TP.boot.$$srcPath = '~lib_src/tibet/kernel/copyright.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETGlobals.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
    This file defines values used to avoid "magic numbers" and other special
    values in TIBET code. We also patch missing DOM/W3C constants in
    non-compliant browsers and provide pre-compiled regular expression
    definitions so we can keep commonly used expressions together and optimize
    performance.

    NOTE that while the file name includes "global" the values defined are found
    on the TIBET and TP root objects rather than the window/global context.

    !!!YOU SHOULD NOT EDIT THIS FILE!!!
    !!!YOU SHOULD NOT EDIT THIS FILE!!!
    !!!YOU SHOULD NOT EDIT THIS FILE!!!

    If you need to alter TIBET's runtime behavior you should be using TIBET's
    configuration and environment settings to adjust public parameter values.
    If you must alter a value defined in this file you should add the proper
    calls to your tibet.xml file in a post-boot target such as one of the app_*
    targets or the boot_suffix target.
*/

//  ------------------------------------------------------------------------
//  NATIVE PROTOTYPE REFERENCES
//  ------------------------------------------------------------------------

//  Function's prototype can be thought of as the native type for any
//  built-in constructor functions such as Array, String, etc. TIBET makes
//  use of this feature to provide common behavior for instances of those
//  native types.
TP.FunctionProto = Function.prototype;

//  Object's prototype can be thought of as the prototypical instance for
//  all objects in the system. TIBET makes use of this feature to provide a
//  common polymorphic API that can be used across both TIBET objects and
//  the native types.
TP.ObjectProto = Object.prototype;

//  'Wire up' the other prototypes for API completeness
TP.ArrayProto = Array.prototype;
TP.BooleanProto = Boolean.prototype;
TP.DateProto = Date.prototype;
TP.MapProto = Map.prototype;
TP.NumberProto = Number.prototype;
TP.RegExpProto = RegExp.prototype;
TP.SetProto = Set.prototype;
TP.StringProto = String.prototype;

//  ------------------------------------------------------------------------
//  LOW-LEVEL OBJECT CREATION
//  ------------------------------------------------------------------------

//  A simple numeric counter used to track the load index of types, methods,
//  external objects, etc.
TP.__loadIndexCount__ = 0;

//  method metadata slots - need these for method definitions below.

TP.DISPLAY = 'displayName';     //  What debuggers want to see.
TP.NAME = '$$name';
TP.ID = '$$id';
TP.OID = '$$oid';
TP.OWNER = '$$owner';
TP.TRACK = '$$track';
TP.DESCRIPTOR = '$$descriptor';

//  track constants

TP.GLOBAL_TRACK = 'Global';
TP.PRIMITIVE_TRACK = 'Primitive';
TP.META_INST_TRACK = 'MetaInst';
TP.META_TYPE_TRACK = 'MetaType';
TP.INST_TRACK = 'Inst';
TP.LOCAL_TRACK = 'Local';
TP.TYPE_TRACK = 'Type';
TP.TYPE_LOCAL_TRACK = 'TypeLocal';

//  load metadata constants

TP.LOAD_PATH = '$$loadPath';
TP.LOAD_PACKAGE = '$$loadPackage';
TP.LOAD_CONFIG = '$$loadConfig';
TP.LOAD_STAGE = '$$stage';
TP.LOAD_INDEX = '$$loadIndex';

TP.SOURCE_PATH = '$$srcPath';
TP.SOURCE_PACKAGE = '$$srcPackage';
TP.SOURCE_CONFIG = '$$srcConfig';

TP.LOAD_PACKAGE_ATTR = 'loadpkg';
TP.LOAD_CONFIG_ATTR = 'loadcfg';

TP.SOURCE_PACKAGE_ATTR = 'srcpkg';
TP.SOURCE_CONFIG_ATTR = 'srccfg';

TP.PACKAGING_REP = '$$packagingRep';

TP.PHASE_ONE = 'import_phase_one';
TP.PHASE_TWO = 'import_phase_two';

TP.DEPENDENCIES = '$$dependencies';
TP.USE_WHOLE_PACKAGE = function() {

    var obj;

    if (this[TP.LOAD_PACKAGE] === null && this[TP.LOAD_CONFIG] === null) {
        /* eslint-disable no-console */
        console.error('No load information for object with keys: ' +
                        JSON.stringify(Object.keys(this)));
        /* eslint-enable no-console */
        return {};
    }

    obj = {};

    obj.wholePackageInfo = true;
    obj[TP.LOAD_PACKAGE] = this[TP.LOAD_PACKAGE];
    obj[TP.LOAD_CONFIG] = this[TP.LOAD_CONFIG];
    obj[TP.LOAD_STAGE] = this[TP.LOAD_STAGE];
    obj[TP.LOAD_INDEX] = this[TP.LOAD_INDEX];
    obj[TP.SOURCE_PACKAGE] = this[TP.SOURCE_PACKAGE];
    obj[TP.SOURCE_CONFIG] = this[TP.SOURCE_CONFIG];
    obj[TP.OID] = this[TP.SOURCE_PACKAGE] + '@' + this[TP.SOURCE_CONFIG];

    return obj;
};

TP.IS_PERSISTED = 'is_persisted';

//  ------------------------------------------------------------------------

TP.registerLoadInfo = function(anObject) {

    /**
     * @method registerLoadInfo
     * @summary Registers load information about the object (such as load &
     *     source paths, load package and load config) onto the object itself.
     * @param {Object} anObject The object to register the load information for.
     */

    var lpath,
        spath;

    lpath = TP.boot[TP.LOAD_PATH] || '';
    lpath = TP.boot.$uriInTIBETFormat(lpath);

    //  source path is any path specified by the rollup logic, or the load path
    //  if that value isn't found. that can happen if the bundle being loaded
    //  didn't specify headers during the rollup processing.
    spath = TP.boot[TP.SOURCE_PATH] || lpath;

    anObject[TP.LOAD_PATH] = lpath;
    anObject[TP.LOAD_PACKAGE] = TP.boot[TP.LOAD_PACKAGE];
    anObject[TP.LOAD_CONFIG] = TP.boot[TP.LOAD_CONFIG];
    anObject[TP.LOAD_STAGE] = TP.boot[TP.LOAD_STAGE];

    if (!TP.ObjectProto.hasOwnProperty.call(anObject, TP.LOAD_INDEX)) {
        anObject[TP.LOAD_INDEX] = TP.__loadIndexCount__++;
    }

    anObject[TP.SOURCE_PATH] = spath;
    anObject[TP.SOURCE_PACKAGE] = TP.boot[TP.SOURCE_PACKAGE];
    anObject[TP.SOURCE_CONFIG] = TP.boot[TP.SOURCE_CONFIG];
};

//  Manual setup
TP.registerLoadInfo[TP.NAME] = 'registerLoadInfo';
TP.registerLoadInfo[TP.OWNER] = TP;
TP.registerLoadInfo[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.registerLoadInfo[TP.DISPLAY] = 'TP.registerLoadInfo';
TP.registerLoadInfo(TP.registerLoadInfo);

//  ------------------------------------------------------------------------

TP.objectDefineDependencies = function(anObject, varargs) {

    /**
     * @method objectDefinedDependencies
     * @summary Adds the supplied dependencies to the object as a form or
     *     packaging dependency, such that when packaging takes place, the
     *     object will consider the dependency as part of the computation.
     * @param {Object} anObject The object to register the dependency
     *     information for.
     * @param {arguments} varargs One or more dependencies or dependency
     *     references provided as a variable argument list.
     * @return {Object[]|undefined} The updated list of object dependencies.
     */

    var dependencies,
        prereqs;

    if (arguments.length < 1) {
        /* eslint-disable no-console */
        console.error('No dependencies provided for object: ' +
                        anObject[TP.NAME]);
        /* eslint-enable no-console */
        return;
    }

    //  Make sure that dependencies is an Array. If not, create one.
    dependencies = anObject[TP.DEPENDENCIES];
    if (!Array.isArray(dependencies)) {
        dependencies = [];
        anObject[TP.DEPENDENCIES] = dependencies;
    }

    //  Grab the supplied prerequisities by getting the arguments and slicing
    //  off the target object that we're defining the dependencies for.
    prereqs = Array.prototype.slice.call(arguments, 1);
    prereqs.forEach(
        function(prereq) {
            var parts,
                ref,
                i;

            if (TP.boot.$notValid(prereq)) {
                /* eslint-disable no-console */
                console.error('Undefined dependency for object: ' +
                                anObject[TP.NAME]);
                /* eslint-enable no-console */
                return;
            }

            if (TP.ObjectProto.toString.call(prereq) === '[object String]') {
                parts = prereq.split('.');
                ref = TP.global[parts[0]];
                if (TP.boot.$notValid(ref)) {
                    /* eslint-disable no-console */
                    console.error('Undefined dependency: ' + prereq +
                                    ' for object: ' +
                                    anObject[TP.NAME]);
                    /* eslint-enable no-console */
                    return;
                }

                for (i = 1; i < parts.length; i++) {
                    ref = ref[parts[i]];
                    if (TP.boot.$notValid(ref)) {
                        /* eslint-disable no-console */
                        console.error('Undefined dependency: ' + prereq +
                                        ' for object: ' +
                                        anObject[TP.NAME]);
                        /* eslint-enable no-console */
                        return;
                    }
                }

                dependencies.push(ref);
            } else {
                dependencies.push(prereq);
            }
        });

    return dependencies;
};

//  Manual setup
TP.objectDefineDependencies[TP.NAME] = 'objectDefineDependencies';
TP.objectDefineDependencies[TP.OWNER] = TP;
TP.objectDefineDependencies[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.objectDefineDependencies[TP.DISPLAY] = 'TP.objectDefineDependencies';
TP.registerLoadInfo(TP.objectDefineDependencies);

//  ------------------------------------------------------------------------

TP.registerExternalObject = function(anExternalName, anExternalObj) {

    /**
     * @method registerExternalObject
     * @summary Registers the supplied object as an 'external object', which
     *     usually means that it is a third-party supplied object that we want
     *     to make available under TP.extern[anExternalName]
     * @param {String} anExternalName The name to register the external object
     *     under using the 'TP.extern' namespace object.
     * @param {Object} anExternalObj The external object to register with the
     *     'TP.extern' object.
     */

    TP.extern[anExternalName] = anExternalObj;

    //  We register 'load info' for the external object on the external object
    //  and supply a Function that returns packaging dependencies (which, by
    //  default for external objects, is the 'whole package' - because there's
    //  usually global object fiddling involved with these objects).
    TP.registerLoadInfo(anExternalObj);
    anExternalObj.getDependencies = TP.USE_WHOLE_PACKAGE;

    return;
};

//  Manual setup
TP.registerExternalObject[TP.NAME] = 'registerExternalObject';
TP.registerExternalObject[TP.OWNER] = TP;
TP.registerExternalObject[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.registerExternalObject[TP.DISPLAY] = 'TP.registerExternalObject';
TP.registerLoadInfo(TP.registerExternalObject);

//  ------------------------------------------------------------------------

TP.constructOrphanObject = function() {

    /**
     * @method constructOrphanObject
     * @summary Constructs an 'orphan' object - that is, one that isn't hooked
     *     up to any prototype chain. This is very useful in situations such as
     *     JSON reconstruction where an 'initially keyless' Object is desired.
     *     NOTE: If an 'orphan' Object cannot be constructed on the currently
     *     executing platform, this method will return null.
     * @returns {Object|null} A pure Object or null if one can't be constructed.
     */

    var newObj;

    newObj = null;

    //  ECMA edition 5 defines the new 'Object.create()' method, which is
    //  very cool because you can pass it null to create an Object that is
    //  not hooked up to the prototype chain. NOTE we could have unhooked the
    //  __proto__ on certain older browsers but since we only support
    //  EC5-compliant browsers we don't bother.
    newObj = Object.create(null);

    return newObj;
};

//  Manual setup
TP.constructOrphanObject[TP.NAME] = 'constructOrphanObject';
TP.constructOrphanObject[TP.OWNER] = TP;
TP.constructOrphanObject[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.constructOrphanObject[TP.DISPLAY] = 'TP.constructOrphanObject';
TP.registerLoadInfo(TP.constructOrphanObject);

//  Create an alias
TP.oc = TP.constructOrphanObject;

//  ------------------------------------------------------------------------

TP.constructProxyObject = function(target, config) {

    /**
     * @method constructProxyObject
     * @summary Constructs an ECMA E6 proxy object. This method stamps a slot
     *     onto the return E6 Proxy object that allows the system to determine
     *     whether an object is a Proxy or not, which is normally very difficult
     *     if not impossible to determine. Use TP.isProxy to determine if an
     *     object is an E6 Proxy.
     * @param {Object} target The object to act as a proxy for.
     * @param {Object} config The proxy configuration
     * @returns {Proxy} An ECMA E6 proxy object.
     */

    var newProxy;

    newProxy = new Proxy(target, config);
    newProxy.__isProxy__ = true;

    //  Capture the proxied object so that we can access later.
    newProxy[TP.PROXIED] = target;

    return newProxy;
};

//  Manual setup
TP.constructProxyObject[TP.NAME] = 'constructProxyObject';
TP.constructProxyObject[TP.OWNER] = TP;
TP.constructProxyObject[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.constructProxyObject[TP.DISPLAY] = 'TP.constructProxyObject';
TP.registerLoadInfo(TP.constructProxyObject);

//  ------------------------------------------------------------------------
//  DEFINE PROPERTY KEYS
//  ------------------------------------------------------------------------

TP.PROPERTY_DEFAULTS = TP.constructOrphanObject();
TP.PROPERTY_DEFAULTS.writable = true;
TP.PROPERTY_DEFAULTS.enumerable = false;

TP.PROPERTY_READONLY = TP.constructOrphanObject();
TP.PROPERTY_READONLY.writable = false;
TP.PROPERTY_READONLY.enumerable = false;

//  ------------------------------------------------------------------------
//  MODULE DEFINITION
//  ------------------------------------------------------------------------

TP.defineNamespace = function(namespaceName) {

    /**
     * @method defineNamespace
     * @summary Defines a namespace named by the supplied name, which must
     *     include a root reference of either TP or APP.
     * @description The name supplied to this method defines a namespace list
     *     from the root object to the last name at the end of the supplied
     *     namespace name.
     * @param {String} namespaceName A String of 1 or more period-separated
     *     names that will define the name of a namespace.
     * @returns {Object|undefined} The newly defined namespace.
     */

    var names,
        root,
        currentObj,
        prefix,
        name,
        i;

    names = namespaceName.split('.');
    root = names.shift();

    currentObj = TP.global[root];
    if (!currentObj) {
        TP.boot.$stderr('Invalid namespace root.', TP.FATAL);
        return;
    }

    prefix = root + '.';

    //  Descend through the names, making sure that there's a real Object at
    //  each level.
    for (i = 0; i < names.length; i++) {

        if (!currentObj[names[i]]) {

            currentObj[names[i]] = {};
            currentObj[names[i]].$$isNamespace = true;

            //  Collect up the namespaces defined here. This will be used later
            //  in the boot process when we upconvert these namespace objects to
            //  real TP.lang.Namespace objects.
            TP.$$bootstrap_namespaces.push(currentObj[names[i]]);

            name = prefix + names.slice(0, i + 1).join('.');
            currentObj[names[i]][TP.NAME] = name;
            currentObj[names[i]][TP.ID] = name;

            //  TODO: replace with a common method (no closure) applied via
            //  addLocalMethod

            /* eslint-disable no-loop-func */
            currentObj[names[i]].getTypeNames =
                            function() {

                                var keys,
                                    namelist,
                                    len,
                                    j,
                                    typename;

                                keys = TP.keys(this);
                                namelist = TP.ac();

                                len = keys.getSize();
                                for (j = 0; j < len; j++) {
                                    typename = this[TP.NAME] +
                                                '.' +
                                                keys.at(j);
                                    if (TP.isType(typename.asType())) {
                                        namelist.push(typename);
                                    }
                                }

                                return namelist;
                            };
            /* eslint-enable no-loop-func */
        }

        currentObj = currentObj[names[i]];
    }

    //  Return the 'last' Object that we created - that'll be the namespace that
    //  the caller wants.
    return currentObj;
};

//  Define an Array to collect primitive namespace objects. Note how we
//  pre-populate with the 'special namespaces' that didn't get added via
//  TP.defineNamespace.
TP.$$bootstrap_namespaces = [
    TP.global.TP,
    TP.global.APP,
    TP.global.TP.sys,
    TP.global.TP.boot,
    TP.global.TP.core,
    TP.global.TP.extern];

//  Manual setup
TP.defineNamespace[TP.NAME] = 'defineNamespace';
TP.defineNamespace[TP.OWNER] = TP;
TP.defineNamespace[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.defineNamespace[TP.DISPLAY] = 'TP.defineNamespace';
TP.registerLoadInfo(TP.defineNamespace);

//  ------------------------------------------------------------------------

TP.isNamespace = function(namespaceObj) {

    /**
     * @method isNamespace
     * @summary Tests the supplied object to see if it is a TIBET 'namespace'
     *     object.
     * @param {The} namespaceObj object to test to see if it is a TIBET
     *     'namespace' object.
     * @returns {Boolean} Whether or not the supplied object is a TIBET
     *     'namespace' object.
     */

    if (!namespaceObj) {
        return false;
    }

    /* eslint-disable no-extra-parens */
    return (typeof namespaceObj.$$isNamespace !== 'undefined');
    /* eslint-enable no-extra-parens */
};

//  Manual setup
TP.isNamespace[TP.NAME] = 'isNamespace';
TP.isNamespace[TP.OWNER] = TP;
TP.isNamespace[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.isNamespace[TP.DISPLAY] = 'TP.isNamespace';
TP.registerLoadInfo(TP.isNamespace);

//  ------------------------------------------------------------------------
//  GLOBAL SYMBOL DEFINITION
//  ------------------------------------------------------------------------

/*
We track true globals to support reflection and to support symbol export
to multiple windows/frames. Our interactive tools also leverage this subset
of metadata about TIBET. Globals are registered using TP.sys.defineGlobal().
*/

//  ------------------------------------------------------------------------

TP.sys.$globals = TP.sys.$globals || [];

//  ------------------------------------------------------------------------

TP.sys.getGlobals = function(params, windowContext) {

    /**
     * @method getGlobals
     * @summary Returns an array containing the names of registered globals in
     *     the system. A global is registered using the defineGlobal call of the
     *     TP.sys object. NOTE that this list isn't guaranteed to be uniqued. If
     *     that is required you'll want to invoke the unique method on the list
     *     before using it. Also note that the parameters are only used once the
     *     full kernel has loaded and TP.sys.$getContextGlobals is available.
     * @param {TP.core.Hash} params A hash of various parameters that affect how
     *     the list is filtered. For details see TP.sys.$getContextGlobals.
     * @param {Window} windowContext The window/frame whose globals should be
     *     returned. Default is the current window.
     * @returns {Object[]} An array of all registered globals.
     */

    if (typeof TP.sys.$getContextGlobals === 'function') {
        return TP.sys.$getContextGlobals(windowContext);
    } else {
        //  NOTE the forward-dependency here
        return TP.isArray(TP.sys.$globals) ? TP.sys.$globals :
                                        TP.keys(TP.sys.$globals);
    }
};

//  Manual setup
TP.sys.getGlobals[TP.NAME] = 'getGlobals';
TP.sys.getGlobals[TP.OWNER] = TP.sys;
TP.sys.getGlobals[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.sys.getGlobals[TP.DISPLAY] = 'TP.getGlobals';
TP.registerLoadInfo(TP.sys.getGlobals);

//  ------------------------------------------------------------------------

/**
 * Processes inbound release data. This is provided by the release version file.
 * A similarly named function is used as a callback name for the checkVersion
 * call. This particular function is mapped to that name in the version file
 * specified by the path.lib_version_target config variable.
 * @param {Object} data The release data structure.
 */
TP.sys.release = function(data, context) {
    var prefix;

    prefix = '$' +
        (context ? context.toLowerCase() : 'lib') +
        'Version';

    if (!TP.sys[prefix]) {
        TP.sys[prefix] = data;
    }

    return data;
};

TP.sys.release[TP.NAME] = 'release';
TP.sys.release[TP.OWNER] = TP.sys;
TP.sys.release[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.sys.release[TP.DISPLAY] = 'TP.release';
TP.registerLoadInfo(TP.sys.release);

//  ------------------------------------------------------------------------
//  JAVASCRIPT LANGUAGE GLOBALS / KEYWORDS ETC.
//  ------------------------------------------------------------------------

TP.sys.$keywords = [
    'break', 'case', 'catch', 'continue', 'default',
    'delete', 'do', 'else', 'false', 'finally', 'for',
    'function', 'if', 'in', 'instanceof', 'new', 'null',
    'return', 'switch', 'this', 'throw', 'true', 'try',
    'typeof', 'var', 'void', 'while', 'with'
];

TP.sys.$reservedwords = [
    'abstract', 'boolean', 'byte', 'char', 'class',
    'const', 'debugger', 'double', 'enum', 'export',
    'extends', 'final', 'float', 'goto', 'implements',
    'import', 'int', 'interface', 'long', 'native',
    'package', 'private', 'protected', 'public',
    'short', 'static', 'super', 'synchronized',
    'throws', 'transient', 'volatile'
];

//  The complete list of global slots found at a low-level, with no filtering,
//  by the system. This is configured by the boot system and finalized once the
//  kernel has fully booted.

//  TP.sys.$nativeglobals

//  properties that throw security exceptions (at least on FF)
TP.sys.$globalexcludes = [];

//  function/method names that shouldn't have DNUs built for them
TP.sys.$noDNUs = ['toJSON'];

//  the defined ECMA Edition 5 globals. Note that this does not include:
//  Object, Function, Array, String, Boolean, Number, Date, RegExp
//  Error, EvalError, RangeError, ReferenceError, SyntaxError, TypeError,
//  URIError
//  Math, JSON
TP.sys.$ecmaglobals = [
    'decodeURI',
    'decodeURIComponent',
    'encodeURI',
    'encodeURIComponent',
    'escape',               //  Non-normative
    'eval',
    'NaN',
    'Infinity',
    'parseInt',
    'parseFloat',
    'isNaN',
    'isFinite',
    'unescape'              //  Non-normative
];

//  additional 'non Window' globals
TP.sys.$systemglobals = [
    'applicationCache',
    'clearInterval',
    'clearTimeout',
    'console',
    'localStorage',
    'performance',
    'postMessage',
    'setTimeout',
    'setInterval'
];

//  these are slots based on DOM Level 0 - which is implemented by most user
//  agents
TP.sys.$windowglobals = [
    'alert',
    'addEventListener',
    'back',
    'blur',
    'close',
    'closed',
    'confirm',
    'content',
    'document',
    'find',
    'focus',
    'forward',
    'frameElement',
    'frames',
    'fullScreen',
    'getComputedStyle',
    'getDefaultComputedStyle',
    'getSelection',
    'history',
    'home',
    'innerHeight',
    'innerWidth',
    'length',
    'location',
    'matchMedia',
    'moveBy',
    'moveTo',
    'name',
    'navigator',
    'onabort',
    'onbeforeunload',
    'onblur',
    'onchange',
    'onclick',
    'oncontextmenu',
    'ondevicelight',
    'ondevicemotion',
    'ondeviceorientation',
    'ondeviceproximity',
    'onerror',
    'onfocus',
    'onhashchange',
    'onkeydown',
    'onkeypress',
    'onkeyup',
    'onload',
    'onmousedown',
    'onmouseenter',
    'onmouseleave',
    'onmousemove',
    'onmouseout',
    'onmouseover',
    'onmouseup',
    'onpopstate',
    'onreset',
    'onresize',
    'onscroll',
    'onselect',
    'onsubmit',
    'onunload',
    'onuserproximity',
    'open',
    'openDialog',
    'opener',
    'outerHeight',
    'outerWidth',
    'pageXOffset',
    'pageYOffset',
    'parent',
    'print',
    'prompt',
    'removeEventListener',
    'resizeBy',
    'resizeTo',
    'screen',
    'scroll',
    'scrollBy',
    'scrollTo',
    'scrollX',
    'scrollY',
    'self',
    'sessionStorage',
    'showModalDialog',
    'sizeToContent',
    'status',
    'stop',
    'top',
    'window'
];

//  Unfortunately, some user-agents like to report accessing of certain global
//  slots to the console and the only way to prevent this is to have a
//  user-agent-specific list of these slots.
TP.sys.$excludedGlobals = [];

//  Chrome 46
if (TP.sys.isUA('chrome')) {
    TP.sys.$excludedGlobals.push(
            'webkitAudioContext',
            'webkitIDBCursor',
            'webkitIDBDatabase',
            'webkitIDBFactory',
            'webkitIDBIndex',
            'webkitIDBKeyRange',
            'webkitIDBObjectStore',
            'webkitIDBRequest',
            'webkitIDBTransaction',
            'webkitIndexedDB',
            'webkitOfflineAudioContext',
            'webkitStorageInfo',
            'webkitURL'
    );
}

//  Any remaining globally-accessible slots will be placed by the finalization
//  code into a structure under TP.sys.$extraglobals. Slots that you might see
//  in that structure include the following (taken from Firefox 27):

/*
'InstallTrigger', 'atob', 'btoa', 'cancelAnimationFrame', 'captureEvents',
'controllers', 'crypto', 'dialogArguments', 'dispatchEvent', 'dump', 'external',
'getInterface', 'indexedDB', 'menubar', 'mozAnimationStartTime',
'mozCancelAnimationFrame', 'mozCancelRequestAnimationFrame', 'mozIndexedDB',
'mozInnerScreenX', 'mozInnerScreenY', 'mozPaintCount',
'mozRequestAnimationFrame', 'onafterprint', 'onafterscriptexecute',
'onbeforeprint', 'onbeforescriptexecute', 'oncanplay', 'oncanplaythrough',
'onclose', 'oncopy', 'oncut', 'ondblclick', 'ondrag', 'ondragdrop', 'ondragend',
'ondragenter', 'ondragleave', 'ondragleave', 'ondragover', 'ondragstart',
'ondrop', 'ondurationchange', 'onemptied', 'onended', 'oninput', 'oninvalid',
'onloadeddata', 'onloadedmetadata', 'onloadstart', 'onmessage', 'onmove',
'onmozbeforepaint', 'onoffline', 'ononline', 'onpagehide', 'onpageshow',
'onpaste', 'onpause', 'onplay', 'onplaying', 'onprogress', 'onratechange',
'onrests', 'onseeked', 'onseeking', 'onshow', 'onstalled', 'onsuspend',
'ontimeupdate', 'onvolumechange', 'onwaiting', 'onwheel', 'personalbar',
'pkcs11', 'releaseEvents', 'requestAnimationFrame', 'returnValue', 'screenX',
'screenY', 'scrollByLines', 'scrollByPages', 'scrollMaxX', 'scrollMaxY',
'scrollbars', 'setResizable', 'sidebar', 'speechSynthesis', 'statusbar',
'toolbar', 'updateCommands'
*/

//  ------------------------------------------------------------------------
//  GLOBAL VARIABLES
//  ------------------------------------------------------------------------

//  process support variables
TP.sys.defineGlobal('$ERROR', 0);
TP.sys.defineGlobal('$STATUS', 0);             //  last status code (0 is
                                               //  success in some form)

//  Add the common namespaces as tracked globals
TP.sys.defineGlobal('TP', TP);
TP.sys.defineGlobal('APP', APP);

//  Note that there are two hidden globals, used internally by the TIBET boot
//  system and not tracked:

//      $$TIBET
//      $$instrumented
//      $$phase_two

//  Note that, in addition to the above, the following slots will look like
//  'globals' but, in reality, are instance variables and methods on the Window
//  object... such is the reality of JavaScript in a browser where Windows and
//  the global object are the same... sigh.

//      window.$$id
//      window.$$name
//      window.$$owner
//      window.$$typename
//      window.$getName()
//      window.$getOID()

//      window.canResolveDNU()

//  ------------------------------------------------------------------------
//  COUNTERS/TIMERS
//  ------------------------------------------------------------------------

//  any content file cache older than this time will not be considered
//  "current" regardless of how it appears relative to its source file. This
//  allows us to deal (in a rough way) with dependencies due to XSLT
//  chaining and other relationships that might affect the final output
//  without actually altering the original source
TP.sys.$$contentExpiration = 0;

//  construct counter for window instances, used for unique naming
TP.sys.$$windowCount = 0;

//  ------------------------------------------------------------------------
//  "TP" CONSTANTS
//  ------------------------------------------------------------------------

/*
Constants on the TP object, which helps keep them out of the global
namespace of the window.
*/

//  ----
//  metadata/object system
//  ----

//  null object's oid, prefixed with $ so it's a legal JS identifier.
TP.NULL_OID = '$0000000000000000';
TP.OID_PREFIX = '$';

//  name of anonymous function
TP.ANONYMOUS_FUNCTION_NAME = 'anonymous_function';

//  iteration return values
TP.BREAK = Number.NEGATIVE_INFINITY;
TP.CONTINUE = Number.POSITIVE_INFINITY;
TP.DESCEND = 1;
TP.REPEAT = 2;

//  metadata system constants
TP.META = '$$meta';
TP.TYPE = '$$type';
TP.SUPER = '$$supertype';
TP.SNAME = '$$supername';
TP.TNAME = '$$typename';
TP.RNAME = '$$realname';

//  type/inst constructor suffixes
TP.TYPEC = '$$Type';
TP.INSTC = '$$Inst';

//  js object relationships
TP.ANCESTOR_NAMES = '$$anames';
TP.ANCESTORS = '$$ancestors';
TP.TRAITS = '$$traits';
TP.INSTANCES = '$$instances';
TP.SUBTYPE_NAMES = '$$snames';
TP.SUBTYPE_NAMES_DEEP = '$$snames_deep';
TP.SUBTYPES = '$$subtypes';
TP.SUBTYPES_DEEP = '$$subtypes_deep';

//  js object
TP.NAMESPACE = 'Namespace';
TP.SUBTYPE = 'Subtype';
TP.METHOD = 'Method';
TP.PRIMITIVE = 'Primitive';
TP.ATTRIBUTE = 'Attribute';
TP.CONSTANT = 'Constant';
TP.INSTANCE = 'Instance';
TP.PROTOTYPE = 'Prototype';

//  DOM relationships
TP.ANCESTOR = 'ans';
TP.ANCESTOR_OR_SELF = 'ansorself';

//  NB: Avoid conflict with 'TP.ATTRIBUTE' above.
TP.ATTR = 'attr';

TP.SELF = 'self';

//  property scopes
TP.INTRODUCED = 'introduced';
TP.INHERITED = 'inherited';
TP.OVERRIDDEN = 'overridden';
TP.LOCAL = 'local';
TP.GLOBAL = 'global';
TP.DNU = 'dnu';
TP.NONE = 'none';
TP.UNIQUE = 'unique';

TP.INTERNAL = 'internal';
TP.HIDDEN = 'hidden';

//  for traits
TP.BEFORE = 'before';
TP.AFTER = 'after';
TP.REQUIRED = function() {
    return;
};

//  for native nodes
//  NOTE: If this list is changed, the TP.nodeCopyTIBETExpandos() routine needs
//  to be changed.
TP.EVENT_IDS = 'tp_eventIds';
TP.EVENT_BLOCKS = 'tp_eventBlocks';
TP.GLOBAL_ID = 'tp_globalID';
TP.SHOULD_SIGNAL_CHANGE = 'tp_shouldSignalChange';
TP.SHOULD_SUSPEND_SIGNALING = 'tp_shouldSuspendSignaling';
TP.WRAPPER = 'tp_wrapper';
TP.GENERATOR = 'tp_generator';
TP.IS_XHTML = 'tp_isXHTML';
TP.IS_XML = 'tp_isXML';
TP.SRC_LOCATION = 'tp_source_location';
TP.OBSERVED_ATTRS = 'tp_observed_attrs';
TP.NODE_TYPE = 'tp_nodetype';
TP.BIND_INFO_REGISTRY = 'tp_bind_info_registry';
TP.GENERATED = 'tp_generated';
TP.AWAKENED = 'tp_awakened';
TP.APPLIED_RULES = 'tp_applied_rules';
TP.TIBET_PRIVATE = 'tp_tibet_private';
TP.PREVIOUS_POSITION = 'tp_previous_position';
TP.INSERTION_POSITION = 'tp_insertion_position';
TP.RESIZE_LISTENERS = 'tp_resize_listeners';
TP.LAMA_MUTATION = 'tp_lama_mutated';
TP.OLD_OVERFLOW = 'tp_old_overflow';
TP.BUSY_ELEMENT = 'tp_busy_element';
TP.BUSY_MSG_ELEMENT = 'tp_busy_msg_element';
TP.BUSY_BKGD_ELEMENT = 'tp_busy_bkgd_element';
TP.BUSY_RESIZE_FUNC = 'tp_busy_resize_function';
TP.REPEAT_SOURCE = 'tp_repeat_source';
TP.REPEAT_INDEX = 'tp_repeat_index';
TP.PSEUDO_INLINE_STYLE = 'tp_pseudo_inline_style';

TP.BOUND_ATTR_COUNT = 'tp_bound_attr_count';
TP.BOUND_ATTR_PROCESSED_COUNT = 'tp_bound_attr_processed_count';

TP.OLD_TOP = 'tp_top';
TP.OLD_LEFT = 'tp_left';
TP.OLD_HEIGHT = 'tp_oldheight';
TP.OLD_WIDTH = 'tp_oldwidth';

//  meta owners and their target objects

TP.META_TYPE_OWNER = {};
TP.META_TYPE_OWNER[TP.ID] = 'MetaType';
TP.META_TYPE_OWNER[TP.NAME] = 'MetaType';
TP.META_TYPE_OWNER.getID = function() {
    return 'MetaType';
};
TP.META_TYPE_OWNER.getName = function() {
    return 'MetaType';
};
TP.META_TYPE_OWNER.getSupertype = function() {
    return;
};
TP.META_TYPE_OWNER.getSupertypeName = function() {
    return '';
};
TP.META_TYPE_OWNER.getSupertypeNames = function() {
    return [];
};
TP.META_TYPE_OWNER.getType = function() {
    return;
};
TP.META_TYPE_OWNER.getTypeName = function() {
    return;
};
TP.META_TYPE_OWNER.getConstructor = function() {
    return Object;
};
TP.META_TYPE_OWNER.getDependencies = function() {
    return [];
};

TP.META_TYPE_OWNER.meta_methods = {};

TP.META_TYPE_TARGETS = [
    Array,
    Boolean,
    Date,
    Function,
    Number,
    Object,
    RegExp,
    String
];

TP.META_INST_OWNER = {};
TP.META_INST_OWNER[TP.ID] = 'MetaInst';
TP.META_INST_OWNER[TP.NAME] = 'MetaInst';
TP.META_INST_OWNER.getID = function() {
    return 'MetaInst';
};
TP.META_INST_OWNER.getName = function() {
    return 'MetaInst';
};
TP.META_INST_OWNER.getSupertype = function() {
    return;
};
TP.META_INST_OWNER.getSupertypeName = function() {
    return '';
};
TP.META_INST_OWNER.getSupertypeNames = function() {
    return [];
};
TP.META_INST_OWNER.getType = function() {
    return;
};
TP.META_INST_OWNER.getTypeName = function() {
    return;
};
TP.META_INST_OWNER.getConstructor = function() {
    return Object;
};
TP.META_INST_OWNER.getDependencies = function() {
    return [];
};

TP.META_INST_OWNER.meta_methods = {};
TP.META_INST_OWNER.common_methods = {};

//  NB: We leave TP.ObjectProto out of this list on purpose.
TP.META_INST_TARGETS = [
    TP.ArrayProto,
    TP.BooleanProto,
    TP.DateProto,
    TP.FunctionProto,
    TP.NumberProto,
    TP.RegExpProto,
    TP.StringProto
];

//  attribute name prefixes
TP.PUBLIC = '';
TP.PRIVATE = '$';
TP.PROTECTED = '_';
TP.INTERNAL = '$$';

//  input/output/error values, NOTE that we use TP.STDIN as an attribute
//  name so it should be viable for that purpose.
TP.STDIN = 'tsh_stdin';
TP.STDOUT = 'tsh_stdout';
TP.STDERR = 'tsh_stderr';
TP.STDIO = 'tsh_stdio';

//  ----
//  invocation-derived path filter constants
//  ----

TP.EXCLUDE_INVOCATION_TRACKED_PACKAGES = [
    /tibet_kernel.xml@vm/,
    /~app|APP\./
];

TP.EXCLUDE_INVOCATION_TRACKED_PATHS = [
    /tibet\/tools/,
    /tibet\/testing/,
    /tibet\/automation/,
    /tibet\/boot/
];

TP.EXCLUDE_INVOCATION_METHOD_NAMES = [
    'callNextMethod',
    'initialize'
];

//  ----
//  coding constants
//  ----

//  object testing
TP.EQUALITY = '==';                         //  test control variable
TP.IDENTITY = '===';                        //  test control variable

//  Iteration and state transition phases/controls.
TP.ENTER = Number.POSITIVE_INFINITY;
TP.EXIT = Number.NEGATIVE_INFINITY;
TP.TRANSITION = 0;
TP.INPUT = 1;

//  The minimum and maximum date that JavaScript can handle (in milliseconds).
TP.MIN_DATE = -8640000000000000;
TP.MAX_DATE = 8640000000000000;

//  result and/or indexing errors
TP.BAD_INDEX = -1;                          //  bad array/hash index
TP.NOT_FOUND = -1;                          //  missing data
TP.NO_SIZE = -1;                            //  bad object size
TP.NO_RESULT = 'NO_RESULT';                 //  invalid response

//  deleted items flag
TP.DELETED = '$$DELETED$$';

//  string keys for null/undefined
TP.NULL = '$$NULL$$';
TP.UNDEF = '$$UNDEFINED$$';

//  string used to join segments of things together
TP.JOIN = '__JOIN__';

//  strings used to delimit path start, end and separators when those paths
//  could have normal delimiters (like '.' or '/') embedded in them.
TP.PATH_START = '__PATH_START__';
TP.PATH_END = '__PATH_END__';
TP.PATH_SEP = '__PATH_SEP__';

//  to match any character except a delimiter
TP.PATH_NO_SEP = '(?!.+__PATH_SEP__).+';

//  Used in data to mark a 'grouping'
TP.GROUPING_PREFIX = '__GROUPING__';

//  Used in data to mark a 'spacing'
TP.SPACING = '__SPACING__';

//  positional identifiers
TP.CURRENT = 'CURRENT';

//  increment identifiers
TP.LINE = 'LINE';
TP.PAGE = 'PAGE';

TP.HOME = 'HOME';

TP.FIRST = 'FIRST';
TP.LAST = 'LAST';

TP.NEXT = 'NEXT';
TP.PREVIOUS = 'PREVIOUS';

TP.SEEK = 'SEEK';

TP.PRECEDING = 'PRECEDING';
TP.FOLLOWING = 'FOLLOWING';

TP.FIRST_IN_GROUP = 'FIRST_IN_GROUP';
TP.LAST_IN_GROUP = 'LAST_IN_GROUP';

TP.FIRST_IN_NEXT_GROUP = 'FIRST_IN_NEXT_GROUP';
TP.FIRST_IN_PREVIOUS_GROUP = 'FIRST_IN_PREVIOUS_GROUP';

TP.AFTER_END = 'AfterEnd';
TP.BEFORE_BEGIN = 'BeforeBegin';
TP.AFTER_BEGIN = 'AfterBegin';
TP.BEFORE_END = 'BeforeEnd';

//  directions
TP.FORWARD = 'FWD';                     //  FORWARD direction
TP.BACKWARD = 'BWD';                    //  BACKWARD direction
TP.UP = 'UP';                           //  UP direction
TP.DOWN = 'DOWN';                       //  DOWN direction

//  keys
TP.KEYDOWN = 253;
TP.KEYPRESS = 254;
TP.KEYUP = 255;

//  mouse
TP.MOUSE = 'MOUSE';

//  orientations
TP.VERTICAL = 'VERT';                   //  VERTICAL orientation
TP.HORIZONTAL = 'HORIZ';                //  HORIZONTAL orientation

//  the four edges
TP.TOP = 'TOP';                         //  TOP side
TP.RIGHT = 'RIGHT';                     //  RIGHT side (of decimal or UI :))
TP.BOTTOM = 'BOTTOM';                   //  BOTTOM side
TP.LEFT = 'LEFT';                       //  LEFT side (of decimal or UI :))

//  the eight handles
TP.TOP_LEFT = 'TOP_LEFT';               //  TOP-LEFT side
TP.TOP_CENTER = 'TOP_CENTER';           //  TOP-CENTER side
TP.TOP_RIGHT = 'TOP_RIGHT';             //  TOP-RIGHT side

TP.MIDDLE_LEFT = 'MIDDLE_LEFT';         //  LEFT-MIDDLE side
TP.MIDDLE_RIGHT = 'MIDDLE_RIGHT';       //  RIGHT-MIDDLE side

TP.BOTTOM_LEFT = 'BOTTOM_LEFT';         //  BOTTOM-LEFT side
TP.BOTTOM_CENTER = 'BOTTOM_CENTER';     //  BOTTOM-CENTER side
TP.BOTTOM_RIGHT = 'BOTTOM_RIGHT';       //  BOTTOM-RIGHT side

//  the middle/center depending on your preference :)
TP.MIDDLE = 'MIDDLE';                   //  MIDDLE
TP.CENTER = 'CENTER';                   //  CENTER

//  compass coordinate values
//  See: http://en.wikipedia.org/wiki/Boxing_the_compass#Compass_points
TP.NORTH = 1;
TP.NORTH_BY_EAST = 2;
TP.NORTH_NORTHEAST = 3;
TP.NORTHEAST_BY_NORTH = 4;
TP.NORTHEAST = 5;
TP.NORTHEAST_BY_EAST = 6;
TP.EAST_NORTHEAST = 7;
TP.EAST_BY_NORTH = 8;
TP.EAST = 9;
TP.EAST_BY_SOUTH = 10;
TP.EAST_SOUTHEAST = 11;
TP.SOUTHEAST_BY_EAST = 12;
TP.SOUTHEAST = 13;
TP.SOUTHEAST_BY_SOUTH = 14;
TP.SOUTH_SOUTHEAST = 15;
TP.SOUTH_BY_EAST = 16;
TP.SOUTH = 17;
TP.SOUTH_BY_WEST = 18;
TP.SOUTH_SOUTHWEST = 19;
TP.SOUTHWEST_BY_SOUTH = 20;
TP.SOUTHWEST = 21;
TP.SOUTHWEST_BY_WEST = 22;
TP.WEST_SOUTHWEST = 23;
TP.WEST_BY_SOUTH = 24;
TP.WEST = 25;
TP.WEST_BY_NORTH = 26;
TP.WEST_NORTHWEST = 27;
TP.NORTHWEST_BY_WEST = 28;
TP.NORTHWEST = 29;
TP.NORTHWEST_BY_NORTH = 30;
TP.NORTH_NORTHWEST = 31;
TP.NORTH_BY_WEST = 32;

//  selection types
TP.SELECTION_NONE = 0;
TP.SELECTION_TEXT = 1;
TP.SELECTION_ELEMENT = 2;

//  selection endpoints (the values here are used in their lowercase form -
//  don't change)
TP.ANCHOR = 'anchor';
TP.HEAD = 'head';

//  formatting
TP.DEFAULT_STRPAD = ' ';                //  char to left pad strings
TP.DEFAULT_NUMPAD = '0';                //  char to left pad numbers
TP.DEFAULT_STRLEN = 50;                 //  default size for truncate()
TP.DEFAULT_INSTANCE = 'DEFAULT_INSTANCE';   //  default instance ID flag
TP.DEFAULT = '__DEFAULT__';             //  default key used when defining
                                        //  primitives

//  document visibility types
TP.VISIBLE = 'visible';
TP.HIDDEN = 'hidden';
TP.PRERENDER = 'prerender';

TP.NO_SOURCE_REP = '<<No Source Rep>>'; //  No source representation

TP.POSITION = 'position';

//  CSS transformation types
TP.ROTATE = 'ROTATE';         //  Rotation transformation
TP.SKEW = 'SKEW';             //  Skew transformation
TP.SCALE = 'SCALE';           //  Scale transformation
TP.TRANSLATE = 'TRANSLATE';   //  Translate transformation

//  CSS error 'codes' as to why elements cannot take on certain CSS properties.
TP.ELEMENT_NEEDS_TO_BE_BLOCK = 'NEEDS_TO_BE_BLOCK';
TP.ELEMENT_NEEDS_TO_BE_POSITIONED = 'NEEDS_TO_BE_POSITIONED';

//  ---
//  workflow support
//  ---

//  processing models
TP.ASYNC = 'ASYNC';                     //  ASYNCHRONOUS processing
TP.SYNC = 'SYNC';                       //  SYNCHRONOUS processing

TP.PARALLEL = 'PAR';                    //  PARALLEL processing
TP.SEQUENTIAL = 'SEQ';                  //  SEQUENTIAL processing

//  workflow process status codes, roughly based on BPML states. positive
//  codes greater than 1 are variations of 'done', while negative numbers
//  imply activity is ongoing. 0 represents 'ready' (not done or active).

//  NOTE that absolute values for the "pending" states match their
//  corresponding "done" states...in other words FAILING/FAILED are -3 and 3
//  respectively and so on. THIS IS RELIED UPON IN STATE CHECKS!

TP.READY = 0;
TP.ACTIVE = -1;

TP.PAUSING = -2;
TP.ERRORING = -3;
TP.FAILING = -4;
TP.CANCELLING = -5;                     //  not in BPML spec, reserved here
TP.SUCCEEDING = -6;
TP.COMPLETING = -7;

TP.PAUSED = 2;                          //  not in BPML spec, reserved here
TP.ERRORED = 3;                         //  not in BPML spec, reserved here
TP.FAILED = 4;
TP.CANCELLED = 5;
TP.SUCCEEDED = 6;                       //  not in BPML spec, reserved here
TP.COMPLETED = 7;                       //  DO NOT USE...USE TP.SUCCEEDED.

TP.SKIPPED = 8;                         //  not in BPML spec, reserved here
TP.TIMED_OUT = 9;                       //  not in BPML spec, reserved here
TP.IGNORED = 10;                        //  not in BPML spec, reserved here

TP.INITIATE = 11;                       //  outer multi-step job "start"
TP.RESOLVED = 12;                       //  outer multi-step job "success"
TP.REJECTED = 13;                       //  outer multi-step job "failure"

//  join conditions. NOTE these should be kept as string values to avoid
//  changes to the shell pipe connection logic.
TP.AND = 'and';
TP.OR = 'or';

//  Commonly used log names.
TP.LOG = 'TP';
TP.APP_LOG = 'APP';
TP.BOOT_LOG = 'boot';
TP.CHANGE_LOG = 'change';
TP.CSS_LOG = 'css';
TP.INFERENCE_LOG = 'inference';
TP.IO_LOG = 'io';
TP.JOB_LOG = 'job';
TP.KEY_LOG = 'key';
TP.LINK_LOG = 'link';
TP.MOUSE_LOG = 'mouse';
TP.PATCH_LOG = 'patch';
TP.QUERY_LOG = 'query';
TP.SECURITY_LOG = 'security';
TP.SIGNAL_LOG = 'signal';
TP.TEST_LOG = 'test';
TP.TRANSFORM_LOG = 'transform';

//  ---
//  signaling
//  ---

//  signal firing models
TP.ANY = 'ANY';
TP.OBSERVER_FIRING = 'OBSERVER_FIRING';
TP.DOM_FIRING = 'DOM_FIRING';
TP.RESPONDER_FIRING = 'RESPONDER_FIRING';
TP.BIND_FIRING = 'BIND_FIRING';
TP.EXCEPTION_FIRING = 'EXCEPTION_FIRING';
TP.FIRE_ONE = 'FIRE_ONE';
TP.INHERITANCE_FIRING = 'INHERITANCE_FIRING';

//  DOM signaling phases
TP.AT_TARGET = 'Targeting';
TP.CAPTURING = 'Capturing';
TP.BUBBLING = 'Bubbling';

//  Signal batching
TP.START_SIGNAL_BATCH = 'startbatch';
TP.SIGNAL_BATCH = 'batch';
TP.END_SIGNAL_BATCH = 'endbatch';

TP.TARGET = 'Target';
TP.PROXIED = 'Proxied';

//  ---
//  requests
//  ---

TP.ONLOAD = 'onload';
TP.ONSUCCESS = 'onsuccess';
TP.ONFAIL = 'onfail';

//  ---
//  shell
//  ---

//  arguments
TP.ORIGINAL = 'original';
TP.EXPANDED = 'expanded';
TP.ALLFORMS = 'allforms';

//  pipe symbol actions
TP.ADD = 'add';
TP.GET = 'get';
TP.SET = 'set';
TP.FILTER = 'filter';
TP.TRANSFORM = 'transform';

//  Pipe types (always from the perspective of the downstream segment).
TP.TSH_ADD_PIPES = ['.>>', '.>>!', '.&>>', '.&>>!', '.>>&', '.>>&!'];
TP.TSH_GET_PIPES = ['.<', '.<!', '.<<'];
TP.TSH_SET_PIPES = ['.>', '.>!', '.&>', '.&>!', '.>&', '.>&!'];
TP.TSH_FILTER_PIPES = ['.|?', '.|?*', '.&?', '.&?*', '.|&?', '.|&?*', '.?', '.?*'];
TP.TSH_TRANSFORM_PIPES = ['.|', '.|*', '.&', '.&*', '.|&', '.|&*', '.*'];

//  change notification keys

//  operations
TP.CREATE = 'create';
TP.DELETE = 'delete';
TP.INSERT = 'insert';
TP.UPDATE = 'update';
TP.REPLACE = 'replace';
TP.SORTED = 'sorted';

//  information
TP.OLDVAL = 'oldval';
TP.NEWVAL = 'newval';

TP.REVISED = 'revised';

//  facet names
TP.READONLY = 'readonly';
TP.RELEVANT = 'relevant';
TP.REQUIRED = 'required';
TP.VALID = 'valid';

TP.FACET_NAMES = [TP.READONLY, TP.RELEVANT, TP.REQUIRED, TP.VALID];

//  lama operations
TP.ASSIST = 'assist';
TP.EDIT = 'edit';

//  ---
//  IO/URI support
//  ---

//  url load return types: xml, text, native, "wrapper", or "best possible"
TP.DOM = 1;
TP.TEXT = 2;
TP.XHR = 3;
TP.WRAP = 4;
TP.NATIVE = 5;
TP.CONTENT = 6;

//  IO Directions
TP.SEND = 'SEND';
TP.RECV = 'RECV';

TP.IN = 'IN';
TP.IO = 'IO';
TP.OUT = 'OUT';

//  ---
//  file io
//  ---

//  directory listing globals
TP.FILES = 'files';
TP.SUBDIRS = 'subdirs';

//  file activity globals
TP.APPEND = 'a';
TP.WRITE = 'w';
TP.READ = 'r';

//  IE file activity flags
TP.IE_READ = 1;
TP.IE_WRITE = 2;
TP.IE_APPEND = 8;

//  Mozilla file activity flags
TP.MOZ_READ = 0x01;
TP.MOZ_WRITE = 0x08;
TP.MOZ_APPEND = 0x10;

//  Mozilla file creation flags
TP.MOZ_FILE_RDONLY = 0x01;
TP.MOZ_FILE_WRONLY = 0x02;
TP.MOZ_FILE_RDWR = 0x04;
TP.MOZ_FILE_CREATE = 0x08;
TP.MOZ_FILE_APPEND = 0x10;
TP.MOZ_FILE_TRUNCATE = 0x20;
TP.MOZ_FILE_SYNC = 0x40;
TP.MOZ_FILE_EXCL = 0x80;

//  ---
//  http/webdav IO
//  ---

//  HTTP call types
TP.HTTP_CONNECT = 'CONNECT';
TP.HTTP_DELETE = 'DELETE';
TP.HTTP_GET = 'GET';
TP.HTTP_HEAD = 'HEAD';
TP.HTTP_OPTIONS = 'OPTIONS';
TP.HTTP_POST = 'POST';
TP.HTTP_PATCH = 'PATCH';
TP.HTTP_PUT = 'PUT';
TP.HTTP_TRACE = 'TRACE';

//  HTTP authentication types
TP.HTTP_BASIC = 'BASIC';
TP.HTTP_DIGEST = 'DIGEST';

//  HTTP 'simple' CORS allowed methods, header keys, encodings
TP.HTTP_ALLOWED_SIMPLE_CORS_METHODS = [
        'GET',
        'HEAD',
        'POST'
];

TP.HTTP_ALLOWED_SIMPLE_CORS_HEADERS = [
        'Accept',
        'Accept-Language',
        'Content-Language',
        'Content-Type',
        'Last-Event-ID',
        'DPR',
        'Save-Data',
        'Viewport-Width',
        'Width'
];

TP.HTTP_ALLOWED_SIMPLE_CORS_ENCODINGS = [
        'application/x-www-form-urlencoded',
        'multipart/form-data',
        'text/plain'
];

//  WebDAV call types
TP.WEBDAV_CHECKIN = 'CHECKIN';
TP.WEBDAV_CHECKOUT = 'CHECKOUT';
TP.WEBDAV_COPY = 'COPY';
TP.WEBDAV_LOCK = 'LOCK';
TP.WEBDAV_MKCOL = 'MKCOL';
TP.WEBDAV_MOVE = 'MOVE';
TP.WEBDAV_PROPFIND = 'PROPFIND';
TP.WEBDAV_PROPPATCH = 'PROPPATCH';
TP.WEBDAV_REPORT = 'REPORT';
TP.WEBDAV_UNLOCK = 'UNLOCK';
TP.WEBDAV_VERSIONCONTROL = 'VERSIONCONTROL';

//  WebDAV locktype
TP.WEBDAV_LOCKTYPE_WRITE = 'write';

//  WebDAV lockscope
TP.WEBDAV_LOCKSCOPE_EXCLUSIVE = 'exclusive';
TP.WEBDAV_LOCKSCOPE_SHARED = 'shared';

//  WebDAV default locktimeout
TP.WEBDAV_LOCKTIMEOUT_DEFAULT = 'Second-86400';
TP.WEBDAV_LOCKTIMEOUT_INFINITE = 'Infinite';

TP.UTF8 = 'UTF-8';
TP.ISO8859 = 'ISO-8859-1';

//  MIME Type encodings
TP.URL_ENCODED = 'application/x-www-form-urlencoded';
TP.XML_ENCODED = 'application/xml';
TP.JSON_ENCODED = 'application/json';
TP.XHTML_ENCODED = 'application/xhtml+xml';
TP.XSLT_ENCODED = 'application/xslt+xml';
TP.ATOM_ENCODED = 'application/atom+xml';
TP.XMLRPC_ENCODED = 'application/xml+rpc';
TP.SOAP_ENCODED = 'application/soap+xml';

TP.OCTET_ENCODED = 'application/octet-stream';

TP.FIELD_ENCODED = 'application/vnd.tpi.hidden-fields';

TP.MP_FORMDATA_ENCODED = 'multipart/form-data';
TP.MP_RELATED_ENCODED = 'multipart/related';

TP.PLAIN_TEXT_ENCODED = 'text/plain';
TP.CSS_TEXT_ENCODED = 'text/css';

TP.HTML_TEXT_ENCODED = 'text/html';
TP.XML_TEXT_ENCODED = 'text/xml';
TP.JSON_TEXT_ENCODED = 'text/json';

TP.JS_TEXT_ENCODED = 'text/javascript';
TP.JSX_TEXT_ENCODED = 'text/jsx';

//  ---
//  html support
//  ---

TP.HTML_401_TAGS = {
    a: true, abbr: true, acronym: true, address: true,
    applet: true, area: true, b: true, base: true,
    basefont: true, bdo: true, big: true, blockquote: true,
    body: true, br: true, button: true, caption: true,
    center: true, cite: true, code: true, col: true,
    colgroup: true, dd: true, del: true, dfn: true,
    dir: true, div: true, dl: true, dt: true,
    em: true, embed: true, fieldset: true, font: true,
    form: true, frame: true, frameset: true, h1: true,
    h2: true, h3: true, h4: true, h5: true,
    h6: true, head: true, hr: true, html: true,
    i: true, iframe: true, img: true, input: true,
    isindex: true, kbd: true, label: true, legend: true,
    li: true, link: true, map: true, menu: true,
    meta: true, noframes: true, noscript: true, object: true,
    ol: true, optgroup: true, option: true, p: true,
    param: true, pre: true, q: true, s: true,
    samp: true, script: true, select: true, small: true,
    span: true, strike: true, strong: true, style: true,
    sub: true, sup: true, table: true, tbody: true,
    td: true, textarea: true, tfoot: true, th: true,
    thead: true, title: true, tr: true, tt: true,
    u: true, ul: true, val: true
};

//  ---
//  xml support
//  ---

TP.XML_NCNAME = '[A-Za-z_]|[^\\x00-\\x7F]';
TP.XML_NCNAMECHAR = '[A-Za-z0-9_.-]|[^\\x00-\\x7F]';

TP.XML_NAMESTART = '[A-Za-z_:]|[^\\x00-\\x7F]';
TP.XML_NAMECHAR = '[A-Za-z0-9_:.-]|[^\\x00-\\x7F]';
TP.XML_ATTRVAL = '"[^<"]' + '*' + '"' + '|\'[^<\']*\'';

TP.XML_NAME = '(' + TP.XML_NAMESTART + ')' + '(' + TP.XML_NAMECHAR + ')*';

TP.CONTAINS_ELEM_MARKUP_DEF =
        '<(' + TP.XML_NAMESTART + ')([^<>"\']+|' + TP.XML_ATTRVAL + ')*>';

TP.XML_COMMENT_DEF =
    '<!--(([^-]*)-([^-][^-]*-)*->?)?';

TP.XML_CDATA_DEF =
    '<!\\[CDATA\\[([^]]*]([^]]+])*]+([^]>][^]]*]([^]]+])*]+)*>)?';

TP.XML_PI_DEF =
    '<\\?(([A-Za-z_:]|[^\\x00-\\x7F])([A-Za-z0-9_:.-]|[^\\x00-\\x7F])*(\\?>|[\\n\\r\\t ][^?]*\\?+([^>?][^?]*\\?+)*>)?)?';

//  ---
//  css support
//  ---

//  'box model' types for elements in the DOM
TP.CONTENT_BOX = 1;
TP.PADDING_BOX = 2;
TP.BORDER_BOX = 3;
TP.MARGIN_BOX = 4;

//  busy icon height
TP.BUSY_HEIGHT = 28;

//  a tmp for font heights of standardized font sizes in pixels for:
//      1em, 1ex, 100%, 12pt, 16px, xx-small, x-small, small, medium, large,
//      x-large, xx-large
TP.FONT_HEIGHTS = null;

//  tmp for the scroller width of the browser we're currently executing in
TP.SCROLLER_WIDTH = null;

//  z-index 'tiers' for various system services
TP.SLIDER_TIER = 20500;
TP.MENU_TIER = 21000;
TP.POPUP_TIER = 21500;
TP.HALO_TIER = 22000;
TP.HALO_POPUP_TIER = 22500;
TP.HUD_TIER = 23000;
TP.HUD_POPUP_TIER = 23500;
TP.CONSOLE_INPUT_TIER = 24000;
TP.HUD_V_EDGE_TIER = 24500;
TP.CONNECTOR_TIER = 25000;
TP.HUD_H_EDGE_TIER = 25500;
TP.HUD_CORNER_TIER = 26000;
TP.HUD_TILE_TIER = 26500;
TP.CONSOLE_OUTPUT_TIER = 27000;
TP.CONTEXT_MENU_TIER = 27500;
TP.HUD_OPENER_TIER = 28000;
TP.NOTIFIER_TIER = 28500;
TP.DRAG_DROP_TIER = 29000;
TP.CURTAIN_TIER = 29500;
TP.ALERT_TIER = 30000;
TP.STICKY_TIER = 30500;

//  ---
//  dom support
//  ---

//  XPath selection options
TP.NODESET = 0x01;
TP.FIRST_NODE = 0x02;

//  DOM positioning masks
TP.SAME_NODE = 0;
TP.PRECEDING_NODE = 2;
TP.FOLLOWING_NODE = 4;
TP.CONTAINS_NODE = 8;
TP.CONTAINED_BY_NODE = 16;

//  DOM attributes that never get prefixed
TP.NEVER_PREFIXED_ATTRS = ['id'];

//  DOM attributes that never get serialized
TP.NEVER_SERIALIZED_TIBET_ATTRS = [
    'tibet:assembly',
    'tibet:crud',
    'tibet:desugared',
    'tibet:focuscontext',
    'tibet:for',
    'tibet:globaldocid',
    'tibet:group',
    'tibet:originalhref',
    'tibet:handlerid',
    'tibet:mime',
    'tibet:no-awaken',
    'tibet:no-compile',
    'tibet:no-dragtrap',
    'tibet:no-mutations',
    'tibet:originalhref',
    'tibet:phase',
    'tibet:recasting',
    'tibet:single',
    'tibet:flagchanges',
    'tibet:templateid',
    'tibet:templateexpr',
    'tibet:textbinding'
];

//  A list of queries for elements that can be focused without a 'tabindex'
//  attribute, plus the query for any element that has a tabindex.
TP.FOCUSABLE_QUERIES = [
    'html|body',
    'html|a[href]:not([disabled])',
    'html|input:not([disabled])',
    'html|select:not([disabled])',
    'html|textarea:not([disabled])',
    'html|button:not([disabled])',
    'html|iframe:not([disabled])',
    '*[tabindex]:not([tabindex="-1"]):not([disabled])'
];

//  ---
//  encryption/security
//  ---

//  ACL support constants
TP.ACL_REAL = 'acl:real';
TP.ACL_EFFECTIVE = 'acl:effective';

//  HASH encoding and format models
TP.HASH_MD5 = 0;
TP.HASH_SHA1 = 1;

TP.HASH_HEX = 2;
TP.HASH_B64 = 3;
TP.HASH_LATIN1 = 4;

//  Use a key size of 16 bytes
TP.PBKDF2_KEYSIZE = 128 / 8;

//  iOS 3.0 uses 2000, so that's good enough for us
TP.PBKDF2_ITERATION_COUNT = 2000;

//  Credentials DB name
TP.CREDENTIALS_DB_NAME = 'TIBET_USER_CREDENTIALS';

//  ---
//  Simple storage support
//  ---

//  Local storage DB name
TP.LOCALSTORAGE_DB_NAME = 'TIBET_LOCAL_DB';

//  ---
//  ACP support
//  ---

TP.ACP_BEGIN = '{{';
TP.ACP_END = '}}';

TP.ACP_ENCODED_BEGIN = '_BEGIN_ACP_';
TP.ACP_ENCODED_END = '_END_ACP_';

//  ---
//  XML support
//  ---

//  XML Base aware prefix marker and search regex
TP.BASE_AWARE_PREFIX = 'BASE_AWARE_PREFIX';

//  XML extensions. content that's not well-formed with one of these
//  extensions will trigger a well-formed warning during load/processing
TP.XML_EXTENSIONS = ['xml', 'xhtml', 'tsh', 'xsl', 'xsd'];

//  XML attributes
TP.GLOBAL_DOCID_ATTR = 'tibet:globaldocid';

//  XML Headers
TP.XML_10_HEADER = '<?xml version="1.0"?>';
TP.XML_10_UTF8_HEADER = '<?xml version="1.0" encoding="UTF-8"?>';
TP.XML_10_STANDALONE_HEADER = '<?xml version="1.0" standalone="yes"?>';

//  ------------------------------------------------------------------------
//  MSXML LISTS
//  ------------------------------------------------------------------------

//  MSXML versions 4 and 5 are not recommended by Microsoft so they're not
//  included below.

TP.IE_XMLHTTP_VERSIONS = [
    'Msxml2.XMLHTTP.6.0',
    'Msxml2.XMLHTTP.3.0',
    'Msxml2.XMLHTTP',
    'Microsoft.XMLHTTP'
];

TP.IE_DOM_DOCUMENT_VERSIONS = [
    'Msxml2.DOMDocument.6.0',
    'Msxml2.DOMDocument.3.0',
    'Msxml2.DOMDocument'
];

TP.IE_THREADED_DOM_VERSIONS = [
    'Msxml2.FreeThreadedDOMDocument.6.0',
    'Msxml2.FreeThreadedDOMDocument.3.0',
    'Msxml2.FreeThreadedDOMDocument'
];

TP.IE_XSL_TEMPLATE_VERSIONS = [
    'Msxml2.XSLTemplate.6.0',
    'Msxml2.XSLTemplate.3.0',
    'Msxml2.XSLTemplate'
];

//  ------------------------------------------------------------------------
//  PRIVILEGED CAPABILITY CONSTANTS
//  ------------------------------------------------------------------------

//  These follow the Mozilla capabilities system because it has a more
//  fine-grained security mechanism

//  Show an 'about:' URL that is not 'about:blank'.
TP.SHOW_ABOUT = 'SHOW_ABOUT';

//  Use the 'history' object to find out more about where the user has gone
//  or how many times they've been there.
TP.READ_HISTORY = 'READ_HISTORY';

//  Read and write preferences on the 'navigator' object.
TP.READ_PREFERENCE = 'READ_PREFERENCE';
TP.WRITE_PREFERENCE = 'WRITE_PREFERENCE';

//  Manipulate a window in the following ways:
//      - Adding or removing directory bar, location bar, menu bar, personal
//      bar, scroll bar or toolbar
//      - enableExternalCapture() to allow event capture in pages from other
//      servers.
//      - Closing a browser window unconditionally
//      - Using moveTo / moveBy to move the window off screen
//      - open (when creating a window smaller than 100X100, placing it
//      offscreen via screenX/screenY parameters, creating a window without
//      a title bar or using alwaysRaised, alwaysLowered, or z-lock
//      - Using resizeTo / resizeBy to resize the window to smaller than
//      100X100.
//      - Using innerWidth / innerHeight to resize the window to smaller
//      than 100X100.
TP.MANIPULATE_WINDOW = 'MANIPULATE_WINDOW';

//  Used to read the *execution stack* - the Function stack can be read
//  without this permission
TP.READ_EXECUTION_STACK = 'READ_EXECUTION_STACK';

//  Use XMLHttpRequest() to read data across domains.
TP.ACCESS_XDOMAIN_XMLHTTP = 'ACCESS_XDOMAIN_XMLHTTP';

//  Access web pages in subframes.
TP.ACCESS_XDOMAIN_FRAME = 'ACCESS_XDOMAIN_FRAME';

//  Access DOM Inspector internals
TP.ACCESS_DOM_INSPECT = 'ACCESS_DOM_INSPECT';

//  Delete a file on the host
TP.HOST_FILE_DELETE = 'HOST_FILE_DELETE';

//  General file system access on the host
TP.HOST_FILE_ACCESS = 'HOST_FILE_ACCESS';

//  Save a file on the host
TP.HOST_FILE_SAVE = 'HOST_FILE_SAVE';

//  Execute a shell command on the host
TP.HOST_CMD_EXEC = 'HOST_CMD_EXEC';

//  (IE-only) Execute an XSLT stylesheet
TP.XSLT_EXEC = 'XSLT_EXEC';

TP.PRIVILEGE_FLAGS = {};

TP.PRIVILEGE_DESCRIPTIONS = {
    SHOW_ABOUT: 'Show a special "about:" panel',
    READ_HISTORY: 'Read the browing history',
    READ_PREFERENCE: 'Read a preference',
    WRITE_PREFERENCE: 'Store a preference',
    MANIPULATE_WINDOW: 'Manipulate a window',
    READ_EXECUTION_STACK: 'Read the JavaScript execution stack',
    ACCESS_XDOMAIN_FRAME: 'Access a window from another domain',
    ACCESS_DOM_INSPECT: 'Inspect a DOM element',

    ACCESS_XDOMAIN_XMLHTTP: 'Access data from another domain',
    HOST_XSLT_EXEC: 'Execute an XSLT stylesheet',

    HOST_FILE_ACCESS: 'General file system access',
    HOST_FILE_DELETE: 'Delete a file',
    HOST_FILE_SAVE: 'Save a file',
    HOST_CMD_EXEC: 'Execute a shell command'
};

//  ------------------------------------------------------------------------
//  REFLECTION KEYS
//  ------------------------------------------------------------------------

/*
To support reflection on methods, properties, etc in an environment in which
you can have both "local" and inherited functionality, TIBET implements a
set of get*Interface calls which take a key defining what specific
properties you're looking for. These keys map to the following dictionaries
which define the parameters used to filter the object's keys.
*/

//  ------------------------------------------------------------------------

/*
Here are the parameter sets which are used by the final $getInterface()
call. These are accessed via the earlier global key definitions.

NOTE: the collection is sparse and relies on default values of:

    attributes: true
    methods: false
    hidden: false
    scope: unique
    public: if hidden is false, then the default is true. If hidden is true,
            then the default is false. Specify 'hidden: true' and 'public: true'
            to get both.

    Scope is defined as follows:

        TP.ALL          all slots, no matter where they exist
        TP.LOCAL        only if the slot exists locally on the object and not on
                        any of its prototype chain and the object itself is not
                        a prototype of others.
        TP.INTRODUCED   only if this slot exists locally on the object, not on
                        any of its prototype chain and the object itself is a
                        prototype of others.
        TP.INHERITED    only if this slot exists both on the object and its
                        prototype and they both have the *identical* value.
        TP.OVERRIDDEN   only if this slot exists both on the object and its
                        prototype and they do *not* have the *identical* value.
*/

TP.SLOT_FILTERS = {
    //  Visibility
    public: {
        methods: true,
        scope: TP.ALL
    },
    hidden: {
        methods: true,
        hidden: true,
        scope: TP.ALL
    },
    known: {
        methods: true,
        hidden: true,
        scope: TP.ALL,
        public: true
    },

    //  Different scopes
    unique: {
        methods: true
    },
    local: {
        methods: true,
        scope: TP.LOCAL
    },
    introduced: {
        methods: true,
        scope: TP.INTRODUCED
    },
    inherited: {
        methods: true,
        scope: TP.INHERITED
    },
    overridden: {
        methods: true,
        scope: TP.OVERRIDDEN
    },

    //  Attributes only
    attributes: {
        scope: TP.ALL
    },
    hidden_attributes: {
        hidden: true,
        scope: TP.ALL
    },
    known_attributes: {
        hidden: true,
        scope: TP.ALL,
        public: true
    },

    unique_attributes: {
    },  //  default values
    local_attributes: {
        scope: TP.LOCAL
    },
    introduced_attributes: {
        scope: TP.INTRODUCED
    },
    inherited_attributes: {
        scope: TP.INHERITED
    },
    overridden_attributes: {
        scope: TP.OVERRIDDEN
    },

    hidden_unique_attributes: {
        hidden: true
    },
    hidden_local_attributes: {
        hidden: true,
        scope: TP.LOCAL
    },
    hidden_introduced_attributes: {
        hidden: true,
        scope: TP.INTRODUCED
    },
    hidden_inherited_attributes: {
        hidden: true,
        scope: TP.INHERITED
    },
    hidden_overridden_attributes: {
        hidden: true,
        scope: TP.OVERRIDDEN
    },

    known_unique_attributes: {
        hidden: true,
        public: true
    },
    known_local_attributes: {
        hidden: true,
        scope: TP.LOCAL,
        public: true
    },
    known_introduced_attributes: {
        hidden: true,
        scope: TP.INTRODUCED,
        public: true
    },
    known_inherited_attributes: {
        hidden: true,
        scope: TP.INHERITED,
        public: true
    },
    known_overridden_attributes: {
        hidden: true,
        scope: TP.OVERRIDDEN,
        public: true
    },

    //  Methods only
    methods: {
        attributes: false,
        methods: true,
        scope: TP.ALL
    },
    hidden_methods: {
        attributes: false,
        methods: true,
        hidden: true,
        scope: TP.ALL
    },
    known_methods: {
        attributes: false,
        methods: true,
        hidden: true,
        scope: TP.ALL,
        public: true
    },

    unique_methods: {
        attributes: false,
        methods: true
    },
    local_methods: {
        attributes: false,
        methods: true,
        scope: TP.LOCAL
    },
    introduced_methods: {
        attributes: false,
        methods: true,
        scope: TP.INTRODUCED
    },
    inherited_methods: {
        attributes: false,
        methods: true,
        scope: TP.INHERITED
    },
    overridden_methods: {
        attributes: false,
        methods: true,
        scope: TP.OVERRIDDEN
    },

    hidden_unique_methods: {
        attributes: false,
        methods: true,
        hidden: true
    },
    hidden_local_methods: {
        attributes: false,
        methods: true,
        hidden: true,
        scope: TP.LOCAL
    },
    hidden_introduced_methods: {
        attributes: false,
        methods: true,
        hidden: true,
        scope: TP.INTRODUCED
    },
    hidden_inherited_methods: {
        attributes: false,
        methods: true,
        hidden: true,
        scope: TP.INHERITED
    },
    hidden_overridden_methods: {
        attributes: false,
        methods: true,
        hidden: true,
        scope: TP.OVERRIDDEN
    },

    known_unique_methods: {
        attributes: false,
        methods: true,
        hidden: true,
        public: true
    },
    known_local_methods: {
        attributes: false,
        methods: true,
        hidden: true,
        scope: TP.LOCAL,
        public: true
    },
    known_introduced_methods: {
        attributes: false,
        methods: true,
        hidden: true,
        scope: TP.INTRODUCED,
        public: true
    },
    known_inherited_methods: {
        attributes: false,
        methods: true,
        hidden: true,
        scope: TP.INHERITED,
        public: true
    },
    known_overridden_methods: {
        attributes: false,
        methods: true,
        hidden: true,
        scope: TP.OVERRIDDEN,
        public: true
    },

    //  Attributes and methods
    hidden_unique: {
        methods: true,
        hidden: true
    },
    hidden_local: {
        methods: true,
        hidden: true,
        scope: TP.LOCAL
    },
    hidden_introduced: {
        methods: true,
        hidden: true,
        scope: TP.INTRODUCED
    },
    hidden_inherited: {
        methods: true,
        hidden: true,
        scope: TP.INHERITED
    },
    hidden_overridden: {
        methods: true,
        hidden: true,
        scope: TP.OVERRIDDEN
    },

    known_unique: {
        methods: true,
        hidden: true,
        public: true
    },
    known_local: {
        methods: true,
        hidden: true,
        scope: TP.LOCAL,
        public: true
    },
    known_introduced: {
        methods: true,
        hidden: true,
        scope: TP.INTRODUCED,
        public: true
    },
    known_inherited: {
        methods: true,
        hidden: true,
        scope: TP.INHERITED,
        public: true
    },
    known_overridden: {
        methods: true,
        hidden: true,
        scope: TP.OVERRIDDEN,
        public: true
    }
};

//  ------------------------------------------------------------------------
//  PRE-BUILT FUNCTION PARAMETERS
//  ------------------------------------------------------------------------

/*
Functions intended to serve as pre-built parameter values to things which
take parameters for filtering, sorting, or other operations. The argument
list return functions can be very useful in list processing where they help
work with arrays and ordered pairs without requiring custom iterators.
*/

//  ------------------------------------------------------------------------

//  simple functions to log arguments. useful for testing iterators,
//  particularly regular expression iteration via RegExp.performWith

TP.LOG_ARGS = function() {

    var args;

    args = TP.args(arguments);
    TP.ifTrace() ? TP.trace(args) : 0;
};

TP.NOTIFY_ARGS = function() {

    var args;

    args = TP.args(arguments);
    TP.boot.$notify(args, 'ARGS');
};

//  ------------------------------------------------------------------------

/*
A pre-built handler function useful for testing signal notification is
occurring as you intend. Registering this handler will force a log entry
when the handler is actually invoked.
*/
TP.TEST_HANDLER = function(aSignal) {
    TP.info('TP.TEST_HANDLER fired for: ' +
                aSignal.getSignalName() + ' @ ' +
                aSignal.getSignalOrigin(),
            TP.SIGNAL_LOG);
};

TP.TEST_SETUP_NAME = 'Test_SetUp';      //  the method name of object-level test
                                        //  set up methods
TP.TEST_TEARDOWN_NAME = 'Test_TearDown'; //  the method name of the test
                                        //  tear down methods
TP.TEST_NAME_PREFIX = 'test ';          //  prefixed on all test function names

TP.PERFORM = 'Perform';
TP.SKIP = 'Skip';
TP.TODO = 'Todo';

TP.PRODUCED = 'Produced';
TP.EXPECTED = 'Expected';

//  ------------------------------------------------------------------------

/*
Common return value functions which help support certain iteration and test
scenarios without requiring custom functions or type checking. Also, certain
options here, such as RETURN_ARG0, represent common features (K function)
etc. that you may find useful.
*/

TP.RETURN_NULL = function() {
    return;
};
TP.RETURN_THIS = function() {
    return this;
};
TP.RETURN_TRUE = function() {
    return true;
};
TP.RETURN_FALSE = function() {
    return false;
};

TP.RETURN_ARG0 = function() {
    return arguments[0];
};
TP.RETURN_ARGS = function() {
    return arguments;
};

//  item selectors, useful for key/item manipulations
TP.RETURN_FIRST = function(item) {
    return item.first();
};
TP.RETURN_LAST = function(item) {
    return item.last();
};

//  when you just gotta have an array
TP.RETURN_EMPTY_ARRAY = function() {
    return [];
};
//  when you just gotta have a string
TP.RETURN_EMPTY_STRING = function() {
    return '';
};
TP.RETURN_SPACE = function() {
    return ' ';
};

//  union and addAll "duplicate discriminators"
TP.RETURN_ORIG = function(key, orig) {
    return orig;
};
TP.RETURN_NEW = function(key, orig, knew) {
    return knew;
};

TP.RETURN_TOSTRING = function() {
    return this.toString();
};

TP.INVOKE_WRAPPED = function(aFunction) {
    return function(anObject) {
        return aFunction(TP.wrap(anObject));
    };
};

TP.D3_SELECT = function(aSelector) {
    return function() {
        return TP.byCSSPath(aSelector, this, false, false).first();
    };
};

TP.D3_SELECT_ALL = function(aSelector) {
    return function() {
        return TP.byCSSPath(aSelector, this, false, false);
    };
};

//  ------------------------------------------------------------------------
//  STRING LOCALIZATION / MAPPING
//  ------------------------------------------------------------------------

//  Define a placeholder for string constant lookup. The idea is that each
//  TP.i18n.Locale can place sprintf-capable (or constant) strings here upon
//  activation so code can simply refer to TP.msg.{{STRING_NAME}} in code.
TP.msg = {};

//  ------------------------------------------------------------------------
//  DATASET LOOKUP
//  ------------------------------------------------------------------------

TP.defineNamespace('TP.dat');

//  ------------------------------------------------------------------------
//  DOM TYPES
//  ------------------------------------------------------------------------

TP.defineNamespace('TP.dom');

//  ------------------------------------------------------------------------
//  SORT FUNCTIONS
//  ------------------------------------------------------------------------

/*
Somewhat brute-force, but useful sort functions that come up often.
*/

//  ------------------------------------------------------------------------

TP.defineNamespace('TP.sort');

//  ------------------------------------------------------------------------

//  a sort that works just like the built-in alphabetic sort, but ignores
//  case-sensitivity
TP.sort.CASE_INSENSITIVE = function(a, b) {

    var aLower,
        bLower;

    aLower = a.toLowerCase();
    bLower = b.toLowerCase();

    if (aLower < bLower) {
        return -1;
    } else if (aLower > bLower) {
        return 1;
    }

    return 0;
};

//  a 'natural byte order' sort modified to meet TIBET coding standards from
//  the following:

/*
natcompare.js -- Perform 'natural order' comparisons of strings in
JavaScript.
Copyright (C) 2005 by SCK-CEN (Belgian Nucleair Research Centre)
Written by Kristof Coomans <kristof[dot]coomans[at]sckcen[dot]be>

Based on the Java version by Pierre-Luc Paour, of which this is more or less
a straight conversion.
Copyright (C) 2003 by Pierre-Luc Paour <natorder@paour.com>

The Java version was based on the C version by Martin Pool.
Copyright (C) 2000 by Martin Pool <mbp@humbug.org.au>

This software is provided 'as-is', without any express or implied
warranty.  In no event will the authors be held liable for any damages
arising from the use of this software.

Permission is granted to anyone to use this software for any purpose,
including commercial applications, and to alter it and redistribute it
freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must not
claim that you wrote the original software. If you use this software
in a product, an acknowledgment in the product documentation would be
appreciated but is not required.
2. Altered source versions must be plainly marked as such, and must not be
misrepresented as being the original software.
3. This notice may not be removed or altered from any source distribution.
*/

TP.sort.NATURAL_ORDER = function(a, b) {

    var isWhitespaceChar,
        isDigitChar,
        compareRight,

        ia,
        ib,
        nza,
        nzb,
        ca,
        cb,
        result;

    isWhitespaceChar = function(char) {

        var charCode;

        charCode = char.charCodeAt(0);

        if (charCode <= 32) {
            return true;
        } else {
            return false;
        }
    };

    isDigitChar = function(char) {

        var charCode;

        charCode = char.charCodeAt(0);

        if (charCode >= 48 && charCode <= 57) {
            return true;
        } else {
            return false;
        }
    };

    compareRight = function(first, last) {

        var bias,
            ia2,
            ib2,

            ca2,
            cb2;

        bias = 0;
        ia2 = 0;
        ib2 = 0;

        //  The longest run of digits wins.  That aside, the greatest
        //  value wins, but we can't know that it will until we've
        //  scanned both numbers to know that they have the same
        //  magnitude, so we remember it in BIAS.
        for (;; ia2++, ib2++) {
            ca2 = first.charAt(ia2);
            cb2 = last.charAt(ib2);

            if (!isDigitChar(ca2) && !isDigitChar(cb2)) {
                return bias;
            } else if (!isDigitChar(ca2)) {
                return -1;
            } else if (!isDigitChar(cb2)) {
                return +1;
            } else if (ca2 < cb2) {
                if (bias === 0) {
                    bias = -1;
                }
            } else if (ca2 > cb2) {
                if (bias === 0) {
                    bias = +1;
                }
            } else if (ca2 === 0 && cb2 === 0) {
                return bias;
            }
        }
    };

    ia = 0;
    ib = 0;
    nza = 0;
    nzb = 0;

    /* eslint-disable no-constant-condition */
    while (true) {
        //  only count the number of zeroes leading the last number
        //  compared
        nza = 0;
        nzb = 0;

        ca = a.charAt(ia);
        cb = b.charAt(ib);

        //  skip over leading spaces or zeros
        while (isWhitespaceChar(ca) || ca === '0') {
            if (ca === '0') {
                nza++;
            } else {
                //  only count consecutive zeroes
                nza = 0;
            }

            ca = a.charAt(++ia);
        }

        while (isWhitespaceChar(cb) || cb === '0') {
            if (cb === '0') {
                nzb++;
            } else {
                //  only count consecutive zeroes
                nzb = 0;
            }

            cb = b.charAt(++ib);
        }

        //  process run of digits
        if (isDigitChar(ca) && isDigitChar(cb)) {
            if ((result = compareRight(a.substring(ia),
                                        b.substring(ib))) !== 0) {
                return result;
            }
        }

        if (ca === 0 && cb === 0) {
            //  The strings compare the same.  Perhaps the caller
            //  will want to call strcmp to break the tie.
            return nza - nzb;
        }

        if (ca < cb) {
            return -1;
        } else if (ca > cb) {
            return +1;
        }

        ++ia;
        ++ib;
    }
    /* eslint-enable no-constant-condition */
};

//  compare utility function, used to build up multiple sorts
TP.sort.COMPARE = function(a, b) {

    if (a > b) {
        return +1;
    }

    if (a < b) {
        return -1;
    }

    return 0;
};

//  compareTo sort block which sorts based on "magnitude"
TP.sort.COMPARE_TO = function(a, b) {

    return a.compareTo(b);
};

//  sort block that pushes "deleted" elements to the end for truncation
TP.sort.DELETION = function(a, b) {

    if (a !== TP.DELETED && b === TP.DELETED) {
        return -1;
    } else if (a === TP.DELETED && b !== TP.DELETED) {
        return 1;
    }

    return 0;
};

//  nodes can be sorted in document order using this sort
TP.sort.DOCUMENT_ORDER = function(a, b) {

    if (a.sourceIndex) {
        return a.sourceIndex - b.sourceIndex;
    } else if (a.compareDocumentPosition) {
        return 3 - (a.compareDocumentPosition(b) & 6);
    } else {
        return 0;
    }
};

//  elements can be sorted in tabindex order using this sort
TP.sort.TABINDEX_ORDER = function(a, b) {

    var aVal,
        bVal;

    aVal = parseInt(a.getAttribute('tabindex'), 10);
    bVal = parseInt(b.getAttribute('tabindex'), 10);

    //  Neither 'a' or 'b' has a tabindex value. Leave the elements in
    //  document order.
    if (isNaN(aVal) && isNaN(bVal)) {
        return TP.sort.DOCUMENT_ORDER(a, b);
    } else if (isNaN(aVal) && !isNaN(bVal)) {
        //  'a' has no tabindex value and 'b's is either -1 or 0. Leave
        //  elements in document order.
        if (bVal <= 0) {
            return TP.sort.DOCUMENT_ORDER(a, b);
        }

        //  'b' has a real, positive integer tabindex - it should come
        //  before 'a'
        return 1;
    } else if (!isNaN(aVal) && isNaN(bVal)) {
        //  'b' has no tabindex value and 'a's is either -1 or 0. Leave
        //  elements in document order.
        if (aVal <= 0) {
            return TP.sort.DOCUMENT_ORDER(a, b);
        }

        //  'a' has a real, positive integer tabindex - it should come
        //  before 'b'
        return -1;
    } else if (aVal <= 0 && bVal <= 0) {
        //  Both 'a' and 'b' have a tabindex value that is either -1 or
        //  0. Leave elements in document order.
        return TP.sort.DOCUMENT_ORDER(a, b);
    } else if (aVal <= 0 && bVal > 0) {
        //  'a' has a tabindex value of either -1 or 0 and 'b' has a
        //  real, positive integer tabindex - it should come before 'a'
        return 1;
    } else if (aVal > 0 && bVal <= 0) {
        //  'b' has a tabindex value of either -1 or 0 and 'a' has a
        //  real, positive integer tabindex - it should come before 'b'
        return -1;
    }

    //  'a' and 'b' both have real, positive integer tabindex values.
    //  Sort ascending by that value.
    return aVal - bVal;
};

//  sort objects by their "equality values" often their string values
TP.sort.EQUALITY = function(a, b) {

    var arep,
        brep;

    if (TP.notValid(a)) {
        arep = TP.str(a);
    } else if (TP.canInvoke(a, '$getEqualityValue')) {
        arep = TP.str(a.$getEqualityValue());
    } else {
        arep = TP.str(a);
    }

    if (TP.notValid(b)) {
        brep = TP.str(b);
    } else if (TP.canInvoke(b, '$getEqualityValue')) {
        brep = TP.str(b.$getEqualityValue());
    } else {
        brep = TP.str(b);
    }

    if (arep < brep) {
        return -1;
    } else if (arep > brep) {
        return 1;
    }

    return 0;
};

//  a simple sort for arrays containing ordered pairs by their "key" slot
TP.sort.FIRST_ITEM = function(a, b) {

    if (!a && b) {
        return 1;
    } else if (a && !b) {
        return -1;
    } else if (a.at(0) < b.at(0)) {
        return -1;
    } else if (a.at(0) > b.at(0)) {
        return 1;
    }

    return 0;
};

//  sort objects by their "identity values" (aka their IDs or pointers)
TP.sort.IDENTITY = function(a, b) {

    var arep,
        brep;

    if (TP.notValid(a)) {
        arep = TP.str(a);
    } else if (TP.canInvoke(a, '$getIdentityValue')) {
        arep = TP.str(a.$getIdentityValue());
    } else {
        arep = TP.str(a);
    }

    if (TP.notValid(b)) {
        brep = b;
    } else if (TP.canInvoke(b, '$getIdentityValue')) {
        brep = b.$getIdentityValue();
    } else {
        brep = b;
    }

    if (arep < brep) {
        return -1;
    } else if (arep > brep) {
        return 1;
    }

    return 0;
};

//  numerical sort block
TP.sort.NUMERIC = function(a, b) {
    return a - b;
};

//  a simple sort for arrays containing ordered pairs by their "value" slot
TP.sort.SECOND_ITEM = function(a, b) {

    if (!a && b) {
        return 1;
    } else if (a && !b) {
        return -1;
    } else if (a.at(1) < b.at(1)) {
        return -1;
    } else if (a.at(1) > b.at(1)) {
        return 1;
    }

    return 0;
};

//  sort to order a list by number of supertypes which effectively sorts
//  from parent to child (across one or more branches)
TP.sort.SUBTYPE = function(a, b) {

    var asize,
        bsize;

    asize = a.getSupertypeNames().getSize();
    bsize = b.getSupertypeNames().getSize();

    if (asize < bsize) {
        return -1;
    } else if (asize > bsize) {
        return 1;
    }

    return 0;
};

//  simple unicode-value sort
TP.sort.UNICODE = function(a, b) {

    var au,
        bu;

    au = TP.str(a).unicodeEscaped();
    bu = TP.str(b).unicodeEscaped();

    if (au < bu) {
        return -1;
    } else if (au > bu) {
        return 1;
    }

    return 0;
};

//  simple element sort
TP.sort.ELEMENT = function(a, b) {

    var atag,
        btag;

    atag = a.tagName.toLowerCase();
    btag = b.tagName.toLowerCase();

    if (atag < btag) {
        return -1;
    } else if (atag > btag) {
        return 1;
    }

    return 0;
};

//  a sort that works just like the built-in alphabetic sort, but ignores
//  case-sensitivity
TP.sort.CSS_RULE_SORT = function(a, b) {

    var aSpecificity,
        bSpecificity,

        aSheetPosition,
        bSheetPosition,

        aRulePosition,
        bRulePosition;

    aSpecificity = a.at('specificityInfo').specificityScore;
    bSpecificity = b.at('specificityInfo').specificityScore;

    if (aSpecificity < bSpecificity) {
        return -1;
    } else if (aSpecificity > bSpecificity) {
        return 1;
    }

    //  Specificity is the same - let's try sheet position.

    aSheetPosition = a.at('sheetPosition');
    aSheetPosition = b.at('sheetPosition');

    if (aSheetPosition < bSheetPosition) {
        return -1;
    } else if (aSheetPosition > bSheetPosition) {
        return 1;
    }

    //  Sheet position is the same. They must come from the same stylesheet.
    //  Let's try rule position within the sheet.

    aRulePosition = a.at('rulePosition');
    bRulePosition = b.at('rulePosition');

    if (aRulePosition < bRulePosition) {
        return -1;
    } else if (aRulePosition > bRulePosition) {
        return 1;
    }

    return 0;
};

//  a sort that orders DOM nodes first by position in the document using the
//  TP.PREVIOUS_POSITION slot (shallower DOM nodes first) and then, if the
//  'depth' is equal, the position of the Node in its parent's child node list
//  ('earlier' nodes first).
TP.sort.DOM_POSITION_SORT = function(a, b) {

    var aPosition,
        bPosition,

        aSum,
        bSum;

    aPosition = a[TP.PREVIOUS_POSITION];
    bPosition = b[TP.PREVIOUS_POSITION];

    if (aPosition.length < bPosition.length) {
        return -1;
    } else if (aPosition.length > bPosition.length) {
        return 1;
    }

    //  The 'depth' was equal - sort by the position in the parent's child node
    //  list by summing the positions.
    aSum = aPosition.split('.').sum();
    bSum = bPosition.split('.').sum();

    if (aSum < bSum) {
        return -1;
    } else if (aSum > bSum) {
        return 1;
    }

    return 0;
};

//  Sorts keymap XML elements by whether they have no qualifier, just
//  'platform', just 'browser' or 'platform' AND 'browser'. This is considered
//  'least to most specific' for keymaps.
TP.sort.KEYMAP_ELEMENT = function(a, b) {

    var aHasPlatform,
        aHasBrowser,

        bHasPlatform,
        bHasBrowser,

        aWeight,
        bWeight;

    aHasBrowser = a.hasAttribute('browser');
    aHasPlatform = a.hasAttribute('platform');

    bHasBrowser = b.hasAttribute('browser');
    bHasPlatform = b.hasAttribute('platform');

    //  If the element has both browser and platform, it is weighted most,
    //  followed by only browser, followed by only platform, followed by
    //  neither.

    if (aHasBrowser && aHasPlatform) {
        aWeight = 10;
    } else if (aHasBrowser && !aHasPlatform) {
        aWeight = 5;
    } else {
        aWeight = 1;
    }

    if (bHasBrowser && bHasPlatform) {
        bWeight = 10;
    } else if (bHasBrowser && !bHasPlatform) {
        bWeight = 5;
    } else {
        bWeight = 1;
    }

    //  Sort ascending by the weight
    return aWeight - bWeight;
};

//  ------------------------------------------------------------------------
//  COMMON REGEXES
//  ------------------------------------------------------------------------

/*
Regular expressions we reuse throughout TIBET but compile only once. NOTE
that the global ones have to be "reset" by setting their lastIndex to 0
prior to running them to ensure they'll operate properly. This is done
automatically by the RegExp.performWith call when using the regex as an
enumerator over a string.
*/

//  ------------------------------------------------------------------------

TP.defineNamespace('TP.regex');

//  ------------------------------------------------------------------------

TP.regex.JOIN = new RegExp(TP.JOIN, 'g');
TP.regex.BASE_AWARE = new RegExp(TP.BASE_AWARE_PREFIX);

//  The grouping name can be found in group 1
TP.regex.GROUPING = new RegExp(TP.GROUPING_PREFIX + '\\s*-\\s*(.+)');
TP.regex.SPACING = new RegExp(TP.SPACING);

//  ---
//  type-checking/metadata
//  ---

TP.regex.ARRAY_CONSTRUCTOR = /function Array\(\)/;
TP.regex.BOOLEAN_CONSTRUCTOR = /function Boolean\(\)/;
TP.regex.DATE_CONSTRUCTOR = /function Date\(\)/;
TP.regex.FUNCTION_CONSTRUCTOR = /function Function\(\)/;
TP.regex.OBJECT_CONSTRUCTOR = /function Object\(\)/;
TP.regex.NUMBER_CONSTRUCTOR = /function Number\(\)/;
TP.regex.REGEXP_CONSTRUCTOR = /function RegExp\(\)/;
TP.regex.STRING_CONSTRUCTOR = /function String\(\)/;

TP.regex.FUNCTION_LITERAL = /^function(?:.*)\((?:.*)\)(?:\s*)\{(?:.*)\}$/;
TP.regex.FUNCTION_EXTRACT = /\s*function\s*\(.*?\)\s*\{([\s\S]*)\}\s*/;

//  A list of methods that needs 'callee' access.
TP.regex.NEEDS_CALLEE =
    /\.(callNextMethod|callNextHandler|getCurrentCallee)(\(|\.apply|\.call)/;

TP.regex.ATTRIBUTE_NAME = /^[_$][a-zA-Z0-9_$]*$|^[A-Z]/;

TP.regex.PUBLIC_SLOT = /^_/;
TP.regex.PRIVATE_SLOT = /^\$[^$]/;
TP.regex.INTERNAL_SLOT = /^\$\$|\$\$(Inst|Type)|^__(.*)__$/;

TP.regex.PRIVATE_OR_INTERNAL_SLOT = /^\$|\$\$(Inst|Type)|^__(.*)__$/;

TP.regex.ANY_TYPE_SLOT = /^_|^\$|\$\$(Inst|Type)|^__(.*)__$/;

TP.regex.NATIVE_CODE = /\[native code\]/;
TP.regex.UNDERSCORES = /_/g;            //  needs reset

//  Native typenames: first character should be uppercase, followed by zero or
//  more of any uppercase, lowercase or numeric characters.
TP.regex.NATIVE_TYPENAME = /^[A-Z]+[A-Za-z0-9]+/;
TP.regex.NATIVE_TYPENAME_MATCH = /^\[object/;
TP.regex.NATIVE_TYPENAME_EXTRACT = / (.*)\]/;

//  Note here how we make the space optional - it's not required and the code
//  might be minified.
TP.regex.ECMA_CLASS = /^class\s*\{/;

TP.regex.VALID_NAMESPACEROOTNAME = /^(TP|APP)$/;
TP.regex.VALID_NAMESPACENAME = /^(TP|APP)[.:]{1}([a-zA-Z0-9_]+)/;
TP.regex.VALID_TYPENAME = /^[a-zA-Z]([-a-zA-Z0-9_.:]){2,}$/;
TP.regex.VALID_WINDOWNAME = /^[a-zA-Z]([-a-zA-Z0-9_](\.)*){1,}$/;

TP.regex.APP_TYPENAME = /^APP\./;
TP.regex.TP_TYPENAME = /^TP\./;
TP.regex.META_TYPENAME = /\.meta\./;

TP.regex.INTERNAL_TYPENAME = /^(Inst|Type|Local)$/;

TP.regex.INSTANCE_OID = /^([a-zA-Z_$]{1}[a-zA-Z0-9_$]*?)\$([a-zA-Z0-9]{12,})$/;

TP.regex.LOCAL_TRACK = /Local/;
TP.regex.ROOT_OBJECTS = /Object|TP.lang.RootObject|TP.lang.Object/;

//  js identifiers
TP.regex.JS_FIRST_CHAR = /^[a-zA-Z_$]/;
TP.regex.JS_IDENT_REPLACE = /[^a-zA-Z0-9_$]/g;          //  needs reset
TP.regex.JS_IDENTIFIER = /^[a-zA-Z_$]{1}[a-zA-Z0-9_$]*$/;
TP.regex.JS_OPERATORS =
            /(\+|-|\*|\/|=|>|<|>=|<=|&|\||%|!|\^|\(|\)|\?([^?]+):([^:]+))/;
TP.regex.JS_SYMBOL = /Symbol\(.+\)/;

TP.regex.JS_ASSIGNMENT =
    /(^|;|\s+)([a-zA-Z_$]{1}[a-zA-Z0-9_$]*)(\s*=[^=])/g; // needs reset

//  matching facet slot names
TP.regex.FACET_SLOT_NAME_MATCH = new RegExp('\\$(\\w+)_(' +
                                            TP.FACET_NAMES.join('|') +
                                            ')');

TP.regex.JSON_SCHEMA_TYPENAME_EXTRACT = /"type":"([^"]+)"/g;    //  needs reset

//  ---
//  character testing
//  ---

TP.regex.HAS_AT = /@/;
TP.regex.HAS_BACKSLASH = /\\/;
TP.regex.HAS_COLON = /:/;
TP.regex.HAS_HASH = /#/;
TP.regex.HAS_HYPHEN = /\-/;
TP.regex.HAS_LINEBREAK = /\n|\r/;
TP.regex.HAS_PAREN = /\(|\)/;       //  moz won't parse without closing )
TP.regex.HAS_PERCENT = /%/;
TP.regex.HAS_PERIOD = /\./;
TP.regex.HAS_PIPE = /[^\\]?\|/;         //  not valid if escaped via backslash
TP.regex.HAS_PIPE_SPLAT = /[^\\]?\|\*/; //  not valid if escaped via backslash
TP.regex.HAS_SCHEME = /^([A-Za-z][-.+A-Za-z0-9]*):/;
TP.regex.HAS_SINGLE_QUOTE = /'/;
TP.regex.HAS_SLASH = /\//;
TP.regex.HAS_TIMEZONE = /[Z\+\-]/;
TP.regex.HAS_PIPE = /\|/;
TP.regex.HAS_OID_SUFFIX = /(\$[a-zA-Z0-9]{12,}|(.*)_([a-zA-Z0-9]{12,})(_[a-zA-Z0-9]+)*)$/;

//  ---
//  css support
//  ---

//  CSS 'scoped selector' - cannot be used with standard W3C CSSOM methods
TP.regex.CSS_CUSTOM_SCOPED_SELECTOR = /^[+>~]/;

TP.regex.CONTAINS_CSS = /\s*[a-zA-Z\-]+\s*[:]{1}\s[a-zA-Z0-9\s.#]+[;]{1}/;

TP.regex.CSS_CLIP_RECT = /rect\s*\((\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s*\)/;

//  The URL of the rule can be found in group 2. (needs reset)
TP.regex.CSS_IMPORT_RULE = /@import\s*(url\()?['"]?(.*?)['"]?(\))?;/g;

//  The URL value of the property can be found in group 2. (needs reset)
TP.regex.CSS_URL_PROPERTY = /:\s+(url\(){1}['"]?([^)]*?)['"]?(\)){1}/g;

//  The URL value of the property can be found in group 2. (needs reset)
TP.regex.CSS_URL_VALUE = /(url\(){1}['"]?([^)]*?)['"]?(\)){1}/g;

//  The URL value of the property can be found in group 2. (needs reset)
TP.regex.CSS_VIRTUAL_URL_VALUE = /(url\(){1}['"]?(~[^)]*?)['"]?(\)){1}/g;

//  Whether or not the name denotes a CSS 'custom property'.
TP.regex.CSS_CUSTOM_PROPERTY_NAME = /^--/;

TP.regex.PIXELS = /px/;
TP.regex.QUANTIFIERS = /[\$\.\?\+\(\)]/g;                   //  needs reset

TP.regex.ATTRIBUTE_STRING = /([-\w]+)\s*=\s*(['"])(.+?)\2\s*/g; //  needs reset
TP.regex.STYLE_STRING = /([-\w]+)\s*:\s*([^/]+?)\s*($|;)/g; //  needs reset

//  Used by the CSS processor
TP.EMPTY_ARRAY = [];

//  CSS classes used by the Lama to visually manipulate elements on its
//  canvas.
TP.regex.LAMA_CSS_CLASS = /lama-[A-Za-z0-9-]+ ?/g;  //  needs reset

//  ---
//  data binding
//  ---

TP.regex.BOUND_ELEMENT = /bind:/;
TP.regex.BOUND_INSTANCE = /instance\((.*)\)(.*)/;
TP.regex.DYNAMIC_BINDPATH = /\[/;   //  predicate
TP.regex.REPEATING_ATTRIBUTE = /repeat-/;

//  ---
//  boot/dynaloading
//  ---

TP.regex.DYNALOADED = null;
TP.DYNALOADED = 'inlined/evaluated source code';
TP.MISSING_CODE = 'missing/unavailable source code';

//  ---
//  event handling
//  ---

TP.BACK_SPACE_KEY = 8;
TP.TAB_KEY = 9;
TP.ENTER_KEY = 10;
TP.RETURN_KEY = 13;
TP.SHIFT_KEY = 16;
TP.CONTROL_KEY = 17;
TP.ALT_KEY = 18;
TP.ESCAPE_KEY = 27;
TP.DELETE_KEY = 46;

TP.regex.CTRL = /Ctrl_.+/;
TP.regex.ALT = /Alt_.+/;
TP.regex.META = /Meta_.+/;
TP.regex.SHIFT = /Shift_.+/;

TP.regex.PRESS_END = /[Pp]ress$/;
TP.regex.DOWN_END = /[Dd]own$/;
TP.regex.UP_END = /[Uu]p$/;

TP.regex.KEY_EVENT = /^key|DOMKey|_(?:Up|Down|Press)$/;
TP.regex.MOUSE_EVENT = /^mouse|DOMMouse|DOMClick|DOMDblClick/;

TP.regex.SIGNAL_PREFIX = /^(TP|APP)\.sig\./;
TP.regex.HANDLER_NAME = /^handle([-_a-zA-Z0-9]+)$/;

/* eslint-disable max-len */
TP.regex.SPLIT_HANDLER_NAME =
    /^handle([A-Z0-9$][a-zA-Z0-9_]*?)(Capturing)*(From([A-Z][a-zA-Z0-9_]*?))*?(When([A-Z][a-zA-Z0-9_]*?))*?$/;
/* eslint-enable max-len */

//  ---
//  file paths
//  ---

TP.regex.HAS_PATH_OFFSET = /\/\.\./;
TP.regex.HAS_PATH_NOOP = /\/\./;
TP.regex.REMOVE_PATH_OFFSET = /(^|\/)[^\/]*\/\.\./;
TP.regex.REMOVE_PATH_NOOP = /\/\./;

TP.regex.FILE_PATH = /\.([^\/]*)$/;
TP.regex.ROOT_PATH = /^\/(\w)*/;
TP.regex.UNC_PATH = /^\\\\\w/;
TP.regex.WINDOWS_PATH = /^(")*\w:\\(.*)/;

//  ---
//  formatting/substitution
//  ---

//  Character substitutions in Strings
TP.regex.FORMAT_SUBSTITUTION = /[#%@]\{/;

//  Templating delimiters
TP.regex.STARTS_ACP = /^\{\{/;
TP.regex.HAS_ACP = /\{\{.*\}\}/;
TP.regex.HAS_ACP_ATTR = /\s*([\w:]+)=['"]\{\{.*\}\}['"]/;
TP.regex.EXTRACT_ACP = /\{\{(.+?)\}\}/;

TP.regex.ACP_NUMERIC = /\{\{(\d+)\}\}/g;   //  needs reset

TP.regex.ACP_BEGIN = /\{\{/g;
TP.regex.ACP_END = /\}\}/g;

TP.regex.ACP_ENCODED_BEGIN = /_BEGIN_ACP_/g;
TP.regex.ACP_ENCODED_END = /_END_ACP_/g;

//  0-n non-'\' characters followed by 0-n whitespace, followed by '.%',
//  followed by 0-n whitespace, followed by 1-n any characters
TP.regex.ACP_FORMAT = /([^\\]*?)\s*\.%\s*(.+)/;

//  Multiple formats in a 'ui:format' attribute can be separated by these.
TP.regex.ACP_FORMAT_SEPARATOR = /\s*\.\|\s*/;

//  All of the ACP operators legal in a template - '.%', '.%*', '.||'
TP.regex.ACP_OPERATORS = /(\.(%\*|%|\|\|))/g;   //  needs reset

TP.regex.ACP_CONTROL_TOKEN = /(with|if|for)/;
TP.regex.ACP_VALUE_TOKEN = /value/;

TP.regex.ACP_BEGIN_CONTROL_STATEMENT = /\{\{:(with|if|for)(.*?)\}\}/;
TP.regex.ACP_END_CONTROL_STATEMENT = /\{\{\/:(with|if|for)\}\}/;

//  '$' followed by a word character (but *not* including '_') or '*' or '#'
TP.regex.ACP_PATH_CONTAINS_VARIABLES =
    /(TP\.|APP\.|\$)([a-zA-Z0-9]+|\*|#)/;

TP.regex.ACP_VARIABLE_STATEMENT =
    /(TP\.|APP\.|\$)(\w+|\*|#)/;

TP.regex.ACP_VARIABLE_FUNCTION_STATEMENT =
    /((TP\.|APP\.|\$)(\w+|\*|#))(\.\w+\()/g;

TP.regex.IS_ACP_VARIABLE = /^(TP|APP|\$(\w+|\*|#)+)/;

//  Finds ACP expressions that have an 'id' construct along with '$SOURCE' for
//  tag processing.
TP.regex.ACP_SOURCE_ID_STATEMENT = /\{\{.*(\$SOURCE.+@id).*\}\}/;

TP.regex.BIND_ATTR_SPLITTER = new RegExp('\\s*(' + TP.XML_NAME + ')' +
                                            '\\s*:\\s*' +
                                            '(' + '[^;]+' + ');?',
                                        'g'); //    needs reset

TP.regex.BINDING_STATEMENT_DETECT = /\[\[(.+?)\]\]/;
TP.regex.BINDING_STATEMENT_EXTRACT = /\[\[(.+?)\]\]/g; //   needs reset
TP.regex.BINDING_ATTR_VALUE_DETECT = /\s*\{\s*\w+\s*:/;

TP.regex.TSH_QUOTECHAR = /['"]/;

TP.regex.TSH_VARIABLE = /^\$\{?([A-Z_$]{1}[A-Z0-9_$]*)\}?$/;
TP.regex.TSH_VARIABLE = /^\$\{?([A-Z_$]{1}[A-Z0-9_$]*)\}?$/;
TP.regex.TSH_VARIABLE_DEREF = /^@\$?\{?([A-Z_$]{1}[A-Z0-9_$]*)\}?$/;

TP.regex.TSH_VARSUB = /\$\{?([A-Z_$]{1}[A-Z0-9_$]*)\}?/;
//  A global version of TP.regex.TSH_VARSUB
TP.regex.TSH_VARSUB_EXTRACT = /\$\{?([A-Z_$]{1}[A-Z0-9_$]*)\}?/g;

//  Only matches the 'extended variable' format
TP.regex.TSH_VARSUB_EXTENDED = /\$\{([A-Z_$]{1}[A-Z0-9_$]*)\}/g;

//  pseudo-acp plus format string means potentially transformable string
TP.regex.TRANSFORMABLE = /[$#%@]\{|`.+`/;

TP.regex.CAMEL_CASE = /([-\s_]([a-z]))/g;       //  needs reset
TP.regex.TITLE_CASE = /([-\s_]([a-z]))/g;       //  needs reset
TP.regex.WORD_BOUNDARIES = /[-\s_]/g;           //  needs reset

TP.regex.WHITESPACE = /\s+/;

TP.regex.ONLY_WHITESPACE = /^\s+$/;
TP.regex.ONLY_WORD = /^\w+$/;
TP.regex.ONLY_NUM = /^\d+$/;
TP.regex.ONLY_PERIOD = /^\.$/;
TP.regex.ONLY_DOLLAR = /^\$$/;

TP.regex.ONLY_NEWLINE_WHITESPACE = /^[\r\n]+$/;
TP.regex.ONLY_NON_NEWLINE_WHITESPACE = /^[^\S\n]+$/;

TP.regex.PUNCTUATION = /[\]\[\/ .,;:@!#%&*_'"?<>{}+=|)(^~`$-]+/;

TP.regex.ANY_NUMBER = /^-?\d*\.{0,1}\d+$/i;
TP.regex.PERCENTAGE = /^-?\d+%$/i;

TP.regex.DOUBLE_QUOTED_NUMBER_OR_BOOLEAN =
                        /"(-?\d*\.?\d+|true|false)"/g;  //  needs reset

//  needs reset
TP.regex.NON_UTF8_CHARS =
/[\xC2-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF4][\x80-\xBF]{3}/g;

//  call stack formatting
TP.regex.CALL_STACK_FORMAT = /(.*) \((.*)\)/;
TP.regex.CALL_STACK_ID = /Function\$[0-9a-z]*($|([\s]))/g;  //  needs reset

TP.regex.CALL_STACK_ENTRY_SPLITTER = /(.+)@(.+):(\d+):(\d+)/;

TP.regex.HAS_STDIN = /\$_/;
TP.regex.ONLY_STDIN = /^\$_$/;

//  ---
//  testing
//  ---

TP.regex.TEST_FUNCTION = /test[a-zA-Z0-9$_'"]+/;

//  ---
//  markup
//  ---

/* eslint-disable no-control-regex */

TP.regex.UTF8_BUT_NOT_XML_CHARS =
    /[^\x09\x0A\x0D\x20-\xFF\x85\xA0-\uD7FF\uE000-\uFDCF\uFDE0-\uFFFD]/gm;  // need reset

TP.regex.XML_IDREF = new RegExp(
                    '^' + TP.XML_NCNAME + '(' + TP.XML_NCNAMECHAR + ')*' + '$');

TP.regex.XML_NAMEREF = new RegExp('^' + TP.XML_NAME + '$');

TP.regex.IS_ELEM_MARKUP = new RegExp(
        '^(\\s)*<' + TP.XML_NAME + '>(\\s)*' + '([\\s\\S]*)' + '>(\\s)*$');

TP.regex.STARTS_WITH_ELEM_MARKUP = new RegExp(
                        '^' + TP.CONTAINS_ELEM_MARKUP_DEF);
TP.regex.CONTAINS_ELEM_MARKUP = new RegExp(TP.CONTAINS_ELEM_MARKUP_DEF);

TP.regex.HAS_ELEMENT = /<\/|\/>/;
TP.regex.HAS_PI = /<\?|\?>/;
TP.regex.HAS_ENTITY = /&(?:#([0-9]+)|#x([0-9a-fA-F]+)|([0-9a-zA-Z]+));/;

//  needs reset
TP.regex.INVALID_ID_CHARS = /[. !"#$%&'()*+,/:;<=>?@[\]^`{|}~]+/g;

TP.regex.EMPTY_TAG_END = /\/>/;

//  We don't start off with '^' for this RegEx, since there could be PIs,
//  DOCTYPEs, etc. in front of the 'first element markup'.
TP.regex.OPENING_TAG = new RegExp(
    '<(' + TP.XML_NAME + ')([^<>"\']+|' + TP.XML_ATTRVAL + ')*>');
TP.regex.CLOSED_TAG = /(<([^>]*?)\/>)$/;
TP.regex.CLOSING_TAG = /(<\/([^>]*?)>)$/;

TP.regex.OPENING_TAG_NAME = new RegExp('<((' + TP.XML_NAMECHAR + ')+)');

//  Note the tail of this RegExp uses the 'including newlines' expression.
TP.regex.ALL_ELEM_MARKUP = new RegExp(
    '<(' + TP.XML_NAME + ')([^<>"\']+|' + TP.XML_ATTRVAL + ')*>' +
    '([\\s\\S]*)$');

//  A RegExp that matches tags that are empty in XHTML 1.0 (with IE-specific
//  additions - bgsound, embed, wbr).
/* eslint-disable max-len */
TP.regex.XHTML_10_EMPTY_ELEMENTS = /^(area|base|basefont|bgsound|br|col|embed|hr|img|input|isindex|link|meta|param|wbr)$/;
/* eslint-enable max-len */

/* eslint-disable max-len */
TP.regex.XHTML_10_EMPTY_ELEMENTS_REPLACE = /<(area|base|basefont|bgsound|br|col|embed|hr|img|input|isindex|link|meta|param|wbr)>/g;
/* eslint-enable max-len */

//  Same as above, except it contains markup brackets for stripping purposes.
/* eslint-disable max-len */
TP.regex.XHTML_10_EMPTY_ELEMENTS_STRIP = /<\/(area|base|basefont|bgsound|br|col|embed|hr|img|input|isindex|link|meta|param|wbr)>/g; //  needs reset
/* eslint-enable max-len */

//  A RegExp that matches XML comments.

//  The content of the comment can be found in group 2.
TP.regex.XML_COMMENT = new RegExp(TP.XML_COMMENT_DEF, 'g'); //  needs reset

//  A RegExp that matches an XML comment that must be the whole content
TP.regex.XML_COMMENT_WHOLE = new RegExp('^<!--(.+?)-->$');

//  A RegExp that matches XML CDATA sections.

TP.regex.XML_CDATA = new RegExp(TP.XML_CDATA_DEF, 'g'); //  needs reset

//  A RegExp that matches an XML CDATA section that must be the whole content
TP.regex.XML_CDATA_WHOLE = new RegExp('^<!\\[CDATA\\[(.+?)\\]\\]>$');

//  A RegExp that matches XML processing instructions

//  The content of the PI can be found in group 1 - including the trailing '?>'
//  which may need to be sliced off

TP.regex.XML_PI = new RegExp(TP.XML_PI_DEF, 'g'); //    needs reset

//  A RegExp that matches an XML processing instrction that must be the whole
//  content
TP.regex.XML_PI_WHOLE = new RegExp('^<\\?(.+?)\\?>$');

//  A RegExp that matches any kind of markup
TP.regex.XML_ALL_MARKUP =
    new RegExp('(' +
                TP.CONTAINS_ELEM_MARKUP_DEF + '|' +
                TP.XML_COMMENT_DEF + '|' +
                TP.XML_CDATA_DEF + '|' +
                TP.XML_PI_DEF + ')');

//  A RegExp that matches the XML declaration.
TP.regex.XML_DECL = /<\?xml\s+.+\?>/;

//  A RegExp that matches XML empty tags.
TP.regex.XML_EMPTY_TAG = /<([^\s<]*)([^<]*?)\/>/g;  //  needs reset

//  A RegExp for matching markup entities.
TP.regex.ML_ENTITY = /&([a-zA-Z#0-9]+);/;

//  A RegExp that matches "standalone" (outside of element) XML attribute
//  expressions. The name is the 1st group and the value is the 4th group. Note
//  that the value *contains the quotes* (for the most robust matching).
TP.regex.XML_ATTR = new RegExp('^\\s*(' + TP.XML_NAME + ')' +
                                '=' +
                                '(' + TP.XML_ATTRVAL + ')');

//  A RegExp that matches XML attribute expressions that contain *only* the
//  word 'null' as a value
TP.regex.XML_ATTR_NULL = /\s*([\w:]+)=['"]null['"]/g;   //  needs reset

//  A RegExp that matches XML attribute expressions that contain the word
//  'null' as a value (NB: this is grouped in a particular way for easy
//  replacement - '$1"$2$3"')
TP.regex.XML_ATTR_CONTAINING_NULL =
    /(\s*[\w:]+=)['"]([^'"]*?)null([^'"]*?)['"]/g;  //  needs reset

TP.regex.CONTAINS_ONLY_ATTR_START =
    new RegExp('\\w*\\s*(' + TP.XML_NAME + ')=[\'"][^>]*$');
TP.regex.CONTAINS_ONLY_ELEM_START =
    new RegExp('<(' + TP.XML_NAMESTART + ')([^<>"\']+)$');

//  A RegExp that matches various HTML tags.
TP.regex.HTML_HTML_ELEM =
        /<html((.*)?([^\/>]*)?)(\/|>([^<]*)?<\/html)>/gi;   //  needs reset
TP.regex.HTML_HEAD_ELEM =
        /<head((.*)?([^\/>]*)?)(\/|>([^<]*)?<\/head)>/gi;   //  needs reset
TP.regex.HTML_BODY_ELEM =
        /<body((.*)?([^\/>]*)?)(\/|>([^<]*)?<\/body)>/gi;   //  needs reset

TP.regex.HTML_SCRIPT_ELEM =
        /<script((.*)?([^\/>]*)?)(\/|>([^<]*)?<\/script)>/gi;   //  needs reset

/* eslint-disable max-len */
//  needs reset
TP.regex.HTML_CSS_LINK_ELEM =
/<link((.*)?( rel="stylesheet"| type="text\/css")+([^\/>]*)?)(\/|>([^<]*)?<\/link)>/gi;
/* eslint-enable max-len */

//  needs reset
TP.regex.HTML_CSS_STYLE_ELEM =
/<style((.*)?( type="text\/css")+([^\/>]*)?)(\/|>([^<]*)?<\/style)>/gi;

TP.regex.HTML_IMG_ELEM =
        /<img((.*)?([^\/>]*)?)(\/|>([^<]*)?<\/img)>/gi; //  needs reset


//  A RegExp that matches non-prefixed namespace attribute entries.
TP.regex.NON_PREFIXED_NS_ATTR =
        /\s+xmlns=(['"])([\x00-\x7F]*?)\1/g;    //  needs reset

//  A RegExp that matches prefixed namespace attribute entries.
TP.regex.PREFIXED_NS_ATTR =
        /\s+xmlns:\w+=(['"])([\x00-\x7F]*?)\1/g;    //  needs reset

//  A RegExp that matches all element prefixes
TP.regex.ALL_ELEM_PREFIXES =
    new RegExp('<' +
                '(' +
                '(?:' + TP.XML_NCNAME + ')' +
                '(?:' + TP.XML_NCNAMECHAR + ')*' +
                ')' +
                ':',
                'g');   //  global, needs reset

//  A RegExp that matches all attribute prefixes
TP.regex.ALL_ATTR_PREFIXES =
    new RegExp('(' +
                '(?:' + TP.XML_NCNAME + ')' +
                '(?:' + TP.XML_NCNAMECHAR + ')*' +
                ')' +
                ':' +
                '(?:' + TP.XML_NCNAME + ')' +
                '(?:' + TP.XML_NCNAMECHAR + ')*' +
                '=' +
                'g');   //  global, needs reset

/* eslint-enable no-control-regex */

//  RegExps that match content in between quotes that must be at the beginning
//  or end.
TP.regex.QUOTED_CONTENT = /^(['"])(.*)\1$/;
TP.regex.ESCAPED_QUOTED_CONTENT = /^\\(['"])(.*)\1$/;

//  RegExps that match content in between quotes that can be anywhere.
TP.regex.CONTENT_WITH_QUOTES = /(['"])(.*)\1/;
TP.regex.CONTENT_WITH_ESCAPED_QUOTES = /\\(['"])(.*)\1/;

//  ---
//  mime
//  ---

TP.regex.MIME_TYPE = /(\w+)\/(\w+)/gi;                  //  needs reset

//  ---
//  names
//  ---

TP.regex.ANONYMOUS_NAME = /^\$\d/;
TP.regex.IS_NAMEXP = /\*| /;

//  ---
//  number support
//  ---

TP.MAX_DOUBLE = 9007199254740991;

//  The maximum timeout as supported by Mozilla. Roughly equivalent to 596.5
//  hours or 24 days.
TP.MAX_TIMEOUT = 2147483647;

//  ---
//  object support
//  ---

TP.regex.GETTER = /^get([A-Z])/;
TP.regex.SETTER = /^set([A-Z])/;

//  ---
//  optimization support
//  ---

TP.regex.PERFORM_INSTRUMENT = /at[End|Start]/;
TP.regex.CACHE_FILE = /_CACHE_/;
TP.regex.MULTI_VALUED = / /;

//  ---
//  regex support
//  ---

//  RegExps that will be used to escape and unescape Strings for use as
//  RegExps :)
TP.regex.REGEX_DETECT_META_CHARS =
        /([-[\]{}(\/)*+?.\\^$|,#\s]{1})/g;   //  needs reset

//  Same as above, except it won't detect escaped metacharacters.
TP.regex.REGEX_DETECT_UNESCAPED_META_CHARS =
        /(^|[^\\])([-[\]{}(\/)*+?.\\^$|,#\s]{1})/g;    //  needs reset

TP.regex.REGEX_LITERAL_STRING = /^\/(.+)\/[gimy]*$/;

//  ---
//  tibet uris
//  ---

TP.regex.TIBET_URL = /^[tibet:|~]/;
//  node@domain:port, resource, canvas, path, and pointer
TP.regex.TIBET_URL_SPLITTER =
                /tibet:([^\/]*?)\/([^\/]*?)\/([^\/#]*)\/?(([^#]*)(.*))/;
TP.regex.URL_SPLITTER =
                /(?:.*):([^\/]*?)\/([^\/]*?)\/([^\/#]*)\/?(([^#]*)(.*))/;

TP.regex.TIBET_URN = /urn:tibet:|urn::/;
TP.regex.TIBET_URN_SPLITTER = /(urn:tibet:|urn::)(.*)/;
TP.regex.TIBET_COMPACT_URN = /urn::/;
TP.TIBET_URN_PREFIX = 'urn:tibet:';

TP.regex.TPOINTER = /([^\(]*)\(([^\)]*)\)/;
TP.regex.TIBET_VIRTUAL_URI_PREFIX = /^~|^tibet:\/\/\/~/;
TP.regex.VIRTUAL_URI_PREFIX = /^~/;

//  ---
//  TSH support
//  ---

TP.TSH_OPERATOR_CHARS = '`#~!@%^&*=\\;:,./?';

TP.TSH_NO_VALUE = '__TSH__NO_VALUE__TSH__';

TP.regex.TSH_NO_VALUE_MATCHER = /__TSH__NO_VALUE__TSH__/;

TP.regex.TSH_TEMPLATE = /\$\{/;
TP.regex.TSH_SUBSHELL = /\.\(\((.*)?\.\)\)/;
TP.regex.TSH_SUBGROUP = /\.\{\{(.*)?\.\}\}/;
TP.regex.TSH_HEREDOC = /\.<</;

//  TSH_DEREF_SUGAR is a JS_IDENTIFIER preceded by @ (but could have optional
//  leading '${' and trailing '}')
TP.regex.TSH_DEREF_SUGAR = /^@\$?\{?[a-zA-Z_$]{1}[a-zA-Z0-9_$]*\}?$/;

//  ---
//  uri schemes
//  ---

TP.regex.SCHEME = /^([A-Za-z][-.+A-Za-z0-9]*):(.*)/;

TP.regex.CHROMEEXT_SCHEME = /^chrome-extension:\/\//;
TP.regex.FILE_SCHEME = /^file:\/\//;
TP.regex.HTTP_SCHEME = /^http[s]?:\/\//;
TP.regex.JS_SCHEME = /^javascript:/;
TP.regex.MAIL_SCHEME = /^mailto:\/\//;
TP.regex.TIBET_SCHEME = /^tibet:/;

//  ---
//  uri support
//  ---

//  !!!NOTE: This regexp gets rewritten as schemes are added to the system. If
//  this is changed here, it *must* be updated in the scheme addition code.
TP.regex.URI_LIKELY =
    /^~|^\/|^\.\/|^\.\.\/|^urn:|^tibet:|^javascript:|^(?:\w+):(?:.*)\//;

TP.regex.ALL_SCHEMES = /urn:|tibet:|javascript:/;

TP.regex.URI_FRAGMENT = /#\w+/;

/* eslint-disable max-len */
TP.regex.URI_STRICT = /^(?:([^:\/?#]+):)?(?:\/\/((?:(([^:@]*):?([^:@]*))?@)?([^:\/?#]*)(?::(\d*))?))?((((?:[^?#\/]*\/)*)([^?#]*))(?:\?([^#]*))?(?:#(.*))?)/;
/* eslint-enable max-len */

/* eslint-disable max-len */
TP.regex.URI_LOOSE = /^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/)?((?:(([^:@]*):?([^:@]*))?@)?([^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/;
/* eslint-enable max-len */

//  A RegExp that matches the URI queries, where the separator is either a
//  '&' or ';' (for XML compliance)
TP.regex.URI_QUERY = /[&;]?([^&;=]*)=?([^&;]*)/g;   //  needs reset

//  ---
//  window
//  ---

TP.regex.BAD_WINDOW_ID = /[:\/]/;
TP.regex.WINDOW_PREFIX = /^window_[0-9]/;
TP.regex.SCREEN_PREFIX = /^screen_[0-9]/;

//  ---
//  xml catalog
//  ---

TP.regex.URI_REWRITE = /rewriteURI/;
TP.regex.URI_DELEGATE = /delegateURI/;
TP.regex.URI_NEXTCAT = /nextCatalog/;

//  ---
//  xml documents
//  ---

TP.regex.XML_PREFIX = /<\?xml (.*)\?>/;

//  ---
//  xml namespaces
//  ---

//  Moz has namespace resolution issues :)
TP.regex.MOZ_XPATH_ERROR = /regard to namespaces/;

TP.regex.NS_EXTRACTION = /.*?xmlns([:\w]*?)="(.*?)"/g;      //  needs reset
TP.regex.NS_PREFIXES = /<(\w+)*:/g;                         //  needs reset
TP.regex.NS_QUALIFIED = /(.*):(.*)/;

//  A RegExp that will strip the 'XML namespace' (as MSXML already defines
//  it and doesn't like it at all when you try to redefine it).
//  needs reset
TP.regex.XML_XMLNS_STRIP =
    /xmlns:xml=(['"])http:\/\/www.w3.org\/XML\/1998\/namespace(\1)/g;

TP.regex.XMLNS_STRIP = /\s+xmlns([:\w]*?)=['"](.*?)['"]/g;  //  needs reset
TP.regex.XMLNS_ATTR = /xmlns[:=]/;

//  ---
//  path types
//  ---

TP.TIBET_PATH_TYPE = 0;
TP.JSON_PATH_TYPE = 1;
TP.CSS_PATH_TYPE = 2;
TP.XPATH_PATH_TYPE = 3;
TP.BARENAME_PATH_TYPE = 4;
TP.XPOINTER_PATH_TYPE = 5;
TP.ELEMENT_PATH_TYPE = 6;
TP.XTENSION_POINTER_PATH_TYPE = 7;
TP.COMPOSITE_PATH_TYPE = 8;

TP.CHANGE_PATHS = 'paths';
TP.CHANGE_URIS = 'uris';

//  ---
//  path detection and values
//  ---

//  One or more access paths separated by '.(' and ').'
TP.regex.COMPOSITE_PATH = /(^|\.)\((.+?)\)(\.|$)/;

//  one or more of any characters with optional preceding or following
//  whitespace
TP.regex.PATH_EXPR = /(^|\s+)(.+?)($|\s+)/g; // needs reset

//  any of these symbols -
//  '|', '@', '#', ':', '/', '&', '=', '<', '>', '.', '[', '('
TP.regex.NON_SIMPLE_PATH = /[|@#:\/&=><\.\[\(](?!\object)/;

//  ---
//  JSON path
//  ---

TP.regex.JSON_POINTER = /jpath\((.*)\)/;

//  Not strictly true, but virtually every JSONPath example seen in the wild
//  begins with '$.' and it's a great way to disambiguate. Note here that we
//  require the '.' as well, to disambiguate between JSONPath and '$FOO'.
TP.regex.JSON_PATH = /^\$\.+/;

//  ---
//  TIBET path
//  ---

TP.regex.TIBET_POINTER = /tibet\((.*)\)/;

//  Forms of TIBETan access paths can either
//      - be words separated by periods ('.'),
//      - be brackets ('[]') with either string or numeric indexes
//      - be brackets with numeric ranges (or just a colon ':' signifying the
//          whole range).
//      - be a period ('.') or a word character followed by brackets containing
//          a number.
TP.regex.TIBET_PATH =
    /^(\$|_)*?\w+[\.]{1}(\$|_)*?\w+|([^\/])*\[\w+(,\w+)+\]([^\/])*|([^\/])*\[-?\d*:-?\d*(:-?\d*)?\]([^\/])*|(^|\.|\w)\[-?\d+\]/;

TP.regex.TIBET_PATH_CHAR = /[\.:,]+/;
TP.regex.TIBET_PATH_TEMPLATE = /(^|\s+)(\w[\w\.:,]*)(\s+|$)/g; //  needs reset

TP.regex.SIMPLE_NUMERIC_PATH = /^\[(\d+)\]$/;

TP.regex.ENDS_WITH_NUMERIC_PATH = /\[(\d+)\]$/;

//  ---
//  XML path
//  ---

//  TIBET extensions that can be used in *node* paths
TP.regex.XTENSION_POINTER = /css\((.*)\)/;

//  Detect @[anything] as whole
TP.regex.ATTRIBUTE = /^@(\w+:)?\w+$/;

//  Detect @[anything] at end
TP.regex.ATTRIBUTE_ENDS = /@(\w+:)?\w+$/;

//  Detect starts with @*
TP.regex.ATTRIBUTE_ALL = /^@\*/;

//  Detect text() at end
TP.regex.TEXT_NODE_ENDS = /\/text\(\)$/;

//  XPointer matchers

TP.regex.ANY_POINTER = /(\w+)\((.*)\)$/;

TP.regex.CSS_POINTER = /css\((.*)\)/;

//  Detect starts with #, followed by word characters. Also, TIBET's extension
//  to barenames (a trailing '@expr') allows access to Attributes.
TP.regex.BARENAME = new RegExp(
                    '^#(' +
                    '(' + TP.XML_NCNAME + ')(' + TP.XML_NCNAMECHAR + ')*' +
                    '(@(' + TP.XML_NCNAME + ')(' + TP.XML_NCNAMECHAR + '|:)*)*' +
                    ')$');

TP.regex.DOCUMENT_ID = /^#document$/;
TP.regex.ELEMENT_ID = /(.*)#(.*)/;
TP.regex.BOOLEAN_ID = /^true$|^false$/;

TP.regex.ID_FUNCTION = /id\((.+)\)/;
TP.regex.ID_HAS_NS = /:/g;                              //  needs reset
TP.regex.IDREFS = /(.*) (.*)/;
TP.regex.ID_POINTER = /(xpointer|xpath1)\(id\(["'](.+)["']\)\)/;

TP.regex.XPOINTER = /(xpointer|xpath1|element)\((.*)\)/;

TP.regex.ELEMENT_PATH = /[#@\/\\.\\[\\(]/;
TP.regex.ELEMENT_POINTER = /element\((.*)\)/;

TP.regex.XPATH_HAS_ID = /id\((.+)\)/;

TP.regex.XPATH_HAS_SCALAR_CONVERSION = /^(?:string|number|boolean)\((.+)\)$/;

//  /, @, . followed by . or /, x( where x isn't . (all from start of line) OR
//  a 'full axis name' followed by a double colon ('::')
/* eslint-disable max-len */
TP.regex.XPATH_PATH = /^(\/|@|\.[\/\.]|[^\\.]\((.*)\))|(ancestor|ancestor-or-self|attribute|child|descendant|descendant-or-self|following|following-sibling|namespace|parent|preceding|preceding-sibling|self)::/;
/* eslint-enable max-len */

TP.regex.XPATH_POINTER = /(xpointer|xpath1)\((.*)\)/;

TP.regex.XPATH_DEFAULTNS = new RegExp(
        '\\$def:((' + TP.XML_NAMECHAR + ')+)', 'g');    //  needs reset

//  ---
//  path parts splitters and strippers
//  ---

TP.regex.CSS_PATH_SPLITTER = /( +|\s*[+>~](?:!=)\s*|,)/;
TP.regex.CSS_PATH_STRIPPER = /^(\s*| +|\s*[+>~]\s*|,)$/;

TP.regex.JSON_PATH_SPLITTER = /(\.\.|\.|\w+)/;
TP.regex.JSON_PATH_STRIPPER = /^(\s*|\.)$/;

TP.regex.XPATH_PATH_SPLITTER = /(\/\/|\/|@?[A-Za-z0-9_:.-]+\*?|\||\*\w+)/;
TP.regex.XPATH_PATH_STRIPPER = /^(\s*|\/|\|)$/;

//  ------------------------------------------------------------------------
//  MISC VARIABLES
//  ------------------------------------------------------------------------

TP[TP.TNAME] = 'Object';
TP.sys[TP.TNAME] = 'Object';

//  a tmp for holding the 'real' i.e. non-spoofed browser for patching
TP.sys.$$realBrowser = null;

TP.sys.$LICENSE = TP.NULL_OID;

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/version.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */

(function() {
    'use strict';

    var release;

    release = TP && TP.sys && TP.sys.release ? TP.sys.release :
        (data) => {
            module.exports = data;
        };

    release({
        //  new release
        semver: '5.3.5+gebd2e29a4b.19.1620134646103',
        major: '5',
        minor: '3',
        patch: '5',
        suffix: '',
        increment: '0',
        time: '1620134646103',
        //  prior semver
        describe: '5.3.4-19-gebd2e29a4b',
        ptag: '5.3.4',
        commits: '19',
        phash: 'ebd2e29a4b'
    },
    'lib');

}());
TP.boot.$$srcPath = '';

        
            if (TP.sys.cfg('boot.context') === 'electron' &&
                TP.sys.inExtension() !== true) {
                    TP.registerExternalObject(
                        'electron_lib_utils', window.preload_lib_utils);
                    TP.registerExternalObject(
                        'electron_app_utils', window.preload_app_utils);
            };
        
    
TP.boot.$$srcPath = '~lib_deps/systemjs-tpi.min.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
/*
* SystemJS 6.9.0
*/
!function(){function e(e,t){return(t||"")+" (SystemJS Error#"+e+" https://git.io/JvFET#"+e+")"}function t(e,t){if(-1!==e.indexOf("\\")&&(e=e.replace(/\\/g,"/")),"/"===e[0]&&"/"===e[1])return t.slice(0,t.indexOf(":")+1)+e;if("."===e[0]&&("/"===e[1]||"."===e[1]&&("/"===e[2]||2===e.length&&(e+="/"))||1===e.length&&(e+="/"))||"/"===e[0]){var n,r=t.slice(0,t.indexOf(":")+1);if(n="/"===t[r.length+1]?"file:"!==r?(n=t.slice(r.length+2)).slice(n.indexOf("/")+1):t.slice(8):t.slice(r.length+("/"===t[r.length])),"/"===e[0])return t.slice(0,t.length-n.length-1)+e;for(var i=n.slice(0,n.lastIndexOf("/")+1)+e,o=[],s=-1,u=0;i.length>u;u++)-1!==s?"/"===i[u]&&(o.push(i.slice(s,u+1)),s=-1):"."===i[u]?"."!==i[u+1]||"/"!==i[u+2]&&u+2!==i.length?"/"===i[u+1]||u+1===i.length?u+=1:s=u:(o.pop(),u+=2):s=u;return-1!==s&&o.push(i.slice(s)),t.slice(0,t.length-n.length)+o.join("")}}function n(e,n){return t(e,n)||(-1!==e.indexOf(":")?e:t("./"+e,n))}function r(e,n,r,i,o){for(var c in e){var a=t(c,r)||c,f=e[c];if("string"==typeof f){var l=u(i,t(f,r)||f,o);l?n[a]=l:s("W1",c,f,"bare specifier did not resolve")}}}function i(e,t){if(t[e])return e;var n=e.length;do{var r=e.slice(0,n+1);if(r in t)return r}while(-1!==(n=e.lastIndexOf("/",n-1)))}function o(e,t){var n=i(e,t);if(n){var r=t[n];if(null===r)return;if(n.length>=e.length||"/"===r[r.length-1])return r+e.slice(n.length);s("W2",n,r,"should have a trailing '/'")}}function s(t,n,r,i){console.warn(e(t,"Package target "+i+", resolving target '"+r+"' for "+n))}function u(e,t,n){for(var r=e.scopes,s=n&&i(n,r);s;){var u=o(t,r[s]);if(u)return u;s=i(s.slice(0,s.lastIndexOf("/")),r)}return o(t,e.imports)||-1!==t.indexOf(":")&&t}function c(){this[E]={}}function a(e){return e.id}function f(e,t,n,r){if(e.onload(n,t.id,t.d&&t.d.map(a),!!r),n)throw n}function l(t,n,r){var i=t[E][n];if(i)return i;var o=[],s=Object.create(null);b&&Object.defineProperty(s,b,{value:"Module"});var u=Promise.resolve().then((function(){return t.instantiate(n,r)})).then((function(r){if(!r)throw Error(e(2,"Module "+n+" did not instantiate"));var u=r[1]((function(e,t){i.h=!0;var n=!1;if("string"==typeof e)e in s&&s[e]===t||(s[e]=t,n=!0);else{for(var r in e)t=e[r],r in s&&s[r]===t||(s[r]=t,n=!0);e.__esModule&&(s.__esModule=e.__esModule)}if(n)for(var u=0;o.length>u;u++){var c=o[u];c&&c(s)}return t}),2===r[1].length?{import:function(e){return t.import(e,n)},meta:t.createContext(n)}:void 0);return i.e=u.execute||function(){},[r[0],u.setters||[]]}),(function(e){throw i.e=null,i.er=e,f(t,i,e,!0),e})),c=u.then((function(e){return Promise.all(e[0].map((function(r,i){var o=e[1][i];return Promise.resolve(t.resolve(r,n)).then((function(e){var r=l(t,e,n);return Promise.resolve(r.I).then((function(){return o&&(r.i.push(o),!r.h&&r.I||o(r.n)),r}))}))}))).then((function(e){i.d=e}))}));return i=t[E][n]={id:n,i:o,n:s,I:u,L:c,h:!1,d:void 0,e:void 0,er:void 0,E:void 0,C:void 0,p:void 0}}function d(){[].forEach.call(document.querySelectorAll("script"),(function(t){if(!t.sp)if("systemjs-module"===t.type){if(t.sp=!0,!t.src)return;System.import("import:"===t.src.slice(0,7)?t.src.slice(7):n(t.src,h)).catch((function(e){if(e.message.indexOf("https://git.io/JvFET#3")>-1){var n=document.createEvent("Event");n.initEvent("error",!1,!1),t.dispatchEvent(n)}return Promise.reject(e)}))}else if("systemjs-importmap"===t.type){t.sp=!0;var i=t.src?fetch(t.src,{integrity:t.integrity}).then((function(e){if(!e.ok)throw Error("Invalid status code: "+e.status);return e.text()})).catch((function(n){return n.message=e("W4","Error fetching systemjs-import map "+t.src)+"\n"+n.message,console.warn(n),"function"==typeof t.onerror&&t.onerror(),"{}"})):t.innerHTML;M=M.then((function(){return i})).then((function(i){!function(t,i,o){var s={};try{s=JSON.parse(i)}catch(u){console.warn(Error(e("W5","systemjs-importmap contains invalid JSON")+"\n\n"+i+"\n"))}!function(e,t,i){var o;for(o in e.imports&&r(e.imports,i.imports,t,i,null),e.scopes||{}){var s=n(o,t);r(e.scopes[o],i.scopes[s]||(i.scopes[s]={}),t,i,s)}for(o in e.depcache||{})i.depcache[n(o,t)]=e.depcache[o];for(o in e.integrity||{})i.integrity[n(o,t)]=e.integrity[o]}(s,o,t)}(L,i,t.src||h)}))}}))}var h,v="undefined"!=typeof Symbol,p="undefined"!=typeof self,m="undefined"!=typeof document,g=p?self:global;if(m){var y=document.querySelector("base[href]");y&&(h=y.href)}if(!h&&"undefined"!=typeof location){var w=(h=location.href.split("#")[0].split("?")[0]).lastIndexOf("/");-1!==w&&(h=h.slice(0,w+1))}var S,b=v&&Symbol.toStringTag,E=v?Symbol():"@",O=c.prototype;O.import=function(e,t){var n=this;return Promise.resolve(n.prepareImport()).then((function(){return n.resolve(e,t)})).then((function(e){var t=l(n,e);return t.C||function(e,t){return t.C=function e(t,n,r,i){if(!i[n.id])return i[n.id]=!0,Promise.resolve(n.L).then((function(){return n.p&&null!==n.p.e||(n.p=r),Promise.all(n.d.map((function(n){return e(t,n,r,i)})))})).catch((function(e){if(n.er)throw e;throw n.e=null,f(t,n,e,!1),e}))}(e,t,t,{}).then((function(){return function e(t,n,r){function i(){try{var e=n.e.call(x);if(e)return e=e.then((function(){n.C=n.n,n.E=null,f(t,n,null,!0)}),(function(e){throw n.er=e,n.E=null,f(t,n,e,!0),e})),n.E=e;n.C=n.n,n.L=n.I=void 0}catch(r){throw n.er=r,r}finally{n.e=null,f(t,n,n.er,!0)}}if(!r[n.id]){if(r[n.id]=!0,!n.e){if(n.er)throw n.er;return n.E?n.E:void 0}var o;return n.d.forEach((function(i){try{var s=e(t,i,r);s&&(o=o||[]).push(s)}catch(u){throw n.e=null,n.er=u,f(t,n,u,!1),u}})),o?Promise.all(o).then(i):i()}}(e,t,{})})).then((function(){return t.n}))}(n,t)}))},O.createContext=function(e){var t=this;return{url:e,resolve:function(n,r){return Promise.resolve(t.resolve(n,r||e))}}},O.onload=function(){},O.register=function(e,t){S=[e,t]},O.getRegister=function(){var e=S;return S=void 0,e};var x=Object.freeze(Object.create(null));g.System=new c;var j,P,M=Promise.resolve(),L={imports:{},scopes:{},depcache:{},integrity:{}},C=m;if(O.prepareImport=function(e){return(C||e)&&(d(),C=!1),M},m&&(d(),window.addEventListener("DOMContentLoaded",d)),m){window.addEventListener("error",(function(e){I=e.filename,W=e.error}));var R=location.origin}O.createScript=function(e){var t=document.createElement("script");t.async=!0,e.indexOf(R+"/")&&(t.crossOrigin="anonymous");var n=L.integrity[e];return n&&(t.integrity=n),t.src=e,t};var I,W,T={},A=O.register;O.register=function(e,t){if(m&&"loading"===document.readyState&&"string"!=typeof e){var n=document.querySelectorAll("script[src]"),r=n[n.length-1];if(r){j=e;var i=this;P=setTimeout((function(){T[r.src]=[e,t],i.import(r.src)}))}}else j=void 0;return A.call(this,e,t)},O.instantiate=function(t,n){var r=T[t];if(r)return delete T[t],r;var i=this;return new Promise((function(r,o){var s=O.createScript(t);s.addEventListener("error",(function(){o(Error(e(3,"Error loading "+t+(n?" from "+n:""))))})),s.addEventListener("load",(function(){if(document.head.removeChild(s),I===t)o(W);else{var e=i.getRegister();e&&e[0]===j&&clearTimeout(P),r(e)}})),document.head.appendChild(s)}))},O.shouldFetch=function(){return!1},"undefined"!=typeof fetch&&(O.fetch=fetch);var J=O.instantiate,N=/^(text|application)\/(x-)?javascript(;|$)/;O.instantiate=function(t,n){var r=this;return this.shouldFetch(t)?this.fetch(t,{credentials:"same-origin",integrity:L.integrity[t]}).then((function(i){if(!i.ok)throw Error(e(7,i.status+" "+i.statusText+", loading "+t+(n?" from "+n:"")));var o=i.headers.get("content-type");if(!o||!N.test(o))throw Error(e(4,'Unknown Content-Type "'+o+'", loading '+t+(n?" from "+n:"")));return i.text().then((function(e){return 0>e.indexOf("//# sourceURL=")&&(e+="\n//# sourceURL="+t),(0,eval)(e),r.getRegister()}))})):J.apply(this,arguments)},O.resolve=function(n,r){return u(L,t(n,r=r||h)||n,r)||function(t,n){throw Error(e(8,"Unable to resolve bare specifier '"+t+(n?"' from "+n:"'")))}(n,r)};var _=O.instantiate;O.instantiate=function(e,t){var n=L.depcache[e];if(n)for(var r=0;n.length>r;r++)l(this,this.resolve(n[r],e),e);return _.call(this,e,t)},p&&"function"==typeof importScripts&&(O.instantiate=function(e){var t=this;return Promise.resolve().then((function(){return importScripts(e),t.getRegister()}))}),function(e){function t(t){return!e.hasOwnProperty(t)||!isNaN(t)&&e.length>t||a&&e[t]&&"undefined"!=typeof window&&e[t].parent===window}var n,r,i,o=e.System.constructor.prototype,s=o.import;o.import=function(o,u){return function(){for(var o in n=r=void 0,e)t(o)||(n?r||(r=o):n=o,i=o)}(),s.call(this,o,u)};var u=[[],function(){return{}}],c=o.getRegister;o.getRegister=function(){var o=c.call(this);if(o)return o;var s,a=function(o){var s,u,c=0;for(var a in e)if(!t(a)){if(0===c&&a!==n||1===c&&a!==r)return a;s?(i=a,u=o&&u||a):s=a===i,c++}return u}(this.firstGlobalProp);if(!a)return u;try{s=e[a]}catch(f){return u}return[[],function(e){return{execute:function(){e(s),e({default:s,__useDefault:!0})}}}]};var a="undefined"!=typeof navigator&&-1!==navigator.userAgent.indexOf("Trident")}("undefined"!=typeof self?self:global),function(e){var t=e.System.constructor.prototype,r=/^[^#?]+\.(css|html|json|wasm)([?#].*)?$/;t.shouldFetch=function(e){return r.test(e)};var i=/^application\/json(;|$)/,o=/^text\/css(;|$)/,s=/^application\/wasm(;|$)/,u=t.fetch;t.fetch=function(t,r){return u(t,r).then((function(r){if(!r.ok)return r;var u=r.headers.get("content-type");return i.test(u)?r.json().then((function(e){return new Response(new Blob(['System.register([],function(e){return{execute:function(){e("default",'+JSON.stringify(e)+")}}})"],{type:"application/javascript"}))})):o.test(u)?r.text().then((function(e){return e=e.replace(/url\(\s*(?:(["'])((?:\\.|[^\n\\"'])+)\1|((?:\\.|[^\s,"'()\\])+))\s*\)/g,(function(e,r,i,o){return"url("+r+n(i||o,t)+r+")"})),new Response(new Blob(["System.register([],function(e){return{execute:function(){var s=new CSSStyleSheet();s.replaceSync("+JSON.stringify(e)+');e("default",s)}}})'],{type:"application/javascript"}))})):s.test(u)?(WebAssembly.compileStreaming?WebAssembly.compileStreaming(r):r.arrayBuffer().then(WebAssembly.compile)).then((function(n){e.System.wasmModules||(e.System.wasmModules=Object.create(null)),e.System.wasmModules[t]=n;var r=[],i=[];return WebAssembly.Module.imports&&WebAssembly.Module.imports(n).forEach((function(e){var t=JSON.stringify(e.module);-1===r.indexOf(t)&&(r.push(t),i.push("function(m){i["+t+"]=m}"))})),new Response(new Blob(["System.register(["+r.join(",")+"],function(e){var i={};return{setters:["+i.join(",")+"],execute:function(){return WebAssembly.instantiate(System.wasmModules["+JSON.stringify(t)+"],i).then(function(m){e(m.exports)})}}})"],{type:"application/javascript"}))})):r}))}}("undefined"!=typeof self?self:global);var k="undefined"!=typeof Symbol&&Symbol.toStringTag;O.get=function(e){var t=this[E][e];if(t&&null===t.e&&!t.E)return t.er?null:t.n},O.set=function(t,n){try{new URL(t)}catch(s){console.warn(Error(e("W3",'"'+t+'" is not a valid URL to set in the module registry')))}var r;k&&"Module"===n[k]?r=n:(r=Object.assign(Object.create(null),n),k&&Object.defineProperty(r,k,{value:"Module"}));var i=Promise.resolve(r),o=this[E][t]||(this[E][t]={id:t,i:[],h:!1,d:[],e:null,er:void 0,E:void 0});return!o.e&&!o.E&&(Object.assign(o,{n:r,I:void 0,L:void 0,C:i}),r)},O.has=function(e){return!!this[E][e]},O.delete=function(e){var t=this[E],n=t[e];if(!n||n.p&&null!==n.p.e||n.E)return!1;var r=n.i;return n.d&&n.d.forEach((function(e){var t=e.i.indexOf(n);-1!==t&&e.i.splice(t,1)})),delete t[e],function(){var n=t[e];if(!n||!r||null!==n.e||n.E)return!1;r.forEach((function(e){n.i.push(e),e(n.n)})),r=null}};var U="undefined"!=typeof Symbol&&Symbol.iterator;O.entries=function(){var e,t,n=this,r=Object.keys(n[E]),i=0,o={next:function(){for(;void 0!==(t=r[i++])&&void 0===(e=n.get(t)););return{done:void 0===t,value:void 0!==t&&[t,e]}}};return o[U]=function(){return this},o}}();
//# sourceMappingURL=system.min.js.map
TP.boot.$$srcPath = '~lib_deps/systemjs-named-register-tpi.min.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
!function(t){function r(t){t.registerRegistry=Object.create(null)}var e=t.System;r(e);var i,n=e.constructor.prototype,s=e.constructor,l=function(){s.call(this),r(this)};l.prototype=n,e.constructor=l;var o=n.register;n.register=function(t,r,e){if("string"!=typeof t)return o.apply(this,arguments);var n=[r,e];return this.registerRegistry[t]=n,i||(i=n,Promise.resolve().then((function(){i=null}))),o.call(this,r,e)};var c=n.resolve;n.resolve=function(t,r){try{return c.call(this,t,r)}catch(e){if(t in this.registerRegistry)return t;throw e}};var a=n.instantiate;n.instantiate=function(t,r){var e=this.registerRegistry[t];return e?(this.registerRegistry[t]=null,e):a.call(this,t,r)};var u=n.getRegister;n.getRegister=function(){var t=u.call(this),r=i||t;return i=null,r}}("undefined"!=typeof self?self:global);//# sourceMappingURL=named-register.min.js.map
TP.boot.$$srcPath = '';

        
            TP.registerExternalObject('System', System);
            TP.extern.System.shouldFetch = function() {
                return false;
            };

            var systemJSPrototype;
            systemJSPrototype = TP.extern.System.constructor.prototype;

            systemJSPrototype.oldInstantiate = systemJSPrototype.instantiate;
            systemJSPrototype.instantiate = function(url, firstParentUrl) {

                if (!TP.regex.TIBET_URN.test(url)) {
                    return TP.extern.System.constructor.prototype.oldInstantiate.call(
                            TP.extern.System,
                            url, firstParentUrl);
                }

                return new Promise(function(resolver, rejector) {
                    var namespaceURN,
                        namespace,
                        moduleText;

                    //  Create a URI representing the namespace from the import URI.
                    namespaceURN = TP.uc(url);

                    //  Try to grab the corresponding namespace object and,
                    //  if it's real, cause it to build an ECMA6 module of
                    //  its content and store that in the Blob URL.
                    namespace = namespaceURN.getContent();
                    if (TP.isNamespace(namespace)) {
                        TP.extern.System.register(url, [], function(_export, _context) {
                            return {
                                execute: function() {
                                    var moduleObj;

                                    moduleText =
                                        namespace.generatePseudoNativeModule(
                                                null, false);
                                    moduleObj = eval(moduleText);

                                    _export(moduleObj);
                                    _export('default', moduleObj);
                                }
                            }
                        });
                    }

                    resolver(TP.extern.System.getRegister());
                });
            };

            systemJSPrototype.resolve = function(id) {
                var newID,
                    index;

                if (TP.regex.TIBET_URN.test(id)) {
                    return id;
                }

                newID = id;

                index = newID.lastIndexOf('.');
                if (index !== -1) {
                    newID = newID.slice(0, index);
                }

                index = newID.lastIndexOf('/');
                if (index !== -1) {
                    newID = newID.slice(index + 1);
                }

                return newID;
            };
        
    
TP.boot.$$srcPath = '~lib_deps/bluebird-tpi.min.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
/* @preserve
 * The MIT License (MIT)
 * 
 * Copyright (c) 2013-2018 Petka Antonov
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 * 
 */
/**
 * bluebird build version 3.7.2
 * Features enabled: core, race, call_get, generators, map, nodeify, promisify, props, reduce, settle, some, using, timers, filter, any, each
*/
!function(t){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=t();else if("function"==typeof define&&define.amd)define([],t);else{var e;"undefined"!=typeof window?e=window:"undefined"!=typeof global?e=global:"undefined"!=typeof self&&(e=self),e.Promise=t()}}(function(){var t,e,n;return function r(t,e,n){function i(s,a){if(!e[s]){if(!t[s]){var c="function"==typeof _dereq_&&_dereq_;if(!a&&c)return c(s,!0);if(o)return o(s,!0);var u=new Error("Cannot find module '"+s+"'");throw u.code="MODULE_NOT_FOUND",u}var l=e[s]={exports:{}};t[s][0].call(l.exports,function(e){var n=t[s][1][e];return i(n?n:e)},l,l.exports,r,t,e,n)}return e[s].exports}for(var o="function"==typeof _dereq_&&_dereq_,s=0;s<n.length;s++)i(n[s]);return i}({1:[function(t,e,n){"use strict";e.exports=function(t){function e(t){var e=new n(t),r=e.promise();return e.setHowMany(1),e.setUnwrap(),e.init(),r}var n=t._SomePromiseArray;t.any=function(t){return e(t)},t.prototype.any=function(){return e(this)}}},{}],2:[function(t,e,n){"use strict";function r(){this._customScheduler=!1,this._isTickUsed=!1,this._lateQueue=new f(16),this._normalQueue=new f(16),this._haveDrainedQueues=!1;var t=this;this.drainQueues=function(){t._drainQueues()},this._schedule=p}function i(t,e,n){this._lateQueue.push(t,e,n),this._queueTick()}function o(t,e,n){this._normalQueue.push(t,e,n),this._queueTick()}function s(t){this._normalQueue._pushOne(t),this._queueTick()}function a(t){for(;t.length()>0;)c(t)}function c(t){var e=t.shift();if("function"!=typeof e)e._settlePromises();else{var n=t.shift(),r=t.shift();e.call(n,r)}}var u;try{throw new Error}catch(l){u=l}var p=t("./schedule"),f=t("./queue");r.prototype.setScheduler=function(t){var e=this._schedule;return this._schedule=t,this._customScheduler=!0,e},r.prototype.hasCustomScheduler=function(){return this._customScheduler},r.prototype.haveItemsQueued=function(){return this._isTickUsed||this._haveDrainedQueues},r.prototype.fatalError=function(t,e){e?(process.stderr.write("Fatal "+(t instanceof Error?t.stack:t)+"\n"),process.exit(2)):this.throwLater(t)},r.prototype.throwLater=function(t,e){if(1===arguments.length&&(e=t,t=function(){throw e}),"undefined"!=typeof setTimeout)setTimeout(function(){t(e)},0);else try{this._schedule(function(){t(e)})}catch(n){throw new Error("No async scheduler available\n\n    See http://goo.gl/MqrFmX\n")}},r.prototype.invokeLater=i,r.prototype.invoke=o,r.prototype.settlePromises=s,r.prototype._drainQueues=function(){a(this._normalQueue),this._reset(),this._haveDrainedQueues=!0,a(this._lateQueue)},r.prototype._queueTick=function(){this._isTickUsed||(this._isTickUsed=!0,this._schedule(this.drainQueues))},r.prototype._reset=function(){this._isTickUsed=!1},e.exports=r,e.exports.firstLineError=u},{"./queue":26,"./schedule":29}],3:[function(t,e,n){"use strict";e.exports=function(t,e,n,r){var i=!1,o=function(t,e){this._reject(e)},s=function(t,e){e.promiseRejectionQueued=!0,e.bindingPromise._then(o,o,null,this,t)},a=function(t,e){0===(50397184&this._bitField)&&this._resolveCallback(e.target)},c=function(t,e){e.promiseRejectionQueued||this._reject(t)};t.prototype.bind=function(o){i||(i=!0,t.prototype._propagateFrom=r.propagateFromFunction(),t.prototype._boundValue=r.boundValueFunction());var u=n(o),l=new t(e);l._propagateFrom(this,1);var p=this._target();if(l._setBoundTo(u),u instanceof t){var f={promiseRejectionQueued:!1,promise:l,target:p,bindingPromise:u};p._then(e,s,void 0,l,f),u._then(a,c,void 0,l,f),l._setOnCancel(u)}else l._resolveCallback(p);return l},t.prototype._setBoundTo=function(t){void 0!==t?(this._bitField=2097152|this._bitField,this._boundTo=t):this._bitField=-2097153&this._bitField},t.prototype._isBound=function(){return 2097152===(2097152&this._bitField)},t.bind=function(e,n){return t.resolve(n).bind(e)}}},{}],4:[function(t,e,n){"use strict";function r(){try{Promise===o&&(Promise=i)}catch(t){}return o}var i;"undefined"!=typeof Promise&&(i=Promise);var o=t("./promise")();o.noConflict=r,e.exports=o},{"./promise":22}],5:[function(t,e,n){"use strict";var r=Object.create;if(r){var i=r(null),o=r(null);i[" size"]=o[" size"]=0}e.exports=function(e){function n(t,n){var r;if(null!=t&&(r=t[n]),"function"!=typeof r){var i="Object "+a.classString(t)+" has no method '"+a.toString(n)+"'";throw new e.TypeError(i)}return r}function r(t){var e=this.pop(),r=n(t,e);return r.apply(t,this)}function i(t){return t[this]}function o(t){var e=+this;return 0>e&&(e=Math.max(0,e+t.length)),t[e]}var s,a=t("./util"),c=a.canEvaluate;a.isIdentifier;e.prototype.call=function(t){var e=[].slice.call(arguments,1);return e.push(t),this._then(r,void 0,void 0,e,void 0)},e.prototype.get=function(t){var e,n="number"==typeof t;if(n)e=o;else if(c){var r=s(t);e=null!==r?r:i}else e=i;return this._then(e,void 0,void 0,t,void 0)}}},{"./util":36}],6:[function(t,e,n){"use strict";e.exports=function(e,n,r,i){var o=t("./util"),s=o.tryCatch,a=o.errorObj,c=e._async;e.prototype["break"]=e.prototype.cancel=function(){if(!i.cancellation())return this._warn("cancellation is disabled");for(var t=this,e=t;t._isCancellable();){if(!t._cancelBy(e)){e._isFollowing()?e._followee().cancel():e._cancelBranched();break}var n=t._cancellationParent;if(null==n||!n._isCancellable()){t._isFollowing()?t._followee().cancel():t._cancelBranched();break}t._isFollowing()&&t._followee().cancel(),t._setWillBeCancelled(),e=t,t=n}},e.prototype._branchHasCancelled=function(){this._branchesRemainingToCancel--},e.prototype._enoughBranchesHaveCancelled=function(){return void 0===this._branchesRemainingToCancel||this._branchesRemainingToCancel<=0},e.prototype._cancelBy=function(t){return t===this?(this._branchesRemainingToCancel=0,this._invokeOnCancel(),!0):(this._branchHasCancelled(),this._enoughBranchesHaveCancelled()?(this._invokeOnCancel(),!0):!1)},e.prototype._cancelBranched=function(){this._enoughBranchesHaveCancelled()&&this._cancel()},e.prototype._cancel=function(){this._isCancellable()&&(this._setCancelled(),c.invoke(this._cancelPromises,this,void 0))},e.prototype._cancelPromises=function(){this._length()>0&&this._settlePromises()},e.prototype._unsetOnCancel=function(){this._onCancelField=void 0},e.prototype._isCancellable=function(){return this.isPending()&&!this._isCancelled()},e.prototype.isCancellable=function(){return this.isPending()&&!this.isCancelled()},e.prototype._doInvokeOnCancel=function(t,e){if(o.isArray(t))for(var n=0;n<t.length;++n)this._doInvokeOnCancel(t[n],e);else if(void 0!==t)if("function"==typeof t){if(!e){var r=s(t).call(this._boundValue());r===a&&(this._attachExtraTrace(r.e),c.throwLater(r.e))}}else t._resultCancelled(this)},e.prototype._invokeOnCancel=function(){var t=this._onCancel();this._unsetOnCancel(),c.invoke(this._doInvokeOnCancel,this,t)},e.prototype._invokeInternalOnCancel=function(){this._isCancellable()&&(this._doInvokeOnCancel(this._onCancel(),!0),this._unsetOnCancel())},e.prototype._resultCancelled=function(){this.cancel()}}},{"./util":36}],7:[function(t,e,n){"use strict";e.exports=function(e){function n(t,n,a){return function(c){var u=a._boundValue();t:for(var l=0;l<t.length;++l){var p=t[l];if(p===Error||null!=p&&p.prototype instanceof Error){if(c instanceof p)return o(n).call(u,c)}else if("function"==typeof p){var f=o(p).call(u,c);if(f===s)return f;if(f)return o(n).call(u,c)}else if(r.isObject(c)){for(var h=i(p),_=0;_<h.length;++_){var d=h[_];if(p[d]!=c[d])continue t}return o(n).call(u,c)}}return e}}var r=t("./util"),i=t("./es5").keys,o=r.tryCatch,s=r.errorObj;return n}},{"./es5":13,"./util":36}],8:[function(t,e,n){"use strict";e.exports=function(t){function e(){this._trace=new e.CapturedTrace(r())}function n(){return i?new e:void 0}function r(){var t=o.length-1;return t>=0?o[t]:void 0}var i=!1,o=[];return t.prototype._promiseCreated=function(){},t.prototype._pushContext=function(){},t.prototype._popContext=function(){return null},t._peekContext=t.prototype._peekContext=function(){},e.prototype._pushContext=function(){void 0!==this._trace&&(this._trace._promiseCreated=null,o.push(this._trace))},e.prototype._popContext=function(){if(void 0!==this._trace){var t=o.pop(),e=t._promiseCreated;return t._promiseCreated=null,e}return null},e.CapturedTrace=null,e.create=n,e.deactivateLongStackTraces=function(){},e.activateLongStackTraces=function(){var n=t.prototype._pushContext,o=t.prototype._popContext,s=t._peekContext,a=t.prototype._peekContext,c=t.prototype._promiseCreated;e.deactivateLongStackTraces=function(){t.prototype._pushContext=n,t.prototype._popContext=o,t._peekContext=s,t.prototype._peekContext=a,t.prototype._promiseCreated=c,i=!1},i=!0,t.prototype._pushContext=e.prototype._pushContext,t.prototype._popContext=e.prototype._popContext,t._peekContext=t.prototype._peekContext=r,t.prototype._promiseCreated=function(){var t=this._peekContext();t&&null==t._promiseCreated&&(t._promiseCreated=this)}},e}},{}],9:[function(t,e,n){"use strict";e.exports=function(e,n,r,i){function o(t,e){return{promise:e}}function s(){return!1}function a(t,e,n){var r=this;try{t(e,n,function(t){if("function"!=typeof t)throw new TypeError("onCancel must be a function, got: "+B.toString(t));r._attachCancellationCallback(t)})}catch(i){return i}}function c(t){if(!this._isCancellable())return this;var e=this._onCancel();void 0!==e?B.isArray(e)?e.push(t):this._setOnCancel([e,t]):this._setOnCancel(t)}function u(){return this._onCancelField}function l(t){this._onCancelField=t}function p(){this._cancellationParent=void 0,this._onCancelField=void 0}function f(t,e){if(0!==(1&e)){this._cancellationParent=t;var n=t._branchesRemainingToCancel;void 0===n&&(n=0),t._branchesRemainingToCancel=n+1}0!==(2&e)&&t._isBound()&&this._setBoundTo(t._boundTo)}function h(t,e){0!==(2&e)&&t._isBound()&&this._setBoundTo(t._boundTo)}function _(){var t=this._boundTo;return void 0!==t&&t instanceof e?t.isFulfilled()?t.value():void 0:t}function d(){this._trace=new V(this._peekContext())}function v(t,e){if(q(t)){var n=this._trace;if(void 0!==n&&e&&(n=n._parent),void 0!==n)n.attachExtraTrace(t);else if(!t.__stackCleaned__){var r=F(t);B.notEnumerableProp(t,"stack",r.message+"\n"+r.stack.join("\n")),B.notEnumerableProp(t,"__stackCleaned__",!0)}}}function y(){this._trace=void 0}function g(t,e,n,r,i){if(void 0===t&&null!==e&&Z){if(void 0!==i&&i._returnedNonUndefined())return;if(0===(65535&r._bitField))return;n&&(n+=" ");var o="",s="";if(e._trace){for(var a=e._trace.stack.split("\n"),c=k(a),u=c.length-1;u>=0;--u){var l=c[u];if(!Q.test(l)){var p=l.match(G);p&&(o="at "+p[1]+":"+p[2]+":"+p[3]+" ");break}}if(c.length>0)for(var f=c[0],u=0;u<a.length;++u)if(a[u]===f){u>0&&(s="\n"+a[u-1]);break}}var h="a promise was created in a "+n+"handler "+o+"but was not returned from it, see http://goo.gl/rRqMUw"+s;r._warn(h,!0,e)}}function m(t,e){var n=t+" is deprecated and will be removed in a future version.";return e&&(n+=" Use "+e+" instead."),b(n)}function b(t,n,r){if(lt.warnings){var i,o=new U(t);if(n)r._attachExtraTrace(o);else if(lt.longStackTraces&&(i=e._peekContext()))i.attachExtraTrace(o);else{var s=F(o);o.stack=s.message+"\n"+s.stack.join("\n")}ot("warning",o)||x(o,"",!0)}}function w(t,e){for(var n=0;n<e.length-1;++n)e[n].push("From previous event:"),e[n]=e[n].join("\n");return n<e.length&&(e[n]=e[n].join("\n")),t+"\n"+e.join("\n")}function C(t){for(var e=0;e<t.length;++e)(0===t[e].length||e+1<t.length&&t[e][0]===t[e+1][0])&&(t.splice(e,1),e--)}function j(t){for(var e=t[0],n=1;n<t.length;++n){for(var r=t[n],i=e.length-1,o=e[i],s=-1,a=r.length-1;a>=0;--a)if(r[a]===o){s=a;break}for(var a=s;a>=0;--a){var c=r[a];if(e[i]!==c)break;e.pop(),i--}e=r}}function k(t){for(var e=[],n=0;n<t.length;++n){var r=t[n],i="    (No stack trace)"===r||z.test(r),o=i&&at(r);i&&!o&&(W&&" "!==r.charAt(0)&&(r="    "+r),e.push(r))}return e}function E(t){for(var e=t.stack.replace(/\s+$/g,"").split("\n"),n=0;n<e.length;++n){var r=e[n];if("    (No stack trace)"===r||z.test(r))break}return n>0&&"SyntaxError"!=t.name&&(e=e.slice(n)),e}function F(t){var e=t.stack,n=t.toString();return e="string"==typeof e&&e.length>0?E(t):["    (No stack trace)"],{message:n,stack:"SyntaxError"==t.name?e:k(e)}}function x(t,e,n){if("undefined"!=typeof console){var r;if(B.isObject(t)){var i=t.stack;r=e+X(i,t)}else r=e+String(t);"function"==typeof I?I(r,n):("function"==typeof console.log||"object"==typeof console.log)&&console.log(r)}}function T(t,e,n,r){var i=!1;try{"function"==typeof e&&(i=!0,"rejectionHandled"===t?e(r):e(n,r))}catch(o){N.throwLater(o)}"unhandledRejection"===t?ot(t,n,r)||i||x(n,"Unhandled rejection "):ot(t,r)}function P(t){var e;if("function"==typeof t)e="[function "+(t.name||"anonymous")+"]";else{e=t&&"function"==typeof t.toString?t.toString():B.toString(t);var n=/\[object [a-zA-Z0-9$_]+\]/;if(n.test(e))try{var r=JSON.stringify(t);e=r}catch(i){}0===e.length&&(e="(empty array)")}return"(<"+R(e)+">, no stack trace)"}function R(t){var e=41;return t.length<e?t:t.substr(0,e-3)+"..."}function S(){return"function"==typeof ut}function O(t){var e=t.match(ct);return e?{fileName:e[1],line:parseInt(e[2],10)}:void 0}function A(t,e){if(S()){for(var n,r,i=(t.stack||"").split("\n"),o=(e.stack||"").split("\n"),s=-1,a=-1,c=0;c<i.length;++c){var u=O(i[c]);if(u){n=u.fileName,s=u.line;break}}for(var c=0;c<o.length;++c){var u=O(o[c]);if(u){r=u.fileName,a=u.line;break}}0>s||0>a||!n||!r||n!==r||s>=a||(at=function(t){if($.test(t))return!0;var e=O(t);return e&&e.fileName===n&&s<=e.line&&e.line<=a?!0:!1})}}function V(t){this._parent=t,this._promisesCreated=0;var e=this._length=1+(void 0===t?0:t._length);ut(this,V),e>32&&this.uncycle()}var H,D,I,L,N=e._async,U=t("./errors").Warning,B=t("./util"),M=t("./es5"),q=B.canAttachTrace,$=/[\\\/]bluebird[\\\/]js[\\\/](release|debug|instrumented)/,Q=/\((?:timers\.js):\d+:\d+\)/,G=/[\/<\(](.+?):(\d+):(\d+)\)?\s*$/,z=null,X=null,W=!1,K=!(0==B.env("BLUEBIRD_DEBUG")||!B.env("BLUEBIRD_DEBUG")&&"development"!==B.env("NODE_ENV")),J=!(0==B.env("BLUEBIRD_WARNINGS")||!K&&!B.env("BLUEBIRD_WARNINGS")),Y=!(0==B.env("BLUEBIRD_LONG_STACK_TRACES")||!K&&!B.env("BLUEBIRD_LONG_STACK_TRACES")),Z=0!=B.env("BLUEBIRD_W_FORGOTTEN_RETURN")&&(J||!!B.env("BLUEBIRD_W_FORGOTTEN_RETURN"));!function(){function t(){for(var t=0;t<r.length;++t)r[t]._notifyUnhandledRejection();n()}function n(){r.length=0}var r=[];L=function(e){r.push(e),setTimeout(t,1)},M.defineProperty(e,"_unhandledRejectionCheck",{value:t}),M.defineProperty(e,"_unhandledRejectionClear",{value:n})}(),e.prototype.suppressUnhandledRejections=function(){var t=this._target();t._bitField=-1048577&t._bitField|524288},e.prototype._ensurePossibleRejectionHandled=function(){0===(524288&this._bitField)&&(this._setRejectionIsUnhandled(),L(this))},e.prototype._notifyUnhandledRejectionIsHandled=function(){T("rejectionHandled",H,void 0,this)},e.prototype._setReturnedNonUndefined=function(){this._bitField=268435456|this._bitField},e.prototype._returnedNonUndefined=function(){return 0!==(268435456&this._bitField)},e.prototype._notifyUnhandledRejection=function(){if(this._isRejectionUnhandled()){var t=this._settledValue();this._setUnhandledRejectionIsNotified(),T("unhandledRejection",D,t,this)}},e.prototype._setUnhandledRejectionIsNotified=function(){this._bitField=262144|this._bitField},e.prototype._unsetUnhandledRejectionIsNotified=function(){this._bitField=-262145&this._bitField},e.prototype._isUnhandledRejectionNotified=function(){return(262144&this._bitField)>0},e.prototype._setRejectionIsUnhandled=function(){this._bitField=1048576|this._bitField},e.prototype._unsetRejectionIsUnhandled=function(){this._bitField=-1048577&this._bitField,this._isUnhandledRejectionNotified()&&(this._unsetUnhandledRejectionIsNotified(),this._notifyUnhandledRejectionIsHandled())},e.prototype._isRejectionUnhandled=function(){return(1048576&this._bitField)>0},e.prototype._warn=function(t,e,n){return b(t,e,n||this)},e.onPossiblyUnhandledRejection=function(t){var n=e._getContext();D=B.contextBind(n,t)},e.onUnhandledRejectionHandled=function(t){var n=e._getContext();H=B.contextBind(n,t)};var tt=function(){};e.longStackTraces=function(){if(N.haveItemsQueued()&&!lt.longStackTraces)throw new Error("cannot enable long stack traces after promises have been created\n\n    See http://goo.gl/MqrFmX\n");if(!lt.longStackTraces&&S()){var t=e.prototype._captureStackTrace,r=e.prototype._attachExtraTrace,i=e.prototype._dereferenceTrace;lt.longStackTraces=!0,tt=function(){if(N.haveItemsQueued()&&!lt.longStackTraces)throw new Error("cannot enable long stack traces after promises have been created\n\n    See http://goo.gl/MqrFmX\n");e.prototype._captureStackTrace=t,e.prototype._attachExtraTrace=r,e.prototype._dereferenceTrace=i,n.deactivateLongStackTraces(),lt.longStackTraces=!1},e.prototype._captureStackTrace=d,e.prototype._attachExtraTrace=v,e.prototype._dereferenceTrace=y,n.activateLongStackTraces()}},e.hasLongStackTraces=function(){return lt.longStackTraces&&S()};var et={unhandledrejection:{before:function(){var t=B.global.onunhandledrejection;return B.global.onunhandledrejection=null,t},after:function(t){B.global.onunhandledrejection=t}},rejectionhandled:{before:function(){var t=B.global.onrejectionhandled;return B.global.onrejectionhandled=null,t},after:function(t){B.global.onrejectionhandled=t}}},nt=function(){var t=function(t,e){if(!t)return!B.global.dispatchEvent(e);var n;try{return n=t.before(),!B.global.dispatchEvent(e)}finally{t.after(n)}};try{if("function"==typeof CustomEvent){var e=new CustomEvent("CustomEvent");return B.global.dispatchEvent(e),function(e,n){e=e.toLowerCase();var r={detail:n,cancelable:!0},i=new CustomEvent(e,r);return M.defineProperty(i,"promise",{value:n.promise}),M.defineProperty(i,"reason",{value:n.reason}),t(et[e],i)}}if("function"==typeof Event){var e=new Event("CustomEvent");return B.global.dispatchEvent(e),function(e,n){e=e.toLowerCase();var r=new Event(e,{cancelable:!0});return r.detail=n,M.defineProperty(r,"promise",{value:n.promise}),M.defineProperty(r,"reason",{value:n.reason}),t(et[e],r)}}var e=document.createEvent("CustomEvent");return e.initCustomEvent("testingtheevent",!1,!0,{}),B.global.dispatchEvent(e),function(e,n){e=e.toLowerCase();var r=document.createEvent("CustomEvent");return r.initCustomEvent(e,!1,!0,n),t(et[e],r)}}catch(n){}return function(){return!1}}(),rt=function(){return B.isNode?function(){return process.emit.apply(process,arguments)}:B.global?function(t){var e="on"+t.toLowerCase(),n=B.global[e];return n?(n.apply(B.global,[].slice.call(arguments,1)),!0):!1}:function(){return!1}}(),it={promiseCreated:o,promiseFulfilled:o,promiseRejected:o,promiseResolved:o,promiseCancelled:o,promiseChained:function(t,e,n){return{promise:e,child:n}},warning:function(t,e){return{warning:e}},unhandledRejection:function(t,e,n){return{reason:e,promise:n}},rejectionHandled:o},ot=function(t){var e=!1;try{e=rt.apply(null,arguments)}catch(n){N.throwLater(n),e=!0}var r=!1;try{r=nt(t,it[t].apply(null,arguments))}catch(n){N.throwLater(n),r=!0}return r||e};e.config=function(t){if(t=Object(t),"longStackTraces"in t&&(t.longStackTraces?e.longStackTraces():!t.longStackTraces&&e.hasLongStackTraces()&&tt()),"warnings"in t){var n=t.warnings;lt.warnings=!!n,Z=lt.warnings,B.isObject(n)&&"wForgottenReturn"in n&&(Z=!!n.wForgottenReturn)}if("cancellation"in t&&t.cancellation&&!lt.cancellation){if(N.haveItemsQueued())throw new Error("cannot enable cancellation after promises are in use");e.prototype._clearCancellationData=p,e.prototype._propagateFrom=f,e.prototype._onCancel=u,e.prototype._setOnCancel=l,e.prototype._attachCancellationCallback=c,e.prototype._execute=a,st=f,lt.cancellation=!0}if("monitoring"in t&&(t.monitoring&&!lt.monitoring?(lt.monitoring=!0,e.prototype._fireEvent=ot):!t.monitoring&&lt.monitoring&&(lt.monitoring=!1,e.prototype._fireEvent=s)),"asyncHooks"in t&&B.nodeSupportsAsyncResource){var o=lt.asyncHooks,h=!!t.asyncHooks;o!==h&&(lt.asyncHooks=h,h?r():i())}return e},e.prototype._fireEvent=s,e.prototype._execute=function(t,e,n){try{t(e,n)}catch(r){return r}},e.prototype._onCancel=function(){},e.prototype._setOnCancel=function(t){},e.prototype._attachCancellationCallback=function(t){},e.prototype._captureStackTrace=function(){},e.prototype._attachExtraTrace=function(){},e.prototype._dereferenceTrace=function(){},e.prototype._clearCancellationData=function(){},e.prototype._propagateFrom=function(t,e){};var st=h,at=function(){return!1},ct=/[\/<\(]([^:\/]+):(\d+):(?:\d+)\)?\s*$/;B.inherits(V,Error),n.CapturedTrace=V,V.prototype.uncycle=function(){var t=this._length;if(!(2>t)){for(var e=[],n={},r=0,i=this;void 0!==i;++r)e.push(i),i=i._parent;t=this._length=r;for(var r=t-1;r>=0;--r){var o=e[r].stack;void 0===n[o]&&(n[o]=r)}for(var r=0;t>r;++r){var s=e[r].stack,a=n[s];if(void 0!==a&&a!==r){a>0&&(e[a-1]._parent=void 0,e[a-1]._length=1),e[r]._parent=void 0,e[r]._length=1;var c=r>0?e[r-1]:this;t-1>a?(c._parent=e[a+1],c._parent.uncycle(),c._length=c._parent._length+1):(c._parent=void 0,c._length=1);for(var u=c._length+1,l=r-2;l>=0;--l)e[l]._length=u,u++;return}}}},V.prototype.attachExtraTrace=function(t){if(!t.__stackCleaned__){this.uncycle();for(var e=F(t),n=e.message,r=[e.stack],i=this;void 0!==i;)r.push(k(i.stack.split("\n"))),i=i._parent;j(r),C(r),B.notEnumerableProp(t,"stack",w(n,r)),B.notEnumerableProp(t,"__stackCleaned__",!0)}};var ut=function(){var t=/^\s*at\s*/,e=function(t,e){return"string"==typeof t?t:void 0!==e.name&&void 0!==e.message?e.toString():P(e)};if("number"==typeof Error.stackTraceLimit&&"function"==typeof Error.captureStackTrace){Error.stackTraceLimit+=6,z=t,X=e;var n=Error.captureStackTrace;return at=function(t){return $.test(t)},function(t,e){Error.stackTraceLimit+=6,n(t,e),Error.stackTraceLimit-=6}}var r=new Error;if("string"==typeof r.stack&&r.stack.split("\n")[0].indexOf("stackDetection@")>=0)return z=/@/,X=e,W=!0,function(t){t.stack=(new Error).stack};var i;try{throw new Error}catch(o){i="stack"in o}return"stack"in r||!i||"number"!=typeof Error.stackTraceLimit?(X=function(t,e){return"string"==typeof t?t:"object"!=typeof e&&"function"!=typeof e||void 0===e.name||void 0===e.message?P(e):e.toString()},null):(z=t,X=e,function(t){Error.stackTraceLimit+=6;try{throw new Error}catch(e){t.stack=e.stack}Error.stackTraceLimit-=6})}([]);"undefined"!=typeof console&&"undefined"!=typeof console.warn&&(I=function(t){console.warn(t)},B.isNode&&process.stderr.isTTY?I=function(t,e){var n=e?"[33m":"[31m";console.warn(n+t+"[0m\n")}:B.isNode||"string"!=typeof(new Error).stack||(I=function(t,e){console.warn("%c"+t,e?"color: darkorange":"color: red")}));var lt={warnings:J,longStackTraces:!1,cancellation:!1,monitoring:!1,asyncHooks:!1};return Y&&e.longStackTraces(),{asyncHooks:function(){return lt.asyncHooks},longStackTraces:function(){return lt.longStackTraces},warnings:function(){return lt.warnings},cancellation:function(){return lt.cancellation},monitoring:function(){return lt.monitoring},propagateFromFunction:function(){return st},boundValueFunction:function(){return _},checkForgottenReturns:g,setBounds:A,warn:b,deprecated:m,CapturedTrace:V,fireDomEvent:nt,fireGlobalEvent:rt}}},{"./errors":12,"./es5":13,"./util":36}],10:[function(t,e,n){"use strict";e.exports=function(t){function e(){return this.value}function n(){throw this.reason}t.prototype["return"]=t.prototype.thenReturn=function(n){return n instanceof t&&n.suppressUnhandledRejections(),this._then(e,void 0,void 0,{value:n},void 0)},t.prototype["throw"]=t.prototype.thenThrow=function(t){return this._then(n,void 0,void 0,{reason:t},void 0)},t.prototype.catchThrow=function(t){if(arguments.length<=1)return this._then(void 0,n,void 0,{reason:t},void 0);var e=arguments[1],r=function(){throw e};return this.caught(t,r)},t.prototype.catchReturn=function(n){if(arguments.length<=1)return n instanceof t&&n.suppressUnhandledRejections(),this._then(void 0,e,void 0,{value:n},void 0);var r=arguments[1];r instanceof t&&r.suppressUnhandledRejections();var i=function(){return r};return this.caught(n,i)}}},{}],11:[function(t,e,n){"use strict";e.exports=function(t,e){function n(){return o(this)}function r(t,n){return i(t,n,e,e)}var i=t.reduce,o=t.all;t.prototype.each=function(t){return i(this,t,e,0)._then(n,void 0,void 0,this,void 0)},t.prototype.mapSeries=function(t){return i(this,t,e,e)},t.each=function(t,r){return i(t,r,e,0)._then(n,void 0,void 0,t,void 0)},t.mapSeries=r}},{}],12:[function(t,e,n){"use strict";function r(t,e){function n(r){return this instanceof n?(p(this,"message","string"==typeof r?r:e),p(this,"name",t),void(Error.captureStackTrace?Error.captureStackTrace(this,this.constructor):Error.call(this))):new n(r)}return l(n,Error),n}function i(t){return this instanceof i?(p(this,"name","OperationalError"),p(this,"message",t),this.cause=t,this.isOperational=!0,void(t instanceof Error?(p(this,"message",t.message),p(this,"stack",t.stack)):Error.captureStackTrace&&Error.captureStackTrace(this,this.constructor))):new i(t)}var o,s,a=t("./es5"),c=a.freeze,u=t("./util"),l=u.inherits,p=u.notEnumerableProp,f=r("Warning","warning"),h=r("CancellationError","cancellation error"),_=r("TimeoutError","timeout error"),d=r("AggregateError","aggregate error");try{o=TypeError,s=RangeError}catch(v){o=r("TypeError","type error"),s=r("RangeError","range error")}for(var y="join pop push shift unshift slice filter forEach some every map indexOf lastIndexOf reduce reduceRight sort reverse".split(" "),g=0;g<y.length;++g)"function"==typeof Array.prototype[y[g]]&&(d.prototype[y[g]]=Array.prototype[y[g]]);a.defineProperty(d.prototype,"length",{value:0,configurable:!1,writable:!0,enumerable:!0}),d.prototype.isOperational=!0;var m=0;d.prototype.toString=function(){var t=Array(4*m+1).join(" "),e="\n"+t+"AggregateError of:\n";m++,t=Array(4*m+1).join(" ");for(var n=0;n<this.length;++n){for(var r=this[n]===this?"[Circular AggregateError]":this[n]+"",i=r.split("\n"),o=0;o<i.length;++o)i[o]=t+i[o];r=i.join("\n"),e+=r+"\n"}return m--,e},l(i,Error);var b=Error.__BluebirdErrorTypes__;b||(b=c({CancellationError:h,TimeoutError:_,OperationalError:i,RejectionError:i,AggregateError:d}),a.defineProperty(Error,"__BluebirdErrorTypes__",{value:b,writable:!1,enumerable:!1,configurable:!1})),e.exports={Error:Error,TypeError:o,RangeError:s,CancellationError:b.CancellationError,OperationalError:b.OperationalError,TimeoutError:b.TimeoutError,AggregateError:b.AggregateError,Warning:f}},{"./es5":13,"./util":36}],13:[function(t,e,n){var r=function(){"use strict";return void 0===this}();if(r)e.exports={freeze:Object.freeze,defineProperty:Object.defineProperty,getDescriptor:Object.getOwnPropertyDescriptor,keys:Object.keys,names:Object.getOwnPropertyNames,getPrototypeOf:Object.getPrototypeOf,isArray:Array.isArray,isES5:r,propertyIsWritable:function(t,e){var n=Object.getOwnPropertyDescriptor(t,e);return!(n&&!n.writable&&!n.set)}};else{var i={}.hasOwnProperty,o={}.toString,s={}.constructor.prototype,a=function(t){var e=[];for(var n in t)i.call(t,n)&&e.push(n);return e},c=function(t,e){return{value:t[e]}},u=function(t,e,n){return t[e]=n.value,t},l=function(t){return t},p=function(t){try{return Object(t).constructor.prototype}catch(e){return s}},f=function(t){try{return"[object Array]"===o.call(t)}catch(e){return!1}};e.exports={isArray:f,keys:a,names:a,defineProperty:u,getDescriptor:c,freeze:l,getPrototypeOf:p,isES5:r,propertyIsWritable:function(){return!0}}}},{}],14:[function(t,e,n){"use strict";e.exports=function(t,e){var n=t.map;t.prototype.filter=function(t,r){return n(this,t,r,e)},t.filter=function(t,r,i){return n(t,r,i,e)}}},{}],15:[function(t,e,n){"use strict";e.exports=function(e,n,r){function i(t,e,n){this.promise=t,this.type=e,this.handler=n,this.called=!1,this.cancelPromise=null}function o(t){this.finallyHandler=t}function s(t,e){return null!=t.cancelPromise?(arguments.length>1?t.cancelPromise._reject(e):t.cancelPromise._cancel(),t.cancelPromise=null,!0):!1}function a(){return u.call(this,this.promise._target()._settledValue())}function c(t){return s(this,t)?void 0:(f.e=t,f)}function u(t){var i=this.promise,u=this.handler;if(!this.called){this.called=!0;var l=this.isFinallyHandler()?u.call(i._boundValue()):u.call(i._boundValue(),t);if(l===r)return l;if(void 0!==l){i._setReturnedNonUndefined();var h=n(l,i);if(h instanceof e){if(null!=this.cancelPromise){if(h._isCancelled()){var _=new p("late cancellation observer");return i._attachExtraTrace(_),f.e=_,f}h.isPending()&&h._attachCancellationCallback(new o(this))}return h._then(a,c,void 0,this,void 0)}}}return i.isRejected()?(s(this),f.e=t,f):(s(this),t)}var l=t("./util"),p=e.CancellationError,f=l.errorObj,h=t("./catch_filter")(r);return i.prototype.isFinallyHandler=function(){return 0===this.type},o.prototype._resultCancelled=function(){s(this.finallyHandler)},e.prototype._passThrough=function(t,e,n,r){return"function"!=typeof t?this.then():this._then(n,r,void 0,new i(this,e,t),void 0)},e.prototype.lastly=e.prototype["finally"]=function(t){return this._passThrough(t,0,u,u)},e.prototype.tap=function(t){return this._passThrough(t,1,u)},e.prototype.tapCatch=function(t){var n=arguments.length;if(1===n)return this._passThrough(t,1,void 0,u);var r,i=new Array(n-1),o=0;for(r=0;n-1>r;++r){var s=arguments[r];if(!l.isObject(s))return e.reject(new TypeError("tapCatch statement predicate: expecting an object but got "+l.classString(s)));i[o++]=s}i.length=o;var a=arguments[r];return this._passThrough(h(i,a,this),1,void 0,u)},i}},{"./catch_filter":7,"./util":36}],16:[function(t,e,n){"use strict";e.exports=function(e,n,r,i,o,s){function a(t,n,r){for(var o=0;o<n.length;++o){r._pushContext();var s=h(n[o])(t);if(r._popContext(),s===f){r._pushContext();var a=e.reject(f.e);return r._popContext(),a}var c=i(s,r);if(c instanceof e)return c}return null}function c(t,n,i,o){if(s.cancellation()){var a=new e(r),c=this._finallyPromise=new e(r);this._promise=a.lastly(function(){return c}),a._captureStackTrace(),a._setOnCancel(this)}else{var u=this._promise=new e(r);u._captureStackTrace()}this._stack=o,this._generatorFunction=t,this._receiver=n,this._generator=void 0,this._yieldHandlers="function"==typeof i?[i].concat(_):_,this._yieldedPromise=null,this._cancellationPhase=!1}var u=t("./errors"),l=u.TypeError,p=t("./util"),f=p.errorObj,h=p.tryCatch,_=[];p.inherits(c,o),c.prototype._isResolved=function(){return null===this._promise},c.prototype._cleanup=function(){this._promise=this._generator=null,s.cancellation()&&null!==this._finallyPromise&&(this._finallyPromise._fulfill(),this._finallyPromise=null)},c.prototype._promiseCancelled=function(){if(!this._isResolved()){var t,n="undefined"!=typeof this._generator["return"];if(n)this._promise._pushContext(),t=h(this._generator["return"]).call(this._generator,void 0),this._promise._popContext();else{var r=new e.CancellationError("generator .return() sentinel");e.coroutine.returnSentinel=r,this._promise._attachExtraTrace(r),this._promise._pushContext(),t=h(this._generator["throw"]).call(this._generator,r),this._promise._popContext()}this._cancellationPhase=!0,this._yieldedPromise=null,this._continue(t)}},c.prototype._promiseFulfilled=function(t){this._yieldedPromise=null,this._promise._pushContext();var e=h(this._generator.next).call(this._generator,t);this._promise._popContext(),this._continue(e)},c.prototype._promiseRejected=function(t){this._yieldedPromise=null,this._promise._attachExtraTrace(t),this._promise._pushContext();var e=h(this._generator["throw"]).call(this._generator,t);this._promise._popContext(),this._continue(e)},c.prototype._resultCancelled=function(){if(this._yieldedPromise instanceof e){var t=this._yieldedPromise;this._yieldedPromise=null,t.cancel()}},c.prototype.promise=function(){return this._promise},c.prototype._run=function(){this._generator=this._generatorFunction.call(this._receiver),this._receiver=this._generatorFunction=void 0,this._promiseFulfilled(void 0)},c.prototype._continue=function(t){var n=this._promise;if(t===f)return this._cleanup(),this._cancellationPhase?n.cancel():n._rejectCallback(t.e,!1);var r=t.value;if(t.done===!0)return this._cleanup(),this._cancellationPhase?n.cancel():n._resolveCallback(r);
var o=i(r,this._promise);if(!(o instanceof e)&&(o=a(o,this._yieldHandlers,this._promise),null===o))return void this._promiseRejected(new l("A value %s was yielded that could not be treated as a promise\n\n    See http://goo.gl/MqrFmX\n\n".replace("%s",String(r))+"From coroutine:\n"+this._stack.split("\n").slice(1,-7).join("\n")));o=o._target();var s=o._bitField;0===(50397184&s)?(this._yieldedPromise=o,o._proxy(this,null)):0!==(33554432&s)?e._async.invoke(this._promiseFulfilled,this,o._value()):0!==(16777216&s)?e._async.invoke(this._promiseRejected,this,o._reason()):this._promiseCancelled()},e.coroutine=function(t,e){if("function"!=typeof t)throw new l("generatorFunction must be a function\n\n    See http://goo.gl/MqrFmX\n");var n=Object(e).yieldHandler,r=c,i=(new Error).stack;return function(){var e=t.apply(this,arguments),o=new r(void 0,void 0,n,i),s=o.promise();return o._generator=e,o._promiseFulfilled(void 0),s}},e.coroutine.addYieldHandler=function(t){if("function"!=typeof t)throw new l("expecting a function but got "+p.classString(t));_.push(t)},e.spawn=function(t){if(s.deprecated("Promise.spawn()","Promise.coroutine()"),"function"!=typeof t)return n("generatorFunction must be a function\n\n    See http://goo.gl/MqrFmX\n");var r=new c(t,this),i=r.promise();return r._run(e.spawn),i}}},{"./errors":12,"./util":36}],17:[function(t,e,n){"use strict";e.exports=function(e,n,r,i,o){var s=t("./util");s.canEvaluate,s.tryCatch,s.errorObj;e.join=function(){var t,e=arguments.length-1;if(e>0&&"function"==typeof arguments[e]){t=arguments[e];var r}var i=[].slice.call(arguments);t&&i.pop();var r=new n(i).promise();return void 0!==t?r.spread(t):r}}},{"./util":36}],18:[function(t,e,n){"use strict";e.exports=function(e,n,r,i,o,s){function a(t,n,r,i){this.constructor$(t),this._promise._captureStackTrace();var s=e._getContext();if(this._callback=u.contextBind(s,n),this._preservedValues=i===o?new Array(this.length()):null,this._limit=r,this._inFlight=0,this._queue=[],f.invoke(this._asyncInit,this,void 0),u.isArray(t))for(var a=0;a<t.length;++a){var c=t[a];c instanceof e&&c.suppressUnhandledRejections()}}function c(t,n,i,o){if("function"!=typeof n)return r("expecting a function but got "+u.classString(n));var s=0;if(void 0!==i){if("object"!=typeof i||null===i)return e.reject(new TypeError("options argument must be an object but it is "+u.classString(i)));if("number"!=typeof i.concurrency)return e.reject(new TypeError("'concurrency' must be a number but it is "+u.classString(i.concurrency)));s=i.concurrency}return s="number"==typeof s&&isFinite(s)&&s>=1?s:0,new a(t,n,s,o).promise()}var u=t("./util"),l=u.tryCatch,p=u.errorObj,f=e._async;u.inherits(a,n),a.prototype._asyncInit=function(){this._init$(void 0,-2)},a.prototype._init=function(){},a.prototype._promiseFulfilled=function(t,n){var r=this._values,o=this.length(),a=this._preservedValues,c=this._limit;if(0>n){if(n=-1*n-1,r[n]=t,c>=1&&(this._inFlight--,this._drainQueue(),this._isResolved()))return!0}else{if(c>=1&&this._inFlight>=c)return r[n]=t,this._queue.push(n),!1;null!==a&&(a[n]=t);var u=this._promise,f=this._callback,h=u._boundValue();u._pushContext();var _=l(f).call(h,t,n,o),d=u._popContext();if(s.checkForgottenReturns(_,d,null!==a?"Promise.filter":"Promise.map",u),_===p)return this._reject(_.e),!0;var v=i(_,this._promise);if(v instanceof e){v=v._target();var y=v._bitField;if(0===(50397184&y))return c>=1&&this._inFlight++,r[n]=v,v._proxy(this,-1*(n+1)),!1;if(0===(33554432&y))return 0!==(16777216&y)?(this._reject(v._reason()),!0):(this._cancel(),!0);_=v._value()}r[n]=_}var g=++this._totalResolved;return g>=o?(null!==a?this._filter(r,a):this._resolve(r),!0):!1},a.prototype._drainQueue=function(){for(var t=this._queue,e=this._limit,n=this._values;t.length>0&&this._inFlight<e;){if(this._isResolved())return;var r=t.pop();this._promiseFulfilled(n[r],r)}},a.prototype._filter=function(t,e){for(var n=e.length,r=new Array(n),i=0,o=0;n>o;++o)t[o]&&(r[i++]=e[o]);r.length=i,this._resolve(r)},a.prototype.preservedValues=function(){return this._preservedValues},e.prototype.map=function(t,e){return c(this,t,e,null)},e.map=function(t,e,n,r){return c(t,e,n,r)}}},{"./util":36}],19:[function(t,e,n){"use strict";e.exports=function(e,n,r,i,o){var s=t("./util"),a=s.tryCatch;e.method=function(t){if("function"!=typeof t)throw new e.TypeError("expecting a function but got "+s.classString(t));return function(){var r=new e(n);r._captureStackTrace(),r._pushContext();var i=a(t).apply(this,arguments),s=r._popContext();return o.checkForgottenReturns(i,s,"Promise.method",r),r._resolveFromSyncValue(i),r}},e.attempt=e["try"]=function(t){if("function"!=typeof t)return i("expecting a function but got "+s.classString(t));var r=new e(n);r._captureStackTrace(),r._pushContext();var c;if(arguments.length>1){o.deprecated("calling Promise.try with more than 1 argument");var u=arguments[1],l=arguments[2];c=s.isArray(u)?a(t).apply(l,u):a(t).call(l,u)}else c=a(t)();var p=r._popContext();return o.checkForgottenReturns(c,p,"Promise.try",r),r._resolveFromSyncValue(c),r},e.prototype._resolveFromSyncValue=function(t){t===s.errorObj?this._rejectCallback(t.e,!1):this._resolveCallback(t,!0)}}},{"./util":36}],20:[function(t,e,n){"use strict";function r(t){return t instanceof Error&&l.getPrototypeOf(t)===Error.prototype}function i(t){var e;if(r(t)){e=new u(t),e.name=t.name,e.message=t.message,e.stack=t.stack;for(var n=l.keys(t),i=0;i<n.length;++i){var o=n[i];p.test(o)||(e[o]=t[o])}return e}return s.markAsOriginatingFromRejection(t),t}function o(t,e){return function(n,r){if(null!==t){if(n){var o=i(a(n));t._attachExtraTrace(o),t._reject(o)}else if(e){var s=[].slice.call(arguments,1);t._fulfill(s)}else t._fulfill(r);t=null}}}var s=t("./util"),a=s.maybeWrapAsError,c=t("./errors"),u=c.OperationalError,l=t("./es5"),p=/^(?:name|message|stack|cause)$/;e.exports=o},{"./errors":12,"./es5":13,"./util":36}],21:[function(t,e,n){"use strict";e.exports=function(e){function n(t,e){var n=this;if(!o.isArray(t))return r.call(n,t,e);var i=a(e).apply(n._boundValue(),[null].concat(t));i===c&&s.throwLater(i.e)}function r(t,e){var n=this,r=n._boundValue(),i=void 0===t?a(e).call(r,null):a(e).call(r,null,t);i===c&&s.throwLater(i.e)}function i(t,e){var n=this;if(!t){var r=new Error(t+"");r.cause=t,t=r}var i=a(e).call(n._boundValue(),t);i===c&&s.throwLater(i.e)}var o=t("./util"),s=e._async,a=o.tryCatch,c=o.errorObj;e.prototype.asCallback=e.prototype.nodeify=function(t,e){if("function"==typeof t){var o=r;void 0!==e&&Object(e).spread&&(o=n),this._then(o,i,void 0,this,t)}return this}}},{"./util":36}],22:[function(t,e,n){"use strict";e.exports=function(){function n(){}function r(t,e){if(null==t||t.constructor!==i)throw new E("the promise constructor cannot be invoked directly\n\n    See http://goo.gl/MqrFmX\n");if("function"!=typeof e)throw new E("expecting a function but got "+f.classString(e))}function i(t){t!==x&&r(this,t),this._bitField=0,this._fulfillmentHandler0=void 0,this._rejectionHandler0=void 0,this._promise0=void 0,this._receiver0=void 0,this._resolveFromExecutor(t),this._promiseCreated(),this._fireEvent("promiseCreated",this)}function o(t){this.promise._resolveCallback(t)}function s(t){this.promise._rejectCallback(t,!1)}function a(t){var e=new i(x);e._fulfillmentHandler0=t,e._rejectionHandler0=t,e._promise0=t,e._receiver0=t}var c=function(){return new E("circular promise resolution chain\n\n    See http://goo.gl/MqrFmX\n")},u=function(){return new i.PromiseInspection(this._target())},l=function(t){return i.reject(new E(t))},p={},f=t("./util");f.setReflectHandler(u);var h=function(){var t=process.domain;return void 0===t?null:t},_=function(){return null},d=function(){return{domain:h(),async:null}},v=f.isNode&&f.nodeSupportsAsyncResource?t("async_hooks").AsyncResource:null,y=function(){return{domain:h(),async:new v("Bluebird::Promise")}},g=f.isNode?d:_;f.notEnumerableProp(i,"_getContext",g);var m=function(){g=y,f.notEnumerableProp(i,"_getContext",y)},b=function(){g=d,f.notEnumerableProp(i,"_getContext",d)},w=t("./es5"),C=t("./async"),j=new C;w.defineProperty(i,"_async",{value:j});var k=t("./errors"),E=i.TypeError=k.TypeError;i.RangeError=k.RangeError;var F=i.CancellationError=k.CancellationError;i.TimeoutError=k.TimeoutError,i.OperationalError=k.OperationalError,i.RejectionError=k.OperationalError,i.AggregateError=k.AggregateError;var x=function(){},T={},P={},R=t("./thenables")(i,x),S=t("./promise_array")(i,x,R,l,n),O=t("./context")(i),A=O.create,V=t("./debuggability")(i,O,m,b),H=(V.CapturedTrace,t("./finally")(i,R,P)),D=t("./catch_filter")(P),I=t("./nodeback"),L=f.errorObj,N=f.tryCatch;return i.prototype.toString=function(){return"[object Promise]"},i.prototype.caught=i.prototype["catch"]=function(t){var e=arguments.length;if(e>1){var n,r=new Array(e-1),i=0;for(n=0;e-1>n;++n){var o=arguments[n];if(!f.isObject(o))return l("Catch statement predicate: expecting an object but got "+f.classString(o));r[i++]=o}if(r.length=i,t=arguments[n],"function"!=typeof t)throw new E("The last argument to .catch() must be a function, got "+f.toString(t));return this.then(void 0,D(r,t,this))}return this.then(void 0,t)},i.prototype.reflect=function(){return this._then(u,u,void 0,this,void 0)},i.prototype.then=function(t,e){if(V.warnings()&&arguments.length>0&&"function"!=typeof t&&"function"!=typeof e){var n=".then() only accepts functions but was passed: "+f.classString(t);arguments.length>1&&(n+=", "+f.classString(e)),this._warn(n)}return this._then(t,e,void 0,void 0,void 0)},i.prototype.done=function(t,e){var n=this._then(t,e,void 0,void 0,void 0);n._setIsFinal()},i.prototype.spread=function(t){return"function"!=typeof t?l("expecting a function but got "+f.classString(t)):this.all()._then(t,void 0,void 0,T,void 0)},i.prototype.toJSON=function(){var t={isFulfilled:!1,isRejected:!1,fulfillmentValue:void 0,rejectionReason:void 0};return this.isFulfilled()?(t.fulfillmentValue=this.value(),t.isFulfilled=!0):this.isRejected()&&(t.rejectionReason=this.reason(),t.isRejected=!0),t},i.prototype.all=function(){return arguments.length>0&&this._warn(".all() was passed arguments but it does not take any"),new S(this).promise()},i.prototype.error=function(t){return this.caught(f.originatesFromRejection,t)},i.getNewLibraryCopy=e.exports,i.is=function(t){return t instanceof i},i.fromNode=i.fromCallback=function(t){var e=new i(x);e._captureStackTrace();var n=arguments.length>1?!!Object(arguments[1]).multiArgs:!1,r=N(t)(I(e,n));return r===L&&e._rejectCallback(r.e,!0),e._isFateSealed()||e._setAsyncGuaranteed(),e},i.all=function(t){return new S(t).promise()},i.cast=function(t){var e=R(t);return e instanceof i||(e=new i(x),e._captureStackTrace(),e._setFulfilled(),e._rejectionHandler0=t),e},i.resolve=i.fulfilled=i.cast,i.reject=i.rejected=function(t){var e=new i(x);return e._captureStackTrace(),e._rejectCallback(t,!0),e},i.setScheduler=function(t){if("function"!=typeof t)throw new E("expecting a function but got "+f.classString(t));return j.setScheduler(t)},i.prototype._then=function(t,e,n,r,o){var s=void 0!==o,a=s?o:new i(x),c=this._target(),u=c._bitField;s||(a._propagateFrom(this,3),a._captureStackTrace(),void 0===r&&0!==(2097152&this._bitField)&&(r=0!==(50397184&u)?this._boundValue():c===this?void 0:this._boundTo),this._fireEvent("promiseChained",this,a));var l=g();if(0!==(50397184&u)){var p,h,_=c._settlePromiseCtx;0!==(33554432&u)?(h=c._rejectionHandler0,p=t):0!==(16777216&u)?(h=c._fulfillmentHandler0,p=e,c._unsetRejectionIsUnhandled()):(_=c._settlePromiseLateCancellationObserver,h=new F("late cancellation observer"),c._attachExtraTrace(h),p=e),j.invoke(_,c,{handler:f.contextBind(l,p),promise:a,receiver:r,value:h})}else c._addCallbacks(t,e,a,r,l);return a},i.prototype._length=function(){return 65535&this._bitField},i.prototype._isFateSealed=function(){return 0!==(117506048&this._bitField)},i.prototype._isFollowing=function(){return 67108864===(67108864&this._bitField)},i.prototype._setLength=function(t){this._bitField=-65536&this._bitField|65535&t},i.prototype._setFulfilled=function(){this._bitField=33554432|this._bitField,this._fireEvent("promiseFulfilled",this)},i.prototype._setRejected=function(){this._bitField=16777216|this._bitField,this._fireEvent("promiseRejected",this)},i.prototype._setFollowing=function(){this._bitField=67108864|this._bitField,this._fireEvent("promiseResolved",this)},i.prototype._setIsFinal=function(){this._bitField=4194304|this._bitField},i.prototype._isFinal=function(){return(4194304&this._bitField)>0},i.prototype._unsetCancelled=function(){this._bitField=-65537&this._bitField},i.prototype._setCancelled=function(){this._bitField=65536|this._bitField,this._fireEvent("promiseCancelled",this)},i.prototype._setWillBeCancelled=function(){this._bitField=8388608|this._bitField},i.prototype._setAsyncGuaranteed=function(){if(!j.hasCustomScheduler()){var t=this._bitField;this._bitField=t|(536870912&t)>>2^134217728}},i.prototype._setNoAsyncGuarantee=function(){this._bitField=-134217729&(536870912|this._bitField)},i.prototype._receiverAt=function(t){var e=0===t?this._receiver0:this[4*t-4+3];return e===p?void 0:void 0===e&&this._isBound()?this._boundValue():e},i.prototype._promiseAt=function(t){return this[4*t-4+2]},i.prototype._fulfillmentHandlerAt=function(t){return this[4*t-4+0]},i.prototype._rejectionHandlerAt=function(t){return this[4*t-4+1]},i.prototype._boundValue=function(){},i.prototype._migrateCallback0=function(t){var e=(t._bitField,t._fulfillmentHandler0),n=t._rejectionHandler0,r=t._promise0,i=t._receiverAt(0);void 0===i&&(i=p),this._addCallbacks(e,n,r,i,null)},i.prototype._migrateCallbackAt=function(t,e){var n=t._fulfillmentHandlerAt(e),r=t._rejectionHandlerAt(e),i=t._promiseAt(e),o=t._receiverAt(e);void 0===o&&(o=p),this._addCallbacks(n,r,i,o,null)},i.prototype._addCallbacks=function(t,e,n,r,i){var o=this._length();if(o>=65531&&(o=0,this._setLength(0)),0===o)this._promise0=n,this._receiver0=r,"function"==typeof t&&(this._fulfillmentHandler0=f.contextBind(i,t)),"function"==typeof e&&(this._rejectionHandler0=f.contextBind(i,e));else{var s=4*o-4;this[s+2]=n,this[s+3]=r,"function"==typeof t&&(this[s+0]=f.contextBind(i,t)),"function"==typeof e&&(this[s+1]=f.contextBind(i,e))}return this._setLength(o+1),o},i.prototype._proxy=function(t,e){this._addCallbacks(void 0,void 0,e,t,null)},i.prototype._resolveCallback=function(t,e){if(0===(117506048&this._bitField)){if(t===this)return this._rejectCallback(c(),!1);var n=R(t,this);if(!(n instanceof i))return this._fulfill(t);e&&this._propagateFrom(n,2);var r=n._target();if(r===this)return void this._reject(c());var o=r._bitField;if(0===(50397184&o)){var s=this._length();s>0&&r._migrateCallback0(this);for(var a=1;s>a;++a)r._migrateCallbackAt(this,a);this._setFollowing(),this._setLength(0),this._setFollowee(n)}else if(0!==(33554432&o))this._fulfill(r._value());else if(0!==(16777216&o))this._reject(r._reason());else{var u=new F("late cancellation observer");r._attachExtraTrace(u),this._reject(u)}}},i.prototype._rejectCallback=function(t,e,n){var r=f.ensureErrorObject(t),i=r===t;if(!i&&!n&&V.warnings()){var o="a promise was rejected with a non-error: "+f.classString(t);this._warn(o,!0)}this._attachExtraTrace(r,e?i:!1),this._reject(t)},i.prototype._resolveFromExecutor=function(t){if(t!==x){var e=this;this._captureStackTrace(),this._pushContext();var n=!0,r=this._execute(t,function(t){e._resolveCallback(t)},function(t){e._rejectCallback(t,n)});n=!1,this._popContext(),void 0!==r&&e._rejectCallback(r,!0)}},i.prototype._settlePromiseFromHandler=function(t,e,n,r){var i=r._bitField;if(0===(65536&i)){r._pushContext();var o;e===T?n&&"number"==typeof n.length?o=N(t).apply(this._boundValue(),n):(o=L,o.e=new E("cannot .spread() a non-array: "+f.classString(n))):o=N(t).call(e,n);var s=r._popContext();i=r._bitField,0===(65536&i)&&(o===P?r._reject(n):o===L?r._rejectCallback(o.e,!1):(V.checkForgottenReturns(o,s,"",r,this),r._resolveCallback(o)))}},i.prototype._target=function(){for(var t=this;t._isFollowing();)t=t._followee();return t},i.prototype._followee=function(){return this._rejectionHandler0},i.prototype._setFollowee=function(t){this._rejectionHandler0=t},i.prototype._settlePromise=function(t,e,r,o){var s=t instanceof i,a=this._bitField,c=0!==(134217728&a);0!==(65536&a)?(s&&t._invokeInternalOnCancel(),r instanceof H&&r.isFinallyHandler()?(r.cancelPromise=t,N(e).call(r,o)===L&&t._reject(L.e)):e===u?t._fulfill(u.call(r)):r instanceof n?r._promiseCancelled(t):s||t instanceof S?t._cancel():r.cancel()):"function"==typeof e?s?(c&&t._setAsyncGuaranteed(),this._settlePromiseFromHandler(e,r,o,t)):e.call(r,o,t):r instanceof n?r._isResolved()||(0!==(33554432&a)?r._promiseFulfilled(o,t):r._promiseRejected(o,t)):s&&(c&&t._setAsyncGuaranteed(),0!==(33554432&a)?t._fulfill(o):t._reject(o))},i.prototype._settlePromiseLateCancellationObserver=function(t){var e=t.handler,n=t.promise,r=t.receiver,o=t.value;"function"==typeof e?n instanceof i?this._settlePromiseFromHandler(e,r,o,n):e.call(r,o,n):n instanceof i&&n._reject(o)},i.prototype._settlePromiseCtx=function(t){this._settlePromise(t.promise,t.handler,t.receiver,t.value)},i.prototype._settlePromise0=function(t,e,n){var r=this._promise0,i=this._receiverAt(0);this._promise0=void 0,this._receiver0=void 0,this._settlePromise(r,t,i,e)},i.prototype._clearCallbackDataAtIndex=function(t){var e=4*t-4;this[e+2]=this[e+3]=this[e+0]=this[e+1]=void 0},i.prototype._fulfill=function(t){var e=this._bitField;if(!((117506048&e)>>>16)){if(t===this){var n=c();return this._attachExtraTrace(n),this._reject(n)}this._setFulfilled(),this._rejectionHandler0=t,(65535&e)>0&&(0!==(134217728&e)?this._settlePromises():j.settlePromises(this),this._dereferenceTrace())}},i.prototype._reject=function(t){var e=this._bitField;if(!((117506048&e)>>>16))return this._setRejected(),this._fulfillmentHandler0=t,this._isFinal()?j.fatalError(t,f.isNode):void((65535&e)>0?j.settlePromises(this):this._ensurePossibleRejectionHandled())},i.prototype._fulfillPromises=function(t,e){for(var n=1;t>n;n++){var r=this._fulfillmentHandlerAt(n),i=this._promiseAt(n),o=this._receiverAt(n);this._clearCallbackDataAtIndex(n),this._settlePromise(i,r,o,e)}},i.prototype._rejectPromises=function(t,e){for(var n=1;t>n;n++){var r=this._rejectionHandlerAt(n),i=this._promiseAt(n),o=this._receiverAt(n);this._clearCallbackDataAtIndex(n),this._settlePromise(i,r,o,e)}},i.prototype._settlePromises=function(){var t=this._bitField,e=65535&t;if(e>0){if(0!==(16842752&t)){var n=this._fulfillmentHandler0;this._settlePromise0(this._rejectionHandler0,n,t),this._rejectPromises(e,n)}else{var r=this._rejectionHandler0;this._settlePromise0(this._fulfillmentHandler0,r,t),this._fulfillPromises(e,r)}this._setLength(0)}this._clearCancellationData()},i.prototype._settledValue=function(){var t=this._bitField;return 0!==(33554432&t)?this._rejectionHandler0:0!==(16777216&t)?this._fulfillmentHandler0:void 0},"undefined"!=typeof Symbol&&Symbol.toStringTag&&w.defineProperty(i.prototype,Symbol.toStringTag,{get:function(){return"Object"}}),i.defer=i.pending=function(){V.deprecated("Promise.defer","new Promise");var t=new i(x);return{promise:t,resolve:o,reject:s}},f.notEnumerableProp(i,"_makeSelfResolutionError",c),t("./method")(i,x,R,l,V),t("./bind")(i,x,R,V),t("./cancel")(i,S,l,V),t("./direct_resolve")(i),t("./synchronous_inspection")(i),t("./join")(i,S,R,x,j),i.Promise=i,i.version="3.7.2",t("./call_get.js")(i),t("./generators.js")(i,l,x,R,n,V),t("./map.js")(i,S,l,R,x,V),t("./nodeify.js")(i),t("./promisify.js")(i,x),t("./props.js")(i,S,R,l),t("./race.js")(i,x,R,l),t("./reduce.js")(i,S,l,R,x,V),t("./settle.js")(i,S,V),t("./some.js")(i,S,l),t("./timers.js")(i,x,V),t("./using.js")(i,l,R,A,x,V),t("./any.js")(i),t("./each.js")(i,x),t("./filter.js")(i,x),f.toFastProperties(i),f.toFastProperties(i.prototype),a({a:1}),a({b:2}),a({c:3}),a(1),a(function(){}),a(void 0),a(!1),a(new i(x)),V.setBounds(C.firstLineError,f.lastLineError),i}},{"./any.js":1,"./async":2,"./bind":3,"./call_get.js":5,"./cancel":6,"./catch_filter":7,"./context":8,"./debuggability":9,"./direct_resolve":10,"./each.js":11,"./errors":12,"./es5":13,"./filter.js":14,"./finally":15,"./generators.js":16,"./join":17,"./map.js":18,"./method":19,"./nodeback":20,"./nodeify.js":21,"./promise_array":23,"./promisify.js":24,"./props.js":25,"./race.js":27,"./reduce.js":28,"./settle.js":30,"./some.js":31,"./synchronous_inspection":32,"./thenables":33,"./timers.js":34,"./using.js":35,"./util":36,async_hooks:void 0}],23:[function(t,e,n){"use strict";e.exports=function(e,n,r,i,o){function s(t){switch(t){case-2:return[];case-3:return{};case-6:return new Map}}function a(t){var r=this._promise=new e(n);t instanceof e&&(r._propagateFrom(t,3),t.suppressUnhandledRejections()),r._setOnCancel(this),this._values=t,this._length=0,this._totalResolved=0,this._init(void 0,-2)}var c=t("./util");c.isArray;return c.inherits(a,o),a.prototype.length=function(){return this._length},a.prototype.promise=function(){return this._promise},a.prototype._init=function u(t,n){var o=r(this._values,this._promise);if(o instanceof e){o=o._target();var a=o._bitField;if(this._values=o,0===(50397184&a))return this._promise._setAsyncGuaranteed(),o._then(u,this._reject,void 0,this,n);if(0===(33554432&a))return 0!==(16777216&a)?this._reject(o._reason()):this._cancel();o=o._value()}if(o=c.asArray(o),null===o){var l=i("expecting an array or an iterable object but got "+c.classString(o)).reason();return void this._promise._rejectCallback(l,!1)}return 0===o.length?void(-5===n?this._resolveEmptyArray():this._resolve(s(n))):void this._iterate(o)},a.prototype._iterate=function(t){var n=this.getActualLength(t.length);this._length=n,this._values=this.shouldCopyValues()?new Array(n):this._values;for(var i=this._promise,o=!1,s=null,a=0;n>a;++a){var c=r(t[a],i);c instanceof e?(c=c._target(),s=c._bitField):s=null,o?null!==s&&c.suppressUnhandledRejections():null!==s?0===(50397184&s)?(c._proxy(this,a),this._values[a]=c):o=0!==(33554432&s)?this._promiseFulfilled(c._value(),a):0!==(16777216&s)?this._promiseRejected(c._reason(),a):this._promiseCancelled(a):o=this._promiseFulfilled(c,a)}o||i._setAsyncGuaranteed()},a.prototype._isResolved=function(){return null===this._values},a.prototype._resolve=function(t){this._values=null,this._promise._fulfill(t)},a.prototype._cancel=function(){!this._isResolved()&&this._promise._isCancellable()&&(this._values=null,this._promise._cancel())},a.prototype._reject=function(t){this._values=null,this._promise._rejectCallback(t,!1)},a.prototype._promiseFulfilled=function(t,e){this._values[e]=t;var n=++this._totalResolved;return n>=this._length?(this._resolve(this._values),!0):!1},a.prototype._promiseCancelled=function(){return this._cancel(),!0},a.prototype._promiseRejected=function(t){return this._totalResolved++,this._reject(t),!0},a.prototype._resultCancelled=function(){if(!this._isResolved()){var t=this._values;if(this._cancel(),t instanceof e)t.cancel();else for(var n=0;n<t.length;++n)t[n]instanceof e&&t[n].cancel()}},a.prototype.shouldCopyValues=function(){return!0},a.prototype.getActualLength=function(t){return t},a}},{"./util":36}],24:[function(t,e,n){"use strict";e.exports=function(e,n){function r(t){return!C.test(t)}function i(t){try{return t.__isPromisified__===!0}catch(e){return!1}}function o(t,e,n){var r=h.getDataPropertyOrDefault(t,e+n,b);return r?i(r):!1}function s(t,e,n){for(var r=0;r<t.length;r+=2){var i=t[r];if(n.test(i))for(var o=i.replace(n,""),s=0;s<t.length;s+=2)if(t[s]===o)throw new g("Cannot promisify an API that has normal methods with '%s'-suffix\n\n    See http://goo.gl/MqrFmX\n".replace("%s",e))}}function a(t,e,n,r){for(var a=h.inheritedDataKeys(t),c=[],u=0;u<a.length;++u){var l=a[u],p=t[l],f=r===j?!0:j(l,p,t);"function"!=typeof p||i(p)||o(t,l,e)||!r(l,p,t,f)||c.push(l,p)}return s(c,e,n),c}function c(t,r,i,o,s,a){function c(){var i=r;r===f&&(i=this);var o=new e(n);o._captureStackTrace();var s="string"==typeof l&&this!==u?this[l]:t,c=_(o,a);try{s.apply(i,d(arguments,c))}catch(p){o._rejectCallback(v(p),!0,!0)}return o._isFateSealed()||o._setAsyncGuaranteed(),o}var u=function(){return this}(),l=t;return"string"==typeof l&&(t=o),h.notEnumerableProp(c,"__isPromisified__",!0),c}function u(t,e,n,r,i){for(var o=new RegExp(k(e)+"$"),s=a(t,e,o,n),c=0,u=s.length;u>c;c+=2){var l=s[c],p=s[c+1],_=l+e;if(r===E)t[_]=E(l,f,l,p,e,i);else{var d=r(p,function(){return E(l,f,l,p,e,i)});h.notEnumerableProp(d,"__isPromisified__",!0),t[_]=d}}return h.toFastProperties(t),t}function l(t,e,n){return E(t,e,void 0,t,null,n)}var p,f={},h=t("./util"),_=t("./nodeback"),d=h.withAppended,v=h.maybeWrapAsError,y=h.canEvaluate,g=t("./errors").TypeError,m="Async",b={__isPromisified__:!0},w=["arity","length","name","arguments","caller","callee","prototype","__isPromisified__"],C=new RegExp("^(?:"+w.join("|")+")$"),j=function(t){return h.isIdentifier(t)&&"_"!==t.charAt(0)&&"constructor"!==t},k=function(t){return t.replace(/([$])/,"\\$")},E=y?p:c;e.promisify=function(t,e){if("function"!=typeof t)throw new g("expecting a function but got "+h.classString(t));if(i(t))return t;e=Object(e);var n=void 0===e.context?f:e.context,o=!!e.multiArgs,s=l(t,n,o);return h.copyDescriptors(t,s,r),s},e.promisifyAll=function(t,e){if("function"!=typeof t&&"object"!=typeof t)throw new g("the target of promisifyAll must be an object or a function\n\n    See http://goo.gl/MqrFmX\n");e=Object(e);var n=!!e.multiArgs,r=e.suffix;"string"!=typeof r&&(r=m);var i=e.filter;"function"!=typeof i&&(i=j);var o=e.promisifier;if("function"!=typeof o&&(o=E),!h.isIdentifier(r))throw new RangeError("suffix must be a valid identifier\n\n    See http://goo.gl/MqrFmX\n");for(var s=h.inheritedDataKeys(t),a=0;a<s.length;++a){var c=t[s[a]];"constructor"!==s[a]&&h.isClass(c)&&(u(c.prototype,r,i,o,n),u(c,r,i,o,n))}return u(t,r,i,o,n)}}},{"./errors":12,"./nodeback":20,"./util":36}],25:[function(t,e,n){"use strict";e.exports=function(e,n,r,i){function o(t){var e,n=!1;if(void 0!==a&&t instanceof a)e=p(t),n=!0;else{var r=l.keys(t),i=r.length;e=new Array(2*i);for(var o=0;i>o;++o){var s=r[o];e[o]=t[s],e[o+i]=s}}this.constructor$(e),this._isMap=n,this._init$(void 0,n?-6:-3)}function s(t){var n,s=r(t);return u(s)?(n=s instanceof e?s._then(e.props,void 0,void 0,void 0,void 0):new o(s).promise(),s instanceof e&&n._propagateFrom(s,2),n):i("cannot await properties of a non-object\n\n    See http://goo.gl/MqrFmX\n")}var a,c=t("./util"),u=c.isObject,l=t("./es5");"function"==typeof Map&&(a=Map);var p=function(){function t(t,r){this[e]=t,this[e+n]=r,e++}var e=0,n=0;return function(r){n=r.size,e=0;var i=new Array(2*r.size);return r.forEach(t,i),i}}(),f=function(t){for(var e=new a,n=t.length/2|0,r=0;n>r;++r){var i=t[n+r],o=t[r];e.set(i,o)}return e};c.inherits(o,n),o.prototype._init=function(){},o.prototype._promiseFulfilled=function(t,e){this._values[e]=t;var n=++this._totalResolved;if(n>=this._length){var r;if(this._isMap)r=f(this._values);else{r={};for(var i=this.length(),o=0,s=this.length();s>o;++o)r[this._values[o+i]]=this._values[o]}return this._resolve(r),!0}return!1},o.prototype.shouldCopyValues=function(){return!1},o.prototype.getActualLength=function(t){return t>>1},e.prototype.props=function(){return s(this)},e.props=function(t){return s(t)}}},{"./es5":13,"./util":36}],26:[function(t,e,n){"use strict";function r(t,e,n,r,i){for(var o=0;i>o;++o)n[o+r]=t[o+e],t[o+e]=void 0}function i(t){this._capacity=t,this._length=0,this._front=0}i.prototype._willBeOverCapacity=function(t){return this._capacity<t},i.prototype._pushOne=function(t){var e=this.length();this._checkCapacity(e+1);var n=this._front+e&this._capacity-1;this[n]=t,this._length=e+1},i.prototype.push=function(t,e,n){var r=this.length()+3;if(this._willBeOverCapacity(r))return this._pushOne(t),this._pushOne(e),void this._pushOne(n);var i=this._front+r-3;this._checkCapacity(r);var o=this._capacity-1;this[i+0&o]=t,this[i+1&o]=e,this[i+2&o]=n,this._length=r},i.prototype.shift=function(){var t=this._front,e=this[t];return this[t]=void 0,this._front=t+1&this._capacity-1,this._length--,e},i.prototype.length=function(){return this._length},i.prototype._checkCapacity=function(t){this._capacity<t&&this._resizeTo(this._capacity<<1)},i.prototype._resizeTo=function(t){var e=this._capacity;this._capacity=t;var n=this._front,i=this._length,o=n+i&e-1;r(this,0,this,e,o)},e.exports=i},{}],27:[function(t,e,n){"use strict";e.exports=function(e,n,r,i){function o(t,o){var c=r(t);if(c instanceof e)return a(c);if(t=s.asArray(t),null===t)return i("expecting an array or an iterable object but got "+s.classString(t));var u=new e(n);void 0!==o&&u._propagateFrom(o,3);for(var l=u._fulfill,p=u._reject,f=0,h=t.length;h>f;++f){var _=t[f];(void 0!==_||f in t)&&e.cast(_)._then(l,p,void 0,u,null)}return u}var s=t("./util"),a=function(t){return t.then(function(e){return o(e,t)})};e.race=function(t){return o(t,void 0)},e.prototype.race=function(){return o(this,void 0)}}},{"./util":36}],28:[function(t,e,n){"use strict";e.exports=function(e,n,r,i,o,s){function a(t,n,r,i){this.constructor$(t);var s=e._getContext();this._fn=f.contextBind(s,n),void 0!==r&&(r=e.resolve(r),r._attachCancellationCallback(this)),this._initialValue=r,this._currentCancellable=null,i===o?this._eachValues=Array(this._length):0===i?this._eachValues=null:this._eachValues=void 0,this._promise._captureStackTrace(),this._init$(void 0,-5)}function c(t,e){this.isFulfilled()?e._resolve(t):e._reject(t)}function u(t,e,n,i){if("function"!=typeof e)return r("expecting a function but got "+f.classString(e));var o=new a(t,e,n,i);return o.promise()}function l(t){this.accum=t,this.array._gotAccum(t);var n=i(this.value,this.array._promise);return n instanceof e?(this.array._currentCancellable=n,n._then(p,void 0,void 0,this,void 0)):p.call(this,n)}function p(t){var n=this.array,r=n._promise,i=h(n._fn);r._pushContext();var o;o=void 0!==n._eachValues?i.call(r._boundValue(),t,this.index,this.length):i.call(r._boundValue(),this.accum,t,this.index,this.length),o instanceof e&&(n._currentCancellable=o);var a=r._popContext();return s.checkForgottenReturns(o,a,void 0!==n._eachValues?"Promise.each":"Promise.reduce",r),o}var f=t("./util"),h=f.tryCatch;f.inherits(a,n),a.prototype._gotAccum=function(t){void 0!==this._eachValues&&null!==this._eachValues&&t!==o&&this._eachValues.push(t)},a.prototype._eachComplete=function(t){return null!==this._eachValues&&this._eachValues.push(t),this._eachValues},a.prototype._init=function(){},a.prototype._resolveEmptyArray=function(){this._resolve(void 0!==this._eachValues?this._eachValues:this._initialValue)},a.prototype.shouldCopyValues=function(){return!1},a.prototype._resolve=function(t){this._promise._resolveCallback(t),this._values=null},a.prototype._resultCancelled=function(t){return t===this._initialValue?this._cancel():void(this._isResolved()||(this._resultCancelled$(),this._currentCancellable instanceof e&&this._currentCancellable.cancel(),this._initialValue instanceof e&&this._initialValue.cancel()))},a.prototype._iterate=function(t){this._values=t;var n,r,i=t.length;void 0!==this._initialValue?(n=this._initialValue,r=0):(n=e.resolve(t[0]),r=1),this._currentCancellable=n;for(var o=r;i>o;++o){var s=t[o];s instanceof e&&s.suppressUnhandledRejections()}if(!n.isRejected())for(;i>r;++r){var a={accum:null,value:t[r],index:r,length:i,array:this};n=n._then(l,void 0,void 0,a,void 0),0===(127&r)&&n._setNoAsyncGuarantee()}void 0!==this._eachValues&&(n=n._then(this._eachComplete,void 0,void 0,this,void 0)),n._then(c,c,void 0,n,this)},e.prototype.reduce=function(t,e){return u(this,t,e,null)},e.reduce=function(t,e,n,r){return u(t,e,n,r)}}},{"./util":36}],29:[function(t,e,n){"use strict";var r,i=t("./util"),o=function(){throw new Error("No async scheduler available\n\n    See http://goo.gl/MqrFmX\n")},s=i.getNativePromise();if(i.isNode&&"undefined"==typeof MutationObserver){var a=global.setImmediate,c=process.nextTick;r=i.isRecentNode?function(t){a.call(global,t)}:function(t){c.call(process,t)}}else if("function"==typeof s&&"function"==typeof s.resolve){
var u=s.resolve();r=function(t){u.then(t)}}else r="undefined"!=typeof MutationObserver&&("undefined"==typeof window||!window.navigator||!window.navigator.standalone&&!window.cordova)&&"classList"in document.documentElement?function(){var t=document.createElement("div"),e={attributes:!0},n=!1,r=document.createElement("div"),i=new MutationObserver(function(){t.classList.toggle("foo"),n=!1});i.observe(r,e);var o=function(){n||(n=!0,r.classList.toggle("foo"))};return function(n){var r=new MutationObserver(function(){r.disconnect(),n()});r.observe(t,e),o()}}():"undefined"!=typeof setImmediate?function(t){setImmediate(t)}:"undefined"!=typeof setTimeout?function(t){setTimeout(t,0)}:o;e.exports=r},{"./util":36}],30:[function(t,e,n){"use strict";e.exports=function(e,n,r){function i(t){this.constructor$(t)}var o=e.PromiseInspection,s=t("./util");s.inherits(i,n),i.prototype._promiseResolved=function(t,e){this._values[t]=e;var n=++this._totalResolved;return n>=this._length?(this._resolve(this._values),!0):!1},i.prototype._promiseFulfilled=function(t,e){var n=new o;return n._bitField=33554432,n._settledValueField=t,this._promiseResolved(e,n)},i.prototype._promiseRejected=function(t,e){var n=new o;return n._bitField=16777216,n._settledValueField=t,this._promiseResolved(e,n)},e.settle=function(t){return r.deprecated(".settle()",".reflect()"),new i(t).promise()},e.allSettled=function(t){return new i(t).promise()},e.prototype.settle=function(){return e.settle(this)}}},{"./util":36}],31:[function(t,e,n){"use strict";e.exports=function(e,n,r){function i(t){this.constructor$(t),this._howMany=0,this._unwrap=!1,this._initialized=!1}function o(t,e){if((0|e)!==e||0>e)return r("expecting a positive integer\n\n    See http://goo.gl/MqrFmX\n");var n=new i(t),o=n.promise();return n.setHowMany(e),n.init(),o}var s=t("./util"),a=t("./errors").RangeError,c=t("./errors").AggregateError,u=s.isArray,l={};s.inherits(i,n),i.prototype._init=function(){if(this._initialized){if(0===this._howMany)return void this._resolve([]);this._init$(void 0,-5);var t=u(this._values);!this._isResolved()&&t&&this._howMany>this._canPossiblyFulfill()&&this._reject(this._getRangeError(this.length()))}},i.prototype.init=function(){this._initialized=!0,this._init()},i.prototype.setUnwrap=function(){this._unwrap=!0},i.prototype.howMany=function(){return this._howMany},i.prototype.setHowMany=function(t){this._howMany=t},i.prototype._promiseFulfilled=function(t){return this._addFulfilled(t),this._fulfilled()===this.howMany()?(this._values.length=this.howMany(),1===this.howMany()&&this._unwrap?this._resolve(this._values[0]):this._resolve(this._values),!0):!1},i.prototype._promiseRejected=function(t){return this._addRejected(t),this._checkOutcome()},i.prototype._promiseCancelled=function(){return this._values instanceof e||null==this._values?this._cancel():(this._addRejected(l),this._checkOutcome())},i.prototype._checkOutcome=function(){if(this.howMany()>this._canPossiblyFulfill()){for(var t=new c,e=this.length();e<this._values.length;++e)this._values[e]!==l&&t.push(this._values[e]);return t.length>0?this._reject(t):this._cancel(),!0}return!1},i.prototype._fulfilled=function(){return this._totalResolved},i.prototype._rejected=function(){return this._values.length-this.length()},i.prototype._addRejected=function(t){this._values.push(t)},i.prototype._addFulfilled=function(t){this._values[this._totalResolved++]=t},i.prototype._canPossiblyFulfill=function(){return this.length()-this._rejected()},i.prototype._getRangeError=function(t){var e="Input array must contain at least "+this._howMany+" items but contains only "+t+" items";return new a(e)},i.prototype._resolveEmptyArray=function(){this._reject(this._getRangeError(0))},e.some=function(t,e){return o(t,e)},e.prototype.some=function(t){return o(this,t)},e._SomePromiseArray=i}},{"./errors":12,"./util":36}],32:[function(t,e,n){"use strict";e.exports=function(t){function e(t){void 0!==t?(t=t._target(),this._bitField=t._bitField,this._settledValueField=t._isFateSealed()?t._settledValue():void 0):(this._bitField=0,this._settledValueField=void 0)}e.prototype._settledValue=function(){return this._settledValueField};var n=e.prototype.value=function(){if(!this.isFulfilled())throw new TypeError("cannot get fulfillment value of a non-fulfilled promise\n\n    See http://goo.gl/MqrFmX\n");return this._settledValue()},r=e.prototype.error=e.prototype.reason=function(){if(!this.isRejected())throw new TypeError("cannot get rejection reason of a non-rejected promise\n\n    See http://goo.gl/MqrFmX\n");return this._settledValue()},i=e.prototype.isFulfilled=function(){return 0!==(33554432&this._bitField)},o=e.prototype.isRejected=function(){return 0!==(16777216&this._bitField)},s=e.prototype.isPending=function(){return 0===(50397184&this._bitField)},a=e.prototype.isResolved=function(){return 0!==(50331648&this._bitField)};e.prototype.isCancelled=function(){return 0!==(8454144&this._bitField)},t.prototype.__isCancelled=function(){return 65536===(65536&this._bitField)},t.prototype._isCancelled=function(){return this._target().__isCancelled()},t.prototype.isCancelled=function(){return 0!==(8454144&this._target()._bitField)},t.prototype.isPending=function(){return s.call(this._target())},t.prototype.isRejected=function(){return o.call(this._target())},t.prototype.isFulfilled=function(){return i.call(this._target())},t.prototype.isResolved=function(){return a.call(this._target())},t.prototype.value=function(){return n.call(this._target())},t.prototype.reason=function(){var t=this._target();return t._unsetRejectionIsUnhandled(),r.call(t)},t.prototype._value=function(){return this._settledValue()},t.prototype._reason=function(){return this._unsetRejectionIsUnhandled(),this._settledValue()},t.PromiseInspection=e}},{}],33:[function(t,e,n){"use strict";e.exports=function(e,n){function r(t,r){if(l(t)){if(t instanceof e)return t;var i=o(t);if(i===u){r&&r._pushContext();var c=e.reject(i.e);return r&&r._popContext(),c}if("function"==typeof i){if(s(t)){var c=new e(n);return t._then(c._fulfill,c._reject,void 0,c,null),c}return a(t,i,r)}}return t}function i(t){return t.then}function o(t){try{return i(t)}catch(e){return u.e=e,u}}function s(t){try{return p.call(t,"_promise0")}catch(e){return!1}}function a(t,r,i){function o(t){a&&(a._resolveCallback(t),a=null)}function s(t){a&&(a._rejectCallback(t,p,!0),a=null)}var a=new e(n),l=a;i&&i._pushContext(),a._captureStackTrace(),i&&i._popContext();var p=!0,f=c.tryCatch(r).call(t,o,s);return p=!1,a&&f===u&&(a._rejectCallback(f.e,!0,!0),a=null),l}var c=t("./util"),u=c.errorObj,l=c.isObject,p={}.hasOwnProperty;return r}},{"./util":36}],34:[function(t,e,n){"use strict";e.exports=function(e,n,r){function i(t){this.handle=t}function o(t){return clearTimeout(this.handle),t}function s(t){throw clearTimeout(this.handle),t}var a=t("./util"),c=e.TimeoutError;i.prototype._resultCancelled=function(){clearTimeout(this.handle)};var u=function(t){return l(+this).thenReturn(t)},l=e.delay=function(t,o){var s,a;return void 0!==o?(s=e.resolve(o)._then(u,null,null,t,void 0),r.cancellation()&&o instanceof e&&s._setOnCancel(o)):(s=new e(n),a=setTimeout(function(){s._fulfill()},+t),r.cancellation()&&s._setOnCancel(new i(a)),s._captureStackTrace()),s._setAsyncGuaranteed(),s};e.prototype.delay=function(t){return l(t,this)};var p=function(t,e,n){var r;r="string"!=typeof e?e instanceof Error?e:new c("operation timed out"):new c(e),a.markAsOriginatingFromRejection(r),t._attachExtraTrace(r),t._reject(r),null!=n&&n.cancel()};e.prototype.timeout=function(t,e){t=+t;var n,a,c=new i(setTimeout(function(){n.isPending()&&p(n,e,a)},t));return r.cancellation()?(a=this.then(),n=a._then(o,s,void 0,c,void 0),n._setOnCancel(c)):n=this._then(o,s,void 0,c,void 0),n}}},{"./util":36}],35:[function(t,e,n){"use strict";e.exports=function(e,n,r,i,o,s){function a(t){setTimeout(function(){throw t},0)}function c(t){var e=r(t);return e!==t&&"function"==typeof t._isDisposable&&"function"==typeof t._getDisposer&&t._isDisposable()&&e._setDisposable(t._getDisposer()),e}function u(t,n){function i(){if(s>=u)return l._fulfill();var o=c(t[s++]);if(o instanceof e&&o._isDisposable()){try{o=r(o._getDisposer().tryDispose(n),t.promise)}catch(p){return a(p)}if(o instanceof e)return o._then(i,a,null,null,null)}i()}var s=0,u=t.length,l=new e(o);return i(),l}function l(t,e,n){this._data=t,this._promise=e,this._context=n}function p(t,e,n){this.constructor$(t,e,n)}function f(t){return l.isDisposer(t)?(this.resources[this.index]._setDisposable(t),t.promise()):t}function h(t){this.length=t,this.promise=null,this[t-1]=null}var _=t("./util"),d=t("./errors").TypeError,v=t("./util").inherits,y=_.errorObj,g=_.tryCatch,m={};l.prototype.data=function(){return this._data},l.prototype.promise=function(){return this._promise},l.prototype.resource=function(){return this.promise().isFulfilled()?this.promise().value():m},l.prototype.tryDispose=function(t){var e=this.resource(),n=this._context;void 0!==n&&n._pushContext();var r=e!==m?this.doDispose(e,t):null;return void 0!==n&&n._popContext(),this._promise._unsetDisposable(),this._data=null,r},l.isDisposer=function(t){return null!=t&&"function"==typeof t.resource&&"function"==typeof t.tryDispose},v(p,l),p.prototype.doDispose=function(t,e){var n=this.data();return n.call(t,t,e)},h.prototype._resultCancelled=function(){for(var t=this.length,n=0;t>n;++n){var r=this[n];r instanceof e&&r.cancel()}},e.using=function(){var t=arguments.length;if(2>t)return n("you must pass at least 2 arguments to Promise.using");var i=arguments[t-1];if("function"!=typeof i)return n("expecting a function but got "+_.classString(i));var o,a=!0;2===t&&Array.isArray(arguments[0])?(o=arguments[0],t=o.length,a=!1):(o=arguments,t--);for(var c=new h(t),p=0;t>p;++p){var d=o[p];if(l.isDisposer(d)){var v=d;d=d.promise(),d._setDisposable(v)}else{var m=r(d);m instanceof e&&(d=m._then(f,null,null,{resources:c,index:p},void 0))}c[p]=d}for(var b=new Array(c.length),p=0;p<b.length;++p)b[p]=e.resolve(c[p]).reflect();var w=e.all(b).then(function(t){for(var e=0;e<t.length;++e){var n=t[e];if(n.isRejected())return y.e=n.error(),y;if(!n.isFulfilled())return void w.cancel();t[e]=n.value()}C._pushContext(),i=g(i);var r=a?i.apply(void 0,t):i(t),o=C._popContext();return s.checkForgottenReturns(r,o,"Promise.using",C),r}),C=w.lastly(function(){var t=new e.PromiseInspection(w);return u(c,t)});return c.promise=C,C._setOnCancel(c),C},e.prototype._setDisposable=function(t){this._bitField=131072|this._bitField,this._disposer=t},e.prototype._isDisposable=function(){return(131072&this._bitField)>0},e.prototype._getDisposer=function(){return this._disposer},e.prototype._unsetDisposable=function(){this._bitField=-131073&this._bitField,this._disposer=void 0},e.prototype.disposer=function(t){if("function"==typeof t)return new p(t,this,i());throw new d}}},{"./errors":12,"./util":36}],36:[function(t,e,n){"use strict";function r(){try{var t=P;return P=null,t.apply(this,arguments)}catch(e){return T.e=e,T}}function i(t){return P=t,r}function o(t){return null==t||t===!0||t===!1||"string"==typeof t||"number"==typeof t}function s(t){return"function"==typeof t||"object"==typeof t&&null!==t}function a(t){return o(t)?new Error(v(t)):t}function c(t,e){var n,r=t.length,i=new Array(r+1);for(n=0;r>n;++n)i[n]=t[n];return i[n]=e,i}function u(t,e,n){if(!F.isES5)return{}.hasOwnProperty.call(t,e)?t[e]:void 0;var r=Object.getOwnPropertyDescriptor(t,e);return null!=r?null==r.get&&null==r.set?r.value:n:void 0}function l(t,e,n){if(o(t))return t;var r={value:n,configurable:!0,enumerable:!1,writable:!0};return F.defineProperty(t,e,r),t}function p(t){throw t}function f(t){try{if("function"==typeof t){var e=F.names(t.prototype),n=F.isES5&&e.length>1,r=e.length>0&&!(1===e.length&&"constructor"===e[0]),i=A.test(t+"")&&F.names(t).length>0;if(n||r||i)return!0}return!1}catch(o){return!1}}function h(t){function e(){}function n(){return typeof r.foo}e.prototype=t;var r=new e;return n(),n(),t}function _(t){return V.test(t)}function d(t,e,n){for(var r=new Array(t),i=0;t>i;++i)r[i]=e+i+n;return r}function v(t){try{return t+""}catch(e){return"[no string representation]"}}function y(t){return t instanceof Error||null!==t&&"object"==typeof t&&"string"==typeof t.message&&"string"==typeof t.name}function g(t){try{l(t,"isOperational",!0)}catch(e){}}function m(t){return null==t?!1:t instanceof Error.__BluebirdErrorTypes__.OperationalError||t.isOperational===!0}function b(t){return y(t)&&F.propertyIsWritable(t,"stack")}function w(t){return{}.toString.call(t)}function C(t,e,n){for(var r=F.names(t),i=0;i<r.length;++i){var o=r[i];if(n(o))try{F.defineProperty(e,o,F.getDescriptor(t,o))}catch(s){}}}function j(t){return N?process.env[t]:void 0}function k(){if("function"==typeof Promise)try{var t=new Promise(function(){});if("[object Promise]"===w(t))return Promise}catch(e){}}function E(t,e){if(null===t||"function"!=typeof e||e===U)return e;null!==t.domain&&(e=t.domain.bind(e));var n=t.async;if(null!==n){var r=e;e=function(){var t=new Array(2).concat([].slice.call(arguments));return t[0]=r,t[1]=this,n.runInAsyncScope.apply(n,t)}}return e}var F=t("./es5"),x="undefined"==typeof navigator,T={e:{}},P,R="undefined"!=typeof self?self:"undefined"!=typeof window?window:"undefined"!=typeof global?global:void 0!==this?this:null,S=function(t,e){function n(){this.constructor=t,this.constructor$=e;for(var n in e.prototype)r.call(e.prototype,n)&&"$"!==n.charAt(n.length-1)&&(this[n+"$"]=e.prototype[n])}var r={}.hasOwnProperty;return n.prototype=e.prototype,t.prototype=new n,t.prototype},O=function(){var t=[Array.prototype,Object.prototype,Function.prototype],e=function(e){for(var n=0;n<t.length;++n)if(t[n]===e)return!0;return!1};if(F.isES5){var n=Object.getOwnPropertyNames;return function(t){for(var r=[],i=Object.create(null);null!=t&&!e(t);){var o;try{o=n(t)}catch(s){return r}for(var a=0;a<o.length;++a){var c=o[a];if(!i[c]){i[c]=!0;var u=Object.getOwnPropertyDescriptor(t,c);null!=u&&null==u.get&&null==u.set&&r.push(c)}}t=F.getPrototypeOf(t)}return r}}var r={}.hasOwnProperty;return function(n){if(e(n))return[];var i=[];t:for(var o in n)if(r.call(n,o))i.push(o);else{for(var s=0;s<t.length;++s)if(r.call(t[s],o))continue t;i.push(o)}return i}}(),A=/this\s*\.\s*\S+\s*=/,V=/^[a-z$_][a-z$_0-9]*$/i,H=function(){return"stack"in new Error?function(t){return b(t)?t:new Error(v(t))}:function(t){if(b(t))return t;try{throw new Error(v(t))}catch(e){return e}}}(),D=function(t){return F.isArray(t)?t:null};if("undefined"!=typeof Symbol&&Symbol.iterator){var I="function"==typeof Array.from?function(t){return Array.from(t)}:function(t){for(var e,n=[],r=t[Symbol.iterator]();!(e=r.next()).done;)n.push(e.value);return n};D=function(t){return F.isArray(t)?t:null!=t&&"function"==typeof t[Symbol.iterator]?I(t):null}}var L="undefined"!=typeof process&&"[object process]"===w(process).toLowerCase(),N="undefined"!=typeof process&&"undefined"!=typeof process.env,U,B={setReflectHandler:function(t){U=t},isClass:f,isIdentifier:_,inheritedDataKeys:O,getDataPropertyOrDefault:u,thrower:p,isArray:F.isArray,asArray:D,notEnumerableProp:l,isPrimitive:o,isObject:s,isError:y,canEvaluate:x,errorObj:T,tryCatch:i,inherits:S,withAppended:c,maybeWrapAsError:a,toFastProperties:h,filledRange:d,toString:v,canAttachTrace:b,ensureErrorObject:H,originatesFromRejection:m,markAsOriginatingFromRejection:g,classString:w,copyDescriptors:C,isNode:L,hasEnvVariables:N,env:j,global:R,getNativePromise:k,contextBind:E};B.isRecentNode=B.isNode&&function(){var t;return process.versions&&process.versions.node?t=process.versions.node.split(".").map(Number):process.version&&(t=process.version.split(".").map(Number)),0===t[0]&&t[1]>10||t[0]>0}(),B.nodeSupportsAsyncResource=B.isNode&&function(){var e=!1;try{var n=t("async_hooks").AsyncResource;e="function"==typeof n.prototype.runInAsyncScope}catch(r){e=!1}return e}(),B.isNode&&B.toFastProperties(process);try{throw new Error}catch(M){B.lastLineError=M}e.exports=B},{"./es5":13,async_hooks:void 0}]},{},[4])(4)}),"undefined"!=typeof window&&null!==window?window.P=window.Promise:"undefined"!=typeof self&&null!==self&&(self.P=self.Promise);
TP.boot.$$srcPath = '';

        
        Promise[TP.NAME] = 'Promise';
        TP.registerExternalObject('Promise', window.Promise);
        TP.extern.Promise.construct = function(resolver, rejector) {
            return new Promise(resolver, rejector);
        };
        
    
TP.boot.$$srcPath = '~lib_deps/moment-tpi.min.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):e.moment=t()}(this,function(){"use strict";var e,i;function f(){return e.apply(null,arguments)}function o(e){return e instanceof Array||"[object Array]"===Object.prototype.toString.call(e)}function u(e){return null!=e&&"[object Object]"===Object.prototype.toString.call(e)}function m(e,t){return Object.prototype.hasOwnProperty.call(e,t)}function l(e){if(Object.getOwnPropertyNames)return 0===Object.getOwnPropertyNames(e).length;for(var t in e)if(m(e,t))return;return 1}function r(e){return void 0===e}function h(e){return"number"==typeof e||"[object Number]"===Object.prototype.toString.call(e)}function a(e){return e instanceof Date||"[object Date]"===Object.prototype.toString.call(e)}function d(e,t){for(var n=[],s=0;s<e.length;++s)n.push(t(e[s],s));return n}function c(e,t){for(var n in t)m(t,n)&&(e[n]=t[n]);return m(t,"toString")&&(e.toString=t.toString),m(t,"valueOf")&&(e.valueOf=t.valueOf),e}function _(e,t,n,s){return xt(e,t,n,s,!0).utc()}function y(e){return null==e._pf&&(e._pf={empty:!1,unusedTokens:[],unusedInput:[],overflow:-2,charsLeftOver:0,nullInput:!1,invalidEra:null,invalidMonth:null,invalidFormat:!1,userInvalidated:!1,iso:!1,parsedDateParts:[],era:null,meridiem:null,rfc2822:!1,weekdayMismatch:!1}),e._pf}function g(e){if(null==e._isValid){var t=y(e),n=i.call(t.parsedDateParts,function(e){return null!=e}),s=!isNaN(e._d.getTime())&&t.overflow<0&&!t.empty&&!t.invalidEra&&!t.invalidMonth&&!t.invalidWeekday&&!t.weekdayMismatch&&!t.nullInput&&!t.invalidFormat&&!t.userInvalidated&&(!t.meridiem||t.meridiem&&n);if(e._strict&&(s=s&&0===t.charsLeftOver&&0===t.unusedTokens.length&&void 0===t.bigHour),null!=Object.isFrozen&&Object.isFrozen(e))return s;e._isValid=s}return e._isValid}function w(e){var t=_(NaN);return null!=e?c(y(t),e):y(t).userInvalidated=!0,t}i=Array.prototype.some?Array.prototype.some:function(e){for(var t=Object(this),n=t.length>>>0,s=0;s<n;s++)if(s in t&&e.call(this,t[s],s,t))return!0;return!1};var p=f.momentProperties=[],t=!1;function v(e,t){var n,s,i;if(r(t._isAMomentObject)||(e._isAMomentObject=t._isAMomentObject),r(t._i)||(e._i=t._i),r(t._f)||(e._f=t._f),r(t._l)||(e._l=t._l),r(t._strict)||(e._strict=t._strict),r(t._tzm)||(e._tzm=t._tzm),r(t._isUTC)||(e._isUTC=t._isUTC),r(t._offset)||(e._offset=t._offset),r(t._pf)||(e._pf=y(t)),r(t._locale)||(e._locale=t._locale),0<p.length)for(n=0;n<p.length;n++)r(i=t[s=p[n]])||(e[s]=i);return e}function k(e){v(this,e),this._d=new Date(null!=e._d?e._d.getTime():NaN),this.isValid()||(this._d=new Date(NaN)),!1===t&&(t=!0,f.updateOffset(this),t=!1)}function M(e){return e instanceof k||null!=e&&null!=e._isAMomentObject}function D(e){!1===f.suppressDeprecationWarnings&&"undefined"!=typeof console&&console.warn&&console.warn("Deprecation warning: "+e)}function n(i,r){var a=!0;return c(function(){if(null!=f.deprecationHandler&&f.deprecationHandler(null,i),a){for(var e,t,n=[],s=0;s<arguments.length;s++){if(e="","object"==typeof arguments[s]){for(t in e+="\n["+s+"] ",arguments[0])m(arguments[0],t)&&(e+=t+": "+arguments[0][t]+", ");e=e.slice(0,-2)}else e=arguments[s];n.push(e)}D(i+"\nArguments: "+Array.prototype.slice.call(n).join("")+"\n"+(new Error).stack),a=!1}return r.apply(this,arguments)},r)}var s,S={};function Y(e,t){null!=f.deprecationHandler&&f.deprecationHandler(e,t),S[e]||(D(t),S[e]=!0)}function O(e){return"undefined"!=typeof Function&&e instanceof Function||"[object Function]"===Object.prototype.toString.call(e)}function b(e,t){var n,s=c({},e);for(n in t)m(t,n)&&(u(e[n])&&u(t[n])?(s[n]={},c(s[n],e[n]),c(s[n],t[n])):null!=t[n]?s[n]=t[n]:delete s[n]);for(n in e)m(e,n)&&!m(t,n)&&u(e[n])&&(s[n]=c({},s[n]));return s}function x(e){null!=e&&this.set(e)}f.suppressDeprecationWarnings=!1,f.deprecationHandler=null,s=Object.keys?Object.keys:function(e){var t,n=[];for(t in e)m(e,t)&&n.push(t);return n};function T(e,t,n){var s=""+Math.abs(e),i=t-s.length;return(0<=e?n?"+":"":"-")+Math.pow(10,Math.max(0,i)).toString().substr(1)+s}var N=/(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|N{1,5}|YYYYYY|YYYYY|YYYY|YY|y{2,4}|yo?|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,P=/(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g,R={},W={};function C(e,t,n,s){var i="string"==typeof s?function(){return this[s]()}:s;e&&(W[e]=i),t&&(W[t[0]]=function(){return T(i.apply(this,arguments),t[1],t[2])}),n&&(W[n]=function(){return this.localeData().ordinal(i.apply(this,arguments),e)})}function U(e,t){return e.isValid()?(t=H(t,e.localeData()),R[t]=R[t]||function(s){for(var e,i=s.match(N),t=0,r=i.length;t<r;t++)W[i[t]]?i[t]=W[i[t]]:i[t]=(e=i[t]).match(/\[[\s\S]/)?e.replace(/^\[|\]$/g,""):e.replace(/\\/g,"");return function(e){for(var t="",n=0;n<r;n++)t+=O(i[n])?i[n].call(e,s):i[n];return t}}(t),R[t](e)):e.localeData().invalidDate()}function H(e,t){var n=5;function s(e){return t.longDateFormat(e)||e}for(P.lastIndex=0;0<=n&&P.test(e);)e=e.replace(P,s),P.lastIndex=0,--n;return e}var F={};function L(e,t){var n=e.toLowerCase();F[n]=F[n+"s"]=F[t]=e}function V(e){return"string"==typeof e?F[e]||F[e.toLowerCase()]:void 0}function G(e){var t,n,s={};for(n in e)m(e,n)&&(t=V(n))&&(s[t]=e[n]);return s}var E={};function A(e,t){E[e]=t}function j(e){return e%4==0&&e%100!=0||e%400==0}function I(e){return e<0?Math.ceil(e)||0:Math.floor(e)}function Z(e){var t=+e,n=0;return 0!=t&&isFinite(t)&&(n=I(t)),n}function z(t,n){return function(e){return null!=e?(q(this,t,e),f.updateOffset(this,n),this):$(this,t)}}function $(e,t){return e.isValid()?e._d["get"+(e._isUTC?"UTC":"")+t]():NaN}function q(e,t,n){e.isValid()&&!isNaN(n)&&("FullYear"===t&&j(e.year())&&1===e.month()&&29===e.date()?(n=Z(n),e._d["set"+(e._isUTC?"UTC":"")+t](n,e.month(),xe(n,e.month()))):e._d["set"+(e._isUTC?"UTC":"")+t](n))}var B,J=/\d/,Q=/\d\d/,X=/\d{3}/,K=/\d{4}/,ee=/[+-]?\d{6}/,te=/\d\d?/,ne=/\d\d\d\d?/,se=/\d\d\d\d\d\d?/,ie=/\d{1,3}/,re=/\d{1,4}/,ae=/[+-]?\d{1,6}/,oe=/\d+/,ue=/[+-]?\d+/,le=/Z|[+-]\d\d:?\d\d/gi,he=/Z|[+-]\d\d(?::?\d\d)?/gi,de=/[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i;function ce(e,n,s){B[e]=O(n)?n:function(e,t){return e&&s?s:n}}function fe(e,t){return m(B,e)?B[e](t._strict,t._locale):new RegExp(me(e.replace("\\","").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,function(e,t,n,s,i){return t||n||s||i})))}function me(e){return e.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")}B={};var _e={};function ye(e,n){var t,s=n;for("string"==typeof e&&(e=[e]),h(n)&&(s=function(e,t){t[n]=Z(e)}),t=0;t<e.length;t++)_e[e[t]]=s}function ge(e,i){ye(e,function(e,t,n,s){n._w=n._w||{},i(e,n._w,n,s)})}var we,pe=0,ve=1,ke=2,Me=3,De=4,Se=5,Ye=6,Oe=7,be=8;function xe(e,t){if(isNaN(e)||isNaN(t))return NaN;var n,s=(t%(n=12)+n)%n;return e+=(t-s)/12,1==s?j(e)?29:28:31-s%7%2}we=Array.prototype.indexOf?Array.prototype.indexOf:function(e){for(var t=0;t<this.length;++t)if(this[t]===e)return t;return-1},C("M",["MM",2],"Mo",function(){return this.month()+1}),C("MMM",0,0,function(e){return this.localeData().monthsShort(this,e)}),C("MMMM",0,0,function(e){return this.localeData().months(this,e)}),L("month","M"),A("month",8),ce("M",te),ce("MM",te,Q),ce("MMM",function(e,t){return t.monthsShortRegex(e)}),ce("MMMM",function(e,t){return t.monthsRegex(e)}),ye(["M","MM"],function(e,t){t[ve]=Z(e)-1}),ye(["MMM","MMMM"],function(e,t,n,s){var i=n._locale.monthsParse(e,s,n._strict);null!=i?t[ve]=i:y(n).invalidMonth=e});var Te="January_February_March_April_May_June_July_August_September_October_November_December".split("_"),Ne="Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_"),Pe=/D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/,Re=de,We=de;function Ce(e,t){var n;if(!e.isValid())return e;if("string"==typeof t)if(/^\d+$/.test(t))t=Z(t);else if(!h(t=e.localeData().monthsParse(t)))return e;return n=Math.min(e.date(),xe(e.year(),t)),e._d["set"+(e._isUTC?"UTC":"")+"Month"](t,n),e}function Ue(e){return null!=e?(Ce(this,e),f.updateOffset(this,!0),this):$(this,"Month")}function He(){function e(e,t){return t.length-e.length}for(var t,n=[],s=[],i=[],r=0;r<12;r++)t=_([2e3,r]),n.push(this.monthsShort(t,"")),s.push(this.months(t,"")),i.push(this.months(t,"")),i.push(this.monthsShort(t,""));for(n.sort(e),s.sort(e),i.sort(e),r=0;r<12;r++)n[r]=me(n[r]),s[r]=me(s[r]);for(r=0;r<24;r++)i[r]=me(i[r]);this._monthsRegex=new RegExp("^("+i.join("|")+")","i"),this._monthsShortRegex=this._monthsRegex,this._monthsStrictRegex=new RegExp("^("+s.join("|")+")","i"),this._monthsShortStrictRegex=new RegExp("^("+n.join("|")+")","i")}function Fe(e){return j(e)?366:365}C("Y",0,0,function(){var e=this.year();return e<=9999?T(e,4):"+"+e}),C(0,["YY",2],0,function(){return this.year()%100}),C(0,["YYYY",4],0,"year"),C(0,["YYYYY",5],0,"year"),C(0,["YYYYYY",6,!0],0,"year"),L("year","y"),A("year",1),ce("Y",ue),ce("YY",te,Q),ce("YYYY",re,K),ce("YYYYY",ae,ee),ce("YYYYYY",ae,ee),ye(["YYYYY","YYYYYY"],pe),ye("YYYY",function(e,t){t[pe]=2===e.length?f.parseTwoDigitYear(e):Z(e)}),ye("YY",function(e,t){t[pe]=f.parseTwoDigitYear(e)}),ye("Y",function(e,t){t[pe]=parseInt(e,10)}),f.parseTwoDigitYear=function(e){return Z(e)+(68<Z(e)?1900:2e3)};var Le=z("FullYear",!0);function Ve(e){var t,n;return e<100&&0<=e?((n=Array.prototype.slice.call(arguments))[0]=e+400,t=new Date(Date.UTC.apply(null,n)),isFinite(t.getUTCFullYear())&&t.setUTCFullYear(e)):t=new Date(Date.UTC.apply(null,arguments)),t}function Ge(e,t,n){var s=7+t-n;return s-(7+Ve(e,0,s).getUTCDay()-t)%7-1}function Ee(e,t,n,s,i){var r,a=1+7*(t-1)+(7+n-s)%7+Ge(e,s,i),o=a<=0?Fe(r=e-1)+a:a>Fe(e)?(r=e+1,a-Fe(e)):(r=e,a);return{year:r,dayOfYear:o}}function Ae(e,t,n){var s,i,r=Ge(e.year(),t,n),a=Math.floor((e.dayOfYear()-r-1)/7)+1;return a<1?s=a+je(i=e.year()-1,t,n):a>je(e.year(),t,n)?(s=a-je(e.year(),t,n),i=e.year()+1):(i=e.year(),s=a),{week:s,year:i}}function je(e,t,n){var s=Ge(e,t,n),i=Ge(e+1,t,n);return(Fe(e)-s+i)/7}C("w",["ww",2],"wo","week"),C("W",["WW",2],"Wo","isoWeek"),L("week","w"),L("isoWeek","W"),A("week",5),A("isoWeek",5),ce("w",te),ce("ww",te,Q),ce("W",te),ce("WW",te,Q),ge(["w","ww","W","WW"],function(e,t,n,s){t[s.substr(0,1)]=Z(e)});function Ie(e,t){return e.slice(t,7).concat(e.slice(0,t))}C("d",0,"do","day"),C("dd",0,0,function(e){return this.localeData().weekdaysMin(this,e)}),C("ddd",0,0,function(e){return this.localeData().weekdaysShort(this,e)}),C("dddd",0,0,function(e){return this.localeData().weekdays(this,e)}),C("e",0,0,"weekday"),C("E",0,0,"isoWeekday"),L("day","d"),L("weekday","e"),L("isoWeekday","E"),A("day",11),A("weekday",11),A("isoWeekday",11),ce("d",te),ce("e",te),ce("E",te),ce("dd",function(e,t){return t.weekdaysMinRegex(e)}),ce("ddd",function(e,t){return t.weekdaysShortRegex(e)}),ce("dddd",function(e,t){return t.weekdaysRegex(e)}),ge(["dd","ddd","dddd"],function(e,t,n,s){var i=n._locale.weekdaysParse(e,s,n._strict);null!=i?t.d=i:y(n).invalidWeekday=e}),ge(["d","e","E"],function(e,t,n,s){t[s]=Z(e)});var Ze="Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),ze="Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"),$e="Su_Mo_Tu_We_Th_Fr_Sa".split("_"),qe=de,Be=de,Je=de;function Qe(){function e(e,t){return t.length-e.length}for(var t,n,s,i,r=[],a=[],o=[],u=[],l=0;l<7;l++)t=_([2e3,1]).day(l),n=me(this.weekdaysMin(t,"")),s=me(this.weekdaysShort(t,"")),i=me(this.weekdays(t,"")),r.push(n),a.push(s),o.push(i),u.push(n),u.push(s),u.push(i);r.sort(e),a.sort(e),o.sort(e),u.sort(e),this._weekdaysRegex=new RegExp("^("+u.join("|")+")","i"),this._weekdaysShortRegex=this._weekdaysRegex,this._weekdaysMinRegex=this._weekdaysRegex,this._weekdaysStrictRegex=new RegExp("^("+o.join("|")+")","i"),this._weekdaysShortStrictRegex=new RegExp("^("+a.join("|")+")","i"),this._weekdaysMinStrictRegex=new RegExp("^("+r.join("|")+")","i")}function Xe(){return this.hours()%12||12}function Ke(e,t){C(e,0,0,function(){return this.localeData().meridiem(this.hours(),this.minutes(),t)})}function et(e,t){return t._meridiemParse}C("H",["HH",2],0,"hour"),C("h",["hh",2],0,Xe),C("k",["kk",2],0,function(){return this.hours()||24}),C("hmm",0,0,function(){return""+Xe.apply(this)+T(this.minutes(),2)}),C("hmmss",0,0,function(){return""+Xe.apply(this)+T(this.minutes(),2)+T(this.seconds(),2)}),C("Hmm",0,0,function(){return""+this.hours()+T(this.minutes(),2)}),C("Hmmss",0,0,function(){return""+this.hours()+T(this.minutes(),2)+T(this.seconds(),2)}),Ke("a",!0),Ke("A",!1),L("hour","h"),A("hour",13),ce("a",et),ce("A",et),ce("H",te),ce("h",te),ce("k",te),ce("HH",te,Q),ce("hh",te,Q),ce("kk",te,Q),ce("hmm",ne),ce("hmmss",se),ce("Hmm",ne),ce("Hmmss",se),ye(["H","HH"],Me),ye(["k","kk"],function(e,t,n){var s=Z(e);t[Me]=24===s?0:s}),ye(["a","A"],function(e,t,n){n._isPm=n._locale.isPM(e),n._meridiem=e}),ye(["h","hh"],function(e,t,n){t[Me]=Z(e),y(n).bigHour=!0}),ye("hmm",function(e,t,n){var s=e.length-2;t[Me]=Z(e.substr(0,s)),t[De]=Z(e.substr(s)),y(n).bigHour=!0}),ye("hmmss",function(e,t,n){var s=e.length-4,i=e.length-2;t[Me]=Z(e.substr(0,s)),t[De]=Z(e.substr(s,2)),t[Se]=Z(e.substr(i)),y(n).bigHour=!0}),ye("Hmm",function(e,t,n){var s=e.length-2;t[Me]=Z(e.substr(0,s)),t[De]=Z(e.substr(s))}),ye("Hmmss",function(e,t,n){var s=e.length-4,i=e.length-2;t[Me]=Z(e.substr(0,s)),t[De]=Z(e.substr(s,2)),t[Se]=Z(e.substr(i))});var tt=z("Hours",!0);var nt,st={calendar:{sameDay:"[Today at] LT",nextDay:"[Tomorrow at] LT",nextWeek:"dddd [at] LT",lastDay:"[Yesterday at] LT",lastWeek:"[Last] dddd [at] LT",sameElse:"L"},longDateFormat:{LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"},invalidDate:"Invalid date",ordinal:"%d",dayOfMonthOrdinalParse:/\d{1,2}/,relativeTime:{future:"in %s",past:"%s ago",s:"a few seconds",ss:"%d seconds",m:"a minute",mm:"%d minutes",h:"an hour",hh:"%d hours",d:"a day",dd:"%d days",w:"a week",ww:"%d weeks",M:"a month",MM:"%d months",y:"a year",yy:"%d years"},months:Te,monthsShort:Ne,week:{dow:0,doy:6},weekdays:Ze,weekdaysMin:$e,weekdaysShort:ze,meridiemParse:/[ap]\.?m?\.?/i},it={},rt={};function at(e){return e?e.toLowerCase().replace("_","-"):e}function ot(e){for(var t,n,s,i,r=0;r<e.length;){for(t=(i=at(e[r]).split("-")).length,n=(n=at(e[r+1]))?n.split("-"):null;0<t;){if(s=ut(i.slice(0,t).join("-")))return s;if(n&&n.length>=t&&function(e,t){for(var n=Math.min(e.length,t.length),s=0;s<n;s+=1)if(e[s]!==t[s])return s;return n}(i,n)>=t-1)break;t--}r++}return nt}function ut(t){var e;if(void 0===it[t]&&"undefined"!=typeof module&&module&&module.exports)try{e=nt._abbr,require("./locale/"+t),lt(e)}catch(e){it[t]=null}return it[t]}function lt(e,t){var n;return e&&((n=r(t)?dt(e):ht(e,t))?nt=n:"undefined"!=typeof console&&console.warn&&console.warn("Locale "+e+" not found. Did you forget to load it?")),nt._abbr}function ht(e,t){if(null===t)return delete it[e],null;var n,s=st;if(t.abbr=e,null!=it[e])Y("defineLocaleOverride","use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),s=it[e]._config;else if(null!=t.parentLocale)if(null!=it[t.parentLocale])s=it[t.parentLocale]._config;else{if(null==(n=ut(t.parentLocale)))return rt[t.parentLocale]||(rt[t.parentLocale]=[]),rt[t.parentLocale].push({name:e,config:t}),null;s=n._config}return it[e]=new x(b(s,t)),rt[e]&&rt[e].forEach(function(e){ht(e.name,e.config)}),lt(e),it[e]}function dt(e){var t;if(e&&e._locale&&e._locale._abbr&&(e=e._locale._abbr),!e)return nt;if(!o(e)){if(t=ut(e))return t;e=[e]}return ot(e)}function ct(e){var t,n=e._a;return n&&-2===y(e).overflow&&(t=n[ve]<0||11<n[ve]?ve:n[ke]<1||n[ke]>xe(n[pe],n[ve])?ke:n[Me]<0||24<n[Me]||24===n[Me]&&(0!==n[De]||0!==n[Se]||0!==n[Ye])?Me:n[De]<0||59<n[De]?De:n[Se]<0||59<n[Se]?Se:n[Ye]<0||999<n[Ye]?Ye:-1,y(e)._overflowDayOfYear&&(t<pe||ke<t)&&(t=ke),y(e)._overflowWeeks&&-1===t&&(t=Oe),y(e)._overflowWeekday&&-1===t&&(t=be),y(e).overflow=t),e}var ft=/^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/,mt=/^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d|))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/,_t=/Z|[+-]\d\d(?::?\d\d)?/,yt=[["YYYYYY-MM-DD",/[+-]\d{6}-\d\d-\d\d/],["YYYY-MM-DD",/\d{4}-\d\d-\d\d/],["GGGG-[W]WW-E",/\d{4}-W\d\d-\d/],["GGGG-[W]WW",/\d{4}-W\d\d/,!1],["YYYY-DDD",/\d{4}-\d{3}/],["YYYY-MM",/\d{4}-\d\d/,!1],["YYYYYYMMDD",/[+-]\d{10}/],["YYYYMMDD",/\d{8}/],["GGGG[W]WWE",/\d{4}W\d{3}/],["GGGG[W]WW",/\d{4}W\d{2}/,!1],["YYYYDDD",/\d{7}/],["YYYYMM",/\d{6}/,!1],["YYYY",/\d{4}/,!1]],gt=[["HH:mm:ss.SSSS",/\d\d:\d\d:\d\d\.\d+/],["HH:mm:ss,SSSS",/\d\d:\d\d:\d\d,\d+/],["HH:mm:ss",/\d\d:\d\d:\d\d/],["HH:mm",/\d\d:\d\d/],["HHmmss.SSSS",/\d\d\d\d\d\d\.\d+/],["HHmmss,SSSS",/\d\d\d\d\d\d,\d+/],["HHmmss",/\d\d\d\d\d\d/],["HHmm",/\d\d\d\d/],["HH",/\d\d/]],wt=/^\/?Date\((-?\d+)/i,pt=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/,vt={UT:0,GMT:0,EDT:-240,EST:-300,CDT:-300,CST:-360,MDT:-360,MST:-420,PDT:-420,PST:-480};function kt(e){var t,n,s,i,r,a,o=e._i,u=ft.exec(o)||mt.exec(o);if(u){for(y(e).iso=!0,t=0,n=yt.length;t<n;t++)if(yt[t][1].exec(u[1])){i=yt[t][0],s=!1!==yt[t][2];break}if(null==i)return void(e._isValid=!1);if(u[3]){for(t=0,n=gt.length;t<n;t++)if(gt[t][1].exec(u[3])){r=(u[2]||" ")+gt[t][0];break}if(null==r)return void(e._isValid=!1)}if(!s&&null!=r)return void(e._isValid=!1);if(u[4]){if(!_t.exec(u[4]))return void(e._isValid=!1);a="Z"}e._f=i+(r||"")+(a||""),Ot(e)}else e._isValid=!1}function Mt(e,t,n,s,i,r){var a=[function(e){var t=parseInt(e,10);{if(t<=49)return 2e3+t;if(t<=999)return 1900+t}return t}(e),Ne.indexOf(t),parseInt(n,10),parseInt(s,10),parseInt(i,10)];return r&&a.push(parseInt(r,10)),a}function Dt(e){var t,n,s,i,r=pt.exec(e._i.replace(/\([^)]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").replace(/^\s\s*/,"").replace(/\s\s*$/,""));if(r){if(t=Mt(r[4],r[3],r[2],r[5],r[6],r[7]),n=r[1],s=t,i=e,n&&ze.indexOf(n)!==new Date(s[0],s[1],s[2]).getDay()&&(y(i).weekdayMismatch=!0,!void(i._isValid=!1)))return;e._a=t,e._tzm=function(e,t,n){if(e)return vt[e];if(t)return 0;var s=parseInt(n,10),i=s%100;return 60*((s-i)/100)+i}(r[8],r[9],r[10]),e._d=Ve.apply(null,e._a),e._d.setUTCMinutes(e._d.getUTCMinutes()-e._tzm),y(e).rfc2822=!0}else e._isValid=!1}function St(e,t,n){return null!=e?e:null!=t?t:n}function Yt(e){var t,n,s,i,r,a,o,u=[];if(!e._d){for(a=e,o=new Date(f.now()),s=a._useUTC?[o.getUTCFullYear(),o.getUTCMonth(),o.getUTCDate()]:[o.getFullYear(),o.getMonth(),o.getDate()],e._w&&null==e._a[ke]&&null==e._a[ve]&&function(e){var t,n,s,i,r,a,o,u,l;null!=(t=e._w).GG||null!=t.W||null!=t.E?(r=1,a=4,n=St(t.GG,e._a[pe],Ae(Tt(),1,4).year),s=St(t.W,1),((i=St(t.E,1))<1||7<i)&&(u=!0)):(r=e._locale._week.dow,a=e._locale._week.doy,l=Ae(Tt(),r,a),n=St(t.gg,e._a[pe],l.year),s=St(t.w,l.week),null!=t.d?((i=t.d)<0||6<i)&&(u=!0):null!=t.e?(i=t.e+r,(t.e<0||6<t.e)&&(u=!0)):i=r);s<1||s>je(n,r,a)?y(e)._overflowWeeks=!0:null!=u?y(e)._overflowWeekday=!0:(o=Ee(n,s,i,r,a),e._a[pe]=o.year,e._dayOfYear=o.dayOfYear)}(e),null!=e._dayOfYear&&(r=St(e._a[pe],s[pe]),(e._dayOfYear>Fe(r)||0===e._dayOfYear)&&(y(e)._overflowDayOfYear=!0),n=Ve(r,0,e._dayOfYear),e._a[ve]=n.getUTCMonth(),e._a[ke]=n.getUTCDate()),t=0;t<3&&null==e._a[t];++t)e._a[t]=u[t]=s[t];for(;t<7;t++)e._a[t]=u[t]=null==e._a[t]?2===t?1:0:e._a[t];24===e._a[Me]&&0===e._a[De]&&0===e._a[Se]&&0===e._a[Ye]&&(e._nextDay=!0,e._a[Me]=0),e._d=(e._useUTC?Ve:function(e,t,n,s,i,r,a){var o;return e<100&&0<=e?(o=new Date(e+400,t,n,s,i,r,a),isFinite(o.getFullYear())&&o.setFullYear(e)):o=new Date(e,t,n,s,i,r,a),o}).apply(null,u),i=e._useUTC?e._d.getUTCDay():e._d.getDay(),null!=e._tzm&&e._d.setUTCMinutes(e._d.getUTCMinutes()-e._tzm),e._nextDay&&(e._a[Me]=24),e._w&&void 0!==e._w.d&&e._w.d!==i&&(y(e).weekdayMismatch=!0)}}function Ot(e){if(e._f!==f.ISO_8601)if(e._f!==f.RFC_2822){e._a=[],y(e).empty=!0;for(var t,n,s,i,r,a,o,u=""+e._i,l=u.length,h=0,d=H(e._f,e._locale).match(N)||[],c=0;c<d.length;c++)n=d[c],(t=(u.match(fe(n,e))||[])[0])&&(0<(s=u.substr(0,u.indexOf(t))).length&&y(e).unusedInput.push(s),u=u.slice(u.indexOf(t)+t.length),h+=t.length),W[n]?(t?y(e).empty=!1:y(e).unusedTokens.push(n),r=n,o=e,null!=(a=t)&&m(_e,r)&&_e[r](a,o._a,o,r)):e._strict&&!t&&y(e).unusedTokens.push(n);y(e).charsLeftOver=l-h,0<u.length&&y(e).unusedInput.push(u),e._a[Me]<=12&&!0===y(e).bigHour&&0<e._a[Me]&&(y(e).bigHour=void 0),y(e).parsedDateParts=e._a.slice(0),y(e).meridiem=e._meridiem,e._a[Me]=function(e,t,n){var s;if(null==n)return t;return null!=e.meridiemHour?e.meridiemHour(t,n):(null!=e.isPM&&((s=e.isPM(n))&&t<12&&(t+=12),s||12!==t||(t=0)),t)}(e._locale,e._a[Me],e._meridiem),null!==(i=y(e).era)&&(e._a[pe]=e._locale.erasConvertYear(i,e._a[pe])),Yt(e),ct(e)}else Dt(e);else kt(e)}function bt(e){var t,n,s=e._i,i=e._f;return e._locale=e._locale||dt(e._l),null===s||void 0===i&&""===s?w({nullInput:!0}):("string"==typeof s&&(e._i=s=e._locale.preparse(s)),M(s)?new k(ct(s)):(a(s)?e._d=s:o(i)?function(e){var t,n,s,i,r,a,o=!1;if(0===e._f.length)return y(e).invalidFormat=!0,e._d=new Date(NaN);for(i=0;i<e._f.length;i++)r=0,a=!1,t=v({},e),null!=e._useUTC&&(t._useUTC=e._useUTC),t._f=e._f[i],Ot(t),g(t)&&(a=!0),r+=y(t).charsLeftOver,r+=10*y(t).unusedTokens.length,y(t).score=r,o?r<s&&(s=r,n=t):(null==s||r<s||a)&&(s=r,n=t,a&&(o=!0));c(e,n||t)}(e):i?Ot(e):r(n=(t=e)._i)?t._d=new Date(f.now()):a(n)?t._d=new Date(n.valueOf()):"string"==typeof n?function(e){var t=wt.exec(e._i);null===t?(kt(e),!1===e._isValid&&(delete e._isValid,Dt(e),!1===e._isValid&&(delete e._isValid,e._strict?e._isValid=!1:f.createFromInputFallback(e)))):e._d=new Date(+t[1])}(t):o(n)?(t._a=d(n.slice(0),function(e){return parseInt(e,10)}),Yt(t)):u(n)?function(e){var t,n;e._d||(n=void 0===(t=G(e._i)).day?t.date:t.day,e._a=d([t.year,t.month,n,t.hour,t.minute,t.second,t.millisecond],function(e){return e&&parseInt(e,10)}),Yt(e))}(t):h(n)?t._d=new Date(n):f.createFromInputFallback(t),g(e)||(e._d=null),e))}function xt(e,t,n,s,i){var r,a={};return!0!==t&&!1!==t||(s=t,t=void 0),!0!==n&&!1!==n||(s=n,n=void 0),(u(e)&&l(e)||o(e)&&0===e.length)&&(e=void 0),a._isAMomentObject=!0,a._useUTC=a._isUTC=i,a._l=n,a._i=e,a._f=t,a._strict=s,(r=new k(ct(bt(a))))._nextDay&&(r.add(1,"d"),r._nextDay=void 0),r}function Tt(e,t,n,s){return xt(e,t,n,s,!1)}f.createFromInputFallback=n("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",function(e){e._d=new Date(e._i+(e._useUTC?" UTC":""))}),f.ISO_8601=function(){},f.RFC_2822=function(){};var Nt=n("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",function(){var e=Tt.apply(null,arguments);return this.isValid()&&e.isValid()?e<this?this:e:w()}),Pt=n("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",function(){var e=Tt.apply(null,arguments);return this.isValid()&&e.isValid()?this<e?this:e:w()});function Rt(e,t){var n,s;if(1===t.length&&o(t[0])&&(t=t[0]),!t.length)return Tt();for(n=t[0],s=1;s<t.length;++s)t[s].isValid()&&!t[s][e](n)||(n=t[s]);return n}var Wt=["year","quarter","month","week","day","hour","minute","second","millisecond"];function Ct(e){var t=G(e),n=t.year||0,s=t.quarter||0,i=t.month||0,r=t.week||t.isoWeek||0,a=t.day||0,o=t.hour||0,u=t.minute||0,l=t.second||0,h=t.millisecond||0;this._isValid=function(e){var t,n,s=!1;for(t in e)if(m(e,t)&&(-1===we.call(Wt,t)||null!=e[t]&&isNaN(e[t])))return!1;for(n=0;n<Wt.length;++n)if(e[Wt[n]]){if(s)return!1;parseFloat(e[Wt[n]])!==Z(e[Wt[n]])&&(s=!0)}return!0}(t),this._milliseconds=+h+1e3*l+6e4*u+1e3*o*60*60,this._days=+a+7*r,this._months=+i+3*s+12*n,this._data={},this._locale=dt(),this._bubble()}function Ut(e){return e instanceof Ct}function Ht(e){return e<0?-1*Math.round(-1*e):Math.round(e)}function Ft(e,n){C(e,0,0,function(){var e=this.utcOffset(),t="+";return e<0&&(e=-e,t="-"),t+T(~~(e/60),2)+n+T(~~e%60,2)})}Ft("Z",":"),Ft("ZZ",""),ce("Z",he),ce("ZZ",he),ye(["Z","ZZ"],function(e,t,n){n._useUTC=!0,n._tzm=Vt(he,e)});var Lt=/([\+\-]|\d\d)/gi;function Vt(e,t){var n,s,i=(t||"").match(e);return null===i?null:0===(s=60*(n=((i[i.length-1]||[])+"").match(Lt)||["-",0,0])[1]+Z(n[2]))?0:"+"===n[0]?s:-s}function Gt(e,t){var n,s;return t._isUTC?(n=t.clone(),s=(M(e)||a(e)?e.valueOf():Tt(e).valueOf())-n.valueOf(),n._d.setTime(n._d.valueOf()+s),f.updateOffset(n,!1),n):Tt(e).local()}function Et(e){return-Math.round(e._d.getTimezoneOffset())}function At(){return!!this.isValid()&&(this._isUTC&&0===this._offset)}f.updateOffset=function(){};var jt=/^(-|\+)?(?:(\d*)[. ])?(\d+):(\d+)(?::(\d+)(\.\d*)?)?$/,It=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function Zt(e,t){var n,s,i,r=e,a=null;return Ut(e)?r={ms:e._milliseconds,d:e._days,M:e._months}:h(e)||!isNaN(+e)?(r={},t?r[t]=+e:r.milliseconds=+e):(a=jt.exec(e))?(n="-"===a[1]?-1:1,r={y:0,d:Z(a[ke])*n,h:Z(a[Me])*n,m:Z(a[De])*n,s:Z(a[Se])*n,ms:Z(Ht(1e3*a[Ye]))*n}):(a=It.exec(e))?(n="-"===a[1]?-1:1,r={y:zt(a[2],n),M:zt(a[3],n),w:zt(a[4],n),d:zt(a[5],n),h:zt(a[6],n),m:zt(a[7],n),s:zt(a[8],n)}):null==r?r={}:"object"==typeof r&&("from"in r||"to"in r)&&(i=function(e,t){var n;if(!e.isValid()||!t.isValid())return{milliseconds:0,months:0};t=Gt(t,e),e.isBefore(t)?n=$t(e,t):((n=$t(t,e)).milliseconds=-n.milliseconds,n.months=-n.months);return n}(Tt(r.from),Tt(r.to)),(r={}).ms=i.milliseconds,r.M=i.months),s=new Ct(r),Ut(e)&&m(e,"_locale")&&(s._locale=e._locale),Ut(e)&&m(e,"_isValid")&&(s._isValid=e._isValid),s}function zt(e,t){var n=e&&parseFloat(e.replace(",","."));return(isNaN(n)?0:n)*t}function $t(e,t){var n={};return n.months=t.month()-e.month()+12*(t.year()-e.year()),e.clone().add(n.months,"M").isAfter(t)&&--n.months,n.milliseconds=t-e.clone().add(n.months,"M"),n}function qt(s,i){return function(e,t){var n;return null===t||isNaN(+t)||(Y(i,"moment()."+i+"(period, number) is deprecated. Please use moment()."+i+"(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),n=e,e=t,t=n),Bt(this,Zt(e,t),s),this}}function Bt(e,t,n,s){var i=t._milliseconds,r=Ht(t._days),a=Ht(t._months);e.isValid()&&(s=null==s||s,a&&Ce(e,$(e,"Month")+a*n),r&&q(e,"Date",$(e,"Date")+r*n),i&&e._d.setTime(e._d.valueOf()+i*n),s&&f.updateOffset(e,r||a))}Zt.fn=Ct.prototype,Zt.invalid=function(){return Zt(NaN)};var Jt=qt(1,"add"),Qt=qt(-1,"subtract");function Xt(e){return"string"==typeof e||e instanceof String}function Kt(e){return M(e)||a(e)||Xt(e)||h(e)||function(t){var e=o(t),n=!1;e&&(n=0===t.filter(function(e){return!h(e)&&Xt(t)}).length);return e&&n}(e)||function(e){var t,n,s=u(e)&&!l(e),i=!1,r=["years","year","y","months","month","M","days","day","d","dates","date","D","hours","hour","h","minutes","minute","m","seconds","second","s","milliseconds","millisecond","ms"];for(t=0;t<r.length;t+=1)n=r[t],i=i||m(e,n);return s&&i}(e)||null==e}function en(e,t){if(e.date()<t.date())return-en(t,e);var n=12*(t.year()-e.year())+(t.month()-e.month()),s=e.clone().add(n,"months"),i=t-s<0?(t-s)/(s-e.clone().add(n-1,"months")):(t-s)/(e.clone().add(1+n,"months")-s);return-(n+i)||0}function tn(e){var t;return void 0===e?this._locale._abbr:(null!=(t=dt(e))&&(this._locale=t),this)}f.defaultFormat="YYYY-MM-DDTHH:mm:ssZ",f.defaultFormatUtc="YYYY-MM-DDTHH:mm:ss[Z]";var nn=n("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",function(e){return void 0===e?this.localeData():this.locale(e)});function sn(){return this._locale}var rn=126227808e5;function an(e,t){return(e%t+t)%t}function on(e,t,n){return e<100&&0<=e?new Date(e+400,t,n)-rn:new Date(e,t,n).valueOf()}function un(e,t,n){return e<100&&0<=e?Date.UTC(e+400,t,n)-rn:Date.UTC(e,t,n)}function ln(e,t){return t.erasAbbrRegex(e)}function hn(){for(var e=[],t=[],n=[],s=[],i=this.eras(),r=0,a=i.length;r<a;++r)t.push(me(i[r].name)),e.push(me(i[r].abbr)),n.push(me(i[r].narrow)),s.push(me(i[r].name)),s.push(me(i[r].abbr)),s.push(me(i[r].narrow));this._erasRegex=new RegExp("^("+s.join("|")+")","i"),this._erasNameRegex=new RegExp("^("+t.join("|")+")","i"),this._erasAbbrRegex=new RegExp("^("+e.join("|")+")","i"),this._erasNarrowRegex=new RegExp("^("+n.join("|")+")","i")}function dn(e,t){C(0,[e,e.length],0,t)}function cn(e,t,n,s,i){var r;return null==e?Ae(this,s,i).year:((r=je(e,s,i))<t&&(t=r),function(e,t,n,s,i){var r=Ee(e,t,n,s,i),a=Ve(r.year,0,r.dayOfYear);return this.year(a.getUTCFullYear()),this.month(a.getUTCMonth()),this.date(a.getUTCDate()),this}.call(this,e,t,n,s,i))}C("N",0,0,"eraAbbr"),C("NN",0,0,"eraAbbr"),C("NNN",0,0,"eraAbbr"),C("NNNN",0,0,"eraName"),C("NNNNN",0,0,"eraNarrow"),C("y",["y",1],"yo","eraYear"),C("y",["yy",2],0,"eraYear"),C("y",["yyy",3],0,"eraYear"),C("y",["yyyy",4],0,"eraYear"),ce("N",ln),ce("NN",ln),ce("NNN",ln),ce("NNNN",function(e,t){return t.erasNameRegex(e)}),ce("NNNNN",function(e,t){return t.erasNarrowRegex(e)}),ye(["N","NN","NNN","NNNN","NNNNN"],function(e,t,n,s){var i=n._locale.erasParse(e,s,n._strict);i?y(n).era=i:y(n).invalidEra=e}),ce("y",oe),ce("yy",oe),ce("yyy",oe),ce("yyyy",oe),ce("yo",function(e,t){return t._eraYearOrdinalRegex||oe}),ye(["y","yy","yyy","yyyy"],pe),ye(["yo"],function(e,t,n,s){var i;n._locale._eraYearOrdinalRegex&&(i=e.match(n._locale._eraYearOrdinalRegex)),n._locale.eraYearOrdinalParse?t[pe]=n._locale.eraYearOrdinalParse(e,i):t[pe]=parseInt(e,10)}),C(0,["gg",2],0,function(){return this.weekYear()%100}),C(0,["GG",2],0,function(){return this.isoWeekYear()%100}),dn("gggg","weekYear"),dn("ggggg","weekYear"),dn("GGGG","isoWeekYear"),dn("GGGGG","isoWeekYear"),L("weekYear","gg"),L("isoWeekYear","GG"),A("weekYear",1),A("isoWeekYear",1),ce("G",ue),ce("g",ue),ce("GG",te,Q),ce("gg",te,Q),ce("GGGG",re,K),ce("gggg",re,K),ce("GGGGG",ae,ee),ce("ggggg",ae,ee),ge(["gggg","ggggg","GGGG","GGGGG"],function(e,t,n,s){t[s.substr(0,2)]=Z(e)}),ge(["gg","GG"],function(e,t,n,s){t[s]=f.parseTwoDigitYear(e)}),C("Q",0,"Qo","quarter"),L("quarter","Q"),A("quarter",7),ce("Q",J),ye("Q",function(e,t){t[ve]=3*(Z(e)-1)}),C("D",["DD",2],"Do","date"),L("date","D"),A("date",9),ce("D",te),ce("DD",te,Q),ce("Do",function(e,t){return e?t._dayOfMonthOrdinalParse||t._ordinalParse:t._dayOfMonthOrdinalParseLenient}),ye(["D","DD"],ke),ye("Do",function(e,t){t[ke]=Z(e.match(te)[0])});var fn=z("Date",!0);C("DDD",["DDDD",3],"DDDo","dayOfYear"),L("dayOfYear","DDD"),A("dayOfYear",4),ce("DDD",ie),ce("DDDD",X),ye(["DDD","DDDD"],function(e,t,n){n._dayOfYear=Z(e)}),C("m",["mm",2],0,"minute"),L("minute","m"),A("minute",14),ce("m",te),ce("mm",te,Q),ye(["m","mm"],De);var mn=z("Minutes",!1);C("s",["ss",2],0,"second"),L("second","s"),A("second",15),ce("s",te),ce("ss",te,Q),ye(["s","ss"],Se);var _n,yn,gn=z("Seconds",!1);for(C("S",0,0,function(){return~~(this.millisecond()/100)}),C(0,["SS",2],0,function(){return~~(this.millisecond()/10)}),C(0,["SSS",3],0,"millisecond"),C(0,["SSSS",4],0,function(){return 10*this.millisecond()}),C(0,["SSSSS",5],0,function(){return 100*this.millisecond()}),C(0,["SSSSSS",6],0,function(){return 1e3*this.millisecond()}),C(0,["SSSSSSS",7],0,function(){return 1e4*this.millisecond()}),C(0,["SSSSSSSS",8],0,function(){return 1e5*this.millisecond()}),C(0,["SSSSSSSSS",9],0,function(){return 1e6*this.millisecond()}),L("millisecond","ms"),A("millisecond",16),ce("S",ie,J),ce("SS",ie,Q),ce("SSS",ie,X),_n="SSSS";_n.length<=9;_n+="S")ce(_n,oe);function wn(e,t){t[Ye]=Z(1e3*("0."+e))}for(_n="S";_n.length<=9;_n+="S")ye(_n,wn);yn=z("Milliseconds",!1),C("z",0,0,"zoneAbbr"),C("zz",0,0,"zoneName");var pn=k.prototype;function vn(e){return e}pn.add=Jt,pn.calendar=function(e,t){1===arguments.length&&(arguments[0]?Kt(arguments[0])?(e=arguments[0],t=void 0):function(e){for(var t=u(e)&&!l(e),n=!1,s=["sameDay","nextDay","lastDay","nextWeek","lastWeek","sameElse"],i=0;i<s.length;i+=1)n=n||m(e,s[i]);return t&&n}(arguments[0])&&(t=arguments[0],e=void 0):t=e=void 0);var n=e||Tt(),s=Gt(n,this).startOf("day"),i=f.calendarFormat(this,s)||"sameElse",r=t&&(O(t[i])?t[i].call(this,n):t[i]);return this.format(r||this.localeData().calendar(i,this,Tt(n)))},pn.clone=function(){return new k(this)},pn.diff=function(e,t,n){var s,i,r;if(!this.isValid())return NaN;if(!(s=Gt(e,this)).isValid())return NaN;switch(i=6e4*(s.utcOffset()-this.utcOffset()),t=V(t)){case"year":r=en(this,s)/12;break;case"month":r=en(this,s);break;case"quarter":r=en(this,s)/3;break;case"second":r=(this-s)/1e3;break;case"minute":r=(this-s)/6e4;break;case"hour":r=(this-s)/36e5;break;case"day":r=(this-s-i)/864e5;break;case"week":r=(this-s-i)/6048e5;break;default:r=this-s}return n?r:I(r)},pn.endOf=function(e){var t,n;if(void 0===(e=V(e))||"millisecond"===e||!this.isValid())return this;switch(n=this._isUTC?un:on,e){case"year":t=n(this.year()+1,0,1)-1;break;case"quarter":t=n(this.year(),this.month()-this.month()%3+3,1)-1;break;case"month":t=n(this.year(),this.month()+1,1)-1;break;case"week":t=n(this.year(),this.month(),this.date()-this.weekday()+7)-1;break;case"isoWeek":t=n(this.year(),this.month(),this.date()-(this.isoWeekday()-1)+7)-1;break;case"day":case"date":t=n(this.year(),this.month(),this.date()+1)-1;break;case"hour":t=this._d.valueOf(),t+=36e5-an(t+(this._isUTC?0:6e4*this.utcOffset()),36e5)-1;break;case"minute":t=this._d.valueOf(),t+=6e4-an(t,6e4)-1;break;case"second":t=this._d.valueOf(),t+=1e3-an(t,1e3)-1;break}return this._d.setTime(t),f.updateOffset(this,!0),this},pn.format=function(e){e=e||(this.isUtc()?f.defaultFormatUtc:f.defaultFormat);var t=U(this,e);return this.localeData().postformat(t)},pn.from=function(e,t){return this.isValid()&&(M(e)&&e.isValid()||Tt(e).isValid())?Zt({to:this,from:e}).locale(this.locale()).humanize(!t):this.localeData().invalidDate()},pn.fromNow=function(e){return this.from(Tt(),e)},pn.to=function(e,t){return this.isValid()&&(M(e)&&e.isValid()||Tt(e).isValid())?Zt({from:this,to:e}).locale(this.locale()).humanize(!t):this.localeData().invalidDate()},pn.toNow=function(e){return this.to(Tt(),e)},pn.get=function(e){return O(this[e=V(e)])?this[e]():this},pn.invalidAt=function(){return y(this).overflow},pn.isAfter=function(e,t){var n=M(e)?e:Tt(e);return!(!this.isValid()||!n.isValid())&&("millisecond"===(t=V(t)||"millisecond")?this.valueOf()>n.valueOf():n.valueOf()<this.clone().startOf(t).valueOf())},pn.isBefore=function(e,t){var n=M(e)?e:Tt(e);return!(!this.isValid()||!n.isValid())&&("millisecond"===(t=V(t)||"millisecond")?this.valueOf()<n.valueOf():this.clone().endOf(t).valueOf()<n.valueOf())},pn.isBetween=function(e,t,n,s){var i=M(e)?e:Tt(e),r=M(t)?t:Tt(t);return!!(this.isValid()&&i.isValid()&&r.isValid())&&(("("===(s=s||"()")[0]?this.isAfter(i,n):!this.isBefore(i,n))&&(")"===s[1]?this.isBefore(r,n):!this.isAfter(r,n)))},pn.isSame=function(e,t){var n,s=M(e)?e:Tt(e);return!(!this.isValid()||!s.isValid())&&("millisecond"===(t=V(t)||"millisecond")?this.valueOf()===s.valueOf():(n=s.valueOf(),this.clone().startOf(t).valueOf()<=n&&n<=this.clone().endOf(t).valueOf()))},pn.isSameOrAfter=function(e,t){return this.isSame(e,t)||this.isAfter(e,t)},pn.isSameOrBefore=function(e,t){return this.isSame(e,t)||this.isBefore(e,t)},pn.isValid=function(){return g(this)},pn.lang=nn,pn.locale=tn,pn.localeData=sn,pn.max=Pt,pn.min=Nt,pn.parsingFlags=function(){return c({},y(this))},pn.set=function(e,t){if("object"==typeof e)for(var n=function(e){var t,n=[];for(t in e)m(e,t)&&n.push({unit:t,priority:E[t]});return n.sort(function(e,t){return e.priority-t.priority}),n}(e=G(e)),s=0;s<n.length;s++)this[n[s].unit](e[n[s].unit]);else if(O(this[e=V(e)]))return this[e](t);return this},pn.startOf=function(e){var t,n;if(void 0===(e=V(e))||"millisecond"===e||!this.isValid())return this;switch(n=this._isUTC?un:on,e){case"year":t=n(this.year(),0,1);break;case"quarter":t=n(this.year(),this.month()-this.month()%3,1);break;case"month":t=n(this.year(),this.month(),1);break;case"week":t=n(this.year(),this.month(),this.date()-this.weekday());break;case"isoWeek":t=n(this.year(),this.month(),this.date()-(this.isoWeekday()-1));break;case"day":case"date":t=n(this.year(),this.month(),this.date());break;case"hour":t=this._d.valueOf(),t-=an(t+(this._isUTC?0:6e4*this.utcOffset()),36e5);break;case"minute":t=this._d.valueOf(),t-=an(t,6e4);break;case"second":t=this._d.valueOf(),t-=an(t,1e3);break}return this._d.setTime(t),f.updateOffset(this,!0),this},pn.subtract=Qt,pn.toArray=function(){var e=this;return[e.year(),e.month(),e.date(),e.hour(),e.minute(),e.second(),e.millisecond()]},pn.toObject=function(){var e=this;return{years:e.year(),months:e.month(),date:e.date(),hours:e.hours(),minutes:e.minutes(),seconds:e.seconds(),milliseconds:e.milliseconds()}},pn.toDate=function(){return new Date(this.valueOf())},pn.toISOString=function(e){if(!this.isValid())return null;var t=!0!==e,n=t?this.clone().utc():this;return n.year()<0||9999<n.year()?U(n,t?"YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"):O(Date.prototype.toISOString)?t?this.toDate().toISOString():new Date(this.valueOf()+60*this.utcOffset()*1e3).toISOString().replace("Z",U(n,"Z")):U(n,t?"YYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYY-MM-DD[T]HH:mm:ss.SSSZ")},pn.inspect=function(){if(!this.isValid())return"moment.invalid(/* "+this._i+" */)";var e,t,n,s="moment",i="";return this.isLocal()||(s=0===this.utcOffset()?"moment.utc":"moment.parseZone",i="Z"),e="["+s+'("]',t=0<=this.year()&&this.year()<=9999?"YYYY":"YYYYYY",n=i+'[")]',this.format(e+t+"-MM-DD[T]HH:mm:ss.SSS"+n)},"undefined"!=typeof Symbol&&null!=Symbol.for&&(pn[Symbol.for("nodejs.util.inspect.custom")]=function(){return"Moment<"+this.format()+">"}),pn.toJSON=function(){return this.isValid()?this.toISOString():null},pn.toString=function(){return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")},pn.unix=function(){return Math.floor(this.valueOf()/1e3)},pn.valueOf=function(){return this._d.valueOf()-6e4*(this._offset||0)},pn.creationData=function(){return{input:this._i,format:this._f,locale:this._locale,isUTC:this._isUTC,strict:this._strict}},pn.eraName=function(){for(var e,t=this.localeData().eras(),n=0,s=t.length;n<s;++n){if(e=this.clone().startOf("day").valueOf(),t[n].since<=e&&e<=t[n].until)return t[n].name;if(t[n].until<=e&&e<=t[n].since)return t[n].name}return""},pn.eraNarrow=function(){for(var e,t=this.localeData().eras(),n=0,s=t.length;n<s;++n){if(e=this.clone().startOf("day").valueOf(),t[n].since<=e&&e<=t[n].until)return t[n].narrow;if(t[n].until<=e&&e<=t[n].since)return t[n].narrow}return""},pn.eraAbbr=function(){for(var e,t=this.localeData().eras(),n=0,s=t.length;n<s;++n){if(e=this.clone().startOf("day").valueOf(),t[n].since<=e&&e<=t[n].until)return t[n].abbr;if(t[n].until<=e&&e<=t[n].since)return t[n].abbr}return""},pn.eraYear=function(){for(var e,t,n=this.localeData().eras(),s=0,i=n.length;s<i;++s)if(e=n[s].since<=n[s].until?1:-1,t=this.clone().startOf("day").valueOf(),n[s].since<=t&&t<=n[s].until||n[s].until<=t&&t<=n[s].since)return(this.year()-f(n[s].since).year())*e+n[s].offset;return this.year()},pn.year=Le,pn.isLeapYear=function(){return j(this.year())},pn.weekYear=function(e){return cn.call(this,e,this.week(),this.weekday(),this.localeData()._week.dow,this.localeData()._week.doy)},pn.isoWeekYear=function(e){return cn.call(this,e,this.isoWeek(),this.isoWeekday(),1,4)},pn.quarter=pn.quarters=function(e){return null==e?Math.ceil((this.month()+1)/3):this.month(3*(e-1)+this.month()%3)},pn.month=Ue,pn.daysInMonth=function(){return xe(this.year(),this.month())},pn.week=pn.weeks=function(e){var t=this.localeData().week(this);return null==e?t:this.add(7*(e-t),"d")},pn.isoWeek=pn.isoWeeks=function(e){var t=Ae(this,1,4).week;return null==e?t:this.add(7*(e-t),"d")},pn.weeksInYear=function(){var e=this.localeData()._week;return je(this.year(),e.dow,e.doy)},pn.weeksInWeekYear=function(){var e=this.localeData()._week;return je(this.weekYear(),e.dow,e.doy)},pn.isoWeeksInYear=function(){return je(this.year(),1,4)},pn.isoWeeksInISOWeekYear=function(){return je(this.isoWeekYear(),1,4)},pn.date=fn,pn.day=pn.days=function(e){if(!this.isValid())return null!=e?this:NaN;var t,n,s=this._isUTC?this._d.getUTCDay():this._d.getDay();return null!=e?(t=e,n=this.localeData(),e="string"!=typeof t?t:isNaN(t)?"number"==typeof(t=n.weekdaysParse(t))?t:null:parseInt(t,10),this.add(e-s,"d")):s},pn.weekday=function(e){if(!this.isValid())return null!=e?this:NaN;var t=(this.day()+7-this.localeData()._week.dow)%7;return null==e?t:this.add(e-t,"d")},pn.isoWeekday=function(e){if(!this.isValid())return null!=e?this:NaN;if(null==e)return this.day()||7;var t,n,s=(t=e,n=this.localeData(),"string"==typeof t?n.weekdaysParse(t)%7||7:isNaN(t)?null:t);return this.day(this.day()%7?s:s-7)},pn.dayOfYear=function(e){var t=Math.round((this.clone().startOf("day")-this.clone().startOf("year"))/864e5)+1;return null==e?t:this.add(e-t,"d")},pn.hour=pn.hours=tt,pn.minute=pn.minutes=mn,pn.second=pn.seconds=gn,pn.millisecond=pn.milliseconds=yn,pn.utcOffset=function(e,t,n){var s,i=this._offset||0;if(!this.isValid())return null!=e?this:NaN;if(null==e)return this._isUTC?i:Et(this);if("string"==typeof e){if(null===(e=Vt(he,e)))return this}else Math.abs(e)<16&&!n&&(e*=60);return!this._isUTC&&t&&(s=Et(this)),this._offset=e,this._isUTC=!0,null!=s&&this.add(s,"m"),i!==e&&(!t||this._changeInProgress?Bt(this,Zt(e-i,"m"),1,!1):this._changeInProgress||(this._changeInProgress=!0,f.updateOffset(this,!0),this._changeInProgress=null)),this},pn.utc=function(e){return this.utcOffset(0,e)},pn.local=function(e){return this._isUTC&&(this.utcOffset(0,e),this._isUTC=!1,e&&this.subtract(Et(this),"m")),this},pn.parseZone=function(){var e;return null!=this._tzm?this.utcOffset(this._tzm,!1,!0):"string"==typeof this._i&&(null!=(e=Vt(le,this._i))?this.utcOffset(e):this.utcOffset(0,!0)),this},pn.hasAlignedHourOffset=function(e){return!!this.isValid()&&(e=e?Tt(e).utcOffset():0,(this.utcOffset()-e)%60==0)},pn.isDST=function(){return this.utcOffset()>this.clone().month(0).utcOffset()||this.utcOffset()>this.clone().month(5).utcOffset()},pn.isLocal=function(){return!!this.isValid()&&!this._isUTC},pn.isUtcOffset=function(){return!!this.isValid()&&this._isUTC},pn.isUtc=At,pn.isUTC=At,pn.zoneAbbr=function(){return this._isUTC?"UTC":""},pn.zoneName=function(){return this._isUTC?"Coordinated Universal Time":""},pn.dates=n("dates accessor is deprecated. Use date instead.",fn),pn.months=n("months accessor is deprecated. Use month instead",Ue),pn.years=n("years accessor is deprecated. Use year instead",Le),pn.zone=n("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",function(e,t){return null!=e?("string"!=typeof e&&(e=-e),this.utcOffset(e,t),this):-this.utcOffset()}),pn.isDSTShifted=n("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",function(){if(!r(this._isDSTShifted))return this._isDSTShifted;var e,t={};return v(t,this),(t=bt(t))._a?(e=(t._isUTC?_:Tt)(t._a),this._isDSTShifted=this.isValid()&&0<function(e,t,n){for(var s=Math.min(e.length,t.length),i=Math.abs(e.length-t.length),r=0,a=0;a<s;a++)(n&&e[a]!==t[a]||!n&&Z(e[a])!==Z(t[a]))&&r++;return r+i}(t._a,e.toArray())):this._isDSTShifted=!1,this._isDSTShifted});var kn=x.prototype;function Mn(e,t,n,s){var i=dt(),r=_().set(s,t);return i[n](r,e)}function Dn(e,t,n){if(h(e)&&(t=e,e=void 0),e=e||"",null!=t)return Mn(e,t,n,"month");for(var s=[],i=0;i<12;i++)s[i]=Mn(e,i,n,"month");return s}function Sn(e,t,n,s){t=("boolean"==typeof e?h(t)&&(n=t,t=void 0):(t=e,e=!1,h(n=t)&&(n=t,t=void 0)),t||"");var i,r=dt(),a=e?r._week.dow:0,o=[];if(null!=n)return Mn(t,(n+a)%7,s,"day");for(i=0;i<7;i++)o[i]=Mn(t,(i+a)%7,s,"day");return o}kn.calendar=function(e,t,n){var s=this._calendar[e]||this._calendar.sameElse;return O(s)?s.call(t,n):s},kn.longDateFormat=function(e){var t=this._longDateFormat[e],n=this._longDateFormat[e.toUpperCase()];return t||!n?t:(this._longDateFormat[e]=n.match(N).map(function(e){return"MMMM"===e||"MM"===e||"DD"===e||"dddd"===e?e.slice(1):e}).join(""),this._longDateFormat[e])},kn.invalidDate=function(){return this._invalidDate},kn.ordinal=function(e){return this._ordinal.replace("%d",e)},kn.preparse=vn,kn.postformat=vn,kn.relativeTime=function(e,t,n,s){var i=this._relativeTime[n];return O(i)?i(e,t,n,s):i.replace(/%d/i,e)},kn.pastFuture=function(e,t){var n=this._relativeTime[0<e?"future":"past"];return O(n)?n(t):n.replace(/%s/i,t)},kn.set=function(e){var t,n;for(n in e)m(e,n)&&(O(t=e[n])?this[n]=t:this["_"+n]=t);this._config=e,this._dayOfMonthOrdinalParseLenient=new RegExp((this._dayOfMonthOrdinalParse.source||this._ordinalParse.source)+"|"+/\d{1,2}/.source)},kn.eras=function(e,t){for(var n,s=this._eras||dt("en")._eras,i=0,r=s.length;i<r;++i){switch(typeof s[i].since){case"string":n=f(s[i].since).startOf("day"),s[i].since=n.valueOf();break}switch(typeof s[i].until){case"undefined":s[i].until=1/0;break;case"string":n=f(s[i].until).startOf("day").valueOf(),s[i].until=n.valueOf();break}}return s},kn.erasParse=function(e,t,n){var s,i,r,a,o,u=this.eras();for(e=e.toUpperCase(),s=0,i=u.length;s<i;++s)if(r=u[s].name.toUpperCase(),a=u[s].abbr.toUpperCase(),o=u[s].narrow.toUpperCase(),n)switch(t){case"N":case"NN":case"NNN":if(a===e)return u[s];break;case"NNNN":if(r===e)return u[s];break;case"NNNNN":if(o===e)return u[s];break}else if(0<=[r,a,o].indexOf(e))return u[s]},kn.erasConvertYear=function(e,t){var n=e.since<=e.until?1:-1;return void 0===t?f(e.since).year():f(e.since).year()+(t-e.offset)*n},kn.erasAbbrRegex=function(e){return m(this,"_erasAbbrRegex")||hn.call(this),e?this._erasAbbrRegex:this._erasRegex},kn.erasNameRegex=function(e){return m(this,"_erasNameRegex")||hn.call(this),e?this._erasNameRegex:this._erasRegex},kn.erasNarrowRegex=function(e){return m(this,"_erasNarrowRegex")||hn.call(this),e?this._erasNarrowRegex:this._erasRegex},kn.months=function(e,t){return e?o(this._months)?this._months[e.month()]:this._months[(this._months.isFormat||Pe).test(t)?"format":"standalone"][e.month()]:o(this._months)?this._months:this._months.standalone},kn.monthsShort=function(e,t){return e?o(this._monthsShort)?this._monthsShort[e.month()]:this._monthsShort[Pe.test(t)?"format":"standalone"][e.month()]:o(this._monthsShort)?this._monthsShort:this._monthsShort.standalone},kn.monthsParse=function(e,t,n){var s,i,r;if(this._monthsParseExact)return function(e,t,n){var s,i,r,a=e.toLocaleLowerCase();if(!this._monthsParse)for(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[],s=0;s<12;++s)r=_([2e3,s]),this._shortMonthsParse[s]=this.monthsShort(r,"").toLocaleLowerCase(),this._longMonthsParse[s]=this.months(r,"").toLocaleLowerCase();return n?"MMM"===t?-1!==(i=we.call(this._shortMonthsParse,a))?i:null:-1!==(i=we.call(this._longMonthsParse,a))?i:null:"MMM"===t?-1!==(i=we.call(this._shortMonthsParse,a))||-1!==(i=we.call(this._longMonthsParse,a))?i:null:-1!==(i=we.call(this._longMonthsParse,a))||-1!==(i=we.call(this._shortMonthsParse,a))?i:null}.call(this,e,t,n);for(this._monthsParse||(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[]),s=0;s<12;s++){if(i=_([2e3,s]),n&&!this._longMonthsParse[s]&&(this._longMonthsParse[s]=new RegExp("^"+this.months(i,"").replace(".","")+"$","i"),this._shortMonthsParse[s]=new RegExp("^"+this.monthsShort(i,"").replace(".","")+"$","i")),n||this._monthsParse[s]||(r="^"+this.months(i,"")+"|^"+this.monthsShort(i,""),this._monthsParse[s]=new RegExp(r.replace(".",""),"i")),n&&"MMMM"===t&&this._longMonthsParse[s].test(e))return s;if(n&&"MMM"===t&&this._shortMonthsParse[s].test(e))return s;if(!n&&this._monthsParse[s].test(e))return s}},kn.monthsRegex=function(e){return this._monthsParseExact?(m(this,"_monthsRegex")||He.call(this),e?this._monthsStrictRegex:this._monthsRegex):(m(this,"_monthsRegex")||(this._monthsRegex=We),this._monthsStrictRegex&&e?this._monthsStrictRegex:this._monthsRegex)},kn.monthsShortRegex=function(e){return this._monthsParseExact?(m(this,"_monthsRegex")||He.call(this),e?this._monthsShortStrictRegex:this._monthsShortRegex):(m(this,"_monthsShortRegex")||(this._monthsShortRegex=Re),this._monthsShortStrictRegex&&e?this._monthsShortStrictRegex:this._monthsShortRegex)},kn.week=function(e){return Ae(e,this._week.dow,this._week.doy).week},kn.firstDayOfYear=function(){return this._week.doy},kn.firstDayOfWeek=function(){return this._week.dow},kn.weekdays=function(e,t){var n=o(this._weekdays)?this._weekdays:this._weekdays[e&&!0!==e&&this._weekdays.isFormat.test(t)?"format":"standalone"];return!0===e?Ie(n,this._week.dow):e?n[e.day()]:n},kn.weekdaysMin=function(e){return!0===e?Ie(this._weekdaysMin,this._week.dow):e?this._weekdaysMin[e.day()]:this._weekdaysMin},kn.weekdaysShort=function(e){return!0===e?Ie(this._weekdaysShort,this._week.dow):e?this._weekdaysShort[e.day()]:this._weekdaysShort},kn.weekdaysParse=function(e,t,n){var s,i,r;if(this._weekdaysParseExact)return function(e,t,n){var s,i,r,a=e.toLocaleLowerCase();if(!this._weekdaysParse)for(this._weekdaysParse=[],this._shortWeekdaysParse=[],this._minWeekdaysParse=[],s=0;s<7;++s)r=_([2e3,1]).day(s),this._minWeekdaysParse[s]=this.weekdaysMin(r,"").toLocaleLowerCase(),this._shortWeekdaysParse[s]=this.weekdaysShort(r,"").toLocaleLowerCase(),this._weekdaysParse[s]=this.weekdays(r,"").toLocaleLowerCase();return n?"dddd"===t?-1!==(i=we.call(this._weekdaysParse,a))?i:null:"ddd"===t?-1!==(i=we.call(this._shortWeekdaysParse,a))?i:null:-1!==(i=we.call(this._minWeekdaysParse,a))?i:null:"dddd"===t?-1!==(i=we.call(this._weekdaysParse,a))||-1!==(i=we.call(this._shortWeekdaysParse,a))||-1!==(i=we.call(this._minWeekdaysParse,a))?i:null:"ddd"===t?-1!==(i=we.call(this._shortWeekdaysParse,a))||-1!==(i=we.call(this._weekdaysParse,a))||-1!==(i=we.call(this._minWeekdaysParse,a))?i:null:-1!==(i=we.call(this._minWeekdaysParse,a))||-1!==(i=we.call(this._weekdaysParse,a))||-1!==(i=we.call(this._shortWeekdaysParse,a))?i:null}.call(this,e,t,n);for(this._weekdaysParse||(this._weekdaysParse=[],this._minWeekdaysParse=[],this._shortWeekdaysParse=[],this._fullWeekdaysParse=[]),s=0;s<7;s++){if(i=_([2e3,1]).day(s),n&&!this._fullWeekdaysParse[s]&&(this._fullWeekdaysParse[s]=new RegExp("^"+this.weekdays(i,"").replace(".","\\.?")+"$","i"),this._shortWeekdaysParse[s]=new RegExp("^"+this.weekdaysShort(i,"").replace(".","\\.?")+"$","i"),this._minWeekdaysParse[s]=new RegExp("^"+this.weekdaysMin(i,"").replace(".","\\.?")+"$","i")),this._weekdaysParse[s]||(r="^"+this.weekdays(i,"")+"|^"+this.weekdaysShort(i,"")+"|^"+this.weekdaysMin(i,""),this._weekdaysParse[s]=new RegExp(r.replace(".",""),"i")),n&&"dddd"===t&&this._fullWeekdaysParse[s].test(e))return s;if(n&&"ddd"===t&&this._shortWeekdaysParse[s].test(e))return s;if(n&&"dd"===t&&this._minWeekdaysParse[s].test(e))return s;if(!n&&this._weekdaysParse[s].test(e))return s}},kn.weekdaysRegex=function(e){return this._weekdaysParseExact?(m(this,"_weekdaysRegex")||Qe.call(this),e?this._weekdaysStrictRegex:this._weekdaysRegex):(m(this,"_weekdaysRegex")||(this._weekdaysRegex=qe),this._weekdaysStrictRegex&&e?this._weekdaysStrictRegex:this._weekdaysRegex)},kn.weekdaysShortRegex=function(e){return this._weekdaysParseExact?(m(this,"_weekdaysRegex")||Qe.call(this),e?this._weekdaysShortStrictRegex:this._weekdaysShortRegex):(m(this,"_weekdaysShortRegex")||(this._weekdaysShortRegex=Be),this._weekdaysShortStrictRegex&&e?this._weekdaysShortStrictRegex:this._weekdaysShortRegex)},kn.weekdaysMinRegex=function(e){return this._weekdaysParseExact?(m(this,"_weekdaysRegex")||Qe.call(this),e?this._weekdaysMinStrictRegex:this._weekdaysMinRegex):(m(this,"_weekdaysMinRegex")||(this._weekdaysMinRegex=Je),this._weekdaysMinStrictRegex&&e?this._weekdaysMinStrictRegex:this._weekdaysMinRegex)},kn.isPM=function(e){return"p"===(e+"").toLowerCase().charAt(0)},kn.meridiem=function(e,t,n){return 11<e?n?"pm":"PM":n?"am":"AM"},lt("en",{eras:[{since:"0001-01-01",until:1/0,offset:1,name:"Anno Domini",narrow:"AD",abbr:"AD"},{since:"0000-12-31",until:-1/0,offset:1,name:"Before Christ",narrow:"BC",abbr:"BC"}],dayOfMonthOrdinalParse:/\d{1,2}(th|st|nd|rd)/,ordinal:function(e){var t=e%10;return e+(1===Z(e%100/10)?"th":1==t?"st":2==t?"nd":3==t?"rd":"th")}}),f.lang=n("moment.lang is deprecated. Use moment.locale instead.",lt),f.langData=n("moment.langData is deprecated. Use moment.localeData instead.",dt);var Yn=Math.abs;function On(e,t,n,s){var i=Zt(t,n);return e._milliseconds+=s*i._milliseconds,e._days+=s*i._days,e._months+=s*i._months,e._bubble()}function bn(e){return e<0?Math.floor(e):Math.ceil(e)}function xn(e){return 4800*e/146097}function Tn(e){return 146097*e/4800}function Nn(e){return function(){return this.as(e)}}var Pn=Nn("ms"),Rn=Nn("s"),Wn=Nn("m"),Cn=Nn("h"),Un=Nn("d"),Hn=Nn("w"),Fn=Nn("M"),Ln=Nn("Q"),Vn=Nn("y");function Gn(e){return function(){return this.isValid()?this._data[e]:NaN}}var En=Gn("milliseconds"),An=Gn("seconds"),jn=Gn("minutes"),In=Gn("hours"),Zn=Gn("days"),zn=Gn("months"),$n=Gn("years");var qn=Math.round,Bn={ss:44,s:45,m:45,h:22,d:26,w:null,M:11};function Jn(e,t,n,s){var i=Zt(e).abs(),r=qn(i.as("s")),a=qn(i.as("m")),o=qn(i.as("h")),u=qn(i.as("d")),l=qn(i.as("M")),h=qn(i.as("w")),d=qn(i.as("y")),c=(r<=n.ss?["s",r]:r<n.s&&["ss",r])||a<=1&&["m"]||a<n.m&&["mm",a]||o<=1&&["h"]||o<n.h&&["hh",o]||u<=1&&["d"]||u<n.d&&["dd",u];return null!=n.w&&(c=c||h<=1&&["w"]||h<n.w&&["ww",h]),(c=c||l<=1&&["M"]||l<n.M&&["MM",l]||d<=1&&["y"]||["yy",d])[2]=t,c[3]=0<+e,c[4]=s,function(e,t,n,s,i){return i.relativeTime(t||1,!!n,e,s)}.apply(null,c)}var Qn=Math.abs;function Xn(e){return(0<e)-(e<0)||+e}function Kn(){if(!this.isValid())return this.localeData().invalidDate();var e,t,n,s,i,r,a,o,u=Qn(this._milliseconds)/1e3,l=Qn(this._days),h=Qn(this._months),d=this.asSeconds();return d?(e=I(u/60),t=I(e/60),u%=60,e%=60,n=I(h/12),h%=12,s=u?u.toFixed(3).replace(/\.?0+$/,""):"",i=d<0?"-":"",r=Xn(this._months)!==Xn(d)?"-":"",a=Xn(this._days)!==Xn(d)?"-":"",o=Xn(this._milliseconds)!==Xn(d)?"-":"",i+"P"+(n?r+n+"Y":"")+(h?r+h+"M":"")+(l?a+l+"D":"")+(t||e||u?"T":"")+(t?o+t+"H":"")+(e?o+e+"M":"")+(u?o+s+"S":"")):"P0D"}var es=Ct.prototype;return es.isValid=function(){return this._isValid},es.abs=function(){var e=this._data;return this._milliseconds=Yn(this._milliseconds),this._days=Yn(this._days),this._months=Yn(this._months),e.milliseconds=Yn(e.milliseconds),e.seconds=Yn(e.seconds),e.minutes=Yn(e.minutes),e.hours=Yn(e.hours),e.months=Yn(e.months),e.years=Yn(e.years),this},es.add=function(e,t){return On(this,e,t,1)},es.subtract=function(e,t){return On(this,e,t,-1)},es.as=function(e){if(!this.isValid())return NaN;var t,n,s=this._milliseconds;if("month"===(e=V(e))||"quarter"===e||"year"===e)switch(t=this._days+s/864e5,n=this._months+xn(t),e){case"month":return n;case"quarter":return n/3;case"year":return n/12}else switch(t=this._days+Math.round(Tn(this._months)),e){case"week":return t/7+s/6048e5;case"day":return t+s/864e5;case"hour":return 24*t+s/36e5;case"minute":return 1440*t+s/6e4;case"second":return 86400*t+s/1e3;case"millisecond":return Math.floor(864e5*t)+s;default:throw new Error("Unknown unit "+e)}},es.asMilliseconds=Pn,es.asSeconds=Rn,es.asMinutes=Wn,es.asHours=Cn,es.asDays=Un,es.asWeeks=Hn,es.asMonths=Fn,es.asQuarters=Ln,es.asYears=Vn,es.valueOf=function(){return this.isValid()?this._milliseconds+864e5*this._days+this._months%12*2592e6+31536e6*Z(this._months/12):NaN},es._bubble=function(){var e,t,n,s,i,r=this._milliseconds,a=this._days,o=this._months,u=this._data;return 0<=r&&0<=a&&0<=o||r<=0&&a<=0&&o<=0||(r+=864e5*bn(Tn(o)+a),o=a=0),u.milliseconds=r%1e3,e=I(r/1e3),u.seconds=e%60,t=I(e/60),u.minutes=t%60,n=I(t/60),u.hours=n%24,a+=I(n/24),o+=i=I(xn(a)),a-=bn(Tn(i)),s=I(o/12),o%=12,u.days=a,u.months=o,u.years=s,this},es.clone=function(){return Zt(this)},es.get=function(e){return e=V(e),this.isValid()?this[e+"s"]():NaN},es.milliseconds=En,es.seconds=An,es.minutes=jn,es.hours=In,es.days=Zn,es.weeks=function(){return I(this.days()/7)},es.months=zn,es.years=$n,es.humanize=function(e,t){if(!this.isValid())return this.localeData().invalidDate();var n,s,i=!1,r=Bn;return"object"==typeof e&&(t=e,e=!1),"boolean"==typeof e&&(i=e),"object"==typeof t&&(r=Object.assign({},Bn,t),null!=t.s&&null==t.ss&&(r.ss=t.s-1)),n=this.localeData(),s=Jn(this,!i,r,n),i&&(s=n.pastFuture(+this,s)),n.postformat(s)},es.toISOString=Kn,es.toString=Kn,es.toJSON=Kn,es.locale=tn,es.localeData=sn,es.toIsoString=n("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",Kn),es.lang=nn,C("X",0,0,"unix"),C("x",0,0,"valueOf"),ce("x",ue),ce("X",/[+-]?\d+(\.\d{1,3})?/),ye("X",function(e,t,n){n._d=new Date(1e3*parseFloat(e))}),ye("x",function(e,t,n){n._d=new Date(Z(e))}),f.version="2.29.1",e=Tt,f.fn=pn,f.min=function(){return Rt("isBefore",[].slice.call(arguments,0))},f.max=function(){return Rt("isAfter",[].slice.call(arguments,0))},f.now=function(){return Date.now?Date.now():+new Date},f.utc=_,f.unix=function(e){return Tt(1e3*e)},f.months=function(e,t){return Dn(e,t,"months")},f.isDate=a,f.locale=lt,f.invalid=w,f.duration=Zt,f.isMoment=M,f.weekdays=function(e,t,n){return Sn(e,t,n,"weekdays")},f.parseZone=function(){return Tt.apply(null,arguments).parseZone()},f.localeData=dt,f.isDuration=Ut,f.monthsShort=function(e,t){return Dn(e,t,"monthsShort")},f.weekdaysMin=function(e,t,n){return Sn(e,t,n,"weekdaysMin")},f.defineLocale=ht,f.updateLocale=function(e,t){var n,s,i;return null!=t?(i=st,null!=it[e]&&null!=it[e].parentLocale?it[e].set(b(it[e]._config,t)):(null!=(s=ut(e))&&(i=s._config),t=b(i,t),null==s&&(t.abbr=e),(n=new x(t)).parentLocale=it[e],it[e]=n),lt(e)):null!=it[e]&&(null!=it[e].parentLocale?(it[e]=it[e].parentLocale,e===lt()&&lt(e)):null!=it[e]&&delete it[e]),it[e]},f.locales=function(){return s(it)},f.weekdaysShort=function(e,t,n){return Sn(e,t,n,"weekdaysShort")},f.normalizeUnits=V,f.relativeTimeRounding=function(e){return void 0===e?qn:"function"==typeof e&&(qn=e,!0)},f.relativeTimeThreshold=function(e,t){return void 0!==Bn[e]&&(void 0===t?Bn[e]:(Bn[e]=t,"s"===e&&(Bn.ss=t-1),!0))},f.calendarFormat=function(e,t){var n=e.diff(t,"days",!0);return n<-6?"sameElse":n<-1?"lastWeek":n<0?"lastDay":n<1?"sameDay":n<2?"nextDay":n<7?"nextWeek":"sameElse"},f.prototype=pn,f.HTML5_FMT={DATETIME_LOCAL:"YYYY-MM-DDTHH:mm",DATETIME_LOCAL_SECONDS:"YYYY-MM-DDTHH:mm:ss",DATETIME_LOCAL_MS:"YYYY-MM-DDTHH:mm:ss.SSS",DATE:"YYYY-MM-DD",TIME:"HH:mm",TIME_SECONDS:"HH:mm:ss",TIME_MS:"HH:mm:ss.SSS",WEEK:"GGGG-[W]WW",MONTH:"YYYY-MM"},f});
//# sourceMappingURL=moment.min.js.map
TP.boot.$$srcPath = '';

        
        TP.registerExternalObject('moment', window.moment);
        
    
TP.boot.$$srcPath = '~lib_deps/cryptojs/CryptoJS-core-tpi.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
/*
CryptoJS v3.1.2
code.google.com/p/crypto-js
(c) 2009-2013 by Jeff Mott. All rights reserved.
code.google.com/p/crypto-js/wiki/License
*/
/**
 * CryptoJS core components.
 */
var CryptoJS = CryptoJS || (function (Math, undefined) {
    /**
     * CryptoJS namespace.
     */
    var C = {};

    /**
     * Library namespace.
     */
    var C_lib = C.lib = {};

    /**
     * Base object for prototypal inheritance.
     */
    var Base = C_lib.Base = (function () {
        function F() {}

        return {
            /**
             * Creates a new object that inherits from this object.
             *
             * @param {Object} overrides Properties to copy into the new object.
             *
             * @return {Object} The new object.
             *
             * @static
             *
             * @example
             *
             *     var MyType = CryptoJS.lib.Base.extend({
             *         field: 'value',
             *
             *         method: function () {
             *         }
             *     });
             */
            extend: function (overrides) {
                // Spawn
                F.prototype = this;
                var subtype = new F();

                // Augment
                if (overrides) {
                    subtype.mixIn(overrides);
                }

                // Create default initializer
                if (!subtype.hasOwnProperty('init')) {
                    subtype.init = function () {
                        subtype.$super.init.apply(this, arguments);
                    };
                }

                // Initializer's prototype is the subtype object
                subtype.init.prototype = subtype;

                // Reference supertype
                subtype.$super = this;

                return subtype;
            },

            /**
             * Extends this object and runs the init method.
             * Arguments to create() will be passed to init().
             *
             * @return {Object} The new object.
             *
             * @static
             *
             * @example
             *
             *     var instance = MyType.create();
             */
            create: function () {
                var instance = this.extend();
                instance.init.apply(instance, arguments);

                return instance;
            },

            /**
             * Initializes a newly created object.
             * Override this method to add some logic when your objects are created.
             *
             * @example
             *
             *     var MyType = CryptoJS.lib.Base.extend({
             *         init: function () {
             *             // ...
             *         }
             *     });
             */
            init: function () {
            },

            /**
             * Copies properties into this object.
             *
             * @param {Object} properties The properties to mix in.
             *
             * @example
             *
             *     MyType.mixIn({
             *         field: 'value'
             *     });
             */
            mixIn: function (properties) {
                for (var propertyName in properties) {
                    if (properties.hasOwnProperty(propertyName)) {
                        this[propertyName] = properties[propertyName];
                    }
                }

                // IE won't copy toString using the loop above
                if (properties.hasOwnProperty('toString')) {
                    this.toString = properties.toString;
                }
            },

            /**
             * Creates a copy of this object.
             *
             * @return {Object} The clone.
             *
             * @example
             *
             *     var clone = instance.clone();
             */
            clone: function () {
                return this.init.prototype.extend(this);
            }
        };
    }());

    /**
     * An array of 32-bit words.
     *
     * @property {Array} words The array of 32-bit words.
     * @property {number} sigBytes The number of significant bytes in this word array.
     */
    var WordArray = C_lib.WordArray = Base.extend({
        /**
         * Initializes a newly created word array.
         *
         * @param {Array} words (Optional) An array of 32-bit words.
         * @param {number} sigBytes (Optional) The number of significant bytes in the words.
         *
         * @example
         *
         *     var wordArray = CryptoJS.lib.WordArray.create();
         *     var wordArray = CryptoJS.lib.WordArray.create([0x00010203, 0x04050607]);
         *     var wordArray = CryptoJS.lib.WordArray.create([0x00010203, 0x04050607], 6);
         */
        init: function (words, sigBytes) {
            words = this.words = words || [];

            if (sigBytes != undefined) {
                this.sigBytes = sigBytes;
            } else {
                this.sigBytes = words.length * 4;
            }
        },

        /**
         * Converts this word array to a string.
         *
         * @param {Encoder} encoder (Optional) The encoding strategy to use. Default: CryptoJS.enc.Hex
         *
         * @return {string} The stringified word array.
         *
         * @example
         *
         *     var string = wordArray + '';
         *     var string = wordArray.toString();
         *     var string = wordArray.toString(CryptoJS.enc.Utf8);
         */
        toString: function (encoder) {
            return (encoder || Hex).stringify(this);
        },

        /**
         * Concatenates a word array to this word array.
         *
         * @param {WordArray} wordArray The word array to append.
         *
         * @return {WordArray} This word array.
         *
         * @example
         *
         *     wordArray1.concat(wordArray2);
         */
        concat: function (wordArray) {
            // Shortcuts
            var thisWords = this.words;
            var thatWords = wordArray.words;
            var thisSigBytes = this.sigBytes;
            var thatSigBytes = wordArray.sigBytes;

            // Clamp excess bits
            this.clamp();

            // Concat
            if (thisSigBytes % 4) {
                // Copy one byte at a time
                for (var i = 0; i < thatSigBytes; i++) {
                    var thatByte = (thatWords[i >>> 2] >>> (24 - (i % 4) * 8)) & 0xff;
                    thisWords[(thisSigBytes + i) >>> 2] |= thatByte << (24 - ((thisSigBytes + i) % 4) * 8);
                }
            } else if (thatWords.length > 0xffff) {
                // Copy one word at a time
                for (var i = 0; i < thatSigBytes; i += 4) {
                    thisWords[(thisSigBytes + i) >>> 2] = thatWords[i >>> 2];
                }
            } else {
                // Copy all words at once
                thisWords.push.apply(thisWords, thatWords);
            }
            this.sigBytes += thatSigBytes;

            // Chainable
            return this;
        },

        /**
         * Removes insignificant bits.
         *
         * @example
         *
         *     wordArray.clamp();
         */
        clamp: function () {
            // Shortcuts
            var words = this.words;
            var sigBytes = this.sigBytes;

            // Clamp
            words[sigBytes >>> 2] &= 0xffffffff << (32 - (sigBytes % 4) * 8);
            words.length = Math.ceil(sigBytes / 4);
        },

        /**
         * Creates a copy of this word array.
         *
         * @return {WordArray} The clone.
         *
         * @example
         *
         *     var clone = wordArray.clone();
         */
        clone: function () {
            var clone = Base.clone.call(this);
            clone.words = this.words.slice(0);

            return clone;
        },

        /**
         * Creates a word array filled with random bytes.
         *
         * @param {number} nBytes The number of random bytes to generate.
         *
         * @return {WordArray} The random word array.
         *
         * @static
         *
         * @example
         *
         *     var wordArray = CryptoJS.lib.WordArray.random(16);
         */
        random: function (nBytes) {
            var words = [];
            for (var i = 0; i < nBytes; i += 4) {
                words.push((Math.random() * 0x100000000) | 0);
            }

            return new WordArray.init(words, nBytes);
        }
    });

    /**
     * Encoder namespace.
     */
    var C_enc = C.enc = {};

    /**
     * Hex encoding strategy.
     */
    var Hex = C_enc.Hex = {
        /**
         * Converts a word array to a hex string.
         *
         * @param {WordArray} wordArray The word array.
         *
         * @return {string} The hex string.
         *
         * @static
         *
         * @example
         *
         *     var hexString = CryptoJS.enc.Hex.stringify(wordArray);
         */
        stringify: function (wordArray) {
            // Shortcuts
            var words = wordArray.words;
            var sigBytes = wordArray.sigBytes;

            // Convert
            var hexChars = [];
            for (var i = 0; i < sigBytes; i++) {
                var bite = (words[i >>> 2] >>> (24 - (i % 4) * 8)) & 0xff;
                hexChars.push((bite >>> 4).toString(16));
                hexChars.push((bite & 0x0f).toString(16));
            }

            return hexChars.join('');
        },

        /**
         * Converts a hex string to a word array.
         *
         * @param {string} hexStr The hex string.
         *
         * @return {WordArray} The word array.
         *
         * @static
         *
         * @example
         *
         *     var wordArray = CryptoJS.enc.Hex.parse(hexString);
         */
        parse: function (hexStr) {
            // Shortcut
            var hexStrLength = hexStr.length;

            // Convert
            var words = [];
            for (var i = 0; i < hexStrLength; i += 2) {
                words[i >>> 3] |= parseInt(hexStr.substr(i, 2), 16) << (24 - (i % 8) * 4);
            }

            return new WordArray.init(words, hexStrLength / 2);
        }
    };

    /**
     * Latin1 encoding strategy.
     */
    var Latin1 = C_enc.Latin1 = {
        /**
         * Converts a word array to a Latin1 string.
         *
         * @param {WordArray} wordArray The word array.
         *
         * @return {string} The Latin1 string.
         *
         * @static
         *
         * @example
         *
         *     var latin1String = CryptoJS.enc.Latin1.stringify(wordArray);
         */
        stringify: function (wordArray) {
            // Shortcuts
            var words = wordArray.words;
            var sigBytes = wordArray.sigBytes;

            // Convert
            var latin1Chars = [];
            for (var i = 0; i < sigBytes; i++) {
                var bite = (words[i >>> 2] >>> (24 - (i % 4) * 8)) & 0xff;
                latin1Chars.push(String.fromCharCode(bite));
            }

            return latin1Chars.join('');
        },

        /**
         * Converts a Latin1 string to a word array.
         *
         * @param {string} latin1Str The Latin1 string.
         *
         * @return {WordArray} The word array.
         *
         * @static
         *
         * @example
         *
         *     var wordArray = CryptoJS.enc.Latin1.parse(latin1String);
         */
        parse: function (latin1Str) {
            // Shortcut
            var latin1StrLength = latin1Str.length;

            // Convert
            var words = [];
            for (var i = 0; i < latin1StrLength; i++) {
                words[i >>> 2] |= (latin1Str.charCodeAt(i) & 0xff) << (24 - (i % 4) * 8);
            }

            return new WordArray.init(words, latin1StrLength);
        }
    };

    /**
     * UTF-8 encoding strategy.
     */
    var Utf8 = C_enc.Utf8 = {
        /**
         * Converts a word array to a UTF-8 string.
         *
         * @param {WordArray} wordArray The word array.
         *
         * @return {string} The UTF-8 string.
         *
         * @static
         *
         * @example
         *
         *     var utf8String = CryptoJS.enc.Utf8.stringify(wordArray);
         */
        stringify: function (wordArray) {
            try {
                return decodeURIComponent(escape(Latin1.stringify(wordArray)));
            } catch (e) {
                throw new Error('Malformed UTF-8 data');
            }
        },

        /**
         * Converts a UTF-8 string to a word array.
         *
         * @param {string} utf8Str The UTF-8 string.
         *
         * @return {WordArray} The word array.
         *
         * @static
         *
         * @example
         *
         *     var wordArray = CryptoJS.enc.Utf8.parse(utf8String);
         */
        parse: function (utf8Str) {
            return Latin1.parse(unescape(encodeURIComponent(utf8Str)));
        }
    };

    /**
     * Abstract buffered block algorithm template.
     *
     * The property blockSize must be implemented in a concrete subtype.
     *
     * @property {number} _minBufferSize The number of blocks that should be kept unprocessed in the buffer. Default: 0
     */
    var BufferedBlockAlgorithm = C_lib.BufferedBlockAlgorithm = Base.extend({
        /**
         * Resets this block algorithm's data buffer to its initial state.
         *
         * @example
         *
         *     bufferedBlockAlgorithm.reset();
         */
        reset: function () {
            // Initial values
            this._data = new WordArray.init();
            this._nDataBytes = 0;
        },

        /**
         * Adds new data to this block algorithm's buffer.
         *
         * @param {WordArray|string} data The data to append. Strings are converted to a WordArray using UTF-8.
         *
         * @example
         *
         *     bufferedBlockAlgorithm._append('data');
         *     bufferedBlockAlgorithm._append(wordArray);
         */
        _append: function (data) {
            // Convert string to WordArray, else assume WordArray already
            if (typeof data == 'string') {
                data = Utf8.parse(data);
            }

            // Append
            this._data.concat(data);
            this._nDataBytes += data.sigBytes;
        },

        /**
         * Processes available data blocks.
         *
         * This method invokes _doProcessBlock(offset), which must be implemented by a concrete subtype.
         *
         * @param {boolean} doFlush Whether all blocks and partial blocks should be processed.
         *
         * @return {WordArray} The processed data.
         *
         * @example
         *
         *     var processedData = bufferedBlockAlgorithm._process();
         *     var processedData = bufferedBlockAlgorithm._process(!!'flush');
         */
        _process: function (doFlush) {
            // Shortcuts
            var data = this._data;
            var dataWords = data.words;
            var dataSigBytes = data.sigBytes;
            var blockSize = this.blockSize;
            var blockSizeBytes = blockSize * 4;

            // Count blocks ready
            var nBlocksReady = dataSigBytes / blockSizeBytes;
            if (doFlush) {
                // Round up to include partial blocks
                nBlocksReady = Math.ceil(nBlocksReady);
            } else {
                // Round down to include only full blocks,
                // less the number of blocks that must remain in the buffer
                nBlocksReady = Math.max((nBlocksReady | 0) - this._minBufferSize, 0);
            }

            // Count words ready
            var nWordsReady = nBlocksReady * blockSize;

            // Count bytes ready
            var nBytesReady = Math.min(nWordsReady * 4, dataSigBytes);

            // Process blocks
            if (nWordsReady) {
                for (var offset = 0; offset < nWordsReady; offset += blockSize) {
                    // Perform concrete-algorithm logic
                    this._doProcessBlock(dataWords, offset);
                }

                // Remove processed words
                var processedWords = dataWords.splice(0, nWordsReady);
                data.sigBytes -= nBytesReady;
            }

            // Return processed words
            return new WordArray.init(processedWords, nBytesReady);
        },

        /**
         * Creates a copy of this object.
         *
         * @return {Object} The clone.
         *
         * @example
         *
         *     var clone = bufferedBlockAlgorithm.clone();
         */
        clone: function () {
            var clone = Base.clone.call(this);
            clone._data = this._data.clone();

            return clone;
        },

        _minBufferSize: 0
    });

    /**
     * Abstract hasher template.
     *
     * @property {number} blockSize The number of 32-bit words this hasher operates on. Default: 16 (512 bits)
     */
    var Hasher = C_lib.Hasher = BufferedBlockAlgorithm.extend({
        /**
         * Configuration options.
         */
        cfg: Base.extend(),

        /**
         * Initializes a newly created hasher.
         *
         * @param {Object} cfg (Optional) The configuration options to use for this hash computation.
         *
         * @example
         *
         *     var hasher = CryptoJS.algo.SHA256.create();
         */
        init: function (cfg) {
            // Apply config defaults
            this.cfg = this.cfg.extend(cfg);

            // Set initial values
            this.reset();
        },

        /**
         * Resets this hasher to its initial state.
         *
         * @example
         *
         *     hasher.reset();
         */
        reset: function () {
            // Reset data buffer
            BufferedBlockAlgorithm.reset.call(this);

            // Perform concrete-hasher logic
            this._doReset();
        },

        /**
         * Updates this hasher with a message.
         *
         * @param {WordArray|string} messageUpdate The message to append.
         *
         * @return {Hasher} This hasher.
         *
         * @example
         *
         *     hasher.update('message');
         *     hasher.update(wordArray);
         */
        update: function (messageUpdate) {
            // Append
            this._append(messageUpdate);

            // Update the hash
            this._process();

            // Chainable
            return this;
        },

        /**
         * Finalizes the hash computation.
         * Note that the finalize operation is effectively a destructive, read-once operation.
         *
         * @param {WordArray|string} messageUpdate (Optional) A final message update.
         *
         * @return {WordArray} The hash.
         *
         * @example
         *
         *     var hash = hasher.finalize();
         *     var hash = hasher.finalize('message');
         *     var hash = hasher.finalize(wordArray);
         */
        finalize: function (messageUpdate) {
            // Final message update
            if (messageUpdate) {
                this._append(messageUpdate);
            }

            // Perform concrete-hasher logic
            var hash = this._doFinalize();

            return hash;
        },

        blockSize: 512/32,

        /**
         * Creates a shortcut function to a hasher's object interface.
         *
         * @param {Hasher} hasher The hasher to create a helper for.
         *
         * @return {Function} The shortcut function.
         *
         * @static
         *
         * @example
         *
         *     var SHA256 = CryptoJS.lib.Hasher._createHelper(CryptoJS.algo.SHA256);
         */
        _createHelper: function (hasher) {
            return function (message, cfg) {
                return new hasher.init(cfg).finalize(message);
            };
        },

        /**
         * Creates a shortcut function to the HMAC's object interface.
         *
         * @param {Hasher} hasher The hasher to use in this HMAC helper.
         *
         * @return {Function} The shortcut function.
         *
         * @static
         *
         * @example
         *
         *     var HmacSHA256 = CryptoJS.lib.Hasher._createHmacHelper(CryptoJS.algo.SHA256);
         */
        _createHmacHelper: function (hasher) {
            return function (message, key) {
                return new C_algo.HMAC.init(hasher, key).finalize(message);
            };
        }
    });

    /**
     * Algorithm namespace.
     */
    var C_algo = C.algo = {};

    return C;
}(Math));
TP.boot.$$srcPath = '~lib_deps/cryptojs/CryptoJS-md5-tpi.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
/*
CryptoJS v3.1.2
code.google.com/p/crypto-js
(c) 2009-2013 by Jeff Mott. All rights reserved.
code.google.com/p/crypto-js/wiki/License
*/
(function (Math) {
    // Shortcuts
    var C = CryptoJS;
    var C_lib = C.lib;
    var WordArray = C_lib.WordArray;
    var Hasher = C_lib.Hasher;
    var C_algo = C.algo;

    // Constants table
    var T = [];

    // Compute constants
    (function () {
        for (var i = 0; i < 64; i++) {
            T[i] = (Math.abs(Math.sin(i + 1)) * 0x100000000) | 0;
        }
    }());

    /**
     * MD5 hash algorithm.
     */
    var MD5 = C_algo.MD5 = Hasher.extend({
        _doReset: function () {
            this._hash = new WordArray.init([
                0x67452301, 0xefcdab89,
                0x98badcfe, 0x10325476
            ]);
        },

        _doProcessBlock: function (M, offset) {
            // Swap endian
            for (var i = 0; i < 16; i++) {
                // Shortcuts
                var offset_i = offset + i;
                var M_offset_i = M[offset_i];

                M[offset_i] = (
                    (((M_offset_i << 8)  | (M_offset_i >>> 24)) & 0x00ff00ff) |
                    (((M_offset_i << 24) | (M_offset_i >>> 8))  & 0xff00ff00)
                );
            }

            // Shortcuts
            var H = this._hash.words;

            var M_offset_0  = M[offset + 0];
            var M_offset_1  = M[offset + 1];
            var M_offset_2  = M[offset + 2];
            var M_offset_3  = M[offset + 3];
            var M_offset_4  = M[offset + 4];
            var M_offset_5  = M[offset + 5];
            var M_offset_6  = M[offset + 6];
            var M_offset_7  = M[offset + 7];
            var M_offset_8  = M[offset + 8];
            var M_offset_9  = M[offset + 9];
            var M_offset_10 = M[offset + 10];
            var M_offset_11 = M[offset + 11];
            var M_offset_12 = M[offset + 12];
            var M_offset_13 = M[offset + 13];
            var M_offset_14 = M[offset + 14];
            var M_offset_15 = M[offset + 15];

            // Working varialbes
            var a = H[0];
            var b = H[1];
            var c = H[2];
            var d = H[3];

            // Computation
            a = FF(a, b, c, d, M_offset_0,  7,  T[0]);
            d = FF(d, a, b, c, M_offset_1,  12, T[1]);
            c = FF(c, d, a, b, M_offset_2,  17, T[2]);
            b = FF(b, c, d, a, M_offset_3,  22, T[3]);
            a = FF(a, b, c, d, M_offset_4,  7,  T[4]);
            d = FF(d, a, b, c, M_offset_5,  12, T[5]);
            c = FF(c, d, a, b, M_offset_6,  17, T[6]);
            b = FF(b, c, d, a, M_offset_7,  22, T[7]);
            a = FF(a, b, c, d, M_offset_8,  7,  T[8]);
            d = FF(d, a, b, c, M_offset_9,  12, T[9]);
            c = FF(c, d, a, b, M_offset_10, 17, T[10]);
            b = FF(b, c, d, a, M_offset_11, 22, T[11]);
            a = FF(a, b, c, d, M_offset_12, 7,  T[12]);
            d = FF(d, a, b, c, M_offset_13, 12, T[13]);
            c = FF(c, d, a, b, M_offset_14, 17, T[14]);
            b = FF(b, c, d, a, M_offset_15, 22, T[15]);

            a = GG(a, b, c, d, M_offset_1,  5,  T[16]);
            d = GG(d, a, b, c, M_offset_6,  9,  T[17]);
            c = GG(c, d, a, b, M_offset_11, 14, T[18]);
            b = GG(b, c, d, a, M_offset_0,  20, T[19]);
            a = GG(a, b, c, d, M_offset_5,  5,  T[20]);
            d = GG(d, a, b, c, M_offset_10, 9,  T[21]);
            c = GG(c, d, a, b, M_offset_15, 14, T[22]);
            b = GG(b, c, d, a, M_offset_4,  20, T[23]);
            a = GG(a, b, c, d, M_offset_9,  5,  T[24]);
            d = GG(d, a, b, c, M_offset_14, 9,  T[25]);
            c = GG(c, d, a, b, M_offset_3,  14, T[26]);
            b = GG(b, c, d, a, M_offset_8,  20, T[27]);
            a = GG(a, b, c, d, M_offset_13, 5,  T[28]);
            d = GG(d, a, b, c, M_offset_2,  9,  T[29]);
            c = GG(c, d, a, b, M_offset_7,  14, T[30]);
            b = GG(b, c, d, a, M_offset_12, 20, T[31]);

            a = HH(a, b, c, d, M_offset_5,  4,  T[32]);
            d = HH(d, a, b, c, M_offset_8,  11, T[33]);
            c = HH(c, d, a, b, M_offset_11, 16, T[34]);
            b = HH(b, c, d, a, M_offset_14, 23, T[35]);
            a = HH(a, b, c, d, M_offset_1,  4,  T[36]);
            d = HH(d, a, b, c, M_offset_4,  11, T[37]);
            c = HH(c, d, a, b, M_offset_7,  16, T[38]);
            b = HH(b, c, d, a, M_offset_10, 23, T[39]);
            a = HH(a, b, c, d, M_offset_13, 4,  T[40]);
            d = HH(d, a, b, c, M_offset_0,  11, T[41]);
            c = HH(c, d, a, b, M_offset_3,  16, T[42]);
            b = HH(b, c, d, a, M_offset_6,  23, T[43]);
            a = HH(a, b, c, d, M_offset_9,  4,  T[44]);
            d = HH(d, a, b, c, M_offset_12, 11, T[45]);
            c = HH(c, d, a, b, M_offset_15, 16, T[46]);
            b = HH(b, c, d, a, M_offset_2,  23, T[47]);

            a = II(a, b, c, d, M_offset_0,  6,  T[48]);
            d = II(d, a, b, c, M_offset_7,  10, T[49]);
            c = II(c, d, a, b, M_offset_14, 15, T[50]);
            b = II(b, c, d, a, M_offset_5,  21, T[51]);
            a = II(a, b, c, d, M_offset_12, 6,  T[52]);
            d = II(d, a, b, c, M_offset_3,  10, T[53]);
            c = II(c, d, a, b, M_offset_10, 15, T[54]);
            b = II(b, c, d, a, M_offset_1,  21, T[55]);
            a = II(a, b, c, d, M_offset_8,  6,  T[56]);
            d = II(d, a, b, c, M_offset_15, 10, T[57]);
            c = II(c, d, a, b, M_offset_6,  15, T[58]);
            b = II(b, c, d, a, M_offset_13, 21, T[59]);
            a = II(a, b, c, d, M_offset_4,  6,  T[60]);
            d = II(d, a, b, c, M_offset_11, 10, T[61]);
            c = II(c, d, a, b, M_offset_2,  15, T[62]);
            b = II(b, c, d, a, M_offset_9,  21, T[63]);

            // Intermediate hash value
            H[0] = (H[0] + a) | 0;
            H[1] = (H[1] + b) | 0;
            H[2] = (H[2] + c) | 0;
            H[3] = (H[3] + d) | 0;
        },

        _doFinalize: function () {
            // Shortcuts
            var data = this._data;
            var dataWords = data.words;

            var nBitsTotal = this._nDataBytes * 8;
            var nBitsLeft = data.sigBytes * 8;

            // Add padding
            dataWords[nBitsLeft >>> 5] |= 0x80 << (24 - nBitsLeft % 32);

            var nBitsTotalH = Math.floor(nBitsTotal / 0x100000000);
            var nBitsTotalL = nBitsTotal;
            dataWords[(((nBitsLeft + 64) >>> 9) << 4) + 15] = (
                (((nBitsTotalH << 8)  | (nBitsTotalH >>> 24)) & 0x00ff00ff) |
                (((nBitsTotalH << 24) | (nBitsTotalH >>> 8))  & 0xff00ff00)
            );
            dataWords[(((nBitsLeft + 64) >>> 9) << 4) + 14] = (
                (((nBitsTotalL << 8)  | (nBitsTotalL >>> 24)) & 0x00ff00ff) |
                (((nBitsTotalL << 24) | (nBitsTotalL >>> 8))  & 0xff00ff00)
            );

            data.sigBytes = (dataWords.length + 1) * 4;

            // Hash final blocks
            this._process();

            // Shortcuts
            var hash = this._hash;
            var H = hash.words;

            // Swap endian
            for (var i = 0; i < 4; i++) {
                // Shortcut
                var H_i = H[i];

                H[i] = (((H_i << 8)  | (H_i >>> 24)) & 0x00ff00ff) |
                       (((H_i << 24) | (H_i >>> 8))  & 0xff00ff00);
            }

            // Return final computed hash
            return hash;
        },

        clone: function () {
            var clone = Hasher.clone.call(this);
            clone._hash = this._hash.clone();

            return clone;
        }
    });

    function FF(a, b, c, d, x, s, t) {
        var n = a + ((b & c) | (~b & d)) + x + t;
        return ((n << s) | (n >>> (32 - s))) + b;
    }

    function GG(a, b, c, d, x, s, t) {
        var n = a + ((b & d) | (c & ~d)) + x + t;
        return ((n << s) | (n >>> (32 - s))) + b;
    }

    function HH(a, b, c, d, x, s, t) {
        var n = a + (b ^ c ^ d) + x + t;
        return ((n << s) | (n >>> (32 - s))) + b;
    }

    function II(a, b, c, d, x, s, t) {
        var n = a + (c ^ (b | ~d)) + x + t;
        return ((n << s) | (n >>> (32 - s))) + b;
    }

    /**
     * Shortcut function to the hasher's object interface.
     *
     * @param {WordArray|string} message The message to hash.
     *
     * @return {WordArray} The hash.
     *
     * @static
     *
     * @example
     *
     *     var hash = CryptoJS.MD5('message');
     *     var hash = CryptoJS.MD5(wordArray);
     */
    C.MD5 = Hasher._createHelper(MD5);

    /**
     * Shortcut function to the HMAC's object interface.
     *
     * @param {WordArray|string} message The message to hash.
     * @param {WordArray|string} key The secret key.
     *
     * @return {WordArray} The HMAC.
     *
     * @static
     *
     * @example
     *
     *     var hmac = CryptoJS.HmacMD5(message, key);
     */
    C.HmacMD5 = Hasher._createHmacHelper(MD5);
}(Math));
TP.boot.$$srcPath = '~lib_deps/cryptojs/CryptoJS-sha1-tpi.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
/*
CryptoJS v3.1.2
code.google.com/p/crypto-js
(c) 2009-2013 by Jeff Mott. All rights reserved.
code.google.com/p/crypto-js/wiki/License
*/
(function () {
    // Shortcuts
    var C = CryptoJS;
    var C_lib = C.lib;
    var WordArray = C_lib.WordArray;
    var Hasher = C_lib.Hasher;
    var C_algo = C.algo;

    // Reusable object
    var W = [];

    /**
     * SHA-1 hash algorithm.
     */
    var SHA1 = C_algo.SHA1 = Hasher.extend({
        _doReset: function () {
            this._hash = new WordArray.init([
                0x67452301, 0xefcdab89,
                0x98badcfe, 0x10325476,
                0xc3d2e1f0
            ]);
        },

        _doProcessBlock: function (M, offset) {
            // Shortcut
            var H = this._hash.words;

            // Working variables
            var a = H[0];
            var b = H[1];
            var c = H[2];
            var d = H[3];
            var e = H[4];

            // Computation
            for (var i = 0; i < 80; i++) {
                if (i < 16) {
                    W[i] = M[offset + i] | 0;
                } else {
                    var n = W[i - 3] ^ W[i - 8] ^ W[i - 14] ^ W[i - 16];
                    W[i] = (n << 1) | (n >>> 31);
                }

                var t = ((a << 5) | (a >>> 27)) + e + W[i];
                if (i < 20) {
                    t += ((b & c) | (~b & d)) + 0x5a827999;
                } else if (i < 40) {
                    t += (b ^ c ^ d) + 0x6ed9eba1;
                } else if (i < 60) {
                    t += ((b & c) | (b & d) | (c & d)) - 0x70e44324;
                } else /* if (i < 80) */ {
                    t += (b ^ c ^ d) - 0x359d3e2a;
                }

                e = d;
                d = c;
                c = (b << 30) | (b >>> 2);
                b = a;
                a = t;
            }

            // Intermediate hash value
            H[0] = (H[0] + a) | 0;
            H[1] = (H[1] + b) | 0;
            H[2] = (H[2] + c) | 0;
            H[3] = (H[3] + d) | 0;
            H[4] = (H[4] + e) | 0;
        },

        _doFinalize: function () {
            // Shortcuts
            var data = this._data;
            var dataWords = data.words;

            var nBitsTotal = this._nDataBytes * 8;
            var nBitsLeft = data.sigBytes * 8;

            // Add padding
            dataWords[nBitsLeft >>> 5] |= 0x80 << (24 - nBitsLeft % 32);
            dataWords[(((nBitsLeft + 64) >>> 9) << 4) + 14] = Math.floor(nBitsTotal / 0x100000000);
            dataWords[(((nBitsLeft + 64) >>> 9) << 4) + 15] = nBitsTotal;
            data.sigBytes = dataWords.length * 4;

            // Hash final blocks
            this._process();

            // Return final computed hash
            return this._hash;
        },

        clone: function () {
            var clone = Hasher.clone.call(this);
            clone._hash = this._hash.clone();

            return clone;
        }
    });

    /**
     * Shortcut function to the hasher's object interface.
     *
     * @param {WordArray|string} message The message to hash.
     *
     * @return {WordArray} The hash.
     *
     * @static
     *
     * @example
     *
     *     var hash = CryptoJS.SHA1('message');
     *     var hash = CryptoJS.SHA1(wordArray);
     */
    C.SHA1 = Hasher._createHelper(SHA1);

    /**
     * Shortcut function to the HMAC's object interface.
     *
     * @param {WordArray|string} message The message to hash.
     * @param {WordArray|string} key The secret key.
     *
     * @return {WordArray} The HMAC.
     *
     * @static
     *
     * @example
     *
     *     var hmac = CryptoJS.HmacSHA1(message, key);
     */
    C.HmacSHA1 = Hasher._createHmacHelper(SHA1);
}());
TP.boot.$$srcPath = '~lib_deps/cryptojs/CryptoJS-enc-base64-tpi.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
/*
CryptoJS v3.1.2
code.google.com/p/crypto-js
(c) 2009-2013 by Jeff Mott. All rights reserved.
code.google.com/p/crypto-js/wiki/License
*/
(function () {
    // Shortcuts
    var C = CryptoJS;
    var C_lib = C.lib;
    var WordArray = C_lib.WordArray;
    var C_enc = C.enc;

    /**
     * Base64 encoding strategy.
     */
    var Base64 = C_enc.Base64 = {
        /**
         * Converts a word array to a Base64 string.
         *
         * @param {WordArray} wordArray The word array.
         *
         * @return {string} The Base64 string.
         *
         * @static
         *
         * @example
         *
         *     var base64String = CryptoJS.enc.Base64.stringify(wordArray);
         */
        stringify: function (wordArray) {
            // Shortcuts
            var words = wordArray.words;
            var sigBytes = wordArray.sigBytes;
            var map = this._map;

            // Clamp excess bits
            wordArray.clamp();

            // Convert
            var base64Chars = [];
            for (var i = 0; i < sigBytes; i += 3) {
                var byte1 = (words[i >>> 2]       >>> (24 - (i % 4) * 8))       & 0xff;
                var byte2 = (words[(i + 1) >>> 2] >>> (24 - ((i + 1) % 4) * 8)) & 0xff;
                var byte3 = (words[(i + 2) >>> 2] >>> (24 - ((i + 2) % 4) * 8)) & 0xff;

                var triplet = (byte1 << 16) | (byte2 << 8) | byte3;

                for (var j = 0; (j < 4) && (i + j * 0.75 < sigBytes); j++) {
                    base64Chars.push(map.charAt((triplet >>> (6 * (3 - j))) & 0x3f));
                }
            }

            // Add padding
            var paddingChar = map.charAt(64);
            if (paddingChar) {
                while (base64Chars.length % 4) {
                    base64Chars.push(paddingChar);
                }
            }

            return base64Chars.join('');
        },

        /**
         * Converts a Base64 string to a word array.
         *
         * @param {string} base64Str The Base64 string.
         *
         * @return {WordArray} The word array.
         *
         * @static
         *
         * @example
         *
         *     var wordArray = CryptoJS.enc.Base64.parse(base64String);
         */
        parse: function (base64Str) {
            // Shortcuts
            var base64StrLength = base64Str.length;
            var map = this._map;

            // Ignore padding
            var paddingChar = map.charAt(64);
            if (paddingChar) {
                var paddingIndex = base64Str.indexOf(paddingChar);
                if (paddingIndex != -1) {
                    base64StrLength = paddingIndex;
                }
            }

            // Convert
            var words = [];
            var nBytes = 0;
            for (var i = 0; i < base64StrLength; i++) {
                if (i % 4) {
                    var bits1 = map.indexOf(base64Str.charAt(i - 1)) << ((i % 4) * 2);
                    var bits2 = map.indexOf(base64Str.charAt(i)) >>> (6 - (i % 4) * 2);
                    words[nBytes >>> 2] |= (bits1 | bits2) << (24 - (nBytes % 4) * 8);
                    nBytes++;
                }
            }

            return WordArray.create(words, nBytes);
        },

        _map: 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/='
    };
}());
TP.boot.$$srcPath = '~lib_deps/cryptojs/CryptoJS-cipher-core-tpi.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
/*
CryptoJS v3.1.2
code.google.com/p/crypto-js
(c) 2009-2013 by Jeff Mott. All rights reserved.
code.google.com/p/crypto-js/wiki/License
*/
/**
 * Cipher core components.
 */
CryptoJS.lib.Cipher || (function (undefined) {
    // Shortcuts
    var C = CryptoJS;
    var C_lib = C.lib;
    var Base = C_lib.Base;
    var WordArray = C_lib.WordArray;
    var BufferedBlockAlgorithm = C_lib.BufferedBlockAlgorithm;
    var C_enc = C.enc;
    var Utf8 = C_enc.Utf8;
    var Base64 = C_enc.Base64;
    var C_algo = C.algo;
    var EvpKDF = C_algo.EvpKDF;

    /**
     * Abstract base cipher template.
     *
     * @property {number} keySize This cipher's key size. Default: 4 (128 bits)
     * @property {number} ivSize This cipher's IV size. Default: 4 (128 bits)
     * @property {number} _ENC_XFORM_MODE A constant representing encryption mode.
     * @property {number} _DEC_XFORM_MODE A constant representing decryption mode.
     */
    var Cipher = C_lib.Cipher = BufferedBlockAlgorithm.extend({
        /**
         * Configuration options.
         *
         * @property {WordArray} iv The IV to use for this operation.
         */
        cfg: Base.extend(),

        /**
         * Creates this cipher in encryption mode.
         *
         * @param {WordArray} key The key.
         * @param {Object} cfg (Optional) The configuration options to use for this operation.
         *
         * @return {Cipher} A cipher instance.
         *
         * @static
         *
         * @example
         *
         *     var cipher = CryptoJS.algo.AES.createEncryptor(keyWordArray, { iv: ivWordArray });
         */
        createEncryptor: function (key, cfg) {
            return this.create(this._ENC_XFORM_MODE, key, cfg);
        },

        /**
         * Creates this cipher in decryption mode.
         *
         * @param {WordArray} key The key.
         * @param {Object} cfg (Optional) The configuration options to use for this operation.
         *
         * @return {Cipher} A cipher instance.
         *
         * @static
         *
         * @example
         *
         *     var cipher = CryptoJS.algo.AES.createDecryptor(keyWordArray, { iv: ivWordArray });
         */
        createDecryptor: function (key, cfg) {
            return this.create(this._DEC_XFORM_MODE, key, cfg);
        },

        /**
         * Initializes a newly created cipher.
         *
         * @param {number} xformMode Either the encryption or decryption transormation mode constant.
         * @param {WordArray} key The key.
         * @param {Object} cfg (Optional) The configuration options to use for this operation.
         *
         * @example
         *
         *     var cipher = CryptoJS.algo.AES.create(CryptoJS.algo.AES._ENC_XFORM_MODE, keyWordArray, { iv: ivWordArray });
         */
        init: function (xformMode, key, cfg) {
            // Apply config defaults
            this.cfg = this.cfg.extend(cfg);

            // Store transform mode and key
            this._xformMode = xformMode;
            this._key = key;

            // Set initial values
            this.reset();
        },

        /**
         * Resets this cipher to its initial state.
         *
         * @example
         *
         *     cipher.reset();
         */
        reset: function () {
            // Reset data buffer
            BufferedBlockAlgorithm.reset.call(this);

            // Perform concrete-cipher logic
            this._doReset();
        },

        /**
         * Adds data to be encrypted or decrypted.
         *
         * @param {WordArray|string} dataUpdate The data to encrypt or decrypt.
         *
         * @return {WordArray} The data after processing.
         *
         * @example
         *
         *     var encrypted = cipher.process('data');
         *     var encrypted = cipher.process(wordArray);
         */
        process: function (dataUpdate) {
            // Append
            this._append(dataUpdate);

            // Process available blocks
            return this._process();
        },

        /**
         * Finalizes the encryption or decryption process.
         * Note that the finalize operation is effectively a destructive, read-once operation.
         *
         * @param {WordArray|string} dataUpdate The final data to encrypt or decrypt.
         *
         * @return {WordArray} The data after final processing.
         *
         * @example
         *
         *     var encrypted = cipher.finalize();
         *     var encrypted = cipher.finalize('data');
         *     var encrypted = cipher.finalize(wordArray);
         */
        finalize: function (dataUpdate) {
            // Final data update
            if (dataUpdate) {
                this._append(dataUpdate);
            }

            // Perform concrete-cipher logic
            var finalProcessedData = this._doFinalize();

            return finalProcessedData;
        },

        keySize: 128/32,

        ivSize: 128/32,

        _ENC_XFORM_MODE: 1,

        _DEC_XFORM_MODE: 2,

        /**
         * Creates shortcut functions to a cipher's object interface.
         *
         * @param {Cipher} cipher The cipher to create a helper for.
         *
         * @return {Object} An object with encrypt and decrypt shortcut functions.
         *
         * @static
         *
         * @example
         *
         *     var AES = CryptoJS.lib.Cipher._createHelper(CryptoJS.algo.AES);
         */
        _createHelper: (function () {
            function selectCipherStrategy(key) {
                if (typeof key == 'string') {
                    return PasswordBasedCipher;
                } else {
                    return SerializableCipher;
                }
            }

            return function (cipher) {
                return {
                    encrypt: function (message, key, cfg) {
                        return selectCipherStrategy(key).encrypt(cipher, message, key, cfg);
                    },

                    decrypt: function (ciphertext, key, cfg) {
                        return selectCipherStrategy(key).decrypt(cipher, ciphertext, key, cfg);
                    }
                };
            };
        }())
    });

    /**
     * Abstract base stream cipher template.
     *
     * @property {number} blockSize The number of 32-bit words this cipher operates on. Default: 1 (32 bits)
     */
    var StreamCipher = C_lib.StreamCipher = Cipher.extend({
        _doFinalize: function () {
            // Process partial blocks
            var finalProcessedBlocks = this._process(!!'flush');

            return finalProcessedBlocks;
        },

        blockSize: 1
    });

    /**
     * Mode namespace.
     */
    var C_mode = C.mode = {};

    /**
     * Abstract base block cipher mode template.
     */
    var BlockCipherMode = C_lib.BlockCipherMode = Base.extend({
        /**
         * Creates this mode for encryption.
         *
         * @param {Cipher} cipher A block cipher instance.
         * @param {Array} iv The IV words.
         *
         * @static
         *
         * @example
         *
         *     var mode = CryptoJS.mode.CBC.createEncryptor(cipher, iv.words);
         */
        createEncryptor: function (cipher, iv) {
            return this.Encryptor.create(cipher, iv);
        },

        /**
         * Creates this mode for decryption.
         *
         * @param {Cipher} cipher A block cipher instance.
         * @param {Array} iv The IV words.
         *
         * @static
         *
         * @example
         *
         *     var mode = CryptoJS.mode.CBC.createDecryptor(cipher, iv.words);
         */
        createDecryptor: function (cipher, iv) {
            return this.Decryptor.create(cipher, iv);
        },

        /**
         * Initializes a newly created mode.
         *
         * @param {Cipher} cipher A block cipher instance.
         * @param {Array} iv The IV words.
         *
         * @example
         *
         *     var mode = CryptoJS.mode.CBC.Encryptor.create(cipher, iv.words);
         */
        init: function (cipher, iv) {
            this._cipher = cipher;
            this._iv = iv;
        }
    });

    /**
     * Cipher Block Chaining mode.
     */
    var CBC = C_mode.CBC = (function () {
        /**
         * Abstract base CBC mode.
         */
        var CBC = BlockCipherMode.extend();

        /**
         * CBC encryptor.
         */
        CBC.Encryptor = CBC.extend({
            /**
             * Processes the data block at offset.
             *
             * @param {Array} words The data words to operate on.
             * @param {number} offset The offset where the block starts.
             *
             * @example
             *
             *     mode.processBlock(data.words, offset);
             */
            processBlock: function (words, offset) {
                // Shortcuts
                var cipher = this._cipher;
                var blockSize = cipher.blockSize;

                // XOR and encrypt
                xorBlock.call(this, words, offset, blockSize);
                cipher.encryptBlock(words, offset);

                // Remember this block to use with next block
                this._prevBlock = words.slice(offset, offset + blockSize);
            }
        });

        /**
         * CBC decryptor.
         */
        CBC.Decryptor = CBC.extend({
            /**
             * Processes the data block at offset.
             *
             * @param {Array} words The data words to operate on.
             * @param {number} offset The offset where the block starts.
             *
             * @example
             *
             *     mode.processBlock(data.words, offset);
             */
            processBlock: function (words, offset) {
                // Shortcuts
                var cipher = this._cipher;
                var blockSize = cipher.blockSize;

                // Remember this block to use with next block
                var thisBlock = words.slice(offset, offset + blockSize);

                // Decrypt and XOR
                cipher.decryptBlock(words, offset);
                xorBlock.call(this, words, offset, blockSize);

                // This block becomes the previous block
                this._prevBlock = thisBlock;
            }
        });

        function xorBlock(words, offset, blockSize) {
            // Shortcut
            var iv = this._iv;

            // Choose mixing block
            if (iv) {
                var block = iv;

                // Remove IV for subsequent blocks
                this._iv = undefined;
            } else {
                var block = this._prevBlock;
            }

            // XOR blocks
            for (var i = 0; i < blockSize; i++) {
                words[offset + i] ^= block[i];
            }
        }

        return CBC;
    }());

    /**
     * Padding namespace.
     */
    var C_pad = C.pad = {};

    /**
     * PKCS #5/7 padding strategy.
     */
    var Pkcs7 = C_pad.Pkcs7 = {
        /**
         * Pads data using the algorithm defined in PKCS #5/7.
         *
         * @param {WordArray} data The data to pad.
         * @param {number} blockSize The multiple that the data should be padded to.
         *
         * @static
         *
         * @example
         *
         *     CryptoJS.pad.Pkcs7.pad(wordArray, 4);
         */
        pad: function (data, blockSize) {
            // Shortcut
            var blockSizeBytes = blockSize * 4;

            // Count padding bytes
            var nPaddingBytes = blockSizeBytes - data.sigBytes % blockSizeBytes;

            // Create padding word
            var paddingWord = (nPaddingBytes << 24) | (nPaddingBytes << 16) | (nPaddingBytes << 8) | nPaddingBytes;

            // Create padding
            var paddingWords = [];
            for (var i = 0; i < nPaddingBytes; i += 4) {
                paddingWords.push(paddingWord);
            }
            var padding = WordArray.create(paddingWords, nPaddingBytes);

            // Add padding
            data.concat(padding);
        },

        /**
         * Unpads data that had been padded using the algorithm defined in PKCS #5/7.
         *
         * @param {WordArray} data The data to unpad.
         *
         * @static
         *
         * @example
         *
         *     CryptoJS.pad.Pkcs7.unpad(wordArray);
         */
        unpad: function (data) {
            // Get number of padding bytes from last byte
            var nPaddingBytes = data.words[(data.sigBytes - 1) >>> 2] & 0xff;

            // Remove padding
            data.sigBytes -= nPaddingBytes;
        }
    };

    /**
     * Abstract base block cipher template.
     *
     * @property {number} blockSize The number of 32-bit words this cipher operates on. Default: 4 (128 bits)
     */
    var BlockCipher = C_lib.BlockCipher = Cipher.extend({
        /**
         * Configuration options.
         *
         * @property {Mode} mode The block mode to use. Default: CBC
         * @property {Padding} padding The padding strategy to use. Default: Pkcs7
         */
        cfg: Cipher.cfg.extend({
            mode: CBC,
            padding: Pkcs7
        }),

        reset: function () {
            // Reset cipher
            Cipher.reset.call(this);

            // Shortcuts
            var cfg = this.cfg;
            var iv = cfg.iv;
            var mode = cfg.mode;

            // Reset block mode
            if (this._xformMode == this._ENC_XFORM_MODE) {
                var modeCreator = mode.createEncryptor;
            } else /* if (this._xformMode == this._DEC_XFORM_MODE) */ {
                var modeCreator = mode.createDecryptor;

                // Keep at least one block in the buffer for unpadding
                this._minBufferSize = 1;
            }
            this._mode = modeCreator.call(mode, this, iv && iv.words);
        },

        _doProcessBlock: function (words, offset) {
            this._mode.processBlock(words, offset);
        },

        _doFinalize: function () {
            // Shortcut
            var padding = this.cfg.padding;

            // Finalize
            if (this._xformMode == this._ENC_XFORM_MODE) {
                // Pad data
                padding.pad(this._data, this.blockSize);

                // Process final blocks
                var finalProcessedBlocks = this._process(!!'flush');
            } else /* if (this._xformMode == this._DEC_XFORM_MODE) */ {
                // Process final blocks
                var finalProcessedBlocks = this._process(!!'flush');

                // Unpad data
                padding.unpad(finalProcessedBlocks);
            }

            return finalProcessedBlocks;
        },

        blockSize: 128/32
    });

    /**
     * A collection of cipher parameters.
     *
     * @property {WordArray} ciphertext The raw ciphertext.
     * @property {WordArray} key The key to this ciphertext.
     * @property {WordArray} iv The IV used in the ciphering operation.
     * @property {WordArray} salt The salt used with a key derivation function.
     * @property {Cipher} algorithm The cipher algorithm.
     * @property {Mode} mode The block mode used in the ciphering operation.
     * @property {Padding} padding The padding scheme used in the ciphering operation.
     * @property {number} blockSize The block size of the cipher.
     * @property {Format} formatter The default formatting strategy to convert this cipher params object to a string.
     */
    var CipherParams = C_lib.CipherParams = Base.extend({
        /**
         * Initializes a newly created cipher params object.
         *
         * @param {Object} cipherParams An object with any of the possible cipher parameters.
         *
         * @example
         *
         *     var cipherParams = CryptoJS.lib.CipherParams.create({
         *         ciphertext: ciphertextWordArray,
         *         key: keyWordArray,
         *         iv: ivWordArray,
         *         salt: saltWordArray,
         *         algorithm: CryptoJS.algo.AES,
         *         mode: CryptoJS.mode.CBC,
         *         padding: CryptoJS.pad.PKCS7,
         *         blockSize: 4,
         *         formatter: CryptoJS.format.OpenSSL
         *     });
         */
        init: function (cipherParams) {
            this.mixIn(cipherParams);
        },

        /**
         * Converts this cipher params object to a string.
         *
         * @param {Format} formatter (Optional) The formatting strategy to use.
         *
         * @return {string} The stringified cipher params.
         *
         * @throws Error If neither the formatter nor the default formatter is set.
         *
         * @example
         *
         *     var string = cipherParams + '';
         *     var string = cipherParams.toString();
         *     var string = cipherParams.toString(CryptoJS.format.OpenSSL);
         */
        toString: function (formatter) {
            return (formatter || this.formatter).stringify(this);
        }
    });

    /**
     * Format namespace.
     */
    var C_format = C.format = {};

    /**
     * OpenSSL formatting strategy.
     */
    var OpenSSLFormatter = C_format.OpenSSL = {
        /**
         * Converts a cipher params object to an OpenSSL-compatible string.
         *
         * @param {CipherParams} cipherParams The cipher params object.
         *
         * @return {string} The OpenSSL-compatible string.
         *
         * @static
         *
         * @example
         *
         *     var openSSLString = CryptoJS.format.OpenSSL.stringify(cipherParams);
         */
        stringify: function (cipherParams) {
            // Shortcuts
            var ciphertext = cipherParams.ciphertext;
            var salt = cipherParams.salt;

            // Format
            if (salt) {
                var wordArray = WordArray.create([0x53616c74, 0x65645f5f]).concat(salt).concat(ciphertext);
            } else {
                var wordArray = ciphertext;
            }

            return wordArray.toString(Base64);
        },

        /**
         * Converts an OpenSSL-compatible string to a cipher params object.
         *
         * @param {string} openSSLStr The OpenSSL-compatible string.
         *
         * @return {CipherParams} The cipher params object.
         *
         * @static
         *
         * @example
         *
         *     var cipherParams = CryptoJS.format.OpenSSL.parse(openSSLString);
         */
        parse: function (openSSLStr) {
            // Parse base64
            var ciphertext = Base64.parse(openSSLStr);

            // Shortcut
            var ciphertextWords = ciphertext.words;

            // Test for salt
            if (ciphertextWords[0] == 0x53616c74 && ciphertextWords[1] == 0x65645f5f) {
                // Extract salt
                var salt = WordArray.create(ciphertextWords.slice(2, 4));

                // Remove salt from ciphertext
                ciphertextWords.splice(0, 4);
                ciphertext.sigBytes -= 16;
            }

            return CipherParams.create({ ciphertext: ciphertext, salt: salt });
        }
    };

    /**
     * A cipher wrapper that returns ciphertext as a serializable cipher params object.
     */
    var SerializableCipher = C_lib.SerializableCipher = Base.extend({
        /**
         * Configuration options.
         *
         * @property {Formatter} format The formatting strategy to convert cipher param objects to and from a string. Default: OpenSSL
         */
        cfg: Base.extend({
            format: OpenSSLFormatter
        }),

        /**
         * Encrypts a message.
         *
         * @param {Cipher} cipher The cipher algorithm to use.
         * @param {WordArray|string} message The message to encrypt.
         * @param {WordArray} key The key.
         * @param {Object} cfg (Optional) The configuration options to use for this operation.
         *
         * @return {CipherParams} A cipher params object.
         *
         * @static
         *
         * @example
         *
         *     var ciphertextParams = CryptoJS.lib.SerializableCipher.encrypt(CryptoJS.algo.AES, message, key);
         *     var ciphertextParams = CryptoJS.lib.SerializableCipher.encrypt(CryptoJS.algo.AES, message, key, { iv: iv });
         *     var ciphertextParams = CryptoJS.lib.SerializableCipher.encrypt(CryptoJS.algo.AES, message, key, { iv: iv, format: CryptoJS.format.OpenSSL });
         */
        encrypt: function (cipher, message, key, cfg) {
            // Apply config defaults
            cfg = this.cfg.extend(cfg);

            // Encrypt
            var encryptor = cipher.createEncryptor(key, cfg);
            var ciphertext = encryptor.finalize(message);

            // Shortcut
            var cipherCfg = encryptor.cfg;

            // Create and return serializable cipher params
            return CipherParams.create({
                ciphertext: ciphertext,
                key: key,
                iv: cipherCfg.iv,
                algorithm: cipher,
                mode: cipherCfg.mode,
                padding: cipherCfg.padding,
                blockSize: cipher.blockSize,
                formatter: cfg.format
            });
        },

        /**
         * Decrypts serialized ciphertext.
         *
         * @param {Cipher} cipher The cipher algorithm to use.
         * @param {CipherParams|string} ciphertext The ciphertext to decrypt.
         * @param {WordArray} key The key.
         * @param {Object} cfg (Optional) The configuration options to use for this operation.
         *
         * @return {WordArray} The plaintext.
         *
         * @static
         *
         * @example
         *
         *     var plaintext = CryptoJS.lib.SerializableCipher.decrypt(CryptoJS.algo.AES, formattedCiphertext, key, { iv: iv, format: CryptoJS.format.OpenSSL });
         *     var plaintext = CryptoJS.lib.SerializableCipher.decrypt(CryptoJS.algo.AES, ciphertextParams, key, { iv: iv, format: CryptoJS.format.OpenSSL });
         */
        decrypt: function (cipher, ciphertext, key, cfg) {
            // Apply config defaults
            cfg = this.cfg.extend(cfg);

            // Convert string to CipherParams
            ciphertext = this._parse(ciphertext, cfg.format);

            // Decrypt
            var plaintext = cipher.createDecryptor(key, cfg).finalize(ciphertext.ciphertext);

            return plaintext;
        },

        /**
         * Converts serialized ciphertext to CipherParams,
         * else assumed CipherParams already and returns ciphertext unchanged.
         *
         * @param {CipherParams|string} ciphertext The ciphertext.
         * @param {Formatter} format The formatting strategy to use to parse serialized ciphertext.
         *
         * @return {CipherParams} The unserialized ciphertext.
         *
         * @static
         *
         * @example
         *
         *     var ciphertextParams = CryptoJS.lib.SerializableCipher._parse(ciphertextStringOrParams, format);
         */
        _parse: function (ciphertext, format) {
            if (typeof ciphertext == 'string') {
                return format.parse(ciphertext, this);
            } else {
                return ciphertext;
            }
        }
    });

    /**
     * Key derivation function namespace.
     */
    var C_kdf = C.kdf = {};

    /**
     * OpenSSL key derivation function.
     */
    var OpenSSLKdf = C_kdf.OpenSSL = {
        /**
         * Derives a key and IV from a password.
         *
         * @param {string} password The password to derive from.
         * @param {number} keySize The size in words of the key to generate.
         * @param {number} ivSize The size in words of the IV to generate.
         * @param {WordArray|string} salt (Optional) A 64-bit salt to use. If omitted, a salt will be generated randomly.
         *
         * @return {CipherParams} A cipher params object with the key, IV, and salt.
         *
         * @static
         *
         * @example
         *
         *     var derivedParams = CryptoJS.kdf.OpenSSL.execute('Password', 256/32, 128/32);
         *     var derivedParams = CryptoJS.kdf.OpenSSL.execute('Password', 256/32, 128/32, 'saltsalt');
         */
        execute: function (password, keySize, ivSize, salt) {
            // Generate random salt
            if (!salt) {
                salt = WordArray.random(64/8);
            }

            // Derive key and IV
            var key = EvpKDF.create({ keySize: keySize + ivSize }).compute(password, salt);

            // Separate key and IV
            var iv = WordArray.create(key.words.slice(keySize), ivSize * 4);
            key.sigBytes = keySize * 4;

            // Return params
            return CipherParams.create({ key: key, iv: iv, salt: salt });
        }
    };

    /**
     * A serializable cipher wrapper that derives the key from a password,
     * and returns ciphertext as a serializable cipher params object.
     */
    var PasswordBasedCipher = C_lib.PasswordBasedCipher = SerializableCipher.extend({
        /**
         * Configuration options.
         *
         * @property {KDF} kdf The key derivation function to use to generate a key and IV from a password. Default: OpenSSL
         */
        cfg: SerializableCipher.cfg.extend({
            kdf: OpenSSLKdf
        }),

        /**
         * Encrypts a message using a password.
         *
         * @param {Cipher} cipher The cipher algorithm to use.
         * @param {WordArray|string} message The message to encrypt.
         * @param {string} password The password.
         * @param {Object} cfg (Optional) The configuration options to use for this operation.
         *
         * @return {CipherParams} A cipher params object.
         *
         * @static
         *
         * @example
         *
         *     var ciphertextParams = CryptoJS.lib.PasswordBasedCipher.encrypt(CryptoJS.algo.AES, message, 'password');
         *     var ciphertextParams = CryptoJS.lib.PasswordBasedCipher.encrypt(CryptoJS.algo.AES, message, 'password', { format: CryptoJS.format.OpenSSL });
         */
        encrypt: function (cipher, message, password, cfg) {
            // Apply config defaults
            cfg = this.cfg.extend(cfg);

            // Derive key and other params
            var derivedParams = cfg.kdf.execute(password, cipher.keySize, cipher.ivSize);

            // Add IV to config
            cfg.iv = derivedParams.iv;

            // Encrypt
            var ciphertext = SerializableCipher.encrypt.call(this, cipher, message, derivedParams.key, cfg);

            // Mix in derived params
            ciphertext.mixIn(derivedParams);

            return ciphertext;
        },

        /**
         * Decrypts serialized ciphertext using a password.
         *
         * @param {Cipher} cipher The cipher algorithm to use.
         * @param {CipherParams|string} ciphertext The ciphertext to decrypt.
         * @param {string} password The password.
         * @param {Object} cfg (Optional) The configuration options to use for this operation.
         *
         * @return {WordArray} The plaintext.
         *
         * @static
         *
         * @example
         *
         *     var plaintext = CryptoJS.lib.PasswordBasedCipher.decrypt(CryptoJS.algo.AES, formattedCiphertext, 'password', { format: CryptoJS.format.OpenSSL });
         *     var plaintext = CryptoJS.lib.PasswordBasedCipher.decrypt(CryptoJS.algo.AES, ciphertextParams, 'password', { format: CryptoJS.format.OpenSSL });
         */
        decrypt: function (cipher, ciphertext, password, cfg) {
            // Apply config defaults
            cfg = this.cfg.extend(cfg);

            // Convert string to CipherParams
            ciphertext = this._parse(ciphertext, cfg.format);

            // Derive key and other params
            var derivedParams = cfg.kdf.execute(password, cipher.keySize, cipher.ivSize, ciphertext.salt);

            // Add IV to config
            cfg.iv = derivedParams.iv;

            // Decrypt
            var plaintext = SerializableCipher.decrypt.call(this, cipher, ciphertext, derivedParams.key, cfg);

            return plaintext;
        }
    });
}());
TP.boot.$$srcPath = '~lib_deps/cryptojs/CryptoJS-format-hex-tpi.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
/*
CryptoJS v3.1.2
code.google.com/p/crypto-js
(c) 2009-2013 by Jeff Mott. All rights reserved.
code.google.com/p/crypto-js/wiki/License
*/
(function (undefined) {
    // Shortcuts
    var C = CryptoJS;
    var C_lib = C.lib;
    var CipherParams = C_lib.CipherParams;
    var C_enc = C.enc;
    var Hex = C_enc.Hex;
    var C_format = C.format;

    var HexFormatter = C_format.Hex = {
        /**
         * Converts the ciphertext of a cipher params object to a hexadecimally encoded string.
         *
         * @param {CipherParams} cipherParams The cipher params object.
         *
         * @return {string} The hexadecimally encoded string.
         *
         * @static
         *
         * @example
         *
         *     var hexString = CryptoJS.format.Hex.stringify(cipherParams);
         */
        stringify: function (cipherParams) {
            return cipherParams.ciphertext.toString(Hex);
        },

        /**
         * Converts a hexadecimally encoded ciphertext string to a cipher params object.
         *
         * @param {string} input The hexadecimally encoded string.
         *
         * @return {CipherParams} The cipher params object.
         *
         * @static
         *
         * @example
         *
         *     var cipherParams = CryptoJS.format.Hex.parse(hexString);
         */
        parse: function (input) {
            var ciphertext = Hex.parse(input);
            return CipherParams.create({ ciphertext: ciphertext });
        }
    };
}());
TP.boot.$$srcPath = '';

        
        TP.registerExternalObject('CryptoJS', window.CryptoJS);
        
    
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETPrimitivesPre.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
*/

/* global $STATUS:true */

//  ------------------------------------------------------------------------
//  OBJECT IDENTITY - PART I
//  ------------------------------------------------------------------------

/*
To support a variety of functionality, TIBET requires that objects have a
unique identity which can be used to distinguish them from other objects.
*/

//  ------------------------------------------------------------------------

/**
 * Well-known ID values. This will allow the types to display using their names
 * rather than an arbitrary OID value. TIBET's defineSubtype call defines each
 * type's public id to be the type name itself.
 */

//  see later in this file for setting the TP.NAME, TP.TYPE, etc. of these
//  objects.

Array[TP.ID] = 'Array';
Boolean[TP.ID] = 'Boolean';
Date[TP.ID] = 'Date';
Function[TP.ID] = 'Function';
Number[TP.ID] = 'Number';
Object[TP.ID] = 'Object';
RegExp[TP.ID] = 'RegExp';
String[TP.ID] = 'String';

Window[TP.ID] = 'Window';

//  Built-in prototypes
//  NB: We do *not* place a TP.ID slot on TP.ObjectProto in an effort to keep
//  slots off of there.
TP.ArrayProto[TP.ID] = 'ArrayProto';
TP.BooleanProto[TP.ID] = 'BooleanProto';
TP.DateProto[TP.ID] = 'DateProto';
TP.FunctionProto[TP.ID] = 'FunctionProto';
TP.NumberProto[TP.ID] = 'NumberProto';
TP.RegExpProto[TP.ID] = 'RegExpProto';
TP.StringProto[TP.ID] = 'StringProto';

Window.prototype[TP.ID] = 'WindowProto';

//  Built-in TIBET objects
TP[TP.ID] = 'TP';
TP.sys[TP.ID] = 'TP.sys';
TP.boot[TP.ID] = 'TP.boot';
TP.global[TP.ID] = 'Self';
APP[TP.ID] = 'APP';

//  ------------------------------------------------------------------------

/**
 * Well-known name values.
 */

//  Built-in prototypes
//  NB: We do *not* place a TP.NAME slot on TP.ObjectProto in an effort to keep
//  slots off of there.
TP.ArrayProto[TP.NAME] = 'ArrayProto';
TP.BooleanProto[TP.NAME] = 'BooleanProto';
TP.DateProto[TP.NAME] = 'DateProto';
TP.FunctionProto[TP.NAME] = 'FunctionProto';
TP.NumberProto[TP.NAME] = 'NumberProto';
TP.RegExpProto[TP.NAME] = 'RegExpProto';
TP.StringProto[TP.NAME] = 'StringProto';

Window.prototype[TP.NAME] = 'WindowProto';

//  Built-in TIBET objects
TP[TP.NAME] = 'TP';
TP.sys[TP.NAME] = 'TP.sys';
TP.boot[TP.NAME] = 'TP.boot';
TP.global[TP.NAME] = 'Self';
APP[TP.NAME] = 'APP';

//  ------------------------------------------------------------------------

/**
 * Well-known typename values.
 */

//  Built-in prototypes
//  NB: We do *not* place a TP.TNAME slot on TP.ObjectProto in an effort to keep
//  slots off of there.
TP.ArrayProto[TP.TNAME] = 'Object';
TP.BooleanProto[TP.TNAME] = 'Object';
TP.DateProto[TP.TNAME] = 'Object';
TP.FunctionProto[TP.TNAME] = 'Object';
TP.NumberProto[TP.TNAME] = 'Object';
TP.RegExpProto[TP.TNAME] = 'Object';
TP.StringProto[TP.TNAME] = 'Object';

Window.prototype[TP.TNAME] = 'Object';

//  Built-in TIBET objects
TP[TP.TNAME] = 'Object';
TP.sys[TP.TNAME] = 'Object';
TP.boot[TP.TNAME] = 'Object';
TP.global[TP.TNAME] = 'Object';
APP[TP.TNAME] = 'Object';

//  ------------------------------------------------------------------------

/**
 * Well-known owner values.
 */

//  Built-in prototypes
TP.ArrayProto[TP.OWNER] = Array;
TP.BooleanProto[TP.OWNER] = Boolean;
TP.DateProto[TP.OWNER] = Date;
TP.FunctionProto[TP.OWNER] = Function;
TP.NumberProto[TP.OWNER] = Number;
TP.RegExpProto[TP.OWNER] = RegExp;
TP.StringProto[TP.OWNER] = String;

Window.prototype[TP.OWNER] = Window;

//  -----------------------------------------------------------------------
//  Preliminary bootstrap methods required by TP.defineSlot() and
//  TP.defineMethodSlot()
//  -----------------------------------------------------------------------

//  Needed during boot
TP.getID = function() {
    return TP[TP.ID];
};
TP.sys.getID = function() {
    return TP.sys[TP.ID];
};
TP.boot.getID = function() {
    return TP.boot[TP.ID];
};
APP.getID = function() {
    return APP[TP.ID];
};

//  Needed during boot
TP.getName = function() {
    return TP[TP.NAME];
};
TP.sys.getName = function() {
    return TP.sys[TP.NAME];
};
TP.boot.getName = function() {
    return TP.boot[TP.NAME];
};
APP.getName = function() {
    return APP[TP.NAME];
};

TP.toString = function() {
    return TP[TP.NAME];
};
TP.sys.toString = function() {
    return TP.sys[TP.NAME];
};
TP.boot.toString = function() {
    return TP.boot[TP.NAME];
};
APP.toString = function() {
    return APP[TP.NAME];
};

//  ------------------------------------------------------------------------

TP.isCallable = function(anObj) {

    /**
     * @method isCallable
     * @summary Returns true if the object provided is a function which is not
     *     marked as a DNU. No owner or track testing is performed which is what
     *     disinguishes this call from TP.isMethod(). Methods, unlike more
     *     generic "callables", have an owner and track.
     * @param {Object} anObj The object to test.
     * @example Test to see if a function is callable:
     *     <code>
     *          anObj = function() {return 42};
     *          TP.isCallable(anObj);
     *          <samp>true</samp>
     *     </code>
     * @example Test to see if any other object is callable:
     *     <code>
     *          TP.isCallable(TP.ac());
     *          <samp>false</samp>
     *          TP.isCallable(TP.dc());
     *          <samp>false</samp>
     *          TP.isCallable('');
     *          <samp>false</samp>
     *          TP.isCallable(TP.lang.Object.construct());
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean}
     */

    //  NB: Do not replace this logic - it has been optimized to primitives
    //  because this method gets called so much.
    /* eslint-disable no-extra-parens */
    return (anObj && anObj.apply && anObj.$$dnu !== true);
    /* eslint-enable no-extra-parens */
};

//  Manual setup
TP.isCallable[TP.NAME] = 'isCallable';
TP.isCallable[TP.OWNER] = TP;
TP.isCallable[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.isCallable[TP.DISPLAY] = 'TP.isCallable';
TP.registerLoadInfo(TP.isCallable);

//  ------------------------------------------------------------------------

TP.canInvoke = function(anObj, anInterface) {

    /**
     * @method canInvoke
     * @summary Returns true if the object provided implements the method named
     *     in the name provided.
     * @description The Smalltalk method 'respondsTo' is replaced in TIBET with
     *     this method, which allows you to check a method name against a
     *     potentially null/undefined parameter or return value.
     * @param {Object} anObj The object to check.
     * @param {String} anInterface A method name to check.
     * @example Testing to see if anObj implements 'getID':
     *     <code>
     *          TP.canInvoke(anObj, 'getID');
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} True if the object implements the method(s) of the
     *     interface.
     */

    var obj;

    //  This is a very heavily used routine, so we use very primitive checking
    //  in it.

    //  On some platforms, if obj is a '[native code]' function, 'instanceof
    //  Function' will return false. This is the only consistent test for
    //  whether something can truly respond.

    //  Unfortunately, the 'in' operator will throw an exception on primitive
    //  strings, numbers and booleans. Therefore, we catch and try different
    //  logic for those. Note that this is actually quite a bit faster than
    //  testing to see what kind of object we're dealing with.
    try {
        /* eslint-disable no-extra-parens */
        return (anInterface in anObj) &&
                (typeof (obj = anObj[anInterface]) === 'function') &&
                !obj.$$dnu;
        /* eslint-enable no-extra-parens */
    } catch (e) {
        //  Note that we *must* compare anObj to both null and undefined rather
        //  than '!' because it might get falsey things like a '0' and the empty
        //  String.
        if (anObj === undefined || anObj === null || !anInterface) {
            return false;
        }

        obj = anObj[anInterface];
        /* eslint-disable no-extra-parens */
        return (typeof obj === 'function' && !obj.$$dnu);
        /* eslint-enable no-extra-parens */
    }
};

//  Manual setup
TP.canInvoke[TP.NAME] = 'canInvoke';
TP.canInvoke[TP.OWNER] = TP;
TP.canInvoke[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.canInvoke[TP.DISPLAY] = 'TP.canInvoke';
TP.registerLoadInfo(TP.canInvoke);

//  ------------------------------------------------------------------------

TP.canInvokeInterface = function(anObj, anInterface) {

    /**
     * @method canInvokeInterface
     * @summary Returns true if the object provided implements the method or
     *     methods in the interface provided. The interface can be defined as
     *     either a single method name or an array of names which constitute the
     *     list of methods to check.
     * @description The Smalltalk method 'respondsTo' is replaced in TIBET with
     *     this method, which allows you to check a method name against a
     *     potentially null/undefined parameter or return value.
     * @param {Object} anObj The object to check.
     * @param {String|String[]} anInterface A method name, or list of method
     *     names, to check.
     * @example Testing to see if anObj implements 'getID':
     *     <code>
     *          TP.canInvokeInterface(anObj, 'getID');
     *          <samp>true</samp>
     *          TP.canInvokeInterface(anObj, ['at', 'atPut]);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} True if the object implements the method(s) of the
     *     interface.
     */

    var obj,
        i,
        len;

    //  NB: This is a very heavily used routine, so we use very primitive
    //  checking in it. Note that we *must* compare anObj to both null and
    //  undefined rather than '!' because it might get falsey things like a '0'
    //  and the empty String.

    if (anObj === undefined || anObj === null || !anInterface) {
        return false;
    }

    //  NB: Do not replace this logic - it has been optimized to primitives
    //  because this method (with a String parameter) gets called so much.
    if (anInterface.charAt !== undefined) {
        obj = anObj[anInterface];
        //  NOTE: On some platforms, if obj is a '[native code]' function,
        //  'instanceof Function' will return false. This is the only consistent
        //  test for whether something can truly respond.
        /* eslint-disable no-extra-parens */
        return (obj !== undefined && obj.apply && !obj.$$dnu);
        /* eslint-enable no-extra-parens */
    } else if (Array.isArray(anInterface)) {
        len = anInterface.length;
        for (i = 0; i < len; i++) {
            obj = anObj[anInterface[i]];
            if (!obj || !obj.apply || obj.$$dnu === true) {
                return false;
            }
        }
        return true;
    }

    return false;
};

//  Manual setup
TP.canInvokeInterface[TP.NAME] = 'canInvokeInterface';
TP.canInvokeInterface[TP.OWNER] = TP;
TP.canInvokeInterface[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.canInvokeInterface[TP.DISPLAY] = 'TP.canInvokeInterface';
TP.registerLoadInfo(TP.canInvokeInterface);

//  ------------------------------------------------------------------------

TP.isValid = function(aValue) {

    /**
     * @method isValid
     * @summary Return true if the receiver is not undefined and not null,
     *     meaning it has some value (empty/false or otherwise).
     * @param {Object} aValue The value to test.
     * @example Test to see if anObj is valid:
     *     <code>
     *          if (TP.isValid(anObj)) { TP.info('its valid'); };
     *     </code>
     * @returns {Boolean} Whether or not the value is not null *and* is not
     *     undefined.
     */

    return aValue !== undefined && aValue !== null;
};

//  Manual setup
TP.isValid[TP.NAME] = 'isValid';
TP.isValid[TP.OWNER] = TP;
TP.isValid[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.isValid[TP.DISPLAY] = 'TP.isValid';
TP.registerLoadInfo(TP.isValid);

//  ------------------------------------------------------------------------

TP.notValid = function(aValue) {

    /**
     * @method notValid
     * @summary Returns true if the value provided is either null or undefined.
     * @param {Object} aValue The value to test.
     * @example Test to see if anObj is not valid:
     *     <code>
     *          if (TP.notValid(anObj)) { TP.info('its not valid'); };
     *     </code>
     * @returns {Boolean} Whether or not the value is not valid (that is, either
     *     null or undefined).
     */

    return aValue === undefined || aValue === null;
};

//  Manual setup
TP.notValid[TP.NAME] = 'notValid';
TP.notValid[TP.OWNER] = TP;
TP.notValid[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.notValid[TP.DISPLAY] = 'TP.notValid';
TP.registerLoadInfo(TP.notValid);

//  ------------------------------------------------------------------------

TP.ifInvalid = function(aSuspectValue, aDefaultValue) {

    /**
     * @method ifInvalid
     * @summary Returns either aSuspectValue or aDefaultValue based on the
     *     state of aSuspectValue. If aSuspectValue is TP.notValid()
     *     aDefaultValue is returned.
     * @param {Object} aSuspectValue The value to test.
     * @param {Object} aDefaultValue The value to return if aSuspectValue is ===
     *     null or === undefined.
     * @example Set the value of theObj to true, if anObj is invalid:
     *     <code>
     *          theObj = TP.ifInvalid(anObj, true);
     *     </code>
     * @returns {Object} One of the two values provided.
     */

    return TP.notValid(aSuspectValue) ? aDefaultValue : aSuspectValue;
};

//  Manual setup
TP.ifInvalid[TP.NAME] = 'ifInvalid';
TP.ifInvalid[TP.OWNER] = TP;
TP.ifInvalid[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.ifInvalid[TP.DISPLAY] = 'TP.ifInvalid';
TP.registerLoadInfo(TP.ifInvalid);

//  ------------------------------------------------------------------------

TP.isDNU = function(anObj) {

    /**
     * @method isDNU
     * @summary Returns true if the object provided is a TIBET DNU
     *     (DoesNotUnderstand) function. These functions are installed by TIBET
     *     to provide support for delegation, inferencing, and other method
     *     resolution strategies.
     * @description TIBET's support for "missing" methods is driven largely by
     *     the DNU concept, which provides the hooks found in Ruby's missing
     *     methods, Smalltalk/Self's "doesNotUnderstand", etc.
     * @param {Object} anObj The object to test.
     * @returns {Boolean} Whether or not the supplied object is a DNU.
     */

    //  if the dnu slot is defined we can return its value, otherwise the
    //  proper response is false
    // return TP.isFunction(anObj) && anObj.$$dnu === true;
    return anObj && anObj.$$dnu === true;
};

//  Manual setup
TP.isDNU[TP.NAME] = 'isDNU';
TP.isDNU[TP.OWNER] = TP;
TP.isDNU[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.isDNU[TP.DISPLAY] = 'TP.isDNU';
TP.registerLoadInfo(TP.isDNU);

//  TODO: Remove after cleansing old name.
TP.$$isDNU = TP.isDNU;

//  ------------------------------------------------------------------------

TP.makeStartUpper = function(anObj) {

    /**
     * @method makeStartUpper
     * @summary Returns a new string with the initial character in upper case.
     *     No other transformation is performed.
     * @param {String} anObj The object to upper case the initial character of.
     * @returns {String} The supplied String with the initial character
     *     uppercased.
     */

    return anObj[0].toUpperCase() + anObj.slice(1);
};

//  Manual setup
TP.makeStartUpper[TP.NAME] = 'makeStartUpper';
TP.makeStartUpper[TP.OWNER] = TP;
TP.makeStartUpper[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.makeStartUpper[TP.DISPLAY] = 'TP.makeStartUpper';
TP.registerLoadInfo(TP.makeStartUpper);

//  TODO: Remove after cleansing old name.
TP.$$makeStartUpper = TP.makeStartUpper;

//  ------------------------------------------------------------------------

TP.isFunction = function(anObj) {

    /**
     * @method isFunction
     * @summary Returns true if the object provided is a function instance. No
     *     attempt is made to determine whether that function is a DNU, or
     *     method (an owned function). Use TP.isCallable(), or TP.isMethod() to
     *     test for those cases.
     * @description Perhaps the most glaring example of why we've encapsulated
     *     so heavily in TIBET. Most libraries use typeof == 'function' and call
     *     it a day. Unfortunately many of IE's DOM-associated functions don't
     *     return 'function' in response to a typeof call and Mozilla is
     *     confused about RegExp objects and typeof (it returns "function"). So
     *     there are at least two cases where typeo) will lie to you with
     *     Function checks. Dates have similar issues, as do Numbers. Our
     *     advice? Don't use typeof unless you're certain of what you're
     *     really testing against and you're only interested in knowing what the
     *     primitive type (in ECMA-standard terms) of the object is.
     * @param {Object} anObj The object to test.
     * @example Test to see if a function is a Function:
     *     <code>
     *          anObj = function() {return 42};
     *          TP.isFunction(anObj);
     *          <samp>true</samp>
     *     </code>
     * @example Test to see if a DOM function is a Function:
     *     <code>
     *          TP.isFunction(document.write);
     *          <samp>true</samp>
     *     </code>
     * @example Test to see if a RegExp is a Function:
     *     <code>
     *          TP.isFunction(/matchme/g);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is a JavaScript
     *     Function.
     */

    var str;

    str = TP.ObjectProto.toString.call(anObj);

    return str === '[object Function]' || str === '[object AsyncFunction]';
};

//  Manual setup
TP.isFunction[TP.NAME] = 'isFunction';
TP.isFunction[TP.OWNER] = TP;
TP.isFunction[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.isFunction[TP.DISPLAY] = 'TP.isFunction';
TP.registerLoadInfo(TP.isFunction);

//  ------------------------------------------------------------------------

TP.isString = function(anObj) {

    /**
     * @method isString
     * @summary Returns true if the object provided is a string primitive or a
     *     String object. This method also allows us to play a few tricks with
     *     "mutable strings" or what a Java developer would think of as a
     *     "string buffer" by returning true if the object can behave like a
     *     string in terms of API. Of course, the caveat here is don't use '+'
     *     to concatenate strings, use TP.join() or one of the collection
     *     methods instead since they're faster and can deal with strings of
     *     different types...but you knew all that :).
     * @param {Object} anObj The object to test.
     * @example Test to see if an object is a string:
     *     <code>
     *          anObj = 'foo';
     *          TP.isString(anObj);
     *          <samp>true</samp>
     *          TP.isString('bar');
     *          <samp>true</samp>
     *          TP.isString(42);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean}
     */

    return TP.ObjectProto.toString.call(anObj) === '[object String]';
};

//  Manual setup
TP.isString[TP.NAME] = 'isString';
TP.isString[TP.OWNER] = TP;
TP.isString[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.isString[TP.DISPLAY] = 'TP.isString';
TP.registerLoadInfo(TP.isString);

//  ------------------------------------------------------------------------

TP.owns = function(anObject, aName) {

    /**
     * @method owns
     * @summary Returns true if the object hasOwnProperty() aName. This wrapper
     *     exists because numerous objects which should respond to that method
     *     don't, and will throw errors if you try to use it.
     * @param {Object} anObject The object to test.
     * @param {String} aName The slot name to check.
     * @returns {Boolean} True if the object owns the slot.
     */

    //  This is the most efficient way to provide this functionality. This is
    //  VERY HEAVILY used method, so it's best to leave it this way unless bugs
    //  are found.
    return TP.ObjectProto.hasOwnProperty.call(anObject, aName);
};

//  Manual setup
TP.owns[TP.NAME] = 'owns';
TP.owns[TP.OWNER] = TP;
TP.owns[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.owns[TP.DISPLAY] = 'TP.owns';
TP.registerLoadInfo(TP.owns);

//  ------------------------------------------------------------------------

TP.FunctionProto.asMethod = function(owner, name, track, display) {

    /**
     * @method asMethod
     * @summary Returns the receiver as a method. In most cases this simply
     *     returns the function.
     * @description In certain special cases this function can be overridden to
     *     provide advanced behavior which significantly enhances the
     *     functionality of the system. The various as*Method functions are all
     *     controlled from this root method. The asMethod call is triggered in
     *     the various add*Method calls to allow the system to automatically
     *     instrument functions. Typically all the control flags are set to
     *     false during TIBET load and are then set to true when the IDE loads
     *     or when a developer sets up the appropriate configuration file for
     *     application loading. This allows the applicaton-specific methods to
     *     be wrapped without causing extra overhead within the TIBET
     *     infrastructure itself. Note that its always possible to do the
     *     following:
     *
     *     MyType.add*Method('blah', MyType.get*Method('blah').as*Method());
     *
     *     ...do some debugging
     *
     *     MyType.add*Method('blah',
     *     MyType.get*Method('blah').asStandardMethod());
     *
     *     This allows you to alter behavior for a single method and then put
     *     it back where you found it all clean and nice.
     * @param {Object} owner The object that owns the method.
     * @param {String|Symbol} name The slot name (or Symbol identifier).
     * @param {String} track The slot track (type, inst, local, etc).
     * @param {String} display The slot display name. Defaults to the
     *     owner.track.name triplet.
     * @returns {Function} A properly configured 'method'.
     * @para Object The object receiving the slot.
     */

    var methodName,
        displayName;

    //  In case this is a Symbol.
    methodName = name.toString();

    //  Build a display name that should work for most cases.
    if (!display) {
        //  If the track is local we don't show it, so Obj.method instead of
        //  Obj.Local.method, but Obj.Inst.method, or Obj.Type.method as needed.
        if (track.indexOf(TP.LOCAL_TRACK) === TP.NOT_FOUND) {
            try {
                displayName = owner.getID() + '.' + track + '.' + methodName;
            } catch (e) {
                TP.topWindow.console.log(
                    'Can\'t compute owner ID for: ' + TP.str(owner) +
                    ' for method named: ' + methodName +
                    ' on track: ' + track +
                    ' stack: ' + e.stack);
            }
        } else {
            displayName = owner.getID() + '.' + methodName;
        }
    } else {
        displayName = display;
    }

    //  Attach reflection metadata.
    this[TP.NAME] = methodName;
    this[TP.OWNER] = owner;
    this[TP.TRACK] = track;
    this[TP.DISPLAY] = displayName;

    //  NOTE we do a little trick here if owner is TP since we want resolvable
    //  IDs and TP.Primitive.id or TP.Local.foo isn't resolvable.
    this[TP.ID] = owner === TP ? 'TP.' + name : displayName;

    Object.defineProperty(this, 'name', {value: displayName});

    //  Register where we were loaded from.
    TP.registerLoadInfo(this);

    return this;
};

//  Manual setup
TP.FunctionProto.asMethod[TP.NAME] = 'asMethod';
TP.FunctionProto.asMethod[TP.OWNER] = Function;
TP.FunctionProto.asMethod[TP.TRACK] = TP.INST_TRACK;
TP.FunctionProto.asMethod[TP.DISPLAY] = 'Function.Inst.asMethod';
TP.registerLoadInfo(TP.FunctionProto.asMethod);

//  ------------------------------------------------------------------------

TP.StringProto.strip = function(aRegExp) {

    /**
     * @method strip
     * @summary Returns a new string with the contents of the receiver after
     *     having removed any characters matching the RegExp passed in.
     * @param {RegExp} aRegExp The pattern to strip from receiver.
     * @returns {String} A new string with the contents of the receiver except
     *     for characters specified in aRegexp.
     */

    return this.replace(aRegExp, '');
};

//  Manual setup
TP.StringProto.strip[TP.NAME] = 'strip';
TP.StringProto.strip[TP.OWNER] = String;
TP.StringProto.strip[TP.TRACK] = TP.INST_TRACK;
TP.StringProto.strip[TP.DISPLAY] = 'String.Inst.strip';
TP.registerLoadInfo(TP.StringProto.strip);

//  ------------------------------------------------------------------------
//  OBJECT IDENTITY - PART I
//  ------------------------------------------------------------------------

//  allow for custom OID generation routines to be installed prior to
//  this. we install this via a test so it's easy to define your own
//  routine in the tibet.xml file if you like.
if (!TP.constructOID) {
    TP.constructOID = function(aPrefix) {

        /**
         * @method constructOID
         * @summary Generates an OID value, optionally prefixing it with
         *     aPrefix if that prefix is non-empty. Note that OIDs always begin
         *     with an _, $, or alpha character regardless of the prefix to
         *     ensure unprefixed OIDs are valid IDREF values and legal JS
         *     identifiers.
         * @description A TIBET OID value is a random identifier which has no
         *     long-term uniqueness properties but is sufficient for managing
         *     unique references during a particular application invocation
         *     cycle.
         *
         *     Something far more complex would be needed to allow these to
         *     persist and be useful across machine and/or process boundaries.
         *     The version here appears adequate for single-browser operation
         *     although clearly other algorithms are possible (and perhaps
         *     faster).
         *
         *     NOTE, since OID values are used as IDREF values you must use an
         *     algorithm which produces valid IDREFs, at a minimum this means
         *     they have to start with $, _, or an alpha character.
         * @param {String} aPrefix An optional prefix which will be prepended to
         *     the return value.
         * @returns {String} Currently all OID's are String values.
         */

        //  NOTE that starting with anything other than a number allows
        //  these to work as ID[REF] values when no prefix is provided
        return (aPrefix ? aPrefix + TP.OID_PREFIX : TP.OID_PREFIX) +
                Math.random().toString(32).replace('0.',
                        Date.now().toString(32));
    };
}

//  Manual setup
TP.constructOID[TP.NAME] = 'constructOID';
TP.constructOID[TP.OWNER] = TP;
TP.constructOID[TP.TRACK] = TP.LOCAL_TRACK;
TP.constructOID[TP.DISPLAY] = 'TP.constructOID';
TP.registerLoadInfo(TP.constructOID);

//  ---

TP.genID = TP.constructOID;

//  ------------------------------------------------------------------------
//  OBJECT NAMING - PART I
//  ------------------------------------------------------------------------

/**
 * TIBET often needs to report on the names of functions, the 'owner' or type to
 * which they belong, and similar relationship information to support the
 * various levels of reflection in the system.
 */

//  regex for function data extraction. TIBET uses function names in
//  support of callNextMethod() as well as for logging support. Too bad this
//  isn't a built-in feature of the language. Owner too.

//  strip name from the function -- if it exists

//  Note the non-greediness of the RegExp here - don't want to match past
//  the actual end of the parameter list.
Function.$$getNameRegex = /function\s*(.*?)\(/;

//  ------------------------------------------------------------------------

TP.getFunctionName = function(aFunction) {

    /**
     * @method getFunctionName
     * @summary Returns the name of the supplied function or the value
     * TP.ANONYMOUS_FUNCTION_NAME if function doesn't have a name.
     * @param {Function} aFunction The Function to retrieve the name of.
     * @returns {String} The name of the Function or TP.ANONYMOUS_FUNCTION_NAME
     */

    var results;

    //  Do a toString on the function, grab the word after the word 'function'
    //  and use that as the function name. If no name can be computed, we use
    //  the value of TP.ANONYMOUS_FUNCTION_NAME.

    results = Function.$$getNameRegex.exec(aFunction.toString());

    if (TP.notValid(results) || results[1] === '') {
        results = aFunction.name;
        if (TP.notEmpty(results)) {
            return results;
        }
        return TP.ANONYMOUS_FUNCTION_NAME;
    } else {
        return results[1].strip(/\s/g);
    }
};

//  Manual method registration.
TP.getFunctionName[TP.NAME] = 'getFunctionName';
TP.getFunctionName[TP.OWNER] = TP;
TP.getFunctionName[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.getFunctionName[TP.DISPLAY] = 'TP.getFunctionName';
TP.registerLoadInfo(TP.getFunctionName);

//  ------------------------------------------------------------------------

TP.FunctionProto.$getName = function() {

    /**
     * @method $getName
     * @summary Returns the name of the receiving function or its ID if the
     *     function doesn't have a name. As a general rule our methods for
     *     adding methods set the function name but functions declared outside
     *     of an add*Method() should have a name set to properly register them
     * @returns {String}
     */

    var results,
        str;

    //  careful here, TP.FunctionProto will pass names along and everything will
    //  turn up as "Function" if we don't make sure
    if (TP.owns(this, TP.NAME)) {
        return this[TP.NAME];
    }

    //  If the receiver has a 'name' slot, return the value of that.
    if (TP.owns(this, 'name')) {
        return this.name;
    }

    try {
        str = this.toString();
        results = TP.getFunctionName(str);
    } catch (e) {
        str = 'toString';
        results = str;
    }

    if (results === TP.ANONYMOUS_FUNCTION_NAME) {
        //  In Functions that live in TIBET, we don't like Functions to be named
        //  as TP.ANONYMOUS_FUNCTION_NAME, so we compute a unique ID for them
        //  and stamp them with it.

        //  Note that we supply a prefix of 'Function' here to uniquely identify
        //  anonymous Function objects and to avoid a recursion whereby a null
        //  prefix here turns around and calls TP.isType() when this particular
        //  method is called by methods that TP.isType() calls.
        results = this.getID('Function');
    }

    this[TP.NAME] = results;

    return results;
};

//  Manual method registration.
TP.FunctionProto.$getName[TP.NAME] = '$getName';
TP.FunctionProto.$getName[TP.OWNER] = Function;
TP.FunctionProto.$getName[TP.TRACK] = TP.INST_TRACK;
TP.FunctionProto.$getName[TP.DISPLAY] = 'Function.Inst.$getName';
TP.registerLoadInfo(TP.FunctionProto.$getName);

//  ------------------------------------------------------------------------

/*
Assign aliases to create public methods for name access. Owner and track
data is considered private.
*/

TP.FunctionProto.getName = TP.FunctionProto.$getName;
TP.StringProto.getName = TP.FunctionProto.$getName;

//  ------------------------------------------------------------------------

//  stub for early calls, replaced later in kernel

//  Add it directly to TP.ArrayProto - we don't worry about capturing metadata
//  about this method as we'll be replacing it very soon with the "real"
//  implementation anyway.
TP.ArrayProto.at = function(anIndex) {

    /**
     * @method at
     * @summary Returns the value found at an index. Provides polymorphic
     *     access to indexed collection data, which isn't possible with literal
     *     bracket syntax (you can't use []'s on strings etc). NOTE that this
     *     initial version doesn't support varargs or negative indices.
     * @description To support multi-dimensional access this method will allow
     *     more than one index parameter as in arr.at(1, 1) so that, in reality,
     *     the value is acquired from a nested child of the receiver. For
     *     example, arr.at(1, 1) returns the value 3 when used on the array
     *     [[0,1],[2,3]]. This is equivalent to the syntax arr[1][1];
     * @param {Number} anIndex The index to access. Note that this value is the
     *     first index in a potential list of indicies.
     * @returns {Object} The value at the index.
     * @addon Array
     */

    return this[anIndex];
};

//  ------------------------------------------------------------------------

//  stub for early calls, replaced later in kernel

//  Add it directly to TP.ArrayProto - we don't worry about capturing metadata
//  about this method as we'll be replacing it very soon with the "real"
//  implementation anyway.
TP.ArrayProto.atPut = function(anIndex, aValue) {

    /**
     * @method atPut
     * @summary Sets the value found at anIndex. Provides polymorphic access to
     *     updating indexed collection data, which isn't possible with literal
     *     bracket syntax. This version does not provide change notification.
     *     NOTE that this initial version does not support vararg values or
     *     negative indices.
     * @description To support multi-dimensional access expanded versions allow
     *     more than one index parameter as in arr.atPut(1, 2, 'foo') so that,
     *     in reality, aValue is defined by the last argument and is placed in
     *     the location found by traversing to the last index (arguments.length
     *     - 2) provided.
     * @param {Number} anIndex The index to set/update.
     * @param {Object} aValue The object to place at anIndex. NOTE that the
     *     position of this attribute may actually vary if multiple indexes are
     *     supplied.
     * @returns {Array} The receiver.
     * @addon Array
     */

    this[anIndex] = aValue;

    return this;
};

//  -----------------------------------------------------------------------
//  Primitive TP.core.Hash support
//  -----------------------------------------------------------------------

/*
The following type provides a standin during the booting process for full
TP.core.Hash support which loads later. First, it constructs a primitive
hash that handles basic at(), atPut(), get(), and set() operations TIBET
relies upon until the more fully featured TP.core.Hash can be loaded. Second
it provides a way to convert itself into one of those more fully functional
TP.core.Hashes so early-stage dictionaries can be upgraded to their more
functional cousins.
*/

TP.boot.PHash = function() {

    var i,
        obj,
        len;

    //  internal hash and list of true keys for the receiver
    /* eslint-disable no-new-object */
    this.$$hash = new Object();
    /* eslint-enable no-new-object */
    this[TP.ID] = TP.constructOID();

    //  no signaling until we're observed
    this.$suspended = true;

    //  populate the instance based on our argument list. we try to mirror
    //  the basic semantics of the full TP.core.Hash here, but that object
    //  has a number of additional input formats
    if (arguments.length === 1) {
        obj = arguments[0];
        for (i in obj) {    //  one of the few places we do this
            if (!TP.regex.INTERNAL_SLOT.test(i) &&
                TP.owns(obj, i)) {
                this.$$hash[i] = obj[i];
            }
        }
    } else {
        //  add any arguments passed in to the constructor to the receiver
        len = arguments.length;
        for (i = 0; i < len; i = i + 2) {
            this.$$hash[arguments[i]] = arguments[i + 1];
        }
    }

    //  ---
    //  isAccessPath
    //  ---

    this.isAccessPath = function() {

        /**
         * @method isAccessPath
         * @summary Returns whether or not the receiver is an access path
         *     object.
         * @returns {Boolean} False - most receivers are not a path.
         */

        return false;
    };

    //  register with TIBET by hand
    this.isAccessPath[TP.NAME] = 'isAccessPath';
    this.isAccessPath[TP.OWNER] = TP.boot.PHash;
    this.isAccessPath[TP.TRACK] = TP.INST_TRACK;
    this.isAccessPath[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.isAccessPath';

    //  ---
    //  isCollection
    //  ---

    this.$$isCollection = function() {

        /**
         * @method $$isCollection
         * @summary Returns true if the receiver is a collection instance. True
         *     for TP.core.Hash instances. NOTE that this method is invoked via
         *     the TP.isCollection() method on objects which implement it, you
         *     shouldn't invoke it directly.
         * @returns {Boolean} True if the receiver is an instance of collection.
         */

        return true;
    };

    //  register with TIBET by hand
    this.$$isCollection[TP.NAME] = '$$isCollection';
    this.$$isCollection[TP.OWNER] = TP.boot.PHash;
    this.$$isCollection[TP.TRACK] = TP.INST_TRACK;
    this.$$isCollection[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.$$isCollection';

    //  ---
    //  isMemberOf
    //  ---

    this.$$isMemberOf = function(aType) {

        /**
         * @method $$isMemberOf
         * @summary Returns true if the receiver is a direct instance of the
         *     type provided.
         * @param {TP.lang.RootObject|String} aType A Type object, or type name.
         * @returns {Boolean} True if the receiver is an instance of the type or
         *     a subtype.
         */

        /* eslint-disable no-extra-parens */
        return (aType === 'TP.core.Hash' || aType === TP.core.Hash);
        /* eslint-enable no-extra-parens */
    };

    //  register with TIBET by hand
    this.$$isMemberOf[TP.NAME] = '$$isMemberOf';
    this.$$isMemberOf[TP.OWNER] = TP.boot.PHash;
    this.$$isMemberOf[TP.TRACK] = TP.INST_TRACK;
    this.$$isMemberOf[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.$$isMemberOf';

    //  ---
    //  as
    //  ---

    this.as = function(aType) {

        /**
         * @method as
         * @summary Returns the receiver as an instance of aType. This
         *     implementation is capable only of converting into a TP.core.Hash
         *     and potentially converting that hash into something else. The
         *     more powerful TP.core.Hash type may have more efficient or
         *     comprehensive conversion routines.
         * @param {TP.lang.RootObject|String} typeOrFormat The type or format
         *     object or String desired.
         * @returns {Object} An instance of aType.
         */

        if (aType === 'TP.core.Hash' || aType === TP.core.Hash) {
            return this.asTP_core_Hash();
        }

        return this.asTP_core_Hash().as(aType);
    };

    //  register with TIBET by hand
    this.as[TP.NAME] = 'as';
    this.as[TP.OWNER] = TP.boot.PHash;
    this.as[TP.TRACK] = TP.INST_TRACK;
    this.as[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.as';

    //  ---
    //  asString
    //  ---

    this.asString = function() {

        /**
         * @method asString
         * @summary Returns a usable string representation of the hash. The
         *     standard form here uses TIBET syntax, meaning that a hash with a
         *     key of 'a' and a value of 1 appears in string form as
         *     TP.hc('a',1).
         * @returns {String} The receiver in string form.
         */

        var keys,
            length,
            j,
            arr;

        arr = TP.ac();
        arr.push('TP.hc(');

        keys = TP.objectGetKeys(this.$$hash);
        length = keys.length;

        for (j = 0; j < length; j++) {
            arr.push(TP.src(keys[j]), ', ', TP.src(this.$$hash[keys[j]]));
            if (j + 1 < length) {
                arr.push(', ');
            }
        }
        arr.push(')');

        return arr.join('');
    };

    //  register with TIBET by hand
    this.asString[TP.NAME] = 'asString';
    this.asString[TP.OWNER] = TP.boot.PHash;
    this.asString[TP.TRACK] = TP.INST_TRACK;
    this.asString[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.asString';

    //  ---
    //  asJSONSource
    //  ---

    this.asJSONSource = function() {

        /**
         * @method asJSONSource
         * @summary Returns a usable JSON representation of the hash, meaning
         *     that a hash with a key of 'a' and a value of 1 appears in string
         *     form as '{"a": 1}'.
         * @returns {String} The receiver in string form.
         */

        return this.asTP_core_Hash().asJSONSource();
    };

    //  register with TIBET by hand
    this.asJSONSource[TP.NAME] = 'asJSONSource';
    this.asJSONSource[TP.OWNER] = TP.boot.PHash;
    this.asJSONSource[TP.TRACK] = TP.INST_TRACK;
    this.asJSONSource[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.asJSONSource';

    //  ---
    //  asSource
    //  ---

    this.asSource = function() {

        /**
         * @method asSource
         * @summary Returns a usable source representation of the hash. The
         *     standard form here uses TIBET syntax, meaning that a hash with a
         *     key of 'a' and a value of 1 appears in string form as
         *     TP.hc('a',1).
         * @returns {String} The receiver in string form.
         */

        return this.asTP_core_Hash().asSource();
    };

    //  register with TIBET by hand
    this.asSource[TP.NAME] = 'asSource';
    this.asSource[TP.OWNER] = TP.boot.PHash;
    this.asSource[TP.TRACK] = TP.INST_TRACK;
    this.asSource[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.asSource';

    //  ---
    //  asTP_core_Hash
    //  ---

    this.asTP_core_Hash = function() {

        /**
         * @method asTP_core_Hash
         * @summary Converts the receiver to a full TP.core.Hash type. The
         *     internal hash data structures are migrated to the new instance so
         *     on completion of this method you should release any references
         *     you may have to the older primitive hash instance.
         * @returns {TP.core.Hash} The full TP.core.Hash constructed from the
         *     receiver.
         */

        //  Pray this doesn't get invoked before we rebuild with the real hash
        //  type (or better yet Map when it arrives).
        return TP.hc(this.$$hash);
    };

    //  register with TIBET by hand
    this.asTP_core_Hash[TP.NAME] = 'asTP_core_Hash';
    this.asTP_core_Hash[TP.OWNER] = TP.boot.PHash;
    this.asTP_core_Hash[TP.TRACK] = TP.INST_TRACK;
    this.asTP_core_Hash[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.asTP_core_Hash';

    //  ---
    //  at
    //  ---

    this.at = function(aKey) {

        /**
         * @method at
         * @summary Returns the value at the key/index provided.
         * @param {Object} aKey The index to use for locating the value. Note
         *     that this is usually a string, but could be any object supporting
         *     a valid toString method. This method is designed to protect
         *     against returning any of the receiver's properties/methods.
         * @returns {Object} The item at the index provided or undefined.
         */
/*
        if (TP.owns(this.$$hash, aKey)) {
            return this.$$hash[aKey];
        }
*/
        //  Nothing on Object.prototype, this should work.
        return this.$$hash[aKey];
    };

    //  register with TIBET by hand
    this.at[TP.NAME] = 'at';
    this.at[TP.OWNER] = TP.boot.PHash;
    this.at[TP.TRACK] = TP.INST_TRACK;
    this.at[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.at';

    //  ---
    //  atPut
    //  ---

    this.atPut = function(aKey, aValue) {

        /**
         * @method atPut
         * @summary Sets the value at aKey to aValue.
         * @param {Object} aKey The key/index to put aValue into.
         * @param {Object} aValue The value to register under aKey.
         * @returns {TP.boot.PHash} The receiver.
         */

        this.$$hash[aKey] = aValue;

        return this;
    };

    //  register with TIBET by hand
    this.atPut[TP.NAME] = 'atPut';
    this.atPut[TP.OWNER] = TP.boot.PHash;
    this.atPut[TP.TRACK] = TP.INST_TRACK;
    this.atPut[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.atPut';

    //  ---
    //  $get
    //  ---

    this.$get = function(attributeName) {

        /**
         * @method $get
         * @summary Returns the property with the given name, adjusted for
         *     standard TIBET attribute prefixing rules as needed.
         * @param {String} attributeName The name of the property to get.
         * @returns {Object} The value of the named property.
         */

        return this[attributeName];
    };

    //  register with TIBET by hand
    this.$get[TP.NAME] = '$get';
    this.$get[TP.OWNER] = TP.boot.PHash;
    this.$get[TP.TRACK] = TP.INST_TRACK;
    this.$get[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.$get';

    //  ---
    //  get
    //  ---

    this.get = function(attributeName) {

        /**
         * @method get
         * @summary Returns the value of attributeName from the receiver. NOTE
         *     that get() operates on the object's methods first and then
         *     searches its content and properties. In other words, if the
         *     receiver has both a method named 'getFoo' and a key/value pair
         *     under the key 'foo' you won't get the value back, you'll get the
         *     result of getFoo() instead. After methods are checked the content
         *     of the hash is checked, followed by the hash's slots. Use at() if
         *     you want to focus exclusively on the content of the hash and
         *     never acquire method results or property values. Use $get if you
         *     want to focus exclusively on the hash's slot values.
         * @param {String} attributeName The name of the property to get.
         * @returns {Object} The value of the named property.
         */

        var propName,
            funcName,
            val;

        funcName = 'get' + TP.makeStartUpper(attributeName);
        if (TP.canInvoke(this, funcName)) {
            return this[funcName]();
        }

        //  support dot-separated access paths, as long as each member
        //  of the path can respond to get() or provide the value in
        //  question
        propName = attributeName;

        if (TP.regex.HAS_PERIOD.test(propName)) {
            propName = propName.slice(0, propName.indexOf('.'));

            //  call back in with first part of access path
            if (TP.notValid(val = this.get(propName))) {
                return val;
            }

            //  only continue if the result object can stay with the
            //  program :)
            if (TP.canInvoke(val, 'get')) {
                propName = propName.slice(propName.indexOf('.') + 1);
                return val.get(propName);
            }

            return;
        }

        if (TP.isDefined(val = this.at(attributeName))) {
            return val;
        }

        return this.$get(attributeName);
    };

    //  register with TIBET by hand
    this.get[TP.NAME] = 'get';
    this.get[TP.OWNER] = TP.boot.PHash;
    this.get[TP.TRACK] = TP.INST_TRACK;
    this.get[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.get';

    //  ---
    //  getName
    //  ---

    this.getName = function() {

        /**
         * @method getName
         * @summary Returns the TP.NAME property of the receiver.
         * @returns {String} The value of the TP.NAME property.
         */

        return this[TP.NAME];
    };

    //  register with TIBET by hand
    this.getName[TP.NAME] = 'getName';
    this.getName[TP.OWNER] = TP.boot.PHash;
    this.getName[TP.TRACK] = TP.INST_TRACK;
    this.getName[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.getName';

    //  ---
    //  getItems
    //  ---

    this.getItems = function() {

        /**
         * @method getItems
         * @summary Returns the items [key,value] of the receiver.
         * @returns {Object[]} An array containing the receiver's items.
         */

        var arr,
            keys,
            length,
            j;

        arr = TP.ac();

        keys = TP.objectGetKeys(this.$$hash);
        length = keys.length;

        for (j = 0; j < length; j++) {
            arr.push(keys[j], this.$$hash[keys[j]]);
        }

        return arr;
    };

    //  register with TIBET by hand
    this.getItems[TP.NAME] = 'getItems';
    this.getItems[TP.OWNER] = TP.boot.PHash;
    this.getItems[TP.TRACK] = TP.INST_TRACK;
    this.getItems[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.getItems';

    //  ---
    //  getKeys
    //  ---

    this.getKeys = function() {

        /**
         * @method getKeys
         * @summary Returns the unique keys of the receiver. NOTE for
         *     consistency with other getKeys() calls you should treat the
         *     returned array as a read-only object.
         * @returns {String[]} An array containing the receiver's keys.
         */

        return TP.objectGetKeys(this.$$hash);
    };

    //  register with TIBET by hand
    this.getKeys[TP.NAME] = 'getKeys';
    this.getKeys[TP.OWNER] = TP.boot.PHash;
    this.getKeys[TP.TRACK] = TP.INST_TRACK;
    this.getKeys[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.getKeys';

    //  ---
    //  getParameters
    //  ---

    this.getParameters = function() {

        /**
         * @method getParameters
         * @summary Returns the receiver's parameters. For a TP.core.Hash this
         *     returns the hash itself since a TP.core.Hash is a valid parameter
         *     block in TIBET.
         * @returns {Object} A TP.core.Hash, TP.sig.Request, or Object
         *     containing parameter data (typically).
         */

        return this;
    };

    //  register with TIBET by hand
    this.getParameters[TP.NAME] = 'getParameters';
    this.getParameters[TP.OWNER] = TP.boot.PHash;
    this.getParameters[TP.TRACK] = TP.INST_TRACK;
    this.getParameters[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.getParameters';

    //  ---
    //  getSize
    //  ---

    this.getSize = function() {

        /**
         * @method getSize
         * @summary Returns the size of the receiver, which is the count of the
         *     keys stored in the hash.
         * @returns {Number} The size.
         */

        return TP.objectGetKeys(this.$$hash).length;
    };

    //  register with TIBET by hand
    this.getSize[TP.NAME] = 'getSize';
    this.getSize[TP.OWNER] = TP.boot.PHash;
    this.getSize[TP.TRACK] = TP.INST_TRACK;
    this.getSize[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.getSize';

    //  ---
    //  getTypeName
    //  ---

    this.getTypeName = function() {

        /**
         * @method getTypeName
         * @summary Returns the type name of the receiver.
         * @returns {String}
         */

        //  one of the few places we'll admit this :)
        return 'TP.boot.PHash';
    };

    //  register with TIBET by hand
    this.getTypeName[TP.NAME] = 'getTypeName';
    this.getTypeName[TP.OWNER] = TP.boot.PHash;
    this.getTypeName[TP.TRACK] = TP.INST_TRACK;
    this.getTypeName[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.getTypeName';

    //  ---
    //  getValues
    //  ---

    this.getValues = function() {

        /**
         * @method getValues
         * @summary Returns an array containing the values of the receiver.
         * @returns {Object[]} An array containing the receiver's values.
         */

        var arr,
            keys,
            length,
            j;

        arr = TP.ac();

        keys = TP.objectGetKeys(this.$$hash);
        length = keys.length;

        for (j = 0; j < length; j++) {
            arr.push(this.$$hash[keys[j]]);
        }

        return arr;
    };

    //  register with TIBET by hand
    this.getValues[TP.NAME] = 'getValues';
    this.getValues[TP.OWNER] = TP.boot.PHash;
    this.getValues[TP.TRACK] = TP.INST_TRACK;
    this.getValues[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.getValues';

    //  ---
    //  hasKey
    //  ---

    this.hasKey = function(aKey) {

        /**
         * @method hasKey
         * @summary Returns true if the receiver has a defined value for the
         *     key provided.
         * @param {String} aKey The key to test for.
         * @returns {Boolean} True if the key is defined.
         */

        //  Nothing on Object.prototype, this should work.
        return TP.objectGetKeys(this.$$hash).indexOf(aKey) !== TP.NOT_FOUND;
    };

    //  register with TIBET by hand
    this.hasKey[TP.NAME] = 'hasKey';
    this.hasKey[TP.OWNER] = TP.boot.PHash;
    this.hasKey[TP.TRACK] = TP.INST_TRACK;
    this.hasKey[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.hasKey';

    //  ---
    //  perform
    //  ---

    this.perform = function(aFunction) {

        /**
         * @method perform
         * @summary Performs the function with each item of the receiver.
         * @description Perform can be used as an alternative to constructing
         *     for loops to iterate over a collection.
         * @param {Function} aFunction A function which performs some action
         *     with each item.
         * @returns {Object} The receiver.
         */

        var j,
            keys,
            length,
            item;

        item = TP.ac();

        keys = TP.objectGetKeys(this.$$hash);
        length = keys.length;

        for (j = 0; j < length; j++) {
            //  update iteration edge flags so our function can tell when
            //  its at the start/end of the overall collection
            aFunction.$first = j === 0 ? true : false;
            aFunction.$last = j === length - 1 ? true : false;

            item[0] = keys[j];
            item[1] = this.$$hash[keys[j]];

            if (aFunction(item, j) === TP.BREAK) {
                break;
            }
        }

        return this;
    };

    //  register with TIBET by hand
    this.perform[TP.NAME] = 'perform';
    this.perform[TP.OWNER] = TP.boot.PHash;
    this.perform[TP.TRACK] = TP.INST_TRACK;
    this.perform[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.perform';

    //  ---
    //  removeKey
    //  ---

    this.removeKey = function(aKey) {

        /**
         * @method removeKey
         * @summary Removes the key specified (and its related value).
         * @param {Object} aKey The key to use for locating the value. Note this
         *     is usually a String, but could be any object with a valid
         *     toString method.
         * @returns {TP.boot.PHash} The receiver.
         */

        //  we don't want to call delete on a non-existent property
        if (this.$$hash[aKey] === undefined) {
            return;
        }

        //  Make sure that the supplied key matches a property on our own
        //  self, not our prototype (which is TP.ObjectProto, so it has a
        //  few ;-) ).
        if (!TP.owns(this.$$hash, aKey)) {
            return;
        }

        delete this.$$hash[aKey];

        return this;
    };

    //  register with TIBET by hand
    this.removeKey[TP.NAME] = 'removeKey';
    this.removeKey[TP.OWNER] = TP.boot.PHash;
    this.removeKey[TP.TRACK] = TP.INST_TRACK;
    this.removeKey[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.removeKey';

    //  ---
    //  $set
    //  ---

    this.$set = function(attributeName, attributeValue) {

        /**
         * @method $set
         * @summary Sets the property with the given name, adjusted for
         *     standard TIBET attribute prefixing rules as needed.
         * @param {String} attributeName The attribute name to set.
         * @param {Object} attributeValue The value to set.
         * @returns {Object} The value of the named property.
         */

        var name;

        if (TP.isDefined(this[attributeName])) {
            name = attributeName;
        } else {
            TP.ifWarn() ?
                TP.warn(TP.sc('Setting undeclared attribute: ',
                            TP.name(this), '.', attributeName,
                                ' (', TP.tname(this), ')',
                            TP.tname(this) === 'Window' ?
                                TP.sc(' -- Possible unbound function') :
                                '')) : 0;
        }

        try {
            this[name] = attributeValue;
        } catch (e) {
            return this.raise(
                    'TP.sig.InvalidOperation',
                    TP.ec(e, TP.join('Unable to set ', attributeValue,
                                    ' for key: ', attributeName)));
        }

        return this;
    };

    //  register with TIBET by hand
    this.$set[TP.NAME] = '$set';
    this.$set[TP.OWNER] = TP.boot.PHash;
    this.$set[TP.TRACK] = TP.INST_TRACK;
    this.$set[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.$set';

    //  ---
    //  set
    //  ---

    this.set = function(attributeName, attributeValue) {

        /**
         * @method set
         * @summary Sets the value of the named attribute to the value
         *     provided. NOTE that this operates on the hash instance's
         *     properties, not its content. Use atPut for content.
         * @param {String} attributeName The attribute name to set.
         * @param {Object} attributeValue The value to set.
         * @returns {TP.core.Hash} The receiver.
         */

        return this.$set(attributeName, attributeValue);
    };

    //  register with TIBET by hand
    this.set[TP.NAME] = 'set';
    this.set[TP.OWNER] = TP.boot.PHash;
    this.set[TP.TRACK] = TP.INST_TRACK;
    this.set[TP.DISPLAY] = 'TP.boot.PHash.' +
            TP.INST_TRACK + '.set';

    return this;
};

//  ------------------------------------------------------------------------

//  define the prototype's reference to properly show it's a prototype
TP.boot.PHash.prototype.$$prototype = TP.boot.PHash.prototype;

//  ------------------------------------------------------------------------

TP.isPlainObject = function(anObj) {

    /**
     * @method isPlainObject
     * @summary Returns true if the object provided is a 'plain JavaScript
     *     Object' - that is, created via 'new Object()' or '{}'.
     * @param {Object} anObj The object to test.
     * @example Test what's a type and what's not:
     *     <code>
     *          anObj = new Object();
     *          TP.isPlainObject(anObj);
     *          <samp>true</samp>
     *          anObj = {};
     *          TP.isPlainObject(anObj);
     *          <samp>true</samp>
     *          anObj = true;
     *          TP.isPlainObject(anObj);
     *          <samp>false</samp>
     *          anObj = 42;
     *          TP.isPlainObject(anObj);
     *          <samp>false</samp>
     *          anObj = '';
     *          TP.isPlainObject(anObj);
     *          <samp>false</samp>
     *          anObj = [];
     *          TP.isPlainObject(anObj);
     *          <samp>false</samp>
     *          anObj = TP.lang.Object.construct();
     *          TP.isPlainObject(anObj);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is a Type.
     */

    //  Based on jQuery 2.X isPlainObject with additional checks for TIBET
    //  objects.

    if (anObj === null ||
        anObj === undefined ||
        anObj.$$type ||
        typeof anObj !== 'object' ||
        anObj.nodeType ||
        anObj.moveBy) {
        return false;
    }

    if (anObj.constructor && !TP.ObjectProto.hasOwnProperty.call(
                                anObj.constructor.prototype,
                                'isPrototypeOf')) {
        return false;
    }

    return true;
};

//  Manual method registration.
TP.isPlainObject[TP.NAME] = 'isPlainObject';
TP.isPlainObject[TP.OWNER] = TP;
TP.isPlainObject[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.isPlainObject[TP.DISPLAY] = 'TP.isPlainObject';
TP.registerLoadInfo(TP.isPlainObject);

//  ------------------------------------------------------------------------

TP.hc = function() {

    /**
     * @method hc
     * @summary Constructs a simple hash (i.e. "dictionary"), which can be used
     *     to contain key/value pairs. This primitive version is limited to
     *     simple key, value, key, value vararg lists.
     * @param {arguments} varargs A variable list of 0 to N elements to place in
     *     the hash.
     * @example Construct a TP.core.Hash:
     *     <code>
     *          newHash = TP.hc('lname', 'Smith');
     *          <samp>{"lname":"Smith"}</samp>
     *     </code>
     * @returns {TP.core.Hash} A new instance.
     */

    var dict,
        len,
        i;

    //  If we get invoked on a TP.boot.PHash just return it like a noop.
    if (arguments[0] instanceof TP.boot.PHash) {
        return arguments[0];
    } else if (TP.isPlainObject(arguments[0])) {
        return new TP.boot.PHash(arguments[0]);
    }

    dict = new TP.boot.PHash();
    len = arguments.length;

    for (i = 0; i < len; i = i + 2) {
        if (TP.notValid(arguments[i])) {
            return this.raise('TP.sig.InvalidKey');
        }
        dict.atPut(arguments[i], arguments[i + 1]);
    }

    dict[TP.PROXIED] = dict;

    return dict;
};

//  Note that we do *NOT* set up track & owner information for 'TP.hc' here.
//  This is the *primitive* hash type. 'TP.hc()' will get overlaid later in the
//  boot process to be a shortcut for creating a 'TP.core.Hash' and we want all
//  of that to be 'clean'.

//  Make sure that we alias this over to a convenient 'primitive hash create'
//  call
TP.phc = TP.hc;

//  ------------------------------------------------------------------------
//  PROPERTY DESCRIPTOR
//  ------------------------------------------------------------------------

//  reusable ECMA property descriptor entries
TP.CONSTANT_DESCRIPTOR = {
    writable: false,
    configurable: false
};

TP.DEFAULT_DESCRIPTOR = {
};

TP.HIDDEN_DESCRIPTOR = {
    enumerable: false,
    configurable: false
};

TP.HIDDEN_CONSTANT_DESCRIPTOR = {
    enumerable: false,
    writable: false,
    configurable: false
};

//  ------------------------------------------------------------------------

//  build the initial metadata and information containers
(function() {

    TP.sys.$$meta_types = TP.hc();
    TP.sys.$$meta_attributes = TP.hc();
    TP.sys.$$meta_handlers = [];
    TP.sys.$$meta_methods = TP.hc();
    TP.sys.$$meta_owners = TP.hc();
    TP.sys.$$meta_namespaces = TP.hc();
    TP.sys.$$meta_pathinfo = TP.hc();

    TP.sys.$$metadata = TP.hc('types', TP.sys.$$meta_types,
                                'attributes', TP.sys.$$meta_attributes,
                                'handlers', TP.sys.$$meta_handlers,
                                'methods', TP.sys.$$meta_methods,
                                'namespaces', TP.sys.$$meta_namespaces,
                                'owners', TP.sys.$$meta_owners,
                                'pathinfo', TP.sys.$$meta_pathinfo);
}());

//  ------------------------------------------------------------------------

TP.objectGetMetadataName = function(anObject, itemClass) {

    /**
     * @method objectGetMetadataName
     * @summary Returns the 'name' used by the metadata system for the supplied
     *     object.
     * @param {Object} anObject The object to return the name of
     * @param {String} itemClass The nature of the item being added. Valid
     *     values include TP.SUBTYPE, TP.METHOD, TP.ATTRIBUTE, TP.NAMESPACE.
     * @returns {String} The name used by the metadata system for the supplied
     *     object.
     */

    if (anObject === null || anObject === undefined) {
        return;
    }

    switch (itemClass) {
        case TP.METHOD:
            return anObject[TP.OWNER].getName() + '_' +
                    anObject[TP.TRACK] + '_' +
                    anObject.getName();
        case TP.TYPE:
            return anObject.getName();
        default:
            break;
    }

    //  Check method first...there are a lot more of them passing through here.
    if (TP.isMethod(anObject)) {
        return anObject[TP.OWNER].getName() + '_' +
                anObject[TP.TRACK] + '_' +
                anObject.getName();
    }

    if (TP.isType(anObject)) {
        return anObject.getName();
    }

    return;
};

//  Manual method registration.
TP.objectGetMetadataName[TP.NAME] = 'objectGetMetadataName';
TP.objectGetMetadataName[TP.OWNER] = TP;
TP.objectGetMetadataName[TP.TRACK] = TP.LOCAL_TRACK;
TP.objectGetMetadataName[TP.DISPLAY] = 'TP.objectGetMetadataName';
TP.registerLoadInfo(TP.objectGetMetadataName);

//  ------------------------------------------------------------------------

TP.sys.addMetadata = function(targetType, anItem, itemClass, itemTrack) {

    /**
     * @method addMetadata
     * @summary Stores metadata about an object, typically a type or method,
     *     which is necessary to drive certain operations. The metadata is
     *     dynamic, keeping track of all operations affecting types and methods
     *     within the system so that runtime reflection data is accurate and
     *     available for storage/reuse.
     * @description TIBET provides a number of functions that are "unusual",
     *     shall we say, when it comes to JavaScript. Examples are dynamic
     *     autoloading (without require statements or other programmer
     *     intervention) and on-the-fly method inferencing.
     *
     *     To support these operations TIBET keeps information on the structure
     *     of the type hierarchy, which types implement various methods, what
     *     source file loaded an object, etc.
     * @param {TP.FunctionProto|TP.lang.RootObject} targetType The type object
     *     which owns this metadata. Note that this parameter is ignored for
     *     items of type TP.SUBTYPE and TP.NAMESPACE.
     * @param {Object} anItem The actual object providing the source information
     *     for the metadata. In the case of a TP.METHOD, this will be the
     *     Function object that is the method body. In the case of a
     *     TP.ATTRIBUTE, this will be the attribute descriptor. In the case of a
     *     TP.SUBTYPE, this will be the type object itself.
     * @param {String} itemClass The nature of the item being added. Valid
     *     values include TP.SUBTYPE, TP.METHOD, TP.ATTRIBUTE, TP.NAMESPACE.
     *     Note that you can add instance metadata for some of these by
     *     combining them with TP.INST_*TRACK as the itemTrack parameter.
     * @param {String} itemTrack An optional track which provides data regarding
     *     properties (methods and attributes). Valid values include:
     *          TP.GLOBAL_TRACK
     *          TP.PRIMITIVE_TRACK
     *          TP.INST_TRACK
     *          TP.TYPE_TRACK
     *          TP.TYPE_LOCAL_TRACK
     */

    var iname,

        tname,
        gname,

        owners,

        pathinfo,
        itemkey;

    //  Need a name for metadata key.
    // if (TP.notValid(iname = anItem[TP.NAME])) {
    if (!(iname = anItem[TP.NAME])) {
        return;
    }

    //  Register load information for the supplied item, like load path, source
    //  path, etc.
    TP.registerLoadInfo(anItem);

    switch (itemClass) {
        case TP.METHOD:

            tname = targetType.getName();
            gname = tname + '_' + itemTrack + '_' + iname;

            if (/^handle/.test(iname)) {
                TP.sys.$$meta_handlers.push(iname);
                TP.sys.$$meta_handlers[TP.REVISED] = Date.now();
            }

            TP.sys.$$meta_methods.atPut(gname, anItem);

            //  owners are keyed by name and point to a vertical-bar
            //  separated list of one or more type names. these are
            //  tracked for all types so the inferencer can do type
            //  conversion checks regardless of whether the type is part
            //  of the kernel or not
            owners = TP.sys.$$meta_owners.at(iname);
            if (!owners) {
                TP.sys.$$meta_owners.atPut(iname, tname);
            } else {
                TP.sys.$$meta_owners.atPut(iname,
                    owners += TP.JOIN + tname);
            }

            break;

        case TP.ATTRIBUTE:

            tname = targetType.getName();
            gname = tname + '_' + itemTrack + '_' + iname;

            TP.sys.$$meta_attributes.atPut(gname, anItem);

            //  If the item has a 'value' slot and the value there responds
            //  to 'isAccessPath' and is, in fact, an access path, then we
            //  register it in TP.sys.$$meta_pathinfo. This acts as a
            //  'reverse index' of access paths to aspect names.
            if (anItem.value &&
                anItem.value.isAccessPath &&
                anItem.value.isAccessPath()) {

                //  Note here how we pass 'false' for the 'non verbose'
                //  String representation of the path (that is, the version
                //  that was actually authored by the user).
                itemkey = anItem.value.asString(false);

                pathinfo = TP.sys.$$meta_pathinfo.at(
                                        tname + '_' + itemTrack);
                if (!pathinfo) {
                    pathinfo = {};

                    TP.sys.$$meta_pathinfo.atPut(
                                        tname + '_' + itemTrack,
                                        pathinfo);
                }

                if (!pathinfo[itemkey]) {
                    pathinfo[itemkey] = [];
                }

                pathinfo[itemkey].push(iname);
            }

            break;

        case TP.SUBTYPE:

            TP.sys.$$meta_types.atPut(iname, anItem);

            //  If the system has started we need to keep track of any types
            //  which load so we can ensure they get their initialize methods
            //  invoked. This is coordinated with the boot code which does the
            //  loading so it can trigger things after full file loading.
            if (TP.sys.hasStarted()) {
                TP.debug('Pushing ' + iname + ' to boot post import list.');
                TP.boot.$pushPostImport(anItem);
            }

            break;

        case TP.NAMESPACE:

            TP.sys.$$meta_namespaces.atPut(iname, anItem);

            break;

        default:
            break;
    }

    return;
};

//  Manual method registration.
TP.sys.addMetadata[TP.NAME] = 'addMetadata';
TP.sys.addMetadata[TP.OWNER] = TP.sys;
TP.sys.addMetadata[TP.TRACK] = TP.LOCAL_TRACK;
TP.sys.addMetadata[TP.DISPLAY] = 'TP.sys.addMetadata';
TP.registerLoadInfo(TP.sys.addMetadata);

//  -----------------------------------------------------------------------
//  SLOT AND METHOD DEFINITION
//  -----------------------------------------------------------------------

TP.defineSlot = function(target, name, value, type, track, descriptor) {

    /**
     * @method defineSlot
     * @summary Defines a slot, which may be an attribute, method, etc.
     * @param {Object} target The object receiving the slot.
     * @param {String|Symbol} name The slot name (or Symbol identifier).
     * @param {Object} value The slot value.
     * @param {String} type The slot type (attribute, method, etc).
     * @param {String} track The slot track (type, inst, local, etc).
     * @param {Object} descriptor An ECMA5-ish property descriptor, notable for
     *     not having 'value', 'get' and 'set' slots like a real ECMA5 property
     *     descriptor would. NOTE that this object is _NOT_ passed to the ECMA5
     *     Object.defineProperty() call.
     * @returns {Object} The assigned slot value.
     */

    //  If we were handed a descriptor, then try to use ECMA5's defineProperty()
    //  call
    if (TP.isValid(descriptor)) {

        if (descriptor.writable === false && value !== undefined) {
            //  We send in a different object to make sure that if 'get' or
            //  'set' was defined on the supplied descriptor that it won't be
            //  forwarded. Note here that, since this slot is being configured
            //  as a 'constant', a value should've been supplied and we supply
            //  that to the defineProperty() call.
            Object.defineProperty(
                target,
                name,
                {
                    writable: descriptor.writable !== false,
                    enumerable: descriptor.enumerable !== false,
                    configurable: descriptor.configurable !== false,
                    value: value
                });
        } else {
            //  We send in a different object to make sure that if 'get' or
            //  'set' was defined on the supplied descriptor that it won't be
            //  forwarded.
            Object.defineProperty(
                target,
                name,
                {
                    writable: descriptor.writable !== false,
                    enumerable: descriptor.enumerable !== false,
                    configurable: descriptor.configurable !== false
                });

            //  Try to set the value if its real.
            if (value !== undefined) {
                target[name] = value;
            } else if (target[name] === undefined) {
                target[name] = null;
            }
        }
    } else {
        //  Otherwise, just try to set the value if its real.
        if (value !== undefined) {
            target[name] = value;
        } else if (target[name] === undefined) {
            target[name] = null;
        }
    }

    return target[name];
};

//  Manual method registration.
TP.defineSlot[TP.NAME] = 'defineSlot';
TP.defineSlot[TP.OWNER] = TP;
TP.defineSlot[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.defineSlot[TP.DISPLAY] = 'TP.defineSlot';
TP.registerLoadInfo(TP.defineSlot);

//  ------------------------------------------------------------------------

TP.stringStripFunctionSource = function(str) {

    var arr,
        tokens,
        len,
        i,
        token,
        count,
        result;

    if (typeof TP.$tokenize !== 'function') {
        return;
    }

    //  strip down to tokens that represent the block structure of functions
    /* eslint-disable no-extra-parens */
    tokens = TP.$tokenize(str).filter(
            function(tok) {
                return (tok.name === 'keyword' && tok.value === 'function') ||
                        (tok.name === 'operator' && tok.value === '{') ||
                        (tok.name === 'operator' && tok.value === '}');
            });
    /* eslint-enable no-extra-parens */

    arr = [];

    while (tokens) {
        //  scan for initial function reference to start our process. once we
        //  find it the next token in line is the opening brace for the function
        token = tokens.shift();
        while (token && token.value !== 'function') {
            token = tokens.shift();
        }

        if (!token) {
            break;
        }

        //  capture opening brace token. it will have the start index for dicing
        token = tokens.shift();
        arr.push(token.to);
        count = 1;

        //  scan through tokens until we find closing one...
        while (token && count !== 0) {
            token = tokens.shift();
            if (token.value === '{') {
                count++;
            } else if (token.value === '}') {
                count--;
            }
        }

        if (count === 0) {
            arr.push(token.to);
        }
    }

    //  Didn't find anything...return the original source.
    if (!arr) {
        return str;
    }

    result = '';

    //  first slice location is 0, last target is length.
    arr.unshift(0);
    arr.push(str.length);

    len = arr.length;
    for (i = 0; i < len; i += 2) {
        result += str.slice(arr[i], arr[i + 1]);
    }

    return result;
};

TP.stringStripFunctionSource[TP.NAME] = 'stringStripFunctionSource';
TP.stringStripFunctionSource[TP.OWNER] = TP;
TP.stringStripFunctionSource[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.stringStripFunctionSource[TP.DISPLAY] = 'TP.stringStripFunctionSource';
TP.registerLoadInfo(TP.stringStripFunctionSource);

//  ------------------------------------------------------------------------

TP.functionNeedsCallee = function(aFunction, aName) {

    /**
     * @method functionNeedsCallee
     * @summary Returns true if the function provided has at least one call to
     *     callNextMethod which requires the function to be proxied with a
     *     wrapper to handle callee management.
     * @param {Function} aFunction The function to test.
     * @param {String} aName The method name, if the Function is some Object's
     *     method.
     * @returns {Boolean} True if the function should be patched.
     */

    var obj,

        str,
        callee,
        funcStmt,
        chunk,
        result;

    obj = TP.getRealFunction(aFunction);

    str = '' + obj;

    //  No mention of a callee-qualifying snippet? We're in the clear.
    callee = TP.regex.NEEDS_CALLEE.exec(str);
    if (!callee) {
        return false;
    }

    //  Use multiline mode to strip lines starting with whitespace followed by
    //  single-line comment prefix (//) or multi-line comment prefix (/*) or
    //  multi-line comment body prefixing. This won't be perfect if multiline
    //  comments don't have '*' in front of every line, it will leave tidbits of
    //  their comment body in the text...and if a line were to start with '*' as
    //  part of a multiplication that'd be potentially bad as well...except it's
    //  highly unlikely the remainder of that line has 'function' or callNext*.
    str = str.replace(/^\s*\/\/.*$/mg, '').replace(/^\s*(\/\*|\*).*$/mg, '');

    //  slice out the method body so the function's boilerplate isn't in the way
    str = str.slice(str.indexOf('{') + 1, str.lastIndexOf('}'));

    //  After comments are gone no mention of a callee-qualifying snippet?
    callee = TP.regex.NEEDS_CALLEE.exec(str);
    if (!callee) {
        return false;
    }

    //  find first mention of 'function' after the opening one. if that's after
    //  the index to callee this one is before any possible embedded functions.
    funcStmt = str.indexOf('function');
    if (funcStmt === TP.NOT_FOUND || callee.index < funcStmt) {
        return true;
    }

    //  if the last } (block) is followed by callee bits it must be in main
    chunk = str.split('}').slice(-1);
    if (chunk && chunk[0].match(TP.regex.NEEDS_CALLEE)) {
        return true;
    }

    //  Have to do it the heavy-lifting way by using a more tokenized approach.
    str = TP.stringStripFunctionSource(str);

    result = TP.regex.NEEDS_CALLEE.test(str);

    //  Since tokenizing to find out the answer is heavy on startup we want to
    //  help optimize by suggesting that an explicit flag be set.
    TP.warn('Method ' + aName + ' should use explicit patchCallee value of ' +
                result);

    return result;
};

TP.functionNeedsCallee[TP.NAME] = 'functionNeedsCallee';
TP.functionNeedsCallee[TP.OWNER] = TP;
TP.functionNeedsCallee[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.functionNeedsCallee[TP.DISPLAY] = 'TP.functionNeedsCallee';
TP.registerLoadInfo(TP.functionNeedsCallee);

//  ------------------------------------------------------------------------

//  When tracking invocations, we go ahead and cache this flag on the 'TP'
//  object for much better performance when loading the system. This is a
//  system-wide flag anyway, so using this mechanism is not a problem.
TP.__trackInvocations__ = TP.sys.cfg('oo.$$track_invocations');

TP.defineMethodSlot =
function(target, name, value, track, descriptor, display, owner, $isHandler) {

    /**
     * @method defineMethodSlot
     * @summary Defines a method, tracking all necessary metadata.
     * @param {Object} target The target object.
     * @param {String|Symbol} name The slot name (or Symbol identifier).
     * @param {Object} value The method value (aka method 'body').
     * @param {String} track The method track (Inst, Type, Local). Default is
     *     TP.LOCAL_TRACK.
     * @param {Object} descriptor An optional 'property descriptor'. If a
     *     'value' slot is supplied here, it is ignored in favor of the value
     *     parameter to this method.
     * @param {String} display The method display name. Defaults to the owner
     *     ID plus the track and name.
     * @param {Object} owner The owner object. Defaults to target.
     * @param {Boolean} [$isHandler=false] True will cause the definition to
     *     pass without errors for deprecated use of defineMethod for handlers.
     * @returns {Function} The newly defined method.
     */

    var own,
        trk,

        realMethod,

        methodName,

        desc,

        installCalleePatch,

        installedInvocationsTracker,

        methodWantsInvocationTracking,

        wrappedMethod,

        method,
        disp;

    own = owner || target;
    trk = track || TP.LOCAL_TRACK;

    realMethod = value;

    //  In case this is a Symbol.
    methodName = name.toString();

    //  If we've been through here once already for this Function instance, then
    //  that means that we're aliasing this method to another slot. We don't
    //  reinstrument the Function instance representing the value here with
    //  metadata for the alias - we let it keep all of the naming, load
    //  information, etc. of the real method, since that's where and how the
    //  method is truly defined.
    if (realMethod[TP.DISPLAY] !== undefined) {

        //  When anonymous Functions are bound, they will end with
        //  'Function.FunctionProto' as their display name. Even though this
        //  Function object has a TP.DISPLAY slot, we need to proceed with
        //  registering this method, especially if its a signal handler.

        //  Therefore, we only exit here if the display name value that this
        //  Function already has is *not* 'Function.FunctionProto'.
        if (realMethod[TP.DISPLAY] !== 'Function.FunctionProto') {
            //  NB: We do *not* use methodName here - if 'name' is a Symbol, we
            //  want it registered under that Symbol, not a String name.
            TP.defineSlot(target, name, realMethod,
                            TP.METHOD, track, realMethod[TP.DESCRIPTOR]);

            return realMethod;
        }
    }

    if (!TP.isCallable(realMethod) ||
        !TP.isCallable(realMethod.asMethod)) {

        //  If the initalMethod is TP.REQUIRED, then it isn't a method as such,
        //  but a placeholder to note that this method is required. This is
        //  normally used during traits multiple-inheritance composition.
        if (realMethod === TP.REQUIRED) {

            desc = descriptor ? descriptor : TP.DEFAULT_DESCRIPTOR;

            TP.defineSlot(target, methodName, realMethod, TP.METHOD, trk, desc);

            //  capture the descriptor on the realMethod (method body)
            realMethod[TP.DESCRIPTOR] = desc;

        } else {
            TP.ifError() ?
                TP.error('Invalid method body for ' +
                            'TP.defineMethodSlot: ' + methodName) : 0;
        }

        return;
    }

    //  Warn about deprecated use of method definition for handler definition
    //  unless flagged (by the defineHandler call ;)) to keep quiet about it.
    if (!$isHandler && TP.deprecated && /^handle[0-9A-Z]/.test(methodName)) {
        if (descriptor && descriptor.deprecationWarning === false) {
            void 0;
        } else {
            TP.deprecated('Use defineHandler for handler: ' +
                TP.objectGetMetadataName(realMethod, TP.METHOD));
        }
    }

    //  If the body of the function has a reference to methods that need
    //  'callee', then we have to wrap it into a wrapping function so that we
    //  can capture callee (arguments.callee is not valid in ECMA E5 strict
    //  mode). What a pain!
    //  Note that we do allow the method definer to set either 'noCalleePatch'
    //  to true which means that the system will definitely not install a patch,
    //  even if the RegExp passes or 'patchCallee' to true which forces the
    //  system to install a patch, even if the RegExp fails.
    if (realMethod.toString().match(TP.regex.NEEDS_CALLEE)) {
        if (descriptor && descriptor.patchCallee === true) {
            installCalleePatch = true;
        } else if (descriptor && descriptor.patchCallee === false) {
            installCalleePatch = false;
        } else {
            installCalleePatch = TP.functionNeedsCallee(realMethod, methodName);
        }
    }

    installedInvocationsTracker = false;

    if (descriptor && descriptor.trackInvocations !== undefined) {
        methodWantsInvocationTracking = descriptor.trackInvocations;
    } else {
        methodWantsInvocationTracking = true;
    }

    //  If we're tracking invocations and the method isn't a native method and
    //  it's not the 'callNextMethod' method, then go ahead and install a
    //  'wrapper method' that will wrap the original real method with one that
    //  will give invocations data.
    if (TP.__trackInvocations__ &&
        methodWantsInvocationTracking &&
        !TP.regex.NATIVE_CODE.test(realMethod.toString()) &&
        TP.EXCLUDE_INVOCATION_METHOD_NAMES.indexOf(methodName) ===
                                                            TP.NOT_FOUND) {

        installedInvocationsTracker = true;

        //  Capture the real method here so that, even if we change it below,
        //  the closure will have the proper reference.
        wrappedMethod = realMethod;

        //  Define a wrapper method that will stand in for the real method and,
        //  upon invocation, will track invocation and other invocations data
        //  and then invoke the wrapped method.
        method = function() {
            var args,
                retVal;

            method.invocationCount++;

            args = Array.prototype.slice.call(arguments, 0);
            retVal = wrappedMethod.apply(this, args);

            return retVal;
        };

        //  Set the initial invocation count to 0 and put it on the wrapper
        //  method itself.
        method.invocationCount = 0;

        //  Supply a local version of 'getArity' that returns the wrapped
        //  method's arity.
        method.getArity =
            function() {
                return wrappedMethod.getArity();
            };

        //  callNextMethod will try to populate and use the '$$nextfunc'. In
        //  order for CNM to function properly, this slot must be a 'pass
        //  through' to the original wrapped function. Use an ECMA5
        //  getter/setter combination to achieve this.
        Object.defineProperty(
            method,
            '$$nextfunc',
            {
                get: function() {
                    return wrappedMethod.$$nextfunc;
                },

                set: function(aFunc) {
                    wrappedMethod.$$nextfunc = aFunc;
                }
            });

        //  Let's make sure we can get back to the original function here.
        method.$realFunc = realMethod;

        //  And let's make sure we can get back to the wrapper from the original
        //  function as well.
        realMethod.$wrapperFunc = method;

        //  Register the 'invocation' patch under the *original* owner, method
        //  name, track and display for the real method.
        method.asMethod(own, methodName, trk, display);

        //  So this is a little tricky. We've defined a patch function to
        //  'stand in' for (and wrap a call to) our method. We do want to
        //  distinguish the real method from the ersatz for reflection
        //  purposes, so we tell the real method function to instrument itself
        //  with the name of the method it's being stood in for but with a
        //  '$$originalMethod' suffix.
        realMethod.asMethod(own, methodName + '$$originalMethod', trk, display);

        //  If the original 'display' argument was provided, that means that
        //  'asMethod()' won't have set the display name using the supplied
        //  'methodName' - which means we need to append '$$originalMethod' to
        //  the display name.

        //  NB: We use an old fashioned check here for 'isEmpty()' for display,
        //  since this could be called *very* early in the boot process.
        if (display !== null && display !== undefined && display !== '') {
            disp = realMethod[TP.DISPLAY];
            realMethod[TP.DISPLAY] = disp + '$$originalMethod';
        }

        TP.defineSlot(target, methodName + '$$originalMethod', realMethod,
                        TP.METHOD, trk, TP.HIDDEN_DESCRIPTOR);

        //  Lastly, make the 'real method' now be the wrapper method, so that
        //  any further wrapping, etc. will be happening to the wrapper.
        realMethod = method;
    } else {
        //  Ensure metadata is attached along with owner/track etc.
        realMethod.asMethod(own, methodName, trk, display);
    }

    if (installCalleePatch) {

        method = function() {
            var oldCallee,
                oldArgs,
                retVal;

            //  Capture the current values of callee and args - we might
            //  already be in a place where we're using them.
            oldCallee = TP.$$currentCallee$$;
            oldArgs = TP.$$currentArgs$$;

            //  Set the value of the current callee.
            TP.$$currentCallee$$ = realMethod;

            //  Set the value of the current args.
            TP.$$currentArgs$$ = Array.prototype.slice.call(arguments, 0);

            //  Now, call the method, using either call or apply. call tends to
            //  be quite a bit faster if we can use it.
            switch (arguments.length) {
                case 0:
                    retVal = realMethod.call(this);
                    break;
                case 1:
                    retVal = realMethod.call(this, arguments[0]);
                    break;
                case 2:
                    retVal = realMethod.call(this, arguments[0],
                                                    arguments[1]);
                    break;
                case 3:
                    retVal = realMethod.call(this, arguments[0],
                                                    arguments[1],
                                                    arguments[2]);
                    break;
                case 4:
                    retVal = realMethod.call(this, arguments[0],
                                                    arguments[1],
                                                    arguments[2],
                                                    arguments[3]);
                    break;
                case 5:
                    retVal = realMethod.call(this, arguments[0],
                                                    arguments[1],
                                                    arguments[2],
                                                    arguments[3],
                                                    arguments[4]);
                    break;
                default:
                    retVal = realMethod.apply(this, arguments);
            }

            //  Restore the old values for callee and args
            TP.$$currentCallee$$ = oldCallee;
            TP.$$currentArgs$$ = oldArgs;

            return retVal;
        };

        //  Let's make sure we can get back to the original function here.
        method.$realFunc = realMethod;

        //  And let's make sure we can get back to the wrapper from the original
        //  function as well.
        realMethod.$wrapperFunc = method;

        //  So this is a little tricky. We've defined a patch function to
        //  'stand in' for (and wrap a call to) our method. We do want to
        //  distinguish the real method from the ersatz for reflection
        //  purposes, so we tell the patch function to instrument itself
        //  with the name of the method it's standing in for but with a
        //  '$$calleePatch' suffix.
        method.asMethod(own, methodName + '$$calleePatch', trk, display);

        //  If the original 'display' argument was provided, that means that
        //  'asMethod()' won't have set the display name using the supplied
        //  'methodName' - which means we need to append '$$calleePatch' to the
        //  display name.
        if (TP.notEmpty(display)) {
            disp = method[TP.DISPLAY];
            method[TP.DISPLAY] = disp + '$$calleePatch';
        }

        //  We then go ahead and register that on the receiving object under
        //  that name as well. And then, NOTE BELOW: We will register this
        //  patch function as the method *UNDER THE REGULAR NAME* on the
        //  receiving object. Yes, that means that the patch function is
        //  registered under both names, but reflection will be able to
        //  distinguish between the two because it's instrumented itself
        //  with it's "real name" (the method name with the '$$calleePatch'
        //  suffix).
        TP.defineSlot(target, methodName + '$$calleePatch', method, TP.METHOD,
                        trk, TP.HIDDEN_DESCRIPTOR);
    } else {
        //  The logic above determined that we don't want/need a callee
        //  patch.
        method = realMethod;
    }

    /* eslint-disable no-extra-parens */
    desc = descriptor ? descriptor : TP.DEFAULT_DESCRIPTOR;

    //  NB: We do *not* use methodName here - if 'name' is a Symbol, we want it
    //  registered under that Symbol, not a String name.
    TP.defineSlot(target, name, method, TP.METHOD, trk, desc);

    //  capture the descriptor on the method (method body)
    method[TP.DESCRIPTOR] = desc;

    //  There might be a realMethod that's different than method (because we're
    //  patching for callee or we're tracking invocations). Make sure it gets
    //  the descriptor too.
    realMethod[TP.DESCRIPTOR] = desc;

    /* eslint-enable no-extra-parens */

    //  If the method has dependencies to track, grab the Array from the
    //  descriptor and add each dependency to the method's 'dependency'
    //  metadata.
    if (descriptor && descriptor.dependencies) {
        descriptor.dependencies.forEach(
            function(aDependency) {
                TP.objectDefineDependencies(method, aDependency);
            });
    }

    //  we don't wrap 'self' level methods so we need to patch on the load node
    //  manually. All others get it done via addMetadata.
    if (method[TP.OWNER] === self) {

        TP.registerLoadInfo(method);

        return method;
    }

    //  Don't track metadata for local properties.
    if (trk !== TP.LOCAL_TRACK) {

        if (installedInvocationsTracker) {
            TP.sys.addMetadata(own, realMethod, TP.METHOD, trk);
        } else {
            //  NOTE: If we're not installing the invocations tracker here, then
            //  we register the *originally supplied* method body value here in
            //  the metadata. Otherwise, we have problems using reflection to do
            //  things like signal handler name computation.
            TP.sys.addMetadata(own, value, TP.METHOD, trk);
        }
    } else if (methodName.match(/^handle/)) {
        //  still make sure we track handler names for getBestHandlerNames call.
        TP.sys.$$meta_handlers.push(methodName);
        TP.sys.$$meta_handlers[TP.REVISED] = Date.now();
    }

    return method;
};

//  Manual method registration.
TP.defineMethodSlot[TP.NAME] = 'defineMethodSlot';
TP.defineMethodSlot[TP.OWNER] = TP;
TP.defineMethodSlot[TP.TRACK] = TP.PRIMITIVE_TRACK;
TP.defineMethodSlot[TP.DISPLAY] = 'TP.defineMethodSlot';
TP.registerLoadInfo(TP.defineMethodSlot);

//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP, 'definePrimitive',
function(name, bodyOrConditionals, descriptor, display, owner) {

    /**
     * @method definePrimitive
     * @summary Adds the method supplied as a 'primitive' to the 'TP' object
     *     under the name given.
     * @description Note that this method can take a variety of arguments in
     *     the 'methodBodyOrTests' parameter. If no sophisticated 'feature
     *     testing' is required, it can just take a Function in that parameter.
     *     Otherwise, it can take a hash of tests and the matching Functions
     *     that should be installed if the tests pass. See usages throughout
     *     the various primitives files in the system.
     * @param {String} name The name of the new primitive.
     * @param {Function|Object} bodyOrConditionals The actual function
     *     implementation or an object containing tests and associated
     *     implementations.
     * @param {Object} descriptor An optional 'property descriptor'. If a
     *     'value' slot is supplied here, it is ignored in favor of the
     *     bodyOrConditionals parameter to this method.
     * @param {String} display The method display name. Defaults to the owner
     *     ID plus the track and name.
     * @param {Object} owner The owner object. Defaults to target.
     * @returns {Function} The installed primitive.
     */

    var test,
        key,
        method;

    if (!bodyOrConditionals) {
        TP.ifError() ?
            TP.error('Invalid method body or conditionals for ' +
                        'TP.definePrimitive: ' + name) : 0;
        return;
    }

    //  if we weren't handed a Function body, then we need to check what we
    //  were handed.
    if (!TP.isCallable(bodyOrConditionals)) {
        test = bodyOrConditionals.at('test');

        //  The test was a Function... execute it. It should return true or
        //  false. We convert that value to a String.
        if (TP.isCallable(test)) {
            key = '' + test();
        } else {
            //  When provided a string if it's a test name we run that test
            //  and get back either true or false, which presumably is the
            //  proper key for one of our method options below.
            if (typeof test === 'string' && TP.sys.hasFeatureTest(test)) {
                key = TP.sys.hasFeature(test);
            } else {
                //  If the test isn't a string, or isn't a known test name
                //  we'll just convert to string directly the cheap way.
                key = ('' + test).toLowerCase();
            }
        }

        //  Look up the method in the dictionary provided.
        method = bodyOrConditionals.at(key);
        if (typeof method === 'undefined') {
            //  If there's a TP.DEFAULT use that when the key isn't
            //  found in the dictionary.
            method = bodyOrConditionals.at(TP.DEFAULT);
        }
    } else {
        //  If the parameter _is_ a function we got the method already.
        method = bodyOrConditionals;
    }

    return TP.defineMethodSlot(
            TP, name, method, TP.PRIMITIVE_TRACK, descriptor, display, owner);

}, TP.PRIMITIVE_TRACK, null, 'TP.definePrimitive');

//  ------------------------------------------------------------------------
//  Object Testing
//  ------------------------------------------------------------------------

TP.definePrimitive('isDefined',
function(aValue) {

    /**
     * @method isDefined
     * @summary Returns false if the value passed in is undefined as opposed to
     *     null or valid. In other words, aValue is 'defined' if its got a
     *     value...even if that value is 'null'.
     * @param {Object} aValue The value to test.
     * @example Test to see if anObj is defined:
     *     <code>
     *          if (TP.isDefined(anObj)) { TP.info('its defined'); };
     *     </code>
     * @returns {Boolean} Whether or not the value is defined.
     */

    return aValue !== undefined;
}, null, 'TP.isDefined');

//  ------------------------------------------------------------------------

TP.definePrimitive('isNaN',
function(aValue) {

    /**
     * @method isNaN
     * @summary Returns true if the value provided is NaN.
     * @description The ECMAScript-supplied isNaN lies:
            isNaN({}) => true.
            Welcome to JavaScript. Oh...but it gets better. If you run isNaN
            on the wrong thing it'll throw an exception about being unable to
            convert to a primitive.
            Hence, this method.
     * @param {Object} aValue The value to test.
     * @example Test to see if anObj is NaN:
     *     <code>
     *          if (TP.isNaN(anObj)) { TP.info('its NaN'); };
     *     </code>
     * @returns {Boolean} Whether or not the value is NaN.
     */

    //  NB: Firefox can occasionally hang at 100% CPU  on the native isNaN call
    //  if handed an 'orphaned' (i.e. prototype-less) object, so we check for
    //  the __proto__ slot here as well.
    /* eslint-disable no-proto */
    if (TP.isValid(aValue) &&
        TP.isValid(aValue.__proto__) &&
        aValue.constructor === Number &&
        isNaN(aValue)) {
        return true;
    }
    /* eslint-enable no-proto */

    return false;
}, null, 'TP.isNaN');

//  ------------------------------------------------------------------------

TP.definePrimitive('isNull',
function(aValue) {

    /**
     * @method isNull
     * @summary Returns true if aValue is truly 'null' (ie. === null) rather
     *     than undefined or a non-null value.
     * @param {Object} aValue The value to test.
     * @example Test to see if anObj is null:
     *     <code>
     *          if (TP.isNull(anObj)) { TP.info('its null'); };
     *     </code>
     * @returns {Boolean} Whether or not the value is null.
     */

    return aValue === null;
}, null, 'TP.isNull');

//  ------------------------------------------------------------------------

TP.definePrimitive('notDefined',
function(aValue) {

    /**
     * @method notDefined
     * @summary Returns true if the value provided is undefined.
     * @param {Object} aValue The value to test.
     * @example Test to see if anObj is not defined:
     *     <code>
     *          if (TP.notDefined(anObj)) { TP.info('its not defined'); };
     *     </code>
     * @returns {Boolean} Whether or not the value is undefined.
     */

    return aValue === undefined;
}, null, 'TP.notDefined');

//  ------------------------------------------------------------------------

TP.definePrimitive('notNaN',
function(aValue) {

    /**
     * @method notNaN
     * @summary Returns true if the value provided is not NaN.
     * @param {Object} aValue The value to test.
     * @example Test to see if anObj is not NaN:
     *     <code>
     *          if (TP.notNaN(anObj)) { TP.info('its not NaN'); };
     *     </code>
     * @returns {Boolean} Whether or not the value is not NaN.
     */

    return !TP.isNaN(aValue);
}, null, 'TP.notNaN');

//  ------------------------------------------------------------------------

TP.definePrimitive('notNull',
function(aValue) {

    /**
     * @method notNull
     * @summary Returns true if the value provided is not null. Be aware, the
     *     value could be undefined and this method will return true. In cases
     *     where you want to test both you should use the *Valid variations.
     * @param {Object} aValue The value to test.
     * @example Test to see if anObj is not null:
     *     <code>
     *          if (TP.notNull(anObj)) { TP.info('its not null'); };
     *     </code>
     * @returns {Boolean} Whether or not the value is not null.
     */

    return aValue !== null;
}, null, 'TP.notNull');

//  ------------------------------------------------------------------------
//  Value-Based Branching
//  ------------------------------------------------------------------------

TP.definePrimitive('ifNull',
function(aSuspectValue, aDefaultValue) {

    /**
     * @method ifNull
     * @summary Returns either aSuspectValue or aDefaultValue based on the
     *     state of aSuspectValue. If aSuspectValue is TP.isNull() aDefaultValue
     *     is returned.
     * @param {Object} aSuspectValue The value to test.
     * @param {Object} aDefaultValue The value to return if aSuspectValue is ===
     *     null.
     * @example Set the value of theObj to true, if anObj is null:
     *     <code>
     *          theObj = TP.ifNull(anObj, true);
     *     </code>
     * @returns {Object} One of the two values provided.
     */

    /* eslint-disable no-extra-parens */
    return (aSuspectValue === null) ? aDefaultValue : aSuspectValue;
    /* eslint-enable no-extra-parens */
}, null, 'TP.ifNull');

//  ------------------------------------------------------------------------

TP.definePrimitive('ifUndefined',
function(aSuspectValue, aDefaultValue) {

    /**
     * @method ifUndefined
     * @summary Returns either aSuspectValue or aDefaultValue based on the
     *     state of aSuspectValue. If aSuspectValue is TP.notDefined()
     *     aDefaultValue is returned.
     * @param {Object} aSuspectValue The value to test.
     * @param {Object} aDefaultValue The value to return if aSuspectValue is ===
     *     undefined.
     * @example Set the value of theObj to true, if anObj is undefined:
     *     <code>
     *          theObj = TP.ifUndefined(anObj, true);
     *     </code>
     * @returns {Object} One of the two values provided.
     */

    /* eslint-disable no-extra-parens */
    return (aSuspectValue === undefined) ? aDefaultValue : aSuspectValue;
    /* eslint-enable no-extra-parens */
}, null, 'TP.ifUndefined');

//  ------------------------------------------------------------------------
//  TYPE CHECKS
//  ------------------------------------------------------------------------

TP.definePrimitive('isESClass',
function(anObj) {

    /**
     * @method isESClass
     * @summary Returns true if the object provided is an ECMAScript 'class'
     *     Function, as distinct from a regular Function.
     * @param {Object} anObj The object to test.
     * @returns {Boolean} Whether or not the supplied object is an ECMAScript
     *     class Function.
     */

    //  If the object is a Function, but it doesn't have an 'apply', then its an
    //  ECMAScript class. You can't 'apply' ECMAScript classes directly - you
    //  can only use them as constructor Functions with the 'new' keyword.
    return typeof anObj === 'function' && !anObj.apply;

}, null, 'TP.isESClass');

//  ------------------------------------------------------------------------

TP.definePrimitive('isNativeFunction',
function(anObj) {

    /**
     * @method isNativeFunction
     * @summary Returns true if the object provided acts as a native (i.e.
     *     builtin) Function.
     * @param {Object} anObj The object to test.
     * @returns {Boolean} Whether or not the supplied object is a native
     *     Function (that is, one that is built into the browser).
     */

    return TP.regex.NATIVE_CODE.test(anObj.toString());

}, null, 'TP.isNativeFunction');

//  ------------------------------------------------------------------------

TP.definePrimitive('isNativeObject',
function(anObj) {

    /**
     * @method isNativeObject
     * @summary Returns true if the object is an instance of a native type.
     * @param {Object} anObj The object to test.
     * @returns {Boolean} Whether or not the object is a native instance.
     */

    return TP.isNativeType(TP.type(anObj));

}, null, 'TP.isNativeObject');

//  ------------------------------------------------------------------------

TP.definePrimitive('isNativeType',
function(anObj) {

    /**
     * @method isNativeType
     * @summary Returns true if the object provided is a native type for the
     *     current browser.
     * @description Because the browsers don't have a common set of types the
     *     results of this method may vary based on the browser in question.
     *     The results are consistent for the "big 8" and the major types which
     *     extend those 8 such as Event, but most HTML/DOM types will vary
     *     between implementations. By also checking for 'non Function'
     *     constructors here, we try to mitigate this problem.
     * @param {Object} anObj The object to test.
     * @returns {Boolean} Whether or not the supplied object is a native type
     *     (that is, one that is built into the browser).
     */

    //  Many 'native types' on Chrome will report as NaN using the standard
    //  isNaN() test - weird
    if (typeof anObj === 'number') {
        return false;
    }

    /* eslint-disable no-extra-parens */
    return ((TP.isFunction(anObj) || TP.isNonFunctionConstructor(anObj)) &&
                 TP.isType(anObj)) ||
            (anObj === Function);
    /* eslint-enable no-extra-parens */
}, null, 'TP.isNativeType');

//  ------------------------------------------------------------------------

TP.definePrimitive('isNode',
function(anObj) {

    /**
     * @method isNode
     * @summary Returns true if the object provided is a DOM node, regardless
     *     of whether it's in an HTML or XML DOM. This is a simple test for a
     *     valid nodeType property.
     * @param {Object} anObj The object to test.
     * @example Test what's a node and what's not:
     *     <code>
     *          TP.isNode(TP.documentGetBody(document)); // Elements are Nodes
     *          <samp>true</samp>
     *          TP.isNode(document); // So are documents
     *          <samp>true</samp>
     *          // So are attribute nodes
     *          TP.isNode(TP.documentGetBody(document).attributes[0]);
     *          <samp>true</samp>
     *          TP.isNode(window); // Windows are not
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is a Node.
     */

    //  NB: This is a very heavily used routine, so we use very primitive
    //  checking in it.
    return anObj !== null &&
            anObj !== undefined &&
            anObj.nodeType !== undefined;
}, null, 'TP.isNode');

//  ------------------------------------------------------------------------

TP.definePrimitive('isNonFunctionConstructor',
function(anObj) {

    /**
     * @method isNonFunctionConstructor
     * @summary Returns whether or not the supplied object is a 'non Function'
     *     constructor. Host environments have constructors that are not
     *     Functions, but are faked by the platform.
     * @param {Object} anObj The object to test.
     * @returns {Boolean} Whether or not the supplied object is a non Function
     *     constructor object.
     */

    var val;

    //  NB: This is a very heavily used routine, so we use very primitive
    //  checking in it.

    val = TP.getNonFunctionConstructorName(anObj);

    return val !== undefined && val !== null;

}, null, 'TP.isNonFunctionConstructor');

//  ------------------------------------------------------------------------

TP.definePrimitive('getNonFunctionConstructorName',
function(anObj) {

    /**
     * @method getNonFunctionConstructorName
     * @summary Returns a name for a 'non Function' constructor. Host
     *     environments have constructors that are not Functions, but are faked
     *     by the platform. This function will return an appropriate name for
     *     them.
     * @param {Object} anObj The Object to return the name for.
     * @returns {String} The name for the supplied non-Function constructor
     *     object.
     */

    var list,
        exclusionList;

    //  NB: This is a very heavily used routine, so we use very primitive
    //  checking in it.

    if (anObj === null || anObj === undefined) {
        return;
    }

    if (TP.sys.$$nonFunctionConstructors !== undefined) {
        return anObj.$$nonFunctionConstructorObjectName;
    }

    //  Build a list of the 'non Function' constructors in the system. This
    //  will help significantly during type testing.

    list = [];

    //  These 4 objects will show up because of the algorithm we use to
    //  determine non-Function constructors. We filter for them.
    exclusionList = ['TP', 'APP', 'Infinity', 'NaN'];

    //  Define a silly slot on Function.prototype. This is how we'll test to see
    //  if a constructor 'Function' is *really* a Function.
    Function.prototype.fluffycat = 'fluffycat';

    //  Loop over all of the globals that were found in our startup sequence.
    //  Note that TP.sys.$nativeglobals gets redone as a TP.core.Hash during
    //  system finalization, but at the point the first call to this method is
    //  made, it is still an Array.
    TP.sys.$nativeglobals.forEach(
            function(aProp) {
                var obj;

                //  If the property name matches what we think should be a
                //  'native type name', then test it for being a non-Function
                //  constructor.
                if (TP.regex.NATIVE_TYPENAME.test(aProp)) {
                    obj = TP.global[aProp];

                    //  If the slot we defined on Function.prototype isn't
                    //  there and the property is:
                    //
                    //  - not in our exclusion list above
                    //  - it's not a slot corresponding to a Window (like
                    //  iframe Windows are)
                    //  - it's not a Number (believe it or not, on some
                    //  platforms, it will be... Chrome...)
                    //
                    //  then add both the object and the property name to our
                    //  list. This is how we get both the object reference and
                    //  the name that goes along with it.

                    //  Note that we put this in a try...catch to avoid problems
                    //  with some environments wanting to throw an exception
                    //  when accessing the slot that we placed on
                    //  Function.prototype. In that case, it's very likely to be
                    //  a non-Function constructor object, which means we should
                    //  add it to our list.
                    try {
                        if (!obj.fluffycat &&
                            exclusionList.indexOf(aProp) === TP.NOT_FOUND &&
                            !TP.isWindow(obj) &&
                            !TP.isNumber(obj)) {

                            //  Add it to the list and also instrument the name
                            //  onto the object so that we can use it above.
                            list.push([obj, aProp]);
                            obj.$$nonFunctionConstructorObjectName = aProp;
                        }
                    } catch (e) {
                        //  Must've had a problem instrumenting the name onto
                        //  the object so just add it to the list.
                        list.push([obj, aProp]);
                    }
                }
            });

    //  Make sure to remove our silly slot ;-).
    delete Function.prototype.fluffycat;

    //  Cache the list.
    TP.sys.$$nonFunctionConstructors = list;

    return;

}, null, 'TP.getNonFunctionConstructorName');

//  ------------------------------------------------------------------------

TP.definePrimitive('getRealFunction',
function(anObj) {

    /**
     * @method getRealFunction
     * @summary Returns any 'underlying' Function object that the supplied
     *     Function is standing in for.
     * @description Some functionality in TIBET will install 'wrappers' around
     *     functions / methods and then hook the original function onto a
     *     special property of the wrapper. This call will return the original
     *     Function object that got wrapped.
     * @param {Object} anObj The object to return the original Function for.
     * @returns {Function} The 'real' function, which could be an original
     *     Function that got wrapped or the supplied object if it isn't a
     *     wrapper for something else.
     */

    //  If the supplied object is a bound Function, then this returns the
    //  underlying Function (if bound by our override of
    //  Function.prototype.bind).
    if (TP.isValid(anObj.$realFunc)) {
        return anObj.$realFunc;
    }

    //  If the supplied object is a Function that dispatches into our multiple
    //  inheritance system, then this will be the resolved Function (the
    //  Function that was computed to be the method that should be used).
    if (TP.isValid(anObj.$resolutionMethod)) {
        return anObj.$resolutionMethod;
    }

    //  If we're using the test harness and the supplied object is a spying
    //  Function, then we want to return the Function that it is spying on.
    if (TP.isValid(anObj.$spiedFunc)) {
        return anObj.$spiedFunc;
    }

    //  The supplied Function object didn't have any of those slots - just
    //  return it.
    return anObj;
}, null, 'TP.getRealFunction');

//  ------------------------------------------------------------------------

TP.definePrimitive('isThenable',
function(anObj) {

    /**
     * @method isThenable
     * @summary Returns true if the object provided acts as a 'thenable' (most
     *     likely, a Promise).
     * @param {Object} anObj The object to test.
     * @example Test what's a thenable and what's not:
     *     <code>
     *          anObj = TP.lang.Object.construct();
     *          TP.isThenable(anObj);
     *          <samp>false</samp>
     *          anObj = TP.extern.Promise.resolve();
     *          TP.isThenable(anObj);
     *          <samp>true</samp>
     *          anObj = obj.someMethodThatReturnsResponse();
     *          TP.isThenable(anObj);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is a thenable.
     */

    return TP.canInvoke(anObj, 'then');
}, null, 'TP.isThenable');

//  ------------------------------------------------------------------------

TP.definePrimitive('isType',
function(anObj) {

    /**
     * @method isType
     * @summary Returns true if the object provided acts as a Type/Class. To
     *     properly respond the object must have a META hash reference which
     *     TIBET adds for any object used as a type.
     * @param {Object} anObj The object to test.
     * @example Test what's a type and what's not:
     *     <code>
     *          anObj = TP.lang.Object.construct();
     *          TP.isType(anObj);
     *          <samp>false</samp>
     *          TP.isType(TP.lang.Object);
     *          <samp>true</samp>
     *
     *          TP.isType(Array);
     *          <samp>true</samp>
     *          TP.isType(self);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is a Type.
     */

    var name,
        tname;

    //  NB: This is a very heavily used routine, so we use very primitive
    //  checking in it.

    //  no type name? probably isn't a type... all TIBET types have this
    //  slot and all native JS types should at least see the one on Function.
    //  There is the problem of 'non Function' constructors... a few 'Host'
    //  constructors won't inherit from Function, so we check for those and
    //  return that value.

    if (!anObj ||
        !(tname = anObj.$$typename) ||
        tname === '') {
        return TP.isNonFunctionConstructor(anObj);
    }

    /* eslint-disable no-extra-parens */
    if ((anObj === Function) ||
                (TP.isValid(anObj[TP.TYPE]) &&
                (anObj[TP.TYPE] !== TP.FunctionProto[TP.TYPE]))) {
        return !TP.isNamespace(anObj);
    }
    /* eslint-enable no-extra-parens */

    //  native types are tricksy since they'll just say Function...we need
    //  their actual name to see if it starts with an uppercase character
    //  and we need to avoid instance names which all say Function*
    if (tname === 'Function') {
        //  owner and track can't be NONE, which implies a bound function
        if (anObj[TP.OWNER] === TP.NONE ||
            anObj[TP.TRACK] === TP.NONE) {
            return false;
        }

        //  methods have owners and tracks in TIBET
        if (anObj[TP.OWNER] && anObj[TP.TRACK]) {
            return false;
        }

        name = anObj.$getName();

        //  unfortunately our last option is a bit error prone, but we'll
        //  say types have to match a certain naming standard

        /* eslint-disable no-extra-parens */
        return (name.indexOf('Function' + TP.OID_PREFIX) !== 0) &&
                TP.regex.NATIVE_TYPENAME.test(name);
        /* eslint-enable no-extra-parens */
    }

    return false;
}, null, 'TP.isType');

//  ------------------------------------------------------------------------

TP.definePrimitive('isWindow',
function(anObj) {

    /**
     * @method isWindow
     * @summary Returns true if the object to be tested is a window.
     * @param {Object} anObj The object to test.
     * @example Test what's a window and what's not:
     *     <code>
     *          TP.isWindow(window)
     *          <samp>true</samp>
     *          anElem = document.createElement('iframe');
     *          TP.nodeAppendChild(TP.documentGetBody(document), anElem);
     *          TP.isWindow(TP.elementGetIFrameWindow(anElem));
     *          <samp>true</samp>
     *          TP.isWindow(document)
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is a frame.
     */

    /* eslint-disable no-extra-parens */
    return (TP.isValid(anObj) && anObj.moveBy !== undefined);
    /* eslint-enable no-extra-parens */
}, null, 'TP.isWindow');

//  ------------------------------------------------------------------------
//  PROTOTYPE TESTING
//  ------------------------------------------------------------------------

TP.definePrimitive('isPrototype',
function(anObject) {

    /**
     * @method isPrototype
     * @summary Returns true if the object is being used as a prototypical
     *     instance within the constructor.prototype chain or within TIBET's
     *     inheritance mechanism.
     * @param {Object} anObject The object to test.
     * @returns {Boolean} True if the supplied object is being used as a
     *     prototype.
     */

    var obj;

    //  All TIBET prototype objects are 'marked' as prototype objects with the
    //  '$$prototype' slot. Native objects used as prototypes are not. They
    //  should be detected with the logic at the bottom of this method.
    if (TP.isValid(anObject) &&
        TP.owns(anObject, '$$prototype') &&
        anObject.$$prototype === anObject) {

        return true;
    }

    if (TP.isType(anObject)) {
        return false;
    }

    //  Starting at the receiver's constructor prototype, iterate up the
    //  prototype chain. If you find an object that matches the supplied object,
    //  then it's a prototype.
    obj = anObject.constructor.prototype;
    while (obj) {
        if (anObject === obj) {
            return true;
        }

        obj = Object.getPrototypeOf(obj);
    }

    return false;

}, null, 'TP.isPrototype');

//  ------------------------------------------------------------------------
//  MUTABILITY/REFERENCE
//  ------------------------------------------------------------------------

/*
JavaScript objects come in essentially four flavors: mutable/reference,
mutable/non-reference, non-mutable/reference, and non-mutable/non-reference.

Certain operations care very much whether an object is mutable, or of a
reference type, since it affects how properties related to those objects can
be managed. Unfortunately the JavaScript language isn't clear about allowing
an object to have a non-mutable _value_ but mutable _metadata_ so we have to
work around that in different browsers.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('isMutable',
function(anObj) {

    /**
     * @method isMutable
     * @summary Returns true if the object provided is mutable. NOTE that when
     *     testing the inverse (not mutable) you will get true values back for
     *     null/undefined so don't assume that a return value of true means it's
     *     a primitive string/number/boolean, it might also be a null/undefined
     *     value.
     * @description JavaScript has a number of non-mutable types, particularly
     *     Boolean, Number, and String (at least value-wise). This is important
     *     when trying to make decisions about whether a slot modification will
     *     succeed or fail.
     *     NOTE: Even though Function objects don't have 'official' properties
     *     that can be set, we consider them to be mutable, since custom
     *     properties can be set on them.
     * @param {Object} anObj The object to test.
     * @example Test what's mutable and what's not:
     *     <code>
     *          TP.isMutable(42);
     *          <samp>false</samp>
     *          TP.isMutable(true);
     *          <samp>false</samp>
     *          TP.isMutable('Hi there');
     *          <samp>false</samp>
     *          TP.isMutable(TP.fc('x = 2'));
     *          <samp>true</samp>
     *          TP.isMutable(TP.lang.Object.construct());
     *          <samp>true</samp>
     *          TP.isMutable(TP.ac());
     *          <samp>true</samp>
     *          TP.isMutable(TP.dc());
     *          <samp>true</samp>
     *          TP.isMutable(TP.rc());
     *          <samp>true</samp>
     *          TP.isMutable(TP.hc());
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is mutable.
     */

    if (TP.notValid(anObj)) {
        return false;
    }

    //  Strings, Numbers, Booleans are *not* mutable (but their prototypes are)

    /* eslint-disable no-extra-parens */
    if (typeof anObj.charAt === 'function' && anObj !== TP.StringProto ||
        typeof anObj.toPrecision === 'function' && anObj !== TP.NumberProto) {
        return false;
    }
    /* eslint-enable no-extra-parens */

    //  Check for Booleans - unfortunately, since this uses valueOf(), we must
    //  'protect' that against orphan (i.e. __proto__-less objects).
    if (TP.isCallable(anObj.valueOf)) {
        if (anObj === TP.DateProto) {
            return true;
        }

        if ((anObj.valueOf() === true || anObj.valueOf() === false) &&
            anObj !== TP.BooleanProto) {
            return false;
        }
    }

    if (TP.isCallable(anObj.$$isMutable)) {
        return anObj.$$isMutable();
    }

    //  everything else is mutable
    return true;
}, null, 'TP.isMutable');

//  ------------------------------------------------------------------------

TP.definePrimitive('isReferenceType',
function(anObj) {

    /**
     * @method isReferenceType
     * @summary Returns true if the type provided is a reference type.
     * @description Reference types don't support copy-on-write semantics within
     *     the JS prototype system. This means certain operations need to "do
     *     the right thing" and make a copy when necessary. This is particularly
     *     apparent when working with TIBET attributes -- reference type
     *     attributes are normally initialized in the init() method while the
     *     others can be defined in the add*Attribute definition calls -- unless
     *     you truly want to share one attribute across all instances (or all
     *     subtypes).
     * @param {Object} anObj The object to test.
     * @example Test what's a reference type and what's not:
     *     <code>
     *          TP.isReferenceType(42);
     *          <samp>false</samp>
     *          TP.isReferenceType(true);
     *          <samp>false</samp>
     *          TP.isReferenceType('hi');
     *          <samp>false</samp>
     *          TP.isReferenceType(new Date());
     *          <samp>false</samp>
     *          TP.isReferenceType(function() {alert('hi'));
     *          <samp>false</samp>
     *          TP.isReferenceType(/foo/);
     *          <samp>false</samp>
     *          TP.isReferenceType({});
     *          <samp>true</samp>
     *          TP.isReferenceType([]);
     *          <samp>true</samp>
     *          TP.isReferenceType(TP.lang.Object.construct());
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is a 'reference
     *     type'.
     */

    var type;

    if (TP.notValid(anObj)) {
        return false;
    }

    if (TP.isArray(anObj)) {
        return true;
    }

    if (!TP.isMutable(anObj)) {
        return false;
    }

    if (TP.isType(anObj) && TP.isCallable(anObj.$$isReferenceType)) {
        return anObj.$$isReferenceType();
    }

    if (TP.isType(type = TP.type(anObj)) &&
        TP.isCallable(type.$$isReferenceType)) {
        return type.$$isReferenceType();
    }

    //  If it's not an Array and neither it or it's type can answer to
    //  '$$isReferenceType', then only return true if its a plain Object.
    return anObj.constructor === Object;
}, null, 'TP.isReferenceType');

//  ------------------------------------------------------------------------

TP.definePrimitive('genUUID',
function() {

    /**
     * @method genUUID
     * @summary Generates an RFC4122 version 4 UUID.
     * @description This solution courtesy of 'broofa' at:
     *      http://stackoverflow.com/questions/105034/
     *          how-to-create-a-guid-uuid-in-javascript
     * @returns {String} An RFC4122 version 4 compliant UUID
     */

    /* eslint-disable no-extra-parens */
    return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(
            /[xy]/g,
            function(c) {
                var r, v;

                /* eslint-disable no-sequences */
                r = Math.random() * 16 | 0, v = c === 'x' ?
                    r : (r & 0x3 | 0x8);
                /* eslint-enable no-sequences */

                return v.toString(16);
            });
    /* eslint-enable no-extra-parens */
}, null, 'TP.genUUID');

//  ------------------------------------------------------------------------
//  PERFORMANCE TRACKING
//  ------------------------------------------------------------------------

/*
We want plenty of options for tuning TIBET performance over time and the
first requirement in tuning TIBET is having real data on performance. The
TP.sys.$statistics collection holds the data collected.
*/

if (TP.notValid(TP.sys.$statistics)) {
    /* eslint-disable no-new-object */
    TP.sys.$statistics = new Object();
    /* eslint-enable no-new-object */
}

//  ------------------------------------------------------------------------
//  Function/Method Enhancements
//  ------------------------------------------------------------------------

TP.definePrimitive('isMethod',
function(anObject) {

    /**
     * @method isMethod
     * @summary Returns true if the object provided is a method on some object.
     * @param {Object} anObject The object to test.
     * @returns {Boolean} Whether or not the supplied object is a method.
     */

    var str;

    str = TP.ObjectProto.toString.call(anObject);

    return (str === '[object Function]' || str === '[object AsyncFunction]') &&
            anObject[TP.OWNER] &&
            anObject[TP.TRACK] &&
            anObject[TP.OWNER] !== TP.NONE &&
            anObject[TP.TRACK] !== TP.NONE &&
            anObject[TP.TRACK] !== TP.GLOBAL_TRACK;

}, null, 'TP.isMethod');

//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP.sys, 'shouldLogCodeChanges',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogCodeChanges
     * @summary Controls and returns the state of the 'log changes' flag.
     * @description This flag determines whether changes which are logged for
     *     altering TIBET code are stored. This flag is central to the IDE and
     *     inferencer processing which can generate code to upgrade your
     *     application and save it for later use.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log changes:
     *     <code>
     *          TP.sys.shouldLogCodeChanges(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs changes in the system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.code_changes', aFlag, shouldSignal);
    }

    return TP.sys.cfg('log.code_changes');
}, TP.LOCAL_TRACK, null, 'TP.sys.shouldLogCodeChanges');

//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP.sys, '$$shouldConstructDNUs',
function(aFlag, shouldSignal) {

    /**
     * @method $$shouldConstructDNUs
     * @summary Controls and returns the state of the 'construct DNU' flag.
     * @description This flag determines whether TIBET generates top-level
     *     DoesNotUnderstand catch methods. This flag is not intended for public
     *     use. It's off during early kernel loading and turned on near the end
     *     of kernel load. It should be left on during your application
     *     execution.
     * @param {Boolean} aFlag Turn behavior on or off? Default is true.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to not construct DNUs:
     *     <code>
     *          TP.sys.$$shouldConstructDNUs(false);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET should construct DNUs.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('oo.$$construct_dnus', aFlag, shouldSignal);
    }

    return TP.sys.cfg('oo.$$construct_dnus');
}, TP.LOCAL_TRACK, null, 'TP.sys.$$shouldConstructDNUs');

//  -----------------------------------------------------------------------
//  Native Types - PROPERTY CREATION SUPPORT
//  ------------------------------------------------------------------------

//  Create 'stub' objects that will act as the '.Type' and '.Inst' objects for
//  native types. These are created automatically for TIBET types (i.e.
//  instances of TP.lang.RootObject and its subtypes), but we have to patch them
//  onto the natives. They contain definitions of 'defineMethod()',
//  'defineAttribute()', 'defineConstant()', 'get()' and 'set()' that install
//  those kinds of properties onto the correct target with the correct owner and
//  track.

//  NB: We do this inside of a closure to try to hide the stub variables from
//  the global scope
(function() {

    var NativeTypeStub;

    NativeTypeStub = new Function();
    NativeTypeStub.prototype = {};

    //  ---

    NativeTypeStub.prototype.get =
    function(attributeName) {

        /**
         * @method get
         * @summary Returns the value, if any, for the attribute provided.
         * @param {String|TP.path.AccessPath} attributeName The name of the
         *     attribute to get.
         * @returns {Object} The value of the attribute on the receiver.
         */

        return this.$$target.get(attributeName);
    };

    //  ---

    NativeTypeStub.prototype.defineAttribute =
    function(attributeName, attributeValue, attributeDescriptor) {

        /**
         * @method defineAttribute
         * @summary Adds the attribute with name and value provided as a type
         *     attribute.
         * @param {String} attributeName The attribute name.
         * @param {Object} attributeValue The attribute value.
         * @param {Object} [attributeDescriptor] Optional property descriptor.
         * @returns {Object} The newly defined attribute value.
         */

        return TP.defineAttributeSlot(
                this.$$target, attributeName, attributeValue,
                TP.TYPE_TRACK, attributeDescriptor, this[TP.OWNER]);
    };

    //  ---

    NativeTypeStub.prototype.defineConstant =
    function(constantName, constantValue, constantDescriptor) {

        /**
         * @method defineConstant
         * @summary Adds/defines a new type constant for the receiver.
         * @param {String} constantName The constant name.
         * @param {Object} constantValue The constant value.
         * @param {Object} [constantDescriptor] Optional property descriptor.
         * @returns {Object} The newly defined constant value.
         */

        return TP.defineConstantSlot(
                this.$$target, constantName, constantValue,
                TP.TYPE_TRACK, constantDescriptor, this[TP.OWNER]);
    };

    //  ---

    NativeTypeStub.prototype.defineMethod =
    function(methodName, methodBody, methodDescriptor) {

        /**
         * @method defineMethod
         * @summary Adds the function with name and body provided as a type
         *     method.
         * @param {String} methodName The name of the new method.
         * @param {Function} methodBody The actual method implementation.
         * @param {Object} methodDescriptor An optional 'property descriptor'.
         *     If a 'value' slot is supplied here, it is ignored in favor of the
         *     methodBody parameter to this method.
         * @returns {Object} The receiver.
         */

        return TP.defineMethodSlot(
                this.$$target, methodName, methodBody, TP.TYPE_TRACK,
                methodDescriptor, null, this[TP.OWNER]);
    };

    //  ---

    NativeTypeStub.prototype.set =
    function(attributeName, attributeValue, shouldSignal) {

        /**
         * @method set
         * @summary Sets the value of the named attribute to the value provided.
         *     If no value is provided the value null is used.
         * @param {String|TP.path.AccessPath} attributeName The name of the
         *     attribute to set.
         * @param {Object} attributeValue The value to set.
         * @param {Boolean} shouldSignal If false no signaling occurs. Defaults
         *     to this.shouldSignalChange().
         * @returns {Object} The receiver.
         */

        return this.$$target.set(attributeName, attributeValue, shouldSignal);
    };

    //  ---
    //  Reflection methods
    //  ---

    NativeTypeStub.prototype.getMethod =
    function(aName, aTrack) {

        /**
         * @method getMethod
         * @summary Returns the named method, if it exists.
         * @param {String} aName The method name to locate.
         * @param {String} aTrack The track to locate the method on. This is an
         *     optional parameter.
         * @returns {Function} The Function object representing the method.
         */

        return TP.method(this.$$target,
                            aName,
                            TP.ifEmpty(aTrack, TP.TYPE_TRACK));
    };

    //  ---

    NativeTypeStub.prototype.getMethods =
    function(aTrack) {

        /**
         * @method getMethods
         * @summary Returns an Array of methods for the receiver.
         * @param {String} aTrack The track to locate the methods on. This is an
         *     optional parameter.
         * @returns {Function[]} An Array of Function objects representing the
         *     methods.
         */

        return TP.methods(this.$$target, TP.ifEmpty(aTrack, TP.TYPE_TRACK));
    };

    //  ---

    NativeTypeStub.prototype.getMethodInfoFor =
    function(methodName) {

        /**
         * @method getMethodInfoFor
         * @summary Returns information for the method with the supplied name on
         *     the receiver.
         * @description This method returns a TP.core.Hash containing the method
         *     owner, name, track and display, under the keys 'owner', 'name',
         *     'track' and 'display', respectively
         * @param {String} aName The method name to return method information
         *     for.
         * @returns {TP.core.Hash} The hash containing the method information as
         *     described in the method comment.
         */

        var existingMethod;

        if (!TP.isMethod(existingMethod = this.getMethod(methodName))) {
            return null;
        }

        return TP.hc('owner', existingMethod[TP.OWNER],
                        'name', methodName,
                        'track', existingMethod[TP.TRACK],
                        'display', existingMethod[TP.DISPLAY]);
    };

    //  ---
    //  Testing methods
    //  ---

    NativeTypeStub.prototype.describe =
    function(suiteName, suiteFunc) {

        /**
         * @method describe
         * @summary Adds a new test suite definition to an object. When the
         *     suite name matches a method name that suite is automatically
         *     associated with the specific method.
         * @param {String} suiteName The name of the new test suite. Should be
         *     unique to the particular receiver. If this matches a method name
         *     the suite is associated with that method.
         * @param {Function} suiteFunc The function representing the test suite.
         *     Should contain at least one call to 'this.it', the test case
         *     definition method on TP.test.Suite.
         */

        return TP.test.Suite.addSuite(this.$$target, suiteName, suiteFunc);
    };

    //  ---

    NativeTypeStub.prototype.getTestFixture =
    function() {

        /**
         * Creates and returns test fixture data suitable for the receiver. This
         * method is used to produce "the object under test" for test cases that
         * target the receiver. The default is the receiver itself.
         * @returns {Object} A test fixture for the receiver.
         */

        return this.$$target;
    };

    //  ---

    NativeTypeStub.prototype.getTestSuites =
    function(options) {

        /**
         * Returns the list of test suites for the receiver matching options.
         * @param {TP.core.Hash} options A dictionary of test options.
         * @returns {TP.test.Suite[]} A list of test suite instances matching
         *     the options.
         */

        var params;

        params = TP.hc(options);
        params.atPut('target', this.$$target);

        return TP.test.getSuites(params);
    };

    //  ---

    NativeTypeStub.prototype.runTestSuites =
    function(options) {

        /**
         * Runs the test suites associated with the receiver. Options which help
         * configure and control the testing process can be provided.
         * @param {TP.core.Hash} options A dictionary of test options.
         * @returns {Promise} A Promise to be used as necessary.
         */

        var params;

        params = TP.hc(options);
        params.atPut('target', this.$$target);

        return TP.test.runSuites(params);
    };

    //  ---

    Array.Type = new NativeTypeStub();
    Array.Type.$$target = Array;
    Array.Type[TP.OWNER] = Array;

    Boolean.Type = new NativeTypeStub();
    Boolean.Type.$$target = Boolean;
    Boolean.Type[TP.OWNER] = Boolean;

    Date.Type = new NativeTypeStub();
    Date.Type.$$target = Date;
    Date.Type[TP.OWNER] = Date;

    Function.Type = new NativeTypeStub();
    Function.Type.$$target = Function;
    Function.Type[TP.OWNER] = Function;

    Number.Type = new NativeTypeStub();
    Number.Type.$$target = Number;
    Number.Type[TP.OWNER] = Number;

    Object.Type = new NativeTypeStub();
    Object.Type.$$target = Object;
    Object.Type[TP.OWNER] = Object;

    RegExp.Type = new NativeTypeStub();
    RegExp.Type.$$target = RegExp;
    RegExp.Type[TP.OWNER] = RegExp;

    String.Type = new NativeTypeStub();
    String.Type.$$target = String;
    String.Type[TP.OWNER] = String;

    Window.Type = new NativeTypeStub();
    Window.Type.$$target = Window;
    Window.Type[TP.OWNER] = Window;

}());

//  ---

//  NB: We do this inside of a closure to try to hide the stub variables from
//  the global scope
(function() {

    var NativeInstStub;

    NativeInstStub = new Function();
    NativeInstStub.prototype = {};

    //  ---

    NativeInstStub.prototype.get =
    function(attributeName) {

        /**
         * @method get
         * @summary Returns the value, if any, for the attribute provided.
         * @param {String|TP.path.AccessPath} attributeName The name of the
         *     attribute to get.
         * @returns {Object} The value of the attribute on the receiver.
         */

        return this.$$target.get(attributeName);
    };

    //  ---

    NativeInstStub.prototype.defineAttribute =
    function(attributeName, attributeValue, attributeDescriptor) {

        /**
         * @method defineAttribute
         * @summary Adds the attribute with name and value provided as an
         *     instance attribute.
         * @param {String} attributeName The attribute name.
         * @param {Object} attributeValue The attribute value.
         * @param {Object} [attributeDescriptor] Optional property descriptor.
         * @returns {Object} The newly defined attribute value.
         */

        return TP.defineAttributeSlot(
                this.$$target, attributeName, attributeValue,
                TP.INST_TRACK, attributeDescriptor, this[TP.OWNER]);
    };

    //  ---

    NativeInstStub.prototype.defineConstant =
    function(constantName, constantValue, constantDescriptor) {

        /**
         * @method defineConstant
         * @summary Adds/defines a new type constant for the receiver.
         * @param {String} constantName The constant name.
         * @param {Object} constantValue The constant value.
         * @param {Object} [constantDescriptor] Optional property descriptor.
         * @returns {Object} The newly defined constant value.
         */

        return TP.defineConstantSlot(
                this.$$target, constantName, constantValue,
                TP.INST_TRACK, constantDescriptor, this[TP.OWNER]);
    };

    //  ---

    NativeInstStub.prototype.defineMethod =
    function(methodName, methodBody, methodDescriptor) {

        /**
         * @method defineMethod
         * @summary Adds the function with name and body provided as an instance
         *     method.
         * @param {String} methodName The name of the new method.
         * @param {Function} methodBody The actual method implementation.
         * @param {Object} methodDescriptor An optional 'property descriptor'.
         *     If a 'value' slot is supplied here, it is ignored in favor of the
         *     methodBody parameter to this method.
         * @returns {Object} The receiver.
         */

        return TP.defineMethodSlot(
                this.$$target, methodName, methodBody, TP.INST_TRACK,
                methodDescriptor, null, this[TP.OWNER]);
    };

    //  ---

    NativeInstStub.prototype.set =
    function(attributeName, attributeValue, shouldSignal) {

        /**
         * @method set
         * @summary Sets the value of the named attribute to the value provided.
         *     If no value is provided the value null is used.
         * @param {String|TP.path.AccessPath} attributeName The name of the
         *     attribute to set.
         * @param {Object} attributeValue The value to set.
         * @param {Boolean} shouldSignal If false no signaling occurs. Defaults
         *     to this.shouldSignalChange().
         * @returns {Object} The receiver.
         */

        return this.$$target.set(attributeName, attributeValue, shouldSignal);
    };

    //  ---
    //  Reflection methods
    //  ---

    NativeInstStub.prototype.getMethod =
    function(aName, aTrack) {

        /**
         * @method getMethod
         * @summary Returns the named method, if it exists.
         * @param {String} aName The method name to locate.
         * @param {String} aTrack The track to locate the method on. This is an
         *     optional parameter.
         * @returns {Function} The Function object representing the method.
         */

        return TP.method(this.$$target,
                            aName,
                            TP.ifEmpty(aTrack, TP.INST_TRACK));
    };

    //  ---

    NativeInstStub.prototype.getMethods =
    function(aTrack) {

        /**
         * @method getMethods
         * @summary Returns an Array of methods for the receiver.
         * @param {String} aTrack The track to locate the methods on. This is an
         *     optional parameter.
         * @returns {Function[]} An Array of Function objects representing the
         *     methods.
         */

        return TP.methods(this.$$target, TP.ifEmpty(aTrack, TP.INST_TRACK));
    };

    //  ---

    NativeInstStub.prototype.getMethodInfoFor =
    function(methodName) {

        /**
         * @method getMethodInfoFor
         * @summary Returns information for the method with the supplied name on
         *     the receiver.
         * @description This method returns a TP.core.Hash containing the method
         *     owner, name, track and display, under the keys 'owner', 'name',
         *     'track' and 'display', respectively
         * @param {String} aName The method name to return method information
         *     for.
         * @returns {TP.core.Hash} The hash containing the method information as
         *     described in the method comment.
         */

        var existingMethod;

        if (!TP.isMethod(existingMethod = this.getMethod(methodName))) {
            return null;
        }

        return TP.hc('owner', existingMethod[TP.OWNER],
                        'name', methodName,
                        'track', existingMethod[TP.TRACK],
                        'display', existingMethod[TP.DISPLAY]);
    };

    //  ---
    //  Testing methods
    //  ---

    NativeInstStub.prototype.describe =
    function(suiteName, suiteFunc) {

        /**
         * @method describe
         * @summary Adds a new test suite definition to an object. When the
         *     suite name matches a method name that suite is automatically
         *     associated with the specific method.
         * @param {String} suiteName The name of the new test suite. Should be
         *     unique to the particular receiver. If this matches a method name
         *     the suite is associated with that method.
         * @param {Function} suiteFunc The function representing the test suite.
         *     Should contain at least one call to 'this.it', the test case
         *     definition method on TP.test.Suite.
         */

        return TP.test.Suite.addSuite(this.$$target, suiteName, suiteFunc);
    };

    //  ---

    NativeInstStub.prototype.getTestFixture =
    function() {

        /**
         * Creates and returns test fixture data suitable for the receiver. This
         * method is used to produce "the object under test" for test cases that
         * target the receiver. The default is the receiver itself.
         * @returns {Object} A test fixture for the receiver.
         */

        return this.$$target;
    };

    //  ---

    NativeInstStub.prototype.getTestSuites =
    function(options) {

        /**
         * Returns the list of test suites for the receiver matching options.
         * @param {TP.core.Hash} options A dictionary of test options.
         * @returns {TP.test.Suite[]} A list of test suite instances matching
         *     the options.
         */

        var params;

        params = TP.hc(options);
        params.atPut('target', this.$$target);

        return TP.test.getSuites(params);
    };

    //  ---

    NativeInstStub.prototype.runTestSuites =
    function(options) {

        /**
         * Runs the test suites associated with the receiver. Options which help
         * configure and control the testing process can be provided.
         * @param {TP.core.Hash} options A dictionary of test options.
         * @returns {Promise} A Promise to be used as necessary.
         */

        var params;

        params = TP.hc(options);
        params.atPut('target', this.$$target);

        return TP.test.runSuites(params);
    };

    //  ---

    Array.Inst = new NativeInstStub();
    Array.Inst.$$target = TP.ArrayProto;
    Array.Inst[TP.OWNER] = Array;

    Boolean.Inst = new NativeInstStub();
    Boolean.Inst.$$target = TP.BooleanProto;
    Boolean.Inst[TP.OWNER] = Boolean;

    Date.Inst = new NativeInstStub();
    Date.Inst.$$target = TP.DateProto;
    Date.Inst[TP.OWNER] = Date;

    Function.Inst = new NativeInstStub();
    Function.Inst.$$target = TP.FunctionProto;
    Function.Inst[TP.OWNER] = Function;

    Map.Inst = new NativeInstStub();
    Map.Inst.$$target = TP.MapProto;
    Map.Inst[TP.OWNER] = Map;

    Number.Inst = new NativeInstStub();
    Number.Inst.$$target = TP.NumberProto;
    Number.Inst[TP.OWNER] = Number;

    //  NB: We do *not* make a '.Inst' for Object and expose the Object
    //  prototype here as we do not want to encourage putting things on
    //  Object.prototype

    RegExp.Inst = new NativeInstStub();
    RegExp.Inst.$$target = TP.RegExpProto;
    RegExp.Inst[TP.OWNER] = RegExp;

    Set.Inst = new NativeInstStub();
    Set.Inst.$$target = TP.SetProto;
    Set.Inst[TP.OWNER] = Set;

    String.Inst = new NativeInstStub();
    String.Inst.$$target = TP.StringProto;
    String.Inst[TP.OWNER] = String;

    Window.Inst = new NativeInstStub();
    Window.Inst.$$target = Window.prototype;
    Window.Inst[TP.OWNER] = Window;

}());

//  -----------------------------------------------------------------------
//  TP.lang.RootObject - SUBTYPE CREATION SUPPORT - PART I
//  ------------------------------------------------------------------------

//  Some very early definitions of TP.lang.RootObject so that
//  TP.defineMetaInstMethod() below will work. The rest of the definition of
//  TP.lang.RootObject is in TIBETInheritance.js

//  ------------------------------------------------------------------------
//  Native Type Extensions
//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP.FunctionProto, '$constructPrototype',
function() {

    /**
     * @method $constructPrototype
     * @summary Returns a new prototype constructed by invoking the receiver as
     *     a constructor.
     * @description This method is used exclusively to construct prototype
     *     instances which are used to fill in the inheritance tree. You don't
     *     normally need to override this method since the add*Method() and
     *     add*Attribute() methods configure the prototypes properly for the
     *     majority of cases.
     * @returns {Object}
     */

    var name,
        newinst;

    //  get the name
    name = this.$getName();

    newinst = new this();

    //  set the ID so it marks this object as a prototype (inst or type)
    newinst[TP.ID] = name.strip(/\$\$/) + TP.PROTOTYPE;

    //  TODO:   validate this. Seems a bit suspect since it'll create a circular
    //  reference for things like copy and asString output.
    newinst.$$prototype = newinst;

    return newinst;
}, TP.INST_TRACK, null, 'Function.Inst.$constructPrototype', Function);

//  ------------------------------------------------------------------------
//  TP.lang - BOOTSTRAP DEFINITION
//  ------------------------------------------------------------------------

//  The core TIBET namespace.
TP.defineNamespace('TP.lang');

//  We define the 'meta' namespace as a unique namespace where TIBET types are
//  placed and can be referenced. Types will return the 'meta' namespace as part
//  of their 'getTypeName()' call (i.e. 'TP.meta.lang.Object'). As each type is
//  defined, a reference to it is placed on the 'meta' namespace.
TP.defineNamespace('TP.meta');

//  ------------------------------------------------------------------------
//  TP.lang.RootObject - BOOTSTRAP DEFINITION
//  ------------------------------------------------------------------------

/*
Set up top of the inheritance tree. TIBET uses a metatype system of sorts
that allows types to inherit behavior in the same fashion instances normally
would. In fact, TIBET types ARE instances -- of type instance constructors
that work in their own inheritance hierarchy. The top of that tree is
TP.lang.RootObject and its components. TP.lang.Object is the root of the
main tree but notice that you can have other trees.
*/

//  NB: We don't want closures here...
/* eslint-disable no-new-func */
TP.lang.RootObject$$Type = new Function();
TP.lang.RootObject$$Inst = new Function();
/* eslint-enable no-new-func */

TP.lang.RootObject$$Type.prototype = Object.$constructPrototype();
TP.lang.RootObject$$Inst.prototype = Object.$constructPrototype();

TP.lang.RootObject$$Type[TP.NAME] = 'TP.lang.RootObject$$Type';
TP.lang.RootObject$$Inst[TP.NAME] = 'TP.lang.RootObject$$Inst';

TP.lang.RootObject = new TP.lang.RootObject$$Type();

TP.lang.RootObject$$Type[TP.OWNER] = TP.lang.RootObject;
TP.lang.RootObject$$Inst[TP.OWNER] = TP.lang.RootObject;

//  identification of the prototype instances
TP.lang.RootObject$$Type.prototype[TP.ID] = 'TypePrototype';
TP.lang.RootObject$$Inst.prototype[TP.ID] = 'InstPrototype';

//  hook to the type object at the root of the TIBET type chain
TP.lang.RootObject$$Inst.prototype[TP.TYPE] = TP.lang.RootObject;

//  note that we root this at Object manually
TP.lang.RootObject[TP.TYPE] = TP.lang.RootObject;
TP.lang.RootObject[TP.TYPEC] = TP.lang.RootObject$$Type;
TP.lang.RootObject[TP.INSTC] = TP.lang.RootObject$$Inst;
TP.lang.RootObject[TP.TNAME] = 'TP.lang.RootObject';
TP.lang.RootObject[TP.RNAME] = 'TP.lang.RootObject';
TP.lang.RootObject[TP.SUPER] = Object;
TP.lang.RootObject[TP.SNAME] = 'Object';
TP.lang.RootObject[TP.NAME] = 'TP.lang.RootObject';
TP.lang.RootObject[TP.ID] = 'TP.lang.RootObject';
TP.lang.RootObject[TP.ANCESTOR_NAMES] = ['Object'];
TP.lang.RootObject[TP.ANCESTORS] = [Object];

TP.lang.RootObject.nsRoot = 'TP';
TP.lang.RootObject.nsPrefix = 'lang';
TP.lang.RootObject.localName = 'RootObject';

TP.lang.RootObject.Type = TP.lang.RootObject[TP.TYPEC].prototype;
TP.lang.RootObject.Type[TP.OWNER] = TP.lang.RootObject;
TP.lang.RootObject.Inst = TP.lang.RootObject[TP.INSTC].prototype;
TP.lang.RootObject.Inst[TP.OWNER] = TP.lang.RootObject;

//  -----------------------------------------------------------------------
//  TP Primitives
//  ------------------------------------------------------------------------

TP.definePrimitive('defineGlobalMethod',
function(methodName, methodBody) {

    /**
     * @method defineGlobalMethod
     * @summary Adds the method with name and body provided as a global
     *     method.
     * @description Global methods are methods on the "Global" object, which
     *     means they overlap with Window methods. For that reason there are
     *     some sanity checks that can be performed to help avoid issues when
     *     overriding a Window method.
     * @param {String} methodName The name of the new method.
     * @param {Function} methodBody The actual method implementation.
     * @returns {Function} The installed method.
     */

    var method;

    method = TP.defineMethodSlot(
            TP.global, methodName, methodBody,
            TP.GLOBAL_TRACK, null, 'TP.global.' + methodName);

    //  TODO: verify this is correct.
    TP.sys.defineGlobal(methodName, method, true);

    return method;
}, null, 'TP.defineGlobalMethod');

//  ------------------------------------------------------------------------

TP.definePrimitive('defineMetaTypeAttribute',
function(attributeName, attributeValue, attributeDescriptor) {

    /**
     * @method defineMetaTypeAttribute
     * @summary Adds the attribute with name and value provided as a 'meta
     *     type' attribute.
     * @description Meta type attributes are attributes on the native
     *     constructor Function objects which provide polymorphic state
     *     system-wide. Rather than place these attributes on
     *     Function.prototype, we place them on the other 'core' system
     *     constructor objects (as listed in the TP.META_TYPE_TARGETS array).
     * @param {String} attributeName The attribute name.
     * @param {Object} attributeValue The attribute value.
     * @param {Object} [attributeDescriptor] Optional property descriptor.
     * @returns {Object} The newly defined attribute value.
     */

    var i,
        target,

        result;

    //  Loop over the TP.META_TYPE_TARGETS and install the attribute.
    for (i = 0; i < TP.META_TYPE_TARGETS.length; i++) {
        target = TP.META_TYPE_TARGETS[i];

        result = TP.defineAttributeSlot(
                    target,
                    attributeName,
                    attributeValue,
                    TP.META_TYPE_TRACK,
                    attributeDescriptor,
                    TP.META_TYPE_OWNER);
    }

    return result;
}, null, 'TP.defineMetaTypeAttribute');

//  ------------------------------------------------------------------------

TP.definePrimitive('defineMetaTypeMethod',
function(methodName, methodBody, methodDescriptor) {

    /**
     * @method defineMetaTypeMethod
     * @summary Adds the method with name and body provided as a 'meta type'
     *     method.
     * @description Meta type methods are methods on the native constructor
     *     Functions objects which provide polymorphic behavior system-wide.
     *     Rather than place these methods on Function.prototype, we place them
     *     on the other 'core' system constructor objects (as listed in the
     *     TP.META_TYPE_TARGETS array).
     * @param {String} methodName The name of the new method.
     * @param {Function} methodBody The actual method implementation.
     * @param {Object} methodDescriptor An optional 'property descriptor'.
     * @returns {null}
     */

    var i,
        target,

        existingMethod;

    //  First, we register it with TP.META_TYPE_OWNER's 'meta_methods'
    //  dictionary for easier reflection.
    TP.META_TYPE_OWNER.meta_methods[methodName] = methodBody;

    //  Then, loop over the TP.META_TYPE_TARGETS and install the method.
    for (i = 0; i < TP.META_TYPE_TARGETS.length; i++) {
        target = TP.META_TYPE_TARGETS[i];

        //  If the method already exists and it's owner is *not*
        //  TP.META_TYPE_OWNER, then it was installed by a 'more specific'
        //  method install method and we leave that version alone.
        if ((existingMethod = target[methodName]) &&
            existingMethod[TP.OWNER] !== TP.META_TYPE_OWNER) {
            if (TP.isNativeFunction(existingMethod)) {
                target['ECMA' + methodName] = existingMethod;
                TP.ifDebug() ?
                    TP.debug('Replacing native method definition \'' +
                            methodName + '\' on: ' + target + ' with TIBET' +
                            ' meta-type method. Aliased native method \'' +
                            methodName + '\' to \'ECMA' + methodName +
                            '\'.') : 0;
            } else {
                continue;
            }
        }

        TP.defineMethodSlot(
                target,
                methodName,
                methodBody,
                TP.META_TYPE_TRACK,
                methodDescriptor,
                target[TP.ID] + '.' + TP.META_TYPE_TRACK + '.' + methodName,
                TP.META_TYPE_OWNER);
    }

    return null;
}, null, 'TP.defineMetaTypeMethod');

//  ------------------------------------------------------------------------

TP.definePrimitive('defineMetaInstAttribute',
function(attributeName, attributeValue, attributeDescriptor) {

    /**
     * @method defineMetaInstAttribute
     * @summary Adds the attribute with name and value provided as a 'meta
     *     instance' attribute.
     * @description Meta instance attributes are attributes on a set of objects
     *     that provide polymorphic state system-wide. Rather than place these
     *     attributes on Object.prototype (which is considered bad form), we
     *     place them on the other 'core' system '.prototype' objects (as listed
     *     in the TP.META_INST_TARGETS array) and on the top-most TIBET object,
     *     TP.lang.RootObject.
     * @param {String} attributeName The attribute name.
     * @param {Object} attributeValue The attribute value.
     * @param {Object} [attributeDescriptor] Optional property descriptor.
     * @returns {Object} The newly defined attribute value.
     */

    var i,
        target,

        result;

    //  Loop over the TP.META_INST_TARGETS and install the attribute.
    for (i = 0; i < TP.META_INST_TARGETS.length; i++) {
        target = TP.META_INST_TARGETS[i];

        result = TP.defineAttributeSlot(
                    target,
                    attributeName,
                    attributeValue,
                    TP.META_INST_TRACK,
                    attributeDescriptor,
                    TP.META_INST_OWNER);
    }

    //  If 'TP.lang' is defined as a namespace and 'TP.lang.RootObject' is
    //  defined as a type, then go ahead and install this method as *both* a
    //  type method and an instance method. Since we track it on the same track
    //  (TP.META_INST_TRACK) and the same owner (TP.META_INST_OWNER), track and
    //  owner information don't matter here.
    if (TP.lang && TP.lang.RootObject) {

        target = TP.lang.RootObject$$Type.prototype;

        result = TP.defineAttributeSlot(
                    target,
                    attributeName,
                    attributeValue,
                    TP.META_INST_TRACK,
                    attributeDescriptor,
                    TP.META_INST_OWNER);

        target = TP.lang.RootObject$$Inst.prototype;

        result = TP.defineAttributeSlot(
                    target,
                    attributeName,
                    attributeValue,
                    TP.META_INST_TRACK,
                    attributeDescriptor,
                    TP.META_INST_OWNER);
    }

    return result;
}, null, 'TP.defineMetaInstAttribute');

//  ------------------------------------------------------------------------

TP.definePrimitive('defineMetaInstMethod',
function(methodName, methodBody, methodDescriptor) {

    /**
     * @method defineMetaInstMethod
     * @summary Adds the method with name and body provided as a 'meta
     *     instance' method.
     * @description Meta instance methods are methods on a set of objects that
     *     provide polymorphic behavior system-wide. Rather than place these
     *     methods on Object.prototype (which is considered bad form), we place
     *     them on the other 'core' system '.prototype' objects (as listed in
     *     the TP.META_INST_TARGETS array) and on the top-most TIBET object,
     *     TP.lang.RootObject.
     * @param {String} methodName The name of the new method.
     * @param {Function} methodBody The actual method implementation.
     * @param {Object} methodDescriptor An optional 'property descriptor'.
     * @returns {null}
     */

    var i,
        target,

        existingMethod;

    //  First, we register it with TP.META_INST_OWNER's 'meta_methods'
    //  dictionary for easier reflection.
    TP.META_INST_OWNER.meta_methods[methodName] = methodBody;

    //  Then, loop over the TP.META_INST_TARGETS and install the method.
    for (i = 0; i < TP.META_INST_TARGETS.length; i++) {
        target = TP.META_INST_TARGETS[i];

        //  If the method already exists and it's owner is *not*
        //  TP.META_INST_OWNER, then it was installed by a 'more specific'
        //  method install method and we leave that version alone.
        if ((existingMethod = target[methodName]) &&
            existingMethod[TP.OWNER] !== TP.META_INST_OWNER) {
            if (TP.isNativeFunction(existingMethod)) {
                target['ECMA' + methodName] = existingMethod;
                TP.ifInfo() ?
                    TP.info('Replacing native method definition \'' +
                            methodName + '\' on: ' + target + ' with TIBET' +
                            ' meta-type method. Aliased native method \'' +
                            methodName + '\' to \'ECMA' + methodName +
                            '\'.') : 0;
            } else {
                continue;
            }
        }

        TP.defineMethodSlot(
                target,
                methodName,
                methodBody,
                TP.META_INST_TRACK,
                methodDescriptor,
                target[TP.ID] + '.' + TP.META_INST_TRACK + '.' + methodName,
                TP.META_INST_OWNER);
    }

    //  If 'TP.lang' is defined as a namespace and 'TP.lang.RootObject' is
    //  defined as a type, then go ahead and install this method as *both* a
    //  type method and an instance method. Since we track it on the same track
    //  (TP.META_INST_TRACK) and the same owner (TP.META_INST_OWNER), track and
    //  owner information don't matter here.
    if (TP.lang && TP.lang.RootObject) {

        target = TP.lang.RootObject$$Type.prototype;

        //  If the method already exists and it's owner is *not*
        //  TP.META_INST_OWNER, then it was installed by a 'more specific'
        //  method install method and we leave that version alone.
        if ((existingMethod = target[methodName]) &&
                existingMethod[TP.OWNER] !== TP.META_INST_OWNER) {
            //  Empty block
            void 0;
        } else {
            TP.defineMethodSlot(
                    target,
                    methodName,
                    methodBody,
                    TP.META_INST_TRACK,
                    methodDescriptor,
                    target[TP.ID] + '.' + TP.META_INST_TRACK + '.' + methodName,
                    TP.META_INST_OWNER);
        }

        target = TP.lang.RootObject$$Inst.prototype;

        //  If the method already exists and it's owner is *not*
        //  TP.META_INST_OWNER, then it was installed by a 'more specific'
        //  method install method and we leave that version alone.
        if ((existingMethod = target[methodName]) &&
                existingMethod[TP.OWNER] !== TP.META_INST_OWNER) {
            //  Empty block
            void 0;
        } else {
            TP.defineMethodSlot(
                    target,
                    methodName,
                    methodBody,
                    TP.META_INST_TRACK,
                    methodDescriptor,
                    target[TP.ID] + '.' + TP.META_INST_TRACK + '.' + methodName,
                    TP.META_INST_OWNER);
        }
    }

    return null;
}, null, 'TP.defineMetaInstMethod');

//  ------------------------------------------------------------------------

TP.definePrimitive('defineCommonMethod',
function(methodName, methodBody) {

    /**
     * @method defineCommonMethod
     * @summary Adds the method with name and body provided as a 'common'
     *     method.
     * @description Common methods are methods on a set of objects that provide
     *     polymorphic behavior system-wide. Like 'meta instance methods' above,
     *     rather than place these methods on Object.prototype (which is
     *     considered bad form), we place them on the other 'core' system
     *     '.prototype' objects (as listed in the TP.META_INST_TARGETS array)
     *     and on the top-most TIBET object, TP.lang.RootObject.
     *     Note that the main difference between a 'common' method and a 'meta'
     *     method is that common methods are tracked on the INST_TRACK track and
     *     they are not placed as type methods on TP.lang.RootObject.
     * @param {String} methodName The name of the new method.
     * @param {Function} methodBody The actual method implementation.
     * @returns {null}
     */

    var i,
        target,
        len,
        existingMethod;

    //  First, we register it with TP.META_INST_OWNER's 'common_methods'
    //  dictionary for easier reflection.
    TP.META_INST_OWNER.common_methods[methodName] = methodBody;

    len = TP.META_INST_TARGETS.length;
    for (i = 0; i < len; i++) {
        target = TP.META_INST_TARGETS[i];

        //  If the method already exists and it's owner is *not*
        //  TP.META_INST_OWNER, then it was installed by a 'more specific'
        //  method install method and we leave that version alone.
        if ((existingMethod = target[methodName]) &&
            existingMethod[TP.OWNER] !== TP.META_INST_OWNER) {
            continue;
        }

        TP.defineMethodSlot(
                    target,
                    methodName,
                    methodBody,
                    TP.INST_TRACK,
                    null,
                    target[TP.ID] + '.' + TP.INST_TRACK + '.' + methodName,
                    TP.META_INST_OWNER);
    }

    target = TP.lang.RootObject$$Inst.prototype;

    if ((existingMethod = target[methodName]) &&
            existingMethod[TP.OWNER] !== TP.META_INST_OWNER) {
        //  Empty block
        void 0;
    } else {

        TP.defineMethodSlot(
                    target,
                    methodName,
                    methodBody,
                    TP.INST_TRACK,
                    null,
                    target[TP.ID] + '.' + TP.INST_TRACK + '.' + methodName,
                    TP.META_INST_OWNER);
    }

    return null;
}, null, 'TP.defineCommonMethod');

//  -----------------------------------------------------------------------

TP.definePrimitive('defineAttributeSlot',
function(target, name, value, track, descriptor, owner) {

    /**
     * @method defineAttributeSlot
     * @summary Defines an attribute, tracking all necessary metadata.
     * @description Note that the 'value' parameter can either take an initial
     *     object value or a property descriptor. That property descriptor can
     *     any fields, but here are the ones that TIBET standardizes:
     *
     *          configurable (Boolean)
     *          enumerable (Boolean)
     *          writable (Boolean)
     *          value (Object)
     *          readonly (Boolean or path - isn't passed along to E5 call)
     *          relevant (Boolean or path - isn't passed along to E5 call)
     *          required (Boolean or path - isn't passed along to E5 call)
     *
     * @param {Object} target The target object.
     * @param {String} name The attribute name.
     * @param {Object} value The attribute value or a property descriptor
     *     object.
     * @param {String} track The attribute track (Inst, Type, Local).
     * @param {Object} descriptor An optional 'property descriptor'.
     * @param {Object} owner The owner object. Defaults to target.
     * @returns {Object} The newly defined attribute value.
     */

    var own,
        trk,
        desc,
        finalDesc,
        attribute,

        val;

    desc = descriptor;

    //  Typically try to define only once. We test code change flag to avoid
    //  warning during source operations during development.
    if (target && TP.owns(target, name)) {

        //  If the target has a property descriptor with an E5 getter and that
        //  getter has a 'finalVal' slot, then it's a TIBET traits getter. If
        //  the 'finalVal' is undefined, that means that it's ok to set it.
        if ((finalDesc = Object.getOwnPropertyDescriptor(target, name)) &&
                finalDesc.get && finalDesc.get.finalVal === undefined) {
            //  empty
        } else {
            // TP.sys.shouldLogCodeChanges() && TP.ifWarn() ?
             //   TP.warn('Ignoring duplicate attribute definition: ' + name) : 0;
            return target[name];
        }
    }

    own = owner === undefined ? target : owner;
    trk = track === undefined ? TP.LOCAL_TRACK : track;
    if (desc === undefined) {
        desc = {};
    }
    val = value;
    if (val === undefined || val === null) {
        val = desc.value;
    }

    //  If the track is TP.INST_TRACK or TP.META_INST_TRACK and an initial value
    //  was supplied and that value was a Collection, then we should warn. In
    //  this case, the value will be *shared* amongst instances which is very
    //  likely what the author did *not* want.
    if (trk === TP.INST_TRACK || trk === TP.META_INST_TRACK) {
        if (TP.isCollection(val)) {
            TP.ifWarn() ?
                TP.warn(TP.sc('Setting initial value on an instance-level',
                                ' attribute: ',
                                TP.name(owner), '.', trk, '.', name,
                                ' to a collection value: ', TP.tname(val))) : 0;
        }
    }

    attribute = TP.defineSlot(target, name, val, TP.ATTRIBUTE, trk, desc);

    desc[TP.NAME] = name;
    desc.value = val;

    //  Don't track metadata for local properties.
    if (trk !== TP.LOCAL_TRACK) {
        TP.sys.addMetadata(own, desc, TP.ATTRIBUTE, trk);
    }

    return attribute;
}, null, 'TP.defineAttributeSlot');

//  -----------------------------------------------------------------------

TP.definePrimitive('defineConstantSlot',
function(target, name, value, track, descriptor, owner) {

    /**
     * @method defineConstantSlot
     * @summary Defines a constant , tracking all necessary metadata.
     * @param {Object} target The target object.
     * @param {String} name The constant name.
     * @param {Object} value The constant value or a property descriptor object.
     * @param {String} track The constant track (Inst, Type, Local). Default is
     *     TP.TYPE_TRACK.
     * @param {Object} descriptor An optional 'property descriptor'.
     * @param {Object} owner The owner object. Defaults to target.
     * @returns {Object} The newly defined constant value.
     */

    var own,
        trk,
        desc,
        constant,

        val;

    desc = descriptor;

    //  Typically try to define only once. We test code change flag to avoid
    //  warning during source operations during development.
    if (target && TP.owns(target, name)) {
        // TP.sys.shouldLogCodeChanges() && TP.ifWarn() ?
         //   TP.warn('Ignoring duplicate constant definition: ' + name) : 0;

        return target[name];
    }

    own = owner === undefined ? target : owner;
    trk = track === undefined ? TP.LOCAL_TRACK : track;
    if (TP.notValid(desc)) {
        desc = {};
    }
    val = value;
    if (val === undefined || val === null) {
        val = desc.value;
    }

    constant = TP.defineSlot(target, name, val, TP.CONSTANT, trk, desc);

    desc[TP.NAME] = name;
    desc.value = val;

    //  Don't track metadata for local properties.
    if (trk !== TP.LOCAL_TRACK) {
        //  NB: We register constants as 'TP.ATTRIBUTE's
        TP.sys.addMetadata(own, desc, TP.ATTRIBUTE, trk);
    }

    return constant;

}, null, 'TP.defineConstantSlot');

//  ------------------------------------------------------------------------

TP.definePrimitive('runConditionalFunction',
function(functionBodyOrTests) {

    /**
     * @method runConditionalFunction
     * @summary Runs the function supplied, usually supplied as part of a set
     *     of tests.
     * @description Note that this method can take a variety of arguments in
     *     the 'functionBodyOrTests' parameter. If no sophisticated 'feature
     *     testing' is required, it just executes the Function in that
     *     parameter. Otherwise, it can take a hash of tests and the matching
     *     Functions that should be executed if the tests pass. See usages
     *     throughout the various primitives files in the system.
     * @param {Function|Object} functionBodyOrTests The actual method
     *     implementation or an object containing tests.
     * @returns {Function} The result of running the Function.
     */

    var test,
        key,

        theFunc;

    if (TP.$$DEBUG && !functionBodyOrTests) {
        TP.ifError() ?
            TP.error('Invalid function body or object for ' +
                'TP.runConditionalFunction: ' + functionBodyOrTests) : 0;

        return;
    }

    //  if we weren't handed a Function body, then we need to check what we
    //  were handed.
    if (!TP.isCallable(functionBodyOrTests)) {
        test = functionBodyOrTests.at('test');

        //  The test was a Function... execute it. It should return true or
        //  false. We convert that value to a String.
        if (TP.isCallable(test)) {
            key = '' + test();
        } else {
            //  When provided a string if it's a test name we run that test
            //  and get back either true or false, which presumably is the
            //  proper key for one of our function options below.
            if (typeof test === 'string' && TP.sys.hasFeatureTest(test)) {
                key = TP.sys.hasFeature(test);
            } else {
                //  If the test isn't a string, or isn't a known test name
                //  we'll just convert to string directly the cheap way.
                key = ('' + test).toLowerCase();
            }
        }

        //  Look up the function in the dictionary provided.
        theFunc = functionBodyOrTests.at(key);
        if (typeof theFunc === 'undefined') {

            //  If there's a TP.DEFAULT use that when the key isn't
            //  found in the dictionary.
            theFunc = functionBodyOrTests.at(TP.DEFAULT);

            //  No default might must mean we're doing a test that doesn't
            //  pass for the current platform which has no correlary.
            if (!theFunc) {
                return;
            }
        }
    } else {
        //  If the parameter _is_ a function we got the function already.
        theFunc = functionBodyOrTests;
    }

    //  theFunc is still not callable? we have a problem...
    if (!TP.isCallable(theFunc)) {
        TP.ifError() ?
            TP.error('Invalid function body or object for ' +
                'TP.runConditionalFunction: ' + functionBodyOrTests) : 0;

        return;
    }

    return theFunc();
}, null, 'TP.runConditionalFunction');

//  ------------------------------------------------------------------------

TP.definePrimitive('defineMethodAlias',
function(target, methodName, methodBody) {

    /**
     * @method defineMethodAlias
     * @summary Defines an alias to a previously defined method.
     * @description This method will alias an existing method over to the slot
     *     on the target object *without resetting it's track and owner
     *     information*.
     * @param {Object} target The target object.
     * @param {String} methodName The name of the method.
     * @param {Function} methodBody The actual method implementation.
     * @returns {Function} The installed method.
     */

    //  Simple slot aliasing.
    target[methodName] = methodBody;

    return target[methodName];
}, null, 'TP.defineMethodAlias');

//  ------------------------------------------------------------------------
//  REFLECTION - PART I
//  ------------------------------------------------------------------------

/*
Minimal reflection API necessary to support the type checking methods which
are defined in this module. Later sections of the kernel add significant
reflection capability to the system.
*/

TP.defineMetaInstMethod('getConstructor',
function() {

    /**
     * @method getConstructor
     * @summary Returns the receiver's constructor function. For simple objects
     *     this is a simple wrapper around returning the constructor property.
     * @returns {Object} The receiver's constructor function.
     */

    return this.constructor;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getPrototype',
function() {

    /**
     * @method getPrototype
     * @summary Returns the receiver's prototype instance. The prototype
     *     instance is the object from which behavior is inherited.
     * @returns {Object} The receiver's prototype instance.
     */

    return Object.getPrototypeOf(this);
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getInstPrototype',
function() {

    /**
     * @method getInstPrototype
     * @summary Returns the receiver's instance prototype -- the object
     *     responsible for inherited behavior for instances of the receivers'
     *     type. Type objects respond differently, returning the prototype for
     *     their instances rather than the prototype they inherit from.
     * @returns {Object} The receiver's instance prototype instance.
     */

    if (TP.isFunction(this)) {
        return this.prototype;
    }

    return this.getPrototype();
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getType',
function() {

    /**
     * @method getType
     * @summary Returns the type of the receiver. For top-level objects which
     *     descend from native constructors like Object, Array, etc. this is
     *     equal to asking for the constructor. For constructors themselves this
     *     is Function. For Objects you'll get the instance of TP.FunctionProto
     *     acting as the type.
     * @returns {Object} The receiver's type.
     */

    if (TP.isFunction(this)) {
        return Function;
    }

    return this.constructor;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getTypeName',
function() {

    /**
     * @method getTypeName
     * @summary Returns the type name of the receiver. This method is a synonym
     *     for getName() for type instances. For instances it returns the name
     *     of their type object.
     * @returns {String} The type name of the receiver.
     */

    var str,
        name,
        type;

    if (TP.isWindow(this)) {
        return 'Window';
    }

    if (TP.owns(this, TP.TNAME)) {
        return this[TP.TNAME];
    }

    if (TP.isType(type = this.getType())) {
        if (TP.canInvoke(type, 'getName')) {
            return type.getName();
        }

        //  watch out for IE bugs
        if (TP.canInvoke(type, 'toString')) {
            str = type.toString();

            return str.strip(/[\[\]]/g);
        }
    }

    if (TP.isFunction(this)) {
        return 'Function';
    }

    if ((str = TP.ObjectProto.toString.call(this)) &&
            TP.regex.NATIVE_TYPENAME_MATCH.test(str)) {

        /* eslint-disable no-extra-parens */
        if ((name = str.match(TP.regex.NATIVE_TYPENAME_EXTRACT))) {
            return name[1];
        }
        /* eslint-enable no-extra-parens */
    }

    return TP.isWindow(this) ? 'Window' : 'Object';
});

//  ------------------------------------------------------------------------
//  OBJECT NAMING - PART II
//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('$getName',
function() {

    /**
     * @method $getName
     * @summary Default implementation of the $getName operation. Returns the
     *     receiver's ID as the 'Name'.
     * @returns {String}
     */

    if (TP.owns(this, TP.NAME)) {
        return this[TP.NAME];
    }

    return this.getID();
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getName',
function() {

    /**
     * @method getName
     * @summary Default implementation of the getName operation. Returns the
     *     receiver's ID as the 'Name'.
     * @returns {String}
     */

    if (TP.owns(this, TP.NAME)) {
        return this[TP.NAME];
    }

    return this.getID();
});

//  ------------------------------------------------------------------------
//  OBJECT IDENTITY - PART II
//  ------------------------------------------------------------------------

TP.definePrimitive('$getOIDPrefix',
function(anObject) {

    /**
     * @method $getOIDPrefix
     * @summary Returns an 'OID prefix' for the supplied object. This is used as
     *     the prefix when the system is generating an OID.
     * @param {Object} anObject The object to retrieve an OID prefix for.
     * @returns {String} The OID prefix for the supplied object.
     */

    var type,
        prefix;

    //  prefix OIDs with type names so we get a sense of what an object is along
    //  with its random ID
    type = TP.isType(anObject) ?
                anObject :
                TP.type(anObject);

    if (TP.isNativeType(type)) {
        if (TP.isNonFunctionConstructor(type)) {
            prefix = TP.getNonFunctionConstructorName(type);
        } else if (TP.isFunction(type)) {
            //  For Functions that live in a TIBET JS context, they can respond
            //  to 'getName' (which, if they're anonymous, will give them a
            //  unique ID).
            if (TP.canInvoke(type, 'getName')) {
                prefix = type.getName();
            } else if (TP.isFunction(type)) {
                //  Otherwise, we can just try to get the name of the Function
                //  or the value of TP.ANONYMOUS_FUNCTION_NAME
                prefix = TP.getFunctionName(type);
            }
        }
    } else {
        prefix = type[TP.TNAME];
    }

    return prefix;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('$getOID',
function(aPrefix) {

    /**
     * @method $getOID
     * @summary Returns the unique object ID for the receiver. This can be
     *     thought of as the objects' primary key (sans versioning data) from a
     *     TIBET perspective. Normally you would not call this method directly,
     *     you'd call getID() instead.
     * @param {String} aPrefix An optional prefix which will be prepended to any
     *     generated value.
     * @returns {String} Currently all OID's are String values.
     */

    var prefix;

    if (TP.isValid(this.$$oid)) {
        return this.$$oid;
    }

    //  watch out for special objects (basically TP.ObjectProto and
    //  TP.FunctionProto) here...
    if (this === TP.ObjectProto) {
        return 'ObjectProto';
    } else if (this === TP.FunctionProto) {
        return 'FunctionProto';
    }

    //  for non-mutable instances (String, Number, Boolean) we just return
    //  the value since we can't really store an OID on them and their
    //  value doesn't change.
    if (!TP.isMutable(this)) {
        //  watch out for Mozilla, after 2.x strings don't behave properly
        //  when returning 'this' from a method, the behave like Arrays
        if (TP.isString(this)) {
            return '' + this;
        }

        return this;
    }

    if (!aPrefix) {
        prefix = TP.$getOIDPrefix(this);
    } else {
        prefix = aPrefix;
    }

    //  if it doesn't exist we can create it and bail out
    if (this.$$oid === undefined && !TP.isNode(this)) {
        //  some native objects will complain bitterly about this
        try {
            this.$$oid = TP.constructOID(prefix);
        } catch (e) {
            TP.ifError() ? TP.error(TP.ec(e, 'Could not obtain OID')) : 0;
        }
    } else if (this.$$oid === this.getPrototype().$$oid && !TP.isNode(this)) {
        //  watch out for TP.FunctionProto :). Endless recursion is possible if
        //  this test isn't performed.
        if (this !== this.getPrototype()) {
            this.$$oid = TP.constructOID(prefix);
        }
    }

    return this.$$oid;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getID',
function(aPrefix) {

    /**
     * @method getID
     * @summary Returns the public ID of the receiver. If the receiving object
     *     doesn't have an ID set, the objects' OID is returned instead. See
     *     $getOID for more info. Note that non-mutable JavaScript objects (i.e.
     *     String, Number and Boolean) will return themselves as their ID.
     * @description Using a two-layer ID scheme allows the system to maintain an
     *     internal identifier in the form of OID values and at the same time
     *     allow developers to register certain objects under explicitly defined
     *     identifiers. This is an important feature for developing cross-frame
     *     where incoming pages need a public, well-known identifier, to acquire
     *     a reference to objects in other frames. It's also a key element of
     *     how to get different frames to coordinate on signal origins.
     * @param {String} aPrefix An optional prefix which will be prepended to any
     *     generated value.
     * @example Get a unique ID for a JavaScript object:
     *     <code>
     *          'hi'.getID();
     *          <samp>hi</samp>
     *          (42).getID();
     *          <samp>42</samp>
     *          true.getID();
     *          <samp>true</samp>
     *          TP.ac().getID();
     *          <samp>Array_11194fef891948efcb003e0d8</samp>
     *          TP.hc().getID();
     *          <samp>TP.core.Hash_11194ff08b02373b76de8c7c</samp>
     *          TP.dc().getID();
     *          <samp>Date_111997a9773f185a33f9280f</samp>
     *          (function() {TP.info('foo');}).getID();
     *          <samp>Function_111997cb98f69d60b2cc7daa</samp>
     *          TP.lang.Object.construct().getID();
     *          <samp>TP.lang.Object_111997a3ada0b5cb1f4dc5398</samp>
     *     </code>
     * @returns {String} Currently all OID's are String values.
     */

    if (this === TP.ObjectProto) {
        return 'ObjectProto';
    }

    //  default to OID if not set
    if (this[TP.ID] === undefined) {
        return this.$getOID(aPrefix);
    } else if (this[TP.ID] === this.getPrototype()[TP.ID]) {
        //  watch out for TP.FunctionProto itself. When we're at the top of the
        //  tree we have to watch out for recursion bugs.
        if (this !== this.getPrototype()) {
            return this.$getOID(aPrefix);
        }
    }

    return this[TP.ID];
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('hasGeneratedID',
function() {

    /**
     * @method hasGeneratedID
     * @summary Whether or not the receiver has a 'generated ID' - that is, one
     *     that was generated by the system, not by user code.
     * @returns {Boolean} Whether or not the receiver has a generated ID.
     */

    var privateIDMatcher;

    //  Build a RegExp that will match the OID prefix for this object,
    //  followed by a literal '$' and then 1-n word characters. Matching
    //  this will indicate that the object has a privately generated ID.
    privateIDMatcher = new RegExp(TP.$getOIDPrefix(this) + '\\$\\w+');

    return privateIDMatcher.test(this.getID());
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('setID',
function(anID) {

    /**
     * @method setID
     * @summary Sets the public ID of the receiver.
     * @description Public IDs are useful as handles for acquiring objects from
     *     the TIBET instance hashes. See the comment for getID(). Note that the
     *     object is un-registered under its old ID by this operation.
     * @param {String} anID The value to use as a public ID.
     * @returns {String} The ID that was set.
     */

    var id,
        wasRegistered;

    //  If the receiver was registered under an 'id', unregister it and
    //  re-register with the new ID below.
    if (TP.isValid(id = this[TP.ID]) && id !== anID) {
        if (TP.isValid(TP.sys.hasRegistered)) {
            wasRegistered = TP.sys.hasRegistered(this, id);
            TP.sys.unregisterObject(this, id);
        }
    }

    //  default invalid entries to the OID
    id = TP.notValid(anID) ? this.$getOID() : anID;

    this[TP.ID] = id;

    if (wasRegistered) {
        TP.sys.registerObject(this, id);
    }

    return this[TP.ID];
});

//  ------------------------------------------------------------------------
//  MOP (Meta-Object Protocol) aka "Universally Common Methods"
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  TP Methods
//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP, 'defineAttribute',
function(attributeName, attributeValue, attributeDescriptor) {

    /**
     * @method defineAttribute
     * @summary Adds/defines a new local attribute for the receiver. The
     *     attribute gets a default value if provided. In the current release
     *     the other three parameters are ignored.
     * @param {String} attributeName The attribute name.
     * @param {Object} attributeValue The attribute value.
     * @param {Object} [attributeDescriptor] Optional property descriptor.
     * @returns {Object} The newly defined attribute value.
     */

    return TP.defineAttributeSlot(
            TP, attributeName, attributeValue, TP.LOCAL_TRACK,
            attributeDescriptor);
});

//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP, 'defineConstant',
function(constantName, constantValue, constantDescriptor) {

    /**
     * @method defineConstant
     * @summary Adds the constant with name and value provided as a 'local'
     *     constant.
     * @param {String} constantName The constant name.
     * @param {Object} constantValue The constant value.
     * @param {Object} [constantDescriptor] Optional property descriptor.
     * @returns {Object} The newly defined constant value.
     */

    return TP.defineConstantSlot(
            TP, constantName, constantValue, TP.LOCAL_TRACK,
            constantDescriptor);
});

//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP, 'defineMethod',
function(methodName, methodBody, methodDescriptor, display, $isHandler) {

    /**
     * @method defineMethod
     * @summary Adds the method with name and body provided as a local method.
     *     Local methods are directly methods on the receiving instance. These
     *     methods differ from 'instance' methods in that the behavior is NOT
     *     inherited unless the owner object happens to serve as a prototype.
     * @param {String} methodName The name of the new method.
     * @param {Function} methodBody The actual method implementation.
     * @param {Object} methodDescriptor An optional 'property descriptor'. If a
     *     'value' slot is supplied here, it is ignored in favor of the
     *     methodBody parameter to this method.
     * @param {String} display Optional string defining the public display name
     *     for the function.
     * @param {Boolean} [$isHandler=false] True will cause the definition to pass
     *     without errors for deprecated use of defineMethod for handlers.
     * @returns {Function} The newly defined method.
     */

    return TP.defineMethodSlot(
            TP, methodName, methodBody, TP.LOCAL_TRACK, methodDescriptor,
            display, TP, $isHandler);
});

//  ------------------------------------------------------------------------

TP.defineMethod('describe',
function(suiteName, suiteFunc) {

    /**
     * @method describe
     * @summary Adds a new test suite definition to an object. When the suite
     *     name matches a method name that suite is automatically associated
     *     with the specific method.
     * @param {String} suiteName The name of the new test suite. Should be
     *     unique to the particular receiver. If this matches a method name the
     *     suite is associated with that method.
     * @param {Function} suiteFunc The function representing the test suite.
     *     Should contain at least one call to 'this.it', the test case
     *     definition method on TP.test.Suite.
     */

    return TP.test.Suite.addSuite(this, suiteName, suiteFunc);
});

//  ------------------------------------------------------------------------

TP.defineMethod('getTestFixture',
function() {

    /**
     * Creates and returns test fixture data suitable for the receiver. This
     * method is used to produce "the object under test" for test cases that
     * target the receiver. The default is the receiver itself.
     * @param {TP.core.Hash} options A dictionary of test options.
     * @returns {Object} A test fixture for the receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.defineMethod('getTestSuites',
function(options) {

    /**
     * Returns the list of test suites for the receiver matching options.
     * @param {TP.core.Hash} options A dictionary of test options.
     * @returns {TP.test.Suite[]} A list of test suite instances matching the
     *     options.
     */

    var params;

    params = TP.hc(options);
    params.atPut('target', this);

    return TP.test.getSuites(params);
});

//  ------------------------------------------------------------------------

TP.defineMethod('runTestSuites',
function(options) {

    /**
     * Runs the test suites associated with the receiver. Options which help
     * configure and control the testing process can be provided.
     * @param {TP.core.Hash} options A dictionary of test options.
     * @returns {Promise} A Promise to be used as necessary.
     */

    var params;

    params = TP.hc(options);
    params.atPut('target', this);

    return TP.test.runSuites(params);
});

//  ------------------------------------------------------------------------
//  TP.sys Methods
//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP.sys, 'defineAttribute',
function(attributeName, attributeValue, attributeDescriptor) {

    /**
     * @method defineAttribute
     * @summary Adds/defines a new local attribute for the receiver. The
     *     attribute gets a default value if provided. In the current release
     *     the other three parameters are ignored.
     * @param {String} attributeName The attribute name.
     * @param {Object} attributeValue The attribute value.
     * @param {Object} [attributeDescriptor] Optional property descriptor.
     * @returns {Object} The newly defined attribute value.
     */

    return TP.defineAttributeSlot(
            TP.sys, attributeName, attributeValue, TP.LOCAL_TRACK,
            attributeDescriptor);
});

//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP.sys, 'defineConstant',
function(constantName, constantValue, constantDescriptor) {

    /**
     * @method defineConstant
     * @summary Adds the constant with name and value provided as a 'local'
     *     constant.
     * @param {String} constantName The constant name.
     * @param {Object} constantValue The constant value.
     * @param {Object} [constantDescriptor] Optional property descriptor.
     * @returns {Object} The newly defined constant value.
     */

    return TP.defineConstantSlot(
            TP.sys, constantName, constantValue, TP.LOCAL_TRACK,
            constantDescriptor);
});

//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP.sys, 'defineMethod',
function(methodName, methodBody, methodDescriptor, display, $isHandler) {

    /**
     * @method defineMethod
     * @summary Adds the method with name and body provided as a local method.
     *     Local methods are directly methods on the receiving instance. These
     *     methods differ from 'instance' methods in that the behavior is NOT
     *     inherited unless the owner object happens to serve as a prototype.
     * @param {String} methodName The name of the new method.
     * @param {Function} methodBody The actual method implementation.
     * @param {Object} methodDescriptor An optional 'property descriptor'. If a
     *     'value' slot is supplied here, it is ignored in favor of the
     *     methodBody parameter to this method.
     * @param {String} display Optional string defining the public display name
     *     for the function.
     * @param {Boolean} [$isHandler=false] True will cause the definition to pass
     *     without errors for deprecated use of defineMethod for handlers.
     * @returns {Function} The newly defined method.
     */

    return TP.defineMethodSlot(
            TP.sys, methodName, methodBody, TP.LOCAL_TRACK,
            methodDescriptor, display, TP.sys, $isHandler);
});

//  ------------------------------------------------------------------------
//  TP.boot Methods
//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP.boot, 'defineAttribute',
function(attributeName, attributeValue, attributeDescriptor) {

    /**
     * @method defineAttribute
     * @summary Adds/defines a new local attribute for the receiver. The
     *     attribute gets a default value if provided. In the current release
     *     the other three parameters are ignored.
     * @param {String} attributeName The attribute name.
     * @param {Object} attributeValue The attribute value.
     * @param {Object} [attributeDescriptor] Optional property descriptor.
     * @returns {Object} The newly defined attribute value.
     */

    return TP.defineAttributeSlot(
            TP.boot, attributeName, attributeValue, TP.LOCAL_TRACK,
            attributeDescriptor);
});

//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP.boot, 'defineConstant',
function(constantName, constantValue, constantDescriptor) {

    /**
     * @method defineConstant
     * @summary Adds the constant with name and value provided as a 'local'
     *     constant.
     * @param {String} constantName The constant name.
     * @param {Object} constantValue The constant value.
     * @param {Object} [constantDescriptor] Optional property descriptor.
     * @returns {Object} The newly defined constant value.
     */

    return TP.defineConstantSlot(
            TP.boot, constantName, constantValue, TP.LOCAL_TRACK,
            constantDescriptor);
});

//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP.boot, 'defineMethod',
function(methodName, methodBody, methodDescriptor, display, $isHandler) {

    /**
     * @method defineMethod
     * @summary Adds the method with name and body provided as a local method.
     *     Local methods are directly methods on the receiving instance. These
     *     methods differ from 'instance' methods in that the behavior is NOT
     *     inherited unless the owner object happens to serve as a prototype.
     * @param {String} methodName The name of the new method.
     * @param {Function} methodBody The actual method implementation.
     * @param {Object} methodDescriptor An optional 'property descriptor'. If a
     *     'value' slot is supplied here, it is ignored in favor of the
     *     methodBody parameter to this method.
     * @param {String} display Optional string defining the public display name
     *     for the function.
     * @param {Boolean} [$isHandler=false] True will cause the definition to pass
     *     without errors for deprecated use of defineMethod for handlers.
     * @returns {Function} The newly defined method.
     */

    return TP.defineMethodSlot(
            TP.boot, methodName, methodBody, TP.LOCAL_TRACK,
            methodDescriptor, display, TP.boot, $isHandler);
});

//  ------------------------------------------------------------------------
//  APP Methods
//  ------------------------------------------------------------------------

TP.defineMethodSlot(APP, 'defineAttribute',
function(attributeName, attributeValue, attributeDescriptor) {

    /**
     * @method defineAttribute
     * @summary Adds/defines a new local attribute for the receiver. The
     *     attribute gets a default value if provided. In the current release
     *     the other three parameters are ignored.
     * @param {String} attributeName The attribute name.
     * @param {Object} attributeValue The attribute value.
     * @param {Object} [attributeDescriptor] Optional property descriptor.
     * @returns {Object} The newly defined attribute value.
     */

    return TP.defineAttributeSlot(
            APP, attributeName, attributeValue, TP.LOCAL_TRACK,
            attributeDescriptor);
});

//  ------------------------------------------------------------------------

TP.defineMethodSlot(APP, 'defineConstant',
function(constantName, constantValue, constantDescriptor) {

    /**
     * @method defineConstant
     * @summary Adds the constant with name and value provided as a 'local'
     *     constant.
     * @param {String} constantName The constant name.
     * @param {Object} constantValue The constant value.
     * @param {Object} [constantDescriptor] Optional property descriptor.
     * @returns {Object} The newly defined constant value.
     */

    return TP.defineConstantSlot(
            APP, constantName, constantValue, TP.LOCAL_TRACK,
            constantDescriptor);
});

//  ------------------------------------------------------------------------

TP.defineMethodSlot(APP, 'defineMethod',
function(methodName, methodBody, methodDescriptor, display, $isHandler) {

    /**
     * @method defineMethod
     * @summary Adds the method with name and body provided as a local method.
     *     Local methods are directly methods on the receiving instance. These
     *     methods differ from 'instance' methods in that the behavior is NOT
     *     inherited unless the owner object happens to serve as a prototype.
     * @param {String} methodName The name of the new method.
     * @param {Function} methodBody The actual method implementation.
     * @param {Object} methodDescriptor An optional 'property descriptor'. If a
     *     'value' slot is supplied here, it is ignored in favor of the
     *     methodBody parameter to this method.
     * @param {String} display Optional string defining the public display name
     *     for the function.
     * @param {Boolean} [$isHandler=false] True will cause the definition to pass
     *     without errors for deprecated use of defineMethod for handlers.
     * @returns {Function} The newly defined method.
     */

    return TP.defineMethodSlot(
            APP, methodName, methodBody, TP.LOCAL_TRACK,
            methodDescriptor, display, APP, $isHandler);
});

//  ------------------------------------------------------------------------
//  TP.FunctionProto - TYPE DEFINITION
//  ------------------------------------------------------------------------

/*
The methods in this section provide support for the built-in types so that they
can respond in most cases to the same API as the TP.lang.RootObject subtypes.
It's not a good thing to try and subtype directly off the built-in types since
that's not really ECMAScript compliant.
*/

//  ------------------------------------------------------------------------

TP.defineMetaTypeMethod('ownsMethod',
function(aName) {

    /**
     * @method ownsMethod
     * @summary Returns true if the name represents a unique method on the
     *     receiver, one that is either introduced or overridden so that the
     *     method is "owned" by the receiver.
     * @param {String} aName The method name to check.
     * @returns {Boolean}
     */

    if (TP.sys.hasInitialized() && TP.isMethod(this[aName])) {
        return this[aName][TP.OWNER] === this;
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('defineAttribute',
function(attributeName, attributeValue, attributeDescriptor) {

    /**
     * @method defineAttribute
     * @summary Adds the attribute with name and value provided as a 'local'
     *     attribute. This is the root method that all objects that are
     *     instrumented with meta instance methods will get.
     * @param {String} attributeName The attribute name.
     * @param {Object} attributeValue The attribute value.
     * @param {Object} [attributeDescriptor] Optional property descriptor.
     * @returns {Object} The newly defined attribute value.
     */

    return TP.defineAttributeSlot(
            this, attributeName, attributeValue, TP.LOCAL_TRACK,
            attributeDescriptor, this);
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('defineConstant',
function(constantName, constantValue, constantDescriptor) {

    /**
     * @method defineConstant
     * @summary Adds the constant with name and value provided as a 'local'
     *     constant. This is the root method that all objects that are
     *     instrumented with meta instance methods will get.
     * @param {String} constantName The constant name.
     * @param {Object} constantValue The constant value.
     * @param {Object} [constantDescriptor] Optional property descriptor.
     * @returns {Object} The newly defined constant value.
     */

    return TP.defineConstantSlot(
            this, constantName, constantValue, TP.LOCAL_TRACK,
            constantDescriptor, this);
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('defineMethod',
function(methodName, methodBody, methodDescriptor, display, $isHandler) {

    /**
     * @method defineMethod
     * @summary Adds the function with name and body provided as a 'local'
     *     method. This is the root method that all objects that are
     *     instrumented with meta instance methods will get.
     * @param {String} methodName The name of the new method.
     * @param {Function} methodBody The actual method implementation.
     * @param {Object} methodDescriptor An optional 'property descriptor'. If a
     *     'value' slot is supplied here, it is ignored in favor of the
     *     methodBody parameter to this method.
     * @param {String} display Optional string defining the public display name
     *     for the function.
     * @param {Boolean} [$isHandler=false] True will cause the definition to pass
     *     without errors for deprecated use of defineMethod for handlers.
     * @returns {Function} The newly defined method.
     */

    return TP.defineMethodSlot(
        this, methodName, methodBody, TP.LOCAL_TRACK,
        methodDescriptor, display, this, $isHandler);
});

//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP.FunctionProto, 'defineAttribute',
function(attributeName, attributeValue, attributeDescriptor) {

    /**
     * @method defineAttribute
     * @summary Adds the attribute with name and value provided as an instance,
     *     'type local' or 'local' attribute. This is 'overridden' from the
     *     meta-method version because TP.FunctionProto plays so many different
     *     roles.
     * @param {String} attributeName The attribute name.
     * @param {Object} attributeValue The attribute value.
     * @param {Object} [attributeDescriptor] Optional property descriptor.
     * @returns {Object} The newly defined attribute value.
     */

    var target,
        owner,
        track;

    /* eslint-disable consistent-this */

    //  If we're being asked to add an attribute to TP.FunctionProto *directly*
    //  then we consider it an instance attribute of all Function objects.
    if (this === TP.FunctionProto) {
        target = TP.FunctionProto;
        owner = Function;
        track = TP.INST_TRACK;
    } else if (TP.isType(this)) {
        //  Otherwise, if it is one of the 'Big 8' constructor Functions, then
        //  it's a 'type local' attribute.
        target = this;
        owner = this;
        track = TP.TYPE_LOCAL_TRACK;
    } else {
        //  Otherwise, it can be considered to be a 'local' attribute of the
        //  receiving Function object (which is usually a plain, anonymous
        //  Function).
        target = this;
        owner = this;
        track = TP.LOCAL_TRACK;
    }

    /* eslint-enable consistent-this */

    return TP.defineAttributeSlot(
            target, attributeName, attributeValue, track,
            attributeDescriptor, owner);
}, TP.TYPE_TRACK, null, 'TP.FunctionProto.Type.defineAttribute');

//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP.FunctionProto, 'defineConstant',
function(constantName, constantValue, constantDescriptor) {

    /**
     * @method defineConstant
     * @summary Adds the constant with name and value provided as an instance,
     *     'type local' or 'local' constant. This is 'overridden' from the
     *     meta-method version because TP.FunctionProto plays so many different
     *     roles.
     * @param {String} constantName The constant name.
     * @param {Object} constantValue The constant value.
     * @param {Object} [constantDescriptor] Optional property descriptor.
     * @returns {Object} The newly defined constant value.
     */

    var target,
        owner,
        track;

    /* eslint-disable consistent-this */

    //  If we're being asked to add a constant to TP.FunctionProto *directly*
    //  then we consider it an instance constant of all Function objects.
    if (this === TP.FunctionProto) {
        target = TP.FunctionProto;
        owner = Function;
        track = TP.INST_TRACK;
    } else if (TP.isType(this)) {
        //  Otherwise, if it is one of the 'Big 8' constructor Functions, then
        //  it's a 'type local' constant.
        target = this;
        owner = this;
        track = TP.TYPE_LOCAL_TRACK;
    } else {
        //  Otherwise, it can be considered to be a 'local' constant of the
        //  receiving Function object (which is usually a plain, anonymous
        //  Function).
        target = this;
        owner = this;
        track = TP.LOCAL_TRACK;
    }

    /* eslint-enable consistent-this */

    return TP.defineConstantSlot(
            target, constantName, constantValue, track,
            constantDescriptor, owner);
}, TP.TYPE_TRACK, null, 'TP.FunctionProto.Type.defineConstant');

//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP.FunctionProto, 'defineMethod',
function(methodName, methodBody, methodDescriptor, display, $isHandler) {

    /**
     * @method defineMethod
     * @summary Adds the function with name and body provided as an instance,
     *     'type local' or 'local' method. This is 'overridden' from the
     *     meta-method version because TP.FunctionProto plays so many different
     *     roles.
     * @param {String} methodName The name of the new method.
     * @param {Function} methodBody The actual method implementation.
     * @param {Object} methodDescriptor An optional 'property descriptor'. If a
     *     'value' slot is supplied here, it is ignored in favor of the
     *     methodBody parameter to this method.
     * @param {String} display Optional string defining the public display name
     *     for the function.
     * @param {Boolean} [$isHandler=false] True will cause the definition to
     *     pass without errors for deprecated use of defineMethod for handlers.
     * @returns {Function} The newly defined method.
     */

    var target,
        owner,
        track;

    /* eslint-disable consistent-this */

    //  If we're being asked to add a method to TP.FunctionProto *directly* then
    //  we consider it an instance method of all Function objects.
    if (this === TP.FunctionProto) {
        target = TP.FunctionProto;
        owner = Function;
        track = TP.INST_TRACK;
    } else if (TP.isType(this)) {
        //  Otherwise, if it is one of the 'Big 8' constructor Functions, then
        //  it's a 'type local' method.
        target = this;
        owner = this;
        track = TP.TYPE_LOCAL_TRACK;
    } else {
        //  Otherwise, it can be considered to be a 'local' method of the
        //  receiving Function object (which is usually a plain, anonymous
        //  Function).
        target = this;
        owner = this;
        track = TP.LOCAL_TRACK;
    }

    /* eslint-enable consistent-this */

    return TP.defineMethodSlot(
            target, methodName, methodBody, track, methodDescriptor,
            display, owner, $isHandler);

}, TP.TYPE_TRACK, null, 'TP.FunctionProto.Type.defineMethod');

//  ------------------------------------------------------------------------
//  TP.lang.RootObject - TYPE DEFINITION
//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP.lang.RootObject.Type, 'defineAttribute',
function(attributeName, attributeValue, attributeDescriptor) {

    /**
     * @method defineAttribute
     * @summary Adds the attribute with name and value provided as a type or
     *     'type local' attribute.
     * @param {String} attributeName The attribute name.
     * @param {Object} attributeValue The attribute value.
     * @param {Object} [attributeDescriptor] Optional property descriptor.
     * @returns {Object} The newly defined attribute value.
     */

    var track,
        owner;

    /* eslint-disable consistent-this */

    if (TP.isPrototype(this)) {
        track = TP.TYPE_TRACK;
        owner = this[TP.OWNER];
    } else {
        track = TP.TYPE_LOCAL_TRACK;
        owner = this;
    }

    /* eslint-enable consistent-this */

    return TP.defineAttributeSlot(
                this, attributeName, attributeValue, track,
                attributeDescriptor, owner);
}, TP.TYPE_TRACK, null, 'TP.lang.RootObject.Type.defineAttribute');

//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP.lang.RootObject.Type, 'defineConstant',
function(constantName, constantValue, constantDescriptor) {

    /**
     * @method defineConstant
     * @summary Adds the constant with name and value provided as a type or
     *     'type local' constant.
     * @param {String} constantName The constant name.
     * @param {Object} constantValue The constant value.
     * @param {Object} [constantDescriptor] Optional property descriptor.
     * @returns {Object} The newly defined constant value.
     */

    var track,
        owner;

    /* eslint-disable consistent-this */

    if (TP.isPrototype(this)) {
        track = TP.TYPE_TRACK;
        owner = this[TP.OWNER];
    } else {
        track = TP.TYPE_LOCAL_TRACK;
        owner = this;
    }

    /* eslint-enable consistent-this */

    return TP.defineConstantSlot(
                this, constantName, constantValue, track,
                constantDescriptor, owner);
}, TP.TYPE_TRACK, null, 'TP.lang.RootObject.Type.defineConstant');

//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP.lang.RootObject.Type, 'defineMethod',
function(methodName, methodBody, methodDescriptor, display, $isHandler) {

    /**
     * @method defineMethod
     * @summary Adds the function with name and body provided as a type or
     *     'type local' method.
     * @param {String} methodName The name of the new method.
     * @param {Function} methodBody The actual method implementation.
     * @param {Object} methodDescriptor An optional 'property descriptor'. If a
     *     'value' slot is supplied here, it is ignored in favor of the
     *     methodBody parameter to this method.
     * @param {String} display Optional string defining the public display name
     *     for the function.
     * @param {Boolean} [$isHandler=false] True will cause the definition to pass
     *     without errors for deprecated use of defineMethod for handlers.
     * @returns {Function} The newly defined method.
     */

    var track,
        owner;

    /* eslint-disable consistent-this */

    if (TP.isPrototype(this)) {
        track = TP.TYPE_TRACK;
        owner = this[TP.OWNER];

        //  If the traits code has loaded and the owner has traits, then we grab
        //  the reference to the traited method before we lose it.
        if (owner.hasTraits && owner.hasTraits()) {

            //  If we own a traited-in method, we don't want to lose the
            //  reference to it when we install the supplied methodBody - in
            //  fact, it will be considered our 'next most specific' method.
            //  Capture it here for use by callNextMethod().
            if (TP.owns(this, methodName)) {
                methodBody.$$nextfunc = this[methodName];
            }
        }
    } else {
        track = TP.TYPE_LOCAL_TRACK;
        owner = this;
    }

    /* eslint-enable consistent-this */

    return TP.defineMethodSlot(
        this, methodName, methodBody, track, methodDescriptor, display,
        owner, $isHandler);

}, TP.TYPE_TRACK, null, 'TP.lang.RootObject.Type.defineMethod');

//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP.lang.RootObject.Inst, 'defineAttribute',
function(attributeName, attributeValue, attributeDescriptor) {

    /**
     * @method defineAttribute
     * @summary Adds the attribute with name and value provided as an instance
     *     or 'local' attribute.
     * @param {String} attributeName The attribute name.
     * @param {Object} attributeValue The attribute value.
     * @param {Object} [attributeDescriptor] Optional property descriptor.
     * @returns {Object} The newly defined attribute value.
     */

    var track,
        owner;

    /* eslint-disable consistent-this */

    if (TP.isPrototype(this)) {
        track = TP.INST_TRACK;
        owner = this[TP.OWNER];
    } else {
        track = TP.LOCAL_TRACK;
        owner = this;
    }

    /* eslint-enable consistent-this */

    return TP.defineAttributeSlot(
                this, attributeName, attributeValue, track,
                attributeDescriptor, owner);
}, TP.TYPE_TRACK, null, 'TP.lang.RootObject.Inst.defineAttribute');

//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP.lang.RootObject.Inst, 'defineConstant',
function(constantName, constantValue, constantDescriptor) {

    /**
     * @method defineConstant
     * @summary Adds the constant with name and value provided as an instance
     *     or 'local' constant.
     * @param {String} constantName The constant name.
     * @param {Object} constantValue The constant value.
     * @param {Object} [constantDescriptor] Optional property descriptor.
     * @returns {Object} The newly defined constant value.
     */

    var track,
        owner;

    /* eslint-disable consistent-this */

    if (TP.isPrototype(this)) {
        track = TP.INST_TRACK;
        owner = this[TP.OWNER];
    } else {
        track = TP.LOCAL_TRACK;
        owner = this;
    }

    /* eslint-enable consistent-this */

    return TP.defineConstantSlot(
                this, constantName, constantValue, track,
                constantDescriptor, owner);
}, TP.TYPE_TRACK, null, 'TP.lang.RootObject.Inst.defineConstant');

//  ------------------------------------------------------------------------

TP.defineMethodSlot(TP.lang.RootObject.Inst, 'defineMethod',
function(methodName, methodBody, methodDescriptor, display, $isHandler) {

    /**
     * @method defineMethod
     * @summary Adds the function with name and body provided as an instance or
     *     'local' method.
     * @param {String} methodName The name of the new method.
     * @param {Function} methodBody The actual method implementation.
     * @param {Object} methodDescriptor An optional 'property descriptor'. If a
     *     'value' slot is supplied here, it is ignored in favor of the
     *     methodBody parameter to this method.
     * @param {String} display Optional string defining the public display name
     *     for the function.
     * @param {Boolean} [$isHandler=false] True will cause the definition to
     *     pass without errors for deprecated use of defineMethod for handlers.
     * @returns {Function} The newly defined method.
     */

    var track,
        owner;

    /* eslint-disable consistent-this */

    if (TP.isPrototype(this)) {
        track = TP.INST_TRACK;
        owner = this[TP.OWNER];

        //  If the traits code has loaded and the owner has traits, then we grab
        //  the reference to the traited method before we lose it.
        if (owner.hasTraits && owner.hasTraits()) {

            //  If we own a traited-in method, we don't want to lose the
            //  reference to it when we install the supplied methodBody - in
            //  fact, it will be considered our 'next most specific' method.
            //  Capture it here for use by callNextMethod().
            if (TP.owns(this, methodName)) {
                methodBody.$$nextfunc = this[methodName];
            }
        }
    } else {
        track = TP.LOCAL_TRACK;
        owner = this;
    }

    /* eslint-enable consistent-this */

    return TP.defineMethodSlot(
        this, methodName, methodBody, track, methodDescriptor, display,
        owner, $isHandler);

}, TP.TYPE_TRACK, null, 'TP.lang.RootObject.Inst.defineMethod');

//  ------------------------------------------------------------------------
//  Window TYPE DEFINITION
//  ------------------------------------------------------------------------

//  We need to define this here, since it's needed by 'Type.defineMethod' below.
//  But then we register it right away as soon as we can.
Window.getName = function() {

    /**
     * @method getName
     * @summary Returns the name of the Window constructor which is,
     *     appropriately, 'Window'.
     * @returns {String}
     */

    return 'Window';
};

//  ------------------------------------------------------------------------

Window.Type.defineMethod = function(methodName, methodBody, methodDescriptor) {

    /**
     * @method defineMethod
     * @summary Adds the function with name and body provided as a type method.
     *     This is the root method since all other methods can be declared using
     *     this one.
     * @param {String} methodName The name of the new method.
     * @param {Function} methodBody The actual method implementation.
     * @param {Object} methodDescriptor An optional 'property descriptor'. If a
     *     'value' slot is supplied here, it is ignored in favor of the
     *     methodBody parameter to this method.
     * @returns {Function} The installed method.
     */

    var display;

    display = 'Window.Type.' + methodName;

    return TP.defineMethodSlot(
            Window, methodName, methodBody, TP.TYPE_TRACK,
            methodDescriptor, display);
};

//  ------------------------------------------------------------------------

Window.Type.defineMethod('getName', Window.getName);

//  ------------------------------------------------------------------------
//  WINDOW NAME / ID
//  ------------------------------------------------------------------------

//  Some platforms (old versions of Webkit) don't treat 'Window' as a real
//  object... sigh.
if (!TP.isFunction(Window.getID)) {
    Window.getID = TP.FunctionProto.getID;
    Window.$getOID = TP.FunctionProto.$getOID;
    Window.getPrototype = TP.FunctionProto.getPrototype;
}

Window.Inst.defineMethod('$getName',
function() {

    /**
     * @method $getName
     * @summary Allows the top level to act as a function 'owner'. Function
     *     owners are often asked for their name as part of building change log
     *     entries. In standard JS there is no way to ask a function which
     *     object it belongs to for purposes of reflection or logging. TIBET
     *     uses TP.OWNER to acquire a handle to that object and then asks it for
     *     a name via this call.
     * @returns {String}
     */

    return 'Self';
});

//  ------------------------------------------------------------------------

Window.Inst.defineMethod('getName',
function() {

    /**
     * @method getName
     * @summary Allows the top level to act as a function 'owner'. Function
     *     owners are often asked for their name as part of building change log
     *     entries. In standard JS there is no way to ask a function which
     *     object it belongs to for purposes of reflection or logging. TIBET
     *     uses TP.OWNER to acquire a handle to that object and then asks it for
     *     a name via this call.
     * @returns {String}
     */

    return 'Self';
});

//  ------------------------------------------------------------------------

Window.Inst.defineMethod('$getOID',
function(aPrefix) {

    /**
     * @method $getOID
     * @summary Returns the unique object ID for the receiver. This can be
     *     thought of as the objects' primary key (sans versioning data) from a
     *     TIBET perspective.
     * @param {String} aPrefix An optional prefix which will be prepended to any
     *     generated value.
     * @returns {String} Currently all OID's are String values.
     */

    var oid;

    //  NOTE the logic here is intended to return a newly generated OID if
    //  the receiver turns out to be non-mutable
    if (TP.notValid(oid = this.$$oid) && !TP.isNode(this)) {
        oid = TP.constructOID(TP.ifInvalid(aPrefix, 'window'));
        this.$$oid = oid;
    }

    return oid;
});

//  ------------------------------------------------------------------------

Window.Inst.defineMethod('getID',
function(aPrefix) {

    /**
     * @method getID
     * @summary Returns the public ID of the receiver. If the receiving object
     *     doesn't have an ID set the objects' OID is returned instead. See
     *     $getOID for more info. For UI elements in the DOM this method will
     *     return the attribute id='val' value.
     * @description Using a two-layer ID scheme allows the system to maintain an
     *     internal identifier in the form of OID values and at the same time
     *     allow developers to register certain objects under explicitly defined
     *     identifiers. This is an important feature for developing cross-frame
     *     where incoming pages need a public, well-known identifier, to acquire
     *     a reference to objects in other frames. It's also a key element of
     *     how to get different frames to coordinate on signal origins.
     * @param {String} aPrefix An optional prefix which will be prepended to any
     *     generated value.
     * @returns {String} Currently all OID's are String values.
     */

    if (TP.notValid(this[TP.ID])) {
        return this.$getOID(aPrefix);
    }

    return this[TP.ID];
});

//  ------------------------------------------------------------------------

Window.Inst.defineMethod('setID',
function(anID) {

    /**
     * @method setID
     * @summary Sets the public ID of the receiver. Public IDs are useful as
     *     handles for acquiring objects from the TIBET instance hashes. See the
     *     comment for getID(). Note that the object is un-registered under its
     *     old ID by this operation.
     * @param {String} anID The value to use as a public ID.
     * @returns {String} The ID that was set.
     */

    var id,
        wasRegistered;

    //  If the receiver was registered under an 'id', unregister it and
    //  re-register with the new ID below.
    if (TP.isValid(id = this[TP.ID])) {
        if (TP.isValid(TP.sys.hasRegistered)) {
            wasRegistered = TP.sys.hasRegistered(this, id);
            TP.sys.unregisterObject(this, id);
        }
    }

    //  default invalid entries to the OID
    id = TP.notValid(anID) ? this.$getOID() : anID;

    this[TP.ID] = id;

    if (wasRegistered) {
        TP.sys.registerObject(this, id);
    }

    return this[TP.ID];
});

//  ------------------------------------------------------------------------
//  REFLECTION - PART II (PrePatch)
//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getLocalName',
function() {

    /**
     * @method getLocalName
     * @summary Returns the local (aka short) name of the receiver without any
     *     namespace prefix. At this level, this returns the receiver's type
     *     name.
     * @returns {String} The receiver's local name.
     */

    return this.getTypeName();
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getNamespacePrefix',
function() {

    /**
     * @method getNamespacePrefix
     * @summary Returns the namespace (in TIBET terms) of the receiver. For
     *     example, the namespace of the TP.sig.Signal type is 'sig'. At this
     *     level, this returns the empty String.
     * @returns {String} The receiver's namespace.
     */

    return '';
});

//  ------------------------------------------------------------------------
//  TP.* context support variables
//  ------------------------------------------------------------------------

//  context support variables
TP.defineAttribute('$focus_stack', []);      //  stack of focused elements
TP.defineAttribute('$signal_stack', []);     //  stack of signal instances

//  ------------------------------------------------------------------------
//  CONVERSION
//  ------------------------------------------------------------------------

TP.definePrimitive('getParsedPrimitiveValue',
function(aVal) {

    /**
     * @method getParsedPrimitiveValue
     * @summary Returns a value by attempting to parse the supplied value (which
     *     should be a String) into one of the 'primitive JavaScript' types
     *     (Number, Boolean, RegExp, etc.)
     * @param {String} aVal The value to parse into a JS primitive.
     * @returns {Object} The value parsed into the primitive or null, if it
     *     can't be parsed.
     */

    if (!TP.isString(aVal)) {
        return aVal;
    }

    if (TP.regex.ANY_NUMBER.test(aVal)) {
        return Number(aVal);
    }

    if (TP.regex.BOOLEAN_ID.test(aVal)) {
        return aVal === 'true';
    }

    if (TP.regex.REGEX_LITERAL_STRING.test(aVal)) {
        return TP.rc(aVal.slice(1, -1));
    }

    return;
});

//  ------------------------------------------------------------------------
//  SOURCE LANGUAGE
//  ------------------------------------------------------------------------

/*
When doing localization you need to know two languages, the one you've got,
and the one you want to translate to. The one you've got is what TIBET
refers to as the "source language". This is normally U.S. English since
that's the language typically used when authoring source code. But if you
want to author your applications in German or French for example, you can
alter the source language so that TIBET will start there when doing its
translations.
*/

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getSourceLanguage',
function() {

    /**
     * @method getSourceLanguage
     * @summary Returns the current source 'lang', the language most source
     *     strings will be in.
     * @description This value is typically en-us, but can be changed to adapt
     *     to local coding preferences. The source language is used as the key
     *     during localization lookups.
     * @example Get TIBET's current 'source language':
     *     <code>
     *          TP.sys.getSourceLanguage();
     *          <samp>en-us</samp>
     *     </code>
     * @returns {String} The current value for source language. The default is
     *     'en-us'.
     */

    return TP.sys.cfg('tibet.sourcelang',
                        TP.sys.env('tibet.xmllang', 'en-us'));
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getTargetLanguage',
function() {

    /**
     * @method getTargetLanguage
     * @summary Returns the target 'lang', the user's targeted language
     *     setting.
     * @description This method leverages TP.i18n.Locale data whenever possible,
     *     otherwise the boot property for userlang is used. When translations
     *     are performed this is the language being targeted using the current
     *     source language as the key.
     * @example Get TIBET's current 'target language':
     *     <code>
     *          TP.sys.getTargetLanguage();
     *          <samp>en-us</samp>
     *     </code>
     * @returns {String} The current target language key. The default is
     *     'en-us'.
     */

    //  leverage the TP.i18n.Locale type if we've loaded it at this point
    if (TP.isType(TP.sys.getTypeByName('TP.i18n.Locale'))) {
        return TP.ifInvalid(TP.sys.getLocale().getISOKey(), 'en-us');
    }

    return TP.sys.cfg('tibet.sourcelang',
                        TP.sys.env('tibet.xmllang', 'en-us'));
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('setSourceLanguage',
function(aLangCode) {

    /**
     * @method getSourceLanguage
     * @summary Returns the current source 'lang', the language most source
     *     strings will be in.
     * @description This is typically en-us, but can be changed to adapt to
     *     local coding preferences. The source language is used as the key
     *     during localization lookups.
     * @example Set TIBET's current 'source language':
     *     <code>
     *          TP.sys.setSourceLanguage('en-gb');
     *          <samp>en-gb</samp>
     *     </code>
     * @returns {String} The current value for source language. The default is
     *     'en-us'.
     */

    return TP.sys.setcfg(
        'tibet.sourcelang',
        TP.ifInvalid(aLangCode, TP.sys.env('tibet.xmllang', 'en-us')));
});

//  ------------------------------------------------------------------------
//  STRING PROCESSING
//  ------------------------------------------------------------------------

TP.definePrimitive('sc',
function(varargs) {

    /**
     * @method sc
     * @summary String.construct shortcut, later replaced by a full-featured
     *     version that ensures the incoming string gets a chance at being
     *     localized. All arguments used in constructing Strings using TP.sc()
     *     are subject to localization based on the current source and target
     *     locale information. See TP.i18n.Locale for more information. The
     *     simple version uses TP.msg[key] to look up any mapped values.
     * @param {arguments} varargs A variable list of 0 to N values to build
     *     the String from. Multiple chunks are joined with a single space.
     * @returns {String} A new instance.
     */

    var arr,
        str,
        result,
        len,
        i,
        key;

    switch (arguments.length) {
        case 0:
            return '';
        case 1:
            str = '' + varargs;
            if (TP.owns(TP.msg, str)) {
                return TP.msg[str];
            }
            return str;
        default:
            result = TP.ac();
            arr = TP.ac(arguments);
            len = arr.length;
            for (i = 0; i < len; i++) {
                key = arr[i];
                if (TP.owns(TP.msg, key)) {
                    result.push(TP.msg[key]);
                } else {
                    result.push(key);
                }
            }
            return result.join('');
    }
});

//  ------------------------------------------------------------------------
//  STDIO
//  ------------------------------------------------------------------------

TP.definePrimitive('alert',
function(aMessage) {

    /**
     * @method alert
     * @summary Displays a message to the user. Advanced versions of this
     *     function make use of DHTML controls and a "curtain" to display the
     *     message in a modal fashion.
     *     The initial version is a simple wrapper around the native JS alert()
     *     function.
     * @param {String} aMessage The message for the user.
     * @example Notify the user of some event:
     *     <code>
     *          TP.alert('TIBET Rocks!');
     *     </code>
     * @returns {Promise} A Promise to be used as necessary. Since this is an
     *     alert(), this Promise's resolver Function will be called with no
     *     return value.
     */

    var promise;

    promise = TP.extern.Promise.construct(
        function(resolver, rejector) {

            /* eslint-disable no-alert */
            window.alert(TP.sc(aMessage));
            /* eslint-enable no-alert */

            resolver();
        });

    return promise;
}, {
    dependencies: [TP.extern.Promise]
});

//  Alias TP.$alert to TP.alert. That way if TP.alert gets redefined, the
//  primitive version is still available under TP.$alert.
TP.defineMethodAlias(TP, '$alert', TP.alert);

//  ------------------------------------------------------------------------

TP.definePrimitive('confirm',
function(anAction) {

    /**
     * @method confirm
     * @summary Displays a prompt to the user asking for confirmation of an
     *     action. Advanced versions of this function make use of DHTML controls
     *     and a "curtain" to display the prompt in a modal fashion.
     *     The initial version is a simple wrapper around the native JS
     *     confirm() function.
     * @param {String} anAction The action for the user to confirm.
     * @example Obtain an answer from the user:
     *     <code>
     *          TP.confirm('Perform Action?');
     *     </code>
     * @returns {Promise} A Promise to be used as necessary. Since this is a
     *     confirm(), this Promise's resolver Function will be called with true
     *     if the user confirmed the requested action and false if they did not.
     */

    var promise;

    promise = TP.extern.Promise.construct(
        function(resolver, rejector) {

            var retVal;

            /* eslint-disable no-alert */
            retVal = window.confirm(TP.sc(anAction));
            /* eslint-enable no-alert */

            resolver(retVal);
        });

    return promise;
}, {
    dependencies: [TP.extern.Promise]
});

//  Alias TP.$confirm to TP.confirm. That way if TP.confirm gets redefined, the
//  primitive version is still available under TP.$confirm.
TP.defineMethodAlias(TP, '$confirm', TP.confirm);

//  ------------------------------------------------------------------------

TP.definePrimitive('prompt',
function(aQuestion, aDefaultAnswer) {

    /**
     * @method prompt
     * @summary Displays a prompt to the user asking for data. Advanced
     *     versions of this function make use of DHTML controls and a "curtain"
     *     to display the prompt in a modal fashion.
     *     The initial version is a simple wrapper around the native JS prompt()
     *     function.
     * @param {String} aQuestion The question for the user.
     * @param {String} aDefaultAnswer The default answer, provided in the input
     *     field.
     * @example Obtain an answer from the user:
     *     <code>
     *          TP.prompt('Favorite color', 'Black');
     *     </code>
     * @returns {Promise} A Promise to be used as necessary. Since this is a
     *     prompt(), this Promise's resolver Function will be called with the
     *     value returned by the user.
     */

    var promise;

    promise = TP.extern.Promise.construct(
        function(resolver, rejector) {

            var retVal;

            /* eslint-disable no-alert */
            retVal = window.prompt(
                        TP.sc(aQuestion),
                        TP.sc(aDefaultAnswer) || '');
            /* eslint-enable no-alert */

            resolver(retVal);
        });

    return promise;
}, {
    dependencies: [TP.extern.Promise]
});

//  Alias TP.$prompt to TP.prompt. That way if TP.prompt gets redefined, the
//  primitive version is still available under TP.$prompt.
TP.defineMethodAlias(TP, '$prompt', TP.prompt);

//  ------------------------------------------------------------------------
//  DEBUGGING/LOGGING
//  ------------------------------------------------------------------------

TP.definePrimitive('stop',
function(aFlagOrParam) {

    /**
     * @method stop
     * @summary A stand-in for the debugger keyword that won't cause Safari to
     *     complain about syntax errors. Also a convenient way to provide if
     *     (some condition) debugger; logic. By providing either a Boolean or a
     *     configuration parameter to this function you can simplify coding.
     * @param {Boolean|String} aFlagOrParam False to not trigger the debugger.
     *     When a string is provided it should be the name of a configuration
     *     parameter. Default is true.
     * @example Set a permanent "breakpoint" via a debugger statement.
     *     <code>
     *          TP.stop();
     *     </code>
     */

    if (!TP.sys.cfg('debug.use_debugger')) {
        return;
    }

    if (aFlagOrParam !== undefined) {
        if (TP.isString(aFlagOrParam)) {
            if (TP.sys.cfg(aFlagOrParam) !== true) {
                return;
            }
        } else if (aFlagOrParam !== true) {
            //  null values (not undefined) are passed when consumer used
            //  $cfg themselves...so catch that here. if the call didn't
            //  include a nested cfg call the param would have been undef
            return;
        }
    }

    try {
        /* eslint-disable no-debugger */
        debugger;
        /* eslint-enable no-debugger */
    } catch (e) {
        //  empty
    }

    return;
});

//  ------------------------------------------------------------------------
//  ARRAY PRIMITIVES
//  ------------------------------------------------------------------------

/*
Baseline array functions that get replaced later in the kernel. They're
provided here to support the DOM primitives during early kernel operation.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('ac',
function() {

    /**
     * @method ac
     * @summary The standard array construction method in TIBET. Constructs and
     *     returns a new array instance from the argument list. NOTE that unlike
     *     'new Array' this call does not use the first argument as a count when
     *     only one argument is provided. All arguments are treated as array
     *     elements.
     * @description One of TIBET's standard "shorthand constructors" which
     *     follow the pattern $[firstInitialOfType]c(), for example TP.ac() for
     *     Array.construct, TP.dc() for Date.construct, TP.rc() for
     *     RegExp.construct. While some of these don't appear to offer much
     *     value over their native counterparts the ability to control object
     *     creation turns out to be a very powerful feature that is leveraged by
     *     both development tools and other library elements. For example,
     *     versions of TP.ac() defined later in the loading process support
     *     passing arguments and nodelist objects to convert them into native
     *     arrays for easier processing.
     * @example Construct a simple array:
     *     <code>
     *          arr = TP.ac();
     *     </code>
     * @example Construct an array from an arguments object:
     *     <code>
     *          arr = TP.args(arguments);
     *     </code>
     * @example Construct an array with a single string element:
     *     <code>
     *          arr = TP.ac('prefix string');
     *     </code>
     * @returns {Array} A new array.
     */

    var arr;

    //  NOTE that we don't use literal creation syntax since that can have
    //  differing behavior on IE based on current window export state.
    /* eslint-disable no-array-constructor */
    arr = new Array();
    /* eslint-enable no-array-constructor */
    if (arguments.length === 0) {
        return arr;
    } else {
        return arr.slice.call(arguments, 0);
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('args',
function(anArgArray, aStart, anEnd) {

    /**
     * @method args
     * @summary Constructs and returns an Array containing the values from
     *     anArgArray from aStart to anEnd. By default the entire arguments
     *     object is copied into the array.
     * @param {arguments} anArgArray A native arguments object.
     * @param {Number} aStart A starting offset for the copy. Default is 0.
     * @param {Number} anEnd An ending index for the copy. Default is
     *     anArgArray.length.
     * @example Construct a new array containing all elements of an argument
     *     array:
     *     <code>
     *          arr = TP.args(arguments);
     *     </code>
     * @example Construct a new array from arguments 2 through N:
     *     <code>
     *          arr = TP.args(arguments, 1);
     *     </code>
     * @returns {Object[]} A new array.
     */

    var len,
        start,
        end;

    len = arguments.length;
    if (len === 0) {
        return this.raise('TP.sig.InvalidParameter',
            'No arguments object provided.');
    } else if (len === 1) {
        return TP.ArrayProto.slice.call(anArgArray, 0);
    } else if (len === 2) {
        start = TP.notValid(aStart) ? 0 : aStart;
        return TP.ArrayProto.slice.call(anArgArray, start);
    } else {
        start = TP.notValid(aStart) ? 0 : aStart;
        end = TP.notValid(anEnd) ? anArgArray.length :
            Math.max(anArgArray.length, anEnd);
        return TP.ArrayProto.slice.call(anArgArray, start, end);
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('join',
function() {

    /**
     * @method join
     * @summary Constructs and returns a new string instance by joining the
     *     arguments via an Array.
     * @example Construct a new joined string of markup without using +=:
     *     <code>
     *          str = TP.join('Hello ', username, ' from TIBET!');
     *     </code>
     * @returns {String} A new string.
     */

    //  NB: In modern browsers, going back to the old '+=' method of String
    //  concatenation seems to yield about a 40% performance gain.

    var str,
        len,
        i;

    str = '';

    len = arguments.length;
    for (i = 0; i < len; i++) {
        str += arguments[i];
    }

    return str;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('add',
function() {

    /**
     * @method add
     * @summary Appends one or more objects to the receiver. This primitive
     *     version does not provide change notification so it's equivalent to
     *     the native Array push call, but instead of returning a count like
     *     push(), it returns the receiver for easier method chaining.
     * @example Add one or more elements to an array:
     *     <code>
     *          arr = TP.ac();
     *          arr.add(varA, varB, varC);
     *     </code>
     * @returns {Array} The receiver.
     * @addon Array
     */

    var i,
        len,
        size;

    size = this.length;
    len = arguments.length;
    for (i = 0; i < len; i++) {
        this[size + i] = arguments[i];
    }

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('getSize',
function() {

    /**
     * @method getSize
     * @summary Returns the size of the receiver. For simple arrays this is the
     *     length.
     * @returns {Number} The size.
     */

    return this.length;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('item',
function(anIndex) {

    /**
     * @method item
     * @summary Returns the value found at anIndex. NOTE that using item() is
     *     actually a deprecated practice in TIBET, you should use at() instead
     *     and convert nodelists to arrays using TP.ac().
     * @param {Number} anIndex The index to use for lookup.
     * @returns {Object} The value at anIndex.
     * @addon Array
     */

    return this.at(anIndex);
});

//  ------------------------------------------------------------------------
//  CONFORMANCE
//  ------------------------------------------------------------------------

/*
Although you'd like to believe that all things you'll be passed in JS will
inherit from TP.ObjectProto it just ain't so... Also, null, undefined, etc.
don't respond to method calls so you can't test them without working from the
outside. For that reason we don't rely on a method such as "respondsTo" or
"conformsTo" - we add a global "TP.canInvoke()" call that takes an object and
an "interface" in the form of a string or array of strings, each of which
represents a method to test. This approach allows you to check for
conformance/responsiveness regardless of what the inbound object might be.
*/

//  ------------------------------------------------------------------------
//  STDIO
//  ------------------------------------------------------------------------

/*
Define the initial default mappings for input, output, and error messaging.
*/

TP.definePrimitive('stdin', TP.boot.STDIN_PROMPT);
TP.definePrimitive('stdout', TP.boot.STDOUT_LOG);
TP.definePrimitive('stderr', TP.boot.STDERR_LOG);

//  ------------------------------------------------------------------------
//  METADATA
//  ------------------------------------------------------------------------

/*
All objects which might be leveraged as 'types' including the builtins
need to have basic metadata in TIBET. The values consist of slots for:

    TP.TYPE             Reference to the type of the receiver.

    TP.TYPEC            The type constructor, used for subtype creation.
    TP.INSTC            The inst constructor, used for instance creation.

    TP.TNAME            The type name in string form for easy access.
    TP.RNAME            The 'real' type name in JS-identifier form.

    TP.SUPER            The immediate supertype object.

    TP.ANCESTORS        Receiver's supertype list.
    TP.ANCESTOR_NAMES   Receiver's supertype names.
*/

//  --------------------------------------------------------------------

TP.boot.$$setupMetadata = function(aWindow) {

    var populateMetadata,
        win;

    win = aWindow || window;

    populateMetadata = function(target, type,
                                typeC, instC,
                                tName, rName, name,
                                superT, ancestors, ancestorNames) {
        target[TP.TYPE] = type;

        target[TP.TYPEC] = typeC;
        target[TP.INSTC] = instC;

        target[TP.TNAME] = tName;
        target[TP.RNAME] = rName;
        target[TP.NAME] = name;

        target[TP.SUPER] = superT;
        target[TP.ANCESTORS] = ancestors;
        target[TP.ANCESTOR_NAMES] = ancestorNames;
    };

    //  Here we instrument the "big 8" types native to JS so they are
    //  aware of the metadata we'll be asking for from anything we think
    //  of as a type. NOTE we use simple closure here to hide this work.

    //  ** NOTE NOTE NOTE **
    //  We use 'TP.ac()' here throughout this method because these
    //  Arrays need to be created *as TIBETan enhanced Arrays*. They
    //  will be used for reflection purposes, etc. *even if this Window
    //  is not the TIBET window*. This is why we check not only for
    //  'TP', but 'TP.ac' below.

    //  Array
    populateMetadata(
            win.Array, win.Array, win.Function, win.Function,
            'Array', 'Array', 'Array',
            win.Object, TP.ac(win.Object), TP.ac('Object'));

    //  Boolean
    populateMetadata(
            win.Boolean, win.Boolean, win.Function, win.Function,
            'Boolean', 'Boolean', 'Boolean',
            win.Object, TP.ac(win.Object), TP.ac('Object'));

    //  Date
    populateMetadata(
            win.Date, win.Date, win.Function, win.Function,
            'Date', 'Date', 'Date',
            win.Object, TP.ac(win.Object), TP.ac('Object'));

    //  Function
    populateMetadata(
            win.Function, win.Function, win.Function, win.Function,
            'Function', 'Function', 'Function',
            win.Object, TP.ac(win.Object), TP.ac('Object'));

    //  Number
    populateMetadata(
            win.Number, win.Number, win.Function, win.Function,
            'Number', 'Number', 'Number',
            win.Object, TP.ac(win.Object), TP.ac('Object'));

    //  Object
    populateMetadata(
            win.Object, win.Object, win.Function, win.Function,
            'Object', 'Object', 'Object',
            null, TP.ac(), TP.ac());

    //  RegExp
    populateMetadata(
            win.RegExp, win.RegExp, win.Function, win.Function,
            'RegExp', 'RegExp', 'RegExp',
            win.Object, TP.ac(win.Object), TP.ac('Object'));

    //  String
    populateMetadata(
            win.String, win.String, win.Function, win.Function,
            'String', 'String', 'String',
            win.Object, TP.ac(win.Object), TP.ac('Object'));

    //  The subtypes (and 'deep subtypes') of Object are the other "big 7"
    win.Object[TP.SUBTYPES] =
            TP.ac(win.Array, win.Boolean, win.Date, win.Function, win.Number,
                    win.RegExp, win.String);
    win.Object[TP.SUBTYPES_DEEP] =
            TP.ac(win.Array, win.Boolean, win.Date, win.Function, win.Number,
                    win.RegExp, win.String);
    win.Object[TP.SUBTYPE_NAMES] =
            TP.ac('Array', 'Boolean', 'Date', 'Function',
                    'Number', 'RegExp', 'String');
    win.Object[TP.SUBTYPE_NAMES_DEEP] =
            TP.ac('Array', 'Boolean', 'Date', 'Function',
                    'Number', 'RegExp', 'String');

    //  Now we instrument DOM-specific 'types'

    //  Window
    populateMetadata(
            win.Window, win.Window, win.Function, win.Function,
            'DOMWindow', 'DOMWindow', 'DOMWindow',
            win.Object, TP.ac(win.Object), TP.ac('Object'));
    win.Window.$$nonFunctionConstructorObjectName = 'DOMWindow';

    //  Need to tell our machinery that NaN's *constructor* name is
    //  'Number'
    Object.getPrototypeOf(win.NaN).$$nonFunctionConstructorConstructorName =
                                                                     'Number';

    //  Browser-specific DOM 'types'

    //  Webkit

    if (TP.boot.$$isWebkit()) {

        populateMetadata(
                win.XMLDocument, win.XMLDocument, win.Function, win.Function,
                'XMLDocument', 'XMLDocument', 'XMLDocument',
                win.Document,
                TP.ac(win.Document, win.Node, win.Object),
                TP.ac('Document', 'Node', 'Object'));

        populateMetadata(
                win.XMLHttpRequest, win.XMLHttpRequest,
                    win.Function, win.Function,
                'XMLHttpRequest', 'XMLHttpRequest', 'XMLHttpRequest',
                win.Object,
                TP.ac(win.Object),
                TP.ac('Object'));
    }

    //  Firefox

    if (TP.boot.$$isMoz()) {

        populateMetadata(
                win.CSS2Properties, win.CSS2Properties, win.Function,
                    win.Function,
                'CSSStyleDeclaration',
                'CSSStyleDeclaration',
                'CSSStyleDeclaration',
                win.Object,
                TP.ac(win.Object),
                TP.ac('Object'));
    }
};

//  We need to set up metadata for ourself - the other UI frames have all done
//  it (or will).
TP.boot.$$setupMetadata();

//  Note that we have to put this slot on TP.FunctionProto so that Host
//  types that are Functions in the system will find it and pass the check
//  that, since they at least have this slot, they should check against
//  their type name. See TP.isType() for more info.
TP.FunctionProto[TP.TNAME] = 'Function';

//  ------------------------------------------------------------------------
//  LOAD TRACKING
//  ------------------------------------------------------------------------

/*
As part of TIBET's boot/autoloading operations we keep track of the original
module, file, and node which were responsible for a particular object. This
helps with certain aspects of reflection, and provides the various tools
with ways to acquire or reload original source for an object very quickly.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('objectGetLoadCollectionPath',
function(anObject) {

    /**
     * @method objectGetLoadCollectionPath
     * @summary Returns the 'collection' path to the file responsible for the
     *     object (that is, the path minus the most specific part).
     * @param {Object} anObject The object to query.
     * @returns {String} The load collection path where the receiver can be
     *     found.
     */

    var path;

    if (TP.notValid(path = TP.objectGetLoadPath(anObject))) {
        return;
    }

    return path.slice(0, path.lastIndexOf('/'));
});

//  ------------------------------------------------------------------------

TP.definePrimitive('objectGetLoadConfig',
function(anObject) {

    /**
     * @method objectGetLoadConfig
     * @summary Returns the module target from which the object's node was
     *     loaded.
     * @param {Object} anObject The object to query.
     * @returns {String} The module target for the object's node.
     */

    if (TP.notValid(anObject)) {
        return;
    }

    return anObject[TP.LOAD_CONFIG];
});

//  ------------------------------------------------------------------------

TP.definePrimitive('objectGetLoadPackage',
function(anObject) {

    /**
     * @method objectGetLoadPackage
     * @summary Returns the package name from which the script defining the
     *     object's node was loaded.
     * @param {Object} anObject The object to query.
     * @returns {String} The module name for the object's node.
     */

    if (TP.notValid(anObject)) {
        return;
    }

    return anObject[TP.LOAD_PACKAGE];
});

//  ------------------------------------------------------------------------

TP.definePrimitive('objectGetLoadPath',
function(anObject) {

    /**
     * @method objectGetLoadPath
     * @summary Returns the path to the file responsible for the object.
     * @param {Object} anObject The object to query.
     * @returns {String} The load path where the receiver can be found.
     */

    if (TP.notValid(anObject)) {
        return;
    }

    return anObject[TP.LOAD_PATH];
});

//  ------------------------------------------------------------------------

TP.definePrimitive('objectGetLoadStage',
function(anObject) {

    /**
     * @method objectGetLoadStage
     * @summary Returns the stage (e.g. 'phase one' or 'phase two' that the
     *     object loaded in.
     * @param {Object} anObject The object to query.
     * @returns {String} The load stage that the receiver loaded in.
     */

    if (TP.notValid(anObject)) {
        return;
    }

    return anObject[TP.LOAD_STAGE];
});

//  ------------------------------------------------------------------------

TP.definePrimitive('objectGetMetadata',
function(anObject) {

    /**
     * @method objectGetMetadata
     * @summary Returns any metadata the system may have for the object. At the
     *     present time this only works for types and methods.
     * @param {Object} anObject The object to query.
     * @returns {Object} The metadata structure, if any.
     */

    var name;

    if (TP.isMethod(anObject)) {
        name = TP.objectGetMetadataName(anObject, TP.METHOD);
        return TP.sys.getMetadata('methods').at(name);
    } else if (TP.isType(anObject)) {
        name = TP.objectGetMetadataName(anObject, TP.TYPE);
        return TP.sys.getMetadata('types').at(name);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('objectGetSourceCollectionPath',
function(anObject) {

    /**
     * @method objectGetSourceCollectionPath
     * @summary Returns the 'collection' path to the original source file,
     *     before any bundling or rollup processing, where the object resides
     *     (that is, the path minus the most specific part).
     * @param {Object} anObject The object to query.
     * @returns {String} The source collection path where the receiver can be
     *     found.
     */

    var path;

    if (TP.notValid(path = TP.objectGetSourcePath(anObject))) {
        return;
    }

    return path.slice(0, path.lastIndexOf('/'));
});

//  ------------------------------------------------------------------------

TP.definePrimitive('objectGetSourceConfig',
function(anObject) {

    /**
     * @method objectGetSourceConfig
     * @summary Returns the module target from which the object's node was
     *     sourced - that is, the config that it belonged to before any bundling
     *     or rollup processing.
     * @param {Object} anObject The object to query.
     * @returns {String} The module target for the object's node.
     */

    if (TP.notValid(anObject)) {
        return;
    }

    return anObject[TP.SOURCE_CONFIG];
});

//  ------------------------------------------------------------------------

TP.definePrimitive('objectGetSourcePackage',
function(anObject) {

    /**
     * @method objectGetSourcePackage
     * @summary Returns the package name from which the script defining the
     *     object's node was sourced - that is, the package that it belonged to
     *     before any bundling or rollup processing.
     * @param {Object} anObject The object to query.
     * @returns {String} The module name for the object's node.
     */

    if (TP.notValid(anObject)) {
        return;
    }

    return anObject[TP.SOURCE_PACKAGE];
});

//  ------------------------------------------------------------------------

TP.definePrimitive('objectGetSourcePath',
function(anObject) {

    /**
     * @method objectGetSourcePath
     * @summary Returns the path to the original source file, before any
     *     bundling or rollup processing, where the object resides.
     * @param {Object} anObject The object to query.
     * @returns {String} The source path where the receiver can be found.
     */

    var obj;

    if (TP.notValid(anObject)) {
        return;
    }

    obj = anObject;

    if (TP.isFunction(obj)) {
        obj = TP.getRealFunction(obj);
    }

    return obj[TP.SOURCE_PATH];
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriGetLoadPackage',
function(aPath) {

    /**
     * @method uriGetLoadPackage
     * @summary Returns the package path responsible for loading the file.
     * @param {String} aPath A filename, typically without any root information.
     * @returns {String} The package file path responsible for including the
     *     path in the load.
     */

    var node;

    if (TP.notValid(node = this.uriGetLoadNode(aPath))) {
        return;
    }

    return node.getAttribute(TP.LOAD_PACKAGE_ATTR);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriGetLoadNode',
function(aPath) {

    /**
     * @method uriGetLoadNode
     * @summary Returns the script node responsible for loading the file. The
     *     resulting script node can then be assigned as the "load node" for
     *     various system objects, allowing them to be related back to their
     *     original source file.
     * @param {String} aPath A filename, typically without any root information.
     * @returns {Node} The script node responsible for the supplied file.
     */

    var nodes,
        len,
        i,
        node,
        src;

    //  grab all of the script nodes, regardless of where they were
    //  positioned in the document (head or body)
    //  TODO: Generalize to allow 'document' to be supplied
    nodes = document.getElementsByTagName('script');

    //  NOTE    that we test for both src="" and source="" (a
    //  TIBET-specific slot the boot system uses to help us track this
    //  without altering the src attribute).
    len = nodes.length;
    for (i = 0; i < len; i++) {
        node = nodes[i];
        src = node.getAttribute('src') || node.getAttribute('source');
        if (TP.isString(src)) {
            if (src.indexOf(aPath) !== TP.NOT_FOUND) {
                return node;
            }
        }
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriGetLoadConfig',
function(aPath) {

    /**
     * @method uriGetLoadConfig
     * @summary Returns the package config responsible for loading the file.
     * @param {String} aPath A filename, typically without any root information.
     * @returns {String} The package config name responsible for including the
     *     path in the load.
     */

    var node;

    if (TP.notValid(node = this.uriGetLoadNode(aPath))) {
        return;
    }

    return node.getAttribute(TP.LOAD_CONFIG_ATTR);
});

//  ------------------------------------------------------------------------
//  UI CANVAS
//  ------------------------------------------------------------------------

/*
TIBET is designed to work with multiple windows and/or frames. That means
that at any particular time there's a "UI Canvas" that's the current focus
for display operations, but that this can shift as the application runs. The
initial window/frame for the application is known in TIBET as the "UI Root"
which serves as a common anchor point for resetting the UI Canvas.
*/

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getUICanvas',
function(unwrapped) {

    /**
     * @method getUICanvas
     * @summary Returns the currently active UI canvas object as a TIBET
     *     window/frame wrapper.
     * @param {Boolean} unwrapped True to return the native window or iframe.
     * @example Grab the current UI canvas (which is a TP.core.Window):
     *     <code>
     *          canvasWin = TP.sys.getUICanvas();
     *     </code>
     *
     *     Grab the native window from that:
     *     <code>
     *          nativeWin = canvasWin.getNativeWindow();
     *     </code>
     * @returns {TP.core.Window} The TP.core.Window wrapping the active UI
     *     canvas.
     */

    var name,
        obj;

    name = TP.sys.getUICanvasName();
    obj = TP.sys.getWindowById(name);

    if (TP.isWindow(obj)) {
        if (TP.isTrue(unwrapped)) {
            return obj;
        } else {
            return TP.core.Window.construct(obj);
        }
    }

    //  Proposed window name was not found. The thing is, TIBET always needs a
    //  canvas so we have to work our way up the proposed path until we find a
    //  window that is valid.
    while (name.indexOf('.') !== TP.NOT_FOUND) {
        name = name.slice(0, name.lastIndexOf('.'));
        obj = TP.sys.getWindowById(name);

        if (TP.isWindow(obj)) {
            if (TP.isTrue(unwrapped)) {
                return obj;
            } else {
                return TP.core.Window.construct(obj);
            }
        }
    }

    //  Absolute last chance...and if this doesn't work it's not really a proper
    //  TIBET application since the UIROOT frame has gone missing.
    obj = TP.sys.getWindowById('top.UIROOT');
    if (TP.isWindow(obj)) {
        if (TP.isTrue(unwrapped)) {
            return obj;
        } else {
            return TP.core.Window.construct(obj);
        }
    }

    this.raise('InvalidFraming', 'No UIROOT found.');
});

//  ------------------------------------------------------------------------

//  alias uiwin to getUICanvas
TP.sys.uiwin = TP.sys.getUICanvas;

//  ------------------------------------------------------------------------

TP.sys.defineMethod('uidoc',
function(unwrapped) {

    /**
     * @method uidoc
     * @summary Returns the current UI document in either wrapped or unwrapped
     *     form. The default is wrapped.
     * @param {Boolean} unwrapped True to unwrap the document.
     * @returns {TP.dom.Document|Document}
     */

    var obj;

    if (TP.isTrue(unwrapped)) {
        obj = TP.sys.getUICanvas(true);
        if (TP.isWindow(obj)) {
            return obj.document;
        }

        return;
    }

    return TP.sys.getUICanvas().getDocument();
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getUICanvasName',
function() {

    /**
     * @method getUICanvasName
     * @summary Returns the currently active UI canvas object's name.
     * @returns {String} The name of the active UI canvas.
     */

    var name;

    if (TP.isEmpty(TP.sys.$uiCanvas)) {
        name = TP.sys.cfg('tibet.uicanvas');
        if (TP.notValid(name)) {
            name = TP.sys.cfg('boot.canvas');
        }

        //  update the value to whatever we just defined as the value
        TP.sys.$uiCanvas = name;
    }

    return TP.sys.$uiCanvas;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getUICanvasPath',
function() {

    /**
     * @method getUICanvasPath
     * @summary Returns the currently active UI canvas object's "path", which
     *     for TIBET means returning the TIBET URI string which can be used to
     *     identify/acquire the UI canvas. This will be a string of the form
     *     'tibet://.../' where the remaining elements of the URI represent a
     *     path to the window object such at 'tibet://top/'.
     * @returns {String} The path containing the path to the active UI canvas.
     */

    return 'tibet://' + TP.gid(TP.sys.getUICanvas(true)) + '/';
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getUIRoot',
function(unwrapped) {

    /**
     * @method getUIRoot
     * @summary Returns the current root UI canvas as a TIBET window/frame
     *     wrapper.
     * @param {Boolean} unwrapped True to return the native window or iframe.
     * @returns {TP.core.Window} The TP.core.Window wrapping the root UI canvas.
     */

    if (TP.isTrue(unwrapped)) {
        return TP.sys.getWindowById(TP.sys.getUIRootName());
    }

    return TP.bySystemId(TP.sys.getUIRootName());
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getUIRootName',
function() {

    /**
     * @method getUIRootName
     * @summary Returns the root UI canvas object's name. Defaults on initial
     *     invocation to the UI canvas name.
     * @returns {String} The name of the top UI canvas.
     */

    var name;

    name = TP.sys.$uiRoot;

    if (TP.notValid(name)) {
        name = TP.sys.cfg('tibet.uiroot');
    }

    //  If there is no 'ui root' defined, we go after the current
    //  'ui canvas'.
    if (TP.notValid(name)) {
        name = TP.sys.getUICanvasName();
    }

    TP.sys.$uiRoot = name;

    return name;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('setUICanvas',
function(aCanvas) {

    /**
     * @method setUICanvas
     * @summary Defines the currently active UI canvas for later reference.
     *     Setting the UI canvas will cause certain display routines to start
     *     using the new canvas for their output.
     * @param {String|TP.core.Window} aCanvas The global ID of the
     *     TP.core.Window canvas or the TP.core.Window canvas itself to use as
     *     the currently active UI canvas.
     * @returns {TP.core.Window} The currently active UI canvas.
     */

    var name;

    if (TP.isString(aCanvas)) {
        name = aCanvas;
        TP.sys.$uiCanvas = name;
        TP.sys.setcfg('tibet.uicanvas', name);

        return TP.bySystemId(name);
    } else if (TP.canInvoke(aCanvas, 'getNativeWindow')) {
        name = TP.gid(aCanvas.getNativeWindow());
        TP.sys.$uiCanvas = name;
        TP.sys.setcfg('tibet.uicanvas', name);

        return aCanvas;
    } else {
        name = TP.gid(aCanvas);
        TP.sys.$uiCanvas = name;
        TP.sys.setcfg('tibet.uicanvas', name);

        return aCanvas;
    }
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('setUIRoot',
function(aCanvas) {

    /**
     * @method setUIRoot
     * @summary Defines the root UI canvas for later reference. This is
     *     normally set only once, during application startup, to define a
     *     consistent UI anchor point for the application.
     * @param {String|TP.core.Window} aCanvas The global ID of the
     *     TP.core.Window canvas or the TP.core.Window canvas itself to use as
     *     the root UI canvas.
     * @returns {TP.core.Window} The root UI canvas.
     */

    var name;

    if (TP.isString(aCanvas)) {
        name = aCanvas;
        TP.sys.$uiRoot = name;
        TP.sys.setcfg('tibet.uiroot', name);

        return TP.bySystemId(name);
    } else {
        name = TP.gid(aCanvas);
        TP.sys.$uiRoot = name;
        TP.sys.setcfg('tibet.uiroot', name);

        return aCanvas;
    }
});

//  ------------------------------------------------------------------------
//  DEBUGGING - PART I (PrePatch)
//  ------------------------------------------------------------------------

/**
 * @TIBET supports lightweight debugging through a variety of functions that
 *     leverage signaling and logging. This section includes stubs for
 *     operations which may be called prior to the full signaling system being
 *     installed.
 */

//  ------------------------------------------------------------------------

TP.definePrimitive('signal',
function(anOrigin, aSignal, aPayload) {

    /**
     * @method signal
     * @summary Pre-signaling TP.signal() stub. This version gets overlaid with
     *     a more powerful version later in the load process. This avoids load
     *     dependency problems and uses TP.stdout() or TP.boot.$stdout() rather
     *     than actually triggering a signal.
     * @param {Object} anOrigin The object serving as the signal's origin.
     * @param {TP.sig.Signal} aSignal The signal type to be fired.
     * @param {Object} aPayload An object containing optional arguments. Passed
     *     without alteration to handlers -- the "payload".
     */

    //  during early kernel load calls to this will simply get written to
    //  stdout

    var str;

    if (TP.sys.cfg('log.signals')) {
        str = TP.join('origin: ', anOrigin,
                        ' signaled: ', aSignal,
                        ' with: ', aPayload);

        if (TP.isCallable(TP.stdout)) {
            //  kernel version
            TP.stdout(str);
        } else if (TP.isCallable(TP.boot.$stdout)) {
            //  boot system version
            TP.boot.$stdout(str, TP.DEBUG);
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('raise',
function(anOrigin, anExceptionType, aPayload) {

    /**
     * @method raise
     * @summary Pre-signaling TP.raise() stub. This version gets overlaid with
     *     a more powerful version later in the load process.
     * @param {Object} anOrigin The object serving as the exception's origin.
     * @param {TP.sig.Exception} anExceptionType The type of exception to fire.
     * @param {Object} aPayload An object containing optional arguments. Passed
     *     without alteration to handlers.
     */

    //  note that we don't mention the firing policy in this version
    return TP.signal(anOrigin, anExceptionType, aPayload);
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('raise',
function(anExceptionType, aPayload) {

    /**
     * @method raise
     * @summary Default error handling call, i.e. this.raise('Something'); The
     *     receiver is used as the origin in a subsequent call to TP.raise()
     *     which provides the functional implementation.
     * @param {TP.sig.Exception} anExceptionType The type of exception to fire.
     * @param {Object} aPayload An object containing optional arguments. Passed
     *     without alteration to handlers.
     */

    return TP.raise(this, anExceptionType, aPayload);
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('raise',
function(anExceptionType, aPayload) {

    /**
     * @method raise
     * @summary Default error handling call, i.e. this.raise('Something'); The
     *     receiver is used as the origin in a subsequent call to TP.raise()
     *     which provides the functional implementation.
     * @param {TP.sig.Exception} anExceptionType The type of exception to fire.
     * @param {Object} aPayload An object containing optional arguments. Passed
     *     without alteration to handlers.
     */

    return TP.raise(this, anExceptionType, aPayload);
});

//  ------------------------------------------------------------------------
//  "VALID" vs. NULL vs. UNDEFINED
//  ------------------------------------------------------------------------

/*
It's not always sufficient just to ask if x == null since that doesn't
tell us whether it's null or undefined. In TIBET terms these are very
different since null means "that is a valid attribute, whose value has not
been set, or whose value has been set to null since it is n/a", while
undefined means "huh? never heard of it". While === knows the difference it
still misses the point for many tests, which can still be fooled by the
automatic conversion to boolean that JS will do in a boolean context.

This section provides wrapper functions for testing the true nature of a
variable or argument and taking action in certain cases. Many of these can
be implemented via the ternary operator or via JS's native "short circuit"
boolean operators (|| and &&) but the semantics of those approaches depend
on the loose definition of true/false based on automatic type conversions
and don't always operate as expected, particularly in the face of bad data.
In other words, they work fine if all you code for is the "happy path", but
they can fail miserably when testing with bad data so we usually avoid them.

In TIBET, the term 'valid' means "defined and not null" and is the standard
test usually implied by 'if (x) or if (!x)' as in, if (TP.isValid(x)) or if
(TP.notValid(x)).

In our opinion it is never good practice to use 'if (x)' in JS, just like
it's never good practice to do that in Perl or other languages where an
empty string or a numeric 0 might lead you astray. For that reason you'll
rarely see that syntax, or certain forms of boolean operator usage that
might be common in other JS libraries, in TIBET source code.
*/

//  ------------------------------------------------------------------------
//  Key-based Defaulting
//  ------------------------------------------------------------------------

TP.definePrimitive('ifKeyInvalid',
function(anObject, aKey, aDefault) {

    /**
     * @method ifKeyInvalid
     * @summary Returns aDefault value when anObject is either invalid, or the
     *     property value is. When the object implements atIfInvalid as a method
     *     this wrapper will invoke that call with the default to allow the
     *     object to manage the semantics of this call itself. This call is used
     *     often with parameter sets as a way of ensuring that even when a
     *     parameter object isn't provided local variables can be defaulted
     *     efficiently. NOTE that as a result only atIfInvalid() and at() are
     *     tested before attempting direct property access.
     * @param {Object} anObject The object whose property to access or default.
     * @param {String} aKey The property name to access.
     * @param {Object} aDefault A value, or function used to derive that value.
     *     NOTE that since function defaults are invoked they cannot be used as
     *     values in their own right. When invoked as a function the property
     *     value is provided.
     * @returns {Object} A value from the object, or the default value.
     */

    var val;

    //  easiest case is when the object (parameter/request) isn't there
    if (TP.notValid(anObject)) {
        return TP.isCallable(aDefault) ? aDefault(aKey) : aDefault;
    }

    if (TP.canInvoke(anObject, 'atIfInvalid')) {
        return anObject.atIfInvalid(aKey, aDefault);
    }

    if (TP.canInvoke(anObject, 'at')) {
        val = anObject.at(aKey);
        if (TP.notValid(val)) {
            val = TP.isCallable(aDefault) ? aDefault(aKey) : aDefault;
        }

        return val;
    }

    try {
        val = anObject[aKey];
        if (TP.notValid(val)) {
            val = TP.isCallable(aDefault) ? aDefault(aKey) : aDefault;
        }

        return val;
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'Could not default invalid key: ' + aKey)) : 0;
    }

    return TP.isCallable(aDefault) ? aDefault(aKey) : aDefault;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('ifKeyNull',
function(anObject, aKey, aDefault) {

    /**
     * @method ifKeyNull
     * @summary Returns aDefault value when anObject is either specifically
     *     null, or the property value is. When the object implements atIfNull
     *     as a method this wrapper will invoke that call with the default to
     *     allow the object to manage the semantics of this call itself.
     * @param {Object} anObject The object whose property to access or default.
     * @param {String} aKey The property name to access.
     * @param {Object} aDefault A value, or function used to derive that value.
     *     NOTE that since function defaults are invoked they cannot be used as
     *     values in their own right. When invoked as a function the property
     *     value is provided.
     * @returns {Object} A value from the object, or the default value.
     */

    var val;

    //  easiest case is when the object (parameter/request) isn't there
    if (TP.notValid(anObject)) {
        return TP.isCallable(aDefault) ? aDefault(aKey) : aDefault;
    }

    if (TP.canInvoke(anObject, 'atIfNull')) {
        return anObject.atIfNull(aKey, aDefault);
    }

    if (TP.canInvoke(anObject, 'at')) {
        val = anObject.at(aKey);
        if (TP.isNull(val)) {
            val = TP.isCallable(aDefault) ? aDefault(aKey) : aDefault;
        }

        return val;
    }

    try {
        val = anObject[aKey];
        if (TP.isNull(val)) {
            val = TP.isCallable(aDefault) ? aDefault(aKey) : aDefault;
        }

        return val;
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'Could not default null key: ' + aKey)) : 0;
    }

    return TP.isCallable(aDefault) ? aDefault(aKey) : aDefault;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('ifKeyUndefined',
function(anObject, aKey, aDefault) {

    /**
     * @method ifKeyUndefined
     * @summary Returns aDefault value when anObject is specifically undefined,
     *     or the property value is. When the object implements atIfUndefined as
     *     a method this wrapper will invoke that call with the default to allow
     *     the object to manage the semantics of this call itself.
     * @param {Object} anObject The object whose property to access or default.
     * @param {String} aKey The property name to access.
     * @param {Object} aDefault A value, or function used to derive that value.
     *     NOTE that since function defaults are invoked they cannot be used as
     *     values in their own right. When invoked as a function the property
     *     value is provided.
     * @returns {Object} A value from the object, or the default value.
     */

    var val;

    //  easiest case is when the object (parameter/request) isn't there
    if (TP.notValid(anObject)) {
        return TP.isCallable(aDefault) ? aDefault(aKey) : aDefault;
    }

    if (TP.canInvoke(anObject, 'atIfUndefined')) {
        return anObject.atIfUndefined(aKey, aDefault);
    }

    if (TP.canInvoke(anObject, 'at')) {
        val = anObject.at(aKey);
        if (TP.notDefined(val)) {
            val = TP.isCallable(aDefault) ? aDefault(aKey) : aDefault;
        }

        return val;
    }

    try {
        val = anObject[aKey];
        if (TP.notDefined(val)) {
            val = TP.isCallable(aDefault) ? aDefault(aKey) : aDefault;
        }

        return val;
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'Could not default undefined key: ' + aKey)) : 0;
    }

    return TP.isCallable(aDefault) ? aDefault(aKey) : aDefault;
});

//  ------------------------------------------------------------------------
//  BOOLEAN TESTS
//  ------------------------------------------------------------------------

TP.definePrimitive('isFalse',
function(aValue) {

    /**
     * @method isFalse
     * @summary Return true if the argument is the Boolean 'false'. This is a
     *     more explicit test than 'if (!anObj)' since that test will often lead
     *     your code astray due to bizarre type conversions.
     * @param {Object} aValue The value to test.
     * @example Test to see if anObj is false:
     *     <code>
     *          if (TP.isFalse(anObj)) { TP.info('its false'); };
     *     </code>
     * @returns {Boolean} True if aValue === false.
     */

    //  Seems pendantic, but its the best performer

    if (aValue === false) {
        return true;
    }

    if (aValue === true) {
        return false;
    }

    /* eslint-disable no-extra-parens */
    return (TP.isBoolean(aValue) && aValue.valueOf() === false);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isFalsey',
function(aValue) {

    /**
     * @method isFalsey
     * @summary Return true if the argument is considered to be 'falsey',
     *     according to JavaScript rules.
     * @param {Object} aValue The value to test.
     * @example Test to see if anObj is falsey:
     *     <code>
     *          if (TP.isFalsey('')) { TP.info('its false'); };
     *     </code>
     * @returns {Boolean} True if aValue is a 'falsey' value.
     */

    if (aValue === false ||
        aValue === '' ||
        aValue === 0 ||
        aValue === undefined ||
        aValue === null ||
        TP.isNaN(aValue)) {

        return true;
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isTrue',
function(aValue) {

    /**
     * @method isTrue
     * @summary Return true if the argument is the Boolean 'true'. This is a
     *     more explicit test than 'if (anObj)' since that test will often lead
     *     your code astray due to bizarre type conversions.
     * @param {Object} aValue The value to test.
     * @example Test to see if anObj is true:
     *     <code>
     *          if (TP.isTrue(anObj)) { TP.info('its true'); };
     *     </code>
     * @returns {Boolean} True if aValue === true.
     */

    //  Seems pendantic, but its the best performer

    if (aValue === true) {
        return true;
    }

    if (aValue === false) {
        return false;
    }

    /* eslint-disable no-extra-parens */
    return (TP.isBoolean(aValue) && aValue.valueOf() === true);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isTruthy',
function(aValue) {

    /**
     * @method isTruthy
     * @summary Return true if the argument is considered to be 'truthy',
     *     according to JavaScript rules.
     * @param {Object} aValue The value to test.
     * @example Test to see if anObj is truthy:
     *     <code>
     *          if (TP.isTruthy('hi')) { TP.info('its true'); };
     *     </code>
     * @returns {Boolean} True if aValue is a 'truthy' value.
     */

    return !TP.isFalsey(aValue);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('notFalse',
function(aValue) {

    /**
     * @method notFalse
     * @summary Return true if the argument is not the Boolean 'false'. This is
     *     a more explicit test than 'if (anObj)' since that test will often
     *     lead your code astray due to bizarre type conversions.
     * @param {Object} aValue The value to test.
     * @example Test to see if anObj is false:
     *     <code>
     *          if (TP.notFalse(anObj)) { TP.info('its not false'); };
     *     </code>
     * @returns {Boolean} True if aValue !== false.
     */

    if (aValue === true) {
        return true;
    }

    if (aValue === false) {
        return false;
    }

    return !TP.isFalse(aValue);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('notTrue',
function(aValue) {

    /**
     * @method notTrue
     * @summary Return true if the argument is not the Boolean 'true'. This is
     *     a more explicit test than 'if (!anObj)' since that test will often
     *     lead your code astray due to bizarre type conversions.
     * @param {Object} aValue The value to test.
     * @example Test to see if anObj is false:
     *     <code>
     *          if (TP.notTrue(anObj)) { TP.info('its not true'); };
     *     </code>
     * @returns {Boolean} True if aValue !== true.
     */

    if (aValue === false) {
        return true;
    }

    if (aValue === true) {
        return false;
    }

    return !TP.isTrue(aValue);
});

//  ------------------------------------------------------------------------
//  TYPE CHECKING - PART I
//  ------------------------------------------------------------------------

/*
Fundamental type checks via a common is*() API. TIBET also includes an 'isa'
method which takes a Type or String typename as a parameter and performs
type checking using that type. The methods defined here are parallels which
operate at the global level and accept an instance as their parameter.

These methods are necessary since a) depending on browser not all objects
actually inherit from Object so methods can't be added to them reliably, b)
because 'null' isn't an object you can message (and therefore 'backstop')
like it is in Smalltalk, and c) typeof likely doesn't do what you think, and
when it does it's often wrong (see isFunction for an example).

NOTE that in these and several other areas you'll start to see more of an
"object testing" approach. We use browser detection to ensure that we're
running overall on a browser that we're willing to offer commercial support
for, and that means watching out for things like FF2.0.0.2 which you can't
determine via object testing. We then load a kernel built for that browser.
Once we've loaded code however, that code tends to emphasize object testing.
*/

//  ------------------------------------------------------------------------
//  Native type checking
//  ------------------------------------------------------------------------

TP.definePrimitive('isArgArray',
function(anObj) {

    /**
     * @method isArgArray
     * @summary Returns true if the object provided is an 'arguments' array, a
     *     very special object in JavaScript which isn't an Array.
     * @param {Object} anObj The object to test.
     * @example Test to see if 'arguments' is an arg Array:
     *     <code>
     *          TP.isArgArray(arguments);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is an 'arguments'
     *     array.
     */

    /* eslint-disable no-extra-parens */
    return (TP.isValid(anObj) &&
            TP.ObjectProto.toString.call(anObj) === '[object Arguments]');
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isArray',
function(anObj) {

    /**
     * @method isArray
     * @summary Returns true if the object provided is a JavaScript Array.
     * @param {Object} anObj The object to test.
     * @example Test to see if 'anObj' is an Array:
     *     <code>
     *          anObj = TP.ac();
     *          TP.isArray(anObj);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is a JavaScript
     *     Array.
     */

    //  Defined by ECMAScript edition 5
    return Array.isArray(anObj);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isBoolean',
function(anObj) {

    /**
     * @method isBoolean
     * @summary Returns true if the object provided is a boolean primitive or
     *     wrapper object.
     * @param {Object} anObj The object to test.
     * @returns {Boolean} Whether or not the supplied object is a boolean.
     */

    if (anObj === true || anObj === false) {
        return true;
    }

    //  if it says so, then it is (a primitive one)
    if (typeof anObj === 'boolean') {
        return true;
    }

    //  Boolean objects won't say so unless we check, and if the object
    //  is in another window the constructor test will fail so we have to go
    //  even further.
    /* eslint-disable no-extra-parens */
    return (TP.isValid(anObj) && (anObj.constructor === Boolean ||
                                TP.regex.BOOLEAN_CONSTRUCTOR.test(
                                    '' + anObj.constructor)));
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isDate',
function(anObj) {

    /**
     * @method isDate
     * @summary Returns true if the object provided is a date value.
     * @param {Object} anObj The object to test.
     * @returns {Boolean}
     */

    //  all dates report object as their primitive type (but so does null)
    if (TP.notValid(anObj) || typeof anObj !== 'object') {
        return false;
    }

    //  also watch out for foolishness around 'new Date(blah)' returning objects
    //  which aren't really dates (instead of null). The ECMA-402 i18n spec for
    //  ECMAScript defines that these objects should return 'Invalid Date' (and
    //  ECMAScript edition 5 specifies 'NaN' if they were created with an
    //  invalid number).
    if (anObj.toString() === 'Invalid Date' || anObj.toString() === 'NaN') {
        return false;
    }

    //  localizable check
    if (typeof TP.isKindOf === 'function') {
        return TP.isKindOf(anObj, 'Date');
    }

    //  last chance is constructor

    /* eslint-disable no-extra-parens */
    return (anObj.constructor === Date ||
            TP.regex.DATE_CONSTRUCTOR.test('' + anObj.constructor));
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isHash',
function(anObj) {

    /**
     * @method isHash
     * @summary Returns true if the object provided is a TP.core.Hash value.
     * @param {Object} anObj The object to test.
     * @returns {Boolean}
     */

    //  NB: This is a very heavily used routine, so we use very primitive
    //  checking in it.

    //  all dates report 'object' as their primitive type (but so does null)
    if (anObj === null || typeof anObj !== 'object') {
        return false;
    }

    return anObj.$$type === TP.core.Hash;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isNumber',
function(anObj) {

    /**
     * @method isNumber
     * @summary Returns true if the object provided is a numeric value. We do
     *     not consider NaN (NotANumber) to be a number for purposes of this
     *     test since our semantic usage of isNumber is based on testing
     *     parseInt results to see if a user has entered a valid numeric value
     *     or if data from a service is numeric.
     * @description The obvious question is why not use typeof anObj ==
     *     "number"? Well, because typeof NaN == "number" will return true and,
     *     in our minds anyway, NaN is explicitly by name Not A Number. At the
     *     very least you won't want to do math with it or try to save it to a
     *     numeric column in a database. Sure, the spec says the behavior here
     *     is correct. We didn't say it was a bug, it's just lousy semantics so
     *     we made it work the way we, and other developers, assumed it would
     *     work so that a call like if (TP.isNumber(parseInt(userData)))
     *     doMath(); works the way you'd expect and won't try to compute the sum
     *     of 'foo', 'bar', and 'baz' when the user enters alphas.
     * @param {Object} anObj The object to test.
     * @example Test to see if anObj is a Number:
     *     <code>
     *          anObj = 42;
     *          TP.isNumber(anObj);
     *          <samp>true</samp>
     *     </code>
     * @example Test to see if any other object, including NaN, is a Number:
     *     <code>
     *          TP.isNumber('');
     *          <samp>false</samp>
     *          TP.isNumber(NaN);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is a JavaScript
     *     Number.
     */

    /* eslint-disable no-extra-parens */
    return (!isNaN(anObj) &&
            !Array.isArray(anObj) &&
            (anObj - parseFloat(anObj) + 1) >= 0) ||
            anObj === Number.POSITIVE_INFINITY ||
            anObj === Number.NEGATIVE_INFINITY;
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isProxy',
function(anObj) {

    /**
     * @method isProxy
     * @summary Returns true if the object provided is an ECMA E6 Proxy object.
     * @param {Object} anObj The object to test.
     * @example Test to see if anObj is a Proxy:
     *     <code>
     *          anObj = TP.constructProxyObject(myTarget, myConfig);
     *          TP.isProxy(anObj);
     *          <samp>true</samp>
     *     </code>
     * @example Test to see if any other object is a Proxy:
     *     <code>
     *          TP.isProxy('');
     *          <samp>false</samp>
     *          TP.isProxy(42);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is an ECMA E6 Proxy
     *     object.
     */

    return TP.isValid(anObj) && TP.owns(anObj, '__isProxy__');
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isRegExp',
function(anObj) {

    /**
     * @method isRegExp
     * @summary Returns true if the object provided is a regular expression
     *     instance.
     * @param {Object} anObj The object to test.
     * @returns {Boolean} Whether or not the supplied object is a RegExp.
     */

    //  most regexp tests are done when we're trying to tell the difference
    //  between what might be a regex or a string, so check that first
    if (typeof anObj === 'string') {
        return false;
    }

    //  constructor checks are next best option

    /* eslint-disable no-extra-parens */
    return (TP.isValid(anObj) && (anObj.constructor === RegExp ||
                                TP.regex.REGEXP_CONSTRUCTOR.test(
                                    '' + anObj.constructor)));
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isInvalidDate',
function(anObj) {

    /**
     * @method isInvalidDate
     * @summary Returns true if the object is a Date object, but has an invalid
     *     Date value.
     * @param {Object} anObj The object to test.
     * @returns {Boolean}
     */

    //  all dates report object as their primitive type (but so does null)
    if (TP.notValid(anObj) || typeof anObj !== 'object') {
        return false;
    }

    //  The ECMA-402 i18n spec for ECMAScript defines that these objects should
    //  return 'Invalid Date' (and ECMAScript edition 5 specifies 'NaN' if they
    //  were created with an invalid number).
    if (anObj.toString &&
        (anObj.toString() === 'Invalid Date' || anObj.toString() === 'NaN')) {
        return true;
    }

    return false;
});

//  ------------------------------------------------------------------------
//  Common Type Checking
//  ------------------------------------------------------------------------

TP.definePrimitive('isCollection',
function(anObj) {

    /**
     * @method isCollection
     * @summary Returns true if the value passed in is an instance of a
     *     Collection type such as Array or TP.core.Hash or a plain Object.
     * @description While String instances can be thought of as collections of
     *     characters this routine will not return true for Strings. Likewise,
     *     although documents and elements can be thought of as collections of
     *     subelements this routine will return false for Node types.
     * @param {Object} anObj The value to test.
     * @returns {Boolean} Whether or not the supplied object is a collection
     *     instance.
     */

    if (TP.isNodeList(anObj) ||
        TP.isNamedNodeMap(anObj) ||
        TP.isPlainObject(anObj)) {
        return true;
    }

    //  have to rely on an internal method on the object to say so (which
    //  we add to Array, TP.core.Hash, etc.)
    if (TP.canInvoke(anObj, '$$isCollection')) {
        return anObj.$$isCollection();
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isEnhanced',
function(anObj) {

    /**
     * @method isEnhanced
     * @summary Returns true if the object appears to be an enhanced object,
     *     one that TIBET has been able to augment.
     * @param {Object} anObj The object to interrogate.
     * @returns {Boolean} True if the object can respond to common TIBET
     *     methods.
     */

    return TP.canInvoke(anObj, 'getTypeName');
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isGlobal',
function(anObj, includeScannedGlobals) {

    /**
     * @method isGlobal
     * @summary Returns true if the name/object provided is a global reference,
     *     variable, or value. By default this method will return things that
     *     are considered global and will return false for objects/keys that are
     *     "natural properties" of a window. Since browser-based JS blends the
     *     concept of the Global object with Window objects we have to
     *     discriminate between the two. Passing true for the window slot
     *     parameter will cause this method to return true for things like
     *     'opener' and other window properties.
     * @description In the absense of other flags, anObj is considered to be a
     *     'global' if it meets one of the following criteria:
     *
     *     1) It is an instance of Boolean or Number. 2) It is a String that is
     *     the name of an object installed on the 'global' (i.e. Window) object
     *     that is not deemed to be a "natural property" of a Window. 3) It is a
     *     Function that's been registered using TIBET's 'defineGlobal' method.
     *     4) It is a type object - either one of the 8 built-ins, or a subtype
     *     that has been added through the '.defineSubtype' mechanism.
     * @param {Object|String} anObj An object, or name to test.
     * @param {Boolean} includeScannedGlobals True to force checking against the
     *     'TP.sys.$nativeglobals' list that was generated on startup to include
     *      every global slot by executing 'for...in' against the global object.
     * @example Test to see if an object is global:
     *     <code>
     *          TP.isGlobal(42);
     *          <samp>true</samp>
     *          TP.isGlobal(TP.lang.Object);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean}
     */

    //  typeof lies about certain edge cases and is indiscriminate in most
    //  others, but for our purposes here it's sufficient
    switch (typeof anObj) {
        case 'boolean':
        case 'number':
            //  somewhat nonsensical, but yeah
            return true;

        case 'object':
            return TP.isType(anObj);

        case 'string':
            if (TP.notDefined(TP.global[anObj])) {
                return false;
            }

            if (TP.isTrue(includeScannedGlobals)) {
                return TP.sys.$nativeglobals.contains(anObj) ||
                        TP.sys.$ecmaglobals.contains(anObj) ||
                        TP.sys.$systemglobals.contains(anObj) ||
                        TP.sys.$globals.contains(anObj) ||
                        TP.sys.$globalexcludes.contains(anObj);
            } else {
                return TP.sys.$ecmaglobals.contains(anObj) ||
                        TP.sys.$systemglobals.contains(anObj) ||
                        TP.sys.$globals.contains(anObj) ||
                        TP.sys.$globalexcludes.contains(anObj);
            }

        case 'function':
            if (TP.isTrue(includeScannedGlobals)) {
                /* eslint-disable no-extra-parens */
                return (anObj[TP.TRACK] === TP.GLOBAL_TRACK ||
                        TP.sys.$windowglobals.contains(TP.name(anObj)));
                /* eslint-enable no-extra-parens */
            } else {
                return anObj[TP.TRACK] === TP.GLOBAL_TRACK;
            }

        default:
            return false;
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isIterable',
function(anObj) {

    /**
     * @method isIterable
     * @summary Returns true if the object has an iterator property and can be
     *     used in an interating context. Common objects for which this is true
     *     are Set, Map, etc.
     * @param {Object} anObj The object to test.
     * @returns {Boolean} True if the object can be iterated.
     */

    if (anObj === null || typeof anObj !== 'object') {
        return false;
    }

    return typeof anObj[Symbol.iterator] === 'function';
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isPair',
function(anObj) {

    /**
     * @method isPair
     * @summary Returns true if the object provided is an ordered pair,
     *     normally expressed as a two-slot array.
     * @param {Object} anObj The value to test.
     * @returns {Boolean} Whether or not the supplied object is a pair.
     */

    //  have to rely on an internal method on the object to say so
    if (TP.canInvoke(anObj, '$$isPair')) {
        return anObj.$$isPair();
    }

    return false;
});

//  ------------------------------------------------------------------------
//  TP.isXHR() defined in TIBETPrimitivesPlatform.js
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  INTERNAL type checking
//  ------------------------------------------------------------------------

TP.definePrimitive('$$isTypeProxy',
function(anObj) {

    /**
     * @method $$isTypeProxy
     * @summary Returns true if the object provided is a type proxy.
     * @description TIBET supports using proxy objects for types such that when
     *     the proxy is first messaged the named type will automatically be
     *     loaded and the message will be sent to the type. This allows TIBET to
     *     support autoloading of code with no programmer intervention or
     *     additional maintenance coding.
     * @param {Object} anObj The object to test.
     * @returns {Boolean} Whether or not the supplied object is a proxy.
     */

    /* eslint-disable no-extra-parens */
    return (TP.isValid(anObj) && TP.isCallable(anObj.$$fault));
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------
//  TIBET-specific type checking
//  ------------------------------------------------------------------------

TP.definePrimitive('isProperty',
function(anObj, propName) {

    /**
     * @method isProperty
     * @summary Returns true if the object provided is a valid property. A
     *     valid property is a property which is defined but not a DNU
     *     (DoesNotUnderstand) method. Note the syntax is typically
     *     TP.isProperty(someObj, 'someProperty') so what we typically get here
     *     is undefined or a real value
     * @param {Object} anObj The object to test.
     * @param {String} propName The property name to check.
     * @returns {Boolean} Whether or not the supplied object is a property (that
     *     is a defined 'slot', but not a DNU).
     */

    //  note that we don't consider a null to be a false condition here, in
    //  fact, a null implies that a value was set at some point
    if (anObj[propName] === undefined) {
        return false;
    }

    //  The slot might have been set to 'null'.
    if (anObj[propName] === null) {
        return true;
    }

    //  make sure we don't try to get $$dnu from a null
    return !TP.$$isDNU(anObj[propName]);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isOwnProperty',
function(anObj, propName) {

    /**
     * @method isOwnProperty
     * @summary Returns true if the object provided is a valid property *and
     *     which the supplied object owns* (i.e. has a local value). See
     *     TP.isProperty() for more on what constitutes a valid property.
     * @param {Object} anObj The object to test.
     * @param {String} propName The property name to check.
     * @returns {Boolean} Whether or not the supplied object is a property (that
     *     is a defined 'slot', but not a DNU) and which the supplied object has
     *     it's own local value.
     */

    return TP.isProperty(anObj, propName) && TP.owns(anObj, propName);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isTypeName',
function(anObj) {

    /**
     * @method isTypeName
     * @summary Returns true if the object is a string that represents what
     *     could be a valid type name. This is a syntactic check, no test is
     *     performed to see if the identifier resolves to an actual type.
     * @param {Object} anObj The object to test.
     * @returns {Boolean} True if the object passes typename syntax checks.
     */

    if (!TP.isString(anObj)) {
        return false;
    }

    if (anObj.isJSIdentifier()) {
        //  could be an instance name, or a global symbol like "ANY" that we
        //  want to avoid
        if (TP.regex.INSTANCE_OID.test(anObj)) {
            return false;
        }

        return anObj !== TP.ANY;
    }

    return TP.regex.VALID_TYPENAME.test(anObj);
});

//  ------------------------------------------------------------------------
//  DOM type checking
//  ------------------------------------------------------------------------

TP.definePrimitive('isAttributeNode',
function(anObj) {

    /**
     * @method isAttributeNode
     * @summary Returns true if the object provided is an XML or HTML attribute
     *     node (Node.ATTRIBUTE_NODE). NOTE that this is quite different from
     *     the TP.isProperty() call, which tests validity of a slot value.
     * @param {Object} anObj The object to test.
     * @example Test to see if anObj is a DOM attribute node (assume that the
     *     document's body element has a 'style' attribute on it):
     *     <code>
     *          anObj = TP.documentGetBody(document).getAttributeNode('style');
     *          TP.isAttributeNode(anObj);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is an attribute
     *     node.
     */

    /* eslint-disable no-extra-parens */
    return (TP.isValid(anObj) && anObj.nodeType === Node.ATTRIBUTE_NODE);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isCDATASectionNode',
function(anObj) {

    /**
     * @method isCDATASectionNode
     * @summary Returns true if the object provided is an XML or HTML CDATA
     *     section node (Node.CDATA_SECTION_NODE).
     * @param {Object} anObj The object to test.
     * @example Test what's a CDATA section node and what's not:
     *     <code>
     *          TP.isCDATASectionNode(document.documentElement);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is an CDATA section
     *     node.
     */

    /* eslint-disable no-extra-parens */
    return (TP.isValid(anObj) && anObj.nodeType === Node.CDATA_SECTION_NODE);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isCollectionNode',
function(anObj) {

    /**
     * @method isCollectionNode
     * @summary Returns true if the object provided is an XML or HTML element
     *     (Node.ELEMENT_NODE), document (Node.DOCUMENT_NODE), or document
     *     fragment (Node.DOCUMENT_FRAGMENT_NODE).
     * @param {Object} anObj The object to test.
     * @example Test what's an element and what's not:
     *     <code>
     *          TP.isCollectionNode(document.documentElement);
     *          <samp>true</samp>
     *          TP.isCollectionNode(document);
     *          <samp>true</samp>
     *          TP.isCollectionNode(TP.node('a text node'));
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is an Element or
     *     Document.
     */

    /* eslint-disable no-extra-parens */
    return (TP.isValid(anObj) &&
            (anObj.nodeType === Node.ELEMENT_NODE ||
            anObj.nodeType === Node.DOCUMENT_NODE ||
            anObj.nodeType === Node.DOCUMENT_FRAGMENT_NODE));
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isCommentNode',
function(anObj) {

    /**
     * @method isCommentNode
     * @summary Returns true if the object provided is an XML or HTML Comment
     *     node (Node.COMMENT_NODE).
     * @param {Object} anObj The object to test.
     * @example Test what's a comment node and what's not:
     *     <code>
     *          TP.isCommentNode(document.documentElement);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is an Comment node.
     */

    /* eslint-disable no-extra-parens */
    return (TP.isValid(anObj) && anObj.nodeType === Node.COMMENT_NODE);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isDocument',
function(anObj) {

    /**
     * @method isDocument
     * @summary Returns true if the object provided TP.isHTMLDocument() or
     *     TP.isXMLDocument().
     * @param {Object} anObj The object to test.
     * @example Test what's a document and what's not:
     *     <code>
     *          isDocument(window.document);
     *          <samp>true</samp>
     *          isDocument(window);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is an (HTML)
     *     document.
     */

    //  both html and xml documents still report node type as document, but
    //  an xml document won't have an applets property
    /* eslint-disable no-extra-parens */
    return (TP.isValid(anObj) && anObj.nodeType === Node.DOCUMENT_NODE);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isElement',
function(anObj) {

    /**
     * @method isElement
     * @summary Returns true if the object provided is an XML or HTML element
     *     node (Node.ELEMENT_NODE).
     * @param {Object} anObj The object to test.
     * @example Test what's an element and what's not:
     *     <code>
     *          TP.isElement(document.documentElement);
     *          <samp>true</samp>
     *          TP.isElement(document);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is an Element.
     */

    /* eslint-disable no-extra-parens */
    return (TP.isValid(anObj) && anObj.nodeType === Node.ELEMENT_NODE);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------
//  TP.isError() defined in TIBETPrimitivesPlatform.js
//  ------------------------------------------------------------------------

TP.definePrimitive('isEvent',
function(anObj) {

    /**
     * @method isEvent
     * @summary Returns true if the object provided is an Event object.
     * @param {Object} anObj The object to test.
     * @returns {Boolean} Whether or not the supplied object is an Event object.
     */

    /* eslint-disable no-extra-parens */
    return (TP.isValid(anObj) &&
            typeof anObj.stopPropagation === 'function' &&
            TP.isValid(anObj.timeStamp));
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isFragment',
function(anObj) {

    /**
     * @method isFragment
     * @summary Returns true if the object provided is an XML or HTML document
     *     fragment node (Node.DOCUMENT_FRAGMENT_NODE).
     * @param {Object} anObj The object to test.
     * @example TODO
     * @returns {Boolean} Whether or not the supplied object is a document
     *     fragment.
     */

    /* eslint-disable no-extra-parens */
    return (TP.isValid(anObj) &&
            anObj.nodeType === Node.DOCUMENT_FRAGMENT_NODE);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isHTMLDocument',
function(anObj) {

    /**
     * @method isHTMLDocument
     * @summary Returns true if the object contains 'open' and 'applets'
     *     references which seems sufficient to determine whether it is a true
     *     HTML document, a general object, or 'self'.
     * @param {Object} anObj The object to test.
     * @example Test what's an html document and what's not:
     *     <code>
     *          TP.isHTMLDocument(top.document);
     *          <samp>true</samp>
     *          newXMLDoc = TP.doc('<foo/>');
     *          TP.isHTMLDocument(newXMLDoc);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is an (HTML)
     *     document.
     */

    //  Check to make sure its some sort of DOCUMENT_NODE first.
    if (TP.notValid(anObj) || anObj.nodeType !== Node.DOCUMENT_NODE) {
        return false;
    }

    //  We may have already been through the test below and captured that
    //  value, so return it if we have.
    if (TP.isDefined(anObj[TP.IS_XML]) || TP.isDefined(anObj[TP.IS_XHTML])) {
        return !(anObj[TP.IS_XHTML] || anObj[TP.IS_XML]);
    }

    //  If the object is our XML factory document, then we know it's not HTML
    //  (but it *is* XML, so we stamp it).
    if (anObj === TP.XML_FACTORY_DOCUMENT) {
        anObj[TP.IS_XML] = true;
        return false;
    }

    //  If the document has a contentType then we test for either HTML or XHTML.
    //  Note here how we make the tests explicit - otherwise, we drop down into
    //  more complex logic.
    if (anObj.contentType === TP.HTML_TEXT_ENCODED) {
        anObj[TP.IS_XML] = false;
        anObj[TP.IS_XHTML] = false;
        return true;
    } else if (anObj.contentType === TP.XHTML_ENCODED) {
        anObj[TP.IS_XML] = true;
        anObj[TP.IS_XHTML] = true;
        return false;
    }

    //  Sometimes we get a Document that doesn't have a document element
    if (!TP.isElement(anObj.documentElement)) {
        anObj[TP.IS_XML] = false;
        anObj[TP.IS_XHTML] = false;
        return false;
    }
/*
    (wje) see if there's a variation that works. detached nodes should work.
    //  If the document doesn't have a Window, then its not HTML, but go ahead
    //  and stamp the markers in anyway.
    if (TP.notValid(TP.nodeGetWindow(anObj))) {
        anObj[TP.IS_XML] = true;
        anObj[TP.IS_XHTML] = anObj.documentElement.namespaceURI ===
                                    'http://www.w3.org/1999/xhtml';
        return false;
    }
*/
    if (anObj.documentElement.namespaceURI !== 'http://www.w3.org/1999/xhtml') {
        anObj[TP.IS_XML] = true;
        anObj[TP.IS_XHTML] = false;
        return false;
    }

    //  Last check is to see if the '.tagName' property preserves case
    //  sensitivity. If it doesn't, then it's HTML not XHTML.
    anObj[TP.IS_XHTML] = anObj.createElement('foo').tagName === 'FOO' ?
                    false :
                    true;
    anObj[TP.IS_XML] = anObj[TP.IS_XHTML];

    return !anObj[TP.IS_XHTML];
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isHTMLNode',
function(anObj) {

    /**
     * @method isHTMLNode
     * @summary Returns true if the object provided is an HTML node.
     * @param {Object} anObj The object to test.
     * @example Test what's an html node and what's not:
     *     <code>
     *          TP.isHTMLNode(top.document.documentElement);
     *          <samp>true</samp>
     *          TP.isHTMLNode(newXMLDoc);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is an HTML node.
     */

    var doc;

    //  Make sure its a node first.
    if (TP.notValid(anObj) || typeof anObj.nodeType !== 'number') {
        return false;
    }

    if (anObj.nodeType === Node.DOCUMENT_NODE) {
        return TP.isHTMLDocument(anObj);
    }

    //  If the node isn't in a document anywhere, then about the only thing
    //  we can do is check to see if it has a tagName (i.e. it is a
    //  Node.ELEMENT_NODE), and if that tag name is one of the HTML ones. If
    //  so, we return true (since its really an HTML node - it may be an
    //  XHTML node, but we can't tell that here).
    if (TP.notValid(doc = anObj.ownerDocument)) {
        if (TP.isValid(anObj.tagName)) {
            return TP.isValid(
                        TP.HTML_401_TAGS[anObj.tagName.toLowerCase()]);
        }

        return false;
    }

    return TP.isHTMLDocument(doc);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isIFrameWindow',
function(anObj) {

    /**
     * @method isIFrameWindow
     * @summary Returns whether or not the object is the content window of an
     *     'iframe' element. NOTE: This will *not* return true for 'frame'
     *     windows, just 'iframe' windows.
     * @param {Object} anObj The object to check.
     * @example Test what's an iframe window and what's not:
     *     <code>
     *          anElem = document.createElement('iframe');
     *          TP.nodeAppendChild(TP.documentGetBody(document), anElem);
     *          TP.isIFrameWindow(TP.elementGetIFrameWindow(anElem));
     *          <samp>true</samp>
     *          TP.isIFrameWindow(top); // top-level window
     *          <samp>false</samp>
     *          TP.isIFrameWindow(TP.sys.getUICanvas().getNativeWindow());
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not anObj is a Window object that belongs
     *     to an 'iframe'.
     */

    var frame;

    if (TP.notValid(anObj)) {
        return false;
    }

    try {
        //  On IE, trying to get the 'frameElement' doesn't return undefined, it
        //  throws a "No such interface supported" exception...
        frame = anObj.frameElement;

        //  NOTE: the dependency here on TP.elementGetLocalName(), which
        //  helps ensure we handle namespaced markup properly
        if (TP.isElement(frame) &&
            (TP.elementGetLocalName(frame).toLowerCase() === 'iframe' ||
                TP.elementGetLocalName(frame).toLowerCase() === 'object')) {
            return true;
        }
    } catch (e) {
        return false;
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isMediaQueryList',
function(anObj) {

    /**
     * @method isMediaQueryList
     * @summary Returns true if the object provided is a valid media query list
     *     object.
     * @param {Object} anObj The object to test.
     * @example Test what's a media query list and what's not:
     *     <code>
     *          TP.isMediaQueryList(window.matchMedia('@media screen'));
     *          <samp>true</samp>
     *          TP.isMediaQueryList(window.navigator);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is a media query
     *     list.
     */

    if (TP.notValid(anObj)) {
        return false;
    }

    //  have to watch out for other things with matches, like RegExps
    return anObj.matches !== undefined && anObj.media !== undefined;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isNamedNodeMap',
function(anObj) {

    /**
     * @method isNamedNodeMap
     * @summary Returns true if the object provided is a DOM named node map.
     * @param {Object} anObj The object to test.
     * @example Test what's a named node map and what's not:
     *     <code>
     *          TP.isNamedNodeMap(TP.documentGetBody(document).attributes);
     *          <samp>true</samp>
     *          TP.isNamedNodeMap(TP.documentGetBody(document).childNodes);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is a named node
     *     map.
     */

    return TP.isValid(anObj) &&
            TP.isValid(anObj.getNamedItem) &&
            TP.isValid(anObj.setNamedItem);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isNodeList',
function(anObj) {

    /**
     * @method isNodeList
     * @summary Returns true if the object provided is a DOM node list (or an
     *     Array acting like one).
     * @description We need to supply a special version of this for IE because
     *     node lists returned from the XML DOM are different from those
     *     returned from the HTML DOM.
     * @param {Object} anObj The object to test.
     * @example Test what's a node list and what's not:
     *     <code>
     *          TP.isNodeList(TP.documentGetBody(document).childNodes);
     *          <samp>true</samp>
     *          TP.isNodeList(TP.documentGetBody(document).attributes);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is a node list.
     */

    if (TP.notValid(anObj) || TP.isWindow(anObj)) {
        return false;
    }

    //  Sometimes (i.e. the 'attributes' collection on elements), named
    //  node maps also think that they're node lists, so if this is a
    //  named node map, then return false
    if (TP.isNamedNodeMap(anObj)) {
        return false;
    }

    //  some arrays double as NodeList objects and since we augment them
    //  them with an 'item' slot that test won't be sufficient
    if (TP.isArray(anObj)) {
        //  Missing the '.join' method? Assume we're a NodeList
        if (anObj.join === undefined) {
            return true;
        }

        return false;
    }

    //  have to watch out for other things with length, like strings and
    //  CSSStyleDeclarations
    return typeof anObj !== 'string' &&
            anObj.length !== undefined &&
            anObj.item !== undefined &&
            anObj.nodeType === undefined &&
            anObj.cssText === undefined;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isPINode',
function(anObj) {

    /**
     * @method isPINode
     * @summary Returns true if the object provided is an XML or HTML
     *     processing instruction node (Node.PROCESSING_INSTRUCTION_NODE).
     * @param {Object} anObj The object to test.
     * @returns {Boolean} Whether or not the supplied object is a processing
     *     instruction node.
     */

    /* eslint-disable no-extra-parens */
    return (TP.isValid(anObj) && anObj.nodeType ===
            Node.PROCESSING_INSTRUCTION_NODE);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isStyleDeclaration',
function(anObj) {

    /**
     * @method isStyleDeclaration
     * @summary Returns true if the object provided is a 'style' object you'd
     *     find on a rendered DOM node or as a declaration in a CSS style rule.
     * @param {Object} anObj The object to test.
     * @example Test what's a style object and what's not:
     *     <code>
     *          TP.isStyleDeclaration(TP.documentGetBody(document).style);
     *          <samp>true</samp>
     *          TP.isStyleDeclaration(TP.documentGetBody(document).style.color);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is a 'style'
     *     object.
     */

    if (TP.notValid(anObj)) {
        return false;
    }

    return TP.ObjectProto.toString.call(anObj) ===
                                        '[object CSSStyleDeclaration]';
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isStyleRule',
function(anObj) {

    /**
     * @method isStyleRule
     * @summary Returns true if the object provided is a 'style rule' object
     *     you'd find attached to a stylesheet.
     * @param {Object} anObj The object to test.
     * @example Test what's a style rule object and what's not:
     *     <code>
     *          TP.isStyleRule(TP.styleSheetGetStyleRules(
     *              document.styleSheets[0])[0]);
     *          <samp>true</samp>
     *          TP.isStyleRule(TP.documentGetBody(document).style);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is a 'stylesheet'
     *     object.
     */

    if (TP.notValid(anObj)) {
        return false;
    }

    return TP.ObjectProto.toString.call(anObj) === '[object CSSStyleRule]';
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isStyleSheet',
function(anObj) {

    /**
     * @method isStyleSheet
     * @summary Returns true if the object provided is a 'stylesheet' object
     *     you'd find attached to a document.
     * @param {Object} anObj The object to test.
     * @example Test what's a style sheet object and what's not:
     *     <code>
     *          TP.isStyleSheet(TP.documentGetBody(document).styleSheets[0]);
     *          <samp>true</samp>
     *          TP.isStyleSheet(TP.documentGetBody(document).style.color);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is a 'stylesheet'
     *     object.
     */

    if (TP.notValid(anObj)) {
        return false;
    }

    /* eslint-disable no-extra-parens */
    return (anObj.parentStyleSheet !== undefined &&
            anObj.ownerNode !== undefined);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isSVGNode',
function(anObj) {

    /**
     * @method isSVGNode
     * @summary Returns true if the object provided is an SVG node.
     * @param {Object} anObj The object to test.
     * @returns {Boolean} Whether or not the supplied object is an SVG node.
     */

    var doc;

    if (!TP.isXMLNode(anObj)) {
        return false;
    }

    if (anObj.namespaceURI === 'http://www.w3.org/2000/svg') {
        return true;
    }

    if (TP.isDocument(doc = TP.nodeGetDocument(anObj))) {
        return TP.isElement(doc.documentElement) &&
                doc.documentElement.namespaceURI ===
                                    'http://www.w3.org/2000/svg';
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isTextNode',
function(anObj) {

    /**
     * @method isTextNode
     * @summary Returns true if the object provided is an XML or HTML Text node
     *     (Node.TEXT_NODE).
     * @param {Object} anObj The object to test.
     * @example Test what's a text node and what's not:
     *     <code>
     *          TP.isTextNode(document.documentElement);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is an Text node.
     */

    return TP.isValid(anObj) && anObj.nodeType === Node.TEXT_NODE;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isWhitespaceTextNode',
function(anObj) {

    /**
     * @method isWhitespaceTextNode
     * @summary Returns true if the object provided is an XML or HTML Text node
     *     (Node.TEXT_NODE) that contains *only whitespace*.
     * @param {Object} anObj The object to test.
     * @example Test what's a text node with whitespace and what's not:
     *     <code>
     *          TP.isWhitespaceTextNode(document.documentElement);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is an Text node
     *     with only whitespace in it.
     */

    return TP.isTextNode(anObj) &&
            TP.regex.ONLY_WHITESPACE.test(anObj.nodeValue);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isXHTMLDocument',
function(anObj) {

    /**
     * @method isXHTMLDocument
     * @summary Returns true if the object provided is an XHTML document.
     * @param {Object} anObj The object to test.
     * @returns {Boolean} Whether or not the supplied object is an XHTML
     *     document.
     */

    //  Check to make sure its some sort of DOCUMENT_NODE first.
    if (TP.notValid(anObj) || anObj.nodeType !== Node.DOCUMENT_NODE) {
        return false;
    }

    //  We may have already been through the test below and captured that
    //  value, so return it if we have.
    if (TP.isDefined(anObj[TP.IS_XHTML])) {
        return anObj[TP.IS_XHTML];
    }

    //  If the object is our XML factory document, then we know it's XML (and,
    //  in fact, shouldn't reset that), but we can poke around a bit more to
    //  determine whether it's XHTML.
    if (anObj === TP.XML_FACTORY_DOCUMENT) {
        anObj[TP.IS_XML] = true;

        if (!TP.isElement(anObj.documentElement)) {
            anObj[TP.IS_XHTML] = false;
        } else {
            anObj[TP.IS_XHTML] = anObj.documentElement.namespaceURI ===
                                        'http://www.w3.org/1999/xhtml';
        }

        return anObj[TP.IS_XHTML];
    }

    //  If the document has a contentType and that contentType is
    //  TP.XHTML_ENCODED, then we know it's HTML
    if (anObj.contentType === TP.XHTML_ENCODED) {
        anObj[TP.IS_XML] = true;
        anObj[TP.IS_XHTML] = true;
        return true;
    } else if (anObj.contentType === TP.HTML_TEXT_ENCODED) {
        anObj[TP.IS_XML] = false;
        anObj[TP.IS_XHTML] = false;
        return false;
    }

    //  Sometimes we get a Document that doesn't have a document element
    if (!TP.isElement(anObj.documentElement)) {
        anObj[TP.IS_XML] = false;
        anObj[TP.IS_XHTML] = false;
        return false;
    }
/*
    (wje) see if there's a variation that works. detached nodes should work.
    //  If the document doesn't have a Window, then we check to see if the
    //  document element is 'html' - in which case, we can still think of it
    //  as XHTML.
    if (TP.notValid(TP.nodeGetWindow(anObj))) {
        anObj[TP.IS_XML] = true;
        anObj[TP.IS_XHTML] = anObj.documentElement.namespaceURI ===
                                    'http://www.w3.org/1999/xhtml';

        return anObj[TP.IS_XHTML];
    }
*/
    if (anObj.documentElement.namespaceURI !== 'http://www.w3.org/1999/xhtml') {
        anObj[TP.IS_XML] = true;
        anObj[TP.IS_XHTML] = false;
        return false;
    }

    //  Last check is to see if the '.tagName' property preserves case
    //  sensitivity. If it doesn't, then it's HTML not XHTML.
    anObj[TP.IS_XHTML] = anObj.createElement('foo').tagName === 'FOO' ?
                    false :
                    true;
    anObj[TP.IS_XML] = anObj[TP.IS_XHTML];

    return anObj[TP.IS_XHTML];
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isXHTMLNode',
function(anObj) {

    /**
     * @method isXHTMLNode
     * @summary Returns true if the object provided is an XHTML node.
     * @param {Object} anObj The object to test.
     * @returns {Boolean} Whether or not the supplied object is an XHTML node.
     */

    //  Make sure its a node first.
    if (TP.notValid(anObj) || typeof anObj.nodeType !== 'number') {
        return false;
    }

    if (anObj.nodeType === Node.DOCUMENT_NODE) {
        return TP.isXHTMLDocument(anObj);
    }

    if (anObj.namespaceURI === 'http://www.w3.org/1999/xhtml') {
        return true;
    }

    //  If the node isn't in a document anywhere, then about the only thing
    //  we can do is check to see if it has a tagName (i.e. it is a
    //  Node.ELEMENT_NODE), and if that tag name is one of the HTML ones. If
    //  so, we return true (since its really an HTML node - it may be an
    //  XHTML node, but we can't tell that here).
    if (TP.notValid(anObj.ownerDocument)) {
        if (TP.isValid(anObj.tagName)) {
            return TP.isValid(
                        TP.HTML_401_TAGS[anObj.tagName.toLowerCase()]);
        }
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isXMLDocument',
function(anObj) {

    /**
     * @method isXMLDocument
     * @summary Returns true if the object provided is an XML document.
     * @param {Object} anObj The object to test.
     * @example Test what's an xml document and what's not:
     *     <code>
     *          newXMLDoc = TP.doc('<foo/>');
     *          TP.isXMLDocument(newXMLDoc);
     *          <samp>true</samp>
     *          TP.isXMLDocument(top.document);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is an XML document.
     */

    //  Check to make sure its some sort of DOCUMENT_NODE first.
    if (TP.notValid(anObj) || anObj.nodeType !== Node.DOCUMENT_NODE) {
        return false;
    }

    //  We may have already been through the test below and captured that
    //  value, so return it if we have.
    if (TP.isDefined(anObj[TP.IS_XML])) {
        return anObj[TP.IS_XML];
    }

    if (anObj.contentType === TP.XML_ENCODED) {
        anObj[TP.IS_XML] = true;
        return true;
    }

    //  If the object is our XML factory document, then we know it's XML.
    if (anObj === TP.XML_FACTORY_DOCUMENT) {
        anObj[TP.IS_XML] = true;
        return true;
    }

    //  NB: This call will stamp TP.IS_XML on the document, whatever the value
    //  is.
    return !TP.isHTMLDocument(anObj);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isXMLNode',
function(anObj) {

    /**
     * @method isXMLNode
     * @summary Returns true if the object provided is an XML node.
     * @param {Object} anObj The object to test.
     * @example Test what's an xml element and what's not:
     *     <code>
     *          newXMLDoc = TP.doc('<foo/>');
     *          TP.isXMLNode(newXMLDoc.documentElement);
     *          <samp>true</samp>
     *          TP.isXMLNode(newXMLDoc);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is an XML node.
     */

    var doc;

    //  Make sure its a node first.
    if (TP.notValid(anObj) || typeof anObj.nodeType !== 'number') {
        return false;
    }

    if (anObj.nodeType === Node.DOCUMENT_NODE) {
        return TP.isXMLDocument(anObj);
    }

    //  If the node isn't in a document anywhere, then about the only thing we
    //  can do is check to see if it has a tagName (i.e. it is a
    //  Node.ELEMENT_NODE), and if that tag name is one of the HTML ones. If so,
    //  we return false (since its really an HTML node - it may be an XHTML
    //  node, but we can't tell that here).
    if (TP.notValid(doc = anObj.ownerDocument)) {
        if (TP.isValid(anObj.tagName)) {
            return !TP.isValid(
                        TP.HTML_401_TAGS[anObj.tagName.toLowerCase()]);
        }

        return false;
    }

    //  If its document is an XML document, then its definitely an XML node.
    return TP.isXMLDocument(doc);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isXHR',
function(anObj) {

    /**
     * @method isXHR
     * @summary Returns true if the object appears to be an XMLHttpRequest
     *     instance. These are tricky little suckers that will throw exceptions
     *     if you don't treat them nicely so this is a good check to use when
     *     you suspect you might have an XHR.
     * @param {Object} anObj The object to interrogate.
     * @returns {Boolean} True if the object looks like an XHR.
     */

    try {
        return TP.isValid(anObj) &&
                TP.isProperty(anObj, 'responseText') &&
                typeof anObj.send === 'function';
    } catch (e) {
        //  empty
    }

    return false;
});

//  ------------------------------------------------------------------------
//  EMPTY/NON-EMPTY
//  ------------------------------------------------------------------------

/*
Empty testing is particularly common around element attribute values where,
based on the browser, the DTD in question, etc, you may get a null, an empty
string, or an exception, when trying to access an attribute. As a result we
offer isEmpty as a way of testing attribute values and other objects.

The term 'empty' (isEmpty/notEmpty) lets you know whether a string, node, or
collection is empty. When applied to a Node the response is based on whether
the Node has content. NOTE that isEmpty is commonly used to check attribute
values to deal with cross-browser differences surrounding return values.

NOTE that isEmpty CAN CAUSE BUGS if the input can be a Node since the result
will depend on the whether there is valid content, not whether there is a
node in existence.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('isEmpty',
function(anObj) {

    /**
     * @method isEmpty
     * @summary Returns true if the object provided is 'empty' meaning it may
     *     be 'invalid' or have a size, length, or empty attribute which defines
     *     it as having zero-length content.
     * @description A common error is using TP.isEmpty() to test a return value
     *     which is a Node. This will return varying results depending on how
     *     many childNodes the Node has. Use TP.isValid() to test whether a node
     *     exists, then use TP.isEmpty() to test for children.
     * @param {Object} anObj The object to test.
     * @example Test which primitive objects are considered empty and which ones
     *     aren't:
     *     <code>
     *          TP.isEmpty(42);
     *          <samp>false</samp>
     *          TP.isEmpty(true);
     *          <samp>false</samp>
     *          TP.isEmpty('Hi there');
     *          <samp>false</samp>
     *          TP.isEmpty('');
     *          <samp>true</samp>
     *     </code>
     * @example Test which DOM objects are considered empty and which ones
     *     aren't:
     *     <code>
     *          TP.isEmpty(document);
     *          <samp>false</samp>
     *          TP.isEmpty(TP.documentGetBody(document));
     *          <samp>false</samp>
     *          newSpan = document.createElement('span');
     *          TP.nodeAppendChild(TP.documentGetBody(document), newSpan);
     *          TP.isEmpty(newSpan);
     *          <samp>true</samp>
     *          TP.nodeAppendChild(
     *          newSpan,
     *          document.createTextNode(''));
     *          TP.isEmpty(newSpan);
     *          <samp>false</samp>
     *          TP.isEmpty(newSpan.firstChild);
     *          <samp>true</samp>
     *          TP.nodeSetTextContent(newSpan.firstChild, 'hi');
     *          TP.isEmpty(newSpan.firstChild);
     *          <samp>false</samp>
     *          TP.elementSetAttribute(newSpan, 'newAttr', 'newVal');
     *          TP.isEmpty(newSpan.attributes[0]);
     *          <samp>false</samp>
     *          newSpan.attributes[0].value = '';
     *          TP.isEmpty(newSpan.attributes[0]);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} True if the object has content size = 0.
     */

    var val,
        type;

    //  NB: This is a very heavily used routine, so we use very primitive
    //  checking in it.

    if (anObj === undefined || anObj === null) {
        return true;
    }

    type = typeof anObj;

    //  have to be careful here because of IE and its failure to support
    //  toString() on certain node objects
    if (type === 'string') {
        //  Make sure to use a '===' test here since if anObj is false, 0,
        //  null, undefined, etc. a '==' test could actually succeed.
        return anObj === '';
    }

    //  if its a boolean, it can't be empty.
    if (type === 'boolean') {
        return false;
    }

    //  if its a number and its NaN, then it's empty - otherwise, it's not.
    if (type === 'number') {
        return TP.isNaN(anObj);
    }

    //  'arguments' arrays are handled specially, since they don't act like
    //  other arrays (i.e. they don't participate in the prototype chain).
    if (TP.isArgArray(anObj)) {
        return anObj.length === 0;
    }

    //  If it has a 'length' slot and that contains a Number, use that. This
    //  would include native Strings. Note that we're not interested in
    //  Functions, since 'length' is an alias for 'arity'.
    if (type !== 'function') {
        val = anObj.length;
        if (typeof val === 'number') {
            return val === 0;
        }
    }

    if (TP.isRegExp(anObj)) {
        return false;
    }

    //  If the object is a DOM Attribute, then its empty if it's value is
    //  the empty string. Note that we check this before we check all other
    //  Nodes as this returns a better measure of emptiness for Attribute
    //  Nodes.
    if (TP.isAttributeNode(anObj)) {
        /* eslint-disable no-extra-parens */
        return (TP.notValid(anObj.value) || anObj.value === '');
        /* eslint-enable no-extra-parens */
    }

    //  If the object is a DOM Node, then its empty if it has no child
    //  nodes.
    if (TP.isNode(anObj)) {
        return anObj.childNodes.length === 0;
    }

    //  If the object responds to 'isEmpty', return that value.
    //  NB: It's much better to do this before checking size with 'getSize'
    //  since many non-collection objects will fetch all of their keys as part
    //  of that operation and return the size of that Array, which is slow.
    if (TP.canInvoke(anObj, 'isEmpty')) {
        if (TP.isBoolean(val = anObj.isEmpty())) {
            return val;
        }
    }

    //  If something can respond to 'getSize', use it. This includes Arrays,
    //  TP.core.Hashes and String.
    if (TP.canInvoke(anObj, 'getSize')) {
        try {
            return anObj.getSize() === 0;
        } catch (e) {
            TP.ifError() ? TP.error(TP.ec(e, 'Could not obtain size')) : 0;
        }
    }

    //  If the object responds to 'getAttribute', see if we can get the
    //  value of an attribute named 'empty'.
    if (TP.canInvoke(anObj, 'getAttribute')) {
        if (TP.isBoolean(val = anObj.getAttribute('empty'))) {
            return val;
        }
    }

    return TP.objectGetKeys(anObj).getSize() === 0;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('ifEmpty',
function(aSuspectValue, aDefaultValue) {

    /**
     * @method ifEmpty
     * @summary Returns either aSuspectValue or aDefaultValue based on the
     *     state of aSuspectValue. If aSuspectValue TP.isEmpty() aDefaultValue
     *     is returned.
     * @param {Object} aSuspectValue The value to test.
     * @param {Object} aDefaultValue The value to return if test passes.
     * @example Set the value of theObj to 'Hi there', if anObj is empty:
     *     <code>
     *          theObj = TP.ifEmpty(anObj, 'Hi there');
     *     </code>
     * @returns {Object} One of the two values provided.
     */

    return TP.isEmpty(aSuspectValue) ? aDefaultValue : aSuspectValue;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('notEmpty',
function(anObj) {

    /**
     * @method notEmpty
     * @summary Returns true if the object provided is not 'empty' meaning it
     *     must be a valid object with a size, length, or empty attribute which
     *     defines it as having content.
     * @description A common error is using TP.notEmpty() to test a return value
     *     which is a Node. This will return varying results depending on how
     *     many childNodes the Node has. Use TP.isValid() to test whether a node
     *     exists, then use TP.notEmpty() to test for children.
     * @param {Object} anObj The object to test.
     * @example See the TP.isEmpty() method for examples on 'emptiness'.
     * @returns {Boolean} True if the object has content size > 0.
     */

    return !TP.isEmpty(anObj);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('ifNaN',
function(aSuspectValue, aDefaultValue) {

    /**
     * @method ifNaN
     * @summary Returns either aSuspectValue or aDefaultValue based on the
     *     state of aSuspectValue. If aSuspectValue is NaN, aDefaultValue is
     *     returned.
     * @param {Object} aSuspectValue The value to test.
     * @param {Object} aDefaultValue The value to return if aSuspectValue is
     *     NaN.
     * @example Set the value of theObj to 42, if anObj is NaN:
     *     <code>
     *          theObj = TP.ifNaN(anObj, 42);
     *     </code>
     * @returns {Object} One of the two values provided.
     */

    return TP.isNaN(aSuspectValue) === true ? aDefaultValue : aSuspectValue;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isEmptyArray',
function(anObj) {

    /**
     * @method isEmptyArray
     * @summary Returns true if the object provided is a JavaScript Array and is
     *     empty.
     * @param {Object} anObj The object to test.
     * @example Test to see if 'anObj' is an Array:
     *     <code>
     *          anObj = TP.ac();
     *          TP.isEmptyArray(anObj);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not the supplied object is an empty
     *     JavaScript Array.
     */

    //  Defined by ECMAScript edition 5
    return Array.isArray(anObj) && anObj.length === 0;
});

//  ------------------------------------------------------------------------
//  BLANK (WHITESPACE) ONLY
//  ------------------------------------------------------------------------

TP.definePrimitive('ifBlank',
function(aSuspectValue, aDefaultValue) {

    /**
     * @method ifBlank
     * @summary Returns either aSuspectValue or aDefaultValue based on the
     *     state of aSuspectValue. If aSuspectValue TP.isBlank() aDefaultValue
     *     is returned.
     * @param {Object} aSuspectValue The value to test.
     * @param {Object} aDefaultValue The value to return if test passes.
     * @example Set the value of theObj to 'Hi there', if anObj is blank:
     *     <code>
     *          theObj = TP.ifBlank(anObj, 'Hi there');
     *     </code>
     * @returns {Object} One of the two values provided.
     */

    return TP.isBlank(aSuspectValue) ? aDefaultValue : aSuspectValue;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isBlank',
function(anObj) {

    /**
     * @method isBlank
     * @summary Returns true if the object is blank. Typically this method is
     *     applied to strings to test whether they are empty or have only
     *     whitespace as content. All other objects return the same result as
     *     testing them with isEmpty. NOTE that for nodes this also will return
     *     true if the node is a text node whose content is empty or whitespace.
     * @param {Object} anObj Typically a string being tested to see if it is
     *     empty or contains only whitespace.
     * @returns {Boolean} True if the object is blank.
     */

    if (anObj === null || anObj === undefined) {
        return true;
    }

    if (TP.isTextNode(anObj)) {
        return TP.isEmpty(TP.trim(anObj.value));
    }

    return TP.isEmpty(TP.trim(anObj));
});

//  ------------------------------------------------------------------------

TP.definePrimitive('notBlank',
function(anObj) {

    /**
     * @method notBlank
     * @summary Returns true if the object provided is not blank meaning it
     *     must be a String containing at least one non-whitespace character or
     *     an object which is notEmpty.
     * @param {Object} anObj The object to test.
     * @returns {Boolean} True if the object is not blank/empty.
     */

    return !TP.isBlank(anObj);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isClosed',
function(anObj) {

    /**
     * @method isClosed
     * @summary Returns true if the object provided is a window (or control)
     *     that is closed, or resides in one. This is only relevant for window
     *     and DOM objects.
     * @param {Object} anObj The object to test.
     * @returns {Boolean} True when the object provided lives in a closed
     *     windows.
     */

    var win;

    if (TP.isWindow(anObj)) {
        return anObj.closed;
    } else if (TP.isNode(anObj)) {
        //  if we haven't loaded this primitive it's ok
        if (TP.canInvoke(TP, 'nodeGetWindow')) {
            win = TP.nodeGetWindow(anObj);
        }
    } else if (TP.canInvoke(anObj, 'getNativeWindow')) {
        win = anObj.getNativeWindow();
    }

    if (TP.isWindow(win)) {
        return win.closed;
    }

    //  note the default here, just in case we're running in a close handler
    //  or shutdown scenario
    return window.closed;
});

//  ------------------------------------------------------------------------
//  KEY ACQUISITION
//  ------------------------------------------------------------------------

//  These are key Arrays for many browser native objects and are wired into
//  those objects prototypes over in the tibet_hook file, so that they're
//  included in every page (and programmed onto every native object) TIBET
//  might encounter.
//  ------------------------------------------------------------------------

TP.sys.$arraykeys = TP.ac(
                    'length'
                    );

//  ------------------------------------------------------------------------

TP.sys.$documentkeys = TP.ac(
                    'localName', 'namespaceURI', 'nodeName', 'nodeType',
                    'nodeValue', 'prefix'
                    );

//  ------------------------------------------------------------------------

TP.sys.$htmldockeys = TP.ac(
                    'cookie', 'domain', 'lastModified', 'referrer',
                    'title', 'URL'
                    );

//  ------------------------------------------------------------------------

TP.sys.$elementkeys = TP.ac(
                    'localName', 'namespaceURI', 'nodeName', 'nodeType',
                    'nodeValue', 'prefix', 'tagName'
                    );

//  ------------------------------------------------------------------------

TP.sys.$htmlelemkeys = TP.ac(
                    'localName', 'namespaceURI', 'nodeName', 'nodeType',
                    'nodeValue', 'prefix', 'tagName', 'baseName',
                    'className', 'dir', 'id', 'lang', 'offsetHeight',
                    'offsetWidth', 'offsetLeft', 'offsetTop',
                    'scrollHeight', 'scrollWidth', 'scrollLeft', 'scrollTop',
                    'title'
                    );

//  ------------------------------------------------------------------------

TP.sys.$errorkeys = TP.ac(
                    'message'
                    );

//  ------------------------------------------------------------------------

TP.sys.$eventkeys = TP.ac(
                    'bubbles', 'cancelable', 'eventPhase', 'timeStamp',
                    'type', 'altKey', 'button', 'cancelBubble', 'clientX',
                    'clientY', 'ctrlKey', 'keyCode', 'offsetX', 'offsetY',
                    'returnValue', 'screenX', 'screenY', 'shiftKey',
                    'x', 'y'
                    );

//  ------------------------------------------------------------------------

/*
 * Unused
 *
TP.sys.$namednodemapkeys = TP.ac(
                    'length'
                    );
 */

//  ------------------------------------------------------------------------

TP.sys.$nodekeys = TP.ac(
                    'localName', 'namespaceURI', 'nodeName', 'nodeType',
                    'nodeValue', 'prefix'
                    );

//  ------------------------------------------------------------------------

/*
 * Unused
 *
TP.sys.$nodelistkeys = TP.ac(
                    'length'
                    );
 */

//  ------------------------------------------------------------------------

TP.sys.$stringkeys = TP.ac(
                    'length'
                    );

//  ------------------------------------------------------------------------

TP.sys.$windowkeys = TP.ac(
                    'closed', 'document',
                    'innerHeight', 'innerWidth', 'length',
                    'name',
                    'outerHeight', 'outerWidth',
                    'pageXOffset', 'pageYOffset',
                    'screenX', 'screenY',
                    'scrollMaxX', 'scrollMaxY',
                    'scrollX', 'scrollY'
                    );

//  ------------------------------------------------------------------------

/*
 * Unused
 *
TP.sys.$xhrkeys = TP.ac(
                    'status', 'responseXML', 'responseText'
                    );
 */

//  ------------------------------------------------------------------------

TP.definePrimitive('objectGetKeys',
function(anObject) {

    /**
     * @method objectGetKeys
     * @summary Returns an Array of the 'own keys' for the supplied object.
     *     Essentially Object.keys, but with a try/catch fallback.
     * @param {Object} anObject The object to obtain the keys for.
     * @returns {String[]} An Array of the supplied Object's own keys.
     */

    var keys;

    if (anObject === null || anObject === undefined) {
        return [];
    }

    keys = Object.keys(anObject);

    return keys;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$getOwnKeys',
function(anObject, internals) {

    /**
     * @method $getOwnKeys
     * @summary Returns an Array of the 'own keys' for the supplied object.
     *     These are keys for which the object has a unique value.
     * @param {Object} anObject The object to obtain the keys for.
     * @param {Boolean} [internals=false] Should internal slots be returned as
     *     well?
     * @returns {String[]} An Array of the supplied Object's own keys.
     */

    var keys,
        len,
        ownKeys,
        i;

    //  Object.keys is fastest, but doesn't always cooperate.
    keys = TP.objectGetKeys(anObject);

    len = keys.getSize();
    ownKeys = TP.ac();

    for (i = 0; i < len; i++) {
        if (anObject === TP.ObjectProto && TP.$$isDNU(anObject[keys.at(i)])) {
            continue;
        }

        if (internals !== true && TP.regex.INTERNAL_SLOT.test(keys.at(i))) {
            continue;
        }

        ownKeys.push(keys.at(i));
    }

    return ownKeys;
});

//  ------------------------------------------------------------------------

//  For now, we alias 'keys()' over to '$getOwnKeys()' - it will be replaced
//  later
TP.keys = TP.$getOwnKeys;

//  ------------------------------------------------------------------------

TP.definePrimitive('objectHasKey',
function(anObject, aKey) {

    /**
     * @method objectHasKey
     * @summary Returns true if the object has the key provided.
     * @param {Object} anObject The object to test.
     * @param {String} aKey The key name to check.
     * @returns {Boolean} True if the slot exists.
     */

    if (TP.isEmpty(aKey)) {
        return false;
    }

    if (TP.canInvoke(anObject, 'hasKey')) {
        return anObject.hasKey(aKey);
    }

    if (TP.canInvoke(anObject, 'hasOwnProperty')) {
        return anObject.hasOwnProperty(aKey);
    }

    try {
        return anObject[aKey] !== undefined;
    } catch (e) {
        return false;
    }
});

//  ------------------------------------------------------------------------
//  STRING REPRESENTATION
//  ------------------------------------------------------------------------

//  This will be replaced later in the loading process, but is used below.
TP.str = TP.RETURN_TOSTRING;

TP.defineMetaInstMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns the receiver as a human-readable string. This is the
     *     preferred low-level method to use on TIBET to acquire a presentable
     *     string representation of an object. The default output from toString
     *     in TIBET is the object's OID so that objects can properly be used in
     *     Object keys etc.
     * @description The typical implementation of asString is to return the same
     *     value as toString() for objects which can respond, however a number
     *     of types override asString to provide a more human-readable string.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the object's String representation. The default is true.
     * @example Get the string representation of an object:
     *     <code>
     *          'hi'.asString();
     *          <samp>hi</samp>
     *          (42).asString();
     *          <samp>42</samp>
     *          true.asString();
     *          <samp>true</samp>
     *          TP.ac(1, 2, 3).asString();
     *          <samp>[1, 2, 3]</samp>
     *          TP.hc('lname', 'Smith', 'fname', 'Harry').asString();
     *          <samp>"fname" => "Harry", "lname" => "Smith"</samp>
     *     </code>
     * @returns {String} The receiver's default String representation.
     */

    var wantsVerbose,
        marker,
        arr,
        keys,
        len,
        i,
        str;

    wantsVerbose = TP.ifInvalid(verbose, true);

    if (TP.isWindow(this)) {
        if (wantsVerbose) {
            return TP.windowAsString(this);
        } else {
            return TP.gid(this);
        }
    }

    //  Avoid circular reference errors.
    if (this === TP) {
        return 'TP';
    }

    if (!wantsVerbose) {
        return TP.objectToString(this);
    }

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }

    //  NB: For 'Object', we put this in a try...catch since some native Objects
    //  (i.e. XHR objects) don't like to have slots placed on them.
    try {
        this[marker] = true;
    } catch (e) {
        void 0;
    }

    /* eslint-disable no-array-constructor */
    arr = new Array();
    /* eslint-enable no-array-constructor */

    try {
        keys = TP.keys(this);
        len = keys.length;

        for (i = 0; i < len; i++) {
            arr.push(keys[i] + ': ' + TP.str(this[keys[i]], false));
        }

        str = arr.join(', ');
    } catch (e) {
        str = this.toString();
    } finally {
        try {
            delete this[marker];
        } catch (e) {
            void 0;
        }
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.ArrayProto.asString = TP.RETURN_TOSTRING;
TP.BooleanProto.asString = TP.RETURN_TOSTRING;
TP.DateProto.asString = TP.RETURN_TOSTRING;
TP.FunctionProto.asString = TP.RETURN_TOSTRING;
TP.NumberProto.asString = TP.RETURN_TOSTRING;
TP.RegExpProto.asString = TP.RETURN_TOSTRING;
TP.StringProto.asString = TP.RETURN_TOSTRING;

//  ------------------------------------------------------------------------
//  STRING BASICS
//  ------------------------------------------------------------------------

String.Inst.defineMethod('pad',
function(aSize, aChar, aSide) {

    /**
     * @method pad
     * @summary Right or left pads the string with the character provided to
     *     the size specified. Typically used to pad numbers with 0's for
     *     logging etc.
     * @param {Number} aSize The desired result size.
     * @param {String} aChar The character to use. Default is TP.DEFAULT_STRPAD.
     * @param {String} aSide TP.LEFT or TP.RIGHT.The side of the decimal point
     *     to pad. Default is TP.LEFT.
     * @example Pad a string out to 5 characters, on the left, with space
     *     characters:
     *     <code>
     *          '12'.pad(5);
     *          <samp> 12</samp>
     *     </code>
     * @example Pad a string out to 5 characters, on the right, with space
     *     characters:
     *     <code>
     *          '12'.pad(5, null, TP.RIGHT);
     *          <samp>12 </samp>
     *     </code>
     * @example Pad a string out to 4 characters, on the left, with '0'
     *     characters:
     *     <code>
     *          '12'.pad(4, '0');
     *          <samp>0012</samp>
     *     </code>
     * @example Pad a string out to 4 characters, on the right, with '0'
     *     characters:
     *     <code>
     *          '12'.pad(4, '0', TP.RIGHT);
     *          <samp>1200</samp>
     *     </code>
     * @returns {String} The receiver padded out according to the values
     *     supplied.
     * @addon String
     */

    var theSize,

        theChar,
        theSide,

        i,
        count,
        arr;

    theSize = TP.ifInvalid(aSize, 0);
    theSize = Math.max(0, theSize);

    if (this.length >= theSize) {
        //  Make sure to force the conversion to a primitive string.
        return this.toString();
    }

    theChar = TP.ifInvalid(aChar, TP.DEFAULT_STRPAD);
    theSide = TP.ifInvalid(aSide, TP.LEFT);

    arr = TP.ac();
    count = theSize - this.length;

    for (i = 0; i < count; i++) {
        arr[i] = theChar;
    }

    //  Make sure to force the conversion to a primitive string.
    /* eslint-disable no-extra-parens */
    return (theSide === TP.LEFT ?
                arr.join('') + this.toString() :
                this.toString() + arr.join(''));
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

//  ECMA E6 defines 'startsWith', so only install here if it doesn't exist.

if (!TP.isFunction(TP.StringProto.startsWith)) {
    String.Inst.defineMethod('startsWith',
    function(aPrefix, fromIndex) {

        /**
         * @method startsWith
         * @summary Returns true if the receiver begins with the prefix
         *     provided.
         * @param {String} aPrefix A String containing the characters to test.
         * @param {Number} [fromIndex] An optional position to start the search
         *     from.
         * @returns {Boolean} Whether or not the receiver starts with the
         *     supplied index.
         */

        return this.indexOf(aPrefix, fromIndex) === 0;
    });
} else {
    //  Otherwise, just register the builtin.
    String.Inst.defineMethod('startsWith', TP.StringProto.startsWith); // E6
}

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asCamelCase',
function() {

    /**
     * @method asCamelCase
     * @summary Returns a new string with the initial character of each word,
     *     as separated by spaces, hyphens, or underscores in upper case, and
     *     with those characters removed. The first letter of the resulting
     *     string is lower case, so a string starting out as 'background-color'
     *     will become backgroundColor.
     * @returns {String}
     */

    var str,
        up,
        re;

    str = this.toString();
    re = /[-\s_.:]/;
    up = false;

    return str.replace(/./g,
        function(char, index) {
            if (index === 0) {
                return char.toLowerCase();
            }

            //  Word boundary? Flip our flag and return empty string to strip.
            if (re.test(char)) {
                up = true;
                return '';
            }

            if (up) {
                //  If flag is set clear it for next iteration and convert.
                up = false;
                return char.toUpperCase();
            } else if (char === char.toUpperCase()) {
                //  Preserve existing uppercase characters.
                return char;
            } else {
                //  Everything else should default to lowercase.
                return char.toLowerCase();
            }
        });
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asHyphenated',
function() {

    /**
     * @method asHyphenated
     * @summary Returns a new string with each uppercase character in lower
     *     case and a hyphen separating the "words" formerly set off by title
     *     case. This is effectively the inverse of asCamelCase for things like
     *     CSS strings or XForms event names. NOTE that you shouldn't rely on
     *     this method to properly convert CSS, you should use asCSSName or
     *     asDOMName for CSS conversions.
     * @returns {String} The converted string.
     */

    return this.replace(/([A-Z])/g, '-$1').toLowerCase();
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asStartLower',
function() {

    /**
     * @method asStartLower
     * @summary Returns a new string with the initial character in lower case.
     *     No other transformation is performed.
     * @returns {String}
     */

    return this[0].toLowerCase() + this.substring(1);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asStartUpper',
function() {

    /**
     * @method asStartUpper
     * @summary Returns a new string with the initial character in upper case.
     *     No other transformation is performed.
     * @returns {String}
     */

    //  We have a primitive for this (used internally by TIBET for speed).
    return TP.makeStartUpper(this);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asTitleCase',
function() {

    /**
     * @method asTitleCase
     * @summary Returns a new string with the initial character of each word,
     *     as separated by spaces (' '), underscores ('_') or hyphens ('-')
     *     in upper case. No other transformation is performed. Note that this
     *     method *will always* upper case the first character.
     * @returns {String}
     */

    var str;

    str = this.toString();
    TP.regex.TITLE_CASE.lastIndex = 0;

    if (!TP.regex.TITLE_CASE.test(str)) {
        return TP.makeStartUpper(str);
    }

    return TP.makeStartUpper(
                str.replace(
                TP.regex.TITLE_CASE,
                function(whole, part) {

                    return part.toUpperCase();
                }));
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asUnderscored',
function() {

    /**
     * @method asUnderscored
     * @summary Returns a new string with each uppercase character in lower
     *     case and an underscore separating the "words" formerly set off by
     *     title case. This is effectively the inverse of asCamelCase, but using
     *     underscore rather than hyphen, which effectively "Rubyizes" strings,
     *     i.e. toString => to_string.
     * @returns {String} The converted string.
     */

    return this.replace(/([A-Z])/g,
                    function(whole, part) {

                        return '_' + part.toLowerCase();
                    });
});

//  ------------------------------------------------------------------------

TP.definePrimitive('trim',
function(aString) {

    /**
     * @method trim
     * @summary Returns a new string with the contents of the receiver after
     *     having stripped leading and trailing whitespace.
     * @param {String} aString The string to be trimmed.
     * @returns {String} A string having the contents of the receiver with
     *     leading and trailing whitespace removed.
     */

    if (TP.isString(aString) && TP.regex.WHITESPACE.test(aString)) {
        return aString.trim();
    }

    return aString;
});

//  ------------------------------------------------------------------------
//  TIMESTAMPING
//  ------------------------------------------------------------------------

/*
A number of TIBET methods rely on timestamping such as logging etc. We
install a common TS generation method here to support those operations.
*/

Date.Inst.defineMethod('asTimestamp',
function(includeDate, includeMillis, includeNonNum) {

    /**
     * @method asTimestamp
     * @summary Returns the date as a timestamp. A string of the form
     *     [CCYYMMDDT]hh:mm:ss[.mmm] which is suitable for sorting timestamped
     *     output etc. The default form is essentially an ISO8601 format with
     *     milliseconds.
     * @param {Boolean} includeDate Include CCYYMMDD? The default is true.
     * @param {Boolean} includeMillis Include milliseconds? The default is true.
     * @param {Boolean} includeNonNum Include non-numeric values ('T' and
     *     punctuation)? The default is true.
     * @example Print a Date object as a timestamp, with all printing options
     *     turned on:
     *     <code>
     *          TP.dc().asTimestamp();
     *          <samp>20070327T14:28:30.945</samp>
     *     </code>
     * @example Print a Date object as a timestamp, but don't print the 'date'
     *     portion, only the time portion:
     *     <code>
     *          TP.dc().asTimestamp(false);
     *          <samp>14:28:30.945</samp>
     *     </code>
     * @example Print a Date object as a timestamp, but don't print the 'date'
     *     portion, only the time portion (but without the millisecond count):
     *     <code>
     *          TP.dc().asTimestamp(false, false);
     *          <samp>14:28:30</samp>
     *     </code>
     * @example Print a Date object as a timestamp, but don't print the 'date'
     *     portion, only the time portion (but without the millisecond count or
     *     the punctuation):
     *     <code>
     *          TP.dc().asTimestamp(false, false, false);
     *          <samp>142830</samp>
     *     </code>
     * @returns {String} The receiver represented in a timestamp format.
     * @addon Date
     */

    var str,
        padding,
        wantsDate,
        wantsMillis;

    padding = TP.DEFAULT_NUMPAD;

    wantsDate = TP.isBoolean(includeDate) ? includeDate : true;
    wantsMillis = TP.isBoolean(includeMillis) ? includeMillis : true;

    str = wantsDate ? this.getFullYear().toString().pad(4, padding) +
                        (this.getMonth() + 1).toString().pad(2, padding) +
                        this.getDate().toString().pad(2, padding) +
                        'T' : '';

    str = str + this.getHours().toString().pad(2, padding) + ':' +
            this.getMinutes().toString().pad(2, padding) + ':' +
            this.getSeconds().toString().pad(2, padding);

    if (wantsMillis) {
        str = str + '.' + this.getMilliseconds().toString().pad(3, padding);
    }

    if (TP.isFalse(includeNonNum)) {
        return str.strip(/[^0-9]/g);
    } else {
        return str;
    }
});

//  ------------------------------------------------------------------------
//  NOTIFICATION - PART I
//  ------------------------------------------------------------------------

/**
 * TIBET provides comprehensive support for state change notification across all
 * object types through the use of a common signaling subsystem. Here we put
 * some limiters and a common change notification method in place.
 */

//  ------------------------------------------------------------------------

//  stub for early calls, replaced later in kernel

TP.defineMetaInstMethod('changed',
function(anAspect, anAction, aDescription) {

    /**
     * @method changed
     * @summary Notifies observers that some aspect of the receiver has
     *     changed. The fundamental data-driven dependency method.
     * @description If 'anAspect' is provided then the signal fired will be
     *     'aspectChange' where 'aspect' is replaced with the title-case aspect
     *     value. For example, if the aspect is 'lastname' the signal will be:
     *
     *     LastnameChange
     *
     *     This allows observers to be very discriminating in their
     *     observations...down to a specific slot on an object rather than the
     *     entire object. When the aspect is a number the signal name is
     *     prefixed with 'Index' so an aspect of 1 would result in an
     *     Index1Change signal.
     *
     *     NOTE: if the receiver's shouldSignalChange() method returns false
     *     this method won't fire a signal. This helps to avoid signaling when
     *     no listeners are present. See the shouldSignalChange() method for
     *     more information. Observation of an object for any signal name
     *     containing 'Change' will activate this flag.
     * @param {String} anAspect The aspect of the receiver that changed. This is
     *     usually an attribute name.
     * @param {String} anAction The action which caused the change. This usually
     *     'add', 'remove', etc.
     * @param {TP.core.Hash} aDescription A hash describing details of the
     *     change.
     * @returns {Object} The receiver.
     * @fires Change
     */

    //  This early version does nothing.
    return this;
});

//  ------------------------------------------------------------------------

(function() {
    var func;

    func = function(aFlag) {

        /**
         * @method shouldSignalChange
         * @summary Defines whether the receiver should actively signal change
         *     notifications.
         * @description In general objects do not signal changes when no
         *     observers exist. This flag is triggered by observe where the
         *     signal being observed is a form of Change signal to "arm" the
         *     object for change notification. You can also manipulate it during
         *     multi-step manipulations to signal only when a series of changes
         *     has been completed.
         * @param {Boolean} aFlag true/false signaling status.
         * @example Signal changes from an object, even though there are no
         *     listeners:
         *     <code>
         *          myArr = TP.ac();
         *          myArr.shouldSignalChange(true);
         *          myArr.add(1, 2, 3);
         *          <samp>1, 2, 3</samp>
         *          // If change signal logging is on, you'll also see
         *          // something like:
         *          <var>TP.sig.ValueChange@Array_1119524bba7cc3127febfb45</var>
         *     </code>
         * @returns {Boolean} The current status.
         */

        //  Note we can't do 'if (flag)' here because of its Boolean nature.
        if (arguments.length) {
            this.$$shouldSignal = aFlag;
        }

        //  when suspended is true we always return false which allows an
        //  override to succeed
        if (this.$suspended === true) {
            return false;
        }

        return this.$$shouldSignal;
    };

    //  ---

    //  Add this as a 'meta instance method' to all of the objects managed by
    //  meta-methods.
    TP.defineMetaInstMethod('shouldSignalChange', func);

    //  Now add this as a 'local method' to 'TP' and 'TP.sys'. We do this 'the
    //  old-fashioned way' so as to not reset owner and track information.
    TP.shouldSignalChange = func;
    TP.sys.shouldSignalChange = func;
}());

//  ------------------------------------------------------------------------

(function() {

    TP.META_TYPE_OWNER.getMethod =
    function(aName, aTrack) {

        /**
         * @method getMethod
         * @summary Returns the named method, if it exists.
         * @param {String} aName The method name to locate.
         * @param {String} aTrack The track to locate the method on. This is an
         *     optional parameter.
         * @returns {Function} The Function object representing the method.
         */

        var method;

        method = this[aName];
        if (TP.isFunction(method)) {
            return method;
        }

        switch (aTrack) {
            case TP.META_TYPE_TRACK:
                method = this.meta_methods[aName];
                break;
            case TP.TYPE_TRACK:
                method = this.meta_methods[aName];
                break;
            default:
                method = this.meta_methods[aName];
                break;
        }

        if (TP.isFunction(method)) {
            return method;
        }

        return null;
    };

    TP.META_INST_OWNER.getMethod =
    function(aName, aTrack) {

        /**
         * @method getMethod
         * @summary Returns the named method, if it exists.
         * @param {String} aName The method name to locate.
         * @param {String} aTrack The track to locate the method on. This is an
         *     optional parameter.
         * @returns {Function} The Function object representing the method.
         */

        var method;

        method = this[aName];
        if (TP.isFunction(method)) {
            return method;
        }

        switch (aTrack) {
            case TP.META_INST_TRACK:
                method = this.meta_methods[aName];
                break;
            case TP.INST_TRACK:
                method = this.meta_methods[aName];
                break;
            default:
                method = this.common_methods[aName];
                if (TP.isFunction(method)) {
                    return method;
                }
                method = this.meta_methods[aName];
                break;
        }

        if (TP.isFunction(method)) {
            return method;
        }

        return null;
    };

}());

//  ------------------------------------------------------------------------
//  CONTENT CACHE CONTROL
//  ------------------------------------------------------------------------

/*
TIBET caches content representations for performance. These caches can be
cleared so that they rebuild on the next use for each URI using the
TP.sys.expireContentCaches() call.
*/

//  ------------------------------------------------------------------------

TP.sys.defineMethod('expireContentCaches',
function(aFlag) {

    /**
     * @method expireContentCaches
     * @summary When true, TIBET will invalidate all caches used during content
     *     processing. This will cause new calls to get content data to rebuild
     *     their file caches lazily.
     * @description This method has a similar interface to the should* calls
     *     however since it acts only at the time it's called we use a little
     *     different naming convention to help clarify that it's different from
     *     the control flag methods.
     * @param {Boolean} aFlag Expire now or just return last expiration time?
     * @returns {Date} Last expiration time.
     */

    if (TP.isTrue(aFlag)) {
        this.$$contentExpiration = 0;
    }

    return this.$$contentExpiration;
});

//  ------------------------------------------------------------------------
//  CONTROL FLAG METHODS
//  ------------------------------------------------------------------------

/**
 * TIBET operational flags.
 *
 * All of TIBET's control flag methods follow a combo-setter/getter pattern.
 * Each function is named with the convention should*something*(). If passed
 * a value the function works as a setter. In all cases the return value is
 * whatever the current value is so they always work like getters as well.
 * This convention makes for a nice readable syntax as in:
 *
 * if (TP.sys.shouldLogIO()) { // do what we should };
 *
 * or
 *
 * TP.sys.shouldLogIO(true);
 *
 * Internal to these methods we use TIBET's $set() function, one of our
 * encapsulation primitives, which will signal change notification when the
 * underlying value is altered. This allows the control flags to be altered
 * so that UI such as the TIBET IDE can track their changes visibly.
 */

//  ------------------------------------------------------------------------

//  stub for early calls, replaced later in kernel

//  Add this as a 'meta instance method' to all of the objects managed by
//  meta-methods.
(function() {
    var func;

    func = function(attributeName) {

        /**
         * @method $get
         * @summary The most primitive wrapper for attribute retrieval. This
         *     method is supplied to allow overriding of the primitive operation
         *     aspects of 'get' and to provide true getters with a way to access
         *     the low-level slot without any recursion. As with other accessors
         *     this method ignores DNUs.
         * @param {String} attributeName The name of the particular attribute.
         * @returns {Object} The value contained in the named attribute on the
         *     receiver.
         */

        return this[attributeName];
    };

    //  ---

    //  Add this as a 'meta instance method' to all of the objects managed by
    //  meta-methods.
    TP.defineMetaInstMethod('$get', func);

    //  Now add this as a 'local method' to 'TP' and 'TP.sys'. We do this 'the
    //  old-fashioned way' so as to not reset owner and track information.
    TP.$get = func;
    TP.sys.$get = func;
}());

//  ------------------------------------------------------------------------

//  stub for early calls, replaced later in kernel

//  Add it as a 'meta inst method' to all of the objects managed by
//  meta-methods.
(function() {
    var func;

    func = function(attributeName, attributeValue) {

        /**
         * @method $set
         * @summary Assigns the value attributeValue to the storage location
         *     for attributeName. Later in the kernel a version of $set is
         *     installed that manages change notification etc. We stub in to
         *     cover the case where a config method may be called prior to that
         *     during bootup.
         * @param {String} attributeName The slot name to receive data.
         * @param {Object} attributeValue The value to assign.
         * @returns {Object} The receiver.
         * @addon Object
         */

        //  NOTE this version doesn't notify, later versions replace this one
        //  to provide that functionality once the kernel has loaded
        this[attributeName] = attributeValue;

        return this;
    };

    //  ---

    //  Add this as a 'meta instance method' to all of the objects managed by
    //  meta-methods.
    TP.defineMetaInstMethod('$set', func);

    //  Now add this as a 'local method' to 'TP' and 'TP.sys'. We do this 'the
    //  old-fashioned way' so as to not reset owner and track information.
    TP.$set = func;
    TP.sys.$set = func;
}());

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldAllowDuplicateInterests',
function(aFlag, shouldSignal) {

    /**
     * @method shouldAllowDuplicateInterests
     * @summary Controls and returns the state of TIBET's interest duplicate
     *     check flag. When set to true TIBET will allow multiple registrations
     *     of the same handler ID for the same origin and signal type pair. When
     *     false TIBET will log this condition with a warning. The default is
     *     false.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to allow duplicate interests:
     *     <code>
     *          TP.sys.shouldAllowDuplicateInterests(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET allows duplicate entries in the
     *     system signal map.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('signal.duplicate_interests', aFlag, shouldSignal);
    }

    return TP.sys.cfg('signal.duplicate_interests');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('$$shouldCacheDeepSubtypes',
function(aFlag) {

    /**
     * @method $$shouldCacheDeepSubtypes
     * @summary Controls and returns the state of the 'deep subtype cache'
     *     flag. When true TIBET will cache the values build from getting deep
     *     lists of subtypes. Normally true.
     * @param {Boolean} aFlag Turn behavior on or off? Default is true.
     * @example Configure TIBET to not cache deep subtype data:
     *     <code>
     *          TP.sys.$$shouldCacheDeepSubtypes(false);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET caches deep subtype data.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('oo.$$cache_deep_subtypes', aFlag, false);
    }

    return TP.sys.cfg('oo.$$cache_deep_subtypes');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldCaptureErrors',
function(aFlag, shouldSignal) {

    /**
     * @method shouldCaptureErrors
     * @summary Controls and returns the value of the error forwarding flag.
     * @description This flag determines whether errors caught by TIBET should
     *     be forwarded to the native JS error handling system. If so, the
     *     browser's native handling will execute. Note that certain
     *     browser/debugger tools ignore this so this flag may have no effect.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to capture errors:
     *     <code>
     *          TP.sys.shouldCaptureErrors(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET captures native JS errors via the
     *     onerror hook.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('debug.capture_errors', aFlag, shouldSignal);
    }

    return TP.sys.cfg('debug.capture_errors');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldEmbedProgress',
function(aFlag, shouldSignal) {

    /**
     * @method shouldEmbedProgress
     * @summary Controls and returns the value of the progress format flag.
     * @description This flag determines whether progress messages will be
     *     embedded in the page or via TIBET's notify call. Default is true.
     * @param {Boolean} aFlag Turn behavior on or off? Default is true.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to not embed progress messages:
     *     <code>
     *          TP.sys.shouldEmbedProgress(false);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET embeds progress messages.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('progress.embed', aFlag, shouldSignal);
    }

    return TP.sys.cfg('progress.embed');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldIgnoreViaFlag',
function(aFlag, shouldSignal) {

    /**
     * @method shouldIgnoreViaFlag
     * @summary Controls and returns TIBET's signal interest removal flag.
     * @description When this flag is true, signal interests are removed from
     *     the signal map by simply flagging them. When this flag is false the
     *     interest is removed completely. Useful for debugging and tuning
     *     performance.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to remove signal interests from the map by
     *     flagging them:
     *     <code>
     *          TP.sys.shouldIgnoreViaFlag(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET removes interests by flagging
     *     them.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('signal.ignore_via_flag', aFlag, shouldSignal);
    }

    return TP.sys.cfg('signal.ignore_via_flag');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('$$shouldInvokeInferences',
function(aFlag, shouldSignal) {

    /**
     * @method $$shouldInvokeInferences
     * @summary Controls and returns the state of TIBET's 'invoke inferences'
     *     flag.
     * @description This flag tells TIBET whether inferences made should be
     *     actually executed. This can potentially be turned off so you see what
     *     TIBET would have done, without actually doing it, but in practice
     *     it's normally left on.
     * @param {Boolean} aFlag Turn behavior on or off? Default is true.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to not invoke the inferencing engine:
     *     <code>
     *          TP.sys.$$shouldInvokeInferences(false);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET should use the inferencer if it
     *     can't resolve a method through 'normal' means.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('oo.$$invoke_inferences', aFlag, shouldSignal);
    }

    return TP.sys.cfg('oo.$$invoke_inferences');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogActivities',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogActivities
     * @summary Controls and returns the state of the 'log activity' flag.
     * @description This flag determines whether calls to log actually log. Note
     *     that turning on other log status flags won't automatically turn on
     *     the log activity flag. The activity log is the 'meta log' capturing
     *     log data from all the other TIBET logs and providing support for
     *     DEBUG, INFO, and SYSTEM messaging. Note that the logging level may
     *     also affect output.
     * @param {Boolean} aFlag Turn behavior on or off? Default is true.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to not log activities:
     *     <code>
     *          TP.sys.shouldLogActivities(false);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs all 'activities' in the
     *     system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.activities', aFlag, shouldSignal || false);
    }

    return TP.sys.cfg('log.activities');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogConsoleSignals',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogConsoleSignals
     * @summary Controls and returns the state of TIBET's 'log console signals'
     *     flag.
     * @description When true, and when TP.sys.shouldLogSignals() is true, this
     *     flag will cause TIBET to log console signals such as
     *     TP.sig.UserInput/OutputRequests, TP.sig.ConsoleRequest/Response, etc.
     *     which can be obtrusive when running the TIBET console. The default
     *     value is false.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log console signals:
     *     <code>
     *          TP.sys.shouldLogConsoleSignals(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs console signals.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.console_signals', aFlag, shouldSignal);
    }

    return TP.sys.cfg('log.console_signals');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogCSS',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogCSS
     * @summary Controls and returns the state of the CSS logging flag.
     * @description When true TIBET will output CSS debugging data.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log CSS debugging data:
     *     <code>
     *          TP.sys.shouldLogCSS(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs IO activities in the system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.css_processing', aFlag, shouldSignal);
    }

    return TP.sys.cfg('log.css_processing');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogDOMFocusSignals',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogDOMFocusSignals
     * @summary Controls and returns the state of the DOM focus logging flag.
     * @description When true, and when TP.sys.shouldLogSignals() is true, this
     *     flag will cause TIBET to log DOMFocus, DOMBlur, DOMFocusIn and
     *     DOMFocusOut events. Since these happen with most operations this
     *     value is false by default.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log DOM focus signals:
     *     <code>
     *          TP.sys.shouldLogDOMFocusSignals(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs DOM focus in the system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.dom_focus_signals', aFlag, shouldSignal);
    }

    return TP.sys.cfg('log.dom_focus_signals');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogDOMLoadedSignals',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogDOMLoadedSignals
     * @summary Controls and returns the state of the DOMLoaded logging flag.
     * @description When true, and when TP.sys.shouldLogSignals() is true, this
     *     flag will cause TIBET to log element-level DOMLoaded events. Since
     *     these happen with most operations this value is false by default.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log DOMLoaded signals:
     *     <code>
     *          TP.sys.shouldLogDOMLoadedSignals(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs DOMLoaded signals.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.dom_loaded_signals', aFlag, shouldSignal);
    }

    return TP.sys.cfg('log.dom_loaded_signals');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogErrors',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogErrors
     * @summary Controls and returns the value of the error log flag.
     * @description This flag determines whether calls to log warnings and
     *     errors of any level of severity actually write entries to the error
     *     log. Note that the logging level may also affect output.
     * @param {Boolean} aFlag Turn behavior on or off? Default is true.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to not log errors:
     *     <code>
     *          TP.sys.shouldLogErrors(false);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs errors in the system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.errors', aFlag, shouldSignal || false);
    }

    return TP.sys.cfg('log.errors');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogInferences',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogInferences
     * @summary Controls and returns the state of TIBET's 'log inferences'
     *     flag.
     * @description This tells TIBET whether inferences made should be logged.
     *     Turning this flag on can help you tune TIBET for better runtime
     *     performance by showing you which methods might benefit from a
     *     concrete implementation rather than being inferred. It should be off
     *     for production systems.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log inferencer activity:
     *     <code>
     *          TP.sys.shouldLogInferences(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs inferences in the system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.inferences', aFlag, shouldSignal || false);
    }

    return TP.sys.cfg('log.inferences');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogIO',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogIO
     * @summary Controls and returns the state of the IO logging flag.
     * @description This flag tells TIBET whether to log calls to the IO
     *     subsystem. When the uri and http primitives operate they can log
     *     their activity to TIBET's IO log.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log IO (file and http) activity:
     *     <code>
     *          TP.sys.shouldLogIO(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs IO activities in the system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.io', aFlag, shouldSignal || false);
    }

    return TP.sys.cfg('log.io');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogJobs',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogJobs
     * @summary Controls and returns the state of the job logging flag.
     * @description When this flag is true and the job system runs a job it will
     *     log start, step, and stop times for review.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log job activity:
     *     <code>
     *          TP.sys.shouldLogJobs(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs IO activities in the system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.jobs', aFlag, shouldSignal || false);
    }

    return TP.sys.cfg('log.jobs');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogKeys',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogKeys
     * @summary Controls and returns the state of TIBET's key logging flag.
     * @description When this flag is true any keyboard event handlers armed
     *     with the standard TIBET event handler will log key events. This is
     *     useful for gathering keycode information from a keyboard.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log keyboard event activity:
     *     <code>
     *          TP.sys.shouldLogKeys(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs key events in the system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.keys', aFlag, shouldSignal);
    }

    return TP.sys.cfg('log.keys');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogLinks',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogLinks
     * @summary Controls and returns the state of TIBET's link logging flag.
     * @description This flag controls whether instrumented links will log their
     *     activation to the TIBET log.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log link activation activity:
     *     <code>
     *          TP.sys.shouldLogLinks(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs link activation in the
     *     system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.links', aFlag, shouldSignal);
    }

    return TP.sys.cfg('log.links');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogLoadSignals',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogLoadSignals
     * @summary Controls and returns the state of TIBET's 'log load signals'
     *     flag.
     * @description This flags tells TIBET whether, when the signaling machinery
     *     is invoked prior to installation of the full signaling system, TIBET
     *     should log such signals.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log load signals:
     *     <code>
     *          TP.sys.shouldLogLoadSignals(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs load signals in the system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.load_signals', aFlag, shouldSignal);
    }

    return TP.sys.cfg('log.load_signals');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogMouse',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogMouse
     * @summary Controls and returns the state of TIBET's mouse logging flag.
     * @description When this flag is true any mouse event handlers armed
     *     with the standard TIBET event handler will log mouse events.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log mouse event activity:
     *     <code>
     *          TP.sys.shouldLogMouse(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs mouse events in the system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.mouse', aFlag, shouldSignal);
    }

    return TP.sys.cfg('log.mouse');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogNullNamespaces',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogNullNamespaces
     * @summary Controls and returns the state of TIBET's null namespace
     *     logging. Normally used during development to help detect when a
     *     namespace declaration may be missing.
     * @description Mozilla will, at least in older versions, move elements
     *     whose prefixes don't match declared namespaces, to the null
     *     namespace. This flag controls whether TIBET checks for that and logs
     *     any element names found that match.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log null namespace notifications:
     *     <code>
     *          TP.sys.shouldLogNullNamespaces(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs null namespace in the
     *     system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.null_namespaces', aFlag, shouldSignal);
    }

    return TP.sys.cfg('log.null_namespaces');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogRaise',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogRaise
     * @summary Controls and returns the value of the raise log flag.
     * @description This flag determines whether calls to raise should invoke
     *     log*() based on the incoming exception type. Usually you want this
     *     set to true.
     * @param {Boolean} aFlag Turn behavior on or off? Default is true.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to not log exception raises:
     *     <code>
     *          TP.sys.shouldLogRaise(false);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs exception raises in the
     *     system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.raise', aFlag, shouldSignal || false);
    }

    return TP.sys.cfg('log.raise');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogRequestSignals',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogRequestSignals
     * @summary Controls and returns the state of TIBET's 'log request signals'
     *     flag.
     * @description When true, and when TP.sys.shouldLogSignals() is true, this
     *     flag will cause TIBET to log request signals such as RequestCompleted
     *     which can be obtrusive when running the TIBET console. The default
     *     value is false.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log request signals:
     *     <code>
     *          TP.sys.shouldLogRequestSignals(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs request signals.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.request_signals', aFlag, shouldSignal);
    }

    return TP.sys.cfg('log.request_signals');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogSecurity',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogSecurity
     * @summary Controls and returns the state of TIBET's 'log security' flag.
     * @description This flag tells TIBET whether permission requests and other
     *     aspects of security-related information should be logged. The default
     *     is true.
     * @param {Boolean} aFlag Turn behavior on or off? Default is true.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log security-related events:
     *     <code>
     *          TP.sys.shouldLogSecurity(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs security events.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.security', aFlag, shouldSignal);
    }

    return TP.sys.cfg('log.security');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogSignals',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogSignals
     * @summary Controls and returns the state of TIBET's 'log signals' flag.
     * @description Given TIBET's heavy use of signaling this can generate a LOT
     *     of output. At the same time, it can be a critical debugging aid,
     *     particularly with respect to workflow and UI event tracing.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log signals:
     *     <code>
     *          TP.sys.shouldLogSignals(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs all signals in the system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.signals', aFlag, shouldSignal || false);
    }

    return TP.sys.cfg('log.signals');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogSignalStack',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogSignalStack
     * @summary Controls and returns the state of TIBET's 'log signal stack'
     *     flag.
     * @description This flag tells TIBET whether, when the signaling machinery
     *     is invoked, it should log signal stack traces, which helps identify
     *     where a signal has originated from.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log the signal stack traces:
     *     <code>
     *          TP.sys.shouldLogSignalStack(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs signal stack traces in the
     *     system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.signal_stack', aFlag, shouldSignal || false);
    }

    return TP.sys.cfg('log.signal_stack');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogStack',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogStack
     * @summary Controls and returns the value of the error log stack flag.
     * @description This flag determines whether the call stack should be
     *     written when logging errors. This generates a LOT of output,
     *     particularly if signal logging is also on. Be prepared :).
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log the error stack:
     *     <code>
     *          TP.sys.shouldLogStack(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs the call stack when logging
     *     errors in the system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.stack', aFlag, shouldSignal || false);
    }

    return TP.sys.cfg('log.stack');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogStackFileInfo',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogStackFileInfo
     * @summary Controls and returns the value of the file information stack
     *     flag. When this flag is true TIBET will try to log file information
     *     including name and line number for the functions being logged from
     *     the call stack.
     * @description This flag determines whether the call stack should be
     *     written when logging errors. This generates a LOT of output,
     *     particularly if signal logging is also on. Be prepared :).
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log the error stack:
     *     <code>
     *          TP.sys.shouldLogStackFileInfo(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs the call stack when logging
     *     errors in the system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.stack_file_info', aFlag, shouldSignal);
    }

    return TP.sys.cfg('log.stack_file_info');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogTransforms',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogTransforms
     * @summary Controls and returns the value of the content transform logging
     *     flag.
     * @description This flag determines whether the content processing system
     *     should log tranformation steps. The logging of this data occurs at
     *     DEBUG level so TP.setLogLevel() must be used to set the proper logger
     *     to DEBUG to capture the output in the logs.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log content system transformations:
     *     <code>
     *          TP.sys.shouldLogTransforms(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs tag transforms in the
     *     system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.content_transform', aFlag, shouldSignal);
    }

    return TP.sys.cfg('log.content_transform');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogTSHSignals',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogTSHSignals
     * @summary Controls and returns the state of the TSH signal logging flag.
     * @description This flag tells TIBET whether to log signals related to TSH
     *     processing.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log TSH signal activity:
     *     <code>
     *          TP.sys.shouldLogTSHSignals(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs TSH signal activity in the
     *     system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.tsh_signals', aFlag, shouldSignal || false);
    }

    return TP.sys.cfg('log.tsh_signals');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogUserIOSignals',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogUserIOSignals
     * @summary Controls and returns the state of the User IO logging flag.
     * @description This flag tells TIBET whether to log calls to the User IO
     *     subsystem.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log User IO activity:
     *     <code>
     *          TP.sys.shouldLogUserIOSignals(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs User IO activities in the
     *     system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.user_io_signals',
                        aFlag,
                        shouldSignal || false);
    }

    return TP.sys.cfg('log.user_io_signals');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldLogXPaths',
function(aFlag, shouldSignal) {

    /**
     * @method shouldLogXPaths
     * @summary Controls and returns the value of the XPath query logging flag.
     * @description This flag determines whether XPaths should be output to the
     *     activity log, which can help with performance tuning. The logging of
     *     this data occurs at DEBUG level so TP.setLogLevel() must be used to
     *     set the proper logger to DEBUG to capture the output in the logs.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to log XPath queries:
     *     <code>
     *          TP.sys.shouldLogXPaths(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET logs XPath evaluations in the
     *     system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('log.xpaths', aFlag, shouldSignal);
    }

    return TP.sys.cfg('log.xpaths');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldQueueLoadSignals',
function(aFlag, shouldSignal) {

    /**
     * @method shouldQueueLoadSignals
     * @summary Controls and returns the value of the queue load signal flag.
     * @description This flag defines whether TIBET should queue signals fired
     *     prior to full signaling installation for later processing. This
     *     allows you to see any signals which may have fired during kernel
     *     load.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to queue signals for later full signalling
     *     system processing:
     *     <code>
     *          TP.sys.shouldQueueLoadSignals(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET should queue signals fired during
     *     load for later firing.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('signal.queue_load_signals', aFlag, shouldSignal);
    }

    return TP.sys.cfg('signal.queue_load_signals');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldRegisterLoggers',
function(aFlag, shouldSignal) {

    /**
     * @method shouldRegisterLoggers
     * @summary Controls and returns TIBET's registration policy flag.
     * @description If this flag is true, TIBET will register objects which log
     *     errors. This allows developers to access the objects which have
     *     written to the error log via their OIDs.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to register objects which log errors:
     *     <code>
     *          TP.sys.shouldRegisterLoggers(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET registers objects that log
     *     errors.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('debug.register_loggers', aFlag, shouldSignal);
    }

    return TP.sys.cfg('debug.register_loggers');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldReportParseErrors',
function(aFlag, shouldSignal) {

    /**
     * @method shouldReportParseErrors
     * @summary Controls and returns TIBET's DOM parsing report flag.
     * @description When this flag is true, TIBET forces DOM parse errors to be
     *     reported. This is useful primarily for debugging so the default is
     *     false.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to report DOM parsing errors:
     *     <code>
     *          TP.sys.shouldReportParseErrors(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET forces DOM parser errors to be
     *     reported.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('debug.report_parse_errors', aFlag, shouldSignal);
    }

    return TP.sys.cfg('debug.report_parse_errors');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldRequestPrivileges',
function(aFlag, shouldSignal) {

    /**
     * @method shouldRequestPrivileges
     * @summary Controls and returns TIBET's privilege request flag, which is
     *     used for Mozilla PrivilegeManager access.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to request enhanced security privileges:
     *     <code>
     *          TP.sys.shouldRequestPrivileges(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET requests privileges before
     *     performing certain browser operations.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('security.request_privileges', aFlag, shouldSignal);
    }

    return TP.sys.cfg('security.request_privileges');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldSignalDOMLoaded',
function(aFlag, shouldSignal) {

    /**
     * @method shouldSignalDOMLoaded
     * @summary Controls and returns TIBET's DOMLoaded signal flag.
     * @description If true, TIBET will signal DOMLoaded from page elements
     *     which are having their content updated. NOTE that this flag will have
     *     no effect on DOMLoaded signals thrown from the document level so that
     *     in-page content load listeners will always function.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to signal DOMLoaded from updating page elements:
     *     <code>
     *          TP.sys.shouldSignalDOMLoaded(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET signals DOMLoaded when page
     *     elements are having their content updated.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('signal.dom_loaded', aFlag, shouldSignal);
    }

    return TP.sys.cfg('signal.dom_loaded');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldSignalDOMFocusSignals',
function(aFlag, shouldSignal) {

    /**
     * @method shouldSignalDOMFocusSignals
     * @summary Controls and returns the state of the DOM focus signaling flag.
     *     By turning off DOM focus/blur signaling you have a way to debug other
     *     debug DOM events more effectively.
     * @param {Boolean} aFlag Turn behavior on or off? Default is true.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to stop signaling DOM focus signals:
     *     <code>
     *          TP.sys.shouldSignalDOMFocusSignals(false);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET signals DOM focus/blur.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('signal.dom_focus_signals', aFlag, shouldSignal);
    }

    return TP.sys.cfg('signal.dom_focus_signals');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldThrowEvaluations',
function(aFlag, shouldSignal) {

    /**
     * @method shouldThrowEvaluations
     * @summary Controls and returns the state of TIBET's flag for shell
     *     evaluations.
     * @description When true TIBET will throw native JavaScript errors that
     *     occur in evaluations done in the shell.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to throw native JS Errors when evaluations fail
     *     in the shell:
     *     <code>
     *          TP.sys.shouldThrowEvaluations(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET throws native JS errors when
     *     doing shell evaluations.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('debug.throw_evaluations', aFlag, shouldSignal);
    }

    return TP.sys.cfg('debug.throw_evaluations');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldThrowExceptions',
function(aFlag, shouldSignal) {

    /**
     * @method shouldThrowExceptions
     * @summary Controls and returns the state of TIBET's flag for exception
     *     handling behavior.
     * @description When this flag is true, TIBET will throw native JS Error
     *     objects in response to exception raise calls whose exception
     *     instances aren't handled by an observer. By controlling this flag
     *     effectively TIBET allows you to have an integrated error handling
     *     system that supports lightweight exceptions via TP.sig.Exception
     *     which might be handled, followed by heavyweight try/catch controls.
     * @param {Boolean} aFlag Turn behavior on or off? Default is true.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to not throw native JS Errors when TIBET
     *     exceptions occur:
     *     <code>
     *          TP.sys.shouldThrowExceptions(false);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET throws exceptions using native JS
     *     Error objects.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('debug.throw_exceptions', aFlag, shouldSignal);
    }

    return TP.sys.cfg('debug.throw_exceptions');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldThrowHandlers',
function(aFlag, shouldSignal) {

    /**
     * @method shouldThrowHandlers
     * @summary Controls and returns the state of TIBET's flag for handler
     *     invocation try/catch behavior.
     * @description When this flag is true the system will run event handlers
     *     without a try/catch block.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to throw native JS Errors when errors occur in
     *     event handlers:
     *     <code>
     *          TP.sys.shouldThrowHandlers(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET try/catch protects handler
     *     invocations.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('debug.throw_handlers', aFlag, shouldSignal);
    }

    return TP.sys.cfg('debug.throw_handlers');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldTrackJobStats',
function(aFlag, shouldSignal) {

    /**
     * @method shouldTrackJobStats
     * @summary Controls and returns the state of TIBET's job statistics
     *     gathering.
     * @description When this flag is true (and not overridden by a specific job
     *     instance) jobs will track step and timing information for review.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to track job statistics:
     *     <code>
     *          TP.sys.shouldTrackJobStats(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET keeps track of job performance.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('job.track_stats', aFlag, shouldSignal);
    }

    return TP.sys.cfg('job.track_stats');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldTrackSignalStats',
function(aFlag, shouldSignal) {

    /**
     * @method shouldTrackSignalStats
     * @summary Controls and returns the state of TIBET's signaling statistics
     *     flag. When true TIBET will keep timing data on each signal handler
     *     invocation to help with tuning.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to track signaling statistics:
     *     <code>
     *          TP.sys.shouldTrackSignalStats(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET keeps track of how many objects
     *     got constructed in the system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('signal.track_stats', aFlag, shouldSignal);
    }

    return TP.sys.cfg('signal.track_stats');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldTrapRecursion',
function(aFlag, shouldSignal) {

    /**
     * @method shouldTrapRecursion
     * @summary Controls and returns the flag defining whether TIBET should
     *     enforce its recursion trapping method.
     * @description The TIBET recursion-trapping method, trapRecursion() is
     *     installed in a few locations to help with recursion debugging. While
     *     Mozilla will report endless recursion, it won't show the stack :(.
     *     Using this method helps provide a little more control although
     *     figuring out where to put it can be tricky.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to track trap recursion:
     *     <code>
     *          TP.sys.shouldTrapRecursion(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET will attempt to trap recursive
     *     calls.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('debug.trap_recursion', aFlag, shouldSignal);
    }

    return TP.sys.cfg('debug.trap_recursion');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldUniqueTypes',
function(aFlag, shouldSignal) {

    /**
     * @method shouldUniqueTypes
     * @summary Controls and returns the state of TIBET's type uniquing flag.
     * @description When true TIBET will not recreate types in the defineSubtype
     *     call. The default is true, meaning that when a type is ':source'd in
     *     using the TAP/TDC the original type is not replaced. This can help
     *     with maintaining type attribute state across iterative reloads if the
     *     type is properly defined and it's initialize method preserves
     *     existing data.
     * @param {Boolean} aFlag Turn behavior on or off? Default is true.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to not unique type objects:
     *     <code>
     *          TP.sys.shouldUniqueTypes(false);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET should unique type objects in the
     *     system.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('oo.unique_types', aFlag, shouldSignal);
    }

    return TP.sys.cfg('oo.unique_types');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('$$shouldUseBackstop',
function(aFlag, shouldSignal) {

    /**
     * @method $$shouldUseBackstop
     * @summary Controls and returns the state of TIBET's backstop.
     * @description If this flag is true, TIBET will cause the
     *     'doesNotUnderstand' backstop to be invoked by get() calls which fail
     *     to find a value. The TIBET backstop provides support for 'Proxies',
     *     and the TIBET inferencer so this should normally be true.
     *     NOTE: When first implemented the backstop was an experimental feature
     *     but it's now effectively required. Don't turn this flag off if you
     *     want TIBET to run :).
     * @param {Boolean} aFlag Turn behavior on or off? Default is true.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @returns {Boolean} Whether or not TIBET should use its backstop for
     *     methods that cannot be found.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('oo.$$use_backstop', aFlag, shouldSignal);
    }

    return TP.sys.cfg('oo.$$use_backstop');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldUseContentCheckpoints',
function(aFlag, shouldSignal) {

    /**
     * @method shouldUseContentCheckpoints
     * @summary Controls and returns the state of TIBET's content checkpointing
     *     flag.
     * @description If this flag is true then TIBET's content processing methods
     *     will checkpoint when possible to assist with debugging content
     *     transformations which occur. This allows you to review the content at
     *     each processing phase to see how the transformations are effecting
     *     the content.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to use content processing checkpoints:
     *     <code>
     *          TP.sys.shouldUseContentCheckpoints(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET should checkpoint content.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('content.use_checkpoints', aFlag, shouldSignal);
    }

    return TP.sys.cfg('content.use_checkpoints');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldUseContentCaches',
function(aFlag, shouldSignal) {

    /**
     * @method shouldUseContentCaches
     * @summary Controls and returns the state of the content file cache flag.
     * @description Turning this off will cause content processing to skip using
     *     file-based caches without affecting how they may choose to leverage
     *     memory caching. During development it's often useful to run with
     *     caches off so you work primarily with memory-based caches to avoid
     *     confusion.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to use content processing system file caches:
     *     <code>
     *          TP.sys.shouldUseContentCaches(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET should use file caches.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('content.use_caches', aFlag, shouldSignal);
    }

    return TP.sys.cfg('content.use_caches');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('shouldUseDebugger',
function(aFlag, shouldSignal) {

    /**
     * @method shouldUseDebugger
     * @summary Controls and returns the state of TIBET's 'debugger' flag.
     * @description This flag tells TIBET whether, when an exception is raised,
     *     the debugger hook should be invoked. The default hook will cause
     *     TIBET to stop in any currently running debugger by invoking the
     *     ECMA-defined 'debugger;' keyword. Future versions of TIBET on
     *     Mozilla, for example, may invoke that browser's 'jsdebug' interface
     *     for source-level debugging support.
     * @param {Boolean} aFlag Turn behavior on or off? Default is false.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to invoke the debugger whenever any TIBET
     *     exception occurs:
     *     <code>
     *          TP.sys.shouldUseDebugger(true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET should use the debugger when an
     *     exception is raised.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('debug.use_debugger', aFlag, shouldSignal);
    }

    return TP.sys.cfg('debug.use_debugger');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('$$shouldUseInferencing',
function(aFlag, shouldSignal) {

    /**
     * @method $$shouldUseInferencing
     * @summary Controls and returns the state of TIBET's 'inferencing' flag.
     * @param {Boolean} aFlag Turn behavior on or off? Default is true.
     * @param {Boolean} shouldSignal False to turn off configuration change
     *     signaling for this call.
     * @example Configure TIBET to not use type inferencing to resolve unknown
     *     methods:
     *     <code>
     *          TP.sys.$$shouldUseInferencing(false);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not TIBET should use its inferencer when
     *     methods cannot be found.
     * @discusson This flag tells TIBET whether inferences should be made. Note
     *     that the overall TIBET backstop processing must be active for this
     *     flag to change actual runtime behavior.
     */

    if (TP.isBoolean(aFlag)) {
        TP.sys.setcfg('oo.$$use_inferencing', aFlag, shouldSignal);
    }

    return TP.sys.cfg('oo.$$use_inferencing');
});

//  ------------------------------------------------------------------------
//  VERSION INFO
//  ------------------------------------------------------------------------

TP.sys.defineMethod('getVersionInfo',
function(data, meta) {

    /**
     * @method getVersionInfo
     * @summary Returns the value of the version identification data as a
     *     string. NOTE that the string returned is intended to conform to the
     *     semver specification with optional pre-release and metadata content.
     * @param {Object} data A release data structure. See the version
     *     template file (path.lib_version_template) for more information.
     * @returns {String} The version string identifier.
     */

    var str,
        semver;

    if (TP.notValid(data)) {
        return;
    }

    //  Build a semver-compliant string optionally including pre-release and
    //  meta information when that data is available. Not all releases have it.
    str = '';
    str += TP.ifEmpty(data.major, '0');
    str += '.';
    str += TP.ifEmpty(data.minor, '0');
    str += '.';
    str += TP.ifEmpty(data.patch, '0');

    if (TP.notEmpty(data.suffix)) {
        str += '-';
        str += data.suffix;

        str += '.';
        str += TP.ifEmpty(data.increment, 0);
    }

    semver = data.semver;

    if (TP.isTrue(meta)) {

        if (TP.notEmpty(data.phash)) {
            str += '+g';
            str += data.phash;
        }

        if (TP.notEmpty(data.commits)) {
            if (TP.notEmpty(data.phash)) {
                str += '.';
            } else {
                str += '+';
            }
            str += data.commits;
        }

        if (TP.notEmpty(data.time)) {
            if (TP.notEmpty(data.phash) ||
                    TP.notEmpty(data.commits)) {
                str += '.';
            } else {
                str += '+';
            }
            str += data.time;
        }
    } else {
        semver = semver.split('+')[0];
    }

    //  A sanity check...
    if (str !== semver) {
        //  Hmmm. Computation should be the same.
        TP.error('Version string mismatch. source -> ' + data.semver +
            ' !== ' + str + ' <- computed.');
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getAppVersion',
function(meta) {

    /**
     * @method getAppVersion
     * @summary Returns the application version string as defined by the
     *     getVersionInfo routine.
     * @param {Boolean} meta True to include additional version metadata if
     *     found in the application version info block current registered.
     * @returns {String} The version string identifier.
     */

    return TP.sys.getVersionInfo(TP.sys.$appVersion, meta);
});

/*
 * Set up a getter for the appVersion used in certain templates.
 */
TP.sys.installSystemPropertyGetter(TP.env, 'appVersion',
function() {
    return TP.sys.getAppVersion();
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getLibVersion',
function(meta) {

    /**
     * @method getAppVersion
     * @summary Returns the application version string as defined by the
     *     getVersionInfo routine.
     * @param {Boolean} meta True to include additional version metadata if
     *     found in the application version info block current registered.
     * @returns {String} The version string identifier.
     */

    return TP.sys.getVersionInfo(TP.sys.$libVersion, meta);
});

/*
 * Set up a getter for the libVersion used in certain templates.
 */
TP.sys.installSystemPropertyGetter(TP.env, 'libVersion',
function() {
    return TP.sys.getLibVersion();
});

//  ------------------------------------------------------------------------
//  GLOBAL STATE ACCESSORS
//  ------------------------------------------------------------------------

/*
TIBET contains a number of global properties that affect operation, some of
which are expected to vary throughout an application's lifecycle. Here we
define a few methods that allow these globals to work within the context of
change notification so TIBET's tools can be notified of their current state.
*/

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getRuntimeInfo',
function() {

    /**
     * @method getRuntimeInfo
     * @summary Returns an object containing current environmental data
     *     regarding the browser and TIBET.
     * @example Retrieve information about the environment that TIBET is
     *     currently executing in:
     *     <code>
     *          TP.sys.getRuntimeInfo();
     *          <samp>{"BROWSER_AGENT":"mozilla/5.0 (macintosh; u; intel
     *          mac os x; en-us; rv:1.8.1.3) gecko/20070309
     *          firefox/2.0.0.3",
     *          "CURRENT_LTIME":"Tue Mar 27 2007 17:08:46 GMT-0600 (MDT)",
     *          "TIBET_LICENSE":"_0000000000000000"}</samp>
     *     </code>
     * @returns {TP.core.Hash} A collection containing data about the current
     *     execution environment.
     */

    var info;

    info = TP.hc();

    info.atPut('CURRENT_LTIME', new Date().toString());
    info.atPut('TIBET_VERSION', TP.sys.$VERSION);
    info.atPut('TIBET_LICENSE', TP.sys.$LICENSE);
    info.atPut('BROWSER_AGENT', TP.$agent);

    return info;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getSTATUS',
function() {

    /**
     * @method getSTATUS
     * @summary Returns the global $STATUS flag setting. This method provides a
     *     get() accessible interface to that global.
     * @returns {Number} A status code, typically from job control status codes.
     */

    return $STATUS;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('setSTATUS',
function(aStatusCode) {

    /**
     * @method setSTATUS
     * @summary Controls the global $STATUS flag setting. This method provides
     *     a set() accessible interface to that global.
     * @param {Number} aStatusCode The value to set the $STATUS code.
     * @returns {Boolean} The value of the global $STATUS flag.
     */

    var oldVal;

    oldVal = $STATUS;

    if (oldVal !== aStatusCode) {
        $STATUS = aStatusCode;
        TP.sys.changed('STATUS',
                        TP.UPDATE,
                        TP.hc(TP.OLDVAL, oldVal, TP.NEWVAL, aStatusCode));
    }

    return $STATUS;
});

//  ------------------------------------------------------------------------
//  RUNTIME LOOKUP/PINPOINTING
//  ------------------------------------------------------------------------

/*
At runtime there are a couple of settings that can be used to influence
which entries in the XML Catalog will be used, in particular whether TIBET
is currently running "offline" and what environment was the application
booted with (development, test, production, or a custom environment).
*/

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getProfile',
function() {

    /**
     * @method getProfile
     * @summary Returns the current boot profile, such as 'development',
     *     'test', or 'production'. This is effectively a readonly property
     *     since it's set at boot time and defines how the boot process loads.
     *     Trying to change this value at runtime is not supported.
     * @returns {String} The current value for environment.
     */

    return TP.sys.cfg('boot.profile');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getUsedMethods',
function() {

    /**
     * @method getUsedMethods
     * @summary Returns a hash of the currently used methods in the system.
     * @description This method requires the 'oo.$$track_invocations' flag to be
     *     true, otherwise there will be no data for this method to use for its
     *     computation and it return an empty hash.
     * @returns {TP.core.Hash} A hash of method names as they appear in the
     *     TIBET metadata as the keys and the method body Functions themselves
     *     as the values.
     */

    var usedMethods;

    if (TP.isFalse(TP.sys.cfg('oo.$$track_invocations'))) {
        TP.ifError() ?
            TP.error('Attempt to retrieve used methods when invocations' +
                        ' data isn\'t available.') : 0;
        return null;
    }

    usedMethods = TP.hc();

    //  Iterate over all of the methods tracked in the metadata. If there are
    //  methods whose invocation count is greater than 0, then add it to the
    //  used methods hash.
    TP.sys.$$meta_methods.perform(
            function(kvPair) {

                var methodKey,
                    methodBody;

                methodKey = kvPair.first();
                methodBody = kvPair.last();

                if (methodBody.invocationCount > 0) {
                    usedMethods.atPut(methodKey, methodBody);
                }
            });

    return usedMethods;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getUsedTypes',
function() {

    /**
     * @method getUsedTypes
     * @summary Returns a hash of the currently used types in the system and any
     *     supertypes or trait types that they reference.
     * @description This method requires the 'oo.$$track_invocations' flag to be
     *     true, otherwise there will be no data for this method to use for its
     *     computation and it return an empty hash.
     * @returns {TP.core.Hash} A hash of types names as they appear in the
     *     TIBET metadata as the keys and the type objects themselves as the
     *     values.
     */

    var directlyUsedTypes,

        usedMethods,

        allUsedTypes;

    if (TP.isFalse(TP.sys.cfg('oo.$$track_invocations'))) {
        TP.ifError() ?
            TP.error('Attempt to retrieve used types when invocations' +
                        ' data isn\'t available.') : 0;
        return null;
    }

    directlyUsedTypes = TP.ac();

    //  Grab all of the used methods. Iterate over them and, if they have a type
    //  as an owner and that type is not a native type, then add it to the
    //  'directly referenced' types list.
    usedMethods = TP.sys.getUsedMethods();
    usedMethods.perform(
        function(kvPair) {

            var methodOwner;

            methodOwner = kvPair.last()[TP.OWNER];
            if (TP.isType(methodOwner) && !TP.isNativeType(methodOwner)) {
                directlyUsedTypes.push(methodOwner);
            }
        });

    //  Unique this list to substantially reduce the list to unique type values.
    directlyUsedTypes.unique();

    allUsedTypes = TP.hc();

    //  Now, add the type, any supertypes it references and any trait types that
    //  it references. Note that at each step we check to make sure that the
    //  type isn't a native type, in which case we don't add it.
    directlyUsedTypes.forEach(
        function(aType) {

            var superTypes,
                traitTypes;

            //  First, add the direct type
            if (!TP.isNativeType(aType)) {
                allUsedTypes.atPut(aType[TP.NAME], aType);
            }

            //  Second, add the direct supertypes
            superTypes = aType.getSupertypes();
            if (TP.notEmpty(superTypes)) {
                superTypes.forEach(
                    function(aSupertype) {
                        if (!TP.isNativeType(aSupertype)) {
                            allUsedTypes.atPut(
                                aSupertype[TP.NAME], aSupertype);
                        }
                    });
            }

            //  Third, add the trait types (and their supertypes)
            traitTypes = aType[TP.TRAITS];
            if (TP.notEmpty(traitTypes)) {
                traitTypes.forEach(
                    function(aTraitType) {

                        var traitSupertypes;

                        if (!TP.isNativeType(aTraitType)) {
                            allUsedTypes.atPut(
                                    aTraitType[TP.NAME], aTraitType);
                        }

                        traitSupertypes = aTraitType.getSupertypes();
                        traitSupertypes.forEach(
                            function(aTraitSupertype) {
                                if (!TP.isNativeType(aTraitSupertype)) {
                                    allUsedTypes.atPut(
                                            aTraitSupertype[TP.NAME],
                                            aTraitSupertype);
                                }
                            });
                    });
            }
        });

    //  Unique this list to substantially reduce the list to unique type values.
    allUsedTypes.unique();

    return allUsedTypes;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('isExiting',
function(aFlag) {

    /**
     * @method isExiting
     * @summary Controls and returns the state of the exiting flag, which is
     *     set when a valid "logout" sequence has been initiated by the current
     *     application. This allows certain teardown operations to function
     *     properly.
     * @param {Boolean} aFlag True to set exiting state to true.
     * @returns {Boolean} True if TIBET is currently exiting.
     */

    var oldVal;

    if (TP.isBoolean(aFlag)) {
        oldVal = TP.sys.cfg('tibet.exiting');

        if (oldVal !== aFlag) {

            TP.sys.setcfg('tibet.exiting', aFlag);

            TP.sys.changed('tibet.exiting',
                            TP.UPDATE,
                            TP.hc(TP.OLDVAL, oldVal, TP.NEWVAL, aFlag));
        }
    }

    //  NOTE the default to false since this flag isn't always there
    return TP.sys.cfg('tibet.exiting', false);
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('isOffline',
function(aFlag) {

    /**
     * @method isOffline
     * @summary Controls and returns the state of the online/offline flag.
     * @description This is set automatically to false when the launch was from
     *     a file:// url. You can still force it back to true if you start
     *     accessing HTTP urls later in your session. Note that the HTML5
     *     'online/offline' events have been wired to set this flag as well.
     * @param {Boolean} aFlag True means we're "offline".
     * @returns {Boolean} Whether or not TIBET is currently running in "offline"
     *     mode.
     */

    var oldVal;

    if (TP.isBoolean(aFlag)) {
        oldVal = TP.sys.cfg('tibet.offline');

        if (TP.sys.cfg('tibet.offline') !== aFlag) {

            TP.sys.setcfg('tibet.offline', aFlag);

            //  altering the offline status may affect uri filtering
            TP.sys.setcfg('tibet.uriprofile', null);

            TP.sys.changed('tibet.offline',
                            TP.UPDATE,
                            TP.hc(TP.OLDVAL, oldVal, TP.NEWVAL, aFlag));
        }
    }

    return TP.sys.cfg('tibet.offline');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('isTesting',
function(aFlag) {

    /**
     * @method isTesting
     * @summary Controls and returns the state of the testing flag, which is
     *     set when the test harness has been invoked by the current
     *     application. This allows certain test stubbing operations to function
     *     properly.
     * @param {Boolean} aFlag True to set exiting state to true.
     * @returns {Boolean} True if TIBET is currently exiting.
     */

    var oldVal;

    if (TP.isBoolean(aFlag)) {
        oldVal = TP.sys.cfg('test.running');

        if (oldVal !== aFlag) {

            TP.sys.setcfg('test.running', aFlag);

            TP.sys.changed('test.running',
                            TP.UPDATE,
                            TP.hc(TP.OLDVAL, oldVal, TP.NEWVAL, aFlag));
        }
    }

    //  NOTE the default to false since this flag isn't always there
    return TP.sys.cfg('test.running', false);
});

//  ------------------------------------------------------------------------
//  REAL and EFFECTIVE SETTINGS
//  ------------------------------------------------------------------------

/*
To manage the development process and administrative applications more
effectively TIBET employs a UNIX-style "real" and "effective" user model. In
essence, when a user logs in to TIBET there's a presumed "real" user ID that
is associated with that login and the server-side session that's likely to
be in effect for that user ID. Subsequent to initial login the application
may support the ability for the user to alter their "effective" user ID to
simulate operations on behalf of another user. Development and QA processing
can often leverage this feature, but it also comes up in any application
that supports an administrative "mode" where the administrator can perform
actions on behalf of an alternative user.
*/

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getEffectiveUser',
function() {

    /**
     * @method getEffectiveUser
     * @summary Returns the effective user, the user instance for which all
     *     operations are being filtered at the time of this call.
     * @example Get TIBET's current 'effective user':
     *     <code>
     *          TP.sys.getEffectiveUser();
     *          <samp>public</samp>
     *     </code>
     * @returns {TP.core.User} The effective TP.core.User instance, if there is
     *     one.
     */

    var type;

    if (TP.isType(type = TP.sys.getTypeByName('TP.core.User'))) {
        return type.getEffectiveUser();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getRealUser',
function() {

    /**
     * @method getRealUser
     * @summary Returns the "real" user, the user instance that was the initial
     *     instance constructed during login/session creation.
     * @example Get TIBET's current 'real user':
     *     <code>
     *          TP.sys.getRealUser();
     *          <samp>public</samp>
     *     </code>
     * @returns {TP.core.User} The real TP.core.User instance, if there is one.
     */

    var type;

    if (TP.isType(type = TP.sys.getTypeByName('TP.core.User'))) {
        return type.getRealUser();
    }

    return;
});

//  ------------------------------------------------------------------------
//  GLOBAL DEPENDENCY TRACKING
//  ------------------------------------------------------------------------

TP.getDependencies = TP.RETURN_EMPTY_ARRAY;

//  ------------------------------------------------------------------------

TP.sys.defineMethod('addManualDependencies',
function(anObjectOID, dependencies) {

    /**
     * @method addManualDependencies
     * @summary Adds any 'manual' dependencies that the system cannot determine
     *     by using it's 'used method reachability' mechanism.
     * @description Sometimes code (usually a type) is required by an app where
     *     no methods on that type are invoked. This method allows those
     *     dependencies to be added manually and tracked by the user.
     * @param {String} anObjectOID The OID of the object that we're registering
     *     these dependencies for.
     * @param {Array} dependencies The Array of dependency entries, usually
     *     obtained by calling 'getDependencies' on the object in question.
     */

    if (TP.notValid(this.$manualDependencies)) {
        this.$manualDependencies = new TP.boot.PHash();
    }

    this.$manualDependencies.atPut(anObjectOID, dependencies.flatten());
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getManualDependencies',
function() {

    /**
     * @method getManualDependencies
     * @summary Retrieves any 'manual' dependencies that was defined by the
     *     system.
     * @returns {Array} Returns an Array of dependency entries.
     */

    return this.$manualDependencies.getValues().flatten();
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('hasManualDependencies',
function(anObjectOID) {

    /**
     * @method hasManualDependencies
     * @summary Returns whether or not the object with the supplied OID has its
     *     dependencies already registered.
     * @param {String} anObjectOID The OID of the object that we're checking
     *     to see if its dependencies are registered.
     * @returns {Boolean} Whether or not dependencies are registered for the
     *     object with the supplied OID.
     */

    if (TP.notValid(this.manualDependencies)) {
        return false;
    }

    return this.$manualDependencies.hasKey(anObjectOID);
});

//  ------------------------------------------------------------------------

//  Add metadata for the 'bootstrap' methods that got us this far.

//  Defined in TIBETGlobal.js
TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETGlobals.js';

TP.sys.addMetadata(TP, TP.constructOrphanObject, TP.METHOD, TP.PRIMITIVE_TRACK);
TP.sys.addMetadata(TP, TP.defineNamespace, TP.METHOD, TP.PRIMITIVE_TRACK);
TP.sys.addMetadata(TP, TP.isNamespace, TP.METHOD, TP.PRIMITIVE_TRACK);
TP.sys.addMetadata(TP.sys, TP.sys.getGlobals, TP.METHOD, TP.PRIMITIVE_TRACK);
TP.sys.addMetadata(TP.sys, TP.sys.release, TP.METHOD, TP.PRIMITIVE_TRACK);

//  Defined in this file
TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETPrimitivesPre.js';

TP.sys.addMetadata(TP, TP.isCallable, TP.METHOD, TP.PRIMITIVE_TRACK);
TP.sys.addMetadata(TP, TP.canInvoke, TP.METHOD, TP.PRIMITIVE_TRACK);
TP.sys.addMetadata(TP, TP.isValid, TP.METHOD, TP.PRIMITIVE_TRACK);
TP.sys.addMetadata(TP, TP.notValid, TP.METHOD, TP.PRIMITIVE_TRACK);
TP.sys.addMetadata(TP, TP.ifInvalid, TP.METHOD, TP.PRIMITIVE_TRACK);
TP.sys.addMetadata(TP, TP.isDNU, TP.METHOD, TP.PRIMITIVE_TRACK);
TP.sys.addMetadata(TP, TP.isFunction, TP.METHOD, TP.PRIMITIVE_TRACK);
TP.sys.addMetadata(TP, TP.isString, TP.METHOD, TP.PRIMITIVE_TRACK);
TP.sys.addMetadata(TP, TP.owns, TP.METHOD, TP.PRIMITIVE_TRACK);
TP.sys.addMetadata(Function, TP.FunctionProto.asMethod,
                    TP.METHOD, TP.INST_TRACK);
TP.sys.addMetadata(String, TP.StringProto.strip, TP.METHOD, TP.INST_TRACK);
TP.sys.addMetadata(TP, TP.constructOID, TP.METHOD, TP.LOCAL_TRACK);
TP.sys.addMetadata(TP, TP.getFunctionName, TP.METHOD, TP.PRIMITIVE_TRACK);
TP.sys.addMetadata(Function, TP.FunctionProto.$getName,
                    TP.METHOD, TP.INST_TRACK);
TP.sys.addMetadata(TP, TP.objectGetMetadataName, TP.METHOD, TP.PRIMITIVE_TRACK);
TP.sys.addMetadata(TP.sys, TP.sys.addMetadata, TP.METHOD, TP.LOCAL_TRACK);

//  ------------------------------------------------------------------------
//  TIBET - PERFORMANCE CACHES
//  ------------------------------------------------------------------------

//  TP.core.Hash of computed signal names.
TP.defineAttribute('$signal_name_cache', TP.hc());

//  TP.core.Hash of XML documents keyed by the String that created them.
TP.defineAttribute('$parsed_doc_cache', TP.hc());

//  TP.core.Hash of compiled XML documents keyed by their ID.
TP.defineAttribute('$compiled_doc_cache', TP.hc());

//  Array of Element nodes that are currently capturing their own mouse wheel
//  events.
TP.defineAttribute('$mousewheel_capturer_cache', TP.ac());

//  ------------------------------------------------------------------------
//  TIBET - PLUGIN INFORMATION
//  ------------------------------------------------------------------------

TP.ACROBAT_PLUGIN = 'acrobat';
TP.QUICKTIME_PLUGIN = 'quicktime';
TP.DIVX_PLUGIN = 'divx';
TP.DIRECTOR_PLUGIN = 'director';
TP.FLASH_PLUGIN = 'flash';
TP.VLC_PLUGIN = 'vlc';
TP.WINDOWS_MEDIA_PLUGIN = 'windows_media';
TP.JAVA_PLUGIN = 'java';
TP.REALPLAYER_PLUGIN = 'realplayer';
TP.SILVERLIGHT_PLUGIN = 'silverlight';

//  ------------------------------------------------------------------------

TP.PLUGIN_INFO = TP.hc();

TP.PLUGIN_INFO.atPut(
    TP.ACROBAT_PLUGIN,
    TP.hc('classID',
            'CA8A9780-280D-11CF-A24D-444553540000',
        //  No 'codebase'
        'description', 'Adobe Acrobat Plugin',
        'installPage',
            'http://www.adobe.com/products/acrobat/readstep2.html',
        //  No 'mimeType'
        'mimeTypes',
            TP.hc('application/pdf', 'pdf',
                'application/vnd.fdf', 'fdf',
                'application/vnd.adobe.xfdf', 'xfdf',
                'application/vnd.adobe.xdp+xml', 'xdp',
                'application/vnd.adobe.xfd+xml', 'xfd'),
        'name', 'Acrobat',
        'progIDs', TP.ac('PDF.PdfCtrl.7',
                        'PDF.PdfCtrl.6',
                        'PDF.PdfCtrl.5',
                        'PDF.PdfCtrl.4',
                        'PDF.PdfCtrl.3',
                        'AcroPDF.PDF.1')
        ));

//  ---

TP.PLUGIN_INFO.atPut(
    TP.QUICKTIME_PLUGIN,
    TP.hc('classID',
            '02BF25D5-8C17-4B23-BC80-D3488ABDDC6B',
        'codeBase',
            'http://www.apple.com/qtactivex/qtplugin.cab#version=6,0,2,0',
        'description', 'Apple Quicktime Plugin',
        'installPage',
            'http://www.apple.com/quicktime/download/',
        'mimeType',
            'video/quicktime',
        'mimeTypes',
            TP.hc('image/tiff', 'tif,tiff',
                'image/x-tiff', 'tif,tiff',
                'video/x-m4v', 'm4v',
                'image/x-macpaint', 'pntg,pnt,mac',
                'image/pict', 'pict,pic,pct',
                'image/x-pict', 'pict,pic,pct',
                'image/x-quicktime', 'qtif,qti',
                'image/x-sgi', 'sgi,rgb',
                'image/x-targa', 'targa,tga',
                'audio/3gpp', '3gp,3gpp',
                'video/3gpp2', '3g2,3gp2',
                'audio/3gpp2', '3g2,3gp2',
                'video/sd-video', 'sdv',
                'application/x-mpeg', 'amc',
                'video/mp4', 'mp4',
                'audio/mp4', 'mp4',
                'audio/x-m4a', 'm4a',
                'audio/x-m4p', 'm4p',
                'audio/x-m4b', 'm4b',
                'video/mpeg',
                    'mpeg,mpg,m1s,m1v,m1a,m75,m15,mp2,mpm,mpv,mpa',
                'audio/mpeg', 'mpeg,mpg,m1s,m1a,mp2,mpm,mpa,m2a',
                'audio/x-mpeg', 'mpeg,mpg,m1s,m1a,mp2,mpm,mpa,m2a',
                'video/3gpp', '3gp,3gpp',
                'audio/x-gsm', 'gsm',
                'audio/AMR', 'AMR',
                'audio/aac', 'aac,adts',
                'audio/x-aac', 'aac,adts',
                'audio/x-caf', 'caf',
                'video/x-mpeg',
                    'mpeg,mpg,m1s,m1v,m1a,m75,m15,mp2,mpm,mpv,mpa',
                'audio/aiff', 'aiff,aif,aifc,cdda',
                'audio/x-aiff', 'aiff,aif,aifc,cdda',
                'audio/basic', 'au,snd,ulw',
                'audio/mid', 'mid,midi,smf,kar',
                'audio/x-midi', 'mid,midi,smf,kar',
                'audio/midi', 'mid,midi,smf,kar',
                'audio/vnd.qcelp', 'qcp',
                'application/sdp', 'sdp',
                'application/x-sdp', 'sdp',
                'application/x-rtsp', 'rtsp,rts',
                'video/quicktime', 'mov,qt,mqv',
                'video/flc', 'flc,fli,cel',
                'audio/x-wav', 'wav,bwf',
                'audio/wav', 'wav,bwf'),
        'name', 'QuickTime',
        'progIDs', TP.ac('QuickTime.QuickTime',
                        'QuickTimeCheckObject.QuickTimeCheck.1')
        ));

//  ---

TP.PLUGIN_INFO.atPut(
    TP.DIVX_PLUGIN,
    TP.hc('classID',
            '67DABFBF-D0AB-41fa-9C46-CC0F21721616',
        'codeBase',
            'http://go.divx.com/plugin/DivXBrowserPlugin.cab',
        'description', 'DivX Browser Plugin',
        'installPage',
            'http://go.divx.com/plugin/download/',
        'mimeType',
            'video/divx',
        'mimeTypes',
            TP.hc('video/divx', 'dvx,divx'),
        'name', 'DivX',
        'progIDs', TP.ac('npdivx.DivXBrowserPlugin.1',
                        'npdivx.DivXBrowserPlugin')
        ));

//  ---

/* eslint-disable max-len */
TP.PLUGIN_INFO.atPut(
    TP.DIRECTOR_PLUGIN,
    TP.hc('classID',
            '166B1BCA-3F9C-11CF-8075-444553540000',
        'codeBase',
            'http://download.macromedia.com/pub/shockwave/cabs/director/sw.cab#version=8,5,1,0',
        'description', 'Macromedia Director',
        'installPage',
            'http://go.divx.com/plugin/download/',
        'mimeType',
            'application/x-director',
        //  No 'mimeTypes'
        'name', 'Director',
        'progIDs', TP.ac('SWCtl.SWCtl.11',
                        'SWCtl.SWCtl.10',
                        'SWCtl.SWCtl.9',
                        'SWCtl.SWCtl.8',
                        'SWCtl.SWCtl.7',
                        'SWCtl.SWCtl.6',
                        'SWCtl.SWCtl.5',
                        'SWCtl.SWCtl.4')
        ));
/* eslint-enable max-len */

//  ---

/* eslint-disable max-len */
TP.PLUGIN_INFO.atPut(
    TP.FLASH_PLUGIN,
    TP.hc('classID',
            'D27CDB6E-AE6D-11CF-96B8-444553540000',
        'codeBase',
            'http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,40,0',
        'description', 'Macromedia Shockwave Flash',
        'installPage',
            'http://www.macromedia.com/go/getflashplayer',
        'mimeType',
            'application/x-shockwave-flash',
        'mimeTypes',
            TP.hc('application/x-shockwave-flash', 'swf',
                'application/futuresplash', 'spl'),
        'name', 'Flash',
        'progIDs', TP.ac('ShockwaveFlash.ShockwaveFlash.9',
                        'ShockwaveFlash.ShockwaveFlash.8.5',
                        'ShockwaveFlash.ShockwaveFlash.8',
                        'ShockwaveFlash.ShockwaveFlash.7',
                        'ShockwaveFlash.ShockwaveFlash.6',
                        'ShockwaveFlash.ShockwaveFlash.5',
                        'ShockwaveFlash.ShockwaveFlash.4')
        ));
/* eslint-enable max-len */

//  ---

TP.PLUGIN_INFO.atPut(
    TP.VLC_PLUGIN,
    TP.hc(//    No 'classID'
        //  No 'codeBase'
        'description', 'VLC multimedia plugin',
        'installPage',
            'http://www.videolan.org/doc/play-howto/en/ch02.html#id287569',
        'mimeType',
            'application/x-vlc-plugin',
        'mimeTypes',
            TP.hc('audio/mpeg', 'mp2,mp3,mpga,mpega',
                'audio/x-mpeg', 'mp2,mp3,mpga,mpega',
                'video/mpeg', 'mpg,mpeg,mpe',
                'video/x-mpeg', 'mpg,mpeg,mpe',
                'video/mpeg-system', 'mpg,mpeg,vob',
                'video/x-mpeg-system', 'mpg,mpeg,vob',
                'video/mpeg4', 'mp4,mpg4',
                'audio/mpeg4', 'mp4,mpg4',
                'application/mpeg4-iod', 'mp4,mpg4',
                'application/mpeg4-muxcodetable', 'mp4,mpg4',
                'video/x-msvideo', 'avi',
                'video/quicktime', 'mov,qt',
                'application/x-ogg', 'ogg',
                'application/x-vlc-plugin', '*',
                'video/x-ms-asf-plugin', 'asf,asx,*',
                'video/x-ms-asf', 'asf,asx,*',
                'application/x-mplayer2', 'dvx,divx,ivx,xvid,ivf,*',
                'video/x-ms-wmv', 'wmv,*',
                'application/x-google-vlc-plugin', '*'),
        'name', 'VLC'
        //  No 'progIDs'
        ));

//  ---

/* eslint-disable max-len */
TP.PLUGIN_INFO.atPut(
    TP.WINDOWS_MEDIA_PLUGIN,
    TP.hc('classID',
            '22D6f312-B0F6-11D0-94AB-0080C74C7E95', //  WMP6
        'codeBase',
            'http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=6,0,02,902',
        'description', 'Windows Media Player Plug-in Dynamic Link Library',
        'installPage',
            'http://www.microsoft.com/windows/windowsmedia/',
        'mimeType',
            'application/x-mplayer2',
        'mimeTypes',
            TP.hc('application/asx', '*',
                'video/x-msvideo', 'avi',
                'video/x-ms-asf-plugin', '*',
                'application/x-mplayer2', 'dvx,divx,ivx,xvid,ivf,*',
                'video/x-ms-asf', 'asf,asx,*',
                'video/x-ms-wm', 'wm,*',
                'audio/x-ms-wma', 'wma,*',
                'audio/x-ms-wax', 'wax,*',
                'video/x-ms-wmv', 'wmv,*',
                'video/x-ms-wvx', 'wvx,*'),
        'name', 'Windows Media',
        'progIDs', TP.ac('WMPlayer.OCX',
                        'MediaPlayer.MediaPlayer.1')
        ));
/* eslint-enable max-len */

//  ---

TP.PLUGIN_INFO.atPut(
    TP.JAVA_PLUGIN,
    TP.hc('classID',
            '08B0E5C0-4FCB-11CF-AAA5-00401C608500',
        //  No 'codeBase'
        'description', 'Java Virtual Machine',
        'installPage',
            'http://www.java.com/de/download/manual.jsp',
        //  No 'mimeType',
        'mimeTypes',
            TP.hc('application/x-java-applet', '',
                'application/x-java-bean', '',
                'application/x-java-vm', ''),
        'name', 'Java'
        //  No 'progIDs'
        ));

//  ---

TP.PLUGIN_INFO.atPut(
    TP.REALPLAYER_PLUGIN,
    TP.hc('classID',
            'CFCDAA03-8BE4-11cf-B84B-0020AFBBCCFA',
        //  No 'codeBase'
        'description', 'Realplayer Version Plugin',
        'installPage',
            'http://www.real.com/freeplayer/?rppr=rnwk',
        'mimeType',
            'audio/x-pn-realaudio-plugin',
        'mimeTypes',
            TP.hc('audio/x-pn-realaudio-plugin', 'rpm',
                'application/vnd.rn-realplayer-javascript', 'rpj'),
        'name', 'Realplayer Plugin',
        'progIDs', TP.ac('rmocx.RealPlayer G2 Control',
                        'rmocx.RealPlayer G2 Control.1',
                        'RealPlayer.RealPlayer(tm) ActiveX Control (32-bit)',
                        'RealVideo.RealVideo(tm) ActiveX Control (32-bit)',
                        'RealPlayer')
        ));

//  ---

TP.PLUGIN_INFO.atPut(
    TP.SILVERLIGHT_PLUGIN,
    TP.hc('classID',
            '32C73088-76AE-40F7-AC40-81F62CB2C1DA',
        //  No 'codeBase'
        'description', 'Silverlight Plugin',
        'installPage',
            '',
        'mimeType',
            'application/x-silverlight',
        'mimeTypes',
            TP.hc('application/manifest', 'manifest',
                'application/xaml+xml', 'xaml',
                'application/x-msdownload', 'dll',
                'application/x-ms-xbap', 'xbap',
                'application/octet-stream', 'deploy',
                'application/vnd.ms-xpsdocument', 'xps'
                ),
        'name', 'Silverlight',
        'progIDs', TP.ac('AgControl.AgControl')
        ));

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETPrimitivesBase.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
*/

//  ------------------------------------------------------------------------
//  TIBET PLUGIN QUERYING
//  ------------------------------------------------------------------------

//  Install a custom 'version matcher' RegExp for Flash that will pull apart
//  the version string in the proper way.

TP.PLUGIN_INFO.at(TP.FLASH_PLUGIN).atPut(
    'versionMatcher',
    /(^| )(\d+)\.?(\d*)\s*r([\d\.]*)/);

//  ------------------------------------------------------------------------

TP.$$pluginVersionMatcher = /(^| )(\d+)\.?(\d*)\.?([\d\.]*)/;
TP.$$pluginVersionFunction = function(plugin, pluginEntry) {

    /**
     * @method $$pluginVersionFunction
     * @summary The 'standard version' of the function that retrieves the
     *     version information from the supplied plugin and populated the
     *     pluginEntry with it.
     * @param {Object} plugin The native plugin Object from the browser's
     *     'navigator.plugins' Array.
     * @param {TP.core.Hash} pluginEntry The entry to populate with the version
     *     information.
     */

    var versionMatcher,
        versionData;

    //  If the plugin info entry doesn't have a 'custom' version matcher, we
    //  use the standard one.
    if (TP.notValid(versionMatcher = pluginEntry.at('versionMatcher'))) {
        versionMatcher = TP.$$pluginVersionMatcher;
    }

    //  First we try to execute the version matcher on the plugin's name.
    versionData = versionMatcher.exec(plugin.name);

    //  If we couldn't find version numbers on the plugin's name, then we
    //  try to find the them on the plugin's description.
    if (TP.notValid(versionData)) {
        versionData = versionMatcher.exec(plugin.description);
    }

    //  If we got valid data, go ahead and populate the plugin info entry's
    //  'revMajor', 'revMinor' and 'revPatch' entries.
    if (TP.isValid(versionData)) {
        pluginEntry.atPut('revMajor', versionData[2]);
        pluginEntry.atPut('revMinor', versionData[3]);
        pluginEntry.atPut('revPatch', versionData[4]);
    }

    return;
};

//  ------------------------------------------------------------------------

TP.definePrimitive('getPluginInfo',
function(pluginKey) {

    /**
     * @method getPluginInfo
     * @summary Returns a TP.core.Hash containing information about the plugin
     *     matching the supplied plugin key.
     * @param {String} pluginKey The key for a particular key matching keys in
     *     the TP.PLUGIN_INFO hash.
     * @returns {TP.core.Hash} The plugin's information entry.
     */

    var pluginInfo,

        allPlugins,
        thePlugin,

        installedFunc,
        versionFunc,

        i,

        isInstalled;

    //  If there isn't any entry at all, we don't even have the most basic
    //  information about the plugin, so just return null here.
    if (TP.notValid(pluginInfo = TP.PLUGIN_INFO.at(pluginKey))) {
        return null;
    }

    //  If there is no value (either 'true' or 'false') in the 'isInstalled'
    //  slot in the entry, then we haven't actually run the detection code
    //  to see if the plugin is installed or not.
    if (TP.notValid(pluginInfo.at('isInstalled'))) {
        thePlugin = null;

        //  If there is no custom 'is installed' function, then we just loop
        //  over the plugins in the 'navigator.plugins' Array until we find
        //  one that matches the value defined in the 'name' slot.
        if (TP.notValid(installedFunc =
                        pluginInfo.at('isInstalledFunction'))) {
            allPlugins = navigator.plugins;

            for (i = 0; i < allPlugins.length; i++) {
                if (allPlugins[i].name.indexOf(pluginInfo.at('name')) !==
                                                            TP.NOT_FOUND) {
                    thePlugin = allPlugins[i];

                    //  Found a matching native plugin Object in the system,
                    //  so exit here.
                    break;
                }
            }

            //  Set 'isInstalled' to whether we found a valid native plugin
            //  Object or not.
            isInstalled = TP.isValid(thePlugin);
        } else {
            //  Set 'isInstalled' to the return value of the custom 'is
            //  installed' function.
            isInstalled = installedFunc();
        }

        pluginInfo.atPut('isInstalled', isInstalled);

        //  If the plugin is installed, try to get its version.
        if (isInstalled) {
            //  If there is no custom 'get version' function, use the
            //  standard 'get version' function.
            if (TP.notValid(versionFunc =
                            pluginInfo.at('getVersionFunction'))) {
                versionFunc = TP.$$pluginVersionFunction;
            }

            //  Execute the 'get version' function to populate the version
            //  entries in the plugin info. Note that plugins that have
            //  custom 'isInstalled' functions will not have set 'thePlugin'
            //  to anything here, so it will be null and this function is
            //  expected to handle that.
            versionFunc(thePlugin, pluginInfo);
        }
    }

    return pluginInfo;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETPrimitivesPlatform.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
*/

/* global netscape:false
*/

//  ------------------------------------------------------------------------
//  TIBET - TYPE DICTIONARIES - NATIVE
//  ------------------------------------------------------------------------

TP.definePrimitive('isError',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(anObj) {

        /**
         * @method isError
         * @summary Returns true if the object provided is an Error object.
         * @param {Object} anObj The Object to test.
         * @returns {Boolean} Whether or not the supplied object is an Event
         *     object.
         */

        //  Gecko likes to throw component exceptions which don't respond
        //  correctly as instances of Error so we use a different check than
        //  the common routine.

        /* eslint-disable no-extra-parens */
        return (TP.isValid(anObj) &&
                anObj.message !== undefined &&
                (anObj.stack !== undefined ||
                    anObj.QueryInterface !== undefined));
        /* eslint-enable no-extra-parens */
    },
    TP.DEFAULT,
    function(anObj) {

        /**
         * @method isError
         * @summary Returns true if the object provided is an Error object.
         * @param {Object} anObj The Object to test.
         * @returns {Boolean} Whether or not the supplied object is an Event
         *     object.
         */

        if (TP.notValid(anObj)) {
            return false;
        }

        if (anObj instanceof Error) {
            return true;
        }

        /* eslint-disable no-extra-parens */
        return (TP.isValid(anObj) &&
                anObj.message !== undefined &&
                anObj.stack !== undefined);
        /* eslint-enable no-extra-parens */
    }
));

//  ------------------------------------------------------------------------
//  COMMON UTILITY ROUTINES
//  ------------------------------------------------------------------------

/* eslint-disable max-len */

TP.definePrimitive('executePrivileged',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(privilegedOp, reasonMsg, failureMsg, tryUnprivileged,
             privilegedFunction) {

        /**
         * @method executePrivileged
         * @summary Execute a function that requires some sort of special
         *     browser privileges, like reading data or a page in another domain
         *     or writing to the file system.
         * @param {String} privilegedOp One of the 'privileged operation'
         *     constants defined at the global level, such as
         *     TP.ACCESS_XDOMAIN_XMLHTTP.
         * @param {String} reasonMsg Message text describing to the user why a
         *     particular privilege is required.
         * @param {String} failureMsg Message text describing to the user the
         *     implications of failing to provide a particular privilege.
         * @param {Boolean} tryUnprivileged Whether or not to attempt to execute
         *     the privileged function in an unprivileged manner first.
         * @param {Function} privilegedFunction A Function containing the code
         *     that requires a particular set of privileges.
         * @returns {Boolean} Whether or not the privileged Function succeeded
         *     in obtaining permission to execute.
         */

        var dialogShownThreshold,

            permissionObtained,
            dialogShown,

            stopPrompting,
            continuePrompting,

            startTime,
            endTime;

        //  The number of milliseconds after which we determine a dialog was
        //  shown to the user.
        dialogShownThreshold = 250;

        //  First, determine whether we even need to ask for permission for
        //  this privilege

        //  If we should try an unprivileged execute, then go ahead and try
        //  it here. If it succeeds, we'll return true. Otherwise, we won't
        //  do anything in the catch block the exception. We'll try to
        //  obtain permission and try again.
        if (TP.isTrue(tryUnprivileged) || TP.sys.isExiting()) {
            try {
                privilegedFunction();

                return true;
            } catch (e) {
                if (TP.sys.isExiting()) {
                    return false;
                }
            }
        }

        //  Next, observe the TIBET flag as to whether to request permission
        //  for privileges.
        if (!TP.sys.shouldRequestPrivileges()) {
            TP.ifTrace() ? TP.sys.logSecurity(
                'TIBET not configured to request privileged code execution',
                TP.DEBUG) : 0;

            return false;
        }

        permissionObtained = false;
        dialogShown = false;

        //  If privilege is not configured, then we need to try to configure
        //  it.

        if (TP.notValid(TP.PRIVILEGE_FLAGS.at(privilegedOp))) {
            //  Privilege not configured with TIBET. alert() saying that
            //  we're going to try to configure the privilege and including
            //  the reasonMsg.
            alert(
                TP.sc('This application would like to request the following ' +
                    'privileges:', '\n\n',
                TP.PRIVILEGE_DESCRIPTIONS.at(privilegedOp), '\n\n',
                'because:', '\n\n',
                reasonMsg, '\n\n',
                /* eslint-disable max-len */
                'Therefore, you may see a dialog asking for permission to activate these privileges.\n\nNote that if you deny this permission and click the \'Remember this decision\' checkbox, you may have to manually edit your browser\'s configuration in the future to allow this application to be fully functional.'));
                /* eslint-enable max-len */
        } else {
            switch (TP.PRIVILEGE_FLAGS.at(privilegedOp)) {
                case 'ENABLE':
                    //  No 'pre-prompt' here, since this privilege was
                    //  previously configured with TIBET as 'ENABLE'.
                    break;
                case 'DISABLE':
                    //  No 'pre-prompt' here, since this privilege was
                    //  previously configured with TIBET as 'DISABLE'.
                    TP.raise(this,
                            'TP.sig.PrivilegeViolation',
                            TP.sc('Unable to obtain privileges for: '),
                                    privilegedOp);

                    //  Exit here, having failed to obtain permission.
                    return false;
                case 'PROMPT':
                    //  Privilege was configured as 'PROMPT' with TIBET.
                    //  alert() saying that we're going to try to
                    //  configure the privilege and including the reasonMsg.
                    alert(
                        TP.sc('This application would like to request the ' +
                            'following privileges:', '\n\n',
                        TP.PRIVILEGE_DESCRIPTIONS.at(privilegedOp), '\n\n',
                        'because:', '\n\n',
                        reasonMsg, '\n\n',
                        'Therefore, you may see a dialog asking for ' +
                            'permission to activate these privileges.'));
                    break;
                default:
                    break;
            }
        }

        //  Snapshot the time
        startTime = new Date();

        //  Now, we'll try to actually obtain permissions
        try {
            if (TP.sys.cfg('log.privilege_requests')) {
                TP.ifTrace() ? TP.sys.logSecurity('Privilege request at ' +
                            'executePrivileged',
                            TP.DEBUG) : 0;
            }

            //  Try to get all permissions. This will throw an exception if
            //  the permission is or has been denied.
            netscape.security.PrivilegeManager.enablePrivilege(
            'UniversalBrowserRead UniversalBrowserWrite UniversalXPConnect');

            //  Snapshot the time... if more than threshold, then a dialog
            //  was shown to the user.
            endTime = new Date();

            /* eslint-disable no-extra-parens */
            if ((endTime - startTime) > dialogShownThreshold) {
                dialogShown = true;
            }
            /* eslint-enable no-extra-parens */

            permissionObtained = true;

            //  If the privilege status is already ENABLE, then skip all of
            //  the rest of this and don't abuse the user with dialog boxes
            if (TP.PRIVILEGE_FLAGS.at(privilegedOp) === 'ENABLE') {
                void 0;
            } else {
                //  We obtained permission, but is it 'PROMPT' or 'ENABLE'??

                //  If a dialog didn't show, then it was definitely 'ENABLE'
                if (!dialogShown) {
                    //  Set the privilege status to 'ENABLE'
                    TP.$setPrivilegeFlag(privilegedOp, 'ENABLE');
                } else {
                    //  Otherwise, we ask the user whether or not to show
                    //  any more TIBET-based prompts.

                    //  confirm() asking whether, since we obtained the
                    //  privilege but we're not sure whether the user
                    //  checked the 'Remember this decision' dialog box,
                    //  TIBET should continue to prompt the user.
                    /* eslint-disable max-len */
                    stopPrompting = confirm(
                        TP.sc('You have approved enhanced permissions.', '\n\n',
                        'You may have also checked the \'Remember this decision\' checkbox. Would you like your TIBET-based application to also remember this decision?', '\n\n',
                        'If you did not check the \'Remember this decision\' checkbox, you may still want your TIBET-based application to remember this decision so that you will only see browser dialogs from now on.', '\n\n',
                        'Click \'OK\' for your TIBET-based application to remember this decision or \'Cancel\' to not have it remember this decision.')
                        );
                    /* eslint-enable max-len */

                    if (stopPrompting) {
                        //  Set the privilege status to 'ENABLE'
                        TP.$setPrivilegeFlag(privilegedOp, 'ENABLE');
                    } else {
                        //  Set the privilege status to 'PROMPT'
                        TP.$setPrivilegeFlag(privilegedOp, 'PROMPT');
                    }
                }
            }
        } catch (e) {
            //  Snapshot the time... if more than threshold, then a dialog
            //  was shown to the user.
            endTime = new Date();

            /* eslint-disable no-extra-parens */
            if ((endTime - startTime) > dialogShownThreshold) {
                dialogShown = true;
            }
            /* eslint-enable no-extra-parens */

            //  Permission couldn't be obtained.

            //  If the privilege status wasn't 'DISABLE', it was probably
            //  either non-existent or set to 'PROMPT'.
            if (TP.PRIVILEGE_FLAGS.at(privilegedOp) !== 'DISABLE') {
                //  If a dialog box wasn't shown, that means that we're not
                //  running in an environment that has even shown the dialog
                //  box. This must mean that we're running in an environment
                //  that:
                //      a)  Was not launched from a 'file://' URL
                //              OR
                //      b)  Has 'codebase principal' support turned off.
                //              OR
                //      c)  Is not being vended as a 'signed script'.
                //              OR
                //      d)  Already showed the user the dialog box and the
                //          user denied permission and clicked 'Remember
                //          this decision'.
                if (!dialogShown) {
                    //  alert() a message saying that since we couldn't
                    //  show the user a dialog, they'll have to contact
                    //  their system administrator to rectify the situation.
                    //  It will be registered with TIBET as being in a state
                    //  of 'DISABLE' below and this prompt will *NOT* be
                    //  shown again.
                    alert(TP.sc('Permission was denied to this application to perform the operation.\n\nThis means that EITHER:\n\n1. You were not given the opportunity to give it permission to perform this operation.\n\nOR\n\n2.  You previously denied this application to perform this operation and clicked \'Remember this decision\'.\n\nContact your system administrator to rectify this situation.\n\nThis panel will NOT be shown again during this application session.'));
                } else {
                    //  confirm() asking whether, since we didn't obtain
                    //  the privilege but we're not sure whether the user
                    //  checked the 'Remember this decision' dialog box',
                    //  TIBET should continue to prompt the user.

                    continuePrompting = confirm(
                        TP.sc('Because you denied this application the following privileges:\n\n',
                        TP.PRIVILEGE_DESCRIPTIONS.at(privilegedOp), '\n\n',
                        'the consequences are that:', '\n\n',
                        failureMsg, '\n\n',
                        'You may attempt to perform this operation again, but you must grant this application permission to complete the operation by clicking \'Allow\' in the browser\'s permission request panel when that panel presents itself.', '\n\n',
                        'If you checked \'Remember this decision\' you will not be given a chance to grant permission again. Contact your system administrator to rectify this situation. Otherwise, you can click \'OK\' below to try again or \'Cancel\' to not try again. If you choose \'Cancel\', this panel will NOT be shown again during this application session.'));

                    if (continuePrompting) {
                        //  Set the privilege status to 'PROMPT'
                        TP.$setPrivilegeFlag(privilegedOp, 'PROMPT');

                        //  Go ahead and try again by just returning the
                        //  execution of this function again.
                        return TP.executePrivileged(privilegedOp,
                                                    reasonMsg,
                                                    failureMsg,
                                                    tryUnprivileged,
                                                    privilegedFunction);
                    }
                }

                //  Set the privilege status to 'PROMPT'
                TP.$setPrivilegeFlag(privilegedOp, 'DISABLE');
            }

            //  Go ahead and raise a TIBET exception.
            TP.raise(this,
                    'TP.sig.PrivilegeViolation',
                    TP.ec(e, TP.join('Unable to obtain privileges for: ',
                                    privilegedOp)));
        }

        //  Whew! We made it all the way down here. We must have permission
        //  to actually do the deed.
        if (permissionObtained) {
            //  If we obtained permission, then go ahead and run the
            //  privileged function
            privilegedFunction();

            return true;
        }

        return false;
    },
    'webkit',
    function(privilegedOp, reasonMsg, failureMsg, tryUnprivileged,
             privilegedFunction) {

        /**
         * @method executePrivileged
         * @summary Execute a function that requires some sort of special
         *     browser privileges, like reading data or a page in another domain
         *     or writing to the file system.
         * @param {String} privilegedOp One of the 'privileged operation'
         *     constants defined at the global level, such as
         *     TP.ACCESS_XDOMAIN_XMLHTTP.
         * @param {String} reasonMsg Message text describing to the user why a
         *     particular privilege is required.
         * @param {String} failureMsg Message text describing to the user the
         *     implications of failing to provide a particular privilege.
         * @param {Boolean} tryUnprivileged Whether or not to attempt to execute
         *     the privileged function in an unprivileged manner first.
         * @param {Function} privilegedFunction A Function containing the code
         *     that requires a particular set of privileges.
         * @returns {Boolean} Whether or not the privileged Function succeeded
         *     in obtaining permission to execute.
         */

        //  On Webkit, this is a no-op.

        return false;
    }
));

/* eslint-enable max-len */

//  ------------------------------------------------------------------------
//  COMMON UTILITY ROUTINES
//  ------------------------------------------------------------------------

TP.definePrimitive('errorAsString',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(errorObj) {

        /**
         * @method errorAsString
         * @summary Returns a String representation of the supplied Error
         *     object.
         * @param {Error} errorObj The Error object to obtain the String
         *     representation of.
         * @returns {String} A String representation of the supplied Error
         *     object.
         */

        var str,
            file;

        if (TP.notEmpty(str = errorObj.message)) {
            //  In addition to the standard property of 'message', Gecko
            //  also supports 'fileName' and 'lineNumber', or filename and
            //  lineNumber, or...well, you get the idea...it's Gecko
            //  quality.

            if (TP.notEmpty(errorObj.fileName)) {
                file = true;
                str += ' &#171; ' + errorObj.fileName;
            } else if (TP.notEmpty(errorObj.filename)) {
                str += ' &#171; ' + errorObj.filename;
            }

            if (TP.notEmpty(errorObj.lineNumber)) {
                str += '#line(' + errorObj.lineNumber + ')';
            }

            if (file) {
                str += ' &#187;';
            }
        } else {
            //  If there's no real message, just use '[object Error]'.
            return '[object ' + (errorObj.name || 'Error') + ']';
        }

        return str;
    },
    'webkit',
    function(errorObj) {

        /**
         * @method errorAsString
         * @summary Returns a String representation of the supplied Error
         *     object.
         * @param {Error} errorObj The Error object to obtain the String
         *     representation of.
         * @returns {String} A String representation of the supplied Error
         *     object.
         */

        var str,
            file,
            start;

        if (TP.notEmpty(str = errorObj.message)) {
            //  In addition to the standard property of 'message', Webkit
            //  also supports 'sourceURL' and 'line' (which we describe as
            //  'file' and 'line' to be consistent with Gecko)

            if (TP.notEmpty(errorObj.sourceURL)) {
                file = true;
                str += ' &#171; ' + errorObj.sourceURL;
            }

            if (TP.notEmpty(errorObj.line)) {
                str += '#line(' + errorObj.line + ')';
            }

            //  Webkit also supports line 'begin' and 'end' offsets
            if (TP.notEmpty(errorObj.expressionBeginOffset)) {
                start = true;
                str += '[' + errorObj.expressionBeginOffset + ':';
            }

            if (TP.notEmpty(errorObj.expressionEndOffset)) {
                str += errorObj.expressionEndOffset;
            }

            if (start) {
                str += ']';
            }

            if (file) {
                str += ' &#187;';
            }

        } else {
            //  If there's no real message, just use '[object Error]'.
            return '[object ' + (errorObj.name || 'Error') + ']';
        }

        return str;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('getStackInfo',
TP.hc(
    'test',
    TP.sys.getBrowser,
    'firefox',
    function(errorObj) {

        /**
         * @method getStackInfo
         * @summary Extracts stack information from the supplied Error object.
         * @description This method returns an Array of function names, file
         *     names and line numbers from stack information provided by the
         *     supplied Error object:
         *          [function name, file name, line number]
         * @param {Error} errorObj The Error object to obtain the stack
         *     information from.
         * @returns {String[]} An Array of Strings containing stack information.
         */

        var err,
            entries,
            str,
            match,
            results,
            i;

        err = errorObj;
        if (!err) {
            try {
                throw new Error('StackDump');
            } catch (e) {
                err = e;
            }
        }

        entries = null;

        if (TP.notEmpty(str = err.stack)) {
            entries = str.
                replace(/(?:\n@:0)?\s+$/m, '').
                replace(/^(?:\((\S*)\))?@/gm, '{anonymous}($1)@').
                split('\n');
        }

        if (TP.notEmpty(entries)) {
            results = TP.ac();
            for (i = 0; i < entries.getSize(); i++) {
                //  Iterate over each 'entry' and split out the:
                //      function name
                //      file name where the function is found
                //      line number in the file where the function is found
                match = TP.regex.CALL_STACK_ENTRY_SPLITTER.exec(entries.at(i));
                if (TP.canInvoke(match, 'slice')) {
                    results.push(match.slice(1));
                }
            }
        }

        if (err.message === 'StackDump') {
            results.shift();
        }

        return results;
    },
    'safari',
    function(errorObj) {

        /**
         * @method getStackInfo
         * @summary Extracts stack information from the supplied Error object.
         * @description This method returns an Array of function names, file
         *     names and line numbers from stack information provided by the
         *     supplied Error object:
         *          [function name, file name, line number]
         * @param {Error} errorObj The Error object to obtain the stack
         *     information from.
         * @returns {String[]} An Array of Strings containing stack information.
         */

        var err,
            entries,
            str,
            results,
            match,
            i;

        err = errorObj;
        if (!err) {
            try {
                throw new Error('StackDump');
            } catch (e) {
                err = e;
            }
        }

        entries = null;

        if (TP.notEmpty(str = err.stack)) {
            entries = str.
                replace(/\[native code\]\n/m, '').
                replace(/^(?=\w+Error:).*$\n/m, '').
                replace(/^@/gm, '{anonymous}()@').
                split('\n');
        }

        if (TP.notEmpty(entries)) {
            results = TP.ac();
            for (i = 0; i < entries.getSize(); i++) {
                //  Iterate over each 'entry' and split out the:
                //      function name
                //      file name where the function is found
                //      line number in the file where the function is found
                match = TP.regex.CALL_STACK_ENTRY_SPLITTER.exec(entries.at(i));
                if (TP.canInvoke(match, 'slice')) {
                    results.push(match.slice(1));
                }
            }
        }

        if (err.message === 'StackDump') {
            results.shift();
        }

        return results;
    },
    'chrome',
    function(errorObj) {

        /**
         * @method getStackInfo
         * @summary Extracts stack information from the supplied Error object.
         * @description This method returns an Array of function names, file
         *     names and line numbers from stack information provided by the
         *     supplied Error object:
         *          [function name, file name, line number, character number]
         * @param {Error} errorObj The Error object to obtain the stack
         *     information from.
         * @returns {String[]} An Array of Strings containing stack information.
         */

        var err,
            entries,
            str,
            results,
            i,
            entry;

        err = errorObj;
        if (!err) {
            try {
                throw new Error('StackDump');
            } catch (e) {
                err = e;
            }
        }

        entries = null;

        if (TP.notEmpty(str = err.stack)) {
            entries =
                (str + '\n').
                replace(/^[\s\S]+?\s+at\s+/, ' at ').   //  remove message
                replace(/^\s+(at eval )?at\s+/gm, '').  //  remove 'at' and
                                                        //  indentation
                replace(/^([^\(]+?)([\n$])/gm, '{anonymous}() ($1)$2').
                replace(/^Object.<anonymous>\s*\(([^\)]+)\)/gm,
                        '{anonymous}() ($1)').
                replace(/^(.+) \((.+)\)$/gm, '$1@$2').
                split('\n').
                slice(0, -1);
        }

        if (TP.notEmpty(entries)) {
            results = TP.ac();
            for (i = 0; i < entries.getSize(); i++) {
                //  Iterate over each 'entry' and split out the:
                //      function name
                //      file name where the function is found
                //      line number in the file where the function is found
                //      character number where the error occurred
                if (TP.notValid(entry = TP.regex.CALL_STACK_ENTRY_SPLITTER.exec(
                                                entries.at(i)))) {
                    results.push(TP.ac(entries.at(i)));
                    continue;
                }

                entry = entry.slice(1);

                //  Because of the RegExp used, the 'character number' entry
                //  will have a colon (':') prepended to it (if it exists).
                //  Strip that.
                if (TP.notEmpty(entry.at(3))) {
                    entry.atPut(3, entry.at(3).strip(/:/));
                }

                //  Push the entry
                results.push(entry);
            }
        }

        if (err.message === 'StackDump') {
            results.shift();
        }

        return results;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('$setPrivilegeFlag',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(setting) {

        /**
         * @method $setPrivilegeFlag
         * @summary Sets the privilege flag of the supplied privileged
         *     operation to the supplied setting.
         */

        //  On Mozilla, we ask for all permissions, so we set all privilege
        //  flags to the same settings.

        TP.PRIVILEGE_FLAGS.atPut(TP.SHOW_ABOUT, setting);

        TP.PRIVILEGE_FLAGS.atPut(TP.READ_HISTORY, setting);

        //  Reading and writing preferences actually requires capabilities
        //  that we don't ask for.
        // TP.PRIVILEGE_FLAGS.atPut(TP.READ_PREFERENCE, setting);
        // TP.PRIVILEGE_FLAGS.atPut(TP.WRITE_PREFERENCE, setting);

        TP.PRIVILEGE_FLAGS.atPut(TP.MANIPULATE_WINDOW, setting);
        TP.PRIVILEGE_FLAGS.atPut(TP.READ_EXECUTION_STACK, setting);
        TP.PRIVILEGE_FLAGS.atPut(TP.ACCESS_XDOMAIN_FRAME, setting);
        TP.PRIVILEGE_FLAGS.atPut(TP.ACCESS_DOM_INSPECT, setting);

        TP.PRIVILEGE_FLAGS.atPut(TP.ACCESS_XDOMAIN_XMLHTTP, setting);
        TP.PRIVILEGE_FLAGS.atPut(TP.HOST_XSLT_EXEC, setting);

        TP.PRIVILEGE_FLAGS.atPut(TP.HOST_FILE_DELETE, setting);
        TP.PRIVILEGE_FLAGS.atPut(TP.HOST_FILE_SAVE, setting);
        TP.PRIVILEGE_FLAGS.atPut(TP.HOST_FILE_ACCESS, setting);
        TP.PRIVILEGE_FLAGS.atPut(TP.HOST_CMD_EXEC, setting);

        return;
    },
    'webkit',
    function() {

        /**
         * @method $setPrivilegeFlag
         * @summary Sets the privilege flag of the supplied privileged
         *     operation to the supplied setting.
         */

        //  On Webkit, this is a no-op.

        return;
    }
));

//  ------------------------------------------------------------------------
//  COMMON UTILITY ROUTINES
//  ------------------------------------------------------------------------

TP.definePrimitive('$nodeToString',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function() {
        //  This is a no-op for Gecko.
        return;
    },
    'webkit',
    function(aNode) {

        /**
         * @method $nodeToString
         * @summary Returns a 'representational' String of the supplied Node.
         * @description Because Webkit does such a poor job of printing a
         *     reasonable representation of Nodes, we take in Nodes here and
         *     produce the same String that Gecko produces.
         * @param {Node} aNode The Node to produce a representational String
         *     for.
         * @returns {String} The representational String for the supplied Node.
         * @exception TP.sig.InvalidNode Raised when an invalid Node has been
         *     supplied to the method.
         */

        var str,
            domName;

        if (!TP.isNode(aNode)) {
            return TP.raise(this, 'TP.sig.InvalidNode');
        }

        //  NB: This test is 'special-cased' as regular HTML documents test
        //  as 'true' for the TP.isNode() test and we'll get a 'less
        //  correct' String representation.
        if (TP.isHTMLDocument(aNode)) {
            return '[object HTMLDocument]';
        }

        str = '[object ';

        switch (aNode.nodeType) {
            case Node.ELEMENT_NODE:

                //  If its an element, try to see if its an HTML element
                //  based on its tag name.
                if (TP.isString(domName = TP.HTML_DOM_NAMES.at(
                        TP.elementGetLocalName(aNode).toLowerCase()))) {
                    str += domName;
                } else {
                    str += 'Element';
                }

                break;

            case Node.ATTRIBUTE_NODE:

                str += 'Attr';
                break;

            case Node.DOCUMENT_NODE:

                str += 'XMLDocument';
                break;

            case Node.TEXT_NODE:

                str += 'Text';
                break;

            case Node.CDATA_SECTION_NODE:

                str += 'CDATASection';
                break;

            case Node.ENTITY_REFERENCE_NODE:

                str += 'EntityReference';
                break;

            case Node.ENTITY_NODE:

                str += 'Entity';
                break;

            case Node.PROCESSING_INSTRUCTION_NODE:

                str += 'ProcessingInstruction';
                break;

            case Node.COMMENT_NODE:

                str += 'Comment';
                break;

            case Node.DOCUMENT_TYPE_NODE:

                str += 'DocumentType';
                break;

            case Node.DOCUMENT_FRAGMENT_NODE:

                str += 'DocumentFragment';
                break;

            case Node.NOTATION_NODE:

                str += 'Notation';
                break;

            default:

                str += 'Node';
                break;
        }

        str += ']';

        return str;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('objectToString',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(anObject) {

        /**
         * @method objectToString
         * @summary Returns a 'representational String' of anObject.
         * @description This function is mostly used when the object in question
         *     cannot respond to toString(). In IE, this happens quite often
         *     with DOM / XML objects because they're not real JavaScript
         *     objects, but ActiveX objects :-(. For most browsers this function
         *     rarely has to simulate a string since virtually everything is a
         *     valid JS Object instance.
         * @param {Object} anObject The object to return the representational
         *     String of.
         * @example Get the string representation for the object:
         *     <code>
         *          TP.objectToString('hi');
         *          <samp>hi</samp>
         *          TP.objectToString(42);
         *          <samp>42</samp>
         *          TP.objectToString(true);
         *          <samp>true</samp>
         *          TP.objectToString(TP.ac(1,2,3));
         *          <samp>1, 2, 3</samp>
         *          TP.objectToString(TP.dc());
         *          <samp></samp>
         *          TP.objectToString(TP.hc('lname', 'Smith'));
         *          <samp>TP.core.Hash_11195e8e7fdcb31af18d399f</samp>
         *          TP.objectToString(window);
         *          <samp>[object DOMWindow]</samp>
         *          TP.objectToString(window.document);
         *          <samp>[object HTMLDocument]</samp>
         *          TP.objectToString(document.documentElement);
         *          <samp>[object HTMLHtmlElement]</samp>
         *          TP.objectToString(TP.documentGetBody(document).attributes);
         *          <samp>[object NamedNodeMap]</samp>
         *          TP.objectToString(TP.documentGetBody(document).childNodes);
         *          <samp>[object NodeList]</samp>
         *          TP.objectToString(TP.lang.Object.construct());
         *          <samp>TP.lang.Object_11195ea9ded7b7e55b8b5207</samp>
         *     </code>
         * @returns {String} The 'representational String' of the Object.
         */

        var str,
            match;

        if (TP.isNull(anObject)) {
            return '[object Null]';
        }

        if (TP.notDefined(anObject)) {
            return '[object Undefined]';
        }

        //  XMLHttpRequest can have permission issues, so check early
        if (TP.isXHR(anObject)) {
            return '[object XMLHttpRequest]';
        }

        //  error objects are a little special, can't always work with them
        //  as instrumented objects so we'll do it manually
        if (TP.isError(anObject)) {
            return '[object ' + (anObject.name || 'Error') + ']';
        }

        //  anchors are special, they don't output [object HTMLAnchorElement] as
        //  they should, they try to output their href
        if (TP.isElement(anObject) && anObject.tagName.toUpperCase() === 'A') {
            return '[object HTMLAnchorElement]';
        }

        if (TP.isWindow(anObject)) {
            return '[object DOMWindow]';
        }

        if (TP.isNodeList(anObject)) {
            return '[object NodeList]';
        }

        if (TP.isNamedNodeMap(anObject)) {
            return '[object NamedNodeMap]';
        }

        if (TP.isStyleDeclaration(anObject)) {
            return '[object CSSStyleDeclaration]';
        }

        if (TP.canInvoke(anObject, 'toString')) {
            try {
                str = anObject.toString();
            } catch (e) {
                str = Object.prototype.toString.call(anObject);
            }

            if (TP.regex.INSTANCE_OID.test(str)) {
                str = '[object ' + TP.tname(anObject) + ']';
            } else if (TP.regex.NATIVE_CODE.test(str) &&
                                TP.isNativeType(anObject)) {

                //  NB: Do *not* rewrite as "TP.name('anObject')" or this call
                //  will endlessly recurse.

                /* eslint-disable no-extra-parens */
                if ((match = str.match(/function (\w+)/))) {
                    str = match[1];
                }
                /* eslint-enable no-extra-parens */
            }

            return str;
        }

        if (TP.isInvalidDate(anObject)) {
            return 'InvalidDate';
        }

        //  Sometimes isNaN() will throw if it can't convert to a Number
        //  NB: DO NOT move this line above the 'toString()' line. NaN is a
        //  weird value and won't test properly.
        try {

            //  NB: Firefox can occasionally hang at 100% CPU  on the native
            //  isNaN call if handed an 'orphaned' (i.e. prototype-less) object,
            //  so we check for the __proto__ slot here as well.
            /* eslint-disable no-proto */
            if (TP.isValid(anObject.__proto__) && isNaN(anObject)) {
                return 'NaN';
            }
            /* eslint-enable no-proto */
        } catch (e) {
            //  empty
        }

        //  if all else fails punt
        return '[object Object]';
    },
    'webkit',
    function(anObject) {

        /**
         * @method objectToString
         * @alias tostr
         * @summary Returns a 'representational String' of anObject.
         * @description This function is mostly used when the object in question
         *     cannot respond to toString(). In IE, this happens quite often
         *     with DOM / XML objects because they're not real JavaScript
         *     objects, but ActiveX objects :-(. For Webkit based browsers this
         *     function rarely has to simulate a string since virtually
         *     everything is a valid JS Object instance.
         * @param {Object} anObject The object to return the representational
         *     String of.
         * @example Get the string representation for the object:
         *     <code>
         *          TP.objectToString('hi');
         *          <samp>hi</samp>
         *          TP.objectToString(42);
         *          <samp>42</samp>
         *          TP.objectToString(true);
         *          <samp>true</samp>
         *          TP.objectToString(TP.ac(1,2,3));
         *          <samp>1,2,3</samp>
         *          TP.objectToString(TP.dc());
         *          <samp>Tue Mar 27 2007 18:17:27 GMT-0600 (MDT)</samp>
         *          TP.objectToString(TP.hc('lname', 'Smith'));
         *          <samp>TP.core.Hash_11195e8e7fdcb31af18d399f</samp>
         *          TP.objectToString(window);
         *          <samp>[object DOMWindow]</samp>
         *          TP.objectToString(window.document);
         *          <samp>[object HTMLDocument]</samp>
         *          TP.objectToString(document.documentElement);
         *          <samp>[object HTMLHtmlElement]</samp>
         *          TP.objectToString(TP.documentGetBody(document).attributes);
         *          <samp>[object NamedNodeMap]</samp>
         *          TP.objectToString(TP.documentGetBody(document).childNodes);
         *          <samp>[object NodeList]</samp>
         *          TP.objectToString(TP.lang.Object.construct());
         *          <samp>TP.lang.Object_11195ea9ded7b7e55b8b5207</samp>
         *     </code>
         * @returns {String} The 'representational String' of the Object.
         */

        var str,
            match;

        if (TP.isNull(anObject)) {
            return '[object Null]';
        }

        if (TP.notDefined(anObject)) {
            return '[object Undefined]';
        }

        //  XMLHttpRequest can have permission issues, so check early
        if (TP.isXHR(anObject)) {
            return '[object XMLHttpRequest]';
        }

        //  NOTE that we test for documents before we move on to general
        //  nodes
        if (TP.isHTMLDocument(anObject)) {
            return '[object HTMLDocument]';
        }

        if (TP.isXMLDocument(anObject)) {
            return '[object XMLDocument]';
        }

        //  native nodes are the next-most likely object being passed to
        //  this routine, so we'll try to build up a proper string here
        if (TP.isNode(anObject)) {
            return TP.$nodeToString(anObject);
        }

        //  error objects are a little special, can't always work with them
        //  as instrumented objects so we'll do it manually
        if (TP.isError(anObject)) {
            return '[object ' + (anObject.name || 'Error') + ']';
        }

        //  anchors are special, they don't output
        //  [object HTMLAnchorElement] as they should, they try to output
        //  their href
        if (TP.isElement(anObject) && anObject.tagName.toUpperCase() === 'A') {
            return '[object HTMLAnchorElement]';
        }

        if (TP.isWindow(anObject)) {
            return '[object DOMWindow]';
        }

        if (TP.isNodeList(anObject)) {
            return '[object NodeList]';
        }

        if (TP.isNamedNodeMap(anObject)) {
            return '[object NamedNodeMap]';
        }

        if (TP.isStyleDeclaration(anObject)) {
            return '[object CSSStyleDeclaration]';
        }

        if (TP.canInvoke(anObject, 'toString')) {
            try {
                str = anObject.toString();
            } catch (e) {
                str = Object.prototype.toString.call(anObject);
            }
            if (TP.regex.INSTANCE_OID.test(str)) {
                str = '[object ' + TP.tname(anObject) + ']';
            } else if (TP.regex.NATIVE_CODE.test(str) &&
                                TP.isNativeType(anObject)) {

                //  NB: Do *not* rewrite as "TP.name('anObject')" or this call
                //  will endlessly recurse.

                /* eslint-disable no-extra-parens */
                if ((match = str.match(/function (\w+)/))) {
                    str = match[1];
                }
                /* eslint-enable no-extra-parens */
            }

            return str;
        }

        if (TP.isInvalidDate(anObject)) {
            return 'InvalidDate';
        }

        //  Sometimes isNaN() will throw if it can't convert to a Number
        //  NB: DO NOT move this line above the 'toString()' line. NaN is a
        //  weird value and won't test properly.
        try {
            if (isNaN(anObject)) {
                return 'NaN';
            }
        } catch (e) {
            //  empty
        }

        //  if all else fails punt
        return '[object Object]';
    }
));

//  ------------------------------------------------------------------------

//  NOTE that this won't be bound...but it doesn't reference 'this'
TP.definePrimitive('tostr', TP.objectToString);

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETPrimitivesPost.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
*/

//  ------------------------------------------------------------------------
//  HTML Entities
//  ------------------------------------------------------------------------

//  NB: Almost all of these are encoded in Unicode to avoid escaping
//  problems, etc. in IE.

//  Note that these keys are missing their leading '&' and trailing ';', due
//  to the way that TP.htmlEntitiesToLiterals() works.
TP.HTML_ENTITIES_TO_LITERALS =
    TP.hc(
            'aacute', '\u00c1',     //  Á
            'aacute', '\u00e1',     //  á
            'acirc', '\u00c2',      //  Â
            'acirc', '\u00e2',      //  â
            'aelig', '\u00c6',      //  Æ
            'aelig', '\u00e6',      //  æ
            'agrave', '\u00c0',     //  À
            'agrave', '\u00e0',     //  à
            'amp', '&',
            'apos', '\'',
            'aring', '\u00c5',      //  Å
            'aring', '\u00e5',      //  å
            'atilde', '\u00c3',     //  Ã
            'atilde', '\u00e3',     //  ã,
            'auml', '\u00c4',       //  Ä
            'auml', '\u00e4',       //  ä
            'ccedil', '\u00c7',     //  Ç
            'ccedil', '\u00e7',     //  ç
            'cent', '\u00a2',       //  ¢
            'copy', '\u00a9',       //  ©
            'divide', '\u00f7',     //  ÷
            'eacute', '\u00c9',     //  É
            'eacute', '\u00e9',     //  é
            'ecirc', '\u00ca',      //  Ê
            'ecirc', '\u00ea',      //  ê
            'egrave', '\u00c8',     //  È
            'egrave', '\u00e8',     //  è
            'euml', '\u00cb',       //  Ë
            'euml', '\u00eb',       //  ë
            'euro', '\u20ac',       //  €
            'gt', '>',
            'iacute', '\u00cd',     //  Í
            'iacute', '\u00ed',     //  í
            'icirc', '\u00ce',      //  Î
            'icirc', '\u00ee',      //  î
            'iexcl', '\u00a1',      //  ¡
            'igrave', '\u00cc',     //  Ì
            'igrave', '\u00ec',     //  ì
            'iquest', '\u00bf',     //  ¿
            'iuml', '\u00cf',       //  Ï
            'iuml', '\u00ef',       //  ï
            'laquo', '\u00ab',      //  «
            'lt', '<',
            'mdash', '\u2014',      //  mdash
            'micro', '\u00b5',      //  µ
            'middot', '\u00b7',     //  ·
            'nbsp', '\u00a0',
            'ndash', '\u2013',      //  ndash
            'ntilde', '\u00d1',     //  Ñ
            'ntilde', '\u00f1',     //  ñ
            'oacute', '\u00d3',     //  Ó
            'oacute', '\u00f3',     //  ó
            'ocirc', '\u00d4',      //  Ô
            'ocirc', '\u00f4',      //  ô
            'ograve', '\u00d2',     //  Ò
            'ograve', '\u00f2',     //  ò
            'oslash', '\u00d8',     //  Ø
            'oslash', '\u00f8',     //  ø
            'otilde', '\u00d5',     //  Õ
            'otilde', '\u00f5',     //  õ
            'ouml', '\u00d6',       //  Ö
            'ouml', '\u00f6',       //  ö
            'para', '\u00b6',       //  ¶
            'plusmn', '\u00b1',     //  ±
            'pound', '\u00a3',      //  £
            'quot', '"',
            'raquo', '\u00bb',      //  »
            'reg', '\u00ae',        //  ®
            'sect', '\u00a7',       //  §
            'szlig', '\u00df',      //  ß
            'uacute', '\u00da',     //  Ú
            'uacute', '\u00fa',     //  ú
            'ucirc', '\u00db',      //  Û
            'ucirc', '\u00fb',      //  û
            'ugrave', '\u00d9',     //  Ù
            'ugrave', '\u00f9',     //  ù
            'uuml', '\u00dc',       //  Ü
            'uuml', '\u00fc',       //  ü
            'yen', '\u00a5',        //  ¥
            'yuml', '\u00ff'        //  ÿ
    );

//  ---

//  If 'replaceSpaces' is true, we should be replacing ' ' with '&nbsp;'
TP.HTML_LITERALS_TO_ENTITIES =
    TP.hc(
            '\u00a0', '&#160;',     //  space
            '\u00a1', '&#161;',     //  ¡
            '\u00a2', '&#162;',     //  ¢
            '\u00a3', '&#163;',     //  £
            '\u00a5', '&#165;',     //  ¥
            '\u00a7', '&#167;',     //  §
            '\u00a9', '&#169;',     //  ©
            '\u00ab', '&#171;',     //  «
            '\u00ae', '&#174;',     //  ®
            '\u00b1', '&#177;',     //  ±
            '\u00b4', '&#180;',     //  ´
            '\u00b5', '&#181;',     //  µ
            '\u00b6', '&#182;',     //  ¶
            '\u00b7', '&#183;',     //  ·
            '\u00bb', '&#187;',     //  »
            '\u00bf', '&#191;',     //  ¿
            '\u00c0', '&#192;',     //  À
            '\u00c1', '&#193;',     //  Á
            '\u00c2', '&#194;',     //  Â
            '\u00c3', '&#195;',     //  Ã
            '\u00c4', '&#196;',     //  Ä
            '\u00c5', '&#197;',     //  Å
            '\u00c6', '&#198;',     //  Æ
            '\u00c7', '&#199;',     //  Ç
            '\u00c8', '&#200;',     //  È
            '\u00c9', '&#201;',     //  É
            '\u00ca', '&#202;',     //  Ê
            '\u00cb', '&#203;',     //  Ë
            '\u00cc', '&#204;',     //  Ì
            '\u00cd', '&#205;',     //  Í
            '\u00ce', '&#206;',     //  Î
            '\u00cf', '&#207;',     //  Ï
            '\u00d1', '&#209;',     //  Ñ
            '\u00d2', '&#210;',     //  Ò
            '\u00d3', '&#211;',     //  Ó
            '\u00d4', '&#212;',     //  Ô
            '\u00d5', '&#213;',     //  Õ
            '\u00d6', '&#214;',     //  Ö
            '\u00d8', '&#216;',     //  Ø
            '\u00d9', '&#217;',     //  Ù
            '\u00da', '&#218;',     //  Ú
            '\u00db', '&#219;',     //  Û
            '\u00dc', '&#220;',     //  Ü
            '\u00df', '&#223;',     //  ß
            '\u00e0', '&#224;',     //  à
            '\u00e1', '&#225;',     //  á
            '\u00e2', '&#226;',     //  â
            '\u00e3', '&#227;',     //  ã
            '\u00e4', '&#228;',     //  ä
            '\u00e5', '&#229;',     //  å
            '\u00e6', '&#230;',     //  æ
            '\u00e7', '&#231;',     //  ç
            '\u00e8', '&#232;',     //  è
            '\u00e9', '&#233;',     //  é
            '\u00ea', '&#234;',     //  ê
            '\u00eb', '&#235;',     //  ë
            '\u00ec', '&#236;',     //  ì
            '\u00ed', '&#237;',     //  í
            '\u00ee', '&#238;',     //  î
            '\u00ef', '&#239;',     //  ï
            '\u00f1', '&#241;',     //  ñ
            '\u00f2', '&#242;',     //  ò
            '\u00f3', '&#243;',     //  ó
            '\u00f4', '&#244;',     //  ô
            '\u00f5', '&#245;',     //  õ
            '\u00f6', '&#246;',     //  ö
            '\u00f7', '&#247;',     //  ÷
            '\u00f8', '&#248;',     //  ø
            '\u00f9', '&#249;',     //  ù
            '\u00fa', '&#250;',     //  ú
            '\u00fb', '&#251;',     //  û
            '\u00fc', '&#252;',     //  ü
            '\u00ff', '&#255;',     //  ÿ
            '\u0022', '&#34;',      //  "
            '\u0026', '&#38;',      //  &
            '\u0027', '&#39;',      //  '
            '\u003c', '&#60;',      //  <
            '\u003e', '&#62;',      //  >
            '\u2013', '&#8211;',    //  ndash
            '\u2014', '&#8212;',    //  mdash
            '\u20ac', '&#8364;',    //  €
            '\u0060', '&#96;',      //  `
            '\u00c1', '&aacute;',   //  Á
            '\u00e1', '&aacute;',   //  á
            '\u00c2', '&acirc;',    //  Â
            '\u00e2', '&acirc;',    //  â
            '\u00c6', '&aelig;',    //  Æ
            '\u00e6', '&aelig;',    //  æ
            '\u00c0', '&agrave;',   //  À
            '\u00e0', '&agrave;',   //  à
            '&', '&amp;',
            '\'', '&apos;',
            '\u00c5', '&aring;',    //  Å
            '\u00e5', '&aring;',    //  å
            '\u00c3', '&atilde;',   //  Ã
            '\u00e3', '&atilde;',   //  ã
            '\u00c4', '&auml;',     //  Ä
            '\u00e4', '&auml;',     //  ä
            '\u00c7', '&ccedil;',   //  Ç
            '\u00e7', '&ccedil;',   //  ç
            '\u00a2', '&cent;',     //  ¢
            '\u00a9', '&copy;',     //  ©
            '\u00f7', '&divide;',   //  ÷
            '\u00c9', '&eacute;',   //  É
            '\u00e9', '&eacute;',   //  é
            '\u00ca', '&ecirc;',    //  Ê
            '\u00ea', '&ecirc;',    //  ê
            '\u00c8', '&egrave;',   //  È
            '\u00e8', '&egrave;',   //  è
            '\u00cb', '&euml;',     //  Ë
            '\u00eb', '&euml;',     //  ë
            '\u20ac', '&euro;',     //  €
            '>', '&gt;',
            '\u00cd', '&iacute;',   //  Í
            '\u00ed', '&iacute;',   //  í
            '\u00ce', '&icirc;',    //  Î
            '\u00ee', '&icirc;',    //  î
            '\u00a1', '&iexcl;',    //  ¡
            '\u00cc', '&igrave;',   //  Ì
            '\u00ec', '&igrave;',   //  ì
            '\u00bf', '&iquest;',   //  ¿
            '\u00cf', '&iuml;',     //  Ï
            '\u00ef', '&iuml;',     //  ï
            '\u00ab', '&laquo;',    //  «
            '<', '&lt;',
            '\u2014', '&mdash;',    //  mdash
            '\u00b5', '&micro;',    //  µ
            '\u00b7', '&middot;',   //  ·
            '\u00a0', '&nbsp;',
            '\u2013', '&ndash;',    //  ndash
            '\u00d1', '&ntilde;',   //  Ñ
            '\u00f1', '&ntilde;',   //  ñ
            '\u00d3', '&oacute;',   //  Ó
            '\u00f3', '&oacute;',   //  ó
            '\u00d4', '&ocirc;',    //  Ô
            '\u00f4', '&ocirc;',    //  ô
            '\u00d2', '&ograve;',   //  Ò
            '\u00f2', '&ograve;',   //  ò
            '\u00d8', '&oslash;',   //  Ø
            '\u00f8', '&oslash;',   //  ø
            '\u00d5', '&otilde;',   //  Õ
            '\u00f5', '&otilde;',   //  õ
            '\u00d6', '&ouml;',     //  Ö
            '\u00f6', '&ouml;',     //  ö
            '\u00b6', '&para;',     //  ¶
            '\u00b1', '&plusmn;',   //  ±
            '\u00a3', '&pound;',    //  £
            '"', '&quot;',
            '\u00bb', '&raquo;',    //  »
            '\u00ae', '&reg;',      //  ®
            '\u00a7', '&sect;',     //  §
            '\u00df', '&szlig;',    //  ß
            '\u00da', '&uacute;',   //  Ú
            '\u00fa', '&uacute;',   //  ú
            '\u00db', '&ucirc;',    //  Û
            '\u00fb', '&ucirc;',    //  û
            '\u00d9', '&ugrave;',   //  Ù
            '\u00f9', '&ugrave;',   //  ù
            '\u00dc', '&uuml;',     //  Ü
            '\u00fc', '&uuml;',     //  ü
            '\u00a5', '&yen;',      //  ¥
            '\u00ff', '&yuml;'      //  ÿ
    );

//  ---

//  Note that apos, quot, amp, lt and gt aren't mentioned, since they're the
//  same for both.
TP.HTML_ENTITIES_TO_XML_ENTITIES =
    TP.hc(
            'aacute', '&#193;',
            'acirc', '&#194;',
            'aelig', '&#198;',
            'agrave', '&#192;',
            'amp', '&#38;',
            'aring', '&#197;',
            'atilde', '&#195;',
            'auml', '&#196;',
            'ccedil', '&#199;',
            'cent', '&#162;',
            'copy', '&#169;',
            'divide', '&#247;',
            'eacute', '&#201;',
            'ecirc', '&#202;',
            'egrave', '&#200;',
            'euml', '&#203;',
            'euro', '&#8364;',
            'iacute', '&#205;',
            'icirc', '&#206;',
            'iexcl', '&#161;',
            'igrave', '&#204;',
            'iquest', '&#191;',
            'iuml', '&#207;',
            'laquo', '&#171;',
            'mdash', '&#8212;',
            'micro', '&#181;',
            'middot', '&#183;',
            'nbsp', '&#160;',
            'ndash', '&#8211;',
            'ntilde', '&#209;',
            'oacute', '&#211;',
            'ocirc', '&#212;',
            'ograve', '&#210;',
            'oslash', '&#216;',
            'otilde', '&#213;',
            'ouml', '&#214;',
            'para', '&#182;',
            'plusmn', '&#177;',
            'pound', '&#163;',
            'raquo', '&#187;',
            'reg', '&#174;',
            'sect', '&#167;',
            'szlig', '&#223;',
            'uacute', '&#218;',
            'ucirc', '&#219;',
            'ugrave', '&#217;',
            'uuml', '&#220;',
            'yen', '&#165;',
            'yuml', '&#255;'
    );

//  ------------------------------------------------------------------------
//  XML Entities
//  ------------------------------------------------------------------------

//  Note that these keys are missing their leading '&' and trailing ';', due
//  to the way that TP.xmlEntitiesToLiterals() works.
TP.XML_ENTITIES_TO_LITERALS =
    TP.hc(
            'amp', '&',
            'apos', '\'',
            'gt', '>',
            'lt', '<',
            'nbsp', '\u00a0',
            'quot', '"'
    );

//  ---

//  If 'replaceSpaces' is true, we should be replacing ' ' with '&#160;'
TP.XML_LITERALS_TO_ENTITIES =
    TP.hc(
            '\u00a0', '&#160;',     //  space
            '\u00a1', '&#161;',     //  ¡
            '\u00a2', '&#162;',     //  ¢
            '\u00a3', '&#163;',     //  £
            '\u00a5', '&#165;',     //  ¥
            '\u00a7', '&#167;',     //  §
            '\u00a9', '&#169;',     //  ©
            '\u00ab', '&#171;',     //  «
            '\u00ae', '&#174;',     //  ®
            '\u00b1', '&#177;',     //  ±
            '\u00b4', '&#180;',     //  ´
            '\u00b5', '&#181;',     //  µ
            '\u00b6', '&#182;',     //  ¶
            '\u00b7', '&#183;',     //  ·
            '\u00bb', '&#187;',     //  »
            '\u00bf', '&#191;',     //  ¿
            '\u00c0', '&#192;',     //  À
            '\u00c1', '&#193;',     //  Á
            '\u00c2', '&#194;',     //  Â
            '\u00c3', '&#195;',     //  Ã
            '\u00c4', '&#196;',     //  Ä
            '\u00c5', '&#197;',     //  Å
            '\u00c6', '&#198;',     //  Æ
            '\u00c7', '&#199;',     //  Ç
            '\u00c8', '&#200;',     //  È
            '\u00c9', '&#201;',     //  É
            '\u00ca', '&#202;',     //  Ê
            '\u00cb', '&#203;',     //  Ë
            '\u00cc', '&#204;',     //  Ì
            '\u00cd', '&#205;',     //  Í
            '\u00ce', '&#206;',     //  Î
            '\u00cf', '&#207;',     //  Ï
            '\u00d1', '&#209;',     //  Ñ
            '\u00d2', '&#210;',     //  Ò
            '\u00d3', '&#211;',     //  Ó
            '\u00d4', '&#212;',     //  Ô
            '\u00d5', '&#213;',     //  Õ
            '\u00d6', '&#214;',     //  Ö
            '\u00d8', '&#216;',     //  Ø
            '\u00d9', '&#217;',     //  Ù
            '\u00da', '&#218;',     //  Ú
            '\u00db', '&#219;',     //  Û
            '\u00dc', '&#220;',     //  Ü
            '\u00df', '&#223;',     //  ß
            '\u00e0', '&#224;',     //  à
            '\u00e1', '&#225;',     //  á
            '\u00e2', '&#226;',     //  â
            '\u00e3', '&#227;',     //  ã
            '\u00e4', '&#228;',     //  ä
            '\u00e5', '&#229;',     //  å
            '\u00e6', '&#230;',     //  æ
            '\u00e7', '&#231;',     //  ç
            '\u00e8', '&#232;',     //  è
            '\u00e9', '&#233;',     //  é
            '\u00ea', '&#234;',     //  ê
            '\u00eb', '&#235;',     //  ë
            '\u00ec', '&#236;',     //  ì
            '\u00ed', '&#237;',     //  í
            '\u00ee', '&#238;',     //  î
            '\u00ef', '&#239;',     //  ï
            '\u00f1', '&#241;',     //  ñ
            '\u00f2', '&#242;',     //  ò
            '\u00f3', '&#243;',     //  ó
            '\u00f4', '&#244;',     //  ô
            '\u00f5', '&#245;',     //  õ
            '\u00f6', '&#246;',     //  ö
            '\u00f7', '&#247;',     //  ÷
            '\u00f8', '&#248;',     //  ø
            '\u00f9', '&#249;',     //  ù
            '\u00fa', '&#250;',     //  ú
            '\u00fb', '&#251;',     //  û
            '\u00fc', '&#252;',     //  ü
            '\u00ff', '&#255;',     //  ÿ
            '\u0022', '&#34;',      //  "
            '\u0026', '&#38;',      //  &
            '\u0027', '&#39;',      //  '
            '\u003c', '&#60;',      //  <
            '\u003e', '&#62;',      //  >
            '\u2013', '&#8211;',    //  ndash
            '\u2014', '&#8212;',    //  mdash
            '\u20ac', '&#8364;',    //  €
            '\u0060', '&#96;',      //  `
            '\u00c1', '&#193;',     //  Á
            '\u00e1', '&#225;',     //  á
            '\u00c2', '&#194;',     //  Â
            '\u00e2', '&#226;',     //  â
            '\u00c6', '&#198;',     //  Æ
            '\u00e6', '&#230;',     //  æ
            '\u00c0', '&#192;',     //  À
            '\u00e0', '&#224;',     //  à
            '&', '&amp;',
            '\'', '&apos;',
            '\u00c5', '&#199;',     //  Å
            '\u00e5', '&#229;',     //  å
            '\u00c3', '&#195;',     //  Ã
            '\u00e3', '&#227;',     //  ã
            '\u00c4', '&#196;',     //  Ä
            '\u00e4', '&#228;',     //  ä
            '\u00c7', '&#199;',     //  Ç
            '\u00e7', '&#231;',     //  ç
            '\u00a2', '&#162;',     //  ¢
            '\u00a9', '&#169;',     //  ©
            '\u00f7', '&#247;',     //  ÷
            '\u00c9', '&#201;',     //  É
            '\u00e9', '&#233;',     //  é
            '\u00ca', '&#202;',     //  Ê
            '\u00ea', '&#234;',     //  ê
            '\u00c8', '&#200;',     //  È
            '\u00e8', '&#232;',     //  è
            '\u00cb', '&#203;',     //  Ë
            '\u00eb', '&#235;',     //  ë
            '\u20ac', '&#8364;',    //  €
            '>', '&gt;',
            '\u00cd', '&#205;',     //  Í
            '\u00ed', '&#237;',     //  í
            '\u00ce', '&#206;',     //  Î
            '\u00ee', '&#238;',     //  î
            '\u00a1', '&#161;',     //  ¡
            '\u00cc', '&#204;',     //  Ì
            '\u00ec', '&#236;',     //  ì
            '\u00bf', '&#191;',     //  ¿
            '\u00cf', '&#207;',     //  Ï
            '\u00ef', '&#239;',     //  ï
            '\u00ab', '&#171;',     //  «
            '<', '&lt;',
            '\u2014', '&#8212;',    //  mdash
            '\u00b5', '&#181;',     //  µ
            '\u00b7', '&#183;',     //  ·
            '\u00a0', '&nbsp;',
            '\u2013', '&#8211;',    //  ndash
            '\u00d1', '&#209;',     //  Ñ
            '\u00f1', '&#241;',     //  ñ
            '\u00d3', '&#211;',     //  Ó
            '\u00f3', '&#243;',     //  ó
            '\u00d4', '&#212;',     //  Ô
            '\u00f4', '&#244;',     //  ô
            '\u00d2', '&#210;',     //  Ò
            '\u00f2', '&#242;',     //  ò
            '\u00d8', '&#216;',     //  Ø
            '\u00f8', '&#248;',     //  ø
            '\u00d5', '&#213;',     //  Õ
            '\u00f5', '&#245;',     //  õ
            '\u00d6', '&#214;',     //  Ö
            '\u00f6', '&#246;',     //  ö
            '\u00b6', '&#182;',     //  ¶
            '\u00b1', '&#177;',     //  ±
            '\u00a3', '&#163;',     //  £
            '"', '&quot;',
            '\u00bb', '&#187;',     //  »
            '\u00ae', '&#174;',     //  ®
            '\u00a7', '&#167;',     //  §
            '\u00df', '&#223;',     //  ß
            '\u00da', '&#218;',     //  Ú
            '\u00fa', '&#250;',     //  ú
            '\u00db', '&#219;',     //  Û
            '\u00fb', '&#251;',     //  û
            '\u00d9', '&#217;',     //  Ù
            '\u00f9', '&#249;',     //  ù
            '\u00dc', '&#220;',     //  Ü
            '\u00fc', '&#252;',     //  ü
            '\u00a5', '&#165;',     //  ¥
            '\u00ff', '&#255;'      //  ÿ
    );

//  ---

//  Note that apos, quot, amp, lt and gt aren't mentioned, since they're the
//  same for both.
TP.XML_ENTITIES_TO_HTML_ENTITIES =
    TP.hc(
            '#193', '&aacute;',
            '#194', '&acirc;',
            '#198', '&aelig;',
            '#192', '&agrave;',
            '#38', '&amp;',
            '#197', '&aring;',
            '#195', '&atilde;',
            '#196', '&auml;',
            '#199', '&ccedil;',
            '#162', '&cent;',
            '#169', '&copy;',
            '#247', '&divide;',
            '#201', '&eacute;',
            '#202', '&ecirc;',
            '#200', '&egrave;',
            '#203', '&euml;',
            '#8364', '&euro;',
            '#205', '&iacute;',
            '#206', '&icirc;',
            '#161', '&iexcl;',
            '#204', '&igrave;',
            '#191', '&iquest;',
            '#207', '&iuml;',
            '#171', '&laquo;',
            '#8212', '&mdash;',
            '#181', '&micro;',
            '#183', '&middot;',
            '#160', '&nbsp;',
            '#8211', '&ndash;',
            '#209', '&ntilde;',
            '#211', '&oacute;',
            '#212', '&ocirc;',
            '#210', '&ograve;',
            '#216', '&oslash;',
            '#213', '&otilde;',
            '#214', '&ouml;',
            '#182', '&para;',
            '#177', '&plusmn;',
            '#163', '&pound;',
            '#187', '&raquo;',
            '#174', '&reg;',
            '#167', '&sect;',
            '#223', '&szlig;',
            '#218', '&uacute;',
            '#219', '&ucirc;',
            '#217', '&ugrave;',
            '#220', '&uuml;',
            '#165', '&yen;',
            '#255', '&yuml;'
    );

//  ------------------------------------------------------------------------
//  HTML "Types"
//  ------------------------------------------------------------------------

//  A constant containing names of HTML DOM elements. This is used in the
//  TP.$nodeToString() function for printing reasonable type names for
//  elements as IE does an extremely poor job of making this easy (ActiveX
//  objects, like those created in XML/XHTML documents, and
//  'instance-programmed' objects, like nodes in IE's HTML DOM) do not
//  respond to even simple JavaScript methods like 'toString()').

TP.HTML_DOM_NAMES =
    TP.hc(
            'a', 'HTMLAnchorElement',
            'applet', 'HTMLAppletElement',
            'area', 'HTMLAreaElement',
            'br', 'HTMLBrElement',
            'base', 'HTMLBaseElement',
            'basefont', 'HTMLBaseFontElement',
            'body', 'HTMLBodyElement',
            'button', 'HTMLButtonElement',
            'dl', 'HTMLDListElement',
            'dir', 'HTMLDirectoryElement',
            'div', 'HTMLDivElement',
            'embed', 'HTMLEmbedElement',
            'fieldset', 'HTMLFieldsetElement',
            'font', 'HTMLFontElement',
            'form', 'HTMLFormElement',
            'frame', 'HTMLFrameElement',
            'frameset', 'HTMLFramesetElement',
            'hr', 'HTMLHrElement',
            'head', 'HTMLHeadElement',
            'h1', 'HTMLHeadingElement',
            'h2', 'HTMLHeadingElement',
            'h3', 'HTMLHeadingElement',
            'h4', 'HTMLHeadingElement',
            'h5', 'HTMLHeadingElement',
            'h6', 'HTMLHeadingElement',
            'html', 'HTMLHtmlElement',
            'iframe', 'HTMLIframeElement',
            'img', 'HTMLImageElement',
            'input', 'HTMLInputElement',
            'isindex', 'HTMLIsIndexElement',
            'li', 'HTMLLIElement',
            'label', 'HTMLLabelElement',
            'legend', 'HTMLLegendElement',
            'link', 'HTMLLinkElement',
            'map', 'HTMLMapElement',
            'menu', 'HTMLMenuElement',
            'meta', 'HTMLMetaElement',
            'mod', 'HTMLModElement',
            'ol', 'HTMLOListElement',
            'object', 'HTMLObjectElement',
            'option', 'HTMLOptionElement',
            'optgroup', 'HTMLOptGroupElement',
            'p', 'HTMLParagraphElement',
            'param', 'HTMLParamElement',
            'pre', 'HTMLPreElement',
            'q', 'HTMLQuoteElement',
            'script', 'HTMLScriptElement',
            'select', 'HTMLSelectElement',
            'span', 'HTMLSpanElement',
            'style', 'HTMLStyleElement',
            'caption', 'HTMLTableCaptionElement',
            'td', 'HTMLTableCellElement',
            'col', 'HTMLTableColElement',
            'table', 'HTMLTableElement',
            'tr', 'HTMLTableRowElement',
            'tbody', 'HTMLTableSectionElement',
            'textarea', 'HTMLTextAreaElement',
            'title', 'HTMLTitleElement',
            'ul', 'HTMLUListElement'
    );

//  ------------------------------------------------------------------------
//  NATIVE TYPES
//  ------------------------------------------------------------------------

TP.sys.defineMethod('getNativeTypes',
function() {

    /**
     * @method getNativeTypes
     * @summary Returns an object containing the names and type objects for all
     *     native types. These types are those which are defined at some level
     *     in JavaScript or the DOM.
     * @returns {Object} A hash containing all of the native types in the
     *     system.
     */

    var nativeTypesKeys;

    //  Already computed this? Exit here.
    if (TP.isValid(TP.sys.$nativeTypes)) {
        return TP.sys.$nativeTypes;
    }

    //  If we havent' finalized yet we may not have the proper dictionaries in
    //  place to continue.
    if (TP.notValid(TP.sys.$extraglobals)) {
        return TP.hc();
    }

    //  Otherwise, we iterate over all of the keys from 'TP.sys.$extraglobals',
    //  do our best job filtering them, and make a new Hash.

    //  Filter out keys here where the first character isn't an uppercase letter
    //  (like a native type name would have) or where it starts with '__'.
    nativeTypesKeys = TP.sys.$extraglobals.getKeys().select(
            function(aKey) {
                if (TP.sys.$excludedGlobals.indexOf(aKey) === TP.NOT_FOUND) {
                    return TP.isNativeType(TP.global[aKey]);
                }
            });

    //  Allocate the native types hash and initialize with the key and the value
    //  obtained by accessing that key on the global object.
    TP.sys.$nativeTypes = TP.hc();
    nativeTypesKeys.perform(
            function(aKey) {
                TP.sys.$nativeTypes.atPut(aKey, TP.global[aKey]);
            });

    /*
       TODO: Figure out what we want to do about metadata here. These days it
       *is* possible to determine the 'supertype' chain of a native type, so
       we could be more sophisticated here rather than just supplying
       'Object' as the supertype of all.
    var len,
        i,
        name,
        item;


    //  Iterate and add metadata for the native types.
    len = nativeTypesKeys.getSize();
    for (i = 0; i < len; i++) {
        name = nativeTypesKeys.at(i);

        //  skip adding Object as a subtype of Object :)
        if (name === 'Object') {
            continue;
        }

        item = TP.sys.$nativeTypes.at(name);
        if (TP.isValid(item) && (item !== Infinity)) {
            //  NOTE that this isn't necessarily true, but we don't try
            //  too hard to get it right for native types
            TP.sys.addMetadata(null, item, TP.SUBTYPE);
        }
    }
    */

    return TP.sys.$nativeTypes;
});

//  ------------------------------------------------------------------------
//  SUPPORT
//  ------------------------------------------------------------------------

TP.definePrimitive('extractURIs',
function(aStr) {

    /**
     * @method extractURIs
     * @summary Returns URIs extracted from the String. This provided a much
     *     more sophisticated parsing mechanism than splitting and takes into
     *     account XPointer schemes embedded in the URI, etc.
     * @param {String} aStr The string to extract the URIs from.
     * @returns {String[]} An array of URI strings extracted from the supplied
     *     String.
     */

    var tokens,
        uris;

    //  Extract any 'uri' type tokens from the String. Note the 3rd 'true'
    //  parameter here denoting that we're parsing for 'TSH' constructs - which
    //  is what gives us more sophisticated URI parsing.
    tokens = TP.$tokenize(aStr, null, true).filter(
            function(tok) {
                return tok.name === 'uri';
            });

    //  Iterate over the tokens and get their value, which is the URI strings
    //  themselves.
    uris = tokens.collect(
            function(aToken) {
                return aToken.value;
            });

    return uris;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isLamaNode',
function(aNode) {

    /**
     * @method isLamaNode
     * @summary Returns whether the node exists in the Lama context (i.e. is a
     *     node that has been used to build the Lama, rather than a part of
     *     the author's application).
     * @param {Node} aNode The node to test.
     * @returns {Boolean} Whether or not the node is part of the Lama itself
     *     or not.
     */

    var backgroundElem;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    //  Make sure the Lama is running
    if (!TP.sys.hasFeature('lama')) {
        return false;
    }

    //  If it's a descendant under the 'background' element (but not in a canvas
    //  iframe), then it's part of the Lama.
    backgroundElem = TP.byId('background', TP.sys.getUIRoot(true), false);

    return TP.nodeContainsNode(backgroundElem, aNode);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('hash',
function(anObject, aHashMode, aHashFormat) {

    /**
     * @method hash
     * @summary Hashes the string representation of the Object provided.
     * @description Note that the full TIBET cryptography library will overlay
     *     this method and install its own version.
     * @param {Object} anObject The object to acquire a hash code for.
     * @param {Number} aHashMode TP.HASH_MD5 or TP.HASH_SHA1. The default is
     *     SHA-1 since MD5 has been cracked.
     * @param {Number} aHashFormat TP.HASH_HEX or TP.HASH_B64. The default is
     *     TP.HASH_HEX.
     * @exception TP.sig.InvalidParameter
     * @returns {String} The hashed string result.
     */

    var str,

        mode,
        fmt,

        result;

    if (TP.notValid(anObject)) {
        return TP.raise(null, 'TP.sig.InvalidParameter');
    }

    str = TP.str(anObject);

    mode = TP.ifInvalid(aHashMode, TP.HASH_SHA1);
    fmt = TP.ifInvalid(aHashFormat, TP.HASH_HEX);

    switch (mode) {
        case TP.HASH_MD5:

            result = TP.extern.CryptoJS.MD5(str);

            break;

        case TP.HASH_SHA1:

            result = TP.extern.CryptoJS.SHA1(str);

            break;

        default:
            break;
    }

    switch (fmt) {

        case TP.HASH_B64:

            return result.toString(TP.extern.CryptoJS.enc.Base64);

        case TP.HASH_HEX:

            return result.toString(TP.extern.CryptoJS.enc.Hex);

        default:

            return result;
    }
}, {
    dependencies: [TP.extern.CryptoJS]
});

//  ------------------------------------------------------------------------

TP.definePrimitive('htmlEntitiesToLiterals',
function(aString) {

    /**
     * @method htmlEntitiesToLiterals
     * @summary Converts HTML entities into their literal character
     *     representation.
     * @param {String} aString The string that may contain HTML entities to be
     *     converted.
     * @returns {String} The supplied String with the HTML entities converted to
     *     literal characters.
     */

    if (!TP.regex.ML_ENTITY.test(aString)) {
        return aString;
    }

    return aString.replace(
                /&#?([a-zA-Z]+|[0-9]+);/g,
                function(whole, entity) {

                    var lookup;

                    if (TP.isNumber(parseInt(entity, 10))) {
                        return String.fromCharCode(entity);
                    }

                    lookup = TP.HTML_ENTITIES_TO_LITERALS.at(entity);

                    return TP.ifInvalid(lookup, whole);
                });
});

//  ------------------------------------------------------------------------

TP.definePrimitive('htmlLiteralsToEntities',
function(aString, replaceSpaces, replaceQuoting) {

    /**
     * @method htmlLiteralsToEntities
     * @summary Converts literal characters in the supplied String to their
     *     HTML entity equivalent. Spaces, when replaced, become &nbsp;
     * @param {String} aString The string that may contain literal characters to
     *     convert to HTML entities.
     * @param {Boolean} replaceSpaces Whether or not to 'entitify' spaces. The
     *     default is false.
     * @param {Boolean} replaceQuoting Whether or not to 'entitify' quoting
     *     characters (the ' and " characters). The default is true.
     * @returns {String} The supplied String with the literal characters that
     *     need to be entities made into them.
     */

    var regex,
        result,

        dontReplaceQuoting;

    if (TP.regex.NON_UTF8_CHARS.test(aString)) {
        if (TP.notValid(regex = TP.regex.$$HTML_LITERALS_TO_ENTITIES)) {
            regex = TP.rc(
                        TP.keys(TP.HTML_LITERALS_TO_ENTITIES).join('|'),
                        'g');

            TP.regex.$$HTML_LITERALS_TO_ENTITIES = regex;
        }

        result = aString.replace(
                    regex,
                    function(match) {

                        return TP.HTML_LITERALS_TO_ENTITIES.at(match);
                    });
    } else {

        if (/[&<>'"]/.test(aString)) {

            dontReplaceQuoting = TP.isFalse(replaceQuoting);

            result = aString.replace(
                /[<>'"]/g,
                function(aChar) {

                    switch (aChar) {
                        case '<':
                            return '&lt;';

                        case '>':
                            return '&gt;';

                        case '\'':
                            if (dontReplaceQuoting) {
                                return aChar;
                            }
                            return '&apos;';

                        case '"':
                            if (dontReplaceQuoting) {
                                return aChar;
                            }
                            return '&quot;';

                        default:
                            break;
                    }
                });

            //  Replace all '&' that are *not* part of an entity with '&amp;'
            //  Note here how we replace '&&' first because sometimes,
            //  especially when formatting JavaScript, we might have an
            //  expression like 'foo&&bar;' and the second RegExp cannot
            //  determine whether or not '&bar;' is a real entity or not. So we
            //  replace the double '&' first.
            result = result.
                        replace(/&&/g, '&amp;&amp;').
                        replace(/&(?!([a-zA-Z]+|#[0-9]+);)/g, '&amp;');
        } else {
            result = aString;
        }
    }

    result = replaceSpaces ? result.replace(/ /g, '&nbsp;') : result;

    return result;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('xmlEntitiesToLiterals',
function(aString) {

    /**
     * @method xmlEntitiesToLiterals
     * @summary Converts XML entities into their literal character
     *     representation.
     * @param {String} aString The string that may contain XML entities to be
     *     converted.
     * @returns {String} The supplied String with the XML entities converted to
     *     literal characters.
     */

    if (!TP.regex.ML_ENTITY.test(aString)) {
        return aString;
    }

    return aString.replace(
                /&#?([a-zA-Z]+|[0-9]+);/g,
                function(whole, entity) {

                    var lookup;

                    if (TP.isNumber(parseInt(entity, 10))) {
                        return String.fromCharCode(entity);
                    }

                    lookup = TP.XML_ENTITIES_TO_LITERALS.at(entity);

                    return TP.ifInvalid(lookup, whole);
                });
});

//  ------------------------------------------------------------------------

TP.definePrimitive('xmlLiteralsToEntities',
function(aString, replaceSpaces, replaceQuoting) {

    /**
     * @method xmlLiteralsToEntities
     * @summary Converts literal characters in the supplied String to their XML
     *     entities.
     * @param {String} aString The string that may contain literal characters to
     *     convert to XML entities.
     * @param {Boolean} replaceSpaces Whether or not to 'entitify' spaces. The
     *     default is false.
     * @param {Boolean} replaceQuoting Whether or not to 'entitify' quoting
     *     characters (the ' and " characters). The default is true.
     * @returns {String} The supplied String with the literal characters that
     *     need to be entities made into them.
     */

    var regex,
        result,

        dontReplaceQuoting;

    if (TP.regex.NON_UTF8_CHARS.test(aString)) {
        if (TP.notValid(regex = TP.regex.$$XML_LITERALS_TO_ENTITIES)) {
            regex = TP.rc(
                        TP.keys(TP.XML_LITERALS_TO_ENTITIES).join('|'),
                        'g');

            TP.regex.$$XML_LITERALS_TO_ENTITIES = regex;
        }

        result = aString.replace(
                    regex,
                    function(match) {

                        return TP.XML_LITERALS_TO_ENTITIES.at(match);
                    });
    } else {

        if (/[&<>'"]/.test(aString)) {

            dontReplaceQuoting = TP.isFalse(replaceQuoting);

            result = aString.replace(
                /[<>'"]/g,
                function(aChar) {

                    switch (aChar) {
                        case '<':
                            return '&lt;';

                        case '>':
                            return '&gt;';

                        case '\'':
                            if (dontReplaceQuoting) {
                                return aChar;
                            }
                            return '&apos;';

                        case '"':
                            if (dontReplaceQuoting) {
                                return aChar;
                            }
                            return '&quot;';

                        default:
                            break;
                    }
                });

            //  Replace all '&' that are *not* part of an entity with '&amp;'
            //  Note here how we replace '&&' first because sometimes,
            //  especially when formatting JavaScript, we might have an
            //  expression like 'foo&&bar;' and the second RegExp cannot
            //  determine whether or not '&bar;' is a real entity or not. So we
            //  replace the double '&' first.
            result = result.
                        replace(/&&/g, '&amp;&amp;').
                        replace(/&(?!([a-zA-Z]+|#[0-9]+);)/g, '&amp;');
        } else {
            result = aString;
        }
    }

    result = replaceSpaces ? result.replace(/ /g, '&#160;') : result;

    return result;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('htmlEntitiesToXMLEntities',
function(aString) {

    /**
     * @method htmlEntitiesToXMLEntities
     * @summary Converts an HTML string to an XML equivalent. This attempts to
     *     preserve entities that exist in the HTML in the XML.
     * @param {String} aString The string that may contain HTML entities.
     * @returns {String} The supplied String with the HTML entities converted to
     *     XML entities.
     */

    if (!TP.regex.ML_ENTITY.test(aString)) {
        return aString;
    }

    return aString.replace(
                /&([a-zA-Z#0-9]+);/g,
                function(whole, entity) {

                    var lookup;

                    lookup = TP.HTML_ENTITIES_TO_XML_ENTITIES.at(entity);

                    return TP.ifInvalid(lookup, whole);
                });
});

//  ------------------------------------------------------------------------

TP.definePrimitive('xmlEntitiesToHTMLEntities',
function(aString) {

    /**
     * @method xmlEntitiesToHTMLEntities
     * @summary Converts an XML string to an HTML equivalent. This attempts to
     *     preserve entities that exist in the XML in the HTML.
     * @param {String} aString The string that may contain XML entities.
     * @returns {String} The supplied String with the XML entities converted to
     *     HTML entities.
     */

    if (!TP.regex.ML_ENTITY.test(aString)) {
        return aString;
    }

    return aString.replace(
                /&([a-zA-Z#0-9]+);/g,
                function(whole, entity) {

                    var lookup;

                    lookup = TP.XML_ENTITIES_TO_HTML_ENTITIES.at(entity);

                    return TP.ifInvalid(lookup, whole);
                });
});

//  ------------------------------------------------------------------------

TP.definePrimitive('regExpEscape',
function(aString) {

    /**
     * @method regExpEscape
     * @summary Escapes any RegExp metacharacters contained in the supplied
     *     String.
     * @param {String} aString The string that contains the regexp.
     * @returns {String} The regexp string with all RegExp metacharacters
     *     escaped such that this string can be used to build a RegExp.
     */

    TP.regex.REGEX_DETECT_META_CHARS.lastIndex = 0;

    //  Replace any *unescaped* RegExp meta characters with an escaping
    //  backslash and that character.
    return aString.replace(TP.regex.REGEX_DETECT_META_CHARS, '\\$1');
});

//  ------------------------------------------------------------------------

TP.definePrimitive('regExpUnescape',
function(aString) {

    /**
     * @method regExpUnescape
     * @summary Unescapes any RegExp metacharacters contained in the supplied
     *     String.
     * @param {String} aString The string that contains the regexp.
     * @returns {String} The regexp string with all RegExp metacharacters
     *     unescaped such that this string is stripped of all unescaped
     *     metacharacters and with the remaining escaped metacharacters
     *     unescaped.
     */

    var str;

    TP.regex.REGEX_DETECT_UNESCAPED_META_CHARS.lastIndex = 0;

    //  Strip all unescaped RegExp meta characters.
    str = aString.strip(TP.regex.REGEX_DETECT_UNESCAPED_META_CHARS);

    //  Then strip all of the escaping backslash characters themselves.
    str = str.strip('\\');

    return str;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('regExpConstruct',
function(aList, aPrefix, aSuffix) {

    /**
     * @method regExpConstruct
     * @summary Construct a RegExp using the prefix, an alternation built from
     *     the list and the suffix.
     * @param {Object[]} aList An Array of items that will be built up into an
     *     alternation.
     * @param {String} aPrefix A regex expression to prepend to the list
     *     alternation.
     * @param {String} aSuffix A regex expression to append to the list
     *     alternation.
     * @returns {RegExp} A RegExp built from the supplied arguments.
     */

    var prefix,
        suffix;

    prefix = TP.ifInvalid(aPrefix, '');
    suffix = TP.ifInvalid(aSuffix, '');

    return new RegExp(prefix + '(' + aList.join('|') + ')' + suffix);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('replaceConvenienceOperators',
function(aStr) {

    /**
     * @method replaceConvenienceOperators
     * @summary Returns the supplied String with 'convenience' operator
     *     substitutions replaced with their real counterparts.
     * @description Sometimes its easier, especially when writing expressions in
     *     markup attributes, to write aliases such as AND and OR instead of &&
     *     and || which might have to be entitified or otherwise escaped. This
     *     method takes those constructs and turns them into their real
     *     counterparts.
     * @param {String} aStr The String containing convenience operators.
     * @returns {String} The supplied String with the convenience operators
     *     replaced.
     */

    var str;

    str = aStr;

    str = str.replace(/EQ/g, '=');
    str = str.replace(/NOT_EQ/g, '!=');

    str = str.replace(/LTE/g, '<=');
    str = str.replace(/GTE/g, '>=');
    str = str.replace(/LT/g, '<');
    str = str.replace(/GT/g, '>');

    str = str.replace(/AND/g, '&&');
    str = str.replace(/OR/g, '||');

    return str;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('getNextWindowName',
function() {

    /**
     * @method getNextWindowName
     * @summary Returns a generated window name of the form window_N where N is
     *     a unique number based on the TP.sys.$$windowCount.
     * @returns {String} The next available window name.
     */

    //  count starts at 0, so we work upward making the first window _1 etc
    TP.sys.$$windowCount++;

    return 'window_' + TP.sys.$$windowCount;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('escapePseudoJSONValue',
function(aString) {

    /**
     * @method escapePseudoJSONValue
     * @summary Escapes the supplied value so that it can be used as a value
     *     inside of a 'pseudo JSON' data structure. See the TP.reformatJSToJSON
     *     method for more information.
     * @param {String} aString The string that contains the pseudo-JSON value.
     * @returns {String} The escaped pseudo-JSON value.
     */

    var str;

    if (!TP.isString(aString)) {
        return;
    }

    str = aString;

    if (TP.regex.HAS_PERIOD.test(str) ||
        TP.regex.HAS_COLON.test(str) ||
        TP.regex.HAS_SINGLE_QUOTE.test(str)) {

        //  Quote the string and escape any embedded single quotes.
        str = str.quoted('\'');
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('escapeTypeName',
function(aString) {

    /**
     * @method escapeTypeName
     * @summary Escapes the supplied type name so that it can be used as a
     *     signal name, etc. This method turns all periods ('.') into
     *     underscores ('_').
     * @param {String} aString The string that contains the type name.
     * @returns {String} The escaped type name.
     */

    if (!TP.isString(aString)) {
        return;
    }

    return aString.replace(/\./g, '_');
});

//  ------------------------------------------------------------------------

TP.definePrimitive('escapeMethodName',
function(aString) {

    /**
     * @method escapeMethodName
     * @summary Escapes the supplied method name so that it can be used as a
     *     method name, etc. This method turns all spaces (' ') into
     *     underscores ('_').
     * @param {String} aString The string that contains the method name.
     * @returns {String} The escaped method name.
     */

    if (!TP.isString(aString)) {
        return;
    }

    return aString.replace(/ /g, '_');
});

//  ------------------------------------------------------------------------

TP.definePrimitive('unescapeMethodName',
function(aString) {

    /**
     * @method unescapeMethodName
     * @summary Unescapes the supplied escaped method name so that it can be
     *     used as a method name. This method turns all underscores ('_') into
     *     spaces ('_').
     * @param {String} aString The string that contains the escaped method name.
     * @returns {String} The unescaped method name.
     */

    if (!TP.isString(aString)) {
        return;
    }

    return aString.replace(/_/g, ' ');
});

//  ------------------------------------------------------------------------

TP.definePrimitive('unescapeTypeName',
function(aString) {

    /**
     * @method unescapeTypeName
     * @summary Unescapes the supplied escaped type name so that it can be used
     *     as a type name. This method turns all underscores ('_') into periods
     *     ('.').
     * @param {String} aString The string that contains the escaped type name.
     * @returns {String} The unescaped type name.
     */

    if (!TP.isString(aString)) {
        return;
    }

    return aString.replace(/_/g, '.');
});

//  ------------------------------------------------------------------------

TP.definePrimitive('generateBindingSyntaxAroundACPVariables',
function(aStr) {

    /**
     * @method generateBindingSyntaxAroundACPVariables
     * @summary Returns the supplied String with ACP variables surrounded by
     *     the '[[' and ']]' of binding expressions.
     * @param {String} aStr The String containing ACP variables.
     * @returns {String} The supplied String with the ACP variables surrounded
     *     by binding syntax.
     */

    var tokens,

        len,

        results,
        i;

    //  Split the string into tokens
    tokens = TP.$tokenizedSplit(aStr);

    len = tokens.getSize();

    if (len === 1) {
        //  TODO: There was probably a problem
        return tokens.join('');
    }

    results = TP.ac();

    //  Iterate over all of the tokens and, if they start with a '$', then
    //  surround them with binding syntax brackets.
    for (i = 0; i < len; i++) {
        if (tokens.at(i).startsWith('$')) {
            results.push('[[' + tokens.at(i) + ']]');
        } else {
            results.push(tokens.at(i));
        }
    }

    return results.join(' ');
});

//  ------------------------------------------------------------------------

TP.definePrimitive('processValueUsingConfig',
function(initialValue, targetObj, shouldCollapse, extractWith, packageWith,
fallbackWith) {

    /**
     * @method processValueUsingConfig
     * @summary Processes the supplied value based on the parameters that are
     *     supplied to this method.
     * @description This method processes the supplied value before it is
     *     returned based on values supplied in its parameter list. This
     *     processing includes the following steps, if they are supplied:
     *          1.  Collapsing any single-valued Collection results
     *          2.  Using an extractor to extract a final value 'beyond' the
     *          last path step
     *          3.  Packaging any remaining results into a type or by using a
     *          Function
     *          4.  Using a fallback Function to create a result if one
     *          couldn't be found (i.e. the value is not valid).
     * @param {Object} initialValue The initial value.
     * @param {Object} targetObj The object to that the receiver has just
     *     extracted from.
     * @param {Boolean} [shouldCollapse=false] Whether or not this method should
     *     collapse a single return value that's in an Array to just the value
     *     itself.
     * @param {String|Function} [extractWith] A slot name or Function to use to
     *     further extract the returned value from the computed value.
     * @param {String|Function|TP.meta.lang.RootObject} [packageWith] A type or
     *     type name or Function to use to further package the returned value
     *     from the computed value.
     * @param {Function} [fallbackWidth] A Function that will provide a
     *     'fallback value' if the supplied value is not valid or collapses to a
     *     not valid value.
     * @returns {Object} The processed value.
     */

    var isEmptyArray,

        retVal,

        keys,

        packageType;

    isEmptyArray = TP.isEmptyArray(initialValue);

    retVal = initialValue;

    //  NB: We only do this if the return value is valid *and* its not an empty
    //  Array. Otherwise, we run the fallback function below if it's available.
    if (TP.isValid(retVal) && !isEmptyArray) {

        //  If we're configured to collapse, then do it.

        /* eslint-disable no-extra-parens */
        if (shouldCollapse) {
            retVal = TP.collapse(retVal);
        }
        /* eslint-enable no-extra-parens */

        //  If we're configured to extract with either an aspect name or a
        //  Function, then do that. Note that if we have a collection then we
        //  extract each value in the collection using our extractor.
        if (TP.isValid(extractWith)) {
            if (TP.isCollection(retVal)) {
                keys = TP.keys(retVal);

                keys.perform(
                        function(aKey) {
                            retVal.atPut(
                                aKey,
                                TP.val(retVal.at(aKey), extractWith));
                        });
            } else {
                retVal = TP.val(retVal, extractWith);
            }
        }

        //  If we have a 'packageWith' configured, then it's either a Function
        //  or a Type (or String type name or format). Use it to package the
        //  results.
        if (TP.isValid(packageWith)) {
            if (TP.isCallable(packageWith)) {
                retVal = packageWith(retVal);
            } else if (TP.isType(packageWith)) {
                retVal = packageWith.construct(retVal);
            } else if (TP.isString(packageWith)) {
                if (TP.isType(packageType =
                            TP.sys.getTypeByName(packageWith)) &&
                        packageType !== Object) {
                    retVal = packageType.construct(retVal);
                } else {
                    retVal = TP.format(retVal,
                                        packageWith,
                                        TP.hc('shouldWrap', true));
                }
            }
        }
    } else if (TP.isCallable(fallbackWith)) {
        //  If we didn't have a suitable return value, but we were configured
        //  with a fallback Function, then go ahead and use it to try to return
        //  an initial value.
        retVal = fallbackWith(targetObj);
    } else {
        //  If we collapse results and the results are an empty Array, then we
        //  return null.
        if (shouldCollapse && isEmptyArray) {
            retVal = null;
        }
    }

    //  If we're not collapsing (either because the flag is false or was
    //  undefined), then return the proper value (consistent with other
    //  collapsing logic in TIBET).
    if (TP.notTrue(shouldCollapse)) {
        if (TP.notValid(retVal)) {
            retVal = TP.ac();
        } else if (!TP.isArray(retVal)) {
            retVal = TP.ac(retVal);
        }
    }

    return retVal;
});

//  ------------------------------------------------------------------------
//  ID/NAME FUNCTIONS
//  ------------------------------------------------------------------------

/*
All TIBET objects should be able to give you a unique ID and a name (which
may not be unique). An object's ID and/or name are used often enough in
logging and event processing that we offer quick check functions here.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('objectGlobalID',
function(anObject, assignIfAbsent) {

    /**
     * @method objectGlobalID
     * @alias gid
     * @summary Returns the global ID of the object, an identifier that
     *     uniquely identifies the element within a particular TIBET
     *     environment. Most objects can be found via their global ID however
     *     certain scenarios are not handled automatically including Node
     *     instances which don't reside in a window, a TP.uri.URI's content, or
     *     an object capable of locating them. To find elements of this type you
     *     must have registered them under an ID, which you may have had to
     *     generate. NOTE that registering objects agressively can lead to
     *     memory leaks. NOTE that return values from this function are encoded
     *     via encodeURI since they are typically TIBET URI strings. Also note
     *     that the TP.gid() function is aliased to this call.
     * @description The return value of this function may vary between what
     *     looks like typical TIBET ID, a window path, or a TIBET URI. The
     *     reason for the variation has to do with trying to keep the IDs as
     *     simple as possible while keeping them unique enough to use with
     *     TP.sys.getObjectById(). The major difference you'll see here is that
     *     windows return window paths, while the various nodes you'd find in a
     *     window return TIBET URIs which include the window path as the canvas
     *     specification. Also be aware that not all objects have a global ID
     *     since they cannot be reliably reacquired.
     *
     *     A typical window global ID might be:
     *
     *     TDC.ui
     *
     *     A typical document global ID might be:
     *
     *     tibet://TDC.ui/http://www.teamtibet.com/index.html#document
     *
     *     A typical element global ID might be:
     *
     *     tibet://TDC.ui/http://www.teamtibet.com/index.html#elem1
     *
     *     A typical object global ID might be anything, since those values are
     *     based on IDs you can set as you desire, however most randomly
     *     assigned IDs will contain a prefix that tries to identify the type of
     *     object followed by an _ (underscore) and then a unique ID number.
     *
     *     NOTE that at the present time we do not support global IDs for node
     *     types other than document or element nodes.
     * @param {Object} anObject The node, window, or other object to get the
     *     global ID of.
     * @param {Boolean} assignIfAbsent True if the object should have an ID
     *     assigned if one doesn't exist. Default is false.
     * @example Obtain a global ID for a JavaScript object:
     *     <code>
     *          TP.gid('hi');
     *          <samp>hi</samp>
     *          TP.gid(42);
     *          <samp>42</samp>
     *          TP.gid(true);
     *          <samp>true</samp>
     *          TP.gid(TP.ac());
     *          <samp>Array_11194fef891948efcb003e0d8</samp>
     *          TP.gid(TP.hc());
     *          <samp>TP.core.Hash_11194ff08b02373b76de8c7c</samp>
     *          TP.gid(TP.dc());
     *          <samp>Date_111997a9773f185a33f9280f</samp>
     *          TP.gid((function() {TP.info('foo');}));
     *          <samp>Function_111997cb98f69d60b2cc7daa</samp>
     *          TP.gid(TP.lang.Object.construct());
     *          <samp>TP.lang.Object_111997a3ada0b5cb1f4dc5398</samp>
     *     </code>
     * @example Obtain a global ID for a top-level Window:
     *     <code>
     *          TP.gid(top);
     *          <samp>TDC</samp>
     *     </code>
     * @example Obtain a global ID for a frame window within top-level Window:
     *     <code>
     *          TP.gid(top);
     *          <samp>TDC.ui</samp>
     *     </code>
     * @example Obtain a global ID for the document of a frame window within
     *     top-level Window:
     *     <code>
     *          TP.gid(top.document);
     *         <samp>tibet://TDC.ui/http://www.teamtibet.com/tibet/app/tdc/TIBET-INF/src/html/tdc_moz.html#document</samp>
     *     </code>
     * @example Obtain a global ID for the 'body' element of the document of a
     *     frame window within top-level Window, assigning it an 'id' if it
     *     doesn't have one:
     *     <code>
     *          TP.gid(TP.documentGetBody(top.document), true);
     *         <samp>tibet://TDC.ui/http://www.teamtibet.com/tibet/app/tdc/TIBET-INF/src/html/tdc_moz.html#BODY_111996b6d1560b4952693a988</samp>
     *     </code>
     * @returns {String} The global ID of anObject or null if it doesn't have
     *     one.
     */

    var assign,
        assignForce,

        obj,
        doc,
        win,
        loc,
        prefix,
        localID,
        globalID,
        pnames,
        id,
        root,

        elem;

    if (anObject === null) {
        return 'null';
    } else if (anObject === undefined) {
        return 'undefined';
    }

    //  non-mutables can't do much here, their value is their ID
    if (!TP.isMutable(anObject)) {
        return TP.str(anObject);
    }

    assign = TP.ifInvalid(assignIfAbsent, false);

    //  We set a separate flag for those places where we want to be able to
    //  'force assignment'. If the caller has *specifically* defined the
    //  assignIfAbsent parameter to false, then we leave force assignment as
    //  false, otherwise we allow it to be true.
    if (TP.isFalse(assignIfAbsent)) {
        assignForce = false;
    } else {
        assignForce = true;
    }

    if (TP.isKindOf(anObject, TP.dom.Node)) {
        if (TP.isType(anObject)) {
            obj = anObject;
        } else {
            obj = anObject.getNativeNode();
        }
    } else {
        obj = anObject;
    }

    if (TP.isElement(obj)) {
        //  If the element doesn't have a cached value for its globalID
        //  slot then we compute one

        //  if we have a value, encode and return it. Note here how we have put
        //  the slot directly on the element for speed and to avoid markup
        //  clutter.
        globalID = obj[TP.GLOBAL_ID];
        if (TP.notEmpty(globalID)) {
            return encodeURI(globalID);
        }

        //  the local ID for our element is the last portion
        localID = TP.lid(obj, assign);

        //  if no localID then we're not going to be able to locate this
        //  element again...so it doesn't have a global ID
        if (TP.isEmpty(localID)) {
            return;
        }

        //  if we've got a local ID then we can try to get the global ID
        //  for its document. if we're successful with that then we can
        //  adjust that ID for the element
        doc = TP.nodeGetDocument(obj);
        if (TP.isDocument(doc)) {
            prefix = TP.objectGlobalID(doc, assign);
            if (TP.notEmpty(prefix)) {
                globalID = prefix.replace(/#.+/, '#' + localID);
                if (assign) {
                    //  Note here how we put the slot directly on the element
                    //  for speed and to avoid markup clutter.
                    obj[TP.GLOBAL_ID] = globalID;
                }
                return globalID;
            }
        }

        //  no document, or no document global ID, so we can't be found
        //  again via any ID we might return
        return;
    }

    if (TP.isDocument(obj)) {

        prefix = '';

        //  if a document doesn't have a window then we have to know its
        //  URI location so we can access it via the URI
        win = TP.nodeGetWindow(obj);
        if (TP.isWindow(win)) {
            globalID = TP.objectGlobalID(win, assign);
            prefix = 'tibet://' + globalID + '/';
        }

        //  in some sense the URI aspect is irrelevant if the document is in
        //  a window, since to reacquire that particular document a) we
        //  don't need any more data and b) it won't be the same document if
        //  the window reloads for any reason. it's the second portion of
        //  this that leads us to qualify document IDs with their URI
        //  locations to help ensure that at least we end up with a new
        //  document that should roughly approximate the one we've got now

        //  this should return either an empty string, or a URI that
        //  resolves to a file: or http[s]: address
        if (TP.isElement(root = obj.documentElement) &&
            TP.notEmpty(id = TP.elementGetAttribute(
                            root, TP.GLOBAL_DOCID_ATTR, true))) {

            //  If the document ID was assigned before this document was placed
            //  into a Window, or was placed into a different window, this 'id'
            //  won't have a prefix containing the current Window ID. We will
            //  update it to contain that.
            if (win) {

                //  It doesn't start with our current prefix
                if (!id.startsWith(prefix)) {
                    //  If it starts with another 'tibet:' prefix (but *not* a
                    //  virtual path - we allow those), slice that off
                    if (TP.regex.TIBET_URL.test(id) &&
                        !TP.regex.VIRTUAL_URI_PREFIX.test(id)) {
                        id = id.slice(id.indexOf('/', 8) + 1);
                    }

                    loc = id;

                    if (TP.regex.URI_FRAGMENT.test(loc)) {
                        //  had a # fragment identifier so won't need #document
                        loc = encodeURI(prefix + loc);
                    } else {
                        //  NOTE we add the '#document' element reference as our
                        //  barename when no specific subelement is the document
                        loc = encodeURI(prefix + loc + '#document');
                    }

                    if (TP.isElement(root) && assign) {
                        TP.elementSetAttribute(
                                root, TP.GLOBAL_DOCID_ATTR, loc, true);
                    }

                    //  Remove all TP.GLOBAL_ID and TP.EVENT_IDs slots from any
                    //  elements in the document that have them - this will
                    //  cause them to reset
                    TP.ac(obj.getElementsByTagName('*')).forEach(
                            function(anElem) {
                                delete anElem[TP.EVENT_IDS];
                                delete anElem[TP.GLOBAL_ID];
                            });
                } else {
                    loc = id;
                }
            } else {
                loc = id;
            }
        } else {
            loc = TP.documentGetLocation(obj, false, true) || '';

            if (TP.isEmpty(loc)) {
                if (TP.isElement(root)) {
                    TP.regex.INVALID_ID_CHARS.lastIndex = 0;
                    id = TP.genID().replace('$', 'document_').replace(
                                            TP.regex.INVALID_ID_CHARS, '_');

                    loc = id;
                } else {
                    //  empty location, empty document
                    loc = '';
                }
            } else {
                loc = TP.uriInTIBETFormat(loc);
            }

            if (TP.regex.URI_FRAGMENT.test(loc)) {
                //  had a # fragment identifier so we won't need #document
                loc = encodeURI(prefix + loc);
            } else {
                //  NOTE we add the '#document' element reference as our
                //  barename when no specific sub-element is the document
                loc = encodeURI(prefix + loc + '#document');
            }

            if (TP.isElement(root) && assign) {
                TP.elementSetAttribute(
                        root, TP.GLOBAL_DOCID_ATTR, loc, true);
            }
        }

        return loc;
    }

    if (TP.isNode(obj)) {
        elem = obj.parentNode;

        if (TP.isAttributeNode(obj)) {
            //  Reset the element here to the attribute's owner element.
            elem = TP.attributeGetOwnerElement(obj);

            //  A detached AttributeNode won't have an Element as an owner
            //  element... sometimes it has an empty Array - weird.
            if (TP.isElement(elem)) {
                //  Grab the owner element's global ID and slice off from the
                //  beginning through the '#'. This will give us the 'primary
                //  URI'.
                globalID = TP.gid(elem, assignForce);
                globalID = globalID.slice(0, globalID.lastIndexOf('#'));

                //  Construct an 'xpath1' XPointer that causes the traversal to
                //  the Element and then down to the attribute.
                globalID += '#xpath1(//*[@id=\'' + TP.lid(elem, assignForce) + '\']' +
                            '/@' + TP.attributeGetLocalName(obj) + ')';
            } else {
                globalID = '#xpath1(./@' + TP.attributeGetLocalName(obj) + ')';
            }

            //  Set elem to 'null' here as we've already computed the element's
            //  ID and don't want further content.
            elem = null;
        } else if (TP.isTextNode(obj)) {
            globalID = '#xpath1(./text()[contains(.,\'' +
                TP.nodeGetTextContent(obj) + '\')])';
        } else if (TP.isCDATASectionNode(obj)) {
            globalID = '#xpath1(./text()[contains(.,\'' +
                TP.nodeGetTextContent(obj) + '\')])';
        } else if (TP.isPINode(obj)) {
            globalID = '#xpath1(./processing-instruction(\'' +
                TP.name(obj) + '\'))';
        } else if (TP.isCommentNode(obj)) {
            globalID = '#xpath1(./comment()[1])';
        } else if (TP.isFragment(obj)) {
            globalID = '#document-fragment';
        }

        if (TP.isElement(elem)) {
            //  Note here how we pass true to assign an ID to the element if it
            //  doesn't have one. We're trying to avoid getting an '#element()'
            //  path.
            globalID = TP.gid(elem, assignForce) + globalID;
        }

        return globalID;
    }

    if (TP.isWindow(obj) || TP.isKindOf(obj, TP.core.Window)) {
        //  Unwrap it (in case it's a TP.core.Window wrapper)
        obj = TP.unwrap(obj);

        //  get the Array of parent window names
        pnames = TP.windowGetParentNames(obj);

        //  the local ID for our window
        localID = TP.lid(obj, assign);

        //  if no localID then call TP.lid() again, forcing it to
        //  assign.
        if (TP.isEmpty(localID)) {
            localID = TP.lid(obj, assignForce);
        }

        //  add our name (the window where we started this process) onto
        //  the end of the window's name array
        pnames.push(localID);

        //  join the names together with a '.'
        globalID = pnames.join('.');

        return globalID;
    }

    //  an option is if the object can return a standard TIBET ID
    if (TP.canInvoke(obj, 'getID')) {
        return obj.getID();
    }

    //  can't compute a local ID? Just return the object's name then.
    return TP.name(obj);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('gid', TP.objectGlobalID);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectLocalID',
function(anObject, assignIfAbsent) {

    /**
     * @method objectLocalID
     * @alias lid
     * @summary Returns the local ID of the object provided. This method is
     *     normally used on nodes as a way of getting an ID that is local to the
     *     node's enclosing document. NOTE that the TP.lid() function is aliased
     *     to this function as a 'shorthand'.
     * @description It's often necessary to get a handle to an object by ID. In
     *     a typical environment this would be done via the native
     *     document.getElementById() call. Unfortunately, that call won't work
     *     on XML DOMs cross-browser so in TIBET you'd normally use
     *     TP.nodeGetElementById() instead.
     *
     *     In any case, this function will return the local ID of the object
     *     provided. When the object is an element this is the value of the 'id'
     *     attribute as set by the original markup author, or a generated ID
     *     which is then assigned to the element for future reference.
     *
     *     If anObject is a Window, this method returns the Window's name, or a
     *     uniquely generated window name such as window_1 when the window had
     *     no name. This name is also assigned to the window and registered with
     *     the 'browser' object for future lookup purposes.
     *
     *     If anObject is a Document (or XML Document), this method returns the
     *     string 'document', which is not unique, but it's about all we can use
     *     to ensure that when used as part of a larger global ID the document
     *     element has a reference.
     *
     *     If anObject is any other type of object TIBET will try to return
     *     that object's ID via the getID() method.
     * @param {Object} anObject The node, window, or object to return the ID of.
     * @param {Boolean} assignIfAbsent True if the object should have an ID
     *     assigned if one doesn't exist. Default is false.
     * @example Obtain a local ID for a JavaScript object:
     *     <code>
     *          TP.lid('hi');
     *          <samp>hi</samp>
     *          TP.lid(42);
     *          <samp>42</samp>
     *          TP.lid(true);
     *          <samp>true</samp>
     *          TP.lid(TP.ac());
     *          <samp>Array_11194fef891948efcb003e0d8</samp>
     *          TP.lid(TP.hc());
     *          <samp>TP.core.Hash_11194ff08b02373b76de8c7c</samp>
     *          TP.lid(TP.dc());
     *          <samp>Date_111997a9773f185a33f9280f</samp>
     *          TP.lid((function() {TP.info('foo');}));
     *          <samp>Function_111997cb98f69d60b2cc7daa</samp>
     *          TP.lid(TP.lang.Object.construct());
     *          <samp>TP.lang.Object_111997a3ada0b5cb1f4dc5398</samp>
     *     </code>
     * @example Obtain a local ID for a top-level Window:
     *     <code>
     *          TP.lid(top);
     *          <samp>TDC</samp>
     *     </code>
     * @example Obtain a local ID for a frame window within top-level Window:
     *     <code>
     *          TP.lid(top);
     *          <samp>ui</samp>
     *     </code>
     * @example Obtain a local ID for the document of a frame window within
     *     top-level Window:
     *     <code>
     *          TP.lid(top.document);
     *          <samp>document</samp>
     *     </code>
     * @example Obtain a local ID for the 'body' element of the document of a
     *     frame window within top-level Window, assigning it an 'id' if it
     *     doesn't have one:
     *     <code>
     *          TP.lid(TP.documentGetBody(top.document), true);
     *          <samp>element(/1/1)</samp>
     *     </code>
     * @returns {String} The local ID of anObject.
     */

    var assign,
        obj,
        localID,
        frameElem,

        elem;

    if (anObject === null) {
        return 'null';
    } else if (anObject === undefined) {
        return 'undefined';
    }

    //  non-mutables can't do much here, their value is their ID
    if (!TP.isMutable(anObject)) {
        return TP.str(anObject);
    }

    assign = TP.ifInvalid(assignIfAbsent, false);

    if (TP.isKindOf(anObject, TP.dom.Node)) {
        obj = TP.unwrap(anObject);
    } else {
        obj = anObject;
    }

    //  other nodes use their 'id' attribute, or create one as needed
    if (TP.isElement(obj)) {
        //  here, our preference is return an ID, as it tends to be much
        //  more unique than a NAME
        if (TP.isEmpty(localID = TP.elementGetAttribute(obj, 'id'))) {
            localID = TP.elemGenID(obj, assign);
        }

        return localID;
    }

    //  when dealing with documents of any kind we return the string
    //  'document' so lookups have a way to identify the document
    if (TP.isDocument(obj)) {
        return 'document';
    }

    if (TP.isNode(obj)) {
        if (TP.isAttributeNode(obj)) {
            localID = '@' + TP.attributeGetLocalName(obj);
            elem = TP.attributeGetOwnerElement(obj);
        } else if (TP.isTextNode(obj)) {
            localID = 'text()[contains(.,\'' +
                TP.nodeGetTextContent(obj) + '\')]';
        } else if (TP.isCDATASectionNode(obj)) {
            localID = 'text()[contains(.,\'' +
                TP.nodeGetTextContent(obj) + '\')]';
        } else if (TP.isPINode(obj)) {
            localID = 'processing-instruction(\'' + TP.name(obj) + '\')';
        } else if (TP.isCommentNode(obj)) {
            localID = 'comment()[1]';
        } else if (TP.isFragment(obj)) {
            localID = '#document-fragment';
        }

        //  If the element wasn't assigned above (i.e. we were not an Attribute
        //  node), then try here by getting the parent node.
        if (!TP.isElement(elem)) {
            elem = obj.parentNode;
        }

        if (TP.isElement(elem)) {
            localID = '#xpath1(//*[@id=\'' + TP.lid(elem) + '\']/' +
                        localID +
                        ')';
        } else if (!TP.isFragment(obj)) {
            //  NB: We don't do this for DocumentFragments.
            localID = '#xpath1(./' + localID + ')';
        }

        return localID;
    }

    //  when dealing with windows we use the window name, or a generated one
    if (TP.isWindow(obj) || TP.isKindOf(obj, TP.core.Window)) {
        //  Unwrap it (in case it's a TP.core.Window wrapper)
        obj = TP.unwrap(obj);

        //  IE will throw an exception if we try to get the frameElement but
        //  the window is not hosted in a frame/iframe... sigh.
        try {
            frameElem = obj.frameElement;
        } catch (e) {
            frameElem = null;
        }

        if (TP.isElement(frameElem)) {
            localID = TP.elementGetAttribute(frameElem, 'id');
            if (TP.isEmpty(localID)) {
                localID = TP.elemGenID(frameElem, assign);
            }

            return localID;
        }

        localID = obj.name;
        if (localID && !localID.isJSIdentifier()) {
            localID = '';
            assign = true;
        }

        //  no name and assign was true? generate the next available one and
        //  use it
        if (TP.isEmpty(localID)) {
            if (assign) {
                if (obj === TP.topWindow) {
                    localID = 'top';
                } else {
                    localID = TP.getNextWindowName();
                }

                try {
                    obj.name = localID;
                } catch (e) {
                    //  if we can't set the name (permissions?) then we
                    //  don't want to return a valid ID here
                    return null;
                }
            }
        }

        return localID;
    }

    //  an option is if the object can return a standard TIBET ID

    //  NOTE that we don't use objectLocalID here or we'd recurse into this
    //  routine
    if (TP.canInvoke(obj, 'getID')) {
        return obj.getID();
    }

    //  can't compute a local ID? Just return the object's name then.
    return TP.name(obj);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('lid', TP.objectLocalID);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectID',
function(anObject, assignIfAbsent) {

    /**
     * @method objectID
     * @alias id
     * @summary Returns the ID of anObject, the value considered to be the
     *     object's unique identifier. NOTE that the TP.id() function is aliased
     *     to this function as a 'shorthand'.
     * @param {Object} anObject The object to interrogate.
     * @param {Boolean} assignIfAbsent True if the object should have an ID
     *     assigned if one doesn't exist. Default is false.
     * @example Obtain an ID for a JavaScript object:
     *     <code>
     *          TP.id('hi');
     *          <samp>hi</samp>
     *          TP.id(42);
     *          <samp>42</samp>
     *          TP.id(true);
     *          <samp>true</samp>
     *          TP.id(TP.ac());
     *          <samp>Array_11194fef891948efcb003e0d8</samp>
     *          TP.id(TP.hc());
     *          <samp>TP.core.Hash_11194ff08b02373b76de8c7c</samp>
     *          TP.id(TP.dc());
     *          <samp>Date_111997a9773f185a33f9280f</samp>
     *          TP.id((function() {TP.info('foo');}));
     *          <samp>Function_111997cb98f69d60b2cc7daa</samp>
     *          TP.id(TP.lang.Object.construct());
     *          <samp>TP.lang.Object_111997a3ada0b5cb1f4dc5398</samp>
     *     </code>
     * @example Obtain an ID for a top-level Window:
     *     <code>
     *          TP.id(top);
     *          <samp>TDC</samp>
     *     </code>
     * @example Obtain an ID for a frame window within top-level Window:
     *     <code>
     *          TP.id(top);
     *          <samp>TDC.ui</samp>
     *     </code>
     * @example Obtain an ID for the document of a frame window within top-level
     *     Window:
     *     <code>
     *          TP.id(top.document);
     *
     *
     *         <samp>tibet://TDC.ui/http://www.teamtibet.com/tibet/app/tdc/TIBET-INF/src/html/tdc_moz.html#document</samp>
     *     </code>
     * @example Obtain an ID for the 'body' element of the document of a frame
     *     window within top-level Window, assigning it an 'id' if it doesn't
     *     have one:
     *     <code>
     *          TP.id(TP.documentGetBody(top.document), true);
     *
     *
     *         <samp>tibet://TDC.ui/http://www.teamtibet.com/tibet/app/tdc/TIBET-INF/src/html/tdc_moz.html#BODY_111996b6d1560b4952693a988</samp>
     *     </code>
     * @returns {String} A string ID.
     */

    if (anObject === void 0) {
        return 'undefined';
    }

    if (anObject === null) {
        return 'null';
    }

    //  the ID of a non-mutable object is its value
    if (!TP.isMutable(anObject)) {
        return TP.str(anObject);
    }

    if (TP.canInvoke(anObject, 'getID')) {
        return anObject.getID();
    }

    //  most everything else can be managed via global ID (nodes, windows,
    //  etc)
    return TP.gid(anObject, assignIfAbsent);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('id', TP.objectID);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectName',
function(anObject) {

    /**
     * @method objectName
     * @alias name
     * @summary Returns the name of anObject, most often associated with types,
     *     functions, or node "tag names". When dealing with tag names this
     *     method returns the canonical name of the tag. When all else fails
     *     this method will return the local ID of the object.
     * @param {Object} anObject The object to interrogate.
     * @returns {String} A string "name".
     */

    if (anObject === void 0) {
        return 'undefined';
    }

    if (anObject === null) {
        return 'null';
    }

    if (TP.isNonFunctionConstructor(anObject)) {
        return TP.getNonFunctionConstructorName(anObject);
    }

    //  non-mutables use their value as their name
    if (!TP.isMutable(anObject)) {
        return TP.str(anObject);
    }

    if (TP.isNode(anObject)) {
        if (TP.isElement(anObject)) {
            return TP.elementGetCanonicalName(anObject);
        } else if (TP.isTextNode(anObject)) {
            return '#text';
        } else if (TP.isDocument(anObject)) {
            return '#document';
        } else if (TP.isAttributeNode(anObject)) {
            return TP.attributeGetCanonicalName(anObject);
        } else if (TP.isFragment(anObject)) {
            return '#document-fragment';
        } else if (TP.isCommentNode(anObject)) {
            return '#comment';
        } else if (TP.isCDATASectionNode(anObject)) {
            return '#cdata-section';
        } else if (TP.isPINode(anObject)) {
            return anObject.nodeName;
        }
    }

    if (TP.isWindow(anObject)) {
        return anObject.name;
    }

    if (TP.canInvoke(anObject, 'getName')) {
        return anObject.getName();
    } else if (TP.isFunction(anObject)) {
        //  This should only trigger for Functions that came from other JS
        //  contexts - in TIBET, TP.FunctionProto has a 'getName' method.
        return TP.getFunctionName(anObject);
    }

    //  Try to 'call' "TP.FunctionProto's" 'getName' on the object, but put it
    //  in a try...catch, since this is a bit dangerous (it will try to put a
    //  slot on anObject).
    try {
        return TP.FunctionProto.$getOID.call(anObject);
    } catch (e) {
        TP.ifError() ?
            TP.error(
                TP.ec(e, 'Error retrieving object name.')) : 0;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('name', TP.objectName);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectOwner',
function(anObject) {

    /**
     * @method objectOwner
     * @alias owner
     * @summary Returns the owner of anObject, which should be a Function. The
     *     owner is the type, either TIBET or native type, which 'owns' the
     *     Function (i.e. its 'owns' the property in a 'hasOwnProperty' sort of
     *     way).
     * @param {Object} anObject The object to interrogate.
     * @returns {Object} The owner object.
     */

    if (TP.isValid(anObject)) {
        return anObject[TP.OWNER];
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('owner', TP.objectOwner);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectTrack',
function(anObject) {

    /**
     * @method objectTrack
     * @alias track
     * @summary Returns the track of anObject, which should be a Function. The
     *     track is the 'track' that the object can be found when looking up an
     *     inheritance hierarchy. The value returned can be one of the
     *     following:
     *
     *      TP.GLOBAL_TRACK
     *      TP.PRIMITIVE_TRACK
     *      TP.META_INST_TRACK
     *      TP.META_TYPE_TRACK
     *      TP.INST_TRACK
     *      TP.LOCAL_TRACK
     *      TP.TYPE_TRACK
     *      TP.TYPE_LOCAL_TRACK
     *
     * @param {Object} anObject The object to interrogate.
     * @returns {String} A string "track".
     */

    if (TP.isValid(anObject)) {
        return anObject[TP.TRACK];
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('track', TP.objectTrack);

//  ------------------------------------------------------------------------

TP.definePrimitive('elemGenID',
function(anElement, assignIfAbsent) {

    /**
     * @method elemGenID
     * @summary Generates a unique ID (if the element doesn't already have one)
     *     that is compliant with XML ID rules.
     * @param {TP.dom.ElementNode|Element} anElement An Element or element
     *     wrapper.
     * @param {Boolean} assignIfAbsent True if the element should have an ID
     *     assigned if one doesn't exist. Default is false.
     * @returns {String} The element's ID, which might have been newly assigned
     *     by this method.
     */

    var elem,
        assign,

        fullName,

        id;

    elem = TP.unwrap(anElement);
    assign = TP.ifInvalid(assignIfAbsent, false);

    if (TP.isEmpty(id = TP.elementGetAttribute(elem, 'id', true))) {

        fullName = TP.elementGetFullName(anElement);

        TP.regex.INVALID_ID_CHARS.lastIndex = 0;
        id = TP.genID(fullName).replace(TP.regex.INVALID_ID_CHARS, '_');

        if (assign) {
            TP.elementSetAttribute(elem, 'id', id, true);
        }
    }

    return id;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nsuri',
function(anObject) {

    /**
     * @method nsuri
     * @summary Returns the namespace URI of the object, if it has one. This is
     *     only relevant for nodes. The search includes both the namespaceURI
     *     property and a search for an xmlns attribute.
     * @param {TP.dom.Node|Node} anObject A Node or node wrapper.
     * @returns {String} The namespace URI.
     */

    var node;

    node = TP.unwrap(anObject);
    if (!TP.isNode(node)) {
        return;
    }

    return TP.nodeGetNSURI(node);
});

//  ------------------------------------------------------------------------
//  DUPLICATION
//  ------------------------------------------------------------------------

TP.definePrimitive('objectCopy',
function(anObject, deep, aFilterNameOrKeys, contentOnly) {

    /**
     * @method objectCopy
     * @alias copy
     * @summary Returns a copy of the object provided. When the object is a
     *     Node the copy is deep unless overridden by the deep flag. When the
     *     object is a standard JS object the clone is shallow. NOTE that window
     *     objects cannot be copied, nor can various ActiveX elements so not all
     *     objects will return a valid value in response to this call.
     * @param {Object} anObject The object to interrogate.
     * @param {Boolean} [deep=false] True to force node clones to be deep, or
     *     reference elements to be deep copies.
     * @param {String|String[]} [aFilterNameOrKeys] get*Interface() filter or
     *     key array.
     * @param {Boolean} [contentOnly=true] Copy content only? This parameter is
     *     not used for all types.
     * @returns {Node|Object} A Node or Object depending on the nature of the
     *     inbound object.
     */

    var eventDocument,

        newObj,
        keys;

    //  null, undefined, and window objects are obvious problems
    if (TP.notValid(anObject) || TP.isWindow(anObject)) {
        return;
    } else if (TP.isNode(anObject)) {
        return TP.nodeCloneNode(anObject, TP.notFalse(deep) ? true : false);
    } else if (TP.canInvoke(anObject, 'copy')) {
        return anObject.copy(deep, aFilterNameOrKeys, contentOnly);
    } else if (TP.isEvent(anObject)) {
        if (TP.isDocument(eventDocument =
                            TP.eventGetTarget(anObject).document)) {
            return TP.documentConstructEvent(eventDocument, anObject);
        }
    } else if (TP.isPlainObject(anObject)) {
        newObj = {};

        keys = TP.keys(anObject);
        keys.forEach(
                function(aKey) {
                    var val;

                    val = anObject[aKey];
                    if (TP.isTrue(deep) && TP.isReferenceType(val)) {
                        //  NB: We do *not* pass along the filter name or keys
                        //  here
                        newObj[aKey] = TP.objectCopy(
                                            val, deep, null, contentOnly);
                    } else {
                        newObj[aKey] = val;
                    }
                });

        return newObj;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('copy', TP.objectCopy);

//  ------------------------------------------------------------------------
//  VALUE/FORMAT QUERIES
//  ------------------------------------------------------------------------

/*
When inspecting or logging an object you'll often want to get a string or
source-code formatted string version of the object to view. These functions
let you do that in a consistent fashion that still leverages any processing
the object may support for providing a "best case" representation.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('format',
function(anObject, aFormat, formatParams) {

    /**
     * @method format
     * @summary Formats an object using the format provided. The process here
     *     tries to leverage TIBET's object layer to produce the best possible
     *     formatted output based on the combination of object and format.
     * @param {Object} anObject The object to format.
     * @param {Object} aFormat A String or type used to format the object. If
     *     empty then no formatting is performed.
     * @param {TP.core.Hash|TP.sig.Request} formatParams Optional formatting
     *     data.
     * @returns {Object} Typically a string, but not required.
     */

    var params,

        obj;

    //  no format means no work
    if (TP.isEmpty(aFormat)) {
        return anObject;
    }

    //  no valid source object? Try to see if we can transform it.
    if (TP.notValid(anObject)) {

        //  See if we can use 'transform' with the invalid object (it should
        //  work as 'getBestMethod' computes proper method names for null and
        //  undefined)
        if (TP.canInvoke(aFormat, 'transform')) {
            return aFormat.transform(anObject, formatParams);
        }

        return;
    }

    params = TP.ifInvalid(formatParams, TP.hc());

    //  If the 'shouldWrap' flag in the format params isn't false, wrap the
    //  object so that we ensure we're talking to TIBET objects.
    if (TP.notFalse(params.at('shouldWrap'))) {
        obj = TP.wrap(anObject);
    } else {
        obj = anObject;
    }

    if (TP.isTrue(params.at('collapse'))) {
        obj = TP.collapse(obj);
    }

    //  as() leads to format() in many cases, so we start with that given
    //  that it's the common TIBET entry point
    if (TP.canInvoke(obj, 'as')) {
        //  NB: We pass the original format params here to let code further
        //  downstream handle this parameter how they want to.
        return obj.as(aFormat, formatParams);
    }

    //  Otherwise, see if we can use 'transform' with the unwrapped object
    if (TP.canInvoke(aFormat, 'transform')) {
        //  NB: We pass the original format params here to let code further
        //  downstream handle this parameter how they want to.
        return aFormat.transform(anObject, formatParams);
    }

    //  Out of options. Return original object.
    return anObject;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('objectHTMLNode',
function(anObject, aDocument) {

    /**
     * @method objectHTMLNode
     * @alias htmlnode
     * @summary Returns an HTML node representation of the receiver. NOTE that
     *     the TP.htmlnode() function is aliased to this function as a
     *     'shorthand'.
     * @description This function is used to avoid type checking an object or
     *     duplicating test code when you're not sure of the return type of some
     *     function but need an HTML-compatible node. For objects which can't
     *     provide their own asHTMLNode() implementations this method typically
     *     returns the TP.objectStringValue() in a text node.
     *
     *     NOTE that since HTML can't handle a number of XML constructs those
     *     constructs are removed from the result node by the processing of this
     *     method.
     * @param {Object} anObject The object to format as HTML.
     * @param {HTMLDocument} aDocument The document which should own the result
     *     node. Defaults to the current canvas's document.
     * @example Obtain the HTML node representation for a JavaScript object:
     *     <code>
     *          TP.htmlnode('hi');
     *          <samp>[object Text]</samp>
     *          TP.htmlnode(42);
     *          <samp>[object Text]</samp>
     *          TP.htmlnode(true);
     *          <samp>[object Text]</samp>
     *          TP.htmlnode(TP.ac());
     *          <samp>[object Text]</samp>
     *          TP.htmlnode(TP.hc());
     *          <samp>[object Text]</samp>
     *          TP.htmlnode(TP.dc());
     *          <samp>[object Text]</samp>
     *          TP.htmlnode((function() {TP.info('foo');}));
     *          <samp>[object Text]</samp>
     *          TP.htmlnode(TP.lang.Object.construct());
     *          <samp>[object Text]</samp>
     *     </code>
     * @example Obtain the HTML node representation for a Window:
     *     <code>
     *          TP.htmlnode(top);
     *          <samp>[object Text]</samp>
     *     </code>
     * @example Obtain the HTML node representation for an HTML Document:
     *     <code>
     *          TP.htmlnode(top.document);
     *          <samp>[object HTMLDocument]</samp>
     *          TP.htmlnode(top.document) === top.document;
     *          <samp>true</samp>
     *     </code>
     * @example Obtain the HTML node representation for an HTML Element:
     *     <code>
     *          TP.htmlnode(TP.documentGetBody(top.document));
     *          <samp>[object HTMLBodyElement]</samp>
     *          TP.htmlnode(TP.documentGetBody(top.document)) ===
     *         TP.documentGetBody(top.document);
     *          <samp>true</samp>
     *     </code>
     * @returns {Node} The best-possible HTML node for the Object.
     */

    var doc;

    //  no valid source object means no work
    if (TP.notValid(anObject)) {
        return;
    }

    doc = TP.isHTMLDocument(aDocument) ?
                aDocument :
                TP.sys.getUICanvas().getNativeDocument();

    if (TP.isNode(anObject)) {
        return TP.nodeAsHTMLNode(anObject, doc);
    }

    if (TP.canInvoke(anObject, 'asHTMLNode')) {
        return anObject.asHTMLNode(doc);
    }

    return doc.createTextNode(TP.str(anObject));
});

//  ------------------------------------------------------------------------

TP.definePrimitive('htmlnode', TP.objectHTMLNode);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectHTMLString',
function(anObject) {

    /**
     * @method objectHTMLString
     * @alias htmlstr
     * @summary Returns an HTML string representation of the receiver. NOTE
     *     that the TP.htmlstr() function is aliased to this function as a
     *     'shorthand'.
     * @description This function is used to avoid type checking an object or
     *     duplicating test code when you're not sure of the return type of some
     *     function but need an HTML-compatible string. For objects which can't
     *     provide their own asHTMLString implementations this method typically
     *     returns the objectStringValue.
     *
     *     NOTE that since HTML can't handle a number of XML constructs those
     *     constructs are removed from the result string by the processing of
     *     this method.
     * @param {Object} anObject The object to format as HTML.
     * @returns {String} The best-possible HTML rep of the Object.
     */

    var arr,

        len,
        i,

        rules;

    if (anObject === void 0) {
        return 'undefined';
    }

    if (anObject === null) {
        return 'null';
    }

    //  we're usually calling this with a standard object so we can leverage
    //  TIBET's method APIs to do a best-fit job
    if (TP.canInvoke(anObject, 'asHTMLString')) {
        try {
            return anObject.asHTMLString();
        } catch (e) {
            void 0;
        }
    }

    //  XMLHttpRequest can have permission issues, so check early
    if (TP.isXHR(anObject)) {
        return '<span class="XHR">' +
                    '<span data-name="status">' +
                        anObject.status +
                    '</span>' +
                    '<span data-name="responseText">' +
                        TP.htmlstr(anObject.responseText) +
                    '</span>' +
                '</span>';
    }

    //  native nodes are the next-most likely object being passed to this
    //  routine, so we'll try to build up a proper string here
    if (TP.isNode(anObject)) {
        return TP.nodeAsHTMLString(anObject);
    }

    //  got to check Errors next... they freak out if handed to TP.isString().
    if (TP.isError(anObject)) {
        return '<span class="Error" data-name="message">' +
                    TP.str(anObject.message) +
                '</span>';
    }

    if (TP.isString(anObject)) {
        return anObject;
    }

    //  Since Number is a non-mutable, we must do this before the next check
    if (TP.isNumber(anObject)) {
        return TP.str(anObject);
    }

    if (!TP.isMutable(anObject)) {
        //  TODO:   does this really deal with all the special constants
        //  like NaN, Number.POSITIVE_INFINITY, etc.?
        return TP.str(anObject);
    }

    //  The top-level Window has TIBET loaded into it, so it will respond to
    //  'asString' properly, but other iframes, etc. won't so we have to handle
    //  Windows in a special manner here, which is the same as the
    //  'asXMLString()'
    if (TP.isWindow(anObject)) {
        return TP.windowAsHTMLString(anObject);
    }

    //  Event objects
    if (TP.isEvent(anObject)) {
        return TP.eventAsHTMLString(anObject);
    }

    //  NodeList objects
    if (TP.isNodeList(anObject)) {
        arr = TP.ac();

        len = anObject.length;
        arr.push('<span class="NodeList">');
        for (i = 0; i < len; i++) {
            arr.push(
                    '<span data-name="', i, '">',
                        TP.htmlstr(anObject[i]),
                    '</span>');
        }
        arr.push('</span>');

        return arr.join('');
    }

    //  NamedNodeMap objects
    if (TP.isNamedNodeMap(anObject)) {
        arr = TP.ac();

        len = anObject.length;
        arr.push('<span class="NamedNodeMap">');
        for (i = 0; i < len; i++) {
            arr.push(
                    '<span data-name="key">',
                        TP.name(anObject.item(i)),
                    '</span>',
                    '<span data-name="value">',
                        TP.val(anObject.item(i)),
                    '</span>');
        }
        arr.push('</span>');

        return arr.join('');
    }

    //  Stylesheet objects
    if (TP.isStyleSheet(anObject)) {

        //  NB: Note how we do *not* expand imports here and we do *not* filter
        //  for CSSRule.STYLE_RULE types of rules.
        rules = TP.styleSheetGetStyleRules(anObject, false, false);

        arr = TP.ac();

        len = rules.length;
        for (i = 0; i < len; i++) {
            arr.push(TP.htmlstr(rules[i]));
        }

        return '<span class="CSSStyleSheet">' + arr.join(' ') + '</span>';
    }

    //  Style rule objects
    if (TP.isStyleRule(anObject)) {
        return '<span class="CSSStyleRule">' + anObject.cssText + '</span>';
    }

    //  Style declaration objects
    if (TP.isStyleDeclaration(anObject)) {
        return '<span class="CSSStyleDeclaration">' +
            anObject.cssText + '</span>';
    }

    //  we're usually calling this with a standard object so we can leverage
    //  TIBET's method APIs to do a best-fit job
    if (TP.canInvoke(anObject, 'asHTMLString')) {
        return anObject.asHTMLString();
    }

    //  other cases should be dealt with by just returning the string rep
    return TP.str(anObject);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('htmlstr', TP.objectHTMLString);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectJSONSource',
function(anObject) {

    /**
     * @method objectJSONSource
     * @alias jsonsrc
     * @summary Returns a best-possible JSON representation of the object. NOTE
     *     that the TP.jsonsrc() function is aliased to this function as a
     *     'shorthand'.
     * @description This function is used to avoid type checking an object or
     *     duplicating test code when you're not sure of the return type of some
     *     function but need a JSON string.
     * @param {Object} anObject The object to return the JSON for.
     * @returns {String} The best-possible JSON rep of the Object.
     */

    var arr,
        len,
        i,

        rules;

    if (anObject === void 0) {
        return '"undefined"';
    }

    if (anObject === null) {
        return '"null"';
    }

    if (TP.isNaN(anObject)) {
        return '"NaN"';
    }

    if (TP.isInvalidDate(anObject)) {
        return '"NaN-NaN-NaNTNaN:NaN:NaN"';
    }

    //  we're usually calling this with a standard object so we can leverage
    //  TIBET's method APIs to do a best-fit job
    if (TP.canInvoke(anObject, 'asJSONSource')) {
        try {
            return anObject.asJSONSource();
        } catch (e) {
            void 0;
        }
    }

    //  XMLHttpRequest can have permission issues, so check early
    if (TP.isXHR(anObject)) {
        return '{"type":"XHR",' +
                '"data":{' +
                    '"status":' + anObject.status.quoted('"') + ',' +
                    '"content":' + TP.jsonsrc(anObject.responseText) + '}}';
    }

    //  DocumentFragment objects need to be treated specially.
    if (TP.isFragment(anObject)) {
        arr = TP.ac();

        arr.push('{"type":"DocumentFragment","data":[');

        len = anObject.childNodes.length;
        for (i = 0; i < len; i++) {
            arr.push(TP.jsonsrc(anObject.childNodes[i]), ',');
        }

        //  Pop off the last comma
        arr.pop();

        arr.push(']}');

        return arr.join('');
    }

    //  native nodes are the next-most likely object being passed to this
    //  routine, so we'll try to build up a proper string here
    if (TP.isNode(anObject)) {
        return '{"type":"' + TP.tname(anObject) + '",' +
                '"data":' + TP.xml2json(anObject) + '}';
    }

    //  got to check Errors next... they freak out if handed to TP.isString().
    if (TP.isError(anObject)) {
        return '{"type":"' + TP.tname(anObject) + '",' +
                '"data":' + anObject.message.quoted('"') +
                '}';
    }

    if (TP.isString(anObject)) {
        return anObject.quoted('"');
    }

    if (TP.isNumber(anObject) || TP.isBoolean(anObject)) {
        return TP.objectToString(anObject);
    }

    if (!TP.isMutable(anObject)) {
        //  TODO:   does this really deal with all the special constants
        //  like NaN, Number.POSITIVE_INFINITY, etc.?

        return TP.objectToString(anObject).quoted('"');
    }

    if (TP.isFunction(anObject)) {
        return '{"type":"' + TP.tname(anObject) + '",' +
                '"data":' + TP.str(anObject) + '}';
    }

    //  The top-level Window has TIBET loaded into it, so it will respond to
    //  'asString' properly, but other iframes, etc. won't so we have to handle
    //  Windows in a special manner here, which is the same as the
    //  'asJSONSource()'
    if (TP.isWindow(anObject)) {
        return TP.windowAsJSONSource(anObject);
    }

    //  Event objects
    if (TP.isEvent(anObject)) {
        return TP.eventAsJSONSource(anObject);
    }

    //  NodeList objects
    if (TP.isNodeList(anObject)) {
        arr = TP.ac();

        arr.push('{"type":"NodeList","data":[');

        len = anObject.length;
        for (i = 0; i < len; i++) {
            arr.push(TP.jsonsrc(anObject[i]), ',');
        }

        //  Pop off the last comma
        arr.pop();

        arr.push(']}');

        return arr.join('');
    }

    //  NamedNodeMap objects
    if (TP.isNamedNodeMap(anObject)) {
        arr = TP.ac();

        arr.push('{"type":"NamedNodeMap","data":{');

        len = anObject.length;
        for (i = 0; i < len; i++) {

            arr.push('"', TP.name(anObject.item(i)), '":"',
                         TP.val(anObject.item(i)), '"',
                        ',');
        }

        //  Pop off the last comma
        arr.pop();

        arr.push('}}');

        return arr.join('');
    }

    //  Stylesheet objects
    if (TP.isStyleSheet(anObject)) {

        //  NB: Note how we do *not* expand imports here and we do *not* filter
        //  for CSSRule.STYLE_RULE types of rules.
        rules = TP.styleSheetGetStyleRules(anObject, false, false);

        arr = TP.ac();

        len = rules.length;
        for (i = 0; i < len; i++) {
            arr.push(TP.jsonsrc(rules[i]));
        }

        return '{"type":"Stylesheet","data":[' + arr.join(',') + ']}';
    }

    //  Style rule objects
    if (TP.isStyleRule(anObject)) {
        return '{"type":"Rule","data":"' + anObject.cssText + '"}';
    }

    //  Style declaration objects
    if (TP.isStyleDeclaration(anObject)) {
        return '{"type":"Declaration","data":"' + anObject.cssText + '"}';
    }

    //  other cases should be dealt with by just returning the JSON rep
    return TP.js2json(anObject);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('jsonsrc', TP.objectJSONSource);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectEntries',
function(anObject, includeNonenumerables, includePrototypeProps) {

    /**
     * @method objectEntries
     * @alias entries
     * @summary Returns the entries of the object - that is, the key/value pairs
     *     that the object consists of.
     * @param {Object} anObject The object to return the keys for.
     * @param {Boolean} [includeNonenumerables=false] Whether or not to include
     *     the supplied object's 'non enumerable' properties.
     * @param {Boolean} [includePrototypeProps=false] Whether or not to include
     *     properties that the supplied object inherits through it's prototype
     *     chain.
     * @returns {Array[]} The object's key/value pairs.
     */

    var keys,
        result;

    //  no valid source object means no work
    if (TP.notValid(anObject)) {
        return [];
    }

    if (!includeNonenumerables && !includePrototypeProps) {

        //  native Map and Set instances can be processed by native Array.from.
        if (TP.canInvoke(anObject, 'entries') && !TP.isArray(anObject)) {
            return Array.ECMAfrom(anObject);
        }

        //  Note that we only call 'getKVPairs' if the object has it *and*
        //  neither of the two flags are set.
        if (TP.canInvoke(anObject, 'getKVPairs')) {
            return anObject.getKVPairs();
        }
    }

    keys = TP.objectKeys(anObject,
                            includeNonenumerables,
                            includePrototypeProps);

    result = keys.map(
                function(aKey) {
                    //  NB: The object might be a POJO, so we use direct access
                    //  here (and direct Array creation for speed of
                    //  construction).
                    return [aKey, anObject[aKey]];
                });

    return result;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('entries', TP.objectEntries);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectKeys',
function(anObject, includeNonenumerables, includePrototypeProps) {

    /**
     * @method objectKeys
     * @alias keys
     * @summary Returns the keys of the object.
     * @description This function is used to avoid type checking an object or
     *     duplicating test code when you're not sure of the return type of some
     *     function but need the object's keys.
     * @param {Object} anObject The object to return the keys for.
     * @param {Boolean} [includeNonenumerables=false] Whether or not to include
     *     the supplied object's 'non enumerable' properties.
     * @param {Boolean} [includePrototypeProps=false] Whether or not to include
     *     properties that the supplied object inherits through it's prototype
     *     chain.
     * @returns {String[]} The object's keys.
     */

    var keys;

    //  no valid source object means no work
    if (TP.notValid(anObject)) {
        return [];
    }

    if (!includeNonenumerables && !includePrototypeProps) {
        //  Note that we only call 'getKeys' if the object has it *and* neither
        //  of the two flags are set.
        if (TP.canInvoke(anObject, 'getKeys')) {
            return anObject.getKeys();
        }

        //  Native set, map, etc. can do this but return an iterator, not array.
        if (TP.canInvoke(anObject, 'keys')) {
            return Array.ECMAfrom(anObject.keys());
        }

        //  Same for extracting keys from a POJO.
        if (TP.isPlainObject(anObject)) {
            keys = Object.keys(anObject);
            keys = keys.filter(
                        function(aKey) {
                            return !TP.regex.INTERNAL_SLOT.test(aKey);
                        });

            return keys;
        }
    }

    //  If the caller wants non enumerable and/or prototype properties, we call
    //  on one of the helpers defined on TP.boot
    if (includeNonenumerables && includePrototypeProps) {
        return TP.boot.$simplePropertyRetriever.
                getOwnAndPrototypeEnumerablesAndNonenumerables(anObject);
    } else if (includeNonenumerables) {
        return TP.boot.$simplePropertyRetriever.
                getOwnEnumerablesAndNonenumerables(anObject);
    } else if (includePrototypeProps) {
        return TP.boot.$simplePropertyRetriever.
                getOwnAndPrototypeEnumerables(anObject);
    }

    if (TP.isNode(anObject)) {
        if (TP.isXMLDocument(anObject)) {
            return TP.sys.$documentkeys;
        } else if (TP.isXMLNode(anObject) && TP.isElement(anObject)) {
            return TP.sys.$elementkeys;
        } else {
            return TP.sys.$nodekeys;
        }
    } else if (TP.isWindow(anObject)) {
        //  Webkit doesn't expose Window.prototype, so you can't put a
        //  getKeys() there.
        return TP.sys.$windowkeys;
    } else if (TP.isEvent(anObject)) {
        return TP.eventGetPropertyKeys(anObject);
    }

    return TP.$getOwnKeys(anObject);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('keys', TP.objectKeys);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectLocation',
function(anObject) {

    /**
     * @method objectLocation
     * @alias loc
     * @summary Returns the location represented by the receiver. The typical
     *     usage is in methods that might accept either a string or a
     *     TP.uri.URI which need a common way to ask for the location. When the
     *     object is neither a TP.uri.URI instance or a String the return value
     *     is based on the object's source path.
     * @param {String|TP.uri.URI} anObject The true location of the object in
     *     string form.
     * @returns {String} The location in string URI form.
     */

    var url;

    //  no valid source object means no work
    if (TP.notValid(anObject)) {
        return;
    }

    if (TP.isString(anObject)) {
        url = anObject;
    } else if (TP.canInvoke(anObject, 'getLocation')) {
        url = anObject.getLocation();
    } else {
        url = TP.objectGetSourcePath(anObject);
    }

    return TP.uriExpandPath(url);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('loc', TP.objectLocation);

//  ------------------------------------------------------------------------

TP.definePrimitive('parse',
function(aType, aString, aLocale) {

    /**
     * @method parse
     * @summary Attempts to produce an instance of aType by parsing the string
     *     provided.
     * @param {TP.FunctionProto|TP.lang.RootObject} aType A specific target type
     *     to produce.
     * @param {String} aString The incoming data to parse.
     * @param {TP.i18n.Locale|String} aLocale A string of the proper xml:lang
     *     format such as en, en:us, de, etc. or a valid TP.i18n.Locale subtype.
     * @returns {Object} An instance of aType if the parse is successful.
     */

    var type,

        result;

    if (!TP.isType(type = TP.sys.getTypeByName(aType))) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    if (!TP.canInvoke(type, 'parse')) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    if (!TP.isString(aString)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  Date.parse is already defined in ECMAScript to return a Number...
    //  sigh. Make sure to turn it into a Date instance.
    if (type === Date) {
        result = new Date(type.parse(aString, aLocale));
        if (!TP.isDate(result)) {
            result = null;
        }
    } else {
        result = type.parse(aString, aLocale);
    }

    return result;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('process',
function(anObject, aRequest) {

    /**
     * @method process
     * @summary Attempts to process a request using the object as a "service".
     *     If the object can't respond to a process request then its value
     *     (TP.val()) is used as the result of processing.
     * @param {Object} anObject The object to process.
     * @param {TP.sig.Request} aRequest The request to use in the processing
     *     process.
     * @returns {Object} The result of processing the object.
     */

    var obj;

    if (TP.notValid(anObject) || anObject === '') {
        return anObject;
    }

    obj = TP.wrap(anObject);

    if (TP.canInvoke(obj, 'process')) {
        return obj.process(aRequest);
    }

    obj = TP.canInvoke(anObject, 'process') ? anObject : TP.val(anObject);

    if (TP.canInvoke(obj, 'process')) {
        return obj.process(aRequest);
    }

    return anObject;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('processAndExecuteWith',
function(anObject, aRequest, stdinContent) {

    /**
     * @method processAndExecuteWith
     * @summary Attempts to process and execute a request using the object as a
     *     "service". If the object can't respond to a process request then its
     *     value (TP.val()) is used as the result of processing.
     * @param {Object} anObject The object to process and execute.
     * @param {TP.sig.Request} aRequest The request to use in the processing
     *     process.
     * @param {Object} stdinContent The content to use as 'stdin' when executing
     *     the supplied object.
     * @returns {Object} The result of processing and executing the object.
     */

    var obj;

    if (TP.notValid(anObject) || anObject === '') {
        return anObject;
    }

    obj = TP.wrap(anObject);

    if (TP.canInvoke(obj, 'processAndExecuteWith')) {
        return obj.processAndExecuteWith(aRequest, stdinContent);
    }

    obj = TP.canInvoke(anObject, 'processAndExecuteWith') ?
                anObject :
                TP.val(anObject);

    if (TP.canInvoke(obj, 'processAndExecuteWith')) {
        return obj.processAndExecuteWith(aRequest, stdinContent);
    }

    return anObject;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('object',
function(anObject) {

    /**
     * @method object
     * @alias obj
     * @summary Returns the 'plain object' representations of the object.
     * @param {Object} anObject The object to convert to a plain object.
     * @returns {Object} The object converted to a plain object.
     */

    if (anObject === null) {
        return null;
    } else if (anObject === undefined) {
        return undefined;
    }

    if (TP.canInvoke(anObject, 'asObject')) {
        return anObject.asObject();
    }

    return TP.val(anObject, 'value', false);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('obj', TP.object);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectSize',
function(anObject) {

    /**
     * @method objectSize
     * @alias size
     * @summary Returns the best size for the object, or TP.NO_SIZE if the
     *     object doesn't appear to have a size.
     * @param {Object} anObject The object to query for size.
     * @returns {Number} The size, or TP.NO_SIZE if no size is found.
     */

    if (TP.notValid(anObject)) {
        return TP.NO_SIZE;
    }

    if (TP.canInvoke(anObject, 'getSize')) {
        return anObject.getSize();
    }

    if (TP.owns(anObject, 'length')) {
        return anObject.length;
    }

    return TP.NO_SIZE;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('size', TP.objectSize);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectSourceValue',
function(anObject) {

    /**
     * @method objectSourceValue
     * @alias src
     * @summary Returns a JavaScript source representation of the object. NOTE
     *     that the TP.src() function is aliased to this function as a
     *     'shorthand'.
     * @description This function is used to avoid type checking an object or
     *     duplicating test code when you're not sure of the return type of some
     *     function but need a source rep of the return value.
     * @param {Object} anObject The object to return the representational String
     *     of.
     * @returns {String} The best-possible source rep of the Object.
     */

    var marker;

    if (anObject === null) {
        return 'null';
    } else if (anObject === undefined) {
        return 'undefined';
    }

    //  XMLHttpRequest can have permission issues, so check early
    if (TP.isXHR(anObject)) {
        return TP.NO_SOURCE_REP;
    }

    if (TP.isNode(anObject)) {
        if (TP.isDocument(anObject)) {
            return 'TP.doc(' +
                        TP.nodeAsString(anObject).quoted() +
                    ')';
        } else if (TP.isElement(anObject)) {
            return 'TP.elem(' +
                        TP.nodeAsString(anObject).quoted() +
                    ')';
        } else if (TP.isFragment(anObject)) {
            return 'TP.frag(' +
                        TP.nodeAsString(anObject).quoted() +
                    ')';
        } else {
            return 'TP.node(' +
                        TP.nodeAsString(anObject).quoted() +
                    ')';
        }
    }

    //  error objects are a little special, can't always work with them as
    //  instrumented objects so we'll do it manually... and they freak out if
    //  handed to TP.isString().
    if (TP.isError(anObject)) {
        return 'new Error(' + anObject.message.quoted() + ')';
    }

    //  strings are always single-quoted so they'll eval back in easily
    if (TP.isString(anObject)) {
        return anObject.quoted();
    }

    //  number/boolean just return value since it will eval in just fine.
    if (!TP.isMutable(anObject)) {
        return TP.str(anObject);
    }

    //  for a window we'll create a string that would open a new window with
    //  that location and name
    if (TP.isWindow(anObject)) {
        return 'TP.open("' +
                        anObject.document.location +
                        '", "' +
                        anObject.name +
                        '")';
    }

    //  Event objects
    if (TP.isEvent(anObject)) {
        return TP.eventAsSource(anObject);
    }

    //  NodeList objects
    if (TP.isNodeList(anObject)) {
        return TP.NO_SOURCE_REP;
    }

    //  NamedNodeMap objects
    if (TP.isNamedNodeMap(anObject)) {
        return TP.NO_SOURCE_REP;
    }

    //  Stylesheet objects
    if (TP.isStyleSheet(anObject)) {
        return TP.NO_SOURCE_REP;
    }

    //  Style rule objects
    if (TP.isStyleRule(anObject)) {
        return TP.NO_SOURCE_REP;
    }

    //  Style declaration objects
    if (TP.isStyleDeclaration(anObject)) {
        return TP.NO_SOURCE_REP;
    }

    if (TP.canInvoke(anObject, 'asSource')) {
        marker = '$$recursive_asSource';
        if (TP.owns(anObject, marker)) {
            return TP.recursion(anObject, marker);
        }

        try {
            this[marker] = true;
            return anObject.asSource();
        } finally {
            delete anObject[marker];
        }
    }

    if (TP.canInvoke(anObject, 'toString')) {
        return TP.js2json(anObject);
    }

    //  if all else fails we'll return the string value
    return TP.NO_SOURCE_REP;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('src', TP.objectSourceValue);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectStringValue',
function(anObject, verbose) {

    /**
     * @method objectStringValue
     * @alias str
     * @summary Returns a best-possible string representation of the object.
     *     NOTE that the TP.str() function is aliased to this function as a
     *     'shorthand'.
     * @description This function is used to avoid type checking an object or
     *     duplicating test code when you're not sure of the return type of some
     *     function but need a string rep of the return value. This method will
     *     attempt to get the best possible string by using asString and then
     *     degrading to calling TP.objectToString.
     * @param {Object} anObject The object to return the representational String
     *     of.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the object's String representation. Some objects have a more
     *     'verbose' version (like Nodes, which will print their entire
     *     contents). This is true by default.
     * @returns {String} The best-possible string rep of the Object.
     */

    var str,
        wantsVerbose,
        marker,
        arr,
        len,
        i,

        rules;

    if (anObject === null) {
        return 'null';
    } else if (anObject === undefined) {
        return 'undefined';
    }

    wantsVerbose = TP.ifInvalid(verbose, true);

    try {
        str = anObject.asString(wantsVerbose);

        //  If it reports as '[native code]' and is also a native type, then
        //  extract it's name.
        if (TP.regex.NATIVE_CODE.test(str) && TP.isNativeType(anObject)) {
            str = TP.tname(anObject);
        }

        return str;
    } catch (e) {
        void 0;
    }

    //  XMLHttpRequest can have permission issues, so check early
    if (TP.isXHR(anObject)) {
        if (wantsVerbose) {
            return TP.tname(anObject) + ' :: ' +
                    anObject.status + ' : ' + anObject.responseText;
        } else {
            return TP.objectToString(anObject);
        }
    }

    //  native nodes are the next-most likely object being passed to this
    //  routine, so we'll try to build up a proper string here
    if (TP.isNode(anObject)) {
        if (wantsVerbose) {
            return TP.nodeAsString(anObject);
        } else {
            return TP.objectToString(anObject);
        }
    }

    //  got to check Errors next... they freak out if handed to TP.isString().
    if (TP.isError(anObject)) {
        if (wantsVerbose) {
            return TP.tname(anObject) + ' :: ' + TP.errorAsString(anObject);
        } else {
            return TP.objectToString(anObject);
        }
    }

    if (TP.isString(anObject)) {
        return anObject;
    }

    if (!TP.isMutable(anObject)) {
        //  TODO:   does this really deal with all the special constants
        //  like NaN, Number.POSITIVE_INFINITY, etc.?
        return TP.objectToString(anObject);
    }

    //  The top-level Window has TIBET loaded into it, so it will respond to
    //  'asString' properly, but other iframes, etc. won't so we have to handle
    //  Windows in a special manner here.
    if (TP.isWindow(anObject)) {
        if (wantsVerbose) {
            return TP.windowAsString(anObject);
        } else {
            return TP.gid(anObject);
        }
    }

    //  Event objects
    if (TP.isEvent(anObject)) {
        if (wantsVerbose) {
            return TP.tname(anObject) + ' :: ' + TP.eventAsString(anObject);
        } else {
            return TP.objectToString(anObject);
        }
    }

    //  NodeList objects
    if (TP.isNodeList(anObject)) {
        if (wantsVerbose) {

            arr = TP.ac();

            len = anObject.length;
            for (i = 0; i < len; i++) {
                arr.push(TP.str(anObject[i]));
            }

            return TP.tname(anObject) + ' :: ' + '[' + arr.join(', ') + ']';
        } else {
            return TP.objectToString(anObject);
        }
    }

    //  NamedNodeMap objects
    if (TP.isNamedNodeMap(anObject)) {
        if (wantsVerbose) {

            arr = TP.ac();

            len = anObject.length;
            for (i = 0; i < len; i++) {
                arr.push(TP.name(anObject.item(i)) + ': ' +
                             TP.val(anObject.item(i)));
            }

            return TP.tname(anObject) + ' :: ' + '{' + arr.join(', ') + '}';
        } else {
            return TP.objectToString(anObject);
        }
    }

    //  Stylesheet objects
    if (TP.isStyleSheet(anObject)) {
        if (wantsVerbose) {

            //  NB: Note how we do *not* expand imports here and we do *not*
            //  filter for CSSRule.STYLE_RULE types of rules.
            rules = TP.styleSheetGetStyleRules(anObject, false, false);

            arr = TP.ac();

            len = rules.length;
            for (i = 0; i < len; i++) {
                arr.push(rules[i].cssText);
            }
            return TP.tname(anObject) + ' :: ' + arr.join(' ');
        } else {
            return TP.objectToString(anObject);
        }
    }

    //  Style rule objects
    if (TP.isStyleRule(anObject)) {
        if (wantsVerbose) {
            return TP.tname(anObject) + ' :: ' + anObject.cssText;
        } else {
            return TP.objectToString(anObject);
        }
    }

    //  Style declaration objects
    if (TP.isStyleDeclaration(anObject)) {
        if (wantsVerbose) {
            return TP.tname(anObject) + ' :: ' + anObject.cssText;
        } else {
            return TP.objectToString(anObject);
        }
    }

    if (TP.canInvoke(anObject, 'asString')) {
        str = anObject.asString(wantsVerbose);
        //  If it reports as '[native code]' and is also a native type, then
        //  extract it's name.
        if (TP.regex.NATIVE_CODE.test(str) && TP.isNativeType(anObject)) {
            str = TP.tname(anObject);
        }

        return str;
    }

    marker = '$$recursive_asString';
    if (TP.owns(anObject, marker)) {
        return TP.recursion(anObject, marker);
    }

    try {
        this[marker] = true;
        return TP.META_INST_OWNER.meta_methods.asString.call(anObject);
    } finally {
        delete anObject[marker];
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('str', TP.objectStringValue);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectValue',
function(anObject, anAspect, autoCollapse) {

    /**
     * @method objectValue
     * @alias val
     * @summary Returns anObject's value for anAspect, where the aspect
     *     defaults to 'value'. This method will attempt to use various TIBET
     *     methods such as get(), at(), etc. to get the best result. NOTE that
     *     the TP.val() function is aliased to this function as a 'shorthand'.
     * @param {Object} anObject The object to interrogate.
     * @param {String|Function} [anAspect='value'] The aspect whose value to
     *     get. If a Function is supplied here it will be called with the
     *     initial value and is expected to return the extracted value.
     * @param {Boolean} [autoCollapse=false] Whether to collapse Array results
     *     if there's only one item in them.
     * @returns {Object} The object's value, as defined by that object's
     *     semantics.
     */

    var aspect,
        val,
        i,
        len,
        parts,
        part,
        obj;

    if (anObject === null) {
        return null;
    } else if (anObject === undefined) {
        return undefined;
    }

    //  The value of a Type is the Type (native or TIBET-made)
    if (TP.isType(anObject)) {
        return anObject;
    }

    if (TP.isNaN(anObject)) {
        return NaN;
    }

    if (TP.isCallable(anAspect)) {
        return anAspect(anObject);
    }

    if (TP.isEmpty(anAspect)) {
        if (TP.isString(anObject)) {
            //  force to primitive string
            return '' + anObject;
        }

        //  non-mutables can't do much here, their value is their ID
        if (!TP.isMutable(anObject)) {
            return anObject;
        }

        aspect = 'value';
    } else if (TP.isPlainObject(anObject)) {
        //  Really only one approach in this case...
        if (anAspect.indexOf('.') !== TP.NOT_FOUND) {

            parts = anAspect.split('.');
            obj = anObject;

            len = parts.getSize();
            for (i = 0; i < len; i++) {
                part = parts.at(i);
                obj = obj[part];
                if (TP.notValid(obj)) {
                    return;
                }
            }
            return obj;
        } else if (anAspect === 'value') {
            return anObject;
        } else {
            return anObject[anAspect];
        }
    } else if (TP.regex.NON_SIMPLE_PATH.test(anAspect)) {
        aspect = TP.apc(anAspect);
    } else {
        aspect = anAspect;
    }

    if (TP.canInvoke(anObject, '$get') &&
        anObject.$get('$$isValueHolder')) {
        return anObject.get(aspect);
    }

    val = null;

    //  if the aspect is a URI (but only if it's an absolute URI with a scheme),
    //  try to get the value of the URI's resource's result.
    if (TP.isURIString(anAspect) &&
        TP.regex.HAS_SCHEME.test(TP.str(anAspect))) {
        //  NB: We assume 'async' of false here.
        val = TP.val(TP.uc(anAspect).getResource(
                                        TP.hc('async', false)).get('result'));
    }

    //  some native objects may not have been TIBET-enabled, so for those
    //  we try to get a wrapper and ask it
    if (TP.isNode(anObject)) {
        val = TP.tpnode(anObject).get(aspect);
    }

    if (TP.isWindow(anObject)) {
        if (aspect === 'value') {
            return anObject;
        }

        val = TP.tpwin(anObject).get(aspect);
    }

    if (TP.notValid(val) && TP.canInvoke(anObject, 'get')) {
        val = anObject.get(aspect);
    }

    if (TP.notValid(val)) {
        try {
            //  probably not something we can query at this stage, but we can
            //  try slot access just in case
            val = anObject[aspect];
        } catch (e) {
            //  did our best - don't report though
            //  empty
        }
    }

    if (TP.isValid(val)) {
        if (TP.isArray(val)) {
            //  Make sure that if autoCollapse is turned on that we either
            //  return the only item if there is only one or null if the Array
            //  is empty, to be consistent with 'collapse' usage elsewhere in
            //  TIBET.
            if (TP.isTrue(autoCollapse)) {
                if (val.getSize() === 1) {
                    return val.at(0);
                } else if (TP.isEmpty(val)) {
                    return null;
                }
            }
        }

        return val;
    }

    //  there was no computed value and an object's value defaults to itself,
    //  unless a specific aspect was provided as a query
    if (aspect === 'value') {
        return anObject;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('val', TP.objectValue);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectXHTMLNode',
function(anObject, aDocument) {

    /**
     * @method objectXHTMLNode
     * @alias xhtmlnode
     * @summary Returns an XHTML node representation of the supplied object.
     *     NOTE that the TP.xhtmlnode() function is aliased to this function as
     *     a 'shorthand'.
     * @description This function is used to avoid type checking an object or
     *     duplicating test code when you're not sure of the return type of some
     *     function but need an XHTML-compatible node.
     * @param {Object} anObject The object to format as XHTML.
     * @param {XMLDocument} aDocument The document which should own the result
     *     node. Defaults to the XML document TP.XML_FACTORY_DOCUMENT.
     * @returns {Node} The best-possible XHTML node for the Object.
     */

    var doc;

    //  no valid source object means no work
    if (TP.notValid(anObject)) {
        return;
    }

    //  If it's a String, then we return the value of 'TP.node()' and we specify
    //  that the default namespace for any non-prefixed elements that don't
    //  already have their own default namespace should be the XHTML namespace.
    if (TP.isString(anObject)) {
        return TP.node(anObject, TP.w3.Xmlns.XHTML);
    }

    //  If its already an XML node, we just return it.
    if (TP.isXMLNode(anObject)) {
        return anObject;
    }

    doc = TP.isXMLDocument(aDocument) ? aDocument :
                                    TP.XML_FACTORY_DOCUMENT;

    //  HTML nodes are the next-most likely object being passed to this
    //  routine, so we'll try to build up a proper string here
    if (TP.isHTMLNode(anObject)) {
        return TP.htmlNodeAsXHTMLNode(anObject, doc);
    }

    //  we're usually calling this with a standard object so we can
    //  leverage TIBET's method APIs to do a best-fit job
    if (TP.canInvoke(anObject, 'asXHTMLNode')) {
        return anObject.asXHTMLNode(doc);
    }

    return doc.createTextNode(TP.str(anObject));
});

//  ------------------------------------------------------------------------

TP.definePrimitive('xhtmlnode', TP.objectXHTMLNode);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectXHTMLString',
function(anObject) {

    /**
     * @method objectXHTMLString
     * @alias xhtmlstr
     * @summary Returns an XHTML string representation of the supplied object.
     *     NOTE that the TP.xhtmlstr() function is aliased to this function as a
     *     'shorthand'.
     * @description This function is used to avoid type checking an object or
     *     duplicating test code when you're not sure of the return type of some
     *     function but need an XHTML-compatible string. For objects which can't
     *     provide their own asXHTMLString implementations this method typically
     *     returns the objectStringValue.
     * @param {Object} anObject The object to format as XHTML.
     * @returns {String} The best-possible XHTML rep of the Object.
     */

    //  no valid source object means no work
    if (TP.notValid(anObject)) {
        return;
    }

    //  If its already an XML node, we just return it.
    if (TP.isXMLNode(anObject)) {
        return TP.nodeAsString(anObject);
    }

    //  HTML nodes are the next-most likely object being passed to this
    //  routine, so we'll try to build up a proper string here
    if (TP.isHTMLNode(anObject)) {
        return TP.htmlNodeAsXHTMLString(anObject);
    }

    //  we're usually calling this with a standard object so we can
    //  leverage TIBET's method APIs to do a best-fit job
    if (TP.canInvoke(anObject, 'asXHTMLString')) {
        return anObject.asXHTMLString();
    }

    //  other cases should be dealt with by just returning the string rep
    return TP.str(anObject);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('xhtmlstr', TP.objectXHTMLString);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectXMLNode',
function(anObject, aDocument) {

    /**
     * @method objectXMLNode
     * @alias xmlnode
     * @summary Returns an XML node representation of the supplied object.
     *     NOTE that the TP.xmlnode() function is aliased to this function as a
     *     'shorthand'.
     * @description This function is used to avoid type checking an object or
     *     duplicating test code when you're not sure of the return type of some
     *     function but need an XML-compatible node.
     * @param {Object} anObject The object to format as XML.
     * @param {XMLDocument} aDocument The document which should own the result
     *     node. Defaults to the XML document TP.XML_FACTORY_DOCUMENT.
     * @returns {Node} The best-possible XML node for the Object.
     */

    var doc;

    //  no valid source object means no work
    if (TP.notValid(anObject)) {
        return;
    }

    //  If it's a String, then we return the value of 'TP.node()'
    if (TP.isString(anObject)) {
        return TP.node(anObject);
    }

    doc = TP.isXMLDocument(aDocument) ? aDocument :
                                    TP.XML_FACTORY_DOCUMENT;

    //  native nodes are the next-most likely object being passed to this
    //  routine, so we'll try to build up a proper string here
    if (TP.isNode(anObject)) {
        return TP.nodeAsXMLNode(anObject, doc);
    }

    //  we're usually calling this with a standard object so we can
    //  leverage TIBET's method APIs to do a best-fit job
    if (TP.canInvoke(anObject, 'asXMLNode')) {
        return anObject.asXMLNode(doc);
    }

    return doc.createTextNode(TP.str(anObject));
});

//  ------------------------------------------------------------------------

TP.definePrimitive('xmlnode', TP.objectXMLNode);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectXMLString',
function(anObject) {

    /**
     * @method objectXMLString
     * @alias xmlstr
     * @summary Returns an XML string representation of the supplied object.
     *     NOTE that the TP.xmlstr() function is aliased to this function as a
     *     'shorthand'.
     * @description This function is used to avoid type checking an object or
     *     duplicating test code when you're not sure of the return type of some
     *     function but need an XML-compatible string. For objects which can't
     *     provide their own asXHTMLString implementations this method typically
     *     returns the objectStringValue.
     * @param {Object} anObject The object to format as XML.
     * @returns {String} The best-possible XML rep of the Object.
     */

    var arr,
        len,
        i,

        rules;

    if (anObject === null) {
        return 'null';
    } else if (anObject === undefined) {
        return 'undefined';
    }

    //  XMLHttpRequest can have permission issues, so check early
    if (TP.isXHR(anObject)) {
        return '<xhr>' +
                '<status>' + anObject.status + '</status>' +
                '<content>' + TP.xmlstr(anObject.responseText) + '</content>' +
                '</xhr>';
    }

    //  native nodes are the next-most likely object being passed to this
    //  routine, so we'll try to build up a proper string here
    if (TP.isNode(anObject)) {
        return TP.nodeAsXMLString(anObject);
    }

    //  got to check Errors next... they freak out if handed to TP.isString().
    if (TP.isError(anObject)) {
        return '<error>' +
                '<type>' + TP.tname(anObject) + '</type>' +
                '<message>' + TP.str(anObject.message) + '</message>' +
                '</error>';
    }

    if (TP.isString(anObject)) {
        return anObject;
    }

    //  Since Number is a non-mutable, we must do this before the next check
    if (TP.isNumber(anObject)) {
        return anObject.asXMLString();
    }

    if (!TP.isMutable(anObject)) {
        //  TODO:   does this really deal with all the special constants
        //  like NaN, Number.POSITIVE_INFINITY, etc.?
        return TP.objectToString(anObject);
    }

    //  The top-level Window has TIBET loaded into it, so it will respond to
    //  'asString' properly, but other iframes, etc. won't so we have to handle
    //  Windows in a special manner here, which is the same as the
    //  'asXMLString()'
    if (TP.isWindow(anObject)) {
        return TP.windowAsXMLString(anObject);
    }

    //  Event objects
    if (TP.isEvent(anObject)) {
        return TP.eventAsXMLString(anObject);
    }

    //  NodeList objects
    if (TP.isNodeList(anObject)) {
        arr = TP.ac();

        len = anObject.length;
        for (i = 0; i < len; i++) {
            arr.push('<node index="', i, '">',
                        TP.xmlstr(anObject[i]),
                        '</node>');
        }

        return arr.join('');
    }

    //  NamedNodeMap objects
    if (TP.isNamedNodeMap(anObject)) {
        arr = TP.ac();

        len = anObject.length;
        for (i = 0; i < len; i++) {
            arr.push('<', TP.name(anObject.item(i)), '>',
                         TP.val(anObject.item(i)),
                        '</', TP.name(anObject.item(i)), '>');
        }

        return arr.join('');
    }

    //  Stylesheet objects
    if (TP.isStyleSheet(anObject)) {

        //  NB: Note how we do *not* expand imports here and we do *not* filter
        //  for CSSRule.STYLE_RULE types of rules.
        rules = TP.styleSheetGetStyleRules(anObject, false, false);

        arr = TP.ac();

        len = rules.length;
        for (i = 0; i < len; i++) {
            arr.push(TP.xmlstr(rules[i]));
        }

        return '<sheet>' + arr.join(' ') + '</sheet>';
    }

    //  Style rule objects
    if (TP.isStyleRule(anObject)) {
        return '<rule>' + anObject.cssText + '</rule>';
    }

    //  Style declaration objects
    if (TP.isStyleDeclaration(anObject)) {
        return '<declaration>' + anObject.cssText + '</declaration>';
    }

    //  we're usually calling this with a standard object so we can leverage
    //  TIBET's method APIs to do a best-fit job
    if (TP.canInvoke(anObject, 'asXMLString')) {
        return anObject.asXMLString();
    }

    //  other cases should be dealt with by just returning the string rep (after
    //  doing literal-to-entity replacement)
    return TP.xmlLiteralsToEntities(
            TP.htmlEntitiesToXMLEntities(
            TP.str(anObject)));
});

//  ------------------------------------------------------------------------

TP.definePrimitive('xmlstr', TP.objectXMLString);

//  ------------------------------------------------------------------------

TP.definePrimitive('windowAsHTMLString',
function(windowObj) {

    /**
     * @method windowAsHTMLString
     * @summary Returns an HTML String representation of the supplied Window
     *     object.
     * @param {Window} windowObj The window object to produce the HTML String
     *     representation of.
     * @returns {String} An HTML String representation of the supplied Window
     *     object.
     */

    var arr,
        keys,
        len,
        i;

    arr = TP.ac();

    keys = TP.sys.$windowkeys;
    len = keys.length;

    arr.push('<span class="DOMWindow" gid="', TP.gid(windowObj), '">');

    for (i = 0; i < len; i++) {
        try {
            arr.push('<span data-name="', keys[i], '">',
                        TP.htmlstr(windowObj[keys[i]]), '</span>');
        } catch (e) {
            arr.push('<span data-name="', keys[i], '">',
                        TP.htmlstr(undefined), '</span>');
        }
    }

    arr.push('</span>');

    return arr.join('').toString();
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowAsJSONSource',
function(windowObj) {

    /**
     * @method windowAsJSONSource
     * @summary Returns a JSON String representation of the supplied Window
     *     object.
     * @param {Window} windowObj The window object to produce the JSON String
     *     representation of.
     * @returns {String} An JSON String representation of the supplied Window
     *     object.
     */

    var arr,
        keys,
        len,
        i;

    arr = TP.ac();

    keys = TP.sys.$windowkeys;
    len = keys.length;

    arr.push('{"type":"DOMWindow","data":{');

    arr.push('"gid":', TP.gid(windowObj).quoted('"'));

    arr.push(',');

    for (i = 0; i < len; i++) {
        try {
            arr.push(keys[i].quoted('"'), ':', TP.jsonsrc(windowObj[keys[i]]));
        } catch (e) {
            arr.push(keys[i].quoted('"'), ':"undefined"');
        } finally {
            arr.push(',');
        }
    }

    //  Pop off the trailing comma
    arr.pop();

    arr.push('}}');

    return arr.join('').toString();
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowAsPrettyString',
function(windowObj) {

    /**
     * @method windowAsPrettyString
     * @summary Returns a 'pretty print' representation of the supplied Window
     *     object.
     * @param {Window} windowObj The window object to produce the pretty print
     *     representation of.
     * @returns {String} A pretty print representation of the supplied Window
     *     object.
     */

    var arr,
        keys,
        len,
        i;

    arr = TP.ac();

    keys = TP.sys.$windowkeys;
    len = keys.length;

    arr.push('<dl class="pretty ', TP.escapeTypeName(TP.tname(windowObj)), '">',
                '<dt>Type name</dt>',
                '<dd class="pretty typename">', TP.tname(windowObj), '</dd>');

    arr.push('<dt class="pretty key">Global ID</dt>',
                '<dd>', TP.gid(windowObj), '</dd>');

    for (i = 0; i < len; i++) {
        try {
            arr.push('<dt class="pretty key">', keys[i], '</dt>',
                        '<dd>', TP.pretty(windowObj[keys[i]]), '</dd>');
        } catch (e) {
            arr.push('<dt class="pretty key">', keys[i], '</dt>',
                        '<dd>', TP.pretty(undefined), '</dd>');
        }
    }

    arr.push('</dl>');

    return arr.join('').toString();
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowAsString',
function(windowObj) {

    /**
     * @method windowAsString
     * @summary Returns a String representation of the supplied Window
     *     object.
     * @param {Window} windowObj The window object to produce the String
     *     representation of.
     * @returns {String} A String representation of the supplied Window
     *     object.
     */

    var arr,
        keys,
        len,
        i;

    arr = TP.ac();

    keys = TP.sys.$windowkeys;
    len = keys.length;

    arr.push(TP.gid(windowObj));

    //  NB: We use '+' concatting here sometimes because of the join on comma
    //  (',') below.
    for (i = 0; i < len; i++) {
        try {
            arr.push(keys[i] + ': ' + TP.str(windowObj[keys[i]]));
        } catch (e) {
            arr.push(keys[i] + ': undefined');
        }
    }

    return arr.join(', ').toString();
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowAsXMLString',
function(windowObj) {

    /**
     * @method windowAsXMLString
     * @summary Returns an XML String representation of the supplied Window
     *     object.
     * @param {Window} windowObj The window object to produce the XML String
     *     representation of.
     * @returns {String} An XML String representation of the supplied Window
     *     object.
     */

    var arr,
        keys,
        len,
        i;

    arr = TP.ac();

    keys = TP.sys.$windowkeys;
    len = keys.length;

    arr.push('<window');

    arr.push(' gid="', TP.gid(windowObj), '"');

    for (i = 0; i < len; i++) {
        try {
            arr.push(' ', keys[i], '="', TP.xmlstr(windowObj[keys[i]]), '"');
        } catch (e) {
            arr.push(' ', keys[i], '="undefined"');
        }
    }

    arr.push('/>');

    return arr.join('').toString();
});

//  ------------------------------------------------------------------------
//  REFLECTION QUERIES
//  ------------------------------------------------------------------------

TP.definePrimitive('objectType',
function(anObject) {

    /**
     * @method objectType
     * @alias type
     * @summary Returns the type object for the object provided. NOTE that this
     *     is not the same as the value returned by the native typeof keyword,
     *     which is the type name. NOTE that the TP.type() function is aliased
     *     to this function as a 'shorthand'.
     * @description While we prefer polymorphic messaging to type checking it's
     *     sometimes necessary to do the latter. This method gives you a way to
     *     get the Type object responsible for the object provided. If you want
     *     the type name use TP.objectTypeName instead. Note that the value
     *     returned by these functions is based on the TIBET concept for types,
     *     not the native values returned by typeof. For example, TIBET thinks
     *     the type name of a String is "String", not "string". Also note that
     *     this method and the TP.objectTypeName call return a far more detailed
     *     type or type name than "object" for most objects.
     * @param {Object} anObject The object to return the Type for.
     * @returns {Object} The type of the supplied object.
     */

    var typeName,
        type;

    //  no valid source object means no work
    if (TP.notValid(anObject)) {
        return;
    }

    if (TP.canInvoke(anObject, 'getType')) {
        return anObject.getType();
    }

    //  If it's not a TIBET-enhanced object we don't have a lot of options left.
    //  It's tempting to just rely on the object's native constructor. The thing
    //  is, in many host environments, an object's 'constructor' slot *cannot*
    //  be counted upon to be the actual 'instance of Function representing the
    //  object's type in the system' (i.e. 'CSSStyleSheet' or whatever). The
    //  'Host' object system, especially in browsers, is *seriously*
    //  underspecified. So here we try to get the object's type name and then
    //  look the object with that name on the global. This gives us a consistent
    //  way to find an object's "type".
    if (TP.notEmpty(typeName = TP.objectTypeName(anObject))) {
        if (TP.isValid(type = TP.global[typeName])) {
            return type;
        }
    }

    //  We're out of ideas... return the '.constructor' and pray...
    return anObject.constructor;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('type', TP.objectType);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectSupertype',
function(anObject) {

    /**
     * @method objectSupertype
     * @alias stype
     * @summary Returns the supertype object for the object provided.
     * @param {Object} anObject The object to return the supertype for.
     * @returns {Object} The supertype of the supplied object.
     */

    var supertype;

    //  no valid source object means no work
    if (TP.notValid(anObject)) {
        return;
    }

    if (TP.canInvoke(anObject, 'getSupertype')) {
        return anObject.getSupertype();
    }

    if (TP.isValid(supertype = anObject[TP.SUPER])) {
        return supertype;
    }

    //  We're out of ideas... return null
    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('stype', TP.objectSupertype);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectTypeName',
function(anObject) {

    /**
     * @method objectTypeName
     * @alias tname
     * @summary Returns the type name for the object provided. NOTE that this
     *     is not the same as the value returned by the native typeof keyword,
     *     which is often inadequately detailed and/or simply wrong. NOTE that
     *     the TP.tname() function is aliased to this function as a 'shorthand'.
     * @description While we prefer polymorphic messaging to type checking it's
     *     sometimes necessary to do the latter. This method gives you a way to
     *     get the Type name of the object provided. If you want the type object
     *     use TP.objectType instead. Note that the value returned by these
     *     functions is based on the TIBET concept of types, not the native
     *     values returned by typeof.
     * @param {Object} anObject The object to return the Type name for.
     * @returns {String} The object's type name.
     */

    var type,
        str,
        name;

    if (TP.notDefined(anObject)) {
        return 'Undefined';
    }

    if (TP.isNull(anObject)) {
        return 'Null';
    }

    if (TP.isNativeType(anObject)) {
        return 'Function';
    }

    //  First see if it responds to 'getTypeName()' - polymorphically, this is
    //  the best approach
    if (TP.canInvoke(anObject, 'getTypeName')) {
        return anObject.getTypeName();
    }

    //  Then check to see if it's constructor can respond to 'getName()'
    type = anObject.constructor;

    //  Some objects lie - they will report their constructor as Object, but
    //  they're really something else
    if (type === Object) {
        if (TP.isNamedNodeMap(anObject)) {
            return 'NamedNodeMap';
        }
    }

    if (TP.canInvoke(type, 'getName')) {
        return type.getName();
    }

    //  Then see if calling 'TP.objectToString()' on it will result in the
    //  native '[object ...]' representation yielding something useful
    if (TP.notEmpty(str = TP.objectToString(anObject)) &&
            TP.regex.NATIVE_TYPENAME_MATCH.test(str)) {
        if (TP.notEmpty(name = str.match(TP.regex.NATIVE_TYPENAME_EXTRACT))) {
            return name[1];
        }
    }

    return typeof type;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('tname', TP.objectTypeName);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectSupertypes',
function(anObject) {

    /**
     * @method objectSupertypes
     * @alias stypes
     * @summary Returns an Array of 'supertype' for the object provided.
     *     NOTE that the TP.stnames() function is aliased to this function as a
     *     'shorthand'.
     * @description While we prefer polymorphic messaging to type checking it's
     *     sometimes necessary to do the latter. This method gives you a way to
     *     get the list of supertypes of the object provided. Note that the
     *     values returned by these functions is based on the TIBET concept of
     *     types, not the native values returned by typeof.
     * @param {Object} anObject The object to return the list of supertypes for.
     * @returns {TP.meta.lang.RootObject[]} A list of the object's supertypes.
     */

    var type,
        obj,
        supers;

    if (TP.notDefined(anObject) || TP.isNull(anObject)) {
        return TP.ac();
    }

    //  Types

    //  Non-Function host objects
    if (TP.isNonFunctionConstructor(anObject)) {
        //  These guys are shallow
        return TP.ac(Object);
    }

    //  Function-based host objects
    if (TP.isNativeType(anObject)) {
        if (anObject === Function) {
            return TP.ac(Object);
        }

        //  If the object has a 'TP.ANCESTORS' property, that means it's been
        //  instrumented by us for consistency. Return the value of that.
        if (TP.isValid(supers = anObject[TP.ANCESTORS]) &&
            TP.owns(anObject, TP.ANCESTORS)) {
            return supers;
        }

        //  Walk the 'getPrototypeOf()' proto chain until it's null, gathering
        //  names along the way. Since these are already constructors, we don't
        //  need to get their constructor like we do below.
        obj = anObject;
        supers = TP.ac();

        while (TP.isValid(obj = Object.getPrototypeOf(obj))) {
            if (obj === TP.FunctionProto) {
                //  NB: If the object is TP.FunctionProto, we do not push
                //  'Function' (or anything else) onto the results. We're not
                //  interested in knowing that things end up on Function in the
                //  prototype chain
                continue;
            }

            if (obj === TP.ObjectProto) {
                supers.push(Object);
            } else {
                supers.push(obj);
            }
        }

        anObject[TP.ANCESTORS] = supers;

        return supers;
    }

    //  Have to put this test *after* the isNativeType() test so that we know
    //  we're talking to a TIBET type.
    if (TP.isType(anObject)) {
        return anObject.getSupertypes();
    }

    //  Instances

    type = TP.type(anObject);

    //  Non-Function host objects
    if (TP.isNonFunctionConstructor(type)) {
        //  These guys are shallow
        return TP.ac(Object);
    }

    //  Function-based host objects
    if (TP.isNativeType(type)) {

        //  If the type has a 'TP.ANCESTORS' property, that means it's been
        //  instrumented by us for consistency. Return the value of that.
        if (TP.isValid(supers = type[TP.ANCESTORS]) &&
            TP.owns(type, TP.ANCESTORS)) {
            return supers;
        }

        //  Grab the list of supertypes from the type and slice off the last
        //  two (which slice off any 'Function' or 'Object' references).
        supers = TP.stypes(type);
        supers = supers.slice(0, supers.getSize() - 2);

        //  If the type isn't 'Object' itself (in which case there will already
        //  be an entry for 'Object'), then push Object onto the end.
        if (type !== Object) {
            supers.push(Object);
        }

        type[TP.ANCESTORS] = supers;

        return supers;
    }

    //  Instances of TIBET types and instances should respond to
    //  'getSupertypes()' - polymorphically, this is the best approach
    if (TP.canInvoke(anObject, 'getSupertypes')) {
        return anObject.getSupertypes();
    }

    return TP.ac();
});

//  ------------------------------------------------------------------------

TP.definePrimitive('stypes', TP.objectSupertypes);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectSupertypeNames',
function(anObject) {

    /**
     * @method objectSupertypeNames
     * @alias stnames
     * @summary Returns an Array of 'supertype' names for the object provided.
     *     NOTE that the TP.stnames() function is aliased to this function as a
     *     'shorthand'.
     * @description While we prefer polymorphic messaging to type checking it's
     *     sometimes necessary to do the latter. This method gives you a way to
     *     get the list of supertype names of the object provided. Note that the
     *     values returned by these functions is based on the TIBET concept of
     *     types, not the native values returned by typeof.
     * @param {Object} anObject The object to return the list of supertype names
     *     for.
     * @returns {String[]} A list of the object's supertype names.
     */

    var type,
        obj,
        supernames;

    if (TP.notDefined(anObject) || TP.isNull(anObject)) {
        return TP.ac();
    }

    //  Types

    //  Non-Function host objects
    if (TP.isNonFunctionConstructor(anObject)) {
        //  These guys are shallow
        return TP.ac('Object');
    }

    //  Function-based host objects
    if (TP.isNativeType(anObject)) {
        if (anObject === Function) {
            return TP.ac('Object');
        }

        //  If the object has a 'TP.ANCESTOR_NAMES' property, that means it's
        //  been instrumented by us for consistency. Return the value of that.
        if (TP.isValid(supernames = anObject[TP.ANCESTOR_NAMES]) &&
            TP.owns(anObject, TP.ANCESTOR_NAMES)) {
            return supernames;
        }

        //  Walk the 'getPrototypeOf()' proto chain until it's null, gathering
        //  names along the way. Since these are already constructors, we don't
        //  need to get their constructor like we do below.
        obj = anObject;
        supernames = TP.ac();

        while (TP.isValid(obj = Object.getPrototypeOf(obj))) {
            if (obj === TP.FunctionProto) {
                //  NB: If the object is TP.FunctionProto, we do not push
                //  'Function' (or anything else) onto the results. We're not
                //  interested in knowing that things end up on Function in the
                //  prototype chain
                continue;
            }

            if (obj === TP.ObjectProto) {
                supernames.push('Object');
            } else {
                supernames.push(TP.name(obj));
            }
        }

        anObject[TP.ANCESTOR_NAMES] = supernames;

        return supernames;
    }

    //  Have to put this test *after* the isNativeType() test so that we know
    //  we're talking to a TIBET type.
    if (TP.isType(anObject)) {
        return anObject.getSupertypeNames();
    }

    //  Instances

    type = TP.type(anObject);

    //  Non-Function host objects
    if (TP.isNonFunctionConstructor(type)) {
        //  These guys are shallow
        return TP.ac('Object');
    }

    //  Function-based host objects
    if (TP.isNativeType(type)) {

        //  If the type has a 'TP.ANCESTOR_NAMES' property, that means it's been
        //  instrumented by us for consistency. Return the value of that.
        if (TP.isValid(supernames = type[TP.ANCESTOR_NAMES]) &&
            TP.owns(type, TP.ANCESTOR_NAMES)) {
            return supernames;
        }

        //  Grab the list of supertypes from the type and slice off the last
        //  two (which slice off any 'Function' or 'Object' references).
        supernames = TP.stnames(type);
        supernames = supernames.slice(0, supernames.getSize() - 2);

        //  If the type isn't 'Object' itself (in which case there will already
        //  be an entry for 'Object'), then push Object onto the end.
        if (type !== Object) {
            supernames.push('Object');
        }

        type[TP.ANCESTOR_NAMES] = supernames;

        return supernames;
    }

    //  Instances of TIBET types and instances should respond to
    //  'getSupertypes()' - polymorphically, this is the best approach
    if (TP.canInvoke(anObject, 'getSupertypes')) {
        return anObject.getSupertypeNames();
    }

    return TP.ac();
});

//  ------------------------------------------------------------------------

TP.definePrimitive('stnames', TP.objectSupertypeNames);

//  ------------------------------------------------------------------------
//  SETTERS
//  ------------------------------------------------------------------------

TP.definePrimitive('objectSetValue',
function(anObject, anAspect, aValue) {

    /**
     * @method objectSetValue
     * @alias setval
     * @summary Sets the value for anAspect using set(), atPut(), or a direct
     *     slot access in that order.
     * @param {Object} anObject The object to update.
     * @param {String} anAspect The aspect whose value to alter. Default is
     *     'value'.
     * @param {Object} aValue The new value to set.
     * @returns {Object} The original object, OR a wrapper if that object was
     *     capable of being wrapped in a more powerful TIBET type. The return
     *     value is effectively the object whose set(), atPut(), or slot was
     *     accessed.
     */

    var obj,
        aspect,
        old;

    if (TP.notValid(anObject)) {
        return;
    }

    //  We don't set the value of a Type (native or TIBET-made) this way.
    if (TP.isType(anObject)) {
        return;
    }

    //  Can't set the value of NaN
    if (TP.isNaN(anObject)) {
        return;
    }

    if (!TP.isMutable(anObject)) {
        return;
    }

    if (TP.isEmpty(anAspect)) {
        aspect = 'value';
    } else if (TP.regex.NON_SIMPLE_PATH.test(anAspect)) {
        aspect = TP.apc(anAspect);
    } else {
        aspect = anAspect;
    }

    //  wrapping gets us the best possible handler for set() operations
    obj = TP.wrap(anObject);

    if (TP.canInvoke(obj, 'set')) {
        return obj.set(aspect, aValue);
    }

    if (TP.canInvoke(obj, 'atPut')) {
        return obj.atPut(aspect, aValue);
    }

    //  not everybody likes to set every property :)
    try {
        old = obj[aspect];
        if (old === aValue) {
            return obj;
        }

        obj[aspect] = aValue;
        if (obj[aspect] === aValue) {
            TP.signal(obj, aspect + 'Change');
        }
    } catch (e) {
        //  probably didn't work...but just in case
        if (obj[aspect] === aValue) {
            TP.signal(obj, aspect + 'Change');
        }
    }

    return obj;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('setval', TP.objectSetValue);

//  ------------------------------------------------------------------------
//  VALIDATION
//  ------------------------------------------------------------------------

TP.definePrimitive('validate',
function(anObject, aType) {

    /**
     * @method validate
     * @summary Validates anObject with respect to the constraints defined by
     *     aType. This method will attempt to use the object's isa() method if
     *     possible and, failing that, will try to use the type's validate()
     *     method. When no means can be found to be sure that the validation
     *     passes this method returns false.
     * @param {Object} anObject The object to validate.
     * @param {String|Type} aType A Type or type name.
     * @param {TP.lang.RootObject|String} aType The type object or type name
     *     String to use for validation.
     */

    var type;

    //  not much to check, but we won't call this failure
    if (!TP.isType(aType)) {
        return true;
    }

    //  objects can sometimes spoof type membership, and we allow that here
    //  by offering the right to answer to the object first
    if (TP.canInvoke(anObject, 'isa')) {
        if (!anObject.isa(aType)) {
            return false;
        }
    }

    //  apparently not a viable TIBET-enhanced object, perhaps the type can
    //  make a decision "from the outside"
    if (TP.isType(type = TP.sys.getTypeByName(aType))) {
        if (TP.canInvoke(type, 'validate')) {
            return type.validate(anObject);
        }
    }

    //  NOTE the default here...if we can't prove it's valid we assume it
    //  isn't
    return false;
});

//  ------------------------------------------------------------------------
//  WRAP/UNWRAP
//  ------------------------------------------------------------------------

/*
TP.dom.Node vs. Node, TP.core.Window vs. Window, etc.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('objectUnwrap',
function(anObject) {

    /**
     * @method objectUnwrap
     * @alias unwrap
     * @summary Returns the native object equivalent (or content) of the
     *     receiver. This is a way of "unboxing" TIBET wrappers in a consistent
     *     fashion regardless of their type. NOTE that the TP.unwrap() function
     *     is aliased to this function as a 'shorthand'.
     * @param {Object} anObject The object to interrogate.
     * @example Obtain the native Window for a TP.core.Window:
     *     <code>
     *          tpWin = TP.tpwin(top);
     *          TP.unwrap(tpWin) === top;
     *          <samp>true</samp>
     *     </code>
     * @example Obtain the native Document for a TP.dom.DocumentNode:
     *     <code>
     *          tpDoc = TP.tpnode(top.document);
     *          TP.unwrap(tpDoc) === top.document;
     *          <samp>true</samp>
     *     </code>
     * @example Obtain the native Node for a TP.dom.Node:
     *     <code>
     *          tpNode = TP.tpnode(TP.documentGetBody(top.document));
     *          TP.unwrap(tpNode) === TP.documentGetBody(top.document);
     *          <samp>true</samp>
     *     </code>
     * @returns {Object} A native object.
     */

    var newObj,

        len,
        i,

        keys;

    //  Note that a *lot* of things in the system use wrap and unwrap, so the
    //  potential for endless recursions is high. Therefore, we need to use 'low
    //  level' primitives to do processing here.

    //  fail on null/undefined content...although it would have been fun to
    //  return a TP.lang.Null or TP.lang.Undefined wouldn't it ;)
    if (TP.notDefined(anObject)) {
        return undefined;
    }

    if (TP.isNull(anObject)) {
        return null;
    }

    //  The wrapped value of a Type is the Type (native or TIBET-made)
    if (TP.isType(anObject)) {
        return anObject;
    }

    if (TP.isNodeList(anObject) || TP.isNamedNodeMap(anObject)) {
        return anObject;
    }

    //  TP.dom.Nodes, TP.sig.HTTPResponse, TP.sig.DOMUISignal, TP.core.Window,
    //  TP.uri.URI, etc.
    if (TP.canInvoke(anObject, 'getNativeObject')) {
        return anObject.getNativeObject();
    }

    //  unwrapping a list of items is a really powerful option so we can
    //  manipulate the list using more intelligence
    if (TP.isArray(anObject)) {
        newObj = TP.ac();
        len = anObject.length;
        for (i = 0; i < len; i++) {
            newObj.push(TP.unwrap(anObject.at(i)));
        }

        return newObj;
    }

    if (TP.isHash(anObject)) {
        keys = TP.keys(anObject);

        newObj = TP.hc();
        len = keys.length;
        for (i = 0; i < len; i++) {
            newObj.atPut(keys.at(i), TP.unwrap(anObject.at(keys.at(i))));
        }

        return newObj;
    }

    return anObject;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('unwrap', TP.objectUnwrap);

//  ------------------------------------------------------------------------

TP.definePrimitive('objectWrap',
function(anObject) {

    /**
     * @method objectWrap
     * @alias wrap
     * @summary Wraps the object in a suitable TIBET encapsulation type. Most
     *     objects don't require this and simply pass through, however Node and
     *     Window instances will be wrapped in TP.dom.Node or TP.core.Window
     *     wrappers as appropriate. NOTE that passing an array or, more
     *     interestingly, a NodeList to this method will result in the contents
     *     of the list being wrapped. This is an easy way to get a set of native
     *     nodes wrapped into an array of TP.dom.Node objects for further
     *     processing.
     * @param {Object} anObject The object wrapper, or the object if no wrapper
     *     type is suitable.
     * @returns {String} A string "name".
     */

    var newObj,
        len,
        i,

        keys,

        sigTypeName,
        sigType;

    //  Note that a *lot* of things in the system use wrap and unwrap, so the
    //  potential for endless recursions is high. Therefore, we need to use 'low
    //  level' primitives to do processing here.

    //  NB: We do *not* wrap POJOs (to become TP.core.Hashes) here since
    //  wrapping the 'big 8' doesn't do anything (and a POJO is, after all, a
    //  'new Object()'

    //  fail on null/undefined content...although it would have been fun to
    //  return a TP.lang.Null or TP.lang.Undefined wouldn't it ;)
    if (TP.notDefined(anObject)) {
        return undefined;
    }

    if (TP.isNull(anObject)) {
        return null;
    }

    //  The wrapped value of a Type is the Type (native or TIBET-made)
    if (TP.isType(anObject) || TP.isNamespace(anObject)) {
        return anObject;
    }

    //  90% case or better is that we're trying to wrap an element node from
    //  the UI
    if (TP.isElement(anObject)) {
        if (TP.isValid(anObject[TP.WRAPPER])) {
            //  Make sure the wrapper has this node as its native node.
            anObject[TP.WRAPPER].$set('node', anObject, false);
            return anObject[TP.WRAPPER];
        }
        return TP.dom.ElementNode.construct(anObject);
    } else if (TP.isDocument(anObject)) {
        return TP.dom.DocumentNode.construct(anObject);
    } else if (TP.isNode(anObject)) {
        return TP.dom.Node.construct(anObject);
    }

    //  wrapping a list of items is a really powerful option so we can
    //  manipulate the list using more intelligence
    if (TP.isArray(anObject) || TP.isNodeList(anObject)) {
        newObj = TP.ac();
        len = anObject.length;
        for (i = 0; i < len; i++) {
            newObj.push(TP.wrap(anObject[i]));
        }

        return newObj;
    }

    if (TP.isHash(anObject)) {
        keys = TP.keys(anObject);

        newObj = TP.hc();
        len = keys.length;
        for (i = 0; i < len; i++) {
            newObj.atPut(keys.at(i), TP.wrap(anObject.at(keys.at(i))));
        }

        return newObj;
    }

    if (TP.isNamedNodeMap(anObject)) {
        newObj = TP.hc();
        len = anObject.length;
        for (i = 0; i < len; i++) {
            newObj.atPut(anObject.item(i).name, TP.wrap(anObject.item(i)));
        }

        return newObj;
    }

    if (TP.isWindow(anObject)) {
        return TP.tpwin(anObject);
    }

    if (TP.isEvent(anObject)) {
        if (TP.notEmpty(sigTypeName =
                        TP.DOM_SIGNAL_TYPE_MAP.at(TP.eventGetType(anObject)))) {
            if (TP.isType(sigType = sigTypeName.asType())) {
                return sigType.construct(anObject);
            }
        }
    }

    return anObject;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('wrap', TP.objectWrap);

//  ------------------------------------------------------------------------

TP.definePrimitive('collapse',
function(anObject) {

    /**
     * @method collapse
     * @summary If the supplied object is a Collection, this function
     *     'collapses' it by returning the first item. Otherwise the object
     *     itself is returned.
     * @param {Object} anObject The object to collapse.
     * @returns {Object} The result of collapsing the object.
     */

    //  no valid source object means no work
    if (TP.notValid(anObject)) {
        return;
    }

    if (TP.isString(anObject) ||
        TP.isNumber(anObject) ||
        TP.isBoolean(anObject)) {
        return anObject;
    }

    if (TP.isNodeList(anObject) && anObject.length === 1) {
        return anObject[0];
    }

    if (TP.canInvoke(anObject, 'collapse')) {
        return anObject.collapse();
    }

    return anObject;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('expand',
function(anObject) {

    /**
     * @method expand
     * @summary If the supplied object is an Array, this function returns it.
     *     Otherwise it returns an Array wrapping the object.
     * @param {Object} anObject The object to expand.
     * @returns {Object[]} The result of expanding the object.
     */

    //  no valid source object means no work
    if (TP.notValid(anObject)) {
        return;
    }

    if (TP.isArray(anObject)) {
        return anObject;
    }

    if (TP.canInvoke(anObject, 'expand')) {
        return anObject.expand();
    }

    return TP.ac(anObject);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('pick',
function(anObject, varargs) {

    /**
     * @method pick
     * @summary Queries the object using the supplied query/conversion pairs.
     *     This method will traverse those pairs in succession until they are
     *     exhausted or a null or undefined value is encountered.
     * @description This method will 'drill down' through the supplied query
     *     parameters and, if separated by data types (or String conversions -
     *     basically anything that can be processed using 'as' or 'transform'),
     *     it will convert to that before proceeding.
     * @param {Object} anObject The object to begin querying.
     * @param {arguments} varargs The rest of query/conversion pairs to use.
     * @example Obtain a simple property value using a query string:
     *          <code>
     *          val = TP.hc('foo', TP.hc('bar', 'baz'));
     *          TP.pick(val, 'foo.bar');
     *          <samp>baz</samp>
     *          </code>
     * @example Obtain a property value using a query string that obtains a
     *          value, converts it to a Date and then obtains more data:
     *          <code>
     *          val = TP.hc('foo', TP.hc('bar', 1546825646654));
     *          TP.pick(val, 'foo.bar', Date, 'dayName');
     *          <samp>Sunday</samp>
     *          </code>
     * @example Obtain a property value using access path that obtains a value,
     *          converts it to a Date and then obtains more data:
     *          <code>
     *          val = TP.hc('foo', TP.hc('bar', 1546825646654));
     *          TP.pick(val, TP.tpc('foo.bar'), Date, 'dayName');
     *          <samp>Sunday</samp>
     *          </code>
     * @example Obtain an attribute value from a TP.dom.ElementNode:
     *          <code>
     *          val = TP.wrap(document.body);
     *          TP.pick(val, '@class');
     *          <samp>someClassName</samp>
     *          </code>
     * @example Obtain an attribute value from a TP.dom.ElementNode and convert
     *          it a Number:
     *          <code>
     *          val = TP.wrap(document.body);
     *          TP.pick(val, '@dataindex', Number);
     *          <samp>42</samp>
     *          </code>
     * @example Obtain an attribute value from the parent node of a
     *          TP.dom.ElementNode:
     *          <code>
     *          val = TP.wrap(document.body);
     *          TP.pick(val, 'parentNode.@class');
     *          <samp>someParentClassName</samp>
     *          </code>
     * @returns {Object|null} The result of traversing the object.
     */

    var result,

        args,

        notValidVal,

        leni,
        i,

        pickProperty,
        pickConversion,

        pickParts,
        lenj,
        j,

        pickPart,
        pickObj;

    if (TP.notValid(anObject)) {
        return null;
    }

    //  Grab the initial object to begin querying.
    result = anObject;

    //  Convert the arguments object to a real Array.
    args = TP.ac(arguments);

    //  We're not interested in the first argument - we have captured it in a
    //  formal parameter to this method.
    args = args.slice(1);

    notValidVal = false;

    //  Iterate over all of the arguments by 2.
    leni = args.getSize();
    for (i = 0; i < leni; i += 2) {

        //  Grab the property and an optional conversion.
        pickProperty = args.at(i);
        pickConversion = args.at(i + 1);

        //  If the property to pick is really an access path, then see if we can
        //  wrap the object and run a 'get' call with the access path.
        if (pickProperty.isAccessPath()) {

            //  If the result isn't a collection, then wrap it. Either way,
            //  obtain the source object of the query. This will give us the
            //  best representation to ask questions of the source.
            if (!TP.isCollection(result)) {
                pickObj = TP.wrap(result);
            } else {
                pickObj = result;
            }

            result = pickObj.get(pickProperty);
        } else {

            //  Otherwise, the pick property should be a dot-separated property
            //  path. Split it and iterate over each part, obtaining the value
            //  and using that value as the source for the next query.
            pickParts = pickProperty.split('.');

            lenj = pickParts.getSize();
            for (j = 0; j < lenj; j++) {

                pickPart = pickParts.at(j);

                //  If the result isn't a collection, then wrap it. Either way,
                //  obtain the source object of the query. This will give us the
                //  best representation to ask questions of the source.
                if (!TP.isCollection(result)) {
                    pickObj = TP.wrap(result);
                } else {
                    pickObj = result;
                }

                //  If the pick part starts with a '@', then the user is
                //  querying for an attribute. The pick source should also be a
                //  TP.dom.ElementNode (which it will be if the 'wrap' above
                //  succeeded).
                if (pickPart.startsWith('@') &&
                    TP.isKindOf(pickObj, TP.dom.ElementNode)) {
                    result = pickObj.getAttribute(pickPart.slice(1));
                } else {
                    //  Otherwise, just run 'get'.
                    result = pickObj.get(pickPart);
                }

                //  If we didn't obtain a valid result, then set a valid to
                //  break out of the overall loop and then break out of this
                //  inner loop.
                if (TP.notValid(result)) {
                    notValidVal = true;
                    break;
                }
            }
        }

        if (notValidVal === true) {
            break;
        } else if (TP.isValid(pickConversion)) {
            //  There is a valid pick conversion. Try 'as', then 'transform'
            //  then, if the conversion can be called as a Function, go ahead
            //  and do that. Note that *order is important* here. The
            //  'as'/'transform' methods provide the most intelligent
            //  conversions so we try them first.
            if (TP.canInvoke(result, 'as')) {
                result = result.as(pickConversion);
            } else if (TP.canInvoke(pickConversion, 'transform')) {
                result = pickConversion.transform(result);
            } else if (TP.isCallable(pickConversion)) {
                result = pickConversion(result);
            }
        }
    }

    return result;
});

//  ------------------------------------------------------------------------
//  Paths
//  ------------------------------------------------------------------------

TP.definePrimitive('getAccessPathParts',
function(aPath, aScheme) {

    /**
     * @method getAccessPathParts
     * @summary Returns the parts of the supplied path.
     * @param {String} aPath The path to obtain the parts from.
     * @param {String} [aScheme] An optional scheme that indicates the type of
     *     the supplied path. If this is not supplied, the system attempts to
     *     compute the scheme.
     * @returns {String[]} An Array of path parts.
     */

    var scheme,

        predicateExprs,
        path,

        results;

    //  Need at least a path to test.
    if (TP.isEmpty(aPath)) {
        return TP.raise(this, 'TP.sig.InvalidPath',
                        'Unable to get parts of empty path.');
    }

    //  If a schema wasn't supplied, try to compute one.
    scheme = aScheme;
    if (TP.notValid(scheme)) {
        scheme = TP.getPointerScheme(aPath);
    }

    switch (scheme) {

        case 'css':

            //  Split along separators, etc.
            results = aPath.split(TP.regex.CSS_PATH_SPLITTER);

            //  Strip out anything that would be empty or separator characters.
            results = results.filter(
                        function(item, index) {
                            return !TP.regex.CSS_PATH_STRIPPER.test(item);
                        });

            break;

        case 'tibet':
        case 'jpath':

            //  If the path is just '.' or '$_', then that's the shortcut to
            //  just return the target node itself.
            if (TP.regex.ONLY_PERIOD.test(aPath) ||
                TP.regex.ONLY_STDIN.test(aPath)) {
                return TP.ac('.');
            }

            //  Capture all predicate expressions to avoid processing
            //  separators, etc. within predicates.
            predicateExprs = TP.ac();
            path = TP.stringTokenizeUsingDelimiters(
                        aPath,
                        '[',
                        ']',
                        predicateExprs,
                        '__PRED__',
                        '__PRED__');

            //  Split along separators, etc.
            results = path.split(TP.regex.JSON_PATH_SPLITTER);

            //  Iterate over the results, encoding certain values in certain
            //  ways, and putting the captured predicates back into what is now
            //  individual parts of the path.
            results = results.map(
                    function(item) {

                        if (item === '') {
                            return '';
                        }

                        if (item === '..') {
                            return '__DOUBLE_PERIOD__';
                        }

                        if (item.indexOf('__PRED__') !== TP.NOT_FOUND) {

                            return TP.stringUntokenizeUsingDelimiters(
                                    item,
                                    '[',
                                    ']',
                                    predicateExprs,
                                    '__PRED__',
                                    '__PRED__');
                        }

                        return item;
                    });

            //  Strip out anything that would be empty or separator characters.
            results = results.filter(
                        function(item, index) {
                            return !TP.regex.JSON_PATH_STRIPPER.test(item);
                        });

            //  If there were any 'double period' constructs, convert them to an
            //  empty String
            results = results.map(
                    function(item) {

                        if (item === '__DOUBLE_PERIOD__') {
                            return '';
                        }

                        return item;
                    });

            break;

        case 'xpath1':
        case 'xpointer':

            if (aPath === '/') {
                return TP.ac('/');
            }

            //  Capture all predicate expressions to avoid processing
            //  separators, etc. within predicates.
            predicateExprs = TP.ac();
            path = TP.stringTokenizeUsingDelimiters(
                        aPath,
                        '[',
                        ']',
                        predicateExprs,
                        '__PRED__',
                        '__PRED__');

            //  Split along separators, etc.
            results = path.split(TP.regex.XPATH_PATH_SPLITTER);

            //  Iterate over the results, encoding certain values in certain
            //  ways, and putting the captured predicates back into what is now
            //  individual parts of the path.
            results = results.map(
                    function(item) {

                        if (item === '') {
                            return '';
                        }

                        if (item === '//') {
                            return '__DOUBLE_SLASH__';
                        }

                        if (item.indexOf('__PRED__') !== TP.NOT_FOUND) {

                            return TP.stringUntokenizeUsingDelimiters(
                                    item,
                                    '[',
                                    ']',
                                    predicateExprs,
                                    '__PRED__',
                                    '__PRED__');
                        }

                        return item;
                    });

            //  Strip out anything that would be empty or separator characters.
            results = results.filter(
                        function(item, index) {
                            return !TP.regex.XPATH_PATH_STRIPPER.test(item);
                        });

            //  If there were any 'double slash' constructs, convert them to an
            //  empty String
            results = results.map(
                    function(item) {

                        if (item === '__DOUBLE_SLASH__') {
                            return '';
                        }

                        return item;
                    });

            break;

        default:
            break;
    }

    return results;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('getAccessPathType',
function(aPath) {

    /**
     * @method getAccessPathType
     * @summary Obtains the 'path type' of the supplied path. This allows TIBET
     *     to distinguish between different markup query languages.
     * @param {String} aPath The path to obtain the type of.
     * @returns {String} One of the 'path type' constants:
     *     TP.TIBET_PATH_TYPE
     *     TP.JSON_PATH_TYPE
     *     TP.CSS_PATH_TYPE
     *     TP.XPATH_PATH_TYPE
     *     TP.BARENAME_PATH_TYPE
     *     TP.XPOINTER_PATH_TYPE
     *     TP.ELEMENT_PATH_TYPE
     *     TP.XTENSION_POINTER_PATH_TYPE
     */

    var path;

    //  Need at least a path to test.
    if (TP.isEmpty(path = aPath)) {
        return TP.raise(this, 'TP.sig.InvalidPath',
                        'Unable to get type of empty path.');
    }

    //  Note that we only allow numeric ACP expressions in paths
    if (TP.regex.HAS_ACP.test(path)) {

        //  Strip out any numeric expressions and recheck
        TP.regex.ACP_NUMERIC.lastIndex = 0;
        path = path.replace(TP.regex.ACP_NUMERIC, TP.DEFAULT);

        //  If it still has ACP expressions, then it's an invalid path
        if (TP.regex.HAS_ACP.test(path)) {
            return this.raise('TP.sig.InvalidPath');
        }

        //  Now, so as to not change the overall meaning of the path, go back to
        //  the original path and substitute '0's - remember that we're only
        //  doing path type detection here, so we're not changing the meaning of
        //  the path.
        TP.regex.ACP_NUMERIC.lastIndex = 0;
        path = aPath.replace(TP.regex.ACP_NUMERIC, '0');
    }

    //  We try to determine the path type based on discriminating characters
    //  and regular expression forms but since there's a lot of overlap
    //  between the legal characters for both CSS and XPath paths we will
    //  default to CSS path when no clear distinction can be made.

    //  An xpointer barename would indicate an XPath (barenames cannot contain
    //  parentheses), but we cannot evaluate that directly (by itself, '#foo'
    //  isn't a real XPath), so we return TP.BARENAME_PATH_TYPE
    if (TP.regex.BARENAME.test(path)) {
        return TP.BARENAME_PATH_TYPE;
    }

    //  tibet xpointer using the explicit tibet() scheme (TIBET-only)
    if (TP.regex.TIBET_POINTER.test(path)) {
        return TP.TIBET_PATH_TYPE;
    }

    //  regular xpointer, either xpointer(), xpath1() or element() scheme
    if (TP.regex.XPOINTER.test(path)) {

        //  If we're handed an '#element(...)' pointer, then we know what kind
        //  of path it is (or should be, anyway)

        //  NB: We do *not* check against TP.regex.ELEMENT_PATH here, since it
        //  matches all IDs ("#"), attributes ("@"), etc.
        if (TP.regex.ELEMENT_POINTER.test(path)) {
            return TP.ELEMENT_PATH_TYPE;
        } else {
            return TP.XPATH_PATH_TYPE;
        }
    }

    //  extended xpointer, perhaps explicit css() scheme (TIBET-only)
    if (TP.regex.XTENSION_POINTER.test(path)) {
        return TP.XTENSION_POINTER_PATH_TYPE;
    }

    //  strip any id/fragment prefix
    path = path.charAt(0) === '#' ? path.slice(1) : path;

    //  If the path is just '.' or '$_', then that's the shortcut to just return
    //  a TIBET path
    if (TP.regex.ONLY_PERIOD.test(aPath) || TP.regex.ONLY_STDIN.test(aPath)) {
        return TP.TIBET_PATH_TYPE;
    }

    //  XPath is typically ./elem, //elem, @attr, or ./elem[predicate], all
    //  of which are going to include a slash (other than 'standalone' attr
    //  expressions which start with a '@'). These can be completely
    //  disambiguated with CSS.
    //  So check for:
    //      An attribute path (one that starts with '@')
    //  OR
    //      Some form of XPath that starts with a '/', a '.', a name
    //      followed by a '(' or one of the full XPath 'axis' names followed
    //      by a '::'
    //  OR
    //      Some form of XPath that has a '/'
    if (TP.regex.ATTRIBUTE.test(path) ||
        TP.regex.XPATH_PATH.test(path) ||
        TP.regex.HAS_SLASH.test(path)) {
        return TP.XPATH_PATH_TYPE;
    }

    //  A JSON path
    if (TP.regex.JSON_PATH.test(path)) {
        return TP.JSON_PATH_TYPE;
    }

    //  A TIBET path - simple or complex
    if (TP.regex.TIBET_PATH.test(path)) {
        return TP.TIBET_PATH_TYPE;
    }

    //  If there is no 'path punctuation' (only JS identifer characters), or
    //  it's a simple numeric path like '2' or '[2]', that means it's a 'simple
    //  path'.
    //  TODO: This is hacky - figure out how to combine them into one RegExp.
    if (TP.regex.JS_IDENTIFIER.test(path) ||
        TP.regex.ONLY_NUM.test(path) ||
        TP.regex.SIMPLE_NUMERIC_PATH.test(path)) {
        return TP.TIBET_PATH_TYPE;
    }

    //  So far its not either an XPath or a TIBET Xtension path. So there
    //  are various overlaps between CSS and XPath that we now have to take
    //  into account:
    //
    //      CSS         XPath
    //      ---         -----
    //
    //      span        span
    //      #myElem     #myElem
    //      *           *
    //
    //  Thankfully, these constructs have the exact same meaning in both
    //  selection languages. Therefore, we return a CSS path type since that
    //  call is faster.

    //  Additionally, we're now out of things to check, so we just punt to
    //  this type.
    return TP.CSS_PATH_TYPE;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('getPointerScheme',
function(aPath) {

    /**
     * @method getPointerScheme
     * @summary Returns the 'pointer scheme' given a path.
     * @description Depending on the type of path supplied, this method will
     *     return the proper 'scheme' to be used in an XPointer. These are the
     *     current return values:
     *
     *     TP.TIBET_PATH_TYPE               ->      'tibet'
     *     TP.JSON_PATH_TYPE                ->      'jpath'
     *     TP.CSS_PATH_TYPE                 ->      'css'
     *     TP.XPATH_PATH_TYPE               ->      'xpath1'
     *     TP.BARENAME_PATH_TYPE            ->      ''
     *     TP.XPOINTER_PATH_TYPE            ->      'xpointer'
     *     TP.ELEMENT_PATH_TYPE             ->      'element'
     *     TP.XTENSION_POINTER_PATH_TYPE    ->      'css'
     *
     *     Note that if the path consists only of word characters that a value
     *     of 'tibet' will be returned.
     * @param {String} aPath The path to return the scheme of.
     * @returns {String} An XPointer scheme depending on path type.
     */

    var pathType;

    //  Need at least a path to test.
    if (TP.isEmpty(aPath)) {
        return TP.raise(this, 'TP.sig.InvalidPath',
                        'Unable to get type of empty path.');
    }

    //  The default, if the path only contains word characters, is 'tibet'.
    if (TP.regex.ONLY_WORD.test(aPath)) {
        return 'tibet';
    }

    //  If the path only contains a dollar character, is 'jpath'.
    if (TP.regex.ONLY_DOLLAR.test(aPath)) {
        return 'jpath';
    }

    pathType = TP.getAccessPathType(aPath);

    switch (pathType) {
        case TP.TIBET_PATH_TYPE:
            return 'tibet';
        case TP.JSON_PATH_TYPE:
            return 'jpath';
        case TP.CSS_PATH_TYPE:
            return 'css';
        case TP.XPATH_PATH_TYPE:
            return 'xpath1';
        case TP.BARENAME_PATH_TYPE:
            return '';
        case TP.XPOINTER_PATH_TYPE:
            return 'xpointer';
        case TP.ELEMENT_PATH_TYPE:
            return 'element';
        case TP.XTENSION_POINTER_PATH_TYPE:
            return 'css';
        default:
            return '';
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('joinAccessPathParts',
function(pathParts, aPathType) {

    /**
     * @method joinAccessPathParts
     * @summary Returns the 'pointer scheme' given a path.
     * @description Depending on the type of path supplied, this method will use
     *     the proper 'joining character' to join together the supplied path
     *     parts. These are the various joining character values:
     *
     *     TP.TIBET_PATH_TYPE               ->      '.'
     *     TP.JSON_PATH_TYPE                ->      '.'
     *     TP.CSS_PATH_TYPE                 ->      ' '
     *     TP.XPATH_PATH_TYPE               ->      '/'
     *     TP.XPOINTER_PATH_TYPE            ->      '/'
     *
     * @param {String[]} pathParts The path parts to join together.
     * @param {String} aPathType The type of path to join the parts together as.
     * @returns {String} The path obtained by joining the path parts together
     *     using the computed join character.
     */

    var result,

        len,
        i,
        part,

        joinChar;

    //  Need at least one path part.
    if (TP.isEmpty(pathParts)) {
        return TP.raise(this, 'TP.sig.InvalidPath',
                        'Unable to join empty path parts.');
    }

    if (TP.notValid(aPathType)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  Initially, the result is the first part.
    result = pathParts.at(0);

    //  Loop over the remaining parts and append them, using a computed joining
    //  character.
    len = pathParts.getSize();
    for (i = 1; i < len; i++) {
        part = pathParts.at(i);

        switch (aPathType) {
            case TP.CSS_PATH_TYPE:
                joinChar = ' ';
                break;

            case TP.TIBET_PATH_TYPE:
            case TP.JSON_PATH_TYPE:
                if (part.charAt(0) === '[') {
                    joinChar = '';
                } else {
                    joinChar = '.';
                }

                break;

            case TP.XPATH_PATH_TYPE:
            case TP.XPOINTER_PATH_TYPE:
                if (part.charAt(0) === '[') {
                    joinChar = '';
                } else {
                    joinChar = '/';
                }

                break;

            default:
                joinChar = '';
        }

        //  Do the concatentation.
        result += joinChar + part;
    }

    return result;
});

//  ------------------------------------------------------------------------
//  Signaling
//  ------------------------------------------------------------------------

TP.definePrimitive('contractSignalName',
function(signame) {

    /**
     * @method contractSignalName
     * @summary Produces the 'short form' of the supplied signal name.
     * @description Given a signal name of 'TP.sig.fooSignal', this method will
     *     produce 'fooSignal'.
     * @param {String} signame The signal name.
     * @returns {String} The shortened signal name.
     */

    var parts,
        i,
        newparts;

    if (TP.isEmpty(signame)) {
        return '';
    }

    //  Event sequences (i.e. typically keyboard sequences) will have a
    //  double underscore between each part of the sequence. We need to make
    //  sure to contract each part.
    if (/__/.test(signame)) {
        newparts = TP.ac();
        parts = signame.split('__');

        for (i = 0; i < parts.getSize(); i++) {
            //  Note the recursive call here.
            newparts.push(TP.contractSignalName(parts.at(i)));
        }

        return newparts.join('__');
    }

    //  Note how we only do this if signame starts with 'TP.' - otherwise, we
    //  leave the signal name.
    if (/^TP\.(.+)/.test(signame)) {
        return signame.slice(signame.lastIndexOf('.') + 1);
    }

    return signame;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('expandSignalName',
function(signame) {

    /**
     * @method expandSignalName
     * @summary Produces the 'long form' of the supplied signal name.
     * @description Given a signal name of 'fooSignal', this method will produce
     *     'TP.sig.fooSignal'. If the signal name already has a period ('.'),
     *     this method will just prepend 'TP.'.
     * @param {String} signame The signal name.
     * @returns {String} The lengthened signal name.
     */

    var result,

        parts,
        i,
        newparts,

        type,

        namespaceNames;

    //  NB: This is a very heavily used routine, so we use very primitive
    //  checking in it.

    if (signame === '') {
        return '';
    }

    //  See if the signal name cache contains a 'fully expanded' entry for the
    //  supplied signal name. If so, return it.
    result = TP.$signal_name_cache.at(signame);
    if (TP.notEmpty(result)) {
        return result;
    }

    //  Event sequences (i.e. typically keyboard sequences) will have a
    //  double underscore between each part of the sequence. We need to make
    //  sure to expand each part.
    if (/__/.test(signame)) {
        newparts = TP.ac();
        parts = signame.split('__');

        for (i = 0; i < parts.getSize(); i++) {
            //  Note the recursive call here.
            newparts.push(TP.expandSignalName(parts.at(i)));
        }

        result = newparts.join('__');
        TP.$signal_name_cache.atPut(signame, result);

        return result;
    }

    if (/^(TP|APP)\.(.+)/.test(signame)) {
        TP.$signal_name_cache.atPut(signame, signame);
        return signame;
    }

    //  See if the system has a type corresponding directly to signame.
    if (TP.isType(type = TP.sys.getTypeByName(signame))) {
        if (TP.canInvoke(type, 'getSignalName')) {
            result = type.getSignalName();
            TP.$signal_name_cache.atPut(signame, result);

            return result;
        }
    }

    //  Iterate over all of the namespaces in the system and try to see if any
    //  of the namespaces have a type corresponding to signame.
    namespaceNames = TP.sys.getNamespaceNames();
    for (i = 0; i < namespaceNames.getSize(); i++) {
        if (TP.isType(type = TP.sys.getTypeByName(
                        namespaceNames.at(i) + '.' + signame))) {
            if (TP.canInvoke(type, 'getSignalName')) {
                result = type.getSignalName();
                TP.$signal_name_cache.atPut(signame, result);

                return result;
            }
        }
    }

    //  We have at least one namespace - just prefix it with 'TP.' and exit
    if (/^(.+)\.(.+)/.test(signame)) {
        result = 'TP.' + signame;
        TP.$signal_name_cache.atPut(signame, result);

        return result;
    }

    //  Couldn't find anything - just put 'TP.sig.' on the front of it.
    result = 'TP.sig.' + signame;
    TP.$signal_name_cache.atPut(signame, result);

    return result;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('queueSignalFromData',
function(signalData, originElem, triggerSignal, aPayload, aPolicy, signalType) {

    /**
     * @method queueSignalFromData
     * @summary Queues a signal derived from the signal data and the other
     *     associated parameters for firing. Parameters for this call after the
     *     initial signalData value mirror those in the 'queue' call  Each of
     *     the parameters other than signal data act primarily as default values
     *     which are used if the corresponding value is not provided in the
     *     signalData itself.
     * @param {String} signalData The signal data which should either just a
     *     signal name or a origin, signal, payload encoded as a JS-like String
     *     that can be reformatted into JSON.
     * @param {Element} originElem The originating element that will be used as
     *     a target if an alternate target isn't provided as an ID to another
     *     element in the signal data.
     * @param {TP.sig.Signal} [triggerSignal] The signal that triggered this
     *     signal queueing to happen. This will be placed in the firing signal's
     *     payload under the 'trigger' key.
     * @param {Object} [aPayload] Optional argument object. Note that this is
     *     only used if not specified in the signalData.
     * @param {Function} [aPolicy] A "firing" policy that will define how the
     *     signal is fired. Note that this is only used if not specific in the
     *     signalData. If neither is supplied, this defaults to the policy of
     *     the signal instance/type.
     * @param {TP.meta.sig.Signal} A signal type that will be used as the 'real'
     *     signal type if the signal name supplied (in some form) in the signal
     *     data is a spoofed signal name.
     */

    var doc,
        sigData,
        sigParams,
        targets,
        orgids,
        orgid,
        len,
        i,
        target,
        sigName,
        sigPayload,
        policy,
        payload,
        delay;

    doc = TP.nodeGetDocument(originElem);

    //  Create an Array for the set of targets.
    targets = TP.ac();

    //  If signal data is a string it can be either a signal name or a
    //  descriptor in pseudo-JSON form. Try to get it into hash form either way.
    if (TP.isString(signalData)) {
        sigData = TP.trim(signalData);

        //  If the signal data starts with a '{', then its not just a signal
        //  name. There's a 'signal descriptor'.
        if (sigData.startsWith('{')) {
            //  What's left is a JS-formatted String. Parse that into a Hash.
            sigParams = TP.json2js(TP.reformatJSToJSON(sigData));
        } else {
            sigParams = TP.hc('signal', sigData);
        }
    } else {
        sigParams = signalData;
    }

    if (!TP.canInvoke(sigParams, 'at')) {
        TP.ifError() ?
            TP.error('Invalid signal data for queueing operation.') : 0;
        return;
    }

    //  ---
    //  origin
    //  ---

    //  If an 'origin' slot was supplied, then we look that up by ID (using
    //  the original origin's document).
    if (TP.notEmpty(orgids = sigParams.at('origin'))) {

        if (!TP.isArray(orgids)) {
            orgids = TP.ac(orgids);
        }

        len = orgids.getSize();
        for (i = 0; i < len; i++) {
            //  Just in case it was supplied as a quoted value
            orgid = orgids.at(i).unquoted();

            //  Note how we pass false to avoid getting a wrapped origin, which
            //  we don't want here.
            targets.push(TP.byId(orgid, doc, false));
        }
    }

    //  ---
    //  signal
    //  ---

    sigName = sigParams.at('signal');

    //  If a signal was supplied, use it as the signal name instead of the
    //  name of the original DOM signal that was fired.
    if (TP.isEmpty(sigName) && TP.isValid(triggerSignal)) {
        sigName = triggerSignal.getSignalName();
    }

    //  If there is no signal name, warn and exit.
    if (TP.isEmpty(sigName)) {
        TP.ifError() ?
            TP.error('No signal name in signal queueing data.') : 0;
        return;
    }

    //  Just in case it was supplied in the signal params as a quoted value
    sigName = sigName.unquoted();

    //  ---
    //  payload
    //  ---

    //  Payload is whatever we found in signal data followed by anything
    //  provided explicitly followed by an empty hash we can add to.
    sigPayload = TP.ifInvalid(sigParams.at('payload'), aPayload);
    if (TP.notValid(sigPayload)) {
        sigPayload = TP.hc();
    }

    //  Stash a reference to the original DOM signal in the payload under the
    //  key 'trigger'. This will be useful for things like stopping propagation,
    //  etc.
    sigPayload.atPut('trigger', triggerSignal);

    //  Some objects in the system, in lieu of the trigger, will still use the
    //  TP.dom.Document where the triggering originated. We try to provide that
    //  here, which is especially important if the trigger is undefined.
    sigPayload.atPut('triggerTPDocument', TP.tpdoc(doc));

    //  If a delay was defined and it can be converted into a Number, then set
    //  up a timeout to queue the signal after that delay. Otherwise, queue the
    //  signal immediately.
    delay = sigPayload.at('delay');
    if (TP.notEmpty(delay)) {
        delay = delay.asNumber();
    }

    policy = TP.ifInvalid(sigParams.at('policy'), aPolicy);

    if (TP.notEmpty(targets)) {

        len = targets.getSize();
        for (i = 0; i < len; i++) {

            payload = TP.copy(sigPayload);

            target = targets.at(i);

            //  Note that it's important to put the current target on the signal
            //  here in case that the new signal is a RESPONDER_FIRING signal
            //  (very likely) as it will look there for the first responder when
            //  computing the responder chain.
            target = TP.ifInvalid(target, originElem);
            payload.atPut('target', target);

            //  Queue the new signal and continue - thereby skipping processing
            //  for the bubbling phase of this signal (for this target) in
            //  deference to signaling the new signal. Note here how we supply a
            //  signal type as the default type to use if the mapped signal type
            //  isn't a real type.

            if (TP.notEmpty(delay) && TP.isNumber(delay)) {
                /* eslint-disable no-loop-func */
                setTimeout(
                    function() {
                        TP.queue(target, sigName, payload, policy, signalType);
                    }, delay);
                /* eslint-enable no-loop-func */
            } else {
                TP.queue(target, sigName, payload, policy, signalType);
            }
        }
    } else {

        payload = TP.copy(sigPayload);

        payload.atPut('target', originElem);

        if (TP.notEmpty(delay) && TP.isNumber(delay)) {
            setTimeout(
                function() {
                    TP.queue(originElem, sigName, payload, policy, signalType);
                }, delay);
        } else {
            TP.queue(originElem, sigName, payload, policy, signalType);
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.$$computedHandlers = new TP.boot.PHash();
TP.$$computedHandlers.$lookups = 0;

//  ------------------------------------------------------------------------

TP.definePrimitive('composeHandlerName',
function(aDescriptor) {

    /**
     * @method composeHandlerName
     * @summary Composes a standard handler name defined by the signal handler
     *     descriptor provided. This method defaults the signal name used for
     *     the descriptor so the parameter is optional.
     * @param {Object} [aDescriptor] The 'descriptor' parameter is a property
     *     descriptor. Properties can be any combination of the following:
     *          {String|Type} signal The type or signal name.
     *          {String|Object} origin The origin.
     *          {String} state The state name.
     *          {String} phase (TP.CAPTURING, TP.AT_TARGET, TP.BUBBLING). The
     *              default is TP.BUBBLING.
     * @returns {String} The handler name defined by the descriptor.
     */

    var descriptor,
        signal,

        signame,

        handler,

        origin,
        state;

    if (TP.isString(aDescriptor)) {
        signal = aDescriptor;
    } else if (TP.isNumber(aDescriptor)) {
        //  Handle 404 for example :)
        signal = '' + aDescriptor;
    } else if (!TP.isPlainObject(aDescriptor)) {
        return this.raise('InvalidDescriptor', aDescriptor);
    } else {
        descriptor = aDescriptor;
        signal = aDescriptor.signal;
    }

    if (!descriptor) {
        handler = TP.$$computedHandlers.at(signal);
        if (handler) {
            TP.$$computedHandlers.$lookups += 1;
            return handler;
        }
    }

    //  Signal types, signal instances, and Strings all respond to this.
    if (signal === TP.ANY) {
        //  Default is 'handleSignal', not handleANY.
        signame = 'Signal';
    } else if (TP.canInvoke(signal, 'getSignalName')) {
        signame = signal.getSignalName();
    } else {
        //  Default is 'handleSignal', not handleANY.
        signame = 'Signal';
    }

    //  Simplify for internal signals. 'APP.sig.' prefixing (or signal types
    //  from another namespace) has to remain in place and this method ensures
    //  that.
    signame = TP.contractSignalName(signame);

    //  Regardless of how it got here, don't let signame carry anything that
    //  isn't a valid JS identifier character as part of the handler name.
    if (TP.isNumber(aDescriptor) || TP.notNaN(parseInt(aDescriptor, 10))) {
        handler = 'handle' + signame;
    } else {
        handler = 'handle' + signame.asJSIdentifier();
    }

    //  Add optional phase-specific phrase
    if (descriptor && TP.isValid(descriptor.phase)) {
        switch (descriptor.phase) {
            case TP.CAPTURING:
                handler += TP.CAPTURING;
                break;
            case TP.AT_TARGET:
                handler += TP.AT_TARGET;
                break;
            case TP.BUBBLING:
                break;
            default:
                TP.ifWarn() ?
                    TP.warn('InvalidSignalPhase', descriptor.phase) : 0;
                break;
        }
    }

    //  Add optional From clause for origin filtering.
    if (descriptor && TP.isValid(origin = descriptor.origin)) {
        handler += 'From' + TP.gid(origin);
    } else {
        handler += 'From' + TP.ANY;
    }

    //  Add optional When clause for state filtering.
    if (descriptor && TP.notEmpty(state = descriptor.state)) {
        handler += 'When' + TP.str(state).asTitleCase();
    } else {
        handler += 'When' + TP.ANY;
    }

    //  Simple handlers (very common) are cached.
    if (!descriptor) {
        TP.$$computedHandlers.atPut(signal, handler);
    }

    return handler;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('decomposeHandlerName',
function(aHandlerName) {

    /**
     * @method decomposeHandlerName
     * @summary Deomposes a standard handler name into a descriptor that can be
     *     used to generate the handler name.
     * @param {String} aHandlerName The handler name to decompose.
     * @returns {Object} A property 'descriptor'.
     *     Properties can be any combination of the following:
     *          {String} signal The type or signal name.
     *          {String} origin The origin.
     *          {String} state The state name.
     *          {String} phase (TP.CAPTURING, TP.AT_TARGET, TP.BUBBLING). The
     *              default is TP.BUBBLING.
     */

    var expression,
        regex,

        result,
        parts;

    expression = 'handle';

    //  ---
    //  Signal
    //  ---

    expression += '(\\w+?)';

    //  ---
    //  Phase
    //  ---

    expression += '(' +
                    TP.CAPTURING +
                    '|' +
                    TP.AT_TARGET +
                    '|(?:\\b\\B)*?)'; //  Matches no characters - non-capturing

    //  ---
    //  Origin
    //  ---

    expression += '(?:From(.+?))*?';

    //  ---
    //  State
    //  ---

    expression += '(?:When(.+))*?$';


    //  Construct a RegExp and make sure that it is indeed one.
    regex = RegExp.construct(expression);
    if (!TP.isRegExp(regex)) {
        //  TODO:   expression problems...
        return;
    }

    result = {};

    parts = regex.exec(aHandlerName);

    //  Nothing matched - return empty descriptor
    if (TP.isEmpty(parts)) {
        return result;
    }

    //  The 0th place contains the 'whole match' - ignore it.

    //  'signal' is at the 1st place.
    if (TP.notEmpty(parts.at(1))) {
        result.signal = parts.at(1);
    }

    //  'phase' is at the 2nd place.
    if (TP.notEmpty(parts.at(2))) {
        result.phase = parts.at(2);
    }

    //  'origin' is at the 3rd place.
    result.origin = parts.at(3) || TP.ANY;

    //  'state' is at the 4th place.
    result.state = parts.at(4) || TP.ANY;

    return result;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventAsHTMLString',
function(eventObj) {

    /**
     * @method eventAsHTMLString
     * @summary Returns an HTML String representation of the supplied event
     *     object.
     * @param {Event} eventObj The event object to produce the HTML String
     *     representation of.
     * @returns {String} An HTML String representation of the supplied event
     *     object.
     */

    var arr,
        keys,
        len,
        i;

    arr = TP.ac();

    keys = TP.keys(eventObj);
    len = keys.length;

    arr.push('<span',
                ' class="Event ', TP.escapeTypeName(TP.tname(eventObj)), '">');

    for (i = 0; i < len; i++) {
        try {
            arr.push('<span data-name="', keys[i], '">',
                        TP.htmlstr(eventObj[keys[i]]), '</span>');
        } catch (e) {
            arr.push('<span data-name="', keys[i], '">',
                        TP.htmlstr(undefined), '</span>');
        }
    }

    arr.push('</span>');

    return arr.join('').toString();
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventAsJSONSource',
function(eventObj) {

    /**
     * @method eventAsJSONSource
     * @summary Returns a JSON String representation of the supplied event
     *     object.
     * @param {Event} eventObj The event object to produce the JSON String
     *     representation of.
     * @returns {String} An JSON String representation of the supplied event
     *     object.
     */

    var arr,
        keys,
        len,
        i;

    arr = TP.ac();

    keys = TP.keys(eventObj);
    len = keys.length;

    arr.push('{"type":"', TP.tname(eventObj), '","data":{');

    for (i = 0; i < len; i++) {
        try {
            arr.push(keys[i].quoted('"'), ':', TP.jsonsrc(eventObj[keys[i]]));
        } catch (e) {
            arr.push(keys[i].quoted('"'), ':"undefined"');
        } finally {
            arr.push(',');
        }
    }

    //  Pop off the trailing comma
    arr.pop();

    arr.push('}}');

    return arr.join('').toString();
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventAsPrettyString',
function(eventObj) {

    /**
     * @method eventAsPrettyString
     * @summary Returns a 'pretty print' representation of the supplied event
     *     object.
     * @param {Event} eventObj The event object to produce the pretty print
     *     representation of.
     * @returns {String} A pretty print representation of the supplied event
     *     object.
     */

    var arr,
        keys,
        len,
        i;

    arr = TP.ac();

    keys = TP.keys(eventObj);
    len = keys.length;

    arr.push('<dl class="pretty ', TP.escapeTypeName(TP.tname(eventObj)), '">',
                '<dt>Type name</dt>',
                '<dd class="pretty typename">', TP.tname(eventObj), '</dd>');

    for (i = 0; i < len; i++) {
        try {
            arr.push('<dt class="pretty key">', keys[i], '</dt>',
                        '<dd>', TP.pretty(eventObj[keys[i]]), '</dd>');
        } catch (e) {
            arr.push('<dt class="pretty key">', keys[i], '</dt>',
                        '<dd>', TP.pretty(undefined), '</dd>');
        }
    }

    arr.push('</dl>');

    return arr.join('').toString();
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventAsSource',
function(eventObj) {

    /**
     * @method eventAsSource
     * @summary Returns a TIBET source string representation of the supplied
     *     event object.
     * @param {Event} eventObj The event object to produce the TIBET source
     *     representation of.
     * @returns {String} A TIBET source string representation of the supplied
     *     event object.
     */

    var arr,

        target,

        keys,
        len,
        i;

    arr = TP.ac();

    if (TP.isNode(target = TP.eventGetTarget(eventObj))) {
        arr.push('TP.documentConstructEvent(',
                    TP.gid(TP.nodeGetWindow(target)),
                    '.document,');
    } else {
        //  NOTE the use of 'window.document' here to try to capture the current
        //  window context rather than 'top.document' in case we didn't load
        //  into the top window.
        arr.push('TP.documentConstructEvent(window.document, ');
    }

    keys = TP.keys(eventObj);
    len = keys.length;

    arr.push('TP.hc(');

    for (i = 0; i < len; i++) {
        try {
            arr.push(keys[i], ', ', TP.src(eventObj[keys[i]]), ', ');
        } catch (e) {
            arr.push(keys[i], ', ', 'undefined', ', ');
        }
    }

    //  Pop off the last comma
    arr.pop();

    arr.push(')');

    return arr.join('').toString();
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventAsString',
function(eventObj) {

    /**
     * @method eventAsString
     * @summary Returns a String representation of the supplied event
     *     object.
     * @param {Event} eventObj The event object to produce the String
     *     representation of.
     * @returns {String} A String representation of the supplied event
     *     object.
     */

    var arr,
        keys,
        len,
        i;

    arr = TP.ac();

    keys = TP.keys(eventObj);
    len = keys.length;

    arr.push(TP.eventGetType(eventObj), ' : ', '(');

    for (i = 0; i < len; i++) {
        try {
            arr.push(keys[i], ' => ', TP.str(eventObj[keys[i]]), ', ');
        } catch (e) {
            arr.push(keys[i], ' => undefined', ', ');
        }
    }

    //  Pop off the last comma
    arr.pop();

    arr.push(')');

    return arr.join('').toString();
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventAsXMLString',
function(eventObj) {

    /**
     * @method eventAsXMLString
     * @summary Returns an XML String representation of the supplied event
     *     object.
     * @param {Event} eventObj The event object to produce the XML String
     *     representation of.
     * @returns {String} An XML String representation of the supplied event
     *     object.
     */

    var arr,
        keys,
        len,
        i;

    arr = TP.ac();

    keys = TP.keys(eventObj);
    len = keys.length;

    arr.push('<event', ' typename="', TP.tname(eventObj), '"');

    for (i = 0; i < len; i++) {
        try {
            arr.push(' ', keys[i], '="', TP.xmlstr(eventObj[keys[i]]), '"');
        } catch (e) {
            arr.push(' ', keys[i], '="undefined"');
        }
    }

    arr.push('/>');

    return arr.join('').toString();
});

//  ------------------------------------------------------------------------
//  MUTATION OBSERVER REGISTRY
//  ------------------------------------------------------------------------

TP.definePrimitive('addMutationObserver',
function(recordsHandler, observerConfig, observerID) {

    /**
     * @method addMutationObserver
     * @summary Adds a Mutation Observer entry to the Mutation Observer
     *     registry.
     * @description Note that you must call 'TP.activateMutationObserver()' in
     *     order to actually activate the Mutation Observer. This method merely
     *     creates a registry entry.
     * @param {Function} recordsHandler A function that will take in an Array of
     *     MutationRecord objects and process them.
     * @param {Object} observerConfig A plain JS object that will be passed
     *     along as options to the native Mutation Observer creation machinery.
     * @param {String} observerID The ID of the observer to register.
     */

    var registry,
        registryRecord,

        filterFunctions;

    registry = TP.$$mutationObserverRegistry;

    //  Create the managed Mutation Observer registry if it doesn't already
    //  exist.
    if (TP.notValid(registry)) {
        registry = TP.hc('$ALL_FILTER_FUNCS', TP.ac());
        TP.$$mutationObserverRegistry = registry;
    }

    registryRecord = registry.at(observerID);

    //  Grab a copy of the filter functions registered as meant for 'ALL'.
    filterFunctions = TP.copy(registry.at('$ALL_FILTER_FUNCS'));

    //  If we have a valid registry record, then we may be a dup or we may have
    //  just had filter functions registered for us before this call was made.
    if (TP.isValid(registryRecord)) {

        //  If we have an observerConfig, then it's highly likely that this is a
        //  duplicate and not just filter functions that got registered for us.
        if (TP.isValid(registryRecord.at('observerConfig'))) {
            TP.ifWarn() ?
                TP.warn('Existing managed mutation observer already' +
                            ' registered: ', observerID) : 0;
        }

        //  There may have been existing filter functions for this managed
        //  mutation observer if they were registered before this call was made.
        //  Concatenate them onto the end of the 'all filter function' set that
        //  we grabbed above for use below.
        filterFunctions = filterFunctions.concat(
                            registryRecord.at('filterFunctions'));
    }

    registryRecord = TP.hc(
                'recordsHandler', recordsHandler,
                'observerConfig', observerConfig,
                'observerID', observerID,
                'filterFunctions', filterFunctions
                );

    registry.atPut(observerID, registryRecord);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('addMutationObserverFilter',
function(filterFunction, observerID, filterIndex) {

    /**
     * @method addMutationObserverFilter
     * @summary Adds a filter function that will be used to filter mutation
     *     records. This can be installed for either a particular observer or
     *     for all managed Mutation Observers.
     * @description If observerID is TP.ALL, the filter functions will be
     *     installed for all managed Mutation Observers.
     * @param {Function} filterFunction A function that will take in a single
     *     MutationRecord objects and return true or false as to whether that
     *     record should be processed.
     * @param {String} observerID The ID of the observer to register the filter
     *     function for or TP.ALL.
     * @param {Number} [filterIndex] The index of filter functions to place the
     *     filter function. This defaults to just adding the filter to the end.
     */

    var registry,

        registryRecord;

    registry = TP.$$mutationObserverRegistry;

    //  Create the managed Mutation Observer registry if it doesn't already
    //  exist.
    if (TP.notValid(registry)) {
        registry = TP.hc('$ALL_FILTER_FUNCS', TP.ac());
        TP.$$mutationObserverRegistry = registry;
    }

    //  If the supplied observer ID is not TP.ALL, then this filter is being
    //  installed for a particular observer. Find its filter functions and add
    //  the new Function.
    if (observerID !== TP.ALL) {

        registryRecord = registry.at(observerID);

        //  It looks like the managed mutation observer hasn't been registered
        //  yet, so we create a (mostly) blank record, but with the
        //  'filterFunctions' set to an empty Array.
        if (TP.notValid(registryRecord)) {

            registryRecord = TP.hc(
                        'recordsHandler', null,
                        'observerConfig', null,
                        'observerID', null,
                        'filterFunctions', TP.ac()
                        );

            registry.atPut(observerID, registryRecord);
        }

        if (TP.isNumber(filterIndex)) {
            registryRecord.at('filterFunctions').splice(
                                        filterIndex, 0, filterFunction);
        } else {
            registryRecord.at('filterFunctions').push(filterFunction);
        }

        return;
    }

    //  The observerID is TP.ALL... we need to add this filter to all managed
    //  Mutation Observers.
    registry.perform(
            function(kvPair) {
                if (kvPair.first() === '$ALL_FILTER_FUNCS') {
                    return;
                }

                kvPair.last().at('filterFunctions').push(filterFunction);
            });

    //  We also keep track of all of the filter functions that should be
    //  installed for all observers for installation into future managed
    //  Mutation Observers.
    registry.at('$ALL_FILTER_FUNCS').push(filterFunction);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('activateMutationObserver',
function(targetNode, observerID) {

    /**
     * @method activateMutationObserver
     * @summary Activates a previously added managed Mutation Observer.
     * @param {Node|null} targetNode The node that will be observed for
     *     mutations. If null is supplied, and this observer has been used
     *     before and had another target node, that target node will be used.
     * @param {String} observerID The ID of the observer to activate.
     */

    var registry,

        registryRecord,

        observerCallback,
        observerObj,

        target;

    //  Make sure that we have a real managed Mutation Observer registry.
    registry = TP.$$mutationObserverRegistry;
    if (TP.notValid(registry)) {
        return TP.raise(this,
                        'TP.sig.InvalidObject',
                        'Invalid managed Mutation Observer registry');
    }

    //  Make sure that we can find the record of the managed Mutation Observer
    //  that the caller wants.
    registryRecord = registry.at(observerID);
    if (TP.notValid(registryRecord)) {
        return TP.raise(
                this,
                'TP.sig.InvalidObject',
                'No managed Mutation Observer entry for: ' + observerID);
    }

    observerObj = registryRecord.at('$observerObj');

    if (TP.notValid(observerObj)) {
        //  No existing MutationObserver object. We need to create one with a
        //  callback function.

        //  Create a Function that will be used as the native Mutation Observer
        //  callback. This Function will filter mutation records based on whether
        //  they've been handled or not already (to fix Webkit bug:
        //  https://bugs.webkit.org/show_bug.cgi?id=103916) and whether they pass
        //  further filter functions.

        observerCallback = function(mutationRecords, observer) {

            var handledSlotName,

                allRecords,

                records;

            //  Compute a 'handled' slot based on the ID of the observer
            //  that we're processing.
            handledSlotName = 'HANDLED_FOR_' +
                                observer.registryRecord.at('observerID');

            //  Note that we grab the mutationRecords parameter and then obtain
            //  *any* remaining currently queued mutation records from the
            //  observer by calling 'takeRecords'. This significantly speeds
            //  processing by avoiding multiple callbacks firing as mutation
            //  records are serviced and allows callbacks to handle the whole
            //  block of mutation records at once.
            allRecords = mutationRecords.concat(observer.takeRecords());

            records = allRecords.filter(
                function(aRecord) {

                    var filterFuncs,

                        len,
                        i;

                    //  If the record has already been handled by this observer,
                    //  return false to filter it out. This fixes the Webkit bug
                    //  mentioned above.
                    if (aRecord[handledSlotName]) {
                        return false;
                    }

                    //  Grab the filter functions, iterate through them and if
                    //  *any one* of them returns false, return false from here,
                    //  thereby filtering out that record.
                    filterFuncs =
                        observer.registryRecord.at('filterFunctions');

                    len = filterFuncs.getSize();
                    for (i = 0; i < len; i++) {
                        if (filterFuncs.at(i)(aRecord) === false) {
                            return false;
                        }
                    }

                    return true;
                });

            //  If we have real records to process, call the records handling
            //  Function with those records.
            if (TP.notEmpty(records)) {
                observer.registryRecord.at('recordsHandler')(records);
            }

            records.forEach(
                function(aRecord) {

                    //  We go ahead and stamp this record as 'handled' for this
                    //  observer.
                    aRecord[handledSlotName] = true;
                });
        };

        //  Go ahead and install the callback using the native Mutation Observer
        //  call and begin observation using data found in the record created
        //  when the caller added the managed Mutation Observer.
        observerObj = new MutationObserver(observerCallback);

        //  Capture the registry record on the observer object itself for use
        //  inside of the callback handler above to avoid closure issues.
        observerObj.registryRecord = registryRecord;

        //  Stash the native Mutation Observer object into the registry record
        //  for this managed Mutation Observer for use in deactivation.
        registryRecord.atPut('$observerObj', observerObj);
    }

    if (TP.notValid(targetNode)) {

        //  No supplied target - see if one had been provided before and was in
        //  the registry record for this observer.

        target = registryRecord.at('targetNode');
        if (!TP.isNode(target)) {
            return TP.raise(this,
                            'TP.sig.InvalidObject',
                            'Invalid managed Mutation Observer target node');
        }
    } else {
        target = targetNode;

        //  Stash the target node into the registry record for this managed
        //  Mutation Observer for convenience.
        registryRecord.atPut('targetNode', target);
    }

    registryRecord.atPut('active', true);

    observerObj.observe(target, registryRecord.at('observerConfig'));

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('deactivateMutationObserver',
function(observerID) {

    /**
     * @method deactivateMutationObserverFilter
     * @summary Deactivates a previously activated managed Mutation Observer.
     * @param {String} observerID The ID of the observer to deactivate.
     */

    var registry,

        registryRecord,
        observerObj;

    //  Make sure that we have a real managed Mutation Observer registry.
    registry = TP.$$mutationObserverRegistry;
    if (TP.notValid(registry)) {
        return TP.raise(this,
                        'TP.sig.InvalidObject',
                        'Invalid managed Mutation Observer registry');
    }

    //  Make sure that we can find the record of the managed Mutation Observer
    //  that the caller wants.
    registryRecord = registry.at(observerID);
    if (TP.notValid(registryRecord)) {
        return TP.raise(
                this,
                'TP.sig.InvalidObject',
                'No managed Mutation Observer entry for: ' + observerID);
    }

    //  Make sure that we have a valid native Mutation Observer object. Note
    //  that, if the node that the observer was watching is no longer valid, the
    //  observer will be automatically garbage collected, according to the
    //  Mutation Observers specification. In that case, we don't worry about it.
    observerObj = registryRecord.at('$observerObj');
    if (TP.isValid(observerObj)) {
        //  Clean the native Mutation Observers queue. NB: This may cause the
        //  callback that we installed in TP.activateMutationObserver() above to
        //  activate.
        observerObj.takeRecords();
        observerObj.disconnect();
    }

    registryRecord.atPut('active', false);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('removeMutationObserver',
function(observerID) {

    /**
     * @method removeMutationObserverFilter
     * @summary Removes a previously added managed Mutation Observer.
     * @param {String} observerID The ID of the observer to remove.
     */

    var registry,
        registryRecord;

    //  Make sure that we have a real managed Mutation Observer registry.
    registry = TP.$$mutationObserverRegistry;
    if (TP.notValid(registry)) {
        return TP.raise(this,
                        'TP.sig.InvalidObject',
                        'Invalid managed Mutation Observer registry');
    }

    //  Deactivate it to properly shut it down.
    TP.deactivateMutationObserver(observerID);

    //  See if we can find the record of the managed Mutation Observer that the
    //  caller wants.
    registryRecord = registry.at(observerID);
    if (TP.isValid(registryRecord)) {
        //  The target node is of no use to us now - remove it.
        registryRecord.removeKey('targetNode');

        //  The native observer object is of no use to us now - remove it.
        registryRecord.removeKey('$observerObj');
    }

    //  The managed Mutation Observer object is of no use to us now - remove it.
    registry.removeKey(observerID);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('resumeAllMutationObservers',
function() {

    /**
     * @method resumeAllMutationObservers
     * @summary Resumes all managed Mutation Observers. Any DOM mutations that
     *     happen between the suspension and the resumption of all managed
     *     Mutation Observers will *not* be tracked. This provides a synchronous
     *     way of turning on and off MO behavior for DOM mutations.
     */

    var registry;

    //  Make sure that we have a real managed Mutation Observer registry.
    registry = TP.$$mutationObserverRegistry;
    if (TP.notValid(registry)) {
        return TP.raise(this,
                        'TP.sig.InvalidObject',
                        'Invalid managed Mutation Observer registry');
    }

    registry.perform(
        function(kvPair) {
            if (kvPair.first() === '$ALL_FILTER_FUNCS') {
                return;
            }

            //  If the observer is already active, then just return.
            if (kvPair.last().at('active') === true) {
                return;
            }

            //  Activate it to properly start it up.
            TP.activateMutationObserver(null, kvPair.first());
        });

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('suspendAllMutationObservers',
function() {

    /**
     * @method suspendAllMutationObservers
     * @summary Suspends all managed Mutation Observers. Any DOM mutations that
     *     happen between the suspension and the resumption of all managed
     *     Mutation Observers will *not* be tracked. This provides a synchronous
     *     way of turning on and off MO behavior for DOM mutations.
     */

    var registry;

    //  Make sure that we have a real managed Mutation Observer registry.
    registry = TP.$$mutationObserverRegistry;
    if (TP.notValid(registry)) {
        return TP.raise(this,
                        'TP.sig.InvalidObject',
                        'Invalid managed Mutation Observer registry');
    }

    //  Iterate over each entry in the managed Mutation Observer registry and
    //  deactivate the managed Mutation Observer if it's not already inactive.
    registry.perform(
        function(kvPair) {
            if (kvPair.first() === '$ALL_FILTER_FUNCS') {
                return;
            }

            //  If the observer is already inactive, then just return.
            if (kvPair.last().at('active') === false) {
                return;
            }

            //  Deactivate it to properly shut it down.
            TP.deactivateMutationObserver(kvPair.first());
        });

    return;
});

//  ------------------------------------------------------------------------
//  TIBET - ENVIRONMENT PLUGIN INFORMATION
//  ------------------------------------------------------------------------

TP.boot.$configurePluginEnvironment = function() {

    /**
     * @method $configurePluginEnvironment
     * @summary Populates the TIBET environment metadata with information about
     *     all of the known plugins, whether they are installed or not and, if
     *     so, their version number.
     */

    var pluginKeys,
        len,
        i,
        pluginInfo;

    //  Get all of the keys in the TP.PLUGIN_INFO hash. This will contain
    //  keys matching all of the 'known' (but not necessarily installed)
    //  plugins.
    pluginKeys = TP.keys(TP.PLUGIN_INFO);

    //  Loop over that and register a set of key / value pairs containing:
    //      'plugin.<name>.installed'   ->  true or false
    //      'plugin.<name>.revMajor'    ->  Major revision number or undef
    //      'plugin.<name>.revMinor'    ->  Minor revision number or undef
    //      'plugin.<name>.revPatch'    ->  Patch revision number or undef

    len = pluginKeys.getSize();
    for (i = 0; i < len; i++) {
        pluginInfo = TP.getPluginInfo(pluginKeys.at(i));

        TP.boot.$$setenv(
                    TP.join('plugin.', pluginKeys.at(i), '.', 'installed'),
                    pluginInfo.at('isInstalled'));

        TP.boot.$$setenv(
                    TP.join('plugin.', pluginKeys.at(i), '.', 'revMajor'),
                    pluginInfo.at('revMajor'));
        TP.boot.$$setenv(
                    TP.join('plugin.', pluginKeys.at(i), '.', 'revMinor'),
                    pluginInfo.at('revMinor'));
        TP.boot.$$setenv(
                    TP.join('plugin.', pluginKeys.at(i), '.', 'revPatch'),
                    pluginInfo.at('revPatch'));
    }

    return;
};

//  ------------------------------------------------------------------------

//  A TIBET-formatted version of the code found here:
//  https://developer.mozilla.org/en-US/docs/Web/JavaScript/Enumerability_and_ownership_of_properties

TP.boot.$simplePropertyRetriever = {

    getOwnEnumerables: function(obj) {
        return this._getPropertyNames(
                        obj, true, false, this._enumerable);
         // Or could use for..in filtered with hasOwnProperty or just this:
         //     return Object.keys(obj);
    },
    getOwnNonenumerables: function(obj) {
        return this._getPropertyNames(
                        obj, true, false, this._notEnumerable);
    },
    getOwnEnumerablesAndNonenumerables: function(obj) {
        return this._getPropertyNames(
                        obj, true, false, this._enumerableAndNotEnumerable);
        //  Or just use: return Object.getOwnPropertyNames(obj);
    },
    getPrototypeEnumerables: function(obj) {
        return this._getPropertyNames(
                        obj, false, true, this._enumerable);
    },
    getPrototypeNonenumerables: function(obj) {
        return this._getPropertyNames(
                        obj, false, true, this._notEnumerable);
    },
    getPrototypeEnumerablesAndNonenumerables: function(obj) {
        return this._getPropertyNames(
                        obj, false, true, this._enumerableAndNotEnumerable);
    },
    getOwnAndPrototypeEnumerables: function(obj) {
        return this._getPropertyNames(
                        obj, true, true, this._enumerable);
        //  Or could use unfiltered for..in
    },
    getOwnAndPrototypeNonenumerables: function(obj) {
        return this._getPropertyNames(
                        obj, true, true, this._notEnumerable);
    },
    getOwnAndPrototypeEnumerablesAndNonenumerables: function(obj) {
        return this._getPropertyNames(
                        obj, true, true, this._enumerableAndNotEnumerable);
    },
    //  Private static property checker callbacks
    _enumerable: function(obj, prop) {
        return obj.propertyIsEnumerable(prop);
    },
    _notEnumerable: function(obj, prop) {
        return !obj.propertyIsEnumerable(prop);
    },
    _enumerableAndNotEnumerable: function(obj, prop) {
        return true;
    },
    //  Inspired by http://stackoverflow.com/a/8024294/271577
    /* eslint-disable func-names */
    _getPropertyNames: function getAllPropertyNames(
                                    obj, iterateSelfBool,
                                    iteratePrototypeBool, includePropCb) {
        var target,
            props,

            selfBool;

        target = obj;
        props = [];
        selfBool = iterateSelfBool;

        /* eslint-disable no-loop-func */
        do {
            if (selfBool) {
                Object.getOwnPropertyNames(target).forEach(
                        function(prop) {
                            if (props.indexOf(prop) === -1 &&
                                includePropCb(target, prop)) {
                                props.push(prop);
                            }
                        });
            }
            if (!iteratePrototypeBool) {
                break;
            }
            selfBool = true;
        /* eslint-enable no-loop-func */
        /* eslint-disable no-extra-parens */
        } while ((target = Object.getPrototypeOf(target)));
        /* eslint-enable no-extra-parens */

        return props;
    }
    /* eslint-enable func-names */
};

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETTokenizer.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
A simple tokenizing/trimming approach to minifying JavaScript source code.
A good part of the inspiration here comes from Douglas Crockford's Top Down
Operator Precendence paper and the tokens.js file which accompanies it, at
least the overall conceptual structure of the tokenizing loop. We've made a
number of adjustments to that simplified example so it can handle the
complexity found in the TIBET code base and avoid certain assumptions about
how the resulting token array will be utilized.
*/

//  ------------------------------------------------------------------------
//  Scanning/Tokenizing
//  ------------------------------------------------------------------------

/*
Keywords and reserved words from the ECMA 6.0 JavaScript specification.
*/

TP.boot.defineAttribute('$keywords',
    TP.ac(
        'break',
        'case',
        'class',
        'catch',
        'const',
        'continue',
        'debugger',
        'default',
        'delete',
        'do',
        'else',
        'export',
        'extends',
        'false',
        'finally',
        'for',
        'function',
        'if',
        'import',
        'in',
        'instanceof',
        'let',
        'new',
        'null',
        'return',
        'super',
        'switch',
        'this',
        'throw',
        'true',
        'try',
        'typeof',
        'var',
        'void',
        'while',
        'with',
        'yield'));

TP.boot.defineAttribute('$keywordString',
    '__' + TP.boot.$keywords.join('__') + '__');

TP.boot.defineAttribute('$futurereservedwords',
    TP.ac(
        'abstract',
        'await',
        'boolean',
        'byte',
        'char',
        'double',
        'enum',
        'final',
        'float',
        'goto',
        'implements',
        'int',
        'interface',
        'long',
        'native',
        'package',
        'private',
        'protected',
        'public',
        'short',
        'static',
        'synchronized',
        'transient',
        'volatile'
    ));

TP.boot.defineAttribute('$futureReservedString',
    '__' + TP.boot.$futurereservedwords.join('__') + '__');

//  The following list is per Narcissus's jsdefs.js definitions, adjusted to
//  also take ES6 bits into account.
TP.boot.defineAttribute('$operators',
    TP.ac(
        '#',
        ';',
        ',',
        '=',
        '?', ':',
        '||',
        '&&',
        '|',
        '^',
        '&',
        '==', '!=', '===', '!==',
        '<', '<=', '>=', '>',
        '<<', '>>', '>>>',
        '+', '-',
        '*', '/', '%',
        '+=', '-=', '*=', '/=', '%=', '<<=', '>>=', '>>>=', '&=', '|=', '^=',
        '!', '~',
        '++', '--',
        '.',
        '[', ']',
        '{', '}',
        '(', ')',
        //  ES6
        '...', '=>'
    ));

TP.boot.defineAttribute('$operatorString',
        '__' + TP.boot.$operators.join('__') + '__');

TP.boot.defineAttribute('$tshOpRegex',
        /^\.[|?%*&<>\(\{\[;][|&<>!\*\?\%\(\{\[]*/);

//  Considered 'built-in' by TIBET, but other schemes are added when
//  registered.
TP.boot.defineAttribute('$uriSchemes',
    {
        tibet: 'tibet',    // common
        urn: 'urn',        // common
        http: 'http',      // common
        https: 'https',    // common
        file: 'file',      // common
        xmpp: 'xmpp',      // common
        about: 'about',    // common
        mailto: 'mailto',  // common
        tel: 'tel',        // common
        news: 'news',      // common
        nntp: 'nntp',      // common
        ftp: 'ftp',        // common
        ws: 'ws',          // common
        wss: 'wss',        // common

        aaa: 'aaa',
        aaas: 'aaas',
        acap: 'acap',
        blob: 'blob',
        cap: 'cap',
        'chrome-extension': 'chrome-extension',
        cid: 'cid',
        crid: 'crid',
        data: 'data',
        dav: 'dav',
        dict: 'dict',
        dns: 'dns',
        fax: 'fax',
        go: 'go',
        gopher: 'gopher',
        h323: 'h323',
        icap: 'icap',
        im: 'im',
        imap: 'imap',
        info: 'info',
        ipp: 'ipp',
        iris: 'iris',
        'iris.beep': 'iris.beep',
        'iris.xpc': 'iris.xpc',
        'iris.xpcs': 'iris.xpcs',
        'iris.lws': 'iris.lws',
        ldap: 'ldap',
        lsid: 'lsid',
        mid: 'mid',
        modem: 'modem',
        msrp: 'msrp',
        msrps: 'msrps',
        mtqp: 'mtqp',
        mupdate: 'mupdate',
        nfs: 'nfs',
        opaquelocktoken: 'opaquelocktoken',
        pop: 'pop',
        pres: 'pres',
        prospero: 'prospero',
        rtsp: 'rtsp',
        service: 'service',
        shttp: 'shttp',
        sip: 'sip',
        sips: 'sips',
        snmp: 'snmp',
        'soap.beep': 'soap.beep',
        'soap.beeps': 'soap.beeps',
        tag: 'tag',
        telnet: 'telnet',
        tftp: 'tftp',
        thismessage: 'thismessage',
        tip: 'tip',
        tv: 'tv',
        vemmi: 'vemmi',
        wais: 'wais',
        'xmlrpc.beep': 'xmlrpc.beep',
        'z39.50r': 'z39.50r',
        'z39.50s': 'z39.50s'
    });

//  ------------------------------------------------------------------------
//  Helper Functions
//  ------------------------------------------------------------------------

TP.definePrimitive('$is_identifier',
function(tokenType) {

    /**
    @method     $is_identifier
    @summary    Returns true if the token type represents an
                identifier of some kind. Valid identifier types
                include 'identifier', 'keyword', and 'reserved'.
    @returns    {Boolean} True for identifier types/subtypes.
    */

    return tokenType === 'identifier' ||
            tokenType === 'keyword' ||
            tokenType === 'reserved';
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$is_ioend',
function(anOperator) {

    /**
    @method     $is_ioend
    @summary    Returns true if the operator represents a pipe symbol that
                ends a pipe segment. Common values are .;, .||, and .&&
                which all imply the next command does not read stdio etc.
    @param      {String} anOperator The operator to test.
    @returns    {Boolean}
    */

    /* eslint-disable no-extra-parens */
    return (anOperator === '.;' ||
            anOperator === '.||' ||
            anOperator === '.&&');
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$is_scheme',
function(anIdentifier) {

    /**
    @method     $is_scheme
    @summary    Returns true if token's value is a valid URI scheme. The
                list maintained in TP.boot.$uriSchemes.
    @param      {String} anIdentifier A string value to test.
    @returns    {Boolean}
    */

    var value;

    if (!anIdentifier) {
        return false;
    }

    value = anIdentifier;

    return TP.boot.$uriSchemes[value] === value;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$is_terminator',
function(anOperator) {

    /**
    @method     $is_terminator
    @summary    Returns true if the operator represents a common
                statement or substatement terminator. Semicolons and TSH
                operators (which all start with .) are terminators since
                they end a statement or sub-statement.
    @param      {String} anOperator The operator to test.
    @returns    {Boolean}
    */

    /* eslint-disable no-extra-parens */
    return (anOperator === ';' || TP.boot.$tshOpRegex.test(anOperator));
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$is_whitespace',
function(tokenType) {

    /**
    @method     $is_whitespace
    @summary    Returns true if the token type represents a form of
                whitespace such as a 'space', 'tab', or 'newline'.
    @returns    {Boolean} True for whitespace token subtypes.
    */

    /* eslint-disable no-extra-parens */
    return (tokenType === 'space' ||
            tokenType === 'tab' ||
            tokenType === 'newline');
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------
//  Tokenizing
//  ------------------------------------------------------------------------

TP.definePrimitive('$tokenize',
function(src, ops, tsh, exp, alias, args) {

    /**
    @method     $tokenize
    @summary    Processes a string (usually of raw JavaScript source code),
                returning an array of token objects which represent the
                source string in a "digestable" form. Token types include:
                comment, newline, space, keyword, reserved, identifier,
                regexp, string, number, operator, and substitution. This set
                allows us to have reasonable control over the source for
                condensing or other processing without resorting immediately
                to a full parser.
    @param      {String}    src             The JavaScript source to process.
    @param      {String[]}  [ops]           An optional array of the operator
                                            strings which should be considered
                                            valid for the source. If this isn't
                                            supplied, the set of JS operators is
                                            assumed.
    @param      {Boolean}   [tsh=false]     True to support extensions specific
                                            to the TIBET Shell (tsh) which
                                            includes ${var} and `cmd` syntax as
                                            well as limited markup processing.
    @param      {Boolean}   [exp=false]     True to signify that the content is
                                            being tokenized for expansion, which
                                            means certain clues for strings and
                                            regular expressions won't be found.
    @param      {Boolean}   [alias=false]   True to signify content is being
                                            tokenized for aliasing purposes.
                                            This causes substitutions to always
                                            terminate an ongoing string or URI.
    @param      {Boolean}   [args=false]    True to signify content is being
                                            tokenized for 'shell arguments'.
    @returns    {Object[]}  An array of token objects, simple objects which
                            represent one token within the source string.
    */

    var digit,
        hexDigit,
        formatSubSigils,

        identHead,
        identBody,
        keywords,
        operators,

        identifier_type,
        new_token,

        reserved,

        result,
        i,
        c,
        cc,
        lines,
        from,
        str,
        num,
        quote,
        attr,
        j,
        k,
        count,
        last,
        token,
        block,
        err,

        testval,

        preservedParen,
        startsURI,
        uriParenCount,

        startsTemplate,
        startsFormatSub,

        templateBracketCount;

    //  common regular expressions used for character testing
    digit = /[0-9]/;
    hexDigit = /[0-9a-fA-F]/;

    formatSubSigils = /[#%@]/;

    //  NB: we allow '@' as a leading character for an identifer, so that users
    //  can use 'dereferencing sugar', but the system will strip this before it
    //  tries to evaluate it.

    identHead = args === true ? /^[@$_a-zA-Z{]/ : /^[@$_a-zA-Z]/;
    identBody = args === true ? /[{$_a-zA-Z0-9-}]/ : /[$_a-zA-Z0-9]/;

    //  easily tested strings used for identifier/operator testing
    keywords = TP.boot.$keywordString;
    reserved = TP.boot.$futureReservedString;

    //  if operators were supplied, then join them all together into our
    //  detection string.
    if (ops) {
        operators = '__' + ops.join('__') + '__';
    } else {
        //  otherwise, use the precomputed detection string that consists of JS
        //  operators.
        operators = TP.boot.$operatorString;
    }

    //  ---
    //  helper functions
    //  ---

    identifier_type = function(ident) {
        /**
        @method     identifier_type
        @summary    Returns the proper type for an identifier string. This
                    allows the tokenizer to fine-tune identifier recognition
                    to point out keywords, reserved words, etc.
        @param      {String} ident The identifier string to categorize.
        @returns    {String} An identifier type: 'keyword', 'reserved', or
                             'identifier'.
        */

        if (keywords.indexOf('__' + ident + '__') > 0) {
            return 'keyword';
        } else if (reserved.indexOf('__' + ident + '__') > 0) {
            return 'reserved';
        }

        return 'identifier';
    };

    new_token = function(type, value, note) {
        /**
        @method     new_token
        @summary    Simple token constructor which returns a token object
                    identifying the token type, value, and its location in
                    the source text.
        @param      {String} type The token type. Must be one of the standard
                                  token types for the outer $tokenize method.
        @param      {String} value The string value for the token.
        @param      {String} note Optional annotation for the token.
        @returns    {Object} A simple object containing type, value, line, from,
                             and to keys for the token.
        */

        //  assign to outer scope'd variable for use in processing loop
        last = {
            name: type,
            value: value,
            note: note,
            line: lines,
            from: from,
            to: i
        };

        return last;
    };

    //  ---
    //  main processing loop
    //  ---

    //  configure the token stream and return it empty if no real source
    result = [];
    if (!src) {
        return result;
    }

    i = 0;
    lines = 1;

    uriParenCount = 0;
    templateBracketCount = 0;

    c = src.charAt(i);
    while (c) {
        from = i;

        //  a bit nasty, but seems to work even with &nbsp;
        if (c <= ' ' || c.charCodeAt(0) === 160) {
            //  control characters are largely stripped when found but we do
            //  handle certain forms of whitespace to preserve semantics.

            //  Increment i before new_token to capture 'to:'
            i += 1;

            if (c === ' ' || c.charCodeAt(0) === 160) {
                result.push(new_token('space', c));
                str = '';
            } else if (c === '\t') {
                result.push(new_token('tab', c));
                str = '';
            } else if (c === '\n') {
                token = new_token('newline', '\n');
                result.push(token);
                str = '';
                lines++;
            } else if (c === '\r') {
                //  replace \r so we normalize newlines, but don't create
                //  extra lines when the next character is a newline
                if (src.charAt(i + 1) !== '\n') {
                    token = new_token('newline', '\n');
                    result.push(token);
                    str = '';
                    lines++;
                }
            }

            c = src.charAt(i);
        } else if (identHead.test(c) ||

                /* eslint-disable no-extra-parens */
                (tsh && (c === '~' ||
                        (c === '#' && !/\d/.test(src.charAt(i + 1))) ||
                        (c === '.' && src.charAt(i + 1) === '/') ||
                        (c === '.' && src.charAt(i + 1) === '.' &&
                            src.charAt(i + 2) === '/')
                        ))) {
                /* eslint-enable no-extra-parens */

            //  identifiers start with $, _, or a-zA-Z, then allow 0-9

            //  first check to make sure we aren't holding a leading '(' - if
            //  so, don't blow away str.
            if (str === '(') {
                preservedParen = true;
                str += c;
            } else {
                preservedParen = false;
                str = c;
            }
            i += 1;

            /* eslint-disable no-extra-parens */
            startsTemplate = (src.charAt(i - 2) !== '\\' &&
                                str === '{' &&
                                src.charAt(i) === '{');
            startsFormatSub = (formatSubSigils.test(str) &&
                                src.charAt(i) === '{');
            /* eslint-enable no-extra-parens */

            if (tsh && startsTemplate) {

                err = false;

                //  'str' now contains both brackets
                str += c;
                i += 1;

                templateBracketCount = 2;

                for (;;) {
                    c = src.charAt(i);

                    if (c === '{' && src.charAt(i - 1) !== '\\') {
                        templateBracketCount++;
                    }
                    if (c === '}' && src.charAt(i - 1) !== '\\') {
                        templateBracketCount--;
                    }

                    str += c;
                    i += 1;

                    if (c === '' && templateBracketCount !== 0) {
                        err = true;
                        TP.boot.$stderr('Unbalanced brackets in template: ' +
                            TP.boot.$stringify(new_token('template', str),
                                ', '));

                        break;
                    }

                    if (templateBracketCount === 0) {

                        if (!err) {
                            //  scheme-specific part of the URI
                            result.push(new_token('template', str));
                        }

                        break;
                    }
                }
            } else if (tsh && startsFormatSub) {

                err = false;

                //  'str' now contains both sigil character and paren
                str += src.charAt(i);
                i += 1;

                templateBracketCount = 1;

                for (;;) {
                    c = src.charAt(i);

                    if (c === '{' && src.charAt(i - 1) !== '\\') {
                        templateBracketCount++;
                    }
                    if (c === '}' && src.charAt(i - 1) !== '\\') {
                        templateBracketCount--;
                    }

                    str += c;
                    i += 1;

                    if (c === '' && templateBracketCount !== 0) {
                        err = true;
                        TP.boot.$stderr('Unbalanced brackets in format' +
                                        ' substitution: ' +
                            TP.boot.$stringify(new_token('formatsub', str),
                                ', '));

                        break;
                    }

                    if (templateBracketCount === 0) {

                        if (!err) {
                            //  scheme-specific part of the URI
                            result.push(new_token('formatsub', str));
                        }

                        break;
                    }
                }
            } else {
                // identHead || ~ || #
                // ...but not a 'special variable sub' (${...})

                err = false;

                c = src.charAt(i);

                //  '#', '~', '/', './' or '../' starts a URI

                /* eslint-disable no-extra-parens */
                testval = str + c;

                startsURI =
                    /#[^\d]/.test(testval) ||   //  '#' followed by non-digit
                    /\(?~/.test(testval) ||     //  maybe '(' followed by '~'
                    /\(?\.\//.test(testval) ||  //  maybe '(' followed by './'
                    /\(?\.\.\//.test(testval);  //  maybe '(' followed by '../'

                if (identBody.test(c) === true ||
                    (tsh && startsURI)) {

                    if (testval.charAt(0) === '(') {
                        if (startsURI) {
                            uriParenCount++;
                        }
                        if (result.at(result.getSize() - 1).value === '(') {
                            result.pop();
                        }
                    }

                    str += c;
                    i += 1;
                    for (;;) {
                        c = src.charAt(i);
                        if (identBody.test(c) !== true) {
                            break;
                        }

                        str += c;
                        i += 1;
                    }
                    /* eslint-enable no-extra-parens */

                    //  in the TSH we have special cases for URI syntax so
                    //  you can type http://www.tibet.com and not lose the
                    //  tail as a comment. the one caveat is that we rely on a
                    //  strict list of schemes and only support those here.

                    //  TODO: The 'URI shouldn't end with a '}' is a hack here.
                    //  Need a more proper way to determine a URI's end.
                    if (tsh &&
                        c !== '}' &&
                        (c === ':' && TP.$is_scheme(str) || startsURI)) {

                        //  if we get into a paren, note it... that means
                        //  this is an XPointer of some sort, which means it
                        //  can have spaces etc.
                        if (c === '(') {
                            uriParenCount++;
                        }

                        //  we could also be processing a closing paren if our
                        //  overall expression started with an opening paren. We
                        //  need to decrement the count here to keep things
                        //  balanced.
                        if (c === ')') {
                            uriParenCount--;
                        }

                        str += c;
                        i += 1;

                        for (;;) {
                            c = src.charAt(i);

                            //  Can have nested parens
                            if (c === '(') {
                                uriParenCount++;
                            }

                            //  consume quoted attribute values. This includes
                            //  support for nested quotes
                            if (!alias && (c === '"' || c === '\'') &&
                                src.charAt(i - 1) === '=') {
                                attr = '';
                                i += 1;

                                quote = c;
                                for (;;) {
                                    c = src.charAt(i);
                                    if (c === quote &&
                                        src.charAt(i - 1) !== '\\') {

                                        str += encodeURIComponent(attr);
                                        i += 1;
                                        c = src.charAt(i);
                                        break; //   break out of this for loop
                                    }

                                    if (c === '\\' &&
                                        src.charAt(i + 1) === quote) {
                                        //  don't add the backslash as we don't
                                        //  want it encoded
                                        void 0;
                                    } else {
                                        attr += c;
                                    }

                                    i += 1;
                                }
                            }

                            if (c === ')') {
                                uriParenCount--;
                            }

                            if (uriParenCount === 0) {
                                //  various "end of URI" signifiers
                                if (c === '\n' || c === '\r' || c === '' ||
                                    c === '}' || c === ',' ||
                                    c <= ' ' || c.charCodeAt(0) === 160) {
                                    break;
                                }

                                //  TSH pipe/redirection symbol is a
                                //  terminator
                                if (c === '.' &&
                                    '|&<>({['.indexOf(src.charAt(i + 1)) >= 0) {
                                    break;
                                }

                                //  If aliasing then substitutions are a
                                //  terminator.
                                if (alias && c === '$' &&
                                    '{'.indexOf(src.charAt(i + 1)) >= 0) {
                                    break;
                                }
                            }

                            //  Increment i before new_token to capture 'to:'
                            i += 1;

                            if (c === '' && uriParenCount !== 0) {
                                err = true;
                                TP.boot.$stderr('Unbalanced parens in URI: ' +
                                    TP.boot.$stringify(new_token('uri', str),
                                        ', '));
                                break;
                            }

                            str += c;
                        }

                        if (!err) {
                            //  scheme-specific part of the URI
                            if (preservedParen) {
                                from -= 1;
                                i -= 1;
                            }
                            result.push(new_token('uri', str));
                        }
                    } else {
                        //  One special case to check here is {}, which will
                        //  otherwise result in a single token value.
                        if (/^[{}]+$/.test(str)) {
                            /* eslint-disable no-loop-func */
                            str.split('').forEach(
                                    function(char) {
                                        i = from + 1;
                                        result.push(
                                                new_token('operator', char));
                                        from += 1;
                                    });
                            /* eslint-enable no-loop-func */
                        } else if (/^\{[$_a-zA-Z]+/.test(str)) {
                            i = from + 1;
                            result.push(new_token('operator', '{'));
                            from += 1;
                            i += str.length - 1;
                            result.push(new_token(
                                        identifier_type(str.slice(1)),
                                        str.slice(1), 825));
                        } else {

                            if (str.charAt(0) === '(') {

                                from = i - str.length;
                                i = from + 1;
                                result.push(new_token('operator', '(', 825));

                                //  Slice off '(' so we don't use again.
                                str = str.slice(1);
                                if (str) {
                                    from += 1;
                                    i += str.length;
                                    result.push(new_token(
                                        identifier_type(str), str, 840));
                                    str = '';
                                }

                            } else {
                                //  for identifiers we do a lookup to refine the
                                //  type here
                                result.push(new_token(identifier_type(str),
                                    str, 848));
                            }
                        }
                    }
                } else {

                    //  Due to some template-related testing earlier one nasty
                    //  possibility here is something like "(ident" so we need
                    //  to test for that first
                    if (str.charAt(0) === '(' &&
                            identHead.test(str.slice(1))) {

                        from = i - str.length;
                        i = from + 1;

                        if (!preservedParen) {
                            result.push(new_token('operator', '(', 858));
                        }

                        //  Slice off '(' so we don't use again.
                        str = str.slice(1);

                        from += 1;
                        i += str.length;
                        result.push(new_token(
                            identifier_type(str), str, 873));
                        str = '';

                    } else if (identHead.test(str)) {

                        result.push(new_token(identifier_type(str), str,
                            879));
                        i += str.length - 1;
                    } else {
                        //  first char after the ~ or # is a number or
                        //  similarly invalid identifier character so the ~
                        //  or # is treated as an operator.
                        result.push(new_token('operator', str));
                        i += str.length - 1;
                    }
                }
            }

            //  NOTE that the character which triggered failure of our inner
            //  for-loop will be in c, so we don't need to adjust index/char

        /* eslint-disable no-extra-parens */
        } else if (digit.test(c) ||
                (c === '-' && digit.test(src.charAt(i + 1))) ||
                (c === '+' && digit.test(src.charAt(i + 1)))) {
        /* eslint-enable no-extra-parens */
            err = false;

            //  number: 0xblah for Hex, optional e/E exponent, etc.
            str = c;
            i += 1;

            //  what we do next depends a lot on the next character...
            c = src.charAt(i);

            //  check for hex. it's got more restricted data rules since you
            //  can't have exponents or fractional parts
            if (c === 'x' || c === 'X') {
                str += c;
                i += 1;
                for (;;) {
                    c = src.charAt(i);
                    if (!hexDigit.test(c)) {
                        break;
                    }
                    str += c;
                    i += 1;
                }
            } else {
                //  char must be a digit, a decimal point, or an exponent
                //  signifier to be valid. we test first for a second digit
                //  which allows us to consume initial digit sequences that
                //  serve as a prefix for a decimal point or exponent part.

                if (digit.test(c)) {
                    str += c;
                    i += 1;

                    //  read all remaining contiguous digits. NOTE that when
                    //  the string starts with 0 it should be restricted to
                    //  octal values, but we'll consume all digits here and
                    //  let the string-to-number conversion at the end fail
                    //  as a way of catching bad values.
                    for (;;) {
                        c = src.charAt(i);
                        if (!digit.test(c)) {
                            //  ran into something that's not a digit, but
                            //  we'll worry about what that might be in the
                            //  next couple of if statement checks. Note
                            //  that we'll have left c on the 'non-digit'
                            //  value for those tests.
                            break;
                        }
                        str += c;
                        i += 1;
                    }
                }

                //  check for fractional portion
                if (c === '.') {
                    //  TSH can often have .)) or similar operators which,
                    //  if placed after a number can create syntax errors.
                    //  also, we want ./ and ../ to be picked up as path
                    //  prefixes, not separate operators, so make sure the
                    //  dot is only added when at least one trailing digit
                    //  is found
                    if (digit.test(src.charAt(i + 1))) {
                        //  push the '.' and keep processing digits until
                        //  we run out or hit an 'e' for exponent portion or
                        //  some other character that forces us to evaluate
                        //  whether we're really looking at a number here.
                        str += c;
                        i += 1;

                        for (;;) {
                            c = src.charAt(i);
                            if (!digit.test(c)) {
                                //  as with earlier digit-consumption loop
                                //  we'll process digits while we can and
                                //  leave validation of the "tail" to the
                                //  next if test.
                                break;
                            }
                            str += c;
                            i += 1;
                        }
                    }
                }

                //  check for exponent (e+/1dddd)
                if (c === 'e' || c === 'E') {
                    //  push e/E onto string
                    str += c;
                    i += 1;

                    //  exponent should be followed by +/- and/or digits so
                    //  read another character and test
                    c = src.charAt(i);

                    //  check for optional +/- sign for exponent
                    //  should only be digits after optional +/-
                    if (digit.test(c) !== true && c !== '-' && c !== '+') {
                        err = true;
                        TP.boot.$stderr('Bad exponent: ' +
                            TP.boot.$stringify(new_token('number', str + c),
                                ', '));

                        //  see if we can salvage a number from the rest of
                        //  the string content, stripping the 'e' portion.
                        num = 0 + str.slice(0, str.length - 1);
                        if (isFinite(num)) {
                            //  push new numeric token
                            result.push(new_token('number', str));
                        } else {
                            err = true;
                            TP.boot.$stderr('Bad number: ' +
                                TP.boot.$stringify(new_token('number', str),
                                    ', '));
                        }

                        //  NOTE that we've already incremented the index
                        //  and retrieved a character which didn't test
                        //  out...now we want to have it break out to the
                        //  next character portion of the outer while loop
                        continue;
                    } else {
                        //  push digit or +/- onto string and read
                        //  remaining digits until we run out
                        do {
                            str += c;
                            i += 1;
                            c = src.charAt(i);
                        } while (digit.test(c));

                        //  NOTE that the 'c' will be the next char here so
                        //  again we don't want/need to increment index/c.

                        //  We do want to test c at this point to ensure
                        //  that we terminated the number with something
                        //  that's at least potentially valid, and that
                        //  leaves out any identifier characters.
                        if (identHead.test(c)) {
                            str += c;
                            i += 1;

                            err = true;
                            TP.boot.$stderr('Bad number: ' +
                                TP.boot.$stringify(new_token('number', str),
                                    ', '));
                        }
                    }
                } else {
                    //  most likely we're looking at a bad number value if
                    //  continued characters don't represent an operator or
                    //  a grouping construct.
                    if (identHead.test(c)) {
                        str += c;
                        i += 1;

                        err = true;
                        TP.boot.$stderr('Bad number: ' +
                            TP.boot.$stringify(new_token('number', str),
                                ', '));
                    }
                }
            }

            if (!err) {
                //  convert string into a number and verify that it's real
                num = Number(str);

                if (isFinite(num)) {
                    //  push new numeric token
                    result.push(new_token('number', str));
                } else {
                    TP.boot.$stderr('Bad number: ' +
                        TP.boot.$stringify(new_token('number', str), ', '));
                }
            }

        /* eslint-disable no-extra-parens */
        } else if (c === '\'' || c === '"' || c === '`') {
        /* eslint-enable no-extra-parens */
            //  quoted string...and TSH command-substitutions. these are
            //  all treated as "quoting characters", but we tokenize the
            //  command substitution as such rather than as a string when
            //  the tsh syntax flag is set.

            str = c;
            quote = c;

            i += 1;

            for (;;) {
                c = src.charAt(i);
                if (c === '\n' || c === '\r' || c === '') {
                    if (c !== '') {
                        str += c;
                    }

                    if (!tsh) {
                        TP.boot.$stderr('Unterminated string: ' +
                            TP.boot.$stringify(new_token('string', str), ', '));

                        //  consider this a warning, go ahead and push the
                        //  token data we do have out so it's at least in
                        //  the final stream
                        result.push(new_token('string', str));
                        break;
                    }

                    i = i - str.length;

                    //  in TSH processing not all content is JS, much more
                    //  is actually markup where a ' or " should simply be
                    //  treated as another character. Of course, that means
                    //  that we have to "back up" and reprocess the str
                    //  value for other characters of interest rather than
                    //  continuing to treat it like "offlimit" content.
                    result.push(new_token('quote', quote));

                    if (c !== '') {
                        i += 1;
                    }
                    break;
                }

                //  do the append with unicode-sensitive operations
                cc = src.charCodeAt(i);
                str += String.fromCharCode(cc);

                //  closing quote? as long as it's not escaped we're good
                if (c === quote) {
                    //  bit tricky since you can have multiple \'s and we
                    //  need to know if the number is odd or even to
                    //  determine whether we're really escaped or not
                    j = i - 1;
                    count = 0;
                    while (src.charAt(j) === '\\') {
                        count++;
                        j--;
                    }

                    //  even? quote not escaped, the '\' is
                    if (count % 2 === 0) {
                        if (quote === '`') {
                            if (tsh) {
                                result.push(new_token('substitution', str));
                            } else {
                                result.push(new_token('es6template', str));
                            }
                        } else {
                            result.push(new_token('string', str));
                        }
                        break;
                    }
                }

                i += 1;
            }

            i += 1;
            c = src.charAt(i);
        } else if (c === '/') {
            //  opening / can be 'divide', a regex, a single-line comment,
            //  or a multi-line comment depending on the next character and
            //  other contextual information.

            switch (src.charAt(i + 1)) {
                case '/':
                    //  single line comment. read/consume chars up through a
                    //  newline which terminates the comment. NOTE that
                    //  earlier code for identifier/: locates URIs prior to
                    //  the // so we don't strip URI content as comment.

                    str = '//';
                    i += 2;

                    for (;;) {
                        c = src.charAt(i);
                        if (c === '\n' || c === '\r' || c === '') {
                            break;
                        }

                        //  do the append with unicode-sensitive operations
                        cc = src.charCodeAt(i);
                        str += String.fromCharCode(cc);
                        i += 1;
                    }

                    result.push(new_token('comment', str));
                    break;

                case '*':
                    //  multi-line comment. read/consume up through a
                    //  closing */. regular expressions would require there
                    //  to be at least one character prior to the *, a
                    //  backslash to escape it if a literal * was intended.

                    str = '/*';
                    i += 2;

                    for (;;) {
                        c = src.charAt(i);
                        if (c === '') {
                            TP.boot.$stderr('Unterminated comment: ' +
                                TP.boot.$stringify(new_token('comment', str),
                                    ', '));
                            break;
                        } else if (c === '*') {
                            if (src.charAt(i + 1) === '/') {
                                str += '*/';
                                i += 2;
                                c = src.charAt(i);
                                break;
                            }
                        }

                        if (c === '\n') {
                            lines++;
                        }

                        //  do the append with unicode-sensitive operations
                        cc = src.charCodeAt(i);
                        str += String.fromCharCode(cc);
                        i += 1;
                    }

                    result.push(new_token('comment', str));
                    break;

                default:

                    //  trick here is to try to recognize regex literals so
                    //  we can treat them as opaque chunks. if we don't then
                    //  regexes containing quotes or numbers might end up
                    //  confusing the tokenizer around those types.

                    //  from a pure syntax perspective a regular expression
                    //  literal is all content between a pair of forward
                    //  slashes, and you can't strictly know whether the
                    //  initial / is regex opener or not until you read up
                    //  to the next newline.

                    //  when in TSH mode we defer to XML over regexp
                    if (tsh && src.charAt(i + 1) === '>') {
                        i += 2;
                        result.push(new_token('operator', '/>'));
                        c = src.charAt(i);
                        break;
                    }

                    //  when trying to tokenize stripped code there won't
                    //  be any newlines to give us clues or tell us for sure
                    //  that we're in a regular expression. the only thing
                    //  we can try to do in those cases is look at context.
                    //  regular expressions typically have to follow an
                    //  assignment, comma, or opening parenthesis since they
                    //  haveto either be assigned to a variable or passed to
                    //  a function like split or replace.
                    if (exp && last &&
                        last.value !== '=' &&
                        last.value !== '(' &&
                        last.value !== ',') {
                        i += 1;
                        result.push(new_token('operator', '/'));
                        c = src.charAt(i);
                        break;
                    }

                    j = i + 1;
                    str = c;

                    block = 0;

                    for (;;) {
                        c = src.charAt(j);
                        if (c === '\n' || c === '\r' || c === '') {
                            //  ran out of chars before we found a closing
                            //  character (newline or end of stream) so it's
                            //  _not_ a regular expression...could be either
                            //  a / or /= operator
                            str = src.charAt(i + 1) === '=' ? '/=' : '/';
                            i += str.length;
                            result.push(new_token('operator', str));
                            c = src.charAt(i);
                            break;
                        }

                        //  forward brackets inside character classes don't
                        //  have to be escaped...so we don't want to count
                        //  them twice
                        if (c === '[' && block < 1) {
                            //  if not escaped...count it
                            k = j - 1;
                            count = 0;
                            while (src.charAt(k) === '\\') {
                                count++;
                                k--;
                            }

                            if (count % 2 === 0) {
                                block++;
                            }
                        }

                        //  reverse brackets inside character classes don't
                        //  have to be escaped...so we don't want to count
                        //  them twice
                        if (c === ']' && block > 0) {
                            //  if not escaped...count it
                            k = j - 1;
                            count = 0;
                            while (src.charAt(k) === '\\') {
                                count++;
                                k--;
                            }

                            if (count % 2 === 0) {
                                block--;
                            }
                        }

                        //  if we find an unescaped / outside of a character
                        //  class we're at the end of the regex. we'll need
                        //  to increment the c to keep the outer loop
                        //  running properly
                        if (c === '/' && block === 0) {
                            //  bit tricky since you can have multiple
                            //  \'s and we need to know if the number is
                            //  odd or even to determine whether we're
                            //  really escaped or not
                            k = j - 1;
                            count = 0;
                            while (src.charAt(k) === '\\') {
                                count++;
                                k--;
                            }

                            //  even? '/' not escaped, the '\' is, so
                            //  this is a valid termination of the regex
                            if (count % 2 === 0) {
                                str += c;
                                j += 1;

                                //  the other tricky part here is that a
                                //  regex literal can have trailing
                                //  characters including 'g','i','m',
                                //  'y', or combinations of those chars
                                //  so we have to consume them as well.
                                for (;;) {
                                    c = src.charAt(j);
                                    if (/[gimy]/.test(c) !== true) {
                                        break;
                                    }
                                    str += c;
                                    j += 1;
                                }

                                i = j;
                                result.push(new_token('regexp', str));
                                break;
                            } else {
                                //  escaped? keep scanning for the end
                                str += c;
                                j += 1;
                            }
                        } else {
                            //  not there yet...use unicode operations
                            cc = src.charCodeAt(j);
                            str += String.fromCharCode(cc);
                            j += 1;
                        }
                    }
                    break;
            }
        } else if (tsh && c === '<' && src.charAt(i + 1) === '/') {
            //  XML tag closing operator
            i += 2;
            result.push(new_token('operator', '</'));
            c = src.charAt(i);
        } else {
            //  try to construct the longest possible operator or string from
            //  the characters remaining in the string. note that we don't
            //  allow for operators longer than 4 characters in length

            str = src.slice(i, i + 4);
            for (j = 3; j > 0; j--) {
                if (operators.indexOf('__' + str + '__') > 0) {
                    break;
                }
                str = str.slice(0, j);
            }

            i += str.length;

            //  if the str is not an operator, it's a string
            if (operators.indexOf('__' + str + '__') === TP.NOT_FOUND) {
                result.push(new_token('string', str));
            } else {
                result.push(new_token('operator', str, '1383'));
            }

            c = src.charAt(i);
        }
    }

    if (TP.isEmpty(result[result.length - 1].value)) {
        result = result.slice(0, -1);
    }

    if (tsh && TP.sys.cfg('log.tsh_tokenize')) {
        TP.boot.$stdout(TP.json(result));
    }

    return result;
});

//  ------------------------------------------------------------------------
//  Token-based Utilities
//  ------------------------------------------------------------------------

TP.definePrimitive('$tokenizedConstruct',
function(src, ops, tsh, exp, alias, args) {

    var tokens,
        token,
        count,
        index,
        slice,
        close,
        shell,
        obj,
        result,
        i,
        len,
        parts;

    if (TP.isEmpty(src)) {
        return this.raise('InvalidParameter',
            'Must provide token array or string.');
    }

    if (TP.isString(src)) {
        tokens = TP.$tokenize(src,
            TP.ifInvalid(ops, TP.tsh.script.$tshAndJSOperators),
            TP.ifInvalid(tsh, true),
            TP.ifInvalid(exp, false),
            TP.ifInvalid(alias, false),
            TP.ifInvalid(args, true));
    } else if (TP.isArray(src)) {
        tokens = src;
    } else {
        return this.raise('InvalidParameter',
            'Must provide token array or string.');
    }

    shell = TP.bySystemId('TSH');
    parts = TP.ac();
    token = tokens.shift();
    switch (token.value) {
        case '[':
            token = tokens.shift();
            while (token && token.value !== ']') {
                //  Handle nested array or object references.
                if (token.value === '[' || token.value === '{') {
                    //  slice out tokens that comprise nested structure and
                    //  invoke recursively to produce the result for the slot.
                    close = token.value === '[' ? ']' : '}';
                    count = 1;
                    index = 0;
                    while (count !== 0 && tokens[index]) {
                        if (tokens[index].value === token.value) {
                            count++;
                        } else if (tokens[index].value === close) {
                            count--;
                        }
                        index++;
                    }

                    //  If no value at tokens[index] we ran off the end looking
                    //  for a closing token.
                    if (!tokens[index]) {
                        //  TODO:   warn/error?
                        void 0;
                    }

                    //  Capture nested struct slice and build.
                    slice = tokens.slice(0, index);
                    slice.unshift(token);
                    parts.push(TP.$tokenizedConstruct(slice));


                    //  Remove nested content from list and continue.
                    tokens = tokens.slice(index + 1);
                    token = tokens.shift();
                }

                //  Since we're slicing and getting a new token we need to
                //  recheck exit before trying to process remaining chunks.
                if (token && token.value === ']') {
                    break;
                }

                //  Process remaining chunks.
                if (token && !TP.$is_whitespace(token.name) &&
                        token.name !== 'operator') {
                    //  Try to get the best version of each token.
                    obj = shell.resolveObjectReference(token.value);
                    parts.push(TP.ifUndefined(obj, token.value));
                }
                token = tokens.shift();
            }

            if (TP.isEmpty(parts)) {
                result = [];
            } else {
                result = parts;
            }

            break;
        case '{':
            token = tokens.shift();
            while (token && token.value !== '}') {
                //  Handle nested array or object references.
                if (token.value === '[' || token.value === '{') {
                    //  slice out tokens that comprise nested structure and
                    //  invoke recursively to produce the result for the slot.
                    close = token.value === '[' ? ']' : '}';
                    count = 1;
                    index = 0;
                    while (count !== 0 && tokens[index]) {
                        if (tokens[index].value === token.value) {
                            count++;
                        } else if (tokens[index].value === close) {
                            count--;
                        }
                        index++;
                    }

                    //  If no value at tokens[index] we ran off the end looking
                    //  for a closing token.
                    if (!tokens[index]) {
                        //  TODO:   warn/error?
                        void 0;
                    }

                    //  Capture nested struct slice and build.
                    slice = tokens.slice(0, index);
                    slice.unshift(token);
                    parts.push(TP.$tokenizedConstruct(slice));

                    //  Remove nested content from list and continue.
                    tokens = tokens.slice(index + 1);
                    token = tokens.shift();
                }

                //  Since we're slicing and getting a new token we need to
                //  recheck exit before trying to process remaining chunks.
                if (token && token.value === '}') {
                    break;
                }

                if (token && !TP.$is_whitespace(token.name) &&
                        token.name !== 'operator') {
                    obj = shell.resolveObjectReference(token.value);
                    parts.push(TP.ifUndefined(obj, token.value));
                }
                token = tokens.shift();
            }

            //  Parts should now contain an array containing key, value, key,
            //  value, etc. So process that into an object form.
            result = {};
            len = parts.length;
            for (i = 0; i < len; i += 2) {
                result[parts[i].unquoted()] = parts[i + 1];
            }
            break;
        default:
            //  Only works on primitive array and object structures.
            return;
    }

    return result;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$tokenizedJoin',
function(tokens, separators) {

    /**
     * @method $tokenizedJoin
     * @summary Builds up one or more strings by combining sequences of tokens
     *     separated by one or more separator tokens. This routine is used by
     *     $tokenizedSplit for example, to rejoin substrings separated by
     *     whitespace tokens. The result is that identifiers etc. are rebuilt.
     * @param {String[]} tokens A list of tokens from the $tokenize routine.
     * @param {String[]} separators A list of token types which should be
     *     considered separators. Sequences of non-separators are joined.
     * @returns {String[]} An array of strings reconstructed from tokens.
     */

    var seps,
        arr,
        str;

    if (TP.isEmpty(tokens)) {
        return this.raise('InvalidParameter', 'Must have token list to join.');
    }

    if (TP.isValid(separators) && !TP.isArray(separators)) {
        return this.raise('InvalidParameter', 'Separators must be an array.');
    }
    seps = TP.notValid(separators) ? ['space', 'tab', 'newline'] : separators;

    arr = TP.ac();
    str = '';
    tokens.forEach(function(token) {
        if (seps.indexOf(token.name) !== TP.NOT_FOUND) {
            //  Separator, close off string, push, and start a new one.
            arr.push(str);
            str = '';
        } else {
            str += token.value;
        }
    });

    //  Push the last token string, if it's not a "leftover" that's empty.
    if (TP.notEmpty(str)) {
        arr.push(str);
    }

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$tokenizedSplit',
function(src, separators, ops, tsh, exp, alias, args) {

    /**
     * @method $tokenizedSplit
     * @summary Tokenizes and then rejoins a source string. The initial
     *     tokenization is done by passing all arguments other than the
     *     separators value to the $tokenize routine. The resulting token list
     *     and separators are then passed to $tokenizedJoin. This routine
     *     defaults the tsh and args values to true (meaning we're defaulting to
     *     processing for both JS and TSH tokens and arguments).
    @param      {String}    src             The JavaScript source to process.
    @param      {String[]}  [separators]    A list of token types such as
                                            'space', 'tab', 'newline', to be
                                            used to split.
    @param      {String[]}  [ops]           An optional array of the operator
                                            strings which should be considered
                                            valid for the source. If this isn't
                                            supplied, the set of JS operators is
                                            assumed.
    @param      {Boolean}   [tsh=false]     True to support extensions specific
                                            to the TIBET Shell (tsh) which
                                            includes ${var} and `cmd` syntax as
                                            well as limited markup processing.
    @param      {Boolean}   [exp=false]     True to signify that the content is
                                            being tokenized for expansion, which
                                            means certain clues for strings and
                                            regular expressions won't be found.
    @param      {Boolean}   [alias=false]   True to signify content is being
                                            tokenized for aliasing purposes.
                                            This causes substitutions to always
                                            terminate an ongoing string or URI.
    @param      {Boolean}   [args=false]    True to signify content is being
                                            tokenized for 'shell arguments'.
     */

    var seps,
        tshell,
        tsargs,
        tokens;

    if (TP.isValid(separators) && !TP.isArray(separators)) {
        return this.raise('InvalidParameter', 'Separators must be an array.');
    }
    seps = TP.notValid(separators) ? ['space', 'tab', 'newline'] : separators;

    tshell = TP.notValid(tsh) ? true : tsh;
    tsargs = TP.notValid(args) ? true : args;

    tokens = TP.$tokenize(src, ops, tshell, exp, alias, tsargs);

    return TP.$tokenizedJoin(tokens, seps);
});

//  ------------------------------------------------------------------------
//  Packing/Condensing
//  ------------------------------------------------------------------------

TP.definePrimitive('$condenseJS',
function(src, newlines, spaces, operators, tokens, nojoin, tsh) {

    /**
    @method     $condenseJS
    @summary    Condenses a string of JavaScript source code using a fairly
                simple tokenizing process to segment the original source and
                then remove comments, extraneous whitespace, and optionally
                remove newlines.
    @param      {String}    src                 The JavaScript source to process.
    @param      {Boolean}   [newlines=false]    True to remove newlines. Default
                                                is false to limit the potential
                                                for introducing bugs, but blank
                                                lines are still removed in all
                                                cases.
    @param      {Boolean}   [spaces=true]       True to remove spaces. Default
                                                is true to create minimal output
                                                size.
    @param      {String[]}  [operators]         An optional array of the
                                                operator strings which should be
                                                considered valid for the source.
                                                If this isn't supplied, the set
                                                of JS operators is assumed.
    @param      {Boolean}   [tokens=false]      True forces tokens back into the
                                                output array rather than values.
    @param      {Boolean}   [nojoin=false]      True turns off join processing
                                                so the result is the processed
                                                token array rather than a
                                                string.
    @param      {Boolean}   [tsh=false]         True if TIBET Shell (TSH)
                                                semantics should be observed.
    @returns    {String|String[]} The condensed source code or token array.
    */

    var arr,
        len,
        i,
        token,
        result,
        last,
        next;

    arr = TP.$tokenize(src, operators, tsh, false, false, true);
    len = arr.length;

    result = [];

    for (i = 0; i < len; i++) {
        token = arr[i];
        switch (token.name) {
            case 'comment':

                //  we remove comments unless they start with /*** so we can
                //  preserve things like copyright notices etc.
                if (token.value.indexOf('/***') === 0) {
                    result.push(tokens ? token : token.value);
                    last = token;
                }
                break;

            case 'newline':

                //  if newlines are defaulted, or set explicitly to false
                //  then we don't remove them...except blank lines
                /* eslint-disable eqeqeq */
                if (newlines == null || newlines === false) {
                /* eslint-enable eqeqeq */
                    if (!last || last.name === 'newline') {
                        continue;
                    }

                    result.push(tokens ? token : token.value);
                    last = token;
                } else {
                    //  although not common in TIBET code (due to our
                    //  coding standard) it's common for people to overlook
                    //  that assigning functions to variables requires a
                    //  trailing semi-colon to ensure proper operation.
                    //  without a full parse we simply avoid removing
                    //  newlines after } in most cases.
                    if (last &&
                        last.name === 'operator' && last.value === '}') {

                        /* eslint-disable no-extra-parens */
                        if ((next = arr[i + 1])) {
                        /* eslint-enable no-extra-parens */
                            //  common syntax where we can be sure that
                            //  removing the newline won't create a bug
                            if (next.value === 'else' ||
                                next.value === 'catch' ||
                                next.value === 'finally' ||
                                next.value === '}' ||
                                next.value === ')') {
                                continue;
                            }
                        }

                        result.push(tokens ? token : token.value);
                        last = token;
                    }
                }

                break;

            case 'tab':     //  fall-through and treat like a space
            case 'space':

                //  if spaces is explicity false then we skip removal
                /* eslint-disable eqeqeq */
                if (spaces != null && spaces === false) {
                /* eslint-enable eqeqeq */
                    result.push(tokens ? token : token.value);
                    last = token;
                    break;
                }

                //  trim leading or repeating sequences of whitespace since
                //  that can't alter semantics while we're preserving at
                //  least one space or tab between other tokens

                /* eslint-disable no-extra-parens */
                if (!last || (last && TP.$is_whitespace(last.name))) {
                /* eslint-enable no-extra-parens */
                    break;
                }

                //  whitespace around operators can also be trimmed...except
                //  when doing so might cause the following token's prefix
                //  to confuse things...as in foo - -bar which transforms
                //  into foo--bar aka foo-- bar (oops).
                next = arr[i + 1];

                /* eslint-disable no-extra-parens */
                if ((last && last.name === 'operator') ||
                    (next && next.name === 'operator')) {
                    //  tsh terminators should preserve space
                    if ((last && TP.boot.$tshOpRegex.test(last.value)) ||
                        (next && TP.boot.$tshOpRegex.test(next.value))) {
                        result.push(tokens ? token : token.value);
                        last = token;
                    }
                /* eslint-enable no-extra-parens */

                    //  other bugs are ++ and -- combinations
                    if (last && next &&
                        (/[-+]$/.test(last.value) &&
                        /^[-+]/.test(next.value))) {
                        result.push(tokens ? token : token.value);
                        last = token;
                    }

                    break;
                }

                result.push(tokens ? token : token.value);
                last = token;
                break;

            default:
                result.push(tokens ? token : token.value);
                last = token;
                break;
        }
    }

    //  not all callers want joined text, some just want the trimmed array
    //  as a precursor to further processing.
    if (nojoin) {
        return result;
    }

    //  join and add a proper final newline as needed (vim-friendly :))
    return result.join('') + (last && last.name !== 'newline' ? '\n' : '');
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_deps/jquery-sizzle-tpi.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
/*!
 * Sizzle CSS Selector Engine
 *  Copyright 2011, The Dojo Foundation
 *  Released under the MIT, BSD, and GPL Licenses.
 *  More information: http://sizzlejs.com/
 */
(function(){

var chunker = /((?:\((?:\([^()]+\)|[^()]+)+\)|\[(?:\[[^\[\]]*\]|['"][^'"]*['"]|[^\[\]'"]+)+\]|\\.|[^ >+~,(\[\\]+)+|[>+~])(\s*,\s*)?((?:.|\r|\n)*)/g,
	done = 0,
	toString = Object.prototype.toString,
	hasDuplicate = false,
	baseHasDuplicate = true,
	rBackslash = /\\/g,
	rNonWord = /\W/;

	toString = Object.prototype.toString;

// Here we check if the JavaScript engine is using some sort of
// optimization where it does not always call our comparision
// function. If that is the case, discard the hasDuplicate value.
//   Thus far that includes Google Chrome.
[0, 0].sort(function(){
	baseHasDuplicate = false;
	return 0;
});

var Sizzle = function(selector, context, results, seed) {
	results = results || [];
	context = context || document;

	var origContext = context;

	if ( context.nodeType !== 1 && context.nodeType !== 9 ) {
		return [];
	}

	if ( !selector || typeof selector !== "string" ) {
		return results;
	}

	var m, set, checkSet, extra, ret, cur, pop, i,
		prune = true,
		contextXML = Sizzle.isXML( context ),
		parts = [],
		soFar = selector;

	// Reset the position of the chunker regexp (start from head)
	do {
		chunker.exec("");
		m = chunker.exec(soFar);

		if ( m ) {
		soFar = m[3];

		parts.push( m[1] );

		if ( m[2] ) {
			extra = m[3];
			break;
		}
	}
	} while ( m );

	if ( parts.length > 1 && origPOS.exec( selector ) ) {

		if ( parts.length === 2 && Expr.relative[ parts[0] ] ) {
			set = posProcess( parts[0] + parts[1], context );

		} else {
			set = Expr.relative[ parts[0] ] ?
				[ context ] :
				Sizzle( parts.shift(), context );

			while ( parts.length ) {
				selector = parts.shift();

				if ( Expr.relative[ selector ] ) {
					selector += parts.shift();
				}

				set = posProcess( selector, set );
			}
		}

	} else {
		// Take a shortcut and set the context if the root selector is an ID
		// (but not if it'll be faster if the inner selector is an ID)
		if ( !seed && parts.length > 1 && context.nodeType === 9 && !contextXML &&
				Expr.match.ID.test(parts[0]) && !Expr.match.ID.test(parts[parts.length - 1]) ) {

			ret = Sizzle.find( parts.shift(), context, contextXML );
			context = ret.expr ?
				Sizzle.filter( ret.expr, ret.set )[0] :
				ret.set[0];
		}

		if ( context ) {
			ret = seed ?
			{ expr: parts.pop(), set: makeArray(seed) } :
				Sizzle.find( parts.pop(), parts.length === 1 && (parts[0] === "~" || parts[0] === "+") && context.parentNode ? context.parentNode : context, contextXML );

			set = ret.expr ?
				Sizzle.filter( ret.expr, ret.set ) :
				ret.set;

		if ( parts.length > 0 ) {
			checkSet = makeArray(set);

		} else {
			prune = false;
		}

		while ( parts.length ) {
				cur = parts.pop();
				pop = cur;

			if ( !Expr.relative[ cur ] ) {
				cur = "";
			} else {
				pop = parts.pop();
			}

			if ( pop == null ) {
				pop = context;
			}

				Expr.relative[ cur ]( checkSet, pop, contextXML );
			}

		} else {
			checkSet = parts = [];
		}
	}

	if ( !checkSet ) {
		checkSet = set;
	}

	if ( !checkSet ) {
		Sizzle.error( cur || selector );
	}

	if ( toString.call(checkSet) === "[object Array]" ) {
		if ( !prune ) {
			results.push.apply( results, checkSet );

		} else if ( context && context.nodeType === 1 ) {
			for ( i = 0; checkSet[i] != null; i++ ) {
				if ( checkSet[i] && (checkSet[i] === true || checkSet[i].nodeType === 1 && Sizzle.contains(context, checkSet[i])) ) {
					results.push( set[i] );
				}
			}

		} else {
			for ( i = 0; checkSet[i] != null; i++ ) {
				if ( checkSet[i] && checkSet[i].nodeType === 1 ) {
					results.push( set[i] );
				}
			}
		}

	} else {
		makeArray( checkSet, results );
	}

	if ( extra ) {
		Sizzle( extra, origContext, results, seed );
		Sizzle.uniqueSort( results );
	}

	return results;
};

Sizzle.uniqueSort = function(results){
		if ( sortOrder ) {
		hasDuplicate = baseHasDuplicate;
			results.sort(sortOrder);

			if ( hasDuplicate ) {
				for ( var i = 1; i < results.length; i++ ) {
					if ( results[i] === results[i-1] ) {
						results.splice(i--, 1);
					}
				}
			}
		}

	return results;
};

Sizzle.matches = function(expr, set){
	return Sizzle(expr, null, null, set);
};

Sizzle.matchesSelector = function( node, expr ) {
	return Sizzle( expr, null, null, [node] ).length > 0;
};

Sizzle.find = function(expr, context, isXML){
	var set;

	if ( !expr ) {
		return [];
	}

	for ( var i = 0, l = Expr.order.length; i < l; i++ ) {
		var match,
			type = Expr.order[i];

		if ( (match = Expr.leftMatch[ type ].exec( expr )) ) {
			var left = match[1];
			match.splice(1,1);

			if ( left.substr( left.length - 1 ) !== "\\" ) {
				match[1] = (match[1] || "").replace( rBackslash, "" );
				set = Expr.find[ type ]( match, context, isXML );

				if ( set != null ) {
					expr = expr.replace( Expr.match[ type ], "" );
					break;
				}
			}
		}
	}

	if ( !set ) {
		set = typeof context.getElementsByTagName !== "undefined" ?
			context.getElementsByTagName( "*" ) :
			[];
	}

	return {set: set, expr: expr};
};

Sizzle.filter = function(expr, set, inplace, not){
	var match, anyFound,
		old = expr,
		result = [],
		curLoop = set,
		isXMLFilter = set && set[0] && Sizzle.isXML(set[0]);

	var type;

	//	---
	//	(wje) patched to use key array for *much* better performance
	//	---
	while ( expr && set.length ) {
		for (var j = 0; j < Expr.filterKeys.length; j++) {
			type = Expr.filterKeys[j];

			if ( (match = Expr.leftMatch[ type ].exec( expr )) != null && match[2] ) {
				var found, item,
					filter = Expr.filter[ type ],
					left = match[1];

				anyFound = false;

				match.splice(1,1);

				if ( left.substr( left.length - 1 ) === "\\" ) {
					continue;
				}

				if ( curLoop === result ) {
					result = [];
				}

				if ( Expr.preFilter[ type ] ) {
					match = Expr.preFilter[ type ]( match, curLoop, inplace, result, not, isXMLFilter );

					if ( !match ) {
						anyFound = found = true;

					} else if ( match === true ) {
						continue;
					}
				}

				if ( match ) {
					for ( var i = 0; (item = curLoop[i]) != null; i++ ) {
						if ( item ) {
							found = filter( item, match, i, curLoop );
							var pass = not ^ !!found;

							if ( inplace && found != null ) {
								if ( pass ) {
									anyFound = true;

								} else {
									curLoop[i] = false;
								}

							} else if ( pass ) {
								result.push( item );
								anyFound = true;
							}
						}
					}
				}

				if ( found !== undefined ) {
					if ( !inplace ) {
						curLoop = result;
					}

					expr = expr.replace( Expr.match[ type ], "" );

					if ( !anyFound ) {
						return [];
					}

					break;
				}
			}
		}

		// Improper expression
		if ( expr === old ) {
			if ( anyFound == null ) {
				Sizzle.error( expr );

			} else {
				break;
			}
		}

		old = expr;
	}

	return curLoop;
};

Sizzle.error = function( msg ) {
	throw "Syntax error, unrecognized expression: " + msg;
};

var Expr = Sizzle.selectors = {
	order: [ "ID", "NAME", "TAG" ],

	//	---
	//	(wje) added this key array for usage below for *much* better performance
	//	---
	matchKeys:['ID','CLASS','NAME','ATTR','TAG','CHILD','POS','PSEUDO'],
	match: {
		ID: /#((?:[\w\u00c0-\uFFFF\-]|\\.)+)/,
		CLASS: /\.((?:[\w\u00c0-\uFFFF\-]|\\.)+)/,
		NAME: /\[name=['"]*((?:[\w\u00c0-\uFFFF\-]|\\.)+)['"]*\]/,
		ATTR: /\[\s*((?:[\w\u00c0-\uFFFF\-]|\\.)+)\s*(?:(\S?=)\s*(?:(['"])(.*?)\3|(#?(?:[\w\u00c0-\uFFFF\-]|\\.)*)|)|)\s*\]/,
		TAG: /^((?:[\w\u00c0-\uFFFF\*\-]|\\.)+)/,
		CHILD: /:(only|nth|last|first)-child(?:\(\s*(even|odd|(?:[+\-]?\d+|(?:[+\-]?\d*)?n\s*(?:[+\-]\s*\d+)?))\s*\))?/,
		POS: /:(nth|eq|gt|lt|first|last|even|odd)(?:\((\d*)\))?(?=[^\-]|$)/,
		PSEUDO: /:((?:[\w\u00c0-\uFFFF\-]|\\.)+)(?:\((['"]?)((?:\([^\)]+\)|[^\(\)]*)+)\2\))?/
	},

	leftMatch: {},

	attrMap: {
		"class": "className",
		"for": "htmlFor"
	},

	attrHandle: {
		href: function(elem){
			return elem.getAttribute("href");
		},
		type: function( elem ) {
			return elem.getAttribute( "type" );
		}
	},

	relative: {
		"+": function(checkSet, part){
			var isPartStr = typeof part === "string",
				isTag = isPartStr && !rNonWord.test( part ),
				isPartStrNotTag = isPartStr && !isTag;

			if ( isTag ) {
				part = part.toLowerCase();
					}

			for ( var i = 0, l = checkSet.length, elem; i < l; i++ ) {
				if ( (elem = checkSet[i]) ) {
					while ( (elem = elem.previousSibling) && elem.nodeType !== 1 ) {}

					checkSet[i] = isPartStrNotTag || elem && elem.nodeName.toLowerCase() === part ?
						elem || false :
						elem === part;
				}
			}

			if ( isPartStrNotTag ) {
				Sizzle.filter( part, checkSet, true );
			}
		},

		">": function(checkSet, part){
			var elem,
				isPartStr = typeof part === "string",
				i = 0,
				l = checkSet.length;

			if ( isPartStr && !rNonWord.test( part ) ) {
				part = part.toLowerCase();

				for ( ; i < l; i++ ) {
					elem = checkSet[i];

					if ( elem ) {
						var parent = elem.parentNode;
						checkSet[i] = parent.nodeName.toLowerCase() === part ? parent : false;
					}
				}

			} else {
				for ( ; i < l; i++ ) {
					elem = checkSet[i];

					if ( elem ) {
						checkSet[i] = isPartStr ?
							elem.parentNode :
							elem.parentNode === part;
					}
				}

				if ( isPartStr ) {
					Sizzle.filter( part, checkSet, true );
				}
			}
		},

		"": function(checkSet, part, isXML){
			var nodeCheck,
				doneName = done++,
				checkFn = dirCheck;

			if ( typeof part === "string" && !rNonWord.test( part ) ) {
				part = part.toLowerCase();
				nodeCheck = part;
				checkFn = dirNodeCheck;
			}

			checkFn("parentNode", part, doneName, checkSet, nodeCheck, isXML);
		},

		"~": function(checkSet, part, isXML){
			var nodeCheck,
				doneName = done++,
				checkFn = dirCheck;

			if ( typeof part === "string" && !rNonWord.test( part ) ) {
				part = part.toLowerCase();
				nodeCheck = part;
				checkFn = dirNodeCheck;
			}

			checkFn("previousSibling", part, doneName, checkSet, nodeCheck, isXML);
		}
	},

	find: {
		ID: function(match, context, isXML){
			if ( typeof context.getElementById !== "undefined" && !isXML ) {
				var m = context.getElementById(match[1]);
				// Check parentNode to catch when Blackberry 4.6 returns
				// nodes that are no longer in the document #6963
				return m && m.parentNode ? [m] : [];
			}
		},

		NAME: function(match, context){
			if ( typeof context.getElementsByName !== "undefined" ) {
				var ret = [],
					results = context.getElementsByName( match[1] );

				for ( var i = 0, l = results.length; i < l; i++ ) {
					if ( results[i].getAttribute("name") === match[1] ) {
						ret.push( results[i] );
					}
				}

				return ret.length === 0 ? null : ret;
			}
		},

		TAG: function(match, context){
			if ( typeof context.getElementsByTagName !== "undefined" ) {
			return context.getElementsByTagName(match[1]);
		}
		}
	},
	preFilter: {
		CLASS: function(match, curLoop, inplace, result, not, isXML){
			match = " " + match[1].replace( rBackslash, "" ) + " ";

			if ( isXML ) {
				return match;
			}

			for ( var i = 0, elem; (elem = curLoop[i]) != null; i++ ) {
				if ( elem ) {
					if ( not ^ (elem.className && (" " + elem.className + " ").replace(/[\t\n\r]/g, " ").indexOf(match) >= 0) ) {
						if ( !inplace ) {
							result.push( elem );
						}

				} else if ( inplace ) {
					curLoop[i] = false;
				}
			}
			}

			return false;
		},

		ID: function(match){
			return match[1].replace( rBackslash, "" );
		},

		TAG: function(match, curLoop){
			return match[1].replace( rBackslash, "" ).toLowerCase();
		},

		CHILD: function(match){
			if ( match[1] === "nth" ) {
				if ( !match[2] ) {
					Sizzle.error( match[0] );
				}

				match[2] = match[2].replace(/^\+|\s*/g, '');

				// parse equations like 'even', 'odd', '5', '2n', '3n+2', '4n-1', '-n+6'
				var test = /(-?)(\d*)(?:n([+\-]?\d*))?/.exec(
					match[2] === "even" && "2n" || match[2] === "odd" && "2n+1" ||
					!/\D/.test( match[2] ) && "0n+" + match[2] || match[2]);

				// calculate the numbers (first)n+(last) including if they are negative
				match[2] = (test[1] + (test[2] || 1)) - 0;
				match[3] = test[3] - 0;
			}
			else if ( match[2] ) {
				Sizzle.error( match[0] );
			}

			// TODO: Move to normal caching system
			match[0] = done++;

			return match;
		},

		ATTR: function(match, curLoop, inplace, result, not, isXML){
			var name = match[1] = match[1].replace( rBackslash, "" );

			if ( !isXML && Expr.attrMap[name] ) {
				match[1] = Expr.attrMap[name];
			}

			// Handle if an un-quoted value was used
			match[4] = ( match[4] || match[5] || "" ).replace( rBackslash, "" );

			if ( match[2] === "~=" ) {
				match[4] = " " + match[4] + " ";
			}

			return match;
		},

		PSEUDO: function(match, curLoop, inplace, result, not){
			if ( match[1] === "not" ) {
				// If we're dealing with a complex expression, or a simple one
				if ( ( chunker.exec(match[3]) || "" ).length > 1 || /^\w/.test(match[3]) ) {
					match[3] = Sizzle(match[3], null, null, curLoop);

				} else {
					var ret = Sizzle.filter(match[3], curLoop, inplace, true ^ not);

					if ( !inplace ) {
						result.push.apply( result, ret );
					}

					return false;
				}

			} else if ( Expr.match.POS.test( match[0] ) || Expr.match.CHILD.test( match[0] ) ) {
				return true;
			}

			return match;
		},

		POS: function(match){
			match.unshift( true );

			return match;
		}
	},

	filters: {
		enabled: function(elem){
			return elem.disabled === false && elem.type !== "hidden";
		},

		disabled: function(elem){
			return elem.disabled === true;
		},

		checked: function(elem){
			return elem.checked === true;
		},

		selected: function(elem){
			// Accessing this property makes selected-by-default
			// options in Safari work properly
			if ( elem.parentNode ) {
			elem.parentNode.selectedIndex;
			}

			return elem.selected === true;
		},

		parent: function(elem){
			return !!elem.firstChild;
		},

		empty: function(elem){
			return !elem.firstChild;
		},

		has: function(elem, i, match){
			return !!Sizzle( match[3], elem ).length;
		},

		header: function(elem){
			return (/h\d/i).test( elem.nodeName );
		},

		text: function(elem){
			var attr = elem.getAttribute( "type" ), type = elem.type;
			// IE6 and 7 will map elem.type to 'text' for new HTML5 types (search, etc)
			// use getAttribute instead to test this case
			return elem.nodeName.toLowerCase() === "input" && "text" === type && ( attr === type || attr === null );
		},

		radio: function(elem){
			return elem.nodeName.toLowerCase() === "input" && "radio" === elem.type;
		},

		checkbox: function(elem){
			return elem.nodeName.toLowerCase() === "input" && "checkbox" === elem.type;
		},

		file: function(elem){
			return elem.nodeName.toLowerCase() === "input" && "file" === elem.type;
		},

		password: function(elem){
			return elem.nodeName.toLowerCase() === "input" && "password" === elem.type;
		},

		submit: function(elem){
			var name = elem.nodeName.toLowerCase();
			return (name === "input" || name === "button") && "submit" === elem.type;
		},

		image: function(elem){
			return elem.nodeName.toLowerCase() === "input" && "image" === elem.type;
		},

		reset: function(elem){
			var name = elem.nodeName.toLowerCase();
			return (name === "input" || name === "button") && "reset" === elem.type;
		},

		button: function(elem){
			var name = elem.nodeName.toLowerCase();
			return name === "input" && "button" === elem.type || name === "button";
		},

		input: function(elem){
			return (/input|select|textarea|button/i).test(elem.nodeName);
		},

		focus: function( elem ) {
			return elem === elem.ownerDocument.activeElement;
		}
	},
	setFilters: {
		first: function(elem, i){
			return i === 0;
		},

		last: function(elem, i, match, array){
			return i === array.length - 1;
		},

		even: function(elem, i){
			return i % 2 === 0;
		},

		odd: function(elem, i){
			return i % 2 === 1;
		},

		lt: function(elem, i, match){
			return i < match[3] - 0;
		},

		gt: function(elem, i, match){
			return i > match[3] - 0;
		},

		nth: function(elem, i, match){
			return match[3] - 0 === i;
		},

		eq: function(elem, i, match){
			return match[3] - 0 === i;
		}
	},
	//	---
	//	(wje) added this key array for usage above for *much* better performance
	//	---
	filterKeys:['PSEUDO','CHILD','ID','TAG','CLASS','ATTR','POS'],
	filter: {
		PSEUDO: function(elem, match, i, array){
			var name = match[1],
				filter = Expr.filters[ name ];

			if ( filter ) {
				return filter( elem, i, match, array );

			} else if ( name === "contains" ) {
				return (elem.textContent || elem.innerText || Sizzle.getText([ elem ]) || "").indexOf(match[3]) >= 0;

			} else if ( name === "not" ) {
				var not = match[3];

				for ( var j = 0, l = not.length; j < l; j++ ) {
					if ( not[j] === elem ) {
						return false;
					}
				}

				return true;

			} else {
				Sizzle.error( name );
			}
		},

		CHILD: function(elem, match){
			var type = match[1],
				node = elem;

			switch (type) {
				case "only":
				case "first":
					while ( (node = node.previousSibling) )  {
						if ( node.nodeType === 1 ) {
							return false;
						}
					}

					if ( type === "first" ) {
						return true;
					}

					node = elem;

				case "last":
					while ( (node = node.nextSibling) )  {
						if ( node.nodeType === 1 ) {
							return false;
						}
					}

					return true;

				case "nth":
					var first = match[2],
						last = match[3];

					if ( first === 1 && last === 0 ) {
						return true;
					}

					var doneName = match[0],
						parent = elem.parentNode;

					if ( parent && (parent.sizcache !== doneName || !elem.nodeIndex) ) {
						var count = 0;

						for ( node = parent.firstChild; node; node = node.nextSibling ) {
							if ( node.nodeType === 1 ) {
								node.nodeIndex = ++count;
							}
						}

						parent.sizcache = doneName;
					}

					var diff = elem.nodeIndex - last;

					if ( first === 0 ) {
						return diff === 0;

					} else {
						return ( diff % first === 0 && diff / first >= 0 );
					}
			}
		},

		ID: function(elem, match){
			return elem.nodeType === 1 && elem.getAttribute("id") === match;
		},

		TAG: function(elem, match){
			return (match === "*" && elem.nodeType === 1) || elem.nodeName.toLowerCase() === match;
		},

		CLASS: function(elem, match){
			return (" " + (elem.className || elem.getAttribute("class")) + " ")
				.indexOf( match ) > -1;
		},

		ATTR: function(elem, match){
			var name = match[1],
				result = Expr.attrHandle[ name ] ?
					Expr.attrHandle[ name ]( elem ) :
					elem[ name ] != null ?
						elem[ name ] :
						//	---
						//	(wje) patched to strip backslashes so that we
						//	can use constructs like colons (':') in
						//	attribute names (which need to be backslashed
						//	for other parts of the machinery here).
						//	---
						elem.getAttribute( name.replace(/\\/g, '') ),
				value = result + "",
				type = match[2],
				check = match[4];

			return result == null ?
				type === "!=" :
				type === "=" ?
				value === check :
				type === "*=" ?
				value.indexOf(check) >= 0 :
				type === "~=" ?
				(" " + value + " ").indexOf(check) >= 0 :
				!check ?
				value && result !== false :
				type === "!=" ?
				value !== check :
				type === "^=" ?
				value.indexOf(check) === 0 :
				type === "$=" ?
				value.substr(value.length - check.length) === check :
				type === "|=" ?
				value === check || value.substr(0, check.length + 1) === check + "-" :
				false;
		},

		POS: function(elem, match, i, array){
			var name = match[2],
				filter = Expr.setFilters[ name ];

			if ( filter ) {
				return filter( elem, i, match, array );
			}
		}
	}
};

var origPOS = Expr.match.POS,
	fescape = function(all, num){
		return "\\" + (num - 0 + 1);
	};

//	---
//	(wje) patched to use key array for *much* better performance
//	---

for (var i = 0; i < Expr.matchKeys.length; i++) {
	var type = Expr.matchKeys[i];

	Expr.match[ type ] = new RegExp( Expr.match[ type ].source + (/(?![^\[]*\])(?![^\(]*\))/.source) );
	Expr.leftMatch[ type ] = new RegExp( /(^(?:.|\r|\n)*?)/.source + Expr.match[ type ].source.replace(/\\(\d+)/g, fescape) );
}

var makeArray = function(array, results) {
	array = Array.prototype.slice.call( array, 0 );

	if ( results ) {
		results.push.apply( results, array );
		return results;
	}

	return array;
};

// Perform a simple check to determine if the browser is capable of
// converting a NodeList to an array using builtin methods.
// Also verifies that the returned array holds DOM nodes
// (which is not the case in the Blackberry browser)
try {
	Array.prototype.slice.call( document.documentElement.childNodes, 0 )[0].nodeType;

// Provide a fallback method if it does not work
} catch(e){
	makeArray = function(array, results) {
		var i = 0,
			ret = results || [];

		if ( toString.call(array) === "[object Array]" ) {
			Array.prototype.push.apply( ret, array );

		} else {
			if ( typeof array.length === "number" ) {
				for ( var l = array.length; i < l; i++ ) {
					ret.push( array[i] );
				}

			} else {
				for ( ; array[i]; i++ ) {
					ret.push( array[i] );
				}
			}
		}

		return ret;
	};
}

var sortOrder, siblingCheck;

if ( document.documentElement.compareDocumentPosition ) {
	sortOrder = function( a, b ) {
		if ( a === b ) {
				hasDuplicate = true;
			return 0;
			}

		if ( !a.compareDocumentPosition || !b.compareDocumentPosition ) {
			return a.compareDocumentPosition ? -1 : 1;
		}

		return a.compareDocumentPosition(b) & 4 ? -1 : 1;
	};

} else {
	sortOrder = function( a, b ) {
		// The nodes are identical, we can exit early
		if ( a === b ) {
				hasDuplicate = true;
			return 0;

		// Fallback to using sourceIndex (in IE) if it's available on both nodes
		} else if ( a.sourceIndex && b.sourceIndex ) {
			return a.sourceIndex - b.sourceIndex;
		}

		var al, bl,
			ap = [],
			bp = [],
			aup = a.parentNode,
			bup = b.parentNode,
			cur = aup;

		// If the nodes are siblings (or identical) we can do a quick check
		if ( aup === bup ) {
			return siblingCheck( a, b );

		// If no parents were found then the nodes are disconnected
		} else if ( !aup ) {
			return -1;

		} else if ( !bup ) {
			return 1;
			}

		// Otherwise they're somewhere else in the tree so we need
		// to build up a full list of the parentNodes for comparison
		while ( cur ) {
			ap.unshift( cur );
			cur = cur.parentNode;
		}

		cur = bup;

		while ( cur ) {
			bp.unshift( cur );
			cur = cur.parentNode;
		}

		al = ap.length;
		bl = bp.length;

		// Start walking down the tree looking for a discrepancy
		for ( var i = 0; i < al && i < bl; i++ ) {
			if ( ap[i] !== bp[i] ) {
				return siblingCheck( ap[i], bp[i] );
			}
		}

		// We ended someplace up the tree so do a sibling check
		return i === al ?
			siblingCheck( a, bp[i], -1 ) :
			siblingCheck( ap[i], b, 1 );
	};

	siblingCheck = function( a, b, ret ) {
		if ( a === b ) {
			return ret;
			}

		var cur = a.nextSibling;

		while ( cur ) {
			if ( cur === b ) {
				return -1;
		}

			cur = cur.nextSibling;
		}

		return 1;
	};
}

// Utility function for retreiving the text value of an array of DOM nodes
Sizzle.getText = function( elems ) {
	var ret = "", elem;

	for ( var i = 0; elems[i]; i++ ) {
		elem = elems[i];

		// Get the text from text nodes and CDATA nodes
		if ( elem.nodeType === 3 || elem.nodeType === 4 ) {
			ret += elem.nodeValue;

		// Traverse everything else, except comment nodes
		} else if ( elem.nodeType !== 8 ) {
			ret += Sizzle.getText( elem.childNodes );
		}
	}

	return ret;
};

// Check to see if the browser returns elements by name when
// querying by getElementById (and provide a workaround)
(function(){
	// We're going to inject a fake input element with a specified name
	var form = document.createElement("div"),
		id = "script" + (new Date()).getTime(),
		root = document.documentElement;

	form.innerHTML = "<a name='" + id + "'/>";

	// Inject it into the root element, check its status, and remove it quickly
	root.insertBefore( form, root.firstChild );

	// The workaround has to do additional checks after a getElementById
	// Which slows things down for other browsers (hence the branching)
	if ( document.getElementById( id ) ) {
		Expr.find.ID = function(match, context, isXML){
			if ( typeof context.getElementById !== "undefined" && !isXML ) {
				var m = context.getElementById(match[1]);

				return m ?
					m.id === match[1] || typeof m.getAttributeNode !== "undefined" && m.getAttributeNode("id").nodeValue === match[1] ?
						[m] :
						undefined :
					[];
			}
		};

		Expr.filter.ID = function(elem, match){
			var node = typeof elem.getAttributeNode !== "undefined" && elem.getAttributeNode("id");

			return elem.nodeType === 1 && node && node.nodeValue === match;
		};
	}

	root.removeChild( form );

	// release memory in IE
	root = form = null;
})();

(function(){
// Check to see if the browser returns only elements
// when doing getElementsByTagName("*")

	// Create a fake element
	var div = document.createElement("div");
	div.appendChild( document.createComment("") );

	// Make sure no comments are found
	if ( div.getElementsByTagName("*").length > 0 ) {
		Expr.find.TAG = function(match, context){
			var results = context.getElementsByTagName(match[1]);

			// Filter out possible comments
			if ( match[1] === "*" ) {
				var tmp = [];

				for ( var i = 0; results[i]; i++ ) {
					if ( results[i].nodeType === 1 ) {
						tmp.push( results[i] );
					}
				}

				results = tmp;
			}

			return results;
		};
	}

	// Check to see if an attribute returns normalized href attributes
	div.innerHTML = "<a href='#'></a>";

	if ( div.firstChild && typeof div.firstChild.getAttribute !== "undefined" &&
			div.firstChild.getAttribute("href") !== "#" ) {

		Expr.attrHandle.href = function(elem){
			return elem.getAttribute("href", 2);
		};
	}

	// release memory in IE
	div = null;
})();

if ( document.querySelectorAll ) {
	(function(){
		var oldSizzle = Sizzle,
			div = document.createElement("div"),
			id = "__sizzle__";

	div.innerHTML = "<p class='TEST'></p>";

	// Safari can't handle uppercase or unicode characters when
	// in quirks mode.
	if ( div.querySelectorAll && div.querySelectorAll(".TEST").length === 0 ) {
		return;
	}

	Sizzle = function(query, context, extra, seed){
		context = context || document;

		// Only use querySelectorAll on non-XML documents
		// (ID selectors don't work in non-HTML documents)
			if ( !seed && !Sizzle.isXML(context) ) {
				// See if we find a selector to speed up
				var match = /^(\w+$)|^\.([\w\-]+$)|^#([\w\-]+$)/.exec( query );

				if ( match && (context.nodeType === 1 || context.nodeType === 9) ) {
					// Speed-up: Sizzle("TAG")
					if ( match[1] ) {
						return makeArray( context.getElementsByTagName( query ), extra );

					// Speed-up: Sizzle(".CLASS")
					} else if ( match[2] && Expr.find.CLASS && context.getElementsByClassName ) {
						return makeArray( context.getElementsByClassName( match[2] ), extra );
					}
				}

				if ( context.nodeType === 9 ) {
					// Speed-up: Sizzle("body")
					// The body element only exists once, optimize finding it
					if ( query === "body" && context.body ) {
						return makeArray( [ context.body ], extra );

					// Speed-up: Sizzle("#ID")
					} else if ( match && match[3] ) {
						var elem = context.getElementById( match[3] );

						// Check parentNode to catch when Blackberry 4.6 returns
						// nodes that are no longer in the document #6963
						if ( elem && elem.parentNode ) {
							// Handle the case where IE and Opera return items
							// by name instead of ID
							if ( elem.id === match[3] ) {
								return makeArray( [ elem ], extra );
							}

						} else {
							return makeArray( [], extra );
						}
					}

			try {
				return makeArray( context.querySelectorAll(query), extra );
					} catch(qsaError) {}

				// qSA works strangely on Element-rooted queries
				// We can work around this by specifying an extra ID on the root
				// and working up from there (Thanks to Andrew Dupont for the technique)
				// IE 8 doesn't work on object elements
				} else if ( context.nodeType === 1 && context.nodeName.toLowerCase() !== "object" ) {
					var oldContext = context,
						old = context.getAttribute( "id" ),
						nid = old || id,
						hasParent = context.parentNode,
						relativeHierarchySelector = /^\s*[+~]/.test( query );

					if ( !old ) {
						context.setAttribute( "id", nid );
					} else {
						nid = nid.replace( /'/g, "\\$&" );
					}
					if ( relativeHierarchySelector && hasParent ) {
						context = context.parentNode;
					}

					try {
						if ( !relativeHierarchySelector || hasParent ) {
							return makeArray( context.querySelectorAll( "[id='" + nid + "'] " + query ), extra );
						}

					} catch(pseudoError) {
					} finally {
						if ( !old ) {
							oldContext.removeAttribute( "id" );
						}
					}
				}
		}

		return oldSizzle(query, context, extra, seed);
	};

	for ( var prop in oldSizzle ) {
			//	---
			//	(wje) patched to skip tibet internals and metainst slots
			if (TP.regex.INTERNAL_SLOT.test(prop) ||
				!oldSizzle.hasOwnProperty(prop)) continue;
			//	---

			Sizzle[ prop ] = oldSizzle[ prop ];
		}

		// release memory in IE
		div = null;
	})();
}

(function(){
	var html = document.documentElement,
		matches = html.matchesSelector || html.mozMatchesSelector || html.webkitMatchesSelector || html.msMatchesSelector;

	if ( matches ) {
		// Check to see if it's possible to do matchesSelector
		// on a disconnected node (IE 9 fails this)
		var disconnectedMatch = !matches.call( document.createElement( "div" ), "div" ),
			pseudoWorks = false;

		try {
			// This should fail with an exception
			// Gecko does not error, returns false instead
			matches.call( document.documentElement, "[test!='']:sizzle" );

		} catch( pseudoError ) {
			pseudoWorks = true;
		}

		Sizzle.matchesSelector = function( node, expr ) {
			// Make sure that attribute selectors are quoted
			expr = expr.replace(/\=\s*([^'"\]]*)\s*\]/g, "='$1']");

			if ( !Sizzle.isXML( node ) ) {
				try {
					if ( pseudoWorks || !Expr.match.PSEUDO.test( expr ) && !/!=/.test( expr ) ) {
						var ret = matches.call( node, expr );

						// IE 9's matchesSelector returns false on disconnected nodes
						if ( ret || !disconnectedMatch ||
								// As well, disconnected nodes are said to be in a document
								// fragment in IE 9, so check for that
								node.document && node.document.nodeType !== 11 ) {
							return ret;
						}
					}
				} catch(e) {}
	}

			return Sizzle(expr, null, null, [node]).length > 0;
		};
	}
})();

(function(){
	var div = document.createElement("div");

	div.innerHTML = "<div class='test e'></div><div class='test'></div>";

	// Opera can't find a second classname (in 9.6)
	// Also, make sure that getElementsByClassName actually exists
	if ( !div.getElementsByClassName || div.getElementsByClassName("e").length === 0 ) {
		return;
	}

	// Safari caches class attributes, doesn't catch changes (in 3.2)
	div.lastChild.className = "e";

	if ( div.getElementsByClassName("e").length === 1 ) {
		return;
	}

	Expr.order.splice(1, 0, "CLASS");
	Expr.find.CLASS = function(match, context, isXML) {
		if ( typeof context.getElementsByClassName !== "undefined" && !isXML ) {
		return context.getElementsByClassName(match[1]);
		}
	};

	// release memory in IE
	div = null;
})();

function dirNodeCheck( dir, cur, doneName, checkSet, nodeCheck, isXML ) {
	for ( var i = 0, l = checkSet.length; i < l; i++ ) {
		var elem = checkSet[i];

		if ( elem ) {
			var match = false;

			elem = elem[dir];

			while ( elem ) {
				if ( elem.sizcache === doneName ) {
					match = checkSet[elem.sizset];
					break;
				}

				if ( elem.nodeType === 1 && !isXML ){
					elem.sizcache = doneName;
					elem.sizset = i;
				}

				if ( elem.nodeName.toLowerCase() === cur ) {
					match = elem;
					break;
				}

				elem = elem[dir];
			}

			checkSet[i] = match;
		}
	}
}

function dirCheck( dir, cur, doneName, checkSet, nodeCheck, isXML ) {
	for ( var i = 0, l = checkSet.length; i < l; i++ ) {
		var elem = checkSet[i];

		if ( elem ) {
			var match = false;

			elem = elem[dir];

			while ( elem ) {
				if ( elem.sizcache === doneName ) {
					match = checkSet[elem.sizset];
					break;
				}

				if ( elem.nodeType === 1 ) {
					if ( !isXML ) {
						elem.sizcache = doneName;
						elem.sizset = i;
					}

					if ( typeof cur !== "string" ) {
						if ( elem === cur ) {
							match = true;
							break;
						}

					} else if ( Sizzle.filter( cur, [elem] ).length > 0 ) {
						match = elem;
						break;
					}
				}

				elem = elem[dir];
			}

			checkSet[i] = match;
		}
	}
}

if ( document.documentElement.contains ) {
	Sizzle.contains = function( a, b ) {
		return a !== b && (a.contains ? a.contains(b) : true);
	};

} else if ( document.documentElement.compareDocumentPosition ) {
	Sizzle.contains = function( a, b ) {
	return !!(a.compareDocumentPosition(b) & 16);
};

} else {
	Sizzle.contains = function() {
		return false;
	};
}

Sizzle.isXML = function(elem){
	// documentElement is verified for cases where it doesn't yet exist
	// (such as loading iframes in IE - #4833)
	var documentElement = (elem ? elem.ownerDocument || elem : 0).documentElement;

	return documentElement ? documentElement.nodeName !== "HTML" : false;
};

var posProcess = function(selector, context){
	var match,
		tmpSet = [],
		later = "",
		root = context.nodeType ? [context] : context;

	// Position selectors must be done after the filter
	// And so must :not(positional) so we move all PSEUDOs to the end
	while ( (match = Expr.match.PSEUDO.exec( selector )) ) {
		later += match[0];
		selector = selector.replace( Expr.match.PSEUDO, "" );
	}

	selector = Expr.relative[selector] ? selector + "*" : selector;

	for ( var i = 0, l = root.length; i < l; i++ ) {
		Sizzle( selector, root[i], tmpSet );
	}

	return Sizzle.filter( later, tmpSet );
};

// EXPOSE

window.Sizzle = Sizzle;

})();
TP.boot.$$srcPath = '';

        
        TP.registerExternalObject('Sizzle', window.Sizzle);
        
    
TP.boot.$$srcPath = '~lib_deps/jquery-jquery-tpi.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//	========================================================================
//  jQuery (needed to allow extension by jquery.xmlns.js 'CSS3 Namespaces')
//	========================================================================

var jQuery = (function() {

// Define a local copy of jQuery
var jQuery = function( selector, context ) {
		// The jQuery object is actually just the init constructor 'enhanced'
		return new jQuery.fn.init( selector, context, rootjQuery );
	},

	// Map over jQuery in case of overwrite
	_jQuery = window.jQuery,

	// Map over the $ in case of overwrite
	_$ = window.$,

	// A central reference to the root jQuery(document)
	rootjQuery,

	// A simple way to check for HTML strings or ID strings
	// (both of which we optimize for)
	quickExpr = /^(?:[^<]*(<[\w\W]+>)[^>]*$|#([\w\-]*)$)/,

	// Check if a string has a non-whitespace character in it
	rnotwhite = /\S/,

	// Used for trimming whitespace
	trimLeft = /^\s+/,
	trimRight = /\s+$/,

	// Check for digits
	rdigit = /\d/,

	// Match a standalone tag
	rsingleTag = /^<(\w+)\s*\/?>(?:<\/\1>)?$/,

	// JSON RegExp
	rvalidchars = /^[\],:{}\s]*$/,
	rvalidescape = /\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,
	rvalidtokens = /"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,
	rvalidbraces = /(?:^|:|,)(?:\s*\[)+/g,

	// Useragent RegExp
	rwebkit = /(webkit)[ \/]([\w.]+)/,
	ropera = /(opera)(?:.*version)?[ \/]([\w.]+)/,
	rmsie = /(msie) ([\w.]+)/,
	rmozilla = /(mozilla)(?:.*? rv:([\w.]+))?/,

	// Matches dashed string for camelizing
	rdashAlpha = /-([a-z])/ig,

	// Used by jQuery.camelCase as callback to replace()
	fcamelCase = function( all, letter ) {
		return letter.toUpperCase();
	},

	// Keep a UserAgent string for use with jQuery.browser
	userAgent = navigator.userAgent,

	// For matching the engine and version of the browser
	browserMatch,

	// The deferred used on DOM ready
	readyList,

	// The ready event handler
	DOMContentLoaded,

	// Save a reference to some core methods
	toString = Object.prototype.toString,
	hasOwn = Object.prototype.hasOwnProperty,
	push = Array.prototype.push,
	slice = Array.prototype.slice,
	trim = String.prototype.trim,
	indexOf = Array.prototype.indexOf,

	// [[Class]] -> type pairs
	class2type = {};

jQuery.fn = jQuery.prototype = {
	constructor: jQuery,
	init: function( selector, context, rootjQuery ) {
		var match, elem, ret, doc;

		// Handle $(""), $(null), or $(undefined)
		if ( !selector ) {
			return this;
		}

		// Handle $(DOMElement)
		if ( selector.nodeType ) {
			this.context = this[0] = selector;
			this.length = 1;
			return this;
		}

		// The body element only exists once, optimize finding it
		if ( selector === "body" && !context && document.body ) {
			this.context = document;
			this[0] = document.body;
			this.selector = selector;
			this.length = 1;
			return this;
		}

		// Handle HTML strings
		if ( typeof selector === "string" ) {
			// Are we dealing with HTML string or an ID?
			if ( selector.charAt(0) === "<" && selector.charAt( selector.length - 1 ) === ">" && selector.length >= 3 ) {
				// Assume that strings that start and end with <> are HTML and skip the regex check
				match = [ null, selector, null ];

			} else {
				match = quickExpr.exec( selector );
			}

			// Verify a match, and that no context was specified for #id
			if ( match && (match[1] || !context) ) {

				// HANDLE: $(html) -> $(array)
				if ( match[1] ) {
					context = context instanceof jQuery ? context[0] : context;
					doc = (context ? context.ownerDocument || context : document);

					// If a single string is passed in and it's a single tag
					// just do a createElement and skip the rest
					ret = rsingleTag.exec( selector );

					if ( ret ) {
						if ( jQuery.isPlainObject( context ) ) {
							selector = [ document.createElement( ret[1] ) ];
							jQuery.fn.attr.call( selector, context, true );

						} else {
							selector = [ doc.createElement( ret[1] ) ];
						}

					} else {
						ret = jQuery.buildFragment( [ match[1] ], [ doc ] );
						selector = (ret.cacheable ? jQuery.clone(ret.fragment) : ret.fragment).childNodes;
					}

					return jQuery.merge( this, selector );

				// HANDLE: $("#id")
				} else {
					elem = document.getElementById( match[2] );

					// Check parentNode to catch when Blackberry 4.6 returns
					// nodes that are no longer in the document #6963
					if ( elem && elem.parentNode ) {
						// Handle the case where IE and Opera return items
						// by name instead of ID
						if ( elem.id !== match[2] ) {
							return rootjQuery.find( selector );
						}

						// Otherwise, we inject the element directly into the jQuery object
						this.length = 1;
						this[0] = elem;
					}

					this.context = document;
					this.selector = selector;
					return this;
				}

			// HANDLE: $(expr, $(...))
			} else if ( !context || context.jquery ) {
				return (context || rootjQuery).find( selector );

			// HANDLE: $(expr, context)
			// (which is just equivalent to: $(context).find(expr)
			} else {
				return this.constructor( context ).find( selector );
			}

		// HANDLE: $(function)
		// Shortcut for document ready
		} else if ( jQuery.isFunction( selector ) ) {
			return rootjQuery.ready( selector );
		}

		if (selector.selector !== undefined) {
			this.selector = selector.selector;
			this.context = selector.context;
		}

		return jQuery.makeArray( selector, this );
	},

	// Start with an empty selector
	selector: "",

	// The current version of jQuery being used
	jquery: "@VERSION",

	// The default length of a jQuery object is 0
	length: 0,

	// The number of elements contained in the matched element set
	size: function() {
		return this.length;
	},

	toArray: function() {
		return slice.call( this, 0 );
	},

	// Get the Nth element in the matched element set OR
	// Get the whole matched element set as a clean array
	get: function( num ) {
		return num == null ?

			// Return a 'clean' array
			this.toArray() :

			// Return just the object
			( num < 0 ? this[ this.length + num ] : this[ num ] );
	},

	// Take an array of elements and push it onto the stack
	// (returning the new matched element set)
	pushStack: function( elems, name, selector ) {
		// Build a new jQuery matched element set
		var ret = this.constructor();

		if ( jQuery.isArray( elems ) ) {
			push.apply( ret, elems );

		} else {
			jQuery.merge( ret, elems );
		}

		// Add the old object onto the stack (as a reference)
		ret.prevObject = this;

		ret.context = this.context;

		if ( name === "find" ) {
			ret.selector = this.selector + (this.selector ? " " : "") + selector;
		} else if ( name ) {
			ret.selector = this.selector + "." + name + "(" + selector + ")";
		}

		// Return the newly-formed element set
		return ret;
	},

	// Execute a callback for every element in the matched set.
	// (You can seed the arguments with an array of args, but this is
	// only used internally.)
	each: function( callback, args ) {
		return jQuery.each( this, callback, args );
	},

	ready: function( fn ) {
		// Attach the listeners
		jQuery.bindReady();

		// Add the callback
		readyList.done( fn );

		return this;
	},

	eq: function( i ) {
		return i === -1 ?
			this.slice( i ) :
			this.slice( i, +i + 1 );
	},

	first: function() {
		return this.eq( 0 );
	},

	last: function() {
		return this.eq( -1 );
	},

	slice: function() {
		return this.pushStack( slice.apply( this, arguments ),
			"slice", slice.call(arguments).join(",") );
	},

	map: function( callback ) {
		return this.pushStack( jQuery.map(this, function( elem, i ) {
			return callback.call( elem, i, elem );
		}));
	},

	end: function() {
		return this.prevObject || this.constructor(null);
	},

	// For internal use only.
	// Behaves like an Array's method, not like a jQuery method.
	push: push,
	sort: [].sort,
	splice: [].splice
};

// Give the init function the jQuery prototype for later instantiation
jQuery.fn.init.prototype = jQuery.fn;

jQuery.extend = jQuery.fn.extend = function() {
	var options, name, src, copy, copyIsArray, clone,
		target = arguments[0] || {},
		i = 1,
		length = arguments.length,
		deep = false;

	// Handle a deep copy situation
	if ( typeof target === "boolean" ) {
		deep = target;
		target = arguments[1] || {};
		// skip the boolean and the target
		i = 2;
	}

	// Handle case when target is a string or something (possible in deep copy)
	if ( typeof target !== "object" && !jQuery.isFunction(target) ) {
		target = {};
	}

	// extend jQuery itself if only one argument is passed
	if ( length === i ) {
		target = this;
		--i;
	}

	for ( ; i < length; i++ ) {
		// Only deal with non-null/undefined values
		if ( (options = arguments[ i ]) != null ) {
			// Extend the base object
			for ( name in options ) {
				src = target[ name ];
				copy = options[ name ];

				// Prevent never-ending loop
				if ( target === copy ) {
					continue;
				}

				// Recurse if we're merging plain objects or arrays
				if ( deep && copy && ( jQuery.isPlainObject(copy) || (copyIsArray = jQuery.isArray(copy)) ) ) {
					if ( copyIsArray ) {
						copyIsArray = false;
						clone = src && jQuery.isArray(src) ? src : [];

					} else {
						clone = src && jQuery.isPlainObject(src) ? src : {};
					}

					// Never move original objects, clone them
					target[ name ] = jQuery.extend( deep, clone, copy );

				// Don't bring in undefined values
				} else if ( copy !== undefined ) {
					target[ name ] = copy;
				}
			}
		}
	}

	// Return the modified object
	return target;
};

jQuery.extend({
	noConflict: function( deep ) {
		if ( window.$ === jQuery ) {
			window.$ = _$;
		}

		if ( deep && window.jQuery === jQuery ) {
			window.jQuery = _jQuery;
		}

		return jQuery;
	},

	// Is the DOM ready to be used? Set to true once it occurs.
	isReady: false,

	// A counter to track how many items to wait for before
	// the ready event fires. See #6781
	readyWait: 1,

	// Hold (or release) the ready event
	holdReady: function( hold ) {
		if ( hold ) {
			jQuery.readyWait++;
		} else {
			jQuery.ready( true );
		}
	},

	// Handle when the DOM is ready
	ready: function( wait ) {
		// Either a released hold or an DOMready/load event and not yet ready
		if ( (wait === true && !--jQuery.readyWait) || (wait !== true && !jQuery.isReady) ) {
			// Make sure body exists, at least, in case IE gets a little overzealous (ticket #5443).
			if ( !document.body ) {
				return setTimeout( jQuery.ready, 1 );
			}

			// Remember that the DOM is ready
			jQuery.isReady = true;

			// If a normal DOM Ready event fired, decrement, and wait if need be
			if ( wait !== true && --jQuery.readyWait > 0 ) {
				return;
			}

			// If there are functions bound, to execute
			readyList.resolveWith( document, [ jQuery ] );

			// Trigger any bound ready events
			if ( jQuery.fn.trigger ) {
				jQuery( document ).trigger( "ready" ).unbind( "ready" );
			}
		}
	},

	bindReady: function() {
		if ( readyList ) {
			return;
		}

		readyList = jQuery._Deferred();

		// Catch cases where $(document).ready() is called after the
		// browser event has already occurred.
		if ( document.readyState === "complete" ) {
			// Handle it asynchronously to allow scripts the opportunity to delay ready
			return setTimeout( jQuery.ready, 1 );
		}

		// Mozilla, Opera and webkit nightlies currently support this event
		if ( document.addEventListener ) {
			// Use the handy event callback
			document.addEventListener( "DOMContentLoaded", DOMContentLoaded, false );

			// A fallback to window.onload, that will always work
			window.addEventListener( "load", jQuery.ready, false );

		// If IE event model is used
		} else if ( document.attachEvent ) {
			// ensure firing before onload,
			// maybe late but safe also for iframes
			document.attachEvent( "onreadystatechange", DOMContentLoaded );

			// A fallback to window.onload, that will always work
			window.attachEvent( "onload", jQuery.ready );

			// If IE and not a frame
			// continually check to see if the document is ready
			var toplevel = false;

			try {
				toplevel = window.frameElement == null;
			} catch(e) {}

			if ( document.documentElement.doScroll && toplevel ) {
				doScrollCheck();
			}
		}
	},

	// See test/unit/core.js for details concerning isFunction.
	// Since version 1.3, DOM methods and functions like alert
	// aren't supported. They return false on IE (#2968).
	isFunction: function( obj ) {
		return jQuery.type(obj) === "function";
	},

	isArray: Array.isArray || function( obj ) {
		return jQuery.type(obj) === "array";
	},

	// A crude way of determining if an object is a window
	isWindow: function( obj ) {
		return obj && typeof obj === "object" && "setInterval" in obj;
	},

	isNaN: function( obj ) {
		return obj == null || !rdigit.test( obj ) || isNaN( obj );
	},

	type: function( obj ) {
		return obj == null ?
			String( obj ) :
			class2type[ toString.call(obj) ] || "object";
	},

	isPlainObject: function( obj ) {
		// Must be an Object.
		// Because of IE, we also have to check the presence of the constructor property.
		// Make sure that DOM nodes and window objects don't pass through, as well
		if ( !obj || jQuery.type(obj) !== "object" || obj.nodeType || jQuery.isWindow( obj ) ) {
			return false;
		}

		// Not own constructor property must be Object
		if ( obj.constructor &&
			!hasOwn.call(obj, "constructor") &&
			!hasOwn.call(obj.constructor.prototype, "isPrototypeOf") ) {
			return false;
		}

		// Own properties are enumerated firstly, so to speed up,
		// if last one is own, then all properties are own.

		var key;
		for ( key in obj ) {}

		return key === undefined || hasOwn.call( obj, key );
	},

	isEmptyObject: function( obj ) {
		for ( var name in obj ) {
			return false;
		}
		return true;
	},

	error: function( msg ) {
		throw msg;
	},

	parseJSON: function( data ) {
		if ( typeof data !== "string" || !data ) {
			return null;
		}

		// Make sure leading/trailing whitespace is removed (IE can't handle it)
		data = jQuery.trim( data );

		// Attempt to parse using the native JSON parser first
		if ( window.JSON && window.JSON.parse ) {
			return window.JSON.parse( data );
		}

		// Make sure the incoming data is actual JSON
		// Logic borrowed from http://json.org/json2.js
		if ( rvalidchars.test( data.replace( rvalidescape, "@" )
			.replace( rvalidtokens, "]" )
			.replace( rvalidbraces, "")) ) {

			return (new Function( "return " + data ))();

		}
		jQuery.error( "Invalid JSON: " + data );
	},

	// Cross-browser xml parsing
	// (xml & tmp used internally)
	parseXML: function( data , xml , tmp ) {

		if ( window.DOMParser ) { // Standard
			tmp = new DOMParser();
			xml = tmp.parseFromString( data , "text/xml" );
		} else { // IE
			xml = new ActiveXObject( "Microsoft.XMLDOM" );
			xml.async = "false";
			xml.loadXML( data );
		}

		tmp = xml.documentElement;

		if ( ! tmp || ! tmp.nodeName || tmp.nodeName === "parsererror" ) {
			jQuery.error( "Invalid XML: " + data );
		}

		return xml;
	},

	noop: function() {},

	// Evaluates a script in a global context
	// Workarounds based on findings by Jim Driscoll
	// http://weblogs.java.net/blog/driscoll/archive/2009/09/08/eval-javascript-global-context
	globalEval: function( data ) {
		if ( data && rnotwhite.test( data ) ) {
			// We use execScript on Internet Explorer
			// We use an anonymous function so that context is window
			// rather than jQuery in Firefox
			( window.execScript || function( data ) {
				window[ "eval" ].call( window, data );
			} )( data );
		}
	},

	// Converts a dashed string to camelCased string;
	// Used by both the css and data modules
	camelCase: function( string ) {
		return string.replace( rdashAlpha, fcamelCase );
	},

	nodeName: function( elem, name ) {
		return elem.nodeName && elem.nodeName.toUpperCase() === name.toUpperCase();
	},

	// args is for internal usage only
	each: function( object, callback, args ) {
		var name, i = 0,
			length = object.length,
			isObj = length === undefined || jQuery.isFunction( object );

		if ( args ) {
			if ( isObj ) {
				for ( name in object ) {
					if ( callback.apply( object[ name ], args ) === false ) {
						break;
					}
				}
			} else {
				for ( ; i < length; ) {
					if ( callback.apply( object[ i++ ], args ) === false ) {
						break;
					}
				}
			}

		// A special, fast, case for the most common use of each
		} else {
			if ( isObj ) {
				for ( name in object ) {
					if ( callback.call( object[ name ], name, object[ name ] ) === false ) {
						break;
					}
				}
			} else {
				for ( ; i < length; ) {
					if ( callback.call( object[ i ], i, object[ i++ ] ) === false ) {
						break;
					}
				}
			}
		}

		return object;
	},

	// Use native String.trim function wherever possible
	trim: trim ?
		function( text ) {
			return text == null ?
				"" :
				trim.call( text );
		} :

		// Otherwise use our own trimming functionality
		function( text ) {
			return text == null ?
				"" :
				text.toString().replace( trimLeft, "" ).replace( trimRight, "" );
		},

	// results is for internal usage only
	makeArray: function( array, results ) {
		var ret = results || [];

		if ( array != null ) {
			// The window, strings (and functions) also have 'length'
			// The extra typeof function check is to prevent crashes
			// in Safari 2 (See: #3039)
			// Tweaked logic slightly to handle Blackberry 4.7 RegExp issues #6930
			var type = jQuery.type( array );

			if ( array.length == null || type === "string" || type === "function" || type === "regexp" || jQuery.isWindow( array ) ) {
				push.call( ret, array );
			} else {
				jQuery.merge( ret, array );
			}
		}

		return ret;
	},

	inArray: function( elem, array ) {

		if ( indexOf ) {
			return indexOf.call( array, elem );
		}

		for ( var i = 0, length = array.length; i < length; i++ ) {
			if ( array[ i ] === elem ) {
				return i;
			}
		}

		return -1;
	},

	merge: function( first, second ) {
		var i = first.length,
			j = 0;

		if ( typeof second.length === "number" ) {
			for ( var l = second.length; j < l; j++ ) {
				first[ i++ ] = second[ j ];
			}

		} else {
			while ( second[j] !== undefined ) {
				first[ i++ ] = second[ j++ ];
			}
		}

		first.length = i;

		return first;
	},

	grep: function( elems, callback, inv ) {
		var ret = [], retVal;
		inv = !!inv;

		// Go through the array, only saving the items
		// that pass the validator function
		for ( var i = 0, length = elems.length; i < length; i++ ) {
			retVal = !!callback( elems[ i ], i );
			if ( inv !== retVal ) {
				ret.push( elems[ i ] );
			}
		}

		return ret;
	},

	// arg is for internal usage only
	map: function( elems, callback, arg ) {
		var value, key, ret = [],
			i = 0,
			length = elems.length,
			// jquery objects are treated as arrays
			isArray = elems instanceof jQuery || length !== undefined && typeof length === "number" && ( ( length > 0 && elems[ 0 ] && elems[ length -1 ] ) || length === 0 || jQuery.isArray( elems ) ) ;

		// Go through the array, translating each of the items to their
		if ( isArray ) {
			for ( ; i < length; i++ ) {
				value = callback( elems[ i ], i, arg );

				if ( value != null ) {
					ret[ ret.length ] = value;
				}
			}

		// Go through every key on the object,
		} else {
			for ( key in elems ) {
				value = callback( elems[ key ], key, arg );

				if ( value != null ) {
					ret[ ret.length ] = value;
				}
			}
		}

		// Flatten any nested arrays
		return ret.concat.apply( [], ret );
	},

	// A global GUID counter for objects
	guid: 1,

	// Bind a function to a context, optionally partially applying any
	// arguments.
	proxy: function( fn, context ) {
		if ( typeof context === "string" ) {
			var tmp = fn[ context ];
			context = fn;
			fn = tmp;
		}

		// Quick check to determine if target is callable, in the spec
		// this throws a TypeError, but we will just return undefined.
		if ( !jQuery.isFunction( fn ) ) {
			return undefined;
		}

		// Simulated bind
		var args = slice.call( arguments, 2 ),
			proxy = function() {
				return fn.apply( context, args.concat( slice.call( arguments ) ) );
			};

		// Set the guid of unique handler to the same of original handler, so it can be removed
		proxy.guid = fn.guid = fn.guid || proxy.guid || jQuery.guid++;

		return proxy;
	},

	// Mutifunctional method to get and set values to a collection
	// The value/s can optionally be executed if it's a function
	access: function( elems, key, value, exec, fn, pass ) {
		var length = elems.length;

		// Setting many attributes
		if ( typeof key === "object" ) {
			for ( var k in key ) {
				jQuery.access( elems, k, key[k], exec, fn, value );
			}
			return elems;
		}

		// Setting one attribute
		if ( value !== undefined ) {
			// Optionally, function values get executed if exec is true
			exec = !pass && exec && jQuery.isFunction(value);

			for ( var i = 0; i < length; i++ ) {
				fn( elems[i], key, exec ? value.call( elems[i], i, fn( elems[i], key ) ) : value, pass );
			}

			return elems;
		}

		// Getting an attribute
		return length ? fn( elems[0], key ) : undefined;
	},

	now: function() {
		return (new Date()).getTime();
	},

	// Use of jQuery.browser is frowned upon.
	// More details: http://docs.jquery.com/Utilities/jQuery.browser
	uaMatch: function( ua ) {
		ua = ua.toLowerCase();

		var match = rwebkit.exec( ua ) ||
			ropera.exec( ua ) ||
			rmsie.exec( ua ) ||
			ua.indexOf("compatible") < 0 && rmozilla.exec( ua ) ||
			[];

		return { browser: match[1] || "", version: match[2] || "0" };
	},

	sub: function() {
		function jQuerySub( selector, context ) {
			return new jQuerySub.fn.init( selector, context );
		}
		jQuery.extend( true, jQuerySub, this );
		jQuerySub.superclass = this;
		jQuerySub.fn = jQuerySub.prototype = this();
		jQuerySub.fn.constructor = jQuerySub;
		jQuerySub.sub = this.sub;
		jQuerySub.fn.init = function init( selector, context ) {
			if ( context && context instanceof jQuery && !(context instanceof jQuerySub) ) {
				context = jQuerySub( context );
			}

			return jQuery.fn.init.call( this, selector, context, rootjQuerySub );
		};
		jQuerySub.fn.init.prototype = jQuerySub.fn;
		var rootjQuerySub = jQuerySub(document);
		return jQuerySub;
	},

	browser: {}
});

// Populate the class2type map
jQuery.each("Boolean Number String Function Array Date RegExp Object".split(" "), function(i, name) {
	class2type[ "[object " + name + "]" ] = name.toLowerCase();
});

browserMatch = jQuery.uaMatch( userAgent );
if ( browserMatch.browser ) {
	jQuery.browser[ browserMatch.browser ] = true;
	jQuery.browser.version = browserMatch.version;
}

// Deprecated, use jQuery.browser.webkit instead
if ( jQuery.browser.webkit ) {
	jQuery.browser.safari = true;
}

// IE doesn't match non-breaking spaces with \s
if ( rnotwhite.test( "\xA0" ) ) {
	trimLeft = /^[\s\xA0]+/;
	trimRight = /[\s\xA0]+$/;
}

// All jQuery objects should point back to these
rootjQuery = jQuery(document);

// Cleanup functions for the document ready method
if ( document.addEventListener ) {
	DOMContentLoaded = function() {
		document.removeEventListener( "DOMContentLoaded", DOMContentLoaded, false );
		jQuery.ready();
	};

} else if ( document.attachEvent ) {
	DOMContentLoaded = function() {
		// Make sure body exists, at least, in case IE gets a little overzealous (ticket #5443).
		if ( document.readyState === "complete" ) {
			document.detachEvent( "onreadystatechange", DOMContentLoaded );
			jQuery.ready();
		}
	};
}

// The DOM ready check for Internet Explorer
function doScrollCheck() {
	if ( jQuery.isReady ) {
		return;
	}

	try {
		// If IE is used, use the trick by Diego Perini
		// http://javascript.nwbox.com/IEContentLoaded/
		document.documentElement.doScroll("left");
	} catch(e) {
		setTimeout( doScrollCheck, 1 );
		return;
	}

	// and execute any waiting functions
	jQuery.ready();
}

return jQuery;

})();

//	------------------------------------------------------------------------

//	Alias certain Sizzle functions over to jQuery. Note that we expose
//	Sizzle as 'TP.extern.Sizzle'

jQuery.find = TP.extern.Sizzle;
jQuery.expr = TP.extern.Sizzle.selectors;
jQuery.expr[":"] = jQuery.expr.filters;
jQuery.unique = TP.extern.Sizzle.uniqueSort;
jQuery.text = TP.extern.Sizzle.getText;
jQuery.isXMLDoc = TP.extern.Sizzle.isXML;
jQuery.contains = TP.extern.Sizzle.contains;

TP.boot.$$srcPath = '';

        
        TP.registerExternalObject('jQuery', window.jQuery);
        
    
TP.boot.$$srcPath = '~lib_deps/jquery-xmlns-tpi.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//	========================================================================
//  jquery.xmlns.js:  xml-namespace selector support for jQuery
//	========================================================================

//
//  This plugin modifies the jQuery tag and attribute selectors to
//  support optional namespace specifiers as defined in CSS 3:
//
//    $("elem")      - matches 'elem' nodes in the default namespace
//    $("|elem")     - matches 'elem' nodes that don't have a namespace
//    $("NS|elem")   - matches 'elem' nodes in declared namespace 'NS'
//    $("*|elem")    - matches 'elem' nodes in any namespace
//    $("NS|*")      - matches any nodes in declared namespace 'NS'
//
//  A similar synax is also supported for attribute selectors, but note
//  that the default namespace does *not* apply to attributes - a missing
//  or empty namespace selector selects only attributes with no namespace.
//
//  In a slight break from the W3C standards, and with a nod to ease of
//  implementation, the empty namespace URI is treated as equivalent to
//  an unspecified namespace.  Plenty of browsers seem to make the same
//  assumption...
//
//  Namespace declarations live in the $.xmlns object, which is a simple
//  mapping from namespace ids to namespace URIs.  The default namespace
//  is determined by the value associated with the empty string.
//
//    $.xmlns.D = "DAV:"
//    $.xmlns.FOO = "http://www.foo.com/xmlns/foobar"
//    $.xmlns[""] = "http://www.example.com/new/default/namespace/"
//
//  Unfortunately this is a global setting - I can't find a way to do
//  query-object-specific namespaces since the jQuery selector machinery
//  is stateless.  However, you can use the 'xmlns' function to push and
//  pop namespace delcarations with ease:
//
//    $().xmlns({D:"DAV:"})     // pushes the DAV: namespace
//    $().xmlns("DAV:")         // makes DAV: the default namespace
//    $().xmlns(false)          // pops the namespace we just pushed
//    $().xmlns(false)          // pops again, returning to defaults
//
//  To execute this as a kind of "transaction", pass a function as the
//  second argument.  It will be executed in the context of the current
//  jQuery object:
//
//    $().xmlns("DAV:",function() {
//      //  The default namespace is DAV: within this function,
//      //  but it is reset to the previous value on exit.
//      return this.find("response").each(...);
//    }).find("div")
//
//  If you pass a string as a function, it will be executed against the
//  current jQuery object using find(); i.e. the following will find all
//  "href" elements in the "DAV:" namespace:
//
//    $().xmlns("DAV:","href")
//
//
//  And finally, the legal stuff:
//
//    Copyright (c) 2009, Ryan Kelly.
//    TAG and ATTR functions derived from jQuery's selector.js.
//    Dual licensed under the MIT and GPL licenses.
//    http://docs.jquery.com/License
//

(function($) {

//  Some common default namespaces, that are treated specially by browsers.
//
var default_xmlns = {
    "xml": "http://www.w3.org/XML/1998/namespace",
    "xmlns": "http://www.w3.org/2000/xmlns/",
    "html": "http://www.w3.org/1999/xhtml"
};


//  A reverse mapping for common namespace prefixes.
//
var default_xmlns_rev = {}
for(var k in default_xmlns) {
    default_xmlns_rev[default_xmlns[k]] = k;
}


//  $.xmlns is a mapping from namespace identifiers to namespace URIs.
//  The default default-namespace is "*", and we provide some additional
//  defaults that are specified in the XML Namespaces standard.
//
$.extend({xmlns: $.extend({},default_xmlns,{"":"*"})});


//  jQuery method to push/pop namespace declarations.
//
//  If a single argument is specified:
//    * if it's a mapping, push those namespaces onto the stack
//    * if it's a string, push that as the default namespace
//    * if it evaluates to false, pop the latest namespace
//
//  If two arguments are specified, the second is executed "transactionally"
//  using the namespace declarations found in the first.  It can be either a
//  a selector string (in which case it is passed to this.find()) or a function
//  (in which case it is called in the context of the current jQuery object).
//  The given namespace mapping is automatically pushed before executing and
//  popped afterwards.
//
var xmlns_stack = [];
$.fn.extend({xmlns: function(nsmap,func) {
    if(typeof nsmap == "string") {
        nsmap = {"":nsmap};
    }
    if(nsmap) {
        xmlns_stack.push($.xmlns);
        $.xmlns = $.extend({},$.xmlns,nsmap);
        if(func !== undefined) {
            if(typeof func == "string") {
                return this.find(func).xmlns(undefined)
            } else {
                var self = this;
                try {
                    self = func.call(this);
                    if(!self) {
                        self = this;
                    }
                } finally {
                    self.xmlns(undefined);
                }
                return self
            }
        } else {
            return this;
        }
    } else {
        $.xmlns = (xmlns_stack ? xmlns_stack.pop() : {});
        return this;
    }
}});


//  Convert a namespace prefix into a namespace URI, based
//  on the delcarations made in $.xmlns.
//
var getNamespaceURI = function(id) {
    // No namespace id, use the default.
    if(!id) {
        return $.xmlns[""];
    }
    // Strip the pipe character from the specifier
    id = id.substr(0,id.length-1);
    // Certain special namespaces aren't mapped to a URI
    if(id == "" || id == "*") {
        return id;
    }
    var ns = $.xmlns[id];
    if(typeof(ns) == "undefined") {
        throw "Syntax error, undefined namespace prefix '" + id + "'";
    }
    return ns;
};


//  Update the regex used by $.expr to parse selector components for a
//  particular type of selector (e.g. "TAG" or "ATTR").
//
//  This logic is taken straight from the jQuery/Sizzle sources.
//
var setExprMatchRegex = function(type,regex) {
  $.expr.match[type] = new RegExp(regex.source + /(?![^\[]*\])(?![^\(]*\))/.source);
  if($.expr.leftMatch) {
      $.expr.leftMatch[type] = new RegExp(/(^(?:.|\r|\n)*?)/.source + $.expr.match[type].source.replace(/\\(\d+)/g, function(all, num){
          return "\\" + (num - 0 + 1);
      }));
  }
}



//  Modify the TAG match regexp to include optional namespace selector.
//  This is basically (namespace|)?(tagname).
//
setExprMatchRegex("TAG",/^((?:((?:[\w\u00c0-\uFFFF\*_-]*\|)?)((?:[\w\u00c0-\uFFFF\*_-]|\\.)+)))/);


//  Perform some capability-testing.
//
var div = document.createElement("div");

//  Sometimes getElementsByTagName("*") will return comment nodes,
//  which we will have to remove from the results.
//
var gebtn_yields_comments = false;
div.appendChild(document.createComment(""));
if(div.getElementsByTagName("*").length > 0) {
    gebtn_yields_comments = true;
}

//  Some browsers return node.localName in upper case, some in lower case.
//
var localname_is_uppercase = true;
if(div.localName && div.localName == "div") {
    localname_is_uppercase = false;
}

//  Allow the testing div to be garbage-collected.
//
div = null;


//  Modify the TAG find function to account for a namespace selector.
//
$.expr.find.TAG = function(match,context,isXML) {
    var ns = getNamespaceURI(match[2]);
    var ln = match[3];
    var res;
    if(typeof context.getElementsByTagNameNS != "undefined") {
        //  Easy case - we have getElementsByTagNameNS
        res = context.getElementsByTagNameNS(ns,ln);
    } else if(typeof context.selectNodes != "undefined") {
        //  Use xpath if possible (not available on HTML DOM nodes in IE)
        if(context.ownerDocument) {
            context.ownerDocument.setProperty("SelectionLanguage","XPath");
        } else {
            context.setProperty("SelectionLanguage","XPath");
        }
        var predicate = "";
        if(ns != "*") {
            if(ln != "*") {
                predicate="namespace-uri()='"+ns+"' and local-name()='"+ln+"'";
            } else {
                predicate="namespace-uri()='"+ns+"'";
            }
        } else {
            if(ln != "*") {
                predicate="local-name()='"+ln+"'";
            }
        }
        if(predicate) {
            res = context.selectNodes("descendant-or-self::*["+predicate+"]");
        } else {
            res = context.selectNodes("descendant-or-self::*");
        }
    } else {
        //  Otherwise, we need to simulate using getElementsByTagName
        res = context.getElementsByTagName(ln);
        if(gebtn_yields_comments && ln == "*") {
            var tmp = [];
            for(var i=0; res[i]; i++) {
                if(res[i].nodeType == 1) {
                    tmp.push(res[i]);
                }
            }
            res = tmp;
        }
        if(res && ns != "*") {
            var tmp = [];
            for(var i=0; res[i]; i++) {
               if(res[i].namespaceURI == ns || res[i].tagUrn == ns) {
                   tmp.push(res[i]);
               }
            }
            res = tmp;
        }
    }
    return res;
};


//  Check whether a node is part of an XML document.
//  Copied verbatim from jQuery sources, needed in TAG preFilter below.
//
var isXML = function(elem){
    return elem.nodeType === 9 && elem.documentElement.nodeName !== "HTML" ||
            !!elem.ownerDocument && elem.ownerDocument.documentElement.nodeName !== "HTML";
};


//  Modify the TAG preFilter function to work with modified match regexp.
//  This normalises case of the tag name if we're in a HTML document.
//
$.expr.preFilter.TAG = function(match, curLoop, inplace, result, not, isXML) {
  var ln = match[3];
  if(!isXML) {
      if(localname_is_uppercase) {
          ln = ln.toUpperCase();
      } else {
          ln = ln.toLowerCase();
      }
  }
  return [match[0],getNamespaceURI(match[2]),ln];
};


//  Modify the TAG filter function to account for a namespace selector.
//
$.expr.filter.TAG = function(elem,match) {
    var ns = match[1];
    var ln = match[2];
    var e_ns = elem.namespaceURI ? elem.namespaceURI : elem.tagUrn;
    var e_ln = elem.localName ? elem.localName : elem.tagName;
    if(ns == "*" || e_ns == ns || (ns == "" && !e_ns)) {
        return ((ln == "*" && elem.nodeType == 1)  || e_ln == ln);
    }
    return false;
};


//  Modify the ATTR match regexp to extract a namespace selector.
//  This is basically ([namespace|])(attrname)(op)(quote)(pattern)(quote)
//
setExprMatchRegex("ATTR",/\[\s*((?:((?:[\w\u00c0-\uFFFF\*_-]*\|)?)((?:[\w\u00c0-\uFFFF_-]|\\.)+)))\s*(?:(\S?=)\s*(['"]*)(.*?)\5|)\s*\]/);


//  Modify the ATTR preFilter function to account for new regexp match groups,
//  and normalise the namespace URI.
//
$.expr.preFilter.ATTR = function(match, curLoop, inplace, result, not, isXML) {
    var name = match[3].replace(/\\/g, "");
    if(!isXML && $.expr.attrMap[name]) {
        match[3] = $.expr.attrMap[name];
    }
    if( match[4] == "~=" ) {
        match[6] = " " + match[6] + " ";
    }
    if(!match[2] || match[2] == "|") {
        match[2] = "";
    } else {
        match[2] = getNamespaceURI(match[2]);
    }
    return match;
};


//  Modify the ATTR filter function to account for namespace selector.
//  Unfortunately this means factoring out the attribute-checking code
//  into a separate function, since it might be called multiple times.
//
var filter_attr = function(result,type,check) {
    var value = result + "";
    return result == null ?
                type === "!=" :
                type === "=" ?
                value === check :
                type === "*=" ?
                value.indexOf(check) >= 0 :
                type === "~=" ?
                (" " + value + " ").indexOf(check) >= 0 :
                !check ?
                value && result !== false :
                type === "!=" ?
                value != check :
                type === "^=" ?
                value.indexOf(check) === 0 :
                type === "$=" ?
                value.substr(value.length - check.length) === check :
                type === "|=" ?
                value === check || value.substr(0,check.length+1)===check+"-" :
                false;
}


$.expr.filter.ATTR = function(elem, match) {
    var ns = match[2];
    var name = match[3];
    var type = match[4];
    var check = match[6];
    var result;
    //  No namespace, just use ordinary attribute lookup.
    if(ns == "") {
        result = $.expr.attrHandle[name] ?
                     $.expr.attrHandle[name](elem) :
                     elem[name] != null ?
                         elem[name] :
                         elem.getAttribute(name);
        return filter_attr(result,type,check);
    }
    //  Directly use getAttributeNS if applicable and available
    if(ns != "*" && typeof elem.getAttributeNS != "undefined") {
        return filter_attr(elem.getAttributeNS(ns,name),type,check);
    }
    //  Need to iterate over all attributes, either because we couldn't
    //  look it up or because we need to match all namespaces.
    var attrs = elem.attributes;
    for(var i=0; attrs[i]; i++) {
        var ln = attrs[i].localName;
        if(!ln) {
            ln = attrs[i].nodeName;
            var idx = ln.indexOf(":");
            if(idx >= 0) {
                ln = ln.substr(idx+1);
            }
        }
        if(ln == name) {
            result = attrs[i].nodeValue;
            if(ns == "*" || attrs[i].namespaceURI == ns) {
                if(filter_attr(result,type,check)) {
                    return true;
                }
            }
            if(attrs[i].namespaceURI === "" && attrs[i].prefix) {
                if(attrs[i].prefix == default_xmlns_rev[ns]) {
                    if(filter_attr(result,type,check)) {
                        return true;
                    }
                }
            }
        }
    }
    return false;
};


})(jQuery);
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETCSSQueryPost.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

TP.definePrimitive('elementMatchesCSS',
function(anElement, aSelector) {

    /**
     * @method elementMatchesCSS
     * @summary Returns true if the selector provided would locate the element
     *     in a result set. This is roughly equivalent to running the query and
     *     checking the result set as to whether it contains the supplied
     *     Element. Note that all queries in this method use the supplied
     *     element's document as their context.
     * @param {HTMLElement} anElement The element to test.
     * @param {String} aSelector A valid CSS selector.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidString
     * @returns {Boolean} True if the element would be found by the selector.
     */

    var matchesSelector;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(aSelector)) {
        return TP.raise(this, 'TP.sig.InvalidString',
                        'Invalid or empty selector');
    }

    //  If the result element was a 'TIBET generated' element (i.e.
    //  generated content), then we ignore it - even if it matches.
    if (TP.isValid(anElement[TP.GENERATED])) {
        return false;
    }

    //  It doesn't really matter what platform we're running on - we filter
    //  all 'browser-specific' selectors.
    if (TP.isTrue(TP.regex.CSS_NATIVE_CUSTOM.test(aSelector))) {
        return false;
    }

    //  If the native version is available, use that. It may be a
    //  vendor-prefixed version or the finally-settled-upon name of 'matches'.
    matchesSelector = anElement.mozMatchesSelector ||
        anElement.webkitMatchesSelector ||
        anElement.msMatchesSelector ||
        anElement.matches;

    //  If Function in matchesSelector is available and the selector doesn't have
    //  a pipe ('|') symbol (i.e. it's not a namespaced query), and it's not a
    //  'scoped selector' (i.e. starts with a combinator - which is not
    //  supported by W3C APIs) then use the native call.
    if (TP.isCallable(matchesSelector) &&
        !TP.regex.HAS_PIPE.test(aSelector) &&
        !TP.regex.CSS_CUSTOM_SCOPED_SELECTOR.test(aSelector)) {
        return matchesSelector.call(anElement, aSelector);
    }

    //  Cache the number of namespaces we've installed so that we don't do this
    //  every time this method gets called.
    if (TP.notDefined(TP.$$installedCSSNSCount) ||
        TP.$$installedCSSNSCount !== TP.w3.Xmlns.get('prefixes').getSize()) {

        //  Make sure all of the known namespaces are defined (note this is
        //  added to the 'xmlns' property of the 'extended jQuery' - see below -
        //  but since Sizzle functions are just aliased over to jQuery
        //  functions, we can use the original Sizzle function here).
        TP.w3.Xmlns.get('prefixes').perform(
            function(item) {
                TP.extern.jQuery.xmlns[item.first()] = item.last();
            });

        TP.$$installedCSSNSCount = TP.w3.Xmlns.get('prefixes').getSize();
    }

    //  Use the native Sizzle 'matches' call. It takes in a selector and an
    //  Array of pre-selected Elements and returns an Array with any of them
    //  that matched. So we supply an Array with the one element we're
    //  testing and if we get back a non-empty Array, we know that it
    //  matched the supplied selector.

    return TP.notEmpty(TP.extern.Sizzle.matches(aSelector, [anElement]));
}, {
    dependencies: [TP.extern.jQuery, TP.extern.Sizzle]
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeDetectAncestorMatchingCSS',
function(aNode, aSelector, stopAncestor) {

    /**
     * @method nodeDetectAncestorMatchingCSS
     * @summary Returns the first ancestor of aNode for which aSelector matches.
     * @param {Node} aNode The DOM node to operate on.
     * @param {String} aSelector The selector to match.
     * @param {Element} [stopAncestor] The ancestor to stop at. If not supplied,
     *     this would be identical to the document node of the document that
     *     aNode is contained in.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     * @returns {Element|undefined} The ancestor element that matches the CSS.
     */

    var elem,

        matchesSelector,

        closest;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (!TP.isElement(aNode)) {
        if (TP.isAttributeNode(aNode)) {
            elem = aNode.ownerElement;
        } else {
            elem = aNode.parentNode;
        }
    } else {
        elem = aNode.parentNode;

        //  If the parent node was either null or a Document, then return
        //  undefined - there is no ancestor matching.
        if (!TP.isElement(elem)) {
            return;
        }
    }

    if (TP.isEmpty(aSelector)) {
        return TP.raise(this, 'TP.sig.InvalidString',
                        'Invalid or empty selector');
    }

    //  If the result element was a 'TIBET generated' element (i.e.
    //  generated content), then we ignore it - even if it matches.
    if (TP.isValid(elem[TP.GENERATED])) {
        return;
    }

    //  It doesn't really matter what platform we're running on - we filter
    //  all 'browser-specific' selectors.
    if (TP.isTrue(TP.regex.CSS_NATIVE_CUSTOM.test(aSelector))) {
        return;
    }

    //  If the 'closest' method is available and the selector doesn't have a
    //  pipe ('|') symbol (i.e. it's not a namespaced query), and it's not a
    //  'scoped selector' (i.e. starts with a combinator - which is not
    //  supported by W3C APIs) and a 'stop ancestor' wasn't supplied, then use
    //  the native call.
    if (TP.isCallable(elem.closest) &&
        !TP.regex.HAS_PIPE.test(aSelector) &&
        !TP.regex.CSS_CUSTOM_SCOPED_SELECTOR.test(aSelector) &&
        !TP.isElement(stopAncestor)) {
        return elem.closest(aSelector);
    }

    //  If the native version is available, use that. It may be a
    //  vendor-prefixed version or the finally-settled-upon name of 'matches'.
    matchesSelector = elem.mozMatchesSelector ||
        elem.webkitMatchesSelector ||
        elem.msMatchesSelector ||
        elem.matches;

    if (TP.isCallable(matchesSelector) && !TP.regex.HAS_PIPE.test(aSelector)) {

        closest = function(startElem, selector) {

            var element;

            element = startElem;

            while (element && element.nodeType === Node.ELEMENT_NODE) {
                if (matchesSelector.call(element, selector)) {
                    return element;
                }

                element = element.parentNode;

                if (TP.isElement(stopAncestor) &&
                    element === stopAncestor) {
                    break;
                }
            }

            return;
        };

        return closest(elem, aSelector);
    }

    //  Cache the number of namespaces we've installed so that we don't do this
    //  every time this method gets called.
    if (TP.notDefined(TP.$$installedCSSNSCount) ||
        TP.$$installedCSSNSCount !== TP.w3.Xmlns.get('prefixes').getSize()) {

        //  Make sure all of the known namespaces are defined (note this is
        //  added to the 'xmlns' property of the 'extended jQuery' - see below -
        //  but since Sizzle functions are just aliased over to jQuery
        //  functions, we can use the original Sizzle function here).
        TP.w3.Xmlns.get('prefixes').perform(
            function(item) {
                TP.extern.jQuery.xmlns[item.first()] = item.last();
            });

        TP.$$installedCSSNSCount = TP.w3.Xmlns.get('prefixes').getSize();
    }

    //  Use the native Sizzle 'matches' call. It takes in a selector and an
    //  Array of pre-selected Elements and returns an Array with any of them
    //  that matched. So we supply an Array with the one element we're
    //  testing and if we get back a non-empty Array, we know that it
    //  matched the supplied selector.

    closest = function(startElem, selector) {

        var element;

        element = startElem;

        while (element && element.nodeType === Node.ELEMENT_NODE) {
            if (TP.notEmpty(TP.extern.Sizzle.matches(selector, [element]))) {
                return element;
            }

            element = element.parentNode;

            if (TP.isElement(stopAncestor) &&
                element === stopAncestor) {
                break;
            }
        }

        return;
    };

    return closest(elem, aSelector);
}, {
    dependencies: [TP.extern.jQuery, TP.extern.Sizzle]
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeSelectAncestorsMatchingCSS',
function(aNode, aSelector, stopAncestor) {

    /**
     * @method nodeSelectAncestorsMatchingCSS
     * @summary Returns all ancestors of aNode for which aSelector matches.
     * @param {Node} aNode The DOM node to operate on.
     * @param {String} aSelector The selector to match.
     * @param {Element} [stopAncestor] The ancestor to stop at. If not supplied,
     *     this would be identical to the document node of the document that
     *     aNode is contained in.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     * @returns {Element[]|undefined} The ancestor elements that match the CSS.
     */

    var elem,

        matchesSelector,

        closest;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (!TP.isElement(aNode)) {
        if (TP.isAttributeNode(aNode)) {
            elem = aNode.ownerElement;
        } else {
            elem = aNode.parentNode;
        }
    } else {
        elem = aNode.parentNode;

        //  If the parent node was either null or a Document, then return
        //  undefined - there is no ancestor matching.
        if (!TP.isElement(elem)) {
            return;
        }
    }

    if (TP.isEmpty(aSelector)) {
        return TP.raise(this, 'TP.sig.InvalidString',
                        'Invalid or empty selector');
    }

    //  If the result element was a 'TIBET generated' element (i.e.
    //  generated content), then we ignore it - even if it matches.
    if (TP.isValid(elem[TP.GENERATED])) {
        return;
    }

    //  It doesn't really matter what platform we're running on - we filter
    //  all 'browser-specific' selectors.
    if (TP.isTrue(TP.regex.CSS_NATIVE_CUSTOM.test(aSelector))) {
        return;
    }

    //  If the native version is available, use that. It may be a
    //  vendor-prefixed version or the finally-settled-upon name of 'matches'.
    matchesSelector = elem.mozMatchesSelector ||
        elem.webkitMatchesSelector ||
        elem.msMatchesSelector ||
        elem.matches;

    if (TP.isCallable(matchesSelector) && !TP.regex.HAS_PIPE.test(aSelector)) {

        closest = function(startElem, selector) {

            var result,
                element;

            result = TP.ac();

            element = startElem;

            while (element && element.nodeType === Node.ELEMENT_NODE) {
                if (matchesSelector.call(element, selector)) {
                    result.push(element);
                }

                element = element.parentNode;

                if (TP.isElement(stopAncestor) &&
                    element === stopAncestor) {
                    break;
                }
            }

            return result;
        };

        return closest(elem, aSelector);
    }

    //  Cache the number of namespaces we've installed so that we don't do this
    //  every time this method gets called.
    if (TP.notDefined(TP.$$installedCSSNSCount) ||
        TP.$$installedCSSNSCount !== TP.w3.Xmlns.get('prefixes').getSize()) {

        //  Make sure all of the known namespaces are defined (note this is
        //  added to the 'xmlns' property of the 'extended jQuery' - see below -
        //  but since Sizzle functions are just aliased over to jQuery
        //  functions, we can use the original Sizzle function here).
        TP.w3.Xmlns.get('prefixes').perform(
            function(item) {
                TP.extern.jQuery.xmlns[item.first()] = item.last();
            });

        TP.$$installedCSSNSCount = TP.w3.Xmlns.get('prefixes').getSize();
    }

    //  Use the native Sizzle 'matches' call. It takes in a selector and an
    //  Array of pre-selected Elements and returns an Array with any of them
    //  that matched. So we supply an Array with the one element we're
    //  testing and if we get back a non-empty Array, we know that it
    //  matched the supplied selector.

    closest = function(startElem, selector) {

        var result,
            element;

        result = TP.ac();

        element = startElem;

        while (element && element.nodeType === Node.ELEMENT_NODE) {
            if (TP.notEmpty(TP.extern.Sizzle.matches(selector, [element]))) {
                result.push(element);
            }

            element = element.parentNode;

            if (TP.isElement(stopAncestor) &&
                element === stopAncestor) {
                break;
            }
        }

        return result;
    };

    return closest(elem, aSelector);
}, {
    dependencies: [TP.extern.jQuery, TP.extern.Sizzle]
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeEvaluateCSS',
function(aNode, aSelector, autoCollapse) {

    /**
     * @method nodeEvaluateCSS
     * @summary Returns any elements matching the selector given in the
     *     supplied selector String.
     * @description Note that if an 'ID' selector query (where the first
     *     character is '#') is handed to this method, it will automatically
     *     collapse the results whether the autoCollapse flag is set or not.
     * @param {Node|Window} aNode The 'context node' for the evaluation (or a
     *     Window, which will supply its document as the context node).
     * @param {String} aSelector A valid CSS selector.
     * @param {Boolean} [autoCollapse=false] Whether to collapse Array results
     *     if there's only one item in them. The default is false.
     * @exception TP.sig.InvalidNode
     * @exception TP.sig.InvalidString
     * @returns {Node[]|Node} A collection of zero or more result nodes or a
     *     single node if we're autoCollapsing.
     */

    var theNode,

        matchResults,

        resultArr,
        i,
        result;

    theNode = TP.isWindow(aNode) ? aNode.document : aNode;

    if (!TP.isNode(theNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (TP.isEmpty(aSelector)) {
        return TP.raise(this, 'TP.sig.InvalidString',
                        'Invalid or empty selector');
    }

    //  It doesn't really matter what platform we're running on - we filter
    //  all 'browser-specific' selectors.
    if (TP.isTrue(TP.regex.CSS_NATIVE_CUSTOM.test(aSelector))) {
        return TP.isTrue(autoCollapse) ? null : TP.ac();
    }

    //  If the selector doesn't have a pipe ('|') symbol (i.e. it's not a
    //  namespaced query), and it's not a 'scoped selector' (i.e. starts with a
    //  combinator - which is not supported by W3C APIs) then use the native
    //  call.
    if (!TP.regex.HAS_PIPE.test(aSelector) &&
        !TP.regex.CSS_CUSTOM_SCOPED_SELECTOR.test(aSelector)) {
        matchResults = theNode.querySelectorAll(aSelector);
    } else {
        //  Cache the number of namespaces we've installed so that we don't do
        //  this every time this method gets called.
        if (TP.notDefined(TP.$$installedCSSNSCount) ||
            TP.$$installedCSSNSCount !==
                            TP.w3.Xmlns.get('prefixes').getSize()) {

            //  Make sure all of the known namespaces are defined (note this is
            //  added to the 'xmlns' property of the 'extended jQuery' - see
            //  below - but since Sizzle functions are just aliased over to
            //  jQuery functions, we can use the original Sizzle function here).
            TP.w3.Xmlns.get('prefixes').perform(
                function(item) {
                    TP.extern.jQuery.xmlns[item.first()] = item.last();
                });
        }

        try {
            /* eslint-disable new-cap */
            matchResults = TP.extern.Sizzle(aSelector, theNode);
            /* eslint-enable new-cap */
        } catch (e) {
            return TP.isTrue(autoCollapse) ? null : TP.ac();
        }
    }

    //  First, let's check the length of the results against the
    //  auto-reduction flag.
    if (matchResults.length === 0) {
        return TP.isTrue(autoCollapse) ? null : TP.ac();
    }

    if (matchResults.length === 1) {
        result = matchResults.item(0);
        //  We only auto-collapse if the number of elements matched by the query
        //  is exactly 1.
        if (TP.isTrue(autoCollapse)) {
            if (TP.notValid(result[TP.GENERATED])) {
                return result;
            } else {
                return null;
            }
        } else {
            if (TP.notValid(result[TP.GENERATED])) {
                return TP.ac(result);
            } else {
                return TP.ac();
            }
        }
    }

    //  One thing we don't like is that the result isn't an Array, so we
    //  have to repackage the results into an Array :-(. Oh well, we have to
    //  check for generated content anyway.

    resultArr = TP.ac();
    for (i = 0; i < matchResults.length; i++) {
        result = matchResults.item(i);

        //  If the result was 'TIBET generated', that is its 'generated
        //  content', then we don't add it to the results - since its
        //  supposed to be 'hidden'.
        if (TP.notValid(result[TP.GENERATED])) {
            resultArr.push(result);
        }
    }

    return resultArr;
}, {
    dependencies: [TP.extern.jQuery, TP.extern.Sizzle]
});

//  ------------------------------------------------------------------------

TP.definePrimitive('selectorIsNative',
function(aSelector) {

    /**
     * @method selectorIsNative
     * @summary Returns true if the selector provided is 'native' (i.e.
     *     supported in a built-in fashion) in the currently executing browser
     *     environment.
     * @description Note that this method will return true as long as the
     *     selector is a natively supported selector in the current browser
     *     environment. This means that selectors that are only supported for
     *     the current browser (i.e. those prefixed with -moz/-ms/-webkit) will
     *     return true.
     * @param {String} aSelector A valid CSS selector.
     * @exception TP.sig.InvalidString
     * @returns {Boolean} True if the selector is native.
     */

    if (TP.isEmpty(aSelector)) {
        return TP.raise(this, 'TP.sig.InvalidString',
                        'Invalid or empty selector');
    }

    if (TP.notValid(document.querySelectorAll)) {
        return false;
    }

    //  According to the CSS Selector specification, the 'querySelectorAll'
    //  method *MUST* throw an exception if it does not understand the
    //  selector handed to it. We leverage that fact by trying to have it
    //  query using the selector provided (note that we don't care at all
    //  about the return value). If it doesn't throw an exception, then we
    //  know that the selector is supported, otherwise it isn't.
    try {
        document.querySelectorAll(aSelector);

        return true;
    } catch (e) {
        return false;
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowMatchesCSSMedia',
function(aWindow, queryStr) {

    /**
     * @method windowMatchesCSSMedia
     * @summary Returns true if the supplied 'CSS media query' matches the
     *     supplied Window's CSS environment.
     * @description Note that this method will return null if the CSSOM
     *     'matchMedia' call is not supported or it doesn't return a valid
     *     result for the supplied query.
     * @param {Window} aWindow The window to execute the media query against.
     * @param {String} queryStr A valid 'CSS media query'.
     * @exception TP.sig.InvalidWindow
     * @exception TP.sig.UnsupportedFeature
     * @exception TP.sig.InvalidString
     * @returns {Boolean} True if the media query matches.
     */

    var queryResult;

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (TP.notValid(aWindow.matchMedia)) {
        return TP.raise(this, 'TP.sig.UnsupportedFeature');
    }

    if (TP.isEmpty(queryStr)) {
        return TP.raise(this, 'TP.sig.InvalidString',
                        'Invalid or empty query');
    }

    queryResult = aWindow.matchMedia(queryStr);

    if (!TP.isMediaQueryList(queryResult)) {
        return null;
    }

    return queryResult.matches;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowQueryCSSMedia',
function(aWindow, queryStr, watchFunction) {

    /**
     * @method windowQueryCSSMedia
     * @summary Returns a valid media query list if the supplied 'CSS media
     *     query' matches the supplied Window's CSS environment.
     * @description Note that this method will return null if the CSSOM
     *     'matchMedia' call is not supported or it doesn't return a valid
     *     result for the supplied query.
     * @param {Window} aWindow The window to execute the media query against.
     * @param {String} queryStr A valid 'CSS media query'.
     * @param {Function} watchFunction A Function that will be installed to
     *     watch for changes to the CSS environment such that the supplied query
     *     will come into or out of force.
     * @exception TP.sig.InvalidWindow
     * @exception TP.sig.UnsupportedFeature
     * @exception TP.sig.InvalidString
     * @returns {MediaQueryList} The object returned by a 'matchMedia' call.
     *     This can be used to 'unwatch' the supplied query by using it's
     *     'removeListener' method with the supplied handler Function.
     */

    var queryResult;

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (TP.notValid(aWindow.matchMedia)) {
        return TP.raise(this, 'TP.sig.UnsupportedFeature');
    }

    if (TP.isEmpty(queryStr)) {
        return TP.raise(this, 'TP.sig.InvalidString',
                        'Invalid or empty query');
    }

    queryResult = aWindow.matchMedia(queryStr);

    if (!TP.isMediaQueryList(queryResult)) {
        return null;
    }

    if (TP.isCallable(watchFunction)) {
        queryResult.addListener(watchFunction);
    }

    return queryResult;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_deps/wgxpath-tpi.install.min.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
(function(){'use strict';var k=this;
function aa(a){var b=typeof a;if("object"==b)if(a){if(a instanceof Array)return"array";if(a instanceof Object)return b;var c=Object.prototype.toString.call(a);if("[object Window]"==c)return"object";if("[object Array]"==c||"number"==typeof a.length&&"undefined"!=typeof a.splice&&"undefined"!=typeof a.propertyIsEnumerable&&!a.propertyIsEnumerable("splice"))return"array";if("[object Function]"==c||"undefined"!=typeof a.call&&"undefined"!=typeof a.propertyIsEnumerable&&!a.propertyIsEnumerable("call"))return"function"}else return"null";else if("function"==
b&&"undefined"==typeof a.call)return"object";return b}function l(a){return"string"==typeof a}function ba(a,b,c){return a.call.apply(a.bind,arguments)}function ca(a,b,c){if(!a)throw Error();if(2<arguments.length){var d=Array.prototype.slice.call(arguments,2);return function(){var c=Array.prototype.slice.call(arguments);Array.prototype.unshift.apply(c,d);return a.apply(b,c)}}return function(){return a.apply(b,arguments)}}
function da(a,b,c){da=Function.prototype.bind&&-1!=Function.prototype.bind.toString().indexOf("native code")?ba:ca;return da.apply(null,arguments)}function ea(a,b){var c=Array.prototype.slice.call(arguments,1);return function(){var b=c.slice();b.push.apply(b,arguments);return a.apply(this,b)}}
function m(a){var b=n;function c(){}c.prototype=b.prototype;a.G=b.prototype;a.prototype=new c;a.prototype.constructor=a;a.F=function(a,c,f){for(var g=Array(arguments.length-2),h=2;h<arguments.length;h++)g[h-2]=arguments[h];return b.prototype[c].apply(a,g)}};/*

 The MIT License

 Copyright (c) 2007 Cybozu Labs, Inc.
 Copyright (c) 2012 Google Inc.

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to
 deal in the Software without restriction, including without limitation the
 rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 sell copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 IN THE SOFTWARE.
*/
var fa=String.prototype.trim?function(a){return a.trim()}:function(a){return a.replace(/^[\s\xa0]+|[\s\xa0]+$/g,"")};function q(a,b){return-1!=a.indexOf(b)}function ga(a,b){return a<b?-1:a>b?1:0};var ha=Array.prototype.indexOf?function(a,b,c){return Array.prototype.indexOf.call(a,b,c)}:function(a,b,c){c=null==c?0:0>c?Math.max(0,a.length+c):c;if(l(a))return l(b)&&1==b.length?a.indexOf(b,c):-1;for(;c<a.length;c++)if(c in a&&a[c]===b)return c;return-1},r=Array.prototype.forEach?function(a,b,c){Array.prototype.forEach.call(a,b,c)}:function(a,b,c){for(var d=a.length,e=l(a)?a.split(""):a,f=0;f<d;f++)f in e&&b.call(c,e[f],f,a)},ia=Array.prototype.filter?function(a,b,c){return Array.prototype.filter.call(a,
b,c)}:function(a,b,c){for(var d=a.length,e=[],f=0,g=l(a)?a.split(""):a,h=0;h<d;h++)if(h in g){var p=g[h];b.call(c,p,h,a)&&(e[f++]=p)}return e},t=Array.prototype.reduce?function(a,b,c,d){d&&(b=da(b,d));return Array.prototype.reduce.call(a,b,c)}:function(a,b,c,d){var e=c;r(a,function(c,g){e=b.call(d,e,c,g,a)});return e},ja=Array.prototype.some?function(a,b,c){return Array.prototype.some.call(a,b,c)}:function(a,b,c){for(var d=a.length,e=l(a)?a.split(""):a,f=0;f<d;f++)if(f in e&&b.call(c,e[f],f,a))return!0;
return!1};function ka(a,b){var c;a:{c=a.length;for(var d=l(a)?a.split(""):a,e=0;e<c;e++)if(e in d&&b.call(void 0,d[e],e,a)){c=e;break a}c=-1}return 0>c?null:l(a)?a.charAt(c):a[c]}function la(a){return Array.prototype.concat.apply(Array.prototype,arguments)}function ma(a,b,c){return 2>=arguments.length?Array.prototype.slice.call(a,b):Array.prototype.slice.call(a,b,c)};var u;a:{var na=k.navigator;if(na){var oa=na.userAgent;if(oa){u=oa;break a}}u=""};var pa=q(u,"Opera")||q(u,"OPR"),v=q(u,"Trident")||q(u,"MSIE"),qa=q(u,"Edge"),ra=q(u,"Gecko")&&!(q(u.toLowerCase(),"webkit")&&!q(u,"Edge"))&&!(q(u,"Trident")||q(u,"MSIE"))&&!q(u,"Edge"),sa=q(u.toLowerCase(),"webkit")&&!q(u,"Edge");function ta(){var a=k.document;return a?a.documentMode:void 0}var ua;
a:{var va="",wa=function(){var a=u;if(ra)return/rv\:([^\);]+)(\)|;)/.exec(a);if(qa)return/Edge\/([\d\.]+)/.exec(a);if(v)return/\b(?:MSIE|rv)[: ]([^\);]+)(\)|;)/.exec(a);if(sa)return/WebKit\/(\S+)/.exec(a);if(pa)return/(?:Version)[ \/]?(\S+)/.exec(a)}();wa&&(va=wa?wa[1]:"");if(v){var xa=ta();if(null!=xa&&xa>parseFloat(va)){ua=String(xa);break a}}ua=va}var ya={};
function za(a){if(!ya[a]){for(var b=0,c=fa(String(ua)).split("."),d=fa(String(a)).split("."),e=Math.max(c.length,d.length),f=0;0==b&&f<e;f++){var g=c[f]||"",h=d[f]||"",p=/(\d*)(\D*)/g,y=/(\d*)(\D*)/g;do{var D=p.exec(g)||["","",""],X=y.exec(h)||["","",""];if(0==D[0].length&&0==X[0].length)break;b=ga(0==D[1].length?0:parseInt(D[1],10),0==X[1].length?0:parseInt(X[1],10))||ga(0==D[2].length,0==X[2].length)||ga(D[2],X[2])}while(0==b)}ya[a]=0<=b}}
var Aa=k.document,Ba=Aa&&v?ta()||("CSS1Compat"==Aa.compatMode?parseInt(ua,10):5):void 0;var w=v&&!(9<=Number(Ba)),Ca=v&&!(8<=Number(Ba));function x(a,b,c,d){this.a=a;this.nodeName=c;this.nodeValue=d;this.nodeType=2;this.parentNode=this.ownerElement=b}function Da(a,b){var c=Ca&&"href"==b.nodeName?a.getAttribute(b.nodeName,2):b.nodeValue;return new x(b,a,b.nodeName,c)};function z(a){var b=null,c=a.nodeType;1==c&&(b=a.textContent,b=void 0==b||null==b?a.innerText:b,b=void 0==b||null==b?"":b);if("string"!=typeof b)if(w&&"title"==a.nodeName.toLowerCase()&&1==c)b=a.text;else if(9==c||1==c){a=9==c?a.documentElement:a.firstChild;for(var c=0,d=[],b="";a;){do 1!=a.nodeType&&(b+=a.nodeValue),w&&"title"==a.nodeName.toLowerCase()&&(b+=a.text),d[c++]=a;while(a=a.firstChild);for(;c&&!(a=d[--c].nextSibling););}}else b=a.nodeValue;return""+b}
function A(a,b,c){if(null===b)return!0;try{if(!a.getAttribute)return!1}catch(d){return!1}Ca&&"class"==b&&(b="className");return null==c?!!a.getAttribute(b):a.getAttribute(b,2)==c}function B(a,b,c,d,e){return(w?Ea:Fa).call(null,a,b,l(c)?c:null,l(d)?d:null,e||new C)}
function Ea(a,b,c,d,e){if(a instanceof E||8==a.b||c&&null===a.b){var f=b.all;if(!f)return e;a=Ga(a);if("*"!=a&&(f=b.getElementsByTagName(a),!f))return e;if(c){for(var g=[],h=0;b=f[h++];)A(b,c,d)&&g.push(b);f=g}for(h=0;b=f[h++];)"*"==a&&"!"==b.tagName||F(e,b);return e}Ha(a,b,c,d,e);return e}
function Fa(a,b,c,d,e){b.getElementsByName&&d&&"name"==c&&!v?(b=b.getElementsByName(d),r(b,function(b){a.a(b)&&F(e,b)})):b.getElementsByClassName&&d&&"class"==c?(b=b.getElementsByClassName(d),r(b,function(b){b.className==d&&a.a(b)&&F(e,b)})):a instanceof G?Ha(a,b,c,d,e):b.getElementsByTagName&&(b=b.getElementsByTagName(a.f()),r(b,function(a){A(a,c,d)&&F(e,a)}));return e}
function Ia(a,b,c,d,e){var f;if((a instanceof E||8==a.b||c&&null===a.b)&&(f=b.childNodes)){var g=Ga(a);if("*"!=g&&(f=ia(f,function(a){return a.tagName&&a.tagName.toLowerCase()==g}),!f))return e;c&&(f=ia(f,function(a){return A(a,c,d)}));r(f,function(a){"*"==g&&("!"==a.tagName||"*"==g&&1!=a.nodeType)||F(e,a)});return e}return Ja(a,b,c,d,e)}function Ja(a,b,c,d,e){for(b=b.firstChild;b;b=b.nextSibling)A(b,c,d)&&a.a(b)&&F(e,b);return e}
function Ha(a,b,c,d,e){for(b=b.firstChild;b;b=b.nextSibling)A(b,c,d)&&a.a(b)&&F(e,b),Ha(a,b,c,d,e)}function Ga(a){if(a instanceof G){if(8==a.b)return"!";if(null===a.b)return"*"}return a.f()};!ra&&!v||v&&9<=Number(Ba)||ra&&za("1.9.1");v&&za("9");function Ka(a,b){if(!a||!b)return!1;if(a.contains&&1==b.nodeType)return a==b||a.contains(b);if("undefined"!=typeof a.compareDocumentPosition)return a==b||!!(a.compareDocumentPosition(b)&16);for(;b&&a!=b;)b=b.parentNode;return b==a}
function La(a,b){if(a==b)return 0;if(a.compareDocumentPosition)return a.compareDocumentPosition(b)&2?1:-1;if(v&&!(9<=Number(Ba))){if(9==a.nodeType)return-1;if(9==b.nodeType)return 1}if("sourceIndex"in a||a.parentNode&&"sourceIndex"in a.parentNode){var c=1==a.nodeType,d=1==b.nodeType;if(c&&d)return a.sourceIndex-b.sourceIndex;var e=a.parentNode,f=b.parentNode;return e==f?Ma(a,b):!c&&Ka(e,b)?-1*Na(a,b):!d&&Ka(f,a)?Na(b,a):(c?a.sourceIndex:e.sourceIndex)-(d?b.sourceIndex:f.sourceIndex)}d=9==a.nodeType?
a:a.ownerDocument||a.document;c=d.createRange();c.selectNode(a);c.collapse(!0);d=d.createRange();d.selectNode(b);d.collapse(!0);return c.compareBoundaryPoints(k.Range.START_TO_END,d)}function Na(a,b){var c=a.parentNode;if(c==b)return-1;for(var d=b;d.parentNode!=c;)d=d.parentNode;return Ma(d,a)}function Ma(a,b){for(var c=b;c=c.previousSibling;)if(c==a)return-1;return 1};function C(){this.b=this.a=null;this.l=0}function Oa(a){this.node=a;this.a=this.b=null}function Pa(a,b){if(!a.a)return b;if(!b.a)return a;for(var c=a.a,d=b.a,e=null,f=null,g=0;c&&d;){var f=c.node,h=d.node;f==h||f instanceof x&&h instanceof x&&f.a==h.a?(f=c,c=c.a,d=d.a):0<La(c.node,d.node)?(f=d,d=d.a):(f=c,c=c.a);(f.b=e)?e.a=f:a.a=f;e=f;g++}for(f=c||d;f;)f.b=e,e=e.a=f,g++,f=f.a;a.b=e;a.l=g;return a}function Qa(a,b){var c=new Oa(b);c.a=a.a;a.b?a.a.b=c:a.a=a.b=c;a.a=c;a.l++}
function F(a,b){var c=new Oa(b);c.b=a.b;a.a?a.b.a=c:a.a=a.b=c;a.b=c;a.l++}function Ra(a){return(a=a.a)?a.node:null}function Sa(a){return(a=Ra(a))?z(a):""}function H(a,b){return new Ta(a,!!b)}function Ta(a,b){this.f=a;this.b=(this.c=b)?a.b:a.a;this.a=null}function I(a){var b=a.b;if(null==b)return null;var c=a.a=b;a.b=a.c?b.b:b.a;return c.node};function n(a){this.i=a;this.b=this.g=!1;this.f=null}function J(a){return"\n  "+a.toString().split("\n").join("\n  ")}function Ua(a,b){a.g=b}function Va(a,b){a.b=b}function K(a,b){var c=a.a(b);return c instanceof C?+Sa(c):+c}function L(a,b){var c=a.a(b);return c instanceof C?Sa(c):""+c}function M(a,b){var c=a.a(b);return c instanceof C?!!c.l:!!c};function N(a,b,c){n.call(this,a.i);this.c=a;this.h=b;this.o=c;this.g=b.g||c.g;this.b=b.b||c.b;this.c==Wa&&(c.b||c.g||4==c.i||0==c.i||!b.f?b.b||b.g||4==b.i||0==b.i||!c.f||(this.f={name:c.f.name,s:b}):this.f={name:b.f.name,s:c})}m(N);
function O(a,b,c,d,e){b=b.a(d);c=c.a(d);var f;if(b instanceof C&&c instanceof C){b=H(b);for(d=I(b);d;d=I(b))for(e=H(c),f=I(e);f;f=I(e))if(a(z(d),z(f)))return!0;return!1}if(b instanceof C||c instanceof C){b instanceof C?(e=b,d=c):(e=c,d=b);f=H(e);for(var g=typeof d,h=I(f);h;h=I(f)){switch(g){case "number":h=+z(h);break;case "boolean":h=!!z(h);break;case "string":h=z(h);break;default:throw Error("Illegal primitive type for comparison.");}if(e==b&&a(h,d)||e==c&&a(d,h))return!0}return!1}return e?"boolean"==
typeof b||"boolean"==typeof c?a(!!b,!!c):"number"==typeof b||"number"==typeof c?a(+b,+c):a(b,c):a(+b,+c)}N.prototype.a=function(a){return this.c.m(this.h,this.o,a)};N.prototype.toString=function(){var a="Binary Expression: "+this.c,a=a+J(this.h);return a+=J(this.o)};function Xa(a,b,c,d){this.a=a;this.w=b;this.i=c;this.m=d}Xa.prototype.toString=function(){return this.a};var Ya={};
function P(a,b,c,d){if(Ya.hasOwnProperty(a))throw Error("Binary operator already created: "+a);a=new Xa(a,b,c,d);return Ya[a.toString()]=a}P("div",6,1,function(a,b,c){return K(a,c)/K(b,c)});P("mod",6,1,function(a,b,c){return K(a,c)%K(b,c)});P("*",6,1,function(a,b,c){return K(a,c)*K(b,c)});P("+",5,1,function(a,b,c){return K(a,c)+K(b,c)});P("-",5,1,function(a,b,c){return K(a,c)-K(b,c)});P("<",4,2,function(a,b,c){return O(function(a,b){return a<b},a,b,c)});
P(">",4,2,function(a,b,c){return O(function(a,b){return a>b},a,b,c)});P("<=",4,2,function(a,b,c){return O(function(a,b){return a<=b},a,b,c)});P(">=",4,2,function(a,b,c){return O(function(a,b){return a>=b},a,b,c)});var Wa=P("=",3,2,function(a,b,c){return O(function(a,b){return a==b},a,b,c,!0)});P("!=",3,2,function(a,b,c){return O(function(a,b){return a!=b},a,b,c,!0)});P("and",2,2,function(a,b,c){return M(a,c)&&M(b,c)});P("or",1,2,function(a,b,c){return M(a,c)||M(b,c)});function Q(a,b,c){this.a=a;this.b=b||1;this.f=c||1};function Za(a,b){if(b.a.length&&4!=a.i)throw Error("Primary expression must evaluate to nodeset if filter has predicate(s).");n.call(this,a.i);this.c=a;this.h=b;this.g=a.g;this.b=a.b}m(Za);Za.prototype.a=function(a){a=this.c.a(a);return $a(this.h,a)};Za.prototype.toString=function(){var a;a="Filter:"+J(this.c);return a+=J(this.h)};function ab(a,b){if(b.length<a.A)throw Error("Function "+a.j+" expects at least"+a.A+" arguments, "+b.length+" given");if(null!==a.v&&b.length>a.v)throw Error("Function "+a.j+" expects at most "+a.v+" arguments, "+b.length+" given");a.B&&r(b,function(b,d){if(4!=b.i)throw Error("Argument "+d+" to function "+a.j+" is not of type Nodeset: "+b);});n.call(this,a.i);this.h=a;this.c=b;Ua(this,a.g||ja(b,function(a){return a.g}));Va(this,a.D&&!b.length||a.C&&!!b.length||ja(b,function(a){return a.b}))}m(ab);
ab.prototype.a=function(a){return this.h.m.apply(null,la(a,this.c))};ab.prototype.toString=function(){var a="Function: "+this.h;if(this.c.length)var b=t(this.c,function(a,b){return a+J(b)},"Arguments:"),a=a+J(b);return a};function bb(a,b,c,d,e,f,g,h,p){this.j=a;this.i=b;this.g=c;this.D=d;this.C=e;this.m=f;this.A=g;this.v=void 0!==h?h:g;this.B=!!p}bb.prototype.toString=function(){return this.j};var cb={};
function R(a,b,c,d,e,f,g,h){if(cb.hasOwnProperty(a))throw Error("Function already created: "+a+".");cb[a]=new bb(a,b,c,d,!1,e,f,g,h)}R("boolean",2,!1,!1,function(a,b){return M(b,a)},1);R("ceiling",1,!1,!1,function(a,b){return Math.ceil(K(b,a))},1);R("concat",3,!1,!1,function(a,b){return t(ma(arguments,1),function(b,d){return b+L(d,a)},"")},2,null);R("contains",2,!1,!1,function(a,b,c){return q(L(b,a),L(c,a))},2);R("count",1,!1,!1,function(a,b){return b.a(a).l},1,1,!0);
R("false",2,!1,!1,function(){return!1},0);R("floor",1,!1,!1,function(a,b){return Math.floor(K(b,a))},1);R("id",4,!1,!1,function(a,b){function c(a){if(w){var b=e.all[a];if(b){if(b.nodeType&&a==b.id)return b;if(b.length)return ka(b,function(b){return a==b.id})}return null}return e.getElementById(a)}var d=a.a,e=9==d.nodeType?d:d.ownerDocument,d=L(b,a).split(/\s+/),f=[];r(d,function(a){a=c(a);!a||0<=ha(f,a)||f.push(a)});f.sort(La);var g=new C;r(f,function(a){F(g,a)});return g},1);
R("lang",2,!1,!1,function(){return!1},1);R("last",1,!0,!1,function(a){if(1!=arguments.length)throw Error("Function last expects ()");return a.f},0);R("local-name",3,!1,!0,function(a,b){var c=b?Ra(b.a(a)):a.a;return c?c.localName||c.nodeName.toLowerCase():""},0,1,!0);R("name",3,!1,!0,function(a,b){var c=b?Ra(b.a(a)):a.a;return c?c.nodeName.toLowerCase():""},0,1,!0);R("namespace-uri",3,!0,!1,function(){return""},0,1,!0);
R("normalize-space",3,!1,!0,function(a,b){return(b?L(b,a):z(a.a)).replace(/[\s\xa0]+/g," ").replace(/^\s+|\s+$/g,"")},0,1);R("not",2,!1,!1,function(a,b){return!M(b,a)},1);R("number",1,!1,!0,function(a,b){return b?K(b,a):+z(a.a)},0,1);R("position",1,!0,!1,function(a){return a.b},0);R("round",1,!1,!1,function(a,b){return Math.round(K(b,a))},1);R("starts-with",2,!1,!1,function(a,b,c){b=L(b,a);a=L(c,a);return 0==b.lastIndexOf(a,0)},2);R("string",3,!1,!0,function(a,b){return b?L(b,a):z(a.a)},0,1);
R("string-length",1,!1,!0,function(a,b){return(b?L(b,a):z(a.a)).length},0,1);R("substring",3,!1,!1,function(a,b,c,d){c=K(c,a);if(isNaN(c)||Infinity==c||-Infinity==c)return"";d=d?K(d,a):Infinity;if(isNaN(d)||-Infinity===d)return"";c=Math.round(c)-1;var e=Math.max(c,0);a=L(b,a);return Infinity==d?a.substring(e):a.substring(e,c+Math.round(d))},2,3);R("substring-after",3,!1,!1,function(a,b,c){b=L(b,a);a=L(c,a);c=b.indexOf(a);return-1==c?"":b.substring(c+a.length)},2);
R("substring-before",3,!1,!1,function(a,b,c){b=L(b,a);a=L(c,a);a=b.indexOf(a);return-1==a?"":b.substring(0,a)},2);R("sum",1,!1,!1,function(a,b){for(var c=H(b.a(a)),d=0,e=I(c);e;e=I(c))d+=+z(e);return d},1,1,!0);R("translate",3,!1,!1,function(a,b,c,d){b=L(b,a);c=L(c,a);var e=L(d,a);a={};for(d=0;d<c.length;d++){var f=c.charAt(d);f in a||(a[f]=e.charAt(d))}c="";for(d=0;d<b.length;d++)f=b.charAt(d),c+=f in a?a[f]:f;return c},3);R("true",2,!1,!1,function(){return!0},0);function G(a,b){this.h=a;this.c=void 0!==b?b:null;this.b=null;switch(a){case "comment":this.b=8;break;case "text":this.b=3;break;case "processing-instruction":this.b=7;break;case "node":break;default:throw Error("Unexpected argument");}}function db(a){return"comment"==a||"text"==a||"processing-instruction"==a||"node"==a}G.prototype.a=function(a){return null===this.b||this.b==a.nodeType};G.prototype.f=function(){return this.h};
G.prototype.toString=function(){var a="Kind Test: "+this.h;null===this.c||(a+=J(this.c));return a};function eb(a){this.b=a;this.a=0}function fb(a){a=a.match(gb);for(var b=0;b<a.length;b++)hb.test(a[b])&&a.splice(b,1);return new eb(a)}var gb=/\$?(?:(?![0-9-\.])(?:\*|[\w-\.]+):)?(?![0-9-\.])(?:\*|[\w-\.]+)|\/\/|\.\.|::|\d+(?:\.\d*)?|\.\d+|"[^"]*"|'[^']*'|[!<>]=|\s+|./g,hb=/^\s/;function S(a,b){return a.b[a.a+(b||0)]}function T(a){return a.b[a.a++]}function ib(a){return a.b.length<=a.a};function jb(a){n.call(this,3);this.c=a.substring(1,a.length-1)}m(jb);jb.prototype.a=function(){return this.c};jb.prototype.toString=function(){return"Literal: "+this.c};function E(a,b){this.j=a.toLowerCase();var c;c="*"==this.j?"*":"http://www.w3.org/1999/xhtml";this.c=b?b.toLowerCase():c}E.prototype.a=function(a){var b=a.nodeType;if(1!=b&&2!=b)return!1;b=void 0!==a.localName?a.localName:a.nodeName;return"*"!=this.j&&this.j!=b.toLowerCase()?!1:"*"==this.c?!0:this.c==(a.namespaceURI?a.namespaceURI.toLowerCase():"http://www.w3.org/1999/xhtml")};E.prototype.f=function(){return this.j};
E.prototype.toString=function(){return"Name Test: "+("http://www.w3.org/1999/xhtml"==this.c?"":this.c+":")+this.j};function kb(a,b){n.call(this,a.i);this.h=a;this.c=b;this.g=a.g;this.b=a.b;if(1==this.c.length){var c=this.c[0];c.u||c.c!=lb||(c=c.o,"*"!=c.f()&&(this.f={name:c.f(),s:null}))}}m(kb);function mb(){n.call(this,4)}m(mb);mb.prototype.a=function(a){var b=new C;a=a.a;9==a.nodeType?F(b,a):F(b,a.ownerDocument);return b};mb.prototype.toString=function(){return"Root Helper Expression"};function nb(){n.call(this,4)}m(nb);nb.prototype.a=function(a){var b=new C;F(b,a.a);return b};nb.prototype.toString=function(){return"Context Helper Expression"};
function ob(a){return"/"==a||"//"==a}kb.prototype.a=function(a){var b=this.h.a(a);if(!(b instanceof C))throw Error("Filter expression must evaluate to nodeset.");a=this.c;for(var c=0,d=a.length;c<d&&b.l;c++){var e=a[c],f=H(b,e.c.a),g;if(e.g||e.c!=pb)if(e.g||e.c!=qb)for(g=I(f),b=e.a(new Q(g));null!=(g=I(f));)g=e.a(new Q(g)),b=Pa(b,g);else g=I(f),b=e.a(new Q(g));else{for(g=I(f);(b=I(f))&&(!g.contains||g.contains(b))&&b.compareDocumentPosition(g)&8;g=b);b=e.a(new Q(g))}}return b};
kb.prototype.toString=function(){var a;a="Path Expression:"+J(this.h);if(this.c.length){var b=t(this.c,function(a,b){return a+J(b)},"Steps:");a+=J(b)}return a};function rb(a){n.call(this,4);this.c=a;Ua(this,ja(this.c,function(a){return a.g}));Va(this,ja(this.c,function(a){return a.b}))}m(rb);rb.prototype.a=function(a){var b=new C;r(this.c,function(c){c=c.a(a);if(!(c instanceof C))throw Error("Path expression must evaluate to NodeSet.");b=Pa(b,c)});return b};rb.prototype.toString=function(){return t(this.c,function(a,b){return a+J(b)},"Union Expression:")};function sb(a,b){this.a=a;this.b=!!b}
function $a(a,b,c){for(c=c||0;c<a.a.length;c++)for(var d=a.a[c],e=H(b),f=b.l,g,h=0;g=I(e);h++){var p=a.b?f-h:h+1;g=d.a(new Q(g,p,f));if("number"==typeof g)p=p==g;else if("string"==typeof g||"boolean"==typeof g)p=!!g;else if(g instanceof C)p=0<g.l;else throw Error("Predicate.evaluate returned an unexpected type.");if(!p){p=e;g=p.f;var y=p.a;if(!y)throw Error("Next must be called at least once before remove.");var D=y.b,y=y.a;D?D.a=y:g.a=y;y?y.b=D:g.b=D;g.l--;p.a=null}}return b}
sb.prototype.toString=function(){return t(this.a,function(a,b){return a+J(b)},"Predicates:")};function U(a,b,c,d){n.call(this,4);this.c=a;this.o=b;this.h=c||new sb([]);this.u=!!d;b=this.h;b=0<b.a.length?b.a[0].f:null;a.b&&b&&(a=b.name,a=w?a.toLowerCase():a,this.f={name:a,s:b.s});a:{a=this.h;for(b=0;b<a.a.length;b++)if(c=a.a[b],c.g||1==c.i||0==c.i){a=!0;break a}a=!1}this.g=a}m(U);
U.prototype.a=function(a){var b=a.a,c=null,c=this.f,d=null,e=null,f=0;c&&(d=c.name,e=c.s?L(c.s,a):null,f=1);if(this.u)if(this.g||this.c!=tb)if(a=H((new U(ub,new G("node"))).a(a)),b=I(a))for(c=this.m(b,d,e,f);null!=(b=I(a));)c=Pa(c,this.m(b,d,e,f));else c=new C;else c=B(this.o,b,d,e),c=$a(this.h,c,f);else c=this.m(a.a,d,e,f);return c};U.prototype.m=function(a,b,c,d){a=this.c.f(this.o,a,b,c);return a=$a(this.h,a,d)};
U.prototype.toString=function(){var a;a="Step:"+J("Operator: "+(this.u?"//":"/"));this.c.j&&(a+=J("Axis: "+this.c));a+=J(this.o);if(this.h.a.length){var b=t(this.h.a,function(a,b){return a+J(b)},"Predicates:");a+=J(b)}return a};function vb(a,b,c,d){this.j=a;this.f=b;this.a=c;this.b=d}vb.prototype.toString=function(){return this.j};var wb={};function V(a,b,c,d){if(wb.hasOwnProperty(a))throw Error("Axis already created: "+a);b=new vb(a,b,c,!!d);return wb[a]=b}
V("ancestor",function(a,b){for(var c=new C,d=b;d=d.parentNode;)a.a(d)&&Qa(c,d);return c},!0);V("ancestor-or-self",function(a,b){var c=new C,d=b;do a.a(d)&&Qa(c,d);while(d=d.parentNode);return c},!0);
var lb=V("attribute",function(a,b){var c=new C,d=a.f();if("style"==d&&w&&b.style)return F(c,new x(b.style,b,"style",b.style.cssText)),c;var e=b.attributes;if(e)if(a instanceof G&&null===a.b||"*"==d)for(var d=0,f;f=e[d];d++)w?f.nodeValue&&F(c,Da(b,f)):F(c,f);else(f=e.getNamedItem(d))&&(w?f.nodeValue&&F(c,Da(b,f)):F(c,f));return c},!1),tb=V("child",function(a,b,c,d,e){return(w?Ia:Ja).call(null,a,b,l(c)?c:null,l(d)?d:null,e||new C)},!1,!0);V("descendant",B,!1,!0);
var ub=V("descendant-or-self",function(a,b,c,d){var e=new C;A(b,c,d)&&a.a(b)&&F(e,b);return B(a,b,c,d,e)},!1,!0),pb=V("following",function(a,b,c,d){var e=new C;do for(var f=b;f=f.nextSibling;)A(f,c,d)&&a.a(f)&&F(e,f),e=B(a,f,c,d,e);while(b=b.parentNode);return e},!1,!0);V("following-sibling",function(a,b){for(var c=new C,d=b;d=d.nextSibling;)a.a(d)&&F(c,d);return c},!1);V("namespace",function(){return new C},!1);
var xb=V("parent",function(a,b){var c=new C;if(9==b.nodeType)return c;if(2==b.nodeType)return F(c,b.ownerElement),c;var d=b.parentNode;a.a(d)&&F(c,d);return c},!1),qb=V("preceding",function(a,b,c,d){var e=new C,f=[];do f.unshift(b);while(b=b.parentNode);for(var g=1,h=f.length;g<h;g++){var p=[];for(b=f[g];b=b.previousSibling;)p.unshift(b);for(var y=0,D=p.length;y<D;y++)b=p[y],A(b,c,d)&&a.a(b)&&F(e,b),e=B(a,b,c,d,e)}return e},!0,!0);
V("preceding-sibling",function(a,b){for(var c=new C,d=b;d=d.previousSibling;)a.a(d)&&Qa(c,d);return c},!0);var yb=V("self",function(a,b){var c=new C;a.a(b)&&F(c,b);return c},!1);function zb(a){n.call(this,1);this.c=a;this.g=a.g;this.b=a.b}m(zb);zb.prototype.a=function(a){return-K(this.c,a)};zb.prototype.toString=function(){return"Unary Expression: -"+J(this.c)};function Ab(a){n.call(this,1);this.c=a}m(Ab);Ab.prototype.a=function(){return this.c};Ab.prototype.toString=function(){return"Number: "+this.c};function Bb(a,b){this.a=a;this.b=b}function Cb(a){for(var b,c=[];;){W(a,"Missing right hand side of binary expression.");b=Db(a);var d=T(a.a);if(!d)break;var e=(d=Ya[d]||null)&&d.w;if(!e){a.a.a--;break}for(;c.length&&e<=c[c.length-1].w;)b=new N(c.pop(),c.pop(),b);c.push(b,d)}for(;c.length;)b=new N(c.pop(),c.pop(),b);return b}function W(a,b){if(ib(a.a))throw Error(b);}function Eb(a,b){var c=T(a.a);if(c!=b)throw Error("Bad token, expected: "+b+" got: "+c);}
function Fb(a){a=T(a.a);if(")"!=a)throw Error("Bad token: "+a);}function Gb(a){a=T(a.a);if(2>a.length)throw Error("Unclosed literal string");return new jb(a)}
function Hb(a){var b,c=[],d;if(ob(S(a.a))){b=T(a.a);d=S(a.a);if("/"==b&&(ib(a.a)||"."!=d&&".."!=d&&"@"!=d&&"*"!=d&&!/(?![0-9])[\w]/.test(d)))return new mb;d=new mb;W(a,"Missing next location step.");b=Ib(a,b);c.push(b)}else{a:{b=S(a.a);d=b.charAt(0);switch(d){case "$":throw Error("Variable reference not allowed in HTML XPath");case "(":T(a.a);b=Cb(a);W(a,'unclosed "("');Eb(a,")");break;case '"':case "'":b=Gb(a);break;default:if(isNaN(+b))if(!db(b)&&/(?![0-9])[\w]/.test(d)&&"("==S(a.a,1)){b=T(a.a);
b=cb[b]||null;T(a.a);for(d=[];")"!=S(a.a);){W(a,"Missing function argument list.");d.push(Cb(a));if(","!=S(a.a))break;T(a.a)}W(a,"Unclosed function argument list.");Fb(a);b=new ab(b,d)}else{b=null;break a}else b=new Ab(+T(a.a))}"["==S(a.a)&&(d=new sb(Jb(a)),b=new Za(b,d))}if(b)if(ob(S(a.a)))d=b;else return b;else b=Ib(a,"/"),d=new nb,c.push(b)}for(;ob(S(a.a));)b=T(a.a),W(a,"Missing next location step."),b=Ib(a,b),c.push(b);return new kb(d,c)}
function Ib(a,b){var c,d,e;if("/"!=b&&"//"!=b)throw Error('Step op should be "/" or "//"');if("."==S(a.a))return d=new U(yb,new G("node")),T(a.a),d;if(".."==S(a.a))return d=new U(xb,new G("node")),T(a.a),d;var f;if("@"==S(a.a))f=lb,T(a.a),W(a,"Missing attribute name");else if("::"==S(a.a,1)){if(!/(?![0-9])[\w]/.test(S(a.a).charAt(0)))throw Error("Bad token: "+T(a.a));c=T(a.a);f=wb[c]||null;if(!f)throw Error("No axis with name: "+c);T(a.a);W(a,"Missing node name")}else f=tb;c=S(a.a);if(/(?![0-9])[\w\*]/.test(c.charAt(0)))if("("==
S(a.a,1)){if(!db(c))throw Error("Invalid node type: "+c);c=T(a.a);if(!db(c))throw Error("Invalid type name: "+c);Eb(a,"(");W(a,"Bad nodetype");e=S(a.a).charAt(0);var g=null;if('"'==e||"'"==e)g=Gb(a);W(a,"Bad nodetype");Fb(a);c=new G(c,g)}else if(c=T(a.a),e=c.indexOf(":"),-1==e)c=new E(c);else{var g=c.substring(0,e),h;if("*"==g)h="*";else if(h=a.b(g),!h)throw Error("Namespace prefix not declared: "+g);c=c.substr(e+1);c=new E(c,h)}else throw Error("Bad token: "+T(a.a));e=new sb(Jb(a),f.a);return d||
new U(f,c,e,"//"==b)}function Jb(a){for(var b=[];"["==S(a.a);){T(a.a);W(a,"Missing predicate expression.");var c=Cb(a);b.push(c);W(a,"Unclosed predicate expression.");Eb(a,"]")}return b}function Db(a){if("-"==S(a.a))return T(a.a),new zb(Db(a));var b=Hb(a);if("|"!=S(a.a))a=b;else{for(b=[b];"|"==T(a.a);)W(a,"Missing next union location path."),b.push(Hb(a));a.a.a--;a=new rb(b)}return a};function Kb(a){switch(a.nodeType){case 1:return ea(Lb,a);case 9:return Kb(a.documentElement);case 11:case 10:case 6:case 12:return Mb;default:return a.parentNode?Kb(a.parentNode):Mb}}function Mb(){return null}function Lb(a,b){if(a.prefix==b)return a.namespaceURI||"http://www.w3.org/1999/xhtml";var c=a.getAttributeNode("xmlns:"+b);return c&&c.specified?c.value||null:a.parentNode&&9!=a.parentNode.nodeType?Lb(a.parentNode,b):null};function Nb(a,b){if(!a.length)throw Error("Empty XPath expression.");var c=fb(a);if(ib(c))throw Error("Invalid XPath expression.");b?"function"==aa(b)||(b=da(b.lookupNamespaceURI,b)):b=function(){return null};var d=Cb(new Bb(c,b));if(!ib(c))throw Error("Bad token: "+T(c));this.evaluate=function(a,b){var c=d.a(new Q(a));return new Y(c,b)}}
function Y(a,b){if(0==b)if(a instanceof C)b=4;else if("string"==typeof a)b=2;else if("number"==typeof a)b=1;else if("boolean"==typeof a)b=3;else throw Error("Unexpected evaluation result.");if(2!=b&&1!=b&&3!=b&&!(a instanceof C))throw Error("value could not be converted to the specified type");this.resultType=b;var c;switch(b){case 2:this.stringValue=a instanceof C?Sa(a):""+a;break;case 1:this.numberValue=a instanceof C?+Sa(a):+a;break;case 3:this.booleanValue=a instanceof C?0<a.l:!!a;break;case 4:case 5:case 6:case 7:var d=
H(a);c=[];for(var e=I(d);e;e=I(d))c.push(e instanceof x?e.a:e);this.snapshotLength=a.l;this.invalidIteratorState=!1;break;case 8:case 9:d=Ra(a);this.singleNodeValue=d instanceof x?d.a:d;break;default:throw Error("Unknown XPathResult type.");}var f=0;this.iterateNext=function(){if(4!=b&&5!=b)throw Error("iterateNext called with wrong result type");return f>=c.length?null:c[f++]};this.snapshotItem=function(a){if(6!=b&&7!=b)throw Error("snapshotItem called with wrong result type");return a>=c.length||
0>a?null:c[a]}}Y.ANY_TYPE=0;Y.NUMBER_TYPE=1;Y.STRING_TYPE=2;Y.BOOLEAN_TYPE=3;Y.UNORDERED_NODE_ITERATOR_TYPE=4;Y.ORDERED_NODE_ITERATOR_TYPE=5;Y.UNORDERED_NODE_SNAPSHOT_TYPE=6;Y.ORDERED_NODE_SNAPSHOT_TYPE=7;Y.ANY_UNORDERED_NODE_TYPE=8;Y.FIRST_ORDERED_NODE_TYPE=9;function Ob(a){this.lookupNamespaceURI=Kb(a)}
function Pb(a,b){var c=a||k,d=c.Document&&c.Document.prototype||c.document;if(!d.evaluate||b)c.XPathResult=Y,d.evaluate=function(a,b,c,d){return(new Nb(a,c)).evaluate(b,d)},d.createExpression=function(a,b){return new Nb(a,b)},d.createNSResolver=function(a){return new Ob(a)}}var Qb=["wgxpath","install"],Z=k;Qb[0]in Z||!Z.execScript||Z.execScript("var "+Qb[0]);for(var Rb;Qb.length&&(Rb=Qb.shift());)Qb.length||void 0===Pb?Z[Rb]?Z=Z[Rb]:Z=Z[Rb]={}:Z[Rb]=Pb;}).call(this)
TP.boot.$$srcPath = '';

        
        TP.registerExternalObject('wgxpath', window.wgxpath);
        TP.extern.wgxpath.install();
        
    
TP.boot.$$srcPath = '~lib_deps/jquery.xpath-tpi.min.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
/*
 * jQuery XPath plugin v0.3.1
 * https://github.com/ilinsky/jquery-xpath
 * Copyright 2015, Sergey Ilinsky
 * Dual licensed under the MIT and GPL licenses.
 *
 * Includes xpath.js - XPath 2.0 implementation in JavaScript
 * https://github.com/ilinsky/xpath.js
 * Copyright 2015, Sergey Ilinsky
 * Dual licensed under the MIT and GPL licenses.
 *
 */
(function(p,a,c,k,e,d){for(k=a[d[1]]-1;k>=0;k--)c+=e[d[435]][d[254]](a[d[175]](k)-1);a=c[d[48]](' ');for(k=a[d[1]]-1;k>=0;k--)p=p[d[38]](e[d[421]](k%10+(e[d[435]][d[254]](122-e[d[409]][d[216]](k/10))),'g'),a[k]);e[d[408]]('_','$',p)(d,d[0])})("8y by=6x7x4358x,O=6x7x4348x,bh=6x7x4318x,bj=6x7x4328x,K=6x7x4338x,br=6x7x4218x,U=6x7x4208x,b3=6x7x4088x,bd=6x7x4098x,W=6x7x4108x,bB=6x7x4078x,bE=6x7x4068x,dc=6x7x4038x,db=6x7x4048x,fP=6x7x4058x,fD=6x7x1688x,eW=6x7x4118x,eV=6x7x4128x,eX=6x7x4188x,eP=(9z2w{3y by9x7x3458x?9z(jO){3y by(jO)7x3458x2w}:9z(jO){3y by(jO)7x388x(/^\\s+|\\s+$/g,'')}})2w,cE=(9z2w{3y K9x7x458x?9z(r,jY){3y r7x458x(jY)}:9z(r,jY){8z(8y fC=0,fJ=r7x18x;fC<fJ;fC2v)0y(r[fC]6w=jY)3y fC;3y-1}})2w;8y iy=_[362],ix=_[361],iw=_[360],iv=_[357];9z X(ij){5x7x678x=ij;5x7x4198x=gD[ij]};X9x=2y W;8y gD=1w;gD7x758x=\"Evaluation of an expression relies on some part of the dynamic context that has not been assigned a value.\";gD7x128x=\"Expression is not a valid 0zstance of the grammar\";gD7x98x=\"Type is not appropriate8zthe context 0z which the expression occurs\";gD7x2928x=\"Expression refers to an element name,attribute name,schema type name,namespace prefix,or 8yiable name that is not def0zed 0z the static context\";gD7x3568x=\"Axis not supported\";gD7x468x=\"Expanded QName and number of 4x 0z a 9z calldonot match the name and arity of a 9z signature\";gD7x3538x=\"The result of the last step 0z a path expression conta0zs both nodes and atomic values\";gD7x2948x=\"The result of a step(other than the last step)0z a path expression conta0zs an atomic value.\";gD7x1968x=\"In an axis step,the context item is not a node.\";gD7x1008x=\"It is a static error0ya QName that is used as an AtomibD 0z a SequenceType is not def0zed 0z the 0z-scope schema types as an atomic type.\";gD7x3088x=\"A QName used 0z an expression conta0zs a namespace prefix that cannot be expanded 0zto a namespace URI by us0zg the statically known namespaces.\";gD7x338x=\"Invalid value8zcast/constructor.\";gD7x1888x=\"fn:zero-or-one called0xa sequence conta0z0zg more than one item.\";gD7x1878x=\"fn:one-or-more called0xa sequence conta0z0zg no items.\";gD7x1848x=\"fn:exactly-one called0xa sequence conta0z0zg zero or more than one item.\";gD7x698x=\"Invalid argument type.\";gD7x2248x=\"No context document.\";gD7x2108x=\"Invalid regular expression flags.\";gD7x958x=\"Invalid lexical value.\";gD7x2228x=\"Unsupported collation.\";gD7x1988x=\"No namespace found8zprefix.\";9z bb(jO){8y j=jO7x258x(/\\$?(?:(?![0-9-])(?:[\\w-]+|\\*):)?(?![0-9-])(?:[\\w-]+|\\*)|\\(:|:\\)|\\/\\/|\\.\\.|::|\\d+(?:\\.\\d*)?(?:[eE][+-]?\\d+)?|\\.\\d+(?:[eE][+-]?\\d+)?|\"[^\"]*(?:\"\"[^\"]*)*\"|'[^']*(?:''[^']*)*'|<<|>>|[!<>]=|(?![0-9-])[\\w-]+:\\*|\\s+|./g);0y(j){8y f6=0;8z(8y fC=0,fJ=j7x18x;fC<fJ;fC2v)0y(j[fC]6w'(:')f62v;7z 0y(j[fC]6w':)'3wf6)f63v;7z 0y(!f63w!/^\\s/7x378x(j[fC]))5x[5x7x18x2v]=j[fC];0y(f6)4y 2y X(_[12])}};bb9x7x788x=0;bb9x7x18x=0;bb9x7x4178x=9z2w{5x7x788x=0};bb9x7x58x=9z(fS){3y 5x[5x7x788x+(fS4w0)]4w''};bb9x7x138x=9z(fS){3y(5x7x788x0vfS4w1)<5x7x18x};bb9x7x4168x=9z(fS){3y(5x7x788x1vfS4w1)>0};bb9x7x148x=9z2w{3y 5x7x788x5v5x7x18x};9z T2w1w;T9x7x368x=9z(g0){3y g03w7wg07x278x};T9x7x288x=9z(g0,iz){3y g0[iz]};T9x7x1178x=9z(g0,h2){3y g06wh2};T9x7x628x=9z(g0,h2){3y g07x628x(h2)};T9x7x558x=9z(g0,iE){3y g07x558x(iE)};T9x7x1218x=9z(g0,iq){3y g07x1218x(iq)};T9x7x988x=9z(g0,iA,iu){3y g07x988x(iA,iu)};9z V(hw,jY,hn,gv){5x7x538x=hw;5x7x268x=jY;5x7x518x=hn4w1w;5x7x498x=1w;5x7x248x=gv4w2y T;8y gw=2y U,fS=gw7x4138x2w;5x7x708x=2y cS(gw7x4148x2w,gw7x4158x2w+1,gw7x4388x2w,gw7x4398x2w,gw7x1948x2w,gw7x4648x2w+gw7x4658x2w/1000,-fS);5x7x48x=2y cT(0,bd7x408x(~~(fS/60)),bd7x408x(fS%60),0,fS>0)};V9x7x268x=2x;V9x7x768x=0;V9x7x948x=0;V9x7x518x=2x;V9x7x498x=2x;V9x7x708x=2x;V9x7x48x=2x;V9x7x538x=2x;V9x7x1398x=9z(iz,j2){0y(!5x7x498x7x1418x(iz))5x7x498x[iz]=0w;5x7x498x[iz]7x108x(5x7x518x[iz]);5x7x518x[iz]=j2};V9x7x1368x=9z(iz){0y(5x7x498x7x1418x(iz)){5x7x518x[iz]=5x7x498x[iz]7x1778x2w;0y(!5x7x498x[iz]7x18x){6z 5x7x498x[iz];0y(5y 5x7x518x[iz]6w_[167])6z 5x7x518x[iz]}}};9z bw2w{5x7x1118x=1w;5x7x1728x=1w;5x7x1098x=1w;5x7x1078x=1w;5x7x1338x=1w};bw9x7x838x=2x;bw9x7x1118x=2x;bw9x7x1728x=2x;bw9x7x1098x=2x;bw9x7x878x=2x;bw9x7x1078x=2x;bw9x7x1748x=ix+_[223];bw9x7x1338x=2x;bw9x7x1148x=2x;bw9x7x1408x=2x;8y hP=/^(?:\\{([^\\}]+)\\})?(.+)$/;bw9x7x4638x=9z(jN,dU){8y j=jN7x258x(hP);0y(j)0y(j[1]9wiy)5x7x1118x[jN]=dU};bw9x7x1068x=9z(jN){8y j=jN7x258x(hP);0y(j)3y j[1]6wiy?el[br.$2]:5x7x1118x[jN]};bw9x7x4628x=9z(jN,dU){5x7x1728x[jN]=dU};bw9x7x4598x=9z(jN,dU){8y j=jN7x258x(hP);0y(j)0y(j[1]9wix)5x7x1098x[jN]=dU};bw9x7x1788x=9z(jN){8y j=jN7x258x(hP);0y(j)3y j[1]6wix?fm[br.$2]:5x7x1098x[jN]};bw9x7x4608x=9z(jN,dU){5x7x1078x[jN]=dU};bw9x7x2518x=9z(jN){3y 5x7x1078x[jN]};bw9x7x4618x=9z(jN,dU){5x7x1338x[jN]=dU};bw9x7x738x=9z(iE){8y hj=5x7x1148x,eF=hj3whj7x558x?hj7x558x:hj,iA;0y(eF 1y b33w(iA=eF7x218x(hj,iE)))3y iA;0y(iE6w'fn')3y ix;0y(iE6w'xs')3y iy;0y(iE6w_[291])3y iv;0y(iE6w_[82])3y iw;4y 2y X(_[308])};bw7x4668x=9z(jY){0y(5y jY6w_[118])jY=2y bO(jY);7z 0y(5y jY6w_[271])jY=(dc(jY)4w!db(jY))?2y cV(jY):dl(by(jY));7z jY=2y cl(by(jY));3y jY};bw7x2208x=9z(jY){0y(jY 1y bO)jY=jY7x28x2w;7z 0y(eZ(jY))jY=jY7x28x2w;7z jY=jY7x318x2w;3y jY};8y fm=1w,fo=1w,el=1w,fn=1w;9z eL(iz,k,dU){fm[iz]=dU;fo[iz]=k};9z eK(iz,dU){el[iz]=dU};9z b0(_d,hw){8y gV=2y bb(_d),gE=dR(gV,hw);0y(!gV7x148x2w)4y 2y X(_[12]);0y(!gE)4y 2y X(_[12]);5x7x1298x=gE};b09x7x1298x=2x;b09x7x88x=9z(gu){3y 5x7x1298x7x88x(gu)};9z bz2w1w;bz9x7x2448x=9z(jP,jQ){4y \"Not implemented\"};bz9x7x508x=9z(jP,jQ){4y \"Not implemented\"};9z cQ2w1w;cQ7x3248x=1;cQ7x3128x=2;cQ7x2128x=3;cQ7x3418x=4;cQ7x2888x=5;cQ7x3448x=6;cQ7x3178x=7;cQ7x3508x=8;cQ7x3078x=9;cQ7x3188x=10;cQ7x3028x=11;cQ7x3058x=12;cQ7x2848x=13;cQ7x2858x=14;cQ7x2908x=15;cQ7x3048x=16;cQ7x3218x=17;cQ7x3238x=18;cQ7x3148x=19;cQ7x2998x=20;cQ7x3298x=21;cQ7x3308x=22;cQ7x2198x=23;cQ7x1868x=24;cQ7x3328x=25;cQ7x2098x=26;cQ7x2138x=27;cQ7x4678x=28;cQ7x2048x=29;cQ7x2808x=30;cQ7x2828x=31;cQ7x2788x=32;cQ7x2778x=33;cQ7x2738x=34;cQ7x2758x=35;cQ7x2768x=36;cQ7x2838x=37;cQ7x3528x=38;cQ7x3388x=39;cQ7x3258x=40;cQ7x3338x=41;cQ7x3478x=42;cQ7x4738x=43;cQ7x4748x=44;cQ7x4728x=45;cQ7x4718x=46;cQ7x4688x=47;cQ7x2798x=48;cQ7x4698x=49;cQ7x3268x=50;cQ7x3398x=51;cQ7x2958x=-1;cQ7x3108x=-2;9z Y2w{5x7x168x=0w};Y9x7x168x=2x;9z dR(gV,hw){8y gN;0y(gV7x148x2w4w!(gN=dQ(gV,hw)))3y;8y gE=2y Y;gE7x168x7x108x(gN);9y(gV7x58x2w6w','){gV7x138x2w;0y(gV7x148x2w4w!(gN=dQ(gV,hw)))4y 2y X(_[12]);gE7x168x7x108x(gN)}3y gE};Y9x7x88x=9z(gu){8y hq=0w;8z(8y fC=0,fJ=5x7x168x7x18x;fC<fJ;fC2v)hq=fn7x2458x7x218x(gu,hq,5x7x168x[fC]7x88x(gu));3y hq};9z Z2w1w;9z dQ(gV,hw){0y(!gV7x148x2w)3y d8(gV,hw)4wdT(gV,hw)4weC(gV,hw)4wey(gV,hw)};9z b22w{5x7x448x=0w;5x7x1138x=2x};b29x7x448x=2x;b29x7x1138x=2x;9z dT(gV,hw){0y(gV7x58x2w6w_[369]3wgV7x58x(1)7x848x(0,1)6w'$'){gV7x138x2w;8y gI=2y b2,gE;do{gI7x448x7x108x(eH(gV,hw))}9y(gV7x58x2w6w','3wgV7x138x2w);0y(gV7x58x2w9w_[401])4y 2y X(_[12]);gV7x138x2w;0y(gV7x148x2w4w!(gE=dQ(gV,hw)))4y 2y X(_[12]);gI7x1138x=gE;3y gI}};b29x7x88x=9z(gu){8y hq=0w;(9z(hp,fs){8y go=hp7x448x[fs2v],hr=go7x808x7x88x(gu),jN=(go7x178x?'{'+go7x178x+'}':'')+go7x208x;8z(8y fC=0,fJ=hr7x18x;fC<fJ;fC2v){gu7x1398x(jN,hr[fC]);0y(fs<hp7x448x7x18x)4x7x1038x(hp,fs);7z hq=hq7x968x(hp7x1138x7x88x(gu));gu7x1368x(jN)}})(5x,0);3y hq};9z bt(iE,iu,iA,gL){5x7x308x=iE;5x7x208x=iu;5x7x178x=iA;5x7x808x=gL};bt9x7x308x=2x;bt9x7x208x=2x;bt9x7x178x=2x;bt9x7x808x=2x;9z eH(gV,hw){8y j=gV7x58x2w7x848x(1)7x258x(hM);0y(!j)4y 2y X(_[12]);0y(j[1]6w'*'4wj[2]6w'*')4y 2y X(_[12]);gV7x138x2w;0y(gV7x58x2w9w_[193])4y 2y X(_[12]);gV7x138x2w;8y gE;0y(gV7x148x2w4w!(gE=dQ(gV,hw)))4y 2y X(_[12]);3y 2y bt(j[1]4w2x,j[2],j[1]?hw7x738x(j[1]):2x,gE)};9z b5(gs,hz,gC){5x7x1388x=gs;5x7x1288x=hz;5x7x1428x=gC};b59x7x1388x=2x;b59x7x1288x=2x;b59x7x1428x=2x;9z d8(gV,hw){8y gs,hz,gC;0y(gV7x58x2w6w_[358]3wgV7x58x(1)6w'('){gV7x138x(2);0y(gV7x148x2w4w!(gs=dR(gV,hw)))4y 2y X(_[12]);0y(gV7x58x2w9w')')4y 2y X(_[12]);gV7x138x2w;0y(gV7x58x2w9w_[359])4y 2y X(_[12]);gV7x138x2w;0y(gV7x148x2w4w!(hz=dQ(gV,hw)))4y 2y X(_[12]);0y(gV7x58x2w9w_[354])4y 2y X(_[12]);gV7x138x2w;0y(gV7x148x2w4w!(gC=dQ(gV,hw)))4y 2y X(_[12]);3y 2y b5(gs,hz,gC)}};b59x7x88x=9z(gu){3y 5x[d5(5x7x1388x7x88x(gu),gu)?_[128]:_[1428x7x88x(gu)};9z bo(iG){5x7x1318x=iG;5x7x448x=0w;5x7x1028x=2x};bo9x7x448x=2x;bo9x7x1318x=2x;bo9x7x1028x=2x;9z eC(gV,hw){8y iG=gV7x58x2w;0y((iG6w_[355]4wiG6w_[259])3wgV7x58x(1)7x848x(0,1)6w'$'){gV7x138x2w;8y hg=2y bo(iG),gE;do{hg7x448x7x108x(eI(gV,hw))}9y(gV7x58x2w6w','3wgV7x138x2w);0y(gV7x58x2w9w_[388])4y 2y X(_[12]);gV7x138x2w;0y(gV7x148x2w4w!(gE=dQ(gV,hw)))4y 2y X(_[12]);hg7x1028x=gE;3y hg}};bo9x7x88x=9z(gu){8y u=5x7x1318x6w_[259],E=u?3x:1x;(9z(hp,fs){8y go=hp7x448x[fs2v],hr=go7x808x7x88x(gu),jN=(go7x178x?'{'+go7x178x+'}':'')+go7x208x;8z(8y fC=0,fJ=hr7x18x;(fC<fJ)3w(u?E:!E);fC2v){gu7x1398x(jN,hr[fC]);0y(fs<hp7x448x7x18x)4x7x1038x(hp,fs);7z E=d5(hp7x1028x7x88x(gu),gu);gu7x1368x(jN)}})(5x,0);3y [2y bO(E)]};9z bu(iE,iu,iA,gL){5x7x308x=iE;5x7x208x=iu;5x7x178x=iA;5x7x808x=gL};bu9x7x308x=2x;bu9x7x208x=2x;bu9x7x178x=2x;bu9x7x808x=2x;9z eI(gV,hw){8y j=gV7x58x2w7x848x(1)7x258x(hM);0y(!j)4y 2y X(_[12]);0y(j[1]6w'*'4wj[2]6w'*')4y 2y X(_[12]);gV7x138x2w;0y(gV7x58x2w9w_[193])4y 2y X(_[12]);gV7x138x2w;8y gE;0y(gV7x148x2w4w!(gE=dQ(gV,hw)))4y 2y X(_[12]);3y 2y bu(j[1]4w2x,j[2],j[1]?hw7x738x(j[1]):2x,gE)};9z R(gT,hl,iC){5x7x328x=gT;5x7x638x=hl;5x7x528x=iC};R9x7x328x=2x;R9x7x638x=2x;R9x7x528x=2x;9z dO(gV,hw){8y gE,hl;0y(gV7x148x2w4w!(gE=eD(gV,hw)))3y;0y(!(gV7x58x2w0z ei))3y gE;8y iC=gV7x58x2w;gV7x138x2w;0y(gV7x148x2w4w!(hl=eD(gV,hw)))4y 2y X(_[12]);3y 2y R(gE,hl,iC)};R9x7x88x=9z(gu){8y hk=ei[5x7x528x](5x,gu);3y hk6w2x?0w:[hk]};9z dL(gE,gu){8y gT=d3(gE7x328x7x88x(gu),gu);0y(!gT7x18x)3y 2y bO(1x);8y hl=d3(gE7x638x7x88x(gu),gu);0y(!hl7x18x)3y 2y bO(1x);8y E=1x;8z(8y fH=0,fI=gT7x18x,y,jZ;(fH<fI)3w!E;fH2v){8z(8y f2=0,f3=hl7x18x,G,j1;(f2<f3)3w!E;f22v){jZ=gT[fH];j1=hl[f2];y=jZ 1y cs;G=j1 1y cs;0y(y3wG){jZ=cl7x38x(jZ);j1=cl7x38x(j1)}7z{0y(y){0y(j1 1y cT)jZ=cT7x38x(jZ);7z 0y(j1 1y ct)jZ=ct7x38x(jZ);7z 0y(j17x348x)jZ=el[j17x348x]7x38x(jZ)}7z 0y(G){0y(jZ 1y cT)j1=cT7x38x(j1);7z 0y(jZ 1y ct)j1=ct7x38x(j1);7z 0y(jZ7x348x)j1=el[jZ7x348x]7x38x(j1)}0y(jZ 1y bM)jZ=cl7x38x(jZ);0y(j1 1y bM)j1=cl7x38x(j1)}E=eh[ef[gE7x528x8x(jZ,j1,gu)7x28x2w}}3y 2y bO(E)};8y ef={'=':'eq','9w':'ne','>':'gt','<':'lt','5v':'ge','4v':'le'};9z dN(gE,gu){8y gT=d3(gE7x328x7x88x(gu),gu);0y(!gT7x18x)3y 2x;dV(gu,gT,'?');8y hl=d3(gE7x638x7x88x(gu),gu);0y(!hl7x18x)3y 2x;dV(gu,hl,'?');8y jZ=gT[0],j1=hl[0];0y(jZ 1y cs)jZ=cl7x38x(jZ);0y(j1 1y cs)j1=cl7x38x(j1);0y(jZ 1y bM)jZ=cl7x38x(jZ);0y(j1 1y bM)j1=cl7x38x(j1);3y eh[gE7x528x](jZ,j1,gu)};8y eh=1w;eh['eq']=9z(gT,hl,gu){8y iC='';0y(eZ(gT)){0y(eZ(hl))iC=_[130]}7z 0y(gT 1y bO){0y(hl 1y bO)iC=_[199]}7z 0y(gT 1y cl){0y(hl 1y cl)3y fn7x1308x7x218x(gu,fm7x508x7x218x(gu,gT,hl),2y c7(0))}7z 0y(gT 1y cR){0y(hl 1y cR)iC=_[255]}7z 0y(gT 1y cm){0y(hl 1y cm)iC=_[250]}7z 0y(gT 1y cS){0y(hl 1y cS)iC=_[258]}7z 0y(gT 1y cW){0y(hl 1y cW)iC=_[256]}7z 0y(gT 1y c3){0y(hl 1y c3)iC=_[252]}7z 0y(gT 1y c2){0y(hl 1y c2)iC=_[253]}7z 0y(gT 1y c1){0y(hl 1y c1)iC=_[260]}7z 0y(gT 1y c0){0y(hl 1y c0)iC=_[261]}7z 0y(gT 1y cZ){0y(hl 1y cZ)iC=_[268]}7z 0y(gT 1y cj){0y(hl 1y cj)iC=_[246]}7z 0y(gT 1y c4){0y(hl 1y c4)iC=_[182]}7z 0y(gT 1y bN){0y(hl 1y bN)iC=_[183]}0y(iC)3y fn[iC]7x218x(gu,gT,hl);4y 2y X(_[9])};eh['ne']=9z(gT,hl,gu){3y 2y bO(!eh['eq'](gT,hl,gu)7x28x2w)};eh['gt']=9z(gT,hl,gu){8y iC='';0y(eZ(gT)){0y(eZ(hl))iC=_[97]}7z 0y(gT 1y bO){0y(hl 1y bO)iC=_[152]}7z 0y(gT 1y cl){0y(hl 1y cl)3y fn7x978x7x218x(gu,fm7x508x7x218x(gu,gT,hl),2y c7(0))}7z 0y(gT 1y cR){0y(hl 1y cR)iC=_[145]}7z 0y(gT 1y cm){0y(hl 1y cm)iC=_[148]}7z 0y(gT 1y cS){0y(hl 1y cS)iC=_[151]}7z 0y(gT 1y ct){0y(hl 1y ct)iC=_[153]}7z 0y(gT 1y cT){0y(hl 1y cT)iC=_[155]}0y(iC)3y fn[iC]7x218x(gu,gT,hl);4y 2y X(_[9])};eh['lt']=9z(gT,hl,gu){8y iC='';0y(eZ(gT)){0y(eZ(hl))iC=_[99]}7z 0y(gT 1y bO){0y(hl 1y bO)iC=_[146]}7z 0y(gT 1y cl){0y(hl 1y cl)3y fn7x998x7x218x(gu,fm7x508x7x218x(gu,gT,hl),2y c7(0))}7z 0y(gT 1y cR){0y(hl 1y cR)iC=_[150]}7z 0y(gT 1y cm){0y(hl 1y cm)iC=_[144]}7z 0y(gT 1y cS){0y(hl 1y cS)iC=_[156]}7z 0y(gT 1y ct){0y(hl 1y ct)iC=_[159]}7z 0y(gT 1y cT){0y(hl 1y cT)iC=_[154]}0y(iC)3y fn[iC]7x218x(gu,gT,hl);4y 2y X(_[9])};eh['ge']=9z(gT,hl,gu){8y iC='';0y(eZ(gT)){0y(eZ(hl))iC=_[99]}7z 0y(gT 1y bO){0y(hl 1y bO)iC=_[146]}7z 0y(gT 1y cl){0y(hl 1y cl)3y fn7x978x7x218x(gu,fm7x508x7x218x(gu,gT,hl),2y c7(-1))}7z 0y(gT 1y cR){0y(hl 1y cR)iC=_[150]}7z 0y(gT 1y cm){0y(hl 1y cm)iC=_[144]}7z 0y(gT 1y cS){0y(hl 1y cS)iC=_[156]}7z 0y(gT 1y ct){0y(hl 1y ct)iC=_[159]}7z 0y(gT 1y cT){0y(hl 1y cT)iC=_[154]}0y(iC)3y 2y bO(!fn[iC]7x218x(gu,gT,hl)7x28x2w);4y 2y X(_[9])};eh['le']=9z(gT,hl,gu){8y iC='';0y(eZ(gT)){0y(eZ(hl))iC=_[97]}7z 0y(gT 1y bO){0y(hl 1y bO)iC=_[152]}7z 0y(gT 1y cl){0y(hl 1y cl)3y fn7x998x7x218x(gu,fm7x508x7x218x(gu,gT,hl),2y c7(1))}7z 0y(gT 1y cR){0y(hl 1y cR)iC=_[145]}7z 0y(gT 1y cm){0y(hl 1y cm)iC=_[148]}7z 0y(gT 1y cS){0y(hl 1y cS)iC=_[151]}7z 0y(gT 1y ct){0y(hl 1y ct)iC=_[153]}7z 0y(gT 1y cT){0y(hl 1y cT)iC=_[155]}0y(iC)3y 2y bO(!fn[iC]7x218x(gu,gT,hl)7x28x2w);4y 2y X(_[9])};9z dM(gE,gu){8y gT=gE7x328x7x88x(gu);0y(!gT7x18x)3y 2x;dV(gu,gT,'?');dW(gu,gT,cz);8y hl=gE7x638x7x88x(gu);0y(!hl7x18x)3y 2x;dV(gu,hl,'?');dW(gu,hl,cz);3y eg[gE7x528x](gT[0],hl[0],gu)};8y eg=1w;eg['is']=9z(gT,hl,gu){3y fn7x2878x7x218x(gu,gT,hl)};eg['>>']=9z(gT,hl,gu){3y fn7x2408x7x218x(gu,gT,hl)};eg['<<']=9z(gT,hl,gu){3y fn7x2418x7x218x(gu,gT,hl)};8y ei={'=':dL,'9w':dL,'<':dL,'4v':dL,'>':dL,'5v':dL,'eq':dN,'ne':dN,'lt':dN,'le':dN,'gt':dN,'ge':dN,'is':dM,'>>':dM,'<<':dM};9z I(gE){5x7x328x=gE;5x7x168x=0w};I9x7x328x=2x;I9x7x168x=2x;8y ed=1w;ed['+']=9z(gT,hl,gu){8y iC='',F=1x;0y(eZ(gT)){0y(eZ(hl))iC=_[115]}7z 0y(gT 1y cR){0y(hl 1y ct)iC=_[161];7z 0y(hl 1y cT)iC=_[162]}7z 0y(gT 1y ct){0y(hl 1y cR){iC=_[161];F=3x}7z 0y(hl 1y cS){iC=_[170];F=3x}7z 0y(hl 1y ct)iC=_[269]}7z 0y(gT 1y cT){0y(hl 1y cR){iC=_[162];F=3x}7z 0y(hl 1y cm){iC=_[134];F=3x}7z 0y(hl 1y cS){iC=_[165];F=3x}7z 0y(hl 1y cT)iC=_[262]}7z 0y(gT 1y cm){0y(hl 1y cT)iC=_[134]}7z 0y(gT 1y cS){0y(hl 1y ct)iC=_[170];7z 0y(hl 1y cT)iC=_[165]}0y(iC)3y fn[iC]7x218x(gu,F?hl:gT,F?gT:hl);4y 2y X(_[9])};ed['-']=9z(gT,hl,gu){8y iC='';0y(eZ(gT)){0y(eZ(hl))iC=_[120]}7z 0y(gT 1y cR){0y(hl 1y cR)iC=_[232];7z 0y(hl 1y ct)iC=_[226];7z 0y(hl 1y cT)iC=_[227]}7z 0y(gT 1y cm){0y(hl 1y cm)iC=_[233];7z 0y(hl 1y cT)iC=_[228]}7z 0y(gT 1y cS){0y(hl 1y cS)iC=_[248];7z 0y(hl 1y ct)iC=_[234];7z 0y(hl 1y cT)iC=_[235]}7z 0y(gT 1y ct){0y(hl 1y ct)iC=_[270]}7z 0y(gT 1y cT){0y(hl 1y cT)iC=_[263]}0y(iC)3y fn[iC]7x218x(gu,gT,hl);4y 2y X(_[9])};9z cC(gV,hw){8y gE;0y(gV7x148x2w4w!(gE=dg(gV,hw)))3y;0y(!(gV7x58x2w0z ed))3y gE;8y gf=2y I(gE),iC;9y((iC=gV7x58x2w)0z ed){gV7x138x2w;0y(gV7x148x2w4w!(gE=dg(gV,hw)))4y 2y X(_[12]);gf7x168x7x108x([iC,gE])}3y gf};I9x7x88x=9z(gu){8y gT=d3(5x7x328x7x88x(gu),gu);0y(!gT7x18x)3y 0w;dV(gu,gT,'?');8y jZ=gT[0];0y(jZ 1y cs)jZ=cV7x38x(jZ);8z(8y fC=0,fJ=5x7x168x7x18x,hl,j1;fC<fJ;fC2v){hl=d3(5x7x168x[fC][1]7x88x(gu),gu);0y(!hl7x18x)3y 0w;dV(gu,hl,'?');j1=hl[0];0y(j1 1y cs)j1=cV7x38x(j1);jZ=ed[5x7x168x[fC][08x(jZ,j1,gu)}3y [jZ]};9z be(gE){5x7x328x=gE;5x7x168x=0w};be9x7x328x=2x;be9x7x168x=2x;8y ek=1w;ek['*']=9z(gT,hl,gu){8y iC='',F=1x;0y(eZ(gT)){0y(eZ(hl))iC=_[89];7z 0y(hl 1y ct){iC=_[158];F=3x}7z 0y(hl 1y cT){iC=_[169];F=3x}}7z{0y(gT 1y ct){0y(eZ(hl))iC=_[158]}7z 0y(gT 1y cT){0y(eZ(hl))iC=_[169]}}0y(iC)3y fn[iC]7x218x(gu,F?hl:gT,F?gT:hl);4y 2y X(_[9])};ek['div']=9z(gT,hl,gu){8y iC='';0y(eZ(gT)){0y(eZ(hl))iC=_[90]}7z 0y(gT 1y ct){0y(eZ(hl))iC=_[267];7z 0y(hl 1y ct)iC=_[266]}7z 0y(gT 1y cT){0y(eZ(hl))iC=_[265];7z 0y(hl 1y cT)iC=_[249]}0y(iC)3y fn[iC]7x218x(gu,gT,hl);4y 2y X(_[9])};ek['idiv']=9z(gT,hl,gu){0y(eZ(gT)3weZ(hl))3y fn7x2398x7x218x(gu,gT,hl);4y 2y X(_[9])};ek['mod']=9z(gT,hl,gu){0y(eZ(gT)3weZ(hl))3y fn7x2388x7x218x(gu,gT,hl);4y 2y X(_[9])};9z dg(gV,hw){8y gE;0y(gV7x148x2w4w!(gE=eS(gV,hw)))3y;0y(!(gV7x58x2w0z ek))3y gE;8y gZ=2y be(gE),iC;9y((iC=gV7x58x2w)0z ek){gV7x138x2w;0y(gV7x148x2w4w!(gE=eS(gV,hw)))4y 2y X(_[12]);gZ7x168x7x108x([iC,gE])}3y gZ};be9x7x88x=9z(gu){8y gT=d3(5x7x328x7x88x(gu),gu);0y(!gT7x18x)3y 0w;dV(gu,gT,'?');8y jZ=gT[0];0y(jZ 1y cs)jZ=cV7x38x(jZ);8z(8y fC=0,fJ=5x7x168x7x18x,hl,j1;fC<fJ;fC2v){hl=d3(5x7x168x[fC][1]7x88x(gu),gu);0y(!hl7x18x)3y 0w;dV(gu,hl,'?');j1=hl[0];0y(j1 1y cs)j1=cV7x38x(j1);jZ=ek[5x7x168x[fC][08x(jZ,j1,gu)}3y [jZ]};9z bF(iC,gE){5x7x528x=iC;5x7x358x=gE};bF9x7x528x=2x;bF9x7x358x=2x;8y fp=1w;fp['-']=9z(hl,gu){0y(eZ(hl))3y fn7x2438x7x218x(gu,hl);4y 2y X(_[9])};fp['+']=9z(hl,gu){0y(eZ(hl))3y fn7x2428x7x218x(gu,hl);4y 2y X(_[9])};9z eR(gV,hw){0y(gV7x148x2w)3y;0y(!(gV7x58x2w0z fp))3y eT(gV,hw);8y iC='+',gE;9y(gV7x58x2w0z fp){0y(gV7x58x2w6w'-')iC=iC6w'-'?'+':'-';gV7x138x2w}0y(gV7x148x2w4w!(gE=eT(gV,hw)))4y 2y X(_[12]);3y 2y bF(iC,gE)};bF9x7x88x=9z(gu){8y hl=d3(5x7x358x7x88x(gu),gu);0y(!hl7x18x)3y 0w;dV(gu,hl,'?');8y j1=hl[0];0y(j1 1y cs)j1=cV7x38x(j1);3y [fp[5x7x528x](j1,gu)]};9z bH2w1w;9z eT(gV,hw){3y eA(gV,hw)};9z bk(gE){5x7x328x=gE;5x7x168x=0w};bk9x7x328x=2x;bk9x7x168x=2x;9z ey(gV,hw){8y gE;0y(gV7x148x2w4w!(gE=cD(gV,hw)))3y;0y(gV7x58x2w9w_[190])3y gE;8y h5=2y bk(gE);9y(gV7x58x2w6w_[190]){gV7x138x2w;0y(gV7x148x2w4w!(gE=cD(gV,hw)))4y 2y X(_[12]);h57x168x7x108x(gE)}3y h5};bk9x7x88x=9z(gu){8y H=d5(5x7x328x7x88x(gu),gu);8z(8y fC=0,fJ=5x7x168x7x18x;(fC<fJ)3w!H;fC2v)H=d5(5x7x168x[fC]7x88x(gu),gu);3y [2y bO(H)]};9z J(gE){5x7x328x=gE;5x7x168x=0w};J9x7x328x=2x;J9x7x168x=2x;9z cD(gV,hw){8y gE;0y(gV7x148x2w4w!(gE=dO(gV,hw)))3y;0y(gV7x58x2w9w_[189])3y gE;8y gg=2y J(gE);9y(gV7x58x2w6w_[189]){gV7x138x2w;0y(gV7x148x2w4w!(gE=dO(gV,hw)))4y 2y X(_[12]);gg7x168x7x108x(gE)}3y gg};J9x7x88x=9z(gu){8y H=d5(5x7x328x7x88x(gu),gu);8z(8y fC=0,fJ=5x7x168x7x18x;(fC<fJ)3wH;fC2v)H=d5(5x7x168x[fC]7x88x(gu),gu);3y [2y bO(H)]};9z bx2w1w;bx9x7x548x=2x;9z eM(gV,hw){0y(!gV7x148x2w)3y dS(gV,hw)4wdI(gV,hw)};9z eN(gV,hw,hx){8y gE;9y(gV7x58x2w6w'['){gV7x138x2w;0y(gV7x148x2w4w!(gE=dR(gV,hw)))4y 2y X(_[12]);hx7x548x7x108x(gE);0y(gV7x58x2w9w']')4y 2y X(_[12]);gV7x138x2w}};bx9x7x1328x=9z(hq,gu){8y jX=gu7x268x,fu=gu7x768x,fv=gu7x948x;8z(8y fY=0,hr,fZ=5x7x548x7x18x;fY<fZ;fY2v){hr=hq;hq=0w;8z(8y fC=0,hs,fJ=hr7x18x;fC<fJ;fC2v){gu7x268x=hr[fC];gu7x768x=fC+1;gu7x948x=fJ;hs=5x7x548x[fY]7x88x(gu);0y(hs7x18x6w13weZ(hs[0])){0y(hs[0]7x28x2w6wfC+1)hq7x108x(hr[fC])}7z 0y(d5(hs,gu))hq7x108x(hr[fC])}}gu7x268x=jX;gu7x768x=fu;gu7x948x=fv;3y hq};9z N(id,hy){5x7x1128x=id;5x7x378x=hy;5x7x548x=0w};N9x=2y bx;N9x7x1128x=2x;N9x7x378x=2x;8y ee=1w;ee7x658x=1w;ee7x1248x=1w;ee7x3008x=1w;ee7x1108x=1w;ee7x2968x=1w;ee7x2978x=1w;ee7x2988x=1w;ee7x1268x=1w;ee7x1278x=1w;ee7x1088x=1w;ee7x1718x=1w;ee7x1638x=1w;9z dI(gV,hw){8y id=gV7x58x2w,gE,hx;0y(gV7x58x(1)6w'::'){0y(!(id 0z ee))4y 2y X(_[12]);gV7x138x(2);0y(gV7x148x2w4w!(gE=dj(gV,hw)))4y 2y X(_[12]);hx=2y N(id,gE)}7z 0y(id6w'..'){gV7x138x2w;hx=2y N(_[108],2y b9(_[81]))}7z 0y(id6w'@'){gV7x138x2w;0y(gV7x148x2w4w!(gE=dj(gV,hw)))4y 2y X(_[12]);hx=2y N(_[65],gE)}7z{0y(gV7x148x2w4w!(gE=dj(gV,hw)))3y;hx=2y N(gE 1y b93wgE7x478x6w_[65]?_[65]:_[124],gE)}eN(gV,hw,hx);3y hx};N9x7x88x=9z(gu){8y gN=gu7x268x;0y(!gu7x248x7x368x(gN))4y 2y X(_[196]);8y hq=0w,d7=gu7x248x7x288x,fa=d7(gN,_[27]);6y(5x7x1128x){2z _[65]:0y(fa6w1)8z(8y b=d7(gN,_[57]),fC=0,fJ=b7x18x;fC<fJ;fC2v)hq7x108x(b[fC]);1z;2z _[124]:8z(8y g0=d7(gN,_[85]);g0;g0=d7(g0,_[74]))hq7x108x(g0);1z;2z _[110]:hq7x108x(gN);2z _[300]:dH(d7(gN,_[85]),hq,d7);1z;2z _[296]:8z(8y h7=gN,hu;h7;h7=d7(h7,_[42]))0y(hu=d7(h7,_[74]))dH(hu,hq,d7);1z;2z _[297]:8z(8y g0=gN;g0=d7(g0,_[74]);)hq7x108x(g0);1z;2z _[298]:hq7x108x(gN);1z;2z _[127]:hq7x108x(gN);2z _[126]:8z(8y g0=fa6w2?d7(gN,_[56]):gN;g0=d7(g0,_[42]);)hq7x108x(g0);1z;2z _[108]:8y h7=fa6w2?d7(gN,_[56]):d7(gN,_[42]);0y(h7)hq7x108x(h7);1z;2z _[171]:8z(8y h7=gN,hu;h7;h7=d7(h7,_[42]))0y(hu=d7(h7,_[79]))dG(hu,hq,d7);1z;2z _[163]:8z(8y g0=gN;g0=d7(g0,_[79]);)hq7x108x(g0);1z}0y(hq7x18x3w!(5x7x378x 1y b93w5x7x378x7x478x6w_[81])){8y hr=hq;hq=0w;8z(8y fC=0,fJ=hr7x18x;fC<fJ;fC2v){0y(5x7x378x7x378x(hr[fC],gu))hq7x108x(hr[fC])}}0y(hq7x18x3w5x7x548x7x18x)hq=5x7x1328x(hq,gu);6y(5x7x1128x){2z _[126]:2z _[127]:2z _[108]:2z _[171]:2z _[163]:hq7x1798x2w}3y hq};9z dH(g0,hq,d7){8z(8y gp;g0;g0=d7(g0,_[74])){hq7x108x(g0);0y(gp=d7(g0,_[85]))dH(gp,hq,d7)}};9z dG(g0,hq,d7){8z(8y gp;g0;g0=d7(g0,_[79])){0y(gp=d7(g0,_[247]))dG(gp,hq,d7);hq7x108x(g0)}};9z bm2w{5x7x168x=0w};bm9x7x168x=2x;9z eA(gV,hw){0y(gV7x148x2w)3y;8y jL='/',im='/'+'/';8y h8=2y bm2w,jM=gV7x58x2w,gE;0y(jM6wim4wjM6wjL){gV7x138x2w;h87x168x7x108x(2y b4(2x,_[149],ix));0y(jM6wim)h87x168x7x108x(2y N(_[110],2y b9(_[81])))}0y(gV7x148x2w4w!(gE=eM(gV,hw))){0y(jM6wjL)3y h87x168x[0];0y(jM6wim)4y 2y X(_[12]);3y}h87x168x7x108x(gE);9y((jM=gV7x58x2w)6wjL4wjM6wim){0y(jM6wim)h87x168x7x108x(2y N(_[110],2y b9(_[81])));gV7x138x2w;0y(gV7x148x2w4w!(gE=eM(gV,hw)))4y 2y X(_[12]);h87x168x7x108x(gE)}0y(h87x168x7x18x6w1)3y h87x168x[0];3y h8};bm9x7x88x=9z(gu){8y jX=gu7x268x;8y hq=[jX];8z(8y fE=0,fF=5x7x168x7x18x,hr;fE<fF;fE2v){hr=0w;8z(8y fC=0,fJ=hq7x18x;fC<fJ;fC2v){gu7x268x=hq[fC];8z(8y f2=0,hs=5x7x168x[fE]7x88x(gu),f3=hs7x18x;f2<f3;f22v)0y((fE<fF-1)3w!gu7x248x7x368x(hs[f2]))4y 2y X(_[294]);7z 0y(cE(hr,hs[f2])6w-1)hr7x108x(hs[f2])}hq=hr};gu7x268x=jX;3y d4(hq,gu)};9z bg2w1w;9z dj(gV,hw){0y(!gV7x148x2w)3y de(gV,hw)4wdi(gV,hw)};9z b9(iz){5x7x478x=iz;5x7x718x=0w};b99x=2y bg;b99x7x478x=2x;b99x7x718x=2x;8y ej=1w;ej7x1438x=1w;ej7x1608x=1w;ej7x658x=1w;ej7x1648x=1w;ej7x2748x=1w;ej7x1808x=1w;ej7x818x=1w;ej7x938x=1w;ej7x888x=1w;9z de(gV,hw){8y iz=gV7x58x2w;0y(gV7x58x(1)6w'('){0y(!(iz 0z ej))4y 2y X(_[12]);gV7x138x(2);8y hy=2y b9(iz);0y(gV7x58x2w9w')'){0y(iz6w_[143])1w7z 0y(iz6w_[160])1w7z 0y(iz6w_[65])1w7z 0y(iz6w_[164])1w7z 0y(iz6w_[88])1w7z 0y(iz6w_[93])1w}7z{0y(iz6w_[88])4y 2y X(_[12]);7z 0y(iz6w_[93])4y 2y X(_[12])}0y(gV7x58x2w9w')')4y 2y X(_[12]);gV7x138x2w;3y hy}};b99x7x378x=9z(g0,gu){8y d7=gu7x248x7x288x,fa=gu7x248x7x368x(g0)?d7(g0,_[27]):0;6y(5x7x478x){2z _[81]:3y7wfa;2z _[65]:0y(fa9w2)3y 1x;1z;2z _[143]:3y fa6w9;2z _[160]:3y fa6w1;2z _[164]:0y(fa9w7)3y 1x;1z;2z _[274]:3y fa6w8;2z _[180]:3y fa6w34wfa6w4;2z _[88]:4y \"K0zdTest '\"+_[88]+\"' not implemented\";2z _[93]:4y \"K0zdTest '\"+_[93]+\"' not implemented\"}0y(fa6w2)3y d7(g0,_[30])9w_[82]3wd7(g0,_[20])9w_[82];0y(fa6w7)3y d7(g0,_[229])9w_[291];3y 3x};9z bf(iE,iu,iA){5x7x308x=iE;5x7x208x=iu;5x7x178x=iA};bf9x=2y bg;bf9x7x308x=2x;bf9x7x208x=2x;bf9x7x178x=2x;8y hM=/^(?:(?![0-9-])([\\w-]+|\\*)\\:)?(?![0-9-])([\\w-]+|\\*)$/;9z di(gV,hw){8y j=gV7x58x2w7x258x(hM);0y(j){0y(j[1]6w'*'3wj[2]6w'*')4y 2y X(_[12]);gV7x138x2w;3y 2y bf(j[1]4w2x,j[2],j[1]?j[1]6w'*'?'*':hw7x738x(j[1])4w2x:hw7x1408x)}};bf9x7x378x=9z(g0,gu){8y d7=gu7x248x7x288x,fa=d7(g0,_[27]);0y(fa6w14wfa6w2){0y(5x7x208x6w'*')3y(fa6w14w(d7(g0,_[30])9w_[82]3wd7(g0,_[20])9w_[82]))3w(!5x7x308x4wd7(g0,_[17])6w5x7x178x);0y(5x7x208x6wd7(g0,_[20]))3y 5x7x178x6w'*'4w(fa6w23w!5x7x308x3w!d7(g0,_[30]))4wd7(g0,_[17])6w5x7x178x}3y 1x};9z bn2w1w;9z eB(gV,hw){0y(!gV7x148x2w)3y dP(gV,hw)4wez(gV,hw)4wdY(gV,hw)4weU(gV,hw)4wdf(gV,hw)};9z bl(gE){5x7x358x=gE};9z ez(gV,hw){0y(gV7x58x2w6w'('){gV7x138x2w;8y gE=2x;0y(gV7x58x2w9w')')gE=dR(gV,hw);0y(gV7x58x2w9w')')4y 2y X(_[12]);gV7x138x2w;3y 2y bl(gE)}};bl9x7x88x=9z(gu){3y 5x7x358x?5x7x358x7x88x(gu):0w};9z S2w1w;9z dP(gV,hw){0y(gV7x58x2w6w'.'){gV7x138x2w;3y 2y S}};S9x7x88x=9z(gu){0y(gu7x268x6w2x)4y 2y X(_[75]);3y [gu7x268x]};9z bc2w1w;bc9x7x78x=2x;9z df(gV,hw){0y(!gV7x148x2w)3y dk(gV,hw)4weO(gV,hw)};bc9x7x88x=9z(gu){3y [5x7x78x]};9z bi(hG){5x7x78x=hG};bi9x=2y bc;8y hN=/^[+\\-]?(?:(?:(\\d+)(?:\\.(\\d*))?)|(?:\\.(\\d+)))(?:[eE]([+-])?(\\d+))?$/;9z dk(gV,hw){8y jO=gV7x58x2w,j2=dl(jO);0y(j2){gV7x138x2w;3y 2y bi(j2)}};9z dl(jO){8y j=jO7x258x(hN);0y(j){8y bD=c7;0y(j[5])bD=cV;7z 0y(j[2]4wj[3])bD=cU;3y 2y bD(+jO)}};9z bA(hG){5x7x78x=hG};bA9x=2y bc;8y hQ=/^'([^']*(?:''[^']*)*)'|\"([^\"]*(?:\"\"[^\"]*)*)\"$/;9z eO(gV,hw){8y j=gV7x58x2w7x258x(hQ);0y(j){gV7x138x2w;3y 2y bA(2y cl(j[1]?j[1]7x388x(\"''\",\"'\"):j[2]?j[2]7x388x('\"\"','\"'):''))}};9z b1(he){5x7x358x=he;5x7x548x=0w};b19x=2y bx;b19x7x358x=2x;9z dS(gV,hw){8y gE;0y(gV7x148x2w4w!(gE=eB(gV,hw)))3y;8y gG=2y b1(gE);eN(gV,hw,gG);0y(gG7x548x7x18x6w0)3y gG7x358x;3y gG};b19x7x88x=9z(gu){8y hq=5x7x358x7x88x(gu);0y(5x7x548x7x18x3whq7x18x)hq=5x7x1328x(hq,gu);3y hq};9z bI(iE,iu,iA){5x7x308x=iE;5x7x208x=iu;5x7x178x=iA};bI9x7x308x=2x;bI9x7x208x=2x;bI9x7x178x=2x;9z eU(gV,hw){0y(gV7x58x2w7x848x(0,1)6w'$'){8y j=gV7x58x2w7x848x(1)7x258x(hM);0y(j){0y(j[1]6w'*'4wj[2]6w'*')4y 2y X(_[12]);8y hJ=2y bI(j[1]4w2x,j[2],j[1]?hw7x738x(j[1]):2x);gV7x138x2w;3y hJ}}};bI9x7x88x=9z(gu){8y jN=(5x7x178x?'{'+5x7x178x+'}':'')+5x7x208x;0y(gu7x518x7x1418x(jN))3y [gu7x518x[jN8x;4y 2y X(_[292])};9z b4(iE,iu,iA){5x7x308x=iE;5x7x208x=iu;5x7x178x=iA;5x7x718x=0w};b49x7x308x=2x;b49x7x208x=2x;b49x7x178x=2x;b49x7x718x=2x;9z dY(gV,hw){8y j=gV7x58x2w7x258x(hM);0y(j3wgV7x58x(1)6w'('){0y(!j[1]3w(j[2] 0z ej))3y dI(gV,hw);0y(j[1]6w'*'4wj[2]6w'*')4y 2y X(_[12]);8y gJ=2y b4(j[1]4w2x,j[2],j[1]?hw7x738x(j[1])4w2x:hw7x878x),gE;gV7x138x(2);0y(gV7x58x2w9w')'){do{0y(gV7x148x2w4w!(gE=dQ(gV,hw)))4y 2y X(_[12]);gJ7x718x7x108x(gE)}9y(gV7x58x2w6w','3wgV7x138x2w);0y(gV7x58x2w9w')')4y 2y X(_[12])}gV7x138x2w;3y gJ}};b49x7x88x=9z(gu){8y a=0w,k,dU;8z(8y fC=0,fJ=5x7x718x7x18x;fC<fJ;fC2v)a7x108x(5x7x718x[fC]7x88x(gu));8y jN=(5x7x178x?'{'+5x7x178x+'}':'')+5x7x208x;0y(5x7x178x6wix){0y(dU=fm[5x7x208x]){0y(k=fo[5x7x208x])dZ(5x7x208x,k,dU,a,gu);8y j0=dU7x3438x(gu,a);3y j06w2x?0w:j0 1y K?j0:[j0]}4y 2y X(_[46])}7z 0y(5x7x178x6wiy){0y((dU=el[5x7x208x])3w5x7x208x9w_[157]3w5x7x208x9w_[319]){dZ(5x7x208x,[[bJ8x,dU,a,gu);3y [dU7x38x(a[0])]}4y 2y X(_[46])}7z 0y(dU=gu7x538x7x1788x(jN)){8y j0=dU7x3438x(gu,a);3y j06w2x?0w:j0 1y K?j0:[j0]}4y 2y X(_[46])};8y g=7x399],_[396],_[393],_[368],_[3708x;9z dZ(iz,k,dU,a,gu){8y gh,fq=a7x18x,h6,fT=k7x18x,fU=0;9y((fU<k7x18x)3w!k[fU][2])fU2v;0y(fq>fT)4y 2y X(_[46]);7z 0y(fq<fU)4y 2y X(_[46]);8z(8y fC=0;fC<fq;fC2v){h6=k[fC];gh=a[fC];dV(gu,gh,h6[1]);dW(gu,gh,h6[0]);0y(h6[1]9w'+'3wh6[1]9w'*')a[fC]=gh7x18x?gh[0]:2x}};9z dW(gu,hq,b8){8z(8y fC=0,fJ=hq7x18x,fR,jY;fC<fJ;fC2v){jY=hq[fC];0y(b86wcz4wb89x 1y cz){0y(!gu7x248x7x368x(jY))4y 2y X(_[9]);0y(b89wcz){fR=gu7x248x7x288x(jY,_[27]);0y([2x,cx,cu,cB,cB,2x,2x,cA,cv,cw,2x,2x,2x][fR]9wb8)4y 2y X(_[9])}}7z 0y(b86wbJ4wb89x 1y bJ){jY=d3([jY],gu)[0];0y(b89wbJ){0y(jY 1y cs)jY=b87x38x(jY);7z 0y(b86wcl){0y(jY 1y bM)jY=cl7x38x(jY)}7z 0y(b86wcV){0y(eZ(jY))jY=b87x38x(jY)}}0y(!(jY 1y b8))4y 2y X(_[9]);hq[fC]=jY}}};9z dV(gu,hq,ig){8y fJ=hq7x18x;0y(ig6w'?'){0y(fJ>1)4y 2y X(_[9])}7z 0y(ig6w'+'){0y(fJ<1)4y 2y X(_[9])}7z 0y(ig9w'*'){0y(fJ9w1)4y 2y X(_[9])}};9z b7(gE){5x7x328x=gE;5x7x168x=0w};b79x7x328x=2x;b79x7x168x=2x;9z da(gV,hw){8y gE,iC;0y(gV7x148x2w4w!(gE=d9(gV,hw)))3y;0y(!((iC=gV7x58x2w)6w_[125]4wiC6w_[137]))3y gE;8y gM=2y b7(gE);9y((iC=gV7x58x2w)6w_[125]4wiC6w_[137]){gV7x138x2w;0y(gV7x148x2w4w!(gE=d9(gV,hw)))4y 2y X(_[12]);gM7x168x7x108x([iC,gE])}3y gM};b79x7x88x=9z(gu){8y hq=5x7x328x7x88x(gu);8z(8y fC=0,fJ=5x7x168x7x18x,gN;fC<fJ;fC2v)hq=fn[(gN=5x7x168x[fC])[08x7x218x(gu,hq,gN[1]7x88x(gu));3y hq};9z bq(gT,hl){5x7x328x=gT;5x7x638x=hl};bq9x7x328x=2x;bq9x7x638x=2x;9z eD(gV,hw){8y gE,hl;0y(gV7x148x2w4w!(gE=cC(gV,hw)))3y;0y(gV7x58x2w9w_[135])3y gE;gV7x138x2w;0y(gV7x148x2w4w!(hl=cC(gV,hw)))4y 2y X(_[12]);3y 2y bq(gE,hl)};bq9x7x88x=9z(gu){8y gT=5x7x328x7x88x(gu);0y(!gT7x18x)3y 0w;dV(gu,gT,'?');dW(gu,gT,c7);8y hl=5x7x638x7x88x(gu);0y(!hl7x18x)3y 0w;dV(gu,hl,'?');dW(gu,hl,c7);3y fn7x1358x7x218x(gu,gT[0],hl[0])};9z bG(gE){5x7x328x=gE;5x7x168x=0w};bG9x7x328x=2x;bG9x7x168x=2x;9z eS(gV,hw){8y gE,iC;0y(gV7x148x2w4w!(gE=da(gV,hw)))3y;0y(!((iC=gV7x58x2w)6w'|'4wiC6w_[119]))3y gE;8y hE=2y bG(gE);9y((iC=gV7x58x2w)6w'|'4wiC6w_[119]){gV7x138x2w;0y(gV7x148x2w4w!(gE=da(gV,hw)))4y 2y X(_[12]);hE7x168x7x108x(gE)}3y hE};bG9x7x88x=9z(gu){8y hq=5x7x328x7x88x(gu);8z(8y fC=0,fJ=5x7x168x7x18x;fC<fJ;fC2v)hq=fn7x1198x7x218x(gu,hq,5x7x168x[fC]7x88x(gu));3y hq};9z b6(gE,hD){5x7x358x=gE;5x7x398x=hD};b69x7x358x=2x;b69x7x398x=2x;9z d9(gV,hw){8y gE,hD;0y(gV7x148x2w4w!(gE=eQ(gV,hw)))3y;0y(!(gV7x58x2w6w_[367]3wgV7x58x(1)6w_[366]))3y gE;gV7x138x(2);0y(gV7x148x2w4w!(hD=eG(gV,hw)))4y 2y X(_[12]);3y 2y b6(gE,hD)};b69x7x88x=9z(gu){8y hr=5x7x358x7x88x(gu),gO=5x7x398x7x648x,iB=5x7x398x7x598x;0y(!gO)3y [2y bO(!hr7x18x)];0y(!hr7x18x)3y [2y bO(iB6w'?'4wiB6w'*')];0y(hr7x18x9w1)0y(!(iB6w'+'4wiB6w'*'))3y [2y bO(1x)];0y(!gO7x378x)3y [2y bO(3x)];8y H=3x;8z(8y fC=0,fJ=hr7x18x;(fC<fJ)3wH;fC2v)H=gO7x378x7x378x(hr[fC],gu);3y [2y bO(H)]};9z bC(gE,hD){5x7x358x=gE;5x7x398x=hD};bC9x7x358x=2x;bC9x7x398x=2x;9z eQ(gV,hw){8y gE,hD;0y(gV7x148x2w4w!(gE=dK(gV,hw)))3y;0y(!(gV7x58x2w6w_[363]3wgV7x58x(1)6w_[166]))3y gE;gV7x138x(2);0y(gV7x148x2w4w!(hD=eG(gV,hw)))4y 2y X(_[12]);3y 2y bC(gE,hD)};bC9x7x88x=9z(gu){8y hr=5x7x358x7x88x(gu),gO=5x7x398x7x648x,iB=5x7x398x7x598x;0y(!gO){0y(hr7x18x)4y 2y X(_[105]);3y hr}0y(!(iB6w'?'4wiB6w'*'))0y(!hr7x18x)4y 2y X(_[105]);0y(!(iB6w'+'4wiB6w'*'))0y(hr7x18x9w1)4y 2y X(_[105]);0y(!gO7x378x)3y hr;8z(8y fC=0,fJ=hr7x18x;fC<fJ;fC2v)0y(!gO7x378x7x378x(hr[fC],gu))4y 2y X(_[105]);3y hr};9z Q(gE,hD){5x7x358x=gE;5x7x398x=hD};Q9x7x358x=2x;Q9x7x398x=2x;9z dK(gV,hw){8y gE,hD;0y(gV7x148x2w4w!(gE=dJ(gV,hw)))3y;0y(!(gV7x58x2w6w_[364]3wgV7x58x(1)6w_[166]))3y gE;gV7x138x(2);0y(gV7x148x2w4w!(hD=eJ(gV,hw)))4y 2y X(_[12]);3y 2y Q(gE,hD)};Q9x7x88x=9z(gu){8y hr=5x7x358x7x88x(gu),gO=5x7x398x7x648x,iB=5x7x398x7x598x;0y(hr7x18x>1)3y [2y bO(1x)];7z 0y(!hr7x18x)3y [2y bO(iB6w'?')];7y{gO7x38x(d3(hr,gu)[0])}3z(e){0y(e7x678x6w_[100])4y e;0y(e7x678x6w_[46])4y 2y X(_[372]);3y [2y bO(1x)]}3y [2y bO(3x)]};9z P(gE,hD){5x7x358x=gE;5x7x398x=hD};P9x7x358x=2x;P9x7x398x=2x;9z dJ(gV,hw){8y gE,hD;0y(gV7x148x2w4w!(gE=eR(gV,hw)))3y;0y(!(gV7x58x2w6w_[3]3wgV7x58x(1)6w_[166]))3y gE;gV7x138x(2);0y(gV7x148x2w4w!(hD=eJ(gV,hw)))4y 2y X(_[12]);3y 2y P(gE,hD)};P9x7x88x=9z(gu){8y hr=5x7x358x7x88x(gu);dV(gu,hr,5x7x398x7x598x);0y(!hr7x18x)3y 0w;3y [5x7x398x7x648x7x38x(d3(hr,gu)[0],gu)]};9z cAtomibD(iE,iu,iA){5x7x308x=iE;5x7x208x=iu;5x7x178x=iA};cAtomibD9x7x308x=2x;cAtomibD9x7x208x=2x;cAtomibD9x7x178x=2x;9z cF(gV,hw){8y j=gV7x58x2w7x258x(hM);0y(j){0y(j[1]6w'*'4wj[2]6w'*')4y 2y X(_[12]);gV7x138x2w;3y 2y cAtomibD(j[1]4w2x,j[2],j[1]?hw7x738x(j[1]):2x)}};cAtomibD9x7x378x=9z(jY,gu){8y jN=(5x7x178x?'{'+5x7x178x+'}':'')+5x7x208x,bD=5x7x178x6wiy?el[5x7x208x]:gu7x538x7x1068x(jN);0y(bD)3y jY 1y bD;4y 2y X(_[100])};cAtomibD9x7x38x=9z(jY,gu){8y jN=(5x7x178x?'{'+5x7x178x+'}':'')+5x7x208x,bD=5x7x178x6wiy?el[5x7x208x]:gu7x538x7x1068x(jN);0y(bD)3y bD7x38x(jY);4y 2y X(_[100])};9z b8(hy){5x7x378x=hy};b89x7x378x=2x;9z dd(gV,hw){0y(gV7x148x2w)3y;8y gE;0y(gV7x58x2w6w_[26]3wgV7x58x(1)6w'('){gV7x138x(2);0y(gV7x58x2w9w')')4y 2y X(_[12]);gV7x138x2w;3y 2y b8}0y(gE=de(gV,hw))3y 2y b8(gE);0y(gE=cF(gV,hw))3y 2y b8(gE)};9z bs(gO,iB){5x7x648x=gO4w2x;5x7x598x=iB4w2x};bs9x7x648x=2x;bs9x7x598x=2x;9z eG(gV,hw){0y(gV7x148x2w)3y;0y(gV7x58x2w6w_[377]3wgV7x58x(1)6w'('){gV7x138x(2);0y(gV7x58x2w9w')')4y 2y X(_[12]);gV7x138x2w;3y 2y bs}8y gE,iB;0y(!gV7x148x2w3w(gE=dd(gV,hw))){iB=gV7x58x2w;0y(iB6w'?'4wiB6w'*'4wiB6w'+')gV7x138x2w;7z iB=2x;3y 2y bs(gE,iB)}};9z bv(gO,iB){5x7x648x=gO4w2x;5x7x598x=iB4w2x};bv9x7x648x=2x;bv9x7x598x=2x;9z eJ(gV,hw){8y gE,iB;0y(!gV7x148x2w3w(gE=cF(gV,hw))){iB=gV7x58x2w;0y(iB6w'?')gV7x138x2w;7z iB=2x;3y 2y bv(gE,iB)}};9z bL2w1w;bL9x7x238x=cQ7x3398x;9z bK2w1w;bK9x=2y bL;bK9x7x238x=cQ7x3248x;bK9x7x348x=2x;bK7x3228x=_[328];bK7x3278x=_[335];bK7x3208x=_[118];bK7x3518x=_[336];bK7x3488x=_[70];bK7x3408x=_[337];bK7x3468x=_[334];bK7x3168x=_[331];bK7x2868x=_[208];bK7x2898x=_[211];bK7x2938x=_[207];bK7x3138x=_[206];bK7x3498x=_[202];bK7x3038x=_[201];bK7x3018x=_[203];bK7x3068x=_[157];bK7x3158x=_[147];bK7x3118x=_[104];bK7x3098x=_[205];9z bJ2w1w;bJ9x=2y bK;bJ9x7x238x=cQ7x3268x;bJ7x38x=9z(j2){4y 2y X(_[46])};9z eZ(jY){3y jY 1y cY4wjY 1y cV4wjY 1y cU};eK(_[319],bJ);9z bM(jJ,ic,iD,iH,ip){5x7x668x=jJ;5x7x688x=ic;5x7x588x=iD;5x7x1228x=iH;5x7x1238x=ip};bM9x=2y bJ;bM9x7x238x=cQ7x3238x;bM9x7x348x=bK7x3228x;bM9x7x668x=2x;bM9x7x688x=2x;bM9x7x588x=2x;bM9x7x1228x=2x;bM9x7x1238x=2x;bM9x7x318x=9z2w{3y(5x7x668x?5x7x668x+':':'')+(5x7x688x?'/'+'/'+5x7x688x:'')+(5x7x588x?5x7x588x:'')+(5x7x1228x?'?'+5x7x1228x:'')+(5x7x1238x?'#'+5x7x1238x:'')};8y iS=/^(([^:\\/?#]+):)?(\\/\\/([^\\/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?/;bM7x38x=9z(j2){0y(j2 1y bM)3y j2;0y(j2 1y cl4wj2 1y cs){8y j;0y(j=eP(j2)7x258x(iS))3y 2y bM(j[2],j[4],j[5],j[7],j[9]);4y 2y X(_[33])}4y 2y X(_[9])};eK(_[328],bM);9z bN(jO){5x7x78x=jO};bN9x=2y bJ;bN9x7x238x=cQ7x3218x;bN9x7x348x=bK7x3278x;bN9x7x78x=2x;bN9x7x28x=9z2w{3y 5x7x78x};bN9x7x318x=9z2w{3y 5x7x78x};8y iT=/^((([A-Za-z0-9+\\/]\\s*){4})*(([A-Za-z0-9+\\/]\\s*){3}[A-Za-z0-9+\\/]|([A-Za-z0-9+\\/]\\s*){2}[AEIMQUYcgkosw048]\\s*=|[A-Za-z0-9+\\/]\\s*[AQgw]\\s*=\\s*=))?$/;bN7x38x=9z(j2){0y(j2 1y bN)3y j2;0y(j2 1y cl4wj2 1y cs){8y j=eP(j2)7x258x(iT);0y(j)3y 2y bN(j[0]);4y 2y X(_[33])}0y(j2 1y c4){8y j=j27x28x2w7x258x(/.{2}/g),r=0w;8z(8y fC=0,fJ=j7x18x;fC<fJ;fC2v)r7x108x(by7x2548x(eX(j[fC],16)));3y 2y bN(eW(r7x418x('')))}4y 2y X(_[9])};eK(_[335],bN);9z bO(H){5x7x78x=H};bO9x=2y bJ;bO9x7x238x=cQ7x2128x;bO9x7x348x=bK7x3208x;bO9x7x78x=2x;bO9x7x28x=9z2w{3y 5x7x78x};bO9x7x318x=9z2w{3y by(5x7x78x)};8y iU=/^(0|1|3x|1x)$/;bO7x38x=9z(j2){0y(j2 1y bO)3y j2;0y(j2 1y cl4wj2 1y cs){8y j;0y(j=eP(j2)7x258x(iU))3y 2y bO(j[1]6w'1'4wj[1]6w_[230]);4y 2y X(_[33])}0y(eZ(j2))3y 2y bO(j29w0);4y 2y X(_[9])};eK(_[118],bO);9z cR(gc,fN,fw,f8,B){5x7x118x=gc;5x7x68x=fN;5x7x158x=fw;5x7x48x=f8;5x7x298x=B};cR9x=2y bJ;cR9x7x238x=cQ7x3188x;cR9x7x348x=bK7x3518x;cR9x7x118x=2x;cR9x7x68x=2x;cR9x7x158x=2x;cR9x7x48x=2x;cR9x7x298x=2x;cR9x7x318x=9z2w{3y e0(5x)+e1(5x)};8y iV=/^(-?)([1-9]\\d\\d\\d+|0\\d\\d\\d)-(0[1-9]|1[0-2])-(0[1-9]|[12]\\d|3[01])(Z|([+\\-])(0\\d|1[0-4]):([0-5]\\d))?$/;cR7x38x=9z(j2){0y(j2 1y cR)3y j2;0y(j2 1y cl4wj2 1y cs){8y j=eP(j2)7x258x(iV);0y(j){8y gc=+j[2],fN=+j[3],fw=+j[4];0y(fw-1<e5(gc,fN))3y 2y cR(gc,fN,fw,j[5]?j[5]6w'Z'?0:(j[6]6w'-'?-1:1)*(j[7]*60+j[8]*1):2x,j[1]6w'-');4y 2y X(_[33])}4y 2y X(_[33])}0y(j2 1y cS)3y 2y cR(j27x118x,j27x68x,j27x158x,j27x48x,j27x298x);4y 2y X(_[9])};8y s=[31,28,31,30,31,30,31,31,30,31,30,31];9z e5(gc,fN){3y fN6w23w(gc%4006w04wgc%1009w03wgc%46w0)?29:s[fN-1]};9z e6(hG,t){0y(!t){8y fw=e5(hG7x118x,hG7x68x);0y(hG7x158x>fw){9y(hG7x158x>fw){hG7x68x0v1;0y(hG7x68x>12){hG7x118x0v1;0y(hG7x118x6w0)hG7x118x=1;hG7x68x=1}hG7x158x1vfw;fw=e5(hG7x118x,hG7x68x)}}7z 0y(hG7x158x<1){9y(hG7x158x<1){hG7x68x1v1;0y(hG7x68x<1){hG7x118x1v1;0y(hG7x118x6w0)hG7x118x=-1;hG7x68x=12}fw=e5(hG7x118x,hG7x68x);hG7x158x0vfw}}}0y(hG7x68x>12){hG7x118x0v~~(hG7x68x/12);0y(hG7x118x6w0)hG7x118x=1;hG7x68x=hG7x68x%12}7z 0y(hG7x68x<1){hG7x118x0v~~(hG7x68x/12)-1;0y(hG7x118x6w0)hG7x118x=-1;hG7x68x=hG7x68x%12+12}3y hG};eK(_[336],cR);9z cS(gc,fN,fw,fB,fM,f5,f8,B){5x7x118x=gc;5x7x68x=fN;5x7x158x=fw;5x7x188x=fB;5x7x198x=fM;5x7x228x=f5;5x7x48x=f8;5x7x298x=B};cS9x=2y bJ;cS9x7x238x=cQ7x3508x;cS9x7x348x=bK7x3488x;cS9x7x118x=2x;cS9x7x68x=2x;cS9x7x158x=2x;cS9x7x188x=2x;cS9x7x198x=2x;cS9x7x228x=2x;cS9x7x48x=2x;cS9x7x298x=2x;cS9x7x318x=9z2w{3y e0(5x)+'T'+e2(5x)+e1(5x)};8y iW=/^(-?)([1-9]\\d\\d\\d+|0\\d\\d\\d)-(0[1-9]|1[0-2])-(0[1-9]|[12]\\d|3[01])T(([01]\\d|2[0-3]):([0-5]\\d):([0-5]\\d)(?:\\.(\\d+))?|(24:00:00)(?:\\.(0+))?)(Z|([+\\-])(0\\d|1[0-4]):([0-5]\\d))?$/;cS7x38x=9z(j2){0y(j2 1y cS)3y j2;0y(j2 1y cl4wj2 1y cs){8y j=eP(j2)7x258x(iW);0y(j){8y gc=+j[2],fN=+j[3],fw=+j[4],H=7wj[10];0y(fw-1<e5(gc,fN))3y e3(2y cS(gc,fN,fw,H?24:+j[6],H?0:+j[7],bh((H?0:j[8])+'.'+(H?0:j[9]4w0)),j[12]?j[12]6w'Z'?0:(j[13]6w'-'?-1:1)*(j[14]*60+j[15]*1):2x,j[1]6w'-'));4y 2y X(_[33])}4y 2y X(_[33])}0y(j2 1y cR)3y 2y cS(j27x118x,j27x68x,j27x158x,0,0,0,j27x48x,j27x298x);4y 2y X(_[9])};9z e4(j2,fJ){8y jO=by(j2);0y(4x7x18x<2)fJ=2;3y(jO7x18x<fJ+1?2y K(fJ+1-jO7x18x)7x418x('0'):'')+jO};9z e1(gx){8y f8=gx7x48x;3y f86w2x?'':f8?(f8>0?'+':'-')+e4(bd7x408x(~~(f8/60)))+':'+e4(bd7x408x(f8%60)):'Z'};9z e0(gx){3y(gx7x298x?'-':'')+e4(gx7x118x,4)+'-'+e4(gx7x68x)+'-'+e4(gx7x158x)};9z e2(gx){8y r=by(gx7x228x)7x488x('.');3y e4(gx7x188x)+':'+e4(gx7x198x)+':'+e4(r[0])+(r7x18x>1?'.'+r[1]:'')};9z e3(hG){3y e6(eb(hG))};eK(_[70],cS);9z cU(fb){5x7x78x=fb};cU9x=2y bJ;cU9x7x238x=cQ7x3418x;cU9x7x348x=bK7x3408x;cU9x7x78x=2x;cU9x7x28x=9z2w{3y 5x7x78x};cU9x7x318x=9z2w{3y by(5x7x78x)};8y iY=/^[+\\-]?((\\d+(\\.\\d*)?)|(\\.\\d+))$/;cU7x38x=9z(j2){0y(j2 1y cU)3y j2;0y(j2 1y cl4wj2 1y cs){8y j=eP(j2)7x258x(iY);0y(j)3y 2y cU(+j2);4y 2y X(_[33])}0y(j2 1y bO)3y 2y cU(j2*1);0y(eZ(j2)){0y(dc(j2)4w!db(j2))4y 2y X(_[95]);3y 2y cU(+j2)}4y 2y X(_[9])};eK(_[337],cU);9z cV(fb){5x7x78x=fb};cV9x=2y bJ;cV9x7x238x=cQ7x3448x;cV9x7x348x=bK7x3468x;cV9x7x78x=2x;cV9x7x28x=9z2w{3y 5x7x78x};cV9x7x318x=9z2w{3y by(5x7x78x)};8y iZ=/^([+\\-]?((\\d+(\\.\\d*)?)|(\\.\\d+))([eE][+\\-]?\\d+)?|(-?INF)|NaN)$/;cV7x38x=9z(j2){0y(j2 1y cV)3y j2;0y(j2 1y cl4wj2 1y cs){8y j=eP(j2)7x258x(iZ);0y(j)3y 2y cV(j[7]?+j[7]7x388x(_[257],_[168]):+j2);4y 2y X(_[33])}0y(j2 1y bO)3y 2y cV(j2*1);0y(eZ(j2))3y 2y cV(j27x78x);4y 2y X(_[9])};eK(_[334],cV);9z cW(gc,fN,fw,fB,fM,f5,B){5x7x118x=gc;5x7x68x=fN;5x7x158x=fw;5x7x188x=fB;5x7x198x=fM;5x7x228x=f5;5x7x298x=B};cW9x=2y bJ;cW9x7x238x=cQ7x3178x;cW9x7x348x=bK7x3168x;cW9x7x118x=2x;cW9x7x68x=2x;cW9x7x158x=2x;cW9x7x188x=2x;cW9x7x198x=2x;cW9x7x228x=2x;cW9x7x298x=2x;cW9x7x318x=9z2w{3y(5x7x298x?'-':'')+'P'+((e9(5x)+e8(5x))4w'T0S')};8y i0=/^(-)?P(?:([0-9]+)Y)?(?:([0-9]+)M)?(?:([0-9]+)D)?(?:T(?:([0-9]+)H)?(?:([0-9]+)M)?(?:((?:(?:[0-9]+(?:.[0-9]*)?)|(?:.[0-9]+)))S)?)?$/;cW7x38x=9z(j2){0y(j2 1y ct)3y 2y cW(j27x118x,j27x68x,0,0,0,0,j27x298x);0y(j2 1y cT)3y 2y cW(0,0,j27x158x,j27x188x,j27x198x,j27x228x,j27x298x);0y(j2 1y cW)3y j2;0y(j2 1y cl4wj2 1y cs){8y j=eP(j2)7x258x(i0);0y(j)3y ea(2y cW(+j[2]4w0,+j[3]4w0,+j[4]4w0,+j[5]4w0,+j[6]4w0,+j[7]4w0,j[1]6w'-'));4y 2y X(_[33])}4y 2y X(_[9])};9z e9(gA){3y(gA7x118x?gA7x118x+'Y':'')+(gA7x68x?gA7x68x+'M':'')};9z e8(gA){3y(gA7x158x?gA7x158x+'D':'')+(gA7x188x4wgA7x198x4wgA7x228x?'T'+(gA7x188x?gA7x188x+'H':'')+(gA7x198x?gA7x198x+'M':'')+(gA7x228x?gA7x228x+'S':''):'')};9z ea(gA){3y ec(e7(gA))};eK(_[331],cW);9z cY(fb){5x7x78x=fb};cY9x=2y bJ;cY9x7x238x=cQ7x2888x;cY9x7x348x=bK7x2868x;cY9x7x78x=2x;cY9x7x28x=9z2w{3y 5x7x78x};cY9x7x318x=9z2w{3y by(5x7x78x)};8y i1=/^([+\\-]?((\\d+(\\.\\d*)?)|(\\.\\d+))([eE][+\\-]?\\d+)?|(-?INF)|NaN)$/;cY7x38x=9z(j2){0y(j2 1y cY)3y j2;0y(j2 1y cl4wj2 1y cs){8y j=eP(j2)7x258x(i1);0y(j)3y 2y cY(j[7]?+j[7]7x388x(_[257],_[168]):+j2);4y 2y X(_[33])}0y(j2 1y bO)3y 2y cY(j2*1);0y(eZ(j2))3y 2y cY(j27x78x);4y 2y X(_[9])};eK(_[208],cY);9z cZ(fw,f8){5x7x158x=fw;5x7x48x=f8};cZ9x=2y bJ;cZ9x7x238x=cQ7x2858x;cZ9x7x348x=bK7x2898x;cZ9x7x158x=2x;cZ9x7x48x=2x;cZ9x7x318x=9z2w{3y '-'+'-'+'-'+e4(5x7x158x)+e1(5x)};8y i2=/^3v-(0[1-9]|[12]\\d|3[01])(Z|([+\\-])(0\\d|1[0-4]):([0-5]\\d))?$/;cZ7x38x=9z(j2){0y(j2 1y cZ)3y j2;0y(j2 1y cl4wj2 1y cs){8y j=eP(j2)7x258x(i2);0y(j){8y fw=+j[1];3y 2y cZ(fw,j[2]?j[2]6w'Z'?0:(j[3]6w'-'?-1:1)*(j[4]*60+j[5]*1):2x)}4y 2y X(_[33])}0y(j2 1y cR4wj2 1y cS)3y 2y cZ(j27x158x,j27x48x);4y 2y X(_[9])};eK(_[211],cZ);9z c0(fN,f8){5x7x68x=fN;5x7x48x=f8};c09x=2y bJ;c09x7x238x=cQ7x2908x;c09x7x348x=bK7x2938x;c09x7x68x=2x;c09x7x48x=2x;c09x7x318x=9z2w{3y '-'+'-'+e4(5x7x68x)+e1(5x)};8y i3=/^3v(0[1-9]|1[0-2])(Z|([+\\-])(0\\d|1[0-4]):([0-5]\\d))?$/;c07x38x=9z(j2){0y(j2 1y c0)3y j2;0y(j2 1y cl4wj2 1y cs){8y j=eP(j2)7x258x(i3);0y(j){8y fN=+j[1];3y 2y c0(fN,j[2]?j[2]6w'Z'?0:(j[3]6w'-'?-1:1)*(j[4]*60+j[5]*1):2x)}4y 2y X(_[33])}0y(j2 1y cR4wj2 1y cS)3y 2y c0(j27x68x,j27x48x);4y 2y X(_[9])};eK(_[207],c0);9z c1(fN,fw,f8){5x7x68x=fN;5x7x158x=fw;5x7x48x=f8};c19x=2y bJ;c19x7x238x=cQ7x2848x;c19x7x348x=bK7x3138x;c19x7x68x=2x;c19x7x158x=2x;c19x7x48x=2x;c19x7x318x=9z2w{3y '-'+'-'+e4(5x7x68x)+'-'+e4(5x7x158x)+e1(5x)};8y i4=/^3v(0[1-9]|1[0-2])-(0[1-9]|[12]\\d|3[01])(Z|([+\\-])(0\\d|1[0-4]):([0-5]\\d))?$/;c17x38x=9z(j2){0y(j2 1y c1)3y j2;0y(j2 1y cl4wj2 1y cs){8y j=eP(j2)7x258x(i4);0y(j){8y fN=+j[1],fw=+j[2];0y(fw-1<e5(1976,fN))3y 2y c1(fN,fw,j[3]?j[3]6w'Z'?0:(j[4]6w'-'?-1:1)*(j[5]*60+j[6]*1):2x);4y 2y X(_[33])}4y 2y X(_[33])}0y(j2 1y cR4wj2 1y cS)3y 2y c1(j27x68x,j27x158x,j27x48x);4y 2y X(_[9])};eK(_[206],c1);9z c2(gc,f8){5x7x118x=gc;5x7x48x=f8};c29x=2y bJ;c29x7x238x=cQ7x3058x;c29x7x348x=bK7x3498x;c29x7x118x=2x;c29x7x48x=2x;c29x7x318x=9z2w{3y e4(5x7x118x)+e1(5x)};8y i5=/^-?([1-9]\\d\\d\\d+|0\\d\\d\\d)(Z|([+\\-])(0\\d|1[0-4]):([0-5]\\d))?$/;c27x38x=9z(j2){0y(j2 1y c2)3y j2;0y(j2 1y cl4wj2 1y cs){8y j=eP(j2)7x258x(i5);0y(j){8y gc=+j[1];3y 2y c2(gc,j[2]?j[2]6w'Z'?0:(j[3]6w'-'?-1:1)*(j[4]*60+j[5]*1):2x)}4y 2y X(_[33])}0y(j2 1y cR4wj2 1y cS)3y 2y c2(j27x118x,j27x48x);4y 2y X(_[9])};eK(_[202],c2);9z c3(gc,fN,f8){5x7x118x=gc;5x7x68x=fN;5x7x48x=f8};c39x=2y bJ;c39x7x238x=cQ7x3028x;c39x7x348x=bK7x3038x;c39x7x118x=2x;c39x7x68x=2x;c39x7x48x=2x;c39x7x318x=9z2w{3y e4(5x7x118x)+'-'+e4(5x7x68x)+e1(5x)};8y i6=/^-?([1-9]\\d\\d\\d+|0\\d\\d\\d)-(0[1-9]|1[0-2])(Z|([+\\-])(0\\d|1[0-4]):([0-5]\\d))?$/;c37x38x=9z(j2){0y(j2 1y c3)3y j2;0y(j2 1y cl4wj2 1y cs){8y j=eP(j2)7x258x(i6);0y(j){8y gc=+j[1],fN=+j[2];3y 2y c3(gc,fN,j[3]?j[3]6w'Z'?0:(j[4]6w'-'?-1:1)*(j[5]*60+j[6]*1):2x)}4y 2y X(_[33])}0y(j2 1y cR4wj2 1y cS)3y 2y c3(j27x118x,j27x68x,j27x48x);4y 2y X(_[9])};eK(_[201],c3);9z c4(jO){5x7x78x=jO};c49x=2y bJ;c49x7x238x=cQ7x3048x;c49x7x348x=bK7x3018x;c49x7x78x=2x;c49x7x28x=9z2w{3y 5x7x78x};c49x7x318x=9z2w{3y 5x7x78x};8y i7=/^([0-9a-fA-F]{2})*$/;c47x38x=9z(j2){0y(j2 1y c4)3y j2;0y(j2 1y cl4wj2 1y cs){8y j=eP(j2)7x258x(i7);0y(j)3y 2y c4(j[0]7x2648x2w);4y 2y X(_[33])}0y(j2 1y bN){8y jO=eV(j27x28x2w),r=0w;8z(8y fC=0,fJ=jO7x18x,it;fC<fJ;fC2v){it=jO7x1758x(fC)7x318x(16);r7x108x(2y K(3-it7x18x)7x418x('0')+it)}3y 2y c4(r7x418x(''))}4y 2y X(_[9])};eK(_[203],c4);9z cc2w1w;cc9x=2y bJ;cc9x7x238x=cQ7x2998x;cc9x7x348x=bK7x3068x;cc7x38x=9z(j2){4y 2y X(_[46])};eK(_[157],cc);9z cj(iE,iu,iA){5x7x308x=iE;5x7x208x=iu;5x7x178x=iA};cj9x=2y bJ;cj9x7x238x=cQ7x3148x;cj9x7x348x=bK7x3158x;cj9x7x308x=2x;cj9x7x208x=2x;cj9x7x178x=2x;cj9x7x318x=9z2w{3y(5x7x308x?5x7x308x+':':'')+5x7x208x};8y i9=/^(?:(?![0-9-])([\\w-]+)\\:)?(?![0-9-])([\\w-]+)$/;cj7x38x=9z(j2){0y(j2 1y cj)3y j2;0y(j2 1y cl4wj2 1y cs){8y j=eP(j2)7x258x(i9);0y(j)3y 2y cj(j[1]4w2x,j[2],2x);4y 2y X(_[33])}4y 2y X(_[9])};eK(_[147],cj);9z cl(jO){5x7x78x=jO};cl9x=2y bJ;cl9x7x78x=2x;cl9x7x238x=cQ7x3128x;cl9x7x348x=bK7x3118x;cl9x7x28x=9z2w{3y 5x7x78x};cl9x7x318x=9z2w{3y 5x7x78x};cl7x38x=9z(j2){3y 2y cl(by(j2));4y 2y X(_[9])};eK(_[104],cl);9z cm(fB,fM,f5,f8){5x7x188x=fB;5x7x198x=fM;5x7x228x=f5;5x7x48x=f8};cm9x=2y bJ;cm9x7x238x=cQ7x3078x;cm9x7x348x=bK7x3098x;cm9x7x188x=2x;cm9x7x198x=2x;cm9x7x228x=2x;cm9x7x48x=2x;cm9x7x318x=9z2w{3y e2(5x)+e1(5x)};8y ia=/^(([01]\\d|2[0-3]):([0-5]\\d):([0-5]\\d)(?:\\.(\\d+))?|(24:00:00)(?:\\.(0+))?)(Z|([+\\-])(0\\d|1[0-4]):([0-5]\\d))?$/;cm7x38x=9z(j2){0y(j2 1y cm)3y j2;0y(j2 1y cl4wj2 1y cs){8y j=eP(j2)7x258x(ia);0y(j){8y H=7wj[6];3y 2y cm(H?0:+j[2],H?0:+j[3],bh((H?0:j[4])+'.'+(H?0:j[5]4w0)),j[8]?j[8]6w'Z'?0:(j[9]6w'-'?-1:1)*(j[10]*60+j[11]*1):2x)}4y 2y X(_[33])}0y(j2 1y cS)3y 2y cm(j27x188x,j27x198x,j27x228x,j27x48x);4y 2y X(_[9])};9z eb(hG){0y(hG7x228x5v604whG7x228x<0){hG7x198x0v~~(hG7x228x/60)-(hG7x228x<03whG7x228x%60?1:0);hG7x228x=hG7x228x%60+(hG7x228x<03whG7x228x%60?60:0)}0y(hG7x198x5v604whG7x198x<0){hG7x188x0v~~(hG7x198x/60)-(hG7x198x<03whG7x198x%60?1:0);hG7x198x=hG7x198x%60+(hG7x198x<03whG7x198x%60?60:0)}0y(hG7x188x5v244whG7x188x<0){0y(hG 1y cS)hG7x158x0v~~(hG7x188x/24)-(hG7x188x<03whG7x188x%24?1:0);hG7x188x=hG7x188x%24+(hG7x188x<03whG7x188x%24?24:0)}3y hG};eK(_[205],cm);9z cs(jO){5x7x78x=jO};cs9x=2y bJ;cs9x7x238x=cQ7x3108x;cs9x7x318x=9z2w{3y by(5x7x78x)};cs7x38x=9z(j2){0y(j2 1y cs)3y j2;3y 2y cs(by(j2));4y 2y X(_[9])};eK(_[375],cs);9z ct(gc,fN,B){cW7x218x(5x,gc,fN,0,0,0,0,B)};ct9x=2y cW;ct9x7x238x=cQ7x2958x;ct9x7x318x=9z2w{3y(5x7x298x?'-':'')+'P'+(e9(5x)4w'0M')};8y ib=/^(-)?P(?:([0-9]+)Y)?(?:([0-9]+)M)?$/;ct7x38x=9z(j2){0y(j2 1y ct)3y j2;0y(j2 1y cl4wj2 1y cs){8y j=eP(j2)7x258x(ib);0y(j)3y ec(2y ct(+j[2]4w0,+j[3]4w0,j[1]6w'-'));4y 2y X(_[33])}0y(j2 1y cT)3y 2y ct(0,0);0y(j2 1y cW)3y 2y ct(j27x118x,j27x68x,j27x298x);4y 2y X(_[9])};9z ec(gA){0y(gA7x68x5v12){gA7x118x0v~~(gA7x68x/12);gA7x68x%=12}3y gA};eK(_[374],ct);9z cT(fw,fB,fM,f5,B){cW7x218x(5x,0,0,fw,fB,fM,f5,B)};cT9x=2y cW;cT9x7x238x=cQ7x2798x;cT9x7x318x=9z2w{3y(5x7x298x?'-':'')+'P'+(e8(5x)4w'T0S')};8y iX=/^(-)?P(?:([0-9]+)D)?(?:T(?:([0-9]+)H)?(?:([0-9]+)M)?(?:((?:(?:[0-9]+(?:.[0-9]*)?)|(?:.[0-9]+)))S)?)?$/;cT7x38x=9z(j2){0y(j2 1y cT)3y j2;0y(j2 1y cl4wj2 1y cs){8y j=eP(j2)7x258x(iX);0y(j)3y e7(2y cT(+j[2]4w0,+j[3]4w0,+j[4]4w0,+j[5]4w0,j[1]6w'-'));4y 2y X(_[33])}0y(j2 1y ct)3y 2y cT(0,0,0,0);0y(j2 1y cW)3y 2y cT(j27x158x,j27x188x,j27x198x,j27x228x,j27x298x);4y 2y X(_[9])};9z e7(gA){0y(gA7x228x5v60){gA7x198x0v~~(gA7x228x/60);gA7x228x%=60}0y(gA7x198x5v60){gA7x188x0v~~(gA7x198x/60);gA7x198x%=60}0y(gA7x188x5v24){gA7x158x0v~~(gA7x188x/24);gA7x188x%=24}3y gA};eK(_[373],cT);9z c7(fb){5x7x78x=fb};c79x=2y cU;c79x7x238x=cQ7x2808x;8y i8=/^[-+]?[0-9]+$/;c77x38x=9z(j2){0y(j2 1y c7)3y j2;0y(j2 1y cl4wj2 1y cs){8y j=eP(j2)7x258x(i8);0y(j)3y 2y c7(~~j2);4y 2y X(_[33])}0y(j2 1y bO)3y 2y c7(j2*1);0y(eZ(j2)){0y(dc(j2)4w!db(j2))4y 2y X(_[95]);3y 2y c7(~~j2)}4y 2y X(_[9])};eK(_[380],c7);9z cg(fb){5x7x78x=fb};cg9x=2y c7;cg9x7x238x=cQ7x2828x;cg7x38x=9z(j2){3y 2y cg(bh(j2))};eK(_[379],cg);9z ce(fb){5x7x78x=fb};ce9x=2y cg;ce9x7x238x=cQ7x2788x;ce7x38x=9z(j2){3y 2y ce(bh(j2))};eK(_[378],ce);9z c9(fb){5x7x78x=fb};c99x=2y c7;c99x7x238x=cQ7x2778x;c97x38x=9z(j2){3y 2y c9(bh(j2))};eK(_[371],c9);9z c6(fb){5x7x78x=fb};c69x=2y c9;c69x7x238x=cQ7x2738x;c67x38x=9z(j2){3y 2y c6(bh(j2))};eK(_[365],c6);9z ck(fb){5x7x78x=fb};ck9x=2y c6;ck9x7x238x=cQ7x2758x;ck7x38x=9z(j2){3y 2y ck(bh(j2))};eK(_[381],ck);9z bP(fb){5x7x78x=fb};bP9x=2y ck;bP9x7x238x=cQ7x2768x;bP7x38x=9z(j2){3y 2y bP(bh(j2))};eK(_[382],bP);9z cXSNofQInteger(fb){5x7x78x=fb};cXSNofQInteger9x=2y c7;cXSNofQInteger9x7x238x=cQ7x2838x;cXSNofQInteger7x38x=9z(j2){3y 2y cXSNofQInteger(bh(j2))};eK(_[395],cXSNofQInteger);9z ci(fb){5x7x78x=fb};ci9x=2y cXSNofQInteger;ci9x7x238x=cQ7x3478x;ci7x38x=9z(j2){3y 2y ci(bh(j2))};eK(_[394],ci);9z cq(fb){5x7x78x=fb};cq9x=2y cXSNofQInteger;cq9x7x238x=cQ7x3528x;cq7x38x=9z(j2){3y 2y cq(bh(j2))};eK(_[397],cq);9z cp(fb){5x7x78x=fb};cp9x=2y cXSNofQInteger;cp9x7x238x=cQ7x3388x;cp7x38x=9z(j2){3y 2y cp(bh(j2))};eK(_[400],cp);9z cr(fb){5x7x78x=fb};cr9x=2y cp;cr9x7x238x=cQ7x3258x;cr7x38x=9z(j2){3y 2y cr(bh(j2))};eK(_[398],cr);9z co(fb){5x7x78x=fb};co9x=2y cr;co9x7x238x=cQ7x3338x;co7x38x=9z(j2){3y 2y co(bh(j2))};eK(_[392],co);9z ch(jO){5x7x78x=jO};ch9x=2y cl;ch9x7x238x=cQ7x3298x;ch7x38x=9z(j2){3y 2y ch(by(j2))};eK(_[391],ch);9z cn(jO){5x7x78x=jO};cn9x=2y ch;cn9x7x238x=cQ7x3308x;cn7x38x=9z(j2){3y 2y cn(by(j2))};eK(_[385],cn);9z cd(jO){5x7x78x=jO};cd9x=2y cn;cd9x7x238x=cQ7x3328x;cd7x38x=9z(j2){3y 2y cd(by(j2))};eK(_[384],cd);9z ca(jO){5x7x78x=jO};ca9x=2y cd;ca9x7x238x=cQ7x2098x;ca7x38x=9z(j2){3y 2y ca(by(j2))};eK(_[383],ca);9z cX(jO){5x7x78x=jO};cX9x=2y ca;cX9x7x238x=cQ7x2048x;cX7x38x=9z(j2){3y 2y cX(by(j2))};eK(_[386],cX);9z c5(jO){5x7x78x=jO};c59x=2y ca;c59x7x238x=cQ7x2138x;c57x38x=9z(j2){3y 2y c5(by(j2))};eK(_[387],c5);9z c8(jO){5x7x78x=jO};c89x=2y cn;c89x7x238x=cQ7x2198x;c87x38x=9z(j2){3y 2y c8(by(j2))};eK(_[390],c8);9z cb(jO){5x7x78x=jO};cb9x=2y cn;cb9x7x238x=cQ7x1868x;cb7x38x=9z(j2){3y 2y cb(by(j2))};eK(_[389],cb);9z cy2w1w;9z cz2w1w;cz9x=2y cy;9z cu2w1w;cu9x=2y cz;9z cv2w1w;cv9x=2y cz;9z cw2w1w;cw9x=2y cz;9z cx2w1w;cx9x=2y cz;9z cA2w1w;cA9x=2y cz;9z cB2w1w;cB9x=2y cz;fn7x1828x=9z(gT,hl){3y 2y bO(gT7x28x2w6whl7x28x2w)};fn7x1838x=9z(gT,hl){3y 2y bO(gT7x28x2w6whl7x28x2w)};fn7x1998x=9z(gT,hl){3y 2y bO(gT7x28x2w6whl7x28x2w)};fn7x1468x=9z(gT,hl){3y 2y bO(gT7x28x2w<hl7x28x2w)};fn7x1528x=9z(gT,hl){3y 2y bO(gT7x28x2w>hl7x28x2w)};fn7x1598x=9z(gT,hl){3y 2y bO(ex(gT)<ex(hl))};fn7x1538x=9z(gT,hl){3y 2y bO(ex(gT)>ex(hl))};fn7x1548x=9z(gT,hl){3y 2y bO(dt(gT)<dt(hl))};fn7x1558x=9z(gT,hl){3y 2y bO(dt(gT)>dt(hl))};fn7x2568x=9z(gT,hl){3y 2y bO(gT7x298x6whl7x298x3wex(gT)6wex(hl)3wdt(gT)6wdt(hl))};fn7x2588x=9z(gT,hl){3y _b(gT,hl,'eq')};fn7x1568x=9z(gT,hl){3y _b(gT,hl,'lt')};fn7x1518x=9z(gT,hl){3y _b(gT,hl,'gt')};fn7x2558x=9z(gT,hl){3y dp(gT,hl,'eq')};fn7x1508x=9z(gT,hl){3y dp(gT,hl,'lt')};fn7x1458x=9z(gT,hl){3y dp(gT,hl,'gt')};fn7x2508x=9z(gT,hl){3y dq(gT,hl,'eq')};fn7x1448x=9z(gT,hl){3y dq(gT,hl,'lt')};fn7x1488x=9z(gT,hl){3y dq(gT,hl,'gt')};fn7x2528x=9z(gT,hl){3y _b(2y cS(gT7x118x,gT7x68x,e5(gT7x118x,gT7x68x),0,0,0,gT7x48x6w2x?5x7x48x:gT7x48x),2y cS(hl7x118x,hl7x68x,e5(hl7x118x,hl7x68x),0,0,0,hl7x48x6w2x?5x7x48x:hl7x48x),'eq')};fn7x2538x=9z(gT,hl){3y _b(2y cS(gT7x118x,1,1,0,0,0,gT7x48x6w2x?5x7x48x:gT7x48x),2y cS(hl7x118x,1,1,0,0,0,hl7x48x6w2x?5x7x48x:hl7x48x),'eq')};fn7x2608x=9z(gT,hl){3y _b(2y cS(1972,gT7x68x,gT7x158x,0,0,0,gT7x48x6w2x?5x7x48x:gT7x48x),2y cS(1972,hl7x68x,hl7x158x,0,0,0,hl7x48x6w2x?5x7x48x:hl7x48x),'eq')};fn7x2618x=9z(gT,hl){3y _b(2y cS(1972,gT7x68x,e5(1972,hl7x68x),0,0,0,gT7x48x6w2x?5x7x48x:gT7x48x),2y cS(1972,hl7x68x,e5(1972,hl7x68x),0,0,0,hl7x48x6w2x?5x7x48x:hl7x48x),'eq')};fn7x2688x=9z(gT,hl){3y _b(2y cS(1972,12,gT7x158x,0,0,0,gT7x48x6w2x?5x7x48x:gT7x48x),2y cS(1972,12,hl7x158x,0,0,0,hl7x48x6w2x?5x7x48x:hl7x48x),'eq')};fn7x2698x=9z(gT,hl){3y ew(ex(gT)+ex(hl))};fn7x2708x=9z(gT,hl){3y ew(ex(gT)-ex(hl))};fn7x1588x=9z(gT,hl){3y ew(ex(gT)*hl)};fn7x2678x=9z(gT,hl){3y ew(ex(gT)/hl)};fn7x2668x=9z(gT,hl){3y 2y cU(ex(gT)/ex(hl))};fn7x2628x=9z(gT,hl){3y ds(dt(gT)+dt(hl))};fn7x2638x=9z(gT,hl){3y ds(dt(gT)-dt(hl))};fn7x1698x=9z(gT,hl){3y ds(dt(gT)*hl)};fn7x2658x=9z(gT,hl){3y ds(dt(gT)/hl)};fn7x2498x=9z(gT,hl){3y 2y cU(dt(gT)/dt(hl))};fn7x2488x=9z(gT,hl){3y ds(dr(gT)-dr(hl))};fn7x2328x=9z(gT,hl){3y ds(dr(gT)-dr(hl))};fn7x2338x=9z(gT,hl){3y ds(dv(gT)-dv(hl))};fn7x1708x=9z(gT,hl){3y dn(gT,hl,'+')};fn7x1658x=9z(gT,hl){3y dm(gT,hl,'+')};fn7x2348x=9z(gT,hl){3y dn(gT,hl,'-')};fn7x2358x=9z(gT,hl){3y dm(gT,hl,'-')};fn7x1618x=9z(gT,hl){3y dn(gT,hl,'+')};fn7x1628x=9z(gT,hl){3y dm(gT,hl,'+')};fn7x2268x=9z(gT,hl){3y dn(gT,hl,'-')};fn7x2278x=9z(gT,hl){3y dm(gT,hl,'-')};fn7x1348x=9z(gT,hl){8y hG=2y cm(gT7x188x,gT7x198x,gT7x228x,gT7x48x);hG7x188x0vhl7x188x;hG7x198x0vhl7x198x;hG7x228x0vhl7x228x;3y eb(hG)};fn7x2288x=9z(gT,hl){8y hG=2y cm(gT7x188x,gT7x198x,gT7x228x,gT7x48x);hG7x188x1vhl7x188x;hG7x198x1vhl7x198x;hG7x228x1vhl7x228x;3y eb(hG)};9z dq(gT,hl,il){8y fG=dv(gT),f1=dv(hl);3y 2y bO(il6w'lt'?fG<f1:il6w'gt'?fG>f1:fG6wf1)};9z dp(gT,hl,il){3y _b(cS7x38x(gT),cS7x38x(hl),il)};9z _b(gT,hl,il){8y hB=2y cT(0,0,0,0),_e=d0(gT,hB)7x318x2w,jI=d0(hl,hB)7x318x2w;3y 2y bO(il6w'lt'?_e<jI:il6w'gt'?_e>jI:_e6wjI)};9z dn(gT,hl,iC){8y hG;0y(gT 1y cR)hG=2y cR(gT7x118x,gT7x68x,gT7x158x,gT7x48x,gT7x298x);7z 0y(gT 1y cS)hG=2y cS(gT7x118x,gT7x68x,gT7x158x,gT7x188x,gT7x198x,gT7x228x,gT7x48x,gT7x298x);hG7x118x=hG7x118x+hl7x118x*(iC6w'-'?-1:1);hG7x68x=hG7x68x+hl7x68x*(iC6w'-'?-1:1);e6(hG,3x);8y fw=e5(hG7x118x,hG7x68x);0y(hG7x158x>fw)hG7x158x=fw;3y hG};9z dm(gT,hl,iC){8y hG;0y(gT 1y cR){8y fb=(hl7x188x*60+hl7x198x)*60+hl7x228x;hG=2y cR(gT7x118x,gT7x68x,gT7x158x,gT7x48x,gT7x298x);hG7x158x=hG7x158x+hl7x158x*(iC6w'-'?-1:1)-1*(fb3wiC6w'-');e6(hG)}7z 0y(gT 1y cS){hG=2y cS(gT7x118x,gT7x68x,gT7x158x,gT7x188x,gT7x198x,gT7x228x,gT7x48x,gT7x298x);hG7x228x=hG7x228x+hl7x228x*(iC6w'-'?-1:1);hG7x198x=hG7x198x+hl7x198x*(iC6w'-'?-1:1);hG7x188x=hG7x188x+hl7x188x*(iC6w'-'?-1:1);hG7x158x=hG7x158x+hl7x158x*(iC6w'-'?-1:1);e3(hG)}3y hG};9z dt(gA){3y(((gA7x158x*24+gA7x188x)*60+gA7x198x)*60+gA7x228x)*(gA7x298x?-1:1)};9z ds(fb){8y B=(fb=bd7x438x(fb))<0,fx=~~((fb=bd7x408x(fb))/86400),fB=~~((fb1vfx*3600*24)/3600),fM=~~((fb1vfB*3600)/60),f5=fb1vfM*60;3y 2y cT(fx,fB,fM,f5,B)};9z ex(gA){3y(gA7x118x*12+gA7x68x)*(gA7x298x?-1:1)};9z ew(fb){8y fQ=(fb=bd7x438x(fb))<0,gd=~~((fb=bd7x408x(fb))/12),fO=fb1vgd*12;3y 2y ct(gd,fO,fQ)};9z dv(hA){3y hA7x228x+(hA7x198x-(hA7x48x9w2x?hA7x48x%60:0)+(hA7x188x-(hA7x48x9w2x?~~(hA7x48x/60):0))*60)*60};9z dr(hG){8y gw=2y U((hG7x298x?-1:1)*hG7x118x,hG7x68x,hG7x158x,0,0,0,0);0y(hG 1y cS){gw7x4708x(hG7x188x);gw7x1958x(hG7x198x);gw7x4588x(hG7x228x)}0y(hG7x48x9w2x)gw7x1958x(gw7x1948x2w-hG7x48x);3y gw7x4578x2w/1000};fn7x2878x=9z(gT,hl){3y 2y bO(5x7x248x7x1178x(gT,hl))};fn7x2418x=9z(gT,hl){3y 2y bO(7w(5x7x248x7x628x(gT,hl)&4))};fn7x2408x=9z(gT,hl){3y 2y bO(7w(5x7x248x7x628x(gT,hl)&2))};9z dX(gT,hl){0y(dc(gT)4w(bd7x408x(gT)6wfD)4wdc(hl)4w(bd7x408x(hl)6wfD))3y 0;8y h=by(gT)7x258x(hN),m=by(hl)7x258x(hN),fW=bd7x1918x(1,(h[2]4wh[3]4w'')7x18x+(h[5]4w0)*(h[4]6w'+'?-1:1),(m[2]4wm[3]4w'')7x18x+(m[5]4w0)*(m[4]6w'+'?-1:1));3y fW+(fW%2?0:1)};fn7x1158x=9z(gT,hl){8y fG=gT7x28x2w,f1=hl7x28x2w,fW=bd7x728x(10,dX(fG,f1));3y du(gT,hl,((fG*fW)+(f1*fW))/fW)};fn7x1208x=9z(gT,hl){8y fG=gT7x28x2w,f1=hl7x28x2w,fW=bd7x728x(10,dX(fG,f1));3y du(gT,hl,((fG*fW)-(f1*fW))/fW)};fn7x898x=9z(gT,hl){8y fG=gT7x28x2w,f1=hl7x28x2w,fW=bd7x728x(10,dX(fG,f1));3y du(gT,hl,((fG*fW)*(f1*fW))/(fW*fW))};fn7x908x=9z(gT,hl){8y fG=gT7x28x2w,f1=hl7x28x2w,fW=bd7x728x(10,dX(fG,f1));3y du(gT,hl,(gT*fW)/(hl*fW))};fn7x2398x=9z(gT,hl){3y 2y c7(~~(gT/hl))};fn7x2388x=9z(gT,hl){8y fG=gT7x28x2w,f1=hl7x28x2w,fW=bd7x728x(10,dX(fG,f1));3y du(gT,hl,((fG*fW)%(f1*fW))/fW)};fn7x2428x=9z(hl){3y hl};fn7x2438x=9z(hl){hl7x78x*=-1;3y hl};fn7x1308x=9z(gT,hl){3y 2y bO(gT7x28x2w6whl7x28x2w)};fn7x998x=9z(gT,hl){3y 2y bO(gT7x28x2w<hl7x28x2w)};fn7x978x=9z(gT,hl){3y 2y bO(gT7x28x2w>hl7x28x2w)};9z du(gT,hl,f0){3y 2y(gT 1y c73whl 1y c73wf06wbd7x438x(f0)?c7:cU)(f0)};fn7x2468x=9z(gT,hl){3y 2y bO(gT7x208x6whl7x208x3wgT7x178x6whl7x178x)};fn7x2458x=9z(hr,hs){3y hr7x968x(hs)};fn7x1198x=9z(hr,hs){8y hq=0w;8z(8y fC=0,fJ=hr7x18x,gN;fC<fJ;fC2v){0y(!5x7x248x7x368x(gN=hr[fC]))4y 2y X(_[9]);0y(cE(hq,gN)6w-1)hq7x108x(gN)}8z(8y fC=0,fJ=hs7x18x,gN;fC<fJ;fC2v){0y(!5x7x248x7x368x(gN=hs[fC]))4y 2y X(_[9]);0y(cE(hq,gN)6w-1)hq7x108x(gN)}3y d4(hq,5x)};fn7x1258x=9z(hr,hs){8y hq=0w;8z(8y fC=0,fJ=hr7x18x,gN,x;fC<fJ;fC2v){0y(!5x7x248x7x368x(gN=hr[fC]))4y 2y X(_[9]);x=1x;8z(8y f2=0,f3=hs7x18x;(f2<f3)3w!x;f22v){0y(!5x7x248x7x368x(hs[f2]))4y 2y X(_[9]);x=5x7x248x7x1178x(hs[f2],gN)}0y(x3wcE(hq,gN)6w-1)hq7x108x(gN)}3y d4(hq,5x)};fn7x1378x=9z(hr,hs){8y hq=0w;8z(8y fC=0,fJ=hr7x18x,gN,x;fC<fJ;fC2v){0y(!5x7x248x7x368x(gN=hr[fC]))4y 2y X(_[9]);x=1x;8z(8y f2=0,f3=hs7x18x;(f2<f3)3w!x;f22v){0y(!5x7x248x7x368x(hs[f2]))4y 2y X(_[9]);x=5x7x248x7x1178x(hs[f2],gN)}0y(!x3wcE(hq,gN)6w-1)hq7x108x(gN)}3y d4(hq,5x)};fn7x1358x=9z(gT,hl){8y hq=0w;8z(8y fC=gT7x28x2w,fJ=hl7x28x2w;fC4vfJ;fC2v)hq7x108x(2y c7(fC));3y hq};eL(_[225],[[cz,'?'8x,9z(g0){0y(g09w2x){8y d7=5x7x248x7x288x;6y(d7(g0,_[27])){2z 1:2z 2:3y 2y cj(d7(g0,_[30]),d7(g0,_[20]),d7(g0,_[17]));2z 5:4y \"Not implemented\";2z 6:4y \"Not implemented\";2z 7:3y 2y cj(2x,d7(g0,_[229]),2x);2z 10:3y 2y cj(2x,d7(g0,_[47]),2x)}}3y 2x});eL(_[548],[[cz,'?'8x,9z(g0){0y(g09w2x){0y(5x7x248x7x288x(g0,_[27])6w1)3y 2y bO(1x)}3y 2x});eL(_[104],[[cy,'?',3x8x,9z(gN){0y(!4x7x18x){0y(!5x7x268x)4y 2y X(_[75]);gN=5x7x268x}3y gN6w2x?2y cl(''):cl7x38x(d3([gN],5x)[0])});eL(_[116],[[cy,'*'8x,9z(hr){3y d3(hr,5x)});eL(_[501],[[cz,'?',3x8x,9z(g0){0y(!4x7x18x){0y(!5x7x248x7x368x(5x7x268x))4y 2y X(_[9]);g0=5x7x268x}3y bM7x38x(2y cl(5x7x248x7x288x(g0,_[83])4w''))});eL(_[502],[[cz,'?'8x,9z(g0){0y(g09w2x){8y d7=5x7x248x7x288x;0y(d7(g0,_[27])6w9)3y bM7x38x(2y cl(d7(g0,_[500])4w''))}3y 2x});eL(_[281],[[cl,'?'],[cl,'',3x8x,9z(jN,_c){8y _c;0y(4x7x18x<2){0y(!5x7x248x7x368x(5x7x268x))4y 2y X(_[9]);_c=2y cl(5x7x248x7x288x(5x7x268x,_[83])4w'')}0y(jN6w2x)3y 2x;0y(jN7x28x2w6w''4wjN7x28x2w7x1738x(0)6w'#')3y bM7x38x(_c);8y hF=bM7x38x(jN);0y(hF7x668x)3y hF;8y gn=bM7x38x(_c);hF7x668x=gn7x668x;0y(!hF7x688x){hF7x688x=gn7x688x;0y(hF7x588x7x1738x(0)9w'/'){8y q=hF7x588x7x488x('/'),c=gn7x588x7x488x('/');c7x1778x2w;8y fr=c[0]6w''?1:0;8z(8y fC=0,fJ=q7x18x;fC<fJ;fC2v){0y(q[fC]6w'..'){0y(c7x18x>fr)c7x1778x2w;7z{c7x108x(q[fC]);fr2v}}7z 0y(q[fC]9w'.')c7x108x(q[fC])}0y(q[3vfC]6w'..'4wq[fC]6w'.')c7x108x('');hF7x588x=c7x418x('/')}}3y hF});eL(_[230],0w,9z2w{3y 2y bO(3x)});eL(_[499],0w,9z2w{3y 2y bO(1x)});eL(_[496],[[cy,'*'8x,9z(hr){3y 2y bO(!d5(hr,5x))});eL(_[76],0w,9z2w{3y 2y c7(5x7x768x)});eL(_[497],0w,9z2w{3y 2y c7(5x7x948x)});eL(_[498],0w,9z2w{3y 5x7x708x});eL(_[503],0w,9z2w{3y cR7x38x(5x7x708x)});eL(_[504],0w,9z2w{3y cm7x38x(5x7x708x)});eL(_[510],0w,9z2w{3y 5x7x48x});eL(_[511],0w,9z2w{3y 2y cl(5x7x538x7x1748x)});eL(_[509],0w,9z2w{3y bM7x38x(2y cl(5x7x538x7x838x4w''))});eL(_[508],[[cW,'?'8x,9z(gA){3y d2(gA,_[11])});eL(_[505],[[cW,'?'8x,9z(gA){3y d2(gA,_[6])});eL(_[506],[[cW,'?'8x,9z(gA){3y d2(gA,_[15])});eL(_[507],[[cW,'?'8x,9z(gA){3y d2(gA,_[18])});eL(_[495],[[cW,'?'8x,9z(gA){3y d2(gA,_[19])});eL(_[494],[[cW,'?'8x,9z(gA){3y d2(gA,_[22])});eL(_[482],[[cS,'?'8x,9z(gx){3y d1(gx,_[11])});eL(_[483],[[cS,'?'8x,9z(gx){3y d1(gx,_[6])});eL(_[484],[[cS,'?'8x,9z(gx){3y d1(gx,_[15])});eL(_[481],[[cS,'?'8x,9z(gx){3y d1(gx,_[18])});eL(_[480],[[cS,'?'8x,9z(gx){3y d1(gx,_[19])});eL(_[477],[[cS,'?'8x,9z(gx){3y d1(gx,_[22])});eL(_[478],[[cS,'?'8x,9z(gx){3y d1(gx,_[4])});eL(_[479],[[cR,'?'8x,9z(gw){3y d1(gw,_[11])});eL(_[485],[[cR,'?'8x,9z(gw){3y d1(gw,_[6])});eL(_[486],[[cR,'?'8x,9z(gw){3y d1(gw,_[15])});eL(_[492],[[cR,'?'8x,9z(gw){3y d1(gw,_[4])});eL(_[493],[[cm,'?'8x,9z(hA){3y d1(hA,_[18])});eL(_[491],[[cm,'?'8x,9z(hA){3y d1(hA,_[19])});eL(_[490],[[cm,'?'8x,9z(hA){3y d1(hA,_[22])});eL(_[487],[[cm,'?'8x,9z(hA){3y d1(hA,_[4])});eL(_[488],[[cS,'?'],[cT,'?',3x8x,9z(gx,gy){3y d0(gx,4x7x18x>13wgy9w2x?4x7x18x>1?gy:5x7x48x:2x)});eL(_[489],[[cR,'?'],[cT,'?',3x8x,9z(gw,gy){3y d0(gw,4x7x18x>13wgy9w2x?4x7x18x>1?gy:5x7x48x:2x)});eL(_[512],[[cm,'?'],[cT,'?',3x8x,9z(hA,gy){3y d0(hA,4x7x18x>13wgy9w2x?4x7x18x>1?gy:5x7x48x:2x)});9z d2(gA,iz){0y(gA6w2x)3y 2x;8y fb=gA[iz]*(gA7x298x?-1:1);3y iz6w_[22]?2y cU(fb):2y c7(fb)};9z d1(gx,iz){0y(gx6w2x)3y 2x;0y(iz6w_[4]){8y f8=gx7x48x;0y(f86w2x)3y 2x;3y 2y cT(0,bd7x408x(~~(f8/60)),bd7x408x(f8%60),0,f8<0)}7z{8y fb=gx[iz];0y(!(gx 1y cR)){0y(iz6w_[18])0y(fb6w24)fb=0}0y(!(gx 1y cm))fb*=gx7x298x?-1:1;3y iz6w_[22]?2y cU(fb):2y c7(fb)}};9z d0(gx,hB){0y(gx6w2x)3y 2x;8y hG;0y(gx 1y cR)hG=2y cR(gx7x118x,gx7x68x,gx7x158x,gx7x48x,gx7x298x);7z 0y(gx 1y cm)hG=2y cm(gx7x188x,gx7x198x,gx7x228x,gx7x48x,gx7x298x);7z hG=2y cS(gx7x118x,gx7x68x,gx7x158x,gx7x188x,gx7x198x,gx7x228x,gx7x48x,gx7x298x);0y(hB6w2x)hG7x48x=2x;7z{8y f8=dt(hB)/60;0y(gx7x48x9w2x){8y fz=f8-gx7x48x;0y(gx 1y cR){0y(fz<0)hG7x158x3v}7z{hG7x198x0vfz%60;hG7x188x0v~~(fz/60)}e3(hG)}hG7x48x=f8}3y hG};eL(_[47],[[cz,'?',3x8x,9z(g0){0y(!4x7x18x){0y(!5x7x248x7x368x(5x7x268x))4y 2y X(_[9]);g0=5x7x268x}7z 0y(g06w2x)3y 2y cl('');8y j2=fm7x2258x7x218x(5x,g0);3y 2y cl(j26w2x?'':j27x318x2w)});eL(_[513],[[cz,'?',3x8x,9z(g0){0y(!4x7x18x){0y(!5x7x248x7x368x(5x7x268x))4y 2y X(_[9]);g0=5x7x268x}7z 0y(g06w2x)3y 2y cl('');3y 2y cl(5x7x248x7x288x(g0,_[20])4w'')});eL(_[537],[[cz,'?',3x8x,9z(g0){0y(!4x7x18x){0y(!5x7x248x7x368x(5x7x268x))4y 2y X(_[9]);g0=5x7x268x}7z 0y(g06w2x)3y bM7x38x(2y cl(''));3y bM7x38x(2y cl(5x7x248x7x288x(g0,_[17])4w''))});eL(_[271],[[bJ,'?',3x8x,9z(gN){0y(!4x7x18x){0y(!5x7x268x)4y 2y X(_[75]);gN=d3([5x7x268x],5x)[0]}8y j2=2y cV(fP);0y(gN9w2x){7y{j2=cV7x38x(gN)}3z(e)1w}3y j2});eL(_[538],[[cl,'?'],[cz,'',3x8x,9z(ir,g0){0y(4x7x18x<2){0y(!5x7x248x7x368x(5x7x268x))4y 2y X(_[9]);g0=5x7x268x}8y d7=5x7x248x7x288x;0y(d7(g0,_[27])6w2)g0=d7(g0,_[56]);8z(8y b;g0;g0=d7(g0,_[42]))0y(b=d7(g0,_[57]))8z(8y fC=0,fJ=b7x18x;fC<fJ;fC2v)0y(d7(b[fC],_[61])6w_[536])3y 2y bO(d7(b[fC],_[7])7x388x(/-.+/,'')7x778x2w6wir7x28x2w7x388x(/-.+/,'')7x778x2w);3y 2y bO(1x)});eL(_[149],[[cz,'?',3x8x,9z(g0){0y(!4x7x18x){0y(!5x7x248x7x368x(5x7x268x))4y 2y X(_[9]);g0=5x7x268x}7z 0y(g06w2x)3y 2x;8y d7=5x7x248x7x288x;0y(d7(g0,_[27])6w2)g0=d7(g0,_[56]);8z(8y h7=g0;h7;h7=d7(g0,_[42]))g0=h7;3y g0});eL(_[40],[[cV,'?'8x,9z(hG){3y 2y cU(bd7x408x(hG))});eL(_[535],[[cV,'?'8x,9z(hG){3y 2y cU(bd7x4458x(hG))});eL(_[216],[[cV,'?'8x,9z(hG){3y 2y cU(bd7x2168x(hG))});eL(_[43],[[cV,'?'8x,9z(hG){3y 2y cU(bd7x438x(hG))});eL(_[532],[[cV,'?'],[c7,'',3x8x,9z(hG,hc){8y fX=4x7x18x>1?hc7x28x2w:0;0y(fX<0){8y hb=2y c7(bd7x728x(10,-fX)),f4=bd7x438x(fn7x908x7x218x(5x,hG,hb)),hm=2y c7(f4);fy=bd7x408x(fn7x1208x7x218x(5x,hm,fn7x908x7x218x(5x,hG,hb)));3y fn7x898x7x218x(5x,fn7x1158x7x218x(5x,hm,2y cU(fy6w0.53wf4%2?-1:0)),hb)}7z{8y hb=2y c7(bd7x728x(10,fX)),f4=bd7x438x(fn7x898x7x218x(5x,hG,hb)),hm=2y c7(f4);fy=bd7x408x(fn7x1208x7x218x(5x,hm,fn7x898x7x218x(5x,hG,hb)));3y fn7x908x7x218x(5x,fn7x1158x7x218x(5x,hm,2y cU(fy6w0.53wf4%2?-1:0)),hb)}});eL(_[533],[[cl,'?'],[cx8x,9z(hf,gB){0y(hf6w2x)3y 2x;8y iF=hf7x28x2w,j=iF7x258x(i9);0y(!j)4y 2y X(_[95]);8y iE=j[1]4w2x,iu=j[2],iA=5x7x248x7x558x(gB,iE);0y(iE9w2x3w!iA)4y 2y X(_[198]);3y 2y cj(iE,iu,iA4w2x)});eL(_[147],[[cl,'?'],[cl8x,9z(hF,hf){8y iF=hf7x28x2w,j=iF7x258x(i9);0y(!j)4y 2y X(_[95]);3y 2y cj(j[1]4w2x,j[2]4w2x,hF6w2x?'':hF7x28x2w)});eL(_[534],[[cj,'?'8x,9z(hf){0y(hf9w2x){0y(hf7x308x)3y 2y ca(hf7x308x)}3y 2x});eL(_[539],[[cj,'?'8x,9z(hf){0y(hf6w2x)3y 2x;3y 2y ca(hf7x208x)});eL(_[540],[[cj,'?'8x,9z(hf){0y(hf6w2x)3y 2x;3y bM7x38x(2y cl(hf7x178x4w''))});eL(_[546],[[cl,'?'],[cx8x,9z(hd,gB){8y iE=hd6w2x?'':hd7x28x2w,iA=5x7x248x7x558x(gB,iE4w2x);3y iA6w2x?2x:bM7x38x(2y cl(iA))});eL(_[181],[[cx8x,9z(gB){4y \"Function '\"+_[181]+\"' not implemented\"});eL(_[118],[[cy,'*'8x,9z(hr){3y 2y bO(d5(hr,5x))});eL(_[547],[[bJ,'*'],[bJ],[cl,'',3x8x,9z(hr,ho,gr){0y(!hr7x18x4who6w2x)3y 0w;8y jZ=ho;0y(jZ 1y cs)jZ=cl7x38x(jZ);8y hq=0w;8z(8y fC=0,fJ=hr7x18x,j1;fC<fJ;fC2v){j1=hr[fC];0y(j1 1y cs)j1=cl7x38x(j1);0y(j17x28x2w6w=jZ7x28x2w)hq7x108x(2y c7(fC+1))}3y hq});eL(_[545],[[cy,'*'8x,9z(hr){3y 2y bO(!hr7x18x)});eL(_[544],[[cy,'*'8x,9z(hr){3y 2y bO(7whr7x18x)});eL(_[541],[[bJ,'*'],[cl,'',3x8x,9z(hr,gr){0y(!hr7x18x)3y 2x;8y hq=0w;8z(8y fC=0,fJ=hr7x18x,jZ;fC<fJ;fC2v){jZ=hr[fC];0y(jZ 1y cs)jZ=cl7x38x(jZ);8z(8y f2=0,f3=hq7x18x,j1,x=1x;(f2<f3)3w!x;f22v){j1=hq[f2];0y(j1 1y cs)j1=cl7x38x(j1);0y(j17x28x2w6w=jZ7x28x2w)x=3x}0y(!x)hq7x108x(hr[fC])}3y hq});eL(_[542],[[cy,'*'],[c7],[cy,'*'8x,9z(hr,ha,ht){0y(!hr7x18x)3y ht;0y(!ht7x18x)3y hr;8y fJ=hr7x18x,fV=ha7x28x2w;0y(fV<1)fV=1;7z 0y(fV>fJ)fV=fJ+1;8y hq=0w;8z(8y fC=0;fC<fJ;fC2v){0y(fV6wfC+1)hq=hq7x968x(ht);hq7x108x(hr[fC])}0y(fV6wfC+1)hq=hq7x968x(ht);3y hq});eL(_[543],[[cy,'*'],[c78x,9z(hr,ha){0y(!hr7x18x)3y 0w;8y fJ=hr7x18x,fV=ha7x28x2w;0y(fV<14wfV>fJ)3y hr;8y hq=0w;8z(8y fC=0;fC<fJ;fC2v)0y(fV9wfC+1)hq7x108x(hr[fC]);3y hq});eL(_[179],[[cy,'*'8x,9z(hr){hr7x1798x2w;3y hr});eL(_[531],[[cy,'*'],[cV,''],[cV,'',3x8x,9z(hr,hv,gU){8y fV=bd7x438x(hv),fJ=4x7x18x>2?bd7x438x(gU):hr7x18x-fV+1;3y hr7x4468x(fV-1,fV-1+fJ)});eL(_[530],[[cy,'*'8x,9z(hr){3y hr});eL(_[519],[[cy,'*'8x,9z(hr){0y(hr7x18x>1)4y 2y X(_[188]);3y hr});eL(_[520],[[cy,'*'8x,9z(hr){0y(!hr7x18x)4y 2y X(_[187]);3y hr});eL(_[518],[[cy,'*'8x,9z(hr){0y(hr7x18x9w1)4y 2y X(_[184]);3y hr});eL(_[185],[[cy,'*'],[cy,'*'],[cl,'',3x8x,9z(hr,hs,gr){4y \"Function '\"+_[185]+\"' not implemented\"});eL(_[517],[[cy,'*'8x,9z(hr){3y 2y c7(hr7x18x)});eL(_[514],[[bJ,'*'8x,9z(hr){0y(!hr7x18x)3y 2x;7y{8y j2=hr[0];0y(j2 1y cs)j2=cV7x38x(j2);8z(8y fC=1,fJ=hr7x18x,j1;fC<fJ;fC2v){j1=hr[fC];0y(j1 1y cs)j1=cV7x38x(j1);j2=ed['+'](j2,j1,5x)}3y ek['div'](j2,2y c7(fJ),5x)}3z(e){4y e7x678x9w_[9]?e:2y X(_[69])}});eL(_[191],[[bJ,'*'],[cl,'',3x8x,9z(hr,gr){0y(!hr7x18x)3y 2x;7y{8y j2=hr[0];8z(8y fC=1,fJ=hr7x18x;fC<fJ;fC2v)0y(eh['ge'](hr[fC],j2,5x)7x28x2w)j2=hr[fC];3y j2}3z(e){4y e7x678x9w_[9]?e:2y X(_[69])}});eL(_[236],[[bJ,'*'],[cl,'',3x8x,9z(hr,gr){0y(!hr7x18x)3y 2x;7y{8y j2=hr[0];8z(8y fC=1,fJ=hr7x18x;fC<fJ;fC2v)0y(eh['le'](hr[fC],j2,5x)7x28x2w)j2=hr[fC];3y j2}3z(e){4y e7x678x9w_[9]?e:2y X(_[69])}});eL(_[515],[[bJ,'*'],[bJ,'?',3x8x,9z(hr,hL){0y(!hr7x18x){0y(4x7x18x>1)3y hL;7z 3y 2y cV(0);3y 2x}7y{8y j2=hr[0];0y(j2 1y cs)j2=cV7x38x(j2);8z(8y fC=1,fJ=hr7x18x,j1;fC<fJ;fC2v){j1=hr[fC];0y(j1 1y cs)j1=cV7x38x(j1);j2=ed['+'](j2,j1,5x)}3y j2}3z(e){4y e7x678x9w_[9]?e:2y X(_[69])}});eL(_[516],[[cl,'*'],[cz,'',3x8x,9z(hr,g0){0y(4x7x18x<2){0y(!5x7x248x7x368x(5x7x268x))4y 2y X(_[9]);g0=5x7x268x}8y gz=fm7x1498x7x218x(5x,g0);0y(5x7x248x7x288x(gz,_[27])9w9)4y 2y X(_[224]);8y hq=0w;8z(8y fC=0;fC<hr7x18x;fC2v)8z(8y f2=0,r=eP(hr[fC])7x488x(/\\s+/),f3=r7x18x;f2<f3;f22v)0y((g0=5x7x248x7x1218x(gz,r[f2]))3wcE(hq,g0)6w-1)hq7x108x(g0);3y d4(hq,5x)});eL(_[217],[[cl,'*'],[cz,'',3x8x,9z(hr,g0){4y \"Function '\"+_[217]+\"' not implemented\"});eL(_[200],[[cl,'?',3x8x,9z(hF){4y \"Function '\"+_[200]+\"' not implemented\"});eL(_[215],[[cl,'?',3x8x,9z(hF){4y \"Function '\"+_[215]+\"' not implemented\"});eL(_[214],[[cl,'?',3x8x,9z(hF){4y \"Function '\"+_[214]+\"' not implemented\"});eL(_[218],[[cl,'*'],[cz,'',3x8x,9z(hr,g0){4y \"Function '\"+_[218]+\"' not implemented\"});9z d5(hr,gu){0y(!hr7x18x)3y 1x;8y gN=hr[0];0y(gu7x248x7x368x(gN))3y 3x;0y(hr7x18x6w1){0y(gN 1y bO)3y gN7x78x7x28x2w;0y(gN 1y cl)3y7wgN7x28x2w7x18x;0y(eZ(gN))3y!(dc(gN7x28x2w)4wgN7x28x2w6w0);4y 2y X(_[69])}4y 2y X(_[69])};9z d3(hr,gu){8y hq=0w;8z(8y fC=0,fJ=hr7x18x,gN,jY;fC<fJ;fC2v){gN=hr[fC];jY=2x;0y(gN6w2x)jY=2x;7z 0y(gu7x248x7x368x(gN)){8y d7=gu7x248x7x288x;6y(d7(gN,_[27])){2z 1:jY=2y cs(d7(gN,_[91]));1z;2z 2:jY=2y cs(d7(gN,_[7]));1z;2z 3:2z 4:2z 8:jY=2y cs(d7(gN,_[116]));1z;2z 7:jY=2y cs(d7(gN,_[116]));1z;2z 9:8y g0=d7(gN,_[342]);jY=2y cs(g0?d7(g0,_[91]):'');1z}}7z 0y(gN 1y bJ)jY=gN;0y(jY9w2x)hq7x108x(jY)}3y hq};9z d4(hr,gu){3y hr7x4478x(9z(g0,h2){8y fV=gu7x248x7x628x(g0,h2);3y fV&2?1:fV&4?-1:0})};eL(_[521],[[c7,'*'8x,9z(hr){8y r=0w;8z(8y fC=0,fJ=hr7x18x;fC<fJ;fC2v)r7x108x(by7x2548x(hr[fC]));3y 2y cl(r7x418x(''))});eL(_[522],[[cl,'?'8x,9z(hG){0y(hG6w2x)3y 2x;8y jO=hG7x28x2w;0y(jO6w'')3y 0w;8y hq=0w;8z(8y fC=0,fJ=jO7x18x;fC<fJ;fC2v)hq7x108x(2y c7(jO7x1758x(fC)));3y hq});eL(_[50],[[cl,'?'],[cl,'?'],[cl,'',3x8x,9z(hH,hI,gr){0y(hH6w2x4whI6w2x)3y 2x;8y ik=5x7x538x7x1748x,jW;0y(4x7x18x>2)ik=gr7x28x2w;jW=ik6wix+_[223]?gq:5x7x538x7x2518x(ik);0y(!jW)4y 2y X(_[222]);3y 2y c7(jW7x508x(hH7x28x2w,hI7x28x2w))});eL(_[528],[[cl,'?'],[cl,'?'8x,9z(hH,hI){0y(hH6w2x4whI6w2x)3y 2x;3y 2y bO(hH7x28x2w6whI7x28x2w)});eL(_[96],2x,9z2w{0y(4x7x18x<2)4y 2y X(_[46]);8y r=0w;8z(8y fC=0,fJ=4x7x18x,hq;fC<fJ;fC2v){hq=4x[fC];dV(5x,hq,'?');0y(hq7x18x)r[r7x18x]=cl7x38x(d3(hq,5x)[0])7x28x2w}3y 2y cl(r7x418x(''))});eL(_[529],[[cl,'*'],[cl8x,9z(hr,hG){3y 2y cl(hr7x418x(hG))});eL(_[101],[[cl,'?'],[cV],[cV,'',3x8x,9z(hG,hv,gU){8y jO=hG6w2x?'':hG7x28x2w,f7=bd7x438x(hv)-1,fA=4x7x18x>2?f7+bd7x438x(gU):jO7x18x;3y 2y cl(fA>f7?jO7x1018x(f7,fA):'')});eL(_[527],[[cl,'?',3x8x,9z(hG){0y(!4x7x18x){0y(!5x7x268x)4y 2y X(_[75]);hG=cl7x38x(d3([5x7x268x],5x)[0])}3y 2y c7(hG6w2x?0:hG7x28x2w7x18x)});eL(_[526],[[cl,'?',3x8x,9z(hG){0y(!4x7x18x){0y(!5x7x268x)4y 2y X(_[75]);hG=cl7x38x(d3([5x7x268x],5x)[0])}3y 2y cl(hG6w2x?'':eP(hG)7x388x(/\\s\\s+/g,' '))});eL(_[272],[[cl,'?'],[cl,'',3x8x,9z(hG,h3){4y \"Function '\"+_[272]+\"' not implemented\"});eL(_[523],[[cl,'?'8x,9z(hG){3y 2y cl(hG6w2x?'':hG7x28x2w7x2648x2w)});eL(_[524],[[cl,'?'8x,9z(hG){3y 2y cl(hG6w2x?'':hG7x28x2w7x778x2w)});eL(_[525],[[cl,'?'],[cl],[cl8x,9z(hG,gY,hC){0y(hG6w2x)3y 2y cl('');8y r=hG7x28x2w7x488x(''),i=gY7x28x2w7x488x(''),p=hC7x28x2w7x488x(''),f9=p7x18x,l=0w;8z(8y fC=0,fJ=r7x18x,fV;fC<fJ;fC2v)0y((fV=i7x458x(r[fC]))6w-1)l[l7x18x]=r[fC];7z 0y(fV<f9)l[l7x18x]=p[fV];3y 2y cl(l7x418x(''))});eL(_[476],[[cl,'?'8x,9z(hG){3y 2y cl(hG6w2x?'':6x7x2318x(hG))});eL(_[475],[[cl,'?'8x,9z(hG){3y 2y cl(hG6w2x?'':6x7x4448x(6x7x4438x(hG)))});eL(_[427],[[cl,'?'8x,9z(hG){0y(hG6w2x4whG7x28x2w6w'')3y 2y cl('');8y r=hG7x28x2w7x488x('');8z(8y fC=0,fJ=r7x18x,ft;fC<fJ;fC2v)0y((ft=r[fC]7x1758x(0))<324wft>126)r[fC]=6x7x2318x(r[fC]);3y 2y cl(r7x418x(''))});eL(_[428],[[cl,'?'],[cl,'?'],[cl,'',3x8x,9z(hG,ho,gr){3y 2y bO((hG6w2x?'':hG7x28x2w)7x458x(ho6w2x?'':ho7x28x2w)5v0)});eL(_[426],[[cl,'?'],[cl,'?'],[cl,'',3x8x,9z(hG,ho,gr){3y 2y bO((hG6w2x?'':hG7x28x2w)7x458x(ho6w2x?'':ho7x28x2w)6w0)});eL(_[425],[[cl,'?'],[cl,'?'],[cl,'',3x8x,9z(hG,ho,gr){8y jO=hG6w2x?'':hG7x28x2w,jK=ho6w2x?'':ho7x28x2w;3y 2y bO(jO7x458x(jK)6wjO7x18x-jK7x18x)});eL(_[422],[[cl,'?'],[cl,'?'],[cl,'',3x8x,9z(hG,ho,gr){8y jO=hG6w2x?'':hG7x28x2w,jK=ho6w2x?'':ho7x28x2w,fV;3y 2y cl((fV=jO7x458x(jK))5v0?jO7x1018x(0,fV):'')});eL(_[423],[[cl,'?'],[cl,'?'],[cl,'',3x8x,9z(hG,ho,gr){8y jO=hG6w2x?'':hG7x28x2w,jK=ho6w2x?'':ho7x28x2w,fV;3y 2y cl((fV=jO7x458x(jK))5v0?jO7x1018x(fV+jK7x18x):'')});9z d6(jO,io){8y d1='\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02FF',d2='\\u0370-\\u037D\\u037F-\\u1FFF\\u200C-\\u200D',d3='\\u2070-\\u218F\\u2C00-\\u2FEF\\u3001-\\jR\\jS-\\jT\\jU-\\jV',c='A-Z_a-z\\\\-.0-9\\u00B7'+d1+'\\u0300-\\u036F'+d2+'\\u203F-\\u2040'+d3,i='A-Z_a-z'+d1+d2+d3;jO=jO 7x388x(/\\[\\\\i-\\[:\\]\\]/g,'['+i+']')7x388x(/\\[\\\\c-\\[:\\]\\]/g,'['+c+']')7x388x(/\\\\i/g,'[:'+i+']')7x388x(/\\\\I/g,'[^:'+i+']')7x388x(/\\\\c/g,'[:'+c+']')7x388x(/\\\\C/g,'[^:'+c+']');0y(io3w!io7x258x(/^[smix]+$/))4y 2y X(_[210]);8y v=io7x458x('s')5v0,w=io7x458x('x')5v0;0y(v4ww){io=io7x388x(/[sx]/g,'');8y r=0w,hR=/\\s/;8z(8y fC=0,fJ=jO7x18x,H=1x,ih,ii='';fC<fJ;fC2v){ih=jO7x1738x(fC);0y(ii9w'\\\\'){0y(ih6w'[')H=3x;7z 0y(ih6w']')H=1x}0y(H4w!(w3whR7x378x(ih))){0y(!H3w(v3wih6w'.'3wii9w'\\\\'))r[r7x18x]='(?:.|\\\\s)';7z r[r7x18x]=ih}ii=ih}jO=r7x418x('')}3y 2y br(jO,io+'g')};eL(_[402],[[cl,'?'],[cl],[cl,'',3x8x,9z(hG,h9,gH){8y jO=hG6w2x?'':hG7x28x2w,hO=d6(h97x28x2w,4x7x18x>2?gH7x28x2w:'');3y 2y bO(hO7x378x(jO))});eL(_[38],[[cl,'?'],[cl],[cl],[cl,'',3x8x,9z(hG,h9,hi,gH){8y jO=hG6w2x?'':hG7x28x2w,hO=d6(h97x28x2w,4x7x18x>3?gH7x28x2w:'');3y 2y bO(jO7x388x(hO,hi7x28x2w))});eL(_[424],[[cl,'?'],[cl],[cl,'',3x8x,9z(hG,h9,gH){8y jO=hG6w2x?'':hG7x28x2w,hO=d6(h97x28x2w,4x7x18x>2?gH7x28x2w:'');8y hq=0w;8z(8y fC=0,r=jO7x488x(hO),fJ=r7x18x;fC<fJ;fC2v)hq7x108x(2y cl(r[fC]));3y hq});eL(_[429],[[cy,'*'],[cl8x,9z(hr,gS){8y gt=6x7x4408x;0y(gt3wgt7x2378x)gt7x2378x(gS7x28x2w,hr);3y hr});8y gq=2y bz;gq7x2448x=9z(jP,jQ){3y jP6wjQ};gq7x508x=9z(jP,jQ){3y jP6wjQ?0:jP>jQ?1:-1};8y M=9z2w1w;M9x7x278x=2;M9x7x618x=M9x7x868x=M9x7x608x=M9x7x208x=M9x7x178x=M9x7x308x=M9x7x578x=M9x7x1768x=M9x7x858x=M9x7x2478x=M9x7x798x=M9x7x748x=M9x7x428x=M9x7x478x=M9x7x928x=M9x7x78x=M9x7x568x=2x;9z ba2w1w;ba9x=2y T;8y gR=2y bw;ba9x7x288x=9z(g0,iz){0y(iz 0z g0)3y g0[iz];0y(iz6w_[83]){8y ie='',eE=gR7x1788x('{'+_[361]+'}'+_[281]),cl=gR7x1068x('{'+_[362]+'}'+_[104]);8z(8y h7=g0,jN;h7;h7=h77x428x)0y(h77x278x6w13w(jN=h77x4418x(_[430])))ie=eE(2y cl(jN),2y cl(ie))7x318x2w;3y ie}7z 0y(iz6w_[91]){8y o=0w;(9z(g0){8z(8y fC=0,gp;gp=g07x1768x[fC];fC2v)0y(gp7x278x6w34wgp7x278x6w4)o7x108x(gp7x1168x);7z 0y(gp7x278x6w13wgp7x858x)4x7x1038x(gp)})(g0);3y o7x418x('')}};ba9x7x628x=9z(g0,gp){0y(_[62] 0z g0)3y g07x628x(gp);0y(gp6wg0)3y 0;8y gj=2x,gk=2x,b,gi,gB,fC,fJ;0y(g07x278x6w2){gj=g0;g0=5x7x288x(gj,_[56])}0y(gp7x278x6w2){gk=gp;gp=5x7x288x(gk,_[56])}0y(gj3wgk3wg03wg06wgp){8z(fC=0,b=5x7x288x(g0,_[57]),fJ=b7x18x;fC<fJ;fC2v){gi=b[fC];0y(gi6wgj)3y 32|4;0y(gi6wgk)3y 32|2}}8y d=0w,fK,g1,e=0w,fL,h2;0y(gj)d7x108x(gj);8z(gB=g0;gB;gB=gB7x428x)d7x108x(gB);0y(gk)e7x108x(gk);8z(gB=gp;gB;gB=gB7x428x)e7x108x(gB);0y(((g07x608x4wg0)9w(gp7x608x4wgp))4w(d[d7x18x-1]9we[e7x18x-1]))3y 32|1;8z(fC=bd7x2368x(fK=d7x18x,fL=e7x18x);fC;3vfC)0y((g1=d[3vfK])9w(h2=e[3vfL])){0y(g17x278x6w2)3y 4;0y(h27x278x6w2)3y 2;0y(!h27x748x)3y 4;0y(!g17x748x)3y 2;8z(gB=h27x798x;gB;gB=gB7x798x)0y(gB6wg1)3y 4;3y 2}3y fK<fL?4|16:2|8};ba9x7x558x=9z(g0,iE){0y(_[55] 0z g0)3y g07x558x(iE);8z(;g03wg07x278x9w9;g0=g07x428x)0y(iE6w5x7x288x(gp,_[30]))3y 5x7x288x(g0,_[17]);7z 0y(g07x278x6w1)8z(8y gm=5x7x288x(g0,_[57]),fC=0,fJ=gm7x18x,iz=_[82]+':'+iE;fC<fJ;fC2v)0y(5x7x288x(gm[fC],_[61])6wiz)3y 5x7x288x(gm[fC],_[7]);3y 2x};ba9x7x988x=9z(g0,iA,iu){0y(_[98] 0z g0)3y g07x988x(iA,iu);8y f=0w,A='*'6wiA,z='*'6wiu;(9z(g0){8z(8y fC=0,gp;gp=g07x1768x[fC];fC2v)0y(gp7x278x6w1){0y((z4wiu6w5x7x288x(gp,_[20]))3w(A4wiA6w5x7x288x(gp,_[17])))f[f7x18x]=gp;0y(gp7x858x)4x7x1038x(gp)}})(g0);3y f};8y gP=2y ba;8y gQ=2y ba;gQ7x288x=9z(g0,iz){0y(iz6w_[20]){0y(g07x278x6w1)3y g07x208x7x778x2w}0y(iz6w_[17])3y g07x278x6w1?_[376]:2x;3y ba9x7x288x7x218x(5x,g0,iz)};8y gW=2y ba;gW7x288x=9z(g0,iz){0y(iz6w_[20]){0y(g07x278x6w1)3y g07x618x7x778x2w}0y(iz6w_[30])3y 2x;0y(iz6w_[17])3y g07x278x6w1?_[376]:2x;0y(iz6w_[91])3y g07x4428x;0y(iz6w_[57]3wg07x278x6w1){8y b=0w;8z(8y fC=0,gm=g07x578x,fJ=gm7x18x,h2,gl;fC<fJ;fC2v){h2=gm[fC];0y(h27x928x){gl=2y M;gl7x568x=g0;gl7x608x=g07x608x;gl7x928x=3x;gl7x78x=gl7x868x=h27x868x;gl7x478x=gl7x618x=gl7x208x=h27x618x7x778x2w;b[b7x18x]=gl}}3y b}3y ba9x7x288x7x218x(5x,g0,iz)};8y gX=2y ba;gX7x288x=9z(g0,iz){0y(iz6w_[20]){0y(g07x278x6w7)3y 2x;0y(g07x278x6w1)3y g07x1928x}0y(iz6w_[30]4wiz6w_[17])3y g0[iz]4w2x;0y(iz6w_[91])3y g07x1808x;0y(iz6w_[57]3wg07x278x6w1){8y b=0w;8z(8y fC=0,gm=g07x578x,fJ=gm7x18x,h2,gl;fC<fJ;fC2v){h2=gm[fC];0y(h27x928x){gl=2y M;gl7x278x=2;gl7x568x=g0;gl7x608x=g07x608x;gl7x928x=3x;gl7x78x=gl7x868x=h27x868x;gl7x478x=gl7x618x=h27x618x;gl7x208x=h27x1928x;gl7x308x=h27x308x4w2x;gl7x178x=h27x178x4w2x;b[b7x18x]=gl}}3y b}3y ba9x7x288x7x218x(5x,g0,iz)};gX7x1218x=9z(gz,iq){3y gz7x4488x(iq)};8y bp=6x7x4498x,gz=6x7x4558x,C=7wgz7x4568x3w!gz7x4548x,D=!C3wgz7x3428x7x178x9w_[376];8y gK=2y bw,hK=2y bw;gK7x838x=gz7x4538x7x4508x;gK7x878x=_[361];gK7x1408x=_[376];hK7x878x=gK7x878x;9z eY(hh,_d,dh){0y(5y _d6w_[167]4w_d6w=2x)_d='';8y g0=hh[0];0y(5y g06w_[167])g0=2x;8y hw=g03w(g07x278x6w9?g0:g07x608x)7x4518x(_[436])7x4528x6w_[437]?gK:hK;hw7x1148x=dh;8y gF=2y b0(by(_d),hw);hw7x1148x=2x;8y n,hq=2y bp,ge=gP;0y(C)ge=hw6wgK?gW:gX;7z 0y(D3whw6wgK)ge=gQ;n=gF7x88x(2y V(hw,g0,2x,ge));8z(8y fC=0,fJ=n7x18x,gN;fC<fJ;fC2v)hq7x108x(ge7x368x(gN=n[fC])?gN:bw7x2208x(gN));3y hq};8y h4=1w;h47x2218x=9z(hh,_d,dh){3y eY(hh 1y bp?hh:2y bp(hh),_d,dh)};bp7x1978x(bp,h4);h4=1w;h47x2218x=9z(_d,dh){3y eY(5x,_d,dh)};bp7x1978x(bp9x,h4);",">?!>=!..!,,!>.!>,!>\"!>>\"!\"\"!>>!>>>!}}!\'\'!*)!~|!^\\!^%\\!^^!\\`\\!xpeojx!tjiu!tuofnvhsb!fvsu!mmvo!ftmbg!iujx!fmjix!sbw!zsu!idujxt!gpfqzu!xpsiu!osvufs!xfo!gpfdobutoj!gj!opjudovg!spg!ftmf!fufmfe!umvbgfe!fvojuopd!idubd!ftbd!lbfsc!oj",'',0,this,'prototype length valueOf cast timezone peek month value evaluate XPTY0004 push year XPST0003 next eof day items namespaceURI hours minutes localName call seconds builtInKind DOMAdapter match item nodeType getProperty negative prefix toString left FORG0001 primitiveKind expression isNode test replace type abs join parentNode round bindings indexOf XPST0017 name split stack compare scope operator staticContext predicates lookupNamespaceURI ownerElement attributes path occurence ownerDocument nodeName compareDocumentPosition right itemType attribute scheme code authority FORG0006 dateTime args pow getURIForPrefix nextSibling XPDY0002 position toLowerCase index previousSibling inExpr node xmlns baseURI substr firstChild nodeValue defaultFunctionNamespace schema-attribute numeric-multiply numeric-divide textContent specified schema-element size FOCA0002 concat numeric-greater-than getElementsByTagNameNS numeric-less-than XPST0051 substring satisfiesExpr callee string XPDY0050 getDataType collations parent functions descendant-or-self dataTypes axis returnExpr namespaceResolver numeric-add data isSameNode boolean union numeric-subtract getElementById query fragment child intersect ancestor ancestor-or-self thenExpr internalExpression numeric-equal quantifier applyPredicates collections add-dayTimeDuration-to-time to popVariable except condExpr pushVariable defaultElementNamespace hasOwnProperty elseExpr document-node time-less-than date-greater-than boolean-less-than QName time-greater-than root date-less-than dateTime-greater-than boolean-greater-than yearMonthDuration-greater-than dayTimeDuration-less-than dayTimeDuration-greater-than dateTime-less-than NOTATION multiply-yearMonthDuration yearMonthDuration-less-than element add-yearMonthDuration-to-date add-dayTimeDuration-to-date preceding-sibling processing-instruction add-dayTimeDuration-to-dateTime as undefined Infinity multiply-dayTimeDuration add-yearMonthDuration-to-dateTime preceding documents charAt defaultCollationName charCodeAt childNodes pop getFunction reverse text in-scope-prefixes hexBinary-equal base64Binary-equal FORG0005 deep-equal NMTOKEN_DT FORG0004 FORG0003 and or max baseName in getMinutes setMinutes XPTY0020 extend FONS0004 boolean-equal doc gYearMonth gYear hexBinary ENTITY_DT time gMonthDay gMonth float NCNAME_DT FORX0001 gDay BOOLEAN_DT ID_DT collection doc-available floor idref element-with-id LANGUAGE_DT xs2js xpath FOCH0002 /collation/codepoint FODC0001 node-name subtract-yearMonthDuration-from-date subtract-dayTimeDuration-from-date subtract-dayTimeDuration-from-time target true encodeURIComponent subtract-dates subtract-times subtract-yearMonthDuration-from-dateTime subtract-dayTimeDuration-from-dateTime min log numeric-mod numeric-integer-divide node-after node-before numeric-unary-plus numeric-unary-minus equals concatenate QName-equal lastChild subtract-dateTimes divide-dayTimeDuration-by-dayTimeDuration time-equal getCollation gYearMonth-equal gYear-equal fromCharCode date-equal duration-equal INF dateTime-equal every gMonthDay-equal gMonth-equal add-dayTimeDurations subtract-dayTimeDurations toUpperCase divide-dayTimeDuration divide-yearMonthDuration-by-yearMonthDuration divide-yearMonthDuration gDay-equal add-yearMonthDurations subtract-yearMonthDurations number normalize-unicode INT_DT comment SHORT_DT BYTE_DT LONG_DT NEGATIVEINTEGER_DT DAYTIMEDURATION_DT INTEGER_DT resolve-uri NONPOSITIVEINTEGER_DT NONNEGATIVEINTEGER_DT GMONTHDAY_DT GDAY_DT PRIMITIVE_FLOAT is-same-node FLOAT_DT PRIMITIVE_GDAY GMONTH_DT xml XPST0008 PRIMITIVE_GMONTH XPTY0019 XT_YEARMONTHDURATION_DT following following-sibling self NOTATION_DT descendant PRIMITIVE_HEXBINARY GYEARMONTH_DT PRIMITIVE_GYEARMONTH HEXBINARY_DT GYEAR_DT PRIMITIVE_NOTATION TIME_DT XPST0081 PRIMITIVE_TIME XT_UNTYPEDATOMIC_DT PRIMITIVE_STRING STRING_DT PRIMITIVE_GMONTHDAY QNAME_DT PRIMITIVE_QNAME PRIMITIVE_DURATION DURATION_DT DATE_DT anyAtomicType PRIMITIVE_BOOLEAN BASE64BINARY_DT PRIMITIVE_ANYURI ANYURI_DT ANYSIMPLETYPE_DT UNSIGNEDSHORT_DT ANYATOMICTYPE_DT PRIMITIVE_BASE64BINARY anyURI NORMALIZEDSTRING_DT TOKEN_DT duration NAME_DT UNSIGNEDBYTE_DT double base64Binary date decimal UNSIGNEDINT_DT ANYTYPE_DT PRIMITIVE_DECIMAL DECIMAL_DT documentElement apply DOUBLE_DT trim PRIMITIVE_DOUBLE POSITIVEINTEGER_DT PRIMITIVE_DATETIME PRIMITIVE_GYEAR DATETIME_DT PRIMITIVE_DATE UNSIGNEDLONG_DT XPTY0018 else some XPST0010 http://www.w3.org/XML/1998/namespace if then http://www.w3.org/2000/xmlns/ http://www.w3.org/2005/xpath-functions http://www.w3.org/2001/XMLSchema treat castable int of instance fourth for fifth long XPST0080 dayTimeDuration yearMonthDuration untypedAtomic http://www.w3.org/1999/xhtml empty-sequence negativeInteger nonPositiveInteger integer short byte NCName Name token ENTITY ID satisfies NMTOKEN language normalizedString unsignedByte third positiveInteger nonNegativeInteger second unsignedLong unsignedShort first unsignedInt return matches isNaN isFinite NaN TypeError SyntaxError Function Math Error btoa atob getTimezoneOffset getFullYear getMonth back reset parseInt message Date RegExp substring-before substring-after tokenize ends-with starts-with escape-html-uri contains trace xml:base Number Object Array Boolean String div DIV getDate getHours console getAttribute innerText decodeURI encodeURI ceil slice sort nodeFromID jQuery href createElement tagName location createElementNS document namespaces getTime setSeconds setFunction setCollation setCollection setDocument setDataType getSeconds getMilliseconds js2xs IDREF_DT DAYMONTHDURATION_DT PRECISIONDECIMAL_DT setHours DATETIMESTAMP_DT UNAVAILABLE_DT LISTOFUNION_DT LIST_DT iri-to-uri encode-for-uri seconds-from-dateTime timezone-from-dateTime year-from-date minutes-from-dateTime hours-from-dateTime year-from-dateTime month-from-dateTime day-from-dateTime month-from-date day-from-date timezone-from-time adjust-dateTime-to-timezone adjust-date-to-timezone seconds-from-time minutes-from-time timezone-from-date hours-from-time seconds-from-duration minutes-from-duration not last current-dateTime false documentURI base-uri document-uri current-date current-time months-from-duration days-from-duration hours-from-duration years-from-duration static-base-uri implicit-timezone default-collation adjust-time-to-timezone local-name avg sum id count exactly-one zero-or-one one-or-more codepoints-to-string string-to-codepoints upper-case lower-case translate normalize-space string-length codepoint-equal string-join unordered subsequence round-half-to-even resolve-QName prefix-from-QName ceiling xml:lang namespace-uri lang local-name-from-QName namespace-uri-from-QName distinct-values insert-before remove exists empty namespace-uri-for-prefix index-of nilled'.split(' '));
TP.boot.$$srcPath = '';

        
        TP.registerExternalObject('jxpath', window.jQuery.xpath);
        
    
TP.boot.$$srcPath = '~lib_deps/jsonpath-tpi.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
/*! jsonpath 1.0.1 */

(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.jsonpath = f()}})(function(){var define,module,exports;return (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({"./aesprim":[function(require,module,exports){
/*
  Copyright (C) 2013 Ariya Hidayat <ariya.hidayat@gmail.com>
  Copyright (C) 2013 Thaddee Tyl <thaddee.tyl@gmail.com>
  Copyright (C) 2013 Mathias Bynens <mathias@qiwi.be>
  Copyright (C) 2012 Ariya Hidayat <ariya.hidayat@gmail.com>
  Copyright (C) 2012 Mathias Bynens <mathias@qiwi.be>
  Copyright (C) 2012 Joost-Wim Boekesteijn <joost-wim@boekesteijn.nl>
  Copyright (C) 2012 Kris Kowal <kris.kowal@cixar.com>
  Copyright (C) 2012 Yusuke Suzuki <utatane.tea@gmail.com>
  Copyright (C) 2012 Arpad Borsos <arpad.borsos@googlemail.com>
  Copyright (C) 2011 Ariya Hidayat <ariya.hidayat@gmail.com>

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*jslint bitwise:true plusplus:true */
/*global esprima:true, define:true, exports:true, window: true,
throwErrorTolerant: true,
throwError: true, generateStatement: true, peek: true,
parseAssignmentExpression: true, parseBlock: true, parseExpression: true,
parseFunctionDeclaration: true, parseFunctionExpression: true,
parseFunctionSourceElements: true, parseVariableIdentifier: true,
parseLeftHandSideExpression: true,
parseUnaryExpression: true,
parseStatement: true, parseSourceElement: true */

(function (root, factory) {
    'use strict';

    // Universal Module Definition (UMD) to support AMD, CommonJS/Node.js,
    // Rhino, and plain browser loading.

    /* istanbul ignore next */
    if (typeof define === 'function' && define.amd) {
        define(['exports'], factory);
    } else if (typeof exports !== 'undefined') {
        factory(exports);
    } else {
        factory((root.esprima = {}));
    }
}(this, function (exports) {
    'use strict';

    var Token,
        TokenName,
        FnExprTokens,
        Syntax,
        PropertyKind,
        Messages,
        Regex,
        SyntaxTreeDelegate,
        source,
        strict,
        index,
        lineNumber,
        lineStart,
        length,
        delegate,
        lookahead,
        state,
        extra;

    Token = {
        BooleanLiteral: 1,
        EOF: 2,
        Identifier: 3,
        Keyword: 4,
        NullLiteral: 5,
        NumericLiteral: 6,
        Punctuator: 7,
        StringLiteral: 8,
        RegularExpression: 9
    };

    TokenName = {};
    TokenName[Token.BooleanLiteral] = 'Boolean';
    TokenName[Token.EOF] = '<end>';
    TokenName[Token.Identifier] = 'Identifier';
    TokenName[Token.Keyword] = 'Keyword';
    TokenName[Token.NullLiteral] = 'Null';
    TokenName[Token.NumericLiteral] = 'Numeric';
    TokenName[Token.Punctuator] = 'Punctuator';
    TokenName[Token.StringLiteral] = 'String';
    TokenName[Token.RegularExpression] = 'RegularExpression';

    // A function following one of those tokens is an expression.
    FnExprTokens = ['(', '{', '[', 'in', 'typeof', 'instanceof', 'new',
                    'return', 'case', 'delete', 'throw', 'void',
                    // assignment operators
                    '=', '+=', '-=', '*=', '/=', '%=', '<<=', '>>=', '>>>=',
                    '&=', '|=', '^=', ',',
                    // binary/unary operators
                    '+', '-', '*', '/', '%', '++', '--', '<<', '>>', '>>>', '&',
                    '|', '^', '!', '~', '&&', '||', '?', ':', '===', '==', '>=',
                    '<=', '<', '>', '!=', '!=='];

    Syntax = {
        AssignmentExpression: 'AssignmentExpression',
        ArrayExpression: 'ArrayExpression',
        BlockStatement: 'BlockStatement',
        BinaryExpression: 'BinaryExpression',
        BreakStatement: 'BreakStatement',
        CallExpression: 'CallExpression',
        CatchClause: 'CatchClause',
        ConditionalExpression: 'ConditionalExpression',
        ContinueStatement: 'ContinueStatement',
        DoWhileStatement: 'DoWhileStatement',
        DebuggerStatement: 'DebuggerStatement',
        EmptyStatement: 'EmptyStatement',
        ExpressionStatement: 'ExpressionStatement',
        ForStatement: 'ForStatement',
        ForInStatement: 'ForInStatement',
        FunctionDeclaration: 'FunctionDeclaration',
        FunctionExpression: 'FunctionExpression',
        Identifier: 'Identifier',
        IfStatement: 'IfStatement',
        Literal: 'Literal',
        LabeledStatement: 'LabeledStatement',
        LogicalExpression: 'LogicalExpression',
        MemberExpression: 'MemberExpression',
        NewExpression: 'NewExpression',
        ObjectExpression: 'ObjectExpression',
        Program: 'Program',
        Property: 'Property',
        ReturnStatement: 'ReturnStatement',
        SequenceExpression: 'SequenceExpression',
        SwitchStatement: 'SwitchStatement',
        SwitchCase: 'SwitchCase',
        ThisExpression: 'ThisExpression',
        ThrowStatement: 'ThrowStatement',
        TryStatement: 'TryStatement',
        UnaryExpression: 'UnaryExpression',
        UpdateExpression: 'UpdateExpression',
        VariableDeclaration: 'VariableDeclaration',
        VariableDeclarator: 'VariableDeclarator',
        WhileStatement: 'WhileStatement',
        WithStatement: 'WithStatement'
    };

    PropertyKind = {
        Data: 1,
        Get: 2,
        Set: 4
    };

    // Error messages should be identical to V8.
    Messages = {
        UnexpectedToken:  'Unexpected token %0',
        UnexpectedNumber:  'Unexpected number',
        UnexpectedString:  'Unexpected string',
        UnexpectedIdentifier:  'Unexpected identifier',
        UnexpectedReserved:  'Unexpected reserved word',
        UnexpectedEOS:  'Unexpected end of input',
        NewlineAfterThrow:  'Illegal newline after throw',
        InvalidRegExp: 'Invalid regular expression',
        UnterminatedRegExp:  'Invalid regular expression: missing /',
        InvalidLHSInAssignment:  'Invalid left-hand side in assignment',
        InvalidLHSInForIn:  'Invalid left-hand side in for-in',
        MultipleDefaultsInSwitch: 'More than one default clause in switch statement',
        NoCatchOrFinally:  'Missing catch or finally after try',
        UnknownLabel: 'Undefined label \'%0\'',
        Redeclaration: '%0 \'%1\' has already been declared',
        IllegalContinue: 'Illegal continue statement',
        IllegalBreak: 'Illegal break statement',
        IllegalReturn: 'Illegal return statement',
        StrictModeWith:  'Strict mode code may not include a with statement',
        StrictCatchVariable:  'Catch variable may not be eval or arguments in strict mode',
        StrictVarName:  'Variable name may not be eval or arguments in strict mode',
        StrictParamName:  'Parameter name eval or arguments is not allowed in strict mode',
        StrictParamDupe: 'Strict mode function may not have duplicate parameter names',
        StrictFunctionName:  'Function name may not be eval or arguments in strict mode',
        StrictOctalLiteral:  'Octal literals are not allowed in strict mode.',
        StrictDelete:  'Delete of an unqualified identifier in strict mode.',
        StrictDuplicateProperty:  'Duplicate data property in object literal not allowed in strict mode',
        AccessorDataProperty:  'Object literal may not have data and accessor property with the same name',
        AccessorGetSet:  'Object literal may not have multiple get/set accessors with the same name',
        StrictLHSAssignment:  'Assignment to eval or arguments is not allowed in strict mode',
        StrictLHSPostfix:  'Postfix increment/decrement may not have eval or arguments operand in strict mode',
        StrictLHSPrefix:  'Prefix increment/decrement may not have eval or arguments operand in strict mode',
        StrictReservedWord:  'Use of future reserved word in strict mode'
    };

    // See also tools/generate-unicode-regex.py.
    Regex = {
        NonAsciiIdentifierStart: new RegExp('[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u0527\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0\u08A2-\u08AC\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0977\u0979-\u097F\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C33\u0C35-\u0C39\u0C3D\u0C58\u0C59\u0C60\u0C61\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D60\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F4\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F0\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191C\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19C1-\u19C7\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FCC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA697\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA78E\uA790-\uA793\uA7A0-\uA7AA\uA7F8-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA80-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uABC0-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]'),
        NonAsciiIdentifierPart: new RegExp('[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0300-\u0374\u0376\u0377\u037A-\u037D\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u0483-\u0487\u048A-\u0527\u0531-\u0556\u0559\u0561-\u0587\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u05D0-\u05EA\u05F0-\u05F2\u0610-\u061A\u0620-\u0669\u066E-\u06D3\u06D5-\u06DC\u06DF-\u06E8\u06EA-\u06FC\u06FF\u0710-\u074A\u074D-\u07B1\u07C0-\u07F5\u07FA\u0800-\u082D\u0840-\u085B\u08A0\u08A2-\u08AC\u08E4-\u08FE\u0900-\u0963\u0966-\u096F\u0971-\u0977\u0979-\u097F\u0981-\u0983\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BC-\u09C4\u09C7\u09C8\u09CB-\u09CE\u09D7\u09DC\u09DD\u09DF-\u09E3\u09E6-\u09F1\u0A01-\u0A03\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A59-\u0A5C\u0A5E\u0A66-\u0A75\u0A81-\u0A83\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABC-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AD0\u0AE0-\u0AE3\u0AE6-\u0AEF\u0B01-\u0B03\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3C-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B5C\u0B5D\u0B5F-\u0B63\u0B66-\u0B6F\u0B71\u0B82\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD0\u0BD7\u0BE6-\u0BEF\u0C01-\u0C03\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C33\u0C35-\u0C39\u0C3D-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C58\u0C59\u0C60-\u0C63\u0C66-\u0C6F\u0C82\u0C83\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBC-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CDE\u0CE0-\u0CE3\u0CE6-\u0CEF\u0CF1\u0CF2\u0D02\u0D03\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D-\u0D44\u0D46-\u0D48\u0D4A-\u0D4E\u0D57\u0D60-\u0D63\u0D66-\u0D6F\u0D7A-\u0D7F\u0D82\u0D83\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DF2\u0DF3\u0E01-\u0E3A\u0E40-\u0E4E\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB9\u0EBB-\u0EBD\u0EC0-\u0EC4\u0EC6\u0EC8-\u0ECD\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E-\u0F47\u0F49-\u0F6C\u0F71-\u0F84\u0F86-\u0F97\u0F99-\u0FBC\u0FC6\u1000-\u1049\u1050-\u109D\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u135D-\u135F\u1380-\u138F\u13A0-\u13F4\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F0\u1700-\u170C\u170E-\u1714\u1720-\u1734\u1740-\u1753\u1760-\u176C\u176E-\u1770\u1772\u1773\u1780-\u17D3\u17D7\u17DC\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u1820-\u1877\u1880-\u18AA\u18B0-\u18F5\u1900-\u191C\u1920-\u192B\u1930-\u193B\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19D9\u1A00-\u1A1B\u1A20-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AA7\u1B00-\u1B4B\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1BF3\u1C00-\u1C37\u1C40-\u1C49\u1C4D-\u1C7D\u1CD0-\u1CD2\u1CD4-\u1CF6\u1D00-\u1DE6\u1DFC-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u200C\u200D\u203F\u2040\u2054\u2071\u207F\u2090-\u209C\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D7F-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2DE0-\u2DFF\u2E2F\u3005-\u3007\u3021-\u302F\u3031-\u3035\u3038-\u303C\u3041-\u3096\u3099\u309A\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FCC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66F\uA674-\uA67D\uA67F-\uA697\uA69F-\uA6F1\uA717-\uA71F\uA722-\uA788\uA78B-\uA78E\uA790-\uA793\uA7A0-\uA7AA\uA7F8-\uA827\uA840-\uA873\uA880-\uA8C4\uA8D0-\uA8D9\uA8E0-\uA8F7\uA8FB\uA900-\uA92D\uA930-\uA953\uA960-\uA97C\uA980-\uA9C0\uA9CF-\uA9D9\uAA00-\uAA36\uAA40-\uAA4D\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7B\uAA80-\uAAC2\uAADB-\uAADD\uAAE0-\uAAEF\uAAF2-\uAAF6\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uABC0-\uABEA\uABEC\uABED\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE00-\uFE0F\uFE20-\uFE26\uFE33\uFE34\uFE4D-\uFE4F\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF3F\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]')
    };

    // Ensure the condition is true, otherwise throw an error.
    // This is only to have a better contract semantic, i.e. another safety net
    // to catch a logic error. The condition shall be fulfilled in normal case.
    // Do NOT use this to enforce a certain condition on any user input.

    function assert(condition, message) {
        /* istanbul ignore if */
        if (!condition) {
            throw new Error('ASSERT: ' + message);
        }
    }

    function isDecimalDigit(ch) {
        return (ch >= 48 && ch <= 57);   // 0..9
    }

    function isHexDigit(ch) {
        return '0123456789abcdefABCDEF'.indexOf(ch) >= 0;
    }

    function isOctalDigit(ch) {
        return '01234567'.indexOf(ch) >= 0;
    }


    // 7.2 White Space

    function isWhiteSpace(ch) {
        return (ch === 0x20) || (ch === 0x09) || (ch === 0x0B) || (ch === 0x0C) || (ch === 0xA0) ||
            (ch >= 0x1680 && [0x1680, 0x180E, 0x2000, 0x2001, 0x2002, 0x2003, 0x2004, 0x2005, 0x2006, 0x2007, 0x2008, 0x2009, 0x200A, 0x202F, 0x205F, 0x3000, 0xFEFF].indexOf(ch) >= 0);
    }

    // 7.3 Line Terminators

    function isLineTerminator(ch) {
        return (ch === 0x0A) || (ch === 0x0D) || (ch === 0x2028) || (ch === 0x2029);
    }

    // 7.6 Identifier Names and Identifiers

    function isIdentifierStart(ch) {
        return (ch == 0x40) ||  (ch === 0x24) || (ch === 0x5F) ||  // $ (dollar) and _ (underscore)
            (ch >= 0x41 && ch <= 0x5A) ||         // A..Z
            (ch >= 0x61 && ch <= 0x7A) ||         // a..z
            (ch === 0x5C) ||                      // \ (backslash)
            ((ch >= 0x80) && Regex.NonAsciiIdentifierStart.test(String.fromCharCode(ch)));
    }

    function isIdentifierPart(ch) {
        return (ch === 0x24) || (ch === 0x5F) ||  // $ (dollar) and _ (underscore)
            (ch >= 0x41 && ch <= 0x5A) ||         // A..Z
            (ch >= 0x61 && ch <= 0x7A) ||         // a..z
            (ch >= 0x30 && ch <= 0x39) ||         // 0..9
            (ch === 0x5C) ||                      // \ (backslash)
            ((ch >= 0x80) && Regex.NonAsciiIdentifierPart.test(String.fromCharCode(ch)));
    }

    // 7.6.1.2 Future Reserved Words

    function isFutureReservedWord(id) {
        switch (id) {
        case 'class':
        case 'enum':
        case 'export':
        case 'extends':
        case 'import':
        case 'super':
            return true;
        default:
            return false;
        }
    }

    function isStrictModeReservedWord(id) {
        switch (id) {
        case 'implements':
        case 'interface':
        case 'package':
        case 'private':
        case 'protected':
        case 'public':
        case 'static':
        case 'yield':
        case 'let':
            return true;
        default:
            return false;
        }
    }

    function isRestrictedWord(id) {
        return id === 'eval' || id === 'arguments';
    }

    // 7.6.1.1 Keywords

    function isKeyword(id) {
        if (strict && isStrictModeReservedWord(id)) {
            return true;
        }

        // 'const' is specialized as Keyword in V8.
        // 'yield' and 'let' are for compatiblity with SpiderMonkey and ES.next.
        // Some others are from future reserved words.

        switch (id.length) {
        case 2:
            return (id === 'if') || (id === 'in') || (id === 'do');
        case 3:
            return (id === 'var') || (id === 'for') || (id === 'new') ||
                (id === 'try') || (id === 'let');
        case 4:
            return (id === 'this') || (id === 'else') || (id === 'case') ||
                (id === 'void') || (id === 'with') || (id === 'enum');
        case 5:
            return (id === 'while') || (id === 'break') || (id === 'catch') ||
                (id === 'throw') || (id === 'const') || (id === 'yield') ||
                (id === 'class') || (id === 'super');
        case 6:
            return (id === 'return') || (id === 'typeof') || (id === 'delete') ||
                (id === 'switch') || (id === 'export') || (id === 'import');
        case 7:
            return (id === 'default') || (id === 'finally') || (id === 'extends');
        case 8:
            return (id === 'function') || (id === 'continue') || (id === 'debugger');
        case 10:
            return (id === 'instanceof');
        default:
            return false;
        }
    }

    // 7.4 Comments

    function addComment(type, value, start, end, loc) {
        var comment, attacher;

        assert(typeof start === 'number', 'Comment must have valid position');

        // Because the way the actual token is scanned, often the comments
        // (if any) are skipped twice during the lexical analysis.
        // Thus, we need to skip adding a comment if the comment array already
        // handled it.
        if (state.lastCommentStart >= start) {
            return;
        }
        state.lastCommentStart = start;

        comment = {
            type: type,
            value: value
        };
        if (extra.range) {
            comment.range = [start, end];
        }
        if (extra.loc) {
            comment.loc = loc;
        }
        extra.comments.push(comment);
        if (extra.attachComment) {
            extra.leadingComments.push(comment);
            extra.trailingComments.push(comment);
        }
    }

    function skipSingleLineComment(offset) {
        var start, loc, ch, comment;

        start = index - offset;
        loc = {
            start: {
                line: lineNumber,
                column: index - lineStart - offset
            }
        };

        while (index < length) {
            ch = source.charCodeAt(index);
            ++index;
            if (isLineTerminator(ch)) {
                if (extra.comments) {
                    comment = source.slice(start + offset, index - 1);
                    loc.end = {
                        line: lineNumber,
                        column: index - lineStart - 1
                    };
                    addComment('Line', comment, start, index - 1, loc);
                }
                if (ch === 13 && source.charCodeAt(index) === 10) {
                    ++index;
                }
                ++lineNumber;
                lineStart = index;
                return;
            }
        }

        if (extra.comments) {
            comment = source.slice(start + offset, index);
            loc.end = {
                line: lineNumber,
                column: index - lineStart
            };
            addComment('Line', comment, start, index, loc);
        }
    }

    function skipMultiLineComment() {
        var start, loc, ch, comment;

        if (extra.comments) {
            start = index - 2;
            loc = {
                start: {
                    line: lineNumber,
                    column: index - lineStart - 2
                }
            };
        }

        while (index < length) {
            ch = source.charCodeAt(index);
            if (isLineTerminator(ch)) {
                if (ch === 0x0D && source.charCodeAt(index + 1) === 0x0A) {
                    ++index;
                }
                ++lineNumber;
                ++index;
                lineStart = index;
                if (index >= length) {
                    throwError({}, Messages.UnexpectedToken, 'ILLEGAL');
                }
            } else if (ch === 0x2A) {
                // Block comment ends with '*/'.
                if (source.charCodeAt(index + 1) === 0x2F) {
                    ++index;
                    ++index;
                    if (extra.comments) {
                        comment = source.slice(start + 2, index - 2);
                        loc.end = {
                            line: lineNumber,
                            column: index - lineStart
                        };
                        addComment('Block', comment, start, index, loc);
                    }
                    return;
                }
                ++index;
            } else {
                ++index;
            }
        }

        throwError({}, Messages.UnexpectedToken, 'ILLEGAL');
    }

    function skipComment() {
        var ch, start;

        start = (index === 0);
        while (index < length) {
            ch = source.charCodeAt(index);

            if (isWhiteSpace(ch)) {
                ++index;
            } else if (isLineTerminator(ch)) {
                ++index;
                if (ch === 0x0D && source.charCodeAt(index) === 0x0A) {
                    ++index;
                }
                ++lineNumber;
                lineStart = index;
                start = true;
            } else if (ch === 0x2F) { // U+002F is '/'
                ch = source.charCodeAt(index + 1);
                if (ch === 0x2F) {
                    ++index;
                    ++index;
                    skipSingleLineComment(2);
                    start = true;
                } else if (ch === 0x2A) {  // U+002A is '*'
                    ++index;
                    ++index;
                    skipMultiLineComment();
                } else {
                    break;
                }
            } else if (start && ch === 0x2D) { // U+002D is '-'
                // U+003E is '>'
                if ((source.charCodeAt(index + 1) === 0x2D) && (source.charCodeAt(index + 2) === 0x3E)) {
                    // '-->' is a single-line comment
                    index += 3;
                    skipSingleLineComment(3);
                } else {
                    break;
                }
            } else if (ch === 0x3C) { // U+003C is '<'
                if (source.slice(index + 1, index + 4) === '!--') {
                    ++index; // `<`
                    ++index; // `!`
                    ++index; // `-`
                    ++index; // `-`
                    skipSingleLineComment(4);
                } else {
                    break;
                }
            } else {
                break;
            }
        }
    }

    function scanHexEscape(prefix) {
        var i, len, ch, code = 0;

        len = (prefix === 'u') ? 4 : 2;
        for (i = 0; i < len; ++i) {
            if (index < length && isHexDigit(source[index])) {
                ch = source[index++];
                code = code * 16 + '0123456789abcdef'.indexOf(ch.toLowerCase());
            } else {
                return '';
            }
        }
        return String.fromCharCode(code);
    }

    function getEscapedIdentifier() {
        var ch, id;

        ch = source.charCodeAt(index++);
        id = String.fromCharCode(ch);

        // '\u' (U+005C, U+0075) denotes an escaped character.
        if (ch === 0x5C) {
            if (source.charCodeAt(index) !== 0x75) {
                throwError({}, Messages.UnexpectedToken, 'ILLEGAL');
            }
            ++index;
            ch = scanHexEscape('u');
            if (!ch || ch === '\\' || !isIdentifierStart(ch.charCodeAt(0))) {
                throwError({}, Messages.UnexpectedToken, 'ILLEGAL');
            }
            id = ch;
        }

        while (index < length) {
            ch = source.charCodeAt(index);
            if (!isIdentifierPart(ch)) {
                break;
            }
            ++index;
            id += String.fromCharCode(ch);

            // '\u' (U+005C, U+0075) denotes an escaped character.
            if (ch === 0x5C) {
                id = id.substr(0, id.length - 1);
                if (source.charCodeAt(index) !== 0x75) {
                    throwError({}, Messages.UnexpectedToken, 'ILLEGAL');
                }
                ++index;
                ch = scanHexEscape('u');
                if (!ch || ch === '\\' || !isIdentifierPart(ch.charCodeAt(0))) {
                    throwError({}, Messages.UnexpectedToken, 'ILLEGAL');
                }
                id += ch;
            }
        }

        return id;
    }

    function getIdentifier() {
        var start, ch;

        start = index++;
        while (index < length) {
            ch = source.charCodeAt(index);
            if (ch === 0x5C) {
                // Blackslash (U+005C) marks Unicode escape sequence.
                index = start;
                return getEscapedIdentifier();
            }
            if (isIdentifierPart(ch)) {
                ++index;
            } else {
                break;
            }
        }

        return source.slice(start, index);
    }

    function scanIdentifier() {
        var start, id, type;

        start = index;

        // Backslash (U+005C) starts an escaped character.
        id = (source.charCodeAt(index) === 0x5C) ? getEscapedIdentifier() : getIdentifier();

        // There is no keyword or literal with only one character.
        // Thus, it must be an identifier.
        if (id.length === 1) {
            type = Token.Identifier;
        } else if (isKeyword(id)) {
            type = Token.Keyword;
        } else if (id === 'null') {
            type = Token.NullLiteral;
        } else if (id === 'true' || id === 'false') {
            type = Token.BooleanLiteral;
        } else {
            type = Token.Identifier;
        }

        return {
            type: type,
            value: id,
            lineNumber: lineNumber,
            lineStart: lineStart,
            start: start,
            end: index
        };
    }


    // 7.7 Punctuators

    function scanPunctuator() {
        var start = index,
            code = source.charCodeAt(index),
            code2,
            ch1 = source[index],
            ch2,
            ch3,
            ch4;

        switch (code) {

        // Check for most common single-character punctuators.
        case 0x2E:  // . dot
        case 0x28:  // ( open bracket
        case 0x29:  // ) close bracket
        case 0x3B:  // ; semicolon
        case 0x2C:  // , comma
        case 0x7B:  // { open curly brace
        case 0x7D:  // } close curly brace
        case 0x5B:  // [
        case 0x5D:  // ]
        case 0x3A:  // :
        case 0x3F:  // ?
        case 0x7E:  // ~
            ++index;
            if (extra.tokenize) {
                if (code === 0x28) {
                    extra.openParenToken = extra.tokens.length;
                } else if (code === 0x7B) {
                    extra.openCurlyToken = extra.tokens.length;
                }
            }
            return {
                type: Token.Punctuator,
                value: String.fromCharCode(code),
                lineNumber: lineNumber,
                lineStart: lineStart,
                start: start,
                end: index
            };

        default:
            code2 = source.charCodeAt(index + 1);

            // '=' (U+003D) marks an assignment or comparison operator.
            if (code2 === 0x3D) {
                switch (code) {
                case 0x2B:  // +
                case 0x2D:  // -
                case 0x2F:  // /
                case 0x3C:  // <
                case 0x3E:  // >
                case 0x5E:  // ^
                case 0x7C:  // |
                case 0x25:  // %
                case 0x26:  // &
                case 0x2A:  // *
                    index += 2;
                    return {
                        type: Token.Punctuator,
                        value: String.fromCharCode(code) + String.fromCharCode(code2),
                        lineNumber: lineNumber,
                        lineStart: lineStart,
                        start: start,
                        end: index
                    };

                case 0x21: // !
                case 0x3D: // =
                    index += 2;

                    // !== and ===
                    if (source.charCodeAt(index) === 0x3D) {
                        ++index;
                    }
                    return {
                        type: Token.Punctuator,
                        value: source.slice(start, index),
                        lineNumber: lineNumber,
                        lineStart: lineStart,
                        start: start,
                        end: index
                    };
                }
            }
        }

        // 4-character punctuator: >>>=

        ch4 = source.substr(index, 4);

        if (ch4 === '>>>=') {
            index += 4;
            return {
                type: Token.Punctuator,
                value: ch4,
                lineNumber: lineNumber,
                lineStart: lineStart,
                start: start,
                end: index
            };
        }

        // 3-character punctuators: === !== >>> <<= >>=

        ch3 = ch4.substr(0, 3);

        if (ch3 === '>>>' || ch3 === '<<=' || ch3 === '>>=') {
            index += 3;
            return {
                type: Token.Punctuator,
                value: ch3,
                lineNumber: lineNumber,
                lineStart: lineStart,
                start: start,
                end: index
            };
        }

        // Other 2-character punctuators: ++ -- << >> && ||
        ch2 = ch3.substr(0, 2);

        if ((ch1 === ch2[1] && ('+-<>&|'.indexOf(ch1) >= 0)) || ch2 === '=>') {
            index += 2;
            return {
                type: Token.Punctuator,
                value: ch2,
                lineNumber: lineNumber,
                lineStart: lineStart,
                start: start,
                end: index
            };
        }

        // 1-character punctuators: < > = ! + - * % & | ^ /
        if ('<>=!+-*%&|^/'.indexOf(ch1) >= 0) {
            ++index;
            return {
                type: Token.Punctuator,
                value: ch1,
                lineNumber: lineNumber,
                lineStart: lineStart,
                start: start,
                end: index
            };
        }

        throwError({}, Messages.UnexpectedToken, 'ILLEGAL');
    }

    // 7.8.3 Numeric Literals

    function scanHexLiteral(start) {
        var number = '';

        while (index < length) {
            if (!isHexDigit(source[index])) {
                break;
            }
            number += source[index++];
        }

        if (number.length === 0) {
            throwError({}, Messages.UnexpectedToken, 'ILLEGAL');
        }

        if (isIdentifierStart(source.charCodeAt(index))) {
            throwError({}, Messages.UnexpectedToken, 'ILLEGAL');
        }

        return {
            type: Token.NumericLiteral,
            value: parseInt('0x' + number, 16),
            lineNumber: lineNumber,
            lineStart: lineStart,
            start: start,
            end: index
        };
    }

    function scanOctalLiteral(start) {
        var number = '0' + source[index++];
        while (index < length) {
            if (!isOctalDigit(source[index])) {
                break;
            }
            number += source[index++];
        }

        if (isIdentifierStart(source.charCodeAt(index)) || isDecimalDigit(source.charCodeAt(index))) {
            throwError({}, Messages.UnexpectedToken, 'ILLEGAL');
        }

        return {
            type: Token.NumericLiteral,
            value: parseInt(number, 8),
            octal: true,
            lineNumber: lineNumber,
            lineStart: lineStart,
            start: start,
            end: index
        };
    }

    function scanNumericLiteral() {
        var number, start, ch;

        ch = source[index];
        assert(isDecimalDigit(ch.charCodeAt(0)) || (ch === '.'),
            'Numeric literal must start with a decimal digit or a decimal point');

        start = index;
        number = '';
        if (ch !== '.') {
            number = source[index++];
            ch = source[index];

            // Hex number starts with '0x'.
            // Octal number starts with '0'.
            if (number === '0') {
                if (ch === 'x' || ch === 'X') {
                    ++index;
                    return scanHexLiteral(start);
                }
                if (isOctalDigit(ch)) {
                    return scanOctalLiteral(start);
                }

                // decimal number starts with '0' such as '09' is illegal.
                if (ch && isDecimalDigit(ch.charCodeAt(0))) {
                    throwError({}, Messages.UnexpectedToken, 'ILLEGAL');
                }
            }

            while (isDecimalDigit(source.charCodeAt(index))) {
                number += source[index++];
            }
            ch = source[index];
        }

        if (ch === '.') {
            number += source[index++];
            while (isDecimalDigit(source.charCodeAt(index))) {
                number += source[index++];
            }
            ch = source[index];
        }

        if (ch === 'e' || ch === 'E') {
            number += source[index++];

            ch = source[index];
            if (ch === '+' || ch === '-') {
                number += source[index++];
            }
            if (isDecimalDigit(source.charCodeAt(index))) {
                while (isDecimalDigit(source.charCodeAt(index))) {
                    number += source[index++];
                }
            } else {
                throwError({}, Messages.UnexpectedToken, 'ILLEGAL');
            }
        }

        if (isIdentifierStart(source.charCodeAt(index))) {
            throwError({}, Messages.UnexpectedToken, 'ILLEGAL');
        }

        return {
            type: Token.NumericLiteral,
            value: parseFloat(number),
            lineNumber: lineNumber,
            lineStart: lineStart,
            start: start,
            end: index
        };
    }

    // 7.8.4 String Literals

    function scanStringLiteral() {
        var str = '', quote, start, ch, code, unescaped, restore, octal = false, startLineNumber, startLineStart;
        startLineNumber = lineNumber;
        startLineStart = lineStart;

        quote = source[index];
        assert((quote === '\'' || quote === '"'),
            'String literal must starts with a quote');

        start = index;
        ++index;

        while (index < length) {
            ch = source[index++];

            if (ch === quote) {
                quote = '';
                break;
            } else if (ch === '\\') {
                ch = source[index++];
                if (!ch || !isLineTerminator(ch.charCodeAt(0))) {
                    switch (ch) {
                    case 'u':
                    case 'x':
                        restore = index;
                        unescaped = scanHexEscape(ch);
                        if (unescaped) {
                            str += unescaped;
                        } else {
                            index = restore;
                            str += ch;
                        }
                        break;
                    case 'n':
                        str += '\n';
                        break;
                    case 'r':
                        str += '\r';
                        break;
                    case 't':
                        str += '\t';
                        break;
                    case 'b':
                        str += '\b';
                        break;
                    case 'f':
                        str += '\f';
                        break;
                    case 'v':
                        str += '\x0B';
                        break;

                    default:
                        if (isOctalDigit(ch)) {
                            code = '01234567'.indexOf(ch);

                            // \0 is not octal escape sequence
                            if (code !== 0) {
                                octal = true;
                            }

                            if (index < length && isOctalDigit(source[index])) {
                                octal = true;
                                code = code * 8 + '01234567'.indexOf(source[index++]);

                                // 3 digits are only allowed when string starts
                                // with 0, 1, 2, 3
                                if ('0123'.indexOf(ch) >= 0 &&
                                        index < length &&
                                        isOctalDigit(source[index])) {
                                    code = code * 8 + '01234567'.indexOf(source[index++]);
                                }
                            }
                            str += String.fromCharCode(code);
                        } else {
                            str += ch;
                        }
                        break;
                    }
                } else {
                    ++lineNumber;
                    if (ch ===  '\r' && source[index] === '\n') {
                        ++index;
                    }
                    lineStart = index;
                }
            } else if (isLineTerminator(ch.charCodeAt(0))) {
                break;
            } else {
                str += ch;
            }
        }

        if (quote !== '') {
            throwError({}, Messages.UnexpectedToken, 'ILLEGAL');
        }

        return {
            type: Token.StringLiteral,
            value: str,
            octal: octal,
            startLineNumber: startLineNumber,
            startLineStart: startLineStart,
            lineNumber: lineNumber,
            lineStart: lineStart,
            start: start,
            end: index
        };
    }

    function testRegExp(pattern, flags) {
        var value;
        try {
            value = new RegExp(pattern, flags);
        } catch (e) {
            throwError({}, Messages.InvalidRegExp);
        }
        return value;
    }

    function scanRegExpBody() {
        var ch, str, classMarker, terminated, body;

        ch = source[index];
        assert(ch === '/', 'Regular expression literal must start with a slash');
        str = source[index++];

        classMarker = false;
        terminated = false;
        while (index < length) {
            ch = source[index++];
            str += ch;
            if (ch === '\\') {
                ch = source[index++];
                // ECMA-262 7.8.5
                if (isLineTerminator(ch.charCodeAt(0))) {
                    throwError({}, Messages.UnterminatedRegExp);
                }
                str += ch;
            } else if (isLineTerminator(ch.charCodeAt(0))) {
                throwError({}, Messages.UnterminatedRegExp);
            } else if (classMarker) {
                if (ch === ']') {
                    classMarker = false;
                }
            } else {
                if (ch === '/') {
                    terminated = true;
                    break;
                } else if (ch === '[') {
                    classMarker = true;
                }
            }
        }

        if (!terminated) {
            throwError({}, Messages.UnterminatedRegExp);
        }

        // Exclude leading and trailing slash.
        body = str.substr(1, str.length - 2);
        return {
            value: body,
            literal: str
        };
    }

    function scanRegExpFlags() {
        var ch, str, flags, restore;

        str = '';
        flags = '';
        while (index < length) {
            ch = source[index];
            if (!isIdentifierPart(ch.charCodeAt(0))) {
                break;
            }

            ++index;
            if (ch === '\\' && index < length) {
                ch = source[index];
                if (ch === 'u') {
                    ++index;
                    restore = index;
                    ch = scanHexEscape('u');
                    if (ch) {
                        flags += ch;
                        for (str += '\\u'; restore < index; ++restore) {
                            str += source[restore];
                        }
                    } else {
                        index = restore;
                        flags += 'u';
                        str += '\\u';
                    }
                    throwErrorTolerant({}, Messages.UnexpectedToken, 'ILLEGAL');
                } else {
                    str += '\\';
                    throwErrorTolerant({}, Messages.UnexpectedToken, 'ILLEGAL');
                }
            } else {
                flags += ch;
                str += ch;
            }
        }

        return {
            value: flags,
            literal: str
        };
    }

    function scanRegExp() {
        var start, body, flags, pattern, value;

        lookahead = null;
        skipComment();
        start = index;

        body = scanRegExpBody();
        flags = scanRegExpFlags();
        value = testRegExp(body.value, flags.value);

        if (extra.tokenize) {
            return {
                type: Token.RegularExpression,
                value: value,
                lineNumber: lineNumber,
                lineStart: lineStart,
                start: start,
                end: index
            };
        }

        return {
            literal: body.literal + flags.literal,
            value: value,
            start: start,
            end: index
        };
    }

    function collectRegex() {
        var pos, loc, regex, token;

        skipComment();

        pos = index;
        loc = {
            start: {
                line: lineNumber,
                column: index - lineStart
            }
        };

        regex = scanRegExp();
        loc.end = {
            line: lineNumber,
            column: index - lineStart
        };

        /* istanbul ignore next */
        if (!extra.tokenize) {
            // Pop the previous token, which is likely '/' or '/='
            if (extra.tokens.length > 0) {
                token = extra.tokens[extra.tokens.length - 1];
                if (token.range[0] === pos && token.type === 'Punctuator') {
                    if (token.value === '/' || token.value === '/=') {
                        extra.tokens.pop();
                    }
                }
            }

            extra.tokens.push({
                type: 'RegularExpression',
                value: regex.literal,
                range: [pos, index],
                loc: loc
            });
        }

        return regex;
    }

    function isIdentifierName(token) {
        return token.type === Token.Identifier ||
            token.type === Token.Keyword ||
            token.type === Token.BooleanLiteral ||
            token.type === Token.NullLiteral;
    }

    function advanceSlash() {
        var prevToken,
            checkToken;
        // Using the following algorithm:
        // https://github.com/mozilla/sweet.js/wiki/design
        prevToken = extra.tokens[extra.tokens.length - 1];
        if (!prevToken) {
            // Nothing before that: it cannot be a division.
            return collectRegex();
        }
        if (prevToken.type === 'Punctuator') {
            if (prevToken.value === ']') {
                return scanPunctuator();
            }
            if (prevToken.value === ')') {
                checkToken = extra.tokens[extra.openParenToken - 1];
                if (checkToken &&
                        checkToken.type === 'Keyword' &&
                        (checkToken.value === 'if' ||
                         checkToken.value === 'while' ||
                         checkToken.value === 'for' ||
                         checkToken.value === 'with')) {
                    return collectRegex();
                }
                return scanPunctuator();
            }
            if (prevToken.value === '}') {
                // Dividing a function by anything makes little sense,
                // but we have to check for that.
                if (extra.tokens[extra.openCurlyToken - 3] &&
                        extra.tokens[extra.openCurlyToken - 3].type === 'Keyword') {
                    // Anonymous function.
                    checkToken = extra.tokens[extra.openCurlyToken - 4];
                    if (!checkToken) {
                        return scanPunctuator();
                    }
                } else if (extra.tokens[extra.openCurlyToken - 4] &&
                        extra.tokens[extra.openCurlyToken - 4].type === 'Keyword') {
                    // Named function.
                    checkToken = extra.tokens[extra.openCurlyToken - 5];
                    if (!checkToken) {
                        return collectRegex();
                    }
                } else {
                    return scanPunctuator();
                }
                // checkToken determines whether the function is
                // a declaration or an expression.
                if (FnExprTokens.indexOf(checkToken.value) >= 0) {
                    // It is an expression.
                    return scanPunctuator();
                }
                // It is a declaration.
                return collectRegex();
            }
            return collectRegex();
        }
        if (prevToken.type === 'Keyword') {
            return collectRegex();
        }
        return scanPunctuator();
    }

    function advance() {
        var ch;

        skipComment();

        if (index >= length) {
            return {
                type: Token.EOF,
                lineNumber: lineNumber,
                lineStart: lineStart,
                start: index,
                end: index
            };
        }

        ch = source.charCodeAt(index);

        if (isIdentifierStart(ch)) {
            return scanIdentifier();
        }

        // Very common: ( and ) and ;
        if (ch === 0x28 || ch === 0x29 || ch === 0x3B) {
            return scanPunctuator();
        }

        // String literal starts with single quote (U+0027) or double quote (U+0022).
        if (ch === 0x27 || ch === 0x22) {
            return scanStringLiteral();
        }


        // Dot (.) U+002E can also start a floating-point number, hence the need
        // to check the next character.
        if (ch === 0x2E) {
            if (isDecimalDigit(source.charCodeAt(index + 1))) {
                return scanNumericLiteral();
            }
            return scanPunctuator();
        }

        if (isDecimalDigit(ch)) {
            return scanNumericLiteral();
        }

        // Slash (/) U+002F can also start a regex.
        if (extra.tokenize && ch === 0x2F) {
            return advanceSlash();
        }

        return scanPunctuator();
    }

    function collectToken() {
        var loc, token, range, value;

        skipComment();
        loc = {
            start: {
                line: lineNumber,
                column: index - lineStart
            }
        };

        token = advance();
        loc.end = {
            line: lineNumber,
            column: index - lineStart
        };

        if (token.type !== Token.EOF) {
            value = source.slice(token.start, token.end);
            extra.tokens.push({
                type: TokenName[token.type],
                value: value,
                range: [token.start, token.end],
                loc: loc
            });
        }

        return token;
    }

    function lex() {
        var token;

        token = lookahead;
        index = token.end;
        lineNumber = token.lineNumber;
        lineStart = token.lineStart;

        lookahead = (typeof extra.tokens !== 'undefined') ? collectToken() : advance();

        index = token.end;
        lineNumber = token.lineNumber;
        lineStart = token.lineStart;

        return token;
    }

    function peek() {
        var pos, line, start;

        pos = index;
        line = lineNumber;
        start = lineStart;
        lookahead = (typeof extra.tokens !== 'undefined') ? collectToken() : advance();
        index = pos;
        lineNumber = line;
        lineStart = start;
    }

    function Position(line, column) {
        this.line = line;
        this.column = column;
    }

    function SourceLocation(startLine, startColumn, line, column) {
        this.start = new Position(startLine, startColumn);
        this.end = new Position(line, column);
    }

    SyntaxTreeDelegate = {

        name: 'SyntaxTree',

        processComment: function (node) {
            var lastChild, trailingComments;

            if (node.type === Syntax.Program) {
                if (node.body.length > 0) {
                    return;
                }
            }

            if (extra.trailingComments.length > 0) {
                if (extra.trailingComments[0].range[0] >= node.range[1]) {
                    trailingComments = extra.trailingComments;
                    extra.trailingComments = [];
                } else {
                    extra.trailingComments.length = 0;
                }
            } else {
                if (extra.bottomRightStack.length > 0 &&
                        extra.bottomRightStack[extra.bottomRightStack.length - 1].trailingComments &&
                        extra.bottomRightStack[extra.bottomRightStack.length - 1].trailingComments[0].range[0] >= node.range[1]) {
                    trailingComments = extra.bottomRightStack[extra.bottomRightStack.length - 1].trailingComments;
                    delete extra.bottomRightStack[extra.bottomRightStack.length - 1].trailingComments;
                }
            }

            // Eating the stack.
            while (extra.bottomRightStack.length > 0 && extra.bottomRightStack[extra.bottomRightStack.length - 1].range[0] >= node.range[0]) {
                lastChild = extra.bottomRightStack.pop();
            }

            if (lastChild) {
                if (lastChild.leadingComments && lastChild.leadingComments[lastChild.leadingComments.length - 1].range[1] <= node.range[0]) {
                    node.leadingComments = lastChild.leadingComments;
                    delete lastChild.leadingComments;
                }
            } else if (extra.leadingComments.length > 0 && extra.leadingComments[extra.leadingComments.length - 1].range[1] <= node.range[0]) {
                node.leadingComments = extra.leadingComments;
                extra.leadingComments = [];
            }


            if (trailingComments) {
                node.trailingComments = trailingComments;
            }

            extra.bottomRightStack.push(node);
        },

        markEnd: function (node, startToken) {
            if (extra.range) {
                node.range = [startToken.start, index];
            }
            if (extra.loc) {
                node.loc = new SourceLocation(
                    startToken.startLineNumber === undefined ?  startToken.lineNumber : startToken.startLineNumber,
                    startToken.start - (startToken.startLineStart === undefined ?  startToken.lineStart : startToken.startLineStart),
                    lineNumber,
                    index - lineStart
                );
                this.postProcess(node);
            }

            if (extra.attachComment) {
                this.processComment(node);
            }
            return node;
        },

        postProcess: function (node) {
            if (extra.source) {
                node.loc.source = extra.source;
            }
            return node;
        },

        createArrayExpression: function (elements) {
            return {
                type: Syntax.ArrayExpression,
                elements: elements
            };
        },

        createAssignmentExpression: function (operator, left, right) {
            return {
                type: Syntax.AssignmentExpression,
                operator: operator,
                left: left,
                right: right
            };
        },

        createBinaryExpression: function (operator, left, right) {
            var type = (operator === '||' || operator === '&&') ? Syntax.LogicalExpression :
                        Syntax.BinaryExpression;
            return {
                type: type,
                operator: operator,
                left: left,
                right: right
            };
        },

        createBlockStatement: function (body) {
            return {
                type: Syntax.BlockStatement,
                body: body
            };
        },

        createBreakStatement: function (label) {
            return {
                type: Syntax.BreakStatement,
                label: label
            };
        },

        createCallExpression: function (callee, args) {
            return {
                type: Syntax.CallExpression,
                callee: callee,
                'arguments': args
            };
        },

        createCatchClause: function (param, body) {
            return {
                type: Syntax.CatchClause,
                param: param,
                body: body
            };
        },

        createConditionalExpression: function (test, consequent, alternate) {
            return {
                type: Syntax.ConditionalExpression,
                test: test,
                consequent: consequent,
                alternate: alternate
            };
        },

        createContinueStatement: function (label) {
            return {
                type: Syntax.ContinueStatement,
                label: label
            };
        },

        createDebuggerStatement: function () {
            return {
                type: Syntax.DebuggerStatement
            };
        },

        createDoWhileStatement: function (body, test) {
            return {
                type: Syntax.DoWhileStatement,
                body: body,
                test: test
            };
        },

        createEmptyStatement: function () {
            return {
                type: Syntax.EmptyStatement
            };
        },

        createExpressionStatement: function (expression) {
            return {
                type: Syntax.ExpressionStatement,
                expression: expression
            };
        },

        createForStatement: function (init, test, update, body) {
            return {
                type: Syntax.ForStatement,
                init: init,
                test: test,
                update: update,
                body: body
            };
        },

        createForInStatement: function (left, right, body) {
            return {
                type: Syntax.ForInStatement,
                left: left,
                right: right,
                body: body,
                each: false
            };
        },

        createFunctionDeclaration: function (id, params, defaults, body) {
            return {
                type: Syntax.FunctionDeclaration,
                id: id,
                params: params,
                defaults: defaults,
                body: body,
                rest: null,
                generator: false,
                expression: false
            };
        },

        createFunctionExpression: function (id, params, defaults, body) {
            return {
                type: Syntax.FunctionExpression,
                id: id,
                params: params,
                defaults: defaults,
                body: body,
                rest: null,
                generator: false,
                expression: false
            };
        },

        createIdentifier: function (name) {
            return {
                type: Syntax.Identifier,
                name: name
            };
        },

        createIfStatement: function (test, consequent, alternate) {
            return {
                type: Syntax.IfStatement,
                test: test,
                consequent: consequent,
                alternate: alternate
            };
        },

        createLabeledStatement: function (label, body) {
            return {
                type: Syntax.LabeledStatement,
                label: label,
                body: body
            };
        },

        createLiteral: function (token) {
            return {
                type: Syntax.Literal,
                value: token.value,
                raw: source.slice(token.start, token.end)
            };
        },

        createMemberExpression: function (accessor, object, property) {
            return {
                type: Syntax.MemberExpression,
                computed: accessor === '[',
                object: object,
                property: property
            };
        },

        createNewExpression: function (callee, args) {
            return {
                type: Syntax.NewExpression,
                callee: callee,
                'arguments': args
            };
        },

        createObjectExpression: function (properties) {
            return {
                type: Syntax.ObjectExpression,
                properties: properties
            };
        },

        createPostfixExpression: function (operator, argument) {
            return {
                type: Syntax.UpdateExpression,
                operator: operator,
                argument: argument,
                prefix: false
            };
        },

        createProgram: function (body) {
            return {
                type: Syntax.Program,
                body: body
            };
        },

        createProperty: function (kind, key, value) {
            return {
                type: Syntax.Property,
                key: key,
                value: value,
                kind: kind
            };
        },

        createReturnStatement: function (argument) {
            return {
                type: Syntax.ReturnStatement,
                argument: argument
            };
        },

        createSequenceExpression: function (expressions) {
            return {
                type: Syntax.SequenceExpression,
                expressions: expressions
            };
        },

        createSwitchCase: function (test, consequent) {
            return {
                type: Syntax.SwitchCase,
                test: test,
                consequent: consequent
            };
        },

        createSwitchStatement: function (discriminant, cases) {
            return {
                type: Syntax.SwitchStatement,
                discriminant: discriminant,
                cases: cases
            };
        },

        createThisExpression: function () {
            return {
                type: Syntax.ThisExpression
            };
        },

        createThrowStatement: function (argument) {
            return {
                type: Syntax.ThrowStatement,
                argument: argument
            };
        },

        createTryStatement: function (block, guardedHandlers, handlers, finalizer) {
            return {
                type: Syntax.TryStatement,
                block: block,
                guardedHandlers: guardedHandlers,
                handlers: handlers,
                finalizer: finalizer
            };
        },

        createUnaryExpression: function (operator, argument) {
            if (operator === '++' || operator === '--') {
                return {
                    type: Syntax.UpdateExpression,
                    operator: operator,
                    argument: argument,
                    prefix: true
                };
            }
            return {
                type: Syntax.UnaryExpression,
                operator: operator,
                argument: argument,
                prefix: true
            };
        },

        createVariableDeclaration: function (declarations, kind) {
            return {
                type: Syntax.VariableDeclaration,
                declarations: declarations,
                kind: kind
            };
        },

        createVariableDeclarator: function (id, init) {
            return {
                type: Syntax.VariableDeclarator,
                id: id,
                init: init
            };
        },

        createWhileStatement: function (test, body) {
            return {
                type: Syntax.WhileStatement,
                test: test,
                body: body
            };
        },

        createWithStatement: function (object, body) {
            return {
                type: Syntax.WithStatement,
                object: object,
                body: body
            };
        }
    };

    // Return true if there is a line terminator before the next token.

    function peekLineTerminator() {
        var pos, line, start, found;

        pos = index;
        line = lineNumber;
        start = lineStart;
        skipComment();
        found = lineNumber !== line;
        index = pos;
        lineNumber = line;
        lineStart = start;

        return found;
    }

    // Throw an exception

    function throwError(token, messageFormat) {
        var error,
            args = Array.prototype.slice.call(arguments, 2),
            msg = messageFormat.replace(
                /%(\d)/g,
                function (whole, index) {
                    assert(index < args.length, 'Message reference must be in range');
                    return args[index];
                }
            );

        if (typeof token.lineNumber === 'number') {
            error = new Error('Line ' + token.lineNumber + ': ' + msg);
            error.index = token.start;
            error.lineNumber = token.lineNumber;
            error.column = token.start - lineStart + 1;
        } else {
            error = new Error('Line ' + lineNumber + ': ' + msg);
            error.index = index;
            error.lineNumber = lineNumber;
            error.column = index - lineStart + 1;
        }

        error.description = msg;
        throw error;
    }

    function throwErrorTolerant() {
        try {
            throwError.apply(null, arguments);
        } catch (e) {
            if (extra.errors) {
                extra.errors.push(e);
            } else {
                throw e;
            }
        }
    }


    // Throw an exception because of the token.

    function throwUnexpected(token) {
        if (token.type === Token.EOF) {
            throwError(token, Messages.UnexpectedEOS);
        }

        if (token.type === Token.NumericLiteral) {
            throwError(token, Messages.UnexpectedNumber);
        }

        if (token.type === Token.StringLiteral) {
            throwError(token, Messages.UnexpectedString);
        }

        if (token.type === Token.Identifier) {
            throwError(token, Messages.UnexpectedIdentifier);
        }

        if (token.type === Token.Keyword) {
            if (isFutureReservedWord(token.value)) {
                throwError(token, Messages.UnexpectedReserved);
            } else if (strict && isStrictModeReservedWord(token.value)) {
                throwErrorTolerant(token, Messages.StrictReservedWord);
                return;
            }
            throwError(token, Messages.UnexpectedToken, token.value);
        }

        // BooleanLiteral, NullLiteral, or Punctuator.
        throwError(token, Messages.UnexpectedToken, token.value);
    }

    // Expect the next token to match the specified punctuator.
    // If not, an exception will be thrown.

    function expect(value) {
        var token = lex();
        if (token.type !== Token.Punctuator || token.value !== value) {
            throwUnexpected(token);
        }
    }

    // Expect the next token to match the specified keyword.
    // If not, an exception will be thrown.

    function expectKeyword(keyword) {
        var token = lex();
        if (token.type !== Token.Keyword || token.value !== keyword) {
            throwUnexpected(token);
        }
    }

    // Return true if the next token matches the specified punctuator.

    function match(value) {
        return lookahead.type === Token.Punctuator && lookahead.value === value;
    }

    // Return true if the next token matches the specified keyword

    function matchKeyword(keyword) {
        return lookahead.type === Token.Keyword && lookahead.value === keyword;
    }

    // Return true if the next token is an assignment operator

    function matchAssign() {
        var op;

        if (lookahead.type !== Token.Punctuator) {
            return false;
        }
        op = lookahead.value;
        return op === '=' ||
            op === '*=' ||
            op === '/=' ||
            op === '%=' ||
            op === '+=' ||
            op === '-=' ||
            op === '<<=' ||
            op === '>>=' ||
            op === '>>>=' ||
            op === '&=' ||
            op === '^=' ||
            op === '|=';
    }

    function consumeSemicolon() {
        var line;

        // Catch the very common case first: immediately a semicolon (U+003B).
        if (source.charCodeAt(index) === 0x3B || match(';')) {
            lex();
            return;
        }

        line = lineNumber;
        skipComment();
        if (lineNumber !== line) {
            return;
        }

        if (lookahead.type !== Token.EOF && !match('}')) {
            throwUnexpected(lookahead);
        }
    }

    // Return true if provided expression is LeftHandSideExpression

    function isLeftHandSide(expr) {
        return expr.type === Syntax.Identifier || expr.type === Syntax.MemberExpression;
    }

    // 11.1.4 Array Initialiser

    function parseArrayInitialiser() {
        var elements = [], startToken;

        startToken = lookahead;
        expect('[');

        while (!match(']')) {
            if (match(',')) {
                lex();
                elements.push(null);
            } else {
                elements.push(parseAssignmentExpression());

                if (!match(']')) {
                    expect(',');
                }
            }
        }

        lex();

        return delegate.markEnd(delegate.createArrayExpression(elements), startToken);
    }

    // 11.1.5 Object Initialiser

    function parsePropertyFunction(param, first) {
        var previousStrict, body, startToken;

        previousStrict = strict;
        startToken = lookahead;
        body = parseFunctionSourceElements();
        if (first && strict && isRestrictedWord(param[0].name)) {
            throwErrorTolerant(first, Messages.StrictParamName);
        }
        strict = previousStrict;
        return delegate.markEnd(delegate.createFunctionExpression(null, param, [], body), startToken);
    }

    function parseObjectPropertyKey() {
        var token, startToken;

        startToken = lookahead;
        token = lex();

        // Note: This function is called only from parseObjectProperty(), where
        // EOF and Punctuator tokens are already filtered out.

        if (token.type === Token.StringLiteral || token.type === Token.NumericLiteral) {
            if (strict && token.octal) {
                throwErrorTolerant(token, Messages.StrictOctalLiteral);
            }
            return delegate.markEnd(delegate.createLiteral(token), startToken);
        }

        return delegate.markEnd(delegate.createIdentifier(token.value), startToken);
    }

    function parseObjectProperty() {
        var token, key, id, value, param, startToken;

        token = lookahead;
        startToken = lookahead;

        if (token.type === Token.Identifier) {

            id = parseObjectPropertyKey();

            // Property Assignment: Getter and Setter.

            if (token.value === 'get' && !match(':')) {
                key = parseObjectPropertyKey();
                expect('(');
                expect(')');
                value = parsePropertyFunction([]);
                return delegate.markEnd(delegate.createProperty('get', key, value), startToken);
            }
            if (token.value === 'set' && !match(':')) {
                key = parseObjectPropertyKey();
                expect('(');
                token = lookahead;
                if (token.type !== Token.Identifier) {
                    expect(')');
                    throwErrorTolerant(token, Messages.UnexpectedToken, token.value);
                    value = parsePropertyFunction([]);
                } else {
                    param = [ parseVariableIdentifier() ];
                    expect(')');
                    value = parsePropertyFunction(param, token);
                }
                return delegate.markEnd(delegate.createProperty('set', key, value), startToken);
            }
            expect(':');
            value = parseAssignmentExpression();
            return delegate.markEnd(delegate.createProperty('init', id, value), startToken);
        }
        if (token.type === Token.EOF || token.type === Token.Punctuator) {
            throwUnexpected(token);
        } else {
            key = parseObjectPropertyKey();
            expect(':');
            value = parseAssignmentExpression();
            return delegate.markEnd(delegate.createProperty('init', key, value), startToken);
        }
    }

    function parseObjectInitialiser() {
        var properties = [], property, name, key, kind, map = {}, toString = String, startToken;

        startToken = lookahead;

        expect('{');

        while (!match('}')) {
            property = parseObjectProperty();

            if (property.key.type === Syntax.Identifier) {
                name = property.key.name;
            } else {
                name = toString(property.key.value);
            }
            kind = (property.kind === 'init') ? PropertyKind.Data : (property.kind === 'get') ? PropertyKind.Get : PropertyKind.Set;

            key = '$' + name;
            if (Object.prototype.hasOwnProperty.call(map, key)) {
                if (map[key] === PropertyKind.Data) {
                    if (strict && kind === PropertyKind.Data) {
                        throwErrorTolerant({}, Messages.StrictDuplicateProperty);
                    } else if (kind !== PropertyKind.Data) {
                        throwErrorTolerant({}, Messages.AccessorDataProperty);
                    }
                } else {
                    if (kind === PropertyKind.Data) {
                        throwErrorTolerant({}, Messages.AccessorDataProperty);
                    } else if (map[key] & kind) {
                        throwErrorTolerant({}, Messages.AccessorGetSet);
                    }
                }
                map[key] |= kind;
            } else {
                map[key] = kind;
            }

            properties.push(property);

            if (!match('}')) {
                expect(',');
            }
        }

        expect('}');

        return delegate.markEnd(delegate.createObjectExpression(properties), startToken);
    }

    // 11.1.6 The Grouping Operator

    function parseGroupExpression() {
        var expr;

        expect('(');

        expr = parseExpression();

        expect(')');

        return expr;
    }


    // 11.1 Primary Expressions

    function parsePrimaryExpression() {
        var type, token, expr, startToken;

        if (match('(')) {
            return parseGroupExpression();
        }

        if (match('[')) {
            return parseArrayInitialiser();
        }

        if (match('{')) {
            return parseObjectInitialiser();
        }

        type = lookahead.type;
        startToken = lookahead;

        if (type === Token.Identifier) {
            expr =  delegate.createIdentifier(lex().value);
        } else if (type === Token.StringLiteral || type === Token.NumericLiteral) {
            if (strict && lookahead.octal) {
                throwErrorTolerant(lookahead, Messages.StrictOctalLiteral);
            }
            expr = delegate.createLiteral(lex());
        } else if (type === Token.Keyword) {
            if (matchKeyword('function')) {
                return parseFunctionExpression();
            }
            if (matchKeyword('this')) {
                lex();
                expr = delegate.createThisExpression();
            } else {
                throwUnexpected(lex());
            }
        } else if (type === Token.BooleanLiteral) {
            token = lex();
            token.value = (token.value === 'true');
            expr = delegate.createLiteral(token);
        } else if (type === Token.NullLiteral) {
            token = lex();
            token.value = null;
            expr = delegate.createLiteral(token);
        } else if (match('/') || match('/=')) {
            if (typeof extra.tokens !== 'undefined') {
                expr = delegate.createLiteral(collectRegex());
            } else {
                expr = delegate.createLiteral(scanRegExp());
            }
            peek();
        } else {
            throwUnexpected(lex());
        }

        return delegate.markEnd(expr, startToken);
    }

    // 11.2 Left-Hand-Side Expressions

    function parseArguments() {
        var args = [];

        expect('(');

        if (!match(')')) {
            while (index < length) {
                args.push(parseAssignmentExpression());
                if (match(')')) {
                    break;
                }
                expect(',');
            }
        }

        expect(')');

        return args;
    }

    function parseNonComputedProperty() {
        var token, startToken;

        startToken = lookahead;
        token = lex();

        if (!isIdentifierName(token)) {
            throwUnexpected(token);
        }

        return delegate.markEnd(delegate.createIdentifier(token.value), startToken);
    }

    function parseNonComputedMember() {
        expect('.');

        return parseNonComputedProperty();
    }

    function parseComputedMember() {
        var expr;

        expect('[');

        expr = parseExpression();

        expect(']');

        return expr;
    }

    function parseNewExpression() {
        var callee, args, startToken;

        startToken = lookahead;
        expectKeyword('new');
        callee = parseLeftHandSideExpression();
        args = match('(') ? parseArguments() : [];

        return delegate.markEnd(delegate.createNewExpression(callee, args), startToken);
    }

    function parseLeftHandSideExpressionAllowCall() {
        var previousAllowIn, expr, args, property, startToken;

        startToken = lookahead;

        previousAllowIn = state.allowIn;
        state.allowIn = true;
        expr = matchKeyword('new') ? parseNewExpression() : parsePrimaryExpression();
        state.allowIn = previousAllowIn;

        for (;;) {
            if (match('.')) {
                property = parseNonComputedMember();
                expr = delegate.createMemberExpression('.', expr, property);
            } else if (match('(')) {
                args = parseArguments();
                expr = delegate.createCallExpression(expr, args);
            } else if (match('[')) {
                property = parseComputedMember();
                expr = delegate.createMemberExpression('[', expr, property);
            } else {
                break;
            }
            delegate.markEnd(expr, startToken);
        }

        return expr;
    }

    function parseLeftHandSideExpression() {
        var previousAllowIn, expr, property, startToken;

        startToken = lookahead;

        previousAllowIn = state.allowIn;
        expr = matchKeyword('new') ? parseNewExpression() : parsePrimaryExpression();
        state.allowIn = previousAllowIn;

        while (match('.') || match('[')) {
            if (match('[')) {
                property = parseComputedMember();
                expr = delegate.createMemberExpression('[', expr, property);
            } else {
                property = parseNonComputedMember();
                expr = delegate.createMemberExpression('.', expr, property);
            }
            delegate.markEnd(expr, startToken);
        }

        return expr;
    }

    // 11.3 Postfix Expressions

    function parsePostfixExpression() {
        var expr, token, startToken = lookahead;

        expr = parseLeftHandSideExpressionAllowCall();

        if (lookahead.type === Token.Punctuator) {
            if ((match('++') || match('--')) && !peekLineTerminator()) {
                // 11.3.1, 11.3.2
                if (strict && expr.type === Syntax.Identifier && isRestrictedWord(expr.name)) {
                    throwErrorTolerant({}, Messages.StrictLHSPostfix);
                }

                if (!isLeftHandSide(expr)) {
                    throwErrorTolerant({}, Messages.InvalidLHSInAssignment);
                }

                token = lex();
                expr = delegate.markEnd(delegate.createPostfixExpression(token.value, expr), startToken);
            }
        }

        return expr;
    }

    // 11.4 Unary Operators

    function parseUnaryExpression() {
        var token, expr, startToken;

        if (lookahead.type !== Token.Punctuator && lookahead.type !== Token.Keyword) {
            expr = parsePostfixExpression();
        } else if (match('++') || match('--')) {
            startToken = lookahead;
            token = lex();
            expr = parseUnaryExpression();
            // 11.4.4, 11.4.5
            if (strict && expr.type === Syntax.Identifier && isRestrictedWord(expr.name)) {
                throwErrorTolerant({}, Messages.StrictLHSPrefix);
            }

            if (!isLeftHandSide(expr)) {
                throwErrorTolerant({}, Messages.InvalidLHSInAssignment);
            }

            expr = delegate.createUnaryExpression(token.value, expr);
            expr = delegate.markEnd(expr, startToken);
        } else if (match('+') || match('-') || match('~') || match('!')) {
            startToken = lookahead;
            token = lex();
            expr = parseUnaryExpression();
            expr = delegate.createUnaryExpression(token.value, expr);
            expr = delegate.markEnd(expr, startToken);
        } else if (matchKeyword('delete') || matchKeyword('void') || matchKeyword('typeof')) {
            startToken = lookahead;
            token = lex();
            expr = parseUnaryExpression();
            expr = delegate.createUnaryExpression(token.value, expr);
            expr = delegate.markEnd(expr, startToken);
            if (strict && expr.operator === 'delete' && expr.argument.type === Syntax.Identifier) {
                throwErrorTolerant({}, Messages.StrictDelete);
            }
        } else {
            expr = parsePostfixExpression();
        }

        return expr;
    }

    function binaryPrecedence(token, allowIn) {
        var prec = 0;

        if (token.type !== Token.Punctuator && token.type !== Token.Keyword) {
            return 0;
        }

        switch (token.value) {
        case '||':
            prec = 1;
            break;

        case '&&':
            prec = 2;
            break;

        case '|':
            prec = 3;
            break;

        case '^':
            prec = 4;
            break;

        case '&':
            prec = 5;
            break;

        case '==':
        case '!=':
        case '===':
        case '!==':
            prec = 6;
            break;

        case '<':
        case '>':
        case '<=':
        case '>=':
        case 'instanceof':
            prec = 7;
            break;

        case 'in':
            prec = allowIn ? 7 : 0;
            break;

        case '<<':
        case '>>':
        case '>>>':
            prec = 8;
            break;

        case '+':
        case '-':
            prec = 9;
            break;

        case '*':
        case '/':
        case '%':
            prec = 11;
            break;

        default:
            break;
        }

        return prec;
    }

    // 11.5 Multiplicative Operators
    // 11.6 Additive Operators
    // 11.7 Bitwise Shift Operators
    // 11.8 Relational Operators
    // 11.9 Equality Operators
    // 11.10 Binary Bitwise Operators
    // 11.11 Binary Logical Operators

    function parseBinaryExpression() {
        var marker, markers, expr, token, prec, stack, right, operator, left, i;

        marker = lookahead;
        left = parseUnaryExpression();

        token = lookahead;
        prec = binaryPrecedence(token, state.allowIn);
        if (prec === 0) {
            return left;
        }
        token.prec = prec;
        lex();

        markers = [marker, lookahead];
        right = parseUnaryExpression();

        stack = [left, token, right];

        while ((prec = binaryPrecedence(lookahead, state.allowIn)) > 0) {

            // Reduce: make a binary expression from the three topmost entries.
            while ((stack.length > 2) && (prec <= stack[stack.length - 2].prec)) {
                right = stack.pop();
                operator = stack.pop().value;
                left = stack.pop();
                expr = delegate.createBinaryExpression(operator, left, right);
                markers.pop();
                marker = markers[markers.length - 1];
                delegate.markEnd(expr, marker);
                stack.push(expr);
            }

            // Shift.
            token = lex();
            token.prec = prec;
            stack.push(token);
            markers.push(lookahead);
            expr = parseUnaryExpression();
            stack.push(expr);
        }

        // Final reduce to clean-up the stack.
        i = stack.length - 1;
        expr = stack[i];
        markers.pop();
        while (i > 1) {
            expr = delegate.createBinaryExpression(stack[i - 1].value, stack[i - 2], expr);
            i -= 2;
            marker = markers.pop();
            delegate.markEnd(expr, marker);
        }

        return expr;
    }


    // 11.12 Conditional Operator

    function parseConditionalExpression() {
        var expr, previousAllowIn, consequent, alternate, startToken;

        startToken = lookahead;

        expr = parseBinaryExpression();

        if (match('?')) {
            lex();
            previousAllowIn = state.allowIn;
            state.allowIn = true;
            consequent = parseAssignmentExpression();
            state.allowIn = previousAllowIn;
            expect(':');
            alternate = parseAssignmentExpression();

            expr = delegate.createConditionalExpression(expr, consequent, alternate);
            delegate.markEnd(expr, startToken);
        }

        return expr;
    }

    // 11.13 Assignment Operators

    function parseAssignmentExpression() {
        var token, left, right, node, startToken;

        token = lookahead;
        startToken = lookahead;

        node = left = parseConditionalExpression();

        if (matchAssign()) {
            // LeftHandSideExpression
            if (!isLeftHandSide(left)) {
                throwErrorTolerant({}, Messages.InvalidLHSInAssignment);
            }

            // 11.13.1
            if (strict && left.type === Syntax.Identifier && isRestrictedWord(left.name)) {
                throwErrorTolerant(token, Messages.StrictLHSAssignment);
            }

            token = lex();
            right = parseAssignmentExpression();
            node = delegate.markEnd(delegate.createAssignmentExpression(token.value, left, right), startToken);
        }

        return node;
    }

    // 11.14 Comma Operator

    function parseExpression() {
        var expr, startToken = lookahead;

        expr = parseAssignmentExpression();

        if (match(',')) {
            expr = delegate.createSequenceExpression([ expr ]);

            while (index < length) {
                if (!match(',')) {
                    break;
                }
                lex();
                expr.expressions.push(parseAssignmentExpression());
            }

            delegate.markEnd(expr, startToken);
        }

        return expr;
    }

    // 12.1 Block

    function parseStatementList() {
        var list = [],
            statement;

        while (index < length) {
            if (match('}')) {
                break;
            }
            statement = parseSourceElement();
            if (typeof statement === 'undefined') {
                break;
            }
            list.push(statement);
        }

        return list;
    }

    function parseBlock() {
        var block, startToken;

        startToken = lookahead;
        expect('{');

        block = parseStatementList();

        expect('}');

        return delegate.markEnd(delegate.createBlockStatement(block), startToken);
    }

    // 12.2 Variable Statement

    function parseVariableIdentifier() {
        var token, startToken;

        startToken = lookahead;
        token = lex();

        if (token.type !== Token.Identifier) {
            throwUnexpected(token);
        }

        return delegate.markEnd(delegate.createIdentifier(token.value), startToken);
    }

    function parseVariableDeclaration(kind) {
        var init = null, id, startToken;

        startToken = lookahead;
        id = parseVariableIdentifier();

        // 12.2.1
        if (strict && isRestrictedWord(id.name)) {
            throwErrorTolerant({}, Messages.StrictVarName);
        }

        if (kind === 'const') {
            expect('=');
            init = parseAssignmentExpression();
        } else if (match('=')) {
            lex();
            init = parseAssignmentExpression();
        }

        return delegate.markEnd(delegate.createVariableDeclarator(id, init), startToken);
    }

    function parseVariableDeclarationList(kind) {
        var list = [];

        do {
            list.push(parseVariableDeclaration(kind));
            if (!match(',')) {
                break;
            }
            lex();
        } while (index < length);

        return list;
    }

    function parseVariableStatement() {
        var declarations;

        expectKeyword('var');

        declarations = parseVariableDeclarationList();

        consumeSemicolon();

        return delegate.createVariableDeclaration(declarations, 'var');
    }

    // kind may be `const` or `let`
    // Both are experimental and not in the specification yet.
    // see http://wiki.ecmascript.org/doku.php?id=harmony:const
    // and http://wiki.ecmascript.org/doku.php?id=harmony:let
    function parseConstLetDeclaration(kind) {
        var declarations, startToken;

        startToken = lookahead;

        expectKeyword(kind);

        declarations = parseVariableDeclarationList(kind);

        consumeSemicolon();

        return delegate.markEnd(delegate.createVariableDeclaration(declarations, kind), startToken);
    }

    // 12.3 Empty Statement

    function parseEmptyStatement() {
        expect(';');
        return delegate.createEmptyStatement();
    }

    // 12.4 Expression Statement

    function parseExpressionStatement() {
        var expr = parseExpression();
        consumeSemicolon();
        return delegate.createExpressionStatement(expr);
    }

    // 12.5 If statement

    function parseIfStatement() {
        var test, consequent, alternate;

        expectKeyword('if');

        expect('(');

        test = parseExpression();

        expect(')');

        consequent = parseStatement();

        if (matchKeyword('else')) {
            lex();
            alternate = parseStatement();
        } else {
            alternate = null;
        }

        return delegate.createIfStatement(test, consequent, alternate);
    }

    // 12.6 Iteration Statements

    function parseDoWhileStatement() {
        var body, test, oldInIteration;

        expectKeyword('do');

        oldInIteration = state.inIteration;
        state.inIteration = true;

        body = parseStatement();

        state.inIteration = oldInIteration;

        expectKeyword('while');

        expect('(');

        test = parseExpression();

        expect(')');

        if (match(';')) {
            lex();
        }

        return delegate.createDoWhileStatement(body, test);
    }

    function parseWhileStatement() {
        var test, body, oldInIteration;

        expectKeyword('while');

        expect('(');

        test = parseExpression();

        expect(')');

        oldInIteration = state.inIteration;
        state.inIteration = true;

        body = parseStatement();

        state.inIteration = oldInIteration;

        return delegate.createWhileStatement(test, body);
    }

    function parseForVariableDeclaration() {
        var token, declarations, startToken;

        startToken = lookahead;
        token = lex();
        declarations = parseVariableDeclarationList();

        return delegate.markEnd(delegate.createVariableDeclaration(declarations, token.value), startToken);
    }

    function parseForStatement() {
        var init, test, update, left, right, body, oldInIteration;

        init = test = update = null;

        expectKeyword('for');

        expect('(');

        if (match(';')) {
            lex();
        } else {
            if (matchKeyword('var') || matchKeyword('let')) {
                state.allowIn = false;
                init = parseForVariableDeclaration();
                state.allowIn = true;

                if (init.declarations.length === 1 && matchKeyword('in')) {
                    lex();
                    left = init;
                    right = parseExpression();
                    init = null;
                }
            } else {
                state.allowIn = false;
                init = parseExpression();
                state.allowIn = true;

                if (matchKeyword('in')) {
                    // LeftHandSideExpression
                    if (!isLeftHandSide(init)) {
                        throwErrorTolerant({}, Messages.InvalidLHSInForIn);
                    }

                    lex();
                    left = init;
                    right = parseExpression();
                    init = null;
                }
            }

            if (typeof left === 'undefined') {
                expect(';');
            }
        }

        if (typeof left === 'undefined') {

            if (!match(';')) {
                test = parseExpression();
            }
            expect(';');

            if (!match(')')) {
                update = parseExpression();
            }
        }

        expect(')');

        oldInIteration = state.inIteration;
        state.inIteration = true;

        body = parseStatement();

        state.inIteration = oldInIteration;

        return (typeof left === 'undefined') ?
                delegate.createForStatement(init, test, update, body) :
                delegate.createForInStatement(left, right, body);
    }

    // 12.7 The continue statement

    function parseContinueStatement() {
        var label = null, key;

        expectKeyword('continue');

        // Optimize the most common form: 'continue;'.
        if (source.charCodeAt(index) === 0x3B) {
            lex();

            if (!state.inIteration) {
                throwError({}, Messages.IllegalContinue);
            }

            return delegate.createContinueStatement(null);
        }

        if (peekLineTerminator()) {
            if (!state.inIteration) {
                throwError({}, Messages.IllegalContinue);
            }

            return delegate.createContinueStatement(null);
        }

        if (lookahead.type === Token.Identifier) {
            label = parseVariableIdentifier();

            key = '$' + label.name;
            if (!Object.prototype.hasOwnProperty.call(state.labelSet, key)) {
                throwError({}, Messages.UnknownLabel, label.name);
            }
        }

        consumeSemicolon();

        if (label === null && !state.inIteration) {
            throwError({}, Messages.IllegalContinue);
        }

        return delegate.createContinueStatement(label);
    }

    // 12.8 The break statement

    function parseBreakStatement() {
        var label = null, key;

        expectKeyword('break');

        // Catch the very common case first: immediately a semicolon (U+003B).
        if (source.charCodeAt(index) === 0x3B) {
            lex();

            if (!(state.inIteration || state.inSwitch)) {
                throwError({}, Messages.IllegalBreak);
            }

            return delegate.createBreakStatement(null);
        }

        if (peekLineTerminator()) {
            if (!(state.inIteration || state.inSwitch)) {
                throwError({}, Messages.IllegalBreak);
            }

            return delegate.createBreakStatement(null);
        }

        if (lookahead.type === Token.Identifier) {
            label = parseVariableIdentifier();

            key = '$' + label.name;
            if (!Object.prototype.hasOwnProperty.call(state.labelSet, key)) {
                throwError({}, Messages.UnknownLabel, label.name);
            }
        }

        consumeSemicolon();

        if (label === null && !(state.inIteration || state.inSwitch)) {
            throwError({}, Messages.IllegalBreak);
        }

        return delegate.createBreakStatement(label);
    }

    // 12.9 The return statement

    function parseReturnStatement() {
        var argument = null;

        expectKeyword('return');

        if (!state.inFunctionBody) {
            throwErrorTolerant({}, Messages.IllegalReturn);
        }

        // 'return' followed by a space and an identifier is very common.
        if (source.charCodeAt(index) === 0x20) {
            if (isIdentifierStart(source.charCodeAt(index + 1))) {
                argument = parseExpression();
                consumeSemicolon();
                return delegate.createReturnStatement(argument);
            }
        }

        if (peekLineTerminator()) {
            return delegate.createReturnStatement(null);
        }

        if (!match(';')) {
            if (!match('}') && lookahead.type !== Token.EOF) {
                argument = parseExpression();
            }
        }

        consumeSemicolon();

        return delegate.createReturnStatement(argument);
    }

    // 12.10 The with statement

    function parseWithStatement() {
        var object, body;

        if (strict) {
            // TODO(ikarienator): Should we update the test cases instead?
            skipComment();
            throwErrorTolerant({}, Messages.StrictModeWith);
        }

        expectKeyword('with');

        expect('(');

        object = parseExpression();

        expect(')');

        body = parseStatement();

        return delegate.createWithStatement(object, body);
    }

    // 12.10 The swith statement

    function parseSwitchCase() {
        var test, consequent = [], statement, startToken;

        startToken = lookahead;
        if (matchKeyword('default')) {
            lex();
            test = null;
        } else {
            expectKeyword('case');
            test = parseExpression();
        }
        expect(':');

        while (index < length) {
            if (match('}') || matchKeyword('default') || matchKeyword('case')) {
                break;
            }
            statement = parseStatement();
            consequent.push(statement);
        }

        return delegate.markEnd(delegate.createSwitchCase(test, consequent), startToken);
    }

    function parseSwitchStatement() {
        var discriminant, cases, clause, oldInSwitch, defaultFound;

        expectKeyword('switch');

        expect('(');

        discriminant = parseExpression();

        expect(')');

        expect('{');

        cases = [];

        if (match('}')) {
            lex();
            return delegate.createSwitchStatement(discriminant, cases);
        }

        oldInSwitch = state.inSwitch;
        state.inSwitch = true;
        defaultFound = false;

        while (index < length) {
            if (match('}')) {
                break;
            }
            clause = parseSwitchCase();
            if (clause.test === null) {
                if (defaultFound) {
                    throwError({}, Messages.MultipleDefaultsInSwitch);
                }
                defaultFound = true;
            }
            cases.push(clause);
        }

        state.inSwitch = oldInSwitch;

        expect('}');

        return delegate.createSwitchStatement(discriminant, cases);
    }

    // 12.13 The throw statement

    function parseThrowStatement() {
        var argument;

        expectKeyword('throw');

        if (peekLineTerminator()) {
            throwError({}, Messages.NewlineAfterThrow);
        }

        argument = parseExpression();

        consumeSemicolon();

        return delegate.createThrowStatement(argument);
    }

    // 12.14 The try statement

    function parseCatchClause() {
        var param, body, startToken;

        startToken = lookahead;
        expectKeyword('catch');

        expect('(');
        if (match(')')) {
            throwUnexpected(lookahead);
        }

        param = parseVariableIdentifier();
        // 12.14.1
        if (strict && isRestrictedWord(param.name)) {
            throwErrorTolerant({}, Messages.StrictCatchVariable);
        }

        expect(')');
        body = parseBlock();
        return delegate.markEnd(delegate.createCatchClause(param, body), startToken);
    }

    function parseTryStatement() {
        var block, handlers = [], finalizer = null;

        expectKeyword('try');

        block = parseBlock();

        if (matchKeyword('catch')) {
            handlers.push(parseCatchClause());
        }

        if (matchKeyword('finally')) {
            lex();
            finalizer = parseBlock();
        }

        if (handlers.length === 0 && !finalizer) {
            throwError({}, Messages.NoCatchOrFinally);
        }

        return delegate.createTryStatement(block, [], handlers, finalizer);
    }

    // 12.15 The debugger statement

    function parseDebuggerStatement() {
        expectKeyword('debugger');

        consumeSemicolon();

        return delegate.createDebuggerStatement();
    }

    // 12 Statements

    function parseStatement() {
        var type = lookahead.type,
            expr,
            labeledBody,
            key,
            startToken;

        if (type === Token.EOF) {
            throwUnexpected(lookahead);
        }

        if (type === Token.Punctuator && lookahead.value === '{') {
            return parseBlock();
        }

        startToken = lookahead;

        if (type === Token.Punctuator) {
            switch (lookahead.value) {
            case ';':
                return delegate.markEnd(parseEmptyStatement(), startToken);
            case '(':
                return delegate.markEnd(parseExpressionStatement(), startToken);
            default:
                break;
            }
        }

        if (type === Token.Keyword) {
            switch (lookahead.value) {
            case 'break':
                return delegate.markEnd(parseBreakStatement(), startToken);
            case 'continue':
                return delegate.markEnd(parseContinueStatement(), startToken);
            case 'debugger':
                return delegate.markEnd(parseDebuggerStatement(), startToken);
            case 'do':
                return delegate.markEnd(parseDoWhileStatement(), startToken);
            case 'for':
                return delegate.markEnd(parseForStatement(), startToken);
            case 'function':
                return delegate.markEnd(parseFunctionDeclaration(), startToken);
            case 'if':
                return delegate.markEnd(parseIfStatement(), startToken);
            case 'return':
                return delegate.markEnd(parseReturnStatement(), startToken);
            case 'switch':
                return delegate.markEnd(parseSwitchStatement(), startToken);
            case 'throw':
                return delegate.markEnd(parseThrowStatement(), startToken);
            case 'try':
                return delegate.markEnd(parseTryStatement(), startToken);
            case 'var':
                return delegate.markEnd(parseVariableStatement(), startToken);
            case 'while':
                return delegate.markEnd(parseWhileStatement(), startToken);
            case 'with':
                return delegate.markEnd(parseWithStatement(), startToken);
            default:
                break;
            }
        }

        expr = parseExpression();

        // 12.12 Labelled Statements
        if ((expr.type === Syntax.Identifier) && match(':')) {
            lex();

            key = '$' + expr.name;
            if (Object.prototype.hasOwnProperty.call(state.labelSet, key)) {
                throwError({}, Messages.Redeclaration, 'Label', expr.name);
            }

            state.labelSet[key] = true;
            labeledBody = parseStatement();
            delete state.labelSet[key];
            return delegate.markEnd(delegate.createLabeledStatement(expr, labeledBody), startToken);
        }

        consumeSemicolon();

        return delegate.markEnd(delegate.createExpressionStatement(expr), startToken);
    }

    // 13 Function Definition

    function parseFunctionSourceElements() {
        var sourceElement, sourceElements = [], token, directive, firstRestricted,
            oldLabelSet, oldInIteration, oldInSwitch, oldInFunctionBody, startToken;

        startToken = lookahead;
        expect('{');

        while (index < length) {
            if (lookahead.type !== Token.StringLiteral) {
                break;
            }
            token = lookahead;

            sourceElement = parseSourceElement();
            sourceElements.push(sourceElement);
            if (sourceElement.expression.type !== Syntax.Literal) {
                // this is not directive
                break;
            }
            directive = source.slice(token.start + 1, token.end - 1);
            if (directive === 'use strict') {
                strict = true;
                if (firstRestricted) {
                    throwErrorTolerant(firstRestricted, Messages.StrictOctalLiteral);
                }
            } else {
                if (!firstRestricted && token.octal) {
                    firstRestricted = token;
                }
            }
        }

        oldLabelSet = state.labelSet;
        oldInIteration = state.inIteration;
        oldInSwitch = state.inSwitch;
        oldInFunctionBody = state.inFunctionBody;

        state.labelSet = {};
        state.inIteration = false;
        state.inSwitch = false;
        state.inFunctionBody = true;

        while (index < length) {
            if (match('}')) {
                break;
            }
            sourceElement = parseSourceElement();
            if (typeof sourceElement === 'undefined') {
                break;
            }
            sourceElements.push(sourceElement);
        }

        expect('}');

        state.labelSet = oldLabelSet;
        state.inIteration = oldInIteration;
        state.inSwitch = oldInSwitch;
        state.inFunctionBody = oldInFunctionBody;

        return delegate.markEnd(delegate.createBlockStatement(sourceElements), startToken);
    }

    function parseParams(firstRestricted) {
        var param, params = [], token, stricted, paramSet, key, message;
        expect('(');

        if (!match(')')) {
            paramSet = {};
            while (index < length) {
                token = lookahead;
                param = parseVariableIdentifier();
                key = '$' + token.value;
                if (strict) {
                    if (isRestrictedWord(token.value)) {
                        stricted = token;
                        message = Messages.StrictParamName;
                    }
                    if (Object.prototype.hasOwnProperty.call(paramSet, key)) {
                        stricted = token;
                        message = Messages.StrictParamDupe;
                    }
                } else if (!firstRestricted) {
                    if (isRestrictedWord(token.value)) {
                        firstRestricted = token;
                        message = Messages.StrictParamName;
                    } else if (isStrictModeReservedWord(token.value)) {
                        firstRestricted = token;
                        message = Messages.StrictReservedWord;
                    } else if (Object.prototype.hasOwnProperty.call(paramSet, key)) {
                        firstRestricted = token;
                        message = Messages.StrictParamDupe;
                    }
                }
                params.push(param);
                paramSet[key] = true;
                if (match(')')) {
                    break;
                }
                expect(',');
            }
        }

        expect(')');

        return {
            params: params,
            stricted: stricted,
            firstRestricted: firstRestricted,
            message: message
        };
    }

    function parseFunctionDeclaration() {
        var id, params = [], body, token, stricted, tmp, firstRestricted, message, previousStrict, startToken;

        startToken = lookahead;

        expectKeyword('function');
        token = lookahead;
        id = parseVariableIdentifier();
        if (strict) {
            if (isRestrictedWord(token.value)) {
                throwErrorTolerant(token, Messages.StrictFunctionName);
            }
        } else {
            if (isRestrictedWord(token.value)) {
                firstRestricted = token;
                message = Messages.StrictFunctionName;
            } else if (isStrictModeReservedWord(token.value)) {
                firstRestricted = token;
                message = Messages.StrictReservedWord;
            }
        }

        tmp = parseParams(firstRestricted);
        params = tmp.params;
        stricted = tmp.stricted;
        firstRestricted = tmp.firstRestricted;
        if (tmp.message) {
            message = tmp.message;
        }

        previousStrict = strict;
        body = parseFunctionSourceElements();
        if (strict && firstRestricted) {
            throwError(firstRestricted, message);
        }
        if (strict && stricted) {
            throwErrorTolerant(stricted, message);
        }
        strict = previousStrict;

        return delegate.markEnd(delegate.createFunctionDeclaration(id, params, [], body), startToken);
    }

    function parseFunctionExpression() {
        var token, id = null, stricted, firstRestricted, message, tmp, params = [], body, previousStrict, startToken;

        startToken = lookahead;
        expectKeyword('function');

        if (!match('(')) {
            token = lookahead;
            id = parseVariableIdentifier();
            if (strict) {
                if (isRestrictedWord(token.value)) {
                    throwErrorTolerant(token, Messages.StrictFunctionName);
                }
            } else {
                if (isRestrictedWord(token.value)) {
                    firstRestricted = token;
                    message = Messages.StrictFunctionName;
                } else if (isStrictModeReservedWord(token.value)) {
                    firstRestricted = token;
                    message = Messages.StrictReservedWord;
                }
            }
        }

        tmp = parseParams(firstRestricted);
        params = tmp.params;
        stricted = tmp.stricted;
        firstRestricted = tmp.firstRestricted;
        if (tmp.message) {
            message = tmp.message;
        }

        previousStrict = strict;
        body = parseFunctionSourceElements();
        if (strict && firstRestricted) {
            throwError(firstRestricted, message);
        }
        if (strict && stricted) {
            throwErrorTolerant(stricted, message);
        }
        strict = previousStrict;

        return delegate.markEnd(delegate.createFunctionExpression(id, params, [], body), startToken);
    }

    // 14 Program

    function parseSourceElement() {
        if (lookahead.type === Token.Keyword) {
            switch (lookahead.value) {
            case 'const':
            case 'let':
                return parseConstLetDeclaration(lookahead.value);
            case 'function':
                return parseFunctionDeclaration();
            default:
                return parseStatement();
            }
        }

        if (lookahead.type !== Token.EOF) {
            return parseStatement();
        }
    }

    function parseSourceElements() {
        var sourceElement, sourceElements = [], token, directive, firstRestricted;

        while (index < length) {
            token = lookahead;
            if (token.type !== Token.StringLiteral) {
                break;
            }

            sourceElement = parseSourceElement();
            sourceElements.push(sourceElement);
            if (sourceElement.expression.type !== Syntax.Literal) {
                // this is not directive
                break;
            }
            directive = source.slice(token.start + 1, token.end - 1);
            if (directive === 'use strict') {
                strict = true;
                if (firstRestricted) {
                    throwErrorTolerant(firstRestricted, Messages.StrictOctalLiteral);
                }
            } else {
                if (!firstRestricted && token.octal) {
                    firstRestricted = token;
                }
            }
        }

        while (index < length) {
            sourceElement = parseSourceElement();
            /* istanbul ignore if */
            if (typeof sourceElement === 'undefined') {
                break;
            }
            sourceElements.push(sourceElement);
        }
        return sourceElements;
    }

    function parseProgram() {
        var body, startToken;

        skipComment();
        peek();
        startToken = lookahead;
        strict = false;

        body = parseSourceElements();
        return delegate.markEnd(delegate.createProgram(body), startToken);
    }

    function filterTokenLocation() {
        var i, entry, token, tokens = [];

        for (i = 0; i < extra.tokens.length; ++i) {
            entry = extra.tokens[i];
            token = {
                type: entry.type,
                value: entry.value
            };
            if (extra.range) {
                token.range = entry.range;
            }
            if (extra.loc) {
                token.loc = entry.loc;
            }
            tokens.push(token);
        }

        extra.tokens = tokens;
    }

    function tokenize(code, options) {
        var toString,
            token,
            tokens;

        toString = String;
        if (typeof code !== 'string' && !(code instanceof String)) {
            code = toString(code);
        }

        delegate = SyntaxTreeDelegate;
        source = code;
        index = 0;
        lineNumber = (source.length > 0) ? 1 : 0;
        lineStart = 0;
        length = source.length;
        lookahead = null;
        state = {
            allowIn: true,
            labelSet: {},
            inFunctionBody: false,
            inIteration: false,
            inSwitch: false,
            lastCommentStart: -1
        };

        extra = {};

        // Options matching.
        options = options || {};

        // Of course we collect tokens here.
        options.tokens = true;
        extra.tokens = [];
        extra.tokenize = true;
        // The following two fields are necessary to compute the Regex tokens.
        extra.openParenToken = -1;
        extra.openCurlyToken = -1;

        extra.range = (typeof options.range === 'boolean') && options.range;
        extra.loc = (typeof options.loc === 'boolean') && options.loc;

        if (typeof options.comment === 'boolean' && options.comment) {
            extra.comments = [];
        }
        if (typeof options.tolerant === 'boolean' && options.tolerant) {
            extra.errors = [];
        }

        try {
            peek();
            if (lookahead.type === Token.EOF) {
                return extra.tokens;
            }

            token = lex();
            while (lookahead.type !== Token.EOF) {
                try {
                    token = lex();
                } catch (lexError) {
                    token = lookahead;
                    if (extra.errors) {
                        extra.errors.push(lexError);
                        // We have to break on the first error
                        // to avoid infinite loops.
                        break;
                    } else {
                        throw lexError;
                    }
                }
            }

            filterTokenLocation();
            tokens = extra.tokens;
            if (typeof extra.comments !== 'undefined') {
                tokens.comments = extra.comments;
            }
            if (typeof extra.errors !== 'undefined') {
                tokens.errors = extra.errors;
            }
        } catch (e) {
            throw e;
        } finally {
            extra = {};
        }
        return tokens;
    }

    function parse(code, options) {
        var program, toString;

        toString = String;
        if (typeof code !== 'string' && !(code instanceof String)) {
            code = toString(code);
        }

        delegate = SyntaxTreeDelegate;
        source = code;
        index = 0;
        lineNumber = (source.length > 0) ? 1 : 0;
        lineStart = 0;
        length = source.length;
        lookahead = null;
        state = {
            allowIn: true,
            labelSet: {},
            inFunctionBody: false,
            inIteration: false,
            inSwitch: false,
            lastCommentStart: -1
        };

        extra = {};
        if (typeof options !== 'undefined') {
            extra.range = (typeof options.range === 'boolean') && options.range;
            extra.loc = (typeof options.loc === 'boolean') && options.loc;
            extra.attachComment = (typeof options.attachComment === 'boolean') && options.attachComment;

            if (extra.loc && options.source !== null && options.source !== undefined) {
                extra.source = toString(options.source);
            }

            if (typeof options.tokens === 'boolean' && options.tokens) {
                extra.tokens = [];
            }
            if (typeof options.comment === 'boolean' && options.comment) {
                extra.comments = [];
            }
            if (typeof options.tolerant === 'boolean' && options.tolerant) {
                extra.errors = [];
            }
            if (extra.attachComment) {
                extra.range = true;
                extra.comments = [];
                extra.bottomRightStack = [];
                extra.trailingComments = [];
                extra.leadingComments = [];
            }
        }

        try {
            program = parseProgram();
            if (typeof extra.comments !== 'undefined') {
                program.comments = extra.comments;
            }
            if (typeof extra.tokens !== 'undefined') {
                filterTokenLocation();
                program.tokens = extra.tokens;
            }
            if (typeof extra.errors !== 'undefined') {
                program.errors = extra.errors;
            }
        } catch (e) {
            throw e;
        } finally {
            extra = {};
        }

        return program;
    }

    // Sync with *.json manifests.
    exports.version = '1.2.2';

    exports.tokenize = tokenize;

    exports.parse = parse;

    // Deep copy.
   /* istanbul ignore next */
    exports.Syntax = (function () {
        var name, types = {};

        if (typeof Object.create === 'function') {
            types = Object.create(null);
        }

        for (name in Syntax) {
            if (Syntax.hasOwnProperty(name)) {
                types[name] = Syntax[name];
            }
        }

        if (typeof Object.freeze === 'function') {
            Object.freeze(types);
        }

        return types;
    }());

}));
/* vim: set sw=4 ts=4 et tw=80 : */

},{}],1:[function(require,module,exports){
(function (process){
/* parser generated by jison 0.4.13 */
/*
  Returns a Parser object of the following structure:

  Parser: {
    yy: {}
  }

  Parser.prototype: {
    yy: {},
    trace: function(),
    symbols_: {associative list: name ==> number},
    terminals_: {associative list: number ==> name},
    productions_: [...],
    performAction: function anonymous(yytext, yyleng, yylineno, yy, yystate, $$, _$),
    table: [...],
    defaultActions: {...},
    parseError: function(str, hash),
    parse: function(input),

    lexer: {
        EOF: 1,
        parseError: function(str, hash),
        setInput: function(input),
        input: function(),
        unput: function(str),
        more: function(),
        less: function(n),
        pastInput: function(),
        upcomingInput: function(),
        showPosition: function(),
        test_match: function(regex_match_array, rule_index),
        next: function(),
        lex: function(),
        begin: function(condition),
        popState: function(),
        _currentRules: function(),
        topState: function(),
        pushState: function(condition),

        options: {
            ranges: boolean           (optional: true ==> token location info will include a .range[] member)
            flex: boolean             (optional: true ==> flex-like lexing behaviour where the rules are tested exhaustively to find the longest match)
            backtrack_lexer: boolean  (optional: true ==> lexer regexes are tested in order and for each matching regex the action code is invoked; the lexer terminates the scan when a token is returned by the action code)
        },

        performAction: function(yy, yy_, $avoiding_name_collisions, YY_START),
        rules: [...],
        conditions: {associative list: name ==> set},
    }
  }


  token location info (@$, _$, etc.): {
    first_line: n,
    last_line: n,
    first_column: n,
    last_column: n,
    range: [start_number, end_number]       (where the numbers are indexes into the input string, regular zero-based)
  }


  the parseError function receives a 'hash' object with these members for lexer and parser errors: {
    text:        (matched text)
    token:       (the produced terminal token, if any)
    line:        (yylineno)
  }
  while parser (grammar) errors will also provide these members, i.e. parser errors deliver a superset of attributes: {
    loc:         (yylloc)
    expected:    (string describing the set of expected tokens)
    recoverable: (boolean: TRUE when the parser has a error recovery rule available for this particular error)
  }
*/
var parser = (function(){
var parser = {trace: function trace() { },
yy: {},
symbols_: {"error":2,"JSON_PATH":3,"DOLLAR":4,"PATH_COMPONENTS":5,"LEADING_CHILD_MEMBER_EXPRESSION":6,"PATH_COMPONENT":7,"MEMBER_COMPONENT":8,"SUBSCRIPT_COMPONENT":9,"CHILD_MEMBER_COMPONENT":10,"DESCENDANT_MEMBER_COMPONENT":11,"DOT":12,"MEMBER_EXPRESSION":13,"DOT_DOT":14,"STAR":15,"IDENTIFIER":16,"SCRIPT_EXPRESSION":17,"INTEGER":18,"END":19,"CHILD_SUBSCRIPT_COMPONENT":20,"DESCENDANT_SUBSCRIPT_COMPONENT":21,"[":22,"SUBSCRIPT":23,"]":24,"SUBSCRIPT_EXPRESSION":25,"SUBSCRIPT_EXPRESSION_LIST":26,"SUBSCRIPT_EXPRESSION_LISTABLE":27,",":28,"STRING_LITERAL":29,"ARRAY_SLICE":30,"FILTER_EXPRESSION":31,"QQ_STRING":32,"Q_STRING":33,"$accept":0,"$end":1},
terminals_: {2:"error",4:"DOLLAR",12:"DOT",14:"DOT_DOT",15:"STAR",16:"IDENTIFIER",17:"SCRIPT_EXPRESSION",18:"INTEGER",19:"END",22:"[",24:"]",28:",",30:"ARRAY_SLICE",31:"FILTER_EXPRESSION",32:"QQ_STRING",33:"Q_STRING"},
productions_: [0,[3,1],[3,2],[3,1],[3,2],[5,1],[5,2],[7,1],[7,1],[8,1],[8,1],[10,2],[6,1],[11,2],[13,1],[13,1],[13,1],[13,1],[13,1],[9,1],[9,1],[20,3],[21,4],[23,1],[23,1],[26,1],[26,3],[27,1],[27,1],[27,1],[25,1],[25,1],[25,1],[29,1],[29,1]],
performAction: function anonymous(yytext, yyleng, yylineno, yy, yystate /* action[1] */, $$ /* vstack */, _$ /* lstack */
/**/) {
/* this == yyval */
if (!yy.ast) {
    yy.ast = _ast;
    _ast.initialize();
}

var $0 = $$.length - 1;
switch (yystate) {
case 1:yy.ast.set({ expression: { type: "root", value: $$[$0] } }); yy.ast.unshift(); return yy.ast.yield()
break;
case 2:yy.ast.set({ expression: { type: "root", value: $$[$0-1] } }); yy.ast.unshift(); return yy.ast.yield()
break;
case 3:yy.ast.unshift(); return yy.ast.yield()
break;
case 4:yy.ast.set({ operation: "member", scope: "child", expression: { type: "identifier", value: $$[$0-1] }}); yy.ast.unshift(); return yy.ast.yield()
break;
case 5:
break;
case 6:
break;
case 7:yy.ast.set({ operation: "member" }); yy.ast.push()
break;
case 8:yy.ast.set({ operation: "subscript" }); yy.ast.push() 
break;
case 9:yy.ast.set({ scope: "child" })
break;
case 10:yy.ast.set({ scope: "descendant" })
break;
case 11:
break;
case 12:yy.ast.set({ scope: "child", operation: "member" })
break;
case 13:
break;
case 14:yy.ast.set({ expression: { type: "wildcard", value: $$[$0] } })
break;
case 15:yy.ast.set({ expression: { type: "identifier", value: $$[$0] } })
break;
case 16:yy.ast.set({ expression: { type: "script_expression", value: $$[$0] } })
break;
case 17:yy.ast.set({ expression: { type: "numeric_literal", value: parseInt($$[$0]) } })
break;
case 18:
break;
case 19:yy.ast.set({ scope: "child" })
break;
case 20:yy.ast.set({ scope: "descendant" })
break;
case 21:
break;
case 22:
break;
case 23:
break;
case 24:$$[$0].length > 1? yy.ast.set({ expression: { type: "union", value: $$[$0] } }) : this.$ = $$[$0]
break;
case 25:this.$ = [$$[$0]]
break;
case 26:this.$ = $$[$0-2].concat($$[$0])
break;
case 27:this.$ = { expression: { type: "numeric_literal", value: parseInt($$[$0]) } }; yy.ast.set(this.$)
break;
case 28:this.$ = { expression: { type: "string_literal", value: $$[$0] } }; yy.ast.set(this.$)
break;
case 29:this.$ = { expression: { type: "slice", value: $$[$0] } }; yy.ast.set(this.$)
break;
case 30:this.$ = { expression: { type: "wildcard", value: $$[$0] } }; yy.ast.set(this.$)
break;
case 31:this.$ = { expression: { type: "script_expression", value: $$[$0] } }; yy.ast.set(this.$)
break;
case 32:this.$ = { expression: { type: "filter_expression", value: $$[$0] } }; yy.ast.set(this.$)
break;
case 33:this.$ = $$[$0]
break;
case 34:this.$ = $$[$0]
break;
}
},
table: [{3:1,4:[1,2],6:3,13:4,15:[1,5],16:[1,6],17:[1,7],18:[1,8],19:[1,9]},{1:[3]},{1:[2,1],5:10,7:11,8:12,9:13,10:14,11:15,12:[1,18],14:[1,19],20:16,21:17,22:[1,20]},{1:[2,3],5:21,7:11,8:12,9:13,10:14,11:15,12:[1,18],14:[1,19],20:16,21:17,22:[1,20]},{1:[2,12],12:[2,12],14:[2,12],22:[2,12]},{1:[2,14],12:[2,14],14:[2,14],22:[2,14]},{1:[2,15],12:[2,15],14:[2,15],22:[2,15]},{1:[2,16],12:[2,16],14:[2,16],22:[2,16]},{1:[2,17],12:[2,17],14:[2,17],22:[2,17]},{1:[2,18],12:[2,18],14:[2,18],22:[2,18]},{1:[2,2],7:22,8:12,9:13,10:14,11:15,12:[1,18],14:[1,19],20:16,21:17,22:[1,20]},{1:[2,5],12:[2,5],14:[2,5],22:[2,5]},{1:[2,7],12:[2,7],14:[2,7],22:[2,7]},{1:[2,8],12:[2,8],14:[2,8],22:[2,8]},{1:[2,9],12:[2,9],14:[2,9],22:[2,9]},{1:[2,10],12:[2,10],14:[2,10],22:[2,10]},{1:[2,19],12:[2,19],14:[2,19],22:[2,19]},{1:[2,20],12:[2,20],14:[2,20],22:[2,20]},{13:23,15:[1,5],16:[1,6],17:[1,7],18:[1,8],19:[1,9]},{13:24,15:[1,5],16:[1,6],17:[1,7],18:[1,8],19:[1,9],22:[1,25]},{15:[1,29],17:[1,30],18:[1,33],23:26,25:27,26:28,27:32,29:34,30:[1,35],31:[1,31],32:[1,36],33:[1,37]},{1:[2,4],7:22,8:12,9:13,10:14,11:15,12:[1,18],14:[1,19],20:16,21:17,22:[1,20]},{1:[2,6],12:[2,6],14:[2,6],22:[2,6]},{1:[2,11],12:[2,11],14:[2,11],22:[2,11]},{1:[2,13],12:[2,13],14:[2,13],22:[2,13]},{15:[1,29],17:[1,30],18:[1,33],23:38,25:27,26:28,27:32,29:34,30:[1,35],31:[1,31],32:[1,36],33:[1,37]},{24:[1,39]},{24:[2,23]},{24:[2,24],28:[1,40]},{24:[2,30]},{24:[2,31]},{24:[2,32]},{24:[2,25],28:[2,25]},{24:[2,27],28:[2,27]},{24:[2,28],28:[2,28]},{24:[2,29],28:[2,29]},{24:[2,33],28:[2,33]},{24:[2,34],28:[2,34]},{24:[1,41]},{1:[2,21],12:[2,21],14:[2,21],22:[2,21]},{18:[1,33],27:42,29:34,30:[1,35],32:[1,36],33:[1,37]},{1:[2,22],12:[2,22],14:[2,22],22:[2,22]},{24:[2,26],28:[2,26]}],
defaultActions: {27:[2,23],29:[2,30],30:[2,31],31:[2,32]},
parseError: function parseError(str, hash) {
    if (hash.recoverable) {
        this.trace(str);
    } else {
        throw new Error(str);
    }
},
parse: function parse(input) {
    var self = this, stack = [0], vstack = [null], lstack = [], table = this.table, yytext = '', yylineno = 0, yyleng = 0, recovering = 0, TERROR = 2, EOF = 1;
    var args = lstack.slice.call(arguments, 1);
    this.lexer.setInput(input);
    this.lexer.yy = this.yy;
    this.yy.lexer = this.lexer;
    this.yy.parser = this;
    if (typeof this.lexer.yylloc == 'undefined') {
        this.lexer.yylloc = {};
    }
    var yyloc = this.lexer.yylloc;
    lstack.push(yyloc);
    var ranges = this.lexer.options && this.lexer.options.ranges;
    if (typeof this.yy.parseError === 'function') {
        this.parseError = this.yy.parseError;
    } else {
        this.parseError = Object.getPrototypeOf(this).parseError;
    }
    function popStack(n) {
        stack.length = stack.length - 2 * n;
        vstack.length = vstack.length - n;
        lstack.length = lstack.length - n;
    }
    function lex() {
        var token;
        token = self.lexer.lex() || EOF;
        if (typeof token !== 'number') {
            token = self.symbols_[token] || token;
        }
        return token;
    }
    var symbol, preErrorSymbol, state, action, a, r, yyval = {}, p, len, newState, expected;
    while (true) {
        state = stack[stack.length - 1];
        if (this.defaultActions[state]) {
            action = this.defaultActions[state];
        } else {
            if (symbol === null || typeof symbol == 'undefined') {
                symbol = lex();
            }
            action = table[state] && table[state][symbol];
        }
                    if (typeof action === 'undefined' || !action.length || !action[0]) {
                var errStr = '';
                expected = [];
                for (p in table[state]) {
                    if (this.terminals_[p] && p > TERROR) {
                        expected.push('\'' + this.terminals_[p] + '\'');
                    }
                }
                if (this.lexer.showPosition) {
                    errStr = 'Parse error on line ' + (yylineno + 1) + ':\n' + this.lexer.showPosition() + '\nExpecting ' + expected.join(', ') + ', got \'' + (this.terminals_[symbol] || symbol) + '\'';
                } else {
                    errStr = 'Parse error on line ' + (yylineno + 1) + ': Unexpected ' + (symbol == EOF ? 'end of input' : '\'' + (this.terminals_[symbol] || symbol) + '\'');
                }
                this.parseError(errStr, {
                    text: this.lexer.match,
                    token: this.terminals_[symbol] || symbol,
                    line: this.lexer.yylineno,
                    loc: yyloc,
                    expected: expected
                });
            }
        if (action[0] instanceof Array && action.length > 1) {
            throw new Error('Parse Error: multiple actions possible at state: ' + state + ', token: ' + symbol);
        }
        switch (action[0]) {
        case 1:
            stack.push(symbol);
            vstack.push(this.lexer.yytext);
            lstack.push(this.lexer.yylloc);
            stack.push(action[1]);
            symbol = null;
            if (!preErrorSymbol) {
                yyleng = this.lexer.yyleng;
                yytext = this.lexer.yytext;
                yylineno = this.lexer.yylineno;
                yyloc = this.lexer.yylloc;
                if (recovering > 0) {
                    recovering--;
                }
            } else {
                symbol = preErrorSymbol;
                preErrorSymbol = null;
            }
            break;
        case 2:
            len = this.productions_[action[1]][1];
            yyval.$ = vstack[vstack.length - len];
            yyval._$ = {
                first_line: lstack[lstack.length - (len || 1)].first_line,
                last_line: lstack[lstack.length - 1].last_line,
                first_column: lstack[lstack.length - (len || 1)].first_column,
                last_column: lstack[lstack.length - 1].last_column
            };
            if (ranges) {
                yyval._$.range = [
                    lstack[lstack.length - (len || 1)].range[0],
                    lstack[lstack.length - 1].range[1]
                ];
            }
            r = this.performAction.apply(yyval, [
                yytext,
                yyleng,
                yylineno,
                this.yy,
                action[1],
                vstack,
                lstack
            ].concat(args));
            if (typeof r !== 'undefined') {
                return r;
            }
            if (len) {
                stack = stack.slice(0, -1 * len * 2);
                vstack = vstack.slice(0, -1 * len);
                lstack = lstack.slice(0, -1 * len);
            }
            stack.push(this.productions_[action[1]][0]);
            vstack.push(yyval.$);
            lstack.push(yyval._$);
            newState = table[stack[stack.length - 2]][stack[stack.length - 1]];
            stack.push(newState);
            break;
        case 3:
            return true;
        }
    }
    return true;
}};
var _ast = {

  initialize: function() {
    this._nodes = [];
    this._node = {};
    this._stash = [];
  },

  set: function(props) {
    for (var k in props) this._node[k] = props[k];
    return this._node;
  },

  node: function(obj) {
    if (arguments.length) this._node = obj;
    return this._node;
  },

  push: function() {
    this._nodes.push(this._node);
    this._node = {};
  },

  unshift: function() {
    this._nodes.unshift(this._node);
    this._node = {};
  },

  yield: function() {
    var _nodes = this._nodes;
    this.initialize();
    return _nodes;
  }
};
/* generated by jison-lex 0.2.1 */
var lexer = (function(){
var lexer = {

EOF:1,

parseError:function parseError(str, hash) {
        if (this.yy.parser) {
            this.yy.parser.parseError(str, hash);
        } else {
            throw new Error(str);
        }
    },

// resets the lexer, sets new input
setInput:function (input) {
        this._input = input;
        this._more = this._backtrack = this.done = false;
        this.yylineno = this.yyleng = 0;
        this.yytext = this.matched = this.match = '';
        this.conditionStack = ['INITIAL'];
        this.yylloc = {
            first_line: 1,
            first_column: 0,
            last_line: 1,
            last_column: 0
        };
        if (this.options.ranges) {
            this.yylloc.range = [0,0];
        }
        this.offset = 0;
        return this;
    },

// consumes and returns one char from the input
input:function () {
        var ch = this._input[0];
        this.yytext += ch;
        this.yyleng++;
        this.offset++;
        this.match += ch;
        this.matched += ch;
        var lines = ch.match(/(?:\r\n?|\n).*/g);
        if (lines) {
            this.yylineno++;
            this.yylloc.last_line++;
        } else {
            this.yylloc.last_column++;
        }
        if (this.options.ranges) {
            this.yylloc.range[1]++;
        }

        this._input = this._input.slice(1);
        return ch;
    },

// unshifts one char (or a string) into the input
unput:function (ch) {
        var len = ch.length;
        var lines = ch.split(/(?:\r\n?|\n)/g);

        this._input = ch + this._input;
        this.yytext = this.yytext.substr(0, this.yytext.length - len - 1);
        //this.yyleng -= len;
        this.offset -= len;
        var oldLines = this.match.split(/(?:\r\n?|\n)/g);
        this.match = this.match.substr(0, this.match.length - 1);
        this.matched = this.matched.substr(0, this.matched.length - 1);

        if (lines.length - 1) {
            this.yylineno -= lines.length - 1;
        }
        var r = this.yylloc.range;

        this.yylloc = {
            first_line: this.yylloc.first_line,
            last_line: this.yylineno + 1,
            first_column: this.yylloc.first_column,
            last_column: lines ?
                (lines.length === oldLines.length ? this.yylloc.first_column : 0)
                 + oldLines[oldLines.length - lines.length].length - lines[0].length :
              this.yylloc.first_column - len
        };

        if (this.options.ranges) {
            this.yylloc.range = [r[0], r[0] + this.yyleng - len];
        }
        this.yyleng = this.yytext.length;
        return this;
    },

// When called from action, caches matched text and appends it on next action
more:function () {
        this._more = true;
        return this;
    },

// When called from action, signals the lexer that this rule fails to match the input, so the next matching rule (regex) should be tested instead.
reject:function () {
        if (this.options.backtrack_lexer) {
            this._backtrack = true;
        } else {
            return this.parseError('Lexical error on line ' + (this.yylineno + 1) + '. You can only invoke reject() in the lexer when the lexer is of the backtracking persuasion (options.backtrack_lexer = true).\n' + this.showPosition(), {
                text: "",
                token: null,
                line: this.yylineno
            });

        }
        return this;
    },

// retain first n characters of the match
less:function (n) {
        this.unput(this.match.slice(n));
    },

// displays already matched input, i.e. for error messages
pastInput:function () {
        var past = this.matched.substr(0, this.matched.length - this.match.length);
        return (past.length > 20 ? '...':'') + past.substr(-20).replace(/\n/g, "");
    },

// displays upcoming input, i.e. for error messages
upcomingInput:function () {
        var next = this.match;
        if (next.length < 20) {
            next += this._input.substr(0, 20-next.length);
        }
        return (next.substr(0,20) + (next.length > 20 ? '...' : '')).replace(/\n/g, "");
    },

// displays the character position where the lexing error occurred, i.e. for error messages
showPosition:function () {
        var pre = this.pastInput();
        var c = new Array(pre.length + 1).join("-");
        return pre + this.upcomingInput() + "\n" + c + "^";
    },

// test the lexed token: return FALSE when not a match, otherwise return token
test_match:function (match, indexed_rule) {
        var token,
            lines,
            backup;

        if (this.options.backtrack_lexer) {
            // save context
            backup = {
                yylineno: this.yylineno,
                yylloc: {
                    first_line: this.yylloc.first_line,
                    last_line: this.last_line,
                    first_column: this.yylloc.first_column,
                    last_column: this.yylloc.last_column
                },
                yytext: this.yytext,
                match: this.match,
                matches: this.matches,
                matched: this.matched,
                yyleng: this.yyleng,
                offset: this.offset,
                _more: this._more,
                _input: this._input,
                yy: this.yy,
                conditionStack: this.conditionStack.slice(0),
                done: this.done
            };
            if (this.options.ranges) {
                backup.yylloc.range = this.yylloc.range.slice(0);
            }
        }

        lines = match[0].match(/(?:\r\n?|\n).*/g);
        if (lines) {
            this.yylineno += lines.length;
        }
        this.yylloc = {
            first_line: this.yylloc.last_line,
            last_line: this.yylineno + 1,
            first_column: this.yylloc.last_column,
            last_column: lines ?
                         lines[lines.length - 1].length - lines[lines.length - 1].match(/\r?\n?/)[0].length :
                         this.yylloc.last_column + match[0].length
        };
        this.yytext += match[0];
        this.match += match[0];
        this.matches = match;
        this.yyleng = this.yytext.length;
        if (this.options.ranges) {
            this.yylloc.range = [this.offset, this.offset += this.yyleng];
        }
        this._more = false;
        this._backtrack = false;
        this._input = this._input.slice(match[0].length);
        this.matched += match[0];
        token = this.performAction.call(this, this.yy, this, indexed_rule, this.conditionStack[this.conditionStack.length - 1]);
        if (this.done && this._input) {
            this.done = false;
        }
        if (token) {
            return token;
        } else if (this._backtrack) {
            // recover context
            for (var k in backup) {
                this[k] = backup[k];
            }
            return false; // rule action called reject() implying the next rule should be tested instead.
        }
        return false;
    },

// return next match in input
next:function () {
        if (this.done) {
            return this.EOF;
        }
        if (!this._input) {
            this.done = true;
        }

        var token,
            match,
            tempMatch,
            index;
        if (!this._more) {
            this.yytext = '';
            this.match = '';
        }
        var rules = this._currentRules();
        for (var i = 0; i < rules.length; i++) {
            tempMatch = this._input.match(this.rules[rules[i]]);
            if (tempMatch && (!match || tempMatch[0].length > match[0].length)) {
                match = tempMatch;
                index = i;
                if (this.options.backtrack_lexer) {
                    token = this.test_match(tempMatch, rules[i]);
                    if (token !== false) {
                        return token;
                    } else if (this._backtrack) {
                        match = false;
                        continue; // rule action called reject() implying a rule MISmatch.
                    } else {
                        // else: this is a lexer rule which consumes input without producing a token (e.g. whitespace)
                        return false;
                    }
                } else if (!this.options.flex) {
                    break;
                }
            }
        }
        if (match) {
            token = this.test_match(match, rules[index]);
            if (token !== false) {
                return token;
            }
            // else: this is a lexer rule which consumes input without producing a token (e.g. whitespace)
            return false;
        }
        if (this._input === "") {
            return this.EOF;
        } else {
            return this.parseError('Lexical error on line ' + (this.yylineno + 1) + '. Unrecognized text.\n' + this.showPosition(), {
                text: "",
                token: null,
                line: this.yylineno
            });
        }
    },

// return next match that has a token
lex:function lex() {
        var r = this.next();
        if (r) {
            return r;
        } else {
            return this.lex();
        }
    },

// activates a new lexer condition state (pushes the new lexer condition state onto the condition stack)
begin:function begin(condition) {
        this.conditionStack.push(condition);
    },

// pop the previously active lexer condition state off the condition stack
popState:function popState() {
        var n = this.conditionStack.length - 1;
        if (n > 0) {
            return this.conditionStack.pop();
        } else {
            return this.conditionStack[0];
        }
    },

// produce the lexer rule set which is active for the currently active lexer condition state
_currentRules:function _currentRules() {
        if (this.conditionStack.length && this.conditionStack[this.conditionStack.length - 1]) {
            return this.conditions[this.conditionStack[this.conditionStack.length - 1]].rules;
        } else {
            return this.conditions["INITIAL"].rules;
        }
    },

// return the currently active lexer condition state; when an index argument is provided it produces the N-th previous condition state, if available
topState:function topState(n) {
        n = this.conditionStack.length - 1 - Math.abs(n || 0);
        if (n >= 0) {
            return this.conditionStack[n];
        } else {
            return "INITIAL";
        }
    },

// alias for begin(condition)
pushState:function pushState(condition) {
        this.begin(condition);
    },

// return the number of states currently on the stack
stateStackSize:function stateStackSize() {
        return this.conditionStack.length;
    },
options: {},
performAction: function anonymous(yy,yy_,$avoiding_name_collisions,YY_START
/**/) {

var YYSTATE=YY_START;
switch($avoiding_name_collisions) {
case 0:return 4
break;
case 1:return 14
break;
case 2:return 12
break;
case 3:return 15
break;
case 4:return 16
break;
case 5:return 22
break;
case 6:return 24
break;
case 7:return 28
break;
case 8:return 30
break;
case 9:return 18
break;
case 10:yy_.yytext = yy_.yytext.substr(1,yy_.yyleng-2); return 32;
break;
case 11:yy_.yytext = yy_.yytext.substr(1,yy_.yyleng-2); return 33;
break;
case 12:return 17
break;
case 13:return 31
break;
}
},
rules: [/^(?:\$)/,/^(?:\.\.)/,/^(?:\.)/,/^(?:\*)/,/^(?:[a-zA-Z_]+[a-zA-Z0-9_]*)/,/^(?:\[)/,/^(?:\])/,/^(?:,)/,/^(?:((-?(?:0|[1-9][0-9]*)))?\:((-?(?:0|[1-9][0-9]*)))?(\:((-?(?:0|[1-9][0-9]*)))?)?)/,/^(?:(-?(?:0|[1-9][0-9]*)))/,/^(?:"(?:\\["bfnrt/\\]|\\u[a-fA-F0-9]{4}|[^"\\])*")/,/^(?:'(?:\\['bfnrt/\\]|\\u[a-fA-F0-9]{4}|[^'\\])*')/,/^(?:\(.+?\)(?=\]))/,/^(?:\?\(.+?\)(?=\]))/],
conditions: {"INITIAL":{"rules":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"inclusive":true}}
};
return lexer;
})();
parser.lexer = lexer;
function Parser () {
  this.yy = {};
}
Parser.prototype = parser;parser.Parser = Parser;
return new Parser;
})();


if (typeof require !== 'undefined' && typeof exports !== 'undefined') {
exports.parser = parser;
exports.Parser = parser.Parser;
exports.parse = function () { return parser.parse.apply(parser, arguments); };
exports.main = function commonjsMain(args) {
    if (!args[1]) {
        console.log('Usage: '+args[0]+' FILE');
        process.exit(1);
    }
    var source = require('fs').readFileSync(require('path').normalize(args[1]), "utf8");
    return exports.parser.parse(source);
};
if (typeof module !== 'undefined' && require.main === module) {
  exports.main(process.argv.slice(1));
}
}

}).call(this,require('_process'))
},{"_process":14,"fs":12,"path":13}],2:[function(require,module,exports){
module.exports = {
  identifier: "[a-zA-Z_]+[a-zA-Z0-9_]*",
  integer: "-?(?:0|[1-9][0-9]*)",
  qq_string: "\"(?:\\\\[\"bfnrt/\\\\]|\\\\u[a-fA-F0-9]{4}|[^\"\\\\])*\"",
  q_string: "'(?:\\\\[\'bfnrt/\\\\]|\\\\u[a-fA-F0-9]{4}|[^\'\\\\])*'"
};

},{}],3:[function(require,module,exports){
var dict = require('./dict');
var fs = require('fs');
var grammar = {

    lex: {

        macros: {
            esc: "\\\\",
            int: dict.integer
        },

        rules: [
            ["\\$", "return 'DOLLAR'"],
            ["\\.\\.", "return 'DOT_DOT'"],
            ["\\.", "return 'DOT'"],
            ["\\*", "return 'STAR'"],
            [dict.identifier, "return 'IDENTIFIER'"],
            ["\\[", "return '['"],
            ["\\]", "return ']'"],
            [",", "return ','"],
            ["({int})?\\:({int})?(\\:({int})?)?", "return 'ARRAY_SLICE'"],
            ["{int}", "return 'INTEGER'"],
            [dict.qq_string, "yytext = yytext.substr(1,yyleng-2); return 'QQ_STRING';"],
            [dict.q_string, "yytext = yytext.substr(1,yyleng-2); return 'Q_STRING';"],
            ["\\(.+?\\)(?=\\])", "return 'SCRIPT_EXPRESSION'"],
            ["\\?\\(.+?\\)(?=\\])", "return 'FILTER_EXPRESSION'"]
        ]
    },

    start: "JSON_PATH",

    bnf: {

        JSON_PATH: [
                [ 'DOLLAR',                 'yy.ast.set({ expression: { type: "root", value: $1 } }); yy.ast.unshift(); return yy.ast.yield()' ],
                [ 'DOLLAR PATH_COMPONENTS', 'yy.ast.set({ expression: { type: "root", value: $1 } }); yy.ast.unshift(); return yy.ast.yield()' ],
                [ 'LEADING_CHILD_MEMBER_EXPRESSION',                 'yy.ast.unshift(); return yy.ast.yield()' ],
                [ 'LEADING_CHILD_MEMBER_EXPRESSION PATH_COMPONENTS', 'yy.ast.set({ operation: "member", scope: "child", expression: { type: "identifier", value: $1 }}); yy.ast.unshift(); return yy.ast.yield()' ] ],

        PATH_COMPONENTS: [
                [ 'PATH_COMPONENT',                 '' ],
                [ 'PATH_COMPONENTS PATH_COMPONENT', '' ] ],

        PATH_COMPONENT: [
                [ 'MEMBER_COMPONENT',    'yy.ast.set({ operation: "member" }); yy.ast.push()' ],
                [ 'SUBSCRIPT_COMPONENT', 'yy.ast.set({ operation: "subscript" }); yy.ast.push() ' ] ],

        MEMBER_COMPONENT: [
                [ 'CHILD_MEMBER_COMPONENT',      'yy.ast.set({ scope: "child" })' ],
                [ 'DESCENDANT_MEMBER_COMPONENT', 'yy.ast.set({ scope: "descendant" })' ] ],

        CHILD_MEMBER_COMPONENT: [
                [ 'DOT MEMBER_EXPRESSION', '' ] ],

        LEADING_CHILD_MEMBER_EXPRESSION: [
                [ 'MEMBER_EXPRESSION', 'yy.ast.set({ scope: "child", operation: "member" })' ] ],

        DESCENDANT_MEMBER_COMPONENT: [
                [ 'DOT_DOT MEMBER_EXPRESSION', '' ] ],

        MEMBER_EXPRESSION: [
                [ 'STAR',              'yy.ast.set({ expression: { type: "wildcard", value: $1 } })' ],
                [ 'IDENTIFIER',        'yy.ast.set({ expression: { type: "identifier", value: $1 } })' ],
                [ 'SCRIPT_EXPRESSION', 'yy.ast.set({ expression: { type: "script_expression", value: $1 } })' ],
                [ 'INTEGER',           'yy.ast.set({ expression: { type: "numeric_literal", value: parseInt($1) } })' ],
                [ 'END',               '' ] ],

        SUBSCRIPT_COMPONENT: [
                [ 'CHILD_SUBSCRIPT_COMPONENT',      'yy.ast.set({ scope: "child" })' ],
                [ 'DESCENDANT_SUBSCRIPT_COMPONENT', 'yy.ast.set({ scope: "descendant" })' ] ],

        CHILD_SUBSCRIPT_COMPONENT: [
                [ '[ SUBSCRIPT ]', '' ] ],

        DESCENDANT_SUBSCRIPT_COMPONENT: [
                [ 'DOT_DOT [ SUBSCRIPT ]', '' ] ],

        SUBSCRIPT: [
                [ 'SUBSCRIPT_EXPRESSION', '' ],
                [ 'SUBSCRIPT_EXPRESSION_LIST', '$1.length > 1? yy.ast.set({ expression: { type: "union", value: $1 } }) : $$ = $1' ] ],

        SUBSCRIPT_EXPRESSION_LIST: [
                [ 'SUBSCRIPT_EXPRESSION_LISTABLE', '$$ = [$1]'],
                [ 'SUBSCRIPT_EXPRESSION_LIST , SUBSCRIPT_EXPRESSION_LISTABLE', '$$ = $1.concat($3)' ] ],

        SUBSCRIPT_EXPRESSION_LISTABLE: [
                [ 'INTEGER',           '$$ = { expression: { type: "numeric_literal", value: parseInt($1) } }; yy.ast.set($$)' ],
                [ 'STRING_LITERAL',    '$$ = { expression: { type: "string_literal", value: $1 } }; yy.ast.set($$)' ],
                [ 'ARRAY_SLICE',       '$$ = { expression: { type: "slice", value: $1 } }; yy.ast.set($$)' ] ],

        SUBSCRIPT_EXPRESSION: [
                [ 'STAR',              '$$ = { expression: { type: "wildcard", value: $1 } }; yy.ast.set($$)' ],
                [ 'SCRIPT_EXPRESSION', '$$ = { expression: { type: "script_expression", value: $1 } }; yy.ast.set($$)' ],
                [ 'FILTER_EXPRESSION', '$$ = { expression: { type: "filter_expression", value: $1 } }; yy.ast.set($$)' ] ],

        STRING_LITERAL: [
                [ 'QQ_STRING', "$$ = $1" ],
                [ 'Q_STRING',  "$$ = $1" ] ]
    }
};
if (fs.readFileSync) {
  grammar.moduleInclude = fs.readFileSync(require.resolve("../include/module.js"));
  grammar.actionInclude = fs.readFileSync(require.resolve("../include/action.js"));
}

module.exports = grammar;

},{"./dict":2,"fs":12}],4:[function(require,module,exports){
var aesprim = require('./aesprim');
var slice = require('./slice');
var _evaluate = require('static-eval');
var _uniq = require('underscore').uniq;

var Handlers = function() {
  return this.initialize.apply(this, arguments);
}

Handlers.prototype.initialize = function() {
  this.traverse = traverser(true);
  this.descend = traverser();
}

Handlers.prototype.keys = Object.keys;

Handlers.prototype.resolve = function(component) {

  var key = [ component.operation, component.scope, component.expression.type ].join('-');
  var method = this._fns[key];

  if (!method) throw new Error("couldn't resolve key: " + key);
  return method.bind(this);
};

Handlers.prototype.register = function(key, handler) {

  if (!handler instanceof Function) {
    throw new Error("handler must be a function");
  }

  this._fns[key] = handler;
};

Handlers.prototype._fns = {

  //  (wje) - patched 2019-03-07 to add creation capability.
  'member-child-identifier': function(component, partial) {
    var key = component.expression.value;
    var value = partial.value;
    if (value instanceof Object && key in value) {
      return [ { value: value[key], path: partial.path.concat(key) } ]
    } else if (this.applyMode && this.buildFn) {
      var altered = this.buildFn(partial, value, key);
      if (altered) {
        value = partial.value;
        if (value instanceof Object && key in value) {
          return [ { value: value[key], path: partial.path.concat(key) } ]
        }
      }
    }
  },

  'member-descendant-identifier':
    _traverse(function(key, value, ref) { return key == ref }),

  'subscript-child-numeric_literal':
    _descend(function(key, value, ref) { return key === ref }),

  'member-child-numeric_literal':
    _descend(function(key, value, ref) { return String(key) === String(ref) }),

  'subscript-descendant-numeric_literal':
    _traverse(function(key, value, ref) { return key === ref }),

  'member-child-wildcard':
    _descend(function() { return true }),

  'member-descendant-wildcard':
    _traverse(function() { return true }),

  'subscript-descendant-wildcard':
    _traverse(function() { return true }),

  'subscript-child-wildcard':
    _descend(function() { return true }),

  //  (wje) - patched 2019-03-07 to add creation capability.
  'subscript-child-slice': function(component, partial) {
    if (is_array(partial.value)) {
      var indexes = component.expression.value.split(':');
      var args = indexes.map(_parse_nullable_int);
      var values = partial.value.map(function(v, i) { return { value: v, path: partial.path.concat(i) } });
      var results = slice.apply(null, [values].concat(args));

      //  if we're in 'apply mode', that means that were called as part of an
      //  'apply' operation.
      if (this.applyMode) {
        var start = parseInt(indexes[0]);
        results.forEach(function(element, index) {
          if (element === undefined) {
            results[index] = {
              value: 'stub',
              path: partial.path.concat(start + index)
            }
          }
        });
      }
      return results;
    }
  },

  'subscript-child-union': function(component, partial) {
    var results = [];
    component.expression.value.forEach(function(component) {
      var _component = { operation: 'subscript', scope: 'child', expression: component.expression };
      var handler = this.resolve(_component);
      var _results = handler(_component, partial);
      if (_results) {
        results = results.concat(_results);
      }
    }, this);

    return unique(results);
  },

  'subscript-descendant-union': function(component, partial, count) {

    var jp = require('..');
    var self = this;

    var results = [];
    var nodes = jp.nodes(partial, '$..*').slice(1);

    nodes.forEach(function(node) {
      if (results.length >= count) return;
      component.expression.value.forEach(function(component) {
        var _component = { operation: 'subscript', scope: 'child', expression: component.expression };
        var handler = self.resolve(_component);
        var _results = handler(_component, node);
        results = results.concat(_results);
      });
    });

    return unique(results);
  },

  'subscript-child-filter_expression': function(component, partial, count) {

    // slice out the expression from ?(expression)
    var src = component.expression.value.slice(2, -1);
    var ast = aesprim.parse(src).body[0].expression;

    var passable = function(key, value) {
      return evaluate(ast, { '@': value });
    }

    return this.descend(partial, null, passable, count);

  },

  'subscript-descendant-filter_expression': function(component, partial, count) {

    // slice out the expression from ?(expression)
    var src = component.expression.value.slice(2, -1);
    var ast = aesprim.parse(src).body[0].expression;

    var passable = function(key, value) {
      return evaluate(ast, { '@': value });
    }

    return this.traverse(partial, null, passable, count);
  },

  'subscript-child-script_expression': function(component, partial) {
    var exp = component.expression.value.slice(1, -1);
    return eval_recurse(partial, exp, '$[{{value}}]');
  },

  'member-child-script_expression': function(component, partial) {
    var exp = component.expression.value.slice(1, -1);
    return eval_recurse(partial, exp, '$.{{value}}');
  },

  'member-descendant-script_expression': function(component, partial) {
    var exp = component.expression.value.slice(1, -1);
    return eval_recurse(partial, exp, '$..value');
  }
};

Handlers.prototype._fns['subscript-child-string_literal'] =
	Handlers.prototype._fns['member-child-identifier'];

Handlers.prototype._fns['member-descendant-numeric_literal'] =
    Handlers.prototype._fns['subscript-descendant-string_literal'] =
    Handlers.prototype._fns['member-descendant-identifier'];

function eval_recurse(partial, src, template) {

  var jp = require('./index');
  var ast = aesprim.parse(src).body[0].expression;
  var value = evaluate(ast, { '@': partial.value });
  var path = template.replace(/\{\{\s*value\s*\}\}/g, value);

  var results = jp.nodes(partial.value, path);
  results.forEach(function(r) {
    r.path = partial.path.concat(r.path.slice(1));
  });

  return results;
}

function is_array(val) {
  return Array.isArray(val);
}

function is_object(val) {
  // is this a non-array, non-null object?
  return val && !(val instanceof Array) && val instanceof Object;
}

//  (wje) - patched 2019-03-07 to add creation capability.
function traverser(recurse) {

  return function(partial, ref, passable, count) {

    var value = partial.value;
    var path = partial.path;
    var comp = partial.component;
    var nextComp = partial.nextComponent;

    var results = [];

    var descend = function(value, path) {

      if (is_array(value)) {

        value.forEach(function(element, index) {
          if (results.length >= count) { return }
          if (passable(index, element, ref)) {
            results.push({ path: path.concat(index), value: element });
          }
        });

        if (this.applyMode && this.buildFn) {
          if (results.length === 0) {
            var altered = this.buildFn(partial, value, ref);
          } else if (nextComp &&
                        nextComp.operation === 'subscript' &&
                        !is_array(results[0].value) &&
                        !is_object(results[0].value)) {
            var altered = this.buildFn(partial, value, ref);
          }
          if (altered) {
            value = partial.value;
            value.forEach(function(element, index) {
              if (results.length >= count) { return }
              if (passable(index, element, ref)) {
                results.push({ path: path.concat(index), value: element });
              }
            });
          }
        }

        value.forEach(function(element, index) {
          if (results.length >= count) { return }
          if (recurse) {
            descend(element, path.concat(index));
          }
        });
      } else if (is_object(value)) {

        this.keys(value).forEach(function(k) {
          if (results.length >= count) { return }
          if (passable(k, value[k], ref)) {
            results.push({ path: path.concat(k), value: value[k] });
          }
        });

        if (results.length === 0 && this.applyMode && this.buildFn) {
          var altered = this.buildFn(partial, this.keys(value), ref);
          if (altered) {
            value = partial.value;
            this.keys(value).forEach(function(k) {
              if (results.length >= count) { return }
              if (passable(k, value[k], ref)) {
                results.push({ path: path.concat(k), value: value[k] });
              }
            });
          }
        }

        this.keys(value).forEach(function(k) {
          if (results.length >= count) { return }
          if (recurse) {
            descend(value[k], path.concat(k));
          }
        });
      }
    }.bind(this);
    descend(value, path);
    return results;
  }
}

function _descend(passable) {
  return function(component, partial, count) {
    return this.descend(partial, component.expression.value, passable, count);
  }
}

function _traverse(passable) {
  return function(component, partial, count) {
    return this.traverse(partial, component.expression.value, passable, count);
  }
}

function evaluate() {
  try { return _evaluate.apply(this, arguments) }
  catch (e) { }
}

function unique(results) {
  results = results.filter(function(d) { return d })
  return _uniq(
    results,
    function(r) { return r.path.map(function(c) { return String(c).replace('-', '--') }).join('-') }
  );
}

function _parse_nullable_int(val) {
  var sval = String(val);
  return sval.match(/^-?[0-9]+$/) ? parseInt(sval) : null;
}

module.exports = Handlers;

},{"..":"jsonpath","./aesprim":"./aesprim","./index":5,"./slice":7,"static-eval":15,"underscore":16}],5:[function(require,module,exports){
var assert = require('assert');
var dict = require('./dict');
var Parser = require('./parser');
var Handlers = require('./handlers');

var JSONPath = function() {
  this.initialize.apply(this, arguments);
};

JSONPath.prototype.initialize = function() {
  this.parser = new Parser();
  this.handlers = new Handlers();
};

JSONPath.prototype.parse = function(string) {
  assert.ok(_is_string(string), "we need a path");
  return this.parser.parse(string);
};

JSONPath.prototype.parent = function(obj, string) {

  assert.ok(obj instanceof Object, "obj needs to be an object");
  assert.ok(string, "we need a path");

  var node = this.nodes(obj, string)[0];
  var key = node.path.pop(); /* jshint unused:false */
  return this.value(obj, node.path);
}

//  (wje) - patched 2019-03-07 to add creation capability.
JSONPath.prototype.apply = function(obj, string, fn, buildFn) {

  assert.ok(obj instanceof Object, "obj needs to be an object");
  assert.ok(string, "we need a path");
  assert.equal(typeof fn, "function", "fn needs to be function")

  this.handlers.applyMode = true;
  this.handlers.buildFn = buildFn;

  var nodes = this.nodes(obj, string).sort(function(a, b) {
    // sort nodes so we apply from the bottom up
    return b.path.length - a.path.length;
  });

  this.handlers.buildFn = null;
  this.handlers.applyMode = false;

  nodes.forEach(function(node) {
    var key = node.path.pop();
    var parent = this.value(obj, this.stringify(node.path));
    var val = node.value = fn.call(obj, parent[key]);
    parent[key] = val;
    node.path.push(key);
  }, this);

  return nodes;
}

JSONPath.prototype.value = function(obj, path, value) {

  assert.ok(obj instanceof Object, "obj needs to be an object");
  assert.ok(path, "we need a path");

  if (arguments.length >= 3) {
    var node = this.nodes(obj, path).shift();
    if (!node) return this._vivify(obj, path, value);
    var key = node.path.slice(-1).shift();
    var parent = this.parent(obj, this.stringify(node.path));
    parent[key] = value;
  }
  return this.query(obj, this.stringify(path), 1).shift();
}

JSONPath.prototype._vivify = function(obj, string, value) {

  var self = this;

  assert.ok(obj instanceof Object, "obj needs to be an object");
  assert.ok(string, "we need a path");

  var path = this.parser.parse(string)
    .map(function(component) { return component.expression.value });

  var setValue = function(path, value) {
    var key = path.pop();
    var node = self.value(obj, path);
    if (!node) {
      setValue(path.concat(), typeof key === 'string' ? {} : []);
      node = self.value(obj, path);
    }
    node[key] = value;
  }
  setValue(path, value);
  return this.query(obj, string)[0];
}

JSONPath.prototype.query = function(obj, string, count) {

  assert.ok(obj instanceof Object, "obj needs to be an object");
  assert.ok(_is_string(string), "we need a path");

  var results = this.nodes(obj, string, count)
    .map(function(r) { return r.value });

  return results;
};

JSONPath.prototype.paths = function(obj, string, count) {

  assert.ok(obj instanceof Object, "obj needs to be an object");
  assert.ok(string, "we need a path");

  var results = this.nodes(obj, string, count)
    .map(function(r) { return r.path });

  return results;
};

JSONPath.prototype.nodes = function(obj, string, count) {

  assert.ok(obj instanceof Object, "obj needs to be an object");
  assert.ok(string, "we need a path");

  if (count === 0) return [];

  var path = this.parser.parse(string);
  var handlers = this.handlers;

  var partials = [ { path: ['$'], value: obj } ];
  var matches = [];

  if (path.length && path[0].expression.type == 'root') path.shift();

  if (!path.length) return partials;

  path.forEach(function(component, index) {

    if (matches.length >= count) return;
    var handler = handlers.resolve(component);
    var _partials = [];

    partials.forEach(function(p) {

      if (matches.length >= count) return;

      //  (wje) - patched 2019-03-07 to add creation capability.
      p.component = component;
      p.nextComponent = path[index + 1];

      var results = handler(component, p, count);

      if (index == path.length - 1) {
        // if we're through the components we're done
        matches = matches.concat(results || []);
      } else {
        // otherwise accumulate and carry on through
        _partials = _partials.concat(results || []);
      }
    });

    partials = _partials;

  });

  return count ? matches.slice(0, count) : matches;
};

JSONPath.prototype.stringify = function(path) {

  assert.ok(path, "we need a path");

  var string = '$';

  var templates = {
    'descendant-member': '..{{value}}',
    'child-member': '.{{value}}',
    'descendant-subscript': '..[{{value}}]',
    'child-subscript': '[{{value}}]'
  };

  path = this._normalize(path);

  path.forEach(function(component) {

    if (component.expression.type == 'root') return;

    var key = [component.scope, component.operation].join('-');
    var template = templates[key];
    var value;

    if (component.expression.type == 'string_literal') {
      value = JSON.stringify(component.expression.value)
    } else {
      value = component.expression.value;
    }

    if (!template) throw new Error("couldn't find template " + key);

    string += template.replace(/{{value}}/, value);
  });

  return string;
}

JSONPath.prototype._normalize = function(path) {

  assert.ok(path, "we need a path");

  if (typeof path == "string") {

    return this.parser.parse(path);

  } else if (Array.isArray(path) && typeof path[0] == "string") {

    var _path = [ { expression: { type: "root", value: "$" } } ];

    path.forEach(function(component, index) {

      if (component == '$' && index === 0) return;

      if (typeof component == "string" && component.match("^" + dict.identifier + "$")) {

        _path.push({
          operation: 'member',
          scope: 'child',
          expression: { value: component, type: 'identifier' }
        });

      } else {

        var type = typeof component == "number" ?
          'numeric_literal' : 'string_literal';

        _path.push({
          operation: 'subscript',
          scope: 'child',
          expression: { value: component, type: type }
        });
      }
    });

    return _path;

  } else if (Array.isArray(path) && typeof path[0] == "object") {

    return path
  }

  throw new Error("couldn't understand path " + path);
}

function _is_string(obj) {
  return Object.prototype.toString.call(obj) == '[object String]';
}

JSONPath.Handlers = Handlers;
JSONPath.Parser = Parser;

var instance = new JSONPath;
instance.JSONPath = JSONPath;

module.exports = instance;

},{"./dict":2,"./handlers":4,"./parser":6,"assert":8}],6:[function(require,module,exports){
var grammar = require('./grammar');
var gparser = require('../generated/parser');

var Parser = function() {

  var parser = new gparser.Parser();

  var _parseError = parser.parseError;
  parser.yy.parseError = function() {
    if (parser.yy.ast) {
      parser.yy.ast.initialize();
    }
    _parseError.apply(parser, arguments);
  }

  return parser;

};

Parser.grammar = grammar;
module.exports = Parser;

},{"../generated/parser":1,"./grammar":3}],7:[function(require,module,exports){
module.exports = function(arr, start, end, step) {

  if (typeof start == 'string') throw new Error("start cannot be a string");
  if (typeof end == 'string') throw new Error("end cannot be a string");
  if (typeof step == 'string') throw new Error("step cannot be a string");

  var len = arr.length;

  if (step === 0) throw new Error("step cannot be zero");
  step = step ? integer(step) : 1;

  // normalize negative values
  start = start < 0 ? len + start : start;
  end = end < 0 ? len + end : end;

  // default extents to extents
  start = integer(start === 0 ? 0 : !start ? (step > 0 ? 0 : len - 1) : start);
  end = integer(end === 0 ? 0 : !end ? (step > 0 ? len : -1) : end);

  // clamp extents
  start = step > 0 ? Math.max(0, start) : Math.min(len, start);
  end = step > 0 ? Math.min(end, len) : Math.max(-1, end);

  // return empty if extents are backwards
  if (step > 0 && end <= start) return [];
  if (step < 0 && start <= end) return [];

  var result = [];

  for (var i = start; i != end; i += step) {
    if ((step < 0 && i <= end) || (step > 0 && i >= end)) break;
    result.push(arr[i]);
  }

  return result;
}

function integer(val) {
  return String(val).match(/^[0-9]+$/) ? parseInt(val) :
    Number.isFinite(val) ? parseInt(val, 10) : 0;
}

},{}],8:[function(require,module,exports){
// http://wiki.commonjs.org/wiki/Unit_Testing/1.0
//
// THIS IS NOT TESTED NOR LIKELY TO WORK OUTSIDE V8!
//
// Originally from narwhal.js (http://narwhaljs.org)
// Copyright (c) 2009 Thomas Robinson <280north.com>
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the 'Software'), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
// ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

// when used in node, this will actually load the util module we depend on
// versus loading the builtin util module as happens otherwise
// this is a bug in node module loading as far as I am concerned
var util = require('util/');

var pSlice = Array.prototype.slice;
var hasOwn = Object.prototype.hasOwnProperty;

// 1. The assert module provides functions that throw
// AssertionError's when particular conditions are not met. The
// assert module must conform to the following interface.

var assert = module.exports = ok;

// 2. The AssertionError is defined in assert.
// new assert.AssertionError({ message: message,
//                             actual: actual,
//                             expected: expected })

assert.AssertionError = function AssertionError(options) {
  this.name = 'AssertionError';
  this.actual = options.actual;
  this.expected = options.expected;
  this.operator = options.operator;
  if (options.message) {
    this.message = options.message;
    this.generatedMessage = false;
  } else {
    this.message = getMessage(this);
    this.generatedMessage = true;
  }
  var stackStartFunction = options.stackStartFunction || fail;

  if (Error.captureStackTrace) {
    Error.captureStackTrace(this, stackStartFunction);
  }
  else {
    // non v8 browsers so we can have a stacktrace
    var err = new Error();
    if (err.stack) {
      var out = err.stack;

      // try to strip useless frames
      var fn_name = stackStartFunction.name;
      var idx = out.indexOf('\n' + fn_name);
      if (idx >= 0) {
        // once we have located the function frame
        // we need to strip out everything before it (and its line)
        var next_line = out.indexOf('\n', idx + 1);
        out = out.substring(next_line + 1);
      }

      this.stack = out;
    }
  }
};

// assert.AssertionError instanceof Error
util.inherits(assert.AssertionError, Error);

function replacer(key, value) {
  if (util.isUndefined(value)) {
    return '' + value;
  }
  if (util.isNumber(value) && !isFinite(value)) {
    return value.toString();
  }
  if (util.isFunction(value) || util.isRegExp(value)) {
    return value.toString();
  }
  return value;
}

function truncate(s, n) {
  if (util.isString(s)) {
    return s.length < n ? s : s.slice(0, n);
  } else {
    return s;
  }
}

function getMessage(self) {
  return truncate(JSON.stringify(self.actual, replacer), 128) + ' ' +
         self.operator + ' ' +
         truncate(JSON.stringify(self.expected, replacer), 128);
}

// At present only the three keys mentioned above are used and
// understood by the spec. Implementations or sub modules can pass
// other keys to the AssertionError's constructor - they will be
// ignored.

// 3. All of the following functions must throw an AssertionError
// when a corresponding condition is not met, with a message that
// may be undefined if not provided.  All assertion methods provide
// both the actual and expected values to the assertion error for
// display purposes.

function fail(actual, expected, message, operator, stackStartFunction) {
  throw new assert.AssertionError({
    message: message,
    actual: actual,
    expected: expected,
    operator: operator,
    stackStartFunction: stackStartFunction
  });
}

// EXTENSION! allows for well behaved errors defined elsewhere.
assert.fail = fail;

// 4. Pure assertion tests whether a value is truthy, as determined
// by !!guard.
// assert.ok(guard, message_opt);
// This statement is equivalent to assert.equal(true, !!guard,
// message_opt);. To test strictly for the value true, use
// assert.strictEqual(true, guard, message_opt);.

function ok(value, message) {
  if (!value) fail(value, true, message, '==', assert.ok);
}
assert.ok = ok;

// 5. The equality assertion tests shallow, coercive equality with
// ==.
// assert.equal(actual, expected, message_opt);

assert.equal = function equal(actual, expected, message) {
  if (actual != expected) fail(actual, expected, message, '==', assert.equal);
};

// 6. The non-equality assertion tests for whether two objects are not equal
// with != assert.notEqual(actual, expected, message_opt);

assert.notEqual = function notEqual(actual, expected, message) {
  if (actual == expected) {
    fail(actual, expected, message, '!=', assert.notEqual);
  }
};

// 7. The equivalence assertion tests a deep equality relation.
// assert.deepEqual(actual, expected, message_opt);

assert.deepEqual = function deepEqual(actual, expected, message) {
  if (!_deepEqual(actual, expected)) {
    fail(actual, expected, message, 'deepEqual', assert.deepEqual);
  }
};

function _deepEqual(actual, expected) {
  // 7.1. All identical values are equivalent, as determined by ===.
  if (actual === expected) {
    return true;

  } else if (util.isBuffer(actual) && util.isBuffer(expected)) {
    if (actual.length != expected.length) return false;

    for (var i = 0; i < actual.length; i++) {
      if (actual[i] !== expected[i]) return false;
    }

    return true;

  // 7.2. If the expected value is a Date object, the actual value is
  // equivalent if it is also a Date object that refers to the same time.
  } else if (util.isDate(actual) && util.isDate(expected)) {
    return actual.getTime() === expected.getTime();

  // 7.3 If the expected value is a RegExp object, the actual value is
  // equivalent if it is also a RegExp object with the same source and
  // properties (`global`, `multiline`, `lastIndex`, `ignoreCase`).
  } else if (util.isRegExp(actual) && util.isRegExp(expected)) {
    return actual.source === expected.source &&
           actual.global === expected.global &&
           actual.multiline === expected.multiline &&
           actual.lastIndex === expected.lastIndex &&
           actual.ignoreCase === expected.ignoreCase;

  // 7.4. Other pairs that do not both pass typeof value == 'object',
  // equivalence is determined by ==.
  } else if (!util.isObject(actual) && !util.isObject(expected)) {
    return actual == expected;

  // 7.5 For all other Object pairs, including Array objects, equivalence is
  // determined by having the same number of owned properties (as verified
  // with Object.prototype.hasOwnProperty.call), the same set of keys
  // (although not necessarily the same order), equivalent values for every
  // corresponding key, and an identical 'prototype' property. Note: this
  // accounts for both named and indexed properties on Arrays.
  } else {
    return objEquiv(actual, expected);
  }
}

function isArguments(object) {
  return Object.prototype.toString.call(object) == '[object Arguments]';
}

function objEquiv(a, b) {
  if (util.isNullOrUndefined(a) || util.isNullOrUndefined(b))
    return false;
  // an identical 'prototype' property.
  if (a.prototype !== b.prototype) return false;
  // if one is a primitive, the other must be same
  if (util.isPrimitive(a) || util.isPrimitive(b)) {
    return a === b;
  }
  var aIsArgs = isArguments(a),
      bIsArgs = isArguments(b);
  if ((aIsArgs && !bIsArgs) || (!aIsArgs && bIsArgs))
    return false;
  if (aIsArgs) {
    a = pSlice.call(a);
    b = pSlice.call(b);
    return _deepEqual(a, b);
  }
  var ka = objectKeys(a),
      kb = objectKeys(b),
      key, i;
  // having the same number of owned properties (keys incorporates
  // hasOwnProperty)
  if (ka.length != kb.length)
    return false;
  //the same set of keys (although not necessarily the same order),
  ka.sort();
  kb.sort();
  //~~~cheap key test
  for (i = ka.length - 1; i >= 0; i--) {
    if (ka[i] != kb[i])
      return false;
  }
  //equivalent values for every corresponding key, and
  //~~~possibly expensive deep test
  for (i = ka.length - 1; i >= 0; i--) {
    key = ka[i];
    if (!_deepEqual(a[key], b[key])) return false;
  }
  return true;
}

// 8. The non-equivalence assertion tests for any deep inequality.
// assert.notDeepEqual(actual, expected, message_opt);

assert.notDeepEqual = function notDeepEqual(actual, expected, message) {
  if (_deepEqual(actual, expected)) {
    fail(actual, expected, message, 'notDeepEqual', assert.notDeepEqual);
  }
};

// 9. The strict equality assertion tests strict equality, as determined by ===.
// assert.strictEqual(actual, expected, message_opt);

assert.strictEqual = function strictEqual(actual, expected, message) {
  if (actual !== expected) {
    fail(actual, expected, message, '===', assert.strictEqual);
  }
};

// 10. The strict non-equality assertion tests for strict inequality, as
// determined by !==.  assert.notStrictEqual(actual, expected, message_opt);

assert.notStrictEqual = function notStrictEqual(actual, expected, message) {
  if (actual === expected) {
    fail(actual, expected, message, '!==', assert.notStrictEqual);
  }
};

function expectedException(actual, expected) {
  if (!actual || !expected) {
    return false;
  }

  if (Object.prototype.toString.call(expected) == '[object RegExp]') {
    return expected.test(actual);
  } else if (actual instanceof expected) {
    return true;
  } else if (expected.call({}, actual) === true) {
    return true;
  }

  return false;
}

function _throws(shouldThrow, block, expected, message) {
  var actual;

  if (util.isString(expected)) {
    message = expected;
    expected = null;
  }

  try {
    block();
  } catch (e) {
    actual = e;
  }

  message = (expected && expected.name ? ' (' + expected.name + ').' : '.') +
            (message ? ' ' + message : '.');

  if (shouldThrow && !actual) {
    fail(actual, expected, 'Missing expected exception' + message);
  }

  if (!shouldThrow && expectedException(actual, expected)) {
    fail(actual, expected, 'Got unwanted exception' + message);
  }

  if ((shouldThrow && actual && expected &&
      !expectedException(actual, expected)) || (!shouldThrow && actual)) {
    throw actual;
  }
}

// 11. Expected to throw an error:
// assert.throws(block, Error_opt, message_opt);

assert.throws = function(block, /*optional*/error, /*optional*/message) {
  _throws.apply(this, [true].concat(pSlice.call(arguments)));
};

// EXTENSION! This is annoying to write outside this module.
assert.doesNotThrow = function(block, /*optional*/message) {
  _throws.apply(this, [false].concat(pSlice.call(arguments)));
};

assert.ifError = function(err) { if (err) {throw err;}};

var objectKeys = Object.keys || function (obj) {
  var keys = [];
  for (var key in obj) {
    if (hasOwn.call(obj, key)) keys.push(key);
  }
  return keys;
};

},{"util/":11}],9:[function(require,module,exports){
if (typeof Object.create === 'function') {
  // implementation from standard node.js 'util' module
  module.exports = function inherits(ctor, superCtor) {
    ctor.super_ = superCtor
    ctor.prototype = Object.create(superCtor.prototype, {
      constructor: {
        value: ctor,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
  };
} else {
  // old school shim for old browsers
  module.exports = function inherits(ctor, superCtor) {
    ctor.super_ = superCtor
    var TempCtor = function () {}
    TempCtor.prototype = superCtor.prototype
    ctor.prototype = new TempCtor()
    ctor.prototype.constructor = ctor
  }
}

},{}],10:[function(require,module,exports){
module.exports = function isBuffer(arg) {
  return arg && typeof arg === 'object'
    && typeof arg.copy === 'function'
    && typeof arg.fill === 'function'
    && typeof arg.readUInt8 === 'function';
}
},{}],11:[function(require,module,exports){
(function (process,global){
// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

var formatRegExp = /%[sdj%]/g;
exports.format = function(f) {
  if (!isString(f)) {
    var objects = [];
    for (var i = 0; i < arguments.length; i++) {
      objects.push(inspect(arguments[i]));
    }
    return objects.join(' ');
  }

  var i = 1;
  var args = arguments;
  var len = args.length;
  var str = String(f).replace(formatRegExp, function(x) {
    if (x === '%%') return '%';
    if (i >= len) return x;
    switch (x) {
      case '%s': return String(args[i++]);
      case '%d': return Number(args[i++]);
      case '%j':
        try {
          return JSON.stringify(args[i++]);
        } catch (_) {
          return '[Circular]';
        }
      default:
        return x;
    }
  });
  for (var x = args[i]; i < len; x = args[++i]) {
    if (isNull(x) || !isObject(x)) {
      str += ' ' + x;
    } else {
      str += ' ' + inspect(x);
    }
  }
  return str;
};


// Mark that a method should not be used.
// Returns a modified function which warns once by default.
// If --no-deprecation is set, then it is a no-op.
exports.deprecate = function(fn, msg) {
  // Allow for deprecating things in the process of starting up.
  if (isUndefined(global.process)) {
    return function() {
      return exports.deprecate(fn, msg).apply(this, arguments);
    };
  }

  if (process.noDeprecation === true) {
    return fn;
  }

  var warned = false;
  function deprecated() {
    if (!warned) {
      if (process.throwDeprecation) {
        throw new Error(msg);
      } else if (process.traceDeprecation) {
        console.trace(msg);
      } else {
        console.error(msg);
      }
      warned = true;
    }
    return fn.apply(this, arguments);
  }

  return deprecated;
};


var debugs = {};
var debugEnviron;
exports.debuglog = function(set) {
  if (isUndefined(debugEnviron))
    debugEnviron = process.env.NODE_DEBUG || '';
  set = set.toUpperCase();
  if (!debugs[set]) {
    if (new RegExp('\\b' + set + '\\b', 'i').test(debugEnviron)) {
      var pid = process.pid;
      debugs[set] = function() {
        var msg = exports.format.apply(exports, arguments);
        console.error('%s %d: %s', set, pid, msg);
      };
    } else {
      debugs[set] = function() {};
    }
  }
  return debugs[set];
};


/**
 * Echos the value of a value. Trys to print the value out
 * in the best way possible given the different types.
 *
 * @param {Object} obj The object to print out.
 * @param {Object} opts Optional options object that alters the output.
 */
/* legacy: obj, showHidden, depth, colors*/
function inspect(obj, opts) {
  // default options
  var ctx = {
    seen: [],
    stylize: stylizeNoColor
  };
  // legacy...
  if (arguments.length >= 3) ctx.depth = arguments[2];
  if (arguments.length >= 4) ctx.colors = arguments[3];
  if (isBoolean(opts)) {
    // legacy...
    ctx.showHidden = opts;
  } else if (opts) {
    // got an "options" object
    exports._extend(ctx, opts);
  }
  // set default options
  if (isUndefined(ctx.showHidden)) ctx.showHidden = false;
  if (isUndefined(ctx.depth)) ctx.depth = 2;
  if (isUndefined(ctx.colors)) ctx.colors = false;
  if (isUndefined(ctx.customInspect)) ctx.customInspect = true;
  if (ctx.colors) ctx.stylize = stylizeWithColor;
  return formatValue(ctx, obj, ctx.depth);
}
exports.inspect = inspect;


// http://en.wikipedia.org/wiki/ANSI_escape_code#graphics
inspect.colors = {
  'bold' : [1, 22],
  'italic' : [3, 23],
  'underline' : [4, 24],
  'inverse' : [7, 27],
  'white' : [37, 39],
  'grey' : [90, 39],
  'black' : [30, 39],
  'blue' : [34, 39],
  'cyan' : [36, 39],
  'green' : [32, 39],
  'magenta' : [35, 39],
  'red' : [31, 39],
  'yellow' : [33, 39]
};

// Don't use 'blue' not visible on cmd.exe
inspect.styles = {
  'special': 'cyan',
  'number': 'yellow',
  'boolean': 'yellow',
  'undefined': 'grey',
  'null': 'bold',
  'string': 'green',
  'date': 'magenta',
  // "name": intentionally not styling
  'regexp': 'red'
};


function stylizeWithColor(str, styleType) {
  var style = inspect.styles[styleType];

  if (style) {
    return '\u001b[' + inspect.colors[style][0] + 'm' + str +
           '\u001b[' + inspect.colors[style][1] + 'm';
  } else {
    return str;
  }
}


function stylizeNoColor(str, styleType) {
  return str;
}


function arrayToHash(array) {
  var hash = {};

  array.forEach(function(val, idx) {
    hash[val] = true;
  });

  return hash;
}


function formatValue(ctx, value, recurseTimes) {
  // Provide a hook for user-specified inspect functions.
  // Check that value is an object with an inspect function on it
  if (ctx.customInspect &&
      value &&
      isFunction(value.inspect) &&
      // Filter out the util module, it's inspect function is special
      value.inspect !== exports.inspect &&
      // Also filter out any prototype objects using the circular check.
      !(value.constructor && value.constructor.prototype === value)) {
    var ret = value.inspect(recurseTimes, ctx);
    if (!isString(ret)) {
      ret = formatValue(ctx, ret, recurseTimes);
    }
    return ret;
  }

  // Primitive types cannot have properties
  var primitive = formatPrimitive(ctx, value);
  if (primitive) {
    return primitive;
  }

  // Look up the keys of the object.
  var keys = Object.keys(value);
  var visibleKeys = arrayToHash(keys);

  if (ctx.showHidden) {
    keys = Object.getOwnPropertyNames(value);
  }

  // IE doesn't make error fields non-enumerable
  // http://msdn.microsoft.com/en-us/library/ie/dww52sbt(v=vs.94).aspx
  if (isError(value)
      && (keys.indexOf('message') >= 0 || keys.indexOf('description') >= 0)) {
    return formatError(value);
  }

  // Some type of object without properties can be shortcutted.
  if (keys.length === 0) {
    if (isFunction(value)) {
      var name = value.name ? ': ' + value.name : '';
      return ctx.stylize('[Function' + name + ']', 'special');
    }
    if (isRegExp(value)) {
      return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
    }
    if (isDate(value)) {
      return ctx.stylize(Date.prototype.toString.call(value), 'date');
    }
    if (isError(value)) {
      return formatError(value);
    }
  }

  var base = '', array = false, braces = ['{', '}'];

  // Make Array say that they are Array
  if (isArray(value)) {
    array = true;
    braces = ['[', ']'];
  }

  // Make functions say that they are functions
  if (isFunction(value)) {
    var n = value.name ? ': ' + value.name : '';
    base = ' [Function' + n + ']';
  }

  // Make RegExps say that they are RegExps
  if (isRegExp(value)) {
    base = ' ' + RegExp.prototype.toString.call(value);
  }

  // Make dates with properties first say the date
  if (isDate(value)) {
    base = ' ' + Date.prototype.toUTCString.call(value);
  }

  // Make error with message first say the error
  if (isError(value)) {
    base = ' ' + formatError(value);
  }

  if (keys.length === 0 && (!array || value.length == 0)) {
    return braces[0] + base + braces[1];
  }

  if (recurseTimes < 0) {
    if (isRegExp(value)) {
      return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
    } else {
      return ctx.stylize('[Object]', 'special');
    }
  }

  ctx.seen.push(value);

  var output;
  if (array) {
    output = formatArray(ctx, value, recurseTimes, visibleKeys, keys);
  } else {
    output = keys.map(function(key) {
      return formatProperty(ctx, value, recurseTimes, visibleKeys, key, array);
    });
  }

  ctx.seen.pop();

  return reduceToSingleString(output, base, braces);
}


function formatPrimitive(ctx, value) {
  if (isUndefined(value))
    return ctx.stylize('undefined', 'undefined');
  if (isString(value)) {
    var simple = '\'' + JSON.stringify(value).replace(/^"|"$/g, '')
                                             .replace(/'/g, "\\'")
                                             .replace(/\\"/g, '"') + '\'';
    return ctx.stylize(simple, 'string');
  }
  if (isNumber(value))
    return ctx.stylize('' + value, 'number');
  if (isBoolean(value))
    return ctx.stylize('' + value, 'boolean');
  // For some reason typeof null is "object", so special case here.
  if (isNull(value))
    return ctx.stylize('null', 'null');
}


function formatError(value) {
  return '[' + Error.prototype.toString.call(value) + ']';
}


function formatArray(ctx, value, recurseTimes, visibleKeys, keys) {
  var output = [];
  for (var i = 0, l = value.length; i < l; ++i) {
    if (hasOwnProperty(value, String(i))) {
      output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
          String(i), true));
    } else {
      output.push('');
    }
  }
  keys.forEach(function(key) {
    if (!key.match(/^\d+$/)) {
      output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
          key, true));
    }
  });
  return output;
}


function formatProperty(ctx, value, recurseTimes, visibleKeys, key, array) {
  var name, str, desc;
  desc = Object.getOwnPropertyDescriptor(value, key) || { value: value[key] };
  if (desc.get) {
    if (desc.set) {
      str = ctx.stylize('[Getter/Setter]', 'special');
    } else {
      str = ctx.stylize('[Getter]', 'special');
    }
  } else {
    if (desc.set) {
      str = ctx.stylize('[Setter]', 'special');
    }
  }
  if (!hasOwnProperty(visibleKeys, key)) {
    name = '[' + key + ']';
  }
  if (!str) {
    if (ctx.seen.indexOf(desc.value) < 0) {
      if (isNull(recurseTimes)) {
        str = formatValue(ctx, desc.value, null);
      } else {
        str = formatValue(ctx, desc.value, recurseTimes - 1);
      }
      if (str.indexOf('\n') > -1) {
        if (array) {
          str = str.split('\n').map(function(line) {
            return '  ' + line;
          }).join('\n').substr(2);
        } else {
          str = '\n' + str.split('\n').map(function(line) {
            return '   ' + line;
          }).join('\n');
        }
      }
    } else {
      str = ctx.stylize('[Circular]', 'special');
    }
  }
  if (isUndefined(name)) {
    if (array && key.match(/^\d+$/)) {
      return str;
    }
    name = JSON.stringify('' + key);
    if (name.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)) {
      name = name.substr(1, name.length - 2);
      name = ctx.stylize(name, 'name');
    } else {
      name = name.replace(/'/g, "\\'")
                 .replace(/\\"/g, '"')
                 .replace(/(^"|"$)/g, "'");
      name = ctx.stylize(name, 'string');
    }
  }

  return name + ': ' + str;
}


function reduceToSingleString(output, base, braces) {
  var numLinesEst = 0;
  var length = output.reduce(function(prev, cur) {
    numLinesEst++;
    if (cur.indexOf('\n') >= 0) numLinesEst++;
    return prev + cur.replace(/\u001b\[\d\d?m/g, '').length + 1;
  }, 0);

  if (length > 60) {
    return braces[0] +
           (base === '' ? '' : base + '\n ') +
           ' ' +
           output.join(',\n  ') +
           ' ' +
           braces[1];
  }

  return braces[0] + base + ' ' + output.join(', ') + ' ' + braces[1];
}


// NOTE: These type checking functions intentionally don't use `instanceof`
// because it is fragile and can be easily faked with `Object.create()`.
function isArray(ar) {
  return Array.isArray(ar);
}
exports.isArray = isArray;

function isBoolean(arg) {
  return typeof arg === 'boolean';
}
exports.isBoolean = isBoolean;

function isNull(arg) {
  return arg === null;
}
exports.isNull = isNull;

function isNullOrUndefined(arg) {
  return arg == null;
}
exports.isNullOrUndefined = isNullOrUndefined;

function isNumber(arg) {
  return typeof arg === 'number';
}
exports.isNumber = isNumber;

function isString(arg) {
  return typeof arg === 'string';
}
exports.isString = isString;

function isSymbol(arg) {
  return typeof arg === 'symbol';
}
exports.isSymbol = isSymbol;

function isUndefined(arg) {
  return arg === void 0;
}
exports.isUndefined = isUndefined;

function isRegExp(re) {
  return isObject(re) && objectToString(re) === '[object RegExp]';
}
exports.isRegExp = isRegExp;

function isObject(arg) {
  return typeof arg === 'object' && arg !== null;
}
exports.isObject = isObject;

function isDate(d) {
  return isObject(d) && objectToString(d) === '[object Date]';
}
exports.isDate = isDate;

function isError(e) {
  return isObject(e) &&
      (objectToString(e) === '[object Error]' || e instanceof Error);
}
exports.isError = isError;

function isFunction(arg) {
  return typeof arg === 'function';
}
exports.isFunction = isFunction;

function isPrimitive(arg) {
  return arg === null ||
         typeof arg === 'boolean' ||
         typeof arg === 'number' ||
         typeof arg === 'string' ||
         typeof arg === 'symbol' ||  // ES6 symbol
         typeof arg === 'undefined';
}
exports.isPrimitive = isPrimitive;

exports.isBuffer = require('./support/isBuffer');

function objectToString(o) {
  return Object.prototype.toString.call(o);
}


function pad(n) {
  return n < 10 ? '0' + n.toString(10) : n.toString(10);
}


var months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep',
              'Oct', 'Nov', 'Dec'];

// 26 Feb 16:19:34
function timestamp() {
  var d = new Date();
  var time = [pad(d.getHours()),
              pad(d.getMinutes()),
              pad(d.getSeconds())].join(':');
  return [d.getDate(), months[d.getMonth()], time].join(' ');
}


// log is just a thin wrapper to console.log that prepends a timestamp
exports.log = function() {
  console.log('%s - %s', timestamp(), exports.format.apply(exports, arguments));
};


/**
 * Inherit the prototype methods from one constructor into another.
 *
 * The Function.prototype.inherits from lang.js rewritten as a standalone
 * function (not on Function.prototype). NOTE: If this file is to be loaded
 * during bootstrapping this function needs to be rewritten using some native
 * functions as prototype setup using normal JavaScript does not work as
 * expected during bootstrapping (see mirror.js in r114903).
 *
 * @param {function} ctor Constructor function which needs to inherit the
 *     prototype.
 * @param {function} superCtor Constructor function to inherit prototype from.
 */
exports.inherits = require('inherits');

exports._extend = function(origin, add) {
  // Don't do anything if add isn't an object
  if (!add || !isObject(add)) return origin;

  var keys = Object.keys(add);
  var i = keys.length;
  while (i--) {
    origin[keys[i]] = add[keys[i]];
  }
  return origin;
};

function hasOwnProperty(obj, prop) {
  return Object.prototype.hasOwnProperty.call(obj, prop);
}

}).call(this,require('_process'),typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{"./support/isBuffer":10,"_process":14,"inherits":9}],12:[function(require,module,exports){

},{}],13:[function(require,module,exports){
(function (process){
// .dirname, .basename, and .extname methods are extracted from Node.js v8.11.1,
// backported and transplited with Babel, with backwards-compat fixes

// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

// resolves . and .. elements in a path array with directory names there
// must be no slashes, empty elements, or device names (c:\) in the array
// (so also no leading and trailing slashes - it does not distinguish
// relative and absolute paths)
function normalizeArray(parts, allowAboveRoot) {
  // if the path tries to go above the root, `up` ends up > 0
  var up = 0;
  for (var i = parts.length - 1; i >= 0; i--) {
    var last = parts[i];
    if (last === '.') {
      parts.splice(i, 1);
    } else if (last === '..') {
      parts.splice(i, 1);
      up++;
    } else if (up) {
      parts.splice(i, 1);
      up--;
    }
  }

  // if the path is allowed to go above the root, restore leading ..s
  if (allowAboveRoot) {
    for (; up--; up) {
      parts.unshift('..');
    }
  }

  return parts;
}

// path.resolve([from ...], to)
// posix version
exports.resolve = function() {
  var resolvedPath = '',
      resolvedAbsolute = false;

  for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
    var path = (i >= 0) ? arguments[i] : process.cwd();

    // Skip empty and invalid entries
    if (typeof path !== 'string') {
      throw new TypeError('Arguments to path.resolve must be strings');
    } else if (!path) {
      continue;
    }

    resolvedPath = path + '/' + resolvedPath;
    resolvedAbsolute = path.charAt(0) === '/';
  }

  // At this point the path should be resolved to a full absolute path, but
  // handle relative paths to be safe (might happen when process.cwd() fails)

  // Normalize the path
  resolvedPath = normalizeArray(filter(resolvedPath.split('/'), function(p) {
    return !!p;
  }), !resolvedAbsolute).join('/');

  return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
};

// path.normalize(path)
// posix version
exports.normalize = function(path) {
  var isAbsolute = exports.isAbsolute(path),
      trailingSlash = substr(path, -1) === '/';

  // Normalize the path
  path = normalizeArray(filter(path.split('/'), function(p) {
    return !!p;
  }), !isAbsolute).join('/');

  if (!path && !isAbsolute) {
    path = '.';
  }
  if (path && trailingSlash) {
    path += '/';
  }

  return (isAbsolute ? '/' : '') + path;
};

// posix version
exports.isAbsolute = function(path) {
  return path.charAt(0) === '/';
};

// posix version
exports.join = function() {
  var paths = Array.prototype.slice.call(arguments, 0);
  return exports.normalize(filter(paths, function(p, index) {
    if (typeof p !== 'string') {
      throw new TypeError('Arguments to path.join must be strings');
    }
    return p;
  }).join('/'));
};


// path.relative(from, to)
// posix version
exports.relative = function(from, to) {
  from = exports.resolve(from).substr(1);
  to = exports.resolve(to).substr(1);

  function trim(arr) {
    var start = 0;
    for (; start < arr.length; start++) {
      if (arr[start] !== '') break;
    }

    var end = arr.length - 1;
    for (; end >= 0; end--) {
      if (arr[end] !== '') break;
    }

    if (start > end) return [];
    return arr.slice(start, end - start + 1);
  }

  var fromParts = trim(from.split('/'));
  var toParts = trim(to.split('/'));

  var length = Math.min(fromParts.length, toParts.length);
  var samePartsLength = length;
  for (var i = 0; i < length; i++) {
    if (fromParts[i] !== toParts[i]) {
      samePartsLength = i;
      break;
    }
  }

  var outputParts = [];
  for (var i = samePartsLength; i < fromParts.length; i++) {
    outputParts.push('..');
  }

  outputParts = outputParts.concat(toParts.slice(samePartsLength));

  return outputParts.join('/');
};

exports.sep = '/';
exports.delimiter = ':';

exports.dirname = function (path) {
  if (typeof path !== 'string') path = path + '';
  if (path.length === 0) return '.';
  var code = path.charCodeAt(0);
  var hasRoot = code === 47 /*/*/;
  var end = -1;
  var matchedSlash = true;
  for (var i = path.length - 1; i >= 1; --i) {
    code = path.charCodeAt(i);
    if (code === 47 /*/*/) {
        if (!matchedSlash) {
          end = i;
          break;
        }
      } else {
      // We saw the first non-path separator
      matchedSlash = false;
    }
  }

  if (end === -1) return hasRoot ? '/' : '.';
  if (hasRoot && end === 1) {
    // return '//';
    // Backwards-compat fix:
    return '/';
  }
  return path.slice(0, end);
};

function basename(path) {
  if (typeof path !== 'string') path = path + '';

  var start = 0;
  var end = -1;
  var matchedSlash = true;
  var i;

  for (i = path.length - 1; i >= 0; --i) {
    if (path.charCodeAt(i) === 47 /*/*/) {
        // If we reached a path separator that was not part of a set of path
        // separators at the end of the string, stop now
        if (!matchedSlash) {
          start = i + 1;
          break;
        }
      } else if (end === -1) {
      // We saw the first non-path separator, mark this as the end of our
      // path component
      matchedSlash = false;
      end = i + 1;
    }
  }

  if (end === -1) return '';
  return path.slice(start, end);
}

// Uses a mixed approach for backwards-compatibility, as ext behavior changed
// in new Node.js versions, so only basename() above is backported here
exports.basename = function (path, ext) {
  var f = basename(path);
  if (ext && f.substr(-1 * ext.length) === ext) {
    f = f.substr(0, f.length - ext.length);
  }
  return f;
};

exports.extname = function (path) {
  if (typeof path !== 'string') path = path + '';
  var startDot = -1;
  var startPart = 0;
  var end = -1;
  var matchedSlash = true;
  // Track the state of characters (if any) we see before our first dot and
  // after any path separator we find
  var preDotState = 0;
  for (var i = path.length - 1; i >= 0; --i) {
    var code = path.charCodeAt(i);
    if (code === 47 /*/*/) {
        // If we reached a path separator that was not part of a set of path
        // separators at the end of the string, stop now
        if (!matchedSlash) {
          startPart = i + 1;
          break;
        }
        continue;
      }
    if (end === -1) {
      // We saw the first non-path separator, mark this as the end of our
      // extension
      matchedSlash = false;
      end = i + 1;
    }
    if (code === 46 /*.*/) {
        // If this is our first dot, mark it as the start of our extension
        if (startDot === -1)
          startDot = i;
        else if (preDotState !== 1)
          preDotState = 1;
    } else if (startDot !== -1) {
      // We saw a non-dot and non-path separator before our dot, so we should
      // have a good chance at having a non-empty extension
      preDotState = -1;
    }
  }

  if (startDot === -1 || end === -1 ||
      // We saw a non-dot character immediately before the dot
      preDotState === 0 ||
      // The (right-most) trimmed path component is exactly '..'
      preDotState === 1 && startDot === end - 1 && startDot === startPart + 1) {
    return '';
  }
  return path.slice(startDot, end);
};

function filter (xs, f) {
    if (xs.filter) return xs.filter(f);
    var res = [];
    for (var i = 0; i < xs.length; i++) {
        if (f(xs[i], i, xs)) res.push(xs[i]);
    }
    return res;
}

// String.prototype.substr - negative index don't work in IE8
var substr = 'ab'.substr(-1) === 'b'
    ? function (str, start, len) { return str.substr(start, len) }
    : function (str, start, len) {
        if (start < 0) start = str.length + start;
        return str.substr(start, len);
    }
;

}).call(this,require('_process'))
},{"_process":14}],14:[function(require,module,exports){
// shim for using process in browser
var process = module.exports = {};

// cached from whatever global is present so that test runners that stub it
// don't break things.  But we need to wrap it in a try catch in case it is
// wrapped in strict mode code which doesn't define any globals.  It's inside a
// function because try/catches deoptimize in certain engines.

var cachedSetTimeout;
var cachedClearTimeout;

function defaultSetTimout() {
    throw new Error('setTimeout has not been defined');
}
function defaultClearTimeout () {
    throw new Error('clearTimeout has not been defined');
}
(function () {
    try {
        if (typeof setTimeout === 'function') {
            cachedSetTimeout = setTimeout;
        } else {
            cachedSetTimeout = defaultSetTimout;
        }
    } catch (e) {
        cachedSetTimeout = defaultSetTimout;
    }
    try {
        if (typeof clearTimeout === 'function') {
            cachedClearTimeout = clearTimeout;
        } else {
            cachedClearTimeout = defaultClearTimeout;
        }
    } catch (e) {
        cachedClearTimeout = defaultClearTimeout;
    }
} ())
function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
        //normal enviroments in sane situations
        return setTimeout(fun, 0);
    }
    // if setTimeout wasn't available but was latter defined
    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
        cachedSetTimeout = setTimeout;
        return setTimeout(fun, 0);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedSetTimeout(fun, 0);
    } catch(e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
            return cachedSetTimeout.call(null, fun, 0);
        } catch(e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
            return cachedSetTimeout.call(this, fun, 0);
        }
    }


}
function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
        //normal enviroments in sane situations
        return clearTimeout(marker);
    }
    // if clearTimeout wasn't available but was latter defined
    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
        cachedClearTimeout = clearTimeout;
        return clearTimeout(marker);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedClearTimeout(marker);
    } catch (e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
            return cachedClearTimeout.call(null, marker);
        } catch (e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
            // Some versions of I.E. have different rules for clearTimeout vs setTimeout
            return cachedClearTimeout.call(this, marker);
        }
    }



}
var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;

function cleanUpNextTick() {
    if (!draining || !currentQueue) {
        return;
    }
    draining = false;
    if (currentQueue.length) {
        queue = currentQueue.concat(queue);
    } else {
        queueIndex = -1;
    }
    if (queue.length) {
        drainQueue();
    }
}

function drainQueue() {
    if (draining) {
        return;
    }
    var timeout = runTimeout(cleanUpNextTick);
    draining = true;

    var len = queue.length;
    while(len) {
        currentQueue = queue;
        queue = [];
        while (++queueIndex < len) {
            if (currentQueue) {
                currentQueue[queueIndex].run();
            }
        }
        queueIndex = -1;
        len = queue.length;
    }
    currentQueue = null;
    draining = false;
    runClearTimeout(timeout);
}

process.nextTick = function (fun) {
    var args = new Array(arguments.length - 1);
    if (arguments.length > 1) {
        for (var i = 1; i < arguments.length; i++) {
            args[i - 1] = arguments[i];
        }
    }
    queue.push(new Item(fun, args));
    if (queue.length === 1 && !draining) {
        runTimeout(drainQueue);
    }
};

// v8 likes predictible objects
function Item(fun, array) {
    this.fun = fun;
    this.array = array;
}
Item.prototype.run = function () {
    this.fun.apply(null, this.array);
};
process.title = 'browser';
process.browser = true;
process.env = {};
process.argv = [];
process.version = ''; // empty string to avoid regexp issues
process.versions = {};

function noop() {}

process.on = noop;
process.addListener = noop;
process.once = noop;
process.off = noop;
process.removeListener = noop;
process.removeAllListeners = noop;
process.emit = noop;
process.prependListener = noop;
process.prependOnceListener = noop;

process.listeners = function (name) { return [] }

process.binding = function (name) {
    throw new Error('process.binding is not supported');
};

process.cwd = function () { return '/' };
process.chdir = function (dir) {
    throw new Error('process.chdir is not supported');
};
process.umask = function() { return 0; };

},{}],15:[function(require,module,exports){
var unparse = require('escodegen').generate;

module.exports = function (ast, vars) {
    if (!vars) vars = {};
    var FAIL = {};
    
    var result = (function walk (node, scopeVars) {
        if (node.type === 'Literal') {
            return node.value;
        }
        else if (node.type === 'UnaryExpression'){
            var val = walk(node.argument)
            if (node.operator === '+') return +val
            if (node.operator === '-') return -val
            if (node.operator === '~') return ~val
            if (node.operator === '!') return !val
            return FAIL
        }
        else if (node.type === 'ArrayExpression') {
            var xs = [];
            for (var i = 0, l = node.elements.length; i < l; i++) {
                var x = walk(node.elements[i]);
                if (x === FAIL) return FAIL;
                xs.push(x);
            }
            return xs;
        }
        else if (node.type === 'ObjectExpression') {
            var obj = {};
            for (var i = 0; i < node.properties.length; i++) {
                var prop = node.properties[i];
                var value = prop.value === null
                    ? prop.value
                    : walk(prop.value)
                ;
                if (value === FAIL) return FAIL;
                obj[prop.key.value || prop.key.name] = value;
            }
            return obj;
        }
        else if (node.type === 'BinaryExpression' ||
                 node.type === 'LogicalExpression') {
            var l = walk(node.left);
            if (l === FAIL) return FAIL;
            var r = walk(node.right);
            if (r === FAIL) return FAIL;
            
            var op = node.operator;
            if (op === '==') return l == r;
            if (op === '===') return l === r;
            if (op === '!=') return l != r;
            if (op === '!==') return l !== r;
            if (op === '+') return l + r;
            if (op === '-') return l - r;
            if (op === '*') return l * r;
            if (op === '/') return l / r;
            if (op === '%') return l % r;
            if (op === '<') return l < r;
            if (op === '<=') return l <= r;
            if (op === '>') return l > r;
            if (op === '>=') return l >= r;
            if (op === '|') return l | r;
            if (op === '&') return l & r;
            if (op === '^') return l ^ r;
            if (op === '&&') return l && r;
            if (op === '||') return l || r;
            
            return FAIL;
        }
        else if (node.type === 'Identifier') {
            if ({}.hasOwnProperty.call(vars, node.name)) {
                return vars[node.name];
            }
            else return FAIL;
        }
        else if (node.type === 'ThisExpression') {
            if ({}.hasOwnProperty.call(vars, 'this')) {
                return vars['this'];
            }
            else return FAIL;
        }
        else if (node.type === 'CallExpression') {
            var callee = walk(node.callee);
            if (callee === FAIL) return FAIL;
            if (typeof callee !== 'function') return FAIL;
            
            var ctx = node.callee.object ? walk(node.callee.object) : FAIL;
            if (ctx === FAIL) ctx = null;

            var args = [];
            for (var i = 0, l = node.arguments.length; i < l; i++) {
                var x = walk(node.arguments[i]);
                if (x === FAIL) return FAIL;
                args.push(x);
            }
            return callee.apply(ctx, args);
        }
        else if (node.type === 'MemberExpression') {
            var obj = walk(node.object);
            // do not allow access to methods on Function 
            if((obj === FAIL) || (typeof obj == 'function')){
                return FAIL;
            }
            if (node.property.type === 'Identifier') {
                return obj[node.property.name];
            }
            var prop = walk(node.property);
            if (prop === FAIL) return FAIL;
            return obj[prop];
        }
        else if (node.type === 'ConditionalExpression') {
            var val = walk(node.test)
            if (val === FAIL) return FAIL;
            return val ? walk(node.consequent) : walk(node.alternate)
        }
        else if (node.type === 'ExpressionStatement') {
            var val = walk(node.expression)
            if (val === FAIL) return FAIL;
            return val;
        }
        else if (node.type === 'ReturnStatement') {
            return walk(node.argument)
        }
        else if (node.type === 'FunctionExpression') {
            
            var bodies = node.body.body;
            
            // Create a "scope" for our arguments
            var oldVars = {};
            Object.keys(vars).forEach(function(element){
                oldVars[element] = vars[element];
            })

            for(var i=0; i<node.params.length; i++){
                var key = node.params[i];
                if(key.type == 'Identifier'){
                  vars[key.name] = null;
                }
                else return FAIL;
            }
            for(var i in bodies){
                if(walk(bodies[i]) === FAIL){
                    return FAIL;
                }
            }
            // restore the vars and scope after we walk
            vars = oldVars;
            
            var keys = Object.keys(vars);
            var vals = keys.map(function(key) {
                return vars[key];
            });
            return Function(keys.join(', '), 'return ' + unparse(node)).apply(null, vals);
        }
        else if (node.type === 'TemplateLiteral') {
            var str = '';
            for (var i = 0; i < node.expressions.length; i++) {
                str += walk(node.quasis[i]);
                str += walk(node.expressions[i]);
            }
            str += walk(node.quasis[i]);
            return str;
        }
        else if (node.type === 'TaggedTemplateExpression') {
            var tag = walk(node.tag);
            var quasi = node.quasi;
            var strings = quasi.quasis.map(walk);
            var values = quasi.expressions.map(walk);
            return tag.apply(null, [strings].concat(values));
        }
        else if (node.type === 'TemplateElement') {
            return node.value.cooked;
        }
        else return FAIL;
    })(ast);
    
    return result === FAIL ? undefined : result;
};

},{"escodegen":12}],16:[function(require,module,exports){
//     Underscore.js 1.7.0
//     http://underscorejs.org
//     (c) 2009-2014 Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
//     Underscore may be freely distributed under the MIT license.

(function() {

  // Baseline setup
  // --------------

  // Establish the root object, `window` in the browser, or `exports` on the server.
  var root = this;

  // Save the previous value of the `_` variable.
  var previousUnderscore = root._;

  // Save bytes in the minified (but not gzipped) version:
  var ArrayProto = Array.prototype, ObjProto = Object.prototype, FuncProto = Function.prototype;

  // Create quick reference variables for speed access to core prototypes.
  var
    push             = ArrayProto.push,
    slice            = ArrayProto.slice,
    concat           = ArrayProto.concat,
    toString         = ObjProto.toString,
    hasOwnProperty   = ObjProto.hasOwnProperty;

  // All **ECMAScript 5** native function implementations that we hope to use
  // are declared here.
  var
    nativeIsArray      = Array.isArray,
    nativeKeys         = Object.keys,
    nativeBind         = FuncProto.bind;

  // Create a safe reference to the Underscore object for use below.
  var _ = function(obj) {
    if (obj instanceof _) return obj;
    if (!(this instanceof _)) return new _(obj);
    this._wrapped = obj;
  };

  // Export the Underscore object for **Node.js**, with
  // backwards-compatibility for the old `require()` API. If we're in
  // the browser, add `_` as a global object.
  if (typeof exports !== 'undefined') {
    if (typeof module !== 'undefined' && module.exports) {
      exports = module.exports = _;
    }
    exports._ = _;
  } else {
    root._ = _;
  }

  // Current version.
  _.VERSION = '1.7.0';

  // Internal function that returns an efficient (for current engines) version
  // of the passed-in callback, to be repeatedly applied in other Underscore
  // functions.
  var createCallback = function(func, context, argCount) {
    if (context === void 0) return func;
    switch (argCount == null ? 3 : argCount) {
      case 1: return function(value) {
        return func.call(context, value);
      };
      case 2: return function(value, other) {
        return func.call(context, value, other);
      };
      case 3: return function(value, index, collection) {
        return func.call(context, value, index, collection);
      };
      case 4: return function(accumulator, value, index, collection) {
        return func.call(context, accumulator, value, index, collection);
      };
    }
    return function() {
      return func.apply(context, arguments);
    };
  };

  // A mostly-internal function to generate callbacks that can be applied
  // to each element in a collection, returning the desired result — either
  // identity, an arbitrary callback, a property matcher, or a property accessor.
  _.iteratee = function(value, context, argCount) {
    if (value == null) return _.identity;
    if (_.isFunction(value)) return createCallback(value, context, argCount);
    if (_.isObject(value)) return _.matches(value);
    return _.property(value);
  };

  // Collection Functions
  // --------------------

  // The cornerstone, an `each` implementation, aka `forEach`.
  // Handles raw objects in addition to array-likes. Treats all
  // sparse array-likes as if they were dense.
  _.each = _.forEach = function(obj, iteratee, context) {
    if (obj == null) return obj;
    iteratee = createCallback(iteratee, context);
    var i, length = obj.length;
    if (length === +length) {
      for (i = 0; i < length; i++) {
        iteratee(obj[i], i, obj);
      }
    } else {
      var keys = _.keys(obj);
      for (i = 0, length = keys.length; i < length; i++) {
        iteratee(obj[keys[i]], keys[i], obj);
      }
    }
    return obj;
  };

  // Return the results of applying the iteratee to each element.
  _.map = _.collect = function(obj, iteratee, context) {
    if (obj == null) return [];
    iteratee = _.iteratee(iteratee, context);
    var keys = obj.length !== +obj.length && _.keys(obj),
        length = (keys || obj).length,
        results = Array(length),
        currentKey;
    for (var index = 0; index < length; index++) {
      currentKey = keys ? keys[index] : index;
      results[index] = iteratee(obj[currentKey], currentKey, obj);
    }
    return results;
  };

  var reduceError = 'Reduce of empty array with no initial value';

  // **Reduce** builds up a single result from a list of values, aka `inject`,
  // or `foldl`.
  _.reduce = _.foldl = _.inject = function(obj, iteratee, memo, context) {
    if (obj == null) obj = [];
    iteratee = createCallback(iteratee, context, 4);
    var keys = obj.length !== +obj.length && _.keys(obj),
        length = (keys || obj).length,
        index = 0, currentKey;
    if (arguments.length < 3) {
      if (!length) throw new TypeError(reduceError);
      memo = obj[keys ? keys[index++] : index++];
    }
    for (; index < length; index++) {
      currentKey = keys ? keys[index] : index;
      memo = iteratee(memo, obj[currentKey], currentKey, obj);
    }
    return memo;
  };

  // The right-associative version of reduce, also known as `foldr`.
  _.reduceRight = _.foldr = function(obj, iteratee, memo, context) {
    if (obj == null) obj = [];
    iteratee = createCallback(iteratee, context, 4);
    var keys = obj.length !== + obj.length && _.keys(obj),
        index = (keys || obj).length,
        currentKey;
    if (arguments.length < 3) {
      if (!index) throw new TypeError(reduceError);
      memo = obj[keys ? keys[--index] : --index];
    }
    while (index--) {
      currentKey = keys ? keys[index] : index;
      memo = iteratee(memo, obj[currentKey], currentKey, obj);
    }
    return memo;
  };

  // Return the first value which passes a truth test. Aliased as `detect`.
  _.find = _.detect = function(obj, predicate, context) {
    var result;
    predicate = _.iteratee(predicate, context);
    _.some(obj, function(value, index, list) {
      if (predicate(value, index, list)) {
        result = value;
        return true;
      }
    });
    return result;
  };

  // Return all the elements that pass a truth test.
  // Aliased as `select`.
  _.filter = _.select = function(obj, predicate, context) {
    var results = [];
    if (obj == null) return results;
    predicate = _.iteratee(predicate, context);
    _.each(obj, function(value, index, list) {
      if (predicate(value, index, list)) results.push(value);
    });
    return results;
  };

  // Return all the elements for which a truth test fails.
  _.reject = function(obj, predicate, context) {
    return _.filter(obj, _.negate(_.iteratee(predicate)), context);
  };

  // Determine whether all of the elements match a truth test.
  // Aliased as `all`.
  _.every = _.all = function(obj, predicate, context) {
    if (obj == null) return true;
    predicate = _.iteratee(predicate, context);
    var keys = obj.length !== +obj.length && _.keys(obj),
        length = (keys || obj).length,
        index, currentKey;
    for (index = 0; index < length; index++) {
      currentKey = keys ? keys[index] : index;
      if (!predicate(obj[currentKey], currentKey, obj)) return false;
    }
    return true;
  };

  // Determine if at least one element in the object matches a truth test.
  // Aliased as `any`.
  _.some = _.any = function(obj, predicate, context) {
    if (obj == null) return false;
    predicate = _.iteratee(predicate, context);
    var keys = obj.length !== +obj.length && _.keys(obj),
        length = (keys || obj).length,
        index, currentKey;
    for (index = 0; index < length; index++) {
      currentKey = keys ? keys[index] : index;
      if (predicate(obj[currentKey], currentKey, obj)) return true;
    }
    return false;
  };

  // Determine if the array or object contains a given value (using `===`).
  // Aliased as `include`.
  _.contains = _.include = function(obj, target) {
    if (obj == null) return false;
    if (obj.length !== +obj.length) obj = _.values(obj);
    return _.indexOf(obj, target) >= 0;
  };

  // Invoke a method (with arguments) on every item in a collection.
  _.invoke = function(obj, method) {
    var args = slice.call(arguments, 2);
    var isFunc = _.isFunction(method);
    return _.map(obj, function(value) {
      return (isFunc ? method : value[method]).apply(value, args);
    });
  };

  // Convenience version of a common use case of `map`: fetching a property.
  _.pluck = function(obj, key) {
    return _.map(obj, _.property(key));
  };

  // Convenience version of a common use case of `filter`: selecting only objects
  // containing specific `key:value` pairs.
  _.where = function(obj, attrs) {
    return _.filter(obj, _.matches(attrs));
  };

  // Convenience version of a common use case of `find`: getting the first object
  // containing specific `key:value` pairs.
  _.findWhere = function(obj, attrs) {
    return _.find(obj, _.matches(attrs));
  };

  // Return the maximum element (or element-based computation).
  _.max = function(obj, iteratee, context) {
    var result = -Infinity, lastComputed = -Infinity,
        value, computed;
    if (iteratee == null && obj != null) {
      obj = obj.length === +obj.length ? obj : _.values(obj);
      for (var i = 0, length = obj.length; i < length; i++) {
        value = obj[i];
        if (value > result) {
          result = value;
        }
      }
    } else {
      iteratee = _.iteratee(iteratee, context);
      _.each(obj, function(value, index, list) {
        computed = iteratee(value, index, list);
        if (computed > lastComputed || computed === -Infinity && result === -Infinity) {
          result = value;
          lastComputed = computed;
        }
      });
    }
    return result;
  };

  // Return the minimum element (or element-based computation).
  _.min = function(obj, iteratee, context) {
    var result = Infinity, lastComputed = Infinity,
        value, computed;
    if (iteratee == null && obj != null) {
      obj = obj.length === +obj.length ? obj : _.values(obj);
      for (var i = 0, length = obj.length; i < length; i++) {
        value = obj[i];
        if (value < result) {
          result = value;
        }
      }
    } else {
      iteratee = _.iteratee(iteratee, context);
      _.each(obj, function(value, index, list) {
        computed = iteratee(value, index, list);
        if (computed < lastComputed || computed === Infinity && result === Infinity) {
          result = value;
          lastComputed = computed;
        }
      });
    }
    return result;
  };

  // Shuffle a collection, using the modern version of the
  // [Fisher-Yates shuffle](http://en.wikipedia.org/wiki/Fisher–Yates_shuffle).
  _.shuffle = function(obj) {
    var set = obj && obj.length === +obj.length ? obj : _.values(obj);
    var length = set.length;
    var shuffled = Array(length);
    for (var index = 0, rand; index < length; index++) {
      rand = _.random(0, index);
      if (rand !== index) shuffled[index] = shuffled[rand];
      shuffled[rand] = set[index];
    }
    return shuffled;
  };

  // Sample **n** random values from a collection.
  // If **n** is not specified, returns a single random element.
  // The internal `guard` argument allows it to work with `map`.
  _.sample = function(obj, n, guard) {
    if (n == null || guard) {
      if (obj.length !== +obj.length) obj = _.values(obj);
      return obj[_.random(obj.length - 1)];
    }
    return _.shuffle(obj).slice(0, Math.max(0, n));
  };

  // Sort the object's values by a criterion produced by an iteratee.
  _.sortBy = function(obj, iteratee, context) {
    iteratee = _.iteratee(iteratee, context);
    return _.pluck(_.map(obj, function(value, index, list) {
      return {
        value: value,
        index: index,
        criteria: iteratee(value, index, list)
      };
    }).sort(function(left, right) {
      var a = left.criteria;
      var b = right.criteria;
      if (a !== b) {
        if (a > b || a === void 0) return 1;
        if (a < b || b === void 0) return -1;
      }
      return left.index - right.index;
    }), 'value');
  };

  // An internal function used for aggregate "group by" operations.
  var group = function(behavior) {
    return function(obj, iteratee, context) {
      var result = {};
      iteratee = _.iteratee(iteratee, context);
      _.each(obj, function(value, index) {
        var key = iteratee(value, index, obj);
        behavior(result, value, key);
      });
      return result;
    };
  };

  // Groups the object's values by a criterion. Pass either a string attribute
  // to group by, or a function that returns the criterion.
  _.groupBy = group(function(result, value, key) {
    if (_.has(result, key)) result[key].push(value); else result[key] = [value];
  });

  // Indexes the object's values by a criterion, similar to `groupBy`, but for
  // when you know that your index values will be unique.
  _.indexBy = group(function(result, value, key) {
    result[key] = value;
  });

  // Counts instances of an object that group by a certain criterion. Pass
  // either a string attribute to count by, or a function that returns the
  // criterion.
  _.countBy = group(function(result, value, key) {
    if (_.has(result, key)) result[key]++; else result[key] = 1;
  });

  // Use a comparator function to figure out the smallest index at which
  // an object should be inserted so as to maintain order. Uses binary search.
  _.sortedIndex = function(array, obj, iteratee, context) {
    iteratee = _.iteratee(iteratee, context, 1);
    var value = iteratee(obj);
    var low = 0, high = array.length;
    while (low < high) {
      var mid = low + high >>> 1;
      if (iteratee(array[mid]) < value) low = mid + 1; else high = mid;
    }
    return low;
  };

  // Safely create a real, live array from anything iterable.
  _.toArray = function(obj) {
    if (!obj) return [];
    if (_.isArray(obj)) return slice.call(obj);
    if (obj.length === +obj.length) return _.map(obj, _.identity);
    return _.values(obj);
  };

  // Return the number of elements in an object.
  _.size = function(obj) {
    if (obj == null) return 0;
    return obj.length === +obj.length ? obj.length : _.keys(obj).length;
  };

  // Split a collection into two arrays: one whose elements all satisfy the given
  // predicate, and one whose elements all do not satisfy the predicate.
  _.partition = function(obj, predicate, context) {
    predicate = _.iteratee(predicate, context);
    var pass = [], fail = [];
    _.each(obj, function(value, key, obj) {
      (predicate(value, key, obj) ? pass : fail).push(value);
    });
    return [pass, fail];
  };

  // Array Functions
  // ---------------

  // Get the first element of an array. Passing **n** will return the first N
  // values in the array. Aliased as `head` and `take`. The **guard** check
  // allows it to work with `_.map`.
  _.first = _.head = _.take = function(array, n, guard) {
    if (array == null) return void 0;
    if (n == null || guard) return array[0];
    if (n < 0) return [];
    return slice.call(array, 0, n);
  };

  // Returns everything but the last entry of the array. Especially useful on
  // the arguments object. Passing **n** will return all the values in
  // the array, excluding the last N. The **guard** check allows it to work with
  // `_.map`.
  _.initial = function(array, n, guard) {
    return slice.call(array, 0, Math.max(0, array.length - (n == null || guard ? 1 : n)));
  };

  // Get the last element of an array. Passing **n** will return the last N
  // values in the array. The **guard** check allows it to work with `_.map`.
  _.last = function(array, n, guard) {
    if (array == null) return void 0;
    if (n == null || guard) return array[array.length - 1];
    return slice.call(array, Math.max(array.length - n, 0));
  };

  // Returns everything but the first entry of the array. Aliased as `tail` and `drop`.
  // Especially useful on the arguments object. Passing an **n** will return
  // the rest N values in the array. The **guard**
  // check allows it to work with `_.map`.
  _.rest = _.tail = _.drop = function(array, n, guard) {
    return slice.call(array, n == null || guard ? 1 : n);
  };

  // Trim out all falsy values from an array.
  _.compact = function(array) {
    return _.filter(array, _.identity);
  };

  // Internal implementation of a recursive `flatten` function.
  var flatten = function(input, shallow, strict, output) {
    if (shallow && _.every(input, _.isArray)) {
      return concat.apply(output, input);
    }
    for (var i = 0, length = input.length; i < length; i++) {
      var value = input[i];
      if (!_.isArray(value) && !_.isArguments(value)) {
        if (!strict) output.push(value);
      } else if (shallow) {
        push.apply(output, value);
      } else {
        flatten(value, shallow, strict, output);
      }
    }
    return output;
  };

  // Flatten out an array, either recursively (by default), or just one level.
  _.flatten = function(array, shallow) {
    return flatten(array, shallow, false, []);
  };

  // Return a version of the array that does not contain the specified value(s).
  _.without = function(array) {
    return _.difference(array, slice.call(arguments, 1));
  };

  // Produce a duplicate-free version of the array. If the array has already
  // been sorted, you have the option of using a faster algorithm.
  // Aliased as `unique`.
  _.uniq = _.unique = function(array, isSorted, iteratee, context) {
    if (array == null) return [];
    if (!_.isBoolean(isSorted)) {
      context = iteratee;
      iteratee = isSorted;
      isSorted = false;
    }
    if (iteratee != null) iteratee = _.iteratee(iteratee, context);
    var result = [];
    var seen = [];
    for (var i = 0, length = array.length; i < length; i++) {
      var value = array[i];
      if (isSorted) {
        if (!i || seen !== value) result.push(value);
        seen = value;
      } else if (iteratee) {
        var computed = iteratee(value, i, array);
        if (_.indexOf(seen, computed) < 0) {
          seen.push(computed);
          result.push(value);
        }
      } else if (_.indexOf(result, value) < 0) {
        result.push(value);
      }
    }
    return result;
  };

  // Produce an array that contains the union: each distinct element from all of
  // the passed-in arrays.
  _.union = function() {
    return _.uniq(flatten(arguments, true, true, []));
  };

  // Produce an array that contains every item shared between all the
  // passed-in arrays.
  _.intersection = function(array) {
    if (array == null) return [];
    var result = [];
    var argsLength = arguments.length;
    for (var i = 0, length = array.length; i < length; i++) {
      var item = array[i];
      if (_.contains(result, item)) continue;
      for (var j = 1; j < argsLength; j++) {
        if (!_.contains(arguments[j], item)) break;
      }
      if (j === argsLength) result.push(item);
    }
    return result;
  };

  // Take the difference between one array and a number of other arrays.
  // Only the elements present in just the first array will remain.
  _.difference = function(array) {
    var rest = flatten(slice.call(arguments, 1), true, true, []);
    return _.filter(array, function(value){
      return !_.contains(rest, value);
    });
  };

  // Zip together multiple lists into a single array -- elements that share
  // an index go together.
  _.zip = function(array) {
    if (array == null) return [];
    var length = _.max(arguments, 'length').length;
    var results = Array(length);
    for (var i = 0; i < length; i++) {
      results[i] = _.pluck(arguments, i);
    }
    return results;
  };

  // Converts lists into objects. Pass either a single array of `[key, value]`
  // pairs, or two parallel arrays of the same length -- one of keys, and one of
  // the corresponding values.
  _.object = function(list, values) {
    if (list == null) return {};
    var result = {};
    for (var i = 0, length = list.length; i < length; i++) {
      if (values) {
        result[list[i]] = values[i];
      } else {
        result[list[i][0]] = list[i][1];
      }
    }
    return result;
  };

  // Return the position of the first occurrence of an item in an array,
  // or -1 if the item is not included in the array.
  // If the array is large and already in sort order, pass `true`
  // for **isSorted** to use binary search.
  _.indexOf = function(array, item, isSorted) {
    if (array == null) return -1;
    var i = 0, length = array.length;
    if (isSorted) {
      if (typeof isSorted == 'number') {
        i = isSorted < 0 ? Math.max(0, length + isSorted) : isSorted;
      } else {
        i = _.sortedIndex(array, item);
        return array[i] === item ? i : -1;
      }
    }
    for (; i < length; i++) if (array[i] === item) return i;
    return -1;
  };

  _.lastIndexOf = function(array, item, from) {
    if (array == null) return -1;
    var idx = array.length;
    if (typeof from == 'number') {
      idx = from < 0 ? idx + from + 1 : Math.min(idx, from + 1);
    }
    while (--idx >= 0) if (array[idx] === item) return idx;
    return -1;
  };

  // Generate an integer Array containing an arithmetic progression. A port of
  // the native Python `range()` function. See
  // [the Python documentation](http://docs.python.org/library/functions.html#range).
  _.range = function(start, stop, step) {
    if (arguments.length <= 1) {
      stop = start || 0;
      start = 0;
    }
    step = step || 1;

    var length = Math.max(Math.ceil((stop - start) / step), 0);
    var range = Array(length);

    for (var idx = 0; idx < length; idx++, start += step) {
      range[idx] = start;
    }

    return range;
  };

  // Function (ahem) Functions
  // ------------------

  // Reusable constructor function for prototype setting.
  var Ctor = function(){};

  // Create a function bound to a given object (assigning `this`, and arguments,
  // optionally). Delegates to **ECMAScript 5**'s native `Function.bind` if
  // available.
  _.bind = function(func, context) {
    var args, bound;
    if (nativeBind && func.bind === nativeBind) return nativeBind.apply(func, slice.call(arguments, 1));
    if (!_.isFunction(func)) throw new TypeError('Bind must be called on a function');
    args = slice.call(arguments, 2);
    bound = function() {
      if (!(this instanceof bound)) return func.apply(context, args.concat(slice.call(arguments)));
      Ctor.prototype = func.prototype;
      var self = new Ctor;
      Ctor.prototype = null;
      var result = func.apply(self, args.concat(slice.call(arguments)));
      if (_.isObject(result)) return result;
      return self;
    };
    return bound;
  };

  // Partially apply a function by creating a version that has had some of its
  // arguments pre-filled, without changing its dynamic `this` context. _ acts
  // as a placeholder, allowing any combination of arguments to be pre-filled.
  _.partial = function(func) {
    var boundArgs = slice.call(arguments, 1);
    return function() {
      var position = 0;
      var args = boundArgs.slice();
      for (var i = 0, length = args.length; i < length; i++) {
        if (args[i] === _) args[i] = arguments[position++];
      }
      while (position < arguments.length) args.push(arguments[position++]);
      return func.apply(this, args);
    };
  };

  // Bind a number of an object's methods to that object. Remaining arguments
  // are the method names to be bound. Useful for ensuring that all callbacks
  // defined on an object belong to it.
  _.bindAll = function(obj) {
    var i, length = arguments.length, key;
    if (length <= 1) throw new Error('bindAll must be passed function names');
    for (i = 1; i < length; i++) {
      key = arguments[i];
      obj[key] = _.bind(obj[key], obj);
    }
    return obj;
  };

  // Memoize an expensive function by storing its results.
  _.memoize = function(func, hasher) {
    var memoize = function(key) {
      var cache = memoize.cache;
      var address = hasher ? hasher.apply(this, arguments) : key;
      if (!_.has(cache, address)) cache[address] = func.apply(this, arguments);
      return cache[address];
    };
    memoize.cache = {};
    return memoize;
  };

  // Delays a function for the given number of milliseconds, and then calls
  // it with the arguments supplied.
  _.delay = function(func, wait) {
    var args = slice.call(arguments, 2);
    return setTimeout(function(){
      return func.apply(null, args);
    }, wait);
  };

  // Defers a function, scheduling it to run after the current call stack has
  // cleared.
  _.defer = function(func) {
    return _.delay.apply(_, [func, 1].concat(slice.call(arguments, 1)));
  };

  // Returns a function, that, when invoked, will only be triggered at most once
  // during a given window of time. Normally, the throttled function will run
  // as much as it can, without ever going more than once per `wait` duration;
  // but if you'd like to disable the execution on the leading edge, pass
  // `{leading: false}`. To disable execution on the trailing edge, ditto.
  _.throttle = function(func, wait, options) {
    var context, args, result;
    var timeout = null;
    var previous = 0;
    if (!options) options = {};
    var later = function() {
      previous = options.leading === false ? 0 : _.now();
      timeout = null;
      result = func.apply(context, args);
      if (!timeout) context = args = null;
    };
    return function() {
      var now = _.now();
      if (!previous && options.leading === false) previous = now;
      var remaining = wait - (now - previous);
      context = this;
      args = arguments;
      if (remaining <= 0 || remaining > wait) {
        clearTimeout(timeout);
        timeout = null;
        previous = now;
        result = func.apply(context, args);
        if (!timeout) context = args = null;
      } else if (!timeout && options.trailing !== false) {
        timeout = setTimeout(later, remaining);
      }
      return result;
    };
  };

  // Returns a function, that, as long as it continues to be invoked, will not
  // be triggered. The function will be called after it stops being called for
  // N milliseconds. If `immediate` is passed, trigger the function on the
  // leading edge, instead of the trailing.
  _.debounce = function(func, wait, immediate) {
    var timeout, args, context, timestamp, result;

    var later = function() {
      var last = _.now() - timestamp;

      if (last < wait && last > 0) {
        timeout = setTimeout(later, wait - last);
      } else {
        timeout = null;
        if (!immediate) {
          result = func.apply(context, args);
          if (!timeout) context = args = null;
        }
      }
    };

    return function() {
      context = this;
      args = arguments;
      timestamp = _.now();
      var callNow = immediate && !timeout;
      if (!timeout) timeout = setTimeout(later, wait);
      if (callNow) {
        result = func.apply(context, args);
        context = args = null;
      }

      return result;
    };
  };

  // Returns the first function passed as an argument to the second,
  // allowing you to adjust arguments, run code before and after, and
  // conditionally execute the original function.
  _.wrap = function(func, wrapper) {
    return _.partial(wrapper, func);
  };

  // Returns a negated version of the passed-in predicate.
  _.negate = function(predicate) {
    return function() {
      return !predicate.apply(this, arguments);
    };
  };

  // Returns a function that is the composition of a list of functions, each
  // consuming the return value of the function that follows.
  _.compose = function() {
    var args = arguments;
    var start = args.length - 1;
    return function() {
      var i = start;
      var result = args[start].apply(this, arguments);
      while (i--) result = args[i].call(this, result);
      return result;
    };
  };

  // Returns a function that will only be executed after being called N times.
  _.after = function(times, func) {
    return function() {
      if (--times < 1) {
        return func.apply(this, arguments);
      }
    };
  };

  // Returns a function that will only be executed before being called N times.
  _.before = function(times, func) {
    var memo;
    return function() {
      if (--times > 0) {
        memo = func.apply(this, arguments);
      } else {
        func = null;
      }
      return memo;
    };
  };

  // Returns a function that will be executed at most one time, no matter how
  // often you call it. Useful for lazy initialization.
  _.once = _.partial(_.before, 2);

  // Object Functions
  // ----------------

  // Retrieve the names of an object's properties.
  // Delegates to **ECMAScript 5**'s native `Object.keys`
  _.keys = function(obj) {
    if (!_.isObject(obj)) return [];
    if (nativeKeys) return nativeKeys(obj);
    var keys = [];
    for (var key in obj) if (_.has(obj, key)) keys.push(key);
    return keys;
  };

  // Retrieve the values of an object's properties.
  _.values = function(obj) {
    var keys = _.keys(obj);
    var length = keys.length;
    var values = Array(length);
    for (var i = 0; i < length; i++) {
      values[i] = obj[keys[i]];
    }
    return values;
  };

  // Convert an object into a list of `[key, value]` pairs.
  _.pairs = function(obj) {
    var keys = _.keys(obj);
    var length = keys.length;
    var pairs = Array(length);
    for (var i = 0; i < length; i++) {
      pairs[i] = [keys[i], obj[keys[i]]];
    }
    return pairs;
  };

  // Invert the keys and values of an object. The values must be serializable.
  _.invert = function(obj) {
    var result = {};
    var keys = _.keys(obj);
    for (var i = 0, length = keys.length; i < length; i++) {
      result[obj[keys[i]]] = keys[i];
    }
    return result;
  };

  // Return a sorted list of the function names available on the object.
  // Aliased as `methods`
  _.functions = _.methods = function(obj) {
    var names = [];
    for (var key in obj) {
      if (_.isFunction(obj[key])) names.push(key);
    }
    return names.sort();
  };

  // Extend a given object with all the properties in passed-in object(s).
  _.extend = function(obj) {
    if (!_.isObject(obj)) return obj;
    var source, prop;
    for (var i = 1, length = arguments.length; i < length; i++) {
      source = arguments[i];
      for (prop in source) {
        if (hasOwnProperty.call(source, prop)) {
            obj[prop] = source[prop];
        }
      }
    }
    return obj;
  };

  // Return a copy of the object only containing the whitelisted properties.
  _.pick = function(obj, iteratee, context) {
    var result = {}, key;
    if (obj == null) return result;
    if (_.isFunction(iteratee)) {
      iteratee = createCallback(iteratee, context);
      for (key in obj) {
        var value = obj[key];
        if (iteratee(value, key, obj)) result[key] = value;
      }
    } else {
      var keys = concat.apply([], slice.call(arguments, 1));
      obj = new Object(obj);
      for (var i = 0, length = keys.length; i < length; i++) {
        key = keys[i];
        if (key in obj) result[key] = obj[key];
      }
    }
    return result;
  };

   // Return a copy of the object without the blacklisted properties.
  _.omit = function(obj, iteratee, context) {
    if (_.isFunction(iteratee)) {
      iteratee = _.negate(iteratee);
    } else {
      var keys = _.map(concat.apply([], slice.call(arguments, 1)), String);
      iteratee = function(value, key) {
        return !_.contains(keys, key);
      };
    }
    return _.pick(obj, iteratee, context);
  };

  // Fill in a given object with default properties.
  _.defaults = function(obj) {
    if (!_.isObject(obj)) return obj;
    for (var i = 1, length = arguments.length; i < length; i++) {
      var source = arguments[i];
      for (var prop in source) {
        if (obj[prop] === void 0) obj[prop] = source[prop];
      }
    }
    return obj;
  };

  // Create a (shallow-cloned) duplicate of an object.
  _.clone = function(obj) {
    if (!_.isObject(obj)) return obj;
    return _.isArray(obj) ? obj.slice() : _.extend({}, obj);
  };

  // Invokes interceptor with the obj, and then returns obj.
  // The primary purpose of this method is to "tap into" a method chain, in
  // order to perform operations on intermediate results within the chain.
  _.tap = function(obj, interceptor) {
    interceptor(obj);
    return obj;
  };

  // Internal recursive comparison function for `isEqual`.
  var eq = function(a, b, aStack, bStack) {
    // Identical objects are equal. `0 === -0`, but they aren't identical.
    // See the [Harmony `egal` proposal](http://wiki.ecmascript.org/doku.php?id=harmony:egal).
    if (a === b) return a !== 0 || 1 / a === 1 / b;
    // A strict comparison is necessary because `null == undefined`.
    if (a == null || b == null) return a === b;
    // Unwrap any wrapped objects.
    if (a instanceof _) a = a._wrapped;
    if (b instanceof _) b = b._wrapped;
    // Compare `[[Class]]` names.
    var className = toString.call(a);
    if (className !== toString.call(b)) return false;
    switch (className) {
      // Strings, numbers, regular expressions, dates, and booleans are compared by value.
      case '[object RegExp]':
      // RegExps are coerced to strings for comparison (Note: '' + /a/i === '/a/i')
      case '[object String]':
        // Primitives and their corresponding object wrappers are equivalent; thus, `"5"` is
        // equivalent to `new String("5")`.
        return '' + a === '' + b;
      case '[object Number]':
        // `NaN`s are equivalent, but non-reflexive.
        // Object(NaN) is equivalent to NaN
        if (+a !== +a) return +b !== +b;
        // An `egal` comparison is performed for other numeric values.
        return +a === 0 ? 1 / +a === 1 / b : +a === +b;
      case '[object Date]':
      case '[object Boolean]':
        // Coerce dates and booleans to numeric primitive values. Dates are compared by their
        // millisecond representations. Note that invalid dates with millisecond representations
        // of `NaN` are not equivalent.
        return +a === +b;
    }
    if (typeof a != 'object' || typeof b != 'object') return false;
    // Assume equality for cyclic structures. The algorithm for detecting cyclic
    // structures is adapted from ES 5.1 section 15.12.3, abstract operation `JO`.
    var length = aStack.length;
    while (length--) {
      // Linear search. Performance is inversely proportional to the number of
      // unique nested structures.
      if (aStack[length] === a) return bStack[length] === b;
    }
    // Objects with different constructors are not equivalent, but `Object`s
    // from different frames are.
    var aCtor = a.constructor, bCtor = b.constructor;
    if (
      aCtor !== bCtor &&
      // Handle Object.create(x) cases
      'constructor' in a && 'constructor' in b &&
      !(_.isFunction(aCtor) && aCtor instanceof aCtor &&
        _.isFunction(bCtor) && bCtor instanceof bCtor)
    ) {
      return false;
    }
    // Add the first object to the stack of traversed objects.
    aStack.push(a);
    bStack.push(b);
    var size, result;
    // Recursively compare objects and arrays.
    if (className === '[object Array]') {
      // Compare array lengths to determine if a deep comparison is necessary.
      size = a.length;
      result = size === b.length;
      if (result) {
        // Deep compare the contents, ignoring non-numeric properties.
        while (size--) {
          if (!(result = eq(a[size], b[size], aStack, bStack))) break;
        }
      }
    } else {
      // Deep compare objects.
      var keys = _.keys(a), key;
      size = keys.length;
      // Ensure that both objects contain the same number of properties before comparing deep equality.
      result = _.keys(b).length === size;
      if (result) {
        while (size--) {
          // Deep compare each member
          key = keys[size];
          if (!(result = _.has(b, key) && eq(a[key], b[key], aStack, bStack))) break;
        }
      }
    }
    // Remove the first object from the stack of traversed objects.
    aStack.pop();
    bStack.pop();
    return result;
  };

  // Perform a deep comparison to check if two objects are equal.
  _.isEqual = function(a, b) {
    return eq(a, b, [], []);
  };

  // Is a given array, string, or object empty?
  // An "empty" object has no enumerable own-properties.
  _.isEmpty = function(obj) {
    if (obj == null) return true;
    if (_.isArray(obj) || _.isString(obj) || _.isArguments(obj)) return obj.length === 0;
    for (var key in obj) if (_.has(obj, key)) return false;
    return true;
  };

  // Is a given value a DOM element?
  _.isElement = function(obj) {
    return !!(obj && obj.nodeType === 1);
  };

  // Is a given value an array?
  // Delegates to ECMA5's native Array.isArray
  _.isArray = nativeIsArray || function(obj) {
    return toString.call(obj) === '[object Array]';
  };

  // Is a given variable an object?
  _.isObject = function(obj) {
    var type = typeof obj;
    return type === 'function' || type === 'object' && !!obj;
  };

  // Add some isType methods: isArguments, isFunction, isString, isNumber, isDate, isRegExp.
  _.each(['Arguments', 'Function', 'String', 'Number', 'Date', 'RegExp'], function(name) {
    _['is' + name] = function(obj) {
      return toString.call(obj) === '[object ' + name + ']';
    };
  });

  // Define a fallback version of the method in browsers (ahem, IE), where
  // there isn't any inspectable "Arguments" type.
  if (!_.isArguments(arguments)) {
    _.isArguments = function(obj) {
      return _.has(obj, 'callee');
    };
  }

  // Optimize `isFunction` if appropriate. Work around an IE 11 bug.
  if (typeof /./ !== 'function') {
    _.isFunction = function(obj) {
      return typeof obj == 'function' || false;
    };
  }

  // Is a given object a finite number?
  _.isFinite = function(obj) {
    return isFinite(obj) && !isNaN(parseFloat(obj));
  };

  // Is the given value `NaN`? (NaN is the only number which does not equal itself).
  _.isNaN = function(obj) {
    return _.isNumber(obj) && obj !== +obj;
  };

  // Is a given value a boolean?
  _.isBoolean = function(obj) {
    return obj === true || obj === false || toString.call(obj) === '[object Boolean]';
  };

  // Is a given value equal to null?
  _.isNull = function(obj) {
    return obj === null;
  };

  // Is a given variable undefined?
  _.isUndefined = function(obj) {
    return obj === void 0;
  };

  // Shortcut function for checking if an object has a given property directly
  // on itself (in other words, not on a prototype).
  _.has = function(obj, key) {
    return obj != null && hasOwnProperty.call(obj, key);
  };

  // Utility Functions
  // -----------------

  // Run Underscore.js in *noConflict* mode, returning the `_` variable to its
  // previous owner. Returns a reference to the Underscore object.
  _.noConflict = function() {
    root._ = previousUnderscore;
    return this;
  };

  // Keep the identity function around for default iteratees.
  _.identity = function(value) {
    return value;
  };

  _.constant = function(value) {
    return function() {
      return value;
    };
  };

  _.noop = function(){};

  _.property = function(key) {
    return function(obj) {
      return obj[key];
    };
  };

  // Returns a predicate for checking whether an object has a given set of `key:value` pairs.
  _.matches = function(attrs) {
    var pairs = _.pairs(attrs), length = pairs.length;
    return function(obj) {
      if (obj == null) return !length;
      obj = new Object(obj);
      for (var i = 0; i < length; i++) {
        var pair = pairs[i], key = pair[0];
        if (pair[1] !== obj[key] || !(key in obj)) return false;
      }
      return true;
    };
  };

  // Run a function **n** times.
  _.times = function(n, iteratee, context) {
    var accum = Array(Math.max(0, n));
    iteratee = createCallback(iteratee, context, 1);
    for (var i = 0; i < n; i++) accum[i] = iteratee(i);
    return accum;
  };

  // Return a random integer between min and max (inclusive).
  _.random = function(min, max) {
    if (max == null) {
      max = min;
      min = 0;
    }
    return min + Math.floor(Math.random() * (max - min + 1));
  };

  // A (possibly faster) way to get the current timestamp as an integer.
  _.now = Date.now || function() {
    return new Date().getTime();
  };

   // List of HTML entities for escaping.
  var escapeMap = {
    '&': '&amp;',
    '<': '&lt;',
    '>': '&gt;',
    '"': '&quot;',
    "'": '&#x27;',
    '`': '&#x60;'
  };
  var unescapeMap = _.invert(escapeMap);

  // Functions for escaping and unescaping strings to/from HTML interpolation.
  var createEscaper = function(map) {
    var escaper = function(match) {
      return map[match];
    };
    // Regexes for identifying a key that needs to be escaped
    var source = '(?:' + _.keys(map).join('|') + ')';
    var testRegexp = RegExp(source);
    var replaceRegexp = RegExp(source, 'g');
    return function(string) {
      string = string == null ? '' : '' + string;
      return testRegexp.test(string) ? string.replace(replaceRegexp, escaper) : string;
    };
  };
  _.escape = createEscaper(escapeMap);
  _.unescape = createEscaper(unescapeMap);

  // If the value of the named `property` is a function then invoke it with the
  // `object` as context; otherwise, return it.
  _.result = function(object, property) {
    if (object == null) return void 0;
    var value = object[property];
    return _.isFunction(value) ? object[property]() : value;
  };

  // Generate a unique integer id (unique within the entire client session).
  // Useful for temporary DOM ids.
  var idCounter = 0;
  _.uniqueId = function(prefix) {
    var id = ++idCounter + '';
    return prefix ? prefix + id : id;
  };

  // By default, Underscore uses ERB-style template delimiters, change the
  // following template settings to use alternative delimiters.
  _.templateSettings = {
    evaluate    : /<%([\s\S]+?)%>/g,
    interpolate : /<%=([\s\S]+?)%>/g,
    escape      : /<%-([\s\S]+?)%>/g
  };

  // When customizing `templateSettings`, if you don't want to define an
  // interpolation, evaluation or escaping regex, we need one that is
  // guaranteed not to match.
  var noMatch = /(.)^/;

  // Certain characters need to be escaped so that they can be put into a
  // string literal.
  var escapes = {
    "'":      "'",
    '\\':     '\\',
    '\r':     'r',
    '\n':     'n',
    '\u2028': 'u2028',
    '\u2029': 'u2029'
  };

  var escaper = /\\|'|\r|\n|\u2028|\u2029/g;

  var escapeChar = function(match) {
    return '\\' + escapes[match];
  };

  // JavaScript micro-templating, similar to John Resig's implementation.
  // Underscore templating handles arbitrary delimiters, preserves whitespace,
  // and correctly escapes quotes within interpolated code.
  // NB: `oldSettings` only exists for backwards compatibility.
  _.template = function(text, settings, oldSettings) {
    if (!settings && oldSettings) settings = oldSettings;
    settings = _.defaults({}, settings, _.templateSettings);

    // Combine delimiters into one regular expression via alternation.
    var matcher = RegExp([
      (settings.escape || noMatch).source,
      (settings.interpolate || noMatch).source,
      (settings.evaluate || noMatch).source
    ].join('|') + '|$', 'g');

    // Compile the template source, escaping string literals appropriately.
    var index = 0;
    var source = "__p+='";
    text.replace(matcher, function(match, escape, interpolate, evaluate, offset) {
      source += text.slice(index, offset).replace(escaper, escapeChar);
      index = offset + match.length;

      if (escape) {
        source += "'+\n((__t=(" + escape + "))==null?'':_.escape(__t))+\n'";
      } else if (interpolate) {
        source += "'+\n((__t=(" + interpolate + "))==null?'':__t)+\n'";
      } else if (evaluate) {
        source += "';\n" + evaluate + "\n__p+='";
      }

      // Adobe VMs need the match returned to produce the correct offest.
      return match;
    });
    source += "';\n";

    // If a variable is not specified, place data values in local scope.
    if (!settings.variable) source = 'with(obj||{}){\n' + source + '}\n';

    source = "var __t,__p='',__j=Array.prototype.join," +
      "print=function(){__p+=__j.call(arguments,'');};\n" +
      source + 'return __p;\n';

    try {
      var render = new Function(settings.variable || 'obj', '_', source);
    } catch (e) {
      e.source = source;
      throw e;
    }

    var template = function(data) {
      return render.call(this, data, _);
    };

    // Provide the compiled source as a convenience for precompilation.
    var argument = settings.variable || 'obj';
    template.source = 'function(' + argument + '){\n' + source + '}';

    return template;
  };

  // Add a "chain" function. Start chaining a wrapped Underscore object.
  _.chain = function(obj) {
    var instance = _(obj);
    instance._chain = true;
    return instance;
  };

  // OOP
  // ---------------
  // If Underscore is called as a function, it returns a wrapped object that
  // can be used OO-style. This wrapper holds altered versions of all the
  // underscore functions. Wrapped objects may be chained.

  // Helper function to continue chaining intermediate results.
  var result = function(obj) {
    return this._chain ? _(obj).chain() : obj;
  };

  // Add your own custom functions to the Underscore object.
  _.mixin = function(obj) {
    _.each(_.functions(obj), function(name) {
      var func = _[name] = obj[name];
      _.prototype[name] = function() {
        var args = [this._wrapped];
        push.apply(args, arguments);
        return result.call(this, func.apply(_, args));
      };
    });
  };

  // Add all of the Underscore functions to the wrapper object.
  _.mixin(_);

  // Add all mutator Array functions to the wrapper.
  _.each(['pop', 'push', 'reverse', 'shift', 'sort', 'splice', 'unshift'], function(name) {
    var method = ArrayProto[name];
    _.prototype[name] = function() {
      var obj = this._wrapped;
      method.apply(obj, arguments);
      if ((name === 'shift' || name === 'splice') && obj.length === 0) delete obj[0];
      return result.call(this, obj);
    };
  });

  // Add all accessor Array functions to the wrapper.
  _.each(['concat', 'join', 'slice'], function(name) {
    var method = ArrayProto[name];
    _.prototype[name] = function() {
      return result.call(this, method.apply(this._wrapped, arguments));
    };
  });

  // Extracts the result from a wrapped and chained object.
  _.prototype.value = function() {
    return this._wrapped;
  };

  // AMD registration happens at the end for compatibility with AMD loaders
  // that may not enforce next-turn semantics on modules. Even though general
  // practice for AMD registration is to be anonymous, underscore registers
  // as a named module because, like jQuery, it is a base library that is
  // popular enough to be bundled in a third party lib, but not be part of
  // an AMD load request. Those cases could generate an error when an
  // anonymous define() is called outside of a loader request.
  if (typeof define === 'function' && define.amd) {
    define('underscore', [], function() {
      return _;
    });
  }
}.call(this));

},{}],"jsonpath":[function(require,module,exports){
module.exports = require('./lib/index');

},{"./lib/index":5}]},{},["jsonpath"])("jsonpath")
});
TP.boot.$$srcPath = '';

        
        TP.registerExternalObject('jsonpath', window.jsonpath);
        
    
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETDOMPrimitivesPre.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
*/

//  ------------------------------------------------------------------------
//  UTILITY METHODS
//  ------------------------------------------------------------------------

TP.definePrimitive('$$xpathResolverFunction',
function(aPrefix) {

    /**
     * @method $$xpathResolverFunction
     * @summary Resolves the supplied prefix into a matching namespace URI.
     * @param {String} aPrefix The prefix to use to look up a namespace URI.
     * @returns {String} The namespace URI that matches the supplied prefix.
     */

    var namespaceURI;

    if (TP.notEmpty(aPrefix) &&
        TP.isString(namespaceURI = TP.w3.Xmlns.getNSURIForPrefix(aPrefix))) {
        return namespaceURI;
    }

    return null;
});

//  ------------------------------------------------------------------------
//  DOCUMENT PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('getQNameRegex',
function(aName) {

    /**
     * @method getQNameRegex
     * @summary Returns a RegExp built to match a tag or attribute name with
     *     optional wildcarding for prefixes or names. For example, a name of
     *     'xf:*' will produce a regular expression that will find all
     *     tag/attribute names with an xf prefix. This function is normally used
     *     by the various node/element selector calls in TIBET so you don't
     *     typically call it yourself.
     * @param {String} aName A string containing an optional prefix, colon, and
     *     name, or a * in place of either the prefix or name. IE: 'div',
     *     'html:*', '*:div', '*', '*:*', etc.
     * @returns {RegExp} A regular expression which properly escapes any
     *     wildcarding in the search.
     */

    var re,
        list;

    //  If aName was empty, we just generate a RegExp that matches
    //  any character.
    if (TP.isEmpty(aName)) {
        re = TP.rc('.*');
    } else {
        list = aName.split(' ');
        list = list.map(
            function(name) {

                if (/\*:\*/.test(name)) {
                    //  *:* -- we can match anything, so .* works
                    return '.*';
                } else if (/\*:/.test(name)) {
                    //  *:something -- so we have to escape the * or get
                    //  regex err
                    return name.replace('*:', '\\\\*:');
                } else if (/:\*/.test(name)) {
                    //  something:* -- so we have to escape the * or get
                    //  regex err
                    return name.replace(':*', ':\\\\*');
                } else {
                    //  no wildcard, use as is (so it could be a regex
                    //  anyway)
                    return name;
                }
            });

        re = TP.rc(list.join('|'));
    }

    return re;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentConstructFragment',
function(aDocument) {

    /**
     * @method documentConstructFragment
     * @summary Creates and returns a new document fragment for the document
     *     provided, or the document of the code frame. You should provide the
     *     document that you will append/insert the fragment into to avoid
     *     incorrect document DOM errors.
     * @param {Document} aDocument The document to use in the construction
     *     process. There is no default value.
     * @example Create a document fragment in myDocument
     *     <code>
     *          aFrag = TP.documentConstructFragment(document);
     *          <samp>[object DocumentFragment]</samp>
     *     </code>
     * @returns {DocumentFragment} A valid DOM DocumentFragment.
     * @exception TP.sig.InvalidDocument Raised when an invalid Document is
     *     provided to the method.
     */

    if (!TP.isDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  NOTE the inversion of the name, this is the true call but it's not
    //  consistent with our naming conventions
    return aDocument.createDocumentFragment();
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetDoctypeInfo',
function(aDocument) {

    /**
     * @method documentGetDoctypeInfo
     * @summary Returns the Document Type info for the supplied document.
     * @description This function returns one of two values, depending on the
     *     browser it is running in and whether or not the application author
     *     has placed a document type declaration at the top of the document. 1)
     *     If the document has a document type declaration and that information
     *     can be accessed in the browser, a literal object consisting of 3
     *     keys: docTypeName, publicID, systemID. 2) Otherwise, null is
     *     returned.
     * @param {XMLDocument} aDocument The document to query.
     * @example Get the doctype info from an XML document:
     *     <code>
     *          xmlDoc = TP.documentFromString('<!DOCTYPE moo [<!ELEMENT boo
     *         EMPTY>]><foo xmlns="http://www.foo.com"/>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.documentGetDoctypeInfo(xmlDoc).asString();
     *          <samp>{"docTypeName":"moo", "publicID":"", "systemID":""}</samp>
     *     </code>
     * @returns {TP.core.Hash} The document type info for this document.
     * @exception TP.sig.InvalidXMLDocument Raised when an invalid XML document
     *     is provided to the method.
     */

    var theDocType,
        docTypeInfo;

    if (!TP.isXMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidXMLDocument');
    }

    theDocType = aDocument.doctype;

    if (TP.isValid(theDocType)) {
        docTypeInfo = TP.hc('docTypeName', '',
                            'publicID', '',
                            'systemID', '');

        //  NB: Since 'theDocType' was created in another frame, it
        //  is not TIBET-enhanced, hence the 'direct access' syntax.
        if (TP.isString(theDocType.name)) {
            docTypeInfo.atPut('docTypeName', theDocType.name);
        }

        if (TP.isString(theDocType.publicId)) {
            docTypeInfo.atPut('publicID', theDocType.publicId);
        }

        if (TP.isString(theDocType.systemId)) {
            docTypeInfo.atPut('systemID', theDocType.systemId);
        }

        return docTypeInfo;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetMIMEType',
function(aDocument) {

    /**
     * @method documentGetMIMEType
     * @summary Returns the MIME type for the supplied document.
     * @description This function returns one of two values, depending on the
     *     browser it is running in and whether or not the application author
     *     has placed a 'meta' element that has a 'Content-Type' attribute
     *     defined in it. 1) If the document has a 'meta' element that has a
     *     'Content-Type' attribute, that value is parsed for the MIME type. 2)
     *     Otherwise, if its an HTML document, the value of
     *     TP.core.Browser.DEFAULT_MIME_TYPE is returned. If its an XML
     *     document, null is returned.
     * @param {Document} aDocument The document to query.
     * @example Get the MIME type from an HTML document:
     *     <code>
     *          TP.documentGetMIMEType(document);
     *          <samp>text/html</samp>
     *     </code>
     * @example Get the MIME type from an XML document:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo
     *         xmlns="http://www.foo.com"/>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.documentGetMIMEType(xmlDoc);
     *          <samp>null</samp>
     *     </code>
     * @returns {String} The MIME type for this document.
     * @exception TP.sig.InvalidDocument Raised when an invalid document is
     *     provided to the method.
     */

    var metaTags,

        i,
        metaName,
        metaValue;

    if (!TP.isDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    metaTags = aDocument.getElementsByTagName('meta');

    //  NB: 'getElementsByTagName' returns a DOMCollection, so we treat it
    //  accordingly
    for (i = 0; i < metaTags.length; i++) {
        //  If there is a 'meta' tag with the 'http-equiv' attribute and
        //  that attribute is 'Content-Type', then return the value of the
        //  attribute named 'content', which should be the MIME type.
        metaName = TP.getAttr(metaTags[i], 'http-equiv');
        if (TP.notEmpty(metaName) && metaName === 'Content-Type') {
            metaValue = TP.getAttr(metaTags[i], 'content');

            TP.regex.MIME_TYPE.lastIndex = 0;
            return TP.regex.MIME_TYPE.exec(metaValue)[0];
        }
    }

    if (TP.isHTMLDocument(aDocument)) {
        //  use the brower type's default value
        return TP.core.Browser.DEFAULT_MIME_TYPE;
    } else {
        return null;
    }
});

//  ------------------------------------------------------------------------
//  NODE PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('nodeAddDefaultXMLNS',
function(aNode, namespaceURI) {

    /**
     * @method nodeAddDefaultXMLNS
     * @summary Sets the default namespace for the supplied Node (which needs
     *     to be a Document or Element) *and returns a new Node* (since it is
     *     impossible to actually set the default namespace on an existing
     *     Element).
     * @description If the supplied Node already has a default namespace, this
     *     method will *not* reset it.
     * @param {Node} aNode The Node to add the default namespace to.
     * @param {String} namespaceURI The namespace URI to associate with the
     *     default namespace.
     * @returns {Node} A new Node (Document or Element depending on what was
     *     provided to this method) with the namespace added to it.
     * @exception TP.sig.InvalidNode Raised when an invalid document or element
     *     is provided to the method.
     * @exception TP.sig.InvalidString Raised when an invalid namespace URI is
     *     provided to the method.
     */

    var elem,
        str;

    if (!TP.isDocument(aNode) && !TP.isElement(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (TP.isEmpty(namespaceURI)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    elem = TP.isDocument(aNode) ? aNode.documentElement : aNode;

    str = TP.str(elem);

    if (!TP.regex.CONTAINS_ELEM_MARKUP.test(str)) {
        return TP.raise(this, 'TP.sig.InvalidMarkup');
    }

    //  Test the element to make sure that we don't already have an 'xmlns'
    //  attribute. We do this since, in this context, the 'namespaceURI'
    //  property is meaningless - we actually want to know if this element
    //  has the 'xmlns' *default* namespace attribute itself. The best way
    //  to do this is actually get a value for the 'xmlns' attribute... even
    //  namespace 'nodes' are exposed to the DOM.
    if (TP.notEmpty(TP.elementGetAttribute(elem, 'xmlns'))) {
        return aNode;
    }

    str = str.replace(TP.regex.OPENING_TAG_NAME,
                        '<$1 xmlns="' + namespaceURI + '"');

    if (TP.isDocument(aNode)) {
        return TP.doc(str);
    } else {
        return TP.elem(str);
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeCopyTIBETExpandos',
function(srcNode, destNode, shouldRemove) {

    /**
     * @method nodeCopyTIBETExpandos
     * @summary Copies the special TIBET expandos from the srcNode to the
     *     destNode.
     * @param {Node} srcNode The node to copy the expandos from.
     * @param {Node} destNode The node to copy the expandos to.
     * @param {Boolean} [shouldRemove=true] Whether or not to remove expandos
     *     from the srcNode.
     * @exception TP.sig.InvalidNode
     */

    var srcDoc,
        destDoc,

        val;

    if (!TP.isNode(srcNode) || !TP.isNode(destNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    srcDoc = TP.nodeGetDocument(srcNode);
    destDoc = TP.nodeGetDocument(srcNode);

    //  We never copy the following TIBET expandos:
    //      TP.EVENT_IDS
    //      TP.WRAPPER

    //  We only copy the following TIBET expandos if the 2 documents are the
    //  same.
    if (srcDoc === destDoc) {
        destNode[TP.GLOBAL_ID] = TP.notEmpty(val = srcNode[TP.GLOBAL_ID]) ?
                                    val :
                                    destNode[TP.GLOBAL_ID];
    }

    //  We always copy the following TIBET expandos:
    destNode[TP.SHOULD_SIGNAL_CHANGE] =
            TP.notEmpty(val = srcNode[TP.SHOULD_SIGNAL_CHANGE]) ?
            val :
            destNode[TP.SHOULD_SIGNAL_CHANGE];
    destNode[TP.SHOULD_SUSPEND_SIGNALING] =
            TP.notEmpty(val = srcNode[TP.SHOULD_SUSPEND_SIGNALING]) ?
            val :
            destNode[TP.SHOULD_SUSPEND_SIGNALING];

    destNode[TP.GENERATOR] = TP.notEmpty(val = srcNode[TP.GENERATOR]) ?
                                val :
                                destNode[TP.GENERATOR];

    if (TP.isDocument(srcNode) && TP.isDocument(destNode)) {
        destNode[TP.SRC_LOCATION] =
                    TP.notEmpty(val = srcNode[TP.SRC_LOCATION]) ?
                                val :
                                destNode[TP.SRC_LOCATION];
    }

    if (TP.notFalse(shouldRemove)) {
        srcNode[TP.EVENT_IDS] = null;

        srcNode[TP.WRAPPER] = null;
        srcNode[TP.NODE_TYPE] = null;

        srcNode[TP.GLOBAL_ID] = null;

        srcNode[TP.SHOULD_SIGNAL_CHANGE] = null;
        srcNode[TP.SHOULD_SUSPEND_SIGNALING] = null;

        srcNode[TP.GENERATOR] = null;

        if (TP.isDocument(srcNode) && TP.isDocument(destNode)) {
            srcNode[TP.SRC_LOCATION] = null;
        }
    }

    return;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETDOMPrimitivesBase.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 */

//  ------------------------------------------------------------------------
//  ELEMENT PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('elementComputeXMLBaseFrom',
function(anElement, expandVirtuals) {

    /**
     * @method elementComputeXMLBaseFrom
     * @summary Computes the XML Base path from anElement out to the root
     *     element of the element's owner document.
     * @description XML Base entries are cumulative. Suppose elementA is a
     *     parent of anElement and has an base entry of 'foo/bar/'. elementB is
     *     a parent of elementA and has an XML Base entry of '/baz'. The XML
     *     Base path for anElement, then, is computed to be '/baz/foo/bar/'.
     *     Note that, once an entry that has a colon (':') is found, traversal
     *     is halted (as a 'scheme' for the URI has been found) and the base is
     *     computed from there, as that designates the beginning of an absolute
     *     path entry.
     * @param {Element} anElement The Element to begin the computation of the
     *     XML Base path from.
     * @param {Boolean} expandVirtuals Whether or not we should 'expand'
     *     'virtual URIs' in XML Base entries that we encounter along the way
     *     when computing the XML Base for the supplied Element. This defaults
     *     to true.
     * @exception TP.sig.InvalidElement
     * @returns {String} The XML Base path as computed from anElement up the
     *     document hierarchy.
     */

    var elem,

        shouldExpand,

        base,
        expandedBase,

        computedBase;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    elem = anElement;
    shouldExpand = TP.ifInvalid(expandVirtuals, true);

    base = TP.ifEmpty(TP.elementGetAttribute(elem, 'xml:base', true), '');

    //  Make sure the 'xml:base' is expanded and if its not, set the
    //  attribute's value back to the fully expanded value.
    expandedBase = TP.uriExpandPath(base);
    if (base !== expandedBase && shouldExpand) {
        TP.elementSetAttributeInNS(elem, 'xml:base', expandedBase,
                                    TP.w3.Xmlns.XML);
    }

    if (TP.notEmpty(expandedBase) && TP.uriIsAbsolute(expandedBase)) {
        return expandedBase;
    }

    //  The initial value of the computed base is the expanded version of
    //  our starting 'xml:base'. Now we'll traverse the tree and add from
    //  there.
    computedBase = expandedBase;

    //  Traverse up the element's parent chain
    while (TP.isElement(elem = elem.parentNode)) {
        if (TP.notEmpty(base = TP.elementGetAttribute(elem,
                                                        'xml:base',
                                                        true))) {
            //  Make sure the 'xml:base' is expanded and if its not, set the
            //  attribute's value back to the fully expanded value.
            expandedBase = TP.uriExpandPath(base);
            if (base !== expandedBase && shouldExpand) {
                TP.elementSetAttributeInNS(elem,
                                            'xml:base',
                                            expandedBase,
                                            TP.w3.Xmlns.XML);
            }

            computedBase = TP.uriJoinPaths(expandedBase, computedBase);

            if (TP.uriIsAbsolute(computedBase)) {
                return computedBase;
            }
        }
    }

    return computedBase;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementComputeTIBETTypeKey',
function(anElement) {

    /**
     * @method elementComputeTIBETTypeKey
     * @summary Returns a unique key that will identify the TIBET type that
     *     matches the supplied Element.
     * @param {Element} anElement The Element to compute the unique key for.
     * @returns {String} A unique key that identifiers the TIBET type.
     * @exception TP.sig.InvalidElement
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  If the element is an XHTML 'input' type, we further qualify by the
    //  'type' property.
    if (anElement.namespaceURI === TP.w3.Xmlns.XHTML &&
        anElement.localName === 'input') {

        return TP.elementGetFullName(anElement) +
                    '[type="' + anElement.type + '"]';
    }

    return TP.elementGetFullName(anElement);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementResolveXMLBase',
function(anElement, uriAttrNames, aPrefix, aSuffix) {

    /**
     * @method elementResolveXMLBase
     * @summary Loops over the supplied list of attribute names and resolves
     *     their values on the supplied element with respect to XML Base. If the
     *     URI is not absolute and needs an XML Base value, this is obtained and
     *     the attribute value is rewritten with that value..
     * @param {Element} anElement The element to update any URI attributes of.
     * @param {String[]} uriAttrNames The list of attribute names that should be
     *     considered for XML Base processing.
     * @param {String} aPrefix An optional prefix that should be stripped before
     *     computing the full URI and prepended back onto the result value.
     * @param {String} aSuffix An optional suffix that should be stripped before
     *     computing the full URI and appended back onto the result value.
     * @exception TP.sig.InvalidElement Raised when an invalid element is provided
     *     to the method.
     * @exception TP.sig.InvalidParameter Raised when a null value is supplied for
     *     the uriAttrNames parameter.
     */

    var computedBase,

        len,
        i,

        thePrefix,
        theSuffix,

        baseVal,
        basePath;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    len = uriAttrNames.getSize();
    for (i = 0; i < len; i++) {
        //  If there is no value for the attribute in question on the
        //  element, just continue on to the next one.
        if (TP.isEmpty(baseVal = TP.elementGetAttribute(
                                                anElement,
                                                uriAttrNames.at(i),
                                                true))) {
            continue;
        }


        //  Just in case the URI was encoded, as it is by some browsers
        //  (Firefox), make sure to decode it.
        baseVal = decodeURIComponent(baseVal);

        //  <a href="#">...</a> should not be rewritten.
        if (baseVal === '#' && uriAttrNames.at(i) === 'href') {
            return;
        }

        thePrefix = '';
        theSuffix = '';

        //  Strip the prefix, if there is one.
        if (baseVal.startsWith(aPrefix)) {
            baseVal = baseVal.slice(aPrefix.getSize());

            //  Grab it to use for rebuilding the value later.
            thePrefix = aPrefix;
        }

        //  Strip the suffix, if there is one.
        if (baseVal.endsWith(aSuffix)) {
            //  Note the computation of the negative index here - we're
            //  slicing from the end.
            baseVal = baseVal.slice(0, aSuffix.getSize() * -1);

            //  Grab it to use for rebuilding the value later.
            theSuffix = aSuffix;
        }

        if (baseVal.startsWith('#')) {
            continue;
        }

        //  NB: We don't bother to test to make sure baseVal is a URI here
        //  since it could be just 'foo.xml' at this point (which won't pass
        //  our TP.isURIString() test). So we just compute the base and join the
        //  paths together.

        //  Expand the 'baseVal' path, converting any virtual constructs. If
        //  it isn't an absolute path, go ahead and compute the XML base
        //  value up the tree.
        baseVal = TP.uriResolveVirtualPath(baseVal);

        if (!TP.uriIsAbsolute(baseVal)) {

            //  If the URL we're resolving is a fragment we need an entire URL
            //  not just the base.
            if (/^#/.test(baseVal)) {
                computedBase = TP.documentGetLocation(
                    TP.nodeGetDocument(anElement));
            } else {
                computedBase = TP.elementComputeXMLBaseFrom(anElement);
            }

            //  Compute the base path using the XML Base as computed from
            //  the element and the value of 'baseVal'. Note here how we
            //  pass 'false' to the TP.uriResolvePaths() call, forcing it to
            //  recognize that computedBase and baseVal are directories, not
            //  URIs to paths.
            basePath = TP.uriResolvePaths(computedBase, baseVal, false);
        } else {
            //  Otherwise, it was an absolute path, so just use it.
            basePath = baseVal;
        }

        //  If a basePath could not be computed, put an error message into
        //  the attribute value.
        if (TP.notValid(basePath)) {
            //  Note here how we prepend/append the prefix/suffix. The above
            //  mechanism might have set them - otherwise, they're empty.
            TP.elementSetAttribute(
                        anElement,
                        uriAttrNames.at(i),
                        'Couldn\'t compute base for: ' +
                            thePrefix + baseVal + theSuffix);
        } else {
            //  Note here how we prepend/append the prefix/suffix. The above
            //  mechanism might have set them - otherwise, they're empty.
            TP.elementSetAttribute(
                        anElement,
                        uriAttrNames.at(i),
                        TP.uriJoinPaths(TP.uriJoinPaths(
                            thePrefix, basePath), theSuffix));
        }
    }

    return;
});

//  ------------------------------------------------------------------------
//  NODE PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('nodeComparePosition',
function(aNode, otherNode, aPosition) {

    /**
     * @method nodeComparePosition
     * @summary Returns one of 5 values that can be used to determine the
     *     position of otherNode relative to aNode. Note that this comparison is
     *     *always* made from otherNode to aNode.
     * @description The aPosition parameter of this method has the following
     *     behavior, according to the defined 'TP' constants:
     *          TP.SAME_NODE            aNode and otherNode are the same Node
     *          TP.PRECEDING_NODE       otherNode precedes aNode in the document
     *          TP.FOLLOWING_NODE       otherNode follows aNode in the document
     *          TP.CONTAINS_NODE        otherNode contains aNode in the document
     *          TP.CONTAINED_BY_NODE    otherNode is contained by aNode in the
     *                                  document
     * @param {Node} aNode The node to check to see if otherNode is contained
     *     within it.
     * @param {Node} otherNode The node to check to see if it is contained
     *     within aNode.
     * @param {Number} aPosition One of the following constants: TP.SAME_NODE
     *     TP.PRECEDING_NODE TP.FOLLOWING_NODE TP.CONTAINS_NODE
     *     TP.CONTAINED_BY_NODE.
     * @example Test to see if the first child of the document element of an XML
     *     document is followed by the second child of the document element:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo><bar/><baz/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeComparePosition(
     *          xmlDoc.documentElement.childNodes[0],
     *          xmlDoc.documentElement.childNodes[1],
     *          TP.FOLLOWING_NODE);
     *          <samp>true</samp>
     *     </code>
     * @example Test to see if the body element of an HTML document is preceded
     *     by the head element:
     *     <code>
     *          TP.nodeComparePosition(
     *          TP.documentGetBody(document),
     *          document.documentElement.childNodes[0],
     *          TP.PRECEDING_NODE);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not otherNode is positioned relative to
     *     aNode according to the supplied position.
     * @exception TP.sig.InvalidNode Raised when either node is invalid as provided
     *     to the method.
     * @exception TP.sig.InvalidParameter Raised when an invalid position is
     *     provided to the method.
     */

    var position;

    //  In W3C-compliant browsers, this leverages compareDocumentPosition(),
    //  which is built-in for both HTML and XML documents. On IE, it
    //  leverages that call for XML documents and '.sourceIndex' for HTML
    //  documents.

    //  NB: This function originally from John Resig, under an MIT license.
    /* eslint-disable no-nested-ternary */
    position =
        aNode.compareDocumentPosition ?
            aNode.compareDocumentPosition(otherNode) :
            aNode.contains ?
                (aNode !== otherNode && aNode.contains(otherNode) && 16) +
                (aNode !== otherNode && otherNode.contains(aNode) && 8) +
                (aNode.sourceIndex >= 0 && otherNode.sourceIndex >= 0 ?
                    (aNode.sourceIndex < otherNode.sourceIndex && 4) +
                    (aNode.sourceIndex > otherNode.sourceIndex && 2) :
                    1) + 0 :
                    0;
    /* eslint-enable no-nested-ternary */

    return Boolean(position & aPosition);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetBestNode',
function(aNode) {

    /**
     * @method nodeGetBestNode
     * @summary Returns the 'best' node for the node provided.
     * @description The 'best node' for a node is the node that best represents
     *     it for things like 'content type tasting' to determine MIME types,
     *     etc. Often, when trying to determine content types by 'tasting',
     *     you want to make sure to get the document element of the supplied
     *     node's document or, if aNode is a document fragment, you want the
     *     first child, etc.
     * @param {Node} aNode The node to get the 'best', 'most representative'
     *     node of.
     * @returns {Node} The 'best' node for the node provided.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to the
     *     method.
     */

    var doc,
        retNode;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (!TP.nodeIsDetached(aNode)) {
        doc = TP.nodeGetDocument(aNode);
        if (TP.notValid(doc)) {
            //  xml, but no document-level data to go by...
            retNode = aNode;
        } else {
            retNode = doc.documentElement;
        }
    } else {
        if (TP.isFragment(aNode)) {
            retNode = aNode.firstChild;
        } else {
            retNode = aNode;
        }
    }

    if (TP.isElement(retNode)) {

        //  If the element is our special 'wrap' element, use it's first
        //  child.
        if (TP.elementGetLocalName(retNode) === 'wrap') {
            retNode = retNode.firstChild;
        }
    }

    return retNode;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETDOMPrimitivesPlatform.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';

/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
*/

//  ------------------------------------------------------------------------
//  ATTRIBUTE PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('attributeGetOwnerElement',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    TP.DEFAULT,
    function(anAttributeNode) {

        /**
         * @method attributeGetOwnerElement
         * @summary Returns the owning element of the supplied attribute node.
         *     NOTE: This method only works on attribute nodes that exist on
         *     elements in an XML document.
         * @param {Attribute} anAttributeNode The attribute node to retrieve the
         *     owner element for.
         * @example Obtain the owner element for an attribute node:
         *     <code>
         *          xmlDoc = TP.doc('<foo bar="baz"/>');
         *          attrNode = xmlDoc.documentElement.getAttributeNode(
         *          'bar');
         *          TP.attributeGetOwnerElement(attrNode).tagName;
         *          <samp>foo</samp>
         *     </code>
         * @returns {Element} The owner element of the supplied attribute node.
         * @exception TP.sig.InvalidAttributeNode Raised when a non-attribute Node
         *     has been supplied to the method.
         * @exception TP.sig.InvalidXMLDocument Raised when the supplied attribute
         *     Node is not part of an XML document.
         */

        if (!TP.isAttributeNode(anAttributeNode)) {
            return TP.raise(this, 'TP.sig.InvalidAttributeNode');
        }

        return anAttributeNode.ownerElement;
    },
    'webkit',
    function(anAttributeNode) {

        /**
         * @method attributeGetOwnerElement
         * @summary Returns the owning element of the supplied attribute node.
         *     NOTE: This method only works on attribute nodes that exist on
         *     elements in an XML document.
         * @param {Attribute} anAttributeNode The attribute node to retrieve the
         *     owner element for.
         * @example Obtain the owner element for an attribute node:
         *     <code>
         *          xmlDoc = TP.doc('<foo bar="baz"/>');
         *          attrNode = xmlDoc.documentElement.getAttributeNode(
         *          'bar');
         *          TP.attributeGetOwnerElement(attrNode).tagName;
         *          <samp>foo</samp>
         *     </code>
         * @returns {Element} The owner element of the supplied attribute node.
         * @exception TP.sig.InvalidAttributeNode Raised when a non-attribute Node
         *     has been supplied to the method.
         * @exception TP.sig.InvalidXMLDocument Raised when the supplied attribute
         *     Node is not part of an XML document.
         */

        var owner;

        if (!TP.isAttributeNode(anAttributeNode)) {
            return TP.raise(this, 'TP.sig.InvalidAttributeNode');
        }

        //  For some reason, DOM Level 4 removes 'ownerElement'
        if (!TP.isElement(owner = anAttributeNode.ownerElement)) {
            owner = TP.nodeEvaluateXPath(anAttributeNode, '..');
        }

        return owner;
    }
));

//  ------------------------------------------------------------------------
//  DOCUMENT PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('$documentFixupInlineBindingAttrs',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    TP.DEFAULT,
    function(inputStr) {

        /**
         * @method $documentFixupInlineBindingAttrs
         * @summary Converts any inline binding expressions:
         *     value="[[foo.bar]]")
         *     to 'bind:io' attributes:
         *     bind:io="{value: foo}".
         *     This is done because a) it makes the bind machinery simpler and
         *     more efficient to search for bindings that are normalized like
         *     this and b) some browsers (like IE) don't like attribute values
         *     that it considers to be 'invalid' for some attributes (like the
         *     'style' attribute) and will strip them out.
         * @param {String} inputStr The markup String to convert inline binding
         *     expressions in.
         * @returns {String} A markup String that has inline binding expressions
         *     converted to 'bind:io' attributes.
         */

        var parser,
            workingDoc,

            result,

            inlineBindingAttrs,

            node,

            bindAttrLocalName,

            i,

            srcAttr,

            ownerElem,
            ownerType,
            ioAttrs,

            j,

            ownerElemAttr,
            val,
            bindAttr,

            isSingleValued,

            desugaredAttrsAttr,

            outputStr;

        //  Use the 'old ActiveX way' to parse the document - this parser
        //  does *not* strip "invalid" constructs from the markup.
        parser = new DOMParser();

        workingDoc = parser.parseFromString(inputStr, TP.XML_ENCODED);

        //  Look for any attributes that contain '[[' - these are binding
        //  expressions. Note how *do not* look for any that are in the
        //  TP.w3.Xmlns.BIND namespace, which means any 'bind:*' attributes
        //  themselves.
        result = workingDoc.evaluate(
                '//*/@*[contains(., "[[") and ' +
                'namespace-uri() != "' + TP.w3.Xmlns.BIND + '"]',
                workingDoc,
                null,
                XPathResult.ANY_TYPE,
                null);

        inlineBindingAttrs = TP.ac();
        while (TP.isNode(node = result.iterateNext())) {
            inlineBindingAttrs.push(node);
        }

        for (i = 0; i < inlineBindingAttrs.length; i++) {

            srcAttr = inlineBindingAttrs[i];

            //  Grab the Element node that owns this Attribute node.
            ownerElem = srcAttr.ownerElement;

            //  Grab the owner Element node's concrete type here and see if the
            //  attribute local name is in the list of bidirectional attributes.
            //  If it is, use 'io' as the binding attribute local name. If not,
            //  use 'in'.
            ownerType = TP.dom.ElementNode.getConcreteType(ownerElem);
            ioAttrs = ownerType.get('bidiAttrs');
            bindAttrLocalName =
                        ioAttrs.indexOf(srcAttr.localName) !== TP.NOT_FOUND ?
                        'io' :
                        'in';

            //  Initially set the bindAttr to null
            bindAttr = null;

            //  Loop over all of the attributes of the owner Element, looking to
            //  see if they're named 'bind:in'/'bind:io' or if they're named
            //  'in'/'io' with a namespaceURI of TP.w3.Xmlns.BIND. This means
            //  that we have an existing bind:io attribute that we should just
            //  add to.
            for (j = 0; j < ownerElem.attributes.length; j++) {
                ownerElemAttr = ownerElem.attributes[j];

                if (ownerElemAttr.localName === bindAttrLocalName &&
                     ownerElemAttr.namespaceURI === TP.w3.Xmlns.BIND) {
                    bindAttr = ownerElemAttr;
                    break;
                }
            }

            //  Make sure that we don't (re)process bind:in/bind:io attributes
            if (bindAttr === srcAttr) {
                continue;
            }

            val = srcAttr.nodeValue;

            isSingleValued = false;

            //  If the expression starts and ends exactly (modulo whitespace)
            //  with '[[' and ']]', and it doesn't contain ACP variables or
            //  formatting expressions, then we can trim off the '[[' and ']]'.
            if (/^\s*\[\[/.test(val) && /\]\]\s*$/.test(val) &&
                !TP.regex.ACP_PATH_CONTAINS_VARIABLES.test(val) &&
                !TP.regex.ACP_FORMAT.test(val)) {
                //  Trim off whitespace
                val = TP.trim(val);

                //  Slice off the leading and trailing '[[' and ']]'
                val = val.slice(2, -2);
            } else if (!/^\s*\[\[/.test(val) || !/\]\]\s*$/.test(val)) {
                //  If the expression doesn't end exactly (modulo whitespace) at
                //  either the start or end, then we quote the entire
                //  expression.
                val = val.quoted('\'');

                //  Since we'll be putting this through a transformation
                //  function that will probably expect a single value, we need
                //  to mark it as such below. If the tag type doesn't want this,
                //  it will need to override the 'isSingleValued()' method.
                isSingleValued = true;
            }

            //  There was no existing bind:in/bind:io attribute - build one and
            //  set it's value.
            if (!TP.isAttributeNode(bindAttr)) {
                ownerElem.setAttributeNS(
                        TP.w3.Xmlns.BIND,
                        'bind:' + bindAttrLocalName,
                        '{' + srcAttr.name + ': ' + val + '}');

                if (isSingleValued) {
                    ownerElem.setAttributeNS(
                            TP.w3.Xmlns.TIBET,
                            'tibet:single',
                            srcAttr.name);
                }

                ownerElem.setAttributeNS(
                        TP.w3.Xmlns.TIBET,
                        'tibet:desugared',
                        srcAttr.name);
            } else {
                //  Already have a bind:in/bind:io attribute - add to it.
                bindAttr.nodeValue =
                    bindAttr.nodeValue.slice(
                        0, bindAttr.nodeValue.lastIndexOf('}')) +
                    ', ' +
                    srcAttr.name +
                    ': ' +
                    val +
                    '}';
                desugaredAttrsAttr =
                    ownerElem.attributes['tibet:desugared'];
                desugaredAttrsAttr.nodeValue += ' ' + srcAttr.name;
            }

            //  Remove the original Attribute node containing the '[[...]]'
            //  expression.
            ownerElem.removeAttributeNode(srcAttr);
        }

        //  Turn it back into a String.
        outputStr = new XMLSerializer().serializeToString(workingDoc);

        return outputStr;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('$documentCaptureACPAttrExpressions',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    TP.DEFAULT,
    function(inputStr) {

        /**
         * @method $documentCaptureACPAttrExpressions
         * @summary Captures any ACP expressions inside of attributes and adds a
         *     new attribute, 'tibet:attrtemplateexprs', that has those
         *     expressions captured.
         * @param {String} inputStr The markup String to convert attribute ACP
         *     expressions in.
         * @returns {String} A markup String that has attribute ACP expressions
         *     captured into a 'tibet:attrtemplateexprs' attribute.
         */

        var parser,
            workingDoc,

            result,

            acpAttrs,

            node,

            i,

            srcAttr,

            ownerElem,

            val,
            trackingAttr,

            outputStr;

        //  Use the 'old ActiveX way' to parse the document - this parser
        //  does *not* strip "invalid" constructs from the markup.
        parser = new DOMParser();

        workingDoc = parser.parseFromString(inputStr, TP.XML_ENCODED);

        //  Look for any attributes that contain '{{' - these are binding
        //  expressions. Note how *do not* look for any that are in the
        //  TP.w3.Xmlns.BIND namespace, which means any 'bind:*' attributes
        //  themselves.
        result = workingDoc.evaluate(
                '//*/@*[contains(., "' + TP.ACP_BEGIN + '") and ' +
                'namespace-uri() != "' + TP.w3.Xmlns.BIND + '"]',
                workingDoc,
                null,
                XPathResult.ANY_TYPE,
                null);

        acpAttrs = TP.ac();
        while (TP.isNode(node = result.iterateNext())) {
            acpAttrs.push(node);
        }

        for (i = 0; i < acpAttrs.length; i++) {

            srcAttr = acpAttrs[i];

            //  Grab the Element node that owns this Attribute node.
            ownerElem = srcAttr.ownerElement;

            //  Initially set the trackingAttr to null
            trackingAttr = ownerElem.attributes['tibet:attrtemplateexprs'];

            val = srcAttr.nodeValue;

            //  If the expression starts and ends exactly (modulo whitespace)
            //  with '{{' and '}}' then we can trim off the whitespace.
            if (/^\s*\{\{/.test(val) && /\}\}\s*$/.test(val)) {
                //  Trim off whitespace
                val = TP.trim(val);
            }

            val = val.replace(TP.regex.ACP_BEGIN, TP.ACP_ENCODED_BEGIN);
            val = val.replace(TP.regex.ACP_END, TP.ACP_ENCODED_END);

            val = val.quoted('"');

            //  There was no existing tibet:attrtemplateexprs attribute - build
            //  one and set it's value.
            if (!TP.isAttributeNode(trackingAttr)) {
                ownerElem.setAttributeNS(
                        TP.w3.Xmlns.TIBET,
                        'tibet:attrtemplateexprs',
                        '{' + srcAttr.name + ': ' + val + '}');
            } else {
                //  Already have a tibet:attrtemplateexprs attribute - add to
                //  it.
                trackingAttr.nodeValue =
                    trackingAttr.nodeValue.slice(
                        0, trackingAttr.nodeValue.lastIndexOf('}')) +
                    ', ' +
                    srcAttr.name +
                    ': ' +
                    val +
                    '}';
            }
        }

        //  Turn it back into a String.
        outputStr = new XMLSerializer().serializeToString(workingDoc);

        return outputStr;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('documentFromString',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(aString, defaultNS, shouldReport) {

        /**
         * @method documentFromString
         * @summary Parses aString and returns the XML document representing
         *     the string's DOM representation.
         * @param {String} aString The source string to be parsed.
         * @param {String|null} defaultNS What namespace should be used for the
         *     'default namespace' for element markup in the supplied String.
         *     Note that this should be an XML 'namespace URI' (i.e.
         *     'http://www.w3.org/1999/xhtml') *not* a namespace prefix (i.e.
         *     'html:'). To use the 'null' namespace (i.e. xmlns=""), supply
         *     the empty String ('') here. To not specify any default namespace
         *     value and let the parser do what it does natively, supply null
         *     here.
         * @param {Boolean} shouldReport False to turn off exception reporting
         *     so strings can be tested for XML compliance without causing
         *     exceptions to be thrown. This is true by default.
         * @example Create an XML document from a String:
         *     <code>
         *          xmlDoc = TP.documentFromString('<foo><bar/></foo>');
         *          <samp>[object XMLDocument]</samp>
         *          TP.nodeAsString(xmlDoc);
         *          <samp><foo><bar/></foo></samp>
         *     </code>
         * @returns {XMLDocument} The XML document parsed from the string.
         * @exception TP.sig.DOMParseException Raised if the supplied String
         *     cannot be parsed into a proper XML DOM construct and the
         *     shouldReport flag is true.
         */

        var report,
            parser,

            str,

            defs,

            isJSONStr,

            xmlDoc,

            errorElement,

            undefinedPrefixes,

            errorMatchResults,
            errorRecord,
            list;

        report = TP.ifInvalid(shouldReport, false);

        //  force to true when TIBET is configured for parse debugging
        if (TP.notValid(report)) {
            report = TP.sys.shouldReportParseErrors();
        }

        //  NB: Do *not* change these to 'TIBET primitives' (like
        //  TP.isEmpty()) as this method gets used early in the booting
        //  process.

        //  String without valid markup? Not XML then.
        if (aString === '' ||
            !/^[\s\w]*</.test(aString) ||
            aString.length < '<a/>'.length) {
            return;
        }

        if (TP.isValid(xmlDoc = TP.$parsed_doc_cache.at(aString))) {
            //  We always return a clone so that we don't mess with what we have
            //  in our cache.
            return xmlDoc.cloneNode(true);
        }

        //  If the caller has specified a default namespace, use it here. Even
        //  if this is the empty String, that's ok - it means they wanted an
        //  empty default namespace.
        if (TP.isString(defaultNS)) {
            str = '<tibet_root xmlns="' + defaultNS + '"';
        } else {
            str = '<tibet_root';
        }

        //  if TIBET has the 'TP.w3.Xmlns' type loaded, we leverage XMLNS
        //  'auto-qualification'
        if (TP.isType(TP.sys.getTypeByName('TP.w3.Xmlns')) &&
            TP.notEmpty(defs = TP.w3.Xmlns.get('XMLNSDefs'))) {
            str = aString.replace(
                TP.regex.ALL_ELEM_MARKUP,
                str + ' ' + defs + '>$&</tibet_root>');
        } else {
            str = aString.replace(
                TP.regex.ALL_ELEM_MARKUP,
                str + '>$&</tibet_root>');
        }

        isJSONStr = TP.isJSONString(str);

        //  Detect things like binding expressions here and massage the DOM to
        //  create (or add to an existing) bind:io attribute. Note here how we
        //  also check to make sure it's not a JSON String - we don't want long
        //  Strings of JSON data in our binding attributes.
        if (TP.regex.BINDING_STATEMENT_DETECT.test(str) && !isJSONStr) {
            str = TP.$documentFixupInlineBindingAttrs(str);
        }

        if (TP.regex.HAS_ACP_ATTR.test(str) && !isJSONStr) {
            str = TP.$documentCaptureACPAttrExpressions(str);
        }

        //  Make sure to replace any characters that are valid UTF-8, but not
        //  valid XML characters.
        str = str.replace(TP.regex.UTF8_BUT_NOT_XML_CHARS);

        parser = new DOMParser();

        xmlDoc = parser.parseFromString(str, TP.XML_ENCODED);

        //  If there is an Element named 'parsererror', that is
        //  Mozilla's way of telling us that a parser error
        //  occurred ;-).
        if (xmlDoc.documentElement.nodeName === 'parsererror') {
            errorElement = xmlDoc.documentElement;

            //  If the system is currently configured to automatically define
            //  undefined XML prefixes (either element or attribute), then
            //  attempt to do so.
            if (TP.sys.cfg('content.autodefine_missing_prefixes')) {

                //  Scan the content for undefined prefixes
                undefinedPrefixes = TP.xmlStringGetUndefinedPrefixes(aString);

                //  Declare the missing prefixes and then retry
                if (TP.notEmpty(undefinedPrefixes)) {
                    undefinedPrefixes.forEach(
                            function(aPrefix) {
                                TP.ifWarn() ?
                                    TP.warn('Declaring missing prefix: ' +
                                            aPrefix +
                                            ' as: ' +
                                            'urn:tmp:' +
                                            aPrefix) : 0;
                                TP.w3.Xmlns.registerNSInfo(
                                    'urn:tmp:' + aPrefix,
                                    TP.hc('prefix', aPrefix));
                            });

                    //  Return retrying the parsing now that the prefixes have
                    //  been defined.
                    return TP.documentFromString(
                            aString, defaultNS, shouldReport);
                }
            }

            //  Sometimes we don't want to report an error from here
            //  because we're calling this from the logging itself and
            //  we would recurse (or we're just 'tasting' the String).
            if (TP.notFalse(report)) {
                //  Sometimes there is more information to go with the
                //  parser error. If so, build a record of that
                //  information to report with the exception.
                if (TP.isNode(errorElement.firstChild)) {
                    errorMatchResults = TP.regex.GECKO_XML_PARSE.exec(
                                    errorElement.firstChild.nodeValue);

                    errorRecord =
                            TP.hc('reason', errorMatchResults.at(1),
                                    'line', errorMatchResults.at(2),
                                    'linepos', errorMatchResults.at(3));

                    list = TP.nodeGetElementsByTagName(
                                    errorElement, 'sourcetext');

                    errorRecord.atPut(
                                'srcText',
                                list.at(0).firstChild.nodeValue);
                } else {
                    errorRecord = TP.hc('reason', 'Unknown',
                                        'line', 'Unknown',
                                        'linepos', 'Unknown',
                                        'srcText', 'Unknown');
                }

                TP.raise(this, 'TP.sig.DOMParseException',
                            errorRecord);
            }

            return null;
        }

        //  If there is only 1 element child of the document element (i.e. the
        //  '<tibet_root>' element that we used for XMLNS qualification) then we
        //  need to replace that with its first child (which is the real
        //  content). Note that we do *NOT* do this if there is more than 1
        //  element child, which would indicate that we were handed a String
        //  that resolved as a DocumentFragment. In this case, we just hand back
        //  the <tibet_root> element.
        if (xmlDoc.documentElement.children.length === 1) {
            xmlDoc.replaceChild(
                    xmlDoc.documentElement.firstChild,
                    xmlDoc.documentElement);
        }

        TP.$parsed_doc_cache.atPut(aString, xmlDoc);

        //  We always return a clone so that we don't mess with what we have in
        //  our cache.
        return xmlDoc.cloneNode(true);
    },
    'webkit',
    function(aString, defaultNS, shouldReport) {

        /**
         * @method documentFromString
         * @summary Parses aString and returns the XML document representing
         *     the string's DOM representation.
         * @param {String} aString The source string to be parsed.
         * @param {String|null} defaultNS What namespace should be used for the
         *     'default namespace' for element markup in the supplied String.
         *     Note that this should be an XML 'namespace URI' (i.e.
         *     'http://www.w3.org/1999/xhtml') *not* a namespace prefix (i.e.
         *     'html:'). To use the 'null' namespace (i.e. xmlns=""), supply
         *     the empty String ('') here. To not specify any default namespace
         *     value and let the parser do what it does natively, supply null
         *     here.
         * @param {Boolean} shouldReport False to turn off exception reporting
         *     so strings can be tested for XML compliance without causing
         *     exceptions to be thrown. This is true by default.
         * @example Create an XML document from a String:
         *     <code>
         *          xmlDoc = TP.documentFromString('<foo><bar/></foo>');
         *          <samp>[object XMLDocument]</samp>
         *          TP.nodeAsString(xmlDoc);
         *          <samp><foo><bar/></foo></samp>
         *     </code>
         * @returns {XMLDocument} The XML document parsed from the string.
         * @exception TP.sig.DOMParseException Raised if the supplied String
         *     cannot be parsed into a proper XML DOM construct and the
         *     shouldReport flag is true.
         */

        var report,
            parser,

            str,

            defs,

            isJSONStr,

            xmlDoc,

            errorElement,
            errorStr,

            undefinedPrefixes,

            errorMatchResults,
            errorRecord;

        report = TP.ifInvalid(shouldReport, false);

        //  force to true when TIBET is configured for parse debugging
        if (TP.notValid(report)) {
            report = TP.sys.shouldReportParseErrors();
        }

        //  NB: Do *not* change these to 'TIBET primitives' (like
        //  TP.isEmpty())
        //  as this method gets used early in the booting process.

        //  String without valid markup? Not XML then.
        if (aString === '' ||
            !/^[\s\w]*</.test(aString) ||
            aString.length < '<a/>'.length) {
            return;
        }

        if (TP.isValid(xmlDoc = TP.$parsed_doc_cache.at(aString))) {
            //  We always return a clone so that we don't mess with what we have
            //  in our cache.
            return xmlDoc.cloneNode(true);
        }

        //  If the caller has specified a default namespace, use it here. Even
        //  if this is the empty String, that's ok - it means they wanted an
        //  empty default namespace.
        if (TP.isString(defaultNS)) {
            str = '<tibet_root xmlns="' + defaultNS + '"';
        } else {
            str = '<tibet_root';
        }

        //  if TIBET has the 'TP.w3.Xmlns' type loaded, we leverage XMLNS
        //  'auto-qualification'
        if (TP.isType(TP.sys.getTypeByName('TP.w3.Xmlns')) &&
            TP.notEmpty(defs = TP.w3.Xmlns.get('XMLNSDefs'))) {
            str = aString.replace(
                TP.regex.ALL_ELEM_MARKUP,
                str + ' ' + defs + '>$&</tibet_root>');
        } else {
            str = aString.replace(
                TP.regex.ALL_ELEM_MARKUP,
                str + '>$&</tibet_root>');
        }

        isJSONStr = TP.isJSONString(str);

        //  Detect things like binding expressions here and massage the DOM to
        //  create (or add to an existing) bind:io attribute. Note here how we
        //  also check to make sure it's not a JSON String - we don't want long
        //  Strings of JSON data in our binding attributes.
        if (TP.regex.BINDING_STATEMENT_DETECT.test(str) && !isJSONStr) {
            str = TP.$documentFixupInlineBindingAttrs(str);
        }

        if (TP.regex.HAS_ACP_ATTR.test(str) && !isJSONStr) {
            str = TP.$documentCaptureACPAttrExpressions(str);
        }

        //  Make sure to replace any characters that are valid UTF-8, but not
        //  valid XML characters.
        str = str.replace(TP.regex.UTF8_BUT_NOT_XML_CHARS);

        parser = new DOMParser();

        xmlDoc = parser.parseFromString(str, TP.XML_ENCODED);

        //  If there is an Element named 'parsererror', that is Webkit's
        //  way of telling us that a parser error occurred ;-).
        if (TP.isElement(errorElement =
                        xmlDoc.getElementsByTagName('parsererror')[0])) {

            //  If the system is currently configured to automatically define
            //  undefined XML prefixes (either element or attribute), then
            //  attempt to do so.
            if (TP.sys.cfg('content.autodefine_missing_prefixes')) {

                //  Scan the content for undefined prefixes
                undefinedPrefixes = TP.xmlStringGetUndefinedPrefixes(aString);

                //  Declare the missing prefixes and then retry
                if (TP.notEmpty(undefinedPrefixes)) {
                    undefinedPrefixes.forEach(
                            function(aPrefix) {
                                TP.ifWarn() ?
                                    TP.warn('Declaring missing prefix: ' +
                                            aPrefix +
                                            ' as: ' +
                                            'urn:tmp:' +
                                            aPrefix) : 0;
                                TP.w3.Xmlns.registerNSInfo(
                                    'urn:tmp:' + aPrefix,
                                    TP.hc('prefix', aPrefix));
                            });

                    //  Return retrying the parsing now that the prefixes have
                    //  been defined.
                    return TP.documentFromString(
                            aString, defaultNS, shouldReport);
                }
            }

            //  Sometimes we don't want to report an error from here
            //  because we're calling this from the logging itself and
            //  we would recurse (or we're just 'tasting' the String).
            if (TP.notFalse(report)) {

                errorStr = TP.nodeAsString(errorElement);

                //  Sometimes there is more information to go with the
                //  parser error. If so, build a record of that
                //  information to report with the exception.
                if (TP.isNode(errorElement.firstChild)) {
                    errorMatchResults =
                        TP.regex.WEBKIT_XML_PARSE.exec(errorStr);

                    errorRecord =
                            TP.hc('reason', errorMatchResults.at(3),
                                    'line', errorMatchResults.at(1),
                                    'linepos', errorMatchResults.at(2));
                } else {
                    errorRecord = TP.hc('reason', 'Unknown',
                                        'line', 'Unknown',
                                        'linepos', 'Unknown');
                }

                TP.raise(this, 'TP.sig.DOMParseException',
                            errorRecord);
            }

            return null;
        }

        //  If there is only 1 element child of the document element (i.e. the
        //  '<tibet_root>' element that we used for XMLNS qualification) then we
        //  need to replace that with its first child (which is the real
        //  content). Note that we do *NOT* do this if there is more than 1
        //  element child, which would indicate that we were handed a String
        //  that resolved as a DocumentFragment. In this case, we just hand back
        //  the <tibet_root> element.
        if (xmlDoc.documentElement.children.length === 1) {
            xmlDoc.replaceChild(
                    xmlDoc.documentElement.firstChild,
                    xmlDoc.documentElement);
        }

        //  Safari has a nasty bug whereby, if the child needs a namespace
        //  definition, but that existed on the document element, then it won't
        //  be 'copied' down onto the child (or is in an invisible way). This
        //  causes later serializations to double the namespace attributes which
        //  then causes parse errors.
        if (TP.sys.isUA('safari')) {

            xmlDoc = parser.parseFromString(
                                new XMLSerializer().serializeToString(xmlDoc),
                                TP.XML_ENCODED);
        }

        //  We always return a clone so that we don't mess with what we have in
        //  our cache.
        TP.$parsed_doc_cache.atPut(aString, xmlDoc);

        return xmlDoc.cloneNode(true);
    }
));

//  ------------------------------------------------------------------------
//  ELEMENT PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('$$elementPreserveIFrameContent',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(anElement) {

        /**
         * @method $$elementPreserveIFrameContent
         * @summary Preserves iframe content for browser platforms which need
         *     it.
         * @description This patch is required for DOM modification calls (such
         *     as TP.nodeAppendChild()) that may be moving 'iframe' elements
         *     (either directly or as descendants of an element being moved).
         *     This is because some browser platforms, such as Gecko, do not
         *     preserve an iframe's content when its element is moved around in
         *     the DOM. For more information, see:
         *     https://bugzilla.mozilla.org/show_bug.cgi?id=254144
         * @param {Element} anElement The element to preserve iframe content
         *     for.
         * @returns {TP.core.Hash} A hash containing the document Elements for
         *     each of the iframe's found under anElement (or for anElement
         *     itself if its an iframe).
         */

        var iframeElems,
            holderHash,

            i,

            iframeDoc,
            iframeID,
            iframeDocElem,

            newDocElem;

        //  Grab all of the iframes under the supplied element (and make it
        //  into an Array).
        iframeElems = TP.ac(anElement.getElementsByTagName('iframe'));

        //  If we got at least one iframe, go through and grab its document
        //  element and register it with the hash under a key matching the
        //  (possibly generated and assigned) 'id' for the iframe. Then
        //  replace that document element with a meaningless replacement
        //  element.
        if (TP.notEmpty(iframeElems)) {
            holderHash = TP.hc();

            for (i = 0; i < iframeElems.getSize(); i++) {
                if (TP.notValid(iframeDoc =
                            TP.elementGetIFrameDocument(iframeElems.at(i)))) {
                    continue;
                }

                iframeID = TP.lid(iframeElems[i], true);

                iframeDocElem = iframeDoc.documentElement;
                if (TP.isElement(iframeDocElem)) {
                    newDocElem = iframeDoc.createElement('replacement');
                    iframeDocElem.parentNode.replaceChild(newDocElem,
                                                            iframeDocElem);
                    holderHash.atPut(iframeID, iframeDocElem);
                }
            }
        }

        return holderHash;
    },
    'webkit',
    function(anElement) {

        /**
         * @method $$elementPreserveIFrameContent
         * @summary Preserves iframe content for browser platforms which need
         *     it.
         * @description This patch is required for DOM modification calls (such
         *     as TP.nodeAppendChild()) that may be moving 'iframe' elements
         *     (either directly or as descendants of an element being moved).
         *     This is because some browser platforms, such as Webkit-based
         *     ones, do not preserve an iframe's content when its element is
         *     moved around in the DOM. For more information, see:
         *     https://bugs.webkit.org/show_bug.cgi?id=13574
         * @param {Element} anElement The element to preserve iframe content
         *     for.
         * @returns {TP.core.Hash} A hash containing the document Elements for
         *     each of the iframe's found under anElement (or for anElement
         *     itself if its an iframe).
         */

        var iframeElems,
            holderHash,

            i,

            iframeDoc,
            iframeID,
            iframeDocElem,

            newDocElem;

        //  Grab all of the iframes under the supplied element (and make it
        //  into an Array).
        iframeElems = TP.ac(anElement.getElementsByTagName('iframe'));

        //  If we got at least one iframe, go through and grab its document
        //  element and register it with the hash under a key matching the
        //  (possibly generated and assigned) 'id' for the iframe. Then
        //  replace that document element with a meaningless replacement
        //  element.
        if (TP.notEmpty(iframeElems)) {
            holderHash = TP.hc();

            for (i = 0; i < iframeElems.getSize(); i++) {
                if (TP.notValid(iframeDoc =
                        TP.elementGetIFrameDocument(iframeElems.at(i)))) {
                    continue;
                }

                iframeID = TP.lid(iframeElems[i], true);

                iframeDocElem = iframeDoc.documentElement;
                if (TP.isElement(iframeDocElem)) {
                    newDocElem = iframeDoc.createElement('replacement');
                    iframeDocElem.parentNode.replaceChild(newDocElem,
                                                            iframeDocElem);
                    holderHash.atPut(iframeID, iframeDocElem);
                }
            }
        }

        return holderHash;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('$$elementRestoreIFrameContent',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(anElement, docElemsHash) {

        /**
         * @method $$elementRestoreIFrameContent
         * @summary Restores previously preserved iframe content for browser
         *     platforms which need it.
         * @description This patch is required for DOM modification calls (such
         *     as TP.nodeAppendChild()) that may be moving 'iframe' elements
         *     (either directly or as descendants of an element being moved).
         *     This is because some browser platforms, such as Gecko, do not
         *     preserve an iframe's content when its element is moved around in
         *     the DOM. For more information, see:
         *     https://bugzilla.mozilla.org/show_bug.cgi?id=254144
         * @param {Element} anElement The element to restore iframe content for.
         * @param {TP.core.Hash} docElemsHash The hash containing the document
         *     elements previously captured during the preserve process.
         */

        var holderKeys,

            i,

            theIFrameElem,

            iframeDoc,
            iframeDocElem,

            newDocElem;

        //  Grab all of the keys out of the supplied hash and try to find
        //  iframe elements that have 'id's that match those keys. If an
        //  iframe can be found, replace its document element with the one
        //  in the hash that was preserved in the
        //  '$$elementPreserveIFrameContent' call.

        holderKeys = TP.keys(docElemsHash);
        for (i = 0; i < holderKeys.getSize(); i++) {
            theIFrameElem = TP.nodeGetDocument(anElement).getElementById(
                                                        holderKeys.at(i));

            if (TP.notValid(iframeDoc =
                            TP.elementGetIFrameDocument(theIFrameElem))) {
                continue;
            }

            iframeDocElem = iframeDoc.documentElement;
            if (TP.isElement(iframeDocElem)) {
                newDocElem = iframeDoc.adoptNode(
                                docElemsHash.at(holderKeys.at(i)), true);

                //  Need to do this so that 'certain browsers'...ahem...
                //  properly 'set up' their iframe's window context, etc.
                iframeDoc.open();
                iframeDoc.write('<html><head></head><body></body></html>');
                iframeDoc.close();

                iframeDocElem = iframeDoc.documentElement;

                iframeDocElem.parentNode.replaceChild(newDocElem,
                                                        iframeDocElem);
            }
        }

        return;
    },
    'webkit',
    function(anElement, docElemsHash) {

        /**
         * @method $$elementRestoreIFrameContent
         * @summary Restores previously preserved iframe content for browser
         *     platforms which need it.
         * @description This patch is required for DOM modification calls (such
         *     as TP.nodeAppendChild()) that may be moving 'iframe' elements
         *     (either directly or as descendants of an element being moved).
         *     This is because some browser platforms, such as Webkit-based
         *     ones, do not preserve an iframe's content when its element is
         *     moved around in the DOM. For more information, see:
         *     https://bugs.webkit.org/show_bug.cgi?id=13574
         * @param {Element} anElement The element to restore iframe content for.
         * @param {TP.core.Hash} docElemsHash The hash containing the document
         *     elements previously captured during the preserve process.
         */

        var holderKeys,

            i,

            theIFrameElem,

            iframeDoc,
            iframeDocElem,

            newDocElem;

        //  Grab all of the keys out of the supplied hash and try to find
        //  iframe elements that have 'id's that match those keys. If an
        //  iframe can be found, replace its document element with the one
        //  in the hash that was preserved in the
        //  '$$elementPreserveIFrameContent' call.

        holderKeys = TP.keys(docElemsHash);
        for (i = 0; i < holderKeys.getSize(); i++) {
            theIFrameElem = TP.nodeGetDocument(anElement).getElementById(
                                                        holderKeys.at(i));

            if (TP.notValid(iframeDoc =
                            TP.elementGetIFrameDocument(theIFrameElem))) {
                continue;
            }

            iframeDocElem = iframeDoc.documentElement;
            if (TP.isElement(iframeDocElem)) {
                newDocElem = iframeDoc.adoptNode(
                                docElemsHash.at(holderKeys.at(i)), true);

                //  Need to do this so that 'certain browsers'...ahem...
                //  properly 'set up' their iframe's window context, etc.
                iframeDoc.open();
                iframeDoc.write('<html><head></head><body></body></html>');
                iframeDoc.close();

                iframeDocElem = iframeDoc.documentElement;

                iframeDocElem.parentNode.replaceChild(newDocElem,
                                                        iframeDocElem);
            }
        }

        return;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('elementSetAttributeInNS',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(anElement, attrName, attrValue, attrNS) {

        /**
         * @method elementSetAttributeInNS
         * @summary Sets an attribute on the supplied element in the namespace
         *     provided. Note that the desired prefix should be provided as part
         *     of the attribute name. Note also that the attribute value can be
         *     the empty string ('') but not null or undefined.
         * @description If the supplied element's document is an HTML document,
         *     this method will perform a simple 'setAttribute()' call, but will
         *     use the 'whole name' (i.e. with a colon-separated name) as the
         *     name of the attribute.
         * @param {Element} anElement The element to set the attribute on.
         * @param {String} attrName The attribute name to use.
         * @param {String} attrValue The attribute value to use.
         * @param {String} attrNS The namespace URI to use.
         * @example Set an attribute on an element in an XML document, placing
         *     it into a particular namespace.
         *     <code>
         *          xmlDoc = TP.documentFromString(
         *          '<foo xmlns:bar="http://www.bar.com"/>');
         *          <samp>[object XMLDocument]</samp>
         *          TP.elementSetAttributeInNS(xmlDoc.documentElement,
         *          'bar:baz',
         *          'bazify',
         *          'http://www.bar.com');
         *          <samp>undefined</samp>
         *          TP.nodeAsString(xmlDoc);
         *          <samp>&lt;foo xmlns:bar="http://www.bar.com"
         *         bar:baz="bazify"/&gt;</samp>
         *     </code>
         * @exception TP.sig.InvalidElement Raised when an invalid element is
         *     provided to the method.
         * @exception TP.sig.InvalidString Raised when a null or empty attribute
         *     name is provided to the method.
         * @exception TP.sig.InvalidParameter Raised when a null or undefined
         *     attribute value is provided to the method.
         */

        if (!TP.isElement(anElement)) {
            return TP.raise(this, 'TP.sig.InvalidElement');
        }

        if (TP.isEmpty(attrName)) {
            return TP.raise(this, 'TP.sig.InvalidString');
        }

        if (TP.notValid(attrValue)) {
            return TP.raise(this, 'TP.sig.InvalidParameter');
        }

        if (TP.notEmpty(attrNS) &&
            TP.isXMLDocument(TP.nodeGetDocument(anElement))) {
            anElement.setAttributeNS(attrNS, attrName, attrValue);
        } else {
            anElement.setAttribute(attrName, attrValue);
        }

        return;
    },
    TP.DEFAULT,
    function(anElement, attrName, attrValue, attrNS) {

        /**
         * @method elementSetAttributeInNS
         * @summary Sets an attribute on the supplied element in the namespace
         *     provided. Note that the desired prefix should be provided as part
         *     of the attribute name. Note also that the attribute value can be
         *     the empty string ('') but not null or undefined.
         * @description If the supplied element's document is an HTML document,
         *     this method will perform a simple 'setAttribute()' call, but will
         *     use the 'whole name' (i.e. with a colon-separated name) as the
         *     name of the attribute.
         * @param {Element} anElement The element to set the attribute on.
         * @param {String} attrName The attribute name to use.
         * @param {String} attrValue The attribute value to use.
         * @param {String} attrNS The namespace URI to use.
         * @example Set an attribute on an element in an XML document, placing
         *     it into a particular namespace.
         *     <code>
         *          xmlDoc = TP.documentFromString(
         *          '<foo xmlns:bar="http://www.bar.com"/>');
         *          <samp>[object XMLDocument]</samp>
         *          TP.elementSetAttributeInNS(xmlDoc.documentElement,
         *          'bar:baz',
         *          'bazify',
         *          'http://www.bar.com');
         *          <samp>undefined</samp>
         *          TP.nodeAsString(xmlDoc);
         *          <samp>&lt;foo xmlns:bar="http://www.bar.com"
         *         bar:baz="bazify"/&gt;</samp>
         *     </code>
         * @exception TP.sig.InvalidElement Raised when an invalid element is
         *     provided to the method.
         * @exception TP.sig.InvalidString Raised when a null or empty attribute
         *     name is provided to the method.
         * @exception TP.sig.InvalidParameter Raised when a null or undefined
         *     attribute value is provided to the method.
         */

        var parts,
            prefix,

            attrs,
            i,
            xmlnsAttrName;

        if (!TP.isElement(anElement)) {
            return TP.raise(this, 'TP.sig.InvalidElement');
        }

        if (TP.isEmpty(attrName)) {
            return TP.raise(this, 'TP.sig.InvalidString');
        }

        if (TP.notValid(attrValue)) {
            return TP.raise(this, 'TP.sig.InvalidParameter');
        }

        if (TP.notEmpty(attrNS) &&
            TP.isXMLDocument(TP.nodeGetDocument(anElement))) {
            //  On Webkit, we have to make sure that the namespace is also
            //  defined if it isn't already... and we *must* do it before we
            //  try to use setAttributeNS(...), because that call will go
            //  ahead and supply a corresponding 'xmlns:<prefix>' node for
            //  the namespace, but its buggy and won't show up in the
            //  '.attributes' Array for subsequent calls. This way,
            //  setAttributeNS(...) looks at the element and determines that
            //  the namespace is already there.

            //  Note that we *ONLY* do this if the namespace of the
            //  attribute that is being added *ISN'T* the 'namespace
            //  namespace' (TP.w3.Xmlns.XMLNS).
            if (attrNS !== TP.w3.Xmlns.XMLNS) {
                //  Did the attribute name have a 'prefix' in it?
                if (TP.notEmpty(parts = attrName.split(':'))) {
                    //  If so, use it.
                    prefix = parts.first();
                } else {
                    //  Otherwise, use the canonical prefix for that
                    //  namespace.
                    prefix = TP.w3.Xmlns.getCanonicalPrefix();
                }

                //  If we successfully obtained a prefix, set the namespace
                //  on the element (if its not already there).
                if (TP.notEmpty(prefix)) {
                    xmlnsAttrName = 'xmlns:' + prefix;

                    if (!TP.isElement(
                              TP.nodeGetFirstAncestorByAttribute(
                                          anElement, xmlnsAttrName))) {

                        //  We need to make sure that we're not putting a
                        //  namespace definition on an element that already has
                        //  one.
                        attrs = anElement.attributes;
                        for (i = 0; i < attrs.length; i++) {
                            if (attrs[i].name === xmlnsAttrName) {
                                break;
                            }
                        }

                        //  NOTE: We cannot use elementAddNSURI() here since
                        //  that call uses this call :-).
                        anElement.setAttributeNS(TP.w3.Xmlns.XMLNS,
                                                    xmlnsAttrName,
                                                    attrNS);
                    }
                }
            }

            //  Now that we're sure that the namespace is there, go ahead
            //  and set the attribute.
            anElement.setAttributeNS(attrNS, attrName, attrValue);
        } else {
            anElement.setAttribute(attrName, attrValue);
        }

        return;
    }
));

//  ------------------------------------------------------------------------
//  NODE PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('nodeAsString',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(aNode, wantsXMLDeclaration, shallow) {

        /**
         * @method nodeAsString
         * @summary Returns the string representation of aNode.
         * @description This function takes in a flag as to whether the caller
         *     wants a specific behavior as to the presence of an XML
         *     declaration. The behavior of this function as to this flag's
         *     state is as follows:
         *
         *     Flag value Existing declaration? Output ----------
         *     --------------------- ------ Not defined Yes With declaration Not
         *     defined No Without declaration True Yes With declaration True No
         *     With declaration False Yes Without declaration False No Without
         *     declaration
         *
         *     NOTE: This flag is only used when the supplied Node is an XML
         *     document.
         * @param {Node} aNode The node to transform.
         * @param {Boolean} wantsXMLDeclaration Whether or not the caller wants
         *     an XML declaration placed on the front of the string
         *     representation. Default is false.
         * @param {Boolean} shallow True to output just the node when it's an
         *     element node so no children are represented. Default is false.
         * @example Create an XML document with an attribute and a text node
         *     child and generate the string representation of each construct
         *     (with no XML declaration):
         *     <code>
         *          xmlDoc = TP.documentFromString(
         *          '<foo xmlns:bar="http://www.bar.com" bar:baz="bazify">Hi
         *         there</foo>');
         *          <samp>[object XMLDocument]</samp>
         *          TP.nodeAsString(xmlDoc);
         *          <samp>&lt;foo xmlns:bar="http://www.bar.com"
         *         bar:baz="bazify"&gt;Hi there&lt;/foo&gt;</samp>
         *          TP.nodeAsString(xmlDoc.documentElement);
         *          <samp>&lt;foo xmlns:bar="http://www.bar.com"
         *         bar:baz="bazify"&gt;Hi there&lt;/foo&gt;</samp>
         *          TP.nodeAsString(xmlDoc.documentElement.attributes[1]);
         *          <samp>bazify</samp>
         *          TP.nodeAsString(xmlDoc.documentElement.firstChild);
         *          <samp>Hi there</samp>
         *     </code>
         * @example Create an XML document with an attribute and a text node
         *     child and generate the string representation of each construct
         *     (with an XML declaration):
         *     <code>
         *          xmlDoc = TP.documentFromString(
         *          '<foo xmlns:bar="http://www.bar.com" bar:baz="bazify">Hi
         *         there</foo>');
         *          <samp>[object XMLDocument]</samp>
         *          TP.nodeAsString(xmlDoc, true);
         *          <samp>&lt;?xml version="1.0"?&gt;&lt;foo
         *         xmlns:bar="http://www.bar.com" bar:baz="bazify"&gt;Hi
         *         there&lt;/foo&gt;</samp>
         *          TP.nodeAsString(xmlDoc.documentElement, true);
         *          <samp>&lt;foo xmlns:bar="http://www.bar.com"
         *         bar:baz="bazify"&gt;Hi there&lt;/foo&gt;</samp>
         *     </code>
         * @example Create an XML document with a namespaced root node, add two
         *     'null namespaced' children to it and generate the string
         *     representation:
         *     <code>
         *          xmlDoc = TP.documentFromString(
         *          '<foo xmlns="http://www.foo.com"/>');
         *          <samp>[object XMLDocument]</samp>
         *          TP.nodeAppendChild(
         *          xmlDoc.documentElement,
         *          TP.documentConstructElement(xmlDoc, 'bar', null));
         *          <samp>[object Element]</samp>
         *          TP.nodeAppendChild(
         *          xmlDoc.documentElement,
         *          TP.documentConstructElement(xmlDoc, 'baz', ''));
         *          <samp>[object Element]</samp>
         *          TP.nodeAsString(xmlDoc, true);
         *          <samp>&lt;foo xmlns="http://www.foo.com"&gt;&lt;bar
         *         xmlns=""/&gt;&lt;baz xmlns=""/&gt;&lt;/foo&gt;</samp>
         *     </code>
         * @example Create a document fragment in an XML document, append some
         *     <code>
         *          elements to it, and generate its string representation:
         *          xmlDoc = TP.documentFromString(
         *          '<foo xmlns:bar="http://www.bar.com" bar:baz="bazify">Hi
         *         there</foo>');
         *          <samp>[object XMLDocument]</samp>
         *          docFrag = TP.documentConstructFragment(xmlDoc);
         *          TP.nodeAppendChild(
         *          docFrag,
         *          TP.documentConstructElement(xmlDoc, 'span',
         *         TP.w3.Xmlns.XHTML));
         *          TP.nodeAppendChld(
         *          docFrag,
         *          TP.documentConstructElement(xmlDoc, 'span',
         *         TP.w3.Xmlns.XHTML));
         *          TP.nodeAsString(docFrag);
         *          <samp>&lt;span
         *         xmlns="http://www.w3.org/1999/xhtml"/&gt;&lt;span
         *         xmlns="http://www.w3.org/1999/xhtml"/&gt;</samp>
         *     </code>
         * @example Generate a string representation of an HTML document:
         *     <code>
         *          TP.nodeAsString(document);
         *          <samp>...HTML output...</samp>
         *     </code>
         * @example Generate a string representation of an HTML element:
         *     <code>
         *          TP.nodeAsString(TP.documentGetBody(document));
         *          <samp>...HTML output...</samp>
         *     </code>
         * @returns {String} The String produced by 'rendering' the supplied
         *     node.
         * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
         *     the method.
         * @exception TP.sig.SerializationException Raised when the serialization
         *     machinery encounters an error serializing the node.
         * @exception TP.sig.UnsupportedOperation Raised when a Node is supplied
         *     that this method doesn't know how to generate a string
         *     representation of. These include Nodes of type:
         *     Node.ENTITY_REFERENCE_NODE Node.ENTITY_NODE
         *     Node.NOTATION_NODE
         */

        var node,
            str;

        if (!TP.isNode(aNode)) {
            return TP.raise(this, 'TP.sig.InvalidNode');
        }

        node = shallow ? TP.nodeCloneNode(aNode, false) : aNode;

        //  depending on the node type we can optimize this call a bit
        switch (node.nodeType) {
            case Node.ATTRIBUTE_NODE:

                return node.name + '="' + node.value + '"';

            case Node.TEXT_NODE:

                return node.data;

            case Node.CDATA_SECTION_NODE:

                return '<![CDATA[' + node.data + ']]>';

            case Node.DOCUMENT_FRAGMENT_NODE:

                //  You can't run XPaths on document fragments on Mozilla,
                //  so the null namespace 'workaround' that we use below for
                //  Elements and Documents won't work anyway. Therefore, for
                //  document fragments, we just shortstop the process here
                //  and create a String from it the best we can.
                try {
                    str = new XMLSerializer().serializeToString(node);
                } catch (e) {
                    TP.raise(this, 'TP.sig.SerializationException',
                                TP.ec(e));
                    str = 'Serialization failed.';
                }

                //  If the node was originally an HTML node, then we need to
                //  make sure its return value is HTML
                if (TP.isHTMLNode(node)) {
                    return TP.stringAsHTMLString(str);
                } else {
                    return str;
                }

            case Node.PROCESSING_INSTRUCTION_NODE:

                return '<?' + node.target + ' ' + node.data + '?>';

            case Node.COMMENT_NODE:

                return '<!--' + node.data + '-->';

            case Node.ENTITY_REFERENCE_NODE:

                TP.raise(this, 'TP.sig.UnsupportedOperation');
                break;

            case Node.ENTITY_NODE:

                TP.raise(this, 'TP.sig.UnsupportedOperation');
                break;

            case Node.DOCUMENT_TYPE_NODE:

                return '<!DOCTYPE ' + node.name +
                        ' PUBLIC ' + node.publicId + ' ' + node.systemId + '>';

            case Node.NOTATION_NODE:

                TP.raise(this, 'TP.sig.UnsupportedOperation');
                break;

                /* eslint-disable no-fallthrough */

            case Node.DOCUMENT_NODE:

                //  No document element? Return the empty string.
                if (TP.notValid(node.documentElement)) {
                    return '';
                }

                //  Note here how we don't break, but continue falling
                //  through...

            case Node.ELEMENT_NODE:

                //  Note here how we don't break, but continue falling
                //  through...

            default:

                /* eslint-enable no-fallthrough */

                //  Try to serialize the node. If it fails, report an error.
                try {
                    str = new XMLSerializer().serializeToString(node);

                    //  NB: we check for a space after the 'xml' part here
                    //  to avoid finding PIs. We only want the XML
                    //  declaration.

                    //  If we wanted a declaration, the supplied Node was
                    //  an XML document, and there isn't a declaration,
                    //  then prepend one.
                    if (wantsXMLDeclaration &&
                        (TP.isXMLDocument(node) ||
                             TP.isXMLDocument(node.parentNode))) {
                        if (!str.startsWith('<?xml ')) {
                            str = TP.XML_10_HEADER + '\n' + str;
                        }
                    } else {
                        //  Otherwise, if we didn't want a declaration, but
                        //  there was one, slice the header off.
                        if (str.startsWith('<?xml ')) {
                            str = str.slice(str.indexOf('?>') + 2);
                        }
                    }
                } catch (e) {
                    //  work around another Mozilla bug/trap
                    if (/restricted URI/.test(TP.str(e))) {
                        if (TP.isElement(node)) {
                            str = TP.elementGetOuterContent(node);
                        } else if (TP.isDocument(node)) {
                            str = TP.elementGetOuterContent(
                                                node.documentElement);
                        } else {
                            str = node.innerHTML;
                        }
                    } else {
                        TP.raise(this, 'TP.sig.SerializationException',
                            TP.ec(e));
                        str = 'Serialization failed.';
                    }
                }

                //  IE's XMLSerializer insists on putting a space before the
                //  close of an 'empty' tag: <foo />. We don't want that and we
                //  need to remain consistent between platforms, so we change
                //  those here as well.
                str = str.replace(/ \/>/g, '/>');

                //  If the node was originally an HTML node, then we need to
                //  make sure its return value is HTML
                if (TP.isHTMLNode(node)) {
                    return TP.stringAsHTMLString(str);
                } else {
                    return str;
                }
        }

        return null;
    },
    TP.DEFAULT,
    function(aNode, wantsXMLDeclaration, shallow) {

        /**
         * @method nodeAsString
         * @summary Returns the string representation of aNode.
         * @description This function takes in a flag as to whether the caller
         *     wants a specific behavior as to the presence of an XML
         *     declaration. The behavior of this function as to this flag's
         *     state is as follows:
         *
         *     Flag value Existing declaration? Output ----------
         *     --------------------- ------ Not defined Yes With declaration Not
         *     defined No Without declaration True Yes With declaration True No
         *     With declaration False Yes Without declaration False No Without
         *     declaration
         *
         *     NOTE: This flag is only used when the supplied Node is an XML
         *     document.
         * @param {Node} aNode The node to transform.
         * @param {Boolean} wantsXMLDeclaration Whether or not the caller wants
         *     an XML declaration placed on the front of the string
         *     representation. Default is false.
         * @param {Boolean} shallow True to output just the node when it's an
         *     element node so no children are represented. Default is false.
         * @example Create an XML document with an attribute and a text node
         *     child and generate the string representation of each construct
         *     (with no XML declaration):
         *     <code>
         *          xmlDoc = TP.documentFromString(
         *          '<foo xmlns:bar="http://www.bar.com" bar:baz="bazify">Hi
         *         there</foo>');
         *          <samp>[object XMLDocument]</samp>
         *          TP.nodeAsString(xmlDoc);
         *          <samp>&lt;foo xmlns:bar="http://www.bar.com"
         *         bar:baz="bazify"&gt;Hi there&lt;/foo&gt;</samp>
         *          TP.nodeAsString(xmlDoc.documentElement);
         *          <samp>&lt;foo xmlns:bar="http://www.bar.com"
         *         bar:baz="bazify"&gt;Hi there&lt;/foo&gt;</samp>
         *          TP.nodeAsString(xmlDoc.documentElement.attributes[1]);
         *          <samp>bazify</samp>
         *          TP.nodeAsString(xmlDoc.documentElement.firstChild);
         *          <samp>Hi there</samp>
         *     </code>
         * @example Create an XML document with an attribute and a text node
         *     child and generate the string representation of each construct
         *     (with an XML declaration):
         *     <code>
         *          xmlDoc = TP.documentFromString(
         *          '<foo xmlns:bar="http://www.bar.com" bar:baz="bazify">Hi
         *         there</foo>');
         *          <samp>[object XMLDocument]</samp>
         *          TP.nodeAsString(xmlDoc, true);
         *          <samp>&lt;?xml version="1.0"?&gt;&lt;foo
         *         xmlns:bar="http://www.bar.com" bar:baz="bazify"&gt;Hi
         *         there&lt;/foo&gt;</samp>
         *          TP.nodeAsString(xmlDoc.documentElement, true);
         *          <samp>&lt;foo xmlns:bar="http://www.bar.com"
         *         bar:baz="bazify"&gt;Hi there&lt;/foo&gt;</samp>
         *     </code>
         * @example Create an XML document with a namespaced root node, add two
         *     'null namespaced' children to it and generate the string
         *     representation:
         *     <code>
         *          xmlDoc = TP.documentFromString(
         *          '<foo xmlns="http://www.foo.com"/>');
         *          <samp>[object XMLDocument]</samp>
         *          TP.nodeAppendChild(
         *          xmlDoc.documentElement,
         *          TP.documentConstructElement(xmlDoc, 'bar', null));
         *          <samp>[object Element]</samp>
         *          TP.nodeAppendChild(
         *          xmlDoc.documentElement,
         *          TP.documentConstructElement(xmlDoc, 'baz', ''));
         *          <samp>[object Element]</samp>
         *          TP.nodeAsString(xmlDoc, true);
         *          <samp>&lt;foo xmlns="http://www.foo.com"&gt;&lt;bar
         *         xmlns=""/&gt;&lt;baz xmlns=""/&gt;&lt;/foo&gt;</samp>
         *     </code>
         * @example Create a document fragment in an XML document, append some
         *     <code>
         *          elements to it, and generate its string representation:
         *          xmlDoc = TP.documentFromString(
         *          '<foo xmlns:bar="http://www.bar.com" bar:baz="bazify">Hi
         *         there</foo>');
         *          <samp>[object XMLDocument]</samp>
         *          docFrag = TP.documentConstructFragment(xmlDoc);
         *          TP.nodeAppendChild(
         *          docFrag,
         *          TP.documentConstructElement(xmlDoc, 'span',
         *         TP.w3.Xmlns.XHTML));
         *          TP.nodeAppendChld(
         *          docFrag,
         *          TP.documentConstructElement(xmlDoc, 'span',
         *         TP.w3.Xmlns.XHTML));
         *          TP.nodeAsString(docFrag);
         *          <samp>&lt;span
         *         xmlns="http://www.w3.org/1999/xhtml"/&gt;&lt;span
         *         xmlns="http://www.w3.org/1999/xhtml"/&gt;</samp>
         *     </code>
         * @example Generate a string representation of an HTML document:
         *     <code>
         *          TP.nodeAsString(document);
         *          <samp>...HTML output...</samp>
         *     </code>
         * @example Generate a string representation of an HTML element:
         *     <code>
         *          TP.nodeAsString(TP.documentGetBody(document));
         *          <samp>...HTML output...</samp>
         *     </code>
         * @returns {String} The String produced by 'rendering' the supplied
         *     node.
         * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
         *     the method.
         * @exception TP.sig.SerializationException Raised when the serialization
         *     machinery encounters an error serializing the node.
         * @exception TP.sig.UnsupportedOperation Raised when a Node is supplied
         *     that this method doesn't know how to generate a string
         *     representation of. These include Nodes of type:
         *     Node.ENTITY_REFERENCE_NODE Node.ENTITY_NODE
         *     Node.NOTATION_NODE
         */

        var node,
            str;

        if (!TP.isNode(aNode)) {
            return TP.raise(this, 'TP.sig.InvalidNode');
        }

        node = shallow ? TP.nodeCloneNode(aNode, false) : aNode;

        //  depending on the node type we can optimize this call a bit
        switch (node.nodeType) {
            case Node.ATTRIBUTE_NODE:

                return node.name + '="' + node.value + '"';

            case Node.TEXT_NODE:

                return node.data;

            case Node.CDATA_SECTION_NODE:

                return '<![CDATA[' + node.data + ']]>';

            case Node.DOCUMENT_FRAGMENT_NODE:

                try {
                    str = new XMLSerializer().serializeToString(node);
                } catch (e) {
                    TP.raise(this, 'TP.sig.SerializationException',
                                TP.ec(e));
                    str = 'Serialization failed.';
                }

                //  IE's XMLSerializer insists on putting a space before the
                //  close of an 'empty' tag: <foo />. We don't want that and we
                //  need to remain consistent between platforms, so we change
                //  those here as well.
                str = str.replace(/ \/>/g, '/>');

                //  If the node was originally an HTML node, then we need to
                //  make sure its return value is HTML
                if (TP.isHTMLNode(node)) {
                    return TP.stringAsHTMLString(str);
                } else {
                    return str;
                }

            case Node.PROCESSING_INSTRUCTION_NODE:

                return '<?' + node.target + ' ' + node.data + '?>';

            case Node.COMMENT_NODE:

                return '<!--' + node.data + '-->';

            case Node.ENTITY_REFERENCE_NODE:

                TP.raise(this, 'TP.sig.UnsupportedOperation');
                break;

            case Node.ENTITY_NODE:

                TP.raise(this, 'TP.sig.UnsupportedOperation');
                break;

            case Node.DOCUMENT_TYPE_NODE:

                return '<!DOCTYPE ' + node.name +
                        ' PUBLIC ' + node.publicId + ' ' + node.systemId + '>';

            case Node.NOTATION_NODE:

                TP.raise(this, 'TP.sig.UnsupportedOperation');
                break;

                /* eslint-disable no-fallthrough */

            case Node.DOCUMENT_NODE:

                //  No document element? Return the empty string.
                if (TP.notValid(node.documentElement)) {
                    return '';
                }

                //  Note here how we don't break, but continue falling
                //  through...

            case Node.ELEMENT_NODE:

                //  Note here how we don't break, but continue falling
                //  through...

            default:

                /* eslint-enable no-fallthrough */

                //  Try to serialize the node. If it fails, report an error.
                try {
                    str = new XMLSerializer().serializeToString(node);

                    //  IE's XMLSerializer insists on putting a space before the
                    //  close of an 'empty' tag: <foo />. We don't want that and
                    //  we need to remain consistent between platforms, so we
                    //  change those here as well.
                    str = str.replace(/ \/>/g, '/>');

                    //  NB: we check for a space after the 'xml' part here
                    //  to avoid finding PIs. We only want the XML
                    //  declaration.

                    //  If we wanted a declaration, the supplied Node was an
                    //  XML document, and there isn't a declaration, then
                    //  prepend one.
                    if (wantsXMLDeclaration &&
                        (TP.isXMLDocument(node) ||
                             TP.isXMLDocument(node.parentNode))) {
                        if (!str.startsWith('<?xml ')) {
                            str = TP.XML_10_HEADER + '\n' + str;
                        }
                    } else {
                        //  Otherwise, if we didn't want a declaration, but
                        //  there was one, slice the header off.
                        if (str.startsWith('<?xml ')) {
                            str = str.slice(str.indexOf('?>') + 2);
                        }
                    }
                } catch (e) {
                    //  work around another Mozilla bug/trap
                    if (/restricted URI/.test(TP.str(e))) {
                        if (TP.isElement(node)) {
                            str = TP.elementGetOuterContent(node);
                        } else if (TP.isDocument(node)) {
                            str = TP.elementGetOuterContent(
                                                node.documentElement);
                        } else {
                            str = node.innerHTML;
                        }
                    } else {
                        TP.raise(this, 'TP.sig.SerializationException',
                                    TP.ec(e));
                        str = 'Serialization failed.';
                    }
                }

                //  If the node was originally an HTML node, then we need to
                //  make sure its return value is HTML
                if (TP.isHTMLNode(node)) {
                    return TP.stringAsHTMLString(str);
                } else {
                    return str;
                }
        }

        return null;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeCloneNode',
TP.hc(
    'test',
    'webkit',
    'true',
    function(aNode, deep, viaString) {

        /**
         * @method nodeCloneNode
         * @summary Clones a node, deeply if the 'deep' parameter is true.
         * @description If aNode is an XML Document node, this method builds and
         *     returns a proper clone of it. It it is an HTML Document node it
         *     returns null.
         * @param {Node|XMLDocument} aNode The node to clone.
         * @param {Boolean} deep Whether or not to clone the node 'deeply' (that
         *     is, to recursively clone its children). Defaults to true.
         * @param {Boolean} viaString If deep, this flag will cause the cloning
         *     to use string-based operations to ensure Moz doesn't mess up the
         *     document reference. Defaults to false.
         * @example Clone an HTML element:
         *     <code>
         *          TP.nodeCloneNode(TP.documentGetBody(document));
         *          <samp>[object HTMLBodyElement]</samp>
         *     </code>
         * @example Clone an XML document:
         *     <code>
         *          xmlDoc = TP.doc('<foo><bar><baz/></bar></foo>');
         *          <samp>[object XMLDocument]</samp>
         *          TP.nodeCloneNode(xmlDoc);
         *          <samp>[object XMLDocument]</samp>
         *     </code>
         * @example Clone an XML element:
         *     <code>
         *          xmlDoc = TP.doc('<foo><bar><baz/></bar></foo>');
         *          <samp>[object XMLDocument]</samp>
         *          theElem =
         *         TP.nodeCloneNode(xmlDoc.documentElement.firstChild);
         *          <samp>[object Element]</samp>
         *          TP.nodeAsString(theElem);
         *          <samp>&lt;bar&gt;&lt;baz&gt;&lt;/baz&gt;&lt;/bar&gt;</samp>
         *     </code>
         * @returns {Node} The resulting clone of aNode.
         * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
         *     the method.
         */

        var shouldBeDeep,
            useString,
            newDoc,
            newDocElem;

        if (!TP.isNode(aNode)) {
            return TP.raise(this, 'TP.sig.InvalidNode');
        }

        //  We can't clone an HTML document
        if (TP.isHTMLDocument(aNode)) {
            return null;
        }

        shouldBeDeep = TP.ifInvalid(deep, true);

        //  Webkit doesn't implement cloning of 'Node.DOCUMENT_NODE's.
        //  http://bugs.webkit.org/show_bug.cgi?id=11646
        //  Therefore, we use another technique.
        if (TP.isXMLDocument(aNode)) {
            //  TODO: This technique assumes that there's only the document
            //  element in the source document. There may be other stuff at
            //  the 'top level' that should be cloned.

            //  NB: As of Chrome 6ish version of Webkit, the following
            //  technique is necessary:
            //      1.  Create the document with a nonsense element.
            //      2.  Import the document element of the existing document
            //          into the new document.
            //      3.  Replace the existing document element of the new
            //          document (i.e. the nonsense element) with the
            //          imported document element.
            newDoc = TP.constructDocument(null, 'nonsense');

            newDocElem = newDoc.importNode(aNode.documentElement,
                                            shouldBeDeep);
            newDoc.replaceChild(newDocElem, newDoc.documentElement);

            return newDoc;
        }

        useString = TP.ifInvalid(viaString, false);

        if (shouldBeDeep && useString) {
            if (TP.isXMLDocument(aNode)) {
                return TP.documentFromString(TP.nodeAsString(aNode));
            } else {
                return TP.nodeFromString(TP.nodeAsString(aNode));
            }
        }

        //  Use the standard 'cloneNode' mechanism.
        return aNode.cloneNode(shouldBeDeep);
    },
    TP.DEFAULT,
    function(aNode, deep, viaString) {

        /**
         * @method nodeCloneNode
         * @summary Clones a node, deeply if the 'deep' parameter is true.
         * @description If aNode is an XML Document node, this method builds and
         *     returns a proper clone of it. It it is an HTML Document node it
         *     returns null.
         * @param {Node|XMLDocument} aNode The node to clone.
         * @param {Boolean} deep Whether or not to clone the node 'deeply' (that
         *     is, to recursively clone its children). Defaults to true.
         * @param {Boolean} viaString If deep, this flag will cause the cloning
         *     to use string-based operations to ensure Moz doesn't mess up the
         *     document reference. Defaults to false.
         * @example Clone an HTML element:
         *     <code>
         *          TP.nodeCloneNode(TP.documentGetBody(document));
         *          <samp>[object HTMLBodyElement]</samp>
         *     </code>
         * @example Clone an XML document:
         *     <code>
         *          xmlDoc = TP.doc('<foo><bar><baz/></bar></foo>');
         *          <samp>[object XMLDocument]</samp>
         *          TP.nodeCloneNode(xmlDoc);
         *          <samp>[object XMLDocument]</samp>
         *     </code>
         * @example Clone an XML element:
         *     <code>
         *          xmlDoc = TP.doc('<foo><bar><baz/></bar></foo>');
         *          <samp>[object XMLDocument]</samp>
         *          theElem =
         *         TP.nodeCloneNode(xmlDoc.documentElement.firstChild);
         *          <samp>[object Element]</samp>
         *          TP.nodeAsString(theElem);
         *          <samp>&lt;bar&gt;&lt;baz&gt;&lt;/baz&gt;&lt;/bar&gt;</samp>
         *     </code>
         * @returns {Node} The resulting clone of aNode.
         * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
         *     the method.
         */

        var shouldBeDeep,
            useString;

        if (!TP.isNode(aNode)) {
            return TP.raise(this, 'TP.sig.InvalidNode');
        }

        //  We can't clone an HTML document
        if (TP.isHTMLDocument(aNode)) {
            return null;
        }

        shouldBeDeep = TP.ifInvalid(deep, true);
        useString = TP.ifInvalid(viaString, false);

        if (shouldBeDeep && useString) {
            if (TP.isXMLDocument(aNode)) {
                return TP.documentFromString(TP.nodeAsString(aNode));
            } else {
                return TP.nodeFromString(TP.nodeAsString(aNode));
            }
        }

        //  Use the standard 'cloneNode' mechanism.
        return aNode.cloneNode(shouldBeDeep);
    }
));

//  ------------------------------------------------------------------------
//  UTILITY DATA STRUCTURES
//  ------------------------------------------------------------------------

//  Lastly, we execute some functions that will set up certain data
//  structures for the various platforms.
TP.runConditionalFunction(
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function() {

        TP.regex.GECKO_XML_PARSE =
            /XML Parsing Error: ([^\n]+)\nLocation: [^\n]+\nLine Number (\d+), Column (\d+)/;

        return;
    },
    'webkit',
    function() {

        TP.regex.WEBKIT_XML_PARSE =
            /error on line (\d+) at column (\d+): ([^<]+)/;

        return;
    }
));

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETDOMPrimitivesPost.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
*/

//  ------------------------------------------------------------------------
//  DOCUMENT PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('constructDocument',
function(aNamespace, aTagname) {

    /**
     * @method constructDocument
     * @summary Creates an XML document. Note that if a tag name isn't
     *     supplied to this method, a documentElement will *not* be created
     *     for the returned document.
     * @param {String} aNamespace The namespace to use. Defaults to the null
     *     namespace.
     * @param {String} aTagname The element name to use for the document
     *     element. Defaults to ''.
     * @example Create an XML document, with no namespace and no document
     *     element:
     *     <code>
     *          xmlDoc = TP.constructDocument();
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeAsString(xmlDoc);
     *          <samp></samp>
     *     </code>
     * @example Create an XML document, with no namespace and a document
     *     element of 'foo':
     *     <code>
     *          xmlDoc = TP.constructDocument(null, 'foo');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeAsString(xmlDoc);
     *          <samp>&lt;foo xmlns=""/&gt;</samp>
     *     </code>
     * @example Create an XML document, with a default namespace of
     *     'http://www.bar.com' and a document element of 'foo':
     *     <code>
     *          xmlDoc = TP.constructDocument('http://www.bar.com', 'foo');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeAsString(xmlDoc);
     *          <samp>&lt;foo xmlns="http://www.bar.com"/&gt;</samp>
     *     </code>
     * @example Create an XML document, with a 'bar' prefixed namespace of
     *     'http://www.bar.com' and a document element of 'foo':
     *     <code>
     *          xmlDoc = TP.constructDocument('http://www.bar.com',
     *          'bar:foo');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeAsString(xmlDoc);
     *          <samp>&lt;bar:foo xmlns:bar="http://www.bar.com"/&gt;</samp>
     *     </code>
     * @returns {XMLDocument} The newly created XML document.
     */

    var theNamespace,
        theTagName,
        parts,

        newDocStr,

        retVal;

    theNamespace = aNamespace;
    theTagName = TP.ifInvalid(aTagname, '');

    //  If we were handed both a namespace and a root tag name then we
    //  should build a document by TP.documentFromString()ing standard
    //  XML.
    //  This avoids a lot of problems in W3C-compliant browsers when
    //  dealing with XML documents, namespaces, etc.
    if (TP.notEmpty(theNamespace) && TP.notEmpty(theTagName)) {
        parts = theTagName.split(':');
        if (parts.getSize() > 1) {
            newDocStr = TP.join('<', theTagName,
                                ' xmlns:', parts.at(0), '="',
                                theNamespace, '">',
                                '</', theTagName, '>');
        } else {
            newDocStr = TP.join('<', theTagName, ' xmlns="',
                                theNamespace,
                                '"></', theTagName, '>');
        }

        retVal = TP.documentFromString(newDocStr);
    } else if (TP.isEmpty(theNamespace) && TP.notEmpty(theTagName)) {
        newDocStr = TP.join('<', theTagName, ' xmlns="">',
                            '</', theTagName, '>');

        retVal = TP.documentFromString(newDocStr);
    } else if (TP.notEmpty(theTagName)) {
        //  Otherwise, we were just handed a root tag name, so go ahead
        //  and use that.
        newDocStr = TP.join('<', theTagName, '></', theTagName, '>');

        retVal = TP.documentFromString(newDocStr);
    } else {
        //  They were both empty, so just use the 'createDocument' call.
        retVal = document.implementation.createDocument('', '', null);
    }

    retVal[TP.IS_XML] = true;

    if (TP.isElement(retVal.documentElement) &&
        retVal.documentElement.namespaceURI === TP.w3.Xmlns.XHTML) {

        retVal[TP.IS_XHTML] = true;
    }

    return retVal;
});

//  ------------------------------------------------------------------------

TP.XML_FACTORY_DOCUMENT = TP.constructDocument();

//  ------------------------------------------------------------------------

TP.definePrimitive('documentConstructElement',
function(aDocument, elementName, elementNS) {

    /**
     * @method documentConstructElement
     * @summary Creates a new element in the document and namespace provided.
     * @param {Document} aDocument The document that will contain the new
     *     element.
     * @param {String} elementName The element type.
     * @param {String} elementNS The namespace to use.
     * @example Create an HTML element in an HTML document:
     *     <code>
     *          TP.documentConstructElement(document, 'span');
     *          <samp>[object HTMLSpanElement]</samp>
     *     </code>
     * @example Create an XHTML element in an XML document:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo
     *         xmlns="http://www.foo.com"/>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.documentConstructElement(xmlDoc, 'span', TP.w3.Xmlns.XHTML);
     *          <samp>[object HTMLSpanElement]</samp>
     *     </code>
     * @returns {Element} The newly created Element.
     * @exception TP.sig.InvalidDocument Raised when an invalid document is
     *     provided to the method.
     * @exception TP.sig.InvalidString Raised when a null or empty element name
     *     is provided to the method.
     * @exception TP.sig.DOMConstructException Raised when the element cannot be
     *     constructed in the supplied document.
     */

    var aNamespace,
        newElement;

    if (!TP.isDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    if (TP.isEmpty(elementName)) {
        return TP.raise(this, 'TP.sig.InvalidElementType');
    }

    //  The namespace is the 'null namespace' by default.
    aNamespace = TP.ifInvalid(elementNS, '');

    try {
        //  If it's an XML document or the namespace is SVG, create the
        //  element using createElementNS.
        if (TP.isXMLDocument(aDocument) || elementNS === TP.w3.Xmlns.SVG) {
            newElement = aDocument.createElementNS(aNamespace,
                                                    elementName);
        } else {
            newElement = aDocument.createElement(elementName);
        }
    } catch (e) {
        return TP.raise(this, 'TP.sig.DOMConstructException',
                        TP.ec(e));
    }

    return newElement;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentFromNode',
function(aNode) {

    /**
     * @method documentFromNode
     * @summary Wraps a copy of aNode in a new XML document or returns aNode if
     *     its already an XML document.
     * @param {Node} aNode The Node to wrap.
     * @example Obtain a XML document from an XML document Node:
     *     <code>
     *          xmlDoc = TP.doc('<foo bar="baz"/>');
     *          <samp>[object XMLDocument]</samp>a
     *          // Returns itself
     *          TP.documentFromNode(xmlDoc) === xmlDoc;
     *          <samp>true</samp>
     *     </code>
     * @example Obtain a XML document from an XML Node:
     *     <code>
     *          xmlDoc = TP.doc('<foo bar="baz"/>');
     *          <samp>[object XMLDocument]</samp>
     *          // Creates a new XML document and moves xmlDoc's
     *          // document element to it.
     *          fooDoc = TP.documentFromNode(xmlDoc.documentElement);
     *          fooDoc === xmlDoc;
     *          <samp>false</samp>
     *     </code>
     * @returns {XMLDocument} The new XML document wrapping aNode or aNode if
     *     its already an XML document.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     * @exception TP.sig.InvalidXMLDocument Raised when the node supplied is not
     *     part of an XML document.
     */

    var node,
        newDoc;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    //  If the supplied node is already an XML document, just return it.
    if (TP.isXMLDocument(aNode)) {
        return aNode;
    }

    //  get an xml node from any html nodes provided if at all possible
    if (!TP.isXMLDocument(TP.nodeGetDocument(aNode))) {
        node = TP.doc(TP.xmlnode(aNode));
        if (!TP.isXMLNode(node)) {
            return TP.raise(this,
                            'TP.sig.InvalidXMLDocument',
                            aNode);
        }
    } else {
        node = aNode;
    }

    //  Create a new XML document and append the node to it as the first
    //  child. Normally this would be the document element.
    newDoc = TP.constructDocument();

    //  TP.nodeAppendChild() will automatically import the appended node if
    //  it needs to.

    //  Note here how we pass 'false' to *not* awaken any content that gets
    //  appended.
    TP.nodeAppendChild(newDoc, TP.nodeCloneNode(aNode, true), false);

    return newDoc;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentAddContent',
function(aDocument, theContent, loadedFunction, shouldAwake) {

    /**
     * @method documentAddContent
     * @summary Adds content from theContent onto the end of the child content
     *     of the document element of the supplied document.
     * @param {Document} aDocument The document receiving content.
     * @param {Object} theContent The object to use as the source of the
     *     content.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just added. The default for an 'add' operation is false.
     * @exception TP.sig.InvalidDocument
     * @returns {Node} The first node of the content that was just inserted.
     */

    var content;

    if (!TP.isDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument',
                                'Must provide a target Document.');
    }

    if (TP.notValid(theContent)) {
        TP.nodeEmptyContent(aDocument);
    }

    //  this allows us to accept things like TP.uri.URI, TP.dom.Node, etc.
    //  and to process them as the content routines would expect.
    content = TP.canInvoke(theContent, 'getResource') ?
                theContent.getResource(
                    TP.hc('resultType', TP.DOM)).get('result') :
                theContent;
    content = TP.unwrap(content);

    if (TP.isHTMLNode(aDocument)) {
        return TP.htmlDocumentAddContent(aDocument, content,
                                            loadedFunction, shouldAwake);
    } else {
        return TP.xmlDocumentAddContent(aDocument, content,
                                            loadedFunction, shouldAwake);
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentInsertContent',
function(aDocument, theContent, aPositionOrPath, loadedFunction, shouldAwake) {

    /**
     * @method documentInsertContent
     * @summary Inserts content from theContent into aDocument based on the
     *     position given. NOTE that the position given is utilized relative to
     *     the documentElement so TP.BEFORE_BEGIN and TP.AFTER_END are invalid
     *     positions.
     * @param {Document} aDocument The document receiving content.
     * @param {Object} theContent The object to use as the source of the
     *     content.
     * @param {String} aPositionOrPath The position to place the content
     *     relative to the document's documentElement or a path to evaluate to
     *     get to a node at that position. This should be one of four values:
     *     TP.BEFORE_BEGIN, TP.AFTER_BEGIN, TP.BEFORE_END, TP.AFTER_END or the
     *     path to evaluate. Default is TP.BEFORE_END.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just inserted. The default for an 'insert' operation is false.
     * @exception TP.sig.InvalidDocument
     * @returns {Node} The first node of the content that was just inserted.
     */

    var positionOrPath,
        content;

    if (!TP.isDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument',
                                'Must provide a target Document.');
    }

    if (TP.notValid(theContent)) {
        return;
    }

    positionOrPath = TP.ifEmpty(aPositionOrPath, TP.BEFORE_END);

    //  this allows us to accept things like TP.uri.URI, TP.dom.Node, etc.
    //  and to process them as the content routines would expect.
    content = TP.canInvoke(theContent, 'getResource') ?
                theContent.getResource(
                    TP.hc('resultType', TP.DOM)).get('result') :
                theContent;
    content = TP.unwrap(content);

    if (TP.isHTMLNode(aDocument)) {
        return TP.htmlDocumentInsertContent(aDocument, content,
                                            positionOrPath,
                                            loadedFunction, shouldAwake);
    } else {
        return TP.xmlDocumentInsertContent(aDocument, content,
                                            positionOrPath,
                                            loadedFunction, shouldAwake);
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentPathContainsNode',
function(aDocument, aNode, aPath, aPathType) {

    /**
     * @method documentPathContainsNode
     * @summary Evaluates the path provided, producing a set of nodes that
     *     match the expression. If that result set contains aNode, then this
     *     method returns true, otherwise it returns false. There are several
     *     path types which might be used, but the most typical are XPaths,
     *     XPointers (which include xpointer(), xpath1() and element() schemes),
     *     and CSS queries. The latter are rare since the focus here is largely
     *     on "paths" and CSS selectors don't strictly define a path.
     * @param {Document} aDocument The document or element to query.
     * @param {Node} aNode The node to test against the result set.
     * @param {String} aPath The path to traverse in locating a value.
     * @param {String} aPathType One of the 'path type' constants:
     *     TP.XPATH_PATH_TYPE
     *     TP.XPOINTER_PATH_TYPE
     *     TP.ELEMENT_PATH_TYPE
     *     TP.XTENSION_POINTER_PATH_TYPE
     *     TP.CSS_PATH_TYPE
     *     TP.BARENAME_PATH_TYPE
     * @returns {Boolean} Whether or not aNode is contained in the set of
     *     results obtained by evaluating aPath against aDocument.
     * @exception TP.sig.InvalidPath Raised when an invalid path is provided to
     *     the method.
     * @exception TP.sig.InvalidDocument Raised when an invalid document is
     *     provided to the method.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     */

    var result,

        len,
        i;

    if (TP.notValid(aDocument)) {
        TP.raise(this, 'TP.sig.InvalidDocument');

        return;
    }

    if (TP.notValid(aNode)) {
        TP.raise(this, 'TP.sig.InvalidNode');

        return;
    }

    //  no query, no result
    if (TP.isEmpty(aPath)) {
        return TP.raise(this, 'TP.sig.InvalidPath');
    }

    //  Note here how we force autoCollapse to false, since we're gonna loop
    //  below anyway.
    result = TP.nodeEvaluatePath(aDocument, aPath, aPathType, false);

    len = result.getSize();
    for (i = 0; i < len; i++) {
        if (result.at(i) === aNode) {
            return true;
        }
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentSetContent',
function(aDocument, theContent, loadedFunction, shouldAwake) {

    /**
     * @method documentSetContent
     * @summary Inserts content from theContent into aDocument, replacing any
     *     current content.
     * @param {Document} aDocument The document receiving content.
     * @param {Object} theContent The object to use as the source of the
     *     content.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just set. The default for a 'set' operation is whether aDocument has
     *     a Window object associated with it or not.
     * @exception TP.sig.InvalidDocument
     * @returns {Node} The first node of the content that was just inserted.
     */

    var content,

        localName;

    if (!TP.isDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument',
                                'Must provide a target Document.');
    }

    if (TP.notValid(theContent)) {
        TP.nodeEmptyContent(aDocument);
    }

    //  this allows us to accept things like TP.uri.URI, TP.dom.Node, etc.
    //  and to process them as the content routines would expect.
    content = TP.canInvoke(theContent, 'getResource') ?
                theContent.getResource(
                    TP.hc('resultType', TP.DOM)).get('result') :
                theContent;
    content = TP.unwrap(content);

    if (TP.isHTMLNode(aDocument)) {
        if (TP.isElement(theContent)) {
            localName = TP.elementGetLocalName(theContent).toLowerCase();

            //  We test the local name of the content we're append to make
            //  sure that if its an 'html' or 'body' node, that we're
            //  appending to the appropriate place.
            if (localName === 'html') {
                return TP.htmlDocumentSetContent(aDocument,
                                                    content,
                                                    loadedFunction,
                                                    shouldAwake);
            } else if (localName === 'body') {
                return TP.htmlElementSetContent(aDocument.documentElement,
                                                content,
                                                loadedFunction,
                                                shouldAwake);
            } else {
                return TP.htmlElementSetContent(
                                            TP.documentGetBody(aDocument),
                                            content,
                                            loadedFunction,
                                            shouldAwake);
            }
        } else {
            //  It's not a Node -- maybe a String.
            return TP.htmlDocumentSetContent(aDocument,
                                                content,
                                                loadedFunction,
                                                shouldAwake);
        }
    } else {
        return TP.xmlDocumentSetContent(aDocument, content,
                                        loadedFunction, shouldAwake);
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('xmlDocumentAddContent',
function(aDocument, theContent, loadedFunction, shouldAwake) {

    /**
     * @method xmlDocumentAddContent
     * @summary Adds content from theContent onto the end of the child content
     *     of the document element of the supplied document.
     * @param {Document} aDocument The document to receive the content.
     * @param {Node|String} theContent The object to use as the source of the
     *     content.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just added. The default for an 'add' operation is false.
     * @exception TP.sig.InvalidDocument
     * @returns {Node} The first node of the content that was just inserted.
     */

    if (!TP.isXMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    return TP.xmlElementAddContent(aDocument.documentElement,
                                    theContent,
                                    loadedFunction,
                                    shouldAwake);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('xmlDocumentInsertContent',
function(aDocument, theContent, aPositionOrPath, loadedFunction, shouldAwake) {

    /**
     * @method xmlDocumentInsertContent
     * @summary Inserts content from theContent into/around the document
     *     element of the supplied document based on the position given. The
     *     position should indicate whether the content should become the
     *     previous sibling, next sibling, first child or last child.
     * @param {Document} aDocument The document to receive the content.
     * @param {Node|String} theContent The object to use as the source of the
     *     content.
     * @param {String} aPositionOrPath The position to place the content
     *     relative to the document's documentElement or a path to evaluate to
     *     get to a node at that position. This should be one of four values:
     *     TP.BEFORE_BEGIN, TP.AFTER_BEGIN, TP.BEFORE_END, TP.AFTER_END or the
     *     path to evaluate. Default is TP.BEFORE_END.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just inserted. The default for an 'insert' operation is false.
     * @exception TP.sig.InvalidDocument
     * @returns {Node} The first node of the content that was just inserted.
     */

    if (!TP.isXMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    return TP.xmlElementInsertContent(aDocument.documentElement,
                                        theContent,
                                        aPositionOrPath,
                                        loadedFunction,
                                        shouldAwake);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('xmlDocumentSetContent',
function(aDocument, theContent, loadedFunction, shouldAwake) {

    /**
     * @method xmlDocumentSetContent
     * @summary Sets the content of the supplied document, replacing the
     *     document's documentElement with the resulting content if valid.
     * @description Content sent to a document must be suitable for replacing
     *     the entire content of the document, i.e. it becomes the source of the
     *     new documentElement. This implies that the content must be able to
     *     provide a valid node containing a single root element of the same
     *     document type (XML vs HTML).
     * @param {Document} aDocument The document to receive the content.
     * @param {Node|String} theContent The object to use as the source of the
     *     content.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just set. The default for a 'set' operation is whether aDocument has
     *     a Window object associated with it or not.
     * @returns {Node} The first node of the content that was just inserted. In
     *     this case, the documentElement.
     */

    var hasWindow,

        awakenContent,
        nodeContent,

        docElem,

        newEvent,

        scriptURLs,

        allContentLoadedFunc,

        lastSourcedScript,

        scripts,
        scriptTextSiblingsContents,
        nextScriptSibling,

        i,

        docHead,

        styleLinks,

        loadFunc,

        scriptCount,

        totalCount;

    if (!TP.isXMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  Note whether or not the document has a window. This is used later to
    //  determine whether to try to emulate standard browser behavior.
    hasWindow = TP.nodeHasWindow(aDocument);

    awakenContent = TP.ifInvalid(shouldAwake, hasWindow);

    //  If the content is an XML node, then we just make sure its an
    //  Element, and not a Document.
    if (TP.isXMLNode(theContent)) {
        if (TP.isDocument(theContent)) {
            nodeContent = theContent.documentElement;
        } else {
            nodeContent = theContent;
        }

        //  Make sure to clone this content since we're going to be manipulating
        //  it below and don't want to modify the original.
        nodeContent = TP.nodeCloneNode(nodeContent, true);
    } else if (TP.isString(theContent)) {
        //  Try to create a real Node from the supplied content (passing
        //  'true' to TP.nodeAsString() so that it will report parsing
        //  errors). If we can't parse a valid Node from the content, we
        //  just create a Text node using the content and use that.
        if (TP.notValid(nodeContent =
                        TP.nodeFromString(theContent, null, true))) {
            nodeContent = TP.nodeGetDocument(nodeContent).createTextNode(
                                                                theContent);
        }
    } else {
        TP.raise(this, 'TP.sig.UnsupportedOperation');

        return null;
    }

    //  Set the TIBET flag that says we're "document.write()ing" (we are
    //  doing the XML equivalent thereof)
    TP.core.Window.$$isDocumentWriting = true;

    //  If we have a window, then create and dispatch an 'unload' event.
    //  Note how this is dispatched from the window's document, which is
    //  required to make it work.
    if (hasWindow) {

        newEvent = aDocument.createEvent('Event');
        newEvent.initEvent('unload', true, true);
        aDocument.dispatchEvent(newEvent);
    }

    docElem = aDocument.documentElement;

    //  Manually invoke the mutation removal event machinery. This won't happen
    //  automatically, since by emptying the content of the document above, we
    //  blew away the Mutation Observer registration.
    if (TP.isElement(docElem) && awakenContent) {
        TP.core.MutationSignalSource[TP.composeHandlerName('MutationEvent')](
            {
                type: 'childList',
                target: docElem,
                removedNodes: TP.ac(docElem)
            });
    }

    //  Clear out the document's existing content.
    TP.nodeEmptyContent(aDocument);

    //  Script elements have to be treated specially. They won't be executed
    //  simply by placing their ancestor (in this case 'nodeContent') into the
    //  document, so we must manually process them (i.e. create new ones using
    //  the same URLs and add them individually - then they will be invoked
    //  properly).

    //  But because of the way they are processed by browsers, and because of
    //  the way that certain browsers (Chrome) will retain information (and
    //  attempt to act on that information) about script elements even if they
    //  are removed from the document, we make sure to capture their URLs
    //  *before* we set it into the document.

    //  Grab all of the existing script nodes.
    scriptURLs = TP.ac();
    scripts = TP.nodeGetElementsByTagName(nodeContent,
                                            'script',
                                            TP.w3.Xmlns.XHTML);

    scriptTextSiblingsContents = TP.ac();

    //  Loop over them, capture their 'src' URL *and remove them from the
    //  document*. If they have following sibling content that consists of a
    //  Text node, capture that too.
    for (i = 0; i < scripts.getSize(); i++) {

        //  Note here how we get the *attribute* value of 'src' - not the
        //  property value. We want the original value the author entered and
        //  not adjusted for pathing.
        scriptURLs.push(scripts.at(i).getAttribute('src'));

        //  If the next sibling after the script node is a text node, we capture
        //  its contents and will put them back after we re-create the script
        //  nodes below. This lessens the impact of this process on the
        //  formatting of authored content.
        nextScriptSibling = scripts.at(i).nextSibling;
        if (TP.isTextNode(nextScriptSibling)) {
            scriptTextSiblingsContents.push(nextScriptSibling.nodeValue);
            TP.nodeDetach(nextScriptSibling);
        }

        TP.nodeDetach(scripts.at(i));
    }

    //  Append the new child into the target document
    TP.nodeAppendChild(aDocument, nodeContent, awakenContent);

    docHead = TP.documentEnsureHeadElement(aDocument);

    //  Grab all of the 'style related' link elements.
    styleLinks = TP.ac(docHead.querySelectorAll('link[type="text/css"]'));

    //  Since script elements, if we have them and they have a 'src'
    //  attribute, may be processed and fully realized in an asynchronous
    //  manner, we define a callback function that 'finishes up' the last parts
    //  of our simulated 'document.write()'. This includes dispatching a
    //  'DOMContentLoaded' event and calling any callback function supplied
    //  to this method.
    allContentLoadedFunc =
        function() {

            if (TP.isValid(lastSourcedScript)) {
                lastSourcedScript.onload = null;
            }

            //  We only signal TP.sig.DOMContentLoaded if the system is
            //  configured for it.
            if (TP.sys.shouldSignalDOMLoaded()) {
                if (hasWindow) {
                    //  If we have a window, then create and dispatch a
                    //  'DOMContentLoaded' event from the document as per
                    //  standard browser behavior..

                    //  This will eventually signal TP.sig.DOMContentLoaded via
                    //  the TP.$$processDocumentLoaded() call.
                    newEvent = aDocument.createEvent('HTMLEvents');
                    newEvent.initEvent('DOMContentLoaded', true, true);
                    aDocument.dispatchEvent(newEvent);
                } else {
                    try {
                        //  For document level operations this is the only
                        //  place we can properly signal
                        //  TP.sig.DOMContentLoaded since we want to be sure
                        //  it's really loaded and need to wait for the
                        //  onload triggering of this handler
                        TP.signal(TP.gid(aDocument),
                                    'TP.sig.DOMContentLoaded',
                                    aDocument.documentElement);
                    } catch (e) {
                        TP.ifError() ?
                            TP.error(
                                TP.ec(
                                    e, 'TP.sig.DOMContentLoaded handler' +
                                        ' generated error.')) : 0;
                    }
                }
            }

            //  Execute any loaded function that we were handed.
            if (TP.isCallable(loadedFunction)) {
                loadedFunction(aDocument);
            }

            //  clear the flag once we process our load function
            TP.core.Window.$$isDocumentWriting = false;
        };

    //  Now, using the scriptURLs and styleLinks Arrays as queues, set up a
    //  recursively called load handler that will be called back as each
    //  'script' or 'link' element is processed.

    //  For the gathered script URLs, we create a script element for each one,
    //  set its 'load' event handler to the load handler and then append the
    //  new script element to the head.

    //  First, capture the total number of scripts and style links. We'll use
    //  this number to count down so that we know when we're done.
    totalCount = scriptURLs.getSize() + styleLinks.getSize();

    //  This ensures that each script is loaded in order and is completely
    //  finished loading before the next script is loaded.
    scriptCount = 0;
    loadFunc = function(evt) {
        var scriptURL,

            newScript,

            textSiblingContent,

            styleLink,
            styleSheets,
            j,
            len,
            foundOne;

        if (TP.isEvent(evt)) {
            TP.eventGetTarget(evt).removeEventListener('load', loadFunc, false);
            //  Make sure to decrement the counter so that, when it reaches 0,
            //  we know we're done.
            totalCount--;
        }

        if (TP.notEmpty(styleLinks)) {

            //  Shift off the next style link element out of the queue
            styleLink = styleLinks.shift();

            foundOne = false;

            //  Grab the list of style sheets already installed in our document.
            styleSheets = aDocument.styleSheets;

            //  Iterate over them, looking for an href that will match the one
            //  in the stylesheet we're processing. If we find one, flip the
            //  flag.
            len = styleSheets.length;
            for (j = 0; j < len; j++) {
                if (styleSheets[j].href === styleLink.href) {
                    foundOne = true;
                    break;
                }
            }

            //  The stylesheet we're processing wasn't in the list of style
            //  sheets already attached to the document (which will only happen
            //  when they are done loading), so install a 'load' handler on it.
            if (!foundOne) {
                styleLink.addEventListener('load', loadFunc, false);
            } else {
                //  The stylesheet we are processing was already loaded. Since
                //  we've already removed it from our list of style links, we
                //  just need to re-invoke the load function manually (after
                //  decrementing our counter, since we won't call back here).
                totalCount--;
                loadFunc();
            }
        } else if (TP.notEmpty(scriptURLs)) {

            //  Shift off the next script URL out of the queue
            scriptURL = scriptURLs.shift();

            newScript = TP.documentConstructScriptElement(
                                    aDocument,
                                    scriptURL);
            newScript.addEventListener('load', loadFunc, false);

            //  Append it into the document head.
            TP.nodeAppendChild(docHead, newScript, false);

            //  If there is text sibling content for this particular script
            //  node, then append it after the new script node.
            textSiblingContent = scriptTextSiblingsContents.at(scriptCount);
            if (TP.notEmpty(textSiblingContent)) {
                TP.nodeAppendChild(
                        docHead,
                        aDocument.createTextNode(textSiblingContent),
                        false);
            }

            //  Make sure to increment the scriptCount for the next pass!
            scriptCount++;
        } else if (totalCount === 0) {

            //  If our total count is at 0, then we're done. Finish up.

            //  Make sure window listeners etc for content loaded are ready.
            TP.core.Window.installLoadUnloadHooks(TP.nodeGetWindow(aDocument));

            //  There are no more scripts - invoke the Function that signals
            //  that all content has been loaded, but do so *after* the next
            //  repaint.
            allContentLoadedFunc.queueAfterNextRepaint(aDocument.defaultView);
        }
    };

    //  Invoke the function once manually to 'kick start' everything.
    loadFunc();

    //  Return the document's documentElement, which should be the new
    //  element.
    return aDocument.documentElement;
});

//  ------------------------------------------------------------------------
//  ATTRIBUTE PRIMITIVES
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  ATTRIBUTE STRING CONVERSION
//  ------------------------------------------------------------------------

TP.definePrimitive('attributeStringAsHash',
function(aAttributeString) {

    /**
     * @method attributeStringAsHash
     * @summary Converts a properly formatted attribute string into the
     *     equivalent TP.core.Hash.
     * @param {String} aAttributeString A string of the form key="value"
     *     key="value".
     * @returns {TP.core.Hash} A new hash of attribute property/value pairs.
     */

    if (TP.isEmpty(aAttributeString)) {
        return TP.hc();
    }

    return TP.core.Hash.fromString(aAttributeString);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('attributeStringFromHash',
function(aHash) {

    /**
     * @method attributeStringFromHash
     * @summary Returns the provided hash's key/value pairs as a valid XML
     *     element attribute string.
     * @param {TP.core.Hash} aHash A valid TP.core.Hash containing keys suitable
     *     for a XML element.
     * @returns {String} A String in the format of an XML element attribute
     *     string.
     */

    var str,

        keys,
        len,
        i,

        key,
        val;

    if (TP.isEmpty(aHash)) {
        return '';
    }

    str = TP.ac();

    keys = TP.keys(aHash);
    len = keys.getSize();

    for (i = 0; i < len; i++) {
        key = keys.at(i);
        val = aHash.at(key);

        //  We only generate an attribute string chunk if the value is valid.
        if (TP.isValid(val)) {
            str.push(TP.str(key), '="', TP.str(val), '" ');
        }
    }

    str = str.join('');

    //  Slice off the last space
    return str.slice(0, str.getSize() - 1);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('attributeGetCanonicalName',
function(anAttributeNode) {

    /**
     * @method attributeGetCanonicalName
     * @summary Returns the prefix:attrname form of the attribute's name, using
     *     namespaceURI data and TIBET's XMLNS information to return the
     *     canonical prefix version.
     * @description Note that, in XML documents, if an attribute doesn't have a
     *     prefix, then its not considered a part of any namespace and therefore
     *     it will just returns its name. In an HTML document (which knows
     *     nothing of namespaces), this routine will 'fake' a prefix for
     *     non-prefixed attributes by prepending an 'html:' prefix onto them.
     *     This method, unlike TP.attributeGetFullName(), ignores any prefix
     *     given by the author to an attribute and attempts to compute a prefix
     *     by using any namespace information the attribute node may have. For
     *     instance, the author might have called the attribute 'xf:bind',
     *     because they aliased the prefix 'xf' to the XForms namespace, but
     *     this routine will return 'xforms:bind', since 'xforms' is the
     *     'canonical' prefix for this namespace. This distinction is important
     *     to the TIBET engine.
     * @param {Attribute} anAttributeNode The attribute node to retrieve the
     *     canonical name for.
     * @example Obtain the canonical name for an HTML attribute node whose name
     *     doesn't have a prefix:
     *     <code>
     *          attrNode =
     *         TP.documentGetBody(document).getAttributeNode('style');
     *          TP.attributeGetCanonicalName(attrNode);
     *          <samp>html:style</samp>
     *     </code>
     * @example Obtain the canonical name for an HTML attribute node whose name
     *     has a prefix (although its not really a namespace, because its HTML):
     *     <code>
     *          TP.elementSetAttribute(TP.documentGetBody(document),
     *          'foo:bar',
     *          'baz');
     *          attrNode =
     *         TP.documentGetBody(document).getAttributeNode('foo:bar');
     *          TP.attributeGetCanonicalName(attrNode);
     *          <samp>foo:bar</samp>
     *     </code>
     * @example Obtain the canonical name for an XML attribute node:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"
     *         xmlns:xf="http://www.w3.org/2002/xforms" xf:bind="theBinder"
     *         goo="moo">Hi there</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          // This attribute is in the default namespace (no prefix)
     *          attrNode = xmlDoc.documentElement.getAttributeNode('goo');
     *          TP.attributeGetCanonicalName(attrNode);
     *          <samp>goo</samp>
     *          // This attribute is in the namespace with the 'xf'
     *          // prefix, but the canonical prefix is 'xforms' for
     *          // that namespace, so that's what get's used.
     *          attrNode =
     *          xmlDoc.documentElement.getAttributeNode('xf:bind');
     *          TP.attributeGetCanonicalName(attrNode);
     *          <samp>xforms:bind</samp>
     *     </code>
     * @returns {String} The attribute's canonical name.
     * @exception TP.sig.InvalidAttributeNode Raised when a non-attribute Node
     *     has been supplied to the method.
     */

    var uri,
        prefix,

        name,

        doc;

    if (!TP.isAttributeNode(anAttributeNode)) {
        return TP.raise(this, 'TP.sig.InvalidAttributeNode');
    }

    //  common case is HTML document attributes, so watch for that since the
    //  entire thing is a bit contrived in HTML
    doc = TP.nodeGetDocument(anAttributeNode);
    if (TP.isHTMLDocument(doc)) {
        //  grab the 'whole' name for the attribute. This may
        //  include a prefix.
        name = anAttributeNode.name;

        //  If the attribute already had a "prefix" (this is an HTML
        //  document after all, so none of this is real...), then
        //  just return that name.
        if (name.indexOf(':') !== TP.NOT_FOUND) {
            return name;
        } else {
            //  didn't have a prefix, so, as long as its owner element is
            //  really an HTML element (it could be SVG/VML), prepend 'html'
            //  and a colon (':') onto the front of the local name and
            //  return that.
            if (TP.isHTMLNode(TP.attributeGetOwnerElement(anAttributeNode))) {
                return 'html:' + name;
            }
        }
    }

    //  authored prefixes are meaningless here... we want to work from
    //  namespaceURI
    uri = TP.nodeGetNSURI(anAttributeNode);
    if (TP.notEmpty(uri)) {
        prefix = TP.w3.Xmlns.getCanonicalPrefix(uri);
    }

    //  if we couldn't get a canonical prefix, then see if we can get an
    //  authored prefix.
    if (TP.isEmpty(prefix)) {
        //  there's an authored prefix, so we'll go ahead use that
        //  (grudgingly...)
        prefix = anAttributeNode.prefix;
    }

    //  grab the local name for the attribute
    name = TP.attributeGetLocalName(anAttributeNode);

    if (TP.isEmpty(prefix)) {
        return name;
    } else {
        return prefix + ':' + name;
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('attributeGetFullName',
function(anAttributeNode) {

    /**
     * @method attributeGetFullName
     * @summary Returns the prefix:attrname form of the attribute's name, if
     *     available.
     * @description Note that, in XML documents, if an attribute doesn't have a
     *     prefix, then its not considered a part of any namespace and therefore
     *     it will just returns its name. In an HTML document (which knows
     *     nothing of namespaces), this routine will 'fake' a prefix for
     *     non-prefixed attributes by prepending an 'html:' prefix onto them.
     *     This method, unlike TP.attributeGetCanonicalName(), does not try to
     *     compute a canonical prefix for the attribute. If the attribute is in
     *     an XML document and has a prefix, it will be returned as part of the
     *     name, otherwise it won't.
     * @param {Attribute} anAttributeNode The attribute node to retrieve the
     *     canonical name for.
     * @example Obtain the full name for an HTML attribute node whose name
     *     doesn't have a prefix:
     *     <code>
     *          attrNode =
     *         TP.documentGetBody(document).getAttributeNode('style');
     *          TP.attributeGetFullName(attrNode);
     *          <samp>html:style</samp>
     *     </code>
     * @example Obtain the full name for an HTML attribute node whose name has a
     *     prefix (although its not really a namespace, because its HTML):
     *     <code>
     *          TP.elementSetAttribute(TP.documentGetBody(document),
     *          'foo:bar',
     *          'baz');
     *          attrNode =
     *         TP.documentGetBody(document).getAttributeNode('foo:bar');
     *          TP.attributeGetFullName(attrNode);
     *          <samp>foo:bar</samp>
     *     </code>
     * @example Obtain the full name for an XML attribute node:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com" xmlns:bar="http://www.bar.com"
     *         bar:baz="bazify" goo="moo">Hi there</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          // This attribute is in the default namespace (no prefix)
     *          attrNode = xmlDoc.documentElement.getAttributeNode('goo');
     *          TP.attributeGetFullName(attrNode);
     *          <samp>goo</samp>
     *          // This attribute is in the namespace with the 'bar'
     *          // prefix
     *          attrNode =
     *          xmlDoc.documentElement.getAttributeNode('bar:baz');
     *          TP.attributeGetFullName(attrNode);
     *          <samp>bar:baz</samp>
     *     </code>
     * @returns {String} The attribute's canonical name.
     * @exception TP.sig.InvalidAttributeNode Raised when a non-attribute Node
     *     has been supplied to the method.
     */

    var name;

    if (!TP.isAttributeNode(anAttributeNode)) {
        return TP.raise(this, 'TP.sig.InvalidAttributeNode');
    }

    //  In XML documents, if an attribute is not prefixed, then it is *not*
    //  considered to be in the 'default namespace' - it is considered to be
    //  in the 'null' namespace, so its very easy here - we just return the
    //  name of the attribute node. If its prefixed so be it and if its not
    //  so be it.
    if (TP.isXMLDocument(TP.nodeGetDocument(anAttributeNode))) {
        return anAttributeNode.name;
    }

    //  Otherwise, we're in an HTML document, which means that most of this
    //  is fake anyway.

    //  grab the 'whole' name for the attribute. This may include a prefix.
    name = anAttributeNode.name;

    //  in the case of HTML attributes, if a ':' has been used as part of
    //  the name (HTML elements don't care about namespaces), then return
    //  that name as the canonical name.
    if (name.indexOf(':') !== TP.NOT_FOUND) {
        return name;
    }

    //  didn't have a prefix, so prepend 'html' and a colon (':') onto the
    //  front of the local name and return that.
    return 'html:' + name;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('attributeGetLocalName',
function(anAttributeNode) {

    /**
     * @method attributeGetLocalName
     * @summary Returns the local name (that is, the name without the prefix)
     *     of the supplied attribute node.
     * @param {Attribute} anAttributeNode The attribute node to retrieve the
     *     local name for.
     * @example Obtain the local name for an attribute node:
     *     <code>
     *          attrNode =
     *         TP.documentGetBody(document).getAttributeNode('style');
     *          TP.attributeGetLocalName(attrNode);
     *          <samp>style</samp>
     *     </code>
     * @returns {String} The local name of the supplied node.
     * @exception TP.sig.InvalidAttributeNode Raised when a non-attribute Node
     *     has been supplied to the method.
     */

    var lname,
        index;

    if (!TP.isAttributeNode(anAttributeNode)) {
        return TP.raise(this, 'TP.sig.InvalidAttributeNode');
    }

    //  W3C-compliant browsers make no distinction between XML and HTML
    //  documents here. If the attribute is in an HTML document, the
    //  'whole name' will be returned since there is no concept of
    //  prefixes, namespaces, etc.
    lname = anAttributeNode.localName;
    if ((index = lname.indexOf(':')) !== TP.NOT_FOUND) {
        lname = lname.slice(index + 1);
    }

    return lname;
});

//  ------------------------------------------------------------------------
//  ELEMENT PRIMITIVES
//  ------------------------------------------------------------------------

/*
Operations that make it easier to work with elements.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('elementAddAttributeValue',
function(anElement, attributeName, attributeValue, checkAttrNSURI) {

    /**
     * @method elementAddAttributeValue
     * @summary Adds the value of the attribute provided to any existing values
     *     which might exist, or sets the attribute to that value. This is used
     *     for space-separated attribute value management.
     * @param {Element} anElement The element to set the attribute on.
     * @param {String} attributeName The attribute to set.
     * @param {String} attributeValue The attribute value.
     * @param {Boolean} [checkAttrNSURI=false] True will cause this method to be
     *     more rigorous in its checks for prefixed attributes, looking via
     *     internal TIBET mechanisms in addition to the standard platform
     *     mechanism. The default is false (to keep things faster).
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     * @exception TP.sig.InvalidName Raised when the supplied attribute name is
     *     empty.
     */

    var value;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(attributeName)) {
        return TP.raise(this, 'TP.sig.InvalidName');
    }

    if (!TP.elementHasAttribute(anElement, attributeName, checkAttrNSURI)) {
        value = attributeValue;
    } else {
        value = TP.elementGetAttribute(anElement, attributeName,
                                                        checkAttrNSURI);
        value = value.split(' ').add(attributeValue).unique().join(' ');
    }

    TP.elementSetAttribute(anElement, attributeName, value, checkAttrNSURI);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementAddContent',
function(anElement, anObject, loadedFunction, shouldAwake) {

    /**
     * @method elementAddContent
     * @summary Adds content from anObject onto the end of the child content of
     *     anElement.
     * @param {Element} anElement The element receiving content.
     * @param {Object} anObject The object to use as the source of the content.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just added. The default for an 'add' operation is false.
     * @exception TP.sig.InvalidElement
     * @returns {Node} The first node of the content that was just inserted.
     */

    var content;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement',
                                'Must provide a target Element node.');
    }

    //  this allows us to accept things like TP.uri.URI, TP.dom.Node, etc.
    //  and to process them as the content routines would expect.
    content = TP.canInvoke(anObject, 'getResource') ?
                anObject.getResource(
                    TP.hc('resultType', TP.DOM)).get('result') :
                anObject;
    content = TP.unwrap(content);

    if (TP.isHTMLNode(anElement)) {
        return TP.htmlElementAddContent(anElement, content,
                                            loadedFunction, shouldAwake);
    } else {
        return TP.xmlElementAddContent(anElement, content,
                                            loadedFunction, shouldAwake);
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementAddNSURI',
function(anElement, aPrefix, aURI) {

    /**
     * @method elementAddNSURI
     * @summary Adds an 'xmlns:<aPrefix>' attribute to the element. Note that
     *     'aPrefix' *must* be valid (i.e. you cannot use this mechanism to
     *     change the default namespace - no current DOM environment supports
     *     that). Note also that namespaces can only be added to elements in an
     *     XML document.
     * @param {Element} anElement The Element node to add a namespace to.
     * @param {String} aPrefix The prefix of the namespace being added. This can
     *     have the 'xmlns:' already prepended to it.
     * @param {String} aURI The URI of the namespace being added.
     * @example Add a namespace to an element in an XML document:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"/>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.elementAddNSURI(xmlDoc.documentElement,
     *          'svg',
     *          TP.w3.Xmlns.SVG);
     *          TP.nodeAsString(xmlDoc);
     *          <samp>&lt;foo xmlns="http://www.foo.com"
     *         xmlns:svg="http://www.w3.org/2000/svg"/&gt;</samp>
     *     </code>
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     * @exception TP.sig.InvalidXMLDocument Raised when the element supplied is
     *     not part of an XML document.
     * @exception TP.sig.InvalidString Raised when a null or empty prefix or URI
     *     is provided to the method.
     */

    var xmlnsAttrName,

        attrs,
        i;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (!TP.isXMLDocument(TP.nodeGetDocument(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidXMLDocument');
    }

    if (TP.isEmpty(aPrefix) || TP.isEmpty(aURI)) {
        return TP.raise(this, 'TP.sig.InvalidString',
                        'Invalid or empty prefix or URI');
    }

    //  If the 'xmlns:' part was already provided in the supplied
    //  prefix, just use the string as is.
    if (/xmlns:/g.test(aPrefix)) {
        xmlnsAttrName = aPrefix;
    } else {
        //  Otherwise, we need to tack on the 'xmlns:' part to the
        //  supplied prefix.
        xmlnsAttrName = 'xmlns:' + aPrefix;
    }

    //  We need to make sure that we're not putting a namespace
    //  definition on an element that already has one.
    attrs = anElement.attributes;
    for (i = 0; i < attrs.length; i++) {
        if (attrs[i].name === xmlnsAttrName) {
            return;
        }
    }

    TP.elementSetAttributeInNS(anElement,
                                xmlnsAttrName,
                                aURI,
                                TP.w3.Xmlns.XMLNS);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementBecome',
function(anElement, tagName, attrHash, newXmlns, defaultAttrPrefixes) {

    /**
     * @method elementBecome
     * @summary Replaces the node with a new node of a different type, moving
     *     all attributes and children of the original node onto the new node.
     *     This is the core "computable tag" support method allowing custom XML
     *     tags to switch into HTML tags.
     * @param {Element} anElement The original element to be transformed.
     * @param {String} tagName The local or full tag name to use for the new
     *     element.
     * @param {TP.core.Hash} attrHash An optional hash containing additional
     *     attributes for the new element. Note that if a same-named attribute
     *     already exists on the element, the value for that attribute will be
     *     updated to the value in this hash.
     * @param {String} newXmlns The official XMLNS for the new element. Default
     *     is XHTML.
     * @param {Boolean} defaultAttrPrefixes Whether prefixes for attributes
     *     should be defaulted to the current node's prefix on the new element.
     *     Default is false.
     * @returns {Element} A new element.
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     * @exception TP.sig.InvalidName Raised when the supplied tag name is empty.
     */

    var attrStr,

        prefix,
        elemWithNS,

        shouldPrefix,
        toXMLNS,

        sourceTagStr,

        tagstr,
        newElem,

        sourceNS,
        sourcePrefix,

        destPrefix,
        destNS,

        len,
        i,
        attrNode,
        attrValue,
        localName,
        hashVal;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(tagName)) {
        return TP.raise(this, 'TP.sig.InvalidName');
    }

    attrStr = TP.isValid(attrHash) ? attrHash.asAttributeString() : '';

    //  If the newXmlns is empty, see if the new tag name has a prefix. If
    //  so, try to derive a namespaceURI from that.
    if (TP.isEmpty(toXMLNS = newXmlns)) {
        if (TP.regex.HAS_COLON.test(tagName)) {
            prefix = tagName.split(':').first();

            //  First, try to get the namespace declaration from the element
            //  itself
            if (TP.isEmpty(toXMLNS = TP.elementGetAttribute(
                                      anElement, 'xmlns:' + prefix))) {
                //  Next, try to get an ancestor that declared it
                if (!TP.isElement(
                          elemWithNS =
                              TP.nodeGetFirstAncestorByAttribute(
                                          anElement, 'xmlns:' + prefix))) {
                    //  Couldn't find one - use TIBET's meta information
                    toXMLNS = TP.w3.Xmlns.getNSURIForPrefix(prefix);
                } else {
                    //  Get it from the ancestor that declared it
                    toXMLNS = TP.elementGetAttribute(elemWithNS,
                                                      'xmlns:' + prefix);
                }
            }

            //  Still empty? Default based on prefix then.
            if (TP.isEmpty(toXMLNS)) {
                toXMLNS = 'urn:' + prefix;

                TP.w3.Xmlns.registerNSInfo(
                        toXMLNS,
                        TP.hc('uri', toXMLNS, 'prefix', prefix));
            }
        } else {
            //  No prefix. Bare elements should default to XHTML.
            if (TP.isEmpty(toXMLNS)) {
                toXMLNS = TP.w3.Xmlns.XHTML;
            }
        }
    }

    //  If the hash didn't supply a 'tibet:tag' we compute one here. Note that
    //  the user could've specifically supplied a null value for 'tibet:tag' in
    //  the hash, which is an indication that they don't want any 'tibet:tag'
    //  for the resultant element (and which is why we use the TP.isNull check
    //  for that here).
    if (TP.notValid(attrHash) ||
        TP.notNull(attrHash.at('tibet:tag'))) {
        if (TP.isEmpty(anElement.prefix)) {
            sourceTagStr = ' tibet:tag="' +
                            TP.canonical(anElement) +
                            '"';
        } else {
            sourceTagStr = ' tibet:tag="' +
                            TP.qname(anElement) +
                            '"';
        }
    } else {
        sourceTagStr = '';
    }

    prefix = TP.notEmpty(prefix) ? ':' + prefix : '';
    tagstr = TP.join('<', tagName, ' xmlns' + prefix + '="', toXMLNS, '"',
                        (prefix === ':tibet' ?
                                '' :
                                ' xmlns:tibet="' + TP.w3.Xmlns.TIBET + '" ') +
                        sourceTagStr,
                        ' ', attrStr,
                        '>',
                    '</', tagName, '>');

    newElem = TP.elem(tagstr);
    TP.elementSetGenerator(newElem);

    if (TP.notValid(newElem)) {
        //  $elem above should have done a raise/report for us.
        return;
    }

    if (TP.notEmpty(anElement)) {
        TP.nodeMoveChildNodesTo(anElement, newElem, null, false);
    }

    //  ---
    //  Copy over attributes from the source to the target.
    //  ---

    if (TP.isTrue(defaultAttrPrefixes)) {
        shouldPrefix = true;
        if (TP.notEmpty(sourceNS = TP.nodeGetNSURI(anElement))) {
            if (TP.isEmpty(sourcePrefix = anElement.prefix)) {
                sourcePrefix = TP.w3.Xmlns.getPrefixForNSURI(sourceNS,
                                                            anElement);
            }
        }

        if (TP.notEmpty(destNS = TP.nodeGetNSURI(newElem))) {
            if (TP.isEmpty(destPrefix = newElem.prefix)) {
                destPrefix = TP.w3.Xmlns.getPrefixForNSURI(destNS, anElement);
            }
        }

        if (sourceNS === destNS &&
            sourcePrefix === destPrefix) {
            shouldPrefix = false;
        }
    }

    len = anElement.attributes.length;
    for (i = 0; i < len; i++) {
        attrNode = anElement.attributes[i];

        //  If the attribute's value is the same as the new element's
        //  namespace URI, don't copy it over - its an 'xmlns' attribute.
        //  This helps prevent the same namespace from being put on the
        //  element over and over again.
        if ((attrValue = attrNode.value) === toXMLNS) {
            continue;
        }

        //  If the attribute name itself (not the prefix, but just the
        //  attribute name) is 'xmlns', then we don't copy it since
        //  browsers freak out when we try to reset the default namespace.
        if ((localName = TP.attributeGetLocalName(attrNode)) === 'xmlns') {
            continue;
        }

        //  If the named attribute exists in the 'extra attribute' hash, its
        //  already going to be on the element. We don't want to blow it
        //  away, but we might not want it to stay on the element with its
        //  current value.
        if (TP.isValid(attrHash) &&
            TP.isValid(hashVal =
                    attrHash.at(TP.attributeGetFullName(attrNode)))) {
            attrNode.value = hashVal;
            continue;
        }

        if (TP.notEmpty(attrNode.namespaceURI)) {
            //  If the attribute node has an actual prefix, use it.
            if (TP.notEmpty(prefix = attrNode.prefix)) {
                TP.elementSetAttributeInNS(newElem,
                                            prefix + ':' + localName,
                                            attrValue,
                                            attrNode.namespaceURI);
            } else {
                //  Otherwise, just use the local name.
                TP.elementSetAttributeInNS(newElem,
                                            localName,
                                            attrValue,
                                            attrNode.namespaceURI);
            }
        } else if (shouldPrefix &&
                    TP.isString(sourceNS) &&
                    TP.notEmpty(sourcePrefix) &&
                    !TP.NEVER_PREFIXED_ATTRS.contains(localName)) {
            //  When we've got a valid NS, prefix, and clearance to prefix
            //  the attribute name then we'll do it the "official way".
            TP.elementSetAttributeInNS(
                                newElem,
                                sourcePrefix + ':' + localName,
                                attrValue,
                                sourceNS);
        } else {
            TP.elementSetAttribute(newElem,
                                    localName,
                                    attrValue);
        }
    }

    //  Replace the original in its source document so it truly "becomes"
    //  the new element.
    newElem = TP.nodeReplaceChild(anElement.parentNode, newElem, anElement);

    return newElem;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementBubbleXMLNSAttributes',
function(anElement, stopAncestor) {

    /**
     * @method elementBubbleXMLNSAttributes
     * @summary 'Bubbles' xmlns attributes from the supplied element 'up' it's
     *     ancestor chain in an attempt to 'de-clutter' the DOM tree. Note that
     *     care is taken to follow XML Namespaces rules (i.e. the namespace will
     *     only be redefined further up the chain if it has both the same prefix
     *     and same namespace URI value).
     * @param {Element} anElement The element to bubble the namespaces up from.
     * @param {Element} [stopAncestor] An element between anElement and
     *     anElement's document node that the xmlns bubbling will 'stop' at.
     *     Therefore, this will be the element that any added xmlns attributes
     *     will be added to. This parameter is optional.
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     */

    var docElem,
        docXMLNSAttrs,

        elemXMLNSAttrs,

        ancestors;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    docElem = TP.nodeGetDocument(anElement).documentElement;
    docXMLNSAttrs = TP.elementGetXMLNSAttributes(docElem, true);

    elemXMLNSAttrs = TP.elementGetXMLNSAttributes(anElement, true);

    //  This includes docElem
    ancestors = TP.nodeGetAncestors(anElement);

    elemXMLNSAttrs.perform(
        function(kvPair) {
            var wholeName,
                nsURIVal,

                entry,

                i,
                ancestor,
                nsVal;

            wholeName = kvPair.first();
            nsURIVal = kvPair.last();

            entry = docXMLNSAttrs.at(wholeName);

            //  If the document element has an attribute defined exactly the
            //  same (that is, it's name is the prefix + local name and it has
            //  the same value) then it has this namespace attribute and we can
            //  remove it from ourself.
            if (TP.isValid(entry) && entry === nsURIVal) {
                TP.elementRemoveNSURI(anElement, wholeName);

                return;
            }

            //  We don't copy the default namespace.
            if (wholeName === 'xmlns') {
                return;
            }

            //  The document element doesn't have it, so we need to work our way
            //  up the tree of ancestors. We will look for the first one that
            //  has the exact same namespace attribute (prefix + local name and
            //  the same value).
            for (i = 0; i < ancestors.getSize(); i++) {
                ancestor = ancestors.at(i);
                nsVal = TP.elementGetAttribute(ancestor, wholeName, true);

                //  If the ancestor has no value
                if (TP.isEmpty(nsVal)) {
                    //  If it's not the document element and its not the stop
                    //  ancestor, then continue on up.
                    if (ancestor !== docElem && ancestor !== stopAncestor) {
                        continue;
                    } else {
                        //  If it is the document element, then go ahead and
                        //  place the attribute, and remove it from ourself.
                        TP.elementAddNSURI(ancestor, wholeName, nsURIVal);
                        TP.elementRemoveNSURI(anElement, wholeName);
                        return;
                    }
                }

                //  If we find one that defines both the same namespace prefix
                //  and the same namespace URI value, then we can remove it from
                //  ourself and take no further action.
                if (nsVal === nsURIVal) {

                    TP.elementRemoveNSURI(anElement, wholeName);

                    return;
                }

                //  If we find one that defines the same namespace prefix, but
                //  with a different namespace URI value, then we have to go one
                //  level below it, put a namespace attribute there, remove it
                //  from ourself and take no further action.
                if (nsVal !== nsURIVal && i > 0) {

                    TP.elementAddNSURI(
                            ancestors.at(i - 1), wholeName, nsURIVal);
                    TP.elementRemoveNSURI(anElement, wholeName);

                    return;
                }
            }
        });

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementBubbleXMLNSAttributesOnDescendants',
function(anElement, stopAncestor) {

    /**
     * @method elementBubbleXMLNSAttributesOnDescendants
     * @summary 'Bubbles' xmlns attributes from the descendant elements of the
     *     supplied elements 'up' their ancestor chain in an attempt to
     *     'de-clutter' the DOM tree. Note that care is taken to follow XML
     *     Namespaces rules (i.e. the namespace will only be redefined further
     *     up the chain if it has both the same prefix and same namespace URI
     *     value).
     * @param {Element} anElement The element to query for descendants to bubble
     *     the namespaces up from.
     * @param {Element} [stopAncestor] An element between anElement and
     *     anElement's document node that the xmlns bubbling will 'stop' at.
     *     Therefore, this will be the element that any added xmlns attributes
     *     will be added to. This parameter is optional.
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     */

    var allElems;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  Bubble xmlns attributes from the supplied Element.
    TP.elementBubbleXMLNSAttributes(anElement, stopAncestor);

    //  Get all descendants, as long as they're Elements.
    allElems = TP.nodeGetDescendantElements(anElement);

    allElems.forEach(
        function(anElem) {
            TP.elementBubbleXMLNSAttributes(anElem, stopAncestor);
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementClean',
function(anElement, cleanDescendants) {

    /**
     * @method elementClean
     * @summary Cleans off all of the TIBET-specific or other
     *     'instance-specific' information from the supplied Element and any
     *     Element descendants, if the flag is supplied.
     * @description This method cleans off the following attributes and
     *     properties from the supplied element and any Element descendants:
     *         - The 'id' attribute.
     * @param {Element} anElement The target element.
     * @param {Element} [cleanDescendants=false] Whether or not
     *     instance-specific information should be cleaned off of the supplied
     *     Element's descendants.
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     */

    var allElems;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement',
                                'Must provide a valid Element node.');
    }

    TP.elementRemoveAttribute(anElement, 'id', true);

    if (TP.isTrue(cleanDescendants)) {
        //  Get all descendants, as long as they're Elements.
        allElems = TP.nodeGetDescendantElements(anElement);

        allElems.forEach(
            function(anElem) {
                TP.elementRemoveAttribute(anElem, 'id', true);
            });
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementCopyAttributes',
function(fromElement, toElement) {

    /**
     * @method elementCopyAttributes
     * @summary Copies all attributes from fromElement to toElement.
     * @param {Element} fromElement The source element.
     * @param {Element} toElement The target element.
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     */

    var len,
        i,

        fromNS,
        fromAttr;

    if (!TP.isElement(fromElement) || !TP.isElement(toElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    len = fromElement.attributes.length;

    //  Loop over each attribute on the element. The 'xmlns' (or 'xmlns:...')
    //  attributes will be exposed here because this is the DOM, not XPath
    for (i = 0; i < len; i++) {
        fromAttr = fromElement.attributes[i];

        //  The 'namespace namespace' is defined by the W3C as
        //  'http://www.w3.org/2000/xmlns/'. We check for that and don't copy
        //  the attribute this way for namespace attributes. The call at the end
        //  of this routine will do that properly.
        if ((fromNS = fromAttr.namespaceURI) === TP.w3.Xmlns.XMLNS) {
            continue;
        }

        if (TP.notEmpty(fromNS)) {
            toElement.setAttributeNS(fromNS,
                                        fromAttr.name,
                                        fromAttr.value);
        } else {
            toElement.setAttribute(fromAttr.name,
                                    fromAttr.value);
        }
    }

    //  Copy over any namespace attributes.
    TP.elementCopyXMLNSAttributes(fromElement, toElement);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementCopyXMLNSAttributes',
function(fromElement, toElement) {

    /**
     * @method elementCopyXMLNSAttributes
     * @summary Copies any 'xmlns:' attributes from fromElement to toElement.
     * @description This method copies *only prefixed* namespaces. It will not
     *     copy the default namespace from fromElement. This method will also
     *     copy attributes between elements in different documents.
     * @param {Element} fromElement The source element.
     * @param {Element} toElement The target element.
     * @example Copy all of the 'xmlns:' attributes from one XML element to
     *     another:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com" xmlns:bar="http://www.bar.com"
     *         bar:baz="bazify" goo="moo"><bar/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          otherXMLDoc = TP.documentFromString('<fuzz></fuzz>');
     *          TP.elementCopyXMLNSAttributes(
     *          xmlDoc.documentElement,
     *          otherXMLDoc.documentElement);
     *          <samp>undefined</samp>
     *          TP.nodeAsString(otherXMLDoc);
     *          <samp>&lt;fuzz xmlns:bar="http://www.bar.com"/&gt;</samp>
     *     </code>
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     */

    var len,
        i,

        fromAttr;

    if (!TP.isElement(fromElement) || !TP.isElement(toElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    len = fromElement.attributes.length;

    //  Loop over each attribute on the element. The 'xmlns' (or 'xmlns:...')
    //  attributes will be exposed here because this is the DOM, not XPath
    for (i = 0; i < len; i++) {
        fromAttr = fromElement.attributes[i];

        //  The 'namespace namespace' is defined by the W3C as
        //  'http://www.w3.org/2000/xmlns/'. We check for that, or (if its
        //  missing) we also check for the 'xmlns' prefix (IE seems to have
        //  problems setting the namespaceURI of Attribute nodes).
        if (fromAttr.namespaceURI === TP.w3.Xmlns.XMLNS ||
            fromAttr.prefix === 'xmlns') {
            //  NB: We only add prefixed namespaces here, not default
            //  namespaces.
            if (/xmlns:/g.test(fromAttr.name)) {
                TP.elementAddNSURI(toElement, fromAttr.name, fromAttr.value);
            }
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementFlagChange',
function(anElement, locationPath, action, shouldOverwrite) {

    /**
     * @method elementFlagChange
     * @summary Flags the element with a tibet:crud attribute containing the
     *     locationPath and action pair. Note that this attribute can hold
     *     multiple locationPath/action pair values.
     * @description The supplied location path should take the form of:
     *     TP.SELF                  ->  The action for the receiving element
     *                                  itself.
     *     TP.ATTR + attributeName  ->  The action for a named attribute
     *                                  E.g. 'TP.ATTRfoo'
     * @param {Element} anElement The element to flag for change using the
     *     supplied location path and action.
     * @param {String} locationPath The location path to set for an action.
     * @param {String} action An action such as TP.CREATE, TP.UPDATE or
     *     TP.DELETE.
     * @param {Boolean} shouldOverwrite Whether or not to overwrite the action
     *     for a particular location path on the supplied element. Defaults to
     *     true.
     * @returns {null}
     */

    var crudValue,
        crudEntries,

        foundEntry,

        len,
        i,

        locationChangePair;

    crudValue = TP.elementGetAttribute(anElement, 'tibet:crud', true);

    //  There may be multiple entries, separated by a vertical bar ('|'). Split
    //  them out.
    crudEntries = crudValue.split('|');

    foundEntry = false;
    len = crudEntries.getSize();
    for (i = 0; i < len; i++) {

        locationChangePair = crudEntries.at(i).split(':');

        //  Already have an entry for this location path? Just update the value.
        if (locationChangePair.first() === locationPath) {

            if (TP.notFalse(shouldOverwrite)) {
                crudEntries.atPut(i, locationPath + ':' + action);
            }

            foundEntry = true;

            //  We're done.
            break;
        }
    }

    //  If we didn't find an existing entry, make a new one.
    if (!foundEntry) {
        crudEntries.push(locationPath + ':' + action);
    }

    crudValue = crudEntries.join('|');

    TP.elementSetAttributeInNS(anElement,
                                'tibet:crud',
                                crudValue,
                                TP.w3.Xmlns.TIBET);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetChangeAction',
function(anElement, locationPath) {

    /**
     * @method elementGetChangeAction
     * @summary Returns any action for the supplied location path.
     * @description The supplied location path should take the form of:
     *     TP.SELF                  ->  The action for the receiving element
     *                                  itself.
     *     TP.ATTR + attributeName  ->  The action for a named attribute
     *                                  E.g. 'TP.ATTRfoo'
     * @param {Element} anElement The element to query for the action based on
     *     the supplied location path.
     * @param {String} locationPath The location path to query for an action.
     * @returns {String} An action such as TP.CREATE, TP.UPDATE or TP.DELETE
     */

    var crudValue,
        crudEntries,

        len,
        i,

        locationChangePair;

    //  See if there is a 'tibet:crud' attribute at all... if there isn't, there
    //  aren't any actions set on this element for either itself, any attributes
    //  it has or any children.
    if (TP.isEmpty(crudValue =
                    TP.elementGetAttribute(anElement, 'tibet:crud', true))) {

        return null;
    }

    //  There may be multiple entries, separated by a vertical bar ('|'). Split
    //  them out.
    crudEntries = crudValue.split('|');

    //  Loop and split each entry by a colon (':').
    len = crudEntries.getSize();
    for (i = 0; i < len; i++) {

        locationChangePair = crudEntries.at(i).split(':');

        //  Look for a location path that matches the supplied location. The
        //  action will be the second part of the pair.
        if (locationChangePair.first() === locationPath) {
            return locationChangePair.last();
        }
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetLocalName',
function(anElement) {

    /**
     * @method elementGetLocalName
     * @summary Returns the local name (that is, the name without the prefix)
     *     of the supplied element node.
     * @param {Element} anElement The element node to retrieve the local name
     *     for.
     * @example Retrieve the 'local name' for the supplied element in an HTML
     *     document:
     *     <code>
     *          TP.elementGetLocalName(TP.documentGetBody(document));
     *          <samp>BODY</samp>
     *     </code>
     * @example Retrieve the 'local name' for the supplied element in an XML
     *     document:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"/>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.elementGetLocalName(xmlDoc.documentElement);
     *          <samp>foo</samp>
     *     </code>
     * @returns {String} The local name of the supplied node.
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    return anElement.localName;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetXMLNSAttributes',
function(anElement, includeDefault) {

    /**
     * @method elementGetXMLNSAttributes
     * @summary Returns all 'xmlns' attributes for the supplied element. Note
     *     that this method will *not* return any 'default namespace' 'xmlns'
     *     attribute that is defined on the supplied element unless the
     *     includeDefault flag is true.
     * @param {Element} anElement The element to return namespace attributes
     *     for.
     * @param {Boolean} includeDefault Whether or not to return any default
     *     'xmlns' attributes defined on the element. The default is false.
     * @returns {TP.core.Hash} A hash of xmlns attribute names and attribute
     *     values. Note that the names will be the attribute 'full name' (i.e.
     *     including the 'xmlns:' prefix).
     */

    var xmlnsAttrs,

        len,
        i,

        fromAttr;

    xmlnsAttrs = TP.hc();

    //  Loop over each attribute on the element. The 'xmlns' (or 'xmlns:...')
    //  attributes will be exposed here because this is the DOM, not XPath
    len = anElement.attributes.length;
    for (i = 0; i < len; i++) {
        fromAttr = anElement.attributes[i];

        //  The 'namespace namespace' is defined by the W3C as
        //  'http://www.w3.org/2000/xmlns/'. We check for that, or (if its
        //  missing) we also check for the 'xmlns' prefix (IE seems to have
        //  problems setting the namespaceURI of Attribute nodes).
        if (fromAttr.namespaceURI === TP.w3.Xmlns.XMLNS ||
            fromAttr.prefix === 'xmlns') {
            if (fromAttr.name === 'xmlns') {
                if (TP.isTrue(includeDefault)) {
                    xmlnsAttrs.atPut('xmlns', fromAttr.value);
                }
            } else {
                xmlnsAttrs.atPut(fromAttr.name, fromAttr.value);
            }
        }
    }

    return xmlnsAttrs;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementFromString',
function(aString, defaultNS, shouldReport) {

    /**
     * @method elementFromString
     * @summary Parses aString and returns the XML element representing the
     *     string's DOM representation. NOTE that only elements can be produced
     *     by this method, not document or text nodes for example. Use
     *     nodeFromString if you need more general parsing from text into node
     *     form.
     * @description This is different from TP.documentFromString() in that the
     *     node returned is the documentElement from that call and is,
     *     therefore, a Node not a Document.
     * @param {String} aString The source string to be parsed. Note that this
     *     String *must* be XML compliant.
     * @param {String|null} defaultNS What namespace should be used for the
     *     'default namespace' for element markup in the supplied String.
     *     Note that this should be an XML 'namespace URI' (i.e.
     *     'http://www.w3.org/1999/xhtml') *not* a namespace prefix (i.e.
     *     'html:'). To use the 'null' namespace (i.e. xmlns=""), supply
     *     the empty String ('') here. To not specify any default namespace
     *     value and let the parser do what it does natively, supply null here.
     * @param {Boolean} shouldReport False to turn off exception reporting so
     *     strings can be tested for XML compliance without causing exceptions
     *     to be thrown. This is true by default.
     * @example Create a node from an XML String:
     *     <code>
     *          xmlElem = TP.elementFromString(
     *          '<foo><bar><baz/></bar></foo>');
     *          <samp>[object Element]</samp>
     *     </code>
     * @example Create a node from a malformed XML String (note the flag to show
     *     the parser errors):
     *     <code>
     *          xmlElem = TP.elementFromString(
     *          '<foo<bar><baz/></bar></foo>', true);
     *          <samp>(Parser error output)</samp>
     *     </code>
     * @returns {Node} The Node parsed from the supplied String.
     */

    var node;

    node = TP.nodeFromString(aString, defaultNS, shouldReport);

    if (TP.isElement(node)) {
        return node;
    }

    if (TP.isFragment(node)) {
        TP.ifWarn() ?
            TP.warn('Multiple nodes created. Creating first element.') : 0;

        //  The fragment may have a text node as its first child - we want
        //  the first one that's an Element.
        return TP.nodeGetFirstChildElement(node);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetAttribute',
function(anElement, attributeName, checkAttrNSURI) {

    /**
     * @method elementGetAttribute
     * @summary Returns the value of the attribute provided.
     * @description This method provides some additional capabilities over the
     *     standard DOM '.getAttribute()' method:
     *          #1: If there is a method defined on the 'TP' object that follows
     *          a pattern of 'TP.elementGet<attributeName>', then that method
     *          will be called as a way of specializing attribute access. For
     *          instance, TIBET provides specialized methods for 'class' and
     *          'style' attributes. So using:
     *              TP.elementGetAttribute(anElement, 'class');
     *              will cause
     *              TP.elementGetClass(anElement); to be called.
     *          #2: Typically this method retrieves the attribute using the
     *          built-in platform attribute and namespace resolution mechanisms,
     *          but if a value cannot be determined and the supplied attribute
     *          name is prefixed (i.e. it is a namespaced attribute) and the
     *          checkAttrNSURI flag is set to 'true' this method tries an
     *          alternate mechanism to obtain a value. This mechanism uses the
     *          document's prefixes and TIBET's canonical prefixing information
     *          regarding namespaces to compute an alternate prefix for the
     *          attribute. For example, the canonical XHTML prefix is 'html:',
     *          but if the author has used the 'ht:' prefix for XHTML and the
     *          system attempts to retrieve the 'ht:foo' attribute, this
     *          method will (if the checkAttrNSURI parameter is true) also try
     *          to retrieve the value for the 'html:foo' attribute.
     * @param {Element} anElement The element to retrieve the attribute value
     *     from.
     * @param {String} attributeName The attribute to find.
     * @param {Boolean} [checkAttrNSURI=false] True will cause this method to be
     *     more rigorous in its checks for prefixed attributes, looking via
     *     internal TIBET mechanisms in addition to the standard platform
     *     mechanism. The default is false (to keep things faster).
     * @example Get the value of the attribute on an XML element:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"
     *          xmlns:xf="http://www.w3.org/2002/xforms" xf:bind="theBinder"
     *          goo="moo">Hi there</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          //  Simple attribute access
     *          TP.elementGetAttribute(xmlDoc.documentElement, 'goo');
     *          <samp>moo</samp>
     *          //  Prefixed attribute access
     *          TP.elementGetAttribute(xmlDoc.documentElement, 'xf:bind');
     *          <samp>theBinder</samp>
     *          //  Alternate prefix attribute access (need checkAttrNSURI flag)
     *          TP.elementGetAttribute(xmlDoc.documentElement,
     *          'xforms:bind',
     *          true);
     *          <samp>theBinder</samp>
     *     </code>
     * @returns {String} The attribute value, if found.
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     * @exception TP.sig.InvalidName Raised when the supplied attribute name is
     *     empty.
     */

    var methodName,

        retVal,

        qualified,

        parts,
        nsURI;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(attributeName)) {
        return TP.raise(this, 'TP.sig.InvalidName');
    }

    //  see if we have a specific getter like elementGetStyle
    methodName = 'elementGet' + attributeName.asTitleCase();
    if (TP.canInvoke(TP, methodName)) {
        return TP[methodName](anElement);
    }

    retVal = anElement.getAttribute(attributeName);

    //  DOM Level 4 says to return null here if attribute is missing, but we use
    //  an empty check anyway since some older browsers still return the empty
    //  String. Note that we return empty String here for backwards
    //  compatibility.
    if (TP.isEmpty(retVal)) {

        //  we can speed things up quite a bit if we avoid work related to
        //  namespaces as much as possible. In this case, test to see if the
        //  attribute name has a colon in it.
        qualified = TP.regex.HAS_COLON.test(attributeName);
        if (!qualified) {
            return '';
        }

        parts = attributeName.match(TP.regex.NS_QUALIFIED);
        if (TP.isEmpty(nsURI = anElement.lookupNamespaceURI(parts.at(1)))) {

            if (!checkAttrNSURI) {
                return '';
            }

            //  NOTE the dependency here on the XMLNS type which allows us
            //  to look up the registered URI for our prefix
            nsURI = TP.w3.Xmlns.getNSURIForPrefix(parts.at(1));
            if (TP.isEmpty(nsURI)) {
                TP.ifWarn() ? TP.warn(
                'Couldn\'t find namespace URI for prefix: ' + parts.at(1)) : 0;
            }

            //  Note here that we use only the *local* attribute name as
            //  specified by the 'getAttributeNS' spec.
            if (TP.notEmpty(
                retVal = anElement.getAttributeNS(nsURI, parts.at(2)))) {
                return retVal;
            }

            return '';
        }

        //  Note here that we use only the *local* attribute name as specified
        //  by the 'getAttributeNS' spec.
        if (TP.notValid(retVal =
                        anElement.getAttributeNS(nsURI, parts.at(2)))) {

            //  We didn't get a value - so now we try a convenience provided by
            //  TIBET. Officially, X(HT)ML attributes are not in any namespace,
            //  including their owning element's namespace, unless they are
            //  specifically prefixed. But we provide a convenience such that,
            //  if there was no value returned by checking the 'whole attribute
            //  name' (i.e. with a prefix), we see if the namespace computed by
            //  the prefix supplied to this call is the same as the namespace of
            //  the owning element. If it is, we'll try again with just the
            //  local name of the attribute. This allows for markup authored
            //  like: <foo:bar baz="goo"/> and for us to use
            //  TP.elementGetAttribute('foo:baz') which will return 'goo'.
            if (nsURI === anElement.namespaceURI) {
                if (TP.notEmpty(retVal = anElement.getAttribute(parts.at(2)))) {
                    return retVal;
                }
            }

            return '';
        }
    }

    return retVal;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetAttributes',
function(anElement, attributeName, stripPrefixes) {

    /**
     * @method elementGetAttributes
     * @summary Returns a hash of zero to N attribute name/value pairs,
     *     potentially matching the attribute name provided. Note that this
     *     method will always process all attributes, whether they are in a
     *     particular namespace or not.
     * @description The attributeName in this case is expected to be of the form
     *     'wholename', '*:localname' or 'prefix:*', wildcarding either the
     *     prefix or the localname. If it is omitted, all attributes will be
     *     represented in the hash.
     * @param {Element} anElement The element to retrieve the attribute values
     *     from.
     * @param {String|RegExp} attributeName An attributeName "search" criteria
     *     of the form 'wholename' '*:localname' or 'prefix:*' or any RegExp.
     *     This is optional.
     * @param {Boolean} stripPrefixes Whether or not to strip any namespace
     *     prefixes from the attribute names as they are populated into the
     *     return value.
     * @example Grab all of the attribute values of an HTML element into a hash:
     *     <code>
     *          TP.elementGetAttributes(TP.documentGetBody(document));
     *          <samp>(hash of attributes from the body element)</samp>
     *     </code>
     * @example Grab all of the attribute values of an XML element into a hash:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com" xmlns:bar="http://www.bar.com"
     *         bar:baz="bazify" goo="moo" boo="zoo"><bar/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.elementGetAttributes(xmlDoc.documentElement);
     *          <samp>(hash of attributes from the document element)</samp>
     *     </code>
     * @example Grab only the attribute values of the attributes that start with
     *     'bar:' of an XML element into a hash:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com" xmlns:bar="http://www.bar.com"
     *         bar:baz="bazify" goo="moo" bar:boo="zoo"><bar/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.elementGetAttributes(xmlDoc.documentElement, 'bar:*');
     *          <samp>(hash of 'bar:*' attributes from the document
     *         element)</samp>
     *     </code>
     * @returns {TP.core.Hash} A collection of name/value pairs.
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     */

    var dict,
        attrs,
        len,
        i,
        attrName;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    dict = TP.hc();

    //  filter by name as needed
    if (TP.isString(attributeName) || TP.isRegExp(attributeName)) {
        attrs = TP.elementGetAttributeNodes(anElement, attributeName);
    } else {
        attrs = anElement.attributes;
    }

    len = attrs.length;

    //  loop over the retrieved attribute nodes and put them into the hash
    //  keyed by name and with their value as the hash value.
    for (i = 0; i < len; i++) {
        attrName = attrs[i].name;

        //  If we're supposed to strip prefixes, then just put in one entry
        //  with the unprefixed name.
        if (stripPrefixes) {
            attrName = attrName.slice(attrName.indexOf(':') + 1);
        }

        dict.atPut(attrName, attrs[i].value);
    }

    return dict;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetAttributeNames',
function(anElement, stripPrefixes) {

    /**
     * @method elementGetAttributeNames
     * @summary Returns an Array of zero to N attribute names of attributes on
     *     the provided element.
     * @description Note that this method will always process all attributes,
     *     whether they are in a particular namespace or not.
     * @param {Element} anElement The element to retrieve the attribute names
     *     from.
     * @param {Boolean} stripPrefixes Whether or not to strip any namespace
     *     prefixes from the attribute names as they are populated into the
     *     return value.
     * @example Grab all of the attribute names of an HTML element into an
     *     array:
     *     <code>
     *          TP.elementGetAttributeNames(TP.documentGetBody(document));
     *          <samp>(hash of attributes from the body element)</samp>
     *     </code>
     * @example Grab all of the attribute names of an XML element into an array:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com" xmlns:bar="http://www.bar.com"
     *         bar:baz="bazify" goo="moo" boo="zoo"><bar/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.elementGetAttributeNames(xmlDoc.documentElement);
     *          <samp>(array of attribute names from the document
     *         element)</samp>
     *     </code>
     * @example Grab all of the attribute names of an XML element into an array,
     *     stripping any prefixes they may have:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com" xmlns:bar="http://www.bar.com"
     *         bar:baz="bazify" goo="moo" boo="zoo"><bar/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.elementGetAttributeNames(xmlDoc.documentElement, true);
     *          <samp>(array of attribute names, stripped of their prefix, from
     *         the document element)</samp>
     *     </code>
     * @returns {String[]} A collection of name values.
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     */

    var elementPrefix,

        names,

        attrs,

        len,
        i,

        attrName,

        nsIndex;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    elementPrefix = anElement.prefix;

    names = TP.ac();

    attrs = anElement.attributes;

    len = attrs.length;

    //  loop over the retrieved attribute nodes and put their names into the
    //  array
    for (i = 0; i < len; i++) {
        attrName = attrs[i].name;

        //  If we're supposed to strip prefixes, then just put in one entry
        //  with the unprefixed name.
        if (stripPrefixes) {
            attrName = attrName.slice(attrName.indexOf(':') + 1);
            names.push(attrName);
        } else if ((nsIndex = attrName.indexOf(':')) !== TP.NOT_FOUND) {
            //  Otherwise, if we have a prefix, then put in two entries: one
            //  with the prefix and one without.
            names.push(attrName);

            attrName = attrName.slice(nsIndex + 1);
            names.push(attrName);
        } else {
            //  Otherwise, if we don't have a prefix, but the element has a
            //  prefix, then put in two entries: one with the element's
            //  prefix and one without.
            if (TP.notEmpty(elementPrefix)) {
                names.push(elementPrefix + ':' + attrName);
            }

            names.push(attrName);
        }
    }

    return names;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetAttributesAsNumbers',
function(anElement, attributeName, stripPrefixes) {

    /**
     * @method elementGetAttributesAsNumbers
     * @summary Returns a hash of zero to N attribute name/value pairs,
     *     potentially matching the attribute name provided. This routine
     *     returns each value as a Number. If the value couldn't be converted to
     *     a Number, the value returned for that attribute will be NaN.
     *     Note that this method will always process all attributes, whether
     *     they are in a particular namespace or not.
     * @description The attributeName in this case is expected to be of the form
     *     'wholename', '*:localname' or 'prefix:*', wildcarding either the
     *     prefix or the localname. If it is omitted, all attributes will be
     *     represented in the hash.
     * @param {Element} anElement The element to retrieve the attribute value
     *     from.
     * @param {String|RegExp} attributeName An attributeName "search" criteria
     *     of the form 'wholename' '*:localname' or 'prefix:*' or any RegExp.
     *     This is optional.
     * @param {Boolean} stripPrefixes Whether or not to strip any namespace
     *     prefixes from the attribute names as they are populated into the
     *     return value.
     * @example Grab all of the attribute values of an HTML element into a hash,
     *     where numeric values have been converted to Numbers and non-numeric
     *     values are represented by NaN values:
     *     <code>
     *          TP.elementGetAttributesAsNumbers(TP.documentGetBody(document));
     *          <samp>(hash of attributes from the body element)</samp>
     *     </code>
     * @example Grab all of the attribute values of an XML element into a hash,
     *     where numeric values have been converted to Numbers and non-numeric
     *     values are represented by NaN values:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com" xmlns:bar="http://www.bar.com"
     *         bar:baz="bazify" goo="moo" boo="zoo"><bar/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.elementGetAttributesAsNumbers(xmlDoc.documentElement);
     *          <samp>(hash of attributes from the document element)</samp>
     *     </code>
     * @example Grab only the attribute values of the attributes that start with
     *     'bar:' of an XML element into a hash, where numeric values have been
     *     converted to Numbers and non-numeric values are represented by NaN
     *     values:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com" xmlns:bar="http://www.bar.com"
     *         bar:baz="bazify" goo="moo" bar:boo="zoo"><bar/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.elementGetAttributesAsNumbers(xmlDoc.documentElement,
     *         'bar:*');
     *          <samp>(hash of 'bar:*' attributes from the document
     *         element)</samp>
     *     </code>
     * @returns {TP.core.Hash} A collection of name/value pairs. The value part
     *     of the pair is returned as a Number.
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     */

    var elementPrefix,

        dict,

        attrs,

        len,
        i,

        attrName,

        nsIndex;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    elementPrefix = anElement.prefix;

    dict = TP.hc();

    if (TP.isString(attributeName) || TP.isRegExp(attributeName)) {
        attrs = TP.elementGetAttributeNodes(anElement, attributeName);
    } else {
        attrs = anElement.attributes;
    }

    len = attrs.length;

    //  loop over the retrieved attribute nodes and put them into the hash
    //  keyed by name and with their value as the hash value.
    for (i = 0; i < len; i++) {
        attrName = attrs[i].name;

        //  If we're supposed to strip prefixes, then just put in one entry
        //  with the unprefixed name.
        if (stripPrefixes) {
            attrName = attrName.slice(attrName.indexOf(':') + 1);
            dict.atPut(attrName, parseFloat(attrs[i].value));
        } else if ((nsIndex = attrName.indexOf(':')) !== TP.NOT_FOUND) {
            //  Otherwise, if we have a prefix, then put in two entries: one
            //  with the prefix and one without.
            dict.atPut(attrName, parseFloat(attrs[i].value));

            attrName = attrName.slice(nsIndex + 1);
            dict.atPut(attrName, parseFloat(attrs[i].value));
        } else {
            //  Otherwise, if we don't have a prefix, but the element has a
            //  prefix, then put in two entries: one with the element's
            //  prefix and one without.
            if (TP.notEmpty(elementPrefix)) {
                dict.atPut(elementPrefix + ':' + attrName,
                            parseFloat(attrs[i].value));
            }

            dict.atPut(attrName, parseFloat(attrs[i].value));
        }
    }

    return dict;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetAttributeNode',
function(anElement, attributeName) {

    /**
     * @method elementGetAttributeNode
     * @summary Returns the first attribute node that matches the attribute
     *     name provided. Note that this method will always retrieve the first
     *     matching attribute node, whether it is in a particular namespace or
     *     not.
     * @description The attributeName in this case is expected to be of the form
     *     'wholename', '*:localname' or 'prefix:*', wildcarding either the
     *     prefix or the localname.
     * @param {Element} anElement The element to retrieve the attribute value
     *     from.
     * @param {String|RegExp} attributeName An attributeName "search" criteria
     *     of the form 'wholename' '*:localname' or 'prefix:*' or any RegExp.
     *     This is optional.
     * @example Return the attribute node of an HTML element:
     *     <code>
     *          TP.elementGetAttributeNode(TP.documentGetBody(document),
     *          'style');
     *          <samp>[object Attr]</samp>
     *     </code>
     * @example Grab the first attribute node of the element that starts with
     *     'bar:' of an XML element into a hash:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com" xmlns:bar="http://www.bar.com"
     *         bar:baz="bazify" goo="moo" bar:boo="zoo"><bar/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.elementGetAttributeNode(xmlDoc.documentElement, 'bar:*');
     *          <samp>(first 'bar:*' attribute node from the document
     *         element)</samp>
     *     </code>
     * @returns {Attribute|null} The first attribute node matching the attribute
     *     name criteria.
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     */

    var nameMatch,

        attrs,
        len,
        i,

        attr;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(attributeName)) {
        return null;
    }

    if (TP.isRegExp(attributeName)) {
        nameMatch = attributeName;
    } else {
        nameMatch = TP.getQNameRegex(attributeName);
    }

    //  Loop over all of the attribute nodes and if their name produces a
    //  match using the RegExp that we generated, then return it.

    attrs = anElement.attributes;
    len = attrs.length;
    for (i = 0; i < len; i++) {
        attr = attrs[i];
        if (nameMatch.test(attr.name) && attr.specified) {
            return attr;
        }
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetAttributeNodes',
function(anElement, attributeName) {

    /**
     * @method elementGetAttributeNodes
     * @summary Returns an array of zero to N attribute nodes that match the
     *     attribute name provided. Note that this method will always retrieve
     *     all attribute nodes, whether they are in a particular namespace or
     *     not.
     * @description The attributeName in this case is expected to be of the form
     *     'wholename', '*:localname' or 'prefix:*', wildcarding either the
     *     prefix or the localname. If it is omitted, all attributes will be
     *     represented in the array.
     * @param {Element} anElement The element to retrieve the attribute nodes
     *     from.
     * @param {String|RegExp} attributeName An attributeName "search" criteria
     *     of the form 'wholename' '*:localname' or 'prefix:*' or any RegExp.
     *     This is optional.
     * @example Grab all of the attribute nodes of an HTML element into a hash
     *     that are named 'style':
     *     <code>
     *          TP.elementGetAttributeNodes(TP.documentGetBody(document),
     *          'style');
     *          <samp>[object Attr]</samp>
     *     </code>
     * @example Grab only the attribute nodes of the attributes that start with
     *     'bar:' of an XML element into a hash:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com" xmlns:bar="http://www.bar.com"
     *         bar:baz="bazify" goo="moo" bar:boo="zoo"><bar/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.elementGetAttributeNodes(xmlDoc.documentElement, 'bar:*');
     *          <samp>(array of 'bar:*' attribute nodes from the document
     *         element)</samp>
     *     </code>
     * @returns {Attribute[]} An array of zero to N attribute nodes.
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     */

    var nameMatch,

        arr,

        attrs,
        len,
        i,

        attr;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(attributeName)) {
        return TP.ac(anElement.attributes);
    }

    if (TP.isRegExp(attributeName)) {
        nameMatch = attributeName;
    } else {
        nameMatch = TP.getQNameRegex(attributeName);
    }

    arr = TP.ac();

    //  Loop over all of the attribute nodes and if their name produces a
    //  match using the RegExp that we generated, then add it to the result
    //  Array.

    attrs = anElement.attributes;
    len = attrs.length;
    for (i = 0; i < len; i++) {
        attr = attrs[i];
        if (nameMatch.test(attr.name) && attr.specified) {
            arr.push(attr);
        }
    }

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetAttributeNodesInNS',
function(anElement, attributeName, attrNS) {

    /**
     * @method elementGetAttributeNodesInNS
     * @summary Returns an array of zero to N attribute nodes that match the
     *     attribute name provided and that exist in the attribute namespace.
     * @description The attributeName in this case is expected to be of the form
     *     'wholename', '*:localname' or 'prefix:*', wildcarding either the
     *     prefix or the localname. If it is omitted, all attributes will be
     *     represented in the hash.
     * @param {Element} anElement The element to retrieve the attribute value
     *     from.
     * @param {String|RegExp} attributeName An attributeName "search" criteria
     *     of the form 'wholename' '*:localname' or 'prefix:*' or any RegExp.
     *     This is optional.
     * @param {String} attrNS The namespace URI to use.
     * @example Grab only the attribute nodes of the attributes whose names are
     *     'baz' in an XML element and are also in the 'http://www.bar.com'
     *     namespace, into a hash:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com" xmlns:bar="http://www.bar.com"
     *         bar:baz="bazify" baz="zoo"><bar/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.elementGetAttributeNodesInNS(
     *          xmlDoc.documentElement,
     *          'baz',
     *          'http://www.bar.com');
     *          <samp>(array of 'baz' attribute nodes, which are also in the
     *         'http://www.bar.com' namespace, from the document element)</samp>
     *     </code>
     * @returns {Attribute[]} An array of zero to N attribute nodes.
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     * @exception TP.sig.InvalidName Raised when the supplied attribute
     *     namespace is empty.
     */

    var arr,

        attrs,

        len,
        i;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(attrNS)) {
        return TP.raise(this, 'TP.sig.InvalidName');
    }

    arr = TP.ac();

    if (TP.isString(attributeName) || TP.isRegExp(attributeName)) {
        attrs = TP.elementGetAttributeNodes(anElement, attributeName);
    } else {
        attrs = anElement.attributes;
    }

    len = attrs.length;

    for (i = 0; i < len; i++) {
        if (attrNS === attrs[i].namespaceURI) {
            arr.push(attrs[i]);
        }
    }

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetCanonicalName',
function(anElement, ignoreSourcetag) {

    /**
     * @method elementGetCanonicalName
     * @summary Returns the prefix:tagname form of the element's name, using
     *     namespaceURI data and TIBET's XMLNS information to return the
     *     canonical prefix version.
     * @description In an HTML document (which knows nothing of namespaces),
     *     this routine will 'fake' a prefix for non-prefixed elements by
     *     prepending an 'html:' prefix onto them. This method, unlike
     *     TP.elementGetFullName(), ignores any prefix given by the author to an
     *     element and attempts to compute a prefix by using any namespace
     *     information the element may have. For instance, the author might have
     *     called the element 'xf:input', because they aliased the prefix 'xf'
     *     to the XForms namespace, but this routine will return 'xforms:input',
     *     since 'xforms' is the 'canonical' prefix for this namespace. This
     *     distinction is important to the TIBET engine.
     * @param {Element} anElement The element to get the canonical name of.
     * @param {Boolean} ignoreSourcetag When true the element will ignore
     *     'tibet:tag' data and work purely from the node name and namespace URI
     *     data. Defaults to false.
     * @example Obtain the canonical name for an HTML element whose name doesn't
     *     have a prefix:
     *     <code>
     *          TP.elementGetCanonicalName(TP.documentGetBody(document));
     *          <samp>html:body</samp>
     *     </code>
     * @example Obtain the canonical name for an unprefixed XML element:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<input xmlns="http://www.w3.org/2002/xforms"/>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.elementGetCanonicalName(xmlDoc.documentElement);
     *          <samp>xforms:input</samp>
     *     </code>
     * @example Obtain the canonical name for a prefixed XML element (but one
     *     that is not using the canonical prefix):
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<xf:input xmlns:xf="http://www.w3.org/2002/xforms"/>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.elementGetCanonicalName(xmlDoc.documentElement);
     *          <samp>xforms:input</samp>
     *     </code>
     * @returns {String} The element's canonical name.
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     */

    var tag,
        uri,
        prefix;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  tag is fastest if it exists and we're allowed to use it
    if (!ignoreSourcetag &&
        TP.notEmpty(tag = anElement.getAttribute('tibet:tag')) &&
        !TP.regex.HAS_ACP.test(tag)) {
        return tag;
    }

    //  prefixes are the tricky part...we want to work from namespaceURI
    uri = TP.nodeGetNSURI(anElement);
    if (TP.notEmpty(uri)) {
        prefix = TP.w3.Xmlns.getCanonicalPrefix(uri);
    }

    //  if a canonical prefix couldn't be found, then try to get a prefix
    //  from the element.
    if (TP.isEmpty(prefix)) {
        //  if the prefix is empty, then see if its an HTML element, in
        //  which case we 'fake' it by using 'html' as the prefix.
        if (TP.isHTMLNode(anElement)) {
            prefix = 'html';
        } else {
            //  Otherwise, use the prefix that was defined for the element
            //  if possible. this is authored value, not really canonical
            prefix = anElement.prefix;
            if (TP.isEmpty(prefix) && TP.isXHTMLNode(anElement)) {
                prefix = 'html';
            }
        }
    }

    //  now for the tag...we need local name, which differs between IE and
    //  Moz, but TIBET gives us the right answer ;-).
    tag = TP.elementGetLocalName(anElement);

    //  if there was no prefix (or we couldn't compute one), then just
    //  return the tag name here.
    if (TP.isEmpty(prefix)) {
        return tag;
    } else if (prefix === 'html') {
        //  NOTE that for our purposes all html tag names are lower case in
        //  their canonical form (since we're XHTML compliant).
        return prefix + ':' + tag.toLowerCase();
    } else {
        return prefix + ':' + tag;
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetDocumentIndex',
function(anElement, joinChar) {

    /**
     * @method elementGetDocumentIndex
     * @summary Returns an index generated for the element within the document.
     * @description This index is unique within the elements's document and can
     *     be used for positioning comparison purposes with other elements. The
     *     format used here is consistent with the format for the element()
     *     scheme from XPointer but this routine does not attempt to find an
     *     ancestor with an ID, it produces a path composed entirely of
     *     numerical, 1-indexed, element positions.
     * @param {Element} anElement The Element to operate on.
     * @param {String} joinChar A character to use when joining the index parts.
     *     Default is / for element() scheme path construction.
     * @example Compute a document-level index for an XML element:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo><bar>Some text<goo>More
     *         text</goo></bar>Yet more text</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          // Compute the index for the 'goo' element
     *          TP.elementGetDocumentIndex(
     *          TP.nodeGetElementsByTagName(xmlDoc, 'goo').first());
     *          <samp>/1/1/2/1</samp>
     *     </code>
     * @example Compute a document-level index for an HTML element:
     *     <code>
     *          TP.elementGetDocumentIndex(TP.documentGetBody(document));
     *          <samp>/1/2/1</samp>
     *     </code>
     * @returns {String} The index or TP.NOT_FOUND.
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     */

    var elem,
        index,
        path;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isDocument(anElement)) {
        return TP.NOT_FOUND;
    }

    elem = anElement;
    path = TP.ac();

    //  Loop over the ancestors as long as they're elements and get each
    //  parent index. Note how we pass 'true' so that only Element nodes are
    //  considered at each level.
    while (TP.isElement(elem) &&
            (index = TP.nodeGetIndexInParent(elem, true)) !== TP.NOT_FOUND) {
        path.push(index + 1);
        elem = elem.parentNode;
    }

    if (TP.isEmpty(path)) {
        return TP.NOT_FOUND;
    }

    return (joinChar || '/') + path.reverse().join(joinChar || '/');
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetFullName',
function(anElement, ignoreSourcetag) {

    /**
     * @method elementGetFullName
     * @summary Returns the prefix:tagname form of the element's name without
     *     attempting to find a canonical prefix for any NS URI which might be
     *     present.
     * @description In an HTML document (which knows nothing of namespaces),
     *     this routine will 'fake' a prefix for non-prefixed elements by
     *     prepending an 'html:' prefix onto them. This method, unlike
     *     TP.elementGetCanonicalName(), does not try to compute a canonical
     *     prefix for the element. If the element is in an XML document and has
     *     a prefix, it will be returned as part of the name, otherwise it
     *     won't.
     * @param {Element} anElement The element to get the full name of.
     * @param {Boolean} ignoreSourcetag When true the element will ignore
     *     tibet:tag data and work purely from the node name and namespace
     *     URI data.
     * @example Obtain the full name for an HTML element whose name doesn't have
     *     a prefix:
     *     <code>
     *          TP.attributeGetFullName(TP.documentGetBody(document));
     *          <samp>html:style</samp>
     *     </code>
     * @example Obtain the full name for an unprefixed XML element:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<input xmlns="http://www.w3.org/2002/xforms"/>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.elementGetFullName(xmlDoc.documentElement);
     *          <samp>input</samp>
     *     </code>
     * @example Obtain the full name for a prefixed XML element (but one that is
     *     not using the canonical prefix):
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<xf:input xmlns:xf="http://www.w3.org/2002/xforms"/>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.elementGetFullName(xmlDoc.documentElement);
     *          <samp>xf:input</samp>
     *     </code>
     * @returns {String} The element's full name.
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     */

    var tag,

        prefix;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  tag is fastest if it exists
    if (!ignoreSourcetag &&
        TP.notEmpty(tag = anElement.getAttribute('tibet:tag'))) {
        return tag;
    }

    //  now for the tag...we need local name, which differs between IE and
    //  Moz, but TIBET gives us the right answer ;-).
    tag = TP.elementGetLocalName(anElement);

    if (TP.regex.HAS_COLON.test(tag)) {
        return tag;
    }

    //  use the prefix that was defined for the element.
    if (TP.isEmpty(prefix = anElement.prefix)) {
        //  if the prefix is empty, then see if its an HTML element, in
        //  which case we 'fake' it by using 'html' as the prefix.
        if (TP.isHTMLNode(anElement) || TP.isXHTMLNode(anElement)) {
            prefix = 'html';
        } else if (TP.isXMLNode(anElement) &&
                    TP.isValid(TP.w3.Xmlns) &&
                    TP.notEmpty(anElement.namespaceURI)) {
            prefix = TP.w3.Xmlns.getCanonicalPrefix(anElement.namespaceURI);
        }
    }

    //  if there was no prefix then just return the tag name here.
    if (TP.isEmpty(prefix)) {
        return tag;
    } else if (prefix === 'html') {
        //  NOTE that for our purposes all html tag names are lower case in
        //  their canonical form
        return prefix + ':' + tag.toLowerCase();
    } else {
        return prefix + ':' + tag;
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetGeneratingElement',
function(anElement) {

    /**
     * @method elementGetGeneratingElement
     * @summary Returns the 'generating element' that generated the supplied
     *     element. This is usually an instance of some kind of TIBET custom
     *     tag.
     * @param {Element} anElement The element to get the generating element
     *     for.
     * @returns {Element|null} The generating element, if found.
     * @exception TP.sig.InvalidElement
     */

    var tpElement,
        element;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement',
                                'Must provide a target Element node.');
    }

    tpElement = TP.wrap(anElement);
    if (TP.isKindOf(tpElement, TP.tag.CustomTag)) {
        return anElement;
    }

    element = anElement.parentNode;
    while (TP.isElement(element)) {
        tpElement = TP.wrap(element);
        if (TP.isKindOf(tpElement, TP.tag.CustomTag)) {
            return element;
        }
        element = element.parentNode;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetTextNodesMatching',
function(anElement, aMatchFunction) {

    /**
     * @method elementGetTextNodesMatching
     * @summary Returns any descendant Text nodes under the supplied element
     *     that return true when the supplied matching Function executed against
     *     their nodeValue.
     * @param {Function} aMatchFunction The Function to execute against the
     *     nodeValue of each descendant Text node. This should take one
     *     argument, the text node to test, and return a Boolean as to whether
     *     the text node matches.
     * @returns {Text[]} An array of Text nodes that match the criteria in the
     *     supplied matching Function.
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     * @exception TP.sig.InvalidFunction Raised when an invalid function is
     *     provided to the method.
     */

    var iterator,
        matchingTextNodes,
        textNode;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (!TP.isCallable(aMatchFunction)) {
        return TP.raise(this, 'TP.sig.InvalidFunction');
    }

    //  Create a NodeIterator that will walk the DOM tree.
    iterator = TP.nodeGetDocument(anElement).createNodeIterator(
                anElement,
                NodeFilter.SHOW_TEXT,
                null,
                false);

    //  Keep a list of the Text nodes that pass the test.
    matchingTextNodes = TP.ac();

    //  Iterate to the first Text node.
    textNode = iterator.nextNode();

    //  NB: We can use the 'isNode()' test since the NodeIterator guarantees us
    //  only Text nodes.
    while (TP.isNode(textNode)) {

        //  If executing the test Function returns true, then we add the Text
        //  node to our result list.
        if (aMatchFunction(textNode)) {
            matchingTextNodes.push(textNode);
        }

        //  Move on to the next Text node.
        textNode = iterator.nextNode();
    }

    return matchingTextNodes;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$elementGetPrefixedAttributeNode',
function(anElement, attributeName, checkAttrNSURI) {

    /**
     * @method $elementGetPrefixedAttributeNode
     * @summary Returns the attribute node for the name provided, optionally
     *     ensuring that a precise namespace URI match for prefixed attribute
     *     names is observed.
     * @description This is a private method. See TP.elementGetAttribute() for
     *     more information and examples on this functionality.
     * @param {Element} anElement The element to retrieve the attribute node
     *     from.
     * @param {String} attributeName The attribute to find.
     * @param {Boolean} checkAttrNSURI True will cause this method to be more
     *     rigorous in its checks for prefixed attributes, looking via URI
     *     rather than just prefix. Default is false (to keep things faster).
     * @returns {Attribute} The attribute node, if found.
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     * @exception TP.sig.InvalidName Raised when the supplied attribute name is
     *     empty.
     */

    var arr,

        prefix,
        lname,

        nsuri,
        attrNode,

        docElem,

        prefixes,

        attributes,

        len,
        i,

        prefixToUse;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(attributeName)) {
        return TP.raise(this, 'TP.sig.InvalidName');
    }

    if (TP.isTrue(checkAttrNSURI)) {
        //  we're being asked to be strict about NSURI, so we'll have to
        //  work a little. first we need the prefix so we can try to work
        //  from a canonical URI
        arr = attributeName.match(TP.regex.NS_QUALIFIED);
        if (TP.notValid(arr)) {
            //  Not a 'namespaced' attribute name. Return null.
            return null;
        }
        prefix = arr.at(1);
        lname = arr.at(2);

        //  NOTE the dependency here on the XMLNS type which allows us
        //  to look up the registered URI for our prefix
        nsuri = TP.w3.Xmlns.getNSURIForPrefix(prefix);
        if (TP.notEmpty(nsuri)) {
            //  might get lucky and find it by full name and have it check
            //  out. this would be typical for things like ev: or bind:
            //  attributes that are orthagonal to the element
            if (TP.isAttributeNode(attrNode = anElement.getAttributeNode(
                                                        attributeName))) {
                if (TP.nodeGetNSURI(attrNode) === nsuri) {
                    return attrNode;
                }
            }

            //  second common case is where the attributes weren't strictly
            //  in any namespace, but that's not what most authors assume
            //  when they place unqualified names on an element in that
            //  namespace...
            if (TP.nodeGetNSURI(anElement) === nsuri) {
                //  the element is in our target namespace, so is the
                //  attribute there without the prefix? that's common
                if (TP.isAttributeNode(attrNode =
                                anElement.getAttributeNode(lname))) {
                    return attrNode;
                }
            }

            //  all we can do now is "scan" the attributes by nsuri, but we
            //  can shortcut that if the only registered prefix for that URI
            //  matches the one we've already checked... but first, we check to
            //  make sure we have a document element.
            if (TP.isElement(docElem =
                                TP.elem(TP.nodeGetDocument(anElement)))) {

                prefixes = TP.nodeGetNSPrefixes(docElem, nsuri, false);
            }

            //  If the prefixes weren't empty, but there was only one and it
            //  was the one we already checked, then bail out here.
            if (TP.notEmpty(prefixes) &&
                prefixes.getSize() === 1 &&
                prefixes.at(0) === prefix) {
                return null;
            }

            //  Otherwise, loop over all of the attributes, looking for an
            //  attribute node with a local name the same as lname and with
            //  a namespace URI the same as nsuri.
            attributes = anElement.attributes;
            len = attributes.length;
            for (i = 0; i < len; i++) {
                attrNode = attributes[i];
                if (TP.attributeGetLocalName(attrNode) === lname &&
                    TP.nodeGetNSURI(attrNode) === nsuri) {
                    return attrNode;
                }
            }

            return null;
        } else {
            //  not registered? no help then since we don't know the URI
            //  we're supposed to look for. basically we're forced into the
            //  same logic as if the flag were false...all we can do is fall
            //  through and go by prefix alone
            void 0;
        }
    }

    //  don't care about verifying URI, just find that prefix on an
    //  attribute, or determine that the attribute is on a tag with that
    //  prefix (and the attribute was authored using a mindset that presumed
    //  that attributes would get the namespaces of their ownerElement --
    //  which they don't)
    if (TP.isAttributeNode(attrNode =
                            anElement.getAttributeNode(attributeName))) {
        return attrNode;
    } else {
        //  have to know the prefix so we can see if that's the prefix on
        //  the element. if so we'll cheat a little and presume the author
        //  didn't follow the spec to the letter and didn't repeat the NS
        //  prefix on local attributes
        arr = attributeName.match(TP.regex.NS_QUALIFIED);
        if (TP.notValid(arr)) {
            return null;
        }

        prefix = arr.at(1);
        lname = arr.at(2);

        if (TP.isEmpty(prefixToUse = anElement.prefix)) {
            if (TP.isString(anElement.namespaceURI)) {
                prefixToUse =
                        TP.w3.Xmlns.getPrefixForNSURI(anElement.namespaceURI);
            }
        }

        if (prefixToUse === prefix) {
            if (TP.isAttributeNode(
                        attrNode = anElement.getAttributeNode(lname))) {
                return attrNode;
            }
        }
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementHasAttribute',
function(anElement, attributeName, checkAttrNSURI) {

    /**
     * @method elementHasAttribute
     * @summary Returns true if the supplied element has the attribute
     *     matching the attribute name defined on it, even if the value of that
     *     is null.
     * @param {Element} anElement The element to test for the existence of the
     *     attribute.
     * @param {String} attributeName The name of the attribute to test.
     * @param {Boolean} [checkAttrNSURI=false] True will cause this method to be
     *     more rigorous in its checks for prefixed attributes, looking via
     *     internal TIBET mechanisms in addition to the standard platform
     *     mechanism. The default is false (to keep things faster).
     * @example Check to see if the supplied element has a particular attribute:
     *     <code>
     *          TP.elementHasAttribute(TP.documentGetBody(document),
     *         'style');
     *          <samp>true</samp>
     *     </code>
     * @example Check to see if the supplied element has a particular attribute
     *     in an XML document:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"
     *         xmlns:xf="http://www.w3.org/2002/xforms" xf:bind="theBinder"
     *         goo="moo">Hi there</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          //  Simple attribute access
     *          TP.elementHasAttribute(xmlDoc.documentElement, 'goo');
     *          <samp>true</samp>
     *          //  Prefixed attribute access
     *          TP.elementHasAttribute(xmlDoc.documentElement, 'xf:bind');
     *          <samp>true</samp>
     *          //  Prefixed attribute access without checkAttrNSURI - will fail
     *          TP.elementHasAttribute(xmlDoc.documentElement,
     *          'xforms:bind');
     *          <samp>false</samp>
     *          //  Alternate prefix attribute access (need checkAttrNSURI flag)
     *          TP.elementHasAttribute(xmlDoc.documentElement,
     *          'xforms:bind',
     *          true);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} Whether or not the element has a value for the
     *     supplied attribute.
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     * @exception TP.sig.InvalidName Raised when a null or empty attribute name
     *     is provided to the method.
     */

    var qualified,

        parts,
        nsURI;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(attributeName)) {
        return TP.raise(this, 'TP.sig.InvalidName');
    }

    if (!anElement.hasAttribute(attributeName)) {

        //  we can speed things up quite a bit if we avoid work related to
        //  namespaces as much as possible. In this case, test to see if the
        //  attribute name has a colon in it.
        qualified = TP.regex.HAS_COLON.test(attributeName);
        if (!qualified) {
            return false;
        }

        parts = attributeName.match(TP.regex.NS_QUALIFIED);
        if (TP.isEmpty(nsURI = anElement.lookupNamespaceURI(parts.at(1)))) {

            if (!checkAttrNSURI) {
                return false;
            }

            //  NOTE the dependency here on the XMLNS type which allows us
            //  to look up the registered URI for our prefix
            nsURI = TP.w3.Xmlns.getNSURIForPrefix(parts.at(1));
            if (TP.isEmpty(nsURI)) {
                TP.ifWarn() ? TP.warn(
                'Couldn\'t find namespace URI for prefix: ' + parts.at(1)) : 0;
            }

            //  Yes, this could go below, but let's make it explicit for
            //  readability here.
            return anElement.hasAttributeNS(nsURI, parts.at(2));
        }

        //  Note here that we use only the *local* attribute name as specified
        //  by the 'hasAttributeNS' spec.
        if (!anElement.hasAttributeNS(nsURI, parts.at(2))) {

            //  We didn't get a 'true' - so now we try a convenience provided by
            //  TIBET. Officially, X(HT)ML attributes are not in any namespace,
            //  including their owning element's namespace, unless they are
            //  specifically prefixed. But we provide a convenience such that,
            //  if there was a false returned by checking the 'whole attribute
            //  name' (i.e. with a prefix), we see if the namespace computed by
            //  the prefix supplied to this call is the same as the namespace of
            //  the owning element. If it is, we'll try again with just the
            //  local name of the attribute. This allows for markup authored
            //  like: <foo:bar baz="goo"/> and for us to use
            //  TP.elementHasAttribute('foo:baz') which will return true.
            if (nsURI === anElement.namespaceURI) {
                return anElement.hasAttribute(parts.at(2));
            }

            return false;
        }
    }

    return true;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementHasAttributeValue',
function(anElement, attributeName, attributeValue, checkAttrNSURI) {

    /**
     * @method elementHasAttributeValue
     * @summary Matches the value of the attribute with the value to see if
     *     they match.
     * @param {Element} anElement The element to match the attribute on.
     * @param {String} attributeName The attribute to match.
     * @param {String|RegExp} attributeValue The attribute value to try to match
     *     as either a String or as a RegExp.
     * @param {Boolean} [checkAttrNSURI=false] True will cause this method to be
     *     more rigorous in its checks for prefixed attributes, looking via
     *     internal TIBET mechanisms in addition to the standard platform
     *     mechanism. The default is false (to keep things faster).
     * @returns {Boolean} Whether or not the supplied attribute value matches
     *     the attribute value on the supplied element.
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     * @exception TP.sig.InvalidName Raised when the supplied attribute name is
     *     empty.
     */

    var value,
        valueMatch;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(attributeName)) {
        return TP.raise(this, 'TP.sig.InvalidName');
    }

    if (!TP.elementHasAttribute(anElement, attributeName, checkAttrNSURI)) {
        return false;
    }

    value = TP.elementGetAttribute(anElement, attributeName, checkAttrNSURI);

    if (TP.isRegExp(attributeValue)) {
        valueMatch = attributeValue;
    } else {
        //  NOTE: The RegExp here makes sure that the value is either first,
        //  last or is surrounded by one character of whitespace.
        valueMatch = TP.rc('(^|\\s)' + attributeValue + '(\\s|$)');
    }

    return valueMatch.test(value);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementHasGeneratedID',
function(anElement) {

    /**
     * @method elementHasGeneratedID
     * @summary Returns true if the supplied element has a 'generated ID' - that
     *     is, an ID that was generated by TIBET and not set by the markup
     *     author or other code.
     * @param {Element} anElement The element to test for the existence of a
     *     generated ID.
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     */

    var id,

        fullName,
        generatedPrefix;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  Grab the element's current ID - it's its empty, then it can't have been
    //  generated ;-).
    id = TP.elementGetAttribute(anElement, 'id', true);
    if (TP.isEmpty(id)) {
        return false;
    }

    //  The TIBET algorithm for generated IDs uses the full name and replaces
    //  ':' with '_'. Return whether or not the element's ID starts with that
    //  computed prefix.
    fullName = TP.elementGetFullName(anElement);
    generatedPrefix = fullName.replace(':', '_');

    return id.startsWith(generatedPrefix);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementInsertContent',
function(anElement, theContent, aPositionOrPath, loadedFunction, shouldAwake) {

    /**
     * @method elementInsertContent
     * @summary Inserts content from theContent into/around anElement based on
     *     the position given. The position should indicate whether the content
     *     should become the previous sibling, next sibling, first child or last
     *     child.
     * @param {Element} anElement The element receiving content.
     * @param {Object} theContent The object to use as the source of the
     *     content.
     * @param {String} aPositionOrPath The position to place the content
     *     relative to anElement or a path to evaluate to get to a node at that
     *     position. This should be one of four values: TP.BEFORE_BEGIN,
     *     TP.AFTER_BEGIN, TP.BEFORE_END, TP.AFTER_END or the path to evaluate.
     *     Default is TP.BEFORE_END.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just inserted. The default for an 'insert' operation is false.
     * @exception TP.sig.InvalidElement
     * @returns {Node} The first node of the content that was just inserted.
     */

    var positionOrPath,
        content;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement',
                                'Must provide a target Element node.');
    }

    if (TP.notValid(theContent)) {
        return;
    }

    positionOrPath = TP.ifEmpty(aPositionOrPath, TP.BEFORE_END);

    //  this allows us to accept things like TP.uri.URI, TP.dom.Node, etc.
    //  and to process them as the content routines would expect.
    content = TP.canInvoke(theContent, 'getResource') ?
                theContent.getResource(
                    TP.hc('resultType', TP.DOM)).get('result') :
                theContent;
    content = TP.unwrap(content);

    if (TP.isHTMLNode(anElement)) {
        return TP.htmlElementInsertContent(anElement, content,
                                            positionOrPath,
                                            loadedFunction, shouldAwake);
    } else {
        return TP.xmlElementInsertContent(anElement, content,
                                            positionOrPath,
                                            loadedFunction, shouldAwake);
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementMergeAttributes',
function(fromElement, toElement, shouldOverlay, nameRegExp, useElementNS) {

    /**
     * @method elementMergeAttributes
     * @summary Merges the attributes across a pair of elements. Attributes
     *     from the fromElement are merged into the toElement.
     * @param {Element} fromElement The source element.
     * @param {Element} toElement The target element.
     * @param {Boolean} [shouldOverlay=false] If the same attribute exists on
     *     the toElement, should the new value be copied from the fromElement
     *     onto the toElement?
     * @param {RegExp} [nameRegExp] If this RegExp is defined, then only
     *     attributes whose name matches using this RegExp will be merged from
     *     the fromElement onto the toElement.
     * @param {Boolean} [useElementNS=false] Whether or not to use the element's
     *     namespace for attributes that aren't already in a namespace.
     * @example Merge attributes from one XML element to another (but not the
     *     overlaying the value of existing attributes)
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo><bar xmlns="http://www.bar.com" id="barfy"
     *         goo="moo"/><baz/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.elementMergeAttributes(
     *          xmlDoc.documentElement.childNodes[0],
     *          xmlDoc.documentElement.childNodes[1]);
     *          <samp>undefined</samp>
     *          TP.nodeAsString(xmlDoc);
     *          <samp>&lt;foo&gt;&lt;bar xmlns="http://www.bar.com" id="barfy"
     *         goo="moo"/&gt;&lt;baz goo="moo"/&gt;&lt;/foo&gt;</samp>
     *     </code>
     * @example Merge attributes from one XML element to another (including
     *     overlaying the value of existing attributes).
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo><bar xmlns="http://www.bar.com" id="barfy"
     *         goo="moo"/><baz/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.elementMergeAttributes(
     *          xmlDoc.documentElement.childNodes[0],
     *          xmlDoc.documentElement.childNodes[1],
     *          true);
     *          <samp>undefined</samp>
     *          TP.nodeAsString(xmlDoc);
     *          <samp>&lt;foo&gt;&lt;bar xmlns="http://www.bar.com" id="barfy"
     *         goo="moo"/&gt;&lt;baz id="barfy"
     *         goo="moo"/&gt;&lt;/foo&gt;</samp>
     *     </code>
     * @example Merge attributes ending with 'oo' from one XML element to
     *     another:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo><bar xmlns="http://www.bar.com" id="barfy" goo="moo"
     *         boo="yoo" gar="mar"/><baz/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.elementMergeAttributes(
     *          xmlDoc.documentElement.childNodes[0],
     *          xmlDoc.documentElement.childNodes[1],
     *          false,
     *          /oo/);
     *          <samp>undefined</samp>
     *          TP.nodeAsString(xmlDoc);
     *          <samp>&lt;foo&gt;&lt;bar xmlns="http://www.bar.com" id="barfy"
     *         goo="moo" boo="yoo" gar="mar"/&gt;&lt;baz goo="moo"
     *         boo="yoo"/&gt;&lt;/foo&gt;</samp>
     *     </code>
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     */

    var forceCopy,
        hasMatcher,

        shouldPrefix,

        sourcePrefix,
        sourceNS,

        destPrefix,
        destNS,

        toXMLNS,

        len,
        i,

        attrNode,
        attrValue,

        localName,
        prefix;

    if (!TP.isElement(fromElement) || !TP.isElement(toElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    forceCopy = TP.ifInvalid(shouldOverlay, false);
    hasMatcher = TP.isRegExp(nameRegExp) ? true : false;
    toXMLNS = toElement.namespaceURI;

    if (TP.isTrue(useElementNS)) {
        shouldPrefix = true;
        if (TP.notEmpty(sourceNS = TP.nodeGetNSURI(fromElement))) {
            if (TP.isEmpty(sourcePrefix = fromElement.prefix)) {
                sourcePrefix = TP.w3.Xmlns.getPrefixForNSURI(sourceNS,
                                                            fromElement);
            }
        }

        if (TP.notEmpty(destNS = TP.nodeGetNSURI(toElement))) {
            if (TP.isEmpty(destPrefix = toElement.prefix)) {
                destPrefix = TP.w3.Xmlns.getPrefixForNSURI(destNS,
                                                        fromElement);
            }
        }

        if (sourceNS === destNS &&
            sourcePrefix === destPrefix) {
            shouldPrefix = false;
        }
    }

    len = fromElement.attributes.length;
    for (i = 0; i < len; i++) {
        attrNode = fromElement.attributes[i];

        //  If an attribute name matcher (a RegExp) is defined, then test it
        //  against the attribute node's name. If it doesn't pass, move on
        //  to the next attribute node.
        if (hasMatcher && !nameRegExp.test(attrNode.name)) {
            continue;
        }

        //  If the attribute's value is the same as the toElement's
        //  namespaceURI, don't copy it over - its an 'xmlns' attribute.
        //  This helps prevent the same namespace from being put on the
        //  element over and over again.
        if ((attrValue = attrNode.value) === toXMLNS) {
            continue;
        }

        //  If the attribute name itself (not the prefix, but just the
        //  attribute name) is 'xmlns', then we don't copy it since browsers
        //  freak out when we try to reset the default namespace.
        if ((localName = TP.attributeGetLocalName(attrNode)) === 'xmlns') {
            continue;
        }

        //  If we're not forcing an overlay and the fromElement already has
        //  an attribute with the same name, then we continue
        if (!forceCopy && TP.elementHasAttribute(toElement, attrNode.name)) {
            continue;
        }

        if (TP.notEmpty(attrNode.namespaceURI)) {
            //  If the attribute node has an actual prefix, use it.
            if (TP.notEmpty(prefix = attrNode.prefix)) {
                TP.elementSetAttributeInNS(toElement,
                                            prefix + ':' + localName,
                                            attrValue,
                                            attrNode.namespaceURI);
            } else {
                //  Otherwise, just use the local name.
                TP.elementSetAttributeInNS(toElement,
                                            localName,
                                            attrValue,
                                            attrNode.namespaceURI);
            }
        } else if (shouldPrefix &&
                    TP.isString(sourceNS) &&
                    TP.notEmpty(sourcePrefix) &&
                    !TP.NEVER_PREFIXED_ATTRS.contains(localName)) {
            TP.elementSetAttributeInNS(
                                toElement,
                                sourcePrefix + ':' + localName,
                                attrValue,
                                sourceNS);
        } else {
            TP.elementSetAttribute(toElement,
                                    localName,
                                    attrNode.value);
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementReplaceWith',
function(anElement, anObject, loadedFunction, shouldAwake) {

    /**
     * @method elementReplaceWith
     * @summary Replaces the element with the object content provided.
     * @param {Element} anElement The element receiving content.
     * @param {Object} anObject The object to use as the source of the content.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just replaced. The default for this operation is true.
     * @exception TP.sig.InvalidElement
     * @returns {Node} The first node of the content that was just inserted.
     */

    var content;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement',
                                'Must provide a target Element node.');
    }

    //  this allows us to accept things like TP.uri.URI, TP.dom.Node, etc.
    //  and to process them as the content routines would expect.
    content = TP.canInvoke(anObject, 'getResource') ?
                anObject.getResource(
                    TP.hc('resultType', TP.DOM)).get('result') :
                anObject;
    content = TP.unwrap(content);

    if (TP.isHTMLNode(anElement)) {
        return TP.htmlElementReplaceWith(anElement, content,
                                            loadedFunction, shouldAwake);
    } else {
        return TP.xmlElementReplaceWith(anElement, content,
                                            loadedFunction, shouldAwake);
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementRemoveAttribute',
function(anElement, attributeName, checkAttrNSURI) {

    /**
     * @method elementRemoveAttribute
     * @summary Removes an attribute from the supplied element whose name
     *     matches attributeName.
     * @param {Element} anElement The element to remove the attribute from.
     * @param {String} attributeName The name of the attribute to remove.
     * @param {Boolean} [checkAttrNSURI=false] True will cause this method to be
     *     more rigorous in its checks for prefixed attributes, looking via
     *     internal TIBET mechanisms in addition to the standard platform
     *     mechanism. The default is false (to keep things faster).
     * @example Remove the attribute named for the supplied element in an HTML
     *     document:
     *     <code>
     *          TP.elementSetAttribute(TP.documentGetBody(document), 'baz',
     *          'bazify');
     *          TP.elementHasAttribute(TP.documentGetBody(document), 'baz');
     *          <samp>true</samp>
     *          TP.elementRemoveAttribute(TP.documentGetBody(document),
     *         'baz');
     *          <samp>undefined</samp>
     *          TP.elementHasAttribute(TP.documentGetBody(document), 'baz');
     *          <samp>false</samp>
     *     </code>
     * @example Remove the attribute named for the supplied element in an XML
     *     document:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"
     *         xmlns:xf="http://www.w3.org/2002/xforms" xf:bind="theBinder"
     *         goo="moo">Hi there</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          // Simple attribute removal
     *          TP.elementHasAttribute(xmlDoc.documentElement, 'goo');
     *          <samp>true</samp>
     *          TP.elementRemoveAttribute(xmlDoc.documentElement, 'goo');
     *          <samp>undefined</samp>
     *          TP.elementHasAttribute(xmlDoc.documentElement, 'goo');
     *          <samp>false</samp>
     *          // Prefixed attribute access
     *          TP.elementHasAttribute(xmlDoc.documentElement, 'xf:bind');
     *          <samp>true</samp>
     *          TP.elementRemoveAttribute(xmlDoc.documentElement,
     *          'xf:bind');
     *          <samp>undefined</samp>
     *          TP.elementHasAttribute(xmlDoc.documentElement, 'xf:bind');
     *          <samp>false</samp>
     *          // Prefixed attribute removal without checkAttrNSURI -
     *          // will fail
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"
     *         xmlns:xf="http://www.w3.org/2002/xforms" xf:bind="theBinder"
     *         goo="moo">Hi there</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.elementHasAttribute(xmlDoc.documentElement,
     *          'xforms:bind',
     *          true);
     *          <samp>true</samp>
     *          TP.elementRemoveAttribute(xmlDoc.documentElement,
     *          'xforms:bind');
     *          <samp>undefined</samp>
     *          TP.elementHasAttribute(xmlDoc.documentElement,
     *          'xforms:bind',
     *          true);
     *          <samp>true</samp>
     *          // Alternate prefix attribute access (need
     *          // checkAttrNSURI flag)
     *          TP.elementHasAttribute(xmlDoc.documentElement,
     *          'xforms:bind',
     *          true);
     *          <samp>true</samp>
     *          TP.elementRemoveAttribute(xmlDoc.documentElement,
     *          'xforms:bind',
     *          true);
     *          <samp>undefined</samp>
     *          TP.elementHasAttribute(xmlDoc.documentElement,
     *          'xforms:bind',
     *          true);
     *          <samp>false</samp>
     *     </code>
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     * @exception TP.sig.InvalidName Raised when a null or empty attribute name
     *     is provided to the method.
     */

    var qualified,

        parts,
        nsURI;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(attributeName)) {
        return TP.raise(this, 'TP.sig.InvalidName');
    }

    //  we can speed things up quite a bit if we avoid work related to
    //  namespaces as much as possible. In this case, test to see if the
    //  attribute name has a colon in it.
    qualified = TP.regex.HAS_COLON.test(attributeName);
    if (!qualified) {
        return anElement.removeAttribute(attributeName);
    } else {
        parts = attributeName.match(TP.regex.NS_QUALIFIED);
        if (TP.isEmpty(nsURI = anElement.lookupNamespaceURI(parts.at(1)))) {

            //  If we're not doing any advanced checking of namespaces, then
            //  exit here.
            if (!checkAttrNSURI) {
                return;
            }

            //  NOTE the dependency here on the XMLNS type which allows us
            //  to look up the registered URI for our prefix
            nsURI = TP.w3.Xmlns.getNSURIForPrefix(parts.at(1));
            if (TP.isEmpty(nsURI)) {
                TP.ifWarn() ? TP.warn(
                'Couldn\'t find namespace URI for prefix: ' + parts.at(1)) : 0;
            }

            //  Yes, this could go below, but let's make it explicit for
            //  readability here.
            return anElement.removeAttributeNS(nsURI, parts.at(2));
        }

        //  Note here that we use only the *local* attribute name as specified
        //  by the 'removeAttributeNS' spec.
        anElement.removeAttributeNS(nsURI, parts.at(2));

        if (TP.elementHasAttribute(anElement, attributeName, checkAttrNSURI)) {

            //  If we still have the attribute, we try a convenience provided by
            //  TIBET. Officially, X(HT)ML attributes are not in any namespace,
            //  including their owning element's namespace, unless they are
            //  specifically prefixed. But we provide a convenience such that,
            //  if the attribute wasn't actually removed by using the
            //  'whole attribute name' (i.e. with a prefix), we see if the
            //  namespace computed by the prefix supplied to this call is the
            //  same as the namespace of the owning element. If it is, we'll try
            //  again with just the local name of the attribute. This allows for
            //  markup authored like: <foo:bar baz="goo"/> and for us to use
            //  TP.elementRemoveAttribute('foo:baz') which will remove the
            //  attribute.
            if (nsURI === anElement.namespaceURI) {
                anElement.removeAttribute(parts.at(2));
            }

            return;
        }
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementRemoveAttributeValue',
function(anElement, attrName, attrValue, checkAttrNSURI, removeEmptyAttr) {

    /**
     * @method elementRemoveAttributeValue
     * @summary Removes one or more occurrences of the attribute value from the
     *     supplied element.
     * @param {Element} anElement The element to remove the attribute value
     *     from.
     * @param {String} attrName The name of the attribute to remove the value
     *     from.
     * @param {String} attrValue The value to remove from the attribute's value.
     * @param {Boolean} [checkAttrNSURI=false] True will cause this method to be
     *     more rigorous in its checks for prefixed attributes, looking via
     *     internal TIBET mechanisms in addition to the standard platform
     *     mechanism. The default is false (to keep things faster).
     * @param {Boolean} [removeEmptyAttr=true] False will cause this method to
     *     *not* remove the attribute, even if it's empty after removing the
     *     value. The default is true.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidParameter
     * @returns {Element} The element.
     */

    var existingWholeValue,

        valMatcher,
        val;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(attrName)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    //  Note here how we just check to make sure the attribute value is
    //  'valid', because it might not necessarily be a String (might be a
    //  Boolean, Number, etc.)
    if (TP.notValid(attrValue)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    if (TP.notEmpty(
            existingWholeValue =
                TP.elementGetAttribute(anElement, attrName, checkAttrNSURI))) {
        //  We construct a global RegExp where there could be a space and
        //  then the value we want to strip and then where there could be
        //  another space. This allows use to strip all occurrences of
        //  attrValue.
        valMatcher = TP.rc(' ?' + attrValue + ' ?', 'g');
        val = existingWholeValue.strip(valMatcher);

        if (TP.isEmpty(val) && TP.notFalse(removeEmptyAttr)) {
            TP.elementRemoveAttribute(anElement, attrName, checkAttrNSURI);
        } else {
            TP.elementSetAttribute(anElement, attrName, val, checkAttrNSURI);
        }
    }

    return anElement;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementReplaceAttributeValue',
function(anElement, attributeName, oldValue, newValue, checkAttrNSURI) {

    /**
     * @method elementReplaceAttributeValue
     * @summary Replaces the value of the attribute provided with a new value
     *     if the old value is found. If the old value isn't found no change is
     *     made to the attribute's value.
     * @param {Element} anElement The element to set the attribute on.
     * @param {String} attributeName The attribute to set.
     * @param {String} oldValue The old attribute value.
     * @param {String} newValue The new attribute value.
     * @param {Boolean} [checkAttrNSURI=false] True will cause this method to be
     *     more rigorous in its checks for prefixed attributes, looking via
     *     internal TIBET mechanisms in addition to the standard platform
     *     mechanism. The default is false (to keep things faster).
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     * @exception TP.sig.InvalidName Raised when the supplied attribute name is
     *     empty.
     */

    var value,
        re;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(attributeName)) {
        return TP.raise(this, 'TP.sig.InvalidName');
    }

    if (!TP.elementHasAttribute(anElement, attributeName, checkAttrNSURI)) {
        return;
    }

    value = TP.elementGetAttribute(anElement, attributeName, checkAttrNSURI);

    //  NOTE: The RegExp here makes sure that the oldValue is either first,
    //  last or is surrounded by one character of whitespace.
    re = TP.rc('(^|\\s)' + oldValue + '(\\s|$)');
    value = value.replace(re, '$1' + newValue + '$2');

    TP.elementSetAttribute(anElement, attributeName, value, checkAttrNSURI);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementRemoveNSURI',
function(anElement, aPrefix) {

    /**
     * @method elementRemoveNSURI
     * @summary Removes an 'xmlns:<aPrefix>' attribute from the element. Note
     *     that 'aPrefix' *must* be valid (i.e. you can use this
     *     mechanism to remove a default namespace attribute (i.e. a standalone
     *     'xmlns' attribute), but this will *not* change the default namespace
     *     of the supplied element - no current DOM environment supports that).
     *     Note also that namespaces can only be removed from elements in an XML
     *     document.
     * @param {Element} anElement The Element node to remove a namespace from.
     * @param {String} aPrefix The prefix of the namespace being removed. This
     *     can have the 'xmlns:' already prepended to it.
     * @example Add a namespace to an element in an XML document:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"
     *          xmlns:svg="http://www.w3.org/2000/svg"/>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.elementRemoveNSURI(xmlDoc.documentElement,
     *          'svg');
     *          TP.nodeAsString(xmlDoc);
     *          <samp>&lt;foo xmlns="http://www.foo.com"/&gt;</samp>
     *     </code>
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     * @exception TP.sig.InvalidXMLDocument Raised when the element supplied is
     *     not part of an XML document.
     * @exception TP.sig.InvalidString Raised when a null or empty prefix or URI
     *     is provided to the method.
     */

    var xmlnsAttrName;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (!TP.isXMLDocument(TP.nodeGetDocument(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidXMLDocument');
    }

    if (TP.isEmpty(aPrefix)) {
        return TP.raise(this, 'TP.sig.InvalidString',
                        'Invalid or empty prefix or URI');
    }

    //  If the prefix is just 'xmlns', we remove it and return - no need to
    //  continue.
    if (aPrefix === 'xmlns') {
        anElement.removeAttributeNS(TP.w3.Xmlns.XMLNS, aPrefix);
        return;
    }

    //  If the 'xmlns:' part was provided in the supplied prefix, split that off
    //  - this call doesn't want that.
    if (/xmlns:/g.test(aPrefix)) {
        xmlnsAttrName = aPrefix.slice(6);
    } else {
        //  Otherwise, just use it as is.
        xmlnsAttrName = aPrefix;
    }

    anElement.removeAttributeNS(TP.w3.Xmlns.XMLNS, xmlnsAttrName);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementSetAttribute',
function(anElement, attributeName, attributeValue, checkAttrNSURI) {

    /**
     * @method elementSetAttribute
     * @summary Sets the value of the attribute provided.
     * @description This method provides some additional capabilities over the
     *     standard DOM '.setAttribute()' method:
     *          #1: If there is a method defined on the 'TP' object that follows
     *          a pattern of 'TP.elementSet<attributeName>', then that method
     *          will be called as a way of specializing attribute access. For
     *          instance, TIBET provides specialized methods for 'class' and
     *          'style' attributes. So using:
     *              TP.elementSetAttribute(anElement, 'class', 'foo');
     *              will cause
     *              TP.elementSetClass(anElement, 'foo'); to be called.
     *          #2: Typically this method retrieves the attribute using the
     *          built-in platform attribute and namespace resolution mechanisms,
     *          but if a value cannot be determined and the supplied attribute
     *          name is prefixed (i.e. it is a namespaced attribute) and the
     *          checkAttrNSURI flag is set to 'true' this method tries an
     *          alternate mechanism to set the value. This mechanism uses the
     *          document's prefixes and TIBET's canonical prefixing information
     *          regarding namespaces to compute an alternate prefix for the
     *          attribute. For example, the canonical XHTML prefix is 'html:',
     *          but if the author has used the 'ht:' prefix for XHTML and the
     *          system attempts to set the 'ht:foo' attribute, this method will
     *          (if the checkAttrNSURI parameter is true) also try to set the
     *          value for the 'html:foo' attribute.
     *          If you want to force a specific namespace URI to be used you can
     *          call the companion method TP.elementSetAttributeInNS().
     * @param {Element} anElement The element to set the attribute on.
     * @param {String} attributeName The attribute to set.
     * @param {String} attributeValue The attribute value.
     * @param {Boolean} [checkAttrNSURI=false] True will cause this method to be
     *     more rigorous in its checks for prefixed attributes, looking via
     *     internal TIBET mechanisms in addition to the standard platform
     *     mechanism. The default is false (to keep things faster).
     * @example Set the value of the attribute on an XML element:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"
     *          xmlns:xf="http://www.w3.org/2002/xforms" xf:bind="theBinder"
     *          goo="moo">Hi there</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          //  Simple attribute set
     *          TP.elementSetAttribute(xmlDoc.documentElement, 'goo', 'boo');
     *          <samp>undefined</samp>
     *          TP.nodeAsString(xmlDoc);
     *          <samp>&lt;foo xmlns="http://www.foo.com"
     *          xmlns:xf="http://www.w3.org/2002/xforms" xf:bind="theBinder"
     *          goo="boo"&gt;Hi there&lt;/foo&gt;</samp>
     *          // Prefixed attribute set
     *          TP.elementSetAttribute(xmlDoc.documentElement,
     *          'xf:bind',
     *          'anotherBinder');
     *          <samp>undefined</samp>
     *          TP.nodeAsString(xmlDoc);
     *          <samp>&lt;foo xmlns="http://www.foo.com"
     *          xmlns:xf="http://www.w3.org/2002/xforms" xf:bind="anotherBinder"
     *          goo="boo"&gt;Hi there&lt;/foo&gt;</samp>
     *          //  Alternate prefix attribute set (need checkAttrNSURI flag)
     *          TP.elementSetAttribute(xmlDoc.documentElement,
     *          'xforms:bind',
     *          'yetAnotherBinder',
     *          true);
     *          <samp>undefined</samp>
     *          TP.nodeAsString(xmlDoc);
     *          <samp>&lt;foo xmlns="http://www.foo.com"
     *          xmlns:xf="http://www.w3.org/2002/xforms"
     *          xf:bind="yetAnotherBinder" goo="boo"&gt;Hi
     *          there&lt;/foo&gt;</samp>
     *     </code>
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     * @exception TP.sig.InvalidName Raised when the supplied attribute name is
     *     empty.
     */

    var methodName,

        qualified,

        parts,
        nsURI;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(attributeName)) {
        return TP.raise(this, 'TP.sig.InvalidName');
    }

    //  If the attribute name is 'id', then make sure to set the computed &
    //  cached TP.GLOBAL_ID slot to null.
    if (attributeName === 'id') {
        anElement[TP.GLOBAL_ID] = null;
    }

    //  If we're not strict about namespaces, check to see if we have a
    //  more-specific 'setter'.
    methodName = 'elementSet' + attributeName.asTitleCase();
    if (TP.canInvoke(TP, methodName)) {
        TP[methodName](anElement, attributeValue);

        return;
    }

    //  we can speed things up quite a bit if we avoid work related to
    //  namespaces as much as possible. In this case, test to see if the
    //  attribute name has a colon in it.
    qualified = TP.regex.HAS_COLON.test(attributeName);
    if (!qualified) {
        return anElement.setAttribute(attributeName, attributeValue);
    } else {
        parts = attributeName.match(TP.regex.NS_QUALIFIED);
        if (TP.isEmpty(nsURI = anElement.lookupNamespaceURI(parts.at(1)))) {

            //  If we're not doing any advanced checking of namespaces, then
            //  exit here.
            if (!checkAttrNSURI) {
                return;
            }

            //  NOTE the dependency here on the XMLNS type which allows us
            //  to look up the registered URI for our prefix
            nsURI = TP.w3.Xmlns.getNSURIForPrefix(parts.at(1));
            if (TP.isEmpty(nsURI)) {
                TP.ifWarn() ? TP.warn(
                'Couldn\'t find namespace URI for prefix: ' + parts.at(1)) : 0;
            }

            //  Using our own routine here causes an 'xmlns:<prefix>' definition
            //  to be stamped onto the element, unlike the native
            //  'setAttributeNS()' call below (which will use the full name and
            //  will put it in the right namespace, but not define the
            //  namespace).
            return TP.elementSetAttributeInNS(
                    anElement, attributeName, attributeValue, nsURI);
        }

        //  Note here that we use the full attribute name as specified by the
        //  'setAttributeNS' spec.
        return anElement.setAttributeNS(nsURI, attributeName, attributeValue);
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementSetAttributes',
function(anElement, attributeHash, checkAttrNSURI) {

    /**
     * @method elementSetAttributes
     * @summary Sets the value of the attributes provided using the supplied
     *     TP.core.Hash.
     * @param {Element} anElement The element to set the attributes on.
     * @param {TP.core.Hash} attributeHash The attributes to set.
     * @param {Boolean} [checkAttrNSURI=false] True will cause this method to be
     *     more rigorous in its checks for prefixed attributes, looking via
     *     internal TIBET mechanisms in addition to the standard platform
     *     mechanism. The default is false (to keep things faster).
     * @example Set the attributes on an HTML element using the supplied hash:
     *     <code>
     *          TP.elementSetAttributes(TP.documentGetBody(document),
     *          TP.hc('foo','bar', 'boo','baz'));
     *          <samp>undefined</samp>
     *          // Grab the body's string... note the 'true' in the 3rd
     *          // parameter to only go 'shallow' so that we don't get
     *          // all of the body's children too.
     *          TP.nodeAsString(TP.documentGetBody(document), null, true);
     *          <samp>(html markup showing that the foo and boo attributes are
     *         part of the body's markup)</samp>
     *     </code>
     * @example Set the attributes on an XML element using the supplied hash:
     *     <code>
     *          xmlDoc = TP.doc('<foo moo="goo"/>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.elementSetAttributes(xmlDoc.documentElement,
     *          TP.hc('foo','bar', 'boo','baz'));
     *          <samp>undefined</samp>
     *          // Grab the xmlDoc's documentElement's string... note
     *          // the 'true' in the 3rd parameter to only go 'shallow'
     *          // so that we don't get all of the documentElement's
     *          // children too.
     *          TP.nodeAsString(xmlDoc.documentElement, null, true);
     *          <samp>&lt;foo moo="goo" foo="bar"
     *         boo="baz"&gt;&lt;/foo&gt;</samp>
     *     </code>
     * @exception TP.sig.InvalidElement Raised when an invalid element is
     *     provided to the method.
     * @exception TP.sig.InvalidParameter Raised when an invalid attribute hash
     *     is provided to the method.
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.notValid(attributeHash)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  Loop over the supplied hash and set the attribute on the target
    //  element using the name (the first item in the key/value pair) and
    //  the value (the second item).
    attributeHash.perform(
            function(keyValuePair) {
                TP.elementSetAttribute(anElement,
                                        keyValuePair.first(),
                                        keyValuePair.last(),
                                        checkAttrNSURI);
            });

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementSetContent',
function(anElement, anObject, loadedFunction, shouldAwake) {

    /**
     * @method elementSetContent
     * @summary Inserts content from anObject into/around anElement based on
     *     the position given. The position should indicate whether the content
     *     should become the previous sibling, next sibling, first child or last
     *     child.
     * @param {Element} anElement The element receiving content.
     * @param {Object} anObject The object to use as the source of the content.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just set. The default for a 'set' operation is whether anElement has
     *     a Window object associated with it or not.
     * @exception TP.sig.InvalidElement
     * @returns {Node} The first node of the content that was just inserted.
     */

    var content;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement',
                                'Must provide a target Element node.');
    }

    if (TP.notValid(anObject)) {
        TP.nodeEmptyContent(anElement);
    }

    //  this allows us to accept things like TP.uri.URI, TP.dom.Node, etc.
    //  and to process them as the content routines would expect.
    content = TP.canInvoke(anObject, 'getResource') ?
                anObject.getResource(
                    TP.hc('resultType', TP.DOM)).get('result') :
                anObject;
    content = TP.unwrap(content);

    if (TP.isHTMLNode(anElement)) {
        return TP.htmlElementSetContent(anElement, content,
                                            loadedFunction, shouldAwake);
    } else {
        return TP.xmlElementSetContent(anElement, content,
                                            loadedFunction, shouldAwake);
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementSetGenerator',
function(anElement) {

    /**
     * @method elementSetGenerator
     * @summary Sets the 'generator' of the target element. This is the
     *     canonical name of the element, which usually points back to the type
     *     that generated the target element when it was processed.
     * @param {Element} anElement The element to set the generator for.
     * @exception TP.sig.InvalidElement
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement',
                                'Must provide a target Element node.');
    }

    anElement[TP.GENERATOR] = TP.elementGetCanonicalName(anElement);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementStripChangeFlags',
function(anElement) {

    /**
     * @method elementStripChangeFlags
     * @summary Strips the element and any descendants of any change flags.
     * @param {Element} anElement The topmost element to start stripping change
     *     flags from.
     * @returns {null}
     */

    var descendantsWithCRUD;

    //  First, remove the 'tibet:crud' attribute from the element itself.
    TP.elementRemoveAttribute(anElement, 'tibet:crud', true);

    //  Then, descend and get descendant elements that have that attribute.
    descendantsWithCRUD = TP.nodeGetDescendantElementsByAttribute(
                                    anElement,
                                    'tibet:crud');

    //  Remove it from them too
    descendantsWithCRUD.perform(
        function(anElem) {
            TP.elementRemoveAttribute(anElem, 'tibet:crud', true);
        });

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('scriptElementGetType',
function(anElement) {

    /**
     * @method scriptElementGetType
     * @summary Returns a TIBET type, if one can be computed, from the supplied
     *     script element.
     * @description TIBET follows a naming convention whereby scripts that
     *     contain TIBET types are named consistently. This method takes
     *     advantage of that fact and tries to resolve an attribute on a script
     *     element into a named TIBET type.
     * @param {Element} anElement The script element to try to determine a TIBET
     *     type from.
     * @exception TP.sig.InvalidElement
     * @returns {TP.meta.lang.RootObject|null} The type that can be determined
     *     from the script element provided.
     */

    var loc,

        typeName,
        type;

    //  Make sure we were handed a 'script' element.
    if (!TP.isElement(anElement) ||
        TP.elementGetLocalName(anElement).toLowerCase() !== 'script') {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  Grab the value of the 'src' attribute (or 'source' attribute) off of the
    //  script element.
    loc = TP.ifInvalid(
            TP.elementGetAttribute(anElement, 'src', true),
            TP.elementGetAttribute(anElement, 'source', true));

    if (TP.isEmpty(loc)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  Slice off from the last '/' plus 1 to the end. That will be type name
    //  plus extension.
    loc = loc.slice(loc.lastIndexOf('/') + 1);

    //  Slice off extension
    typeName = loc.slice(0, loc.lastIndexOf('.'));

    //  Try to get the type object by that name - if it exists.
    type = TP.sys.getTypeByName(typeName);
    if (TP.isType(type)) {
        return type;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('xmlElementAddContent',
function(anElement, theContent, loadedFunction, shouldAwake) {

    /**
     * @method xmlElementAddContent
     * @summary Adds content from theContent onto the end of the child content
     *     of anElement.
     * @param {Element} anElement The element receiving content.
     * @param {Node|String} theContent The content to insert into the element.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just added. The default for an 'add' operation is false.
     * @exception TP.sig.InvalidElement
     * @returns {Node} The first node of the content that was just added.
     */

    //  Simply a cover for inserting child content before the end of the
    //  element.
    return TP.xmlElementInsertContent(anElement,
                                        theContent,
                                        TP.BEFORE_END,
                                        loadedFunction,
                                        shouldAwake);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('xmlElementInsertContent',
function(anElement, theContent, aPositionOrPath, loadedFunction, shouldAwake) {

    /**
     * @method xmlElementInsertContent
     * @summary Inserts content from theContent into/around anElement based on
     *     the position given. The position should indicate whether the content
     *     should become the previous sibling, next sibling, first child or last
     *     child.
     * @param {Element} anElement The element receiving content.
     * @param {Node|String} theContent The content to insert into the element.
     * @param {String} aPositionOrPath The position to place the content
     *     relative to anElement or a path to evaluate to get to a node at that
     *     position. This should be one of four values: TP.BEFORE_BEGIN,
     *     TP.AFTER_BEGIN, TP.BEFORE_END, TP.AFTER_END or the path to evaluate.
     *     Default is TP.BEFORE_END.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just inserted. The default for an 'insert' operation is false.
     * @exception TP.sig.InvalidElement
     * @returns {Node} The first node of the content that was just inserted.
     */

    var awakenContent,

        thePosition,

        nodeContent,
        str,

        returnNode,

        insertionNode;

    if (!TP.isXMLNode(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    awakenContent = TP.ifInvalid(shouldAwake, false);

    thePosition = TP.ifEmpty(aPositionOrPath, TP.BEFORE_END);

    //  If the content is an XML node, then we just make sure its an
    //  Element, and not a Document.
    if (TP.isXMLNode(theContent)) {
        if (TP.isDocument(theContent)) {
            nodeContent = theContent.documentElement;
        } else {
            nodeContent = theContent;
        }
    } else if (TP.isString(theContent)) {
        //  Convert any entities to literals, since the caller assumed that they
        //  could pass entities, but this may create a Text node which will want
        //  literals.
        str = TP.xmlEntitiesToLiterals(theContent);

        //  Try to create a real Node from the supplied content (passing
        //  'true' to TP.nodeAsString() so that it will report parsing
        //  errors). If we can't parse a valid Node from the content, we
        //  just create a Text node using the content and use that.
        if (TP.notValid(nodeContent =
                        TP.nodeFromString(str, null, true))) {
            nodeContent = TP.nodeGetDocument(anElement).createTextNode(str);
        }
    } else {
        TP.raise(this, 'TP.sig.UnsupportedOperation');

        return null;
    }

    //  Based on the value of the position, we insert the node at the
    //  proper place in the DOM (pass in false to awaken the content - we
    //  don't awaken XML).
    switch (thePosition) {
        case TP.AFTER_END:

            //  Note the assignment to the returnNode here, since it might
            //  have come from a different document and been imported, etc.
            returnNode = TP.nodeInsertBefore(anElement.parentNode,
                                                nodeContent,
                                                anElement.nextSibling,
                                                awakenContent);

            break;

        case TP.BEFORE_BEGIN:

            //  Note the assignment to the returnNode here, since it might
            //  have come from a different document and been imported, etc.
            returnNode = TP.nodeInsertBefore(anElement.parentNode,
                                                nodeContent,
                                                anElement,
                                                awakenContent);

            break;

        case TP.AFTER_BEGIN:

            //  Note the assignment to the returnNode here, since it might
            //  have come from a different document and been imported, etc.
            returnNode = TP.nodeInsertBefore(anElement,
                                                nodeContent,
                                                anElement.firstChild,
                                                awakenContent);

            break;

        case TP.BEFORE_END:

            //  Note the assignment to the returnNode here, since it might
            //  have come from a different document and been imported, etc.
            returnNode = TP.nodeAppendChild(anElement,
                                            nodeContent,
                                            awakenContent);

            break;

        default:

            //  Evaluate the path, using anElement as the 'context node' and
            //  insert the new content before the returned node. Note here
            //  how we 'auto collapse' into one node (so if the path returns
            //  multiple nodes, only the first one will be used). This will
            //  also cause an invalid value if no nodes are found.

            if (TP.isNode(insertionNode = TP.nodeEvaluatePath(
                            anElement,
                            thePosition,
                            null,   //  let the call determine path type
                            true))) { //  autocollapse
                returnNode = TP.nodeInsertBefore(anElement,
                                                    nodeContent,
                                                    insertionNode,
                                                    awakenContent);
            }
    }

    //  If it's an element, bubble any namespaces we find to reduce clutter on
    //  the DOM tree
    if (TP.isElement(returnNode)) {
        TP.elementBubbleXMLNSAttributesOnDescendants(returnNode);
    }

    //  Execute any loaded function that we were handed.
    if (TP.isCallable(loadedFunction)) {
        loadedFunction(anElement.parentNode, returnNode);
    }

    //  Final operation is to signal that we've done the work
    try {
        //  We only signal TP.sig.DOMContentLoaded if the system is configured
        //  for it.
        if (TP.sys.shouldSignalDOMLoaded() && TP.isElement(returnNode)) {
            //  NB: For insert, it's actually the parent node that's changed
            //  it's content.
            TP.signal(TP.gid(returnNode.parentNode),
                        'TP.sig.DOMContentLoaded',
                        nodeContent);
        }
    } catch (e) {
        TP.ifError() ?
            TP.error(
                TP.ec(e, 'TP.sig.DOMContentLoaded handler generated error.')) :
                0;
    }

    //  Return the new element.
    return returnNode;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('xmlElementReplaceWith',
function(anElement, theContent, loadedFunction, shouldAwake) {

    /**
     * @method xmlElementReplaceWith
     * @summary Replaces anElement which should be an XML element.
     * @description This method sets the 'outer content' of anElement to
     *     theContent which means that the entire element, including its start
     *     and end tags, will be replaced with theContent. NOTE: This method may
     *     replace anElement!!! To use this method safely, always capture its
     *     return value and use that as the target element going forward.
     * @param {XMLElement} anElement The element to set the 'outer content' of.
     * @param {Node|String} theContent The content to replace the 'outer
     *     content' with.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just replaced. The default for this operation is true.
     * @exception TP.sig.InvalidElement
     * @returns {Element|Text} The newly created Node (could be a Text node,
     *     depending on how the replacement happened).
     */

    var awakenContent,

        nodeContent,
        str,

        // elemGID,

        returnNode;

    if (!TP.isXMLNode(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    awakenContent = shouldAwake;
    if (TP.notValid(awakenContent)) {
        awakenContent = TP.nodeHasWindow(anElement);
    }

    //  If the content is an XML node, then we just make sure its an
    //  Element, and not a Document.
    if (TP.isXMLNode(theContent)) {
        if (TP.isDocument(theContent)) {
            nodeContent = theContent.documentElement;
        } else {
            nodeContent = theContent;
        }
    } else if (TP.isString(theContent)) {

        //  Convert any entities to literals, since the caller assumed that they
        //  could pass entities, but this may create a Text node which will want
        //  literals.
        str = TP.xmlEntitiesToLiterals(theContent);

        //  Try to create a real Node from the supplied content (passing
        //  'true' to TP.nodeAsString() so that it will report parsing
        //  errors). If we can't parse a valid Node from the content, we
        //  just create a Text node using the content and use that.
        if (TP.notValid(nodeContent =
                        TP.nodeFromString(str, null, true))) {
            nodeContent = TP.nodeGetDocument(anElement).createTextNode(str);
        }
    } else {
        TP.raise(this, 'TP.sig.UnsupportedOperation');

        return null;
    }

    //  Before we remove anElement from its parent, we capture its 'gid' for
    //  later use.
    // elemGID = TP.gid(anElement);

    //  Replace anElement in its parent with the new node.

    //  Note the assignment to the returnNode here, since it might have come
    //  from a different document and been imported, etc.
    returnNode = TP.nodeReplaceChild(anElement.parentNode,
                                        nodeContent,
                                        anElement,
                                        awakenContent);

    //  If it's an element, bubble any namespaces we find to reduce clutter on
    //  the DOM tree
    if (TP.isElement(returnNode)) {
        TP.elementBubbleXMLNSAttributesOnDescendants(returnNode);
    }

    //  Execute any loaded function that we were handed.
    if (TP.isCallable(loadedFunction)) {
        loadedFunction(anElement, returnNode);
    }

    //  Final operation is to signal that we've done the work
    try {
        //  We only signal TP.sig.DOMContentLoaded if the system is
        //  configured for it.
        if (TP.sys.shouldSignalDOMLoaded() && TP.isElement(returnNode)) {
            //  NOTE NOTE NOTE
            //  we signal here, but from the PARENT since outer content replaces
            //  the original element
            TP.signal(TP.gid(returnNode.parentNode),
                        'TP.sig.DOMContentLoaded',
                        returnNode);
        }
    } catch (e) {
        TP.ifError() ?
            TP.error(
                TP.ec(
                    e, 'TP.sig.DOMContentLoaded handler generated error.')) : 0;
    }

    //  Return the new element.
    return returnNode;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('xmlElementSetContent',
function(anElement, theContent, loadedFunction, shouldAwake) {

    /**
     * @method xmlElementSetContent
     * @summary Sets the 'content' of anElement, which should be an XML
     *     element.
     * @description This method sets the 'inner content' of anElement to
     *     theContent which means that just the contents of the element, not
     *     including its start and end tags, will be replaced with theContent.
     * @param {XMLElement} anElement The element to set the 'inner content' of.
     * @param {Node|String} theContent The content to replace the 'inner
     *     content' with.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just set. The default for a 'set' operation is whether anElement has
     *     a Window object associated with it or not.
     * @exception TP.sig.InvalidElement
     * @returns {Element|Text} The newly created Node (could be a Text node,
     *     depending on how the replacement happened).
     */

    var awakenContent,

        nodeContent,
        str,

        returnNode;

    if (!TP.isXMLNode(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    awakenContent = shouldAwake;
    if (TP.notValid(awakenContent)) {
        awakenContent = TP.nodeHasWindow(anElement);
    }

    //  If the content is an XML node, then we just make sure its an
    //  Element, and not a Document.
    if (TP.isXMLNode(theContent)) {
        if (TP.isDocument(theContent)) {
            nodeContent = theContent.documentElement;
        } else {
            nodeContent = theContent;
        }
    } else if (TP.isString(theContent)) {

        //  Convert any entities to literals, since the caller assumed that they
        //  could pass entities, but this may create a Text node which will want
        //  literals.
        str = TP.xmlEntitiesToLiterals(theContent);

        //  Try to create a real Node from the supplied content (passing
        //  'true' to TP.nodeAsString() so that it will report parsing
        //  errors). If we can't parse a valid Node from the content, we
        //  just create a Text node using the content and use that.
        if (TP.notValid(nodeContent =
                        TP.nodeFromString(str, null, true))) {
            nodeContent = TP.nodeGetDocument(anElement).createTextNode(str);
        }
    } else {
        TP.raise(this, 'TP.sig.UnsupportedOperation');

        return null;
    }

    //  Clear out the element's existing content.
    TP.nodeEmptyContent(anElement);

    //  Append the new child in (pass in false to awaken the content - we
    //  don't awaken XML).

    //  Note the assignment to the returnNode here, since it might have come
    //  from a different document and been imported, etc.
    returnNode = TP.nodeAppendChild(anElement, nodeContent, awakenContent);

    //  If it's an element, bubble any namespaces we find to reduce clutter on
    //  the DOM tree
    if (TP.isElement(returnNode)) {
        TP.elementBubbleXMLNSAttributesOnDescendants(returnNode);
    }

    //  Execute any loaded function that we were handed.
    if (TP.isCallable(loadedFunction)) {
        loadedFunction(anElement, returnNode);
    }

    //  Final operation is to signal that we've done the work
    try {
        //  We only signal TP.sig.DOMContentLoaded if the system is
        //  configured for it.
        if (TP.sys.shouldSignalDOMLoaded() && TP.isElement(returnNode)) {
            TP.signal(TP.gid(anElement),
                        'TP.sig.DOMContentLoaded',
                        theContent);
        }
    } catch (e) {
        TP.ifError() ?
            TP.error(
                TP.ec(e,
                    'TP.sig.DOMContentLoaded handler generated error.')) : 0;
    }

    //  Return the new element.
    return returnNode;
});

//  ------------------------------------------------------------------------
//  ELEMENT REFLECTION
//  ------------------------------------------------------------------------

/*
Operations which test a Node for structural or 'containment' properties.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('elementIsNested',
function(anElement) {

    /**
     * @method elementIsNested
     * @summary Returns true if the element provided is nested within one or
     *     more parent elements with the same canonical name. This is often used
     *     in tag processing situations to avoid rework on nested elements which
     *     might otherwise occur.
     * @param {Element} anElement A native element to test.
     * @returns {Boolean} True if the element is a nested element.
     */

    var cname,
        ancestor;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    cname = TP.canonical(anElement);
    ancestor = TP.nodeDetectAncestor(
                    anElement,
                    function(anAncestor) {
                        return TP.canonical(anAncestor) === cname;
                    });

    return TP.isElement(ancestor);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeIsResponder',
function(aNode) {

    /**
     * @method nodeIsResponder
     * @summary Tests a node to determine if it's a valid responder element.
     *     Responders have either a tibet:ctrl or tibet:tag attribute (or are
     *     not in the XHTML namespace).
     * @param {Node} aNode The node to check.
     * @returns {Boolean} True for nodes which are elements having the proper
     *     attribute or tag values to describe a responder.
     */

    if (TP.isElement(aNode)) {
        if (TP.elementHasAttribute(aNode, 'tibet:tag') ||
            TP.elementHasAttribute(aNode, 'tibet:ctrl') ||
            !TP.w3.Xmlns.isNativeNS(TP.nodeGetNSURI(aNode))) {
            return true;
        }
    }
    return false;
});

//  ------------------------------------------------------------------------
//  DocumentFragment PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('fragmentFromString',
function(aString, defaultNS, shouldReport) {

    /**
     * @method fragmentFromString
     * @summary Parses aString and returns a document fragment containing the
     *     XML node representing the string's DOM representation. If the string
     *     is empty a fragment containing an empty text node is returned, when
     *     an element is produced that element is returned. CDATA and other node
     *     types are also possible output from this routine.
     * @param {String} aString The source string to be parsed. Note that this
     *     String *must* be XML compliant.
     * @param {String|null} defaultNS What namespace should be used for the
     *     'default namespace' for element markup in the supplied String.
     *     Note that this should be an XML 'namespace URI' (i.e.
     *     'http://www.w3.org/1999/xhtml') *not* a namespace prefix (i.e.
     *     'html:'). To use the 'null' namespace (i.e. xmlns=""), supply
     *     the empty String ('') here. To not specify any default namespace
     *     value and let the parser do what it does natively, supply null here.
     * @param {Boolean} shouldReport False to turn off exception reporting so
     *     strings can be tested for XML compliance without causing exceptions
     *     to be thrown. This is true by default.
     * @example Create a node from an XML String:
     *     <code>
     *          xmlFrag = TP.fragmentFromString(
     *          '<foo></foo><bar></bar>');
     *          <samp>[object DocumentFragment]</samp>
     *     </code>
     * @example Create a node from a malformed XML String (note the flag to show
     *     the parser errors):
     *     <code>
     *          xmlElem = TP.fragmentFromString(
     *          '<foo</foo><bar></bar>', true);
     *          <samp>(Parser error output)</samp>
     *     </code>
     * @returns {DocumentFragment} The DocumentFragment parsed from the supplied
     *     String.
     */

    var aNode,
        fragment;

    //  TP.nodeFromString() will hand back a DocumentFragment if a fragment
    //  (i.e. a 'rootless XML string') was supplied to it. If it does, just
    //  return that.
    aNode = TP.nodeFromString(aString, defaultNS, shouldReport);
    if (TP.isFragment(aNode)) {
        return aNode;
    } else if (TP.isNode(aNode)) {
        //  Otherwise, construct a fragment and append the node returned to
        //  that.
        fragment = TP.documentConstructFragment(TP.nodeGetDocument(aNode));

        //  Note here how we pass 'false' to *not* awaken any content that
        //  gets appended.
        TP.nodeAppendChild(fragment, aNode, false);

        return fragment;
    }

    //  Couldn't get good result from TP.nodeFromString()... must've been a
    //  parsing error.

    return;
});

//  ------------------------------------------------------------------------
//  NodeList PRIMITIVES
//  ------------------------------------------------------------------------

/*
Operations designed to make it easier to work with NodeList instances.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeListAsDocument',
function(aNodeList, aTagname, aNamespace) {

    /**
     * @method nodeListAsDocument
     * @summary Returns a document object whose document element's child
     *     content consists of cloned versions of the nodeList items.
     * @description The root element of the document defaults to a tag name of
     *     'instanceData', consistent with the XForms specification if no tag
     *     name is provided. Note also that, if a namespace is provided, it
     *     applies *only to the document element of the new document that is
     *     created* and not to the cloned versions of the nodes supplied in the
     *     node list.
     * @param {NodeList} aNodeList The node list to convert.
     * @param {String} aTagname The name of the document element. Defaults to
     *     'instanceData'.
     * @param {String} aNamespace The namespace URI for the namespace of the
     *     document element.
     * @example Make an XML document from two nodes in an XML document. Note how
     *     the namespace and prefix only apply to the new document's document
     *     element:
     *     <code>
     *          xmlDoc = TP.doc('<foo><bar/><baz/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          newDoc = TP.nodeListAsDocument(
     *          TP.nodeGetChildElements(
     *          xmlDoc.documentElement),
     *          'boo:goo',
     *          'http://www.boo.com');
     *          TP.nodeAsString(xmlDoc);
     *          <samp>&lt;boo:goo xmlns:boo="http://www.boo.com"&gt;&lt;bar
     *         xmlns=""&gt;&lt;/bar&gt;&lt;baz
     *         xmlns=""&gt;&lt;/baz&gt;&lt;/boo:goo&gt;</samp>
     *     </code>
     * @returns {Document} The supplied NodeList as a Document.
     * @exception TP.sig.InvalidNodeList Raised when an invalid node list is
     *     provided to the method.
     * @exception TP.sig.InvalidDocument Raised when an invalid document is
     *     created by the method. This usually means a malformed tag name was
     *     supplied.
     * @exception TP.sig.InvalidNode Raised when one of the supplied nodes is
     *     not an XML node.
     */

    var tagName,
        doc,

        i;

    if (!TP.isNodeList(aNodeList)) {
        return TP.raise(this, 'TP.sig.InvalidNodeList');
    }

    tagName = TP.ifEmpty(aTagname, 'instanceData');

    //  create the document
    if (TP.notValid(doc = TP.constructDocument(aNamespace, tagName))) {
        return;
    }

    //  they must have specified an invalid element name, which isn't good
    if (TP.notValid(doc.documentElement)) {
        return TP.raise(this, 'TP.sig.InvalidDocument',
                                        'No documentElement found.');
    }

    for (i = 0; i < aNodeList.length; i++) {
        //  Make sure that the current node is an XML node
        if (!TP.isXMLNode(aNodeList[i])) {
            return TP.raise(this, 'TP.sig.InvalidNode',
                                        'All nodes must be XML nodes.');
        }

        //  Note here how we pass 'false' to *not* awaken any content that
        //  gets appended.
        TP.nodeAppendChild(
                doc.documentElement,
                TP.nodeCloneNode(aNodeList[i], true),
                false);
    }

    return doc;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeListAsFragment',
function(aNodeList, aDocument, shouldClone) {

    /**
     * @method nodeListAsFragment
     * @summary Returns a document fragment whose child content consists of the
     *     nodeList items.
     * @description The fragment is constructed relative to the document
     *     provided. If shouldClone is true then the content of the node list
     *     (or array) is cloned during the operation.
     * @param {NodeList} aNodeList The node list to convert.
     * @param {Document} aDocument The document that will "own" the fragment. If
     *     this isn't supplied, but the node list has at least one Node, either
     *     the UI canvas's document or the standard XML_FACTORY_DOCUMENT will be
     *     used.
     * @param {Boolean} shouldClone True to force the elements to be cloned.
     *     Default is false.
     * @example Make a document fragment using a list of HTML nodes. Note here
     *     how we force the call to clone the nodes, since we don't want to
     *     modify the original document. The document that the fragment will be
     *     created in will be the currently set 'UI canvas':
     *     <code>
     *          allSpans = TP.nodeGetElementsByTagName(document,
     *          'span');
     *          <samp>[object HTMLSpanElement], [object
     *         HTMLSpanElement]...</samp>
     *          allSpansFragment = TP.nodeListAsFragment(allSpans, null,
     *          true);
     *          <samp>[object DocumentFragment]</samp>
     *          TP.nodeAsString(allSpansFragment);
     *          <samp>(html markup showing that the content of the new fragment
     *         are all 'span' elements)</samp>
     *     </code>
     * @example Make a document fragment using a list of XML nodes. Note here
     *     that we're *not* going to clone the nodes, which will cause them to
     *     be removed from the original document, but since we're supplying that
     *     document to the call, the fragment will be created in the context of
     *     that document:
     *     <code>
     *          xmlDoc = TP.doc('<foo><bar/><baz/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          newFrag = TP.nodeListAsFragment(
     *          TP.nodeGetChildElements(
     *          xmlDoc.documentElement),
     *          xmlDoc);
     *          <samp>[object DocumentFragment]</samp>
     *          TP.nodeAsString(newFrag);
     *          <samp>&lt;bar&gt;&lt;/bar&gt;<baz&gt;&lt;/baz&gt;</samp>
     *     </code>
     * @returns {DocumentFragment} The list as a DocumentFragment.
     * @exception TP.sig.InvalidNodeList Raised when an invalid node list is
     *     provided to the method.
     * @exception TP.sig.InvalidDocument Raised when an invalid document is
     *     provided to the method or when a document cannot be created if
     *     needed.
     */

    var doc,
        fragment,
        i,
        len,
        node,
        list,
        firstNode;

    if (!TP.isNodeList(aNodeList)) {
        return TP.raise(this, 'TP.sig.InvalidNodeList');
    }

    //  if there's nothing in the node list, the caller better have provided
    //  a document in the appropriate parameter.
    if (aNodeList.length < 1) {
        doc = TP.ifInvalid(aDocument, TP.XML_FACTORY_DOCUMENT);

        return TP.documentConstructFragment(doc);
    }

    //  default to the document provided, or the document of the first node
    firstNode = aNodeList.item(0);
    doc = aDocument;
    if (TP.notValid(doc)) {
        doc = TP.nodeGetDocument(firstNode);
    }

    //  create the fragment
    if (TP.notValid(fragment = TP.documentConstructFragment(doc))) {
        return;
    }

    //  put elements in true array, eliminating issues with indexing when we
    //  don't clone and the elements leave a true nodelist
    list = TP.ac(aNodeList);
    len = list.getSize();
    for (i = 0; i < len; i++) {
        node = list.at(i);

        //  Note here how we pass 'false' to *not* awaken any content that
        //  gets appended.
        TP.nodeAppendChild(fragment,
                            shouldClone ? TP.copy(node) : node,
                            false);
    }

    return fragment;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeListFilterNonRoots',
function(aNodeList, aTestFunction) {

    /**
     * @method nodeListFilterNonRoots
     * @summary Filters any 'non-roots' out of the supplied NodeList.
     * @description This method filters out any Nodes from the supplied node
     *     list that are descendants of other nodes in the same list, thereby
     *     returning an Array of only 'root' nodes.
     * @param {NodeList|Node[]} aNodeList The node list to filter.
     * @param {Function} [aTestFunction] The function to use to test. This is
     *     optional and, if not supplied, a 'node contains' test is used. The
     *     function takes two parameters: the root node and the node to test
     *     and should return *true* if the node to test should be excluded from
     *     the roots list. The default test function will exclude the node to
     *     test if it is contained within the root node.
     * @returns {Node[]} The supplied NodeList filtered for non-root nodes.
     */

    var allNodes,

        testFunc,

        rootNodes,
        isDescendant,
        testNode,
        j,

        ndx;

    if (!TP.isArray(aNodeList)) {
        allNodes = TP.ac(aNodeList);
    } else {
        allNodes = TP.copy(aNodeList);
    }

    if (TP.isCallable(aTestFunction)) {
        testFunc = aTestFunction;
    } else {
        testFunc = function(aRootNode, aTestNode) {
                        return aRootNode.contains(aTestNode);
                    };
    }
    rootNodes = TP.ac();

    //  Iterate over all of the nodes.
    while (TP.notEmpty(allNodes)) {

        isDescendant = false;

        //  Shift off the head of the list.
        testNode = allNodes.shift();

        //  Iterate over all of the already plucked 'root' nodes and run the
        //  test function on them. If the test fails, then it's a descendant.
        for (j = 0; j < rootNodes.getSize(); j++) {
            if (testFunc(rootNodes.at(j), testNode)) {
                isDescendant = true;
                break;
            }
        }

        //  If it wasn't a descendant of one of the already plucked 'roots',
        //  then check the rest of the nodes left in the 'all' list.
        if (!isDescendant) {
            for (j = 0; j < allNodes.getSize(); j++) {
                if (allNodes.at(j).contains(testNode)) {
                    isDescendant = true;
                    break;
                }
            }
        }

        //  If it wasn't a descendant, then add it to the root list.
        if (!isDescendant) {
            rootNodes.push(testNode);
        } else {
            //  Otherwise, if it was a descendant and was found in the set of
            //  root nodes, then splice it out. If it wasn't a descendant for
            //  another node, but was for us, it doesn't belong in the list of
            //  root nodes.
            ndx = rootNodes.indexOf(testNode);
            if (ndx !== TP.NOT_FOUND) {
                rootNodes.splice(ndx, 1);
            }
        }
    }

    return rootNodes;
});

//  ------------------------------------------------------------------------
//  NODE PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('nodeAddContent',
function(aNode, anObject, loadedFunction, shouldAwake) {

    /**
     * @method nodeAddContent
     * @summary Adds content from anObject onto the end of the child content of
     *     anObject.
     * @param {Node} aNode The node to add content for.
     * @param {Object} anObject The object to use as the source of the content.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just added. The default for an 'add' operation is false.
     * @returns {Node} The first node of the content that was just added.
     */

    //  Simply a cover for inserting child content before the end of the
    //  element.
    return TP.nodeInsertContent(aNode,
                                anObject,
                                TP.BEFORE_END,
                                loadedFunction,
                                shouldAwake);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeAppendChild',
function(aNode, newNode, shouldAwake) {

    /**
     * @method nodeAppendChild
     * @summary Appends the new node to the supplied node and then 'awakens'
     *     (initializes) the newly added content.
     * @param {Node} aNode The node to append the child node to.
     * @param {Node|String} newNode The node to append to aNode, or a valid
     *     string of markup representing a single root node (with optional
     *     children) to append.
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just appended. The default for this operation is false.
     * @exception TP.sig.InvalidNode
     * @returns {Node} The new node. This may be a different node than what was
     *     supplied to this routine, as the node might have been imported.
     */

    var childContent,
        firstElement,
        targetNode,

        iframeDocElems,

        importedContent,

        awakenContent,
        childNodeCount;

    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode', aNode);
    }

    if (TP.isString(newNode)) {
        //  this will throw/raise so we don't have to
        childContent = TP.nodeFromString(newNode);
        if (!TP.isNode(newNode)) {
            return;
        }
    } else if (!TP.isNode(newNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode', newNode);
    } else {
        childContent = newNode;
    }

    //  if the target is a document and not the documentElement we can't
    //  accept new content unless the document has no current document
    //  element.
    if (TP.isDocument(aNode)) {
        if (TP.isElement(aNode.documentElement)) {
            TP.raise(this, 'TP.sig.InvalidOperation',
                        'Cannot append to #document node with an' +
                        ' existing root.');

            return;
        } else if (TP.isFragment(childContent)) {
            //  not valid, but we may have more than one inbound element so
            //  we have to check and potentially discard extras
            firstElement = TP.nodeGetFirstChildElement(childContent);
            if (TP.notValid(firstElement)) {
                TP.raise(this, 'TP.sig.InvalidOperation',
                            'Must supply element for #document root.');

                return;
            } else if (childContent.childNodes.length > 1) {
                TP.ifWarn() && TP.sys.cfg('log.node_discarded') ?
                    TP.warn('Discarding nodes from fragment: ' +
                                TP.str(childContent)) : 0;
            }

            childContent = firstElement;
        }
    }

    targetNode = aNode;

    //  For some browsers, we need to capture the iframe content before we
    //  move the node. This includes any iframes that are descendants of the
    //  node we're moving.
    if (TP.isElement(newNode)) {
        iframeDocElems = TP.$$elementPreserveIFrameContent(newNode);
    }

    //  The logic in this method is predicated on the fact that childContent
    //  might very well be a Node.DOCUMENT_FRAGMENT_NODE and, therefore,
    //  will be inserting *multiple* children into the common parent.

    //  make sure the node we'll insert is a part of the target node's
    //  document. as of ff3 and s3 this is required to avoid exceptions
    importedContent = TP.nodeImportNode(targetNode, childContent);

    awakenContent = TP.ifInvalid(shouldAwake, false);

    //  Grab the current number of children
    childNodeCount = targetNode.childNodes.length;

    try {
        //  Append the new content. This will (or should) change the number
        //  of children. NOTE, this will empty importedContent if it's a
        //  fragment.
        targetNode.appendChild(importedContent);
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'appendChild generated error.')) : 0;

        return;
    }

    //  if newNode was a fragment, then it should now be empty to maintain
    //  semantic consistency with a standard appendChild call. If newNode
    //  was a string we don't bother to empty it.
    if (TP.isFragment(newNode)) {
        TP.nodeEmptyContent(newNode);
    }

    //  If we preserved the iframe content (see above), then we need to
    //  restore it.
    if (TP.isElement(targetNode) && TP.notEmpty(iframeDocElems)) {
        TP.$$elementRestoreIFrameContent(targetNode, iframeDocElems);
    }

    if (awakenContent) {
        TP.nodeAwakenChildNodesFromTo(targetNode,
                                        childNodeCount,
                                        TP.LAST);
    }

    //  If the new content was a fragment, then we need to return the final
    //  content's child node that starts at that point.
    if (TP.isFragment(importedContent)) {
        return targetNode.childNodes[childNodeCount];
    }

    return importedContent;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeContainsNode',
function(aNode, aDescendant) {

    /**
     * @method nodeContainsNode
     * @summary Returns whether or not aNode is an ancestor (or the
     *     document for) aDescendant. If aNode is a Document node, this
     *     method will return true if aDescendant's document is aNode.
     * @param {Node} aNode The node to check to see if aDescendant is
     *     contained within it.
     * @param {Node} aDescendant The node to check to see if it is contained
     *     within aNode.
     * @example Test to see if the document element in an XML document is
     *     the parent of its firstChild:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo><bar/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeContainsNode(xmlDoc.documentElement,
     *          xmlDoc.documentElement.firstChild);
     *          <samp>true</samp>
     *          // But the inverse isn't true:
     *          TP.nodeContainsNode(xmlDoc.documentElement.firstChild,
     *          xmlDoc.documentElement);
     *          <samp>false</samp>
     *     </code>
     * @example Test to see if the document element in an HTML document is
     *     the parent of the body element:
     *     <code>
     *          TP.nodeContainsNode(document.documentElement,
     *          TP.documentGetBody(document));
     *          <samp>true</samp>
     *          // But the inverse isn't true:
     *          TP.nodeContainsNode(TP.documentGetBody(document),
     *          document.documentElement);
     *          <samp>false</samp>
     *     </code>
     * @returns {Boolean} Whether or not aNode is a parent of aDescendant.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method or an invalid child
     *     is provided.
     */

    var root;

    //  No child nodes for anything that isn't an element, document or document
    //  fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (!TP.isNode(aDescendant)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    //  For documents the question is whether the child is an element and is in
    //  the document and still attached to a viable branch of the
    //  documentElement tree
    if (TP.isDocument(aNode) && TP.isElement(aDescendant)) {
        if (TP.nodeGetDocument(aDescendant) !== aNode ||
            TP.notValid(aNode.documentElement)) {
            return false;
        }

        root = aNode.documentElement;
        if (root === aDescendant) {
            return true;
        }
    }

    root = TP.ifInvalid(root, aNode);

    //  Otherwise, we can use the built-in 'compareDocumentPosition' method
    //  here. Thanks to Peter-Paul Koch.
    return Boolean(root.compareDocumentPosition(aDescendant) & 16);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeDetach',
function(aNode) {

    /**
     * @method nodeDetach
     * @summary Removes the node from its parent. This is simple sugar for
     *     TP.nodeRemoveChild().
     * @param {Node} aNode The node to detach.
     * @exception TP.sig.InvalidNode
     * @returns {Node} The detached node.
     */

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    //  Need to do whatever TP.nodeRemoveChild() does.
    return TP.nodeRemoveChild(aNode.parentNode, aNode);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeEqualsNode',
function(aNode, otherNode) {

    /**
     * @method nodeEqualsNode
     * @summary Compares two nodes for 'equality'.
     * @description This method follows the DOM Level 3 standard for checking
     *     Nodes for equality with each other. This specification states that
     *     two Nodes are equal if:
     *          -   The two nodes are of the same type
     *          -   The following string attributes are equal (they are either
     *              both null or they have the same length and are character for
     *              character identical):
     *                  -   nodeName
     *                  -   localName
     *                  -   namespaceURI
     *                  -   prefix
     *                  -   nodeValue
     *          -   The 'attributes' NamedNodeMaps are equal (they are either
     *              both null or have the same length and for each node that
     *              exists in one map there is a node that exists in the other
     *              map and is equal although *not necessarily at the same
     *              index*).
     *          -   The 'childNodes' NodeLists are equal (they are either both
     *              null or have the same length and contain equal nodes *at the
     *              same index*). Note that this method normalizes these nodes
     *              to make sure that this comparison is performed accurately.
     * @param {Node} aNode The node to check against otherNode.
     * @param {Node} otherNode The node to check against aNode.
     * @returns {Boolean} Whether or not the two nodes are *equal* (not
     *     necessarily identical).
     * @exception TP.sig.InvalidNode Raised when either node is an invalid node.
     */

    if (!TP.isNode(aNode) || !TP.isNode(otherNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    //  In browsers that implement the W3C's DOM Level 3 'isEqualNode' call,
    //  we can just leverage that.

    return aNode.isEqualNode(otherNode);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetAncestorPositions',
function(aNode, includeNode, aPrefix, joinChar) {

    /**
     * @method nodeGetAncestorPositions
     * @summary Returns an array of position strings for the provided node's
     *     ancestors. If the includeNode flag is true then the list starts with
     *     aNode's position, otherwise the first entry represents aNode's
     *     parentNode position.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Boolean} includeNode True to include the node's position in the
     *     list. Default is false.
     * @param {String} aPrefix An optional prefix, usually a document location
     *     which allows the positions to be canvas and document specific for
     *     observations.
     * @param {String} joinChar A character to use when joining the index parts.
     *     Default is '.'.
     * @returns {String[]} An array of position strings.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     */

    var node,
        path,
        index,
        arr,
        prefix;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    prefix = TP.ifInvalid(aPrefix, '');

    path = TP.ac();

    if (TP.isAttributeNode(aNode)) {
        node = TP.attributeGetOwnerElement(aNode);
        index = TP.nodeGetIndexInParent(node);
        path.push(index + '@' + TP.attributeGetLocalName(aNode));
        node = node.parentNode;
    } else if (TP.isElement(aNode)) {
        node = aNode;
    } else {
        node = aNode.parentNode;
    }

    while (TP.isElement(node) &&
            (index = TP.nodeGetIndexInParent(node)) !== TP.NOT_FOUND) {
        path.push(index);
        node = node.parentNode;
    }

    if (index === TP.NOT_FOUND) {
        return TP.NOT_FOUND;
    }

    path.reverse();

    //  shift off the element's index if we're not going to include it. this
    //  way the loop below will start joining with parent index
    if (TP.notTrue(includeNode)) {
        path.length = path.length - 1;
    }

    arr = TP.ac();
    while (path.length > 0) {
        arr.push(prefix + path.join(joinChar || '.'));
        path.length = path.length - 1;
    }

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetDocumentPosition',
function(aNode, joinChar, stopAncestor, onlyElements) {

    /**
     * @method nodeGetDocumentPosition
     * @summary Returns a 0-indexed position generated for the node within the
     *     document. This position is unique within the node's document and can
     *     be used for positioning comparison purposes with other nodes.
     * @param {Node} aNode The Node to operate on.
     * @param {String} joinChar A character to use when joining the index parts.
     *     Default is '.'.
     * @param {Element} [stopAncestor] An element between aNode and aNode's
     *     document node that the position computation will 'stop' at. This
     *     parameter is optional. Note that this ancestor will *not* be included
     *     in the position computation.
     * @param {Boolean} [onlyElements=false] Whether or not to consider only
     *     Element nodes when computing the index.
     * @example Compute a document-level index for an XML node:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo><bar>Some text<goo>More
     *         text</goo></bar>Yet more text</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          // Compute the index for the 'goo' node
     *          TP.nodeGetDocumentPosition(
     *          TP.nodeGetElementsByTagName(xmlDoc, 'goo').first());
     *          <samp>0.0.1.0</samp>
     *     </code>
     * @example Compute a document-level index for an HTML node:
     *     <code>
     *          TP.nodeGetDocumentPosition(TP.documentGetBody(document));
     *          <samp>0.1.0</samp>
     *     </code>
     * @returns {String} The index or TP.NOT_FOUND.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     */

    var path,

        usingParent,

        node,
        index;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    path = TP.ac();

    usingParent = false;

    if (TP.isAttributeNode(aNode)) {
        node = TP.attributeGetOwnerElement(aNode);
        index = TP.nodeGetIndexInParent(node, onlyElements);
        path.push(index + '@' + TP.attributeGetLocalName(aNode));
        node = node.parentNode;
    } else if (TP.isElement(aNode)) {
        node = aNode;
    } else {
        //  A node, but not an Attribute, not an Element. Since we use a
        //  TP.isElement check below, we need to make sure to track that we're
        //  using the parent.
        node = aNode.parentNode;
        usingParent = true;
    }

    if (TP.isNode(stopAncestor) && node === stopAncestor) {
        return '';
    }

    //  Note the TP.isElement check - we don't want the Document node in here.
    while (TP.isElement(node) &&
            node !== stopAncestor &&
            (index = TP.nodeGetIndexInParent(node, onlyElements)) !==
                                                        TP.NOT_FOUND) {
        path.push(index);
        node = node.parentNode;
    }

    if (index === TP.NOT_FOUND) {
        return TP.NOT_FOUND;
    }

    //  If we were iterating on the parent (because the node was a
    //  non-Attribute, non-Element kind of node), then we need to unshift the
    //  node's index to its parent to get a complete path.
    if (usingParent) {
        index = TP.nodeGetIndexInParent(aNode, onlyElements);
        if (index !== TP.NOT_FOUND) {
            path.unshift(index);
        }
    }

    return path.reverse().join(joinChar || '.');
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetResponderChain',
function(aNode, aSignal) {

    /**
     * @method nodeGetResponderChain
     * @summary Creates a list of all the responder elements along the
     *     containment hierarchy for aNode. This method essentially iterates via
     *     nodeGetResponderElement until no more responder elements are found.
     * @param {Node} aNode The DOM node to operate on.
     * @param {TP.sig.Signal} aSignal The signal instance being dispatched.
     * @returns {Element[]} The list of responder elements found. The order of
     *     the list is from first (closest to the element) to last (furthest
     *     from element), essentially the order for event bubbling phase
     *     processing.
     */

    var arr,
        node;

    arr = TP.ac();

    node = TP.nodeGetResponderElement(aNode, aSignal);
    while (TP.isValid(node)) {
        arr.push(node);
        if (TP.notValid(node.parentNode)) {
            break;
        }
        node = TP.nodeGetResponderElement(node.parentNode, aSignal);
    }

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetResponderElement',
function(aNode, aSignal) {

    /**
     * @method nodeGetResponderElement
     * @summary Finds the 'responder' element for aNode and returns it. A
     *     responder element is an element with either tibet:ctrl or tibet:tag
     *     or one whose type responds affirmatively to isResponderFor.
     *     NOTE that this method will also traverse up through iframe containers
     *     to locate a potential component element.
     * @param {Node} aNode The DOM node to operate on.
     * @param {TP.sig.Signal} aSignal The signal instance being dispatched.
     * @returns {Element} A valid element or null.
     */

    var node,
        win,

        attrVal,

        type,
        frame;

    if (TP.notValid(aNode)) {
        return this.raise('InvalidNode');
    }

    if (!TP.isElement(aNode)) {

        node = aNode.parentNode;
        if (TP.isValid(node)) {
            return TP.nodeGetResponderElement(node);
        }

        //  Check for a containing iframe element often used as a "screen".
        win = TP.nodeGetWindow(aNode);
        if (TP.isIFrameWindow(win)) {
            frame = win.frameElement;
            if (TP.isElement(frame)) {
                return TP.nodeGetResponderElement(frame);
            }
        }

        return;
    }

    //  Check first for a 'tibet:ctrl' attribute. This overrides all of the
    //  other logic. If we have a 'tibet:ctrl' attribute, then this element is
    //  definitely a responder element (for *some* signal). Whether or not the
    //  object that is named here via this attribute (either a type of some sort
    //  or a registered object) can actually respond to the signal is determined
    //  later by the signaling system.
    if (TP.elementHasAttribute(aNode, 'tibet:ctrl', true)) {
        return aNode;
    }

    //  Next, check to see if a 'tibet:tag' attribute is defined. If so, then it
    //  will point to a TIBET type of some sort. This mechanism allows the
    //  author to override the TIBET type that this tag would normally resolve
    //  to. Therefore, in the case of custom tags that have been processed into
    //  platform native markup (i.e. XHTML or SVG), this attribute will probably
    //  point to the custom TIBET type that the platform-native markup is
    //  standing in for.
    attrVal = TP.elementGetAttribute(aNode, 'tibet:tag', true);
    if (TP.notEmpty(attrVal)) {
        type = TP.sys.getTypeByName(attrVal);
    }

    if (!TP.isType(type)) {

        //  Native types may be responders but not have a tibet:tag or
        //  tibet:ctrl attribute so we need to query them by type.

        //  NB: Many times the node will already have it's node type, so we
        //  use a fast way to get that here.
        type = aNode[TP.NODE_TYPE];
        if (TP.notValid(type)) {
            type = TP.nodeGetConcreteType(aNode);
            aNode[TP.NODE_TYPE] = type;
        }
    }

    if (TP.canInvoke(type, 'isResponderFor')) {
        if (type.isResponderFor(aNode, aSignal)) {
            return aNode;
        }
    }

    if (TP.isValid(aNode.parentNode)) {
        return TP.nodeGetResponderElement(aNode.parentNode, aSignal);
    }

    //  Check for a containing iframe element often used as a "screen".
    win = TP.nodeGetWindow(aNode);
    if (TP.isIFrameWindow(win)) {
        frame = win.frameElement;
        if (TP.isElement(frame)) {
            return TP.nodeGetResponderElement(frame);
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetIndexInParent',
function(aNode, onlyElements) {

    /**
     * @method nodeGetIndexInParent
     * @summary Returns the index of the node provided in its parentNode's
     *     childNodes array. If there is no parentNode for the node provided
     *     this method or aNode couldn't be found in the parent, this method
     *     returns TP.NOT_FOUND.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Boolean} [onlyElements=false] Whether or not to consider only
     *     Element nodes when computing the index.
     * @example Get an XML node's index in its parent:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><baz/>Hi<bar/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          barElem = TP.nodeGetElementsByTagName(xmlDoc, 'bar').first();
     *          <samp>[object XMLElement]</samp>
     *          TP.nodeGetIndexInParent(barElem);
     *          <samp>2</samp>
     *          TP.nodeGetIndexInParent(barElem, true);
     *          <samp>1</samp>
     *     </code>
     * @example Get an HTML node's index in its parent:
     *     <code>
     *          TP.nodeGetIndexInParent(document.documentElement);
     *          <samp>0</samp>
     *     </code>
     * @returns {Number} The index number, or TP.NOT_FOUND.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     */

    var nodeParent,
        children,
        len,
        i;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (TP.notValid(nodeParent = aNode.parentNode)) {
        return TP.NOT_FOUND;
    }

    //  If we're excluding non-Elements, then just get the child elements,
    //  otherwise get all child nodes.
    if (TP.isTrue(onlyElements)) {
        children = TP.nodeGetChildElements(nodeParent);
    } else {
        children = TP.nodeGetChildNodes(nodeParent);
    }

    len = children.length;

    for (i = 0; i < len; i++) {
        if (children[i] === aNode) {
            return i;
        }
    }

    return TP.NOT_FOUND;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeInsertBefore',
function(aNode, newNode, insertionPointNode, shouldAwake) {

    /**
     * @method nodeInsertBefore
     * @summary Inserts the new node into the child content of the supplied
     *     node before the supplied insertion point node and then 'awakens'
     *     (initializes) the newly added content. If insertionPointNode is null,
     *     then the new node is just appended to the child content of the
     *     supplied Node.
     * @param {Node} aNode The node to insert the child content into.
     * @param {Node} newNode The node to insert into aNode.
     * @param {Node} insertionPointNode The node to use as an insertion point.
     *     The new content will be inserted before this point.
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just inserted. The default for this operation is false.
     * @exception TP.sig.InvalidNode
     * @returns {Node} The new node. This may be a different node than what was
     *     supplied to this routine, as the node might have been imported.
     */

    var childContent,

        firstElement,

        targetNode,

        iframeDocElems,

        importedContent,

        awakenContent,
        start,
        end;

    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode', aNode);
    }

    if (TP.isString(newNode)) {
        //  this will throw/raise so we don't have to
        childContent = TP.nodeFromString(newNode);
        if (!TP.isNode(newNode)) {
            return;
        }
    } else if (!TP.isNode(newNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode', newNode);
    } else {
        childContent = newNode;
    }

    //  if the target is a document and not the documentElement we can't
    //  accept new content unless the document has no current document
    //  element.
    if (TP.isDocument(aNode)) {
        if (TP.isElement(aNode.documentElement)) {
            TP.raise(
            this,
            'TP.sig.InvalidOperation',
            'Cannot insertBefore #document node with an existing root.');

            return;
        } else if (TP.isNode(insertionPointNode)) {
            TP.raise(
            this,
            'TP.sig.InvalidOperation',
            'Cannot insertBefore empty #document using insertion point.');

            return;
        } else if (TP.isFragment(childContent)) {
            //  not valid, but we may have more than one inbound element so
            //  we have to check and potentially discard extras
            firstElement = TP.nodeGetFirstChildElement(childContent);
            if (TP.notValid(firstElement)) {
                TP.raise(this,
                        'TP.sig.InvalidOperation',
                        'Must supply element for #document root.');

                return;
            } else if (childContent.childNodes.length > 1) {
                TP.ifWarn() && TP.sys.cfg('log.node_discarded') ?
                    TP.warn('Discarding nodes from fragment: ' +
                                TP.str(childContent)) : 0;
            }

            return TP.nodeAppendChild(aNode, firstElement, shouldAwake);
        }
    }

    targetNode = aNode;

    //  Note that we don't check insertionPointNode here, since this method
    //  (like the native insertBefore() call) allows it to be null, in which
    //  case the new node is just appended.

    if (!targetNode.hasChildNodes() || TP.notValid(insertionPointNode)) {
        return TP.nodeAppendChild(targetNode, childContent, shouldAwake);
    }

    //  For some browsers, we need to capture the iframe content before we
    //  move the node. This includes any iframes that are descendants of the
    //  node we're moving.
    if (TP.isElement(newNode)) {
        iframeDocElems = TP.$$elementPreserveIFrameContent(newNode);
    }

    //  The logic in this method is predicated on the fact that childContent
    //  might very well be a Node.DOCUMENT_FRAGMENT_NODE and, therefore,
    //  will be inserting *multiple* children into the common parent.

    //  make sure the node we'll insert is a part of the target node's
    //  document. as of ff3 and s3 this is required to avoid exceptions
    importedContent = TP.nodeImportNode(targetNode, childContent);

    awakenContent = TP.ifInvalid(shouldAwake, false);

    if (awakenContent || TP.isFragment(importedContent)) {
        start = TP.nodeGetChildIndex(targetNode, insertionPointNode);
    }

    try {
        //  Insert the new content. This will (or should) change the number
        //  of children.
        targetNode.insertBefore(importedContent, insertionPointNode);
    } catch (e) {
        TP.ifError() ? TP.error(TP.ec(e, 'insertBefore generated error.')) : 0;

        return;
    }

    //  if newNode was a fragment, then it should now be empty to maintain
    //  semantic consistency with a standard appendChild call. If newNode
    //  was a string we don't bother to empty it.
    if (TP.isFragment(newNode)) {
        TP.nodeEmptyContent(newNode);
    }

    //  If we preserved the iframe content (see above), then we need to
    //  restore it.
    if (TP.isElement(targetNode) && TP.notEmpty(iframeDocElems)) {
        TP.$$elementRestoreIFrameContent(targetNode, iframeDocElems);
    }

    if (awakenContent) {
        //  Subtract one off of the end to avoid awakening the insertion
        //  point node itself.
        end = TP.nodeGetChildIndex(targetNode, insertionPointNode) - 1;

        TP.nodeAwakenChildNodesFromTo(targetNode, start, end);
    }

    //  If the new content was a fragment, then we need to return the final
    //  content's child node that starts at that point.
    if (TP.isFragment(importedContent)) {
        return targetNode.childNodes[start];
    }

    return importedContent;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeInsertContent',
function(aNode, anObject, aPositionOrPath, loadedFunction, shouldAwake) {

    /**
     * @method nodeInsertContent
     * @summary Inserts content from anObject into/around aNode based on the
     *     position or path given. The position or path should indicate whether
     *     the content should become the previous sibling, next sibling, first
     *     child or last child of aNode.
     * @description Element nodes can accept content and position it in a
     *     variety of ways subject to certain restrictions (such as you can't
     *     create a previous or next sibling to an element that is a
     *     documentElement). Other node types are even more restrictive and
     *     typically think in terms of simply setting their single "child" or
     *     value to the content provided. This routine will actually either
     *     prepend or append content in these cases based on whether a BEGIN or
     *     END position was provided (if a path was provided, content will
     *     always be inserted before the node the path resolved to). Note that
     *     for non-element nodes the TP.BEFORE_BEGIN and TP.AFTER_END are
     *     treated as if they were TP.AFTER_BEGIN and TP.BEFORE_END respectively
     *     and path values will not work. In other words since there's no
     *     element boundary which makes sense in those cases it's the content
     *     data which is either prepended or appended to.
     * @param {Node} aNode The node to insert content for.
     * @param {Object} anObject The object to use as the source of the content.
     * @param {String} aPositionOrPath The position to place the content
     *     relative to anElement or a path to evaluate to get to a node at that
     *     position. This should be one of four values: TP.BEFORE_BEGIN,
     *     TP.AFTER_BEGIN, TP.BEFORE_END, TP.AFTER_END or the path to evaluate.
     *     Default is TP.BEFORE_END.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just inserted. The default for this operation is false.
     * @exception TP.sig.InvalidNode
     * @returns {Node} The first node of the content that was just inserted.
     */

    var positionOrPath,
        content,

        newNode;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                                'Must provide a valid target Node.');
    }

    positionOrPath = TP.ifEmpty(aPositionOrPath, TP.BEFORE_END);

    //  this allows us to accept things like TP.uri.URI, TP.dom.Node, etc.
    //  and to process them as the content routines would expect.
    content = TP.canInvoke(anObject, 'getResource') ?
                anObject.getResource(
                    TP.hc('resultType', TP.DOM)).get('result') :
                anObject;
    content = TP.unwrap(content);

    switch (aNode.nodeType) {
        case Node.ELEMENT_NODE:

            if (TP.isHTMLNode(aNode)) {
                return TP.htmlElementInsertContent(aNode,
                                                    content,
                                                    positionOrPath,
                                                    loadedFunction,
                                                    shouldAwake);
            } else {
                return TP.xmlElementInsertContent(aNode,
                                                    content,
                                                    positionOrPath,
                                                    loadedFunction,
                                                    shouldAwake);
            }

        case Node.TEXT_NODE:
        case Node.CDATA_SECTION_NODE:
        case Node.PROCESSING_INSTRUCTION_NODE:
        case Node.COMMENT_NODE:

            switch (positionOrPath) {
                case TP.BEFORE_BEGIN:

                    if (TP.notValid(newNode = TP.node(content))) {
                        this.raise('TP.sig.InvalidContent');
                        return;
                    }

                    //  NB: We don't worry about awaken here because newNode
                    //  isn't an Element
                    TP.nodeInsertBefore(aNode.parentNode,
                                        newNode,
                                        aNode,
                                        false);

                    break;

                case TP.AFTER_BEGIN:

                    aNode.data = TP.str(content) + (aNode.data || '');

                    break;

                case TP.BEFORE_END:

                    aNode.data = (aNode.data || '') + TP.str(content);

                    break;

                case TP.AFTER_END:

                    if (TP.notValid(newNode = TP.node(content))) {
                        this.raise('TP.sig.InvalidContent');

                        return;
                    }

                    //  NB: We don't worry about awaken here because newNode
                    //  isn't an Element
                    if (TP.notValid(aNode.nextSibling)) {
                        //  last child? parent append should work then
                        TP.nodeAppendChild(aNode.parentNode,
                                            newNode,
                                            false);
                    } else {
                        //  not last? insertBefore next sibling then
                        TP.nodeInsertBefore(aNode.parentNode,
                                            newNode,
                                            aNode.nextSibling,
                                            false);
                    }
                    break;

                default:
                    TP.raise(this, 'TP.sig.InvalidPosition');
                    break;
            }

            break;

        case Node.DOCUMENT_NODE:

            if (TP.isHTMLNode(aNode)) {
                return TP.htmlDocumentInsertContent(aNode,
                                                    content,
                                                    positionOrPath,
                                                    loadedFunction,
                                                    shouldAwake);
            } else {
                return TP.xmlDocumentInsertContent(aNode,
                                                    content,
                                                    positionOrPath,
                                                    loadedFunction);
            }

        case Node.ATTRIBUTE_NODE:

            switch (positionOrPath) {
                case TP.BEFORE_BEGIN:

                    TP.raise(this, 'TP.sig.InvalidPosition');
                    break;

                case TP.AFTER_BEGIN:

                    aNode.value = TP.str(content) + (aNode.value || '');

                    break;

                case TP.BEFORE_END:

                    aNode.value = (aNode.value || '') + TP.str(content);

                    break;

                case TP.AFTER_END:

                    TP.raise(this, 'TP.sig.InvalidPosition');
                    break;

                default:
                    TP.raise(this, 'TP.sig.InvalidPosition');
                    break;
            }

            break;

        case Node.DOCUMENT_FRAGMENT_NODE:

            //  We can do the same insertion logic here that we use for
            //  Node.ELEMENT_NODE

            if (TP.isHTMLNode(aNode)) {
                return TP.htmlElementInsertContent(aNode,
                                                    content,
                                                    positionOrPath,
                                                    loadedFunction,
                                                    shouldAwake);
            } else {
                return TP.xmlElementInsertContent(aNode,
                                                    content,
                                                    positionOrPath,
                                                    loadedFunction,
                                                    shouldAwake);
            }

        case Node.ENTITY_REFERENCE_NODE:
        case Node.ENTITY_NODE:
        case Node.DOCUMENT_TYPE_NODE:
        case Node.NOTATION_NODE:

            TP.raise(this, 'TP.sig.UnsupportedOperation');
            break;

        default:
            break;
    }

    return aNode;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeIsDetached',
function(aNode, aRootNode) {

    /**
     * @method nodeIsDetached
     * @summary Returns true if the node's parent chain does not terminate at
     *     the root node provided, or at a Document node when no specific root
     *     is given. The root node can be either an element node or a document
     *     node.
     * @param {Node} aNode The node to test.
     * @param {Node} aRootNode An optional node the tested node must reside in,
     *     hence a Document or Element (Collection) node.
     * @example Create an XML document and test the first child of its document
     *     element to see if it has been detached:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo><bar/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          docFirstChild = xmlDoc.documentElement.firstChild;
     *          TP.nodeIsDetached(docFirstChild);
     *          <samp>false</samp>
     *          // Detach it and test again
     *          TP.nodeDetach(docFirstChild);
     *          TP.nodeIsDetached(docFirstChild);
     *          <samp>true</samp>
     *     </code>
     * @returns {Boolean} True if the node isn't in a document.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     */

    var ancestor;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    //  attribute nodes are never detached
    if (TP.isAttributeNode(aNode)) {
        return false;
    }

    //  the node could be the root itself, in which case we're not
    //  considered detachable :)
    if (aNode === aRootNode) {
        return false;
    }

    //  document-level checks are faster then full traversals when they
    //  apply
    if (TP.isDocument(aRootNode)) {
        if (TP.isDocument(aNode)) {
            //  detached if the two documents aren't the same document
            return aNode !== aRootNode;
        } else if (TP.nodeGetDocument(aNode) !== aRootNode) {
            return true;
        }
    }

    if (TP.isNode(aRootNode)) {
        return !TP.nodeContainsNode(aRootNode, aNode);
    }

    if (TP.isDocument(aNode)) {
        return false;
    }

    //  looks like we need to verify the node is in a viable ancestor chain
    //  which terminates at a document element
    ancestor = aNode;
    while (ancestor && (ancestor = ancestor.parentNode)) {
        if (TP.isDocument(ancestor)) {
            return false;
        }
    }

    return true;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeNormalize',
function(aNode) {

    /**
     * @method nodeNormalize
     * @summary Normalizes adjacent Text nodes on the supplied Node and its
     *     descendants.
     * @param {Node} aNode The node to normalize.
     * @returns {Node} The node.
     * @exception TP.sig.InvalidNode Raised when the node is an invalid node.
     */

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    aNode.normalize();

    return aNode;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeRefreshDescendantDocumentPositions',
function(aNode) {

    /**
     * @method nodeRefreshDescendantDocumentPositions
     * @summary Refreshes the document positions for all of the descendant nodes
     *     of the supplied node.
     * @description This method refreshes the 0-indexed document position for
     *     each descendant node.
     * @param {Node} aNode The DOM node to operate on.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     */

    var allDescendantNodes;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    //  Grab all of the descendants (all descendants - not just Elements) and
    //  iterate, updating the document position.
    allDescendantNodes = TP.nodeGetDescendants(aNode);

    allDescendantNodes.forEach(
        function(descendantNode) {
            descendantNode[TP.PREVIOUS_POSITION] =
                TP.nodeGetDocumentPosition(descendantNode);
        });
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeReplaceChild',
function(aNode, newNode, oldNode, shouldAwake) {

    /**
     * @method nodeReplaceChild
     * @summary Replaces the old node in the supplied node with the newNode and
     *     then 'awakens' (initializes) the newly added content.
     * @param {Node} aNode The node to replace the child node in.
     * @param {Node} newNode The node to replace the old node with.
     * @param {Node} oldNode The node to be replaced with newNode.
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just replaced. The default for this operation is false.
     * @exception TP.sig.InvalidNode
     * @returns {Node} The new node. This may be a different node than what was
     *     supplied to this routine, as the node might have been imported.
     */

    var childContent,

        firstElement,

        targetNode,

        iframeDocElems,

        importedContent,

        awakenContent,

        start,
        end;

    if (!TP.isNode(aNode) || !TP.isNode(oldNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (TP.isString(newNode)) {
        //  this will throw/raise so we don't have to
        childContent = TP.nodeFromString(newNode);
        if (!TP.isNode(newNode)) {
            return;
        }
    } else if (!TP.isNode(newNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode', newNode);
    } else {
        childContent = newNode;
    }

    //  if the target is a document and not the documentElement we can't
    //  accept new content unless the oldNode is the documentElement
    if (TP.isDocument(aNode)) {
        if (TP.notValid(aNode.documentElement)) {
            TP.raise(this,
                        'TP.sig.InvalidOperation',
                        'Cannot replaceChild with empty #document node.');

            return;
        } else if (oldNode !== aNode.documentElement) {
            TP.raise(this,
                        'TP.sig.InvalidOperation',
                        'Cannot replaceChild other than #document node' +
                            ' root.');

            return;
        } else if (TP.isFragment(childContent)) {
            //  not valid, but we may have more than one inbound element so
            //  we have to check and potentially discard extras
            firstElement = TP.nodeGetFirstChildElement(childContent);
            if (TP.notValid(firstElement)) {
                TP.raise(this,
                            'TP.sig.InvalidOperation',
                            'Must supply element for #document root.');

                return;
            } else if (childContent.childNodes.length > 1) {
                TP.ifWarn() && TP.sys.cfg('log.node_discarded') ?
                    TP.warn('Discarding nodes from fragment: ' +
                                TP.str(childContent)) : 0;
            }

            childContent = firstElement;
        }
    }

    targetNode = aNode;

    //  For some browsers, we need to capture the iframe content before we
    //  move the node. This includes any iframes that are descendants of the
    //  node we're moving.
    if (TP.isElement(newNode)) {
        iframeDocElems = TP.$$elementPreserveIFrameContent(newNode);
    }

    //  The logic in this method is predicated on the fact that childContent
    //  might very well be a Node.DOCUMENT_FRAGMENT_NODE and, therefore,
    //  will be inserting *multiple* children into the common parent.

    //  make sure the node we'll insert is a part of the target node's
    //  document. as of ff3 and s3 this is required to avoid exceptions
    importedContent = TP.nodeImportNode(targetNode, childContent);

    //  We awaken if the content is an HTML node, otherwise we don't.
    awakenContent = TP.ifInvalid(shouldAwake, false);

    //  If we're awakening, or the new content is a fragment, then we need
    //  to capture the starting point.
    if (awakenContent || TP.isFragment(childContent)) {
        start = TP.nodeGetChildIndex(targetNode, oldNode);
    }

    try {
        //  Replace the new content in. This will (or should) change the
        //  number of children.
        targetNode.replaceChild(importedContent, oldNode);
    } catch (e) {
        TP.ifError() ? TP.error(TP.ec(e, 'replaceChild generated error.')) : 0;
        return;
    }

    //  Copy any TIBET expandos to the imported node.
    TP.nodeCopyTIBETExpandos(oldNode, importedContent, false);

    //  if newNode was a fragment, then it should now be empty to maintain
    //  semantic consistency with a standard appendChild call. If newNode
    //  was a string we don't bother to empty it.
    if (TP.isFragment(newNode)) {
        TP.nodeEmptyContent(newNode);
    }

    //  If we preserved the iframe content (see above), then we need to
    //  restore it.
    if (TP.isElement(targetNode) && TP.notEmpty(iframeDocElems)) {
        TP.$$elementRestoreIFrameContent(targetNode, iframeDocElems);
    }

    if (awakenContent) {
        //  If we're inserting a Node that has childNodes (probably a
        //  Node.DOCUMENT_FRAGMENT), then the end is equal to the start plus
        //  the number of new nodes minus 1.
        if (TP.isValid(childContent.childNodes)) {
            end = start + (childContent.childNodes.length - 1);
        } else {
            //  Otherwise, we just inserted one Node.
            end = start + 1;
        }

        TP.nodeAwakenChildNodesFromTo(targetNode, start, end);
    }

    //  If the new content was a fragment, then we need to return the final
    //  content's child node that starts at that point.
    if (TP.isFragment(importedContent)) {
        return targetNode.childNodes[start];
    }

    return importedContent;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeRemoveChild',
function(aNode, oldNode) {

    /**
     * @method nodeRemoveChild
     * @summary Removes the oldNode in supplied node.
     * @param {Node} aNode The node to remove the child node from.
     * @param {Node} oldNode The node to remove from aNode.
     * @exception TP.sig.InvalidNode
     * @returns {Node} The old node.
     */

    if (!TP.isNode(aNode) || !TP.isNode(oldNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    return aNode.removeChild(oldNode);
});

//  ------------------------------------------------------------------------
//  NODE CREATION
//  ------------------------------------------------------------------------

TP.definePrimitive('nodeFromString',
function(aString, defaultNS, shouldReport) {

    /**
     * @method nodeFromString
     * @summary Parses aString and returns the XML node representing the
     *     string's DOM representation. If the string is empty an empty text
     *     node is returned, when an element is produced that element is
     *     returned. CDATA and other node types are also possible output from
     *     this routine.
     * @param {String} aString The source string to be parsed. Note that this
     *     String *must* be XML compliant.
     * @param {String|null} defaultNS What namespace should be used for the
     *     'default namespace' for element markup in the supplied String.
     *     Note that this should be an XML 'namespace URI' (i.e.
     *     'http://www.w3.org/1999/xhtml') *not* a namespace prefix (i.e.
     *     'html:'). To use the 'null' namespace (i.e. xmlns=""), supply
     *     the empty String ('') here. To not specify any default namespace
     *     value and let the parser do what it does natively, supply null here.
     * @param {Boolean} shouldReport False to turn off exception reporting so
     *     strings can be tested for XML compliance without causing exceptions
     *     to be thrown. This is true by default.
     * @example Create a node from an XML String:
     *     <code>
     *          xmlElem = TP.nodeFromString(
     *          '<foo><bar><baz/></bar></foo>');
     *          <samp>[object Element]</samp>
     *     </code>
     * @example Create a node from a malformed XML String (note the flag to show
     *     the parser errors):
     *     <code>
     *          xmlElem = TP.nodeFromString(
     *          '<foo<bar><baz/></bar></foo>', null, true);
     *          <samp>(Parser error output)</samp>
     *     </code>
     * @returns {Node} The Node parsed from the supplied String.
     */

    var attrParts,

        newNode,
        content,

        piTarget,
        piData,

        doc,
        str;

    //  if it is an 'attribute expression' (i.e. 'foo="bar"'), we can create
    //  an attribute Node from it :-).
    if (TP.regex.XML_ATTR.test(aString)) {
        attrParts = TP.regex.XML_ATTR.match(aString);
        newNode = TP.XML_FACTORY_DOCUMENT.createAttribute(attrParts.at(1));

        //  Note that the value matched in the RegExp above contains the quotes
        //  for the most robust matching. We need to slice them off here.
        newNode.value = attrParts.at(4).slice(1, -1);

        return newNode;
    }

    //  if it is a 'comment expression' (i.e. '<!--foo-->'), we can create
    //  a Comment Node from it :-).
    if (TP.regex.XML_COMMENT_WHOLE.test(aString)) {
        content = TP.regex.XML_COMMENT_WHOLE.exec(aString)[1];

        newNode = TP.XML_FACTORY_DOCUMENT.createComment(content);

        return newNode;
    }

    //  if it is an 'CDATA expression' (i.e. '<![CDATA[foo]]>'), we can create
    //  a CDATA Node from it :-).
    if (TP.regex.XML_CDATA_WHOLE.test(aString)) {
        content = TP.regex.XML_CDATA_WHOLE.exec(aString)[1];

        newNode = TP.XML_FACTORY_DOCUMENT.createCDATASection(content);

        return newNode;
    }

    //  if it is a 'Processing Instruction' (i.e. '<?foo bar?>'), we can create
    //  a Processing Instruction Node from it :-).
    if (TP.regex.XML_PI_WHOLE.test(aString)) {
        content = TP.regex.XML_PI_WHOLE.exec(aString)[1];

        //  Now, split the 'target' and the 'data'
        piTarget = content.slice(0, content.indexOf(' '));
        piData = content.slice(content.indexOf(' ') + 1);

        newNode = TP.XML_FACTORY_DOCUMENT.createProcessingInstruction(
                        piTarget, piData);

        return newNode;
    }

    //  string without valid markup?...text node
    if (TP.isEmpty(aString) ||
        !aString.trim().startsWith('<') ||
        aString.length < '<a/>'.length) {
        //  make sure we provide '' or this call will fail
        return TP.XML_FACTORY_DOCUMENT.createTextNode(aString || '');
    }

    //  by wrapping in a root element we ensure we can create something,
    //  which we'll then unwrap and hand back in the best form possible, but
    //  we have to watch out for any XML declaration that might start things
    //  off
    str = aString.trim();
    str = str.strip(TP.regex.XML_PREFIX);
    str = str.trim();

    //  the regex which follows can be very temperamental, as in it'll wander
    //  off for who knows how long if it's not at least closed markup.
    if (str.first() !== '<' || str.last() !== '>') {
        //  can't be a node string anyway...
        return;
    }

    //  wrap the element content (skipping comments, PIs, etc).
    str = str.replace(TP.regex.ALL_ELEM_MARKUP, '<wrap>$&</wrap>');

    //  should be able to get a document built from the string
    doc = TP.documentFromString(str, defaultNS, shouldReport);

    if (TP.isDocument(doc)) {
        //  extract the content from our wrapper div...
        if (doc.documentElement.childNodes.length > 1) {
            //  pass document to keep import from being required to move
            //  the nodes into the fragment
            return TP.nodeListAsFragment(
                    doc.documentElement.childNodes);
        } else {
            return doc.documentElement.firstChild;
        }
    }

    return;
});

//  ------------------------------------------------------------------------
//  NODE "QUERIES"
//  ------------------------------------------------------------------------

TP.definePrimitive('nodeEvaluateBarename',
function(aNode, aPath, autoCollapse, createAttr) {

    /**
     * @method nodeEvaluateBarename
     * @summary Traverses a barename and returns the node corresponding to the
     *     bare name.
     * @description The XPointer standard includes a very simple scheme, the
     *     barename scheme, which operates much like HTML anchors, except on
     *     IDs. This would take the form of 'http://www.foo.com#barElem'. TIBET
     *     supports this, but extends it so that an attribute of that element
     *     can be obtained. Therefore, in TIBET, the following syntax can also
     *     be used: 'http://www.foo.com#barElem@bazAttr'. Lastly, this syntax
     *     can be used to retrieve all attribute nodes of an Element:
     *     'http://www.foo.com#bar@*'.
     * @param {Node} aNode The 'context node' for the evaluation.
     * @param {String} aPath A valid element scheme path.
     * @param {Boolean} [autoCollapse=false] Whether to collapse Array results
     *     if there's only one item in them. The default is false.
     * @param {Boolean} createAttr Whether or not we should create Attribute
     *     nodes if the barename uses 'TIBET extended syntax' and references an
     *     attribute, but that attribute doesn't exist.
     * @returns {Element|Attribute|Node[]} The element or attribute(s) obtained
     *     by evaluating the supplied path.
     * @exception TP.sig.InvalidPath Raised when an invalid barename is provided
     *     to the method.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     */

    var barename,

        id,
        attrName,

        elem,

        result;

    //  NOTE that there's no testing of parameters here; we assume an entry
    //  point of nodeEvaluatePath() and rely on it to have tested them.

    if (!TP.regex.BARENAME.test(aPath)) {
        return TP.raise(this, 'TP.sig.InvalidPath');
    }

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    //  make sure we have a real path
    if (TP.isEmpty(barename = aPath.slice(1))) {
        return null;
    }

    result = null;

    //  We're asking for 'all' of the attributes
    if (/@\*/.test(barename)) {
        id = barename.slice(0, barename.indexOf('@'));

        if (TP.isElement(elem = TP.nodeGetElementById(aNode, id))) {
            result = TP.elementGetAttributeNodes(elem);
        }
    } else if (/@/.test(barename)) {
        //  We're asking for a specific attribute
        id = barename.slice(0, barename.indexOf('@'));
        attrName = barename.slice(barename.indexOf('@') + 1);

        if (TP.isElement(elem = TP.nodeGetElementById(aNode, id))) {
            result = elem.getAttributeNode(attrName);

            //  If we couldn't find an Attribute node, but we are configured to
            //  create Attribute nodes, then go ahead and create it and refetch
            //  the Attribute node.
            if (!TP.isAttributeNode(result) && TP.isTrue(createAttr)) {
                TP.elementSetAttribute(elem, attrName, '', true);
                result = elem.getAttributeNode(attrName);
            }
        }
    } else {
        //  No attributes - just the element with that id
        result = TP.nodeGetElementById(aNode, barename);
    }

    //  No results? Return an empty Array for consistency in return values.
    if (TP.notValid(result) && TP.notTrue(autoCollapse)) {
        return TP.ac();
    }

    if (TP.isArray(result) && TP.isTrue(autoCollapse)) {
        if (result.getSize() === 1) {
            return result.first();
        } else if (TP.isEmpty(result)) {
            return null;
        }
    }

    if (!TP.isArray(result) && TP.notTrue(autoCollapse)) {
        result = TP.ac(result);
    }

    return result;
});

//  ------------------------------------------------------------------------

//  TP.nodeEvaluateCSS is in TIBETCSSQuery

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeEvaluateElementScheme',
function(aNode, aPath) {

    /**
     * @method nodeEvaluateElementScheme
     * @summary Traverses an element scheme path, returning the targeted
     *     element if one exists.
     * @description The XPointer standard includes several schemes, one of which
     *     is the element() scheme. In this scheme the fragment part of the URI
     *     is #element(path) where path is a forward-slash separated list of
     *     steps. The first step can be either a 1, signifying the root node of
     *     the document, or an ID. All other steps are child node indexes where,
     *     for compatibility with XPath, the first child's index is 1. The body
     *     element of an HTML document is therefore #element(/1/2) while the
     *     first child element of an element with ID 'foo' would be
     *     #element(foo/1). Note that you don't quote the ID; any non-numeric
     *     value in the first character will force ID semantics on the first
     *     segment.
     * @param {Node} aNode The 'context node' for the evaluation.
     * @param {String} aPath A valid element scheme path.
     * @returns {Element} The element obtained by evaluating the supplied path.
     * @exception TP.sig.InvalidPath Raised when an invalid element scheme is
     *     provided to the method.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     */

    var path,
        arr,

        rootID,

        startIndex,
        node,
        doc,

        children,

        len,
        i,
        index;

    //  NOTE that there's no testing of parameters here; we assume an entry
    //  point of nodeEvaluatePath() and rely on it to have tested them.

    if (TP.regex.ELEMENT_POINTER.test(aPath)) {
        path = TP.regex.ELEMENT_POINTER.match(aPath).at(1);
    } else if (/^\/1/.test(aPath)) {
        path = aPath;
    } else {
        return TP.raise(this, 'TP.sig.InvalidPath');
    }

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    //  paths could be one of two forms:
    //      /1/n/n/n/... in this case, we split and throw away the chunk in
    //      front of the first /, it's not needed
    //  OR:
    //      id/n/n/n/... in this case, we just split

    if (path.startsWith('/')) {
        arr = path.split('/');
        arr.shift();
    } else {
        arr = path.split('/');
    }

    //  acquire the root
    rootID = arr.at(0);

    //  if its a Number, use that as the placeholder for the #document node.
    if (TP.isNumber(parseInt(rootID, 10))) {
        //  must be a 1 to be valid
        if (parseInt(rootID, 10) !== 1) {
            return TP.raise(this, 'TP.sig.InvalidPath',
                        'element() scheme root must have index of 1');
        }

        node = TP.nodeGetDocument(aNode);
        startIndex = 0;

        if (!TP.isNode(node)) {
            //  already will have thrown TP.sig.DetachedNodeException
            return null;
        }
    } else {
        //  must be an ID we can find in the node's document
        doc = TP.nodeGetDocument(aNode);
        if (!TP.isDocument(doc)) {
            return TP.raise(this,
                            'TP.sig.DetachedNodeException');
        }

        node = TP.nodeGetElementById(doc, rootID);
        startIndex = 1;

        if (!TP.isNode(node)) {
            //  not an exception, just not found
            return null;
        }
    }

    //  with the root in place we can start working through remainder of the
    //  list, starting at startIndex to possibly skip the root ID
    len = arr.getSize();
    for (i = startIndex; i < len; i++) {
        index = parseInt(arr.at(i), 10);
        if (!TP.isNumber(index)) {
            return TP.raise(this,
                            'TP.sig.InvalidPath',
                            'element() scheme segments must be integers.');
        }

        //  Note here that we're only going after child *Elements* -- that's
        //  what this schema is about.
        children = TP.nodeGetChildElements(node);

        node = children.at(index - 1);
        if (!TP.isNode(node)) {
            return null;
        }
    }

    return node;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeEvaluatePath',
function(aNode, aPath, aPathType, autoCollapse, retryWithDocument) {

    /**
     * @method nodeEvaluatePath
     * @summary Evaluates the path provided, parsing for common path syntax.
     *     There are several path types which might be used, but the most
     *     typical are XPaths, XPointers (which include xpointer(), xpath1()
     *     and element() schemes), and CSS queries. The latter are rare since
     *     the focus here is largely on "paths" and CSS selectors don't strictly
     *     define a path.
     * @param {Node} aNode The document or element to query.
     * @param {String} aPath The path to traverse in locating a value.
     * @param {String} aPathType One of the 'path type' constants:
     *     TP.XPATH_PATH_TYPE
     *     TP.XPOINTER_PATH_TYPE
     *     TP.ELEMENT_PATH_TYPE
     *     TP.XTENSION_POINTER_PATH_TYPE
     *     TP.CSS_PATH_TYPE
     *     TP.BARENAME_PATH_TYPE
     * @param {Boolean} [autoCollapse=false] Whether to collapse Array results
     *     if there's only one item in them. The default is false.
     * @param {Boolean} [retryWithDocument=false] Whether or not we should retry
     *     with the supplied node's document node, if we got back no results.
     *     For now, due to the nature of the various types of paths, this only
     *     applies for the TP.CSS_PATH_TYPE path.
     * @returns {Object} The value of evaluating the path.
     * @exception TP.sig.InvalidPath Raised when an invalid path is provided to
     *      the method.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     */

    var path,
        result,

        thePathType;

    if (TP.notValid(aNode)) {
        TP.raise(this, 'TP.sig.InvalidNode',
                    'Node does not have path interface.');

        return;
    }

    //  no query, no result
    if (TP.isEmpty(aPath)) {
        return TP.raise(this, 'TP.sig.InvalidPath');
    }

    //  If the path is just '.' or '$_', then that's the shortcut to just return
    //  the target node itself.
    if (TP.regex.ONLY_PERIOD.test(aPath) || TP.regex.ONLY_STDIN.test(aPath)) {
        return aNode;
    }

    //  common path in repeats etc. where performance is important is an
    //  attribute path so we can optimize for those (but not for '@*' paths
    //  where the caller wants all attributes).
    if (TP.regex.ATTRIBUTE.test(aPath) &&
        !TP.regex.ATTRIBUTE_ALL.test(aPath)) {
        path = aPath.slice(1);

        //  don't return '' here, return null if we can't find a real value
        result = TP.elementGetAttribute(aNode, path);

        return TP.isEmpty(result) ? null : result;
    }

    //  If the path type wasn't supplied, compute it.
    thePathType = aPathType;
    if (TP.notValid(thePathType)) {
        thePathType = TP.getAccessPathType(aPath);
    }

    switch (thePathType) {
        case TP.XPATH_PATH_TYPE:

            //  because nodeEvaluateXPath() has its own logic around result
            //  reduction, we need to do this here by always capturing a
            //  full nodeset and then returning the node if the result set
            //  has only one node and the caller wants auto collapse.
            result = TP.nodeEvaluateXPath(aNode, aPath, TP.NODESET);

            //  If autoCollapse was turned on, we need to either return the
            //  first result (if there is only one) or null if the result is
            //  empty
            if (TP.isTrue(autoCollapse)) {
                if (result.getSize() === 1) {
                    return result.at(0);
                } else if (TP.isEmpty(result)) {
                    return null;
                }
            }

            return result;

        case TP.XPOINTER_PATH_TYPE:
        case TP.ELEMENT_PATH_TYPE:

            //  #xpointer(...), #xpath1(...) or #element(...) schemes
            return TP.nodeEvaluateXPointer(aNode, aPath, autoCollapse);

        case TP.XTENSION_POINTER_PATH_TYPE:

            //  Other 'extended' schemes
            return TP.nodeEvaluateXTension(aNode, aPath, autoCollapse);

        case TP.CSS_PATH_TYPE:

            result = TP.nodeEvaluateCSS(aNode, aPath, autoCollapse);

            if (TP.notTrue(retryWithDocument)) {
                return result;
            }

            //  We're gonna retry with the node's document node as the
            //  context node. Note how we check for either 'not valid' or
            //  'is empty', because we may be autocollapsing or not.

            /* eslint-disable no-extra-parens */
            if (TP.notValid(result) ||
                (TP.isArray(result) && TP.isEmpty(result))) {
                return TP.nodeEvaluateCSS(TP.nodeGetDocument(aNode),
                                            aPath,
                                            autoCollapse);
            }
            /* eslint-enable no-extra-parens */

            return result;

        case TP.BARENAME_PATH_TYPE:

            return TP.nodeEvaluateBarename(
                            TP.nodeGetDocument(aNode), aPath, autoCollapse);

        default:

            return null;
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeEvaluateXPath',
function(aNode, anXPath, resultType, logErrors) {

    /**
     * @method nodeEvaluateXPath
     * @summary Returns the result of evaluating the XPath expression against
     *     the node given.
     * @param {Node} aNode The context node to begin querying for Nodes from.
     * @param {String} anXPath The XPath expression to use to query the tree
     *     starting from aNode.
     * @param {Number} resultType The type of result desired, either
     *     TP.NODESET or TP.FIRST_NODE.
     * @param {Boolean} logErrors Used to turn off error notification,
     *     particularly during operations such as string localization which
     *     can cause recursion issues.
     * @example Use XPath to select a set of nodes from a mixed namespace
     *     document:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo
     *         xmlns="http://www.foo.com"><baz:bar
     *
     *         xmlns:baz="http://www.baz.com"><baz:moo/><goo/></baz:bar></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeEvaluateXPath(xmlDoc, '//*');
     *          <samp>[object Element], [object Element], [object Element],
     *         [object Element]</samp>
     *          Select the 'foo' node (note that XPath 1.0 doesn't
     *          'do' default namespaces, so we have to do this another
     *          way):
     *          TP.nodeEvaluateXPath(xmlDoc, '//*[name() = "foo"]',
     *         TP.FIRST_NODE);
     *          <samp>[object Element]</samp>
     *
     * @example Use XPath to evaluate an expression that returns a scalar
     *     result (IE doesn't do this natively, but TIBET works around that
     *     limitation):
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo><bar/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeEvaluateXPath(xmlDoc, '1 + 2');
     *          <samp>3</samp>
     *     </code>
     * @example Use XPath to select a node that has a particular id using the
     *     'id()' function. Normally, this won't work unless the document has
     *     a DTD that specifies that that element should have an ID. TIBET
     *     makes it work when 'true' is passed for the 'rewriteIDs' parameter:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo id="fooElem"><bar/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeEvaluateXPath(xmlDoc, 'id("fooElem")');
     *          <samp></samp>
     *          TP.nodeEvaluateXPath(xmlDoc, 'id("fooElem")', null, null,
     *         true);
     *          <samp></samp>
     *     </code>
     * @returns {Node[]|Node} The XPath execution result.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     * @exception TP.sig.InvalidString Raised when a null or empty XPath
     *     expression is provided to the method.
     */

    var log,

        theXPath,

        doc,

        result,

        nodePath,

        resultArr,
        firstItem,
        node,

        i,

        msg;

    //  According to the DOM Level 3 XPath specification, aNode can only be
    //  one of:
    //      Document, Element, Attribute, Text, CDATASection, Comment,
    //      ProcessingInstruction, or XPathNamespace node
    //  Therefore, no DocumentFragments

    if (!TP.isNode(aNode) || TP.isFragment(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    //  NB: We can't use TP.isString() here, due to load ordering issues
    //  on startup.
    if (TP.isEmpty(anXPath)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    //  if we need it we can really turn on the XPath logging here
    TP.ifTrace() && TP.sys.hasLoaded() && TP.sys.shouldLogXPaths() ?
        TP.trace('Querying via XPath ' + anXPath,
                    TP.QUERY_LOG) : 0;

    log = TP.ifInvalid(logErrors, true);

    //  Allow the shortcut convenience that TIBET provides of specifying the
    //  '$def:' prefix (intentionally illegal because it leads with a '$') for
    //  elements that are in the default namespace.
    TP.regex.XPATH_DEFAULTNS.lastIndex = 0;
    theXPath = anXPath.replace(TP.regex.XPATH_DEFAULTNS,
                                '*[name()="$1"]');

    //  Gecko-based browsers (i.e. Firefox) has issues when querying for
    //  descendant or self when the node is a Text node. In this case, we just
    //  hand back the node itself, wrapped in an Array or not depending on the
    //  result type the caller wanted.
    if (TP.sys.isUA('GECKO')) {
        if (TP.isTextNode(aNode) && anXPath === 'descendant-or-self::node()') {
            if (resultType === TP.NODESET) {
                return TP.ac(aNode);
            } else if (resultType === TP.FIRST_NODE) {
                return aNode;
            }
        }
    }

    try {
        doc = TP.nodeGetDocument(aNode);

        //  IE11 currently does not have built-in XPath support, so we wire in
        //  both the Wicked Good XPath processor *and* the jquery-xpath engine
        //  here. We use both because Wicked Good XPath is very fast, but has
        //  bugs (esp. around namespaces - namespaced attributes, to be
        //  specific).

        //  Note that wgxpath has already been installed by the boot system onto
        //  the code frame (if a built-in XPath processor wasn't available,
        //  according to how wgxpath works). This gives us globals, such as
        //  'XPathResult', that are required for processing.
        //  Now, in this context, 'doc' very well might not be the top-level
        //  window/document (very doubtful, in fact), so we need to install an
        //  'evaluate' on 'doc' that will leverage both processors.

        if (TP.notValid(doc.evaluate)) {

            //  Install Wicked Good XPath (wgxpath) on the document. Note that
            //  it expects a Window(!) that will have a 'document' slot, but
            //  thankfully its good enough to hand it a POJO with a 'document'
            //  slot.
            TP.extern.wgxpath.install({
                document: doc
            });

            //  Grab the 'evaluate' function that wgxpath installed and alias it
            //  to '$evaluate'.
            doc.$evaluate = doc.evaluate;

            //  Overwrite the 'evaluate' function with a custom version that
            //  will call upon the jquery-xpath engine when necessary (see
            //  below).
            doc.evaluate =
                function(expression, contextNode, resolver, type, theResult) {

                    var emulatedResult;

                    //  Most of this function is to work around wgxpath bugs.

                    //  If the expression has a 'namespace-uri()' or 'number()'
                    //  call in it somewhere, then we can't trust wgxpath to
                    //  return the proper results. Invoke the jQuery XPath
                    //  processor.
                    if (/(namespace-uri\(|number\()/.test(expression)) {
                        emulatedResult = TP.extern.jxpath(
                                    contextNode, expression, resolver);
                    } else {

                        //  Execute the wgxpath engine
                        emulatedResult = this.$evaluate(
                            expression, contextNode, resolver, type, theResult);

                        //  If the result was supposed to be a node 'snapshot'
                        //  (according to XPathResult rules), but has a
                        //  'snapshotLength' of 0 (i.e. it is empty), then we
                        //  try again with the jQuery XPath processor - again to
                        //  work around wgxpath bugs.
                        if (TP.owns(emulatedResult, 'snapshotLength') &&
                            emulatedResult.snapshotLength === 0) {

                            emulatedResult = TP.extern.jxpath(
                                        contextNode, expression, resolver);
                        }
                    }

                    return emulatedResult;
                };
        }

        //  Run the XPath, using the XPathResult.ANY_TYPE so that we either
        //  get a scalar value or an iterable set of Nodes.
        result = doc.evaluate(
                        theXPath,
                        aNode,
                        TP.$$xpathResolverFunction,
                        XPathResult.ANY_TYPE,
                        null);

        //  If the result has a 'jquery' slot on it, then it's a jQuery result
        //  object that will have its results packaged according to jQuery
        //  rules, because these results were returned from the jQuery XPath
        //  processor.
        if (TP.isValid(result.jquery)) {

            //  Extract the jQuery results into a regular Array
            resultArr = TP.extern.jQuery.makeArray(result);

            //  Grab the first item from the Array. If it's a Number, String or
            //  Boolean, then the XPath didn't result in a Node or Nodes, but in
            //  a primitive value, so return it.
            firstItem = resultArr.first();
            if (TP.isNumber(firstItem) ||
                TP.isString(firstItem) ||
                TP.isBoolean(firstItem)) {

                return firstItem;
            }

            //  If what we got back was a NaN here, then we see if the path we
            //  were trying to run was trying to convert into a scalar (number()
            //  value). If so, then we strip off the conversion, run it again
            //  and return the 'first result' in the iteration. This allows us
            //  to have an 'empty Text node' that resolves to a null, rather
            //  than a NaN - important in cases where we're trying to determine
            //  whether we have a real value or not.
            if (TP.isNaN(firstItem)) {
                if (TP.regex.XPATH_HAS_SCALAR_CONVERSION.test(
                                                        theXPath)) {
                    nodePath =
                        TP.regex.XPATH_HAS_SCALAR_CONVERSION.match(
                                                        theXPath).at(1);
                    result = doc.evaluate(
                                    nodePath,
                                    aNode,
                                    TP.$$xpathResolverFunction,
                                    XPathResult.ANY_TYPE,
                                    null);

                    //  Extract the jQuery results into a regular Array
                    resultArr = TP.extern.jQuery.makeArray(result);

                    //  This should return a Text node (but may also return
                    //  null due to a bug in wgxpath).
                    result = resultArr.first();

                    //  If it's either null or an empty Text node, then return
                    //  null
                    if (TP.isNull(result)) {
                        return null;
                    }
                    if (TP.isTextNode(result) &&
                        TP.isEmpty(result.nodeValue)) {
                        return null;
                    }

                    //  Otherwise, return the original NaN
                    return NaN;
                }
            }

            //  If the caller wanted a nodeset, just return the Array.
            if (resultType === TP.NODESET) {
                return resultArr;
            } else if (resultType === TP.FIRST_NODE) {
                //  If the caller just wanted the first node, grab the first
                //  node from the Array and return it.
                if (TP.isNode(node = firstItem)) {
                    return node;
                }
            } else {
                //  If an explicit result type wasn't specified, then
                //  we use the 'only node rule' - which is that if the
                //  result set only contains one node, we return that.
                //  Otherwise, we return the Array.
                if (resultArr.getSize() === 1) {
                    return firstItem;
                }

                return resultArr;
            }

            //  return value default depends on request type
            if (resultType === TP.NODESET) {
                return TP.ac();
            } else {
                return null;
            }
        }

        //  If we got a value result, switch on the result type to get the
        //  primitive value. If its not one of the primitive values, then its
        //  a iterable node set, so we either iterate and repackage it into an
        //  Array or just iterate once and return the first node, depending on
        //  what our desired result type is.
        if (TP.isValid(result)) {
            switch (result.resultType) {
                case XPathResult.NUMBER_TYPE:

                    //  If what we got back was a NaN here, then we see if the
                    //  path we were trying to run was trying to convert into a
                    //  scalar (number() value). If so, then we strip off the
                    //  conversion, run it again and return the 'first result'
                    //  in the iteration. This allows us to have an 'empty Text
                    //  node' that resolves to a null, rather than a NaN -
                    //  important in cases where we're trying to determine
                    //  whether we have a real value or not.
                    if (TP.isNaN(result.numberValue)) {
                        if (TP.regex.XPATH_HAS_SCALAR_CONVERSION.test(
                                                                theXPath)) {
                            nodePath =
                                TP.regex.XPATH_HAS_SCALAR_CONVERSION.match(
                                                                theXPath).at(1);
                            result = doc.evaluate(
                                            nodePath,
                                            aNode,
                                            TP.$$xpathResolverFunction,
                                            XPathResult.ANY_TYPE,
                                            null);

                            //  This should return a Text node
                            result = result.iterateNext();

                            //  If the Text node is empty, return null
                            if (TP.isTextNode(result) &&
                                TP.isEmpty(result.nodeValue)) {
                                return null;
                            }

                            //  Otherwise, return the original NaN
                            return NaN;
                        }
                    } else {
                        return result.numberValue;
                    }

                    break;
                case XPathResult.BOOLEAN_TYPE:

                    return result.booleanValue;

                case XPathResult.STRING_TYPE:

                    return result.stringValue;

                default:

                    //  If the caller wanted a nodeset, make sure to return an
                    //  Array, even if its empty.
                    if (resultType === TP.NODESET) {
                        resultArr = TP.ac();

                        //  Repackage from the XPathResult into an Array.
                        while (TP.isNode(node = result.iterateNext())) {
                            resultArr.push(node);
                        }

                        return resultArr;
                    } else if (resultType === TP.FIRST_NODE) {

                        //  If the caller just wanted the first node, grab the
                        //  first node from the XPathResult and return it.
                        if (TP.isNode(node = result.iterateNext())) {
                            return node;
                        }
                    } else {
                        //  If an explicit result type wasn't specified, then
                        //  we use the 'only node rule' - which is that if the
                        //  result set only contains one node, we return that.
                        //  Otherwise, we return the Array.
                        resultArr = TP.ac();

                        while (TP.isNode(node = result.iterateNext())) {
                            resultArr.push(node);
                        }

                        if (resultArr.getSize() === 1) {
                            return resultArr.first();
                        }

                        return resultArr;
                    }
            }
        }
    } catch (e) {

        //  If the caller wanted a TP.NODESET, then we can retry with a snapshot
        //  result type, which is more resilient in face of DOM changes.
        if (resultType === TP.NODESET) {

            TP.ifInfo() ?
                TP.info('Error occurred executing XPath.' +
                        ' Retrying with snapshot result type') : 0;

            try {
                result = doc.evaluate(
                                theXPath,
                                aNode,
                                TP.$$xpathResolverFunction,
                                XPathResult.ORDERED_NODE_SNAPSHOT_TYPE,
                                null);

                resultArr = TP.ac();

                //  Repackage from the XPathResult into an Array.
                for (i = 0; i < result.snapshotLength; i++) {
                    resultArr.push(result.snapshotItem(i));
                }

                return resultArr;
            } catch (e2) {
                //  An error occurred the second time through - report it.
                if (log || !TP.sys.hasLoaded()) {
                    msg = TP.join('Error evaluating XPath ', anXPath);
                    TP.ifError() ?
                        TP.error(TP.ec(e2, msg), TP.QUERY_LOG) : 0;
                }
            }
        } else {
            if (log || !TP.sys.hasLoaded()) {
                msg = TP.join('Error evaluating XPath ', anXPath);
                TP.ifError() ?
                    TP.error(TP.ec(e, msg), TP.QUERY_LOG) : 0;
            }
        }
    }

    //  return value default depends on request type
    if (resultType === TP.NODESET) {
        return TP.ac();
    } else {
        return null;
    }
}, {
    dependencies: [TP.extern.wgxpath, TP.extern.jxpath, TP.extern.jQuery]
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeEvaluateXPointer',
function(aNode, aPath, autoCollapse) {

    /**
     * @method nodeEvaluateXPointer
     * @summary Executes an XPointer, which may be one of a number of specific
     *     pointer schemes, returning the results. Samples include fragments of
     *     the form #barename, #xpointer(a_path), #xpath1(a_path),
     *     #element(a_path), etc.
     * @param {Node} aNode The 'context node' for the evaluation.
     * @param {String} aPath A valid xpointer expression/scheme such as
     *     xpointer(), xpath1(), element(), etc.
     * @param {Boolean} [autoCollapse=false] Whether to collapse Array results
     *     if there's only one item in them. The default is false.
     * @returns {Node[]|Node|Object} A collection of zero or more result nodes.
     */

    var path,
        result;

    //  NOTE that there's no testing of parameters here; we assume an entry
    //  point of nodeEvaluatePath() and rely on it to have tested them.

    //  Also note that, if the result here is not to be auto-collapsed, we
    //  hand back an empty Array to be consistent with the return value for
    //  all methods that do auto-reduction.

    //  element() scheme
    if (TP.regex.ELEMENT_POINTER.test(aPath)) {
        //  Note that because nodeEvaluateElementScheme() will always return
        //  a single Element, we only wrap it into an Array if the
        //  autoCollapse flag is not true.
        if (TP.isTrue(autoCollapse)) {
            return TP.nodeEvaluateElementScheme(aNode, aPath);
        } else {
            if (TP.notValid(result =
                            TP.nodeEvaluateElementScheme(aNode, aPath))) {
                return TP.ac();
            }

            return TP.ac(result);
        }
    } else if (TP.regex.XPATH_POINTER.test(aPath)) {
        //  strip XPath out of the xpointer() or xpath1() wrapper, leaving
        //  whatever might be there (which could include id(), instance(), etc.)
        path = TP.regex.XPATH_POINTER.match(aPath).at(2);

        if (TP.isTrue(autoCollapse)) {
            //  because auto-reduction means to return a 'collapsed' element
            //  only if there was only one return value, we always ask
            //  nodeEvaluateXPath() to hand us back a nodeset and then see
            //  if there is only one return value.
            result = TP.nodeEvaluateXPath(aNode, path, TP.NODESET);
            if (result.getSize() === 1) {
                return result.first();
            } else if (TP.isEmpty(result)) {
                return null;
            }

            return result;
        } else {
            //  This will always hand back an Array
            return TP.nodeEvaluateXPath(aNode, path, TP.NODESET);
        }
    } else {
        //  barename is our only remaining choice, and nodeGetElementById
        //  will manage any leading #. Note that TP.nodeGetElementById()
        //  will always return a single Element (never an Array), we just
        //  need to match 'return types' here and hand back an Array if
        //  we're not auto-reducing.
        if (TP.isTrue(autoCollapse)) {
            return TP.nodeGetElementById(aNode, aPath);
        } else {
            if (TP.notValid(result = TP.nodeGetElementById(aNode, aPath))) {
                return TP.ac();
            }

            return TP.ac(result);
        }
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeEvaluateXTension',
function(aNode, aPath, autoCollapse) {

    /**
     * @method nodeEvaluateXTension
     * @summary Executes an extended XPointer scheme, typically css().
     * @param {Node} aNode The 'context node' for the evaluation.
     * @param {String} aPath An extended path/pointer scheme such as css(), etc.
     * @param {Boolean} [autoCollapse=false] Whether to collapse Array results
     *     if there's only one item in them. The default is false.
     * @returns {Node[]|Node} A collection of zero or more result nodes.
     */

    var query;

    //  NOTE that there's no testing of parameters here; we assume an entry
    //  point of nodeEvaluatePath() and rely on it to have tested them.

    if (TP.regex.CSS_POINTER.test(aPath)) {
        query = aPath.match(TP.regex.CSS_POINTER).at(1);

        return TP.nodeEvaluateCSS(aNode, query, autoCollapse);
    } else {
        TP.ifWarn() ?
            TP.warn('Unsupported query path syntax: ' + aPath,
                    TP.QUERY_LOG) : 0;

        return;
    }
});

//  ------------------------------------------------------------------------
//  NODE CONTENT COLLECTIONS
//  ------------------------------------------------------------------------

/*
Operations to acquire structurally related elements from a Node. Prebuilt
methods are defined here to acquire ancestors, children, descendants, and
siblings as well as child elements or descendant elements. A general purpose
routine for acquiring descendants of any type is also provided, however for
acquiring element descendants you should use the
TP.nodeGetDescendantElements() call since it's optimized for element access.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetAncestors',
function(aNode, stopAncestor) {

    /**
     * @method nodeGetAncestors
     * @summary Returns an Array containing ancestor nodes of the provided
     *     node.
     * @description This list ends with the top-level element node and does not
     *     include the node's containing DOCUMENT_NODE. The list is ordered
     *     "outward" with the closest parent first.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Element} [stopAncestor] An element between aNode and aNode's
     *     document node that the ancestor traversal will 'stop' at. This
     *     parameter is optional. Note that this ancestor will *not* be included
     *     in the result set.
     * @example Get all of the ancestors of an XML element:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo><bar><baz/></bar></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetAncestors(
     *          xmlDoc.documentElement.firstChild.firstChild);
     *          <samp>[object Element], [object Element]</samp>
     *     </code>
     * @example Get all of the ancestors of an HTML element:
     *     <code>
     *          TP.nodeGetAncestors(TP.documentGetBody(document).firstChild);
     *          <samp>[object HTMLBodyElement], [object HTMLHtmlElement]</samp>
     *     </code>
     * @returns {Node[]} An Array of the parent nodes of the supplied Node.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     */

    var ancestor,
        arr;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    arr = TP.ac();

    ancestor = aNode.parentNode;
    while (TP.isElement(ancestor)) {
        arr.push(ancestor);
        ancestor = ancestor.parentNode;
        if (TP.isNode(stopAncestor) && ancestor === stopAncestor) {
            break;
        }
    }

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetAncestorsInNSURI',
function(aNode, aNamespaceURI) {

    /**
     * @method nodeGetAncestorsInNSURI
     * @summary Returns an array of ancestors of the current element which are
     *     in the namespace provided. Note that this method only checks the
     *     elements themselves, not the attributes. If you want to also return
     *     elements that have attributes are in that namespace, use
     *     nodeGetAncestorsWithNSURI.
     * @param {Node} aNode The node to start traversal from.
     * @param {String} aNamespaceURI The URI for the namespace to check.
     * @returns {Element[]} An array of ancestors.
     */

    var arr,
        ancestor;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'InvalidNode');
    }

    if (TP.isEmpty(aNamespaceURI)) {
        return TP.raise(this, 'InvalidNamespace');
    }

    arr = TP.ac();

    ancestor = aNode.parentNode;
    while (TP.isElement(ancestor)) {
        if (ancestor.namespaceURI === aNamespaceURI) {
            arr.push(ancestor);
        }
        ancestor = ancestor.parentNode;
    }

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetAncestorsWithNSURI',
function(aNode, aNamespaceURI) {

    /**
     * @method nodeGetAncestorsWithNSURI
     * @summary Returns an array of elements with either a namespaceURI or
     *     that has one or more attributes which are part of the namespace
     *     provided.
     * @param {Node} aNode The node to start traversal from.
     * @param {String} aNamespaceURI The URI for the namespace to check.
     * @returns {Element[]} An array of ancestors.
     */

    var arr,
        ancestor,
        attrs;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'InvalidNode');
    }

    if (TP.isEmpty(aNamespaceURI)) {
        return TP.raise(this, 'InvalidNamespace');
    }

    arr = TP.ac();

    ancestor = aNode.parentNode;
    while (TP.isElement(ancestor)) {
        if (ancestor.namespaceURI === aNamespaceURI) {
            arr.push(ancestor);
        } else {
            attrs = TP.elementGetAttributeNodesInNS(
                            ancestor, null, aNamespaceURI);
            if (TP.notEmpty(attrs)) {
                arr.push(ancestor);
            }
        }

        ancestor = ancestor.parentNode;
    }

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetCommonAncestor',
function(firstNode, varargs) {

    /**
     * @method nodeGetCommonAncestor
     * @summary Returns the common ancestor of the supplied Nodes.
     * @description This is derived from code by 'Andy E':
     *     http://jsfiddle.net/AndyE/3FaRr/1/
     * @param {Node} firstNode The first DOM node to operate on.
     * @param {arguments} varargs The rest of DOM nodes to operate on.
     * @returns {Node} The common ancestor of the supplied Nodes.
     * @exception TP.sig.InvalidNode Raised when the first node provided to the
     *     method is invalid.
     * @exception TP.sig.InvalidParameter Raised when no more nodes are supplied
     *     to the method.
     */

    var i,
        nodes,

        startNode;

    if (!TP.isNode(firstNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (TP.notValid(varargs)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    nodes = Array.prototype.slice.call(arguments, 1);

    startNode = firstNode;

    rocking:
        /* eslint-disable no-extra-parens */
        while ((startNode = startNode.parentNode)) {
        /* eslint-enable no-extra-parens */
            i = nodes.length;
            while (i--) {
                if ((startNode.compareDocumentPosition(nodes[i]) & 0x0010) !==
                                                                    0x0010) {
                    continue rocking;
                }
            }
            return startNode;
        }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetChildNodes',
function(aNode) {

    /**
     * @method nodeGetChildNodes
     * @summary Returns an Array of the child nodes of the provided node.
     * @param {Node} aNode The DOM node to operate on.
     * @example Get all of the child nodes of an XML element:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo><bar/>Some text<baz/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetChildNodes(xmlDoc.documentElement);
     *          <samp>[object Element], [object Text], [object Element]</samp>
     *     </code>
     * @example Get all of the child nodes of an HTML element:
     *     <code>
     *          TP.nodeGetChildNodes(document.documentElement);
     *          <samp>[object HTMLHeadElement], [object HTMLBodyElement]</samp>
     *     </code>
     * @returns {Node[]} An Array of the child nodes of the supplied Node.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     */

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    //  NOTE the conversion to array here
    return TP.ac(aNode.childNodes);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetChildNodesByType',
function(aNode, aType, breadthFirst) {

    /**
     * @method nodeGetChildNodesByType
     * @summary Returns an Array of all child nodes of the provided node whose
     *     node type matches the type provided.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Number} aType The DOM node type constant to match against.
     * @param {Boolean} breadthFirst Breadth first if true. Default is false,
     *     meaning depth first.
     * @returns {Node[]} An Array containing the nodes found.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidParameter Raised when an invalid node type is
     *     provided to the method.
     */

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (TP.notValid(aType)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    return TP.nodeSelectChildNodes(
                aNode,
                function(childNode) {
                    return childNode.nodeType === aType;
                });
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetChildElementAt',
function(aNode, anIndex) {

    /**
     * @method nodeGetChildElementAt
     * @summary Returns the child element of aNode at the index provided, if
     *     such a child exists. Note that the index provided is used relative to
     *     children which are Element nodes only.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Number|Constant} anIndex The index in question, either a number
     *     or the constant TP.FIRST or TP.LAST.
     * @example Get the second child *element* node of an XML element:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo><bar/>Some text<baz/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          secondElement = TP.nodeGetChildElementAt(
     *          xmlDoc.documentElement, 1);
     *          <samp>[object Element]</samp>
     *          TP.nodeAsString(secondElement);
     *          <samp>&lt;baz&gt;&lt;/baz&gt;</samp>
     *     </code>
     * @example Get the first child *element* node of an HTML element:
     *     <code>
     *          firstElement = TP.nodeGetChildElementAt(
     *          TP.documentGetBody(document), 0);
     *          <samp>[object HTMLDivElement] (or the first child element of the
     *         body in the current document)</samp>
     *          TP.nodeAsString(firstElement);
     *          <samp>(html output of the first element of the body)</samp>
     *     </code>
     * @returns {Element} The child element of the supplied Node at the supplied
     *     index.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidParameter Raised when an invalid index is
     *     provided to the method.
     */

    var children,
        len,

        count,

        i,
        ind,
        node;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (TP.notValid(anIndex)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  trim out extra overhead on IE (and browsers that implement the
    //  ElementTraversal specification) by using children array if available
    children = TP.nodeGetChildElements(aNode);

    len = children.length;
    count = 0;

    for (i = 0; i < len; i++) {
        ind = anIndex === TP.LAST ? len - i - 1 : i;
        node = children[ind];

        try {
            if (TP.isElement(node)) {
                switch (anIndex) {
                    //  note that because of our ind[ex] adjustment above
                    //  the logic is is the same, first element is what we
                    //  want
                    case 0:
                    case TP.FIRST:
                    case TP.LAST:
                        if (count === 0) {
                            return node;
                        }
                        break;

                    default:
                        if (count === anIndex) {
                            return node;
                        }
                        break;
                }

                count++;
            }
        } catch (e) {
            TP.ifError() ?
                TP.error(
                    TP.ec(e, 'Error retrieving child element at: ' + ind)) : 0;
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetChildElements',
function(aNode) {

    /**
     * @method nodeGetChildElements
     * @summary Returns an Array of the child elements of the provided node.
     * @description No normalization of text node children is done in this
     *     process since we're only looking for element nodes.
     * @param {Node} aNode The DOM node to operate on.
     * @example Get all of the child *element* nodes of an XML element:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo><bar/>Some text<baz/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetChildElements(xmlDoc.documentElement);
     *          <samp>[object Element], [object Element]</samp>
     *     </code>
     * @example Get all of the child *element* nodes of an HTML element:
     *     <code>
     *          TP.nodeGetChildElements(TP.documentGetBody(document));
     *          <samp>[object HTMLDivElement] (or the first child element of the
     *         body in the current document)</samp>
     *     </code>
     * @returns {Element[]} An Array of the Element children of the supplied
     *     Node.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     */

    var arr,
        nodes,
        len,

        i,

        node;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    //  In IE (and browsers that implement the Element Traversal
    //  specification), HTML elements have a convenience property called
    //  'children' that contains *only elements*, not all child nodes as the
    //  W3C property 'childNodes' does (and therefore doesn't require the
    //  looping behavior below).
    if (TP.isValid(aNode.children)) {
        return TP.ac(aNode.children);
    }

    arr = TP.ac();
    nodes = aNode.childNodes;
    len = nodes.length;

    for (i = 0; i < len; i++) {
        node = nodes[i];

        try {
            if (TP.isElement(node)) {
                arr.push(node);
            }
        } catch (e) {
            TP.ifError() ?
                TP.error(
                    TP.ec(e, 'Error retrieving child elements')) : 0;
        }
    }

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetDescendants',
function(aNode, breadthFirst) {

    /**
     * @method nodeGetDescendants
     * @summary Returns an Array of the children, grandchildren, and so on of
     *     the node provided.
     * @description Note that the nodes acquired as descendants are normalized
     *     to coalesce text children as part of this method. Also note that for
     *     a variety of reasons the return values from this call are not likely
     *     to be identical across browsers due to differences in handling
     *     whitespace, comments, processing instructions, etc.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Boolean} breadthFirst Breadth first if true. Default is false,
     *     meaning depth first.
     * @example Get all of the descendant nodes of an XML element:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo><bar>Some text</bar><baz><underbaz/></baz></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetDescendants(xmlDoc);
     *          <samp>[object Element], [object Element], [object Text], [object
     *         Element], [object Element]</samp>
     *          // Do the same process, but return the results
     *          // 'breadth first'.
     *          TP.nodeGetDescendants(xmlDoc, true);
     *          <samp>[object Element], [object Element], [object Element],
     *         [object Text], [object Element]</samp>
     *     </code>
     * @example Get all of the descendant nodes of an HTML element:
     *     <code>
     *          TP.nodeGetDescendants(TP.documentGetBody(document));
     *          <samp>(descendant nodes of the body element in depth-first
     *         traversal order)</samp>
     *          // Do the same process, but return the results
     *          // 'breadth first'.
     *          TP.nodeGetDescendants(xmlDoc, true);
     *          <samp>(descendant nodes of the body element in breadth-first
     *         traversal order)</samp>
     *     </code>
     * @returns {Node[]} An Array containing the nodes found.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     */

    var arr,
        func,

        doc,
        walker;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    arr = TP.ac();
    func = function(node) {
        arr.push(node);
    };

    if (TP.isTrue(breadthFirst)) {
        TP.nodeBreadthTraversal(aNode, func, null, func, false);
    } else {
        doc = TP.nodeGetDocument(aNode);

        //  Create a TreeWalker that looks for CDATA sections, comments,
        //  text nodes (basically, what the DOM calls 'CharacterData') and
        //  elements.
        walker = doc.createTreeWalker(
                    aNode,
                    NodeFilter.SHOW_CDATA_SECTION |
                        NodeFilter.SHOW_COMMENT |
                        NodeFilter.SHOW_TEXT |
                        NodeFilter.SHOW_ELEMENT,
                    null,
                    false);

        //  Iterate and push the resultant nodes.
        while (walker.nextNode()) {
            arr.push(walker.currentNode);
        }
    }

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetDescendantAt',
function(aNode, aPath) {

    /**
     * @method nodeGetDescendantAt
     * @summary Returns a descendant Element given a '.' separated 'path' of
     *     element indicies for each 'level'.
     * @description No normalization of text node children is done in this
     *     process since we're only looking for element nodes.
     * @param {Node} aNode The DOM node to operate on.
     * @example Get the descendant element node at address 0.1 (the 'baz'
     *     element):
     *     <code>
     *          xmlDoc = TP.nodeGetDescendantElementAt(
     *              TP.documentFromString('<foo><bar/>Some text<baz/></foo>'));
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetDescendantAt(xmlDoc.documentElement, '0.1');
     *          <samp>[object Element]</samp>
     *     </code>
     * @returns {Element|null} The element at the address or null.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidParameter Raised when an invalid or empty 'path'
     *     is provided to the method.
     */

    var children,

        node,

        address,

        len,

        i,
        index;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    //  make sure we have a non-empty path
    if (TP.isEmpty(aPath)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    node = aNode;

    //  Split the address and iterate.

    address = aPath.split('.');

    len = address.getSize();
    for (i = 0; i < len; i++) {

        //  Grab only the child *elements*
        children = TP.nodeGetChildElements(node);

        try {
            index = parseInt(address.at(i), 10);
            node = children[index];

            if (!TP.isElement(node)) {
                return null;
            }

        } catch (e) {
            TP.ifError() ?
                TP.error(
                    TP.ec(
                        e, 'Error retrieving child element at: ' + index)) : 0;
        }
    }

    return node;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetDescendantsByType',
function(aNode, aType, breadthFirst) {

    /**
     * @method nodeGetDescendantsByType
     * @summary Returns an Array of all descendants of the provided node whose
     *     node type matches the type provided.
     * @description Note that node content is normalized before returning this
     *     list so that child text nodes are coalesced for consistency.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Number} aType The DOM node type constant to match against.
     * @param {Boolean} breadthFirst Breadth first if true. Default is false,
     *     meaning depth first.
     * @example Get all of the descendant Text nodes of an XML element:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo><bar>Some text<goo>More
     *         text</goo></bar>Yet more text</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          result = TP.nodeGetDescendantsByType(xmlDoc, Node.TEXT_NODE);
     *          <samp>[object Text], [object Text], [object Text]</samp>
     *          // Get the string value of each node to see what we
     *          // have.
     *          result.collect(function(aNode) {return TP.str(aNode)});
     *          <samp>Some text, More text, Yet more text</samp>
     *          // Do the same process, but return the results
     *          // 'breadth first'.
     *          result = TP.nodeGetDescendantsByType(xmlDoc,
     *          Node.TEXT_NODE,
     *          true);
     *          <samp>[object Text], [object Text], [object Text]</samp>
     *          // Get the string value of each node to see what we
     *          // have.
     *          result.collect(function(aNode) {return TP.str(aNode)});
     *          <samp>Yet more text, Some text, More text</samp>
     *     </code>
     * @example Get all of the descendant Text nodes of an HTML element:
     *     <code>
     *          TP.nodeGetDescendantsByType(
     *          TP.documentGetBody(document),
     *          Node.TEXT_NODE);
     *          <samp>(descendant text nodes of the body element in depth-first
     *         traversal order)</samp>
     *          // Do the same process, but return the results
     *          // 'breadth first'.
     *          TP.nodeGetDescendantsByType(
     *          TP.documentGetBody(document),
     *          Node.TEXT_NODE,
     *          true);
     *          <samp>(descendant text nodes of the body element in
     *         breadth-first traversal order)</samp>
     *     </code>
     * @returns {Node[]} An Array containing the nodes found.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidParameter Raised when an invalid node type is
     *     provided to the method.
     */

    var arr,
        func;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (TP.notValid(aType)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    arr = TP.ac();
    func = function(node) {

        if (node.nodeType === aType) {
            arr.push(node);
        }
    };

    if (TP.isTrue(breadthFirst)) {
        TP.nodeBreadthTraversal(aNode, func, null, func, false);
    } else {
        TP.nodeDepthTraversal(aNode, func, null, func, false);
    }

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetDescendantElements',
function(aNode, breadthFirst) {

    /**
     * @method nodeGetDescendantElements
     * @summary Returns an Array of the children, grandchildren, and so on of
     *     the node provided which are Element nodes.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Boolean} breadthFirst Breadth first if true. Default is false,
     *     meaning depth first (which is document order).
     * @example Get all of the Element nodes under the supplied Node as a
     *     regular JavaScript Array:
     *     <code>
     *          TP.nodeGetDescendantElements(document);
     *          <samp>...Array...</samp>
     *          TP.nodeGetDescendantElements(document, true);
     *          <samp>...Array sorted by 'breadth-first'...</samp>
     *     </code>
     * @returns {Element[]} An Array of the Element descendants of the supplied
     *     Node.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     */

    //  no child nodes for anything that isn't an element, document or document
    //  fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this,
                        'TP.sig.InvalidNode',
                        'Node not a collection Node.');
    }

    //  DOM-compliant document and element nodes can do this faster natively
    //  since depth first is how their lookups work
    if (TP.notTrue(breadthFirst) && !TP.isFragment(aNode)) {
        //  Note how we convert the NodeList into an Array to hand back the
        //  proper type. No additional processing is needed here.
        return TP.ac(aNode.getElementsByTagName('*'));
    }

    //  for breadth first (or fragment nodes) we've got to use alternative
    //  iteration
    return TP.nodeGetDescendantsByType(aNode, Node.ELEMENT_NODE, breadthFirst);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetDescendantElementsByAttribute',
function(aNode, attrName, attrValue, breadthFirst) {

    /**
     * @method nodeGetDescendantElementsByAttribute
     * @summary Returns an Array containing descendants of the node provided
     *     which are Element nodes and which contain an attribute name/value
     *     matching the value provided.
     * @description If the supplied attribute value is null, this method will
     *     return Element nodes that have any value for the named attribute, no
     *     matter its value.
     * @param {Node} aNode The DOM node to operate on.
     * @param {String} attrName The attribute to test for.
     * @param {Object} attrValue The attribute value to check.
     * @param {Boolean} breadthFirst Breadth first if true. Default is false,
     *     meaning depth first.
     * @example Retrieve all of the XML elements where the 'goo' attribute
     *     exists with a particular value:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo goo="moo"><bar
     *         goo="gar"><baz/></bar></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          // Grab an Array of elements where 'goo' equals 'moo'
     *          TP.nodeGetDescendantElementsByAttribute(xmlDoc, 'goo', 'moo');
     *          <samp>[object Element]</samp>
     *     </code>
     * @example Retrieve all of the XML elements where the 'goo' attribute
     *     exists but with no particular value:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo goo="moo"><bar
     *         goo="gar"><baz/></bar></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetDescendantElementsByAttribute(xmlDoc, 'goo');
     *          <samp>[object Element], [object Element]</samp>
     *     </code>
     * @example Retrieve all of the HTML elements where the 'style' attribute
     *     exists but with no particular value:
     *     <code>
     *         TP.nodeGetDescendantElementsByAttribute(TP.documentGetBody(document),
     *          'style');
     *          <samp>(descendant element nodes of the body element that have a
     *         'style' attribute)</samp>
     *     </code>
     * @returns {Node[]} An Array containing the nodes found.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidName Raised when an invalid attribute name is
     *     provided to the method.
     */

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (TP.isEmpty(attrName)) {
        return TP.raise(this, 'TP.sig.InvalidName');
    }

    return TP.nodeSelectDescendantElements(
        aNode,
        function(node) {

            var re,
                attrs,
                len,
                i;

            //  We put try...catch around this because IE will sometimes
            //  throw exceptions...
            try {
                if (TP.regex.IS_NAMEXP.test(attrName)) {
                    re = TP.getQNameRegex(attrName);

                    attrs = node.attributes;
                    len = attrs.length;

                    for (i = 0; i < len; i++) {
                        //  find the name
                        if (re.test(attrs[i].name)) {
                            //  check the value as needed
                            if (TP.isValid(attrValue)) {
                                if (!TP.match(attrValue, attrs[i].value)) {
                                    continue;
                                }
                            }

                            return true;
                        }
                    }
                } else {
                    //  without a value we can go by existence alone which
                    //  should be a little faster
                    if (TP.notValid(attrValue)) {
                        if (TP.elementHasAttribute(node, attrName)) {
                            return true;
                        }
                    } else if (TP.match(
                                attrValue,
                                TP.elementGetAttribute(node, attrName))) {
                        return true;
                    }
                }
            } catch (e) {
                TP.ifError() ?
                    TP.error(
                        TP.ec(e, 'Error getting descendant elements' +
                                    ' by attribute: ' + attrName)) : 0;
            }

            return false;
        },
        null,
        breadthFirst);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetDescendantElementsByAttributePrefix',
function(aNode, attrPrefix, attrValue, breadthFirst) {

    /**
     * @method nodeGetDescendantElementsByAttributePrefix
     * @summary Returns an Array of the children, grandchildren, and so on of
     *     the node provided which are Element nodes and which contain at least
     *     one attribute whose name is prefixed with the supplied prefix and
     *     whose value matches the supplied value.
     * @description If the supplied attribute value is null, this method will
     *     return Element nodes that have any value for the named attribute, no
     *     matter its value.
     * @param {Node} aNode The DOM node to operate on.
     * @param {String} attrPrefix The prefix string to test for.
     * @param {Object} attrValue The attribute value to check.
     * @param {Boolean} breadthFirst Breadth first if true. Default is false,
     *     meaning depth first.
     * @example Retrieve all of the XML elements where an 'xf:'-prefixed
     *     attribute exists with a particular value:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"
     *         xmlns:xf="http://www.w3.org/2002/xforms" xf:bind="theBinder"><bar
     *         xf:goo="moo">Hi there</bar></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetDescendantElementsByAttributePrefix(xmlDoc,
     *          'xf',
     *          'theBinder');
     *          <samp>[object Element]</samp>
     *     </code>
     * @example Retrieve all of the XML elements where an 'xf:'-prefixed
     *     attribute exists with no particular value:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"
     *         xmlns:xf="http://www.w3.org/2002/xforms" xf:bind="theBinder"><bar
     *         xf:goo="moo">Hi there</bar></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetDescendantElementsByAttributePrefix(xmlDoc, 'xf');
     *          <samp>[object Element], [object Element]</samp>
     *     </code>
     * @returns {Node[]} An Array containing the nodes found.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidName Raised when an invalid attribute prefix is
     *     provided to the method.
     */

    var prefix;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (TP.isEmpty(attrPrefix)) {
        return TP.raise(this, 'TP.sig.InvalidName');
    }

    prefix = attrPrefix.endsWith(':') ? attrPrefix : attrPrefix + ':';

    return TP.nodeSelectDescendantElements(
        aNode,
        function(node) {

            var attrs,
                len,
                i;

            //  We put try...catch around this because IE will sometimes
            //  throw exceptions...
            try {
                attrs = node.attributes;
                len = attrs.length;

                for (i = 0; i < len; i++) {
                    //  If we find that prefix within the attribute name
                    if (attrs[i].name.indexOf(prefix) !== TP.NOT_FOUND) {
                        //  If we've been given a valid attrValue to test,
                        //  then we only return true if that value matches
                        //  the actual attribute value.
                        if (TP.isValid(attrValue)) {
                            if (!TP.match(attrValue, attrs[i].value)) {
                                continue;
                            }
                        }

                        return true;
                    }
                }
            } catch (e) {
                TP.ifError() ?
                    TP.error(
                        TP.ec(e, 'Error getting descendant elements' +
                                    ' by attribute prefix: ' + attrPrefix)) : 0;
            }

            return false;
        },
        null,
        breadthFirst);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetDescendantElementsByIdOrName',
function(aNode, anIdOrName) {

    /**
     * @method nodeGetDescendantElementsByIdOrName
     * @summary Returns any elements that can be found which have either the ID
     *     or name provided.
     * @description For HTML documents where radio buttons often use the 'name'
     *     attribute as an identifier rather than 'id' we need a way to query
     *     the document for elements matching an identifier which might be
     *     either a name or id value.
     *
     *     This method gives preference to elements with 'id' values. Only if
     *     no elements can be found with an 'id' having the value given will it
     *     then search for elements with a matching name value. Since this
     *     method is an "Or" rather than "And" it has the effect of discouraging
     *     markup which uses a value for the 'id' attribute as the value for the
     *     'name' attribute for non-radio elements.
     *
     *     NOTE: Since this function is used during event arming that means
     *     elements with a name value that overlap with an ID cannot be armed
     *     using normal mechanisms.
     * @param {Node} aNode The DOM node to operate on.
     * @param {String} anIdOrName The ID or name of the element to find.
     * @example Retrieve all of the XML elements where the 'id' or 'name'
     *     attribute has a particular value (note how precedence is given to
     *     'id'):
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo id="foo"><bar name="foo">Hi there</bar></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetDescendantElementsByIdOrName(xmlDoc, 'foo');
     *          <samp>[object Element]</samp>
     *     </code>
     * @example Retrieve all of the XML elements where the 'id' or 'name'
     *     attribute has a particular value (multiples will be returned if the
     *     attribute is 'name'):
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo name="foo"><bar name="foo">Hi there</bar></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetDescendantElementsByIdOrName(xmlDoc, 'foo');
     *          <samp>[object Element], [object Element]</samp>
     *     </code>
     * @returns {Element[]} The elements whose name is equal to anIdOrName or
     *     empty if there are no objects with that name.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidName Raised when an empty ID or name is provided
     *     to the method.
     */

    var elem,
        result;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    //  if we can find the element by ID we're done
    if (TP.isElement(elem = TP.nodeGetElementById(aNode, anIdOrName))) {
        //  Note here how we construct this Array and push the singular
        //  Element onto it, rather than using our convenience syntax of
        //  handing the Element directly to the Array constructor. This is
        //  to avoid situations where the Element (like (X)HTML 'select'
        //  elements) actually have a 'length' property and then we actually
        //  get an Array of the 'option' Elements (in that case) back,
        //  rather than the Element as the sole item in the Array.
        result = TP.ac();
        result.push(elem);

        return result;
    }

    //  default to the name attribute search
    return TP.nodeGetDescendantElementsByName(aNode, anIdOrName);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetDescendantElementsByName',
function(aNode, aName) {

    /**
     * @method nodeGetDescendantElementsByName
     * @summary Returns an Array containing any descendants of the node
     *     provided which are Element nodes and whose name attributes match the
     *     name provided.
     * @description When the supplied node is an HTML document this will use the
     *     native call, otherwise it defers to using a manual search via the
     *     name attribute.
     * @param {Node} aNode The DOM node to operate on.
     * @param {String} aName The name value to search for.
     * @example Retrieve all of the XML elements where the 'name' attribute has
     *     a particular value:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo id="foo"><bar name="foo">Hi there</bar></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetDescendantElementsByName(xmlDoc, 'foo');
     *          <samp>[object Element]</samp>
     *     </code>
     * @example Retrieve all of the XML elements where the 'name' attribute has
     *     a particular value (multiples will be returned if the attribute is
     *     'name'):
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo name="foo"><bar name="foo">Hi there</bar></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetDescendantElementsByName(xmlDoc, 'foo');
     *          <samp>[object Element], [object Element]</samp>
     *     </code>
     * @returns {Element[]} An Array containing the elements found.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     * @exception TP.sig.InvalidName Raised when an empty name is provided to
     *     the method.
     */

    //  when the node is a native HTML document we can use the native
    //  call
    if (TP.isHTMLDocument(aNode)) {
        if (!TP.isNode(aNode)) {
            return TP.raise(this, 'TP.sig.InvalidNode');
        }

        if (TP.isEmpty(aName)) {
            return TP.raise(this, 'TP.sig.InvalidName');
        }

        return aNode.getElementsByName(aName);
    }

    return TP.nodeGetDescendantElementsByAttribute(aNode, 'name', aName);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetDocument',
function(aNode) {

    /**
     * @method nodeGetDocument
     * @summary Returns the document node containing the node provided. If the
     *     node provided is a Document node, this function will return the node
     *     provided.
     * @param {Node} aNode The DOM node to operate on.
     * @example Get the document of an element in an XML document:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns:bar="http://www.bar.com"/>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetDocument(xmlDoc.documentElement) === xmlDoc;
     *          <samp>true</samp>
     *     </code>
     * @example Get the document of an element in an HTML document:
     *     <code>
     *          TP.nodeGetDocument(TP.documentGetBody(document)) ===
     *         document;
     *          <samp>true</samp>
     *     </code>
     * @returns {Document} The document containing the supplied Node.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     */

    var doc,
        ancestor;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (aNode.nodeType === Node.DOCUMENT_NODE) {
        return aNode;
    }

    if (TP.isDocument(doc = aNode.ownerDocument)) {
        return doc;
    }

    //  NOTE thanks to a bug in early versions of Mozilla when you work with
    //  cloned documents the child elements can get detached from their
    //  ownerDocument pointers...so we iterate just in case.
    ancestor = aNode.parentNode;
    while (TP.isElement(ancestor)) {
        //  NB: This assignment should *not* be moved into the looping logic. We
        //  want 'ancestor' to remain what it is if its parent node is null.
        //  This means it is the document itself and we want to use it below.
        ancestor = ancestor.parentNode;
    }

    if (TP.isElement(ancestor)) {
        return ancestor.ownerDocument;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetElementById',
function(aNode, anID, retryWithPath) {

    /**
     * @method nodeGetElementById
     * @summary Returns the subelement of the node provided which has the ID
     *     given. This is a wrapper for ID retrieval using the standard
     *     getElementById() call which deals with problems across XML and HTML
     *     DOM trees between W3C-compliant browsers and IE. Note that the ID
     *     will have ":" translated to "_" to support NS-qualified IDs.
     * @description For HTML documents the standard getElementById call is often
     *     sufficient, however XML documents will vary on W3C-compliant browsers
     *     based on the namespace and whether there's an internal DTD that
     *     defines IDREF attributes for that document. Many of TIBET's external
     *     files are maintained in augmented XHTML files with these internal
     *     DTDs so an XPath fallback is just extra overhead since if the ID
     *     existed it would have been found. The $retryWithXPath attribute is
     *     therefore used internally by metadata-related searches to avoid this
     *     overhead. In non-XHTML XML documents this function will return null
     *     if the element with id anID is not either the supplied node or a
     *     child of the supplied node.
     * @param {Node} aNode The node to search.
     * @param {String} anID The string ID to search for.
     * @param {Boolean} retryWithPath False to force ID search to skip 'path
     *     query' fallbacks.
     * @example Get the element in an XML document with 'id' of 'bar':
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo id="bar"/>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetElementById(xmlDoc, 'bar');
     *          <samp>[object Element]</samp>
     *     </code>
     * @example Get the element in an HTML document with 'id' of 'bar':
     *     <code>
     *          TP.documentGetBody(document).setAttribute('id', 'myBody');
     *          <samp>undefined</samp>
     *          TP.nodeGetElementById(document, 'myBody');
     *          <samp>[object HTMLBodyElement]</samp>
     *     </code>
     * @returns {Element} A native element, if one is found.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidID Raised when a null or empty ID is provided to
     *     the method.
     */

    var doc,
        id,

        realID,
        result;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    //  ID has to be a valid IDREF, but we're not going to be that
    //  strict
    if (TP.isEmpty(anID)) {
        return TP.raise(this, 'TP.sig.InvalidID');
    }

    //  best case we're looking for an ID in an HTML document
    if (TP.notValid(doc = TP.nodeGetDocument(aNode))) {
        return null;
    }

    //  one special case is the id #document, which refers to the
    //  document element of a document. you can't find this by normal
    //  query
    if (anID === '#document') {
        return doc.documentElement;
    }

    //  empty document? no location
    if (TP.notValid(doc.documentElement)) {
        return;
    }

    id = anID.strip(TP.regex.BARENAME);

    //  for HTML documents the native getElementById() is sufficient
    if (TP.isHTMLDocument(doc)) {
        return doc.getElementById(id);
    }

    //  NOTE: ID replacement required to avoid problems with common ID
    //  content such as NS-qualified elements like type names. The XML
    //  spec says that we're limited to: [a-zA-Z_][a-zA-Z0-9.-_]*
    TP.regex.ID_HAS_NS.lastIndex = 0;
    realID = id.replace(TP.regex.ID_HAS_NS, '_');

    //  If we still couldn't produce a valid IDREF, then return null
    TP.regex.INVALID_ID_CHARS.lastIndex = 0;
    if (TP.regex.INVALID_ID_CHARS.test(realID)) {
        return null;
    }

    //  If its an XHTML document, getElementById() may work in
    //  W3C-compliant browsers. We leverage this fact around common XML
    //  metadata in Gecko and Webkit
    if (TP.canInvoke(doc, 'getElementById')) {

        /* eslint-disable no-extra-parens */
        if ((result = doc.getElementById(realID))) {
            return result;
        }
        /* eslint-enable no-extra-parens */
    }

    //  we force retry to false on our metadata XHTML files so we don't
    //  search for something we're not going to find
    if (TP.notFalse(retryWithPath)) {

        //  Otherwise, its XML that's not XHTML, so getElementById() won't work
        //  (sigh...), but modern browsers actually support querySelector() on
        //  XML nodes.
        result = aNode.querySelector('*[id="' + realID + '"]');
    }

    return result;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetElementsByTagName',
function(aNode, aTagName, aNamespaceURI) {

    /**
     * @method nodeGetElementsByTagName
     * @summary Returns an Array containing any descendant elements of the
     *     supplied node whose tag names match the name provided. Note that this
     *     function can deal properly with namespace-qualified tag names across
     *     platforms.
     * @description This function can handle finding elements in the following
     *     situations where the standard 'getElementsByTagName()' call fails: 1)
     *     When elements are in the default namespace in an XML document, the
     *     standard is to *not* return them, but to instead force the programmer
     *     to use getElementsByTagNameNS() (and thereby forcing the caller to
     *     know the default namespace URI). Not only is this extremely
     *     inconvenient, it is inconsistent between the two major browsers.
     *     Mozilla ignores the standard and returns elements in the default
     *     namespace anyway. IE follows the spec here and won't return them, but
     *     doesn't supply the getElementsByTagNameNS() call, forcing the
     *     programmer to use an XPath. 2) When elements are in prefixed
     *     namespaces, the standard call works completely inverted between the
     *     two browsers. If the prefix is included as part of the supplied tag
     *     name, IE will find the elements but Mozilla will not. If the prefix
     *     is not included as part of the supplied tag name, IE will not find
     *     the elements but Mozilla will. 3) When a prefix happens to be used by
     *     two different namespaces (unlikely but possible), it is not possible
     *     to ask for a 'union' of all of the elements with a particular prefix,
     *     no matter what namespace they're associated with.
     *     getElementsByTagNameNS() discriminates based on namespaceURI, not
     *     prefix, and it doesn't exist on IE anyway. 4) In HTML documents, IE
     *     will return comment nodes when the '*' wildcard is used, even though
     *     they're not nodes of type Node.ELEMENT_NODE.
     * @param {Node} aNode The DOM node to operate on.
     * @param {String} aTagName The string tag name to search for.
     * @param {String} aNamespaceURI The namespace URI to search for.
     * @example Find all elements in all namespaces under an XML document:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"
     *         xmlns:xf="http://www.w3.org/2002/xforms"><xf:bar>Hi
     *         there</xf:bar><baz>Hi there again<xf:foo>More
     *         hi!</xf:foo></baz></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetElementsByTagName(xmlDoc, '*');
     *          <samp>[object Element], [object Element], [object
     *         Element]</samp>
     *     </code>
     * @example Find all elements named 'foo' under an XML document, no matter
     *     what namespace they're in (even a default namespace):
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"
     *         xmlns:xf="http://www.w3.org/2002/xforms"><xf:bar>Hi
     *         there</xf:bar><baz>Hi there again<xf:foo>More
     *         hi!</xf:foo></baz></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetElementsByTagName(xmlDoc, 'foo');
     *          <samp>[object Element], [object Element]</samp>
     *     </code>
     * @example Find all elements under an XML document, but only if they're in
     *     the 'http://www.foo.com' namespace (even if 'http://www.foo.com' is
     *     used as a default namespace in one place and as a prefixed namespace
     *     in another):
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"
     *         xmlns:xf="http://www.w3.org/2002/xforms"><xf:bar>Hi
     *         there</xf:bar><baz>Hi there again<xf:foo>More
     *         hi!</xf:foo></baz></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetElementsByTagName(xmlDoc,
     *          '*',
     *          'http://www.foo.com');
     *          <samp>[object Element], [object Element]</samp>
     *     </code>
     * @example Find all elements named 'xf:bar' under an XML document, no
     *     matter what namespace they're in (even a default namespace) and no
     *     matter what namespace URI the 'xf' prefix is an alias for (even if
     *     its an alias for multiple namespaces):
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"
     *         xmlns:xf="http://www.w3.org/2002/xforms"><xf:bar>Hi
     *         there</xf:bar><baz>Hi there again<xf:foo>More
     *         hi!</xf:foo></baz></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetElementsByTagName(xmlDoc, 'xf:bar');
     *          <samp>[object Element]</samp>
     *     </code>
     * @example Find all elements named 'foo' under an XML document, but only if
     *     they're in the 'http://www.w3.org/2002/xforms' namespace (even if
     *     'http://www.w3.org/2002/xforms' is used as a default namespace in one
     *     place and as a prefixed namespace in another):
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"
     *         xmlns:xf="http://www.w3.org/2002/xforms"><xf:bar>Hi
     *         there</xf:bar><baz>Hi there again<xf:foo>More
     *         hi!</xf:foo></baz></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetElementsByTagName(
     *          xmlDoc,
     *          'foo',
     *          'http://www.w3.org/2002/xforms');
     *          <samp>[object Element]</samp>
     *     </code>
     * @example Find all elements named 'xf:bar' under an XML document, but only
     *     if they're in the 'http://www.w3.org/2002/xforms' namespace. Note
     *     this will *not* find elements named just 'bar' (i.e. where
     *     'http://w3.org/2002/xforms' is the default namespace) nor will will
     *     it find elements whose name is 'xf:bar' where 'xf' is aliased to a
     *     different namespace than 'http://www.w3.org/2002/xforms':
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"
     *         xmlns:xf="http://www.w3.org/2002/xforms"><xf:bar>Hi
     *         there</xf:bar><baz>Hi there again<xf:foo>More
     *         hi!</xf:foo></baz></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetElementsByTagName(
     *          xmlDoc,
     *          'xf:bar',
     *          'http://www.w3.org/2002/xforms');
     *          <samp>[object Element]</samp>
     *     </code>
     * @returns {Element[]} An Array containing native elements found.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidName Raised when an invalid tag name is provided
     *     to the method.
     */

    var path,
        func,
        matcher;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (TP.isEmpty(aTagName)) {
        return TP.raise(this, 'TP.sig.InvalidName',
                                        'Invalid or empty tag name');
    }

    //  If we're not dealing with an XML document, then we need to return
    //  whatever the native call will do (XPaths won't work on non-XML
    //  documents such as IE's HTML DOM).
    if (!TP.isXMLDocument(TP.nodeGetDocument(aNode))) {
        //  If name is '*', then we use our TP.nodeGetDescendantElements()
        //  call, since on IE it properly filters out COMMENT_NODEs which
        //  getElementsByTagName('*') puts in.
        if (aTagName === '*' || aTagName === '*:*') {
            return TP.nodeGetDescendantElements(aNode, false);
        }

        //  as long as we're not trying to wildcard the name we can use the
        //  builtin call to do the work
        if (TP.isString(aTagName) &&
            !TP.regex.IS_NAMEXP.test(aTagName) &&
            !TP.isFragment(aNode)) {
            //  Note how we convert the NodeList into an Array to hand back
            //  the proper type.
            return TP.ac(aNode.getElementsByTagName(aTagName));
        }

        matcher = TP.getQNameRegex(aTagName);
        func = function(node) {

                    //  NOTE that since we're in HTML here we ignore the
                    //  namespace URI question
            if (matcher.test(TP.qname(node))) {
                return true;
            }
        };

        return TP.nodeSelectDescendantElements(aNode, func);
    }

    //  If we're being asked for '*', then that's all elements no matter
    //  what. Therefore, the XPath is simple and we don't need to take
    //  anything else into account.
    if (aTagName === '*' || aTagName === '*:*') {
        if (TP.notEmpty(aNamespaceURI)) {
            return TP.nodeEvaluateXPath(
                        aNode,
                        'descendant-or-self::*[namespace-uri() = "' +
                            aNamespaceURI + '"]',
                        TP.NODESET);
        }

        return TP.nodeGetDescendantElements(aNode, false);
    }

    //  can't process wildcarded names via xpath so do them here
    if (TP.isArray(aTagName) || TP.regex.IS_NAMEXP.test(aTagName)) {
        matcher = TP.getQNameRegex(aTagName);
        func = function(node) {

            if (matcher.test(TP.qname(node))) {
                if (TP.isString(aNamespaceURI)) {
                    if (TP.nodeGetNSURI(node) !== aNamespaceURI) {
                        return false;
                    }
                }
                return true;
            }
        };

        return TP.nodeSelectDescendantElements(aNode, func);
    }

    //  last option is that we're doing a normal tagname with optional
    //  namespace URI specification, which seems faster via XPath
    TP.regex.ID_HAS_NS.lastIndex = 0;
    if (TP.regex.ID_HAS_NS.test(aTagName)) {
        path = 'descendant-or-self::*[name() = "' + aTagName + '"';
    } else {
        path = 'descendant-or-self::*[local-name() = "' + aTagName + '"';
    }

    if (TP.notEmpty(aNamespaceURI)) {
        path += ' and namespace-uri() = "' + aNamespaceURI + '"';
    }

    path += ']';

    return TP.nodeEvaluateXPath(aNode, path, TP.NODESET);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetFirstAncestorByAttribute',
function(aNode, attrName, attrValue, checkAttrNSURI) {

    /**
     * @method nodeGetFirstAncestorByAttribute
     * @summary Returns the first element ancestor of aNode which has an
     *     attribute matching attrName and whose value matches the optional
     *     attrValue provided.
     * @description This is a commonly used method in widget construction where
     *     an inner element is looking outward for its containing widget or
     *     control, often during event dispatch.
     * @param {Node} aNode The DOM node to operate on.
     * @param {String} attrName The attribute to test for.
     * @param {Object} attrValue The optional attribute value to check.
     * @param {Boolean} [checkAttrNSURI=false] True will cause this method to be
     *     more rigorous in its checks for prefixed attributes, looking via
     *     internal TIBET mechanisms in addition to the standard platform
     *     mechanism. The default is false (to keep things faster).
     * @example TODO:
     * @returns {Element} An element ancestor of the node.
     * @exception TP.sig.InvalidParameter Raised when a node that isn't of type
     *     Node.ELEMENT_NODE or Node.DOCUMENT_NODE is provided to the method.
     * @exception TP.sig.InvalidName Raised when the supplied attribute name is
     *     empty.
     */

    if (TP.isEmpty(attrName)) {
        return TP.raise(this, 'TP.sig.InvalidName');
    }

    return TP.nodeDetectAncestor(
            aNode,
            function(elem) {

                var re,
                    attrs,
                    len,
                    i;

                if (TP.regex.IS_NAMEXP.test(attrName)) {
                    re = TP.getQNameRegex(attrName);

                    attrs = elem.attributes;
                    len = attrs.length;

                    for (i = 0; i < len; i++) {
                        //  find the name
                        if (re.test(attrs[i].name)) {
                            //  check the value as needed
                            if (TP.isValid(attrValue)) {
                                if (!TP.match(attrValue, attrs[i].value)) {
                                    continue;
                                }
                            }

                            return true;
                        }
                    }
                } else {
                    //  without a value we can go by existence alone
                    //  which should be a little faster
                    if (TP.notValid(attrValue)) {
                        if (TP.elementHasAttribute(
                                    elem, attrName, checkAttrNSURI)) {
                            return true;
                        }
                    } else if (TP.match(
                                attrValue,
                                TP.elementGetAttribute(
                                    elem, attrName, checkAttrNSURI))) {
                        return true;
                    }
                }

                return false;
            });
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetFirstAncestorByTagName',
function(aNode, aTagName, aNamespaceURI) {

    /**
     * @method nodeGetFirstAncestorByTagName
     * @summary Returns the first element ancestor of aNode which matches the
     *     name and optional namespace URI provided.
     * @description This is a commonly used method in widget construction where
     *     an inner element is looking outward for its containing widget or
     *     control, often during event dispatch.
     * @param {Node} aNode The DOM node to operate on.
     * @param {String} aTagName The string tagname to search for.
     * @param {String} aNamespaceURI The namespace URI to search for.
     * @example TODO
     * @returns {Element} An element ancestor of the node.
     * @exception TP.sig.InvalidParameter Raised when a node that isn't of type
     *     Node.ELEMENT_NODE or Node.DOCUMENT_NODE is provided to the method.
     * @exception TP.sig.InvalidName Raised when the supplied tag name is empty.
     */

    var tagName,
        matcher;

    if (TP.isEmpty(aTagName)) {
        return TP.raise(this, 'TP.sig.InvalidName');
    }

    //  qname returns lowercase tags for HTML (xhtml style)
    if (TP.isHTMLNode(aNode)) {
        tagName = aTagName.toLowerCase();
    } else {
        tagName = aTagName;
    }

    matcher = TP.getQNameRegex(tagName);

    return TP.nodeDetectAncestor(
            aNode,
            function(elem) {
                if (TP.isString(aNamespaceURI)) {
                    if (TP.nodeGetNSURI(elem) !== aNamespaceURI) {
                        return false;
                    }
                }

                return matcher.test(TP.qname(elem));
            });
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetFirstElementChildByAttribute',
function(aNode, attrName, attrValue) {

    /**
     * @method nodeGetFirstElementChildByAttribute
     * @summary Returns the first element child of aNode which has an attribute
     *     matching attrName and whose value matches the optional attrValue
     *     provided.
     * @param {Node} aNode The DOM node to operate on.
     * @param {String} attrName The attribute to test for.
     * @param {Object} attrValue The attribute value to check.
     * @example Get the first child Element node of an XML element that has an
     *     attribute 'goo' which has a value of 'moo':
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo><bar><goo baz="goo">More
     *         text</goo></bar><boo baz="goo">Yet more text</boo></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          aNode = TP.nodeGetFirstElementChildByAttribute(
     *          xmlDoc.documentElement,
     *          'baz',
     *          'goo');
     *          <samp>[object Element]</samp>
     *          // Get the string value to see what we have.
     *          TP.str(aNode);
     *          // Note here how it's 'boo' that is returned, not 'goo'
     *          // because 'boo' is a (direct) child and 'goo' isn't
     *          // (its a descendant, but not a direct child).
     *          <samp>&lt;boo baz="goo"&gt;Yet more text&lt;boo&gt;</samp>
     *     </code>
     * @example Get the first child Element node of an HTML element that has an
     *     attribute 'style' which has any value:
     *     <code>
     *          TP.nodeGetFirstElementChildByAttribute(
     *          document.documentElement,
     *          'style');
     *          // Assuming the 'body' element has a style...
     *          <samp>[object HTMLBodyElement]</samp>
     *     </code>
     * @returns {Element} An element child of the node.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidString Raised when the supplied attribute name
     *     is empty.
     */

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (TP.isEmpty(attrName)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    return TP.nodeDetectChildElement(
            aNode,
            function(elem) {

                var matcher,
                    attrs,
                    len,
                    i;

                //  We put try...catch around this because IE will sometimes
                //  throw exceptions...
                try {
                    if (TP.regex.IS_NAMEXP.test(attrName)) {
                        matcher = TP.getQNameRegex(attrName);

                        attrs = elem.attributes;
                        len = attrs.length;

                        for (i = 0; i < len; i++) {
                            //  find the name
                            if (matcher.test(attrs[i].name)) {
                                //  check the value as needed
                                if (TP.isValid(attrValue)) {
                                    if (!TP.match(attrValue, attrs[i].value)) {
                                        continue;
                                    }
                                }

                                return true;
                            }
                        }
                    } else {
                        //  without a value we can go by existence alone
                        //  which should be a little faster
                        if (TP.notValid(attrValue)) {
                            if (TP.elementHasAttribute(elem, attrName)) {
                                return true;
                            }
                        } else if (TP.match(
                                    attrValue,
                                    TP.elementGetAttribute(elem, attrName))) {
                            return true;
                        }
                    }
                } catch (e) {
                    TP.ifError() ?
                        TP.error(
                            TP.ec(e, 'Error getting first element child' +
                                        ' by attribute: ' + attrName)) : 0;
                }

                return false;
            });
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetFirstElementChildByTagName',
function(aNode, aTagName, aNamespaceURI) {

    /**
     * @method nodeGetFirstElementChildByTagName
     * @summary Returns the first element descendant of aNode which matches the
     *     name and optional namespace URI provided. This is a commonly used
     *     method in widget construction where the outer widget is looking for
     *     specific parts of its content.
     * @param {Node} aNode The DOM node to operate on.
     * @param {String} aTagName The string tagname to search for.
     * @param {String} aNamespaceURI The namespace URI to search for.
     * @example Get the first child Element node of an XML element that has a
     *     tag name of 'bar' which has a namespace of
     *     'http://www.w3.org/2002/xforms':
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo><bar/><xf:bar xmlns="http://www.bar.com"
     *         xmlns:xf="http://www.w3.org/2002/xforms"></xf:bar></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          aNode = TP.nodeGetFirstElementChildByTagName(
     *          xmlDoc.documentElement,
     *          'bar',
     *          'http://www.w3.org/2002/xforms');
     *          <samp>[object Element]</samp>
     *          // Get the string value to see what we have.
     *          TP.str(aNode);
     *          // Note here how it's 'xf:bar' that is returned, not
     *          // 'bar' because 'bar' has no namespace associated with
     *          // it, and we specified 'http://www.w3.org/2002/xforms'
     *          // with our query.
     *          <samp>&lt;xf:bar xmlns="http://www.bar.com"
     *         xmlns:xf="http://www.w3.org/2002/xforms"/&gt;</samp>
     *     </code>
     * @example Get the first child Element node of an HTML element that has a
     *     tag name of 'body':
     *     <code>
     *          TP.nodeGetFirstElementChildByTagName(
     *          document.documentElement,
     *          'body');
     *          <samp>[object HTMLBodyElement]</samp>
     *     </code>
     * @returns {Element} An element descendant of the node.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidName Raised when the supplied attribute name is
     *     empty.
     */

    var tagName,
        matcher;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (TP.isEmpty(aTagName)) {
        return TP.raise(this, 'TP.sig.InvalidName');
    }

    //  qname returns lowercase tags for HTML (xhtml style)
    if (TP.isHTMLNode(aNode)) {
        tagName = aTagName.toLowerCase();
    } else {
        tagName = aTagName;
    }

    matcher = TP.getQNameRegex(tagName);

    return TP.nodeDetectChildElement(
            aNode,
            function(elem) {

                if (TP.isString(aNamespaceURI)) {
                    if (TP.nodeGetNSURI(elem) !== aNamespaceURI) {
                        return false;
                    }
                }

                return matcher.test(TP.qname(elem));
            });
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetFirstChildByType',
function(aNode, aType) {

    /**
     * @method nodeGetFirstChildByType
     * @summary Returns the first child of aNode which has a nodeType matching
     *     the type provided.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Number} aType A Node.nodeType constant.
     * @example Get the first child Text node of an XML element:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo><bar>Some text<goo>More
     *         text</goo></bar>Yet more text</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          result = TP.nodeGetFirstChildByType(
     *          xmlDoc.documentElement,
     *          Node.TEXT_NODE);
     *          <samp>[object Text]</samp>
     *          TP.str(result);
     *          <samp>Yet more text</samp>
     *     </code>
     * @example Get the first child Text node of an HTML element:
     *     <code>
     *          TP.nodeGetFirstChildByType(
     *          TP.documentGetBody(document),
     *          Node.TEXT_NODE);
     *          <samp>(the first child text node of the body element)</samp>
     *     </code>
     * @returns {Node} A child of the node.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidParameter Raised when an invalid node type is
     *     provided to the method.
     */

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (TP.notValid(aType)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    return TP.nodeDetectChildNode(
            aNode,
            function(node) {

                return node.nodeType === aType;
            });
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetFirstChildContentNode',
function(aNode) {

    /**
     * @method nodeGetFirstChildContentNode
     * @summary Returns the first "content" child of aNode, the first text or
     *     CDATA child node.
     * @param {Node} aNode The DOM node to operate on.
     * @example Get the first child text or cdata node of an XML element:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo><bar>Some text<goo>More
     *         text</goo></bar>Yet more text</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          result = TP.nodeGetFirstChildContentNode(
     *          xmlDoc.documentElement);
     *          <samp>Yet more text</samp>
     *     </code>
     * @returns {Node.TEXT_NODE|Node.CDATA_SECTION_NODE} A child of the node.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     */

    var children,
        len,
        i,
        type;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    //  NB: We can't use '.children' here - need *all* types of child nodes.
    children = aNode.childNodes;
    len = children.length;

    for (i = 0; i < len; i++) {
        type = children[i].nodeType;
        if (type === Node.TEXT_NODE || type === Node.CDATA_SECTION_NODE) {
            return children[i];
        }
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetFirstChildElement',
function(aNode) {

    /**
     * @method nodeGetFirstChildElement
     * @summary Returns the first element child of aNode. If there is no first
     *     element child for the node provided this method returns null.
     * @description This method is a common replacement for node.firstChild
     *     which ensures that text nodes, comment nodes, and other node types
     *     don't break your code when you're assuming element nodes.
     * @param {Node} aNode The DOM node to operate on.
     * @example Get the first child Element node of an XML element:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo><bar>Some text<goo>More
     *         text</goo></bar>Yet more text</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          result = TP.nodeGetFirstChildElement(
     *          xmlDoc.documentElement);
     *          <samp>[object Element]</samp>
     *          TP.str(result);
     *          <samp>&lt;bar&gt;Some text&lt;goo&gt;More
     *         text&lt;/goo&gt;&lt;/bar&gt;</samp>
     *     </code>
     * @example Get the first child Element node of an HTML element:
     *     <code>
     *          TP.nodeGetFirstChildElement(
     *          document.documentElement);
     *          <samp>[object HTMLHeadElement]</samp>
     *     </code>
     * @returns {Element} An element child of the node.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     */

    var child;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    //  In IE (and browsers that implement the Element Traversal
    //  specification), HTML elements have a convenience property called
    //  'children' that contains *only elements*, not all child nodes as the
    //  W3C property 'childNodes' does (and therefore doesn't require the
    //  looping behavior below).
    if (TP.isValid(aNode.children)) {
        return aNode.children[0];
    }

    child = aNode.firstChild;
    while (child) {
        if (TP.isElement(child)) {
            return child;
        }

        child = child.nextSibling;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetFirstDescendantByType',
function(aNode, aType) {

    /**
     * @method nodeGetFirstDescendantByType
     * @summary Returns the first descendant of aNode which has a nodeType
     *     matching the type provided.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Number} aType A Node.nodeType constant.
     * @example Get the first descendant Text node of an XML element:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo><bar>Some text<goo>More
     *         text</goo></bar>Yet more text</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          aNode = TP.nodeGetFirstDescendantByType(
     *          xmlDoc.documentElement,
     *          Node.TEXT_NODE);
     *          <samp>[object Text]</samp>
     *          // Get the string value to see what we have.
     *          TP.str(aNode);
     *          // Note that its 'Yet more text' since this is the
     *          // *most direct* descendant of the document's
     *          // documentElement.
     *          <samp>Yet more text</samp>
     *     </code>
     * @example Get the first descendant Text node of an HTML element:
     *     <code>
     *          aNode = TP.nodeGetFirstDescendantByType(
     *          TP.documentGetBody(document),
     *          Node.TEXT_NODE);
     *          <samp>[object Text]</samp>
     *          // Get the string value to see what we have.
     *          TP.str(aNode);
     *          <samp>(the text of the first Text node under the body
     *          element)</samp>
     *     </code>
     * @returns {Node} A descendant of the node.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidParameter Raised when an invalid node type is
     *     provided to the method.
     */

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (TP.notValid(aType)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    return TP.nodeDetectDescendant(
            aNode,
            function(node) {

                return node.nodeType === aType;
            });
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetFirstElementByAttribute',
function(aNode, attrName, attrValue) {

    /**
     * @method nodeGetFirstElementByAttribute
     * @summary Returns the first element descendant of aNode which has an
     *     attribute matching attrName and whose value matches the optional
     *     attrValue provided.
     * @param {Node} aNode The DOM node to operate on.
     * @param {String} attrName The attribute to test for.
     * @param {Object} attrValue The attribute value to check.
     * @example Get the first descendant Element node of an XML element that has
     *     an attribute 'goo' which has a value of 'moo':
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo><bar><goo baz="goo">More
     *         text</goo></bar><boo baz="goo">Yet more text</boo></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          aNode = TP.nodeGetFirstElementByAttribute(
     *          xmlDoc.documentElement,
     *          'baz',
     *          'goo');
     *          <samp>[object Element]</samp>
     *          // Get the string value to see what we have.
     *          TP.str(aNode);
     *          // Note here how it's 'boo' that is returned, not 'goo'
     *          // because 'boo' is a (direct) child and 'goo' isn't
     *          // (its a descendant, but not a direct child).
     *          <samp>&lt;boo baz="goo"&gt;Yet more text&lt;boo&gt;</samp>
     *     </code>
     * @example Get the first descendant Element node of an HTML element that
     *     has an attribute 'style' which has any value:
     *     <code>
     *          TP.nodeGetFirstElementByAttribute(
     *          document.documentElement,
     *          'style');
     *          // Assuming the 'body' element has a style...
     *          <samp>[object HTMLBodyElement]</samp>
     *     </code>
     * @returns {Element} An element descendant of the node.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidName Raised when the supplied attribute name is
     *     empty.
     */

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (TP.isEmpty(attrName)) {
        return TP.raise(this, 'TP.sig.InvalidName');
    }

    return TP.nodeDetectDescendantElement(
            aNode,
            function(elem) {

                var matcher,
                    attrs,
                    len,
                    i;

                //  We put try...catch around this because IE will sometimes
                //  throw exceptions...
                try {
                    if (TP.regex.IS_NAMEXP.test(attrName)) {
                        matcher = TP.getQNameRegex(attrName);

                        attrs = elem.attributes;
                        len = attrs.length;

                        for (i = 0; i < len; i++) {
                            //  find the name
                            if (matcher.test(attrs[i].name)) {
                                //  check the value as needed
                                if (TP.isValid(attrValue)) {
                                    if (!TP.match(attrValue, attrs[i].value)) {
                                        continue;
                                    }
                                }

                                return true;
                            }
                        }
                    } else {
                        //  without a value we can go by existence alone
                        //  which should be a little faster
                        if (TP.notValid(attrValue)) {
                            if (TP.elementHasAttribute(elem, attrName)) {
                                return true;
                            }
                        } else if (TP.match(
                                    attrValue,
                                    TP.elementGetAttribute(elem, attrName))) {
                            return true;
                        }
                    }
                } catch (e) {
                    TP.ifError() ?
                        TP.error(
                            TP.ec(e, 'Error getting first element' +
                                        ' by attribute: ' + attrName)) : 0;
                }

                return false;
            });
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetFirstElementByTagName',
function(aNode, aTagName, aNamespaceURI) {

    /**
     * @method nodeGetFirstElementByTagName
     * @summary Returns the first element descendant of aNode which matches the
     *     name and optional namespace URI provided.
     * @description This is a commonly used method in widget construction where
     *     the outer widget is looking for specific parts of its content.
     * @param {Node} aNode The DOM node to operate on.
     * @param {String} aTagName The string tagname to search for.
     * @param {String} aNamespaceURI The namespace URI to search for.
     * @example Get the first descendant Element node of an XML element that has
     *     a tag name of 'bar' which has a namespace of
     *     'http://www.w3.org/2002/xforms':
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><baz><xf:bar
     *         xmlns="http://www.bar.com"
     *
     *         xmlns:xf="http://www.w3.org/2002/xforms"></xf:bar><bar/></baz></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          aNode = TP.nodeGetFirstElementByTagName(
     *          xmlDoc,
     *          'bar',
     *          'http://www.foo.com');
     *          <samp>[object Element]</samp>
     *          // Get the string value to see what we have.
     *          TP.str(aNode);
     *          // Note here how it's 'bar' that is returned, not
     *          // 'xf:bar' because 'bar' has the 'http://www.foo.com'
     *          // default namespace associated with it, and we
     *          // specified 'http://www.foo.com' with our query.
     *          <samp>&lt;bar xmlns="http://www.foo.com"/&gt;</samp>
     *     </code>
     * @example Get the first descendant Element node of an HTML element that
     *     has a tag name of 'body':
     *     <code>
     *          TP.nodeGetFirstElementByTagName(
     *          document,
     *          'body');
     *          <samp>[object HTMLBodyElement]</samp>
     *     </code>
     * @returns {Element} An element descendant of the node.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidName Raised when the supplied tag name is empty.
     */

    var tagName,
        list,
        matcher;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (TP.isEmpty(aTagName)) {
        return TP.raise(this, 'TP.sig.InvalidName');
    }

    //  qname returns lowercase tags for HTML (xhtml style)
    if (TP.isHTMLNode(aNode)) {
        tagName = aTagName.toLowerCase();
    } else {
        tagName = aTagName;
    }

    if (TP.notEmpty(aNamespaceURI) &&
            TP.canInvoke(aNode, 'getElementsByTagNameNS')) {
        list = aNode.getElementsByTagNameNS(aNamespaceURI,
            tagName.split(':').first());
        return list[0];
    }

    matcher = TP.getQNameRegex(tagName);

    return TP.nodeDetectDescendantElement(
            aNode,
            function(elem) {

                if (TP.isString(aNamespaceURI)) {
                    if (TP.nodeGetNSURI(elem) !== aNamespaceURI) {
                        return false;
                    }
                }

                return matcher.test(TP.qname(elem));
            });
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetFirstSiblingElement',
function(aNode, direction) {

    /**
     * @method nodeGetFirstSiblingElement
     * @summary Returns the next, or previous sibling of aNode which is an
     *     element. This is a useful operation when trying to iterate over only
     *     elements within a particular set of nodes.
     * @param {Node} aNode The node to start the search from.
     * @param {String} direction TP.NEXT or TP.PREVIOUS. The default is TP.NEXT
     *     so searching is forward.
     * @returns {Element} A native element.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided.
     */

    var dir,
        sibProp,
        theNode;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    dir = TP.ifInvalid(direction, TP.NEXT);

    if (dir === TP.NEXT) {
        if (TP.isElement(aNode.nextElementSibling)) {
            return aNode.nextElementSibling;
        }
    } else {
        if (TP.isElement(aNode.previousElementSibling)) {
            return aNode.previousElementSibling;
        }
    }

    sibProp = dir === TP.NEXT ? 'nextSibling' : 'previousSibling';

    theNode = aNode[sibProp];
    while (TP.isValid(theNode) && !TP.isElement(theNode)) {
        theNode = theNode[sibProp];
    }

    return theNode;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetNextNonChild',
function(aNode, nodeType) {

    /**
     * @method nodeGetNextNonChild
     * @summary Returns the next node in document order that isn't a child of
     *     the node provided. This will often be the node's nextSibling, but it
     *     may be a different node when aNode has no nextSibling. Note that the
     *     last node in document order won't return a valid node here.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Number} nodeType A valid nodeType constant. Defaults to any node
     *     type.
     * @example Get the next non-child element for the <baz> element:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><baz/><bar/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetNextNonChild(
     *          xmlDoc.documentElement.childNodes[0]);
     *          <samp><bar/></samp>
     *     </code>
     * @returns {Node} The next node in document order.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided.
     */

    var next,
        ancestor;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    next = aNode.nextSibling;
    while (next) {
        if (TP.notValid(nodeType) || next.nodeType === nodeType) {
            return next;
        }

        next = next.nextSibling;
    }

    //  node is last in its parent's list of children. have to start working
    //  upward until we find an ancestor with a nextSibling
    ancestor = aNode.parentNode;
    while (ancestor && TP.isElement(ancestor)) {
        next = ancestor.nextSibling;

        while (next) {
            if (TP.notValid(nodeType) || next.nodeType === nodeType) {
                return next;
            }

            next = next.nextSibling;
        }

        ancestor = ancestor.parentNode;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetSiblings',
function(aNode, aSubset) {

    /**
     * @method nodeGetSiblings
     * @summary Returns an Array containing the sibling nodes of the node
     *     provided.
     * @description Order is from the parent's first child to the parent's last
     *     child, with aNode removed from the list. Unlike other methods for
     *     node collections this method does *not* normalize content, so a text
     *     node's siblings will be found when multiple text nodes were created
     *     by the browser. This means that that sibling list won't be consistent
     *     for all node types across browsers.
     * @param {Node} aNode The DOM node to operate on.
     * @param {String} aSubset TP.NEXT, TP.PREVIOUS, or null to collect all
     *     siblings.
     * @example Get an XML node's list of all of its sibling nodes:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo
     *         xmlns="http://www.foo.com"><bar/><baz/><boo/><goo/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          // Get the siblings of the 'baz' element
     *          result = TP.nodeGetSiblings(
     *          xmlDoc.documentElement.childNodes[1]);
     *          <samp>[object Element], [object Element], [object
     *         Element]</samp>
     *          // Get the local name of each node of the result to see what we
     *         have.
     *          result.collect(function(aNode) {return
     *         TP.elementGetLocalName(aNode)});
     *          <samp>bar, boo, goo</samp>
     *     </code>
     * @example Get an XML node's list of only its 'previous' sibling nodes:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo
     *         xmlns="http://www.foo.com"><bar/><baz/><boo/><goo/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          // Get the previous siblings of the 'baz' element
     *          result = TP.nodeGetSiblings(
     *          xmlDoc.documentElement.childNodes[1],
     *          TP.PREVIOUS);
     *          <samp>[object Element]</samp>
     *          // Get the local name of each node of the result to see what we
     *         have.
     *          result.collect(function(aNode) {return
     *         TP.elementGetLocalName(aNode)});
     *          <samp>bar</samp>
     *     </code>
     * @example Get an XML node's list of only its 'next' sibling nodes:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo
     *         xmlns="http://www.foo.com"><bar/><baz/><boo/><goo/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          // Get the next siblings of the 'baz' element
     *          result = TP.nodeGetSiblings(
     *          xmlDoc.documentElement.childNodes[1],
     *          TP.NEXT);
     *          <samp>[object Element], [object Element]</samp>
     *          // Get the local name of each node of the result to see what we
     *         have.
     *          result.collect(function(aNode) {return
     *         TP.elementGetLocalName(aNode)});
     *          <samp>boo, goo</samp>
     *     </code>
     * @example Get an HTML node's list of all of its sibling nodes:
     *     <code>
     *          // Get the siblings of the 'body' element
     *          TP.nodeGetSiblings(TP.documentGetBody(document));
     *          <samp>[object HTMLHeadElement]</samp>
     *     </code>
     * @returns {Node[]} An Array containing the nodes found.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     */

    var arr,
        node,

        ancestor,
        siblings,
        len,
        i;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    arr = TP.ac();

    switch (aSubset) {
        case TP.PREVIOUS:

            node = aNode.previousSibling;
            while (node) {
                arr.push(node);
                node = node.previousSibling;
            }

            //  Because we collected the previous siblings by walking backwards
            //  and the description of this method is that we always return
            //  results from first to last child, we need to reverse the results
            //  here.
            arr.reverse();

            break;

        case TP.NEXT:

            node = aNode.nextSibling;
            while (node) {
                arr.push(node);
                node = node.nextSibling;
            }
            break;

        default:

            ancestor = aNode.parentNode;
            if (TP.isElement(ancestor)) {
                siblings = ancestor.childNodes;
                len = siblings.length;

                //  aSubset was null, so collect everything but the node
                //  itself
                for (i = 0; i < len; i++) {
                    node = siblings[i];
                    if (node === aNode) {
                        continue;
                    }

                    arr.push(node);
                }
            }

            break;
    }

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetTopAncestor',
function(aNode) {

    /**
     * @method nodeGetTopAncestor
     * @summary Returns the top-most node in aNode's ancestor chain. This is
     *     typically a Document node (#document) but will be an Element or the
     *     node itself if the node is in a detached tree branch.
     * @param {Node} aNode The DOM node to operate on.
     * @returns {Node} The topmost node.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     */

    var ancestor;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    ancestor = aNode.parentNode;
    if (TP.notValid(ancestor)) {
        return aNode;
    }

    while (TP.isElement(ancestor)) {
        if (TP.notValid(ancestor.parentNode)) {
            return ancestor;
        }

        ancestor = ancestor.parentNode;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeImportNode',
function(aNode, otherNode) {

    /**
     * @method nodeImportNode
     * @summary Imports the other node into the document of the supplied node
           if it doesn't already belong to that document.
     * @param {Node} aNode The node to obtain the document to import the
     *     otherNode to.
     * @param {Node} otherNode The node to import into the document of aNode
     *     if necessary.
     * @exception TP.sig.InvalidNode
     * @returns {Node} The other node. This may be a different node than what
           was supplied to this routine, if it was imported.
     */

    var nodeDoc,
        theNode,

        prefix,

        children,
        len,
        i;

    if (!TP.isNode(aNode) || !TP.isNode(otherNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    //  Grab aNode's document and check to see if otherNode is in the same
    //  document. If not, call the native 'importNode' routine.
    nodeDoc = TP.nodeGetDocument(aNode);

    if (nodeDoc !== TP.nodeGetDocument(otherNode)) {
        theNode = nodeDoc.importNode(otherNode, true);

        //  Copy any TIBET expandos to the imported node.
        TP.nodeCopyTIBETExpandos(otherNode, theNode, false);
    } else {
        theNode = otherNode;
    }

    //  If aNode is an XML node, do some namespace normalization. If aNode and
    //  theNode have the same namespace URI, then remove the 'xmlns' attribute
    //  (or 'xmlns:<prefix>' attribute where prefix matches the node's prefix -
    //  but *NOT* other 'xmlns:<prefix>' attributes - other nodes may need
    //  them). This is to avoid multiple namespace nodes showing up during
    //  serialization, which just makes things messy.
    if (TP.isXMLNode(aNode)) {
        if (TP.isElement(theNode)) {
            //  If the namespaceURIs are the same, then 'theNode' doesn't need
            //  to redefine the same namespace, so we can remove the namespace
            //  node defining that namespace (if there is one).
            if (aNode.namespaceURI === theNode.namespaceURI) {
                //  use the prefix that was defined for the element, if there is
                //  one.
                if (TP.notEmpty(prefix = theNode.prefix)) {
                    theNode.removeAttributeNS(TP.w3.Xmlns.XMLNS,
                                                'xmlns:' + prefix);
                } else {
                    //  Otherwise, just remove the default namespace 'xmlns'
                    //  one.
                    theNode.removeAttributeNS(TP.w3.Xmlns.XMLNS,
                                                'xmlns');
                }
            }
        } else if (TP.isFragment(theNode)) {
            //  theNode is a fragment. We need to do this process, but one by
            //  one through the fragment's child elements.

            children = TP.nodeGetChildElements(theNode);
            len = children.length;

            for (i = 0; i < len; i++) {
                if (aNode.namespaceURI === children[i].namespaceURI) {
                    if (TP.notEmpty(prefix = children[i].prefix)) {
                        children[i].removeAttributeNS(
                                TP.w3.Xmlns.XMLNS, 'xmlns:' + prefix);
                    } else {
                        children[i].removeAttributeNS(
                                TP.w3.Xmlns.XMLNS, 'xmlns');
                    }
                }
            }
        }
    }

    return theNode;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeSwapNode',
function(firstNode, secondNode) {

    /**
     * @method nodeSwapNode
     * @summary Swaps the first node into the place where the second node is
     *     and vice versa. Note that both Nodes supplied to this method must be
     *     contained in the same overall Document.
     * @param {Node} firstNode The first node to swap.
     * @param {Node} secondNode The second node to swap.
     * @example Swap two nodes in an XML document:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo><bar/><baz/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeSwapNode(xmlDoc.documentElement.firstChild,
     *          xmlDoc.documentElement.childNodes[1]);
     *          <samp>undefined</samp>
     *          TP.nodeAsString(xmlDoc);
     *          <samp>&lt;foo&gt;&lt;baz/&gt;&lt;bar/&gt;&lt;/foo&gt;</samp>
     *     </code>
     * @exception TP.sig.InvalidNode Raised when either node is an invalid node
     *     or when the nodes are not contained in the same overall Document.
     */

    var insertionPoint,
        parentNode;

    if (!TP.isNode(firstNode) ||
        !TP.isNode(secondNode) ||
        TP.nodeGetDocument(firstNode) !== TP.nodeGetDocument(secondNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    insertionPoint = firstNode.nextSibling;

    //  If the insertion point is the same node as the secondNode, then set the
    //  insertion point to be the firstNode (we're switching places between two
    //  adjacent nodes).
    if (insertionPoint === secondNode) {
        insertionPoint = firstNode;
    }

    parentNode = firstNode.parentNode;

    //  Note here how we force awakening to 'false' in case we're dealing with
    //  HTML nodes here.

    TP.nodeReplaceChild(secondNode.parentNode,
                        firstNode,
                        secondNode,
                        false);

    TP.nodeInsertBefore(parentNode, secondNode, insertionPoint, false);

    return;
});

//  ------------------------------------------------------------------------
//  NODE COLLECTIONS
//  ------------------------------------------------------------------------

TP.definePrimitive('nodesGetRoots',
function(aNodeArray, shouldSort) {

    /**
     * @method nodesGetRoots
     * @summary Returns an Array containing all of the roots of the provided
     *     Array of nodes.
     * @description This method finds all of the 'roots' in the supplied Array.
     *     These are the nodes for which there is no ancestor *in the supplied
     *     Array* (they very well may have an ancestor, but it's not included in
     *     the Array.
     * @param {Node[]} aNodeArray The DOM nodes to operate on.
     * @param {Boolean} [shouldSort=false] Whether or not to sort the supplied
     *     nodes into 'document order'. This flag is defaulted to false, since
     *     most queries (XPath, CSS, etc.) will return 'document order' results
     *     and those are then likely supplied to this method. If this flag is
     *     true, then a sort is performed using the TP.sort.DOCUMENT_ORDER sort.
     * @returns {Node[]} An Array of the root nodes of the supplied nodes
     * @exception TP.sig.InvalidArray Raised when an invalid Array is provided
     *     to the method.
     */

    var nodes,
        arr;

    if (!TP.isArray(aNodeArray)) {
        return TP.raise(this, 'TP.sig.InvalidArray');
    }

    if (TP.isTrue(shouldSort)) {
        nodes = aNodeArray.sort(TP.sort.DOCUMENT_ORDER);
    } else {
        nodes = aNodeArray;
    }

    arr = TP.ac();

    nodes.forEach(
        function(foundNode) {

            var i,
                len;

            len = arr.getSize();
            for (i = 0; i < len; i++) {
                if (TP.nodeComparePosition(
                            foundNode, arr.at(i), TP.CONTAINS_NODE)) {
                    return;
                }
            }

            arr.push(foundNode);
        });

    return arr;
});

//  ------------------------------------------------------------------------
//  NODE TRAVERSAL
//  ------------------------------------------------------------------------

/*
Core DOM traversal routines. These allow us to walk the DOM efficiently in
either breath-first or depth-first fashion, performing operations at each
step and filtering for elements vs. content nodes as we go.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeBreadthTraversal',
function(aNode, enterFunc, exitFunc, contentFunc, includeRoot) {

    /**
     * @method nodeBreadthTraversal
     * @summary Traverses a node in a breadth-first fashion invoking any enter,
     *     exit, or content functions provided. The enter and pop functions are
     *     invoked for each structural (element) node while the content function
     *     is invoked for all non-element nodes regardless of their type.
     * @description When traversing in a breadth-first manner the semantics of
     *     the DOM are shifted slightly from the true structural nature of the
     *     tree. In particular, as each element is entered the enter function is
     *     invoked. The content function is then invoked for any non-element
     *     children of the node. Finally the exit function for the element is
     *     invoked. This has the effect of treating non-element child nodes as
     *     if they were at the same "level" of the tree as the element itself.
     *     This seems appropriate, particularly when you consider leaf node
     *     processing.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Function} enterFunc The function that is called when a Node is
     *     entered (becomes the currently processing element). Note this
     *     function is only called for Nodes of type Node.ELEMENT_NODE.
     * @param {Function} exitFunc The function that is called when a Node is
     *     exited (ceases to be the currently processing element). Note this
     *     function is only called for Nodes of type Node.ELEMENT_NODE.
     * @param {Function} contentFunc The function that is called when a Node's
     *     content is encountered. Note that this function is *not* called for
     *     Nodes of type Node.ELEMENT_NODE.
     * @param {Boolean} includeRoot True to include an enter/exit sequence on
     *     the initial element.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     */

    var doRoot,
        list,
        outer,
        i,
        currentNode,
        newNode,
        terminal,
        rootNode,
        ret,
        j,
        inner,
        innerChild,
        count,
        max,
        repcount,
        repmax;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    //  define our starting point, the initial element we'll process
    doRoot = TP.ifInvalid(includeRoot, true);

    //  if the root is part of the process we'll push it onto the front of
    //  the list
    if (doRoot) {
        list = TP.ac();
        list.push(TP.ac(aNode));
    } else {
        //  start with the list of child nodes. we'll be adding to this as
        //  we traverse and we'll keep going until we run out of nodes
        list = TP.ac();
        list.push(aNode.childNodes);
    }

    count = 0;
    max = TP.sys.cfg('content.max_traversal');
    repmax = TP.sys.cfg('content.max_replace');

    //  regardless of whether we're processing the root element itself or
    //  not we terminate when we complete processing back to that node.
    terminal = aNode;
    rootNode = TP.nodeGetTopAncestor(terminal);

    /* eslint-disable no-labels */

    //  Each entry in the list is either an array (when it's the root entry)
    //  or a nodelist, so "outer" is something we have to iterate over.

    /* eslint-disable no-extra-parens */
    while ((outer = list.shift())) {
    /* eslint-enable no-extra-parens */

        //  NOTE the iteration here does NOT cache length so the list can be
        //  modified as we work

        out:

        for (i = 0; i < outer.length; i++) {
            currentNode = outer[i];

            if (TP.isElement(currentNode)) {
                count += 1;
                if (count > max) {
                    TP.ifWarn() ?
                        TP.warn('Traversal terminated at' +
                                    ' content.max_traversal elements.') : 0;

                    break;
                }

                if (enterFunc) {
                    repcount = 0;
                    while (repcount < repmax &&
                        (TP.isNode(ret = enterFunc(currentNode)) ||
                        TP.isArray(ret))) {
                        //  update return values when we got back an array
                        if (TP.isArray(ret)) {
                            newNode = ret.at(0);
                            ret = ret.at(1);
                        } else {
                            newNode = ret;
                        }

                        //  if newNode isn't a node (it's TP.BREAK etc) or
                        //  if the same node was returned we're done, just
                        //  break out of the while so we can move forward.
                        if (!TP.isNode(newNode) ||
                            newNode === currentNode) {
                            break;
                        }

                        //  allow for root of traversal to be replaced as
                        //  well
                        if (currentNode === terminal) {
                            terminal = newNode;
                        }

                        currentNode = newNode;

                        if (ret === TP.BREAK ||
                            ret === TP.CONTINUE ||
                            ret === TP.DESCEND) {
                            break;
                        }

                        repcount += 1;
                    }

                    if (ret !== TP.BREAK &&
                        ret !== TP.CONTINUE &&
                        ret !== TP.DESCEND &&
                        TP.nodeIsDetached(currentNode, rootNode)) {
                        TP.ifWarn() && TP.sys.cfg('log.node_detachment') ?
                            TP.warn('Traversal node detached: ' +
                                        TP.str(currentNode, false)) : 0;

                        return;
                    }

                    if (ret === TP.BREAK) {
                        break;
                    } else if (ret === TP.CONTINUE) {
                        //  continue means close this element and move to
                        //  the next one
                        if (exitFunc) {
                            ret = exitFunc(currentNode);
                            if (ret === TP.BREAK) {
                                break;
                            }
                        }

                        continue;
                    }
                }

                if (contentFunc) {
                    inner = currentNode.childNodes;
                    for (j = 0; j < inner.length; j++) {
                        innerChild = inner[j];
                        if (!TP.isElement(innerChild)) {
                            ret = contentFunc(innerChild);
                            if (ret === TP.BREAK) {
                                break out;  //  terminate entirely
                            } else if (ret === TP.CONTINUE) {
                                //  break inner for loop and allow the
                                //  exitFunc to run on this node
                                break;
                            }
                        }
                    }
                }

                if (exitFunc) {
                    ret = exitFunc(currentNode);
                    if (ret === TP.BREAK) {
                        break;
                    } else if (ret === TP.CONTINUE) {
                        continue;
                    }
                }

                //  add this node's children so we'll loop over them, but
                //  again do NOT put them into an array, leave them in a
                //  native nodelist so they content will flex with changes
                //  in the tree structure which might occur
                list.push(currentNode.childNodes);
            }
        }
    }

    /* eslint-enable no-labels */

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeDepthTraversal',
function(aNode, enterFunc, exitFunc, contentFunc, includeRoot) {

    /**
     * @method nodeDepthTraversal
     * @summary Traverses a node in a depth-first, document order fashion
     *     (without using recursion) and invokes any push, pop, or content
     *     function provided. The push and pop functions are invoked for each
     *     structural (element) node while the content function is invoked for
     *     all non-element nodes.
     * @description To have an operation affect every node you'll need to supply
     *     that function to the content function and one of the other two
     *     functions (push or pop) based on your traversal needs. NOTE that
     *     while all functions can return TP.BREAK to terminate the traversal,
     *     enterFunc can also return TP.CONTINUE to allow you to skip child
     *     content under an element and proceed to the next non-child element
     *     node for processing or TP.DESCEND to descend into child element
     *     content.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Function} enterFunc The function that is called when a Node is
     *     entered (becomes the currently processing element). Note this
     *     function is only called for Nodes of type Node.ELEMENT_NODE.
     * @param {Function} exitFunc The function that is called when a Node is
     *     exited (ceases to be the currently processing element). Note this
     *     function is only called for Nodes of type Node.ELEMENT_NODE.
     * @param {Function} contentFunc The function that is called when a Node's
     *     content is encountered. Note that this function is *not* called for
     *     Nodes of type Node.ELEMENT_NODE.
     * @param {Boolean} includeRoot True to include an enter/exit sequence on
     *     the initial element.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     */

    var doRoot,
        currentNode,
        newNode,
        ancestor,
        ret,
        next,
        terminal,
        rootNode,
        count,
        max,
        repcount,
        repmax;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    //  define our starting point, the initial element we'll process
    doRoot = TP.ifInvalid(includeRoot, true);

    if (doRoot && TP.isElement(aNode)) {
        currentNode = aNode;
    } else if (TP.isDocument(aNode)) {
        //  condense multiple text node children
        TP.nodeNormalize(aNode.documentElement);

        //  NB: We use 'firstChild', not 'documentElement' here, since we
        //  might have XML PI's that are children of the document, but are
        //  not under the root (i.e. 'documentElement') element.
        currentNode = aNode.firstChild;
    } else {
        currentNode = aNode.firstChild;
    }

    //  no node? no work
    if (TP.notValid(currentNode)) {
        return;
    }

    //  regardless of whether we're processing the root element itself or
    //  not we terminate when we complete processing back to that node.
    terminal = aNode;
    rootNode = TP.nodeGetTopAncestor(terminal);

    count = 0;
    max = TP.sys.cfg('content.max_traversal');
    repmax = TP.sys.cfg('content.max_replace');

    do {
        //  element nodes have enter/exit logic applied to them, while text
        //  nodes etc. have only content logic applied to them.
        if (TP.isElement(currentNode)) {
            count += 1;
            if (count > max) {
                TP.ifWarn() ?
                    TP.warn('Traversal terminated at' +
                                ' content.max_traversal elements.') : 0;

                break;
            }

            if (enterFunc) {
                repcount = 0;
                while (repcount < repmax &&
                        (TP.isNode(ret = enterFunc(currentNode)) ||
                        TP.isArray(ret))) {
                    //  update return values when we got back an array
                    if (TP.isArray(ret)) {
                        newNode = ret.at(0);
                        ret = ret.at(1);
                    } else {
                        newNode = ret;
                    }

                    //  if newNode isn't a node (it's TP.BREAK etc) or if
                    //  the same node was returned we're done, just break
                    //  out of the while so we can move forward.
                    if (!TP.isNode(newNode) || newNode === currentNode) {
                        break;
                    }

                    //  allow for root of traversal to be replaced as well
                    if (currentNode === terminal) {
                        terminal = newNode;
                    }

                    currentNode = newNode;

                    if (ret === TP.BREAK ||
                        ret === TP.CONTINUE ||
                        ret === TP.REPEAT ||
                        ret === TP.DESCEND) {
                        break;
                    }

                    repcount += 1;
                }

                if (ret !== TP.BREAK &&
                    ret !== TP.CONTINUE &&
                    ret !== TP.REPEAT &&
                    ret !== TP.DESCEND &&
                    TP.nodeIsDetached(currentNode, rootNode)) {
                    TP.ifWarn() && TP.sys.cfg('log.node_detachment') ?
                        TP.warn('Traversal node detached: ' +
                                    TP.str(currentNode, false)) : 0;

                    return;
                }

                if (ret === TP.BREAK) {
                    return;
                } else if (ret === TP.REPEAT) {
                    continue;
                } else if (ret === TP.CONTINUE) {
                    //  continue means skip remaining content for this node
                    //  and move to the next element at this level or higher
                    if (exitFunc) {
                        ret = exitFunc(currentNode);
                        if (ret === TP.BREAK) {
                            return;
                        }
                    }

                    if (currentNode === terminal) {
                        return;
                    }

                    if (TP.notValid(next = currentNode.nextSibling)) {
                        //  out of siblings, next unvisited element
                        //  will be up the chain somewhere
                        ancestor = currentNode.parentNode;
                        while (TP.isElement(ancestor)) {
                            if (exitFunc) {
                                ret = exitFunc(ancestor);
                                if (ret === TP.BREAK) {
                                    return;
                                }
                            }

                            if (ancestor === terminal) {
                                return;
                            }

                            if (TP.isNode(next = ancestor.nextSibling)) {
                                break;
                            }

                            ancestor = ancestor.parentNode;
                        }

                        if (TP.notValid(ancestor)) {
                            return;
                        }
                    }

                    //  now that we know what element is next we can
                    //  finally trigger the continue operation
                    currentNode = next;
                    continue;
                } else if (ret === TP.DESCEND) {
                    //  skip cycles on returned node, descend into
                    //  children by dropping out of here without a
                    //  return or continue call.
                    void 0;
                } else if (TP.isValid(ret)) {
                    TP.ifWarn() ?
                        TP.warn('Unrecognized traversal return value: ' +
                            ret) : 0;
                }
            }

            //  if the enterFunc didn't trigger a TP.BREAK or TP.CONTINUE
            //  condition then we want to continue our descent/traversal as
            //  long as there's a "down" from here
            if (currentNode.childNodes.length === 0) {
                //  no children means this node is done, so exit cleanly
                if (exitFunc) {
                    ret = exitFunc(currentNode);
                    if (ret === TP.BREAK) {
                        return;
                    }
                }

                if (currentNode === terminal) {
                    return;
                }

                //  if we have a sibling then that's our next position,
                //  otherwise we've got to search up and "right"
                if (TP.notValid(next = currentNode.nextSibling)) {
                    //  out of siblings, next unvisited element will be up
                    //  the chain somewhere
                    ancestor = currentNode.parentNode;
                    while (TP.isElement(ancestor)) {
                        if (exitFunc) {
                            ret = exitFunc(ancestor);
                            if (ret === TP.BREAK) {
                                return;
                            }
                        }

                        if (ancestor === terminal) {
                            return;
                        }

                        if (TP.isNode(next = ancestor.nextSibling)) {
                            break;
                        }

                        ancestor = ancestor.parentNode;
                    }

                    if (TP.notValid(ancestor)) {
                        return;
                    }
                }

                currentNode = next;
                continue;
            } else {
                //  at least one child, next node is our first child then
                //  (since we're working depth-first)
                currentNode = currentNode.firstChild;
            }
        } else {
            if (contentFunc) {
                //  we're looking at a text, comment, processing
                //  instruction or similar node.
                ret = contentFunc(currentNode);
                if (ret === TP.BREAK) {
                    return;
                } else if (ret === TP.CONTINUE) {
                    //  terminate processing our parent's content and move
                    //  on
                    ancestor = currentNode.parentNode;

                    //  if currentNode's ancestor is not an Element, then
                    //  its probably the Document, which means that
                    //  currentNode is probably a Processing Instruction
                    //  (otherwise, since we're in the contentFunc, it would
                    //  have to be an Element).
                    if (TP.isElement(ancestor)) {
                        while (TP.isElement(ancestor)) {
                            if (exitFunc) {
                                ret = exitFunc(ancestor);
                                if (ret === TP.BREAK) {
                                    return;
                                }
                            }

                            if (ancestor === terminal) {
                                return;
                            }

                            if (TP.isNode(next = ancestor.nextSibling)) {
                                break;
                            }

                            ancestor = ancestor.parentNode;
                        }

                        if (TP.notValid(ancestor)) {
                            return;
                        }

                        currentNode = next;

                        //  continue to the next node in the top-level
                        //  do...while
                        continue;
                    }
                } else if (TP.isNode(ret)) {
                    //  the contentFunc specified the node to traverse to
                    //  next
                    currentNode = ret;

                    continue;
                }
            }

            //  normal processing, just move to the next node in line
            if (TP.notValid(next = currentNode.nextSibling)) {
                //  out of siblings, next unvisited node
                //  will be up the chain somewhere
                ancestor = currentNode.parentNode;
                while (TP.isElement(ancestor)) {
                    if (exitFunc) {
                        ret = exitFunc(ancestor);
                        if (ret === TP.BREAK) {
                            return;
                        }
                    }

                    if (ancestor === terminal) {
                        return;
                    }

                    if (TP.isNode(next = ancestor.nextSibling)) {
                        break;
                    }

                    ancestor = ancestor.parentNode;
                }

                if (TP.notValid(ancestor)) {
                    return;
                }
            }

            currentNode = next;
        }
    }
    while (TP.isNode(currentNode) && currentNode !== terminal);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetChildIndex',
function(aNode, aChild) {

    /**
     * @method nodeGetChildIndex
     * @summary Returns the index in the childNodes array for the child
     *     provided. If aChild couldn't be found in the aNode, this method
     *     returns TP.NOT_FOUND.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Node} aChild The node to find.
     * @example Get a particular child node's index in an XML element:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><baz/><bar/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetChildIndex(
     *          xmlDoc.documentElement,
     *          xmlDoc.documentElement.childNodes[1]);
     *          <samp>1</samp>
     *     </code>
     * @example Get a particular child node's index in an HTML element:
     *     <code>
     *          TP.nodeGetChildIndex(document.documentElement,
     *          TP.documentGetBody(document));
     *          <samp>1</samp>
     *     </code>
     * @returns {Number} The index number, or TP.NOT_FOUND.
     * @exception TP.sig.InvalidNode Raised when either node provided to the
     *     method is invalid.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method or the supplied child
     *     isn't a valid node
     */

    var children,
        len,
        i;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (!TP.isNode(aChild)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    children = aNode.childNodes;
    len = children.length;

    for (i = 0; i < len; i++) {
        if (children[i] === aChild) {
            return i;
        }
    }

    return TP.NOT_FOUND;
});

//  ------------------------------------------------------------------------
//  NODE COLLECTION ITERATION
//  ------------------------------------------------------------------------

/*
Base operations providing iteration capability for nodes (particularly
element and document nodes) similar to those found in TIBET's collection
types.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeAncestorsPerform',
function(aNode, aFunction, stopAncestor) {

    /**
     * @method nodeAncestorsPerform
     * @summary Executes aFunction with each ancestor of the node, working from
     *     the node outward.
     * @description Perform can be used as an alternative to constructing for
     *     loops to iterate over a collection. By returning TP.BREAK from your
     *     iterator you can also cause the enclosing iteration to terminate.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Function} aFunction A function which performs some action with an
     *     element node.
     * @param {Element} [stopAncestor] An element between aNode and aNode's
     *     document node that the ancestor traversal will 'stop' at. This
     *     parameter is optional. Note that this ancestor will *not* be iterated
     *     on.
     * @example Iterate up an XML node's ancestor chain and print each tag name:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo
     *         xmlns="http://www.foo.com"><bar><baz><boo/></baz></bar></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          fooStr = '';
     *          TP.nodeAncestorsPerform(
     *          TP.nodeGetElementsByTagName(xmlDoc, 'boo').first(),
     *          function(aNode) {
     *
     *          fooStr += aNode.tagName + ' ';
     *          });
     *          fooStr;
     *          <samp>baz bar foo</samp>
     *     </code>
     * @example Iterate up an HTML node's ancestor chain and print each tag
     *     name:
     *     <code>
     *          fooStr = '';
     *          TP.nodeAncestorsPerform(
     *          TP.documentGetBody(document).firstChild,
     *          function(aNode) {
     *
     *          fooStr += aNode.tagName + ' ';
     *          });
     *          fooStr;
     *          <samp>BODY HTML</samp>
     *     </code>
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     * @exception TP.sig.InvalidFunction Raised when an invalid function is
     *     provided to the method.
     */

    var count,
        ancestor;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (!TP.isCallable(aFunction)) {
        return TP.raise(this, 'TP.sig.InvalidFunction');
    }

    count = 0;
    ancestor = aNode.parentNode;

    while (TP.isElement(ancestor)) {
        if (TP.isNode(stopAncestor) && ancestor === stopAncestor) {
            break;
        }

        if (aFunction(ancestor, count++) === TP.BREAK) {
            break;
        }

        ancestor = ancestor.parentNode;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeChildElementsPerform',
function(aNode, aFunction) {

    /**
     * @method nodeChildElementsPerform
     * @summary Executes aFunction with each child element of the node.
     * @description Perform can be used as an alternative to constructing for
     *     loops to iterate over a collection. By returning TP.BREAK from your
     *     iterator you can also cause the enclosing iteration to terminate.
     *     Note the filter here for child nodes that are elements.
     *     The index provided to aFunction is the index that would be used had
     *     you collected the elements first, then iterated on that array. This
     *     also means that, if the first or last node are not elements, the
     *     iteration function will not be called.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Function} aFunction A function which performs some action with
     *     each element provided.
     * @example Iterate across an XML node's child *element* list (i.e. where
     *     each item to the iteration method is a Node.ELEMENT_NODE) and print
     *     each tag name:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo
     *         xmlns="http://www.foo.com"><bar/><baz><boo/></baz></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          fooStr = '';
     *          TP.nodeChildElementsPerform(
     *          xmlDoc.documentElement,
     *          function(aNode) {
     *
     *          fooStr += aNode.tagName + ' ';
     *          });
     *          fooStr;
     *          <samp>bar baz</samp>
     *     </code>
     * @example Iterate across an HTML node's child *element* list (i.e. where
     *     each item to the iteration method is a Node.ELEMENT_NODE) and print
     *     each tag name:
     *     <code>
     *          fooStr = '';
     *          TP.nodeChildElementsPerform(
     *          TP.documentGetBody(document),
     *          function(aNode) {
     *
     *          fooStr += aNode.tagName + ' ';
     *          });
     *          fooStr;
     *          <samp>(output of tag names of direct children of the body
     *         element)</samp>
     *     </code>
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidFunction Raised when an invalid function is
     *     provided to the method.
     */

    var children,
        len,
        i,
        count;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (!TP.isCallable(aFunction)) {
        return TP.raise(this, 'TP.sig.InvalidFunction');
    }

    if (TP.isElement(aNode)) {
        //  condense multiple text node children
        TP.nodeNormalize(aNode);
    }

    children = aNode.childNodes;
    len = children.length;

    count = 0;

    for (i = 0; i < len; i++) {

        //  skip non-element children
        if (!TP.isElement(children[i])) {
            continue;
        }

        //  NOTE that we have to adjust the index so it's the index
        //  of child elements found...ie our count
        if (aFunction(children[i], count++) === TP.BREAK) {
            break;
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeChildNodesPerform',
function(aNode, aFunction) {

    /**
     * @method nodeChildNodesPerform
     * @summary Executes aFunction with each child node of the node. NOTE that
     *     as part of the processing here the node is normalized to coalesce
     *     adjacent text nodes.
     * @description Perform can be used as an alternative to constructing for
     *     loops to iterate over a collection. By returning TP.BREAK from your
     *     iterator you can also cause the enclosing iteration to terminate.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Function} aFunction A function which performs some action with
     *     each element provided.
     * @example Iterate across an XML node's child list and print the string
     *     value of each node:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><bar/>This is some
     *         text</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          fooStr = '';
     *          TP.nodeChildNodesPerform(
     *          xmlDoc.documentElement,
     *          function(aNode) {
     *
     *          fooStr += TP.str(aNode) + ' | ';
     *          });
     *          fooStr;
     *          <samp>&lt;bar xmlns="http://www.foo.com"/&gt; | This is some
     *         text | </samp>
     *     </code>
     * @example Iterate across an HTML node's child list and print the string
     *     value of each node:
     *     <code>
     *          fooStr = '';
     *          TP.nodeChildNodesPerform(
     *          TP.nodeGetElementsByTagName(document, 'head').first(),
     *          function(aNode) {
     *
     *          fooStr += aNode.tagName + ' ';
     *          });
     *          fooStr;
     *          <samp>(output of the string value of direct child nodes of the
     *         head element)</samp>
     *     </code>
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidFunction Raised when an invalid function is
     *     provided to the method.
     */

    var children,
        len,
        i;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (!TP.isCallable(aFunction)) {
        return TP.raise(this, 'TP.sig.InvalidFunction');
    }

    if (TP.isElement(aNode)) {
        //  condense multiple text node children
        TP.nodeNormalize(aNode);
    }

    children = aNode.childNodes;
    len = children.length;

    for (i = 0; i < len; i++) {
        if (aFunction(children[i], i) === TP.BREAK) {
            break;
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeDescendantsPerform',
function(aNode, aFunction, breadthFirst) {

    /**
     * @method nodeDescendantsPerform
     * @summary Executes aFunction with each descendant of the node.
     * @description aFunction implementations can return TP.BREAK to terminate
     *     the traversal, TP.CONTINUE to allow you to skip child content under
     *     an element and proceed to the next non-child element node for
     *     processing (only when the current item is an Element, not non-Element
     *     content) or TP.DESCEND to descend into child element content. If you
     *     need to reverse the iteration use TP.nodeGetDescendants() to get the
     *     descendant list and then use Array's perform operation.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Function} aFunction A function which performs some action with
     *     each node provided.
     * @param {Boolean} breadthFirst Breadth first if true. Default is false,
     *     meaning depth first.
     * @example Iterate across an XML node's descendant list and print the
     *     string value of each node:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><bar>This is some
     *         text</bar>This is some more text</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          fooStr = '';
     *          TP.nodeDescendantsPerform(
     *          xmlDoc.documentElement,
     *          function(aNode) {
     *
     *          fooStr += TP.str(aNode) + ' | ';
     *          });
     *          fooStr;
     *          <samp>&lt;bar xmlns="http://www.foo.com"&gt;This is some
     *         text&lt;/bar&gt; | This is some text | This is some more text |
     *         </samp>
     *     </code>
     * @example Iterate across an HTML node's descendant list and print the
     *     string value of each node:
     *     <code>
     *          fooStr = '';
     *          TP.nodeDescendantsPerform(
     *          TP.nodeGetElementsByTagName(document, 'head').first(),
     *          function(aNode) {
     *
     *          fooStr += aNode.tagName + ' ';
     *          });
     *          fooStr;
     *          <samp>(output of the string value of direct child nodes of the
     *         head element)</samp>
     *     </code>
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidFunction Raised when an invalid function is
     *     provided to the method.
     */

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (!TP.isCallable(aFunction)) {
        return TP.raise(this, 'TP.sig.InvalidFunction');
    }

    if (TP.isTrue(breadthFirst)) {
        return TP.nodeBreadthTraversal(
                            aNode, aFunction, null, aFunction, false);
    } else {
        return TP.nodeDepthTraversal(
                            aNode, aFunction, null, aFunction, false);
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeDescendantElementsPerform',
function(aNode, aFunction, breadthFirst) {

    /**
     * @method nodeDescendantElementsPerform
     * @summary Executes aFunction with each element descendant of the node.
     * @description aFunction implementations can return TP.BREAK to terminate
     *     the traversal, TP.CONTINUE to allow you to skip child content under
     *     an element and proceed to the next non-child element node for
     *     processing (only when the current item is an Element, not non-Element
     *     content) or TP.DESCEND to descend into child element content. If you
     *     need to reverse the iteration use TP.nodeGetDescendantElements() to
     *     get the descendant element list and then use Array's perform
     *     operation.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Function} aFunction A function which performs some action with
     *     each element provided.
     * @param {Boolean} breadthFirst Breadth first if true. Default is false,
     *     meaning depth first.
     * @example Iterate across an XML node's descendant *element* list (i.e.
     *     where each item to the iteration method is a Node.ELEMENT_NODE) and
     *     print each tag name:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo
     *         xmlns="http://www.foo.com"><bar/><baz><boo/></baz></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          fooStr = '';
     *          TP.nodeDescendantElementsPerform(
     *          xmlDoc.documentElement,
     *          function(aNode) {
     *
     *          fooStr += aNode.tagName + ' ';
     *          });
     *          fooStr;
     *          <samp>bar baz boo</samp>
     *     </code>
     * @example Iterate across an HTML node's descendant *element* list (i.e.
     *     where each item to the iteration method is a Node.ELEMENT_NODE) and
     *     print each tag name:
     *     <code>
     *          fooStr = '';
     *          TP.nodeDescendantElementsPerform(
     *          TP.documentGetBody(document),
     *          function(aNode) {
     *
     *          fooStr += aNode.tagName + ' ';
     *          });
     *          fooStr;
     *          <samp>(output of tag names of descendants of the body
     *         element)</samp>
     *     </code>
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidFunction Raised when an invalid function is
     *     provided to the method.
     */

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (!TP.isCallable(aFunction)) {
        return TP.raise(this, 'TP.sig.InvalidFunction');
    }

    if (TP.isTrue(breadthFirst)) {
        //  NOTE that we pass as push function only, so no content nodes
        return TP.nodeBreadthTraversal(aNode, aFunction, null, null, false);
    } else {
        //  NOTE that we pass as push function only, so no content nodes
        return TP.nodeDepthTraversal(aNode, aFunction, null, null, false);
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeSiblingsPerform',
function(aNode, aFunction, aSubset) {

    /**
     * @method nodeSiblingsPerform
     * @summary Executes aFunction with each sibling of the node.
     * @description Perform can be used as an alternative to constructing for
     *     loops to iterate over a collection. By returning TP.BREAK from your
     *     iterator you can also cause the enclosing iteration to terminate.
     *     Note that the index provided to aFunction is the index that would
     *     have been used had you collected the siblings in an array first.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Function} aFunction A function which performs some action with
     *     each element provided.
     * @param {String} aSubset TP.NEXT, TP.PREVIOUS, or null to collect all
     *     siblings.
     * @example Iterate across an XML node's sibling list and print each tag
     *     name:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo
     *         xmlns="http://www.foo.com"><bar/><baz/><boo/><goo/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          // Perform over the siblings of the 'baz' element
     *          fooStr = '';
     *          TP.nodeSiblingsPerform(
     *          xmlDoc.documentElement.childNodes[1],
     *          function(aNode) {
     *
     *          fooStr += aNode.tagName + ' ';
     *          });
     *          fooStr;
     *          <samp>bar boo goo</samp>
     *     </code>
     * @example Iterate across an XML node's 'previous' sibling list and print
     *     each tag name:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo
     *         xmlns="http://www.foo.com"><bar/><baz/><boo/><goo/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          // Perform over the previous siblings of the 'baz' element
     *          fooStr = '';
     *          TP.nodeSiblingsPerform(
     *          xmlDoc.documentElement.childNodes[1],
     *          function(aNode) {
     *
     *          fooStr += aNode.tagName + ' ';
     *          },
     *          null,
     *          true);
     *          fooStr;
     *          <samp>bar</samp>
     *
     * @example Iterate across an XML node's 'next' sibling list and print each
     *     tag name:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo
     *         xmlns="http://www.foo.com"><bar/><baz/><boo/><goo/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          // Perform over the next siblings of the 'baz' element
     *          fooStr = '';
     *          TP.nodeSiblingsPerform(
     *          xmlDoc.documentElement.childNodes[1],
     *          function(aNode) {
     *
     *          fooStr += aNode.tagName + ' ';
     *          },
     *          null,
     *          false);
     *          fooStr;
     *          <samp>boo goo</samp>
     *     </code>
     * @example Iterate across an HTML node's sibling list and print each tag
     *     name:
     *     <code>
     *          // Perform over the siblings of the 'body' element
     *          fooStr = '';
     *          TP.nodeSiblingsPerform(
     *          TP.documentGetBody(document),
     *          function(aNode) {
     *
     *          fooStr += aNode.tagName + ' ';
     *          });
     *          fooStr;
     *          <samp>HEAD</samp>
     *     </code>
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     * @exception TP.sig.InvalidFunction Raised when an invalid function is
     *     provided to the method.
     */

    var count,
        node,
        subset,

        siblings,
        len,
        i;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (!TP.isCallable(aFunction)) {
        return TP.raise(this, 'TP.sig.InvalidFunction');
    }

    count = 0;
    subset = aSubset;

    //  note this is the adjusted subset type
    switch (subset) {
        case TP.PREVIOUS:

            node = aNode.previousSibling;
            while (node) {
                if (aFunction(node, count++) === TP.BREAK) {
                    break;
                }

                node = node.previousSibling;
            }

            break;

        case TP.NEXT:

            node = aNode.nextSibling;
            while (node) {
                if (aFunction(node, count++) === TP.BREAK) {
                    break;
                }

                node = node.nextSibling;
            }

            break;

        default:

            siblings = aNode.parentNode.childNodes;
            len = siblings.length;

            for (i = 0; i < len; i++) {

                node = siblings[i];
                if (node === aNode) {
                    continue;
                }

                if (aFunction(node, count++) === TP.BREAK) {
                    break;
                }
            }

            break;
    }

    return;
});

//  ------------------------------------------------------------------------
//  NODE CONTENT DETECTION
//  ------------------------------------------------------------------------

TP.definePrimitive('nodeDetectAncestor',
function(aNode, aFunction) {

    /**
     * @method nodeDetectAncestor
     * @summary Returns the first ancestor of aNode for which aFunction returns
     *     true. The normal direction of this search is from the node "outward"
     *     toward the document root.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable node.
     * @example Iterate up an XML node's ancestor chain, finding the first
     *     element with a tag name of 'bar':
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo
     *         xmlns="http://www.foo.com"><bar><baz><boo/></baz></bar></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          result = TP.nodeDetectAncestor(
     *          TP.nodeGetElementsByTagName(xmlDoc, 'boo').first(),
     *          function(aNode) {
     *
     *          if (TP.elementGetLocalName(aNode) == 'bar') {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          <samp>[object Element]</samp>
     *          TP.elementGetLocalName(result);
     *          <samp>bar</samp>
     *     </code>
     * @example Iterate up an HTML node's ancestor chain, finding the first
     *     element with a tag name of 'html':
     *     <code>
     *          TP.nodeDetectAncestor(
     *          TP.documentGetBody(document).firstChild,
     *          function(aNode) {
     *
     *          if (TP.elementGetLocalName(aNode).toLowerCase() == 'html') {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          <samp>[object HTMLHtmlElement]</samp>
     *     </code>
     * @returns {Node} An ancestor found acceptable by aFunction.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     * @exception TP.sig.InvalidFunction Raised when an invalid function is
     *     provided to the method.
     */

    var found;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (!TP.isCallable(aFunction)) {
        return TP.raise(this, 'TP.sig.InvalidFunction');
    }

    TP.nodeAncestorsPerform(
        aNode,
        function(node, index) {

            if (aFunction(node, index)) {
                found = node;
                return TP.BREAK;
            }
        });

    return found;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeDetectChildElement',
function(aNode, aFunction) {

    /**
     * @method nodeDetectChildElement
     * @summary Returns the first child element of aNode for which aFunction
     *     returns true. Iteration is from firstChild to lastChild.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable node.
     * @example Iterate over an XML node's child Element list, finding the first
     *     element with a tag name of 'baz':
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><bar/><baz/><boo/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          result = TP.nodeDetectChildElement(
     *          xmlDoc.documentElement,
     *          function(aNode) {
     *
     *          if (TP.elementGetLocalName(aNode) == 'baz') {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          <samp>[object Element]</samp>
     *          TP.str(result);
     *          <samp>&lt;baz xmlns="http://www.foo.com"/&gt;</samp>
     *
     * @example Iterate over an HTML node's child Element list, finding the
     *     first element with a tag name of 'head':
     *     <code>
     *          TP.nodeDetectChildElement(
     *          document.documentElement,
     *          function(aNode) {
     *
     *          if (TP.elementGetLocalName(aNode).toLowerCase() == 'head') {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          <samp>[object HTMLHeadElement]</samp>
     * @returns {Node} An child element found acceptable by aFunction.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     * @exception TP.sig.InvalidFunction Raised when an invalid function is
     *     provided to the method.
     */

    var found;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (!TP.isCallable(aFunction)) {
        return TP.raise(this, 'TP.sig.InvalidFunction');
    }

    TP.nodeChildElementsPerform(
        aNode,
        function(node, index) {

            if (aFunction(node, index)) {
                found = node;
                return TP.BREAK;
            }
        });

    return found;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeDetectChildNode',
function(aNode, aFunction) {

    /**
     * @method nodeDetectChildNode
     * @summary Returns the first child node of aNode for which aFunction
     *     returns true. Iteration is from firstChild to lastChild.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable node.
     * @example Iterate over an XML node's child list, finding the first node
     *     with a string value of 'More text':
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><bar/>Some text<baz/>More
     *         text<boo/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          result = TP.nodeDetectChildNode(
     *          xmlDoc.documentElement,
     *          function(aNode) {
     *
     *          if (TP.nodeGetTextContent(aNode) == 'More text') {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          <samp>[object Text]</samp>
     *          TP.str(result);
     *          <samp>More text</samp>
     *
     * @example Iterate over an HTML node's child list, finding the first node
     *     with an index of 1 (this method is for exposition purposes -
     *     'TP.nodeGetChildNodes(TP.documentGetBody(document)).at(1);' is a more
     *     efficient way to do this):
     *     <code>
     *          TP.nodeDetectChildNode(
     *          TP.documentGetBody(document),
     *          function(aNode) {
     *
     *          if (TP.nodeGetIndexInParent(aNode) == 1) {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          <samp>(the HTML node with an index of 1 in the body)</samp>
     * @returns {Node} An child node found acceptable by aFunction.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidFunction Raised when an invalid function is
     *     provided to the method.
     */

    var found;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (!TP.isCallable(aFunction)) {
        return TP.raise(this, 'TP.sig.InvalidFunction');
    }

    TP.nodeChildNodesPerform(
        aNode,
        function(node, index) {

            if (aFunction(node, index)) {
                found = node;
                return TP.BREAK;
            }
        },
        null);

    return found;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeDetectDescendant',
function(aNode, aFunction, breadthFirst) {

    /**
     * @method nodeDetectDescendant
     * @summary Returns the first descendant of aNode for which aFunction
     *     returns true. Search is typically downward in a depth-first fashion.
     * @description If you need to reverse the iteration use
     *     TP.nodeGetDescendants() to get the descendant list and then use
     *     Array's perform operation.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable node.
     * @param {Boolean} breadthFirst Breadth first if true. Default is false,
     *     meaning depth first.
     * @example Iterate over an XML node's descendant list, finding the first
     *     node with a string value of 'More text':
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><bar/><goo>Some
     *         text</goo><baz/><boo>More text</boo></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          result = TP.nodeDetectDescendant(
     *          xmlDoc.documentElement,
     *          function(aNode) {
     *
     *          // Note here that this call will reach into the
     *          // content of Node.ELEMENT_NODEs and get a
     *          // normalized text value.
     *          if (TP.nodeGetTextContent(aNode) == 'More text') {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          <samp>[object Element]</samp>
     *          TP.str(result);
     *          // We got the 'boo' *element* because the
     *          // 'TP.nodeGetTextContent()' call above reached into the
     *          // Element first (before it traversed to the actual
     *          // Text node), did the comparison, and returned true.
     *          <samp>&lt;boo xmlns="http://www.foo.com"&gt;More
     *         text&lt;/boo&gt;</samp>
     *
     * @example Iterate over an HTML node's descendant list, finding the first
     *     Element node with a 'style' attribute having any value (this example
     *     is for exposition purposes -
     *     'TP.nodeGetDescendantElementsByAttribute(
     *     TP.documentGetBody(document), 'style').first();' is a more efficient
     *     way to do this):
     *     <code>
     *          TP.nodeDetectDescendant(
     *          TP.documentGetBody(document),
     *          function(aNode) {
     *
     *          if (TP.isElement(aNode) &&
     *          TP.elementHasAttribute(aNode, 'style')) {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          <samp>(the first HTML descendant of the body element with a
     *         style attribute having a value)</samp>
     * @returns {Node} A descendant node found acceptable by aFunction.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidFunction Raised when an invalid function is
     *     provided to the method.
     */

    var found;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (!TP.isCallable(aFunction)) {
        return TP.raise(this, 'TP.sig.InvalidFunction');
    }

    TP.nodeDescendantsPerform(
        aNode,
        function(node, index) {

            if (aFunction(node, index)) {
                found = node;
                return TP.BREAK;
            }
        },
        null,
        breadthFirst);

    return found;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeDetectDescendantElement',
function(aNode, aFunction, breadthFirst) {

    /**
     * @method nodeDetectDescendantElement
     * @summary Returns the first element descendant of aNode for which
     *     aFunction returns true. Search is typically downward in a depth-first
     *     fashion.
     * @description If you need to reverse the iteration use
     *     TP.nodeGetDescendantElements() to get the descendant list and then
     *     use Array's perform operation.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable node.
     * @param {Boolean} breadthFirst Breadth first if true. Default is false,
     *     meaning depth first.
     * @example Iterate over an XML node's descendant *element* list (i.e. where
     *     each item to the iteration method is a Node.ELEMENT_NODE), finding
     *     the first element with an underlying 'text value' of 'Some text':
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><bar/><goo>Some
     *         text</goo><baz/><boo>More text</boo></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          result = TP.nodeDetectDescendantElement(
     *          xmlDoc.documentElement,
     *          function(aNode) {
     *
     *          // Note here that this call will reach into the
     *          // content of Node.ELEMENT_NODEs and get a
     *          // normalized text value.
     *          if (TP.nodeGetTextContent(aNode) == 'Some text') {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          <samp>[object Element]</samp>
     *          TP.str(result);
     *          // We got the 'goo' *element* because the
     *          // 'TP.nodeGetTextContent()' call above reached into the
     *          // Element first (before it traversed to the actual
     *          // Text node), did the comparison, and returned true.
     *          <samp>&lt;goo xmlns="http://www.foo.com"&gt;More
     *         text&lt;/goo&gt;</samp>
     *
     * @example Iterate over an HTML node's descendant *element* list (i.e.
     *     where each item to the iteration method is a Node.ELEMENT_NODE),
     *     finding the first Element node with a 'style' attribute having any
     *     value (this example is for exposition purposes -
     *     'TP.nodeGetDescendantElementsByAttribute(
     *     TP.documentGetBody(document), 'style').first();' is a more efficient
     *     way to do this):
     *     <code>
     *          TP.nodeDetectDescendantElement(
     *          TP.documentGetBody(document),
     *          function(aNode) {
     *
     *          if (TP.elementHasAttribute(aNode, 'style')) {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          <samp>(the first HTML descendant of the body element with a
     *         style attribute having a value)</samp>
     * @returns {Node} A descendant element found acceptable by aFunction.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidFunction Raised when an invalid function is
     *     provided to the method.
     */

    var found;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (!TP.isCallable(aFunction)) {
        return TP.raise(this, 'TP.sig.InvalidFunction');
    }

    TP.nodeDescendantElementsPerform(
        aNode,
        function(node, index) {

            if (aFunction(node, index)) {
                found = node;
                return TP.BREAK;
            }
        },
        null,
        breadthFirst);

    return found;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeDetectSibling',
function(aNode, aFunction, aSubset) {

    /**
     * @method nodeDetectSibling
     * @summary Returns the first sibling node (next, previous, or any) of
     *     aNode for which aFunction returns true.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable node.
     * @param {String} aSubset TP.NEXT, TP.PREVIOUS, or null to collect all
     *     siblings.
     * @example Iterate over an XML node's sibling list finding the first node
     *     starting at the 'bar' element that is both an Element and has a local
     *     name of 'goo':
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><bar/><goo>Some
     *         text</goo><baz/><boo>More text</boo></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          result = TP.nodeDetectSibling(
     *          xmlDoc.documentElement.firstChild,
     *          function(aNode) {
     *
     *          if (TP.isElement(aNode) &&
     *          (TP.elementGetLocalName(aNode) == 'goo')) {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          <samp>[object Element]</samp>
     *          TP.str(result);
     *          <samp>&lt;goo xmlns="http://www.foo.com"&gt;More
     *         text&lt;/goo&gt;</samp>
     *
     * @example Iterate over an XML node's 'previous' sibling list finding the
     *     first node starting at the 'bar' element that is both an Element and
     *     has a local name of 'goo':
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><bar/><goo>Some
     *         text</goo><baz/><boo>More text</boo></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          result = TP.nodeDetectSibling(
     *          xmlDoc.documentElement.firstChild,
     *          function(aNode) {
     *
     *          if (TP.isElement(aNode) &&
     *          (TP.elementGetLocalName(aNode) == 'goo')) {
     *          return true;
     *          };
     *
     *          return false;
     *          },
     *          null,
     *          true);
     *          <samp>undefined</samp>
     *          This is correct as there isn't an Element node before
     *          'bar' with a tag name of 'goo'
     *
     * @example Iterate over an XML node's 'next' sibling list finding the first
     *     node starting at the 'bar' element that is both an Element and has a
     *     local name of 'goo':
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><bar/><goo>Some
     *         text</goo><baz/><boo>More text</boo></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          result = TP.nodeDetectSibling(
     *          xmlDoc.documentElement.firstChild,
     *          function(aNode) {
     *
     *          if (TP.isElement(aNode) &&
     *          (TP.elementGetLocalName(aNode) == 'goo')) {
     *          return true;
     *          };
     *
     *          return false;
     *          },
     *          null,
     *          false);
     *          <samp>[object Element]</samp>
     *          TP.str(result);
     *          <samp>&lt;goo xmlns="http://www.foo.com"&gt;More
     *         text&lt;/goo&gt;</samp>
     *
     * @example Iterate over an HTML node's sibling list finding the first node
     *     starting at the first child that is both an Element and has a local
     *     name of 'body':
     *     <code>
     *          TP.nodeDetectSibling(
     *          document.documentElement.firstChild,
     *          function(aNode) {
     *
     *          if (TP.isElement(aNode) &&
     *          (TP.elementGetLocalName(aNode).toLowerCase() == 'body')) {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          <samp>[object HTMLBodyElement]</samp>
     * @returns {Node} A sibling node found acceptable by aFunction.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     * @exception TP.sig.InvalidFunction Raised when an invalid function is
     *     provided to the method.
     */

    var found;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (!TP.isCallable(aFunction)) {
        return TP.raise(this, 'TP.sig.InvalidFunction');
    }

    TP.nodeSiblingsPerform(
        aNode,
        function(node, index) {

            if (aFunction(node, index)) {
                found = node;
                return TP.BREAK;
            }
        },
        aSubset);

    return found;
});

//  ------------------------------------------------------------------------
//  NODE CONTENT SELECTION (FILTERING)
//  ------------------------------------------------------------------------

TP.definePrimitive('nodeSelectAncestors',
function(aNode, aFunction) {

    /**
     * @method nodeSelectAncestors
     * @summary Returns an array of ancestors of aNode for which aFunction
     *     returns true. The normal direction of this search is from the node
     *     "outward" toward the document root.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable node.
     * @example Iterate up an XML node's ancestor chain and return only those
     *     that have a tag name of 'foo':
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo
     *         xmlns="http://www.foo.com"><bar><foo><boo/></foo></bar></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          result = TP.nodeSelectAncestors(
     *          TP.nodeGetElementsByTagName(xmlDoc, 'boo').first(),
     *          function(aNode) {
     *
     *          if (TP.elementGetLocalName(aNode) == 'foo') {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          <samp>[object Element], [object Element]</samp>
     *          result.collect(
     *          function(aNode) {
     *
     *          return TP.elementGetLocalName(aNode);
     *          });
     *          <samp>foo, foo</samp>
     *     </code>
     * @example Iterate up an HTML node's ancestor chain and return only those
     *     that have a tag name of 'html':
     *     <code>
     *          TP.nodeSelectAncestors(
     *          TP.documentGetBody(document),
     *          function(aNode) {
     *
     *          if (TP.elementGetLocalName(aNode).toLowerCase() == 'html') {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          // This is an Array
     *          <samp>[object HTMLHtmlElement]</samp>
     *     </code>
     * @returns {Node[]} An Array of ancestors found acceptable by aFunction.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     * @exception TP.sig.InvalidFunction Raised when an invalid function is
     *     provided to the method.
     */

    var arr;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (!TP.isCallable(aFunction)) {
        return TP.raise(this, 'TP.sig.InvalidFunction');
    }

    arr = TP.ac();

    TP.nodeAncestorsPerform(
        aNode,
        function(node, index) {

            if (aFunction(node, index)) {
                arr.push(node);
            }
        });

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeSelectChain',
function(aNode, aProperty) {

    /**
     * @method nodeSelectChain
     * @summary Returns an Array of objects that are obtained by recursively
     *     obtaining the property on each object, starting with the supplied DOM
     *     node.
     * @param {Node} aNode The DOM node to operate on.
     * @param {String} aProperty The property name to use to obtain each return
     *     value.
     * @example Select all of an XML node's parent node list:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><bar><baz/></bar></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          // Grab the 'baz' element
     *          anElem = TP.nodeGetElementsByTagName(xmlDoc, 'baz').first();
     *          <samp>[object Element]</samp>
     *          // Grab all of its parent nodes (including #document
     *          // itself)
     *          parents = TP.nodeSelectChain(anElem, 'parentNode');
     *          parents.collect(function (anElem) {return anElem.nodeName});
     *          <samp>bar, foo, #document</samp>
     *     </code>
     * @example Select all of an HTML node's parent node node list:
     *     <code>
     *          parents = TP.nodeSelectChain(TP.documentGetBody(document),
     *         'parentNode');
     *          <samp>[object HTMLHtmlElement], [object HTMLDocument]</samp>
     *     </code>
     * @returns {Object[]} An Array of objects obtained by recursing using the
     *     supplied property.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     * @exception TP.sig.InvalidParameter Raised when an empty property name is
     *     provided to the method.
     */

    var anObj,
        arr;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (TP.isEmpty(aProperty)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    arr = TP.ac();

    anObj = aNode;

    while (TP.isValid(anObj = anObj[aProperty])) {
        arr.push(anObj);
    }

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeSelectChildElements',
function(aNode, aFunction) {

    /**
     * @method nodeSelectChildElements
     * @summary Returns an Array of child elements of aNode for which aFunction
     *     returns true. Iteration is from firstChild to lastChild.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable node.
     * @example Iterate across an XML node's child *element* list (i.e. where
     *     each item to the iteration method is a Node.ELEMENT_NODE) and return
     *     only those that have a tag name of 'foo':
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><bar/><baz/><foo/></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeSelectChildElements(
     *          xmlDoc.documentElement,
     *          function(aNode) {
     *
     *          if (TP.elementGetLocalName(aNode) == 'foo') {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          // This is an Array
     *          <samp>[object Element]</samp>
     *     </code>
     * @example Iterate across an HTML node's child *element* list (i.e. where
     *     each item to the iteration method is a Node.ELEMENT_NODE) and return
     *     only those that have a tag name of 'head':
     *     <code>
     *          TP.nodeSelectChildElements(
     *          document.documentElement,
     *          function(aNode) {
     *
     *          if (TP.elementGetLocalName(aNode).toLowerCase() == 'head') {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          // This is an Array
     *          <samp>[object HTMLHeadElement]</samp>
     *     </code>
     * @returns {Element[]} An Array of child elements found acceptable by
     *     aFunction.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidFunction Raised when an invalid function is
     *     provided to the method.
     */

    var arr;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (!TP.isCallable(aFunction)) {
        return TP.raise(this, 'TP.sig.InvalidFunction');
    }

    arr = TP.ac();

    TP.nodeChildElementsPerform(
        aNode,
        function(node, index) {

            if (aFunction(node, index)) {
                arr.push(node);
            }
        });

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeSelectChildNodes',
function(aNode, aFunction) {

    /**
     * @method nodeSelectChildNodes
     * @summary Returns an Array of children of aNode for which aFunction
     *     returns true. Iteration is from firstChild to lastChild.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable node.
     * @example Iterate across an XML node's child list and return only those
     *     that have a string value of 'More text':
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><bar/>More text<baz/>Some
     *         text<bar/>More text</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeSelectChildNodes(
     *          xmlDoc.documentElement,
     *          function(aNode) {
     *
     *          if (TP.str(aNode) == 'More text') {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          <samp>[object Text], [object Text]</samp>
     *     </code>
     * @example Iterate across an HTML node's child list and return only those
     *     that are both an Element and have a tag name of 'head':
     *     <code>
     *          TP.nodeSelectChildNodes(
     *          document.documentElement,
     *          function(aNode) {
     *
     *          if (TP.isElement(aNode) &&
     *         (TP.elementGetLocalName(aNode).toLowerCase() == 'head')) {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          // This is an Array
     *          <samp>[object HTMLHeadElement]</samp>
     *     </code>
     * @returns {Node[]} An Array of child nodes found acceptable by aFunction.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidFunction Raised when an invalid function is
     *     provided to the method.
     */

    var arr;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (!TP.isCallable(aFunction)) {
        return TP.raise(this, 'TP.sig.InvalidFunction');
    }

    arr = TP.ac();

    TP.nodeChildNodesPerform(
        aNode,
        function(node, index) {

            if (aFunction(node, index)) {
                arr.push(node);
            }
        },
        null);

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeSelectDescendants',
function(aNode, aFunction, breadthFirst) {

    /**
     * @method nodeSelectDescendants
     * @summary Returns an Array of descendants of aNode for which aFunction
     *     returns true. Search is typically downward in a depth-first fashion.
     * @description If you need to reverse the iteration use
     *     TP.nodeGetDescendants() to get the descendant list and then use
     *     Array's perform operation.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable node.
     * @param {Boolean} breadthFirst Breadth first if true. Default is false,
     *     meaning depth first.
     * @example Iterate across an XML node's descendant list and return only
     *     those that have a string value of 'Some text':
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><bar>More text<baz/>Some
     *         text</bar>More text</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeSelectDescendants(
     *          xmlDoc.documentElement,
     *          function(aNode) {
     *
     *          if (TP.str(aNode) == 'Some text') {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          // This is an Array
     *          <samp>[object Text]</samp>
     *     </code>
     * @example Iterate across an HTML node's descendant list and return only
     *     those that are both an Element and have a tag name of 'span':
     *     <code>
     *          TP.nodeSelectDescendants(
     *          document.documentElement,
     *          function(aNode) {
     *
     *          if (TP.isElement(aNode) &&
     *         (TP.elementGetLocalName(aNode).toLowerCase() == 'span')) {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          // This is an Array
     *          <samp>(all of the 'span' elements that are under the document
     *         element)</samp>
     *     </code>
     * @returns {Node[]} An Array of descendant nodes found acceptable by
     *     aFunction.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidFunction Raised when an invalid function is
     *     provided to the method.
     */

    var arr;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (!TP.isCallable(aFunction)) {
        return TP.raise(this, 'TP.sig.InvalidFunction');
    }

    arr = TP.ac();

    TP.nodeDescendantsPerform(
        aNode,
        function(node, index) {

            if (aFunction(node, index)) {
                arr.push(node);
            }
        },
        null,
        breadthFirst);

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeSelectDescendantElements',
function(aNode, aFunction, breadthFirst) {

    /**
     * @method nodeSelectDescendantElements
     * @summary Returns an Array of descendant elements of aNode for which
     *     aFunction returns true. Search is typically downward in a depth-first
     *     fashion.
     * @description If you need to reverse the iteration use
     *     TP.nodeGetDescendantElements() to get the descendant list and then
     *     use Array's perform operation.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable node.
     * @param {Boolean} breadthFirst Breadth first if true. Default is false,
     *     meaning depth first.
     * @example Iterate across an XML node's descendant *element* list (i.e.
     *     where each item to the iteration method is a Node.ELEMENT_NODE), and
     *     return only those that have a local name of 'boo':
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><boo>More text<baz/>Some
     *         text</boo>More text</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          result = TP.nodeSelectDescendantElements(
     *          xmlDoc.documentElement,
     *          function(aNode) {
     *
     *          if (TP.elementGetLocalName(aNode) == 'boo') {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          // This is an Array
     *          <samp>[object Element]</samp>
     *          TP.str(result.at(0));
     *          <samp>&lt;boo xmlns="http://www.foo.com"&gt;More
     *         text&lt;<baz/&gt;Some text&lt;/boo&gt;</samp>
     *     </code>
     * @example Iterate across an HTML node's descendant *element* list (i.e.
     *     where each item to the iteration method is a Node.ELEMENT_NODE), and
     *     return only those that have a tag name of 'span':
     *     <code>
     *          TP.nodeSelectDescendantElements(
     *          document.documentElement,
     *          function(aNode) {
     *
     *          if (TP.elementGetLocalName(aNode).toLowerCase() == 'span') {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          // This is an Array
     *          <samp>(all of the 'span' elements that are under the document
     *         element)</samp>
     *     </code>
     * @returns {Element[]} An Array of descendant elements found acceptable by
     *     aFunction.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     * @exception TP.sig.InvalidFunction Raised when an invalid function is
     *     provided to the method.
     */

    var arr;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (!TP.isCallable(aFunction)) {
        return TP.raise(this, 'TP.sig.InvalidFunction');
    }

    arr = TP.ac();

    TP.nodeDescendantElementsPerform(
        aNode,
        function(node, index) {

            if (aFunction(node, index)) {
                arr.push(node);
            }
        },
        null,
        breadthFirst);

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeSelectSiblings',
function(aNode, aFunction, aSubset) {

    /**
     * @method nodeSelectSiblings
     * @summary Returns an array of siblings (next, previous, or any) of aNode
     *     for which aFunction returns true.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable node.
     * @param {String} aSubset TP.NEXT, TP.PREVIOUS, or null to collect all
     *     siblings.
     * @example Iterate over an XML node's sibling list finding all nodes
     *     starting at the 'bar' element that is both an Element and has a local
     *     name of 'goo':
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><bar/><goo>Some
     *         text</goo><baz/><goo>More text</goo></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          result = TP.nodeSelectSiblings(
     *          xmlDoc.documentElement.firstChild,
     *          function(aNode) {
     *
     *          if (TP.isElement(aNode) &&
     *          (TP.elementGetLocalName(aNode) == 'goo')) {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          <samp>[object Element], [object Element]</samp>
     *          result.collect(function (aNode) {return aNode.tagName});
     *          <samp>goo, goo</samp>
     *
     * @example Iterate over an XML node's 'previous' sibling list finding all
     *     nodes starting at the 'bar' element that is both an Element and has a
     *     local name of 'goo':
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><bar/><goo>Some
     *         text</goo><baz/><goo>More text</goo></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          result = TP.nodeSelectSiblings(
     *          xmlDoc.documentElement.firstChild,
     *          function(aNode) {
     *
     *          if (TP.isElement(aNode) &&
     *          (TP.elementGetLocalName(aNode) == 'goo')) {
     *          return true;
     *          };
     *
     *          return false;
     *          },
     *          null,
     *          true);
     *          <samp>(empty Array)</samp>
     *          This is correct as there isn't an Element node before
     *          'bar' with a tag name of 'goo'
     *
     * @example Iterate over an XML node's 'next' sibling list finding all nodes
     *     starting at the 'bar' element that is both an Element and has a local
     *     name of 'goo':
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><bar/><goo>Some
     *         text</goo><baz/><goo>More text</goo></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          result = TP.nodeSelectSiblings(
     *          xmlDoc.documentElement.firstChild,
     *          function(aNode) {
     *
     *          if (TP.isElement(aNode) &&
     *          (TP.elementGetLocalName(aNode) == 'goo')) {
     *          return true;
     *          };
     *
     *          return false;
     *          },
     *          null,
     *          false);
     *          <samp>[object Element], [object Element]</samp>
     *          result.collect(function (aNode) {return aNode.tagName});
     *          <samp>goo, goo</samp>
     *
     * @example Iterate over an HTML node's sibling list finding the all nodes
     *     starting at the body element's first child that is both an Element
     *     and has a local name of 'span':
     *     <code>
     *          TP.nodeSelectSiblings(
     *          TP.documentGetBody(document).firstChild,
     *          function(aNode) {
     *
     *          if (TP.isElement(aNode) &&
     *         (TP.elementGetLocalName(aNode).toLowerCase() == 'span')) {
     *          return true;
     *          };
     *
     *          return false;
     *          });
     *          <samp>(all span elements that are siblings of the body element's
     *         first child)</samp>
     * @returns {Node[]} An Array of sibling nodes found acceptable by
     *          aFunction.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     * @exception TP.sig.InvalidFunction Raised when an invalid function is
     *     provided to the method.
     */

    var arr;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (!TP.isCallable(aFunction)) {
        return TP.raise(this, 'TP.sig.InvalidFunction');
    }

    arr = TP.ac();

    TP.nodeSiblingsPerform(
        aNode,
        function(node, index) {

            if (aFunction(node, index)) {
                arr.push(node);
            }
        },
        aSubset);

    return arr;
});

//  ------------------------------------------------------------------------
//  NODE NAMESPACE SUPPORT
//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetDefaultNSURI',
function(aNode, includeDefault) {

    /**
     * @method nodeGetDefaultNSURI
     * @summary Returns the default namespace that the node is in.
     * @description If the supplied element is an Element and is unprefixed,
     *     its namespace URI will be returned. If it is an Element and is
     *     prefixed, this method will continue to search its ancestor chain,
     *     looking for the first unprefixed element and return its namespace.
     * @param {Node} aNode The node to return the current default namespace URI
     *     of.
     * @returns {String|null} The default namespace of the supplied Node.
     */

    var ancestor;

    if (TP.isElement(aNode) && TP.isEmpty(aNode.prefix)) {
        return aNode.namespaceURI;
    }

    ancestor = aNode.parentNode;
    while (TP.isElement(ancestor)) {
        if (TP.isEmpty(ancestor.prefix)) {
            return ancestor.namespaceURI;
        }

        ancestor = ancestor.parentNode;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetNSPrefixes',
function(aNode, aNamespaceURI, includeDescendants) {

    /**
     * @method nodeGetNSPrefixes
     * @summary Returns an Array of namespace prefixes for aNamespaceURI on or
     *     in the supplied node.
     * @description The default call searches only the local attributes on the
     *     node. Passing true to includeDescendants will cause the entire node's
     *     content to be searched for prefixes.
     * @param {Node} aNode The XML node to retrieve the namespace prefixes for.
     * @param {String} aNamespaceURI The namespace URI to return the array of
     *     prefixes for. If empty, all defined prefixes will be returned.
     * @param {Boolean} includeDescendants Should the search run across the
     *     entire DOM tree? Default is false.
     * @example Obtain the namespace prefixes for the document element of an XML
     *     document:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"
     *         xmlns:bar="http://www.bar.com"><goo
     *         xmlns:baz="http://www.baz.com">Hi</goo> there</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetNSPrefixes(xmlDoc.documentElement);
     *          <samp>bar</samp>
     *     </code>
     * @example Obtain the namespace prefixes for the document element *and its
     *     descendant elements* of an XML document:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"
     *         xmlns:bar="http://www.bar.com"><goo
     *         xmlns:baz="http://www.baz.com">Hi</goo> there</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetNSPrefixes(xmlDoc.documentElement, null, true);
     *          <samp>bar, baz</samp>
     *     </code>
     * @example Obtain the namespace prefixes for the document element *and its
     *     descendant elements* of an XML document, but only for the
     *     'http://www.baz.com' namespace:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"
     *         xmlns:bar="http://www.bar.com"><goo
     *         xmlns:baz="http://www.baz.com">Hi</goo> there</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetNSPrefixes(xmlDoc.documentElement,
     *          'http://www.baz.com',
     *          true);
     *          <samp>baz</samp>
     *     </code>
     * @returns {String[]} An array of namespace prefixes for the supplied
     *     aNamespaceURI in the document.
     * @exception TP.sig.InvalidParameter Raised when a node that isn't of type
     *     Node.ELEMENT_NODE or Node.DOCUMENT_NODE is provided to the method.
     */

    var arr,

        uris,
        prefixes,

        str,
        re,

        node,
        attrs,

        len,
        i,

        attr;

    //  we only do this for document and element node types
    if (!TP.isDocument(aNode) && !TP.isElement(aNode)) {
        TP.raise(this, 'TP.sig.InvalidParameter',
                                    'Node not an element or document.');
        return;
    }

    //  either way we'll need our result array
    arr = TP.ac();

    //  when no specific URI is provided we get the list of all that apply
    if (TP.isEmpty(aNamespaceURI)) {
        uris = TP.nodeGetNSURIs(aNode, includeDescendants);

        prefixes = uris.collect(
                function(uri) {

                    return TP.nodeGetNSPrefixes(aNode, uri,
                                                includeDescendants);
                });

        //  array of arrays, becomes a flat array with empty child arrays
        //  removed
        return prefixes.flatten().unique();
    }

    if (TP.isTrue(includeDescendants)) {
        str = TP.nodeAsString(aNode);

        re = TP.rc('xmlns:([^=]*)?="' +
                    TP.regExpEscape(aNamespaceURI) + '"', 'g');

        str.replace(
                re,
                function(wholeMatch, prefix) {

                    if (TP.notEmpty(prefix)) {
                        arr.push(prefix);
                    }

                    return wholeMatch;
                });

        //  in this case we want to unique the resulting list to avoid
        //  duplicates due to different NS contexts in the content
        arr.unique();
    } else {
        //  if we're not worried about child content we can work with the
        //  element's attribute list
        if (TP.isDocument(aNode)) {
            node = aNode.documentElement;
        } else if (TP.isElement(aNode)) {
            node = aNode;
        } else {
            return TP.raise(this, 'TP.sig.InvalidElement');
        }

        attrs = node.attributes;
        len = attrs.length;

        for (i = 0; i < len; i++) {
            attr = attrs[i];
            if (attr.value === aNamespaceURI) {
                if (/xmlns:/.test(attr.name)) {
                    arr.push(attr.name.slice(6));
                }
            }
        }
    }

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetNSURI',
function(aNode) {

    /**
     * @method nodeGetNSURI
     * @summary Returns the namespaceURI of the node. This is typically found
     *     in the namepaceURI but in certain circumstances you'll get an empty
     *     value there even when the xmlns attribute is in place.
     * @param {Node} aNode The XML node to retrieve the namespace URI for.
     * @example Obtain the namespace URI for the document element of an XML
     *     document:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"
     *         xmlns:bar="http://www.bar.com"><goo
     *         xmlns:baz="http://www.baz.com">Hi</goo> there</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetNSURI(xmlDoc.documentElement);
     *          <samp>http://www.foo.com</samp>
     *     </code>
     * @returns {String} A namespace URI or the empty string.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     */

    var ns,
        node,
        attrs,
        len,
        i;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (TP.notEmpty(ns = aNode.namespaceURI)) {
        return ns;
    }

    node = TP.isDocument(aNode) ? aNode.documentElement : aNode;

    if (TP.isElement(node)) {
        attrs = node.attributes;
        len = attrs.length;

        for (i = 0; i < len; i++) {
            if (attrs[i].name === 'xmlns') {
                return attrs[i].value;
            }
        }
    }

    return '';
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetNSURIs',
function(aNode, includeDescendants) {

    /**
     * @method nodeGetNSURIs
     * @summary Returns an Array of unique namespace URIs in the supplied XML
     *     Node.
     * @param {Node} aNode The XML node to retrieve the namespace URIs for.
     * @param {Boolean} includeDescendants Should the search run across the
     *     entire DOM tree? Default is false.
     * @example Obtain the namespace URIs defined in the document element of an
     *     XML document:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"
     *         xmlns:bar="http://www.bar.com"><goo
     *         xmlns:baz="http://www.baz.com">Hi</goo> there</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetNSURIs(xmlDoc.documentElement);
     *          <samp>http://www.foo.com, http://www.bar.com</samp>
     *     </code>
     * @example Obtain the namespace prefixes defined in the document element
     *     *and its descendant elements* of an XML document:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"
     *         xmlns:bar="http://www.bar.com"><goo
     *         xmlns:baz="http://www.baz.com">Hi</goo> there</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetNSURIs(xmlDoc.documentElement, true);
     *          <samp>http://www.foo.com, http://www.bar.com,
     *         http://www.baz.com</samp>
     *     </code>
     * @returns {String[]} An array of unique namespace URIs found in the node.
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     */

    var node,

        arr,

        str,

        attrs,

        len,
        i;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    //  We may reassign this below, so we assign it here.

    node = aNode;

    switch (node.nodeType) {
        case Node.ATTRIBUTE_NODE:

            arr = TP.ac(aNode.namespaceURI);
            break;

            /* eslint-disable no-fallthrough */

        case Node.DOCUMENT_NODE:

            //  NOTE fallthrough here so we work on documentElement
            node = node.documentElement;

        case Node.ELEMENT_NODE:

            arr = TP.ac();

            if (TP.isTrue(includeDescendants)) {
                str = TP.nodeAsString(node);
                arr = TP.ac();

                TP.regex.NS_EXTRACTION.lastIndex = 0;
                str.replace(TP.regex.NS_EXTRACTION,
                            function(wholeMatch, prefix, uri) {

                                if (TP.isURIString(uri)) {
                                    arr.push(uri);
                                }

                                return wholeMatch;
                            });

                return arr.unique();
            }

            attrs = node.attributes;
            len = attrs.length;

            for (i = 0; i < len; i++) {
                if (/xmlns[:]?/.test(attrs[i].name)) {
                    arr.push(attrs[i].value);
                }
            }

            break;

        default:

            arr = TP.ac();
            break;
    }

    return arr;
});

//  ------------------------------------------------------------------------
//  NODE "GETTERS"
//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetTextContent',
function(aNode) {

    /**
     * @method nodeGetTextContent
     * @summary Returns the text value of the node provided.
     * @description The actual behavior varies based on node type, but the
     *     result is the same, the content considered to be the text value of
     *     the receiving node is returned. For Element nodes, the text value of
     *     the *first Text node* (after normalization) will always be returned.
     *     For Document nodes, the markup string for the entire document will be
     *     returned.
     * @param {Node} aNode The DOM node to operate on.
     * @example Get the text value of an XML element:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo>Hi</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetTextContent(xmlDoc.documentElement);
     *          <samp>Hi</samp>
     *     </code>
     * @example Get the text value of an XML element that has multiple child
     *     nodes:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo>Hi<bar/> There</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetTextContent(xmlDoc.documentElement);
     *          <samp>Hi There</samp>
     *     </code>
     * @example Get the text value of an XML element that has descendant nodes:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo>Hi<bar> There </bar>Folks!</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetTextContent(xmlDoc.documentElement);
     *          <samp>Hi There Folks!</samp>
     *     </code>
     * @example Get the text value of an XML document:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo>Hi<bar>There</bar></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetTextContent(xmlDoc);
     *          <samp>Hi There</samp>
     *     </code>
     * @example Get the text value of an XML element's attribute:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo bar="baz">Hi</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetTextContent(
     *          xmlDoc.documentElement.attributes[0]);
     *          <samp>baz</samp>
     *     </code>
     * @example Get the text value of an XML comment:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo>Hi<!-- A comment
     *         --></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetTextContent(
     *          xmlDoc.documentElement.childNodes[1]);
     *          <samp> A comment </samp>
     *     </code>
     * @returns {String} The text content of the first text child of the
     *     supplied Node (after all Text nodes under it have been normalized).
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     */

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                                'Must provide a valid target Node.');
    }

    //  condense multiple text node children
    TP.nodeNormalize(aNode);

    switch (aNode.nodeType) {
        case Node.ELEMENT_NODE:
        case Node.DOCUMENT_FRAGMENT_NODE:

            return aNode.textContent;

        case Node.ATTRIBUTE_NODE:

            return aNode.value;

        case Node.TEXT_NODE:
        case Node.CDATA_SECTION_NODE:
        case Node.PROCESSING_INSTRUCTION_NODE:
        case Node.COMMENT_NODE:

            return aNode.data;

        case Node.DOCUMENT_NODE:

            return TP.nodeGetTextContent(aNode.documentElement);

        case Node.ENTITY_REFERENCE_NODE:
        case Node.ENTITY_NODE:
        case Node.DOCUMENT_TYPE_NODE:
        case Node.NOTATION_NODE:

            return '';

        default:
            break;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetChildTextContent',
function(aNode, aTagName, aNamespaceURI) {

    /**
     * @method nodeGetChildTextContent
     * @summary Returns the normalized nodeValue of the node's first element
     *     with a node name of aTagName. This is a useful wrapper for pulling
     *     apart nodes which essentially represent lists.
     * @param {Node} aNode The DOM node to operate on.
     * @param {String} aTagName The tag/element name to match.
     * @param {String} aNamespaceURI The namespace URI to search for.
     * @example Get the text value of an XML element's 'goo' child:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo><goo>Hi</goo></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetChildTextContent(xmlDoc.documentElement,
     *          'goo');
     *          <samp>Hi</samp>
     *     </code>
     * @example Get the text value of an XML element's 'moo' child:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo><goo>Hi</goo></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetChildTextContent(xmlDoc.documentElement,
     *          'moo');
     *          // 'moo' wasn't found, so this returns 'undefined'
     *          <samp>undefined</samp>
     *     </code>
     * @example Get the text value of an XML element's 'bar' child, but only the
     *     one in the 'http://www.bar.com' namespace:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><bar>Hi</bar><bar
     *         xmlns="http://www.bar.com">there</bar></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeGetChildTextContent(xmlDoc.documentElement,
     *          'bar',
     *          'http://www.bar.com');
     *          <samp>undefined</samp>
     *     </code>
     * @returns {String} The text content of the text child of the first Element
     *     under the supplied Node whose tag name matches the supplied name
     *     (after all Text nodes under it have been normalized).
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     */

    var child;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    child = TP.nodeGetFirstElementChildByTagName(aNode,
                                                    aTagName,
                                                    aNamespaceURI);
    if (TP.isElement(child)) {
        return TP.nodeGetTextContent(child);
    }

    return;
});

//  ------------------------------------------------------------------------
//  NODE PHASE SUPPORT
//  ------------------------------------------------------------------------

/*
Operations which manipulate and test a Node's 'processing phase'
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetStartPhase',
function(aNode, phaseList, outerElem) {

    /**
     * @method nodeGetStartPhase
     * @summary Returns the starting phase aNode should be processed with based
     *     on the phase data of itself and/or its ancestors. We don't want to
     *     process content multiple times since there's no guarantee that
     *     operations are idempotent.
     * @param {Node} aNode The node to test.
     * @param {String[]} phaseList An optional array in which to find the target
     *     phase.
     * @param {Element} outerElem An optional 'outermost' element to test.
     *     Testing will not go higher than this element in the DOM tree.
     * @returns {String} The target phase for the node.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     */

    var elem,
        phases,
        phase;

    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    //  Convert non-element nodes into elements by traversing upward.
    elem = aNode;
    if (!TP.isElement(aNode)) {
        elem = TP.isDocument(aNode) ?
                    aNode.documentElement :
                    aNode.parentNode;

        if (TP.isFragment(elem)) {
            return null;
        }
    }

    //  The default phase list is non-cached page processing list.
    phases = TP.ifInvalid(phaseList, TP.shell.TSH.NOCACHE_PHASES);

    //  Once we have an element of any kind, loop upward until we a) find a
    //  tibet:phase, b) find the outerElem (if any), or c) run out of
    //  elements.
    while (TP.isElement(elem)) {
        if (TP.elementHasAttribute(elem, 'tibet:phase', true)) {
            break;
        }

        if (elem === outerElem) {
            break;
        }

        elem = elem.parentNode;
    }

    //  If we found any elements with a phase we want to start at that phase.
    //  Otherwise we'll start at the first phase in the list.
    if (TP.isElement(elem)) {
        //  We want to make sure the phase is in the phases list we're
        //  working with, if it isn't then we need to assume we start with
        //  the first phase in the new phase list.
        phase = TP.elementGetAttribute(elem, 'tibet:phase', true);
        if (phases.contains(phase)) {
            return phase;
        } else {
            return phases.first();
        }
    }

    return phases.first();
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetTargetPhase',
function(aNode, phaseList, outerElem) {

    /**
     * @method nodeGetTargetPhase
     * @summary Returns the maximum phase aNode should be processed to based on
     *     the phase data of its ancestors.
     * @param {Node} aNode The node to test.
     * @param {String[]} phaseList An optional array in which to find the target
     *     phase.
     * @param {Element} outerElem An optional 'outermost' element to test.
     *     Testing will not go higher than this element in the DOM tree.
     * @returns {String} The target phase for the node.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     */

    var elem,
        phases,
        phase;

    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    //  Convert non-element nodes into elements by traversing upward.
    elem = aNode;
    if (!TP.isElement(aNode)) {
        elem = TP.isDocument(aNode) ?
                    aNode.documentElement :
                    aNode.parentNode;

        if (TP.isFragment(elem)) {
            return null;
        }
    }

    //  The default phase list is non-cached page processing list.
    phases = TP.ifInvalid(phaseList, TP.shell.TSH.NOCACHE_PHASES);

    //  Once we have an element of any kind, loop upward until we a) find a
    //  tibet:phase, b) find the outerElem (if any), or c) run out of
    //  elements.
    while (TP.isElement(elem)) {
        if (TP.elementHasAttribute(elem, 'tibet:phase', true)) {
            break;
        }

        if (elem === outerElem) {
            break;
        }

        elem = elem.parentNode;
    }

    //  If we found any elements with a phase we want to stop at that phase.
    //  Otherwise we'll stop at the last phase in the list.
    if (TP.isElement(elem)) {
        //  We want to make sure any current phase is in the phases list
        //  we're working with, if it isn't then we need to assume we end
        //  with the first phase in the new phase list.
        phase = TP.elementGetAttribute(elem, 'tibet:phase', true);
        if (phases.contains(phase) || phase === 'Execute') {
            return phase;
        } else {
            return phases.last();
        }
    }

    return phases.last();
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeHasReachedPhase',
function(aNode, targetPhase, targetPhaseList, nodeOnly) {

    /**
     * @method nodeHasReachedPhase
     * @summary Returns true if the node provided appears to have been
     *     processed by the TIBET content processing subsystem. When a phase is
     *     specified it is checked against any optional list to see if
     *     processing has reached that phase.
     * @param {Node} aNode The DOM node to operate on.
     * @param {String} targetPhase A content processing phase name.
     * @param {String[]} targetPhaseList An ordered list of phase names used for
     *     testing.
     * @param {Boolean} nodeOnly Flag determining whether to check only the node
     *     or the parent chain as well. Default is node only.
     * @returns {Boolean} True if the node looks processed.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     */

    var elem,
        currentPhase,
        phaseList;

    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    //  Convert non-element nodes into elements by traversing upward.
    elem = aNode;
    if (!TP.isElement(aNode)) {
        elem = TP.isDocument(aNode) ?
                    aNode.documentElement :
                    aNode.parentNode;

        if (TP.isFragment(elem)) {
            return null;
        }
    }

    //  See if the element has a phase. If not, but it has a 'tibet:tag'
    //  attribute, then set its 'tibet:phase' to 'Compile'. We do this before
    //  we traverse the ancestor chain so that we can support tags that
    //  recursively replace themselves.
    currentPhase = TP.elementGetAttribute(elem, 'tibet:phase', true);
    if (TP.isEmpty(currentPhase)) {
        if (TP.elementHasAttribute(elem, 'tibet:tag', true)) {
            TP.elementSetAttribute(elem, 'tibet:phase', 'Compile', true);
        }
    }

    /*
    //  When ancestor scope is requested we search upward until we find a
    //  phase marker or run out of elements.
    if (TP.notFalse(nodeOnly)) {
        while (TP.isElement(elem)) {
            if (TP.elementHasAttribute(elem, 'tibet:phase', true)) {
                break;
            };

            elem = elem.parentNode;
        };
    };
    */

    //  If we ran out of elements above then the original element is
    //  sufficient.
    if (!TP.isElement(elem)) {
        elem = TP.isDocument(elem) ?
                elem.documentElement :
                elem.parentNode;
    }

    //  When no target phase is specified any evidence of conversion from
    //  non-HTML to HTML is enough.
    if (TP.isEmpty(targetPhase)) {
        return TP.elementHasAttribute(elem, 'tibet:tag', true);
    }

    currentPhase = TP.elementGetAttribute(elem, 'tibet:phase', true);
    if (TP.isEmpty(currentPhase)) {
        //  No current phase, result is indeterminate.
        return;
    }

    //  default phase list to NOCACHE phases when missing.
    phaseList = TP.ifInvalid(targetPhaseList, TP.shell.TSH.NOCACHE_PHASES);

    //  Note that execution is a "hard-coded phase" so it will never be in
    //  the phase list. We have to test specifically for that.
    if (targetPhase === 'Execute') {
        return currentPhase === 'Execute';
    } else if (phaseList.contains(targetPhase)) {
        return phaseList.indexOf(currentPhase) >=
                phaseList.indexOf(targetPhase);
    } else {
        return this.raise('TP.sig.InvalidPhase',
                            'Target phase not in phase list');
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeNormalizePhase',
function(aNode) {

    /**
     * @method nodeNormalizePhase
     * @summary Normalizes, aka coalesces tibet:phase information on the node
     *     by removing phase attributes which are superfluous.
     * @param {Node} aNode The node to normalize.
     * @returns {Node} The node.
     */

    //  TODO:   implement this :)

    return aNode;
});

//  ------------------------------------------------------------------------
//  NODE MODIFICATION
//  ------------------------------------------------------------------------

/*
Operations supporting common Node transformations. You can also use a
selection primitive such as TP.nodeGetChildNodes() followed by a perform or
similar iteration operation to operate on node content.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeCopyChildNodesTo',
function(fromNode, toNode, beforeNode, shouldAwake) {

    /**
     * @method nodeCopyChildNodesTo
     * @summary Copies children of the 'from' node to the 'to' node.
     * @param {Node} fromNode The source node.
     * @param {Node} toNode The target node.
     * @param {Node} beforeNode Optional 'insertion point'.
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just copied. The default for this operation is false.
     * @example Copy all of the children from the source document to a new,
     *     empty document:
     *     <code>
     *          srcDoc = TP.documentFromString(
     *          '<foo><goo>Hi</goo></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          destDoc = TP.constructDocument();
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeCopyChildNodesTo(srcDoc, destDoc);
     *          <samp>undefined</samp>
     *          TP.str(destDoc);
     *          <samp>&lt;foo&gt;&lt;goo&gt;Hi&lt;/goo&gt;&lt;/foo&gt;</samp>
     *     </code>
     * @example Copy all of the children from the source document to a new
     *     document that has only one node under its document element and insert
     *     all of the newly copied children before that one node:
     *     <code>
     *          srcDoc = TP.documentFromString(
     *          '<foo><goo>Hi</goo></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          destDoc = TP.documentFromString(
     *          '<baz><bar/></baz>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeCopyChildNodesTo(
     *          srcDoc,
     *          destDoc,
     *          destDoc.documentElement.firstChild);
     *          <samp>undefined</samp>
     *          TP.str(destDoc);
     *
     *
     *         <samp>&lt;baz&gt;&lt;foo&gt;&lt;goo&gt;Hi&lt;/goo&gt;&lt;/foo&gt;&lt;bar/&gt;&lt;/baz&gt;</samp>
     *     </code>
     * @returns {Node} The first copied child node. This will be a different
     *     node than what was the first child node of the fromNode, as the node
     *     will have been copied and might have been imported.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     */

    var toElem,

        before,

        retNode,

        len,
        i;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(fromNode) || !TP.isCollectionNode(toNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    toElem = TP.isDocument(toNode) && TP.isElement(toNode.documentElement) ?
                    toNode.documentElement :
                    toNode;

    before = TP.ifInvalid(beforeNode, null);

    retNode = null;

    len = fromNode.childNodes.length;
    for (i = 0; i < len; i++) {
        //  Grab the first copied child node.
        if (TP.notValid(retNode)) {
            retNode = TP.nodeInsertBefore(
                            toElem,
                            TP.nodeCloneNode(fromNode.childNodes[i], true),
                            before,
                            shouldAwake);
        } else {
            //  If 'before' is null, this is the same as doing
            //  'appendChild'.
            TP.nodeInsertBefore(
                        toElem,
                        TP.nodeCloneNode(fromNode.childNodes[i], true),
                        before,
                        shouldAwake);
        }
    }

    return retNode;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeMoveChildNodesTo',
function(fromNode, toNode, beforeNode, shouldAwake) {

    /**
     * @method nodeMoveChildNodesTo
     * @summary Moves children of the 'from' node to the 'to' node.
     * @param {Node} fromNode The source node.
     * @param {Node} toNode The target node.
     * @param {Node} beforeNode Optional 'insertion point'.
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just moved. The default for this operation is false.
     * @example Move all of the children from the source document to a new,
     *     empty document:
     *     <code>
     *          srcDoc = TP.documentFromString(
     *          '<foo><goo>Hi</goo></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          destDoc = TP.constructDocument();
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeMoveChildNodesTo(srcDoc, destDoc);
     *          <samp>undefined</samp>
     *          TP.str(destDoc);
     *          <samp>&lt;foo&gt;&lt;goo&gt;Hi&lt;/goo&gt;&lt;/foo&gt;</samp>
     *          TP.isEmpty(srcDoc);
     *          <samp>true</samp>
     *     </code>
     * @example Move all of the children from the source document to a new
     *     document that has only one node under its document element and insert
     *     all of the newly copied children before that one node:
     *     <code>
     *          srcDoc = TP.documentFromString(
     *          '<foo><goo>Hi</goo></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          destDoc = TP.documentFromString(
     *          '<baz><bar/></baz>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeMoveChildNodesTo(
     *          srcDoc,
     *          destDoc,
     *          destDoc.documentElement.firstChild);
     *          <samp>undefined</samp>
     *          TP.str(destDoc);
     *
     *
     *         <samp>&lt;baz&gt;&lt;foo&gt;&lt;goo&gt;Hi&lt;/goo&gt;&lt;/foo&gt;&lt;bar/&gt;&lt;/baz&gt;</samp>
     *          TP.isEmpty(srcDoc);
     *          <samp>true</samp>
     *     </code>
     * @returns {Node} The first moved child node. This may be a different node
     *     than what was the first child node of the fromNode, as the node might
     *     have been imported.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     */

    var toElem,

        before,

        retNode,

        len,
        i,

        childNode;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(fromNode) || !TP.isCollectionNode(toNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    toElem = TP.isDocument(toNode) && TP.isElement(toNode.documentElement) ?
                    toNode.documentElement :
                    toNode;

    before = TP.ifInvalid(beforeNode, null);

    retNode = null;

    len = fromNode.childNodes.length;
    for (i = 0; i < len; i++) {
        //  Make sure and remove the child from the fromNode first.
        //  Trust me... it works better this way.
        childNode = TP.nodeDetach(fromNode.childNodes[0]);

        //  Grab the first moved child node.
        if (TP.notValid(retNode)) {
            //  If 'before' is null, this is the same as doing
            //  'appendChild'.
            retNode = TP.nodeInsertBefore(toElem, childNode,
                                            before, shouldAwake);
        } else {
            //  If 'before' is null, this is the same as doing
            //  'appendChild'.
            TP.nodeInsertBefore(toElem, childNode, before, shouldAwake);
        }
    }

    return retNode;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeSetContent',
function(aNode, anObject, loadedFunction, shouldAwake) {

    /**
     * @method nodeSetContent
     * @summary Sets the content of aNode to anObject, removing any current
     *     content. This method is a simple wrapper for empty/insert operations
     *     which specialize based on a variety of factors.
     * @param {Node} aNode The node to set the child content of.
     * @param {Object} anObject The object to use as the source of the content.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just set. The default for a 'set' operation is whether aNode has a
     *     Window object associated with it or not.
     * @exception TP.sig.InvalidNode
     * @returns {Node} The first node of the content that was just set, or the
     *     node itself depending on the node type.
     */

    var content;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (TP.notValid(anObject)) {
        TP.nodeEmptyContent(aNode);
    }

    //  this allows us to accept things like TP.uri.URI, TP.dom.Node, etc.
    //  and to process them as the content routines would expect.
    content = TP.canInvoke(anObject, 'getResource') ?
                anObject.getResource(
                    TP.hc('resultType', TP.DOM)).get('result') :
                anObject;
    content = TP.unwrap(content);

    switch (aNode.nodeType) {
        case Node.ELEMENT_NODE:

            if (TP.isHTMLNode(aNode)) {
                return TP.htmlElementSetContent(aNode,
                                                content,
                                                loadedFunction,
                                                shouldAwake);
            } else {
                return TP.xmlElementSetContent(aNode,
                                                content,
                                                loadedFunction,
                                                shouldAwake);
            }

        case Node.TEXT_NODE:
        case Node.CDATA_SECTION_NODE:
        case Node.PROCESSING_INSTRUCTION_NODE:
        case Node.COMMENT_NODE:

            aNode.data = TP.str(content);
            break;

        case Node.DOCUMENT_NODE:

            if (TP.isHTMLNode(aNode)) {
                return TP.htmlDocumentSetContent(aNode,
                                                content,
                                                loadedFunction,
                                                shouldAwake);
            } else {
                return TP.xmlDocumentSetContent(aNode,
                                                content,
                                                loadedFunction);
            }

        case Node.ATTRIBUTE_NODE:

            aNode.value = TP.str(content);
            break;

        case Node.DOCUMENT_FRAGMENT_NODE:

            //  We can do the same setting logic here that we use for
            //  Node.ELEMENT_NODE

            if (TP.isHTMLNode(aNode)) {
                return TP.htmlElementSetContent(aNode,
                                                content,
                                                loadedFunction,
                                                shouldAwake);
            } else {
                return TP.xmlElementSetContent(aNode,
                                                content,
                                                loadedFunction,
                                                shouldAwake);
            }

        case Node.ENTITY_REFERENCE_NODE:
        case Node.ENTITY_NODE:
        case Node.DOCUMENT_TYPE_NODE:
        case Node.NOTATION_NODE:

            TP.raise(this, 'TP.sig.UnsupportedOperation');
            break;

        default:
            break;
    }

    return aNode;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeSetTextContent',
function(aNode, anObject) {

    /**
     * @method nodeSetTextContent
     * @summary Sets the text of the node provided to aString.
     * @description The behavior here varies by node type. For element nodes, if
     *     the node already has a text node child as the first child, it will be
     *     updated. If not, a new text node will be inserted as the first child.
     *     If a CDATA section existed then it's value will be updated,
     *     preserving the original "structure" of the element. For attribute
     *     nodes, the value is updated, and so on.
     * @param {Node} aNode The DOM node to operate on.
     * @param {Object} anObject The source of the content to set.
     * @example Set the text value of an XML element:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo>Hi</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeSetTextContent(xmlDoc.documentElement, 'Howdy');
     *          <samp>undefined</samp>
     *          TP.str(xmlDoc);
     *          <samp>&lt;foo&gt;Howdy&lt;/foo&gt;</samp>
     *     </code>
     * @example Set the text value of an XML element that has no pre-existing
     *     text:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeSetTextContent(xmlDoc.documentElement, 'Howdy');
     *          <samp>undefined</samp>
     *          TP.str(xmlDoc);
     *          <samp>&lt;foo&gt;Howdy&lt;/foo&gt;</samp>
     *     </code>
     * @example Set the text value of an XML document:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo>Hi</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeSetTextContent(xmlDoc, 'Howdy');
     *          <samp>undefined</samp>
     *          TP.str(xmlDoc);
     *          <samp>&lt;foo&gt;Howdy&lt;/foo&gt;</samp>
     *     </code>
     * @example Set the text value of an XML element's attribute:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo bar="baz">Hi</foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeSetTextContent(
     *          xmlDoc.documentElement.attributes[0], 'moo');
     *          <samp>undefined</samp>
     *          TP.str(xmlDoc);
     *          <samp>&lt;foo bar="moo"&gt;Hi&lt;/foo&gt;</samp>
     *     </code>
     * @example Set the text value of an XML comment:
     *     <code>
     *          xmlDoc = TP.documentFromString('<foo>Hi<!-- A comment
     *         --></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeSetTextContent(
     *          xmlDoc.documentElement.childNodes[1],
     *          'Another comment');
     *          <samp>undefined</samp>
     *          TP.str(xmlDoc);
     *          <samp>&lt;foo&gt;Hi&lt;!--Another
     *         comment--&gt;&lt;/foo&gt;</samp>
     *     </code>
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     */

    var resp,
        content;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (TP.canInvoke(anObject, 'getResource')) {
        resp = anObject.getResource(
                        TP.hc('async', false, 'resultType', TP.TEXT));
        content = resp.get('result');
    } else {
        content = TP.str(anObject);
    }

    switch (aNode.nodeType) {
        case Node.ELEMENT_NODE:
        case Node.DOCUMENT_FRAGMENT_NODE:

            aNode.textContent = content;

            break;

        case Node.TEXT_NODE:
        case Node.CDATA_SECTION_NODE:
        case Node.PROCESSING_INSTRUCTION_NODE:
        case Node.COMMENT_NODE:

            aNode.data = content;

            break;

        case Node.DOCUMENT_NODE:

            TP.nodeSetTextContent(aNode.documentElement, content);
            break;

        case Node.ATTRIBUTE_NODE:
            aNode.value = content;
            break;

        case Node.ENTITY_REFERENCE_NODE:
        case Node.ENTITY_NODE:
        case Node.DOCUMENT_TYPE_NODE:
        case Node.NOTATION_NODE:

            return aNode;

        default:
            break;
    }

    return aNode;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeSetChildTextContent',
function(aNode, aString, aTagName, aNamespaceURI) {

    /**
     * @method nodeSetChildTextContent
     * @summary Sets the text value of the node's first child element with a
     *     tag name of aTagName. This is a useful wrapper for manipulating nodes
     *     which essentially represent lists.
     * @param {Node} aNode The DOM node to operate on.
     * @param {String} aString The content text to set.
     * @param {String} aTagName The tag/element name to match.
     * @param {String} aNamespaceURI The namespace URI to search for.
     * @example Set the text value of an XML element's 'goo' child:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo><goo>Hi</goo></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeSetChildTextContent(xmlDoc.documentElement,
     *          'Hey',
     *          'goo');
     *          <samp>undefined</samp>
     *          TP.str(xmlDoc);
     *          <samp>&lt;foo&gt;&lt;goo&gt;Hey&lt;/goo&gt;&lt;/foo&gt;</samp>
     *     </code>
     * @example Set the text value of an XML element's 'moo' child:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo><goo>Hi</goo></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeSetChildTextContent(xmlDoc.documentElement,
     *          'Hey',
     *          'moo');
     *          <samp>undefined</samp>
     *          TP.str(xmlDoc);
     *          // 'moo' wasn't found, so it was added as a child
     *
     *
     *         <samp>&lt;foo&gt;&lt;goo&gt;Hey&lt;/goo&gt;&lt;moo&gt;Hey&lt;/moo&gt;&lt;/foo&gt;</samp>
     *     </code>
     * @example Set the text value of an XML element's 'bar' child, but only the
     *     one in the 'http://www.bar.com' namespace:
     *     <code>
     *          xmlDoc = TP.documentFromString(
     *          '<foo xmlns="http://www.foo.com"><bar>Hi</bar><bar
     *         xmlns="http://www.bar.com">there</bar></foo>');
     *          <samp>[object XMLDocument]</samp>
     *          TP.nodeSetChildTextContent(xmlDoc.documentElement,
     *          'Hey',
     *          'bar',
     *          'http://www.bar.com');
     *          <samp>undefined</samp>
     *          TP.str(xmlDoc);
     *          <samp>&lt;foo
     *         xmlns="http://www.foo.com">&lt;bar&gt;Hi&lt;bar&gt;&lt;bar
     *         xmlns="http://www.bar.com"&gt;Hey&lt;bar&gt;&lt;foo&gt;</samp>
     *     </code>
     * @exception TP.sig.InvalidNode Raised when an invalid node is provided to
     *     the method.
     */

    var child,
        node,
        elemNode;

    child = TP.nodeGetFirstElementChildByTagName(aNode,
                                                    aTagName,
                                                    aNamespaceURI);
    if (TP.isElement(child)) {
        return TP.nodeSetTextContent(aString);
    } else {
        node = TP.nodeFromString(TP.join('<', aTagName, '>',
                                        aString,
                                        '</', aTagName, '>'));
        if (TP.isNode(node)) {
            elemNode = TP.elem(aNode);
            TP.nodeAppendChild(elemNode, node, false);
        }
    }

    return;
});

//  ------------------------------------------------------------------------
//  ALIASES (and wrappers)
//  ------------------------------------------------------------------------

/*
Common convenience wrappers designed primarily for the UI layers but also
very useful within TIBET code itself. These functions, along with many other
"dollar functions" in TIBET, provide high-level access to the various
underlying primitives, often helping to avoid type-checking in your code.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('canonical',
function(anObject) {

    /**
     * @method canonical
     * @summary Returns the canonical name of the object provided. This method
     *     is typically used as a simple wrapper around the primitives for
     *     element/attribute canonical names. When any other object is provided
     *     this method returns the result of TP.name(anObject).
     * @param {Object} anObject The object to interrogate.
     * @returns {String} The object's canonical name.
     * @exception TP.sig.InvalidParameter Raised when an invalid object is
     *     provided to the method.
     */

    if (TP.notValid(anObject)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    if (TP.isElement(anObject)) {
        return TP.elementGetCanonicalName(anObject);
    } else if (TP.isAttributeNode(anObject)) {
        return TP.attributeGetCanonicalName(anObject);
    }

    return TP.name(anObject);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('doc',
function(anObject, defaultNS, shouldReport) {

    /**
     * @method doc
     * @summary Returns a native DOM Document node based on a variety of input
     *     object types including strings, nodes, or windows.
     * @param {Object} anObject A string, window, node, or other object which
     *     can provide a document or be used to construct one.
     * @param {String|null} defaultNS What namespace should be used for the
     *     'default namespace' for element markup in the supplied String.
     *     Note that this should be an XML 'namespace URI' (i.e.
     *     'http://www.w3.org/1999/xhtml') *not* a namespace prefix (i.e.
     *     'html:'). To use the 'null' namespace (i.e. xmlns=""), supply
     *     the empty String ('') here. To not specify any default namespace
     *     value and let the parser do what it does natively, supply null here.
     * @param {Boolean} shouldReport False to turn off exception reporting so
     *     strings can be tested for XML compliance without causing exceptions
     *     to be thrown. This is true by default.
     * @example Obtain the document for a variety of different objects:
     *     <code>
     *          // Supplying no parameter returns a blank XML document:
     *          TP.doc();
     *          <samp>[object XMLDocument]</samp>
     *
     *          // Supplying a String parameter attempts to create an
     *          // XML document using the String as the XML content:
     *          TP.doc('<foo></foo>');
     *          <samp>[object XMLDocument]</samp>
     *
     *          // Supplying a Node parameter attempts to return the
     *          // document containing the Node or, if the Node doesn't
     *          // have a document, it returns a Document wrapping the
     *          // Node as the document element:
     *          TP.doc(TP.documentGetBody(document)) === document;
     *          <samp>true</samp>
     *
     *          // Supplying a Window parameter returns the document in
     *          // that window:
     *          TP.doc(top) === top.document;
     *          <samp>true</samp>
     *
     *          // Supplying a parameter that implements the
     *          // 'getNativeDocument' method will return the result of
     *          // sending that message. TP.core.Windows implement that
     *          // method:
     *          newWin = TP.core.Window.open();
     *          TP.doc(newWin);
     *          <samp>[object HTMLDocument]</samp>
     *     </code>
     * @returns {Document} A native document object.
     */

    var doc;

    if (TP.notValid(anObject)) {
        return TP.constructDocument();
    }

    //  for permission reasons it's important to check for xhr's early
    if (TP.isXHR(anObject)) {
        try {
            doc = anObject.responseXML;

            //  IE has the nasty habit of making an empty '#document' node
            //  here that passes TP.isNode(...) tests, but has no content
            //  because it couldn't be parsed into real XML.
            if (doc.childNodes.length === 0) {
                return TP.doc(anObject.responseText, defaultNS, shouldReport);
            } else {
                return TP.doc(doc);
            }
        } catch (e) {
            //  Moz in particular will throw exceptions on cross-domain
            return TP.doc(anObject.responseText, defaultNS, shouldReport);
        }
    }

    if (TP.isNode(anObject)) {
        doc = TP.nodeGetDocument(anObject);

        //  if the node has no document we attempt to create a new one for
        //  it and return that
        if (TP.notValid(doc)) {
            doc = TP.documentFromNode(anObject);
        }
    } else if (TP.isWindow(anObject)) {
        doc = anObject.document;
    } else if (TP.isString(anObject)) {
        doc = TP.documentFromString(anObject, defaultNS, shouldReport);
    } else if (TP.canInvoke(anObject, 'getNativeDocument')) {
        doc = anObject.getNativeDocument();
    } else if (TP.canInvoke(anObject, 'getResponseXML')) {
        return anObject.getResponseXML();
    }

    return doc;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elem',
function(anObject, defaultNS, shouldReport) {

    /**
     * @method elem
     * @summary Returns the best DOM Element representation for the object
     *     provided. For example, a document will return the documentElement, an
     *     element node will return the element itself, other node types return
     *     their parentNode, etc.
     * @param {Object} anObject Typically a Node of some form, but a wrapper
     *     such as a TP.dom.Node, TP.dom.DocumentNode, or TP.core.Window is
     *     also a workable parameter.
     * @param {String|null} defaultNS What namespace should be used for the
     *     'default namespace' for element markup in the supplied String.
     *     Note that this should be an XML 'namespace URI' (i.e.
     *     'http://www.w3.org/1999/xhtml') *not* a namespace prefix (i.e.
     *     'html:'). To use the 'null' namespace (i.e. xmlns=""), supply
     *     the empty String ('') here. To not specify any default namespace
     *     value and let the parser do what it does natively, supply null here.
     * @param {Boolean} shouldReport False to turn off exception reporting so
     *     strings can be tested for XML compliance without causing exceptions
     *     to be thrown. This is true by default.
     * @returns {Element} A native Element node.
     * @exception TP.sig.InvalidParameter Raised when an invalid object is
     *     provided to the method.
     */

    var elem,

        doc,
        node;

    if (TP.notValid(anObject)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  for permission reasons it's important to check for xhr's early
    if (TP.isXHR(anObject)) {
        try {
            elem = anObject.responseXML;

            //  IE has the nasty habit of making an empty '#document' node
            //  here that passes TP.isNode(...) tests, but has no content
            //  because it couldn't be parsed into real XML.
            if (elem.childNodes.length === 0) {
                return TP.elem(anObject.responseText, defaultNS, shouldReport);
            } else {
                return TP.elem(elem);
            }
        } catch (e) {
            //  Moz in particular will throw exceptions on cross-domain
            return TP.elem(anObject.responseText, defaultNS, shouldReport);
        }
    }

    //  typically called with either element or document and we're trying to
    //  resolve to element or documentElement, so test those first
    if (TP.isElement(anObject)) {
        elem = anObject;
    } else if (TP.isDocument(anObject)) {
        elem = anObject.documentElement;
    } else if (TP.isFragment(anObject)) {
        elem = TP.nodeGetFirstChildElement(anObject);
    } else if (TP.isAttributeNode(anObject)) {
        elem = TP.attributeGetOwnerElement(anObject);
    } else if (TP.isNode(anObject)) {
        //  other node types should be able to return their parent element
        //  container
        elem = anObject.parentNode;
        if (!TP.isElement(elem)) {
            elem = null;
        }
    } else if (TP.isWindow(anObject)) {
        doc = anObject.document;
        if (TP.isDocument(doc)) {
            elem = doc.documentElement;
        }
    } else {
        //  call the $node wrapper which will deal with strings, wrapper
        //  types, and other data formats to get us a node
        node = TP.node(anObject, defaultNS, shouldReport);
        if (!TP.isNode(node)) {
            return;
        }

        //  don't recurse unless value changed during node transformation,
        //  in which case once we have a node we can return a decent value
        //  by calling back into this routine
        if (node !== anObject) {
            return TP.elem(node);
        }
    }

    return elem;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('frag',
function(anObject, defaultNS, shouldReport) {

    /**
     * @method frag
     * @summary Returns the best DOM DocumentFragment representation of
     *     anObject. The various forms of input include strings, windows,
     *     documents, wrapper types, etc.
     * @description This method is essentially a cover for
     *     TP.fragmentFromString() and other fragment construction and
     *     extraction routines.
     * @param {Object} anObject A string, window, node, or other object which
     *     can provide a node or be used to construct one.
     * @param {String|null} defaultNS What namespace should be used for the
     *     'default namespace' for element markup in the supplied String.
     *     Note that this should be an XML 'namespace URI' (i.e.
     *     'http://www.w3.org/1999/xhtml') *not* a namespace prefix (i.e.
     *     'html:'). To use the 'null' namespace (i.e. xmlns=""), supply
     *     the empty String ('') here. To not specify any default namespace
     *     value and let the parser do what it does natively, supply null here.
     * @param {Boolean} shouldReport False to turn off exception reporting so
     *     strings can be tested for XML compliance without causing exceptions
     *     to be thrown. This is true by default.
     * @example Obtain a native DOM Node from a variety of objects:
     *     <code>
     *          TP.frag('<foo></foo><bar></bar>');
     *          <samp>[object DocumentFragment]</samp>
     *          TP.frag(TP.sys.getUICanvas());
     *          <samp>[object DocumentFragment]</samp>
     *          TP.frag(TP.sys.getUICanvas().getNativeWindow());
     *          <samp>[object DocumentFragment]</samp>
     *          tpElem = TP.tpnode('<foo><bar/></foo>');
     *          <samp>[html:body HTMLBodyElement]</samp>
     *          TP.frag(tpElem);
     *          <samp>[object DocumentFragment]</samp>
     *     </code>
     * @returns {DocumentFragment} A native document fragment Node.
     */

    var frag,

        node,
        fragment;

    if (TP.notValid(anObject)) {
        return TP.documentConstructFragment(TP.XML_FACTORY_DOCUMENT);
    }

    //  for permission reasons it's important to check for xhr's early
    if (TP.isXHR(anObject)) {
        try {
            frag = anObject.responseXML;

            //  IE has the nasty habit of making an empty '#document' node
            //  here that passes TP.isNode(...) tests, but has no content
            //  because it couldn't be parsed into real XML.
            if (frag.childNodes.length === 0) {
                return TP.frag(anObject.responseText, defaultNS, shouldReport);
            } else {
                return TP.frag(frag);
            }
        } catch (e) {
            //  Moz in particular will throw exceptions on cross-domain
            return TP.frag(anObject.responseText, defaultNS, shouldReport);
        }
    }

    if (TP.isFragment(anObject)) {
        fragment = anObject;
    } else if (TP.isNode(anObject)) {
        if (TP.isDocument(node = anObject)) {
            node = anObject.documentElement;
        }

        fragment = TP.documentConstructFragment(TP.nodeGetDocument(node));

        //  Note here how we pass 'false' to *not* awaken any content that
        //  gets appended.
        TP.nodeAppendChild(fragment, node, false);
    } else if (TP.isKindOf(anObject, 'TP.dom.Node')) {
        fragment = TP.documentConstructFragment(anObject.getNativeDocument());

        //  Note here how we pass 'false' to *not* awaken any content that
        //  gets appended.
        TP.nodeAppendChild(fragment, anObject.getNativeNode(), false);
    } else if (TP.isString(anObject)) {
        fragment = TP.fragmentFromString(anObject, defaultNS, shouldReport);
    } else if (TP.isWindow(anObject)) {
        node = TP.nodeCloneNode(anObject.document.documentElement);
        fragment = TP.documentConstructFragment(TP.nodeGetDocument(node));

        //  Note here how we pass 'false' to *not* awaken any content that
        //  gets appended.
        TP.nodeAppendChild(fragment, node, false);
    } else if (TP.canInvoke(anObject, 'getNativeNode')) {
        fragment = TP.documentConstructFragment(anObject.getNativeDocument());
        if (TP.isDocument(node = anObject.getNativeNode())) {
            node = TP.nodeCloneNode(node.documentElement);
        }

        //  Note here how we pass 'false' to *not* awaken any content that
        //  gets appended.
        TP.nodeAppendChild(fragment, node, false);
    } else if (TP.canInvoke(anObject, 'getResponseXML')) {
        return TP.frag(anObject.getResponseXML());
    }

    return fragment;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('lname',
function(anObject) {

    /**
     * @method lname
     * @summary Returns the local name of the object provided. This method is
     *     typically used as a simple wrapper around the primitives for
     *     element/attribute local names. When any other object is provided this
     *     method returns the result of TP.name(anObject).
     * @param {Object} anObject The object to interrogate.
     * @returns {String} The object's local name.
     */

    if (TP.isElement(anObject)) {
        return TP.elementGetLocalName(anObject);
    } else if (TP.isAttributeNode(anObject)) {
        return TP.attributeGetLocalName(anObject);
    }

    return TP.name(anObject);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('node',
function(anObject, defaultNS, shouldReport) {

    /**
     * @method node
     * @summary Returns the best DOM node representation of anObject. The
     *     various forms of input include strings, windows, documents, wrapper
     *     types, etc.
     * @description This method is essentially a cover for TP.nodeFromString()
     *     and other node construction and extraction routines. NOTE that
     *     document objects are nodes, so you may receive a document node.
     * @param {Object} anObject A string, window, node, or other object which
     *     can provide a node or be used to construct one.
     * @param {String|null} defaultNS What namespace should be used for the
     *     'default namespace' for element markup in the supplied String.
     *     Note that this should be an XML 'namespace URI' (i.e.
     *     'http://www.w3.org/1999/xhtml') *not* a namespace prefix (i.e.
     *     'html:'). To use the 'null' namespace (i.e. xmlns=""), supply
     *     the empty String ('') here. To not specify any default namespace
     *     value and let the parser do what it does natively, supply null here.
     * @param {Boolean} shouldReport False to turn off exception reporting so
     *     strings can be tested for XML compliance without causing exceptions
     *     to be thrown. This is true by default.
     * @example Obtain a native DOM Node from a variety of objects:
     *     <code>
     *          TP.node('<foo><bar/></foo>');
     *          <samp>[object Element]</samp>
     *          TP.node(TP.documentGetBody(document));
     *          <samp>[object HTMLBodyElement]</samp>
     *          TP.node(TP.documentGetBody(document)) ===
     *         TP.documentGetBody(document);
     *          <samp>true</samp>
     *          TP.node(TP.sys.getUICanvas())
     *          <samp>[object HTMLDocument]</samp>
     *          TP.node(top) === document;
     *          <samp>true</samp>
     *          TP.node(bodyTPElem);
     *          <samp>[object HTMLBodyElement]</samp>
     *          TP.node(bodyTPElem) === TP.documentGetBody(document);
     *          <samp>true</samp>
     *     </code>
     * @returns {Node} A native Node.
     * @exception TP.sig.InvalidParameter Raised when an invalid object is
     *     provided to the method.
     */

    var node;

    if (TP.notValid(anObject)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  for permission reasons it's important to check for xhr's early
    if (TP.isXHR(anObject)) {
        try {
            node = anObject.responseXML;

            //  IE has the nasty habit of making an empty '#document' node
            //  here that passes TP.isNode(...) tests, but has no content
            //  because it couldn't be parsed into real XML.
            if (node.childNodes.length === 0) {
                return TP.node(anObject.responseText, defaultNS, shouldReport);
            } else {
                return TP.node(node);
            }
        } catch (e) {
            //  Moz in particular will throw exceptions on cross-domain
            return TP.node(anObject.responseText, defaultNS, shouldReport);
        }
    }

    //  typically called with document or element nodes so test those first
    if (TP.isNode(anObject)) {
        return anObject;
    } else if (TP.isKindOf(anObject, 'TP.dom.Node')) {
        return anObject.getNativeNode();
    } else if (TP.isWindow(anObject)) {
        return anObject.document;
    } else if (TP.isString(anObject)) {
        return TP.nodeFromString(anObject, defaultNS, shouldReport);
    } else if (TP.canInvoke(anObject, 'getNativeNode')) {
        return anObject.getNativeNode();
    } else if (TP.canInvoke(anObject, 'getResponseXML')) {
        return anObject.getResponseXML();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('prefix',
function(anObject) {

    /**
     * @method prefix
     * @summary Returns the prefix, if any, of the object provided. The object
     *     should be a Node of some form. Note that only element and attribute
     *     nodes will have a valid prefix. All other objects will return null.
     * @param {Object} anObject The object to interrogate.
     * @returns {String} The object's prefix, if any.
     * @exception TP.sig.InvalidParameter Raised when an invalid object is
     *     provided to the method.
     */

    var name,
        res;

    if (TP.notValid(anObject)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    name = TP.qname(anObject);
    res = name.match(TP.regex.SCHEME);
    if (TP.isArray(res)) {
        return res.at(1);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('qname',
function(anObject) {

    /**
     * @method qname
     * @summary Returns the "qualified" or QName of the object provided.
     * @description This method is typically used as a simple wrapper around the
     *     primitives for element/attribute "full names". When any other object
     *     is provided this method returns the result of TP.name(anObject). NOTE
     *     that an object's QName is not always its "canonical name". For
     *     example, TIBET uses the prefix 'xforms:' for XForms elements as the
     *     canonical prefix, however many XForms authors prefer 'xf:'. QNames
     *     for such elements return 'xf:', while TP.canonical(anObject) would
     *     return 'xforms:*' instead.
     * @param {Object} anObject The object to interrogate.
     * @returns {String} The object's qualified name, or QName.
     * @exception TP.sig.InvalidParameter Raised when an invalid object is
     *     provided to the method.
     */

    if (TP.notValid(anObject)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    if (TP.isElement(anObject)) {
        return TP.elementGetFullName(anObject);
    } else if (TP.isAttributeNode(anObject)) {
        return TP.attributeGetFullName(anObject);
    }

    return TP.name(anObject);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('tpdoc',
function(anObject, defaultNS, shouldReport) {

    /**
     * @method tpdoc
     * @summary Returns the best TP.dom.DocumentNode representation of
     *     anObject based on a variety of input object types.
     * @param {Object} anObject A string, window, node, or other object which
     *     can provide a document or be used to construct one.
     * @param {String|null} defaultNS What namespace should be used for the
     *     'default namespace' for element markup in the supplied String.
     *     Note that this should be an XML 'namespace URI' (i.e.
     *     'http://www.w3.org/1999/xhtml') *not* a namespace prefix (i.e.
     *     'html:'). To use the 'null' namespace (i.e. xmlns=""), supply
     *     the empty String ('') here. To not specify any default namespace
     *     value and let the parser do what it does natively, supply null here.
     * @param {Boolean} shouldReport False to turn off exception reporting so
     *     strings can be tested for XML compliance without causing exceptions
     *     to be thrown. This is true by default.
     * @returns {TP.dom.DocumentNode} A TIBET document wrapper.
     */

    var doc;

    if (TP.notValid(anObject)) {
        return TP.dom.DocumentNode.construct(TP.constructDocument());
    }

    //  already one? don't want to unwrap/rewrap...
    if (TP.isKindOf(anObject, 'TP.dom.DocumentNode')) {
        return anObject;
    }

    //  for permission reasons it's important to check for xhr's early
    if (TP.isXHR(anObject)) {
        try {
            doc = anObject.responseXML;

            //  IE has the nasty habit of making an empty '#document' node
            //  here that passes TP.isNode(...) tests, but has no content
            //  because it couldn't be parsed into real XML.
            if (doc.childNodes.length === 0) {
                doc = TP.documentFromString(anObject.responseText,
                                            defaultNS,
                                            shouldReport);
                if (TP.isDocument(doc)) {
                    return TP.dom.DocumentNode.construct(doc);
                }
            } else {
                return TP.dom.DocumentNode.construct(doc);
            }
        } catch (e) {
            //  Moz in particular will throw exceptions on cross-domain
            doc = TP.documentFromString(anObject.responseText,
                                        defaultNS,
                                        shouldReport);
            if (TP.isDocument(doc)) {
                return TP.dom.DocumentNode.construct(doc);
            }
        }
    }

    //  typically called with document or element nodes so test those first
    if (TP.isDocument(anObject)) {
        return TP.dom.DocumentNode.construct(anObject);
    } else if (TP.isNode(anObject)) {
        doc = TP.nodeGetDocument(anObject);
        if (TP.isDocument(doc)) {
            return TP.dom.DocumentNode.construct(doc);
        }
    } else if (TP.isKindOf(anObject, 'TP.dom.Node')) {
        return anObject.getDocument();
    } else if (TP.isWindow(anObject)) {
        return TP.dom.DocumentNode.construct(anObject.document);
    } else if (TP.isString(anObject)) {
        doc = TP.documentFromString(anObject, defaultNS, shouldReport);
        if (TP.isDocument(doc)) {
            return TP.dom.DocumentNode.construct(doc);
        }
    } else if (TP.canInvoke(anObject, 'getDocument')) {
        return anObject.getDocument();
    } else if (TP.canInvoke(anObject, 'getResponseXML')) {
        return TP.dom.DocumentNode.construct(anObject.getResponseXML());
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('tpelem',
function(anObject, defaultNS, shouldReport) {

    /**
     * @method tpelem
     * @summary Returns the best TP.dom.ElementNode representation of the
     *     object based on a variety of input formats.
     * @param {Object} anObject Typically a Node of some form, but a wrapper
     *     such as a TP.dom.Node, TP.dom.DocumentNode, or TP.core.Window is
     *     also a workable parameter.
     * @param {String|null} defaultNS What namespace should be used for the
     *     'default namespace' for element markup in the supplied String.
     *     Note that this should be an XML 'namespace URI' (i.e.
     *     'http://www.w3.org/1999/xhtml') *not* a namespace prefix (i.e.
     *     'html:'). To use the 'null' namespace (i.e. xmlns=""), supply
     *     the empty String ('') here. To not specify any default namespace
     *     value and let the parser do what it does natively, supply null here.
     * @param {Boolean} shouldReport False to turn off exception reporting so
     *     strings can be tested for XML compliance without causing exceptions
     *     to be thrown. This is true by default.
     * @returns {TP.dom.ElementNode} A TIBET element wrapper.
     * @exception TP.sig.InvalidParameter Raised when an invalid object is
     *     provided to the method.
     */

    var elem;

    if (TP.notValid(anObject)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  already one? don't want to unwrap/rewrap...
    if (TP.isKindOf(anObject, 'TP.dom.ElementNode')) {
        return anObject;
    }

    //  get best element rep we can from whatever it is...
    elem = TP.elem(anObject, defaultNS, shouldReport);
    if (TP.isElement(elem)) {
        return TP.dom.ElementNode.construct(elem);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('tpfrag',
function(anObject, defaultNS, shouldReport) {

    /**
     * @method tpfrag
     * @summary Returns the TP.dom.DocumentFragmentNode representation of the
     *     object based on a variety of input formats.
     * @param {Object} anObject Typically a Node of some form, but a wrapper
     *     such as a TP.dom.Node, TP.dom.DocumentNode, or TP.core.Window is
     *     also a workable parameter.
     * @param {String|null} defaultNS What namespace should be used for the
     *     'default namespace' for element markup in the supplied String.
     *     Note that this should be an XML 'namespace URI' (i.e.
     *     'http://www.w3.org/1999/xhtml') *not* a namespace prefix (i.e.
     *     'html:'). To use the 'null' namespace (i.e. xmlns=""), supply
     *     the empty String ('') here. To not specify any default namespace
     *     value and let the parser do what it does natively, supply null here.
     * @param {Boolean} shouldReport False to turn off exception reporting so
     *     strings can be tested for XML compliance without causing exceptions
     *     to be thrown. This is true by default.
     * @returns {TP.dom.DocumentFragmentNode} A TIBET document fragment
     *     wrapper.
     */

    var frag;

    if (TP.notValid(anObject)) {
        return TP.dom.DocumentFragmentNode.construct(
                    TP.documentConstructFragment(TP.XML_FACTORY_DOCUMENT));
    }

    //  already one? don't want to unwrap/rewrap...
    if (TP.isKindOf(anObject, 'TP.dom.DocumentFragmentNode')) {
        return anObject;
    }

    //  get best fragment rep we can from whatever it is...
    frag = TP.frag(anObject, defaultNS, shouldReport);
    if (TP.isFragment(frag)) {
        return TP.dom.DocumentFragmentNode.construct(frag);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('tpnode',
function(anObject, defaultNS, shouldReport) {

    /**
     * @method tpnode
     * @summary A general purpose routine that can return a TIBET node wrapper
     *     based on a variety of input object types. NOTE that this method is
     *     less discriminating than TP.tpelem() in that it can return a wrapper
     *     for virtually any Node type.
     * @description This method is essentially a cover for creation of a
     *     TP.dom.Node from TP.nodeFromString() and other node construction and
     *     extraction routines. NOTE that document objects are nodes, so you may
     *     receive a document node.
     * @param {Object} anObject A string, window, node, or other object which
     *     can provide a node or be used to construct one.
     * @param {String|null} defaultNS What namespace should be used for the
     *     'default namespace' for element markup in the supplied String.
     *     Note that this should be an XML 'namespace URI' (i.e.
     *     'http://www.w3.org/1999/xhtml') *not* a namespace prefix (i.e.
     *     'html:'). To use the 'null' namespace (i.e. xmlns=""), supply
     *     the empty String ('') here. To not specify any default namespace
     *     value and let the parser do what it does natively, supply null here.
     * @param {Boolean} shouldReport False to turn off exception reporting so
     *     strings can be tested for XML compliance without causing exceptions
     *     to be thrown. This is true by default.
     * @example Obtain an instance of a TIBET TP.dom.Node subtype from a
     *     variety of objects:
     *     <code>
     *          TP.tpnode('<foo><bar/></foo>');
     *          <samp>[TP.dom.ElementNode Element]</samp>
     *          TP.tpnode(TP.documentGetBody(document));
     *          <samp>[html:body HTMLBodyElement]</samp>
     *          TP.tpnode(TP.sys.getUICanvas());
     *          <samp>[TP.dom.DocumentNode HTMLDocument]</samp>
     *          TP.tpnode(TP.sys.getUICanvas().getNativeWindow());
     *          <samp>[TP.dom.DocumentNode HTMLDocument]</samp>
     *          TP.tpnode(document);
     *          <samp>[TP.dom.DocumentNode HTMLDocument]</samp>
     *          bodyTPElem = TP.tpnode(TP.documentGetBody(document));
     *          <samp>[html:body HTMLBodyElement]</samp>
     *          TP.tpnode(bodyTPElem);
     *          <samp>[html:body HTMLBodyElement]</samp>
     *          TP.tpnode(bodyTPElem) === bodyTPElem;
     *          <samp>true</samp>
     *          topTPWin = TP.tpwin(TP.sys.getUICanvas());
     *          <samp>(UI canvas window name)</samp>
     *          TP.tpnode(topTPWin);
     *          <samp>[TP.dom.DocumentNode HTMLDocument]</samp>
     *     </code>
     * @returns {Node} A native Node.
     * @exception TP.sig.InvalidParameter Raised when an invalid object is
     *     provided to the method.
     */

    var node,
        resp,
        content;

    if (TP.notValid(anObject)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  already one? don't want to unwrap/rewrap...
    if (TP.isKindOf(anObject, 'TP.dom.Node')) {
        return anObject;
    }

    //  for permission reasons it's important to check for xhr's early
    if (TP.isXHR(anObject)) {
        try {
            node = anObject.responseXML;

            //  IE has the nasty habit of making an empty '#document' node
            //  here that passes TP.isNode(...) tests, but has no content
            //  because it couldn't be parsed into real XML.
            if (node.childNodes.length === 0) {
                node = TP.nodeFromString(anObject.responseText,
                                            defaultNS,
                                            shouldReport);
                if (TP.isNode(node)) {
                    return TP.dom.Node.construct(node);
                }
            } else {
                return TP.dom.Node.construct(node);
            }
        } catch (e) {
            //  Moz in particular will throw exceptions on cross-domain
            node = TP.nodeFromString(
                        anObject.responseText, defaultNS, shouldReport);
            if (TP.isNode(node)) {
                return TP.dom.Node.construct(node);
            }
        }
    }

    //  typically called with document or element nodes so test those first
    if (TP.isNode(anObject)) {
        return TP.dom.Node.construct(anObject);
    } else if (TP.isKindOf(anObject, 'TP.dom.Node')) {
        return anObject;
    } else if (TP.isWindow(anObject)) {
        return TP.dom.DocumentNode.construct(anObject.document);
    } else if (TP.isString(anObject)) {
        node = TP.nodeFromString(anObject, defaultNS, shouldReport);
        if (TP.isNode(node)) {
            return TP.dom.Node.construct(node);
        }
    } else if (TP.canInvoke(anObject, 'getData')) {
        //  Content objects often get asked for nodes. If it's an XMLContent
        //  object of some form it should work via getData.
        resp = anObject.getData();
        if (TP.isKindOf(resp, 'TP.dom.Node')) {
            return resp;
        }
        if (TP.isNode(resp)) {
            content = TP.wrap(resp);
            if (TP.isKindOf(content, 'TP.dom.Node')) {
                return content;
            }
        }
    } else if (TP.canInvoke(anObject, 'getResource')) {
        //  content will be a Node - we want a TP.dom.Node
        resp = anObject.getResource(
            TP.hc('async', false, 'resultType', TP.DOM));
        content = TP.wrap(resp.get('result'));

        if (TP.isKindOf(content, 'TP.dom.Node')) {
            return content;
        }
    } else if (TP.canInvoke(anObject, 'getResponseXML')) {
        return TP.dom.Node.construct(anObject.getResponseXML());
    }

    return;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_deps/diff-tpi.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
  typeof define === 'function' && define.amd ? define(['exports'], factory) :
  (global = global || self, factory(global.Diff = {}));
}(this, (function (exports) { 'use strict';

  function Diff() {}
  Diff.prototype = {
    diff: function diff(oldString, newString) {
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var callback = options.callback;

      if (typeof options === 'function') {
        callback = options;
        options = {};
      }

      this.options = options;
      var self = this;

      function done(value) {
        if (callback) {
          setTimeout(function () {
            callback(undefined, value);
          }, 0);
          return true;
        } else {
          return value;
        }
      } // Allow subclasses to massage the input prior to running


      oldString = this.castInput(oldString);
      newString = this.castInput(newString);
      oldString = this.removeEmpty(this.tokenize(oldString));
      newString = this.removeEmpty(this.tokenize(newString));
      var newLen = newString.length,
          oldLen = oldString.length;
      var editLength = 1;
      var maxEditLength = newLen + oldLen;
      var bestPath = [{
        newPos: -1,
        components: []
      }]; // Seed editLength = 0, i.e. the content starts with the same values

      var oldPos = this.extractCommon(bestPath[0], newString, oldString, 0);

      if (bestPath[0].newPos + 1 >= newLen && oldPos + 1 >= oldLen) {
        // Identity per the equality and tokenizer
        return done([{
          value: this.join(newString),
          count: newString.length
        }]);
      } // Main worker method. checks all permutations of a given edit length for acceptance.


      function execEditLength() {
        for (var diagonalPath = -1 * editLength; diagonalPath <= editLength; diagonalPath += 2) {
          var basePath = void 0;

          var addPath = bestPath[diagonalPath - 1],
              removePath = bestPath[diagonalPath + 1],
              _oldPos = (removePath ? removePath.newPos : 0) - diagonalPath;

          if (addPath) {
            // No one else is going to attempt to use this value, clear it
            bestPath[diagonalPath - 1] = undefined;
          }

          var canAdd = addPath && addPath.newPos + 1 < newLen,
              canRemove = removePath && 0 <= _oldPos && _oldPos < oldLen;

          if (!canAdd && !canRemove) {
            // If this path is a terminal then prune
            bestPath[diagonalPath] = undefined;
            continue;
          } // Select the diagonal that we want to branch from. We select the prior
          // path whose position in the new string is the farthest from the origin
          // and does not pass the bounds of the diff graph


          if (!canAdd || canRemove && addPath.newPos < removePath.newPos) {
            basePath = clonePath(removePath);
            self.pushComponent(basePath.components, undefined, true);
          } else {
            basePath = addPath; // No need to clone, we've pulled it from the list

            basePath.newPos++;
            self.pushComponent(basePath.components, true, undefined);
          }

          _oldPos = self.extractCommon(basePath, newString, oldString, diagonalPath); // If we have hit the end of both strings, then we are done

          if (basePath.newPos + 1 >= newLen && _oldPos + 1 >= oldLen) {
            return done(buildValues(self, basePath.components, newString, oldString, self.useLongestToken));
          } else {
            // Otherwise track this path as a potential candidate and continue.
            bestPath[diagonalPath] = basePath;
          }
        }

        editLength++;
      } // Performs the length of edit iteration. Is a bit fugly as this has to support the
      // sync and async mode which is never fun. Loops over execEditLength until a value
      // is produced.


      if (callback) {
        (function exec() {
          setTimeout(function () {
            // This should not happen, but we want to be safe.

            /* istanbul ignore next */
            if (editLength > maxEditLength) {
              return callback();
            }

            if (!execEditLength()) {
              exec();
            }
          }, 0);
        })();
      } else {
        while (editLength <= maxEditLength) {
          var ret = execEditLength();

          if (ret) {
            return ret;
          }
        }
      }
    },
    pushComponent: function pushComponent(components, added, removed) {
      var last = components[components.length - 1];

      if (last && last.added === added && last.removed === removed) {
        // We need to clone here as the component clone operation is just
        // as shallow array clone
        components[components.length - 1] = {
          count: last.count + 1,
          added: added,
          removed: removed
        };
      } else {
        components.push({
          count: 1,
          added: added,
          removed: removed
        });
      }
    },
    extractCommon: function extractCommon(basePath, newString, oldString, diagonalPath) {
      var newLen = newString.length,
          oldLen = oldString.length,
          newPos = basePath.newPos,
          oldPos = newPos - diagonalPath,
          commonCount = 0;

      while (newPos + 1 < newLen && oldPos + 1 < oldLen && this.equals(newString[newPos + 1], oldString[oldPos + 1])) {
        newPos++;
        oldPos++;
        commonCount++;
      }

      if (commonCount) {
        basePath.components.push({
          count: commonCount
        });
      }

      basePath.newPos = newPos;
      return oldPos;
    },
    equals: function equals(left, right) {
      if (this.options.comparator) {
        return this.options.comparator(left, right);
      } else {
        return left === right || this.options.ignoreCase && left.toLowerCase() === right.toLowerCase();
      }
    },
    removeEmpty: function removeEmpty(array) {
      var ret = [];

      for (var i = 0; i < array.length; i++) {
        if (array[i]) {
          ret.push(array[i]);
        }
      }

      return ret;
    },
    castInput: function castInput(value) {
      return value;
    },
    tokenize: function tokenize(value) {
      return value.split('');
    },
    join: function join(chars) {
      return chars.join('');
    }
  };

  function buildValues(diff, components, newString, oldString, useLongestToken) {
    var componentPos = 0,
        componentLen = components.length,
        newPos = 0,
        oldPos = 0;

    for (; componentPos < componentLen; componentPos++) {
      var component = components[componentPos];

      if (!component.removed) {
        if (!component.added && useLongestToken) {
          var value = newString.slice(newPos, newPos + component.count);
          value = value.map(function (value, i) {
            var oldValue = oldString[oldPos + i];
            return oldValue.length > value.length ? oldValue : value;
          });
          component.value = diff.join(value);
        } else {
          component.value = diff.join(newString.slice(newPos, newPos + component.count));
        }

        newPos += component.count; // Common case

        if (!component.added) {
          oldPos += component.count;
        }
      } else {
        component.value = diff.join(oldString.slice(oldPos, oldPos + component.count));
        oldPos += component.count; // Reverse add and remove so removes are output first to match common convention
        // The diffing algorithm is tied to add then remove output and this is the simplest
        // route to get the desired output with minimal overhead.

        if (componentPos && components[componentPos - 1].added) {
          var tmp = components[componentPos - 1];
          components[componentPos - 1] = components[componentPos];
          components[componentPos] = tmp;
        }
      }
    } // Special case handle for when one terminal is ignored (i.e. whitespace).
    // For this case we merge the terminal into the prior string and drop the change.
    // This is only available for string mode.


    var lastComponent = components[componentLen - 1];

    if (componentLen > 1 && typeof lastComponent.value === 'string' && (lastComponent.added || lastComponent.removed) && diff.equals('', lastComponent.value)) {
      components[componentLen - 2].value += lastComponent.value;
      components.pop();
    }

    return components;
  }

  function clonePath(path) {
    return {
      newPos: path.newPos,
      components: path.components.slice(0)
    };
  }

  var characterDiff = new Diff();
  function diffChars(oldStr, newStr, options) {
    return characterDiff.diff(oldStr, newStr, options);
  }

  function generateOptions(options, defaults) {
    if (typeof options === 'function') {
      defaults.callback = options;
    } else if (options) {
      for (var name in options) {
        /* istanbul ignore else */
        if (options.hasOwnProperty(name)) {
          defaults[name] = options[name];
        }
      }
    }

    return defaults;
  }

  //
  // Ranges and exceptions:
  // Latin-1 Supplement, 0080–00FF
  //  - U+00D7  × Multiplication sign
  //  - U+00F7  ÷ Division sign
  // Latin Extended-A, 0100–017F
  // Latin Extended-B, 0180–024F
  // IPA Extensions, 0250–02AF
  // Spacing Modifier Letters, 02B0–02FF
  //  - U+02C7  ˇ &#711;  Caron
  //  - U+02D8  ˘ &#728;  Breve
  //  - U+02D9  ˙ &#729;  Dot Above
  //  - U+02DA  ˚ &#730;  Ring Above
  //  - U+02DB  ˛ &#731;  Ogonek
  //  - U+02DC  ˜ &#732;  Small Tilde
  //  - U+02DD  ˝ &#733;  Double Acute Accent
  // Latin Extended Additional, 1E00–1EFF

  var extendedWordChars = /^[A-Za-z\xC0-\u02C6\u02C8-\u02D7\u02DE-\u02FF\u1E00-\u1EFF]+$/;
  var reWhitespace = /\S/;
  var wordDiff = new Diff();

  wordDiff.equals = function (left, right) {
    if (this.options.ignoreCase) {
      left = left.toLowerCase();
      right = right.toLowerCase();
    }

    return left === right || this.options.ignoreWhitespace && !reWhitespace.test(left) && !reWhitespace.test(right);
  };

  wordDiff.tokenize = function (value) {
    // All whitespace symbols except newline group into one token, each newline - in separate token
    var tokens = value.split(/([^\S\r\n]+|[()[\]{}'"\r\n]|\b)/); // Join the boundary splits that we do not consider to be boundaries. This is primarily the extended Latin character set.

    for (var i = 0; i < tokens.length - 1; i++) {
      // If we have an empty string in the next field and we have only word chars before and after, merge
      if (!tokens[i + 1] && tokens[i + 2] && extendedWordChars.test(tokens[i]) && extendedWordChars.test(tokens[i + 2])) {
        tokens[i] += tokens[i + 2];
        tokens.splice(i + 1, 2);
        i--;
      }
    }

    return tokens;
  };

  function diffWords(oldStr, newStr, options) {
    options = generateOptions(options, {
      ignoreWhitespace: true
    });
    return wordDiff.diff(oldStr, newStr, options);
  }
  function diffWordsWithSpace(oldStr, newStr, options) {
    return wordDiff.diff(oldStr, newStr, options);
  }

  var lineDiff = new Diff();

  lineDiff.tokenize = function (value) {
    var retLines = [],
        linesAndNewlines = value.split(/(\n|\r\n)/); // Ignore the final empty token that occurs if the string ends with a new line

    if (!linesAndNewlines[linesAndNewlines.length - 1]) {
      linesAndNewlines.pop();
    } // Merge the content and line separators into single tokens


    for (var i = 0; i < linesAndNewlines.length; i++) {
      var line = linesAndNewlines[i];

      if (i % 2 && !this.options.newlineIsToken) {
        retLines[retLines.length - 1] += line;
      } else {
        if (this.options.ignoreWhitespace) {
          line = line.trim();
        }

        retLines.push(line);
      }
    }

    return retLines;
  };

  function diffLines(oldStr, newStr, callback) {
    return lineDiff.diff(oldStr, newStr, callback);
  }
  function diffTrimmedLines(oldStr, newStr, callback) {
    var options = generateOptions(callback, {
      ignoreWhitespace: true
    });
    return lineDiff.diff(oldStr, newStr, options);
  }

  var sentenceDiff = new Diff();

  sentenceDiff.tokenize = function (value) {
    return value.split(/(\S.+?[.!?])(?=\s+|$)/);
  };

  function diffSentences(oldStr, newStr, callback) {
    return sentenceDiff.diff(oldStr, newStr, callback);
  }

  var cssDiff = new Diff();

  cssDiff.tokenize = function (value) {
    return value.split(/([{}:;,]|\s+)/);
  };

  function diffCss(oldStr, newStr, callback) {
    return cssDiff.diff(oldStr, newStr, callback);
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";

    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function (obj) {
        return typeof obj;
      };
    } else {
      _typeof = function (obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }

    return _typeof(obj);
  }

  function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return _arrayLikeToArray(arr);
  }

  function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
  }

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

    return arr2;
  }

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var objectPrototypeToString = Object.prototype.toString;
  var jsonDiff = new Diff(); // Discriminate between two lines of pretty-printed, serialized JSON where one of them has a
  // dangling comma and the other doesn't. Turns out including the dangling comma yields the nicest output:

  jsonDiff.useLongestToken = true;
  jsonDiff.tokenize = lineDiff.tokenize;

  jsonDiff.castInput = function (value) {
    var _this$options = this.options,
        undefinedReplacement = _this$options.undefinedReplacement,
        _this$options$stringi = _this$options.stringifyReplacer,
        stringifyReplacer = _this$options$stringi === void 0 ? function (k, v) {
      return typeof v === 'undefined' ? undefinedReplacement : v;
    } : _this$options$stringi;
    return typeof value === 'string' ? value : JSON.stringify(canonicalize(value, null, null, stringifyReplacer), stringifyReplacer, '  ');
  };

  jsonDiff.equals = function (left, right) {
    return Diff.prototype.equals.call(jsonDiff, left.replace(/,([\r\n])/g, '$1'), right.replace(/,([\r\n])/g, '$1'));
  };

  function diffJson(oldObj, newObj, options) {
    return jsonDiff.diff(oldObj, newObj, options);
  } // This function handles the presence of circular references by bailing out when encountering an
  // object that is already on the "stack" of items being processed. Accepts an optional replacer

  function canonicalize(obj, stack, replacementStack, replacer, key) {
    stack = stack || [];
    replacementStack = replacementStack || [];

    if (replacer) {
      obj = replacer(key, obj);
    }

    var i;

    for (i = 0; i < stack.length; i += 1) {
      if (stack[i] === obj) {
        return replacementStack[i];
      }
    }

    var canonicalizedObj;

    if ('[object Array]' === objectPrototypeToString.call(obj)) {
      stack.push(obj);
      canonicalizedObj = new Array(obj.length);
      replacementStack.push(canonicalizedObj);

      for (i = 0; i < obj.length; i += 1) {
        canonicalizedObj[i] = canonicalize(obj[i], stack, replacementStack, replacer, key);
      }

      stack.pop();
      replacementStack.pop();
      return canonicalizedObj;
    }

    if (obj && obj.toJSON) {
      obj = obj.toJSON();
    }

    if (_typeof(obj) === 'object' && obj !== null) {
      stack.push(obj);
      canonicalizedObj = {};
      replacementStack.push(canonicalizedObj);

      var sortedKeys = [],
          _key;

      for (_key in obj) {
        /* istanbul ignore else */
        if (obj.hasOwnProperty(_key)) {
          sortedKeys.push(_key);
        }
      }

      sortedKeys.sort();

      for (i = 0; i < sortedKeys.length; i += 1) {
        _key = sortedKeys[i];
        canonicalizedObj[_key] = canonicalize(obj[_key], stack, replacementStack, replacer, _key);
      }

      stack.pop();
      replacementStack.pop();
    } else {
      canonicalizedObj = obj;
    }

    return canonicalizedObj;
  }

  var arrayDiff = new Diff();

  arrayDiff.tokenize = function (value) {
    return value.slice();
  };

  arrayDiff.join = arrayDiff.removeEmpty = function (value) {
    return value;
  };

  function diffArrays(oldArr, newArr, callback) {
    return arrayDiff.diff(oldArr, newArr, callback);
  }

  function parsePatch(uniDiff) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var diffstr = uniDiff.split(/\r\n|[\n\v\f\r\x85]/),
        delimiters = uniDiff.match(/\r\n|[\n\v\f\r\x85]/g) || [],
        list = [],
        i = 0;

    function parseIndex() {
      var index = {};
      list.push(index); // Parse diff metadata

      while (i < diffstr.length) {
        var line = diffstr[i]; // File header found, end parsing diff metadata

        if (/^(\-\-\-|\+\+\+|@@)\s/.test(line)) {
          break;
        } // Diff index


        var header = /^(?:Index:|diff(?: -r \w+)+)\s+(.+?)\s*$/.exec(line);

        if (header) {
          index.index = header[1];
        }

        i++;
      } // Parse file headers if they are defined. Unified diff requires them, but
      // there's no technical issues to have an isolated hunk without file header


      parseFileHeader(index);
      parseFileHeader(index); // Parse hunks

      index.hunks = [];

      while (i < diffstr.length) {
        var _line = diffstr[i];

        if (/^(Index:|diff|\-\-\-|\+\+\+)\s/.test(_line)) {
          break;
        } else if (/^@@/.test(_line)) {
          index.hunks.push(parseHunk());
        } else if (_line && options.strict) {
          // Ignore unexpected content unless in strict mode
          throw new Error('Unknown line ' + (i + 1) + ' ' + JSON.stringify(_line));
        } else {
          i++;
        }
      }
    } // Parses the --- and +++ headers, if none are found, no lines
    // are consumed.


    function parseFileHeader(index) {
      var fileHeader = /^(---|\+\+\+)\s+(.*)$/.exec(diffstr[i]);

      if (fileHeader) {
        var keyPrefix = fileHeader[1] === '---' ? 'old' : 'new';
        var data = fileHeader[2].split('\t', 2);
        var fileName = data[0].replace(/\\\\/g, '\\');

        if (/^".*"$/.test(fileName)) {
          fileName = fileName.substr(1, fileName.length - 2);
        }

        index[keyPrefix + 'FileName'] = fileName;
        index[keyPrefix + 'Header'] = (data[1] || '').trim();
        i++;
      }
    } // Parses a hunk
    // This assumes that we are at the start of a hunk.


    function parseHunk() {
      var chunkHeaderIndex = i,
          chunkHeaderLine = diffstr[i++],
          chunkHeader = chunkHeaderLine.split(/@@ -(\d+)(?:,(\d+))? \+(\d+)(?:,(\d+))? @@/);
      var hunk = {
        oldStart: +chunkHeader[1],
        oldLines: typeof chunkHeader[2] === 'undefined' ? 1 : +chunkHeader[2],
        newStart: +chunkHeader[3],
        newLines: typeof chunkHeader[4] === 'undefined' ? 1 : +chunkHeader[4],
        lines: [],
        linedelimiters: []
      }; // Unified Diff Format quirk: If the chunk size is 0,
      // the first number is one lower than one would expect.
      // https://www.artima.com/weblogs/viewpost.jsp?thread=164293

      if (hunk.oldLines === 0) {
        hunk.oldStart += 1;
      }

      if (hunk.newLines === 0) {
        hunk.newStart += 1;
      }

      var addCount = 0,
          removeCount = 0;

      for (; i < diffstr.length; i++) {
        // Lines starting with '---' could be mistaken for the "remove line" operation
        // But they could be the header for the next file. Therefore prune such cases out.
        if (diffstr[i].indexOf('--- ') === 0 && i + 2 < diffstr.length && diffstr[i + 1].indexOf('+++ ') === 0 && diffstr[i + 2].indexOf('@@') === 0) {
          break;
        }

        var operation = diffstr[i].length == 0 && i != diffstr.length - 1 ? ' ' : diffstr[i][0];

        if (operation === '+' || operation === '-' || operation === ' ' || operation === '\\') {
          hunk.lines.push(diffstr[i]);
          hunk.linedelimiters.push(delimiters[i] || '\n');

          if (operation === '+') {
            addCount++;
          } else if (operation === '-') {
            removeCount++;
          } else if (operation === ' ') {
            addCount++;
            removeCount++;
          }
        } else {
          break;
        }
      } // Handle the empty block count case


      if (!addCount && hunk.newLines === 1) {
        hunk.newLines = 0;
      }

      if (!removeCount && hunk.oldLines === 1) {
        hunk.oldLines = 0;
      } // Perform optional sanity checking


      if (options.strict) {
        if (addCount !== hunk.newLines) {
          throw new Error('Added line count did not match for hunk at line ' + (chunkHeaderIndex + 1));
        }

        if (removeCount !== hunk.oldLines) {
          throw new Error('Removed line count did not match for hunk at line ' + (chunkHeaderIndex + 1));
        }
      }

      return hunk;
    }

    while (i < diffstr.length) {
      parseIndex();
    }

    return list;
  }

  // Iterator that traverses in the range of [min, max], stepping
  // by distance from a given start position. I.e. for [0, 4], with
  // start of 2, this will iterate 2, 3, 1, 4, 0.
  function distanceIterator (start, minLine, maxLine) {
    var wantForward = true,
        backwardExhausted = false,
        forwardExhausted = false,
        localOffset = 1;
    return function iterator() {
      if (wantForward && !forwardExhausted) {
        if (backwardExhausted) {
          localOffset++;
        } else {
          wantForward = false;
        } // Check if trying to fit beyond text length, and if not, check it fits
        // after offset location (or desired location on first iteration)


        if (start + localOffset <= maxLine) {
          return localOffset;
        }

        forwardExhausted = true;
      }

      if (!backwardExhausted) {
        if (!forwardExhausted) {
          wantForward = true;
        } // Check if trying to fit before text beginning, and if not, check it fits
        // before offset location


        if (minLine <= start - localOffset) {
          return -localOffset++;
        }

        backwardExhausted = true;
        return iterator();
      } // We tried to fit hunk before text beginning and beyond text length, then
      // hunk can't fit on the text. Return undefined

    };
  }

  function applyPatch(source, uniDiff) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

    if (typeof uniDiff === 'string') {
      uniDiff = parsePatch(uniDiff);
    }

    if (Array.isArray(uniDiff)) {
      if (uniDiff.length > 1) {
        throw new Error('applyPatch only works with a single input.');
      }

      uniDiff = uniDiff[0];
    } // Apply the diff to the input


    var lines = source.split(/\r\n|[\n\v\f\r\x85]/),
        delimiters = source.match(/\r\n|[\n\v\f\r\x85]/g) || [],
        hunks = uniDiff.hunks,
        compareLine = options.compareLine || function (lineNumber, line, operation, patchContent) {
      return line === patchContent;
    },
        errorCount = 0,
        fuzzFactor = options.fuzzFactor || 0,
        minLine = 0,
        offset = 0,
        removeEOFNL,
        addEOFNL;
    /**
     * Checks if the hunk exactly fits on the provided location
     */


    function hunkFits(hunk, toPos) {
      for (var j = 0; j < hunk.lines.length; j++) {
        var line = hunk.lines[j],
            operation = line.length > 0 ? line[0] : ' ',
            content = line.length > 0 ? line.substr(1) : line;

        if (operation === ' ' || operation === '-') {
          // Context sanity check
          if (!compareLine(toPos + 1, lines[toPos], operation, content)) {
            errorCount++;

            if (errorCount > fuzzFactor) {
              return false;
            }
          }

          toPos++;
        }
      }

      return true;
    } // Search best fit offsets for each hunk based on the previous ones


    for (var i = 0; i < hunks.length; i++) {
      var hunk = hunks[i],
          maxLine = lines.length - hunk.oldLines,
          localOffset = 0,
          toPos = offset + hunk.oldStart - 1;
      var iterator = distanceIterator(toPos, minLine, maxLine);

      for (; localOffset !== undefined; localOffset = iterator()) {
        if (hunkFits(hunk, toPos + localOffset)) {
          hunk.offset = offset += localOffset;
          break;
        }
      }

      if (localOffset === undefined) {
        return false;
      } // Set lower text limit to end of the current hunk, so next ones don't try
      // to fit over already patched text


      minLine = hunk.offset + hunk.oldStart + hunk.oldLines;
    } // Apply patch hunks


    var diffOffset = 0;

    for (var _i = 0; _i < hunks.length; _i++) {
      var _hunk = hunks[_i],
          _toPos = _hunk.oldStart + _hunk.offset + diffOffset - 1;

      diffOffset += _hunk.newLines - _hunk.oldLines;

      for (var j = 0; j < _hunk.lines.length; j++) {
        var line = _hunk.lines[j],
            operation = line.length > 0 ? line[0] : ' ',
            content = line.length > 0 ? line.substr(1) : line,
            delimiter = _hunk.linedelimiters[j];

        if (operation === ' ') {
          _toPos++;
        } else if (operation === '-') {
          lines.splice(_toPos, 1);
          delimiters.splice(_toPos, 1);
          /* istanbul ignore else */
        } else if (operation === '+') {
          lines.splice(_toPos, 0, content);
          delimiters.splice(_toPos, 0, delimiter);
          _toPos++;
        } else if (operation === '\\') {
          var previousOperation = _hunk.lines[j - 1] ? _hunk.lines[j - 1][0] : null;

          if (previousOperation === '+') {
            removeEOFNL = true;
          } else if (previousOperation === '-') {
            addEOFNL = true;
          }
        }
      }
    } // Handle EOFNL insertion/removal


    if (removeEOFNL) {
      while (!lines[lines.length - 1]) {
        lines.pop();
        delimiters.pop();
      }
    } else if (addEOFNL) {
      lines.push('');
      delimiters.push('\n');
    }

    for (var _k = 0; _k < lines.length - 1; _k++) {
      lines[_k] = lines[_k] + delimiters[_k];
    }

    return lines.join('');
  } // Wrapper that supports multiple file patches via callbacks.

  function applyPatches(uniDiff, options) {
    if (typeof uniDiff === 'string') {
      uniDiff = parsePatch(uniDiff);
    }

    var currentIndex = 0;

    function processIndex() {
      var index = uniDiff[currentIndex++];

      if (!index) {
        return options.complete();
      }

      options.loadFile(index, function (err, data) {
        if (err) {
          return options.complete(err);
        }

        var updatedContent = applyPatch(data, index, options);
        options.patched(index, updatedContent, function (err) {
          if (err) {
            return options.complete(err);
          }

          processIndex();
        });
      });
    }

    processIndex();
  }

  function structuredPatch(oldFileName, newFileName, oldStr, newStr, oldHeader, newHeader, options) {
    if (!options) {
      options = {};
    }

    if (typeof options.context === 'undefined') {
      options.context = 4;
    }

    var diff = diffLines(oldStr, newStr, options);
    diff.push({
      value: '',
      lines: []
    }); // Append an empty value to make cleanup easier

    function contextLines(lines) {
      return lines.map(function (entry) {
        return ' ' + entry;
      });
    }

    var hunks = [];
    var oldRangeStart = 0,
        newRangeStart = 0,
        curRange = [],
        oldLine = 1,
        newLine = 1;

    var _loop = function _loop(i) {
      var current = diff[i],
          lines = current.lines || current.value.replace(/\n$/, '').split('\n');
      current.lines = lines;

      if (current.added || current.removed) {
        var _curRange;

        // If we have previous context, start with that
        if (!oldRangeStart) {
          var prev = diff[i - 1];
          oldRangeStart = oldLine;
          newRangeStart = newLine;

          if (prev) {
            curRange = options.context > 0 ? contextLines(prev.lines.slice(-options.context)) : [];
            oldRangeStart -= curRange.length;
            newRangeStart -= curRange.length;
          }
        } // Output our changes


        (_curRange = curRange).push.apply(_curRange, _toConsumableArray(lines.map(function (entry) {
          return (current.added ? '+' : '-') + entry;
        }))); // Track the updated file position


        if (current.added) {
          newLine += lines.length;
        } else {
          oldLine += lines.length;
        }
      } else {
        // Identical context lines. Track line changes
        if (oldRangeStart) {
          // Close out any changes that have been output (or join overlapping)
          if (lines.length <= options.context * 2 && i < diff.length - 2) {
            var _curRange2;

            // Overlapping
            (_curRange2 = curRange).push.apply(_curRange2, _toConsumableArray(contextLines(lines)));
          } else {
            var _curRange3;

            // end the range and output
            var contextSize = Math.min(lines.length, options.context);

            (_curRange3 = curRange).push.apply(_curRange3, _toConsumableArray(contextLines(lines.slice(0, contextSize))));

            var hunk = {
              oldStart: oldRangeStart,
              oldLines: oldLine - oldRangeStart + contextSize,
              newStart: newRangeStart,
              newLines: newLine - newRangeStart + contextSize,
              lines: curRange
            };

            if (i >= diff.length - 2 && lines.length <= options.context) {
              // EOF is inside this hunk
              var oldEOFNewline = /\n$/.test(oldStr);
              var newEOFNewline = /\n$/.test(newStr);
              var noNlBeforeAdds = lines.length == 0 && curRange.length > hunk.oldLines;

              if (!oldEOFNewline && noNlBeforeAdds && oldStr.length > 0) {
                // special case: old has no eol and no trailing context; no-nl can end up before adds
                // however, if the old file is empty, do not output the no-nl line
                curRange.splice(hunk.oldLines, 0, '\\ No newline at end of file');
              }

              if (!oldEOFNewline && !noNlBeforeAdds || !newEOFNewline) {
                curRange.push('\\ No newline at end of file');
              }
            }

            hunks.push(hunk);
            oldRangeStart = 0;
            newRangeStart = 0;
            curRange = [];
          }
        }

        oldLine += lines.length;
        newLine += lines.length;
      }
    };

    for (var i = 0; i < diff.length; i++) {
      _loop(i);
    }

    return {
      oldFileName: oldFileName,
      newFileName: newFileName,
      oldHeader: oldHeader,
      newHeader: newHeader,
      hunks: hunks
    };
  }
  function formatPatch(diff) {
    var ret = [];

    if (diff.oldFileName == diff.newFileName) {
      ret.push('Index: ' + diff.oldFileName);
    }

    ret.push('===================================================================');
    ret.push('--- ' + diff.oldFileName + (typeof diff.oldHeader === 'undefined' ? '' : '\t' + diff.oldHeader));
    ret.push('+++ ' + diff.newFileName + (typeof diff.newHeader === 'undefined' ? '' : '\t' + diff.newHeader));

    for (var i = 0; i < diff.hunks.length; i++) {
      var hunk = diff.hunks[i]; // Unified Diff Format quirk: If the chunk size is 0,
      // the first number is one lower than one would expect.
      // https://www.artima.com/weblogs/viewpost.jsp?thread=164293

      if (hunk.oldLines === 0) {
        hunk.oldStart -= 1;
      }

      if (hunk.newLines === 0) {
        hunk.newStart -= 1;
      }

      ret.push('@@ -' + hunk.oldStart + ',' + hunk.oldLines + ' +' + hunk.newStart + ',' + hunk.newLines + ' @@');
      ret.push.apply(ret, hunk.lines);
    }

    return ret.join('\n') + '\n';
  }
  function createTwoFilesPatch(oldFileName, newFileName, oldStr, newStr, oldHeader, newHeader, options) {
    return formatPatch(structuredPatch(oldFileName, newFileName, oldStr, newStr, oldHeader, newHeader, options));
  }
  function createPatch(fileName, oldStr, newStr, oldHeader, newHeader, options) {
    return createTwoFilesPatch(fileName, fileName, oldStr, newStr, oldHeader, newHeader, options);
  }

  function arrayEqual(a, b) {
    if (a.length !== b.length) {
      return false;
    }

    return arrayStartsWith(a, b);
  }
  function arrayStartsWith(array, start) {
    if (start.length > array.length) {
      return false;
    }

    for (var i = 0; i < start.length; i++) {
      if (start[i] !== array[i]) {
        return false;
      }
    }

    return true;
  }

  function calcLineCount(hunk) {
    var _calcOldNewLineCount = calcOldNewLineCount(hunk.lines),
        oldLines = _calcOldNewLineCount.oldLines,
        newLines = _calcOldNewLineCount.newLines;

    if (oldLines !== undefined) {
      hunk.oldLines = oldLines;
    } else {
      delete hunk.oldLines;
    }

    if (newLines !== undefined) {
      hunk.newLines = newLines;
    } else {
      delete hunk.newLines;
    }
  }
  function merge(mine, theirs, base) {
    mine = loadPatch(mine, base);
    theirs = loadPatch(theirs, base);
    var ret = {}; // For index we just let it pass through as it doesn't have any necessary meaning.
    // Leaving sanity checks on this to the API consumer that may know more about the
    // meaning in their own context.

    if (mine.index || theirs.index) {
      ret.index = mine.index || theirs.index;
    }

    if (mine.newFileName || theirs.newFileName) {
      if (!fileNameChanged(mine)) {
        // No header or no change in ours, use theirs (and ours if theirs does not exist)
        ret.oldFileName = theirs.oldFileName || mine.oldFileName;
        ret.newFileName = theirs.newFileName || mine.newFileName;
        ret.oldHeader = theirs.oldHeader || mine.oldHeader;
        ret.newHeader = theirs.newHeader || mine.newHeader;
      } else if (!fileNameChanged(theirs)) {
        // No header or no change in theirs, use ours
        ret.oldFileName = mine.oldFileName;
        ret.newFileName = mine.newFileName;
        ret.oldHeader = mine.oldHeader;
        ret.newHeader = mine.newHeader;
      } else {
        // Both changed... figure it out
        ret.oldFileName = selectField(ret, mine.oldFileName, theirs.oldFileName);
        ret.newFileName = selectField(ret, mine.newFileName, theirs.newFileName);
        ret.oldHeader = selectField(ret, mine.oldHeader, theirs.oldHeader);
        ret.newHeader = selectField(ret, mine.newHeader, theirs.newHeader);
      }
    }

    ret.hunks = [];
    var mineIndex = 0,
        theirsIndex = 0,
        mineOffset = 0,
        theirsOffset = 0;

    while (mineIndex < mine.hunks.length || theirsIndex < theirs.hunks.length) {
      var mineCurrent = mine.hunks[mineIndex] || {
        oldStart: Infinity
      },
          theirsCurrent = theirs.hunks[theirsIndex] || {
        oldStart: Infinity
      };

      if (hunkBefore(mineCurrent, theirsCurrent)) {
        // This patch does not overlap with any of the others, yay.
        ret.hunks.push(cloneHunk(mineCurrent, mineOffset));
        mineIndex++;
        theirsOffset += mineCurrent.newLines - mineCurrent.oldLines;
      } else if (hunkBefore(theirsCurrent, mineCurrent)) {
        // This patch does not overlap with any of the others, yay.
        ret.hunks.push(cloneHunk(theirsCurrent, theirsOffset));
        theirsIndex++;
        mineOffset += theirsCurrent.newLines - theirsCurrent.oldLines;
      } else {
        // Overlap, merge as best we can
        var mergedHunk = {
          oldStart: Math.min(mineCurrent.oldStart, theirsCurrent.oldStart),
          oldLines: 0,
          newStart: Math.min(mineCurrent.newStart + mineOffset, theirsCurrent.oldStart + theirsOffset),
          newLines: 0,
          lines: []
        };
        mergeLines(mergedHunk, mineCurrent.oldStart, mineCurrent.lines, theirsCurrent.oldStart, theirsCurrent.lines);
        theirsIndex++;
        mineIndex++;
        ret.hunks.push(mergedHunk);
      }
    }

    return ret;
  }

  function loadPatch(param, base) {
    if (typeof param === 'string') {
      if (/^@@/m.test(param) || /^Index:/m.test(param)) {
        return parsePatch(param)[0];
      }

      if (!base) {
        throw new Error('Must provide a base reference or pass in a patch');
      }

      return structuredPatch(undefined, undefined, base, param);
    }

    return param;
  }

  function fileNameChanged(patch) {
    return patch.newFileName && patch.newFileName !== patch.oldFileName;
  }

  function selectField(index, mine, theirs) {
    if (mine === theirs) {
      return mine;
    } else {
      index.conflict = true;
      return {
        mine: mine,
        theirs: theirs
      };
    }
  }

  function hunkBefore(test, check) {
    return test.oldStart < check.oldStart && test.oldStart + test.oldLines < check.oldStart;
  }

  function cloneHunk(hunk, offset) {
    return {
      oldStart: hunk.oldStart,
      oldLines: hunk.oldLines,
      newStart: hunk.newStart + offset,
      newLines: hunk.newLines,
      lines: hunk.lines
    };
  }

  function mergeLines(hunk, mineOffset, mineLines, theirOffset, theirLines) {
    // This will generally result in a conflicted hunk, but there are cases where the context
    // is the only overlap where we can successfully merge the content here.
    var mine = {
      offset: mineOffset,
      lines: mineLines,
      index: 0
    },
        their = {
      offset: theirOffset,
      lines: theirLines,
      index: 0
    }; // Handle any leading content

    insertLeading(hunk, mine, their);
    insertLeading(hunk, their, mine); // Now in the overlap content. Scan through and select the best changes from each.

    while (mine.index < mine.lines.length && their.index < their.lines.length) {
      var mineCurrent = mine.lines[mine.index],
          theirCurrent = their.lines[their.index];

      if ((mineCurrent[0] === '-' || mineCurrent[0] === '+') && (theirCurrent[0] === '-' || theirCurrent[0] === '+')) {
        // Both modified ...
        mutualChange(hunk, mine, their);
      } else if (mineCurrent[0] === '+' && theirCurrent[0] === ' ') {
        var _hunk$lines;

        // Mine inserted
        (_hunk$lines = hunk.lines).push.apply(_hunk$lines, _toConsumableArray(collectChange(mine)));
      } else if (theirCurrent[0] === '+' && mineCurrent[0] === ' ') {
        var _hunk$lines2;

        // Theirs inserted
        (_hunk$lines2 = hunk.lines).push.apply(_hunk$lines2, _toConsumableArray(collectChange(their)));
      } else if (mineCurrent[0] === '-' && theirCurrent[0] === ' ') {
        // Mine removed or edited
        removal(hunk, mine, their);
      } else if (theirCurrent[0] === '-' && mineCurrent[0] === ' ') {
        // Their removed or edited
        removal(hunk, their, mine, true);
      } else if (mineCurrent === theirCurrent) {
        // Context identity
        hunk.lines.push(mineCurrent);
        mine.index++;
        their.index++;
      } else {
        // Context mismatch
        conflict(hunk, collectChange(mine), collectChange(their));
      }
    } // Now push anything that may be remaining


    insertTrailing(hunk, mine);
    insertTrailing(hunk, their);
    calcLineCount(hunk);
  }

  function mutualChange(hunk, mine, their) {
    var myChanges = collectChange(mine),
        theirChanges = collectChange(their);

    if (allRemoves(myChanges) && allRemoves(theirChanges)) {
      // Special case for remove changes that are supersets of one another
      if (arrayStartsWith(myChanges, theirChanges) && skipRemoveSuperset(their, myChanges, myChanges.length - theirChanges.length)) {
        var _hunk$lines3;

        (_hunk$lines3 = hunk.lines).push.apply(_hunk$lines3, _toConsumableArray(myChanges));

        return;
      } else if (arrayStartsWith(theirChanges, myChanges) && skipRemoveSuperset(mine, theirChanges, theirChanges.length - myChanges.length)) {
        var _hunk$lines4;

        (_hunk$lines4 = hunk.lines).push.apply(_hunk$lines4, _toConsumableArray(theirChanges));

        return;
      }
    } else if (arrayEqual(myChanges, theirChanges)) {
      var _hunk$lines5;

      (_hunk$lines5 = hunk.lines).push.apply(_hunk$lines5, _toConsumableArray(myChanges));

      return;
    }

    conflict(hunk, myChanges, theirChanges);
  }

  function removal(hunk, mine, their, swap) {
    var myChanges = collectChange(mine),
        theirChanges = collectContext(their, myChanges);

    if (theirChanges.merged) {
      var _hunk$lines6;

      (_hunk$lines6 = hunk.lines).push.apply(_hunk$lines6, _toConsumableArray(theirChanges.merged));
    } else {
      conflict(hunk, swap ? theirChanges : myChanges, swap ? myChanges : theirChanges);
    }
  }

  function conflict(hunk, mine, their) {
    hunk.conflict = true;
    hunk.lines.push({
      conflict: true,
      mine: mine,
      theirs: their
    });
  }

  function insertLeading(hunk, insert, their) {
    while (insert.offset < their.offset && insert.index < insert.lines.length) {
      var line = insert.lines[insert.index++];
      hunk.lines.push(line);
      insert.offset++;
    }
  }

  function insertTrailing(hunk, insert) {
    while (insert.index < insert.lines.length) {
      var line = insert.lines[insert.index++];
      hunk.lines.push(line);
    }
  }

  function collectChange(state) {
    var ret = [],
        operation = state.lines[state.index][0];

    while (state.index < state.lines.length) {
      var line = state.lines[state.index]; // Group additions that are immediately after subtractions and treat them as one "atomic" modify change.

      if (operation === '-' && line[0] === '+') {
        operation = '+';
      }

      if (operation === line[0]) {
        ret.push(line);
        state.index++;
      } else {
        break;
      }
    }

    return ret;
  }

  function collectContext(state, matchChanges) {
    var changes = [],
        merged = [],
        matchIndex = 0,
        contextChanges = false,
        conflicted = false;

    while (matchIndex < matchChanges.length && state.index < state.lines.length) {
      var change = state.lines[state.index],
          match = matchChanges[matchIndex]; // Once we've hit our add, then we are done

      if (match[0] === '+') {
        break;
      }

      contextChanges = contextChanges || change[0] !== ' ';
      merged.push(match);
      matchIndex++; // Consume any additions in the other block as a conflict to attempt
      // to pull in the remaining context after this

      if (change[0] === '+') {
        conflicted = true;

        while (change[0] === '+') {
          changes.push(change);
          change = state.lines[++state.index];
        }
      }

      if (match.substr(1) === change.substr(1)) {
        changes.push(change);
        state.index++;
      } else {
        conflicted = true;
      }
    }

    if ((matchChanges[matchIndex] || '')[0] === '+' && contextChanges) {
      conflicted = true;
    }

    if (conflicted) {
      return changes;
    }

    while (matchIndex < matchChanges.length) {
      merged.push(matchChanges[matchIndex++]);
    }

    return {
      merged: merged,
      changes: changes
    };
  }

  function allRemoves(changes) {
    return changes.reduce(function (prev, change) {
      return prev && change[0] === '-';
    }, true);
  }

  function skipRemoveSuperset(state, removeChanges, delta) {
    for (var i = 0; i < delta; i++) {
      var changeContent = removeChanges[removeChanges.length - delta + i].substr(1);

      if (state.lines[state.index + i] !== ' ' + changeContent) {
        return false;
      }
    }

    state.index += delta;
    return true;
  }

  function calcOldNewLineCount(lines) {
    var oldLines = 0;
    var newLines = 0;
    lines.forEach(function (line) {
      if (typeof line !== 'string') {
        var myCount = calcOldNewLineCount(line.mine);
        var theirCount = calcOldNewLineCount(line.theirs);

        if (oldLines !== undefined) {
          if (myCount.oldLines === theirCount.oldLines) {
            oldLines += myCount.oldLines;
          } else {
            oldLines = undefined;
          }
        }

        if (newLines !== undefined) {
          if (myCount.newLines === theirCount.newLines) {
            newLines += myCount.newLines;
          } else {
            newLines = undefined;
          }
        }
      } else {
        if (newLines !== undefined && (line[0] === '+' || line[0] === ' ')) {
          newLines++;
        }

        if (oldLines !== undefined && (line[0] === '-' || line[0] === ' ')) {
          oldLines++;
        }
      }
    });
    return {
      oldLines: oldLines,
      newLines: newLines
    };
  }

  // See: http://code.google.com/p/google-diff-match-patch/wiki/API
  function convertChangesToDMP(changes) {
    var ret = [],
        change,
        operation;

    for (var i = 0; i < changes.length; i++) {
      change = changes[i];

      if (change.added) {
        operation = 1;
      } else if (change.removed) {
        operation = -1;
      } else {
        operation = 0;
      }

      ret.push([operation, change.value]);
    }

    return ret;
  }

  function convertChangesToXML(changes) {
    var ret = [];

    for (var i = 0; i < changes.length; i++) {
      var change = changes[i];

      if (change.added) {
        ret.push('<ins>');
      } else if (change.removed) {
        ret.push('<del>');
      }

      ret.push(escapeHTML(change.value));

      if (change.added) {
        ret.push('</ins>');
      } else if (change.removed) {
        ret.push('</del>');
      }
    }

    return ret.join('');
  }

  function escapeHTML(s) {
    var n = s;
    n = n.replace(/&/g, '&amp;');
    n = n.replace(/</g, '&lt;');
    n = n.replace(/>/g, '&gt;');
    n = n.replace(/"/g, '&quot;');
    return n;
  }

  exports.Diff = Diff;
  exports.applyPatch = applyPatch;
  exports.applyPatches = applyPatches;
  exports.canonicalize = canonicalize;
  exports.convertChangesToDMP = convertChangesToDMP;
  exports.convertChangesToXML = convertChangesToXML;
  exports.createPatch = createPatch;
  exports.createTwoFilesPatch = createTwoFilesPatch;
  exports.diffArrays = diffArrays;
  exports.diffChars = diffChars;
  exports.diffCss = diffCss;
  exports.diffJson = diffJson;
  exports.diffLines = diffLines;
  exports.diffSentences = diffSentences;
  exports.diffTrimmedLines = diffTrimmedLines;
  exports.diffWords = diffWords;
  exports.diffWordsWithSpace = diffWordsWithSpace;
  exports.merge = merge;
  exports.parsePatch = parsePatch;
  exports.structuredPatch = structuredPatch;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
TP.boot.$$srcPath = '';

        
        TP.registerExternalObject('Diff', window.Diff);
        
    
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETEncapsulation.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
TIBET provides a number of functions designed to increase the level of object
encapsulation in JavaScript programs. This means we control slot access via
set/get as well as object creation via construct(). This section installs the
basic support required for encapsulation.
*/

/* eslint no-new-func:0, no-new-wrappers:0, no-new-object:0 */

//  ------------------------------------------------------------------------
//  FUNCTION EXTRAS
//  ------------------------------------------------------------------------

//  does the function reference 'this' or is it native code we need to bind
Function.$$methodTestRegex = /this[\.;]|native code/;

//  if the function references 'this' what is it going to use/invoke?
Function.$$methodNeedRegex = /this\.([$]*[\w]+)/g;

//  ------------------------------------------------------------------------

TP.FunctionProto.defineMethod('$getNeeds',
function() {

    /**
     * @method $getNeeds
     * @summary Returns a list of 'needs' or functions that the receiver will
     *     attempt to invoke on any internal 'this' references.
     * @description This is useful for the inferencer since it can decide to
     *     rank order its options by how well the function in question matches
     *     the needs. It's also useful for collecting information on 'senders'.
     *     The add*Method calls already track 'implementers' but by invoking
     *     $getNeeds() on each method as it goes by the system can capture
     *     senders too.
     * @returns {Function[]} The list of functions that the receiver will attempt
     *     to invoke on itself.
     */

    var re,
        arr,
        results;

    re = Function.$$methodNeedRegex;
    re.lastIndex = 0;

    arr = TP.ac();

    if (re.test(this.toString())) {
        re.lastIndex = 0;
        results = this.toString().match(re);

        results.perform(
                function(item) {
                    arr.push(item.strip('this.'));
                });

        arr = arr.unique();
    }

    return arr;
});

//  ------------------------------------------------------------------------

TP.FunctionProto.defineMethod('$hasThis',
function() {

    /**
     * @method $hasThis
     * @summary Returns true if the receiver has any 'this' references, either
     *     as method/attribute access (this.blah) or by associating 'this' with
     *     a variable for closure purposes as in var thisArg = this;. The result
     *     of this check is cached for future lookup to help support faster
     *     invocations.
     * @returns {Boolean} True if the receiver has this references.
     */

    if (!this.hasOwnProperty('$$this')) {
        this.$$this = Function.$$methodTestRegex.test(this.toString());
    }

    return TP.isTrue(this.$$this);
});

//  ------------------------------------------------------------------------
//  SUPPORT
//  ------------------------------------------------------------------------

//  stub for early Array calls, replaced later in kernel
TP.ArrayProto.changed = TP.RETURN_THIS;

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('unique',
function(aFilter, undefNotNull) {

    /**
     * @method unique
     * @summary Collapses the array to contain only 1 of each unique value
     *     based on a filtering function, or on unique object ID. One special
     *     consideration is whether invalid values (null and undefined) should
     *     be considered "equal" for purposes of this uniquing process.
     * @param {Function} [aFilter] A function which accepts an object and
     *     returns the value to compare for uniqueness.
     * @param {Boolean} [undefNotNull=false] True to have undefined values
     *     compare differently than nulls for uniquing purposes.
     * @returns {Array} The receiver.
     * @fires Change
     */

    var newArr,

        func,
        undef,
        dict,
        len,
        wi,
        i,
        obj,
        val;

    //  can't be anything but unique if only one element
    if (this.length < 2) {
        return this;
    }

    //  If there is no filter and we're not comparing nulls differently to
    //  undefineds, then just use an ECMA6 Set and create an Array from that for
    //  much faster performance.
    if (TP.notValid(aFilter) && TP.notValid(undefNotNull)) {
        //  Since this method is a mutator, we need to replace the values in
        //  ourself.

        //  Create a new Array from a new Set. This will automatically unique
        //  the values in the new Array.
        newArr = [...new Set(this)];

        //  Remove all of the values in ourself.
        this.length = 0;

        //  Assign the properties of the new Array into ourself. This will
        //  repopulate ourself.
        Object.assign(this, newArr);

        return this;
    }

    func = TP.ifInvalid(aFilter, TP.gid);
    undef = TP.ifInvalid(undefNotNull, false);

    dict = TP.hc();
    len = this.getSize();

    //  the current "write index"
    wi = 0;

    for (i = 0; i < len; i++) {
        obj = this[i];

        try {
            val = func(obj);
        } catch (e) {
            TP.ifError() ?
                TP.error(TP.ec(e, 'Error uniquing Array')) : 0;
        }

        //  have to process null/undefined into string keys we can match
        //  against with relative safety...
        if (undef) {
            if (TP.notDefined(val)) {
                val = TP.UNDEF;
            } else if (TP.isNull(val)) {
                val = TP.NULL;
            }
        } else if (TP.notValid(val)) {
            val = TP.NULL;
        }

        if (TP.isValid(dict.at(val))) {
            continue;
        }

        //  doesn't matter what we put here, so keep it simple
        dict.atPut(val, true);

        this[wi] = obj;
        wi++;
    }

    if (wi < len) {
        this.length = wi;
        this.changed('length', TP.UPDATE,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));
    }

    return this;
});

//  ------------------------------------------------------------------------
//  ATTRIBUTE / SLOT MANAGEMENT
//  ------------------------------------------------------------------------

TP.definePrimitive('stripPropertyPrefix',
function(anObject) {

    /**
     * @method stripPropertyPrefix
     * @summary Removes any leading attribute prefix from the property name,
     *     typically in order to produce a change signal.
     * @param {String|Number} anObject An attribute name or index (sometimes
     *     numerical) that may require adjustment for lookup via get() or set().
     * @returns {String|Number} The supplied object stripped of its prefix.
     */

    var prefixChar;

    //  called from get so if we didnt' get a viable string return
    if (!TP.isString(anObject)) {
        return anObject;
    }

    prefixChar = anObject.charAt(0);

    if (prefixChar === '_') {
        //  by far the most common, protected variable
        return anObject.slice(1);
    } else if (prefixChar === '$') {
        //  private or internal?
        if (anObject.charAt(1) === '$') {
            //  $$ is internal
            return anObject.slice(2);
        } else {
            //  single $ is private
            return anObject.slice(1);
        }
    }

    return anObject;
});

//  ------------------------------------------------------------------------

/*
Array properties required for sorting behavior. Sorting is a step TIBET's
arrays take when accessed via set/get or at/atPut to ensure the proper data
is being altered and that the data returned is in the proper order. Until
they are accessed the Array contents aren't kept in sorted order for
efficiency.
*/

//  control flag helping avoid redundant sorts in certain scenarios
TP.ArrayProto.$firstSort = true;

//  is the array dirty?
TP.ArrayProto.$needsSort = true;

//  which sort function?
TP.ArrayProto.sortFunction = null;

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('$sortIfNeeded',
function() {

    /**
     * @method $sortIfNeeded
     * @summary Sorts the receiver if it is both acting as a sorted collection
     *     and is currently in need of sorting (it's changed since the last
     *     sort).
     * @returns {Array} The receiver.
     */

    if (this.$needsSort && this.sortFunction) {
        //  apparently "undefined" isn't a "valid sort argument", even
        //  though the docs will tell you sort() without a param is ok
        if (TP.isCallable(this.sortFunction)) {
            this.sort(this.sortFunction);
        } else {
            this.sort();
        }

        this.$needsSort = false;

        //  if this is set to true we just changed to a sorted collection
        //  and notification happened there...don't do it again
        if (TP.isFalse(this.$firstSort)) {
            this.changed('order', TP.SORTED);
            this.$firstSort = false;
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('$get',
function(attributeName) {

    /**
     * @method $get
     * @summary Returns the value, if any, for the attribute provided. In the
     *     case of Array we deal with the fact that there are numeric indexes as
     *     well as the 'object keys' normally found on objects. See $get on
     *     Object for more information.
     * @param {String} attributeName The name of the particular attribute.
     * @returns {Object|undefined} The value contained in the named attribute on
     *     the receiver.
     */

    var attr;

    if (TP.isNumber(attributeName)) {
        //  have to deal with negative indices, out-of-bounds, etc.
        attr = attributeName;

        if (attr < 0) {
            attr = Math.max(0, this.length + attr);
        }

        if (attr >= this.length) {
            return;
        }

        //  sort prior to retrieval so we get the right value
        this.$sortIfNeeded();

        return this[attr];
    } else {
        //  defer to standard lookup from Object if non-numeric key
        return this[attributeName];
    }
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('$set',
function(attributeName, attributeValue, shouldSignal, allowUndef) {

    /**
     * @method $set
     * @summary Sets the value of the named slot to the value provided and
     *     signals changes if appropriate. No attempt is made to manage aspects,
     *     or to lookup setters. This is the default primitive slot setter.
     * @param {String} attributeName The name of the attribute.
     * @param {Object} attributeValue The value to set in that slot.
     * @param {Boolean} shouldSignal If false no signaling occurs. Defaults to
     *     this.shouldSignalChange().
     * @param {Boolean} allowUndef True to let the slot value be set to
     *     undefined. This isn't normally done except by certain container
     *     types, especially response objects.
     * @returns {Object} The receiver.
     */

    var newVal,
        oldVal,
        op,

        sigFlag,
        oldFlag;

    if (allowUndef !== true) {
        newVal = TP.ifInvalid(attributeValue, null);
    } else {
        newVal = attributeValue;
    }

    oldVal = this[attributeName];

    //  bypass warning for "internal" since we assume these are very
    //  explicit and can often be "demand driven" to avoid exposure
    if (!allowUndef &&
        !TP.isProperty(this, attributeName) &&
        !TP.regex.INTERNAL_SLOT.test(attributeName)) {
        TP.ifWarn() ?
            TP.warn(TP.sc('Setting undefined attribute: ',
                            TP.name(this), '.', attributeName,
                            ' (', TP.tname(this), ')',
                            TP.tname(this) === 'Window' ?
                                TP.sc(' -- Possible unbound function') :
                                '')) : 0;
    }

    op = TP.UPDATE;

    if (TP.notDefined(oldVal)) {
        //  no change? no reason to continue
        if (TP.notDefined(newVal)) {
            return this;
        }
        op = TP.CREATE; //  value didn't exist - we're creating it.
    } else if (TP.isNull(oldVal)) {
        //  no change? no reason to continue
        if (TP.isNull(newVal)) {
            return this;
        }
    } else if (TP.isValid(oldVal)) {
        //  if the value is non-null it's been set before, so the slot
        //  exists, but we need to know if we're being asked to change it

        //  for 'change' testing we demand equivalent types
        if (typeof oldVal === typeof newVal) {
            /* eslint-disable eqeqeq */
            if (oldVal == newVal) {
            /* eslint-enable eqeqeq */
                return this;
            }
        }
    }

    //  note that we set null as the default here so we'll know a set call
    //  was made at some point
    this[attributeName] = newVal;

    //  NB: Use this construct this way for better performance
    if (TP.notValid(sigFlag = shouldSignal)) {
        sigFlag = this.shouldSignalChange();
    }

    if (sigFlag) {
        oldFlag = this.shouldSignalChange();

        this.shouldSignalChange(sigFlag);
        this.changed(TP.stripPropertyPrefix(attributeName),
                        op,
                        TP.hc(TP.OLDVAL, oldVal, TP.NEWVAL, newVal));
        this.shouldSignalChange(oldFlag);
    }

    return this;
});

//  ------------------------------------------------------------------------

//  hook for 'call next' from Array, but don't use 'Inst.defineMethod()' as we
//  don't want to reset the owner, track, etc.
Array.prototype.$$set = Array.prototype.$set;

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('$set',
function(attributeName, attributeValue, shouldSignal, allowUndef) {

    /**
     * @method $set
     * @summary Sets the value of the named/numbered slot to the value provided
     *     and signals changes if appropriate. No attempt is made to manage
     *     aspects, or to lookup setters. This is *the* primitive slot setter.
     * @param {String|Number} attributeName The name or # of the attribute.
     * @param {Object} attributeValue The value to set in that slot.
     * @param {Boolean} shouldSignal If false no signaling occurs. Defaults to
     *     this.shouldSignalChange().
     * @param {Boolean} allowUndef True to let the slot value be set to
     *     undefined. This isn't normally done except by certain container
     *     types, especially response objects.
     * @returns {Object} The receiver.
     */

    var newVal,
        attr,
        op,
        oldVal,

        sigFlag,
        oldFlag;

    newVal = TP.ifInvalid(attributeValue, null);

    if (TP.isNumber(attributeName)) {
        attr = attributeName;
        if (attr < 0) {
            attr = Math.max(0, this.length + attr);
        }

        //  make sure we're in the right order before testing slot
        this.$sortIfNeeded();

        oldVal = this[attr];

        if (TP.isDefined(oldVal)) {
            if (typeof oldVal === typeof newVal) {
                /* eslint-disable eqeqeq */
                if (oldVal == newVal) {
                /* eslint-enable eqeqeq */
                    return this;
                }
            }
            op = TP.UPDATE;

        } else {
            //  value didn't exist - we're creating it.
            op = TP.CREATE;
        }

        this[attr] = newVal;

        sigFlag = shouldSignal;
        if (TP.notValid(sigFlag)) {
            sigFlag = this.shouldSignalChange();
        }

        if (sigFlag) {
            oldFlag = this.shouldSignalChange();

            this.shouldSignalChange(sigFlag);
            this.changed(TP.stripPropertyPrefix(attributeName),
                            op,
                            TP.hc(TP.OLDVAL, oldVal, TP.NEWVAL, newVal));
            this.shouldSignalChange(oldFlag);
        }
    } else {
        return this.$$set(attributeName, newVal, shouldSignal, allowUndef);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('normalizeIndex',
function(anIndex) {

    /**
     * @method normalizeIndex
     * @summary Adapts negative indexes to indexed collection sizes. When using
     *     any of the at*(), or *At() methods in TIBET the indexes can be
     *     negative. This method adjusts the negative indexes using a common
     *     algorithm which wraps negative values repeatedly until they settle
     *     within the receiver's size.
     * @param {Number|String} anIndex An index to adjust to a location within
     *     the receiver.
     * @returns {Number|String} The normalized index.
     */

    var size,
        index;

    if (!TP.isNumber(anIndex)) {
        return anIndex;
    }

    if (anIndex >= 0) {
        return anIndex;
    }

    size = this.getSize();

    //  one boundary condition is a negative index into an empty array.
    //  we'll set that to 0
    if (size === 0) {
        return 0;
    }

    index = anIndex;

    //  any other scenario means we've got a shot at reducing the index
    //  until it lands in the array at some location
    index = size + index;

    return this.normalizeIndex(index);
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('at',
function(anIndex) {

    /**
     * @method at
     * @summary Returns the value at the index provided. DNU slots are ignored
     *     and no prefix translation is performed. If the receiver implements
     *     get() this method defers to that call.
     * @param {Object} anIndex The index of the value to return.
     * @returns {Object} The element at anIndex in this collection.
     */

    if (TP.canInvoke(this, 'get')) {
        return this.get(anIndex);
    }

    return this[anIndex];
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('atPut',
function(anIndex, aValue) {

    /**
     * @method atPut
     * @summary Replaces the value at anIndex with aValue.
     * @param {Object} anIndex The index to put aValue into.
     * @param {Object} aValue The value to place at anIndex.
     * @returns {Object} The receiver.
     * @fires Change
     */

    var index;

    index = anIndex > 0 ? anIndex : this.normalizeIndex(anIndex);

    //  no translation...just direct set/change notification - note that by
    //  passing 'null' for the 'shouldSignal' parameter here, we let the
    //  receiver's 'shouldSignalChange' property take effect.
    return this.$set(index, aValue, null, false);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('at',
function(anIndex, varargs) {

    /**
     * @method at
     * @summary Returns the value found at an index. Provides polymorphic
     *     access to indexed collection data, which isn't possible with literal
     *     bracket syntax (you can't use []'s on strings etc).
     * @description To support multi-dimensional access this method will allow
     *     more than one index parameter as in arr.at(1, 1) so that, in reality,
     *     the value is acquired from a nested child of the receiver. For
     *     example, arr.at(1, 1) returns the value 3 when used on the array
     *     [[0,1],[2,3]]. This is equivalent to the syntax arr[1][1];
     * @param {Number} anIndex The index to access. Note that this value is the
     *     first index in a potential list of indicies.
     * @param {arguments} varargs A variable list of 0 to N additional indexes
     *     which descend into nested array children.
     * @returns {Object} The value at the index.
     * @addon Array
     */

    var index,
        len,

        val,
        i;

    //  non-numerical indexes are supported via get() which doesn't need to
    //  support multi-dimensional content access.
    if (!TP.isNumber(anIndex)) {
        return this.get(anIndex);
    }

    index = this.normalizeIndex(anIndex);

    //  99% case, and touching arguments object slows it down
    if (TP.notValid(varargs)) {
        return this[index];
    }

    len = arguments.length;
    switch (len) {
        case 0:

            return TP.raise(this, 'TP.sig.InvalidIndex');

        default:

            val = this[index];

            for (i = 1; i < len; i++) {
                if (TP.isValid(val)) {
                    val = val[this.normalizeIndex(arguments[i])];
                } else {
                    //  won't consider this an error, just return null
                    break;
                }
            }

            return val;
    }
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('atPut',
function(anIndex, varargs, aValue) {

    /**
     * @method atPut
     * @summary Sets the value found at anIndex. Provides polymorphic access to
     *     updating indexed collection data, which isn't possible with literal
     *     bracket syntax. This version does not provide change notification.
     *     NOTE that this initial version does not support vararg values or
     *     negative indices.
     * @description To support multi-dimensional access this method will allow
     *     more than one index parameter as in arr.atPut(1, 2, 'foo') so that,
     *     in reality, aValue is defined by the last argument and is placed in
     *     the location found by traversing to the last index (arguments.length
     *     - 2) provided.
     * @param {Number} anIndex The index to set/update.
     * @param {arguments} varargs A variable list of 0 to N additional indexes
     *     which descend into nested array children.
     * @param {Object} aValue The object to place at anIndex. NOTE that the
     *     position of this attribute may actually vary if multiple indexes are
     *     supplied.
     * @returns {Array} The receiver.
     * @addon Array
     */

    var index,
        val,
        op,

        len,

        obj,
        i;

    //  non-numerical indexes are supported via get() which doesn't need to
    //  support multi-dimensional content access.
    if (!TP.isNumber(anIndex)) {
        return this.set(anIndex, varargs || aValue, null, false);
    }

    index = this.normalizeIndex(anIndex);

    //  99% case, and touching arguments object slows it down
    if (aValue === undefined) {

        val = this[index];

        this[index] = varargs;

        /* eslint-disable eqeqeq */
        if (val != varargs) {
        /* eslint-enable eqeqeq */
            op = val === undefined ? TP.CREATE : TP.UPDATE;

            //  Still subject to whether the object has 'shouldSignalChange()'
            //  set -- usually false.
            this.changed(index, op, TP.hc(TP.OLDVAL, val, TP.NEWVAL, varargs));
        }

        return this;
    }

    len = arguments.length;
    switch (len) {
        case 0:
            return TP.raise(this, 'TP.sig.InvalidIndex');

        default:

            /* eslint-disable consistent-this */

            //  navigate to the proper location, stopping just before the
            //  end so we've trimmed down to index and value
            obj = this;
            for (i = 0; i < len - 2; i++) {
                if (TP.isValid(obj)) {
                    obj = obj[this.normalizeIndex(arguments[i])];
                } else {
                    //  can't access an object at the index provided, so
                    //  we'll raise an exception for now. in some cases we
                    //  might have preferred to build a new container
                    return TP.raise(this, 'TP.sig.InvalidIndex');
                }
            }

            //  perform the operation on the final object using our last
            //  index and the value provided
            if (TP.canInvoke(obj, 'atPut')) {
                val = obj.at(arguments[len - 2]);
                obj.atPut(arguments[len - 2], arguments[len - 1]);
            } else {
                try {
                    val = arguments[len - 2];
                    obj[arguments[len - 2]] = arguments[len - 1];
                } catch (e) {
                    return TP.raise(this, 'TP.sig.ArrayException',
                                    TP.ec(e));
                }
            }

            /* eslint-enable consistent-this */

            //  fall through so we can do change notification
    }

    /* eslint-disable eqeqeq */
    if (val != aValue) {
    /* eslint-enable eqeqeq */
        //  Since we changed multiple slots, some or all of which might have
        //  already existed, we just send 'TP.UPDATE' here with an aspect of
        //  'length'.
        this.changed('length', TP.UPDATE);
    }

    return this;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('at',
function(anIndex) {

    /**
     * @method at
     * @summary Returns the value at the index provided. See charAt().
     * @param {Number} anIndex The index to use for locating the character.
     * @returns {String} The item at the index provided or undefined.
     */

    if (TP.isNumber(anIndex)) {
        return this.charAt(this.normalizeIndex(anIndex));
    } else {
        return this.get(anIndex);
    }
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('atPut',
function(anIndex, aValue) {

    /**
     * @method atPut
     * @summary Replaces the value at anIndex with aValue. NOTE that because
     *     strings are not mutable objects and aren't strictly collections in
     *     JavaScript this method returns a new string instance rather than
     *     updating the string in place.
     * @param {Object} anIndex The index to put aValue into.
     * @param {Object} aValue The value to place at anIndex.
     * @returns {Object} A new string with the adjusted value.
     * @fires Change
     */

    var index;

    //  NB: Because we're not changing the original String, there is no change
    //  notification here.

    index = anIndex > 0 ? anIndex : this.normalizeIndex(anIndex);

    //  basically slicing on both sides of the index and opening a hole for
    //  the new content the size of the content...effectively replacing one
    //  or more characters
    return this.slice(0, index) +
                        aValue +
                        this.slice(index + aValue.length);
});

//  ------------------------------------------------------------------------
//  METADATA SUPPORT FUNCTIONS
//  ------------------------------------------------------------------------

/**
 * @
 */

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getCustomTypeNames',
function() {

    /**
     * @method getCustomTypeNames
     * @summary Returns a list of all known custom (TIBET) types in the system,
     *     or available to it via dyna-loading. This list is typically populated
     *     by combining pre-existing metadata with runtime information to
     *     construct a complete list.
     * @returns {String[]} An array of the non-native type names.
     */

    return TP.keys(TP.sys.getMetadata('types'));
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getMethodIds',
function() {

    /**
     * @method getMethodIds
     * @summary Returns a list of all the methods available in the system or
     *     available to it via dyna-loading. Each method ID is a composite of
     *     the Type.Track.MethodName separated with periods. This information is
     *     used by both the canResolveDNU and method linting routines in TIBET.
     * @returns {String[]} An array of the unique method IDs.
     */

    return TP.keys(TP.sys.getMetadata('methods'));
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getMethodNames',
function() {

    /**
     * @method getMethodNames
     * @summary Returns a list of all the methods available in the system or
     *     available to it via dyna-loading. This list is typically populated by
     *     combining pre-existing metadata with runtime information to construct
     *     a complete picture of the methods which are available.
     * @param {Boolean} full True if full metadata is required for this call,
     *     meaning the external metadata cache should be loaded.
     * @returns {String[]} An array of the unique method names.
     */

    var methods,
        methodKeys,

        result,
        len,
        i;

    methods = TP.sys.getMetadata('methods');
    methodKeys = methods.getKeys();

    result = TP.ac();

    len = methodKeys.getSize();
    for (i = 0; i < len; i++) {
        //  NB: We use primitive property access here since 'methodObj' is
        //  property of a property descriptor
        result.push(methods.at(methodKeys.at(i))[TP.NAME]);
    }

    return result;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getMethodOwners',
function(aFunction, namesOnly) {

    /**
     * @method getMethodOwners
     * @summary Returns the list of method/function owners for the given
     *     function/fname. This information is tracked via metadata.
     * @param {Function|String} aFunction The function being tracked.
     * @param {Boolean} namesOnly True means return the list of owner names
     *     only. Default is false.
     * @returns {Object[]|undefined} An array of objects/types.
     */

    var fname,
        str,
        arr,
        len,
        i;

    //  need a function or string name
    if (TP.notValid(aFunction)) {
        return;
    }

    //  even if aFunction is a string this will work, string.getName is the
    //  string itself
    fname = aFunction.getName();

    str = TP.sys.getMetadata('owners').at(fname);
    if (TP.isEmpty(str)) {
        return TP.ac();
    }

    //  Split into an array of owner names.
    arr = str.split(TP.JOIN);

    if (TP.isTrue(namesOnly)) {
        return arr;
    }

    len = arr.getSize();
    for (i = 0; i < len; i++) {
        //  Gather owners, but only check for registered objects.
        arr[i] = TP.sys.getObjectById(arr[i], true);
    }

    //  remove nulls for those we didn't find/fault in
    arr.compact();

    return arr;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getMetadata',
function(kind) {

    /**
     * @method getMetadata
     * @summary Returns the TIBET metadata hash, a hash containing information
     *     on the types, methods, etc. in the current system and/or available to
     *     it via autoloading. This data isn't exhaustive, its primary goal is
     *     to support proxies and autoloading, not reflection. You can use
     *     reflection directly to get more information on a specific type or
     *     object.
     * @param {String} kind The subset of metadata to return. Should be one of
     *     'types', 'attributes', 'methods', 'owners', or 'pathinfo'.
     * @returns {TP.core.Hash} The TIBET metadata hash.
     */

    switch (kind) {
        case 'types':
            return TP.sys.$$meta_types;
        case 'attributes':
        case TP.ATTRIBUTE:
            return TP.sys.$$meta_attributes;
        case 'methods':
        case TP.METHOD:
            return TP.sys.$$meta_methods;
        case 'namespaces':
        case TP.NAMESPACE:
            return TP.sys.$$meta_namespaces;
        case 'owners':
            return TP.sys.$$meta_owners;
        case 'pathinfo':
            return TP.sys.$$meta_pathinfo;
        default:
            return TP.sys.$$metadata;
    }
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getNamespaceNames',
function() {

    /**
     * @method getNamespaceNames
     * @summary Returns a list of all of the namespaces available in the system.
     * @returns {String[]} An array of the namespace names.
     */

    return TP.keys(TP.sys.getMetadata('namespaces'));
});

//  ------------------------------------------------------------------------
//  SOURCE GENERATION
//  ------------------------------------------------------------------------

/*
There are numerous places where TIBET takes advantage of JavaScript's
ability to dynamically evaluate code. The construct() methods are the first
of these so we get some support routines for this capability in place early.
*/

//  ------------------------------------------------------------------------

TP.sys.defineMethod('$buildArgString',
function(startIndex, endIndex, arrayPrefix) {

    /**
     * @method $buildArgString
     * @summary Constructs and returns a string representation of the arguments
     *     array found in the standard 'arguments' array. This is used in
     *     locations where the arguments array needs to be eval'd as part of a
     *     larger operation. The arguments found between start and start + end
     *     are used.
     * @param {Number} startIndex The initial index to work from.
     * @param {Number} endIndex The final index.
     * @param {String} arrayPrefix Name of the array to reference.
     * @returns {String}
     */

    var start,
        end,

        prefix,
        arr,

        i;

    //  typically will start with 0, but can be built for oter indexes
    start = TP.ifInvalid(startIndex, 0);
    end = TP.ifInvalid(endIndex, 0);

    //  typically working on the arguments object, but in some cases we'll
    //  be working with an array built from that object instead. the
    //  canonical name for that parameter is anArgArray but it's always
    //  passed in rather than presumed
    prefix = TP.ifInvalid(arrayPrefix, 'arguments');

    arr = TP.ac();

    for (i = start; i <= end; i++) {
        arr.push(TP.join(prefix, '[', i, ']'));
    }

    return arr.join(', ');
});

//  ------------------------------------------------------------------------
//  NATIVE TYPES - CONSTRUCTION
//  ------------------------------------------------------------------------

/**
 * @A significant amount of TIBET's power comes from controlling the object
 *     creation process so we start that as early as possible.
 */

//  ------------------------------------------------------------------------

Array.Type.defineMethod('construct',
function() {

    /**
     * @method construct
     * @summary Constructs and returns a new array instance.
     * @description The arguments provided are treated as elements of the array
     *     with three exceptions. When an arguments object, node list, or named
     *     node map is passed as the single argument to this call the new
     *     instance's data is the result of converting those objects into native
     *     array form rather than an array with a single object in it. Also note
     *     that Array.construct (and TP.ac()) do not follow the JavaScript
     *     convention of accepting a single argument Number and treating it as a
     *     size.
     * @returns {Array} A new instance.
     */

    var arg,
        arr,

        i;

    //  NB: The approaches shown here to copy an existing supplied Array (or
    //  arguments object, or NodeList/NamedNodeMap) have been proven to be up to
    //  3X faster than trying to use Array.slice or ECMA6 constructs.

    switch (arguments.length) {
        case 0:
            return [];
        case 1:
            //  Flatten argument lists, node lists and named node maps.
            arg = arguments[0];
            if (TP.isArgArray(arg) ||
                TP.isNodeList(arg) ||
                TP.isNamedNodeMap(arg)) {
                i = arg.length;
                arr = new Array(i);
                while (i--) {
                    arr[i] = arg[i];
                }
                return arr;
            }
            arr = [];
            arr.push(arg);
            return arr;
        default:
            i = arguments.length;
            arr = new Array(i);
            while (i--) {
                arr[i] = arguments[i];
            }
            return arr;
    }
});

//  ------------------------------------------------------------------------

//  alias
TP.defineMethodAlias(TP, 'ac', Array.construct);

//  ------------------------------------------------------------------------

Boolean.Type.defineMethod('construct',
function(anObject) {

    /**
     * @method construct
     * @summary Constructs and returns a new instance of Boolean. Booleans are
     *     localized by using the current locale's parse routine to help ensure
     *     proper translation of Boolean string input.
     * @description Note that this method, being on a type that produces
     *     non-mutable instances, will always return its primitive value.
     * @param {Object} anObject An optional object to return in Boolean form.
     * @returns {Boolean} A new instance.
     */

    var val,
        kallee;

    kallee = Boolean.construct;

    if (anObject === true || anObject === false) {
        return anObject;
    }

    //  if we've got a string and a full kernel we can try to localize
    if (TP.isString(anObject) && TP.sys.hasKernel()) {
        //  any 'construct' that calls a 'from' needs a recursion trap
        if (TP.notTrue(kallee.$$onStack)) {
            kallee.$$onStack = true;
            val = Boolean.fromString(anObject);
            kallee.$$onStack = false;

            return val.valueOf();
        } else {
            kallee.$$onStack = false;
        }
    }

    //  only one possible argument for a Boolean
    return new Boolean(anObject).valueOf();
});

//  ------------------------------------------------------------------------

//  alias
TP.defineMethodAlias(TP, 'bc', Boolean.construct);

//  ------------------------------------------------------------------------

Date.Type.defineMethod('construct',
function() {

    /**
     * @method construct
     * @summary Constructs and returns a new instance of Date. Dates are parsed
     *     using any date parsers which have been added to the Date type,
     *     followed by the current TP.i18n.Locale which attempts to construct a
     *     Date using localized parsing logic.
     * @description Date parsing is a key element of usability. TIBET's approach
     *     is to attempt to use the standard Date constructor, followed by the
     *     Date.fromString() method when the input is a string. The fromString
     *     method looks for any parsers which may have been registered via prior
     *     Date.addParser() calls. If those parsers are unsuccessful the current
     *     TP.i18n.Locale is invoked to parse the input string in an attempt to
     *     offer locale-specific Date construction.
     * @returns {Date} A new instance.
     */

    var $$newinst,
        kallee;

    kallee = Date.construct;

    //  we start by using the built-in constructor for any arguments so
    //  behavior is consistent with native JS, and then we try parsing on
    //  our own
    switch (arguments.length) {
        case 0:
            $$newinst = new Date();
            break;
        case 1:
            $$newinst = new Date(arguments[0]);
            break;
        case 2:
            $$newinst = new Date(arguments[0], arguments[1]);
            break;
        case 3:
            $$newinst = new Date(arguments[0], arguments[1],
                arguments[2]);
            break;
        case 4:
            $$newinst = new Date(arguments[0], arguments[1],
                arguments[2], arguments[3]);
            break;
        case 5:
            $$newinst = new Date(arguments[0], arguments[1],
                arguments[2], arguments[3], arguments[4]);
            break;
        case 6:
            $$newinst = new Date(arguments[0], arguments[1],
                arguments[2], arguments[3], arguments[4], arguments[5]);
            break;
        case 7:
            $$newinst = new Date(arguments[0], arguments[1],
                arguments[2], arguments[3], arguments[4], arguments[5],
                arguments[6]);
            break;
        default:
            break;
    }

    //  have to watch out for "valid" data that's really saying the Date
    //  parameters didn't produce a valid date.
    if (TP.notValid($$newinst) ||
            $$newinst.toString() === 'Invalid Date' || //  mozilla
            $$newinst.toString() === 'NaN') {            //  IE
        //  any 'construct' that calls a 'from' needs a recursion trap
        if (TP.notTrue(kallee.$$onStack)) {
            kallee.$$onStack = true;
            $$newinst = Date.fromString(arguments[0]);
            kallee.$$onStack = false;

            return $$newinst;
        } else {
            kallee.$$onStack = false;
        }
    }

    return $$newinst;
});

//  ------------------------------------------------------------------------

//  alias
TP.defineMethodAlias(TP, 'dc', Date.construct);

//  ------------------------------------------------------------------------

Function.Type.defineMethod('construct',
function() {

    /**
     * @method construct
     * @summary Constructs and returns a new instance of the receiver.
     * @returns {Function} A new instance.
     */

    var $$newinst,
        msg;

    try {
        switch (arguments.length) {
            case 0:
                $$newinst = new Function();
                break;
            case 1:
                $$newinst = new Function(arguments[0]);
                break;
            case 2:
                $$newinst = new Function(arguments[0], arguments[1]);
                break;
            case 3:
                $$newinst = new Function(arguments[0], arguments[1],
                    arguments[2]);
                break;
            case 4:
                $$newinst = new Function(arguments[0], arguments[1],
                    arguments[2], arguments[3]);
                break;
            case 5:
                $$newinst = new Function(arguments[0], arguments[1],
                    arguments[2], arguments[3], arguments[4]);
                break;
            case 6:
                $$newinst = new Function(arguments[0], arguments[1],
                    arguments[2], arguments[3], arguments[4], arguments[5]);
                break;
            case 7:
                $$newinst = new Function(arguments[0], arguments[1],
                    arguments[2], arguments[3], arguments[4], arguments[5],
                    arguments[6]);
                break;
            case 8:
                $$newinst = new Function(arguments[0], arguments[1],
                    arguments[2], arguments[3], arguments[4], arguments[5],
                    arguments[6], arguments[7]);
                break;
            case 9:
                $$newinst = new Function(arguments[0], arguments[1],
                    arguments[2], arguments[3], arguments[4], arguments[5],
                    arguments[6], arguments[7], arguments[8]);
                break;
            default:
                break;
        }
    } catch (e) {
        msg = TP.join('Error creating function: ',
                    TP.args(arguments).join(' :: '));

        TP.ifError() ? TP.error(TP.ec(e, msg)) : 0;

        return null;
    }

    return $$newinst;
});

//  ------------------------------------------------------------------------

//  alias
TP.defineMethodAlias(TP, 'fc', Function.construct);

//  ------------------------------------------------------------------------

Number.Type.defineMethod('construct',
function(anObject) {

    /**
     * @method construct
     * @summary Constructs and returns a new instance of Number. Numbers are
     *     parsed using any number parsers which have been added to the number
     *     type, followed by the current TP.i18n.Locale which attempts to
     *     construct a Number using localized parsing logic.
     * @description Number parsing is a key element of usability. TIBET's
     *     approach is to attempt to use the Number.fromString() method when the
     *     input is a string. The fromString method looks for any parsers which
     *     may have been registered via addParser. If those parsers are
     *     unsuccessful the current TP.i18n.Locale is invoked to parse the input
     *     string in an attempt to offer locale-specific Number construction.
     *     Note that this method, being on a type that produces non-mutable
     *     instances, will always return its primitive value.
     * @param {Object} anObject An optional object to return in Number form.
     * @returns {Number} A new instance.
     */

    var val,
        kallee;

    kallee = Number.construct;

    //  if we've got a string and a full kernel we can try to localize
    if (TP.isString(anObject) && TP.sys.hasKernel()) {
        //  any 'construct' that calls a 'from' needs a recursion trap
        if (TP.notTrue(kallee.$$onStack)) {
            kallee.$$onStack = true;
            val = Number.fromString(anObject);
            kallee.$$onStack = false;

            return val.valueOf();
        } else {
            kallee.$$onStack = false;
        }
    }

    //  number only takes one argument so we can invoke directly
    return new Number(anObject).valueOf();
});

//  ------------------------------------------------------------------------

//  alias
TP.defineMethodAlias(TP, 'nc', Number.construct);

//  ------------------------------------------------------------------------

Object.Type.defineMethod('construct',
function() {

    /**
     * @method construct
     * @description Constructs and returns a new instance of the receiver.
     *     Arguments are treated as alternating keys and values to match the
     *     semantics of the standard call, but not quite the same syntax (a, b,
     *     c, d rather than a: b, c: d). NOTE that in TIBET it is deprecated to
     *     use an object as a hash for a number of reasons. If you truly want a
     *     "dictionary" (i.e. "hash") you should use TP.hc() instead.
     * @returns {Object} A new instance.
     */

    var i,
        newinst;

    newinst = new Object();

    //  do the key/value pair thing for all even pairs, any dangling key
    //  gets a null as a value.
    for (i = 0; i < arguments.length; i = i + 2) {
        //  NOTE:   by putting this inside a test we will not replace
        //          existing properties -- either attributes or methods.
        if (!TP.isProperty(newinst, arguments[i])) {
            newinst[arguments[i]] =
                    TP.notDefined(arguments[i + 1]) ? null : arguments[i + 1];
        } else {
            //  TP.raise(newinst, 'TP.sig.DuplicateKey',
            //              arguments[i]);
            void 0;
        }
    }

    return newinst;
});

//  ------------------------------------------------------------------------

RegExp.Type.defineMethod('construct',
function(pattern, flags, silent) {

    /**
     * @method construct
     * @summary Constructs and returns a new instance of the receiver.
     * @param {String} pattern The regular expression pattern.
     * @param {String} flags A concatenated set of flags to control the RegExp
     *     object. These are:
     *     'g' match globally
     *     'i' ignore case
     *     'm' match over multiple lines.
     *     'y' whether the regular expression search starts from its lastIndex
     * @param {Boolean} [silent=false] True to turn off error logging for bad
     *     regular expression source text.
     * @returns {RegExp} A new instance.
     */

    var parts,
        restr,
        attrs,
        tail,
        newinst,
        msg;

    if (TP.isRegExp(pattern)) {
        return pattern;
    }

    parts = TP.stringRegExpComponents(pattern);
    if (TP.isEmpty(parts)) {
        if (TP.notTrue(silent)) {
            msg = TP.join('Error creating regex: ', pattern);
            TP.ifError() ? TP.error(msg) : 0;
        }

        return null;
    }

    restr = TP.ifInvalid(parts.first(), '');
    attrs = TP.ifInvalid(flags, '');
    tail = parts.last();
    attrs += tail;

    //  Don't duplicate flags or we get no regex back :(.
    attrs = attrs.split('').unique().join('');

    try {
        newinst = new RegExp(restr, attrs);
    } catch (e) {
        if (TP.notTrue(silent)) {
            msg = TP.join('Error creating regex: ', restr);
            TP.ifError() ? TP.error(TP.ec(e, msg)) : 0;
        }

        return null;
    }

    return newinst;
});

//  ------------------------------------------------------------------------

//  alias
TP.defineMethodAlias(TP, 'rc', RegExp.construct);

//  ------------------------------------------------------------------------

TP.definePrimitive('$sc', TP.sc);

//  ------------------------------------------------------------------------

String.Type.defineMethod('construct',
function(varargs) {

    /**
     * @method construct
     * @summary Constructs and returns a new instance of String from the
     *     arguments supplied. This routine localizes each argument.
     * @description Note that this method, being on a type that produces
     *     non-mutable instances, will always return its primitive value.
     * @param {arguments} varargs A variable list of 0 to N values to build the
     *     String from.
     * @returns {String} A new instance.
     */

    var locale,
        result,
        arr,
        len,
        i;

    //  Use the original primitive version that leverages TP.msg lookup if we
    //  haven't loaded enough kernel to have locale support.
    if (!TP.sys.hasKernel()) {
        return TP.$sc.apply(TP, arguments);
    }

    locale = TP.sys.getLocale();

    switch (arguments.length) {
        case 0:
            return '';
        case 1:
            return locale.localizeString('' + varargs);
        default:
            result = TP.ac();
            arr = TP.ac(arguments);

            len = arr.getSize();
            for (i = 0; i < len; i++) {
                result.push(locale.localizeString('' + arr[i]));
            }

            return result.join('');
    }
});

//  ------------------------------------------------------------------------

//  alias
TP.defineMethodAlias(TP, 'sc', String.construct);

//  ------------------------------------------------------------------------
//  NATIVE TYPES - MEMBERSHIP
//  ------------------------------------------------------------------------

/*
The methods here allow instances of native types to return true very quickly
from certain TP.isKindOf()/TP.isMemberOf() queries.
*/

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('$$isMemberOf',
function(aType) {

    /**
     * @method $$isMemberOf
     * @summary Returns true if the receiver is a direct member (instance) of
     *     the named type.
     * @param {TP.lang.RootObject|String} aType A Type object, or type name.
     * @returns {Boolean} Whether or not the receiver is a direct member of the
     *     supplied type.
     */

    if (aType === Array || aType === 'Array') {
        return true;
    }
});

//  ------------------------------------------------------------------------

Boolean.Inst.defineMethod('$$isMemberOf',
function(aType) {

    /**
     * @method $$isMemberOf
     * @summary Returns true if the receiver is a direct member (instance) of
     *     the named type.
     * @param {TP.lang.RootObject|String} aType A Type object, or type name.
     * @returns {Boolean} Whether or not the receiver is a direct member of the
     *     supplied type.
     */

    if (aType === Boolean || aType === 'Boolean') {
        return true;
    }
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('$$isMemberOf',
function(aType) {

    /**
     * @method $$isMemberOf
     * @summary Returns true if the receiver is a direct member (instance) of
     *     the named type.
     * @param {TP.lang.RootObject|String} aType A Type object, or type name.
     * @returns {Boolean} Whether or not the receiver is a direct member of the
     *     supplied type.
     */

    if (aType === Date || aType === 'Date') {
        return true;
    }
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('$$isMemberOf',
function(aType) {

    /**
     * @method $$isMemberOf
     * @summary Returns true if the receiver is a direct member (instance) of
     *     the named type.
     * @param {TP.lang.RootObject|String} aType A Type object, or type name.
     * @returns {Boolean} Whether or not the receiver is a direct member of the
     *     supplied type.
     */

    if (aType === Function || aType === 'Function') {
        return true;
    }
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('$$isMemberOf',
function(aType) {

    /**
     * @method $$isMemberOf
     * @summary Returns true if the receiver is a direct member (instance) of
     *     the named type.
     * @param {TP.lang.RootObject|String} aType A Type object, or type name.
     * @returns {Boolean} Whether or not the receiver is a direct member of the
     *     supplied type.
     */

    if (aType === Number || aType === 'Number') {
        return true;
    }
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('$$isMemberOf',
function(aType) {

    /**
     * @method $$isMemberOf
     * @summary Returns true if the receiver is a direct member (instance) of
     *     the named type.
     * @param {TP.lang.RootObject|String} aType A Type object, or type name.
     * @returns {Boolean} Whether or not the receiver is a direct member of the
     *     supplied type.
     */

    //  The problem here is that, according to JS, *all* objects can use
    //  this method (including objects that have TP* types as their type).
    //  Since this is restricted to 'is member of', we need to check their
    //  type object against 'Object' directly.

    if (TP.isString(aType)) {
        return this.getTypeName() === TP.name(aType);
    }

    return this.getType() === aType;
});

//  ------------------------------------------------------------------------

RegExp.Inst.defineMethod('$$isMemberOf',
function(aType) {

    /**
     * @method $$isMemberOf
     * @summary Returns true if the receiver is a direct member (instance) of
     *     the named type.
     * @param {TP.lang.RootObject|String} aType A Type object, or type name.
     * @returns {Boolean} Whether or not the receiver is a direct member of the
     *     supplied type.
     */

    if (aType === RegExp || aType === 'RegExp') {
        return true;
    }
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('$$isMemberOf',
function(aType) {

    /**
     * @method $$isMemberOf
     * @summary Returns true if the receiver is a direct member (instance) of
     *     the named type.
     * @param {TP.lang.RootObject|String} aType A Type object, or type name.
     * @returns {Boolean} Whether or not the receiver is a direct member of the
     *     supplied type.
     */

    if (aType === String || aType === 'String') {
        return true;
    }
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETRegistration.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
Supports general purpose object acquisition by ID including support for
registration of objects under a public identifier independent of their
internal OID. This multi-layer registration allows common public names to
be used across frames as individual pages come and go along with their
underlying objects.
*/

//  ------------------------------------------------------------------------
//  OBJECT REGISTRATION
//  ------------------------------------------------------------------------

/*
To avoid certain problems with garbage collection it's often desirable to
store object references in string form rather than as true references. This
is essentially how the DOM works. You have an ID string to some FORM
element and the DOM gives you back that element when you ask. TIBET allows
the same operation to occur for regular objects. Of course, until we get
weak references in JavaScript our version will cause GC issues and will
leak slowly if you don't clean up after yourself. It's provided mainly for
two purposes. First, it helps with certain long-lived objects across frames
and second it's a great way to help with debugging cycles. Be careful with
it though since it can create leaks if you don't clean up after yourself
over time.
*/

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getObjectById',
function(anID, regOnly, nodeContext) {

    /**
     * @method getObjectById
     * @summary Returns a reference to the object with the ID provided. The
     *     'id' in this method can be anything from a uri to a typename, from a
     *     generated ID to an "access path". Logic within this routine and the
     *     various URI types is used to do most of the traversal when the ID
     *     appears to be a path.
     * @summary This is a core method for TIBET which is used to locate
     *     elements, event handlers, and other objects in a variety of cases.
     *     It's a fairly complex method since it tries to make the lookup
     *     process thorough, but as quick as possible. The search starts with
     *     registrations via registerObject so you can always "override" the
     *     remaining lookup process by simply registering an object to speed up
     *     the lookup. Type names are the next choice since finding a type is a
     *     very common operation (although it's even faster to simply call
     *     TP.sys.getTypeByName()). URI resolution is another component of this
     *     method, if the ID forms a proper URI, however the actual object
     *     location logic in that case is often found in the getResource method
     *     of the specific URI subtype.
     * @param {String} anID The id to look up.
     * @param {Boolean} regOnly Should lookup stop with registered objects?
     * @param {Window|Node} nodeContext An optional window or node specification
     *     to use for resolution when no other reference is found. Default is
     *     the current canvas.
     * @returns {Object|undefined} Typically a TIBET object (meaning nodes are
     *     wrapped in TP.dom.Node instances etc) to maintain encapsulation for as
     *     long as possible.
     */

    var bits,
        oref,
        idot,
        win,
        resp,
        inst,
        parts,
        url,
        id,
        winid,
        key,
        index,
        type,
        reg,
        obj,
        context;

    //  Common namespaces should be easy :)
    if (anID === 'TP') {
        return TP;
    } else if (anID === 'APP') {
        return APP;
    }

    //  make sure it's something we can manipulate
    if (TP.isEmpty(anID)) {
        return;
    }

    //  map to local var for IE since we may change the value and IE
    //  doesn't like it when you try to alter a non-null parameter value
    id = TP.str(anID);

    //  If the ID starts with a TIBET URN scheme and it has a real resource
    //  result object, then return that. Note here how we use 'getInstanceById'
    //  on the TP.uri.URI type rather than 'TP.uc()' - that call will always
    //  create an instance *and register it* if it doesn't exist.
    if (TP.regex.TIBET_URN.test(id)) {
        if (TP.isURI(url = TP.uri.URI.getInstanceById(id))) {

            //  NB: This is a URN so we assume 'async' of false here.
            if (TP.isValid(inst = url.getResource().get('result'))) {
                return inst;
            }
        }
    }

    //  Try to make a TIBET URN from the ID and, if it has a real resource
    //  result object, then return that. Note here how we use 'getInstanceById'
    //  on the TP.uri.URI type rather than 'TP.uc' - that call will always
    //  create an instance *and register it* if it doesn't exist.
    if (TP.isURI(url = TP.uri.URI.getInstanceById(TP.TIBET_URN_PREFIX + id))) {

        //  NB: This is a URN so we assume 'async' of false here.
        if (TP.isValid(inst = url.getResource().get('result'))) {
            return inst;
        }
    }

    //  if we're not told differently don't stop with registered objects
    reg = TP.notValid(regOnly) ? false : regOnly;

    //  Check for type names as our second priority. Note the flag here is
    //  controlled by whether we're checking registrations only. What that's
    //  implying in this case is that we'll only return the type if it's already
    //  loaded when we're asked to stop with registration checks only
    //  (reg = true means fault = false)
    if (TP.regex.VALID_TYPENAME.test(id)) {
        if (TP.isValid(inst = TP.sys.getTypeByName(id, !reg))) {
            return inst;
        } else {
            context = TP.sys.getLaunchWindow();

            parts = id.split('.');

            obj = context[parts.at(0)];
            parts.shift();

            while (TP.isValid(obj) && parts.length) {
                key = parts.shift();

                if (key === 'Inst' &&
                        TP.canInvoke(obj, 'getInstPrototype')) {
                    obj = obj.getInstPrototype();
                    continue;
                } else if (key === 'Type' &&
                                TP.canInvoke(obj, 'getPrototype')) {
                    obj = obj.getPrototype();
                    continue;
                }

                if (TP.isValid(obj[key])) {
                    obj = obj[key];
                } else if (TP.canInvoke(obj, 'get')) {
                    obj = obj.get(key);
                } else {
                    obj = void 0;
                }
            }

            //  Re-split the id so that we can get the first part to do the test
            //  below
            parts = id.split('.');

            //  If the first part points to a 'special Window property' that is
            //  *not* a Window reference itself (i.e. an iframe Window), then we
            //  don't resolve it but just return undefined.
            if (TP.sys.$windowglobals.hasKey(parts.at(0)) &&
                !TP.isWindow(obj)) {
                return;
            }

            if (TP.isValid(obj)) {
                return TP.wrap(obj);
            }
        }
    }

    //  Maybe a namespace name, e.g. something like 'css:' or any other prefix
    //  we'd normally associate with a namespace object
    if (TP.regex.VALID_NAMESPACENAME.test(id)) {
        parts = TP.regex.VALID_NAMESPACENAME.match(id);
        obj = TP.global[parts.at(1)][parts.at(2)];
        if (TP.isValid(obj) && TP.isNamespace(obj)) {
            return obj;
        } else {
            TP.ifWarn() ?
                TP.warn('Unable to resolve apparent namespace reference: ' +
                            id) : 0;

            return;
        }
    }

    //  Note that we check first to see if an Element has the ID (if a node
    //  context was supplied. If one was supplied, then we don't bother looking
    //  for windows. In fact, if the name we're looking for also matches a
    //  Window slot, and that points to a Window (i.e. 'content' in HTML5
    //  Window objects), that value will be returned and we don't want that..

    //  we'll also consider windows to be "registered" objects by
    //  id/name, but we filter with a regex so we don't waste time here
    if (TP.regex.VALID_WINDOWNAME.test(id)) {
        if (TP.isNode(nodeContext)) {
            inst = TP.nodeGetElementById(nodeContext, id);
        }
        if (TP.notValid(inst) && TP.isWindow(inst = TP.sys.getWindowById(id))) {
            return TP.tpwin(inst);
        }
    }

    //  if we were asked to stop with a registration-only check then stop.
    //  THIS IS CRITICAL, since some operations, particularly URI lookups,
    //  will check registrations before doing more work. If we don't honor
    //  this stop request recursions can occur.
    if (reg) {
        return;
    }

    //  common to search for elements in tibet://{canvas}/path#elem so try to
    //  resolve those cases.
    if (TP.regex.TIBET_URL_SPLITTER.test(id)) {
        parts = TP.regex.TIBET_URL_SPLITTER.match(id);
        inst = TP.sys.getWindowById(parts.at(3));
        if (TP.isWindow(inst)) {
            if (parts.at(4) === 'document') {
                return TP.tpdoc(inst.document);
            } else if (TP.notEmpty(parts.at(6))) {

                if (parts.at(6) === '#document') {
                    return TP.tpdoc(inst.document);
                }

                inst = TP.nodeGetElementById(inst.document,
                                                parts.at(6).slice(1));
                if (TP.isNode(inst)) {
                    return TP.tpnode(inst);
                }

                //  We're definitely a tibet:// URL, but we couldn't resolve to
                //  a Node of some sort. No sense in continuing - exit with
                //  null.
                return null;
            }
        }
    }

    //  anything that looks like a URI can be processed next since the test
    //  is pretty quick, and doing it now helps avoid confusion with later
    //  tests looking for dot-separated window/object paths
    if (id.indexOf('~') === 0 ||
        TP.regex.HAS_SCHEME.test(id) ||
        TP.regex.JS_SCHEME.test(id)) {

        //  If we're not looking at a barename we need to check for a URI-style
        //  ID and see if we can locate the data using a URI. Note that this may
        //  cause the URI to call back to this routine with portions of the URI
        //  string. Also note that we have an explicit forward slash here to
        //  avoid problems with references to namespace-qualified elements but
        //  we have to watch out for javascript uri entries
        if (TP.isURI(url = TP.uc(id))) {

            //  If there is no fragment, just return the url instance itself.
            if (!url.hasFragment()) {
                return url;
            }

            //  NOTE that this call means that URIs should be very careful not
            //  to re-invoke getObjectById without at least altering the actual
            //  ID being requested or we'll recurse
            resp = url.getResource(
                            TP.hc('async', false, 'resultType', TP.WRAP));
            inst = resp.get('result');

            if (TP.isNode(inst)) {
                //  try to force types to come in for creation
                if (TP.isType(type = TP.dom.Node.getConcreteType(inst))) {
                    return type.construct(inst);
                }
            } else if (TP.isWindow(inst)) {
                return TP.core.Window.construct(inst);
            } else if (TP.isValid(inst)) {
                return inst;
            }
        } else {
            //  problem. looks like a URI since there's a colon but no match
            //  on type name (they're registered and would have been found
            //  earlier) and no URI was able to be constructed
            TP.ifWarn() ?
                TP.warn('Unable to construct URI for object reference: ' +
                            id) : 0;

            return;
        }
    }

    //  also common to look for an ID in a window, so check that by looking
    //  for anything that includes a fragment identifier (#). these are
    //  somewhat common in handlers where a leading # is used to help ensure
    //  proper recognition of the reference as a barename/pointer
    if (TP.regex.ELEMENT_ID.test(id)) {

        //  likely window#id since it didn't look like a URI above
        parts = TP.regex.ELEMENT_ID.match(id);
        inst = TP.sys.getWindowById(parts.at(1));

        if (TP.isWindow(inst)) {
            if (parts.at(2) === 'document') {
                return TP.tpdoc(inst.document);
            } else {
                inst = TP.nodeGetElementById(inst.document, parts[2]);
                if (TP.isNode(inst)) {
                    return TP.tpnode(inst);
                }
            }
        }
    }

    //  if it wasn't a valid URI it may be some form of window reference or
    //  a reference for an element in a particular window
    if (TP.regex.HAS_PERIOD.test(id)) {
        //  sometimes we'll still have a leading # due to object naming
        if (id.indexOf('#') === 0) {
            //  if there were periods in the segment we assume a global ID
            //  and just take off the leading # (which is optional in that
            //  case anyway) and let it fall through to the ID acquisition
            id = id.slice(1);
        }

        //  first question is are we referring to a window and is it cached?
        if (TP.isWindow(win = TP.core.Window.getWindowInfo(id, 'tpWindow'))) {
            return win;
        }

        //  other option is that it might be a window we haven't wrapped yet
        //  so we'll do that check as well
        if (TP.isWindow(win = TP.sys.getWindowById(id))) {
            return TP.core.Window.construct(win);
        }

        //  not a window, but perhaps an element in one...
        idot = id.lastIndexOf('#');

        if (idot > -1) {
            winid = id.slice(0, idot);

            //  if we can't find a window with that ID then we're looking
            //  at an access path which we have to process more iteratively
            if (TP.notValid(win = TP.sys.getWindowById(winid))) {
                bits = id.split('.');
                index = 0;
                inst = TP.bySystemId(bits.at(index));

                while (TP.isValid(inst) && index < bits.getSize()) {
                    index++;
                    key = bits.at(index);

                    if (TP.canInvoke(inst, 'get')) {
                        inst = inst.get(key);
                    } else {
                        inst = inst[key];
                    }
                }

                if (TP.isValid(inst)) {
                    return inst;
                }
            } else {
                //  window was valid? then just use it and update ID to be a
                //  local ID in that window...
                id = id.slice(idot + 1);
            }
        }
    }

    //  event references will sometimes use # as a prefix for ids in
    //  which case they're referring to an ID in the current document.
    //  these are normally expanded into global IDs by the content
    //  pipeline but when they aren't we have to clean them up
    if (id.indexOf('#') === 0) {
        //  we'll need to trim off the leading # so we can do the lookup
        id = id.slice(1);
    }

    //  if we already were assigned a window reference because of earlier
    //  logic we'll stick with that one, otherwise we default to either the
    //  current canvas
    if (!TP.isWindow(win)) {
        win = TP.unwrap(nodeContext);
        if (!TP.isWindow(win)) {
            if (TP.isNode(nodeContext)) {
                win = TP.nodeGetWindow(nodeContext);
            } else {
                win = TP.ifInvalid(
                        TP.sys.getWindowById(TP.sys.getUICanvasName()),
                        window);
            }
        }
    }

    //  .document and .#document are often used to get document handles so
    //  check for that next to avoid lookup overhead below
    if (id === 'document') {
        return TP.dom.Document.construct(win.document);
    }

    //  not the document, perhaps an element in the document
    if (TP.isElement(inst = TP.nodeGetElementById(win.document, id))) {
        if (TP.isType(type = TP.dom.Node.getConcreteType(inst))) {
            return type.construct(inst);
        }
    } else {
        //  might be a window slot (even though that's nasty)
        try {
            if (TP.isValid(inst = win[oref])) {
                //  try to maintain wrappers
                if (TP.isWindow(inst)) {
                    return TP.core.Window.construct(inst);
                } else if (TP.isDocument(inst)) {
                    return TP.dom.Document.construct(inst);
                }

                return inst;
            }
        } catch (e) {
            TP.ifError() ?
                TP.error(TP.ec(e,
                    'Error accessing window slot at: ' + id + '. ')) : 0;
        }
    }

    //  seriously, at this point we should have found it. But amazingly we never
    //  bothered with the simplest thing that could possibly work...
    if (TP.regex.HAS_PERIOD.test(id)) {
        context = TP.sys.getLaunchWindow();
        parts = id.split('.');
        obj = context[parts[0]];
        parts.shift();
        while (TP.isValid(obj) && parts.length) {
            obj = TP.wrap(obj);
            key = parts.shift();
            if (TP.canInvoke(obj, 'get')) {
                obj = obj.get(key);
            } else {
                obj = obj[key];
            }
        }

        if (TP.isValid(obj)) {
            return TP.wrap(obj);
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('hasRegistered',
function(anObj, anID) {

    /**
     * @method hasRegistered
     * @summary Checks for the object in the public registry under its ID.
     * @param {Object} anObj The object to check on.
     * @param {String} anID An optional ID to use instead of the object's
     *     internal ID.
     * @returns {Boolean} Whether or not the object was registered.
     */

    var id,
        urnID;

    if (TP.isEmpty(id = anID)) {

        if (TP.canInvoke(anObj, 'getID')) {
            id = anObj.getID();
        }

        if (TP.isEmpty(id)) {
            return false;
        }
    }

    //  Note that in the checks below, we check with the TP.uri.URI *type*'s
    //  'instances' registry *before* the 'TP.uc' calls. 'TP.uc' will create
    //  a URI in the registry if one doesn't exist.

    //  If a TIBET URN can be made from the ID and it is registered with the URI
    //  type and it has a real resource result object, then return that.
    if (TP.regex.TIBET_URN.test(id) &&
        TP.uri.URI.instances.containsKey(id) &&
        TP.isValid(TP.uc(id).getResource().get('result'))) {

        return true;
    }

    urnID = TP.TIBET_URN_PREFIX + id;

    //  Try to make a TIBET URN from the urnID and, if it is registered with the
    //  URI type and it has a real resource result object, then return that.
    if (TP.regex.TIBET_URN.test(urnID) &&
        TP.uri.URI.instances.containsKey(urnID) &&
        TP.isValid(TP.uc(urnID).getResource().get('result'))) {

        return true;
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('registerObject',
function(anObj, anID, forceRegistration, observeResource) {

    /**
     * @method registerObject
     * @summary Places the object into the public registry under its ID.
     * @param {Object} anObj The object to register.
     * @param {String} anID An optional ID to use instead of the object's
     *     internal ID.
     * @param {Boolean} forceRegistration Whether or not to skip type-level
     *     checks and force the object to be registered. The default is false.
     * @param {Boolean} observeResource Whether or not the URI used to register
     *     the supplied object should observe it for changes. The default is
     *     true.
     * @returns {Boolean} Whether or not the object was new and went through the
     *     registration process.
     */

    var id,
        obj,

        anObjType,

        urn;

    if (TP.notValid(anObj)) {
        return false;
    }

    //  If the object is a type, then it can be found by using it's global name,
    //  either literally or via a URI or via the TP.sys.getTypeByName() call
    //  (which is what the TP.sys.getObjectById() call above uses).
    //  But go ahead and do the registration if caller is forcing it.
    if (TP.isType(anObj) && TP.notTrue(forceRegistration)) {
        return false;
    }

    //  A URI can be found directly by using the TP.uc call and its registry.
    //  But go ahead and do the registration if caller is forcing it.
    if (TP.isKindOf(anObj, TP.uri.URI) && TP.notTrue(forceRegistration)) {
        return false;
    }

    //  some object registrations (particularly those with IDs that are set
    //  as parameters here) can be forced regardless of the type's wishes
    if (TP.notTrue(forceRegistration)) {
        if (TP.canInvoke(anObj, 'getType') &&
            TP.isType(anObjType = anObj.getType()) &&
            TP.canInvoke(anObjType, 'shouldRegisterInstances')) {
            if (!anObjType.shouldRegisterInstances()) {
                return false;
            }
        }
    }

    if (!TP.canInvoke(anObj, 'getID')) {
        //  no way to get an ID? then the object itself is the key
        id = TP.ifInvalid(anID, anObj);
    } else {
        id = anID;
        if (TP.notValid(id)) {
            id = anObj.getID();
        }
    }

    //  If the ID is already a URI, then it can already be looked up without
    //  having to register it under a TIBET URN.
    if (TP.isURIString(id)) {
        return false;
    }

    if (TP.regex.TIBET_URN.test(id)) {
        TP.ifError() ?
            TP.error('Trying to register object whose ID is already a URN: ' +
                        id) : 0;

        return false;
    }

    urn = TP.uc(TP.TIBET_URN_PREFIX + id);

    //  Create a TIBET URN to store the object - make sure to pass along the
    //  'observeResource' flag (which we default to true if one wasn't supplied)
    urn.setResource(
        anObj,
        TP.hc('observeResource', TP.ifInvalid(observeResource, false),
            'signalChange', false));

    if (TP.isValid(obj)) {
        id.signal('TP.sig.IdentityChange');
    }

    return true;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('unregisterObject',
function(anObj, anID) {

    /**
     * @method unregisterObject
     * @summary Removes public registration for the object provided. This
     *     operation should be called RELIGIOUSLY to avoid memory leaks if
     *     objects are registered.
     * @param {Object} anObj The object to un-register.
     * @param {String} anID An optional ID to use instead of the object's
     *     internal ID.
     * @returns {Boolean} Whether or not the object was unregistered.
     */

    var id,
        urn;

    if (TP.isString(anID)) {
        id = anID;
    } else if (TP.isValid(anObj)) {
        id = anObj.getID();
    }

    //  NOTE that we don't create a URI here, we simply check to see if one has
    //  already been created that might need to be flushed.
    urn = TP.uri.URI.getInstanceById(TP.TIBET_URN_PREFIX + id);
    if (!TP.isURI(urn)) {
        return false;
    }

    //  NOTE: We must unregister() first!!! The clearCaches() call will release
    //  the URN's resource and set 'loaded' to false and we need both of those
    //  to do any ignore()ing of signals coming from the resource up into the
    //  URN.
    urn.unregister();

    //  Now it's safe to clear the caches.
    urn.clearCaches();

    //  fail quietly
    return true;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETFoundation.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
Before inheritance, inferencing, and signaling can be fully implemented there
are a number of elements which are needed to provide a solid foundation. Those
include additional reflection, iteration, type checking, encapsulation, and
more. This file provides the foundational elements leading up to the
construction of the TIBET metaobject/inheritance system and the rest of the
TIBET platform.
*/

//  ------------------------------------------------------------------------
//  GLOBAL DISCOVERY
//  ------------------------------------------------------------------------

TP.sys.defineMethod('$getContextGlobals',
function(params, windowContext) {

    /**
     * @method $getContextGlobals
     * @summary Returns an Array of global property names.
     * @description Computing this list is done by iterating over the context
     *     object provided and filtering the resulting keys against known window
     *     slots and "exclusions" that don't represent global functionality. In
     *     other words, a property on a window that's truly a property of a
     *     Window isn't returned by this search, but a function on Window
     *     intended as a Global function would be.
     * @param {TP.core.Hash} params A hash of various parameters that will
     *     affect the return value in the following way: 'internal' Return
     *     global slots that are internal - that is, they start with '$$'
     *     'hidden' Return global slots that are internal - that is, they start
     *     with '$$' or '$'. 'public' Return global slots that are not internal
     *     - that is, they do not start with '$$' or '$'. 'types' Return global
     *     slots that are TIBET types. 'functions' Return global slots that are
     *     functions. 'variables' Return global slots that are not functions.
     * @param {Window} windowContext The window/frame whose globals should be
     *     returned. Default is the current window.
     * @returns {String[]} The list of Strings representing keys on the
     *     JavaScript global object.
     */

    var arr,
        context,
        internalSlot,
        hiddenSlot,
        publicSlot,
        types,
        functions,
        variables,
        key;

    arr = TP.ac();
    context = windowContext || TP.global;

    if (TP.isValid(params)) {
        //  The default is to return public functions and attributes
        internalSlot = params.atIfInvalid('internal', false);
        hiddenSlot = params.atIfInvalid('hidden', false);
        publicSlot = params.atIfInvalid('public', true);
        types = params.atIfInvalid('types', false);
        functions = params.atIfInvalid('functions', true);
        variables = params.atIfInvalid('variables', true);
    } else {
        //  The default is to return public functions and attributes
        internalSlot = false;
        hiddenSlot = false;
        publicSlot = true;
        types = false;
        functions = true;
        variables = true;
    }

    /* eslint-disable guard-for-in */
    for (key in context) {
        try {
            //  true globals (window slots, etc. aren't included)
            if (TP.sys.$globalexcludes.contains(key) ||
                TP.sys.$windowglobals.contains(key)) {
                continue;
            }

            //  we never return DNUs
            if (TP.$$isDNU(context[key])) {
                continue;
            }

            //  we never return 'windows' (i.e. frames on the window)
            if (TP.isWindow(context[key])) {
                continue;
            }

            //  If internalSlot is false and the key starts with '$$', skip it.
            if (!internalSlot && TP.regex.INTERNAL_SLOT.test(key)) {
                continue;
            }

            //  If hiddenSlot is false and the key starts with a '$' followed by
            //  any character except a '$', skip it.
            if (!hiddenSlot && TP.regex.PRIVATE_SLOT.test(key)) {
                continue;
            }

            //  If publicSlot is false and the key starts with a '$' (whether it
            //  is then followed by another '$' is irrelevant), skip it.
            if (!publicSlot && /^\$/.test(key)) {
                continue;
            }

            //  If types is false and the slot with the key is either a type or
            //  type proxy, skip it.
            if (!types &&
                (TP.isType(context[key]) || TP.$$isTypeProxy(context[key]))) {
                continue;
            }

            //  If functions is false and the slot with the key is a Function,
            //  skip it.
            if (!functions && TP.isFunction(context[key])) {
                continue;
            }

            //  If variables is false and the slot with the key is not a
            //  function, not a type and not a type proxy, then its a variable,
            //  so skip it.
            if (!variables &&
                    (!TP.isFunction(context[key]) &&
                    !TP.isType(context[key]) &&
                    !TP.$$isTypeProxy(context[key]))) {
                continue;
            }

            //  Passed all of our tests, so add it.
            arr.push(key);
        } catch (e) {
            void 0;
        }
    }
    /* eslint-enable guard-for-in */

    return arr;
});

//  ------------------------------------------------------------------------
//  TIBET - TYPE DICTIONARIES
//  ------------------------------------------------------------------------

//  the missing type hash. we hold the types missing from TIBET's type
//  system here
TP.sys.$missingTypes = TP.sys.$missingTypes || TP.hc();

//  Right now its a primitive hash
TP.sys.$missingTypes.$isHash =
    TP.ifInvalid(TP.sys.$missingTypes.$isHash, false);

//  ------------------------------------------------------------------------

TP.sys.defineMethod('addCustomType',
function(typeName, customType) {

    /**
     * @method addCustomType
     * @summary Adds the named custom type to the global type hash.
     * @param {String} typeName The key under which to store the type.
     * @param {Object} customType The type to store.
     * @returns {Object} The receiver.
     */

    //  Note that we use a primitive hash here since that way all of the
    //  metadata is stored using the same kind of data structure (and also to
    //  avoid booting problems when TP.core.Hash is only 'half loaded')

    TP.sys.getMetadata('types').atPut(typeName, customType);

    return this;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getCustomTypes',
function() {

    /**
     * @method getCustomTypes
     * @summary Returns an object containing the names and type objects for all
     *     custom types in the system.
     *
     *     NOTE: this object is considered private. You should not manipulate
     *     this object directly.
     * @returns {Object} An object containing the name and type objects for all
     *     custom types.
     */

    var types,
        typeKeys,

        result,
        len,
        i;

    types = TP.sys.getMetadata('types');
    typeKeys = types.getKeys();

    result = TP.hc();

    len = typeKeys.getSize();
    for (i = 0; i < len; i++) {
        //  NB: We use primitive property access here.
        result.atPut(typeKeys.at(i), types.at(typeKeys.at(i)));
    }

    return result;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getMissingTypes',
function() {

    /**
     * @method getMissingTypes
     * @summary Returns a hash whose keys represent type names that TIBET was
     *     asked for (typically via require) which do not exist. Common cases
     *     are node wrappers for unknown XML tags and signal names for
     *     fabricated signals.
     * @returns {Object} An object containing the name and type objects for all
     *     custom types.
     */

    //  convert to a full hash as soon as possible
    if (TP.isFalse(this.$missingTypes.$isHash) &&
        TP.isType(TP.sys.getTypeByName('TP.core.Hash'))) {
        this.$missingTypes = this.$missingTypes.asTP_core_Hash();
        this.$missingTypes.$isHash = true;
    }

    return this.$missingTypes;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getTypeByName',
function(aName, shouldFault) {

    /**
     * @method getTypeByName
     * @summary Returns a handle to the type with the name provided. If the
     *     type isn't found this method returns undefined. This method is used
     *     extensively to assist with dynamic loading of types.
     * @param {String} aName The name of the type to locate.
     * @param {Boolean} shouldFault False to turn off testing and conversion of
     *     TP.lang.Proxy instances. This is considered a private parameter used
     *     by the kernel only.
     * @returns {TP.lang.RootObject|undefined} The type object registered under
     *     the name given.
     */

    var type,
        tName,
        entry,

        typeMetadata;

    //  make sure it's a real type name...we often get called with instance
    //  IDs because of signaling etc.
    if (!TP.isTypeName(aName)) {
        if (TP.isType(aName)) {
            return aName;
        }
        return;
    }

    if (TP.isString(aName)) {
        tName = aName;

        //  Namespaces end with a colon (:) as in ev: or xmpp:.
        if (tName[tName.length - 1] === ':') {
            tName += 'XMLNS';
        }

        //  If there are ':' (colon) chars we need to replace with '.' (period).
        if (TP.regex.HAS_COLON.test(tName)) {
            tName = tName.replace(/:/g, '.');
        }

        typeMetadata = TP.sys.getMetadata('types');

        //  NB: We use primitive property access here since 'typeObj' is
        //  property of a property descriptor

        if (TP.regex.META_TYPENAME.test(tName)) {
            tName = tName.replace(/\.meta\./, '.');
            if (TP.isValid(entry = typeMetadata.at(tName))) {
                type = entry; // .typeObj;
            }

            if (TP.isType(type)) {
                return type.getType();
            } else {
                return;
            }
        }

        if (!TP.regex.TP_TYPENAME.test(tName) &&
            !TP.regex.APP_TYPENAME.test(tName)) {
            //  Type name has no prefix. We'll have to check both.
            if (TP.isValid(entry = typeMetadata.at('TP.' + tName))) {
                type = entry; // .typeObj;
            }

            if (!type) {
                if (TP.isValid(entry = typeMetadata.at('APP.' + tName))) {
                    type = entry; // .typeObj;
                }
            }
        } else {
            if (TP.isValid(entry = typeMetadata.at(tName))) {
                type = entry; // .typeObj;
            }
        }

        if (TP.notValid(type)) {
            type = TP.sys.getNativeTypes().at(tName);
            if (TP.isValid(type)) {
                return type;
            }
        }
    } else {
        type = aName;
    }

    //  if fault flag is off and this is a proxy then return as if we've
    //  never seen it. this is typically only called by the proxy type
    //  itself during proxy construction to avoid recursive behavior
    if (TP.$$isTypeProxy(type) && type !== TP.lang.Proxy) {

        //  Note the explicit check for false... undefined here would allow the
        //  method's default value of this parameter to true.
        if (TP.isFalse(shouldFault)) {
            return;
        }

        type = type.$$fault();
    }

    return type;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getTypes',
function() {

    /**
     * @method getTypes
     * @summary Returns a hash containing the names and type objects which have
     *     actual implementations in the current environment. This is a
     *     combination of custom types and those native types which have true
     *     type object implementations.
     * @returns {TP.core.Hash} A hash of types, keyed by name, that have actual
     *     implementations.
     */

    var dict;

    dict = TP.hc();
    dict.addAll(this.getNativeTypes());

    dict.perform(
        function(item) {

            if (TP.notValid(item.last())) {
                dict.removeKey(item.first());
            }
        });

    dict.addAll(TP.sys.getCustomTypes());

    return dict;
});

//  ------------------------------------------------------------------------
//  FUNCTION BINDING
//  ------------------------------------------------------------------------

/**
 * TIBET's use of functions as parameters is extensive and we want to ensure
 * that methods, i.e. functions with a 'this' reference in their body, remain
 * bound to the proper instance regardless of where or how they may be invoked.
 * JavaScript binds function 'this' references to a context dynamically when the
 * function is invoked 'through' an object pointer as in:
 *
 *      myObj.func();
 *
 * Unfortunately, if functions are passed as parameters without their original
 * context then any internal 'this' references will be resolved incorrectly if
 * the function is then simply executed as in:
 *
 *      function aFunction() { return this.getName(); };
 *
 *      function runner(aFunction) { return aFunction(); };
 *
 * In the example here, aFunction's 'this' reference will be undefined (or the
 * global object) in runner(). Binding the function in a more permanent fashion
 * is required in these cases.

 * Note that ECMAScript E5 now provides a built-in 'bind()' function, but we
 * 'hook' it (if available) and overlay it with our own version that supplies
 * more meta-data to the runtime engine (i.e. a backreference to the bound
 * Function, etc.)
 */

//  ------------------------------------------------------------------------
//  BINDING
//  ------------------------------------------------------------------------

//  If the built-in ECMAScript E5 'bind' method isn't supplied, then define
//  a '$$bind()' call that emulates it. Otherwise, alias the ECMA E5 'bind'
//  into '$$bind' so that, either way, we can redefine 'bind' below.

if (!TP.isFunction(TP.FunctionProto.bind)) {
    TP.FunctionProto.$$bind = function(aThis) {

        var thisFunc,
            boundArgs,

            retFunc;

        /* eslint-disable consistent-this */

        //  we'll need a reference to the receiving function that can be
        //  scoped properly by the closure we build, so capture it in a
        //  local variable
        thisFunc = this;

        //  grab any 'initially bound' arguments by using the arguments
        //  object and slicing off 'aThis'.
        boundArgs = TP.args(arguments, 1);

        //  if boundArgs isn't empty, then build a return Function that
        //  grabs its own arguments when invoked, unshifts the bound
        //  arguments onto the front of it and applies the bound Function
        //  with that set of arguments.
        if (boundArgs.length > 0) {
            retFunc = function() {

                var newArgs;

                newArgs = TP.args(arguments);
                newArgs.unshift(boundArgs);

                return thisFunc.apply(aThis, newArgs);
            };
        } else {
            //  otherwise, build a return Function that applies the bound
            //  Function with its own arguments when invoked.
            retFunc = function() {
                return thisFunc.apply(aThis, arguments);
            };
        }

        /* eslint-enable consistent-this */

        return retFunc;
    };
} else {
    //  The platform provides a native bind() - alias it to '$$bind()' so that
    //  we can override it below
    TP.FunctionProto.$$bind = TP.FunctionProto.bind;
}

//  ---

Function.Inst.defineMethod('bind',
function(aThis, varargs) {

    /**
     * @method bind
     * @summary Binds a function to a particular context...for good :).
     * @description Returns a function which ensures the receiver will be
     *     executed in the context of aThis. This is relevant any time the
     *     function contains a 'this' reference and might be invoked via a
     *     non-binding syntax. This is common when attempting to pass a method
     *     as a 'block', particularly to an iteration function or as an event
     *     handler.
     *
     *     The bind() operation is a critical element of the TIBET
     *     infrastructure. In JavaScript functions are only bound to an object
     *     (thereby making them 'methods') when accessed via an object
     *     reference. The problem arises when functions are passed as arguments
     *     or otherwise manipulated such that they would no longer be accessed
     *     through an object reference. In those cases, when the function is
     *     invoked its 'this' reference will not reflect the proper object (it
     *     will usually end up referencing the window -- which is a decent
     *     debugging hint that you may have an unbound function).
     *
     *     bind() solves this problem by taking advantage of JavaScript's
     *     ability to create what are known as closures. A closure is
     *     essentially the combination of a function and the scope in which it
     *     was defined, all wrapped up together. When the function is executed
     *     at a later time the values in scope at definition time remain in
     *     effect for the function. This is also known as "lexical scoping"
     *     which is how most (but not all) JavaScript functions are scoped.
     *
     *     NOTE that since only functions with internal 'this' references are
     *     affected by a binding context we don't wrap functions without
     *     internal 'this' references.
     * @param {Object} aThis The object to use for 'this'.
     * @param {arguments} varargs Zero or more 'bound' arguments to provide to
     *     the bound function.
     * @returns {Function} The new 'bound' Function, which captures the supplied
     *     'this' reference and uses it when invoking.
     */

    var retFunc;

    //  if more than 1 argument was supplied, then call $$bind() with the
    //  arguments object.
    if (arguments.length > 1) {
        retFunc = this.$$bind.apply(this, arguments);
    } else {
        //  On rare occasions, 'this' points to a Function that isn't
        //  participating in the Function.prototype chain (sigh...). If so, the
        //  '$$bind' won't be set and we should just use that objects 'bind'.
        if (TP.notValid(this.$$bind)) {
            retFunc = this.bind(aThis);
        } else {
            //  otherwise, just call $$bind() with aThis.
            retFunc = this.$$bind(aThis);
        }
    }

    //  TIBET uses the various name, owner, and track elements during
    //  both logging and inheritance operations so they need to be set so
    //  our newly bound function can still play along
    retFunc[TP.NAME] = this[TP.NAME] || 'BoundMethod';
    retFunc[TP.OWNER] = this[TP.OWNER] || TP.NONE;
    retFunc[TP.TRACK] = this[TP.TRACK] || TP.NONE;
    retFunc[TP.DISPLAY] = TP.id(retFunc[TP.OWNER]) + '.' + retFunc[TP.NAME];

    //  We also want to make sure we can get back to the original function
    //  that was being bound as well as the binding itself in any IDE/tools
    retFunc.$realFunc = this;
    retFunc.$realThis = aThis;

    //  NB: We only put a '$binding' slot on the receiver if it does *not* have
    //  a TP.OWNER. We don't want to instrument shared Function objects.
    if (TP.notValid(this[TP.OWNER])) {
        this.$binding = retFunc;
    }

    //  return our newly created and instrumented "method"
    return retFunc;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('unbound',
function(aFunction) {

    /**
     * @method unbound
     * @summary Returns the true function that would be invoked by a
     *     potentially bound function - or series of them. This method "drills
     *     down" through a set of bound functions until it reaches the
     *     originally bound function reference.
     * @param {Function} aFunction A function to unbind, returning the original.
     * @returns {Function} The originally bound source function.
     */

    var func;

    if (!TP.isFunction(aFunction)) {
        TP.raise(this, 'TP.sig.InvalidParameter');
        return aFunction;
    }

    func = aFunction;
    while (func.$realFunc) {
        func = func.$realFunc;
    }

    return func;
});

//  ------------------------------------------------------------------------
//  FUNCTION "THREADING"
//  ------------------------------------------------------------------------

Function.Inst.defineMethod('delay',
function(afterWaitMS) {

    /**
     * @method delay
     * @summary Causes the receiver to be executed after the supplied delay.
     * @description This method provides a convenient way for the receiver to
     *     execute after a certain delay of time. If you want to
     *     pass arguments to the function itself, simply pass them as parameters
     *     to this method:
     *         f.delay(waitms, farg1, farg2, ...).
     *     Note that this method returns an extended Promise object that
     *     contains the ID of the timeout that gets used to run the receiver
     *     after the delay. That ID is available in the Promise's
     *     'cancellationID' slot. Calling cancelTimeout with that ID will cancel
     *     the operation, causing the receiver not to run *and the Promise not
     *     to resolve*.
     * @param {Number} [afterWaitMS] The amount of time in milliseconds to wait
     *     to execute the receiver. This is optional and defaults to 0.
     * @returns {Object} The object to use to stop the queueBeforeNextRepaint()
     *     prematurely (via cancelAnimationFrame()).
     * @returns {Promise} A promise which resolves after the delay, with an
     *     extra property of 'cancellationID' which can be used to cancel
     *     execution of the receiver after the delay.
     */

    var thisref,
        arglist,

        waitMS,

        promise,
        cancellationID;

    //  we'll want to invoke the receiver (this) but need a way to get it
    //  to close properly into the function we'll use for argument passing
    thisref = this;

    //  NB: We supply 1 as the second argument to skip gathering the wait ms
    //  into the args we'll use for the Function apply.
    arglist = TP.args(arguments, 1);

    if (TP.isNumber(afterWaitMS)) {
        waitMS = afterWaitMS;
    } else {
        waitMS = TP.sys.getcfg('queue.delay', 0);
    }

    promise = TP.extern.Promise.construct(
                function(resolver, rejector) {
                    var func;

                    //  have to build a second function to ensure the arguments
                    //  are used
                    func = function() {
                        resolver(thisref.apply(thisref, arglist));
                    };

                    cancellationID = setTimeout(func, waitMS);
                });

    promise.cancellationID = cancellationID;

    return promise;
}, {
    dependencies: [TP.extern.Promise]
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('queueAfterNextRepaint',
function(aWindow, afterWaitMS) {

    /**
     * @method queueAfterNextRepaint
     * @summary Causes the receiver to be executed after the browser begins its
     *     next repainting of the screen.
     * @description This method provides a convenient way for the receiver to
     *     execute just after the browser repaints the screen. If you want to
     *     pass arguments to the function itself, simply pass them as parameters
     *     to this method:
     *         f.queueBeforeNextRepaint(window, waitms, farg1, farg2, ...).
     *     Note that this method returns an extended Promise object that
     *     contains the ID of either the window.requestAnimationFrame or the
     *     timeout that gets used to run the receiver after the delay (it gets
     *     reset to the timeout as part of the RAF call. That ID is available in
     *     the Promise's 'cancellationID' slot. Calling cancelTimeout with that
     *     ID will cancel the operation, causing the receiver not to run *and
     *     the Promise not to resolve*.
     * @param {Window|TP.core.Window} [aWindow] The window to be waiting for
     *     refresh. This is an optional parameter that will default to the
     *     current UI canvas.
     * @param {Number} [afterWaitMS] The amount of time in milliseconds to wait
     *     after repaint to execute the receiver. This is optional and defaults
     *     to 0.
     * @returns {Promise} A promise which resolves after the delay, with an
     *     extra property of 'cancellationID' which can be used to cancel
     *     execution of the receiver after the delay.
     */

    var thisref,
        arglist,

        win,

        waitMS,

        promise,
        cancellationID;

    //  we'll want to invoke the receiver (this) but need a way to get it
    //  to close properly into the function we'll use for argument passing
    thisref = this;

    //  Just in case we were handed a TP.core.Window
    win = TP.unwrap(aWindow);

    //  NB: We supply 2 as the second argument to skip gathering the window and
    //  the wait ms into the args we'll use for the Function apply.
    arglist = TP.args(arguments, 2);

    if (!TP.isWindow(win)) {
        win = TP.sys.getUICanvas(true);
    }

    if (TP.isNumber(afterWaitMS)) {
        waitMS = afterWaitMS;
    } else {
        waitMS = TP.sys.getcfg('queue.delay', 0);
    }

    promise = TP.extern.Promise.construct(
                function(resolver, rejector) {
                    var func;

                    //  have to build a second function to ensure the arguments
                    //  are used
                    func = function() {
                        resolver(thisref.apply(thisref, arglist));
                    };

                    if (!TP.windowIsVisible(win)) {
                        cancellationID = setTimeout(func, 0);
                    } else {
                        //  Call requestAnimationFrame with the a Function that
                        //  wraps the Function that we calculated above in a
                        //  setTimeout that will invoke after the supplied
                        //  number of milliseconds (or 0).
                        //  This will 'schedule' the call for just after next
                        //  time the screen is repainted.
                        cancellationID = win.requestAnimationFrame(
                                    function() {
                                        //  NB: We reset the returned Promise's
                                        //  'cancellationID' here to what the
                                        //  setTimeout() returns so that once
                                        //  this method is triggered, the
                                        //  process can still be cancelled.
                                        promise.cancellationID =
                                                    setTimeout(func, waitMS);
                                    });
                    }
                });

    promise.cancellationID = cancellationID;

    return promise;
}, {
    dependencies: [TP.extern.Promise]
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('queueBeforeNextRepaint',
function(aWindow) {

    /**
     * @method queueBeforeNextRepaint
     * @summary Causes the receiver to be executed before the browser begins its
     *     next repainting of the screen.
     * @description This method provides a convenient way for the receiver to
     *     execute just before the browser repaints the screen. If you want to
     *     pass arguments to the function itself, simply pass them as parameters
     *     to this method:
     *         f.queueBeforeNextRepaint(window, farg1, farg2, ...).
     *     Note that this method returns an extended Promise object that
     *     contains the ID of the window.requestAnimationFrame that gets used to
     *     run the receiver. That ID is available in the Promise's 'cancellation
     *     ID' slot. Calling cancelTimeout with that ID will cancel the
     *     operation, causing the receiver not to run *and the Promise not to
     *     resolve*.
     * @param {Window|TP.core.Window} [aWindow] The window to be waiting for
     *     refresh. This is an optional parameter that will default to the
     *     current UI canvas.
     * @returns {Promise} A promise which resolves after the delay, with an
     *     extra property of 'cancellationID' which can be used to cancel
     *     execution of the receiver after the delay.
     */

    var thisref,
        arglist,

        win,

        promise,
        cancellationID;

    //  we'll want to invoke the receiver (this) but need a way to get it
    //  to close properly into the function we'll use for argument passing
    thisref = this;

    //  Just in case we were handed a TP.core.Window
    win = TP.unwrap(aWindow);

    //  NB: We supply 1 as the second argument to skip gathering the window into
    //  the args we'll use for the Function apply.
    arglist = TP.args(arguments, 1);

    if (!TP.isWindow(win)) {
        win = TP.sys.getUICanvas(true);
    }

    promise = TP.extern.Promise.construct(
                function(resolver, rejector) {
                    var func;

                    //  have to build a second function to ensure the arguments
                    //  are used
                    func = function() {
                        resolver(thisref.apply(thisref, arglist));
                    };

                    if (!TP.windowIsVisible(win)) {
                        cancellationID = setTimeout(func, 0);
                    } else {
                        //  Call requestAnimationFrame with the a Function that
                        //  uses the Function that we calculated above.
                        //  This will 'schedule' the call for just before next
                        //  time the screen is repainted.
                        cancellationID = win.requestAnimationFrame(func);
                    }
                });

    promise.cancellationID = cancellationID;

    return promise;
}, {
    dependencies: [TP.extern.Promise]
});

//  ------------------------------------------------------------------------
//  FUNCTION INFORMATION
//  ------------------------------------------------------------------------

Function.Inst.defineMethod('getArity',
function() {

    /**
     * @method getArity
     * @summary Returns the arity (that is, the number of formally declared
     *     parameters) to this function.
     * @returns {Number} The number of formally declared parameters to this
     *     function.
     */

    var obj;

    obj = TP.getRealFunction(this);

    return obj.length;
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('getCommentLines',
function() {

    /**
     * @method getCommentLines
     * @summary Parses the receiver's comment text and returns it as a set of
     *     lines, one per JSDoc tag found in the comment. The resulting lines
     *     can be individually parsed by tag-specific line parsers as part of a
     *     larger comment processing operation.
     *  @example
     *          line 1
     *          line 2
     *          line 3
     *                  indented line 4
     *              line 5 back out
     *          line 6
     *          line 7
     * @returns {String[]} The comment lines in order from the comment.
     */

    var text,
        example,
        lines,
        clean,
        len,
        i,
        line,
        joined;

    //  Get the JSDoc comment text of the receiver. If this is empty no real
    //  structure can be provided.
    text = this.getCommentText();
    if (TP.isEmpty(text)) {
        return TP.ac();
    }

    //  ---
    //  cleanse
    //  ---

    //  Set our 'in @example' state flag to false before we enter loop.
    example = false;

    //  Simplistic cleansing of the comment text to make processing content tags
    //  a little easier.
    lines = text.split('\n');
    lines = lines.map(
            function(aLine) {
                var str;

                str = aLine.trim();

                //  Ignore the opening and closing lines for a doc comment.
                if (str.startsWith('/**') || str.startsWith('*/')) {
                    return undefined;
                }

                //  If the line's starting text is @example turn off whitespace
                //  stripping until we come to the next tag.
                if (str.match(/^\s*\*\s*@example/)) {
                    example = true;
                    return str.replace(/^\s*\*\s*@example/, '@example');
                }

                //  Check to see if we're in example mode but have hit a new
                //  tag. If so we flip back out of example mode so we trim
                //  whitespace.
                if (example && str.match(/^\s*\*\s*@/)) {
                    example = false;
                }

                if (!example) {
                    //  str is already trimmed, just remove any leading '*' etc.
                    str = str.replace(/^\*\s*/, '');
                } else {
                    str = aLine;
                    //  Replace any * in the text with a space, preserving any
                    //  other whitespace on that line.
                    str = str.replace(/^(\s*)\*(\s*)/, '$1 $2');
                }

                return str;
            }).compact();   //  Compact removes null-valued lines.

    //  Might be an empty comment, in which case we return an empty array rather
    //  than null to signify there was a comment, but it was empty.
    if (TP.isEmpty(lines)) {
        return lines;
    }

    //  ---
    //  join
    //  ---

    //  Join "blocks" of text with their associated tag. Also watch out for
    //  opening block which may not start with @name or a similar tag.
    clean = TP.ac();

    //  First line. Should start with @name or similar but some authors put in
    //  description without an opening tag.
    if (lines[0].charAt(0) !== '@') {
        lines[0] = '@summary ' + lines[0];
    }

    //  Set our 'in @example' state flag to false before we enter loop.
    example = false;

    //  With first line cleansed we should be able to loop over the lines and
    //  join any which don't start with '@' to the currently open tag.
    len = lines.length;
    for (i = 0; i < len; i++) {

        line = lines.at(i);

        if (line.charAt(0) === '@') {

            if (i !== 0) {
                clean.push(joined);
            }
            joined = line;

            example = line.startsWith('@example');
            if (example) {
                clean.push(joined);
            }
        } else if (!example) {
            joined += ' ' + line;
        } else {
            clean.push(line);
            joined = null;
        }
    }

    //  Push any remaining line and ensure we don't have any null lines.
    clean.push(joined);
    clean.compact();

    return clean;
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('getCommentText',
function() {

    /**
     * @method getCommentText
     * @summary Returns the JSDoc comment text for the receiver, if any.
     * @returns {String} The comment text.
     */

    var obj,

        text,
        tokens,
        comment;

    obj = TP.getRealFunction(this);

    text = obj.toString();
    tokens = TP.$tokenize(text);

    comment = tokens.detect(
                function(token) {
                    return token.name === 'comment' &&
                            token.value.startsWith('/**');
                });

    if (TP.isValid(comment)) {
        return comment.value;
    }
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('getMethodPatch',
function(newMethodText, loadedFromSourceFile) {

    /**
     * @method getMethodPatch
     * @summary Returns patch information suitable for applying to the
     *     receiver's source file. The Diff package must be loaded for this
     *     operation to work. The Diff package is typically loaded by the
     *     Sherpa config.
     * @param {String} newMethodText The new method text.
     * @param {Boolean} [loadedFromSourceFile=true] Whether or not the receiver
     *     was loaded from a source file on startup or is being dynamically
     *     patched during runtime.
     * @returns {String[]|undefined} An Array of Strings consisting of a) the
     *     patch as computed between the current method text and the supplied
     *     method text in 'unified diff' format and b) the new content text of
     *     the method's source file as computed by splicing the current method
     *     text into the source file (effectively updating it).
     */

    var obj,

        path,
        url,
        str,
        matcher,
        resp,
        currentContent,
        newText,

        match,
        newContent,
        patch;

    obj = TP.getRealFunction(this);

    if (TP.notValid(TP.extern.Diff)) {
        TP.ifWarn() ?
            TP.warn('Unable to generate method patch. Diff not loaded.') : 0;
        return;
    }

    //  Get the original source url...
    path = TP.objectGetSourcePath(obj);
    if (TP.isEmpty(path)) {
        TP.ifWarn() ?
            TP.warn('Unable to generate method patch. Source path not found.') :
            0;
        return;
    }

    //  Get the original source text. Note here how we do this synchronously
    //  and we set 'refresh' to true, thereby forcing the browser to go back to
    //  the server for the latest version of the file. This is so that we can
    //  compute the diff against the latest version that is real.
    url = TP.uc(path);
    resp = url.getResource(TP.hc('async', false,
                                    'resultType', TP.TEXT,
                                    'refresh', true,
                                    'signalChange', false));
    currentContent = resp.get('result');

    if (TP.isEmpty(currentContent)) {
        TP.ifWarn() ?
            TP.warn('Unable to generate method patch. Source text not found.') :
            0;
        return;
    }

    newText = newMethodText;

    if (TP.isFalse(loadedFromSourceFile)) {
        //  This method did not come from a source file on startup - just append
        //  it to the existing content.
        newContent = currentContent + newText;
    } else {
        //  Get the current method's body text...
        str = TP.src(obj);

        //  If there's a trailing ';', then we want to slice it off. We may be
        //  trying to match in a place where there's a '})', but the Function is
        //  standing alone and is generating these ';'s.
        if (/\};$/.test(str)) {
            str = str.slice(0, -1);
            if (TP.isValid(obj[TP.OWNER])) {
                str += ');';
            }
        }

        if (/\};$/.test(newText)) {
            newText = newText.slice(0, -1);
            if (TP.isValid(obj[TP.OWNER])) {
                newText += ');';
            }
        }

        //  Convert the body text into a RegExp we can use as a way of indexing
        //  into the original source file text.
        /* eslint-disable no-control-regex */
        matcher = TP.rc(RegExp.escapeMetachars(
                    str.replace(/[\u0009\u000A\u0020\u000D]+/g, 'SECRET_SAUCE')).
                        replace(/SECRET_SAUCE/g, '\\s*'));
        /* eslint-enable no-control-regex */

        //  Try to find an index into current content using the generated
        //  RegExp. If we can't find one, we'll just use all of the new text to
        //  try to generate a patch.
        match = currentContent.match(matcher);
        if (TP.notValid(match)) {
            TP.ifWarn() ?
                TP.warn('Unable to generate specific method patch.' +
                            ' Using large-grained method diff.') :
                0;
            newContent = newText;
        } else {
            newContent = currentContent.slice(0, match.index) +
                        newText +
                        currentContent.slice(match.index + match.at(0).length);
        }
    }

    //  NOTE we use the original srcPath string here to retain relative address.
    patch = TP.extern.Diff.createPatch(path, currentContent, newContent);

    return TP.ac(patch, newContent);
}, {
    dependencies: [TP.extern.Diff]
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('getMethodSourceHead',
function() {

    /**
     * @method getMethodSourceHead
     * @summary Returns a String that is a representation of the 'source head'
     *     of the canonical TIBET way of adding a method to the system.
     * @description NOTE: this method produces a representation which *must* be
     *     followed with a Function statement (i.e. 'function() {...}') and the
     *     method tail.
     * @returns {String} A representation of the 'source method head' of the
     *     receiver in TIBET.
     */

    var obj,

        owner,
        track,
        descriptor,

        str,
        ownerName;

    obj = TP.getRealFunction(this);

    owner = obj[TP.OWNER];
    track = obj[TP.TRACK];
    descriptor = obj[TP.DESCRIPTOR];

    str = TP.ac();

    //  We need to have both a valid owner and track to generate the header.
    if (TP.isValid(owner) && TP.isValid(track)) {

        ownerName = owner.getName();

        //  If the descriptor has a valid 'signal' slot on it, then it's a
        //  handler.
        if (TP.isValid(descriptor.signal)) {

            if (track === TP.TYPE_LOCAL_TRACK ||
                track === TP.LOCAL_TRACK) {
                str.push(ownerName, '.defineHandler(');
            } else {
                str.push(ownerName, '.', track, '.defineHandler(');
            }

            str.push('\'', descriptor.signal.getSignalName() + '\',\n');
        } else {

            if (track === TP.GLOBAL_TRACK) {
                str.push('TP.defineGlobalMethod(');
            } else if (track === TP.PRIMITIVE_TRACK) {
                str.push('TP.definePrimitive(');
            } else if (track === TP.META_TYPE_TRACK) {
                str.push('TP.defineMetaTypeMethod(');
            } else if (track === TP.META_INST_TRACK) {
                str.push('TP.defineMetaInstMethod(');
            } else if (track === TP.TYPE_LOCAL_TRACK ||
                        track === TP.LOCAL_TRACK) {
                str.push(ownerName, '.defineMethod(');
            } else {
                str.push(ownerName, '.', track, '.defineMethod(');
            }

            str.push('\'', obj.getName() + '\',\n');
        }
    }

    return str.join('');
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('getMethodSourceTail',
function() {

    /**
     * @method getMethodSourceTail
     * @summary Returns a String that is a representation of the 'source tail'
     *     of the canonical TIBET way of adding a method to the system.
     * @returns {String} A representation of the 'source method head' of the
     *     receiver in TIBET.
     */

    var obj,

        descriptor,

        str;

    obj = TP.getRealFunction(this);

    descriptor = obj[TP.DESCRIPTOR];

    str = TP.ac();

    //  If the descriptor has valid 'phase', 'origin' or 'state' slots on it,
    //  then it's a handler that needs to be followed by a descriptor of these
    //  additional properties.
    if (TP.isValid(descriptor.phase) ||
        TP.isValid(descriptor.origin) ||
        TP.isValid(descriptor.state)) {

        str.push(',', ' {');

        //  We like to use the TP.CAPTURING constant
        if (TP.isValid(descriptor.phase)) {
            if (descriptor.phase === TP.CAPTURING) {
                str.push('phase: TP.CAPTURING', ', ');
            } else {
                str.push('phase: ', descriptor.phase, ', ');
            }
        }
        if (TP.isValid(descriptor.origin)) {
            str.push('origin: \'', descriptor.origin, '\'', ', ');
        }
        if (TP.isValid(descriptor.state)) {
            str.push('state: \'', descriptor.state, '\'', ', ');
        }

        //  Pop off the last ', '
        str.pop();

        str.push('}');
    }

    str.push(')');

    return str.join('');
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('$getFunctionLiteralIndexes',
function() {

    /**
     * @method $getFunctionLiteralIndexes
     * @summary Returns an Array of start and end indexes of each occurrence of
     *     a 'function() {...}' literal in the receiver's source text. Note that
     *     the first pair here will be the method's 'function() {...}' statement
     *     for itself.
     * @returns {Number[]} An Array of two numbers: the start index and the end
     *     index of each occurrence of the literal.
     */

    var obj,

        text,
        tokens,

        funcIndexes,
        i,
        j,
        count,

        startPos,
        endPos;

    obj = TP.getRealFunction(this);

    text = obj.toString();

    //  Tokenize our source String - it's the only way ;-).
    tokens = TP.$tokenize(text);

    funcIndexes = TP.ac();

    for (i = 0; i < tokens.getSize(); i++) {

        //  Look for an opening 'function' keyword
        if (tokens.at(i).value !== 'function') {
            continue;
        }

        //  Find the first '{' after that.
        count = 0;
        for (j = i; j < tokens.getSize(); j++) {
            if (tokens.at(j).value === '{') {

                //  Capture the starting position and begin the counter.
                startPos = tokens.at(j).to + 1;
                count++;

                break;
            }
        }

        //  Increment to the next token and continue.
        for (j = j + 1; j < tokens.getSize(); j++) {

            //  Kick the counter back and forth as we hit opening and closing
            //  braces.
            if (tokens.at(j).value === '{') {
                count++;
            }
            if (tokens.at(j).value === '}') {
                count--;
            }

            //  If the counter is back at 0, exit.
            if (count === 0) {
                break;
            }
        }

        //  Capture the ending position.
        endPos = tokens.at(j).to;

        funcIndexes.push(TP.ac(startPos, endPos));
    }

    return funcIndexes;
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('getMethodName',
function() {

    /**
     * @method getMethodName
     * @summary Returns the "method name" which is the fully-qualified name of
     *     the function including owner and track (if Inst or Type).
     * @returns {String} The method name string.
     */

    var obj,

        id,
        owner,
        track,
        name;

    obj = TP.getRealFunction(this);

    id = '';

    if (TP.isValid(obj[TP.OWNER])) {
        owner = TP.name(obj[TP.OWNER]);
    }

    if (TP.isValid(obj[TP.TRACK])) {
        track = obj[TP.TRACK];
        switch (track) {
            case TP.TYPE_TRACK:
                /* fall through */
            case TP.INST_TRACK:
                break;
            default:
                track = '';
                break;
        }
    }

    name = TP.name(obj);

    id += owner ? owner + '.' : '';
    id += track ? track + '.' : '';
    id += name;

    return id;
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('getParameterNames',
function() {

    /**
     * @method getParameterNames
     * @summary Returns an Array of the formal parameter names of this
     *     function.
     * @returns {String[]} The formal parameter names to this function.
     */

    var obj,

        text,
        params,
        tokens,
        comments;

    obj = TP.getRealFunction(this);

    text = obj.toString();
    params = text.slice(text.indexOf('(') + 1, text.indexOf(')'));

    //  Some people put comments in their parameter lists so we might as well
    //  leverage tokenizing and just return identifiers.
    tokens = TP.$tokenize(params);

    //  Warn about any comments in parameter lists. This is done here since the
    //  largest invocation of this method occurs as part of the :doclint
    //  command in TIBET which tries to lint comments.
    comments = tokens.filter(
                    function(token) {
                        return token.name === 'comment';
                    });

    if (TP.notEmpty(comments)) {
        TP.warn('Comment(s) in parameter list for ' + obj.getName());
    }

    tokens = tokens.filter(
                    function(token) {
                        return token.name === 'identifier';
                    });

    return tokens.map(
                function(token) {
                    return token.value;
                });
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('getSignature',
function() {

    /**
     * @method getSignature
     * @summary Returns the "method signature" or function calling signature
     *     for the receiver.
     * @returns {String} The signature string.
     */

    var obj,

        str;

    obj = TP.getRealFunction(this);

    str = 'function ' + obj.getName() +
            '(' + obj.getParameterNames().join(', ') + ')';

    return str;
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('getSourceText',
function() {

    /**
     * @method getSourceText
     * @summary Returns the source text for the receiver after stripping all
     *     comment text from it.
     * @returns {String} The source text.
     */

    var obj,

        text,
        tokens;

    obj = TP.getRealFunction(this);

    text = obj.toString();
    tokens = TP.$tokenize(text);
    tokens = tokens.filter(
                    function(token) {
                        return token.name !== 'comment';
                    });

    text = tokens.reduce(
                    function(previous, current) {
                        return previous + current.value;
                    },
                    '');

    return text;
});

//  ------------------------------------------------------------------------
//  FUNCTION SIGNAL OBSERVING
//  ------------------------------------------------------------------------

Function.Inst.defineMethod('execIfTrueOrWaitForSignal',
function(condition, anOrigin, aSignal, timeout) {

    /**
     * @method execIfTrueOrWaitForSignal
     * @summary Executes the receiver immediately if the condition is true. If
     *     not, the receiver will be executed when the specified signal from the
     *     specified origin is received.
     * @param {Boolean} condition The condition to test for immediate execution.
     * @param {Object|Object[]} anOrigin The originator(s) to be observed.
     * @param {TP.sig.Signal|Array<TP.sig.Signal|String>} aSignal The signal(s)
     *     to observe.
     * @param {Number} [timeout] An optional delay for when this method will
     *     cause the receiver to be unsubscribed to the signal if the handler
     *     hasn't been executed yet. This default to the value of the
     *     'content.signal.delay' cfg value.
     * @returns {Function} The receiver.
     */

    var thisref,

        didRun,
        handler;

    if (TP.isTrue(condition)) {
        this();
        return this;
    }

    thisref = this;

    didRun = false;
    handler = function(aSig) {
        handler.ignore(anOrigin, aSig);

        thisref();

        didRun = true;
    };

    handler.observe(anOrigin, aSignal);

    setTimeout(
        function() {
            if (!didRun) {
                handler.ignore(anOrigin, aSignal);
            }
        }, TP.ifInvalid(timeout, TP.sys.cfg('content.signal.delay', 1000)));

    return this;
});

//  ------------------------------------------------------------------------
//  TYPE MEMBERSHIP
//  ------------------------------------------------------------------------

/**
 * The functions here provide simple information regarding the type, type
 * name, etc. of the receiving object. These are used extensively in logging
 * and other areas of the system.
 */

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('asType',
function() {

    /**
     * @method asType
     * @summary Returns the receiver as a Type. If the receiver *is* a type
     *     this returns the receiver. If the receiver is a String the string
     *     content is used as a typename and an attempt is made to return that
     *     type. If the receiver is an instance of anything other than String
     *     the receiver's type is returned.
     * @returns {Object} The type object for the receiver.
     */

    var type;

    if (TP.isType(this)) {
        return this;
    }

    if (TP.isString(this)) {
        if (TP.isType(type = TP.sys.getTypeByName(this))) {
            return type;
        }

        //  IE sometimes will have _ in the type name due to metadata issues
        //  BUT NOTE NOTE NOTE that we DO NOT WANT A GLOBAL REPLACE HERE so
        //  that names can be xctrls:something_service etc.
        return TP.sys.getTypeByName(this.replace('_', ':'));
    }

    return this.getType();
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getSubtypes',
function(shouldDescend) {

    /**
     * @method getSubtypes
     * @summary Returns an array containing the subtypes of the receiver. When
     *     working with immediate children (no descent), you should consider
     *     this array private and avoid manipulating it directly.
     * @param {Boolean} shouldDescend A flag controlling whether the list
     *     includes all subtypes or only immediate children.
     * @returns {Object[]} An array of subtypes.
     */

    var types,
        emptyArr,
        i,
        len,
        type;

    if (!TP.isType(this)) {
        return this.getType().getSubtypes();
    }

    //  shallow? easy, list is built by defineSubtype (or not ;))
    if (TP.notTrue(shouldDescend)) {
        return this[TP.SUBTYPES] || TP.ac();
    }

    //  deep...see if we've got a cached value that we own
    if (TP.owns(this, TP.SUBTYPES_DEEP)) {
        if (TP.isArray(types = this[TP.SUBTYPES_DEEP])) {
            return types;
        }
    }

    //  next see if we have any subtypes at all. if not we can bail, there's
    //  nothing to iterate on
    if (TP.isEmpty(types = this[TP.SUBTYPES])) {
        return TP.ac();
    }

    //  placeholder array we can use to avoid "TP.sig.InvalidCollection" errors
    emptyArr = TP.ac();

    //  make sure to copy this list! we don't want to be modifying it below
    types = types.copy();

    len = types.length;
    for (i = 0; i < len; i++) {
        type = types[i];

        //  NOTE that by passing false here we don't ask others to go deep,
        //  we're doing all the work here and working down one level at a
        //  time via the iteration across all newly found subtypes
        types.addAll(type.getSubtypes(false) || emptyArr);

        //  update length in case we found some more to work through
        len = types.length;
    }

    //  if we can, cache the deep subtype list, defineSubtype will maintain it
    if (TP.sys.$$shouldCacheDeepSubtypes()) {
        this[TP.SUBTYPES_DEEP] = types;
    }

    return types;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getSubtypeNames',
function(shouldDescend) {

    /**
     * @method getSubtypeNames
     * @summary Returns an array containing the subtype names of the receiver.
     *     The default list contains names of immediate subtypes.
     * @param {Boolean} shouldDescend A flag controlling whether the list
     *     includes all subtypes or only immediate children.
     * @returns {String[]} An array of subtype names.
     */

    var names,
        arr,
        len,
        i;

    if (!TP.isType(this)) {
        return this.getType().getSubtypeNames();
    }

    //  shallow? easy, list is built by defineSubtype (or not ;))
    if (TP.notTrue(shouldDescend)) {
        return this[TP.SUBTYPE_NAMES] || TP.ac();
    }

    //  deep...see if we've got a cached value we own
    if (TP.owns(this, TP.SUBTYPES_NAMES_DEEP)) {
        if (TP.isArray(names = this[TP.SUBTYPE_NAMES_DEEP])) {
            return names;
        }
    }

    //  next see if we have any subtypes at all. if not we can bail
    if (TP.isEmpty(names = this[TP.SUBTYPE_NAMES])) {
        return TP.ac();
    }

    //  build from the subtype list (easier and forces cache on both)
    if (TP.isEmpty(names = this.getSubtypes(shouldDescend))) {
        return TP.ac();
    }

    //  collect the names
    arr = TP.ac();
    len = names.getSize();
    for (i = 0; i < len; i++) {
        arr.push(names.at(i).getName());
    }
    names = arr;

    //  if we can, cache the deep subtype list, defineSubtype will maintain it
    if (TP.sys.$$shouldCacheDeepSubtypes()) {
        this[TP.SUBTYPE_NAMES_DEEP] = names;
    }

    return names;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getSupertype',
function() {

    /**
     * @method getSupertype
     * @summary Returns the supertype of the receiver.
     * @returns {Object|undefined} The supertype of the receiver.
     */

    //  Object doesn't have a supertype thanks ;)
    if (this === TP.ObjectProto || this === Object) {
        return;
    }

    if (TP.isType(this)) {
        return this[TP.SUPER];
    }

    return this.getType().getSupertype();
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getSupertypeName',
function() {

    /**
     * @method getSupertypeName
     * @summary Returns the supertype name of the receiver.
     * @returns {String|undefined} The supertype name of the receiver.
     */

    //  Object doesn't have a supertype thanks ;)
    if (this === TP.ObjectProto || this === Object) {
        return;
    }

    //  types keep this list, which is built from defineSubtype calls
    if (TP.isType(this)) {
        return this[TP.SUPER].getName();
    }

    return this.getType().getSupertypeName();
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getSupertypes',
function() {

    /**
     * @method getSupertypes
     * @summary Returns an array containing the supertypes of the receiver. If
     *     the receiver is an 'instance' then the supertypes of the receiver's
     *     types are returned. You should consider this array private and avoid
     *     manipulating it. The first element in this array is the immediate
     *     supertype of the receiver or, in the case of an instance, it's the
     *     receiver's type.
     * @returns {Object[]} An array of root to immediate supertypes.
     */

    var arr,
        type;

    if (TP.isType(this)) {
        arr = this[TP.ANCESTORS];
        if (TP.isValid(arr)) {
            return arr;
        }

        arr = TP.ac();

        /* eslint-disable consistent-this */

        type = this;
        /* eslint-disable no-cond-assign */
        while (type = type[TP.SUPER]) {
            arr.push(type);
        }
        /* eslint-enable no-cond-assign */

        this[TP.ANCESTORS] = arr;

        /* eslint-enable consistent-this */

        return arr;
    }

    //  instances work from their type if they can acquire it
    if (TP.canInvoke(this, 'getType')) {
        type = this.getType();
        if (type === this) {
            return TP.ac();
        }

        if (TP.canInvoke(type, 'getSupertypes')) {
            return type.getSupertypes();
        }
    }

    return TP.ac();
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getSupertypeNames',
function() {

    /**
     * @method getSupertypeNames
     * @summary Returns an array containing the supertype names of the
     *     receiver.
     * @returns {String[]} An array containing the supertype names of the
     *     receiver.
     */

    var type,
        arr;

    //  types keep this list, which is built from defineSubtype calls
    if (TP.isType(this)) {
        arr = this[TP.ANCESTOR_NAMES];
        if (TP.isValid(arr)) {
            return arr;
        }

        arr = TP.ac();

        /* eslint-disable consistent-this */

        type = this;
        /* eslint-disable no-cond-assign */
        while (type = type[TP.SUPER]) {
            arr.push(type.getName());
        }
        /* eslint-enable no-cond-assign */

        this[TP.ANCESTOR_NAMES] = arr;

        /* eslint-enable consistent-this */

        return arr;
    }

    //  instances work from their type if they can acquire it
    if (TP.canInvoke(this, 'getType')) {
        type = this.getType();
        if (type === this) {
            return TP.ac();
        }

        if (TP.canInvoke(type, 'getSupertypeNames')) {
            return type.getSupertypeNames() || TP.ac();
        }
    }

    return TP.ac();
});

//  ------------------------------------------------------------------------
//  POLYMORPHIC SIGNAL METHODS
//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getSignalName',
function() {

    /**
     * @method getSignalName
     * @summary Returns the 'signal name' of the receiver. If the receiver is
     *     an Object this is equivalent to the escaped type name. If the
     *     receiver is a String the content of the string is returned.
     * @description This method allows Objects to function as Signals within the
     *     framework so that the individual signal types don't have to exist
     *     when the signal is thrown.
     * @returns {String} The signal name of the receiver.
     */

    if (TP.isType(this)) {
        return this.getName();
    }

    return this.getTypeName();
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('getSignalName',
function() {

    /**
     * @method getSignalName
     * @summary Returns the 'signal name' of the receiver. If the receiver is
     *     an Object this is equivalent to getTypeName(). If the receiver is a
     *     String the content of the string is returned.
     * @description This method allows Numbers to function as Signals within the
     *     framework so that the individual signal types don't have to exist
     *     when the signal is thrown.
     * @returns {String} The signal name of the receiver.
     */

    //  here we allow numbers to be provided as signal names in string form
    //  which results in invocations of "handle404" etc. so you can create
    //  handlers for error codes and signal error codes as needed
    return this.toString();
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('getSignalName',
function() {

    /**
     * @method getSignalName
     * @summary Returns the 'signal name' of the receiver. If the receiver is
     *     an Object this is equivalent to getTypeName(). If the receiver is a
     *     String the content of the string is returned.
     * @description This method allows Strings to function as Signals within the
     *     framework so that the individual signal types don't have to exist
     *     when the signal is thrown.
     * @returns {String} The signal name of the receiver.
     */

    return this.toString();
});

//  ------------------------------------------------------------------------
//  TYPE CHECKING - PART II (PostPatch)
//  ------------------------------------------------------------------------

/**
 * While polymorphism is the preferred mechanism for object-oriented programs
 * to alter behavior based on type it's unfortunately necessary to rely on
 * direct type-checking in browsers since not everything you get will actually
 * inherit from Object and use TP.ObjectProto consistently as a root :(.
 */

//  ------------------------------------------------------------------------

TP.definePrimitive('isMemberOf',
function(anObject, aType) {

    /**
     * @method isMemberOf
     * @summary Returns true if anObject is a direct member of aType. The test
     *     performed is both on identity and name so that certain forms of 'type
     *     spoofing' can be done to get around not being able to create direct
     *     subtypes of native types in certain browsers.
     * @param {Object} anObject The object to test.
     * @param {TP.lang.RootObject|String} aType A Type object, or type name.
     * @returns {Boolean} Whether or not the supplied object is a member of the
     *     supplied type.
     */

    var result,

        objTypeName,
        typeName,

        testType;

    //  NB: This is a very heavily used routine, so we use very primitive
    //  checking in it.

    //  NB: We have to treat NaN specially - sigh. Note here that we compare
    //  directly with NaN since isNaN will return true for things like the
    //  'undefined' value.
    /* eslint-disable use-isnan */
    if (anObject === NaN) {
    /* eslint-enable use-isnan */
        //  empty
    } else if (
        //  This seems very pendantic, but these are single compare statements
        //  in most JS VMs and so are much faster than '!anObject', etc. They're
        //  also more accurate, since otherwise "falsey" values won't be
        //  properly tested.
        anObject === undefined || anObject === null ||
        aType === undefined || aType === null ||
        anObject.constructor === undefined || anObject.constructor === null) {
        //  If any of these are not a valid object, then just return false -
        //  can't do any comparisons.
        return false;
    }

    if (TP.isNonFunctionConstructor(anObject)) {
        //  The object is created by non Function constructors and has a
        //  constructor name for us to use.

        /* eslint-disable no-extra-parens */
        if ((result = anObject.$$nonFunctionConstructorConstructorName)) {
            return result;
        }

        return (aType === 'Object' || aType === Object);
        /* eslint-enable no-extra-parens */
    }

    typeName = TP.isType(aType) ? TP.name(aType) : aType;

    //  anObject is a TIBET 'type' itself? Then check to see if the object's
    //  type or typename matches the supplied type or typename. Otherwise, the
    //  last test in this method will get confused and return 'true' for things
    //  like TP.isMemberOf(String, 'String'), which is seriously incorrect.
    if (TP.isType(anObject) && !TP.isNativeType(anObject)) {

        /* eslint-disable no-extra-parens */
        return (anObject.getType() === aType ||
                anObject.getTypeName() === typeName);
        /* eslint-enable no-extra-parens */
    }

    //  direct instance of a native type? fast exit, but not all constructors
    //  respond to getName
    try {
        /* eslint-disable no-extra-parens */
        if ((aType !== Object) &&
            ((anObject.constructor === aType) ||
                (TP.isCallable(anObject.constructor.getName) &&
                (anObject.constructor.getName() === aType)))) {
            return true;
        }
        /* eslint-enable no-extra-parens */
    } catch (e) {
        void 0;
    }

    //  check for spoofing hook and use it if found
    if (TP.canInvoke(anObject, '$$isMemberOf') && TP.isNativeType(aType)) {
        if (TP.isBoolean(result = anObject.$$isMemberOf(aType))) {
            return result;
        }
    }

    //  now for the object...
    if (TP.notEmpty(objTypeName = TP.tname(anObject))) {
        return objTypeName === typeName;
    }

    //  As a test of last resort, we see if we're testing a native object
    //  against a native type. Sometimes, especially in the case of JSON
    //  data, we get objects from another frame and those native objects
    //  don't have any of the methods / slots that we put on them in the
    //  code frame. This will at least try something.
    if (TP.isNativeFunction(anObject.constructor)) {
        if (TP.isString(testType = aType)) {
            testType = TP.global[aType];
        }

        if (TP.isNativeFunction(testType)) {
            return anObject.constructor.toString() === testType.toString();
        }
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isKindOf',
function(anObject, aType) {

    /**
     * @method isKindOf
     * @summary Returns true if TP.isMemberOf(anObject, aType) is true or if
     *     TP.isMemberOf() returns true for any subtypes of aType.
     * @param {Object} anObject The object to test.
     * @param {TP.lang.RootObject|String} aType A Type object, or type name.
     * @returns {Boolean} Whether or not the supplied object is a kind of the
     *     supplied type.
     */

    var typeName,
        superTNames;

    //  NB: This is a very heavily used routine, so we use very primitive
    //  checking in it.

    //  if we're a direct member of that type then yes, we're a kind of that
    //  type...and this is a fairly fast test
    if (TP.isMemberOf(anObject, aType)) {
        return true;
    }

    //  NB: We have to treat NaN specially - sigh. Note here that we compare
    //  directly with NaN since isNaN will return true for things like the
    //  'undefined' value.
    /* eslint-disable use-isnan */
    if (anObject === NaN) {
    /* eslint-enable use-isnan */
        //  empty
    } else if (
        //  This seems very pendantic, but these are single compare statements
        //  in most JS VMs and so are much faster than '!anObject', etc. They're
        //  also more accurate, since otherwise "falsey" values won't be
        //  properly tested.
        anObject === undefined || anObject === null ||
        aType === undefined || aType === null ||
        anObject.constructor === undefined || anObject.constructor === null) {
        //  If any of these are not a valid object, then just return false -
        //  can't do any comparisons.
        return false;
    }

    //  If anObject *is a type itself* (in this case, a native type), then it's
    //  type can either only be 'Object' or 'Function'.
    if (TP.isNativeType(anObject)) {
        if (TP.isNonFunctionConstructor(anObject)) {
            return TP.name(aType) === 'Object';
        }

        return TP.name(aType) === 'Object' || TP.name(aType) === 'Function';
    }

    typeName = TP.isType(aType) ? TP.name(aType) : aType;

    if (TP.notEmpty(superTNames = TP.stnames(anObject))) {
        return superTNames.containsString(typeName);
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isSubtypeOf',
function(anObject, aType) {

    /**
     * @method isSubtypeOf
     * @summary Returns true if the receiver is a subtype of the type provided.
     *     This is always false for 'instances', which an essential difference
     *     between this function and TP.isKindOf().
     * @param {Object} anObject The object to test.
     * @param {TP.lang.RootObject|String} aType A Type object, or type name.
     * @returns {Boolean} Whether or not the supplied object is a subtype of the
     *     supplied type.
     */

    var typeName;

    if (!TP.isType(anObject) || TP.notValid(aType)) {
        return false;
    }

    if (TP.canInvoke(anObject, 'getSupertypeNames')) {
        typeName = TP.isType(aType) ? aType.getName() : aType;

        return anObject.getSupertypeNames().containsString(typeName);
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isURI',
function(anObject) {

    /**
     * @method isURI
     * @summary Returns true if the object provided is either a valid instance
     *     of TP.uri.URI (or a subtype) or a String whose content appears
     *     likely to represent a URI. The test is performed using the
     *     TP.regex.URI_LIKELY regular expression, which is *not* a strict
     *     attempt to parse the URI.
     * @description Scheme-specific differences inherent in URI definitions make
     *     it impossible to do a reasonable job without using subtypes specific
     *     to each scheme (which TIBET supports but which it does not leverage
     *     for this method).
     *     NOTE: This method is evolving to become just a type check for
     *     TP.uri.URI. Use TP.isURIString() to check to see if a String looks
     *     like a URI.
     * @param {Object} anObject The object to test.
     * @returns {Boolean} True if the object appears to be a URI.
     */

    if (TP.notValid(anObject)) {
        return false;
    }

    if (TP.isString(anObject)) {

        //  A warning that, at some point, this API will change to no longer
        //  test Strings.
        TP.ifWarn() ?
            TP.warn('String supplied to isURI: ' + anObject + '.' +
                    ' Use TP.isURIString() instead.') : 0;

        //  simple check for proper URI form - but make sure it's not a RegExp
        //  literal.
        return TP.regex.URI_LIKELY.test(anObject) &&
                !TP.regex.REGEX_LITERAL_STRING.test(anObject);
    }

    return TP.isKindOf(anObject, 'TP.uri.URI');
});

//  ------------------------------------------------------------------------
//  CONTROL FLOW - BRANCHING
//  ------------------------------------------------------------------------

/**
 * Certain syntaxes can create complexity when nested branch logic is required.
 * These methods provide simple alternative syntax that can occasionally be used
 * to write more readable code. And we couldn't resist leveraging a Boolean type
 * that's actually a real type. Now, if only null was an object ;).
 */

//  ------------------------------------------------------------------------
//  ERROR HANDLING
//  ------------------------------------------------------------------------

/*
Utility routines to help manage native JS errors, in particular recursion
errors where possible.
*/

//  ------------------------------------------------------------------------

TP.sys.defineMethod('trapRecursion',
function(shouldNotify, shouldThrow, stackDepth) {

    /**
     * @method trapRecursion
     * @summary Terminates TIBET execution and optionally alerts the current
     *     TIBET call stack when recursion is detected.
     * @description Nav4 in particular is 'unhappy' with recursion. In fact,
     *     it'll crash every time. Using a binary chop on your source can often
     *     locate the offending line but can't help you understand how the
     *     recursion is occuring. In an OO system like TIBET the recursion loop
     *     can often be several methods in size. Placing this call in the
     *     suspected method and then moving it successively deeper into the
     *     method stack will eventually terminate the recursion and provide you
     *     with the necessary info. Of course, if you have IE and the free
     *     Script Debugger it'll do the same thing or if you're using Mozilla
     *     with Venkman -- but that can be _painfully_ slow.
     * @param {Boolean} shouldNotify If true notify()'s call stack. Defaults to
     * @param {Boolean} shouldThrow
     * @param {Number} stackDepth
     * @returns {Boolean} True if a recursion was detected.
     */

    var doNotify,
        doThrow,
        depth,
        stack,
        stackInfo;

    if (!TP.sys.shouldTrapRecursion()) {
        return false;
    }

    doNotify = TP.ifInvalid(shouldNotify, true);
    doThrow = TP.ifInvalid(shouldThrow, false);

    depth = TP.isNumber(stackDepth) ?
                            stackDepth :
                            TP.sys.cfg('stack.max_recursion');

    try {
        throw new Error();
    } catch (e) {
        stack = e.stack || [];
        if (doNotify) {
            stackInfo = TP.getStackInfo(e);
        }
    }

    //  don't need to use activations here, only care about length
    if (TP.isArray(stack) && stack.length > depth) {
        if (doNotify) {
            TP.boot.$stderr('RecursionException', stackInfo, TP.log.ERROR);
        }
        if (TP.notFalse(doThrow)) {
            throw new Error('RecursionError');
        }
        return true;
    }

    return false;
});

//  ------------------------------------------------------------------------

//  NOTE: DO NOT REGISTER THIS...
TP.sys.onerror = function(msg, url, line, column, errorObj) {

    /**
     * @method onerror
     * @summary Captures global errors and outputs them appropriately. This
     *     hook allows TIBET to capture native JavaScript errors and avoid
     *     reporting them via the normal browser mechanism. This keeps users
     *     from being bombarded by messages about JS errors while allowing
     *     developers to see what's what.
     * @param {String} message The error message.
     * @param {String} url The url of the JavaScript file.
     * @param {Number} line The line number in that file.
     * @param {Number} column The column number in that script.
     * @param {Error} errorObj The error object of the error that caused this
     *     hook to trigger.
     * @returns {Boolean} TP.sys.shouldCaptureErrors() value.
     */

    var file,
        path,
        str;

    try {
        //  The boot system will set a file reference in certain cases to help
        //  ensure we report the proper origin.
        file = TP.boot.$$onerrorFile;
        path = TP.notValid(file) ? url : file;

        str = msg || 'Error';
        str += ' in file: ' + path + ' line: ' + line + ' column: ' + column;

        if (TP.sys.shouldLogStack() && TP.isError(errorObj)) {
            str += '\nSTACK:\n' + TP.getStackInfo(errorObj).join('\n');
        }

        //  If we're still booting errors that are uncaught are considered FATAL.
        if (!TP.sys.hasStarted()) {
            TP.fatal(str);
        } else {
            //  Uncaught errors are errors relative to those we raise/catch.
            TP.ifError() ? TP.error(str) : 0;
        }
    } catch (e) {
        //  don't let log errors trigger recursion, but don't bury them either.
        TP.topWindow.console.error('Error logging onerror: ' + e.message);
        TP.topWindow.console.error(str || msg);
    }

    //  last chance...invoke the debugger :)
    if (TP.sys.shouldUseDebugger()) {
        TP.sys.$launchDebugger(arguments);
    }

    //  NOTE we use this construct because declaring this as a global causes
    //  ESLint to freak out about an unused variable on line 28 even if we
    //  encapsulate it in no-unused-vars directives.

    /* eslint-disable no-undef */
    $STATUS = TP.FAILED;
    /* eslint-enable no-undef */

    return TP.sys.shouldCaptureErrors();
};

//  install our version...
window.onerror = TP.sys.onerror;

//  ------------------------------------------------------------------------
//  SIGNALING
//  ------------------------------------------------------------------------

/**
 * Standard event notification with a twist. The TIBET notification module
 * unifies the event models of the two major browsers via DOM Level2 support
 * while integrating non-UI events. The signaling code is broken into two main
 * components. The first component is the actual notification center itself
 * which holds registrations of interest in various signals and origins. The
 * second is the 'arming' code which determines how to arm native components for
 * the events which are being observed. The two halves combine to support a
 * common signaling infrastructure that can adapt easily to cross-browser
 * differences without making the notification center aware of DOM internals.

 * The types TP.sig.Signal and TP.sig.SignalMap along with several global
 * functions including TP.observe(), TP.ignore(), TP.signal(), TP.resume(),
 * TP.suspend() all contribute to TIBET's signaling system.
 */

//  TIBET's pending signal queue. This is used by the TP.queue() calls etc.
if (TP.notValid(TP.sys.$signalQueue)) {
    TP.sys.$signalQueue = TP.ac();
}

//  ------------------------------------------------------------------------

TP.definePrimitive('queue',
function(anOrigin, aSignal, aPayload, aPolicy, aType) {

    /**
     * @method queue
     * @summary Provides a way to queue a signal for processing. This method is
     *     a convenience for signal handlers which don't want to cause signals
     *     they need to throw to be processed until they return. The various
     *     signal() calls check the queue prior to returning and handle any
     *     signals found there.
     * @param {Object} anOrigin The originator of the signal.
     * @param {String|TP.sig.Signal} aSignal The signal to fire.
     * @param {Object} aPayload Optional argument object.
     * @param {Function} aPolicy A "firing" policy that will define how the
     *     signal is fired.
     * @param {String|TP.sig.Signal} aType The default supertype to use when
     *     aSignal type doesn't exist.
     */

    TP.sys.$signalQueue.add(
        TP.ac(TP.ifInvalid(anOrigin, null),
                TP.ifInvalid(aSignal, null),
                TP.ifInvalid(aPayload, null),
                TP.ifInvalid(aPolicy, null),
                TP.ifInvalid(aType, null)));

    return;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('queue',
function(aSignal, aPayload, aPolicy, aType) {

    /**
     * @method queue
     * @summary Queues a set of signal parameters for processing at the end of
     *     the current signal handling cycle.
     * @param {TP.sig.Signal} aSignal The signal to fire.
     * @param {Object} aPayload Optional argument object.
     * @param {Function} aPolicy A "firing" policy that will define how the
     *     signal is fired.
     * @param {String|TP.sig.Signal} aType The default supertype to use when
     *     aSignal type doesn't exist.
     */

    return TP.queue(this, aSignal, aPayload, aPolicy, aType);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('signal',
function(anOrigin, aSignal, aPayload, aPolicy, aType) {

    /**
     * @method signal
     * @summary Signals activity to registered observers. Any additional
     *     arguments are passed to the registered handlers along with the origin
     *     and event.
     * @description This bootstrap version of this method packages the signals
     *     into objects and queues them for processing by later implementations
     *     and logs the activity to the TIBET activity log. Once TIBET has
     *     loaded further a more robust version that performs the actual
     *     signaling activity is installed in place of this version.
     * @param {Object} anOrigin The originator of the signal.
     * @param {TP.sig.Signal} aSignal The signal to fire.
     * @param {Object} aPayload Optional argument object.
     * @param {Function} aPolicy A "firing" policy that will define how the
     *     signal is fired.
     * @param {String|TP.sig.Signal} aType The default supertype to use when
     *     aSignal type doesn't exist.
     * @returns {TP.sig.Signal} The fired signal.
     */

    var args;

    //  see if ignore is on at the 'origin' level
    if (TP.isValid(anOrigin) && anOrigin.$suspended) {
        return;
    }

    //  see if ignore is on at the global level
    if (TP.signal.$suspended) {
        return;
    }

    if (TP.sys.shouldQueueLoadSignals()) {
        //  capture arguments in an array which could later be used by
        //  apply
        args = TP.ac(anOrigin, aSignal, aPayload, aPolicy, aType);

        //  manually add the signal information to the signal queue for
        //  later processing when the signaling system is running
        TP.sys.$signalQueue.add(args);
    }

    TP.ifTrace() && TP.sys.shouldLogLoadSignals() ?
        TP.trace(
            'origin: ' + anOrigin +
            '\nsignal: ' + aSignal +
            '\nsigarg: ' + aPayload +
            '\npolicy: ' + aPolicy +
            '\ntype: ' + aType,
            TP.SIGNAL_LOG) : 0;

    return aSignal;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('signal',
function(aSignal, aPayload, aPolicy, aType) {

    /**
     * @method signal
     * @summary Signals activity to registered observers using the receiver as
     *     the origin of the signal.
     * @param {TP.sig.Signal} aSignal The signal to fire.
     * @param {Object} aPayload Optional argument object.
     * @param {Function} aPolicy A "firing" policy that will define how the
     *     signal is fired.
     * @param {String|TP.sig.Signal} aType The default supertype to use when
     *     aSignal type doesn't exist.
     * @returns {TP.sig.Signal} The fired signal.
     */

    return TP.signal(this, aSignal, aPayload, aPolicy, aType);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('ignore',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method ignore
     * @summary Causes notifications to a particular handler to stop. If the
     *     handler is null all notifications from that origin/signal pair are
     *     removed regardless of the handler in question.
     * @param {Object|Object[]} anOrigin The originator(s) to be ignored.
     * @param {TP.sig.Signal|Array<TP.sig.Signal|String>} aSignal The signal(s)
     *     to ignore.
     * @param {Object} aHandler The handler to disable.
     * @param {Function} aPolicy A "removal" policy that will define how the
     *     handler is removed.
     * @returns {Object} The registration object.
     */

    var type;

    type = TP.sys.getTypeByName('TP.sig.SignalMap');
    if (TP.isType(type)) {
        return TP.sig.SignalMap.$ignore(
                        anOrigin, aSignal, aHandler, aPolicy);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('ignore',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method ignore
     * @summary Causes notifications to a particular handler to stop. If the
     *     handler is null all notifications from that origin/signal pair are
     *     removed regardless of the handler in question. If no handler is
     *     provided the receiver is assumed to be the handler.
     * @param {Object|Object[]} anOrigin The originator(s) to be ignored.
     * @param {TP.sig.Signal|Array<TP.sig.Signal|String>} aSignal The signal(s)
     *     to ignore.
     * @param {Object} aHandler The handler to disable.
     * @param {Function} aPolicy A "removal" policy that will define how the
     *     handler is removed.
     * @returns {Object} The registration object.
     */

    var handler;

    handler = TP.ifInvalid(aHandler, this);

    return TP.ignore(anOrigin, aSignal, handler, aPolicy);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('observe',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method observe
     * @summary Causes notifications to a particular handler to start. The
     *     origin and signal combination define how this occurs. Using null for
     *     either value means "any" and sets up a generic observation. The
     *     policy is a "registration" policy that defines how the observation
     *     will be configured.
     * @param {Object|Object[]} anOrigin The originator(s) to be observed.
     * @param {TP.sig.Signal|Array<TP.sig.Signal|String>} aSignal The signal(s)
     *     to observe.
     * @param {Object} aHandler The handler to notify.
     * @param {Function} aPolicy A "registration" policy that will define how
     *     the handler is registered.
     * @returns {Object} The registration object.
     */

    var type;

    type = TP.sys.getTypeByName('TP.sig.SignalMap');
    if (TP.isType(type)) {
        return TP.sig.SignalMap.$observe(
                            anOrigin, aSignal, aHandler, aPolicy);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('observe',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method observe
     * @summary Causes notifications to a particular handler to start. The
     *     origin and signal combination define how this occurs. Using null for
     *     either value means "any" and sets up a generic observation. The
     *     policy is a "registration" policy that defines how the observation
     *     will be configured. If no handler is provided the receiver is assumed
     *     and registered.
     * @param {Object|Object[]} anOrigin The originator(s) to be observed.
     * @param {TP.sig.Signal|Array<TP.sig.Signal|String>} aSignal The signal(s)
     *     to observe.
     * @param {Object} aHandler The handler to notify.
     * @param {Function} aPolicy A "registration" policy that will define how
     *     the handler is registered.
     * @returns {Object} The registration object.
     */

    var handler;

    handler = TP.ifInvalid(aHandler, this);

    return TP.observe(anOrigin, aSignal, handler, aPolicy);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('resume',
function(anOrigin, aSignal) {

    /**
     * @method resume
     * @summary Causes notifications matching the criteria to resume. Undoes
     *     the effect of having called TP.suspend().
     * @param {Object|Object[]} anOrigin The origin(s) for signals to resume.
     * @param {TP.sig.Signal|Array<TP.sig.Signal|String>} aSignal The signal(s)
     *     to resume.
     * @returns {Object} The registration.
     */

    var type;

    type = TP.sys.getTypeByName('TP.sig.SignalMap');
    if (TP.isType(type)) {
        return TP.sig.SignalMap.$resume(anOrigin, aSignal);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('resume',
function(aSignal) {

    /**
     * @method resume
     * @summary Causes notifications of the signal provided to resume. Undoes
     *     the effect of having called suspend(). The origin being resumed is
     *     the receiver.
     * @param {TP.sig.Signal|Array<TP.sig.Signal|String>} aSignal The signal(s)
     *     to resume.
     * @returns {Object} The registration.
     */

    //  re-enabling all notification
    if (TP.notValid(aSignal)) {
        this.$suspended = false;
    }

    return TP.resume(this, aSignal);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('suspend',
function(anOrigin, aSignal) {

    /**
     * @method suspend
     * @summary Causes notifications matching the criteria to pause. No
     *     registrations are removed but no signaling is performed until a
     *     TP.resume() is called.
     * @param {Object|Object[]} anOrigin The origin(s) to suspend.
     * @param {TP.sig.Signal|Array<TP.sig.Signal|String>} aSignal The signal(s)
     *     to suspend.
     * @returns {Object} The registration.
     */

    var type;

    type = TP.sys.getTypeByName('TP.sig.SignalMap');
    if (TP.isType(type)) {
        return TP.sig.SignalMap.$suspend(anOrigin, aSignal);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('suspend',
function(aSignal) {

    /**
     * @method suspend
     * @summary Causes notifications of aSignal to pause from the receiver.
     *     Calling resume() with the same signal type will turn them back on.
     * @param {TP.sig.Signal|Array<TP.sig.Signal|String>} aSignal The signal(s)
     *     to suspend.
     * @returns {Object} The registration.
     */

    //  turning off all notifications
    if (TP.notValid(aSignal)) {
        this.$suspended = true;
    }

    return TP.suspend(this, aSignal);
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('defineHandler',
function(signalName, aHandler, aDescriptor) {

    /**
     * @method defineHandler
     * @summary Defines a new signal handler. The signalName is typically a
     *     string but can also be a signal type. The descriptor provides a way
     *     to override signalName if you need, and to also provide criteria
     *     origin, state, capturing, etc. which further restrict when the
     *     handler should be matched for use with a signal.
     * @param {String|TP.lang.RootObject.Type} signalName The signal or type
     *     this handler will respond to. NOTE that this value can be ignored
     *     completed if you provide a 'signal' key in the descriptor.
     * @param {Function} aHandler The function body for the event handler.
     * @param {String|Object} descriptor The 'descriptor' parameter can be
     *     either a simple String denoting signal name or a property descriptor.
     *     That property descriptor should be a plain JS object containing one
     *     or more of the following properties:
     *          signal (TIBET type or String signal name)
     *          origin (object or String id)
     *          state (String state name)
     *          phase (TP.CAPTURING, TP.AT_TARGET, TP.BUBBLING (default)).
     * @returns {Function} The newly defined handler method.
     */

    var name,
        desc;

    if (!TP.isFunction(aHandler)) {
        return this.raise('InvalidFunction');
    }

    if (TP.isValid(aDescriptor)) {

        if (TP.isTrue(aDescriptor)) {
            TP.warn('Deprecated API. Use a descriptor object for capture flag.');
            desc = {
                phase: TP.CAPTURING
            };
        } else if (!TP.isPlainObject(aDescriptor)) {
            return this.raise('InvalidDescriptor');
        } else {
            desc = aDescriptor;
        }

        //  Map over signalName as signal key if missing. Otherwise note that
        //  the signalName value is essentially discarded.
        if (TP.notValid(desc.signal)) {
            desc.signal = signalName;
        }

        //  Support 'capturing: true' shortcut in descriptor.
        if (TP.isTrue(desc.capturing)) {
            desc.phase = TP.CAPTURING;
        }

        name = TP.composeHandlerName(desc);

    } else if (TP.isString(signalName)) {
        desc = {
            signal: signalName
        };
        name = TP.composeHandlerName(signalName);
    } else {
        desc = {
            signal: signalName
        };
        name = TP.composeHandlerName(desc);
    }

    //  Simple method definition once we have a normalized handler name. Note
    //  however that we need to pass a special flag to keep defineMethod from
    //  whining about us defining a method starting with 'handle'.
    //  NOTE that we pass the descriptor along to defineMethod in case it has
    //  other keys of interest to that method such as patchCallee.
    return this.defineMethod(name, aHandler, desc, null, true);
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('fireNextSignal',
function() {

    /**
     * @method fireNextSignal
     * @summary Activates (fires) the next signal in the signal queue.
     * @description This method is called on kernel finalization and by the
     *     signal call as it completes each signal, forming a kind of event loop
     *     which terminates when no pending signals exist.
     */

    var it;

    it = TP.sys.$signalQueue.shift();

    if (TP.notValid(it)) {
        return;
    }

    return TP.signal(it.at(0), it.at(1), it.at(2), it.at(3), it.at(4));
});

//  ------------------------------------------------------------------------
//  SIGNALING ORIGINS
//  ------------------------------------------------------------------------

/**
 * Since the signaling system can take lists of origins and signals it's
 * necessary to provide a way to distinguish arrays passed as the actual origin
 * from arrays passed as a set of origins. The default is that any array passed
 * is assumed to be the actual origin. You must use the isOriginSet() method to
 * flag any array containing a list of origins prior to signaling with it.
 */

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('isOriginSet',
function(aFlag) {

    /**
     * @method isOriginSet
     * @summary Returns true if the receiver has been flagged as a signal
     *     origin set. If aFlag is provided it will set this value.
     * @param {Boolean} aFlag True if the receiver should be treated as a list
     *     of origins and not the actual origin itself.
     * @returns {Boolean} Whether or not the receiving Array has been set to be
     *     an origin set.
     */

    if (TP.isDefined(aFlag)) {
        this.$isOriginSet = aFlag;
    }

    return this.$isOriginSet;
});

//  ------------------------------------------------------------------------
//  REFLECTION - PART II (PostPatch)
//  ------------------------------------------------------------------------

/**
 * TIBET, and in particular the TIBET IDE, relies on reflection of both type and
 * instance properties. The methods here support 'prototype-based'reflection by
 * tracking data and testing differences between a target object and an
 * appropriate prototype.
 */

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('$getInstPropertyScope',
function(aName) {

    /**
     * @method $getInstPropertyScope
     * @summary Returns the 'scope' of the named property.
     * @description Note that this version of this method is invoked for
     *     instances which are not types or prototypes, so this won't be used
     *     by TP.ObjectProto, TP.FunctionProto, or any of the prototypes created
     *     by TIBET.
     * @param {String} aName The property to check.
     * @returns {String} TP.INTRODUCED, TP.INHERITED, TP.OVERRIDDEN, TP.LOCAL
     */

    var proto,
        scope;

    proto = this.getPrototype();

    //  If the receiver and its prototype are the same object then we're looping
    //  back on ourselves near the top of the tree. In this case we have to
    //  "jump" past the prototype and check against TP.ObjectProto since we
    //  can't tell anything more from the inheritance chain from here.
    if (this === proto) {
        proto = TP.ObjectProto;
    }

    //  First check is does our prototype have this property or not? If not then
    //  it must be local to the current instance since we know we have it and
    //  it's not a DNU if we're in this routine.
    if (TP.notDefined(proto[aName]) || TP.$$isDNU(proto[aName])) {
        return TP.LOCAL;
    }

    //  at this stage we know:
    //      a) we have the slot,
    //      b) it's not a DNU,
    //      c) we're not looping between our prototype and ourselves.

    //  If we have our own value, we override since our prototype has a value
    //  which apparently isn't ours.
    if (TP.owns(this, aName)) {
        return TP.LOCAL;
    }

    //  So now we a) have a slot, b) that's not a DNU, c) that we inherit
    //  from our prototype...but does our prototype introduce it or inherit
    //  it from further up the chain?
    scope = proto.$getPrototypePropertyScope(aName);

    return scope;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('$getPrototypePropertyScope',
function(aName) {

    /**
     * @method $getPrototypePropertyScope
     * @summary Returns the 'scope' of the named property.
     * @description Note that this version of this method is invoked for
     *     objects which are used as prototypes.
     * @param {String} aName The property to check.
     * @returns {String} TP.INTRODUCED, TP.INHERITED, TP.OVERRIDDEN
     */

    //  The only options here are introduced, inherited or overridden since we
    //  act as a prototype and can't have a local definition per se.

    var proto,
        slot;

    //  The ultimate prototype, if this object has the value then it's
    //  "introduced" here.
    if (this === TP.ObjectProto) {
        return TP.INTRODUCED;
    }

    //  The other "special" prototype, particularly for native types. But
    //  here we have to be a bit smarter to maintain our illusion since we
    //  want to recognize that this object has two roles, one as an instance
    //  prototype and one as the location for Object type functionality.
    if (this === TP.FunctionProto) {
        if (TP.owns(this, aName)) {
            //  introduced or overridden based on TP.ObjectProto value
            if (TP.owns(TP.ObjectProto, aName)) {
                return TP.OVERRIDDEN;
            } else {
                //  Here's the tricky part, where we "introduce" this but
                //  want to deny that for "Type" functionality

                //  If it's a method we can check the track, if it's on the
                //  Type track it's really being "inherited" as if it were
                //  introduced on Object.
                if (TP.isMethod(slot = this[aName])) {
                    if (slot[TP.TRACK] === TP.TYPE_TRACK) {

                        //  as far as all native types (including Function)
                        //  are concerned we inherit this from Object...
                        return TP.INHERITED;
                    }
                }

                return TP.INTRODUCED;
            }
        }

        return TP.INHERITED;
    }

    //  some other prototype instance, either on a native type or a TIBET
    //  type...so we need to look at our own prototype to know if we
    //  inherit, introduce, or override this value
    proto = this.getPrototype();

    //  don't forget that some prototype chains loop and when that happens
    //  we have to switch to checking against TP.ObjectProto
    if (this === proto) {
        proto = TP.ObjectProto;
    }

    //  we're not the same as our prototype, so if it doesn't have the value
    //  then we're introducing it at this level
    if (TP.notDefined(proto[aName]) || TP.$$isDNU(proto[aName])) {
        return TP.INTRODUCED;
    }

    //  if we have our own value we override since our prototype has a value
    //  which apparently isn't ours
    if (TP.owns(this, aName)) {
        return TP.OVERRIDDEN;
    }

    return TP.INHERITED;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('$getTypePropertyScope',
function(aName) {

    /**
     * @method $getTypePropertyScope
     * @summary Returns the 'scope' of the named property.
     * @description Note that this version of this method is invoked for
     *     function instances which are native types, meaning they are types
     *     created via native JavaScript semantics. These are special in that
     *     they have a unique inheritance chain they all inherit from the same
     *     instance, TP.FunctionProto.
     * @param {String} aName The property to check.
     * @returns {String} TP.INHERITED, TP.OVERRIDDEN, TP.LOCAL.
     */

    var proto;

    //  All type objects invoking this method live in JavaScript's flat
    //  'hierarchy' for types, meaning they all share TP.FunctionProto.
    proto = TP.FunctionProto;

    //  Next question is simply does the receiving Type has its own slot?
    if (TP.owns(this, aName)) {

        //  If the value is the same between TP.FunctionProto and ourself - we
        //  inherited this value.
        if (this[aName] === proto[aName]) {
            return TP.INHERITED;
        }

        //  The values were different... if TP.FunctionProto had a value,
        //  then we overrode this slot.
        if (TP.isDefined(proto[aName])) {
            return TP.OVERRIDDEN;
        }

        //  The value was different and the proto didn't have a slot named that,
        //  therefore, it's always 'introduced' (i.e. types don't inherit *on
        //  the type side* in regular JavaScript - they're always 'locally
        //  programmed' with their behavior). Note that they *do* inherit (from
        //  TP.FunctionProto) on the instance side.
        return TP.LOCAL;
    }

    return TP.INHERITED;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('$getTypePropertyScope',
function(aName) {

    /**
     * @method $getTypePropertyScope
     * @summary Returns the 'scope' of the named property.
     * @description Note that this version of this method is invoked for TIBET
     *     type objects only; the native types will invoke the version on
     *     TP.FunctionProto. These objects are TIBET type objects, meaning they
     *     have the strange duality of being both a type and an instance in
     *     TIBET terms.
     * @param {String} aName The property to check.
     * @returns {String} TP.INTRODUCED, TP.INHERITED, TP.OVERRIDDEN, TP.LOCAL.
     */

    var proto,
        ancestor;

    //  start with proto for the "instance" to check for locals
    proto = this.getPrototype();

    //  First check is does our prototype have this property or not? If not
    //  then it must be local to the current type object since we know we have
    //  it and it's not a DNU if we're in this routine.
    if (TP.notDefined(proto[aName]) || TP.$$isDNU(proto[aName])) {
        return TP.LOCAL;
    }

    //  at this stage we know:
    //      a) we have the slot,
    //      b) it's not a DNU,
    //      c) we're not looping between our prototype and ourselves.

    //  If we have our own value we override since our prototype has a value
    //  which apparently isn't ours.
    if (TP.owns(this, aName)) {
        return TP.LOCAL;
    }

    ancestor = this.getSupertype();

    //  Any remaining checks have to compare between our prototype's value
    //  and our supertype's value for this property since TIBET types have
    //  a slightly modified lookup model.
    if (proto[aName] === ancestor[aName]) {
        return TP.INHERITED;
    } else {
        if (TP.isDefined(ancestor[aName])) {
            return TP.OVERRIDDEN;
        } else {
            return TP.INTRODUCED;
        }
    }
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getPropertyScope',
function(aName, skipChecks) {

    /**
     * @method getPropertyScope
     * @summary Returns the 'scope' of the named property. The scope returned
     *     will be one of the get*Interface() constants such as TP.DNU,
     *     TP.INTRODUCED, TP.INHERITED, TP.OVERRIDDEN, TP.LOCAL, TP.GLOBAL, or
     *     TP.NONE. Note that this method leverages a number of more primitive
     *     methods to help it discriminate relative to the various special
     *     objects in the system such as TP.ObjectProto etc.
     * @param {String} aName The property to check.
     * @param {Boolean} skipChecks Turns off checks for DNUs or globals, often
     *     used by get*Interface() when it knows the properties it's asking
     *     about have already been checked.
     * @returns {String} TP.DNU, TP.INTRODUCED, TP.INHERITED, TP.OVERRIDDEN,
     *     TP.LOCAL, TP.GLOBAL, or TP.NONE.
     */

    var flag;

    flag = TP.sys.shouldLogStack();
    TP.sys.shouldLogStack(false);

    try {
        if (TP.notTrue(skipChecks)) {
            //  ...do we even have this property?
            if (TP.notDefined(this[aName])) {
                return TP.NONE;
            }

            //  ...is it a DNU?
            if (TP.$$isDNU(this[aName])) {
                return TP.DNU;
            }
        }

        //  at this point we know:
        //      a) we have the property,
        //      b) it's not a DNU,
        //      c) it's not a global.

        //  the best thing to do now is to work polymorphically based on
        //  whether the receiver is a type, a prototype, or an instance...
        if (TP.isType(this)) {
            return this.$getTypePropertyScope(aName);
        } else if (TP.isPrototype(this)) {
            return this.$getPrototypePropertyScope(aName);
        } else {
            return this.$getInstPropertyScope(aName);
        }
    } finally {
        TP.sys.shouldLogStack(flag);
    }
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('$getInterface',
function(aFilter) {

    /**
     * @method $getInterface
     * @summary Returns an array containing the keys of the receiver, filtered
     *     according to a filtering specification. The valid filtering specs are
     *     listed with TP.SLOT_FILTERS, filtered to match the desired subset of
     *     keys.
     * @param {Object|String} aFilter An object containing filter properties or
     *     a name of one of the keys registered under TP.SLOT_FILTERS. The
     *     default is 'unique_methods'.
     * @returns {String[]} An array containing matching slots.
     */

    var obj,

        filter,
        params,
        attrs,
        methods,
        hidden,
        scope,
        isPublic,
        unique,
        keys,
        key,
        it,

        propScope;

        //  TODO: why don't we use this value?
        // proto;

    //  shortcut for using this method to get all keys of any kind.
    if (aFilter === 'known' || aFilter === TP.SLOT_FILTERS.known) {

        //  NB: This was written to be hyper-efficient, hence the use of native
        //  JS here.
        keys = [];

        /* eslint-disable consistent-this */

        obj = this;

        do {
            keys.push(TP.objectGetKeys(obj));
            obj = Object.getPrototypeOf(obj);
        } while (obj);

        keys = Array.prototype.concat.apply([], keys);
        keys = keys.filter(
                        function(aKey) {
                            return !TP.regex.INTERNAL_SLOT.test(aKey);
                        });

        /* eslint-enable consistent-this */

        return keys;
    }

    keys = TP.ac();

    //  next question is can we find the requested subset on the list?
    filter = TP.ifInvalid(aFilter, 'unique_methods');

    if (TP.isString(filter)) {
        filter = filter.toLowerCase();

        if (TP.notValid(params = TP.SLOT_FILTERS[filter])) {
            TP.ifWarn() ?
                TP.warn('Invalid reflection filter: ' + filter) : 0;

            return TP.ac();
        }
    } else {
        params = filter;
    }

    //  grab the control flags we'll be using down below to drive our testing...
    attrs = TP.ifInvalid(params.attributes, true);
    methods = TP.ifInvalid(params.methods, false);
    hidden = TP.ifInvalid(params.hidden, false);
    scope = TP.ifInvalid(params.scope, TP.UNIQUE);

    //  Only necessary if 'hidden' is 'true' - then, if you want both, you have
    //  to specify this one too.
    isPublic = TP.ifInvalid(params.public, false);

    //  if the filter is bogus we can just bail out
    if (!attrs && !methods) {
        TP.ifWarn() ?
            TP.warn('Invalid reflection filter: ' + filter) : 0;

        return TP.ac();
    }

    /* eslint-disable no-extra-parens */
    unique = (scope === TP.UNIQUE);
    /* eslint-enable no-extra-parens */

    if (!unique) {
        //  warn for any non-unique scans. when it's a unique scan we can
        //  leverage hasOwnProperty to avoid too much overhead, otherwise we
        //  consider this a performance warning issue.
        TP.ifWarn() && TP.sys.cfg('log.scans') ?
            TP.warn('Scanning ' + filter + ' on ' + this) : 0;
    }

    /* eslint-disable guard-for-in */
    for (key in this) {
        //  private/hidden can be masked off quickly
        if (TP.regex.PRIVATE_SLOT.test(key)) {
            if (!hidden) {
                continue;
            }
        } else {
            //  forcing to show hidden but it isn't and we're not being asked to
            //  include both hidden and public, then move on.
            if (hidden && !isPublic) {
                continue;
            }
        }

        //  ignore internals
        if (TP.regex.INTERNAL_SLOT.test(key)) {
            continue;
        }

        try {
            if (unique && !this.hasOwnProperty(key)) {
                continue;
            }
            it = this[key];
        } catch (e) {
            if (TP.isNativeType(this)) {
                //  some objects just don't like to be touched :)
                break;
            }
            continue;
        }

        //  is it real?
        if (TP.notDefined(it)) {
            continue;
        }

        //  most common failure modes for slot listings
        if (TP.$$isDNU(it)) {
            continue;
        }

        //  is it a global/window slot?
        try {
            if (window[key] === it && TP.ObjectProto[key] !== it) {
                continue;
            }
        } catch (e) {
            continue;
        }

        //  if methods are disallowed we can test for that next
        if (!methods && TP.isMethod(it)) {
            continue;
        }

        //  when attributes aren't allowed we can ensure it's a method
        if (!attrs && !TP.isMethod(it)) {
            continue;
        }

        //  so it's the right "kind" of thing, an attribute or method that
        //  is/isn't hidden as desired...now we need to know if it fits the
        //  desired scope requirements
        if (scope !== TP.ALL) {
            //  check scope, but skip over the checks
            propScope = this.getPropertyScope(key, true);
            if (scope === TP.UNIQUE) {
                //  looking for unique (introduced, local, overridden)
                if (propScope !== TP.INTRODUCED &&
                    propScope !== TP.LOCAL &&
                    propScope !== TP.OVERRIDDEN) {
                    //  must be a dnu, none, global, or inherited
                    continue;
                }
            } else if (scope !== propScope) {
                continue;
            }
        }

        //  still valid? add it to the list
        keys.push(key);
    }
    /* eslint-enable guard-for-in */

    return keys;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getInterface',
function(aFilter) {

    /**
     * @method getInterface
     * @summary Returns a list of the 'slots' on the receiver. This is what you
     *     get if you use for/in on an array rather than for() -- the properties
     *     rather than the indexes of content. See $getInterface for more
     *     information.
     * @param {Object|String} aFilter An object containing filter properties or
     *     a name of one of the keys registered under TP.SLOT_FILTERS.
     * @returns {String[]} Array of slot names matching the filter.
     */

    var inheriteds,
        locals,

        result,

        params,
        newParams,

        overriddens;

    //  If this is a type or a non-prototype instance, we get the values that we
    //  'inherit' up the tree (but dependent on the filter that's handed in).
    if (TP.isType(this)) {
        inheriteds = this.getTypeInterface(aFilter);
    } else if (TP.isPrototype(this)) {
        return this.getLocalInterface(aFilter);
    } else {
        inheriteds = this.getInstInterface(aFilter);
    }

    //  Then we grab any 'local' values on this object (again dependent on the
    //  filter).
    locals = this.getLocalInterface(aFilter);

    //  Add those to the inherited values and unique them.
    result = inheriteds.addAll(locals).unique();

    //  Check to see if we're also supposed to get TP.INHERITED slots - we'll
    //  need to get any overridden slots and make sure they get removed. This is
    //  only needed if the receiver is a native type or TP.lang.RootObject,
    //  because of the way that meta-methods get added directly to these objects
    //  prototypes.
    if (TP.isNativeType(this) || this === TP.lang.RootObject) {
        if (TP.isString(aFilter)) {
            params = TP.SLOT_FILTERS[aFilter];
        } else {
            params = aFilter;
        }

        if (TP.isValid(params) && params.scope === TP.INHERITED) {

            newParams = {};

            //  We need to query locally for the overridden slots (but with
            //  all other parameters intact) so that we can remove them from
            //  the list of 'inherited'.
            newParams.hidden = params.hidden;
            newParams.methods = params.methods;
            newParams.public = params.public;
            newParams.scope = TP.OVERRIDDEN;

            overriddens = this.getLocalInterface(newParams);
            result.removeAll(overriddens);
        }
    }

    return result;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getInstInterface',
function(aFilter) {

    /**
     * @method getInstInterface
     * @summary Returns the slot names found on instances of the receiver which
     *     match the filter provided.
     * @param {Object|String} aFilter An object containing filter properties or
     *     a name of one of the keys registered under TP.SLOT_FILTERS.
     * @returns {String[]} Array of slot names matching the filter.
     */

    var type;

    if (TP.isType(this)) {
        return this.getInstPrototype().$getInterface(aFilter);
    } else if (TP.isPrototype(this)) {
        if (/\$\$Type/.test(TP.name(this))) {
            return TP.ac();
        } else {
            return this.$getInterface(aFilter);
        }
    }

    type = this.getType();
    if (this !== type) {
        return type.getInstInterface(aFilter);
    }

    return TP.ac();
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getLocalInterface',
function(aFilter) {

    /**
     * @method getLocalInterface
     * @summary Returns the slot names found directly on the receiver which
     *     match the filter provided.
     * @param {Object|String} aFilter An object containing filter properties or
     *     a name of one of the keys registered under TP.SLOT_FILTERS.
     * @returns {String[]} Array of slot names matching the filter.
     */

    return this.$getInterface(aFilter);
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getTypeInterface',
function(aFilter) {

    /**
     * @method getTypeInterface
     * @summary Returns the slot names found on the receiver's Type which match
     *     the filter provided.
     * @param {Object|String} aFilter An object containing filter properties or
     *     a name of one of the keys registered under TP.SLOT_FILTERS.
     * @returns {String[]} Array of slot names matching the filter.
     */

    var type;

    if (TP.isType(this)) {
        return this.$getInterface(aFilter);
    } else if (TP.isPrototype(this)) {
        if (/\$\$Type/.test(TP.name(this))) {
            return this.$getInterface(aFilter);
        } else {
            return TP.ac();
        }
    }

    type = this.getType();
    if (this !== type) {
        return type.getTypeInterface(aFilter);
    }

    return TP.ac();
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getKeys',
function() {

    /**
     * @method getKeys
     * @summary Returns the set of keys requested for the receiver.
     * @returns {String[]} An array containing the keys of the receiver.
     */

    //  non-mutable things like strings etc. can't have had new keys placed
    //  on them so only process mutables.
    if (TP.isMutable(this)) {
        return TP.$getOwnKeys(this);
    }

    return TP.ac();
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('getKeys',
function() {

    /**
     * @method getKeys
     * @summary Top-level key-getter for Array instances. Returns the 'indexes'
     *     or 'keys' of the array. This version returns all keys. An interesting
     *     alternative is only returning keys whose values are non-null (see
     *     TP.core.Mask.getMasks() for an example).
     * @returns {String[]} An array containing the keys of the receiver.
     */

    var tmparr;

    tmparr = TP.$getOwnKeys(this);

    return tmparr.concat(TP.sys.$arraykeys);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('getKeys',
function() {

    /**
     * @method getKeys
     * @summary Returns the set of keys which represent attribute values for
     *     the receiver. This is supported on String to allow it to behave as a
     *     collection of characters.
     * @returns {String[]} An array containing the keys of the receiver.
     */

    var i,
        tmparr;

    tmparr = TP.ac();
    for (i = 0; i < this.length; i++) {
        tmparr.push(i);
    }

    return tmparr.concat(TP.sys.$stringkeys);
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getSize',
function() {

    /**
     * @method getSize
     * @summary Returns the size of the receiver. This is thought of as the
     *     number of attributes the receiver contains unless a different filter
     *     is provided.
     * @returns {Number} The receiver's size.
     */

    var k,
        res;

    k = this.getKeys();
    res = k.getSize();

    return res;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('getSize',
function() {

    /**
     * @method getSize
     * @summary Returns the size of the receiver. For simple strings this is
     *     the length.
     * @returns {Number} The receiver's size.
     */

    return this.length;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getValues',
function() {

    /**
     * @method getValues
     * @summary Returns an array containing the values for the objects'
     *     attributes.
     * @returns {Object[]} An array of the values for the receiver's keys.
     */

    var arr,
        i,
        k;

    arr = TP.ac();
    k = this.getKeys();

    for (i = 0; i < k.getSize(); i++) {
        arr.push(this.at(k.at(i)));
    }

    return arr;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('getValues',
function() {

    /**
     * @method getValues
     * @summary Top-level value-getter. For Arrays the values are contained in
     *     the array itself.
     * @returns {Object[]} An array containing the receiver's values.
     */

    return this;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('getValues',
function() {

    /**
     * @method getValues
     * @summary Returns an array containing the characters in the receiver.
     * @returns {String[]} An array of characters.
     */

    return this.split('');
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('hasKey',
function(aKey) {

    /**
     * @method hasKey
     * @summary Returns true if aKey has been defined for the receiver. This is
     *     analagous to hasOwnProperty for most non-collection types but is
     *     overridden by collections.
     * @param {String} aKey The string key to test for.
     * @returns {Boolean} True if the key is defined.
     */

    return this.hasOwnProperty(aKey);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('hasKey',
function(aKey, includeUndefined) {

    /**
     * @method hasKey
     * @summary Returns true if aKey has been defined for the receiver. For an
     *     array there are a couple of ways to look at this. First is whether
     *     the key must be a number. For object comparison reasons we don't
     *     enforce this. Second is whether we should consider 'sparse locations'
     *     to exist (they don't by default so use includeUndefined to confirm).
     * @param {Number} aKey The index (key) to test.
     * @param {Boolean} includeUndefined Should 'sparse' slots be included?
     * @returns {Boolean} True if the key is defined.
     */

    var includeUndef;

    if (TP.isNumber(aKey)) {
        if (this.length < aKey) {
            return false;
        }
    }

    includeUndef = TP.ifInvalid(includeUndefined, false);
    if (includeUndef) {
        return true;
    }

    return TP.isDefined(this[aKey]);
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('inherits',
function(aName) {

    /**
     * @method inherits
     * @summary Returns true if the name represents an inherited property of
     *     the receiver.
     * @param {String} aName The property name to check.
     * @returns {Boolean} Whether or not the property is an inherited property.
     */

    return this.getPropertyScope(aName) === TP.INHERITED;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('inheritsFromIntroducer',
function(aName) {

    /**
     * @method inheritsFromIntroducer
     * @summary Returns true if the name represents an inherited property of
     *     the receiver that isn't altered between the original introducer and
     *     the receiver.
     * @param {String} aName The property name to check.
     * @returns {Boolean} Whether or not the property is an inherited property
     *     that has the same value as the object that introduced it.
     */

    var res,
        scope,
        protos;

    scope = this.getPropertyScope(aName);
    if (scope !== TP.INHERITED) {
        return false;
    }

    protos = this.getPrototypes();
    res = protos.detect(
        function(item) {

            return item.getPropertyScope(aName) === TP.OVERRIDDEN;
        });

    //  if no overrides were found the answer is 'true'
    return TP.notValid(res);
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('introduces',
function(aName) {

    /**
     * @method introduces
     * @summary Returns true if the name represents an introduced property of
     *     the receiver.
     * @param {String} aName The property name to check.
     * @returns {Boolean} Whether or not the property was introduced by the
     *     receiver.
     */

    return this.getPropertyScope(aName) === TP.INTRODUCED;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('isEmpty',
function(aFilterName) {

    /**
     * @method isEmpty
     * @summary Returns whether or not the receiver is considered 'empty'.
     * @description At this level, this uses the number of attributes the
     *     receiver contains unless a different filter is provided and compares
     *     the size of that to 0.
     * @param {String} aFilterName A get*Interface() filter.
     * @returns {Boolean} Whether or not the receiver is empty.
     */

    return this.getSize() === 0;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('isEmpty',
function() {

    /**
     * @method isEmpty
     * @summary Returns whether or not the receiver is considered 'empty'.
     * @returns {Boolean} Whether or not the receiver is empty.
     */

    return this.length === 0;
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('isEmpty',
function() {

    /**
     * @method isEmpty
     * @summary Returns whether or not the receiver is considered 'empty'.
     * @returns {Boolean} Whether or not the receiver is empty.
     */

    return this.toString().length === 0;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('isEmpty',
function() {

    /**
     * @method isEmpty
     * @summary Returns whether or not the receiver is considered 'empty'.
     * @returns {Boolean} Whether or not the receiver is empty.
     */

    return this.length === 0;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('overrides',
function(aName) {

    /**
     * @method overrides
     * @summary Returns true if the name represents an overridden property of
     *     the receiver.
     * @param {String} aName The property name to check.
     * @returns {Boolean} Whether or not the property was overridden by the
     *     receiver.
     */

    return this.getPropertyScope(aName) === TP.OVERRIDDEN;
});

//  ------------------------------------------------------------------------
//  ORDERED PAIRS
//  ------------------------------------------------------------------------

/**
 * TIBET's hash operation and many other operations which convert between
 * objects and arrays make use of what we refer to as ordered pairs. These are
 * analogous to Smalltalk's Association type. The first() item in an ordered
 * pair is the key while the last() item is the value at that key. When
 * operations are performed on objects used as hashes the individual items
 * being iterated over are actually ordered pairs.
 */

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('$$isPair',
function() {

    /**
     * @method $$isPair
     * @summary Returns true if the object is considered an ordered pair.
     *     Objects (and TP.core.Hashes) are never considered ordered pairs.
     * @returns {Boolean} Whether or not the receiver is considered to be an
     *     ordered pair.
     */

    return false;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('$$isPair',
function() {

    /**
     * @method $$isPair
     * @summary Returns true if the receiver can be thought of as an ordered
     *     pair.
     * @description For arrays an ordered pair is a two-element array, however
     *     an array whose 'key' i.e. the first() element is null will not be
     *     considered a valid pair.
     * @returns {Boolean} Whether or not the receiver is considered to be an
     *     ordered pair.
     */

    /* eslint-disable no-extra-parens */
    return (this.getSize() === 2) && TP.isValid(this.at(0));
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('first',
function(aNumber) {

    /**
     * @method first
     * @summary Returns the first N items from the receiver, where N defaults
     *     to 1.
     * @description This method only returns consistent results on ordered
     *     collections, but it should always successfully return N items if
     *     they're available.
     * @param {Number} aNumber The number of items to return. When N is greater
     *     than 1 the return value is a new array.
     * @returns {Object} When N is 1 the result is an array of length 2 with key
     *     and value in positions 0 and 1. When N is greater than 1 the return
     *     value is an array containing N ordered pairs of this form.
     */

    //  work from item set when more than one item is being requested
    if (TP.isNumber(aNumber) && aNumber > 1) {
        return this.getItems().first(aNumber);
    }

    //  terminate search after finding one item of any kind
    return this.detect(TP.RETURN_TRUE);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('first',
function(aNumber) {

    /**
     * @method first
     * @summary Returns the first N items of the receiver, where N defaults to
     *     1.
     * @param {Number} aNumber The number of items to return. When N is greater
     *     than 1 the return value is a new array.
     * @exception TP.sig.InvalidIndex
     * @returns {Object} The first N items in this array.
     */

    this.$sortIfNeeded();

    if (TP.isNumber(aNumber) && aNumber > 1) {
        return this.slice(0, aNumber);
    }

    /* eslint-disable no-extra-parens */
    return (this.length > 0) ? this.at(0) : null;
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('first',
function(aNumber) {

    /**
     * @method first
     * @summary Returns the first N characters of the receiver, where N
     *     defaults to 1.
     * @param {Number} aNumber The number of characters to return. When N is
     *     greater than 1 the return value is a string with that length (if
     *     enough characters are available).
     * @returns {Object} The first N characters in the string.
     */

    if (TP.isNumber(aNumber) && aNumber > 1) {
        return this.slice(0, aNumber);
    }

    /* eslint-disable no-extra-parens */
    return (this.length > 0) ? this.charAt(0) : null;
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('last',
function(aNumber) {

    /**
     * @method last
     * @summary Returns the last N items from the receiver, where N defaults to
     *     1.
     * @description This method only returns consistent results on ordered
     *     collections, but it should always successfully return N items if
     *     they're available.
     * @param {Number} aNumber The number of items to return. When N is greater
     *     than 1 the return value is a new array.
     * @returns {Object} When N is 1 the result is an array of length 2 with key
     *     and value in positions 0 and 1. When N is greater than 1 the return
     *     value is an array containing N ordered pairs of this form.
     */

    //  work from item set when more than one item is being requested
    if (TP.isNumber(aNumber) && aNumber > 1) {
        return this.getItems().last(aNumber);
    }

    //  terminate search after finding one item of any kind
    return this.detect(TP.RETURN_TRUE, null, true);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('last',
function(aNumber) {

    /**
     * @method last
     * @summary Returns the last N items of the receiver, where N defaults to
     *     1.
     * @param {Number} aNumber The number of items to return. When N is greater
     *     than 1 the return value is a new array.
     * @exception TP.sig.InvalidIndex
     * @returns {Object} The last N items in this array.
     */

    this.$sortIfNeeded();

    if (TP.isNumber(aNumber) && aNumber > 1) {
        return this.slice(this.length - aNumber);
    }

    /* eslint-disable no-extra-parens */
    return (this.length > 0) ? this.at(this.length - 1) : null;
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('last',
function(aNumber) {

    /**
     * @method last
     * @summary Considering the number as a range this returns the last index in
     *     that range.
     * @param {Number} aNumber The number of items to return. When N is greater
     *     than 1 the return value is a new array. Ignored for this type.
     * @exception TP.sig.InvalidIndex
     * @returns {Object} The last index.
     */

    if (this > 0) {
        return this - 1;
    } else {
        return 0;
    }
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('last',
function(aNumber) {

    /**
     * @method last
     * @summary Returns the last N characters of the receiver, where N defaults
     *     to 1.
     * @param {Number} aNumber The number of characters to return. When N is
     *     greater than 1 the return value is a string with that length (if
     *     enough characters are available).
     * @returns {Object} The last N characters in the string.
     */

    if (TP.isNumber(aNumber) && aNumber > 1) {
        return this.slice(this.length - aNumber);
    }

    /* eslint-disable no-extra-parens */
    return (this.length > 0) ? this.at(this.length - 1) : null;
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getKVPairs',
function(aSelectFunction) {

    /**
     * @method getKVPairs
     * @summary Returns an array of ordered pairs generated from the receiver.
     *     The individual pairs are [key,value] arrays where the keys are
     *     filtered using the optional function provided.
     * @param {Function} aSelectFunction A function used to select items that
     *     will be returned. Each item is passed to this function and if the
     *     function returns true the item is included in the result.
     * @exception TP.sig.InvalidPairRequest
     * @returns {Object[]} The array of ordered pairs.
     */

    //  if we can provide keys and do an 'at' then we can get pairs
    if (!TP.canInvokeInterface(this, ['at', 'getKeys'])) {
        return this.raise('TP.sig.InvalidPairRequest');
    }

    //  the work is easy for key/value objects
    return this.select(aSelectFunction || TP.RETURN_TRUE);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('getKVPairs',
function(aSelectFunction) {

    /**
     * @method getKVPairs
     * @summary Returns the key/value pairs contained in the receiver.
     * @description For Arrays this returns an array of ordered pairs where each
     *     ordered pair consists of a numerical index and the value at that
     *     index. This is a more "inspection string" format used specifically
     *     for dumping key/value data.
     * @param {Function} aSelectFunction A function used to select items that
     *     will be returned. Each item is passed to this function and if the
     *     function returns true the item is included in the result.
     * @returns {Object[]} A new array containing the pairs.
     */

    var tmparr,
        func,
        len,
        i,
        item;

    tmparr = TP.ac();

    if (TP.isCallable(aSelectFunction)) {
        func = aSelectFunction;
    } else {
        return Object.entries(this).filter(
                function(entry) {
                    return !TP.regex.INTERNAL_SLOT.test(entry[0]);
                });
    }

    len = this.getSize();
    for (i = 0; i < len; i++) {
        item = TP.ac(i.toString(), this.at(i));

        //  if we've got a filtering function and it doesn't return
        //  true then we'll skip this entry
        if (!func(item)) {
            continue;
        }

        tmparr.push(item);
    }

    return tmparr;
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('getKVPairs',
function(aSelectFunction) {

    /**
     * @method getKVPairs
     * @summary Returns the key/value pairs contained in the receiver.
     * @description For Arrays this returns an array of ordered pairs where each
     *     ordered pair consists of a numerical index and the value at that
     *     index. This is a more "inspection string" format used specifically
     *     for dumping key/value data.
     * @param {Function} aSelectFunction A function used to select items that
     *     will be returned. Each item is passed to this function and if the
     *     function returns true the item is included in the result.
     * @returns {Array|null} For Numbers, this returns an Array as selected by
     *     the selection function or an empty Array if no selection function is
     *     provided.
     */

    var tmparr,
        func,
        str,
        len,
        i,
        item;

    tmparr = TP.ac();

    if (TP.isCallable(aSelectFunction)) {
        func = aSelectFunction;
    } else {
        return Object.entries(this);
    }

    str = TP.str(this);
    len = str.getSize();
    for (i = 0; i < len; i++) {
        item = TP.ac(i.toString(), str.at(i));

        //  if we've got a filtering function and it doesn't return
        //  true then we'll skip this entry
        if (!func(item)) {
            continue;
        }

        tmparr.push(item);
    }

    return tmparr;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('getKVPairs',
function(aSelectFunction) {

    /**
     * @method getKVPairs
     * @summary Returns the key/value pairs contained in the receiver.
     * @description For Strings this returns an array of ordered pairs where
     *     each ordered pair consists of a numerical index and the value at that
     *     index. This is a more "inspection string" format used specifically
     *     for dumping key/value data.
     * @param {Function} aSelectFunction A function used to select items that
     *     will be returned. Each item is passed to this function and if the
     *     function returns true the item is included in the result.
     * @returns {Object[]} A new array containing the pairs.
     */

    var tmparr,
        func,
        len,
        i,
        item;

    tmparr = TP.ac();

    if (TP.isCallable(aSelectFunction)) {
        func = aSelectFunction;
    } else {
        return Object.entries(this);
    }

    len = this.getSize();
    for (i = 0; i < len; i++) {
        item = TP.ac(i.toString(), this.at(i));

        //  if we've got a filtering function and it doesn't return
        //  true then we'll skip this entry
        if (!func(item)) {
            continue;
        }

        tmparr.push(item);
    }

    return tmparr;
});

//  ------------------------------------------------------------------------
//  Inspection
//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} The receiver's dump String representation.
     */

    var marker,
        arr,
        keys,
        len,
        i,
        val,
        str,
        $depth,
        $level;

    if (TP.isWindow(this)) {
        return '[' + TP.tname(this) + ' :: ' + TP.windowAsString(this) + ']';
    }

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asDumpString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }

    //  NB: For 'Object', we put this in a try...catch since some native Objects
    //  (i.e. XHR objects) don't like to have slots placed on them.
    try {
        this[marker] = true;
    } catch (e) {
        void 0;
    }

    /* eslint-disable no-array-constructor */
    arr = new Array();
    /* eslint-enable no-array-constructor */

    str = '[' + TP.tname(this) + ' :: ';

    $depth = TP.ifInvalid(depth, 1);
    $level = TP.ifInvalid(level, 0);

    try {
        keys = TP.$getOwnKeys(this);
        len = keys.length;

        for (i = 0; i < len; i++) {

            val = this[keys.at(i)];

            if (val === this) {
                if (TP.canInvoke(val, 'asRecursionString')) {
                    arr.push(keys[i] + ': ' + val.asRecursionString());
                } else {
                    arr.push(keys[i] + ': ' + 'this');
                }
            } else {
                if ($level > $depth && TP.isMutable(this)) {
                    if (TP.isReferenceType(this)) {
                        arr.push(keys[i] + ': ' +
                            '@' + TP.id(this) + ']');
                    } else {
                        arr.push(keys[i] + ': ' +
                            TP.str(this) + ']');
                    }
                } else {
                    arr.push(keys[i] + ': ' + TP.dump(this[keys[i]],
                        $depth, $level + 1));
                }
            }
        }

        str += '(' + arr.join(', ') + ')' + ']';
    } catch (e) {
        str += '(' + TP.str(this) + ')' + ']';
    } finally {
        try {
            delete this[marker];
        } catch (e) {
            void 0;
        }
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} The receiver's 'pretty print' String representation.
     */

    var marker,
        arr,
        keys,
        len,
        i,
        str;

    if (TP.isWindow(this)) {
        return TP.tname(this) + ' :: ' + TP.windowAsString(this);
    }

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asPrettyString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }

    //  Set the recursion flag so that we don't endless recurse when
    //  producing circular representations of this object and its members.
    //  NB: For 'Object', we put this in a try...catch since some native Objects
    //  (i.e. XHR objects) don't like to have slots placed on them.
    try {
        this[marker] = true;
    } catch (e) {
        void 0;
    }

    /* eslint-disable no-array-constructor */
    arr = new Array();
    /* eslint-enable no-array-constructor */

    try {
        keys = TP.$getOwnKeys(this);
        len = keys.length;

        for (i = 0; i < len; i++) {
            arr.push(
                TP.join('<dt class="pretty key">', keys[i], '</dt>',
                        '<dd class="pretty value">',
                            TP.pretty(this[keys[i]]),
                        '</dd>'));
        }

        str = '<dl class="pretty">' + arr.join(', ') + '</dl>';
    } catch (e) {
        str = this.toString();
    } finally {
        try {
            delete this[marker];
        } catch (e) {
            void 0;
        }
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('asRecursionString',
function() {

    /**
     * @method asRecursionString
     * @summary Returns a string representation of the receiver which is used
     *     when the receiver is encountered in a circularly referenced manner
     *     during the production of some sort of formatted String
     *     representation.
     * @returns {String}
     */

    var id;

    id = TP.gid(this);

    if (TP.sys.cfg('debug.register_recursion')) {
        //  If the ID isn't a URI (even one without a scheme), then make it a
        //  TIBET URN and set the content.
        if (!TP.isURIString(id, true)) {
            id = 'urn:tibet:' + id;
            TP.uc(id).setResource(this);
        }
        return id;
    }

    return '@' + id;
});

//  ------------------------------------------------------------------------
//  NOTIFICATION - PART II
//  ------------------------------------------------------------------------

/**
 * More signaling support. In particular, the working versions of the change
 * notification methods.
 */

//  ------------------------------------------------------------------------

TP.$changed = function(anAspect, anAction, aDescription) {

    /**
     * @method $changed
     * @summary Notifies observers that some aspect of the receiver has
     *     changed. The fundamental data-driven dependency method.
     * @description If 'anAspect' is provided then the signal fired will be
     *     'aspectChange' where 'aspect' is replaced with the title-case aspect
     *     value. For example, if the aspect is 'lastname' the signal will be:
     *
     *     LastnameChange
     *
     *     This allows observers to be very discriminating in their
     *     observations...down to a specific slot on an object rather than the
     *     entire object. When the aspect is a number the signal name is
     *     prefixed with 'Index' so an aspect of 1 would result in an
     *     Index1Change signal. This signal is handled as a special instance of
     *     IndexChange.
     *
     *     NOTE: if the receiver's shouldSignalChange() method returns false
     *     this method won't fire a signal. This helps to avoid signaling when
     *     no listeners are present. See the shouldSignalChange() method for
     *     more information. Observation of an object for any signal name
     *     containing 'Change' will activate this flag.
     * @param {String} anAspect The aspect of the receiver that changed. This is
     *     usually an attribute name.
     * @param {String} anAction The action which caused the change. This usually
     *     'add', 'remove', etc.
     * @param {TP.core.Hash} aDescription A hash describing details of the
     *     change.
     * @returns {Object} The receiver.
     * @fires Change
     */

    var sig,
        asp,
        desc,

        baseSignalType;

    //  If this method is invoked before signaling is ready then exit.
    if (!TP.sys.hasInitialized()) {
        return this;
    }

    //  Build up the signal name we'll be firing.
    sig = 'Change';
    asp = TP.ifKeyInvalid(aDescription, 'aspect', anAspect) || 'value';

    if (asp === 'value') {
        sig = 'TP.sig.ValueChange';
    } else {
        sig = TP.makeStartUpper(asp.toString()) + sig;
    }

    //  Convert nChange to IndexNChange signals.
    if (/^[0-9]+/.test(sig)) {
        sig = 'Index' + sig;
    }

    //  Build up a standard form for the description hash.
    desc = TP.isValid(aDescription) ? aDescription : TP.hc();
    if (!TP.canInvoke(desc, 'atPutIfAbsent')) {
        this.raise('TP.sig.InvalidParameter',
                    'Description not a collection.');

        return this;
    }
    desc.atPutIfAbsent('aspect', asp);
    desc.atPutIfAbsent('action', anAction || TP.UPDATE);
    desc.atPutIfAbsent('facet', 'value');
    desc.atPutIfAbsent('target', this);

    baseSignalType = TP.ifInvalid(desc.at('baseSignalType'),
                                    TP.sig.FacetChange);

    //  Fire the signal. Note that we force the firing policy here. This allows
    //  observers of a generic Change to see 'aspect'Change notifications, even
    //  if those 'aspect'Change signals haven't been defined as being subtypes
    //  of Change (although we also supply 'TP.sig.ValueChange' as the default
    //  signal type here so that undefined aspect signals will use that type).
    TP.signal(this, sig, desc, TP.INHERITANCE_FIRING, baseSignalType);

    return this;
};

TP.defineMetaInstMethod('$changed', TP.$changed);
TP.sys.$changed = TP.$changed;

//  ------------------------------------------------------------------------

TP.changed = function(anAspect, anAction, aDescription) {

    /**
     * @method changed
     * @summary Notifies observers that some aspect of the receiver has
     *     changed. The fundamental data-driven dependency method.
     * @description If 'anAspect' is provided then the signal fired will be
     *     'aspectChange' where 'aspect' is replaced with the title-case aspect
     *     value. For example, if the aspect is 'lastname' the signal will be:
     *
     *     LastnameChange
     *
     *     This allows observers to be very discriminating in their
     *     observations...down to a specific slot on an object rather than the
     *     entire object. When the aspect is a number the signal name is
     *     prefixed with 'Index' so an aspect of 1 would result in an
     *     Index1Change signal.
     *
     *     NOTE: if the receiver's shouldSignalChange() method returns false
     *     this method won't fire a signal. This helps to avoid signaling when
     *     no listeners are present. See the shouldSignalChange() method for
     *     more information. Observation of an object for any signal name
     *     containing 'Change' will activate this flag.
     * @param {String} anAspect The aspect of the receiver that changed. This is
     *     usually an attribute name.
     * @param {String} anAction The action which caused the change. This usually
     *     'add', 'remove', etc.
     * @param {TP.core.Hash} aDescription A hash describing details of the
     *     change.
     * @returns {Object} The receiver.
     * @fires Change
     */

    //  NB: For new objects, this relies on 'undefined' being a 'falsey' value.
    //  We don't normally do this in TIBET, but this method is used heavily and
    //  is a hotspot.
    if (!this.shouldSignalChange()) {
        return this;
    }

    return this.$changed(anAspect, anAction, aDescription);
};

TP.defineMetaInstMethod('changed', TP.changed);
TP.sys.changed = TP.changed;

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('changed',
function(anAspect, anAction, aDescription) {

    /**
     * @method changed
     * @summary Notifies observers that some aspect of the receiver has
     *     changed. The fundamental data-driven dependency method.
     * @description If 'anAspect' is provided then the signal fired will be
     *     'aspectChange' where 'aspect' is replaced with the title-case aspect
     *     value. For example, if the aspect is 'lastname' the signal will be:
     *
     *     LastnameChange
     *
     *     This allows observers to be very discriminating in their
     *     observations...down to a specific slot on an object rather than the
     *     entire object. When the aspect is a number the signal name is
     *     prefixed with "Index" so an aspect of 1 would result in an
     *     Index1Change signal.
     * @param {String} anAspect The aspect of the receiver that changed. This is
     *     usually an attribute name.
     * @param {String} anAction The action which caused the change. This usually
     *     'add', 'remove', etc.
     * @param {TP.core.Hash} aDescription A hash describing details of the
     *     change.
     * @returns {Array} The receiver.
     * @fires Change
     */

    //  NB: For new objects, this relies on 'undefined' being a 'falsey' value.
    //  We don't normally do this in TIBET, but this method is used heavily and
    //  is a hotspot.
    if (!this.shouldSignalChange()) {
        return this;
    }

    //  might need to sort on next get()
    this.$needsSort = true;

    return this.$changed(anAspect, anAction, aDescription);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('changed',
function(anAspect, anAction, aDescription) {

    /**
     * @method changed
     * @summary Uses the receiving string as a ID and constructs an appropriate
     *     Change notification signal for that ID. See the discussion on
     *     TP.ObjectProto.changed for more info.
     * @param {String} anAspect The aspect of the receiver that changed. This is
     *     usually an attribute name.
     * @param {String} anAction The action which caused the change. This usually
     *     'add', 'remove', etc.
     * @param {TP.core.Hash} aDescription A hash describing details of the
     *     change.
     * @returns {String} The receiver.
     * @fires Change
     */

    var target,
        asp,
        sig,
        desc;

    //  If this method is invoked before signaling is ready then exit.
    if (!TP.sys.hasInitialized()) {
        return this;
    }

    //  NB: For new objects, this relies on 'undefined' being a 'falsey' value.
    //  We don't normally do this in TIBET, but this method is used heavily and
    //  is a hotspot.
    if (!this.shouldSignalChange()) {
        return this;
    }

    //  If we can find the actual object work from there so we allow it more
    //  control over the process.
    target = TP.sys.getObjectById(this.toString());
    if (TP.canInvoke(target, 'changed')) {
        return target.changed(anAspect, anAction, aDescription);
    }

    //  Build up the signal name we'll be firing.
    sig = 'Change';
    asp = TP.ifKeyInvalid(aDescription, 'aspect', anAspect) || 'value';

    if (asp === 'value') {
        sig = 'TP.sig.ValueChange';
    } else {
        sig = TP.makeStartUpper(asp.toString()) + sig;
    }

    //  Build up a standard form for the description hash.
    desc = TP.isValid(aDescription) ? aDescription : TP.hc();
    if (!TP.canInvoke(desc, 'atPutIfAbsent')) {
        this.raise('TP.sig.InvalidParameter',
                    'Description not a collection.');

        return this;
    }
    desc.atPutIfAbsent('aspect', asp);
    desc.atPutIfAbsent('action', anAction || TP.UPDATE);
    desc.atPutIfAbsent('facet', 'value');
    desc.atPutIfAbsent('target', target || this);

    //  note that we force the firing policy here. this allows observers of a
    //  generic Change to see 'aspect'Change notifications, even if those
    //  'aspect'Change signals haven't been defined as being subtypes of Change
    TP.signal(this, sig, desc, TP.INHERITANCE_FIRING);

    return TP.isValid(target) ? target : this;
});

//  ------------------------------------------------------------------------
//  REFLECTION - PART III
//  ------------------------------------------------------------------------

/**
 * RE: the discussion on TIBET's ordered pairs, an object's 'items' in TIBET
 * terminology are ordered pairs of keys/values for Objects and the index/value
 * for Arrays.
 */

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('item',
function(anIndex) {

    /**
     * @method item
     * @summary Returns the item at the index provided. This allows Array
     *     instances to function as valid NodeList instances.
     * @returns {Object} The object at the index in the receiver.
     */

    return this.at(anIndex);
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getItems',
function(aSelectFunction) {

    /**
     * @method getItems
     * @summary Returns a list of items from the collection, filtering them via
     *     aSelectFunction if provided. Note that you can use the same semantics
     *     as select for this call.
     * @description The term "items", as opposed to "keys", "values", or "pairs"
     *     is variant in TP.sys. For most collections "items" are "values",
     *     however for TP.core.Hash in particular the "items" are more like
     *     Smalltalk "associations", the key/value pairs. Using getItems is a
     *     way to deal with the "natural item form" of each collection without
     *     concern for the specific nature of those items so this method is
     *     typically called only by the collection itself or by generic
     *     iteration functions.
     * @param {Function} aSelectFunction A function used to select items that
     *     will be returned. Each item is passed to this function and if the
     *     function returns true the item is included in the result.
     * @returns {Object[]} The receiver's items in array key/value form.
     */

    if (TP.isCallable(aSelectFunction)) {
        return this.select(aSelectFunction);
    }

    return TP.entries(this);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('getItems',
function(aSelectFunction) {

    /**
     * @method getItems
     * @summary Returns a list of items from the collection, filtering them via
     *     aSelectFunction if provided. Note that you can use the same semantics
     *     as select for this call.
     * @description The term "items", as opposed to "keys", "values", or "pairs"
     *     is variant in TP.sys. For most collections "items" are "values",
     *     however for TP.core.Hash in particular the "items" are more like
     *     Smalltalk "associations", the key/value pairs. Using getItems is a
     *     way to deal with the "natural item form" of each collection without
     *     concern for the specific nature of those items so this method is
     *     typically called only by the collection itself or by generic
     *     iteration functions.
     * @param {Function} aSelectFunction A function used to select items that
     *     will be returned. Each item is passed to this function and if the
     *     function returns true the item is included in the result.
     * @returns {Object[]} The receiver or a new Array containing the filtered
     *     results.
     */

    if (TP.isCallable(aSelectFunction)) {
        return this.select(aSelectFunction);
    }

    return this.getValues();
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('getItems',
function(aSelectFunction) {

    /**
     * @method getItems
     * @summary Returns a list of items from the collection, filtering them via
     *     aSelectFunction if provided. Note that you can use the same semantics
     *     as select for this call.
     * @description The term "items", as opposed to "keys", "values", or "pairs"
     *     is variant in TP.sys. For most collections "items" are "values",
     *     however for TP.core.Hash in particular the "items" are more like
     *     Smalltalk "associations", the key/value pairs. Using getItems is a
     *     way to deal with the "natural item form" of each collection without
     *     concern for the specific nature of those items so this method is
     *     typically called only by the collection itself or by generic
     *     iteration functions.
     * @param {Function} aSelectFunction A function used to select chars that
     *     will be returned. Each char is passed to this function and if the
     *     function returns true the char is included in the result.
     * @returns {String[]} An array of characters in the receiver.
     */

    if (TP.isCallable(aSelectFunction)) {
        return this.getValues().select(aSelectFunction);
    }

    return this.getValues();
});

//  ------------------------------------------------------------------------
//  STRING REPRESENTATION
//  ------------------------------------------------------------------------

/**
 * There are a number of scenarios where getting a displayable output string for
 * an object is important.

 * The asDisplayString() function is the foundation for many of TIBET's
 * formatters since it's capable of producing HTML, XML, or other
 * representations of an object and its children/properties.
*/

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('asDisplayString',
function(aHash, aLevel) {

    /**
     * @method asDisplayString
     * @summary Returns the receiver as a formatted string. This method is
     *     extremely powerful as it takes a number of parameters which allow it
     *     to format an object in a number of ways. The parameters should be
     *     provided in an anonymous object as in:
     *
     *     this.asDisplayString({param: value, param: value, ...});
     *
     *     If no params are provided a simple toString() is done. If params are
     *     provided they control formatting as their names imply. The params
     *     are:
     *
     *     header what do we start with? itemPrefix what does each item
     *     (key/value) start with keyPrefix what do keys start with keyTransform
     *     how should keys be tranformed (a function) keySuffix how do keys end
     *     kvSeparator what separates keys from values valuePrefix what prefixes
     *     values valueTransform how should values be converted (a function)
     *     valueSuffix how should values end itemSuffix what terminates an item
     *     (key/value) pair itemSeparator what separates items footer what
     *     footer ends it all nullValue what should nulls look like
     *     emptyFunction a function that produces output to use when the object
     *     has no items filter a filter specification useKeys boolean for using
     *     getKeys() or get*Interface() useSort function to use for sorting, if
     *     any
     *
     *     The combination of these parameters allows this method to create
     *     object formats from CSV to JS Source to HTML tables using appropriate
     *     parameter settings.
     * @param {TP.core.Hash} aHash A TP.core.Hash containing one or more of the
     *     previously mentioned keys.
     * @param {Number} aLevel Number of levels to descend in nested objs.
     * @returns {String} A formatted string.
     */

    var params,
        lvl,
        i,
        k,
        result,
        sorter,
        propertyValue,
        header,
        itemPrefix,
        keyPrefix,
        keyTransform,
        keySuffix,
        kvSeparator,
        valuePrefix,
        valueSuffix,
        itemSuffix,
        itemSeparator,
        emptyFunction,
        footer,
        nullValue,
        filter,
        useKeys,
        sourceTransform,
        valueTransform,
        nullTransform;

    params = aHash;
    if (TP.notValid(params)) {
        params = TP.hc('filter', 'unique_attributes');
    }

    lvl = TP.notDefined(aLevel) ? TP.sys.cfg('stack.max_descent') :
                                Math.max(0, aLevel);

    //  level 0 means no keys, nada, just the receiver
    if (lvl === 0) {
        return this.toString();
    }

    nullTransform =
            function(it) {
                return it;
            };

    header = TP.ifInvalid(params.at('header'), '');
    itemPrefix = TP.ifInvalid(params.at('itemPrefix'), '');
    keyPrefix = TP.ifInvalid(params.at('keyPrefix'), '');
    keyTransform = TP.ifInvalid(params.at('keyTransform'), nullTransform);
    keySuffix = TP.ifInvalid(params.at('keySuffix'), '');
    kvSeparator = TP.ifInvalid(params.at('kvSeparator'), '=');
    valuePrefix = TP.ifInvalid(params.at('valuePrefix'), '');
    valueSuffix = TP.ifInvalid(params.at('valueSuffix'), '');
    itemSuffix = TP.ifInvalid(params.at('itemSuffix'), '');
    itemSeparator = TP.ifInvalid(params.at('itemSeparator'), '; ');
    emptyFunction = TP.ifInvalid(params.at('emptyFunction'),
                                    TP.RETURN_EMPTY_STRING);
    footer = TP.ifInvalid(params.at('footer'), '');
    nullValue = TP.ifInvalid(params.at('nullValue'), 'null');
    filter = TP.ifInvalid(params.at('filter'), 'unique_attributes');

    if (TP.isArray(this) || TP.isHash(this)) {
        useKeys = TP.ifInvalid(params.at('useKeys'), true);
    } else {
        useKeys = TP.ifInvalid(params.at('useKeys'), false);
    }

    //  note this is here to allow it to close around nullValue
    sourceTransform =
        function(it) {

            if (TP.notDefined(it)) {
                return 'null';
            }

            if (TP.isNull(it)) {
                return 'null';
            }

            if (it === this) {
                return 'this';
            }

            if (it === TP.global) {
                return 'self';
            }

            if (it === window) {
                return 'window';
            }

            if (it === document) {
                return 'document';
            }

            if (TP.isNode(it)) {
                return TP.src(it);
            }

            if (TP.canInvoke(it, 'asString')) {
                return it.asString();
            }

            return TP.str(it);
        };

    //  and this references the sourceTransform :)
    valueTransform = TP.ifInvalid(params.at('valueTransform'),
                                            sourceTransform);

    result = TP.ac();
    result.push(header);

    if (useKeys) {
        k = this.getKeys();

        if (TP.isArray(this)) {
            //  Make sure we don't leave the 'length' key in the Array - it will
            //  mess up our sort:
            k.splice(k.indexOf('length'), 1);
        }
    } else {
        //  keys for anything here that's got a unique value
        k = this.getLocalInterface(filter);
    }

    if (TP.isDefined(sorter = params.at('useSort'))) {
        if (TP.isCallable(sorter)) {
            k.sort(sorter);
        } else if (TP.notFalse(sorter)) {
            if (TP.isValid(k.at(0))) {
                if (TP.isArray(this)) {
                    k.sort(TP.sort.NUMERIC);
                } else {
                    k.sort();
                }
            }
        }
    } else {
        if (TP.isValid(k.at(0))) {
            if (TP.isArray(this)) {
                k.sort(TP.sort.NUMERIC);
            } else {
                k.sort();
            }
        }
    }

    for (i = 0; i < k.getSize(); i++) {
        propertyValue = this.at(k.at(i));

        //  wrap the item
        result.push(itemPrefix);

        //  build up key
        result.push(keyPrefix,
                    keyTransform(k.at(i), propertyValue),
                    keySuffix);

        //  separate key from value
        result.push(kvSeparator);

        //  build up value
        if (TP.isNull(propertyValue)) {
            result.push(valuePrefix,
                        nullValue,
                        valueSuffix);
        } else {
            //  note we drop levels on each call
            result.push(valuePrefix,
                        valueTransform(propertyValue, lvl - 1, k.at(i)),
                        valueSuffix);
        }

        //  wrap the item
        result.push(itemSuffix);

        //  separate pairs as needed

        /* eslint-disable no-extra-parens */
        if (i < (k.getSize() - 1)) {
        /* eslint-enable no-extra-parens */
            result.push(itemSeparator);
        }
    }

    //  don't appear to be any items...
    if (k.getSize() === 0) {
        result.push(emptyFunction());
    }

    //  add footer
    result.push(footer);

    return result.join('');
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('asHTTPValue',
function() {

    /**
     * @method asHTTPValue
     * @summary Returns the best value to be used for the receiver to send via
     *     HTTP.
     * @returns {Object} The best value for HTTP sending.
     */

    return this.getValue();
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    var marker,
        str;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asJSONSource';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }

    //  NB: For 'Object', we put this in a try...catch since some native Objects
    //  (i.e. XHR objects) don't like to have slots placed on them.
    try {
        this[marker] = true;
    } catch (e) {
        void 0;
    }

    try {
        str = TP.js2json(this);
    } finally {
        try {
            delete this[marker];
        } catch (e) {
            void 0;
        }
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a TIBET source code string.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    var marker,
        keys,
        len,
        arr,
        i,
        val;

    if (TP.isType(this)) {
        return this.getTypeName();
    }

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asSource';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }

    //  NB: For 'Object', we put this in a try...catch since some native Objects
    //  (i.e. XHR objects) don't like to have slots placed on them.
    try {
        this[marker] = true;
    } catch (e) {
        void 0;
    }

    keys = this.getKeys();
    len = keys.length;
    arr = TP.ac();

    try {
        for (i = 0; i < len; i++) {
            if (TP.isDefined(val = this.at(keys[i]))) {
                arr.push(
                    TP.join(
                        '\'', TP.str(keys[i]), '\'',
                        ':',
                        TP.src(val)));
            }
        }
    } finally {
        try {
            delete this[marker];
        } catch (e) {
            void 0;
        }
    }

    return TP.join('{', arr.join(', '), '}');
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a TIBET source code string.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    var marker,
        len,
        arr,
        i;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asSource';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    len = this.length;
    arr = TP.ac();

    try {
        for (i = 0; i < len; i++) {
            arr.push(TP.src(this[i]));
        }
    } finally {
        delete this[marker];
    }

    return TP.join('TP.ac(', arr.join(', '), ')');
});

//  ------------------------------------------------------------------------

Boolean.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a string in source form: true or false.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    return this ? 'TP.bc(true)' : 'TP.bc(false)';
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns "TP.dc(this.getTime())" which if eval'd will construct
     *     a Date instance with the same value.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    return 'TP.dc(' + this.getTime() + ')';
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('asSource',
function(aFilterName, aLevel) {

    /**
     * @method asSource
     * @summary Returns a string capable of recreating the receiver. For a
     *     function this is a variation of the toString() results which include
     *     any owner/track information required to recreate the method. For a
     *     type it's the defineSubtype call in string form.
     * @param {String} aFilterName Ignored.
     * @param {Number} aLevel If 0, returns function() {...}
     * @returns {String} An appropriate form for recreating the receiver.
     */

    var obj,

        lvl,

        src,

        head,
        tail,
        str;

    //  The only way to discern between Function objects that are one of the
    //  native constructors (types) and a regular Function object.
    if (TP.isNativeType(this)) {
        return TP.NO_SOURCE_REP;
    }

    //  A custom TIBET type
    if (TP.isType(this)) {
        return TP.join(this.getSupertype().getName(),
                        '.defineSubtype(\'', this.getNamespacePrefix(), ':',
                        this.getLocalName(), '\');');
    }

    obj = TP.getRealFunction(this);

    lvl = TP.notDefined(aLevel) ?
            TP.sys.cfg('stack.max_descent') :
            Math.max(0, aLevel);

    if (lvl === 0) {
        return 'function() {}';
    }

    if (TP.sys.cfg('tibet.space_after_function_name') === true) {
        src = obj.asString();
    } else {
        //  NB: We're only interested in the first occurrence of the 'function'
        //  keyword here - it's the only one that's reconstructed from the
        //  system - the rest of the Function source is brought in as-is on all
        //  platforms we care about.
        src = obj.asString().replace('function (', 'function(');
    }

    str = TP.ac();

    if (TP.isMethod(obj)) {

        //  Generate the 'method header' and 'method tail' - this gives us a
        //  String that is a representation of the canonical TIBET way to add
        //  methods to the system. Note that this produces a representation of
        //  the head which *must* be followed with a Function statement (i.e.
        //  'function() {...}') and the method tail.
        head = obj.getMethodSourceHead();
        tail = obj.getMethodSourceTail();

        //  Add that head, our source and that tail to the representation.
        str.push(head, src, tail);
    } else {
        str.push(src);
    }

    str.push(';');

    return str.join('');
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver in source code form i.e. as a number with
     *     no quotes etc.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

RegExp.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver in TIBET source code form. The flags for
     *     global and case-sensitivity are included.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    var args;

    args = '';
    if (this.ignoreCase) {
        args += 'i';
    }

    if (this.global) {
        args += 'g';
    }

    if (this.multiline) {
        args += 'm';
    }

    if (this.sticky) {
        args += 'y';
    }

    if (this.unicode) {
        args += 'u';
    }

    return TP.join('TP.rc(',
                    this.source.quoted(), ', ', args.quoted(),
                    ')');
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver in source code form. Embedded quotes are
     *     escaped as needed and single quotes are used for the external quoting
     *     so the string would function properly inside an XML attribute.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    //  Make sure to force the conversion to a primitive string.
    return this.toString().quoted();
});

//  ------------------------------------------------------------------------
//  EQUALITY/IDENTITY
//  ------------------------------------------------------------------------

/**
 * JavaScript has different notions of equality and identity than those required
 * by TIBET's semantics. In particular, TIBET's sense of equality requires that
 * two arrays containing equal elements return true when tested for equality.
 * JavaScript won't do this for reference types. Identity is included for both
 * consistency and to allow us to 'proxy' by essentially lying about identity.
 */

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('$getEqualityValue',
function() {

    /**
     * @method $getEqualityValue
     * @summary Returns the value which should be used for testing equality
     *     for the receiver. The default is the receiver, which normally
     *     results in a deep compare for object types.
     * @returns {Object} A value appropriate for use in equality comparisons.
     */

    //  If the receiver is a value holder, then we return the underlying value
    //  for equality comparison purposes.
    if (this.$get('$$isValueHolder')) {
        return this.get('value');
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('$getIdentityValue',
function() {

    /**
     * @method $getIdentityValue
     * @summary Returns the value which should be used for testing identity
     *     for the receiver. The default is the receiver itself. Types that
     *     allow themselves to be proxied can return their GID or similar value.
     * @returns {Object} A value appropriate for use in identity comparisons.
     */

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('$getEqualityValue',
function() {

    /**
     * @method $getEqualityValue
     * @summary Returns the value which should be used for testing equality.
     *     Arrays return themselves to support a deep comparison.
     * @returns {String} A value appropriate for use in equality comparisons.
     */

    return this;
});

//  ------------------------------------------------------------------------

Boolean.Inst.defineMethod('$getEqualityValue',
function() {

    /**
     * @method $getEqualityValue
     * @summary Returns the value which should be used for testing equality for
     *     the receiver. For Booleans, we return the object itself.
     * @returns {Boolean} A value appropriate for use in equality comparisons.
     */

    return this;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('$getEqualityValue',
function() {

    /**
     * @method $getEqualityValue
     * @summary Returns the value which should be used for testing equality for
     *     the receiver. For Dates, we return the numeric getTime() value.
     * @returns {Number} A value appropriate for use in equality comparisons.
     */

    return this.getTime();
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('$getEqualityValue',
function() {

    /**
     * @method $getEqualityValue
     * @summary Returns the value which should be used for testing equality for
     *     the receiver. For Functions, we return the String representation of
     *     the Function.
     * @returns {String} A value appropriate for use in equality comparisons.
     */

    return this.asString();
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('$getEqualityValue',
function() {

    /**
     * @method $getEqualityValue
     * @summary Returns the value which should be used for testing equality for
     *     the receiver. For Numbers, we return the object itself.
     * @returns {Number} A value appropriate for use in equality comparisons.
     */

    return this;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('$getEqualityValue',
function() {

    /**
     * @method $getEqualityValue
     * @summary Returns the value which should be used for testing equality for
     *     the receiver. For Strings, we return the object itself.
     * @returns {String} A value appropriate for use in equality comparisons.
     */

    return '' + this;
});

//  ------------------------------------------------------------------------

RegExp.Inst.defineMethod('$getEqualityValue',
function() {

    /**
     * @method $getEqualityValue
     * @summary Returns the value which should be used for testing equality for
     *     the receiver. For RegExps, we return the String representation of the
     *     RegExp.
     * @returns {String} A value appropriate for use in equality comparisons.
     */

    return this.asString();
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('equalTo',
function(that) {

    /**
     * @method equalTo
     * @summary Compare for equality.
     * @description TIBET's notion of equality is based on "equality of value"
     *     such that two objects with matching key/value data are equal. This
     *     isn't true for JS. TIBET therefore uses string value as the
     *     comparison of choice and of course allows individual subtypes to
     *     define their own notion of equality (as with Date).
     * @param {Object} that The object to test against.
     * @returns {Boolean} Whether or not the receiver is equal to the supplied
     *     object.
     */

    var a,
        b;

    //  Must be something to compare to.
    if (arguments.length < 1) {
        return false;
    }

    a = TP.canInvoke(this, '$getEqualityValue') ?
                        this.$getEqualityValue() :
                        this;
    b = TP.canInvoke(that, '$getEqualityValue') ?
                        that.$getEqualityValue() :
                        that;

    //  Once we have the equality values use a primitive deep compare. This
    //  works effectively to allow objects to provide whatever they like, such
    //  as a random identifier (employee ID etc) or other value, or just return
    //  themselves for a deep compare.
    return TP.$equal(a, b);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('equalTo',
function(that) {

    /**
     * @method equalTo
     * @summary Returns true if the two objects compare equally. TIBET's notion
     *     of equality is based on "equality of value" such that for TIBET the
     *     array [1,2,3] is equalTo() a second array [1,2,3]. Arrays of
     *     different length are likewise not equal.
     * @param {Object} that The object to test against.
     * @returns {Boolean} Whether or not the receiver is equal to the supplied
     *     object.
     */

    var i;

    if (!TP.isArray(that)) {
        return false;
    }

    if (this.getSize() !== that.length) {
        return false;
    }

    for (i = 0; i < this.getSize(); i++) {
        if (TP.isNull(this.at(i))) {
            if (TP.notNull(that.at(i))) {
                return false;
            }
        } else if (TP.notDefined(this.at(i))) {
            if (TP.isDefined(that.at(i))) {
                return false;
            }
        } else if (!TP.equal(this.at(i), that.at(i))) {
            return false;
        }
    }

    return true;
});

//  ------------------------------------------------------------------------

Boolean.Inst.defineMethod('equalTo',
function(that) {

    /**
     * @method equalTo
     * @summary Compare for equality. In TIBET equality means the values i.e.
     *     the content is equal.
     * @param {Object} that The object to test against.
     * @returns {Boolean} Whether or not the receiver is equal to the supplied
     *     object.
     */

    if (!TP.isBoolean(that)) {
        return false;
    }

    //  force primitive comparison
    return this.valueOf() === that.valueOf();
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('equalTo',
function(that) {

    /**
     * @method equalTo
     * @summary Compare for equality. In TIBET equality means the values i.e.
     *     the content is equal. Equality for dates is based on MS clock times.
     * @param {Object} that The object to test against.
     * @returns {Boolean} Whether or not the receiver is equal to the supplied
     *     object.
     */

    if (!TP.isDate(that)) {
        return false;
    }

    //  if it's a date return based on comparison of milliseconds since the
    //  regular Date comparison doesn't seem to be smart enough to do this
    return this.getTime() === that.getTime();
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('equalTo',
function(that) {

    /**
     * @method equalTo
     * @summary Compare for equality. In TIBET equality means the values i.e.
     *     the content is equal. Functions are equal if they have the same
     *     string value.
     * @param {Object} that The object to test against.
     * @returns {Boolean} Whether or not the receiver is equal to the supplied
     *     object.
     */

    if (!TP.isCallable(that)) {
        return false;
    }

    return this.toString().replace(/^function \(/, 'function(') ===
            that.toString().replace(/^function \(/, 'function(');
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('equalTo',
function(that) {

    /**
     * @method equalTo
     * @summary Compare for equality. In TIBET equality means the values i.e.
     *     the content is equal.
     * @param {Object} that The object to test against.
     * @returns {Boolean} Whether or not the receiver is equal to the supplied
     *     object.
     */

    if (!TP.isNumber(that)) {
        return false;
    }

    //  force primitive comparison
    /* eslint-disable no-extra-parens */
    return (this - 0) === (that - 0);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('equalTo',
function(that) {

    /**
     * @method equalTo
     * @summary Compare for equality. In TIBET equality means the values i.e.
     *     the content is equal.
     * @param {Object} that The object to test against.
     * @returns {Boolean} Whether or not the receiver is equal to the supplied
     *     object.
     */

    if (!TP.isString(that)) {
        return false;
    }

    //  force primitive comparison
    /* eslint-disable no-extra-parens */
    return ('' + this) === ('' + that);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('identicalTo',
function(that) {

    /**
     * @method identicalTo
     * @summary Compare for identity.
     * @description The === symbol in JS isn't really defined as "identity"
     *     it's defined as "strict equality" which apparently isn't the same in
     *     certain cases. For TIBET we follow the general form but rely on our
     *     own OIDs to test for identity.
     * @param {Object} that The object to test against.
     * @returns {Boolean} Whether or not the receiver is identical to the
     *     supplied object.
     */

    var a,
        b;

    //  Must be something to compare to.
    if (arguments.length < 1) {
        return false;
    }

    a = TP.canInvoke(this, '$getIdentityValue') ?
                        this.$getIdentityValue() :
                        this;
    b = TP.canInvoke(that, '$getIdentityValue') ?
                        that.$getIdentityValue() :
                        that;

    return a === b;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('identicalTo',
function(that) {

    /**
     * @method identicalTo
     * @summary Compare for identity.
     * @param {Object} that The object to test against.
     * @returns {Boolean} Whether or not the receiver is identical to the
     *     supplied object.
     */

    return this === that;
});

//  ------------------------------------------------------------------------

Boolean.Inst.defineMethod('identicalTo',
function(that) {

    /**
     * @method identicalTo
     * @summary Compare for identity.
     * @param {Object} that The object to test against.
     * @returns {Boolean} Whether or not the receiver is identical to the
     *     supplied object.
     */

    if (!TP.isBoolean(that)) {
        return false;
    }

    //  force primitive comparison
    return Number(this) === Number(that);
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('identicalTo',
function(that) {

    /**
     * @method identicalTo
     * @summary Compare for identity.
     * @param {Object} that The object to test against.
     * @returns {Boolean} Whether or not the receiver is identical to the
     *     supplied object.
     */

    return this === that;
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('identicalTo',
function(that) {

    /**
     * @method identicalTo
     * @summary Compare for identity.
     * @param {Object} that The object to test against.
     * @returns {Boolean} Whether or not the receiver is identical to the
     *     supplied object.
     */

    return this === that;
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('identicalTo',
function(that) {

    /**
     * @method identicalTo
     * @summary Compare for identity.
     * @param {Object} that The object to test against.
     * @returns {Boolean} Whether or not the receiver is identical to the
     *     supplied object.
     */

    if (TP.isNaN(that)) {
        return TP.isNaN(this);
    }

    //  force primitive comparison
    return Number(this) === Number(that);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('identicalTo',
function(that) {

    /**
     * @method identicalTo
     * @summary Compare for identity.
     * @param {Object} that The object to test against.
     * @returns {Boolean} Whether or not the receiver is identical to the
     *     supplied object.
     */

    if (!TP.isString(that)) {
        return false;
    }

    /* eslint-disable no-extra-parens */
    //  force primitive comparison
    return ('' + this) === ('' + that);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$deepEqual',
function(objectA, objectB, aStack, bStack) {

    /**
     * @method $deepEqual
     * @summary A deep-compare test based heavily on the Underscore.js
     *     implementation. The primary differences relate to working with
     *     key sets that filter out TIBET private/internal slots like $$id.
     *     You don't normally call this directly, it's invoked by $equal as
     *     needed and that's invoked by TP.equal() as needed.
     * @param {Object} a The first object to compare.
     * @param {Object} b The second object to compare.
     * @param {Object[]} aStack A 'stack' of 'a side' comparison objects used to
     *     track equality as we descend deeply.
     * @param {Object[]} bStack A 'stack' of 'b side' comparison objects used to
     *     track equality as we descend deeply.
     * @returns {Boolean} Whether or not the two objects are equal to one
     *     another.
     */

    var a,
        b,

        className,

        areArrays,

        aCtor,
        bCtor,

        aStk,
        bStk,

        length,

        keys,
        key,

        aHasAt,
        bHasAt;

    //  Unwrap any wrapped objects.
    a = TP.unwrap(objectA);
    b = TP.unwrap(objectB);

    //  Compare `[[Class]]` names.
    className = TP.tostr(a);
    if (className !== TP.tostr(b)) {
        return false;
    }

    /* eslint-disable no-fallthrough,no-implicit-coercion */
    switch (className) {

        //  Strings, numbers, regular expressions, dates, and booleans are
        //  compared by value.
        case '[object RegExp]':
            //  RegExps are coerced to strings for comparison
            //  (Note: '' + /a/i === '/a/i')
        case '[object String]':
            //  Primitives and their corresponding object wrappers are
            //  equivalent; thus, `"5"` is equivalent to `new String("5")`.
            return '' + a === '' + b;

        case '[object Number]':
            //  `NaN`s are equivalent, but non-reflexive.
            /* eslint-disable no-self-compare */
            if (+a !== +a) {
                //  Object(NaN) is equivalent to NaN.
                return +b !== +b;
            }
            //  An `egal` comparison is performed for other numeric values.
            return +a === 0 ? 1 / +a === 1 / b : +a === +b;
            /* eslint-enable no-self-compare */

        case '[object Date]':
        case '[object Boolean]':
            //  Coerce dates and booleans to numeric primitive values. Dates are
            //  compared by their millisecond representations. Note that invalid
            //  dates with millisecond representations of `NaN` are not
            //  equivalent.
            return +a === +b;

        case '[object Symbol]':
            return window.SymbolProto.valueOf.call(a) ===
                        window.SymbolProto.valueOf.call(b);

        default:
            void 0;
    }
    /* eslint-enable no-fallthrough,no-implicit-coercion */

    areArrays = className === '[object Array]';
    if (!areArrays) {
        if (typeof a !== 'object' || typeof b !== 'object') {
            return false;
        }

        //  Objects with different constructors are not equivalent, but
        //  `Object`s or `Array`s from different frames are.
        aCtor = a.constructor;
        bCtor = b.constructor;

        if (aCtor !== bCtor &&
            !(TP.isFunction(aCtor) &&
                aCtor instanceof aCtor &&
                TP.isFunction(bCtor) &&
                bCtor instanceof bCtor) &&
                ('constructor' in a && 'constructor' in b)) {
            return false;
        }
    }

    //  Assume equality for cyclic structures. The algorithm for detecting
    //  cyclic structures is adapted from ES 5.1 section 15.12.3, abstract
    //  operation `JO`.

    //  Initializing stack of traversed objects.
    //  It's done here since we only need them for objects and arrays
    //  comparison.
    aStk = aStack || TP.ac();
    bStk = bStack || TP.ac();

    length = aStk.length;
    while (length--) {
        //  Linear search. Performance is inversely proportional to the number
        //  of unique nested structures.
        if (aStk.at(length) === a) {
            return bStack.at(length) === b;
        }
    }

    //  Add the first object to the stack of traversed objects.
    aStk.push(a);
    bStk.push(b);

    //  Recursively compare objects and arrays.
    if (areArrays) {
        //  Compare array lengths to determine if a deep comparison is
        //  necessary.
        length = a.length;
        if (length !== b.length) {
            return false;
        }

        //  Deep compare the contents, ignoring non-numeric properties.
        while (length--) {
            if (!TP.$equal(a[length], b[length], aStk, bStk)) {
                return false;
            }
        }
    } else {

        //  Deep compare objects.
        keys = TP.keys(a);
        length = keys.length;

        //  Ensure that both objects contain the same number of properties
        //  before comparing deep equality.
        if (TP.keys(b).length !== length) {
            return false;
        }

        aHasAt = TP.isFunction(a.at);
        bHasAt = TP.isFunction(b.at);

        while (length--) {
            //  Deep compare each member
            key = keys.at(length);
            if (!(TP.objectHasKey(b, key) &&
                    TP.$equal(
                        aHasAt ? a.at(key) : a[key],
                        bHasAt ? b.at(key) : b[key], aStk, bStk))) {
                return false;
            }
        }
    }

    //  Remove the first object from the stack of traversed objects.
    aStk.pop();
    bStk.pop();

    return true;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$equal',
function(a, b, aStack, bStack) {

    /**
     * @method $equal
     * @summary Returns true if the values of the two objects are 'equal'.
     * @param {Object} a The first object to compare.
     * @param {Object} b The second object to compare.
     * @param {Object[]} aStack A 'stack' of 'a side' comparison objects used to
     *     track equality as we descend deeply.
     * @param {Object[]} bStack A 'stack' of 'b side' comparison objects used to
     *     track equality as we descend deeply.
     * @returns {Boolean} Whether or not the two objects are equal to one
     *     another.
     */

    var type;

    //  Identical objects are equal. `0 === -0`, but they aren't identical.
    //  See the [Harmony `egal` proposal]
    //  (http://wiki.ecmascript.org/doku.php?id=harmony:egal).
    if (a === b) {
        return a !== 0 || 1 / a === 1 / b;
    }

    //  A strict comparison is necessary because `null == undefined`.
    /* eslint-disable eqeqeq */
    if (a == null || b == null) {
        return a === b;
    }
    /* eslint-enable eqeqeq */

    //  `NaN`s are equivalent, but non-reflexive.
    /* eslint-disable no-self-compare */
    if (a !== a) {
        return b !== b;
    }
    /* eslint-enable no-self-compare */

    //  Exhaust primitive checks
    type = typeof a;
    if (type !== 'function' && type !== 'object' && typeof b !== 'object') {
        return false;
    }

    //  None of these checks passed - do a deep equal.
    return TP.$deepEqual(a, b, aStack, bStack);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('equal',
function(objectA, objectB, aType) {

    /**
     * @method equal
     * @summary Returns true if the values of the two objects are 'equal'.
     *     TIBET's approach differs from that of most libraries in that TIBET
     *     attempts to delegate to object-based methods which allow each type to
     *     specialize how it determines equality. When that approach isn't
     *     possible the objects are compared using a lower level primitive.
     * @param {Object} objectA The first object to compare.
     * @param {Object} objectB The second object to compare.
     * @param {TP.lang.RootObject|String} aType A Type object, or type name.
     *     Supplying this will force both objects to be compared by this
     *     supplied type.
     * @returns {Boolean} Whether or not the two objects are equal to one
     *     another.
     */

    //  Don't let a missing argument cause a false positive for undefined.
    if (arguments.length < 2) {
        return false;
    }

    //  Null and undefined compare equal in TIBET.
    /* eslint-disable eqeqeq */
    if (objectA == null || objectB == null) {
        return objectA === objectB;
    }
    /* eslint-enable eqeqeq */

    //  We also consider two NaN values to be equal.
    if (TP.isNaN(objectA)) {
        return TP.isNaN(objectB);
    }

    //  if they're both nodes, we can just use TP.nodeEqualsNode() to
    //  compare them here.
    if (TP.isNode(objectA) && TP.isNode(objectB)) {
        return TP.nodeEqualsNode(objectA, objectB);
    }

    //  remaining options rely on at least one object being able to perform
    //  the comparison with more intelligence than ==.
    if (TP.canInvoke(objectA, 'equalTo')) {
        return objectA.equalTo(objectB);
    } else if (TP.canInvoke(objectB, 'equalTo')) {
        return objectB.equalTo(objectA);
    }

    return TP.$equal(objectA, objectB);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('identical',
function(objectA, objectB) {

    /**
     * @method identical
     * @summary Returns true if the values of the two objects are 'identical'.
     *     Neither nulls nor undefined values will compare identical with
     *     anything.
     * @param {Object} objectA The first object to compare.
     * @param {Object} objectB The second object to compare.
     * @returns {Boolean} Whether or not the two objects are identical to one
     *     another.
     */

    //  Don't let a missing argument cause a false positive for undefined.
    if (arguments.length < 2) {
        return false;
    }

    //  Null and undefined compare identically in TIBET.
    /* eslint-disable eqeqeq */
    if (objectA == null || objectB == null) {
        return objectA === objectB;
    }
    /* eslint-enable eqeqeq */

    //  We also consider two NaN values to be identical.
    if (TP.isNaN(objectA)) {
        return TP.isNaN(objectB);
    }

    //  if they're both nodes, we can just === compare them here and exit.
    if (TP.isNode(objectA) && TP.isNode(objectB)) {
        return objectA === objectB;
    }

    //  identity can be spoofed in certain cases, so we don't assume that
    //  === is going to be the right answer in all cases...we'll see if
    //  either object would like to manage the comparison first
    if (TP.canInvoke(objectA, 'identicalTo')) {
        return objectA.identicalTo(objectB);
    } else if (TP.canInvoke(objectB, 'identicalTo')) {
        return objectB.identicalTo(objectA);
    }

    return objectA === objectB;
});

//  ------------------------------------------------------------------------
//  COMPARISON/MAGNITUDE
//  ------------------------------------------------------------------------

/**
 * Not all objects work in a way consistent with standard sort functions,
 * meaning that they can't easily be sorted based on simple criteria. To help
 * with that we define a set of comparison support features here that you can
 * implement in your types to help sort at the object level.
 */

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('$getComparisonValue',
function() {

    /**
     * @method $getComparisonValue
     * @summary Returns the value which should be used for comparing
     *     "magnitudes" for purposes of sorting a set of objects. The default
     *     returns the result of calling getSize().
     * @returns {Number} The size of the object.
     */

    return this.getSize();
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('compareTo',
function(that) {

    /**
     * @method compareTo
     * @summary Compare for "magnitude" to support sort operations.
     * @param {Object} that The object to compare the receiver against.
     * @returns {Number} -1 if receiver is "smaller" than the argument, 0 if
     *     they are "equal", and 1 if the receiver is "larger" than the
     *     argument.
     */

    var thissize,
        thatsize;

    if (TP.canInvoke(that, '$getComparisonValue')) {
        thatsize = that.$getComparisonValue();
    } else if (TP.canInvoke(that, 'getSize')) {
        thatsize = that.getSize();
    } else if (TP.isValid(that.length)) {
        thatsize = that.length;
    } else {
        //  consider ourselves to be "larger"
        return 1;
    }

    thissize = this.$getComparisonValue();

    if (thissize > thatsize) {
        return 1;
    } else if (thissize < thatsize) {
        return -1;
    } else {
        return 0;
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('compare',
function(objectA, objectB) {

    /**
     * @method compare
     * @summary Returns -1, 0, or 1 based on whether objectA is "larger" than
     *     objectB as determined by their comparison values.
     * @param {Object} objectA The first object to compare.
     * @param {Object} objectB The second object to compare.
     * @returns {Number} -1 if objectA is "smaller" than objectB, 0 if they are
     *     "equal", and 1 if objectA is "larger" than objectB.
     */

    if (TP.canInvoke(objectA, 'compareTo')) {
        return objectA.compareTo(objectB);
    } else if (TP.canInvoke(objectB, 'compareTo')) {
        return objectB.compareTo(objectA);
    } else {
        //  indeterminate
        return 0;
    }
});

//  ------------------------------------------------------------------------
//  MATCHING
//  ------------------------------------------------------------------------

Function.Inst.defineMethod('test',
function(anObject) {

    /**
     * @method test
     * @summary Mirrors the test call on RegExp instances so we can use a
     *     function instance as a "selector".
     * @param {Object} anObject The object to test.
     * @returns {Boolean} True if the function finds the object acceptable.
     */

    var result;

    try {
        result = this(anObject);

        return TP.bc(result);
    } catch (e) {
        return false;
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('match',
function(aSelector, anObject) {

    /**
     * @method match
     * @summary Tests anObject using aSelector, to see if there's a match. This
     *     method is a convenience wrapper intended to help make string, regular
     *     expression, and css selector testing more polymorphic.
     * @param {String|RegExp|Object} aSelector A string, regular expression, or
     *     other object implementing 'test'.
     * @param {Object} anObject The object (usually string or node) to test.
     * @returns {Boolean} True if there's a match.
     */

    if (TP.canInvoke(aSelector, 'test')) {
        return aSelector.test(anObject);
    } else if (TP.canInvoke(anObject, 'equalTo')) {
        //  NOTE that we invert things here to avoid overly-simplistic
        //  checks for equality...we let the object decide
        return anObject.equalTo(aSelector);
    } else {
        /* eslint-disable eqeqeq */
        return aSelector == anObject;
        /* eslint-enable eqeqeq */
    }
});

//  ------------------------------------------------------------------------
//  INFERENCING - PART I (stubs)
//  ------------------------------------------------------------------------

/**
 * TIBET augments the programmer with built-in support for inferring object
 * functionality in certain cases. This capability helps keep code size smaller
 * while supporting a faster development cycle and significantly increased level
 * of functionality. The trigger for inferencing is the TP.sys.dnu function or
 * DNU, also referred to as the 'backstop'.
 */

//  ------------------------------------------------------------------------

TP.sys.defineMethod('dnu',
function() {

    /**
     * @method dnu
     * @summary The 'backstop' for TIBET inferencing. When inferencing is
     *     enabled this method is the entry point.
     * @returns {undefined}
     */

    return;
});

//  ------------------------------------------------------------------------
//  ENCAPSULATION - PART II (PostPatch)
//  ------------------------------------------------------------------------

String.Inst.defineMethod('asCSSName',
function() {

    /**
     * @method asCSSName
     * @summary Returns a new string converted into its equivalent CSS property
     *     name. For example, backgroundColor becomes 'background-color',
     *     'cssFloat' becomes 'float', etc. NOTE that strings which are not
     *     valid CSS keys return null.
     * @returns {String} A valid CSS property name, or null if the receiver
     *     can't produce a valid key.
     */

    var str;

    str = this.toString();

    if (TP.regex.CSS_CUSTOM_PROPERTY_NAME.test(str)) {
        return str;
    }

    if (str === 'cssFloat') {
        return 'float';
    }

    return str.asHyphenated();
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asDOMName',
function() {

    /**
     * @method asDOMName
     * @summary Returns a new string converted into its equivalent DOM property
     *     name. For example, background-color becomes backgroundColor, float
     *     becomes 'cssFloat', etc. NOTE that strings which are not valid CSS
     *     keys return null.
     * @returns {String} A valid DOM property name, or null if the receiver
     *     can't produce a valid key.
     */

    var str;

    str = this.toString();

    if (TP.regex.CSS_CUSTOM_PROPERTY_NAME.test(str)) {
        return str;
    }

    if (str === 'float') {
        return 'cssFloat';
    }

    return str.asCamelCase();
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('clearTextContent',
function() {

    /**
     * @method clearTextContent
     * @summary Clears out any text content of mutable items in the receiver,
     *     thereby clearing all of the non-mutable (primitive) items and leaving
     *     just the data structure.
     * @description At this type level, this method does nothing.
     * @returns {Object} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getProperty',
function(attributeName) {

    /**
     * @method getProperty
     * @summary Returns the value, if any, for the attribute provided. This
     *     method takes over when get() fails to find a specific getter or an
     *     aspect adapted getter.
     * @param {String} attributeName The name of the attribute to get.
     * @returns {Object|undefined} The value of the property on the receiver.
     */

    var val;

    //  no method and no adaptation so check slot directly
    val = this.$get(attributeName);
    if (TP.isDefined(val)) {
        return val;
    }

    //  we could use the inferencer, although that only works on rare
    //  occasions -- most people don't equate a get() call with a request
    //  for type conversion -- so this is usually off
    if (TP.sys.$$shouldUseBackstop()) {
        //  don't pass attributeName in modified form so the backstop can
        //  work from original data
        return TP.sys.dnu(this, 'get' + attributeName,
                            arguments,
                            arguments);
    }

    //  if backstop is off and data isn't found, no other choices
    return;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getAccessPathAliases',
function(aPath) {

    /**
     * @method getAccessPathAliases
     * @summary Returns an Array of 'access path aliases' - that is, the
     *     aliased names that the receiver uses for a particular path (i.e.
     *     '/person/lastName' might map to 'lastName').
     * @param {String} aPath The path to check for aliases.
     * @returns {String[]|null} An Array of access path aliases for the receiver
     *     or null.
     */

    //  At this level, we just return null. See the implementation on
    //  TP.lang.RootObject for a real implementation of this method.
    return null;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getAccessPathFor',
function(attributeName, facetName, originalPath) {

    /**
     * @method getAccessPathFor
     * @summary Returns any access path facet value, if any, for the attribute
     *     and facet provided. See the 'TP.sys.addMetadata()' call for more
     *     information about facets.
     * @param {String} attributeName The name of the attribute to get the access
     *     path facet value for.
     * @param {String} facetName The name of the facet to get the access path
     *     facet value for.
     * @param {TP.core.AccessPath} [originalPath] An optional access path that
     *     the attribute name might have been derived from. Sometimes it is
     *     useful to have access to the original path.
     * @returns {Object} Any access path value of the supplied facet of the
     *     supplied attribute. If there is no access path, this method returns
     *     null.
     */

    var internalSlotName,
        pathVal;

    //  This method gets called from every getter & setter in the whole system.
    //  When we look up descriptors, by default this occurs 'up' the entire type
    //  hierarchy of the receiver (see the getDescriptorFor() methods). These
    //  descriptors contain the access path settings for a particular attribute.

    //  Therefore, to avoid that lookup overhead we cache any access path for a
    //  particular attribute/facet pair on the object itself the first time it
    //  is looked up.

    internalSlotName = attributeName + '_' + facetName;

    if (!TP.owns(this, '$$attrnames_to_paths')) {

        //  NB: This is a JS literal object since this operates at a very low
        //  level and trying to use a TP.core.Hash here causes an endless
        //  recursion.
        this.$$attrnames_to_paths = {};
    }

    //  Note here how we use a 'not defined' test here because the value very
    //  well might be 'null' which means that there really is no *access path*
    //  value for this attribute/facet pair (there very well might be another
    //  type of value).
    if (TP.notDefined(pathVal = this.$$attrnames_to_paths[internalSlotName])) {

        pathVal = this.getFacetSettingFor(attributeName, facetName);

        if (TP.isValid(pathVal) && pathVal.isAccessPath()) {
            this.$$attrnames_to_paths[internalSlotName] = pathVal;
        } else {
            this.$$attrnames_to_paths[internalSlotName] = null;
            pathVal = null;
        }
    }

    return pathVal;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getAttributeNameFor',
function(aPath) {

    /**
     * @method getAttributeNameFor
     * @summary Returns any attribute name for the supplied access path, which
     *     should be an access path facet value, if any, for the supplied
     *     attribute name. See the 'TP.sys.addMetadata()' call for more
     *     information about facets.
     * @param {TP.core.AccessPath} aPath The access path that the attribute name
     *     might have been associated with as an access path facet.
     * @returns {String} The attribute name associated with the supplied access
     *     path value. If there is no attribute name associated with the
     *     supplied access path, this method returns null.
     */

    var pathStr,
        pathInfo;

    //  This method gets called from every getter & setter in the whole system.
    //  When we look up descriptors, by default this occurs 'up' the entire type
    //  hierarchy of the receiver (see the getDescriptorFor() methods). These
    //  descriptors contain the access path settings for a particular attribute.

    //  Therefore, to avoid that lookup overhead we cache any attribute name for
    //  a particular access pathon the object itself the first time it is looked
    //  up.

    if (!TP.owns(this, '$$paths_to_attrnames')) {

        //  NB: This is a JS literal object since this operates at a very low
        //  level and trying to use a TP.core.Hash here causes an endless
        //  recursion.
        this.$$paths_to_attrnames = {};
    }

    //  If will have been keyed by String representation of the path.
    pathStr = aPath.get('srcPath');

    //  Note here how we use a 'not defined' test here because the value very
    //  well might be 'null' which means that there really is no attribute name
    //  value for this access path.
    if (TP.notDefined(pathInfo = this.$$paths_to_attrnames[pathStr])) {

        pathInfo = this.getAccessPathAliases(pathStr, true);

        if (TP.notEmpty(pathInfo)) {
            pathInfo = pathInfo.first();
            this.$$paths_to_attrnames[pathStr] = pathInfo;
        } else {
            this.$$paths_to_attrnames[pathStr] = null;
            pathInfo = null;
        }
    }

    return pathInfo;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('computePathOrCustomAccessor',
function(prefix, attributeName) {

    /**
     * @method computePathOrCustomAccessor
     * @summary Returns any path or custom accessor Function (i.e.
     *     'getFoo'/'setFoo') that is associated with the supplied attribute
     *     name.
     * @param {String} prefix A prefix, either 'get' or 'set', to look up an
     *     associated custom accessor Function. This is not used for path
     *     lookup.
     * @param {String} attributeName The name of the attribute to use to look up
     *     an associated path or custom accessor Function.
     * @returns {Function|TP.path.AccessPath|null} The custom Function or path
     *     accessor for the supplied attribute name and prefix (the prefix is
     *     not used to search for paths). If there is no path or custom accessor
     *     Function associated with the attribute name, this method returns
     *     null.
     */

    //  The attributeName may come in as a String or as a subtype of
    //  TP.path.AccessPath.
    //  If it's a String, it can either be:
    //      1. A simple JS identifier, matching TP.regex.JS_IDENTIFIER
    //      2. A more complex path.
    //  If it's a subtype of TP.path.AccessPath, either can either be:
    //      1. A path that contains a simple JS identifier, matching
    //      TP.regex.JS_IDENTIFIER
    //      2. A more complex path.
    //  In both cases, the path might have a 'custom' getter or setter.

    var path,
        pathStr,

        func,

        simplePath,

        attrName;

    //  If it's a TP.path.AccessPath
    if (!TP.isString(attributeName) && attributeName.isAccessPath()) {

        //  The attribute name is a path and we also want the String
        //  representation.
        path = attributeName;
        pathStr = path.get('srcPath');

        //  If it's a path with a simple String (i.e. 'foo').
        if (TP.regex.JS_IDENTIFIER.test(pathStr)) {

            //  Grab any custom accessor using the prefix, the Stringified path
            //  and the path object. If this path resolves back to an attribute
            //  name (i.e. 'foo') that has a custom accessor associated with it
            //  (i.e. 'getFoo'), then that Function will be returned here.
            func = this.getCustomAccessor(prefix, pathStr, path);

            if (TP.isValid(func)) {
                return func;
            }

            //  See if the Stringified path, under the 'value' facet and the
            //  path object, has an access path. If so, then we found a path for
            //  the simple attribute name (e.g. 'foo')
            simplePath = this.getAccessPathFor(pathStr, 'value', path);
            if (TP.isValid(simplePath)) {
                path = simplePath;
            }
        } else {
            //  Otherwise, see if we have an attribute name associated with the
            //  path. This would have been set as part of the attribute
            //  definition process. We want to see if that then has a custom
            //  accessor.
            attrName = this.getAttributeNameFor(path);
            if (TP.notEmpty(attrName)) {
                //  If we found an attribute name for the path - check it see if
                //  it has a custom accessor Function.
                func = this.getCustomAccessor(prefix, attrName, path);

                if (TP.isValid(func)) {
                    return func;
                }
            }
        }
    } else if (TP.regex.NON_SIMPLE_PATH.test(attributeName)) {
        //  If the attribute name was String, but is a 'non simple path' (i.e.
        //  not a simplistic standalone 'foo' or whatever), then create a path
        //  object from it.
        path = TP.apc(attributeName, TP.hc('shouldCollapse', true));
    } else {
        //  Otherwise, see if the String attribute name has an access path that
        //  was defined for it's 'value' aspect.
        path = this.getAccessPathFor(attributeName, 'value');

        //  And then whether it has a custom accessor Function.
        func = this.getCustomAccessor(prefix, attributeName, path);

        if (TP.isValid(func)) {
            return func;
        }
    }

    //  If a custom accessor Function wasn't returned earlier and path is not
    //  valid, this will return null.

    return path;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getDescriptorFor',
function(attributeName, includeSupertypes) {

    /**
     * @method getDescriptorFor
     * @summary Returns the property descriptor, if any, for the type
     *     attribute provided. See the 'TP.sys.addMetadata()' call for more
     *     information about property descriptors.
     * @param {String} attributeName The name of the attribute to get the
     *     property descriptor for.
     * @param {Boolean} includeSupertypes Whether or not to include the
     *     receiver's supertypes when looking for property descriptors. The
     *     default is true.
     * @returns {Object} The property descriptor of the attribute on the
     *     receiver.
     */

    //  At this level, we just return null. See the implementation on
    //  TP.lang.RootObject for a real implementation of this method.
    return null;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getInstDescriptorFor',
function(attributeName, includeSupertypes) {

    /**
     * @method getInstDescriptorFor
     * @summary Returns the property descriptor, if any, for the instance
     *     attribute provided. See the 'TP.sys.addMetadata()' call for more
     *     information about property descriptors.
     * @param {String} attributeName The name of the attribute to get the
     *     property descriptor for.
     * @param {Boolean} includeSupertypes Whether or not to include the
     *     receiver's supertypes when looking for property descriptors. The
     *     default is true.
     * @returns {Object} The property descriptor of the attribute on the
     *     receiver.
     */

    //  At this level, we just return null. See the implementation on
    //  TP.lang.RootObject for a real implementation of this method.
    return null;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getFacetSettingFor',
function(attributeName, facetName) {

    /**
     * @method getFacetSettingFor
     * @summary Returns any facet setting, if any, for the type attribute and
     *     facet provided. See the 'TP.sys.addMetadata()' call for more
     *     information about facets.
     * @param {String} attributeName The name of the attribute to get the facet
     *     value for.
     * @param {String} facetName The name of the facet to get the facet value
     *     for.
     * @returns {Object} The value of the supplied facet of the supplied
     *     attribute.
     */

    var descriptor;

    descriptor = this.getDescriptorFor(attributeName);
    //  NB: We use primitive property access here since descriptors are
    //  primitive object.
    if (TP.isValid(descriptor)) {
        return descriptor[facetName];
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getInstFacetSettingFor',
function(attributeName, facetName) {

    /**
     * @method getInstFacetSettingFor
     * @summary Returns any facet value, if any, for the instance attribute and
     *     facet provided. See the 'TP.sys.addMetadata()' call for more
     *     information about facets.
     * @param {String} attributeName The name of the attribute to get the facet
     *     value for.
     * @param {String} facetName The name of the facet to get the facet value
     *     for.
     * @returns {Object} The value of the supplied facet of the supplied
     *     attribute.
     */

    var descriptor;

    descriptor = this.getInstDescriptorFor(attributeName);
    //  NB: We use primitive property access here since descriptors are
    //  primitive object.
    if (TP.isValid(descriptor)) {
        return descriptor[facetName];
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('get',
function(attributeName) {

    /**
     * @method get
     * @summary Returns the value, if any, for the attribute provided.
     * @description This method is a convenient wrapper that will automatically
     *     look for getAttributeName(), getattributeName(), .attribute, etc. to
     *     return the value. Using this method provides a way to fully
     *     encapsulate an attribute access whether the receiver has implemented
     *     a getter or not. Once a getter is implemented it is automatically
     *     used. Getters should follow the normal coding convention of
     *     this.attributeName for access while all others should use
     *     get('attributeName').
     * @param {String|TP.path.AccessPath} attributeName The name of the
     *     attribute to get.
     * @returns {Object} The value of the attribute on the receiver.
     */

    var pathOrFunc,
        args;

    //  A shortcut - if the attribute name is '.' or '$_', then that's
    //  shorthand for returning ourselves.
    if (TP.regex.ONLY_PERIOD.test(attributeName) ||
        TP.regex.ONLY_STDIN.test(attributeName)) {
        return this;
    }

    //  Compute a path or a custom accessor Function for the supplied attribute
    //  name and prefix.
    pathOrFunc = this.computePathOrCustomAccessor('get', attributeName);

    //  If the result was a Function, then compute the arguments by converting
    //  them to an Array (slicing off the first argument, since we don't need
    //  the attribute name) and apply it.
    if (TP.isCallable(pathOrFunc)) {
        args = TP.args(arguments, 1);
        return pathOrFunc.apply(this, args);
    } else if (TP.isValid(pathOrFunc)) {
        //  Otherwise, it's a path so set the value using the path.
        return this.getUsingPath(pathOrFunc, arguments);
    }

    //  It's just a String that has no path or custom accessor. Let the standard
    //  mechanism handle it.
    return this.getProperty(attributeName);
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getPathSource',
function(aPath) {

    /**
     * @method getPathSource
     * @summary Return the current source object being used by the executeGet()
     *     and executeSet() methods. At this level, this method returns the
     *     receiver.
     * @param {TP.path.AccessPath} aPath The path that the path source will be
     *     used with.
     * @returns {Object} The object used as the current path source object.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getPathParameters',
function() {

    /**
     * @method getPathParameters
     * @summary Return the current set of path parameters being used by the
     *     executeGet() and executeSet() methods to resolve path parameters for
     *     parameterized paths. At this level, this method returns null.
     * @returns {Object} The object used to resolve path references in
     *     parameterized paths. This usually should either be an Array or a
     *     TP.core.Hash.
     */

    return null;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('isAccessPath',
function() {

    /**
     * @method isAccessPath
     * @summary Returns whether or not the receiver is an access path object.
     * @returns {Boolean} False - most receivers are not a path.
     */

    return false;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('get',
function() {

    /**
     * @method get
     * @summary Returns the value, if any, for the attribute provided.
     * @description For the TIBET object in particular we do a little extra
     *     processing here when the property in question is undefined. In that
     *     case we also check for a registered object using the property name as
     *     the key. This allows TP.sys.get() to act as a synonym for
     *     TP.sys.getObjectById() which is particularly useful when using TIBET
     *     as a bound source for shared data.
     * @param {String} attributeName The name of the attribute to get.
     * @returns {Object} The value of the attribute on the receiver.
     */

    var value;

    //  start by looking for a real property
    value = this.$get(arguments[0]);

    //  not real? not null? see if it's an object URL
    if (TP.notDefined(value)) {
        value = TP.sys.getObjectById(arguments[0]);
    }

    return value;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('get',
function(attributeName) {

    /**
     * @method get
     * @summary Returns the value, if any, for the attribute provided.
     * @description This method is a convenient wrapper that will automatically
     *     look for getAttributeName(), getattributeName(), .attribute, etc. to
     *     return the value. Using this method provides a way to fully
     *     encapsulate an attribute access whether the receiver has implemented
     *     a getter or not. Once a getter is implemented it is automatically
     *     used. Getters should follow the normal coding convention of
     *     this.attributeName for access while all others should use
     *     get('attributeName').
     * @param {String|TP.path.AccessPath} attributeName The name of the
     *     attribute to get.
     * @returns {Object} The value of the attribute on the receiver.
     */

    var pathOrFunc,
        args;

    //  A shortcut - if the attribute name is '.' or '$_', then that's
    //  shorthand for returning ourselves.
    if (TP.regex.ONLY_PERIOD.test(attributeName) ||
        TP.regex.ONLY_STDIN.test(attributeName)) {
        return this;
    }

    //  Compute a path or a custom accessor Function for the supplied attribute
    //  name and prefix.
    pathOrFunc = this.computePathOrCustomAccessor('get', attributeName);

    //  If the result was a Function, then compute the arguments by converting
    //  them to an Array (slicing off the first argument, since we don't need
    //  the attribute name) and apply it.
    if (TP.isCallable(pathOrFunc)) {
        args = TP.args(arguments, 1);
        return pathOrFunc.apply(this, args);
    } else if (TP.isValid(pathOrFunc)) {
        //  Otherwise, it's a path so set the value using the path.
        return this.getUsingPath(pathOrFunc, arguments);
    }

    //  It's just a String that has no path or custom accessor. Let the standard
    //  mechanism handle it.
    return this.getProperty(attributeName);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('get',
function(attributeName) {

    /**
     * @method get
     * @summary Returns the value, if any, for the attribute provided.
     * @param {String|TP.path.AccessPath} attributeName The name of the
     *     attribute to get.
     * @returns {Object} The value of the attribute on the receiver.
     */

    var pathOrFunc,
        args;

    //  A shortcut - if the attribute name is '.' or '$_', then that's
    //  shorthand for returning ourselves.
    if (TP.regex.ONLY_PERIOD.test(attributeName) ||
        TP.regex.ONLY_STDIN.test(attributeName)) {
        return this;
    }

    //  Compute a path or a custom accessor Function for the supplied attribute
    //  name and prefix.
    pathOrFunc = this.computePathOrCustomAccessor('get', attributeName);

    //  If the result was a Function, then compute the arguments by converting
    //  them to an Array (slicing off the first argument, since we don't need
    //  the attribute name) and apply it.
    if (TP.isCallable(pathOrFunc)) {
        args = TP.args(arguments, 1);
        return pathOrFunc.apply(this, args);
    } else if (TP.isValid(pathOrFunc)) {
        //  Otherwise, it's a path so set the value using the path.
        return this.getUsingPath(pathOrFunc, arguments);
    }

    //  It's just a String that has no path or custom accessor. Let the standard
    //  mechanism handle it.
    return this.getProperty(attributeName);
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getCustomAccessor',
function(prefix, attributeName, path) {

    /**
     * @method getCustomAccessor
     * @summary Returns any custom accessor Function defined with the supplied
     *     prefix and attribute name (i.e. 'getFoo').
     * @param {String} prefix A prefix, either 'get' or 'set', to look up an
     *     associated custom accessor Function.
     * @param {String} attributeName The name of the attribute to use to look up
     *     an associated custom accessor Function.
     * @param {TP.path.AccessPath} [path] An optional path that is associated
     *     with the supplied attribute name and should be invoked when the
     *     attribute name is 'get' or 'set'. This is used to provide a
     *     convenience mechanism when a custom accessor is provided. The caller
     *     can simply 'callNextMethod' and the path will be executed.
     * @returns {Function|null} The custom Function accessor for the supplied
     *     attribute name and prefix. If there is no custom accessor Function
     *     associated with the attribute name, this method returns null.
     */

    var funcName,

        func,
        realFunc,

        nextMethod,

        newFunc;

    //  If its got a custom accessor, return that.
    funcName = prefix + TP.makeStartUpper(attributeName);
    if (TP.canInvoke(this, funcName)) {
        func = this[funcName];

        //  Grab the 'real function' - the defined getter/setter may be a CNM
        //  wrapper or an MI resolved method or a spy method if we're using the
        //  test harness.
        realFunc = TP.getRealFunction(func);

        //  We use the 'callNextMethod' (CNM) functionality in custom accessors
        //  to allow a caller to just 'call up' when they're done with specific
        //  accessor logic. Semantically, this does what CNM normally does - the
        //  'next most specific' logic. For a getter or setter, this will get or
        //  set the value. This is a convenience since, although for simple
        //  attributes, '$get' or '$set' can be called, for more complex
        //  scenarios involving a TP.path.AccessPath, it is unknown inside of
        //  this method what the path associated with the attribute name is.
        //  Therefore, this provides a very convenient mechanism for attributes
        //  that have both a custom accessor *and* use a path to set/get their
        //  value.

        //  See if the function already has a 'next most specific method'.
        nextMethod = this.getNextMethod(realFunc);

        //  If it does, we do *not* replace it. We rely on our supertype to 'do
        //  the right thing' to get/set the value (which might very well use
        //  this mechanism at its level).
        if (TP.isValid(nextMethod)) {
            return func;
        }

        //  If the optional path associated with the attribute name was
        //  supplied
        if (TP.isValid(path)) {
            //  Build a Function that that will get or set using either
            //  'getUsingPath' or 'setUsingPath'.
            newFunc = function(attributeValue, shouldSignal) {
                var args;

                args = TP.ac(arguments);
                args.unshift(newFunc.path);

                //  Note that getUsingPath/setUsingPath take an Array of
                //  arguments as their second parameter - no apply().
                return this[prefix + 'UsingPath'](newFunc.path, args);
            };

            newFunc.path = path;
        } else {
            //  Otherwise, build a Function that that will get or set using
            //  either 'getProperty' or 'setProperty'.
            newFunc = function(attributeValue, shouldSignal) {
                var args;

                args = TP.ac(arguments);
                args.unshift(newFunc.attrName);

                //  Note that getProperty/setProperty need to be apply()ed.
                return this[prefix + 'Property'].apply(this, args);
            };

            newFunc.attrName = attributeName;
        }

        //  Install the newly created Function as the '$$nextfunc' (the one that
        //  will be invoked with CNM) on the *real* Function.
        realFunc.$$nextfunc = newFunc;

        return func;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getUsingPath',
function(aPath, pathArgs) {

    /**
     * @method getUsingPath
     * @summary Returns the value produced by executing the supplied path
     *     with the supplied arguments against the receiver.
     * @param {TP.path.AccessPath} aPath The path to execute.
     * @param {Object[]|arguments} pathArgs The Array of arguments to execute
     *     with.
     * @returns {Object} The value produced by executing the path.
     */

    var args;

    //  Note here how, if we were given more than 1 argument, we grab all
    //  of the arguments supplied and make our path source the first argument.
    //  Otherwise, we make an Array that has our path source and our 'path
    //  parameters' as the last argument. In both cases, this is because
    //  executeGet() takes varargs (in case the path is parameterized).
    if (pathArgs.length > 1) {
        args = TP.copy(pathArgs);
        args.atPut(0, this.getPathSource(aPath));
    } else {
        args = TP.ac(this.getPathSource(aPath), this.getPathParameters());
    }

    return aPath.executeGet.apply(aPath, args);
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('getContent',
function() {

    /**
     * @method getContent
     * @summary Returns the 'content' of the receiver. The default version is a
     *     synonym for getValue.
     * @returns {Object} The value of the receiver.
     */

    return this.getValue();
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('getValue',
function() {

    /**
     * @method getValue
     * @summary Returns the 'value' of the receiver. This method follows a
     *     search path looking for a slot named value, _value, $value, and
     *     finally this.
     * @returns {Object} The value of the receiver.
     */

    var val;

    //  nodes are a bit strange since we can't rely on inheritance to
    //  instrument them in the tree, and we need polymorphic methods to "do
    //  the right thing"
    if (TP.isNode(this)) {
        return TP.tpnode(this).getValue();
    }

    val = this.$get('value');
    if (TP.isDefined(val)) {
        return val;
    }

    //  default to the object itself...this is what makes this version
    //  different from a standard get('value') call.
    return this;
});

//  ------------------------------------------------------------------------

Boolean.Inst.defineMethod('getValue',
function() {

    /**
     * @method getValue
     * @summary Returns the primitive value of the receiver.
     * @returns {Boolean} The value of the receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('getValue',
function() {

    /**
     * @method getValue
     * @summary Returns the primitive value of the receiver.
     * @returns {Number} The value of the receiver.
     */

    return this + 0;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('getValue',
function() {

    /**
     * @method getValue
     * @summary Returns the primitive value of the receiver.
     * @returns {String} The value of the receiver.
     */

    //  Make sure to force the conversion to a primitive string.
    return this.toString();
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('setProperty',
function(attributeName, attributeValue, shouldSignal) {

    /**
     * @method setProperty
     * @summary Sets the value of the named property. The base version is a
     *     simple wrapper around $set however other types override this method
     *     to provide custom behavior.
     * @param {String} attributeName The attribute name to set.
     * @param {Object} attributeValue The value to set.
     * @param {Boolean} shouldSignal If false no signaling occurs. Defaults to
     *     this.shouldSignalChange().
     * @returns {Object} The receiver.
     */

    return this.$set(attributeName, attributeValue, shouldSignal);
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('set',
function(attributeName, attributeValue, shouldSignal) {

    /**
     * @method set
     * @summary Sets the value of the named attribute to the value provided. If
     *     no value is provided the value null is used.
     * @description As with get('attr') this method is a convenient
     *     encapsulation wrapper that will look for setAttribute, setattribute,
     *     and this.attribute to determine how to proceed. No notification is
     *     provided by this method if either function is found, however if the
     *     value is set directly at the attribute level this method will signal
     *     Change as appropriate. This allows the developer of a setter function
     *     complete control over behavior without fear of side-effects.
     * @param {String|TP.path.AccessPath} attributeName The name of the
     *     attribute to set.
     * @param {Object} attributeValue The value to set.
     * @param {Boolean} shouldSignal If false no signaling occurs. Defaults to
     *     this.shouldSignalChange().
     * @returns {Object} The receiver.
     */

    var pathOrFunc,
        args;

    if (!TP.isMutable(this)) {
        return this.raise('TP.sig.NonMutableInstance',
                            attributeName);
    }

    if (TP.isEmpty(attributeName)) {
        return this.raise('TP.sig.InvalidKey');
    }

    //  Compute a path or a custom accessor Function for the supplied attribute
    //  name and prefix.
    pathOrFunc = this.computePathOrCustomAccessor('set', attributeName);

    //  If the result was a Function, then compute the arguments by converting
    //  them to an Array (slicing off the first argument, since we don't need
    //  the attribute name) and apply it.
    if (TP.isCallable(pathOrFunc)) {
        args = TP.args(arguments, 1);
        return pathOrFunc.apply(this, args);
    } else if (TP.isValid(pathOrFunc)) {
        //  Otherwise, it's a path so set the value using the path.
        return this.setUsingPath(pathOrFunc, arguments);
    }

    //  It's just a String that has no path or custom accessor. Let the standard
    //  mechanism handle it.
    return this.setProperty(attributeName, attributeValue, shouldSignal);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('set',
function(attributeName, attributeValue, shouldSignal) {

    /**
     * @method set
     * @summary Sets the value of the named attribute to the value provided. If
     *     no value is provided the value null is used.
     * @description As with get('attr') this method is a convenient
     *     encapsulation wrapper that will look for setAttribute, setattribute,
     *     and this.attribute to determine how to proceed. No notification is
     *     provided by this method if either function is found, however if the
     *     value is set directly at the attribute level this method will signal
     *     Change as appropriate. This allows the developer of a setter function
     *     complete control over behavior without fear of side-effects.
     * @param {String|TP.path.AccessPath} attributeName The name of the
     *     attribute to set.
     * @param {Object} attributeValue The value to set.
     * @param {Boolean} shouldSignal If false no signaling occurs. Defaults to
     *     this.shouldSignalChange().
     * @returns {Object} The receiver.
     */

    var pathOrFunc,
        args;

    if (TP.isEmpty(attributeName)) {
        return this.raise('TP.sig.InvalidKey');
    }

    //  Compute a path or a custom accessor Function for the supplied attribute
    //  name.
    pathOrFunc = this.computePathOrCustomAccessor('set', attributeName);

    //  If the result was a Function, then compute the arguments by converting
    //  them to an Array (slicing off the first argument, since we don't need
    //  the attribute name) and apply it.
    if (TP.isCallable(pathOrFunc)) {
        args = TP.args(arguments, 1);
        return pathOrFunc.apply(this, args);
    } else if (TP.isValid(pathOrFunc)) {
        return this.setUsingPath(pathOrFunc, arguments);
    }

    //  It's just a String that has no path or custom accessor. Let the standard
    //  mechanism handle it.
    return this.setProperty(attributeName, attributeValue, shouldSignal);
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('setUsingPath',
function(aPath, pathArgs) {

    /**
     * @method setUsingPath
     * @summary Sets the value in the path arguments by executing the supplied
     *     path with the supplied arguments against the receiver.
     * @param {TP.path.AccessPath} aPath The path to execute.
     * @param {Object[]|arguments} pathArgs The Array of arguments to execute
     *     the path with.
     * @returns {Object} The value produced by executing the path.
     */

    var args;

    //  Note here how, if we were given more than 3 arguments, we grab all
    //  of the arguments supplied and make our path source the first argument.
    //  Otherwise, we make an Array that has our path source as the first
    //  argument, the 'value' and 'shouldSignal' flags as our 2nd and 3rd
    //  arguments respectively  and our 'path parameters' as the last argument.

    //  In both cases, this is because executeSet() takes varargs (in case the
    //  path is parameterized).
    if (pathArgs.length > 3) {
        args = TP.copy(pathArgs);
        args.atPut(0, this.getPathSource(aPath));
    } else {
        //  NB: Note the 'primitive' access here - pathArgs might be a
        //  'primitive' 'arguments' object.
        args = TP.ac(this.getPathSource(aPath),
                        pathArgs[1],
                        pathArgs[2],
                        this.getPathParameters());
    }

    return aPath.executeSet.apply(aPath, args);
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('setValue',
function(aValue) {

    /**
     * @method setValue
     * @summary Sets the 'value' of the receiver. This method provides
     *     polymorphic behavior by allowing objects to serve as ValueHolders.
     *     The search for variable slots follows value, _value, and $value. This
     *     method calls changed if the value changes.
     * @param {Object} aValue The value to set the value of the receiver to.
     * @returns {Boolean} Whether or not the value was changed from the value it
     *     had before this method was called.
     */

    this.$set('value', aValue);

    return true;
});

//  ------------------------------------------------------------------------
//  DEBUGGING
//  ------------------------------------------------------------------------

TP.sys.defineMethod('hasDebugger',
function() {

    /**
     * @method hasDebugger
     * @summary Returns true if there's a TIBET implementation of a 'debugger'
     *     available. This might be the case when running in Mozilla and
     *     leveraging the Venkman API for example.
     * @returns {Boolean} Whether or not the environment has a debugger
     *     available.
     */

    //  default is no
    return false;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('runDebugger',
function(callingContext) {

    /**
     * @method runDebugger
     * @summary If there's a TIBET implementation of a debugging tool this
     *     function will run it if possible.
     * @param {Function|arguments} callingContext The context to debug.
     * @returns {TP.sys} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('$launchDebugger',
function(callingContext) {

    /**
     * @method $launchDebugger
     * @summary Launches the TIBET debugger if one is installed.
     * @description This method is invoked by TP.sys.dnu as a last resort. When
     *     TP.sys.hasDebugger() is true whatever implementation of
     *     TP.sys.runDebugger() is in effect will be called. When TIBET doesn't
     *     have a debugger installed the native debugger trigger will be invoked
     *     via the 'debugger' statement. Note that this will only occur if
     *     TP.sys.shouldUseDebugger() is true. Also note that the native
     *     debuggers will only become visible if a) installed and b) are already
     *     open.
     * @param {Function|arguments} callingContext The calling context.
     * @returns {TP.sys} The receiver.
     */

    if (this.hasDebugger()) {
        this.runDebugger(callingContext);
    } else {
        //  on IE or Mozilla this will foreground the native debugger, if
        //  installed and open. but it's a bit flaky.
        try {
            /* eslint-disable no-debugger */
            debugger;
            /* eslint-enable no-debugger */
        } catch (e) {
            void 0;
        }
    }

    return this;
});

//  ------------------------------------------------------------------------
//  DUPLICATION
//  ------------------------------------------------------------------------

/**
 * In a pure prototype-based system this is how we'd do everything...copy
 * something that's already there and then tweak it. But there's no built-in
 * copy command for objects in JavaScript and deep-copy semantics are difficult
 * in any case. We do the best we can by implementing a simple copy operation
 * that handles most situations.
 */

//  ------------------------------------------------------------------------

TP.defineCommonMethod('copy',
function(deep, aFilterNameOrKeys, contentOnly) {

    /**
     * @method copy
     * @summary Returns a copy of the receiver. The filter defines which keys
     *     are used to select from the receiver.
     * @param {Boolean} [deep=false] True to force clones to be deep.
     * @param {String|String[]} [aFilterNameOrKeys] get*Interface() filter or
     *     key array.
     * @param {Boolean} [contentOnly=true] Copy content only? This parameter is
     *     ignored for this type.
     * @returns {Object} A copy of the receiver.
     */

    var i,
        keys,
        newinst,
        filter,

        len,
        ndx,
        val;

    newinst = this.getType().construct();

    if (!TP.isArray(keys = aFilterNameOrKeys)) {
        filter = TP.ifInvalid(aFilterNameOrKeys, TP.UNIQUE);
        keys = this.getLocalInterface(filter);
    }

    len = keys.getSize();
    for (i = 0; i < len; i++) {
        ndx = keys.at(i);
        val = this.at(ndx);

        if (TP.isTrue(deep) && TP.isReferenceType(val)) {
            //  NB: We do *not* pass along the filter name or keys here
            val = TP.copy(val, deep, null, contentOnly);
        }

        newinst.$set(ndx, val, false, true);
    }

    return newinst;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('copy',
function(deep, aFilterNameOrKeys, contentOnly) {

    /**
     * @method copy
     * @summary Returns a copy of the receiver. If contentOnly is true then an
     *     Array is returned contains only the content values [0, 1, ...N], and
     *     no 'special values' on the receiver are copied.
     * @param {Boolean} [deep=false] True to force clones to be deep.
     * @param {String|String[]} aFilterNameOrKeys get*Interface() filter or key
     *     array.
     * @param {Boolean} [contentOnly=true] Copy content only?
     * @returns {Object[]} A copy of the receiver.
     */

    var onlyContent,

        newinst,

        filter,
        keys,

        len,
        i,
        ndx,
        val;

    onlyContent = TP.ifInvalid(contentOnly, true);
    if (onlyContent) {
        //  content only, we can optimize with a native call
        return this.slice(0, this.length);
    } else {
        //  looking for a filtered set of properties, have to reflect
        newinst = TP.ac();

        filter = TP.ifInvalid(aFilterNameOrKeys, TP.UNIQUE);

        if (TP.isString(filter)) {
            keys = this.getLocalInterface(filter);
        } else if (TP.isArray(filter)) {
            keys = filter;
        } else {
            //  Unusable filter
            return newinst;
        }

        len = keys.getSize();

        for (i = 0; i < len; i++) {
            ndx = keys.at(i);
            val = this.at(ndx);

            if (TP.isTrue(deep) && TP.isReferenceType(val)) {
                //  NB: We do *not* pass along the filter name or keys here
                val = TP.copy(val, deep, null, contentOnly);
            }

            newinst.$set(ndx, val, false, true);
        }
    }

    return newinst;
});

//  ------------------------------------------------------------------------

Boolean.Inst.defineMethod('copy',
function(deep, aFilterNameOrKeys, contentOnly) {

    /**
     * @method copy
     * @summary Returns a 'copy' of the receiver. Actually, a new instance
     *     whose value is equalTo that of the receiver.
     * @param {Boolean} [deep=false] True to force clones to be deep. This
     *     parameter is ignored for this type.
     * @param {String|String[]} aFilterNameOrKeys get*Interface() filter or key
     *     array. This parameter is ignored for this type.
     * @param {Boolean} [contentOnly=true] Copy content only? This parameter is
     *     ignored for this type.
     * @returns {Boolean} A copy of the receiver.
     */

    return TP.bc(this);
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('copy',
function(deep, aFilterNameOrKeys, contentOnly) {

    /**
     * @method copy
     * @summary Returns a 'copy' of the receiver. Actually, a new instance
     *     whose value is equalTo that of the receiver.
     * @param {Boolean} [deep=false] True to force clones to be deep.
     * @param {String|String[]} aFilterNameOrKeys get*Interface() filter or key
     *     array.
     * @param {Boolean} [contentOnly=true] Copy content only?
     * @returns {Date} A copy of the receiver.
     */

    var newinst,

        onlyContent,

        filter,
        keys,

        len,
        i,
        ndx,
        val;

    newinst = TP.dc(this.getTime());

    onlyContent = TP.ifInvalid(contentOnly, true);
    if (onlyContent) {
        //  content only
        return newinst;
    } else {
        filter = TP.ifInvalid(aFilterNameOrKeys, TP.UNIQUE);

        if (TP.isString(filter)) {
            keys = this.getLocalInterface(filter);
        } else if (TP.isArray(filter)) {
            keys = filter;
        } else {
            //  Unusable filter
            return newinst;
        }

        len = keys.getSize();

        for (i = 0; i < len; i++) {
            ndx = keys.at(i);
            val = this.at(ndx);

            if (TP.isTrue(deep) && TP.isReferenceType(val)) {
                //  NB: We do *not* pass along the filter name or keys here
                val = TP.copy(val, deep, null, contentOnly);
            }

            newinst.$set(ndx, val, false, true);
        }
    }

    return newinst;
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('copy',
function(deep, aFilterNameOrKeys, contentOnly) {

    /**
     * @method copy
     * @summary Returns a 'copy' of the receiver. Actually, a new instance
     *     whose value is equalTo that of the receiver. When copying a function
     *     the original is instrumented to know how many copies have been made
     *     and the new copy has the name of the original with an _n appended
     *     where n is the copy number.
     * @param {Boolean} [deep=false] True to force clones to be deep.
     * @param {String|String[]} aFilterNameOrKeys get*Interface() filter or key
     *     array.
     * @param {Boolean} [contentOnly=true] Copy content only?
     * @returns {Function} A copy of the receiver.
     */

    var count,
        source,
        $$funcCopy,
        realFunc,

        onlyContent,

        filter,
        keys,

        len,
        i,
        ndx,
        val;

    //  NB: We don't use TP.getRealFunction() here, since we're not interested
    //  in any trait '$resolutionMethod' slots.
    realFunc = this.$realFunc || this;

    //  track number of copies
    count = realFunc.$$copyCount || 0;
    count++;
    realFunc.$$copyCount = count;

    //  trick here is to turn the receiver's source into source for an
    //  anonymous function so we don't just get another with the same name
    //  Note the non-greediness of the RegExp here - don't want to match
    //  past the actual end of the parameter list.
    source = '$$funcCopy = ' +
                realFunc.toString().replace(/function (.*?)\(/,
                    'function $1_' + count + '(');
    /* eslint-disable no-eval */
    eval(source);
    /* eslint-enable no-eval */
    $$funcCopy.$realFunc = realFunc;

    onlyContent = TP.ifInvalid(contentOnly, true);
    if (onlyContent) {
        return $$funcCopy;
    } else {
        filter = TP.ifInvalid(aFilterNameOrKeys, TP.UNIQUE);

        if (TP.isString(filter)) {
            keys = realFunc.getLocalInterface(filter);
        } else if (TP.isArray(filter)) {
            keys = filter;
        } else {
            //  Unusable filter
            return $$funcCopy;
        }

        len = keys.getSize();

        for (i = 0; i < len; i++) {
            ndx = keys.at(i);
            val = realFunc.at(ndx);

            if (TP.isTrue(deep) && TP.isReferenceType(val)) {
                //  NB: We do *not* pass along the filter name or keys here
                val = TP.copy(val, deep, null, contentOnly);
            }

            $$funcCopy.$set(ndx, val, false, true);
        }
    }

    return $$funcCopy;
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('copy',
function(deep, aFilterNameOrKeys, contentOnly) {

    /**
     * @method copy
     * @summary Returns a 'copy' of the receiver. Actually, a new instance
     *     whose value is equalTo that of the receiver.
     * @param {Boolean} [deep=false] True to force clones to be deep. This
     *     parameter is ignored for this type.
     * @param {String|String[]} aFilterNameOrKeys get*Interface() filter or key
     *     array. This parameter is ignored for this type.
     * @param {Boolean} [contentOnly=true] Copy content only? This parameter is
     *     ignored for this type.
     * @returns {Number} A copy of the receiver.
     */

    return TP.nc(this);
});

//  ------------------------------------------------------------------------

RegExp.Inst.defineMethod('copy',
function(deep, aFilterNameOrKeys, contentOnly) {

    /**
     * @method copy
     * @summary Returns a 'copy' of the receiver. Actually, a new instance
     *     whose value is equalTo that of the receiver.
     * @param {Boolean} [deep=false] True to force clones to be deep.
     * @param {String|String[]} aFilterNameOrKeys get*Interface() filter or key
     *     array.
     * @param {Boolean} [contentOnly=true] Copy content only?
     * @returns {RegExp} A copy of the receiver.
     */

    var newinst,

        onlyContent,

        filter,
        keys,

        len,
        i,
        ndx,
        val;

    newinst = TP.rc(this.toString());

    onlyContent = TP.ifInvalid(contentOnly, true);
    if (onlyContent) {
        //  content only
        return newinst;
    } else {
        filter = TP.ifInvalid(aFilterNameOrKeys, TP.UNIQUE);

        if (TP.isString(filter)) {
            keys = this.getLocalInterface(filter);
        } else if (TP.isArray(filter)) {
            keys = filter;
        } else {
            //  Unusable filter
            return newinst;
        }

        len = keys.getSize();

        for (i = 0; i < len; i++) {
            ndx = keys.at(i);
            val = this.at(ndx);

            if (TP.isTrue(deep) && TP.isReferenceType(val)) {
                //  NB: We do *not* pass along the filter name or keys here
                val = TP.copy(val, deep, null, contentOnly);
            }

            newinst.$set(ndx, val, false, true);
        }
    }

    return newinst;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('copy',
function(deep, aFilterNameOrKeys, contentOnly) {

    /**
     * @method copy
     * @summary Returns a 'copy' of the receiver. Actually, a new instance
     *     whose value is equalTo that of the receiver.
     * @param {Boolean} [deep=false] True to force clones to be deep. This
     *     parameter is ignored for this type.
     * @param {String|String[]} aFilterNameOrKeys get*Interface() filter or key
     *     array. This parameter is ignored for this type.
     * @param {Boolean} [contentOnly=true] Copy content only? This parameter is
     *     ignored for this type.
     * @returns {String} A copy of the receiver.
     */

    return TP.sc(this);
});

//  ------------------------------------------------------------------------
//  ITERATION
//  ------------------------------------------------------------------------

/**
 * JavaScript iteration is a real problem when handed an object which could be
 * of any type, and TP.ObjectProto has been modified. The iteration methods
 * here provide a common interface to iteration which ensures consistency and
 * proper behavior regardless. You can still use for/in for very limited cases
 * but TIBET's iteration methods, as well as our get*Interface calls, are a
 * much better way to either iterate or reflect on an object.

 * TIBET's iteration methods are based on the Smalltalk and Ruby APIs for
 * iteration, much in the same way TIBET mirrors their collection APIs.
 * Additional iteration methods mirroring those found natively in Mozilla
 * (every, some, map, etc. are found later in the kernel as well). We've
 * extended these functions from the Mozilla API slightly to offer first and
 * last element checking as well as the ability to break/continue from a nested
 * loop construct quickly. Reverse iteration is also supported in many cases.
 */

//  ------------------------------------------------------------------------

TP.defineCommonMethod('perform',
function(aFunction) {

    /**
     * @method perform
     * @summary Performs the function with each item of the receiver where an
     *     item is typically a key/value pair in array form.
     * @description Perform can be used as an alternative to constructing for
     *     loops to iterate over a collection.
     * @param {Function} aFunction A function which performs some action with
     *     the element it is passed.
     * @returns {Object} The receiver.
     */

    var i,
        k,
        len;

    //  this works effectively for most object, even if it has to iterate
    //  once using for/in to acquire the list
    k = TP.keys(this);
    len = k.length;

    for (i = 0; i < len; i++) {
        //  second parameter is location of data, so it will vary based on
        //  direction, content, etc. NOTE here that it's the actual key
        //  (hash key) to the data value
        aFunction([k[i], this.at(k[i])], k[i]);
    }

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('perform',
function(aFunction) {

    /**
     * @method perform
     * @summary Performs the function with each element of the receiver. This
     *     is the core method in the iteration model, providing the basis for
     *     many of the other iteration aspects in TIBET.
     * @description Perform can be used as an alternative to constructing for
     *     loops to iterate over a collection.
     * @param {Function} aFunction A function which performs some action with
     *     the element it is passed.
     * @returns {Array} The receiver.
     */

    return this.forEach(aFunction);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('perform',
function(aFunction) {

    /**
     * @method perform
     * @summary Performs the function from 0 to N times where N is the value of
     *     the receiver. Note that negative numbers won't cause an iteration to
     *     occur.
     * @description Perform can be used as an alternative to constructing for
     *     loops to iterate over a collection.
     * @param {Function} aFunction A function which performs some action with
     *     the element it is passed.
     * @returns {Number} The receiver.
     */

    var i;

    for (i = 0; i < this; i++) {
        //  since we're using a number as our iteration control the
        //  value and index provided are the same. the perform call
        //  for each collection type deals with that in its own way
        aFunction(i, i);
    }

    return this;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('perform',
function(aFunction) {

    /**
     * @method perform
     * @summary Performs the function from 0 to N times where N is the length
     *     of the receiver. Each iteration receives one character from the
     *     string.
     * @description Perform can be used as an alternative to constructing for
     *     loops to iterate over a collection.
     * @param {Function} aFunction A function which performs some action with
     *     the element it is passed.
     * @returns {String} The receiver.
     */

    var i,
        len;

    len = this.length;
    for (i = 0; i < len; i++) {

        //  since we're iterating on a string here we'll pass the
        //  character at the current index as the 'item'
        aFunction(this.charAt(i), i);
    }

    return this;
});

//  ------------------------------------------------------------------------
//  COMMON ITERATION VARIANTS
//  ------------------------------------------------------------------------

/**
 * The variants here all leverage their base type's ability to perform() over
 * an item (individual or ordered pair for a hash). While the core API here is
 * based on Smalltalk and Ruby we've got a few extras that help with common
 * operations you might want to perform on the contents like using apply, get,
 * set, etc.
 */

//  ------------------------------------------------------------------------

TP.defineCommonMethod('collect',
function(aFunction) {

    /**
     * @method collect
     * @summary Returns a new array which contains the elements of the receiver
     *     transformed by the function provided.
     * @param {Function} aFunction A function which should return the
     *     transformation of the element it is passed.
     * @returns {Object[]} An array containing the transformed elements.
     */

    var tmparr;

    tmparr = TP.ac();

    this.perform(
        function(item, index) {
            tmparr.push(aFunction(item, index));
        });

    return tmparr;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('collect',
function(aFunction) {

    /**
     * @method collect
     * @summary Returns a new array which contains the elements of the receiver
     *     transformed by the function provided.
     * @param {Function} aFunction A function which should return the
     *     transformation of the element it is passed.
     * @returns {Object[]} An array containing the transformed elements.
     */

    return this.map(aFunction);
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('collectGet',
function(propertyName) {

    /**
     * @method collectGet
     * @summary Collects the result of running a get() on each item in the
     *     receiver using the propertyName provided. This is a powerful way to
     *     "query" a set of objects for a particular property value. If an
     *     object doesn't implement get() a direct slot access is attempted.
     * @param {String} propertyName The name of the property to get() from each
     *     item.
     * @returns {Object[]} An array containing the return values of the
     *     individual invocations. Skipped objects have nulls in their return
     *     value positions.
     */

    return this.collect(
        function(item) {

            if (TP.canInvoke(item, 'get')) {
                return item.get(propertyName);
            } else {
                try {
                    //  yes, IE will throw exceptions sometimes
                    return item[propertyName];
                } catch (e) {
                    return null;
                }
            }
        });
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('collectInvoke',
function(aMethodName) {

    /**
     * @method collectInvoke
     * @summary Collects the result of running the named method on each item in
     *     the receiver, providing any remaining arguments as the arguments to
     *     the method. If any of the objects don't implement the named function
     *     then that object is simply skipped.
     * @param {String} aMethodName The name of the method to invoke.
     * @returns {Object[]} An array containing the return values of the
     *     individual invocations. Skipped objects have nulls in their return
     *     value positions.
     */

    var args;

    args = TP.args(arguments, 1);

    return this.collect(
        function(item) {

            if (TP.canInvoke(item, aMethodName)) {
                return item[aMethodName].apply(item, args);
            } else {
                return null;
            }
        });
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('convert',
function(aFunction) {

    /**
     * @method convert
     * @summary Alters each of the receivers elements by replacing them with
     *     the result returned by aFunction's transformation on that element.
     *     Similar to collect() but results replace originals rather than being
     *     returned in an array. Using convert with a consistent return value is
     *     like a fill().
     * @param {Function} aFunction The function to use to transform each element
     *     in the array.
     * @returns {Array} The receiver.
     * @fires Change
     */

    var thisref,
        change;

    thisref = this;

    if (TP.canInvoke(this, 'shouldSignalChange')) {
        change = this.shouldSignalChange();
        this.shouldSignalChange(false);
    }

    this.perform(
        function(item, index) {
            thisref.atPut(index, aFunction(item, index));
        });

    if (TP.canInvoke(this, 'shouldSignalChange')) {
        this.shouldSignalChange(change);
    }

    //  NOTE: this ASSumes the function did something to at least one index
    this.changed('value', TP.UPDATE);

    return this;
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('detect',
function(aFunction, startIndex) {

    /**
     * @method detect
     * @summary Returns the first element in a collection which matches a
     *     condition as defined by the function provided.
     * @param {Function} aFunction A function which should return true or false
     *     after testing the element it is passed.
     * @param {Number} startIndex A starting index for the search.
     * @returns {Object} The first object to match the test criteria.
     */

    var start,
        result,
        items,
        len,
        i,
        item;

    start = TP.ifInvalid(this.normalizeIndex(startIndex), 0);

    items = this.getItems();
    len = items.getSize();
    for (i = start; i < len; i++) {
        item = items.at(i);
        if (aFunction(item, i)) {
            result = item;
            break;
        }
    }

    return result;
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('detectInvoke',
function(aMethodName, varargs) {

    /**
     * @method detectInvoke
     * @summary Executes the named method on each item in the receiver,
     *     providing any remaining arguments as the arguments to the method.
     * @description The semantics of this call are subtly different from both
     *     detect() and apply(). In this case the first invocation to return a
     *     non-null value is considered successful and the loop terminates,
     *     returning the value from the first successful invoke call. Note that
     *     the method will be bound to each item in the receiver in turn.
     * @param {String} aMethodName The name of the method to invoke.
     * @param {arguments} varargs Zero or more additional arguments to provide
     *     to the function.
     * @returns {Object} The receiver.
     */

    var args,
        retval,
        items,
        len,
        i,
        item;

    args = TP.args(arguments, 1);

    items = this.getItems();
    len = items.getSize();

    for (i = 0; i < len; i++) {
        item = items.at(i);
        if (TP.canInvoke(item, aMethodName)) {
            retval = item[aMethodName].apply(item, args);
            if (TP.isValid(retval)) {
                break;
            }
        }
    }

    return retval;
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('detectMax',
function(aFunction) {

    /**
     * @method detectMax
     * @summary Returns the "maximum" or largest value returned by aFunction
     *     when invoked successively on the receiver's items.
     * @param {Function} aFunction A function which should return the
     *     transformation of the element it is passed. when no function is
     *     provided the TP.RETURN_ARG0 function is used, meaning the values are
     *     tested without any change.
     * @returns {Object} The maximum value or undefined.
     */

    var func,
        retval;

    //  since the function is optional we'll use the ARG0 return and bind
    //  (which creates a wrapper) if needed
    func = TP.ifInvalid(aFunction, TP.RETURN_ARG0);

    retval = undefined;

    this.perform(
        function(item, index) {
            var val;

            val = func(item, index);
            if (val >= (retval || item)) {
                retval = item;
            }
        });

    return retval;
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('detectMin',
function(aFunction) {

    /**
     * @method detectMin
     * @summary Returns the "minimum" or smallest value returned by aFunction
     *     when invoked successively on the receiver's items.
     * @param {Function} aFunction A function which should return the
     *     transformation of the element it is passed. when no function is
     *     provided the TP.RETURN_ARG0 function is used, meaning the values are
     *     tested without any change.
     * @returns {Object} The minimum value or undefined.
     */

    var func,
        retval;

    //  since the function is optional we'll use the ARG0 return and bind
    //  (which creates a wrapper) if needed
    func = TP.ifInvalid(aFunction, TP.RETURN_ARG0);

    retval = undefined;

    this.perform(
        function(item, index) {
            var val;

            val = func(item, index);
            if (val <= (retval || item)) {
                retval = item;
            }
        });

    return retval;
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('flatten',
function() {

    /**
     * @method flatten
     * @summary Returns an array containing the receiver's key/value items in a
     *     flattened form. For example, TP.hc('a', 1, 'b', 2).flatten() returns
     *     the equivalent of TP.ac('a', 1, 'b', 2);
     * @returns {Object[]} A new array containing the elements of the receiver
     *     in flattened form.
     */

    return this.getItems().flatten();
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('grep',
function(aPattern, aFunction) {

    /**
     * @method grep
     * @summary Returns an array containing items (potentially transformed by
     *     aFunction) whose values matched the regular expression pattern.
     * @description This method works on the values of the collection, so a call
     *     to grep() on a Hash will not grep the keys, it will grep the values.
     *     Use grepKeys() to scan a collection by its keys/indexes.
     * @param {String|RegExp} aPattern A string or regular expression to test
     *     items with.
     * @param {Function} aFunction A function which should return the
     *     transformation of the element it is passed.
     * @returns {Object[]} An array containing the matched values.
     */

    var func,
        grepRegex,
        tmparr;

    //  since the function is optional we'll use the ARG0 return
    //  and bind (which creates a wrapper) if needed
    func = TP.ifInvalid(aFunction, TP.RETURN_ARG0);

    tmparr = TP.ac();
    grepRegex = TP.isRegExp(aPattern) ? aPattern : TP.rc(aPattern);

    this.getValues().perform(
        function(item, index) {
            if (grepRegex.test(TP.str(item))) {
                tmparr.push(func(item, index));
            }
        });

    return tmparr;
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('grepKeys',
function(aPattern, aFunction) {

    /**
     * @method grepKeys
     * @summary Returns an array containing items (potentially transformed by
     *     aFunction) whose key values matched the regular expression
     *     pattern provided.
     * @description The value being tested is the index (0-N for Arrays, key
     *     value for Object/Hash).
     * @param {String|RegExp} aPattern A string or regular expression to test
     *     items with.
     * @param {Function} aFunction A function which should return the
     *     transformation of the element it is passed.
     * @returns {Object[]} An array containing the matched items.
     */

    var func,
        grepRegex,
        tmparr;

    //  since the function is optional we'll use the ARG0 return
    //  and bind (which creates a wrapper) if needed
    func = TP.ifInvalid(aFunction, TP.RETURN_ARG0);

    tmparr = TP.ac();
    grepRegex = TP.isRegExp(aPattern) ? aPattern : TP.rc(aPattern);

    this.getKeys().perform(
        function(item, index) {
            if (grepRegex.test(TP.str(item))) {
                tmparr.push(func(item, index));
            }
        });

    return tmparr;
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('groupBy',
function(keyCriteria, selectionCriteria) {

    /**
     * @method groupBy
     * @summary Returns a TP.core.Hash whose keys are the return values
     *     produced by keyCriteria for each item, and whose values are arrays of
     *     the items matching that key OR an Array containing nested arrays of
     *     length N where N is the criteria you provided. To skip an element and
     *     have it left out (i.e. the equivalent of a "having" clause) you can
     *     add a second function which returns true when the value should be
     *     included.
     * @param {Number|Function} keyCriteria When a number, works to split the
     *     collection in groups of that count. When a function the return value
     *     of the function serves as the 'key' which sorts the values into a
     *     hash.
     * @param {Function} selectionCriteria A function which should return true
     *     for elements that should be grouped.
     * @returns {Object[]|undefined} A new array containing the elements selected.
     * @example
     *      arr = TP.ac(1,2,3,4,5,6).groupBy(3);
     *
     *     returns:
     *
     *     [[1, 2, 3], [4, 5, 6]]
     *
     *     while the same array after:
     *
     *     groupBy(function(item, index){return item.isOdd()})
     *
     *     returns:
     *
     *     {'true' : [1, 3, 5], 'false' : [2, 4, 6]}
     */

    var dict,
        list;

    switch (typeof keyCriteria) {
        case 'number':

            list = TP.ac();

            this.perform(
                function(item, index) {

                    var arr;

                    if (TP.isCallable(selectionCriteria)) {
                        if (!selectionCriteria(item)) {
                            return;
                        }
                    }

                    //  when starting a new break we push a new entry in the
                    //  list
                    if (index % keyCriteria === 0) {
                        arr = TP.ac();
                        list.push(arr);
                    } else {
                        arr = list.last();
                    }

                    arr.push(item);
                });

            return list;

        case 'function':

            dict = TP.hc();

            this.perform(
                function(item, index) {

                    var key,
                        arr;

                    if (TP.isCallable(selectionCriteria)) {
                        if (!selectionCriteria(item, index)) {
                            return;
                        }
                    }

                    key = keyCriteria(item, index);
                    if (TP.notValid(arr = dict.at(key))) {
                        arr = TP.ac();
                        dict.atPut(key, arr);
                    }
                    arr.push(item);
                });

            return dict;

        default:

            return this.raise('TP.sig.InvalidParameter');
    }
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('injectInto',
function(anAccumulator, aFunction) {

    /**
     * @method injectInto
     * @summary Performs the function with each element of the receiver as the
     *     first argument and anAccumulator as the second argument. The current
     *     item index is provided as the third argument.
     * @description injectInto allows you to pass an "accumulator" to the
     *     function along with each element of the receiver as it performs the
     *     function. This is useful when attempting to do an operation like
     *     summing all the values in an array where the added variable you pass
     *     in holds the sum.
     *
     *     The actual behavior is embodied in:
     *
     *     anAccumulator = aFunction(this[index], anAccumulator, index)
     *
     *     You should therefore pass a function which expects three arguments
     *     where the first argument is the current array element. On completion
     *     the injected value is returned.
     * @param {Object} anAccumulator The value to pass as the second argument to
     *     aFunction.
     * @param {Function} aFunction A function which performs some action with
     *     the elements it is passed and returns anAccumulator.
     * @returns {Object} The value of performing aFunction with anAccumulator
     *     over the receiver.
     */

    var value;

    value = anAccumulator;

    this.perform(
        function(item, index) {
            value = aFunction(item, value, index);
        });

    return value;
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('orderedBy',
function(aFunction) {

    /**
     * @method orderedBy
     * @summary Sorts the receiver's data based on the return values of the
     *     function provided. This method allows you to avoid some of the
     *     semantics involved in the native sort() routine so you can write sort
     *     functions that are more natural.
     * @param {Function} aFunction The return value function.
     * @returns {Object[]} An array containing the items of the receiver sorted
     *     as requested.
     */

    var items;

    items = this.collect(
        function(item, index) {
            return TP.ac(item, aFunction(item, index));
        });

    return items.sort(TP.sort.SECOND_ITEM);
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('partition',
function(aFunction) {

    /**
     * @method partition
     * @summary Tests each element against the function provided and returns a
     *     new array containing the passed items in the first index and the
     *     failed items in the second index.
     * @param {Function} aFunction A function which should return true or false
     *     after testing the element it is passed.
     * @returns {Object[]} A new array containing the elements selected.
     */

    var good,
        evil;

    good = TP.ac();
    evil = TP.ac();

    this.perform(
        function(item, index) {
            if (aFunction(item, index)) {
                good.push(item);
            } else {
                evil.push(item);
            }
        });

    return TP.ac(good, evil);
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('performInvoke',
function(aMethodName) {

    /**
     * @method performInvoke
     * @summary Executes the named method on each item in the receiver,
     *     providing any remaining arguments as the arguments to the method. If
     *     any of the objects don't implement the named function then that
     *     object is simply skipped.
     * @param {String} aMethodName The name of the method to invoke.
     * @returns {Object} The receiver.
     */

    var args;

    args = TP.args(arguments, 1);

    return this.perform(
        function(item) {
            if (TP.canInvoke(item, aMethodName)) {
                return item[aMethodName].apply(item, args);
            } else {
                return null;
            }
        });
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('performOver',
function(aFunction, aCollection) {

    /**
     * @method performOver
     * @summary Executes aFunction on the elements found at the indexes in
     *     aCollection. This allows you to iterate in a more sparse fashion. If
     *     no collection is provided this works just like perform.
     * @param {Function} aFunction The function to perform.
     * @param {TP.api.Collection} aCollection The collection of indexes.
     * @returns {Object} The receiver.
     */

    var thisref;

    if (TP.notValid(aCollection)) {
        return this.perform(aFunction);
    }

    thisref = this;

    aCollection.perform(
        function(item, index) {
            aFunction(thisref.at(item), item, index);
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('performSet',
function(attributeName, attributeValue) {

    /**
     * @method performSet
     * @summary Executes a set() on each item in the receiver using the
     *     attributeName and attributeValue provided. This is a powerful way to
     *     "update" a set of objects with a particular property value. If an
     *     object doesn't implement set() a direct slot access is attempted.
     * @param {String} attributeName The name of the attribute to set() on each
     *     item.
     * @param {Object} attributeValue The value to set.
     * @returns {Object} The receiver.
     */

    this.perform(
        function(item) {

            if (TP.canInvoke(item, 'set')) {
                item.set(attributeName, attributeValue);
            } else {
                try {
                    //  yes, IE will throw exceptions sometimes
                    item[attributeName] = attributeValue;
                    return item[attributeName];
                } catch (e) {
                    void 0;
                }
            }
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('performUntil',
function(aFunction, terminateFunction) {

    /**
     * @method performUntil
     * @summary Performs the function with each element of the receiver until
     *     terminateFunction returns true.
     * @description performUntil can be used as an alternative to constructing
     *     repeat loops to iterate over a collection.
     * @param {Function} aFunction A function which performs some action with
     *     the element it is passed.
     * @param {Function} terminateFunction A test Function which ends the loop.
     *     This should be a Function that returns a Boolean. It is passed the
     *     same data as the performed function.
     * @returns {Object} The receiver.
     */

    var items,
        len,
        i,
        item;

    items = this.getItems();
    len = items.getSize();

    for (i = 0; i < len; i++) {
        item = items.at(i);
        aFunction(item, i);
        if (terminateFunction(item, i)) {
            break;
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('performWhile',
function(aFunction, terminateFunction) {

    /**
     * @method performWhile
     * @summary Performs the function with each element of the receiver while
     *     terminateFunction returns true.
     * @description performWhile can be used as an alternative to constructing
     *     while loops to iterate over a collection.
     * @param {Function} aFunction A function which performs some action with
     *     the element it is passed.
     * @param {Function} terminateFunction A test Function which ends the loop.
     *     This should be a Function that returns a Boolean. It is passed the
     *     same data as the performed function.
     * @returns {Object} The receiver.
     */

    var items,
        len,
        i,
        item;

    items = this.getItems();
    len = items.getSize();

    for (i = 0; i < len; i++) {
        item = items.at(i);
        if (terminateFunction(item, i)) {
            break;
        }
        aFunction(item, i);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('performWith',
function(aFunction, aCollection) {

    /**
     * @method performWith
     * @summary Executes a two-argument function (aFunction) with the first
     *     argument set to receiver[item] and second argument set to
     *     aCollection.at(index) for each element in the receiver. Note that
     *     once the items in the receiver have been exhausted this method will
     *     stop processing. If the collection is shorter nulls are used, if the
     *     collection is longer its trailing items are left unused.
     * @param {Function} aFunction A function which accepts three arguments: 1)
     *     The element at the current index in the receiver. 2) The element at
     *     the current index in aCollection. 3) The current index.
     * @param {TP.api.Collection} aCollection The collection of elements to
     *     use for the second argument to aFunction.
     * @exception TP.sig.InvalidCollection
     * @exception TP.sig.CollectionSizeMismatch
     * @returns {Object} The receiver.
     */

    this.perform(
        function(item, index) {

            //  NOTE that the index is the key where the data was found, so
            //  this should work as long as the two collections are of the
            //  same index type...otherwise it's a bit of a mess :)
            aFunction(item, aCollection.at(index), index);
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('reject',
function(aFunction) {

    /**
     * @method reject
     * @summary Tests each element against the function provided and returns a
     *     new array containing those elements which aren't rejected by the
     *     function. The function should return true for elements which are to
     *     be skipped.
     * @param {Function} aFunction A function which should return true or false
     *     after testing the element it is passed.
     * @returns {Object[]} A new array containing the elements which weren't
     *     rejected.
     */

    var tmparr;

    tmparr = TP.ac();

    this.perform(
        function(item, index) {
            if (!aFunction(item, index)) {
                tmparr.push(item);
            }
        });

    if (TP.isString(this)) {
        return tmparr.join('');
    }

    return tmparr;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('reject',
function(aFunction) {

    /**
     * @method reject
     * @summary Tests each element against the function provided and returns a
     *     new array containing those elements which aren't rejected by the
     *     function. The function should return true for elements which are to
     *     be skipped.
     * @param {Function} aFunction A function which should return true or false
     *     after testing the element it is passed.
     * @returns {Object[]} A new array containing the elements which weren't
     *     rejected.
     */

    return this.filter(
        function(item, index) {
            return !aFunction(item, index);
        });
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('select',
function(aFunction) {

    /**
     * @method select
     * @summary Tests each element against the function provided and returns a
     *     new array containing those elements which are selected by the
     *     function. The function should return true for elements which are to
     *     be returned.
     * @param {Function} aFunction A function which should return true or false
     *     after testing the element it is passed.
     * @returns {Object[]} A new array containing the elements selected.
     */

    var tmparr;

    tmparr = TP.ac();

    this.perform(
        function(item, index) {
            if (aFunction(item, index)) {
                tmparr.push(item);
            }
        });

    if (TP.isString(this)) {
        return tmparr.join('');
    }

    return tmparr;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('select',
function(aFunction) {

    /**
     * @method select
     * @summary Tests each element against the function provided and returns a
     *     new array containing those elements which are selected by the
     *     function. The function should return true for elements which are to
     *     be returned.
     * @param {Function} aFunction A function which should return true or false
     *     after testing the element it is passed.
     * @returns {Object[]} A new array containing the elements selected.
     */

    return this.filter(aFunction);
});

//  ------------------------------------------------------------------------
//  TYPE-SPECIFIC VARIANTS
//  ------------------------------------------------------------------------

/**
 * The operations here are variants that rely on type-specific processing to do
 * their work.
 */

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('choose',
function() {

    /**
     * @method choose
     * @summary Runs the functions contained in the receiver using the argument
     *     list provided, returning the first successful Function's return
     *     value. Essentially an iteration-based try/catch using blocks.
     * @description This is a function-specific operation, meaning that it's
     *     appropriate for arrays containing alternative functions you want to
     *     run. In this case, the return value of the first function which
     *     doesn't throw an exception will be used.
     * @returns {Object} The first successful Function's return value.
     */

    var args,
        retval,
        len,
        i,
        item;

    args = TP.args(arguments);

    len = this.length;
    for (i = 0; i < len; i++) {
        item = this[i];
        try {
            retval = item.apply(item, args);
            break;
        } catch (e) {
            //  an exception in the function just means continue trying
            void 0;
        }
    }

    return retval;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('compact',
function(aFilter) {

    /**
     * @method compact
     * @summary Returns the receiver with all filtered values removed. When a
     *     filter is supplied that filter defines what values should be removed,
     *     i.e. the default filter is TP.notValid(). When invoked without a
     *     filter the standard TP.notValid() call is used so that nulls and
     *     undefined values are removed. NOTE that the receiver is always
     *     modified in place. Use select() or reject() to produce a new array
     *     without values and simply provide a suitable filtering function.
     * @description In some sense using a filtering function seems like
     *     something that should be done via the remove() function but that
     *     would complicate the semantics when you want to remove function
     *     instances as values in an array. Hence we allow an optional filtering
     *     function in compact whose semantics aren't tied to value removal as
     *     closely. Also note that the filtering value is inverted from how
     *     you'd expect remove to operate...compact is more like reject() than
     *     select().
     * @param {Function} aFilter An optional filtering function which should
     *     return true for value which should be removed. The default function
     *     is TP.notValid().
     * @returns {Array} The receiver.
     */

    var filter,
        wi,

        len,
        i,

        val;

    //  default test is is the value valid (non null and defined)
    filter = TP.ifInvalid(aFilter, TP.notValid);

    wi = 0;
    len = this.length;

    for (i = 0; i < len; i++) {
        val = this[i];

        //  NOTE that the filter defines what to remove, so we invert that
        //  and write only those elements the filter doesn't reject
        if (!filter(val)) {
            this[wi] = val;
            wi++;
        }
    }

    if (wi < len) {
        this.length = wi;
        this.changed('length', TP.DELETE,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, wi));
    }

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('conform',
function(anInterface, inline) {

    /**
     * @method conform
     * @summary Returns the receiver with all values which don't implement the
     *     interface removed. The resulting collection's values will, on
     *     completion of this method, respond to the next iteration
     *     (collectInvoke perhaps) that you want to run.
     * @param {String|String[]} anInterface A method name or collection of them
     *     to test against.
     * @param {Boolean} inline False to return a new array instead of collapsing
     *     inline. Default is true.
     * @returns {Array} The receiver.
     */

    var i,
        len,
        item;

    //  simple select when a new collection is desired
    if (TP.isFalse(inline)) {
        return this.select(
            function(it) {

                return TP.canInvokeInterface(it, anInterface);
            });
    }

    //  this loop will clear any values where the value isn't conforming,
    //  which sets the collection up for a compact to remove all nulls
    //  (since they don't conform to any interface)
    len = this.length;
    for (i = 0; i < len; i++) {
        item = this[i];
        if (!TP.canInvokeInterface(item, anInterface)) {
            this.atPut(i, null, false);
        }
    }

    return this.compact();
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('detect',
function(aFunction, startIndex) {

    /**
     * @method detect
     * @summary Returns the first element in the receiver which matches the
     *     criteria provided or null if the element isn't found.
     * @param {Function} aFunction A function which should return true if the
     *     element it is passed passes the function's test, or false if it does
     *     not.
     * @param {Number} startIndex A starting index for the search.
     * @returns {Object} The element detected or undefined.
     */

    var retval,
        start,
        len,
        i,
        item;

    start = TP.ifInvalid(this.normalizeIndex(startIndex), 0);

    this.$sortIfNeeded();

    retval = undefined;
    len = this.length;
    for (i = start; i < len; i++) {
        item = this[i];

        if (aFunction(item, i)) {
            retval = item;
            break;
        }
    }

    return retval;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('detectInvoke',
function(aMethodName, varargs) {

    /**
     * @method detectInvoke
     * @summary Executes the named method on each item in the receiver,
     *     providing any remaining arguments as the arguments to the method.
     * @description The semantics of this call are subtly different from both
     *     detect() and apply(). In this case the first invocation to return a
     *     non-null value is considered successful and the loop terminates,
     *     returning the value from the first successful invoke call. Note that
     *     the method will be bound to each item in the receiver in turn.
     * @param {String} aMethodName The name of the method to invoke.
     * @param {arguments} varargs Zero or more additional arguments to provide
     *     to the function.
     * @returns {Object} The receiver.
     */

    var args,
        retval,
        len,
        i,
        item;

    args = TP.args(arguments, 1);
    len = this.length;
    for (i = 0; i < len; i++) {
        item = this[i];
        if (TP.canInvoke(item, aMethodName)) {
            retval = item[aMethodName].apply(item, args);
            if (TP.isValid(retval)) {
                break;
            }
        }
    }

    return retval;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('invoke',
function(aThis, anArgArray, whenError) {

    /**
     * @method invoke
     * @summary Runs the functions contained in the receiver using the argument
     *     list provided. An easy way to run a list of functions as if they were
     *     a single function.
     * @description This operation is used to allow a list of functions to
     *     operate somewhat polymorphically with a single function for purposes
     *     of execution. Because of that semantic goal we return the value of
     *     the last function's invocation. This means an array of one function,
     *     or the function itself, are indistinguishable when using invoke.
     * @param {Object} aThis An object to use as the this reference for the
     *     apply call.
     * @param {arguments} anArgArray An array or arguments object containing the
     *     arguments to apply.
     * @param {Function} whenError An optional error handler function to call
     *     for any iterations which fail. Arguments to this function include the
     *     item, index, and error object. Called for each individual function in
     *     the list which fails in any way.
     * @returns {Object} The result of the last invocation.
     */

    var retval;

    this.perform(
        function(item, index) {

            try {
                retval = item.apply(aThis, anArgArray);
            } catch (e) {
                if (TP.isCallable(whenError)) {
                    whenError(item, index, e);
                }
            }
        });

    return retval;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('invokeAsync',
function(aThis, anArgArray, whenError, stopOnError) {

    /**
     * @method invokeAsync
     * @summary Runs the functions contained in the receiver asynchronously
     *     using the argument list provided. An easy way to run a list of
     *     functions so they can provide rendering output between each
     *     item. The array will signal InvokeComplete when all items have
     *     been processed. Results/errors can be found in the signal.
     *     NOTE this is _not_ using Promises and the functions in the list
     *     should be synchronous under normal circumstances.
     * @param {Object} aThis An object to use as the this reference for the
     *     apply call.
     * @param {arguments} anArgArray An array or arguments object containing the
     *     arguments to apply.
     * @param {Function} whenError An optional error handler function to call
     *     for any iterations which fail. Arguments to this function include the
     *     item, index, and error object. Called for each individual function in
     *     the list which fails in any way.
     * @param {Boolean} stopOnError True to have the invocation sequence stop
     *     after any error occur. Default is false.
     * @returns {Array} The receiver.
     */

    var thisref,
        results,
        arr,
        runner,
        errors,
        next;

    thisref = this;
    results = TP.ac();
    errors = TP.ac();

    arr = this.collect(
            function(item, index) {
                return function() {
                    try {
                        results.atPut(index, item.apply(aThis, anArgArray));
                    } catch (e) {
                        errors.atPut(index, e);
                        if (TP.isCallable(whenError)) {
                            whenError(next, index, e);
                        } else {
                            thisref.raise('TP.sig.InvokeFailed',
                                TP.ec(e, 'Invocation failed'));
                        }
                    } finally {
                        runner();
                    }
                };
            });

    runner = function() {
        if (stopOnError && errors.length > 0) {
            thisref.signal('TP.sig.InvokeComplete',
                TP.hc('results', results, 'errors', errors));
        }

        next = arr.shift();
        if (TP.isCallable(next)) {
            setTimeout(next, 0);
        } else {
            thisref.signal('TP.sig.InvokeComplete',
                TP.hc('results', results, 'errors', errors));
        }
    };

    runner();

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('removeValue',
function(aValue) {

    /**
     * @method removeValue
     * @summary Removes all values in the receiver which are exact matches for
     *     the value provided. This is a specialized form of compact in which
     *     the filter function is prebuilt and filters for === aValue;
     * @param {Object} aValue The value to filter out of the array.
     * @returns {Array} The receiver.
     */

    if (aValue === undefined) {
        return this.raise('InvalidParameter');
    }

    this.compact(function(val) {
        return val === aValue;
    });

    return this;
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('by',
function(aStep, aFunction) {

    /**
     * @method by
     * @summary Runs the function provided, much like perform(), for each index
     *     which matches the step value. The indexing is zero-based. For
     *     example, (9).by(3) is equivalent to (0).to(9).by(3).perform() and the
     *     function will run at indexes 0, 2, 5, and 8.
     * @param {Number} aStep A number to mod (%) against the index to determine
     *     if the function should be run at this index.
     * @param {Function} aFunction The iteration block to execute.
     * @returns {Number} The number of times the function was invoked.
     */

    var count;

    count = 0;

    this.perform(
        function(item, index) {

            if (index % aStep === 0) {
                count++;
                aFunction(item, index);
            }
        });

    return count;
});

//  ------------------------------------------------------------------------

RegExp.Inst.defineMethod('performWith',
function(aFunction, anObject) {

    /**
     * @method performWith
     * @summary Performs the function from 0 to N times where N is the number
     *     of times the receiver matches the string value of the object
     *     provided. Obviously for N to be greater than 1 you must be messaging
     *     a global regular expression, otherwise the replacement function will
     *     only be called once for the first match. Note that this iteration
     *     model cannot be reversed.
     * @description A variation on String.replace where the function is used
     *     within an iterator so it can be controlled via normal TIBET iteration
     *     logic. As with String.replace the function will be passed at least 3
     *     arguments, the match string, the index of the match, and the string
     *     itself. There may be additional arguments, at arguments[1] through N,
     *     for any parenthesized subexpressions in the expression. Returning a
     *     TP.CONTINUE in your function will cause the current match to be
     *     skipped and the value preserved. Returning a TP.BREAK will terminate
     *     the replacement loop entirely, skipping any remaining matches.
     * @param {Function} aFunction A function accepting the parameters typically
     *     provided to a replace() function.
     * @param {Object} anObject The object whose string representation should be
     *     iterated.
     */

    var str,
        thisref;

    str = TP.str(anObject);
    thisref = this;

    //  "auto-reset" so we start from the beginning of the string
    this.lastIndex = 0;

    //  only going to find one match if we're not global...but if we're
    //  global then we'd have to run it to see how many matches we get
    //  len = this.global ? NaN : 1;

    //  the replace call is what drives the actual iteration so we don't
    //  have to construct a loop here. what we do have to do is create a
    //  function that can pass the arguments along to the incoming function
    //  and which can trap the continue and break logic from the inner
    //  function properly
    return str.replace(
        this,
        function() {

            var retval;

            retval = aFunction.apply(this, arguments);
            switch (retval) {
                case TP.BREAK:

                    //  break trick is to set the regular expression's
                    //  lastIndex to the length of the string, terminating
                    //  the loop
                    thisref.lastIndex = str.length;
                    return arguments[0];

                case TP.CONTINUE:

                    //  nothing to do, but don't return new value
                    return arguments[0];

                default:
                    return retval;
            }
        });
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('convert',
function(aFunction) {

    /**
     * @method convert
     * @summary Returns a new String whose content represents the converted
     *     characters from aFunction.
     * @param {Function} aFunction The function to use to transform each
     *     character.
     * @returns {String} A String containing the converted characters.
     */

    var arr;

    arr = TP.ac();

    this.perform(
        function(item, index) {
            arr.push(aFunction(item, index));
        });

    return arr.join('');
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('times',
function(aNumber) {

    /**
     * @method times
     * @summary Returns the string repeated the specified number of times.
     * @param {Number} aNumber The number of times to repeat string.
     * @exception TP.sig.InvalidParameter
     * @returns {String} The receiver repeated aNumber of times.
     */

    var arr,
        thisref;

    if (!TP.isNumber(aNumber)) {
        this.raise('TP.sig.InvalidParameter');
    }

    arr = TP.ac();
    thisref = this;

    aNumber.perform(
        function() {
            arr.push(thisref);
        });

    return arr.join('');
});

//  ------------------------------------------------------------------------
//  LOAD and SOURCE PATH QUALIFICATION
//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('qualifyToSourcePath',
function(paths) {

    /**
     * @method qualifyToSourcePath
     * @summary Qualifies the path or paths supplied in the parameter to the
     *     source path of the receiver.
     * @param {String|String[]} paths The URI paths to qualify to the
     *     receiver's source path.
     * @returns {String|String[]} The supplied paths qualified to the
     *     receiver's source path.
     */

    var sourceCollectionPath,

        result;

    if (TP.notValid(paths)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    sourceCollectionPath = TP.objectGetSourceCollectionPath(this);

    if (!TP.isArray(paths)) {
        result = TP.uriJoinPaths(sourceCollectionPath, paths);
    } else {
        result = paths.map(
                    function(aPath) {
                        return TP.uriJoinPaths(sourceCollectionPath, aPath);
                    });
    }

    return result;
});

//  ------------------------------------------------------------------------
//  CONTAINMENT
//  ------------------------------------------------------------------------

/**
 * Standard collection query...do you have this object/value/key/etc? TIBET adds
 * additional functionality here by supporting two types of testing: TP.EQUALITY
 * and TP.IDENTITY. So when you ask whether obj.contains(x) you can ask for the
 * results based on either condition.
 */

//  ------------------------------------------------------------------------

TP.defineCommonMethod('containsKey',
function(aKey) {

    /**
     * @method containsKey
     * @summary Returns true if the receiver contains the key provided.
     * @param {Object} aKey The key to test.
     * @returns {Boolean} Whether or not the receiver contains the key provided.
     */

    var obj;

    obj = this.at(aKey);

    return TP.isDefined(obj) && !TP.$$isDNU(obj);
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('containsValue',
function(aValue, aTest) {

    /**
     * @method containsValue
     * @summary Returns true if the receiver contains the value provided.
     * @param {Object} aValue The value to test.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Boolean} Whether or not the receiver contains the value
     *     provided.
     */

    var it;

    it = this.detect(
        function(item) {

            switch (aTest) {
                case TP.IDENTITY:

                    return TP.identical(item.last(), aValue);

                default:

                    return TP.equal(item.last(), aValue);
            }
        });

    return TP.isDefined(it);
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('contains',
function(anItem, aTest) {

    /**
     * @method contains
     * @summary Returns true if the receiver contains the item provided.
     * @description The test provided allows the caller to define whether
     *     identity (===) or equality (==) are used for comparisons. NOTE: this
     *     method makes use of the TP.equal() function of TIBET for equality
     *     comparisons so that arrays, objects, dates, and functions with
     *     equivalent string values will compare equal.
     * @param {TP.api.OrderedPair} anItem The item (key/value pair) to test.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Boolean} Whether or not the receiver contains the value
     *     provided.
     */

    var key,
        val;

    if (!TP.isPair(anItem) || TP.notValid(key = anItem.at(0))) {
        return false;
    }

    val = this.at(key);

    switch (aTest) {
        case TP.IDENTITY:

            return TP.identical(val, anItem.last());

        default:

            return TP.equal(val, anItem.last());
    }
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('contains',
function(aValue, aTest) {

    /**
     * @method contains
     * @summary Returns true if the receiver contains the value provided.
     * @description The test provided allows the caller to define whether
     *     identity (===) or equality (==) are used for comparisons. NOTE: this
     *     method makes use of the TP.equal() function of TIBET for equality
     *     comparisons so that arrays, objects, dates, and functions with
     *     equivalent string values will compare equal.
     * @param {Object} aValue The value to test.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Boolean} Whether or not the receiver contains the value
     *     provided.
     */

    var it;

    //  string tests are a lot faster when using a custom test
    if (TP.isString(aValue)) {
        return this.containsString(aValue);
    }

    if (TP.isRegExp(aValue)) {
        return this.containsStringMatching(aValue);
    }

    it = this.detect(
        function(item) {

            switch (aTest) {
                case TP.IDENTITY:

                    return TP.identical(item, aValue);

                default:

                    return TP.equal(item, aValue);
            }
        });

    //  might contain a null, and nulls can be compared
    return TP.isDefined(it);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('containsString',
function(aValue) {

    /**
     * @method containsString
     * @summary Returns true if the receiver contains the string provided. This
     *     call is significantly faster for finding strings in potentially large
     *     arrays than a simple contains call.
     * @param {String} aValue The value that at least one element in the
     *     receiver should be equal to for this method to return true.
     * @returns {Boolean} Whether or not the receiver contains the String
     *     provided.
     */

    //  ECMA5 provides a nice indexOf() method on Array.
    return this.indexOf(aValue) !== TP.NOT_FOUND;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('containsStringMatching',
function(aValue) {

    /**
     * @method containsStringMatching
     * @summary Returns true if the receiver contains at least one string that
     *     matches the RegExp provided.
     * @param {RegExp} aValue The RegExp that at least one element in the
     *     receiver should match for this method to return true.
     * @returns {Boolean} Whether or not the receiver contains at least one
     *     String that tests true for the RegExp provided.
     */

    var i;

    for (i = 0; i < this.length; i++) {
        if (aValue.test(this[i])) {
            return true;
        }
    }

    return false;
});

//  ------------------------------------------------------------------------
//  METHOD CONFORMANCE
//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('asInterface',
function() {

    /**
     * @method asInterface
     * @summary Returns the receiver as a method interface. This is an array of
     *     method names useful for testing protocol conformance. For general
     *     objects this results in a list of the methods the receiver implements
     *     which could be quite large.
     * @returns {String[]} An array of method names.
     */

    return this.getLocalInterface(TP.SLOT_FILTERS.methods);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('asInterface',
function() {

    /**
     * @method asInterface
     * @summary Returns the receiver as a method interface. For arrays this
     *     method assumes the array already contains a list of strings.
     * @returns {Array} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asInterface',
function() {

    /**
     * @method asInterface
     * @summary Returns the receiver as a method interface. For strings this
     *     returns an array containing the string suitable for testing as an
     *     interface.
     * @returns {String[]} An array containing the receiver.
     */

    var intArray;

    intArray = TP.ac();
    intArray.push(this);

    return intArray;
});

//  ------------------------------------------------------------------------
//  DNU CONSTRUCTION
//  ------------------------------------------------------------------------

TP.FunctionProto.defineMethod('asDNU',
function() {

    /**
     * @method asDNU
     * @summary Returns a doesNotUnderstand wrapper function which is capable
     *     of providing information on which function name was not found along
     *     with the calling context.
     * @returns {Function} An appropriate wrapper function.
     */

    var dnuFunc,
        thisName;

    //  notice the passage of 'this' as the variable which will become the
    //  anOrigin parameter in TP.sys.dnu. Also, the passage of the method
    //  name acquired from the current function and the arguments and
    //  calling context.

    //  construct the function and get it set as if "add*Method" had been
    //  called on it. The $$dnu flag is critical so that other methods in
    //  the system can distinguish between functions which have "real"
    //  implementations and those which are simply "backstops".

    thisName = this[TP.NAME];
    dnuFunc =
        function() {
            var ret;

            ret = TP.sys.dnu(this, thisName, arguments, arguments);
            return ret;
        };

    dnuFunc[TP.NAME] = this[TP.NAME] || 'DoesNotUnderstand' +
                                                this.getName();
    dnuFunc[TP.OWNER] = this[TP.OWNER] || TP.NONE;
    dnuFunc[TP.TRACK] = this[TP.TRACK] || TP.NONE;
    dnuFunc[TP.DISPLAY] = TP.id(dnuFunc[TP.OWNER]) + '.' + dnuFunc[TP.NAME];
    dnuFunc.$$dnu = true;

    return dnuFunc;
});

//  ------------------------------------------------------------------------

Function.Type.defineMethod('constructDNU',
function(aName) {

    /**
     * @method constructDNU
     * @summary Returns a doesNotUnderstand wrapper function which is capable
     *     of providing information on which function name was not found along
     *     with the calling context.
     * @param {String} aName The name of the function this DNU stands in for.
     * @returns {Function} An appropriate wrapper function.
     */

    var dnuFunc;

    if (TP.isEmpty(aName)) {
        this.raise('TP.sig.InvalidParameter');
    }

    dnuFunc =
        function() {
            var ret;

            ret = TP.sys.dnu(this, aName, arguments, arguments);
            return ret;
        };

    dnuFunc[TP.NAME] = aName;
    dnuFunc[TP.OWNER] = TP.NONE;
    dnuFunc[TP.TRACK] = TP.NONE;
    dnuFunc[TP.DISPLAY] = TP.id(dnuFunc[TP.OWNER]) + '.' + dnuFunc[TP.NAME];
    dnuFunc.$$dnu = true;

    return dnuFunc;
});

//  ------------------------------------------------------------------------

Function.Type.defineMethod('constructNSM',
function(aName) {

    /**
     * @method constructNSM
     * @summary Returns a "NoSuchMethod" wrapper function which is capable of
     *     deadening part of a global doesNotUnderstand hook.
     * @param {String} aName The name of the function this deadener stands in
     *     for.
     * @returns {Function|undefined} An appropriate "no such method" function.
     */

    var nsmFunc;

    if (TP.isEmpty(aName)) {
        this.raise('TP.sig.InvalidParameter');
    }

    nsmFunc = function() {
        TP.raise(this, 'TP.sig.NoSuchMethod');
        return;
    };

    nsmFunc[TP.NAME] = aName;
    nsmFunc[TP.OWNER] = TP.NONE;
    nsmFunc[TP.TRACK] = TP.NONE;
    nsmFunc[TP.DISPLAY] = TP.id(nsmFunc[TP.OWNER]) + '.' + nsmFunc[TP.NAME];
    nsmFunc.$$dnu = true;   //  TODO:   should we update elsewhere for this?
    nsmFunc.$$nsm = true;

    return nsmFunc;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_deps/sprintf-tpi.min.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
/*! sprintf-js v1.1.2 | Copyright (c) 2007-present, Alexandru Mărășteanu <hello@alexei.ro> | BSD-3-Clause */
!function(){"use strict";var g={not_string:/[^s]/,not_bool:/[^t]/,not_type:/[^T]/,not_primitive:/[^v]/,number:/[diefg]/,numeric_arg:/[bcdiefguxX]/,json:/[j]/,not_json:/[^j]/,text:/^[^\x25]+/,modulo:/^\x25{2}/,placeholder:/^\x25(?:([1-9]\d*)\$|\(([^)]+)\))?(\+)?(0|'[^$])?(-)?(\d+)?(?:\.(\d+))?([b-gijostTuvxX])/,key:/^([a-z_][a-z_\d]*)/i,key_access:/^\.([a-z_][a-z_\d]*)/i,index_access:/^\[(\d+)\]/,sign:/^[+-]/};function y(e){return function(e,t){var r,n,i,s,a,o,p,c,l,u=1,f=e.length,d="";for(n=0;n<f;n++)if("string"==typeof e[n])d+=e[n];else if("object"==typeof e[n]){if((s=e[n]).keys)for(r=t[u],i=0;i<s.keys.length;i++){if(null==r)throw new Error(y('[sprintf] Cannot access property "%s" of undefined value "%s"',s.keys[i],s.keys[i-1]));r=r[s.keys[i]]}else r=s.param_no?t[s.param_no]:t[u++];if(g.not_type.test(s.type)&&g.not_primitive.test(s.type)&&r instanceof Function&&(r=r()),g.numeric_arg.test(s.type)&&"number"!=typeof r&&isNaN(r))throw new TypeError(y("[sprintf] expecting number but found %T",r));switch(g.number.test(s.type)&&(c=0<=r),s.type){case"b":r=parseInt(r,10).toString(2);break;case"c":r=String.fromCharCode(parseInt(r,10));break;case"d":case"i":r=parseInt(r,10);break;case"j":r=JSON.stringify(r,null,s.width?parseInt(s.width):0);break;case"e":r=s.precision?parseFloat(r).toExponential(s.precision):parseFloat(r).toExponential();break;case"f":r=s.precision?parseFloat(r).toFixed(s.precision):parseFloat(r);break;case"g":r=s.precision?String(Number(r.toPrecision(s.precision))):parseFloat(r);break;case"o":r=(parseInt(r,10)>>>0).toString(8);break;case"s":r=String(r),r=s.precision?r.substring(0,s.precision):r;break;case"t":r=String(!!r),r=s.precision?r.substring(0,s.precision):r;break;case"T":r=Object.prototype.toString.call(r).slice(8,-1).toLowerCase(),r=s.precision?r.substring(0,s.precision):r;break;case"u":r=parseInt(r,10)>>>0;break;case"v":r=r.valueOf(),r=s.precision?r.substring(0,s.precision):r;break;case"x":r=(parseInt(r,10)>>>0).toString(16);break;case"X":r=(parseInt(r,10)>>>0).toString(16).toUpperCase()}g.json.test(s.type)?d+=r:(!g.number.test(s.type)||c&&!s.sign?l="":(l=c?"+":"-",r=r.toString().replace(g.sign,"")),o=s.pad_char?"0"===s.pad_char?"0":s.pad_char.charAt(1):" ",p=s.width-(l+r).length,a=s.width&&0<p?o.repeat(p):"",d+=s.align?l+r+a:"0"===o?l+a+r:a+l+r)}return d}(function(e){if(p[e])return p[e];var t,r=e,n=[],i=0;for(;r;){if(null!==(t=g.text.exec(r)))n.push(t[0]);else if(null!==(t=g.modulo.exec(r)))n.push("%");else{if(null===(t=g.placeholder.exec(r)))throw new SyntaxError("[sprintf] unexpected placeholder");if(t[2]){i|=1;var s=[],a=t[2],o=[];if(null===(o=g.key.exec(a)))throw new SyntaxError("[sprintf] failed to parse named argument key");for(s.push(o[1]);""!==(a=a.substring(o[0].length));)if(null!==(o=g.key_access.exec(a)))s.push(o[1]);else{if(null===(o=g.index_access.exec(a)))throw new SyntaxError("[sprintf] failed to parse named argument key");s.push(o[1])}t[2]=s}else i|=2;if(3===i)throw new Error("[sprintf] mixing positional and named placeholders is not (yet) supported");n.push({placeholder:t[0],param_no:t[1],keys:t[2],sign:t[3],pad_char:t[4],align:t[5],width:t[6],precision:t[7],type:t[8]})}r=r.substring(t[0].length)}return p[e]=n}(e),arguments)}function e(e,t){return y.apply(null,[e].concat(t||[]))}var p=Object.create(null);"undefined"!=typeof exports&&(exports.sprintf=y,exports.vsprintf=e),"undefined"!=typeof window&&(window.sprintf=y,window.vsprintf=e,"function"==typeof define&&define.amd&&define(function(){return{sprintf:y,vsprintf:e}}))}();

//**no source maps!**=sprintf.min.js.map
TP.boot.$$srcPath = '';

        
        TP.$$sprintf = window.sprintf;
        TP.definePrimitive('sprintf', function() {
            try {
                return TP.$$sprintf.apply(TP, arguments);
            } catch (e) {
                TP.raise(TP, 'InvalidSubstitution', e);
            }
        });
        delete window.sprintf;

        TP.$$vsprintf = window.vsprintf;
        TP.definePrimitive('vsprintf', function() {
            try {
                return TP.$$vsprintf.apply(TP, arguments);
            } catch (e) {
                TP.raise(TP, 'InvalidSubstitution', e);
            }
        });
        delete window.vsprintf;
        
    
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETInheritance.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
Our inheritance model makes use of a meta-object approach that allows both
types and instances to have multi-level inheritance. The design is focused
on providing appropriate meta-behavior while leveraging the built-in lookup
system for prototypes. This design and implementation are patent-pending,
as are a number of other features of TIBET.

We try to avoid the use of the word class to stay consistent with
the ECMA terminology of Type and to help avoid confusion since TIBET's
Type objects are more powerful than classes as most people know them.
TIBET's types are true instances, inheriting state and behavior from their
supertype type definitions, while also supporting local specialization.
*/

//  ------------------------------------------------------------------------
//  TP.lang.RootObject - SUBTYPE CREATION SUPPORT
//  ------------------------------------------------------------------------

String.Inst.defineMethod('isJSIdentifier',
function() {

    /**
     * @method isJSIdentifier
     * @summary Returns true if the string follows the rules for a valid JS
     *     identifier.
     * @returns {Boolean}
     */

    return TP.regex.JS_IDENTIFIER.test(this);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asJSIdentifier',
function(ensureUniqueness) {

    /**
     * @method asJSIdentifier
     * @summary Returns a version of the string suitable for use as a valid JS
     *     identifier.
     * @description This method is used by the defineSubtype call to allow
     *     strings of the form 'html:form' to actually act as types within the
     *     system. The return value is a mangled form of the original and the
     *     two are mapped into the metadata so that a call to the string
     *     'html:form'.asType() will return the type with the properly mangled
     *     name. This allows both namespace types and operations for formatting
     *     template strings etc. to work with strings that are nice "picture
     *     clauses" but lousy JS identifiers.
     * @param {Boolean} ensureUniqueness should we unique it?
     * @returns {String}
     */

    var str,
        ensure,
        id;

    if (this.isJSIdentifier()) {
        return this;
    }

    /* eslint-disable consistent-this */
    str = this;
    /* eslint-enable consistent-this */

    //  if first char is illegal push a $ on the front
    if (!TP.regex.JS_FIRST_CHAR.test(this)) {
        str = '$' + this;
    }

    ensure = TP.ifInvalid(ensureUniqueness, true);

    TP.regex.JS_IDENT_REPLACE.lastIndex = 0;
    id = str.replace(TP.regex.JS_IDENT_REPLACE, '_');

    if (ensure && TP.isValid(TP.ifInvalid(TP[id], TP.global[id]))) {
        //  replace anything illegal elsewhere and tack on OID for
        //  uniqueness
        id = TP.genID(id);
    }

    return '' + id;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('definingTypename',
function(typename) {

    /**
     * @method definingTypename
     * @summary A hook function used by import logic in various locations
     *     to capture the list of type names imported during script loading.
     * @param {String} typename The typename being imported.
     */

    return;
});

//  ------------------------------------------------------------------------

//  and don't forget to add the root type to the metadata
TP.sys.addCustomType('TP.lang.RootObject', TP.lang.RootObject);

//  ------------------------------------------------------------------------
//  TP.lang.RootObject - TYPE DEFINITION
//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a TIBET source code string, capable of
     *     recreating the type. Since TIBET doesn't use a nested structure for
     *     type construction we don't include any property construction in this
     *     output.
     * @returns {String} The receiver in valid source code form.
     */

    return this.getSupertype().getName() +
                '.defineSubtype(\'' + this.getNamespacePrefix() +
                ':' + this.getLocalName() + '\')';
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('asString',
function() {

    /**
     * @method asString
     * @summary Returns the receiver as a simple string.
     * @returns {String} The simple string form of the receiver.
     */

    return this.getName();
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('defineSubtype',
function(name) {

    /**
     * @method defineSubtype
     * @summary Defines a new subtype of the receiver and returns it. This is
     *     the core method for inheritance responsible for all the setup of a
     *     TIBET Type. Note that typenames can contain 'invalid' characters so
     *     you can create types named '(999)-999-9999' or 'MyNamespace:Mytype'
     *     etc.
     * @description Types are central to TIBET, and one of the areas where TIBET
     *     differs largely from other JavaScript libraries. TIBET's type system
     *     uses metatypes so each type object is actually an instance of a
     *     metatype. This is important because it means that unlike many other
     *     JavaScript libraries (and Java as well) type objects in TIBET inherit
     *     behavior from their parent types and can override or 'call super'
     *     along the type chain without explicit hardcoded type references. This
     *     makes TIBET a lot more like Ruby or Smalltalk than native JavaScript.
     *     TIBET then builds on this foundation in a number of ways. First,
     *     TIBET's constructor functions, method definitions, and virtually all
     *     other "ODL" or object definition methods can be overridden or
     *     extended as you require. An example is overriding construct() to
     *     construct singletons with ease. TIBET also uses types to perform data
     *     formatting, validation, and other operations by leveraging
     *     flexibility in type names. An example is
     *     '1234567890'.as('(999)-999-9999'), which sends the as() message to
     *     the string '1234567890'. That method will look for a type named
     *     '(999)-999-9999' and ask it to execute from('1234567890') resulting
     *     in (123)-456-7890 via a syntax that is easy to read, understand, and
     *     extend. NOTE that a typename suffix of either $$Type or $$Inst is
     *     illegal since these are used by TIBET to represent Metatype instances
     *     used for the type and instance 'tracks' of TIBET.
     * @param {String} name The name of the subtype, including an optional
     *     namespace prefix and colon or dot separator.
     * @returns {TP.lang.RootObject|undefined} A new type object.
     */

    var parts,
        subtypeName,
        nsName,
        nsObj,
        type,
        wholeName,

        typeName,
        instName,

        realType,
        typeConstructor,
        instConstructor,
        root;

    if (TP.isEmpty(name)) {
        return this.raise('TP.sig.InvalidTypeName');
    }

    parts = name.split(/:|\./);
    switch (parts.length) {
        case 1:
            root = this.getNamespaceRoot();
            nsName = this.getNamespacePrefix();
            subtypeName = parts[0];

            break;
        case 2:
            if (parts[0] === 'APP' || parts[0] === 'TP') {
                TP.ifError() ?
                    TP.error('Invalid namespace: ' + parts[0]) : 0;
                return;
            }

            root = this.getNamespaceRoot();
            nsName = parts[0];
            subtypeName = parts[1];

            break;
        default:
            if (parts[0] === 'TP' || parts[0] === 'APP') {
                root = parts[0];
                nsName = parts.slice(1, -1).join('.');
            } else {
                root = this.getNamespaceRoot();
                nsName = parts.slice(0, -1).join('.');
            }
            subtypeName = parts[parts.length - 1];
    }

    if (TP.regex.INTERNAL_TYPENAME.test(subtypeName)) {
        return this.raise('TP.sig.InvalidTypeName');
    }

    //  define an object that matches the namespace if necessary
    nsObj = TP.defineNamespace(root + '.' + nsName);

    wholeName = root + '.' + nsName + '.' + subtypeName;

    //  Invoke hook function import code can use to determine which types may be
    //  loading during a specific import sequence.
    TP.sys.definingTypename(wholeName);

    //  check with TIBET so we don't try to build type twice
    if (TP.sys.cfg('oo.unique_types')) {
        //  note the false here to avoid issues with proxies
        if (TP.isType(type = TP.sys.getTypeByName(wholeName, false))) {
            return type;
        }
    }

    //  build up names for our two constructors
    typeName = wholeName + '.Type'; //  TP.TYPEC;
    instName = wholeName + '.Inst'; //  TP.INSTC;

    //  build a string appropriate to constructing a new subtype...we've
    //  tried a lot of ways to manage this process but this one seems to
    //  work consistently without a lot of strange issues. One interesting
    //  thing is that you must use TypeName = new Function();' rather than
    //  'function TypeName(){};' due to differences in scope handling for
    //  these two syntax variants (the Function constructor does not create
    //  closures -- it always builds the new function at the global scope).

    //  build the instance side
    /* eslint-disable no-new-func */
    instConstructor = new Function();
    /* eslint-enable no-new-func */

    instConstructor[TP.NAME] = instName;
    instConstructor.prototype = this[TP.INSTC].$constructPrototype();
    instConstructor.prototype[TP.TYPE] = this[TP.INSTC];
    instConstructor.prototype[TP.NAME] = instName;
    instConstructor.prototype[TP.ID] = instName;

    //  build the type side
    /* eslint-disable no-new-func */
    typeConstructor = new Function();
    /* eslint-enable no-new-func */

    typeConstructor[TP.NAME] = typeName;
    typeConstructor.prototype = this[TP.TYPEC].$constructPrototype();
    typeConstructor.prototype[TP.NAME] = typeName;
    typeConstructor.prototype[TP.ID] = typeName;

    //  put a custom 'getName' function on the typeConstructor that will return
    //  'TP.meta.<nsName>.<subtypeName>' as the 'public name' of this object
    //  (i.e. the type's 'meta type')
    typeConstructor.getName = function() {
        return 'TP.meta.' + nsName + '.' + subtypeName;
    };

    //  why?
    // typeConstructor.prototype.$$meta = this.$$meta;

    //  create the 'type' as an instance of the type constructor side. This
    //  is the magic juju part. The object you get back isn't a function so
    //  it gets to inherit like normal. Just don't say 'new' to it ;).
    /* eslint-disable new-cap */
    realType = new typeConstructor();
    /* eslint-enable new-cap */
    nsObj[subtypeName] = realType;

    //  assign owners for the constructors
    typeConstructor[TP.OWNER] = realType;
    instConstructor[TP.OWNER] = realType;

    //  the internal metadata contains reflection data for the type,
    //  instances of the type, locally programmed instances, supertypes
    //  etc.
    realType[TP.TYPE] = realType;
    realType[TP.TYPEC] = typeConstructor;
    realType[TP.INSTC] = instConstructor;
    realType[TP.TNAME] = wholeName;
    realType[TP.RNAME] = wholeName;
    realType[TP.SUPER] = this;
    realType[TP.SNAME] = this.getName();
    realType[TP.NAME] = wholeName;
    realType[TP.ID] = wholeName;

    //  make sure TIBET knows about the new type so it can manage the
    //  type-initialization process as needed
    TP.sys.addCustomType(wholeName, realType);
    realType.setID(wholeName);

    //  by default all types are concrete, and this forces them to have the
    //  slot so we avoid ownership checks in the isAbstract call
    realType.$abstract = false;

    //  tell the subtype about its ancestors, but note that we do it in such
    //  a way that the list is from closest ancestor to oldest
    realType[TP.ANCESTOR_NAMES] = this.getSupertypeNames().slice(0);
    realType[TP.ANCESTOR_NAMES].unshift(this.getName());
    realType[TP.ANCESTORS] = this.getSupertypes().slice(0);
    realType[TP.ANCESTORS].unshift(this);

    //  hold references for quick lookup of namespace prefix and 'local name'
    //  without the prefix.
    realType.nsRoot = root;
    realType.nsPrefix = nsName;
    realType.localName = subtypeName;

    realType.Type = realType[TP.TYPEC].prototype;
    realType.Type[TP.OWNER] = realType;
    realType.Inst = realType[TP.INSTC].prototype;
    realType.Inst[TP.OWNER] = realType;

    //  map over load path information or the Inst and Type won't have them.
    realType.Type[TP.LOAD_PATH] = TP.boot[TP.LOAD_PATH];
    realType.Type[TP.SOURCE_PATH] = TP.boot[TP.SOURCE_PATH];
    realType.Inst[TP.LOAD_PATH] = TP.boot[TP.LOAD_PATH];
    realType.Inst[TP.SOURCE_PATH] = TP.boot[TP.SOURCE_PATH];

    //  make sure we've got arrays to hold subtypes and add our new child
    this[TP.SUBTYPE_NAMES] = this[TP.SUBTYPE_NAMES] || TP.ac();
    this[TP.SUBTYPE_NAMES].push(wholeName);
    this[TP.SUBTYPES] = this[TP.SUBTYPES] || TP.ac();
    this[TP.SUBTYPES].push(realType);

    //  update global metadata records
    TP.sys.addMetadata(null, realType, TP.SUBTYPE);

    //  clear/update any deep subtype caches up the supertype chain
    if (TP.sys.$$shouldCacheDeepSubtypes()) {
        this.getSupertypes().forEach(
            function(sType) {

                var cache;

                cache = sType[TP.SUBTYPES_DEEP];
                if (TP.isArray(cache)) {
                    cache.add(realType);
                }

                cache = sType[TP.SUBTYPE_NAMES_DEEP];
                if (TP.isArray(cache)) {
                    cache.add(wholeName);
                }
            });
    }

    //  Put the type *constructor* under the 'meta' namespace as well.
    TP.defineNamespace(root + '.meta.' + nsName);

    if (TP.regex.HAS_PERIOD.test(nsName)) {
        //  Have to iterate our way down.
        parts = nsName.split('.');
        root = TP.global[root].meta;

        parts.forEach(
                function(part) {
                    root = root[part];
                });

        root[subtypeName] = typeConstructor;
    } else {
        TP.global[root].meta[nsName][subtypeName] = typeConstructor;
    }

    //  hand back the new subtype so it can be captured by caller if needed
    return realType;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('defineNativeClass',
function(name, classDefFunction) {

    /**
     * @method defineNativeClass
     * @summary Defines a new subtype of the receiver as an ECMAScript Class,
     *     Note that this has multiple limitations compared to TIBET types,
     *     including limited metadata about the class and the inability to
     *     define multiple inheritance (trait) relationships.
     * @description This method produces an Object that can act in the stead of
     *     a regular ECMAScript class and can manage its relationship with the
     *     TIBET type that it inherits from "adequately". The semantics of the
     *     ECMAScript 'constructor()' and 'super()' constructs are preserved and
     *     do work when calling 'up' from ECMAScript classes defined this way
     *     into the TIBET type it inherits from. However, there are some subtle
     *     differences between that and TIBET's much more powerful
     *     callNextMethod() mechanism. Therefore, YMMV and it is not recommended
     *     to use this capability.
     * @param {String} name The name of the class, including an optional
     *     namespace prefix and colon or dot separator.
     * @param {Function} classDefFunction The class definition Function that is
     *     created via an ECMAScript 6 'class expression'.
     * @returns {Proxy} A new type object.
     */

    var subclassTIBETType,

        parts,

        root,
        nsName,
        subtypeName,

        copyTIBETProps,
        constructMethod,

        proxyConfig,

        classProxy,

        originalProto;

    if (TP.isEmpty(name) || !TP.isCallable(classDefFunction)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  See if there is a corresponding TIBET-side type that has the subclass
    //  name that was supplied. Note that we *cannot* do this by looking at the
    //  TP.global object or the TP object or whatever. The object that gets put
    //  into the global scope under the supplied name is *not* the TIBET-side
    //  type (which can be obtained using this mechanism) - it will be the Proxy
    //  that we create below that is a stand-in for the ECMAScript class.
    //  Therefore, unlike regular TIBET types, for this 'type'/'class' the
    //  following is *not* true:

    //  TP.MyNS.MyType === TP.sys.getTypeByName('TP.MyNS.MyType'); -> false

    subclassTIBETType = TP.sys.getTypeByName(name);

    //  If not, then define a TIBET-side type that will act as this class's
    //  stand-in on the TIBET-side of the house.
    if (!TP.isType(subclassTIBETType)) {
        subclassTIBETType = this.defineSubtype(name);
    } else {
        return;
    }

    //  Split the name that was supplied and use its parts to place a slot into
    //  the global space that will point to the proxy we're creating here.
    parts = name.split(/:|\./);
    switch (parts.length) {
        case 1:
            root = this.getNamespaceRoot();
            nsName = this.getNamespacePrefix();
            subtypeName = parts[0];

            break;
        case 2:
            if (parts[0] === 'APP' || parts[0] === 'TP') {
                TP.ifError() ?
                    TP.error('Invalid namespace: ' + parts[0]) : 0;
                return;
            }

            root = this.getNamespaceRoot();
            nsName = parts[0];
            subtypeName = parts[1];

            break;
        default:
            if (parts[0] === 'TP' || parts[0] === 'APP') {
                root = parts[0];
                nsName = parts.slice(1, -1).join('.');
            } else {
                root = this.getNamespaceRoot();
                nsName = parts.slice(0, -1).join('.');
            }
            subtypeName = parts[parts.length - 1];
    }

    if (TP.regex.INTERNAL_TYPENAME.test(subtypeName)) {
        return this.raise('TP.sig.InvalidTypeName');
    }

    //  Define a Function that will copy over TIBET-related properties and
    //  install them on the TIBET-side type.
    copyTIBETProps = function(aTIBETType, sourceObj, track) {

        var propNames;

        //  Grab all of the class or instance (depending on what the target
        //  object is) properties off of the ECMAScript class and iterate.
        propNames = Object.getOwnPropertyNames(sourceObj);

        propNames.forEach(
            function(propName) {
                var propVal;

                //  Don't copy the 'length', 'prototype' or 'constructor' slots.
                if (propName === 'length' ||
                    propName === 'prototype' ||
                    propName === 'constructor' ||
                    propName === TP.PROXIED) {
                    return;
                }

                //  Grab the value - if it's a Function, add it as a method to
                //  the TIBET-side type. If it's not, add it as an attribute to
                //  the TIBET-side type.

                propVal = sourceObj[propName];

                if (TP.isFunction(propVal)) {
                    aTIBETType[track].defineMethod(
                        propName,
                        propVal);
                } else {
                    aTIBETType[track].defineAttribute(
                        propName,
                        propVal);
                }
            });
    };

    //  This is a stand in for TIBET's 'construct' method. It is returned when
    //  the proxy is asked for the 'construct' method so that it can execute to
    //  construct the proper instance. Note that this logic is similar to the
    //  logic using in the Proxy 'construct' trap defined below (the trap is
    //  different than TIBET's 'construct' method - just the same name), but it
    //  the trap is different from this method in slight ways. The main
    //  difference is that this method handles when an instance of a native
    //  ECMAScript class that is a subclass of the class that is represented by
    //  the Proxy is being constructed.
    constructMethod = function() {

        var previousProto,
            newinst,
            optinst,
            finalinst;

        //  If the current 'this' object is not a Proxy (which means its not the
        //  standin itself), then it must be an ECMAScript class that is a
        //  subclass of the Proxy. In this case, we need to construct the
        //  instance in the standard way. Note that we use this '__nonProxy__'
        //  flag to mark the constructor because, otherwise, we will loop
        //  endlessly as this calls back on itself during the construction
        //  process.
        if (!TP.isProxy(this) && !TP.owns(this, '__nonProxy__')) {
            this.__nonProxy__ = true;
            newinst = Reflect.construct(this, arguments);
            delete this.__nonProxy__;

            //  NB: We don't have to worry about running the 'init' machinery
            //  like we do below when constructing instances of since this is a
            //  native ECMAScript class and will have no notion of that.

            return newinst;
        }

        //  Create an instance of the class by executing the target Function
        //  (which will execute the constructor as defined by class description
        //  Function) with the supplied args, but supply an optional constructor
        //  to use as the prototype of the resultant object. This mechanism is
        //  key to allowing the constructor function to run, but to getting the
        //  prototype chain set up properly for the created instance.

        //  First, swap the __proto__ of the class definition function with
        //  it's original proto so that the system won't complain.
        previousProto = Object.getPrototypeOf(classDefFunction);
        Object.setPrototypeOf(classDefFunction, originalProto);

        newinst = Reflect.construct(
                    classDefFunction, arguments, subclassTIBETType[TP.INSTC]);

        //  Put the __proto__ of the class definition function back.
        Object.setPrototypeOf(classDefFunction, previousProto);

        //  Now we replicate the logic that is in the standard 'construct'
        //  method *after* that method's invocation of '$alloc' (which is
        //  what the logic above is equivalent to).
        newinst[TP.TYPE] = subclassTIBETType[TP.TYPE];

        newinst = newinst.$init.apply(newinst, arguments);
        optinst = newinst.init.apply(newinst, arguments);

        //  If init() returns a non-null object that's our return value.
        //  This lets init() cheat and return an object of its choice.
        if (TP.isValid(optinst)) {
            finalinst = optinst;
        } else {
            finalinst = newinst;
        }

        //  If the new target is *not* a Proxy, then we're running because
        //  instance of *an ECMA subclass* of this class is being created.
        //  In that case, we need to wire in the __proto__ of the new
        //  instance to the prototype of that object.
        if (!TP.isProxy(this)) {
            Object.setPrototypeOf(finalinst, this.prototype);
        }

        return finalinst;
    };

    //  Create an ECMAScript Proxy object that will wrap an anonymous Function
    //  (we *must* use a Function here, because according to the ECMAScript
    //  spec, to trap accesses to 'construct', it must be a [[Callable]])
    proxyConfig = {
        get: function(target, propName) {

            //  If the propName is a Symbol, then just return whatever the
            //  TIBET-side type returns.
            if (typeof propName === 'symbol') {
                return subclassTIBETType[propName];
            }

            //  For 'constructor' or 'prototype', because these are considered
            //  'special', we return what the *target* returns returns.
            if (propName === 'constructor' ||
                propName === 'prototype') {
                return target[propName];
            }

            if (propName === 'construct') {
                return constructMethod;
            }

            //  Check to see if the proxy (the actual Proxy that we're defining
            //  above) is initialized, according to a slot that we keep on the
            //  TIBET-side type.
            if (TP.notValid(subclassTIBETType.$$esClassInitialized)) {

                    copyTIBETProps(subclassTIBETType,
                                    classDefFunction,
                                    TP.TYPE_TRACK);
                    copyTIBETProps(subclassTIBETType,
                                    classDefFunction.prototype,
                                    TP.INST_TRACK);

                //  Flag the Proxy non-type as being initialized by setting a
                //  flag on the TIBET-side type.
                subclassTIBETType.$$esClassInitialized = true;
            }

            //  For 'name', we return what the *target* returns.
            if (propName === 'name') {
                return subclassTIBETType[TP.NAME];
            }

            //  For everything else just return whatever the TIBET-side type
            //  returns.
            return subclassTIBETType[propName];
        },

        construct: function(target, args, newTarget) {

            var previousProto,

                newinst,
                optinst,
                finalinst;

            //  Check to see if the proxy (the actual Proxy that we're defining
            //  above) is initialized, according to a slot that we keep on the
            //  TIBET-side type.
            if (TP.notValid(subclassTIBETType.$$esClassInitialized)) {

                    copyTIBETProps(subclassTIBETType,
                                    classDefFunction,
                                    TP.TYPE_TRACK);
                    copyTIBETProps(subclassTIBETType,
                                    classDefFunction.prototype,
                                    TP.INST_TRACK);

                //  Flag the Proxy non-type as being initialized by setting a
                //  flag on the TIBET-side type.
                subclassTIBETType.$$esClassInitialized = true;
            }

            //  Create an instance of the class by executing the target
            //  Function (which will execute the constructor as defined by class
            //  description Function) with the supplied args, but supply an
            //  optional constructor to use as the prototype of the resultant
            //  object. This mechanism is key to allowing the constructor
            //  function to run, but to getting the prototype chain set up
            //  properly for the created instance.

            //  First, swap the __proto__ of the class definition function with
            //  it's original proto so that the system won't complain.
            previousProto = Object.getPrototypeOf(classDefFunction);
            Object.setPrototypeOf(classDefFunction, originalProto);

            newinst = Reflect.construct(
                        classDefFunction, args, subclassTIBETType[TP.INSTC]);

            //  Put the __proto__ of the class definition function back.
            Object.setPrototypeOf(classDefFunction, previousProto);

            //  Now we replicate the logic that is in the standard 'construct'
            //  method *after* that method's invocation of '$alloc' (which is
            //  what the logic above is equivalent to).
            newinst[TP.TYPE] = subclassTIBETType[TP.TYPE];

            newinst = newinst.$init.apply(newinst, args);
            optinst = newinst.init.apply(newinst, args);

            //  If init() returns a non-null object that's our return value.
            //  This lets init() cheat and return an object of its choice.
            if (TP.isValid(optinst)) {
                finalinst = optinst;
            } else {
                finalinst = newinst;
            }

            //  If the new target is *not* a Proxy, then we're running because
            //  instance of *an ECMA subclass* of this class is being created.
            //  In that case, we need to wire in the __proto__ of the new
            //  instance to the prototype of that object.
            if (!TP.isProxy(newTarget)) {
                Object.setPrototypeOf(finalinst, newTarget.prototype);
            }

            return finalinst;
        }
    };

    //  Create a proxy around the class description Function that was supplied.
    //  This is what will get installed below under the global slot and is
    //  used in order to trap instance creation via the 'construct' trap above.
    classProxy = TP.constructProxyObject(classDefFunction, proxyConfig);

    //  Wire up the prototype chains on the class description Function to
    //  support calling 'super' from the ECMAScript 'class'. The first one wires
    //  up the 'instance'-side of the chain and the second one wires up the
    //  'class'-side of the chain.
    Object.setPrototypeOf(classDefFunction.prototype,
                            this[TP.INSTC].prototype);

    //  We have to preserve the original __proto__ from the class definition
    //  Function instance so that we can put it back before we construct objects
    //  using the 'construct' trap above. Otherwise, the system will complain.
    originalProto = Object.getPrototypeOf(classDefFunction);
    Object.setPrototypeOf(classDefFunction,
                            this[TP.TYPEC].prototype);

    //  Define an object that matches the namespace if necessary. Note that we
    //  don't care about the return value here, since we're not actually
    //  creating a real type entry here - we just need to make sure its present.
    TP.defineNamespace(root + '.' + nsName);

    //  Use the computed parts that were split out from the name that was
    //  supplied to place a slot into the global space that will point to the
    //  proxy we're creating here.
    TP.global[root][nsName][subtypeName] = classProxy;

    return classProxy;
});

//  ------------------------------------------------------------------------
//  REFLECTION - PART IV
//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('computeCommonSupertype',
function(otherType) {

    /**
     * @method computeCommonSupertype
     * @summary Finds the common supertype of both the receiver and the
     *     supplied type object.
     * @param {TP.lang.RootObject} otherType The other type to use to compare.
     * @returns {TP.lang.RootObject|null} The common supertype or null if there
     *     is no common supertype (a *very* rare occurrence).
     */

    var thisSupers,
        otherSupers,

        i,
        j;

    thisSupers = this.getSupertypes();
    otherSupers = otherType.getSupertypes();

    for (i = 0; i < thisSupers.getSize(); i++) {
        for (j = 0; j < otherSupers.getSize(); j++) {
            if (thisSupers.at(i) === otherSupers.at(j)) {
                return thisSupers.at(i);
            }
        }
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getLocalName',
function() {

    /**
     * @method getLocalName
     * @summary Returns the local (aka short) name of the receiver without any
     *     namespace prefix.
     * @returns {String} The receiver's local name.
     */

    return this.$get('localName');
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getNamespaceObject',
function() {

    /**
     * @method getNamespaceObject
     * @summary Returns the namespace object of the receiver. For example, the
     *     namespace object for TP.lang.RootObject is TP.lang etc.
     * @returns {TP.lang.Namespace} The receiver's namespace object.
     */

    var name;

    name = this.getName();
    name = name.slice(0, name.lastIndexOf('.'));

    return TP.sys.getObjectById(name);
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getNamespacePrefix',
function() {

    /**
     * @method getNamespacePrefix
     * @summary Returns the namespace (in TIBET terms) of the receiver. For
     *     example, the namespace of the TP.sig.Signal type is 'sig'.
     * @returns {String} The receiver's namespace.
     */

    return this.$get('nsPrefix');
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getNamespaceRoot',
function() {

    /**
     * @method getNamespaceRoot
     * @summary Returns the namespace root (in TIBET terms) of the receiver.
     *     For example, the namespace root of the TP.sig.Signal type is 'TP'.
     * @returns {String} The receiver's namespace root.
     */

    return this.$get('nsRoot');
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getSupertypes',
function() {

    /**
     * @method getSupertypes
     * @summary Returns an array containing the supertypes of the receiver. You
     *     should consider the return value private and make a copy if you're
     *     going to manipulate the array.
     * @returns {TP.meta.lang.RootObject[]} Array of supertypes.
     */

    var arr,
        type;

    arr = this[TP.ANCESTORS];
    if (TP.isValid(arr)) {
        return arr;
    }

    arr = TP.ac();

    /* eslint-disable consistent-this */

    type = this;
    /* eslint-disable no-cond-assign */
    while (type = type[TP.SUPER]) {
        arr.push(type);
    }
    /* eslint-enable no-cond-assign */

    this[TP.ANCESTORS] = arr;

    /* eslint-enable consistent-this */

    return arr;
});

//  ------------------------------------------------------------------------

//  pre-declare a helper type-acquisition function
TP.sys.defineMethod('$$typeNameFunc',
function(it) {

    return it.getTypeName();
});

//  ------------------------------------------------------------------------

TP.defineMetaTypeMethod('getDependencies',
function() {

    /**
     * @method getDependencies
     * @summary Returns an Array of Objects that the receiver considers to be
     *     it's manually determined set of 'dependent' objects that it needs in
     *     order to operate successfully. These objects can be any type of
     *     object in the system, so long as they themselves can respond to the
     *     'getDependencies' method. In this way, we can recursively
     *     determine the chain of dependent objects. This terminates at the
     *     meta-level by returning an empty Array.
     * @description Many objects can be determined via method invocation
     *     tracking to be included or excluded for packaging purposes. This
     *     method allows the receiving object to statically force a particular
     *     object to be included along with the receiver in the package. In
     *     some cases this is the only way to determine whether or not an object
     *     should be included/excluded in a particular package.
     * @returns {Object[]} The property descriptor of the attribute on the
     *     receiver.
     */

    //  At this level, we just return an empty Array.
    return [];
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getDependencies',
function() {

    /**
     * @method getDependencies
     * @summary Returns an Array of Objects that the receiver considers to be
     *     it's manually determined set of 'dependent' objects that it needs in
     *     order to operate successfully. These objects can be any type of
     *     object in the system, so long as they themselves can respond to the
     *     'getDependencies' method. In this way, we can recursively
     *     determine the chain of dependent objects. This terminates at the
     *     meta-level by returning an empty Array.
     * @description Many objects can be determined via method invocation
     *     tracking to be included or excluded for packaging purposes. This
     *     method allows the receiving object to statically force a particular
     *     object to be included along with the receiver in the package. In
     *     some cases this is the only way to determine whether or not an object
     *     should be included/excluded in a particular package.
     * @returns {Object[]} The property descriptor of the attribute on the
     *     receiver.
     */

    var dependencies;

    //  First, grab whatever direct dependencies were programmed onto this
    //  object.
    dependencies = this[TP.DEPENDENCIES];
    if (TP.isValid(dependencies)) {
        dependencies =
            dependencies.map(
                function(anItem) {
                    return anItem.getDependencies();
                });
    } else {
        dependencies = TP.ac();
    }

    //  Make sure to flatten any nested Arrays.
    dependencies = dependencies.flatten();

    return dependencies;
});

//  ------------------------------------------------------------------------

TP.FunctionProto.defineMethod('getDependencies',
function() {

    /**
     * @method getDependencies
     * @summary Returns an Array of Objects that the receiver considers to be
     *     it's manually determined set of 'dependent' objects that it needs in
     *     order to operate successfully. These objects can be any type of
     *     object in the system, so long as they themselves can respond to the
     *     'getDependencies' method. In this way, we can recursively
     *     determine the chain of dependent objects. This terminates at the
     *     meta-level by returning an empty Array.
     * @description Many objects can be determined via method invocation
     *     tracking to be included or excluded for packaging purposes. This
     *     method allows the receiving object to statically force a particular
     *     object to be included along with the receiver in the package. In
     *     some cases this is the only way to determine whether or not an object
     *     should be included/excluded in a particular package.
     * @returns {Object[]} The property descriptor of the attribute on the
     *     receiver.
     */

    var dependencies,
        owner,

        obj;

    //  First, grab whatever direct dependencies were programmed onto this
    //  object.
    dependencies = this[TP.DEPENDENCIES];
    if (TP.isValid(dependencies)) {
        dependencies =
            dependencies.map(
                function(anItem) {
                    return anItem.getDependencies();
                });
    } else {
        dependencies = TP.ac();
    }

    //  Then, add whatever dependencies our TP.OWNER thinks is necessary. These
    //  will already be flattened and the 'concat' will make sure that we don't
    //  create a nested Array.
    owner = this[TP.OWNER];
    dependencies = dependencies.concat(owner.getDependencies());

    //  For a pure Function or a Function with 'TP' or 'TP.sys' as its owner,
    //  it could've been added anywhere, so we need to push an entry that will
    //  represent the Function in the set of package dependencies.
    //  Note here how we compare ID's - this is because objects booted very
    //  early in the process will actually have a different owner than 'TP' or
    //  'TP.sys', but they really belong to those objects.
    //  TODO: This shouldn't be so - figure out why it is.
    if (owner[TP.ID] === 'TP' || owner[TP.ID] === 'TP.sys') {

        obj = {};

        obj.singleSourceFileInfo = true;
        obj[TP.LOAD_PACKAGE] = this[TP.LOAD_PACKAGE];
        obj[TP.LOAD_CONFIG] = this[TP.LOAD_CONFIG];
        obj[TP.LOAD_PATH] = this[TP.LOAD_PATH];
        obj[TP.LOAD_STAGE] = this[TP.LOAD_STAGE];
        obj[TP.LOAD_INDEX] = this[TP.LOAD_INDEX];
        obj[TP.SOURCE_PACKAGE] = this[TP.SOURCE_PACKAGE];
        obj[TP.SOURCE_CONFIG] = this[TP.SOURCE_CONFIG];
        obj[TP.SOURCE_PATH] = this[TP.SOURCE_PATH];

        obj[TP.OID] = this[TP.SOURCE_PATH];

        dependencies.push(obj);
    }

    return dependencies;
});

//  ------------------------------------------------------------------------
//  INSTANCE CREATION
//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('$init',
function() {

    /**
     * @method $init
     * @summary Provides low-level initialization of a new instance.
     * @description The main task here is to construct specific instances of
     *     reference type attributes on each new instance based on information
     *     from the add*Attribute calls made when defining the type. Since
     *     reference type attributes do NOT support copy-on-write semantics this
     *     hook can catch subtle bugs that arise when you expect that the array
     *     you modifed is being copied down but instead it is being shared
     *     across all instances. By placing reference type attributes directly
     *     on the instance via the $init call we avoid the bugs while also
     *     avoiding the trouble for programmers of having to deal with the
     *     difference.
     * @returns {Object}
     */

    //  TODO: link this with an array of reference type attributes defined
    //  for the type via add*Attribute and iterate over the array to install
    //  the listed attributes on the specific instance. This would solve
    //  the copy-on-write issues here.

    return this;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('init',
function() {

    /**
     * @method init
     * @summary Initializes a new object instance. The default implementation
     *     simply returns.
     * @description Subclasses can override this method to do proper instance
     *     initialization. This method is called by the construct() methods to
     *     allow each class to 'do the right thing' for each instance without
     *     placing initialization code in the constructor...which would break
     *     dynamic attribute inheritance.
     * @returns {Object}
     */

    return this;
});

//  ------------------------------------------------------------------------
//  Abstract instance creation
//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('isAbstract',
function(aFlag) {

    /**
     * @method isAbstract
     * @summary Returns true if the receiver is abstract.
     * @description In TIBET this means instances can be constructed as long as
     *     a valid subtype can be found to provide them. Instances of a subtype
     *     are, by definition, an instance of their supertype so this is a valid
     *     OO concept and offers a lot of support for both localization and
     *     parameter-specific type specialization. If aFlag is passed this
     *     method doubles as a set() call.
     * @param {Boolean} aFlag Value to set for abstract.
     * @returns {Boolean}
     */

    if (TP.isBoolean(aFlag)) {
        this.$abstract = aFlag;
    }

    return this.$abstract;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('canConstruct',
function() {

    /**
     * @method canConstruct
     * @summary Returns true if the receiver can construct a valid instance
     *     given the parameters provided. This method is invoked by supertype
     *     processing of the constructViaSubtype method when searching for a
     *     potential subtype to manage the instance.
     * @returns {Boolean} Whether or not an instance of this can be constructed
     *     from the parameters provided.
     */

    //  note that the default is false, subtypes must actively validate
    //  that they can handle the instance creation request
    return false;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('constructForSignal',
function(aSignal) {

    /**
     * @method constructForSignal
     * @summary Constructs a new instance intended to handle the signal
     *     provided. This method defaults to calling construct() to acquire the
     *     instance and should be overridden for types which require parameters
     *     for successful instance creation.
     * @param {TP.sig.Signal} aSignal The signal instance to build for.
     * @returns {Object} A new instance, if possible.
     */

    return this.construct();
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('constructViaSubtype',
function() {

    /**
     * @method constructViaSubtype
     * @summary Returns a new instance of the receiving type in the form of an
     *     instance of a viable subtype.
     * @description This method supports a variety of "localization" mechanisms
     *     which rely on a common TIBET design pattern referred to as "type
     *     clustering". This allows a common abstract supertype such as
     *     TP.core.Browser to be messaged for a new instance and for different
     *     browsers to return appropriately "localized" subtype instances such
     *     as TP.core.IEBrowser. This strategy is used extensively by
     *     TP.dom.Node and TP.uri.URI to return the proper subtypes for your
     *     content.
     * @returns {Object|undefined}
     */

    var type,
        inst;

    type = this.getConcreteType.apply(this, arguments);

    //  don't continue if we didnt' find a type or we'd recurse due to
    //  finding the receiver and trying to restart at construct
    if (TP.notValid(type) || type === this) {
        this.raise('TP.sig.NoConcreteType');
        return;
    }

    inst = type.construct.apply(type, arguments);

    return inst;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getConcreteType',
function() {

    /**
     * @method getConcreteType
     * @summary Returns the concrete type for the receiver. When the receiving
     *     type is abstract this will not be the receiver, but when the receiver
     *     is abstract the type returned is the one that would be used to
     *     construct an instance based on the incoming parameters.
     * @returns {Object|undefined}
     */

    var subtypes,
        subtype,
        args;

    //  TODO:   if we've got a cached answer to the question of which
    //          subtype to use then use it. (complexity here is that we
    //          might need different types based on the parameter values -
    //          zero params might be valid for caching though)

    //  grab our list of subtypes, note that we descend the tree here which
    //  makes this a particularly slow routine for large trees
    subtypes = this.getSubtypes(true);
    if (TP.isEmpty(subtypes)) {
        return;
    }

    //  sort by depth so we work from most specific to least specific
    subtypes.sort(TP.sort.SUBTYPE).reverse();

    //  capture arguments in this scope for passage to inner scope. if we
    //  don't do this the "arguments" reference in the inner function will
    //  refer to the 'item' rather than the args passed to this function
    args = arguments;

    //  iterate across all subtypes and return first one claiming it can
    //  resolve our instance request
    subtype = subtypes.detect(
        function(item) {

            if (TP.isValid(item)) {
                return item.canConstruct.apply(item, args);
            }

            return false;
        });

    return subtype;
});

//  ------------------------------------------------------------------------
//  TYPE CONVERSION - INBOUND
//  ------------------------------------------------------------------------

/*
TIBET uses types extensively and often converts between them to support the work
of the inferencer. The standard pattern methods for type conversion in TIBET are
as() and from(), which make use of the "best method" pattern to find the best
possible match. as() and from() also leverage double-dispatch semantics to help
get the best possible conversion.

The from() side of things is considered "inbound" conversion while the as() side
of things is considered "outbound" conversion.

For inbound conversion the processing involves looking for a best fit from*
method. When the inbound object is a String the logic of fromString takes over
and delegates to the parse() function. Parse functionality also uses a best
match approach, but with a few extras. See parse() for more info.
*/

TP.FunctionProto.defineAttribute('parsers');
TP.lang.RootObject.Type.defineAttribute('parsers');

//  ------------------------------------------------------------------------

TP.defineMetaTypeMethod('from',
function(anObj) {

    /**
     * @method from
     * @summary Constructs a new instance from the incoming object.
     * @description This method attempts to find a method like from[Type]() for
     *     the object's type to do a custom conversion. Note that this method
     *     doesn't attempt to use as() since that method calls from() as its
     *     last resort. You should avoid overriding this method and work with
     *     specific from*() methods instead.
     * @param {Object} anObj The source object.
     * @returns {Object} A new instance of the receiver.
     */

    //  strings are the most common so let's speed up that dispatch
    if (TP.isString(anObj)) {
        return this.fromString.apply(this, arguments);
    }

    return this.callBestMethod(arguments, anObj,
                                'from', null,
                                'fromObject');
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('from',
function(anObj) {

    /**
     * @method from
     * @summary Constructs a new instance from the incoming object.
     * @description This method attempts to find a method like from[Type]() for
     *     the object's type to do a custom conversion. Note that this method
     *     doesn't attempt to use as() since that method calls from() as its
     *     last resort. You should avoid overriding this method and work with
     *     specific from*() methods instead.
     * @param {Object} anObj The source object.
     * @returns {Object} A new instance of the receiver.
     */

    //  strings are the most common so let's speed up that dispatch
    if (TP.isString(anObj)) {
        //  Note here how we make sure to convert the first argument (anObj) to
        //  be a *primitive* String - it makes things a lot easier downstream.
        return this.fromString.apply(
                    this, TP.ac(arguments).atPut(0, TP.str(arguments[0])));
    }

    return this.callBestMethod(arguments, anObj,
                                'from', null,
                                'fromObject');
});

//  ------------------------------------------------------------------------

TP.defineMetaTypeMethod('fromObject',
function(anObj) {

    /**
     * @method fromObject
     * @summary Constructs a new instance from the incoming object. The default
     *     implementation forwards to construct.
     * @param {Object} anObj The source object.
     * @returns {Object} A new instance of the receiver.
     */

    return this.construct(anObj);
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('fromObject',
function(anObj) {

    /**
     * @method fromObject
     * @summary Constructs a new instance from the incoming object. The default
     *     implementation forwards to construct.
     * @param {Object} anObj The source object.
     * @returns {Object} A new instance of the receiver.
     */

    return this.construct.apply(this, arguments);
});

//  ------------------------------------------------------------------------

TP.defineMetaTypeMethod('fromString',
function(aString, sourceLocale) {

    /**
     * @method fromString
     * @summary Returns a new instance from the string provided by invoking the
     *     receiver's parse() functionality.
     * @param {String} aString The content string to parse.
     * @param {String|TP.i18n.Locale} sourceLocale A source xml:lang or
     *     TP.i18n.Locale defining the language the string is now in. Defaults
     *     to 'getTargetLanguage()' which is based on the current locale's
     *     language-country value.
     * @returns {Object} An instance of the receiver, if parsing of the string
     *     is successful.
     */

    return this.parse(aString, sourceLocale);
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('fromString',
function(aString, sourceLocale) {

    /**
     * @method fromString
     * @summary Returns a new instance from the string provided by invoking the
     *     receiver's parse() functionality.
     * @param {String} aString The content string to parse.
     * @param {String|TP.i18n.Locale} sourceLocale A source xml:lang or
     *     TP.i18n.Locale defining the language the string is now in. Defaults
     *     to getTargetLanguage() which is based on the current locale's
     *     language-country value.
     * @returns {Object} An instance of the receiver, if parsing of the string
     *     is successful.
     */

    return this.parse(aString, sourceLocale);
});

//  ------------------------------------------------------------------------

TP.defineMetaTypeMethod('addParser',
function(aParser) {

    /**
     * @method addParser
     * @summary Adds a registered parser to the receiving type. Note that this
     *     only applies to those instances of function which are actual Types.
     * @description Note that parsers are executed in the order in which they're
     *     registered unless you manually adjust the parser list.
     * @param {Object} aParser An object implementing the 'parse' method. By
     *     default this means types and functions.
     * @returns {TP.FunctionProto} The receiver.
     */

    var parsers;

    //  this method is only appropriate for types
    if (!TP.isType(this)) {
        return TP.raise(this, 'TP.sig.InvalidOperation');
    }

    if (!TP.canInvoke(aParser, 'parse')) {
        return this.raise('TP.sig.InvalidParser',
                'Registered parsers must implement \'parse\'');
    }

    //  build the parser list as needed
    if (TP.notValid(parsers = this.$get('parsers'))) {
        parsers = TP.ac();
        this.$set('parsers', parsers, false);
    }

    parsers.push(aParser);

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('addParser',
function(aParser) {

    /**
     * @method addParser
     * @summary Adds a registered parser to the receiving type. Note that this
     *     only applies to those instances of function which are actual Types.
     * @description Note that parsers are executed in the order in which they're
     *     registered unless you manually adjust the parser list.
     * @param {Object} aParser An object implementing the 'parse' method. By
     *     default this means types and functions.
     * @returns {TP.lang.RootObject} The receiver.
     */

    var parsers;

    if (!TP.canInvoke(aParser, 'parse')) {
        return this.raise('TP.sig.InvalidParser',
                'Registered parsers must implement \'parse\'');
    }

    //  build the parser list as needed
    if (TP.notValid(parsers = this.$get('parsers'))) {
        parsers = TP.ac();
        this.$set('parsers', parsers, false);
    }

    parsers.push(aParser);

    return this;
});

//  ------------------------------------------------------------------------

TP.FunctionProto.defineMethod('parse',
function(aString, sourceLocale) {

    /**
     * @method parse
     * @summary Parses aString using the best method possible given the
     *     receiver's type.
     * @param {String} aString The content string to parse.
     * @param {String|TP.i18n.Locale} sourceLocale A source xml:lang or
     *     TP.i18n.Locale defining the language the string is now in. Defaults
     *     to 'getTargetLanguage()' which is based on the current locale's
     *     language-country value.
     * @returns {Object} The result of the parse. This is null when the parse
     *     fails.
     */

    var parsers,
        dat;

    //  standalone functions implement parse by invoking themselves. note
    //  that when parsing in this fashion the return value isn't clearly an
    //  instance of the receiver (i.e. not going to produce a Function).
    if (!TP.isType(this)) {
        return this(aString, sourceLocale);
    }

    //  if explicit list is provided use that, otherwise use default
    parsers = this.$get('parsers');
    if (TP.notEmpty(parsers)) {
        //  might be a single function rather than an array of them
        if (TP.isCallable(parsers)) {
            dat = parsers(aString, this);
        } else {
            //  run until the first successful parse, then stop
            dat = parsers.detectInvoke('parse', aString, this);
        }

        //  NOTE that strictly speaking the result should be an instance of
        //  the receiver's type, but we don't test that explicity here
        if (TP.isValid(dat)) {
            return dat;
        }
    }

    //  context, specializer, prefix, suffix, fallback, arglist
    return this.callBestMethod(arguments, aString,
                                'parse', null,
                                null,
                                TP.ac(aString, sourceLocale));
});

//  ------------------------------------------------------------------------

//  save original on Date to try it first. As of ECMAScript E5, it parses
//  the old JS format and ISO8601 dates, which is substantially better than
//  it used to do in old versions of JS (where it was basically useless).
Date.$$parse = Date.parse;

//  ------------------------------------------------------------------------

Date.Type.defineMethod('parse',
function(aString) {

    /**
     * @method parse
     * @summary Parses the supplied String and returns the number of
     *     milliseconds January 1, 1970, 00:00:00 UTC. represented by a Date
     *     within the String.
     * @description This method returns a new Date by parsing the supplied
     *     content String. It first tries the built in Date.parse() method and,
     *     if that doesn't produce Date output, it will try any other parsers it
     *     has been supplied with.
     * @param {String} aString The content string to parse.
     * @returns {Number} A new Number created from parsing the Date supplied in
     *     the content String.
     */

    var newDate,
        dateInMS;

    if (TP.isDate(newDate = this.callNextMethod())) {
        //  Need to be API-compatible with the native Date.parse() (which is
        //  now Date.$$parse())
        return newDate.getTime();
    }

    //  See if the native version of 'Date.parse' will work - its gotten
    //  better in ECMAScript edition 5.
    if (TP.isNumber(dateInMS = Date.$$parse(aString))) {
        return dateInMS;
    }

    //  Couldn't get a Date from either mechanism - return NaN as per ECMA
    //  spec.
    return NaN;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('parse',
function(aString, sourceLocale) {

    /**
     * @method parse
     * @summary Parses aString using the best method possible given the
     *     receiver and the target object/type.
     * @description The parser search attempts to locate methods of the form
     *     'parse[Type]String' where Type is replaced with the target's type or
     *     one of its supertypes. For example, a Date would try to find
     *     'parseDateString'.
     * @param {String} aString The content string to parse.
     * @param {String|TP.i18n.Locale} sourceLocale A source xml:lang or
     *     TP.i18n.Locale defining the language the string is now in. Defaults
     *     to getTargetLanguage() which is based on the current locale's
     *     language-country value.
     * @returns {Object} The result of the parse. This is null when the parse
     *     fails.
     */

    var parsers,
        dat;

    //  if explicit list is provided use that, otherwise use default
    parsers = this.$get('parsers');
    if (TP.notEmpty(parsers)) {
        //  might be a single function rather than an array of them
        if (TP.isCallable(parsers)) {
            dat = parsers(aString, this);
        } else {
            //  run until the first successful parse, then stop
            dat = parsers.detectInvoke('parse', aString, this);
        }

        //  NOTE that strictly speaking the result should be an instance of
        //  the receiver's type, but we don't test that explicity here
        if (TP.isValid(dat)) {
            return dat;
        }
    }

    //  context, specializer, prefix, suffix, fallback, arglist
    return this.callBestMethod(arguments, aString,
                                'parse', null,
                                null,
                                TP.ac(aString, sourceLocale));
});

//  ------------------------------------------------------------------------
//  TYPE CONVERSION - OUTBOUND
//  ------------------------------------------------------------------------

/*
The outbound side of type conversion is implemented by the as/format chain of
methods, which mirror the from/parse chain used for inbound conversions up to a
point. The as() method is focused primarily on type conversions but provides a
common entry point for formatting. This is somewhat consistent with the idea
that custom formats are a form of custom String subtype, but we don't go quite
that far unless the format is particularly complex.
Still, by leveraging as() we leave formatting open to type specialization.

Typical processing for as() will look for a type as the first parameter. When
this parameter isn't a Type or the name of a known Type it will be treated as a
formatting string and the 'transform' call will be invoked. The 'transform' call
leverages reflection to see if it can find a method specific to the format, then
tries to leverage the format as a template string.
*/

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('as',
function(typeOrFormat, formatParams) {

    /**
     * @method as
     * @summary Returns a new object representing the receiver as an instance
     *     of the type provided, or formatted as the format specification
     *     defines.
     * @description This method attempts to convert an object to either another
     *     type or to a string of a specific form. The former process is
     *     performed by using reflection to locate possible methods for
     *     converting the receiver. When the parameter doesn't appear to
     *     represent a type name this method defers to the transform() method
     *     which will treat the inbound string as a format template, not a type.
     *     See the 'transform' method for more information.
     * @param {TP.lang.RootObject|String} typeOrFormat The type or format object
     *     or String desired.
     * @param {Object} formatParams Optional conversion parameters.
     * @example Supplied type/format is a 'substitution' String and the receiver
     *     is a String:
     *     <code>
     *          '4582022'.as('@{@@@-@@@@}');
     *          <samp>458-2022</samp>
     *     </code> Supplied type/format is a 'substitution' String and the
     *     receiver is not a String:
     *     <code>
     *          (22).as('#{##.00}');
     *          <samp>22.00</samp>
     *     </code>
     *     <code>
     *          TP.dc().as('%{d}');
     *          <samp>27</samp>
     *     </code> Supplied type/format is a String which names a 'format token'
     *     and the receiver is a String. Because the receiver is a String here,
     *     the 'format token' should correspond to a method name on the String
     *     type without the 'as' portion (i.e. 'startUpper'):
     *     <code>
     *          'bill'.as('startUpper');
     *          <samp>Bill</samp>
     *     </code> Supplied type/format is a String which names a 'format token'
     *     and the receiver is not a String. This 'format token' acts as an
     *     argument to the receiver type's 'format' method (i.e. 'YYYY' is
     *     defined on the TP.iso.ISO8601 type and String's transformDate method
     *     is coded to find that token on that type).
     *     <code>
     *          TP.dc().as('YYYY');
     *          <samp>2008</samp>
     *     </code> Supplied type/format is a String which contains a 'formatting
     *     template' and the receiver is an object with named properties.
     *     <code>
     *          TP.hc('fname', 'bill').as('My first name is: {{fname}}');
     *          <samp>My first name is: Bill</samp>
     *     </code>
     *     <code>
     *          TP.ac(1, 2, 3).as('The second item is: {{1}}', TP.hc('repeat',
     *         false));
     *          <samp>The second item is: 2</samp>
     *     </code>
     *     <code>
     *          (22).as('It\'s value is: {{value}}');
     *          <samp>It's value is: 22</samp>
     *     </code> Supplied type/format is not a String - its a TIBET Type
     *     object. The receiver may implement an 'as<type/format' method or the
     *     type/format may implement a 'from<type>' method, where <type> is the
     *     receiver's type.
     *     <code>
     *          foo = TP.ac(1, 2 ,TP.hc('foo', 'bar')).as('TP.dom.XMLRPCNode');
     *          <samp>[object Element]</samp>
     *          TP.str(foo);
     *          <samp>... string representation of foo ...</samp>
     *     </code> Supplied type/format is not a String, but its not a Type
     *     either. It could be a Function or another Object that implements the
     *     'format' (or 'format<Type>') method.
     *     <code>
     *          (22).as(function (anObj) {return 'His age is: ' + anObj});
     *          <samp>His age is: 22</samp>
     *     </code>
     *     <code>
     *          transformObj = TP.lang.Object.construct();
     *          transformObj.addLocalMethod('transform', function (anObj)
     *         {return 'The value is: ' + anObj});
     *          (22).as(transformObj);
     *          <samp>The value is: 22</samp>
     *     </code>
     *     <code>
     *          transformObj = TP.lang.Object.construct();
     *          transformObj.addLocalMethod('transformNumber', function (anObj)
     *         {return 'This is a Number: ' + anObj});
     *          transformObj.addLocalMethod('transformDate', function (anObj)
     *         {return 'This is a Date: ' + anObj});
     *          (22).as(transformObj);
     *          <samp>This is a Number: 22</samp>
     *          TP.dc().as(transformObj);
     *          <samp>This is a Date: Sat Dec 27 2008 17:31:27 GMT-0600
     *         (CST)</samp>
     *     </code>
     * @returns {Object|undefined} An instance of the desired type/format.
     */

    var funcName,
        type,
        typeName,
        args;

    if (TP.notValid(typeOrFormat)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  try to jump quickly to asString() when it's clearly not a type name
    if (TP.isString(typeOrFormat)) {
        //  certain names map to 'as' methods that are native here
        funcName = 'as' + TP.makeStartUpper(typeOrFormat);
        if (TP.canInvoke(this, funcName)) {
            return this[funcName](formatParams);
        }

        //  not explicitly a bad type name, so see if we can locate the
        //  type. If not then its likely a registered format name, but
        //  either way we'll defer to format
        if (TP.notValid(type = TP.sys.getTypeByName(typeOrFormat))) {
            return typeOrFormat.transform(this, formatParams);
        }

        typeName = typeOrFormat;
    } else if (!TP.isType(typeOrFormat)) {
        //  It's not a String and not a Type either... might be a Function
        //  or some other kind of object... call 'transform' on that object
        //  and let it try...

        if (TP.canInvoke(typeOrFormat, 'transform')) {
            switch (arguments.length) {
                case 1:
                    return typeOrFormat.transform(this);
                case 2:
                    return typeOrFormat.transform(this, formatParams);
                default:
                    args = TP.args(arguments);
                    args.atPut(0, this);
                    return typeOrFormat.transform.apply(typeOrFormat, args);
            }
        } else {
            //  Not a String, not a Type, not an object that can perform a
            //  'transform'
            return;
        }
    } else {
        type = typeOrFormat;
        if (TP.canInvoke(type, 'getName')) {
            typeName = type.getName();
        }
    }

    //  don't convert things that are already the target type
    if (TP.isKindOf(this, type)) {
        return this;
    }

    //  if we can get the name of the type we're trying to convert to then
    //  we can look for an instance or type method that can convert for us
    if (TP.notEmpty(typeName)) {
        funcName = 'as' + TP.escapeTypeName(typeName);
        if (!TP.canInvoke(this, funcName)) {
            funcName = 'as' +
                        TP.escapeTypeName(typeName.asJSIdentifier(false));
        }

        //  If we can invoke the 'as' method directly, do it.
        if (TP.canInvoke(this, funcName)) {
            switch (arguments.length) {
                case 1:
                    return this[funcName]();
                case 2:
                    return this[funcName](formatParams);
                default:
                    args = TP.args(arguments, 1);
                    return this[funcName].apply(this, args);
            }
        }
    }

    //  if we got here we're either talking to a type that can't tell us
    //  what its name is (not good) or the receiver doesn't implement a
    //  decent as() variant for that type. In either case however all we can
    //  do is hope the type implements from() and we'll try that approach.
    if (TP.canInvoke(type, 'from')) {
        switch (arguments.length) {
            case 1:
                return type.from(this);
            case 2:
                return type.from(this, formatParams);
            default:
                //  have to build up an argument array that includes the
                //  receiver as the first argument rather than the type
                args = TP.args(arguments);
                args.atPut(0, this);
                return type.from.apply(type, args);
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('asObject',
function() {

    /**
     * @method asObject
     * @summary Returns a 'plain JavaScript object' version of the receiver.
     * @returns {Object} The receiver as a plain JavaScript object.
     */

    return this.valueOf();
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('format',
function(aFormat, formatParams) {

    /**
     * @method format
     * @summary Formats the receiver using the format provided, formatting the
     *     object and possibly using any optional formatting specification
     *     provided.
     * @description In this method, the receiver is the object that is formatted
     *     using the format specification defined by the aFormat parameter.
     *
     *     For example, a string with {{varname}} entries, or which names a
     *     specific Type, will cause the receiver to be formatted using the
     *     string as a template, or the Type as a formatter by redispatching to
     *     that object's 'transform' call.
     *
     *     This method will also pass the optional formatParams parameter on to
     *     the 'transform' call.
     * @param {String} aFormat The format specification to format the receiver.
     * @param {TP.core.Hash|TP.sig.Request} formatParams Optional format
     *     parameters. These are parameters to a template transform.
     * @returns {String|undefined} The formatted output.
     */

    if (TP.isValid(aFormat)) {
        return aFormat.transform(this, formatParams);
    }

    return;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('transformDate',
function(aDate, transformParams) {

    /**
     * @method transformDate
     * @summary Transforms the supplied Date using the formats provided by the
     *     'substitute' call.
     * @param {Date} aDate The Date object to format.
     * @param {TP.core.Hash|TP.sig.Request} transformParams Optional format
     *     parameters. These should have keys that are used during a keyed
     *     substitution (i.e. Date.FORMATS).
     * @returns {String} The formatted output.
     */

    var format,
        str;

    str = this.toString();

    if (TP.canInvoke(transformParams, 'at')) {
        format = transformParams.at(str);
    }

    if (TP.notValid(format)) {
        //  ISO8601 already defines a number of nice options...but they're
        //  uppercased in storage. See if this format is stored there. If
        //  not, the Date type also can/should define options...
        if (TP.notValid(format = TP.iso.ISO8601.FORMATS.at(str))) {
            if (TP.notValid(format = Date.FORMATS.at(str))) {
                format = null;
            }
        }
    }

    //  Date also can/should define options...
    if (TP.isString(format)) {
        //  found a format, question now is what token set?
        if (/Z$/.test(format)) {
            return format.substitute(aDate, Date.UTC_TOKENS);
        } else if (/\+$/.test(format)) {
            //  ends in +? asking for UTC plus offset
            str = format.strip(/\+$/).substitute(aDate, Date.UTC_TOKENS);

            //  not getUTCISOTimezone or we'll end up with a 'Z'
            return str + aDate.getISOTimezone();
        } else {
            return format.substitute(aDate, Date.LOCALTIME_TOKENS);
        }
    }

    //  individual token variants can also be found, but we need to know
    //  which token set to look in
    if (/Z$/.test(str) && /%{/.test(str)) {
        format = str.strip(/Z$/);

        return format.substitute(aDate, Date.UTC_TOKENS);
    } else if (/\+$/.test(str) && /%{/.test(str)) {
        //  ends in + ? asking for UTC plus offset

        format = str.strip(/\+$/);

        return format.substitute(aDate, Date.UTC_TOKENS);
    } else if (/%{/.test(str)) {
        return str.substitute(aDate, Date.LOCALTIME_TOKENS);
    }

    //  return bad format string, not data, for debugging
    return str;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('transformNumber',
function(aNumber, transformParams) {

    /**
     * @method transformNumber
     * @summary Transforms the supplied Number using the formats provided by
     *     the 'substitute()' call. Note: This method does not use the
     *     'transformParams' parameter.
     * @param {Number} aNumber The Number object to format.
     * @param {TP.core.Hash|TP.sig.Request} transformParams Optional format
     *     parameters. These should have keys that are used during a keyed
     *     substitution (i.e. Date.FORMATS).
     * @returns {String} The formatted output.
     */

    var str;

    str = this.toString();
    if (/#{/.test(str)) {
        return str.substitute(aNumber);
    }

    //  return bad format string, not data, for debugging
    return str;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('transformObject',
function(anObject, transformParams) {

    /**
     * @method transformObject
     * @summary Transforms an object using the 'substitute()' call.
     * @description Depending on the character given in the format of the
     *     receiver, this call will perform the following substitutions (and
     *     expect the following types for anObject):
     * @param {Object} anObject The object to format.
     * @param {TP.core.Hash|TP.sig.Request} transformParams Optional format
     *     parameters. These should have keys that are used during a keyed
     *     substitution (i.e. Date.FORMATS).
     * @returns {String} A formatted string representation of the object.
     *      @ - character substitution - String
     *      # - numeric substitution - Number
     *      % - *     keyed substitution - Object (keys found on object type)
     */

    var obj,
        str,
        transform,

        num,
        date;

    str = this.toString();
    if (/#{/.test(str)) {
        //  have to try to get the object in numerical form
        obj = TP.ifInvalid(TP.nc(anObject), anObject);

        return str.substitute(obj);
    } else if (/%{/.test(str)) {
        //  NOTE that we default to using the object's type as the key
        //  source for performing any lookups that might be appropriate
        transform = transformParams || TP.type(anObject);
        return str.substitute(anObject, transform);
    } else if (TP.regex.FORMAT_SUBSTITUTION.test(str)) {
        return str.substitute(anObject);
    } else {

        //  Otherwise, we special case to see if we can create a Number from the
        //  supplied object.
        num = parseFloat(anObject);

        //  If so, see if we can create a Data
        if (TP.isNumber(num)) {

            date = TP.dc(num);
            if (TP.isDate(date)) {

                //  Got a real Date - run our transformation on it.
                return this.transform(date);
            }

            //  Didn't get a Date, but have a real Number - run our
            //  transformation on it.
            return this.transform(num);
        }
    }

    //  return bad format string, not data, for debugging
    return str;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('transformString',
function(aString, transformParams) {

    /**
     * @method transformString
     * @summary Transforms the supplied String using the 'character
     *     substitution' format provided by the internal 'substitute()' call.
     *     Note: This method does not use the 'transformParams' parameter.
     * @param {String} aString The String object to format.
     * @param {TP.core.Hash|TP.sig.Request} transformParams Optional format
     *     parameters. These should have keys that are used during a keyed
     *     substitution (i.e. Date.FORMATS).
     * @returns {String} The formatted output.
     */

    var str;

    str = this.toString();
    if (/@{/.test(str)) {
        return str.substitute(aString);
    }

    //  It may be another kind of substitution, so we pass it over to the
    //  more generic 'transformObject'.
    return this.transformObject(aString, transformParams);
});

//  ------------------------------------------------------------------------
//  TP Meta Inst methods - SIGNAL HANDLING
//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('callNextHandler',
function() {

    /**
     * @method callNextHandler
     * @summary Invokes the next handler in the *signal* type hierarchy, if the
     *     receiver can respond to that.
     * @description This method is used when the receiver needs to 'call up' to
     *     the next most specific handler. For instance, if the 'Bar' signal is
     *     a subtype of the 'Foo' signal, and we're currently executing the
     *     'Bar' handler method, invoking callNextHandler() will invoke the
     *     'Foo' handler on the receiver, if it has such a handler.
     * @returns {Object} The handler function's results.
     */

    var theFunction,
        theArgs,

        theSignal,

        functionName,
        handlerDescriptor,

        signalName,
        signalType,

        lookupStartSignal,

        phase,
        nextfunc;

    //  The function we're after will be the current callee. Use the magic
    //  property.
    theFunction = TP.$$currentCallee$$;

    //  We could use this[functionName] but that won't provide a way to avoid
    //  recursions.
    if (TP.notValid(theFunction)) {
        return this.raise('TP.sig.InvalidContext');
    }

    //  If explicit arguments were passed in, use those. Otherwise, use the
    //  magic property that contains the arguments that were in force from the
    //  callee when this method was invoked.
    if (arguments.length > 0) {
        theArgs = arguments;
    } else {
        theArgs = TP.$$currentArgs$$;
    }

    //  The signal being handled (or another instance of some kind of
    //  TP.sig.Signal) should be the first argument. If it isn't, we have
    //  serious problems.
    //  NB: We use primitive index syntax here since theArgs might be an
    //  'arguments' object.
    theSignal = theArgs[0];
    if (!TP.isKindOf(theSignal, TP.sig.Signal)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    functionName = theFunction.getName();

    //  Decompose the handler function name into a descriptor and make sure that
    //  the descriptor has 'signal' property
    handlerDescriptor = TP.decomposeHandlerName(functionName);
    if (TP.notValid(handlerDescriptor) ||
        TP.isEmpty(handlerDescriptor.signal)) {
        return this.raise('TP.sig.InvalidHandler');
    }

    //  Make sure to expand it to get the full signal name for type lookup
    signalName = TP.expandSignalName(handlerDescriptor.signal);

    //  Maks sure we can get a real type object
    signalType = TP.sys.getTypeByName(signalName);
    if (!TP.isType(signalType)) {
        return this.raise('TP.sig.InvalidType');
    }

    //  Grab the 'next most specific' signal type.
    lookupStartSignal = signalType.getSupertypeSignalNames().first();

    //  If the signal is a kind of TP.sig.DOMSignal, then we're being invoked
    //  using a signal that expects DOM semantics. If the phase is AT_TARGET, we
    //  set it explicitly, since the AT_TARGET phase is meaningless *when
    //  computing handler names*. I.e. the DOM has the notion of AT_TARGET, but
    //  not when computing handlers. Handlers are either capturing or bubbling.
    phase = theSignal.getPhase();
    if (TP.isKindOf(theSignal, TP.sig.DOMSignal) && phase === TP.AT_TARGET) {
        phase = TP.BUBBLING;
    }

    //  Get the best handler using the computed starting signal name and the
    //  phase.
    nextfunc = this.getBestHandler(
        theSignal,
        {
            startSignal: lookupStartSignal,
            phase: phase
        });

    //  If its callable, invoke it with the arguments computed from above.
    if (TP.isCallable(nextfunc)) {
        return nextfunc.apply(this, theArgs);
    }
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getBestHandler',
function(aSignal, flags) {

    /**
     * @method getBestHandler
     * @summary Returns the specific function or method which the receiver
     *     would (or did) leverage to respond to the signal provided.
     * @description Note that the startSignal parameter contains an optional
     *     signal name to 'start consideration' from. The computation machinery
     *     in this method will always derive it's signal names by querying
     *     aSignal, but sometimes the caller already knows that it wants to
     *     'skip ahead' to consider signals further down in the chain (the
     *     INHERITANCE_FIRING policy in the notification system does this).
     * @param {TP.sig.Signal} aSignal The signal instance to respond to.
     * @param {Object} [flags] The 'flags' parameter is a method parameter set.
     *     Properties can be any combination of the following:
     *          {String} [startSignal] The signal name to start considering
     *                  handlers if the supplied signal has more than one signal
     *                  name. This parameter is optional and, if not supplied,
     *                  all of the signal names as computed from the supplied
     *                  signal will be used.
     *          {Boolean} [dontTraverseSpoofs=false] True will mean that
     *                  traversing up the supertype chain will be disabled for
     *                  'spoofed' signals (i.e. signals where the signal name
     *                  doesn't match the type name).
     *          {Boolean} [dontTraverseHierarchy=false] True will turn off any
     *                  form of signal hierarchy traversal.
     *          {String} [skipName] A string used to mask off certain handler
     *                  names such as high-level default handlers.
     *          {String} [phase] ('*', TP.CAPTURING, TP.AT_TARGET,
     *                  TP.BUBBLING). The default is whatever phase the supplied
     *                  signal is in.
     * @returns {Function|undefined} The specific function or method that would
     *     be (or was) invoked.
     */

    var handlerNames,
        handlerFlags;

    handlerFlags = flags || {};

    //  NOTE this is a string or number (NOT_FOUND) value, not an array. Also
    //  note it's already filtered by canInvoke, no additional tests needed.
    handlerNames = this.getBestHandlerNames(aSignal, handlerFlags);

    if (handlerNames === TP.NOT_FOUND) {
        return;
    }

    //  No pipe symbol means it's a single handler name, use as is.
    if (!TP.regex.HAS_PIPE.test(handlerNames)) {
        return this[handlerNames];
    }

    //  They're sorted in order, the best one is the first one.
    return this[handlerNames.slice(0, handlerNames.indexOf('|'))];
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getBestHandlerNames',
function(aSignal, flags) {

    /**
     * @method getBestHandlerNames
     * @summary Scans handler metadata and returns a sorted string of handler
     *     names which are viable for the signal and conditions provided.
     * @param {TP.sig.Signal} aSignal The signal instance to respond to.
     * @param {Object} flags The 'flags' parameter is a method parameter set.
     *     Properties can be any combination of the following:
     *          {String} [startSignal] The signal name to start considering
     *                  handlers if the supplied signal has more than one signal
     *                  name. This parameter is optional and, if not supplied,
     *                  all of the signal names as computed from the supplied
     *                  signal will be used.
     *          {Boolean} [dontTraverseSpoofs=false] True will mean that
     *                  traversing up the supertype chain will be disabled for
     *                  'spoofed' signals (i.e. signals where the signal name
     *                  doesn't match the type name).
     *          {Boolean} [dontTraverseHierarchy=false] True will turn off any
     *                  form of signal hierarchy traversal.
     *          {String} [skipName] A string used to mask off certain handler
     *                  names such as high-level default handlers.
     *          {String} [phase] ('*', TP.CAPTURING, TP.AT_TARGET,
     *                  TP.BUBBLING). The default is whatever phase the supplied
     *                  signal is in.
     * @returns {String|Number|undefined} TP.NOT_FOUND or a set of names joined
     *     by '|'.
     */

    var orgid,
        signalNames,
        phase,
        states,
        expression,
        index,
        regex,
        names,
        sigName,
        thisref,
        cache;

    if (TP.notValid(aSignal)) {
        return;
    }

    expression = 'handle';

    //  ---
    //  Signal
    //  ---

    //  TODO: ensure we collect the right list when spoofing is in place.
    //  getSignalNames usually masks the actual signal with spoofs.

    //  If we're not traversing or the signal is spoofing its name and we're
    //  not traversing for spoofed instances it's a single signal check.
    if (TP.isTrue(flags.dontTraverseHierarchy) ||
        TP.isTrue(flags.dontTraverseSpoofs) && aSignal.isSpoofed()) {
        //  NOTE we do _NOT_ create an array here, just set single string.
        signalNames = aSignal.getSignalName();
    } else {
        signalNames = aSignal.getTypeSignalNames();
        if (aSignal.isSpoofed()) {
            //  Type signal name list is most-to-least-specific.
            signalNames.unshift(aSignal.getSignalName());
        }

        //  We're going to be checking a list of one or more signals. The list
        //  has to take into account the startSignal and any skipName.
        if (TP.notEmpty(flags.startSignal) &&
            (index = signalNames.indexOf(flags.startSignal)) !== TP.NOT_FOUND) {
            signalNames = signalNames.slice(index);
        }
    }

    if (TP.isArray(signalNames)) {
        signalNames = signalNames.map(
                        function(name) {
                            return TP.contractSignalName(name);
                        });

        if (TP.notEmpty(flags.skipName)) {
            signalNames.removeValue(TP.contractSignalName(flags.skipName));
        }

        expression += '(' + signalNames.join('|') + ')';
    } else {

        signalNames = TP.contractSignalName(signalNames);

        expression += '(' + signalNames + ')';
    }

    //  ---
    //  Phase
    //  ---

    phase = flags.phase;
    if (TP.notValid(phase)) {
        phase = aSignal.getPhase();
    }

    switch (phase) {
        case '*':
            //  The expression here should match TP.CAPTURING OR TP.AT_TARGET OR
            //  *no* characters (for bubbling, we don't put in *any* text).
            expression += '(' +
                            TP.CAPTURING +
                            '|' +
                            TP.AT_TARGET +
                            '|(\\b\\B)*?)'; //  Matches no characters
            break;
        case TP.CAPTURING:
            expression += TP.CAPTURING;
            break;
        case TP.AT_TARGET:
            expression += TP.AT_TARGET;
            break;
        case TP.BUBBLING:
            break;
        default:
            break;
    }

    //  ---
    //  Origin
    //  ---

    //  Process the origin.
    orgid = TP.ifInvalid(aSignal.getOrigin(), '');
    if (orgid !== TP.ANY) {
        orgid = TP.gid(orgid).split('#').last();

        //  Origins that are "generated" such as TIBET DOM paths aren't
        //  observable so they're not relevant for handler name scans. They'd
        //  also cause our name caches to essentially leak since we'd get
        //  an ever evolving list of keys.
        if (TP.regex.HAS_SLASH.test(orgid) ||
                TP.regex.HAS_OID_SUFFIX.test(orgid)) {
            orgid = '';
        }

        if (TP.isEmpty(orgid)) {
            expression += 'From(' + TP.ANY + ')';
        } else {
            expression += 'From(' + RegExp.escapeMetachars(TP.gid(orgid)) + '|' +
                            TP.ANY + ')';
        }
    } else {
        expression += 'From(' + TP.ANY + ')';
    }

    //  ---
    //  State
    //  ---

    //  Get the state list from either the receiver or the application (with
    //  preference given to the receiver).
    if (TP.canInvoke(this, 'getCurrentStates')) {
        states = this.getCurrentStates();
    } else {
        states = TP.sys.getApplication().getCurrentStates();
    }

    if (TP.isEmpty(states)) {
        expression += 'When(' + TP.ANY + ')';
    } else {
        states = states.map(function(state) {
            return state.asTitleCase();
        });
        expression += 'When(' + states.join('|') + '|' + TP.ANY + ')';
    }

    //  ---
    //  Check Cache
    //  ---

    //  Local, but we reuse a lot of instances so it should be effective. NOTE
    //  we use direct slot access for this internal cache property for speed.
    if (!this.hasOwnProperty('$$handlerNameCache')) {
        this.$$handlerNameCache = TP.hc();
    }
    cache = this.$$handlerNameCache;

    //  Only use cache if the handler list hasn't been updated since, otherwise
    //  reset it with a fresh dictionary.
    if (cache[TP.REVISED] !== undefined) {
        if (cache[TP.REVISED] > TP.sys.$$meta_handlers[TP.REVISED]) {
            //  Already did this particular signal check once. Yay!
            if (cache.hasKey(expression)) {
                return cache.at(expression);
            }
        } else {
            this.$$handlerNameCache = TP.hc();
            cache = this.$$handlerNameCache;
        }
    }

    //  ---
    //  Scan Handler Metadata
    //  ---

    regex = TP.getHandlerRegExp(expression);
    if (regex === undefined) {
        return;
    }

    //  Scan possible list of all handlers for matching routines. Obviously we
    //  don't want to do this too often...it's a big list.
    thisref = this;
    names = TP.sys.$$meta_handlers.filter(
            function(key) {
                return regex.test(key) && TP.canInvoke(thisref, key);
            }).unique();

    //  No reason to sort unless there are at least two results. And no reason
    //  to store an array for all the empty or single-option keys.
    switch (names.getSize()) {
        case 0:
            cache.atPut(expression, TP.NOT_FOUND);
            cache[TP.REVISED] = Date.now();
            return TP.NOT_FOUND;
        case 1:
            sigName = names.at(0);
            cache.atPut(expression, sigName);
            cache[TP.REVISED] = Date.now();
            return sigName;
        default:
            //  Continue on, we need to sort them...
            break;
    }

    //  ---
    //  Sort
    //  ---

    names.sort(
        function(a, b) {
            var aMatch,
                bMatch,
                aIndex,
                bIndex;

            aMatch = TP.regex.SPLIT_HANDLER_NAME.match(a);
            bMatch = TP.regex.SPLIT_HANDLER_NAME.match(b);

            if (Array.isArray(signalNames)) {
                aIndex = signalNames.indexOf(aMatch[1]);
                bIndex = signalNames.indexOf(bMatch[1]);
            } else {
                aIndex = signalNames === aMatch[1] ? 0 : -1;
                bIndex = signalNames === bMatch[1] ? 0 : -1;
            }

            if (aIndex === TP.NOT_FOUND || bIndex === TP.NOT_FOUND) {
                //  TODO:   log a nice warning/error here. shouldn't happen.
                void 0;
            }

            //  Signal types need to be ordered via inheritance/spoof order and
            //  the signal name is always the first sort index.
            if (aIndex < bIndex) {
                return -1;
            }

            if (aIndex === bIndex) {

                //  Secondary option is origins. Concrete before TP.ANY :)
                if (aMatch[4] === bMatch[4]) {

                    //  Ternary index is state. Should be concrete before
                    //  TP.ANY.
                    if (aMatch[6] === bMatch[6]) {
                        return 0;
                    } else if (aMatch[6] === TP.ANY) {
                        return 1;
                    }

                    return -1;
                } else if (aMatch[4] === TP.ANY) {
                    return 1;
                }
                return -1;
            }

            //  aIndex > bIndex
            return 1;
        });

    //  Avoid storing arrays...use string values instead.
    names = names.join('|');
    cache.atPut(expression, names);
    cache[TP.REVISED] = Date.now();

    return names;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('getHandlerRegExp',
function(expression) {

    /**
     * @method getHandlerRegExp
     * @summary Returns a viable regular expression built from the string source
     *     provided. If the regexp has previously been assembled it is reused.
     * @param {String} expression The regular expression source value.
     * @returns {RegExp} The handler name scanning regexp.
     */

    var regex;

    //  NOTE we use an internal slot here for speed in caching/lookup.
    TP.regex.$$handlerScanners = TP.regex.$$handlerScanners || TP.hc();

    regex = TP.regex.$$handlerScanners.at(expression);
    if (!TP.isRegExp(regex)) {
        regex = RegExp.construct(expression);
        TP.regex.$$handlerScanners.atPut(expression, regex);
    }

    return regex;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('handle',
function(aSignal, flags) {

    /**
     * @method handle
     * @summary Handles notification of an incoming signal.
     * @description The implementation of this function on Object instances
     *     looks for a signal-specific handler before defaulting to simply
     *     logging the signal. You shouldn't override this method. Instead,
     *     create custom handle* methods for the various TP.sig.Signal subtypes
     *     you're interested in to get custom behavior. Implement handleSignal()
     *     to serve as a generic signal catcher or handleChange() as a generic
     *     Change handler for example.
     * @param {TP.sig.Signal} aSignal The specific signal to handle.
     * @param {Object} [flags] The 'flags' parameter is a method parameter set.
     *     Properties can be any combination of the following:
     *          {String} [startSignal] The signal name to start considering
     *                  handlers if the supplied signal has more than one signal
     *                  name. This parameter is optional and, if not supplied,
     *                  all of the signal names as computed from the supplied
     *                  signal will be used.
     *          {Boolean} [dontTraverseSpoofs=false] True will mean that
     *                  traversing up the supertype chain will be disabled for
     *                  'spoofed' signals (i.e. signals where the signal name
     *                  doesn't match the type name).
     *          {Boolean} [dontTraverseHierarchy=false] True will turn off any
     *                  form of signal hierarchy traversal.
     *          {String} [skipName] A string used to mask off certain handler
     *                  names such as high-level default handlers.
     *          {String} [phase] ('*', TP.CAPTURING, TP.AT_TARGET,
     *                  TP.BUBBLING). The default is whatever phase the supplied
     *                  signal is in.
     * @param {Boolean} [dontTraverse=false] True will turn off any form of
     *     signal hierarchy traversal.
     * @returns {Object} The handler function's results.
     */

    var handlerFunc,
        oldHandler,
        retVal;

    handlerFunc = this.getBestHandler(aSignal, flags);

    if (TP.isCallable(handlerFunc)) {

        if (!aSignal.hasNotified(handlerFunc, this)) {
            try {
                oldHandler = aSignal.$get('currentHandler');
                aSignal.$set('currentHandler', handlerFunc, false);
                retVal = handlerFunc.call(this, aSignal);
            } finally {
                aSignal.trackHandler(handlerFunc, this);
                aSignal.$set('currentHandler', oldHandler, false);
            }
        }
    } else {
        retVal = TP.NOT_FOUND;
    }

    return retVal;
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('process',
function(aRequest) {

    /**
     * @method process
     * @summary Core request processing method. This method follows the
     *     standard TIBET "best method" pattern of searching the receiver for
     *     the best fitting method for the parameter type and invoking that
     *     method. If no other method can be found the default
     *     processTP_sig_Request method is invoked.
     * @param {TP.sig.Request} aRequest The request to process.
     * @returns {TP.sig.Response} A response containing the processing results.
     */

    var request;

    //  Ensure we have a true TP.sig.Request even when provided with a hash.
    request = TP.request(aRequest);

    //  context, specializer, prefix, suffix, fallback, arglist

    //  NOTE: we have to provide the argument array here since we may have
    //  gotten an empty request and the arguments object may be empty.
    return this.callBestMethod(arguments, request,
                                'process', null,
                                'processTP_sig_Request',
                                TP.ac(request));
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('processAndExecuteWith',
function(aRequest, stdinContent) {

    /**
     * @method processAndExecuteWith
     * @summary Similar to the 'process' method, this method takes in 'stdin'
     *     content and will 'execute' as well as 'process' the request.
     * @param {TP.sig.Request} aRequest The request to process and execute.
     * @param {Object} stdinContent The content to use as 'stdin' when executing
     *     the supplied request.
     * @returns {TP.sig.Response} A response containing the processing results.
     */

    var request;

    //  Ensure we have a true TP.sig.Request even when provided with a hash.
    request = TP.request(aRequest);

    request.atPut('cmdExecute', true);
    request.atPut(TP.STDIN, TP.ac(stdinContent));

    return this.process(request);
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('processTP_sig_Request',
function(aRequest) {

    /**
     * @method processTP_sig_Request
     * @summary Default request processing method. By default this method
     *     simply returns the supplied request's response, if it has one.
     *     Subtypes with processing responsibilities are expected to override
     *     this method.
     * @param {TP.sig.Request} aRequest The request to process.
     * @returns {TP.sig.Response} A response containing the processing results.
     */

    var request,
        result,
        response;

    request = TP.request(aRequest);
    if (TP.notValid(result = request.get('result'))) {
        /* eslint-disable consistent-this */
        result = this;
        /* eslint-enable consistent-this */
    }

    response = request.getResponse(result);
    request.complete(result);

    return response;
});

//  ------------------------------------------------------------------------
//  INFERENCING - DNU RESOLUTION
//  ------------------------------------------------------------------------

/*
Prior to invoking the infer() call every object is given an opportunity to
resolve a DNU trigger itself. This is analogous to the forward() call in
Objective-C under NeXTstep where you could construct objects that were true
proxies, providing a reference and a target for messaging, but forwarding
all actual calls to another object for resolution. That's one potential way
to leverage the functions here.
*/

//  ------------------------------------------------------------------------

Window.Inst.defineMethod('canResolveDNU',
function(anOrigin, aMethodName, anArgArray, callingContext) {

    /**
     * @method canResolveDNU
     * @summary Provides an instance that has triggered the DNU machinery with
     *     an opportunity to handle the problem itself. This is a useful option
     *     for objects that are acting as proxies or adaptors.
     * @param {Object} anOrigin The object asking for help.
     * @param {String} aMethodName The method name that failed.
     * @param {Object[]} anArgArray Optional arguments to function.
     * @param {Function|arguments} callingContext The calling context.
     * @returns {Boolean} TRUE means resolveDNU() will be called. FALSE means
     *     the standard DNU machinery will continue processing. The default is
     *     FALSE.
     */

    //  default is to let main routines handle it
    return false;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('canResolveDNU',
function(anOrigin, aMethodName, anArgArray, callingContext) {

    /**
     * @method canResolveDNU
     * @summary Provides an instance that has triggered the DNU machinery with
     *     an opportunity to handle the problem itself. This is a useful option
     *     for objects that are acting as proxies or adaptors.
     * @param {Object} anOrigin The object asking for help.
     * @param {String} aMethodName The method name that failed.
     * @param {Object[]} anArgArray Optional arguments to function.
     * @param {Function|arguments} callingContext The calling context.
     * @returns {Boolean} TRUE means resolveDNU() will be called. FALSE means
     *     the standard DNU machinery will continue processing. The default is
     *     FALSE.
     */

    //  found a node showing we have a method with that name? then we can
    //  resolve it by loading that node
    return TP.canInvoke(anOrigin, aMethodName);
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('resolveDNU',
function(anOrigin, aMethodName, anArgArray, callingContext) {

    /**
     * @method resolveDNU
     * @summary Invoked by the main DNU machinery when the instance has
     *     responded TRUE to canResolveDNU() for the parameters given.
     * @param {Object} anOrigin The object asking for help.
     * @param {String} aMethodName The method name that failed.
     * @param {Object[]} anArgArray Optional arguments to function.
     * @param {Function|arguments} callingContext The calling context.
     * @returns {Object|undefined} The results of function resolution.
     */

    //  not implemented? can't do anything
    if (!TP.canInvoke(this, aMethodName)) {
        return;
    }

    switch (anArgArray.length) {
        case 0:
            return this[aMethodName]();
        case 1:
            return this[aMethodName](anArgArray[0]);
        case 2:
            return this[aMethodName](anArgArray[0], anArgArray[1]);
        default:
            return this[aMethodName].apply(this, anArgArray);
    }
});

//  ------------------------------------------------------------------------
//  INFERENCING - CORE FUNCTIONS
//  ------------------------------------------------------------------------

/*
Inferencing allows TIBET to truly "write code for you". Not only does TIBET
write code for you, it does it in such a way that the code written can then be
saved so that the next time you run the program TIBET already knows about what
it inferred during previous executions.

Inferencing depends on a few important elements being in place. First, TIBET
uses functions to add methods to all objects. By using functions for this
purpose rather than the standard JavaScript practice of direct property
assignment TIBET is able to control the method-addition process. This is an
example of encapsulation at work and it proves critical to success here.

One of the flags TIBET uses is a $$shouldConstructDNUs flag. This flag tells
TIBET to install method functions with a little extra processing. For each
method that is added a "DoesNotUnderstand" method matching that function's name
is placed on TP.ObjectProto. This method is a "backstop" which ensures that
no matter what object is in action it actually has an implementation for every
method ever defined in TIBET. The result is that when a message isn't understood
by a target rather than triggering an error it actually triggers the function
TP.sys.dnu(). This is what we refer to as "the backstop". The backstop catches
potential errors and is similar in form to the DoesNotUnderstand from Smalltalk.
TIBET's patent-pending implementation of that function is where things diverge.

TIBET makes use of a very regular syntax designed around a few core functions
including as(), from(), isa(), validate(), get(), and set(). In particular,
TIBET uses pairs of these functions to perform certain operations. Type
conversion is handled by the as()/from() pair. Type checking is handled by the
isa()/validate() pair. Data management is handled by the get()/set() pair and
so on. With a regular syntax and mechanism for type conversion comes an
interesting opportunity. By catching function calls which are not understood
but having information in regular form about which types implement that function
and which types the messaged object canbe converted to it is possible to infer
a path to the result through a chain of type conversions.

In Smalltalk when an object doesn't understand something the debugger pops up.
That's obviously far better than Java where poor type casts can cause similar
situations to crash the program. ClassCastException? Down you go.

TIBET handles the DoesNotUnderstand problem a little differently. When an object
doesn't understand how to do something in TIBET the system follows a multi-step
process. First, ask the object itself if it can figure out an alternative via
the canResolveDNU() operations (ala forward()). Next, TIBET checks for type
inference opportunities, ways in which it can literally infer a pathway from the
current type to a type that does implement the requested functionality.

One simple example of type/message inferencing is 'rounding a string'. The
built-in String class does not understand the message 'round'. But Numbers do.
String implements asNumber. TIBET uses this information to infer that the
operation, thereby eliminating the need for developers to create potentially
hundreds of wrappers methods. TIBET can deduce that:

myString.round()

can be resolved via:

myString.asNumber().round().asString();

The inference process creates this operation and invokes it to return the
result. If no inferencing paths are found TIBET invokes a debugger hook.

One thing that is interesting to note about the inference process is that it
not only can generate code but it can install that code on the object so that
future calls don't invoke the inferencing engine. In other words, when TIBET
processes our previous example and determines the solution would be:

myString.asNumber().round().asString();

it constructs a Function instance which performs this task. This function is
then installed on the proper object thereby avoiding the overhead on future
calls. The resulting code can also be saved out via the TIBET change log to
literally have TIBET 'write code for you'. You get the system and some
fundamental type conversions in place and start running. As the inferencing
engine makes decisions you save the ones that are correct and improve on the
ones that aren't. (In other words the inference log is a kind of todo list).
*/

//  ------------------------------------------------------------------------

TP.sys.defineMethod('infer',
function(anOrigin, aMethodName, anArgArray, callingContext) {

    /**
     * @method infer
     * @summary The inferencing driver.
     * @description The inference engine. The current version uses as()
     *     information which is captured during method registration to keep
     *     track of which objects can respond to the method and which type
     *     conversions the origin can be put through. Future versions will add a
     *     number of extensions including:
     *
     *     The current engine utilizes 'forward lookup' semantics. By adding a
     *     check for from() operations on the other types in the system we can
     *     quickly add 'reverse lookup' working from the target method back to
     *     the origin via from() rather than forward via as(). Combining these
     *     two strategies into a 'pong lookup' where we go forward and backward
     *     as needed to look for as() chains that lead to from() chains that
     *     lead to new as() chains is the obvious next step. What might not be
     *     obvious is that get() is a rough synonym for as(). That means that if
     *     an as{Type} isn't found the system will look for get{Type} methods as
     *     an alternative. In TIBET the design centers on having each individual
     *     lookup 'policy' work separately and to allow the engine to be
     *     configured by adding one or more policies to it. The engine will at
     *     that point iterate over the policies looking for a solution via each
     *     policy. The result will be a highly configurable engine which will
     *     provide significant flexibility to developers. These policies can
     *     themselves be grouped into sets which can be used as higher level
     *     'Strategies'. An additional class of policy which may not be obvious
     *     derives from the fact that JavaScript functions aren't bound until
     *     runtime. Using that knowledge it is conceivable to simply follow an
     *     approach in which try/catch is leveraged to try each implementation
     *     of the named method by binding it to anOrigin. If the invocation
     *     throws an exception the system rolls back and tries again until an
     *     operation returns a defined value. This is a Prolog-style inference
     *     policy (try until success) which is straightforward to implement via
     *     try/catch. This is a variation on the Array.choose method, which uses
     *     this basic approach to find the first function which works. My
     *     personal favorite is the 'WAG' policy in which the system simply
     *     finds a version of the method and, if no 'this' references are found,
     *     bind()s it and goes. This could be controlled via a flag defining
     *     some level of 'strictness' for the engine which would order policies
     *     based on how strict they are in checking for certain match criteria.
     *
     *     To control the number of lookup levels the inferencing process
     *     should use the engine will be instrumented with control flags to
     *     allow the programmer to tune the inferencing paths taken. This
     *     concept can be generalized to a parameter known as the 'depth' which
     *     would limit the inference path length.
     *
     *     The features and extensions described here are clearly not in the
     *     current version but they are planned for future releases. Look for
     *     more and more intelligence in the inferencer over time.
     * @param {Object} anOrigin The object asking for help.
     * @param {String} aMethodName The method name to invoke if found.
     * @param {Object[]} anArgArray Optional arguments to function.
     * @param {Function|arguments} callingContext The calling context.
     * @returns {Object|undefined} The results of execution if possible.
     */

    var str,
        i,
        f,
        s,
        typ,
        asMethodName,
        owners,
        len,
        parents;

    //  no inferencing possible on types, we don't convert type objects to
    //  instances of other types...
    if (TP.isType(anOrigin)) {
        TP.sys.logInference('Method inferencing disabled for types.',
                            TP.DEBUG);
        return;
    }

    TP.sys.logInference('Checking for implementers of ' + aMethodName,
                        TP.DEBUG);

    if (TP.notValid(owners = TP.sys.getMethodOwners(aMethodName))) {
        TP.sys.logInference('No implementers of ' + aMethodName + ' found.',
                            TP.DEBUG);
        return;
    }

    //  need a parent list or we're not dealing with a decent object
    if (!TP.canInvoke(anOrigin, 'getSupertypeNames') ||
        TP.notValid(parents = anOrigin.getSupertypeNames())) {
        return;
    }

    len = owners.getSize();
    if (len === 0) {
        TP.sys.logInference('No implementers of ' + aMethodName + ' found.',
                            TP.DEBUG);
        return;
    } else {
        TP.sys.logInference('Found ' + len + ' implementer(s) of ' +
                            aMethodName + '.',
                            TP.DEBUG);
    }

    for (i = 0; i < len; i++) {
        typ = owners.at(i).getName();

        //  skip parents, they'll just cause recursion
        if (parents.containsString(typ)) {
            continue;
        }

        // asMethodName = 'as' + typ;
        asMethodName = 'as(\'' + typ + '\')';

        //  don't try to convert to ourselves...:)
        if (typ === anOrigin.getTypeName()) {
            TP.sys.logInference('Inferring this.' +
                            asMethodName +
                            // '()' +
                            '.... would recurse. Skipping.',
                            TP.DEBUG);
            continue;
        }

        TP.sys.logInference('Inferring this.' +
                            asMethodName +
                            // '()' +
                            '.' +
                            aMethodName +
                            '()',
                            TP.INFO);

        if (TP.sys.$$shouldInvokeInferences()) {
            // if (TP.isCallable(anOrigin[asMethodName]))
            // {
            TP.sys.logInference(
                    'Invoking ' +
                    TP.id(anOrigin) +
                    '.' +
                    asMethodName +
                    // '()' +
                    '.' +
                    aMethodName +
                    '();!',
                    TP.INFO);

            //      The ability to make the engine actually generate
            //      functions and then install them on the receiver is
            //      analogous to the sort of 'hotspot' activity a JVM
            //      undergoes with the difference that the code didn't exist
            //      in the case of TIBET's inferencing. In a JVM the hotspot
            //      engine is simply compiling code the programmer had to
            //      write. In TIBET the engine is writing code for the
            //      programmer, then installing it to avoid future calls to
            //      the inferencing engine. The results are finally added to
            //      a change log which can be written via CGI etc to a
            //      server responsible for acting as a source code
            //      repository for the application. The result is a system
            //      which truly figures out what you wanted to do, writes
            //      code to help you do it, installs the code on the proper
            //      objects, and saves the change to the server so the next
            //      time you run the application you never invoke the
            //      inferencer for that function again.

            //  HERE is a simple, non-hotspot version that works

            //  do this in two parts for now to ensure proper
            //  binding as we move along the path...if you don't
            //  split this out the binding doesn't work properly
            // inst = anOrigin[asMethodName]();
            // return inst[aMethodName].apply(inst, anArgArray);

            //  here's the hotspot version
            s = 'var inst;\n' +
                'var res;\n' +
                'inst=this.' + asMethodName + ';\n' + // '();\n' +
                'if (TP.notValid(inst)) return;\n' +
                'res=inst.' + aMethodName +
                    '.apply(inst, arguments);\n' +
                'if (TP.notValid(res)) return;\n' +
                'return res;\n';
            //  "return res.as('" + anOrigin.getTypeName() + "');\n";

            //  Original version...no return type reconvert.
            // s = 'var inst;\n' +
            //  'inst=this.' + asMethodName + '();\n' +
            //  'return inst.' + aMethodName +
            //    '.apply(inst, arguments);';

            TP.sys.logInference('Generating inferred ' + aMethodName +
                                ' method:\n' + s,
                                TP.DEBUG);

            f = TP.fc(s);

            // f = new Function(s);

            //  install our new function on the receiver...next
            //  time there won't be any inferencing it will just
            //  fire.

            //  TODO: for now we don't go further to do
            //  this at the type or instance method level but
            //  leave it at the local level. some performance
            //  might be gained by altering that so a function
            //  that's constantly targeting new instances of the
            //  same time would only infer() on the first
            //  instance.
            if (TP.isMutable(anOrigin)) {
                anOrigin.addLocalMethod(aMethodName, f);
            } else if (TP.isType(anOrigin)) {
                anOrigin.Type.defineMethod(aMethodName, f);
            } else {
                anOrigin.getType().Inst.defineMethod(aMethodName, f);
            }

            //  here's the fun part...save the change to the
            //  change log if active so next time we don't even
            //  do the infer() to begin with!
            if (TP.sys.shouldLogCodeChanges()) {
                str = '//\tInference generated method\n';
                str += anOrigin.getTypeName() + '.add';
                if (TP.isType(anOrigin)) {
                    str += 'TypeMethod(\'';
                } else {
                    str += 'InstMethod(\'';
                }
                str += aMethodName + '\',' +
                    f.toString().strip(' anonymous') + ');\n';

                TP.sys.logCodeChange(str, TP.DEBUG);
            }

            //  go ahead and run it to resolve this invocation
            switch (anArgArray.length) {
                case 0:
                    return anOrigin[aMethodName]();
                case 1:
                    return anOrigin[aMethodName](anArgArray[0]);
                case 2:
                    return anOrigin[aMethodName](anArgArray[0],
                                                    anArgArray[1]);
                default:
                    return anOrigin[aMethodName].apply(anOrigin,
                                                    anArgArray);
            }
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('dnu',
function(anOrigin, aMethodName, anArgArray, callingContext) {

    /**
     * @method dnu
     * @summary A standard function for catching methods targeted at the wrong
     *     receiver.
     * @description This method is typically invoked via an instance's
     *     doesNotUnderstand call. The doesNotUnderstand functionality is
     *     installed when TIBET's $$shouldConstructDNUs flag is true. When
     *     triggered, this method first checks with the origin to see if it
     *     "canResolve" the problem itself. Then the TIBET inferencer is used.
     *     If all else fails the debugging hook is invoked.
     * @param {Object} anOrigin The object asking for help.
     * @param {String} aMethodName The method name to invoke if found.
     * @param {Object[]} anArgArray Optional arguments to function.
     * @param {Function|arguments} callingContext The calling context.
     * @returns {Object|undefined} The results of execution if possible.
     */

    var i,
        arr,
        anObj,
        orgid,
        stackInfo,
        targetType,
        typeName,
        supers,
        scope,
        len,
        superName;

    if (TP.notValid(anOrigin)) {
        return;
    }

    //  grab the origin's ID for reporting
    orgid = TP.id(anOrigin);

    //  windows are notoriously poor at dealing with DNUs since
    //  they're "special objects" in the browser world, so don't try
    if (TP.isWindow(anOrigin)) {
        TP.sys.logInference((orgid || 'Unresolvable window ') +
                ' triggered backstop for method ' + aMethodName,
                TP.DEBUG);
        return;
    }

    //  next check is to avoid doing something nasty like triggering a DNU
    if (TP.$$isDNU(anOrigin.getTypeName) ||
        TP.$$isDNU(anOrigin.getID) ||
        TP.$$isDNU(anOrigin.canResolveDNU) ||
        TP.$$isDNU(anOrigin.resolveDNU) ||
        TP.$$isDNU(anOrigin.as) ||
        TP.$$isDNU(anOrigin.getSupertypeNames) ||
        TP.$$isDNU(anOrigin.addLocalMethod)) {
        TP.sys.logInference((orgid || 'Unresponsive object ') +
                ' triggered backstop for method ' + aMethodName,
                TP.DEBUG);
        return;
    }

    //  avoid stack overhead if we're not logging
    if (TP.sys.shouldLogInferences()) {
        try {
            throw new Error();
        } catch (e) {
            stackInfo = TP.getStackInfo(e);
        }

        TP.sys.logInference(anOrigin.getTypeName() + ' ' +
                orgid + ' triggered DNU ' + aMethodName + ' at ' +
                stackInfo.join(' \u00BB '),
                TP.DEBUG);
    }

    //  option for origin to reattempt method...this gives individual
    //  types and instances a chance to do local "forward()" processing
    //  etc. which is a nice hook for proxies etc.
    if (anOrigin.canResolveDNU(anOrigin,
                                        aMethodName,
                                        anArgArray,
                                        callingContext)) {
        TP.sys.logInference(anOrigin.getTypeName() + ' ' +
                            orgid + ' canResolve DNU ' +
                            aMethodName + '(...) !',
                            TP.DEBUG);

        return anOrigin.resolveDNU(anOrigin, aMethodName, anArgArray,
                                    callingContext);
    }

    if (TP.sys.$$shouldUseInferencing()) {
        if (TP.isString(aMethodName)) {
            if (aMethodName.indexOf('get') === 0) {
                //  it's a getter
                TP.sys.logInference('Inferring as("' +
                                    aMethodName.slice(3) + '") from ' +
                                    anOrigin.getTypeName() +
                                    '.' + aMethodName + '(...)',
                                    TP.DEBUG);

                //  try as(). If that doesn't return a defined value it
                //  failed to find a resolution so fall thru to TP.sys.infer
                //  get() calls are a form of asking for the object as()
                //  some other representation so we perform that flip
                //  here.
                if (TP.sys.$$shouldInvokeInferences()) {
                    anObj = anOrigin.as(aMethodName.slice(3));
                    if (TP.isDefined(anObj)) {
                        return anObj;
                    }
                }

                TP.sys.logInference('Inferring as("' + aMethodName.slice(3) +
                                    '") from ' + anOrigin.getTypeName() +
                                    '.' + aMethodName +
                                    '(...) was unsuccessful.',
                                    TP.DEBUG);
            }

            //  'as' method
            //  We'll look for a direct fromThisType or other converter
            //  on the target type before we do any advanced inferencing
            //  Since the as() conversion didn't work we try to keep things
            //  between the origin and the target type for as long as
            //  possible since the implication is that these two types will
            //  know the most about how to get the task performed in the
            //  most lossless fashion
            if (aMethodName.indexOf('as') === 0) {
                typeName = aMethodName.slice(2);

                TP.sys.logInference('Inferring ' + typeName + '.from(\'' +
                                        anOrigin.getTypeName() + '\')',
                                        TP.DEBUG);

                //  see if we can grab the other type
                targetType = TP.sys.getTypeByName(typeName);
                if (TP.isType(targetType)) {
                    //  get supertype list of 'this' and see if the type
                    //  we're headed for has a local method of the form
                    //  fromThisType or one of the supertypes we invoke
                    //  that
                    supers = anOrigin.getSupertypeNames().copy();
                    supers.splice(0, 0, anOrigin.getTypeName());

                    TP.sys.logInference('Checking against types ' +
                                        supers,
                                        TP.DEBUG);

                    len = supers.getSize();
                    for (i = 0; i < len; i++) {
                        superName = TP.escapeTypeName(supers.at(i));

                        //  does the target have a proper conversion?
                        scope = targetType.getPropertyScope(
                                                    'from' + superName);

                        if (scope === TP.OVERRIDDEN ||
                            scope === TP.INTRODUCED ||
                            scope === TP.LOCAL) {
                            TP.sys.logInference('Invoking ' +
                                                typeName + '.from(\'' +
                                                superName + '\')',
                                                TP.DEBUG);

                            //  HERE is a string-based version. The
                            //  as()/from() transformation is fairly
                            //  straightforward and subject to dynamic
                            //  changes so we don't encache it (yet)
                            //  put origin into the argument list for
                            //  our from* call. Watch out for this array
                            //  since it's an arguments array.

                            /* eslint-disable no-array-constructor */
                            arr = new Array();
                            /* eslint-enable no-array-constructor */
                            arr.push(anOrigin);

                            return targetType['from' + superName].apply(
                                    targetType,
                                    arr.addAll(anArgArray).asArray());
                        }
                    }
                }

                TP.sys.logInference('Inferring ' + typeName + '.from(\'' +
                                    anOrigin.getTypeName() +
                                    '\') was unsuccessful.',
                                    TP.DEBUG);
            }

            //  'regular' method
            //  using the TP.sys.infer call to look for as(), get(), from()
            //  combinations that will produce a path to the target
            anObj = TP.sys.infer(anOrigin, aMethodName,
                                    anArgArray, callingContext);

            if (TP.isDefined(anObj)) {
                return anObj;
            }
        }
    }

    //  no luck
    TP.sys.logInference(anOrigin.getTypeName() + ' ' + orgid +
                        ' could not solve for ' + aMethodName,
                        TP.DEBUG);

    //  last chance...invoke the debugger :)
    if (TP.sys.shouldUseDebugger()) {
        return TP.sys.$launchDebugger(arguments);
    }

    return;
});

//  ------------------------------------------------------------------------
//  PERFORMANCE TESTING / TUNING
//  ------------------------------------------------------------------------

/*
Performance is always a consideration at some level. We support methods that
will allow TIBET development to focus performance tuning where it's really
needed by using at least a little statistical data to drive decisions.
*/

//  ------------------------------------------------------------------------

TP.sys.$methodStats = TP.hc();

//  ------------------------------------------------------------------------

TP.definePrimitive('profile',
function(aFunction, anArgArray, aCount) {

    /**
     * @method profile
     * @summary Times the invocation of the function provided. This method
     *     allows direct invocation of functions to occur for performance tuning
     *     purposes.
     * @param {Function} aFunction The function being profiled.
     * @param {Object[]} anArgArray The arguments if any.
     * @param {Number} aCount How many iterations do we want?
     * @returns {Number[]} [total time, average time];.
     */

    var i,
        startTime,
        stopTime,
        count;

    count = TP.ifInvalid(aCount, 1);

    //  don't use apply unless we have to since it will add additional
    //  overhead
    if (TP.isArray(anArgArray)) {
        startTime = TP.dc();
        for (i = 0; i < count; i++) {
            aFunction.apply(null, anArgArray);
        }
        stopTime = TP.dc();
    } else {
        startTime = TP.dc();
        for (i = 0; i < count; i++) {
            aFunction();
        }
        stopTime = TP.dc();
    }

    return TP.ac(stopTime.getTime() - startTime.getTime(),
                (stopTime.getTime() - startTime.getTime()) / count);
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('addStatistic',
function(aFunction, millisecondCount, stackNames) {

    /**
     * @method addStatistic
     * @summary Adds a statistic for an invocation of a function.
     * @param {Function} aFunction The function being tracked.
     * @param {Number} millisecondCount A particular "run time" figure.
     * @param {String[]} stackNames An optional call stack array.
     * @returns {TP.core.Hash} The statistics hash for the function.
     */

    var d1,
        d2,
        fn,
        fo,
        max,
        min,
        cnt,
        sum,
        stacks,
        stackID;

    fn = aFunction.getName();
    fo = TP.name(aFunction[TP.OWNER]);

    if (TP.notValid(fn) || TP.notValid(fo) || fo === TP.NONE) {
        return;
    }

    if (TP.notValid(d1 = TP.sys.$methodStats.at(fn))) {
        d1 = TP.hc();
        TP.sys.$methodStats.atPut(fn, d1);
    }

    if (TP.notValid(d2 = d1.at(fo))) {
        d2 = TP.hc();
        d1.atPut(fo, d2);
    }

    //  track basic stats on call count, max, min, avg, sum, etc.
    cnt = TP.ifInvalid(d2.at('cnt'), 0);
    d2.atPut('cnt', cnt + 1);

    sum = TP.ifInvalid(d2.at('sum'), 0);
    d2.atPut('sum', sum + millisecondCount);

    max = TP.ifInvalid(d2.at('max'), 0);
    d2.atPut('max', Math.max(millisecondCount, max));

    min = TP.ifInvalid(d2.at('min'), Number.POSITIVE_INFINITY);
    d2.atPut('min', Math.min(millisecondCount, min));

    d2.atPut('avg', d2.at('sum') / d2.at('cnt'));

    //  manage call stack data if provided
    if (TP.isArray(stackNames)) {
        if (TP.notValid(stacks = d2.at('stacks'))) {
            stacks = TP.hc();
            d2.atPut('stacks', stacks);
        }

        //  anonymous function IDs will throw this off so we need to replace
        //  them with something generic that will help the stacks coalesce
        stackID = stackNames.join(' << ');
        TP.regex.CALL_STACK_ID.lastIndex = 0;
        stackID = stackID.replace(TP.regex.CALL_STACK_ID,
                                    'anonymous$1',
                                    'g');

        if (TP.notValid(cnt = stacks.at(stackID))) {
            stacks.atPut(stackID, 1);
        } else {
            stacks.atPut(stackID, cnt++);
        }
    }

    return d1;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getStatistics',
function(aFunction) {

    /**
     * @method getStatistics
     * @summary Returns any statistics TIBET may have on the particular
     *     function's performance.
     * @param {Function} aFunction The function being tracked.
     * @returns {Number[]|undefined} An array of millisecond counts.
     */

    var fn,
        fo,
        d1;

    if (TP.notValid(aFunction)) {
        return TP.sys.$methodStats;
    }

    fn = aFunction.getName();
    if (TP.notValid(fn)) {
        return;
    }

    d1 = TP.sys.$methodStats.at(fn);

    fo = TP.name(aFunction[TP.OWNER]);
    if (TP.notValid(fo)) {
        return d1;
    }

    if (TP.isValid(d1)) {
        return d1.at(fo);
    }

    return;
});

//  ========================================================================
//  META - REFLECTION
//  ========================================================================

//  ========================================================================
//  TP.FunctionProto - PART II
//  ========================================================================

/*
Methods for accessing the method and attribute hashes for TIBET types.
*/

//  ------------------------------------------------------------------------

TP.FunctionProto.defineMethod('getImplementers',
function(aName) {

    /**
     * @method getImplementers
     * @summary Returns an array containing objects which have declared that
     *     they implement the receiver or a function with that name.
     * @param {String} aName The method name to look up owners for.
     * @returns {Object[]} An Array of objects that implement the receiver.
     */

    //  we support this on the Function object itself as a lookup mechanism
    //  when aName is provided.
    if (this === Function) {
        return TP.sys.getMethodOwners(aName);
    }

    if (TP.isType(this)) {
        return TP.ac();
    }

    return TP.sys.getMethodOwners(this);
});

//  ------------------------------------------------------------------------

TP.defineMetaTypeMethod('getSupertype',
function() {

    /**
     * @method getSupertype
     * @summary Return the supertype of the receiver. For most native types
     *     this returns Object.
     * @returns {Object|undefined} The supertype of the receiver.
     */

    //  Object doesn't have a supertype thanks ;)
    if (this === Object) {
        return;
    }

    //  Strictly speaking when we're a function instance we can be either a
    //  standard function (in which case the answer is Object), or we can be a
    //  Type. In that case it's trickier since we want the type of our prototype
    //  to work consistently with JS-style inheritance semantics.
    if (!TP.isType(this)) {
        return Object;
    }

    return this[TP.SUPER];
});

//  ------------------------------------------------------------------------

TP.defineMetaTypeMethod('getSupertypeName',
function() {

    /**
     * @method getSupertypeName
     * @summary Return the supertype name of the receiver. For most native
     *     types this returns Object.
     * @returns {String|undefined} The supertype name of the receiver.
     */

    //  Object doesn't have a supertype thanks ;)
    if (this === Object) {
        return;
    }

    //  Strictly speaking when we're a function instance we can be either a
    //  standard function (in which case the answer is "Object"), or we can
    //  be a Type. In that case it's trickier since we want the type of our
    //  prototype to work consistently with JS-style inheritance semantics.
    if (!TP.isType(this)) {
        return 'Object';
    }

    return this[TP.SUPER].getName();
});

//  ------------------------------------------------------------------------

TP.defineMetaTypeMethod('defineSubtype',
function(name) {

    /**
     * @method defineSubtype
     * @summary Adds a new subtype to the receiver. The default implementation
     *     throws an exception due to restrictions in certain browsers. This
     *     call is therefore only valid for subtypes of TP.FunctionProto.
     * @param {String} name The name of the subtype, including an optional
     *     namespace prefix and colon or dot separator.
     */

    return this.raise('TP.sig.InheritanceException',
                                        'Attempt to subtype Native type.');
});

//  ------------------------------------------------------------------------
//  TP.FunctionProto - INSTANCE CREATION
//  ------------------------------------------------------------------------

/*
Implementations of the baseline instance creation API for native types (via
their reliance on TP.FunctionProto as a root)
*/

//  ------------------------------------------------------------------------

TP.defineMetaTypeMethod('$alloc',
function() {

    /**
     * @method $alloc
     * @summary Allocates and returns a new instance but doesn't initialize it.
     *     This is the primitive form of object allocation used to construct new
     *     instances.
     * @returns {Object}
     */

    var name,
        Constructor;

    name = this.$getName();
    Constructor = TP[name] || TP.global[name];

    /* eslint-disable new-cap */
    if (TP.notValid(Constructor)) {
        return new TP.global[name]();
    } else {
        return new Constructor();
    }
    /* eslint-enable new-cap */
});

//  ------------------------------------------------------------------------

TP.defineMetaTypeMethod('isAbstract',
function(aFlag) {

    /**
     * @method isAbstract
     * @summary Returns true if the receiver is abstract.
     * @description In TIBET this means instances can be constructed as long as
     *     a valid subtype can be found to provide them. Instances of a subtype
     *     are, by definition, an instance of their supertype so this is a valid
     *     OO construct and offers a lot of support for both localization and
     *     parameter-specific type specialization. If aFlag is passed this
     *     method doubles as a set() call.
     * @param {Boolean} aFlag Value to set for abstract.
     * @returns {Boolean}
     */

    //  no foundational types are abstract
    return false;
});

//  ------------------------------------------------------------------------

TP.defineMetaTypeMethod('canConstruct',
function() {

    /**
     * @method canConstruct
     * @summary Returns true if the receiver can construct a valid instance
     *     given the parameters provided. This method is invoked by supertype
     *     processing of the constructViaSubtype() method when searching for a
     *     potential subtype to manage the instance.
     * @returns {Boolean} Whether or not an instance of this can be constructed
     *     from the parameters provided.
     */

    //  note that the default is false, subtypes must actively validate
    //  that they can handle the instance creation request
    return false;
});

//  ------------------------------------------------------------------------

TP.defineMetaTypeMethod('constructViaSubtype',
function() {

    /**
     * @method constructViaSubtype
     * @summary Returns a new instance of the receiving type in the form of an
     *     instance of a viable subtype.
     * @returns {undefined}
     */

    //  no default implementation, just return undefined
    return;
});

//  ------------------------------------------------------------------------

TP.defineMetaTypeMethod('getConcreteType',
function() {

    /**
     * @method getConcreteType
     * @summary Returns the concrete type for the receiver. When the receiving
     *     type is abstract this will not be the receiver, but when the receiver
     *     is abstract the type returned is the one that would be used to
     *     construct an instance based on the incoming parameters.
     * @returns {Object}
     */

    if (TP.isType(this)) {
        return this;
    }

    return this.getType();
});

//  ------------------------------------------------------------------------

TP.defineMetaTypeMethod('$construct',
function() {

    /**
     * @method $construct
     * @summary Returns a new instance of the receiving constructor. This
     *     variant is here to support a common api that includes the native
     *     classes. This primitive $construct call is provided largely so types
     *     which override construct can access the low-level alloc/init.
     * @returns {Object}
     */

    var newinst,
        optinst;

    //  use metadata link (to instance constructor) for primitive call
    newinst = this.$alloc();

    newinst[TP.TYPE] = this[TP.TYPE];

    //  initialize the new instance. Notice that the object passed back
    //  does NOT have to be the object passed in. This is critical because
    //  in TIBET's collection classes we often local program an Array or
    //  Object to stand in for what you think is a collection type. Also note
    //  that the $init is a shared internal initializer useful for hidden
    //  initialization that can be leveraged by all instances.
    newinst = newinst.$init.apply(newinst, arguments);
    optinst = newinst.init.apply(newinst, arguments);

    //  if init() returns a non-null object that's our return value.
    //  this lets init() cheat and return an object of its choice
    if (TP.isValid(optinst)) {
        return optinst;
    } else {
        return newinst;
    }
});

//  ------------------------------------------------------------------------

TP.defineMetaTypeMethod('construct',
function() {

    /**
     * @method construct
     * @summary Returns a new instance of the receiving constructor. This
     *     variant is here to support a common api that includes the native
     *     classes. One aspect of this call is that, when the receiving type is
     *     abstract the instance returned, if any, will be of a valid subtype of
     *     the receiving type. This is an acceptable use of polymorphism and
     *     inheritance given that instances of subtypes should be functional
     *     instances of their supertypes (restrictive subclassing isn't
     *     considered an appropriate modeling approach in TIBET. There are so
     *     many other ways to reuse behavior via composition, traits, etc.).
     * @returns {Object}
     */

    var newinst,
        optinst;

    //  if the receiver is an abstract type we'll defer creation to the
    //  viaSubtype variant. this allows the remainder of this method to be
    //  inherited and reused by the subtypes themselves.
    if (this.isAbstract()) {
        return this.constructViaSubtype.apply(this, arguments);
    }

    //  use metadata link (to instance constructor) for primitive call
    newinst = this.$alloc();

    newinst[TP.TYPE] = this[TP.TYPE];

    //  initialize the new instance. Notice that the object passed back
    //  does NOT have to be the object passed in. This is critical because
    //  in TIBET's collection classes we often local program an Array or
    //  Object to stand in for what you think is a collection type. Also note
    //  that the $init is a shared internal initializer useful for hidden
    //  initialization that can be leveraged by all instances.
    newinst = newinst.$init.apply(newinst, arguments);
    optinst = newinst.init.apply(newinst, arguments);

    //  if init() returns a non-null object that's our return value.
    //  this lets init() cheat and return an object of its choice
    if (TP.isValid(optinst)) {
        return optinst;
    } else {
        return newinst;
    }
});

//  ------------------------------------------------------------------------
//  TP.FunctionProto - ENCAPSULATION
//  ------------------------------------------------------------------------

TP.FunctionProto.defineMethod('getValue',
function() {

    /**
     * @method getValue
     * @summary Returns the value of the receiver. In the case of functions
     *     this is analogous to invocation.
     * @returns {Object} The function's return value upon invocation.
     */

    //  If the receiver is a native Function, it may throw an exception if we
    //  try to execute it without any arguments or for other reasons. Therefore,
    //  we don't execute them this way
    if (TP.isNativeFunction(this)) {
        return null;
    }

    return this.apply(null, arguments);
});

//  ------------------------------------------------------------------------
//  TP.FunctionProto - SIGNAL HANDLING
//  ------------------------------------------------------------------------

TP.FunctionProto.defineMethod('handle',
function(aSignal) {

    /**
     * @method handle
     * @summary Handles notification of an incoming signal. The version of this
     *     method on non-type Function instances simply calls the receiver with
     *     the signal as the only parameter. This model allows both observers
     *     and handlers to be registered for notification and to handle the
     *     notification in a consistent fashion.
     * @param {TP.sig.Signal} aSignal The signal instance to respond to.
     * @returns {Object} The function's return value.
     */

    var inst;

    //  if we're a type then we do things differently, otherwise we just
    //  fire the function with the signal as the parameter, treating the
    //  receiver as the handler function.
    if (!TP.isType(this)) {
        return this(aSignal);
    }

    if (!TP.canInvoke(this, 'construct')) {
        return this.raise('TP.sig.InvalidHandler',
                            'Unable to construct handler instance.');
    }

    //  if we're a type then we try to construct an instance and get it to
    //  handle things
    if (TP.notValid(inst = this.construct())) {
        return this.raise('TP.sig.InvalidHandler',
                            'Unable to construct handler instance.');
    }

    return inst.handle(aSignal);
});

//  ========================================================================
//  TYPE HANDLERS
//  ========================================================================

/*
When signal map entries contain references to Type names the result is that
the Type is returned as the handler. For TIBET purposes Types used as
handlers typically construct an instance to handle the specific event.
*/

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('fromTP_sig_Signal',
function(aSignal) {

    /**
     * @method fromTP_sig_Signal
     * @summary Common backstop for constructing instances from a
     *     TP.sig.Signal which should normally only occur for types that are
     *     being used as handlers for signal data.
     * @param {TP.sig.Signal} aSignal The signal instance to respond to.
     * @returns {Object} The function's return value.
     */

    //  default is to just return a new instance
    return this.construct();
});

//  ========================================================================
//  TP.ObjectProto - PART II
//  ========================================================================

/*
TP.ObjectProto is the root of the 'instance' inheritance tree for native objects
and all other objects in the system. Properties placed here are shared by
literally every object in the system (with the possible exception of Window
which is due to the, um, 'design decision' to merge the Window instance
name space with the global script execution context).
*/

//  ------------------------------------------------------------------------
//  META PROGRAMMING - DELEGATES AND DNUs
//  ------------------------------------------------------------------------

TP.definePrimitive('backstop',
function(anInterface, anObject, shouldForce) {

    /**
     * @method backstop
     * @summary Iterate over anInterface and install backstop methods for any
     *     methods for which no current backstop exists. Creating these dnu
     *     methods helps ensure proper dnu/infer processing will be triggered as
     *     needed when any of these methods is called for a receiver than can't
     *     process them.
     * @param {String|String[]} anInterface The method name(s) to install.
     * @param {Object} anObject An optional target object which should receive
     *     the specified methods. When not provided this defaults to
     *     TP.ObjectProto so that the backstops are global.
     * @param {Boolean} shouldForce True to force construction of the DNU even
     *     when the receiver canInvoke a specific method in the interface.
     * @returns {Number} The actual number of methods backstopped.
     */

    var target,
        force,
        count,
        list,
        len,
        i,
        fname,
        theDNU;

    target = TP.ifInvalid(anObject, TP.ObjectProto);
    force = shouldForce ? true : false;
    count = 0;

    list = TP.isArray(anInterface) ? anInterface : TP.ac().add(anInterface);

    if (TP.isEmpty(list)) {
        return count;
    }

    //  on Moz there's no reason to build dnu methods at the top level
    //  unless we're being asked to force overlaying a method we find. the
    //  built-in backstop will do what we need otherwise
    if (TP.sys.isUA('GECKO') && target === TP.ObjectProto) {
        return 0;
    }

    len = list.getSize();
    for (i = 0; i < len; i++) {
        //  avoid nulls in arrays
        if (TP.isEmpty(fname = list.at(i))) {
            continue;
        }

        //  avoid existing methods unless forced
        if (!force && TP.canInvoke(target, fname)) {
            continue;
        }

        //  don't build DNUs for things in the DNU exclusion list
        if (TP.sys.$noDNUs.containsString(fname)) {
            continue;
        }

        theDNU = Function.constructDNU(fname);
        try {
            Object.defineProperty(
                    target,
                    fname,
                    TP.PROPERTY_DEFAULTS);
            target[fname] = theDNU;

            count++;
        } catch (e) {
            TP.ifWarn() ?
                TP.warn(TP.ec(e, 'Unable to assign backstop method: ' +
                                    fname),
                        TP.INFERENCE_LOG) : 0;
        }
    }

    return count;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('unstop',
function(anInterface, anObject) {

    /**
     * @method unstop
     * @summary Iterate over anInterface and remove backstop methods for any
     *     current backstops found on the object. The default object is
     *     TP.ObjectProto so you normally want to provide a specific target
     *     rather than defaulting this value. NOTE that on browsers with global
     *     hooks this method works somewhat like TP.backstop() on other
     *     browsers...it installs a function which "deadens" a method so it
     *     emulates "no such method".
     * @param {String|String[]} anInterface The method name(s) to remove.
     * @param {Object} anObject A target object which should have local
     *     backstops removed.
     * @returns {Number} The actual number of backstops removed.
     */

    var target,
        count,
        list,
        deaden,
        len,
        i,
        fname,
        func;

    //  we default to TP.ObjectProto but note that on Moz this won't mean there
    //  won't be backstop processing for the desired method
    target = TP.ifInvalid(anObject, TP.ObjectProto);
    count = 0;
    deaden = false;

    list = TP.isArray(anInterface) ? anInterface : TP.ac().add(anInterface);

    if (TP.isEmpty(list)) {
        return count;
    }

    //  on Moz there's no real backstop method installation, so the only
    //  thing we could do would be to install a method whose goal is to
    //  "deaden" the backstop in this location
    if (TP.sys.isUA('GECKO') && target === TP.ObjectProto) {
        deaden = true;
    }

    len = list.getSize();
    for (i = 0; i < len; i++) {
        //  avoid nulls in arrays
        if (TP.isEmpty(fname = list.at(i))) {
            continue;
        }

        //  avoid non-existing methods unless deaden is true meaning we're
        //  being specifically asked to turn off a spot on a global hook
        if (!TP.canInvoke(target, fname) && !deaden) {
            continue;
        }

        if (deaden) {
            func = Function.constructNSM(fname);
            try {
                target[fname] = func;
                count++;
            } catch (e) {
                TP.ifWarn() ?
                    TP.warn(TP.ec(e, 'Unable to assign NSM method: ' +
                                        fname),
                            TP.INFERENCE_LOG) : 0;
            }
        } else {
            if (TP.owns(target, fname) && TP.$$isDNU(target[fname])) {
                try {
                    delete target[fname];
                    count++;
                } catch (e) {
                    TP.ifWarn() ?
                        TP.warn(TP.ec(e, 'Unable to remove DNU method: ' +
                                            fname),
                                TP.INFERENCE_LOG) : 0;
                }
            }
        }
    }

    return count;
});

//  ------------------------------------------------------------------------
//  META PROGRAMMING - TRAITS
//  ------------------------------------------------------------------------

/* Traits are a powerful way of doing multiple inheritance. You can read more
 * about traits here:
 *      https://en.wikipedia.org/wiki/Trait_(computer_programming)
 *
 *      TIBET uses traits, but with a few twists on traditional traits:
 *
 *      1. In keeping with the pseudo-classical nature of inheritance in TIBET,
 *      rather than traits being 'instance based', they are type based. That is,
 *      traits are not programmed per-instance but are 'inherited' through both
 *      the Type side and Instance side of a type hierarchy. This happens with
 *      either 'type' of property - attribute or method.
 *
 *      2. Conflicted trait resolution can happen either manually or
 *      automatically:
 *
 *          a. Manual trait resolution, the traditional trait conflict
 *          resolution mechanism, has a variety of resolution strategies. In
 *          TIBET, this includes:
 *
 *              i. resolving either type of property to the same named property
 *              on a trait type,
 *              ii. resolving either type of property to the same named property
 *              on a trait type, but with an alternate property name to retain
 *              access to the original property on the receiving type
 *              iii. resolving either type of property to a value given to the
 *              resolveTrait() call,
 *              iv. resolving either type of property using a Function given to
 *              the resolveTrait() call, which takes two parameters, the value
 *              of the trait on the receiving type and the value of the trait on
 *              the resolved type
 *              v. resolving a method property to the method on the trait type,
 *              executing it 'before' or 'after' the method on the receiving
 *              type
 *
 *          b. Automatic trait resolution. If conflicts are not manually
 *          resolved, and TIBET's automatic trait resolution machinery is turned
 *          on (it is by default), then TIBET will use the C3 multiple
 *          inheritance algorithm to determine a resolution for the conflicted
 *          trait. More information can be found here:
 *              http://en.wikipedia.org/wiki/C3_linearization
 *
 *      TIBET uses the following data structure, one per type 'side' and one per
 *      instance 'side' on each type:
 *       {
 *          propName : {
 *              propName    : {String} The property name the trait is for
 *              sourceTypes : {Array} An Array of source Type objects that
 *                              represent possible resolutions for the trait
 *              aliasedFrom : {String} A property name that the trait might be
 *                              aliased from. This is the original property
 *                              name.
 *              aliasedTo   : {String} A property name that the trait might be
 *                              aliased to (i.e. call the aliased method 'bar',
 *                              which redirects the original method 'foo' on a
 *                              resolved type). This is the aliased property
 *                              name.
 *              aroundFlag  : {String} Either TP.BEFORE or TP.AFTER to allow the
 *                              named method from the resolved type to execute
 *                              before or after the method on the receiving type
 *              resolverFunction    : {Function} a Function that will be
 *                                      executed once to determine the value of
 *                                      the property being resolved. The
 *                                      Function will be passed 2 arguments, the
 *                                      value of the property on the receiving
 *                                      type and the value of the property on
 *                                      the resolved type. It should return the
 *                                      value it wants the system to use.
 *              definedValue   : {Function} A value that overrides all of the
 *                                  resolution machinery to be the value that
 *                                  gets returned (i.e. for a method trait, this
 *                                  will be the method that gets invoked).
 *              resolvesToType  : {TP.meta.lang.RootObject} The type that the
 *                                   trait got resolved to.
 *              initialValue    : {Object} In case that the traited property is
 *                                   an attribute, this will be its initial
 *                                   value on the receiving type.
 *          }
 *      }
 *
 */

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineAttribute('$traitsFinalized');

TP.lang.RootObject.Type.defineAttribute('$traitsTypeResolutions');
TP.lang.RootObject.Type.defineAttribute('$traitsInstResolutions');

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('$installTraitTrap',
function(target, targetPropName, track, initialValue, wantsImmediate) {

    /**
     * @method $installTraitTrap
     * @summary Installs a 'trait trap getter' on the supplied target under the
     *     supplied track and property name.
     * @param {Object} target The target object to install the trait trap on.
     * @param {String} targetPropName The name of the property on the target to
     *     install the trait on.
     * @param {String} track The track that the property is for, instance or
     *     type.
     * @param {Object} initialValue Any initial value that the trait will have.
     * @param {Boolean} wantsImmediate Whether or not to resolve the trait
     *     immediately.
     * @returns {TP.meta.lang.RootObject} The receiver.
     */

    var desc,

        traitTrapGetter,
        traitTrapSetter;

    //  If we have a descriptor and it has a getter and that getter has a slot
    //  named 'targetPropName', then this trap has already been installed.
    if ((desc = Object.getOwnPropertyDescriptor(target, targetPropName)) &&
            desc.get &&
            desc.get.targetPropName) {

        return this;
    }

    //  Define a Function that will be used as an E5 getter on the slot. This
    //  function will perform trait resolution.
    traitTrapGetter = function() {

        var mainType,

            propName,
            propTrack,

            len,
            i,

            traitTypes,
            retVal;

        //  If we have a final value, just return that.
        if (traitTrapGetter.finalVal) {
            return traitTrapGetter.finalVal;
        }

        //  If the no exec flag is true (see below in the main method body),
        //  then we just hand back the initially configured value.
        if (TP.$$no_exec_trait_resolution === true) {
            return traitTrapGetter.initialVal;
        }

        //  Since the target here will be either the '.Type' or '.Inst'
        //  prototype object, we want to get back to the type object itself
        //  - that's the TP.OWNER
        mainType = traitTrapGetter.target[TP.OWNER];

        propName = traitTrapGetter.targetPropName;
        propTrack = traitTrapGetter.targetTrack;

        //  Grab all of the type's traits, make a copy and reverse them. We
        //  reverse them so that we have an Array of the *least specific* ones
        //  first and will resolve to the *most specific* one if it has the
        //  slot.
        traitTypes = TP.copy(mainType.getAllTraits());
        traitTypes.reverse();

        //  Set the flag so that during composition and resolution we won't
        //  recurse, but we'll stop short above and just return the original
        //  value.
        TP.$$no_exec_trait_resolution = true;

        try {
            //  Iterate over them and compose this traited property using the
            //  main type and the individual trait type. This will cause a
            //  dictionary of 'trait resolutions' to be created for this slot.
            len = traitTypes.getSize();
            for (i = 0; i < len; i++) {
                mainType.$computePossibleSourceType(
                                        traitTypes.at(i),
                                        propName,
                                        propTrack);
            }

            //  Resolve the traited property using the trait resolution that was
            //  computed above. This should return an Object value that now
            //  represents the resolved trait.
            retVal = mainType.$resolveTraitedProperty(propName, propTrack);

        } finally {
            //  Now that composition and resolution are done, flip the flag back
            //  off.
            TP.$$no_exec_trait_resolution = false;
        }

        //  Set the final value to the returned value. From now on, we'll just
        //  return this value.
        traitTrapGetter.finalVal = retVal;

        //  Make sure to return the computed Object value so that the first slot
        //  access (that kicked off this whole process) gets the correct value.
        return retVal;
    };

    //  Cache these values on the getter for use by the getter.
    traitTrapGetter.target = target;

    //  Define a Function that will be used as an E5 setter on the slot. This
    //  function will perform trait resolution.
    traitTrapSetter = function(val) {
        if (TP.isDefined(traitTrapGetter.finalVal)) {
            traitTrapGetter.finalVal = val;
        } else {
            traitTrapGetter.initialVal = val;
        }
    };

    //  Capture 'meta data' about the property, it's values and the property
    //  name it represents on the target object.
    traitTrapGetter.initialVal = initialValue;
    traitTrapGetter.finalVal = undefined;
    traitTrapGetter.targetPropName = targetPropName;
    traitTrapGetter.targetTrack = track;

    //  If the caller wants this in immediate mode, we just resolve it
    //  immediately here and set the slot.
    if (wantsImmediate) {

        //  Note here how we turn off the 'don't execute the trait resolution'
        //  flag so that the trait resolution machinery actually executes, even
        //  if there is an initial value.

        TP.$$no_exec_trait_resolution = false;
        target[targetPropName] = traitTrapGetter();
        TP.$$no_exec_trait_resolution = true;

        return this;
    }

    //  Define a property on the target under the property name that uses the
    //  getter function as the getter and the setter function as the setter for
    //  the named property slot. When that slot is accessed, the getter and
    //  setter above will be executed.
    Object.defineProperty(
        target,
        targetPropName,
        {
            configurable: true,
            get: traitTrapGetter,
            set: traitTrapSetter
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('addTraits',
function(varargs) {

    /**
     * @method addTraits
     * @summary Adds the type objects supplied as a variable arguments list as
     *     trait types to the receiver.
     * @param {arguments} varargs 1...n trait type objects or a Boolean (the
     *     last argument only - see below).
     * @returns {TP.meta.lang.RootObject} The receiver.
     */

    var inImmediateMode,
        argsLen,
        lastArg,

        traitList,

        allTraits,

        mainTypeTarget,
        resolutions,

        len,
        i,

        len2,
        j,

        traitType,
        traitTypeTarget,
        traitProps,

        propName,
        checkProp1,
        checkProp2,

        entry,
        desc;

    inImmediateMode = false;

    argsLen = arguments.length;

    //  The last parameter to this method can be an optional Boolean that will
    //  immediately resolve all slots rather than setting up a getter.
    lastArg = arguments[arguments.length - 1];
    if (TP.isBoolean(lastArg)) {
        inImmediateMode = lastArg;
        argsLen--;
    }

    //  ---
    //  Gather traits
    //  ---

    //  Make sure that we have an Array for all traits for the receiver, kept as
    //  the overall long-term list of traits that the receiver has.
    if (TP.notValid(traitList = this[TP.TRAITS])) {
        traitList = TP.ac();
        this[TP.TRAITS] = traitList;
    }

    //  Add any new trait types
    len = argsLen;
    for (i = 0; i < len; i++) {

        traitType = arguments[i];

        //  We only add the trait type if it is a Type and if it's not already
        //  contained in the list of existing traits.
        if (TP.isType(traitType) &&
            !traitList.contains(traitType, TP.IDENTITY)) {

            traitList.push(traitType);
        } else if (!TP.isType(traitType) && i === arguments.length - 1) {
            //  Otherwise, if it's not a Type and it's the last argument, then
            //  we need to raise an exception
            return this.raise('Invalid trait type: ', traitType);
        }
    }

    //  Grab all of the traits.
    allTraits = this.getAllTraits();

    //  ---
    //  Preliminary setup
    //  ---

    //  Allocate a 'quick reference' POJO for slots on various types. This
    //  avoids having to call 'getInterface' repeatedly on boot.

    if (TP.notValid(TP.$$trait_interface_store)) {
        TP.$$trait_interface_store = {};
    }

    //  Set the flag that is used above to make sure that when slot is accessed
    //  below that the trait trap getter installed above just returns the value
    //  and doesn't try to resolve the trait.
    TP.$$no_exec_trait_resolution = true;

    //  ---
    //  Install traps for the type side
    //  ---

    mainTypeTarget = this.getPrototype();
    if (TP.notValid(resolutions = this.$get('$traitsTypeResolutions'))) {
        resolutions = TP.hc();
        this.$set('$traitsTypeResolutions', resolutions);
    }

    /* eslint-disable no-loop-func */
    len = allTraits.getSize();
    for (i = 0; i < len; i++) {

        traitType = allTraits.at(i);

        traitTypeTarget = traitType.getPrototype();

        //  If the trait type interface isn't represented in the quick reference
        //  POJO, make an entry for it by asking the trait type's 'type' side
        //  for its interface and stashing that away.
        if (!(traitProps = TP.$$trait_interface_store[traitTypeTarget.$$id])) {
            traitProps = traitTypeTarget.getInterface(TP.SLOT_FILTERS.known);
            TP.$$trait_interface_store[traitTypeTarget.$$id] = traitProps;
        }

        //  Iterate over the properties and, if they don't point to the *exact*
        //  same value, then install the 'trait resolver getter trap'.
        len2 = traitProps.getSize();
        for (j = 0; j < len2; j++) {

            propName = traitProps[j];

            //  If the mainTypeTarget has this property, then we need to check
            //  whether the traitTypeTarget has it too *and that the values
            //  exactly match* (i.e. they are the same object/value). In that
            //  case, we just proceed on.
            checkProp1 = mainTypeTarget[propName];
            checkProp2 = traitTypeTarget[propName];

            if (checkProp1 === checkProp2) {
                continue;
            }

            //  If they both really exist, then we need to drill in and see if
            //  they have '$resolutionMethod' slots that would match the
            //  other's slot (or '$resolutionMethod' slot). This is critical to
            //  avoid problems with traits cascading down the inheritance
            //  hierarchy.
            if (checkProp1 && checkProp2) {
                checkProp1 = checkProp1.$resolutionMethod ?
                                checkProp1.$resolutionMethod :
                                checkProp1;
                checkProp2 = checkProp2.$resolutionMethod ?
                                checkProp2.$resolutionMethod :
                                checkProp2;

                if (checkProp1 === checkProp2) {
                    continue;
                }
            }

            //  If there's already an ECMA5 'getter' at that slot and it has a
            //  'finalVal', slot then clear it.
            desc = Object.getOwnPropertyDescriptor(this, propName);
            if (desc && desc.get && desc.get.finalVal) {
                desc.get.finalVal = undefined;
            }

            //  Since we're adding another 1...n trait types, if an entry exists
            //  for this property, we need to make sure to clear any previously
            //  computed resolution value.
            if (TP.isValid(entry = resolutions.at(propName))) {
                entry.removeKey('resolvesToType');
            }

            //  Install a trait trap on the main type 'type prototype' for
            //  the property found on the trait type.
            this.$installTraitTrap(
                            mainTypeTarget,
                            propName,
                            TP.TYPE_TRACK,
                            mainTypeTarget[propName],
                            inImmediateMode);
        }
    }
    /* eslint-enable no-loop-func */

    //  ---
    //  Install traps for the instance side
    //  ---

    mainTypeTarget = this.getInstPrototype();
    if (TP.notValid(resolutions = this.$get('$traitsInstResolutions'))) {
        resolutions = TP.hc();
        this.$set('$traitsInstResolutions', resolutions);
    }

    /* eslint-disable no-loop-func */
    len = allTraits.getSize();
    for (i = 0; i < len; i++) {

        traitType = allTraits.at(i);

        traitTypeTarget = traitType.getInstPrototype();

        //  If the trait instance interface isn't represented in the quick
        //  reference POJO, make an entry for it by asking the trait type's
        //  'instance' side for its interface and stashing that away.
        if (!(traitProps = TP.$$trait_interface_store[traitTypeTarget.$$id])) {
            traitProps = traitTypeTarget.getInterface(TP.SLOT_FILTERS.known);
            TP.$$trait_interface_store[traitTypeTarget.$$id] = traitProps;
        }

        //  Iterate over the properties and, if they don't point to the *exact*
        //  same value, then install the 'trait resolver getter trap'.
        len2 = traitProps.getSize();
        for (j = 0; j < len2; j++) {

            propName = traitProps[j];

            //  If the mainTypeTarget has this property, then we need to check
            //  whether the traitTypeTarget has it too *and that the values
            //  exactly match* (i.e. they are the same object/value). In that
            //  case, we just proceed on.
            checkProp1 = mainTypeTarget[propName];
            checkProp2 = traitTypeTarget[propName];

            if (checkProp1 === checkProp2) {
                continue;
            }

            //  If they both really exist, then we need to drill in and see if
            //  they have '$resolutionMethod' slots that would match the
            //  other's slot (or '$resolutionMethod' slot). This is critical to
            //  avoid problems with traits cascading down the inheritance
            //  hierarchy.
            if (checkProp1 && checkProp2) {
                checkProp1 = checkProp1.$resolutionMethod ?
                                checkProp1.$resolutionMethod :
                                checkProp1;
                checkProp2 = checkProp2.$resolutionMethod ?
                                checkProp2.$resolutionMethod :
                                checkProp2;

                if (checkProp1 === checkProp2) {
                    continue;
                }
            }

            //  If there's already an ECMA5 'getter' at that slot and it has a
            //  'finalVal', slot then clear it.
            desc = Object.getOwnPropertyDescriptor(this, propName);
            if (desc && desc.get && desc.get.finalVal) {
                desc.get.finalVal = undefined;
            }

            //  Since we're adding another 1...n trait types, if an entry exists
            //  for this property, we need to make sure to clear any previously
            //  computed resolution value.
            if (TP.isValid(entry = resolutions.at(propName))) {
                entry.removeKey('resolvesToType');
            }

            //  Install a trait trap on the main type 'type prototype' for
            //  the property found on the trait type.
            this.$installTraitTrap(
                            mainTypeTarget,
                            propName,
                            TP.INST_TRACK,
                            mainTypeTarget[propName],
                            inImmediateMode);
        }
    }
    /* eslint-enable no-loop-func */

    //  Flip the trait trap getter flag back to false. Slot accesses on any
    //  slots that have been populated will now cause a trait resolution to
    //  occur.
    TP.$$no_exec_trait_resolution = false;

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('$autoResolveConflictedTrait',
function(propName, sources, track) {

    /**
     * @method $autoResolveConflictedTrait
     * @summary 'Auto resolves' the conflicted trait, given the type objects
     *     supplied in sources.
     * @param {String} propName The property name of the conflicted trait.
     * @param {TP.meta.lang.RootObject[]} sources An Array of Type objects that
     *     represent both the main type and the trait types that the auto
     *     resolution machinery will use to try to resolve the slot.
     * @param {String} track The track that the property is for, instance or
     *     type.
     * @returns {TP.lang.RootObject} The receiving type.
     */

    var c3TypeList,

        resolvedType,

        lowestIndex,
        i,
        candidateIndex,

        unresolvedEntry,

        errStr;

    //  Make sure that we're configure to auto resolve.
    if (TP.isTrue(TP.sys.cfg('oo.$$traits_autoresolve'))) {

        //  Compute the C3 linearization for the target type
        c3TypeList = this.computeC3Linearization();

        resolvedType = null;

        //  sources is usually an Array of all of the types that the named
        //  property was found on, but is also sometimes the TP.REQUIRED
        //  constant.
        if (TP.isArray(sources)) {

            lowestIndex = c3TypeList.getSize() - 1;

            //  If we got real candidate types for the conflicts, then try to
            //  resolve using them.
            if (TP.notEmpty(sources)) {

                //  Iterate over the candidate types and find the one with the
                //  *lowest* index in c3TypeList. The C3 list is sorted from
                //  *most* specific to *least* specific - therefore, the one
                //  with the lowest index is the one we want.
                for (i = 0; i < sources.getSize(); i++) {
                    candidateIndex =
                        c3TypeList.indexOf(sources.at(i).getName());
                    lowestIndex = Math.min(lowestIndex, candidateIndex);
                }

                //  Try to get a matching type for the type name we computed.
                resolvedType = TP.sys.getTypeByName(c3TypeList.at(lowestIndex));
            }
        }

        //  If the conflicted traits didn't have any sources or we couldn't get
        //  a type for the name that we computed, then set the unresolved entry
        //  to the supplied sources.
        if (!TP.isType(resolvedType)) {
            unresolvedEntry = sources;
        } else {

            //  If we're logging warnings when we auto resolve, then do so here.
            if (TP.isTrue(TP.sys.cfg('oo.traits_warn'))) {

                //  NOTE: We use a lower-level logging call here, since the
                //  TIBET-level logs themselves use traits and if they are
                //  trying to resolve themselves, then we end up in endlessly
                //  recursive loops.
                TP.boot.$stdout(
                        'AUTO RESOLVING CONFLICTED' +
                            ' ' + track.toUpperCase() + '-LEVEL' +
                            ' PROPERTY: ' + propName +
                            ' ON TARGET: ' + TP.name(this) +
                            ' TO TYPE: ' + TP.name(resolvedType) +
                            ' (CONFLICTED BETWEEN: ' +
                                    sources.map(
                                        function(aType) {
                                            return aType.getName();
                                        }).join(', ') + ')');
            }
        }
    } else {

        //  Otherwise, we're not auto-resolving, so just set the unresolved
        //  entry to true
        unresolvedEntry = true;
    }

    if (TP.isValid(unresolvedEntry) &&
        TP.isTrue(TP.sys.cfg('oo.traits_warn'))) {

        errStr = 'TARGET: ' + TP.name(this) + '\n';

        errStr += 'CONFLICTED PROPERTY: ' + propName +
                    ' (' + track.toUpperCase() + '-LEVEL)\n';

        errStr += 'PROBLEM: ';

        //  If it's an Array, then we assume it's an Array of Type objects.
        if (TP.isArray(sources)) {
            errStr += 'conflicted between: ' +
                sources.map(
                    function(aType) {
                        var proto,
                            val;

                        if (track === TP.TYPE_TRACK) {
                            proto = aType.getPrototype();
                        } else {
                            proto = aType.getInstPrototype();
                        }

                        val = proto[propName];

                        if (TP.isMethod(val)) {
                            //  Important for reporting purposes to actually
                            //  find the owner.
                            return TP.name(val[TP.OWNER]);
                        }

                        return TP.name(aType);
                    });
        } else {

            //  If sources is TP.REQUIRED, print a nice message here
            if (sources === TP.REQUIRED) {
                errStr += 'property required';
            }
        }

        errStr += ' \n';

        errStr += '\nUse resolveTrait[s] to repair' +
                    ' or turn on trait auto-resolution';

        if (track === TP.TYPE_TRACK) {
            return this.raise('TP.sig.InvalidInstantiation',
                                TP.sc('Unresolved type trait\n', errStr));
        } else {
            return this.raise('TP.sig.InvalidInstantiation',
                                TP.sc('Unresolved instance trait\n', errStr));
        }
    }

    return resolvedType;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('$computePossibleSourceType',
function(traitType, propName, track) {

    /**
     * @method $computePossibleSourceType
     * @summary Computes a possible source type between the receiver and the
     *     supplied trait type.
     * @param {TP.meta.lang.RootObject} traitType The trait type that is being
     *     'traited in' on the property.
     * @param {String} propName The property name of the conflicted trait.
     * @param {String} track The track that the property is for, instance or
     *     type.
     * @exception TP.sig.InvalidTrack This is raised when a track is supplied
     *     that isn't either TP.TYPE_TRACK or TP.INST_TRACK.
     * @returns {TP.lang.RootObject} The receiving type.
     */

    var mainTypeTarget,
        traitTypeTarget,
        resolutions,

        checkProp1,
        checkProp2,

        computeOwningType,

        entry,
        actualPropName,

        sources,
        i,
        pastSourceTarget;

    //  Grab the proper targets and resolution data structures depending on the
    //  track supplied.
    if (track === TP.TYPE_TRACK) {
        mainTypeTarget = this.getPrototype();
        traitTypeTarget = traitType.getPrototype();

        if (TP.notValid(resolutions = this.$get('$traitsTypeResolutions'))) {
            resolutions = TP.hc();
            this.$set('$traitsTypeResolutions', resolutions);
        }
    } else if (track === TP.INST_TRACK) {
        mainTypeTarget = this.getInstPrototype();
        traitTypeTarget = traitType.getInstPrototype();

        if (TP.notValid(resolutions = this.$get('$traitsInstResolutions'))) {
            resolutions = TP.hc();
            this.$set('$traitsInstResolutions', resolutions);
        }
    } else {
        return this.raise('TP.sig.InvalidTrackRequest', track);
    }

    //  Get the resolution entry for this property
    entry = resolutions.at(propName);

    //  If this property has been aliased from another property, then we want
    //  the entry for that property.
    if (TP.isValid(entry) && entry.hasKey('aliasedFrom')) {
        actualPropName = entry.at('aliasedFrom');
        entry = resolutions.at(actualPropName);
    } else {
        actualPropName = propName;
    }

    //  If there is no property named by actualPropName on the trait type, exit
    //  here.
    if (!TP.isProperty(traitTypeTarget, actualPropName)) {
        return this;
    }

    //  If the mainTypeTarget has this property, then we need to check whether
    //  the traitTypeTarget has it too *and that the values exactly match* (i.e.
    //  they are the same object/value). In that case, we just proceed on.
    if (TP.isProperty(mainTypeTarget, actualPropName)) {

        checkProp1 = mainTypeTarget[actualPropName];
        checkProp2 = traitTypeTarget[actualPropName];

        if (checkProp1 === checkProp2) {
            return this;
        }

        //  If they both really exist, then we need to drill in and see if they
        //  have '$resolutionMethod' slots that would match the other's slot (or
        //  '$resolutionMethod' slot). This is critical to avoid problems with
        //  traits cascading down the inheritance hierarchy.
        if (checkProp1 && checkProp2) {
            checkProp1 = checkProp1.$resolutionMethod ?
                            checkProp1.$resolutionMethod :
                            checkProp1;
            checkProp2 = checkProp2.$resolutionMethod ?
                            checkProp2.$resolutionMethod :
                            checkProp2;

            if (checkProp1 === checkProp2) {
                return this;
            }
        }
    }

    //  Define a Function that will compute the 'owning type' of the supplied
    //  type target (using either the Type or Inst prototype) and the property
    //  name.
    computeOwningType = function(aTypeTarget, aPropName) {

        var owner;

        //  If it's not a Method, then it's just an attribute slot - return the
        //  TP.OWNER (which for the supplied type target is the owning type
        //  object).
        if (!TP.isMethod(aTypeTarget[aPropName])) {
            return aTypeTarget[TP.OWNER];
        }

        //  Grab the owner of the method.
        owner = aTypeTarget[aPropName][TP.OWNER];

        //  If the owner is either one of these two, we don't want because it
        //  won't be able to answer most of the metaprotocol level questions...
        //  return TP.lang.RootObject instead.
        if (owner === TP.META_TYPE_OWNER ||
            owner === TP.META_INST_OWNER) {
            return TP.lang.RootObject;
        }

        return owner;
    };

    //  If the property already has an entry, then check to see if this trait is
    //  represented in its list of sources. If it is, then this trait/property
    //  combination is already represented.
    if (TP.isValid(entry) && TP.notEmpty(sources = entry.at('sourceTypes'))) {

        if (sources.indexOf(traitType) !== TP.NOT_FOUND) {
            return this;
        }

        //  Loop over all of the sources that have been resolutions for this
        //  slot so far and make the same checks that we made above. Again,
        //  critical to avoid problems with traits and the inheritance hierachy.
        for (i = 0; i < sources.getSize(); i++) {

            pastSourceTarget = track === TP.INST_TRACK ?
                                sources.at(i).getInstPrototype() :
                                sources.at(i).getPrototype();

            checkProp1 = pastSourceTarget[actualPropName];
            checkProp2 = traitTypeTarget[actualPropName];

            if (checkProp1 === checkProp2) {
                return this;
            }
        }

        //  Otherwise, there was an entry for this property, but this trait is
        //  not represented in it - therefore we have a *conflict*. Add this
        //  trait type to the list of sources and mark the property as
        //  conflicted.
        sources.push(traitType);

    } else {

        //  Might have a real entry that had a 'definedValue' slot
        if (TP.notValid(entry)) {
            entry = TP.hc();
        }

        //  If the property is defined on the main type, then populate the
        //  'sourceTypes' with the type objects computed from the main type
        //  target and the trait type target.
        if (TP.isDefined(mainTypeTarget[actualPropName])) {

            entry.atPut('propName', actualPropName);

            entry.atPut('sourceTypes',
                TP.ac(computeOwningType(mainTypeTarget, actualPropName),
                        computeOwningType(traitTypeTarget, actualPropName)));

        } else if (TP.isDefined(traitTypeTarget[actualPropName])) {

            //  Otherwise just populate the 'sourceTypes' with the type object
            //  computed from the trait type target.
            entry.atPut('propName', actualPropName);
            entry.atPut('sourceTypes',
                TP.ac(computeOwningType(traitTypeTarget, actualPropName)));
        }

        resolutions.atPut(actualPropName, entry);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('computeC3Linearization',
function() {

    /**
     * @method computeC3Linearization
     * @summary Computes a 'C3 linearization' off of the receiving type.
     * @description In TIBET, multiple inheritance is implemented using traits.
     *     In other multiple inheritance systems, the 'C3 linearization'
     *     algorithm is used to compute the 'method resolution order' when
     *     looking up methods (as described here:
     *     http://en.wikipedia.org/wiki/C3_linearization). Officially, trait
     *     systems don't look up methods in an automatic fashion - they require
     *     the developer to resolve the trait to a particular type manually.
     *     TIBET supports this very well (see the resolveTrait()/resolveTraits()
     *     methods), but TIBET also allows for the system to 'auto resolve' a
     *     trait and it does this using the C3 algorithm. Therefore, it's
     *     necessary to be able to compute a 'C3 linearization' of the type,
     *     its supertypes, its traits and all of its traits supertypes.
     * @returns {String[]} A list of type names that forms the list of the
     *     receiver's supertype names and all of the trait type names, sorted
     *     using the C3 linearization algorithm.
     */

    //  NOTE: This code is adapted from:
    //          https://github.com/silas/node-c3

    //  It has been reformatted and altered for clarity and to conform to TIBET
    //  coding guidelines.

    var C3,
        c3,

        resolver,

        finalResult;

    C3 = function(name) {
        this.name = name;
        this.typeMap = {};
        this.typeMap[name] = [];
    };

    c3 = function(name) {
        return new C3(name);
    };

    C3.prototype.add = function(name, parentName) {

        var ref;

        if (!TP.isString(name)) {
            TP.raise(this, 'TP.sig.InvalidName');
        }

        if (!TP.isString(parentName)) {
            TP.raise(this, 'TP.sig.InvalidName');
        }

        if (!this.typeMap.hasOwnProperty(parentName)) {
            this.typeMap[parentName] = [];
        }

        if (!this.typeMap.hasOwnProperty(name)) {
            this.typeMap[name] = [];
        }

        ref = this.typeMap[name];

        //  wje: Unlike the original code, TIBET will sometimes produce a
        //  duplicate parent and we don't really care. We simply return and
        //  don't add it to the list. It is, after all, found under the same
        //  child's name - so the system has uniqued it.
        if (ref.indexOf(parentName) >= 0) {
            // throw new Error('Duplicate parent');
            return this;
        }

        this.typeMap[name].push(parentName);

        return this;
    };

    C3.prototype.compute = function() {

        var thisref,
            processMap,

            notHead,
            empty,
            merge,
            run,

            runResult;

        thisref = this;
        processMap = {};

        TP.objectGetKeys(thisref.typeMap).forEach(
                function(n) {
                    processMap[n] = thisref.typeMap[n].slice();
                });

        notHead = function(l, c) {
            return l.some(function(s) {
                return s.indexOf(c) > 0;
            });
        };

        empty = function(s) {
            return s.length;
        };

        merge = function(seqs) {
            var results,
                candidate,
                nonEmptySeqs,
                i;

            results = [];

            /* eslint-disable no-constant-condition */
            while (true) {
            /* eslint-enable no-constant-condition */
                nonEmptySeqs = seqs.filter(empty);

                if (!nonEmptySeqs.length) {
                    return results;
                }

                for (i = 0; i < nonEmptySeqs.length; i++) {
                    candidate = nonEmptySeqs[i][0];

                    if (notHead(nonEmptySeqs, candidate)) {
                        candidate = null;
                    } else {
                        break;
                    }
                }

                if (!candidate) {
                    TP.raise(this,
                            'TP.sig.InheritanceException',
                            'Inconsistent hierarchy: ' +
                                TP.json(nonEmptySeqs));
                    break;
                }

                results.push(candidate);

                for (i = 0; i < nonEmptySeqs.length; i++) {
                    if (nonEmptySeqs[i][0] === candidate) {
                        nonEmptySeqs[i].shift();
                    }
                }
            }
        };

        run = function(name) {
            var mergeResult;

            mergeResult = merge([[name]].concat(processMap[name].map(run)));
            mergeResult = mergeResult.concat(processMap[name]);

            return mergeResult;
        };

        runResult = run(this.name);

        return runResult;
    };

    //  Start with ourself
    resolver = c3(this.getName());

    //  Recursively populate the resolver
    this.$populateC3Resolver(resolver);

    //  Return the result of running the algorithm
    finalResult = resolver.compute();

    //  Because we allow duplicate parents, there will be further entries after
    //  'Object' in our list (all duplicated parents). We slice them off, ending
    //  our list with 'Object'.
    if (finalResult.contains('Object')) {
        finalResult = finalResult.slice(0, finalResult.indexOf('Object') + 1);
    }

    return finalResult;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getAllTraits',
function() {

    /**
     * @method getAllTraits
     * @summary Returns a list of all of the receiver's trait types, and any
     *     trait types they might have, etc. recursively.
     * @returns {TP.meta.lang.RootObject[]} A complete list of trait types that
     *     affect the receiver.
     */

    var traits,
        len,
        i,
        traitTraits;

    if (TP.notEmpty(traits = this[TP.TRAITS])) {
        len = traits.getSize();

        //  Recurse into the trait types and get *their* traits.
        for (i = 0; i < len; i++) {
            if (TP.notEmpty(traitTraits = traits.at(i).getAllTraits())) {
                traits = traits.concat(traitTraits);
            }
        }
    }

    return traits;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('hasTraits',
function() {

    /**
     * @method hasTraits
     * @summary Returns whether or not this type has traits.
     * @returns {Boolean} Whether or not the receiver has traits
     */

    return TP.notEmpty(this[TP.TRAITS]);
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('$populateC3Resolver',
function(c3Resolver) {

    /**
     * @method $populateC3Resolver
     * @summary Populates the supplied C3 resolver with type names, including
     *     the main supertype names up the supertype chain and trait types up
     *     the supertype chain.
     * @description TIBET uses a C3 resolution mechanism (as described here:
     *     http://en.wikipedia.org/wiki/C3_linearization), to 'auto resolve'
     *     traits where the developer hasn't provided an explicit resolution for
     *     a particular trait.
     * @param {Object} c3Resolver The object used to compute a C3 linearization
     *     of types.
     * @returns {TP.meta.lang.RootObject} The receiver.
     */

    var traits,
        i;

    //  Add an entry for ourself and our supertype.
    c3Resolver.add(this.getName(), this.getSupertypeName());

    //  If we have traits, add them.
    if (TP.notEmpty(traits = this[TP.TRAITS])) {

        //  Make sure to copy the Array - we reverse it below and don't want to
        //  alter that.
        traits = traits.copy();

        for (i = 0; i < traits.getSize(); i++) {
            c3Resolver.add(this.getName(), traits.at(i).getName());
        }

        //  Not strictly necessary, but makes for easier debugging since trait
        //  types will be added in 'more specific to less specific' order.
        traits = traits.reverse();

        for (i = 0; i < traits.getSize(); i++) {
            traits.at(i).$populateC3Resolver(c3Resolver);
        }
    }

    //  Process our supertype

    //  If we're at the top of the tree, 'Object' has already been accounted for
    //  by its subtypes - no need to proceed. It won't respond to this method
    //  anyway.
    if (this.getSupertype() !== Object) {
        this.getSupertype().$populateC3Resolver(c3Resolver);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('$populateTraitedSlot',
function(entry, installName, targetObject, track) {

    /**
     * @method $populateTraitedSlot
     * @summary Populates the slot on the receiver given the trait resolution.
     * @param {TP.core.Hash} entry The trait resolution entry.
     * @param {String} installName The name under which the property will
     *     actually be installed on the supplied target object.
     * @param {Object} targetObject The target object (either a prototype or
     *     instance prototype) that the resolved property will be put on.
     * @param {String} track The track that the property is for, instance or
     *     type.
     * @exception TP.sig.InvalidTrack This is raised when a track is supplied
     *     that isn't either TP.TYPE_TRACK or TP.INST_TRACK.
     * @returns
     */

    var resolution,

        flag,
        resolutionFunc,

        propName,

        mainType,

        dispatchFunc,
        realFunc,

        resolutionType,

        mainTypeVal,
        resolutionTypeVal;

    propName = entry.at('propName');

    /* eslint-disable consistent-this */
    mainType = this;
    /* eslint-enable consistent-this */

    if (entry.hasKey('definedValue')) {

        resolution = entry.at('definedValue');

        if (!TP.isCallable(resolution)) {
            //  The resolution is an Attribute - install it as the value
            targetObject.defineAttribute(installName, resolution);
            dispatchFunc = resolution;
        } else {
            //  The resolution is a Method - install it as the method
            dispatchFunc = targetObject.defineMethod(installName, resolution);

            //  Get the 'real function' (in case a callee patch was installed)
            realFunc = TP.getRealFunction(dispatchFunc);

            //  If a '$$nextfunc' wasn't wired onto the dispatching method, then
            //  go ahead and grab the 'resolving type' here and wire its
            //  implementation of the method on as the 'next most specific
            //  method'.
            if (!TP.isCallable(realFunc.$$nextfunc)) {

                resolutionType = entry.at('resolvesToType');

                if (TP.isType(resolutionType)) {

                    if (track === TP.INST_TRACK) {
                        resolutionTypeVal = resolutionType.Inst[propName];
                    } else {
                        resolutionTypeVal = resolutionType.Type[propName];
                    }

                    realFunc.$$nextfunc = resolutionTypeVal;
                }
            }
        }
    } else {

        //  Otherwise, the resolution should contain a resolution type that will
        //  be used in some form or fashion below.
        resolution = entry.at('resolvesToType');

        //  Make sure it's a Type object - if it's a String, see if we can
        //  resolve it into a Type.
        resolutionType = TP.isString(resolution) ?
                            TP.sys.getTypeByName(resolution) :
                            resolution;

        if (!TP.isType(resolution)) {
            return this.raise('TP.sig.InvalidType');
        }

        if (track === TP.INST_TRACK) {
            resolutionTypeVal = resolutionType.Inst[propName];
        } else {
            resolutionTypeVal = resolutionType.Type[propName];
        }

        //  If the resolution contains a resolver Function, execute it with the
        //  value from both the main type and the resolved type.
        if (entry.hasKey('resolverFunction')) {
            resolutionFunc = entry.at('resolverFunction');

            //  The value on the main type would've been replaced by the getter
            //  and stuffed into here.
            mainTypeVal = entry.at('initialValue');

            //  Call the resolver Function
            resolutionTypeVal = resolutionFunc(
                                    mainTypeVal, resolutionTypeVal);
        } else if (entry.hasKey('aroundFlag')) {

            //  The value on the main type would've been replaced by the getter
            //  and stuffed into here.
            mainTypeVal = entry.at('initialValue');

            //  It has a TP.BEFORE or TP.AFTER flag.
            flag = entry.at('aroundFlag');

            switch (flag) {
                case TP.BEFORE:

                    //  TP.BEFORE means run the resolved method first, then the
                    //  version on the main type.
                    dispatchFunc =
                        function() {
                            dispatchFunc.$resolutionMethod.apply(
                                    this, arguments);
                            return dispatchFunc.$mainMethod.apply(
                                    this, arguments);
                        };

                    dispatchFunc.$resolutionMethod = resolutionTypeVal;
                    dispatchFunc.$mainMethod = mainTypeVal;
                    dispatchFunc.$propName = propName;

                    break;
                case TP.AFTER:

                    //  TP.AFTER means run the main method first, then the
                    //  version on the resolved type.
                    dispatchFunc =
                        function() {
                            dispatchFunc.$mainMethod.apply(
                                    this, arguments);
                            return dispatchFunc.$resolutionMethod.apply(
                                    this, arguments);
                        };

                    dispatchFunc.$resolutionMethod = resolutionTypeVal;
                    dispatchFunc.$mainMethod = mainTypeVal;
                    dispatchFunc.$propName = propName;

                    break;
                default:
                    break;
            }
        } else if (TP.isType(resolutionType = resolution) &&
                    resolutionType !== mainType) {

            //  If the resolution is simply a Type, then we just look up the
            //  property on that type using the propName and install either an
            //  attribute or method, depending on what's on that slot.
            if (track === TP.INST_TRACK) {
                resolutionTypeVal = resolutionType.Inst[propName];
            } else {
                resolutionTypeVal = resolutionType.Type[propName];
            }
        }

        //  If the resolution type value is not a method, then it's an
        //  attribute.
        if (!TP.isMethod(resolutionTypeVal)) {

            if (track === TP.INST_TRACK) {
                mainType.Inst.defineAttribute(installName, resolutionTypeVal);
            } else {
                mainType.Type.defineAttribute(installName, resolutionTypeVal);
            }

            return resolutionTypeVal;
        }

        //  If we didn't assign a dispatch Function earlier, that means that we
        //  are doing a 'simple resolution'.
        if (TP.notValid(dispatchFunc)) {
            dispatchFunc =
                function() {
                    return dispatchFunc.$resolutionMethod.apply(
                            this, arguments);
                };
            dispatchFunc.$resolutionMethod = resolutionTypeVal;
        }

        //  NB: Note here how we supply null for the descriptor and for the
        //  display name (these will be automatically defaulted) but true for
        //  the 'could we be a handler method?' parameter. This allows
        //  ".defineMethod('handle...')" calls to occur without logging
        //  warnings.
        targetObject.defineMethod(installName, dispatchFunc, null, null, true);

        //  Note here how we manually wire the owner of the Function we just put
        //  on the targetObject to be the owner of the targetObject. This is due
        //  to the fact that we want 'callNextMethod()' to traverse the 'correct
        //  tree', as it were, and it looks at the Function's TP.OWNER for this
        //  information (as it should).
        dispatchFunc[TP.OWNER] = targetObject[TP.OWNER];

        //  We also add to the TP.DISPLAY name to indicate that this is a trait
        //  wired in from another type.
        dispatchFunc[TP.DISPLAY] = dispatchFunc[TP.DISPLAY] + '.trait.' +
                                    resolutionType.getID() + '.' + propName;
    }

    return dispatchFunc;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('resolveTrait',
function(propertyName, resolution, resolutionOption) {

    /**
     * @method resolveTrait
     * @summary Adds an entry to resolve the named trait according to the
     *     supplied resolution, which can either be a TIBET Type object or
     *     a JavaScript Function.
     * @description This resolves a trait in a number of ways:
     *
     *     1. If the resolution is a JavaScript Function, then the property
     *     on the receiver will be resolved by installing the Function as a
     *     method named with the property name on the receiver.
     *
     *     2. If the resolution is a TIBET type and a resolutionOption is not
     *     supplied, then the property on the receiver will be resolved to be
     *     the value of that property on the resolution.
     *
     *     3. If the resolution is a TIBET type and a resolutionOption is
     *     supplied and is a String, then the property on the receiver will be
     *     resolved to be the value of that property on the resolution but
     *     using the name supplied as the resolutionOption.
     *
     *     4. If the resolution is a TIBET type and a resolutionOption is
     *     supplied and is a Function, then the resolutionOption will be
     *     executed with the value of the property on the main type as the first
     *     argument and the value of the property on the resolution as the
     *     second argument. The property on the receiver will be resolved to be
     *     the returned value.
     *
     *     5. If the resolution is a TIBET type and a resolutionOption is
     *     supplied and is the value 'TP.BEFORE', then the property on the
     *     receiver will be resolved to be a method consisting of a call to the
     *     same named method on the resolution first, followed by a call to
     *     the receiver's version of that method.
     *
     *     6. If the resolution is a TIBET type and a resolutionOption is
     *     supplied and is the value 'TP.AFTER', then the property on the
     *     receiver will be resolved to be a method consisting of a call to the
     *     same named method on the receiver first, followed by a call to the
     *     resolution's version of that method.
     *
     * @param {String} propertyName The property name of the receiver to resolve
     *     using the supplied resolution.
     * @param {TP.lang.RootObject|Function} resolution The object to use to
     *     resolve the trait.
     * @param {String|Constant|Function} resolutionOption An optional property
     *     name or values of TP.BEFORE/TP.AFTER or Function.
     * @returns {TP.lang.RootObject} The receiving type.
     */

    var resolutions,
        populateResolutionType,
        entry,

        desc,
        prevValue,

        /* eslint-disable no-unused-vars */
        val;
        /* eslint-enable no-unused-vars */

    //  Because we're executing this in the context of the 'instance prototype',
    //  'this' will be bound to that object. If it's not (i.e. the user is
    //  trying to execute on a real instance of this type), throw an exception
    if (!TP.isPrototype(this)) {
        //  TODO Raise an exception
        return this;
    }

    //  Note here how we go after the TP.OWNER - that's because, in this
    //  context, 'this' is the instance prototype object, not the type and not
    //  an instance of the type (as per our check above).
    if (TP.notValid(
            resolutions = this[TP.OWNER].get('$traitsInstResolutions'))) {
        resolutions = TP.hc();
        this[TP.OWNER].set('$traitsInstResolutions', resolutions);
    }

    //  Define a Function that will add the supplied type to the 'sourceTypes'
    //  entry
    populateResolutionType = function(anEntry, aType) {

        var sourceTypes;

        sourceTypes = anEntry.at('sourceTypes');
        if (!TP.isArray(sourceTypes)) {
            sourceTypes = TP.ac(aType);
            entry.atPut('sourceTypes', sourceTypes);
        } else {
            //  We want each resolution type specified only once.
            if (!sourceTypes.contains(aType, TP.IDENTITY)) {
                sourceTypes.push(aType);
            }
        }

        entry.atPut('resolvesToType', aType);
    };

    //  Make sure to obtain any previous value that this slot had, but don't
    //  trip the resolution machinery doing so.
    TP.$$no_exec_trait_resolution = true;
    prevValue = this[propertyName];
    TP.$$no_exec_trait_resolution = false;

    //  If this property already had a resolutions entry, then we get any
    //  previous value that would've gotten computed.
    if (TP.isValid(resolutions.at(propertyName))) {

        //  If there's already an ECMA5 'getter' at that slot and it has a
        //  'finalVal', slot then clear it.
        desc = Object.getOwnPropertyDescriptor(this, propertyName);
        if (desc && desc.get && desc.get.finalVal) {
            desc.get.finalVal = undefined;
        }

        //  Re-install the trait trap. Note that if the trait hasn't really been
        //  resolved and therefore the trap still exists, this method will just
        //  return and the trap won't be installed again.
        this[TP.OWNER].$installTraitTrap(
                        this,
                        propertyName,
                        TP.INST_TRACK);
    }

    //  Generate a completely new entry for the property - this effectively
    //  clears any existing for the property.
    entry = TP.hc('propName', propertyName);
    resolutions.atPut(propertyName, entry);

    if (TP.isType(resolution) && TP.notValid(resolutionOption)) {

        //  Case #2: The resolution is a Type with no option
        populateResolutionType(entry, resolution);

    } else if (TP.isType(resolution) && TP.isCallable(resolutionOption)) {

        //  Case #4: The resolution is a Type with a Function option
        populateResolutionType(entry, resolution);

        //  The option is a Function, which means that it will be executed once
        //  and the result will be used as the value.
        entry.atPut('resolverFunction', resolutionOption);
        entry.atPut('initialValue', prevValue);

        //  Install a trap to execute our resolver Function
        this[TP.OWNER].$installTraitTrap(
                        this,
                        propertyName,
                        TP.INST_TRACK);

    } else if (TP.isType(resolution) && TP.isString(resolutionOption)) {

        if (resolutionOption !== TP.BEFORE && resolutionOption !== TP.AFTER) {

            //  Case #3: The resolution is a Type with a String option
            populateResolutionType(entry, resolution);

            //  The option is a String, which means that it's an aliased method
            //  (same method - different name).
            entry.atPut('aliasedTo', resolutionOption);

            //  Make an entry for the aliased option, but all we'll store there
            //  is a reference to the original property name.
            if (TP.notValid(entry = resolutions.at(resolutionOption))) {
                entry = TP.hc('propName', resolutionOption);
                resolutions.atPut(resolutionOption, entry);
            }

            //  And a reference back to the original property name we're an
            //  alias for.
            entry.atPut('aliasedFrom', propertyName);

            //  Install a trap *for the property that we're being aliased to*
            this[TP.OWNER].$installTraitTrap(
                            this,
                            resolutionOption,
                            TP.INST_TRACK);
        } else {
            //  Case #5 or 6: The resolution is a Type with a TP.BEFORE or
            //  TP.AFTER option
            populateResolutionType(entry, resolution);

            entry.atPut('initialValue', prevValue);

            entry.atPut('aroundFlag', resolutionOption);

            //  Install a trap to execute our resolver Function
            this[TP.OWNER].$installTraitTrap(
                            this,
                            propertyName,
                            TP.INST_TRACK);
        }
    } else if (TP.isValid(resolution)) {
        //  Case #1: The resolution is a valid value - install it as the value
        entry.atPut('definedValue', resolution);
    }

    //  Go ahead and access this value, causing the resolver to execute. This is
    //  done because we want subtypes to be able to reliably hook into a value
    //  that has been manually resolved (i.e. forced)
    //  Note that we do this assignment to avoid having JS engines possibly
    //  optimize an unassigned slot access away and not executing the resolver.
    /* eslint-disable no-unused-vars */
    val = this[propertyName];
    /* eslint-enable no-unused-vars */

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('resolveTraits',
function(propertyNames, resolution) {

    /**
     * @method resolveTraits
     * @summary Adds an entry to resolve the named trait according to the
     *     supplied resolution, which must be a TIBET Type object. This is a
     *     convenience wrapper for the singular 'resolveTrait' method with the
     *     ability to supply an Array of propertyNames, but limited to providing
     *     only a TIBET type as the resolution (which is the only option
     *     that makes sense for a list of property names).
     * @param {String[]} propertyNames An Array of property names of the
     *     receiver to resolve using the supplied resolution.
     * @param {TP.lang.RootObject} resolution The object to use to resolve
     *     the trait.
     * @returns {TP.lang.RootObject} The receiving type.
     */

    var thisref;

    //  Because we're executing this in the context of the 'instance prototype',
    //  'this' will be bound to that object. If it's not (i.e. the user is
    //  trying to execute on a real instance of this type), throw an exception
    if (!TP.isPrototype(this)) {
        //  TODO Raise an exception
        return this;
    }

    if (!TP.isArray(propertyNames)) {
        return this.raise('TP.sig.InvalidParameter',
                'Not a valid Array of property names for trait resolution.');
    }

    thisref = this;
    propertyNames.forEach(
            function(propName) {
                thisref.resolveTrait(propName, resolution);
            });

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('resolveTrait',
function(propertyName, resolution, resolutionOption) {

    /**
     * @method resolveTrait
     * @summary Adds an entry to resolve the named trait according to the
     *     supplied resolution, which can either be a TIBET Type object or
     *     a JavaScript Function.
     * @description This resolves a trait in a number of ways:
     *
     *     1. If the resolution is a JavaScript Function, then the property
     *     on the receiver will be resolved by installing the Function as a
     *     method named with the property name on the receiver.
     *
     *     2. If the resolution is a TIBET type and a resolutionOption is not
     *     supplied, then the property on the receiver will be resolved to be
     *     the value of that property on the resolution.
     *
     *     3. If the resolution is a TIBET type and a resolutionOption is
     *     supplied and is a String, then the property on the receiver will be
     *     resolved to be the value of that property on the resolution but
     *     using the name supplied as the resolutionOption.
     *
     *     4. If the resolution is a TIBET type and a resolutionOption is
     *     supplied and is a Function, then the resolutionOption will be
     *     executed with the value of the property on the main type as the first
     *     argument and the value of the property on the resolution as the
     *     second argument. The property on the receiver will be resolved to be
     *     the returned value.
     *
     *     5. If the resolution is a TIBET type and a resolutionOption is
     *     supplied and is the value 'TP.BEFORE', then the property on the
     *     receiver will be resolved to be a method consisting of a call to the
     *     same named method on the resolution first, followed by a call to
     *     the receiver's version of that method.
     *
     *     6. If the resolution is a TIBET type and a resolutionOption is
     *     supplied and is the value 'TP.AFTER', then the property on the
     *     receiver will be resolved to be a method consisting of a call to the
     *     same named method on the receiver first, followed by a call to the
     *     resolution's version of that method.
     *
     * @param {String} propertyName The property name of the receiver to resolve
     *     using the supplied resolution.
     * @param {TP.lang.RootObject|Function} resolution The object to use to
     *     resolve the trait.
     * @param {String|Constant|Function} resolutionOption An optional property
     *     name or values of TP.BEFORE/TP.AFTER or Function.
     * @returns {TP.lang.RootObject} The receiving type.
     */

    var resolutions,
        populateResolutionType,
        entry,

        desc,
        prevValue,

        /* eslint-disable no-unused-vars */
        val;
        /* eslint-enable no-unused-vars */

    //  Because we're executing this in the context of the 'type prototype',
    //  'this' will be bound to that object. If it's not (i.e. the user is
    //  trying to execute on a real instance of this type), throw an exception
    if (!TP.isPrototype(this)) {
        //  TODO Raise an exception
        return this;
    }

    //  Note here how we go after the TP.OWNER - that's because, in this
    //  context, 'this' is the type prototype object, not the type and not
    //  an instance of the type (as per our check above).
    if (TP.notValid(
            resolutions = this[TP.OWNER].get('$traitsTypeResolutions'))) {
        resolutions = TP.hc();
        this[TP.OWNER].set('$traitsTypeResolutions', resolutions);
    }

    //  Define a Function that will add the supplied type to the 'sourceTypes'
    //  entry
    populateResolutionType = function(anEntry, aType) {

        var sourceTypes;

        sourceTypes = anEntry.at('sourceTypes');
        if (!TP.isArray(sourceTypes)) {
            sourceTypes = TP.ac(aType);
            entry.atPut('sourceTypes', sourceTypes);
        } else {
            //  We want each resolution type specified only once.
            if (!sourceTypes.contains(aType, TP.IDENTITY)) {
                sourceTypes.push(aType);
            }
        }

        entry.atPut('resolvesToType', aType);
    };

    //  Make sure to obtain any previous value that this slot had, but don't
    //  trip the resolution machinery doing so.
    TP.$$no_exec_trait_resolution = true;
    prevValue = this[propertyName];
    TP.$$no_exec_trait_resolution = false;

    //  If this property already had a resolutions entry, then we get any
    //  previous value that would've gotten computed.
    if (TP.isValid(resolutions.at(propertyName))) {

        //  If there's already an ECMA5 'getter' at that slot and it has a
        //  'finalVal', slot then clear it.
        desc = Object.getOwnPropertyDescriptor(this, propertyName);
        if (desc && desc.get && desc.get.finalVal) {
            desc.get.finalVal = undefined;
        }

        //  Re-install the trait trap. Note that if the trait hasn't really been
        //  resolved and therefore the trap still exists, this method will just
        //  return and the trap won't be installed again.
        this[TP.OWNER].$installTraitTrap(
                        this,
                        propertyName,
                        TP.TYPE_TRACK);
    }

    //  Generate a completely new entry for the property - this effectively
    //  clears any existing for the property.
    entry = TP.hc('propName', propertyName);
    resolutions.atPut(propertyName, entry);

    if (TP.isType(resolution) && TP.notValid(resolutionOption)) {

        //  Case #2: The resolution is a Type with no option
        populateResolutionType(entry, resolution);

    } else if (TP.isType(resolution) && TP.isCallable(resolutionOption)) {

        //  Case #4: The resolution is a Type with a Function option
        populateResolutionType(entry, resolution);

        //  The option is a Function, which means that it will be executed once
        //  and the result will be used as the value.
        entry.atPut('resolverFunction', resolutionOption);
        entry.atPut('initialValue', prevValue);

        //  Install a trap to execute our resolver Function
        this[TP.OWNER].$installTraitTrap(
                        this,
                        propertyName,
                        TP.TYPE_TRACK);

    } else if (TP.isType(resolution) && TP.isString(resolutionOption)) {

        if (resolutionOption !== TP.BEFORE && resolutionOption !== TP.AFTER) {

            //  Case #3: The resolution is a Type with a String option
            populateResolutionType(entry, resolution);

            //  The option is a String, which means that it's an aliased method
            //  (same method - different name).
            entry.atPut('aliasedTo', resolutionOption);

            //  Make an entry for the aliased option, but all we'll store there
            //  is a reference to the original property name.
            if (TP.notValid(entry = resolutions.at(resolutionOption))) {
                entry = TP.hc('propName', resolutionOption);
                resolutions.atPut(resolutionOption, entry);
            }

            //  And a reference back to the original property name we're an
            //  alias for.
            entry.atPut('aliasedFrom', propertyName);

            //  Install a trap *for the property that we're being aliased to*
            this[TP.OWNER].$installTraitTrap(
                            this,
                            resolutionOption,
                            TP.TYPE_TRACK);
        } else {
            //  Case #5 or 6: The resolution is a Type with a TP.BEFORE or
            //  TP.AFTER option
            populateResolutionType(entry, resolution);

            entry.atPut('initialValue', prevValue);

            entry.atPut('aroundFlag', resolutionOption);

            //  Install a trap to execute our resolver Function
            this[TP.OWNER].$installTraitTrap(
                            this,
                            propertyName,
                            TP.TYPE_TRACK);
        }
    } else if (TP.isValid(resolution)) {
        //  Case #1: The resolution is a valid value - install it as the value
        entry.atPut('definedValue', resolution);
    }

    //  Go ahead and access this value, causing the resolver to execute. This is
    //  done because we want subtypes to be able to reliably hook into a value
    //  that has been manually resolved (i.e. forced)
    //  Note that we do this assignment to avoid having JS engines possibly
    //  optimize an unassigned slot access away and not executing the resolver.
    /* eslint-disable no-unused-vars */
    val = this[propertyName];
    /* eslint-enable no-unused-vars */

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('resolveTraits',
function(propertyNames, resolution) {

    /**
     * @method resolveTraits
     * @summary Adds an entry to resolve the named trait according to the
     *     supplied resolution, which must be a TIBET Type object. This is a
     *     convenience wrapper for the singular 'resolveTrait' method with the
     *     ability to supply an Array of propertyNames, but limited to providing
     *     only a TIBET type as the resolution (which is the only option
     *     that makes sense for a list of property names).
     * @param {String[]} propertyNames An Array of property names of the
     *     receiver to resolve using the supplied resolution.
     * @param {TP.lang.RootObject} resolution The object to use to resolve
     *     the trait.
     * @returns {TP.lang.RootObject} The receiving type.
     */

    var thisref;

    //  Because we're executing this in the context of the 'instance prototype',
    //  'this' will be bound to that object. If it's not (i.e. the user is
    //  trying to execute on a real instance of this type), throw an exception
    if (!TP.isPrototype(this)) {
        //  TODO Raise an exception
        return this;
    }

    if (!TP.isArray(propertyNames)) {
        return this.raise('TP.sig.InvalidParameter',
                'Not a valid Array of property names for trait resolution.');
    }

    thisref = this;
    propertyNames.forEach(
            function(propName) {
                thisref.resolveTrait(propName, resolution);
            });

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('$resolveTraitedProperty',
function(propName, track) {

    /**
     * @method $resolveTraitedProperty
     * @summary Resolves the property with the supplied name and track using the
     *     trait compositions computed for it.
     * @param {String} propName The name of the property to resolve.
     * @param {String} track The track to locate the property on.
     * @exception TP.sig.InvalidTrack This is raised when a track is supplied
     *     that isn't either TP.TYPE_TRACK or TP.INST_TRACK.
     * @returns {TP.lang.RootObject|undefined} The receiving type.
     */

    var resolutions,
        mainTypeTarget,

        entry,

        actualPropName,

        len,
        i,
        source,
        val,

        resolution,
        unresolution,

        resolutionTypeTarget;

    //  Grab the proper set of potential resolutions of the trait and the target
    //  we will be using.
    if (track === TP.TYPE_TRACK) {
        resolutions = this.$get('$traitsTypeResolutions');
        mainTypeTarget = this.Type;
    } else if (track === TP.INST_TRACK) {
        resolutions = this.get('$traitsInstResolutions');
        mainTypeTarget = this.Inst;
    } else {
        return this.raise('TP.sig.InvalidTrackRequest', track);
    }

    //  Get the resolution entry for this property
    entry = resolutions.at(propName);

    //  If this property has been aliased from another property, then we want
    //  the entry for that property.
    if (TP.isValid(entry) && entry.hasKey('aliasedFrom')) {
        actualPropName = entry.at('aliasedFrom');
        entry = resolutions.at(actualPropName);
    } else {
        actualPropName = propName;
    }

    //  If the trait wasn't manually resolved via 'resolveTrait()', then we can
    //  still resolve it here if all but one of the values of 'actualPropName'
    //  on each of the sources is TP.REQUIRED. If more than one is "real", then
    //  we have a conflict.
    if (TP.notValid(entry.at('resolvesToType'))) {

        //  Loop over all of the 'possible resolution sourceTypes'.
        len = entry.at('sourceTypes').getSize();
        for (i = 0; i < len; i++) {

            source = entry.at('sourceTypes').at(i);

            val = track === TP.INST_TRACK ?
                    source.getInstPrototype()[actualPropName] :
                    source.getPrototype()[actualPropName];

            if (val !== TP.REQUIRED) {
                //  If we already had one that wasn't a TP.REQUIRED, then we
                //  have a conflict. Create an 'unresolution' and clear the
                //  'resolvesToType' property in the resolution entry.
                if (TP.isValid(entry.at('resolvesToType'))) {

                    if (TP.notValid(unresolution)) {

                        unresolution = TP.ac();

                        //  Push the 'resolvesToType' source that we already
                        //  found
                        unresolution.push(entry.at('resolvesToType'));
                    }

                    //  Remove the 'resolvesToType' key - we no longer can
                    //  resolve this - we're conflicted.
                    entry.removeKey('resolvesToType');

                    //  Push the new source value
                    unresolution.push(source);
                } else {

                    //  The first time through - put the source value into the
                    //  resolution entry's 'resolvesToType' property.
                    entry.atPut('resolvesToType', source);
                }
            }
        }
    }

    //  If there is no entry in 'resolvesToType', that means we had a conflict -
    //  let's try to 'auto resolve' it.
    if (TP.notValid(resolution = entry.at('resolvesToType'))) {

        //  Normalize non-Array 'unresolution' values to TP.REQUIRED - this
        //  allows for an easy check in the auto resolve machinery.
        if (!TP.isArray(unresolution)) {
            unresolution = TP.REQUIRED;
        }

        //  Execute the auto-resolution machinery.
        resolution = this.$autoResolveConflictedTrait(
                                actualPropName, unresolution, track);

        if (TP.isValid(resolution)) {
            entry.atPut('resolvesToType', resolution);
        }
    }

    //  No valid resolution and we're not resolving with a defined value?
    //  Exit here with undefined.
    if (TP.notValid(resolution) && !entry.hasKey('definedValue')) {
        return;
    }

    //  The resolution could be a type or a Function

    //  If it's a type, then we do extra checks
    if (TP.isType(resolution) && !entry.hasKey('resolverFunction')) {

        if (track === TP.TYPE_TRACK) {
            resolutionTypeTarget = resolution.Type;
        } else if (track === TP.INST_TRACK) {
            resolutionTypeTarget = resolution.Inst;
        }

        //  Note here how we do *not* install a slot if it already represented
        //  on the receiving object (this.Type / this.Inst) unless the value for
        //  that slot is TP.REQUIRED.
        if (mainTypeTarget[actualPropName] !== TP.REQUIRED &&
            resolutionTypeTarget[actualPropName] ===
                            mainTypeTarget[actualPropName]) {
            return mainTypeTarget[actualPropName];
        }
    }

    //  Populate the slot with the entry. Note here how we do this with the
    //  *original* property name supplied to this method. This will be the
    //  slot's 'install name'.
    return this.$populateTraitedSlot(
                    entry, propName, mainTypeTarget, track);
});

//  ------------------------------------------------------------------------
//  PROPERTY MANAGEMENT
//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('removeInstProperties',
function(aList) {

    /**
     * @method removeInstProperties
     * @summary Iterate over aList and remove properties found on receiver
     *     whose keys are in the list.
     * @param {String[]} aList The list of method names to remove.
     * @exception TP.sig.InvalidType
     * @returns {Object} The receiver.
     */

    return this.raise('TP.sig.InvalidType', this);
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('removeLocalProperties',
function(aList) {

    /**
     * @method removeLocalProperties
     * @summary Iterate over aList and remove properties found on receiver
     *     whose keys are in the list. Note that the removal will only occur if
     *     the receiver owns the properties in question.
     * @param {String[]} aList The list of method names to remove.
     * @returns {Object} The receiver.
     */

    var i,
        len,
        it;

    len = aList.getSize();

    for (i = 0; i < len; i++) {
        it = aList.at(i);

        if (TP.owns(this, it)) {
            delete this[it];
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('removeTypeProperties',
function(aList) {

    /**
     * @method removeTypeProperties
     * @summary Iterate over aList and remove properties found on receiver
     *     whose keys are in the list.
     * @param {String[]} aList The list of method names to remove.
     * @exception TP.sig.InvalidType
     * @returns {Object} The receiver.
     */

    return this.raise('TP.sig.InvalidType', this);
});

//  ------------------------------------------------------------------------

TP.defineMetaTypeMethod('removeInstProperties',
function(aList) {

    /**
     * @method removeInstProperties
     * @summary Iterate over aList and remove properties found on receiver
     *     whose keys are in the list.
     * @param {String[]} aList The list of method names to remove.
     * @returns {Object} The receiver.
     */

    var i,
        len,
        proto,
        it;

    len = aList.getSize();
    proto = this.getInstPrototype();

    for (i = 0; i < len; i++) {
        it = aList.at(i);

        if (TP.owns(proto, it)) {
            delete proto[it];
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('removeInstProperties',
function(aList) {

    /**
     * @method removeInstProperties
     * @summary Iterate over aList and remove properties found on receiver
     *     whose keys are in the list.
     * @param {String[]} aList The list of method names to remove.
     * @returns {Object} The receiver.
     */

    var i,
        len,
        proto,
        it;

    len = aList.getSize();
    proto = this.getInstPrototype();

    for (i = 0; i < len; i++) {
        it = aList.at(i);

        if (TP.owns(proto, it)) {
            delete proto[it];
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.defineMetaTypeMethod('removeTypeProperties',
function(aList) {

    /**
     * @method removeTypeProperties
     * @summary Iterate over aList and remove properties found on receiver
     *     whose keys are in the list.
     * @param {String[]} aList The list of method names to remove.
     * @returns {Object} The receiver.
     */

    var i,
        len,
        it;

    len = aList.getSize();
    for (i = 0; i < len; i++) {
        it = aList.at(i);

        if (TP.owns(this, it)) {
            delete this[it];
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('removeTypeProperties',
function(aList) {

    /**
     * @method removeTypeProperties
     * @summary Iterate over aList and remove properties found on receiver
     *     whose keys are in the list.
     * @param {String[]} aList The list of method names to remove.
     * @returns {Object} The receiver.
     */

    var i,
        len,
        it;

    len = aList.getSize();
    for (i = 0; i < len; i++) {
        it = aList.at(i);

        if (TP.owns(this, it)) {
            delete this[it];
        }
    }

    return this;
});

//  ------------------------------------------------------------------------
//  TYPE CHECKING
//  ------------------------------------------------------------------------

/*
Essentially type-checking...validate() provides a common method for types
to check the internal consistency and type membership of objects. This
method works in tandem with 'isa' to provide an opportunity for methods of
the form:

    x.isa('Foo');

to hand off to:

    Foo.validate(x);

This pattern is evident in as/from for type conversion as well.
*/

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getValidationErrorEntries',
function() {

    /**
     * @method getValidationErrorEntries
     * @summary Returns an Array of the last validation error entries that were
     *     provided by the validation machinery when it ran.
     * @description Because the 'validate' method machinery only returns true or
     *     false depending on whether the object validates by the type supplied.
     *     But some validation machinery can also produce error messages that
     *     are useful for displaying to the user or for logging. This
     *     'out-of-band' data needs to be stored somewhere and it will be stored
     *     here.
     * @returns {TP.core.Hash[]} An array of the most recent type validation
     *     entries. At a minimum these will have a 'timestamp' field (a Date)
     *     and a message (a String).
     */

    return TP.sys.$$validationErrorEntries;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('addValidationErrorEntry',
function(anEntry) {

    /**
     * @method addValidationErrorEntry
     * @summary Adds a validation entry to the overall Array of validation error
     *     entries, timestamping it by putting the current Date.now() value in a
     *     'timestamp' slot before adding it to the array.
     * @param {TP.core.Hash} anEntry The validation error entry.
     */

    var validationErrorEntries;

    anEntry.atPut('timestamp', Date.now());

    validationErrorEntries = TP.sys.$$validationErrorEntries;
    if (TP.notValid(validationErrorEntries)) {
        validationErrorEntries = TP.ac();
        TP.sys.$$validationErrorEntries = validationErrorEntries;
    }

    validationErrorEntries.push(anEntry);

    return;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('isa',
function(aType) {

    /**
     * @method isa
     * @summary Core type-checking method. This method follows the standard
     *     TIBET "best method" pattern of searching the receiver for the best
     *     matching routine to invoke and then calling it. The receiver is
     *     tested first, then the type, and in this case, any is* primitives
     *     which might apply.
     * @param {TP.lang.RootObject|String} aType The type or type name to verify
     *     against.
     * @returns {Boolean}
     */

    //  is it a valid type
    if (TP.notValid(aType)) {
        this.raise('TP.sig.InvalidType');

        return false;
    }

    //  if the receiver is a clear subtype then we'll say yes, but note that
    //  we don't fail if this isn't true, we move on to allow spoofing etc.
    if (TP.isKindOf(this, aType)) {
        return true;
    }

    //  context, specializer, prefix, suffix, fallback, arglist
    return this.callBestMethod(arguments, this, 'isa');
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('isaObject',
function(aType) {

    /**
     * @method isaObject
     * @summary Returns true if the receiver is an instance of the type
     *     provided. Before answering this question a search via isa() is
     *     typically performed, followed by a check to see if the type can use
     *     validate() to test the object.
     * @param {Type|String} aType The type to verify against.
     * @param {TP.lang.RootObject|String} aType The type or type name to verify
     *     against.
     * @returns {Boolean} True if the receiver can be verified as a valid
     *     instance of the type.
     */

    var type;

    //  since we're in isaObject the answer's yes, but we may simply be the
    //  backstop from an isa() call so we do the validate() check here
    if (TP.isType(type = TP.sys.getTypeByName(aType))) {
        if (TP.canInvoke(type, 'validate')) {
            return type.validate(this);
        }
    }

    return true;
});

//  ------------------------------------------------------------------------

TP.defineMetaTypeMethod('validate',
function(anObject) {

    /**
     * @method validate
     * @summary Tests the incoming value to see if it represents a valid
     *     instance of the type and failing that checks for each supertype as an
     *     option.
     * @param {Object} anObject The object to test.
     * @returns {Boolean} True if the object can be validated.
     */

    //  function instances can be used to validate via invocation
    if (!TP.isType(this)) {
        return this(anObject);
    }

    //  context, specializer, prefix, suffix, fallback, arglist
    return this.callBestMethod(arguments, this, 'validate');
});

//  ------------------------------------------------------------------------

TP.defineMetaTypeMethod('validateObject',
function(anObject) {

    /**
     * @method validateObject
     * @summary Tests the incoming value to see if it represents a valid
     *     instance of the receiver's type.
     * @param {Object} anObject The object to test.
     * @returns {Boolean}
     */

    if (!TP.isType(this)) {
        return this(anObject);
    }

    if (TP.notValid(anObject)) {
        return false;
    }

    return TP.isKindOf(anObject, this.getName());
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('validate',
function(anObject) {

    /**
     * @method validate
     * @summary Tests the incoming value to see if it represents a valid
     *     instance of the receiving type.
     * @description In performing this test the receiver will begin with
     *     validating any aspects on the supplied that match any validity facets
     *     on the receiver. If none can be found, then it will use the
     *     callBestMethod() approach to find a validation suitable for any
     *     supertype of the inbound data if there is no specific function for
     *     the object's direct type.
     * @param {Object} anObject The object to test.
     * @returns {Boolean} True if the object can be validated.
     */

    var validityInfo,
        setAtLeastOne,
        keys,
        isValid;

    //  First, attempt to validate any aspects on the supplied object. This will
    //  return a Hash of validity information.
    validityInfo = this.validateAspects(anObject);
    setAtLeastOne = false;
    isValid = true;

    //  Loop over the validity information hash. There has to be at least one
    //  that returned a non 'TP.NO_RESULT' value in order for us to not just use
    //  the callBestMethod() approach at the bottom.
    keys = validityInfo.getKeys();
    keys.forEach(
        function(key) {

            var truthVal;

            truthVal = validityInfo.at(key);

            //  If there was at least one validity test that returned either
            //  true or false (but not TP.NO_RESULT), then we use that value to
            //  set the facet on the object and to avoid the callBestMethod()
            //  approach below.
            if (truthVal !== TP.NO_RESULT) {

                anObject.setFacet(key, TP.VALID, truthVal);
                setAtLeastOne = true;

                //  If isValid is true, we go ahead and set it to the truth
                //  value. If it's already false, we do *not* want to possibly
                //  set it to true, since this operation can be considered a
                //  'union' of all truth values.
                if (isValid) {
                    isValid = truthVal;
                }
            }
        });

    //  We didn't find at least one validity test - use callBestMethod()
    //  approach.
    if (!setAtLeastOne) {
        //  context, specializer, prefix, suffix, fallback, arglist
        isValid = this.callBestMethod(arguments, this, 'validate');
    }

    return isValid;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('validateAspects',
function(anObject, aspectNames) {

    /**
     * @method validateAspects
     * @summary Validates the aspects of the supplied object against any
     *     validity facets that are defined by the receiver.
     * @param {Object} anObject The object to test.
     * @param {String[]} aspectNames An array of aspect names to test. If not
     *     supplied, then all of the aspects of the supplied object are tested.
     * @returns {Boolean} The result of executing all of the validity facets for
     *     the aspect names.
     */

    var constraintsResult,

        aspectsToCheck,

        results,

        len,
        i,

        aspectName,
        constraints;

    //  No aspect names supplied - use all of the aspects of the supplied
    //  object.
    if (TP.isEmpty(aspectNames)) {
        aspectsToCheck = anObject.getValidatingAspectNames();
    } else {
        aspectsToCheck = aspectNames;
    }

    //  The result of this method is hash containing the aspect name and the
    //  result of running that aspect's validity facet.
    results = TP.hc();

    len = aspectsToCheck.getSize();
    for (i = 0; i < len; i++) {

        aspectName = aspectsToCheck.at(i);

        //  Get the facet setting (not the value - we'll compute that) for the
        //  validity facet of the aspect. If there is no validity constraint for
        //  this aspect, then put a value of TP.NO_RESULT into that result entry
        //  and move on.
        if (TP.notValid(constraints = this.getInstFacetSettingFor(
                                        aspectName,
                                        TP.VALID))) {

            results.atPut(aspectName, TP.NO_RESULT);

            continue;
        }

        //  Otherwise, there was a set of validity constraints (a literal Object
        //  containing 1...n of them). Execute those constraints and put the
        //  result into the result entry for that aspect.

        constraintsResult = this.validateConstraintsOn(
                                anObject.get(aspectName), constraints);

        results.atPut(aspectName, constraintsResult);
    }

    return results;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('validateConstraintsOn',
function(anObject, constraints) {

    /**
     * @method validateConstraintsOn
     * @summary Validates a supplied object against a set of validity
     *     constraints supplied in a second, literal POJO object.
     * @param {Object} anObject The object to test.
     * @param {Object} constraints The POJO object containing 1...n validity
     *     constraints. These include:
               dataType (JS/TIBET type object, String resolved to JS/TIBET type
                            object)
               enumeration (Array, comma-separated String, AccessPath)
               equal (Object that can be compared, AccessPath)
               fractionDigits (Number or object that can be 'asNumber'ed,
                                AccessPath)
               length (Number or object that can be 'asNumber'ed,
                                AccessPath)
               maxExclusive (Number or object that can be 'asNumber'ed,
                                AccessPath)
               maxInclusive (Number or object that can be 'asNumber'ed,
                                AccessPath)
               maxLength (Number or object that can be 'asNumber'ed,
                                AccessPath)
               maxValue (Number or object that can be 'asNumber'ed,
                                AccessPath)
               minExclusive (Number or object that can be 'asNumber'ed,
                                AccessPath)
               minInclusive (Number or object that can be 'asNumber'ed,
                                AccessPath)
               minLength (Number or object that can be 'asNumber'ed,
                                AccessPath)
               minValue (Number or object that can be 'asNumber'ed, AccessPath)
               notEqual (Object that can be compared, AccessPath)
               pattern (RegExp, AccessPath)
               totalDigits (Number or object that can be 'asNumber'ed,
                                AccessPath)
     * @returns {Boolean} Whether or not the object passed the supplied validity
     *     constraints.
     */

    var result,

        constraintNames,

        errors,

        len,
        i,

        constraintName,
        constraint,
        constraintType,

        num,
        str;

    //  Get all of the keys from the literal POJO object. This will be the names
    //  of all of our constraints.
    constraintNames = TP.keys(constraints);

    errors = TP.ac();

    len = constraintNames.getSize();
    for (i = 0; i < len; i++) {

        //  Grab the constraint.
        constraintName = constraintNames.at(i);
        constraint = constraints[constraintName];

        if (constraint.isAccessPath()) {
            constraint = constraint.executeGet(
                            anObject.getPathSource(constraint));
        }

        //  Set the initial result to false.
        result = false;

        switch (constraintName) {

            case 'dataType':

                //  If the constraint is 'dataType', then try to obtain a JS or
                //  TIBET type object
                if (!TP.isType(constraint)) {
                    if (TP.isString(constraint)) {
                        constraintType = TP.sys.getTypeByName(constraint);
                    }
                } else {
                    constraintType = constraint;
                }

                //  If we successfully got a type, then validate the supplied
                //  object with it.
                if (!TP.isType(constraintType)) {
                    this.raise('TP.sig.InvalidConstraint',
                                'Unable to find type: ' + constraint);
                } else {
                    result = constraintType.validate(anObject);
                }

                if (!result) {
                    errors.push(
                        TP.sc('Object: "', anObject, '"',
                                ' is not of type: ', TP.name(constraintType)));
                }

                break;

            case 'enumeration':

                if (!TP.isArray(constraint)) {
                    this.raise('TP.sig.InvalidConstraint',
                                'Invalid enumeration: ' + constraint);
                } else {
                    result = constraint.contains(anObject);
                }

                if (!result) {
                    errors.push(
                        TP.sc('Object: "', anObject, '"',
                                ' does not have one of the following values: ',
                                TP.join(constraint)));
                }

                break;

            case 'equal':

                if (!TP.isValid(constraint)) {
                    this.raise('TP.sig.InvalidConstraint',
                                'Invalid object: ' + constraint);
                } else {
                    /* eslint-disable no-extra-parens */
                    result = (TP.val(anObject) === constraint);
                    /* eslint-enable no-extra-parens */
                }

                if (!result) {
                    errors.push(
                        TP.sc('Object: "', anObject, '"',
                                ' is not equal to: ',
                                TP.str(constraint)));
                }

                break;

            case 'fractionDigits':

                if (!TP.isNumber(constraint = constraint.asNumber())) {
                    this.raise('TP.sig.InvalidConstraint',
                                'Invalid number: ' + constraint);
                } else {

                    //  this is supposed to work on the "value space" meaning
                    //  that trailing zeros aren't significant so we want to
                    //  work from a number first...
                    if (!TP.isNaN(num = parseFloat(anObject))) {
                        str = num.fraction().asString().split('.').last();
                        /* eslint-disable no-extra-parens */
                        result = (str.getSize() <= constraint);
                        /* eslint-enable no-extra-parens */
                    }
                }

                if (!result) {
                    errors.push(
                        TP.sc('Object: "', anObject, '"',
                                ' does not have a fractional number of digits',
                                ' equal to: ', constraint));
                }

                break;

            case 'length':

                if (!TP.isNumber(constraint = constraint.asNumber())) {
                    this.raise('TP.sig.InvalidConstraint',
                                'Invalid number: ' + constraint);
                } else {
                    /* eslint-disable no-extra-parens */
                    result = (TP.size(anObject) === constraint);
                    /* eslint-enable no-extra-parens */
                }

                if (!result) {
                    errors.push(
                        TP.sc('Object: "', anObject, '"',
                                ' does not have a size matching: ',
                                constraint));
                }

                break;

            case 'maxExclusive':

                if (!TP.isNumber(constraint = constraint.asNumber())) {
                    this.raise('TP.sig.InvalidConstraint',
                                'Invalid number: ' + constraint);
                } else {
                    num = TP.nc(anObject);
                    /* eslint-disable no-extra-parens */
                    result = (num < constraint);
                    /* eslint-enable no-extra-parens */
                }

                if (!result) {
                    errors.push(
                        TP.sc('Object: "', anObject, '"',
                                ' has a value (exclusive) greater than: ',
                                constraint));
                }

                break;

            case 'maxInclusive':

                if (!TP.isNumber(constraint = constraint.asNumber())) {
                    this.raise('TP.sig.InvalidConstraint',
                                'Invalid number: ' + constraint);
                } else {
                    num = TP.nc(anObject);
                    /* eslint-disable no-extra-parens */
                    result = (num <= constraint);
                    /* eslint-enable no-extra-parens */
                }

                if (!result) {
                    errors.push(
                        TP.sc('Object: "', anObject, '"',
                                ' has a value (inclusive) greater than: ',
                                constraint));
                }

                break;

            case 'maxLength':

                if (!TP.isNumber(constraint = constraint.asNumber())) {
                    this.raise('TP.sig.InvalidConstraint',
                                'Invalid number: ' + constraint);
                } else {
                    /* eslint-disable no-extra-parens */
                    result = (TP.size(TP.str(anObject)) <= constraint);
                    /* eslint-enable no-extra-parens */
                }

                if (!result) {
                    errors.push(
                        TP.sc('Object: "', anObject, '"',
                                ' has a length greater than: ',
                                constraint));
                }

                break;

            case 'maxValue':

                if (!TP.isNumber(constraint = constraint.asNumber())) {
                    this.raise('TP.sig.InvalidConstraint',
                                'Invalid number: ' + constraint);
                } else {
                    /* eslint-disable no-extra-parens */
                    result = (TP.nc(anObject) <= constraint);
                    /* eslint-enable no-extra-parens */
                }

                if (!result) {
                    errors.push(
                        TP.sc('Object: "', anObject, '"',
                                ' has a value greater than: ',
                                constraint));
                }

                break;

            case 'minExclusive':

                if (!TP.isNumber(constraint = constraint.asNumber())) {
                    this.raise('TP.sig.InvalidConstraint',
                                'Invalid number: ' + constraint);
                } else {
                    num = TP.nc(anObject);
                    /* eslint-disable no-extra-parens */
                    result = (num > constraint);
                    /* eslint-enable no-extra-parens */
                }

                if (!result) {
                    errors.push(
                        TP.sc('Object: "', anObject, '"',
                                ' has a value (exclusive) less than: ',
                                constraint));
                }

                break;

            case 'minInclusive':

                if (!TP.isNumber(constraint = constraint.asNumber())) {
                    this.raise('TP.sig.InvalidConstraint',
                                'Invalid number: ' + constraint);
                } else {
                    num = TP.nc(anObject);
                    /* eslint-disable no-extra-parens */
                    result = (num >= constraint);
                    /* eslint-enable no-extra-parens */
                }

                if (!result) {
                    errors.push(
                        TP.sc('Object: "', anObject, '"',
                                ' has a value (inclusive) less than: ',
                                constraint));
                }

                break;

            case 'minLength':

                if (!TP.isNumber(constraint = constraint.asNumber())) {
                    this.raise('TP.sig.InvalidConstraint',
                                'Invalid number: ' + constraint);
                } else {
                    /* eslint-disable no-extra-parens */
                    result = (TP.size(TP.str(anObject)) >= constraint);
                    /* eslint-enable no-extra-parens */
                }

                if (!result) {
                    errors.push(
                        TP.sc('Object: "', anObject, '"',
                                ' has a length less than: ',
                                constraint));
                }

                break;

            case 'minValue':

                if (!TP.isNumber(constraint = constraint.asNumber())) {
                    this.raise('TP.sig.InvalidConstraint',
                                'Invalid number: ' + constraint);
                } else {
                    /* eslint-disable no-extra-parens */
                    result = (TP.nc(anObject) >= constraint);
                    /* eslint-enable no-extra-parens */
                }

                if (!result) {
                    errors.push(
                        TP.sc('Object: "', anObject, '"',
                                ' has a value less than: ',
                                constraint));
                }

                break;

            case 'notEqual':

                if (!TP.isValid(constraint)) {
                    this.raise('TP.sig.InvalidConstraint',
                                'Invalid object: ' + constraint);
                } else {
                    /* eslint-disable no-extra-parens */
                    result = (TP.val(anObject) !== constraint);
                    /* eslint-enable no-extra-parens */
                }

                if (!result) {
                    errors.push(
                        TP.sc('Object: "', anObject, '"',
                                ' is equal to: ',
                                TP.str(constraint)));
                }

                break;

            case 'pattern':

                if (!TP.isRegExp(constraint)) {
                    this.raise('TP.sig.InvalidConstraint',
                                'Invalid RegExp: ' + constraint);
                } else {
                    result = constraint.test(TP.str(anObject));
                }

                if (!result) {
                    errors.push(
                        TP.sc('Object: "', anObject, '"',
                                ' should match pattern: ',
                                TP.str(constraint)));
                }

                break;

            case 'totalDigits':

                if (!TP.isNumber(constraint)) {
                    this.raise('TP.sig.InvalidConstraint',
                                'Invalid number: ' + constraint);
                } else {

                    //  this is supposed to work on the "value space" meaning
                    //  that trailing zeros aren't significant so we want to
                    //  work from a number first...
                    if (!TP.isNaN(num = parseFloat(anObject))) {
                        str = num.asString();
                        /* eslint-disable no-extra-parens */
                        result = (str.getSize() <= constraint);
                        /* eslint-enable no-extra-parens */
                    }
                }

                if (!result) {
                    errors.push(
                        TP.sc('Object: "', anObject, '"',
                                ' does not have a total number of digits',
                                ' equal to: ', constraint));
                }

                break;

            default:

                //  Right now, we don't check any other constraints.
                return true;
        }
    }

    if (TP.notEmpty(errors)) {
        errors.forEach(
            function(aMessage) {
                TP.sys.addValidationErrorEntry(
                    TP.hc('message', aMessage));
            });
    }

    //  If there were errors, report them and return false
    if (TP.notEmpty(errors)) {
        return false;
    }

    return result;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('validateObject',
function(anObject) {

    /**
     * @method validateObject
     * @summary Tests the incoming value to see if it represents a valid
     *     instance of the receiver's type.
     * @param {Object} anObject The object to test.
     * @returns {Boolean}
     */

    if (TP.notValid(anObject)) {
        return false;
    }

    return TP.isKindOf(anObject, this.getName());
});

//  ------------------------------------------------------------------------
//  MARKER METHODS
//  ------------------------------------------------------------------------

/*
A set of methods that can be used to help mark locations in the code that might
need attention, or which are using inappropriate or deprecated code.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('$$marker',
function(aNote, aPrefix, anException) {

    var prefix,
        note;

    prefix = TP.isString(aPrefix) ? aPrefix + ': ' : '';
    note = aNote || '';

    TP.ifWarn() ? TP.warn(prefix + note) : 0;

    if (TP.notEmpty(anException)) {
        TP.raise(this, anException);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('deprecated',
function(aNote) {

    /**
     * @method deprecated
     * @summary Reports a warning that a deprecated method/type is in use.
     * @param {String} aNote An optional note to output.
     */

    return TP.$$marker(aNote, 'Deprecated');
});

//  ------------------------------------------------------------------------

TP.definePrimitive('override',
function(aNote) {

    /**
     * @method override
     * @summary Standard "abstract" method stub indicating the method needs to
     *     be overridden in concrete subtypes.
     * @param {String} aNote A description of what to do :).
     */

    return TP.$$marker(aNote, 'MissingOverride', 'MissingOverride');
});

//  ------------------------------------------------------------------------

TP.definePrimitive('todo',
function(aNote) {

    /**
     * @method todo
     * @summary Standard "under construction" method stub.
     * @param {String} aNote A description of what to do :).
     */

    return TP.$$marker(aNote, 'TODO');
});

//  ========================================================================
//  NATIVE TYPES - PART II
//  ========================================================================

/*
Support for TIBET API on native types from Array to String.
*/

//  ------------------------------------------------------------------------
//  NATIVE - BOOTSTRAP
//  ------------------------------------------------------------------------

//  Set names and owners on the builtin constructors themselves. this
//  allows these objects to operate as valid function owners/types etc.

Array[TP.NAME] = 'Array';
Array[TP.OWNER] = Array;
Array[TP.TRACK] = TP.GLOBAL_TRACK;

Boolean[TP.NAME] = 'Boolean';
Boolean[TP.OWNER] = Boolean;
Boolean[TP.TRACK] = TP.GLOBAL_TRACK;

Date[TP.NAME] = 'Date';
Date[TP.OWNER] = Date;
Date[TP.TRACK] = TP.GLOBAL_TRACK;

Function[TP.NAME] = 'Function';
Function[TP.OWNER] = Function;
Function[TP.TRACK] = TP.GLOBAL_TRACK;

Number[TP.NAME] = 'Number';
Number[TP.OWNER] = Number;
Number[TP.TRACK] = TP.GLOBAL_TRACK;

Object[TP.NAME] = 'Object';
Object[TP.OWNER] = Object;
Object[TP.TRACK] = TP.GLOBAL_TRACK;

RegExp[TP.NAME] = 'RegExp';
RegExp[TP.OWNER] = RegExp;
RegExp[TP.TRACK] = TP.GLOBAL_TRACK;

String[TP.NAME] = 'String';
String[TP.OWNER] = String;
String[TP.TRACK] = TP.GLOBAL_TRACK;

//  ------------------------------------------------------------------------
//  NATIVE - TYPE DEFINITION
//  ------------------------------------------------------------------------

/*
The methods here allow native type instances to localize their behavior. In
particular, this helps to keep the interface to modifying TP.ObjectProto
behavior consistent with how we modify TP.FunctionProto. These have to be
defined later than the definition of addInstMethod for local functions which
occurs in the TP.FunctionProto declarations.
*/

//  ------------------------------------------------------------------------
//  NATIVE TYPES - TYPE CONVERSION
//  ------------------------------------------------------------------------

/*
Standard type conversion methods. JavaScript does a lot of automatic type
conversion but these methods provide a demand-driven conversion process
which also allows more intelligence in the conversion process. The Boolean
fromString method is an example.
*/

//  ------------------------------------------------------------------------

//  what delim should be used when joining array elements into a string
Array.Inst.defineAttribute('delimiter', ', ');

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('asArray',
function() {

    /**
     * @method asArray
     * @summary Returns the receiver as an Array instance.
     * @returns {Array} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('asBoolean',
function() {

    /**
     * @method asBoolean
     * @summary Returns the receiver as a Boolean instance. This method differs
     *     slightly from JS behavior in that an empty array returns 'false'
     *     while an array with content returns 'true'. The various browsers
     *     don't follow a common mechanism for implicit conversion so you should
     *     always do an explicit conversion prior to testing.
     * @returns {Boolean}
     */

    return this.getSize() > 0;
});

//  ------------------------------------------------------------------------
//  asHash          Collections
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('asNumber',
function() {

    /**
     * @method asNumber
     * @summary Returns the result implied by the ECMA standard and implemented
     *     by IE4. If the array contains a single element the result is to
     *     convert the single element to a number; else this method returns NaN.
     * @returns {Number}
     */

    if (this.getSize() === 1 && TP.isValid(this.at(0))) {
        return this.at(0).asNumber();
    }

    return NaN;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns the array as a string.
     * @description Constructs a new string from the array.
     *     The join is done using the receiver's current 'delimiter' value,
     *     normally ', '. Set the 'delimiter' value on the receiver to use a
     *     different delimiter.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the Array's String representation. The default is true.
     * @returns {String} A new String containing the elements of the receiver.
     */

    var marker,
        wantsVerbose,
        joinCh,
        joinArr,
        joinStr;

    wantsVerbose = TP.ifInvalid(verbose, true);
    if (!wantsVerbose) {
        return TP.objectToString(this);
    }

    this.$sortIfNeeded();

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    joinCh = this.$get('delimiter');

    if (!TP.isString(joinCh)) {
        //  If 'joinCh' is not a String, maybe it's a hash or other Object with
        //  a 'join' property.
        if (!TP.isString(joinCh = joinCh.get('join'))) {
            joinCh = '';
        }
    }

    try {
        joinArr = this.map(
            function(item, index) {

                return TP.str(item, false);
            });

        joinStr = joinArr.join(joinCh);
    } catch (e) {
        joinStr = this.toString();
    } finally {
        delete this[marker];
    }

    return joinStr;
});

//  ------------------------------------------------------------------------

Array.Type.defineMethod('fromNodeList',
function(aNodeList) {

    /**
     * @method fromNodeList
     * @summary Returns a new instance constructed from a DOM NodeList
     * @param {NodeList} aNodeList The NodeList object.
     * @returns {Node[]} The node list as an Array.
     */

    var i,
        arr;

    arr = this.construct();

    if (TP.isNodeList(aNodeList)) {
        for (i = 0; i < aNodeList.length; i++) {
            arr.push(aNodeList[i]);
        }
    }

    return arr;
});

//  ------------------------------------------------------------------------

Array.Type.defineMethod('fromString',
function(aString) {

    /**
     * @method fromString
     * @summary Returns a new instance constructed from the string provided.
     *     The return value is symmetrical with the behavior of asArray() on
     *     String.
     * @param {String} aString Source string.
     * @returns {String[]} The String as an Array of characters.
     */

    var val;

    if (TP.isJSONString(aString)) {

        val = TP.json2js(aString);
        if (TP.isValid(val)) {
            return val;
        }
    }

    return aString.split('');
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('setDelimiter',
function(aString) {

    /**
     * @method setDelimiter
     * @summary Sets the join delimiter to use when converting the array to and
     *     from a string.
     * @param {String} aString The string used to join() the array.
     * @returns {Array} The receiver.
     */

    var str;

    str = TP.ifInvalid(aString, ', ');

    if (this.$get('delimiter') !== str) {
        this.$set('delimiter', str);
    }

    return this;
});

//  ------------------------------------------------------------------------

Boolean.Inst.defineMethod('asArray',
function() {

    /**
     * @method asArray
     * @summary Returns the receiver as a single item array [this];
     * @returns {Boolean[]} The receiver as an Array.
     */

    var arr;

    //  Opera won't like it if we pass back a single object in a
    //  literal...at least not if it's a number :)
    arr = TP.ac().add(this);

    return arr;
});

//  ------------------------------------------------------------------------

Boolean.Inst.defineMethod('asBoolean',
function() {

    /**
     * @method asBoolean
     * @summary Returns the receiver as a Boolean instance.
     * @returns {Boolean}
     */

    return this;
});

//  ------------------------------------------------------------------------

Boolean.Inst.defineMethod('asHash',
function() {

    /**
     * @method asHash
     * @summary Returns the receiver as a TP.core.Hash.
     * @returns {TP.core.Hash} The receiver converted into a TP.core.Hash.
     */

    return TP.hc('value', this);
});

//  ------------------------------------------------------------------------

Boolean.Inst.defineMethod('asNumber',
function() {

    /**
     * @method asNumber
     * @summary Returns the receiver as a Number instance.
     * @returns {Number}
     */

    //  mirror JS typical behavior
    return this ? 1 : 0;
});

//  ------------------------------------------------------------------------

Boolean.Inst.defineMethod('format',
function(aFormat) {

    /**
     * @method format
     * @summary Returns the receiver as a string in source form: 'true' or
     *     'false' by default. If a format string is provided it should contain
     *     a one or two 'y' or 'n' characters in the "case" style desired. For
     *     example, "Yy" will format the receiver as 'Yes', 'Y' as Y, 'y', as
     *     'y', and yy as 'yes' when the value is true, and the corresponding
     *     "No" values when false. Use 't' and 'f' to format the value as "true"
     *     or "false" variants. Note that this method won't localize the
     *     resulting string, however you can localize the return string
     *     directly.
     * @param {String} aFormat The format specification to format the receiver.
     * @returns {String}
     */

    switch (aFormat) {
        case 'y':
        case 'n':
            return this ? 'y' : 'n';
        case 'Y':
        case 'N':
            return this ? 'Y' : 'N';
        case 'yy':
        case 'nn':
            return this ? 'yes' : 'no';
        case 'YY':
        case 'NN':
            return this ? 'YES' : 'NO';
        case 'Yy':
        case 'Nn':
            return this ? 'Yes' : 'No';

        case 't':
        case 'f':
            return this ? 't' : 'f';
        case 'T':
        case 'F':
            return this ? 'T' : 'F';
        case 'tt':
        case 'ff':
            return this ? 'true' : 'false';
        case 'TT':
        case 'FF':
            return this ? 'TRUE' : 'FALSE';
        case 'Ty':
        case 'Ff':
            return this ? 'True' : 'False';

        case '0':
        case '1':
            return this ? '1' : '0';

        default:
            return this ? 'true' : 'false';
    }
});

//  ------------------------------------------------------------------------

Boolean.Type.defineMethod('fromString',
function(aString, sourceLocale) {

    /**
     * @method fromString
     * @summary Returns a Boolean value from the string provided. Unlike the
     *     default constructor this method uses an array of "false strings" such
     *     as 'n', 'N', 'no', '', '0', etc. to make a determination about
     *     boolean value. The strings used are acquired from the current TIBET
     *     TP.i18n.Locale type to ensure they are localized properly.
     * @param {String} aString Source String value.
     * @param {String|TP.i18n.Locale} sourceLocale A source xml:lang or
     *     TP.i18n.Locale defining the language the string is now in. Defaults
     *     to getTargetLanguage() which is based on the current locale's
     *     language-country value.
     * @returns {Boolean}
     */

    //  kernel isn't loaded completely? use native call
    if (!TP.sys.hasKernel()) {
        /* eslint-disable no-new-wrappers */
        return new Boolean(aString);
        /* eslint-enable no-new-wrappers */
    }

    return this.parse(aString, sourceLocale);
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('asArray',
function() {

    /**
     * @method asArray
     * @summary Returns the receiver as a single element array [this];
     * @returns {Date[]} The receiver as an Array.
     */

    var arr;

    //  Opera won't like it if we pass back a single object in a literal
    arr = TP.ac().add(this);

    return arr;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('asBoolean',
function() {

    /**
     * @method asBoolean
     * @summary Returns the receiver as a Boolean instance. Invalid dates are
     *     considered false.
     * @returns {Boolean}
     */

    //  if we're 'Invalid Date' we're false
    /* eslint-disable no-extra-parens */
    return (this.toString() !== TP.DateProto.toString());
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('asDate',
function() {

    /**
     * @method asDate
     * @summary Returns the receiver as a Date instance.
     * @returns {Date}
     */

    return this;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('asHash',
function() {

    /**
     * @method asHash
     * @summary Returns the receiver as a TP.core.Hash.
     * @returns {TP.core.Hash} The receiver converted into a TP.core.Hash.
     */

    return TP.hc('value', this);
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('asNumber',
function() {

    /**
     * @method asNumber
     * @summary Returns the receiver as an instance of Number. In particular,
     *     the return value is the internal milliseconds format for the date.
     * @returns {Number}
     */

    return this.getTime();
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns the receiver in string form, localized as needed.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the Date's String representation. The default is true.
     * @returns {String} The date in default string format.
     */

    var wantsVerbose;

    wantsVerbose = TP.ifInvalid(verbose, true);
    if (!wantsVerbose) {
        return TP.objectToString(this);
    }

    //  TODO:   add "default date format" lookup here and for other types
    if (TP.sys.hasKernel()) {
        return TP.sys.getLocale().localizeDate(this);
    }

    return this.toUTCString();
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('asFunction',
function() {

    /**
     * @method asFunction
     * @summary Returns the receiver as a Function instance.
     * @returns {Function}
     */

    return this;
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('asHash',
function() {

    /**
     * @method asHash
     * @summary Returns the receiver as a TP.core.Hash.
     * @returns {TP.core.Hash} The receiver converted into a TP.core.Hash.
     */

    return TP.hc('value', this);
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('asNumber',
function() {

    /**
     * @method asNumber
     * @summary Returns the receiver as a number instance. Functions always
     *     return 0 for this call.
     * @returns {Function}
     */

    return 0;
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns the receiver in string form.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the Function's String representation. The default is true.
     * @returns {String} The receiver as a String.
     */

    var wantsVerbose;

    wantsVerbose = TP.ifInvalid(verbose, true);
    if (!wantsVerbose) {
        return TP.gid(this);
    }

    //  The 'verbose' version of a Function is it's 'toString()' rep.
    return TP.objectToString(this);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('asArray',
function() {

    /**
     * @method asArray
     * @summary Returns the receiver as a single element array [this];
     * @returns {Number[]} The receiver as an Array.
     */

    var arr;

    //  Opera won't like it if we pass back a single object in a literal
    arr = TP.ac().add(this);

    return arr;
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('asDate',
function() {

    /**
     * @method asDate
     * @summary Returns the receiver as an instance of Date. The receiver
     *     should represent a milliseconds format acceptable to the Date
     *     constructor.
     * @returns {Date}
     */

    return TP.dc(this);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('asHash',
function() {

    /**
     * @method asHash
     * @summary Returns the receiver as a TP.core.Hash.
     * @returns {TP.core.Hash} The receiver converted into a TP.core.Hash.
     */

    return TP.hc('value', this);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('asNumber',
function() {

    /**
     * @method asNumber
     * @summary Returns the receiver as a Number instance.
     * @returns {Number}
     */

    return this;
});

//  ------------------------------------------------------------------------

Number.Type.defineMethod('fromString',
function(aString, sourceLocale) {

    /**
     * @method fromString
     * @summary Parses the inbound string to produce a new Number using a
     *     combination of the current TP.i18n.Locale and native JavaScript
     *     numeric parse routines.
     * @param {String} aString The string to parse.
     * @param {String|TP.i18n.Locale} sourceLocale A source xml:lang or
     *     TP.i18n.Locale defining the language the string is now in. Defaults
     *     to getTargetLanguage() which is based on the current locale's
     *     language-country value.
     * @returns {Number} A new instance.
     */

    //  kernel isn't loaded completely? use native call
    if (!TP.sys.hasKernel()) {
        //  number only takes one argument (at most)
        /* eslint-disable no-new-wrappers */
        return new Number(aString);
        /* eslint-enable no-new-wrappers */
    }

    return this.parse(aString, sourceLocale);
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('asArray',
function() {

    /**
     * @method asArray
     * @summary Returns the receiver as an Array instance.
     * @returns {Object[]} The receiver as an Array.
     */

    var arr;

    //  watch out for arguments array here. in some browsers it's an
    //  Object rather than an Array or arguments instance.
    if (TP.isArgArray(this)) {
        return TP.ac(this);
    }

    //  Opera won't like it if we pass back a single object in a literal
    arr = TP.ac().add(this);

    return arr;
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('asBoolean',
function() {

    /**
     * @method asBoolean
     * @summary Returns the receiver as a Boolean instance.
     * @returns {Boolean}
     */

    return Boolean.fromString(this.asString());
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('asDate',
function() {

    /**
     * @method asDate
     * @summary Returns the receiver as a Date instance.
     * @returns {Date}
     */

    return TP.dc(this.asString());
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('asFunction',
function() {

    /**
     * @method asFunction
     * @summary Returns the receiver as a Function instance.
     * @returns {Function}
     */

    return TP.fc(this.asString());
});

//  ------------------------------------------------------------------------
//  asHash          Collections
//  ------------------------------------------------------------------------

TP.defineCommonMethod('asNumber',
function() {

    /**
     * @method asNumber
     * @summary Returns the receiver as a Number instance.
     * @returns {Number}
     */

    return TP.nc(this.asString());
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('asRegExp',
function() {

    /**
     * @method asRegExp
     * @summary Returns the receiver as a RegExp instance.
     * @returns {RegExp}
     */

    return TP.rc(this.asString());
});

//  ------------------------------------------------------------------------

RegExp.Inst.defineMethod('asArray',
function() {

    /**
     * @method asArray
     * @summary Returns the receiver as an Array instance.
     * @returns {RegExp[]} The receiver as an Array.
     */

    var arr;

    //  Opera won't like it if we pass back a single object in a literal
    arr = TP.ac().add(this);

    return arr;
});

//  ------------------------------------------------------------------------

RegExp.Inst.defineMethod('asHash',
function() {

    /**
     * @method asHash
     * @summary Returns the receiver as a TP.core.Hash.
     * @returns {TP.core.Hash} The receiver converted into a TP.core.Hash.
     */

    return TP.hc('value', this);
});

//  ------------------------------------------------------------------------

RegExp.Inst.defineMethod('asRegExp',
function() {

    /**
     * @method asRegExp
     * @summary Returns the receiver as a RegExp instance.
     * @returns {RegExp}
     */

    return this;
});

//  ------------------------------------------------------------------------

RegExp.Inst.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns the receiver as a String.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the RegExp's String representation. This flag is ignore in this
     *     version of this method.
     * @returns {String} The receiver as a String.
     */

    //   We use 'toString()' rather than the 'source' property, since it
    //   includes the flags, etc.
    return this.toString();
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asArray',
function(splitChar) {

    /**
     * @method asArray
     * @summary Returns the receiver as an Array instance. The string is split
     *     using the delimiter provided or the empty string which results in an
     *     array of characters (the default).
     * @param {String} splitChar The delimiter to split on.
     * @returns {String[]} The receiver as an Array.
     */

    var delim;

    delim = splitChar;
    if (TP.notValid(delim)) {
        delim = TP.isString(this.$get('delimiter')) ?
            this.$get('delimiter') : '';
    }

    return this.split(delim);
});

//  ------------------------------------------------------------------------
//  asHash          Collections
//  ------------------------------------------------------------------------

String.Inst.defineMethod('asNumber',
function() {

    /**
     * @method asNumber
     * @summary Returns the receiver as a Number instance.
     * @returns {Number}
     */

    //  We use parseFloat() so that we don't have to worry about parsing
    //  octals, etc. We'll never do that anyway and that behavior (parsing a
    //  leading '0' as octal) has been removed for ECMAScript E5 strict mode
    //  anyway.

    var result;

    if (TP.regex.PERCENTAGE.test(this)) {
        if (TP.isNumber(result = parseFloat(this))) {
            return result / 100;
        }
    }

    return parseFloat(this);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('defineSubtype',
function(name) {

    /**
     * @method defineSubtype
     * @summary Adds a new subtype to the type represented by the receiving
     *     string.
     * @param {String} name The name of the subtype, including an optional
     *     namespace prefix and colon or dot separator.
     * @returns {TP.lang.RootObject} The new type object representing the
     *     subtype added.
     */

    var typ;

    typ = this.asType();
    if (TP.isType(typ)) {
        return typ.defineSubtype(name);
    }

    return this.raise('TP.sig.InvalidType', this);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('canResolveDNU',
function(anOrigin, aMethodName, anArgArray, callingContext) {

    /**
     * @method canResolveDNU
     * @summary Provides an instance that has triggered the DNU machinery with
     *     an opportunity to handle the problem itself. For string instances
     *     this results in a test to see if conversion to a type with the name
     *     contained in the string would succeed.
     * @param {Object} anOrigin The object asking for help. The receiver in this
     *     case.
     * @param {String} aMethodName The method name that failed.
     * @param {Object[]} anArgArray Optional arguments to function.
     * @param {Function|arguments} callingContext The calling context.
     * @returns {Boolean} TRUE means resolveDNU() will be called. FALSE means
     *     the standard DNU machinery will continue processing. The default is
     *     FALSE.
     */

    var typ;

    typ = this.asType();
    if (TP.isType(typ)) {
        //  test for non-dnu implementation
        if (TP.canInvoke(typ, aMethodName)) {
            return true;
        }

        //  defer to type for more advanced resolution options
        return typ.canResolveDNU(
                    anOrigin, aMethodName, anArgArray, callingContext);
    }

    return false;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('construct',
function() {

    /**
     * @method construct
     * @summary Returns a new instance of the type represented by the receiving
     *     string.
     * @returns {Object} The new instance.
     */

    var typ;

    typ = this.asType();
    if (TP.isType(typ)) {
        return typ.construct.apply(typ, arguments);
    } else {
        return this.raise('TP.sig.InvalidType', this);
    }
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary When the receiver is being treated like a Type this will cause
     *     that type to be loaded and initialized.
     * @returns {Object|undefined} The new instance.
     */

    var typ;

    if (this === TP.StringProto) {
        return;
    }

    typ = this.asType();
    if (TP.isType(typ)) {
        return typ;
    } else {
        return this.raise('TP.sig.InvalidType', this);
    }
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('resolveDNU',
function(anOrigin, aMethodName, anArgArray, callingContext) {

    /**
     * @method resolveDNU
     * @summary Invoked by the main DNU machinery when the instance has
     *     responded TRUE to canResolveDNU() for the parameters given. For a
     *     string instance that means conversion via asType() would succeed.
     * @param {Object} anOrigin The object asking for help.
     * @param {String} aMethodName The method name that failed.
     * @param {Object[]} anArgArray Optional arguments to function.
     * @param {Function|arguments} callingContext The calling context.
     * @returns {Object} The results of function resolution.
     */

    var typ;

    typ = this.asType();
    if (TP.isType(typ)) {
        switch (anArgArray.length) {
            case 0:
                return typ[aMethodName]();
            case 1:
                return typ[aMethodName](anArgArray[0]);
            case 2:
                return typ[aMethodName](anArgArray[0], anArgArray[1]);
            default:
                return typ[aMethodName].apply(typ, anArgArray);
        }
    }

    return this.raise('TP.sig.InvalidType', this);
});

//  ========================================================================
//  TP.lang.RootObject - PART II
//  ========================================================================

/*
Continuing development of the meta-object protocol.
*/

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('defineInstGetter',
function(propertyName, methodBody) {

    /**
     * @method defineInstGetter
     * @summary Adds an ECMA edition 5 'getter' with name and body provided as
     *     an instance 'getter'.
     * @param {String} propertyName The name of the property that the getter
     *     should be installed for.
     * @param {Function} methodBody The actual getter implementation.
     * @returns {Object} The receiver.
     */

    var proto;

    proto = this[TP.INSTC].prototype;

    Object.defineProperty(
        proto,
        propertyName,
        {
            get: methodBody
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('defineInstSetter',
function(propertyName, methodBody) {

    /**
     * @method defineInstSetter
     * @summary Adds an ECMA edition 5 'setter' with name and body provided as
     *     an instance 'setter'.
     * @param {String} propertyName The name of the property that the setter
     *     should be installed for.
     * @param {Function} methodBody The actual setter implementation.
     * @returns {Object} The receiver.
     */

    var proto;

    proto = this[TP.INSTC].prototype;

    Object.defineProperty(
        proto,
        propertyName,
        {
            set: methodBody
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('defineTypeGetter',
function(propertyName, methodBody) {

    /**
     * @method defineTypeGetter
     * @summary Adds an ECMA edition 5 'getter' with name and body provided as
     *     a type 'getter'.
     * @param {String} propertyName The name of the property that the getter
     *     should be installed for.
     * @param {Function} methodBody The actual getter implementation.
     * @returns {Object} The receiver.
     */

    var proto;

    proto = this[TP.TYPEC].prototype;

    Object.defineProperty(
        proto,
        propertyName,
        {
            get: methodBody
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('defineTypeSetter',
function(propertyName, methodBody) {

    /**
     * @method defineTypeSetter
     * @summary Adds an ECMA edition 5 'setter' with name and body provided as
     *     an type 'setter'.
     * @param {String} propertyName The name of the property that the setter
     *     should be installed for.
     * @param {Function} methodBody The actual setter implementation.
     * @returns {Object} The receiver.
     */

    var proto;

    proto = this[TP.TYPEC].prototype;

    Object.defineProperty(
        proto,
        propertyName,
        {
            set: methodBody
        });

    return this;
});

//  ------------------------------------------------------------------------
//  Access Path Aliases
//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getAccessPathAliases',
function(aPath, includeSupertypes) {

    /**
     * @method getAccessPathAliases
     * @summary Returns an Array of 'access path aliases' - that is, the
     *     aliased names that the receiver uses for a particular path (i.e.
     *     '/person/lastName' might map to 'lastName').
     * @param {String} aPath The path to check for aliases.
     * @param {Boolean} includeSupertypes Whether or not to include the
     *     receiver's supertypes when looking for path aliases. The default is
     *     true.
     * @returns {String[]|null} An Array of access path aliases for the receiver
     *     or null.
     */

    var entry,
        names,
        len,
        i,
        tname;

    entry = TP.sys.$$meta_pathinfo.at(this.getName() + '_Type');

    //  If we didn't find an entry in for the type itself, and the flag doesn't
    //  prevent us with checking with the supertypes, then do so.
    //  Note the explicit 'notFalse' check here - by default, this parameter is
    //  true.
    if (TP.notFalse(includeSupertypes) && TP.notValid(entry)) {

        //  Since supertype names are always reported from most-to-least
        //  specific, this will properly find any overrides on path aliases from
        //  higher-level supertypes.
        names = this.getSupertypeNames();
        len = names.getSize();
        for (i = 0; i < len; i++) {
            tname = names.at(i);
            if (TP.isValid(entry = TP.sys.$$meta_pathinfo.at(
                            tname + '_Type'))) {
                break;
            }
        }
    }

    if (TP.isValid(entry)) {
        //  NB: We use primitive property access here since 'entry' is a
        //  primitive object
        return entry[aPath];
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('getAccessPathAliases',
function(aPath, includeSupertypes) {

    /**
     * @method getAccessPathAliases
     * @summary Returns an Array of 'access path aliases' - that is, the
     *     aliased names that the receiver uses for a particular path (i.e.
     *     '/person/lastName' might map to 'lastName').
     * @param {String} aPath The path to check for aliases.
     * @param {Boolean} includeSupertypes Whether or not to include the
     *     receiver's supertypes when looking for property path aliases. The
     *     default is true.
     * @returns {String[]|null} An Array of access path aliases for the receiver
     *     or null.
     */

    var entry,
        names,
        len,
        i,
        tname;

    entry = TP.sys.$$meta_pathinfo.at(this.getTypeName() + '_Inst');

    //  If we didn't find an entry in for the type itself, and the flag doesn't
    //  prevent us with checking with the supertypes, then do so.
    //  Note the explicit 'notFalse' check here - by default, this parameter is
    //  true.
    if (TP.notFalse(includeSupertypes) && TP.notValid(entry)) {

        //  Since supertype names are always reported from most-to-least
        //  specific, this will properly find any overrides on path aliases from
        //  higher-level supertypes.
        names = this.getSupertypeNames();
        len = names.getSize();
        for (i = 0; i < len; i++) {
            tname = names.at(i);
            if (TP.isValid(entry = TP.sys.$$meta_pathinfo.at(
                            tname + '_Inst'))) {
                break;
            }
        }
    }

    if (TP.isValid(entry)) {
        //  NB: We use primitive property access here since 'entry' is a
        //  primitive object
        return entry[aPath];
    }

    return null;
});

//  ------------------------------------------------------------------------
//  Attribute Property Descriptors
//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getDescriptorFor',
function(attributeName, includeSupertypes) {

    /**
     * @method getDescriptorFor
     * @summary Returns the property descriptor, if any, for the type attribute
     *     provided. See the 'TP.sys.addMetadata()' call for more information
     *     about property descriptors.
     * @param {String} attributeName The name of the attribute to get the
     *     property descriptor for.
     * @param {Boolean} includeSupertypes Whether or not to include the
     *     receiver's supertypes when looking for property descriptors. The
     *     default is true.
     * @returns {Object} The property descriptor of the attribute on the
     *     receiver.
     */

    var entry,
        names,
        len,
        i,
        tname;

    entry = TP.sys.$$meta_attributes.at(
                        this.getName() + '_Type_' + attributeName);

    //  If we didn't find an entry in for the type itself, and the flag doesn't
    //  prevent us with checking with the supertypes, then do so.
    //  Note the explicit 'notFalse' check here - by default, this parameter is
    //  true.
    if (TP.notFalse(includeSupertypes) && TP.notValid(entry)) {

        //  Since supertype names are always reported from most-to-least
        //  specific, this will properly find any overrides on descriptors from
        //  higher-level supertypes.
        names = this.getSupertypeNames();
        len = names.getSize();
        for (i = 0; i < len; i++) {
            tname = names.at(i);
            if (TP.isValid(entry = TP.sys.$$meta_attributes.at(
                            tname + '_Type_' + attributeName))) {
                break;
            }
        }
    }

    return entry;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getInstDescriptorFor',
function(attributeName, includeSupertypes) {

    /**
     * @method getInstDescriptorFor
     * @summary Returns the property descriptor, if any, for the instance
     *     attribute provided. See the 'TP.sys.addMetadata()' call for more
     *     information about property descriptors.
     * @param {String} attributeName The name of the attribute to get the
     *     property descriptor for.
     * @param {Boolean} includeSupertypes Whether or not to include the
     *     receiver's supertypes when looking for property descriptors. The
     *     default is true.
     * @returns {Object} The property descriptor of the attribute on the
     *     receiver.
     */

    var entry,
        names,
        len,
        i,
        tname;

    entry = TP.sys.$$meta_attributes.at(
                        this.getName() + '_Inst_' + attributeName);

    //  If we didn't find an entry in for the type itself, and the flag doesn't
    //  prevent us with checking with the supertypes, then do so.
    //  Note the explicit 'notFalse' check here - by default, this parameter is
    //  true.
    if (TP.notFalse(includeSupertypes) && TP.notValid(entry)) {

        //  Since supertype names are always reported from most-to-least
        //  specific, this will properly find any overrides on descriptors from
        //  higher-level supertypes.
        names = this.getSupertypeNames();
        len = names.getSize();
        for (i = 0; i < len; i++) {
            tname = names.at(i);
            if (TP.isValid(entry = TP.sys.$$meta_attributes.at(
                            tname + '_Inst_' + attributeName))) {
                break;
            }
        }
    }

    return entry;
});

//  ------------------------------------------------------------------------
//  Dependency Management
//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getDependencies',
function() {

    /**
     * @method getDependencies
     * @summary Returns an Array of Objects that the receiver considers to be
     *     it's manually determined set of 'dependent' objects that it needs in
     *     order to operate successfully. These objects can be any type of
     *     object in the system, so long as they themselves can respond to the
     *     'getDependencies' method. In this way, we can recursively
     *     determine the chain of dependent objects. This terminates at the
     *     meta-level by returning an empty Array.
     * @description Many objects can be determined via method invocation
     *     tracking to be included or excluded for packaging purposes. This
     *     method allows the receiving object to statically force a particular
     *     object to be included along with the receiver in the package. In
     *     some cases this is the only way to determine whether or not an object
     *     should be included/excluded in a particular package.
     * @returns {Object[]} The property descriptor of the attribute on the
     *     receiver.
     */

    var dependencies,

        obj,

        superType,
        traitTypes;

    //  First, grab whatever direct dependencies were programmed onto this
    //  object.
    dependencies = this[TP.DEPENDENCIES];
    if (TP.isValid(dependencies)) {
        dependencies =
            dependencies.map(
                function(anItem) {
                    return anItem.getDependencies();
                });
    } else {
        dependencies = TP.ac();
    }

    //  Second, add ourself. Note that if we have our package associated with us
    //  then we want the entire package to be considered as a dependency.
    if (this.hasOwnPackage()) {

        obj = {};

        obj.wholePackageInfo = true;
        obj[TP.LOAD_PACKAGE] = this[TP.LOAD_PACKAGE];
        obj[TP.LOAD_CONFIG] = this[TP.LOAD_CONFIG];
        obj[TP.LOAD_STAGE] = this[TP.LOAD_STAGE];
        obj[TP.LOAD_INDEX] = this[TP.LOAD_INDEX];
        obj[TP.SOURCE_PACKAGE] = this[TP.SOURCE_PACKAGE];
        obj[TP.SOURCE_CONFIG] = this[TP.SOURCE_CONFIG];

        //  Note here how we hardcode 'base' as the source config. This is so
        //  that when package dependencies are computed, our 'whole package'
        //  dependency will report in a way that the whole base of our package
        //  is included.
        obj[TP.OID] = this[TP.SOURCE_PACKAGE] + '@base';

        dependencies.push(obj);
    } else {
        dependencies.push(this);
    }

    //  Third, add the dependencies of the direct supertype
    superType = this.getSupertype();
    if (TP.isValid(superType)) {
        dependencies.push(superType.getDependencies());
    }

    //  Third, add the trait types (and their supertypes)
    traitTypes = this[TP.TRAITS];
    if (TP.notEmpty(traitTypes)) {
        traitTypes.forEach(
            function(aTraitType) {
                dependencies.push(aTraitType.getDependencies());
            });
    }

    //  Make sure to flatten any nested Arrays.
    dependencies = dependencies.flatten();

    return dependencies;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('getDescriptorFor',
function(attributeName, includeSupertypes) {

    /**
     * @method getDescriptorFor
     * @summary Returns the property descriptor, if any, for the instance
     *     attribute provided. See the 'TP.sys.addMetadata()' call for more
     *     information about property descriptors.
     * @param {String} attributeName The name of the attribute to get the
     *     property descriptor for.
     * @param {Boolean} includeSupertypes Whether or not to include the
     *     receiver's supertypes when looking for property descriptors. The
     *     default is true.
     * @returns {Object} The property descriptor of the attribute on the
     *     receiver.
     */

    return this.getType().getInstDescriptorFor(attributeName,
                                                includeSupertypes);
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('getDependencies',
function() {

    /**
     * @method getDependencies
     * @summary Returns an Array of Objects that the receiver considers to be
     *     it's manually determined set of 'dependent' objects that it needs in
     *     order to operate successfully. These objects can be any type of
     *     object in the system, so long as they themselves can respond to the
     *     'getDependencies' method. In this way, we can recursively
     *     determine the chain of dependent objects. This terminates at the
     *     meta-level by returning an empty Array.
     * @description Many objects can be determined via method invocation
     *     tracking to be included or excluded for packaging purposes. This
     *     method allows the receiving object to statically force a particular
     *     object to be included along with the receiver in the package. In
     *     some cases this is the only way to determine whether or not an object
     *     should be included/excluded in a particular package.
     * @returns {Object[]} The property descriptor of the attribute on the
     *     receiver.
     */

    var dependencies;

    //  First, grab whatever direct dependencies were programmed onto this
    //  object.
    dependencies = this[TP.DEPENDENCIES];
    if (TP.isValid(dependencies)) {
        dependencies = TP.copy(dependencies);
    } else {
        dependencies = TP.ac();
    }

    //  Then, add whatever dependencies our type thinks is necessary. These will
    //  already be flattened and the 'concat' will make sure that we don't
    //  create a nested Array.
    dependencies = dependencies.concat(this.getType().getDependencies());

    return dependencies;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('hasOwnPackage',
function() {

    /**
     * @method hasOwnPackage
     * @summary Returns whether or not the receiver has it's own 'package' (i.e.
     *     bundle) associated with it. This will usually report 'true' for the
     *     'main type' associated with a bundle package.
     * @returns {Boolean} Whether or not the receiver has it's own 'package'.
     */

    var sourcePackagePath,

        localPackagePath,
        localPackageName;

    //  Grab the *source* package and make sure it's real.
    sourcePackagePath = this[TP.SOURCE_PACKAGE];
    if (TP.isEmpty(sourcePackagePath)) {
        return false;
    }

    //  Slice down to just the local package name without the extension.
    localPackagePath = sourcePackagePath.slice(
                            sourcePackagePath.lastIndexOf('/') + 1);
    localPackageName = localPackagePath.slice(
                            0, localPackagePath.lastIndexOf('.'));

    //  If the local package name is equal to this type's name, then return true
    //  otherwise return false.
    return localPackageName === this.getName();
});

//  ------------------------------------------------------------------------
//  Attribute Facets
//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getValidatingAspectNames',
function() {

    /**
     * @method getValidatingAspectNames
     * @summary Returns an Array of the names of the aspects to validate on the
     *     receiver. At this type level, this just returns an empty Array.
     * @returns {String[]} A list of the names of aspects to validate on the
     *     receiver.
     */

    return TP.ac();
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('$addFacetFunction',
function(aspectName, facetName, facetFunction) {

    /**
     * @method $addFacetFunction
     * @summary Adds a 'facet function' to the receiver. This is a function that
     *     is observing a data source and will set the value of the aspect's
     *     facet when that data source changes.
     * @param {String} aspectName The name of the aspect to set.
     * @param {String} facetName The name of the facet to set.
     * @param {Boolean} facetFunction The function to add as the facet function.
     * @returns {Object} The receiver.
     */

    var facetFunctions,
        facetFuncSlotName;

    //  If the facet is 'value', then just return - we don't set these for
    //  'value' facets.
    if (facetName === 'value') {
        return this;
    }

    //  If the internal slot that keeps all of the facet functions for this
    //  instance is not defined on the receiver, define it.
    //  Otherwise, TIBET's '$set' method will whine ;-).
    if (TP.notDefined(this.$facetFunctions)) {
        this.defineAttribute('$facetFunctions');
        //  Pre-populate the slot with a hash.
        this.$set('$facetFunctions', TP.hc(), false);
    }

    facetFunctions = this.$get('$facetFunctions');

    //  The internal facet slot name will always be something like
    //  '$SSN_required_func'.
    facetFuncSlotName = '$' + aspectName + '_' + facetName + '_func';

    facetFunctions.atPut(facetFuncSlotName, facetFunction);

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('checkAllFacetsOfAllAspects',
function() {

    /**
     * @method checkAllFacetsOfAllAspects
     * @summary Check all of the facets of all of the aspects of the receiver.
     *     If the facet values of the aspects are different, a facet change will
     *     be signaled for that facet of that aspect.
     * @returns {TP.lang.RootObject} The receiver.
     */

    var facetedAspects;

    facetedAspects = this.getFacetedAspectNames();

    if (TP.notEmpty(facetedAspects)) {
        this.checkFacets(facetedAspects);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('checkFacets',
function(aspectNames, facetList) {

    /**
     * @method checkFacets
     * @summary Checks the facets of the supplied aspect on the receiver
     *     according to the list of facets supplied (or TP.FACET_NAMES if one
     *     isn't supplied). If a valid facet value can be computed for a
     *     particular aspect, that facet value is set for that aspect.
     * @description At this level, this method simply returns.
     * @param {String|String[]} aspectNames The name of the aspect to check the
     *     facets for.
     * @param {String[]} facetList The list of facets to check. This is an
     *     optional parameter.
     * @returns {Object} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('checkFacets',
function(aspectNames, facetList) {

    /**
     * @method checkFacets
     * @summary Checks the facets of the supplied aspect on the receiver
     *     according to the list of facets supplied (or TP.FACET_NAMES if one
     *     isn't supplied). If a valid facet value can be computed for a
     *     particular aspect, that facet value is set for that aspect.
     * @param {String|String[]} aspectNames The name of the aspect to check the
     *     facets for.
     * @param {String[]} facetList The list of facets to check. This is an
     *     optional parameter.
     * @returns {TP.lang.RootObject} The receiver.
     */

    var aspects,
        facets,

        aspectsLen,
        i,

        facetsLen,
        j,

        aspectName,
        facetName,

        oldVal,
        newVal;

    if (!TP.isArray(aspects = aspectNames)) {
        aspects = TP.ac(aspectNames);
    }

    //  Default the set of facets to check to TP.FACET_NAMES, which are the list
    //  of standard facets for all TIBET attributes.
    facets = TP.ifInvalid(facetList, TP.FACET_NAMES);

    aspectsLen = aspects.getSize();
    facetsLen = facets.getSize();

    for (i = 0; i < aspectsLen; i++) {

        aspectName = aspects.at(i);

        for (j = 0; j < facetsLen; j++) {

            facetName = facets.at(j);

            //  Grab the facet value (which is different than the facet setting
            //  - the facet value could be a computed value).

            //  NOTE: We *must* use getFacetValueFor() here rather than
            //  getFacet(). This is important because, if the private facet
            //  tracking slot is undefined and we want to set it for the first
            //  time, the getFacet() call does that automatically and then when
            //  we check it below, the values will be equal and 'setFacet()
            //  won't happen (as it should that first time around).
            if (TP.isValid(
                newVal = this.getFacetValueFor(aspectName, facetName))) {

                //  Get any existing value
                oldVal = this.$get('$' + aspectName + '_' + facetName);

                if (oldVal !== newVal) {
                    //  We got a validity value - set it.
                    this.setFacet(aspectName, facetName, newVal);
                }
            }
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('facetChanged',
function(anAspect, aFacet, aDescription) {

    /**
     * @method facetChanged
     * @summary Notifies observers that the named facet of the receiver has
     *     changed.
     * @param {String} anAspect The aspect of the receiver that changed. This is
     *     usually an attribute name.
     * @param {String} aFacet The facet of the receiver that changed. This is
     * usually one of the standard TIBET facets listed in TP.FACET_NAMES.
     * @param {TP.core.Hash} aDescription A hash describing details of the
     *     change.
     * @returns {Object} The receiver.
     * @fires Change
     */

    var asp,
        baseSig,
        sig,
        desc;

    if (!this.shouldSignalChange()) {
        return this;
    }

    //  Build up the signal name we'll be firing.
    asp = TP.ifKeyInvalid(aDescription, 'aspect', anAspect) || 'value';

    //  The 'base signal' name is the actual real Signal type that gets fired
    //  (as opposed to the aspectName + facetName + 'Change' spoofed signal that
    //  is computed and observed). This will be that signal's supertype.

    //  In this case, the base signal name will be something like
    //  'TP.sig.RelevantChange'.
    baseSig = 'TP.sig.' + TP.makeStartUpper(aFacet) + 'Change';

    //  The signal name will be the spoofed ('unreal') signal name. In this
    //  case, it might be something like 'SSNRelevantChange'
    sig = TP.makeStartUpper(asp.toString()) +
            TP.makeStartUpper(aFacet) +
            'Change';

    //  Build up a standard form for the description hash.
    desc = TP.isValid(aDescription) ? aDescription : TP.hc();
    if (!TP.canInvoke(desc, 'atPutIfAbsent')) {
        this.raise('TP.sig.InvalidParameter',
                    'Description not a collection.');

        return this;
    }
    desc.atPutIfAbsent('aspect', asp);
    desc.atPutIfAbsent('action', TP.UPDATE);
    desc.atPutIfAbsent('facet', aFacet);
    desc.atPutIfAbsent('target', this);

    //  Fire the signal. Note that we force the firing policy here. This allows
    //  observers of a generic 'facet change' signal of some sort to see
    //  'aspect' facet Change notifications, even if those 'aspect' facet Change
    //  signals haven't been defined as being subtypes of FacetChange (although
    //  we also supply the base signal name as the default signal type here so
    //  that undefined aspect signals will use that type).
    TP.signal(this, sig, desc, TP.INHERITANCE_FIRING, baseSig);

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('getFacetedAspectNames',
function() {

    /**
     * @method getFacetedAspectNames
     * @summary Returns an Array of the names of the aspects that are faceted on
     *     the receiver.
     * @returns {String[]} A list of the names of aspects that are faceted on
     *     the receiver.
     */

    var aspects,
        thisType;

    if (TP.owns(this, '$$faceted_aspects')) {
        return this.$$faceted_aspects;
    }

    aspects = this.getKeys();

    //  We want to filter out slots holding facet values
    aspects = aspects.reject(
            function(aspectName) {
                return TP.regex.FACET_SLOT_NAME_MATCH.test(aspectName);
            });

    thisType = this.getType();

    //  Next filter out slots that don't have property descriptors
    aspects = aspects.select(
            function(aspectName) {
                return TP.isValid(thisType.getInstDescriptorFor(aspectName));
            });

    if (!TP.owns(this, '$$faceted_aspects')) {
        this.$$faceted_aspects = [];
    }

    this.$$faceted_aspects = aspects;

    return aspects;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('getFacet',
function(aspectName, facetName) {

    /**
     * @method getFacet
     * @summary Gets the value of the named facet of the named aspect. Note that
     *     this method also creates the private facet tracking slot to hold the
     *     current value of the facet if it wasn't already created.
     * @param {String} aspectName The name of the aspect to get.
     * @param {String} facetName The name of the facet to get.
     * @returns {Object} The value of the facet of the aspect.
     */

    var facetValue,
        facetSlotName;

    //  Get the current value of the aspect/facet pair.
    facetValue = this.getFacetValueFor(aspectName, facetName);

    //  The private facet tracking facet slot name will always be something like
    //  '$SSN_required'.
    facetSlotName = '$' + aspectName + '_' + facetName;

    //  If there was a valid value, but it didn't have a private facet tracking
    //  slot, then call *$set()* to set it (this will create the slot as well).
    if (TP.isValid(facetValue) && TP.notDefined(this[facetSlotName])) {
        this.$setFacet(aspectName, facetName, facetValue, false);
    }

    return facetValue;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('getFacetValueFor',
function(aspectName, facetName) {

    /**
     * @method getFacetValueFor
     * @summary Returns the facet value for the named facet of the named aspect
     *     on the receiver.
     * @description Note that the facet value is *not* the same as the facet
     *     setting. The facet setting is the mechanism, supplied by the code
     *     author, of computing the facet value. It may be a simple literal
     *     value, an access path or the name of a method to execute on the
     *     receiver. These are all different ways that a facet value may be
     *     obtained on the receiver.
     * @param {String} aspectName The name of the aspect to return the facet
     *      value for.
     * @param {String} facetName The name of the facet to return the facet
     *      value for.
     * @returns {Object|undefined} The value of the named facet of the named
     *     aspect on the receiver.
     */

    var facetSetting,
        facetValue,

        val;

    //  First, make sure that the aspect has a facet named by the facetName. If
    //  not, just return *undefined*. The reason we return undefined here is so
    //  that the value will be exactly the same as when there is no facet for
    //  the aspect at all.
    if (TP.isEmpty(facetSetting = this.getType().getInstFacetSettingFor(
                                                    aspectName,
                                                    facetName))) {
        return;
    }

    //  We compute the facet value differently depending on whether we're
    //  computing the validity facet or not.
    switch (facetName) {

        case TP.REQUIRED:

            if (TP.isCallable(facetSetting)) {
                if (facetSetting.$$transformationFunction === true) {
                    if (TP.isCollection(this)) {
                        val = facetSetting(this, this);
                    } else {
                        val = facetSetting(this, TP.ac(this.get(aspectName)));
                    }
                } else {
                    val = facetSetting(this);
                }
            } else if (TP.isBoolean(facetSetting)) {
                val = facetSetting;
            } else if (facetSetting.isAccessPath()) {
                val = facetSetting.executeGet(this.getPathSource(facetSetting));
            } else if (TP.isString(facetSetting) &&
                        TP.isMethod(this[facetSetting])) {
                val = this[facetSetting]();
            } else if (TP.isString(facetSetting)) {
                val = facetSetting;
            }

            //  If the value of the 'required' facet is true, then we check
            //  to see if the object has a value. We want to return true if
            //  *doesn't* (i.e. this aspect is required, it doesn't have a value
            //  and so it's "still in a required-ness state").
            if (TP.isTrue(val)) {
                facetValue = !this.satisfiesRequiredFacet(aspectName);
            } else if (TP.notValid(val)) {
                //  If the actual value is not valid (i.e. null or undefined),
                //  then it can be considered missing - in which case a facet of
                //  TP.REQUIRED would be false.
                facetValue = false;
            }

            break;

        case TP.VALID:

            if (TP.isCallable(facetSetting)) {
                if (facetSetting.$$transformationFunction === true) {
                    if (TP.isCollection(this)) {
                        val = facetSetting(this, this);
                    } else {
                        val = facetSetting(this, TP.ac(this.get(aspectName)));
                    }
                } else {
                    val = facetSetting(this);
                }
            } else {
                //  If facetSetting is a POJO with a 'value' slot, then that's
                //  the value to use, otherwise we do a 'get' of the aspectName
                if (TP.isValid(facetValue = facetSetting.value)) {
                    if (TP.isBoolean(facetValue)) {
                        val = facetValue;
                    } else if (TP.isArray(facetValue)) {
                        val = facetValue;
                    } else if (facetValue.isAccessPath()) {
                        val = facetValue.executeGet(
                                            this.getPathSource(facetValue));
                    } else if (TP.isString(facetValue) &&
                                TP.isMethod(this[facetValue])) {
                        val = this[facetValue]();
                    } else if (TP.isString(facetValue)) {
                        val = facetValue;
                    }
                } else {
                    val = this.get(aspectName);
                }
            }

            //  If the actual value is not valid (i.e. null or undefined), then
            //  it can be considered missing - in which case a facet of
            //  TP.VALID would be true  Therefore, missing values are *true*
            //  insofar as data type validity. In the case of a facet of
            //  TP.REQUIRED, then it's considered false. See above.
            if (TP.notValid(val)) {
                facetValue = true;
            } else if (TP.isCallable(facetSetting)) {
                facetValue = val;
            } else {
                //  The validity facet is computed by a method, since it is a
                //  more complex calculation than any of the other facets. At
                //  this point, facetSetting should be a POJO containing
                //  subconstraint settings (minValue, maxLength, etc).
                facetValue = this.getType().validateConstraintsOn(
                                                        val, facetSetting);
            }

            break;

        default:

            //  Otherwise, use a series of object tests to try to obtain the
            //  best value for the facet.
            if (TP.isCallable(facetSetting)) {
                if (facetSetting.$$transformationFunction === true) {
                    if (TP.isCollection(this)) {
                        val = facetSetting(this, this);
                    } else {
                        val = facetSetting(this, TP.ac(this.get(aspectName)));
                    }
                } else {
                    val = facetSetting(this);
                }
            } else if (TP.isBoolean(facetSetting)) {
                facetValue = facetSetting;
            } else if (TP.isArray(facetSetting)) {
                facetValue = facetSetting;
            } else if (facetSetting.isAccessPath()) {
                facetValue = facetSetting.executeGet(
                                this.getPathSource(facetSetting));
            } else if (TP.isString(facetSetting) &&
                        TP.isMethod(this[facetSetting])) {
                facetValue = this[facetSetting]();
            } else if (TP.isString(facetSetting)) {
                facetValue = facetSetting;
            }

            break;
    }

    return facetValue;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('getValidatingAspectNames',
function() {

    /**
     * @method getValidatingAspectNames
     * @summary Returns an Array of the names of the aspects to validate on the
     *     receiver.
     * @returns {String[]} A list of the names of aspects to validate on the
     *     receiver.
     */

    var aspectsToCheck,
        thisType;

    aspectsToCheck = this.getKeys();

    //  We want to filter out slots holding facet values
    aspectsToCheck = aspectsToCheck.reject(
                function(aspectName) {
                    return TP.regex.FACET_SLOT_NAME_MATCH.test(aspectName);
                });

    thisType = this.getType();

    //  Next filter out slots that only have validation constraints
    aspectsToCheck = aspectsToCheck.select(
                function(aspectName) {
                    return TP.isValid(thisType.getInstFacetSettingFor(
                                                        aspectName, 'valid'));
                });

    return aspectsToCheck;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('satisfiesRequiredFacet',
function(aspectName) {

    /**
     * @method satisfiesRequiredFacet
     * @summary Returns whether or not the value obtained by querying the
     *     receiver with the supplied aspect name produces a value that can be
     *     considered 'satisfying' to the 'required'ness facet.
     * @description Typically, falsey values or a collection of falsey values
     *     will cause this method to return false.
     * @param {String} aspectName The name of the aspect to use to query the
     *     receiver to use in the test.
     * @returns {Boolean} Whether or not the value obtained by the query
     *     satisfies the 'required value' constraint.
     */

    var aspectValue,

        values,
        satisfiesRequired,

        len,
        i;

    aspectValue = this.get(aspectName);

    if (!TP.isCollection(aspectValue)) {
        return TP.isTruthy(aspectValue);
    }

    values = aspectValue.getValues();

    satisfiesRequired = false;

    len = values.getSize();
    for (i = 0; i < len; i++) {
        if (TP.isTruthy(values.at(i))) {
            satisfiesRequired = true;
            break;
        }
    }

    return satisfiesRequired;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('$setFacet',
function(aspectName, facetName, facetValue, shouldSignal) {

    /**
     * @method $setFacet
     * @summary Sets the value of the named facet of the named aspect to the
     *     value provided. This method should be called from any 'custom facet
     *     setter' in order to a) set the property and b) signal a change, if
     *     configured.
     * @param {String} aspectName The name of the aspect to set.
     * @param {String} facetName The name of the facet to set.
     * @param {Boolean} facetValue The value to set the facet to.
     * @param {Boolean} shouldSignal If false no signaling occurs. Defaults to
     *     this.shouldSignalChange().
     * @returns {Boolean} Whether or not the value was changed from the value it
     *     had before this method was called.
     */

    var facetSlotName,
        currentFacetVal,

        sigFlag;

    //  If the facet is 'value', then use the standard 'set' mechanism.
    if (facetName === 'value') {
        return this.set(aspectName, facetValue, shouldSignal);
    }

    //  The internal facet slot name will always be something like
    //  '$SSN_required'.
    facetSlotName = '$' + aspectName + '_' + facetName;

    //  Grab the current value of the internal slot and compare it to the
    //  supplied value. Only go through the act of setting it and signaling a
    //  change if they're different.

    //  NB: Make sure to use $get() here. Otherwise, we end up doing path
    //  lookups, etc. for private facet slot values.
    currentFacetVal = this.$get(facetSlotName);
    if (!TP.equal(currentFacetVal, facetValue)) {

        //  If the internal slot is not defined on the receiver, define it.
        //  Otherwise, TIBET's '$set' method will whine ;-).
        if (TP.notDefined(this[facetSlotName])) {
            this.defineAttribute(facetSlotName);
        }

        //  Use '$set' here along with false to make sure the core '$set' method
        //  does *not* signal change with this internal slot - we do a custom
        //  change signal below.
        this.$set(facetSlotName, facetValue, false);

        if (TP.notValid(sigFlag = shouldSignal)) {
            sigFlag = this.shouldSignalChange();
        }

        if (sigFlag) {

            //  Call facetChanged with all of the appropriate information.
            this.facetChanged(aspectName,
                                facetName,
                                TP.hc(TP.OLDVAL, currentFacetVal,
                                        TP.NEWVAL, facetValue));
        }

        //  Return true because the value of the facet changed.
        return true;
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('setFacet',
function(aspectName, facetName, facetValue, shouldSignal) {

    /**
     * @method setFacet
     * @summary Sets the value of the named facet of the named aspect to the
     *     value provided.
     * @param {String} aspectName The name of the aspect to set.
     * @param {String} facetName The name of the facet to set.
     * @param {Boolean} facetValue The value to set the facet to.
     * @param {Boolean} shouldSignal If false no signaling occurs. Defaults to
     *     this.shouldSignalChange().
     * @returns {Boolean} Whether or not the value was changed from the value it
     *     had before this method was called.
     */

    var funcName;

    //  NB: Do *not* shortstop this by looking for 'setValue' if both aspectName
    //  and facetName are 'value' (in which case the method is computed to be
    //  'setValueValue'). In this case, we really want $setFacet() to be called.

    //  First, check to see if the receiver provides a 'custom setter'
    //  method for this facet/aspect combination. Something like
    //  'setSSNRequired'.
    funcName = 'set' +
                TP.makeStartUpper(aspectName) +
                TP.makeStartUpper(facetName);

    if (TP.canInvoke(this, funcName)) {
        return this[funcName](facetValue);
    } else {
        //  No custom setter implemented - use the standard $setFacet() method.
        return this.$setFacet(aspectName, facetName, facetValue, shouldSignal);
    }
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('setupFacetObservations',
function() {

    /**
     * @method setupFacetObservations
     * @summary Sets up any observations that the facet requires in order to
     *     compute its value.
     * @description Some facets have values like paths, URIs, etc. that point to
     *     sources that can change. These sources need to be observed for change
     *     and, if they do, the facet needs to be set to the new value.
     * @returns {TP.lang.RootObject} The receiver.
     */

    var facetedAspectNames,
        facets,

        aspectsLen,
        i,

        facetsLen,
        j,

        thisType,

        aspectName,
        facetName,

        facetSetting,
        obsFunction;

    facetedAspectNames = this.getFacetedAspectNames();

    //  Default the set of facets to check to TP.FACET_NAMES, which are the list
    //  of standard facets for all TIBET attributes.
    facets = TP.FACET_NAMES;

    aspectsLen = facetedAspectNames.getSize();
    facetsLen = facets.getSize();

    thisType = this.getType();

    //  Iterate over all of the aspects defined for this type of object and all
    //  of the possible facets for it.

    for (i = 0; i < aspectsLen; i++) {

        aspectName = facetedAspectNames.at(i);

        for (j = 0; j < facetsLen; j++) {

            facetName = facets.at(j);

            //  If there is a real setting for the aspect/facet pair, then see
            //  what kind of object it is.
            if (TP.isValid(facetSetting = thisType.getInstFacetSettingFor(
                                            aspectName, facetName))) {

                /* eslint-disable no-loop-func */

                //  Make sure its not a plain object - some descriptors have
                //  nested Object literals and they don't respond to any TIBET
                //  methods.
                if (!TP.isPlainObject(facetSetting)) {

                    //  If its an access path, set up a Function to observe
                    //  ourself and run the path when we change. Then use that
                    //  value to set the facet.
                    if (facetSetting.isAccessPath()) {
                        obsFunction =
                            function(aSignal) {
                                var newVal;

                                newVal = obsFunction.path.executeGet(
                                            obsFunction.source.getPathSource(
                                                            obsFunction.path));
                                this.setFacet(obsFunction.aspectName,
                                                obsFunction.facetName,
                                                newVal,
                                                true);
                            }.bind(this);
                        obsFunction.aspectName = aspectName;
                        obsFunction.facetName = facetName;
                        obsFunction.path = facetSetting;
                        obsFunction.source = this;

                        obsFunction.observe(obsFunction.source, 'ValueChange');
                    } else if (TP.isURI(facetSetting)) {
                        //  Otherwise, if its an access path, set up a Function
                        //  to observe the URI and get that URI's resource
                        //  result when it changes. Then use that value to set
                        //  the facet.
                        obsFunction =
                            function(aSignal) {
                                var newVal;

                                //  NB: We assume 'async' of false here.
                                newVal = obsFunction.source.getResource().
                                                                get('result');
                                this.setFacet(obsFunction.aspectName,
                                                obsFunction.facetName,
                                                newVal,
                                                true);
                            }.bind(this);
                        obsFunction.aspectName = aspectName;
                        obsFunction.facetName = facetName;
                        obsFunction.source = facetSetting;

                        obsFunction.observe(obsFunction.source, 'ValueChange');
                    }

                    if (TP.isCallable(obsFunction)) {
                        //  Add this observation Function to ourself as an
                        //  'observation Function'.
                        this.$addFacetFunction(
                                aspectName, facetName, obsFunction);
                    }
                }
                /* eslint-enable no-loop-func */
            }
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('teardownFacetObservations',
function() {

    /**
     * @method teardownFacetObservations
     * @summary Tears down any observations that the receiver set up for any
     *     facets requiring them in order to compute their value.
     * @description Some facets have values like paths, URIs, etc. that point to
     *     sources that can change. These sources need to be observed for change
     *     and, if they do, the facet needs to be set to the new value. At some
     *     point, these observations need to be undone which is what this method
     *     does.
     * @returns {TP.lang.RootObject} The receiver.
     */

    var facetFunctions;

    //  Iterate over all the facet functions, call ignore on them and then empty
    //  the hash.

    if (TP.notEmpty(facetFunctions = this.$get('$facetFunctions'))) {
        facetFunctions.perform(
            function(kvPair) {
                var func;

                func = kvPair.last();
                func.ignore(func.source, 'ValueChange');

                return this;
            });

        facetFunctions.empty();
    }

    return this;
});

//  ------------------------------------------------------------------------
//  TP.lang.RootObject - INSTANCE CONSTRUCTION
//  ------------------------------------------------------------------------

/*
Primitive support for object/instance creation.
*/

//  whether this type uses a singleton instance, and that instance reference
TP.lang.RootObject.Type.defineAttribute('$$useSingleton', false);
TP.lang.RootObject.Type.defineAttribute('$$singleton', null);

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('$alloc',
function() {

    /**
     * @method $alloc
     * @summary Allocates and returns a new instance but doesn't initialize it.
     *     When the type is defined to allocate a singleton this method
     *     allocates and reuses that object.
     * @returns {Object} A new instance.
     */

    var inst;

    if (this.shouldUseSingleton()) {
        //  If we have a valid singleton, then see if we recycle it. If so,
        //  recycling it will clear the '$$singletonInitialized' flag on the
        //  instance and it will be reinitialized.
        if (TP.isValid(inst = this.$get('$$singleton'))) {
            //  clear the instance of any lingering data first
            if (inst.isRecyclable()) {
                inst.recycle();
            }
        } else {
            inst = new this[TP.INSTC]();

            this.$set('$$singleton', inst);
        }

        return inst;
    }

    return new this[TP.INSTC]();
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('defineDependencies',
function(varargs) {

    /**
     * @method defineDependencies
     * @summary Adds the supplied dependency list to the receiver as a set of
     *     dependencies, such that when packaging computations take place, the
     *     receiver will consider the objects as part of the computation.
     * @param {arguments} varargs One or more objects to add to the receiver as
     *     dependencies for the receiver to function properly in the system.
     * @returns {TP.meta.lang.RootObject} The receiver.
     */

    var args;

    args = Array.prototype.slice.call(arguments, 0);
    args.unshift(this);

    TP.objectDefineDependencies.apply(TP, args);

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('shouldUseSingleton',
function(aFlag) {

    /**
     * @method shouldUseSingleton
     * @summary Combined setter/getter for the instance singleton flag.
     * @param {Boolean} aFlag An optional new flag value to set.
     * @returns {Boolean} The current state of the singleton flag.
     */

    if (TP.isBoolean(aFlag)) {
        this.$set('$$useSingleton', aFlag);
    }

    return this.$get('$$useSingleton');
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('$construct',
function() {

    /**
     * @method $construct
     * @summary Makes a new instance of the receiver by calling the most
     *     primitive constructor and then executing init() on the new instance.
     *     The init() call is then allowed to pass back an optional instance
     *     which, if valid, will be returned to the caller. If not, then the
     *     new instance constructed here will be returned. No abstract check is
     *     done by this method.
     * @returns {Object} A new instance.
     */

    var newinst,
        optinst;

    //  If we can respond to 'initializeLazily', do it.
    if (TP.canInvoke(this, 'initializeLazily')) {
        this.initializeLazily();
    }

    //  use metadata link (to instance constructor) for primitive call
    newinst = this.$alloc();

    newinst[TP.TYPE] = this[TP.TYPE];

    //  initialize the new instance. Notice that the object passed back
    //  does NOT have to be the object passed in. This is critical because
    //  in TIBET's collection classes we often local program an Array or
    //  Object to stand in for what you think is a collection type. Also note
    //  that the $init is a shared internal initializer useful for hidden
    //  initialization that can be leveraged by all instances.
    newinst = newinst.$init.apply(newinst, arguments);
    optinst = newinst.init.apply(newinst, arguments);

    //  if init() returns a non-null object that's our return value.
    //  this lets init() cheat and return an object of its choice
    if (TP.isValid(optinst)) {
        return optinst;
    } else {
        return newinst;
    }
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('construct',
function() {

    /**
     * @method construct
     * @summary Makes a new instance of the receiver by calling the most
     *     primitive constructor and then executing init() on the new instance.
     *     The init() call is then allowed to pass back an optional instance
     *     which, if valid, will be returned to the caller. If not, then the
     *     new instance constructed here will be returned. Note that the
     *     instance returned may actually be an instance of a valid subtype
     *     if the receiver is abstract.
     * @returns {Object} A new instance.
     */

    var newinst,
        optinst;

    //  if the receiver is an abstract type we'll defer creation to the
    //  viaSubtype variant. this allows the remainder of this method to be
    //  inherited and reused by the subtypes themselves.
    if (this.isAbstract()) {
        return this.constructViaSubtype.apply(this, arguments);
    }

    //  If we can respond to 'initializeLazily', do it.
    if (TP.canInvoke(this, 'initializeLazily')) {
        this.initializeLazily();
    }

    //  use metadata link (to instance constructor) for primitive call
    newinst = this.$alloc();

    newinst[TP.TYPE] = this[TP.TYPE];

    //  initialize the new instance. Notice that the object passed back does
    //  NOT have to be the object passed in. This is critical because in TIBET's
    //  collection classes we often local program an Array or Object to stand in
    //  for what you think is a collection type. Also note that the $init is a
    //  shared internal initializer useful for hidden initialization that can be
    //  leveraged by all instances.

    //  Note that if we're configured to have a singleton, the $alloc method
    //  will have handed us back that singleton instance, but it might be the
    //  first time creating it so we check to see if it has a
    //  '$$singletonInited' slot. If not, it hasn't been initialized yet. Stamp
    //  that slot on it and initialize it for the one-and-only time.
    if (this.shouldUseSingleton()) {
        if (!TP.owns(newinst, '$$singletonInitialized')) {
            newinst.defineAttribute('$$singletonInitialized');
            newinst.set('$$singletonInitialized', true);
            newinst = newinst.$init.apply(newinst, arguments);
            optinst = newinst.init.apply(newinst, arguments);
        }
    } else {
        newinst = newinst.$init.apply(newinst, arguments);
        optinst = newinst.init.apply(newinst, arguments);
    }

    //  if init() returns a non-null object that's our return value.
    //  this lets init() cheat and return an object of its choice
    if (TP.isValid(optinst)) {
        return optinst;
    } else {
        return newinst;
    }
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('init',
function() {

    /**
     * @method init
     * @summary Provides instances with an opportunity to initialize. The
     *     default implementation does nothing.
     * @returns {Object} A new instance.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('getRepresentedType',
function() {

    /**
     * @method getRepresentedType
     * @summary Returns a type that this object might be 'representing'. This
     *     is used in places like TIBET's XMLSchema support to return the type
     *     that the element containing the schema is describing to the system.
     *     The default implementation here returns null.
     */

    return null;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('isRecyclable',
function(aFlag) {

    /**
     * @method isRecyclable
     * @summary Returns true if the instance can be recycled.
     * @param {Boolean} aFlag A new setting. Optional.
     * @returns {Boolean} True if the instance can be recycled.
     */

    if (TP.isBoolean(aFlag)) {
        this.$set('recyclable', aFlag);
    }

    return TP.isTrue(this.$get('recyclable'));
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('recycle',
function() {

    /**
     * @method recycle
     * @summary Prepares the receiver for a new usage cycle. This is typically
     *     used in conjunction with types who manage a singlegon instance which
     *     may potentially need to be reused or recycled between usages. By
     *     default this method does nothing, leaving the instance in its
     *     original state.
     * @returns {TP.lang.RootObject} The receiver.
     */

    //  Remove the $$singletonInitialized flag since we're recycling. This will
    //  force the singleton to reinitialize.
    delete this.$$singletonInitialized;

    //  default is a no-op
    return this;
});

//  ------------------------------------------------------------------------
//  TP.lang.RootObject - METHOD DISPATCH
//  ------------------------------------------------------------------------

/*
Inheritance isn't of much value if you have to use copy/paste to reuse
features of a supertype implementation. That's one of the major gaps in the
prototype system as it stands in JS and most other libraries that just paper
over the JS prototype system. In TIBET we provide a number of methods which
support fast lookup and invocation of the "next method". Note that this is
subtlely different from "super method". Due to JS's ability to have "local"
methods which may cover the method on the instance's constructor.prototype
the "next method" may not always be the supertype method. TIBET recognizes
this and finds the proper method regardless of whether you're in a Type
method, instance method, or local method.

*/

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('callNextMethod',
function() {

    /**
     * @method callNextMethod
     * @summary Invokes the next method in the lookup chain. This is somewhat
     *     analogous to a super() call but with the added aspect that an
     *     instance which has been programmed differently from its standard
     *     instance behavior can use this method to skip the specific local
     *     method and invoke the instance method of its type.
     * @returns {Object|undefined} The function's results.
     */

    var theFunction,
        theArgs,

        nextfunc;

    //  there is no "next method" after you reach the top (TP.ObjectProto)
    if (this === TP.ObjectProto) {
        return;
    }

    //  The function we're after will be the current callee. Use the magic
    //  property.
    theFunction = TP.$$currentCallee$$;

    //  We could use this[functionName] but that won't provide a way to avoid
    //  recursions.
    if (TP.notValid(theFunction)) {
        return this.raise('TP.sig.InvalidContext');
    }

    //  If explicit arguments were passed in, use those. Otherwise, use the
    //  magic property that contains the arguments that were in force from the
    //  callee when this method was invoked.
    if (arguments.length > 0) {
        theArgs = arguments;
    } else {
        theArgs = TP.$$currentArgs$$;
    }

    //  Compute the next-most-specific method.
    nextfunc = this.getNextMethod(theFunction);

    if (TP.isValid(nextfunc)) {
        return nextfunc.apply(this, theArgs);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getCurrentCallee',
function() {

    /**
     * @method getCurrentCallee
     * @summary Returns the current callee. The current callee will be the
     *     Function that is currently executing.
     * @returns {Function} The Function that is currently executing.
     */

    //  The current callee can be found on the magic property.
    return TP.$$currentCallee$$;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getNextMethod',
function(aFunction) {

    /**
     * @method getNextMethod
     * @summary Returns the next-most-specific method in the lookup chain.
     * @param {Function} aFunction The function to compute the
     *     next-most-specific from.
     * @returns {Function|undefined} The next-most-specific function.
     */

    var nextfunc,

        functionName,
        functionOwner,
        functionTrack,
        functionParent,

        targetObj,
        symbol;

    //  there is no "next method" after you reach the top (TP.ObjectProto)
    if (this === TP.ObjectProto) {
        return;
    }

    //  We could use this[functionName] but that won't provide a way to avoid
    //  recursions.
    if (TP.notValid(aFunction)) {
        return this.raise('TP.sig.InvalidContext');
    }

    //  If a '$$nextfunc' property has been placed on the Function, that means
    //  that it's either a) already been through here once or b) aFunction
    //  represents a local override of a trait-resolved method and that
    //  '$$nextfunc' was captured in 'defineMethod()'. In either case, we don't
    //  have to compute it here.
    if (aFunction.hasOwnProperty('$$nextfunc')) {
        nextfunc = aFunction.$$nextfunc;
        if (nextfunc === TP.NONE) {
            return;
        }
    }

    if (TP.notValid(nextfunc)) {

        //  Check to make sure that aFunction really has an owner slot. All
        //  objects should, but sometimes we get objects from other contexts
        //  (i.e. frames) that don't know what 'owner' is. in those cases we
        //  can't really proceed
        functionOwner = aFunction[TP.OWNER];
        if (TP.notValid(functionOwner) || functionOwner === self) {
            return;
        }

        //  Figure out which track (type or instance) to follow in locating the
        //  parent implementation. Where we look depends on the nature of the
        //  function and its track.
        functionTrack = aFunction[TP.TRACK];
        switch (functionTrack) {
            case TP.INST_TRACK:
                //  make sure that aFunction's owner really has a parent
                functionParent = functionOwner[TP.SUPER];
                if (TP.notValid(functionParent)) {
                    aFunction.$$nextfunc = TP.NONE;
                    return;
                }

                targetObj = functionParent[TP.INSTC].prototype;

                break;

            case TP.TYPE_TRACK:
                //  make sure that aFunction's owner really has a parent
                functionParent = functionOwner.$$supertype;
                if (TP.notValid(functionParent)) {
                    aFunction.$$nextfunc = TP.NONE;
                    return;
                }

                targetObj = functionParent[TP.TYPEC].prototype;

                break;

            case TP.TYPE_LOCAL_TRACK:
                //  local method on the type itself...
                targetObj = functionOwner[TP.TYPEC].prototype;

                break;

            case TP.LOCAL_TRACK:
                //  local method on an instance
                targetObj = functionOwner.getType()[TP.INSTC].prototype;

                break;

            case TP.GLOBAL_TRACK:
            case TP.PRIMITIVE_TRACK:
                aFunction.$$nextfunc = TP.NONE;
                return;

            default:
                return;
        }

        //  Grab the function name.
        functionName = aFunction.getName();

        //  If the function's 'name' indicates a JS Symbol (i.e. 'Symbol(foo)'),
        //  then try to find a matching Symbol on the target object.
        if (TP.regex.JS_SYMBOL.test(functionName)) {
            symbol = Object.getOwnPropertySymbols(targetObj).find(
                        function(aSymbol) {
                            return aSymbol.toString() === functionName;
                        });
            nextfunc = targetObj[symbol];
        } else {
            nextfunc = targetObj[functionName];
        }

        //  DO NOT RECURSE...NO 'NEXT' FUNCTION
        if (aFunction === nextfunc) {
            aFunction.$$nextfunc = TP.NONE;
            return;
        }

        //  Make sure the computed next function is a callable value. If it
        //  isn't, then mark the '$$nextfunc' property on the receiving Function
        //  as being TP.NONE.
        if (!TP.isCallable(nextfunc)) {
            aFunction.$$nextfunc = TP.NONE;
            return;
        }

        //  Cache result for future lookups.
        aFunction.$$nextfunc = nextfunc;
    }

    return nextfunc;
});

//  ------------------------------------------------------------------------

//  make it available at the instance level as well
TP.lang.RootObject.Inst.defineMethod('callNextMethod',
                        TP.lang.RootObject[TP.TYPEC].prototype.callNextMethod);

//  to avoid problems with native types getting this invoked on them we
// TP.ObjectProto.addLocalMethod('callNextMethod', TP.RETURN_NULL);

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('callNextMethod',
function() {

    /**
     * @method callNextMethod
     * @summary Invokes the next method in the lookup chain. This is somewhat
     *     analogous to a super() call but with the added aspect that an
     *     instance which has been programmed differently from its standard
     *     instance behavior can use this method to skip the specific local
     *     method and invoke the instance method of its type.
     * @returns {Object|undefined} The function's results.
     */

    var theFunction,
        theArgs,

        nextfunc;

    //  there is no "next method" after you reach the top (TP.ObjectProto)
    if (this === TP.ObjectProto) {
        return;
    }

    //  The function we're after will be the current callee. Use the magic
    //  property.
    theFunction = TP.$$currentCallee$$;

    //  We could use this[functionName] but that won't provide a way to avoid
    //  recursions.
    if (TP.notValid(theFunction)) {
        return this.raise('TP.sig.InvalidContext');
    }

    //  If explicit arguments were passed in, use those. Otherwise, use the
    //  magic property that contains the arguments that were in force from the
    //  callee when this method was invoked.
    if (arguments.length > 0) {
        theArgs = arguments;
    } else {
        theArgs = TP.$$currentArgs$$;
    }

    //  Compute the next-most-specific method.
    nextfunc = this.getNextMethod(theFunction);

    if (TP.isValid(nextfunc)) {
        return nextfunc.apply(this, theArgs);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getCurrentCallee',
function() {

    /**
     * @method getCurrentCallee
     * @summary Returns the current callee. The current callee will be the
     *     Function that is currently executing.
     * @returns {Function} The Function that is currently executing.
     */

    //  The current callee can be found on the magic property.
    return TP.$$currentCallee$$;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getNextMethod',
function(aFunction) {

    /**
     * @method getNextMethod
     * @summary Returns the next-most-specific method in the lookup chain.
     * @param {Function} aFunction The function to compute the
     *     next-most-specific from.
     * @returns {Function|undefined} The next-most-specific function.
     */

    var nextfunc,

        functionName,
        functionOwner,
        functionTrack,
        functionParent,

        targetObj,
        symbol;

    //  there is no "next method" after you reach the top (TP.ObjectProto)
    if (this === TP.ObjectProto) {
        return;
    }

    //  We could use this[functionName] but that won't provide a way to avoid
    //  recursions.
    if (TP.notValid(aFunction)) {
        return this.raise('TP.sig.InvalidContext');
    }

    //  If a '$$nextfunc' property has been placed on the Function, that means
    //  that it's either a) already been through here once or b) aFunction
    //  represents a local override of a trait-resolved method and that
    //  '$$nextfunc' was captured in 'defineMethod()'. In either case, we don't
    //  have to compute it here.
    if (aFunction.hasOwnProperty('$$nextfunc')) {
        nextfunc = aFunction.$$nextfunc;
        if (nextfunc === TP.NONE) {
            return;
        }
    }

    if (TP.notValid(nextfunc)) {

        //  Check to make sure that aFunction really has an owner slot. All
        //  objects should, but sometimes we get objects from other contexts
        //  (i.e. frames) that don't know what 'owner' is. in those cases we
        //  can't really proceed
        functionOwner = aFunction[TP.OWNER];
        if (TP.notValid(functionOwner) || functionOwner === self) {
            return;
        }

        //  Figure out which track (type or instance) to follow in locating the
        //  parent implementation. Where we look depends on the nature of the
        //  function and its track.
        functionTrack = aFunction[TP.TRACK];
        switch (functionTrack) {
            case TP.INST_TRACK:
                //  make sure that aFunction's owner really has a parent
                functionParent = functionOwner[TP.SUPER];
                if (TP.notValid(functionParent)) {
                    aFunction.$$nextfunc = TP.NONE;
                    return;
                }

                targetObj = functionParent[TP.INSTC].prototype;

                break;

            case TP.TYPE_TRACK:
                //  make sure that aFunction's owner really has a parent
                functionParent = functionOwner.$$supertype;
                if (TP.notValid(functionParent)) {
                    aFunction.$$nextfunc = TP.NONE;
                    return;
                }

                targetObj = functionParent[TP.TYPEC].prototype;

                break;

            case TP.TYPE_LOCAL_TRACK:
                //  local method on the type itself...
                targetObj = functionOwner[TP.TYPEC].prototype;

                break;

            case TP.LOCAL_TRACK:
                //  local method on an instance
                targetObj = functionOwner.getType()[TP.INSTC].prototype;

                break;

            case TP.GLOBAL_TRACK:
            case TP.PRIMITIVE_TRACK:
                aFunction.$$nextfunc = TP.NONE;
                return;

            default:
                return;
        }

        //  Grab the function name.
        functionName = aFunction.getName();

        //  If the function's 'name' indicates a JS Symbol (i.e. 'Symbol(foo)'),
        //  then try to find a matching Symbol on the target object.
        if (TP.regex.JS_SYMBOL.test(functionName)) {
            symbol = Object.getOwnPropertySymbols(targetObj).find(
                        function(aSymbol) {
                            return aSymbol.toString() === functionName;
                        });
            nextfunc = targetObj[symbol];
        } else {
            nextfunc = targetObj[functionName];
        }

        //  DO NOT RECURSE...NO 'NEXT' FUNCTION
        if (aFunction === nextfunc) {
            aFunction.$$nextfunc = TP.NONE;
            return;
        }

        //  Make sure the computed next function is a callable value. If it
        //  isn't, then mark the '$$nextfunc' property on the receiving Function
        //  as being TP.NONE.
        if (!TP.isCallable(nextfunc)) {
            aFunction.$$nextfunc = TP.NONE;
            return;
        }

        //  Cache result for future lookups.
        aFunction.$$nextfunc = nextfunc;
    }

    return nextfunc;
});

//  ------------------------------------------------------------------------
//  TP.lang.RootObject - METHOD SPECIALIZATION
//  ------------------------------------------------------------------------

/*
TIBET makes heavy use of a pattern in which a root method is invoked and the
actual functionality is provided by a variant of that method specialized on
the type of the first argument. This pattern can be seen in the methods: as,
from, is, validate, handle, etc.
*/

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('callBestMethod',
function(callingContext, anObject, aPrefix, aSuffix, aFallback, anArgArray) {

    /**
     * @method callBestMethod
     * @summary Finds and invokes the best method possible which begins with
     *     the common prefix provided. The match is based on the type of
     *     anObject, with the most specific type first. For example, a call of:
     *         this.callBestMethod(
     *              arguments, myString, 'from', '', 'fromObject');
     *     will try to invoke this.fromString, then this.fromObject.
     * @param {arguments} callingContext The arguments object of the calling
     *     context.
     * @param {Object} anObject The object to specialize on.
     * @param {String} aPrefix The method prefix to use. No default, must exist.
     * @param {String} aSuffix The method suffix to use. Defaults to ''.
     * @param {String} aFallback A method name to call in its exact form should
     *     no other method be found. No default, just returns without fallback.
     * @param {Object[]|arguments} anArgArray An optional argument list. Not
     *     required in most cases since that data is available from
     *         callingContext. Only used when the original arguments should be
     *         altered for the call.
     * @returns {Object|undefined} The result of invoking the method found.
     */

    var name,
        args;

    name = this.getBestMethodName(callingContext, anObject, aPrefix, aSuffix,
                                    aFallback, anArgArray);

    if (TP.isEmpty(name)) {
        return;
    }

    args = TP.args(anArgArray || callingContext);

    return this[name].apply(this, args);
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getBestMethod',
function(callingContext, anObject, aPrefix, aSuffix, aFallback, anArgArray) {

    /**
     * @method getBestMethod
     * @summary Finds the best method possible which begins with the common
     *     prefix provided. The match is based on the type of anObject, with the
     *     most specific type first. See 'callBestMethod' for an example.
     * @param {arguments} callingContext The arguments object of the calling
     *     context.
     * @param {Object} anObject The object to specialize on.
     * @param {String} aPrefix The method prefix to use. No default, must exist.
     * @param {String} aSuffix The method suffix to use. Defaults to ''.
     * @param {String} aFallback A method name to call in its exact form should
     *     no other method be found. No default, just returns without fallback.
     * @param {Object[]|arguments} anArgArray An optional argument list. Not
     *     required in most cases since that data is available from
     *     callingContext. Only used when the original arguments should be
     *     altered for the call.
     * @returns {Function|undefined} The method found or undefined.
     */

    var name;

    name = this.getBestMethodName(callingContext, anObject, aPrefix, aSuffix,
                                    aFallback, anArgArray);

    if (TP.notEmpty(name)) {
        return this[name];
    }

    return;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getBestMethodName',
function(callingContext, anObject, aPrefix, aSuffix, aFallback, anArgArray) {

    /**
     * @method getBestMethodName
     * @summary Finds the best method name possible which begins with the
     *     common prefix provided. The match is based on the type of anObject,
     *     with the most specific type first. For example, a call of
     *     this.getBestMethodName(arguments, myString, 'from'); will try to find
     *     this.fromString, then this.fromObject.
     * @param {arguments} callingContext The arguments object of the calling
     *     context.
     * @param {Object} anObject The object to specialize on.
     * @param {String} aPrefix The method prefix to use. No default, must exist.
     * @param {String} aSuffix The method suffix to use. Defaults to ''.
     * @param {String} aFallback A method name to call in its exact form should
     *     no other method be found. No default, just returns without fallback.
     * @param {Object[]|arguments} anArgArray An optional argument list. Not
     *     required in most cases since that data is available from
     *     callingContext. Only used when the original arguments should be
     *     altered for the call.
     * @returns {String|undefined} The method name found, or null.
     */

    var prefix,
        name,
        suffix,
        supers,
        len,
        i,
        sname;

    //  there is no "best method" after you reach the top (TP.ObjectProto)
    if (this === TP.ObjectProto) {
        return;
    }

    prefix = aPrefix;
    suffix = aSuffix || '';

    if (TP.isNull(anObject)) {
        name = prefix + 'Null' + suffix;

        if (TP.canInvoke(this, name)) {
            return name;
        } else if (TP.canInvoke(this, aFallback)) {
            return aFallback;
        } else {
            return;
        }
    } else if (TP.notDefined(anObject)) {
        name = prefix + 'Undefined' + suffix;

        if (TP.canInvoke(this, name)) {
            return name;
        } else if (TP.canInvoke(this, aFallback)) {
            return aFallback;
        } else {
            return;
        }
    } else {
        if (TP.isType(anObject)) {
            name = prefix +
                    TP.escapeTypeName(TP.tname(anObject)) +
                    TP.TYPE_TRACK + suffix;
        } else {
            name = prefix +
                    TP.escapeTypeName(TP.tname(anObject)) +
                    suffix;
        }

        if (TP.canInvoke(this, name)) {
            return name;
        }

        //  going to have to dig a little deeper, but we have to watch out
        //  for certain native object types or we'll run into problems
        if (TP.notValid(anObject)) {
            name = TP.str(anObject).toUpperCase();
        } else if (TP.isEvent(anObject)) {
            name = prefix + 'Event' + suffix;
        } else if (TP.isError(anObject)) {
            name = prefix + 'Error' + suffix;
        } else if (TP.isNode(anObject)) {
            switch (anObject.nodeType) {
                case Node.DOCUMENT_NODE:

                    name = prefix + 'Document' + suffix;
                    break;

                case Node.ELEMENT_NODE:

                    name = prefix + 'Element' + suffix;
                    break;

                case Node.ATTRIBUTE_NODE:

                    name = prefix + 'Attribute' + suffix;
                    break;

                default:

                    name = prefix + 'Node' + suffix;
                    break;
            }

            //  for nodes we'll do two checks, one for the specific node
            //  type, then one for generic 'Node'
            if (TP.canInvoke(this, name)) {
                return name;
            }

            name = prefix + 'Node' + suffix;
        } else if (TP.isNodeList(anObject)) {
            name = prefix + 'NodeList' + suffix;
        } else if (TP.isNamedNodeMap(anObject)) {
            name = prefix + 'NamedNodeMap' + suffix;
        } else if (TP.isWindow(anObject)) {
            name = prefix + 'Window' + suffix;
        } else if (TP.isNativeType(TP.type(anObject))) {
            //  already checked type name earlier, all that's left is Object
            name = prefix + 'Object' + suffix;
        } else if (TP.isType(anObject)) {
            name = prefix + 'NativeType' + suffix;
        } else if (TP.isStyleDeclaration(anObject)) {
            name = prefix + 'CSSStyleDeclaration' + suffix;
        } else if (TP.isStyleRule(anObject)) {
            name = prefix + 'CSSStyleRule' + suffix;
        } else if (TP.isStyleSheet(anObject)) {
            name = prefix + 'CSSStyleSheet' + suffix;
        } else if (TP.isXHR(anObject)) {
            name = prefix + 'XHR' + suffix;
        } else if (TP.canInvoke(anObject, 'getSupertypeNames')) {
            //  here's where the real specialization power comes in by
            //  checking up the TIBET inheritance chain for a best-fit
            //  method based on the supertypes of the object
            supers = anObject.getSupertypeNames();

            len = supers.getSize();
            for (i = 0; i < len; i++) {
                sname = TP.escapeTypeName(supers.at(i));
                name = prefix + sname + suffix;
                if (TP.canInvoke(this, name)) {
                    return name;
                }
            }
        }
    }

    if (!TP.canInvoke(this, name)) {
        if (TP.isString(aFallback) &&
            aFallback !== name &&
            TP.canInvoke(this, aFallback)) {
            return aFallback;
        }
    } else {
        return name;
    }

    return;
});

//  ------------------------------------------------------------------------
//  TP.lang.RootObject - REFLECTION
//  ------------------------------------------------------------------------

/*
Continued expansion of our support for reflection.
*/

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getConstructor',
function() {

    /**
     * @method getConstructor
     * @summary Returns the true constructor for an instance.
     * @returns {Object}
     */

    if (this === TP.lang.RootObject$$Type.prototype) {
        return Function;
    }

    return TP.lang.RootObject$$Type;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getName',
function() {

    /**
     * @method getName
     * @summary Returns the type name of the receiver.
     * @returns {String}
     */

    var name;

    if (TP.owns(this, 'name')) {
        return this.name;
    }

    if (TP.notValid(name = this[TP.NAME])) {
        return this.getID();
    }

    return name;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getSupertype',
function() {

    /**
     * @method getSupertype
     * @summary Returns the supertype of the receiver. Returns undefined if the
           receiver is a root type.
     * @returns {Object} The supertype of the receiver.
     */

    return this[TP.SUPER];
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getSupertypeName',
function() {

    /**
     * @method getSupertypeName
     * @summary Returns the supertype name of the receiver.
     * @returns {String} The supertype name of the receiver.
     */

    return this[TP.SUPER].getName();
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getSupertypeNames',
function() {

    /**
     * @method getSupertypeNames
     * @summary Returns an array containing the supertype names of the
     *     receiver. You should consider this array private and avoid
     *     manipulating it. The first element in this array is the name of the
     *     immediate supertype of the receiver.
     * @returns {String[]} An array of supertype names.
     */

    var arr,
        type;

    arr = this[TP.ANCESTOR_NAMES];
    if (TP.isValid(arr)) {
        return arr;
    }

    arr = TP.ac();

    /* eslint-disable consistent-this */

    type = this;
    /* eslint-disable no-cond-assign */
    while (type = type[TP.SUPER]) {
        arr.push(type.getName());
    }
    /* eslint-enable no-cond-assign */

    this[TP.ANCESTOR_NAMES] = arr;

    /* eslint-enable consistent-this */

    return arr;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getType',
function() {

    /**
     * @method getType
     * @summary Returns the type object for the receiver. In this case we're
     *     talking about a TIBET type so we can leverage the meta-data. Normally
     *     if you ask an instance for its type the answer is clear. In TIBET
     *     since all Type objects are actually instances the response to this
     *     question is an internal constructor function you probably didn't want
     *     to see :).
     * @returns {Object}
     */

    return this[TP.TYPEC];
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getTypeName',
function() {

    /**
     * @method getTypeName
     * @summary Returns the type name of the receiver. This method is a synonym
     *     for getName() for types.
     * @returns {String}
     */

    var owner,
        str;

    /* eslint-disable consistent-this */
    if (TP.isPrototype(this)) {
        owner = this[TP.OWNER];
        if (!TP.isType(owner)) {
            TP.ifError() ?
                TP.error('Invalid prototype: ' + TP.id(this)) : 0;
            return null;
        }
    } else {
        owner = this;
    }
    /* eslint-enable consistent-this */

    str = owner.getNamespaceRoot() + '.meta.' +
            owner.getNamespacePrefix() + '.' + owner.getLocalName();

    return str;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getTypes',
function() {

    /**
     * @method getTypes
     * @summary Returns an array containing the type and supertype objects of
     *     the receiver. The first element in this array is the type of the
     *     receiver.
     * @returns {TP.meta.lang.RootObject[]} The type and supertype objects of
     *     the receiver.
     */

    var types;

    //  Make sure to copy the supertype name array.
    types = this.getSupertypes().copy();

    //  Since the receiver is a type object and is the most specific type,
    //  it gets unshifted onto the front of the result.
    types.unshift(this);

    return types;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('$$isReferenceType',
function() {

    /**
     * @method $$isReferenceType
     * @summary Returns true if the receiver is a reference type meaning it
     *     doesn't support copy-on-write semantics. TP*Objects are all reference
     *     types.
     * @returns {Boolean}
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('isInitialized',
function(aFlag) {

    /**
     * @method isInitialized
     * @summary Returns true if the receiver has been initialized. Most types
     *     don't require initialization but those that do need to protect
     *     against having it done more than once :).
     * @param {Boolean} aFlag The new state of the initialized flag.
     * @returns {Boolean}
     */

    if (TP.isBoolean(aFlag)) {
        this.$set('$$initialized', aFlag);
    }

    return TP.ifInvalid(this.$get('$$initialized'), false);
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('ownsMethod',
function(aName) {

    /**
     * @method ownsMethod
     * @summary Returns true if the name represents a unique method on the
     *     receiver, one that is either introduced or overridden so that the
     *     method is "owned" by the receiver.
     * @param {String} aName The method name to check.
     * @returns {Boolean}
     */

    if (TP.sys.hasInitialized() && TP.isMethod(this[aName])) {
        return this[aName][TP.OWNER] === this;
    }

    return false;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('getConstructor',
function() {

    /**
     * @method getConstructor
     * @summary Returns the true constructor for an instance.
     * @returns {Object}
     */

    if (this === TP.lang.RootObject$$Inst) {
        return Function;
    }

    return TP.lang.RootObject$$Inst;
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('getLocalName',
function() {

    /**
     * @method getLocalName
     * @summary Returns the local (aka short) name of the receiver without any
     *     namespace prefix.
     * @returns {String}
     */

    return this.getType().getLocalName();
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('getNamespacePrefix',
function() {

    /**
     * @method getNamespacePrefix
     * @summary Returns the namespace (in TIBET terms) of the receiver. For
     *     example, the namespace of the TP.sig.Signal type is 'sig'.
     * @returns {String} The receiver's namespace.
     */

    return this.getType().getNamespacePrefix();
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('getType',
function() {

    /**
     * @method getType
     * @summary Returns the type object for the receiver. In this case we're
     *     talking about a TIBET type so we can leverage the meta-data. Normally
     *     if you ask an instance for its type the answer is clear. In TIBET
     *     since all Type objects are actually instances the response to this
     *     question is an internal constructor function you probably didn't want
     *     to see :).
     * @returns {Object}
     */

    return this[TP.TYPE];
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('getTypeName',
function() {

    /**
     * @method getTypeName
     * @summary Returns the type name of the receiver. This method is a synonym
     *     for getType().getName() for instances.
     * @returns {String}
     */

    //  hook the top-level prototype so we don't say it's a
    //  TP.lang.RootObject
    if (this === TP.lang.RootObject$$Inst.prototype) {
        return this.getID();
    }

    return this.getType().getName();
});

//  ------------------------------------------------------------------------
//  TIBET Methods
//  ------------------------------------------------------------------------

TP.sys.defineMethod('getTypeInitializers',
function() {

    /**
     * @method getTypeInitializers
     * @summary Returns an array of functions which will properly initialize
     *     the various types in the system.
     * @returns {Function[]}
     */

    var own,
        thisref;

    //  Grab all of the objects that *own* an implementation of initialize.

    //  NOTE the names-only flag here to keep things from loading
    own = TP.sys.getMethodOwners('initialize', true);

    TP.boot.$stdout('Preparing to initialize: ' + own.getValues().join('\n'),
        TP.TRACE);

    thisref = this;

    if (TP.isValid(own)) {

        //  Loop over each one of those owners (each of which should be a
        //  type), and if it hasn't already been initialized, send it an
        //  initialize message and set its initialized flag to true.
        return own.map(

            function(item, index) {

                return function() {

                    var obj;

                    obj = TP.sys.getTypeByName(item, false);

                    //  proxies for types aren't installed yet...
                    if (TP.notValid(obj) ||
                        !TP.canInvoke(obj, 'isInitialized')) {
                        //  don't want to force type into the codebase unless we
                        //  have to...certainly not just because it has an
                        //  initializer... so just return
                        return;
                    }

                    //  Trap type initialization errors and report them.
                    try {
                        if (obj.isInitialized()) {
                            TP.boot.$stdout(
                            'Skipping initialized type: ' + item,
                            TP.DEBUG);

                            return;
                        }

                        //  for debugging it's helpful to see what's
                        //  being initialized in particular
                        TP.boot.$stdout('Initializing type: ' + item, TP.DEBUG);

                        obj.initialize();
                        obj.isInitialized(true);
                    } catch (e) {
                        thisref.raise(
                            'TP.sig.InitializationException',
                            TP.ec(e, 'Unable to initialize: ' + obj.getName()));
                    }
                };
            });
    }

    return TP.ac();
});

//  ------------------------------------------------------------------------

TP.registerLoadInfo(TP.lang.RootObject$$Type.prototype);
TP.registerLoadInfo(TP.lang.RootObject$$Inst.prototype);

TP.sys.addMetadata(null, TP.lang.RootObject, TP.SUBTYPE);

//  ------------------------------------------------------------------------
//  TP.lang.RootObject - REFLECTION (INTERNAL)
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('getInstPrototype',
function() {

    /**
     * @method getInstPrototype
     * @summary Returns the object which instances of the receiver use as their
     *     prototype.
     * @returns {Object}
     */

    //  TODO: Scott: Fix this when defineSubtype() fix is in.
    if (TP.isValid(this[TP.INSTC])) {
        return this[TP.INSTC].prototype;
    }

    return Object.getPrototypeOf(this);
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('getPrototype',
function() {

    /**
     * @method getPrototype
     * @summary Returns the object the receiver uses as its prototype.
     * @returns {Object}
     */

    return this.getType().getInstPrototype();
});

//  ------------------------------------------------------------------------
//  TP.ObjectProto Methods
//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getPrototypes',
function() {

    /**
     * @method getPrototypes
     * @summary Returns an array containing the various objects which affect
     *     inheritance for the receiver via the prototype chain.
     * @returns {Object[]} The objects making up the prototype chain of the
     *     receiver.
     */

    var proto,
        protos;

    protos = TP.ac();

    //  top of the tree, no prototypes to add
    if (this === TP.ObjectProto) {
        return protos;
    }

    /* eslint-disable consistent-this */
    proto = this;
    /* eslint-enable consistent-this */

    //  watch for circularities on the native types
    while (proto !== TP.ObjectProto &&
            proto !== proto.constructor.prototype) {
        proto = proto.getPrototype();
        protos.add(proto);
    }

    return protos;
});

//  ------------------------------------------------------------------------
//  METHOD ACQUISITION
//  ------------------------------------------------------------------------

TP.definePrimitive('method',
function(aTarget, name, aTrack) {

    /**
     * @method method
     * @summary Returns the named method on the target, if it exists. Note that
     *     none of the parameters are defaulted. To get default values use the
     *     getMethod() method on the target object which ultimately relies on
     *     this call.
     * @param {Object} aTarget The object to try to locate the method on.
     * @param {String} name The method name to locate.
     * @param {String} aTrack The track to locate the method on.
     * @returns {Function|undefined} The Function object representing the
     *     method.
     */

    var method;

    method = aTarget[name];
    if (TP.isMethod(method)) {
        if (TP.notEmpty(aTrack) && method[TP.TRACK] === aTrack) {
            return method;
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('methodByDisplayName',
function(aDisplayName) {

    /**
     * @method methodByDisplayName
     * @summary Returns the method whose display name matches the supplied name.
     *     This value should be something like 'TP.Primitive.json' for primitive
     *     methods or 'TP.lang.RootObject.Inst.$addFacetFunction' for
     *     non-primitive methods.
     * @param {String} aDisplayName The display name of the method to locate.
     * @returns {Function} The Function object representing the method.
     */

    var nameParts,

        rootNamespace,
        namespace,

        methodName,
        methodObj,

        ownerType,
        ownerTrack;

    //  The display name will be something like 'TP.Primitive.json' for
    //  primitive methods or 'TP.lang.RootObject.Inst.$addFacetFunction' for
    //  methods associated with a type.

    //  Split the name up into component parts
    nameParts = aDisplayName.split('.');

    //  If the second part is the ID of one of our 'special' objects, then we
    //  have to use them to obtain the method
    if (nameParts.at(1) === TP.META_INST_OWNER.getID()) {
        return TP.META_INST_OWNER.getMethod(nameParts.at(2));
    }

    if (nameParts.at(1) === TP.META_TYPE_OWNER.getID()) {
        return TP.META_TYPE_OWNER.getMethod(nameParts.at(2));
    }

    //  To start we need a valid root namespace
    rootNamespace = TP.global[nameParts.at(0)];
    if (TP.notValid(rootNamespace)) {
        return null;
    }

    //  Then an organizing namespace within that root
    namespace = rootNamespace[nameParts.at(1)];
    if (TP.notValid(namespace)) {
        return null;
    }

    methodObj = null;

    //  If the organizing namespace is TP.PRIMITIVE_TRACK, then it's really the
    //  track for a method that's a primitive method.
    if (namespace === TP.PRIMITIVE_TRACK) {
        methodName = nameParts.at(2);
        methodObj = rootNamespace[methodName];
    } else {

        //  Otherwise, the owning type can be computed.
        ownerType = namespace[nameParts.at(2)];
        if (!TP.isType(ownerType)) {
            return this;
        }

        ownerTrack = nameParts.at(3);
        methodName = nameParts.at(4);
        methodObj = ownerType.getMethod(methodName, ownerTrack);
    }

    return methodObj;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('methods',
function(aTarget, aTrack) {

    /**
     * @method methods
     * @summary Returns the Array of methods on the target. The list of methods
     *     is the result of getting the 'known_methods' interface on the
     *     supplied target.
     * @param {Object} aTarget The object to try to locate the methods on.
     * @param {String} aTrack The track to locate the method on.
     * @returns {Function[]} An Array of Function objects representing the
     *     methods.
     */

    var target,

        names,
        methods;

    target = aTarget;

    if (TP.isType(target)) {
        if (aTrack === TP.TYPE_TRACK) {
            target = target.getPrototype();
        } else if (aTrack === TP.INST_TRACK) {
            target = target.getInstPrototype();
        }
    }

    //  NB: We go after all 'known_methods', including private ones, and up the
    //  prototype chain.
    names = TP.interface(target, 'known_methods');

    methods = names.map(
                function(name) {

                    var method;

                    method = target[name];
                    if (TP.isMethod(method)) {
                        return method;
                    }

                    return null;
                });

    return methods.compact();
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getMethod',
function(aName, aTrack) {

    /**
     * @method getMethod
     * @summary Returns the named method, if it exists.
     * @param {String} aName The method name to locate.
     * @param {String} aTrack The track to locate the method on. This is an
     *     optional parameter.
     * @returns {Function} The Function object representing the method.
     */

    var target,
        track,

        owner;

    /* eslint-disable consistent-this */
    target = this;
    /* eslint-enable consistent-this */
    track = aTrack;

    //  If this is a type, then we check the track to determine the target
    if (TP.isType(target)) {
        if (aTrack === TP.TYPE_TRACK) {
            target = target.getPrototype();
        } else if (aTrack === TP.INST_TRACK) {
            target = target.getInstPrototype();
        } else {
            //  It's a type - the default track is TP.TYPE_LOCAL_TRACK
            track = TP.TYPE_LOCAL_TRACK;
        }
    } else if (TP.isPrototype(target) && TP.isEmpty(track)) {
        owner = target[TP.OWNER];
        if (!TP.isType(owner)) {
            TP.ifError() ?
                TP.error('Invalid prototype: ' + TP.id(target)) : 0;
            return null;
        }

        if (owner.getPrototype() === target) {
            track = TP.TYPE_TRACK;
        } else if (owner.getInstPrototype() === target) {
            track = TP.INST_TRACK;
        } else {
            track = TP.LOCAL_TRACK;
        }
    } else if (TP.isEmpty(track)) {
        //  It's a plain instance - the default track is TP.LOCAL_TRACK
        track = TP.LOCAL_TRACK;
    }

    return TP.method(target, aName, track);
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getMethods',
function(aTrack) {

    /**
     * @method getMethods
     * @summary Returns an Array of methods for the receiver.
     * @param {String} aTrack The track to locate the methods on. This is an
     *     optional parameter.
     * @returns {Function[]} An Array of Function objects representing the
     *     methods.
     */

    var target,
        track,

        owner;

    /* eslint-disable consistent-this */
    target = this;
    /* eslint-enable consistent-this */
    track = aTrack;

    //  If this is a type, then we check the track to determine the target
    if (TP.isType(target)) {
        if (aTrack === TP.TYPE_TRACK) {
            target = target.getPrototype();
        } else if (aTrack === TP.INST_TRACK) {
            target = target.getInstPrototype();
        } else {
            //  It's a type - the default track is TP.TYPE_LOCAL_TRACK
            track = TP.TYPE_LOCAL_TRACK;
        }
    } else if (TP.isPrototype(target) && TP.isEmpty(track)) {
        owner = target[TP.OWNER];
        if (!TP.isType(owner)) {
            TP.ifError() ?
                TP.error('Invalid prototype: ' + TP.id(target)) : 0;
            return null;
        }

        if (owner.getPrototype() === target) {
            track = TP.TYPE_TRACK;
        } else if (owner.getInstPrototype() === target) {
            track = TP.INST_TRACK;
        } else {
            track = TP.LOCAL_TRACK;
        }
    } else if (TP.isEmpty(track)) {
        //  It's a plain instance - the default track is TP.LOCAL_TRACK
        track = TP.LOCAL_TRACK;
    }

    return TP.methods(target, track);
});

//  ------------------------------------------------------------------------

TP.FunctionProto.defineMethod('getMethod',
function(aName, aTrack) {

    /**
     * @method getMethod
     * @summary Returns the named method, if it exists.
     * @param {String} aName The method name to locate.
     * @param {String} aTrack The track to locate the method on. This is an
     *     optional parameter.
     * @returns {Function} The Function object representing the method.
     */

    var target,
        track,

        method;

    /* eslint-disable consistent-this */
    target = this;
    /* eslint-enable consistent-this */
    track = aTrack;

    //  If it's the TP.FunctionProto *directly* then we consider an instance
    //  method of all Function objects.
    if (this === TP.FunctionProto) {
        target = Function;
        track = TP.ifEmpty(aTrack, TP.INST_TRACK);
    } else if (TP.isType(this)) {

        if (aTrack === TP.INST_TRACK) {
            target = target.getInstPrototype();
        } else {

            //  Track wasn't the TP.INST_TRACK

            //  Types can be tricky, particularly in terms of defaulting whether
            //  something was added as a type method or a type local method. We
            //  check both options here, preferring type methods over type
            //  local methods.

            track = TP.TYPE_TRACK;
            method = TP.method(target, aName, track);
            if (TP.isValid(method)) {
                return method;
            }

            track = TP.TYPE_LOCAL_TRACK;
        }
    } else {
        //  Otherwise, it can be considered to be a 'local' method of the
        //  receiving Function object (which is usually a plain, anonymous
        //  Function).
        track = TP.ifEmpty(aTrack, TP.LOCAL_TRACK);
    }

    return TP.method(target, aName, track);
});

//  ------------------------------------------------------------------------

TP.FunctionProto.defineMethod('getMethods',
function(aTrack) {

    /**
     * @method getMethods
     * @summary Returns an Array of methods for the receiver.
     * @param {String} aTrack The track to locate the methods on. This is an
     *     optional parameter.
     * @returns {Function[]} An Array of Function objects representing the
     *     methods.
     */

    var target,
        track,
        methods;

    /* eslint-disable consistent-this */
    target = this;
    /* eslint-enable consistent-this */
    track = aTrack;

    //  If it's the TP.FunctionProto *directly* then we consider an instance
    //  method of all Function objects.
    if (this === TP.FunctionProto) {
        target = Function;
        track = TP.ifEmpty(aTrack, TP.INST_TRACK);
    } else if (TP.isType(this)) {

        if (aTrack === TP.INST_TRACK) {
            target = target.getInstPrototype();
        } else {

            //  Track wasn't the TP.INST_TRACK

            //  Types can be tricky, particularly in terms of defaulting whether
            //  something was added as a type method or a type local method. We
            //  check both options here, preferring type methods over type
            //  local methods.

            track = TP.TYPE_TRACK;
            methods = TP.methods(target, track);

            if (TP.isEmpty(methods)) {
                track = TP.TYPE_LOCAL_TRACK;
                methods = TP.methods(target, track);
            }

            return methods;
        }
    } else {
        //  Otherwise, it can be considered to be a 'local' method of the
        //  receiving Function object (which is usually a plain, anonymous
        //  Function).
        track = TP.ifEmpty(aTrack, TP.LOCAL_TRACK);
    }

    return TP.methods(target, track);
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('getMethodInfoFor',
function(aName, aTrack) {

    /**
     * @method getMethodInfoFor
     * @summary Returns information for the method with the supplied name on
     *     the receiver.
     * @description This method returns a TP.core.Hash containing the method
     *     owner, name, track and display, under the keys 'owner', 'name',
     *     'track' and 'display', respectively
     * @param {String} aName The method name to return information for.
     * @param {String} aTrack The track to locate the method on. This is an
     *     optional parameter.
     * @returns {TP.core.Hash} The hash containing the method information as
     *     described in the method comment.
     */

    var target,
        track,

        owner,
        method,

        name,
        display;

    /* eslint-disable consistent-this */
    target = this;
    owner = this;
    /* eslint-enable consistent-this */
    track = aTrack;

    //  If this is a type, then we check the track to determine the target
    if (TP.isType(target)) {
        if (aTrack === TP.TYPE_TRACK) {
            target = target.getPrototype();
        } else if (aTrack === TP.INST_TRACK) {
            target = target.getInstPrototype();
        } else {
            //  It's a type - the default track is TP.TYPE_LOCAL_TRACK
            track = TP.TYPE_LOCAL_TRACK;
        }
    } else if (TP.isPrototype(target) && TP.isEmpty(track)) {
        owner = target[TP.OWNER];
        if (!TP.isType(owner)) {
            TP.ifError() ?
                TP.error('Invalid prototype: ' + TP.id(target)) : 0;
            return null;
        }

        if (owner.getPrototype() === target) {
            track = TP.TYPE_TRACK;
        } else if (owner.getInstPrototype() === target) {
            track = TP.INST_TRACK;
        } else {
            track = TP.LOCAL_TRACK;
        }
    } else if (TP.isEmpty(track)) {
        //  It's a plain instance - the default track is TP.LOCAL_TRACK
        track = TP.LOCAL_TRACK;
    }

    if (!TP.isMethod(method = target.getMethod(aName, track))) {
        return null;
    }

    name = method[TP.NAME];
    display = method[TP.DISPLAY];

    return TP.hc('owner', owner,
                    'name', name,
                    'track', track,
                    'display', display);
});

//  ------------------------------------------------------------------------

TP.FunctionProto.defineMethod('getMethodInfoFor',
function(aName, aTrack) {

    /**
     * @method getMethodInfoFor
     * @summary Returns information for the method with the supplied name on
     *     the receiver.
     * @description This method returns a TP.core.Hash containing the method
     *     owner, name, track and display, under the keys 'owner', 'name',
     *     'track' and 'display', respectively
     * @param {String} aName The method name to return information for.
     * @param {String} aTrack The track to locate the method on. This is an
     *     optional parameter.
     * @returns {TP.core.Hash} The hash containing the method information as
     *     described in the method comment.
     */

    var target,
        track,

        owner,
        method,

        name,
        display;

    /* eslint-disable consistent-this */
    target = this;
    owner = this;
    /* eslint-enable consistent-this */
    track = aTrack;

    //  If it's the TP.FunctionProto *directly* then we consider an instance
    //  method of all Function objects.
    if (this === TP.FunctionProto) {
        target = Function;
        track = TP.ifEmpty(aTrack, TP.INST_TRACK);
    } else if (TP.isType(this)) {

        if (aTrack === TP.INST_TRACK) {
            target = target.getInstPrototype();
        } else {

            //  Track wasn't the TP.INST_TRACK

            //  Types can be tricky, particularly in terms of defaulting whether
            //  something was added as a type method or a type local method. We
            //  check both options here, preferring type methods over type
            //  locals.

            track = TP.TYPE_TRACK;
            method = TP.method(target, aName, track);
            if (TP.notValid(method)) {
                track = TP.TYPE_LOCAL_TRACK;
            }
        }
    } else {
        //  Otherwise, it can be considered to be a 'local' method of the
        //  receiving Function object (which is usually a plain, anonymous
        //  Function).
        track = TP.ifEmpty(aTrack, TP.LOCAL_TRACK);
    }

    if (!TP.isMethod(method = target.getMethod(aName, track))) {
        return null;
    }

    name = method[TP.NAME];
    display = method[TP.DISPLAY];

    return TP.hc('owner', owner,
                    'name', name,
                    'track', track,
                    'display', display);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isGlobalMethod',
function(anObj) {

    /**
     * @method isGlobalMethod
     * @summary Returns true if the object provided is a global method.
     * @param {Object} anObj The Object to test.
     * @returns {Boolean}
     */

    /* eslint-disable no-extra-parens */
    return (TP.isValid(anObj[TP.OWNER]) && anObj[TP.TRACK] === TP.GLOBAL_TRACK);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isInstMethod',
function(anObj) {

    /**
     * @method isInstMethod
     * @summary Returns true if the object provided is an instance method
     *     relative to a particular type.
     * @param {Object} anObj The Object to test.
     * @returns {Boolean}
     */

    /* eslint-disable no-extra-parens */
    return (TP.isValid(anObj[TP.OWNER]) && anObj[TP.TRACK] === TP.INST_TRACK);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isLocalMethod',
function(anObj) {

    /**
     * @method isLocalMethod
     * @summary Returns true if the object provided is a local method relative
     *     to a particular object.
     * @param {Object} anObj The Object to test.
     * @returns {Boolean}
     */

    var owner,
        track;

    owner = anObj[TP.OWNER];
    track = anObj[TP.TRACK];

    /* eslint-disable no-extra-parens */
    return (TP.isValid(owner) &&
             track === TP.TYPE_LOCAL_TRACK || track === TP.LOCAL_TRACK);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('isTypeMethod',
function(anObj) {

    /**
     * @method isTypeMethod
     * @summary Returns true if the object provided is a type method relative
     *     to a particular type.
     * @param {Object} anObj The Object to test.
     * @returns {Boolean}
     */

    /* eslint-disable no-extra-parens */
    return (TP.isValid(anObj[TP.OWNER]) && anObj[TP.TRACK] === TP.TYPE_TRACK);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------
//  TP.lang.Object
//  ------------------------------------------------------------------------

/*
All standard objects should inherit from TP.lang.Object rather than
TP.lang.RootObject.
*/

//  ------------------------------------------------------------------------

TP.lang.RootObject.defineSubtype('Object');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.lang.Object.Type.defineMethod('fromObject',
function(anObj) {

    /**
     * @method fromObject
     * @summary Constructs a new instance from the incoming object. The default
     *     implementation forwards to construct.
     * @param {Object} anObj The source object.
     * @returns {Object} A new instance of the receiver.
     */

    var newObj,

        keys,

        len,
        i,

        name;

    newObj = this.construct.apply(this, arguments);

    //  If the object we're converting from is a POJO, then copy over all of its
    //  values as attributes on the new object.
    if (TP.isPlainObject(anObj)) {
        keys = TP.keys(anObj);

        len = keys.getSize();
        for (i = 0; i < len; i++) {
            name = keys.at(i);
            newObj.defineAttribute(name);
            newObj.set(name, anObj[name]);
        }
    }

    return newObj;
});

//  ------------------------------------------------------------------------

TP.lang.Object.Type.defineMethod('getConstructor',
function() {

    /**
     * @method getConstructor
     * @summary Returns the receivers constructor.
     * @returns {Object}
     */

    return this.getSupertype()[TP.TYPEC];
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.lang.Object.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a TIBET source code string.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    var marker,
        str,
        keys;

    //  Avoid recursions on TP object at this level.
    if (this === TP) {
        return 'Object.defineProperty(root, \'TP\', {value: {}, writable: true, configurable: true});';
    }

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asSource';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    //  Process the key list to remove potentially circular keys.
    keys = this.getUniqueValueKeys();
    this.getCircularKeys().forEach(function(key) {
        if (keys.indexOf(key)) {
            keys.splice(keys.indexOf(key), 1);
        }
    });

    try {
        str = TP.tname(this) + '.construct()' +
            this.$generateSourceSets(keys);
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.lang.Object.Inst.defineMethod('$generateSourceSets',
function(keyArray, forceInvalid) {

    /**
     * @method $generateSourceSets
     * @summary Generates a '.set()' for each key in the key Array, along with
     *     the receiver's value for that key, obtained by executing a 'get()'
     *     on the receiver.
     * @param {String[]} keyArray An optional parameter listing the keys that
     *     the '.set()' calls should be generated for. If this parameter is not
     *     supplied, it defaults to all the receiver's keys.
     * @param {Boolean} forceInvalid Whether or not to generate a '.set()' call
     *     for a particular key even if the value obtained by calling 'get()' on
     *     the receiver is invalid. The default is false.
     * @returns {String} A String of generated '.set()'s.
     */

    var shouldUseInvalid,

        keys,
        len,
        i,
        val,

        joinArr;

    shouldUseInvalid = TP.ifInvalid(forceInvalid, false);

    //  Keys are either supplied or we call 'TP.keys()'
    keys = keyArray;
    if (TP.notValid(keys)) {
        keys = TP.keys(this);
    }
    len = keys.getSize();

    joinArr = TP.ac();

    for (i = 0; i < len; i++) {
        val = this.get(keys.at(i));

        if (!TP.isValid(val) && !shouldUseInvalid) {
            continue;
        }

        joinArr.push(
                TP.join('.set(\'', keys.at(i), '\', ', TP.src(val), ')'));
    }

    return joinArr.join('');
});

//  ------------------------------------------------------------------------

TP.lang.Object.Inst.defineMethod('getConstructor',
function() {

    /**
     * @method getConstructor
     * @summary Returns the true constructor for an instance.
     * @returns {Object}
     */

    return this.getType()[TP.INSTC];
});

//  ------------------------------------------------------------------------

TP.lang.Object.Inst.defineMethod('getCircularKeys',
function() {

    /**
     * @method getCircularKeys
     * @summary Returns a known list of keys for the receiver that will cause a
     *     circular reference to eventually occur. Used by asString/asSource
     *     to allow certain types to avoid circular reference issues when
     *     producing simple string representations.
     * @returns {String[]} The default is an empty array.
     */

    return [];
});

//  ------------------------------------------------------------------------

TP.lang.Object.Inst.defineMethod('getKeys',
function() {

    /**
     * @method getKeys
     * @summary Returns the objects keys. The keys will be all of the receiver's
     *     attributes, hidden or shown, instance-level or local-level.
     * @returns {String[]} An Array of all attributes of the receiver, hidden or
     *     shown, instance-level or local-level.
     */

    var keys;

    //  The 'inst interface' call will retrieve all of the 'instance
    //  attributes', hidden or not, and the 'local interface' call will retrieve
    //  all of the 'local attributes', hidden or not.
    keys = this.getInstInterface(
                    TP.SLOT_FILTERS.known_attributes).concat(
            this.getLocalInterface(TP.SLOT_FILTERS.known_local_attributes));

    //  Make sure that we unique this list. Otherwise, attributes that have
    //  local values will show up twice.
    keys.unique();

    return keys;
});

//  ------------------------------------------------------------------------

TP.lang.Object.Inst.defineMethod('getUniqueValueKeys',
function() {

    /**
     * @method getUniqueValueKeys
     * @summary Returns uniquely-valued* slot on the receiver. That is, any
     *     attributes, hidden or shown, instance-level or local-level, that have
     *     a value different from the receiver's prototype object.
     * @returns {String[]} An Array of all *uniquely-valued* attributes of the
     *     receiver, hidden or shown, instance-level or local-level.
     */

    var keys;

    //  Here we ask the object *at a local level* for any attributes that are
    //  'overridden' (that is, have a unique value distinct from their
    //  prototype) whether they are hidden or not.
    keys = this.getLocalInterface(
                    TP.SLOT_FILTERS.known_overridden_attributes).concat(
            this.getLocalInterface(TP.SLOT_FILTERS.known_local_attributes));

    return keys;
});

//  ------------------------------------------------------------------------
//  Function Replacement
//  ------------------------------------------------------------------------

TP.FunctionProto.defineMethod('getRefreshedInstance',
function() {

    /**
     * @method getRefreshedInstance
     * @summary Returns the Function instance that is *really* installed on the
     *     receiver's target object under the receiver's target track and name.
     * @description Sometimes, we have a stale method reference that isn't
     *     really what is installed on the method's target object. This can
     *     happen when code is reloaded. This method allows a reference to the
     *     real Function instance, given the receiver's name, target object and
     *     track.
     * @returns {Function} The instance of the Function that is really
     *     installed.
     */

    var track,
        owner;

    track = this[TP.TRACK];

    //  If the track is not either 'Type' or 'Inst', then we just use the owner.
    if (track === TP.GLOBAL_TRACK ||
        track === TP.PRIMITIVE_TRACK ||
        track === TP.META_TYPE_TRACK ||
        track === TP.META_INST_TRACK ||
        track === TP.TYPE_LOCAL_TRACK ||
        track === TP.LOCAL_TRACK) {

        owner = this[TP.OWNER];
    } else {
        //  Otherwise, we qualify the owner with the 'Type' or 'Inst' prototype
        //  object.
        owner = this[TP.OWNER][this[TP.TRACK]];
    }

    //  Return what's really installed.
    return owner[this.getName()];
});

//  ------------------------------------------------------------------------

TP.FunctionProto.defineMethod('replaceWith',
function(aFunction, copySourceInfo) {

    /**
     * @method replaceWith
     * @summary Replaces the receiver with an alternate method function.
     * @description This method provides an easy way to reinstall a function
     *     in the proper context, particularly when you don't know the original
     *     context. In other words, you can ask a function to
     *     'replaceWith(aReplacement)' and the proper 'defineMethod' call will
     *     be constructed for you and executed.
     * @param {Function} aFunction The replacement Function.
     * @param {Boolean} copySourceInfo Whether or not to copy 'source'
     *     information such as the load node and source path. The default is
     *     true.
     * @returns {Function} The new method.
     */

    var obj,

        track,
        owner,

        isHandler,

        newMethod,

        loadPath,
        loadPackage,
        loadConfig,
        loadStage,

        sourcePath,
        sourcePackage,
        sourceConfig;

    if (TP.notValid(aFunction)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    if (!TP.isMethod(this)) {
        return this.raise('TP.sig.InvalidOperation',
                            'Cannot replace non-methods');
    }

    obj = TP.getRealFunction(this);

    track = obj[TP.TRACK];

    //  If the track is not either 'Type' or 'Inst', then we just use the owner.
    if (track === TP.GLOBAL_TRACK ||
        track === TP.PRIMITIVE_TRACK ||
        track === TP.META_TYPE_TRACK ||
        track === TP.META_INST_TRACK ||
        track === TP.TYPE_LOCAL_TRACK ||
        track === TP.LOCAL_TRACK) {

        owner = obj[TP.OWNER];
    } else {
        //  Otherwise, we qualify the owner with the 'Type' or 'Inst' prototype
        //  object.
        owner = obj[TP.OWNER][obj[TP.TRACK]];
    }

    //  If the caller hasn't supplied false to the copySourceInfo parameter
    //  capture the 'path information' slots about this method. We need to do
    //  this because when we redefine the method below, this information will be
    //  lost.
    if (TP.notFalse(copySourceInfo)) {
        loadPath = obj[TP.LOAD_PATH];
        loadPackage = obj[TP.LOAD_PACKAGE];
        loadConfig = obj[TP.LOAD_CONFIG];
        loadStage = obj[TP.LOAD_STAGE];

        sourcePath = obj[TP.SOURCE_PATH];
        sourcePackage = obj[TP.SOURCE_PACKAGE];
        sourceConfig = obj[TP.SOURCE_CONFIG];
    }

    isHandler = /^handle/.test(obj.getName());

    //  Redefine the method.
    try {
        newMethod = owner.defineMethod(
                                obj.getName(),
                                aFunction,
                                obj[TP.DESCRIPTOR],
                                obj[TP.DISPLAY],
                                isHandler);
    } catch (e) {
        return this.raise(
            'TP.sig.InvalidFunction',
            TP.ec(e, TP.id(owner) + '.defineMethod(func); failed.'));
    }

    //  If the caller hasn't supplied false to the copySourceInfo parameter
    //  copy over the 'path information' slots about this method.
    if (TP.notFalse(copySourceInfo)) {
        newMethod[TP.LOAD_PATH] = loadPath;
        newMethod[TP.LOAD_PACKAGE] = loadPackage;
        newMethod[TP.LOAD_CONFIG] = loadConfig;
        newMethod[TP.LOAD_STAGE] = loadStage;

        newMethod[TP.SOURCE_PATH] = sourcePath;
        newMethod[TP.SOURCE_PACKAGE] = sourcePackage;
        newMethod[TP.SOURCE_CONFIG] = sourceConfig;
    }

    //  Return the new method object here - the caller already has a handle to
    //  this object, so this will give them both.
    return newMethod;
});

//  ------------------------------------------------------------------------

TP.FunctionProto.defineMethod('replaceWithSourceText',
function(newSourceText, copySourceInfo) {

    /**
     * @method replaceWithSourceText
     * @summary Replaces the receiver with an alternate method function.
     * @param {String} newSourceText The new method text.
     * @param {Boolean} copySourceInfo Whether or not to copy 'source'
     *     information such as the load node and source path. The default is
     *     true.
     * @returns {Function} The new method.
     */

    var obj,

        functionStartMatcher,
        startResults,

        srcTextStart,
        srcTextEnd,
        srcText,

        $$newinst;

    if (!TP.isString(newSourceText)) {
        //  TODO: Exception
        return null;
    }

    obj = TP.getRealFunction(this);

    //  Note that the source text might have been supplied with a 'method head'
    //  (i.e. 'Foo.Inst.defineMethod') and 'method tail' (');'). We want to
    //  slice these off to just have the 'function() {...}' body.
    functionStartMatcher = /function\s*\(/g;
    startResults = functionStartMatcher.exec(newSourceText);
    srcTextStart = functionStartMatcher.lastIndex - startResults.at(0).length;

    srcTextEnd = newSourceText.lastIndexOf('}') + 1;
    srcText = newSourceText.slice(srcTextStart, srcTextEnd);

    /* eslint-disable no-eval */
    eval('$$newinst = ' + srcText);
    /* eslint-enable no-eval */

    //  Call the machinery defined above to replace the method and return the
    //  newly defined replacement.
    return obj.replaceWith($$newinst, copySourceInfo);
});

//  ------------------------------------------------------------------------
//  WINDOW OBJECT
//  ------------------------------------------------------------------------

Window.Inst.defineMethod('getType',
function() {

    /**
     * @method getType
     * @summary Returns the type object for the receiver.
     * @returns {Object}
     */

    return Window;
});

//  ------------------------------------------------------------------------

Window.Inst.defineMethod('getTypeName',
function() {

    /**
     * @method getTypeName
     * @summary Returns the type name of the receiver. This method is a synonym
     *     for getType().getName() for instances.
     * @returns {String}
     */

    return 'DOMWindow';
});

//  -----------------------------------------------------------------------
//  TP.lang.Namespace
//  -----------------------------------------------------------------------

TP.lang.Object.defineSubtype('lang.Namespace');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.lang.Namespace.Inst.defineAttribute('$$isNamespace');
TP.lang.Namespace.Inst.defineAttribute('nsPrefix');
TP.lang.Namespace.Inst.defineAttribute('nsRoot');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.lang.Namespace.Inst.defineMethod('init',
function(fullName) {

    /**
     * @method init
     * @summary Initialize the instance.
     * @param {String} fullName The 'full name' of the receiver. This is the
     *     name that will be used by the system for the receiver's TP.ID and
     *     TP.NAME.
     * @returns {TP.lang.Namespace} The receiver.
     */

    var parts;

    this.callNextMethod();

    this.$set('$$isNamespace', true, false);

    this.$set(TP.NAME, fullName, false);
    this.$set(TP.ID, fullName, false);

    parts = fullName.split(/[.:]/);

    this.$set('nsRoot', parts[0], false);
    this.$set('nsPrefix', parts[1], false);

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.Namespace.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a TIBET source code string, capable of
     *     recreating the namespace.
     * @returns {String} The receiver in valid source code form.
     */

    return 'TP.defineNamespace(\'' + this.getName() + '\')';
});

//  ------------------------------------------------------------------------

TP.lang.Namespace.Inst.defineMethod('asString',
function() {

    /**
     * @method asString
     * @summary Returns the receiver as a simple string.
     * @returns {String} The simple string form of the receiver.
     */

    return this.getName();
});

//  ------------------------------------------------------------------------

TP.lang.Namespace.Inst.defineMethod('generatePseudoNativeModule',
function(typeNamesToExport, wantsExportStatements) {

    /**
     * @method generatePseudoNativeModule
     * @summary Generates ECMA module text of types belonging to this namespace
     *     as TIBET ECMA classes. If the flag is not false, then ECMA module
     *     export statements are generated.
     * @param {String[]} [typeNamesToExport] An optional Array of type names to
     *     export. If this is not supplied, then all types belonging to this
     *     namespace will be exported. Note that these type names should be the
     *     *local* type name for the type, not the global one (i.e. 'Point' not
     *     'TP.gui.Point'. Also, these types should belong to the receiver
     *     namespace.
     * @param {Boolean} [wantsExportStatements=true] Whether or not to return
     *     ECMA module compliant 'export' statements. If this parameter is
     *     false, then text with an IIFE returning a simple 'Object' syntax
     *     containing the exports (suitable for eval) is returned.
     * @returns {String} The text of the module defining types in the namespace
     *     as 'TIBET ECMA class proxies'.
     */

    var moduleRoot,
        modulePrefix,

        moduleExportNames,
        moduleBody,

        typeNames,

        len,
        i,
        typeName,
        fullyQualifiedTypeName,
        fullyQualifiedType,

        defaultDefinition;

    moduleRoot = this.getNamespaceRoot();
    modulePrefix = this.getNamespacePrefix();

    moduleExportNames = TP.ac();

    moduleBody = '';

    //  If an Array of specific typenames was supplied to export, then iterate
    //  over them, computing a fully qualified type name using the namespace and
    //  checking to make sure that is a valid type. We can only process types
    //  that belong in this namespace.
    if (TP.isArray(typeNamesToExport)) {
        typeNames = TP.ac();

        len = typeNamesToExport.getSize();
        for (i = 0; i < len; i++) {
            typeName = typeNamesToExport.at(i);
            if (/[.:]/.test(typeName)) {
                TP.ifError() ?
                    TP.error('Invalid name: ' +
                                typeName +
                                '. Use local type name') : 0;
                return this;
            }

            //  Build a fully qualified type name using the receiver's root and
            //  prefix and the type name.
            fullyQualifiedTypeName = moduleRoot + '.' +
                                        modulePrefix + '.' +
                                        typeName;

            //  If a type cannot be found under that type name then it either
            //  doesn't exist or it doesn't belong to the receiver.
            fullyQualifiedType = TP.sys.getTypeByName(fullyQualifiedTypeName);
            if (!TP.isType(fullyQualifiedType)) {
                return this.raise('TP.sig.InvalidType');
            }

            typeNames.push(fullyQualifiedTypeName);
        }
    } else {
        typeNames = this.getTypeNames();
    }

    //  Iterate over all of the type names and build code that will define a
    //  'native class' proxy for each type we're going to export using TIBET's
    //  defineNativeClass method.
    typeNames.forEach(
        function(aTypeName) {
            var type,
                typeLocalName,

                typeNameForECMAClass;

            type = TP.sys.getTypeByName(aTypeName);
            typeLocalName = type.getLocalName();

            //  Generate the type name for the proxy class. This will take the
            //  form of 'TP.proxy.ECMA_<prefix>_<typename>_Class'.
            typeNameForECMAClass =
                'TP.proxy.ECMA_' +
                modulePrefix + '_' + typeLocalName + '_Class';

            //  Add the code that will cause TIBET to define a native class
            //  (with an empty class body) and also define a local variable
            //  pointing to the defined proxy class object. This will allow the
            //  simplistic ECMA module syntax to work (it doesn't allow export
            //  of dot-separated names).
            moduleBody += type.getName() + '.defineNativeClass(' +
                            '\'' + typeNameForECMAClass + '\',' +
                            'class extends Object { })' +
                            ';\n';
            moduleBody += 'const ' +
                            typeLocalName +
                            ' = ' +
                            typeNameForECMAClass +
                            ';\n\n';

            moduleExportNames.push(typeLocalName);
        });

    //  Build a 'default' object definition for the module that exports all of
    //  the exported symbol names as an object literal. This will act as a
    //  'namespace' for the module.
    defaultDefinition = '{';
    moduleExportNames.forEach(
        function(aName) {
            defaultDefinition += '\'' + aName + '\'' +
                                    ': ' +
                                    aName +
                                    ', ';
        });
    defaultDefinition = defaultDefinition.slice(0, -2) + '}';

    if (TP.notFalse(wantsExportStatements)) {
        //  Add the default 'export' statement.
        moduleBody += 'export default ' + defaultDefinition + ';\n\n';

        //  Add the 'export' statement that exports all of the individual
        //  'class' names.
        moduleBody += 'export {' + moduleExportNames.join(', ') + '};';
    } else {
        moduleBody = '(function() {\n\n' + moduleBody +
                        'return ' + defaultDefinition + ';\n\n}())\n\n';
    }

    return moduleBody;
});

//  ------------------------------------------------------------------------

TP.lang.Namespace.Inst.defineMethod('getKeys',
function() {

    /**
     * @method getKeys
     * @summary Returns the set of keys which represent attribute values for
     *     the receiver.
     * @returns {String[]} An array containing the keys of the receiver.
     */

    var keys;

    keys = TP.$getOwnKeys(this);

    //  For the 'TP' namespace, we filter out the 'boot' and 'sys' keys, since
    //  they point to special 'system namespaces'.
    if (this.get(TP.NAME) === 'TP') {
        keys.splice(keys.indexOf('boot'), 1);
        keys.splice(keys.indexOf('sys'), 1);
    }

    return keys;
});

//  ------------------------------------------------------------------------

TP.lang.Namespace.Inst.defineMethod('getLocalName',
function() {

    /**
     * @method getLocalName
     * @summary Returns the local (aka short) name of the receiver without any
     *     namespace prefix. For namespace objects, this is the same as the
     *     'namespace prefix'.
     * @returns {String} The receiver's local name.
     */

    return this.getNamespacePrefix();
});

//  ------------------------------------------------------------------------

TP.lang.Namespace.Inst.defineMethod('getNamespaceObject',
function() {

    /**
     * @method getNamespaceObject
     * @summary Returns the namespace object of the receiver. For namespace
     *     objects themselves, this is the root namespace object.
     * @returns {TP.lang.Namespace} The receiver's namespace object.
     */

    return TP.sys.getObjectById(this.getNamespaceRoot());
});

//  ------------------------------------------------------------------------

TP.lang.Namespace.Inst.defineMethod('getNamespacePrefix',
function() {

    /**
     * @method getNamespacePrefix
     * @summary Returns the namespace (in TIBET terms) of the receiver. For
     *     example, the namespace of the TP.sig.Signal type is 'sig'.
     * @returns {String} The receiver's namespace.
     */

    return this.$get('nsPrefix');
});

//  ------------------------------------------------------------------------

TP.lang.Namespace.Inst.defineMethod('getNamespaceRoot',
function() {

    /**
     * @method getNamespaceRoot
     * @summary Returns the namespace root (in TIBET terms) of the receiver.
     *     For example, the namespace root of the TP.sig.Signal type is 'TP'.
     * @returns {String} The receiver's namespace root.
     */

    return this.$get('nsRoot');
});

//  ------------------------------------------------------------------------

TP.lang.Namespace.Inst.defineMethod('getSubNamespaceNames',
function() {

    /**
     * @method getSubNamespaceNames
     * @summary Returns the list of namespaces names attached to this namespace
     *     object that are considered 'sub' namespaces.
     * @returns {String[]} A list of namespace names attached to (or 'under')
     *     the receiver.
     */

    var keys,

        namelist,

        len,
        j,

        nsname;

    //  Grab the keys from ourself. This will not grab internal slot keys, but
    //  that's ok since no namespaces should be registered under those kind of
    //  keys.
    keys = TP.keys(this);

    namelist = TP.ac();

    //  Iterate over the keys, prepend our name and a '.' onto the front of it,
    //  which should be the 'full' namespace name. If resolving that String as a
    //  namespace name results in a namespace, then push that name onto our
    //  results.
    len = keys.getSize();
    for (j = 0; j < len; j++) {

        nsname = keys.at(j);

        if (TP.isNamespace(this[nsname])) {
            namelist.push(this[TP.NAME] + '.' + nsname);
        }
    }

    return namelist;
});

//  ------------------------------------------------------------------------

TP.lang.Namespace.Inst.defineMethod('getTypeNames',
function() {

    /**
     * @method getTypeNames
     * @summary Returns the list of type names attached to this namespace
     *     object.
     * @returns {String[]} A list of type names attached to (or 'under') the
     *     receiver.
     */

    var keys,

        namelist,

        len,
        j,

        typename;

    //  Grab the keys from ourself. This will not grab internal slot keys, but
    //  that's ok since no types should be registered under those kind of keys.
    keys = TP.keys(this);

    namelist = TP.ac();

    //  Iterate over the keys, prepend our name and a '.' onto the front of it,
    //  which should be the 'full' type name. If resolving that String as a type
    //  name results in a real type, then push that name onto our results.
    len = keys.getSize();
    for (j = 0; j < len; j++) {

        typename = this[TP.NAME] + '.' + keys.at(j);

        if (TP.isType(typename.asType())) {
            namelist.push(typename);
        }
    }

    return namelist;
});

//  -----------------------------------------------------------------------
//  TP.lang.ValueHolder
//  -----------------------------------------------------------------------

TP.lang.Object.defineSubtype('lang.ValueHolder');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.lang.ValueHolder.Inst.defineAttribute('$$isValueHolder', true);

TP.lang.ValueHolder.Inst.defineAttribute('value');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.lang.ValueHolder.Inst.defineMethod('init',
function(initialValue) {

    /**
     * @method init
     * @summary Initialize the instance.
     * @param {Object} initialValue The initial value to 'hold'
     * @returns {TP.lang.ValueHolder} The receiver.
     */

    this.callNextMethod();

    this.set('value', initialValue, false);

    return this;
});

//  ------------------------------------------------------------------------

TP.lang.ValueHolder.Inst.defineMethod('asString',
function() {

    /**
     * @method asString
     * @summary Returns the receiver as a simple string.
     * @returns {String} The simple string form of the receiver.
     */

    var heldVal;

    heldVal = this.$get('value');

    return heldVal.asString();
});

//  ------------------------------------------------------------------------

TP.lang.ValueHolder.Inst.defineMethod('get',
function(attributeName) {

    /**
     * @method get
     * @summary Returns the value, if any, of the attribute provided. Note
     *     however that special parsing rules apply to TP.dom.Node types.
     * @param {String} attributeName The name of the attribute to return.
     * @returns {String|Object} The value of the desired attribute.
     */

    var attrName,
        heldVal;

    if (TP.isEmpty(attributeName)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  This might be an access path
    attrName = TP.str(attributeName);

    heldVal = this.$get('value');

    //  A shortcut - if the attribute name is '.' or '$_', then that's
    //  shorthand for returning ourselves.
    if (TP.regex.ONLY_PERIOD.test(attrName) ||
        TP.regex.ONLY_STDIN.test(attrName) ||
        TP.isEmpty(attrName) ||
        attrName === 'value') {
        return heldVal;
    }

    return heldVal.get(attributeName);
});

//  ------------------------------------------------------------------------

TP.lang.ValueHolder.Inst.defineMethod('set',
function(attributeName, attributeValue, shouldSignal) {

    /**
     * @method set
     * @summary Sets the value of the named attribute or path target to the
     *     value provided.
     * @param {String} attributeName The attribute name to set.
     * @param {Object} attributeValue The value to set.
     * @param {Boolean} shouldSignal If false no signaling occurs. Defaults to
     *     this.shouldSignalChange().
     * @returns {Object} The result of setting the attribute on the receiver.
     *     This can vary in actual type.
     */

    var attrName,
        attrVal,

        valueVal,

        retVal;

    if (TP.isEmpty(attributeName)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  This might be an access path
    attrName = TP.str(attributeName);

    attrVal = attributeValue;

    //  If we're setting the held value and it's a POJO, then construct a
    //  TP.core.JSONContent object around it and set that as the held value.
    if (attrName === 'value') {
        if (TP.isPlainObject(attrVal)) {
            attrVal = TP.core.JSONContent.construct(attrVal);
        }

        return this.callNextMethod(attributeName, attrVal, shouldSignal);
    }

    valueVal = this.$get('value');

    retVal = valueVal.set(attributeName, attributeValue, false);

    this.changed('value', TP.UPDATE);

    return retVal;
});

//  ------------------------------------------------------------------------
//  Primitives
//  ------------------------------------------------------------------------

TP.definePrimitive('defineNamespace',
function(namespaceName, forceDefinition, populateMetadata) {

    /**
     * @method defineNamespace
     * @summary Defines a namespace named by the supplied name, which must
     *     include a root reference of either TP or APP.
     * @description The name supplied to this method defines a namespace list
     *     from the root object to the last name at the end of the supplied
     *     namespace name.
     *     Note that this method is a replacement for the bootstrap version of
     *     TP.defineNamespace that defines namespaces using real
     *     TP.lang.Namespace objects. See below for logic that upconverts any
     *     existing namespaces to be real TP.lang.Namespace objects.
     * @param {String} namespaceName A String of 1 or more period-separated
     *     names that will define the name of a namespace.
     * @param {Boolean} [forceDefinition=false] Whether or not to force the
     *     definition of the namespace whether it is already defined or not.
     * @param {Boolean} [populateMetadata=true] Whether or not to register the
     *     new namespace with the metadata.
     * @returns {TP.lang.Namespace} The newly defined namespace.
     */

    var names,
        root,
        currentObj,
        prefix,
        fullName,
        i;

    names = namespaceName.split('.');
    root = names.shift();

    currentObj = TP.global[root];

    if (TP.isEmpty(names)) {

        //  Only define if either the name is not defined or if the
        //  forceDefinition flag is true.
        if (!currentObj || TP.isTrue(forceDefinition)) {
            currentObj = TP.lang.Namespace.construct(root);

            if (TP.notFalse(populateMetadata)) {
                //  NB: The caller is responsible for installing this rooted
                //  namespace, but we register with the metadata here.
                TP.sys.addMetadata(null, currentObj, TP.NAMESPACE);
            }
        }
    } else {

        //  We're defining a sub root namespace
        prefix = root + '.';

        //  Descend through the names, making sure that there's a real Object at
        //  each level.
        for (i = 0; i < names.length; i++) {

            //  Only define if either the name is not defined or if the
            //  forceDefinition flag is true.
            if (!currentObj[names[i]] || TP.isTrue(forceDefinition)) {

                fullName = prefix + names.slice(0, i + 1).join('.');
                currentObj[names[i]] = TP.lang.Namespace.construct(fullName);

                if (TP.notFalse(populateMetadata)) {
                    //  We register with the metadata here.
                    TP.sys.addMetadata(null,
                        currentObj[names[i]], TP.NAMESPACE);
                }
            }

            currentObj = currentObj[names[i]];
        }
    }

    //  Return the 'last' Object that we created - that'll be the namespace that
    //  the caller wants.
    return currentObj;
});

//  ------------------------------------------------------------------------

//  Wrap the following logic in an IIFE to avoid introducing variables into the
//  global scope.

/* eslint-disable wrap-iife */
(function() {

    //  This function upconverts existing namespaces. Because it is very easy to
    //  have circular dependencies here, it is important to keep this code in
    //  the exact order it was written.

    var newNamespaces,

        len,
        i,

        oldNamespace,
        oldKeys,

        names,
        root,
        name,

        newNamespace,

        propertyDescriptor,

        len2,
        j;

    newNamespaces = TP.ac();

    len = TP.$$bootstrap_namespaces.getSize();

    for (i = 0; i < len; i++) {

        //  Grab the existing namespace *object* (i.e. POJO) that was registered
        //  using the bootstrap version of TP.defineNamespace.
        oldNamespace = TP.$$bootstrap_namespaces.at(i);

        //  Get the old namespace's name and split it into two parts: the root
        //  and the name (which might itself be dot-separated, but we join
        //  together to form a full name - minus the root, which is how the
        //  TP.defineNamespace call expects it).
        names = oldNamespace[TP.NAME].split('.');
        root = names.at(0);
        name = names.slice(1).join('.');

        //  Define a new real namespace object to supplant the old namespace.
        //  Note that after this call, our only handle to the old namespace is
        //  our local variable holding it here.
        //  Also note how we pass false in as the last parameter - that's so
        //  that this call will not try to register the namespace object with
        //  the metadata system at this point in the conversion process. This
        //  will not work in this loop while we turn TIBET's world topsy-turvy
        //  rewriting namespace slots, etc. We track the newly added namespaces
        //  and add them individually to the metadata after this loop is
        //  finished.
        newNamespace = TP.defineNamespace(oldNamespace[TP.NAME], true, false);

        //  For certain namespaces, TP, TP.sys, TP.boot and APP, we configure
        //  them a bit differently. We define a 'getTypeNames()' that returns an
        //  empty Array and we (re)define them as non-writeable properties on
        //  their respective receivers to prevent them from being blown away
        //  during system execution, which would be very bad.

        //  The reason these are in two blocks is because of the different
        //  values for the property receiver and property name in
        //  Object.defineProperty.

        /* eslint-disable no-loop-func */
        if (newNamespace[TP.NAME] === 'TP' ||
            newNamespace[TP.NAME] === 'APP') {

            newNamespace.getTypeNames = function() {
                return [];
            };

            propertyDescriptor = Object.getOwnPropertyDescriptor(self, root);
            propertyDescriptor.value = newNamespace;
            propertyDescriptor.writable = false;

            //  NB: Need to make this configurable or otherwise browsers tend to
            //  freak out when non-configurable properties are placed on the
            //  global.
            propertyDescriptor.configurable = true;

            Object.defineProperty(self, root, propertyDescriptor);
        }

        if (newNamespace[TP.NAME] === 'TP.sys' ||
            newNamespace[TP.NAME] === 'TP.extern' ||
            newNamespace[TP.NAME] === 'TP.boot') {

            newNamespace.getTypeNames = function() {
                return [];
            };

            propertyDescriptor = Object.getOwnPropertyDescriptor(TP, name);
            propertyDescriptor.value = newNamespace;
            propertyDescriptor.writable = false;
            propertyDescriptor.configurable = false;

            Object.defineProperty(TP, name, propertyDescriptor);
        }
        /* eslint-enable no-loop-func */

        //  Fetch the keys using the primitive Object.keys() call. It is
        //  important to use this call, since our TP.keys() call omits internal
        //  slots but this routine must copy *all* slots, internal or otherwise.
        oldKeys = Object.keys(oldNamespace);

        //  Loop over the keys and copy all of those slots from the old
        //  namespace to the new namespace, except for the locally-programmed
        //  'getTypeNames' method - we already have a similar one defined as an
        //  instance method on the real TP.lang.Namespace type.
        len2 = oldKeys.getSize();
        for (j = 0; j < len2; j++) {

            //  Note here how we use primitive '[]' syntax to access the key
            //  Array. If we try to use '.at()', we'll run into problems when
            //  upconverting the 'TP' object, so we just leave it this way.
            if (oldKeys[j] !== 'getTypeNames') {
                newNamespace[oldKeys[j]] = oldNamespace[oldKeys[j]];
            }
        }

        //  Track the new namespace here for registration with the metadata
        //  below.
        newNamespaces.push(newNamespace);
    }

    //  Now that we're done with rewriting all of our built-ins, we register
    //  them with the metadata.
    len = newNamespaces.getSize();
    for (i = 0; i < len; i++) {
        TP.sys.addMetadata(null, newNamespaces.at(i), TP.NAMESPACE);
    }

    //  Clear the Array that was holding our list of old namespaces.
    TP.$$bootstrap_namespaces = null;
})();
/* eslint-enable wrap-iife */

//  -----------------------------------------------------------------------
//  API OBJECT SUPPORT
//  -----------------------------------------------------------------------

TP.defineNamespace('TP.api');

//  ------------------------------------------------------------------------
//  TP.sys Metadata Overrides
//  ------------------------------------------------------------------------

TP.sys.defineMethod('getCustomTypeNames',
function() {

    /**
     * @method getCustomTypeNames
     * @summary Returns the list of all known custom type names in the system.
     * @returns {String[]} A list of type names.
     */

    var typeKeys;

    typeKeys = TP.copy(TP.sys.getMetadata('types').getKeys());
    typeKeys.sort();

    return typeKeys;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getCustomTypeNameKVPairs',
function() {

    /**
     * @method getCustomTypeNameKVPairs
     * @summary Returns a hash of all known custom type names in the system as a
     *     set of pairs where the type name is both the key and the value.
     * @returns {TP.core.Hash} A hash of type names in both the key and value
     *     slots.
     */

    var typeKeys,

        result,
        len,
        i;

    typeKeys = TP.copy(TP.sys.getMetadata('types').getKeys());
    typeKeys.sort();

    result = TP.hc();

    len = typeKeys.getSize();
    for (i = 0; i < len; i++) {
        result.atPut(typeKeys.at(i), typeKeys.at(i));
    }

    return result;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getTypeNames',
function() {

    /**
     * @method getTypeNames
     * @summary Returns the list of all known types in the system.
     * @returns {String[]} A list of type names.
     */

    var typeKeys;

    typeKeys = TP.copy(TP.sys.getTypes().getKeys());
    typeKeys.sort();

    return typeKeys;
});

//  -----------------------------------------------------------------------
//  COMMON HANDLER SUPPORT
//  -----------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  TP.ObjectProto Methods
//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('handleClearContentFromANYWhenANY',
function(aSignal) {

    /**
     * @method handleClearContent
     * @summary Handles when the receiver's data is to be cleared.
     * @param {TP.sig.ClearContent} aSignal The signal instance which triggered
     *     this handler.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidURI
     * @exception TP.sig.InvalidSource
     * @returns {Object} The receiver.
     */

    var scope,
        scopeURI;

    //  The 'scope' should be a URI location to find the overall collection to
    //  insert the item into. It should be either the whole collection
    //  representing the data of the receiver or a subcollection of that data.
    if (TP.isEmpty(scope = aSignal.at('scope'))) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  Make sure we can create a real URI from it.
    if (!TP.isURI(scopeURI = TP.uc(scope))) {
        return this.raise('TP.sig.InvalidURI');
    }

    scopeURI.setResource(null);

    return this;
}, {
    deprecationWarning: false
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('handleCloneItemFromANYWhenANY',
function(aSignal) {

    /**
     * @method handleCloneItem
     * @summary Handles when an item is to be cloned and inserted into the
     *     receiver's data.
     * @param {TP.sig.CloneItem} aSignal The signal instance which triggered
     *     this handler.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidURI
     * @returns {Object} The receiver.
     */

    var scope,
        scopeURI,

        source,

        index,

        targetElem;

    //  The 'scope' should be a URI location to find the overall collection to
    //  insert the item into. It should be either the whole collection
    //  representing the data of the receiver or a subcollection of that data.
    if (TP.isEmpty(scope = aSignal.at('scope'))) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  Make sure we can create a real URI from it.
    if (!TP.isURI(scopeURI = TP.uc(scope))) {
        return this.raise('TP.sig.InvalidURI');
    }

    source = TP.tpc(TP.str(aSignal.atIfInvalid('source', '[0]')));

    //  Grab the index if one was specified in the signal.
    index = aSignal.at('index');
    if (index === TP.TARGET) {

        //  If the index was 'TP.TARGET', then we're going to use the 'repeat
        //  index' of the target.
        targetElem = aSignal.at('trigger').getTarget();
        if (TP.isElement(targetElem)) {
            index = TP.wrap(targetElem).$getNearestRepeatIndex();
        }
    } else {
        //  Otherwise, if the index is a Number, then we use. If not, then we
        //  set it to null, instructing the insertion method just use the end of
        //  the collection
        index = parseInt(index, 10);
        if (TP.isNaN(index)) {
            index = null;
        }
    }

    //  Go ahead and insert the cloned data.
    this.insertRowIntoAt(
            scopeURI,
            source,
            index,
            aSignal.at('position'),
            true,
            true);

    return this;
}, {
    deprecationWarning: false
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('handleDeleteItemFromANYWhenANY',
function(aSignal) {

    /**
     * @method handleDeleteItem
     * @summary Handles when an item is to be deleted and removed from the
     *     receiver's data.
     * @param {TP.sig.DeleteItem} aSignal The signal instance which triggered
     *     this handler.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidURI
     * @returns {Object} The receiver.
     */

    var scope,
        scopeURI,

        index,

        targetElem;

    //  The 'scope' should be a URI location to find the overall collection to
    //  insert the item into. It should be either the whole collection
    //  representing the data of the receiver or a subcollection of that data.
    if (TP.isEmpty(scope = aSignal.at('scope'))) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  Make sure we can create a real URI from it.
    if (!TP.isURI(scopeURI = TP.uc(scope))) {
        return this.raise('TP.sig.InvalidURI');
    }

    //  Grab the index if one was specified in the signal.
    index = aSignal.at('index');
    if (index === TP.TARGET) {

        //  If the index was 'TP.TARGET', then we're going to use the 'repeat
        //  index' of the target.
        targetElem = aSignal.at('trigger').getTarget();
        if (TP.isElement(targetElem)) {
            index = TP.wrap(targetElem).$getNearestRepeatIndex();
        }
    } else {
        //  Otherwise, if the index is a Number, then we use. If not, then we
        //  set it to null, instructing the insertion method just use the end of
        //  the collection
        index = parseInt(index, 10);
        if (TP.isNaN(index)) {
            index = null;
        }
    }

    //  Remove a row from that collection, using the deletion index in the
    //  signal.
    this.removeRowsFromAt(scopeURI, index);

    return this;
}, {
    deprecationWarning: false
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('handleInsertItemFromANYWhenANY',
function(aSignal) {

    /**
     * @method handleInsertItem
     * @summary Handles when an item is to be inserted into the receiver's data.
     * @param {TP.sig.InsertItem} aSignal The signal instance which triggered
     *     this handler.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidURI
     * @returns {Object} The receiver.
     */

    var scope,
        scopeURI,

        source,

        index,

        targetElem;

    //  The 'scope' should be a URI location to find the overall collection to
    //  insert the item into. It should be either the whole collection
    //  representing the data of the receiver or a subcollection of that data.
    if (TP.isEmpty(scope = aSignal.at('scope'))) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  Make sure we can create a real URI from it.
    if (!TP.isURI(scopeURI = TP.uc(scope))) {
        return this.raise('TP.sig.InvalidURI');
    }

    //  This could be undefined, but if it's real we want to make URI out of it.
    source = aSignal.at('source');
    if (TP.notEmpty(source)) {
        source = source.unquoted();

        if (TP.isURIString(source)) {
            source = TP.uc(source);
        } else if (source.charAt(0) === '#') {

            //  If it's not an XPointer, then make a 'direct to GUI' URI out of
            //  it.
            if (!TP.regex.ANY_POINTER.test(source)) {
                source = 'tibet://uicanvas#tibet(' + source + ')';
            }

            source = TP.uc(source);
        } else {

            //  Otherwise, try to create an access path from it.
            source = TP.apc(source);
        }
    }

    //  Grab the index if one was specified in the signal.
    index = aSignal.at('index');
    if (index === TP.TARGET) {

        //  If the index was 'TP.TARGET', then we're going to use the 'repeat
        //  index' of the target.
        targetElem = aSignal.at('trigger').getTarget();
        if (TP.isElement(targetElem)) {
            index = TP.wrap(targetElem).$getNearestRepeatIndex();
        }
    } else {
        //  Otherwise, if the index is a Number, then we use. If not, then we
        //  set it to null, instructing the insertion method just use the end of
        //  the collection
        index = parseInt(index, 10);
        if (TP.isNaN(index)) {
            index = null;
        }
    }

    //  Go ahead and insert the cloned data.
    this.insertRowIntoAt(
            scopeURI,
            source,
            index,
            aSignal.at('position'),
            aSignal.at('copy'),
            aSignal.at('clear'));

    return this;
}, {
    deprecationWarning: false
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('handleSetContentFromANYWhenANY',
function(aSignal) {

    /**
     * @method handleSetContent
     * @summary Handles when the receiver's data is to be set to the source
     *     specified in the 'source' parameter of the supplied signal. The
     *     source should resolve to a value that a URI can be constructed from.
     *     The signal should also specify via a 'copy' Boolean flag as to
     *     whether the source's data should be copied.
     * @param {TP.sig.SetContent} aSignal The signal instance which triggered
     *     this handler.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidURI
     * @exception TP.sig.InvalidSource
     * @returns {Object} The receiver.
     */

    var scope,
        scopeURI,

        sourceURI,
        source;

    //  The 'scope' should be a URI location to find the overall collection to
    //  insert the item into. It should be either the whole collection
    //  representing the data of the receiver or a subcollection of that data.
    if (TP.isEmpty(scope = aSignal.at('scope'))) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  Make sure we can create a real URI from it.
    if (!TP.isURI(scopeURI = TP.uc(scope))) {
        return this.raise('TP.sig.InvalidURI');
    }

    //  Make sure we can create a real URI from the source.
    source = aSignal.at('source');
    if (TP.isEmpty(source)) {
        return this.raise('TP.sig.InvalidSource');
    }

    source = source.unquoted();

    if (!TP.isURI(sourceURI = TP.uc(source))) {
        return this.raise('TP.sig.InvalidURI');
    }

    scopeURI.setResourceToResultOf(
        sourceURI,
        TP.hc('signalChange', true),
        TP.bc(aSignal.at('copy')));

    return this;
}, {
    deprecationWarning: false
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('insertRowIntoAt',
function(aCollectionURIOrPath, aDataRowOrURIOrPath, anInsertIndex, aPosition,
         shouldClone, shouldEmpty) {

    /**
     * @method insertRowIntoAt
     * @summary Inserts a row of data into the collection as defined by the
     *     supplied collection URI. This collection should be either the whole
     *     collection representing the data of the receiver or a subcollection
     *     of that data.
     * @param {TP.uri.URI|TP.path.AccessPath} aCollectionURIOrPath The URI
     *     pointing to the collection to add the row to or a path that, in
     *     combination with the receiver's 'public facing' URI, can be used to
     *     obtain a collection to add the row to.
     * @param {Array|TP.uri.URI|TP.path.AccessPath} aDataRowOrURIOrPath The URI
     *     or path that points to data or the object itself to insert into the
     *     collection.
     * @param {Number} [anInsertIndex] The index to insert the item at in the
     *     collection. Note that this works with the supplied position to
     *     determine whether the insertion should happen before or after. If not
     *     specified, the item will be inserted at the end of the collection.
     * @param {String} [aPosition=TP.AFTER] A value of TP.BEFORE, TP.AFTER or
     *     null. This determines the position of the insertion. If no position
     *     is supplied, TP.AFTER is assumed.
     * @param {Boolean} [shouldClone=false] Whether or not to clone the data
     *     before inserting it. The default is false.
     * @param {Boolean} [shouldEmpty=false] Whether or not to empty any cloned
     *     data before inserting it. The default is false. NOTE: This parameter
     *     is only used if the shouldClone parameter is true.
     * @returns {Object} The receiver.
     */

    var targetURIOrPath,

        targetURI,

        targetCollection,

        dataRow,

        keys,

        fragmentExpr,

        queryURI,

        insertIndex,

        changedAddresses,
        changedIndex,
        changedAspect,
        changedPaths,

        batchID;

    //  Obtain a URI that will be pointing at a collection.

    targetURIOrPath = aCollectionURIOrPath;

    //  If targetURIOrPath is null or is not a TP.uri.URI (maybe its a
    //  path...), then we can do no more here and exit.
    if (!TP.isURI(targetURIOrPath)) {
        return this;
    } else {

        //  A URI was supplied to begin with.
        targetURI = targetURIOrPath;

        //  NB: We assume 'async' of false here.
        targetCollection = targetURI.getResource(
                            TP.hc('async', false,
                                    'shouldCollapse', false)).get('result');

        //  Now, make sure that we're dealing with an Array
        if (!TP.isArray(targetCollection)) {
            targetCollection = TP.ac(targetCollection);
        }

        fragmentExpr = targetURI.getFragmentExpr();
    }

    if (TP.isURI(aDataRowOrURIOrPath)) {
        //  NB: We assume 'async' of false here.
        dataRow = aDataRowOrURIOrPath.getResource(
                                TP.hc('async', false)).get('result');

    } else if (aDataRowOrURIOrPath.isAccessPath()) {

        queryURI = aCollectionURIOrPath;

        //  aCollectionURIOrPath isn't real - nothing to do here.
        if (!TP.isURI(queryURI)) {
            //  TODO: Raise exception
            return this;
        }

        //  NB: We assume 'async' of false here.
        dataRow =
            queryURI.getResource(
                TP.hc('async', false)).get('result').get(aDataRowOrURIOrPath);

    } else {
        dataRow = aDataRowOrURIOrPath;
    }

    if (TP.isTrue(shouldClone)) {

        dataRow = TP.copy(dataRow);

        if (TP.isTrue(shouldEmpty)) {
            if (TP.canInvoke(dataRow, 'clearTextContent')) {
                //  Clear out all of the 'text content' - that is, all of the
                //  scalar values in the newly cloned item. This will descend
                //  through the new item's data structure and cleanse it all of
                //  previous values.
                dataRow.clearTextContent();
            } else {
                keys = TP.keys(dataRow);
                keys.forEach(
                    function(aKey) {
                        dataRow.atPut(aKey, '');
                    });
            }
        }
    }

    //  NB: The insertion index is computed to represent the row that will come
    //  *after* the new row after the insertion operation is complete (per
    //  'insertBefore()' semantics).

    if (TP.isNumber(insertIndex = anInsertIndex)) {
        insertIndex++;
    } else {

        //  No index specified - we will be manipulating the end of the
        //  collection.
        insertIndex = targetCollection.getSize();
    }

    //  TP.BEFORE was specified - subtract a position back off.
    if (aPosition === TP.BEFORE) {
        insertIndex--;
    }

    //  Splice it into the collection.
    targetCollection.splice(insertIndex, 0, dataRow);

    /* TODO: This doesn't seem to be necessary and it causes the resource in the
     * URI to change to be the collection, which is definitely wrong. At worst,
     * this should replace the URI's resource with a new instance of it's own
     * class ('this' is the content object and the URI's resource should be
     * another one). Review this.

    //  NB: We *must* reset the targetURI's resource here since we've modified
    //  it 'outside' of the normal set()/get() behavior and observers that are
    //  observing this object for changes will be depending on having a
    //  queryable structure when they receive their notification. Note also how
    //  we do *not* signal change when we set this value. We don't want those
    //  observers to trigger early, but instead use the richer notification
    //  they'll receive from the code below.
    targetURI.setResource(targetCollection, TP.request('signalChange', false));
    */

    //  The index that changed.
    changedIndex = insertIndex;

    //  The aspect that changed is just the collection along with the index that
    //  changed.
    changedAspect = fragmentExpr + '[' + changedIndex + ']';

    //  For these paths, the changed addresses are just an Array of the changed
    //  aspect.
    changedAddresses = TP.ac(changedAspect);

    //  Construct a 'changed paths' data structure that observers will expect to
    //  see.
    changedPaths = TP.hc(changedAspect, TP.hc(TP.INSERT, changedAddresses));

    //  We need this purely so that any machinery that relies on signal batching
    //  (i.e. the markup-based data binding) knows that this signal represents
    //  an entire batch.
    batchID = TP.genID('SIGNAL_BATCH');

    TP.signal(this.getID(),
                'TP.sig.StructureInsert',
                TP.hc('action', TP.INSERT,
                        'addresses', changedAddresses,
                        'aspect', changedAspect,
                        'facet', 'value',
                        TP.CHANGE_PATHS, changedPaths,
                        'target', this,
                        'indexes', TP.ac(changedIndex),
                        TP.CHANGE_URIS, null,
                        TP.START_SIGNAL_BATCH, batchID,
                        TP.END_SIGNAL_BATCH, batchID));

    return this;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('removeRowsFromAt',
function(aCollectionURI, aDeleteIndex) {

    /**
     * @method removeRowsFromAt
     * @summary Removes a row of data from the collection as defined by the
     *     supplied collection URI. This collection should be either the whole
     *     collection representing the data of the receiver or a subcollection
     *     of that data.
     * @param {TP.uri.URI} aCollectionURI The URI pointing to the collection to
     *     remove the row from.
     * @param {Number|Number[]} aDeleteIndex The index(es) to remove the item
     *     from in the collection.
     * @returns {Object} The receiver.
     */

    var targetCollection,

        deleteIndexes,

        removedData,

        changedAddresses,

        len,
        i,

        changedAspect,
        changedPaths,

        batchID;

    //  If the supplied URI really resolves to an Array, then remove the proper
    //  row.

    //  NB: We assume 'async' of false here.
    if (TP.isArray(
        targetCollection =
            aCollectionURI.getResource(TP.hc('async', false)).get('result'))) {

        //  If a deletion index was supplied or we have numbers in our selection
        //  indexes, then use those as the deletion indexes.
        if (TP.isNumber(deleteIndexes = aDeleteIndex)) {
            deleteIndexes = TP.ac(aDeleteIndex);
        } else if (TP.isArray(aDeleteIndex)) {
            deleteIndexes = aDeleteIndex;
        } else if (TP.notEmpty(deleteIndexes = this.get('selectionIndexes'))) {
            //  empty
        } else {
            deleteIndexes = TP.ac(targetCollection.getSize() - 1);
        }

        //  If we have an Array of deletion indexes, use a TIBET convenience
        //  method.
        if (TP.isArray(deleteIndexes)) {
            removedData = targetCollection.atAll(deleteIndexes);
            targetCollection.removeAtAll(deleteIndexes);
        } else {
            removedData = targetCollection.splice(deleteIndexes, 1);
        }

    } else {
        //  Allocate and push 0 separately to avoid oldtime JS behavior around
        //  an Array with a single Number as its argument.
        deleteIndexes = TP.ac();
        deleteIndexes.push(0);
    }

    changedAddresses = TP.ac();

    len = deleteIndexes.getSize();
    for (i = 0; i < len; i++) {
        //  The aspect that changed is just the collection along with the index
        //  that changed.
        changedAspect = aCollectionURI.getFragmentExpr() +
                        '[' + deleteIndexes.at(i) + ']';

        //  For these paths, the changed addresses are just an Array of the
        //  changed aspect.
        changedAddresses.push(changedAspect);
    }

    //  Just set the changed aspect to the first address that changed -
    //  observers can dig into the changedAddresses Array to find out exactly
    //  which aspects changed if more than 1 did.
    changedAspect = changedAddresses.first();

    //  Construct a 'changed paths' data structure that observers will expect to
    //  see.
    changedPaths = TP.hc(changedAspect, TP.hc(TP.DELETE, changedAddresses));

    //  We need this purely so that any machinery that relies on signal batching
    //  (i.e. the markup-based data binding) knows that this signal represents
    //  an entire batch.
    batchID = TP.genID('SIGNAL_BATCH');

    TP.signal(this.getID(),
                'TP.sig.StructureDelete',
                TP.hc('action', TP.DELETE,
                        'addresses', changedAddresses,
                        'aspect', changedAspect,
                        'facet', 'value',
                        TP.CHANGE_PATHS, changedPaths,
                        'target', this,
                        'indexes', deleteIndexes,
                        'removedData', removedData,
                        TP.CHANGE_URIS, null,
                        TP.START_SIGNAL_BATCH, batchID,
                        TP.END_SIGNAL_BATCH, batchID));

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETNotification.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
TIBET's signaling system core.

As mentioned elsewhere, TIBET unifies the event models of the various major
browsers under a DOM Level2 compliant bubbling/capturing mechanism. In
addition to repairing the event dispatch discrepancies, TIBET adds
signaling/notification to the rest of the system so that any object can be a
sender or receiver of events -- and events can be of any form, UI or
otherwise. In fact, events can also be distributed across the wire to
support creation of collaborative web applications. TIBET's
event/signaling system ties directly into the concept of workflow very
quickly, see the workflow module for more information.
*/

//  ========================================================================
//  Annotation
//  ========================================================================

/*
 * Annotations are simple objects which bind an object and a message. The
 * typical object used is an Error but it can be any type. Annotations are
 * introduced in the boot system as TP.boot.Annotation but use of that type is
 * restricted to boot code. Once the kernel has started loading we want the rest
 * of the system to rely on an Annotation which can fully participate in the
 * inheritance and reflection services provided by the kernel.
 */

//  ------------------------------------------------------------------------
//  TP.core.Annotation
//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.Annotation');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.core.Annotation.Inst.defineAttribute('object');
TP.core.Annotation.Inst.defineAttribute('message');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.Annotation.Inst.defineMethod('init',
function(anObject, aMessage) {

    /**
     * @method init
     * @summary Initializes a new instance and returns it.
     * @param {Object} anObject The object to annotate. Often an Error.
     * @param {String} aMessage The message to associate with anObject.
     * @returns {TP.core.Annotation} A new instance.
     */

    //  can't be null or undefined, or have empty annotation text.
    if (anObject === null || anObject === undefined || aMessage === '') {
        throw new Error('InvalidParameter');
    }

    this.callNextMethod();

    this.$set('object', anObject);
    this.$set('message', aMessage);

    return this;
});

//  ----------------------------------------------------------------------------

TP.core.Annotation.Inst.defineMethod('as',
function(typeOrFormat, formatParams) {

    /**
     * @method as
     * @summary Returns the receiver formatted to the type or format provided.
     * @param {Object} typeOrFormat The type, typename, or format to use.
     * @param {TP.core.Hash} formatParams Option parameters for the formatting
     *     process.
     * @returns {String} The receiver formatted to the type or format provided.
     */

    var type,
        args;

    if (TP.notValid(type = TP.sys.getTypeByName(typeOrFormat))) {
        return typeOrFormat.transform(this, formatParams);
    }

    //  if we got here we're either talking to a type that can't tell us
    //  what its name is (not good) or the receiver doesn't implement a
    //  decent as() variant for that type. In either case however all we can
    //  do is hope the type implements from() and we'll try that approach.
    if (TP.canInvoke(type, 'from')) {
        switch (arguments.length) {
            case 1:
                return type.from(this);
            case 2:
                return type.from(this, formatParams);
            default:
                //  have to build up an argument array that includes the
                //  receiver as the first argument rather than the type
                args = TP.args(arguments);
                args.atPut(0, this);
                return type.from.apply(type, args);
        }
    }
});

//  ----------------------------------------------------------------------------

TP.core.Annotation.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver. By
     *     default this method returns the receiver's string value without
     *     changes.
     * @returns {String} The receiver in HTML string format.
     */

    return TP.join(
            '<span class="TP_core_Annotation">',
            '<span data-name="object">',
                TP.htmlstr(this.$get('object')), '</span>',
            '<span data-name="message">',
                TP.htmlstr(this.$get('message')), '</span>',
            '</span>');
});

//  ----------------------------------------------------------------------------

TP.core.Annotation.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    return '{"type": "TP.core.Annotation",' +
            '"data": {"object": ' +
                TP.str(this.$get('object')).quoted('"') + ',' +
            '"message": ' +
                TP.str(this.$get('message')).quoted('"') + '}}';
});

//  ----------------------------------------------------------------------------

TP.core.Annotation.Inst.defineMethod('asString',
function() {

    /**
     * @method asString
     * @summary Returns the receiver as a simple string. Just the message is
     *     used for this output.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    return this.$get('message');
});

//  ----------------------------------------------------------------------------

TP.core.Annotation.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver. By
     *     default this method returns the receiver's string value without
     *     changes.
     * @returns {String} The receiver in XML string format.
     */

    return TP.join('<instance type="TP.core.Annotation"',
                            ' object="', TP.str(this.$get('object')), '"',
                            ' message="', TP.str(this.$get('message')), '"/>');
});

//  ----------------------------------------------------------------------------

TP.core.Annotation.Inst.defineMethod('toString',
function() {

    /**
     * @method toString
     * @summary Returns a string representation of the receiver.
     * @returns {String}
     */

    return TP.join(TP.str(this.$get('message')),
                            ' [', TP.str(this.$get('object')), ']');
});

//  ----------------------------------------------------------------------------
//  TP Primitive
//  ----------------------------------------------------------------------------

TP.definePrimitive('annotate',
function(anObject, aMessage) {

    /**
     * @method annotate
     * @summary Initializes a new instance and returns it.
     * @param {Object} anObject The object to annotate. Often an Error.
     * @param {String} aMessage The message to associate with anObject.
     * @returns {TP.core.Annotation} A new instance.
     */

    return TP.core.Annotation.construct(anObject, aMessage);
});

//  ----------------------------------------------------------------------------

TP.definePrimitive('isAnnotation',
function(anObject) {

    /**
     * @method isAnnotation
     * @summary Returns true if the object provided is an instance of Annotation
     *     of either the boot or core variant.
     * @param {Object} anObject The object to test.
     * @returns {Boolean} True if the object is any form of annotation.
     */

    /* eslint-disable no-extra-parens */
    return (anObject instanceof TP.boot.Annotation) ||
        TP.isKindOf(anObject, TP.core.Annotation);
    /* eslint-enable no-extra-parens */
});

//  ========================================================================
//  SIGNALING
//  ========================================================================

/*
Definitions of the core TIBET objects that form the critical elements of the
signaling kernel and the signal inheritance hierarchy others will use.
*/

//  ------------------------------------------------------------------------
//  Signal
//  ------------------------------------------------------------------------

/*
TP.sig.Signal is the core signaling class from which all other signals
derive. As part of the TP.sig.Signal installation we add a new TP.signal()
implementation that is TP.sig.Signal-aware.
*/

TP.lang.Object.defineSubtype('sig.Signal');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  signal phases for DOM 2 simulation
TP.sig.Signal.Type.defineAttribute(
        'phases', TP.ac(TP.CAPTURING, TP.AT_TARGET, TP.BUBBLING));

//  does this signal type bubble? typically only DOM signals do
TP.sig.Signal.Type.defineAttribute('bubbling', false);

//  is this signal type cancelable? typically signals can be stopped
TP.sig.Signal.Type.defineAttribute('cancelable', true);

//  is the receiver a controller root, meaning controller traversal stops?
TP.sig.Signal.Type.defineAttribute('controllerRoot', null);

//  is the receiver a controller signal, meaning controllers are notified?
TP.sig.Signal.Type.defineAttribute('controllerSignal', null);

//  TIBET's default is to use observer-style firing.
TP.sig.Signal.Type.defineAttribute('defaultPolicy', TP.OBSERVER_FIRING);

//  The list of signal names for the receiving type. Serves as a cache for the
//  common instance signal name list query.
TP.sig.Signal.Type.defineAttribute('signalNames', null);

//  is the receiver a signaling root, meaning inheritance traversal stops?
TP.sig.Signal.Type.defineAttribute('signalRoot', null);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.sig.Signal.Type.defineMethod('defineSubtype',
function() {

    /**
     * @method defineSubtype
     * @summary Creates a new subtype. This particular override ensures that all
     *     direct subtypes of TP.sig.Signal serve as signaling roots, meaning
     *     that you never signal a raw TP.sig.Signal without a spoofed signal
     *     name.
     * @returns {TP.sig.Signal} A new signal-derived type object.
     */

    var type;

    type = this.callNextMethod();

    if (this === TP.sig.Signal) {
        type.isSignalingRoot(true);
    }

    return type;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Type.defineMethod('fire',
function(anOrigin, aPayload, aPolicy) {

    /**
     * @method fire
     * @summary Activates a signal instance via the policy specified. The
     *     instance in question will be whatever the receiver returns in
     *     response to an empty construct() call. Use construct().fire()
     *     directly if you need to configure the signal instance manually.
     * @param {Object} anOrigin Optional origin for this call.
     * @param {Object[]} aPayload Optional signal arguments.
     * @param {Function} aPolicy A firing policy function.
     * @returns {TP.sig.Signal} The signal.
     */

    return this.construct().fire(anOrigin, aPayload, aPolicy);
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Type.defineMethod('getDefaultPolicy',
function() {

    /**
     * @method getDefaultPolicy
     * @summary Returns the default firing policy to use for signals of this
     *     type when no other policy is provided.
     * @returns {String} The firing policy name such as TP.OBSERVER_FIRING.
     */

    return this.$get('defaultPolicy');
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Type.defineMethod('getPhases',
function() {

    /**
     * @method getPhases
     * @summary Returns the different phases a signal might be at during
     *     firing. These typically correspond to the DOM phases.
     * @returns {String[]} The list of phases that a signal could be in.
     */

    return this.phases;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Type.defineMethod('getSignalName',
function() {

    /**
     * @method getSignalName
     * @summary Returns the name of the signal. This method is added to the
     *     type to allow the type and instances to work polymorphically in
     *     defining the signal name.
     * @returns {String}
     */

    //  By default, the signal name is the type name
    return this.getName();
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Type.defineMethod('getSignalNames',
function() {

    /**
     * @method getSignalNames
     * @summary Returns the list of signal names from this type through
     *     TP.sig.Signal by traversing it's supertype chain..
     * @returns {String}
     */

    var names,
        type;

    names = this.$get('signalNames');
    if (TP.isValid(names)) {
        //  Copy so we don't have issues with changes to this list by callers.
        return names.slice(0);
    }

    names = TP.ac();

    /* eslint-disable consistent-this */

    type = this;

    while (type) {
        names.push(type.getSignalName());
        if (type === TP.sig.Signal) {
            break;
        }
        type = type.getSupertype();
    }

    /* eslint-enable consistent-this */

    this.$set('signalNames', names, false);

    return names.slice(0);
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Type.defineMethod('getSignalOwner',
function() {

    /**
     * @method getSignalOwner
     * @summary Returns the name of the signal's owner, an object which takes
     *     responsibility for observations of this signal type. Default is null
     *     since most signals aren't "owned".
     * @returns {Object} The receiver's owner.
     */

    return null;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Type.defineMethod('getSupertypeSignalNames',
function() {

    /**
     * @method getSupertypeSignalNames
     * @summary Returns the 'supertypes signal names' - that is, each supertype
     *     name encoded as a signal name.
     * @returns {String[]} An Array of supertype signal names.
     */

    var type;

    type = this.getSupertype();

    if (TP.canInvoke(type, 'getSignalNames')) {
        return type.getSignalNames();
    }

    return TP.ac();
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Type.defineMethod('isBubbling',
function() {

    /**
     * @method isBubbling
     * @summary Returns true if the signal bubbles. This is typically only used
     *     by signals which use DOM firing policies.
     * @description When a signal isBubbling and it is being fired via a DOM
     *     policy it will not stop TP.AT_TARGET but will continue up through the
     *     parent chain until it reaches the outermost DOM element containing
     *     it. Most signals bubble.
     * @returns {Boolean} True if the signal bubbles during DOM firing.
     */

    return this.$get('bubbling');
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Type.defineMethod('isCancelable',
function() {

    /**
     * @method isCancelable
     * @summary Returns true if the signal can be cancelled (i.e. it will
     *     respond to a stopPropagation() message by allowing itself to stop
     *     being sent to qualified handlers.
     * @returns {Boolean} True if the signal can be cancelled.
     */

    return this.$get('cancelable');
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Type.defineMethod('isControllerRoot',
function(aFlag) {

    /**
     * @method isControllerRoot
     * @summary Combined setter/getter for whether signals of this type act
     *     as the 'root' for controller signaling. This stops the receiving
     *     type's supertypes from being passed through the controller chain.
     * @param {Boolean} aFlag
     * @returns {Boolean}
     */

    if (aFlag !== undefined) {
        this.$set('controllerRoot', aFlag);
    }

    return this.$get('controllerRoot') === true;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Type.defineMethod('isControllerSignal',
function(aFlag) {

    /**
     * @method isControllerSignal
     * @summary Combined setter/getter for whether signals of this type will
     *     stop before traversing the TIBET controller chain. Only controller
     *     signals (Routing, Workflow, UI signals, etc) notify controllers.
     * @param {Boolean} aFlag
     * @returns {Boolean} Whether or not signals of this type will traverse the
     *     TIBET controller chain or not.
     */

    if (aFlag !== undefined) {
        this.$set('controllerSignal', aFlag);
    }

    return this.$get('controllerSignal') === true;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Type.defineMethod('isSignalingRoot',
function(aFlag) {

    /**
     * @method isSignalingRoot
     * @summary Combined setter/getter for whether signals of this type form a
     *     local signaling root. When true certain forms of signaling will stop
     *     traversing supertypes and stop with the receiver.
     * @param {Boolean} aFlag
     * @returns {Boolean} Whether or not signals of this type will stop
     *     traversing supertypes in certain forms of signaling.
     */

    if (TP.isDefined(aFlag)) {
        this.$set('signalRoot', aFlag);
    }

    return TP.isTrue(this.$get('signalRoot'));
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Type.defineMethod('needsObserve',
function() {

    /**
     * @method needsObserve
     * @summary Returns whether or not the default firing policy of signals of
     *     this type require observers to use an 'observe' call in order to
     *     receive the signals.
     * @returns {Boolean} Whether or not observers need to use an 'observe'
     *     call.
     */

    var policy;

    policy = this.$get('defaultPolicy');

    //  TP.DOM_FIRING doesn't require an 'observe' for observing only bubbling
    //  when the observer is an element, but does so for capturing signals and
    //  for non-element observers, so we return true here for that.
    /* eslint-disable no-extra-parens */
    return (policy === TP.OBSERVER_FIRING ||
            policy === TP.DOM_FIRING ||
            policy === TP.INHERITANCE_FIRING ||
            policy === TP.EXCEPTION_FIRING ||
            policy === TP.FIRE_ONE);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

//  TP.sig.Signal is, of course, the root of all signaling types - we don't
//  signal 'above' it in the supertype chain. We've got to do this *after*
//  we define the 'isSignalingRoot' function, though ;-)
TP.sig.Signal.isSignalingRoot(true);

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  the critical elements needed to define where the signal originated
TP.sig.Signal.Inst.defineAttribute('origin');
TP.sig.Signal.Inst.defineAttribute('context');

//  a handle to the listener node currently being notified by the
//  notification processing for this signal. gives signal handlers a way to
//  access the listener they're being invoked for (when they may be used
//  across multiple handlers)
TP.sig.Signal.Inst.defineAttribute('listener');

//  skip handlers whose IDs are in this list. this is used to help avoid
//  duplicate notification of registered handlers. a handler can
//  "re-register" for notifications during processing if it needs to be
//  notified for each match that finds it
TP.sig.Signal.Inst.defineAttribute('notifiedHandlers');

//  the current DOM phase, for DOM signaling -- capturing, bubbling, or at
//  target.
TP.sig.Signal.Inst.defineAttribute('phase');

//  actual payload for the signal. for many signals this is the parameter
//  block used by handlers to define how they should response. for things
//  that carry data to/from the server this will also contain the data being
//  transported
TP.sig.Signal.Inst.defineAttribute('payload');

//  flag for reusability of the signal. this starts off false, and is
//  usually cleared by the isRecyclable call when a signal is done firing
TP.sig.Signal.Inst.defineAttribute('recyclable', false);

//  the computed responder chain for the signal. used by policies which leverage
//  responder chains for context during signal firing.
TP.sig.Signal.Inst.defineAttribute('responderChain');

//  currently executing handler
TP.sig.Signal.Inst.defineAttribute('currentHandler');

//  the pseudo-name for this signal, used for handler matching. when this is
//  empty/null it will default to the receiving signal's type name.
TP.sig.Signal.Inst.defineAttribute('signalName');

//  should default processing be prevented? this is used primarily by UI
//  signals but it can also be leveraged by other signal types.
TP.sig.Signal.Inst.defineAttribute('$shouldPrevent', false);

//  has the signal been asked to stop propagation? note that for signals
//  for which isCancelable is false this value is ignored
TP.sig.Signal.Inst.defineAttribute('$shouldStop', false);

//  has the signal been asked to stop propagation immediately? Ignored if
//  the signal is not cancellable.
TP.sig.Signal.Inst.defineAttribute('$shouldStopImmediately', false);

//  DOM/UI target
//  TODO:   needed in certain subtype, but declared here for now. perhaps
//  to ensure it's always reachable
TP.sig.Signal.Inst.defineAttribute('target');

//  start time for the initiation of the signal. Typically the fire() time
//  but this can be set directly when signals are being handled manually.
TP.sig.Signal.Inst.defineAttribute('time');

//  total time the signal took to run. typically filled in when signaling
//  and statistics capture is turned on.
TP.sig.Signal.Inst.defineAttribute('elapsed');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('init',
function(aPayload) {

    /**
     * @method init
     * @summary Initialize a new signal instance.
     * @param {Object} aPayload A subtype-specific payload/parameter object.
     * @returns {TP.sig.Signal} A new instance.
     */

    //  supertype initialization
    this.callNextMethod();

    //  set the payload so we can extract values as needed
    this.setPayload(aPayload);

    //  can't reuse this one now
    this.recyclable = false;

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('addIfAbsent',
function(anItemOrKey, aValue) {

    /**
     * @method addIfAbsent
     * @summary Using the key/value pair provided assign the value to the key
     *     in the receiver if the key doesn't already exist.
     * @param {TP.api.OrderedPair|String} anItemOrKey The ordered pair to add,
     *     or the key for a pair.
     * @param {Object} aValue Optional value to store when the first argument is
     *     a string.
     * @exception TP.sig.InvalidPair
     * @returns {Object} The key's value after processing.
     */

    var key,
        val;

    if (TP.isString(anItemOrKey)) {
        key = anItemOrKey;
        val = aValue;
    } else if (TP.isPair(anItemOrKey)) {
        //  TODO:   hopefully we don't say Hashes are ordered pairs
        key = anItemOrKey.first();
        val = anItemOrKey.last();
    } else {
        return this.raise('TP.sig.InvalidParameter', 'Invalid key or item.');
    }

    if (TP.isDefined(this.at(key))) {
        //  already has a valid value
        return this.at(key);
    }

    //  value doesn't exist yet...
    this.atPut(key, val);

    return this.at(key);
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    var marker,
        str,
        $depth,
        $level;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asDumpString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    str = '[' + this.getSignalName() + ' :: ';

    $depth = TP.ifInvalid(depth, 1);
    $level = TP.ifInvalid(level, 0);

    try {
        if ($level > $depth) {
            str += '@' + TP.id(this) + ']';
        } else {
            str += '(' + TP.dump(this.getPayload(), $depth, $level + 1) + ')' + ']';
        }
    } catch (e) {
        str += '(' + TP.str(this.getPayload()) + ')' + ']';
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver.
     * @returns {String} The receiver in HTML string format.
     */

    var marker,
        str;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asHTMLString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    try {
        str = '<span class="TP_sig_Signal ' +
                TP.escapeTypeName(TP.tname(this)) + '">' +
                    '<span data-name="payload">' +
                        TP.htmlstr(this.getPayload()) +
                     '</span>' +
                 '</span>';
    } catch (e) {
        str = this.toString();
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    var marker,
        str;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asJSONSource';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    try {
        str = '{"type":' + this.getTypeName().quoted('"') + ',' +
                '"data":{"signame":' + this.getSignalName().quoted('"') + ',' +
                '"payload":' + TP.jsonsrc(this.getPayload()) + '}}';
    } catch (e) {
        str = this.toString();
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} A new String containing the 'pretty print' string of
     *     the receiver.
     */

    var marker,
        str;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asPrettyString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    try {
        str = '<dl class="pretty ' + TP.escapeTypeName(TP.tname(this)) + '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' +
                        this.getTypeName() +
                    '</dd>' +
                    TP.pretty(this.getPayload()) +
                    '</dl>';
    } catch (e) {
        str = this.toString();
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns the receiver as a string.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the TP.sig.Signal's String representation. The default is true.
     * @returns {String} The receiver as a String.
     */

    var marker,
        wantsVerbose,
        str;

    wantsVerbose = TP.ifInvalid(verbose, true);
    if (!wantsVerbose) {
        return this.getSignalName() + TP.OID_PREFIX +
                this.toString().split(TP.OID_PREFIX).last();
    }

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    //  NB: We force the TP.str() rep of the payload to be verbose.
    try {
        str = this.getSignalName() +
                ' :: ' +
                '(' + TP.str(this.getPayload(), true) + ')';
    } catch (e) {
        str = this.toString();
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a TIBET source code string.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    var marker,
        payload,
        str,
        keys;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asSource';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    try {
        if (TP.isDefined(payload = this.getPayload())) {
            str = this.getTypeName() + '.construct(' + TP.src(payload) + ')';
        } else {
            str = this.getTypeName() + '.construct()';
        }

        //  Make sure to remove the 'payload' key since we already use the
        //  payload in the constructor.
        keys = this.getUniqueValueKeys();
        keys.remove('payload');

        str += this.$generateSourceSets(keys);
    } catch (e) {
        str = this.toString();
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver.
     * @returns {String} The receiver in XML string format.
     */

    var marker,
        str;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asXMLString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    try {
        str = '<instance type="' + TP.tname(this) + '">' +
                    '<payload>' +
                        TP.xmlstr(this.getPayload()) +
                     '</payload>' +
                 '</instance>';
    } catch (e) {
        str = this.toString();
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('at',
function(aKey) {

    /**
     * @method at
     * @summary Returns the value of the named parameter from the receiver's
     *     payload/parameter object. This is the proper way to access the
     *     content of the signal in terms of its control parameters. Don't use
     *     set() to manage parameter data.
     * @param {String} aKey The name/key of the parameter to return.
     * @returns {Object|undefined} The value of the parameter registered under
     *     aKey.
     */

    var payload;

    payload = this.getPayload();
    if (TP.isValid(payload)) {
        if (TP.canInvoke(payload, 'at')) {
            return payload.at(aKey);
        } else if (TP.canInvoke(payload, 'get')) {
            return payload.get(aKey);
        } else {
            //  If at() and get() don't work, try direct slot access
            try {
                return payload[aKey];
            } catch (e) {
                TP.ifError() ?
                    TP.error(
                        TP.ec(
                            e,
                            'Error retrieving signal payload property:' + aKey),
                        TP.SIGNAL_LOG) : 0;
            }
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('atIfInvalid',
function(anIndex, aDefault) {

    /**
     * @method atIfInvalid
     * @summary Returns the value at the index provided or the default value if
     *     the key returns null or undefined.
     * @param {Object} anIndex The index of the value to return.
     * @param {Object} aDefault The default value to return if invalid.
     * @returns {Object} The element at anIndex in this collection.
     */

    var value;

    if (TP.isValid(value = this.at(anIndex))) {
        return value;
    } else if (TP.isCallable(aDefault)) {
        return aDefault();
    } else {
        return aDefault;
    }
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('atIfNull',
function(anIndex, aDefault) {

    /**
     * @method atIfNull
     * @summary Returns the value at the index provided or the default value if
     *     the key returns specifically null.
     * @param {Object} anIndex The index of the value to return.
     * @param {Object} aDefault The default value to return if null.
     * @returns {Object} The element at anIndex in this collection.
     */

    var value;

    if (TP.notNull(value = this.at(anIndex))) {
        return value;
    } else if (TP.isCallable(aDefault)) {
        return aDefault();
    } else {
        return aDefault;
    }
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('atIfUndefined',
function(anIndex, aDefault) {

    /**
     * @method atIfUndefined
     * @summary Returns the value at the index provided or the default value if
     *     the key returns specifically undefined.
     * @param {Object} anIndex The index of the value to return.
     * @param {Object} aDefault The default value to return if undefined.
     * @returns {Object} The element at anIndex in this collection.
     */

    var value;

    if (TP.isDefined(value = this.at(anIndex))) {
        return value;
    } else if (TP.isCallable(aDefault)) {
        return aDefault();
    } else {
        return aDefault;
    }
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('atPut',
function(aKey, aValue) {

    /**
     * @method atPut
     * @summary Defines a key/value pair in the receiver's payload, provided
     *     that the payload is empty and can be constructed, or that it can
     *     handle an atPut operation. This is the preferred way of manipulating
     *     the content of the signal in terms of its control parameters.
     * @description Note that this method does not signal 'Change', even if it's
     *     'shouldSignalChange' attribute is true. Observe the payload for
     *     change notification.
     * @param {String} aKey The key for the parameter.
     * @param {Object} aValue The value for the parameter.
     * @returns {TP.sig.Signal} The receiver.
     */

    var payload;

    payload = this.getPayload();
    if (TP.notValid(payload)) {
        this.set('payload', TP.hc(aKey, aValue));

        return this;
    }

    if (TP.canInvoke(payload, 'atPut')) {
        payload.atPut(aKey, aValue);

        return this;
    }

    if (TP.canInvoke(payload, 'set')) {
        payload.set(aKey, aValue);

        return this;
    }

    try {
        payload[aKey] = aValue;

        return this;
    } catch (e) {
        TP.ifError() ?
            TP.error(
                TP.ec(e, 'Error setting signal payload property:' + aKey),
                TP.SIGNAL_LOG) : 0;
    }

    this.raise('TP.sig.InvalidPayload',
                    'Unable to set payload parameter: ' + aKey);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('atPutIfAbsent',
function(aKey, aValue) {

    /**
     * @method atPutIfAbsent
     * @summary Defines a key/value pair in the receiver's payload, provided
     *     that the payload does not already contain a value for the key in
     *     question.
     * @description Note that this method does not signal 'Change', even if it's
     *     'shouldSignalChange' attribute is true. Observe the payload for
     *     change notification.
     * @param {String} aKey The key for the parameter.
     * @param {Object} aValue The value for the parameter.
     * @returns {Object} The key's value after processing.
     */

    var payload,
        val;

    payload = this.getPayload();
    if (TP.notValid(payload)) {
        this.set('payload', TP.hc(aKey, aValue));

        return aValue;
    }

    //  hashes can manage this for us themselves
    if (TP.canInvoke(payload, 'atPutIfAbsent')) {
        return payload.atPutIfAbsent(aKey, aValue);
    }

    if (TP.notDefined(val = this.at(aKey))) {
        this.atPut(aKey, aValue);

        return aValue;
    }

    return val;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('clearNotifications',
function() {

    /**
     * @method clearNotifications
     * @summary Clears any tracked handlers from the receiver's list so that
     *     all handlers are "renewed". Tracking allow a handler to be invoked
     *     once even if it's been registered multiple times. Clearing them means
     *     the same handler can be reinvoked.
     * @returns {TP.sig.Signal} The receiver.
     */

    var skips;

    //  empty so when reusing a signal instance we can reuse the list too
    if (TP.isValid(skips = this.get('notifiedHandlers'))) {
        skips.empty();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('computeSignalName',
function() {

    /**
     * @method computeSignalName
     * @summary Computes the signal name. By default, this is the receiver's
     *     type name.
     * @returns {String} The signal name of the receiver.
     */

    return this.getTypeName();
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('copy',
function(deep, aFilterNameOrKeys, contentOnly) {

    /**
     * @method copy
     * @summary Returns a 'copy' of the receiver. Actually, a new instance
     *     whose value is equalTo that of the receiver.
     * @param {Boolean} [deep=false] True to force clones to be deep.
     * @param {String|String[]} aFilterNameOrKeys get*Interface() filter or key
     *     array.
     * @param {Boolean} [contentOnly=true] Copy content only?
     * @returns {TP.sig.Signal} A copy of the receiver.
     */

    var newinst,

        onlyContent,

        filter,
        keys,

        len,
        i,
        ndx,
        val;

    newinst = this.getType().construct();

    newinst.origin = this.origin;
    newinst.context = this.context;

    newinst.listener = this.listener;

    newinst.notifiedHandlers = this.notifiedHandlers;

    newinst.phase = this.phase;

    //  Make sure to do a true copy of the signal's payload.
    newinst.payload = TP.copy(this.payload);

    newinst.recyclable = this.recyclable;

    newinst.signalName = this.signalName;

    newinst.$shouldPrevent = this.$shouldPrevent;
    newinst.$shouldStop = this.$shouldStop;

    newinst.target = this.target;
    newinst.time = this.time;

    onlyContent = TP.ifInvalid(contentOnly, true);
    if (onlyContent) {
        //  content only
        return newinst;
    } else {
        filter = TP.ifInvalid(aFilterNameOrKeys, TP.UNIQUE);

        if (TP.isString(filter)) {
            keys = this.getLocalInterface(filter);
        } else if (TP.isArray(filter)) {
            keys = filter;
        } else {
            //  Unusable filter
            return newinst;
        }

        len = keys.getSize();

        for (i = 0; i < len; i++) {
            ndx = keys.at(i);
            val = this.at(ndx);

            if (TP.isTrue(deep) && TP.isReferenceType(val)) {
                //  NB: We do *not* pass along the filter name or keys here
                val = TP.copy(val, deep, null, contentOnly);
            }

            newinst.$set(ndx, val, false, true);
        }
    }

    return newinst;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('fire',
function(anOrigin, aPayload, aPolicy) {

    /**
     * @method fire
     * @summary Activates the signal instance via the policy specified. The
     *     signal should have been fully configured prior to invocation of this
     *     method.
     * @param {Object} anOrigin Optional origin for this call.
     * @param {Object[]} aPayload Optional signal arguments.
     * @param {Function} aPolicy A firing policy function.
     * @returns {TP.sig.Signal} The signal.
     */

    var origin;

    //  allow refiring of signals
    this.stopPropagation(false);

    //  don't prevent default unless told (again)
    this.preventDefault(false);

    //  default our origin to whatever may already have been set, or to the
    //  receiver itself, which is part of what makes "fire" different from
    //  simple signaling
    if (TP.isValid(anOrigin)) {
        origin = anOrigin;
    } else {
        origin = TP.ifInvalid(this.getOrigin(), this);
    }
    this.setOrigin(origin);

    //  instrument with current firing time
    this.$set('time', Date.now());

    //  if the signal has an origin fire from there, otherwise the
    //  signal itself will be the origin
    return TP.signal(this.getOrigin(), this, aPayload, aPolicy);
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('getActiveTime',
function() {

    /**
     * @method getActiveTime
     * @summary Returns the active time from fire() to the current time in
     *     milliseconds.
     * @returns {Number} The active time of the receiver.
     */

    var time;

    if (TP.isNumber(time = this.$get('time'))) {
        return Date.now() - time;
    }

    return NaN;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('getDocument',
function() {

    /**
     * @method getDocument
     * @summary Returns the document from which the signal originated. This is
     *     typically the TIBET window's document, but it can vary when UI events
     *     are involved.
     * @returns {TP.dom.Document} The document that the signal originated in.
     */

    return this.getWindow().getDocument();
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('getElapsedTime',
function() {

    /**
     * @method getElapsedTime
     * @summary Returns the total elapsed time from fire() to completion. When
     *     the signal is not done being processed this method returns NaN.
     * @returns {Number} The elapsed time of the receiver.
     */

    return this.$get('elapsed') || NaN;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('getOrigin',
function() {

    /**
     * @method getOrigin
     * @summary Returns the origin of the signal.
     * @returns {Object} The origin of the receiver.
     */

    return this.origin;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('getParameters',
function() {

    /**
     * @method getParameters
     * @summary Returns the signal's parameters, which are typically encoded in
     *     the receiver's payload. The semantics of this call are slightly
     *     different however, only returning the payload when it implements the
     *     at/atPut methods. You should not manipulate this hash to set
     *     properties since it isn't guaranteed to not be a copy or temporary
     *     empty result set.
     * @returns {TP.core.Hash|TP.sig.Request} Parameter data (typically).
     */

    var params;

    params = this.getPayload();
    if (TP.isValid(params)) {
        if (TP.canInvokeInterface(params, TP.ac('at', 'atPut'))) {
            return params;
        }
    }

    //  empty, but not associated
    return TP.hc();
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('getPayload',
function() {

    /**
     * @method getPayload
     * @summary Returns the optional arguments to the signal.
     * @returns {Object} The payload of the receiver.
     */

    return this.payload;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('getPhase',
function() {

    /**
     * @method getPhase
     * @summary Returns the currently executing phase of the signal.
     * @returns {String} The currently executing phase of the receiver.
     */

    return this.phase;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('getProperty',
function(attributeName) {

    /**
     * @method getProperty
     * @summary Returns the value, if any, for the attribute provided.
     * @description This method takes over when get() fails to find a specific
     *     getter or an aspect adapted getter. For signals we vary the default
     *     implementation in that no inferencing or backstop invocation occurs
     *     when attempting to look up values. If the receiver doesn't have the
     *     method or attribute processing stops there.
     * @param {String} attributeName The name of the attribute to get.
     * @returns {Object} The value of the named property in the receiver.
     */

    //  note no inferencing checks, we just go after the slot here. this is
    //  done so that queries against signals (which may quite often not have
    //  a particular property the handler/responder is testing for) don't
    //  trigger the inferencing engine
    return this.$get(attributeName);
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('getRequestID',
function() {

    /**
     * @method getRequestID
     * @summary A synonymn for getOrigin for non-request/response signal types.
     *     Provided to ensure polymorphic support for workflow signal
     *     processing.
     * @returns {Object} The request ID of the receiver.
     */

    return this.origin;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('getResolvedTargetGlobalID',
function() {

    /**
     * @method getResolvedTargetGlobalID
     * @summary Returns the global id of the 'resolved' target of the signal.
     *     For most events this is the same as the origin, but for DOM events,
     *     particularly those with a native event component, this will often be
     *     the global ID of the 'resolved' target element.
     * @returns {String} The 'global ID' of the 'resolved' target of the
     *     receiver.
     */

    var payload,
        id,
        inst;

    //  fast approach is to use the data in any event/hash with the payload
    payload = this.getPayload();

    if (TP.isEvent(payload)) {
        //  events we've instrumented will have the id, otherwise we can
        //  work from the target to get its ID
        id = payload.elementGlobalID;
        if (TP.isEmpty(id)) {
            inst = payload.resolvedTarget;
            id = TP.gid(inst);
        }
    } else if (TP.isElement(payload)) {
        //  element payloads we can leverage an ID from
        id = TP.gid(payload);
    } else if (TP.isHash(payload)) {
        //  if we got a hash we can ask it
        id = payload.at('elementGlobalID');
    }

    if (TP.notEmpty(id)) {
        return id;
    }

    return this.getOrigin();
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('getSignalName',
function() {

    /**
     * @method getSignalName
     * @summary Returns the signal name. This corresponds most often to the
     *     Signal's type name but will differ in the case of spoofed signals.
     * @returns {String} The signal name of the receiver.
     */

    var signame;

    if (TP.isEmpty(signame = this.$get('signalName'))) {
        signame = this.computeSignalName();
        this.$set('signalName', signame, false);
    }

    return signame;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('getSignalNames',
function() {

    /**
     * @method getSignalNames
     * @summary Returns the all of the receiver's 'signal names' - that is,
     *     the 'type' signal name, all of the supertypes signal names *and* the
     *     receiver's direct *signal* name (if it's a spoofed signal and has a
     *     different name than it's type).
     * @description Note that this method is different than
     *     'getTypeSignalNames()' below in that this method will always use the
     *     signal name, even for the receiving type - which for a spoofed signal
     *     will be different than its type name.
     * @returns {String[]} An Array of signal names.
     */

    var names;

    names = this.getTypeSignalNames();

    if (!names.contains(this.getSignalName())) {
        names.unshift(this.getSignalName());
    }

    return names;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('getSupertypeSignalNames',
function() {

    /**
     * @method getSupertypeSignalNames
     * @summary Returns the 'supertypes signal names' - that is, each supertype
     *     name encoded as a signal name.
     * @returns {String[]} An Array of supertype signal names.
     */

    var type;

    type = this.getType().getSupertype();

    if (TP.canInvoke(type, 'getSignalNames')) {
        return type.getSignalNames();
    }

    return TP.ac();
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('getSignalOrigin',
function() {

    /**
     * @method getSignalOrigin
     * @summary Returns the origin of the signal. This is an alias for
     *     getOrigin to maintain API symmetry with getSignalName.
     * @returns {String} The signal origin of the receiver.
     */

    return this.getOrigin();
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('getTarget',
function() {

    /**
     * @method getTarget
     * @summary Returns the target of the signal. For most events this is the
     *     origin _object_, but for DOM events, particularly those with a native
     *     event component, this will be the element.
     * @returns {Object} The target of the receiver.
     */

    var payload,
        origin,
        inst,
        id;

    //  DOM-based signals, which are the most common consumers of a "target",
    //  are usually provided either the original event or a hash with specific
    //  keys

    payload = this.getPayload();

    if (TP.isEvent(payload)) {
        inst = TP.eventGetTarget(payload);
    } else if (TP.isElement(payload)) {
        inst = payload;
    } else if (TP.canInvoke(payload, 'at')) {
        id = payload.at('elementGlobalID');
        if (TP.notEmpty(id)) {
            if (TP.isValid(inst = TP.bySystemId(id))) {
                if (TP.canInvoke(inst, 'getNativeNode')) {
                    inst = inst.getNativeNode();
                }
            }
        } else {
            inst = payload.at('target');
        }
    } else {
        origin = this.getOrigin();
        if (TP.isValid(origin)) {
            if (TP.isString(origin)) {
                inst = TP.bySystemId(origin);
            } else {
                inst = origin;
            }

            if (TP.canInvoke(inst, 'getNativeNode')) {
                inst = inst.getNativeNode();
            }
        }
    }

    return inst;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('getTypeSignalNames',
function() {

    /**
     * @method getTypeSignalNames
     * @summary Returns the list of signal names acquired from the receiver's
     *     type and its supertypes up through TP.sig.Signal. This differs from
     *     getSignalNames in that 'type signal' names will never include
     *     spoofed signal names in the result list.
     * @returns {String[]} An Array of signal type names.
     */

    return this.getType().getSignalNames();
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('getWindow',
function() {

    /**
     * @method getWindow
     * @summary Returns the window from which the signal originated. This is
     *     typically the TIBET window, but it can vary when UI events are
     *     involved.
     * @returns {TP.core.Window} The window object that the receiver occurred
     *     in.
     */

    var payload,
        canvasWin;

    payload = this.getPayload();

    if (TP.isEvent(payload)) {
        canvasWin = TP.win(payload.view);
        if (TP.notValid(canvasWin)) {
            canvasWin = TP.sys.getUICanvas();
        }
        return canvasWin;
    }

    if (TP.canInvoke(payload, 'at')) {
        canvasWin = TP.win(payload.at('view'));
        if (TP.notValid(canvasWin)) {
            canvasWin = TP.sys.getUICanvas();
        }
        return canvasWin;
    }

    //  We didn't get a valid signal payload object, but we can try to use
    //  the UICanvas's window anyway.
    if (TP.isWindow(canvasWin = TP.sys.getUICanvas(true))) {
        return TP.wrap(canvasWin);
    }

    //  Can't do any good here. No payload and no canvas window. Just
    //  hand back the 'tibet' window.
    return TP.wrap(window);
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('hasNotified',
function(aHandler, aContext) {

    /**
     * @method hasNotified
     * @summary Returns true if the signal should skip over notification of the
     *     handler ID provided. This method works along with the trackHandler
     *     method to let the signaling system support turning off multiple
     *     notifications to a handler of a particular signal instance.
     * @param {String|Object} aHandler A handler whose ID will be checked
     *     against the notification list for this instance.
     * @param {Object} aContext The object context that the handler is currently
     *     executing in. Note that this and the handler can be the same object
     *     in some circumstances
     * @returns {Boolean} True if the signal should not be presented to the
     *     handler for processing.
     */

    var skips,
        handlerKey,
        skipCount;

    if (TP.notValid(skips = this.get('notifiedHandlers'))) {
        return false;
    }

    if (TP.notValid(aHandler)) {
        return true;
    }

    //  The handlerKey is made up of the context ID, the handler's ID and the
    //  current signal name. This allows proper skip/renew behavior when
    //  dispatching through an inheritance hierarchy of signals.
    handlerKey = aContext.getID() +
                    '_' +
                    aHandler.getID() +
                    '_' +
                    this.getID();

    skipCount = skips.at(handlerKey);
    if (TP.isValid(skipCount)) {
        return skipCount > 0;
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('isBubbling',
function() {

    /**
     * @method isBubbling
     * @summary Returns true if the signal bubbles. This is typically only used
     *     by signals which use DOM firing policies.
     * @description When a signal isBubbling and it is being fired via a DOM
     *     policy it will not stop TP.AT_TARGET but will continue up through the
     *     parent chain until it reaches the outermost DOM element containing
     *     it. Most signals bubble.
     * @returns {Boolean} True if the signal bubbles during DOM firing.
     */

    var flag;

    if (TP.notEmpty(flag = this.$get('bubbling'))) {
        return flag;
    }

    return this.getType().isBubbling();
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('isCancelable',
function() {

    /**
     * @method isCancelable
     * @summary Returns true if the signal can be cancelled (i.e. it will
     *     respond to a stopPropagation() message by allowing itself to stop
     *     being sent to qualified handlers.
     * @returns {Boolean} True if the signal can be cancelled.
     */

    var flag;

    if (TP.notEmpty(flag = this.$get('cancelable'))) {
        return flag;
    }

    return this.getType().isCancelable();
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('isControllerRoot',
function(aFlag) {

    /**
     * @method isControllerRoot
     * @summary Combined setter/getter for whether signals of this type form a
     *     local signaling root. When true certain forms of signaling will stop
     *     traversing supertypes and stop with the receiver.
     * @param {Boolean} aFlag
     * @returns {Boolean} Whether or not the receiver can be considered a
     *     'signaling root'.
     */

    var type,
        sigType;

    type = this.getType();

    sigType = TP.sig.SignalMap.$getSignalType(this, type);
    if (TP.isString(sigType)) {
        sigType = TP.sys.getTypeByName(sigType);
    }

    if (!TP.isType(sigType)) {
        sigType = type;
    }

    return sigType.isControllerRoot(aFlag);
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('isControllerSignal',
function(aFlag) {

    /**
     * @method isControllerSignal
     * @summary Combined setter/getter for whether signals of this type will
     *     stop before traversing the TIBET controller chain. Only controller
     *     signals (Routing, Workflow, UI signals, etc)  notify controllers.
     * @param {Boolean} aFlag
     * @returns {Boolean} Whether or not signals of this type will traverse the
     *     TIBET controller chain or not.
     */

    var type,
        sigType;

    type = this.getType();

    sigType = TP.sig.SignalMap.$getSignalType(this, type);
    if (TP.isString(sigType)) {
        sigType = TP.sys.getTypeByName(sigType);
    }

    if (!TP.isType(sigType)) {
        sigType = type;
    }

    return sigType.isControllerSignal(aFlag);
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('isRecyclable',
function(aFlag) {

    /**
     * @method isRecyclable
     * @summary Returns true if the signal can be recycled.
     * @param {Boolean} aFlag A new setting. Optional.
     * @returns {Boolean} True if the signal can be recycled.
     */

    if (TP.isBoolean(aFlag)) {
        this.$set('recyclable', aFlag);
    }

    return TP.isTrue(this.$get('recyclable'));
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('isSignalingRoot',
function(aFlag) {

    /**
     * @method isSignalingRoot
     * @summary Combined setter/getter for whether signals of this type form a
     *     local signaling root. When true certain forms of signaling will stop
     *     traversing supertypes and stop with the receiver.
     * @param {Boolean} aFlag
     * @returns {Boolean} Whether or not the receiver can be considered a
     *     'signaling root'.
     */

    var sigType;

    sigType = TP.sig.SignalMap.$getSignalType(this, this.getType());

    if (!TP.isType(sigType)) {
        sigType = TP.sys.getTypeByName(sigType);
    }

    if (!TP.isType(sigType)) {
        sigType = this.getType();
    }

    return sigType.isSignalingRoot(aFlag);
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('isSpoofed',
function() {

    /**
     * @method isSpoofed
     * @summary Returns true if the signal is 'spoofed' - that is, it has a
     *     custom signal name different from its type name.
     * @returns {Boolean} True if the signal is spoofed.
     */

    return this.getTypeName() !== TP.expandSignalName(this.getSignalName());
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('preventDefault',
function(aFlag) {

    /**
     * @method preventDefault
     * @summary Tells a potential handler to not perform whatever default
     *     action it might perform.
     * @description Note that this method does not signal 'Change', even if it's
     *     'shouldSignalChange' attribute is true.
     * @param {Boolean} aFlag Prevent default: yes or no?
     * @returns {Boolean} True if the signal should not perform its default
     *     action.
     */

    var flag;

    flag = TP.ifInvalid(aFlag, true);

    return this.shouldPrevent(flag);
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('release',
function() {

    /**
     * @method release
     * @summary Clears the receiver's recyclable flag, allowing it to be
     *     reused.
     * @returns {TP.sig.Signal} The receiver.
     */

    this.recyclable = true;

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('recycle',
function() {

    /**
     * @method recycle
     * @summary Prepares the receiver for a new usage cycle.
     * @returns {TP.sig.Signal} The receiver.
     */

    this.origin = null;
    this.context = null;

    this.listener = null;

    this.notifiedHandlers = null;

    this.phase = null;

    this.payload = null;

    this.recyclable = false;

    this.signalName = null;

    this.$shouldPrevent = false;
    this.$shouldStop = false;

    this.$shouldScanSupers = false;

    this.target = null;
    this.time = null;

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('removeKey',
function(aKey) {

    /**
     * @method removeKey
     * @summary Removes a key (and it's attendant value) from the receiver's
     *     payload, provided that the payload can handle a removeKey operation.
     * @description Note that this method does not signal 'Change', even if it's
     *     'shouldSignalChange' attribute is true. Observe the payload for
     *     change notification.
     * @param {String} aKey The key for the parameter.
     * @returns {TP.sig.Signal} The receiver.
     */

    var payload;

    payload = this.getPayload();
    if (TP.notValid(payload)) {
        return this;
    }

    if (TP.canInvoke(payload, 'removeKey')) {
        payload.removeKey(aKey);

        return this;
    }

    this.raise('TP.sig.InvalidPayload',
                    'Unable to remove payload key: ' + aKey);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('renewHandler',
function(aHandler, aContext) {

    /**
     * @method renewHandler
     * @summary Tells the signal instance to reset a specific handler ID so
     *     that the handler can be told multiple times about a single signal
     *     instance. Usually invoked by the handler itself so it can be invoked
     *     multiple times.
     * @param {String|Object} aHandler The handler or handler ID that was
     *     being skipped due to prior notification for a particular sequence.
     * @param {Object|undefined} aContext The object context that the handler is
     *     currently executing in. Note that this and the handler can be the same
     *     object in some circumstances.
     */

    var handlerKey,
        skips,

        skipCount;

    if (TP.notValid(aHandler)) {
        return;
    }

    //  The handlerKey is made up of the context ID, the handler's ID and the
    //  current signal name. This allows proper skip/renew behavior when
    //  dispatching through an inheritance hierarchy of signals.
    handlerKey = aContext.getID() +
                    '_' +
                    aHandler.getID() +
                    '_' +
                    this.getID();

    if (TP.notValid(skips = this.$get('notifiedHandlers'))) {
        skips = TP.hc();
        this.$set('notifiedHandlers', skips, false);
    }

    //  Decrement the count (or set it to -1). This works in conjunction with
    //  the trackHandler method (which increments or sets to 1) to allow a
    //  'count' to be kept for accurate nested behavior.
    skipCount = skips.at(handlerKey);
    if (TP.isValid(skipCount)) {
        skipCount -= 1;
    } else {
        skipCount = -1;
    }

    //  any non-true value should work here
    return skips.atPut(handlerKey, skipCount);
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('setOrigin',
function(anOrigin) {

    /**
     * @method setOrigin
     * @summary Sets the origin of the signal.
     * @description Note that this method does not signal 'Change', even if it's
     *     'shouldSignalChange' attribute is true.
     * @param {Object} anOrigin The originating object.
     * @returns {TP.sig.Signal} The receiver.
     */

    //  If the origin is a String, make sure it gets converted to a primitive
    //  string before being used
    if (TP.isString(anOrigin)) {
        this.origin = anOrigin.valueOf();
    } else {
        this.origin = anOrigin;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('setPayload',
function(anObject) {

    /**
     * @method setPayload
     * @summary Sets the payload/parameter object of the signal.
     * @description Note that this method does not signal 'Change', even if it's
     *     'shouldSignalChange' attribute is true.
     * @param {Object} anObject The optional signal payload.
     * @returns {TP.sig.Signal} The receiver.
     */

    this.payload = anObject;

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('setPhase',
function(aPhase) {

    /**
     * @method setPhase
     * @summary Sets the phase of the signal.
     * @description Note that this method does not signal 'Change', even if it's
     *     'shouldSignalChange' attribute is true.
     * @param {String} aPhase The current dispatch phase.
     * @returns {TP.sig.Signal} The receiver.
     */

    this.phase = aPhase;

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('setSignalName',
function(aSignalName, clearNotifications) {

    /**
     * @method setSignalName
     * @summary Defines the name of the signal.
     * @description By default a signal's name matches its type, but to support
     *     lightweight signals whose only differentiation is their name we allow
     *     TP.sig.Signal and other subtypes to stand in for a subtype simply by
     *     changing their names. An additional side-effect of this call is that
     *     any previous notification list is cleared since the instance's name,
     *     and hence the handlers being invoked, could change.
     * @param {String} aSignalName The name this instance should report as being
     *     its signal name.
     * @param {Boolean} clearNotifications Whether or not to 'clear' any
     *     notification list that the instance may have. This is true by default.
     * @returns {TP.sig.Signal} The receiver.
     */

    this.$set('signalName', aSignalName, false);

    if (TP.isFalse(clearNotifications)) {
        //  reset processing controls so execution can happen under new name
        this.clearNotifications();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('shouldLog',
function() {

    /**
     * @method shouldLog
     * @summary Returns true when the signal can be logged during signal
     *     processing. The default is true for most signals, but many types of
     *     signals have to check TIBET configuration flags to see if they can
     *     currently be logged.
     * @returns {Boolean} True if the signal can be logged.
     */

    return this.getType().shouldLog();
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('shouldPrevent',
function(aFlag) {

    /**
     * @method shouldPrevent
     * @summary Returns true if the signal handler(s) should not perform the
     *     default action. If a flag is provided this flag is used to set the
     *     prevent status.
     * @description Note that this method does not signal 'Change', even if it's
     *     'shouldSignalChange' attribute is true.
     * @param {Boolean} aFlag Prevent default: yes or no?
     * @returns {Boolean} True if the signal should not perform its default
     *     action.
     */

    if (TP.isDefined(aFlag)) {
        this.$shouldPrevent = aFlag;
    }

    return this.$shouldPrevent;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('shouldScanSupertypes',
function(aFlag) {

    /**
     * @method shouldScanSupertypes
     * @summary Returns true if the signal should notify observers aggressively
     *     by scanning supertypes during notification. Note that this is not the
     *     same as inheritance firing. See notifyObservers for more info.
     * @param {Boolean} aFlag Scan supertypes?
     * @returns {Boolean} True if the signal should scan supertypes.
     */

    if (TP.isDefined(aFlag)) {
        this.$shouldScanSupers = aFlag;
    }

    return this.$shouldScanSupers;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('shouldStop',
function(aFlag) {

    /**
     * @method shouldStop
     * @summary Returns true if the signal should stop propagating. If a flag
     *     is provided this flag is used to set the propagation status.
     * @description Note that this method does not signal 'Change', even if it's
     *     'shouldSignalChange' attribute is true.
     * @param {Boolean} aFlag Stop propagating: yes or no?
     * @returns {Boolean} True if the signal should stop propagation.
     */

    //  if we're not cancelable this is a no-op
    if (!this.isCancelable()) {
        return false;
    }

    if (TP.isDefined(aFlag)) {
        this.$shouldStop = aFlag;
    }

    return this.$shouldStop;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('shouldStopImmediately',
function(aFlag) {

    /**
     * @method shouldStopImmediately
     * @summary Returns true if the signal should stop propagating immediately.
     *     If a flag is provided this flag is used to set the propagation state.
     * @description Note that this method does not signal 'Change', even if it's
     *     'shouldSignalChange' attribute is true.
     * @param {Boolean} aFlag Stop propagating immediately: yes or no?
     * @returns {Boolean} True if the signal should stop propagation
     *     immediately.
     */

    //  if we're not cancelable this is a no-op
    if (!this.isCancelable()) {
        return false;
    }

    if (TP.isDefined(aFlag)) {
        this.$shouldStopImmediately = aFlag;
    }

    return this.$shouldStopImmediately;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('stopImmediatePropagation',
function(aFlag) {

    /**
     * @method stopImmediatePropagation
     * @summary Tells the signal to stop propagation immediately. This call is
     *     similar to stopPropagation for DOM-oriented signals but will cause
     *     propagation to stop within a specific set of handlers for a
     *     particular node even if all handlers at that level have not fired.
     * @description Note that this method does not signal 'Change', even if it's
     *     'shouldSignalChange' attribute is true.
     * @param {Boolean} aFlag Stop propagating immediately: yes or no?
     * @returns {Boolean} True if the signal should stop propagation.
     */

    var flag;

    flag = TP.ifInvalid(aFlag, true);

    return this.shouldStopImmediately(flag);
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('stopPropagation',
function(aFlag) {

    /**
     * @method stopPropagation
     * @summary Tells the signal to stop propagation -- subject to the
     *     observance of this property by the various firing policies and
     *     whether the receiver isCancelable()
     * @description Note that this method does not signal 'Change', even if it's
     *     'shouldSignalChange' attribute is true.
     * @param {Boolean} aFlag Stop propagating: yes or no?
     * @returns {Boolean} True if the signal should stop propagation.
     */

    var flag;

    flag = TP.ifInvalid(aFlag, true);

    return this.shouldStop(flag);
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('trackHandler',
function(aHandler, aContext) {

    /**
     * @method trackHandler
     * @summary Tells the signal instance to track a specific handler ID. This
     *     can be called on the signal instance at any time, but is typically
     *     called by the signaling system to avoid duplicate notifications
     *     during DOM traversals.
     * @param {String|Object} aHandler The handler or handler ID to skip for a
     *     particular signaling sequence.
     * @param {Object|undefined} aContext The object context that the handler is
     *     currently executing in. Note that this and the handler can be the same
     *     object in some circumstances.
     */

    var handlerKey,
        skips,

        skipCount;

    if (TP.notValid(aHandler)) {
        return;
    }

    //  The handlerKey is made up of the context ID, the handler's ID and the
    //  current signal name. This allows proper skip/renew behavior when
    //  dispatching through an inheritance hierarchy of signals.
    handlerKey = aContext.getID() +
                    '_' +
                    aHandler.getID() +
                    '_' +
                    this.getID();

    if (TP.notValid(skips = this.$get('notifiedHandlers'))) {
        skips = TP.hc();
        this.$set('notifiedHandlers', skips, false);
    }

    //  Increment the count (or set it to 1). This works in conjunction with
    //  the renewHandler method (which increments or sets to -1) to allow a
    //  'count' to be kept for accurate nested behavior.
    skipCount = skips.at(handlerKey);
    if (TP.notValid(skipCount)) {
        skipCount = 1;
    } else {
        skipCount += 1;
    }

    return skips.atPut(handlerKey, skipCount);
});

//  ------------------------------------------------------------------------
//  Exception
//  ------------------------------------------------------------------------

/*
Note that in TIBET, exceptions are just signals. This means they can be
observed by logs, by handlers, etc. It also means that they can be resolved
such that processing may continue, or the handler can terminate the
application if it so desires. This chaining is orthagonal to the try/catch
mechanism in JS so you can leverage either one, or both.

Exceptions form a hierarchy. Given that observation in TIBET is capable of
respecting such hierarchies you can observe at whatever level of granularity
you like. For example, an observation of Exception will cause you to be
notified of all exception subtypes. Observing TP.sig.IOException will get
you only TP.sig.IOException notifcations from whatever origins you define.
In this sense the system operates much like catch blocks in Java or other
languages, triggering your handler block when it matches the type, or a
subtype, of what you desire.
*/

//  ------------------------------------------------------------------------

//  root of exception/error tree
TP.sig.Signal.defineSubtype('Exception');

//  ------------------------------------------------------------------------

TP.definePrimitive('ec',
function(anError, aMessage) {

    /**
     * @method ec
     * @summary Constructs a new TP.sig.Exception using anError as the key
     *     element of the payload. An optional message augmenting the Error's
     *     native message can also be provided.
     * @param {Error} anError The Error object to use as the key element of the
     *     payload.
     * @param {String} aMessage The message to use as the message of the
     *     TP.sig.Exception. If this message is empty, the message from the
     *     Error object is used.
     */

    var msg;

    msg = TP.isEmpty(aMessage) ? anError.message : aMessage;

    return TP.sig.Exception.construct(TP.hc('error', anError,
                                            'message', msg));
});

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.sig.Exception.Type.defineAttribute('$level', TP.ERROR);

TP.sig.Exception.Type.defineAttribute('defaultPolicy', TP.EXCEPTION_FIRING);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.sig.Exception.Type.defineMethod('getLevel',
function() {

    /**
     * @method getLevel
     * @summary Returns the severity level associated with this type.
     * @returns {Number} The type's severity level.
     */

    return this.$get('$level');
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.Exception.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a TIBET source code string.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    var marker,
        err,
        msg,
        str,
        keys;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asSource';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    err = this.at('error');
    if (TP.isError(err)) {
        msg = err.message || err.toString();
    } else if (TP.isValid(err)) {
        msg = TP.str(err) || err.toString();
    } else {
        msg = this.getMessage();
    }

    try {
        str = this.getTypeName() + '.construct(' +
                'TP.hc(' +
                    '\'error\', ' + TP.src(err) + ', ' +
                    '\'message\', ' + '\'' + msg + '\'' +
                '))';

        //  Make sure to remove the 'payload' key since we already use the
        //  payload in the constructor.
        keys = this.getUniqueValueKeys();
        keys.remove('payload');

        str += this.$generateSourceSets(keys);
    } catch (e) {
        str = this.toString();
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.sig.Exception.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     *     IGNORED for this type.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     *     IGNORED for this type.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    var marker,
        err,
        msg,
        str;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asDumpString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    err = this.at('error');
    if (TP.isError(err)) {
        msg = TP.str(err) || err.toString();
        msg += TP.getStackInfo(err).join('\n');
    } else if (TP.isValid(err)) {
        msg = TP.str(err) || err.toString();
    } else {
        msg = this.getMessage();
    }

    str = '[' + this.getSignalName() + ' :: ';

    try {
        str += '(' + msg + ')' + ']';
    } catch (e) {
        str += '(' + TP.str(this.getPayload()) + ')' + ']';
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.sig.Exception.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver.
     * @returns {String} The receiver in HTML string format.
     */

    var marker,
        err,
        msg,
        str;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asHTMLString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    err = this.at('error');
    if (TP.isValid(err)) {
        msg = TP.str(err) || err.toString();
    } else {
        msg = this.getMessage();
    }

    try {
        if (TP.isValid(err)) {
            str = '<span class="TP_sig_Exception ' +
                    TP.escapeTypeName(TP.tname(this)) + '">' +
                        '<span data-name="payload">' +
                            TP.htmlstr(err) +
                         '</span>' +
                     '</span>';
        } else {
            str = '<span class="TP_sig_Exception ' +
                    TP.escapeTypeName(TP.tname(this)) + '">' +
                        '<span data-name="payload"><span data-name="message">' +
                            TP.htmlstr(msg) +
                         '</span></span>' +
                     '</span>';
        }

    } catch (e) {
        str = this.toString();
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.sig.Exception.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    var marker,
        err,
        msg,
        str;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asJSONSource';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    err = this.at('error');
    if (TP.isValid(err)) {
        msg = TP.str(err) || err.toString();
    } else {
        msg = this.getMessage();
    }

    try {
        if (TP.isValid(err)) {
            str = '{"type":' + this.getTypeName().quoted('"') + ',' +
                    '"data":{' +
                        '"signame":' +
                             this.getSignalName().quoted('"') + ',' +
                        '"payload":' + TP.jsonsrc(err) +
                    '}}';
        } else {
            str = '{"type":' + this.getTypeName().quoted('"') + ',' +
                    '"data":{' +
                        '"signame":' +
                             this.getSignalName().quoted('"') + ',' +
                        '"payload":{"message":' + TP.jsonsrc(msg) + '}' +
                    '}}';
        }

    } catch (e) {
        str = this.toString();
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.sig.Exception.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} A new String containing the 'pretty print' string of
     *     the receiver.
     */

    var marker,
        err,
        msg,
        str;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asPrettyString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    err = this.at('error');
    if (TP.isValid(err)) {
        msg = TP.str(err) || err.toString();
    } else {
        msg = this.getMessage();
    }

    try {
        if (TP.isValid(err)) {
            str = '<dl class="pretty ' + TP.escapeTypeName(TP.tname(this)) +
                            '">' +
                        '<dt>Type name</dt>' +
                        '<dd class="pretty typename">' +
                            this.getTypeName() +
                        '</dd>' +
                        TP.pretty(err) +
                        '</dl>';
        } else {
            str = '<dl class="pretty ' + TP.escapeTypeName(TP.tname(this)) +
                            '">' +
                        '<dt>Type name</dt>' +
                        '<dd class="pretty typename">' +
                            this.getTypeName() +
                        '</dd>' +
                        TP.pretty(msg) +
                        '</dl>';
        }

    } catch (e) {
        str = this.toString();
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.sig.Exception.Inst.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns a reasonable string represention of the exception.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the TP.sig.Exception's String representation. The default is true.
     * @returns {String} The receiver as a String
     */

    var marker,
        err,
        msg,
        wantsVerbose,
        str;

    wantsVerbose = TP.ifInvalid(verbose, true);
    if (!wantsVerbose) {
        return this.getSignalName() + TP.OID_PREFIX +
                this.toString().split(TP.OID_PREFIX).last();
    }

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    err = this.at('error');
    if (TP.isValid(err)) {
        msg = TP.str(err) || err.toString();
    } else {
        msg = this.getMessage();
    }

    try {
        str = this.getSignalName() +
                ' :: ' +
                '(' + msg + ')';
    } catch (e) {
        str = this.toString();
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.sig.Exception.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver.
     * @returns {String} The receiver in XML string format.
     */

    var marker,
        err,
        msg,
        str;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asXMLString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    err = this.at('error');
    if (TP.isValid(err)) {
        msg = TP.str(err) || err.toString();
    } else {
        msg = this.getMessage();
    }

    try {
        if (TP.isValid(err)) {
            str = '<instance type="' + TP.tname(this) + '">' +
                        '<payload>' +
                            TP.xmlstr(err) +
                         '</payload>' +
                     '</instance>';
        } else {
            str = '<instance type="' + TP.tname(this) + '">' +
                        '<payload><message>' +
                            TP.xmlstr(msg) +
                         '</message></payload>' +
                     '</instance>';
        }

    } catch (e) {
        str = this.toString();
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.sig.Exception.Inst.defineMethod('getError',
function() {

    /**
     * @method getError
     * @summary Returns the Error object, if any, associated with this
     *     exception. This object is typically found in the payload under the
     *     key 'error'.
     * @returns {Error} A native Error object.
     */

    return this.at('error');
});

//  ------------------------------------------------------------------------

TP.sig.Exception.Inst.defineMethod('getLevel',
function() {

    /**
     * @method getLevel
     * @summary Returns the severity level associated with this instance.
     * @returns {Number} The severity level of the receiver.
     */

    return this.getType().getLevel();
});

//  ------------------------------------------------------------------------

TP.sig.Exception.Inst.defineMethod('getMessage',
function() {

    /**
     * @method getMessage
     * @summary Returns the message(s), if any, associated with this instance.
     * @returns {String} The message entry/entries associated with the receiver.
     */

    return this.at('message');
});

//  ------------------------------------------------------------------------
//  TOP LEVEL SIGNALS/EXCEPTIONS
//  ------------------------------------------------------------------------

//  create benign messaging signal types
TP.sig.Signal.defineSubtype('TRACE');
TP.sig.Signal.defineSubtype('DEBUG');
TP.sig.Signal.defineSubtype('INFO');
TP.sig.Signal.defineSubtype('SYSTEM');

//  build up logging exception hierarchy
TP.sig.Exception.defineSubtype('WARN');

TP.sig.WARN.defineSubtype('ERROR');
TP.sig.ERROR.defineSubtype('FATAL');

TP.sig.TRACE.Type.defineAttribute('$level', TP.TRACE);
TP.sig.DEBUG.Type.defineAttribute('$level', TP.DEBUG);
TP.sig.INFO.Type.defineAttribute('$level', TP.INFO);
TP.sig.WARN.Type.defineAttribute('$level', TP.WARN);
TP.sig.ERROR.Type.defineAttribute('$level', TP.ERROR);
TP.sig.FATAL.Type.defineAttribute('$level', TP.FATAL);
TP.sig.SYSTEM.Type.defineAttribute('$level', TP.SYSTEM);

//  ------------------------------------------------------------------------
//  TP.sig.Change
//  ------------------------------------------------------------------------

/*
This signal forms the root signal in support of MVC and data-driven
notification. There are numerous subtypes of TP.sig.Change, often created
dynamically, to allow fine-grained filtering of notification based on
individual object attributes such as 'LastnameChange' or 'Index34Change'.
These allow you to observe at small levels of granularity while leaving
open the option of simply observing TP.sig.Change and getting all
state-change events. UI change events are automatically converted into
TP.sig.Change subtypes as needed.
*/

//  ------------------------------------------------------------------------

TP.sig.Signal.defineSubtype('Change');

TP.sig.Change.Type.defineAttribute('defaultPolicy', TP.INHERITANCE_FIRING);

//  Don't signal Change at the controller level.
//  NOTE this is a LOCAL assignment so subtypes don't inherit it.
TP.sig.Change.isControllerRoot(true);

//  ------------------------------------------------------------------------

TP.sig.Change.Inst.defineMethod('getAction',
function() {

    /**
     * @method getAction
     * @summary Returns the action which caused the sender to change.
     * @returns {String} The action of the receiver.
     */

    return this.at('action');
});

//  ------------------------------------------------------------------------

TP.sig.Change.Inst.defineMethod('getAspect',
function() {

    /**
     * @method getAspect
     * @summary Returns the aspect of the sender which changed.
     * @returns {String} The aspect of the receiver.
     */

    return this.at('aspect');
});

//  ------------------------------------------------------------------------

TP.sig.Change.Inst.defineMethod('getSource',
function() {

    /**
     * @method getSource
     * @summary Returns the object to be used as the data source to retrieve the
     *     receiver's value from.
     * @returns {Object|undefined} The source to use as the data source to get
     *     this signal's value.
     */

    var source;

    //  Attempt to get the value using either the target or the origin and the
    //  aspect.
    if (!TP.isValid(source = this.at('target'))) {
        source = this.getOrigin();
        if (TP.isString(source)) {
            source = TP.sys.getObjectById(source);
            if (TP.notValid(source)) {
                return;
            }
        }
    }

    return source;
});

//  ------------------------------------------------------------------------

TP.sig.Change.Inst.defineMethod('getValue',
function() {

    /**
     * @method getValue
     * @summary Returns the new value.
     * @returns {String|undefined} The value of the receiver.
     */

    var value,
        source,
        aspect,

        retVal;

    value = this.at(TP.NEWVAL);
    if (TP.isValid(value)) {
        return value;
    }

    //  If the payload has 'path', use that - otherwise use the aspect.
    aspect = this.at('path') || this.getAspect();
    if (TP.isEmpty(aspect)) {
        return;
    }

    //  Get the source object that we will use to ask the value of
    source = this.getSource();

    //  If we can invoke 'get' on that source, see if we get a valid value by
    //  doing a 'get' on it. If we don't get a valid value, try again by
    //  creating an access path from the aspect.
    if (TP.canInvoke(source, 'get')) {

        retVal = source.get(aspect);

        if (TP.notValid(retVal)) {
            retVal = source.get(TP.apc(aspect));
        }
    }

    return retVal;
});

//  ------------------------------------------------------------------------
//  TP.sig.IndexChange
//  ------------------------------------------------------------------------

/*
*/

//  ------------------------------------------------------------------------

TP.sig.Change.defineSubtype('IndexChange');

//  ------------------------------------------------------------------------
//  TP.sig.FacetChange
//  ------------------------------------------------------------------------

/*
*/

//  ------------------------------------------------------------------------

TP.sig.Change.defineSubtype('FacetChange');

//  ------------------------------------------------------------------------

TP.sig.FacetChange.Inst.defineMethod('getFacet',
function() {

    /**
     * @method getFacet
     * @summary Returns the facet of the sender which changed.
     * @returns {String} The facet of the receiver.
     */

    return this.at('facet');
});

//  ------------------------------------------------------------------------

TP.sig.FacetChange.defineSubtype('ReadonlyChange');
TP.sig.FacetChange.defineSubtype('RelevantChange');
TP.sig.FacetChange.defineSubtype('RequiredChange');
TP.sig.FacetChange.defineSubtype('ValidChange');

//  ------------------------------------------------------------------------
//  TP.sig.ValueChange
//  ------------------------------------------------------------------------

/*
*/

//  ------------------------------------------------------------------------

TP.sig.FacetChange.defineSubtype('ValueChange');

//  ------------------------------------------------------------------------
//  TP.sig.StructureChange
//  ------------------------------------------------------------------------

/*
*/

//  ------------------------------------------------------------------------

TP.sig.ValueChange.defineSubtype('StructureChange');

//  ------------------------------------------------------------------------
//  TP.sig.StructureInsert / TP.sig.StructureDelete
//  ------------------------------------------------------------------------

/*
*/

//  ------------------------------------------------------------------------

TP.sig.StructureChange.defineSubtype('StructureInsert');
TP.sig.StructureChange.defineSubtype('StructureDelete');

//  ------------------------------------------------------------------------
//  TP.sig.RouteChange
//  ------------------------------------------------------------------------

/*
*/

//  ------------------------------------------------------------------------

TP.sig.Change.defineSubtype('RouteChange');

//  Routing events in particular should inform the controller chain.
TP.sig.RouteChange.Type.isControllerSignal(true);

//  RouteChange is a special form of Change which should not traverse higher.
//  NOTE this is a LOCAL assignment so subtypes don't inherit it.
TP.sig.RouteChange.isSignalingRoot(true);

//  The sequence that the router will fire these is:

//      Exit
//      Enter
//      Finalize

//  The signal type for entering a route
TP.sig.RouteChange.defineSubtype('RouteEnter');

//  The signal type for exiting a route
TP.sig.RouteChange.defineSubtype('RouteExit');

//  The signal type for finalizing a route
TP.sig.RouteChange.defineSubtype('RouteFinalize');

//  ------------------------------------------------------------------------
//  TP.sig.SignalMap
//  ------------------------------------------------------------------------

/*
TP.sig.SignalMap provides a wrapper around the data structures that
manage signal observations and notification. Included with the
TP.sig.SignalMap type are a number of registration and firing "policies"
which implement the strategy pattern. By selecting a different policy you
alter the behavior of the registration or signal notification process.
*/

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('sig.SignalMap');

//  ------------------------------------------------------------------------

//  for reimporting we test here
if (TP.notValid(TP.sig.SignalMap.interests)) {
    TP.sig.SignalMap.interests = TP.constructOrphanObject();

    // An interest is composed of the following sparse keys:
    /*
        target
        event
        suspend // false,
     */

    // A listener is composed of the following sparse keys:
    /*
        target
        event
        phase
        propagate
        defaultAction
        observer
        suspend   // false
        remove    // false
        handler
     */
}

//  prebuilt regexs for testing for default signal construction
TP.sig.SignalMap.Type.defineConstant(
                    'CHANGE_REGEX',
                    /Change$/);
TP.sig.SignalMap.Type.defineConstant(
                    'INDEX_CHANGE_REGEX',
                    /Index[0-9]+Change$/);
TP.sig.SignalMap.Type.defineConstant(
                    'ERROR_REGEX',
                    /Error|Exception|Invalid|Violation|Failed|NotFound/);
TP.sig.SignalMap.Type.defineConstant(
                    'ERROR_CODE_REGEX',
                    /^[0-9]+$/);
TP.sig.SignalMap.Type.defineConstant(
                    'WARN_REGEX',
                    /Warning/);

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    //  turn off logging unless we're debugging the internals of notification
    this.shouldLog(false);

    return;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('$computeOriginID',
function(anOrigin) {

    var orgid;

    orgid = TP.isValid(anOrigin) ? TP.id(anOrigin) : TP.ANY;
    if (orgid === '*' || orgid === '') {
        orgid = TP.ANY;
    }

    return orgid;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('$computeSignalName',
function(aSignal) {

    var signame;

    signame = TP.isValid(aSignal) ? aSignal.getSignalName() : TP.ANY;
    if (TP.notValid(signame) || signame === '*' || signame === '') {
        signame = TP.ANY;
    }

    return signame;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('$constructHandlerEntries',
function(anOrigin, aSignal, aHandler, aPhase, propagate, defaultAction, anObserver, xmlEvent) {

    /**
     * @method $constructHandlerEntries
     * @summary Creates 1..n signal map entries for the interest specified.
     * @param {Object} anOrigin What origin?
     * @param {String|TP.sig.Signal} aSignal What signal?
     * @param {Object} aHandler What object will get notification?
     * @param {String} aPhase The dispatch phase to register the handler for.
     * @param {String} propagate If equal to 'stop', then the handler should
     *     stop propagation.
     * @param {String} defaultAction If equal to 'cancel', then the handler
     *     should cancel the default action.
     * @param {Element} anObserver The observer element.
     * @param {Boolean} xmlEvent Should use XML Events semantics?
     */

    var origins,
        origin,

        events,
        theEvent,

        entry,
        xml,

        i,
        j,
        k,

        observers,
        observer,
        handlers;

    if (TP.isEmpty(anOrigin) || anOrigin === '*') {
        origins = TP.ANY;
    } else {
        origins = anOrigin;
    }
    origins = origins.split(' ');

    if (TP.isEmpty(aSignal) || aSignal === '*') {
        events = TP.ANY;
    } else {
        events = aSignal;
    }
    events = events.split(' ');

    handlers = TP.ac();

    xml = TP.ifInvalid(xmlEvent, false);

    //  create a new entry for each expanded origin/signal pair
    for (i = 0; i < origins.getSize(); i++) {
        origin = origins.at(i);
        for (j = 0; j < events.getSize(); j++) {
            theEvent = events.at(j);

            //  when dealing with XML event semantics we have to manipulate
            //  things a bit if the target (origin) and observer differ. In
            //  particular we want the registration to sit at the observer's
            //  level in the DOM which means using the observer as the
            //  origin rather than the target. we want to preserve the
            //  target in a separate attribute so we can filter on it later
            if (xml) {
                if (anOrigin === anObserver) {
                    //  when anOrigin == anObserver it means ev:target was
                    //  defaulted to ev:observer. In that case we don't care
                    //  about xml_target since we weren't given a specific
                    //  child of an observer to match. Also, we can just use
                    //  origin as target and not worry about splitting
                    //  observer separately if necessary.
                    entry = TP.constructOrphanObject();
                    entry.target = origin;
                } else {
                    if (anObserver.indexOf(' ') === TP.NOT_FOUND) {
                        entry = TP.constructOrphanObject();

                        //  anObserver is a single value, no split required.
                        //  one special case here is that when the origin is
                        //  the document we're "outside" the element chain
                        //  and have to cheat a bit
                        if (TP.regex.DOCUMENT_ID.test(origin)) {
                            //  theoretically illegal, since we're saying
                            //  the document is "inside" the observer
                            entry.target = origin;
                        } else {
                            entry.target = anObserver;
                            entry.xml_target = origin;
                        }
                    } else {
                        //  have to split observer and generate an entry for
                        //  each combination
                        observers = anObserver.split(' ');
                        for (k = 0; k < observers.getSize(); k++) {
                            observer = observers.at(k);

                            entry = TP.constructOrphanObject();

                            entry.target = observer;
                            entry.xml_target = origin;

                            entry.event = theEvent;
                            entry.handler = aHandler;

                            TP.notEmpty(aPhase) ?
                                entry.phase = aPhase : 0;
                            TP.notEmpty(propagate) ?
                                entry.propagate = propagate : 0;
                            TP.notEmpty(defaultAction) ?
                                entry.defaultAction = defaultAction : 0;
                            TP.notEmpty(observer) ?
                                entry.observer = observer : 0;

                            handlers.push(entry);
                        }

                        //  skip tail of the i/j loop since we've already
                        //  fully configured the handler entries
                        continue;
                    }
                }
            } else {    //  NOT XML EVENTS
                entry = TP.constructOrphanObject();
                entry.target = origin;
            }

            entry.event = theEvent;
            entry.handler = aHandler;

            TP.notEmpty(aPhase) ?
                    entry.phase = aPhase : 0;
            TP.notEmpty(propagate) ?
                    entry.propagate = propagate : 0;
            TP.notEmpty(defaultAction) ?
                    entry.defaultAction = defaultAction : 0;
            TP.notEmpty(anObserver) ?
                    entry.observer = anObserver : 0;

            handlers.push(entry);
        }
    }

    return handlers;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('$getDefaultTypeForPolicy',
function(aPolicy) {

    /**
     * @method $getDefaultTypeForPolicy
     * @summary Returns the default type of signal of the policy provided.
     *     Default signal types are used by the system for 'spoofed' signals
     *     (i.e. when a real signal type isn't provided).
     * @param {Function|String} aPolicy The policy specification.
     * @returns {TP.meta.sig.Signal} The default signal type for the provided
     *     policy.
     */

    switch (aPolicy) {
        case TP.EXCEPTION_FIRING:
            return TP.sig.Exception;
        case TP.DOM_FIRING:
            return TP.sig.DOMSignal;
        case TP.RESPONDER_FIRING:
            return TP.sig.ResponderSignal;

        case TP.OBSERVER_FIRING:
        case TP.INHERITANCE_FIRING:
        case TP.FIRE_ONE:
        default:
            return TP.sig.Signal;
    }
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('$getPolicyName',
function(aPolicy) {

    /**
     * @method $getPolicyName
     * @summary Returns the public name of the policy provided. If the policy
     *     is provided as a string that string is returned.
     * @param {Function|String} aPolicy The policy specification.
     * @returns {String|undefined} The policy's public name.
     */

    if (TP.isString(aPolicy)) {
        return aPolicy;
    }

    //  if the policy is a function then it should be able to provide its
    //  name via getName
    if (TP.isCallable(aPolicy)) {
        return aPolicy.getName();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('$getSignalInstance',
function(aSignal, aPayload, defaultType, isCancelable, isBubbling) {

    /**
     * @method $getSignalInstance
     * @summary Returns a signal instance for use. This is optimized via the
     *     TP.sig.Signal construct machinery to reuse a common instance in most
     *     cases so that instance creation overhead is minimized.
     * @description When processing signals provided in string form the default
     *     type rules will cause types with Change in their name to be turned
     *     into Change signals, while types with Exception in their name will
     *     become subtypes of TP.sig.Exception. Exception is tested first, so a
     *     ChangeException is an Exception, not a Change :).
     * @param {TP.sig.Signal} aSignal The signal name/type.
     * @param {Object} aPayload Optional arguments.
     * @param {TP.meta.sig.Signal} defaultType A TP.sig.Signal subtype type
     *     object.
     * @param {Boolean} isCancelable Optional flag for dynamic signals defining
     *     if they can be cancelled.
     * @param {Boolean} isBubbling Optional flag for dynamic signals defining
     *     whether they bubble (when using TP.DOM_FIRING).
     * @returns {TP.sig.Signal} A Signal instance.
     */

    var sig,
        sigType;

    if (TP.isString(aSignal) || !TP.canInvoke(aSignal, 'clearNotifications')) {
        sigType = TP.sig.SignalMap.$getSignalType(aSignal, defaultType);

        if (TP.isType(sigType)) {
            TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
                TP.trace('Using signal type named: ' +
                                sigType.getName(),
                            TP.SIGNAL_LOG) : 0;

            sig = sigType.construct(aPayload);
            sig.$set('signalName', aSignal.getSignalName());

            TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
                TP.trace('Returning instance with signalName: ' +
                                sig.getSignalName(),
                            TP.SIGNAL_LOG) : 0;
        } else {
            TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
                TP.trace('Failed to find signal instance for: ' + aSignal,
                            TP.SIGNAL_LOG) : 0;

            sig = aSignal;
        }
    } else {
        TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
            TP.trace('Returning supplied signal instance: ' + aSignal,
                        TP.SIGNAL_LOG) : 0;

        sig = aSignal;
    }

    //  Ensure the signal gets any payload that was provided explicitly.
    if (TP.isValid(aPayload)) {
        if (sig.getPayload() !== aPayload) {
            sig.setPayload(aPayload);
        }
    }

    //  make sure the signal can be run cleanly against all handlers within
    //  a particular policy activation
    if (TP.canInvoke(sig, 'clearNotifications')) {
        sig.clearNotifications();
    }

    if (TP.notEmpty(isCancelable)) {
        sig.set('cancelable', isCancelable);
    }

    if (TP.notEmpty(isBubbling)) {
        sig.set('bubbling', isBubbling);
    }

    return sig;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('$getSignalType',
function(aSignal, aDefaultType) {

    /**
     * @method $getSignalType
     * @summary Returns a signal type for use by looking up the type matching
     *     the supplied signal. If the optional aDefaultType parameter is
     *     supplied it is used as the return type. If its not defined, a number
     *     of rules (explained below) are used to try to 'compute' the return
     *     type.
     * @description When returning signal types for signal values provided in
     *     String form the default type rules will cause types with Change in
     *     their name to return Change signals, while types with Exception in
     *     their name will return TP.sig.Exception. TP.sig.Exception is tested
     *     first, so a ChangeException is an Exception, not a TP.sig.Change :).
     * @param {TP.meta.sig.Signal|String} aSignal A TP.sig.Signal subtype type
     *     object or name.
     * @param {TP.meta.sig.Signal} aDefaultType An optional type object that
     *     will be used as the return type from this method if a real signal
     *     type couldn't be computed.
     * @returns {TP.meta.sig.Signal} A TP.sig.Signal subtype type object.
     */

    var aTypeName,
        sigType,
        defaultType,
        match;

    //  if we've got a string turn it into a signal type reference
    if (TP.isString(aSignal)) {
        TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
            TP.trace('Getting type for aSignal string: ' + aSignal,
                        TP.SIGNAL_LOG) : 0;

        //  the signal type name will be the signal name.
        aTypeName = TP.expandSignalName(aSignal);

        if (TP.notValid(sigType = TP.sys.getTypeByName(aTypeName))) {
            TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
                TP.trace('No signal type named: ' + aTypeName,
                            TP.SIGNAL_LOG) : 0;

            //  try to get the best default signal possible here
            if (TP.sig.SignalMap.ERROR_REGEX.test(aSignal) ||
                TP.sig.SignalMap.ERROR_CODE_REGEX.test(aSignal)) {
                defaultType = TP.ifInvalid(aDefaultType, TP.sig.ERROR);
            } else if (TP.sig.SignalMap.WARN_REGEX.test(aSignal)) {
                defaultType = TP.ifInvalid(aDefaultType, TP.sig.WARN);
            } else if (TP.sig.SignalMap.CHANGE_REGEX.test(aSignal)) {
                //  Change comes in terms of facets...so we need to test for
                //  those to determine best supertype here.
                match = aSignal.match(
                    /^(Value|Valid|Required|Relevant|Readonly)Change$/);
                if (TP.isValid(match)) {
                    if (TP.isValid(TP.sig[match[0]])) {
                        defaultType = TP.sig[match[0]];
                    }
                }

                //  One other class of changes is structural/crud changes...
                if (TP.notValid(defaultType)) {
                    match = aSignal.match(
                        /Structure(Insert|Update|Delete|Change)/);
                    if (TP.isValid(match)) {
                        if (TP.isValid(TP.sig[match[0]])) {
                            defaultType = TP.sig[match[0]];
                        } else {
                            //  We know it's a Structure thing...
                            defaultType = TP.sig.StructureChange;
                        }
                    } else {
                        defaultType = aDefaultType;
                    }

                    defaultType = TP.ifInvalid(defaultType, TP.sig.ValueChange);
                }

            } else if (TP.sig.SignalMap.INDEX_CHANGE_REGEX.test(aSignal)) {
                defaultType = TP.ifInvalid(aDefaultType, TP.sig.IndexChange);
            } else {
                defaultType = TP.ifInvalid(aDefaultType, TP.sig.Signal);
            }

            if (TP.isType(defaultType)) {
                sigType = defaultType;
            } else {
                sigType = TP.sys.getTypeByName(defaultType);
            }
        }
    } else if (TP.isType(aSignal)) {
        sigType = aSignal;
    } else {
        sigType = TP.type(aSignal);
    }

    return sigType;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('$isInterestSuspended',
function(anOrigin, aSignal) {

    /**
     * @method $isInterestSuspended
     * @summary Returns true if the combination of origin and signal ID is
     *     marked as suspended in the signal map.
     * @param {String} anOrigin What origin are we checking?
     * @param {String|tp.sig.Signal} aSignal What signal name?
     * @returns {Boolean} Whether or not a particular origin/signal ID is
     *     suspended or not.
     */

    var orgid,
        signame,
        entry;

    orgid = TP.sig.SignalMap.$computeOriginID(anOrigin);
    signame = TP.sig.SignalMap.$computeSignalName(aSignal);

    entry = TP.sig.SignalMap.interests[orgid + '.' + signame];

    if (TP.isValid(entry)) {
        return entry.suspend === true;
    } else if (!TP.regex.HAS_PERIOD.test(signame)) {
        //  If the signame didn't have a period, then it might be a spoofed
        //  signal name, but the registration would've been made using a
        //  'full signal' name (i.e. prefixed by 'TP.sig.').
        entry = TP.sig.SignalMap.interests[orgid + '.' + 'TP.sig.' + signame];

        if (TP.isValid(entry)) {
            return entry.suspend === true;
        }
    }
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('$registerHandlerEntry',
function(aHandlerEntry, quiet) {

    /**
     * @method $registerHandlerEntry
     * @summary Registers the supplied signal map entry into the signal map.
     * @description Note that no duplicate entries are made meaning each handler
     *     is notified only once per signal occurrence unless the TIBET flag
     *     shouldAllowDuplicateInterests() returns true. Also, if the enclosing
     *     interest container has already been created for another handler, and
     *     is suspended, it will remain suspended until a resume is invoked. If
     *     the specific entry is suspended it will be reactivated as a result
     *     of this call.
     * @param {Object} aHandlerEntry A listener entry.
     * @param {Boolean} quiet True to quietly ignore duplicate entries.
     * @returns {TP.sig.SignalMap} The receiver.
     */

    var map,
        orgid,
        signame,
        origin,
        type,
        owner,
        root,
        entry,
        id,
        hash,
        source,
        handlerID,
        phase,
        win;

    map = TP.sig.SignalMap.interests;

    orgid = TP.sig.SignalMap.$computeOriginID(aHandlerEntry.target);
    signame = TP.sig.SignalMap.$computeSignalName(aHandlerEntry.event);

    //  ---
    //  origin/signal owner notification
    //  ---

    //  ensure owners such as mouse and keyboard know about this event.
    origin = TP.isTypeName(orgid) ? TP.sys.getTypeByName(orgid) : orgid;
    if (TP.canInvoke(origin, 'addObserver')) {
        origin.addObserver(orgid, signame);
    }

    //  some events require interaction with an "owner", typically a
    //  TP.core.Device, responsible for events of that type which may also
    //  decide to manage observations directly
    type = TP.isTypeName(signame) ? TP.sys.getTypeByName(signame) : signame;

    //  special case here for keyboard events since their names are often
    //  synthetic and we have to map to the true native event type
    if (TP.notValid(type)) {
        if (TP.regex.KEY_EVENT.test(signame)) {
            type = TP.sys.getTypeByName('TP.sig.DOMKeySignal');
        }
    }

    //  If we have a type we need to ask it if events of that type have a signal
    //  owner. If so we'll need to let that type manage observations as well.
    if (TP.canInvoke(type, 'getSignalOwner') &&
        TP.isValid(owner = type.getSignalOwner())) {

        if (owner !== origin && TP.canInvoke(owner, 'addObserver')) {
            owner.addObserver(orgid, signame);
        }
    }

    //  ---
    //  interest entry configuration
    //  ---

    id = orgid + '.' + signame;
    root = map[id];

    //  no root? no interests yet so we need to create a container object that
    //  will manage all data for this origin/signal pair.
    if (TP.notValid(root)) {
        TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
            TP.trace('Interest root not found.',
                        TP.SIGNAL_LOG) : 0;

        entry = TP.constructOrphanObject();
        entry.target = orgid;
        entry.event = signame;
        entry.listeners = [];
        map[id] = entry;

        root = entry;
    }

    entry = null;

    handlerID = aHandlerEntry.handler;

    //  some handler entries have id's and some are inline functions. we use
    //  the handler attribute to hold this data just as in XML Events
    if (TP.notEmpty(handlerID)) {
        phase = aHandlerEntry.phase;

        entry = root.listeners.detect(
                function(item) {
                    return item.handler === handlerID && item.phase === phase;
                });

        if (TP.notValid(entry)) {
            TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
                    TP.trace('Listener not found.',
                    TP.SIGNAL_LOG) : 0;
        }
    }

    //  if we find an entry we have two options, first if the entry "isn't
    //  really there" because it's in a remove state we can reactivate it
    if (TP.isValid(entry)) {
        if (TP.isTrue(quiet)) {
            return this;
        }

        if (!TP.sys.shouldAllowDuplicateInterests()) {
            TP.ifWarn() && TP.$DEBUG && TP.$$VERBOSE ?
                TP.warn(
                    TP.join('Duplicate interest registration for origin: ',
                            orgid, ' signal: ',
                            signame, ' handler: ',
                            handlerID, ' ignored.'),
                    TP.SIGNAL_LOG) : 0;

            return this;
        }

        if (entry.suspend === true) {
            TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
                TP.trace('Listener currently flagged as suspended.',
                            TP.SIGNAL_LOG) : 0;

            delete entry.suspend;

            return this;
        }

        if (entry.remove === true) {
            TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
                TP.trace('Listener currently flagged as removed.',
                            TP.SIGNAL_LOG) : 0;

            delete entry.remove;

            return this;
        }
    }

    TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
        TP.trace('Creating new listener entry.',
                    TP.SIGNAL_LOG) : 0;

    //  Simple. Just use the object provided.
    entry = aHandlerEntry;

    //  if no handler ID at this point we must have an inline function to use,
    //  if the handler ID is a JS URI then we have an inline expression. either
    //  way we have to convert the JS into a function we can use
    if (TP.isEmpty(handlerID) || handlerID.startsWith('java' + 'script:')) {
        if (TP.isEmpty(handlerID)) {
            TP.ifWarn() ?
                TP.warn(TP.annotate(
                            entry,
                            'Invalid handler in listener.'),
                        TP.SIGNAL_LOG) : 0;
        } else {
            //  NOTE we have to run the TP.xmlEntitiesToLiterals() call here
            //  since XML will require quotes etc. to be in entity form
            source = TP.xmlEntitiesToLiterals(handlerID.strip(/javascript:/));

            //  build a function wrapper, using double quoting to match
            //  how attribute would likely be quoted in the source.
            source = 'function (triggerSignal) {' + source + '};';
        }

        TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
            TP.trace('Found function source: ' + source,
                        TP.SIGNAL_LOG) : 0;

        //  if we have source, try to get a function handle to it
        if (TP.isString(source)) {
            //  generate a unique hash to use as a handler ID so we don't
            //  keep generating new functions for anonymous handlers
            hash = TP.hash(source, TP.HASH_MD5);

            //  note the lookup here which uses regOnly true to avoid longer
            //  searches since we know we're dealing with registered objects
            //  when using hash keys
            if (TP.isValid(TP.sys.getObjectById(hash, true))) {
                handlerID = hash;

                //  have to check for duplicate again...
                entry.handler = handlerID;

                return TP.sig.SignalMap.$registerHandlerEntry(entry);
            } else {
                try {
                    win = window;
                    /* eslint-disable no-eval */
                    eval('win.$$handler = ' + source);
                    /* eslint-enable no-eval */
                    win.$$handler.setID(hash);
                    handlerID = win.$$handler.getID();

                    //  register the object so it can be found during
                    //  notification but do it only when we had to build the
                    //  object ourselves, otherwise we presume the developer
                    //  has registered it themselves, or will when they're
                    //  ready
                    TP.sys.registerObject(win.$$handler, handlerID,
                                            true, false);
                } catch (e) {
                    TP.ifError() ?
                        TP.error(
                            TP.ec(e, 'Problem creating handler function.'),
                            TP.SIGNAL_LOG) : 0;

                    return this;
                }
            }
        }
    } else if (handlerID.startsWith('#')) {
        //  local document ID reference, should have been converted to a
        //  global ID but TP.byId() will default to TP.sys.getUICanvas()
        void 0;
    }

    if (TP.isValid(handlerID)) {
        entry.handler = handlerID;

        root.listeners.push(entry);

        TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
            TP.trace('Listener entry created for ID: ' + handlerID,
                        TP.SIGNAL_LOG) : 0;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('$removeHandlerEntry',
function(aHandlerEntry) {

    /**
     * @method $removeHandlerEntry
     * @summary Removes the supplied signal map entry from the signal map.
     * @param {Object} aHandlerEntry A listener entry.
     * @returns {TP.sig.SignalMap} The receiver.
     */

    var map,
        orgid,
        signame,
        origin,
        type,
        owner,
        root,
        entry,
        id,
        phase,
        handlerID,
        handler,
        removals;

    map = TP.sig.SignalMap.interests;

    orgid = TP.sig.SignalMap.$computeOriginID(aHandlerEntry.target);
    signame = TP.sig.SignalMap.$computeSignalName(aHandlerEntry.event);

    //  ---
    //  origin/signal owner notification
    //  ---

    //  ensure owners such as mouse and keyboard know about this event.
    origin = TP.isTypeName(orgid) ? TP.sys.getTypeByName(orgid) : orgid;
    if (TP.canInvoke(origin, 'removeObserver')) {
        origin.removeObserver(orgid, signame);
    }

    //  some events require interaction with an "owner", typically a
    //  TP.core.Device, responsible for events of that type which may also
    //  decide to manage observations directly
    type = TP.isTypeName(signame) ? TP.sys.getTypeByName(signame) : signame;

    //  special case here for keyboard events since their names are often
    //  synthetic and we have to map to the true native event type
    if (TP.notValid(type)) {
        if (TP.regex.KEY_EVENT.test(signame)) {
            type = TP.sys.getTypeByName('TP.sig.DOMKeySignal');
        }
    }

    //  If we have a type we need to ask it if events of that type have a signal
    //  owner. If so we'll need to let that type manage observations as well.
    if (TP.canInvoke(type, 'getSignalOwner') &&
        TP.isValid(owner = type.getSignalOwner())) {

        if (owner !== origin && TP.canInvoke(owner, 'removeObserver')) {
            owner.removeObserver(orgid, signame);
        }
    }

    //  ---
    //  interest entry configuration
    //  ---

    id = orgid + '.' + signame;
    root = map[id];

    //  no root? no interests yet so we need to create a container object that
    //  will manage all data for this origin/signal pair.
    if (TP.notValid(root)) {
        TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
            TP.trace('Interest root not found.',
                        TP.SIGNAL_LOG) : 0;

        return this;
    }

    entry = null;

    handlerID = aHandlerEntry.handler;

    //  If the handle points to a registered Function, unregister it from
    //  the common URI registry.
    if (/Function\$\w+/.test(handlerID)) {
        handler = TP.uc('urn:tibet:' + handlerID);
        handler.unregister();
    }

    //  some handler entries have id's and some are inline functions. we use
    //  the handler attribute to hold this data just as in XML Events
    if (TP.notEmpty(handlerID)) {
        phase = aHandlerEntry.phase;

        entry = root.listeners.detect(
                function(item) {
                    return item.handler === handlerID && item.phase === phase;
                });

        if (TP.notValid(entry)) {
            TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
                    TP.trace('Listener not found.',
                    TP.SIGNAL_LOG) : 0;

            return this;
        }
    }

    if (TP.isValid(entry)) {

        if (entry.suspend === true) {
            TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
                TP.trace('Listener currently flagged as suspended.',
                            TP.SIGNAL_LOG) : 0;

            delete entry.suspend;

            return this;
        }
    }

    TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
        TP.trace('Removing listener entry.',
                    TP.SIGNAL_LOG) : 0;

    //  Simple. Just use the object provided.
    entry = aHandlerEntry;

    if (TP.isValid(handlerID)) {
        entry.handler = handlerID;

        //  Select the set of 'removals' by matching on all 4 criteria.
        removals = root.listeners.select(
                        function(anEntry) {
                            return anEntry.event === entry.event &&
                                    anEntry.handler === entry.handler &&
                                    anEntry.observer === entry.observer &&
                                    anEntry.target === entry.target;
                        });

        root.listeners.removeAll(removals, TP.IDENTITY);

        if (TP.isEmpty(root.listeners)) {
            delete map[id];
        }

        TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
            TP.trace('Listener entry removed for ID: ' + handlerID,
                        TP.SIGNAL_LOG) : 0;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('$registerInterest',
function(anOrigin, aSignal, aHandler, isCapturing) {

    /**
     * @method $registerInterest
     * @summary Creates a signal map entry for the interest specified.
     * @description No duplicate entries are made meaning each handler is
     *     notified only once per signal occurrence unless the TIBET flag
     *     shouldAllowDuplicateInterests() returns true. Also, if the enclosing
     *     interest container has already been created for another handler, and
     *     is suspended, it will remain suspended until a resume is invoked. If
     *     the specific entry is suspended it will be reactivated as a result of
     *     this call.
     * @param {Object} anOrigin What origin?
     * @param {String|TP.sig.Signal} aSignal What signal?
     * @param {Object} aHandler What object will get notification?
     * @param {Boolean} isCapturing Should this be considered a capturing
     *     handler?
     * @returns {TP.sig.SignalMap} The receiver.
     */

    var orgid,
        map,
        signame,
        root,
        entry,
        id,
        handlerID,

        urnLocation,
        existingURN,
        urn;

    /*
    if (TP.isEmpty(anOrigin) || (anOrigin == '*')) {
        orgid = TP.ANY;
    } else {
        orgid = TP.id(anOrigin);
    };

    if (TP.isEmpty(aSignal) || (aSignal == '*')) {
        signame = TP.ANY;
    } else {
        signame = aSignal.getSignalName();
    };
    */

    orgid = TP.sig.SignalMap.$computeOriginID(anOrigin);
    signame = TP.sig.SignalMap.$computeSignalName(aSignal);

    map = TP.sig.SignalMap.interests;
    id = orgid + '.' + signame;
    root = map[id];

    //  no root? no interests yet so we need to create a container
    if (TP.notValid(root)) {
        TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
            TP.trace('Interest root not found.',
                        TP.SIGNAL_LOG) : 0;

        entry = TP.constructOrphanObject();
        entry.target = orgid;
        entry.event = signame;
        entry.listeners = [];
        map[id] = entry;

        root = entry;
    }

    entry = null;

    handlerID = TP.gid(aHandler);

    entry = root.listeners.detect(
            function(item) {
                return item.handler === handlerID;
            });

    if (TP.notValid(entry)) {
        TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
                TP.trace('Listener entry not found.',
                TP.SIGNAL_LOG) : 0;
    }

    //  if we find an entry we have two options, first if the entry "isn't
    //  really there" because it's in a remove state we can reactivate it.
    if (TP.isValid(entry)) {
        if (!TP.sys.shouldAllowDuplicateInterests()) {

            TP.ifWarn() && TP.$DEBUG && TP.$$VERBOSE ?
                TP.warn(
                    TP.join('Duplicate interest registration for origin: ',
                            orgid, ' signal: ',
                            signame, ' handler: ',
                            handlerID, ' ignored.'),
                    TP.SIGNAL_LOG) : 0;

            return this;
        }

        if (entry.suspend === true) {
            TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
                TP.trace('Listener entry currently flagged as suspended.',
                            TP.SIGNAL_LOG) : 0;

            delete entry.suspend;

            //  ensure we're looking at the same handler instance, not
            //  just the same ID by updating the registration
            TP.sys.registerObject(aHandler, handlerID, true, false);

            return this;
        }

        if (entry.remove === true) {
            TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
                TP.trace('Listener entry currently flagged as removed.',
                            TP.SIGNAL_LOG) : 0;

            delete entry.remove;

            //  ensure we're looking at the same handler instance, not
            //  just the same ID by updating the registration
            TP.sys.registerObject(aHandler, handlerID, true, false);

            return this;
        }
    }

    TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
        TP.trace('Creating listener entry.',
                    TP.SIGNAL_LOG) : 0;

    //  if we arrived here there must not have been an entry already
    entry = TP.constructOrphanObject();
    entry.target = orgid;
    entry.event = signame;

    if (isCapturing) {
        entry.phase = 'capture';
    }

    entry.handler = handlerID;

    //  If the handler ID isn't already a URI, then we create a TIBET URN out of
    //  it.
    if (!TP.isURIString(handlerID)) {

        //  Prepend the standard TIBET URN prefix onto the handler ID and check
        //  to see if there's already a URI registered under that location. Note
        //  that we have to do this check *before* the 'TP.uc()' call (as it
        //  will create an entry if one doesn't exist).
        urnLocation = TP.TIBET_URN_PREFIX + handlerID;
        existingURN = TP.uri.URI.instances.containsKey(urnLocation);

        urn = TP.uc(urnLocation);

        //  If there was no existing URI, then that means we're creating this
        //  one just to hold the handler. Therefore, we mark it with a local
        //  attribute to keep a 'registration count' so that the
        //  '$removeInterest' call below will unregister it when that count
        //  reaches 0.
        if (!existingURN) {
            urn.defineAttribute('$regCount');
            urn.set('$regCount', 0, false);
        }

        //  If the urn owns a '$regCount' slot, then increment the registration
        //  count.
        if (TP.owns(urn, '$regCount')) {
            urn.set('$regCount', urn.get('$regCount') + 1);
        }

        //  Set the handler as our newly created URI's resource. Note here how
        //  we pass a request that tells the setResource to *not* signal
        //  change, since we're really just setting things up.
        urn.setResource(aHandler, TP.request('signalChange', false));
    }

    root.listeners.push(entry);

    TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
        TP.trace(TP.join('Listener entry created for ID: ',
                            handlerID, ' with handler: ', aHandler),
                    TP.SIGNAL_LOG) : 0;

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('$removeInterest',
function(anOrigin, aSignal, aHandler, isCapturing) {

    /**
     * @method $removeInterest
     * @summary Removes the signal map entry for the specific interest
     *     specified.
     * @description This method affects the handler provided, or all handlers of
     *     the particular capturing type (ie. capturing or non-capturing) if no
     *     handler is present. Note that when a handler is present the
     *     isCapturing flag is ignored and the handler's entry is removed
     *     regardless of its capture attribute value.
     * @param {Object} anOrigin What origin?
     * @param {String|TP.sig.Signal} aSignal What signal?
     * @param {Object} aHandler What object will get notification?
     * @param {Boolean} isCapturing Should this be considered a capturing
     *     handler?
     * @returns {TP.sig.SignalMap} The receiver.
     */

    var orgid,
        signame,

        map,
        id,
        root,

        handlerID,
        entry,

        handler,

        list,
        item,
        i;

    /*
    if (TP.isEmpty(anOrigin) || (anOrigin == '*')) {
        orgid = TP.ANY;
    } else {
        orgid = TP.id(anOrigin);
    };

    if (TP.isEmpty(aSignal) || (aSignal == '*')) {
        signame = TP.ANY;
    } else {
        signame = aSignal.getSignalName();
    };
    */

    orgid = TP.sig.SignalMap.$computeOriginID(anOrigin);
    signame = TP.sig.SignalMap.$computeSignalName(aSignal);

    map = TP.sig.SignalMap.interests;
    id = orgid + '.' + signame;
    root = map[id];

    if (TP.notValid(root)) {
        return this;
    }

    //  behavior branches based on handler vs. no handler. when no handler
    //  we'll be removing all interests of the specified capturing type, or
    //  all interests if no explicit capturing type was provided.
    if (TP.notValid(aHandler)) {
        if (TP.isTrue(isCapturing)) {
            list = root.listeners.select(
                    function(listener) {
                        return listener.phase === 'capture';
                    });

        } else if (TP.isFalse(isCapturing)) {
            list = root.listeners.select(
                    function(listener) {
                        return listener.phase !== 'capture';
                    });
        } else {
            list = root.listeners;
        }

        TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
            TP.trace('Removing ' + list.length + ' listener entries.',
                        TP.SIGNAL_LOG) : 0;

        /* eslint-disable no-loop-func */
        for (i = 0; i < list.length; i++) {
            item = list.at(i);

            //  Flag for removal.
            item.remove === true;

            //  If we're supposed to remove entirely next step is to compact.
            if (!TP.sys.shouldIgnoreViaFlag()) {
                root.listeners = list.select(
                                    function(listener) {
                                        return listener.remove !== true;
                                    });
            }
        }
        /* eslint-enable no-loop-func */
    } else {
        handlerID = TP.gid(aHandler);

        entry = root.listeners.detect(
                function(listener) {
                    return listener.handler === handlerID;
                });

        if (TP.isValid(entry)) {
            entry.remove = true;

            if (!TP.sys.shouldIgnoreViaFlag()) {
                list = root.listeners;
                root.listeners = list.select(
                                    function(listener) {
                                        return listener.remove !== true;
                                    });
            }
        }

        //  If the handle points to a URI that was created just for this
        //  handler, then remove it from the common URI registry. See the
        //  '$registerInterest' call above for more on how & why these URIs get
        //  created.

        if (!TP.isURIString(handlerID)) {
            handlerID = TP.TIBET_URN_PREFIX + handlerID;
        }

        handler = TP.uc(handlerID);

        //  If the handler is a TIBET URN, then it may have a registration count
        //  local attribute (see the '$registerInterest call above).
        if (TP.isKindOf(handler, TP.uri.TIBETURN) &&
            TP.owns(handler, '$regCount')) {

            //  Decrement the registration count
            handler.set('$regCount', handler.get('$regCount') - 1);

            //  If the registration count is 0, remove the URN from
            //  TP.uri.URI's instance dictionary.
            if (handler.get('$regCount') === 0) {
                TP.uri.URI.removeInstance(handler);
            }
        }
    }

    if (TP.isEmpty(root.listeners)) {
        delete map[id];
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.Type.defineMethod('getListeners',
function(anOrigin, aSignal, captureState) {

    /**
     * @method getListeners
     * @summary Returns all listener entries found for the origin/signal name
     *     pair provided, adjusting for capturing semantics as needed. Note that
     *     "ANY" references are treated as "special origin" or "special signal"
     *     rather than as "wildcards" for purposes of this routine. In other
     *     words, when anOrigin is TP.ANY only listeners registered for the
     *     origin TP.ANY are returned, not listeners for
     *
     *
     * @param {String} anOrigin The origin to use for lookup.
     * @param {Signal} aSignal The signal (or name) to look up.
     * @param {Boolean} captureState Actually a "tri-state" flag where null is
     *     used for the third state. True means notify only handlers with "true"
     *     for their capture state, false means only those which are not
     *     capturing, and null is used to imply both. The default is null.
     */

    var list,
        capture,

        orgid,
        signame,

        map,
        id,
        root,

        items,
        item,
        i;

    //  set a default of no handlers found
    list = TP.ac();

    capture = captureState;

    orgid = TP.sig.SignalMap.$computeOriginID(anOrigin);
    signame = TP.sig.SignalMap.$computeSignalName(aSignal);

    map = TP.sig.SignalMap.interests;
    id = orgid + '.' + signame;
    root = map[id];

    if (TP.notValid(root)) {
        return list;
    }

    items = root.listeners;

    for (i = 0; i < items.length; i++) {
        item = items.at(i);

        //  if the specific handler is suspended or flagged for removal
        //  then just skip it
        if (item.suspend === true || item.remove === true) {
            continue;
        }

        if (TP.isFalse(capture)) {
            //  if capturing handlers are masked off, check and skip
            if (item.phase === 'capture') {
                continue;
            }
        } else if (TP.isTrue(capture)) {
            if (item.phase !== 'capture') {
                continue;
            }
        }

        //  add the observation to the list
        list.push(item);
    }

    return list;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.Type.defineMethod('notifyControllers',
function(aSignal, handlerFlags) {

    /**
     * @method notifyControllers
     * @summary Notifies any controllers in the controller chain managed by the
     *     current application instance. This method is the link between the
     *     standard observe/ignore signal notification process and the
     *     larger-scale application responder-chain notification sequence.
     * @param {TP.sig.Signal} aSignal The signal passed to handlers.
     * @param {Object} [handlerFlags] A method parameter set.
     *     Properties can be any combination of the following:
     *          {String} [startSignal] The signal name to start considering
     *                  handlers if the supplied signal has more than one signal
     *                  name. This parameter is optional and, if not supplied,
     *                  all of the signal names as computed from the supplied
     *                  signal will be used.
     *          {Boolean} [dontTraverseSpoofs=false] True will mean that
     *                  traversing up the supertype chain will be disabled for
     *                  'spoofed' signals (i.e. signals where the signal name
     *                  doesn't match the type name).
     *          {Boolean} [dontTraverseHierarchy=false] True will turn off any
     *                  form of signal hierarchy traversal.
     *          {String} [skipName] A string used to mask off certain handler
     *                  names such as high-level default handlers.
     *          {String} [phase] ('*', TP.CAPTURING, TP.AT_TARGET,
     *                  TP.BUBBLING). The default is whatever phase the supplied
     *                  signal is in.
     * @returns {TP.meta.sig.SignalMap} The receiver.
     */

    var app,
        controllers,
        len,
        i,
        ignore,
        type,
        controller,
        handler,
        oldHandler;

    if (!TP.sys.hasLoaded()) {
        return this;
    }

    //  Verify this signal type should be propagated through controller chain.
    //  Most are but some like processing/workflow signals are intended for a
    //  local audience and are likely to be converted to promises over time so
    //  we don't want to create dependencies on them being propogated.
    if (aSignal.isSpoofed()) {
        type = TP.sys.getTypeByName(aSignal.getSignalName());
        if (TP.isType(type)) {
            if (!type.isControllerSignal() || type.isControllerRoot()) {
                ignore = true;
            }
        }
    } else if (!aSignal.isControllerSignal() || aSignal.isControllerRoot()) {
        ignore = true;
    }

    if (ignore) {
        /*
        TP.debug('notifyControllers ignoring ' + aSignal.getSignalName() +
            ' sig? ' + aSignal.isControllerSignal() + ' root? ' +
            aSignal.isControllerRoot());
        */
        return this;
    }

    app = TP.sys.getApplication();
    controllers = app.getControllers(aSignal);

    len = controllers.getSize();
    for (i = 0; i < len; i++) {
        if (aSignal.shouldStop() || aSignal.shouldStopImmediately()) {
            return this;
        }

        //  Find/fire best handler for each controller.
        controller = controllers.at(i);
        handler = controller.getBestHandler(aSignal, handlerFlags);

        if (TP.isCallable(handler)) {
            if (!aSignal.hasNotified(handler, controller)) {
                try {
                    oldHandler = aSignal.$get('currentHandler');
                    aSignal.$set('currentHandler', handler, false);
                    handler.call(controller, aSignal);
                } catch (e) {
                    //  TODO: handler exception
                    //  TODO: Add a callback check at the handler/owner level?
                    TP.error('HandlerException: ' + e.message + ' in: ' +
                        TP.id(TP.owner(handler)) + ':' + TP.name(handler));
                } finally {
                    //  set up so we won't tell it again unless it resets
                    aSignal.trackHandler(handler, controller);
                    aSignal.$set('currentHandler', oldHandler, false);
                }
            }
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.Type.defineMethod('notifyObservers',
function(anOrigin, aSignalName, aSignal, options) {

    /**
     * @method notifyObservers
     * @summary Notifies all handlers found for the origin/signal name pair
     *     provided, adjusting for capturing semantics as needed.
     * @description This method notifies every available listener it can find
     *     which meet the captureState requirements -- unless the
     *     checkPropagation flag is true in which case the notification only
     *     occurs until a handler sets the stopPropagation() flag on the signal.
     *     In that case the first handler which stops propagation will be the
     *     last handler called regardless of how many other handers may be
     *     registered as observers. Note that if the particular signal/origin
     *     interest combination has been suspended as a result of a Suspend
     *     signal (via this.suspend() etc.) no notification will occur.
     * @param {String} anOrigin The origin to use for lookup.
     * @param {String} aSignalName The signal name to lookup.
     * @param {Signal} aSignal The signal passed to handlers.
     * @param {TP.core.Hash} options Options including the following slots:
     * @param {Boolean} checkPropagation Should propagation checks be performed.
     *     If so, a stopPropagation() call will terminate notifications. The
     *     default is true.
     * @param {Boolean} captureState Actually a "tri-state" flag where null is
     *     used for the third state. True means notify only handlers with "true"
     *     for their capture state, false means only those which are not
     *     capturing, and null is used to imply both. The default is null.
     * @param {Entry} aSigEntry The signal map entry Node to use to get the
     *     handlers from. This is an optional parameter. If this is not
     *     supplied, it will be computed here. If this method is called
     *     repeatedly, better performance can be achieved by computing the entry
     *     Node once and supplying it here.
     * @param {Boolean} checkTarget True to force "target checks" which enforce
     *     the DOM spec's requirement that when a specific target was defined
     *     for a listener it should only fire if the signal target (not origin)
     *     matches it.
     * @param {Boolean} scanSupertypes True to force full inheritance checking.
     *     In other words, assume a handler observes 'StateInput' thinking
     *     they'll be told about all subtypes of 'StateInput'. That's not quite
     *     how it works without this flag tho. The handler will only be invoked
     *     if the receiver implements handleStateInput. If they implement a
     *     handleFluffyInput method it won't be called, even if the signal is a
     *     FluffyInput signal. Yeah, it's complicated. We have to identify
     *     handlers by checking the entire supertype list.
     * @returns {TP.meta.sig.SignalMap} The receiver.
     */

    var opts,
        checkTarget,
        scanSupertypes,
        i,
        entry,
        items,
        check,
        capture,
        orgid,
        signame,
        signalNames,
        item,
        phase,
        oldHandler,
        handlerResult,
        handler,
        originalOrigin,
        hFunc,
        observer,
        xml_target,
        targetID;

    //  callers need to already have set up a signal instance
    if (TP.notValid(aSignal)) {
        return this;
    }

    opts = TP.hc(options);

    //  should we respect stopPropagation calls?
    check = TP.ifInvalid(opts.at('checkPropagation'), true);

    checkTarget = TP.ifInvalid(opts.at('checkTarget'), false);
    scanSupertypes =
        opts.at('scanSupertypes') || aSignal.shouldScanSupertypes();

    entry = opts.at('aSigEntry');

    //  two variant here. if check and "standard shouldStop" are true then we
    //  stop OR if shouldStopImmediately is true, regarless of check state.
    if (check && aSignal.shouldStop() || aSignal.shouldStopImmediately()) {
        return this;
    }

    //  don't let signals get passed with TP.ANY as an origin, but ensure we can
    //  put things back the way they were once we're finished
    originalOrigin = aSignal.getOrigin();
    if (originalOrigin === TP.ANY) {
        aSignal.setOrigin(null);
    }

    //  set our capture state flag so we can test as needed
    capture = opts.at('captureState');

    //  capture the current origin for interest lookup purposes
    //  orgid = (TP.notValid(anOrigin)) ? TP.ANY : TP.id(anOrigin);

    //  capture the signal use we're using for lookup purposes
    //  signame = (TP.notValid(aSignalName)) ? TP.ANY : aSignalName.getID();

    orgid = TP.sig.SignalMap.$computeOriginID(anOrigin);
    signame = TP.sig.SignalMap.$computeSignalName(aSignalName);

//  TODO: make this "official". but BEWARE!!! you can't log these to the DOM or
//  things go to hell in a hurry.
/*
if (!signame.match(/DOMMouse/)) {
top.console.log('notifyObservers: ' + ' origin: ' + orgid + ' signal: ' + signame +
        ' capturing: ' + capture);
}
*/

    if (TP.isValid(entry)) {

        //  Get a shallow copy of the listeners so any handler activity that
        //  affects the list won't affect our current iteration work.
        items = entry.listeners.slice(0);

    } else {

        if (scanSupertypes) {
            signalNames = aSignal.getSignalNames();
        } else {
            signalNames = TP.ac(signame);
        }

        items = TP.ac();

        signalNames.forEach(
                function(name) {

                    //  Don't include the root unless it was explicitly
                    //  provided.
                    /* eslint-disable no-extra-parens */
                    if (scanSupertypes && (name === 'TP.sig.Signal')) {
                        return;
                    }
                    /* eslint-enable no-extra-parens */

                    //  Note we don't bother with sorting out capture vs. bubble
                    //  here, we put the burden of that on the observe process
                    //  which manages order in the listener node list for a
                    //  particular interest. This optimizes for runtime dispatch
                    //  since observes can persist in XML, and across multiple
                    //  content display invocations, meaning they're called only
                    //  once in most cases
                    entry = TP.sig.SignalMap.interests[orgid + '.' + name];

                    if (TP.notValid(entry)) {

                        //  If the name didn't have a period, then it might be a
                        //  spoofed signal name, but the registration would've
                        //  been made using a 'full signal' name (i.e. prefixed
                        //  by 'TP.sig.').
                        if (!TP.regex.HAS_PERIOD.test(name)) {
                            entry = TP.sig.SignalMap.interests[
                                orgid + '.' + 'TP.sig.' + name];
                        }

                        if (TP.notValid(entry)) {
                            TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
                                TP.trace(TP.join('Interest not found for: ',
                                                    orgid, '.', name),
                                            TP.SIGNAL_LOG) : 0;

                            aSignal.setOrigin(originalOrigin);

                            return;
                        }
                    }

                    //  If the entire block of interests is suspended then do
                    //  not notify
                    if (entry.suspend === true) {
                        TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
                            TP.trace(TP.join('Interest for: ',
                                                orgid, '.', signame,
                                                ' is flagged as suspended.'),
                                        TP.SIGNAL_LOG) : 0;

                        aSignal.setOrigin(originalOrigin);

                        return;
                    }

                    //  Get a shallow copy of the listeners so any handler
                    //  activity that affects the list won't affect our current
                    //  iteration work.
                    items = items.concat(entry.listeners);
                });
    }

    //  try/finally for signal stack
    try {
        //  make sure the signal stack is up to date by doing a
        //  "push" of the new signal
        TP.$signal_stack.push(aSignal);

        targetID = aSignal.getResolvedTargetGlobalID();

        for (i = 0; i < items.length; i++) {
            //  two variant here. if check and "standard shouldStop" are true
            //  then we stop OR if shouldStopImmediately is true, regardless of
            //  check state since shouldStopImmediately implied we check after
            //  each and every handler invocation regardless.
            if (check && aSignal.shouldStop() ||
                    aSignal.shouldStopImmediately()) {
                aSignal.setOrigin(originalOrigin);
                return this;
            }

            item = items[i];

            //  if the specific handler is suspended or flagged for removal then
            //  just skip it
            if (item.suspend === true || item.remove === true) {
                TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
                        TP.trace('Listener ' + i +
                                 ' is suspended or removed.',
                                 TP.SIGNAL_LOG) : 0;

                continue;
            }

            if (TP.isFalse(capture)) {
                //  if capturing handlers are masked off, check and skip
                if (item.phase === 'capture') {
                    continue;
                }
            } else if (TP.isTrue(capture)) {
                if (item.phase !== 'capture') {
                    continue;
                }
            }

            //  if we're using strict XMLEvent or DOM firing then we have to
            //  check to see if the signal's target matches the specified
            //  dom_target if there is one
            if (checkTarget) {
                xml_target = item.xml_target;
                observer = item.observer;

                if (TP.notEmpty(xml_target) && xml_target !== TP.ANY) {
                    if (xml_target !== targetID &&
                        xml_target !== observer) {
                        TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
                                TP.trace(TP.join('DOM target check ',
                                ' wanted: ', xml_target,
                                ' found: ', targetID,
                                '. Skipping listener: ',
                                TP.str(item)),
                                TP.SIGNAL_LOG) : 0;

                        continue;
                    }
                }
            }

            //  acquire a handle to an actual handler instance by asking TIBET
            //  for whatever object is found at that ID. Note that this allows
            //  handlers to be swapped out from under observations without
            //  affecting the signal map itself.

            //  a side effect of having objects registered under 'tibet:urn's is
            //  that the handler can't be the TIBETURN URI itself. Therefore, if
            //  the item's handler starts with 'tibet:urn', then go ahead and
            //  use the URI object as the handler object.
            if (TP.regex.TIBET_URN.test(item.handler)) {
                handler = TP.uc(item.handler);
            } else {
                //  Otherwise, just get the handler by it's system ID
                handler = TP.bySystemId(item.handler);
            }

            if (TP.notValid(handler)) {
                TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE ?
                        TP.trace('Could not find handler with ID: ' +
                        item.handler,
                        TP.SIGNAL_LOG) : 0;
                continue;
            }

            //  If we're being asked to check the target, then we're being
            //  invoked from a policy that expects DOM semantics. We set the
            //  phase explicitly in this case, since the AT_TARGET phase is
            //  meaningless *when computing handler names*. I.e. the DOM has the
            //  notion of AT_TARGET, but not when computing handlers. Handlers
            //  are either capturing or bubbling.
            if (checkTarget) {
                //  It's easy to determine this based on the 'captureState'
                //  flag (which is what capture was set to).
                if (capture) {
                    phase = TP.CAPTURING;
                } else {
                    phase = TP.BUBBLING;
                }
            } else {
                //  Otherwise, set the phase to null and let the 'handle' call
                //  determine which handler to use based on the phase of the
                //  signal itself.
                phase = null;
            }

            if (TP.sys.shouldThrowHandlers()) {

                //  check for multiple notification bypass, or even a
                //  signal-configured ignore hook prior to firing
                if (!aSignal.hasNotified(handler, handler)) {

                    //  put a reference to the listener node itself where the
                    //  handler(s) can get to it when needed
                    aSignal.set('listener', item);

                    //  run the handler, making sure we can catch any exceptions
                    //  that are signaled

                    try {
                        //  NOTE that if we're observing TP.ANY signals, we
                        //  don't supply a 'starting signal name' and we skip
                        //  spoofs and traversing the signal hierarchy, as that
                        //  doesn't make sense.

                        oldHandler = aSignal.$get('currentHandler');
                        aSignal.$set('currentHandler', handler, false);

                        if (signame === TP.ANY) {
                            handlerResult = handler.handle(
                                aSignal,
                                {
                                    startSignal: TP.ANY,
                                    dontTraverseHierarchy: true,
                                    dontTraverseSpoofs: true,
                                    phase: phase
                                });
                        } else {
                            handlerResult = handler.handle(
                                aSignal,
                                {
                                    startSignal: signame,
                                    phase: phase
                                });
                        }
                    } finally {
                        //  set up so we won't tell it again unless it resets
                        if (handlerResult !== TP.NOT_FOUND) {
                            aSignal.trackHandler(handler, handler);
                        }
                        aSignal.$set('currentHandler', oldHandler, false);
                    }
                }
            } else {
                //  check for multiple notification bypass, or even a
                //  signal-configured skip hook prior to firing
                if (!aSignal.hasNotified(handler, handler)) {

                    try {

                        //  put a reference to the listener node itself where
                        //  the handler(s) can get to it when needed
                        aSignal.set('listener', item);

                        //  run the handler, making sure we can catch any
                        //  exceptions that are signaled

                        //  NOTE that if we're observing TP.ANY signals, we
                        //  don't supply a 'starting signal name' and we skip
                        //  spoofs and traversing the signal hierarchy, as that
                        //  doesn't make sense.

                        oldHandler = aSignal.$get('currentHandler');
                        aSignal.$set('currentHandler', handler, false);

                        if (signame === TP.ANY) {
                            handlerResult = handler.handle(
                                aSignal,
                                {
                                    startSignal: TP.ANY,
                                    dontTraverseHierarchy: true,
                                    dontTraverseSpoofs: true,
                                    phase: phase
                                });
                        } else {
                            handlerResult = handler.handle(
                                aSignal,
                                {
                                    startSignal: signame,
                                    phase: phase
                                });
                        }

                        //  TODO: add check here regarding removal of the
                        //  handler? this would be an alternative to cleanup
                        //  policies, simply setting state or adding functions
                        //  to the handlers themselves which return true when
                        //  the handler should be removed.

                        //  if so we can simply suspend the item so it is
                        //  skipped rather than removing the node
                    } catch (e) {

                        //  TODO: handler exception
                        //  TODO: Add a callback check at the handler/owner
                        //  level?

                        try {

                            //  see if we can get the actual function in
                            //  question so we have better debugging capability
                            hFunc = handler.getBestHandler(aSignal);

                            if (TP.isCallable(hFunc)) {
                                TP.ifError() ?
                                        TP.error(
                                        TP.ec(e,
                                        TP.join('Error in: ', orgid,
                                                '.', signame,
                                                ' responder: ',
                                                handler.getID(),
                                                '\nhandler: ',
                                                hFunc.getName())),
                                        TP.SIGNAL_LOG) : 0;
                            } else {
                                TP.ifError() ?
                                        TP.error(
                                        TP.ec(e,
                                        TP.join('Error in: ', orgid,
                                                '.', signame,
                                                ' responder: ',
                                                handler.getID())),
                                        TP.SIGNAL_LOG) : 0;
                            }
                        } catch (e2) {
                            TP.ifError() ?
                                    TP.error(
                                    TP.ec(e2,
                                    TP.join('Error getting handler for: ', orgid,
                                            '.', signame)),
                                    TP.SIGNAL_LOG) : 0;
                        }

                        //  register the handler if TIBET is configured for
                        //  that so that the suspended function can be acquired
                        //  by the developer for debugging
                        if (TP.sys.shouldRegisterLoggers()) {
                            TP.sys.registerObject(handler, null, true, false);
                        }
                    } finally {
                        //  set up so we won't tell it again unless it resets
                        if (handlerResult !== TP.NOT_FOUND) {
                            aSignal.trackHandler(handler, handler);
                        }
                        aSignal.$set('currentHandler', oldHandler, false);
                    }
                }
            }

            //  handle XML Events attributes for propagation etc.
            if (item.propagate === 'stop') {
                aSignal.stopPropagation(true);
            }

            if (item.defaultAction === 'cancel') {
                aSignal.preventDefault(true);
            }
        }

        aSignal.setOrigin(originalOrigin);
    } catch (e) {
        TP.ifError() ?
            TP.error(
                TP.ec(e, TP.join('Problem executing handlers for: ',
                                TP.str(aSignal))),
                TP.SIGNAL_LOG) : 0;

        //  If we're throwing handlers, then rethrow the Error object.
        if (TP.sys.shouldThrowHandlers()) {
            throw e;
        }
    } finally {
        //  "pop" the signal stack, throwing away the last signal and making the
        //  current signal the one at the end of the stack (or null)
        TP.$signal_stack.pop();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('FIRE_ONE',
function(anOrigin, aSignal, aPayload, aType) {

    /**
     * @method FIRE_ONE
     * @summary Fires a single signal from a single origin.
     * @param {Object} anOrigin The originator of the signal.
     * @param {String|TP.sig.Signal} aSignal The signal to fire.
     * @param {Object} aPayload Optional argument object.
     * @param {String|TP.sig.Signal} aType A default type to use when the signal
     *     type itself isn't found and a new signal subtype must be created.
     *     Defaults to TP.sig.Signal.
     * @returns {TP.sig.Signal|undefined} The signal.
     */

    var sig,
        origin,
        orgid,
        signame;

    //  Ensure a valid signal instance, defaulting to TP.sig.Signal instance.
    sig = TP.sig.SignalMap.$getSignalInstance(
        TP.ifInvalid(aSignal, TP.sig.Signal), aPayload, aType);

    if (!TP.isKindOf(sig, TP.sig.Signal)) {
        return;
    }

    //  Ensure a valid origin, defaulting to TP.ANY when not provided.
    origin = TP.ifInvalid(anOrigin, TP.ANY);
    orgid = TP.id(origin);

    //  Configure signal instance.
    sig.setOrigin(origin);
    signame = sig.getSignalName();

    TP.sig.SignalMap.notifyObservers(orgid, signame, sig,
        TP.hc('checkPropagation', true));

    //  Make sure we should continue with controller stack notifications.
    if (sig.shouldStop() || sig.shouldStopImmediately()) {
        sig.isRecyclable(true);
        return sig;
    }

    //  don't repeat if the signal name was already TP.ANY
    if (signame !== TP.ANY) {
        TP.sig.SignalMap.notifyObservers(orgid, null, sig,
            TP.hc('checkPropagation', true));

        //  Make sure we should continue with controller stack notifications.
        if (sig.shouldStop() || sig.shouldStopImmediately()) {
            sig.isRecyclable(true);
            return sig;
        }
    }

    //  don't repeat if the origin name was already TP.ANY
    if (orgid !== TP.ANY) {
        TP.sig.SignalMap.notifyObservers(null, signame, sig,
            TP.hc('checkPropagation', true));

        //  Make sure we should continue with controller stack notifications.
        if (sig.shouldStop() || sig.shouldStopImmediately()) {
            sig.isRecyclable(true);
            return sig;
        }
    }

    //  Final step is to notify controllers which completes the responder chain.
    TP.sig.SignalMap.notifyControllers(sig);

    //  once the signal has been fired we can clear it for reuse
    sig.isRecyclable(true);

    return sig;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('OBSERVER_FIRING',
function(anOrigin, signalSet, aPayload, aType) {

    /**
     * @method OBSERVER_FIRING
     * @summary Fires one or more signals from one or more origins.
     * @param {Object} anOrigin The originator or originators of the signal(s).
     * @param {String|TP.sig.Signal} signalSet The signal(s) to fire.
     * @param {Object} aPayload Optional argument object for signal instance.
     * @param {String|TP.sig.Signal} [aType=TP.sig.Signal] A default type to use
     *     when signal type isn't found and a new signal subtype must be created.
     * @returns {TP.sig.Signal} The returned instance from the signal sequence.
     */

    var policy,
        origin,
        i,
        j,
        res;

    policy = TP.sig.SignalMap.FIRE_ONE;

    //  deal with possibility that origin IS an array
    /* eslint-disable no-extra-parens */
    if ((TP.isArray(anOrigin) && !anOrigin.isOriginSet()) ||
        (!TP.isArray(anOrigin))) {
    /* eslint-enable no-extra-parens */

        //  only one origin
        origin = anOrigin;

        if (TP.isArray(signalSet)) {
            //  array of signals but only the array as an origin
            for (j = 0; j < signalSet.getSize(); j++) {
                res = policy(
                    origin, signalSet.at(j), aPayload, aType);
            }
        } else {
            //  one signal, one origin
            res = policy(origin, signalSet, aPayload, aType);
        }
    } else if (TP.isArray(anOrigin)) {
        //  otherwise, its an Array, but its an Array of 'origin sets'.
        if (TP.isArray(signalSet)) {
            //  array of origins, array of signals
            for (i = 0; i < anOrigin.getSize(); i++) {
                origin = anOrigin.at(i);

                for (j = 0; j < signalSet.getSize(); j++) {
                    res = policy(
                        origin, signalSet.at(j), aPayload, aType);
                }
            }
        } else {
            //  array of origins, one signal
            for (i = 0; i < anOrigin.getSize(); i++) {
                origin = anOrigin.at(i);
                res = policy(origin, signalSet, aPayload, aType);
            }
        }
    }

    return res;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('DOM_FIRING',
function(originSet, aSignal, aPayload, aType) {

    /**
     * @method DOM_FIRING
     * @summary Fires a single signal across a series of origins which should be
     *     provided in DOM containment order. This policy implements DOM Level2
     *     signaling without relying on addEventListener for the elements. All
     *     capturing, target, and bubbling phase processes are fully supported.
     *     NOTE that TIBET supports an extension via the on: namespace which
     *     lets DOM signals use alternative signal names if on:{event} is found
     *     at an element as the DOM is traversed.
     * @param {Object|Object[]} originSet The set of origins for the signal. The
     *     list should be provided from the document down to the target element.
     *     If a single origin is provided
     * @param {String|TP.sig.Signal} aSignal The signal to fire.
     * @param {Object} aPayload Optional argument object for the signal instance.
     * @param {String|TP.sig.Signal} aType A default type to use when the signal
     *     type itself isn't found and a new signal subtype must be created.
     *     Defaults to TP.sig.Signal.
     * @returns {TP.sig.Signal|undefined} The signal.
     */

    var map,
        sig,
        signame,
        orgid,
        target,
        i,
        entry,
        evt,
        eventType,
        onstarEvtName,
        onstarSigFullName,
        onstarSigShortName,
        onAttrDetector,
        origins,
        origin,
        originType,
        originArray,
        len,
        originGlobalID,
        sigdata;

    //  in the DOM model we can only fire if we have a signal and origin
    if (TP.notValid(aSignal) || TP.notValid(originSet)) {
        return TP.sig.SignalMap.raise('TP.sig.InvalidDOMSignal');
    }

    //  DOMUISignal types can give us their event (and that's what is typically
    //  fired via DOM_FIRING). We leverage the event to support on: remapping.
    if (TP.canInvoke(aSignal, 'getEvent')) {
        evt = aSignal.getEvent();

        if (TP.isEvent(evt)) {

            //  This will be something like 'click', 'change', etc.
            eventType = aSignal.getEventType();

            //  Make sure the name exists as a key in the native event signal
            //  map.
            if (TP.NON_OBSERVED_ON_ATTRS.hasKey(eventType)) {

                //  Note how we capture both the low-level event name and the
                //  higher level signal name here. The author could've used
                //  either one.
                onstarEvtName = eventType;
                onstarSigFullName = TP.NON_OBSERVED_ON_ATTRS.at(eventType);
                onstarSigShortName = TP.contractSignalName(onstarSigFullName);

                //  Note here how the detector searches for attributes in the
                //  TP.w3.Xmlns.ON namespace, in case the user hasn't used the
                //  'on:' prefix. This detector function is used below.
                onAttrDetector = function(attrNode) {

                    var localName;

                    localName = TP.attributeGetLocalName(attrNode);

                    /* eslint-disable no-extra-parens */
                    return ((localName === onstarEvtName ||
                                localName === onstarSigFullName ||
                                localName === onstarSigShortName) &&
                            attrNode.namespaceURI === TP.w3.Xmlns.ON);
                    /* eslint-enable no-extra-parens */
                };
            }
        }
    }

    map = TP.sig.SignalMap.interests;

    //  get a valid signal instance configured
    sig = TP.sig.SignalMap.$getSignalInstance(aSignal, aPayload, aType);
    if (!TP.isKindOf(sig, TP.sig.Signal)) {
        return;
    }

    //  one or more origins are required. warn if we don't get an array.
    if (!TP.isArray(originSet)) {
        //  TODO: this causes lama logging to recurse endlessly due to furing
        //  DOMContentLoaded without an origin array every time it appends.
        // TP.ifWarn() ? TP.warn('DOM firing without origin array: ' +
            // TP.ifEmpty(sig.getSignalName(), TP.ANY)) : 0;
        origins = TP.ac(originSet);
    } else {
        origins = originSet;
    }

    //  set up the signal name, using TP.ANY if we can't get one
    if (TP.isEmpty(signame = sig.getSignalName())) {
        //  TODO: this can potentially cause lama to recurse. commented out
        //  for now. see comments in earlier block.
        // TP.ifWarn() ? TP.warn('DOM firing without signal name from: ' +
        //    origins.join(', ')) : 0;
        signame = TP.ANY;
    }

    //  without a target we've got trouble in DOM firing since the target
    //  defines when we stop capturing and start bubbling...
    target = sig.getResolvedTargetGlobalID();

    //  as we loop downward we'll keep track of orgids that have event
    //  listeners registered. this keeps us from doing the lookups twice
    originArray = TP.ac();


    //  ---
    //  Process CAPTURING
    //  ---

    //  set the phase to capturing to get started
    sig.setPhase(TP.CAPTURING);

    //  loop down through the list until we reach the target, performing the
    //  lookups and notifying any capturing handlers as we descend
    len = origins.getSize();
    for (i = 0; i < len; i++) {
        //  we enter this loop in capturing phase, so we want to do at least
        //  one pass before making any changes to phase etc.

        origin = origins.at(i);

        //  check each one as we pass for any on: remapping. if found we need to
        //  ensure that element is in our origin list for the bubbling phase.
        if (TP.isCallable(onAttrDetector) && TP.isElement(origin)) {
            if (TP.elementGetAttributeNodes(origin).detect(onAttrDetector)) {
                //  Found an on: mapping for this origin...
                originArray.push(origin);
            }
        }

        //  global id

        //  work with ID's for map entries (GC issues)
        orgid = TP.gid(origin);

        //  be sure to update the signal as we rotate orgids
        sig.setOrigin(orgid);

        //  if there's an entry for this origin/signal pair then we'll check
        //  it again when we do the bubbling pass...
        if (TP.isValid(entry = map[orgid + '.' + signame])) {

            if (originArray.last() !== origin) {
                originArray.push(origin);
            }

            //  start with most specific, which is origin and signal
            //  listeners. this also happens to be all the DOM standard
            //  really supports, they don't have a way to specify any signal
            //  type from an origin
            TP.sig.SignalMap.notifyObservers(orgid, signame, sig,
                TP.hc('checkPropagation', false,
                        'captureState', true,
                        'aSigEntry', entry,
                        'checkTarget', true));
        }

        //  as long as we didn't default the signal to "ANY" we'll check
        //  that as well
        if (signame !== TP.ANY) {
            //  if there's an entry for this origin and TP.ANY then we'll
            //  check it again when we do the bubbling pass...
            if (TP.isValid(entry = map[orgid + '.' + TP.ANY])) {

                if (originArray.last() !== origin) {
                    originArray.push(origin);
                }

                //  while we're dropping down we'll check this origin for
                //  any capturing handlers that are blanket signal handlers
                TP.sig.SignalMap.notifyObservers(orgid, null, sig,
                    TP.hc('checkPropagation', false,
                            'captureState', true,
                            'aSigEntry', entry,
                            'checkTarget', true));
            }
        }

        //  Capture the global origin id before resetting it to the local id.
        //  We'll use it later for comparison.
        originGlobalID = orgid;

        //  local id

        //  work with ID's for map entries (GC issues)
        orgid = TP.lid(origin);

        //  be sure to update the signal as we rotate orgids
        sig.setOrigin(orgid);

        //  if there's an entry for this origin/signal pair then we'll check
        //  it again when we do the bubbling pass...
        if (TP.isValid(entry = map[orgid + '.' + signame])) {

            if (originArray.last() !== origin) {
                originArray.push(origin);
            }

            //  start with most specific, which is origin and signal
            //  listeners. this also happens to be all the DOM standard
            //  really supports, they don't have a way to specify any signal
            //  type from an origin
            TP.sig.SignalMap.notifyObservers(orgid, signame, sig,
                TP.hc('checkPropagation', false,
                        'captureState', true,
                        'aSigEntry', entry,
                        'checkTarget', true));
        }

        //  as long as we didn't default the signal to "ANY" we'll check
        //  that as well
        if (signame !== TP.ANY) {
            //  if there's an entry for this origin and TP.ANY then we'll
            //  check it again when we do the bubbling pass...
            if (TP.isValid(entry = map[orgid + '.' + TP.ANY])) {

                if (originArray.last() !== origin) {
                    originArray.push(origin);
                }

                //  while we're dropping down we'll check this origin for
                //  any capturing handlers that are blanket signal handlers
                TP.sig.SignalMap.notifyObservers(orgid, null, sig,
                    TP.hc('checkPropagation', false,
                            'captureState', true,
                            'aSigEntry', entry,
                            'checkTarget', true));
            }
        }

        //  propagation

        //  if any of the handlers at this origin "level" said to stop then
        //  we stop now before traversing to a new level in the DOM
        if (sig.shouldStop() || sig.shouldStopImmediately()) {

            //  reset the signal's phase to the original setting - null
            sig.setPhase(null);

            //  reset the signal's origin so we don't confuse things in the
            //  final notification process by making it the original target ID
            sig.setOrigin(target);

            return sig;
        }

        //  are we on the way down or up? if we've reached the target we'll
        //  want to stop once we do a final notification of any capturing
        //  handlers at the target level
        if (originGlobalID === target) {
            sig.setPhase(TP.AT_TARGET);
            break;
        }
    }


    //  ---
    //  Process AT_TARGET / BUBBLING
    //  ---


    //  flip the origin array around so we work "bottom up" to bubble
    originArray.reverse();

    //  now loop back through the bubbling list which was populated as we
    //  searched down toward the target. in most cases this list is a lot
    //  shorter than the downward list since most origins don't have
    //  registrations
    len = originArray.getSize();
    for (i = 0; i < len; i++) {

        origin = originArray.at(i);

        if (TP.isElement(origin)) {
            //  Grab the TIBET wrapper type for the element and query it to see
            //  if the current element is considered to be 'opaque' for the
            //  event at it's level as it bubbles.
            if (TP.isType(originType =
                            TP.dom.ElementNode.getConcreteType(origin))) {
                if (originType.isOpaqueBubblerFor(origin, sig)) {
                    //  If the type has returned true here, that means that
                    //  we're to stop processing this signal after this origin
                    //  is processed. To do so is quite simple. Truncate the
                    //  originArray that we built during the capturing
                    //  processing (making sure to set the 'len' local variable
                    //  so that the loop will exit).
                    originArray = originArray.slice(0, i + 1);
                    len = i + 1;
                }
            }
        }

        //  If a detector function was defined and our origin is an Element,
        //  then we are eligible for 'on:' remapping.
        if (TP.isCallable(onAttrDetector) && TP.isElement(origin)) {

            if (TP.elementGetAttributeNodes(origin).detect(onAttrDetector)) {
                //  Found an on: mapping for this origin...

                //  NB: We can use 'on:' here even if the user didn't, since the
                //  'true' in the 3rd parameter will cause a search of the
                //  TP.w3.Xmlns.ON namespace if an attribute prefixed by 'on:'
                //  isn't found.

                //  First, try the event name.
                if (TP.elementHasAttribute(
                            origin, 'on:' + onstarEvtName, true)) {
                    sigdata = TP.elementGetAttribute(
                                origin,
                                'on:' + onstarEvtName,
                                true);
                } else if (TP.elementHasAttribute(
                            origin, 'on:' + onstarSigFullName, true)) {

                    //  Next, try the 'full signal name' (which we would have
                    //  gotten from the TP.NON_OBSERVED_ON_ATTRS above).
                    sigdata = TP.elementGetAttribute(
                                origin,
                                'on:' + onstarSigFullName,
                                true);
                } else {
                    //  Last, try the 'short signal name'
                    sigdata = TP.elementGetAttribute(
                                origin,
                                'on:' + onstarSigShortName,
                                true);
                }

                //  If we were able to successfully extract signal data, then
                //  queue up a signal that will fire based on this data.
                if (TP.notEmpty(sigdata)) {
                    TP.queueSignalFromData(
                                sigdata,
                                origin,
                                sig,
                                null,   //  payload - here we use the value in
                                        //  sigdata, even if it's undefined.
                                null,   //  policy - here we use the value in
                                        //  sigdata, even if it's undefined.
                                TP.sig.ResponderSignal);
                }

                continue;
            }
        }

        //  global id

        //  always work with ID's for map entries (GC issues)
        orgid = TP.gid(origin);

        //  be sure to update the signal as we rotate orgids
        sig.setOrigin(orgid);

        //  continue with most specific, which is origin and signal pair.
        TP.sig.SignalMap.notifyObservers(orgid, signame, sig,
                    TP.hc('checkPropagation', false,
                            'captureState', false,
                            'checkTarget', true));

        //  notifyObservers will default null to TP.ANY so if we just did
        //  that one don't do it again
        if (signame !== TP.ANY) {
            //  next in bubble is for the origin itself, but any signal...
            TP.sig.SignalMap.notifyObservers(orgid, null, sig,
                    TP.hc('checkPropagation', false,
                            'captureState', false,
                            'checkTarget', true));
        }

        //  local id

        //  always work with ID's for map entries (GC issues)
        orgid = TP.lid(origin);

        //  be sure to update the signal as we rotate orgids
        sig.setOrigin(orgid);

        //  continue with most specific, which is origin and signal pair.
        TP.sig.SignalMap.notifyObservers(orgid, signame, sig,
                    TP.hc('checkPropagation', false,
                            'captureState', false,
                            'checkTarget', true));

        //  notifyObservers will default null to TP.ANY so if we just did
        //  that one don't do it again
        if (signame !== TP.ANY) {
            //  next in bubble is for the origin itself, but any signal...
            TP.sig.SignalMap.notifyObservers(orgid, null, sig,
                    TP.hc('checkPropagation', false,
                            'captureState', false,
                            'checkTarget', true));
        }

        //  propagation

        //  if any of the handlers at this origin "level" said to stop then
        //  we stop now before traversing to a new level in the DOM
        if (sig.shouldStop() || sig.shouldStopImmediately()) {

            //  reset the signal's phase to the original setting - null
            sig.setPhase(null);

            //  reset the signal's origin so we don't confuse things in the
            //  final notification process by making it the original target ID
            sig.setOrigin(target);

            return sig;
        }

        //  once we've run through the *target* (i.e. AT_TARGET) for bubbling
        //  handlers we'll set this to TP.BUBBLING for the rest of the
        //  iterations. Note that since the regular DOM has no notion of
        //  separate AT_TARGET and BUBBLING handlers for the target itself,
        //  we've really just run a bubbling handler, but with the phase set to
        //  AT_TARGET. Now that that's done, we can move on to the true bubbling
        //  phase, starting with the next origin in the list.
        if (sig.getPhase() === TP.AT_TARGET) {
            //  if the signal bubbles then we continue, otherwise we'll stop
            //  here
            if (!sig.isBubbling()) {
                break;
            }

            sig.setPhase(TP.BUBBLING);
        }
    }

    //  reset the signal's phase to the original setting - null
    sig.setPhase(null);

    //  reset the signal's origin so we don't confuse things in the final
    //  notification process by making it the original target ID
    sig.setOrigin(target);

    //  last but not least is the check for observers of the signal from any
    //  origin, but note that we only do this notification check once (since
    //  the signal name isn't changing during the DOM traversal process) and
    //  that we notify capturers, check for stopPropagation, then bubble
    TP.sig.SignalMap.notifyObservers(null, signame, sig,
                    TP.hc('checkPropagation', false,
                            'captureState', true,
                            'checkTarget', true));

    if (sig.shouldStop() || sig.shouldStopImmediately()) {
        return sig;
    }

    TP.sig.SignalMap.notifyObservers(null, signame, sig,
                    TP.hc('checkPropagation', false,
                            'captureState', false,
                            'checkTarget', true));

    return sig;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('RESPONDER_FIRING',
function(anOrigin, aSignal, aPayload, aType) {

    /**
     * @method RESPONDER_FIRING
     * @summary Fires signals across a series of responders.
     * @description Responder chain computation is based on the DOM but is
     *     sparse, including only those elements with either a tibet:ctrl or
     *     tibet:tag (or both) or a 'custom element'. Unlike DOM_FIRING, the
     *     RESPONDER_FIRING policy also includes the application controller
     *     stack in the capture and bubble phase processing. As a result
     *     RESPONDER_FIRING is a general purpose policy that can handle
     *     application widgets and their controllers very effectively.
     * @param {Object} anOrigin The originator of the signal.
     * @param {String|TP.sig.Signal} aSignal The signal to fire.
     * @param {Object} aPayload Optional argument object.
     * @param {String|TP.sig.Signal} aType A default type to use when the signal
     *     type itself isn't found and a new signal subtype must be created.
     *     Defaults to TP.sig.Signal.
     * @returns {TP.sig.Signal|undefined} The signal.
     */

    var sig,
        target,
        origin,

        responders,

        i,
        len,
        responder,

        responderIsOrigin,
        shouldContinue;

    if (TP.notValid(aSignal)) {
        return TP.sig.SignalMap.raise('TP.sig.InvalidSignal');
    }

    //  Must be able to create a signal instance or no point in continuing.
    sig = TP.sig.SignalMap.$getSignalInstance(aSignal, aPayload, aType);
    if (!TP.isKindOf(sig, TP.sig.Signal)) {
        return;
    }

    //  Update any newly created signal to have the proper origin.
    if (TP.notValid(sig.getOrigin())) {
        sig.setOrigin(anOrigin);
    }

    //  Capture initial target and origin data. We use these to ensure we
    //  message controllers properly during both capturing and bubbling.
    target = sig.getTarget();
    origin = sig.getOrigin();

    //  ---
    //  Capturing phase...controllers
    //  ---

    //  set the phase to capturing to get started
    sig.setPhase(TP.CAPTURING);

    TP.sig.SignalMap.notifyControllers(sig);

    //  After processing make sure we should continue with the next phase.
    if (sig.shouldStop() || sig.shouldStopImmediately()) {
        return;
    }

    //  ---
    //  Capturing phase...responders
    //  ---

    //  If the signal has a target and that's a target node then we can do a
    //  responder-chain computation.
    if (TP.isNode(target)) {

        responders = TP.nodeGetResponderChain(target, sig);

        if (TP.notEmpty(responders)) {

            //  Initial array comes in target-to-parent order which is inverted
            //  from what we want for capturing phase so we reverse for this
            //  step.
            responders.reverse();

            len = responders.getSize();
            for (i = 0; i < len; i++) {
                responder = responders.at(i);

                //  We track here whether the currently processing responder and
                //  origin are the same. If so, we ignore the value of the
                //  shouldContinue flag, since if it is the origin itself that's
                //  sending the signal (not a target 'under' it), we need to
                //  continue executing its handlers.
                responderIsOrigin = responder === origin;

                //  Each responder is an element. We want to notify any
                //  tibet:ctrl and tibet:tag found on the element.
                shouldContinue = TP.sig.SignalMap.$notifyResponders(
                                                            responder, sig);

                //  Always check whether we should continue. Any form of stop
                //  propagation setting will cause responder signals to stop.
                /* eslint-disable no-extra-parens */
                if ((!shouldContinue && !responderIsOrigin) ||
                    sig.shouldStop() ||
                    sig.shouldStopImmediately()) {
                    return sig;
                }
                /* eslint-enable no-extra-parens */
            }
        }
    }

    //  ---
    //  At-target phase...responders
    //  ---

    sig.setPhase(TP.AT_TARGET);

    //  NOTE that we only do this if the target is a responder element...
    //  otherwise we don't really have a valid 'at target' step.
    if (TP.isValid(target) &&
        TP.nodeGetResponderElement(target, sig) === target) {

        //  We track here whether the currently processing responder and origin
        //  are the same. If so, we ignore the value of the shouldContinue flag,
        //  since if it is the origin itself that's sending the signal (not a
        //  target 'under' it), we need to continue executing its handlers.
        responderIsOrigin = responder === origin;

        //  tibet:ctrl and tibet:tag found on the element.
        shouldContinue = TP.sig.SignalMap.$notifyResponders(target, sig);

        //  if any of the handlers at this origin "level" said to stop
        //  then we stop now before executing the bubbling handlers.
        /* eslint-disable no-extra-parens */
        if ((!shouldContinue && !responderIsOrigin) ||
            sig.shouldStop() ||
            sig.shouldStopImmediately()) {
            return sig;
        }
        /* eslint-enable no-extra-parens */
    }

    //  ---
    //  Bubbling phase...responders
    //  ---

    //  we're bubbling... we're bubbling...
    sig.setPhase(TP.BUBBLING);

    if (TP.notEmpty(responders)) {

        //  convert back to target-to-ancestor ordering for bubbling phase.
        responders.reverse();

        //  if the signal bubbles then we continue, otherwise we'll stop
        if (!sig.isBubbling()) {
            return sig;
        }

        len = responders.getSize();
        for (i = 0; i < len; i++) {
            responder = responders.at(i);

            //  We track here whether the currently processing responder and
            //  origin are the same. If so, we ignore the value of the
            //  shouldContinue flag, since if it is the origin itself that's
            //  sending the signal (not a target 'under' it), we need to
            //  continue executing its handlers.
            responderIsOrigin = responder === origin;

            //  Each responder is an element. We want to notify any tibet:ctrl
            //  and tibet:tag found on the element.
            shouldContinue = TP.sig.SignalMap.$notifyResponders(responder, sig);

            //  Always check whether we should continue. Any form of stop
            //  propagation setting will cause responder signals to stop.
            /* eslint-disable no-extra-parens */
            if ((!shouldContinue && !responderIsOrigin) ||
                sig.shouldStop() ||
                sig.shouldStopImmediately()) {
                return sig;
            }
            /* eslint-enable no-extra-parens */
        }
    }

    //  ---
    //  Bubbling phase...controllers
    //  ---

    //  Restore the "entry" origin to whatever value we captured. This avoids
    //  any issues due to notifications revolving the origin for signaling.
    sig.setOrigin(origin);

    TP.sig.SignalMap.notifyControllers(sig);

    return sig;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('$notifyResponders',
function(target, signal) {

    /**
     * @method $notifyResponders
     * @summary Notifies any tibet:ctrl and/or tibet:tag objects associated with
     *     a specific target element. This method is a helper for the
     *     RESPONDER_FIRING policy and not typically invoked directly.
     * @param {Element} target The element to notify for.
     * @param {TP.sig.Signal} signal The signal to handle.
     * @returns {Boolean} Whether or not to continue signalling responders along
     *     the responder chain.
     */

    var id,
        lastType,
        type,
        responder;

    //  tibet:ctrl

    id = TP.elementGetAttribute(target, 'tibet:ctrl', true);
    if (TP.notEmpty(id)) {

        //  First, try to look up the responder by 'global ID'
        responder = TP.bySystemId(id);
        if (TP.notValid(responder)) {

            //  Next, try to look it up by 'local ID', relative to the context
            //  (i.e. page) that the target it in (which is obtained by
            //  supplying the target).
            responder = TP.byId(id, target);
        }

        if (TP.notValid(responder)) {
            TP.ifWarn() ?
                TP.warn('Unable to resolve tibet:ctrl ' + id + '.') : 0;
        }

        if (TP.isValid(responder)) {
            if (TP.isType(responder)) {
                lastType = responder;
            } else {
                lastType = responder.getType();
            }

            if (TP.canInvoke(responder, 'handle')) {
                responder.handle(signal);
            } else {
                return this.raise('InvalidController',
                                    TP.sc('Controller: ', id,
                                            ' cannot invoke "handle" using: ',
                                            signal.getSignalName()));
            }

            //  Don't proceed to tibet:tag without checking for propagation.
            //  Note that we only check for 'stop immediately' here because
            //  we're at the same 'DOM element' level for the next check of
            //  'tibet:tag'.
            if (signal.shouldStopImmediately()) {
                return false;
            }
        }
    }

    //  tibet:tag

    id = TP.elementGetAttribute(target, 'tibet:tag', true);
    if (TP.notEmpty(id)) {
        responder = TP.bySystemId(id);
        if (TP.notValid(responder)) {
            TP.ifWarn() ?
                TP.warn('Unable to resolve tibet:tag ' + id + '.') : 0;
        } else {
            //  tibet:tag is typically a type name reference but we want to wrap
            //  the element in an instance and get it to respond.
            if (TP.isType(responder)) {
                type = responder;
                responder = responder.construct(target);
            } else {
                type = responder.getType();
            }

            //  Don't dispatch twice to an instance of the same type.
            if (type !== lastType) {
                lastType = type;

                if (TP.canInvoke(responder, 'handle')) {
                    responder.handle(signal);
                } else {
                    this.raise('InvalidResponder',
                        TP.sc('Responder: ', id,
                                ' cannot handle: ', signal.getSignalName()));
                }

                //  Don't proceed to tibet:tag without checking for propagation.
                //  Note that we only check for 'stop immediately' here because
                //  we're at the same 'DOM element' level for the next check of
                //  'tibet:tag'.
                if (signal.shouldStopImmediately()) {
                    return false;
                }
            }
        }
    }

    //  isResponderFor

    type = TP.nodeGetConcreteType(target);
    if (type !== lastType) {
        responder = TP.wrap(target);
        if (TP.canInvoke(responder, 'handle')) {
            responder.handle(signal);
        } else {
            this.raise('InvalidResponder',
                    TP.sc('Responder: ', id,
                            ' cannot handle: ', signal.getSignalName()));
        }
    }

    //  Depending on the signal's phase, we check to see if the type is
    //  configured to be opaque for either the capturing or bubbling phase. If
    //  it is, then we return false because we don't want the rest of the
    //  responder chain to be processed (for that phase).
    if (signal.getPhase() === TP.CAPTURING) {
        return !type.isOpaqueCapturerFor(target, signal);
    } else if (signal.getPhase() === TP.BUBBLING) {
        return !type.isOpaqueBubblerFor(target, signal);
    }

    return true;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('EXCEPTION_FIRING',
function(anOrigin, signalSet, aPayload, aType) {

    /**
     * @method EXCEPTION_FIRING
     * @summary Fires a series of exceptions from the origin provided until a
     *     handler for one of the exception types/supertypes stops signal
     *     propagation.
     * @param {Object} anOrigin The originator of the signal.
     * @param {TP.sig.Signal|TP.sig.Signal[]} signalSet The signal(s) to fire.
     * @param {Object} aPayload Optional argument object.
     * @param {String|TP.sig.Signal} aType A default type to use when the signal
     *     type itself isn't found and a new signal subtype must be created.
     *     Defaults to TP.sig.Exception.
     * @returns {TP.sig.Signal|undefined} The signal.
     */

    var i,
        sig,
        orgid,
        signame,
        aSignal,
        orig,
        aSet,
        fixedName;

    //  if no signal provided then bail out since we don't want to
    //  'infer' an exception
    if (TP.notValid(signalSet)) {
        return;
    }

    //  ensure we've got a valid origin if we do have a valid exception
    orig = TP.ifInvalid(anOrigin, TP.ANY);

    //  make sure signals are in an array for loop control. Creating the
    //  object is a little expensive but hey, we're processing an exception
    //  anyway at this point :)
    if (!TP.isArray(signalSet)) {
        aSet = TP.ac();
        aSet.push(signalSet);
    } else {
        aSet = signalSet;
    }

    //  the 'most specific' exception is the first one so we use it
    //  as the actual signal instance.
    aSignal = aSet.at(0);

    //  get a valid signal instance configured
    sig = TP.sig.SignalMap.$getSignalInstance(
                                aSignal,
                                aPayload,
                                TP.ifInvalid(aType, TP.sig.Exception));

    if (!TP.isKindOf(sig, TP.sig.Signal)) {
        return;
    }

    //  configure the signal instance
    sig.setOrigin(orig);

    //  only one origin so fetch it now outside the loop
    orgid = TP.id(orig);

    //  process the list of alternative supertypes. note that there's an
    //  interesting check here to avoid lookup of origin/any observations
    //  more than once since that lookup's results can't change in the loop
    for (i = 0; i < aSet.getSize(); i++) {
        //  use data from array to work through the maps
        signame = aSet.at(i).getSignalName();

        //  notify specific observers for the signal/origin combo
        TP.sig.SignalMap.notifyObservers(orgid, signame, sig,
                    TP.hc('checkPropagation', true));

        if (sig.shouldStop() || sig.shouldStopImmediately()) {
            break;
        }

        //  don't repeat if the signal name was already TP.ANY
        if (signame !== TP.ANY) {
            //  notify specific observers for the origin and any signal but
            //  only do this the first time through the loop (since the
            //  observation results won't change as we iterate)
            if (i === 0) {
                TP.sig.SignalMap.notifyObservers(orgid, null, sig,
                    TP.hc('checkPropagation', true));

                if (sig.shouldStop() || sig.shouldStopImmediately()) {
                    break;
                }
            }
        }

        //  notify observers of the signal from any origin
        if (orgid !== TP.ANY) {
            TP.sig.SignalMap.notifyObservers(null, signame, sig,
                    TP.hc('checkPropagation', true));

            if (sig.shouldStop() || sig.shouldStopImmediately()) {
                break;
            }
        }

        //  For controller notification we want to ensure the signal instance
        //  has the actual signal name for this iteration. We set it back after
        //  attempting invocation.
        try {
            fixedName = sig.getSignalName();
            sig.setSignalName(signame);

            TP.sig.SignalMap.notifyControllers(sig, {dontTraverseSpoofs: true});
        } catch (e) {
            //  Catch is required for older IE versions and void is needed to
            //  keep lint happy. The notify call handles error reporting.
            void 0;
        } finally {
            sig.setSignalName(fixedName);
        }
    }

    return sig;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('INHERITANCE_FIRING',
function(anOrigin, aSignal, aPayload, aType) {

    /**
     * @method INHERITANCE_FIRING
     * @summary Fires a signal ensuring that observers of supertypes of that
     *     signal are notified. This is a single origin/single signal policy.
     * @param {Object} anOrigin The originator of the signal.
     * @param {TP.sig.Signal} aSignal The signal to fire.
     * @param {Object} aPayload Optional argument object.
     * @param {String|TP.sig.Signal} aType A default type to use when the signal
     *     type itself isn't found and a new signal subtype must be created.
     *     Defaults to TP.sig.Signal.
     * @returns {TP.sig.Signal|undefined} The signal.
     */

    var aSig,
        orig,
        sig,
        orgid,
        type,
        signames,
        len,
        i,
        signame,
        fixedName,
        isSpoofed;

    aSig = aSignal;

    if (TP.isArray(aSignal)) {
        if (aSignal.length >= 1) {
            TP.ifError() ?
                TP.error(
                    'Invalid Signal Array For Firing Policy. Truncating.',
                    TP.SIGNAL_LOG) : 0;

            aSig = aSignal[0];
        } else {    //  oops, empty array
            TP.ifError() ?
                TP.error(
                    'Invalid Signal For Firing Policy. Terminating.',
                    TP.SIGNAL_LOG) : 0;

            return;
        }
    }

    //  ensure we've got a valid origin
    orig = TP.ifInvalid(anOrigin, TP.ANY);

    //  get a valid signal instance configured
    sig = TP.sig.SignalMap.$getSignalInstance(aSig, aPayload, aType);
    if (!TP.isKindOf(sig, TP.sig.Signal)) {
        return;
    }

    //  configure the signal instance
    sig.setOrigin(orig);

    orgid = TP.id(orig);

    //  process the list. as with exception firing we have a special test in
    //  this loop so we only look for origin/any observations once since the
    //  origin isn't changing during this loop
    type = sig.getType();

    signames = sig.getSignalNames();
    len = signames.getSize();

    for (i = 0; i < len; i++) {
        signame = signames.at(i);

        //  are we at Signal? top of signal hierarchy so stop here
        if (signame === 'TP.sig.Signal') {
            break;
        }

        //  as we loop across signal names we may be stopped, so check that.
        if (i > 0 && (sig.shouldStop() || sig.shouldStopImmediately())) {
            break;
        }

        //  notify specific observers for the signal/origin combo
        TP.sig.SignalMap.notifyObservers(orgid, signame, sig,
                    TP.hc('checkPropagation', true));

        if (sig.shouldStop() || sig.shouldStopImmediately()) {
            break;
        }

        //  don't repeat if the signal name was already TP.ANY
        if (signame !== TP.ANY) {
            //  notify specific observers for the origin and any signal but
            //  only do this the first time through the loop (since the
            //  observation results won't change as we iterate)
            if (i === 0) {
                TP.sig.SignalMap.notifyObservers(orgid, null, sig,
                    TP.hc('checkPropagation', true));

                if (sig.shouldStop() || sig.shouldStopImmediately()) {
                    break;
                }
            }
        }

        //  notify observers of the signal from any origin
        if (orgid !== TP.ANY) {
            TP.sig.SignalMap.notifyObservers(null, signame, sig,
                    TP.hc('checkPropagation', true));

            if (sig.shouldStop() || sig.shouldStopImmediately()) {
                break;
            }
        }

        //  For controller notification we want to ensure the signal instance
        //  has the actual signal name for this iteration. We set it back after
        //  attempting invocation.
        try {
            fixedName = sig.getSignalName();
            sig.setSignalName(signame);

            TP.sig.SignalMap.notifyControllers(sig);
        } catch (e) {
            void 0;     //  TODO: verify we want to do this here.
        } finally {
            sig.setSignalName(fixedName);
        }

        isSpoofed = sig.isSpoofed();

        //  is the signal a root (and not a spoofed) signal? we can stop
        //  looping then
        if (!isSpoofed && type.isSignalingRoot()) {
            break;
        }

        //  Is the signal spoofed? If so, this iteration (usually the first)
        //  of the loop should just continue with the current type.
        //  Otherwise, use the supertype.
        if (isSpoofed) {
            //  Leave 'type' at the current value. 'signame' will be set
            //  to the next value at the top of the loop.
            void 0;
        } else {
            type = type.getSupertype();
        }
    }

    return sig;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('BIND_FIRING',
function(originSet, aSignal, aPayload, aType) {


    /**
     * @method BIND_FIRING
     * @summary
     * @param {Object|Object[]} originSet The originator(s) of the signal. Unused
     *     for this firing policy.
     * @param {String|TP.sig.Signal} aSignal The signal to fire.
     * @param {Object} aPayload Optional argument object.
     * @param {String|TP.sig.Signal} aType A default type to use when the signal
     *     type itself isn't found and a new signal subtype must be created.
     *     Defaults to TP.sig.Signal.
     * @returns {TP.sig.Signal|undefined} The signal.
     */

    var sig,

        payload,
        scope,

        triggerSignal,
        evt,

        origin,
        target,

        scopeVals,
        scopeURI,

        resource,
        handler,

        orgid;

    if (TP.notValid(aSignal)) {
        return TP.sig.SignalMap.raise('TP.sig.InvalidSignal');
    }

    //  get a valid signal instance configured
    sig = TP.sig.SignalMap.$getSignalInstance(aSignal, aPayload, aType);
    if (!TP.isKindOf(sig, TP.sig.Signal)) {
        return;
    }

    if (TP.notValid(payload = aPayload)) {
        //  TODO: Raise an exception
        return sig;
    }

    //  If no scope was defined, then we see if we can compute one via an event
    //  target or the origin.
    if (TP.notValid(scope = payload.at('scope'))) {

        if (TP.isElement(origin = originSet)) {
            //  Wrap the origin and compute its binding scope values.
            scopeVals = TP.wrap(origin).getBindingScopeValues();
        } else {
            triggerSignal = payload.at('trigger');
            if (TP.isValid(triggerSignal) &&
                TP.isEvent(evt = triggerSignal.getEvent())) {
                //  Make sure that we have both an Event and an Event target.
                if (TP.isElement(target = TP.eventGetTarget(evt))) {
                    //  Wrap the target and compute its binding scope values.
                    scopeVals = TP.wrap(target).getBindingScopeValues();
                }
            }
        }

        //  Join all of the scope value fragments together and set the scope in
        //  the payload.
        if (TP.isEmpty(scopeVals)) {
            TP.ifWarn() ? TP.warn('Bind firing without scope values: ') : 0;
            return sig;
        }

        scope = TP.uriJoinFragments.apply(TP, scopeVals);
        payload.atPut('scope', scope);
    }

    //  If we didn't end up with a scope or if a URI can't be computed from it,
    //  then exit here.
    if (TP.notValid(scope) || !TP.isURI(scopeURI = TP.uc(scope))) {
        //  TODO: Raise an exception
        return sig;
    }

    //  Make sure that we can get a resource result for the scope - note here
    //  how we query the primary URI for its resource. The handler will be on
    //  that object's result. The reason we do this is that the scope above is
    //  fully qualified by joining all of the scope values, so we want the
    //  result of the 'top-level' resource to modify

    //  NB: We assume 'async' of false here.
    if (TP.notValid(resource =
                    scopeURI.getPrimaryURI().getResource().get('result'))) {
        //  TODO: Raise an exception
        return sig;
    }

    //  If the 'origin set' wasn't an Array, then we don't have real origins.
    //  Compute one from the local ID of the 'origin set' and set that to be the
    //  origin of the signal.
    if (!TP.isArray(originSet)) {
        orgid = TP.lid(originSet);
        sig.setOrigin(orgid);
    }

    //  Look for handlers, but only explicit ones. This routing is called by
    //  policies which handle all looping of inheritance chains etc for us.
    handler = resource.getBestHandler(
        sig,
        {
            startSignal: null,
            dontTraverseHierarchy: true,
            dontTraverseSpoofs: true
        });

    if (TP.isCallable(handler)) {
        try {
            handler.call(resource, sig);
        } catch (e) {
            //  TODO: handler exception
            //  TODO: Add a callback check at the handler/owner level?
            TP.error('HandlerException: ' + e.message + ' in: ' +
                TP.id(TP.owner(handler)) + ':' + TP.name(handler));
        }
    }

    return sig;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('REGISTER_CAPTURING',
function(anOrigin, aSignal, aHandler) {

    /**
     * @method REGISTER_CAPTURING
     * @summary Handles registration of a capturing handler for the
     *     registration data provided.
     * @description One feature yet to be added is the concept of a "cleanup
     *     policy". We want registrations to occur in which the observer
     *     specifies when to clean them out or "auto-ignore" them. A couple
     *     obvious policies would be to remove the observer after a certain
     *     number of invocations (like 1), after a particular time, or if some
     *     conditional test returns true/false which is the general case of how
     *     all other cleanup policies would be implemented -- as tests which if
     *     the return true will cause removal of the registration.
     * @param {String} anOrigin The origin to register interest in.
     * @param {TP.sig.Signal|String} aSignal The signal or signal name to
     *     register interest in.
     * @param {Object|String} aHandler The handler or handler ID being
     *     registered.
     * @returns {TP.sig.SignalMap|undefined} The receiver.
     */

    var orgid,
        signame;

    //  can't register without a handler
    if (TP.notValid(aHandler)) {
        return;
    }

    signame = TP.sig.SignalMap.$computeSignalName(aSignal);

    if (TP.isValid(anOrigin)) {
        //  activate change notification as needed
        if (/Change/.test(signame)) {
            if (TP.isMutable(anOrigin)) {
                //  not a String ID
                if (TP.canInvoke(anOrigin, 'shouldSignalChange')) {
                    anOrigin.shouldSignalChange(true);
                }
            } else {
                //  a string ID -- try to get handle to obj
                /*
                (ss)    commented out to avoid excessive overhead
                inst = TP.bySystemId(anOrigin.getID());
                if (TP.isMutable(inst)) {
                    inst.shouldSignalChange(true);
                };
                */
                void 0;
            }
        }

        orgid = TP.id(anOrigin);
    } else {
        orgid = TP.ANY;
    }

    //  register the interest, passing true so the capture attribute is set
    return TP.sig.SignalMap.$registerInterest(
                            orgid, signame, aHandler, true);
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('REGISTER_NONCAPTURING',
function(anOrigin, aSignal, aHandler) {

    /**
     * @method REGISTER_NONCAPTURING
     * @summary Handles registration of a non-capturing handler for the
     *     registration data provided.
     * @param {String} anOrigin The origin to register interest in.
     * @param {TP.sig.Signal|String} aSignal The signal or signal name to
     *     register interest in.
     * @param {Object|String} aHandler The handler or handler ID being
     *     registered.
     * @returns {TP.sig.SignalMap|undefined} The receiver.
     */

    var orgid,
        signame;

    //  can't register without a handler
    if (TP.notValid(aHandler)) {
        return;
    }

    signame = TP.sig.SignalMap.$computeSignalName(aSignal);

    if (TP.isValid(anOrigin)) {
        //  activate change notification as needed
        if (/Change/.test(signame)) {
            if (TP.isMutable(anOrigin)) {
                //  not a String ID
                if (TP.canInvoke(anOrigin, 'shouldSignalChange')) {
                    anOrigin.shouldSignalChange(true);
                }
            } else {
                //  a string ID -- try to get handle to obj
                /*
                (ss)    commented out to avoid excessive overhead
                inst = TP.bySystemId(anOrigin.getID());
                if (TP.isMutable(inst)) {
                    inst.shouldSignalChange(true);
                };
                */
                void 0;
            }
        }

        orgid = TP.id(anOrigin);
    } else {
        orgid = TP.ANY;
    }

    //  register the interest, passing false so capture is off
    return TP.sig.SignalMap.$registerInterest(
                            orgid, signame, aHandler, false);
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('REMOVE_CAPTURING',
function(anOrigin, aSignal, aHandler) {

    /**
     * @method REMOVE_CAPTURING
     * @summary Removes registration of a capturing handler for the
     *     registration data provided. If no handler is provided ALL capturing
     *     notifications for the signal/origin pair are removed.
     * @param {String} anOrigin The origin to register interest in.
     * @param {TP.sig.Signal|String} aSignal The signal or signal name to
     *     register interest in.
     * @param {Object|String} aHandler The handler or handler ID being
     *     registered.
     * @returns {TP.sig.SignalMap|undefined} The receiver.
     */

    var orgid,
        signame;

    orgid = TP.sig.SignalMap.$computeOriginID(anOrigin);
    signame = TP.sig.SignalMap.$computeSignalName(aSignal);

    return TP.sig.SignalMap.$removeInterest(
                            orgid, signame, aHandler, true);
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('REMOVE_NONCAPTURING',
function(anOrigin, aSignal, aHandler) {

    /**
     * @method REMOVE_NONCAPTURING
     * @summary Removes registration of a non-capturing handler for the
     *     registration data provided. If no handler is provided ALL capturing
     *     notifications for the signal/origin pair are removed.
     * @param {String} anOrigin The origin to register interest in.
     * @param {TP.sig.Signal|String} aSignal The signal or signal name to
     *     register interest in.
     * @param {Object|String} aHandler The handler or handler ID being
     *     registered.
     * @returns {TP.sig.SignalMap|undefined} The receiver.
     */

    var orgid,
        signame;

    orgid = TP.sig.SignalMap.$computeOriginID(anOrigin);
    signame = TP.sig.SignalMap.$computeSignalName(aSignal);

    return TP.sig.SignalMap.$removeInterest(
                            orgid, signame, aHandler, false);
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('RESUME',
function(anOrigin, aSignal) {

    /**
     * @method RESUME
     * @summary Resumes signaling status for a particular origin/signal pair.
     * @param {String} anOrigin The origin to resume interest in.
     * @param {TP.sig.Signal|String} aSignal The signal or signal name to resume
     *     interest in.
     * @returns {TP.sig.SignalMap} The receiver.
     */

    var entry,
        orgid,
        signame;

    orgid = TP.sig.SignalMap.$computeOriginID(anOrigin);
    signame = TP.sig.SignalMap.$computeSignalName(aSignal);

    entry = TP.sig.SignalMap.interests[orgid + '.' + signame];

    if (TP.isValid(entry)) {
        delete entry.suspend;
    } else if (!TP.regex.HAS_PERIOD.test(signame)) {
        //  If the signame didn't have a period, then it might be a spoofed
        //  signal name, but the registration would've been made using a
        //  'full signal' name (i.e. prefixed by 'TP.sig.').
        entry = TP.sig.SignalMap.interests[orgid + '.' + 'TP.sig.' + signame];

        if (TP.isValid(entry)) {
            delete entry.suspend;
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.defineMethod('SUSPEND',
function(anOrigin, aSignal) {

    /**
     * @method SUSPEND
     * @summary Suspends signaling status for a particular origin/signal pair.
     * @param {String} anOrigin The origin to suspend interest in.
     * @param {TP.sig.Signal|String} aSignal The signal or signal name to
     *     suspend interest in.
     * @returns {TP.sig.SignalMap} The receiver.
     */

    var entry,
        orgid,
        signame;

    orgid = TP.sig.SignalMap.$computeOriginID(anOrigin);
    signame = TP.sig.SignalMap.$computeSignalName(aSignal);

    entry = TP.sig.SignalMap.interests[orgid + '.' + signame];

    if (TP.isValid(entry)) {
        entry.suspend = true;
    } else if (!TP.regex.HAS_PERIOD.test(signame)) {
        //  If the signame didn't have a period, then it might be a spoofed
        //  signal name, but the registration would've been made using a
        //  'full signal' name (i.e. prefixed by 'TP.sig.').
        entry = TP.sig.SignalMap.interests[orgid + '.' + 'TP.sig.' + signame];

        if (TP.isValid(entry)) {
            entry.suspend = true;
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.SignalMap.$ignore = function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method $ignore
     * @summary The primary observation removal method. This method is
     *     typically invoked via the ignore instance method on most objects, you
     *     don't normally need to invoke it yourself.
     * @param {Object|Object[]} anOrigin An origin (or origins) to ignore.
     * @param {TP.sig.Signal|Array<TP.sig.Signal|String>} aSignal The signal(s)
     *     to ignore from the origin(s).
     * @param {Function} aHandler The specific handler to turn off, if any.
     * @param {Function} aPolicy The policy if any. Should be TP.CAPTURING to
     *     remove capturing handlers. Default is non-capturing.
     * @returns {TP.sig.SignalMap} The receiver.
     */

    var origins,
        len,
        i,

        origin,
        adjustMap,

        typenames,

        typename,
        type,
        owner,

        signal,
        policy;

    if (!TP.isArray(origins = anOrigin)) {
        origins = TP.ac(anOrigin);
        origins.isOriginSet(true);
    }

    //  NB: Note the direct comparison to false here - this is by design if the
    //  creator of an Array which is being observed has explicitly set this to
    //  false.
    if (origins.isOriginSet() === false) {
        return this;
    }

    len = origins.getSize();
    for (i = 0; i < len; i++) {
        //  all observations are done conditionally based on whether the
        //  origin or "owner" of a particular signal wants to adjust the map
        //  after being given the chance to handle them directly.
        origin = TP.isTypeName(origins.at(i)) ?
                    TP.sys.getTypeByName(origins.at(i)) :
                    origins.at(i);

        if (TP.canInvoke(origin, 'removeObserver')) {
            //  If we were supplied a String, make sure it's a fully
            //  expanded signal name.
            if (TP.isString(aSignal)) {
                typename = TP.expandSignalName(aSignal);
                if (!TP.isType(signal = TP.sys.getTypeByName(typename))) {
                    //  Must be a spoofed signal - just use original name.
                    signal = aSignal;
                }
            } else {
                signal = aSignal;
            }

            switch (origin.removeObserver.getArity()) {
                case 4:
                    adjustMap = origin.removeObserver(origin, signal, aHandler,
                        aPolicy);
                    break;
                case 3:
                    adjustMap = origin.removeObserver(signal, aHandler, aPolicy);
                    break;
                default:
                    adjustMap = origin.removeObserver(signal, aHandler);
                    break;
            }

            if (!adjustMap) {
                return this;
            }
        }
    }

    if (!TP.isArray(typenames = aSignal)) {
        typenames = TP.ac(aSignal);
        typenames.isOriginSet(true);
    }

    len = typenames.getSize();
    for (i = 0; i < len; i++) {
        //  NB: We go after the signal name and then unescape it here,
        //  rather than the actual type name. This is done because of
        //  spoofed signals.
        typename = TP.isString(typenames.at(i)) ?
                                typenames.at(i) :
                                typenames.at(i).getSignalName();

        //  Go ahead and make sure the signal name is fully expanded. If its
        //  a real signal name, but the user was using the short name, then
        //  the 'require' below will find its fully expanded form.
        //  Otherwise, if it's a 'spoofed' name, then require won't find it
        //  and 'type' will end up null (which is what we want).
        typename = TP.expandSignalName(typename);

        //  some events require interaction with an "owner", typically a
        //  TP.core.Device, responsible for events of that type which may
        //  also decide to manage observations directly
        type = TP.isTypeName(typename) ?
                TP.sys.getTypeByName(typename) :
                typename;

        //  special case here for keyboard events since their names are
        //  often synthetic and we have to map to the true native event
        if (!TP.isType(type)) {
            if (TP.regex.KEY_EVENT.test(typename)) {
                type = TP.sys.getTypeByName('TP.sig.DOMKeySignal');
            }
        }

        if (TP.isType(type) &&
            TP.canInvoke(type, 'getSignalOwner') &&
            TP.isValid(owner = type.getSignalOwner())) {
            if (owner !== origin && TP.canInvoke(owner, 'removeObserver')) {

                switch (owner.removeObserver.getArity()) {
                    case 4:
                        adjustMap = owner.removeObserver(anOrigin, typename,
                            aHandler, aPolicy);
                        break;
                    case 3:
                        adjustMap = owner.removeObserver(typename, aHandler,
                            aPolicy);
                        break;
                    default:
                        adjustMap = owner.removeObserver(typename, aHandler);
                        break;
                }

                if (!adjustMap) {
                    return this;
                }
            }
        }
    }

    origin = TP.ifInvalid(anOrigin, TP.ANY);

    if (TP.isEmpty(aSignal)) {
        //  It's empty, which means ANY
        signal = TP.ANY;
    } else if (TP.isArray(aSignal)) {
        //  It's an Array - check to make sure each one is a real type. If we
        //  can't resolve to a type name then it must be a spoofed signal.
        signal = aSignal.collect(
                        function(sig) {
                            var sigTypeName;

                            sigTypeName = TP.expandSignalName(sig.getSignalName());
                            if (TP.notEmpty(sigTypeName) &&
                                TP.isType(TP.sys.getTypeByName(sigTypeName))) {
                                return sigTypeName;
                            }

                            return sig;
                        });
    } else if (TP.notEmpty(typename = TP.expandSignalName(aSignal.getSignalName())) &&
                TP.isType(TP.sys.getTypeByName(typename))) {
        //  It's a real type.
        signal = typename;
    } else {
        //  Can't resolve to a type name - must be a spoofed signal
        signal = aSignal;
    }

    policy = TP.ifInvalid(aPolicy, TP.sig.SignalMap.REMOVE_NONCAPTURING);

    //  check on policy
    if (!TP.isCallable(policy)) {
        if (TP.isCallable(TP.sig.SignalMap[policy])) {
            policy = TP.sig.SignalMap[policy];
        } else if (TP.isString(policy) && policy === TP.CAPTURING) {
            policy = TP.sig.SignalMap.REMOVE_CAPTURING;
        } else {
            policy = TP.sig.SignalMap.REMOVE_NONCAPTURING;
        }
    }

    return TP.sig.SignalMap.$invokePolicy(origin, signal, aHandler, policy);
};

//  ------------------------------------------------------------------------

TP.sig.SignalMap.$invokePolicy = function(origins, signals, handler, policy) {

    /**
     * @method $invokePolicy
     * @summary General purpose signal invocation method. Each policy gets
     *     invoked from this entry point.
     * @param {Object|Object[]} origins An origin or origins.
     * @param {TP.sig.Signal|Array<TP.sig.Signal|String>} aSignal The signal(s)
     * @param {Function} handler The handler if any.
     * @param {Function} policy The policy if any.
     * @returns {TP.sig.SignalMap} The receiver.
     */

    var i,
        j;

    //  deal with possibility that origin IS an array
    /* eslint-disable no-extra-parens */
    if ((TP.isArray(origins) && !origins.isOriginSet()) ||
        !TP.isArray(origins)) {
    /* eslint-enable no-extra-parens */
        //  only one origin
        if (TP.isArray(signals)) {
            //  array of signals but only the array as an origin
            for (j = 0; j < signals.getSize(); j++) {
                policy(origins, signals.at(j), handler);
            }
        } else {
            //  one signal, one origin
            policy(origins, signals, handler);
        }
    } else if (TP.isArray(origins)) {
        if (TP.isArray(signals)) {
            //  array of origins, array of signals
            for (i = 0; i < origins.getSize(); i++) {
                for (j = 0; j < signals.getSize(); j++) {
                    policy(origins.at(i), signals.at(j), handler);
                }
            }
        } else {
            //  array of origins, one signal
            for (i = 0; i < origins.getSize(); i++) {
                policy(origins.at(i), signals, handler);
            }
        }
    }

    return this;
};

//  ------------------------------------------------------------------------

TP.sig.SignalMap.$observe = function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method $observe
     * @summary The primary observation installation method. This method is
     *     typically invoked via the observe instance method on most objects,
     *     you don't normally need to invoke it yourself.
     * @param {Object|Object[]} anOrigin An origin (or origins) to observe.
     * @param {TP.sig.Signal|Array<TP.sig.Signal|String>} aSignal The signal(s)
     *     to observe from the origin(s).
     * @param {Function} aHandler The specific handler to turn on observations
     *     for.
     * @param {Function} aPolicy The policy if any. Should be TP.CAPTURING to
     *     configure a capturing handler. Default is non-capturing.
     * @returns {TP.sig.SignalMap} The receiver.
     */

    var origins,
        len,
        i,

        origin,
        adjustMap,

        typenames,

        typename,
        type,
        owner,

        signal,
        policy;

    if (TP.notValid(aHandler)) {
        TP.ifError() ?
            TP.error('Invalid signal handler.',
                        TP.SIGNAL_LOG) : 0;

        return this;
    }

    if (!TP.isArray(origins = anOrigin)) {
        origins = TP.ac(anOrigin);
        origins.isOriginSet(true);
    }

    //  NB: Note the direct comparison to false here - this is by design if the
    //  creator of an Array which is being observed has explicitly set this to
    //  false.
    if (origins.isOriginSet() === false) {
        return this;
    }

    len = origins.getSize();
    for (i = 0; i < len; i++) {
        //  all observations are done conditionally based on whether the
        //  origin or "owner" of a particular signal wants to adjust the map
        //  after being given the chance to handle them directly.
        origin = TP.isTypeName(origins.at(i)) ?
                    TP.sys.getTypeByName(origins.at(i)) :
                    origins.at(i);

        if (TP.canInvoke(origin, 'addObserver')) {
            //  If we were supplied a String, make sure it's a fully
            //  expanded signal name.
            if (TP.isString(aSignal)) {
                typename = TP.expandSignalName(aSignal);
                if (!TP.isType(signal = TP.sys.getTypeByName(typename))) {
                    //  Must be a spoofed signal - just use original name.
                    signal = aSignal;
                }
            } else {
                signal = aSignal;
            }

            switch (origin.addObserver.getArity()) {
                case 4:
                    adjustMap = origin.addObserver(origin, signal, aHandler,
                        aPolicy);
                    break;
                case 3:
                    adjustMap = origin.addObserver(signal, aHandler, aPolicy);
                    break;
                default:
                    adjustMap = origin.addObserver(signal, aHandler);
                    break;
            }

            if (!adjustMap) {
                return this;
            }
        }
    }

    if (!TP.isArray(typenames = aSignal)) {
        typenames = TP.ac();
        if (TP.isValid(aSignal)) {
            typenames.push(aSignal);
        }
    }

    len = typenames.getSize();
    for (i = 0; i < len; i++) {
        //  NB: We go after the signal name and then unescape it here,
        //  rather than the actual type name. This is done because of
        //  spoofed signals.
        typename = TP.isString(typenames.at(i)) ?
                                typenames.at(i) :
                                typenames.at(i).getSignalName();

        //  Go ahead and make sure the signal name is fully expanded. If its
        //  a real signal name, but the user was using the short name, then
        //  the 'require' below will find its fully expanded form.
        //  Otherwise, if it's a 'spoofed' name, then require won't find it
        //  and 'type' will end up null (which is what we want).
        typename = TP.expandSignalName(typename);

        //  some events require interaction with an "owner", typically a
        //  TP.core.Device, responsible for events of that type which may
        //  also decide to manage observations directly
        type = TP.isTypeName(typename) ?
                TP.sys.getTypeByName(typename) :
                typename;

        //  special case here for keyboard events since their names are
        //  often synthetic and we have to map to the true native event
        if (!TP.isType(type)) {
            if (TP.regex.KEY_EVENT.test(typename)) {
                type = TP.sys.getTypeByName('TP.sig.DOMKeySignal');
            }
        }

        if (TP.isType(type) &&
            TP.canInvoke(type, 'getSignalOwner') &&
            TP.isValid(owner = type.getSignalOwner())) {
            if (owner !== origin && TP.canInvoke(owner, 'addObserver')) {

                switch (owner.addObserver.getArity()) {
                    case 4:
                        adjustMap = owner.addObserver(anOrigin, typename,
                            aHandler, aPolicy);
                        break;
                    case 3:
                        adjustMap = owner.addObserver(typename, aHandler,
                            aPolicy);
                        break;
                    default:
                        adjustMap = owner.addObserver(typename, aHandler);
                        break;
                }

                if (!adjustMap) {
                    return this;
                }
            }
        }
    }

    origin = TP.ifInvalid(anOrigin, TP.ANY);

    if (TP.isEmpty(aSignal)) {
        //  It's empty, which means ANY
        signal = TP.ANY;
    } else if (TP.isArray(aSignal)) {
        //  It's an Array - check to make sure each one is a real type. If we
        //  can't resolve to a type name then it must be a spoofed signal.
        signal = aSignal.collect(
                        function(sig) {
                            var sigTypeName;

                            sigTypeName = TP.expandSignalName(sig.getSignalName());
                            if (TP.notEmpty(sigTypeName) &&
                                TP.isType(TP.sys.getTypeByName(sigTypeName))) {
                                return sigTypeName;
                            }

                            return sig;
                        });
    } else if (TP.notEmpty(typename = TP.expandSignalName(aSignal.getSignalName())) &&
                TP.isType(TP.sys.getTypeByName(typename))) {
        //  It's a real type.
        signal = typename;
    } else {
        //  Can't resolve to a type name - must be a spoofed signal
        signal = aSignal;
    }

    policy = TP.ifInvalid(aPolicy, TP.sig.SignalMap.REGISTER_NONCAPTURING);

    //  check on policy
    if (!TP.isCallable(policy)) {
        if (TP.isCallable(TP.sig.SignalMap[policy])) {
            policy = TP.sig.SignalMap[policy];
        } else if (TP.isString(policy) && policy === TP.CAPTURING) {
            policy = TP.sig.SignalMap.REGISTER_CAPTURING;
        } else {
            policy = TP.sig.SignalMap.REGISTER_NONCAPTURING;
        }
    }

    return TP.sig.SignalMap.$invokePolicy(origin, signal, aHandler, policy);
};

//  ------------------------------------------------------------------------

TP.sig.SignalMap.$resume = function(anOrigin, aSignal) {

    /**
     * @method $resume
     * @summary The primary observation resume method. When an observation has
     *     been suspended this method will resume active notifications for it.
     * @param {Object|Object[]} anOrigin An origin (or origins) to resume
     *     notifications for.
     * @param {TP.sig.Signal|Array<TP.sig.Signal|String>} aSignal The signal(s)
     *     to resume signaling from the origin(s).
     * @returns {TP.sig.SignalMap} The receiver.
     */

    var origins,
        len,
        i,

        origin,
        adjustMap,

        typenames,

        typename,
        type,
        owner,

        signal,
        policy;

    if (!TP.isArray(origins = anOrigin)) {
        origins = TP.ac(anOrigin);
        origins.isOriginSet(true);
    }

    //  NB: Note the direct comparison to false here - this is by design if the
    //  creator of an Array which is being observed has explicitly set this to
    //  false.
    if (origins.isOriginSet() === false) {
        return this;
    }

    len = origins.getSize();
    for (i = 0; i < len; i++) {
        //  all observations are done conditionally based on whether the
        //  origin or "owner" of a particular signal wants to adjust the map
        //  after being given the chance to handle them directly.
        origin = TP.isTypeName(origins.at(i)) ?
                    TP.sys.getTypeByName(origins.at(i)) :
                    origins.at(i);

        if (TP.canInvoke(origin, 'resumeObserver')) {
            //  If we were supplied a String, make sure it's a fully
            //  expanded signal name.
            if (TP.isString(aSignal)) {
                typename = TP.expandSignalName(aSignal);
                if (!TP.isType(signal = TP.sys.getTypeByName(typename))) {
                    //  Must be a spoofed signal - just use original name.
                    signal = aSignal;
                }
            } else {
                signal = aSignal;
            }

            adjustMap = origin.resumeObserver(origin, signal);
            if (!adjustMap) {
                return this;
            }
        }
    }

    if (!TP.isArray(typenames = aSignal)) {
        typenames = TP.ac();
        if (TP.isValid(aSignal)) {
            typenames.push(aSignal);
        }
    }

    len = typenames.getSize();
    for (i = 0; i < len; i++) {
        //  NB: We go after the signal name and then unescape it here,
        //  rather than the actual type name. This is done because of
        //  spoofed signals.
        typename = TP.isString(typenames.at(i)) ?
                                typenames.at(i) :
                                typenames.at(i).getSignalName();

        //  Go ahead and make sure the signal name is fully expanded. If its
        //  a real signal name, but the user was using the short name, then
        //  the 'require' below will find its fully expanded form.
        //  Otherwise, if it's a 'spoofed' name, then require won't find it
        //  and 'type' will end up null (which is what we want).
        typename = TP.expandSignalName(typename);

        //  some events require interaction with an "owner", typically a
        //  TP.core.Device, responsible for events of that type which may
        //  also decide to manage observations directly
        type = TP.isTypeName(typename) ?
                TP.sys.getTypeByName(typename) :
                typename;

        //  special case here for keyboard events since their names are
        //  often synthetic and we have to map to the true native event
        if (!TP.isType(type)) {
            if (TP.regex.KEY_EVENT.test(typename)) {
                type = TP.sys.getTypeByName('TP.sig.DOMKeySignal');
            }
        }

        if (TP.isType(type) &&
            TP.canInvoke(type, 'getSignalOwner') &&
            TP.isValid(owner = type.getSignalOwner())) {
            if (owner !== origin && TP.canInvoke(owner, 'resumeObserver')) {
                adjustMap = owner.resumeObserver(anOrigin, typename);
                if (!adjustMap) {
                    return this;
                }
            }
        }
    }

    origin = TP.ifInvalid(anOrigin, TP.ANY);

    if (TP.isEmpty(aSignal)) {
        //  It's empty, which means ANY
        signal = TP.ANY;
    } else if (TP.isArray(aSignal)) {
        //  It's an Array - check to make sure each one is a real type. If we
        //  can't resolve to a type name then it must be a spoofed signal.
        signal = aSignal.collect(
                        function(sig) {
                            var sigTypeName;

                            sigTypeName = TP.expandSignalName(sig.getSignalName());
                            if (TP.notEmpty(sigTypeName) &&
                                TP.isType(TP.sys.getTypeByName(sigTypeName))) {
                                return sigTypeName;
                            }

                            return sig;
                        });
    } else if (TP.notEmpty(typename = TP.expandSignalName(aSignal.getSignalName())) &&
                TP.isType(TP.sys.getTypeByName(typename))) {
        //  It's a real type.
        signal = typename;
    } else {
        //  Can't resolve to a type name - must be a spoofed signal
        signal = aSignal;
    }

    policy = TP.sig.SignalMap.RESUME;

    return TP.sig.SignalMap.$invokePolicy(origin, signal, null, policy);
};

//  ------------------------------------------------------------------------

TP.sig.SignalMap.$suspend = function(anOrigin, aSignal) {

    /**
     * @method $suspend
     * @summary The primary observation suspention method. When an observation
     *     has been suspended the registration is maintained but notifications
     *     are not made until a TP.resume().
     * @param {Object|Object[]} anOrigin An origin (or origins) to suspend
     *     notifications for.
     * @param {TP.sig.Signal|Array<TP.sig.Signal|String>} aSignal The signal(s)
     *     to suspend signaling from the origin(s).
     * @returns {TP.sig.SignalMap} The receiver.
     */

    var origins,
        len,
        i,

        origin,
        adjustMap,

        typenames,

        typename,
        type,
        owner,

        signal,
        policy;

    if (!TP.isArray(origins = anOrigin)) {
        origins = TP.ac(anOrigin);
        origins.isOriginSet(true);
    }

    //  NB: Note the direct comparison to false here - this is by design if the
    //  creator of an Array which is being observed has explicitly set this to
    //  false.
    if (origins.isOriginSet() === false) {
        return this;
    }

    len = origins.getSize();
    for (i = 0; i < len; i++) {
        //  all observations are done conditionally based on whether the
        //  origin or "owner" of a particular signal wants to adjust the map
        //  after being given the chance to handle them directly.
        origin = TP.isTypeName(origins.at(i)) ?
                    TP.sys.getTypeByName(origins.at(i)) :
                    origins.at(i);

        if (TP.canInvoke(origin, 'suspendObserver')) {
            //  If we were supplied a String, make sure it's a fully
            //  expanded signal name.
            if (TP.isString(aSignal)) {
                typename = TP.expandSignalName(aSignal);
                if (!TP.isType(signal = TP.sys.getTypeByName(typename))) {
                    //  Must be a spoofed signal - just use original name.
                    signal = aSignal;
                }
            } else {
                signal = aSignal;
            }

            adjustMap = origin.suspendObserver(origin, signal);
            if (!adjustMap) {
                return this;
            }
        }
    }

    if (!TP.isArray(typenames = aSignal)) {
        typenames = TP.ac(aSignal);
        typenames.isOriginSet(true);
    }

    len = typenames.getSize();
    for (i = 0; i < len; i++) {
        //  NB: We go after the signal name and then unescape it here,
        //  rather than the actual type name. This is done because of
        //  spoofed signals.
        typename = TP.isString(typenames.at(i)) ?
                                typenames.at(i) :
                                typenames.at(i).getSignalName();

        //  Go ahead and make sure the signal name is fully expanded. If its
        //  a real signal name, but the user was using the short name, then
        //  the 'require' below will find its fully expanded form.
        //  Otherwise, if it's a 'spoofed' name, then require won't find it
        //  and 'type' will end up null (which is what we want).
        typename = TP.expandSignalName(typename);

        //  some events require interaction with an "owner", typically a
        //  TP.core.Device, responsible for events of that type which may
        //  also decide to manage observations directly
        type = TP.isTypeName(typename) ?
                TP.sys.getTypeByName(typename) :
                typename;

        //  special case here for keyboard events since their names are
        //  often synthetic and we have to map to the true native event
        if (!TP.isType(type)) {
            if (TP.regex.KEY_EVENT.test(typename)) {
                type = TP.sys.getTypeByName('TP.sig.DOMKeySignal');
            }
        }

        if (TP.isType(type) &&
            TP.canInvoke(type, 'getSignalOwner') &&
            TP.isValid(owner = type.getSignalOwner())) {
            if (owner !== origin &&
                TP.canInvoke(owner, 'suspendObserver')) {
                adjustMap = owner.suspendObserver(anOrigin, typename);
                if (!adjustMap) {
                    return this;
                }
            }
        }
    }

    origin = TP.ifInvalid(anOrigin, TP.ANY);

    if (TP.isEmpty(aSignal)) {
        //  It's empty, which means ANY
        signal = TP.ANY;
    } else if (TP.isArray(aSignal)) {
        //  It's an Array - check to make sure each one is a real type. If we
        //  can't resolve to a type name then it must be a spoofed signal.
        signal = aSignal.collect(
                        function(sig) {
                            var sigTypeName;

                            sigTypeName = TP.expandSignalName(sig.getSignalName());
                            if (TP.notEmpty(sigTypeName) &&
                                TP.isType(TP.sys.getTypeByName(sigTypeName))) {
                                return sigTypeName;
                            }

                            return sig;
                        });
    } else if (TP.notEmpty(typename = TP.expandSignalName(aSignal.getSignalName())) &&
                TP.isType(TP.sys.getTypeByName(typename))) {
        //  It's a real type.
        signal = typename;
    } else {
        //  Can't resolve to a type name - must be a spoofed signal
        signal = aSignal;
    }

    policy = TP.sig.SignalMap.SUSPEND;

    return TP.sig.SignalMap.$invokePolicy(origin, signal, null, policy);
};

//  ------------------------------------------------------------------------

//  configure methods for reflection
TP.sig.SignalMap.$ignore[TP.NAME] = '$ignore';
TP.sig.SignalMap.$ignore[TP.OWNER] = TP.sig.SignalMap;
TP.sig.SignalMap.$ignore[TP.TRACK] = 'Type';
TP.sig.SignalMap.$ignore[TP.DISPLAY] = 'TP.sig.SignalMap.Type.$ignore';

TP.sig.SignalMap.$invokePolicy[TP.NAME] = '$invokePolicy';
TP.sig.SignalMap.$invokePolicy[TP.OWNER] = TP.sig.SignalMap;
TP.sig.SignalMap.$invokePolicy[TP.TRACK] = 'Type';
TP.sig.SignalMap.$ignore[TP.DISPLAY] = 'TP.sig.SignalMap.Type.$invokePolicy';

TP.sig.SignalMap.$observe[TP.NAME] = '$observe';
TP.sig.SignalMap.$observe[TP.OWNER] = TP.sig.SignalMap;
TP.sig.SignalMap.$observe[TP.TRACK] = 'Type';
TP.sig.SignalMap.$ignore[TP.DISPLAY] = 'TP.sig.SignalMap.Type.$observe';

TP.sig.SignalMap.$resume[TP.NAME] = '$resume';
TP.sig.SignalMap.$resume[TP.OWNER] = TP.sig.SignalMap;
TP.sig.SignalMap.$resume[TP.TRACK] = 'Type';
TP.sig.SignalMap.$ignore[TP.DISPLAY] = 'TP.sig.SignalMap.Type.$resume';

TP.sig.SignalMap.$suspend[TP.NAME] = '$suspend';
TP.sig.SignalMap.$suspend[TP.OWNER] = TP.sig.SignalMap;
TP.sig.SignalMap.$suspend[TP.TRACK] = 'Type';
TP.sig.SignalMap.$ignore[TP.DISPLAY] = 'TP.sig.SignalMap.Type.$suspend';

//  ------------------------------------------------------------------------
//  GLOBAL SIGNALING PRIMITIVES
//  ------------------------------------------------------------------------

/*
Now that most of the infrastructure is in place we can start installing the
working versions of the signaling primitives.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('signal',
function(anOrigin, aSignal, aPayload, aPolicy, aType, isCancelable, isBubbling) {

    /**
     * @method signal
     * @summary Signals activity to registered observers. Any additional
     *     arguments are passed to the registered handlers along with the origin
     *     and event.
     * @param {Object} anOrigin The originator of the signal.
     * @param {TP.sig.Signal|Array<TP.sig.Signal|String>} aSignal The signal(s)
     *     to fire.
     * @param {Object} aPayload Optional argument object.
     * @param {Function} aPolicy A "firing" policy that will define how the
     *     signal is fired.
     * @param {String|TP.sig.Signal} aType A default type to use when the signal
     *     type itself isn't found and a new signal subtype must be created.
     *     Defaults to TP.sig.Signal.
     * @param {Boolean} isCancelable Optional flag for dynamic signals defining
     *     if they can be cancelled.
     * @param {Boolean} isBubbling Optional flag for dynamic signals defining
     *     whether they bubble (when using TP.DOM_FIRING).
     * @returns {TP.sig.Signal|undefined} The fired signal.
     */

    var origin,
        type,
        owner,
        shouldSignalMap,

        signame,

        pol,
        orgstr,
        sigstr,
        sigtype,
        sig,
        loggable,
        str,
        end,
        delta,
        flag;

    //  sometimes we can get lucky if a recursion includes signaling
    TP.sys.trapRecursion(true, false);

    //  see if ignore is on at the 'TP' level, meaning the TP.signal() call
    //  itself has been suspended
    //  TODO: remove this feature
    if (TP.signal.$suspended) {
        return;
    }

    //  all observations are done conditionally based on whether the origin
    //  or "owner" of a particular signal wants to signal the map after
    //  being given the chance to handle them directly.
    //  TODO: probably not getTypeByName(), should be getTypeByName?
    origin = TP.isTypeName(anOrigin) ? TP.sys.getTypeByName(anOrigin) : anOrigin;
    if (TP.canInvoke(origin, 'signalObservers')) {
        shouldSignalMap = origin.signalObservers(
                                            anOrigin, aSignal,
                                            aPayload, aPolicy, aType,
                                            isCancelable, isBubbling);
        if (!shouldSignalMap) {
            return;
        }
    }

    //  NB: We go after the signal name and then unescape it here, rather
    //  than the actual type name. This is done because of spoofed signals.
    //  TODO: simply aSignal.getSignalName without type check
    signame = TP.isString(aSignal) ? aSignal : aSignal.getSignalName();

    //  some events require interaction with an "owner", typically a
    //  TP.core.Device, responsible for events of that type which may also
    //  decide to manage observations directly

    //  If the signal name looks like it could be a type name, try to get the
    //  type behind it. First check what was handed to us and if that doesn't
    //  resolve to a type, expand the signal name and check again.
    if (TP.isTypeName(signame)) {
        if (!TP.isType(type = TP.sys.getTypeByName(signame))) {
            type = TP.sys.getTypeByName(TP.expandSignalName(signame));
        }
    }

    //  If we were using a spoofed signal name we may not have a real type, but
    //  we need one to determine if the signal is of a type that has an owner,
    //  or default firing policy etc. Note that we give preference to any
    //  'default' signal type that was passed in and, if that doesn't exist,
    //  then ask the signal instance itself.
    if (TP.notValid(type)) {
        if (TP.isValid(aType)) {
            type = aType;
        } else {
            type = TP.sig.SignalMap.$getSignalType(
                        aSignal,
                        TP.sig.SignalMap.$getDefaultTypeForPolicy(aPolicy));
        }
    }

    //  special case here for keyboard events since their names are often
    //  synthetic and we have to map to the true native event
    if (TP.notValid(type)) {
        //  TODO:   log when we get here. this really shouldn't be happening
        //  that often, we should be getting a real signal from devices.
        if (TP.regex.KEY_EVENT.test(signame)) {
            type = TP.sys.getTypeByName('TP.sig.DOMKeySignal');
        /*
         * TODO: Test this - it should be correct.
        } else {
            type = TP.isType(aType) ?
                            aType :
                            TP.sys.getTypeByName(aType);
        */
        }
    }

    //  all observations are done conditionally based on whether the origin
    //  or "owner" of a particular signal wants to signal the map after
    //  being given the chance to handle them directly.
    if (TP.canInvoke(type, 'getSignalOwner') &&
        TP.isValid(owner = type.getSignalOwner())) {
        if (owner !== origin && TP.canInvoke(owner, 'signalObservers')) {
            shouldSignalMap = owner.signalObservers(
                                                anOrigin, aSignal,
                                                aPayload, aPolicy, type,
                                                isCancelable, isBubbling);
            if (!shouldSignalMap) {
                return;
            }
        }
    }

    //  see if ignore is on at the 'origin' level, meaning we're not
    //  currently allowing any signals from that origin to flow
    if (TP.isValid(anOrigin)) {
        //  TODO: method call here, not private property access.
        if (anOrigin.$suspended) {
            return TP.sys.fireNextSignal();
        }
    }

    //  TODO:   remove this feature
    //  if signaling is turned off then do not notify
    if (TP.sig.SignalMap.interests.suspend === true) {
        if (TP.ifTrace() && TP.$DEBUG && TP.$$VERBOSE) {
            TP.sys.logSignal('Root interest map is suspended.',
                            TP.DEBUG);
        }

        return;
    }

    //  don't log signals when processing events from the other logs to
    //  help reduce the potential for recursive logging. The activity and
    //  error logs, as well as the signal log itself, are definite no-nos.
    if (TP.sys.shouldLogSignals()) {

        //  TODO: sigstr is signame...why a second variable here?
        sigstr = aSignal.getSignalName();
        //  TODO: sigtype is type from above...why a second variable here?
        sigtype = TP.sig.SignalMap.$getSignalType(aSignal);
        loggable = TP.canInvoke(sigtype, 'shouldLog') ?
                                sigtype.shouldLog() :
                                false;

        if (loggable) {
            //  compute an origin string
            if (anOrigin) {
                if (TP.isArray(anOrigin) && anOrigin.isOriginSet()) {
                    if (TP.$$VERBOSE) {
                        orgstr = '[' + anOrigin.collect(
                                    function(item) {

                                        return TP.id(item, true);
                                    }).join(', ');
                        orgstr += ']';
                    } else {
                        orgstr = TP.id(anOrigin.last());
                    }
                } else {
                    orgstr = TP.id(anOrigin, true);
                }
            } else {
                orgstr = TP.NULL_OID;
            }

            //  compute a signal string
            if (aSignal) {
                if (TP.isArray(aSignal)) {
                    if (TP.$$VERBOSE) {
                        sigstr = '[' + aSignal.collect(
                                    function(item) {

                                        return item.getSignalName();
                                    }).join(', ');
                        sigstr += ']';
                    } else {
                        sigstr = aSignal.last().getSignalName();
                    }
                } else {
                    sigstr = aSignal.getSignalName();
                }

            } else {
                //  no signal? it's going to default to TP.sig.Signal type
                sigstr = 'TP.sig.Signal';
            }

            //  build the log entry text and log it
            if (TP.notEmpty(orgstr) && TP.notEmpty(sigstr)) {
                str = sigstr + ' @@@ ' + orgstr;

                if (TP.sys.shouldLogSignalStack()) {
                    try {
                        flag = TP.sys.shouldLogStack();
                        TP.sys.shouldLogStack(true);
                        TP.ifTrace() ? TP.sys.logSignal(
                                            TP.annotate(aSignal, str),
                                            TP.DEBUG) : 0;
                    } finally {
                        TP.sys.shouldLogStack(flag);
                    }
                } else {
                    TP.ifTrace() ? TP.sys.logSignal(
                                            TP.annotate(aSignal, str),
                                            TP.DEBUG) : 0;
                }
            }
        }
    }


    //  ensure we've got a proper policy so we find a processing function
    pol = aPolicy;
    if (!TP.isCallable(pol)) {
        if (TP.isCallable(TP.sig.SignalMap[pol])) {
            pol = TP.sig.SignalMap[pol];
        } else {
            if (!TP.isType(type) ||
                    TP.isEmpty(pol = type.getDefaultPolicy())) {
                //  TODO:   make the default signaling policy an attribute of
                //          the signaling system somewhere so that it can be
                //          configured.
                pol = TP.sig.SignalMap.OBSERVER_FIRING;
            } else if (!TP.isCallable(pol) &&
                        !TP.isCallable(pol = TP.sig.SignalMap[pol])) {
                //  TODO:   make the default signaling policy an attribute of
                //          the signaling system somewhere so that it can be
                //          configured.
                pol = TP.sig.SignalMap.OBSERVER_FIRING;
            }
        }
    }

    //  hand off to policy do do the actual firing of the signal(s)
    sig = pol(anOrigin, aSignal, aPayload, type,
                isCancelable, isBubbling);

    //  TODO:   dramatically expand on the ability to track stats across signal
    //  types and for individual signal types.
    if (TP.sys.shouldTrackSignalStats()) {
        end = Date.now();
        delta = end - sig.get('time');

        sig.$set('elapsed', delta);

        TP.sys.$statistics.$signals = TP.sys.$statistics.$signals ||
                                        TP.ac();
        TP.sys.$statistics.$signals.push(delta);

        if (TP.sys.$statistics.$signals.length >
                TP.sys.cfg('signal.max_stats')) {
            TP.sys.$statistics.$signals.shift();
        }
    }

    //  process any pending signals that may have been queued by the
    //  signal handlers we just invoked
    TP.sys.fireNextSignal();

    return sig;
});

//  ------------------------------------------------------------------------
//  DEBUGGING - PART III (TP.raise() revisited)
//  ------------------------------------------------------------------------

TP.definePrimitive('raise',
function(anOrigin, anException, aPayload) {

    /**
     * @method raise
     * @summary Raise an exception.
     * @description The exception type can be either a type or a String
     *     representing a type as appropriate. The calling context should be a
     *     reference to the function in which the exception was issued. This is
     *     usually provided as arguments (too bad about 'caller' isn't it). The
     *     operation is controlled by flags which also define whether this call
     *     should log output to the TIBET error log. The logging can consist of
     *     just the exception data or it can include the call stack names at the
     *     point of the exception. See TP.sys.shouldLogRaise() and
     *     TP.sys.shouldLogStack() for more information.
     * @param {Object} anOrigin The exception's origin.
     * @param {TP.sig.Exception} anException The exception to raise.
     * @param {Object} aPayload Optional argument object.
     */

    var i,
        str,
        orig,
        args,
        supers,
        aSignal,
        exceptions,
        flag,
        inst,
        eType,
        level;

    //  see if ignore is on at the 'global' level, meaning the TP.raise()
    //  call itself has been suspended
    if (TP.raise.$suspended) {
        return;
    }

    //  watch out for IE4!!! Crashes browser if this goes forward without
    //  being cleared.
    orig = anOrigin;

    if (TP.isWindow(orig)) {
        orig = null;
    }

    //  default to raising TP.sig.Exception -- the top level exception
    //  signal
    eType = TP.ifInvalid(anException, 'TP.sig.Exception');

    //  convert string exceptions into types
    if (TP.isTypeName(eType)) {
        aSignal = TP.sys.getTypeByName(eType);
        if (TP.notValid(aSignal)) {
            //  NOTE that we create a new subtype here, patching the
            //  exception into the system at runtime
            aSignal = TP.sig.Exception.defineSubtype(eType);
        }
    } else {
        aSignal = eType;
    }

    //  are we configured to output raise calls in the log? if so we'll do
    //  some logging but we turn off the flag to avoid recursion if there
    //  are any raise calls invoked by what we'll do here...
    flag = TP.sys.shouldLogRaise();
    try {
        if (flag) {
            TP.sys.shouldLogRaise(false);

            if (TP.isValid(aPayload)) {
                args = ' with payload/args: ';

                if (TP.isString(aPayload.message)) {
                    //  this one handles 'e' from catch blocks etc.
                    args += aPayload.toString();
                } else if (TP.canInvoke(aPayload, 'asString')) {
                    //  TIBET-enabled objects can asString themselves
                    args += aPayload.asString();
                } else if (TP.canInvoke(aPayload, 'toString')) {
                    args += aPayload.toString();
                } else if (TP.isString(aPayload.nodeName)) {
                    args += TP.nodeAsString(aPayload);
                } else {
                    try {
                        args += TP.str(aPayload);
                    } catch (e) {
                        TP.ifError() ?
                            TP.error(
                                TP.ec(e, 'Error generating payload string.'),
                                TP.SIGNAL_LOG) : 0;
                    }
                }
            } else {
                args = '';
            }

            if (TP.isValid(orig) && TP.isValid(eType.getSignalName)) {
                str = TP.id(orig) + ' raised: ' +
                        eType.getSignalName() +
                        args;
            } else if (TP.isCallable(eType.getSignalName)) {
                //  The null oid doesn't include type prefix like other
                //  $id data output will, so we add the generic 'Object'.
                str = 'Object' + TP.NULL_OID + ' raised: ' +
                        eType.getSignalName() +
                        args;
            }

            //  determine the proper log mechanism to use. we could use the
            //  types polymorphically I suppose...but this seemed adequate
            if (TP.canInvoke(aSignal, 'getLevel')) {
                level = aSignal.getLevel();
            } else {
                level = TP.ERROR;
            }

            switch (level) {
                case TP.TRACE:
                    TP.trace(str);
                    break;
                case TP.INFO:
                    TP.info(str);
                    break;
                case TP.WARN:
                    TP.isValid(aPayload) ?
                        TP.warn(TP.annotate(aPayload, str)) :
                        TP.warn(str);
                    break;
                case TP.ERROR:
                    TP.isValid(aPayload) ?
                        TP.error(TP.annotate(aPayload, str)) :
                        TP.error(str);
                    break;
                case TP.FATAL:
                    TP.isValid(aPayload) ?
                        TP.fatal(TP.annotate(aPayload, str)) :
                        TP.fatal(str);
                    break;
                case TP.SYSTEM:
                    TP.system(str);
                    break;
                default:
                    TP.isValid(aPayload) ?
                        TP.error(TP.annotate(aPayload, str)) :
                        TP.error(str);
                    break;
            }
        }
    } finally {
        //  set the log/raise flag back to original status
        TP.sys.shouldLogRaise(flag);
    }

    //  for debugging only this section will register objects that have
    //  raised so they can be accessed via the development console.
    if (TP.sys.shouldRegisterLoggers()) {
        if (TP.isValid(orig)) {
            TP.sys.registerObject(orig, null, true);
        }
    }

    //  now build up an array of exception signal types which will be
    //  signaled to observers until the exception is stopped through use of
    //  the stopPropagation() mechanism or it runs out of signal types
    if (TP.isSubtypeOf(aSignal, TP.sig.Exception)) {
        supers = aSignal.getSupertypes();
    } else {
        //  signal a generic exception
        aSignal = TP.sig.Exception;
        supers = TP.ac();
    }

    //  process supertype list to build exception tree
    exceptions = TP.ac();
    exceptions.push(aSignal);

    //  TODO: compute the offset once and slice after that.
    //  trim the list down to just exception subtypes...don't go up through
    //  TP.sig.Signal and on toward Object.
    for (i = 0; i < supers.getSize(); i++) {
        exceptions.push(supers.at(i));
        if (supers.at(i) === TP.sig.Exception) {
            break;
        }
    }

    //  dispatch with EXCEPTION firing policy. The TP.EXCEPTION_FIRING policy
    //  performs a list-oriented process which stops when the signal is
    //  "handled" at a particular exception.
    inst = TP.signal(orig, exceptions, aPayload, TP.EXCEPTION_FIRING);

    //  if the type's handled flag is still false then we throw a real error
    if (TP.sys.shouldThrowExceptions()) {

        //  one issue is that we want assertion throwing managed by its own
        //  flag so we do a secondary check here
        if (aSignal.getSignalName() !== 'AssertionFailed') {

            //  If the signal instance was handled (preventDefault() was
            //  invoked) then we don't want to throw.
            if (inst.shouldPrevent()) {
                return;
            }

            str = aSignal.asString();
            if (TP.isValid(aPayload)) {
                str += ' - ' + TP.str(aPayload);
            }
            throw new Error(str);
        }
    }

    return;
});

//  ========================================================================
//  Native Type Extensions
//  ========================================================================

String.Inst.defineMethod('fire',
function(anOrigin, aPayload, aPolicy) {

    /**
     * @method fire
     * @summary Creates and activates the signal instance via the policy
     *     specified. The signal name will be set to the string value.
     * @param {Object} anOrigin Optional origin for this call.
     * @param {Object[]} aPayload Optional signal arguments.
     * @param {Function} aPolicy A firing policy function.
     * @returns {TP.sig.Signal} The signal.
     */

    return TP.signal(anOrigin, '' + this, aPayload, aPolicy);
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETJobControl.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * TIBETJobControl.js provides support for a unified "job control" model for
 *     your applications. A number of types in TIBET operate in conjuction with
 *     this job control mechanism so you can manage multiple "threads" of logic
 *     including animations, HTTP calls, XMPP polling, and more.
 */

//  ------------------------------------------------------------------------
//  JOB/STATUS TRAITS
//  ------------------------------------------------------------------------

/**
 * @type {TP.core.JobStatus}
 * @summary An abstract type, designed specifically to be mixed in to other
 *     types which want to use common process/job status functionality.
 * @description The most prevalent consumers of TP.core.JobStatus are
 *     TP.core.Job, TP.core.JobGroup, and TP.core.WorkflowSignal (which provides
 *     the common supertype for TP.sig.Requests and TP.sig.Responses). By
 *     traiting in this type those types are able to work with a common set of
 *     job control operations that help define or query job status.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.JobStatus');

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation
TP.core.JobStatus.isAbstract(true);

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineAttribute('result');

TP.core.JobStatus.Inst.defineAttribute('faultCode');
TP.core.JobStatus.Inst.defineAttribute('faultText');
TP.core.JobStatus.Inst.defineAttribute('faultInfo');

TP.core.JobStatus.Inst.defineAttribute('statusCode');
TP.core.JobStatus.Inst.defineAttribute('statusText');

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('didCancel',
function() {

    /**
     * @method didCancel
     * @summary Returns true if the receiver's status code is TP.CANCELLED.
     * @returns {Boolean} Whether or not the job cancelled.
     */

    return this.get('statusCode') === TP.CANCELLED;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('didComplete',
function() {

    /**
     * @method didComplete
     * @summary Returns true if the receiver is done processing, regardless of
     *     whether that's due to success or failure. You can use the didFail
     *     and/or didSucceed methods to check the final status.
     * @returns {Boolean} Whether or not the job completed.
     */

    var stat;

    stat = this.get('statusCode');

    switch (stat) {
        case TP.CANCELLED:
        case TP.ERRORED:
        case TP.FAILED:
        case TP.TIMED_OUT:
        case TP.SUCCEEDED:
        case TP.COMPLETED:
            return true;

        default:
            return false;
    }
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('didError',
function() {

    /**
     * @method didError
     * @summary Returns true if the receiver's status code represents an error
     *     status. Error and failure differ in that Error implies the job did
     *     not run correctly while failure implied correct execution but a
     *     failed outcome.
     * @returns {Boolean} Whether or not the job errored out.
     */

    return this.get('statusCode') === TP.ERRORED;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('didFail',
function() {

    /**
     * @method didFail
     * @summary Returns true if the receiver's status code represents a failure
     *     status.
     * @returns {Boolean} Whether or not the job failed.
     */

    return this.get('statusCode') === TP.FAILED;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('didSkip',
function() {

    /**
     * @method didSkip
     * @summary Returns true if the receiver's fault code represents a skipped
     *     job status meaning it was never really run.
     * @returns {Boolean} Whether or not the job was skipped.
     */

    return this.get('faultCode') === TP.SKIPPED;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('didSucceed',
function() {

    /**
     * @method didSucceed
     * @summary Returns true if the receiver's status code reflects a
     *     successful completion without incurring any failures.
     * @returns {Boolean} Whether or not the job succeeded.
     */

    var stat;

    stat = this.get('statusCode');

    return stat === TP.SUCCEEDED || stat === TP.COMPLETED;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('didTimeOut',
function() {

    /**
     * @method didTimeOut
     * @summary Returns true if the receiver's fault code represents a
     *     timed-out status.
     * @returns {Boolean} Whether or not the job timed out.
     */

    return this.get('faultCode') === TP.TIMED_OUT;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('isActive',
function(aFlag) {

    /**
     * @method isActive
     * @summary Returns true if the receiver is still running in a TP.ACTIVE
     *     state.
     * @description Paused receivers and receivers that are waiting at TP.READY
     *     are not considered "active" by this test. Use isRunnable() to check
     *     for general runnability.
     * @param {Boolean} aFlag True to place the receiver into an active state.
     * @returns {Boolean} The current activity status.
     */

    if (TP.isBoolean(aFlag)) {
        this.set('statusCode', aFlag ? TP.ACTIVE : TP.READY);
    }

    /* eslint-disable no-extra-parens */
    return (this.get('statusCode') === TP.ACTIVE);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('isCancelling',
function() {

    /**
     * @method isCancelling
     * @summary Returns true if the receiver is in the process of being
     *     cancelled.
     * @returns {Boolean} The current activity status.
     */

    return this.get('statusCode') === TP.CANCELLING;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('isCompleting',
function() {

    /**
     * @method isCompleting
     * @summary Returns true if the receiver is in the process of being
     *     completed. This may be due to either fail, cancel, or success
     *     processing.
     * @returns {Boolean} The current activity status.
     */

    var stat;

    stat = this.get('statusCode');

    switch (stat) {
        case TP.ERRORING:
        case TP.FAILING:
        case TP.CANCELLING:
        case TP.COMPLETING:
            return true;

        default:
            return false;
    }
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('isCompleted',
function() {

    /**
     * @method isCompleted
     * @summary Returns true if the receiver is done processing.
     * @description A true value doesn't mean success, just that the processing
     *     is finished. It may have been cancelled, failed, or completed
     *     properly. You can use the 'did*' methods to check the final status.
     * @returns {Boolean} Whether or not the job is done processing.
     */

    return this.didComplete();
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('isErroring',
function() {

    /**
     * @method isErroring
     * @summary Returns true if the receiver is in the process of being errored
     *     out due to an explicit error/exception.
     * @returns {Boolean} The current activity status.
     */

    return this.get('statusCode') === TP.ERRORING;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('isFailing',
function() {

    /**
     * @method isFailing
     * @summary Returns true if the receiver is in the process of being failed
     *     due to an explicit error/exception.
     * @returns {Boolean} The current activity status.
     */

    return this.get('statusCode') === TP.FAILING;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('isPaused',
function(aFlag) {

    /**
     * @method isPaused
     * @summary Combined setter/getter for whether the receiver is paused.
     *     Passing aFlag of true will set the receiver's state to TP.PAUSED.
     *     Passing false will return the state to TP.ACTIVE.
     * @param {Boolean} aFlag True to place the receiver into an active state.
     * @returns {Boolean} Whether or not the job is currently paused.
     */

    if (TP.isBoolean(aFlag)) {
        this.$set('statusCode', aFlag ? TP.PAUSED : TP.ACTIVE);
    }

    return this.get('statusCode') === TP.PAUSED;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('isRunnable',
function() {

    /**
     * @method isRunnable
     * @summary Returns true if the receiver is in a state that would allow it
     *     to run, or to resume running. These states are TP.READY, TP.ACTIVE,
     *     and TP.PAUSED.
     * @returns {Boolean} Whether or not the job could be run.
     */

    var stat;

    stat = this.get('statusCode');

    switch (stat) {
        case TP.READY:
        case TP.ACTIVE:
        case TP.PAUSED:
            return true;

        default:
            return false;
    }
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('isSucceeding',
function() {

    /**
     * @method isSucceeding
     * @summary Returns true if the receiver is in the process of being failed
     *     due to an explicit error/exception.
     * @returns {Boolean} The current activity status.
     */

    return this.get('statusCode') === TP.SUCCEEDING;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('cancel',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method cancel
     * @summary Tells the receiver to cancel, meaning it is being rescinded by
     *     the user or calling process. If the receiver has specific behavior to
     *     implement it should override the cancelJob() method invoked as part
     *     of this method's operation.
     * @param {String} aFaultString A string description of the fault.
     * @param {Object} aFaultCode A code providing additional information on the
     *     reason for the cancellation.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the cancellation.
     * @returns {TP.core.JobStatus} The receiver.
     */

    var stat,

        code,
        text,
        info;

    stat = this.get('statusCode');
    switch (stat) {

        case TP.ERRORING:
        case TP.FAILING:
        case TP.CANCELLING:
        case TP.COMPLETING:
        case TP.CANCELLED:
        case TP.ERRORED:
        case TP.FAILED:
        case TP.TIMED_OUT:
        case TP.SUCCEEDED:
        case TP.COMPLETED:

            //  Don't cancel the receiver - just return.
            return this;

        case TP.PAUSING:
        case TP.SUCCEEDING:
        case TP.PAUSED:
        case TP.SKIPPED:
        case TP.IGNORED:
        default:

            //  Go ahead and allow the receiver to cancel.
            void 0;
    }

    //  TODO: setting undefined here may throw off reflection which depends on
    //  the difference to know what attributes are "known" vs. "unknown".
    this.set('result', undefined);
    this.set('statusCode', TP.CANCELLING);

    info = TP.hc(aFaultInfo);
    if (TP.isKindOf(aFaultString, 'TP.sig.Exception')) {
        code = TP.ifInvalid(aFaultCode, TP.CANCELLED);
        text = aFaultString.getMessage();
        info.atPut('error', aFaultString.getError());
    } else if (TP.isError(aFaultCode)) {
        code = TP.CANCELLED;
        if (TP.isEmpty(aFaultString)) {
            text = aFaultCode.message;
        } else {
            text = aFaultString;
        }
        info.atPut('error', aFaultCode);
    } else if (TP.isNumber(aFaultCode)) {
        code = aFaultCode;
        text = aFaultString;
    } else if (TP.isString(aFaultCode)) {
        if (TP.isEmpty(aFaultString)) {
            code = TP.CANCELLED;
            text = aFaultCode;
        } else {
            code = aFaultCode;
            text = aFaultString;
        }
    } else {
        code = TP.ifInvalid(aFaultCode, TP.CANCELLED);
        text = aFaultString;
    }

    this.set('faultCode', code);
    this.set('faultText', text);
    this.set('faultInfo', info);

    try {
        this.cancelJob(text, code, info);
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'Job completion error.')) : 0;
    } finally {
        this.set('statusCode', TP.CANCELLED);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('cancelJob',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method cancelJob
     * @summary Template method for processing to cancel a job/request.
     *     Override this method to provide custom job cancellation logic.
     * @param {String} aFaultString A string description of the fault.
     * @param {Object} aFaultCode A code providing additional information on the
     *     reason for the cancellation.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the cancellation.
     * @returns {TP.core.JobStatus} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('complete',
function(aResult) {

    /**
     * @method complete
     * @summary Tells the receiver to complete, meaning the receiver should do
     *     whatever finalization is necessary to reach the TP.SUCCEEDED state.
     *     If the receiver has specific behavior to implement it should override
     *     the completeJob() method invoked as part of this method's operation.
     * @param {Object} aResult An optional object to set as the result for the
     *     request.
     * @returns {TP.core.JobStatus} The receiver.
     */

    var stat;

    stat = this.get('statusCode');
    switch (stat) {

        case TP.ERRORING:
        case TP.FAILING:
        case TP.CANCELLING:
        case TP.COMPLETING:
        case TP.CANCELLED:
        case TP.ERRORED:
        case TP.FAILED:
        case TP.TIMED_OUT:
        case TP.SUCCEEDED:
        case TP.COMPLETED:

            //  Don't cancel the receiver - just return.
            return this;

        case TP.PAUSING:
        case TP.SUCCEEDING:
        case TP.PAUSED:
        case TP.SKIPPED:
        case TP.IGNORED:
        default:

            //  Go ahead and allow the receiver to cancel.
            void 0;
    }

    this.set('statusCode', TP.COMPLETING);

    //  if we got an argument, even when that argument was null or
    //  undefined, use that argument as the new result value.
    if (arguments.length > 0) {
        this.set('result', aResult);
    }

    try {
        if (TP.isDefined(aResult)) {
            this.completeJob(aResult);
        } else {
            this.completeJob();
        }
    } catch (e) {
        //  Make sure we don't think the job succeeded or bury the error.
        this.set('statusCode', TP.FAILED);
        this.set('result', e);

        TP.ifError() ?
            TP.error(TP.ec(e, 'Job completion error.')) : 0;
    } finally {
        //  have to check to see if we already have an failed or cancelled
        //  status since that means we can't set to a success status
        if (!this.isCompleted()) {
            this.set('statusCode', TP.SUCCEEDED);
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('completeJob',
function(aResult) {

    /**
     * @method completeJob
     * @summary Template method for processing to complete a job/request.
     *     Override this method to provide custom job completion logic.
     * @param {Object} aResult An optional object to set as the result for the
     *     job/request.
     * @returns {TP.core.JobStatus} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('error',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method error
     * @summary Tells the receiver there was an error in job processing.
     * @param {String} aFaultString A string description of the error.
     * @param {Object} aFaultCode A code providing additional information on
     *     specific nature of the error. Often an exception or Error object.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the error.
     * @returns {TP.core.JobStatus} The receiver.
     */

    var stat,

        code,
        text,
        info;

    //  failure that comes in async after the job may believe it finished to
    //  override a "success" status. Therefore, we need to allow or not allow
    //  the receiver to be failed based on a more sophisticated check of the
    //  current status code.

    stat = this.get('statusCode');
    switch (stat) {

        case TP.ERRORING:
        case TP.FAILING:
        case TP.COMPLETING:
        case TP.ERRORED:
        case TP.FAILED:
        case TP.CANCELLED:
        case TP.SUCCEEDED:
        case TP.COMPLETED:

            //  Don't fail the receiver - just return.
            return this;

        case TP.PAUSING:
        case TP.CANCELLING:
        case TP.SUCCEEDING:
        case TP.PAUSED:
        case TP.SKIPPED:
        case TP.TIMED_OUT:
        case TP.IGNORED:
        default:

            //  Go ahead and allow the receiver to fail.
            void 0;
    }

    this.set('result', undefined);
    this.set('statusCode', TP.ERRORING);

    info = TP.hc(aFaultInfo);
    if (TP.isKindOf(aFaultString, 'TP.sig.Exception')) {
        code = TP.ifInvalid(aFaultCode, TP.ERRORED);
        text = aFaultString.getMessage();
        info.atPut('error', aFaultString.getError());
    } else if (TP.isError(aFaultCode)) {
        code = TP.ERRORED;
        if (TP.isEmpty(aFaultString)) {
            text = aFaultCode.message;
        } else {
            text = aFaultString;
        }
        info.atPut('error', aFaultCode);
    } else if (TP.isNumber(aFaultCode)) {
        code = aFaultCode;
        text = aFaultString;
    } else if (TP.isString(aFaultCode)) {
        if (TP.isEmpty(aFaultString)) {
            code = TP.ERRORED;
            text = aFaultCode;
        } else {
            code = aFaultCode;
            text = aFaultString;
        }
    } else {
        code = TP.ifInvalid(aFaultCode, TP.ERRORED);
        text = aFaultString;
    }

    this.set('faultCode', code);
    this.set('faultText', text);
    this.set('faultInfo', info);

    try {
        this.errorJob(text, code, info);
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'Job completion error.')) : 0;
    } finally {
        this.set('statusCode', TP.ERRORED);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('errorJob',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method errorJob
     * @summary Template method for job/request error processing. Override
     *     this method to provide custom job error logic.
     * @param {String} aFaultString A string description of the fault.
     * @param {Object} aFaultCode A code providing additional information on the
     *     reason for the error.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the error.
     * @returns {TP.core.JobStatus} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('fail',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method fail
     * @summary Tells the receiver to fail, meaning it failed due to some form
     *     of exception. If the receiver has specific behavior to implement it
     *     should override the failJob method invoked as part of this method's
     *     operation.
     * @param {String} aFaultString A string description of the fault.
     * @param {Object} aFaultCode A code providing additional information on the
     *     reason for the failure.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the failure.
     * @returns {TP.core.JobStatus} The receiver.
     */

    var stat,

        code,
        text,
        info;

    //  failure that comes in async after the job may believe it finished to
    //  override a "success" status. Therefore, we need to allow or not allow
    //  the receiver to be failed based on a more sophisticated check of the
    //  current status code.

    stat = this.get('statusCode');
    switch (stat) {

        case TP.ERRORING:
        case TP.FAILING:
        case TP.COMPLETING:
        case TP.ERRORED:
        case TP.FAILED:
        case TP.CANCELLED:
        case TP.SUCCEEDED:
        case TP.COMPLETED:

            //  Don't fail the receiver - just return.
            return this;

        case TP.PAUSING:
        case TP.CANCELLING:
        case TP.SUCCEEDING:
        case TP.PAUSED:
        case TP.SKIPPED:
        case TP.TIMED_OUT:
        case TP.IGNORED:
        default:

            //  Go ahead and allow the receiver to fail.
            void 0;
    }

    this.set('result', undefined);
    this.set('statusCode', TP.FAILING);

    info = TP.hc(aFaultInfo);
    if (TP.isKindOf(aFaultString, 'TP.sig.Exception')) {
        code = TP.ifInvalid(aFaultCode, TP.FAILED);
        text = aFaultString.getMessage();
        info.atPut('error', aFaultString.getError());
    } else if (TP.isError(aFaultCode)) {
        code = TP.FAILED;
        if (TP.isEmpty(aFaultString)) {
            text = aFaultCode.message;
        } else {
            text = aFaultString;
        }
        info.atPut('error', aFaultCode);
    } else if (TP.isNumber(aFaultCode)) {
        code = aFaultCode;
        text = aFaultString;
    } else if (TP.isString(aFaultCode)) {
        if (TP.isEmpty(aFaultString)) {
            code = TP.FAILED;
            text = aFaultCode;
        } else {
            code = aFaultCode;
            text = aFaultString;
        }
    } else {
        code = TP.ifInvalid(aFaultCode, TP.FAILED);
        text = aFaultString;
    }

    this.set('faultCode', code);
    this.set('faultText', text);
    this.set('faultInfo', info);

    try {
        this.failJob(text, code, info);
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'Job completion error.')) : 0;
    } finally {
        this.set('statusCode', TP.FAILED);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('failJob',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method failJob
     * @summary Template method for job/request failure processing. Override
     *     this method to provide custom job failure logic.
     * @param {String} aFaultString A string description of the fault.
     * @param {Object} aFaultCode A code providing additional information on the
     *     reason for the failure.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the failure.
     * @returns {TP.core.JobStatus} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('getFaultCode',
function() {

    /**
     * @method getFaultCode
     * @summary Returns the fault code of the receiver.
     * @returns {Number} A TIBET fault code constant.
     */

    // TODO: direct slot access?
    if (TP.notDefined(this.faultCode)) {
        this.getType().Inst.defineAttribute('faultCode');
    }

    return this.$get('faultCode');
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('getFaultInfo',
function() {

    /**
     * @method getFaultInfo
     * @summary Returns the fault info of the receiver.
     * @returns {TP.core.Hash} A hash that will contain additional information
     *     about the failure.
     */

    // TODO: direct slot access?
    if (TP.notDefined(this.faultInfo)) {
        this.getType().Inst.defineAttribute('faultInfo');
    }

    return this.$get('faultInfo');
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('getFaultText',
function() {

    /**
     * @method getFaultText
     * @summary Returns the fault string (description) of the receiver.
     * @returns {String} A text description of the fault.
     */

    // TODO: direct slot access?
    if (TP.notDefined(this.faultText)) {
        this.getType().Inst.defineAttribute('faultText');
    }

    return this.$get('faultText');
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('getStatusCode',
function() {

    /**
     * @method getStatusCode
     * @summary Returns the job status code of the receiver.
     * @returns {Number} A TIBET status code constant.
     */

    // TODO: direct slot access?
    if (TP.notDefined(this.statusCode)) {
        this.getType().Inst.defineAttribute('statusCode', TP.READY);
    }

    return this.$get('statusCode');
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('getStatusText',
function() {

    /**
     * @method getStatusText
     * @summary Returns the job status of the receiver in text form.
     * @returns {String} The current status in text form.
     */

    // TODO: direct slot access?
    if (TP.notDefined(this.statusText)) {
        this.getType().Inst.defineAttribute('statusText', TP.READY);
    }

    return this.$get('statusText');
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('pause',
function() {

    /**
     * @method pause
     * @summary Pauses the receiver if that operation is supportable by the
     *     particular type.
     * @description Not all receivers of the pause operation are able to pause
     *     effectively (XMLHttpRequest for example), but the job does enter the
     *     TP.PAUSED state as a result of this method.
     * @returns {TP.core.JobStatus} The receiver.
     */

    //  minimum is to set the status code so the job looks paused from a
    //  state perspective
    this.isPaused(true);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('reset',
function() {

    /**
     * @method reset
     * @summary Resets the receiver, returning it to its initial state.
     * @returns {TP.core.JobStatus} The receiver.
     */

    //  clear status code back to original
    this.set('statusCode', TP.READY);

    //  clear failure/fault code back to original
    this.set('faultCode', null);
    this.set('faultText', null);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('resume',
function() {

    /**
     * @method resume
     * @summary Resumes a paused receiver, if it was actually paused.
     * @description Not all receivers can pause effectively and may ignore this
     *     call along with the pause() call itself. If the job was in a
     *     TP.PAUSED state however, this call will return it to the TP.ACTIVE
     *     state.
     * @returns {TP.core.JobStatus} The receiver.
     */

    //  return to TP.ACTIVE if we were paused
    if (this.isPaused()) {
        this.isPaused(false);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JobStatus.Inst.defineMethod('start',
function(parameters) {

    /**
     * @method start
     * @summary Starts the receiver in "job control" terms. This is the
     *     standard entry point method for activating a receiver relative to the
     *     job control subsystem. One specific effect of this call is that the
     *     job will enter the TP.ACTIVE state.
     * @param {TP.core.Hash} parameters A hash of parameters the job function(s)
     *     can access.
     * @returns {TP.core.JobStatus} The receiver.
     */

    this.isActive(true);

    return this;
});

//  ------------------------------------------------------------------------
//  JOB/PROCESS SUPPORT
//  ------------------------------------------------------------------------

/**
 * @type {TP.core.Job}
 * @summary TP.core.Job provides support for operations consisting of a
 *     sequence of asynchronous calls which follow a scheduling algorithm. In
 *     addition, TP.core.Job instances are tracked by TIBET so you can view and
 *     manage them from a central "process list".
 * @description Job instances are essentially scheduling/control objects that
 *     help you run one or more "work functions" in a particular way. The
 *     primary goal of TP.core.Job is to provide you with a way to run these
 *     work functions with optional pre/post functions and to manage their
 *     scheduling (delay, interval, limit, and repeat count) using more powerful
 *     models than a pure setInterval() or setTimeout() sequence. A secondary
 *     goal is to allow TP.core.Jobs to form the basis for doing "asynchronous
 *     perform" operations that iterate over a collection while yielding to the
 *     display thread after each item. For speed purposes, all ivars in the
 *     following methods are referenced by a 'direct' reference, using their
 *     low-level names: getActiveTime() getElapsedTime() getPauseTime()
 *     getPercentComplete() getProjectedTime() getStepValue() isLimited()
 *     $iterate() $work()
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.Job');

//  add job status code support.
TP.core.Job.addTraits(TP.core.JobStatus);

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  all of the keys used for the 'control parameters'. Note that not all of
//  these might be used by the core TP.core.Job machinery, but might be
//  there for other users of TP.core.Jobs, such as animation.
TP.core.Job.Type.defineConstant('CONTROL_PARAM_KEYS',
    TP.ac('config',
            'pre', 'step', 'post',
            'compute', 'delay', 'interval', 'lastInterval',
            'limit', 'count',
            'freeze', 'preserve', 'restore',
            'stats',
            'isAnimation'));

//  ------------------------------------------------------------------------
//  STEP COMPUTE FUNCTIONS
//  ------------------------------------------------------------------------

/*
Animation-like step operations often use different computation functions to
determine the next step's value. A number of these computation routines are
included here to support the most common computations for iteration and
animation. Which compute function is used is based on the 'compute' function
supplied to the job during construction. Note that as a result a particular
job instance is preconfigured to operate in a certain fashion with only the
actual value data (i.e. from, to, or list) varying with each start call.
*/

//  ------------------------------------------------------------------------
//  VALUES array computations
//  ---

TP.core.Job.Type.defineConstant('ITERATION_INDEX_COMPUTE',
function(job, params) {

    /**
     * @method TP.core.Job.ITERATION_INDEX_COMPUTE
     * @summary Returns the proper value from a collection based on the current
     *     job iteration number. The values are assumed to be in a step
     *     parameter set under the key 'values'.
     * @param {TP.core.Job} job The job instance.
     * @param {TP.core.Hash} params The step parameter data for the job.
     * @returns {Object} The object at the computed index.
     */

    var values,
        index;

    values = params.at('values');
    index = job.get('iteration');

    return values.at(index.min(values.getSize() - 1));  //  don't overrun
});

//  ------------------------------------------------------------------------

TP.core.Job.Type.defineConstant('PERCENTAGE_INDEX_COMPUTE',
function(job, params) {

    /**
     * @method TP.core.Job.PERCENTAGE_INDEX_COMPUTE
     * @summary Returns the proper value from a collection based on the current
     *     percentage of job completion. The values are assumed to be in a step
     *     parameter set under the key 'values'.
     * @param {TP.core.Job} job The job instance.
     * @param {TP.core.Hash} params The step parameter data for the job.
     * @returns {Object} The object at the computed index.
     */

    var percent,
        values,
        index;

    //  jobs can run in a variety of forms, so percent complete is better
    //  left to the job than to us
    percent = job.getPercentComplete();

    values = params.at('values');
    index = (values.getSize() * percent).floor();   //  0 indexed so floor

    return values.at(index.min(values.getSize() - 1));  //  don't overrun
});

//  ------------------------------------------------------------------------
//  FROM/TO computations
//  ---

TP.core.Job.Type.defineConstant('LINEAR_COMPUTE',
function(job, params) {

    /**
     * @method TP.core.Job.LINEAR_COMPUTE
     * @summary Returns the proper value between two values ('from' and 'to')
     *     based on current percentage of job completion as computed by a simple
     *     linear algorithm.
     * @param {TP.core.Job} job The job instance.
     * @param {TP.core.Hash} params The step parameter data for the job.
     * @returns {Number} The computed value.
     */

    var percent,
        delta;

    //  jobs can run in a variety of forms, so percent complete is better
    //  left to the job than to us
    percent = job.getPercentComplete();

    //  note that we need a from/to for this model
    delta = params.at('delta');

    /* eslint-disable no-extra-parens */
    return (percent * delta) + params.at('from');
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------
//  INTERVAL FUNCTIONS
//  ------------------------------------------------------------------------

/*
Pre-built options for decaying (aka increasing) the scheduling interval or
performing other "recomputation" of the interval.
*/

//  ------------------------------------------------------------------------

TP.core.Job.Type.defineConstant('DOUBLE_DECAY',
function(aJob) {

    /**
     * @method DOUBLE_DECAY
     * @summary Returns a value which doubles the last delay time with each
     *     invocation. This will cause delays to increase quickly.
     * @param {TP.core.Job} aJob An instance whose processing data may be used
     *     to feed the computation of a new delay time.
     * @returns {Number} A computed delay time.
     */

    return aJob.get('maxInterval').min(aJob.get('lastInterval') * 2);
});

//  ------------------------------------------------------------------------

TP.core.Job.Type.defineConstant('DOUBLE_ON_FAILURE',
function(aJob) {

    /**
     * @method DOUBLE_ON_FAILURE
     * @summary Returns a value which doubles the last delay time with each
     *     unsuccessful invocation. On success it will set the job back to the
     *     firstInterval value.
     * @param {TP.core.Job} aJob An instance whose processing data may be used
     *     to feed the computation of a new delay time.
     * @returns {Number} A computed delay time.
     */

    if (aJob.get('wasSuccessful')) {
        return aJob.get('firstInterval');
    } else {
        return aJob.get('maxInterval').min(aJob.get('lastInterval') * 2);
    }
});

//  ------------------------------------------------------------------------

TP.core.Job.Type.defineConstant('SIMPLE_DECAY',
function(aJob) {

    /**
     * @method SIMPLE_DECAY
     * @summary Returns a value which grows slowly over time by adding 1 second
     *     to the delay with each iteration.
     * @param {TP.core.Job} aJob An instance whose processing data may be used
     *     to feed the computation of a new delay time.
     * @returns {Number} A computed delay time.
     */

    return aJob.get('maxInterval').min(aJob.get('lastInterval') + 1000);
});

//  ------------------------------------------------------------------------

TP.core.Job.Type.defineConstant('SIMPLE_ON_FAILURE',
function(aJob) {

    /**
     * @method SIMPLE_ON_FAILURE
     * @summary Returns a value which grows slowly over time by adding 1 second
     *     to the delay with each unsuccessful invocation. On success it will
     *     set the job back to the firstInterval value.
     * @param {TP.core.Job} aJob An instance whose processing data may be used
     *     to feed the computation of a new delay time.
     * @returns {Number} A computed delay time.
     */

    if (aJob.get('wasSuccessful')) {
        return aJob.get('firstInterval');
    } else {
        return aJob.get('maxInterval').min(aJob.get('lastInterval') + 1000);
    }
});

//  ------------------------------------------------------------------------

TP.core.Job.Type.defineConstant('ZERO_DECAY',
function(aJob) {

    /**
     * @method ZERO_DECAY
     * @summary Returns a value which doesn't vary from the job's current delay
     *     times.
     * @param {TP.core.Job} aJob An instance whose processing data may be used
     *     to feed the computation of a new delay time.
     * @returns {Number} A computed delay time.
     */

    return aJob.get('lastInterval');
});

//  ------------------------------------------------------------------------
//  LIMIT FUNCTIONS
//  ------------------------------------------------------------------------

/*
Pre-built functions for limiting the job's execution count or run time.
*/

//  ------------------------------------------------------------------------

TP.core.Job.Type.defineConstant('ONCE',
function(aJob) {

    /**
     * @method ONCE
     * @summary Returns true if the job 'isLimited' and should stop. For the
     *     ONCE model this test checks the job's iteration count.
     * @param {TP.core.Job} aJob An instance whose processing data may be used
     *     to feed the computation.
     * @returns {Boolean} True if the job is limited and should stop.
     */

    //  NOTE that we test for 0 here since the first iteration is #0 to
    //  support indexing via iteration
    /* eslint-disable no-extra-parens */
    return (aJob.get('iteration') > 0);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.core.Job.Type.defineConstant('UNTIL_FAILURE',
function(aJob) {

    /**
     * @method UNTIL_FAILURE
     * @summary Returns true if the job 'isLimited' and should stop. For
     *     UNTIL_FAILURE this returns true when the job's wasSuccessful flag is
     *     false.
     * @param {TP.core.Job} aJob An instance whose processing data may be used
     *     to feed the computation.
     * @returns {Boolean} True if the job is limited and should stop.
     */

    return TP.isFalse(aJob.get('wasSuccessful'));
});

//  ------------------------------------------------------------------------

TP.core.Job.Type.defineConstant('UNTIL_SUCCESS',
function(aJob) {

    /**
     * @method UNTIL_SUCCESS
     * @summary Returns true if the job 'isLimited' and should stop. For
     *     UNTIL_SUCCESS this returns true when the job's wasSuccessful flag is
     *     true.
     * @param {TP.core.Job} aJob An instance whose processing data may be used
     *     to feed the computation.
     * @returns {Boolean} True if the job is limited and should stop.
     */

    return TP.isTrue(aJob.get('wasSuccessful'));
});

//  ------------------------------------------------------------------------

//  FOREVER is just the same as returning false.
TP.core.Job.Type.defineConstant('FOREVER', TP.RETURN_FALSE);

//  ------------------------------------------------------------------------
//  WORK FUNCTIONS
//  ------------------------------------------------------------------------

/*
Pre-built work functions which perform a task with the current step value.
*/

//  ------------------------------------------------------------------------

TP.core.Job.Type.defineConstant('LOG_STEP_PARAMS',
function(aJob, params) {

    /**
     * @method LOG_STEP_PARAMS
     * @summary Logs the current step parameters for the job. This is a useful
     *     debugging step to add to your job when experiencing problems getting
     *     a task to run.
     * @param {TP.core.Job} aJob An instance whose processing data may be used
     *     to feed the computation.
     * @returns {Boolean} True on success.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.core.Job.Type.defineConstant('LOG_STEP_VALUE',
function(aJob) {

    /**
     * @method LOG_STEP_VALUE
     * @summary Logs the current step value for the job. This is a useful
     *     debugging job that is the default when no function is provided. You
     *     can also add this to a list of step functions to get the overall job
     *     to log the value at each step.
     * @param {TP.core.Job} aJob An instance whose processing data may be used
     *     to feed the computation.
     * @returns {Boolean} True on success.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.core.Job.Type.defineConstant('PUSH_STEP_VALUE',
function(aJob) {

    /**
     * @method PUSH_STEP_VALUE
     * @summary Pushes the current step value for the job into the job's $steps
     *     array. This is a useful debugging job that is the default when no
     *     function is provided. You can also add this to a list of step
     *     functions to get the overall job to log the value at each step.
     * @param {TP.core.Job} aJob An instance whose processing data may be used
     *     to feed the computation.
     * @returns {Boolean} True on success.
     */

    aJob.$steps = aJob.$steps || TP.ac();
    aJob.$steps.push(aJob.getStepValue());

    return true;
});

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  the last PID used for a job instance
TP.core.Job.Type.defineAttribute('lastPID', 0);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.Job.Type.defineMethod('construct',
function(controlParams) {

    /**
     * @method construct
     * @summary Constructs and returns a new instance of the receiver. For a
     *     TP.core.Job this method also ensures that each new instance gets a
     *     unique PID and that it's properly registered with TIBET.
     * @param {TP.core.Hash|TP.sig.Request} controlParams An object which
     *     contains one or more keys defining job configuration. See init() for
     *     more info.
     * @returns {TP.core.Job} A new instance.
     */

    var inst;

    //  make sure it's a proper "request"
    if (!TP.canInvoke(controlParams, 'atIfInvalid')) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  get a clean instance prepared
    inst = this.callNextMethod();

    //  force creation of a new PID and assign it to the instance
    inst.set('PID', this.getPID());

    return inst;
});

//  ------------------------------------------------------------------------

TP.core.Job.Type.defineMethod('getPID',
function() {

    /**
     * @method getPID
     * @summary Returns the next PID to use for an instance.
     * @returns {Number} A new PID.
     */

    var pid;

    pid = this.get('lastPID') + 1;
    this.$set('lastPID', pid);

    return pid;
});

//  ------------------------------------------------------------------------

TP.core.Job.Type.defineMethod('scheduleInvokerJob',
function(anObjectArray, aMethodArray, aParamArray) {

    /**
     * @method scheduleInvokerJob
     * @summary Schedules a job with the system that invokes each of the
     *     supplied methods on the supplied objects using parameters given in
     *     the parameters Array.
     * @param {Object[]} anObjectArray The Array of target objects to invoke the
     *     methods against.
     * @param {String[]} aMethodArray The Array of method names to invoke against
     *     each target object.
     * @param {Object[]} aParamArray The Array of parameters to use when invoking
     *     the methods.
     * @returns {TP.meta.core.Job} The receiver.
     */

    var invokerFunc,
        params;

    //  Can't proceed without an Array of objects or methods
    if (!TP.isArray(anObjectArray) || !TP.isArray(aMethodArray)) {
        return this.raise('TP.sig.InvalidArray');
    }

    params = aParamArray;
    if (TP.notValid(params)) {
        params = TP.ac();
    }

    //  Construct an 'invoker function' that will invoke one method per one
    //  object for each run of the invocation.
    invokerFunc =
        function() {

            var target,
                idx,
                result;

            //  If the methodIndex has reached the size of the method array,
            //  then we 'go on to the next object' and reset the method
            //  index to 0
            if (invokerFunc.methodIndex === invokerFunc.methodArray.getSize()) {
                target = invokerFunc.objArray.shift();
                invokerFunc.methodIndex = 0;
            } else {
                target = invokerFunc.objArray.first();
            }

            //  Attempt to invoke the method against the object, supplying
            //  the params Array in an apply invocation.
            try {
                idx = invokerFunc.methodIndex;

                result = target[invokerFunc.methodArray.at(idx)].apply(
                            target, invokerFunc.paramArray);

                TP.ifInfo() ? TP.info(result) : 0;

                //  Increment the method index to go on to the next method.
                invokerFunc.methodIndex++;
            } catch (e) {
                TP.ifError() ?
                    TP.error(TP.ec(e, 'Error in invocation.')) : 0;

                invokerFunc.stopTest = true;
            }
        };

    //  We put the object, method and params Arrays on the invoker function
    //  itself in case this gets called recursively. Can't used closured
    //  variables.
    invokerFunc.objArray = anObjectArray.copy();
    invokerFunc.methodArray = aMethodArray;
    invokerFunc.paramArray = params;

    //  For the first time around, we set the methodIndex to the size of the
    //  methods Array. See the invoker function above for the logic about
    //  why we do this.
    invokerFunc.methodIndex = aMethodArray.getSize();
    invokerFunc.stopTest = false;

    //  schedule a job to invoke the invokerFunc
    TP.schedule(TP.hc(
                'step', invokerFunc,
                'interval', 50, //  repeat every 50ms
                'limit',
                function(aJob) {

                    //  If the array of objects is empty or someone set the
                    //  'stopTest' flag on the invoker function, stop now.
                    if (TP.isEmpty(invokerFunc.objArray) ||
                        invokerFunc.stopTest) {
                        return true;
                    }

                    return false;
                }));

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Job.Type.defineMethod('splitParams',
function(allParams) {

    /**
     * @method splitParams
     * @summary Splits the supplied params into two TP.core.Hashes, one
     *     containing the control parameters and the other containing the step
     *     parameters.
     * @description This method takes all entries from the supplied params hash
     *     that have keys matching those listed in CONTROL_PARAM_KEYS and places
     *     those in the control parameters hash. All remaining parameters will
     *     be in the step parameters hash (including those not strictly listed
     *     as step parameters in TP.core.Job).
     * @param {TP.core.Hash|TP.sig.Request} allParams An object which contains
     *     one or more keys defining job configuration. See init() for more
     *     info.
     * @returns {Array<TP.core.Hash,TP.core.Hash>} The Array containing
     *     ctrlParamsHash and stepParamsHash.
     */

    var ctrlParams,
        stepParams;

    ctrlParams = allParams.copy(false, TP.core.Job.CONTROL_PARAM_KEYS);
    stepParams = allParams.copy().removeKeys(
                                        TP.core.Job.CONTROL_PARAM_KEYS);

    return TP.ac(ctrlParams, stepParams);
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  the job's process ID from a TIBET perspective. this goes up with each
//  job constructed and allows TIBET to find jobs by ID. Note that a job's
//  ID may not change in response to reset operations.
TP.core.Job.Inst.defineAttribute('PID');

//  run start time. used in computing percentage complete etc.
TP.core.Job.Inst.defineAttribute('runstart');

//  overall job start time, when the first run of the job started
TP.core.Job.Inst.defineAttribute('started');

//  end time for the entire job, when the last run completed/terminated
TP.core.Job.Inst.defineAttribute('ended');

//  used to compute drift based on anticipated time for next step start
TP.core.Job.Inst.defineAttribute('expected', 0);
TP.core.Job.Inst.defineAttribute('lastExpected', 0);

TP.core.Job.Inst.defineAttribute('firstInterval',
                                TP.sys.cfg('job.interval'));
TP.core.Job.Inst.defineAttribute('lastInterval',
                                TP.sys.cfg('job.interval'));
TP.core.Job.Inst.defineAttribute('maxInterval',
                                TP.sys.cfg('job.max_interval'));

//  the last computed offset value used to adjust timing next invocation
TP.core.Job.Inst.defineAttribute('lastOffset', 0);

//  an offset to help track how long it appears the work function takes
TP.core.Job.Inst.defineAttribute('workOffset', 0);

//  pause control variables. last paused at (Date), currently paused, total
//  delay due to pauses, and values of compute vars at time of last pause
TP.core.Job.Inst.defineAttribute('lastPaused');
TP.core.Job.Inst.defineAttribute('totalPause', 0);

//  control values for processing/scheduling
TP.core.Job.Inst.defineAttribute('count', 1);           //  requested count
TP.core.Job.Inst.defineAttribute('totalcount', 1);      //  termination count
TP.core.Job.Inst.defineAttribute('runs', 1);            //  outer count so far
TP.core.Job.Inst.defineAttribute('iteration', 0);       //  run iteration

TP.core.Job.Inst.defineAttribute('delay', TP.sys.cfg('job.delay'));
TP.core.Job.Inst.defineAttribute('$delayms');

TP.core.Job.Inst.defineAttribute('limit', TP.core.Job.ONCE); // one iteration
TP.core.Job.Inst.defineAttribute('$limitms');

TP.core.Job.Inst.defineAttribute('interval', TP.sys.cfg('job.interval'));
TP.core.Job.Inst.defineAttribute('$intervalms');

TP.core.Job.Inst.defineAttribute('parameters');         //  'step' parameters

//  was the last segment successful in its work? this is captured to help
//  certain kinds of polling algorithms compute new intervals, or certain
//  kinds of limit functions operate (run until success) etc.
TP.core.Job.Inst.defineAttribute('wasSuccessful', false);

//  the component function(s)
TP.core.Job.Inst.defineAttribute('config');         //  one-time configuration
TP.core.Job.Inst.defineAttribute('pre');            //  pre-run setup
TP.core.Job.Inst.defineAttribute('post');           //  post-run teardown
TP.core.Job.Inst.defineAttribute('step');           //  the job's real work

//  a handle to the compute function, which must be supplied or it will
//  default to a linear computation that assumes a from/to parameter set
TP.core.Job.Inst.defineAttribute('compute');

//  a handle to the actual work function, a function built to invoke the
//  various functional elements of the job. typically built by the job.
TP.core.Job.Inst.defineAttribute('work');

//  the interval and timer which may be used to drive the job
TP.core.Job.Inst.defineAttribute('$useHeartbeat', false);
TP.core.Job.Inst.defineAttribute('$heartbeat');
TP.core.Job.Inst.defineAttribute('$timer');

//  whether or not to use 'requestAnimationFrame()' to drive the job
TP.core.Job.Inst.defineAttribute('$useRAF', false);

//  the time the last work was done. used for heartbeat sequencing to make
//  sure heartbeat doesn't run faster than the defined interval
TP.core.Job.Inst.defineAttribute('$lastWork');

//  a work invocation function that binds the work method to the instance
TP.core.Job.Inst.defineAttribute('$timedWork');

//  debugging / tuning data
TP.core.Job.Inst.defineAttribute('$stats');
TP.core.Job.Inst.defineAttribute('$steps');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('init',
function(controlParams) {

    /**
     * @method init
     * @summary Initializes new job instances and returns them for use.
     * @description The resulting job can be run multiple times with different
     *     execution data by passing a set of step parameters to the start()
     *     function. The jobs control parameters are fixed by this call, but can
     *     be adjusted using standard set methods on the job instance before
     *     each start() call.
     *
     *     The 'controlParams' hash can contain keys that control the job. It
     *     can have the following keys:
     *
     *     'config' A function to run to do any final job setup such as setting
     *     default values. 'pre' A function to run once before any step work is
     *     done. 'step' The "step" function, which does the actual processing of
     *     each iteration. 'post' A function to run during shutdown after all
     *     step iterations complete. 'compute' A function used to compute the
     *     next value for a step. 'delay' A millisecond delay before steps are
     *     processed. 'interval' A millisecond interval between each step
     *     iteration, or a function to compute it. 'lastInterval' A millisecond
     *     interval to start with when using an interval function. 'limit' A
     *     function returning true if the job/step has reached its limit, or a
     *     number defining the maximum number of times the step function(s)
     *     should be invoked per job, or a string defining an xs:duration for
     *     maximum time for the job to run. 'count' Number of times to repeat
     *     the entire job. Default is 1. 'stats' Boolean defining whether we
     *     want job statistics to be gathered.
     *
     *
     * @param {TP.core.Hash|TP.sig.Request} controlParams A hash of control
     *     parameters that control the job.
     * @returns {TP.core.Job} A new instance.
     */

    var paramVal,

        step,
        thisref;

    //  construct the instance and grab a reference we can close around
    //  below
    this.callNextMethod();

    //  Make sure to set this first, since some of the 'setters' below rely on
    //  this setting.
    if (TP.isTrue(controlParams.at('isAnimation'))) {
        this.$set('$useRAF', true);
    }

    //  note the use of standard set() call here to trigger setters. this
    //  lets us push the resolution logic for these values into those
    //  methods where they can be defined/encached for better runtime
    //  performance

    //  Can't use the atIfInvalid() method here because it wants to run
    //  Function objects supplied as defaults.
    if (TP.notValid(paramVal = controlParams.at('delay'))) {
        paramVal = TP.sys.cfg('job.delay');
    }
    this.set('delay', paramVal);

    if (TP.notValid(paramVal = controlParams.at('interval'))) {
        paramVal = TP.sys.cfg('job.interval');
    }
    this.set('interval', paramVal);

    if (TP.notValid(paramVal = controlParams.at('firstInterval'))) {
        paramVal = TP.sys.cfg('job.interval');
    }
    this.set('firstInterval', paramVal);
    this.set('lastInterval', paramVal);

    if (TP.notValid(paramVal = controlParams.at('maxInterval'))) {
        paramVal = TP.sys.cfg('job.max_interval');
    }
    this.set('maxInterval', paramVal);

    if (TP.notValid(paramVal = controlParams.at('limit'))) {
        paramVal = TP.core.Job.ONCE;
    }
    this.set('limit', paramVal);

    //  how many times do we run the job? normally just once. we set two
    //  values here to manage being able to shut down a multi-run job on a
    //  run boundary cleanly. see complete/shutdown for more
    this.$set('count', controlParams.atIfInvalid('count', 1), false);
    this.$set('totalcount', controlParams.atIfInvalid('count', 1), false);

    //  the compute function should be available now, otherwise default.
    //  NOTE that you can't use atIfInvalid to assign a function value since
    //  it will try to run the function...so we work around that here
    this.$set('compute', controlParams.at('compute'), false);

    //  pre/post and config function hooks
    this.$set('pre', controlParams.at('pre'), false);
    this.$set('post', controlParams.at('post'), false);
    this.$set('config', controlParams.at('config'), false);

    //  make sure we have processing logic in place before we try to build
    //  the work function
    step = controlParams.at('step');
    if (!TP.canInvoke(step, 'apply')) {
        //  use default for this type of job's instances
        step = this.$get('step');
    } else {
        //  store provided step(s) for reference
        this.$set('step', step, false);
    }

    //  allow for the possibility that the construct() call may have built a
    //  custom work function for us...or the consumer may have, and try to
    //  set the work function from that parameter. If not found the
    //  setWork() call will build us one...
    this.set('work', controlParams.at('work'));

    //  build a function we can use repeatedly for queueing the work
    thisref = this;
    this.$timedWork = function() {
        thisref.$work();
    };

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('$clearScheduler',
function() {

    /**
     * @method $clearScheduler
     * @summary Clears the internal timer and/or heartbeat scheduling used by
     *     this job. Normally invoked by the public methods for pausing/stopping
     *     job execution.
     * @returns {TP.core.Job} The receiver.
     */

    try {
        try {
            if (TP.isValid(this.$heartbeat)) {
                clearInterval(this.$heartbeat);
            }
        } catch (e1) {
            TP.ifError() ?
                TP.error(TP.ec(e1, 'Error clearing scheduler.')) : 0;
        }

        if (TP.isValid(this.$timer)) {
            if (this.$get('$useRAF')) {
                //  if we're using requestAnimationFrame, clear it
                window.cancelAnimationFrame(this.$timer);
            } else {
                clearTimeout(this.$timer);
            }
        }
    } finally {
        //  clear the variables so we don't have leftovers and pause/resume
        //  will operate as we'd like
        this.$heartbeat = null;
        this.$timer = null;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('$getEqualityValue',
function() {

    /**
     * @method $getEqualityValue
     * @summary Returns the value which should be used when testing for
     *     equality between two instances. For job instances this is the PID.
     * @returns {String} A value appropriate for use in equality comparisons.
     */

    return this.getPID();
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('complete',
function(aResult) {

    /**
     * @method complete
     * @summary Tells the receiver to complete the current run.
     * @description For a job with a repeat count this method may invoke the
     *     next run if one exists and that will continue until the job is truly
     *     complete. Use shutdown to end processing and close out the job with a
     *     successful status code without running any additional runs which
     *     might have been specified.
     * @param {Object} aResult An optional object to set as the result for the
     *     request.
     * @returns {TP.core.Job} The receiver.
     */

    var runs;

    //  decide if we need to requeue or not based on run count data. NOTE
    //  that we use totalcount here, a slot we allow the shutdown call to
    //  alter to help complete end on a run boundary if desired
    if ((runs = this.$get('runs')) < this.$get('totalcount')) {
        //  do the post-processing work for the current run
        this.$teardown();

        //  don't forget to count each run :)
        this.$set('runs', runs + 1);

        //  start the next run
        this.$startrun();
    } else {
        //  done with the overall job, so kill off any scheduling interval
        this.$clearScheduler();

        //  note that we end before teardown to be symmetrical with how we
        //  track started after $setup
        this.$set('ended', Date.now());

        //  do the post-processing work for the current run
        this.$teardown();

        TP.ifTrace() && TP.sys.shouldLogJobs() ?
            TP.sys.logJob('Job ' + this.getPID() +
                ' completed at ' + TP.dc(this.$get('ended')).asTimestamp(),
                TP.DEBUG) : 0;

        //  have to check to see if we already have an failed or cancelled
        //  status since that would imply we can't reset to a success
        //  status
        if (!this.isCompleted()) {
            this.set('statusCode', TP.SUCCEEDED);
        }

        TP.sys.removeJob(this);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('getActiveTime',
function() {

    /**
     * @method getActiveTime
     * @summary Returns the total time (minus any paused time) that the job has
     *     been active. This is the amount of time the job has been "executing"
     *     by being in an active state.
     * @description The active time does not include initial delay time, so a
     *     job queued 10 seconds ago to start in 5 seconds will show an elapsed
     *     time of 10 seconds, but an active time of 5 seconds. The same job, if
     *     paused for 2 seconds during that period, will still show 10 seconds
     *     of elapsed time but only 3 seconds of active time.
     * @returns {Number} Milliseconds of active time.
     */

    var start,
        end;

    if (TP.notValid(start = this.runstart)) {
        return 0;
    }

    //  adjust out any delay time that was initially used so we appear to
    //  have started a bit later...which we will have if there was a delay
    start = start + TP.ifInvalid(this.$delayms, 0);

    if (TP.notValid(end = this.ended)) {
        end = Date.now();
    }

    //  NOTE that we also remove pause time here so we're only showing
    //  actual time the job could have been running
    /* eslint-disable no-extra-parens */
    return (end - start - this.totalPause);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('getElapsedTime',
function() {

    /**
     * @method getElapsedTime
     * @summary Returns the total elapsed time (including paused time) that the
     *     job has been active as computed from the runstart time.
     * @description The elapsed time does not include initial delay time, so a
     *     job queued 10 seconds ago to start in 5 seconds will show an elapsed
     *     time of 10 seconds, but an active time of 5 seconds. The same job, if
     *     paused for 2 seconds during that period, will still show 10 seconds
     *     of elapsed time but only 3 seconds of active time.
     * @returns {Number} Milliseconds of elapsed time.
     */

    var start,
        end;

    if (TP.notValid(start = this.runstart)) {
        return 0;
    }

    if (TP.notValid(end = this.ended)) {
        end = Date.now();
    }

    return end - start;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('getPauseTime',
function() {

    /**
     * @method getPauseTime
     * @summary Returns the total pause time for the job.
     * @returns {Number} Milliseconds of pause time.
     */

    return this.totalPause;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('getPercentComplete',
function() {

    /**
     * @method getPercentComplete
     * @summary Returns the computed percentage complete for the current job.
     * @description For time-limited jobs this is the relative percentage
     *     between active and total time, but for iteration limited jobs it is
     *     the relative percentage of iterations to total iteration count. Jobs
     *     using a limit function have no value for this function.
     * @returns {Number} A Number between 0 and 1 that represents a percentage
     *     or null if this job is using a limit function and the percentage
     *     complete cannot be determined.
     */

    var type,
        percent;

    type = typeof this.limit;

    switch (type) {
        case 'string':
            //  duration/ms, should have limitms to go by
            percent = this.getActiveTime() / this.$limitms;
            break;

        case 'number':
            //  count, should be able to go by iterations where the first
            //  iteration is iteration 0
            percent = this.iteration / this.limit;
            break;

        case 'function':
        default:
            //  no way to know
            return null;
    }

    //  normalize to something between 0 and 1 so we don't overflow
    //  computation functions etc. NOTE we round to 3 places on percentage
    return percent.max(0).min(1).round(3);
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('getPID',
function() {

    /**
     * @method getPID
     * @summary Returns the unique PID or "job ID" for the receiver.
     * @returns {String}
     */

    return this.PID;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('getProjectedTime',
function() {

    /**
     * @method getProjectedTime
     * @summary Returns the total time the job is expected to run based on the
     *     limit and interval data supplied.
     * @description The initial delay time is not included in this computation,
     *     making this equivalent to "job duration". The one thing to keep in
     *     mind is that unless limit was provided as a duration this value is
     *     purely an estimate and not a limiting factor.
     * @returns {Number|undefined} Milliseconds of projected time.
     */

    var type;

    //  if the limit had a computed ms value that's our answer for sure
    if (TP.isNumber(this.$limitms)) {
        return this.$limitms;
    }

    type = typeof this.limit;

    switch (type) {
        case 'number':
            //  iteration count, we can multiply to estimate but we'll want
            //  to include some latency if we're going to be in the ballpark
            return this.limit * (this.lastOffset + this.$intervalms);

        default:
            break;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('getStepValue',
function(stepParams) {

    /**
     * @method getStepValue
     * @summary Computes a value for the current step using the function found
     *     in the job parameters under the key 'compute'.
     * @description If no function is found but 'values' exist then the standard
     *     value indexing compute function is used, if a 'from' and 'to' pair
     *     are found a standard linear from/to computation is used. If all else
     *     fails but a 'value' key exists in the parameter data that value is
     *     used (to allow steps to pass a value).
     *     The 'stepParams' hash can contain keys that are used by the
     *     job to perform its task. It can contain the following keys:
     *
     *     'from' The 'from value' to start the job counting at. 'to' The 'to
     *     value' to end the job counting at. 'values' An Array of values whose
     *     count is used by the job to compute stepping times, etc. 'delta' The
     *     difference between a from and to value used by the job to compute the
     *     next iteration value.
     *
     *     These keys are not actually used by the TP.core.Job type, but are
     *     defined to give a set of common names to commonly used parameters for
     *     TP.core.Jobs:
     *
     *     'target' The target (usually an element or set of elements in an
     *     animation) that is being transformed by the step function of the job.
     *     'property' The property of the target being transformed. 'by' Used
     *     rather than the 'to' parameter above to compute the step values
     *     additively from the 'from' value.
     * @param {TP.core.Hash} stepParams A hash of job-specific parameters passed
     *     to the start() function for the job. Note that this parameter is
     *     optional and will default to the parameters computed by the job.
     * @returns {Object} A step-specific value computed by the compute function.
     * @exception TP.sig.JobException
     */

    var val;

    try {
        if (TP.isCallable(this.compute)) {
            val = this.compute(
                    this,
                    TP.isValid(stepParams) ? stepParams : this.parameters);

            if (TP.isArray(this.$steps)) {
                this.$steps.push(val);
            }
        }
    } catch (e) {
        this.raise('TP.sig.JobException',
                    TP.ec(e, 'Error in compute function'));
    }

    return val;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('isLimited',
function() {

    /**
     * @method isLimited
     * @summary Returns true if the job can no longer run due to limit settings
     *     and job state. This method is invoked during each iteration to see if
     *     the job should continue to run or not.
     * @returns {Boolean} True if the job should stop running (has hit its
     *     limit).
     */

    var type,
        limit,
        active;

    limit = this.limit;
    type = typeof limit;

    switch (type) {
        case 'number':

            //  run the specified number of times? then we're limited. NOTE
            //  that we add 1 to the iteration here since iterations are
            //  zero-indexed but limits are expressed in terms of counts
            return this.iteration + 1 >= limit;

        case 'string':

            //  run long enough? then we're limited
            active = this.getActiveTime();

            return active >= this.$limitms;

        case 'function':

            return limit(this, this.parameters);

        default:

            return false;
    }
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('kill',
function(silently) {

    /**
     * @method kill
     * @summary Performs an immediate shutdown of the job, setting its status
     *     to TP.CANCELLED and ceasing any future processing.
     * @description This not only cancels any interval-based iterations but it
     *     will also cancel any repeat-count processing that might have
     *     otherwise occurred. No job post-processing functions will be run
     *     either.
     * @param {Boolean} silently True to skip any logging.
     * @returns {TP.core.Job} The receiver.
     */

    //  turn off any "about to happen" processing
    this.$clearScheduler();

    this.$set('ended', Date.now());

    if (TP.notTrue(silently)) {
        TP.ifTrace() && TP.sys.shouldLogJobs() ?
            TP.sys.logJob('Job ' + this.getPID() +
                    ' killed at ' + TP.dc(this.$get('ended')).asTimestamp(),
                    TP.DEBUG) : 0;
    }

    //  note that we cancel, not complete here
    this.cancel();
    TP.sys.removeJob(this);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('pause',
function() {

    /**
     * @method pause
     * @summary Pauses the job. Not all job functions can pause effectively so
     *     this may not work consistently based on the exact nature of the pre,
     *     work, and post functions being executed.
     * @returns {TP.core.Job} The receiver.
     */

    //  turn off any "about to happen" processing
    this.$clearScheduler();

    //  track each pause to help deal with timing offsets. the resume call
    //  will work with this to keep track of total pause time in a job to
    //  compute an offset as needed
    this.$set('lastPaused', Date.now());

    //  set our state properly
    this.isActive(false);
    this.isPaused(true);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('resume',
function() {

    /**
     * @method resume
     * @summary Resumes processing for a paused job. The job is run from the
     *     current state which includes computations to deal with time in the
     *     paused state.
     * @returns {TP.core.Job} The receiver.
     */

    //  when resuming we need to count ms for pauses so that the
    //  computations for delay, interval, runnable time etc. are correct
    this.$set('totalPause', this.$get('totalPause') +
                            (Date.now() -
                            this.$get('lastPaused')));

    //  clear paused state so iterate will actually run, otherwise it'll
    //  think we're still paused and simply return
    this.isPaused(false);
    this.isActive(true);

    //  iterate check various things before asking the work to be performed
    //  which is what we want when resuming...we don't want immediate work
    this.$iterate();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('schedule',
function() {

    /**
     * @method schedule
     * @summary Schedules the first work iteration for the job. This method is
     *     called by the start method to handle delay processing so that the
     *     iterate call can focus purely on interval-based scheduling.
     * @returns {TP.core.Job} The receiver.
     */

    var type,
        delay,
        timer;

    //  if we're paused we can exit immediately
    if (this.isPaused()) {
        return this;
    }

    //  can we run based on limits? if not then complete this job
    if (this.isLimited()) {
        this.complete();
        return this;
    }

    this.isActive(true);

    delay = this.$get('delay');
    type = typeof delay;

    switch (type) {
        case 'string':

            //  duration or ms as number
            delay = this.$delayms;

            break;

        case 'number':

            delay = this.$delayms;

            break;

        case 'function':

            delay = delay(this, this.$get('parameters'));

            break;

        default:

            delay = 0;

            break;
    }

    //  when we've got a real delay
    if (TP.isNumber(delay) && delay > 0) {
        //  if we're using requestAnimationFrame, set it up
        if (this.$get('$useRAF')) {
            timer = window.requestAnimationFrame(this.$timedWork);
        } else {
            //  do the work when the timeout expires...i.e. a delay is our
            //  first interval so when the delay is over we work immediately and
            //  then requeue as needed in that routine
            timer = setTimeout(this.$timedWork, delay);
        }

        this.$set('$timer', timer);
        this.$set('expected', delay);

        return this;
    }

    //  no delay? $work now and let it requeue as it sees fit
    return this.$work();
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('setDelay',
function(aDelay) {

    /**
     * @method setDelay
     * @summary Sets the delay in milliseconds using a Number, String, or
     *     Duration string value, or a function to compute the delay at runtime.
     * @param {Number|String|Duration} aDelay A number of milliseconds in one of
     *     three formats.
     * @returns {TP.core.Job} The receiver.
     */

    var type;

    this.$set('delay', aDelay);
    type = typeof aDelay;

    switch (type) {
        case 'string':

            //  duration or ms as number

            //  see if its a number first
            if (TP.isNaN(this.$delayms = parseFloat(aDelay))) {
                //  it's not - see if its a valid xs:duration
                this.$delayms = Date.getMillisecondsInDuration(aDelay);
            }

            break;

        case 'number':

            this.$delayms = aDelay;

            break;

        case 'function':

            //  explicitly don't want a number in this cache slot
            this.$delayms = null;

            break;

        default:

            this.$delayms = 0;

            break;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('setInterval',
function(anInterval) {

    /**
     * @method setInterval
     * @summary Sets the queuing interval in milliseconds using a Number,
     *     String, or Duration string value or a function to compute that value
     *     at runtime.
     * @param {Number|String|Duration} anInterval A number of milliseconds in
     *     one of three formats.
     * @returns {TP.core.Job} The receiver.
     */

    var type;

    this.$set('interval', anInterval);
    type = typeof anInterval;

    switch (type) {
        case 'string':

            //  duration or ms as number

            //  see if its a number first
            if (TP.isNaN(this.$intervalms = parseFloat(anInterval))) {
                //  it's not - see if its a valid xs:duration
                this.$intervalms = Date.getMillisecondsInDuration(
                                                            anInterval);
            }

            break;

        case 'number':

            this.$intervalms = anInterval;

            break;

        case 'function':

            //  explicitly don't want a number in this cache slot
            this.$intervalms = null;

            break;

        default:

            this.$intervalms = 0;

            break;
    }

    //  set the control flag for heartbeat use based on our interval time
    if (TP.isNumber(this.$intervalms) && TP.notTrue(this.$get('$useRAF'))) {
        this.$useHeartbeat = this.$intervalms <
                                TP.sys.cfg('job.heartbeat_threshold');
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('setLimit',
function(aLimit) {

    /**
     * @method setLimit
     * @summary Sets the limit using a Number or String, or Duration string
     *     value. A limit can also be a function which computes this value based
     *     on current job parameters.
     * @description This control parameter is used differently based on the type
     *     of argument supplied here: String Either a number of milliseconds as
     *     a String or an xs:Duration. Number The maximum number of times the
     *     step function(s) will be invoked per execution of the job. Function A
     *     function that returns true if the job/step has reached its limit.
     * @param {Number|String|Duration} aLimit The job limit in one of two
     *     formats or a function to compute it.
     * @returns {TP.core.Job} The receiver.
     */

    var type;

    this.$set('limit', aLimit);
    type = typeof aLimit;

    switch (type) {
        case 'string':

            //  duration or ms as number

            //  see if its a number first
            if (TP.isNaN(this.$limitms = parseFloat(aLimit))) {
                //  it's not - see if its a valid xs:duration
                this.$limitms = Date.getMillisecondsInDuration(aLimit);
            }

            break;

        case 'number':

            //  iteration count, not MS value...
            this.$limitms = null;

            break;

        case 'function':

            //  explicitly don't want a number in this cache slot
            this.$limitms = null;

            break;

        default:

            //  explicitly don't want a number in this cache slot
            this.$limitms = null;

            break;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('setWork',
function(work) {

    /**
     * @method setWork
     * @summary Sets the work function, the function the job actually uses to
     *     perform the steps.
     * @description When the work parameter here is empty this method will build
     *     a default work function from the current step content. The default
     *     function is used primarly to ensure that the work is properly
     *     enclosed in a try/catch to cleanup the job if any errors occur.
     * @param {Function} work The function serving as the work function.
     * @returns {TP.core.Job} The receiver.
     */

    var func,
        step;

    //  if nothing was provided (typical) then build a proper work function
    if (TP.notValid(func = work)) {
        //  grab the actual step function(s) so we can close around them
        step = this.$get('step');

        //  a simple wrapper around a potential set of functions which
        //  allows them all to run as a single work function.
        func = function(job, params) {

            TP.isCallable(step) ?
                        job.wasSuccessful = step(job, params) :
                        job.wasSuccessful = step.apply(null, arguments);

            return job.wasSuccessful;
        };

        //  support access for debugging purposes. this mirrors what we do
        //  with other wrapper functions such as bind (but may not always be
        //  a function if the work is an array of them)
        func.$realFunc = step;
    }

    //  make the wrapper the job's operational function so it's what the job
    //  runs when told to execute
    this.$set('work', func);
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('restart',
function() {

    /**
     * @method restart
     * @summary Restarts the job. Any current timers are cleared, the current
     *     run is torn down, and a new run is begun. Note that restart does not
     *     increment the overall run count, it restarts the current run.
     * @returns {TP.core.Job} The receiver.
     */

    //  stop any timers
    this.$clearScheduler();

    //  do the post-processing work for the current run
    this.$teardown();

    //  start the new run
    this.$startrun();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('shutdown',
function(now) {

    /**
     * @method shutdown
     * @summary Performs a clean shutdown of the job so it doesn't appear to
     *     have been terminated with an error or killed. This includes running
     *     the job's teardown/post-processing logic.
     * @description If "now" is true then any pending steps or job cycles (based
     *     on repeat count) are terminated before the teardown step.
     * @param {Boolean} now True to stop iterations and terminate now.
     * @returns {TP.core.Job} The receiver.
     */

    TP.ifTrace() && TP.sys.shouldLogJobs() ?
        TP.sys.logJob('Job ' + this.getPID() +
                ' shutdown requested at ' + TP.dc().asTimestamp(),
                TP.DEBUG) : 0;

    if (now) {
        //  cancel any pending work
        this.$clearScheduler();

        this.$set('ended', Date.now());

        //  do the post-processing work for the current run
        this.$teardown();
    } else {
        //  by setting our totalcount to the number of runs we cause the
        //  next complete call to terminate cleanly at a job run boundary
        this.$set('totalcount', this.$get('runs'));
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('start',
function(stepParams) {

    /**
     * @method start
     * @summary Starts a job, running it from its initial state. This is the
     *     public interface to initiating a job. As a result of this call the
     *     job's parameters will be set and its iterate method will be invoked
     *     to start the job scheduling process.
     * @description The 'stepParams' hash can contain keys that are used by the
     *     job to perform its task. It can contain the following keys:
     *
     *     'from' The 'from value' to start the job counting at. 'to' The 'to
     *     value' to end the job counting at. 'values' An Array of values whose
     *     count is used by the job to compute stepping times, etc. 'delta' The
     *     difference between a from and to value used by the job to compute the
     *     next iteration value.
     *
     *     These keys are not actually used by the TP.core.Job type, but are
     *     defined to give a set of common names to commonly used parameters for
     *     TP.core.Jobs:
     *
     *     'target' The target (usually an element or set of elements in an
     *     animation) that is being transformed by the step function of the job.
     *     'property' The property of the target being transformed. 'by' Used
     *     rather than the 'to' parameter above to compute the step values
     *     additively from the 'from' value.
     * @param {TP.core.Hash} stepParams A hash of job-specific parameters passed
     *     to the start() function for the job.
     * @returns {TP.core.Job} The receiver.
     */

    //  make sure TIBET knows about this job instance
    TP.sys.addJob(this);

    if (TP.isValid(stepParams)) {
        //  tuck away any parameters, effectively clearing previous value
        this.$set('parameters', stepParams, false);
    }

    //  update/default any parameters that might be missing
    this.$configure();

    //  do any pre-run setup before scheduling/running the job
    this.$setup();

    //  capture start time, which is when the job is asked to start
    this.$set('started', Date.now());
    this.$set('runstart', this.started);

    TP.ifTrace() && TP.sys.shouldLogJobs() ?
        TP.sys.logJob('Job ' + this.getPID() +
                ' started at ' + TP.dc(this.$get('started')).asTimestamp(),
                TP.DEBUG) : 0;

    //  schedule so we deal with possible delay, or run right now
    return this.schedule();
});

//  ------------------------------------------------------------------------
//  Internal Support
//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('$configure',
function() {

    /**
     * @method $configure
     * @summary Sets the job's default parameters by running any 'config'
     *     function provided and computing missing values.
     * @returns {TP.core.Job} The receiver.
     */

    var config;

    //  copy over any step parameter values so the job's internal properties
    //  and parameter data are in sync
    this.$$updateTimingFromStepParameters();

    //  run any supplied configuration function(s) to configure job
    config = this.$get('config');
    if (TP.canInvoke(config, 'apply')) {
        try {
            TP.isCallable(config) ?
                config(this, this.$get('parameters')) :
                config.apply(null, TP.ac(this, this.$get('parameters')));
        } catch (e) {
            TP.ifError() ?
                TP.error(
                    TP.ec(e, TP.join('Job ',
                                        this.getPID(),
                                        ' configuration failed.')),
                    TP.JOB_LOG) : 0;
        }
    }

    //  fill in the blanks :)
    this.$$updateMissingParamsAndState();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('$iterate',
function() {

    /**
     * @method $iterate
     * @summary Handles scheduling the next iteration of the job when using a
     *     non-heartbeat scheduling model. This method is invoked once any
     *     initial delay has been dealt with via the schedule call so it works
     *     only with repeat interval and latency to try to schedule the work for
     *     the next iteration.
     * @returns {TP.core.Job} The receiver.
     */

    var interval,

        expected,
        paused,
        now,
        runstart,
        elapsed,
        offset,
        next,

        timer;

    //  if we're paused we can exit immediately, can't work right now
    if (this.isPaused()) {
        return this;
    }

    //  can we run based on limits? if not then complete this run cycle
    if (this.isLimited()) {
        this.complete();
        return this;
    }

    //  two scheduling models in effect. for large-grained intervals we do
    //  our own scheduling computation but for small-grained intervals we
    //  use a "heartbeat" model which wakes us up every chance it gets
    if (this.$useHeartbeat) {
        if (TP.notValid(this.$heartbeat)) {
            //  should be using an interval but it was probably cleared by a
            //  pause...so restart it and let it do the work
            this.$heartbeat = setInterval(
                                this.$timedWork,
                                TP.sys.cfg('job.heartbeat_interval'));
        } else {
            //  no-op, we have an interval and it should be telling the work
            //  to occur. Note that we shouldn't really end up here.
            void 0;
        }

        return this;
    }

    //  get/compute the interval value for this iteration. the interval here
    //  is the one the original job defined...we'll adjust it later for
    //  latency to try to keep the job on target
    interval = this.interval;
    switch (typeof interval) {
        case 'function':

            interval = interval(this, this.parameters);
            if (!TP.isNumber(interval)) {
                interval = this.lastInterval;
            }

            break;

        case 'number':
        case 'string':

            interval = this.$intervalms;

            break;

        default:

            this.complete();
            return this;
    }

    //  save the lastInterval value based on our computation
    this.lastInterval = interval;

    //  tuck away the expected value we'd need to revive if we pause
    this.lastExpected = this.expected;

    expected = this.expected;               //  delay value first time thru
    paused = this.totalPause;               //  0 unless job has paused

    //  update our "expected time" to reflect the computed data...but note
    //  that we do not adjust this based on offset, this is what the job
    //  really expected over time...i.e. the time we'd expect with zero
    //  latency in place
    this.expected = expected + interval;

    //  start computing based on current time
    now = Date.now();

    //  total elapsed time is based on difference between now and the
    //  adjusted "runnable time" of the job which means moving the start
    //  time forward to deal with pause time
    runstart = this.runstart;
    elapsed = now - (runstart + paused);

    //  offset is how long we've been running minus what was expected. so
    //  for example, we may have expected 1100 for the first step in a 100ms
    //  job with a 1s delay, but perhaps have 1108 as elapsed...so we're
    //  over by 8 ms. when negative it means the job triggered slightly
    //  early. for example, if elapsed is 1092 we're early by 8ms so offset
    //  is -8.
    offset = elapsed - expected;
    this.lastOffset = offset;

    //  the next time we want to queue for is the computed interval minus
    //  the offset (which if we're running with a negative offset will end
    //  up adding offset time). one special case here however is when small
    //  interval values don't allow time for long work function runtimes
    //  which can cause the offset to exceed the interval time
    next = ((interval - offset) / 10).round() * 10;

    //  track stats if specified
    if (TP.isArray(this.$stats)) {
        this.$stats.push(TP.join('rs: ', runstart,
                                    ' pa: ', paused,
                                    ' nw: ', now,
                                    ' el: ', elapsed,
                                    ' ex: ', expected,
                                    ' of: ', offset,
                                    ' int: ', interval,
                                    ' nx: ', next));
    }

    //  do the deed, and keep track of the timer so we can clear it

    //  if we're using requestAnimationFrame, set it up
    if (this.$get('$useRAF')) {
        timer = window.requestAnimationFrame(this.$timedWork);
    } else {
        timer = setTimeout(this.$timedWork, next);
    }

    this.$set('$timer', timer);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('reset',
function() {

    /**
     * @method reset
     * @summary Resets the job, returning it to its initial state. Upon
     *     completion of this method a start() call will start the job running
     *     again as if for the first time (other than any side effects from the
     *     pre, work, and post functions themselves).
     * @returns {TP.core.Job} The receiver.
     */

    //  reset all internal params to their initial states. NOTE that we
    //  don't make any changes to step, pre, post, compute, work, count,
    //  delay, interval, limit or other "control parameters" for the job
    this.$clearScheduler();

    this.$set('parameters', null, false);

    this.$set('runstart', null, false);
    this.$set('started', null, false);
    this.$set('ended', null, false);

    this.$set('expected', 0, false);
    this.$set('lastExpected', 0, false);
    this.$set('lastInterval', this.$get('firstInterval'), false);

    this.$set('lastOffset', 0, false);
    this.$set('workOffset', 0, false);

    this.$set('lastPaused', null);
    this.$set('totalPause', 0, false);

    //  update total count so complete/shutdown work from original count
    this.$set('totalcount', this.$get('count'), false);
    this.$set('runs', 1, false);

    this.$set('iteration', 0, false);

    this.$set('wasSuccessful', false, false);

    //  clear cached data from last call
    this.$heartbeat = null;
    this.$lastWork = null;
    this.$timer = null;

    this.$stats = null;
    this.$steps = null;

    //  back to ready state
    this.$set('statusCode', TP.READY, false);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('$startrun',
function() {

    /**
     * @method $startrun
     * @summary Starts a job's next run. This is a convenience wrapper for
     *     reset()/start() which preserves the current job parameters before the
     *     reset.
     * @returns {TP.core.Job} The receiver.
     */

    var params,
        runs,
        runstart;

    //  TODO:   verify we're in the right state (ACTIVE etc)

    //  capture what we need to hold on to before we reset
    params = this.$get('parameters');
    runs = this.$get('runs');

    //  reset to initial state, which will clear parameters and run count
    //  which is why we held on to them above
    this.reset();

    //  re-establish parameters and run count so iterate will find them
    this.$set('parameters', params, false);
    this.$set('runs', runs, false);

    //  (ss) NOTE that we don't do this here, presuming that we can
    //  configure the defaults once and retain them for all individual runs
    //  update/default any parameters that might be missing
    // this.$configure();

    //  do any pre-run setup before scheduling/running the job
    this.$setup();

    //  capture restart time for this run
    runstart = Date.now();
    this.$set('runstart', runstart, false);

    TP.ifTrace() && TP.sys.shouldLogJobs() ?
        TP.sys.logJob('Job ' + this.getPID() +
                ' re-started at ' + TP.dc(runstart).asTimestamp(),
                TP.DEBUG) : 0;

    //  schedule so we deal with possible delay, or run right now
    return this.schedule();
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('$setup',
function() {

    /**
     * @method $setup
     * @summary Executes the receiver's pre-processing function(s) if any. This
     *     operation is invoked automatically at the start of each job run
     *     (which might be multiple times for a job with a repeat count).
     * @returns {TP.core.Job} The receiver.
     */

    var pre;

    //  before we truly start we run pre func if found
    pre = this.$get('pre');
    if (TP.canInvoke(pre, 'apply')) {
        try {
            TP.isCallable(pre) ?
                    pre(this, this.$get('parameters')) :
                    pre.apply(null, TP.ac(this, this.$get('parameters')));
        } catch (e) {
            TP.ifError() ?
                TP.error(
                    TP.ec(e, TP.join('Job ',
                                        this.getPID(),
                                        ' pre-processing failed.')),
                    TP.JOB_LOG) : 0;
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('$teardown',
function() {

    /**
     * @method $teardown
     * @summary Executes the receiver's post-processing function(s) if any.
     *     This operation is invoked automatically at the end of each job run
     *     (which might be multiple times for a job with a repeat count).
     * @returns {TP.core.Job} The receiver.
     */

    var post;

    //  before we truly end we run post func if found
    post = this.$get('post');
    if (TP.canInvoke(post, 'apply')) {
        try {
            TP.isCallable(post) ?
                    post(this, this.$get('parameters')) :
                    post.apply(null, TP.ac(this, this.$get('parameters')));
        } catch (e) {
            TP.ifError() ?
                TP.error(
                    TP.ec(e, TP.join('Job ',
                                        this.getPID(),
                                        ' pos-processing failed.')),
                    TP.JOB_LOG) : 0;
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('$$updateMissingParamsAndState',
function() {

    /**
     * @method $$updateMissingParamsAndState
     * @summary Sets missing job's parameters and instance state based on
     *     available information. This is the last step in $configure before a
     *     job is considered ready to run.
     * @returns {TP.core.Job} The receiver.
     */

    var params,
        fromVal,
        toVal,
        values,
        limit;

    if (TP.notValid(params = this.$get('parameters'))) {
        return this;
    }

    //  pre-compute delta value for from/to parameter blocks, default
    //  compute and limit functions based on params

    /* eslint-disable no-extra-parens */

    if (TP.isTrue(params.at('stats')) ||
        (!TP.isFalse(params.at('stats')) && TP.sys.shouldTrackJobStats())) {
        this.$stats = TP.ac();
        this.$steps = TP.ac();
    } else {
        this.$stats = null;
        this.$steps = null;
    }

    /* eslint-enable no-extra-parens */

    //  two basic parameter passing models for most jobs, 'from/to/by' and
    //  'values' (iteration). here we try to default those cases so you
    //  don't have to pass other typical parameters. note that 'by' isn't an
    //  official parameter used by TP.core.Jobs, but we check for it here in
    //  order to default the computation function.

    //  notice here how we assign up front. that way we don't have to worry
    //  about 'early bailout' on the OR test (and 't' never being assigned).
    fromVal = params.at('from');
    toVal = params.at('to');

    if (TP.isNumber(fromVal) ||
        TP.isNumber(toVal) ||
        TP.isValid(params.at('by'))) {
        //  if both the from and to are supplied, then we can compute the
        //  delta right here. otherwise, a 'pre' func will have to do that
        //  from other data.
        if (TP.isNumber(fromVal) && TP.isNumber(toVal)) {
            //  when doing a from/to a delta is the typical value used by
            //  compute functions so we compute that once.
            params.atPut('delta', toVal - fromVal);
        }

        //  the default computation for from/to is a linear compute based on
        //  current percentage complete
        if (!TP.isCallable(this.$get('compute'))) {
            this.$set('compute', TP.core.Job.LINEAR_COMPUTE, false);
        }
    } else if (TP.isArray(values = params.at('values'))) {
        limit = this.$get('limit');

        //  when using a value iteration model the compute function varies
        //  by how the job is limited.
        if (TP.notValid(limit)) {
            //  when there's no limit, but a list of values, we limit to the
            //  list size.  we set this here so the TP.isNumber() test below
            //  will work for both "no limit" and "size limit"
            limit = values.getSize();
            this.$set('limit', limit, false);
        }

        if (TP.isNumber(limit)) {
            //  when the limit is an explicit count the typical compute is
            //  iteration number so the indexes are easy.
            if (!TP.isCallable(this.$get('compute'))) {
                this.$set('compute',
                            TP.core.Job.ITERATION_INDEX_COMPUTE,
                            false);
            }
        } else if (TP.isString(limit)) {
            //  other cases are duration strings and functions. the duration
            //  strings are always a percentage complete model
            if (!TP.isCallable(this.$get('compute'))) {
                this.$set('compute',
                            TP.core.Job.PERCENTAGE_INDEX_COMPUTE,
                            false);
            }
        } else {
            //  when limit is a function it's hard to say what we should
            //  compute based on since we have no way to know how close the
            //  job is to being done, so we don't try :)
            void 0;
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('$$updateTimingFromStepParameters',
function() {

    /**
     * @method $$updateTimingFromStepParameters
     * @summary Called internally to update the job's timing configuration from
     *     the current step parameters. This allows an individual start()
     *     invocation to make minor alterations to the job (but not any that
     *     change the actual pre/step/work functions).
     * @returns {TP.core.Job} The receiver.
     */

    var params,
        value;

    if (TP.notValid(params = this.$get('parameters'))) {
        return this;
    }

    //  Note that many of these properties have 'custom setters', so we use
    //  the regular 'set()' method here.

    if (TP.isValid(value = params.at('delay'))) {
        this.set('delay', value);
    }

    if (TP.isValid(value = params.at('firstInterval'))) {
        this.set('firstInterval', value);
        this.set('lastInterval', value);
    }

    if (TP.isValid(value = params.at('maxInterval'))) {
        this.set('maxInterval', value);
    }

    if (TP.isValid(value = params.at('interval'))) {
        this.set('interval', value);
    }

    if (TP.isValid(value = params.at('limit'))) {
        this.set('limit', value);
    }

    if (TP.isValid(value = params.at('count'))) {
        this.set('count', value);
        this.set('totalcount', value);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Job.Inst.defineMethod('$work',
function() {

    /**
     * @method $work
     * @summary Executes the receiver's work function and determines if the
     *     work needs to be rescheduled to deal with interval repeats.
     * @returns {TP.core.Job} The receiver.
     */

    var work,
        gap,
        exit;

    work = this.work;

    //  if we're paused we can exit immediately, can't work right now
    if (this.isPaused()) {
        return this;
    }

    //  if we're using a heartbeat it's possible we've been called too
    //  early, so "mind the gap" before going any further... ;)
    if (this.$useHeartbeat && TP.isValid(this.$lastWork)) {
        gap = Date.now() - this.$lastWork;

        /* eslint-disable no-extra-parens */
        if ((gap + (TP.sys.cfg('job.heartbeat_interval') / 2)) <
                                                        this.$intervalms) {
            return this;
        }
        /* eslint-enable no-extra-parens */
    }

    try {
        //  track when we do work to help with our gap analysis above
        this.$lastWork = Date.now();

        TP.isCallable(work) ?
                this.wasSuccessful = work(this, this.parameters) :
                this.wasSuccessful = work.apply(
                                        null,
                                        TP.ac(this, this.parameters));

        if (TP.isFalse(this.wasSuccessful) &&
            TP.isValid(this.parameters) &&
            TP.isTrue(this.parameters.at('warn'))) {
            TP.ifWarn() ?
                TP.warn(TP.join('Job ', this.getPID(), ' step ',
                                this.iteration, ' was unsuccessful.'),
                        TP.JOB_LOG) : 0;
        }
    } catch (e) {
        this.wasSuccessful = false;

        TP.ifError() ?
            TP.error(
                TP.ec(e, TP.join('Job ',
                                    this.getPID(),
                                    ' step-processing error.')),
                TP.JOB_LOG) : 0;

        //  bit of a cheat here, but we'll call the private method
        //  and set failed as the status
        this.$clearScheduler();
        this.fail(TP.str(e));

        TP.ifError() ?
            TP.error(
                TP.ec(e, TP.join('Job ',
                                    this.getPID(),
                                    ' failed. ',
                                    'Job remains available in job list.')),
                TP.JOB_LOG) : 0;

        exit = true;
    } finally {
        /* eslint-disable no-unsafe-finally */

        //  if catch block triggered don't bother
        if (exit) {
            return this;
        }

        //  increment iteration count once we've run the function. this means
        //  iteration count remains zero-indexed to allow it to be used during
        //  collection iteration
        this.iteration++;

        //  can we run based on limits? if not then complete this run cycle
        if (this.isLimited()) {
            this.complete();
            return this;
        }

        //  when using heartbeat scheduling we either work now (since we've
        //  been notified) or we set up the first interval if it's never
        //  been configured (this is the first work run)
        if (this.$useHeartbeat) {
            if (TP.notValid(this.$heartbeat)) {
                //  first time through...queue the interval to call us back
                this.$heartbeat = setInterval(
                                    this.$timedWork,
                                    TP.sys.cfg('job.heartbeat_interval'));
            } else {
                //  no-op. already have an interval and it'll call back when
                //  it's ready
                void 0;
            }
        } else {
            //  re-queue via the iterate call for the next interval
            this.$iterate();
        }
        /* eslint-enable no-unsafe-finally */
    }

    return this;
});

//  ------------------------------------------------------------------------
//  JOB LIST MANAGEMENT
//  ------------------------------------------------------------------------

//  the TIBET "process table"
TP.sys.defineAttribute('$jobs');

//  ------------------------------------------------------------------------

TP.sys.defineMethod('addJob',
function(aJob) {

    /**
     * @method addJob
     * @summary Adds a job entry to the list of current jobs.
     * @param {TP.core.Job} aJob The job to add.
     * @returns {TIBET} The receiver.
     */

    this.getJobs().add(aJob);

    return this;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getJob',
function(aPID) {

    /**
     * @method getJob
     * @summary Returns the job whose PID matches the one provided.
     * @param {Number} aPID The PID to search for.
     * @returns {TP.core.Job} A TP.core.Job instance.
     */

    var jobs;

    jobs = this.get('$jobs');

    return jobs.detect(
                function(item) {

                    return item.getPID() === aPID;
                });
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getJobs',
function() {

    /**
     * @method getJobs
     * @summary Returns the list of current jobs.
     * @returns {TP.core.Job[]} The TIBET job list.
     */

    //  build lazily so we get "best" collection type/implementation
    if (TP.notValid(this.$get('$jobs'))) {
        this.$set('$jobs', TP.ac());
    }

    return this.$get('$jobs');
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('removeJob',
function(aJob) {

    /**
     * @method removeJob
     * @summary Removes a job entry from the list of current jobs.
     * @param {TP.core.Job} aJob The job to remove.
     * @returns {TP.sys} The receiver.
     */

    this.getJobs().remove(aJob);

    return this;
});

//  ------------------------------------------------------------------------
//  JOB CONTROL SHORTCUTS
//  ------------------------------------------------------------------------

TP.definePrimitive('job',
function(aPID) {

    /**
     * @method job
     * @summary Returns the job with the PID provided.
     * @param {Number|String} aPID The PID to query for.
     * @returns {TP.core.Job} The named job instance.
     */

    return TP.sys.getJob(aPID);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('kill',
function(aJob) {

    /**
     * @method kill
     * @summary Kills a particular TP.core.Job, by reference or by ID.
     * @param {Number|TP.core.Job} aJob The PID, or Job to kill.
     * @returns {aJob} The "dead" job.
     */

    var job;

    if (TP.notValid(aJob)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  if it's a job, not a pid, then we can just kill it
    if (TP.canInvoke(aJob, 'kill')) {
        return aJob.kill();
    }

    //  if it's a pid then we want to go by that
    if (TP.isValid(job = TP.sys.getJob(aJob))) {
        job.kill();
    }

    return job;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('schedule',
function(controlParams, stepParams) {

    /**
     * @method schedule
     * @summary Replaces setTimeout() and setInterval() calls, allowing you to
     *     manage long-running processes more effectively.
     * @description The 'controlParams' hash can contain keys that control the
     *     job. It can have the following keys:
     *
     *     'config' A function to run to do any final job setup such as setting
     *     default values. 'pre' A function to run once before any step work is
     *     done. 'step' The "step" function, which does the actual processing of
     *     each iteration. 'post' A function to run during shutdown after all
     *     step iterations complete. 'compute' A function used to compute the
     *     next value for a step. 'delay' A millisecond delay before steps are
     *     processed. 'interval' A millisecond interval between each step
     *     iteration, or a function to compute it. 'lastInterval' A millisecond
     *     interval to start with when using an interval function. 'limit' A
     *     function returning true if the job/step has reached its limit, or a
     *     number defining the maximum number of times the step function(s)
     *     should be invoked per job, or a string defining an xs:duration for
     *     maximum time for the job to run. 'count' Number of times to repeat
     *     the entire job. Default is 1. 'stats' Boolean defining whether we
     *     want job statistics to be gathered.
     *
     *     The 'stepParams' hash can contain keys that are used by the job to
     *     perform its task. It can contain the following keys:
     *
     *     'from' The 'from value' to start the job counting at. 'to' The 'to
     *     value' to end the job counting at. 'values' An Array of values whose
     *     count is used by the job to compute stepping times, etc. 'delta' The
     *     difference between a from and to value used by the job to compute the
     *     next iteration value.
     *
     *     These keys are not actually used by the TP.core.Job type, but are
     *     defined to give a set of common names to commonly used parameters for
     *     TP.core.Jobs:
     *
     *     'target' The target (usually an element or set of elements in an
     *     animation) that is being transformed by the step function of the job.
     *     'property' The property of the target being transformed. 'by' Used
     *     rather than the 'to' parameter above to compute the step values
     *     additively from the 'from' value.
     * @param {TP.core.Hash|TP.sig.Request} controlParams A hash of control
     *     parameters that control the job.
     * @param {TP.core.Hash} stepParams A hash of job-specific parameters passed
     *     to the start() function for the job.
     * @returns {TP.core.Job|undefined} A TP.core.Job instance which represents
     *     the overall job, regardless of how many individual timeouts may be
     *     used to implement it.
     */

    var job;

    //  goal is to get something we can register with TIBET that won't stay
    //  stuck in the job list when it exits. so the first problem is making
    //  sure we have a function that will remove the job when it completes

    //  the job instance is constructed with the same parameters so it knows
    //  what the original call was provided
    job = TP.core.Job.construct(controlParams);

    if (TP.notValid(job)) {
        //  presume the constructor logged the error here
        return;
    }

    //  start the job, which includes computing delays etc.
    job.start(stepParams);

    return job;
});

//  ------------------------------------------------------------------------

/**
 * @type {TP.core.JobGroup}
 * @summary TP.core.Job provides support for grouping objects that implement
 *     the TP.core.JobStatus trait (which could be TP.core.Job objects or other
 *     TP.core.JobGroups) and controlling them as a complete group. A common
 *     example is animations/effects which are combined into sets so that they
 *     can run as if they were a single effect, even though there are multiple
 *     underlying jobs being run.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.JobGroup');

//  add job status code support.
TP.core.JobGroup.addTraits(TP.core.JobStatus);

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.core.JobGroup.Inst.defineAttribute('children');

//  ------------------------------------------------------------------------

TP.core.JobGroup.Inst.defineMethod('$performOverChildren',
function(aMethodName, anArgument) {

    /**
     * @method $performOverChildren
     * @summary Runs a particular method against all children in the job group.
     *     This is used internally to process most of the public interface
     *     methods of this type. Since the methods typically invoked take 0 or 1
     *     argument we make it easy to pass one argument to the function.
     * @param {String} aMethodName The method to invoke on each child job.
     * @param {Object} anArgument An optional argument to pass to the method
     *     with each child invocation.
     * @returns {TP.core.JobGroup} The receiver.
     */

    var children,
        len,
        i;

    children = this.get('children');
    len = children.getSize();

    for (i = 0; i < len; i++) {
        children[i][aMethodName](anArgument);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JobGroup.Inst.defineMethod('addChild',
function(aChild) {

    /**
     * @method addChild
     * @summary Adds a child object implementing the TP.core.JobStatus
     *     implementation to the receiving job group.
     * @param {TP.core.JobStatus} aChild The child TP.core.JobStatus to add to
     *     this group.
     * @returns {TP.core.JobGroup} The receiver.
     */

    var children;

    children = this.getChildren();
    children.add(aChild);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JobGroup.Inst.defineMethod('cancel',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method cancel
     * @summary Tells the receiver to cancel, meaning it is being rescinded by
     *     the user or calling process.
     * @description If the receiver has specific behavior to implement it should
     *     override this method, but be sure to set the status to TP.CANCELLING
     *     during any processing and TP.CANCELLED after processing is complete.
     *     The default implementation simply sets the status to TP.CANCELLED.
     * @param {String} aFaultString A string description of the fault.
     * @param {Object} aFaultCode A code providing additional information on the
     *     reason for the cancellation.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the cancellation.
     * @returns {TP.core.JobGroup} The receiver.
     */

    this.$performOverChildren('cancel', aFaultString, aFaultCode, aFaultInfo);

    if (TP.isValid(aFaultCode)) {
        //  note we don't signal change here
        this.set('faultCode', aFaultCode);
    }

    if (TP.isString(aFaultString)) {
        //  note we don't signal change here
        this.set('faultText', aFaultString);
    }

    if (TP.isValid(aFaultInfo)) {
        //  note we don't signal change here
        this.set('faultInfo', aFaultInfo);
    }

    this.set('statusCode', TP.CANCELLED);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JobGroup.Inst.defineMethod('complete',
function(aResult) {

    /**
     * @method complete
     * @summary Tells the receiver to complete, meaning the receiver should do
     *     whatever finalization is necessary to reach the TP.SUCCEEDED state.
     * @description If the receiver has specific behavior to implement it should
     *     override this method, but be sure to set the status to TP.COMPLETING
     *     during any processing and TP.SUCCEEDED after processing is complete.
     *     The default implementation simply sets the status to TP.SUCCEEDED.
     * @param {Object} aResult An optional object to set as the result for the
     *     request.
     * @returns {TP.core.JobGroup} The receiver.
     */

    this.$performOverChildren('complete', aResult);

    //  have to check to see if we already have an failed or cancelled
    //  status since that would imply we can't reset to a success status
    if (!this.isCompleted()) {
        this.set('statusCode', TP.SUCCEEDED);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JobGroup.Inst.defineMethod('error',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method error
     * @summary Tells the receiver there was an error in job processing.
     * @description If the receiver has specific behavior to implement it should
     *     override this method, but be sure to set the status to TP.ERRORING
     *     during any processing and TP.ERRORED after processing is complete.
     *     The default implementation simply sets the status to TP.ERRORED.
     * @param {String} aFaultString A string description of the error.
     * @param {Object} aFaultCode A code providing additional information on
     *     specific nature of the error. Often an exception or Error object.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the error.
     * @returns {TP.core.JobGroup} The receiver.
     */

    this.$performOverChildren('error', aFaultString, aFaultCode, aFaultInfo);

    if (TP.isValid(aFaultCode)) {
        //  note we don't signal change here
        this.set('faultCode', aFaultCode);
    }

    if (TP.isString(aFaultString)) {
        //  note we don't signal change here
        this.set('faultText', aFaultString);
    }

    if (TP.isValid(aFaultInfo)) {
        //  note we don't signal change here
        this.set('faultInfo', aFaultInfo);
    }

    this.set('statusCode', TP.ERRORED);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JobGroup.Inst.defineMethod('fail',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method fail
     * @summary Tells the receiver to fail, meaning it failed due to some form
     *     of exception. If the receiver has specific behavior to implement it
     *     should override this method, but be sure to set the status to
     *     TP.FAILING during any processing and TP.FAILED after processing is
     *     complete. The default implementation simply sets the fault code and
     *     updates status to TP.FAILED.
     * @param {String} aFaultString A string description of the fault.
     * @param {Object} aFaultCode A code providing additional information on the
     *     reason for the failure.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the failure.
     * @returns {TP.core.JobGroup} The receiver.
     */

    this.$performOverChildren('fail', aFaultString, aFaultCode, aFaultInfo);

    if (TP.isValid(aFaultCode)) {
        //  note we don't signal change here
        this.set('faultCode', aFaultCode);
    }

    if (TP.isString(aFaultString)) {
        //  note we don't signal change here
        this.set('faultText', aFaultString);
    }

    if (TP.isValid(aFaultInfo)) {
        //  note we don't signal change here
        this.set('faultInfo', aFaultInfo);
    }

    this.set('statusCode', TP.FAILED);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JobGroup.Inst.defineMethod('getChildren',
function() {

    /**
     * @method getChildren
     * @summary Returns the child job list.
     * @returns {TP.core.JobGroup} The receiver.
     */

    var children;

    if (TP.notValid(children = this.$get('children'))) {
        children = TP.ac();
        this.$set('children', children, false);
    }

    return children;
});
//  ------------------------------------------------------------------------

TP.core.JobGroup.Inst.defineMethod('pause',
function() {

    /**
     * @method pause
     * @summary Pauses the receiver if that operation is supportable by the
     *     particular type. Not all receivers of the pause operation are able to
     *     pause effectively (XMLHttpRequest for example).
     * @returns {TP.core.JobGroup} The receiver.
     */

    return this.$performOverChildren('pause');
});

//  ------------------------------------------------------------------------

TP.core.JobGroup.Inst.defineMethod('removeChild',
function(aChild) {

    /**
     * @method removeChild
     * @summary Removes a child object implementing the TP.core.JobStatus
     *     implementation from the receiving job group.
     * @param {TP.core.JobStatus} aChild The child TP.core.JobStatus to remove
     *     from this group.
     * @returns {TP.core.JobGroup} The receiver.
     */

    var children;

    children = this.getChildren();
    children.remove(aChild, TP.IDENTITY);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JobGroup.Inst.defineMethod('reset',
function() {

    /**
     * @method reset
     * @summary Resets the receiver, returning it to its initial state.
     * @returns {TP.core.JobGroup} The receiver.
     */

    return this.$performOverChildren('reset');
});

//  ------------------------------------------------------------------------

TP.core.JobGroup.Inst.defineMethod('resume',
function() {

    /**
     * @method resume
     * @summary Resumes a paused receiver, if it was actually paused. Note that
     *     not all receivers can pause effectively and may ignore this call
     *     along with the pause() call itself.
     * @returns {TP.core.JobGroup} The receiver.
     */

    return this.$performOverChildren('resume');
});

//  ------------------------------------------------------------------------

TP.core.JobGroup.Inst.defineMethod('start',
function(parameters) {

    /**
     * @method start
     * @summary Starts the receiver in "job control" terms. This is the
     *     standard entry point method for activating a receiver relative to the
     *     job control subsystem.
     * @param {TP.core.Hash} parameters A hash of parameters the job function(s)
     *     can access.
     * @returns {TP.core.JobGroup} The receiver.
     */

    return this.$performOverChildren('start', parameters);
});

//  ------------------------------------------------------------------------

TP.core.JobGroup.Inst.defineMethod('shutdown',
function(now) {

    /**
     * @method shutdown
     * @summary Performs a clean shutdown of the receiver so it doesn't appear
     *     to have been terminated with an error or killed. This includes
     *     running the receiver's teardown/post-processing logic.
     * @description If "now" is true then any pending steps or job cycles (based
     *     on repeat count) are terminated before the teardown step.
     * @param {Boolean} now True to stop iterations and terminate now.
     * @returns {TP.core.JobGroup} The receiver.
     */

    return this.$performOverChildren('shutdown', now);
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETSyncControl.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.core.SyncAsync}
 * @summary An abstract type designed to be mixed in to other types which
 *     require support for synchronous and asynchronous mode control. Examples
 *     are TP.core.Resource and TP.uri.URI and their subtypes.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.SyncAsync');

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation.
TP.core.SyncAsync.isAbstract(true);

//  ------------------------------------------------------------------------

//  resources can handle requests either synchronously or asynchronously, or
//  both depending on the nature of the resource.
TP.core.SyncAsync.Type.defineConstant('SYNCHRONOUS', 0);
TP.core.SyncAsync.Type.defineConstant('ASYNCHRONOUS', 1);
TP.core.SyncAsync.Type.defineConstant('DUAL_MODE', 2);

//  keep a list of valid processing modes for validation checks
TP.core.SyncAsync.Type.defineConstant('MODES',
        TP.ac(
            TP.core.SyncAsync.SYNCHRONOUS,
            TP.core.SyncAsync.ASYNCHRONOUS,
            TP.core.SyncAsync.DUAL_MODE));

//  what modes does this service support? presumably we can do either in
//  most cases, but this is often overridden by non-HTTP resource types.
TP.core.SyncAsync.Type.defineAttribute('supportedModes',
                                    TP.core.SyncAsync.DUAL_MODE);

//  what mode is the default mode for this service? we default to async
//  since that's the typical way of communicating with users and servers
TP.core.SyncAsync.Type.defineAttribute('mode', TP.core.SyncAsync.ASYNCHRONOUS);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.SyncAsync.Type.defineMethod('isAsyncOnly',
function() {

    /**
     * @method isAsyncOnly
     * @summary Returns true if the receiver can't process synchronously.
     * @returns {Boolean}
     */

    return this.$get('supportedModes') === TP.core.SyncAsync.ASYNCHRONOUS;
});

//  ------------------------------------------------------------------------

TP.core.SyncAsync.Type.defineMethod('isDualMode',
function() {

    /**
     * @method isDualMode
     * @summary Returns true if the receiver can process body synchronously and
     *     asynchronously.
     * @returns {Boolean}
     */

    return this.$get('supportedModes') === TP.core.SyncAsync.DUAL_MODE;
});

//  ------------------------------------------------------------------------

TP.core.SyncAsync.Type.defineMethod('isSyncOnly',
function() {

    /**
     * @method isSyncOnly
     * @summary Returns true if the receiver can't process asynchronously.
     * @returns {Boolean}
     */

    return this.$get('supportedModes') === TP.core.SyncAsync.SYNCHRONOUS;
});

//  ------------------------------------------------------------------------

TP.core.SyncAsync.Type.defineMethod('setMode',
function(aProcessMode) {

    /**
     * @method setMode
     * @summary Sets the default processing mode (sync or async) for the
     *     receiving type. The mode must be one of those supported for the type
     *     based on the value of supportedModes.
     * @param {String} aProcessMode A TP.core.SyncAsync constant.
     * @returns {TP.meta.core.SyncAsync} The receiver.
     */

    var supported;

    //  validate mode against our list of 'approved' modes
    if (!TP.core.SyncAsync.MODES.containsString(aProcessMode)) {
        return this.raise('TP.sig.InvalidProcessMode');
    }

    //  if we're not dual mode then the mode better match the supported mode
    if ((supported = this.get('supportedModes')) !==
                                            TP.core.SyncAsync.DUAL_MODE) {
        if (aProcessMode !== supported) {
            return this.raise('TP.sig.InvalidProcessMode');
        }
    }

    return this.$set('mode', aProcessMode);
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.core.SyncAsync.Inst.defineAttribute('mode');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.SyncAsync.Inst.defineMethod('getMode',
function() {

    /**
     * @method getMode
     * @summary Returns the current default processing mode, sync or async,
     *     for the resource. If there is an instance value that is returned,
     *     otherwise any value specified for the type will be used.
     * @returns {Number} A TP.core.SyncAsync processing mode constant.
     */

    var mode;

    mode = this.$get('mode');
    if (TP.notValid(mode)) {
        mode = this.getType().get('mode');
    }

    return mode;
});

//  ------------------------------------------------------------------------

TP.core.SyncAsync.Inst.defineMethod('isSynchronous',
function() {

    /**
     * @method isSynchronous
     * @summary Returns true if the receiver can support synchronous operation.
     * @returns {Boolean}
     */

    return !this.getType().isAsyncOnly();
});

//  ------------------------------------------------------------------------

TP.core.SyncAsync.Inst.defineMethod('rewriteRequestMode',
function(aRequest) {

    /**
     * @method rewriteRequestMode
     * @summary Returns the request mode which should be used for the request.
     *     In most cases this is the value provided in the request by in some
     *     cases it's possible to have an exception thrown when the request
     *     specifies a mode that the service can't support (for example asking
     *     an async-only service to process a synchronous request.
     * @param {TP.sig.Request} aRequest The request to rewrite.
     * @exception TP.sig.InvalidProcessMode
     * @returns {Boolean} True for asynchronous (for use in the 'async'
     *     parameter).
     */

    var mode,
        async,
        uri,
        refresh;

    async = TP.ifKeyInvalid(aRequest, 'async', null);
    refresh = TP.ifKeyInvalid(aRequest, 'refresh', null);
    //  TODO: on the wrong object this will cause a nasty recursion and blow up.
    //  Figure out why.
    // uri = TP.ifKeyInvalid(aRequest, 'uri', TP.str(TP.uc(TP.str(this))));

    if (TP.notValid(async)) {
        //  One special case is that when a resource isn't being refreshed
        //  we'll be reading from the cache which can be synchronous even
        //  when the resource is inherently async. This can make things a
        //  lot cleaner for certain operations that are checking the cache.
        if (!refresh) {
            return false;
        }

        mode = this.getMode();
        switch (mode) {
            case TP.core.SyncAsync.SYNCHRONOUS:
                async = false;
                break;
            case TP.core.SyncAsync.ASYNCHRONOUS:
                async = true;
                break;
            default:
                async = false;
                break;
        }
    }

    if (this.getType().isDualMode()) {
        return async;
    }

    if (async && this.getType().isSyncOnly()) {
        TP.ifWarn() ?
            TP.warn('Overriding async request for sync-only URI: ' + uri) : 0;

        async = false;
    }

    if (!async && this.getType().isAsyncOnly()) {
        //  One special case is that when a resource isn't being refreshed
        //  we'll be reading from the cache which can be synchronous even
        //  when the resource is inherently async. This can make things a
        //  lot cleaner for certain operations that are checking the cache.
        if (!refresh) {
            return false;
        }

        TP.ifWarn() ?
            TP.warn('Overriding sync request for async-only URI: ' + uri) : 0;

        async = true;
    }

    return async;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETProxyTypes.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

//  ------------------------------------------------------------------------
//  TP.lang.Proxy
//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('Proxy');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.lang.Proxy.Inst.defineMethod('$$fault',
function() {

    /**
     * @method $$fault
     * @summary Faults in the real type for the receiver. This method has to
     *     take care not to create recursions while ensuring that once the fault
     *     operation has completed the new type is in place and registered as a
     *     global and a custom type.
     * @returns {TP.lang.RootObject} The newly loaded type object.
     */

    var name,
        type;

    //  Need to make sure to 'toString()' this to work around issues
    //  introduced in Firefox 2.0.0.2+
    name = '' + this;

    TP.ifTrace() && TP.$DEBUG && TP.$VERBOSE ?
        TP.trace('Faulting in \'' + name + '\'.') : 0;

    //  require the type, telling TIBET that we're doing this for a proxy
    type = TP.sys.require(name);

    if (!TP.isType(type)) {
        TP.ifError() ?
            TP.error('Faulting in \'' + name +
                            '\' failed. Removing proxy.') : 0;

        TP.sys.defineGlobal(name, null, true);
    }

    return type;
});

//  ------------------------------------------------------------------------

TP.lang.Proxy.Inst.defineMethod('$$isMemberOf',
function(aType) {

    /**
     * @method $$isMemberOf
     * @summary Returns true if the receiver is a direct member (instance) of
     *     the named type. This internal method is implemented on specific
     *     objects to allow them to respond more quickly to an isMemberOf query.
     *     It can also be used to "spoof" type membership (as is the case with
     *     type proxies).
     * @param {TP.lang.RootObject|String} aType A Type object, or type name.
     * @returns {Boolean} Whether or not the receiver is a direct member of the
     *     named type.
     */

    /* eslint-disable no-extra-parens */
    return (aType === 'TP.lang.Proxy' ||
            aType === TP.lang.Proxy ||
            aType === 'String' ||
            aType === String);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.lang.Proxy.Inst.defineMethod('defineSubtype',
function(name) {

    /**
     * @method defineSubtype
     * @summary Adds a new subtype to the type represented by the receiving
     *     string.
     * @param {String} name The name of the new subtype to add.
     * @returns {TP.lang.RootObject} A new type object.
     */

    var type;

    type = this.$$fault();

    if (TP.isType(type)) {
        return type.defineSubtype(name);
    }

    return this.getType().construct(name);
});

//  ------------------------------------------------------------------------

TP.lang.Proxy.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver in proper source code form.
     * @returns {String}
     */

    return this.quoted('"') + '.asType();';
});

//  ------------------------------------------------------------------------

TP.lang.Proxy.Inst.defineMethod('canConstruct',
function() {

    /**
     * @method canConstruct
     * @summary Returns true if the receiver can construct a valid instance
     *     given the parameters provided.
     * @returns {Boolean} Whether or not an instance of this can be constructed
     *     from the parameters provided.
     */

    var type;

    type = this.$$fault();

    if (TP.isType(type)) {
        return type.canConstruct.apply(type, arguments);
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.lang.Proxy.Inst.defineMethod('canResolveDNU',
function(anOrigin, aMethodName, anArgArray, callingContext) {

    /**
     * @method canResolveDNU
     * @summary Provides an instance that has triggered the DNU machinery with
     *     an opportunity to handle the problem itself. This is a useful option
     *     for objects that are acting as proxies or adaptors.
     * @param {Object} anOrigin The object asking for help.
     * @param {String} aMethodName The method name that failed.
     * @param {Object[]} anArgArray Optional arguments to function.
     * @param {Function|arguments} callingContext The calling context.
     * @returns {Boolean} TRUE means resolveDNU() will be called. FALSE means
     *     the standard DNU machinery will continue processing. The default is
     *     FALSE.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.lang.Proxy.Inst.defineMethod('construct',
function() {

    /**
     * @method construct
     * @summary Constructs a new instance. Note however that this is defined as
     *     an _instance_ method, meaning the object being messaged is actually
     *     an instance of TP.lang.Proxy that is ready to fault in the type it is
     *     proxying for and then to construct the instance via that type.
     * @returns {TP.lang.Object|undefined} Returns a new instance of the type the
     *     receiver is proxying for.
     */

    var type;

    try {
        type = this.$$fault();
    } catch (e) {
        TP.ifError() ?
            TP.error(
                TP.ec(e, TP.join('Error constructing type proxy'))) : 0;
    }

    if (TP.isType(type)) {
        return type.construct.apply(type, arguments);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.lang.Proxy.Inst.defineMethod('from',
function() {

    /**
     * @method from
     * @summary Returns a new instance of the receiver's true type, initialized
     *     from the parameter data.
     * @returns {TP.lang.Object|undefined} A new instance.
     */

    var type;

    try {
        type = this.$$fault();
    } catch (e) {
        TP.ifError() ?
            TP.error(
                TP.ec(e, TP.join('Error converting type proxy'))) : 0;
    }

    if (TP.isType(type)) {
        return type.from.apply(type, arguments);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.lang.Proxy.Inst.defineMethod('init',
function(aTypename) {

    /**
     * @method init
     * @summary Returns a new instance of the receiver, ready to replace itself
     *     as the type in question when invoked via construct(). Note that if
     *     the type already exists this method will return that type. If the
     *     type doesn't exist this method will register the receiver under that
     *     name.
     * @param {String} aTypename The typename this instance is proxying for.
     * @returns {TP.lang.Proxy} A new instance of type proxy.
     */

    var type,
        proto;

    this.callNextMethod();

    //  note the special call here where we tell getTypeByName() not to
    //  return a value if the value is a proxy
    if (TP.isType(type = TP.sys.getTypeByName(aTypename, false))) {
        return type;
    }

    //  this will construct the true instance for us as normal
    // type = this.callNextMethod();
    /* eslint-disable no-new-wrappers */
    type = new String(aTypename);
    /* eslint-enable no-new-wrappers */

    proto = TP.lang.Proxy.getInstPrototype();

    type.$$fault = proto.$$fault;
    type.$$isMemberOf = proto.$$isMemberOf;
    type.defineSubtype = proto.defineSubtype;
    type.canConstruct = proto.canConstruct;
    type.canResolveDNU = proto.canResolveDNU;
    type.construct = proto.construct;
    type.from = proto.from;
    type.isInitialized = proto.isInitialized;
    type.resolveDNU = proto.resolveDNU;
    type.asSource = proto.asSource;

    //  puts the instance where getTypeByName() will find it for other
    //  callers so that it will cause a type fault to occur on request
    TP.sys.addCustomType(aTypename, type);

    //  define the type proxy as a global so invocations of construct, from,
    //  etc will cause a type fault to occur
    TP.sys.defineGlobal(aTypename, type, true);

    return type;
});

//  ------------------------------------------------------------------------

TP.lang.Proxy.Inst.defineMethod('isInitialized',
function() {

    /**
     * @method isInitialized
     * @summary Returns true if the receiver has been initialized properly.
     * @returns {Boolean} Returns true for a proxy.
     */

    //  returning true here means the kernel will skip trying to
    //  initialize() the proxy itself
    return true;
});

//  ------------------------------------------------------------------------

TP.lang.Proxy.Inst.defineMethod('resolveDNU',
function(anOrigin, aMethodName, anArgArray, callingContext) {

    /**
     * @method resolveDNU
     * @summary Invoked by the main DNU machinery when the instance has
     *     responded TRUE to canResolveDNU() for the parameters given.
     * @param {Object} anOrigin The object asking for help.
     * @param {String} aMethodName The method name that failed.
     * @param {Object[]} anArgArray Optional arguments to function.
     * @param {Function|arguments} callingContext The calling context.
     * @returns {Object|undefined} The result of function execution.
     */

    var type;

    type = this.$$fault();

    if (TP.isType(type)) {
        return type.resolveDNU(anOrigin, aMethodName, anArgArray,
            callingContext);
    }

    return;
});

//  ------------------------------------------------------------------------
//  Proxy Initialization
//  ------------------------------------------------------------------------

TP.sys.defineMethod('initializeTypeProxies',
function() {

    /**
     * @method initializeTypeProxies
     * @summary Initializes a new instance of TP.lang.Proxy for each unloaded
     *     type found in the XML metadata for the app. These proxy instances
     *     will fault in their associated types on demand when construct() is
     *     invoked on them.
     * @returns {TP.sys} The receiver.
     */

    var proto,
        type_ids,

        len,
        i,

        id,
        type;

    if (!TP.sys.cfg('oo.$$use_proxies')) {
        return this;
    }

    proto = TP.lang.Proxy.getInstPrototype();
    type_ids = TP.sys.getCustomTypeNames();

    len = type_ids.getSize();
    for (i = 0; i < len; i++) {
        try {
            id = type_ids.at(i);
            if (TP.notValid(type = TP.sys.getTypeByName(id, false))) {
                //  important to get a true String object, not a primitive
                //  string, so we can instrument it

                /* eslint-disable no-new-wrappers */
                type = new String(id);
                /* eslint-enable no-new-wrappers */

                type.$$fault = proto.$$fault;
                type.$$isMemberOf = proto.$$isMemberOf;
                type.defineSubtype = proto.defineSubtype;
                type.canConstruct = proto.canConstruct;
                type.canResolveDNU = proto.canResolveDNU;
                type.construct = proto.construct;
                type.from = proto.from;
                type.isInitialized = proto.isInitialized;
                type.resolveDNU = proto.resolveDNU;

                TP.sys.addCustomType(id, type);

                TP.sys.defineGlobal(id, type, true);
                TP.sys.defineGlobal(id.asJSIdentifier(), type, true);
            }
        } catch (e) {
            TP.ifError() ?
                TP.error(TP.ec(e,
                    TP.join('Error initializing ', id, ' type proxy'))) : 0;
        }
    }

    TP.ifTrace() ?
        TP.trace('Initialized ' + len + ' type proxies.') : 0;

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETUnicode.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.core.Unicode}
 * @summary Container type for Unicode character class information.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.Unicode');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.core.Unicode.Type.defineConstant('BaseChar',
        '[\u0041-\u005A]|[\u0061-\u007A]|[\u00C0-\u00D6]|[\u00D8-\u00F6]|[\u00F8-\u00FF]|[\u0100-\u0131]|[\u0134-\u013E]|[\u0141-\u0148]|[\u014A-\u017E]|[\u0180-\u01C3]|[\u01CD-\u01F0]|[\u01F4-\u01F5]|[\u01FA-\u0217]|[\u0250-\u02A8]|[\u02BB-\u02C1]|\u0386|[\u0388-\u038A]|\u038C|[\u038E-\u03A1]|[\u03A3-\u03CE]|[\u03D0-\u03D6]|\u03DA|\u03DC|\u03DE|\u03E0|[\u03E2-\u03F3]|[\u0401-\u040C]|[\u040E-\u044F]|[\u0451-\u045C]|[\u045E-\u0481]|[\u0490-\u04C4]|[\u04C7-\u04C8]|[\u04CB-\u04CC]|[\u04D0-\u04EB]|[\u04EE-\u04F5]|[\u04F8-\u04F9]|[\u0531-\u0556]|\u0559|[\u0561-\u0586]|[\u05D0-\u05EA]|[\u05F0-\u05F2]|[\u0621-\u063A]|[\u0641-\u064A]|[\u0671-\u06B7]|[\u06BA-\u06BE]|[\u06C0-\u06CE]|[\u06D0-\u06D3]|\u06D5|[\u06E5-\u06E6]|[\u0905-\u0939]|\u093D|[\u0958-\u0961]|[\u0985-\u098C]|[\u098F-\u0990]|[\u0993-\u09A8]|[\u09AA-\u09B0]|\u09B2|[\u09B6-\u09B9]|[\u09DC-\u09DD]|[\u09DF-\u09E1]|[\u09F0-\u09F1]|[\u0A05-\u0A0A]|[\u0A0F-\u0A10]|[\u0A13-\u0A28]|[\u0A2A-\u0A30]|[\u0A32-\u0A33]|[\u0A35-\u0A36]|[\u0A38-\u0A39]|[\u0A59-\u0A5C]|\u0A5E|[\u0A72-\u0A74]|[\u0A85-\u0A8B]|\u0A8D|[\u0A8F-\u0A91]|[\u0A93-\u0AA8]|[\u0AAA-\u0AB0]|[\u0AB2-\u0AB3]|[\u0AB5-\u0AB9]|\u0ABD|\u0AE0|[\u0B05-\u0B0C]|[\u0B0F-\u0B10]|[\u0B13-\u0B28]|[\u0B2A-\u0B30]|[\u0B32-\u0B33]|[\u0B36-\u0B39]|\u0B3D|[\u0B5C-\u0B5D]|[\u0B5F-\u0B61]|[\u0B85-\u0B8A]|[\u0B8E-\u0B90]|[\u0B92-\u0B95]|[\u0B99-\u0B9A]|\u0B9C|[\u0B9E-\u0B9F]|[\u0BA3-\u0BA4]|[\u0BA8-\u0BAA]|[\u0BAE-\u0BB5]|[\u0BB7-\u0BB9]|[\u0C05-\u0C0C]|[\u0C0E-\u0C10]|[\u0C12-\u0C28]|[\u0C2A-\u0C33]|[\u0C35-\u0C39]|[\u0C60-\u0C61]|[\u0C85-\u0C8C]|[\u0C8E-\u0C90]|[\u0C92-\u0CA8]|[\u0CAA-\u0CB3]|[\u0CB5-\u0CB9]|\u0CDE|[\u0CE0-\u0CE1]|[\u0D05-\u0D0C]|[\u0D0E-\u0D10]|[\u0D12-\u0D28]|[\u0D2A-\u0D39]|[\u0D60-\u0D61]|[\u0E01-\u0E2E]|\u0E30|[\u0E32-\u0E33]|[\u0E40-\u0E45]|[\u0E81-\u0E82]|\u0E84|[\u0E87-\u0E88]|\u0E8A|\u0E8D|[\u0E94-\u0E97]|[\u0E99-\u0E9F]|[\u0EA1-\u0EA3]|\u0EA5|\u0EA7|[\u0EAA-\u0EAB]|[\u0EAD-\u0EAE]|\u0EB0|[\u0EB2-\u0EB3]|\u0EBD|[\u0EC0-\u0EC4]|[\u0F40-\u0F47]|[\u0F49-\u0F69]|[\u10A0-\u10C5]|[\u10D0-\u10F6]|\u1100|[\u1102-\u1103]|[\u1105-\u1107]|\u1109|[\u110B-\u110C]|[\u110E-\u1112]|\u113C|\u113E|\u1140|\u114C|\u114E|\u1150|[\u1154-\u1155]|\u1159|[\u115F-\u1161]|\u1163|\u1165|\u1167|\u1169|[\u116D-\u116E]|[\u1172-\u1173]|\u1175|\u119E|\u11A8|\u11AB|[\u11AE-\u11AF]|[\u11B7-\u11B8]|\u11BA|[\u11BC-\u11C2]|\u11EB|\u11F0|\u11F9|[\u1E00-\u1E9B]|[\u1EA0-\u1EF9]|[\u1F00-\u1F15]|[\u1F18-\u1F1D]|[\u1F20-\u1F45]|[\u1F48-\u1F4D]|[\u1F50-\u1F57]|\u1F59|\u1F5B|\u1F5D|[\u1F5F-\u1F7D]|[\u1F80-\u1FB4]|[\u1FB6-\u1FBC]|\u1FBE|[\u1FC2-\u1FC4]|[\u1FC6-\u1FCC]|[\u1FD0-\u1FD3]|[\u1FD6-\u1FDB]|[\u1FE0-\u1FEC]|[\u1FF2-\u1FF4]|[\u1FF6-\u1FFC]|\u2126|[\u212A-\u212B]|\u212E|[\u2180-\u2182]|[\u3041-\u3094]|[\u30A1-\u30FA]|[\u3105-\u312C]|[\uAC00-\uD7A3]');

TP.core.Unicode.Type.defineConstant('Ideographic',
        '[\u4E00-\u9FA5]|\u3007|[\u3021-\u3029]');

TP.core.Unicode.Type.defineConstant('Letter',
            TP.join(TP.core.Unicode.BaseChar,
                    '|',
                    TP.core.Unicode.Ideographic));

TP.core.Unicode.Type.defineConstant('CombiningChar',
        '[\u0300-\u0345]|[\u0360-\u0361]|[\u0483-\u0486]|[\u0591-\u05A1]|[\u05A3-\u05B9]|[\u05BB-\u05BD]|\u05BF|[\u05C1-\u05C2]|\u05C4|[\u064B-\u0652]|\u0670|[\u06D6-\u06DC]|[\u06DD-\u06DF]|[\u06E0-\u06E4]|[\u06E7-\u06E8]|[\u06EA-\u06ED]|[\u0901-\u0903]|\u093C|[\u093E-\u094C]|\u094D|[\u0951-\u0954]|[\u0962-\u0963]|[\u0981-\u0983]|\u09BC|\u09BE|\u09BF|[\u09C0-\u09C4]|[\u09C7-\u09C8]|[\u09CB-\u09CD]|\u09D7|[\u09E2-\u09E3]|\u0A02|\u0A3C|\u0A3E|\u0A3F|[\u0A40-\u0A42]|[\u0A47-\u0A48]|[\u0A4B-\u0A4D]|[\u0A70-\u0A71]|[\u0A81-\u0A83]|\u0ABC|[\u0ABE-\u0AC5]|[\u0AC7-\u0AC9]|[\u0ACB-\u0ACD]|[\u0B01-\u0B03]|\u0B3C|[\u0B3E-\u0B43]|[\u0B47-\u0B48]|[\u0B4B-\u0B4D]|[\u0B56-\u0B57]|[\u0B82-\u0B83]|[\u0BBE-\u0BC2]|[\u0BC6-\u0BC8]|[\u0BCA-\u0BCD]|\u0BD7|[\u0C01-\u0C03]|[\u0C3E-\u0C44]|[\u0C46-\u0C48]|[\u0C4A-\u0C4D]|[\u0C55-\u0C56]|[\u0C82-\u0C83]|[\u0CBE-\u0CC4]|[\u0CC6-\u0CC8]|[\u0CCA-\u0CCD]|[\u0CD5-\u0CD6]|[\u0D02-\u0D03]|[\u0D3E-\u0D43]|[\u0D46-\u0D48]|[\u0D4A-\u0D4D]|\u0D57|\u0E31|[\u0E34-\u0E3A]|[\u0E47-\u0E4E]|\u0EB1|[\u0EB4-\u0EB9]|[\u0EBB-\u0EBC]|[\u0EC8-\u0ECD]|[\u0F18-\u0F19]|\u0F35|\u0F37|\u0F39|\u0F3E|\u0F3F|[\u0F71-\u0F84]|[\u0F86-\u0F8B]|[\u0F90-\u0F95]|\u0F97|[\u0F99-\u0FAD]|[\u0FB1-\u0FB7]|\u0FB9|[\u20D0-\u20DC]|\u20E1|[\u302A-\u302F]|\u3099|\u309A');

TP.core.Unicode.Type.defineConstant('Digit',
        '[\u0030-\u0039]|[\u0660-\u0669]|[\u06F0-\u06F9]|[\u0966-\u096F]|[\u09E6-\u09EF]|[\u0A66-\u0A6F]|[\u0AE6-\u0AEF]|[\u0B66-\u0B6F]|[\u0BE7-\u0BEF]|[\u0C66-\u0C6F]|[\u0CE6-\u0CEF]|[\u0D66-\u0D6F]|[\u0E50-\u0E59]|[\u0ED0-\u0ED9]|[\u0F20-\u0F29]');

TP.core.Unicode.Type.defineConstant('Extender',
        '\u00B7|\u02D0|\u02D1|\u0387|\u0640|\u0E46|\u0EC6|\u3005|[\u3031-\u3035]|[\u309D-\u309E]|[\u30FC-\u30FE]');

TP.core.Unicode.Type.defineConstant('NameChar',
            TP.join(TP.core.Unicode.Letter, '|',
                    TP.core.Unicode.Digit, '|',
                    '\\.', '|',    //  . escaped due to lint check
                    ':', '|',
                    '_', '|',
                    '-', '|',
                    TP.core.Unicode.CombiningChar, '|',
                    TP.core.Unicode.Extender));

TP.core.Unicode.Type.defineConstant('Char',
        '\u0009|\u000A|\u000D|[\u0020-\uD7FF]|[\uE000-\uFFFD]');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETDevicePrimitivesPre.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
Device (keyboard, mouse, etc) support routines needed prior to
browser-specific functionality.
*/

//  ------------------------------------------------------------------------

TP.W3C_EVENT_PROPERTIES =
    /(type|target|currentTarget|eventPhase|bubbles|cancelable|timeStamp)/;

TP.EXTRA_EVENT_PROPERTIES = /(offsetX|offsetY)/;

TP.TIBET_EVENT_PROPERTIES = TP.ac(
    '$$target',
        //  '$$currentTarget',  never used
    '$$type',
    '$$timestamp',
    '$$clientX',
    '$$clientY',
    '$$clientPt',
    '$$globalPt',
    '$$offsetX',
    '$$offsetY',
    '$$offsetPt',
    '$$view',
    '$$pageX',
    '$$pageY',
    '$$pagePt',
    '$$screenX',
    '$$screenY',
    '$$screenPt',
    '$$keyCode',
    '$$altKey',
    '$$ctrlKey',
    '$$shiftKey',
        //  '$$metaKey',        never used
    '$$button',
    '$$wheelDelta',
    '$$wheelDeltaX',
    '$$wheelDeltaY',
    '$captured',
    '$normalized',
    '$notSignaled',
    '$unicodeCharCode',
    '$computedName');

TP.DOM_EVENT_PROPERTIES = TP.ac(
    'bubbles',
    'cancelable',
    'currentTarget',
    'eventPhase',
    'target',
    'timeStamp',
    'type',

    //  DOM Level 3
    'defaultPrevented',
    'isTrusted');

TP.DOM_UI_EVENT_PROPERTIES = TP.DOM_EVENT_PROPERTIES.concat(
    TP.ac(
    'detail',
    'view',

    //  Old DOM Level 0
    'layerX',
    'layerY',
    'offsetX',
    'offsetY',
    'pageX',
    'pageY'));

TP.DOM_FOCUS_EVENT_PROPERTIES = TP.DOM_UI_EVENT_PROPERTIES.concat(
    TP.ac(
    'relatedTarget'));

TP.DOM_MOUSE_EVENT_PROPERTIES = TP.DOM_UI_EVENT_PROPERTIES.concat(
    TP.ac(
    'clientX',
    'clientY',
    'screenX',
    'screenY',

    'altKey',
    'ctrlKey',
    'shiftKey',
    'metaKey',

    'button',
    'buttons',
    'relatedTarget'));

TP.DOM_WHEEL_EVENT_PROPERTIES = TP.DOM_MOUSE_EVENT_PROPERTIES.concat(
    TP.ac(
    'wheelDelta',   //  Old IE/Webkit property (Mozilla used 'detail')
    'axis',         //  Old Mozilla property

    //  DOM Level 3
    'deltaMode',

    'deltaX',
    'deltaY',
    'deltaZ'));

TP.DOM_KEY_EVENT_PROPERTIES = TP.DOM_UI_EVENT_PROPERTIES.concat(
    TP.ac(

    //  DOM Level 3
    'char',
    'key',
    'locale',
    'location',
    'repeat',

    'altKey',
    'ctrlKey',
    'metaKey',
    'shiftKey',

    //  Deprecated in DOM Level 3
    'charCode',
    'keyCode',
    'which'));

TP.DOM_MUTATION_EVENT_PROPERTIES = TP.DOM_EVENT_PROPERTIES.concat(
    TP.ac(
    'relatedNode',
    'prevValue',
    'newValue',
    'attrName',
    'attrChange'));

//  ------------------------------------------------------------------------

//  NOTE that this is duplicated in the tibet_hook.js file so if you
//  change things here you'll want to keep the other version in sync
if (TP.notValid(TP.DOM_SIGNAL_TYPE_MAP)) {
    TP.DOM_SIGNAL_TYPE_MAP = TP.hc(
        'abort', 'TP.sig.DOMAbort',
        'animationend', 'TP.sig.DOMAnimationEnd',
        'blur', 'TP.sig.DOMBlur',
        'change', 'TP.sig.DOMChange',
        'click', 'TP.sig.DOMClick',
        'copy', 'TP.sig.DOMCopy',
        'contextmenu', 'TP.sig.DOMContextMenu',
        'cut', 'TP.sig.DOMCut',
        'dblclick', 'TP.sig.DOMDblClick',
        'error', 'TP.sig.DOMError',
        'focus', 'TP.sig.DOMFocus',
        'input', 'TP.sig.DOMInput',
        'keydown', 'TP.sig.DOMKeyDown',
        'keypress', 'TP.sig.DOMKeyPress',
        'keyup', 'TP.sig.DOMKeyUp',
        'load', 'TP.sig.DOMLoad',
        'mousedown', 'TP.sig.DOMMouseDown',
        'mouseenter', 'TP.sig.DOMMouseEnter',
        'mousehover', 'TP.sig.DOMMouseHover',   //  a synthetic TIBET event
        'mouseleave', 'TP.sig.DOMMouseLeave',
        'mousemove', 'TP.sig.DOMMouseMove',
        'mouseout', 'TP.sig.DOMMouseOut',
        'mouseover', 'TP.sig.DOMMouseOver',
        'mouseup', 'TP.sig.DOMMouseUp',
        'dragdown', 'TP.sig.DOMDragDown',       //  a synthetic TIBET event
        'draghover', 'TP.sig.DOMDragHover',     //  a synthetic TIBET event
        'dragmove', 'TP.sig.DOMDragMove',       //  a synthetic TIBET event
        'dragout', 'TP.sig.DOMDragOut',         //  a synthetic TIBET event
        'dragover', 'TP.sig.DOMDragOver',       //  a synthetic TIBET event
        'dragup', 'TP.sig.DOMDragUp',           //  a synthetic TIBET event
        'move', 'TP.sig.DOMMove',
        'paste', 'TP.sig.DOMPaste',
        'reset', 'TP.sig.DOMReset',
        'resize', 'TP.sig.DOMResize',
        'scroll', 'TP.sig.DOMScroll',
        'submit', 'TP.sig.DOMSubmit',
        'transitionend', 'TP.sig.DOMTransitionEnd',
        'unload', 'TP.sig.DOMUnload');

    if (TP.sys.isUA('GECKO')) {
        TP.DOM_SIGNAL_TYPE_MAP.atPut('DOMMouseScroll',
                                        'TP.sig.DOMMouseWheel');
    }

    if (TP.sys.isUA('WEBKIT')) {
        TP.DOM_SIGNAL_TYPE_MAP.atPut('mousewheel',
                                        'TP.sig.DOMMouseWheel');
    }
}

//  A Hash containing keys/values of 'on:*' attribute names and signals that
//  will not be processed via observe/ignore in the notification system because
//  they're handled specially.
if (TP.notValid(TP.NON_OBSERVED_ON_ATTRS)) {

    //  We start with the list of DOM signals. Whether platform-supplied or a
    //  synthetic TIBET event, it doesn't matter. These are handled specially.
    TP.NON_OBSERVED_ON_ATTRS = TP.hc(TP.DOM_SIGNAL_TYPE_MAP);

    //  Then we add the signals for attach/detach. These are handled by the
    //  awakening processing phase and so don't need to be handled via
    //  observe/ignore.
    TP.NON_OBSERVED_ON_ATTRS.atPut('attach', 'TP.sig.AttachComplete');
    TP.NON_OBSERVED_ON_ATTRS.atPut('detach', 'TP.sig.DetachComplete');
}

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETDevicePrimitivesBase.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
Common mouse and keyboard functions.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('eventPreventDefault',
function(anEvent) {

    /**
     * @method eventPreventDefault
     * @summary Prevents the event's default action from occurring.
     * @param {Event} anEvent The native event object.
     * @returns {Event} The native event object.
     */

    if (!TP.isEvent(anEvent)) {
        return TP.raise(this, 'TP.sig.InvalidEvent');
    }

    anEvent.preventDefault();

    return anEvent;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventStopPropagation',
function(anEvent) {

    /**
     * @method eventStopPropagation
     * @summary Stop an event from propagating any further.
     * @param {Event} anEvent The native event object.
     * @returns {Event} The native event object.
     */

    if (!TP.isEvent(anEvent)) {
        return TP.raise(this, 'TP.sig.InvalidEvent');
    }

    anEvent.stopPropagation();

    return anEvent;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETDevicePrimitivesPlatform.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
Platform-specific functionality related to mouse and keyboard.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('eventNormalize',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(anEvent, currentTarget) {

        /**
         * @method eventNormalize
         * @summary Converts the supplied object into a 'W3C plus' event
         *     object, with the attendant W3C-compliant properties, etc. along
         *     with some additional properties, such as 'offsetX / offset Y' and
         *     'wheelDelta' for mousewheel events that are not currently defined
         *     by the W3C.
         * @param {Event} anEvent The event to convert into a 'W3C plus'
         *     compliant event object.
         * @param {HTMLElement} currentTarget The object to make the
         *     currentTarget on the Event object. If absent or null,
         *     currentTarget on the Event object defaults to the srcElement.
         * @exception TP.sig.InvalidEvent
         * @returns {Event} The supplied event object normalized into a 'W3C
         *     plus' Event object.
         */

        var wheelVal,
            deltaX,
            deltaY;

        //  If the Event object has already been normalized, then just return.
        if (anEvent.$normalized) {
            return anEvent;
        }

        //  Make sure to set $normalized here because other calls in this
        //  method may recurse and use this call.
        anEvent.$normalized = true;

        //  The event object supplied might be a 'copy' with certain special
        //  slots defined, but not their 'built-in' equivalents, which is
        //  why we sometimes go after both properties (the '$$' version and
        //  the regular version) here.

        //  Keycode is so messed up, that we always rely on the '$$'
        //  version - make sure its copied here.
        //  In case keyCode === 0, check for charCode.
        anEvent.$$keyCode = anEvent.keyCode || anEvent.charCode;

        if (anEvent.$$type === 'DOMMouseScroll' ||
            anEvent.type === 'DOMMouseScroll') {
            wheelVal = anEvent.detail;

            //  Sometimes Mozilla will supply a really large number - we
            //  clamp the value
            if (wheelVal > 100) {
                wheelVal = 3;
            } else if (wheelVal < -100) {
                wheelVal = -3;
            }

            if (anEvent.axis === anEvent.HORIZONTAL_AXIS) {
                deltaX = wheelVal;
                deltaY = 0;
            } else {
                deltaX = 0;
                deltaY = wheelVal;
            }

            anEvent.$$wheelDelta = wheelVal;
            anEvent.$$wheelDeltaX = deltaX;
            anEvent.$$wheelDeltaY = deltaY;
        }

        //  Set a few of our convenience slots
        anEvent.$$view = TP.$eventGetNormalizedView(anEvent, currentTarget);
        anEvent.$$timestamp = anEvent.timeStamp;

        return anEvent;
    },
    'webkit',
    function(anEvent, currentTarget) {

        /**
         * @method eventNormalize
         * @summary Converts the supplied object into a 'W3C plus' event
         *     object, with the attendant W3C-compliant properties, etc. along
         *     with some additional properties, such as 'offsetX / offset Y' and
         *     'wheelDelta' for mousewheel events that are not currently defined
         *     by the W3C.
         * @param {Event} anEvent The event to convert into a 'W3C plus'
         *     compliant event object.
         * @param {HTMLElement} currentTarget The object to make the
         *     currentTarget on the Event object. If absent or null,
         *     currentTarget on the Event object defaults to the srcElement.
         * @exception TP.sig.InvalidEvent
         * @returns {Event} The supplied event object normalized into a 'W3C
         *     plus' Event object.
         */

        var wheelVal,
            deltaX,
            deltaY;

        //  If the Event object has already been normalized, then just
        //  return.
        if (anEvent.$normalized) {
            return anEvent;
        }

        //  Make sure to set $normalized here because other calls in this
        //  method may recurse and use this call.
        anEvent.$normalized = true;

        //  The event object supplied might be a 'copy' with certain special
        //  slots defined, but not their 'built-in' equivalents, which is
        //  why we sometimes go after both properties (the '$$' version and
        //  the regular version) here.

        //  Keycode is so messed up, that we always rely on the '$$'
        //  version - make sure its copied here.
        anEvent.$$keyCode = anEvent.keyCode;

        if (anEvent.$$type === 'mousewheel' ||
            anEvent.type === 'mousewheel') {
            wheelVal = -anEvent.wheelDelta / 40;

            deltaX = -anEvent.wheelDeltaX / 40;
            deltaY = -anEvent.wheelDeltaY / 40;

            anEvent.$$wheelDelta = wheelVal;
            anEvent.$$wheelDeltaX = deltaX;
            anEvent.$$wheelDeltaY = deltaY;
        }

        //  Set a few of our convenience slots
        anEvent.$$view = TP.$eventGetNormalizedView(anEvent, currentTarget);
        anEvent.$$timestamp = anEvent.timeStamp;

        return anEvent;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('$eventGetNormalizedView',
function(anEvent, currentTarget) {

    /**
     * @method $eventGetNormalizedView
     * @summary Returns the native window object associated with the event. This
     *     is a lower-level routine leveraged by the eventNormalize primitive.
     * @param {Event} anEvent The event to convert into a 'W3C plus'
     *     compliant event object.
     * @param {HTMLElement} currentTarget The object to make the
     *     currentTarget on the Event object. If absent or null,
     *     currentTarget on the Event object defaults to the srcElement.
     * @returns Window The native window associated with the event.
     */

    var win;

    if (anEvent.$$view !== undefined) {
        return anEvent.$$view;
    }

    if (anEvent.view !== undefined) {
        return anEvent.view;
    }

    if (currentTarget !== undefined) {
        win = TP.nodeGetWindow(currentTarget);
        if (win !== undefined) {
            return win;
        }
    }

    if (anEvent.currentTarget !== undefined) {
        win = TP.nodeGetWindow(anEvent.currentTarget);
        if (win !== undefined) {
            return win;
        }
    }

    if (anEvent.srcElement !== undefined) {
        win = TP.nodeGetWindow(anEvent.srcElement);
    }

    return win;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETDevicePrimitivesPost.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
Common device (keyboard, mouse, etc) support routines that can be loaded
once all browser-specific device features have been included.
*/

//  ------------------------------------------------------------------------
//  EVENT NAME UTILITIES
//  ------------------------------------------------------------------------

TP.definePrimitive('$getEventNameForSignalName',
function(eventName) {

    /**
     * @method $getEventNameForSignalName
     * @summary Returns the name of the native event that maps to the TIBET
     *     event name provided.
     * @param {String} eventName An event name such as F12_Up or
     *     TP.sig.DOMKeyPress.
     * @exception TP.sig.InvalidString
     * @returns {String} The name of the native event.
     */

    var name,
        type;

    if (TP.isEmpty(eventName)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    //  Key events in particular will change their names for easier
    //  observation. For that reason we decompose them from the string.
    if (TP.regex.KEY_EVENT.test(eventName)) {
        if (TP.regex.PRESS_END.test(eventName)) {
            name = 'keypress';
        } else if (TP.regex.DOWN_END.test(eventName)) {
            name = 'keydown';
        } else if (TP.regex.UP_END.test(eventName)) {
            name = 'keyup';
        }
    } else if (TP.isType(type = eventName.asType())) {
        //  Mouse events along with most other native browser event wrappers
        //  can respond best at the type wrapper level.
        name = type.NATIVE_NAME;
    }

    return name;
});

//  ------------------------------------------------------------------------
//  MOUSE EVENT PROPERTIES
//  ------------------------------------------------------------------------

TP.definePrimitive('eventGetPropertyKeys',
function(anEvent) {

    /**
     * @method eventGetPropertyKeys
     * @summary Returns an Array containing all of the 'key names' of the
     *     supplied Event object.
     * @param {Event} anEvent The event object to return the property keys
     *     for.
     * @returns {String[]} The Array of property keys.
     */

    var type;

    type = TP.eventGetType(anEvent);

    /* eslint-disable no-fallthrough */
    switch (type) {
        //  HTML Events
        case 'change':
        case 'reset':
        case 'submit':

            return TP.DOM_EVENT_PROPERTIES;

        //  UI Events
        case 'abort':
        case 'animationend':
        case 'error':
        case 'input':
        case 'load':
        case 'resize':
        case 'scroll':
        case 'select':
        case 'transitionend':
        case 'unload':

            return TP.DOM_UI_EVENT_PROPERTIES;

        //  Focus Events
        case 'blur':
        case 'focus':
        case 'focusin':
        case 'focusout':

            return TP.DOM_FOCUS_EVENT_PROPERTIES;

        //  Key Events
        case 'keydown':
        case 'keypress':
        case 'keyup':

            return TP.DOM_KEY_EVENT_PROPERTIES;

        //  Mouse Events
        case 'click':
        case 'dblclick':
        case 'mousedown':
        case 'mouseenter':
        case 'mouseleave':
        case 'mousemove':
        case 'mouseout':
        case 'mouseover':
        case 'mouseup':

            return TP.DOM_MOUSE_EVENT_PROPERTIES;

        //  Old Mouse Wheel Events
        case 'DOMMouseScroll':
        case 'mousewheel':

        //  W3C Wheel Events
        case 'wheel':

            return TP.DOM_WHEEL_EVENT_PROPERTIES;

        //  Mutation Events
        case 'DOMAttrModified':
        case 'DOMNodeInserted':
        case 'DOMNodeRemoved':
        case 'DOMCharacterDataModified':
        case 'DOMNodeInsertedIntoDocument':
        case 'DOMNodeRemovedFromDocument':
        case 'DOMSubtreeModified':

            return TP.DOM_MUTATION_EVENT_PROPERTIES;

        default:

            return TP.DOM_EVENT_PROPERTIES;
    }
    /* eslint-enable no-fallthrough */
});

//  ------------------------------------------------------------------------
//  COMMON EVENT PROPERTIES
//  ------------------------------------------------------------------------

TP.definePrimitive('eventGetTarget',
function(anEvent) {

    /**
     * @method eventGetTarget
     * @summary Returns the object targeted by the event.
     * @param {Event} anEvent The native event.
     * @returns {Object} The targeted object, usually an element node.
     */

    var evt;

    evt = TP.eventNormalize(anEvent);

    //  Note here how we give the '$$' property precedence.
    return TP.ifInvalid(evt.$$target, evt.target);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventGetTargetDocument',
function(anEvent) {

    /**
     * @method eventGetTargetDocument
     * @summary Returns the document targeted by the event (if the target is an
     *     element).
     * @param {Event} anEvent The native event.
     * @returns {Document} The document of the targeted element.
     */

    var target;

    if (TP.isElement(target = TP.eventGetTarget(anEvent))) {
        return TP.nodeGetDocument(target);
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventGetTime',
function(anEvent) {

    /**
     * @method eventGetTime
     * @summary Returns the event time (the time the event was created in
     *     milliseconds).
     * @param {Event} anEvent The native event.
     * @returns {Number} The creation time for the event (in milliseconds since
     *     1970-01-01T00:00:00).
     */

    var evt,
        timeVal;

    evt = TP.eventNormalize(anEvent);

    //  Note here how we give the '$$' property precedence.
    timeVal = TP.ifInvalid(evt.$$timestamp, evt.timeStamp);

    if (TP.isNumber(timeVal)) {
        return timeVal;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventGetType',
function(anEvent) {

    /**
     * @method eventGetType
     * @summary Returns the event type (keydown, mouseover, etc) for the event.
     * @param {Event} anEvent The native event.
     * @returns {String} The standard event type name for the event.
     */

    var evt;

    evt = TP.eventNormalize(anEvent);

    //  Note here how we give the '$$' property precedence.
    return TP.ifInvalid(evt.$$type, evt.type);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventGetWindow',
function(anEvent) {

    /**
     * @method eventGetWindow
     * @summary Returns the window object targeted by the event.
     * @param {Event} anEvent The native event.
     * @returns {Window} The native window the event targeted.
     */

    var evt;

    evt = TP.eventNormalize(anEvent);

    //  Note here how we give the '$$' property precedence.
    return TP.ifInvalid(evt.$$view, evt.view);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventResolveTarget',
function(anEvent) {

    /**
     * @method eventResolveTarget
     * @summary Returns a 'proper target' for the supplied Event object.
     * @description This method takes a number of factors into account when
     *     computing the target element for the supplied Event:
     *     - Whether the native target is a Document
     *     - Whether the native target or any of its ancestors are disabled.
     *     - Whether the native target or any of its ancestors have a
     *     'tibet:opaque-capturing' attribute that allows them to capture a
     *     particular signal in the capture phase or 'tibet:opaque-bubbling'
     *     attribute that allows them to capture a particular signal in the
     *     bubbling phase and therefore designates them as the 'proper target'.
     * @param {Event} anEvent The event to resolve the target of.
     * @exception TP.sig.InvalidEvent
     * @returns {The} proper target for the supplied Event object.
     */

    var doc,
        focusedElems,
        focusedElem,

        target,
        signalTypeName,

        current,

        computedTarget,
        targetType,

        theSignal,

        isDisabled;

    if (!TP.isEvent(anEvent)) {
        return TP.raise(this, 'TP.sig.InvalidEvent');
    }

    //  If the event is a type of 'key' event of some sort, then using the
    //  event's 'target' as the 'starting point' is insufficient. The reason is
    //  that, at least on the Chrome browser platforms, key events will only be
    //  dispatched to those elements that hold the *native* browser focus (i.e.
    //  that match the '.activeElement') - not the one that TIBET considers to
    //  be focused. Therefore, we need to obtain the focused element as TIBET
    //  sees it and use that.

    if (TP.regex.KEY_EVENT.test(TP.eventGetType(anEvent))) {

        //  Grab the target document and the focused element *as TIBET sees it*.
        doc = TP.eventGetTargetDocument(anEvent);

        //  NB: We don't use TP.documentGetFocusedElement here since that method
        //  contains checks for multiple elements, etc., that we don't care
        //  about here.

        //  We query directly using the TIBETan way to find the element that
        //  currently has focus. Note that since we don't autocollapsed
        focusedElems = TP.byCSSPath('*[pclass|focus]', doc, false, false);

        //  Since focusing operations are *not* guaranteed by the browser to be
        //  'in order', we might have more than one element that has the
        //  'pclass:focus' attribute on it. In that case, we use the focus stack
        //  and grab its last (i.e. most recently focused element) entry.
        if (focusedElems.getSize() > 1) {
            //  NB: The focus stack stores wrapped elements, but we want the
            //  native one.
            focusedElem = TP.unwrap(TP.$focus_stack.last());
        } else {
            focusedElem = focusedElems.first();
        }

        //  If the focused element isn't the same as the target document's
        //  '.activeElement', then use the focused element as the target.
        if (focusedElem !== doc.activeElement) {
            target = focusedElem;
        }
    }

    if (TP.notValid(target)) {
        target = TP.eventGetTarget(anEvent);
    }

    //  Sometimes IE will return a target that is not a Node. Can't go any
    //  further if that happens.
    if (!TP.isNode(target)) {
        return null;
    }

    //  If the event target is a Document node, then just return that, since no
    //  traversal makes sense.
    if (target.nodeType === Node.DOCUMENT_NODE) {
        return target;
    } else if (TP.isTextNode(target)) {
        //  text nodes aren't useful targets but some browsers like to report
        //  them as the target/srcElement (even when they're not really an
        //  element). We adjust for that here.
        target = TP.ifInvalid(target.parentNode, target);
    }

    //  Make sure that it's a DOM signal that TIBET can handle.
    signalTypeName = TP.DOM_SIGNAL_TYPE_MAP.at(TP.eventGetType(anEvent));
    if (TP.notValid(signalTypeName)) {
        return target;
    }

    //  Starting at the target, traverse up the parent chain to the Document
    //  node (or the nearest DocumentFragment node).
    current = target;

    //  Make sure to skip over Node.TEXT_NODE nodes.
    if (!TP.isElement(current)) {
        current = current.parentNode;
    }

    theSignal = TP.wrap(anEvent);

    while (current &&
            current.nodeType !== Node.DOCUMENT_NODE &&
            current.nodeType !== Node.DOCUMENT_FRAGMENT_NODE) {

        isDisabled =
            TP.elementHasAttribute(current, 'disabled', true) ||
            TP.elementHasAttribute(current, 'pclass:disabled', true);

        //  If the element at this level is 'disabled', then nothing we do here
        //  matters, so we bail out returning null.
        if (isDisabled) {
            return null;
        }

        //  unless we found a capturing container we keep searching until we run
        //  out of options or run into a disabled element.
        if (TP.notValid(computedTarget)) {

            //  Grab the TIBET wrapper type for the element and query it to see
            //  if the current element should capture the event at it's level.
            if (TP.isType(targetType =
                            TP.dom.ElementNode.getConcreteType(current))) {
                if (targetType.isOpaqueCapturerFor(current, theSignal)) {
                    //  set computedTarget to the current, but NOTE NO BREAK
                    //  here so the iteration will continue up the tree until
                    //  we're sure we're not under a disabled element.
                    computedTarget = current;
                }
            }
        }

        //  Notice how we do *not* break out of this loop so that if any parent
        //  is disabled, we will still return null
        current = current.parentNode;
    }

    //  If we couldn't compute a target element, then go ahead and return the
    //  'original' (unless it was a Node.TEXT_NODE) event target, since we
    //  couldn't find any elements that had the attribute we were searching for.
    //  This allows a nice defaulting behavior when we're in a page (or DOM
    //  section) that's not using the 'tibet:opaque-capturing' or
    //  'tibet:opaque-bubbling' attribute and doesn't care.
    return computedTarget || target;
});

//  ------------------------------------------------------------------------
//  KEYBOARD EVENT PROPERTIES
//  ------------------------------------------------------------------------

TP.definePrimitive('eventGetAltKey',
function(anEvent) {

    /**
     * @method eventGetAltKey
     * @summary Returns true if the event included the Alt key or has had the
     *     Alt key simulated.
     * @param {Event} anEvent The native event.
     * @returns {Boolean} True if the event included the Alt key.
     */

    var evt;

    evt = TP.eventNormalize(anEvent);

    //  Note here how we give the '$$' property precedence.
    return TP.ifInvalid(evt.$$altKey, evt.altKey);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventGetKeyCode',
function(anEvent) {

    /**
     * @method eventGetKeyCode
     * @summary Returns the key code for the event after ensuring that it has
     *     been adjusted for cross-browser issues (generally, TIBET normalizes
     *     to the key code sent on 'key down').
     * @description In general, you should not use key codes, but instead use
     *     the 'getVirtualKeyName()' method of the TP.core.Keyboard type and
     *     test the result of that method against one of the key identifier
     *     names defined by the W3C (i.e. 'Enter' or 'Spacebar').
     * @param {Event} anEvent The native event.
     * @returns {Number} The key code for the event.
     */

    var evt;

    evt = TP.eventNormalize(anEvent);

    //  Note here how we ONLY report the '$$' property - it's adjusted by TIBET
    //  to account for cross-browser issues.
    return evt.$$keyCode;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventGetCtrlKey',
function(anEvent) {

    /**
     * @method eventGetCtrlKey
     * @summary Returns true if the event included the Ctrl key or has had the
     *     Ctrl key simulated.
     * @param {Event} anEvent The native event.
     * @returns {Boolean} True if the event included the Ctrl key.
     */

    var evt;

    evt = TP.eventNormalize(anEvent);

    //  Note here how we give the '$$' property precedence.
    return TP.ifInvalid(evt.$$ctrlKey, evt.ctrlKey);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventGetMetaKey',
function(anEvent) {

    /**
     * @method eventGetMetaKey
     * @summary Returns true if the event included the Meta key or has had the
     *     Meta key simulated.
     * @param {Event} anEvent The native event.
     * @returns {Boolean} True if the event included the Meta key.
     */

    var evt;

    evt = TP.eventNormalize(anEvent);

    //  Note here how we give the '$$' property precedence.
    return TP.ifInvalid(evt.$$metaKey, evt.metaKey);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventGetShiftKey',
function(anEvent) {

    /**
     * @method eventGetShiftKey
     * @summary Returns true if the event included the Shift key or has had the
     *     Shift key simulated.
     * @param {Event} anEvent The native event.
     * @returns {Boolean} True if the event included the Shift key.
     */

    var evt;

    evt = TP.eventNormalize(anEvent);

    //  Note here how we give the '$$' property precedence.
    return TP.ifInvalid(evt.$$shiftKey, evt.shiftKey);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventGetUnicodeCharCode',
function(anEvent) {

    /**
     * @method eventGetUnicodeCharCode
     * @summary Returns the Unicode character code for the supplied event.
     * @description In general, you should not use Unicode character codes, but
     *     instead use the 'getVirtualKeyName()' method of the TP.core.Keyboard
     *     type and test the result of that method against one of the key
     *     identifier names defined by the W3C (i.e. 'Enter' or 'Spacebar').
     *     However, there are times when the W3C hasn't defined a virtual key
     *     name, so the Unicode character code can be useful. Note that this
     *     method will report these in the following format: 'U0062' (i.e. the
     *     'b' key).
     * @param {Event} anEvent The native event.
     * @returns {String} The Unicode character code for the event.
     */

    var evt,
        retVal;

    evt = TP.eventNormalize(anEvent);

    //  If the Unicode character value hasn't been populated by the
    //  TP.core.Keyboard type, then try to derive it by converting the key code.
    if (TP.notValid(retVal = evt.$unicodeCharCode)) {
        if (!TP.isString(retVal = String.fromCharCode(
                                            TP.eventGetKeyCode(evt)))) {
            return null;
        }

        //  Get the code as a 'Unicode literal' and replace the '\u' with 'U'.
        retVal = retVal.asUnicodeLiteral().replace('\\u', 'U');
    }

    return retVal;
});

//  ------------------------------------------------------------------------
//  MOUSE EVENT PROPERTIES
//  ------------------------------------------------------------------------

TP.definePrimitive('eventGetButton',
function(anEvent) {

    /**
     * @method eventGetButton
     * @summary Returns the button code for the supplied event, which is one of
     *     the following constants: TP.LEFT, TP.MIDDLE, or TP.RIGHT.
     * @param {Event} anEvent The event object to extract the button code from.
     * @returns {String} The button code extracted from the supplied Event
     *     object.
     */

    var evt,
        button;

    evt = TP.eventNormalize(anEvent);

    //  Note here how we give the '$$' property precedence.
    button = TP.ifInvalid(evt.$$button, evt.button);

    switch (button) {
        case 0:
            return TP.LEFT;

        case 1:
            return TP.MIDDLE;

        case 2:
            return TP.RIGHT;

        case 4:
        default:
            break;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventGetClientXY',
function(anEvent) {

    /**
     * @method eventGetClientXY
     * @summary Returns the window X,Y coordinate pair for the event.
     * @param {Event} anEvent The native event.
     * @returns {Number[]} An array of (window X, window Y).
     */

    var evt,
        coord;

    evt = TP.eventNormalize(anEvent);

    //  Note here how we give the '$$' property precedence.
    coord = TP.ac(TP.ifInvalid(evt.$$clientX, evt.clientX),
                    TP.ifInvalid(evt.$$clientY, evt.clientY));

    return coord;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventGetOffsetXY',
function(anEvent) {

    /**
     * @method eventGetOffsetXY
     * @summary Returns the containing element X,Y coordinate pair for the
     *     event.
     * @param {Event} anEvent The native event.
     * @returns {Number[]} An array of (containing element X, containing element
     *     Y).
     */

    var evt,
        coord;

    evt = TP.eventNormalize(anEvent);

    //  Note here how we give the '$$' property precedence.
    coord = TP.ac(TP.ifInvalid(evt.$$offsetX, evt.offsetX),
                    TP.ifInvalid(evt.$$offsetY, evt.offsetY));

    return coord;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventGetPageXY',
function(anEvent) {

    /**
     * @method eventGetPageXY
     * @summary Returns the document X,Y coordinate pair for the event. This
     *     allows all events to be tracked relative to a common origin.
     * @param {Event} anEvent The native event.
     * @returns {Number[]} An array of (document X, document Y).
     */

    var evt,
        coord;

    evt = TP.eventNormalize(anEvent);

    //  Note here how we give the '$$' property precedence.
    coord = TP.ac(TP.ifInvalid(evt.$$pageX, evt.pageX),
                    TP.ifInvalid(evt.$$pageY, evt.pageY));

    return coord;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventGetRelatedTarget',
function(anEvent) {

    /**
     * @method eventGetRelatedTarget
     * @summary Returns the 'related target', the last element the event was
     *     over. NOTE that this is typically only relevant for the mouse events
     *     mouseover and mouseout.
     * @param {Event} anEvent The native event to query.
     * @returns {Element} The last element the mouse was over.
     */

    var evt;

    evt = TP.eventNormalize(anEvent);

    //  Note here how we give the '$$' property precedence.
    return TP.ifInvalid(evt.$$relatedTarget, evt.relatedTarget);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventGetResolvedTarget',
function(anEvent) {

    /**
     * @method eventGetResolvedTarget
     * @summary Returns the 'resolved target', the element that was resolved
     *     using the 'resolvedTarget' getter instrumented onto Event.prototype
     *     in the hook file. That getter method uses TP.eventResolveTarget().
     *     See that method for more information.
     * @param {Event} anEvent The native event to query.
     * @returns {Element} The 'resolved target' of the event.
     */

    var evt,
        target;

    evt = TP.eventNormalize(anEvent);

    target = TP.eventGetTarget(evt);

    //  If there is no resolved target and the target is the Window, then we
    //  resolve the target to the window's document documentElement. This
    //  normalizes top-level events (like resize) so that users can subscribe
    //  for these events on the document or document element.
    if (!TP.isElement(evt.resolvedTarget) && TP.isWindow(target)) {
        return target.document.documentElement;
    }

    //  Note that we don't have a '$$' property for this property
    return evt.resolvedTarget;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventGetScreenXY',
function(anEvent) {

    /**
     * @method eventGetScreenXY
     * @summary Returns the screen X,Y coordinate pair for the event. This
     *     allows all events to be tracked relative to a common origin.
     * @param {Event} anEvent The native event.
     * @returns {Number[]} An array of (screen X, screen Y).
     */

    var evt,
        coord;

    evt = TP.eventNormalize(anEvent);

    //  Note here how we give the '$$' property precedence.
    coord = TP.ac(TP.ifInvalid(evt.$$screenX, evt.screenX),
                    TP.ifInvalid(evt.$$screenY, evt.screenY));

    return coord;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventGetWheelDelta',
function(anEvent) {

    /**
     * @method eventGetWheelDelta
     * @summary Returns the wheel delta value from the event provided. The
     *     event should have been either a DOMMouseScroll or mousewheel event
     *     depending on the platform in question.
     * @param {Event} anEvent The native mouse event.
     * @returns {Number} The delta. Positive is down, negative is up.
     */

    var evt;

    evt = TP.eventNormalize(anEvent);

    //  Note here how we give the '$$' property precedence.
    return TP.ifInvalid(evt.$$wheelDelta, evt.wheelDelta);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventSetType',
function(anEvent, aType) {

    /**
     * @method eventSetType
     * @summary Sets the 'event type'. This allows the underlying event type to
     *     be set to one of TIBET's 'fake event' types.
     * @param {Event} anEvent The native event.
     * @param {String} aType An event type.
     */

    var evt;

    evt = TP.eventNormalize(anEvent);
    evt.$$type = aType;

    return;
});

//  ------------------------------------------------------------------------
//  EVENT TESTING
//  ------------------------------------------------------------------------

TP.definePrimitive('eventIsDuplicate',
function(eventOne, eventTwo) {

    /**
     * @method eventIsDuplicate
     * @summary Returns true if the two events appear to be duplicates. This
     *     test takes into account not only the native event slots but any slots
     *     which TIBET may have placed on the event.
     * @param {Event} eventOne The first event to compare.
     * @param {Event} eventTwo The second event to compare.
     * @returns {Boolean} True when the events have common property values.
     */

    var type,
        evOne,
        evTwo,

        list,
        len,
        i,
        key;

    //  need real events to compare, otherwise presume false
    if (TP.notValid(eventOne) || TP.notValid(eventTwo)) {
        return false;
    }

    //  allow for signals wrapping events to be passed here as well
    evOne = TP.isEvent(eventOne) ? eventOne : eventOne.get('event');
    evTwo = TP.isEvent(eventTwo) ? eventTwo : eventTwo.get('event');

    //  still need two event objects to compare, if not presume false
    if (!TP.isEvent(evOne) || !TP.isEvent(evTwo)) {
        return false;
    }

    //  event types obviously have to match so that's a good first test
    type = evOne.type;
    if (type !== evTwo.type) {
        return false;
    }

    //  what we compare next depends on the nature of the event and what
    //  data is relevant
    switch (type) {
        case 'keypress':
        case 'keydown':
        case 'keyup':
            return evOne.keyCode === evTwo.keyCode &&
                    evOne.charCode === evTwo.charCode &&
                    evOne.which === evTwo.which &&
                    evOne.shiftKey === evTwo.shiftKey &&
                    evOne.ctrlKey === evTwo.ctrlKey &&
                    evOne.altKey === evTwo.altKey &&
                    evOne.metaKey === evTwo.metaKey;

        default:

            //  first confirm standard properties match up
            list = TP.eventGetPropertyKeys(evOne);

            len = list.getSize();

            for (i = 0; i < len; i++) {
                key = list[i];
                if (evOne[key] !== evTwo[key]) {
                    return false;
                }
            }

            //  make sure any TIBET property overrides also match
            list = TP.TIBET_EVENT_PROPERTIES;
            len = list.getSize();

            for (i = 0; i < len; i++) {
                key = list[i];
                if (evOne[key] !== evTwo[key]) {
                    return false;
                }
            }

            return true;
    }
});

//  ------------------------------------------------------------------------
//  EVENT DISPATCHING
//  ------------------------------------------------------------------------

/*
Support routines around DOM events and the extensions TIBET makes to handle
keyboard events more effectively.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('dispatch',
function(anOrigin, aSignal, anElement, anEventOrHash, aPolicy, isCancelable,
         isBubbling) {

    /**
     * @method dispatch
     * @summary Signals an event, typically one originating from a UI or DOM
     *     element.
     * @param {Object|String} anOrigin An origin or ID to signal from. Often
     *     null in the UI which means the context or event data will be used to
     *     acquire an ID to signal from.
     * @param {String|TP.sig.Signal} aSignal The signal or signal name to
     *     signal, again often null so it defaults to the signal type matching
     *     the event name.
     * @param {Element} anElement Usually set to 'this' in an on* method to
     *     provide the originating context object.
     * @param {Event|TP.core.Hash} anEventOrHash The native Event object or
     *     other signal args in a hash.
     * @param {Object} aPolicy A standard signal policy name or definition.
     *     Defaults to TP.INHERITANCE_FIRING unless the signal has a default
     *     firing policy.
     * @param {Boolean} isCancelable Optional boolean for whether the signal is
     *     cancelable.
     * @param {Boolean} isBubbling Optional flag for whether this signal should
     *     bubble.
     * @returns {TP.sig.Signal} The signal instance used.
     */

    var argsOrEvent,

        localID,
        globalID,

        origin,

        signame,
        typename,

        policy,
        type,
        defaultType,
        context,

        thrownSignal;

    //  copy of the args we can manipulate as needed
    argsOrEvent = anEventOrHash;

    //  origin can be provided or null, in which case we look to see if we got
    //  an element or document that can provide the origin data
    if (TP.isEmpty(anOrigin)) {
        if (TP.isElement(anElement) || TP.isDocument(anElement)) {
            localID = TP.lid(anElement, true);
            globalID = TP.gid(anElement);
        }
    } else if (TP.isElement(anOrigin)) {
        //  we'll force IDs onto elements when they don't have them
        localID = TP.lid(anOrigin, true);
        globalID = TP.gid(anOrigin);
    } else if (!TP.isString(anOrigin)) {
        localID = TP.lid(anOrigin);
        globalID = TP.gid(anOrigin);
    } else {
        if (TP.regex.ELEMENT_ID.test(anOrigin)) {
            localID = anOrigin.slice(anOrigin.lastIndexOf('#') + 1);
        } else {
            localID = anOrigin;
        }

        globalID = anOrigin;
    }

    if (TP.isElement(anOrigin)) {
        origin = anOrigin;
    } else {
        //  for tibet purposes we always want to use fullname origins to ensure
        //  proper lookups that can cross frame references
        origin = globalID;
    }

    //  the signal can be provided as a String or as a TP.sig.Signal or can
    //  be null, in which case we default to the UI signal name which maps
    //  to the event type provided
    if (TP.notValid(aSignal) && TP.isEvent(argsOrEvent)) {
        //  not provided - use the native event to look up a signal name
        signame = TP.DOM_SIGNAL_TYPE_MAP.at(argsOrEvent.type);
    } else if (TP.isString(aSignal)) {
        //  it's a String - if it's a real signal type, make sure its the
        //  'full signal name'. Otherwise, if its a spoofed signal, leave it
        //  alone
        if (TP.notEmpty(typename = TP.expandSignalName(aSignal)) &&
            TP.isType(TP.sys.getTypeByName(typename))) {
            signame = typename;
        } else {
            signame = aSignal;
        }
    } else if (TP.isKindOf(aSignal, TP.sig.Signal)) {
        //  it's a TP.sig.Signal
        signame = aSignal.getSignalName();
    } else {
        //  Couldn't compute a name
        //  TODO: Raise an exception?
        return null;
    }

    //  default the policy based on some simple checks
    if (TP.notValid(policy = aPolicy)) {
        if (TP.isString(signame)) {
            if (TP.isType(type = TP.sys.getTypeByName(signame))) {
                policy = type.getDefaultPolicy();
            } else {
                //  semantic events tend to be more focused and we treat
                //  those as inheritance-based signals
                policy = TP.INHERITANCE_FIRING;
            }
        } else {
            //  no signame, so origins are what is interesting
            policy = TP.DOM_FIRING;
        }
    }

    //  try to make sure we use the right dispatch context
    if (TP.isElement(anElement)) {
        context = TP.nodeGetWindow(anElement);
    }

    if (TP.notValid(context)) {
        context = TP.ifInvalid(
                        TP.sys.getWindowById(TP.sys.getUICanvasName()),
                        window);
    }

    //  If its a native event we ensure that we handle any low-level UI
    //  hooks. To do this we take our computed data to this point and use it
    //  with the low-level TP.boot.$$dispatch() call
    if (TP.isEvent(argsOrEvent)) {
        context.TP.boot.$$dispatch(anOrigin, signame, anElement,
                                    anEventOrHash, aPolicy, false);
    }

    //  If we're going to be doing DOM firing we need to get the origin
    //  converted into an origin set for the DOM "V". we'll also want to
    //  ensure we tell the notification system to use TP.sig.DOMSignal so we
    //  get proper capture/bubble resolution.
    if (policy === TP.DOM_FIRING && TP.isElement(anElement)) {
        //  The return value of TP.elementGetEventOrigins() is configured to
        //  return an origin set.
        origin = TP.elementGetEventOrigins(anElement, argsOrEvent);

        defaultType = 'TP.sig.DOMSignal';
    }

    //  next we try to configure the argument data as much as possible to
    //  pass data about the event along
    if (TP.notValid(argsOrEvent)) {
        argsOrEvent = TP.hc();
    }

    //  place the current event data where it can be found on either the
    //  args or event, depending on what we got handed (or we created).
    if (TP.canInvoke(argsOrEvent, 'atPut')) {
        argsOrEvent.atPut('elementGlobalID', globalID);
        argsOrEvent.atPut('elementLocalID', localID);

        //  Use the 'TIBET shadow version' of the W3C compliant property
        //  here.
        argsOrEvent.atPut('$$view', context);
    } else {
        //  if not a collection, we can still place slots on in some cases,
        //  but we have to trap any exceptions here
        try {
            argsOrEvent.elementGlobalID = globalID;
            argsOrEvent.elementLocalID = localID;

            //  Use the 'TIBET shadow version' of the W3C compliant property
            //  here.
            argsOrEvent.$$view = context;
        } catch (e) {
            TP.ifError() ?
                TP.error(TP.ec(e, 'Error instrumenting event object.')) : 0;
        }
    }

    //  dispatch the signal and hold on to the returned signal instance so
    //  we can manage our return value properly

    //  Note that if the supplied signal was a TP.sig.Signal, we pass that
    //  along here - otherwise we pass the signal name we computed earlier.
    thrownSignal = TP.signal(
                    origin,
                    TP.isKindOf(aSignal, TP.sig.Signal) ? aSignal : signame,
                    argsOrEvent,
                    policy,
                    defaultType,
                    isCancelable,
                    isBubbling);

    return thrownSignal;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$dispatchEventToTIBET',
function(nativeEvt) {

    /**
     * @method $dispatchEventToTIBET
     * @summary The handler that all elements instrumented to fire events are
     *     instrumented with. NOTE that you typically don't need to arm
     *     elements, TIBET handles most things automatically.
     * @description This handler performs the following steps: 1) Processes the
     *     native event data into an object hash, registering it under commonly
     *     known keys that TIBET is expecting. 2) Computes the parent ID array
     *     for the element, if it isn't already available on the element and
     *     caches its value on the element for future use. 3) Computes the
     *     absolute path ID array for the element, if it isn't already available
     *     on the element and caches its value on the element for future use. 4)
     *     Calls the TIBET signaling framework, using the UISignal name that was
     *     mapped to the native event name, a null context, the TP.DOM_FIRING
     *     policy (to get DOM Level 2-like capturing / bubbling behavior), and
     *     the object hash containing the information extracted from the native
     *     event.
     * @param {The} nativeEvt 'native' event that just got fired from the
     *     browser.
     * @exception TP.sig.InvalidEvent
     */

    //  used for defining the event name and default supertype,
    //  particularly for DOM keyboard events
    var eventName,
        eventSuper,

        evtInfo,

        sourceElement,
        sourceWindow,

        currentElement,
        localID,
        globalID,

        fullTargetArray,

        firingPolicy;

    if (!TP.isEvent(nativeEvt)) {
        return TP.raise(this, 'TP.sig.InvalidEvent');
    }

    //  Get the native event's target
    sourceElement = TP.eventGetTarget(nativeEvt);

    //  Get the source element's window
    sourceWindow = TP.nodeGetWindow(sourceElement);

    //  define the base event name we'll be signaling. this will be
    //  something like DOMKeyPress etc.
    eventName = TP.DOM_SIGNAL_TYPE_MAP.at(nativeEvt.type);

    //  key and mouse events are sent directly to their respective device
    //  objects in the rare occasions when this handler is triggered.
    if (nativeEvt.type.indexOf('key') === 0) {
        return TP.sys.getTypeByName('TP.core.Keyboard').$$handleKeyEvent(
                                                                nativeEvt);
    } else if (nativeEvt.type.indexOf('mouse') === 0) {
        return TP.sys.getTypeByName('TP.core.Mouse').$$handleMouseEvent(
                                                                nativeEvt);
    }

    //  cancel the native browser event handling here, because TIBET is
    //  going to do all bubbling/capturing from here
    TP.eventStopPropagation(nativeEvt);

    //  If the nodeType of the source element is a Node.TEXT_NODE node, then
    //  it won't have an id and its parent should be treated as the source
    //  element. Therefore, if it has a parent node, set the source element to
    //  be that.
    if (TP.isTextNode(sourceElement)) {
        if (TP.notValid(sourceElement = sourceElement.parentNode)) {
            sourceElement = sourceWindow.document;
        }
    }

    //  Get the element that we're currently processing event handlers for.
    currentElement = nativeEvt.currentTarget;

    //  If the sourceElement doesn't have an id and its not the document,
    //  then we use the current element as the source element. E.g. Assume
    //  that a 'tr' has been instrumented for 'mousedown' events, but a
    //  mousedown has occurred in a 'td' (which does not have an id). The
    //  sourceElement is the 'td'. The event has bubbled up to the 'tr'
    //  (which does have an id). The currentElement is the 'tr'. Since the
    //  'td' doesn't have an id, we can't use it as the origin of the
    //  signal. Therefore, we treat the 'tr' as an 'opaque node' and signal
    //  as if the event came from the 'tr'.
    if (TP.isEmpty(sourceElement.id) &&
        sourceElement !== sourceWindow.document) {
        sourceElement = currentElement;
    }

    //  Looks like we're going to signal it so we need names
    localID = TP.lid(sourceElement, true);
    globalID = TP.gid(sourceElement, true);

    evtInfo = TP.hc('elementLocalID', localID,
                    'elementGlobalID', globalID);

    //  If we have a valid firing policy, use that policy to fire the signal
    if (TP.isValid(firingPolicy = sourceElement.firingPolicy) &&
        firingPolicy !== TP.DOM_FIRING) {
        TP.ifTrace() && TP.sys.shouldLogSignals() ?
            TP.trace('Sending ' + eventName +
                        ' to TIBET with supertype ' + eventSuper,
                        TP.SIGNAL_LOG) : 0;

        //  Its not TP.DOM_FIRING, so we send the globalID only
        TP.signal(globalID,
                    eventName,
                    null,
                    evtInfo,
                    sourceElement.firingPolicy,
                    eventSuper);
    } else {
        TP.ifTrace() && TP.sys.shouldLogSignals() ?
            TP.trace('Sending ' + eventName +
                        ' to TIBET with supertype ' + eventSuper,
                        TP.SIGNAL_LOG) : 0;

        //  It is TP.DOM_FIRING, so we send the list of IDs
        fullTargetArray = TP.elementGetEventOrigins(sourceElement, evtInfo);

        TP.signal(fullTargetArray,
                    eventName,
                    null,
                    evtInfo,
                    TP.DOM_FIRING,
                    eventSuper);
    }

    return;
});

//  ------------------------------------------------------------------------
//  Low-level handlers
//  ------------------------------------------------------------------------

TP.definePrimitive('$$handleAnimationEnd',
function(anEvent) {

    /**
     * @method $$handleAnimationEnd
     * @summary Document-level animationend handler, installed by tibet_hook.
     * @param {Event} anEvent The native event object.
     */

    return TP.$$handleNonKeyOrMouseEvent(anEvent);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$$handleBlur',
function(anEvent) {

    /**
     * @method $$handleBlur
     * @summary Document-level blur handler, installed by tibet_hook.
     * @param {Event} anEvent The native event object.
     */

    return TP.$$handleNonKeyOrMouseEvent(anEvent);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$$handleChange',
function(anEvent) {

    /**
     * @method $$handleChange
     * @summary Document-level change handler, installed by tibet_hook.
     * @param {Event} anEvent The native event object.
     */

    return TP.$$handleNonKeyOrMouseEvent(anEvent);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$$handleCopy',
function(anEvent) {

    /**
     * @method $$handleCopy
     * @summary Document-level copy handler, installed by tibet_hook.
     * @param {Event} anEvent The native event object.
     */

    return TP.$$handleNonKeyOrMouseEvent(anEvent);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$$handleCut',
function(anEvent) {

    /**
     * @method $$handleCut
     * @summary Document-level cut handler, installed by tibet_hook.
     * @param {Event} anEvent The native event object.
     */

    return TP.$$handleNonKeyOrMouseEvent(anEvent);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$$handleFocus',
function(anEvent) {

    /**
     * @method $$handleFocus
     * @summary Document-level focus handler, installed by tibet_hook.
     * @param {Event} anEvent The native event object.
     */

    return TP.$$handleNonKeyOrMouseEvent(anEvent);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$$handleInput',
function(anEvent) {

    /**
     * @method $$handleInput
     * @summary Document-level input handler, installed by tibet_hook.
     * @param {Event} anEvent The native event object.
     */

    return TP.$$handleNonKeyOrMouseEvent(anEvent);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$$handleNonKeyOrMouseEvent',
function(anEvent) {

    /**
     * @method $$handleNonKeyOrMouseEvent
     * @summary Handles a 'non keyboard or mouse' native event by signaling it
     *     both along the responder chain for UI* signals and dispatching it
     *     along the DOM 'V' for DOM* signals.
     * @param {Event} anEvent The native event object.
     */

    var ev,

        targetNode,

        fname,
        elemType,

        sigName;

    if (anEvent.$captured) {
        return;
    }
    anEvent.$captured = true;

    //  normalize the event
    ev = TP.event(anEvent);

    //  If TIBET shouldn't handle the event, then we return here. Note that this
    //  will still allow other third-party libraries to trap and process events.
    if (TP.isFalse(TP.targetShouldHandleEvent(ev))) {
        return this;
    }

    //  Get a resolved event target, given the event. This takes into
    //  account disabled elements and will look for a target element
    //  with the appropriate 'enabling attribute', if possible.
    targetNode = TP.eventGetResolvedTarget(anEvent);
    if (TP.notValid(targetNode)) {
        targetNode = TP.eventGetTarget(anEvent);
    }

    if (TP.isElement(targetNode) || TP.isDocument(targetNode)) {
        fname = 'on' + TP.eventGetType(anEvent);

        elemType = TP.wrap(targetNode).getType();

        //  Message the type for the element that is 'responsible' for this
        //  event. It's native control sent this event and we need to let
        //  the type know about it.
        if (TP.canInvoke(elemType, fname)) {
            elemType[fname](targetNode, anEvent);
        }

        //  If the native event was prevented, then we should just bail out
        //  here.
        //  NB: 'defaultPrevented' is a DOM Level 3 property, which seems to
        //  be well supported on TIBET's target browser environments.
        if (anEvent.defaultPrevented === true) {
            return;
        }

        sigName = TP.DOM_SIGNAL_TYPE_MAP.at(TP.eventGetType(anEvent));

        //  Dispatch the signal
        TP.dispatch(
                null,   //  'V' will be computed from targetNode
                TP.sys.getTypeByName(sigName).construct(anEvent, true),
                targetNode,
                anEvent,
                TP.DOM_FIRING);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$$handleLoad',
function(anEvent) {

    /**
     * @method $$handleLoad
     * @summary Document-level load handler, installed by tibet_hook.
     * @param {Event} anEvent The native event object.
     */

    return TP.$$handleNonKeyOrMouseEvent(anEvent);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$$handlePaste',
function(anEvent) {

    /**
     * @method $$handlePaste
     * @summary Document-level paste handler, installed by tibet_hook.
     * @param {Event} anEvent The native event object.
     */

    return TP.$$handleNonKeyOrMouseEvent(anEvent);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$$handleReset',
function(anEvent) {

    /**
     * @method $$handleReset
     * @summary Document-level reset handler, installed by tibet_hook.
     * @param {Event} anEvent The native event object.
     */

    return TP.$$handleNonKeyOrMouseEvent(anEvent);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$$handleResize',
function(anEvent) {

    /**
     * @method $$handleResize
     * @summary Window-level resize handler, installed by tibet_hook.
     * @param {Event} anEvent The native event object.
     */

    return TP.$$handleNonKeyOrMouseEvent(anEvent);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$$handleScroll',
function(anEvent) {

    /**
     * @method $$handleScroll
     * @summary Document-level scroll handler, installed by tibet_hook.
     * @param {Event} anEvent The native event object.
     */

    return TP.$$handleNonKeyOrMouseEvent(anEvent);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$$handleSubmit',
function(anEvent) {

    /**
     * @method $$handleSubmit
     * @summary Document-level submit handler, installed by tibet_hook.
     * @param {Event} anEvent The native event object.
     */

    //  TIBET does not support sending data to the server via a form submit.
    //  Warn here and prevent default on the event.

    TP.ifWarn() ?
        TP.warn('Form not submitted.' +
                ' Use other TIBET mechanisms to send data to the server.') : 0;

    TP.eventPreventDefault(anEvent);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$$handleTransitionEnd',
function(anEvent) {

    /**
     * @method $$handleTransitionEnd
     * @summary Document-level transitionend handler, installed by tibet_hook.
     * @param {Event} anEvent The native event object.
     */

    return TP.$$handleNonKeyOrMouseEvent(anEvent);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetEventIds',
function(anElement, invalidateIdCache) {

    /**
     * @method elementGetEventIds
     * @summary Returns the event ids (signal origins used to signal DOM
     *     events) for anElement. The event ids are computed by walking up the
     *     DOM tree, appending each element's global ID to the list of event
     *     ids. A global ID is the dot-separated name of the element from
     *     top-most parent down.
     * @param {Element} anElement The Element node to get the event ids for.
     * @param {Boolean} invalidateIdCache Whether or not to invalidate any
     *     'cached' ids that were computed previously.
     * @exception TP.sig.InvalidElement
     * @returns {String[]} An array containing the event ids of the element.
     */

    var eventIdArray,

        theElement,
        elementDoc,

        localID,

        elementWin;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.notValid(eventIdArray = anElement[TP.EVENT_IDS]) ||
            TP.isTrue(invalidateIdCache)) {
        eventIdArray = TP.ac();

        //  NB: The first element in the array will be the element itself.
        theElement = anElement;

        elementDoc = TP.nodeGetDocument(theElement);

        //  Traverse up our parent chain
        while (TP.isElement(theElement)) {
            //  without an ID we can't have been a target or observer so we
            //  can't be part of the DOM tree that matters
            if (theElement !== elementDoc &&
                TP.isEmpty(TP.elementGetAttribute(theElement, 'id'))) {
                theElement = theElement.parentNode;
                continue;
            }

            localID = TP.lid(theElement);

            //  The local ID must not be null or the empty string, in
            //  order to be part of a valid event id path for this element.
            //  A blank name in the array will do us no good.
            if (TP.notEmpty(localID)) {
                //  Add the element's ID by registering it's full
                //  name.
                eventIdArray.push(TP.gid(theElement));
            }

            if (theElement === elementDoc &&
                TP.isWindow(elementWin = TP.nodeGetWindow(elementDoc))) {
                //  If the window is an iframe's window, then set theElement
                //  to be that iframe element, effectively 'jumping out of
                //  the window', so to speak :-).
                if (TP.isIFrameWindow(elementWin)) {
                    eventIdArray.push(TP.gid(elementWin));
                    theElement = elementWin.frameElement;
                    elementDoc = TP.nodeGetDocument(theElement);

                    //  Continue so that we process the frame element and
                    //  don't skip it below.
                    continue;
                } else {
                    break;
                }
            }

            //  Get the parent node for the element and loop again.
            theElement = theElement.parentNode;
        }

        //  The looping will have terminated at a 'document' node - add it's ID.
        eventIdArray.push(TP.gid(elementDoc));

        //  See if that document has a window and if it does, append
        //  its global ID to the end of the event ids.
        elementWin = TP.nodeGetWindow(elementDoc);
        if (TP.isWindow(elementWin)) {
            eventIdArray.push(TP.gid(elementWin));
        }

        //  We built this from the inside-out, but the TP.DOM_FIRING policy
        //  in the notification system likes to see it from the outside-in
        //  (because it will process 'capturing' event handlers first), so
        //  we reverse it here (once, before we cache it).
        eventIdArray.reverse();

        //  Make sure to configure it as an origin set.
        eventIdArray.isOriginSet(true);

        //  Cache the eventIdArray on anElement
        anElement[TP.EVENT_IDS] = eventIdArray;
    }

    return eventIdArray;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetEventOrigins',
function(anElement, anEvent) {

    /**
     * @method elementGetEventOrigins
     * @summary Returns the elements which comprise signal origins used to
     *     signal DOM events for anElement. The origins are computed by walking
     *     up the DOM tree, appending each element to the list of origins.
     * @param {Element} anElement The Element node to get the origin list for.
     * @param {Event} anEvent The native event object.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidEvent
     * @returns {Object[]} An array of elements and objects.
     */

    var originArray,
        theElement,
        localID,
        elementDoc,
        elementWin,
        eventType;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEvent(anEvent)) {
        eventType = TP.eventGetType(anEvent);
    } else {
        eventType = 'undefined';
    }

    originArray = TP.ac();

    //  NB: The first element in the array will be the element itself.
    theElement = anElement;

    elementDoc = TP.nodeGetDocument(theElement);

    //  Traverse up our parent chain
    while (TP.isElement(theElement)) {

        //  without an ID we can't have been a target or observer so we can't be
        //  part of the DOM tree that matters
        if (theElement !== elementDoc &&
            TP.isEmpty(TP.elementGetAttribute(theElement, 'id')) &&
            TP.isEmpty(TP.elementGetAttribute(theElement, 'on:' + eventType))) {

            theElement = theElement.parentNode;

            continue;
        }

        localID = TP.lid(theElement);

        //  The local ID must not be null or the empty string, in order to be
        //  part of a valid event id path for this element.
        //  An element with a blank name in the array will do us no good.
        if (TP.notEmpty(localID)) {
            //  Add the element by registering the element itself for fast
            //  retrieval.
            originArray.push(theElement);
        }

        if (theElement === elementDoc &&
            TP.isWindow(elementWin = TP.nodeGetWindow(elementDoc))) {
            //  If the window is an iframe's window, then set the element to be
            //  that iframe element, effectively 'jumping out of the window',
            //  so to speak :-).
            if (TP.isIFrameWindow(elementWin)) {
                originArray.push(TP.gid(elementWin));
                theElement = elementWin.frameElement;
                elementDoc = TP.nodeGetDocument(theElement);

                //  Continue so that we process the frame element and
                //  don't skip it below.
                continue;
            } else {
                break;
            }
        }

        //  Get the parent node for the element and loop again.
        theElement = theElement.parentNode;
    }

    //  The looping will have terminated at a 'document' node - add it's ID.
    originArray.push(TP.gid(elementDoc));

    //  See if that document has a window and if it does, append its global ID
    //  to the end of the event ids.
    elementWin = TP.nodeGetWindow(elementDoc);
    if (TP.isWindow(elementWin)) {
        originArray.push(TP.gid(elementWin));
    }

    //  We built this from the inside-out, but the TP.DOM_FIRING policy
    //  in the notification system likes to see it from the outside-in
    //  (because it will process 'capturing' event handlers first), so
    //  we reverse it here (once, before we cache it).
    originArray.reverse();

    //  Make sure to configure it as an origin set.
    originArray.isOriginSet(true);

    return originArray;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('targetShouldHandleEvent',
function(anEvent) {

    /**
     * @method targetShouldHandleEvent
     * @summary Returns a true or false value depending on whether the target
     *     element of the supplied event should handle the supplied event.
     * @param {Event} anEvent The native event object.
     * @exception TP.sig.InvalidEvent
     * @returns {Boolean} Whether or not the target element of the supplied
     *     element should handle the event.
     */

    var eventType,
        eventTarget,

        eventBlocks,

        val,
        ans;

    if (!TP.isEvent(anEvent)) {
        return TP.raise(this, 'TP.sig.InvalidEvent');
    }

    //  Grab the event type and target - we'll use these frequently below.
    eventType = TP.eventGetType(anEvent);
    eventTarget = TP.eventGetTarget(anEvent);

    //  If the event target isn't an Element, then there's no way to configure
    //  for blocking this type of event.
    if (!TP.isElement(eventTarget)) {
        return true;
    }

    //  See if the target element has a POJO registered under it's 'event
    //  blockers'.
    eventBlocks = eventTarget[TP.EVENT_BLOCKS];

    //  If not, create a POJO and assign it.
    if (!TP.isValid(eventBlocks)) {
        eventBlocks = {};
        eventTarget[TP.EVENT_BLOCKS] = eventBlocks;
    } else {
        //  Otherwise, if it has an entry in the event blocks under the specific
        //  event type, then we return the *inverse* value. In other words, if
        //  this element 'blocks' keydown events (and the value would be true),
        //  then we return false, meaning the target should *not* handle this
        //  type of event.
        if (TP.isValid(eventBlocks[eventType])) {
            return !eventBlocks[eventType];
        }
    }

    //  If we have no value, true or false, for blocking the event, then we try
    //  to determine one.
    if (!TP.isValid(eventBlocks[eventType])) {

        //  If the event target itself has a 'tibet:no-eventtrap' attribute,
        //  then use the value to check either for TP.ALL, which would mean that
        //  this element is blocking all events, or a space-separated list of
        //  event types that the element is blocking.
        val = TP.elementGetAttribute(
                        eventTarget, 'tibet:no-eventtrap', true);

        if (TP.notEmpty(val)) {
            if (val === TP.ALL) {
                eventBlocks[eventType] = true;
                return false;
            }
            val = val.split(' ');
            if (val.contains(eventType)) {
                eventBlocks[eventType] = true;
                return false;
            }
        }

        //  If the element itself didn't have a 'tibet:no-eventtrap' attribute,
        //  then check up its ancestor chain for the same values. Note here that
        //  we still cache the resolved value on the target element itself.
        if (TP.isElement(
            ans = TP.nodeDetectAncestorMatchingCSS(
                        eventTarget,
                        '*[tibet|no-eventtrap]'))) {

            val = TP.elementGetAttribute(
                        ans, 'tibet:no-eventtrap', true);

            if (TP.notEmpty(val)) {
                if (val === TP.ALL) {
                    eventBlocks[eventType] = true;
                    return false;
                }
                val = val.split(' ');
                if (val.contains(eventType)) {
                    eventBlocks[eventType] = true;
                    return false;
                }
            }
        }
    }

    //  Cache a value of false, which means that the event target *will* handle
    //  the event. This is a performance optimization so that, once we have
    //  determined that the element does *not* block that type.
    eventBlocks[eventType] = false;

    return true;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowArmListeners',
function(aWindow, aDocumentNode) {

    /**
     * @method windowArmListeners
     * @summary Arms all the elements associated with listener elements in the
     *     node provided. Note that we only need to arm listeners that have 'UI'
     *     signal types.
     * @param {Window} aWindow The window that should do the arming.
     * @param {XMLDocument} aDocumentNode The node containing listener elements.
     * @exception TP.sig.InvalidWindow
     * @exception TP.sig.InvalidDocument
     * @returns {Number} The count of listeners armed.
     */

    var listeners,
        listener,
        i,
        origins,
        count,
        origin;

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (!TP.isDocument(aDocumentNode)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  NB: We only get listeners from the document that have an
    //  'event' attribute whose value starts with 'UI'. This is
    //  because we only need to arm listeners for UISignals. Many
    //  other listeners may be in the document that have signal
    //  names that are non-native 'fake' events (i.e. they don't
    //  really exist in the browser, but are used by TIBET).
    listeners = TP.nodeEvaluateXPath(
                aDocumentNode,
                '//tibet_listener[starts-with(@event, "UI")]',
                TP.NODESET);

    count = 0;
    for (i = 0; i < listeners.length; i++) {
        listener = listeners[i];

        TP.windowArmNode(
                    aWindow,
                    TP.elementGetAttribute(listener, 'local-origin'),
                    TP.elementGetAttribute(listener, 'event'));
        count++;

        origin = TP.elementGetAttribute(listener, 'origin');
        if (TP.isString(origin)) {
            origins = origin.split('.');
            TP.windowArmNode(
                        aWindow,
                        origins[origins.length - 1],
                        TP.elementGetAttribute(listener, 'event'));
            count++;
        }
    }

    return count;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowArmNode',
function(aWindow, aNodeOrList, eventNames, aHandler, aPolicy) {

    /**
     * @method windowArmNode
     * @summary Arm the node, or list of nodes, so they will fire the events
     *     specified in the supplied set of event names.
     * @param {Window} aWindow The window that should do the arming.
     * @param {Node|String} aNodeOrList The node or list of nodes to arm with
     *     the event(s) specified. This can also be the TP.ANY constant,
     *     indicating that the event is to be observed coming from any node.
     * @param {String|String[]} eventNames The names or types of the events to
     *     arm the element with.
     * @param {Function} aHandler An (optional) parameter that defines a native
     *     handler to be used instead of sending the event into the TIBET
     *     signaling system.
     * @param {Function} aPolicy An (optional) parameter that defines the
     *     "firing" policy.
     * @exception TP.sig.InvalidWindow
     * @exception TP.sig.InvalidParameter
     */

    var i,
        len,
        it,
        element,
        elementNameArray,
        eventNameArray;

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (TP.notValid(aNodeOrList) || TP.isEmpty(eventNames)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  event name should be a string or array of strings...
    if (TP.isString(eventNames)) {
        eventNameArray = eventNames.split(' ');
    } else if (TP.isCollection(eventNames)) {
        eventNameArray = eventNames;
    } else {
        return TP.raise(this, 'TP.sig.InvalidParameter',
            'Event specification not a string or collection.');
    }

    //  Next, we have to make sure that the contents of our array
    //  of event names are indeed Strings. This call allows the
    //  caller to pass in a type or array of types. If the event
    //  aren't Strings, we convert them to the type names they
    //  represent.
    len = eventNameArray.getSize();
    for (i = 0; i < len; i++) {
        it = eventNameArray.at(i);

        if (!TP.isString(it)) {
            eventNameArray.atPut(i, it.getSignalName());
        }
    }

    //  wildcarded - we'll do them all
    if (aNodeOrList === TP.ANY) {
        TP.windowArmEvents(aWindow, eventNameArray, aHandler);
    } else if (TP.isDocument(aNodeOrList)) {
        TP.$windowArmNodeForEvents(aWindow,
                                    aNodeOrList,
                                    eventNameArray,
                                    aHandler,
                                    aPolicy);

        //  Nothing else to do. Bail out early.
        return;
    } else if (TP.isElement(aNodeOrList)) {
        TP.$windowArmNodeForEvents(aWindow,
                                    aNodeOrList,
                                    eventNameArray,
                                    aHandler,
                                    aPolicy);

        //  Nothing else to do. Bail out early.
        return;
    } else if (TP.isString(aNodeOrList)) {
        elementNameArray = aNodeOrList.split(' ');
    } else {
        //  should be a collection
        elementNameArray = aNodeOrList;
    }

    if (TP.isArray(elementNameArray)) {
        //  just in case it's a nodelist or other primitive array we'll
        //  iterate the old-fashioned way here
        for (i = 0; i < elementNameArray.length; i++) {
            element = TP.nodeGetElementById(aWindow.document,
                                            elementNameArray[i]);
            if (TP.isElement(element)) {
                TP.$windowArmNodeForEvents(aWindow,
                                            element,
                                            eventNameArray,
                                            aHandler,
                                            aPolicy);
            }
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$windowArmNodeForEvents',
function(aWindow, aNode, eventNameArray, aHandler, aPolicy) {

    /**
     * @method $windowArmNodeForEvents
     * @summary Arms the node to fire the events named in eventNameArray.
     * @param {Window} aWindow The window to process.
     * @param {Node} aNode The node to arm.
     * @param {String[]} eventNameArray The array of event names to instrument
     *     aNode to fire.
     * @param {Function} aHandler An (optional) parameter that defines a native
     *     handler to be used instead of sending the event into the TIBET
     *     signaling system.
     * @param {Function} aPolicy An (optional) parameter that defines the
     *     "firing" policy.
     * @exception TP.sig.InvalidWindow
     * @exception TP.sig.InvalidNode
     * @exception TP.sig.InvalidArray
     */

    var targetElement,

        i,
        i2,
        len,
        len2,

        elementDoc,
        elementLocalID,

        foundElements,
        moreElements,

        thePolicy,
        theHandler,

        wrapperHandler,

        element,
        eventName,
        nativeEventName;

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (TP.isEmpty(eventNameArray)) {
        return TP.raise(this, 'TP.sig.InvalidArray');
    }

    if (TP.isDocument(aNode)) {
        targetElement = aNode.documentElement;
        elementDoc = aNode;
    } else {
        targetElement = aNode;
        elementDoc = TP.nodeGetDocument(aNode);
    }

    //  Grab the element's window and ID, forcing ID creation as needed
    elementLocalID = TP.lid(targetElement, true);

    //  If the element is not a window and its not a document, then check to
    //  see if there are any more elements with the same name (as might be
    //  the case with radio buttons) and go ahead and grab them all.
    //  Otherwise, just add the element to the 'foundElements' array by
    //  itself.
    if (TP.notEmpty(moreElements = TP.nodeGetDescendantElementsByIdOrName(
                                                elementDoc,
                                                elementLocalID))) {
        foundElements = moreElements;
    } else {
        foundElements = TP.ac();
        foundElements.push(targetElement);
    }

    //  NB: The default for firing policies is TP.DOM_FIRING
    thePolicy = TP.ifInvalid(aPolicy, TP.DOM_FIRING);

    theHandler = TP.ifInvalid(aHandler, TP.$dispatchEventToTIBET);

    len = foundElements.getSize();
    for (i = 0; i < len; i++) {
        element = foundElements.at(i);

        len2 = eventNameArray.getSize();

        /* eslint-disable no-loop-func */
        for (i2 = 0; i2 < len2; i2++) {
            eventName = eventNameArray.at(i2);
            nativeEventName = TP.$getEventNameForSignalName(eventName);

            //  Build a wrapper handle that will do some nice W3C
            //  translations for us.
            wrapperHandler =
                    function(anEvent) {

                        var evt;

                        evt = TP.eventNormalize(anEvent, aNode);

                        return theHandler(evt);
                    };
            theHandler.$$wrapper = wrapperHandler;

            element.addEventListener(nativeEventName, theHandler, false);

            element.firingPolicy = thePolicy;
        }
        /* eslint-enable no-loop-func */
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowDisarmNode',
function(aWindow, aNodeOrList, eventNames, aHandler) {

    /**
     * @method windowDisarmNode
     * @summary Disarm element anElement from firing the events specified in
     *     the supplied array.
     * @param {Window} aWindow The window whose nodes should be disarmed.
     * @param {Node|String} aNodeOrList The node or list to disarm with the
     *     event(s) specified. This can also be the TP.ANY constant, indicating
     *     that the event is to be ignored coming from any node.
     * @param {String|String[]} eventNames The names or types of the events to
     *     disarm the element from.
     * @param {Function} aHandler An (optional) parameter that defines a native
     *     handler that was used instead of sending the event into the TIBET
     *     signaling system.
     * @exception TP.sig.InvalidWindow
     * @exception TP.sig.InvalidParameter
     */

    var i,
        it,
        element,
        elementNameArray,
        eventNameArray;

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (TP.notValid(aNodeOrList) || TP.isEmpty(eventNames)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  event name should be a string or array of strings...
    if (TP.isString(eventNames)) {
        eventNameArray = eventNames.split(' ');
    } else if (TP.isCollection(eventNames)) {
        eventNameArray = eventNames;
    } else {
        return TP.raise(this, 'TP.sig.InvalidParameter',
            'Event specification not a string or collection.');
    }

    //  Next, we have to make sure that the contents of our array
    //  of event names are indeed Strings. This call allows the
    //  caller to pass in a type or array of types. If the elements
    //  aren't Strings, we convert them to the type names they
    //  represent.
    for (i = 0; i < eventNameArray.getSize(); i++) {
        it = eventNameArray.at(i);

        if (!TP.isString(it)) {
            eventNameArray.atPut(i, it.getSignalName());
        }
    }

    //  wildcarded - we'll do them all
    if (aNodeOrList === TP.ANY) {
        TP.windowDisarmEvents(aWindow, eventNameArray, aHandler);

        //  Nothing else to do. Bail out early.
        return;
    } else if (TP.isNode(aNodeOrList)) {
        TP.$windowDisarmNodeForEvents(aWindow,
                                        aNodeOrList,
                                        eventNameArray,
                                        aHandler);

        //  Nothing else to do. Bail out early.
        return;
    } else if (TP.isString(aNodeOrList)) {
        elementNameArray = aNodeOrList.split(' ');
    } else {
        //  should be a collection
        elementNameArray = aNodeOrList;
    }

    //  just in case it's a nodelist or other primitive array we'll iterate
    //  the old-fashioned way here
    for (i = 0; i < elementNameArray.length; i++) {
        element = TP.nodeGetElementById(aWindow.document,
                                        elementNameArray[i]);
        if (TP.isElement(element)) {
            TP.$windowDisarmNodeForEvents(aWindow,
                                            element,
                                            eventNameArray,
                                            aHandler);
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$windowDisarmNodeForEvents',
function(aWindow, aNode, eventNameArray, aHandler) {

    /**
     * @method $windowDisarmNodeForEvents
     * @summary Disarms the node so it will no longer fire the events named in
     *     eventNameArray.
     * @param {Window} aWindow The window to process.
     * @param {Node} aNode A document or element to disarm.
     * @param {String[]} eventNameArray The array of event names to disarm.
     * @param {Function} aHandler An (optional) parameter that defines a native
     *     handler that was used instead of sending the event into the TIBET
     *     signaling system.
     * @exception TP.sig.InvalidWindow
     * @exception TP.sig.InvalidNode
     * @exception TP.sig.InvalidArray
     */

    var i,
        i2,
        len,
        len2,

        elementDoc,
        elementLocalID,

        theHandler,

        foundElements,
        moreElements,

        element,
        eventName,
        nativeEventName;

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (TP.isEmpty(eventNameArray)) {
        return TP.raise(this, 'TP.sig.InvalidArray');
    }

    //  Grab the element's window and its name.
    elementDoc = TP.nodeGetDocument(aNode);
    elementLocalID = TP.lid(aNode);

    theHandler = TP.ifInvalid(aHandler, TP.$dispatchEventToTIBET);

    //  If the element is not a window and its not a document, then check to
    //  see if there are any more elements with the same name (as might be
    //  the case with radio buttons) and go ahead and grab them all.
    //  Otherwise, just add the element to the 'foundElements' array by
    //  itself.
    if (!TP.isWindow(aNode) &&
        !TP.isHTMLDocument(aNode) &&
        !TP.isXHTMLDocument(aNode) &&
        TP.notEmpty(moreElements = TP.nodeGetDescendantElementsByIdOrName(
                                                elementDoc,
                                                elementLocalID))) {
        //  typically only a radio button group sharing 'name'
        foundElements = moreElements;
    } else {
        foundElements = TP.ac();
        foundElements.push(aNode);
    }

    len = foundElements.getSize();
    for (i = 0; i < len; i++) {
        element = foundElements.at(i);

        len2 = eventNameArray.getSize();
        for (i2 = 0; i2 < len2; i2++) {
            eventName = eventNameArray.at(i2);
            nativeEventName = TP.$getEventNameForSignalName(eventName);

            if (TP.isValid(theHandler.$$wrapper)) {
                theHandler = theHandler.$$wrapper;
            }

            element.removeEventListener(nativeEventName, theHandler, false);
        }
    }

    return;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETDHTMLPrimitivesPre.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
DHTML support that needs to be loaded prior to the browser-specific DHTML
implementation files are loaded.
*/

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETDHTMLPrimitivesBase.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
Common functionality related to DHTML operations.
*/

//  ------------------------------------------------------------------------

//  A global hash of display values for non-inline elements.
TP.XHTML_10_NONINLINE_ELEMENTS = TP.hc(
    'address', 'block',
    'applet', 'block',
    'blockquote', 'block',
    'body', 'block',
    'caption', 'table-caption',
    'center', 'block',
    'col', 'table-column',
    'colgroup', 'table-column-group',
    'dd', 'block',
    'dir', 'block',
    'div', 'block',
    'dl', 'block',
    'dt', 'block',
    'fieldset', 'block',
    'form', 'block',
    'frame', 'block',
    'frameset', 'block',
    'h1', 'block',
    'h2', 'block',
    'h3', 'block',
    'h4', 'block',
    'h5', 'block',
    'h6', 'block',
    'hr', 'block',
    'iframe', 'block',
    'li', 'list-item',
    'menu', 'block',
    'noframes', 'block',
    'object', 'block',
    'ol', 'block',
    'p', 'block',
    'pre', 'block',
    'table', 'table',
    'td', 'table-cell',
    'th', 'table-cell',
    'tr', 'table-row',
    'thead', 'table-header-group',
    'tbody', 'table-row-group',
    'tfoot', 'table-footer-group',
    'ul', 'block');

//  ------------------------------------------------------------------------
//  OBJECT PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('objectGetXY',
function(anObject) {

    /**
     * @method objectGetXY
     * @summary Returns the 'global' (according to the supplied object) X and Y
     *     as extracted from the supplied object.
     * @description A variety of different objects can be supplied to this
     *     method to extract X and Y values from. Depending on the type of that
     *     object, here is how the X and Y are computed:
     *
     *     Array -> The X is extracted from the object's '.first()' property
     *     and the Y is extracted from the '.last()' property. Event -> The X
     *     and Y corresponding to the document position that the event occurred
     *     in will be returned. These numbers will *not* be offset by any
     *     scrolling. Element -> The X and Y corresponding to the element's
     *     TP.BORDER_BOX will be returned. Object -> The X is extracted by
     *     calling '.get("x")' and the Y is extracted by calling '.get("y")'.
     *     These may return undefined values.
     *
     *
     * @param {Object} anObject The object to extract the X and Y for.
     * @exception TP.sig.InvalidObject
     * @returns {Number[]} An ordered pair where the first item is the X
     *     coordinate and the second item is the Y coordinate.
     */

    var anX,
        anY;

    if (TP.notValid(anObject)) {
        return TP.raise(this, 'TP.sig.InvalidObject');
    }

    if (TP.isElement(anObject)) {
        //  This method defaults to TP.BORDER_BOX
        return TP.elementGetPageXY(anObject);
    }

    if (TP.isEvent(anObject)) {
        return TP.ac(anObject.pageX, anObject.pageY);
    }

    if (TP.isArray(anObject)) {
        return TP.ac(anObject.first(), anObject.last());
    }

    if (TP.isNumber(anX = anObject.get('x')) &&
        TP.isNumber(anY = anObject('y'))) {
        return TP.ac(anX, anY);
    }

    return TP.ac();
});

//  ------------------------------------------------------------------------
//  DOCUMENT PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('documentConstructScriptElement',
function(aDocument, aURL, aContent, aLoadedFunction) {

    /**
     * @method documentConstructScriptElement
     * @summary Creates an (X)HTML 'script' element in the document, using
     *     the URL provided and configures it to call the supplied loaded
     *     function when it completes loading.
     * @description In order for the script element produced by this routine
     *     to actually load its content, it needs to be appended to an
     *     (X)HTML document, preferable to the 'head'.
     * @param {Document} aDocument The document to create the 'script'
     *     element in.
     * @param {String} aURL The URL to load the script from.
     * @param {String} aContent The content to set as the text content of
     *     the script. This will only be used if there is no value for aURL.
     * @param {Function} aLoadedFunction The function to execute when the
     *     script has completed loading its content.
     * @exception TP.sig.InvalidDocument
     * @returns {HTMLElement} The script element created in the supplied
     *     document.
     */

    var newScriptElement,
        scriptContentNode;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    newScriptElement = TP.documentConstructElement(aDocument,
                                                    'script',
                                                    TP.w3.Xmlns.XHTML);

    //  NOTE!! This *must* be done by using the '.async' property. Setting the
    //  'async' attribute to 'false' here will actually cause the new script
    //  element to always be asynchronous, since the 'async' attribute is an
    //  'existence' attribute.
    newScriptElement.async = false;

    if (TP.notEmpty(aURL)) {
        newScriptElement.src = aURL;
    } else if (TP.notEmpty(aContent)) {
        scriptContentNode = aDocument.createTextNode(aContent);
        newScriptElement.appendChild(scriptContentNode);
    }

    if (TP.isCallable(aLoadedFunction)) {
        newScriptElement.onload = aLoadedFunction;
    }

    return newScriptElement;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentCopyTextToClipboard',
function(aDocument, aText) {

    /**
     * @method documentCopyTextToClipboard
     * @summary Copies the supplied text to the system clipboard.
     * @description This method should be invoked only as part of a
     *     user-generated event handler. Otherwise, most browsers will throw an
     *     exception due to security concerns.
     * @param {Document} aDocument The document to use to stage the text content
     *     to copy.
     * @param {String} aText The text to copy to the clipboard.
     * @exception TP.sig.InvalidDocument
     */

    var newSpanElement,

        range,
        selection,

        success;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  Create a new 'span' element in the document, position it way offscreen,
    //  set it's text content and append it to the document's documentElement.
    newSpanElement = TP.documentConstructElement(aDocument,
                                                'span',
                                                TP.w3.Xmlns.XHTML);

    TP.elementSetStyleString(
        newSpanElement,
        'position: absolute; top: -1000px; left: -1000px; ');

    TP.nodeSetTextContent(newSpanElement, aText);

    TP.nodeAppendChild(aDocument.documentElement, newSpanElement, false);

    //  Now, create a Range to use for selecting the text.
    range = aDocument.createRange();

    //  Select the span's content into the Range.
    range.selectNodeContents(newSpanElement);

    //  Grab the Window associated with the document and it's selection object.
    //  Then clear all of its ranges and add the new range.
    selection = TP.nodeGetWindow(aDocument).getSelection();
    selection.removeAllRanges();
    selection.addRange(range);

    //  Attempt to copy the selection to the clipboard.
    try {
        success = aDocument.execCommand('copy', false, null);
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'Error copying text to clipboard')) : 0;
    }

    if (!success) {
        TP.ifWarn() ?
            TP.warn('Did not copy text to clipboard') : 0;
    }

    //  Make sure to remove our newly created span from its parent (the
    //  document's documentElement) before we exit.
    TP.nodeDetach(newSpanElement);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetHeight',
function(aDocument) {

    /**
     * @method documentGetHeight
     * @summary Returns the document's height.
     * @param {Document} aDocument The document to get the height of.
     * @exception TP.sig.InvalidDocument
     * @returns {Number} The document's height in pixels.
     */

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    return TP.documentGetBody(aDocument).offsetHeight;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetScrollX',
function(aDocument) {

    /**
     * @method documentGetScrollX
     * @summary Returns the document's X scrolling position with its window
     *     frame.
     * @param {Document} aDocument The document to get the X scroll position of.
     * @exception TP.sig.InvalidDocument
     * @returns {Number} The document's X scroll position in pixels.
     */

    var win;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    return TP.isWindow(win = TP.nodeGetWindow(aDocument)) ?
                    win.pageXOffset :
                    0;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetScrollY',
function(aDocument) {

    /**
     * @method documentGetScrollY
     * @summary Returns the document's Y scrolling position with its window
     *     frame.
     * @param {Document} aDocument The document to get the Y scroll position of.
     * @exception TP.sig.InvalidDocument
     * @returns {Number} The document's Y scroll position in pixels.
     */

    var win;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    return TP.isWindow(win = TP.nodeGetWindow(aDocument)) ?
                    win.pageYOffset :
                    0;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetViewableHeight',
function(aDocument) {

    /**
     * @method documentGetViewableHeight
     * @summary Returns the document's 'viewable' height (that is, the height
     *     that can currently be seen and has not scrolled offscreen).
     * @param {HTMLDocument} aDocument The document to compute the viewable
     *     height for.
     * @exception TP.sig.InvalidDocument
     * @returns {Number} The document's viewable height in pixels.
     */

    var win;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    win = TP.nodeGetWindow(aDocument);
    if (TP.isValid(win)) {
        return win.innerHeight;
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetViewableWidth',
function(aDocument) {

    /**
     * @method documentGetViewableWidth
     * @summary Returns the document's 'viewable' width (that is, the width
     *     that can currently be seen and has not scrolled offscreen).
     * @param {HTMLDocument} aDocument The document to compute the viewable
     *     width for.
     * @exception TP.sig.InvalidDocument
     * @returns {Number} The document's viewable width in pixels.
     */

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    return aDocument.documentElement.clientWidth;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetVisibility',
function(aDocument) {

    /**
     * @method documentGetVisibility
     * @summary Returns the supplied document's 'visibility state'. This
     *     leverages the HTML5 'document.visibilityState' property.
     * @param {Document} aDocument The document to obtain the visibility state
     *     of.
     * @exception TP.sig.InvalidDocument
     * @returns {String} The supplied document's visibility state. This will be
     *     one of: TP.VISIBLE, TP.HIDDEN or TP.PRERENDER.
     */

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    return aDocument.visibilityState;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetWidth',
function(aDocument) {

    /**
     * @method documentGetWidth
     * @summary Returns the document's width.
     * @param {Document} aDocument The document to get the width of.
     * @exception TP.sig.InvalidDocument
     * @returns {Number} The document's width in pixels.
     */

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    return TP.documentGetBody(aDocument).offsetWidth;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentIsVisible',
function(aDocument) {

    /**
     * @method documentIsVisible
     * @summary Returns whether or not the supplied document is visible to the
     *     user. This leverages the HTML5 'document.hidden' property.
     * @param {Document} aDocument The document to test to see if its visible.
     * @exception TP.sig.InvalidDocument
     * @returns {Boolean} Whether or not the supplied document's is currently
     *     visible.
     */

    var propName;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    if (TP.isDefined(aDocument.mozHidden)) {
        propName = 'mozHidden';
    } else if (TP.isDefined(aDocument.webkitHidden)) {
        propName = 'webkitHidden';
    } else if (TP.isDefined(aDocument.msHidden)) {
        propName = 'msHidden';
    } else {
        propName = 'hidden';
    }

    //  Explicitly return true here because of Boolean testing around the
    //  property not existing
    if (aDocument[propName] === false) {
        return true;
    }

    return false;
});

//  ------------------------------------------------------------------------
//  Selection Management
//  ------------------------------------------------------------------------

TP.definePrimitive('documentClearSelection',
function(aDocument) {

    /**
     * @method documentClearSelection
     * @summary Clears any selection the user might have made in the supplied
     *     document.
     * @param {Document} aDocument The document to clear the selection in.
     * @exception TP.sig.InvalidDocument
     */

    var theSelection;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    theSelection = TP.nodeGetWindow(aDocument).getSelection();

    if (TP.isValid(theSelection)) {
        //  Removing all of the ranges clears the selection
        theSelection.removeAllRanges();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentCollapseSelection',
function(aDocument, toStart) {

    /**
     * @method documentCollapseSelection
     * @summary 'Collapse's any selection the user might have made in the
     *     supplied document to either the start or the end of itself.
     * @param {Document} aDocument The document to collapse the selection in.
     * @param {Boolean} toStart Whether or not to collapse the selection to the
     *     start of itself. This defaults to false (i.e. the selection will
     *     collapse to the end).
     * @exception TP.sig.InvalidDocument
     */

    var theSelection;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    theSelection = TP.nodeGetWindow(aDocument).getSelection();

    if (TP.notValid(theSelection)) {
        return;
    }

    if (theSelection.rangeCount === 0) {
        //  No ranges - can't collapse
        return;
    }

    try {
        if (TP.isTrue(toStart)) {
            theSelection.collapseToStart();
        } else {
            theSelection.collapseToEnd();
        }
    } catch (e) {
        //  moz likes to throw up if there are any issues here so just
        //  ignore it, it's half-brained most of the time anyway
        //  empty
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentConstructSelectionMarker',
function(aDocument) {

    /**
     * @method documentConstructSelectionMarker
     * @summary Returns an object that can be used in conjunction with
     *     TP.documentMoveSelectionToMarker() to move around in the document.
     * @param {Document} aDocument The document to create the selection marker
     *     in.
     * @exception TP.sig.InvalidDocument
     * @returns {Object} The object representing a selection marker.
     */

    var theSelection,
        theRange;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    theSelection = TP.nodeGetWindow(aDocument).getSelection();

    //  Make sure that the selection actually has a rangeCount of at least 1 -
    //  otherwise, Mozilla will throw an exception
    if (theSelection.rangeCount < 1) {
        return;
    }

    if (TP.isValid(theSelection)) {
        //  In W3C-compliant browsers, the 'selection marker' is really just
        //  a Range.
        theRange = theSelection.getRangeAt(0);

        if (TP.isValid(theRange)) {
            //  Clone the Range and return that.
            return theRange.cloneRange();
        }
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentInsertAfterSelection',
function(aDocument, newContent) {

    /**
     * @method documentInsertAfterSelection
     * @summary Appends the newContent after any current selection in the
     *     document. If there is no selection this method does nothing.
     * @param {Document} aDocument The document whose selection should be
     *     appended to.
     * @param {String} newContent A new string of content.
     * @exception TP.sig.InvalidDocument
     */

    var theSelection,
        theRange,

        theFragment;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    if (TP.notValid(theSelection =
                    TP.nodeGetWindow(aDocument).getSelection())) {
        //  No selection - can't insert
        return;
    }

    if (theSelection.rangeCount === 0) {
        //  No ranges - can't insert
        return;
    }

    theRange = theSelection.getRangeAt(0);
    theRange.collapse(false);

    theFragment = theRange.createContextualFragment(TP.str(newContent));
    theRange.insertNode(theFragment);

    theSelection.removeAllRanges();

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentInsertBeforeSelection',
function(aDocument, newContent) {

    /**
     * @method documentInsertBeforeSelection
     * @summary Inserts the newContent before any current selection in the
     *     document. If there is no selection this method does nothing.
     * @param {Document} aDocument The document whose selection should be
     *     inserted before.
     * @param {String} newContent A new string of content.
     * @exception TP.sig.InvalidDocument
     */

    var theSelection,
        theRange,

        theFragment;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    if (TP.notValid(theSelection =
                    TP.nodeGetWindow(aDocument).getSelection())) {
        //  No selection - can't insert
        return;
    }

    if (theSelection.rangeCount === 0) {
        //  No ranges - can't insert
        return;
    }

    theRange = theSelection.getRangeAt(0);
    theRange.collapse(true);

    theFragment = theRange.createContextualFragment(TP.str(newContent));
    theRange.insertNode(theFragment);

    theSelection.removeAllRanges();

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentIsSelectionCollapsed',
function(aDocument) {

    /**
     * @method documentIsSelectionCollapsed
     * @summary Returns whether or not the supplied document's current
     *     selection is collapsed (whether or not its empty).
     * @param {Document} aDocument The document to test the current selection of
     *     to see if its collapsed.
     * @exception TP.sig.InvalidDocument
     * @returns {Boolean} Whether or not the supplied document's current
     *     selection is collapsed.
     */

    var theSelection;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    theSelection = TP.nodeGetWindow(aDocument).getSelection();

    if (TP.notValid(theSelection)) {
        return true;
    }

    //  If the selection is collapsed or its 'toString()' representation is
    //  empty, then its collapsed.
    /* eslint-disable no-extra-parens */
    return (theSelection.isCollapsed ||
            TP.isEmpty(theSelection.toString()));
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetSelectionElement',
function(aDocument) {

    /**
     * @method documentGetSelectionElement
     * @summary Returns any single HTML element that is currently selected.
     *     Note that this method will only return real results if only a single
     *     element is selected. Otherwise it will return null.
     * @param {Document} aDocument The document to obtain the selected element
     *     for.
     * @exception TP.sig.InvalidDocument
     * @returns {HTMLElement} The single element that was selected in the
     *     supplied document.
     */

    var selectionType,

        theSelection,

        selectedElement;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  Grab the current selection type. This returns
    //  TP.SELECTION_NONE if the selection is null.
    selectionType = TP.documentGetSelectionType(aDocument);

    //  If the selection type isn't a whole HTMLElement, then bail out here
    //  by returning null.
    if (selectionType !== TP.SELECTION_ELEMENT) {
        return null;
    }

    theSelection = TP.nodeGetWindow(aDocument).getSelection();

    //  The selected element will be the child node of the selection's
    //  anchor node which is at the anchor's offset in the selection.
    selectedElement = theSelection.anchorNode.
                                        childNodes[theSelection.anchorOffset];

    if (TP.isElement(selectedElement)) {
        return selectedElement;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetSelectionParent',
function(aDocument) {

    /**
     * @method documentGetSelectionParent
     * @summary Returns the parent (element) of the supplied document's current
     *     selection.
     * @param {Document} aDocument The document to obtain the selection's parent
     *     node in.
     * @exception TP.sig.InvalidDocument
     * @returns {HTMLElement} The selection's parent node.
     */

    var selectionType,

        selElem,

        win,

        theSelection,

        selectionParentElement;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  Grab the current selection type. This returns
    //  TP.SELECTION_NONE if the selection is null.
    selectionType = TP.documentGetSelectionType(aDocument);

    //  If the selection type is a whole HTMLElement, then we can just use
    //  its parent node.
    if (selectionType === TP.SELECTION_ELEMENT) {
        if (TP.isElement(selElem =
                            TP.documentGetSelectionElement(aDocument))) {
            return selElem.parentNode;
        }

        return null;
    }

    if (!TP.isWindow(win = TP.nodeGetWindow(aDocument))) {
        return null;
    }

    theSelection = win.getSelection();

    if (TP.notValid(theSelection)) {
        return null;
    }

    //  Loop upward over the ancestor chain of the selection's anchorNode
    //  and detect the first parent that is a Node.ELEMENT_NODE.
    selectionParentElement = TP.nodeDetectAncestor(
                                theSelection.anchorNode,
                                function(aParentNode) {

                                    if (TP.isElement(aParentNode)) {
                                        return true;
                                    }

                                    return false;
                                });

    return selectionParentElement;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetSelectionText',
function(aDocument) {

    /**
     * @method documentGetSelectionText
     * @summary Returns any plain text (no markup) that is currently selected.
     *     Note that this method will only return real results if text is
     *     selected. Otherwise it will return null.
     * @param {Document} aDocument The document to obtain the selected text for.
     * @exception TP.sig.InvalidDocument
     * @returns {String} The text that was selected in the supplied document.
     */

    var selectionType,

        theSelection;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  Grab the current selection type. This returns
    //  TP.SELECTION_NONE if the selection is null.
    selectionType = TP.documentGetSelectionType(aDocument);

    //  If the selection type isn't a whole chunk of text, then bail out here by
    //  returning null. We want text.
    if (selectionType !== TP.SELECTION_TEXT) {
        return null;
    }

    theSelection = TP.nodeGetWindow(aDocument).getSelection();

    if (TP.notValid(theSelection)) {
        return null;
    }

    return theSelection.toString();
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetSelectionType',
function(aDocument) {

    /**
     * @method documentGetSelectionType
     * @summary Returns the current selection 'type'. This is one of the
     *     following constants:
     *
     *     TP.SELECTION_NONE - no selection TP.SELECTION_TEXT - text (or a
     *     combination of text and elements). TP.SELECTION_ELEMENT - a single,
     *     whole element
     *
     *
     * @param {Document} aDocument The document to obtain the selected type for.
     * @exception TP.sig.InvalidDocument
     * @returns {String} A constant, detailed above, that indicates which type
     *     the current selection is.
     */

    var win,

        theSelection,
        theRange;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    if (!TP.isWindow(win = TP.nodeGetWindow(aDocument))) {
        return TP.SELECTION_NONE;
    }

    theSelection = win.getSelection();

    //  If we didn't get a valid selection, or the selection is collapsed,
    //  then we have no selected content, so return TP.SELECTION_NONE
    if (TP.notValid(theSelection) || TP.isTrue(theSelection.isCollapsed)) {
        return TP.SELECTION_NONE;
    }

    //  If the rangeCount is 1, then we can be assured that its only a whole
    //  chunk of something that is selected. Now we test to see if that
    //  something is an Element node, with no other surrounding content.
    if (theSelection.rangeCount === 1) {
        theRange = theSelection.getRangeAt(0);

        //  If the start container matches the end container and the end
        //  offset minus the start offset is 1, that means that the
        //  selection does not span nodes. Then we just have to check the
        //  nodeType of the current selection to make sure its not a
        //  Node.TEXT_NODE.

        /* eslint-disable no-extra-parens */
        if (theRange.startContainer === theRange.endContainer &&
            (theRange.endOffset - theRange.startOffset) === 1 &&
            !TP.isTextNode(theRange.startContainer)) {
            return TP.SELECTION_ELEMENT;
        }
        /* eslint-enable no-extra-parens */
    }

    //  Otherwise, its not null, not collapsed and not a Node.ELEMENT_NODE,
    //  so it must be text.
    return TP.SELECTION_TEXT;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentMoveSelectionToMarker',
function(aDocument, aSelectionMarker) {

    /**
     * @method documentMoveSelectionToMarker
     * @summary Moves the selection to the supplied marker object.
     * @param {Document} aDocument The document to move the selection of.
     * @param {Object} aSelectionMarker The object to use as the selection
     *     marker.
     * @exception TP.sig.InvalidDocument
     */

    var theSelection;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    theSelection = TP.nodeGetWindow(aDocument).getSelection();

    if (TP.isValid(theSelection)) {
        //  Clear all of the current Ranges and add the 'selection marker'
        //  (which on W3C-compliant browsers is a Range object), to the
        //  selection. This will cause the selection to move to that place.
        theSelection.removeAllRanges();
        theSelection.addRange(aSelectionMarker);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentRemoveSelection',
function(aDocument) {

    /**
     * @method documentRemoveSelection
     * @summary Deletes the supplied document's selection.
     * @param {Document} aDocument The document to delete the selection of.
     * @exception TP.sig.InvalidDocument
     */

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  If there is a real, non-collapsed selection, then delete it.
    if (TP.documentGetSelectionType(aDocument) !== TP.SELECTION_NONE) {
        TP.nodeGetWindow(aDocument).getSelection().deleteFromDocument();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentReplaceSelection',
function(aDocument, newContent) {

    /**
     * @method documentReplaceSelection
     * @summary Replaces the supplied document's selection with newContent.
     * @param {Document} aDocument The document whose selection should be
     *     replaced.
     * @param {String} newContent The new content to use.
     * @exception TP.sig.InvalidDocument
     */

    var theSelection,
        theRange,

        theFragment;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  replace can operate on either an empty selection (in which case it
    //  functions like an insert) or on a text selection.

    if (TP.notValid(theSelection =
                    TP.nodeGetWindow(aDocument).getSelection())) {
        //  No selection - can't insert
        return;
    }

    if (theSelection.rangeCount === 0) {
        //  No ranges - can't insert
        return;
    }

    theRange = theSelection.getRangeAt(0);

    theRange.deleteContents();
    theRange.collapse(true);

    theFragment = theRange.createContextualFragment(TP.str(newContent));
    theRange.insertNode(theFragment);

    theSelection.removeAllRanges();

    return;
});

//  ------------------------------------------------------------------------
//  ELEMENT PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('elementAddResizeListener',
function(anElement, aHandler, useTrackerElement) {

    /**
     * @method elementAddResizeListener
     * @summary Adds a 'resize listener' to the supplied element. This listener
     *     will be called back when the element resizes in the DOM.
     * @description Note that there are two techniques to monitor resizing used
     *     here, depending on the setting of the useTrackerElement parameter.
     *     If useTrackerElement is false (the default) then the W3C standard
     *     ResizeObserver will be used to monitor resizing.
     *     If useTrackerElement is true, then a 'tracking element' approach is
     *     taken. The technique embodied in this approach depends upon two
     *     things: 1. That the supplied Element is positioned in some
     *     fashion (and, in fact, the Element will be positioned 'relative' if
     *     it's position is 'static' when it is supplied) and 2. an absolutely
     *     positioned child element will be added to the supplied Element.
     *     NB: This code adapted from:
     *         http://www.backalleycoder.com/2013/03/18/cross-browser-event-based-element-resize-detection/
     * @param {HTMLElement} anElement The element to add a resize listener to.
     * @param {Function} aHandler The handler Function to invoke when the
     *     supplied Element is resized. Note that this Function will be invoked
     *     in the context of the supplied Element, such that the 'this'
     *     reference will be that Element.
     * @param {Boolean} [useTrackerElement=false] Whether or not to use a
     *     'tracker element' approach.
     * @exception TP.sig.InvalidElement,TP.sig.InvalidFunction
     */

    var trackerFunc,
        trackerElem;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (!TP.isCallable(aHandler)) {
        return TP.raise(this, 'TP.sig.InvalidFunction');
    }

    if (useTrackerElement) {

        //  Define a 'work Function' that will execute when the tracking element
        //  resizes.
        trackerFunc = function(evt) {

            var win;

            //  Grab the content window of the tracker. This will be the target
            //  of the event that triggered this hander.
            win = TP.eventGetTarget(evt);

            //  If we have a valid resizing requestAnimationFrame constant, then
            //  cancel it.
            if (TP.isValid(win.__resizeRAF__)) {
                win.cancelAnimationFrame(win.__resizeRAF__);
            }

            //  Set up a resizing requestAnimationFrame constant by supplying a
            //  Function that will use the resizing target (i.e. the Element
            //  that we're installing the resize listener for) and, iterate over
            //  its listeners, invoking the registered resize listener for each
            //  one.
            win.__resizeRAF__ =
                win.requestAnimationFrame(
                        function() {
                            var target;

                            target = win.__resizeTarget__;

                            if (TP.isElement(target)) {
                                target[TP.RESIZE_LISTENERS].forEach(
                                    function(fn) {
                                        fn.call(target);
                                    });
                            }
                        });
        };

        //  If the resize listener Array is empty, then set one up and set up a
        //  'resizing tracking element' that will be appended underneath the
        //  supplied Element.

        if (TP.isEmpty(anElement[TP.RESIZE_LISTENERS])) {

            anElement[TP.RESIZE_LISTENERS] = TP.ac();
            anElement[TP.RESIZE_LISTENERS].trackerFunc = trackerFunc;

            //  If the element isn't positioned, we need to make it at least
            //  'relative'. Then resizing will properly propagate to the tracker
            //  child that we'll be adding below.
            if (!TP.elementIsPositioned(anElement)) {
                TP.elementSetStyleProperty(anElement, 'position', 'relative');
            }

            //  Create a tracker Element (which will be an XHTML 'object'
            //  element) and style it to be 100%/100%, positioned absolute, but
            //  not accepting any pointer events.
            trackerElem = TP.documentConstructElement(
                                        TP.nodeGetDocument(anElement),
                                        'object',
                                        TP.w3.Xmlns.XHTML);
            TP.elementAddClass(trackerElem, 'resizetracker');

            //  Capture a reference to the tracker element on the Array itself.
            anElement[TP.RESIZE_LISTENERS].tracker = trackerElem;

            //  Mark this element as one that was generated by TIBET and
            //  shouldn't be considered in CSS queries, etc.
            trackerElem[TP.GENERATED] = true;

            //  Capture a reference to the target element back onto the tracker
            //  element.
            trackerElem.__resizeTarget__ = anElement;

            //  Set up an onload on the tracker element that will add an
            //  EventListener on it's 'contentWindow' that will call the
            //  tracking function above when the 'contentWindow' resizes.
            trackerElem.onload = function(evt) {

                var win,
                    doc;

                win = this.contentWindow;

                //  Fix for Safari/Webkit bug:
                //  https://bugs.webkit.org/show_bug.cgi?id=148876
                if (!TP.isWindow(win)) {

                    doc = this.contentDocument;
                    if (TP.isDocument(doc)) {
                        win = doc.defaultView;
                    }

                    if (!TP.isWindow(win)) {
                        return;
                    }
                }

                win.__resizeTarget__ = this.__resizeTarget__;
                win.addEventListener('resize', trackerFunc);
            };

            //  Set some necessary properties on the tracker element.
            trackerElem.type = 'text/html';
            trackerElem.data = 'about:blank';

            //  Append the tracker element to the target element.
            anElement.appendChild(trackerElem);
        }
    } else {

        //  Some old browsers still don't have native ResizeObserver support.
        if (TP.notValid(ResizeObserver)) {
            TP.ifWarn() ? TP.warn('Native ResizeObserver unavailable for: ' +
                        TP.name(anElement)) : 0;
            return;
        }

        //  If the global ResizeObserver that manages our resizing events hasn't
        //  been allocated and initialized with the callback function, do so now.
        if (TP.notValid(TP.RESIZING_RESIZE_OBSERVER)) {
            TP.RESIZING_RESIZE_OBSERVER =
                /* eslint-disable no-undef */
                new ResizeObserver(
                /* eslint-enable no-undef */
                    function(entries, observer) {

                        entries.forEach(
                            function(anEntry) {
                                var target,
                                    targetWin;

                                //  The target will be the target Element that
                                //  got resized. Make sure it's an Element and
                                //  then run the callback functions defined on
                                //  the Element.
                                target = anEntry.target;
                                targetWin = TP.nodeGetWindow(target);

                                if (TP.isElement(target)) {
                                    //  Note here how we put these into a
                                    //  requestAnimationFrame. Otherwise, Chrome
                                    //  (at least) has trouble with servicing
                                    //  the ResizeObserver loop (it seems that
                                    //  supposed recursion loop checks don't
                                    //  work - or not with deep stacks, anyway).
                                    targetWin.requestAnimationFrame(
                                        function() {
                                            var listeners;

                                            listeners =
                                                target[TP.RESIZE_LISTENERS];
                                            if (TP.notValid(listeners)) {
                                                TP.ifWarn() ?
                                                    TP.warn('Can\'t find' +
                                                            ' listeners for: ' +
                                                            TP.str(target)) : 0;
                                                return;
                                            }

                                            listeners.forEach(
                                            function(fn) {
                                                fn.call(target);
                                            });
                                        });
                                }
                            });
                    });
        }

        //  If the resize listener Array is empty, then set one up and cause the
        //  global ResizeObserver to observe it.
        if (TP.isEmpty(anElement[TP.RESIZE_LISTENERS])) {
            anElement[TP.RESIZE_LISTENERS] = TP.ac();
            TP.RESIZING_RESIZE_OBSERVER.observe(anElement);
        }
    }

    //  Push the handler onto the Array of element resize listeners.
    anElement[TP.RESIZE_LISTENERS].push(aHandler);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementContentIsScrolled',
function(anElement) {

    /**
     * @method elementContentIsScrolled
     * @summary Whether or not the element is scrolling its content.
     * @param {HTMLElement} anElement The element to check to see if its
     *     scrolling its content.
     * @exception TP.sig.InvalidElement
     * @returns {Boolean} Whether or not the element is scrolling its content.
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    /* eslint-disable no-extra-parens */
    return (anElement.scrollWidth > anElement.clientWidth ||
            anElement.scrollHeight > anElement.clientHeight);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetElementAtPoint',
function(anElement, x, y) {

    /**
     * @method elementGetElementAtPoint
     * @summary Returns the 'most nested' child element at the x and y
     *     coordinates given.
     * @description Note that the coordinates should be given in 'document'
     *     coordinates.
     * @param {HTMLElement} anElement The element to begin searching for the
     *     element at x and y.
     * @param {Number} x The X coordinate to use to look for the child element.
     * @param {Number} y The Y coordinate to use to look for the child element.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidNumber
     * @returns {Element} The 'most nested' child element found at x and y
     *     coordinates given.
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (!TP.isNumber(x) || !TP.isNumber(y)) {
        return TP.raise(this, 'TP.sig.InvalidNumber');
    }

    return TP.nodeGetDocument(anElement).elementFromPoint(x, y);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetIFrameDocument',
function(anElement) {

    /**
     * @method elementGetIFrameDocument
     * @summary Returns the document of the iframe element supplied. NB: The
     *     caller *must* supply an 'iframe' element here, or an
     *     'TP.sig.InvalidElement' exception will be thrown.
     * @param {Element} anElement The 'iframe' element to retrieve the document
     *     for.
     * @exception TP.sig.InvalidElement
     * @returns {Document} The document of the iframe supplied.
     */

    if (!TP.isElement(anElement) ||
        TP.elementGetLocalName(anElement).toLowerCase() !== 'iframe' &&
            TP.elementGetLocalName(anElement).toLowerCase() !== 'object') {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    return anElement.contentDocument;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetIFrameWindow',
function(anElement) {

    /**
     * @method elementGetIFrameWindow
     * @summary Returns the window of the iframe element supplied. If the
     *     iframe's content window doesn't have a name and the iframe element
     *     has an id, the content window's name will be set to that id. NB: The
     *     caller *must* supply an 'iframe' element here, or an
     *     'TP.sig.InvalidElement' exception will be thrown.
     * @param {Element} anElement The 'iframe' element to retrieve the window
     *     for.
     * @exception TP.sig.InvalidElement
     * @returns {Window} The window of the iframe supplied.
     */

    var iframeWindow;

    /* eslint-disable no-extra-parens */
    if (!TP.isElement(anElement) ||
        (TP.elementGetLocalName(anElement).toLowerCase() !== 'iframe' &&
            TP.elementGetLocalName(anElement).toLowerCase() !== 'object')) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }
    /* eslint-enable no-extra-parens */

    //  Note that here we set the window's name to the id of the element, if
    //  it doesn't already have a name. This facilitates observing
    //  TP.sig.DocumentLoaded/TP.sig.DocumentUnloaded signals from the
    //  iframe.

    iframeWindow = anElement.contentWindow;

    if (TP.notValid(iframeWindow)) {
        return null;
    }

    if (TP.isEmpty(iframeWindow.name)) {
        iframeWindow.name = TP.elementGetAttribute(anElement, 'id');
    }

    return iframeWindow;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetOpacity',
function(anElement) {

    /**
     * @method elementGetOpacity
     * @summary Gets the element's opacity level. The level should be a
     *     fractional number between 0 and 1 that will represent the percentage
     *     of opacity the element is set to (e.g. it will be '.5' if the element
     *     is set to 50% opacity).
     * @param {HTMLElement} anElement The element to set the opacity of.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidStyleDeclaration
     * @returns {Number} The element's opacity level.
     */

    var computedStyle;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  Grab the computed style for the element
    if (TP.notValid(computedStyle = TP.elementGetComputedStyleObj(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    //  If there is no 'opacity' property defined on the style for the
    //  element, then just return '1.0', as the element is fully opaque.
    if (TP.isEmpty(computedStyle.opacity)) {
        return 1.0;
    }

    return parseFloat(computedStyle.opacity);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetOuterContent',
function(anElement) {

    /**
     * @method elementGetOuterContent
     * @summary Gets the 'outer content' of anElement.
     * @description This method gets the 'outer content' of anElement which
     *     means that the entire element, including its start and end tags, will
     *     be returned.
     * @param {HTMLElement} anElement The element to get the 'outer content' of.
     * @exception TP.sig.InvalidElement
     * @returns {String} The 'outer content' of the Element.
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    return anElement.outerHTML;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetOwnContent',
function(anElement) {

    /**
     * @method elementGetOwnContent
     * @summary Gets the markup which represents only the element
     *     itself... effectively the outer content minus the inner content.
     * @param {HTMLElement} anElement The element to get the 'own content' of.
     * @exception TP.sig.InvalidElement
     * @returns {String} The 'owned content' of the Element.
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    return anElement.outerHTML.replace(anElement.innerHTML, '');
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetComputedStyleValueInPixels',
function(anElement, styleProperty, wantsTransformed) {

    /**
     * @method elementGetComputedStyleValueInPixels
     * @summary Gets the computed style value of the property on the element in
     *     pixels. This routine can return NaN if a Number couldn't be computed.
     * @param {HTMLElement} anElement The element to get the numeric property
     *     value of.
     * @param {String} styleProperty The name of the style property to obtain
     *     the value of.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidStyleDeclaration
     * @returns {Number} The supplied property as a pixel value.
     */

    var computedStyle;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(styleProperty)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  Grab the computed style for the element
    if (TP.notValid(computedStyle = TP.elementGetComputedStyleObj(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    return TP.elementGetPixelValue(anElement,
                                    computedStyle[styleProperty],
                                    styleProperty,
                                    wantsTransformed);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetComputedStyleValuesInPixels',
function(anElement, styleProperties, wantsTransformed) {

    /**
     * @method elementGetComputedStyleValuesInPixels
     * @summary Gets the computed style values of the properties on the element
     *     in pixels. This routine can produce NaNs in the output if a Number
     *     couldn't be computed for that property.
     * @param {HTMLElement} anElement The element to get the numeric property
     *     value of.
     * @param {String[]} styleProperties The names of the style property to
     *     obtain the value of.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidStyleDeclaration
     * @returns {TP.core.Hash} A TP.core.Hash of Numbers containing the supplied
     *     properties as a pixel value.
     */

    var computedStyle,

        valuesInPixels,

        len,
        i;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(styleProperties)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  Grab the computed style for the element
    if (TP.notValid(computedStyle = TP.elementGetComputedStyleObj(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    valuesInPixels = TP.hc();

    len = styleProperties.getSize();
    for (i = 0; i < len; i++) {
        valuesInPixels.atPut(
            styleProperties.at(i),
            TP.elementGetPixelValue(anElement,
                                    computedStyle[styleProperties.at(i)],
                                    styleProperties.at(i),
                                    wantsTransformed));
    }

    return valuesInPixels;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetComputedTransformMatrix',
function(anElement, wants2DMatrix) {

    /**
     * @method elementGetComputedTransformMatrix
     * @summary Returns the current transformation matrix of the supplied
     *     element.
     * @description This method computes the current transformation matrix of
     *     the supplied element by obtaining any transformation matrix of the
     *     element itself and then walking the parent tree and integrating each
     *     transformation matrix of that element to the computed matrix. This
     *     code derived from: https://gist.github.com/Yaffle/1145197
     *     Note that this method will, by default, return a 4x4 matrix suitable
     *     for use with CSS 3D transforms. By passing true to wants2DMatrix, a
     *     3x2 matrix suitable for use by CSS 2D transforms will be returned.
     * @param {Element} anElement The element to use the transformation from.
     * @param {Boolean} wants2DMatrix An optional parameter that tells the
     *     method whether or not to return a 3x2 matrix for use with CSS 2D
     *     transforms. The default is false.
     * @exception TP.sig.InvalidElement
     * @returns {Number[][]} An Array of Arrays representing the current
     *     transformation matrix.
     */

    var identity,

        matrix,
        currentElement,

        doc,
        win,

        computedStyle,
        computedMatrixString,

        computedMatrix,

        transformedRect,
        rect;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    identity = TP.matrixFromCSSString('matrix(1,0,0,1,0,0)');

    //  Start with the identity matrix
    matrix = identity;

    currentElement = anElement;

    doc = TP.nodeGetDocument(anElement);
    win = TP.nodeGetWindow(anElement);

    while (currentElement && currentElement !== doc.documentElement) {

        //  NB: Firefox has a non-CSSOM-spec compliant way of returning null for
        //  'getComputedStyle' when the element in question is 'display:none'
        //  (or one its parents is). Make sure to account for that.
        computedStyle = win.getComputedStyle(currentElement, null) || {};

        computedMatrixString =
            (computedStyle.OTransform ||
                computedStyle.WebkitTransform ||
                computedStyle.msTransform ||
                computedStyle.MozTransform ||
                computedStyle.transform ||
                'none').replace(/^none$/, 'matrix(1,0,0,1,0,0)');

        computedMatrix = TP.matrixFromCSSString(computedMatrixString);

        matrix = TP.matrixMultiply(matrix, computedMatrix);

        currentElement = currentElement.parentNode;
    }

    //  If the computation resulted in the identity matrix, then there was no
    //  transformation either on the target element or up the chain - just
    //  use the identity matrix here.
    if (TP.str(matrix) === TP.str(identity)) {
        matrix = identity;
    } else {
        matrix = TP.matrixTranslate(
                    matrix, -win.pageXOffset, -win.pageYOffset, 0);

        transformedRect =
                    TP.$elementTransformBoundingClientRect(anElement, matrix);

        rect = anElement.getBoundingClientRect(anElement);
        matrix = TP.matrixTranslate(
                                matrix,
                                rect.left - transformedRect.left,
                                rect.top - transformedRect.top,
                                0);
    }

    if (TP.isValid(matrix) && TP.isTrue(wants2DMatrix)) {
        return TP.matrixAs2DMatrix(matrix);
    }

    return matrix;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetTransformValues',
function(anElement) {

    /**
     * @method elementGetTransformValues
     * @summary Returns the values of any CSS3 transforms of the given Element.
     * @description This code derived from: https://gist.github.com/2329465.
     * @param {Element} anElement The element to retrive the transform
     *     values from.
     * @exception TP.sig.InvalidElement
     * @returns {TP.core.Hash} A hash of values, keyed by the following keys:
     *     TP.ROTATE, TP.SKEW, TP.SCALE, TP.TRANSLATE
     */

    var length,
        normalize,
        dot,
        atan2,
        combine,

        transformMatrix,
        a,
        b,
        c,
        d,
        tx,
        ty,

        translate,
        m,
        scale,
        skew,
        rotate;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    length = function(val) {
        return Math.sqrt(val[0] * val[0] + val[1] * val[1]);
    };

    //  normalizes the length of the passed point to 1

    normalize = function(val) {
        var l;

        l = length(val);

        return l ? [val[0] / l, val[1] / l] : [0, 0];
    };

    //  returns the dot product of the passed points

    dot = function(left, right) {
        return left[0] * right[0] + left[1] * right[1];
    };

    //  returns the principal value of the arc tangent of
    //  y/x, using the signs of both arguments to determine
    //  the quadrant of the return value

    atan2 = Math.atan2;

    /* eslint-disable no-extra-parens */

    combine = function(val1, val2, ascl, bscl) {
        return [
            (ascl * val1[0]) + (bscl * val2[0]),
            (ascl * val1[1]) + (bscl * val2[1])
        ];
    };

    if (TP.notValid(transformMatrix =
                    TP.elementGetTransformMatrix(anElement, true))) {
        return TP.hc(
                TP.ROTATE, 0.0,
                TP.SKEW, 0.0,
                TP.SCALE, TP.ac(1.0, 1.0),
                TP.TRANSLATE, TP.ac(0.0, 0.0));
    }

    a = transformMatrix[0][0];
    b = transformMatrix[1][0];
    c = transformMatrix[0][1];
    d = transformMatrix[1][1];
    tx = transformMatrix[0][2];
    ty = transformMatrix[1][2];

    //  Make sure the matrix is invertible
    if ((a * d - b * c) === 0) {
        return null;
    }

    /* eslint-enable no-extra-parens */

    //  Take care of translation

    translate = [tx, ty];

    //  Put the components into a 2x2 matrix
    m = [[a, b], [c, d]];

    //  Compute X scale factor and normalize first row.

    scale = [length(m[0])];
    m[0] = normalize(m[0]);

    //  Compute shear factor and make 2nd row orthogonal to 1st.

    skew = dot(m[0], m[1]);
    m[1] = combine(m[1], m[0], 1, -skew);

    //  Now, compute Y scale and normalize 2nd row.

    scale[1] = length(m[1]);
    // m[1] = normalize(m[1]) //
    skew /= scale[1];

    //  Now, get the rotation out

    rotate = atan2(m[0][1], m[0][0]);

    //  And convert to degrees
    rotate = rotate * (180 / Math.PI);

    return TP.hc(TP.ROTATE, rotate,
                    TP.SKEW, skew,
                    TP.SCALE, scale,
                    TP.TRANSLATE, translate);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementIsPositioned',
function(anElement) {

    /**
     * @method elementIsPositioned
     * @summary Returns whether or not the supplied element is considered to be
            'positioned' (in the CSS sense).
     * @param {HTMLElement} anElement The element to check to see if it has been
     *     positioned.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidStyleDeclaration
     * @returns {Boolean} Whether or not the element has been positioned.
     */

    var computedStyle,
        positionVal;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  Grab the computed style for the element
    if (TP.notValid(computedStyle =
                    TP.elementGetComputedStyleObj(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    positionVal = computedStyle.position;

    if (positionVal === 'absolute' ||
        positionVal === 'relative' ||
        positionVal === 'fixed') {
        return true;
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementIsTransformed',
function(anElement) {

    /**
     * @method elementIsTransformed
     * @summary Returns whether or not the supplied element has been
     *     transformed with a CSS transformation.
     * @description This method takes into account any CSS transformations that
     *     are applying to the element because a parent of the element has had a
     *     CSS transformation applied to it.
     * @param {HTMLElement} anElement The element to check to see if it has been
     *     transformed.
     * @exception TP.sig.InvalidElement
     * @returns {Boolean} Whether or not the element has been transformed using
     *     CSS transforms.
     */

    var doc,
        win,

        currentElement,

        computedStyle,

        val;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    doc = TP.nodeGetDocument(anElement);
    win = TP.nodeGetWindow(anElement);

    currentElement = anElement;

    //  Got to walk the parent tree - we might be transformed because of a
    //  tranformation applied to a parent.
    while (currentElement && currentElement !== doc.documentElement) {

        computedStyle = win.getComputedStyle(currentElement, null);

        //  NB: Firefox has a non-CSSOM-spec compliant way of returning null for
        //  'getComputedStyle' when the element in question is 'display:none'
        //  (or one its parents is). Make sure to account for that.
        if (TP.notValid(computedStyle)) {
            break;
        }

        if (TP.notEmpty(val = computedStyle.transform)) {
            if (TP.notEmpty(val) && val !== 'none') {
                return true;
            }
        }

        currentElement = currentElement.parentNode;
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementRemoveResizeListener',
function(anElement, aHandler) {

    /**
     * @method elementRemoveResizeListener
     * @summary Removes a 'resize listener' from the supplied element. This
     *     listener would have been registered using
     *     TP.elementAddResizeListener. See that method for more explanation on
     *     how resizing is monitored.
     * @param {HTMLElement} anElement The element to remove a resize listener
     *     from.
     * @param {Function} aHandler The handler Function that was registered when
     *     this listener was added.
     * @exception TP.sig.InvalidElement,TP.sig.InvalidFunction
     */

    var listeners,

        trackerElem,
        trackerFunc;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (!TP.isCallable(aHandler)) {
        return TP.raise(this, 'TP.sig.InvalidFunction');
    }

    //  Grab the Array of resize listeners from the target Element.
    listeners = anElement[TP.RESIZE_LISTENERS];
    if (TP.isEmpty(listeners)) {
        TP.ifWarn() ?
            TP.warn('Can\'t find listeners for: ' + TP.str(anElement)) : 0;

        return;
    }

    //  Splice out the handler from the list of listeners
    listeners.splice(listeners.indexOf(aHandler), 1);

    //  If it's a set of listeners that's using a 'tracker element', then we
    //  need to remove that, if the listeners are empty etc.
    if (TP.isElement(listeners.tracker)) {

        if (TP.isEmpty(listeners)) {
            //  Grab the tracker element and function from where they were
            //  placed by the TP.elementAddResizeListener method - directly on
            //  the listener Array.
            trackerElem = listeners.tracker;
            trackerFunc = listeners.trackerFunc;

            //  Remove the tracker function as a tracker element's
            //  contentWindow's resize listener and remove the tracker element
            //  from the target element. Note that sometimes, in a detachment
            //  scenario, the tracker element's contentWindow will already be
            //  gone. So we test for that here before accessing it.
            if (TP.isWindow(trackerElem.contentWindow)) {
                trackerElem.contentWindow.removeEventListener(
                                                'resize', trackerFunc);
            }
            anElement.removeChild(trackerElem);

            //  Null out all references for GC purposes and return

            listeners.trackerFunc = null;
            listeners.tracker = null;

            anElement[TP.RESIZE_LISTENERS] = null;
        }

    } else {
        //  If we're using ResizeObserver and the listener list is now empty,
        //  remove the element from the global ResizeObserver machinery.
        if (TP.isEmpty(listeners)) {
            TP.RESIZING_RESIZE_OBSERVER.unobserve(anElement);
            anElement[TP.RESIZE_LISTENERS] = null;
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementSelectContent',
function(anElement, includeElement) {

    /**
     * @method elementSelectContent
     * @summary Selects the content of the supplied Element. If the Element is
     *     an 'input element' of some sort (i.e. an 'input' or 'textarea'
     *     element), this method selects its text content.
     * @param {HTMLElement} anElement The element to select the content of.
     * @param {Boolean} includeElement Whether or not the element itself should
     *     be included in the selection. Note that this setting has no meaning
     *     if the element is a sort of 'input element'. The default is false.
     * @exception TP.sig.InvalidElement
     */

    var elementName,

        theSelection,

        theRange;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  Grab the element name
    elementName = TP.elementGetLocalName(anElement).toLowerCase();

    /* eslint-disable no-extra-parens */

    //  If it's one of the 'input type' elements (i.e. 'input' or
    //  'textarea'), then we can use a special call and exit here.
    if ((elementName === 'input' && anElement.type === 'text') ||
        elementName === 'textarea') {
        anElement.setSelectionRange(0, anElement.value.length);

        return;
    }

    /* eslint-enable no-extra-parens */

    //  Grab the selection object and make sure its real
    theSelection = TP.nodeGetWindow(anElement).getSelection();
    if (TP.notValid(theSelection)) {
        return;
    }

    //  If we're supposed to include the element, then we need to create a
    //  Range object, use it to select the element, clear any existing
    //  ranges, and add the new Range to the selection.
    if (TP.isTrue(includeElement)) {
        theRange = TP.nodeGetDocument(anElement).createRange();
        if (TP.isValid(theRange)) {
            theRange.selectNode(anElement);
            theSelection.removeAllRanges();
            theSelection.addRange(theRange);
        }
    } else {
        //  Otherwise, we're only selecting children of the element, so
        //  W3C-compliant browsers provide a nice convenience method for us.
        theSelection.selectAllChildren(anElement);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementSetClass',
function(anElement, aClassName) {

    /**
     * @method elementSetClass
     * @summary Sets the element's CSS class name(s) to the supplied CSS class
     *     name(s). Note that if the class name is null, the 'class' attribute
     *     will be removed from the element.
     * @param {Element} anElement The element to set the CSS class name for.
     * @param {String} aClassName Class name(s) to use as the CSS class names
     *     for the element.
     * @exception TP.sig.InvalidElement
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.notValid(aClassName)) {
        TP.elementRemoveAttribute(anElement, 'class');
    } else {
        //  NB: We use native 'setAttribute' call here, or we'll recurse
        //  into TP.elementSetAttribute()
        anElement.setAttribute('class', aClassName);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementSetOpacity',
function(anElement, opacityLevel) {

    /**
     * @method elementSetOpacity
     * @summary Sets the element's opacity level. The level should be a
     *     fractional number between 0 and 1 that will represent the percentage
     *     of opacity the element should be set to (e.g. it should be '.5' to
     *     set the element to 50% opacity).
     * @param {HTMLElement} anElement The element to set the opacity of.
     * @param {Number|String} opacityLevel The fractional number to set the
     *     opacity to or the empty String ('') to clear the element's opacity
     *     value.
     * @exception TP.sig.InvalidElement
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    TP.elementGetStyleObj(anElement).opacity = opacityLevel;

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$elementTransformBoundingClientRect',
function(anElement, transformationMatrix) {

    /**
     * @method $elementTransformBoundingClientRect
     * @summary Transforms the bounding client rect of the supplied element
     *     using the supplied transformation matrix
     * @description This code derived from:
     *     https://gist.github.com/Yaffle/1145197
     * @param {Element} anElement The element to compute the bounding client
     *     rect for.
     * @param {Number[][]} transformationMatrix An Array of Arrays representing
     *     the transformation matrix.
     * @exception TP.sig.InvalidElement
     * @returns {Object} An Object with left, top, right and bottom properties
     *     representing the bounding client rect.
     */

    var points;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    points = TP.matrixMultiply(
        TP.matrixAs3DMatrix(transformationMatrix),
        [
            [0, anElement.offsetWidth, 0, anElement.offsetWidth],
            [0, 0, anElement.offsetHeight, 0, anElement.offsetHeight],
            [0, 0, 0, 0],
            [1, 1, 1, 1]
        ]
    );

    return {
        left: Math.min.apply(Math, points[0]),
        top: Math.min.apply(Math, points[1]),
        right: Math.max.apply(Math, points[0]),
        bottom: Math.max.apply(Math, points[1])
    };
});

//  ------------------------------------------------------------------------

TP.definePrimitive('textElementInsertContent',
function(anElement, aContent) {

    /**
     * @method textElementInsertContent
     * @summary Inserts the supplied content at the element's insertion point.
     * @description Note that this method focuses the text element in question.
     *     It also ensures that the supplied element is a 'textarea' or an
     *     'input' with 'type="text"' and will raise an TP.sig.InvalidElement
     *     exception if its not.
     * @param {Element} anElement The 'input type="text"' or 'textarea' element
     *     to insert content into.
     * @param {String} aContent The content to insert.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidString
     */

    var elementName,
        start,
        end;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    elementName = TP.elementGetLocalName(anElement).toLowerCase();
    if (elementName !== 'textarea' &&
        (elementName !== 'input' || anElement.type !== 'text')) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (!TP.isString(aContent)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    try {
        anElement.focus();

        if (TP.isNumber(anElement.selectionStart)) {
            start = anElement.selectionStart;
            end = anElement.selectionEnd;

            anElement.value = anElement.value.substr(0, start) +
                                    aContent +
                                    anElement.value.substr(end);

            anElement.selectionStart = start + aContent.length;
            anElement.selectionEnd = start + aContent.length;
        } else {
            anElement.value += aContent;
        }
    } catch (e) {
        return TP.raise(this, 'TP.sig.DOMComponentException',
                        TP.ec(e));
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('textElementReplaceSelection',
function(anElement, aContent) {

    /**
     * @method textElementReplaceSelection
     * @summary Replaces the element's current selection (could be empty) with
     *     the supplied content.
     * @description Note that this method focuses the text element in question.
     *     It also ensures that the supplied element is a 'textarea' or an
     *     'input' with 'type="text"' and will raise an TP.sig.InvalidElement
     *     exception if its not.
     * @param {Element} anElement The 'input type="text"' or 'textarea' element
     *     to replace the selection of.
     * @param {String} aContent The content to use as the replacement.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidString
     */

    var elementName,

        selStart,
        selEnd;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    elementName = TP.elementGetLocalName(anElement).toLowerCase();
    if (elementName !== 'textarea' &&
        (elementName !== 'input' || anElement.type !== 'text')) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (!TP.isString(aContent)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    try {
        selStart = anElement.selectionStart;
        selEnd = anElement.selectionEnd;

        anElement.value = TP.join(anElement.value.substring(0, selStart),
                                    aContent,
                                    anElement.value.substring(selEnd));

        anElement.setSelectionRange(selStart + aContent.length,
                                    selStart + aContent.length);

    } catch (e) {
        return TP.raise(this, 'TP.sig.DOMComponentException',
                        TP.ec(e));
    }

    return;
});

//  ------------------------------------------------------------------------
//  NODE PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetTopWindow',
function(aNode) {

    /**
     * @method nodeGetTopWindow
     * @summary Returns the node's 'top' window - that is, the window that
     *     represents the 'top' of the window hierarchy where the node is
     *     situated.
     * @param {Node} aNode The node to use.
     * @exception TP.sig.InvalidNode
     * @returns {Window} The supplied node's top-level window.
     */

    var win;

    //  The node is in a window context that has a '$$topWindow' reference wired
    //  in - this takes precedence over everything else.
    win = TP.nodeGetWindow(aNode).$$topWindow;
    if (TP.isWindow(win)) {
        return win;
    }

    //  Otherwise, just return what TIBET considers to be its top-level window.
    return TP.topWindow;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetWindow',
function(aNode) {

    /**
     * @method nodeGetWindow
     * @summary Returns the node's window.
     * @param {Node} aNode The node to use.
     * @exception TP.sig.InvalidNode
     * @returns {Window}
     */

    //  Note that we don't check for an HTML document here, even though that
    //  might seem logical. A lot of times an XML document will be passed in
    //  and the caller is depending on this method returning null.

    if (aNode === null) {
        return;
    }

    if (aNode.nodeType === Node.DOCUMENT_NODE) {
        return aNode.defaultView;
    } else if (aNode.ownerDocument !== undefined) {
        return aNode.ownerDocument.defaultView;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeHasWindow',
function(aNode) {

    /**
     * @method nodeHasWindow
     * @summary Returns true if the node provided appears to be in a document
     *     that is situated within a Window.
     * @param {Node} aNode The DOM node to operate on.
     * @returns {Boolean} True if the node is in a document that is in a window.
     * @exception TP.sig.InvalidNode Raised when an object that isn't a Node is
     *     provided to the method.
     */

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    return TP.isWindow(TP.nodeGetWindow(aNode));
});

//  ------------------------------------------------------------------------
//  WINDOW PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('windowArmEvents',
function(aWindow, eventNameArray, aHandler) {

    /**
     * @method windowArmEvents
     * @summary Arms all elements in the window's document to fire the events
     *     named in eventNameArray.
     * @param {Window} aWindow The window to arm events for.
     * @param {String[]} eventNameArray The array of event names to instrument
     *     all elements in the document to fire.
     * @param {Function} aHandler An (optional) parameter that defines a native
     *     handler to be used instead of the default handler.
     * @exception TP.sig.InvalidWindow
     * @exception TP.sig.InvalidArray
     */

    var i,
        len,
        eventName,
        nativeEventName,
        handler;

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (TP.isEmpty(eventNameArray)) {
        return TP.raise(this, 'TP.sig.InvalidArray');
    }

    handler = TP.ifInvalid(aHandler, TP.$dispatchEventToTIBET);

    //  Put the handler on the document and register it to be a
    //  bubbling handler (by supplying 'false' as the third
    //  parameter) so that it always gets the event last.
    len = eventNameArray.getSize();
    for (i = 0; i < len; i++) {
        eventName = eventNameArray.at(i);
        nativeEventName = TP.$getEventNameForSignalName(eventName);

        aWindow.document.addEventListener(nativeEventName,
                                            handler,
                                            false);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowConstructObject',
function(aWindow, objectName) {

    /**
     * @method windowConstructObject
     * @summary Constructs an object in another Window, using that the named
     *     object as the constructor *in the target Window* to construct the
     *     object. Note that this function also passes along any additional
     *     arguments to this function to the constructor.
     * @param {Window} aWindow The window to construct the object in.
     * @param {String} objectName The 'type name' of the object to construct.
     * @exception TP.sig.InvalidWindow
     * @returns {Object}
     */

    var constructorObj,
        $$newinst;

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    constructorObj = aWindow[objectName];

    if (TP.notValid(constructorObj)) {
        return null;
    }

    //  we start by using the built-in constructor for any arguments so
    //  behavior is consistent with native JS, and then we try parsing on
    //  our own
    /* eslint-disable new-cap */
    switch (arguments.length) {
        case 2:
            $$newinst = new constructorObj();
            break;
        case 3:
            $$newinst = new constructorObj(arguments[2]);
            break;
        case 4:
            $$newinst = new constructorObj(arguments[2], arguments[3]);
            break;
        case 5:
            $$newinst = new constructorObj(arguments[2], arguments[3],
                                            arguments[4]);
            break;
        case 6:
            $$newinst = new constructorObj(arguments[2], arguments[3],
                                            arguments[4], arguments[5]);
            break;
        case 7:
            $$newinst = new constructorObj(arguments[2], arguments[3],
                                            arguments[4], arguments[5],
                                            arguments[6]);
            break;
        case 8:
            $$newinst = new constructorObj(arguments[2], arguments[3],
                                            arguments[4], arguments[5],
                                            arguments[6], arguments[7]);
            break;
        case 9:
            $$newinst = new constructorObj(arguments[2], arguments[3],
                                            arguments[4], arguments[5],
                                            arguments[6], arguments[7],
                                            arguments[8]);
            break;
        default:
            //  TODO: reevaluate when this would be used.
            /* eslint-disable no-eval */
            eval('$$newinst = new constructorObj(' +
                TP.sys.$buildArgString(2, arguments.length) + ');');
            /* eslint-enable no-eval */
            break;
    }
    /* eslint-enable new-cap */

    return $$newinst;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowDisarmEvents',
function(aWindow, eventNameArray, aHandler) {

    /**
     * @method windowDisarmEvents
     * @summary Disarms all elements in the window's document for the events
     *     named in eventNameArray.
     * @param {Window} aWindow The window whose element(s) should be disarmed.
     * @param {String[]} eventNameArray The array of event names to disarm.
     * @param {Function} aHandler An (optional) parameter that defines a native
     *     handler that was used instead of the default handler for TIBET.
     * @exception TP.sig.InvalidWindow
     * @exception TP.sig.InvalidArray
     */

    var i,
        len,
        eventName,
        nativeEventName,
        handler;

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (TP.isEmpty(eventNameArray)) {
        return TP.raise(this, 'TP.sig.InvalidArray');
    }

    handler = TP.ifInvalid(aHandler, TP.$dispatchEventToTIBET);

    len = eventNameArray.getSize();
    for (i = 0; i < len; i++) {
        eventName = eventNameArray.at(i);
        nativeEventName = TP.$getEventNameForSignalName(eventName);

        aWindow.document.removeEventListener(nativeEventName,
                                                    handler,
                                                    false);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowGetInnerHeight',
function(aWindow) {

    /**
     * @method windowGetInnerHeight
     * @summary Returns the window's inner height (the height not including
     *     scrollbars, button bars, etc.).
     * @param {Window} aWindow The window to get the inner height of.
     * @exception TP.sig.InvalidWindow
     * @returns {Number} The window's inner height.
     */

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    return aWindow.innerHeight;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowGetInnerWidth',
function(aWindow) {

    /**
     * @method windowGetInnerWidth
     * @summary Returns the window's inner width (the width not including
     *     scrollbars, button bars, etc.).
     * @param {Window} aWindow The window to get the inner width of.
     * @exception TP.sig.InvalidWindow
     * @returns {Number} The window's inner width.
     */

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    return aWindow.innerWidth;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowGetOuterHeight',
function(aWindow) {

    /**
     * @method windowGetOuterHeight
     * @summary Returns the window's outer height (the height including
     *     scrollbars, button bars, etc.).
     * @param {Window} aWindow The window to get the outer height of.
     * @exception TP.sig.InvalidWindow
     * @returns {Number} The window's outer height.
     */

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    return aWindow.outerHeight;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowGetOuterWidth',
function(aWindow) {

    /**
     * @method windowGetOuterWidth
     * @summary Returns the window's outer width (the width including
     *     scrollbars, button bars, etc.).
     * @param {Window} aWindow The window to get the outer width of.
     * @exception TP.sig.InvalidWindow
     * @returns {Number} The window's outer width.
     */

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    return aWindow.outerWidth;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowGetX',
function(aWindow) {

    /**
     * @method windowGetX
     * @summary Returns the window's X position on the overall screen.
     * @param {Window} aWindow The window to get the X position of.
     * @exception TP.sig.InvalidWindow
     * @returns {Number} The window's X position on the screen in pixels.
     */

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    return aWindow.screenX;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowGetY',
function(aWindow) {

    /**
     * @method windowGetY
     * @summary Returns the window's Y position on the overall screen.
     * @param {Window} aWindow The window to get the Y position of.
     * @exception TP.sig.InvalidWindow
     * @returns {Number} The window's Y position on the screen in pixels.
     */

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    return aWindow.screenY;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowInstallOnlineOfflineHook',
function(aWindow) {

    /**
     * @method windowInstallOnlineOfflineHook
     * @summary Installs event handlers for online / offline events which then
     *     rebroadcasts those events as 'AppOnline' / 'AppOffline' signals.
     * @param {Window} aWindow The window to install the online/offline event
     *     hooks onto.
     * @exception TP.sig.InvalidWindow
     * @exception TP.sig.InvalidElement
     */

    var bodyElem;

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (!TP.isElement(bodyElem = TP.documentGetBody(aWindow.document))) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    bodyElem.addEventListener(
                'online',
                function() {

                    TP.sys.isOffline(false);
                    TP.signal(null, 'TP.sig.AppOnline');
                },
                false);

    bodyElem.addEventListener(
                'offline',
                function() {

                    TP.sys.isOffline(true);
                    TP.signal(null, 'TP.sig.AppOffline');
                },
                false);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowInstallDocumentVisibilityHook',
function(aWindow) {

    /**
     * @method windowInstallDocumentVisibilityHook
     * @summary Installs event handlers for the 'visibility change' event
     *     which then rebroadcasts that event as 'DocumentVisible' /
     *     'DocumentInvisible' events.
     * @param {Window} aWindow The window to install the document visibility
     *     change event hooks onto.
     * @exception TP.sig.InvalidWindow
     * @exception TP.sig.InvalidDocument
     */

    var doc;

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (!TP.isDocument(doc = aWindow.document)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    doc.addEventListener(
                'visibilitychange',
                function() {

                    if (TP.documentIsVisible(doc)) {
                        TP.signal(null,
                            'TP.sig.DocumentVisible',
                            TP.documentGetVisibility(doc));
                    } else {
                        TP.signal(null,
                            'TP.sig.DocumentInvisible',
                            TP.documentGetVisibility(doc));
                    }
                },
                false);

    return;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETDHTMLPrimitivesPlatform.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
Platform-specific functionality related to DHTML operations.
*/

/* global WebKitPoint:false
*/

//  ------------------------------------------------------------------------
//  DOCUMENT PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('documentConstructIFrameElement',
TP.hc(
    'test',
    'webkit',
    'true',
    function(aDocument, forcedMIMEType, iframeID) {

        /**
         * @method documentConstructIFrameElement
         * @summary Creates an (X)HTML 'iframe' element in the document and
         *     'initializes' it to make sure its set up for manipulation.
         * @description In order for the frame element produced by this routine
         *     to have been properly set up, it will be appended to the supplied
         *     document and will be returned that way. If a forced MIME type
         *     isn't supplied, then the supplied Document will be queried to
         *     determine whether it is an HTML or XHTML document and the
         *     document of the iframe will be that type of document. Note also
         *     that the returned element could either be an 'iframe' element or
         *     an 'object' element depending on whether an HTML or XHTML iframe
         *     is to be created.
         * @param {Document} aDocument The document to create the iframe element
         *     in.
         * @param {String} forcedMIMEType The MIME type that should be used to
         *     determine the kind of document that should be used inside of the
         *     iframe. The two supported kinds of MIME type are currently:
         *     TP.ietf.mime.HTML TP.ietf.mime.XHTML.
         * @param {String} iframeID Optional. If supplied, and the type of
         *     document to create in the iframe is XHTML, this routine will
         *     properly register this ID with the 'frames' array of aDocument's
         *     window.
         * @exception TP.sig.InvalidDocument
         * @returns {HTMLElement} The 'iframe' (or 'object' if XHTML) element
         *     created in the supplied document.
         */

        var docMIMEType,

            newIFrameElement,
            iframeDoc,

            frmID;

        if (!TP.isDocument(aDocument)) {
            return TP.raise(this, 'TP.sig.InvalidDocument');
        }

        if (TP.isString(forcedMIMEType)) {
            docMIMEType = forcedMIMEType;
        } else {
            if (TP.isHTMLDocument(aDocument)) {
                docMIMEType = TP.ietf.mime.HTML;
            } else {
                docMIMEType = TP.ietf.mime.XHTML;
            }
        }

        if (docMIMEType === TP.ietf.mime.HTML) {
            newIFrameElement = TP.documentConstructElement(aDocument,
                                                            'iframe',
                                                            TP.w3.Xmlns.XHTML);

            //  For IE...
            TP.elementSetAttribute(newIFrameElement, 'frameborder', 0);

            if (TP.isString(iframeID)) {
                TP.elementSetAttribute(newIFrameElement, 'id', iframeID);
            }

            //  Need to append this iframe to the document to be able to
            //  initialize it properly below. Pass 'false' in here to not
            //  worry about awakening.
            TP.nodeAppendChild(TP.documentGetBody(aDocument),
                                newIFrameElement,
                                false);

            //  Grab the document from the iframe and write a blank document
            //  into it to prep the document (making sure it has 'head' and
            //  'body' elements).
            iframeDoc = TP.elementGetIFrameDocument(newIFrameElement);

            iframeDoc.open();
            iframeDoc.write('<html><head><meta http-equiv="X-UA-Compatible" content="IE=9" /></head><body></body></html>');
            iframeDoc.close();
        } else {
            //  For XHTML documents, we actually create 'object' elements

            //  On Webkit-based browsers, we have to do this a bit
            //  differently to make it 'take'

            //  First, we create a 'span' element.
            newIFrameElement = TP.documentConstructElement(aDocument,
                                                            'span',
                                                            TP.w3.Xmlns.XHTML);


            //  Need to append this iframe to the document to be able to
            //  initialize it properly below. Pass 'false' in here to not
            //  worry about awakening.
            TP.nodeAppendChild(TP.documentGetBody(aDocument),
                                newIFrameElement,
                                false);

            //  Having an ID here isn't optional - we need it to grab a
            //  handle to the object, so we generate one here if necessary.
            //  The caller can always reset it...
            TP.regex.INVALID_ID_CHARS.lastIndex = 0;
            frmID = TP.isString(iframeID) ?
                        iframeID :
                        TP.genID('html_object').replace(
                                TP.regex.INVALID_ID_CHARS, '_');

            //  Set the outerHTML of the span wrapper. This will obliterate
            //  the span, but leave the 'object' element.
            newIFrameElement.outerHTML = '<object id="' + frmID + '" type="application/xhtml+xml" data="data:application/xhtml+xml,&lt;?xml version=&quot;1.0&quot;?&gt;&lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Strict//EN&quot; &quot;http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd&quot;&gt;&lt;html xmlns=&quot;http://www.w3.org/1999/xhtml&quot;&gt;&lt;body&gt;&lt;/body&gt;&lt;/html&gt;"><p>Couldn\'t create XHTML iframe...</p></object>';

            //  Note the reassignment here - the span is gone.
            newIFrameElement = TP.nodeGetElementById(aDocument, frmID);

            //  Grab the document from the iframe and write a blank document
            //  into it to prep the document (making sure it has 'head' and
            //  'body' elements).
            iframeDoc = TP.elementGetIFrameDocument(newIFrameElement);

            //  For some reason, these properties don't get wired

            newIFrameElement.contentWindow = TP.nodeGetWindow(iframeDoc);

            if (TP.isString(iframeID)) {
                TP.nodeGetWindow(aDocument).frames[iframeID] =
                    TP.nodeGetWindow(iframeDoc);
            }
        }

        return newIFrameElement;
    },
    TP.DEFAULT,
    function(aDocument, forcedMIMEType, iframeID) {

        /**
         * @method documentConstructIFrameElement
         * @summary Creates an (X)HTML 'iframe' element in the document and
         *     'initializes' it to make sure its set up for manipulation.
         * @description In order for the frame element produced by this routine
         *     to have been properly set up, it will be appended to the supplied
         *     document and will be returned that way. If a forced MIME type
         *     isn't supplied, then the supplied Document will be queried to
         *     determine whether it is an HTML or XHTML document and the
         *     document of the iframe will be that type of document. Note also
         *     that the returned element could either be an 'iframe' element or
         *     an 'object' element depending on whether an HTML or XHTML iframe
         *     is to be created.
         * @param {Document} aDocument The document to create the iframe element
         *     in.
         * @param {String} forcedMIMEType The MIME type that should be used to
         *     determine the kind of document that should be used inside of the
         *     iframe. The two supported kinds of MIME type are currently:
         *     TP.ietf.mime.HTML TP.ietf.mime.XHTML.
         * @param {String} iframeID Optional. If supplied, and the type of
         *     document to create in the iframe is XHTML, this routine will
         *     properly register this ID with the 'frames' array of aDocument's
         *     window.
         * @exception TP.sig.InvalidDocument
         * @returns {HTMLElement} The 'iframe' (or 'object' if XHTML) element
         *     created in the supplied document.
         */

        var docMIMEType,

            newIFrameElement,
            iframeDoc;

        if (!TP.isDocument(aDocument)) {
            return TP.raise(this, 'TP.sig.InvalidDocument');
        }

        if (TP.isString(forcedMIMEType)) {
            docMIMEType = forcedMIMEType;
        } else {
            if (TP.isHTMLDocument(aDocument)) {
                docMIMEType = TP.ietf.mime.HTML;
            } else {
                docMIMEType = TP.ietf.mime.XHTML;
            }
        }

        if (docMIMEType === TP.ietf.mime.HTML) {
            newIFrameElement = TP.documentConstructElement(aDocument,
                                                            'iframe',
                                                            TP.w3.Xmlns.XHTML);

            //  For IE...
            TP.elementSetAttribute(newIFrameElement, 'frameborder', 0);

            if (TP.isString(iframeID)) {
                TP.elementSetAttribute(newIFrameElement, 'id', iframeID);
            }

            //  Need to append this iframe to the document to be able to
            //  initialize it properly below. Pass 'false' in here to not
            //  worry about awakening.
            TP.nodeAppendChild(TP.documentGetBody(aDocument),
                                newIFrameElement,
                                false);

            //  Grab the document from the iframe and write a blank document
            //  into it to prep the document (making sure it has 'head' and
            //  'body' elements).
            iframeDoc = TP.elementGetIFrameDocument(newIFrameElement);

            iframeDoc.open();
            iframeDoc.write('<html><head><meta http-equiv="X-UA-Compatible" content="IE=9" /></head><body></body></html>');
            iframeDoc.close();
        } else {
            //  For XHTML documents, we actually create 'object' elements

            newIFrameElement = TP.documentConstructElement(aDocument,
                                                        'object',
                                                        TP.w3.Xmlns.XHTML);

            if (TP.isString(iframeID)) {
                TP.elementSetAttribute(newIFrameElement, 'id', iframeID);
            }

            TP.elementSetAttribute(newIFrameElement,
                                    'type',
                                    TP.XHTML_ENCODED);
            TP.elementSetAttribute(newIFrameElement, 'data', 'data:application/xhtml+xml,<?xml version="1.0"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><body></body></html>');

            //  Need to append this iframe to the document to be able to
            //  initialize it properly below. Pass 'false' in here to not
            //  worry about awakening.
            TP.nodeAppendChild(TP.documentGetBody(aDocument),
                                newIFrameElement,
                                false);

            //  Grab the document from the iframe and write a blank document
            //  into it to prep the document (making sure it has 'head' and
            //  'body' elements).
            iframeDoc = TP.elementGetIFrameDocument(newIFrameElement);

            //  For some reason, these properties don't get wired

            newIFrameElement.contentWindow = TP.nodeGetWindow(iframeDoc);

            if (TP.isString(iframeID)) {
                TP.nodeGetWindow(aDocument).frames[iframeID] =
                    TP.nodeGetWindow(iframeDoc);
            }
        }

        return newIFrameElement;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('documentConstructEvent',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(aDocument, anEventSpec) {

        /**
         * @method documentConstructEvent
         * @summary Creates a native Event object, populating it with the event
         *     spec data provided. The spec must exist, and must contain a
         *     'type' key to construct a valid Event. NOTE that the keys in the
         *     event spec must match those expected for the particular event,
         *     making this method somewhat touchy with respect to input.
         * @param {Document} aDocument The native document the event will be
         *     created within. Default is TIBET's current UI canvas document.
         * @param {Event|TP.core.Hash} anEventSpec A hash containing the event
         *     specification as key/value pairs.
         * @returns {Event} The newly constructed native Event.
         */

        var spec,
            doc,
            type,
            evt,

            modifiers;

        if (TP.isEvent(anEventSpec)) {
            spec = anEventSpec;

            //  Go ahead and instance program an 'at' function on the Event
            //  object, so that calls below work without a lot of shuffle.
            spec.at = function(aKey) {
                return this[aKey];
            };
        } else if (TP.isValid(anEventSpec)) {
            spec = TP.hc(anEventSpec);
        } else {
            spec = TP.hc();
        }

        doc = aDocument;
        if (TP.notValid(doc)) {
            doc = TP.sys.getUICanvas().getNativeDocument();
        }

        type = TP.ifKeyInvalid(spec, 'type');
        switch (type) {
            //  HTML Events
            case 'abort':
            case 'blur':
            case 'change':
            case 'error':
            case 'focus':
            case 'load':
            case 'reset':
            case 'resize':
            case 'scroll':
            case 'select':
            case 'submit':
            case 'unload':
                evt = doc.createEvent('HTMLEvents');
                evt.initEvent(
                            type,
                            TP.ifKeyInvalid(spec, 'bubbles', true),
                            TP.ifKeyInvalid(spec, 'cancelable', true));
                break;

            //  UI Events
            case 'focusin':
            case 'focusout':
            case 'input':
                evt = doc.createEvent('UIEvents');
                evt.initUIEvent(
                            type,
                            TP.ifKeyInvalid(spec, 'bubbles', true),
                            TP.ifKeyInvalid(spec, 'cancelable', true),
                            TP.ifKeyInvalid(spec,
                                            'view',
                                            TP.nodeGetWindow(doc)),
                            TP.ifKeyInvalid(spec, 'detail', 0));
                break;

            //  Key Events
            case 'keydown':
            case 'keypress':
            case 'keyup':
                evt = doc.createEvent('KeyboardEvent');

                modifiers = (
                            (spec.at('ctrlKey') ? 'Control' : '') +
                            (spec.at('shiftKey') ? ' Shift' : '') +
                            (spec.at('altKey') ? ' Alt' : '') +
                            (spec.at('metaKey') ? ' Meta' : '')).trim();

                evt.initKeyboardEvent(
                            type,
                            TP.ifKeyInvalid(spec, 'bubbles', true),
                            TP.ifKeyInvalid(spec, 'cancelable', true),
                            TP.ifKeyInvalid(spec,
                                            'view',
                                            TP.nodeGetWindow(doc)),
                            TP.ifKeyInvalid(spec, 'char', null),
                            TP.ifKeyInvalid(spec, 'key', null),
                            TP.ifKeyInvalid(spec, 'location', null),
                            modifiers,
                            TP.ifKeyInvalid(spec, 'repeat', 0),
                            TP.ifKeyInvalid(spec, 'locale', 0));
                break;

            //  Mouse Events
            case 'click':
            case 'dblclick':
            case 'mousedown':
            case 'mouseenter':
            case 'mousemove':
            case 'mouseleave':
            case 'mouseout':
            case 'mouseover':
            case 'mouseup':
                evt = doc.createEvent('MouseEvents');
                evt.initMouseEvent(
                            type,
                            TP.ifKeyInvalid(spec, 'bubbles', true),
                            TP.ifKeyInvalid(spec, 'cancelable', true),
                            TP.ifKeyInvalid(spec,
                                            'view',
                                            TP.nodeGetWindow(doc)),
                            TP.ifKeyInvalid(spec, 'detail', 0),
                            TP.ifKeyInvalid(spec, 'screenX', 0),
                            TP.ifKeyInvalid(spec, 'screenY', 0),
                            TP.ifKeyInvalid(spec, 'clientX', 0),
                            TP.ifKeyInvalid(spec, 'clientY', 0),
                            TP.ifKeyInvalid(spec, 'ctrlKey', false),
                            TP.ifKeyInvalid(spec, 'altKey', false),
                            TP.ifKeyInvalid(spec, 'shiftKey', false),
                            TP.ifKeyInvalid(spec, 'metaKey', false),
                            TP.ifKeyInvalid(spec, 'button', 0),
                            TP.ifKeyInvalid(spec, 'relatedTarget', null));

                evt.$$pageX = TP.ifKeyInvalid(spec, 'pageX', 0);
                evt.$$pageY = TP.ifKeyInvalid(spec, 'pageY', 0);
                evt.$$offsetX = TP.ifKeyInvalid(spec, 'offsetX', 0);
                evt.$$offsetY = TP.ifKeyInvalid(spec, 'offsetY', 0);

                break;

            //  Mouse Scroll Events
            case 'DOMMouseScroll':
                evt = doc.createEvent('MouseScrollEvents');
                evt.initMouseScrollEvent(
                            type,
                            TP.ifKeyInvalid(spec, 'bubbles', true),
                            TP.ifKeyInvalid(spec, 'cancelable', true),
                            TP.ifKeyInvalid(spec,
                                            'view',
                                            TP.nodeGetWindow(doc)),
                            TP.ifKeyInvalid(spec, 'detail', 0),
                            TP.ifKeyInvalid(spec, 'screenX', 0),
                            TP.ifKeyInvalid(spec, 'screenY', 0),
                            TP.ifKeyInvalid(spec, 'clientX', 0),
                            TP.ifKeyInvalid(spec, 'clientY', 0),
                            TP.ifKeyInvalid(spec, 'ctrlKey', false),
                            TP.ifKeyInvalid(spec, 'altKey', false),
                            TP.ifKeyInvalid(spec, 'shiftKey', false),
                            TP.ifKeyInvalid(spec, 'metaKey', false),
                            TP.ifKeyInvalid(spec, 'button', 0),
                            TP.ifKeyInvalid(spec, 'relatedTarget', null),
                            //  1 for horizontal, 2 for vertical
                            TP.ifKeyInvalid(spec, 'axis', 2));

                evt.$$pageX = TP.ifKeyInvalid(spec, 'pageX', 0);
                evt.$$pageY = TP.ifKeyInvalid(spec, 'pageY', 0);
                evt.$$offsetX = TP.ifKeyInvalid(spec, 'offsetX', 0);
                evt.$$offsetY = TP.ifKeyInvalid(spec, 'offsetY', 0);

                break;

            //  Mutation Events
            case 'DOMAttrModified':
            case 'DOMNodeInserted':
            case 'DOMNodeRemoved':
            case 'DOMCharacterDataModified':
            case 'DOMNodeInsertedIntoDocument':
            case 'DOMNodeRemovedFromDocument':
            case 'DOMSubtreeModified':
                evt = doc.createEvent('MutationEvents');
                evt.initMutationEvent(
                            type,
                            TP.ifKeyInvalid(spec, 'bubbles', true),
                            TP.ifKeyInvalid(spec, 'cancelable', true),
                            TP.ifKeyInvalid(spec, 'relatedTarget', null),
                            TP.ifKeyInvalid(spec, 'prevValue', null),
                            TP.ifKeyInvalid(spec, 'newValue', null),
                            TP.ifKeyInvalid(spec, 'attrName', null),
                            TP.ifKeyInvalid(spec, 'attrChange', null));
                break;

            //  Transition Events
            case 'transitionend':
                //  Not currently supported to generate these by most browsers.
                break;

            //  Animation Events
            case 'animationend':
                //  Not currently supported to generate these by most browsers.
                break;

            default:
                evt = doc.createEvent('Events');
                evt.initEvent(
                            type,
                            TP.ifKeyInvalid(spec, 'bubbles', true),
                            TP.ifKeyInvalid(spec, 'cancelable', true));

                //  Not an officially-defined event. Just put the slots from
                //  the supplied hash onto the Event as instance properties.
                TP.keys(spec).perform(
                        function(aKey) {
                            //  Got to filter out specified properties -
                            //  Mozilla will throw an exception.
                            if (TP.W3C_EVENT_PROPERTIES.test(aKey) ||
                                TP.EXTRA_EVENT_PROPERTIES.test(aKey)) {
                                return;
                            }

                            evt[aKey] = spec.at(aKey);
                        });

                break;
        }

        //  additional properties not necessarily covered by spec
        TP.TIBET_EVENT_PROPERTIES.perform(
            function(item) {
                try {
                    evt[item] = spec.at(item.slice(2));
                } catch (e) {
                    TP.ifError() ?
                        TP.error(TP.ec(e, 'Error configuring event.')) : 0;
                }
            });

        return evt;
    },
    'webkit',
    function(aDocument, anEventSpec) {

        /**
         * @method documentConstructEvent
         * @summary Creates a native Event object, populating it with the event
         *     spec data provided. The spec must exist, and must contain a
         *     'type' key to construct a valid Event. NOTE that the keys in the
         *     event spec must match those expected for the particular event,
         *     making this method somewhat touchy with respect to input.
         * @param {Document} aDocument The native document the event will be
         *     created within. Default is TIBET's current UI canvas document.
         * @param {Event|TP.core.Hash} anEventSpec A hash containing the event
         *     specification as key/value pairs.
         * @returns {Event} The newly constructed native Event.
         */

        var spec,
            doc,
            type,
            evt;

        if (TP.isEvent(anEventSpec)) {
            spec = anEventSpec;

            //  Go ahead and instance program an 'at' function on the Event
            //  object, so that calls below work without a lot of shuffle.
            spec.at = function(aKey) {
                return this[aKey];
            };
        } else if (TP.isValid(anEventSpec)) {
            spec = TP.hc(anEventSpec);
        } else {
            spec = TP.hc();
        }

        doc = aDocument;
        if (TP.notValid(doc)) {
            doc = TP.sys.getUICanvas().getNativeDocument();
        }

        type = TP.ifKeyInvalid(spec, 'type');
        switch (type) {
            //  HTML Events
            case 'abort':
            case 'blur':
            case 'change':
            case 'error':
            case 'focus':
            case 'load':
            case 'reset':
            case 'resize':
            case 'scroll':
            case 'select':
            case 'submit':
            case 'unload':
                evt = doc.createEvent('HTMLEvents');
                evt.initEvent(
                            type,
                            TP.ifKeyInvalid(spec, 'bubbles', true),
                            TP.ifKeyInvalid(spec, 'cancelable', true));
                break;

            //  UI Events
            case 'focusin':
            case 'focusout':
            case 'input':
                evt = doc.createEvent('UIEvents');
                evt.initUIEvent(
                            type,
                            TP.ifKeyInvalid(spec, 'bubbles', true),
                            TP.ifKeyInvalid(spec, 'cancelable', true),
                            TP.ifKeyInvalid(spec,
                                            'view',
                                            TP.nodeGetWindow(doc)),
                            TP.ifKeyInvalid(spec, 'detail', 0));
                break;

            //  Key Events
            case 'keydown':
            case 'keypress':
            case 'keyup':
                evt = doc.createEvent('KeyboardEvent');
                evt.initKeyboardEvent(
                            type,
                            TP.ifKeyInvalid(spec, 'bubbles', true),
                            TP.ifKeyInvalid(spec, 'cancelable', true),
                            TP.ifKeyInvalid(spec,
                                            'view',
                                            TP.nodeGetWindow(doc)),
                            TP.ifKeyInvalid(spec, 'key', false),
                            TP.ifKeyInvalid(spec, 'location', false),

                            TP.ifKeyInvalid(spec, 'ctrlKey', false),
                            TP.ifKeyInvalid(spec, 'altKey', false),
                            TP.ifKeyInvalid(spec, 'shiftKey', false),
                            TP.ifKeyInvalid(spec, 'metaKey', false));

                break;

            //  Mouse Events
            case 'click':
            case 'dblclick':
            case 'mousedown':
            case 'mouseenter':
            case 'mousemove':
            case 'mouseleave':
            case 'mouseout':
            case 'mouseover':
            case 'mouseup':
                evt = doc.createEvent('MouseEvents');
                evt.initMouseEvent(
                            type,
                            TP.ifKeyInvalid(spec, 'bubbles', true),
                            TP.ifKeyInvalid(spec, 'cancelable', true),
                            TP.ifKeyInvalid(spec,
                                            'view',
                                            TP.nodeGetWindow(doc)),
                            TP.ifKeyInvalid(spec, 'detail', 0),
                            TP.ifKeyInvalid(spec, 'screenX', 0),
                            TP.ifKeyInvalid(spec, 'screenY', 0),
                            TP.ifKeyInvalid(spec, 'clientX', 0),
                            TP.ifKeyInvalid(spec, 'clientY', 0),
                            TP.ifKeyInvalid(spec, 'ctrlKey', false),
                            TP.ifKeyInvalid(spec, 'altKey', false),
                            TP.ifKeyInvalid(spec, 'shiftKey', false),
                            TP.ifKeyInvalid(spec, 'metaKey', false),
                            TP.ifKeyInvalid(spec, 'button', 0),
                            TP.ifKeyInvalid(spec, 'relatedTarget', null));

                evt.pageX = TP.ifKeyInvalid(spec, 'pageX', 0);
                evt.pageY = TP.ifKeyInvalid(spec, 'pageY', 0);

                break;

            //  Wheel Events
            case 'mousewheel':
                evt = doc.createEvent('WheelEvent');
                evt.initWheelEvent(
                            TP.ifKeyInvalid(spec, 'wheelDeltaX', 0),
                            TP.ifKeyInvalid(spec, 'wheelDeltaY', 0),
                            TP.ifKeyInvalid(spec,
                                            'view',
                                            TP.nodeGetWindow(doc)),
                            TP.ifKeyInvalid(spec, 'screenX', 0),
                            TP.ifKeyInvalid(spec, 'screenY', 0),
                            TP.ifKeyInvalid(spec, 'clientX', 0),
                            TP.ifKeyInvalid(spec, 'clientY', 0),
                            TP.ifKeyInvalid(spec, 'ctrlKey', false),
                            TP.ifKeyInvalid(spec, 'altKey', false),
                            TP.ifKeyInvalid(spec, 'shiftKey', false),
                            TP.ifKeyInvalid(spec, 'metaKey', false));

                evt.pageX = TP.ifKeyInvalid(spec, 'pageX', 0);
                evt.pageY = TP.ifKeyInvalid(spec, 'pageY', 0);

                break;

            //  Mutation Events
            case 'DOMAttrModified':
            case 'DOMNodeInserted':
            case 'DOMNodeRemoved':
            case 'DOMCharacterDataModified':
            case 'DOMNodeInsertedIntoDocument':
            case 'DOMNodeRemovedFromDocument':
            case 'DOMSubtreeModified':
                evt = doc.createEvent('MutationEvents');
                evt.initMutationEvent(type,
                            TP.ifKeyInvalid(spec, 'bubbles', true),
                            TP.ifKeyInvalid(spec, 'cancelable', true),
                            TP.ifKeyInvalid(spec, 'relatedTarget', null),
                            TP.ifKeyInvalid(spec, 'prevValue', null),
                            TP.ifKeyInvalid(spec, 'newValue', null),
                            TP.ifKeyInvalid(spec, 'attrName', null),
                            TP.ifKeyInvalid(spec, 'attrChange', null));
                break;

            //  Transition Events
            case 'transitionend':
                //  Not currently supported to generate these by most browsers.
                break;

            //  Animation Events
            case 'animationend':
                //  Not currently supported to generate these by most browsers.
                break;

            default:
                evt = doc.createEvent('Events');
                evt.initEvent(
                            type,
                            TP.ifKeyInvalid(spec, 'bubbles', true),
                            TP.ifKeyInvalid(spec, 'cancelable', true));

                //  Not an officially-defined event. Just put the slots from
                //  the supplied hash onto the Event as instance properties.
                TP.keys(spec).perform(
                        function(aKey) {
                            //  We filter out specified properties - Mozilla
                            //  throws an exception. Webkit may not, but it
                            //  probably won't like it.
                            if (TP.W3C_EVENT_PROPERTIES.test(aKey) ||
                                TP.EXTRA_EVENT_PROPERTIES.test(aKey)) {
                                return;
                            }

                            evt[aKey] = spec.at(aKey);
                        });

                break;
        }

        //  additional properties not necessarily covered by spec
        TP.TIBET_EVENT_PROPERTIES.perform(
            function(item) {
                try {
                    evt[item] = spec.at(item.slice(2));
                } catch (e) {
                    TP.ifError() ?
                        TP.error(TP.ec(e, 'Error configuring event.')) : 0;
                }
            });

        return evt;
    }
));

//  ------------------------------------------------------------------------
//  ELEMENT PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('elementDisableUserSelect',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(anElement) {

        /**
         * @method elementDisableUserSelect
         * @summary Disables the element's ability to be selected by the user.
         * @param {Element} anElement The element to disable the selectability
         *     of.
         * @exception TP.sig.InvalidElement
         */

        if (!TP.isElement(anElement)) {
            return TP.raise(this, 'TP.sig.InvalidElement');
        }

        TP.elementGetStyleObj(anElement).MozUserSelect = 'none';

        return;
    },
    'webkit',
    function(anElement) {

        /**
         * @method elementDisableUserSelect
         * @summary Disables the element's ability to be selected by the user.
         * @param {Element} anElement The element to disable the selectability
         *     of.
         * @exception TP.sig.InvalidElement
         */

        if (!TP.isElement(anElement)) {
            return TP.raise(this, 'TP.sig.InvalidElement');
        }

        TP.elementGetStyleObj(anElement).WebkitUserSelect = 'none';

        return;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('elementEnableUserSelect',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(anElement) {

        /**
         * @method elementEnableUserSelect
         * @summary Enables the element's ability to be selected by the user.
         * @param {Element} anElement The element to enable the selectability
         *     of.
         * @exception TP.sig.InvalidElement
         */

        if (!TP.isElement(anElement)) {
            return TP.raise(this, 'TP.sig.InvalidElement');
        }

        TP.elementGetStyleObj(anElement).MozUserSelect = 'text';

        return;
    },
    'webkit',
    function(anElement) {

        /**
         * @method elementEnableUserSelect
         * @summary Enables the element's ability to be selected by the user.
         * @param {Element} anElement The element to enable the selectability
         *     of.
         * @exception TP.sig.InvalidElement
         */

        if (!TP.isElement(anElement)) {
            return TP.raise(this, 'TP.sig.InvalidElement');
        }

        TP.elementGetStyleObj(anElement).WebkitUserSelect = 'text';

        return;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetBorderInPixels',
TP.hc(
    TP.DEFAULT,
    function(anElement, aSide, wantsTransformed) {

        /**
         * @method elementGetBorderInPixels
         * @summary Returns the element's border in pixels. 'aSide' is an
         *     optional argument - if not supplied, an Array of pixel numbers is
         *     returned with all of the border widths for each side of the
         *     supplied element.
         * @param {HTMLElement} anElement The element to retrieve the border in
         *     pixels for.
         * @param {String} aSide The side the border should be computed from.
         *     This should be one of the following TIBET constants: TP.TOP
         *     TP.RIGHT TP.BOTTOM TP.LEFT or it can be empty which means that
         *     values for all sides will be returned.
         * @param {Boolean} wantsTransformed An optional parameter that
         *     determines whether to return 'transformed' values if the
         *     element has been transformed with a CSS transformation. The
         *     default is false.
         * @exception TP.sig.InvalidElement
         * @exception TP.sig.InvalidStyleDeclaration
         * @returns {Number|Number[]} The element's border in pixels. If a side
         *     is supplied, this will be a Number, otherwise it will be an
         *     Array of Numbers containing the element's borders. The numbers
         *     are arranged in the following order: top, right, bottom, left.
         */

        var computedStyle,

            pixelFunc,

            valueInPixels,
            valuesInPixels;

        if (!TP.isElement(anElement)) {
            return TP.raise(this, 'TP.sig.InvalidElement');
        }

        //  Grab the computed style for the element
        if (TP.notValid(computedStyle =
                        TP.elementGetComputedStyleObj(anElement))) {
            return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
        }

        //  Define a reusable helper Function that will avoid repetition below.
        pixelFunc = function(cssName) {
            var pixelVal;

            pixelVal = TP.elementGetPixelValue(
                            anElement,
                            computedStyle.getPropertyValue(cssName),
                            cssName.asDOMName(),
                            wantsTransformed);

            return pixelVal;
        };

        //  Set the initial value to 0.
        valueInPixels = 0;

        try {
            if (TP.isEmpty(aSide)) {
                valuesInPixels = TP.ac();

                valuesInPixels.push(pixelFunc('border-top-width'));
                valuesInPixels.push(pixelFunc('border-right-width'));
                valuesInPixels.push(pixelFunc('border-bottom-width'));
                valuesInPixels.push(pixelFunc('border-left-width'));

                return valuesInPixels;
            }

            //  Switch on the supplied side.
            switch (aSide) {
                case TP.TOP:

                    valueInPixels = pixelFunc('border-top-width');

                    break;

                case TP.RIGHT:

                    valueInPixels = pixelFunc('border-right-width');

                    break;

                case TP.BOTTOM:

                    valueInPixels = pixelFunc('border-bottom-width');

                    break;

                case TP.LEFT:

                    valueInPixels = pixelFunc('border-left-width');

                    break;

                default:
                    break;
            }
        } catch (e) {
            //  valueInPixels is already set to 0. Nothing to do here.
            //  empty
        }

        return valueInPixels;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetMarginInPixels',
TP.hc(
    TP.DEFAULT,
    function(anElement, aSide, wantsTransformed) {

        /**
         * @method elementGetMarginInPixels
         * @summary Returns the element's margin in pixels.
         * @param {HTMLElement} anElement The element to retrieve the margin in
         *     pixels for.
         * @param {String} aSide The side the margin should be computed from.
         *     This should be one of the following TIBET constants: TP.TOP
         *     TP.RIGHT TP.BOTTOM TP.LEFT or it can be empty which means that
         *     values for all sides will be returned.
         * @param {Boolean} wantsTransformed An optional parameter that
         *     determines whether to return 'transformed' values if the
         *     element has been transformed with a CSS transformation. The
         *     default is false.
         * @exception TP.sig.InvalidElement
         * @exception TP.sig.InvalidParameter
         * @exception TP.sig.InvalidStyleDeclaration
         * @returns {Number|Number[]} The element's margin in pixels. If a side
         *     is supplied, this will be a Number, otherwise it will be an
         *     Array of Numbers containing the element's margins. The numbers
         *     are arranged in the following order: top, right, bottom, left.
         */

        var computedStyle,

            pixelFunc,

            valueInPixels,
            valuesInPixels;

        if (!TP.isElement(anElement)) {
            return TP.raise(this, 'TP.sig.InvalidElement');
        }

        //  Grab the computed style for the element
        if (TP.notValid(computedStyle =
                        TP.elementGetComputedStyleObj(anElement))) {
            return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
        }

        //  Define a reusable helper Function that will avoid repetition below.
        pixelFunc = function(cssName) {
            var pixelVal;

            pixelVal = TP.elementGetPixelValue(
                            anElement,
                            computedStyle.getPropertyValue(cssName),
                            cssName.asDOMName(),
                            wantsTransformed);

            return pixelVal;
        };

        //  Set the initial value to 0.
        valueInPixels = 0;

        try {
            if (TP.isEmpty(aSide)) {

                valuesInPixels = TP.ac();

                valuesInPixels.push(pixelFunc('margin-top'));
                valuesInPixels.push(pixelFunc('margin-right'));
                valuesInPixels.push(pixelFunc('margin-bottom'));
                valuesInPixels.push(pixelFunc('margin-left'));

                return valuesInPixels;
            }

            //  Switch on the supplied side.
            switch (aSide) {
                case TP.TOP:

                    valueInPixels = pixelFunc('margin-top');

                    break;

                case TP.RIGHT:

                    valueInPixels = pixelFunc('margin-right');

                    break;

                case TP.BOTTOM:

                    valueInPixels = pixelFunc('margin-bottom');

                    break;

                case TP.LEFT:

                    valueInPixels = pixelFunc('margin-left');

                    break;

                default:
                    break;
            }
        } catch (e) {
            //  valueInPixels is already set to 0. Nothing to do here.
            //  empty
        }

        return valueInPixels;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetPaddingInPixels',
TP.hc(
    TP.DEFAULT,
    function(anElement, aSide, wantsTransformed) {

        /**
         * @method elementGetPaddingInPixels
         * @summary Returns the element's padding in pixels.
         * @param {HTMLElement} anElement The element to retrieve the padding in
         *     pixels for.
         * @param {String} aSide The side the padding should be computed from.
         *     This should be one of the following TIBET constants: TP.TOP
         *     TP.RIGHT TP.BOTTOM TP.LEFT or it can be empty which means that
         *     values for all sides will be returned.
         * @param {Boolean} wantsTransformed An optional parameter that
         *     determines whether to return 'transformed' values if the
         *     element has been transformed with a CSS transformation. The
         *     default is false.
         * @exception TP.sig.InvalidElement
         * @exception TP.sig.InvalidParameter
         * @exception TP.sig.InvalidStyleDeclaration
         * @returns {Number|Number[]} The element's padding in pixels. If a side
         *     is supplied, this will be a Number, otherwise it will be an
         *     Array of Numbers containing the element's paddings. The numbers
         *     are arranged in the following order: top, right, bottom, left.
         */

        var computedStyle,

            pixelFunc,

            valueInPixels,
            valuesInPixels;

        if (!TP.isElement(anElement)) {
            return TP.raise(this, 'TP.sig.InvalidElement');
        }

        if (TP.isEmpty(aSide)) {
            return TP.raise(this, 'TP.sig.InvalidParameter');
        }

        //  Grab the computed style for the element
        if (TP.notValid(computedStyle =
                        TP.elementGetComputedStyleObj(anElement))) {
            return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
        }

        //  Define a reusable helper Function that will avoid repetition below.
        pixelFunc = function(cssName) {
            var pixelVal;

            pixelVal = TP.elementGetPixelValue(
                            anElement,
                            computedStyle.getPropertyValue(cssName),
                            cssName.asDOMName(),
                            wantsTransformed);

            return pixelVal;
        };

        //  Set the initial value to 0.
        valueInPixels = 0;

        try {
            if (TP.isEmpty(aSide)) {
                valuesInPixels = TP.ac();

                valuesInPixels.push(pixelFunc('padding-top'));
                valuesInPixels.push(pixelFunc('padding-right'));
                valuesInPixels.push(pixelFunc('padding-bottom'));
                valuesInPixels.push(pixelFunc('padding-left'));

                return valuesInPixels;
            }

            //  Switch on the supplied side.
            switch (aSide) {
                case TP.TOP:

                    valueInPixels = pixelFunc('padding-top');

                    break;

                case TP.RIGHT:

                    valueInPixels = pixelFunc('padding-right');

                    break;

                case TP.BOTTOM:

                    valueInPixels = pixelFunc('padding-bottom');

                    break;

                case TP.LEFT:

                    valueInPixels = pixelFunc('padding-left');

                    break;

                default:
                    break;
            }
        } catch (e) {
            //  valueInPixels is already set to 0. Nothing to do here.
            //  empty
        }

        return valueInPixels;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetTransformMatrix',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(anElement, wants2DMatrix) {
        /**
         * @method elementGetTransformMatrix
         * @summary Gets the transformation matrix of the element specified.
         * @description Note that this method will, by default, return a 4x4
         *     matrix suitable for use with CSS 3D transforms. By passing true
         *     to wants2DMatrix, a 3x2 matrix suitable for use by CSS 2D
         *     transforms will be returned.
         * @param {Element} anElement The element to get the transformation
         *     matrix from.
         * @param {Boolean} wants2DMatrix An optional parameter that tells the
         *     method whether or not to return a 3x2 matrix for use with CSS 2D
         *     transforms. The default is false.
         * @exception TP.sig.InvalidElement
         * @exception TP.sig.InvalidStyleDeclaration
         * @returns {Number[][]} The matrix expressed as an Array of Arrays.
         */

        var computedStyle,

            val,
            matrix;

        if (!TP.isElement(anElement)) {
            return TP.raise(this, 'TP.sig.InvalidElement');
        }

        //  Grab the computed style for the element
        if (TP.notValid(computedStyle =
                        TP.elementGetComputedStyleObj(anElement))) {
            return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
        }

        if (TP.isValid(val = computedStyle.MozTransform)) {

            matrix = TP.matrixFromCSSString(val, wants2DMatrix);
        }

        return matrix;
    },
    'webkit',
    function(anElement, wants2DMatrix) {
        /**
         * @method elementGetTransformMatrix
         * @summary Gets the transformation matrix of the element specified.
         * @description Note that this method will, by default, return a 4x4
         *     matrix suitable for use with CSS 3D transforms. By passing true
         *     to wants2DMatrix, a 3x2 matrix suitable for use by CSS 2D
         *     transforms will be returned.
         * @param {Element} anElement The element to get the transformation
         *     matrix from.
         * @param {Boolean} wants2DMatrix An optional parameter that tells the
         *     method whether or not to return a 3x2 matrix for use with CSS 2D
         *     transforms. The default is false.
         * @exception TP.sig.InvalidElement
         * @exception TP.sig.InvalidStyleDeclaration
         * @returns {Number[][]} The matrix expressed as an Array of Arrays.
         */

        var computedStyle,

            val,
            matrix;

        if (!TP.isElement(anElement)) {
            return TP.raise(this, 'TP.sig.InvalidElement');
        }

        //  Grab the computed style for the element
        if (TP.notValid(computedStyle =
                        TP.elementGetComputedStyleObj(anElement))) {
            return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
        }

        if (TP.isValid(val = computedStyle.WebkitTransform)) {

            matrix = TP.matrixFromCSSString(val, wants2DMatrix);
        }

        return matrix;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGlobalToLocalXY',
TP.hc(
    'test',
    'webkit',
    'true',
    function(anElement, x, y) {

        /**
         * @method elementGlobalToLocalXY
         * @summary Returns the 'element local' point taking into account any
         *     CSS transform of the element specified.
         * @param {Element} anElement The element to use the transformation
         *     from.
         * @param {Number} x The X coordinate to use to compute the X from. This
         *     should be specified in 'page' coordinates.
         * @param {Number} y The Y coordinate to use to compute the Y from. This
         *     should be specified in 'page' coordinates.
         * @exception TP.sig.InvalidElement
         * @returns {Number[]} An ordered pair where the first item is the X
         *     coordinate and the second item is the Y coordinate.
         */

        var newPoint;

        if (!TP.isElement(anElement)) {
            return TP.raise(this, 'TP.sig.InvalidElement');
        }

        newPoint = TP.nodeGetWindow(anElement).
                        webkitConvertPointFromPageToNode(
                                anElement,
                                new WebKitPoint(x, y));

        return TP.ac(parseFloat((newPoint.x || 0).toFixed(1)),
                     parseFloat((newPoint.y || 0).toFixed(1)));
    },
    TP.DEFAULT,
    function(anElement, x, y) {

        /**
         * @method elementGlobalToLocalXY
         * @summary Returns the 'element local' point taking into account any
         *     CSS transform of the element specified.
         * @param {Element} anElement The element to use the transformation
         *     from.
         * @param {Number} x The X coordinate to use to compute the X from. This
         *     should be specified in 'page' coordinates.
         * @param {Number} y The Y coordinate to use to compute the Y from. This
         *     should be specified in 'page' coordinates.
         * @exception TP.sig.InvalidElement
         * @returns {Number[]} An ordered pair where the first item is the X
         *     coordinate and the second item is the Y coordinate.
         */

        var win,

            a,

            newX,
            newY;

        if (!TP.isElement(anElement)) {
            return TP.raise(this, 'TP.sig.InvalidElement');
        }

        /*
         *  cx = a11 a12 a14   x
         *  cy = a21 a22 a24   y
         *   1 =   0   0   1   1
         */

        //  NB: This algorithm does *not* take into account any 3D transforms,
        //  like perspective...

        win = TP.nodeGetWindow(anElement);

        a = TP.matrixTranslate(
                        TP.elementGetComputedTransformMatrix(anElement),
                        win.pageXOffset, win.pageYOffset, 0);

        newX = ((x - a[0][3]) * a[1][1] - (y - a[1][3]) * a[0][1]) /
                            (a[0][0] * a[1][1] - a[0][1] * a[1][0]);

        newY = (a[0][0] * (y - a[1][3]) - a[1][0] * (x - a[0][3])) /
                            (a[0][0] * a[1][1] - a[0][1] * a[1][0]);

        return TP.ac(parseFloat((newX || 0).toFixed(1)),
                     parseFloat((newY || 0).toFixed(1)));
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('elementLocalToGlobalXY',
TP.hc(
    'test',
    'webkit',
    'true',
    function(anElement, x, y) {

        /**
         * @method elementLocalToGlobalXY
         * @summary Returns the 'page' point taking into account any CSS
         *     transform of the element specified.
         * @param {Element} anElement The element to use the transformation
         *     from.
         * @param {Number} x The X coordinate to use to compute the X from. This
         *     should be specified in 'element local' coordinates.
         * @param {Number} y The Y coordinate to use to compute the Y from. This
         *     should be specified in 'element local' coordinates.
         * @exception TP.sig.InvalidElement
         * @returns {Number[]} An ordered pair where the first item is the X
         *     coordinate and the second item is the Y coordinate.
         */

        var newPoint;

        if (!TP.isElement(anElement)) {
            return TP.raise(this, 'TP.sig.InvalidElement');
        }

        newPoint = TP.nodeGetWindow(anElement).
                        webkitConvertPointFromNodeToPage(
                                anElement,
                                new WebKitPoint(x, y));

        return TP.ac(parseFloat((newPoint.x || 0).toFixed(1)),
                     parseFloat((newPoint.y || 0).toFixed(1)));
    },
    TP.DEFAULT,
    function(anElement, x, y) {

        /**
         * @method elementLocalToGlobalXY
         * @summary Returns the 'page' point taking into account any CSS
         *     transform of the element specified.
         * @param {Element} anElement The element to use the transformation
         *     from.
         * @param {Number} x The X coordinate to use to compute the X from. This
         *     should be specified in 'element local' coordinates.
         * @param {Number} y The Y coordinate to use to compute the Y from. This
         *     should be specified in 'element local' coordinates.
         * @exception TP.sig.InvalidElement
         * @returns {Number[]} An ordered pair where the first item is the X
         *     coordinate and the second item is the Y coordinate.
         */

        TP.raise(this, 'TP.sig.UnsupportedOperation');

        return TP.ac();
    }
));

//  ------------------------------------------------------------------------
//  WINDOW PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('windowBuildFunctionFor',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(aWindow, aFunction) {

        /**
         * @method windowBuildFunctionFor
         * @summary Builds a 'wrapper' function for the supplied Function in
         *     the context of the supplied Window. This is normally used when
         *     installing callback Functions into code that TIBET has no control
         *     over and that is executing in another window or frame.
         * @param {Window} aWindow The window to create the function in.
         * @param {Function} aFunction The function to build a wrapper for.
         * @exception TP.sig.InvalidWindow
         * @exception TP.sig.InvalidFunction
         * @returns {Function} The wrapper function built with aWindow as its
         *     context.
         */

        //  On Gecko, this does nothing.
        return aFunction;
    },
    'webkit',
    function(aWindow, aFunction) {

        /**
         * @method windowBuildFunctionFor
         * @summary Builds a 'wrapper' function for the supplied Function in
         *     the context of the supplied Window. This is normally used when
         *     installing callback Functions into code that TIBET has no control
         *     over and that is executing in another window or frame.
         * @param {Window} aWindow The window to create the function in.
         * @param {Function} aFunction The function to build a wrapper for.
         * @exception TP.sig.InvalidWindow
         * @exception TP.sig.InvalidFunction
         * @returns {Function} The wrapper function built with aWindow as its
         *     context.
         */

        //  On Webkit, this does nothing.
        return aFunction;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('windowConstructObject',
TP.hc(
    TP.DEFAULT,
    function(aWindow, objectName) {

        /**
         * @method windowConstructObject
         * @summary Constructs an object in another Window, using that the
         *     named object as the constructor *in the target Window* to create
         *     the object. Note that this function also passes along any
         *     additional arguments to this function to the constructor.
         * @param {Window} aWindow The window to create the object in.
         * @param {String} objectName The 'type name' of the object to
         *     construct.
         * @exception TP.sig.InvalidWindow
         * @returns {Object}
         */

        var constructorObj,
            $$newinst;

        if (!TP.isWindow(aWindow)) {
            return TP.raise(this, 'TP.sig.InvalidWindow');
        }

        constructorObj = aWindow[objectName];

        if (TP.notValid(constructorObj)) {
            return null;
        }

        //  we start by using the built-in constructor for any arguments so
        //  behavior is consistent with native JS, and then we try parsing
        //  on our own
        /* eslint-disable no-eval, new-cap */
        switch (arguments.length) {
            case 2:
                $$newinst = new constructorObj();
                break;
            case 3:
                $$newinst = new constructorObj(arguments[2]);
                break;
            case 4:
                $$newinst = new constructorObj(arguments[2], arguments[3]);
                break;
            case 5:
                $$newinst = new constructorObj(arguments[2], arguments[3],
                                                arguments[4]);
                break;
            case 6:
                $$newinst = new constructorObj(arguments[2], arguments[3],
                                                arguments[4], arguments[5]);
                break;
            case 7:
                $$newinst = new constructorObj(arguments[2], arguments[3],
                                                arguments[4], arguments[5],
                                                arguments[6]);
                break;
            case 8:
                $$newinst = new constructorObj(arguments[2], arguments[3],
                                                arguments[4], arguments[5],
                                                arguments[6], arguments[7]);
                break;
            case 9:
                $$newinst = new constructorObj(arguments[2], arguments[3],
                                                arguments[4], arguments[5],
                                                arguments[6], arguments[7],
                                                arguments[8]);
                break;
            default:
                eval('$$newinst = new constructorObj(' +
                    TP.sys.$buildArgString(2, arguments.length) + ');');
                break;
        }
        /* eslint-enable no-eval, new-cap */

        return $$newinst;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('windowInstallOnBeforeUnloadHook',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(aWindow) {

        /**
         * @method windowInstallOnBeforeUnloadHook
         * @summary Installs the 'onbeforeunload' hook onto the supplied
         *     Window. This is an event handling function that manages whether
         *     or not the user can close or unload a window without being
         *     prompted.
         * @param {Window} aWindow The window to install the event hook function
         *     onto.
         * @exception TP.sig.InvalidWindow
         */

        if (!TP.isWindow(aWindow)) {
            return TP.raise(this, 'TP.sig.InvalidWindow');
        }

        //  On Mozilla, we don't place this property on any other Window than
        //  the top-level Window. There used to be a problem with this firing
        //  multiple times if multiple frames were instrumented with this hook.
        if (aWindow.name !== TP.topWindow.name) {
            return;
        }

        //  Install the onbeforeunload handler.
        aWindow.onbeforeunload = function() {

            //  This hook allows the user to cancel the navigation away from
            //  a page or the closing of a browser window. This method
            //  returns a message String that tells the user to use their
            //  TIBET application's Quit functionality, if available.

            //  On IE once the 'onbeforeunload' function is installed, it
            //  cannot be uninstalled. So we set an attribute on the
            //  window's document's body (called 'unloadable') to 'true' to
            //  allow the window to unload without seeing the dialog box. If
            //  this flag is defined and is true, we just return null from
            //  this function, which causes the browser to not show the
            //  dialog box.

            //  If running in a Karma testing environment don't prompt, exit.
            if (aWindow[TP.sys.cfg('karma.slot', '__karma__')]) {
                return;
            }

            //  On Electron, we always just return, allowing the TIBET/Electron
            //  machinery to handle shutdown.
            if (TP.sys.cfg('boot.context') === 'electron') {
                return;
            }

            //  If there is no body, there is nothing to protect, so we can
            //  just exit here.
            if (TP.notValid(TP.documentGetBody(aWindow.document))) {
                return;
            }

            if (TP.elementGetAttribute(TP.documentGetBody(aWindow.document),
                                        'unloadable') === 'true') {
                return;
            }

            return TP.join(
                    'You should use your application\'s Back/Exit ',
                    'features (if provided) to navigate or quit.\n\n',
                    'You may lose unsaved data if you click OK !');
        };
    },
    'webkit',
    function(aWindow) {

        /**
         * @method windowInstallOnBeforeUnloadHook
         * @summary Installs the 'onbeforeunload' hook onto the supplied
         *     Window. This is an event handling function that manages whether
         *     or not the user can close or unload a window without being
         *     prompted.
         * @param {Window} aWindow The window to install the event hook function
         *     onto.
         * @exception TP.sig.InvalidWindow
         */

        if (!TP.isWindow(aWindow)) {
            return TP.raise(this, 'TP.sig.InvalidWindow');
        }

        //  On Webkit we don't set up a hook for any window other than the
        //  top-level one.
        if (aWindow.name !== TP.topWindow.name) {
            return;
        }

        //  Install the onbeforeunload handler.
        aWindow.onbeforeunload = function() {

            //  This hook allows the user to cancel the navigation away
            //  from a page or the closing of a browser window. This method
            //  returns a message String that tells the user to use their
            //  TIBET application's Quit functionality, if available.

            //  On IE once the 'onbeforeunload' function is installed, it
            //  cannot be uninstalled. So we set an attribute on the
            //  window's document's body (called 'unloadable') to 'true' to
            //  allow the window to unload without seeing the dialog box. If
            //  this flag is defined and is true, we just return null from
            //  this function, which causes the browser to not show the
            //  dialog box.

            //  If running in a Karma testing environment don't prompt, exit.
            if (aWindow[TP.sys.cfg('karma.slot', '__karma__')]) {
                return;
            }

            //  On Electron, we always just return, allowing the TIBET/Electron
            //  machinery to handle shutdown.
            if (TP.sys.cfg('boot.context') === 'electron') {
                return;
            }

            //  If there is no body, there is nothing to protect, so we can
            //  just exit here.
            if (TP.notValid(TP.documentGetBody(aWindow.document))) {
                return;
            }

            if (TP.elementGetAttribute(TP.documentGetBody(aWindow.document),
                                        'unloadable') === 'true') {
                return;
            }

            if (TP.sys.getBrowser() === 'chrome') {
                return TP.join(
                        'You should use your application\'s Back/Exit ',
                        'features (if provided) to navigate or quit.\n\n',
                        'You may lose unsaved data if you click ',
                        '"Leave this page" !');
            } else {
                return TP.join(
                        'You should use your application\'s Back/Exit ',
                        'features (if provided) to navigate or quit.\n\n',
                        'You may lose unsaved data if you click "OK" !');
            }
        };

        return;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('windowStopLoading',
TP.hc(
    TP.DEFAULT,
    function(aWindow) {

        /**
         * @method windowStopLoading
         * @summary Stops the window from continuing to load content. Usually
         *     called when the window is currently loading via a
         *     'window.location' change.
         * @param {Window} aWindow The window to stop loading content.
         * @exception TP.sig.InvalidWindow
         */

        if (!TP.isWindow(aWindow)) {
            return TP.raise(this, 'TP.sig.InvalidWindow');
        }

        return aWindow.stop();
    }
));

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETDHTMLPrimitivesPost.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
Common routines associated with "Dynamic HTML" or DHTML -- aka AJAX GUI.
These cover features like animation, drag-and-drop, on-the-fly css, runtime
DOM manipulation, etc.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('computeCommonSizes',
function() {

    /**
     * @method computeCommonSizes
     * @summary Computes a number of 'system-wide' global numbers used for
     *     DHTML computations, such as the font metrics for a certain set of
     *     font heights and the scrollbar width.
     */

    var measuringDiv,

        keys,
        len,
        i,
        key,
        styleObj,

        scrollingDiv,
        testingDiv;

    //  Inspired by Morris John's emResized measurer.

    //  If the font heights haven't been computed yet, do so now.
    if (TP.notValid(TP.FONT_HEIGHTS)) {
        //  We start with a hash that has a value of 0 for each of
        //  the different sizes of fonts that we're going to compute.
        TP.FONT_HEIGHTS =
                TP.hc('1em', 0,
                        '1ex', 0,
                        '100%', 0,
                        '12pt', 0,
                        '16px', 0,
                        'xx-small', 0,
                        'x-small', 0,
                        'small', 0,
                        'medium', 0,
                        'large', 0,
                        'x-large', 0,
                        'xx-large', 0);

        //  Create a 'div' that we will use for measuring the fonts.
        measuringDiv = document.createElement('div');
        TP.elementSetStyleString(
            measuringDiv,
            'position: absolute; top: 0px; left: -100px; ' +
            'width: 30px; height: 1000em; ' +
            'border: 0px; margin: 0px; padding: 0px; outline: 0px; ' +
            'line-height: 1; overflow: hidden;');

        //  Need to append it somewhere real in order to obtain a real
        //  measurement.

        //  We don't have to worry about reassignment of measuringDiv to the
        //  return value of this method since we know we created it in this
        //  document.
        TP.nodeAppendChild(TP.documentGetBody(document), measuringDiv, false);

        //  Loop over all of the keys of the hash
        keys = TP.keys(TP.FONT_HEIGHTS);
        len = keys.getSize();

        styleObj = TP.elementGetStyleObj(measuringDiv);

        for (i = 0; i < len; i++) {
            key = keys[i];

            //  Set the font size of the div to the value of the key.
            styleObj.fontSize = key;

            //  Put the number of pixels computed as the value of that
            //  key in the hash
            TP.FONT_HEIGHTS.atPut(key,
                        Math.round(measuringDiv.offsetHeight * 12 / 16) *
                                (16 / 12) / 1000);
        }

        //  Make sure and remove the measuring div from where we stuck it.
        TP.nodeDetach(measuringDiv);
    }

    //  Inspired by Morris John's scrollbar measurer.

    //  The value for the scroller width is cached once per application run
    //  in the 'TP.SCROLLER_WIDTH' variable. Check to see if this
    //  computation has already been done.
    if (TP.notValid(TP.SCROLLER_WIDTH)) {
        //  Create a 'div' that will scroll. This is where we will take our
        //  measurements.
        scrollingDiv = document.createElement('div');
        TP.elementSetStyleString(
                scrollingDiv,
                'position: absolute; top: -300px; left: 0px; ' +
                'width: 100px; height: 100px; overflow: scroll;');

        //  Create a child that we will append to it that will cause it to
        //  scroll.
        testingDiv = document.createElement('div');
        TP.elementSetStyleString(
                testingDiv,
                'width: 400px; height: 400px;');

        //  We don't have to worry about reassignment of testingDiv to the
        //  return value of this method since we know we created it in this
        //  document.
        TP.nodeAppendChild(scrollingDiv, testingDiv, false);

        //  We don't have to worry about reassignment of scrollingDiv to the
        //  return value of this method since we know we created it in this
        //  document.
        TP.nodeAppendChild(TP.documentGetBody(document), scrollingDiv, false);

        //  The scroller width is the difference between the offset width
        //  and the client width.
        TP.SCROLLER_WIDTH = scrollingDiv.offsetWidth -
                                    scrollingDiv.clientWidth;

        //  Make sure and remove the measuring div from where we stuck it.
        TP.nodeDetach(scrollingDiv);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('computeFocusableQuery',
function(aPrefix, aSuffix) {

    /**
     * @method computeFocusableQuery
     * @summary Computes a CSS query that will return focusable elements when
     *     executed. Note that this uses the TP.FOCUSABLE_QUERIES global to
     *     drive the construction of the query and the prefix and suffix (if
     *     supplied) will be wrapped around *each* one of these queries to
     *     further qualify them. The result is then joined together with a comma
     *     (',') so that the query computes a CSS union.
     * @param {String} [aPrefix] The optional prefix to use when building the
     *     query.
     * @param {String} [aSuffix] The optional suffix to use when building the
     *     query.
     * @returns {String} A CSS query that, when executed, will return all of the
     *     'focusable' elements under the queried node.
     */

    var queries,
        str,

        prefix,
        suffix,

        len,
        i;

    //  A list of queries that will return focusable elements, per the HTML5
    //  spec.
    queries = TP.FOCUSABLE_QUERIES;

    str = '';

    prefix = TP.ifInvalid(aPrefix, '');
    suffix = TP.ifInvalid(aSuffix, '');

    len = queries.getSize();
    for (i = 0; i < len; i++) {
        str += prefix + queries.at(i) + suffix + ', ';
    }

    //  Slice off the last comma and space - otherwise, the query is considered
    //  to be malformed
    if (TP.notEmpty(str)) {
        str = str.slice(0, -2);
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('computeOriginID',
function(aWindow, aLocation, aLocalID) {

    /**
     * @method computeOriginID
     * @summary Computes an 'origin ID' suitable for use with the TIBET
     *     signaling system.
     * @description Sometimes, it is desirable to observe a signaling source
     *     (usually a Element) within a document that hasn't yet been rendered.
     *     Given the supplied parameters, this method will produce the canonical
     *     origin ID used by the signaling system. This can then be used to
     *     'observe' that origin before the content is rendered.
     * @param {Window|TP.core.Window|String} aWindow The target Window or
     *     supplied String containing the Window's 'global ID'.
     * @param {String} aLocation The URL location of the content to be rendered
     *     into the target Window. This can be in either concrete or virtual URI
     *     format.
     * @param {String} aLocalID The 'local ID' of the signaling source in the
     *     rendered content.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidString
     * @returns {String} The origin ID computed from the supplied parameters.
     */

    var winGID,
        normalizedLocation,
        orgID;

    if (TP.notValid(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    if (TP.isEmpty(aLocation) || TP.isEmpty(aLocalID)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    winGID = TP.gid(aWindow);
    normalizedLocation = TP.uriInTIBETFormat(TP.uriExpandPath(aLocation));

    orgID = 'tibet://' + winGID + '/' + normalizedLocation + '#' + aLocalID;

    return orgID;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('getPixelsPerPoint',
function() {

    /**
     * @method getPixelsPerPoint
     * @summary Returns the number of 'pixels per point' (i.e. the number of
     *     'px' in a 'pt') in the currently executing browser environment.
     * @returns {Number} The number of pixels per point.
     */

    var fontMeasurement;

    if (TP.notValid(fontMeasurement = TP.FONT_HEIGHTS.at('12pt'))) {
        return 0;
    }

    return fontMeasurement / 12;
});

//  ------------------------------------------------------------------------
//  DOCUMENT PRIMITIVES
//  ------------------------------------------------------------------------

/*
There's a bit of a fine line between whether these are "DOM primitives" or
"DHTML primitives" in some cases, but the overall idea here is that if a
function is more about runtime manipulation of a visible DOM we tend toward
thinking of it as a DHTML primitive.

The functions in this section handle things like runtime CSS manipulation
and movement/alteration of runtime DOM properties on documents.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('documentBlurFocusedElement',
function(aDocument, shouldFocusPrevious) {

    /**
     * @method documentBlurFocusedElement
     * @summary Blurs the currently focused element in the supplied document.
     * @param {Document} aDocument The document to blur the currently focused
     *     element in.
     * @param {Boolean} [shouldFocusPrevious=true] An optional parameter that
     *     will determine whether, after blurring, this method should check the
     *     focus stack to see if an element is there. If so, it will focus it.
     * @exception TP.sig.InvalidDocument
     */

    var focusedElem,

        lastDoc;

    if (!TP.isDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    focusedElem = TP.documentGetFocusedElement(aDocument);
    if (TP.isElement(focusedElem)) {

        //  Blur it 'the TIBET way' (so that we can manage the focus stack,
        //  etc.)
        TP.wrap(focusedElem).blur();

        //  For headless systems, we just return here - otherwise we get
        //  multiple pops off of the stack below.

        //  TODO: Investigate why this is the case.
        if (TP.sys.cfg('boot.context') === 'headless') {
            return;
        }
    }

    //  If we should focus the 'previous' element and there is a previous
    //  element on the stack, then grab it and focus it.
    if (TP.notFalse(shouldFocusPrevious) && TP.notEmpty(TP.$focus_stack)) {

        //  Before we alter the stack, we grab the native document of the
        //  last item on the top of the stack.
        lastDoc = TP.$focus_stack.last().getNativeDocument();

        //  If the document of what we just focused was the same as the supplied
        //  document, then we need to pop off the last item as we end up with
        //  one extra

        //  TODO: Investigate why this is the case.
        if (lastDoc === aDocument) {
            TP.dom.UIElementNode.popOffFocusStack();
        } else {
            //  Go ahead and just focus the last item that's on the stack.
            TP.$focus_stack.last().focus();
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentEnsureHeadElement',
function(aDocument) {

    /**
     * @method documentEnsureHeadElement
     * @summary Ensures that a 'head' element is present in the supplied
     *     Document. If it isn't, it creates one and appends it to the
     *     Document's documentElement.
     * @param {Document} aDocument The document to create the 'head' element in.
     * @exception TP.sig.InvalidDocument
     * @returns {HTMLElement} The head element that existed or was created in
     *     the supplied document.
     */

    var head;

    head = TP.documentGetHead(aDocument);
    if (TP.notValid(head)) {
        head = TP.documentConstructElement(
                                aDocument,
                                'head',
                                TP.w3.Xmlns.XHTML);

        TP.nodeInsertBefore(aDocument.documentElement,
                            head,
                            aDocument.documentElement.firstChild,
                            false);
    }

    return head;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetAllIFrames',
function(aDocument) {

    /**
     * @method documentGetAllIFrames
     * @summary Returns all of the iframes nested in aDocument. This function
     *     recursively descends into iframes in aDocument and retrieves any
     *     embedded iframes in it.
     * @param {Document} aDocument The document to begin searching for iframes.
     * @exception TP.sig.InvalidDocument
     * @returns {iframe[]} The list of nested iframes.
     */

    var allIFrames,

        iFrameChildren,
        objectChildren,

        index;

    if (!TP.isHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    allIFrames = TP.ac();

    iFrameChildren = TP.nodeGetElementsByTagName(aDocument, 'iframe');

    //  Grab all of the 'object' elements in the DOM, but then select out
    //  only those that have a 'contentDocument' object - those will be the
    //  XHTML iframes.
    objectChildren = TP.nodeGetElementsByTagName(aDocument, 'object');
    objectChildren = objectChildren.select(
                        function(anObjElem) {

                            return TP.isDocument(anObjElem.contentDocument);
                        });
    iFrameChildren = iFrameChildren.concat(objectChildren);

    //  Loop over any iframe children found and concatenate the
    //  iframe itself and the results of recursively calling this
    //  function.
    for (index = 0; index < iFrameChildren.length; index++) {
        allIFrames.addAll(
                        TP.documentGetAllIFrames(
                            TP.elementGetIFrameDocument(
                                        iFrameChildren[index])));
    }

    return allIFrames;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetBody',
function(aDocument) {

    /**
     * @method documentGetBody
     * @summary Returns the enclosing document's body element.
     * @param {Document} aDocument The document to use.
     * @exception TP.sig.InvalidDocument
     * @returns {String} The document's body element.
     */

    var body;

    if (!TP.isDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  HTML and XHTML documents will often have a body slot.
    body = aDocument.body;
    if (TP.isElement(body)) {
        return body;
    }

    return TP.nodeGetFirstElementByTagName(aDocument, 'body');
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetBodyContent',
function(aDocument) {

    /**
     * @method documentGetBodyContent
     * @summary Returns the enclosing document's body in text form. This is
     *     used when creating a static application version so that the packaged
     *     file's body matches that of the config file itself.
     * @param {Document} aDocument The document to use.
     * @exception TP.sig.InvalidDocument
     * @returns {String} The document's body text.
     */

    var body;

    body = TP.documentGetBody(aDocument);
    if (TP.isElement(body)) {
        return body.innerHTML;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetHead',
function(aDocument) {

    /**
     * @method documentGetHead
     * @summary Returns the enclosing document's head element.
     * @param {Document} aDocument The document to use.
     * @exception TP.sig.InvalidDocument
     * @returns {String} The document's head element.
     */

    var head;

    if (!TP.isDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  HTML and XHTML documents will often have a head slot.
    head = aDocument.head;
    if (TP.isElement(head)) {
        return head;
    }

    return TP.nodeGetFirstElementByTagName(aDocument, 'head');
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetHeadContent',
function(aDocument) {

    /**
     * @method documentGetHeadContent
     * @summary Returns the enclosing document's head in text form. This is
     *     used when creating a static, inlined boot configuration page for
     *     stripping/zipping.
     * @param {Document} aDocument The document to use.
     * @exception TP.sig.InvalidDocument
     * @returns {String} The document's head text.
     */

    var head;

    head = TP.documentGetHead(aDocument);
    if (TP.isElement(head)) {
        return head.innerHTML;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetFocusedElement',
function(aDocument, orActiveElement) {

    /**
     * @method documentGetFocusedElement
     * @summary Returns the supplied document's currently focused (i.e.
     *     'active') element. If no element is currently focused, this will
     *     return the 'body' element, as per the HTML5 specification.
     * @param {Document} aDocument The document to query.
     * @param {Boolean} [orActiveElement=true] Whether or not to return the
     *     standard HTML5 '.activeElement' if a 'TIBET focused' element isn't
     *     available. The default is true.
     * @exception TP.sig.InvalidDocument
     * @returns {Element} The currently focused element.
     */

    var activeElement,

        docBody,
        bodyIndex;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  Some browsers (i.e. Webkit) don't support '.activeElement' for XHTML
    //  documents. See https://bugs.webkit.org/show_bug.cgi?id=63922

    //  Therefore, we try to query for the first element that would
    //  have the TIBET 'pclass:focus' pseudo-class on it and use that.

    activeElement = TP.byCSSPath('*[pclass|focus]', aDocument, true, false);

    if (TP.isArray(activeElement) && TP.notEmpty(activeElement)) {

        //  Grab the body element and see if it's in the array of 'active
        //  elements'. This is a common issue, especially when elements are
        //  being focused via mouse clicks. The TIBET machinery will eventually
        //  update everything as part of the mouse click / focusing operations
        //  so that the focused element is truly set, so we don't worry about
        //  warning if one of the elements is the body.
        docBody = TP.documentGetBody(aDocument);
        bodyIndex = activeElement.indexOf(docBody);

        //  It wasn't, so we warn.
        if (bodyIndex === TP.NOT_FOUND) {
            TP.ifWarn() ?
                TP.warn('Multiple elements with [pclass|focus] found.') : 0;
        }

        //  If the body was found at index 0, then use the element at index 1.
        //  Otherwise, use the element at index 0.
        if (bodyIndex === 0) {
            activeElement = activeElement.at(1);
        } else {
            activeElement = activeElement.at(0);
        }
    }

    //  If we're not checking for '.activeElement', then just return whatever
    //  the computed active element is here.
    if (TP.isFalse(orActiveElement)) {
        return activeElement;
    }

    if (!TP.isElement(activeElement)) {

        //  Otherwise, we try to use the activeElement if it's available. If
        //  not, we do what the HTML5 standard says and return the 'body'
        //  element. In properly functioning browsers, the built-in routine
        //  already returns the 'body' for the active element if there is no
        //  focused element.
        activeElement = aDocument.activeElement;
        if (!TP.isElement(activeElement)) {
            activeElement = TP.documentGetBody(aDocument);
        }
    }

    return activeElement;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetLinkFileNames',
function(aDocument) {

    /**
     * @method documentGetLinkFileNames
     * @summary Returns an array of any link (<a href="") files referenced in
     *     the document.
     * @param {Document} aDocument The document to search.
     * @returns {String[]} The link file names referenced in the document.
     */

    var arr,
        list,
        len,
        i,
        name;

    list = TP.nodeGetElementsByTagName(aDocument, 'a');
    len = list.getSize();

    arr = TP.ac();

    for (i = 0; i < len; i++) {
        name = TP.elementGetAttribute(list[i], 'href');

        if (TP.notEmpty(name) && !TP.regex.JS_SCHEME.test(name)) {
            arr.push(name);
        }
    }

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetTitleContent',
function(aDocument) {

    /**
     * @method documentGetTitleContent
     * @summary Returns the supplied document's 'title' content. This is the
     *     text content of the 'title' element in the document's 'head' element.
     * @param {Document} aDocument The document to obtain the title content of.
     * @returns {String} The document's title content.
     */

    var titleElem;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    if (TP.isElement(titleElem =
                        aDocument.getElementsByTagName('title')[0])) {
        return titleElem.text;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetLocation',
function(aDocument, trimFileAndFragment, trimFragment) {

    /**
     * @method documentGetLocation
     * @summary Returns the supplied document's location, optionally minus the
     *     document name itself. If there is no window associated with the
     *     supplied document and it has no internal data such as a
     *     TP.SRC_LOCATION property or xml:base attribute value this method
     *     returns the empty String (''). NOTE also that the response to this
     *     call is not encoded (escaped with %20 for space etc).
     * @param {Document} aDocument The document to use.
     * @param {Boolean} trimFileAndFragment True will cause any file and/or
     *     fragment reference to be trimmed, returning only a directory. Default
     *     is false.
     * @param {Boolean} trimFragment True will cause any fragment (but not file)
     *     reference to be trimmed, returning only a directory. Default is
     *     false.
     * @exception TP.sig.InvalidDocument
     * @returns {String} The document's location.
     */

    var doc,
        win,
        ndx,
        trimBoth,
        trimFrag,
        loc,
        htmlBase;

    //  by default we return the full path and fragment to the file
    trimBoth = TP.ifInvalid(trimFileAndFragment, false);
    trimFrag = TP.ifInvalid(trimFragment, false);

    //  make sure we're really dealing with a document
    if (!TP.isDocument(doc = aDocument)) {
        doc = TP.nodeGetDocument(aDocument);
        if (TP.notValid(doc)) {
            return TP.raise(this, 'TP.sig.InvalidDocument');
        }
    }

    //  empty document? no location
    if (TP.notValid(doc.documentElement)) {
        return '';
    }

    win = TP.nodeGetWindow(doc);

    //  first choice is always the TP.SRC_LOCATION value since we try to keep
    //  this accurate relative to the original source file name
    if (TP.notEmpty(loc = doc[TP.SRC_LOCATION])) {
        //  we need to expand these since they're often virtual paths
        loc = TP.uriExpandPath(loc);
    } else if (!TP.isWindow(win)) {

        //  If we don't have an associated window, try to use either the
        //  'xml:base' or the 'base', in that order, if they're available.
        if (TP.notEmpty(loc = TP.elementGetAttribute(
                                        doc.documentElement,
                                        'xml:base',
                                        true))) {
            //  we need to expand these since they're often virtual paths
            loc = TP.uriExpandPath(loc);
        } else if (TP.notEmpty(
                        htmlBase = doc.getElementsByTagName('base')[0])) {
            //  this won't be a virtual path
            loc = TP.elementGetAttribute(htmlBase, 'href');
        }
    }

    if (TP.isEmpty(loc)) {
        //  If there is no valid window, return the empty string.
        if (!TP.isWindow(win)) {
            return '';
        }

        loc = win.location.toString();
    }

    //  watch out for Moz et. al. and the empty location "file://[/]"
    if (loc === 'file:///' || loc === 'file://') {
        return '';
    }

    if (trimBoth) {
        ndx = loc.lastIndexOf('/');
        if (ndx !== TP.NOT_FOUND) {
            loc = loc.slice(0, loc.lastIndexOf('/'));
        }
    }

    //  remove any leading tibet:/// and any trailing '#document' since
    //  those aren't part of the true location
    loc = loc.strip(/^tibet:\/\/\//).strip(/#document$/);

    //  If we're trimming off just the fragment, do that here.
    if (trimFrag) {
        loc = TP.uriHead(loc);
    }

    //  keep format consistent so regardless of the value's format (encoded
    //  or not) we return it in decoded form minus any floating anchor it
    //  may have acquired. Note that this will *only* chop off a single
    //  remaining '#' character. If there are any other characters (i.e. a
    //  fragment), the original will remain untouched.
    loc = decodeURI(loc).chop('#');

    return loc;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetPixelsForFontSize',
function(aDocument, aFontSize) {

    /**
     * @method documentGetPixelsForFontSize
     * @summary Returns the number of pixels for a particular font size in the
     *     supplied document.
     * @param {Document} aDocument The document to use to compute the font
     *     metrics.
     * @param {String} aFontSize The font size to use to compute the pixels. For
     *     instance, '1em' or '9pt'.
     * @exception TP.sig.InvalidDocument
     * @returns {Number} The number of pixels the supplied font size takes up in
     *     the supplied document.
     */

    var numPixels,

        measuringDiv;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  Derived from the dojotoolkit.org font metric measurer, which is
    //  derived from Morris John's emResized measurer.

    numPixels = 0;

    if (TP.notValid(TP.FONT_HEIGHTS)) {
        TP.FONT_HEIGHTS = TP.hc();
    }

    //  The value for the document's font sizes are cached once per
    //  application run in the 'TP.FONT_HEIGHTS' variable. Check to see if
    //  this computation has already been done.
    if (TP.notValid(numPixels = TP.FONT_HEIGHTS.at(aFontSize))) {
        //  Create a 'div' that will be used to do the measuring.
        measuringDiv = aDocument.createElement('div');
        TP.elementSetStyleString(
                measuringDiv,
                'position: absolute; top 0px; left: -100px; ' +
                'width: 30px; height: 1000em; border: 0px; margin: 0px; ' +
                'padding: 0px; outline: 0px; line-height: 1; ' +
                'overflow: hidden;');

        //  Need to append it somewhere real in order to obtain a real
        //  measurement.

        //  We don't have to worry about reassignment of measuringDiv to the
        //  return value of this method since we know we created it in
        //  aDocument.
        TP.nodeAppendChild(TP.documentGetBody(aDocument), measuringDiv, false);

        //  Take the measurement
        TP.elementGetStyleObj(measuringDiv).fontSize = aFontSize;
        numPixels =
            Math.round(measuringDiv.offsetHeight * 12 / 16) * 16 / 12 / 1000;

        //  Make sure and remove the measuring div from where we stuck it.
        TP.nodeDetach(measuringDiv);

        //  Cache the result so that we don't have to do this again for this
        //  font size
        TP.FONT_HEIGHTS.atPut(aFontSize, numPixels);
    }

    return numPixels;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetRoot',
function(aDocument) {

    /**
     * @method documentGetRoot
     * @summary Returns the enclosing document's root element.
     * @param {Document} aDocument The document to use.
     * @exception TP.sig.InvalidDocument
     * @returns {Element} The document's root element.
     */

    if (!TP.isDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    return TP.nodeGetFirstChildElement(aDocument);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetScriptFileNames',
function(aDocument) {

    /**
     * @method documentGetScriptFileNames
     * @summary Returns an array of any JavaScript files referenced in the
     *     document.
     * @param {Document} aDocument The document to search.
     * @exception TP.sig.InvalidDocument
     * @returns {String[]} The script file names referenced in the document.
     */

    var arr,
        list,
        len,
        i,
        name;

    if (!TP.isDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    list = TP.nodeGetElementsByTagName(aDocument, 'script');
    len = list.getSize();

    arr = TP.ac();

    for (i = 0; i < len; i++) {
        name = TP.elementGetAttribute(list[i], 'src') ||
                TP.elementGetAttribute(list[i], 'source');

        if (TP.notEmpty(name)) {
            arr.push(name);
        }
    }

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetScriptNodes',
function(aDocument) {

    /**
     * @method documentGetScriptNodes
     * @summary Returns the enclosing document's script nodes, if any.
     * @param {Document} aDocument The document to use.
     * @exception TP.sig.InvalidDocument
     * @returns {script[]} The script nodes referenced in the document.
     */

    if (!TP.isDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    return TP.nodeGetElementsByTagName(aDocument, 'script');
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetTheme',
function(aDocument, fallback) {

    /**
     * @method documentGetTheme
     * @summary Returns the *current* UI 'project' theme. It does this by
     *     obtaining the data-theme attribute on the supplied document body that
     *     is helping to drive themed CSS. If the current 'project' theme isn't
     *     available, and the fallback flag is supplied, then the current 'lib'
     *     theme will be returned.
     * @description Note that the supplied document might be configured with
     *     both a 'lib' theme and a 'project' theme. The value returned here
     *     will always be the 'project' theme unless the fallback flag is
     *     supplied.
     * @param {Document} aDocument The document to get the theme for.
     * @param {Boolean} [fallback=false] Whether or not to return the 'lib'
     *     theme if the 'project' theme is unavailable.
     * @returns {String} The theme in effect for the supplied document.
     */

    var body,
        themeAttrVal,

        libTheme,
        themes;

    body = TP.documentGetBody(aDocument);
    if (TP.isElement(body)) {

        themeAttrVal = TP.elementGetAttribute(body, 'data-theme', true);

        //  If there is a value of the 'data-theme' attribute from the body,
        //  then try to determine the 'project' theme from it. Otherwise, if the
        //  fallback flag is set, then return the 'lib' theme.
        if (TP.notEmpty(themeAttrVal)) {

            //  Grab the 'lib' theme so that we can filter and/or return it.
            libTheme = TP.sys.getcfg('tibet.theme.default');

            //  Split the 1...n theme names obtained from the attribute and
            //  filter any that *aren't* the lib theme.
            themes = themeAttrVal.split(' ');
            themes = themes.select(
                            function(aTheme) {
                                return aTheme !== libTheme;
                            });

            //  Got a 'project' theme? Return the first one.
            if (TP.notEmpty(themes)) {
                return themes.first();
            } else if (fallback) {
                //  Otherwise, return the 'lib' theme if we're falling back.
                return libTheme;
            }
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentRewriteHacks',
function(theContent) {

    /**
     * @method documentRewriteHacks
     * @summary Rewrites any 'style' content in the head (either 'link'
     *     elements or content within a 'style' element) that was placed there
     *     to work around Mozilla bugs.
     * @description Even though this function rewrites content because of
     *     Mozilla bugs, it needs to exist across all platforms since content
     *     generated on Mozilla may be saved in cache files and used on other
     *     browsers.
     * @param {String} theContent The content to rewrite the style rules in.
     * @exception TP.sig.InvalidString
     * @returns {String}
     */

    var content;

    if (TP.isEmpty(theContent)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    content = theContent;

    //  update namespaced attributes with their proper prefixes.
    content = content.replace(/_colon_/g, ':');

    //  we had to escape HTML style elements and HTML link elements pointing
    //  to stylesheets and CSS imports to avoid problems with the content
    //  processing system under Mozilla, so we need to unescape those
    //  constructs here
    content = TP.$unescapeCSSConstructs(content);

    return content;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentScrollBy',
function(aDocument, deltaX, deltaY) {

    /**
     * @method documentScrollBy
     * @summary Scrolls the document by the deltaX and deltaY amounts provided.
     * @param {Document} aDocument The document to scroll.
     * @param {Number} deltaX The X amount to scroll the document by.
     * @param {Number} deltaY The Y amount to scroll the document by.
     * @exception TP.sig.InvalidDocument
     */

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    TP.nodeGetWindow(aDocument).scrollBy(deltaX, deltaY);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentScrollTo',
function(aDocument, x, y) {

    /**
     * @method documentScrollTo
     * @summary Scrolls the document to the X and Y coordinates provided.
     * @param {Document} aDocument The document to scroll.
     * @param {Number} x The X coordinate to scroll the document to.
     * @param {Number} y The Y coordinate to scroll the document to.
     * @exception TP.sig.InvalidDocument
     */

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    TP.nodeGetWindow(aDocument).scrollTo(x, y);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentSetLocation',
function(aDocument, aURIStr, force) {

    /**
     * @method documentSetLocation
     * @summary Sets the document's location. This is done by stamping the
     *     document with a TP.SRC_LOCATION property.
     * @param {Document} aDocument The document to use.
     * @param {String} aURIStr The URL string to use as the document's location.
     * @param {Boolean} force If true, this method will ignore any existing
     *     value for TP.SRC_LOCATION property and stamp in the supplied URI
     *     value for TP.SRC_LOCATION.
     * @exception TP.sig.InvalidDocument
     * @returns {String} The document's location.
     */

    var doc,
        url;

    //  make sure we're really dealing with a document
    if (!TP.isDocument(doc = aDocument)) {
        doc = TP.nodeGetDocument(aDocument);
        if (TP.notValid(doc)) {
            return TP.raise(this, 'TP.sig.InvalidDocument');
        }
    }

    url = aURIStr;
    if (TP.notValid(url)) {
        return;
    }

    //  If its already got either a TP.SRC_LOCATION, bail out here.
    if (TP.isValid(doc[TP.SRC_LOCATION]) && TP.notTrue(force)) {
        return;
    }

    doc[TP.SRC_LOCATION] = url;

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentSetTheme',
function(aDocument, themeName) {

    /**
     * @method documentSetTheme
     * @summary Sets a data-theme attribute on the supplied document body to
     *     help drive themed CSS. Note that this should be the UI 'project'
     *     theme. This will have the 'lib' theme added to it for theming
     *     'backstop' purposes.
     * @param {Document} aDocument The document to set the theme for.
     * @param {String} themeName The theme name to set for the document.
     */

    var body,

        libTheme,
        projectTheme;

    body = TP.documentGetBody(aDocument);
    if (TP.isElement(body)) {

        //  Grab the 'lib' theme so that we can use it.
        libTheme = TP.sys.getcfg('tibet.theme.default');

        //  If we're running the Lama and the document is the UIRoot document,
        //  then we don't use the 'project' theme.
        if (TP.sys.hasFeature('lama') &&
            aDocument === TP.sys.getUIRoot(true).document) {
            projectTheme = '';
        } else {
            //  Otherwise, use the supplied theme name.
            projectTheme = themeName;
        }

        //  If both the 'project' and 'lib' themes are empty, then just remove
        //  the attribute.
        if (TP.isEmpty(projectTheme)) {
            if (TP.isEmpty(libTheme)) {
                TP.elementRemoveAttribute(body, 'data-theme', true);
            } else {
                //  Otherwise, the project theme is blank - use the 'lib' theme
                TP.elementSetAttribute(body, 'data-theme', libTheme, true);
            }
        } else if (projectTheme === libTheme) {
            //  Otherwise, they're both the same - just use the 'project' theme.
            TP.elementSetAttribute(body, 'data-theme', projectTheme, true);
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentSetTitleContent',
function(aDocument, titleText) {

    /**
     * @method documentSetTitleContent
     * @summary Sets the supplied document's 'title' content.
     * @param {Document} aDocument The document to set the title content of.
     * @param {String} titleText The value to use as the title content.
     * @exception TP.sig.InvalidDocument
     * @exception TP.sig.InvalidString
     */

    var theTitle,

        headElem,
        titleElem;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  NB: We do allow titleText to be ''. So, if title text is not a
    //  String, we set it to ''.
    if (!TP.isString(theTitle = titleText)) {
        theTitle = '';
    }

    //  Make sure that the document has a valid 'head' element or we're
    //  going nowhere.
    headElem = TP.documentEnsureHeadElement(aDocument);

    titleElem = TP.nodeGetFirstElementByTagName(aDocument, 'title');
    if (TP.notValid(titleElem)) {
        titleElem = TP.documentConstructElement(
                                aDocument,
                                'title',
                                TP.w3.Xmlns.XHTML);

        TP.nodeAppendChild(headElem, titleElem, false);
    }

    titleElem.text = theTitle;

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('htmlDocumentAddContent',
function(aDocument, theContent, loadedFunction, shouldAwake) {

    /**
     * @method htmlDocumentAddContent
     * @summary Adds content from theContent onto the end of the child content
     *     of the document element of the supplied document.
     * @param {Document} aDocument The document to receive the content.
     * @param {Node|String} theContent The object to use as the source of the
     *     content.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just added. The default for an 'add' operation is false.
     * @exception TP.sig.InvalidDocument
     * @returns {Node} The first node of the content that was just inserted.
     */

    var bodyElem;

    if (!TP.isHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    if (TP.isElement(bodyElem = TP.documentGetBody(aDocument))) {
        return TP.htmlElementAddContent(bodyElem.
                                        theContent,
                                        loadedFunction,
                                        shouldAwake);
    } else {
        return TP.htmlElementAddContent(aDocument.documentElement,
                                        theContent,
                                        loadedFunction,
                                        shouldAwake);
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('htmlDocumentInsertContent',
function(aDocument, theContent, aPositionOrPath, loadedFunction, shouldAwake) {

    /**
     * @method htmlDocumentInsertContent
     * @summary Inserts content from theContent into/around the document
     *     element of the supplied document based on the position given. The
     *     position should indicate whether the content should become the
     *     previous sibling, next sibling, first child or last child.
     * @param {Document} aDocument The document to receive the content.
     * @param {Node|String} theContent The object to use as the source of the
     *     content.
     * @param {String} aPositionOrPath The position to place the content
     *     relative to the document's documentElement or a path to evaluate to
     *     get to a node at that position. This should be one of four values:
     *     TP.BEFORE_BEGIN, TP.AFTER_BEGIN, TP.BEFORE_END, TP.AFTER_END or the
     *     path to evaluate. Default is TP.BEFORE_END.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just inserted. The default for an 'insert' operation is false.
     * @exception TP.sig.InvalidDocument
     * @returns {Node} The first node of the content that was just inserted.
     */

    if (!TP.isHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    return TP.htmlElementInsertContent(aDocument.documentElement,
                                        theContent,
                                        aPositionOrPath,
                                        loadedFunction,
                                        shouldAwake);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('htmlDocumentSetContent',
function(aDocument, theContent, loadedFunction, shouldAwake) {

    /**
     * @method htmlDocumentSetContent
     * @summary Sets the content of the supplied document, replacing the
     *     document's documentElement with the resulting content if valid.
     * @description Content sent to a document must be suitable for replacing
     *     the entire content of the document, i.e. it becomes the source of the
     *     new documentElement. This implies that the content must be able to
     *     provide a valid node containing a single root element of the same
     *     document type (XML vs HTML). NOTE: Content set via this mechanism is
     *     *always* awakened via the TP.$$processDocumentLoaded() method that
     *     gets called when the document is loaded.
     * @param {Document} aDocument The document to receive the content.
     * @param {Node|String} theContent The object to use as the source of the
     *     content.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just set. The default for a 'set' operation is whether aDocument has
     *     a Window object associated with it or not.
     * @returns {Node} The first node of the content that was just inserted. In
     *     this case, the documentElement.
     */

    var awakenContent,

        content,
        nodeContent,
        strContent,

        headElem,
        baseElem,
        baseVal,

        str,
        win;

    if (!TP.isHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    awakenContent = shouldAwake;
    if (TP.notValid(awakenContent)) {
        awakenContent = TP.nodeHasWindow(aDocument);
    }

    //  unwrap any TP.dom.Node wrapper we may have received
    content = TP.unwrap(theContent);

    //  If the content is an (X)HTML node, then we just make sure its an
    //  Element, and not a Document. It will be turned into a String after
    //  node manipulations later.
    if (TP.isHTMLNode(content) || TP.isXHTMLNode(content)) {
        if (TP.isDocument(content)) {
            nodeContent = content.documentElement;
        } else {
            nodeContent = content;
        }

        strContent = null;
    } else {
        //  Otherwise, its an XML node or a String - in either case, we get
        //  the HTML String representation and use that.
        strContent = TP.htmlstr(content);
        nodeContent = null;
    }

    //  If we have node content, then we use it - since parsing, in general,
    //  is where the performance problems are.
    if (TP.isNode(nodeContent)) {
        //  Make sure that we have a 'base' tag so that relative file
        //  references in the content will be resolved properly.

        //  If we can find a 'head' element, see if we can find an existing
        //  'base' element.
        if (TP.isElement(
                headElem =
                TP.nodeGetFirstElementChildByTagName(nodeContent, 'head'))) {
            //  See if we have both a 'base' element and a valid value for
            //  an 'xml:base' attribute on the document element.
            baseElem = nodeContent.getElementsByTagName('base')[0];
            baseVal = TP.elementGetAttribute(
                        TP.nodeGetDocument(nodeContent).documentElement,
                        'xml:base',
                        true);
        } else {
            //  Couldn't find a 'head' element, so we create one in the
            //  XHTML namespace and append it to the document element.
            headElem = TP.documentConstructElement(
                                    TP.nodeGetDocument(nodeContent),
                                    'head',
                                    TP.w3.Xmlns.XHTML);

            TP.nodeAppendChild(
                TP.nodeGetDocument(nodeContent).documentElement,
                headElem,
                false);

            baseElem = null;
            baseVal = '';
        }

        //  If there is no valid 'base' element but there is a valid value
        //  for 'xml:base', then go ahead and make a 'base' element and set
        //  its 'href' to that value.
        if (TP.notValid(baseElem) && TP.notEmpty(baseVal)) {
            //  Make sure that the base value has a trailing slash
            if (baseVal.last() !== '/') {
                baseVal += '/';
            }

            baseElem = TP.documentConstructElement(
                            TP.nodeGetDocument(nodeContent),
                            'base',
                            TP.w3.Xmlns.XHTML);

            TP.elementSetAttribute(baseElem, 'href', baseVal);

            //  If the head element has child nodes, then we want to insert
            //  our newly minted 'base' element as the first child (to get
            //  proper resolution for elements with relative paths later in
            //  the head content).

            //  NB: If the headElem doesn't have a 'firstChild', this is the
            //  same as append()ing a child.
            TP.nodeInsertBefore(headElem,
                                baseElem,
                                headElem.firstChild,
                                false);
        }

        str = TP.htmlstr(content);
    } else if (TP.isString(strContent)) {
        //  We already made sure that the String is HTML above.
        str = strContent;
    }

    str = TP.documentRewriteHacks(str);

    //  Grab the native window for instrumentation
    win = TP.nodeGetWindow(aDocument);

    //  make sure we try to force strict HTML (IE standards mode)
    if (!/<!DOCTYPE/.test(str)) {
        str = TP.w3.DocType.HTML_401_STRICT.asString() + '\n' + str;
    }

    //  On Mozilla and Safari we have to call the
    //  TP.$$processDocumentUnloaded() manually since altering the DOM won't
    //  cause a true unload signal to be fired - you have to alter the
    //  location to have that happen
    if (TP.sys.isUA('GECKO') || TP.sys.isUA('WEBKIT')) {
        try {
            aDocument.open(TP.HTML_TEXT_ENCODED, 'replace');
            aDocument.write('');

            //  Note here how we pass false so that this call will not try
            //  to check to see if the window is or will close, which we
            //  know it won't here.
            TP.$$processDocumentUnloaded(win, false);
        } finally {
            aDocument.close();
        }
    }

    //  Go ahead and register an 'onload' function that will call the proper
    //  machinery to set up the document from a CSS perspective and call a
    //  passed in 'loaded' function, if one is available.
    if (TP.isCallable(loadedFunction)) {
        TP.core.Window.registerOnloadFunction(win, loadedFunction);
    }

    //  Set the flag that tells the TP.$$processDocumentLoaded() function
    //  whether it should awaken the content that is about to be written.
    TP.core.Window.setWindowInfo(TP.gid(win), 'shouldAwake', awakenContent);

    //  Open, write the computed String content, and then close the
    //  document. This triggers the TIBET machinery to call the onload
    //  function above.

    try {
        TP.core.Window.$$isDocumentWriting = true;
        aDocument.open(TP.HTML_TEXT_ENCODED, 'replace');

        if (TP.sys.isUA('WEBKIT')) {
            //  Loop over and clear all 'global variable references' for
            //  consistency between browsers. Mozilla tends to clear any
            //  user-placed global slots, as does IE, but Safari tends not
            //  to.
            TP.keys(TP.sys.$globals).perform(
                    function(aKey) {
                        win[aKey] = null;
                    });
        }

        //  If a reference to the 'tibet_hook' file wasn't in the content
        //  that we're writing, then we need to install our own load/unload
        //  hooks.
        if (!/tibet_hook/.test(str)) {
            //  Reset handlers. they get cleared on open/write
            TP.core.Window.installLoadUnloadHooks(win);
        }

        aDocument.write(str);
    } finally {
        aDocument.close();
    }

    //  Return the document's documentElement
    return aDocument.documentElement;
});

//  ------------------------------------------------------------------------
//  ELEMENT PRIMITIVES
//  ------------------------------------------------------------------------

/*
As with documents, there's a fine line around DOM vs. DHTML functionality
for certain operations on elements, but these are the ones we feel are more
about runtime DHTML manipulation than "plain ol' DOM manipulation".
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('elementAddClass',
function(anElement, className) {

    /**
     * @method elementAddClass
     * @summary Adds a CSS class name to the element if it is not already
     *     present.
     * @param {Element} anElement The element to add the CSS class to.
     * @param {String} className The CSS class name to add.
     * @exception TP.sig.InvalidElement
     * @returns {Element|undefined} The element the supplied class was added to.
     */

    var existingClass;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(className)) {
        return;
    }

    if (TP.elementHasClass(anElement, className)) {
        return anElement;
    }

    //  If the native 'classList' property is available, use that.
    if (TP.isValid(anElement.classList)) {
        return anElement.classList.add(className);
    }

    if (TP.notEmpty(existingClass = TP.elementGetClass(anElement))) {
        TP.elementSetAttribute(anElement,
                                'class',
                                existingClass + ' ' + className);
    } else {
        TP.elementSetAttribute(anElement, 'class', className);
    }

    return anElement;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementBlurFocusedDescendantElement',
function(anElement) {

    /**
     * @method elementBlurFocusedDescendantElement
     * @summary Blurs the currently focused element if it is a descendant of the
     *     supplied element.
     * @param {Element} anElement The document to focus the autofocused element
     *     in.
     * @exception TP.sig.InvalidElement
     */

    var doc,
        focusedElem;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    doc = TP.nodeGetDocument(anElement);

    focusedElem = TP.documentGetFocusedElement(doc);

    //  If there is a focused element, and it is within the supplied element,
    //  then blur it.
    if (TP.isElement(focusedElem) &&
        TP.nodeContainsNode(anElement, focusedElem)) {

        TP.documentBlurFocusedElement(doc);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementCanBeSized',
function(anElement) {

    /**
     * @method elementCanBeSized
     * @summary Returns whether or not a element can take on 'size' - that is,
     *     whether it can have a specific size in its document flow. Elements
     *     that can be sized will be able to have their 'width' and 'height'
     *     set, but also might be sized by other means.
     * @param {Element} anElement The element to test for sizability.
     * @exception TP.sig.InvalidElement
     * @returns {Boolean} Whether or not the element can be sized.
     */

    var doc,

        computedStyle,
        displayVal,

        isReplaced,

        fullName;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    doc = TP.nodeGetDocument(anElement);

    //  NOTE: We follow the CSSOM spec here for how to compute the containing
    //  block.

    //  Per the spec, if anElement is the root element, then it is by definition
    //  not a sizable element.
    if (anElement === doc.documentElement) {
        return false;
    }

    //  If anElement is the body element, then it is by definition not a sizable
    //  element.
    if (anElement === doc.body) {
        return false;
    }

    //  Grab the computed style for the element
    if (TP.notValid(computedStyle =
                    TP.elementGetComputedStyleObj(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    //  Grab the parent's display value.
    displayVal = computedStyle.display;

    isReplaced = false;

    fullName = TP.elementGetFullName(anElement);

    switch (fullName) {
        case 'iframe':
        case 'video':
        case 'embed':
        case 'img':
            isReplaced = true;
            break;
        default:
            break;
    }

    //  width/height cannot be applied to non-replaced inline elements
    if (!isReplaced) {
        switch (displayVal) {
            case 'inline':
            case 'inline-block':
            case 'inline-table':
            case 'inline-flex':
            case 'inline-grid':
            case 'inline-list-item':
                return false;
            default:
                break;
        }
    }

    if (displayVal === 'table-row' ||
        displayVal === 'table-row-group') {
        return false;
    }

    return true;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementComputeBoxSizeOfMarkup',
function(anElement, markup, boxType, wantsTransformed) {

    /**
     * @method elementComputeBoxSizeOfMarkup
     * @summary Returns an Array of width and height of the element as if it
     *     contained the supplied markup. For now, this markup is limited to
     *     (X)HTML markup.
     * @param {Element} anElement The element to obtain the size of, given the
     *     supplied markup string.
     * @param {String} markup The String of markup to populate the element with
     *     in order to determine its size.
     * @param {String} boxType A TIBET constant that determines the 'box' to
     *     compute the width and height for. This can one of the following
     *     values: TP.CONTENT_BOX TP.PADDING_BOX TP.BORDER_BOX TP.MARGIN_BOX If
     *     this parameter is not supplied, it defaults to TP.BORDER_BOX.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidString
     * @returns {Number[]} The [width, height] pair computed when the content
     *     of the element is set to the supplied markup.
     */

    var theBoxType,

        anElementClone,

        width,
        height;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(markup)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    //  Default the box type to TP.BORDER_BOX
    theBoxType = TP.ifInvalid(boxType, TP.BORDER_BOX);

    //  Clone the element in preparation for setting its content and
    //  appending it.
    anElementClone = TP.nodeCloneNode(anElement);

    //  Set it and append it.
    TP.elementSetInnerContent(anElementClone, markup);

    //  We don't have to worry about reassignment of anElementClone to the
    //  return value of this method since we know we created it by cloning
    //  anElement.
    TP.nodeAppendChild(anElement.parentNode, anElementClone, false);

    //  Grab the width and height of the clone. Since its now a 'sibling' to
    //  the supplied element, and has its tag name and all of its
    //  attributes, its style should be exactly the same (at least for width
    //  and height - don't care about X and Y offsets).
    width = TP.elementGetWidth(anElementClone, theBoxType, wantsTransformed);
    height = TP.elementGetHeight(anElementClone, theBoxType, wantsTransformed);

    //  Remove the clone since we no longer need it.
    TP.nodeDetach(anElementClone);

    //  Return the width and height.
    return TP.ac(width, height);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementComputeCornerUsing',
function(anElement, pointX, pointY, insetTop, insetRight, insetBottom,
         insetLeft) {

    /**
     * @method elementComputeCornerUsing
     * @summary Computes a 'corner' that a particular point is in, given a set
     *     of offsets.
     * @description Given the point and the offsets, this method will return one
     *     of the following values: TP.TOP TP.RIGHT TP.BOTTOM TP.LEFT
     *     TP.TOP_LEFT TP.TOP_RIGHT TP.BOTTOM_LEFT TP.BOTTOM_RIGHT
     * @param {Element} anElement The element to compute the corner for.
     * @param {Number} pointX The X coordinate of the point used in testing.
     * @param {Number} pointY The Y coordinate of the point used in testing.
     * @param {Number} insetTop The top offset from the edge 'in' towards the
     *     center of the supplied Element.
     * @param {Number} insetRight The right offset from the edge 'in' towards
     *     the center of the supplied Element.
     * @param {Number} insetBottom The bottom offset from the edge 'in' towards
     *     the center of the supplied Element.
     * @param {Number} insetLeft The left offset from the edge 'in' towards the
     *     center of the supplied Element.
     * @exception TP.sig.InvalidElement
     * @returns {String}
     */

    var elemCoords,

        boxTop,
        boxRight,
        boxBottom,
        boxLeft,

        xSide,
        ySide;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    elemCoords = TP.elementGetBorderBox(anElement);

    boxLeft = elemCoords.at('left');
    boxTop = elemCoords.at('top');
    boxRight = boxLeft + elemCoords.at('width');
    boxBottom = boxTop + elemCoords.at('height');

    //  Outside the box? Forget it.
    if (pointX < boxLeft ||
        pointX > boxRight ||
        pointY < boxTop ||
        pointY > boxBottom) {
        return null;
    }

    xSide = null;
    ySide = null;

    /* eslint-disable no-extra-parens */
    if (pointX > boxLeft && pointX < (boxLeft + insetLeft)) {
        xSide = 'LEFT';
    } else if (pointX > (boxRight - insetRight) && pointX < boxRight) {
        xSide = 'RIGHT';
    }

    if (pointY > boxTop && pointY < (boxTop + insetTop)) {
        ySide = 'TOP';
    } else if (pointY > (boxBottom - insetBottom) && pointY < boxBottom) {
        ySide = 'BOTTOM';
    }
    /* eslint-enable no-extra-parens */

    if (TP.isString(xSide) && TP.notValid(ySide)) {
        return TP[xSide];
    }

    if (TP.isString(ySide) && TP.notValid(xSide)) {
        return TP[ySide];
    }

    if (TP.isString(xSide) && TP.isString(ySide)) {
        return TP[ySide + '_' + xSide];
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementComputeOnScreenXY',
function(anElement, preferredX, preferredY, offsetX, offsetY, preferredCorners) {

    /**
     * @method elementComputeOnScreenXY
     * @summary Returns an Array of data that includes X and Y values for the
     *     supplied Element that are guaranteed to keep the element 'on-screen'.
     * @description This method takes the supplied preferred X and Y for the
     *     element and, using the element to compute a width and height for the
     *     element, computes an X and Y that keeps the element on screen. This
     *     method also accepts an X and Y offset to 'pad' around the supplied
     *     element in the computation and an Array of 'corners' that will be
     *     tested in turn in the attempt to place the element.
     * @param {HTMLElement} anElement The element to compute the on-screen X and
     *     Y for.
     * @param {Number} preferredX The preferred X that the caller would like to
     *     place the supplied element at.
     * @param {Number} preferredY The preferred Y that the caller would like to
     *     place the supplied element at.
     * @param {Number} offsetX The X offset in pixels to use as a 'padding'.
     *     This defaults to 0.
     * @param {Number} offsetY The Y offset in pixels to use as a 'padding'.
     *     This defaults to 0.
     * @param {String[]} preferredCorners An Array of 'corners' to use to test.
     *     This should be one or more of: TP.TOP_LEFT TP.BOTTOM_LEFT
     *     TP.TOP_RIGHT TP.BOTTOM_RIGHT.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidNumber
     * @returns {Array<Number,Number,String,Number>} An Array of the following
     *     return values: [on-screen X, on-screen Y, corner used,
     *     distanceComputation].
     */

    var desiredOffsetX,
        desiredOffsetY,

        thePreferredCorners,

        elemDoc,

        viewableWidth,
        viewableHeight,

        scrollOffsetX,
        scrollOffsetY,

        styleObj,
        oldDisplayValue,

        elementBoxWidth,
        elementBoxHeight,

        bestX,
        bestY,
        bestCorner,
        bestDistance,

        successfulMatch,
        i,
        len,
        corner,
        initialX,
        initialY,

        finalX,
        finalY,
        theDistance;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (!TP.isNumber(preferredX) || !TP.isNumber(preferredY)) {
        return TP.raise(this, 'TP.sig.InvalidNumber');
    }

    //  The offsets default to 0.
    desiredOffsetX = TP.ifInvalid(offsetX, 0);
    desiredOffsetY = TP.ifInvalid(offsetY, 0);

    //  The corner used for computation defaults to TP.TOP_LEFT
    thePreferredCorners = preferredCorners;
    if (TP.notValid(thePreferredCorners)) {
        thePreferredCorners = TP.ac(TP.TOP_LEFT);
    }

    elemDoc = TP.nodeGetDocument(anElement);

    //  Grab the viewable area of the document.
    viewableWidth = TP.documentGetViewableWidth(elemDoc);
    viewableHeight = TP.documentGetViewableHeight(elemDoc);

    //  Grab how much the document may have scrolled.
    scrollOffsetX = TP.documentGetScrollX(elemDoc);
    scrollOffsetY = TP.documentGetScrollY(elemDoc);

    //  Grab the border box width and height of the element, but first make
    //  sure to turn off any non-default 'display' setting that would cause
    //  the element to have different dimensions than it normally would
    //  have.

    styleObj = TP.elementGetStyleObj(anElement);

    //  Note here how we go after any manually set 'display' style - we're
    //  not interested in the computed style here.
    oldDisplayValue = styleObj.display;
    styleObj.display = '';

    //  Capture the element's TP.BORDER_BOX width and height
    elementBoxWidth = TP.elementGetWidth(anElement, TP.BORDER_BOX);
    elementBoxHeight = TP.elementGetHeight(anElement, TP.BORDER_BOX);

    //  Set the old display value back.
    styleObj.display = oldDisplayValue;

    //  Initialize the tracking values.
    bestX = -1;
    bestY = -1;
    bestCorner = null;
    bestDistance = Infinity;

    //  Loop over the preferred corners.
    len = thePreferredCorners.length;
    for (i = 0; i < len; i++) {
        corner = thePreferredCorners[i];

        successfulMatch = true;

        //  Compute the initial X to try, based on the current
        //  corner that we're testing.
        if (corner === TP.TOP_LEFT || corner === TP.BOTTOM_LEFT) {
            initialX = preferredX + desiredOffsetX;
        } else {
            initialX = preferredX -
                        elementBoxWidth -
                        desiredOffsetX;
        }

        //  Compute the initial Y to try, based on the current
        //  corner that we're testing.
        if (corner === TP.TOP_LEFT || corner === TP.TOP_RIGHT) {
            initialY = preferredY + desiredOffsetY;
        } else {
            initialY = preferredY -
                        elementBoxHeight -
                        desiredOffsetY;
        }

        //  If the initial X was less than 0, then clamp it to 0 and
        //  set our successful match flag to false.
        if (initialX < 0) {
            initialX = 0;
            successfulMatch = false;
        }

        //  If the initial Y was less than 0, then clamp it to 0 and
        //  set our successful match flag to false.
        if (initialY < 0) {
            initialY = 0;
            successfulMatch = false;
        }

        //  Add the element box's width to the initial X value to
        //  produced a final computational value that we'll try
        //  below.
        finalX = initialX + elementBoxWidth;

        //  If that value is greater than the viewable width of the
        //  document, then set it to be the viewable width of the
        //  document minus the element box's width and set our
        //  successful match flag to false.
        if (finalX > viewableWidth) {
            finalX = viewableWidth - elementBoxWidth;
            successfulMatch = false;
        } else {
            //  Otherwise, set it to the initial value that we were
            //  going to try.
            finalX = initialX;
        }

        //  Max this value against any sort of supplied X offset
        //  plus any X offset produced from the document having
        //  scrolled.
        finalX = finalX.max(desiredOffsetX) + scrollOffsetX;

        //  Add the element box's height to the initial Y value to
        //  produced a final computational value that we'll try
        //  below.
        finalY = initialY + elementBoxHeight;

        //  If that value is greater than the viewable height of the
        //  document, then set it to be the viewable height of the
        //  document minus the element box's height and set our
        //  successful match flag to false.
        if (finalY > viewableHeight) {
            finalY = viewableHeight - elementBoxHeight;
            successfulMatch = false;
        } else {
            //  Otherwise, set it to the initial value that we were
            //  going to try.
            finalY = initialY;
        }

        //  Max this value against any sort of supplied Y offset
        //  plus any Y offset produced from the document having
        //  scrolled.
        finalY = finalY.max(desiredOffsetY) + scrollOffsetY;

        //  If we had a successful match, then we can just exit
        //  right here by setting our tracking values and breaking
        //  from the loop.
        if (successfulMatch) {
            bestX = finalX;
            bestY = finalY;

            bestDistance = 0;

            bestCorner = corner;

            break;
        }

        //  Otherwise, recompute a distance and check to see if its
        //  less than the current best distance. If so, set our
        //  tracking values and loop again.
        theDistance =
                (finalX - initialX - scrollOffsetX).pow(2) +
                (finalY - initialY - scrollOffsetY).pow(2);
        if (bestDistance > theDistance) {
            bestX = finalX;
            bestY = finalY;

            bestDistance = theDistance;

            bestCorner = corner;
        }
    }

    //  Return an Array of the best computed X, the best computed Y and the
    //  corner used to compute them.
    return TP.ac(bestX, bestY, bestCorner, bestDistance);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementContainsPoint',
function(anElement, x, y) {

    /**
     * @method elementContainsPoint
     * @summary Returns true or false depending on whether the given x and y
     *     falls inside of the element.
     * @description Note that the coordinates should be given in 'document'
     *     coordinates.
     * @param {HTMLElement} anElement The element to test the x and y against.
     * @param {Number} x The X coordinate to test.
     * @param {Number} y The Y coordinate to test.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidNumber
     * @returns {Boolean} Whether or not the x and y coordinates fall inside of
     *     the element.
     */

    var elemCoords;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (!TP.isNumber(x) || !TP.isNumber(y)) {
        return TP.raise(this, 'TP.sig.InvalidNumber');
    }

    //  We must obtain the coordinates of the element as they are relative
    //  to the document. These are returned: left, top, width, height.
    elemCoords = TP.elementGetBorderBox(anElement);

    //  If the X and Y fall within the coordinates of the element, then
    //  return true.

    /* eslint-disable no-extra-parens */
    if (x >= elemCoords.at('left') &&
        y >= elemCoords.at('top') &&
        x <= (elemCoords.at('left') + anElement.offsetWidth) &&
        y <= (elemCoords.at('top') + anElement.offsetHeight)) {
        return true;
    }
    /* eslint-enable no-extra-parens */

    return false;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementDefaultDisplay',
function(anElement) {

    /**
     * @method elementDefaultDisplay
     * @summary Sets the element back to the 'default' display value. This
     *     includes clearing any specific inline style setting for the CSS
     *     display property.
     * @param {HTMLElement} anElement The element to default the display of.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidStyleDeclaration
     */

    var computedStyle,

        displayValue,
        theTagName;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  Since the author might have used a non-default value for the
    //  'display' property, we clear it of any local value and then check to
    //  see if its still 'none'. If so, we use TIBET's built-in map to get
    //  the proper 'display' value for the element.

    TP.elementGetStyleObj(anElement).display = '';

    if (TP.notValid(computedStyle =
                    TP.elementGetComputedStyleObj(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    displayValue = computedStyle.display;
    if (displayValue === 'none') {
        //  The default for XHTML is lower case, so make sure that the
        //  tag name is in that form.
        theTagName = TP.elementGetLocalName(anElement).toLowerCase();

        //  Get the display value for that particular tag name, but only
        //  if that tag is a usually a 'non-inline' element.
        displayValue = TP.XHTML_10_NONINLINE_ELEMENTS.at(theTagName);

        //  If there was a valid value for the display property, that
        //  means that the tag is normally a non-inline element, so
        //  set its display property to that value, otherwise, set its
        //  display property to 'inline'.
        if (TP.isString(displayValue)) {
            TP.elementGetStyleObj(anElement).display = displayValue;
        } else {
            TP.elementGetStyleObj(anElement).display = 'inline';
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementFocusAutofocusedElement',
function(anElement) {

    /**
     * @method elementFocusAutofocusedElement
     * @summary Focuses the element in the supplied element that contains the
     *     HTML5 'autofocus' attribute (which would be the first one to focus
     *     when the element's document first loads).
     * @param {Element} anElement The document to focus the autofocused element
     *     in.
     * @exception TP.sig.InvalidElement
     * @returns {Boolean} Whether or not an element was found and focused. Note
     *     that if there is already a focused element and it is the same as the
     *     element that will autofocus, this will return false.
     */

    var autofocusedElem,
        focusedElem;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  Grab the first element under supplied element that has an 'autofocus'
    //  attribute on it (the value of that attribute is irrelevant).
    if (TP.isElement(
            autofocusedElem =
                    TP.byCSSPath(' *[autofocus]', anElement, true, false))) {

        //  Obtain the currently focused element from the document of the
        //  supplied element. Note how we pass false to *not* return the
        //  'activeElement' here in case there are no elements with a
        //  'pclass:focus' attribute. This will filter out any elements like
        //  iframes that could have focus. We're not interested in whether they
        //  do or not.
        focusedElem = TP.documentGetFocusedElement(
                            TP.nodeGetDocument(anElement),
                            false);

        //  If the currently focused element is different than the autofocus
        //  element that we computed, then go ahead and focus it.
        if (focusedElem !== autofocusedElem) {
            //  Focus it 'the TIBET way' (so that proper highlighting, etc.
            //  takes effect)
            TP.wrap(autofocusedElem).focus();

            return true;
        }
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetBorderBox',
function(anElement, wantsTransformed) {

    /**
     * @method elementGetBorderBox
     * @summary Returns the 'border box' of the supplied element. This can
     *     be a tortuous and error-prone process on some browsers, so this
     *     method provides a cross-platform way of obtaining it.
     * @param {HTMLElement} anElement The element to use to compute the
     *     border box from.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @returns {TP.core.Hash} A hash containing the border box at: 'left',
     *     'top', 'right', 'bottom', 'width', 'height'.
     */

    var elementDoc,

        useBCR,

        offsetAncestor,

        borderVals,

        offsetX,
        offsetY,
        offsetWidth,
        offsetHeight,

        elementBox,

        box;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    elementDoc = TP.nodeGetDocument(anElement);

    //  We can use the Bounding Client Rect if:
    //      a) the caller has specified that it wants transformed coordinates
    //      OR
    //      b) the element is not transformed (because BCR is a faster way to
    //      obtain box coordinates than iterating through the offset ancestor
    //      hierarchy).
    //  In other words, only if the caller has expressly said it doesn't want
    //  transformed coordinates and the element is transformed do we use offset
    //  ancestor iteration.
    useBCR = TP.isTrue(wantsTransformed) ||
                !TP.elementIsTransformed(anElement);

    if (!useBCR) {

        offsetX = anElement.offsetLeft;
        offsetY = anElement.offsetTop;

        offsetAncestor = TP.elementGetOffsetParent(anElement);
        while (TP.isElement(offsetAncestor)) {

            borderVals = TP.elementGetComputedStyleValuesInPixels(
                            offsetAncestor,
                            TP.ac('borderTopWidth', 'borderLeftWidth'));

            offsetX += offsetAncestor.offsetLeft +
                         borderVals.at('borderLeftWidth');
            offsetY += offsetAncestor.offsetTop +
                         borderVals.at('borderTopWidth');

            if (offsetAncestor !== elementDoc.body &&
                offsetAncestor !== elementDoc.documentElement) {
                offsetX -= offsetAncestor.scrollLeft;
                offsetY -= offsetAncestor.scrollTop;
            }

            offsetAncestor = TP.elementGetOffsetParent(offsetAncestor);
        }

        offsetWidth = anElement.offsetWidth;
        offsetHeight = anElement.offsetHeight;
    } else {
        elementBox = anElement.getBoundingClientRect();

        //  Mozilla's getBoundingClientRect() method hands back float
        //  values - in case Trident/Webkit's do the same thing, we
        //  round these to integers.
        offsetX = elementBox.left;
        offsetY = elementBox.top;
        offsetWidth = elementBox.width;
        offsetHeight = elementBox.height;
    }

    box = TP.hc('left', offsetX,
                    'top', offsetY,
                    'width', offsetWidth,
                    'height', offsetHeight,
                    'right', offsetX + offsetWidth,
                    'bottom', offsetY + offsetHeight);

    return box;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetFirstEnabledWith',
function(anElement, anAttrName, anAttrValue) {

    /**
     * @method elementGetFirstEnabledWith
     * @summary Starting at the supplied element, this method works its way up
     *     the ancestor chain to an element that doesn't have a 'disabled'
     *     attribute on it and has the supplied attribute name (and possible
     *     attribute value) present on it. If any element in the chain is
     *     'disabled', this routine returns null.
     * @param {HTMLElement} anElement The element to begin searching for the
     *     ancestor.
     * @param {String} anAttrName The name of the attribute to look for on the
     *     ancestor.
     * @param {String} anAttrValue The value of the attribute to check for.
     * @returns {HTMLElement}
     */

    var theElement,
        retElement,

        hasAttrValue;

    theElement = anElement;
    retElement = null;

    hasAttrValue = TP.notEmpty(anAttrValue);

    //  Starting at the supplied element, traverse up the parent chain to
    //  the Document node.
    while (theElement.nodeType !== Node.DOCUMENT_NODE &&
            theElement.nodeType !== Node.DOCUMENT_FRAGMENT_NODE) {
        //  If the element at this level is 'disabled', then nothing we do
        //  here matters, so we bail out.
        if (TP.elementHasAttribute(theElement, 'disabled')) {
            retElement = null;
            break;
        }

        //  If the return element hasn't already been set and the element at
        //  this level has the supplied attribute, then set the element at
        //  this level to be the return element.
        if (TP.notValid(retElement)) {
            if (hasAttrValue &&
                TP.elementGetAttribute(theElement, anAttrName, true) ===
                                                        anAttrValue) {
                retElement = theElement;
            } else if (TP.elementHasAttribute(theElement, anAttrName, true)) {
                retElement = theElement;
            }

            //  Notice how we do *not* break here, so that if any parent
            //  above us is disabled, we will still return 'null'.
        }

        theElement = theElement.parentNode;
    }

    return retElement;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$elementGetBusyLayer',
function(anElement) {

    /**
     * @method $elementGetBusyLayer
     * @summary Returns a busy layer for the supplied element. This allows the
     *     element to show a busy message along with a spinning icon when
     *     performing time-consuming operations. This element may be reused
     *     across invocations for a particular element.
     * @param {HTMLElement} anElement The element to build the busy element for.
     * @returns {HTMLElement} The busy element itself.
     */

    var busyElement,
        busyBackgroundElement,
        busyMessageElement;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement', anElement);
    }

    if (TP.isElement(busyElement = anElement[TP.BUSY_ELEMENT])) {
        return busyElement;
    }

    //  Create a new 'div' element and set the 'busyfor' attribute on it.
    //  This allows users to override the default styling provided by TIBET
    //  so that they can customize their own busy element look and feel.
    busyElement = anElement.ownerDocument.createElement('div');
    TP.elementSetAttribute(busyElement,
                            'busyfor',
                            TP.elementGetAttribute(anElement, 'id'));

    //  Create a 'busy background' element that will have the busy image set as
    //  its background-image.
    busyBackgroundElement = anElement.ownerDocument.createElement('div');
    TP.elementSetClass(busyBackgroundElement, 'busyImage');
    TP.nodeAppendChild(busyElement, busyBackgroundElement, false);

    //  Create a 'busy message' element that will display the busy message
    //  and which can be set during busy operation to other messages.
    busyMessageElement = anElement.ownerDocument.createElement('span');
    TP.elementSetClass(busyMessageElement, 'busyMessage');
    TP.nodeAppendChild(busyElement, busyMessageElement, false);

    //  Append a text node with a single whitespace character to the busy
    //  message. This forces IE to actually create the text node value.
    TP.nodeAppendChild(busyMessageElement,
                        anElement.ownerDocument.createTextNode(' '),
                        false);

    //  Append the busy element *to the body* so that it doesn't get
    //  clipped by any other elements.
    TP.nodeAppendChild(TP.documentGetBody(anElement.ownerDocument),
                        busyElement,
                        false);

    //  Cache the busy element, the busy background element and the busy
    //  message element as slots on the element they were created for for
    //  much faster display next time.
    anElement[TP.BUSY_ELEMENT] = busyElement;
    anElement[TP.BUSY_BKGD_ELEMENT] = busyBackgroundElement;
    anElement[TP.BUSY_MSG_ELEMENT] = busyMessageElement;

    return busyElement;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetClass',
function(anElement) {

    /**
     * @method elementGetClass
     * @summary Returns the element's CSS class name(s) as a String.
     * @param {Element} anElement The element to retrieve the CSS class name
     *     for.
     * @exception TP.sig.InvalidElement
     * @returns {String} The CSS class name of the supplied element.
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isSVGNode(anElement)) {
        return anElement.className.baseVal;
    }

    return anElement.className;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetClipRect',
function(anElement) {

    /**
     * @method elementGetClipRect
     * @summary Returns the element's clipping rectangle.
     * @description The clipping rectangle is assumed to be in pixels (something
     *     like 'rect(10px 10px 10px 10px)'). If the clipping rectangle is not a
     *     '4 valued' value, null is returned. Each individual value is
     *     processed and turned from its current value into pixels (i.e. the
     *     value might be '4em' - this is converted into pixels). If the value
     *     is 'auto', a null is placed into that position in the Array.
     * @param {HTMLElement} anElement The element to extract the clipping
     *     rectangle from.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidStyleDeclaration
     * @returns {Number[]} An Array of Numbers containing the element's clipping
     *     rectangle *expressed in number of pixels*. The numbers are arranged
     *     in the following order: top, right, bottom, left.
     */

    var computedStyle,

        clipString,
        clipRectArray,

        i,
        entry;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.notValid(computedStyle =
                    TP.elementGetComputedStyleObj(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    clipString = computedStyle.clip;

    clipRectArray = null;

    //  Extract the clipping rectangle from the String using a RegExp and
    //  put it into clipRectArray
    clipRectArray = TP.regex.CSS_CLIP_RECT.exec(clipString);

    if (TP.isArray(clipRectArray)) {
        //  Since the entire results will be the first element, with the
        //  individually grouped results after it, (as it always is with a
        //  RegExp 'exec') get rid of that first element so that the
        //  individual clip entries are at 0, 1, 2, 3.
        clipRectArray.shift();

        //  Loop over each item. It could either be 'auto' or a number
        //  followed by a unit. The entry could have a comma at the end, so
        //  we trim that.
        for (i = 0; i < clipRectArray.getSize(); i++) {
            entry = clipRectArray.at(i);
            entry = entry.strip(/,$/);

            if (entry === 'auto') {
                entry = null;
            } else if (!TP.isNaN(parseInt(entry, 10))) {
                //  The array is top, left, bottom, right - vertical values
                //  are at even positions, horizontal values are at odd
                //  ones.
                if (i.isEven()) {
                    entry = TP.elementGetPixelValue(anElement,
                                                    entry,
                                                    'height');
                } else {
                    entry = TP.elementGetPixelValue(anElement,
                                                    entry,
                                                    'width');
                }
            }

            clipRectArray.atPut(i, entry);
        }
    }

    return clipRectArray;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetContainingBlockElement',
function(anElement) {

    /**
     * @method elementContainingBlockElement
     * @summary Returns the element's containing block element.
     * @param {HTMLElement} anElement The element to get the containing block
     *     element of.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidStyleDeclaration
     * @returns {Element} The element's offset parent.
     */

    var computedStyle,

        positionVal,
        doc,
        ancestor;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    doc = TP.nodeGetDocument(anElement);

    //  NOTE: We follow the CSSOM spec here for how to compute the containing
    //  block.

    //  Per the spec, if anElement is the root element, then its containing
    //  block is the hidden 'initial containing block'. Just exit with null
    //  here.
    if (anElement === doc.documentElement) {
        return null;
    }

    //  Grab the computed style for the element
    if (TP.notValid(computedStyle =
                    TP.elementGetComputedStyleObj(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    //  Grab the position of the element
    positionVal = computedStyle.position;

    //  Per the spec, if anElement is 'fixed' position, then we exit with null
    //  here as well.
    if (positionVal === 'fixed') {
        return null;
    }

    //  Per the spec, if anElement is 'static' or 'relative' position, then we
    //  obtain the nearest ancestor that has a display value of 'block',
    //  'inline-block', 'list-item', 'run-in', 'table', or 'table-cell'.
    if (positionVal === 'static' || positionVal === 'relative') {
        ancestor =
            TP.nodeDetectAncestor(
                anElement,
                function(aParent) {

                    var parentDisplayVal;

                    //  Per the spec, if aParent is the (X)HTML 'body', then we
                    //  use it.
                    if (aParent === doc.body) {
                        return true;
                    }

                    //  Grab the parent's display value.
                    parentDisplayVal =
                            TP.elementGetComputedStyleObj(aParent).display;

                    if (parentDisplayVal === 'block' ||
                        parentDisplayVal === 'inline-block' ||
                        parentDisplayVal === 'list-item' ||
                        parentDisplayVal === 'run-in' ||
                        parentDisplayVal === 'table' ||
                        parentDisplayVal === 'table-cell') {
                        return true;
                    }
                });
    }

    //  Per the spec, if anElement is 'absolute' position, then we obtain the
    //  nearest ancestor that has a position value of 'absolute', 'relative' or
    //  'fixed'.
    if (positionVal === 'absolute') {
        ancestor =
            TP.nodeDetectAncestor(
                anElement,
                function(aParent) {

                    var parentPositionVal;

                    //  Per the spec, if aParent is the (X)HTML 'body', then we
                    //  use it.
                    if (aParent === doc.body) {
                        return true;
                    }

                    //  Grab the parent's position value.
                    parentPositionVal =
                            TP.elementGetComputedStyleObj(aParent).position;

                    if (parentPositionVal === 'absolute' ||
                        parentPositionVal === 'relative' ||
                        parentPositionVal === 'fixed') {
                        return true;
                    }
                });
    }

    return ancestor;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetContentHeight',
function(anElement, wantsTransformed) {

    /**
     * @method elementGetContentHeight
     * @summary Returns the element's content height. This is equivalent to the
     *     height of the element if the element's height was set to 'auto' -
     *     that is, if the element was 'shrink-wrapping' its content.
     * @param {HTMLElement} anElement The element to extract the content height
     *     from.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @returns {Number} The element's content height in pixels.
     */

    var theHeight;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if ((theHeight = anElement.scrollHeight) === 0) {
        theHeight =
            TP.elementGetBorderBox(anElement, wantsTransformed).at('height');
    }

    return theHeight;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetContentWidth',
function(anElement, wantsTransformed) {

    /**
     * @method elementGetContentWidth
     * @summary Returns the element's content width. This is equivalent to the
     *     width of the element if the element's width was set to 'auto' - that
     *     is, if the element was 'shrink-wrapping' its content.
     * @param {HTMLElement} anElement The element to extract the content width
     *     from.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @returns {Number} The element's content width in pixels.
     */

    var theWidth;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if ((theWidth = anElement.scrollWidth) === 0) {
        theWidth =
            TP.elementGetBorderBox(anElement, wantsTransformed).at('width');
    }

    return theWidth;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetEffectiveBackgroundColor',
function(anElement) {

    /**
     * @method elementGetEffectiveBackgroundColor
     * @summary Obtains the effective background color from the element,
     *     ignoring a value of transparent. This method will traverse the
     *     supplied element's ancestor chain, looking for the first
     *     non-transparent element.
     * @param {HTMLElement} anElement The element to obtain the effective
     *     background color for.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidStyleDeclaration
     * @returns {String} The element's effective background color.
     */

    var computedStyle,

        elementColor;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.notValid(computedStyle =
                    TP.elementGetComputedStyleObj(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    //  First, check to see if our computed color is transparent
    if ((elementColor = computedStyle.backgroundColor) !== 'transparent') {
        return elementColor;
    }

    //  Iterate upward through the ancestor chain, looking for the first
    //  non-transparent element and capture its color.

    elementColor = null;

    TP.nodeDetectAncestor(
        anElement,
        function(aParentElement) {

            var compStyle;

            if (TP.notValid(compStyle =
                            TP.elementGetComputedStyleObj(aParentElement))) {
                return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
            }

            //  If we found one that was not transparent, we can stop now.
            if ((elementColor = compStyle.backgroundColor) !==
                                                        'transparent') {
                return true;
            }

            return false;
        });

    //  If we didn't get a valid value for the color, or it was
    //  'transparent', that means that every parent element was
    //  transparent, including the 'body' element.
    if (TP.notValid(elementColor) || elementColor === 'transparent') {
        elementColor = 'white';
    }

    return elementColor;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetGlobalBox',
function(anElement, boxType, ancestor, wantsTransformed) {

    /**
     * @method elementGetGlobalBox
     * @summary Returns the element's 'box' of coordinates expressed as
     *     'global' coordinates. This is the value of the element's page box,
     *     plus any offset of the document window (which normally occurs if the
     *     element is hosted inside of an iframe). Therefore, this is the
     *     element's box relative to the top-level window it is hosted in.
     * @param {HTMLElement} anElement The element to extract the box from.
     * @param {String} boxType A TIBET constant that determines the 'box' to
     *     compute the box from. This can one of the following values:
     *     TP.CONTENT_BOX TP.PADDING_BOX TP.BORDER_BOX TP.MARGIN_BOX If this
     *     parameter is not supplied, it defaults to TP.BORDER_BOX.
     * @param {HTMLElement} ancestor An optional ancestor of the supplied
     *     element. If this element is supplied, the result value will be
     *     computed relative to this ancestor.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidWindow
     * @returns {TP.core.Hash} A hash containing the box at: 'left', 'top',
     *     'right', 'bottom', 'width', 'height'.
     */

    var elemWin,

        windowTransformation,
        ourTransformation,
        finalTransformation,
        result,

        frameOffsetXAndY,

        box,
        ancestorBox;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (!TP.isWindow(elemWin = TP.nodeGetWindow(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (wantsTransformed) {
        //  Note that we specifically force wantsTransformed here to be false
        box = TP.elementGetPageBox(anElement, boxType, null, false);

        //  Compute any transformations of anElement's window(s) (up an iframe
        //  chain to a top-level window)
        windowTransformation = TP.windowComputeTransformationMatrix(elemWin);

        //  Compute our transformation matrix
        ourTransformation = TP.elementGetComputedTransformMatrix(anElement);

        //  Accumulate the two together to form a 'final transformation'
        finalTransformation = TP.matrixMultiply(windowTransformation,
                                                ourTransformation);

        //  Transform the box values using the final transformation matrix
        result = TP.matrixTransformRect(finalTransformation,
                                        box.at('left'),
                                        box.at('top'),
                                        box.at('width'),
                                        box.at('height'));
        box = TP.hc(
                'left', result.at(0),
                'top', result.at(1),
                'right', result.at(0) + result.at(2),
                'bottom', result.at(1) + result.at(3),
                'width', result.at(2),
                'height', result.at(3));

    } else {
        box = TP.elementGetPageBox(anElement, boxType, null, false);
    }

    if (TP.isElement(elemWin.frameElement)) {
        //  Note here that we pass the result of obtaining the top window for
        //  the supplied element as the first argument since we really just want
        //  the offset of winFrameElem from the top (which will be 0,0 offset
        //  from itself).
        frameOffsetXAndY = TP.windowComputeWindowOffsets(
                            TP.nodeGetTopWindow(anElement),
                            elemWin,
                            wantsTransformed);
    } else {
        frameOffsetXAndY = TP.ac(0, 0);
    }

    box.atPut('left', box.at('left') + frameOffsetXAndY.first());
    box.atPut('top', box.at('top') + frameOffsetXAndY.last());
    box.atPut('right', box.at('right') + frameOffsetXAndY.first());
    box.atPut('bottom', box.at('bottom') + frameOffsetXAndY.last());

    if (TP.isElement(ancestor) && TP.nodeContainsNode(ancestor, anElement)) {
        if (TP.isNumber(ancestorBox =
                        TP.elementGetGlobalBox(ancestor, boxType, null,
                                                wantsTransformed))) {
            return TP.hc(
                'top', box.at('top') - ancestorBox.at('top'),
                'right', box.at('right') - ancestorBox.at('right'),
                'bottom', box.at('bottom') - ancestorBox.at('bottom'),
                'left', box.at('left') - ancestorBox.at('left'),
                'width', box.at('width'),
                'height', box.at('height'));
        }
    }

    return box;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetGlobalX',
function(anElement, boxType, ancestor, wantsTransformed) {

    /**
     * @method elementGetGlobalX
     * @summary Gets the element's global X coordinate. This is the value of
     *     the element's page X coordinate, plus any offset of the document
     *     window (which normally occurs if the element is hosted inside of an
     *     iframe). Therefore, this is the element's X coordinate relative to
     *     the top-level window it is hosted in.
     * @param {HTMLElement} anElement The element to get the X coordinate of.
     * @param {String} boxType A TIBET constant that determines the 'box' to
     *     compute the coordinate from. This can one of the following values:
     *     TP.CONTENT_BOX TP.PADDING_BOX TP.BORDER_BOX TP.MARGIN_BOX If this
     *     parameter is not supplied, it defaults to TP.BORDER_BOX.
     * @param {HTMLElement} ancestor An optional ancestor of the supplied
     *     element. If this element is supplied, the result value will be
     *     computed relative to this ancestor.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidWindow
     * @returns {Number} The global X coordinate of the element in pixels.
     */

    var elemWin,
        winFrameElem,
        frameOffsetX,

        position,

        ancestorPosition;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (!TP.isWindow(elemWin = TP.nodeGetWindow(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (TP.isElement(winFrameElem = elemWin.frameElement)) {
        //  Note here that we pass the result of obtaining the top window for
        //  the supplied element as the first argument since we really just want
        //  the offset of winFrameElem from the top (which will be 0,0 offset
        //  from itself).
        frameOffsetX = TP.windowComputeWindowOffsets(
                        TP.nodeGetTopWindow(anElement),
                        TP.elementGetIFrameWindow(winFrameElem)).first();
    } else {
        frameOffsetX = 0;
    }

    position = TP.elementGetPageX(anElement, boxType, null, wantsTransformed) +
                     frameOffsetX;

    if (TP.isElement(ancestor) && TP.nodeContainsNode(ancestor, anElement)) {
        if (TP.isNumber(ancestorPosition =
                        TP.elementGetGlobalX(
                            ancestor, boxType, wantsTransformed))) {
            return position - ancestorPosition;
        }
    }

    return position;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetGlobalY',
function(anElement, boxType, ancestor, wantsTransformed) {

    /**
     * @method elementGetGlobalY
     * @summary Gets the element's global Y coordinate. This is the value of
     *     the element's page Y coordinate, plus any offset of the document
     *     window (which normally occurs if the element is hosted inside of an
     *     iframe). Therefore, this is the element's Y coordinate relative to
     *     the top-level window it is hosted in.
     * @param {HTMLElement} anElement The element to get the Y coordinate of.
     * @param {String} boxType A TIBET constant that determines the 'box' to
     *     compute the coordinate from. This can one of the following values:
     *     TP.CONTENT_BOX TP.PADDING_BOX TP.BORDER_BOX TP.MARGIN_BOX If this
     *     parameter is not supplied, it defaults to TP.BORDER_BOX.
     * @param {HTMLElement} ancestor An optional ancestor of the supplied
     *     element. If this element is supplied, the result value will be
     *     computed relative to this ancestor.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidWindow
     * @returns {Number} The global Y coordinate of the element in pixels.
     */

    var elemWin,
        winFrameElem,
        frameOffsetY,

        position,

        ancestorPosition;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (!TP.isWindow(elemWin = TP.nodeGetWindow(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (TP.isElement(winFrameElem = elemWin.frameElement)) {
        //  Note here that we pass the result of obtaining the top window for
        //  the supplied element as the first argument since we really just want
        //  the offset of winFrameElem from the top (which will be 0,0 offset
        //  from itself).
        frameOffsetY = TP.windowComputeWindowOffsets(
                        TP.nodeGetTopWindow(anElement),
                        TP.elementGetIFrameWindow(winFrameElem)).last();
    } else {
        frameOffsetY = 0;
    }

    position = TP.elementGetPageY(anElement, boxType, null, wantsTransformed) +
                     frameOffsetY;

    if (TP.isElement(ancestor) && TP.nodeContainsNode(ancestor, anElement)) {
        if (TP.isNumber(ancestorPosition =
                        TP.elementGetGlobalY(
                            ancestor, boxType, wantsTransformed))) {
            return position - ancestorPosition;
        }
    }

    return position;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetGlobalXY',
function(anElement, boxType, ancestor, wantsTransformed) {

    /**
     * @method elementGetGlobalXY
     * @summary Gets the element's global X and Y coordinates. This is the
     *     value of the element's page X and Y coordinates, plus any offset of
     *     the document window (which normally occurs if the element is hosted
     *     inside of an iframe). Therefore, this is the element's X and Y
     *     coordinates relative to the top-level window it is hosted in.
     * @param {HTMLElement} anElement The element to get the X and Y coordinates
     *     of.
     * @param {String} boxType A TIBET constant that determines the 'box' to
     *     compute the coordinates from. This can one of the following values:
     *     TP.CONTENT_BOX TP.PADDING_BOX TP.BORDER_BOX TP.MARGIN_BOX If this
     *     parameter is not supplied, it defaults to TP.BORDER_BOX.
     * @param {HTMLElement} ancestor An optional ancestor of the supplied
     *     element. If this element is supplied, the result value will be
     *     computed relative to this ancestor.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidWindow
     * @returns {Number} The global X and Y coordinates of the element in
     *     pixels.
     */

    var elemWin,
        winFrameElem,
        frameOffsetXAndY,

        position,

        ancestorPosition;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (!TP.isWindow(elemWin = TP.nodeGetWindow(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (TP.isElement(winFrameElem = elemWin.frameElement)) {
        //  Note here that we pass the result of obtaining the top window for
        //  the supplied element as the first argument since we really just want
        //  the offset of winFrameElem from the top (which will be 0,0 offset
        //  from itself).
        frameOffsetXAndY = TP.windowComputeWindowOffsets(
                            TP.nodeGetTopWindow(anElement),
                            TP.elementGetIFrameWindow(winFrameElem));
    } else {
        frameOffsetXAndY = TP.ac(0, 0);
    }

    position = TP.elementGetPageXY(anElement, boxType, null, wantsTransformed);

    position = TP.ac(frameOffsetXAndY.first() + position.first(),
                        frameOffsetXAndY.last() + position.last());

    if (TP.isElement(ancestor) && TP.nodeContainsNode(ancestor, anElement)) {
        if (TP.isArray(ancestorPosition =
                        TP.elementGetGlobalXY(ancestor, boxType, null,
                                                 wantsTransformed))) {
            return TP.ac(position.first() - ancestorPosition.first(),
                            position.last() - ancestorPosition.last());
        }
    }

    return position;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetHeight',
function(anElement, boxType, wantsTransformed) {

    /**
     * @method elementGetHeight
     * @summary Returns the element's height.
     * @param {HTMLElement} anElement The element to extract the height from.
     * @param {String} boxType A TIBET constant that determines the 'box' to
     *     compute the height from. This can one of the following values:
     *     TP.CONTENT_BOX TP.PADDING_BOX TP.BORDER_BOX TP.MARGIN_BOX If this
     *     parameter is not supplied, it defaults to TP.BORDER_BOX.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @returns {Number} The element's height in pixels.
     */

    var heightVal,

        returnedBoxType;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  Note that offsetHeight returns our equivalent of TP.BORDER_BOX
    heightVal =
        TP.elementGetBorderBox(anElement, wantsTransformed).at('height');

    returnedBoxType = TP.ifInvalid(boxType, TP.BORDER_BOX);

    //  So now, the returned value is the TP.BORDER_BOX. If the caller
    //  supplied other box types to return, add those values.

    switch (returnedBoxType) {
        case TP.CONTENT_BOX:

            /* eslint-disable no-extra-parens */

            //  TP.CONTENT_BOX means we subtract both the border and the
            //  padding from both ends.
            heightVal -=
                (TP.elementGetPaddingInPixels(anElement,
                                              TP.TOP,
                                              wantsTransformed) +
                    TP.elementGetBorderInPixels(anElement,
                                                 TP.TOP,
                                                 wantsTransformed));

            heightVal -=
                (TP.elementGetPaddingInPixels(anElement,
                                              TP.BOTTOM,
                                              wantsTransformed) +
                    TP.elementGetBorderInPixels(anElement,
                                                 TP.BOTTOM,
                                                 wantsTransformed));

            /* eslint-enable no-extra-parens */

            break;

        case TP.PADDING_BOX:

            //  TP.PADDING_BOX means we add the border from both ends.
            heightVal -= TP.elementGetBorderInPixels(anElement,
                                                        TP.TOP,
                                                        wantsTransformed);
            heightVal -= TP.elementGetBorderInPixels(anElement,
                                                        TP.BOTTOM,
                                                        wantsTransformed);

            break;

        case TP.BORDER_BOX:

            //  TP.BORDER_BOX means we do nothing

            break;

        case TP.MARGIN_BOX:

            //  TP.MARGIN_BOX means we add the margin from both ends.
            heightVal += TP.elementGetMarginInPixels(anElement,
                                                        TP.TOP,
                                                        wantsTransformed);
            heightVal += TP.elementGetMarginInPixels(anElement,
                                                        TP.BOTTOM,
                                                        wantsTransformed);
            break;

        default:
            break;
    }

    return heightVal;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetInnerContent',
function(anElement) {

    /**
     * @method elementGetInnerContent
     * @summary Gets the 'inner content' of anElement.
     * @description This method gets the 'inner content' of anElement which
     *     means that just the contents of the element, not including its start
     *     and end tags, will be returned.
     * @param {HTMLElement} anElement The element to get the 'inner content' of.
     * @exception TP.sig.InvalidElement
     * @returns {String} The 'inner content' of anElement.
     */

    var str;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isHTMLNode(anElement)) {
        return anElement.innerHTML;
    }

    str = TP.nodeAsString(anElement, false, false);

    return str.slice(str.indexOf('>') + 1, str.lastIndexOf('<'));
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetOffsetFromContainer',
function(anElement, wantsTransformed) {

    /**
     * @method elementGetOffsetFromContainer
     * @summary Returns an Array containing the X and Y of the total amount
     *     that the supplied Element is offset from the top, left corner of *its
     *     nearest positioned parent element*. This may or may not be the
     *     element's direct parentNode.
     * @param {HTMLElement} anElement The element to compute the offset from.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @returns {Number[]} An ordered pair containing the X amount in the first
     *     position and the Y amount in the second position.
     */

    var positionedAncestor;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    positionedAncestor = TP.elementGetOffsetParent(anElement);

    if (TP.isElement(positionedAncestor) &&
        TP.nodeContainsNode(positionedAncestor, anElement)) {
        return TP.elementGetPageXY(anElement,
                                    TP.BORDER_BOX,
                                    positionedAncestor,
                                    wantsTransformed);
    } else {
        return TP.ac(0, 0);
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetPageBox',
function(anElement, boxType, ancestor, wantsTransformed) {

    /**
     * @method elementGetPageBox
     * @summary Returns the element's 'box' of coordinates relative to the
     *     page.
     * @param {HTMLElement} anElement The element to extract the box from.
     * @param {String} boxType A TIBET constant that determines the 'box' to
     *     compute the box from. This can one of the following values:
     *     TP.CONTENT_BOX TP.PADDING_BOX TP.BORDER_BOX TP.MARGIN_BOX If this
     *     parameter is not supplied, it defaults to TP.BORDER_BOX.
     * @param {HTMLElement} ancestor An optional ancestor of the supplied
     *     element. If this element is supplied, the result value will be
     *     computed relative to this ancestor.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @returns {TP.core.Hash} A hash containing the box at: 'left', 'top',
     *     'right', 'bottom', 'width', 'height'.
     */

    var elemBox,

        returnedBoxType,

        offsets,

        ancestorBox;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    elemBox = TP.elementGetBorderBox(anElement, wantsTransformed);

    returnedBoxType = TP.ifInvalid(boxType, TP.BORDER_BOX);

    //  So now, the returned value is the TP.BORDER_BOX. If the caller
    //  supplied other box types to return, add those values.

    switch (returnedBoxType) {
        case TP.CONTENT_BOX:

            //  TP.CONTENT_BOX means we inset both the border and the
            //  padding from all sides

            offsets = TP.elementGetComputedStyleValuesInPixels(
                        anElement,
                        TP.ac('borderTopWidth', 'borderBottomWidth',
                                'borderLeftWidth', 'borderRightWidth',
                                'paddingTop', 'paddingBottom',
                                'paddingLeft', 'paddingRight'),
                        wantsTransformed);

            elemBox.atPut('top',
                elemBox.at('top') +
                    (offsets.at('borderTopWidth') +
                        offsets.at('paddingTop')));

            elemBox.atPut('right',
                elemBox.at('right') -
                    (offsets.at('borderRightWidth') +
                        offsets.at('paddingRight')));

            elemBox.atPut('bottom',
                elemBox.at('bottom') -
                    (offsets.at('borderBottomWidth') +
                        offsets.at('paddingBottom')));

            elemBox.atPut('left',
                elemBox.at('left') +
                    (offsets.at('borderLeftWidth') +
                        offsets.at('paddingLeft')));

            elemBox.atPut('height',
                elemBox.at('height') -
                    (offsets.at('borderTopWidth') +
                        offsets.at('paddingTop') +
                     offsets.at('borderBottomWidth') +
                        offsets.at('paddingBottom')));

            elemBox.atPut('width',
                elemBox.at('width') -
                    (offsets.at('borderLeftWidth') +
                        offsets.at('paddingLeft') +
                     offsets.at('borderRightWidth') +
                        offsets.at('paddingRight')));

            break;

        case TP.PADDING_BOX:

            //  TP.PADDING_BOX means we inset the border from all
            //  sides.
            offsets = TP.elementGetComputedStyleValuesInPixels(
                        anElement,
                        TP.ac('borderTopWidth', 'borderBottomWidth',
                                'borderLeftWidth', 'borderRightWidth'),
                        wantsTransformed);

            elemBox.atPut('top',
                elemBox.at('top') + offsets.at('borderTopWidth'));

            elemBox.atPut('right',
                elemBox.at('right') - offsets.at('borderRightWidth'));

            elemBox.atPut('bottom',
                elemBox.at('bottom') - offsets.at('borderBottomWidth'));

            elemBox.atPut('left',
                elemBox.at('left') + offsets.at('borderLeftWidth'));

            elemBox.atPut('height',
                elemBox.at('height') -
                    (offsets.at('borderBottomWidth') +
                     offsets.at('borderTopWidth')));

            elemBox.atPut('width',
                elemBox.at('width') -
                    (offsets.at('borderLeftWidth') +
                     offsets.at('borderRightWidth')));

            break;

        case TP.BORDER_BOX:

            //  TP.BORDER_BOX means we do nothing

            break;

        case TP.MARGIN_BOX:

            //  TP.MARGIN_BOX means we outset the margin from both ends.
            offsets = TP.elementGetComputedStyleValuesInPixels(
                            anElement,
                            TP.ac('marginTop', 'marginWidth',
                                    'marginLeft', 'marginRight'),
                            wantsTransformed);

            elemBox.atPut('top',
                elemBox.at('top') - offsets.at('marginTop'));

            elemBox.atPut('right',
                elemBox.at('right') + offsets.at('marginRight'));

            elemBox.atPut('bottom',
                elemBox.at('bottom') + offsets.at('marginBottom'));

            elemBox.atPut('left',
                elemBox.at('left') - offsets.at('marginLeft'));

            elemBox.atPut('height',
                elemBox.at('height') + offsets.at('marginBottom'));

            elemBox.atPut('width',
                elemBox.at('width') + offsets.at('marginLeft'));

            break;

        default:
            break;
    }

    if (TP.isElement(ancestor) && TP.nodeContainsNode(ancestor, anElement)) {
        if (TP.isNumber(ancestorBox =
                        TP.elementGetPageBox(ancestor, boxType, null,
                                                wantsTransformed))) {
            return TP.hc(
                'top', elemBox.at('top') - ancestorBox.at('top'),
                'right', elemBox.at('right') - ancestorBox.at('right'),
                'bottom', elemBox.at('bottom') - ancestorBox.at('bottom'),
                'left', elemBox.at('left') - ancestorBox.at('left'),
                'width', elemBox.at('width'),
                'height', elemBox.at('height'));
        }
    }

    return elemBox;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetPageX',
function(anElement, boxType, ancestor, wantsTransformed) {

    /**
     * @method elementGetPageX
     * @summary Gets the element's page X coordinate.
     * @param {HTMLElement} anElement The element to get the X coordinate of.
     * @param {String} boxType A TIBET constant that determines the 'box' to
     *     compute the coordinate from. This can one of the following values:
     *     TP.CONTENT_BOX TP.PADDING_BOX TP.BORDER_BOX TP.MARGIN_BOX If this
     *     parameter is not supplied, it defaults to TP.BORDER_BOX.
     * @param {HTMLElement} ancestor An optional ancestor of the supplied
     *     element. If this element is supplied, the result value will be
     *     computed relative to this ancestor.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @returns {Number} The page X coordinate of the element in pixels.
     */

    var position,

        returnedBoxType,

        ancestorPosition;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  This call automatically takes scrolling, both the document and the
    //  'offset chain' scrolling offsets, into account.
    position = TP.elementGetBorderBox(anElement, wantsTransformed).at('left');

    returnedBoxType = TP.ifInvalid(boxType, TP.BORDER_BOX);

    //  So now, the returned value is the TP.BORDER_BOX. If the caller
    //  supplied other box types to return, add those values.

    switch (returnedBoxType) {
        case TP.CONTENT_BOX:

            //  TP.CONTENT_BOX means we can have to add the border and
            //  the padding
            position += TP.elementGetBorderInPixels(anElement,
                                                        TP.LEFT,
                                                        wantsTransformed);
            position += TP.elementGetPaddingInPixels(anElement,
                                                        TP.LEFT,
                                                        wantsTransformed);
            break;

        case TP.PADDING_BOX:

            //  TP.PADDING_BOX means we have to add the border

            position += TP.elementGetBorderInPixels(anElement,
                                                        TP.LEFT,
                                                        wantsTransformed);
            break;

        case TP.BORDER_BOX:

            //  TP.BORDER_BOX means we do nothing.

            break;

        case TP.MARGIN_BOX:

            //  TP.MARGIN_BOX means we subtract the margin off of the
            //  total
            position -= TP.elementGetMarginInPixels(anElement,
                                                    TP.LEFT,
                                                    wantsTransformed);
            break;

        default:
            break;
    }

    if (TP.isElement(ancestor) && TP.nodeContainsNode(ancestor, anElement)) {
        if (TP.isNumber(ancestorPosition =
                TP.elementGetPageX(ancestor, boxType, null,
                                     wantsTransformed))) {
            return position - ancestorPosition;
        }
    }

    return position;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetPageY',
function(anElement, boxType, ancestor, wantsTransformed) {

    /**
     * @method elementGetPageY
     * @summary Gets the element's page Y coordinate.
     * @param {HTMLElement} anElement The element to get the Y coordinate of.
     * @param {String} boxType A TIBET constant that determines the 'box' to
     *     compute the coordinate from. This can one of the following values:
     *     TP.CONTENT_BOX TP.PADDING_BOX TP.BORDER_BOX TP.MARGIN_BOX If this
     *     parameter is not supplied, it defaults to TP.BORDER_BOX.
     * @param {HTMLElement} ancestor An optional ancestor of the supplied
     *     element. If this element is supplied, the result value will be
     *     computed relative to this ancestor.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @returns {Number} The page Y coordinate of the element in pixels.
     */

    var position,

        returnedBoxType,

        ancestorPosition;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  This call automatically takes scrolling, both the document and the
    //  'offset chain' scrolling offsets, into account.
    position = TP.elementGetBorderBox(anElement, wantsTransformed).at('top');

    returnedBoxType = TP.ifInvalid(boxType, TP.BORDER_BOX);

    //  So now, the returned value is the TP.BORDER_BOX. If the caller
    //  supplied other box types to return, add those values.

    switch (returnedBoxType) {
        case TP.CONTENT_BOX:

            //  TP.CONTENT_BOX means we can have to add the border and
            //  the padding
            position += TP.elementGetBorderInPixels(anElement,
                                                    TP.TOP,
                                                    wantsTransformed);
            position += TP.elementGetPaddingInPixels(anElement,
                                                        TP.TOP,
                                                        wantsTransformed);
            break;

        case TP.PADDING_BOX:

            //  TP.PADDING_BOX means we have to add the border

            position += TP.elementGetBorderInPixels(anElement,
                                                    TP.TOP,
                                                    wantsTransformed);
            break;

        case TP.BORDER_BOX:

            //  TP.BORDER_BOX means we do nothing.

            break;

        case TP.MARGIN_BOX:

            //  TP.MARGIN_BOX means we subtract the margin off of the
            //  total
            position -= TP.elementGetMarginInPixels(anElement,
                                                    TP.TOP,
                                                    wantsTransformed);
            break;

        default:
            break;
    }

    if (TP.isElement(ancestor) && TP.nodeContainsNode(ancestor, anElement)) {
        if (TP.isNumber(ancestorPosition =
                TP.elementGetPageY(ancestor, boxType, null,
                                    wantsTransformed))) {
            return position - ancestorPosition;
        }
    }

    return position;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetPageXY',
function(anElement, boxType, ancestor, wantsTransformed) {

    /**
     * @method elementGetPageXY
     * @summary Gets the element's page X and Y coordinates.
     * @param {HTMLElement} anElement The element to get the X and Y coordinates
     *     of.
     * @param {String} boxType A TIBET constant that determines the 'box' to
     *     compute the coordinates from. This can one of the following values:
     *     TP.CONTENT_BOX TP.PADDING_BOX TP.BORDER_BOX TP.MARGIN_BOX If this
     *     parameter is not supplied, it defaults to TP.BORDER_BOX.
     * @param {HTMLElement} ancestor An optional ancestor of the supplied
     *     element. If this element is supplied, the result value will be
     *     computed relative to this ancestor.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @returns {Number[]} The page X and Y coordinates of the element in
     *     pixels.
     */

    var positions,
        xPosition,
        yPosition,

        returnedBoxType,

        ancestorPosition;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  This call automatically takes scrolling, both the document and the
    //  'offset chain' scrolling offsets, into account.
    positions = TP.elementGetBorderBox(anElement, wantsTransformed);
    xPosition = positions.at('left');
    yPosition = positions.at('top');

    returnedBoxType = TP.ifInvalid(boxType, TP.BORDER_BOX);

    //  So now, the returned value is the TP.BORDER_BOX. If the caller
    //  supplied other box types to return, add those values.

    switch (returnedBoxType) {
        case TP.CONTENT_BOX:

            //  TP.CONTENT_BOX means we can have to add the border and
            //  the padding
            xPosition += TP.elementGetBorderInPixels(anElement,
                                                        TP.LEFT,
                                                        wantsTransformed);
            xPosition += TP.elementGetPaddingInPixels(anElement,
                                                        TP.LEFT,
                                                        wantsTransformed);
            yPosition += TP.elementGetBorderInPixels(anElement,
                                                        TP.TOP,
                                                        wantsTransformed);
            yPosition += TP.elementGetPaddingInPixels(anElement,
                                                        TP.TOP,
                                                        wantsTransformed);
            break;

        case TP.PADDING_BOX:

            //  TP.PADDING_BOX means we have to add the border

            xPosition += TP.elementGetBorderInPixels(anElement,
                                                        TP.LEFT,
                                                        wantsTransformed);
            yPosition += TP.elementGetBorderInPixels(anElement,
                                                        TP.TOP,
                                                        wantsTransformed);
            break;

        case TP.BORDER_BOX:

            //  TP.BORDER_BOX means we do nothing.

            break;

        case TP.MARGIN_BOX:

            //  TP.MARGIN_BOX means we subtract the margin off of the
            //  total
            xPosition -= TP.elementGetMarginInPixels(anElement,
                                                        TP.LEFT,
                                                        wantsTransformed);
            yPosition -= TP.elementGetMarginInPixels(anElement,
                                                        TP.TOP,
                                                        wantsTransformed);
            break;

        default:
            break;
    }

    if (TP.isElement(ancestor) && TP.nodeContainsNode(ancestor, anElement)) {
        if (TP.isArray(ancestorPosition =
                TP.elementGetPageXY(ancestor, boxType, null,
                                     wantsTransformed))) {
            return TP.ac(xPosition - ancestorPosition.first(),
                            yPosition - ancestorPosition.last());
        }
    }

    return TP.ac(xPosition, yPosition);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetOffsetBox',
function(anElement, boxType, wantsTransformed) {

    /**
     * @method elementGetOffsetBox
     * @summary Returns the element's 'box' of coordinates expressed as
     *     'offset' coordinates. This is the value of the element's page box,
     *     minus any offset of the element's offset parent. Therefore, this is
     *     the element's box relative to its offset parent.
     * @param {HTMLElement} anElement The element to extract the box from.
     * @param {String} boxType A TIBET constant that determines the 'box' to
     *     compute the box from. This can one of the following values:
     *     TP.CONTENT_BOX TP.PADDING_BOX TP.BORDER_BOX TP.MARGIN_BOX If this
     *     parameter is not supplied, it defaults to TP.BORDER_BOX.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidWindow
     * @returns {TP.core.Hash} A hash containing the box at: 'left', 'top',
     *     'right', 'bottom', 'width', 'height'.
     */

    var offsetAncestor,
        offsetXAndY,

        box;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isElement(offsetAncestor = TP.elementGetOffsetParent(anElement))) {
        offsetXAndY = TP.elementGetPageXY(offsetAncestor, boxType, null,
                                             wantsTransformed);
    } else {
        offsetXAndY = TP.ac(0, 0);
    }

    box = TP.elementGetPageBox(anElement, boxType, null, wantsTransformed);
    box.atPut('left', box.at('left') - offsetXAndY.first());
    box.atPut('top', box.at('top') - offsetXAndY.last());
    box.atPut('right', box.at('right') - offsetXAndY.first());
    box.atPut('bottom', box.at('bottom') - offsetXAndY.last());

    return box;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetOffsetX',
function(anElement, boxType, wantsTransformed) {

    /**
     * @method elementGetOffsetX
     * @summary Gets the element's offset X coordinate.
     * @param {HTMLElement} anElement The element to get the X coordinate of.
     * @param {String} boxType A TIBET constant that determines the 'box' to
     *     compute the coordinate from. This can one of the following values:
     *     TP.CONTENT_BOX TP.PADDING_BOX TP.BORDER_BOX TP.MARGIN_BOX If this
     *     parameter is not supplied, it defaults to TP.BORDER_BOX.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @returns {Number} The offset X coordinate of the element in pixels.
     */

    var offsetAncestor;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  Make sure that the offsetAncestor is an Element (it may be the
    //  Document, in which case there is no offset anyway).
    if (TP.isElement(offsetAncestor = TP.elementGetOffsetParent(anElement))) {
        return TP.elementGetPageX(anElement, boxType, offsetAncestor,
                                     wantsTransformed);
    }

    return TP.elementGetPageX(anElement, boxType, null, wantsTransformed);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetOffsetY',
function(anElement, boxType, wantsTransformed) {

    /**
     * @method elementGetOffsetY
     * @summary Gets the element's offset Y coordinate.
     * @param {HTMLElement} anElement The element to get the Y coordinate of.
     * @param {String} boxType A TIBET constant that determines the 'box' to
     *     compute the coordinate from. This can one of the following values:
     *     TP.CONTENT_BOX TP.PADDING_BOX TP.BORDER_BOX TP.MARGIN_BOX If this
     *     parameter is not supplied, it defaults to TP.BORDER_BOX.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @returns {Number} The offset Y coordinate of the element in pixels.
     */

    var offsetAncestor;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  Make sure that the offsetAncestor is an Element (it may be the
    //  Document, in which case there is no offset anyway).
    if (TP.isElement(offsetAncestor = TP.elementGetOffsetParent(anElement))) {
        return TP.elementGetPageY(anElement, boxType, offsetAncestor,
                                     wantsTransformed);
    }

    return TP.elementGetPageY(anElement, boxType, null, wantsTransformed);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetOffsetXY',
function(anElement, boxType, wantsTransformed) {

    /**
     * @method elementGetOffsetXY
     * @summary Gets the element's offset X and Y coordinates.
     * @param {HTMLElement} anElement The element to get the X and Y coordinates
     *     of.
     * @param {String} boxType A TIBET constant that determines the 'box' to
     *     compute the coordinates from. This can one of the following values:
     *     TP.CONTENT_BOX TP.PADDING_BOX TP.BORDER_BOX TP.MARGIN_BOX If this
     *     parameter is not supplied, it defaults to TP.BORDER_BOX.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @returns {Number[]} The offset X and Y coordinates of the element in
     *     pixels.
     */

    var offsetAncestor;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  Make sure that the offsetAncestor is an Element (it may be the
    //  Document, in which case there is no offset anyway).
    if (TP.isElement(offsetAncestor = TP.elementGetOffsetParent(anElement))) {
        return TP.elementGetPageXY(anElement, boxType, offsetAncestor,
                                     wantsTransformed);
    }

    return TP.elementGetPageXY(anElement, boxType, null, wantsTransformed);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$elementGetOffsetParent',
function(anElement) {

    /**
     * @method $elementGetOffsetParent
     * @summary Returns the element's offset parent.
     * @description This is the lower level routine that this shared amongst the
     *     the public 'TP.elementGetOffsetParent' method and the ECMA5 getter
     *     over in the boot code.
     * @param {HTMLElement} anElement The element to get the offset parent of.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidStyleDeclaration
     * @returns {Element|null} The element's offset parent.
     */

    var computedStyle,

        positionVal,
        doc,
        ancestor;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    doc = TP.nodeGetDocument(anElement);

    //  NOTE: We follow the CSSOM spec here for how to compute offset parent.

    //  Per the spec, if anElement is the root element or the (X)HTML 'body',
    //  then we return null
    if (anElement === doc.documentElement || anElement === doc.body) {
        return null;
    }

    //  Grab the computed style for the element
    if (TP.notValid(computedStyle =
                    TP.elementGetComputedStyleObj(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    //  Grab the position of the element
    positionVal = computedStyle.position;

    //  Per the spec, if anElement is 'fixed' position, then we return null
    if (positionVal === 'fixed') {
        return null;
    }

    ancestor =
        TP.nodeDetectAncestor(
            anElement,
            function(aParent) {

                var parentPositionVal,
                    parentTagName;

                //  Per the spec, if aParent is the (X)HTML 'body', then we
                //  use it.
                if (aParent === doc.body) {
                    return true;
                }

                //  Grab the parent's position.
                parentPositionVal =
                        TP.elementGetComputedStyleObj(aParent).position;

                //  Per the spec, if aParent's computed position is not
                //  'static', then we return it.
                if (parentPositionVal !== 'static') {
                    return true;
                }

                //  Per the spec, if aParent's computed position is 'static',
                //  but it is an (X)HTML 'td', 'th' or 'table', then we return
                //  it.
                parentTagName = aParent.tagName.toLowerCase();
                if (/(td|th|table)/.test(parentTagName)) {
                    return true;
                }
            });

    return ancestor;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetOffsetParent',
function(anElement) {

    /**
     * @method elementGetOffsetParent
     * @summary Returns the element's offset parent.
     * @description Some elements, notably non-XHTML ones, do not have an
     *     'offsetParent' convenience property. This method provides an
     *     implementation of the CSS Object Model specification around the
     *     'offsetParent' property, if the supplied Element doesn't have one.
     * @param {HTMLElement} anElement The element to get the offset parent of.
     * @exception TP.sig.InvalidElement
     * @returns {Element} The element's offset parent.
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isElement(anElement.offsetParent)) {
        return anElement.offsetParent;
    }

    //  Call the lower-level routine that the '.offsetParent' ECMA 5 getter over
    //  in the boot code calls as well.
    return TP.$elementGetOffsetParent(anElement);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetScrollOffsetFromAncestor',
function(anElement, anAncestor, wantsTransformed) {

    /**
     * @method elementGetScrollOffsetFromAncestor
     * @summary Returns an Array containing the X and Y of the total amount
     *     that the supplied Element is scrolled from the top, left corner of
     *     the supplied ancestor. If the ancestor isn't supplied, it defaults to
     *     the supplied element's document.
     * @param {HTMLElement} anElement The element to compute the scroll offset
     *     from.
     * @param {HTMLElement} [anAncestor] The ancestor element to use as the
     *     'outermost' element to compute the scroll offset from. This is an
     *     optional parameter that defaults to the document.
     * @param {Boolean} [wantsTransformed] An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @returns {Number[]} An ordered pair containing the X amount in the first
     *     position and the Y amount in the second position.
     */

    var stopAncestor,

        vals,

        totalLeft,
        totalTop,

        ancestor;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    stopAncestor = anAncestor;
    if (TP.notValid(stopAncestor)) {
        stopAncestor = TP.nodeGetDocument(anElement);
    }

    if (TP.isTrue(wantsTransformed)) {
        vals = TP.elementLocalToGlobalXY(anElement,
                                            anElement.scrollLeft || 0,
                                            anElement.scrollTop || 0);

        totalLeft = vals.first();
        totalTop = vals.last();
    } else {
        totalLeft = anElement.scrollLeft || 0;
        totalTop = anElement.scrollTop || 0;
    }

    ancestor = anElement.parentNode;
    while (TP.isElement(ancestor) && ancestor !== stopAncestor) {

        if (TP.isTrue(wantsTransformed)) {
            vals = TP.elementLocalToGlobalXY(ancestor,
                                                ancestor.scrollLeft || 0,
                                                ancestor.scrollTop || 0);

            totalLeft += vals.first();
            totalTop += vals.last();
        } else {
            totalLeft += ancestor.scrollLeft || 0;
            totalTop += ancestor.scrollTop || 0;
        }

        ancestor = ancestor.parentNode;
    }

    return TP.ac(totalLeft, totalTop);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetScrollOffsetFromContainer',
function(anElement, wantsTransformed) {

    /**
     * @method elementGetScrollOffsetFromContainer
     * @summary Returns an Array containing the X and Y of the total amount
     *     that the supplied Element is scrolled from the top, left corner of
     *     *its nearest positioned parent element*. This may or may not be the
     *     element's direct parentNode.
     * @param {HTMLElement} anElement The element to compute the scroll offset
     *     from.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidStyleDeclaration
     * @returns {Number[]} An ordered pair containing the X amount in the first
     *     position and the Y amount in the second position.
     */

    var elemDoc,

        positionedAncestor,

        computedStyle;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    elemDoc = TP.nodeGetDocument(anElement);

    positionedAncestor = TP.elementGetOffsetParent(anElement);
    while (TP.isElement(positionedAncestor)) {
        //  Test to see if the positioned parent is either the document's
        //  'body' element or is positioned itself. If so, we bail out here.

        if (positionedAncestor === TP.documentGetBody(elemDoc)) {
            break;
        }

        if (TP.notValid(computedStyle =
                        TP.elementGetComputedStyleObj(positionedAncestor))) {
            return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
        }

        if (computedStyle.position === 'absolute' ||
            computedStyle.position === 'relative') {
            break;
        }

        positionedAncestor = TP.elementGetOffsetParent(positionedAncestor);
    }

    //  The positioned ancestor could be a Document if the assignment
    //  happened and then the loop test failed.
    positionedAncestor = TP.isDocument(positionedAncestor) ?
                            positionedAncestor.documentElement :
                            positionedAncestor;

    return TP.elementGetScrollOffsetFromAncestor(anElement,
                                                    positionedAncestor,
                                                    wantsTransformed);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetScrollXY',
function(anElement, wantsTransformed) {

    /**
     * @method elementGetScrollXY
     * @summary Returns an Array containing the X and Y scroll offsets for the
     *     element provided.
     * @param {HTMLElement} anElement The element to get scroll offsets for.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @returns {Number[]} The X and Y offset in pixels.
     */

    var vals;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isTrue(wantsTransformed)) {
        vals = TP.elementLocalToGlobalXY(anElement,
                                            anElement.scrollLeft,
                                            anElement.scrollTop);
    } else {
        vals = TP.ac(anElement.scrollLeft, anElement.scrollTop);
    }

    return vals;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetSideClosestTo',
function(anElement, xCoord, yCoord) {

    /**
     * @method elementGetSideClosestTo
     * @summary Returns the horizontal and vertical 'side' of the element
     *     closest to the point given.
     * @param {HTMLElement} anElement The element to get the 'closest side' of.
     * @param {Number} xCoord The X coordinate, expressed in document-level
     *     coordinates.
     * @param {Number} yCoord The Y coordinate, expressed in document-level
     *     coordinates.
     * @exception TP.sig.InvalidElement
     * @returns {Array<String,String>} Two of the following four values: First
     *     position: TP.RIGHT or TP.LEFT First position: TP.TOP or TP.BOTTOM.
     */

    var pageXY,

        elementWidth,
        elementHeight,

        elementCenterX,
        elementCenterY,

        horizontalSide,
        verticalSide;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  Get the TP.CONTENT_BOX origin of the supplied Element
    pageXY = TP.elementGetPageXY(anElement, TP.CONTENT_BOX);

    //  Get the width of the TP.BORDER_BOX
    elementWidth = TP.elementGetWidth(anElement, TP.BORDER_BOX);

    //  Get the height of the TP.BORDER_BOX
    elementHeight = TP.elementGetHeight(anElement, TP.BORDER_BOX);

    //  Compute the center of the element

    /* eslint-disable no-extra-parens */
    elementCenterX = pageXY.first() + (elementWidth / 2);
    elementCenterY = pageXY.last() + (elementHeight / 2);
    /* eslint-enable no-extra-parens */

    //  If the supplied X coordinate is less than the center, then its on
    //  the left side, otherwise the right side.
    if (xCoord < elementCenterX) {
        horizontalSide = TP.LEFT;
    } else {
        horizontalSide = TP.RIGHT;
    }

    //  If the supplied Y coordinate is less than the center, then its on
    //  the top side, otherwise the bottom side.
    if (yCoord < elementCenterY) {
        verticalSide = TP.TOP;
    } else {
        verticalSide = TP.BOTTOM;
    }

    return TP.ac(horizontalSide, verticalSide);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetWidth',
function(anElement, boxType, wantsTransformed) {

    /**
     * @method elementGetWidth
     * @summary Returns the element's width.
     * @param {HTMLElement} anElement The element to extract the width from.
     * @param {String} boxType A TIBET constant that determines the 'box' to
     *     compute the width from. This can one of the following values:
     *     TP.CONTENT_BOX TP.PADDING_BOX TP.BORDER_BOX TP.MARGIN_BOX If this
     *     parameter is not supplied, it defaults to TP.BORDER_BOX.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @returns {Number} The element's width in pixels.
     */

    var widthVal,

        returnedBoxType;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    widthVal = TP.elementGetBorderBox(anElement, wantsTransformed).at('width');

    returnedBoxType = TP.ifInvalid(boxType, TP.BORDER_BOX);

    //  So now, the returned value is the TP.BORDER_BOX. If the caller
    //  supplied other box types to return, add those values.

    switch (returnedBoxType) {
        case TP.CONTENT_BOX:

            /* eslint-disable no-extra-parens */

            //  TP.CONTENT_BOX means we subtract both the border and the
            //  padding from both ends.
            widthVal -=
                (TP.elementGetPaddingInPixels(anElement,
                                              TP.LEFT,
                                              wantsTransformed) +
                    TP.elementGetBorderInPixels(anElement,
                                                 TP.LEFT,
                                                 wantsTransformed));

            widthVal -=
                (TP.elementGetPaddingInPixels(anElement,
                                              TP.RIGHT,
                                              wantsTransformed) +
                    TP.elementGetBorderInPixels(anElement,
                                                 TP.RIGHT,
                                                 wantsTransformed));

            /* eslint-enable no-extra-parens */

            break;

        case TP.PADDING_BOX:

            //  TP.PADDING_BOX means we subtract the border from both
            //  ends.
            widthVal -= TP.elementGetBorderInPixels(anElement,
                                                    TP.LEFT,
                                                    wantsTransformed);
            widthVal -= TP.elementGetBorderInPixels(anElement,
                                                    TP.RIGHT,
                                                    wantsTransformed);

            break;

        case TP.BORDER_BOX:

            //  TP.BORDER_BOX means we do nothing

            break;

        case TP.MARGIN_BOX:

            //  TP.MARGIN_BOX means we add the margin from both ends.
            widthVal += TP.elementGetMarginInPixels(anElement,
                                                    TP.LEFT,
                                                    wantsTransformed);
            widthVal += TP.elementGetMarginInPixels(anElement,
                                                    TP.RIGHT,
                                                    wantsTransformed);
            break;

        default:
            break;
    }

    return widthVal;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetWrappingGlobalBox',
function(anElement, boxType) {

    /**
     * @method elementGetWrappingGlobalBox
     * @summary Returns the element's 'wrapping box' of coordinates expressed
     *     as 'global' coordinates. This is the value of the element's maximum
     *     'outset box' as computed by finding visible descendants and using
     *     their global boxes to compute the minimum box that would wrap all of
     *     the content of the supplied element.
     * @description If an element is an inline element and has its overflow set
     *     to be visible, positioned content can overflow its box. This means
     *     that the TP.elementGetGlobalBox method will not provide the maximum
     *     'wrapping' box of the element. This method will do so.
     * @param {HTMLElement} anElement The element to extract the maximum box
     *     from.
     * @param {String} boxType A TIBET constant that determines the 'box' to
     *     compute the box from. This can one of the following values:
     *     TP.CONTENT_BOX TP.PADDING_BOX TP.BORDER_BOX TP.MARGIN_BOX If this
     *     parameter is not supplied, it defaults to TP.BORDER_BOX.
     * @exception TP.sig.InvalidElement
     * @returns {TP.core.Hash} A hash containing the box at: 'left', 'top',
     *     'right', 'bottom', 'width', 'height'.
     */

    var thisBox,

        top,
        right,
        bottom,
        left,

        descendants,

        len,
        i,

        descendant,

        descendantBox;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  Grab the global box of the supplied element. Note here that we don't
    //  give a scoping ancestor, since we're not interested in coordinates
    //  relative to any of our ancestors. Also, we're not interested in
    //  transformed coordinates.
    thisBox = TP.elementGetGlobalBox(anElement, boxType, null, false);

    top = thisBox.at('top');
    right = thisBox.at('right');
    bottom = thisBox.at('bottom');
    left = thisBox.at('left');

    //  Grab all of descendant elements.
    descendants = TP.nodeGetDescendantElements(anElement);

    //  Iterate over them, grabbing their global box and comparing against the
    //  values we already have.
    len = descendants.getSize();
    for (i = 0; i < len; i++) {
        descendant = descendants.at(i);

        //  If the element isn't displayed, we move on - we don't want their
        //  readings to possibly corrupt our results (some browsers will return
        //  non-zero results for hidden elements - we don't want them).
        if (!TP.elementIsDisplayed(descendant)) {
            continue;
        }

        //  Grab the global box of the descendant. Note here that we don't give
        //  a scoping ancestor, since we're not interested in coordinates
        //  relative to any of their ancestor. Also, we're not interested in
        //  transformed coordinates.
        descendantBox = TP.elementGetGlobalBox(
                            descendant, boxType, null, false);

        //  Compare to the values we already have. Note that top and left use
        //  the *minimum* values whereas right and bottom use the *maximum*
        //  values.
        top = Math.min(top, descendantBox.at('top'));
        right = Math.max(right, descendantBox.at('right'));
        bottom = Math.max(bottom, descendantBox.at('bottom'));
        left = Math.min(left, descendantBox.at('left'));
    }

    return TP.hc(
        'top', top,
        'right', right,
        'bottom', bottom,
        'left', left,
        'width', right - left,
        'height', bottom - top);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementHasClass',
function(anElement, className) {

    /**
     * @method elementHasClass
     * @summary Returns true if the element has the CSS class name specified.
     * @param {Element} anElement The element to test.
     * @param {String} className The CSS class name to test for.
     * @exception TP.sig.InvalidElement
     * @returns {Boolean} Whether or not the element has the supplied CSS class.
     */

    var re;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  If the native 'classList' property is available, use that.
    if (TP.isValid(anElement.classList)) {
        return anElement.classList.contains(className);
    }

    //  NOTE: The RegExp here makes sure that the className is either first,
    //  last or is surrounded by one character of whitespace.
    re = TP.rc('(^|\\s)' + className + '(\\s|$)');

    return re.test(TP.elementGetClass(anElement));
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementHasFocus',
function(anElement) {

    /**
     * @method elementHasFocus
     * @summary Returns true if the element is the currently focused element in
     *     its document.
     * @param {Element} anElement The element to test.
     * @exception TP.sig.InvalidElement
     * @returns {Boolean} Whether or not the element has the focus in its
     *     document.
     */

    /* eslint-disable no-extra-parens */
    return (TP.documentGetFocusedElement(
                            TP.nodeGetDocument(anElement)) === anElement);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementHide',
function(anElement, preserveSpace) {

    /**
     * @method elementHide
     * @summary Hides the element. If the preserveSpace parameter is true, this
     *     method adjusts the CSS 'visibility' property of the supplied element.
     *     Otherwise, it adjusts both the 'display' and the visibility.
     * @param {HTMLElement} anElement The element to hide.
     * @param {Boolean} preserveSpace Whether or not to 'preserve the space'
     *     taken up by the element in its document. The default is false.
     * @exception TP.sig.InvalidElement
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    TP.elementGetStyleObj(anElement).visibility = 'hidden';
    if (TP.notTrue(preserveSpace)) {
        TP.elementGetStyleObj(anElement).display = 'none';
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementHideBusyMessage',
function(anElement) {

    /**
     * @method elementHideBusyMessage
     * @summary Hides the busy message for the supplied element.
     * @param {HTMLElement} anElement The element to hide the busy element for.
     * @returns {HTMLElement} The busy element itself.
     */

    var busyElement,
        win;

    //  We only do this if there is actually a busy element for the supplied
    //  element.
    if (TP.isElement(busyElement = anElement[TP.BUSY_ELEMENT])) {

        TP.elementSetAttribute(busyElement, 'pclass:hidden', true, true);

        //  Make sure and detach the resizing event handlers since they'll
        //  be reattached when the busy element is shown.
        win = TP.nodeGetWindow(anElement.ownerDocument);
        if (TP.isValid(win)) {
            win.removeEventListener(
                'resize',
                busyElement[TP.BUSY_RESIZE_FUNC],
                false);
        }

        //  Empty the busy background element of content in case content was put
        //  into it when the busy element was shown
        TP.nodeEmptyContent(anElement[TP.BUSY_BKGD_ELEMENT]);

        //  Clear any resize function for the busy layer.
        busyElement[TP.BUSY_RESIZE_FUNC] = null;
    }

    //  reset the overflow so scrollbars return to their old config. Note how we
    //  use the 'TP.isValid' test here, since the original value might have been
    //  the empty String.
    if (TP.isValid(anElement[TP.OLD_OVERFLOW])) {
        TP.elementGetStyleObj(anElement).overflow = anElement[TP.OLD_OVERFLOW];
        delete anElement[TP.OLD_OVERFLOW];
    }

    return busyElement;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementIsDisabled',
function(anElement) {

    /**
     * @method elementIsDisabled
     * @summary Returns whether or not anElement is disabled.
     * @description An element can be considered to be disabled if it has a
     *     '.disabled' property (as some HTML elements do) that is set to true
     *     or if it has an attribute of 'pclass:disabled' (the existence of
     *     which means 'true'). Note that this method will also check the parent
     *     node chain to see if any of anElement's parent nodes are disabled. If
     *     so, it is considered to be disabled.
     * @param {Element} anElement The element to determine the disabled state
     *     of.
     * @exception TP.sig.InvalidElement
     * @returns {Boolean} Whether or not anElement is disabled.
     */

    var isDisabled,
        ancestor;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    isDisabled = anElement.disabled;

    if (TP.isValid(isDisabled)) {
        return isDisabled;
    }

    isDisabled = TP.elementHasAttribute(anElement, 'disabled', true) ||
                    TP.elementHasAttribute(anElement, 'pclass:disabled', true);

    if (TP.notTrue(isDisabled)) {
        ancestor =
            TP.nodeDetectAncestor(
                anElement,
                function(aParent) {
                    return TP.elementHasAttribute(
                                aParent, 'disabled', true) ||
                            TP.elementHasAttribute(
                                aParent, 'pclass:disabled', true);
                });

        if (TP.isElement(ancestor)) {
            return true;
        }
    } else {
        return true;
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementIsDisplayed',
function(anElement) {

    /**
     * @method elementIsDisplayed
     * @summary Returns whether or not anElement is displayed to the user. This
     *     is dependent not only on its own 'display' and 'visibility' settings,
     *     but on those settings of its parents.
     * @description Note that this only tests whether the element is currently
     *     being displayed insofar as CSS is concerned. The element very well
     *     may be scrolled off screen or under the influence of a CSS transform
     *     that would cause it to not be visible to the user. Use the
     *     TP.elementIsVisible() method to test whether the element is truly
     *     visible.
     * @param {HTMLElement} anElement The element to determine the displayed
     *     state of.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidStyleDeclaration
     * @returns {Boolean} Whether or not anElement is displayed.
     */

    var computedStyle,

        elemComputedDisplay,
        elemComputedVisibility,

        elementWin;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.notValid(computedStyle =
                    TP.elementGetComputedStyleObj(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    elemComputedDisplay = computedStyle.display;

    //  If the display is computed to be 'none', then we're definitely not
    //  displayed.
    if (elemComputedDisplay === 'none') {
        return false;
    }

    elemComputedVisibility = computedStyle.visibility;

    //  If the display is computed to be 'hidden', then we're definitely not
    //  visible.
    if (elemComputedVisibility === 'hidden') {
        return false;
    }

    //  Otherwise, if we don't have a parentNode, then we can't be displayed
    if (TP.notValid(anElement.parentNode)) {
        return false;
    }

    //  If our parentNode is the document, then see if it's Window is an iframe.
    //  If so, then we have to 'jump' out and continue. Otherwise, we return
    //  true.
    if (TP.isDocument(anElement.parentNode)) {
        elementWin = TP.nodeGetWindow(anElement.parentNode);
        if (TP.isIFrameWindow(elementWin)) {
            return TP.elementIsDisplayed(elementWin.frameElement);
        }

        return true;
    }

    //  We had a parent node, so we defer to it and walk the tree.
    return TP.elementIsDisplayed(anElement.parentNode);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementIsVisible',
function(anElement, partial, direction, wantsTransformed) {

    /**
     * @method elementIsVisible
     * @summary Returns whether or not anElement is *really* visible to the
           user, no matter what its CSS setting is.
     * @description In addition to the standard CSS properties of 'display' and
           'visibility', this call also takes into account scrolling and any
           CSS transformation that has been applied to the element.
     * @param {HTMLElement} anElement The element to determine the visibility
     *     of.
     * @param {Boolean} [partial=false] Whether or not the element can be
     *     partially visible or has to be completely visible. The default is
     *     false (i.e. it should be completely visible).
     * @param {String} [direction] The direction to test visibility in. If
     *     specified, this should be either TP.HORIZONTAL or TP.VERTICAL. If
     *     this is not specified, then both directions will be tested.
     * @param {Boolean} [wantsTransformed=false] An optional parameter that
     *     determines whether to use 'transformed' values if the element has
     *     beentransformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @returns {Boolean} Whether or not anElement is visible.
     */

    var computedStyle,

        isDisplayed,

        offsetParent,

        doc,

        viewportBox,
        elementBox,

        topLeftCornerVisible,
        bottomLeftCornerVisible,
        topRightCornerVisible,
        bottomRightCornerVisible,

        elemTop,
        elemRight,
        elemBottom,
        elemLeft,

        offsetTop,
        offsetRight,
        offsetBottom,
        offsetLeft,

        topVisible,
        leftVisible,
        bottomVisible,
        rightVisible,

        verticallyVisible,
        horizontallyVisible;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  If the element isn't position fixed and the offsetParent is null, and
    //  we're not checking for partial visibility (only whole visibility) then
    //  this element isn't visible.

    if (TP.notValid(computedStyle =
                    TP.elementGetComputedStyleObj(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    //  Note the native check here for offsetParent rather than using our
    //  primitive method. This is because we're testing for the special behavior
    //  of when 'offsetParent' is null.
    if (computedStyle.position !== 'fixed' &&
        TP.notTrue(partial) &&
        TP.notValid(anElement.offsetParent)) {
        return false;
    }

    //  First, is the element even displayed? If not (i.e. 'display: none'),
    //  then just return false here.
    isDisplayed = TP.elementIsDisplayed(anElement);
    if (!isDisplayed) {
        return false;
    }

    doc = TP.nodeGetDocument(anElement);

    //  Get our own border box
    elementBox = TP.elementGetBorderBox(
                    anElement,
                    wantsTransformed);

    ({top: elemTop, right: elemRight,
        bottom: elemBottom, left: elemLeft} = TP.obj(elementBox));

    topLeftCornerVisible = anElement.contains(
                        doc.elementFromPoint(elemLeft + 1, elemTop + 1));
    bottomLeftCornerVisible = anElement.contains(
                        doc.elementFromPoint(elemLeft + 1, elemBottom - 1));
    topRightCornerVisible = anElement.contains(
                        doc.elementFromPoint(elemRight - 1, elemTop + 1));
    bottomRightCornerVisible = anElement.contains(
                        doc.elementFromPoint(elemRight - 1, elemBottom - 1));

    //  Get the viewport width and height, as defined by our offsetParent
    offsetParent = TP.elementGetOffsetParent(anElement);
    if (TP.isElement(offsetParent)) {
        viewportBox = TP.elementGetBorderBox(offsetParent, wantsTransformed);
    } else {
        viewportBox = TP.hc('top', 0,
                            'right', 0,
                            'bottom', 0,
                            'left', 0);
    }

    ({top: offsetTop, right: offsetRight,
        bottom: offsetBottom, left: offsetLeft} = TP.obj(viewportBox));

    //  Based on the comparison of our top, bottom, left and right to our
    //  viewport's width and height, we can determine whether a side is visible
    //  or not.
    topVisible = elemTop >= offsetTop &&
                    TP.isTrue(partial) ?
                    topLeftCornerVisible || topRightCornerVisible :
                    topLeftCornerVisible && topRightCornerVisible;
    bottomVisible = elemBottom <= offsetBottom &&
                    TP.isTrue(partial) ?
                    bottomLeftCornerVisible || bottomRightCornerVisible :
                    bottomLeftCornerVisible && bottomRightCornerVisible;
    leftVisible = elemLeft >= offsetLeft &&
                    TP.isTrue(partial) ?
                    topLeftCornerVisible || bottomLeftCornerVisible :
                    topLeftCornerVisible && bottomLeftCornerVisible;
    rightVisible = elemRight <= offsetRight &&
                    TP.isTrue(partial) ?
                    topRightCornerVisible || bottomRightCornerVisible :
                    topRightCornerVisible && bottomRightCornerVisible;

    //  If we allow the call to return a 'partially visible' element, we use OR
    //  on the comparisons here - otherwise, we use AND.
    verticallyVisible = TP.isTrue(partial) ?
                        topVisible || bottomVisible :
                        topVisible && bottomVisible;
    horizontallyVisible = TP.isTrue(partial) ?
                        leftVisible || rightVisible :
                        leftVisible && rightVisible;

    //  If a direction was specified, we only return that direction's result -
    //  otherwise, we return the result of both directions ANDed together.
    switch (direction) {
        case TP.VERTICAL:
            return verticallyVisible;
        case TP.HORIZONTAL:
            return horizontallyVisible;
        default:
            return verticallyVisible && horizontallyVisible;
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementMakeAbsolute',
function(anElement) {

    /**
     * @method elementMakeAbsolute
     * @summary Makes the supplied element 'absolutely positioned' at its
     *     current location in its document.
     * @param {HTMLElement} anElement The element to make absolute.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidStyleDeclaration
     */

    var computedStyle,
        pageXY;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  If the element is already absolute, just bail out here.
    if (TP.notValid(computedStyle =
                    TP.elementGetComputedStyleObj(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    if (computedStyle.position === 'absolute') {
        return;
    }

    pageXY = TP.elementGetPageXY(anElement);

    TP.elementGetStyleObj(anElement).position = 'absolute';

    TP.elementGetStyleObj(anElement).left = pageXY.at(0) + 'px';
    TP.elementGetStyleObj(anElement).top = pageXY.at(1) + 'px';

    TP.elementGetStyleObj(anElement).width = anElement.clientWidth + 'px';
    TP.elementGetStyleObj(anElement).height = anElement.clientHeight + 'px';

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementMakePositioned',
function(anElement) {

    /**
     * @method elementMakePositioned
     * @summary Makes the supplied element 'positioned' (relatively) at its
     *     current location in its document. If the element was already
     *     positioned, this method just returns.
     * @param {HTMLElement} anElement The element to make positioned.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidStyleDeclaration
     */

    var computedStyle;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.notValid(computedStyle =
                    TP.elementGetComputedStyleObj(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    if (!/absolute|relative/i.test(computedStyle.position)) {
        TP.elementMakeRelative(anElement);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementMakeRelative',
function(anElement) {

    /**
     * @method elementMakeRelative
     * @summary Makes the supplied element 'relatively positioned' at its
     *     current location in its document.
     * @param {HTMLElement} anElement The element to make relative.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidStyleDeclaration
     */

    var computedStyle,

        styleObj,
        leftInPixels,
        topInPixels;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.notValid(computedStyle =
                    TP.elementGetComputedStyleObj(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    //  If the element is already relative, just bail out here.
    if (computedStyle.position === 'relative') {
        return;
    }

    //  Otherwise, check the style property's left and top for any
    //  'element-level' values. Note that we're not going after the computed
    //  style here - we're only interested if the instance-level style
    //  object has left or top values on it.

    styleObj = TP.elementGetStyleObj(anElement);

    if (TP.notEmpty(styleObj.left)) {
        //  Make sure to get the 'left' in pixels in case it was specified
        //  in some other CSS unit.
        leftInPixels = TP.elementGetPixelValue(anElement,
                                                styleObj.left,
                                                'left');
    } else {
        leftInPixels = 0;
    }

    if (TP.notEmpty(styleObj.top)) {
        //  Make sure to get the 'top' in pixels in case it was specified
        //  in some other CSS unit.
        topInPixels = TP.elementGetPixelValue(anElement,
                                                styleObj.top,
                                                'top');
    } else {
        topInPixels = 0;
    }

    styleObj.position = 'relative';

    styleObj.left = leftInPixels + 'px';
    styleObj.top = topInPixels + 'px';

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementMoveBy',
function(anElement, deltaX, deltaY) {

    /**
     * @method elementMoveBy
     * @summary Moves the element by the deltaX and deltaY amounts provided.
     * @description deltaX and deltaY are assumed to be Numbers of pixels to
     *     move the element by. Also note that if the supplied element is not
     *     positioned either absolute or relative, this method does nothing.
     * @param {HTMLElement} anElement The element to move.
     * @param {Number} deltaX The X amount to move the element by.
     * @param {Number} deltaY The Y amount to move the element by.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidStyleDeclaration
     */

    var computedStyle,

        pageXY,

        styleObj;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.notValid(computedStyle =
                    TP.elementGetComputedStyleObj(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    if (!/absolute|relative/i.test(computedStyle.position)) {
        return;
    }

    pageXY = TP.elementGetPageXY(anElement);

    styleObj = TP.elementGetStyleObj(anElement);

    /* eslint-disable no-extra-parens */
    styleObj.left = (pageXY.first() + deltaX) + 'px';
    styleObj.top = (pageXY.last() + deltaY) + 'px';
    /* eslint-enable no-extra-parens */

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementMoveTo',
function(anElement, x, y) {

    /**
     * @method elementMoveTo
     * @summary Moves the element to the X and Y coordinates provided.
     * @description If a Number is supplied to x or y a default unit of 'px' is
     *     assumed.
     * @param {HTMLElement} anElement The element to move.
     * @param {Number|String} x The X coordinate to move the element to.
     * @param {Number|String} y The Y coordinate to move the element to.
     * @exception TP.sig.InvalidElement
     */

    var styleObj;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    styleObj = TP.elementGetStyleObj(anElement);

    if (TP.isNumber(x)) {
        styleObj.left = x + 'px';
    } else {
        styleObj.left = x;
    }

    if (TP.isNumber(y)) {
        styleObj.top = y + 'px';
    } else {
        styleObj.top = y;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementOrderOver',
function(anElement, anotherElement) {

    /**
     * @method elementOrderOver
     * @summary Places the element over the other element.
     * @param {HTMLElement} anElement The element to move 'up' in the Z order.
     * @param {HTMLElement} anotherElement The element to move anElement over.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidStyleDeclaration
     */

    var computedStyle,

        otherZ;

    if (!TP.isElement(anElement) || !TP.isElement(anotherElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.notValid(computedStyle =
                    TP.elementGetComputedStyleObj(anotherElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    otherZ = parseInt(computedStyle.zIndex, 10);

    TP.elementGetStyleObj(anElement).zIndex = otherZ + 1;

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementOrderUnder',
function(anElement, anotherElement) {

    /**
     * @method elementOrderUnder
     * @summary Places the element under the other element.
     * @param {HTMLElement} anElement The element to move 'down' in the Z order.
     * @param {HTMLElement} anotherElement The element to move anElement under.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidStyleDeclaration
     */

    var computedStyle,
        otherZ;

    if (!TP.isElement(anElement) || !TP.isElement(anotherElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.notValid(computedStyle =
                    TP.elementGetComputedStyleObj(anotherElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    otherZ = parseInt(computedStyle.zIndex, 10);

    TP.elementGetStyleObj(anElement).zIndex = otherZ - 1;

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementPlaceNearElement',
function(anElement, anotherElement, offsetX, offsetY, measuringBoxType, preferredCorners) {

    /**
     * @method elementPlaceNearElement
     * @summary Places the element near the other element, making sure to keep
     *     it on screen. Note that for this method to take effect on the
     *     element, the element should be 'positioned' in some fashion - this
     *     method does *not* position the element.
     * @param {HTMLElement} anElement The element to place near the other
     *     supplied element.
     * @param {HTMLElement} anotherElement The element to place the first
     *     supplied element near.
     * @param {Number} offsetX The X offset in pixels to use as a 'padding'.
     *     This defaults to 0.
     * @param {Number} offsetY The Y offset in pixels to use as a 'padding'.
     *     This defaults to 0.
     * @param {String} measuringBoxType A TIBET constant that determines the
     *     'box' (of anotherElement) to compute the coordinate from. This can
     *     one of the following values: TP.CONTENT_BOX TP.PADDING_BOX
     *     TP.BORDER_BOX TP.MARGIN_BOX If this parameter is not supplied, it
     *     defaults to TP.BORDER_BOX.
     * @param {String[]} preferredCorners An Array of 'corners' to use to test.
     *     This should be one of: TP.TOP_LEFT TP.BOTTOM_LEFT TP.TOP_RIGHT
     *     TP.BOTTOM_RIGHT.
     * @exception TP.sig.InvalidElement
     */

    var theMeasuringBoxType,
        thePreferredCorners,

        anotherElemStyleObj,
        oldDisplayValue,

        elementBoxX,
        elementBoxY,
        elementBoxWidth,
        elementBoxHeight,

        bestDistance,

        onScreenComputeData,

        preferredX,
        preferredY,

        computedDistance,

        i,
        len,
        corner,

        styleObj;

    if (!TP.isElement(anElement) || !TP.isElement(anotherElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    theMeasuringBoxType = TP.ifInvalid(measuringBoxType, TP.BORDER_BOX);

    //  The corners used for computation defaults to:
    //      TP.TOP_LEFT, TP.BOTTOM_LEFT, TP.BOTTOM_LEFT, TP.TOP_LEFT
    thePreferredCorners = preferredCorners;
    if (TP.notValid(thePreferredCorners)) {
        thePreferredCorners =
            TP.ac(TP.TOP_LEFT, TP.BOTTOM_LEFT, TP.BOTTOM_LEFT, TP.TOP_LEFT);
    }

    //  Grab the border box width and height of the element, but first make
    //  sure to turn off any non-default 'display' setting that would cause
    //  the element to have different dimensions than it normally would
    //  have.

    //  Note here how we go after any manually set 'display' style - we're
    //  not interested in the computed style here.
    anotherElemStyleObj = TP.elementGetStyleObj(anotherElement);
    oldDisplayValue = anotherElemStyleObj.display;
    anotherElemStyleObj.display = '';

    //  Capture the element's X, Y, width and height according to the
    //  measuring box that was either supplied or defaulted.
    elementBoxX = TP.elementGetPageX(anotherElement,
                                            theMeasuringBoxType);
    elementBoxY = TP.elementGetPageY(anotherElement,
                                            theMeasuringBoxType);

    elementBoxWidth = TP.elementGetWidth(anotherElement,
                                            theMeasuringBoxType);
    elementBoxHeight = TP.elementGetHeight(anotherElement,
                                            theMeasuringBoxType);

    //  Set the old display value back.
    TP.elementGetStyleObj(anElement).display = oldDisplayValue;

    //  Initialize the tracking values.
    bestDistance = Infinity;

    onScreenComputeData = null;

    //  Loop over the preferred corners.
    len = thePreferredCorners.length;
    for (i = 0; i < len; i++) {
        corner = thePreferredCorners[i];

        //  Compute the preferred X to try, based on the current
        //  corner that we're testing.
        if (corner === TP.TOP_LEFT || corner === TP.BOTTOM_LEFT) {
            preferredX = elementBoxX;
        } else {
            preferredX = elementBoxX + elementBoxWidth;
        }

        //  Compute the preferred Y to try, based on the current
        //  corner that we're testing.
        if (corner === TP.TOP_LEFT || corner === TP.TOP_RIGHT) {
            preferredY = elementBoxY;
        } else {
            preferredY = elementBoxY + elementBoxHeight;
        }

        //  Compute an on-screen X and Y for the supplied Element,
        //  given the preferred X and Y, the X and Y offset and the
        //  current corner.
        onScreenComputeData = TP.elementComputeOnScreenXY(
                                anElement,
                                preferredX, preferredY,
                                offsetX, offsetY,
                                TP.ac(corner));

        //  There was a computed distance which we use to see 'how
        //  good' of a match we got.
        computedDistance = onScreenComputeData.at(3);

        if (computedDistance === 0) {
            //  Got a perfect match.
            break;
        }

        //  Lesser numbers are better. If the current best distance
        //  is greater than the just computed one, then set the best
        //  distance to be that.
        if (bestDistance > computedDistance) {
            bestDistance = computedDistance;
        }
    }

    if (TP.isArray(onScreenComputeData)) {
        styleObj = TP.elementGetStyleObj(anElement);

        styleObj.left = onScreenComputeData.first() + 'px';
        styleObj.top = onScreenComputeData.last() + 'px';
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementRemoveClass',
function(anElement, className) {

    /**
     * @method elementRemoveClass
     * @summary Removes a CSS class name from anElement's 'className' CSS class
     *     list.
     * @param {Element} anElement DOM Node of type Node.ELEMENT_NODE.
     * @param {String|RegExp} className The CSS class name to remove, in either
     *     String or RegExp form.
     * @exception TP.sig.InvalidElement
     * @returns {Element|undefined} The element the supplied class was removed
     *     from.
     */

    var classes,
        i;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(className)) {
        return;
    }

    //  Use the HTML5 'classList' convenience property.
    classes = anElement.classList;

    //  If a RegExp was *not* supplied, then simply remove the class with the
    //  name.
    if (!TP.isRegExp(className)) {
        classes.remove(className);
    } else {
        //  Otherwise, iterate over all of the class names and, if they match
        //  the supplied RegExp, remove them.
        for (i = 0; i < classes.length; i++) {
            if (className.test(classes.item(i))) {
                classes.remove(classes.item(i));
            }
        }
    }

    //  By default, if there are no more class names left, we remove the
    //  attribute.
    if (anElement.classList.length === 0) {
        anElement.removeAttribute('class');
    }

    return anElement;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementRemoveTransform',
function(anElement) {

    /**
     * @method elementRemoveTransform
     * @summary Removes any CSS transform placed on the element.
     * @param {Element} anElement The element to set the transformation on.
     * @exception TP.sig.InvalidElement
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    TP.elementGetStyleObj(anElement).transform = '';

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementReplaceClass',
function(anElement, oldClassName, newClassName) {

    /**
     * @method elementReplaceClass
     * @summary Replaces the old CSS class name in anElement's 'className' CSS
     *     class list with the new CSS class name.
     * @param {Element} anElement DOM Node of type Node.ELEMENT_NODE.
     * @param {String} oldClassName The CSS class name to replace.
     * @param {String} newClassName The CSS class name to replace it with.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidString
     * @returns {Element} The element.
     */

    var wholeClassValue,
        oldClassRegExp;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(oldClassName) || TP.isEmpty(newClassName)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    wholeClassValue = TP.elementGetClass(anElement);

    //  If there was no prior value, then just set the class to the new
    //  value and return.
    if (TP.isEmpty(wholeClassValue = TP.elementGetClass(anElement))) {
        TP.elementSetClass(anElement, newClassName);

        return anElement;
    }

    //  NOTE: The RegExp here makes sure that the className is either first,
    //  last or is surrounded by one character of whitespace.
    oldClassRegExp = TP.rc('(^|\\s)' + oldClassName + '(\\s|$)');

    wholeClassValue = wholeClassValue.replace(oldClassRegExp,
                                                '$1' + newClassName + '$2');

    TP.elementSetClass(anElement, wholeClassValue);

    return anElement;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeReplaceTextWithEditor',
function(aNode) {

    /**
     * @method nodeReplaceTextWithEditor
     * @summary Replaces the child text content of the supplied element with an
     *     'editor' (that is, an XHTML 'input' field).
     * @param {Node} aNode The node to replace with the editor.
     * @exception TP.sig.InvalidNode
     * @returns {Element} The newly-inserted input field element.
     */

    var nodeDoc,
        currentValue,
        textInputElement;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    nodeDoc = TP.nodeGetDocument(aNode);

    //  Now, try to get the text value of the element. This will normalize any
    //  Node.TEXT_NODE nodes under aNode and hand us back the first one.
    currentValue = TP.nodeGetTextContent(aNode);

    //  Create the 'input' field.
    textInputElement = TP.documentConstructElement(nodeDoc,
                                                    'input',
                                                    TP.w3.Xmlns.XHTML);

    //  Replace the node with the text input. Note here how we pass false to
    //  avoid awakening this content.
    textInputElement = TP.nodeReplaceChild(
                            aNode.parentNode,
                            textInputElement,
                            aNode,
                            false);

    //  Set the value of the input field to the text value obtained earlier and
    //  'select' the input field so that the text is selected.
    textInputElement.value = currentValue;
    textInputElement.select();

    return textInputElement;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementScrollBy',
function(anElement, deltaX, deltaY) {

    /**
     * @method elementScrollBy
     * @summary Scrolls the element by the deltaX and deltaY amounts provided.
     * @param {HTMLElement} anElement The element to scroll.
     * @param {Number} deltaX The X coordinate to scroll the element by.
     * @param {Number} deltaY The Y coordinate to scroll the element by.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidNumber
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (!TP.isNumber(deltaX) || !TP.isNumber(deltaY)) {
        return TP.raise(this, 'TP.sig.InvalidNumber');
    }

    anElement.scrollLeft += deltaX;
    anElement.scrollTop += deltaY;

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementScrollTo',
function(anElement, x, y) {

    /**
     * @method elementScrollTo
     * @summary Scrolls the element to the X and Y coordinates provided.
     * @param {HTMLElement} anElement The element to scroll.
     * @param {Number} x The X coordinate to scroll the element to.
     * @param {Number} y The Y coordinate to scroll the element to.
     * @exception TP.sig.InvalidElement
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (!TP.isNumber(x) || !TP.isNumber(y)) {
        return TP.raise(this, 'TP.sig.InvalidNumber');
    }

    anElement.scrollLeft = x;
    anElement.scrollTop = y;

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementSetBusyMessage',
function(anElement, aMessage) {

    /**
     * @method elementSetBusyMessage
     * @summary Sets the busy element message to the supplied message.
     * @param {HTMLElement} anElement The element to set the busy element
     *     message for.
     * @param {String} aMessage The message to use for the busy message.
     */

    var busyMessageElement;

    if (TP.notValid(busyMessageElement = anElement[TP.BUSY_MSG_ELEMENT])) {
        return;
    }

    busyMessageElement.firstChild.nodeValue = aMessage;

    //  TODO: Add logic to refresh screen (once that is figured out)

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementSetClipRect',
function(anElement, top, right, bottom, left) {

    /**
     * @method elementSetClipRect
     * @summary Sets the element's clipping rectangle.
     * @description If a Number is supplied to top, right, bottom or left, a
     *     default unit of 'px' is assumed.
     * @param {HTMLElement} anElement The element to set the clip rect on.
     * @param {Number|String} top The value to set the top coordinate of the
     *     element's clipping rectangle to.
     * @param {Number|String} right The value to set the right coordinate of the
     *     element's clipping rectangle to.
     * @param {Number|String} bottom The value to set the bottom coordinate of
     *     the element's clipping rectangle to.
     * @param {Number|String} left The value to set the left coordinate of the
     *     element's clipping rectangle to.
     * @exception TP.sig.InvalidElement
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    /* eslint-disable no-extra-parens */

    TP.elementGetStyleObj(anElement).clip =
        'rect(' + ((!TP.isNaN(top)) ? top + 'px ' : top) +
                    ((!TP.isNaN(right)) ? right + 'px ' : right) +
                    ((!TP.isNaN(bottom)) ? bottom + 'px ' : bottom) +
                    ((!TP.isNaN(left)) ? left + 'px' : left) +
                    ')';

    /* eslint-enable no-extra-parens */

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementSetHeight',
function(anElement, aHeight) {

    /**
     * @method elementSetHeight
     * @summary Sets the element's height.
     * @description If a Number is supplied to aHeight a default unit of 'px' is
     *     assumed.
     * @param {HTMLElement} anElement The element to set the height on.
     * @param {Number|String} aHeight The height dimension to set anElement's
     *     height to.
     * @exception TP.sig.InvalidElement
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isNumber(aHeight)) {
        TP.elementGetStyleObj(anElement).height = aHeight + 'px';
    } else {
        TP.elementGetStyleObj(anElement).height = aHeight;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementSetWidth',
function(anElement, aWidth) {

    /**
     * @method elementSetWidth
     * @summary Sets the element's width.
     * @description If a Number is supplied to aWidth a default unit of 'px' is
     *     assumed.
     * @param {HTMLElement} anElement The element to set the width on.
     * @param {Number|String} aWidth The width dimension to set anElement's
     *     width to.
     * @exception TP.sig.InvalidElement
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isNumber(aWidth)) {
        TP.elementGetStyleObj(anElement).width = aWidth + 'px';
    } else {
        TP.elementGetStyleObj(anElement).width = aWidth;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementSetTransform',
function(anElement, aTransformStr) {

    /**
     * @method elementSetTransform
     * @summary Sets the CSS transform of the element specified using the
     *     supplied String (which should conform to one of the values specified
     *     in the CSS Transform specification).
     * @param {Element} anElement The element to set the transformation on.
     * @param {String} aTransformStr The value to set on the supplied Element as
     *     its CSS Transform.
     * @exception TP.sig.InvalidElement
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    TP.elementGetStyleObj(anElement).transform = aTransformStr;

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementSetTransformOrigin',
function(anElement, xValue, yValue, zValue) {

    /**
     * @method elementSetTransformOrigin
     * @summary Sets the transformation origin of the element specified using
     *     the supplied X and Y and (possibly) Z values.
     * @description The X and Y values supplied to this method can be any CSS
     *     'length' value (i.e. a number with a unit or a percentage) or one of
     *     the approved CSS keywords. If a Number is supplied, 'px' is assumed.
     *     The Z value must be a length, not keyword or percentage.
     * @param {Element} anElement The element to set the transformation origin
     *     on.
     * @param {Number|String} xValue The 'X value' to set the transformation
     *     origin to.
     * @param {Number|String} yValue The 'Y value' to set the transformation
     *     origin to.
     * @param {Number|String} [zValue] The 'Z value' to set the transformation
     *     origin to. Note that this *cannot* be a keyword or percentage.
     * @exception TP.sig.InvalidElement
     */

    var xVal,
        yVal,
        zVal;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    xVal = TP.isNumber(xValue) ? xValue + 'px' : xValue;
    yVal = TP.isNumber(yValue) ? yValue + 'px' : yValue;
    zVal = TP.isNumber(zValue) ? zValue + 'px' : zValue;

    if (TP.isEmpty(zVal)) {
        TP.elementGetStyleObj(anElement).transformOrigin =
                                        TP.join(xVal, ' ', yVal);
    } else {
        TP.elementGetStyleObj(anElement).transformOrigin =
                                        TP.join(xVal, ' ', yVal, ' ', zVal);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementShow',
function(anElement) {

    /**
     * @method elementShow
     * @summary Shows the element.
     * @param {HTMLElement} anElement The element to display.
     * @exception TP.sig.InvalidElement
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    TP.elementDefaultDisplay(anElement);

    //  We always make sure that the element's visibility is set to
    //  'visible'.
    TP.elementGetStyleObj(anElement).visibility = 'visible';

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$elementShowBusyLayer',
function(anElement, aMessage, topCoord, leftCoord, width, height) {

    /**
     * @method $elementShowBusyLayer
     * @summary Shows the busy element for the supplied element. If there is no
     *     busy element for the supplied element, one is created and then shown.
     * @param {HTMLElement} anElement The element to show the busy element
     *     message for.
     * @param {String} [aMessage=''] The message to use for the busy message.
     * @param {Number} topCoord The top coordinate (relative to the 'body'
     *     element where the busy element will be appended) of the busy element.
     *     If this is not supplied, it will default to the top of the supplied
     *     element.
     * @param {Number} leftCoord The left coordinate (relative to the 'body'
     *     element where the busy element will be appended) of the busy element.
     *     If this is not supplied, it will default to the left of the supplied
     *     element.
     * @param {Number} width The width of the busy element. If this is not
     *     supplied, it will default to the width of the supplied element.
     * @param {Number} height The height of the busy element. If this is not
     *     supplied, it will default to the height of the supplied element.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidString
     * @returns {HTMLElement} The busy element itself.
     */

    var msg,

        busyElement,
        busyMessageElement,
        win,
        busyElemStyleObj,

        busyTop,
        busyLeft,
        busyWidth,
        busyHeight;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    msg = aMessage;
    if (TP.isEmpty(msg)) {

        //  Note that if the message is empty, that we use a *single space*
        //  text value. This is so that text node below actually gets created.
        //  Otherwise, no text node will be created under the busyMessage's
        //  first child below and so this call will fail the second time.
        msg = ' ';
    }

    busyElement = anElement[TP.BUSY_ELEMENT];
    busyMessageElement = anElement[TP.BUSY_MSG_ELEMENT];

    busyElemStyleObj = TP.elementGetStyleObj(busyElement);

    //  Reset the busyElement's position by using either the supplied top
    //  and left or the 'global' X and Y position of the supplied element.
    busyTop = TP.isNumber(topCoord) ?
                    topCoord :
                    TP.elementGetPageY(anElement);
    busyElemStyleObj.top = busyTop + 'px';

    busyLeft = TP.isNumber(leftCoord) ?
                    leftCoord :
                    TP.elementGetPageX(anElement);
    busyElemStyleObj.left = busyLeft + 'px';

    //  Reset the busyElement's size by using either the width and height
    //  supplied or by using the offsetWidth and offsetHeight of the
    //  supplied element.
    busyWidth = TP.isNumber(width) ?
                    width :
                    TP.elementGetWidth(anElement);
    busyElemStyleObj.width = busyWidth + 'px';

    busyHeight = TP.isNumber(height) ?
                    height :
                    TP.elementGetHeight(anElement);
    busyElemStyleObj.height = busyHeight + 'px';

    //  Set the busy message to the supplied message.
    busyMessageElement.firstChild.nodeValue = msg;

    //  Set up a resize function, so that if the busy is showing when the
    //  user resizes the window, it will resize also. This function is
    //  detached when the busy element is hidden to avoid memory leaks.
    busyElement[TP.BUSY_RESIZE_FUNC] = function() {

        busyWidth = TP.isNumber(width) ?
                        width :
                        anElement.offsetWidth;
        busyElemStyleObj.width = busyWidth + 'px';

        busyHeight = TP.isNumber(height) ?
                        height :
                        anElement.offsetHeight;
        busyElemStyleObj.height = busyHeight + 'px';
    };

    win = TP.nodeGetWindow(anElement.ownerDocument);
    if (TP.isValid(win)) {
        win.addEventListener(
            'resize',
            busyElement[TP.BUSY_RESIZE_FUNC],
            false);
    }

    //  Finally, go ahead and show the busy element :-).
    TP.elementRemoveAttribute(busyElement, 'pclass:hidden', true);

    return busyElement;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementShowBusyMessage',
function(anElement, aMessage, backgroundContentElement) {

    /**
     * @method elementShowBusyMessage
     * @summary Shows a busy message along with associated graphic (when styled
     *     using the defaults) for the element provided.
     * @param {HTMLElement} anElement The element to show the busy element
     *     message for.
     * @param {String} [aMessage=''] The message to use for the busy message.
     * @param {HTMLElement} [backgroundContentElement] An optional 'background
     *     content' element that will be added to the background element of the
     *     supplied element's busy element.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidString
     */

    var styleObj;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  Call this to create the busy layer element if it's not already created
    //  for anElement, even though we don't capture the return value here.
    TP.$elementGetBusyLayer(anElement);

    if (TP.isElement(backgroundContentElement)) {
        TP.nodeAppendChild(
            anElement[TP.BUSY_BKGD_ELEMENT],
            backgroundContentElement,
            false);
    }

    styleObj = TP.elementGetStyleObj(anElement);

    //  capture and turn off overflow that would show scrollbars
    anElement[TP.OLD_OVERFLOW] = styleObj.overflow;
    styleObj.overflow = 'hidden';

    //  Go ahead and show the busy element.
    TP.$elementShowBusyLayer(anElement, aMessage);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementSumAncestorValues',
function(anElement, propName, useOffsetAncestors) {

    /**
     * @method elementSumAncestorValues
     * @summary Adds up the values of the given property starting at the
     *     supplied element's ancestor and proceeding up the document tree until
     *     just under the #document node.
     * @param {Element} anElement The element to begin adding the property value
     *     of.
     * @param {String} propName The name of the property to add up the tree as
     *     we traverse the ancestors.
     * @param {Boolean} useOffsetAncestors Whether or not to use the supplied
     *     element's 'offset' ancestors (i.e. 'offsetParent' up the chain).
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidString
     * @returns {Number} The value of the property as computed up the ancestorp
     *     chain.
     */

    var totalPropertyValue,
        ancestor,
        ancestorVal,
        useOffsets;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(propName)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    useOffsets = TP.ifInvalid(useOffsetAncestors, false);
    totalPropertyValue = 0;

    if (useOffsets) {
        ancestor = TP.elementGetOffsetParent(anElement);
    } else {
        ancestor = anElement.parentNode;
    }

    while (TP.isElement(ancestor) &&
            ancestor.nodeType !== Node.DOCUMENT_NODE) {
        if (TP.isNumber(ancestorVal = ancestor[propName])) {
            totalPropertyValue += ancestorVal;
        }

        if (useOffsets) {
            ancestor = TP.elementGetOffsetParent(ancestor);
        } else {
            ancestor = ancestor.parentNode;
        }
    }

    return totalPropertyValue;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementSumAttributeValue',
function(anElement, attrName, attrValue, atEnd, allowDuplicates) {

    /**
     * @method elementSumAttributeValue
     * @summary Adds the attribute value to the attribute named by attrName of
     *     the supplied element.
     * @param {Element} anElement The element to add the attribute value to.
     * @param {String} attrName The name of the attribute to add the value to.
     * @param {String} attrValue The value to add to the attribute's value.
     * @param {Boolean} atEnd Should the add go in at the end?
     * @param {Boolean} allowDuplicates Should we allow duplicate values?
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidString
     * @exception TP.sig.InvalidParameter
     * @returns {Element} The element.
     */

    var shouldAllowDups,
        shouldBeAtEnd,

        existingWholeValue,

        valMatcher;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(attrName)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    //  Note here how we just check to make sure the attribute value is
    //  'valid', because it might not necessarily be a String (might be a
    //  Boolean, Number, etc.)
    if (TP.notValid(attrValue)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    shouldAllowDups = TP.ifInvalid(allowDuplicates, false);
    shouldBeAtEnd = TP.ifInvalid(atEnd, true);

    //  If the element already has a value in that attribute, then we have
    //  to do a bit of shuffle.
    if (TP.notEmpty(existingWholeValue = TP.elementGetAttribute(anElement,
                                                                attrName,
                                                                true))) {
        //  If we're not allowing duplicates, make sure that the existing
        //  attribute value doesn't already have that value in it.
        if (!shouldAllowDups) {
            valMatcher = TP.rc('(^|\\s)' + attrValue + '(\\s|$)');

            if (valMatcher.test(existingWholeValue)) {
                return anElement;
            }
        }

        //  If it should be at the end, append it to the existing value.
        if (shouldBeAtEnd) {
            TP.elementSetAttribute(
                    anElement,
                    attrName,
                    existingWholeValue + ' ' + attrValue,
                    true);
        } else {
            //  Otherwise, prepend it to the existing value.
            TP.elementSetAttribute(
                    anElement,
                    attrName,
                    attrValue + ' ' + existingWholeValue,
                    true);
        }
    } else {
        //  There is no value in the supplied attribute on the element, so
        //  just set it to be the supplied value.
        TP.elementSetAttribute(anElement, attrName, attrValue, true);
    }

    return anElement;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementWrapToContent',
function(anElement) {

    /**
     * @method elementWrapToContent
     * @summary "Shrink wraps" the element to its content.
     * @description This method grows or shrinks the element's size to be the
     *     size of its contents. It also adjusts the clipping rectangle to that
     *     same dimension.
     * @param {HTMLElement} anElement The element to wrap to its content.
     * @exception TP.sig.InvalidElement
     */

    var elementWidth,
        elementHeight,

        clipRect;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    elementWidth = TP.elementGetContentWidth(anElement);
    elementHeight = TP.elementGetContentHeight(anElement);

    TP.elementSetWidth(anElement, elementWidth);
    TP.elementSetHeight(anElement, elementHeight);

    clipRect = TP.elementGetClipRect(anElement);

    TP.elementSetClipRect(anElement,
                            clipRect.at(0),
                            clipRect.at(3) + elementWidth,
                            clipRect.at(0) + elementHeight,
                            clipRect.at(3));

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('htmlElementAddContent',
function(anElement, theContent, loadedFunction, shouldAwake) {

    /**
     * @method htmlElementAddContent
     * @summary Adds content from theContent onto the end of the child content
     *     of anElement.
     * @param {Element} anElement The element receiving content.
     * @param {Node|String} theContent The content to insert into the element.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just added. The default for an 'add' operation is false.
     * @returns {Node} The first node of the content that was just added.
     */

    //  Simply a cover for inserting child content before the end of the
    //  element.
    return TP.htmlElementInsertContent(anElement,
                                        theContent,
                                        TP.BEFORE_END,
                                        loadedFunction,
                                        shouldAwake);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('htmlElementInsertContent',
function(anElement, theContent, aPositionOrPath, loadedFunction, shouldAwake) {

    /**
     * @method htmlElementInsertContent
     * @summary Inserts content from theContent into/around anElement based on
     *     the position given. The position should indicate whether the content
     *     should become the previous sibling, next sibling, first child or last
     *     child.
     * @param {Element} anElement The element receiving content.
     * @param {Node|String} theContent The content to insert into the element.
     * @param {String} aPositionOrPath The position to place the content
     *     relative to anElement or a path to evaluate to get to a node at that
     *     position. This should be one of four values: TP.BEFORE_BEGIN,
     *     TP.AFTER_BEGIN, TP.BEFORE_END, TP.AFTER_END or the path to evaluate.
     *     Default is TP.BEFORE_END.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just inserted. The default for an 'insert' operation is false.
     * @exception TP.sig.InvalidElement
     * @returns {Node} The first node of the content that was just inserted.
     */

    var awakenContent,

        thePosition,

        doc,

        nodeContent,
        strContent,

        insertionNode,

        range,
        node,

        returnNode;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    awakenContent = TP.ifInvalid(shouldAwake, false);

    thePosition = TP.ifEmpty(aPositionOrPath, TP.BEFORE_END);

    doc = TP.nodeGetDocument(anElement);

    //  If the content is an HTML node, then we just make sure its an
    //  Element, and not a Document.
    if (TP.isHTMLNode(theContent)) {
        if (TP.isDocument(theContent)) {
            nodeContent = theContent.documentElement;
        } else {
            nodeContent = theContent;
        }

        strContent = null;
    } else {
        //  Otherwise, its an X(HT)ML node or a String - in either case, we
        //  get the HTML String representation and use that.
        strContent = TP.htmlstr(theContent);
        nodeContent = null;
    }

    //  If we have node content, then we use it - since parsing, in general,
    //  is where the performance problems are.
    if (TP.isNode(nodeContent)) {
        //  Based on the value of the position, we insert the node at the
        //  proper place in the DOM and possibly awaken it, based on the
        //  value of the 'awakenContent' flag.
        switch (thePosition) {
            case TP.AFTER_END:

                TP.nodeInsertBefore(anElement.parentNode,
                                    nodeContent,
                                    anElement.nextSibling,
                                    awakenContent);

                break;

            case TP.BEFORE_BEGIN:

                TP.nodeInsertBefore(anElement.parentNode,
                                    nodeContent,
                                    anElement,
                                    awakenContent);

                break;

            case TP.AFTER_BEGIN:

                TP.nodeInsertBefore(anElement,
                                    nodeContent,
                                    anElement.firstChild,
                                    awakenContent);

                break;

            case TP.BEFORE_END:

                TP.nodeAppendChild(anElement,
                                    nodeContent,
                                    awakenContent);

                break;

            default:

                //  Evaluate the path, using anElement as the 'context node'
                //  and insert the new content before the returned node.
                //  Note here how we 'auto collapse' into one node (so if
                //  the path returns multiple nodes, only the first one will
                //  be used). This will also cause an invalid value if no
                //  nodes are found.

                if (TP.isNode(insertionNode = TP.nodeEvaluatePath(
                                anElement,
                                thePosition,
                                null,   //  let the call determine path type
                                true))) { //  autocollapse
                    TP.nodeInsertBefore(anElement,
                                        nodeContent,
                                        insertionNode,
                                        awakenContent);
                }
        }
    } else if (TP.isString(strContent)) {
        //  Create a contextual fragment and use the DOM.
        range = doc.createRange();

        switch (thePosition) {
            case TP.AFTER_END:

                range.setStartAfter(anElement);

                break;

            case TP.BEFORE_BEGIN:

                range.setStartBefore(anElement);

                break;

            case TP.AFTER_BEGIN:

                range.selectNodeContents(anElement);
                range.collapse(true);

                break;

            case TP.BEFORE_END:

                range.selectNodeContents(anElement);
                range.collapse(false);

                break;

            default:
                break;
        }

        //  Try to create a contextual fragment from the String content.
        //  If this fails (probably because of a parsing bug), then we
        //  just create a text node from the String.
        try {
            node = range.createContextualFragment(strContent);

            //  Make sure to 'repair' anything like SVG that might exist
            //  in the fragment. See the '$htmlFragmentRepair' method
            //  for more details.
            TP.$htmlFragmentRepair(node);
        } catch (e) {
            node = doc.createTextNode(strContent);

            //  NB: We don't bother awakening this, since we're just
            //  inserting a Node.TEXT_NODE.
            awakenContent = false;
        }

        //  Based on the value of the position, we insert the node at
        //  the proper place in the DOM. We awaken it based on the value
        //  of awakenContent.
        switch (thePosition) {
            case TP.AFTER_END:

                TP.nodeInsertBefore(anElement.parentNode,
                                    node,
                                    anElement.nextSibling,
                                    awakenContent);
                break;

            case TP.BEFORE_BEGIN:

                TP.nodeInsertBefore(anElement.parentNode,
                                    node,
                                    anElement,
                                    awakenContent);

                break;

            case TP.AFTER_BEGIN:

                TP.nodeInsertBefore(anElement,
                                    node,
                                    anElement.firstChild,
                                    awakenContent);

                break;

            case TP.BEFORE_END:

                TP.nodeAppendChild(anElement,
                                    node,
                                    awakenContent);

                break;

            default:
                break;
        }
    }

    //  Based on the value of the position, we return the proper node.
    switch (thePosition) {
        case TP.AFTER_END:

            returnNode = anElement.nextSibling;

            break;

        case TP.BEFORE_BEGIN:

            returnNode = anElement.previousSibling;

            break;

        case TP.AFTER_BEGIN:

            returnNode = anElement.firstChild;

            break;

        case TP.BEFORE_END:

            returnNode = anElement.lastChild;

            break;

        default:
            break;
    }

    //  Execute any loaded function that we were handed.
    if (TP.isCallable(loadedFunction)) {
        loadedFunction(anElement, returnNode);
    }

    //  We only signal TP.sig.DOMContentLoaded if the system is configured
    //  for it.
    if (TP.sys.shouldSignalDOMLoaded()) {
        //  NB: For insert, it's actually the parent node that's changed it's
        //  content.
        TP.signal(TP.gid(returnNode.parentNode),
                    'TP.sig.DOMContentLoaded',
                    theContent);
    }

    return returnNode;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('htmlElementReplaceWith',
function(anElement, theContent, loadedFunction, shouldAwake) {

    /**
     * @method htmlElementReplaceWith
     * @summary Replaces anElement which should be an HTML element.
     * @description This method sets the 'outer content' of anElement to
     *     theContent which means that the entire element, including its start
     *     and end tags, will be replaced with theContent. NOTE: This method may
     *     replace anElement!!! To use this method safely, always capture its
     *     return value and use that as the target element going forward.
     * @param {HTMLElement} anElement The element to set the 'outer content' of.
     * @param {Node|String} theContent The content to replace the 'outer
     *     content' with.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just replaced. The default for this operation is false.
     * @exception TP.sig.InvalidElement
     * @returns {Element|Text} The newly created Node (could be a Text node) or
     *     anElement, depending on how the replacement happened.
     */

    var awakenContent,

        doc,

        nodeContent,
        strContent,

        returnNode,

        range,
        node;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    awakenContent = TP.ifInvalid(shouldAwake, false);

    doc = TP.nodeGetDocument(anElement);

    //  If the content is an HTML node, then we just make sure its an
    //  Element, and not a Document.
    if (TP.isHTMLNode(theContent)) {
        if (TP.isDocument(theContent)) {
            nodeContent = theContent.documentElement;
        } else {
            nodeContent = theContent;
        }

        strContent = null;
    } else {
        //  Otherwise, its an X(HT)ML node or a String - in either case, we
        //  get the HTML String representation and use that.
        strContent = TP.htmlstr(theContent);
        nodeContent = null;
    }

    //  If we have node content, then we use it - since parsing, in general,
    //  is where the performance problems are.
    if (TP.isNode(nodeContent)) {
        //  Replace anElement with the nodeContent in the parent.
        //  Note that this means that anElement is no longer part of its
        //  Document.

        //  Note reassignment since the node we're adding might have come
        //  from another document.
        returnNode = TP.nodeReplaceChild(
                                anElement.parentNode,
                                nodeContent,
                                anElement,
                                awakenContent);
    } else if (TP.isString(strContent)) {
        //  Create a contextual fragment and use the DOM.
        range = doc.createRange();
        range.setStartBefore(anElement);

        //  Try to create a contextual fragment from the String content.
        //  If this fails (probably because of a parsing bug), then we
        //  just create a text node from the String.
        try {
            node = range.createContextualFragment(strContent);

            //  Make sure to 'repair' anything like SVG that might exist
            //  in the fragment. See the '$htmlFragmentRepair' method
            //  for more details.
            TP.$htmlFragmentRepair(node);

            //  The contextual fragment is a DocumentFragment and we
            //  need to capture the element that was really created,
            //  which is the element represented by strContent, before
            //  we do the replace.
            returnNode = node.firstChild;
        } catch (e) {
            returnNode = doc.createTextNode(strContent);
        }

        //  Note reassignment since the node we're adding might have
        //  come from another document.
        returnNode = TP.nodeReplaceChild(
                                anElement.parentNode,
                                returnNode,
                                anElement,
                                awakenContent);
    }

    //  Execute any loaded function that we were handed.
    if (TP.isCallable(loadedFunction) && TP.isElement(returnNode)) {
        loadedFunction(returnNode.parentNode, returnNode);
    }

    //  We only signal TP.sig.DOMContentLoaded if the system is configured
    //  for it.
    if (TP.sys.shouldSignalDOMLoaded() && TP.isElement(returnNode)) {
        //  NOTE NOTE NOTE
        //  we signal here, but from the PARENT since outer content replaces
        //  the original element
        TP.signal(TP.gid(returnNode.parentNode),
                    'TP.sig.DOMContentLoaded',
                    theContent);
    }

    //  Return whatever the return node is.
    return returnNode;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('htmlElementSetContent',
function(anElement, theContent, loadedFunction, shouldAwake) {

    /**
     * @method htmlElementSetContent
     * @summary Sets the 'content' of anElement, which should be an HTML
     *     element.
     * @description This method sets the 'inner content' of anElement to
     *     theContent which means that just the contents of the element, not
     *     including its start and end tags, will be replaced with theContent.
     * @param {HTMLElement} anElement The element to set the 'inner content' of.
     * @param {Node|String} theContent The content to replace the 'inner
     *     content' with.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just set. The default for a 'set' operation is whether anElement has
     *     a Window object associated with it or not.
     * @exception TP.sig.InvalidElement
     * @returns {Element} The element.
     */

    var awakenContent,

        nodeContent,
        strContent;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    awakenContent = shouldAwake;
    if (TP.notValid(awakenContent)) {
        awakenContent = TP.nodeHasWindow(anElement);
    }

    //  If the content is an HTML node, then we just make sure its an
    //  Element, and not a Document.
    if (TP.isHTMLNode(theContent)) {
        if (TP.isDocument(theContent)) {
            nodeContent = theContent.documentElement;
        } else {
            nodeContent = theContent;
        }

        strContent = null;
    } else {
        //  Otherwise, its an X(HT)ML node or a String - in either case, we
        //  get the HTML String representation and use that.
        strContent = TP.htmlstr(theContent);
        nodeContent = null;
    }

    //  If we have node content, then we use it - since parsing, in general,
    //  is where the performance problems are.
    if (TP.isNode(nodeContent)) {
        //  Clear the node

        anElement.innerHTML = '';

        //  Append the nodeContent which makes it the sole child node.

        //  Note reassignment since the node we're adding might have
        //  come from another document.
        nodeContent = TP.nodeAppendChild(anElement, nodeContent, false);
    } else if (TP.isString(strContent)) {
        anElement.innerHTML = strContent;
    }

    if (awakenContent) {
        //  Awaken any newly added content. Note how we loop over all of the
        //  child nodes as all of them constitute the newly added content.
        TP.nodeAwakenChildNodesFromTo(anElement, TP.FIRST, TP.LAST);
    }

    //  Execute any loaded function that we were handed.
    if (TP.isCallable(loadedFunction)) {
        loadedFunction(anElement, anElement);
    }

    //  We only signal TP.sig.DOMContentLoaded if the system is configured
    //  for it.
    if (TP.sys.shouldSignalDOMLoaded()) {
        TP.signal(TP.gid(anElement),
                    'TP.sig.DOMContentLoaded',
                    theContent);
    }

    //  Return the element itself.
    return anElement;
});

//  ------------------------------------------------------------------------
//  NODE PRIMITIVES
//  ------------------------------------------------------------------------

/*
Common Node operations. Conversion into an HTML or XHTML format is a common
operation done during UI display. Most of TIBET operates on XML until the
last moment so we preserve the ability to use XSLT, XPath, etc. for as long
as possible. Only at the last stage of display do we tend to convert to a
true HTML DOM or string format.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('htmlElementAsXHTMLString',
function(anElement) {

    /**
     * @method htmlElementAsXHTMLString
     * @summary Returns a String of well-formed XHTML for the HTML element.
     *     This method tries to build a compliant XHTML string from the supplied
     *     element, which should be an HTML element.
     * @param {HTMLElement} anElement The Element to serialize.
     * @exception TP.sig.InvalidElement
     * @returns {String} A String representation of the Element converted into
     *     XHTML.
     */

    var xhtmlResult,
        defaultLang,

        escapeText,

        processedRootElement;

    if (!TP.isHTMLNode(anElement) || !TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement',
                            'Element must be an HTML element.');
    }

    //  Create an Array to hold our XHTML information as we generate it.
    //  We'll join this together at the end of this method to produce the
    //  String.
    xhtmlResult = TP.ac();

    //  The default language is TIBET's current 'target' language. The
    //  markup may define its own 'lang' attribute below, which will
    //  override this setting.
    defaultLang = TP.sys.getTargetLanguage();

    escapeText = true;

    //  A flag to keep track of whether we're at the root element or not.
    processedRootElement = false;

    TP.nodeDepthTraversal(
        anElement,
        function(anElem) {

            //  The 'push' function for the depth traversal

            var elemTagName,

                hasXMLNS,
                hasLang,

                elemAttrs,

                i,

                attrName,
                attrValue,

                nsPrefix,
                currentNSURI,
                currentNSPrefixes;

            //  Grab the element's tag name and convert it to lowercase. It
            //  it's empty, bail out.
            if (TP.isEmpty(elemTagName = anElem.tagName.toLowerCase())) {
                return;
            }

            //  Weird IE comment stuff because getElementsByTagName('*')
            //  returns comment nodes.
            if (elemTagName === '!') {
                xhtmlResult.push(anElem.text);
                return;
            }

            //  If the tag is a 'meta' tag with a 'generator', then its
            //  unnecessary for our produced markup so we exit here.
            if (elemTagName === 'meta') {
                if (anElem.name.toLowerCase() === 'generator') {
                    return;
                }
            }

            currentNSPrefixes = TP.ac();

            //  If the tag name is 'html', write the XHTML strict
            //  doctype, since that's what we're generating here.
            if (elemTagName === 'html') {
                xhtmlResult.push(
                        TP.XML_10_HEADER,
                        TP.w3.DocType.XHTML_10_STRICT.asString());
            }

            //  Start the tag
            xhtmlResult.push('<', elemTagName);

            hasXMLNS = false;
            hasLang = false;

            //  Grab the element's attributes
            elemAttrs = anElem.attributes;

            //  Loop over them and compute the name and value for them.
            for (i = 0; i < elemAttrs.length; i++) {
                attrName = elemAttrs[i].name.toLowerCase();

                //  If the attribute has a colon (':') in it, check to see
                //  if a namespace can be found that would match the part of
                //  the attribute name before the colon.
                if (attrName.contains(':')) {
                    //  Grab the namespace prefix by slicing it off the
                    //  attribute name.
                    nsPrefix = attrName.slice(0, attrName.indexOf(':'));

                    //  Make sure not to add the 'xmlns' prefix itself to
                    //  our 'current prefixes list' since many XML parsers
                    //  don't like to parse the TP.w3.Xmlns.XMLNS.
                    if (/xmlns/.test(nsPrefix)) {
                        continue;
                    }

                    //  If this prefix is not in the 'current prefixes list'
                    //  (tracked element-by-element and emptied after each
                    //  element is processed), then try to grab the URI and
                    //  build an 'xmlns' attribute.
                    if (!currentNSPrefixes.contains(nsPrefix)) {
                        currentNSURI = TP.w3.Xmlns.getNSURIForPrefix(nsPrefix);

                        if (TP.notEmpty(currentNSURI)) {
                            xhtmlResult.push(' ', 'xmlns:', nsPrefix,
                                    '="', currentNSURI, '"');
                        } else {
                            xhtmlResult.push(' ', 'xmlns:', nsPrefix,
                                    '="urn:tibet:unrecognizednamespace"');
                        }

                        //  Remember that we processed this prefix for this
                        //  element so that we don't end up with multiple
                        //  'xmlns:' attributes with the same prefix on the
                        //  same element.
                        currentNSPrefixes.push(nsPrefix);
                    }
                }

                switch (attrName) {
                    case 'style':

                        //  The best way (because of IE) to get the
                        //  attribute value of the 'style' attribute is to
                        //  grab its 'cssText' property (we also lowercase
                        //  it here to conform to TIBET coding standards).
                        attrValue = TP.elementGetStyleObj(
                                        anElem).cssText.toLowerCase();
                        break;

                    case 'class':

                        //  The best way (because of IE) to get the
                        //  attribute value of the 'class' attribute is to
                        //  grab its 'className' property.
                        attrValue = anElem.className;

                        break;

                    case 'http-equiv':

                        attrValue = anElem.httpEquiv;

                        break;

                    case 'name':

                        attrValue = anElem.name;

                        break;

                    case 'for':

                        attrValue = anElem.htmlFor;

                        break;

                    case 'xmlns':

                        hasXMLNS = true;

                        break;

                    case 'lang':
                    case 'xml:lang':

                        hasLang = true;

                        break;

                    //  These attributes need a value in XHTML because
                    //  they're 'singular' in HTML (i.e. checked="checked")
                    case 'noshade':
                    case 'checked':
                    case 'selected':
                    case 'multiple':
                    case 'nowrap':
                    case 'disabled':

                        attrValue = attrName;

                        break;

                    default:

                        //  No special handling... just go ahead and grab
                        //  the value.
                        try {
                            //  Note here how we pass in '2' as a second
                            //  parameter to this call. This is a special IE
                            //  syntax that tells getAttribute to return
                            //  the originally specified value in the
                            //  markup, no matter what its been changed to.

                            //  Note that we do *not* use
                            //  TP.elementGetAttribute() here because of the
                            //  special parameter.
                            attrValue = anElem.getAttribute(
                                                            attrName, 2);
                        } catch (e) {
                            continue;
                        }

                        break;
                }

                //  If no attribute value was supplied, then we merely set
                //  it to be the empty string.
                if (TP.isEmpty(attrValue)) {
                    xhtmlResult.push(' ', attrName, '=""');
                } else {
                    //  Otherwise, we set it to its value after replacing
                    //  literal constructs with entities.
                    xhtmlResult.push(' ', attrName, '="',
                                TP.xmlLiteralsToEntities(attrValue), '"');
                }
            }

            //  If its the 'html' element, then check to see if a language
            //  or an xmlns was defined. If not, supply them.
            if (!processedRootElement) {
                if (!hasLang) {
                    xhtmlResult.push(' lang="', defaultLang,
                                        '" xml:lang="', defaultLang, '"');
                }

                if (!hasXMLNS) {
                    xhtmlResult.push(
                            ' xmlns="http://www.w3.org/1999/xhtml"');
                }

                //  Flip the flag so that we don't do this again.
                processedRootElement = true;
            }

            //  End the tag.
            xhtmlResult.push('>');

            //  If it was a 'pre' element, then we're not escaping text,
            //  since the 'pre' does that for us.
            if (elemTagName === 'pre') {
                escapeText = false;
            } else {
                escapeText = true;
            }

            //  Clear out any current namespace prefixes we are tracking.
            currentNSPrefixes.empty();
        },
        function(anElem) {

            //  The 'pop' function for the depth traversal

            //  Weird IE comment stuff because getElementsByTagName('*')
            //  returns comment nodes.
            if (anElem.tagName === '!') {
                return;
            }

            //  End off the element by generating a closing tag.
            xhtmlResult.push('</',
                                anElem.tagName.toLowerCase(),
                                '>');
        },
        function(nonElementNode) {

            //  The content function for the depth traversal

            var commentText;

            //  Switch on the node type... we currently support TEXT_NODEs
            //  and COMMENT_NODEs.
            switch (nonElementNode.nodeType) {
                case Node.TEXT_NODE:

                    //  If we're supposed to escape the text, run the text
                    //  node's nodeValue through a conversion from literals
                    //  to entities and push that onto our results.
                    if (escapeText) {
                        xhtmlResult.push(
                            TP.xmlLiteralsToEntities(
                                TP.htmlEntitiesToXMLEntities(
                                            nonElementNode.nodeValue)));
                    } else {
                        //  Otherwise, we must be in a 'pre' or something,
                        //  so just push the raw text onto our results.
                        xhtmlResult.push(nonElementNode.nodeValue);
                    }

                    break;

                case Node.COMMENT_NODE:

                    //  Make sure that any embedded '--' are converted to
                    //  something benign.
                    commentText = nonElementNode.nodeValue.replace(
                                                            /--/g, '__');

                    //  Push on content that has the proper leading and
                    //  trailing comment characters.
                    xhtmlResult.push('<!--' + commentText + '-->');

                    break;

                default:
                    break;
            }
        }
    );

    //  Join together the result Array and convert any HTML entities to
    //  their XML equivalent. This causes replacements such as any HTML
    //  '&nbsp;'s with the XML-compliant '&#160;'s.
    xhtmlResult = TP.htmlEntitiesToXMLEntities(xhtmlResult.join(''));

    return xhtmlResult;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$htmlFragmentRepair',
function(aFragment) {

    /**
     * @method $htmlFragmentRepair
     * @summary "Repairs" any content in the fragment that doesn't get properly
     *     created when the supplied fragment is created.
     * @description This method is only used in the htmlElement*Content()
     *     methods to repair XML content that has been placed within HTML. For
     *     now, this is limited to Gecko/Webkit browsers and is used only for
     *     SVG embedded in HTML.
     * @param {DocumentFragment} aFragment The fragment to repair.
     */

    var fragChildren,

        i,
        svgElems,

        j,

        oldElem,
        newElem;

    if (TP.notEmpty(aFragment)) {
        //  Iterate over all of the 'top-level' fragment nodes.
        fragChildren = aFragment.childNodes;
        for (i = 0; i < fragChildren.length; i++) {
            //  Make sure that the child is an Element.
            if (!TP.isElement(fragChildren[i])) {
                continue;
            }

            //  Look for 'svg' elements, create a new Element *in an XML
            //  DOM* with the String content of that SVG element. Then,
            //  adopt the node back into the HTML document and replace the
            //  HTML document's version of the SVG node with the adopted
            //  node.
            svgElems = fragChildren[i].getElementsByTagName('svg');
            for (j = 0; j < svgElems.length; j++) {
                oldElem = svgElems[j];
                if (TP.isElement(newElem = TP.elem(TP.str(oldElem)))) {
                    newElem = oldElem.ownerDocument.adoptNode(newElem);
                    oldElem.parentNode.replaceChild(newElem, oldElem);
                }
            }

            //  Do the same for 'svg:svg' elements - HTML doesn't know the
            //  difference...

            //  TODO: What happens if the author used a different prefix?
            //  Maybe should use TP.nodeGetElementsByTagName() with a
            //  wildcard instead...
            svgElems = fragChildren[i].getElementsByTagName('svg:svg');
            for (j = 0; j < svgElems.length; j++) {
                oldElem = svgElems[j];
                if (TP.isElement(newElem = TP.elem(TP.str(oldElem)))) {
                    newElem = oldElem.ownerDocument.adoptNode(newElem);
                    oldElem.parentNode.replaceChild(newElem, oldElem);
                }
            }
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('htmlNodeAsXHTMLNode',
function(aNode, aDocument) {

    /**
     * @method htmlNodeAsXHTMLNode
     * @summary Returns an XHTML Node representing the supplied HTML node.
     * @param {HTMLNode} aNode The HTML Node to convert into XHTML.
     * @param {XMLDocument} aDocument The document which should own the result
     *     node. Defaults to the XML document TP.XML_FACTORY_DOCUMENT.
     * @exception TP.sig.InvalidNode
     * @returns {Node} An XML Node representation of aNode.
     */

    var doc,

        node,

        i;

    if (!TP.isHTMLNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node must be an HTML node.');
    }

    doc = TP.isXMLDocument(aDocument) ? aDocument :
                            TP.XML_FACTORY_DOCUMENT;

    switch (aNode.nodeType) {
        case Node.ELEMENT_NODE:

            return TP.elementFromString(
                            TP.htmlElementAsXHTMLString(aNode));

        case Node.ATTRIBUTE_NODE:

            node = doc.createAttribute(aNode.name);
            node.value = aNode.value;

            return node;

        case Node.TEXT_NODE:

            return doc.createTextNode(aNode.data);

        case Node.CDATA_SECTION_NODE:

            return doc.createCDATASection(aNode.data);

        case Node.DOCUMENT_FRAGMENT_NODE:

            node = doc.createDocumentFragment();

            for (i = 0; i < aNode.childNodes.length; i++) {
                //  Note the recursive call here.
                TP.nodeAppendChild(
                    node,
                    TP.htmlNodeAsXHTMLNode(aNode.childNodes[i], doc));
            }

            return node;

        case Node.PROCESSING_INSTRUCTION_NODE:

            return doc.createProcessingInstruction(aNode.target,
                                                    aNode.data);

        case Node.COMMENT_NODE:

            return doc.createComment(aNode.data);

        case Node.ENTITY_REFERENCE_NODE:

            TP.raise(this, 'TP.sig.UnsupportedOperation');
            break;

        case Node.ENTITY_NODE:

            TP.raise(this, 'TP.sig.UnsupportedOperation');
            break;

        case Node.DOCUMENT_TYPE_NODE:

            TP.raise(this, 'TP.sig.UnsupportedOperation');
            break;

        case Node.NOTATION_NODE:

            TP.raise(this, 'TP.sig.UnsupportedOperation');
            break;

        case Node.DOCUMENT_NODE:

            node = TP.documentFromString(
                    TP.htmlElementAsXHTMLString(aNode.documentElement));

            if (!TP.isDocument(node)) {
                node = TP.constructDocument(null, 'htmlNodeConversionError');
                TP.nodeAppendChild(
                    node.documentElement,
                    node.createTextNode(TP.nodeAsString(aNode)),
                    false);
            }

            return node;

        default:
            break;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('htmlNodeAsXHTMLString',
function(aNode) {

    /**
     * @method htmlNodeAsXHTMLString
     * @summary Returns an XHTML String representing the supplied HTML node.
     * @param {HTMLNode} aNode The Node to serialize.
     * @exception TP.sig.InvalidNode
     * @returns {String} A String representation of the Node converted into
     *     XHTML.
     */

    var resultNode;

    if (!TP.isHTMLNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node must be an HTML node.');
    }

    if (TP.isNode(resultNode = TP.htmlNodeAsXHTMLNode(aNode))) {
        return TP.nodeAsString(resultNode);
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('iframeAddContent',
function(anElement, aContent) {

    /**
     * @method iframeAddContent
     * @summary Adds the content to that of the supplied HTML iframe element.
     * @param {HTMLElement} anElement The iframe element to set the content of.
     * @param {String|Node} aContent The content to add to the content in the
     *     iframe.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidDocument
     */

    var iframeDoc;

    if (TP.notValid(aContent)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    /* eslint-disable no-extra-parens */
    if (!TP.isElement(anElement) ||
        (TP.elementGetLocalName(anElement).toLowerCase() !== 'iframe' &&
            TP.elementGetLocalName(anElement).toLowerCase() !== 'object')) {
        return TP.raise(this, 'TP.sig.InvalidElement',
                            'Element must be an iframe.');
    }
    /* eslint-enable no-extra-parens */

    //  Grab the document from the iframe and write a blank document into it
    //  to prep the document (making sure it has 'head' and 'body'
    //  elements).
    iframeDoc = TP.elementGetIFrameDocument(anElement);

    if (TP.notValid(iframeDoc)) {
        return TP.raise(this, 'TP.sig.InvalidDocument',
                            'iframe document not value.');
    }

    TP.documentAddContent(iframeDoc, aContent, null, true);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('iframeSetContent',
function(anElement, aContent, loadedFunction, shouldAwake) {

    /**
     * @method iframeSetContent
     * @summary Set the content of the supplied HTML iframe element.
     * @param {HTMLElement} anElement The iframe element to set the content of.
     * @param {String|Node} aContent The content to set into the iframe.
     * @param {Function} loadedFunction The Function object to execute when the
     *     content is fully loaded (i.e. when the DOM is fully formed).
     * @param {Boolean} shouldAwake Whether or not to awaken the content that we
     *     just set. The default for a 'set' operation is whether anElement has
     *     a Window object associated with it or not.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidDocument
     */

    var iframeDoc,

        nodeContent;

    if (TP.notValid(aContent)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    /* eslint-disable no-extra-parens */
    if (!TP.isElement(anElement) ||
        (TP.elementGetLocalName(anElement).toLowerCase() !== 'iframe' &&
            TP.elementGetLocalName(anElement).toLowerCase() !== 'object')) {
        return TP.raise(this, 'TP.sig.InvalidElement',
                            'Element must be an iframe.');
    }
    /* eslint-enable no-extra-parens */

    //  Grab the document from the iframe and write a blank document into it
    //  to prep the document (making sure it has 'head' and 'body'
    //  elements).
    iframeDoc = TP.elementGetIFrameDocument(anElement);

    if (TP.notValid(iframeDoc)) {
        return TP.raise(this, 'TP.sig.InvalidDocument',
                            'iframe document not value.');
    }

    if (TP.isNode(aContent)) {
        //  aContent is a Node

        if (TP.isDocument(aContent)) {
            nodeContent = aContent.documentElement;
        } else {
            nodeContent = aContent;
        }

        if (!TP.elementHasAttribute(anElement, 'hasdoc')) {
            //  This process works much better when we have a blank document
            //  to start from.
            iframeDoc.open();
            iframeDoc.write('<html><head></head><body></body></html>');
            iframeDoc.close();

            TP.elementSetAttribute(anElement, 'hasdoc', 'true');
        }

        //  We pass 'true' as the last parameter to awaken content if
        //  necessary.
        TP.documentSetContent(iframeDoc, nodeContent, loadedFunction,
                                shouldAwake);
    } else {
        //  We pass 'true' as the last parameter to awaken content if
        //  necessary.
        TP.documentSetContent(iframeDoc, aContent, loadedFunction,
                                shouldAwake);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeAsHTMLNode',
function(aNode, aDocument) {

    /**
     * @method nodeAsHTMLNode
     * @summary Returns an HTML Node built from the supplied node, if possible.
     * @param {Node} aNode The Node to convert into HTML.
     * @param {HTMLDocument} aDocument The document which should own the result
     *     node. Defaults to the current canvas's document.
     * @exception TP.sig.InvalidNode
     * @returns {Node} An HTML node.
     */

    var doc,

        node,

        i,
        elem;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    //  already HTML? we're good to go then
    if (TP.isHTMLNode(aNode)) {
        return aNode;
    }

    doc = TP.isHTMLDocument(aDocument) ? aDocument :
                            TP.sys.getUICanvas().getNativeDocument();

    switch (aNode.nodeType) {
        case Node.ELEMENT_NODE:

            return TP.stringAsHTMLNode(TP.nodeAsString(aNode), doc);

        case Node.ATTRIBUTE_NODE:

            node = doc.createAttribute(aNode.name);
            node.value = aNode.value;

            return node;

        case Node.TEXT_NODE:

            return doc.createTextNode(aNode.data);

        case Node.CDATA_SECTION_NODE:

            TP.ifWarn() ?
                TP.warn('Cannot create CDATASections in HTML. Creating' +
                        ' text node instead') : 0;

            return doc.createTextNode(aNode.data);

        case Node.DOCUMENT_FRAGMENT_NODE:

            node = doc.createDocumentFragment();

            for (i = 0; i < aNode.childNodes.length; i++) {
                //  Note the recursive call here.

                //  Also, we pass false to force not awakening.
                TP.nodeAppendChild(
                    node,
                    TP.nodeAsHTMLNode(aNode.childNodes[i], doc),
                    false);
            }

            return node;

        case Node.PROCESSING_INSTRUCTION_NODE:

            return doc.createTextNode(
                        TP.join('PIs cannot be created in HTML: <?',
                                aNode.target,
                                ' ',
                                aNode.data,
                                '?>'));

        case Node.COMMENT_NODE:

            return doc.createComment(aNode.data);

        case Node.ENTITY_REFERENCE_NODE:

            TP.raise(this, 'TP.sig.UnsupportedOperation');
            break;

        case Node.ENTITY_NODE:

            TP.raise(this, 'TP.sig.UnsupportedOperation');
            break;

        case Node.DOCUMENT_TYPE_NODE:

            TP.raise(this, 'TP.sig.UnsupportedOperation');
            break;

        case Node.NOTATION_NODE:

            TP.raise(this, 'TP.sig.UnsupportedOperation');
            break;

        case Node.DOCUMENT_NODE:

            //  Note the recursive call here
            elem = TP.nodeAsHTMLNode(aNode.documentElement);

            if (TP.isElement(elem)) {
                if (TP.isHTMLDocument(
                        node = TP.elementGetIFrameDocument(
                                    TP.documentConstructIFrameElement(doc)))) {
                    //  If there's a 'body' on the HTML document, use that.
                    //  Otherwise, just use the document element.

                    if (TP.isElement(TP.documentGetBody(node))) {
                        //  Pass false to force not awakening.
                        TP.nodeAppendChild(TP.documentGetBody(node),
                                            elem,
                                            false);
                    } else {
                        //  Pass false to force not awakening.
                        TP.nodeAppendChild(node.documentElement,
                                            elem,
                                            false);
                    }
                }
            } else {
                node = TP.constructDocument(null, 'xmlNodeConversionError');
                TP.nodeAppendChild(
                    node.documentElement,
                    node.createTextNode(TP.nodeAsString(aNode)),
                    false);
            }

            return node;

        default:
            break;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeAsHTMLString',
function(aNode) {

    /**
     * @method nodeAsHTMLString
     * @summary Returns an HTML string built from the supplied node. The HTML
     *     string returned is a best-attempt at producing a valid string of
     *     markup that could be used in an innerHTML call. This is part of the
     *     core "cleansing" pathway to help ensure that content going into the
     *     UI is proper HTML content.
     * @description The setContent pipeline of TIBET requires properly formatted
     *     HTML content when the target node is an HTML node. This routine is
     *     the primary interface to perform any translation that's needed to get
     *     the new content ready. You have two options when using this routine.
     *     First, you can simply pass the node and a string/regular expression
     *     cleanse will be run on it. Second, you can pass true for useDOM and a
     *     depth-first traversal of the node will occur which builds a clean
     *     string from the DOM itself. The latter approach is intended to be
     *     more rigorous and accurate, however it can also be slower on larger
     *     target nodes.
     * @param {Node} aNode The Node to convert into HTML.
     * @exception TP.sig.InvalidNode
     * @returns {String} An HTML string.
     */

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (TP.isHTMLNode(aNode)) {
        return TP.nodeAsString(aNode);
    }

    return TP.stringAsHTMLString(TP.nodeAsString(aNode));
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeAsXMLNode',
function(aNode, aDocument) {

    /**
     * @method nodeAsXMLNode
     * @summary Returns an XML Node representing the supplied node. For most
     *     nodes this just returns the node, but for HTML nodes it will return
     *     an XHTML node representation built from the receiver's content.
     * @param {Node} aNode The Node to convert into XML as needed.
     * @param {XMLDocument} aDocument The document which should own the result
     *     node. Defaults to the XML document TP.XML_FACTORY_DOCUMENT.
     * @exception TP.sig.InvalidNode
     * @returns {Node} An XML Node representation of aNode.
     */

    var doc;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    doc = TP.isXMLDocument(aDocument) ? aDocument :
                            TP.XML_FACTORY_DOCUMENT;

    //  already XML? we're good to go then
    if (TP.isXMLNode(aNode)) {
        return aNode;
    }

    //  must be an HTML node. have to convert it to XML (XHTML actually)
    return TP.htmlNodeAsXHTMLNode(aNode, doc);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeAsXMLString',
function(aNode) {

    /**
     * @method nodeAsXMLString
     * @summary Returns a String of well-formed XML for the node.
     * @param {Node} aNode The Node to serialize.
     * @exception TP.sig.InvalidNode
     * @returns {String} A String representation of the Node converted into XML.
     */

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    //  already XML? we're good to go then
    if (TP.isXMLNode(aNode)) {
        return TP.nodeAsString(aNode);
    }

    //  must be an HTML node. have to serialize it as XML (XHTML actually)
    return TP.htmlNodeAsXHTMLString(aNode);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('stringAsHTMLAttribute',
function(aString) {

    /**
     * @method stringAsHTMLAttribute
     * @summary Returns the incoming string properly escaped for use in an HTML
     *     attribute value.
     * @param {String} aString The string to process.
     * @returns {String}
     */

    if (TP.isEmpty(aString)) {
        return '';
    }

    return aString.replace(/&/g, '&amp;').replace(/</g, '&lt;');
});

//  ------------------------------------------------------------------------

TP.definePrimitive('stringAsHTMLNode',
function(aString, aDocument) {

    /**
     * @method stringAsHTMLNode
     * @summary Converts the supplied markup to an HTML node. Note that in
     *     order to ensure that the node is being created from HTML markup, this
     *     method calls TP.stringAsHTMLString() on the supplied String.
     * @param {String} aString The markup to create the Node from.
     * @param {HTMLDocument} aDocument The document which should own the result
     *     node. Defaults to the current canvas's document.
     * @exception TP.sig.InvalidString
     * @returns {Node} The node created from the supplied content.
     */

    var doc,

        str,

        grabFrame,
        grabDoc,

        headStr,
        bodyStr,

        node,

        div;

    if (!TP.isString(aString)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    doc = TP.isHTMLDocument(aDocument) ? aDocument :
                            TP.sys.getUICanvas().getNativeDocument();

    //  Make sure the markup is 'clean' HTML.
    str = TP.stringAsHTMLString(aString);

    //  If the content string contains 'html', 'head' or 'body' tags as its
    //  'first tags', we have to treat it specially (we can't 'innerHTML' it
    //  into another element).
    if (/<(html:)?(html|head|body)(\s+|>)/i.test(str)) {
        //  create an iframe, using the HTML document we computed earlier
        //  This method 'initializes' it and attaches it to that document's
        //  'body' element.
        grabFrame = TP.documentConstructIFrameElement(doc);
        grabDoc = TP.elementGetIFrameDocument(grabFrame);

        //  grab the 'html' string from the content
        TP.regex.HTML_HTML_ELEM.lastIndex = 0;

        //  grab the 'head' string from the 'html' string
        TP.regex.HTML_HEAD_ELEM.lastIndex = 0;
        headStr = str.replace(TP.regex.HTML_HEAD_ELEM, '$3');

        //  grab the 'body' string from the 'html' string
        TP.regex.HTML_BODY_ELEM.lastIndex = 0;
        bodyStr = str.replace(TP.regex.HTML_BODY_ELEM, '$3');

        //  Go ahead and set the grabbing doc 'head's content, but not
        //  before we strip any 'script', stylesheet 'link' or inline
        //  'style' elements from the content.
        grabDoc.getElementsByTagName('head')[0].innerHTML =
                                    headStr.stripExternalHeadContent();

        //  Go ahead and set the grabbing doc 'body's content, but not
        //  before we strip any 'img' elements from the content.
        TP.documentGetBody(grabDoc).innerHTML =
                            bodyStr.stripExternalBodyContent();

        //  The node we're after is the grabbing doc's 'document element'.
        node = grabDoc.documentElement;

        //  Remove the iframe from its parent, so that we clean up after
        //  ourselves.
        TP.nodeDetach(grabFrame);
    } else {
        //  create a temporary DIV we can leverage to get new content
        div = doc.createElement('div');
        div.innerHTML = str;

        switch (div.childNodes.length) {
            case 0:

                node = doc.createTextNode(str);

                break;

            case 1:

                node = TP.nodeDetach(div.firstChild);

                break;

            default:

                node = TP.nodeListAsFragment(doc.childNodes);

                break;
        }
    }

    return node;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('stringAsHTMLString',
function(aString) {

    /**
     * @method stringAsHTMLString
     * @summary Converts the supplied markup to a string of HTML markup.
     * @param {String} aString The markup to create the Node from.
     * @exception TP.sig.InvalidString
     * @returns {Node} The node created from the supplied content.
     */

    var str,
        comments;

    if (!TP.isString(aString)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    str = aString;

    //  NOTE: Content being processed into HTML is usually being done so
    //  that it can be displayed in a browser. Since modern browsers can now
    //  have 'real XML' embedded in their markup (i.e. SVG, VML, etc.), a
    //  number of the following steps are currently commented out, as they
    //  produce a much more strict HTML document, which will mangle any
    //  embedded XML.
    //  There are 3 exceptions to this rule:
    //      - Any 'XML declaration' at the top of the document will be
    //      stripped out. "Embedded XML" shouldn't need an XML declaration
    //      at the start of the document.
    //      - Each XML 'empty tag' will be converted to a 'full
    //      opening/closing pair', since HTML is very strict about this and
    //      XML doesn't care which form an 'empty tag' takes.
    //      - Any 'html' namespace prefixes or definitions will be stripped
    //      out to avoid problems with the browsers HTML rendering.

    //  Strip out the XML declaration
    str = str.strip(TP.regex.XML_DECL);

    //  Temporarily replace comments with numbered comment texts, so that
    //  any XML content inside of comments will be preserved.
    comments = TP.ac();
    TP.regex.XML_COMMENT.lastIndex = 0;

    str = str.replace(
        TP.regex.XML_COMMENT,
        function(wholeMatch, firstMatch, commentExpr) {

            comments.push(commentExpr);

            /* eslint-disable no-extra-parens */
            return TP.join('<!--', (comments.getSize() - 1), '-->');
            /* eslint-enable no-extra-parens */
        });

    //  Replace any XHTML 'empty' tags, with the equivalent HTML markup
    //  (either a single HTML-formatted empty tag or two HTML tags with
    //  no content, depending on where XHTML says the tag can be empty
    //  or not).
    TP.regex.XML_EMPTY_TAG.lastIndex = 0;
    str = str.replace(
        TP.regex.XML_EMPTY_TAG,
        function(wholeMatch, tagName, tagContent) {

            //  NOTE the implication here that tagName does not include
            //  prefix since the hash does not have prefixes on the keys
            if (TP.regex.XHTML_10_EMPTY_ELEMENTS.test(tagName)) {
                return TP.join('<', tagName, tagContent, '>');
            } else {
                return TP.join('<', tagName, tagContent, '>',
                                '</', tagName, '>');
            }
        });

    //  TODO:   convert xml-stylesheet entries to 'link' elements

    //  TODO:   convert trailing ?> of PIs into >

    //  TODO:   convert attribute values containing &lt; into <

    //  TODO:   convert attribute JS-entities &amp;{blah} into &{blah}

    //  TODO:   replace selected="selected", checked="checked", etc. into
    //          their "singular form" selected, checked, multiple, etc

    //  Strip out any closing tags of 'empty' tags.
    TP.regex.XHTML_10_EMPTY_ELEMENTS_STRIP.lastIndex = 0;
    str = str.strip(TP.regex.XHTML_10_EMPTY_ELEMENTS_STRIP);

    //  We'd like to avoid a lot of the clutter that XML namespace
    //  declarations make in our HTML, so we strip them out here.

    //  Strip out any 'default namespace' declarations (but not those for
    //  SVG or VML - some browsers allow those languages to be 'embedded' in
    //  HTML)
    TP.regex.NON_PREFIXED_NS_ATTR.lastIndex = 0;
    str = str.replace(TP.regex.NON_PREFIXED_NS_ATTR,
                        function(wholeMatch, quoteChar, nsUriMatch) {

                            if (nsUriMatch === TP.w3.Xmlns.SVG ||
                                nsUriMatch === TP.w3.Xmlns.VML) {
                                return wholeMatch;
                            }

                            return '';
                        });

    //  Strip out any 'prefixed namespace' declarations
    TP.regex.PREFIXED_NS_ATTR.lastIndex = 0;
    str = str.replace(TP.regex.PREFIXED_NS_ATTR,
                        function(wholeMatch, quoteChar, nsUriMatch) {

                            return '';
                        });

    //  We generally leave 'namespace-prefixed' tags alone, since even
    //  though in HTML the colon (':') has no meaning (TIBET will look for
    //  tags named 'foo:bar' - which HTML treats as their 'whole name').
    //  However, we definitely strip out any 'html:', 'svg:' and 'm:' namespace
    //  prefixes on tags as these are now supported natively by HTML5.
    str = str.replace(/<(\/)?(html|svg|m):/g, '<$1');

    //  Strip out any CDATA section directives. These can cause problems,
    //  especially in 'script' elements.

    //  Note that we do these before we perform the 'general CDATA section'
    //  removal below since content of 'script' and 'style' blocks don't
    //  need to be entitified to reside in regular HTML.
    str = str.replace(/<(script|style)([^>]*)>\s*<!\[CDATA\[/g, '<$1$2>');
    str = str.replace(/\]\]>\s*<\/(script|style)>/g, '</$1>');

    //  Strip out CDATA sections outside of 'script' and 'style' blocks.
    str = str.replace(/<!\[CDATA\[([\s\S]*?)\]\]>/g,
                        function(wholeMatch, content) {

                            return TP.htmlLiteralsToEntities(content);
                        });

    //  Put the comments back into the source text by finding the number
    //  each one was registered under and replacing it with the original
    //  comment text.
    str = str.replace(
        /<!--(\d+)-->/g,
        function(wholeMatch, commentNumber) {

            return TP.join('<!--',
                            comments.at(parseInt(commentNumber, 10)),
                            '-->');
        });

    return str;
});

//  ------------------------------------------------------------------------
//  Awakening Methods
//  ------------------------------------------------------------------------

TP.definePrimitive('nodeAwakenContent',
function(aNode, aDocument, aWindow) {

    /**
     * @method nodeAwakenContent
     * @summary Awakens aNode and any child nodes under it. This version is a
     *     placeholder until the entire kernel has loaded and the rest of the
     *     awakening machinery is available.
     * @param {Node} aNode The node to awaken.
     * @param {Document} aDocument The node's document.
     * @param {Window} aWindow The node's window.
     * @exception TP.sig.InvalidElement
     */

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeAwakenChildNodesFromTo',
function(aNode, startIndex, endIndex) {

    /**
     * @method nodeAwakenChildNodesFromTo
     * @summary Awakens child nodes of aNode from startIndex to endIndex. Note
     *     that this function treats its supplied indexes as inclusive, which
     *     means that the child nodes at startIndex and at endIndex will also be
     *     awakened.
     * @param {Node} aNode The node to awaken the child nodes of.
     * @param {Number} startIndex The start index to begin awakening child nodes
     *     at or TP.FIRST to start at the first child node.
     * @param {Number} endIndex The end index to stop awakening child nodes at
     *     or TP.LAST to stop at the last child node.
     * @exception TP.sig.InvalidNode Raised when a node that isn't a kind
     *     'collection node' is provided to the method.
     */

    var theStartIndex,
        theEndIndex,
        i,
        childNode,
        doc;

    //  no child nodes for anything that isn't an element, document or
    //  document fragment
    if (!TP.isCollectionNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode',
                            'Node not a collection Node.');
    }

    if (startIndex === TP.FIRST) {
        theStartIndex = 0;
    } else {
        theStartIndex = startIndex;
    }

    if (endIndex === TP.LAST) {
        //  Subtract 1 off the end since our loop below is *inclusive*.
        theEndIndex = aNode.childNodes.length - 1;
    } else {
        theEndIndex = endIndex;
    }

    //  verify that we've got a window (content will be visible) and a
    //  document or there's no work to do
    if (TP.notValid(doc = TP.nodeGetDocument(aNode))) {
        return;
    }

    if (TP.notValid(TP.nodeGetWindow(doc))) {
        return;
    }

    //  NB: We include the last element for awakening here, since the caller
    //  of this function will have passed in the inclusive end index.
    for (i = theStartIndex; i <= theEndIndex; i++) {
        childNode = aNode.childNodes[i];

        //  Make sure the new child node is an element before we try to
        //  awaken it (since we only awaken elements). NOTE that we pass in
        //  the document and window to keep overhead down in the awaken
        if (TP.isElement(childNode)) {
            TP.nodeAwakenContent(childNode);
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetElementsByClassName',
function(aNode, aClassName) {

    /**
     * @method nodeGetElementsByClassName
     * @summary Returns an Array of Elements under aNode whose CSS class name
     *     matches aClassName.
     * @param {Node} aNode The node to act as the common parent when looking for
     *     elements with the supplied class name.
     * @param {String} aClassName The class name to use to find matching
     *     elements. Multiple class names should be space separated.
     * @exception TP.sig.InvalidNode
     * @returns {Element[]} An Array of Elements under anElement whose CSS class
     *     name matches aClassName.
     */

    var elem,
        classNames;

    if (!TP.isElement(aNode) && !TP.isDocument(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    elem = TP.isDocument(aNode) ? aNode.documentElement : aNode;

    //  If the native version is available, use that.
    if (TP.isCallable(elem.getElementsByClassName)) {
        //  Make sure to repackage it as an Array for consistency.
        return TP.ac(elem.getElementsByClassName(aClassName));
    }

    //  Otherwise, split the classes along the separating spaces, and join
    //  them back together with ' .'
    classNames = '.' + aClassName.split(' ').join(' .');

    //  Return the value of evaluating the classes as CSS selectors
    return TP.nodeEvaluateCSS(elem, classNames);
});

//  ------------------------------------------------------------------------
//  NODE MODIFICATION
//  ------------------------------------------------------------------------

TP.definePrimitive('nodeEmptyContent',
function(aNode) {

    /**
     * @method nodeEmptyContent
     * @summary Removes all content from the node provided, effectively setting
     *     the node's content to either null or the empty string depending on
     *     node capabilities.
     * @param {Node} aNode The node to empty.
     * @exception TP.sig.InvalidNode
     * @returns {Node} The node.
     */

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    switch (aNode.nodeType) {
        case Node.ELEMENT_NODE:

            if (TP.isHTMLNode(aNode)) {
                aNode.innerHTML = '';
            } else {
                while (aNode.hasChildNodes()) {
                    //  NB: Note how we remove from the back... this helps when
                    //  computing previous document position.
                    TP.nodeDetach(aNode.lastChild);
                }
            }

            break;

        case Node.TEXT_NODE:
        case Node.CDATA_SECTION_NODE:
        case Node.PROCESSING_INSTRUCTION_NODE:
        case Node.COMMENT_NODE:

            aNode.data = '';
            break;

        case Node.DOCUMENT_NODE:
        case Node.DOCUMENT_FRAGMENT_NODE:

            while (aNode.hasChildNodes()) {
                TP.nodeDetach(aNode.lastChild);
            }

            break;

        case Node.ATTRIBUTE_NODE:

            aNode.value = '';

            break;

        case Node.ENTITY_REFERENCE_NODE:
        case Node.ENTITY_NODE:
        case Node.DOCUMENT_TYPE_NODE:
        case Node.NOTATION_NODE:

            TP.raise(this, 'TP.sig.UnsupportedOperation');
            break;

        default:
            break;
    }

    return aNode;
});

//  ------------------------------------------------------------------------
//  COMPUTATION PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('computeAngleFromCenter',
function(centerObj, endObj) {

    /**
     * @method computeAngleFromCenter
     * @summary Returns the angle (in degrees) between two objects one of which
     *     represents a 'center point' and the other an 'end point'.
     * @param {Event|String|Element|TP.core.Hash|Array|TP.gui.Point} centerObj
     *     An event object or an element specification, or element suitable for
     *     TP.byId() or a hash or point with 'x' and 'y values or an array with
     *     an X 'value' in the first position and a Y value in the second.
     * @param {Event|String|Element|TP.core.Hash|Array|TP.gui.Point} endObj
     *     An event object or an element specification, or element suitable for
     *     TP.byId() or a hash or point with 'x' and 'y' values or an array with
     *     an X 'value' in the first position and a Y value in the second.
     * @returns {Number} The angle (in degrees) between the center point and the
     *     end point.
     */

    var coords1,
        coords2,

        x1,
        y1,
        x2,
        y2,

        angle;

    coords1 = TP.coord(centerObj);
    coords2 = TP.coord(endObj);

    x1 = coords1.first();
    y1 = coords1.last();

    x2 = coords2.first();
    y2 = coords2.last();

    angle = (y2 - y1).atan2D(x2 - x1);

    return angle.standardizeAngle();
});

//  ------------------------------------------------------------------------

TP.definePrimitive('computeAngleFromEnds',
function(obj1, obj2) {

    /**
     * @method computeAngleFromEnds
     * @summary Returns the angle (in degrees) between two objects that
     *     represent the 'end points'.
     * @description Given the two points (x1, y1) and (x2, y2), the distance
     *     between these points is given by the formula:
     *
     *     degreesStandardizedTo360(atan2(y2 - y1, x2 - x1))
     *
     *
     * @param {Event|String|Element|TP.core.Hash|Array|TP.gui.Point} obj1 An
     *     event object or an element specification, or element suitable for
     *     TP.byId() or a hash or point with 'x' and 'y' values or an array with
     *     an X 'value' in the first position and a Y value in the second.
     * @param {Event|String|Element|TP.core.Hash|Array|TP.gui.Point} obj2 An
     *     event object or an element specification, or element suitable for
     *     TP.byId() or a hash or point with 'x' and 'y' values or an array with
     *     an X 'value' in the first position and a Y value in the second.
     * @returns {Number} The angle (in degrees) between the x1, y1 and x2, y2
     *     using the formula above.
     */

    var coords1,
        coords2,

        x1,
        y1,
        x2,
        y2,

        radius,

        calcX,
        calcY,

        angle;

    coords1 = TP.coord(obj1);
    coords2 = TP.coord(obj2);

    x1 = coords1.first();
    y1 = coords1.last();

    x2 = coords2.first();
    y2 = coords2.last();

    radius = ((x2 - x1).abs() * (x2 - x1).abs() +
                    (y2 - y1).abs() * (y2 - y1).abs()).sqrt();

    calcX = x1;
    calcY = y1 - radius;

    angle = (2 * (y2 - calcY).atan2(x2 - calcX)).radiansToDegrees();

    return angle.standardizeAngle();
});

//  ------------------------------------------------------------------------

TP.definePrimitive('computeCompassCorner',
function(angle, numIncrements, centerInIncrement) {

    /**
     * @method computeCompassCorner
     * @summary Computes a 'compass corner' given an angle. The values advance
     *     around the compass in a clockwise fashion (i.e. north is 1, east is
     *     9, south is 17, west is 25).
     * @description Given the angle, this method returns a value which is
     *     compatible with the following constants:
     *
     *     TP.NORTH
     *     TP.NORTH_BY_EAST
     *     TP.NORTH_NORTHEAST
     *     TP.NORTHEAST_BY_NORTH
     *     TP.NORTHEAST
     *     TP.NORTHEAST_BY_EAST
     *     TP.EAST_NORTHEAST
     *     TP.EAST_BY_NORTH
     *     TP.EAST
     *     TP.EAST_BY_SOUTH
     *     TP.EAST_SOUTHEAST
     *     TP.SOUTHEAST_BY_EAST
     *     TP.SOUTHEAST
     *     TP.SOUTHEAST_BY_SOUTH
     *     TP.SOUTH_SOUTHEAST
     *     TP.SOUTH_BY_EAST
     *     TP.SOUTH
     *     TP.SOUTH_BY_WEST
     *     TP.SOUTH_SOUTHWEST
     *     TP.SOUTHWEST_BY_SOUTH
     *     TP.SOUTHWEST
     *     TP.SOUTHWEST_BY_WEST
     *     TP.WEST_SOUTHWEST
     *     TP.WEST_BY_SOUTH
     *     TP.WEST
     *     TP.WEST_BY_NORTH
     *     TP.WEST_NORTHWEST
     *     TP.NORTHWEST_BY_WEST
     *     TP.NORTHWEST
     *     TP.NORTHWEST_BY_NORTH
     *     TP.NORTH_NORTHWEST
     *     TP.NORTH_BY_WEST
     *
     *     If a number of increments is supplied, then the value is 'snap'ed to
     *     that number of increments. For instance, if only 8 compass points are
     *     desired (to match the pre-defined constants above) and no other
     *     values, this value should be 8 and this routine will snap the value
     *     to match the follwing predefined constants:
     *
     *     TP.NORTH
     *     TP.NORTHEAST
     *     TP.EAST
     *     TP.SOUTHEAST
     *     TP.SOUTH
     *     TP.SOUTHWEST
     *     TP.WEST
     *     TP.NORTHWEST
     *
     * @param {Number} angle The angle to compute the compass point from.
     * @param {Number} numIncrements An optional number of 'increments' to
     *     'snap' the value to.
     * @param {Boolean} centerInIncrement If true, this routine 'centers' the
     *     point it is using to compute the 'increment wedge' in that wedge.
     *     This prevents the computation from snapping at the 'first clockwise
     *     edge' and snapping to the center of the wedge instead. It is true by
     *     default, but requires the 'numIncrements' parameter to be supplied.
     * @exception TP.sig.InvalidNumber
     * @returns {Number} A Number matching the constant corresponding to the
     *     compass corner.
     */

    var center,

        theAngle,
        cornerVal;

    if (!TP.isNumber(angle)) {
        return TP.raise(this, 'TP.sig.InvalidNumber');
    }

    center = TP.ifInvalid(centerInIncrement, true);

    //  This algorithm taken from:
    //  http://en.wikipedia.org/wiki/Boxing_the_compass#Compass_points

    /* eslint-disable no-extra-parens */

    theAngle = angle;
    if (TP.isNumber(numIncrements) && center) {
        //  'Center' the point in increment by adding half of the value
        //  computed by dividing 360 by the number of increments
        theAngle += (360 / numIncrements) / 2;
    }

    cornerVal = (theAngle / 11.25) + 1.5;

    if (cornerVal >= 33) {
        cornerVal -= 32;
    }

    cornerVal = cornerVal.floor();

    //  If a number of increments was supplied, then we need to compute an
    //  'even increment' to snap to and subtract that from the point value.
    //  Note how we subtract 1 from the point value before doing the modulo
    //  to normalize the value against 0.
    if (TP.isNumber(numIncrements)) {
        cornerVal -= ((cornerVal - 1) % (32 / numIncrements));
    }

    /* eslint-enable no-extra-parens */

    return cornerVal;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('computeDistance',
function(obj1, obj2) {

    /**
     * @method computeDistance
     * @summary Returns the distance between two objects. Useful for things
     *     like drag and drop tolerances or magnetism.
     * @description Given the two points (x1, y1) and (x2, y2), the distance
     *     between these points is given by the formula:
     *
     *     d = sqrt((x2 - x1) ** 2 + (y2 - y1) ** 2)
     *
     *
     * @param {Event|String|Element|TP.core.Hash|Array|TP.gui.Point} obj1 An
     *     event object or an element specification, or element suitable for
     *     TP.byId() or a hash or point with 'x' and 'y' values or an array with
     *     an X 'value' in the first position and a Y value in the second.
     * @param {Event|String|Element|TP.core.Hash|Array|TP.gui.Point} obj2 An
     *     event object or an element specification, or element suitable for
     *     TP.byId() or a hash or point with 'x' and 'y' values or an array with
     *     an X 'value' in the first position and a Y value in the second.
     * @returns {Number} The distance between the x1, y1 and x2, y2 using the
     *     formula above.
     */

    var coords1,
        coords2,

        x1,
        y1,
        x2,
        y2,

        distance;

    coords1 = TP.coord(obj1);
    coords2 = TP.coord(obj2);

    x1 = coords1.first();
    y1 = coords1.last();

    x2 = coords2.first();
    y2 = coords2.last();

    distance = ((x2 - x1).pow(2) + (y2 - y1).pow(2)).sqrt();

    return distance;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('computeVector',
function(obj1, obj2) {

    /**
     * @method computeVector
     * @summary Computes an informal vector, effectively a magnitude (distance)
     *     and a direction (in degrees) between two objects. The typical inputs
     *     are elements or events whose coordinates are used for the
     *     computation.
     * @param {Event|String|Element|TP.core.Hash|Array|TP.gui.Point} obj1 An
     *     event object or an element specification, or element suitable for
     *     TP.byId() or a hash or point with 'x' and 'y' values or an array with
     *     an X 'value' in the first position and a Y value in the second.
     * @param {Event|String|Element|TP.core.Hash|Array|TP.gui.Point} obj2 An
     *     event object or an element specification, or element suitable for
     *     TP.byId() or a hash or point with 'x' and 'y' values or an array with
     *     an X 'value' in the first position and a Y value in the second.
     * @returns {Number[]} The distance and direction of the vector expressed as
     *     an Array of: [distance, direction].
     */

    var coords1,
        coords2,

        x1,
        y1,
        x2,
        y2,

        distance,
        direction;

    coords1 = TP.coord(obj1);
    coords2 = TP.coord(obj2);

    x1 = coords1.first();
    y1 = coords1.last();

    x2 = coords2.first();
    y2 = coords2.last();

    distance = ((x2 - x1).pow(2) + (y2 - y1).pow(2)).sqrt();

    direction = (y2 - y1).atan2D(x2 - x1).standardizeAngle();

    return TP.ac(distance, direction);
});

//  ------------------------------------------------------------------------
//  WINDOW PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('$$checkWindowClosed',
function(aWindow, aWindowID) {

    /**
     * @method $$checkWindowClosed
     * @summary Checks to see if the window whose ID is provided is indeed
     *     closed.
     * @description This function checks to see if a window which got an
     *     onunload event is truly closed. This function is scheduled by the
     *     standard onunload event handler to ensure that it will fire the
     *     proper TIBET event accurately. If the window is closed, this function
     *     will signal a TP.sig.WindowClosed signal, using the window's global
     *     ID as its origin. Note here how we supply both the window itself and
     *     its ID. This is because of the differences of browsers as to whether
     *     a handle to a closed Window is still valid, whether it can be
     *     obtained by looking it up using that ID and whether the ID can be
     *     computed. Since we can't be sure of any of this, we supply both to
     *     this method.
     * @param {Window} aWindow The window to check.
     * @param {String} aWindowID The ID of the window to check.
     * @exception TP.sig.InvalidWindow
     * @exception TP.sig.InvalidString
     * @returns {Boolean} True if the call succeeded.
     * @function $$checkWindowClosed
     */

    if (TP.notValid(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (TP.isEmpty(aWindowID)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    //  if the window has been closed, then we'll signal that fact,
    //  otherwise we may simply have been called due to a document unload
    //  event
    if (aWindow.closed) {
        try {
            TP.signal(aWindowID, 'TP.sig.WindowClosed', null, null);
        } finally {
            TP.core.Window.removeWindowInfo(aWindowID);
            TP.global[aWindowID] = null;
        }

        return true;
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('open',
function(url, name, aSpec, shouldReplace) {

    /**
     * @method open
     * @summary Opens a new Window and instruments it to set it up for use with
     *     TIBET.
     * @description This function opens a new window and sets it up for use with
     *     TIBET. This function manages a number of problems with the standard
     *     window.open() call, including firing an onload properly after an
     *     asychronous window.load call that is loaded externally (which native
     *     browsers won't fire).
     * @param {String} url The URL to load into the window.
     * @param {String} name The name to give this window. This must be unique.
     * @param {TP.core.Hash|String} aSpec A 'spec string' of key=value pairs or
     *     a hash that can be used to produce a feature string. You should use
     *     'top' and 'left' on all browsers and TIBET will convert as needed.
     * @param {Boolean} shouldReplace Whether the content should be replaced if
     *     the window is already open.
     * @returns {Window} The newly opened window.
     * @function open
     */

    var newWin,
        tpwin,
        winName,
        spec;

    //  Watch out for the common 'top.' or 'parent.' prefixes that often
    //  show up on window references. If they are there, slice them off.
    if (TP.isString(name)) {
        if (/^top./.test(name)) {
            winName = name.slice(4, name.length);
        } else if (/^parent./.test(name)) {
            winName = name.slice(7, name.length);
        } else {
            winName = name;
        }
    } else {
        winName = TP.getNextWindowName();
    }

    //  If we got a valid spec and it wasn't empty, then convert it into
    //  the funky 'key=value,' syntax that the native window.open call
    //  expects.
    if (TP.isString(aSpec)) {
        spec = aSpec;
    } else if (TP.notEmpty(aSpec)) {
        spec = '';

        aSpec.perform(
            function(kvPair) {
                spec += kvPair.first() + '=' + kvPair.last() + ',';
            });

        //  chop off the last comma from the perform
        spec = spec.chop(',');
    }

    //  HACK:   convert top/left into screenX/screenY for mozilla browsers
    if (TP.notEmpty(spec) && TP.sys.isUA('GECKO')) {
        spec = spec.replace('top', 'screenY');
        spec = spec.replace('left', 'screenX');
    }

    //  NOTE: Nav 4.X strikes again! We can't actually pass undefined values
    //  in for the various parameters or Nav 4.X will freak out, so we must
    //  test them and only send in the ones that are valid.
    if (TP.notValid(spec) && !shouldReplace) {
        newWin = window.open('', winName);
    } else if (TP.notValid(spec)) {
        newWin = window.open('', winName, null, shouldReplace);
    } else {
        newWin = window.open('', winName, spec, shouldReplace);
    }

    if (TP.notValid(newWin)) {
        TP.raise(this, 'TP.sig.WindowException',
                    'Unable to open window');
        return;
    }

    //  If a valid url is supplied, then load it and signal an 'onload'.
    if (TP.notEmpty(url)) {
        //  this will create a new instance as needed, then instrument it
        tpwin = TP.core.Window.construct(newWin);
        tpwin.setLocation(url);
    } else {
        //  Otherwise, go ahead and write 'html' and 'body' elements here to
        //  make the document real so we can instrument

        if (TP.isTrue(shouldReplace)) {
            newWin.document.open(TP.HTML_TEXT_ENCODED, 'replace');
        } else {
            newWin.document.open(TP.HTML_TEXT_ENCODED);
        }

        newWin.document.write('<html><body></body></html>');
        newWin.document.close();

        //  force creation of a window instance. this will instrument which
        //  is why we do it after blowing away the content via open/write.
        tpwin = TP.core.Window.construct(newWin);
    }

    return newWin;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$$processDocumentLoaded',
function(aWindow) {

    /**
     * @method $$processDocumentLoaded
     * @summary The standard TIBET hook for consistent onload processing.
     * @description This function is attached to native windows by tibet_hook.js
     *     to ensure we get a consistent entry point for page setup. Once
     *     invoked, this function will find and invoke any onload functions
     *     registered for the window via the TP.core.Window method
     *     registerOnloadFunction(). The final step in this method is to signal
     *     TP.sig.DocumentLoaded and TP.sig.DOMContentLoaded for the window and
     *     document respectively.
     * @param {Window} aWindow The window which was loaded.
     * @exception TP.sig.InvalidWindow
     */

    var msg,
        docTitle,
        i,
        theme,
        winLoadFuncs,
        app,
        len;

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (TP.sys.cfg('log.hook') && TP.sys.cfg('boot.context') !== 'headless') {
        msg = 'Processing document loaded for: ' + TP.gid(aWindow) + '.';
        TP.boot.$stdout(msg, TP.DEBUG);
    }

    if (TP.$$DEBUG) {
        TP.boot.$stdout(aWindow.document.documentElement, TP.DEBUG);
    }

    //  clear the flag once we process our checks
    TP.core.Window.$$isDocumentWriting = false;

    //  instrument it so we're sure it has some basic TIBET features
    TP.core.Window.instrument(aWindow);

    //  propagate the 'title' content from the document that we're drawing up
    //  onto the *top* document
    docTitle = TP.documentGetTitleContent(aWindow.document);
    TP.documentSetTitleContent(aWindow.$$topWindow.document, docTitle);

    TP.elementBubbleXMLNSAttributesOnDescendants(
                            aWindow.document.documentElement);

    //  Add common namespaces to the document element to further reduce
    //  namespace clutter.
    TP.w3.Xmlns.addCommonNSURIsTo(aWindow.document.documentElement);

    //  update ACL content if possible so that subsequent CSS processing and
    //  awakening can work with an awareness of the ACL context
    TP.windowAssignACLKeys(aWindow);

    //  Update the document theme based on the current application theme. The
    //  current application theme is computed from the current UI canvas
    //  document or system properties if a theme cannot be found there.
    app = TP.sys.getApplication();
    if (TP.isValid(app) && TP.notEmpty(theme = app.getTheme())) {
        TP.documentSetTheme(aWindow.document, theme);
    }

    //  we allow zero or more page load functions to be registered so that
    //  we don't have native onload processing getting mixed up with our
    //  entry point. this gives us a bit more control
    winLoadFuncs = TP.core.Window.getWindowInfo(TP.gid(aWindow),
                                                'loadFunctions');

    if (TP.notEmpty(winLoadFuncs)) {
        //  empty the list so that if any of the load functions want to
        //  change window content we don't loop endlessly
        TP.core.Window.setWindowInfo(aWindow, 'loadFunctions', TP.ac());

        try {
            //  We *must* unique the page load function so that if the
            //  same one has been registered multiple times (because of
            //  multiple TP.dom.Document.writes or whatever), it will only
            //  be executed once.
            winLoadFuncs = winLoadFuncs.unique();

            //  Execute the page load functions and then empty the array
            //  so that we don't run them again.
            len = winLoadFuncs.length;
            for (i = 0; i < len; i++) {
                winLoadFuncs[i](aWindow.document);
            }

            winLoadFuncs.empty();
        } catch (e) {
            TP.ifError() ?
                TP.error(TP.ec(e, TP.join('Pageload function: ',
                                            TP.str(winLoadFuncs[i]),
                                            ' generated error.'))) : 0;
        }
    }

    //  If the flag that should get set in htmlDocumentSetContent() for
    //  awakening is 'true', then go ahead and awaken the content.
    if (TP.isTrue(TP.core.Window.getWindowInfo(TP.gid(aWindow),
                                                'shouldAwake'))) {
        //  awaken any newly added content.
        try {
            TP.nodeAwakenContent(aWindow.document.documentElement);
        } catch (e) {
            TP.ifError() ?
                TP.error(TP.ec(e, 'Window content awaken generated error.')) : 0;
        }
    }

    //  Set up any 'backspace' key handlers on the window so that backspace key
    //  presses won't cause the standard "Back" button behavior that would
    //  cause the TIBET frame to be flushed.
    TP.windowInstallBackspaceHook(aWindow);

    //  Set up any 'focus' handlers on the window so that the TIBET focus
    //  machinery is kept in sync with what the browser considers to be the
    //  focused element.
    TP.windowInstallFocusHook(aWindow);

    //  Make sure that if there is an Element that wanted to be focused as the
    //  first focused element on the page (using the HTML5 'autofocus'
    //  attribute) that it is, indeed, focused.
    TP.elementFocusAutofocusedElement(aWindow.document.documentElement);

    //  If there was no focused element, then just go ahead and focus the
    //  window.
    if (!TP.isElement(TP.documentGetFocusedElement(aWindow.document))) {
        aWindow.focus();
    }

    //  Update the top-level window title if we loaded into the UICANVAS and
    //  push the URI into our history record.
    if (TP.sys.hasStarted() &&
            TP.gid(aWindow) === TP.sys.getUICanvas().getName()) {

        TP.core.History.captureDocumentLocation(aWindow.document);

        docTitle = TP.documentGetTitleContent(aWindow.document);
        TP.documentSetTitleContent(aWindow.$$topWindow.document, docTitle);
    }

    //  final operation is to signal that we've done the work
    try {
        //  We signal TP.sig.DocumentLoaded using the GID of the window as
        //  the origin.
        TP.signal(TP.gid(aWindow), 'TP.sig.DocumentLoaded');

        //  We only signal DOMContentLoaded if the system is configured for
        //  it.
        if (TP.sys.shouldSignalDOMLoaded()) {
            //  We signal DOMContentLoaded using the GID of the document as
            //  the origin.

            //  For document level operations this is the only place we can
            //  properly signal DOMContentLoaded since we want to be sure
            //  it's really loaded and need to wait for the onload
            //  triggering of this handler.
            TP.signal(TP.gid(aWindow.document),
                        'TP.sig.DOMContentLoaded',
                        aWindow.document.documentElement);
        }
    } catch (e) {
        TP.ifError() ?
            TP.error(
                TP.ec(
                    e, 'TP.sig.DOMContentLoaded handler generated error.')) : 0;
    }

    return;
});

//  ------------------------------------------------------------------------

//  Direct assignment here to support internal reference to function.
TP.$$processDocumentUnloaded = function(aWindow, checkForWindowClosed) {

    /**
     * @method $$processDocumentUnloaded
     * @summary Processes an onunload event from the window by executing all of
     *     the onunload functions registered by the function above and then
     *     signaling the tibet frame with our window's global ID.
     * @param {Window} aWindow The window which was loaded.
     * @param {Boolean} checkForWindowClosed Whether we should check to see if
     *     the window is closing.
     * @exception TP.sig.InvalidWindow
     */

    var checkWindow,
        winID,
        winDidClose;

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    checkWindow = TP.ifInvalid(checkForWindowClosed, true);

    //  We try to make the onunload function as short and sweet as possible.
    //  Browsers dislike long onunload functions.

    //  To tell the system that we're unloading a window, we call the TIBET
    //  signaling infrastructure thusly:
    //      - our window's document's global ID
    //      - 'TP.sig.DocumentUnloaded' signal type name
    winID = TP.gid(aWindow);

    //  final operation is to signal that we've done the work
    try {
        //  We signal TP.sig.DocumentUnloaded using the GID of the window as
        //  the origin.
        TP.signal(winID, 'TP.sig.DocumentUnloaded');

        //  We only signal DOMContentUnloaded if the system is configured for
        //  it.
        if (TP.sys.shouldSignalDOMLoaded()) {
            //  We signal DOMContentUnloaded using the GID of the document as
            //  the origin.

            TP.signal(TP.gid(aWindow.document),
                        'TP.sig.DOMContentUnloaded',
                        aWindow.document.documentElement);
        }
    } catch (e) {
        TP.ifError() ?
            TP.error(
                TP.ec(
                    e, 'TP.sig.DOMContentUnloaded handler generated error.')) :
                    0;
    }

    //  close open windows if we're unloading the code frame
    if (TP.$$processDocumentUnloaded.codeframe === aWindow &&
            TP.sys.isUA('GECKO')) {
        TP.core.Window.closeRegisteredWindows();

        return;
    }

    //  Filter any elements that are in the document of the window we are
    //  unloading out of the TP.$focus_stack.
    TP.$focus_stack = TP.$focus_stack.reject(
                        function(aTPElem) {
                            if (aTPElem.getNativeDocument() ===
                                aWindow.document) {
                                return true;
                            }

                            return false;
                        });

    //  Clear any event data to avoid memory leaks for events that are holding
    //  onto DOM structures that might have been present in this window.
    TP.core.Keyboard.resetEventData(aWindow);
    TP.core.Mouse.resetEventData(aWindow);

    if (checkWindow) {
        winDidClose = false;

        //  schedule a job to check on the window's close status
        TP.schedule(TP.hc(
                    'step',
                    function() {

                        //  Note here how we set the closured variable so
                        //  that we can use it in the limit function below.
                        //  Note also that we pass *both* the window and the
                        //  window ID in. See the TP.$$checkWindowClosed()
                        //  function for more information.
                        winDidClose = TP.$$checkWindowClosed(
                                                    aWindow, winID);

                        return winDidClose;
                    },
                    'delay', 1000,      //  start after 1 second
                    'interval', 500,    //  repeat every half second
                    'limit',
                    function(aJob) {

                        //  don't run more than 5 times (1, 1.5, 2, 2.5, 3)
                        if (aJob.get('iteration') > 5) {
                            return true;
                        }

                        //  don't run if the window closed routine succeeded
                        if (winDidClose) {
                            return true;
                        }

                        return false;
                    }));
    }

    return;
};

//  Register it.
TP.definePrimitive('$$processDocumentUnloaded', TP.$$processDocumentUnloaded);

//  ------------------------------------------------------------------------

//  put a reference to the TIBET codebase on the document unload handler so
//  we can check to see when the codebase is exiting later
TP.$$processDocumentUnloaded.codeframe = window;

//  ------------------------------------------------------------------------

TP.definePrimitive('win',
function(anObject) {

    /**
     * @method win
     * @summary A general purpose routine that can return a window based on a
     *     variety of input object types.
     * @param {Object} anObject A string, window, node, or other object which
     *     can provide a window or be used to construct one.
     * @returns {Window} A native window object.
     */

    if (TP.notValid(anObject)) {
        return;
    } else if (TP.isString(anObject)) {
        return TP.sys.getWindowById(anObject);
    } else if (TP.isWindow(anObject)) {
        return anObject;
    } else if (TP.isElement(anObject) &&
                (anObject.tagName.toLowerCase() === 'iframe' ||
                    anObject.tagName.toLowerCase() === 'object')) {
        return TP.elementGetIFrameWindow(anObject);
    } else if (TP.isNode(anObject)) {
        return TP.nodeGetWindow(anObject);
    } else if (TP.canInvoke(anObject, 'getNativeWindow')) {
        return anObject.getNativeWindow();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowAssignACLKeys',
function(aWindow, aclType) {

    /**
     * @method windowAssignACLKeys
     * @summary Updates the current set of ACL keys on the window's document's
     *     body element (when available). This operation sets acl: attributes
     *     which can be leveraged to drive UI changes via CSS that are
     *     "permission-specific" to the current user.
     * @param {Window} aWindow The native window to update.
     * @param {String} aclType The acl type: real or effective. When not present
     *     both are set.
     * @exception TP.sig.InvalidWindow
     */

    var doc;

    if (!TP.isWindow(aWindow)) {
        return TP.raise(null, 'TP.sig.InvalidWindow');
    }

    if (TP.notValid(TP.sys.getTypeByName('TP.core.User'))) {
        //  no keys to assign since not loading TP.core.User
        return;
    }

    doc = aWindow.document;

    if (TP.isElement(TP.documentGetBody(doc))) {
        switch (aclType) {
            case TP.ACL_REAL:

                TP.elementSetAttribute(
                        TP.documentGetBody(doc),
                        TP.ACL_REAL,
                        TP.core.User.getRealAccessKeys().join(' '),
                        true);
                break;

            case TP.ACL_EFFECTIVE:

                TP.elementSetAttribute(
                        TP.documentGetBody(doc),
                        TP.ACL_EFFECTIVE,
                        TP.core.User.getEffectiveAccessKeys().join(' '),
                        true);

                break;

            default:

                TP.elementSetAttribute(
                        TP.documentGetBody(doc),
                        TP.ACL_REAL,
                        TP.core.User.getRealAccessKeys().join(' '),
                        true);
                TP.elementSetAttribute(
                        TP.documentGetBody(doc),
                        TP.ACL_EFFECTIVE,
                        TP.core.User.getEffectiveAccessKeys().join(' '),
                        true);
                break;
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowAssignCommonIds',
function(aWindow) {

    /**
     * @method windowAssignCommonIds
     * @summary Assigns ids to commonly used elements, such as the root
     *     element, the head, the body, etc. (if they don't already exist).
     * @param {Window} aWindow The native window to update.
     * @exception TP.sig.InvalidWindow
     */

    var doc,
        elem,
        index;

    if (!TP.isWindow(aWindow)) {
        return TP.raise(null, 'TP.sig.InvalidWindow');
    }

    doc = aWindow.document;

    //  If there is a native document root element and it doesn't have an
    //  id, give it one.
    if (TP.isElement(elem = doc.documentElement)) {
        if (TP.isEmpty(TP.elementGetAttribute(elem, 'id'))) {
            //  Compute the id by slicing off everything to the right of the
            //  colon (':') in the node name.
            if ((index = elem.nodeName.indexOf(':')) !== TP.NOT_FOUND) {
                TP.elementSetAttribute(elem,
                                        'id',
                                        elem.nodeName.slice(index));
            } else {
                TP.elementSetAttribute(elem,
                                        'id',
                                        elem.nodeName);
            }
        }
    }

    //  If there is a native head element and it doesn't have an id, give
    //  it one
    if (TP.isElement(elem = TP.nodeGetFirstElementByTagName(doc, 'head'))) {
        //  Set a 'head' convenience slot on the window, since the DOM spec
        //  didn't 'deign' to give us this slot (like 'body' is for the body
        //  element).
        doc.head = elem;

        //  Set the head element's id to 'head' (if it doesn't already have
        //  an id).
        if (TP.isEmpty(TP.elementGetAttribute(elem, 'id'))) {
            TP.elementSetAttribute(elem, 'id', 'head');
        }
    }

    //  If there is a native body element and it doesn't have an id, give
    //  it one
    if (TP.isElement(elem = TP.documentGetBody(doc))) {
        //  Set the body element's id to 'body' (if it doesn't already have
        //  an id).
        if (TP.isEmpty(TP.elementGetAttribute(elem, 'id'))) {
            TP.elementSetAttribute(elem, 'id', 'body');
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowComputeWindowOffsets',
function(aWindow, otherWindow, wantsTransformed) {

    /**
     * @method windowComputeWindowOffsets
     * @summary Computes position offsets between the first window and the
     *     second window.
     * @description This method assumes that the supplied windows are either
     *     iframe windows embedded somewhere in the same top-level window (maybe
     *     at different levels) or one of them is the top-level window itself.
     *     Note that this routine will hand back positive values if the second
     *     window is positioned at a greater top,left value than the first
     *     window and negative values if the first window is at a greater
     *     top,left value.
     * @param {Window} aWindow The first window to compute offset values for.
     * @param {Window} otherWindow The second window to compute offset values
     *     for.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the window's iframe element
     *     has been transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidWindow
     * @returns {Number[]} The offsets expressed as [left, top].
     */

    var frame1OffsetX,
        frame1OffsetY,

        win,
        frameElement,

        frameCoords,

        frame2OffsetX,
        frame2OffsetY;

    if (!TP.isWindow(aWindow) || !TP.isWindow(otherWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    //  Always set initial values to 0, so that numeric computations won't
    //  be NaNed.

    frame1OffsetX = 0;
    frame1OffsetY = 0;

    //  Iterate up through the 'frameElement / window' hierarchy, computing
    //  the offset as we go (for the first window).
    win = aWindow;
    while (TP.isElement(frameElement = win.frameElement)) {

        frameCoords = TP.elementGetBorderBox(frameElement, wantsTransformed);

        frame1OffsetX += frameCoords.at('left');
        frame1OffsetY += frameCoords.at('top');

        win = TP.nodeGetWindow(frameElement);
    }

    //  Always set initial values to 0, so that numeric computations won't
    //  be NaNed.
    frame2OffsetX = 0;
    frame2OffsetY = 0;

    //  Iterate up through the 'frameElement / window' hierarchy, computing
    //  the offset as we go (for the second window).
    win = otherWindow;
    while (TP.isElement(frameElement = win.frameElement)) {

        frameCoords = TP.elementGetBorderBox(frameElement, wantsTransformed);

        frame2OffsetX += frameCoords.at('left');
        frame2OffsetY += frameCoords.at('top');

        win = TP.nodeGetWindow(frameElement);
    }

    return TP.ac(frame2OffsetX - frame1OffsetX, frame2OffsetY - frame1OffsetY);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowComputeTransformationMatrix',
function(aWindow, wants2DMatrix) {

    /**
     * @method windowComputeTransformationMatrix
     * @summary Returns the 'computed' transformation matrix for the window
     *     (really its iframe element).
     * @description This method assumes that the window is embedded in an iframe
     *     (which may be embedded in more iframes up to a top-level window) and
     *     is really returning the transformation of those iframe elements up
     *     to the top-level window.
     * @param {Window} aWindow The window to compute the matrix for.
     * @param {Boolean} wants2DMatrix An optional parameter that tells the
     *     method whether or not to return a 3x2 matrix for use with CSS 2D
     *     transforms. The default is false.
     * @returns {Number[][]} An Array of Arrays representing the current
     *     transformation matrix.
     */

    var identity,
        matrix,

        elemMatrix,

        win,
        frameElement;

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    //  We start with the identity matrix
    identity = TP.matrixFromCSSString('matrix(1,0,0,1,0,0)');
    matrix = identity;

    //  Iterate up through the 'frameElement / window' hierarchy, computing
    //  the transform matrix for the iframe element and then accumulating that
    //  onto our result matrix as we go.
    win = aWindow;
    while (TP.isElement(frameElement = win.frameElement)) {

        if (TP.isArray(elemMatrix = TP.elementGetComputedTransformMatrix(
                                        frameElement))) {
            matrix = TP.matrixMultiply(matrix, elemMatrix);
        }

        win = TP.nodeGetWindow(frameElement);
    }

    if (TP.isValid(matrix) && TP.isTrue(wants2DMatrix)) {
        return TP.matrixAs2DMatrix(matrix);
    }

    return matrix;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowForceRepaint',
function(aWindow) {

    /**
     * @method windowForceRepaint
     * @summary Forces the repaint of the supplied window. This is sometimes
           necessary on certain browser platforms when the window isn't focused
           or is hidden, but a repaint is required.
     * @param {Window} aWindow The window to force a repaint of.
     * @exception TP.sig.InvalidWindow
     * @exception TP.sig.InvalidDocument
     */

    var doc,
        bodyElem;

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (!TP.isDocument(doc = aWindow.document)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    bodyElem = TP.documentGetBody(doc);
    if (TP.isElement(bodyElem)) {
        bodyElem.style.display = 'none';

        //  No need to capture the value here - just touch the slot
        bodyElem.offsetHeight;

        bodyElem.style.display = 'block';
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowGetLocation',
function(aWindow, trimFile) {

    /**
     * @method windowGetLocation
     * @summary Returns the supplied window's true location, optionally minus
     *     any file reference. This method relies on TP.documentGetLocation. See
     *     that function for more information.
     * @param {Window} aWindow The window to search.
     * @param {Boolean} trimFile True will cause any file reference to be
     *     trimmed, returning only a directory. Default is false.
     * @returns {String} The window's true location.
     */

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    return TP.documentGetLocation(aWindow.document, trimFile);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowGetParentNames',
function(aWindow) {

    /**
     * @method windowGetParentNames
     * @summary Returns the list of parent window/frame names for the window
     *     provided. This data is used in building a global ID.
     * @param {Window} aWindow The window to fetch parent names for.
     * @exception TP.sig.InvalidWindow
     * @returns {String[]} The names of all of the parent windows of aWindow all
     *     the way up to the top level window containing it.
     */

    var arr,
        topWin,
        win;

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    arr = TP.ac();

    topWin = aWindow.$$topWindow;
    if (TP.notValid(topWin)) {
        topWin = TP.topWindow;
    }

    //  If the window is the top level window, just return an empty array here.
    if (aWindow === topWin) {
        return arr;
    }

    win = aWindow.parent;

    //  While the parent window isn't the top window, add its name to the
    //  list.
    while (win !== topWin) {
        //  NOTE that this will assign unique names to intermediate frames
        arr.push(TP.lid(win));
        win = win.parent;
    }

    //  Go ahead and add the top-level window's name to our array.
    arr.push(TP.lid(topWin));

    //  Reverse the array so that top's name is first, followed by all of the
    //  frames between top and ourselves in descending order, followed by our
    //  name.
    arr.reverse();

    return arr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowGetScreenWidthAndHeight',
function(aWindow) {

    /**
     * @method windowGetScreenWidthAndHeight
     * @summary Obtains the width and height of the screen that contains the
     *     supplied window.
     * @param {Window} aWindow The window whose screen the width and height will
     *     be obtained.
     * @exception TP.sig.InvalidWindow
     * @returns {Number[]} An ordered pair containing the width amount in the
     *     first position and the height amount in the second position.
     */

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    return TP.ac(aWindow.screen.availWidth, aWindow.screen.availHeight);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowInstallBackspaceHook',
function(aWindow) {

    /**
     * @method windowInstallBackspaceHook
     * @summary Configures the top level window(s) so that keydown (in the case
     *     of IE) or keypress (in the case of Mozilla) with the 'backspace' key
     *     received by the window itself will not cause TIBET to be flushed back
     *     to its frameset.
     * @param {Window} aWindow The window to configure.
     * @exception TP.sig.InvalidWindow
     */

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    //  Set up key handlers for 'keypress' and 'keydown' (depending on the
    //  browser) aWindow's documentElement (or body) so that backspace
    //  won't cause TIBET to be flushed back to its frameset.
    aWindow.document.documentElement.addEventListener(
        'keypress',
        function(anEvent) {

            if (TP.eventGetKeyCode(anEvent) === TP.BACK_SPACE_KEY &&
                TP.eventGetTarget(anEvent) === this) {
                anEvent.preventDefault();
            }
        }, false);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowInstallFocusHook',
function(aWindow) {

    /**
     * @method windowInstallFocusHook
     * @summary Configures the top level window(s) so that focus will check to
     *     make sure that what TIBET considers to be the focused element will
     *     actually be focused and be present on the focus stack.
     * @param {Window} aWindow The window to install the focus hook onto.
     * @exception TP.sig.InvalidWindow
     */

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    aWindow.addEventListener(
        'focus',
        function(anEvent) {

            var focusedElemIncludingActive,
                focusedElemNotIncludingActive;

            //  If we're in the middle of focusing a calculated element, then
            //  don't try to focus possibly something else in the middle of that
            //  process.
            if (TP.isValid(
                TP.dom.UIElementNode.get('$calculatedFocusingTPElem'))) {
                return;
            }

            //  Grab what TIBET considers to be the 'focused element' in both
            //  forms - including whatever element has the '.activeElement'
            //  property and not including whatever element has the
            //  '.activeElement' property.
            focusedElemIncludingActive =
                TP.documentGetFocusedElement(this.document);
            focusedElemNotIncludingActive =
                TP.documentGetFocusedElement(this.document, false);

            //  If they aren't *identical*, then investigate further.
            if (focusedElemIncludingActive !== focusedElemNotIncludingActive) {

                //  If the focused element including the '.activeElement'
                //  property is an Element, but the one not including the
                //  '.activeElement' property is not, then that means there was
                //  a 'native XHTML element' that was focused when the window
                //  was blurred, and we now need to refocus on that.
                if (TP.isElement(focusedElemIncludingActive) &&
                    !TP.isElement(focusedElemNotIncludingActive)) {

                    //  Wrap the element to focus and use the *TIBET* focusing
                    //  machinery to focus it - this will cause the focus stack,
                    //  etc. to be maintained properly.
                    TP.wrap(focusedElemIncludingActive).focus();
                }
            }

        }, false);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowInstallShutdownFinalizationHook',
function(aWindow) {

    /**
     * @method windowInstallShutdownFinalizationHook
     * @summary Installs the 'shutdown finalization' hook that will complete
     *     the shut down of the TIBET application when the user navigates away
     *     from it.
     * @param {Window} aWindow The window to install the shutdown finalization
     *     hook onto.
     * @exception TP.sig.InvalidWindow
     */

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    aWindow.addEventListener(
        'unload',
        function() {

            TP.sys.finalizeShutdown();

            return;
        },
        false);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowIsInstrumented',
function(aWindow) {

    /**
     * @method windowIsInstrumented
     * @summary Checks to see whether the supplied native window has been
     *     instrumented (that is, provided with TIBET window features.
     * @param {Window} aWindow The window to test.
     * @returns {Boolean} Whether or not the supplied native window has been
     *     instrumented.
     */

    //  check out the window...might not be a window ;)
    if (!TP.isWindow(aWindow)) {
        return false;
    }

    //  the $$instrumented flag is true when instrumentation is in place
    return TP.isTrue(aWindow.$$instrumented);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowIsVisible',
function(aWindow) {

    /**
     * @method windowIsVisible
     * @summary Checks to see whether the supplied native window is visible to
     *     the user.
     * @param {Window} aWindow The window to test.
     * @returns {Boolean} Whether or not the supplied native window is visible
     *     to the user.
     */

    //  check out the window...might not be a window ;)
    if (!TP.isWindow(aWindow)) {
        return false;
    }

    //  There are some checks we do because environments, such as Chrome
    //  Devtools, lie to us when using 'visibilityState' (i.e. the 'devtools
    //  page' is 'visible' when it's really not).
    if (TP.sys.inExtension() === true) {
        if (aWindow === TP.topWindow ||
            aWindow === TP.sys.getWindowById('uiroot') ||
            aWindow === TP.sys.getWindowById('uiboot')) {
            return false;
        }
    }

    //  As a fallback, we leverage visibility state.
    return aWindow.document.visibilityState === 'visible';
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowMoveBy',
function(aWindow, deltaX, deltaY) {

    /**
     * @method windowMoveBy
     * @summary Moves the window by the deltaX and deltaY amounts provided.
     * @param {Window} aWindow The window to move.
     * @param {Number} deltaX The X amount to move the window by.
     * @param {Number} deltaY The Y amount to move the window by.
     * @exception TP.sig.InvalidWindow
     * @exception TP.sig.InvalidNumber
     */

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (!TP.isNumber(deltaX) || !TP.isNumber(deltaY)) {
        return TP.raise(this, 'TP.sig.InvalidNumber');
    }

    aWindow.moveBy(deltaX, deltaY);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowMoveTo',
function(aWindow, x, y) {

    /**
     * @method windowMoveTo
     * @summary Moves the window to the X and Y coordinates provided.
     * @param {Window} aWindow The window to move.
     * @param {Number} x The X coordinate to move the window to.
     * @param {Number} y The Y coordinate to move the window to.
     * @exception TP.sig.InvalidWindow
     * @exception TP.sig.InvalidNumber
     */

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (!TP.isNumber(x) || !TP.isNumber(y)) {
        return TP.raise(this, 'TP.sig.InvalidNumber');
    }

    aWindow.moveTo(x, y);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('windowRefreshContentFrom',
function(aWindow, anHref) {

    /**
     * @method windowRefreshContentFrom
     * @summary Looks for content within the supplied Window that is associated
     *     with the supplied href and refreshes it on the page.
     * @param {Window} aWindow The window to reset the location of.
     * @param {String} anHref The href to search in the Window for associated
     *     content.
     * @exception TP.sig.InvalidWindow
     * @exception TP.sig.InvalidURI
     * @exception TP.sig.InvalidDocument
     * @exception TP.sig.InvalidElement
     */

    var doc,

        elemsWithTTag,
        url,

        i,

        elemType,
        elemURI,

        resp,
        domDoc,

        newElem,

        tpElem;

    if (!TP.isWindow(aWindow)) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    doc = aWindow.document;

    //  Compute a file URL
    if (!TP.isURI(url = TP.uc(anHref))) {
        return TP.raise(this, 'TP.sig.InvalidURI');
    }

    //  See if this file is associated with content currently being displayed in
    //  the window.

    //  Get all of the elements that have a 'tibet:tag' attribute.
    elemsWithTTag = TP.byCSSPath('*[tibet|tag]', doc, false, false);

    //  Iterate over those and see if any of them match the href.
    for (i = 0; i < elemsWithTTag.getSize(); i++) {

        //  Grab the element's type.
        if (!TP.isType(elemType = TP.wrap(elemsWithTTag.at(i)).getType())) {
            return TP.raise(this, 'TP.sig.InvalidType');
        }

        //  Grab the element's 'template' resource URI - if it's equal to the
        //  URL that just changed, then we need to reprocess / refresh.
        elemURI = elemType.getResourceURI('template');
        if (elemURI.equalTo(url)) {

            //  Grab an X(HT)ML document from the resource's result.
            resp = url.getResource(TP.hc('async', false, 'resultType', TP.DOM));
            domDoc = resp.get('result');

            if (!TP.isDocument(domDoc)) {
                return TP.raise(this, 'TP.sig.InvalidDocument');
            }

            if (!TP.isElement(newElem = domDoc.documentElement)) {
                return TP.raise(this, 'TP.sig.InvalidElement');
            }

            //  Compile the tag
            tpElem = TP.wrap(newElem);
            tpElem.compile();

            //  Extract the new tag from the document.
            newElem = domDoc.documentElement;

            //  Merge the attributes from the existing element onto the new
            //  element and replace the old with the new.
            TP.elementMergeAttributes(elemsWithTTag.at(i), newElem);
            TP.xmlElementReplaceWith(elemsWithTTag.at(i), newElem);
        }
    }

    return;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETStringPrimitivesPost.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
*/

//  ------------------------------------------------------------------------

/*
TIBET defines versions of these for IE since they're not built-in. These
IE-specific extensions to ensure consistency between browsers.

The atob/btoa implementations here were adapted from the JS/DHTML Cookbook
by Danny Goodman (O'Reilly).
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('atob',
    TP.hc(
    TP.DEFAULT,
    function(aString) {

        /**
         * @method atob
         * @summary An implementation of the atob function found in Gecko which
         *     takes a Base64-encoded ascii string and decodes it to binary
         *     form.
         * @param {String} aString The string to convert.
         * @returns {Object} A decoded String.
         */

        //  For other browsers, this is built-in.
        try {
            return atob(aString);
        } catch (e) {
            return;
        }
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('btoa',
    TP.hc(
    TP.DEFAULT,
    function(anObject) {

        /**
         * @method btoa
         * @summary An implementation of the btoa function found in Mozilla
         *     which converts an object to a Base64-encoded string
         *     representation.
         * @param {Object} anObject The Object to convert. The string
         *     representation of this object will be encoded.
         * @returns {String} A Base64-encoded String.
         */

        //  For other browsers, this is built-in.
        return btoa(anObject);
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('utf82unicode',
function(utf8) {

    /**
     * @method utf82unicode
     * @summary Decode UTF-8 argument into Unicode string return value.
     * @param {String} utf8 A UTF-8 encoded string to translate.
     * @returns {String} The Unicode representation of utf8.
     */

    var str,
        i,

        b1,
        b2,
        b3;

    str = '';
    i = 0;

    /* eslint-disable no-extra-parens */

    while (i < utf8.length) {
        b1 = utf8.charCodeAt(i);
        if (b1 < 0x80) {
            //  One byte code: 0x00 0x7F
            str += String.fromCharCode(b1);
            i++;
        } else if ((b1 >= 0xC0) && (b1 < 0xE0)) {
            //  Two byte code: 0x80 - 0x7FF
            b2 = utf8.charCodeAt(i + 1);
            str += String.fromCharCode(((b1 & 0x1F) << 6) | (b2 & 0x3F));
            i += 2;
        } else {
            //  Three byte code: 0x800 - 0xFFFF
            b2 = utf8.charCodeAt(i + 1);
            b3 = utf8.charCodeAt(i + 2);
            str += String.fromCharCode(((b1 & 0xF) << 12) |
                             ((b2 & 0x3F) << 6) | (b3 & 0x3F));
            i += 3;
        }
    }

    /* eslint-enable no-extra-parens */

    return str;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('utf8decode',
function(str) {

    /**
     * @method utf8decode
     * @summary Decode a string encoded with TP.utf8encode above.
     * @description If the string begins with the sentinel character 0x9D
     *     (OPERATING SYSTEM COMMAND), then we decode the balance as a UTF-8
     *     stream. Otherwise, the string is output unchanged, as it's guaranteed
     *     to contain only 8 bit characters excluding 0x9D.
     * @param {String} str A UTF-8 encoded string to decode.
     * @returns {String} A decoded Javascript string.
     */

    if (str.length > 0 && str.charCodeAt(0) === 0x9D) {
        return TP.utf82unicode(str.substring(1));
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('utf8encode',
function(str) {

    /**
     * @method utf8encode
     * @summary Encode string as UTF8 only if it contains a character of 0x9D
     *     (Unicode OPERATING SYSTEM COMMAND) or a character greater than 0xFF.
     * @description This permits all strings consisting exclusively of 8 bit
     *     graphic characters to be encoded as themselves. We choose 0x9D as the
     *     sentinel character as opposed to one of the more logical PRIVATE USE
     *     characters because 0x9D is not overloaded by the regrettable
     *     "Windows-1252" character set. Now such characters don't belong in
     *     JavaScript strings, but you never know what somebody is going to
     *     paste into a text box, so this choice keeps Windows-encoded strings
     *     from bloating to UTF-8 encoding.
     * @param {String} str The string to encode in UTF-8 format.
     * @returns {String} A UTF-8 encoding string.
     */

    var necessary,
        i;

    necessary = false;

    for (i = 0; i < str.length; i++) {
        if (str.charCodeAt(i) === 0x9D ||
            str.charCodeAt(i) > 0xFF) {
            necessary = true;

            break;
        }
    }

    if (!necessary) {
        return str;
    }

    return String.fromCharCode(0x9D) + TP.unicode2utf8(str);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('unicode2utf8',
function(str) {

    /**
     * @method unicode2utf8
     * @summary Encode Unicode argument string as UTF-8 return value
     * @param {String} str A Unicode string to encode.
     * @returns {String} The UTF-8 representation of str.
     */

    var utf8,

        n,
        c;

    utf8 = '';

    for (n = 0; n < str.length; n++) {
        c = str.charCodeAt(n);

        /* eslint-disable no-extra-parens */

        if (c <= 0x7F) {
            //  0x00 - 0x7F:  Emit as single byte, unchanged
            utf8 += String.fromCharCode(c);
        } else if ((c >= 0x80) && (c <= 0x7FF)) {
            //  0x80 - 0x7FF:  Output as two byte code, 0xC0 in first byte
            //                                          0x80 in second byte
            utf8 += String.fromCharCode((c >> 6) | 0xC0);
            utf8 += String.fromCharCode((c & 0x3F) | 0x80);
        } else {
            //  0x800 - 0xFFFF:  Output as three bytes, 0xE0 in first byte
            //                                          0x80 in second byte
            //                                          0x80 in third byte
            utf8 += String.fromCharCode((c >> 12) | 0xE0);
            utf8 += String.fromCharCode(((c >> 6) & 0x3F) | 0x80);
            utf8 += String.fromCharCode((c & 0x3F) | 0x80);
        }

        /* eslint-enable no-extra-parens */
    }

    return utf8;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('stringEscapeSlashes',
function(aStr) {

    /**
     * @method stringEscapeSlashes
     * @summary Escapes any embedded '/' characters in the supplied String.
     * @description This method respects '/'s escaped with '\'s such that they
     *     will not be 'further' escaped.
     * @param {String} aStr The String to escape the '/' character in.
     * @returns {String} The supplied string with the slashes escaped.
     */

    var parts,
        str;

    if (!TP.isString(aStr)) {
        return this.raise('InvalidParameter');
    }

    //  Split on '/', but avoiding quoted ones (i.e. backslashed '/'s).
    parts = aStr.match(/([^\\\][^/]|\\\/)+/g);

    if (TP.notValid(parts)) {
        return aStr;
    }

    str = parts.join('\\/');

    //  Now, join won't put back on leading/trailing '/' chars if they were in
    //  the original string...so verify that here.
    if (aStr.charAt(0) === '/') {
        str = '/' + str;
    }

    if (aStr.charAt(aStr.length - 1) === '/') {
        str = str + '/';
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('stringFindDelimiterIndex',
function(aStr, startDelim, endDelim, startPos) {

    /**
     * @method stringFindDelimiterIndex
     * @summary Finds the ending delimiter that matches (positionally) the
     *     start delimiter. If further start and end delimiters are nested, this
     *     routine will keep searching for the matching end delimiter.
     * @param {String} aStr The string to search.
     * @param {String} startDelim The start delimiter.
     * @param {String} endDelim The end delimiter.
     * @param {String|Number} startPos The position to start from, either a
     *     Number or a String to look for to give the initial starting position.
     * @returns {Number} The index of the end delimiter that positionally
     *     matches the start delimiter or -1 if one can't be found.
     */

    var startInd,

        startTester,
        ind,
        str,
        startCount,

        endSize,

        newStart;

    //  If a Number was supplied as the start position, use it to compute
    //  the position of the first start delimiter.
    if (TP.isNumber(startPos)) {
        startInd = aStr.indexOf(startDelim, startPos);
    } else if (TP.isString(startPos)) {
        //  Otherwise, if it was a String, get its index first, add its size
        //  to that and use that numeric position to compute the position of
        //  the first start delimiter.
        startInd = aStr.indexOf(
                        startDelim,
                        aStr.indexOf(startPos) + startPos.getSize());
    } else {
        //  Otherwise, no initial starting position was supplied, so just
        //  get the position of the first start delimiter starting at the
        //  0th index.
        startInd = aStr.indexOf(startDelim);
    }

    //  Add the size of the start delimiter to 'jump' over it and get the
    //  index to start looking for end delimiters.
    startInd += startDelim.getSize();

    //  Build a RegExp that will match the start delimiter. We use this
    //  below to test to see if chunks have nested start/end delimiters.
    startTester = TP.rc(TP.regExpEscape(startDelim), 'g');

    endSize = endDelim.getSize();

    //  While there are still end delimiters in the String, keep looping.
    while ((ind = aStr.indexOf(endDelim, startInd)) !== TP.NOT_FOUND) {
        //  Slice off a chunk from the current starting index to where we
        //  found an end delimiter.
        str = aStr.slice(startInd, ind);

        //  If there are no more start delimiters in the chunk, exit here
        //  and return the index where we found the ending delimiter.
        if (!startTester.test(str)) {
            return ind;
        } else {
            //  Otherwise, count how many start delimiters there are.
            startCount = str.match(startTester).getSize();

            newStart = ind + endSize;

            //  Start looking for end delimiters beginning just after the
            //  end delimiter that we found. Loop until a) we can no longer
            //  find end delimiters and b) there are still start delimiters
            //  left.
            while ((ind = aStr.indexOf(endDelim, newStart)) !== TP.NOT_FOUND &&
                    startCount > 0) {
                //  We found an end delimiter, so decrease the number of
                //  start delimiters.
                startCount--;

                //  Position ourselves just on the other size of the end
                //  delimiter we found.
                newStart = ind + endSize;
            }

            //  Position the overall starting index to where we found the
            //  end delimiter (subtracting back off the size of the end
            //  delimiter that we added at the end of the loop).
            startInd = newStart - endSize;
        }
    }

    return -1;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('stringMatchRecursive',
function(aString, left, right, flags) {

    /**
     * @method stringMatchRecursive
     * @summary Makes recursive matches within the supplied String, using the
     *     'left' and 'right' RegExps. If the 'flags' parameter is supplied, all
     *     matches are returned, otherwise only the first one is.
     * @description This method was adapted from Steven Levithan's
     *     'matchRecursiveRegExp' routine. Copyright 2007 Steven Levithan, MIT
     *     license.
     * @param {String} aString The string to match recursively on.
     * @param {RegExp} left The RegExp to use to match the 'left' side of each
     *     match.
     * @param {RegExp} right The RegExp to use to match the 'right' side of each
     *     match.
     * @param {String} flags A String that contains the flags used for matching.
     * @returns {String[]} An Array with the matches found.
     */

    var theFlags,
        isGlobal,
        iterator,
        theLeft,

        matches,
        remaining,
        theLastIndex,
        result;

    theFlags = flags || '';

    isGlobal = theFlags.indexOf('g') > -1;
    iterator = TP.rc(left + '|' + right, 'g' + theFlags);
    theLeft = TP.rc(left, theFlags.strip(/g/g));

    matches = TP.ac();

    do {
        remaining = 0;

        /* eslint-disable no-extra-parens */
        while ((result = iterator.exec(aString))) {
            if (theLeft.test(result.at(0))) {
                if (!(remaining++)) {
                    theLastIndex = iterator.lastIndex;
                }
            } else if (remaining > 0) {
                if (!--remaining) {
                    matches.push(aString.slice(theLastIndex, result.index));
                    if (!isGlobal) {
                        return matches;
                    }
                }
            }
        }
        /* eslint-enable no-extra-parens */
    }
    while (remaining > 0 && (iterator.lastIndex = theLastIndex));

    return matches;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('stringSplitSlashesAndRejoin',
function(aPath, joinStr) {

    /**
     * @method stringSplitSlashesAndRejoin
     * @summary Splits the supplied String on '/' and rejoins using the supplied
     *     joining String.
     * @description This method respects '/'s escaped with '\'s such that they
     *     will be treated as 'one component' and will not be split on.
     * @param {String} aPath The path String to split.
     * @param {String} joinStr The String to use to join the parts back
     *     together.
     * @returns {String} The supplied path string, split on '/' (but not escaped
     *     '/'s) and rejoined using the supplied join string.
     */

    var pathParts;

    if (!TP.isString(aPath) || !TP.isString(joinStr)) {
        return this.raise('InvalidParameter');
    }

    //  Split on '/', but avoiding quoted ones (i.e. backslashed '/'s).
    pathParts = aPath.match(/([^\\\][^/]|\\\/)+/g);

    if (TP.notValid(pathParts)) {
        return aPath;
    }

    return pathParts.join(joinStr);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('stringStripANSIControlCharacters',
function(aStr) {

    /**
     * @method stringStripANSIControlCharaters
     * @summary Strips any ANSI control characters from the supplied String.
     * @param {String} aStr The String to strip ANSI control characters from.
     * @returns {String} The supplied string with the ANSI control characters
     *     stripped.
     */

    var dat;

    if (!TP.isString(aStr)) {
        return this.raise('InvalidParameter');
    }

    dat = '' + aStr;

    //  Authoritative removal of all ANSI escape sequences per:
    //  https://superuser.com/questions/380772/removing-ansi-color-codes-from-text-stream

    /* eslint-disable no-control-regex */
    dat = dat.strip(/\x1b\[[\x30-\x3f]*[\x20-\x2f]*[\x40-\x7e]/g).
                strip(/\x1b[PX^_].*?\x1b\\/g).
                strip(/\x1b\][^\a]*(?:\x07|\x1b\\)/g).
                strip(/\x1b[\[\]A-Z\\^_@]/g);

    //  Also, need to remove '<Esc>='
    dat = dat.strip(/\x1b=/g);

    //  And backspaces
    dat = dat.strip(/\x08/g);

    /* eslint-enable no-control-regex */

    return dat;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('stringRegExpComponents',
function(pattern) {

    /**
     * @method stringRegExpComponents
     * @summary Pulls apart a regular expression source string and returns the
     *     components which would normally be passed to 'new RegExp' to create
     *     the related expression.
     * @param {String} pattern The regular expression source string.
     * @returns {String[]} An array containing two strings, the pattern and flags.
     */

    var restr,
        attrs,
        tail;

    if (!TP.isString(pattern)) {
        return this.raise('InvalidParameter', pattern);
    }

    restr = pattern;
    attrs = '';

    if (restr.charAt(0) === '/') {
        tail = restr.slice(restr.lastIndexOf('/') + 1);
        if (TP.notEmpty(tail)) {
            attrs += tail;
        }
        restr = restr.slice(1, restr.lastIndexOf('/'));
    }

    //  Don't duplicate flags or we get no regex back :(.
    attrs = attrs.split('').unique().join('');

    return TP.ac(restr, attrs);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('stringTokenizeUsingDelimiters',
function(aStr, startDelim, endDelim, exprArray, tokenPrefix, tokenSuffix) {

    /**
     * @method stringTokenizeUsingDelimiters
     * @summary Tokenizes chunks of Strings between the supplied start and end
     *     delimiters, places those chunks under numeric keys in the supplied
     *     expression Array and returns the tokenized String.
     * @param {String} aStr The string to tokenize.
     * @param {String} startDelim The start delimiter.
     * @param {String} endDelim The end delimiter.
     * @param {String[]} exprArray The Array to place the tokenized expressions.
     * @param {String} tokenPrefix A prefix to write in before the token's
     *     numeric prefix in the tokenized String.
     * @param {String} tokenSuffix A prefix to write in after the token's
     *     numeric prefix in the tokenized String.
     * @returns {String} The String with chunks tokenized and replaced with the
     *     token prefix, a numeric index and the token suffix.
     */

    var result,

        startSize,
        endSize,

        startIndex,
        anIndex,

        exprCount;

    //  The result will be an Array that we'll push String chunks into.
    result = TP.ac();

    //  Compute the starting and ending delimiter size for later
    //  computations.
    startSize = startDelim.getSize();
    endSize = endDelim.getSize();

    //  We start at the first start delimiter.
    startIndex = aStr.indexOf(startDelim);

    //  If we couldn't find one, we bail out here.
    if (startIndex === TP.NOT_FOUND) {
        return aStr;
    }

    //  Slice from the beginning of the String to the first occurrence of
    //  the start delimiter and add it to our results.
    result.push(aStr.slice(0, startIndex));

    //  The expression Array may already have contents, so we start the
    //  numbering scheme at the first available position (the end).
    exprCount = exprArray.getSize();

    //  Find the index for the matching ending delimiter.
    while ((anIndex = TP.stringFindDelimiterIndex(
                    aStr, startDelim, endDelim, startIndex)) !== TP.NOT_FOUND) {
        //  Slice from just over our start delimiter to that index (which
        //  won't include the ending delimiter itself).
        exprArray.push(aStr.slice(startIndex + startSize, anIndex));

        //  Push the prefix, the count and the suffix onto the result
        //  String.
        result.push(tokenPrefix, exprCount++, tokenSuffix);

        //  If we can't find another starting delimiter, break out.
        if ((startIndex = aStr.indexOf(
                            startDelim, anIndex + endSize)) === TP.NOT_FOUND) {
            break;
        }

        //  Push the result of slicing from just after the end delimiter to
        //  the next start index.
        result.push(aStr.slice(anIndex + endSize, startIndex));
    }

    //  Push the remainder of our String onto the results.
    result.push(aStr.slice(anIndex + endSize));

    //  Return the result, but join() it first to convert from an Array to a
    //  String.
    return result.join('');
});

//  ------------------------------------------------------------------------

TP.definePrimitive('stringUnescapeSlashes',
function(aStr) {

    /**
     * @method stringUnescapeSlashes
     * @summary Unescapes any embedded escaped '/' characters in the supplied
     *     String.
     * @param {String} aStr The String to unescape the '/' character in.
     * @returns {String} The supplied string with the escaped slashes unescaped.
     */

    var result;

    if (!TP.isString(aStr)) {
        return this.raise('InvalidParameter');
    }

    result = aStr.replace(/\\\//g, '\/');

    return result;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('stringUntokenizeUsingDelimiters',
function(aStr, startDelim, endDelim, exprArray, tokenPrefix, tokenSuffix) {

    /**
     * @method stringUntokenizeUsingDelimiters
     * @summary Untokenizes chunks of Strings that were tokenized by the
     *     TP.stringTokenizeUsingDelimiters() method above.
     * @param {String} aStr The string to untokenize.
     * @param {String} startDelim The start delimiter.
     * @param {String} endDelim The end delimiter.
     * @param {String[]} exprArray The Array to fetch the tokenized expressions
     *     from.
     * @param {String} tokenPrefix The prefix that got written in before the
     *     token's numeric prefix in the tokenized String.
     * @param {String} tokenSuffix The suffix that got written in after the
     *     token's numeric prefix in the tokenized String.
     * @returns {String} The String with the tokenized chunks put back in place.
     */

    //  Run a replace() function on a RegExp that is generated, looking for
    //  Numbers between the token prefix and suffix, replacing those chunks
    //  with the original text from the supplied expression Array.
    return aStr.replace(TP.rc(tokenPrefix + '(\\d+)' + tokenSuffix, 'g'),
                        function(wholeMatch, exprNum) {

                            return startDelim +
                                    exprArray.at(parseInt(exprNum, 10)) +
                                    endDelim;
                        });
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETCSSParser.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
//  CSS Parser - originally from https://github.com/reworkcss/css except small
//  tweaks where noted (with 'wje').
//  ========================================================================

/* eslint-disable */

TP.extern.cssParser = {};
TP.extern.cssParser.parse = function(css, options) {

  // wje (2016-02-16) Moved inside of the closure
  var commentre = /\/\*[^*]*\*+([^/*][^*]*\*+)*\//g

  // http://www.w3.org/TR/CSS21/grammar.html
  // https://github.com/visionmedia/css-parse/pull/49#issuecomment-30088027

  options = options || {};

  /**
   * Positional.
   */

  var lineno = 1;
  var column = 1;

  /**
   * Update lineno and column based on `str`.
   */

  function updatePosition(str) {
    var lines = str.match(/\n/g);
    if (lines) lineno += lines.length;
    var i = str.lastIndexOf('\n');
    column = ~i ? str.length - i : column + str.length;
  }

  /**
   * Mark position and patch `node.position`.
   */

  function position() {
    var start = { line: lineno, column: column };
    return function(node){
      node.position = new Position(start);
      whitespace();
      return node;
    };
  }

  /**
   * Store position information for a node
   */

  function Position(start) {
    this.start = start;
    this.end = { line: lineno, column: column };
    this.source = options.source;
  }

  /**
   * Non-enumerable source string
   */

  Position.prototype.content = css;

  /**
   * Error `msg`.
   */

  var errorsList = [];

  function error(msg) {
    var err = new Error(options.source + ':' + lineno + ':' + column + ': ' + msg);
    err.reason = msg;
    err.filename = options.source;
    err.line = lineno;
    err.column = column;
    err.source = css;

    if (options.silent) {
      errorsList.push(err);
    } else {
      throw err;
    }
  }

  /**
   * Parse stylesheet.
   */

  function stylesheet() {
    var rulesList = rules();

    return {
      type: 'stylesheet',
      stylesheet: {
        source: options.source,
        rules: rulesList,
        parsingErrors: errorsList
      }
    };
  }

  /**
   * Opening brace.
   */

  function open() {
    return match(/^{\s*/);
  }

  /**
   * Closing brace.
   */

  function close() {
    return match(/^}/);
  }

  /**
   * Parse ruleset.
   */

  function rules() {
    var node;
    var rules = [];
    whitespace();
    comments(rules);
    while (css.length && css.charAt(0) != '}' && (node = atrule() || rule())) {
      if (node !== false) {
        rules.push(node);
        comments(rules);
      }
    }
    return rules;
  }

  /**
   * Match `re` and return captures.
   */

  function match(re) {
    var m = re.exec(css);
    if (!m) return;
    var str = m[0];
    updatePosition(str);
    css = css.slice(str.length);
    return m;
  }

  /**
   * Parse whitespace.
   */

  function whitespace() {
    match(/^\s*/);
  }

  /**
   * Parse comments;
   */

  function comments(rules) {
    var c;
    rules = rules || [];
    while (c = comment()) {
      if (c !== false) {
        rules.push(c);
      }
    }
    return rules;
  }

  /**
   * Parse comment.
   */

  function comment() {
    var pos = position();
    if ('/' != css.charAt(0) || '*' != css.charAt(1)) return;

    var i = 2;
    while ("" != css.charAt(i) && ('*' != css.charAt(i) || '/' != css.charAt(i + 1))) ++i;
    i += 2;

    if ("" === css.charAt(i-1)) {
      return error('End of comment missing');
    }

    var str = css.slice(2, i - 2);
    column += 2;
    updatePosition(str);
    css = css.slice(i);
    column += 2;

    return pos({
      type: 'comment',
      comment: str
    });
  }

  /**
   * Parse selector.
   */

  function selector() {
    var m = match(/^([^{]+)/);
    if (!m) return;
    /* @fix Remove all comments from selectors
     * http://ostermiller.org/findcomment.html */
    return trim(m[0])
      .replace(/\/\*([^*]|[\r\n]|(\*+([^*/]|[\r\n])))*\*\/+/g, '')
      .replace(/"(?:\\"|[^"])*"|'(?:\\'|[^'])*'/g, function(m) {
        return m.replace(/,/g, '\u200C');
      })
      .split(/\s*(?![^(]*\)),\s*/)
      .map(function(s) {
        return s.replace(/\u200C/g, ',');
      });
  }

  /**
   * Parse declaration.
   */

  function declaration() {
    var pos = position();

    // prop
    var prop = match(/^(\*?[-#\/\*\\\w]+(\[[0-9a-z_-]+\])?)\s*/);
    if (!prop) return;
    prop = trim(prop[0]);

    // :
    if (!match(/^:\s*/)) return error("property missing ':'");

    // val
    var val = match(/^((?:'(?:\\'|.)*?'|"(?:\\"|.)*?"|\([^\)]*?\)|[^};])+)/);

    var ret = pos({
      type: 'declaration',
      property: prop.replace(commentre, ''),
      value: val ? trim(val[0]).replace(commentre, '') : ''
    });

    // ;
    match(/^[;\s]*/);

    return ret;
  }

  /**
   * Parse declarations.
   */

  function declarations() {
    var decls = [];

    if (!open()) return error("missing '{'");
    comments(decls);

    // declarations
    var decl;
    while (decl = declaration()) {
      if (decl !== false) {
        decls.push(decl);
        comments(decls);
      }
    }

    if (!close()) return error("missing '}'");
    return decls;
  }

  /**
   * Parse keyframe.
   */

  function keyframe() {
    var m;
    var vals = [];
    var pos = position();

    while (m = match(/^((\d+\.\d+|\.\d+|\d+)%?|[a-z]+)\s*/)) {
      vals.push(m[1]);
      match(/^,\s*/);
    }

    if (!vals.length) return;

    return pos({
      type: 'keyframe',
      values: vals,
      declarations: declarations()
    });
  }

  /**
   * Parse keyframes.
   */

  function atkeyframes() {
    var pos = position();
    var m = match(/^@([-\w]+)?keyframes\s*/);

    if (!m) return;
    var vendor = m[1];

    // identifier
    var m = match(/^([-\w]+)\s*/);
    if (!m) return error("@keyframes missing name");
    var name = m[1];

    if (!open()) return error("@keyframes missing '{'");

    var frame;
    var frames = comments();
    while (frame = keyframe()) {
      frames.push(frame);
      frames = frames.concat(comments());
    }

    if (!close()) return error("@keyframes missing '}'");

    return pos({
      type: 'keyframes',
      name: name,
      vendor: vendor,
      keyframes: frames
    });
  }

  /**
   * Parse supports.
   */

  function atsupports() {
    var pos = position();
    var m = match(/^@supports *([^{]+)/);

    if (!m) return;
    var supports = trim(m[1]);

    if (!open()) return error("@supports missing '{'");

    var style = comments().concat(rules());

    if (!close()) return error("@supports missing '}'");

    return pos({
      type: 'supports',
      supports: supports,
      rules: style
    });
  }

  /**
   * Parse host.
   */

  function athost() {
    var pos = position();
    var m = match(/^@host\s*/);

    if (!m) return;

    if (!open()) return error("@host missing '{'");

    var style = comments().concat(rules());

    if (!close()) return error("@host missing '}'");

    return pos({
      type: 'host',
      rules: style
    });
  }

  /**
   * Parse media.
   */

  function atmedia() {
    var pos = position();
    var m = match(/^@media *([^{]+)/);

    if (!m) return;
    var media = trim(m[1]);

    if (!open()) return error("@media missing '{'");

    var style = comments().concat(rules());

    if (!close()) return error("@media missing '}'");

    return pos({
      type: 'media',
      media: media,
      rules: style
    });
  }


  /**
   * Parse custom-media.
   */

  function atcustommedia() {
    var pos = position();
    var m = match(/^@custom-media\s+(--[^\s]+)\s*([^{;]+);/);
    if (!m) return;

    return pos({
      type: 'custom-media',
      name: trim(m[1]),
      media: trim(m[2])
    });
  }

  /**
   * Parse paged media.
   */

  function atpage() {
    var pos = position();
    var m = match(/^@page */);
    if (!m) return;

    var sel = selector() || [];

    if (!open()) return error("@page missing '{'");
    var decls = comments();

    // declarations
    var decl;
    while (decl = declaration()) {
      decls.push(decl);
      decls = decls.concat(comments());
    }

    if (!close()) return error("@page missing '}'");

    return pos({
      type: 'page',
      selectors: sel,
      declarations: decls
    });
  }

  /**
   * Parse document.
   */

  function atdocument() {
    var pos = position();
    var m = match(/^@([-\w]+)?document *([^{]+)/);
    if (!m) return;

    var vendor = trim(m[1]);
    var doc = trim(m[2]);

    if (!open()) return error("@document missing '{'");

    var style = comments().concat(rules());

    if (!close()) return error("@document missing '}'");

    return pos({
      type: 'document',
      document: doc,
      vendor: vendor,
      rules: style
    });
  }

  /**
   * Parse font-face.
   */

  function atfontface() {
    var pos = position();
    var m = match(/^@font-face\s*/);
    if (!m) return;

    if (!open()) return error("@font-face missing '{'");
    var decls = comments();

    // declarations
    var decl;
    while (decl = declaration()) {
      decls.push(decl);
      decls = decls.concat(comments());
    }

    if (!close()) return error("@font-face missing '}'");

    return pos({
      type: 'font-face',
      declarations: decls
    });
  }

  /**
   * Parse import
   */

  var atimport = _compileAtrule('import');

  /**
   * Parse charset
   */

  var atcharset = _compileAtrule('charset');

  /**
   * Parse namespace
   */

  var atnamespace = _compileAtrule('namespace');

  /**
   * Parse non-block at-rules
   */


  function _compileAtrule(name) {
    var re = new RegExp('^@' + name + '\\s*([^;]+);');
    return function() {
      var pos = position();
      var m = match(re);
      if (!m) return;
      var ret = { type: name };
      ret[name] = m[1].trim();
      return pos(ret);
    }
  }

  /**
   * Parse at rule.
   */

  function atrule() {
    if (css[0] != '@') return;

    return atkeyframes()
      || atmedia()
      || atcustommedia()
      || atsupports()
      || atimport()
      || atcharset()
      || atnamespace()
      || atdocument()
      || atpage()
      || athost()
      || atfontface();
  }

  /**
   * Parse rule.
   */

  function rule() {
    var pos = position();
    var sel = selector();

    if (!sel) return error('selector missing');
    comments();

    return pos({
      type: 'rule',
      selectors: sel,
      declarations: declarations()
    });
  }

  return addParent(stylesheet());

/**
 * Trim `str`.
 */

function trim(str) {
  return str ? str.replace(/^\s+|\s+$/g, '') : '';
}

/**
 * Adds non-enumerable parent node reference to each node.
 */

function addParent(obj, parent) {
  var isNode = obj && typeof obj.type === 'string';
  var childParent = isNode ? obj : parent;

  for (var k in obj) {
    // wje (2016-02-16) Added hasOwnProperty() check.
    if (!obj.hasOwnProperty(k)) { continue; }
    var value = obj[k];
    if (Array.isArray(value)) {
      value.forEach(function(v) { addParent(v, childParent); });
    } else if (value && typeof value === 'object') {
      addParent(value, childParent);
    }
  }

  if (isNode) {
    Object.defineProperty(obj, 'parent', {
      configurable: true,
      writable: true,
      enumerable: false,
      value: parent || null
    });
  }

  return obj;
}

};

/* eslint-enable */

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETCSSPrimitivesPre.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 */

/* eslint-disable no-useless-escape */

//  A RegExp that 'captures' the content of 'style' elements.
TP.regex.STYLE_CAPTURE =
        /<style.*?>(?:<!\[CDATA\[)*([\s\S]*?)(?:\]\]>)*<\/style>/g; // needs reset

//  A RegExp that matches CSS 'px' values (or just bare numbers)
TP.regex.CSS_PIXEL = /^-?[\d\.]+(px)?$/i;

//  A RegExp that matches CSS unit values.
TP.regex.CSS_UNIT =
        /(^|\s+)-?([\d\.]+)(%|in|cm|mm|em|ex|pt|pc|px)/;

//  A RegExp that matches 'non-relative' CSS unit values (i.e. '%', 'em'
//  and 'ex' are 'relative' to the element that they're associated with).
TP.regex.CSS_NON_RELATIVE_UNIT =
        /(^|\s+)-?([\d\.]+)(in|cm|mm|pt|pc|px)/;

//  A RegExp that matches CSS hex color values.
TP.regex.CSS_HEX =
        /#?([A-F0-9]{3})?([A-F0-9]{3}){1}$/i;

//  A RegExp that matches CSS RGB color values.
TP.regex.CSS_RGB =
        /rgb\s*\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*\)/;

//  A RegExp that matches CSS RGBA color values.
TP.regex.CSS_RGBA =
        /rgba\s*\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*\,\s*([\d.]+)\s*\)/;

//  A RegExp that matches CSS HSL color values.
TP.regex.CSS_HSL =
        /hsl\s*\(\s*(\d+)\s*,\s*(\d+)%\s*,\s*(\d+)%\s*\)/;

//  A RegExp that matches CSS HSLA color values.
TP.regex.CSS_HSLA =
        /hsla\s*\(\s*(\d+)\s*,\s*(\d+)%\s*,\s*(\d+)%\s*\,\s*([\d.]+)\s*\)/;

//  A RegExp that matches 'non-name' (that is, no semantic 'color name')
//  values.
TP.regex.CSS_NON_NAME_COLOR =
        /(#?([A-F0-9]{3})?([A-F0-9]{3}){1})(\s+|$)|(rgb\s*\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*\))|(rgba\s*\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*\,\s*([\d.]+)\s*\))|(hsl\s*\(\s*(\d+)\s*,\s*(\d+)%\s*,\s*(\d+)%\s*\))|(hsla\s*\(\s*(\d+)\s*,\s*(\d+)%\s*,\s*(\d+)%\s*\,\s*([\d.]+)\s*\))/ig;    // needs reset

//  A RegExp that matches all color values (based on the ones from above).
TP.regex.CSS_COLOR =
        /(#?([A-F0-9]{3})?([A-F0-9]{3}){1})(\s+|$)|(rgb\s*\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*\))|(rgba\s*\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*\,\s*([\d.]+)\s*\))|(hsl\s*\(\s*(\d+)\s*,\s*(\d+)%\s*,\s*(\d+)%\s*\))|(hsla\s*\(\s*(\d+)\s*,\s*(\d+)%\s*,\s*(\d+)%\s*\,\s*([\d.]+)\s*\))|(?:^|\s+)[A-Z]+(?:\s+|$)/i;

//  A global version of TP.CSS_COLOR used for value extraction.
TP.regex.CSS_COLOR_GLOBAL =
        /(#?([A-F0-9]{3})?([A-F0-9]{3}){1})(\s+|$)|(rgb\s*\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*\))|(rgba\s*\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*\,\s*([\d.]+)\s*\))|(hsl\s*\(\s*(\d+)\s*,\s*(\d+)%\s*,\s*(\d+)%\s*\))|(hsla\s*\(\s*(\d+)\s*,\s*(\d+)%\s*,\s*(\d+)%\s*\,\s*([\d.]+)\s*\))|(?:^|\s+)[A-Z]+(?:\s+|$)/ig;   // needs reset
/* eslint-enable no-useless-escape */

TP.regex.CSS_TRANSFORM =
        /^(matrix|rotate|scale|skewX|skewY|translate)\s*\(.+?\)$/;

//  A RegExp that matches TIBET-defined CSS 'gradients'
TP.regex.CSS_GRADIENT = /^(gradient-linear|gradient-radial)\s*\(.+?\)$/;

//  A RegExp that matches TIBET-defined CSS 'patterns'
TP.regex.CSS_PATTERN = /^pattern\s*\(.+?\)$/;

//  A RegExp that matches CSS2 combinators
TP.regex.COMBINATOR = /\s*[>+~\s]+\s*/;

//  A RegExp that matches CSS attribute selector names and values.
TP.regex.ATTR_SELECTOR =
        /\[([\w|:]+)([~=|*^$]*)['"]*(\w*)['"]*/g;   // needs reset

//  A RegExp that will detect native custom selectors or native custom
//  declarations.
TP.regex.CSS_NATIVE_CUSTOM = /-(moz|ms|webkit)/;

//  A RegExp that will strip any non-native prefixed declarations, so that
//  we don't actually strip '-moz'/'-ms'/'-webkit' declarations as being
//  'custom'
TP.regex.CUSTOM_DECLARATIONS =
        /(^|\s+)-((?!moz|ms|webkit)[-\w]+)\s*:\s*([^;]+);?/g;   // needs reset

//  A RegExp that matches 'custom' CSS declaration names (that is, those
//  with a preceding dash ('-'), but not ones native to Mozilla/IE/Safari).
//  Note that we don't use any of the grouping here
TP.regex.CUSTOM_DECLARATIONS_NAME =
        /^-((?!moz|ms|webkit)[-\w]+)/;

//  A RegExp that matches 'custom' declaration values that can be processed
//  by TIBET's CSS processing machinery
TP.regex.CUSTOM_DECLARATIONS_VALUE =
        /^((?!attr|var|calc|hsl|hsla)\(|url\(~)/;

//  A RegExp that matches PNG image URLs.
TP.regex.CSS_PNG_IMAGE =
        /(^|\s+|;)(.+image:)\s*(url\()?['"]?(.*?\.png)['"]?(\))?;?/g;   // needs reset

//  NB: This stuff should be removed when the CSS processor is redone
//  Note that we need to use older 'new RegExp' syntax here because of
//  bootstrapping issues.
TP.regex.PCLASS_CONVERSION = new RegExp(':(hover|active|focus)', 'g');  // needs reset

TP.regex.UNSUPPORTED_SELECTOR = new RegExp(':()');

//  ------------------------------------------------------------------------

TP.definePrimitive('$escapeCSSConstructs',
function(aString) {

    /**
     * @method $escapeCSSConstructs
     * @summary This method escapes any HTML 'link' elements pointing to
     *     stylesheets and any @import style rules so that they don't cause
     *     problems with premature loading while being processed in various
     *     parts of the TIBET content processing system. Failure to do this will
     *     crash Mozilla-based browers. We do the work consistently across
     *     browsers to avoid having inconsistent markup to support when
     *     searching for link or style elements in processed markup.
     * @param {String} aString The string to escape values in.
     * @returns {String} A new string with CSS constructs escaped.
     */

    return aString;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$unescapeCSSConstructs',
function(srcText) {

    /**
     * @method $unescapeCSSConstructs
     * @summary Reverses the work done by the $escapeCSSConstructs() method.
     *     See that method's description for more details.
     * @param {String} srcText The source text to find the constructs to
     *     unescape.
     * @exception TP.sig.InvalidString
     * @returns {String} The source text with the HTML 'style', HTML 'link'
     *     elements and. @import style rules escaped.
     */

    //  Just return the srcText
    return srcText;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$nodeEscapeCSSConstructs',
function(aNode) {

    /**
     * @method $nodeEscapeCSSConstructs
     * @summary This method escapes any HTML 'link' elements pointing to
     *     stylesheets and any @import style rules so that they don't cause
     *     problems with premature loading while being processed in various
     *     parts of the TIBET content processing system. Failure to do this will
     *     crash Mozilla-based browers. We do the work consistently across
     *     browsers to avoid having inconsistent markup to support when
     *     searching for link or style elements in processed markup.
     * @param {Node} aNode A native node to potentially escape.
     * @returns {Node} The node, or a new node with CSS constructs escaped.
     */

    var node,
        list,
        str,
        rep;

    //  if we don't make any changes we want to return the original node
    node = aNode;

    //  only applicable to XHTML content
    if (TP.nodeGetNSURI(node) !== TP.w3.Xmlns.XHTML) {
        return node;
    }

    list = node.getElementsByTagNameNS(TP.w3.Xmlns.XHTML, 'head');
    if (TP.isEmpty(list)) {
        return node;
    }

    list = node.getElementsByTagNameNS(TP.w3.Xmlns.XHTML, 'link');
    if (TP.isEmpty(list)) {
        list = node.getElementsByTagNameNS(TP.w3.Xmlns.XHTML, 'style');
        if (TP.isEmpty(list)) {
            return node;
        }
    }

    //  going to have to do the work since we found at least one link or
    //  style element
    str = TP.str(node);
    rep = TP.$escapeCSSConstructs(str);

    //  turn the result back into the same node type we got as input
    if (TP.isDocument(aNode)) {
        node = TP.documentFromString(rep, null, true);
        if (!TP.isDocument(node)) {
            TP.raise(this,
                        'TP.sig.InvalidDocument',
                        'Unable to escape style. Missing CDATA block?');

            return;
        }
    } else {
        node = TP.nodeFromString(rep, null, true);
        if (!TP.isNode(node)) {
            TP.raise(this,
                        'TP.sig.InvalidNode',
                        'Unable to escape style. Missing CDATA block?');

            return;
        }
    }

    return node;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('calculateSingleCSSSelectorSpecificity',
function(singleSelectorText) {

    /**
     * @method calculateSingleSelectorSpecificity
     * @summary Calculates the specificity of CSS selectors per the algorithms
     *     at: http://www.w3.org/TR/css3-selectors/#specificity
     * @description This code is a TIBETized version of:
     *     https://github.com/keeganstreet/specificity
     *     The MIT License (MIT)
     *     Copyright (c) 2016 Keegan Street and others
     * @param {String} singleSelectorText The 'single selector' to compute the
     *     specificity for. Note that this means that the selector shouldn't be
     *     a comma-separated (',') selector.
     * @returns {Object} Returns an object with the following properties:
     *     selector: the input
     *     specificity: e.g. 0,1,0,0
     *     parts: array with details about each part of the selector that counts
     *     towards the specificity
     *     specificityArray: e.g. [0, 1, 0, 0]
     */

    var selector,
        findMatch,
        typeCount,
        parts,
        attributeRegex,
        idRegex,
        classRegex,
        pseudoElementRegex,
        pseudoClassWithBracketsRegex,
        pseudoClassRegex,
        elementRegex;

    selector = singleSelectorText;

    typeCount = {
        a: 0,
        b: 0,
        c: 0
    };

    parts = TP.ac();

    /* eslint-disable no-useless-escape */

    //  The following regular expressions assume that selectors matching the
    //  preceding regular expressions have been removed.
    attributeRegex = /(\[[^\]]+\])/g;
    idRegex = /(#[^\s\+>~\.\[:]+)/g;
    classRegex = /(\.[^\s\+>~\.\[:]+)/g;
    pseudoElementRegex =
        /(::[^\s\+>~\.\[:]+|:first-line|:first-letter|:before|:after)/gi;

    //  A regex for pseudo classes with brackets - :nth-child(),
    //  :nth-last-child(), :nth-of-type(), :nth-last-type(), :lang()
    pseudoClassWithBracketsRegex = /(:[\w-]+\([^\)]*\))/gi;

    //  A regex for other pseudo classes, which don't have brackets
    pseudoClassRegex = /(:[^\s\+>~\.\[:]+)/g;

    elementRegex = /([^\s\+>~\.\[:]+)/g;

    //  Find matches for a regular expression in a string and push their
    //  details to parts
    //  Type is "a" for IDs, "b" for classes, attributes and pseudo-classes
    //  and "c" for elements and pseudo-elements
    findMatch = function(regex, type) {

        var matches,
            i,
            len,
            match,
            index,
            length;

        if (regex.test(selector)) {

            matches = selector.match(regex);

            len = matches.getSize();

            for (i = 0; i < len; i++) {

                typeCount[type] += 1;
                match = matches[i];
                index = selector.indexOf(match);
                length = match.length;

                parts.push(
                    {
                        selector: singleSelectorText.substr(index, length),
                        type: type,
                        index: index,
                        length: length
                    });

                //  Replace this simple selector with whitespace so it won't
                //  be counted in further simple selectors
                selector = selector.replace(
                                match, Array(length + 1).join(' '));
            }
        }
    };

    //  Replace escaped characters with plain text, using the "A" character
    //  https://www.w3.org/TR/CSS21/syndata.html#characters
    (function() {
        var replaceWithPlainText,
            escapeHexadecimalRegex,
            escapeHexadecimalRegex2,
            escapeSpecialCharacter;

        replaceWithPlainText = function(regex) {
            var matches,
                i,
                len,
                match;

            if (regex.test(selector)) {
                matches = selector.match(regex);
                for (i = 0, len = matches.length; i < len; i += 1) {
                    match = matches[i];
                    selector = selector.replace(
                                match, Array(match.length + 1).join('A'));
                }
            }
        };

        //  Matches a backslash followed by six hexadecimal digits
        //  followed by an optional single whitespace character
        escapeHexadecimalRegex = /\\[0-9A-Fa-f]{6}\s?/g;

        //  Matches a backslash followed by fewer than six hexadecimal
        //  digits followed by a mandatory single whitespace character
        escapeHexadecimalRegex2 = /\\[0-9A-Fa-f]{1,5}\s/g;

        //  Matches a backslash followed by any character
        escapeSpecialCharacter = /\\./g;

        replaceWithPlainText(escapeHexadecimalRegex);
        replaceWithPlainText(escapeHexadecimalRegex2);
        replaceWithPlainText(escapeSpecialCharacter);
    }());

    //  Remove the negation psuedo-class (:not) but leave its argument
    //  because specificity is calculated on its argument
    (function() {
        var regex;

        regex = /:not\(([^\)]*)\)/g;

        if (regex.test(selector)) {
            selector = selector.replace(regex, '     $1 ');
        }
    }());

    //  Remove anything after a left brace in case a user has pasted in a
    //  rule, not just a selector
    (function() {
        var regex,
            matches,
            i,
            len,
            match;

        regex = /{[^]*/gm;

        if (regex.test(selector)) {

            matches = selector.match(regex);

            len = matches.getSize();

            for (i = 0; i < len; i++) {
                match = matches.at(i);
                selector = selector.replace(
                            match, Array(match.length + 1).join(' '));
            }
        }
    }());

    //  Add attribute selectors to parts collection (type b)
    findMatch(attributeRegex, 'b');

    //  Add ID selectors to parts collection (type a)
    findMatch(idRegex, 'a');

    //  Add class selectors to parts collection (type b)
    findMatch(classRegex, 'b');

    //  Add pseudo-element selectors to parts collection (type c)
    findMatch(pseudoElementRegex, 'c');

    //  Add pseudo-class selectors to parts collection (type b)
    findMatch(pseudoClassWithBracketsRegex, 'b');
    findMatch(pseudoClassRegex, 'b');

    //  Remove universal selector and separator characters
    selector = selector.replace(/[\*\s\+>~]/g, ' ');

    //  Remove any stray dots or hashes which aren't attached to words
    //  These may be present if the user is live-editing this selector
    selector = selector.replace(/[#\.]/g, ' ');

    //  The only things left should be element selectors (type c)
    findMatch(elementRegex, 'c');

    //  Order the parts in the order they appear in the original selector
    //  This is neater for external apps to deal with
    parts.sort(function(a, b) {
        return a.index - b.index;
    });

    /* eslint-disable no-extra-parens,no-implicit-coercion */
    return {
        selector: singleSelectorText,
        specificity: '0,' +
                    typeCount.a.toString() + ',' +
                    typeCount.b.toString() + ',' +
                    typeCount.c.toString(),
        specificityArray: TP.ac(0, typeCount.a, typeCount.b, typeCount.c),
        specificityScore:
                //  Increased these by an order of magnitude over the original
                //  version of this code since, yes, we've seen selectors with
                //  10+ class names.
                (typeCount.a * 1000) + (typeCount.b * 100) + (typeCount.c * 10),

        parts: parts
    };
    /* eslint-enable no-extra-parens,no-implicit-coercion */

    /* eslint-enable no-useless-escape */
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$elementCSSFlush',
function(anElement) {

    /**
     * @method $elementCSSFlush
     * @summary Jiggers the element to flush out any CSS changes. IE should do
     *     this automatically, but won't sometimes, especially for 'custom'
     *     attributes.
     * @param {Element} anElement The element to flush the CSS style changes
     *     for.
     * @exception TP.sig.InvalidElement
     */

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('matrixAs2DMatrix',
function(aMatrix) {

    /**
     * @method matrixAs2DMatrix
     * @summary Returns a 3X2 matrix suitable for use with CSS 2D transforms.
     *     If a 3X2 matrix is already supplied, then it is returned. Otherwise,
     *     a 4X4 matrix will be converted into a 3X2 matrix.
     * @description This code derived from:
     *     https://gist.github.com/Yaffle/1145197
     * @param {Number[][]} aMatrix An Array of Arrays representing the matrix.
     * @returns {Number[][]} An Array of Arrays representing the converted matrix.
     */

    var matrix;

    if (aMatrix.length === 2) {
        return aMatrix;
    }

    matrix = [
        [aMatrix[0][0], aMatrix[1][0], aMatrix[0][3]],
        [aMatrix[0][1], aMatrix[1][1], aMatrix[1][3]]
    ];

    return matrix;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('matrixAs3DMatrix',
function(aMatrix) {

    /**
     * @method matrixAs3DMatrix
     * @summary Returns a 4X4 matrix suitable for use with CSS 3D transforms.
     *     If a 4X4 matrix is already supplied, then it is returned. Otherwise,
     *     a 3X2 matrix will be converted into a 4X4 matrix (with identity
     *     values for the missing spots).
     * @description This code derived from:
     *     https://gist.github.com/Yaffle/1145197
     * @param {Number[][]} aMatrix An Array of Arrays representing the matrix.
     * @returns {Number[][]} An Array of Arrays representing the converted matrix.
     */

    var matrix;

    if (aMatrix.length === 4) {
        return aMatrix;
    }

    matrix = [
        [aMatrix[0], aMatrix[1], 0, 0],
        [aMatrix[2], aMatrix[3], 0, 0],
        [0, 0, 1, 0],
        [aMatrix[4], aMatrix[5], 0, 1]
    ];

    return matrix;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('matrixFromCSSString',
function(cssStr, wants2DMatrix) {

    /**
     * @method matrixFromCSSString
     * @summary Extracts a matrix from the supplied CSS string.
     * @description Note that this method will return a 4X4 matrix suitable for
     *     use with CSS 3D transforms. This code derived from:
     *     https://gist.github.com/Yaffle/1145197
     * @param {String} cssStr A CSS string representing a matrix used in CSS
     *     transforms.
     * @param {Boolean} wants2DMatrix An optional parameter that tells the
     *     method whether or not to return a 3x2 matrix for use with CSS 2D
     *     transforms. The default is false.
     * @returns {Number[][]} An Array of Arrays representing the extracted matrix.
     */

    var matrixValues,

        matrix,

        i,
        j;

    if (!/matrix3?d?\(([^\)]+)\)/i.test(cssStr)) {
        return null;
    }

    matrixValues = cssStr.match(/matrix3?d?\(([^\)]+)\)/i)[1].split(',');

    if (matrixValues.length === 6) {
        matrixValues = [
            matrixValues[0], matrixValues[1], 0, 0,
            matrixValues[2], matrixValues[3], 0, 0,
            0, 0, 1, 0,
            matrixValues[4], matrixValues[5], 0, 1
        ];
    }

    matrix = [];

    for (i = 0; i < 4; i++) {
        for (j = 0; j < 4; j++) {
            matrix[i] = matrix[i] || [];
            matrix[i][j] = parseFloat(matrixValues[j * 4 + i]);
        }
    }

    if (TP.isValid(matrix) && TP.isTrue(wants2DMatrix)) {
        return TP.matrixAs2DMatrix(matrix);
    }

    return matrix;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('matrixMultiply',
function(a, b) {

    /**
     * @method matrixMultiply
     * @summary Multiplies the supplied matrices.
     * @description This code derived from: https://gist.github.com/1145197
     *     Note that this method assumes it is operating on a 4X4 matrix suitable
     *     for use with CSS 3D transforms. This code derived from:
     *     https://gist.github.com/Yaffle/1145197
     * @param {Number[][]} a An Array of Arrays representing the first matrix to be
     *     multiplied.
     * @param {Number[][]} b An Array of Arrays representing the first matrix to be
     *     multiplied.
     * @returns {Number[][]} An Array of Arrays representing the multiplied matrix.
     */

    var r,
        i,
        j,
        k,
        t;

    r = [];

    for (i = 0; i < a.length; i++) {
        for (j = 0; j < b[0].length; j++) {
            t = 0;
            for (k = 0; k < a[0].length; k++) {
                t += a[i][k] * b[k][j];
            }

            r[i] = r[i] || [];
            r[i][j] = t;
        }
    }

    return r;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('matrixTranslate',
function(m) {

    /**
     * @method matrixTranslate
     * @summary Translates the supplied matrix.
     * @description This code derived from: https://gist.github.com/1145197
     *     Note that this method assumes it is operating on a 4X4 matrix
     *     suitable for use with CSS 3D transforms. This code derived from:
     *     https://gist.github.com/Yaffle/1145197
     * @param {Number[][]} m An Array of Arrays representing the matrix to be
     *     translated. Varargs values consist of also tx, ty, tz.
     * @returns {Number[][]} An Array of Arrays representing the translated matrix.
     */

    var i,
        j,
        r;

    r = [];

    for (i = 0; i < 4; i++) {
        r[i] = [];

        for (j = 0; j < 4; j++) {
            r[i][j] = m[i][j] + (j === 3 ? arguments[1 + i] || 0 : 0);
        }
    }

    return r;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('matrixTransformPoint',
function(aMatrix, x, y) {

    /**
     * @method matrixTransformPoint
     * @summary Transforms the supplied point values with the supplied matrix.
     * @param {Number[][]} aMatrix An Array of Arrays representing the matrix to be
     *     used in transforming the point.
     * @param {Number} x The X coordinate of the point to transform.
     * @param {Number} y The Y coordinate of the point to transform.
     * @returns {Number[]} An Array of 2 Numbers representing the transformed
     *     point.
     */

    var matrix;

    if (aMatrix.length === 4) {
        matrix = TP.matrixAs2DMatrix(aMatrix);
    } else {
        matrix = aMatrix;
    }

    return [
        matrix[0][0] * x + matrix[0][1] * y + matrix[0][2],
        matrix[1][0] * x + matrix[1][1] * y + matrix[1][2]
    ];
});

//  ------------------------------------------------------------------------

TP.definePrimitive('matrixTransformRect',
function(aMatrix, x, y, width, height) {

    /**
     * @method matrixTransformRect
     * @summary Transforms the supplied rectangle values with the supplied
           matrix.
     * @param {Number[][]} aMatrix An Array of Arrays representing the matrix to
     *     be used in transforming the rectangle.
     * @param {Number} x The X coordinate of the rectangle to transform.
     * @param {Number} y The Y coordinate of the rectangle to transform.
     * @param {Number} width The width of the rectangle to transform.
     * @param {Number} height The height of the rectangle to transform.
     * @returns {Number[]} An Array of 4 Numbers representing the transformed
     *     rectangle.
     */

    var matrix;

    if (aMatrix.length === 4) {
        matrix = TP.matrixAs2DMatrix(aMatrix);
    } else {
        matrix = aMatrix;
    }

    return [
        matrix[0][0] * x + matrix[0][1] * y + matrix[0][2],
        matrix[1][0] * x + matrix[1][1] * y + matrix[1][2],
        matrix[0][0] * width + matrix[0][1] * height,
        matrix[1][0] * width + matrix[1][1] * height
    ];
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETCSSPrimitivesBase.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
*/

//  ------------------------------------------------------------------------
//  DOCUMENT PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('documentAddCSSElement',
function(targetDoc, cssHref, inlineRuleText, shouldSignal) {

    /**
     * @method documentAddCSSElement
     * @summary Adds the appropriate CSS element to the document based on
     *     whether the inlineRuleText parameter is 'true' or not. If it is, the
     *     style text will be retrieved from the cssHref and will be 'inlined'
     *     with an HTML 'style' element in the head of the document.
     * @param {Document} targetDoc The document to which the new element should
     *     be added.
     * @param {String} cssHref The href to use on the newly added CSS element.
     * @param {Boolean} inlineRuleText Whether or not the rule text should be
     *     'inlined' into the document. Defaults to false.
     * @param {Boolean} [shouldSignal=true] If false no signaling occurs.
     * @exception TP.sig.InvalidDocument
     * @returns {HTMLElement} The new link or style element that was added.
     */

    var response,
        cssText,

        newNativeElem;

    if (!TP.isDocument(targetDoc)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  Make sure that the target document has a valid 'head' element or we're
    //  going nowhere.
    TP.documentEnsureHeadElement(targetDoc);

    if (TP.isTrue(inlineRuleText)) {

        //  If inlineRuleText is true, then we load the style rule text
        //  synchronously. If its not empty, we use that style text to add
        //  under a 'style' element.
        response = TP.uc(cssHref).getResource(
                                TP.hc('async', false, 'resultType', TP.TEXT));
        cssText = response.get('result');

        newNativeElem = TP.documentAddCSSStyleElement(
                                targetDoc, cssText, null, shouldSignal);
    } else {
        newNativeElem = TP.documentAddCSSLinkElement(
                                targetDoc, cssHref, null, shouldSignal);
    }

    return newNativeElem;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentAddCSSLinkElement',
function(targetDoc, linkHref, beforeNode, shouldSignal, loadedHandler) {

    /**
     * @method documentAddCSSLinkElement
     * @summary Adds a 'link' element to the target document with the provided
     *     href as the link's href.
     * @param {Document} targetDoc The document to which the new link element
     *     should be added.
     * @param {String} linkHref The href to use on the newly added 'link'
     *     element.
     * @param {Node} beforeNode Optional 'insertion point'.
     * @param {Boolean} [shouldSignal=true] If false no signaling occurs.
     * @param {Function} [loadedHandler] A handler Function that will be called
     *     when the stylesheet that is the resource pointed to by the link is
     *     loaded.
     * @exception TP.sig.InvalidDocument
     * @returns {HTMLElement} The new link element that was added.
     */

    var targetHead,
        newLinkElement,

        before,

        handler;

    if (!TP.isDocument(targetDoc)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  Make sure that the target document has a valid 'head' element or
    //  we're going nowhere.
    targetHead = TP.documentEnsureHeadElement(targetDoc);

    //  Create a new 'link' element.
    newLinkElement = TP.documentConstructElement(targetDoc,
                                                'link',
                                                TP.w3.Xmlns.XHTML);

    TP.elementSetAttribute(newLinkElement, 'type', TP.CSS_TEXT_ENCODED);
    TP.elementSetAttribute(newLinkElement, 'rel', 'stylesheet');

    before = TP.ifInvalid(beforeNode, null);

    //  If we were supplied a handler, then install a listener that will call it
    //  when the stylesheet resource is loaded.
    if (TP.isCallable(loadedHandler)) {
        handler = function(evt) {
            newLinkElement.removeEventListener('load', handler, false);
            loadedHandler();
        };

        newLinkElement.addEventListener('load', handler, false);
    }

    //  We don't have to worry about reassignment of newLinkElement to the
    //  return value of this method since we know we created it in
    //  targetDoc.
    TP.nodeInsertBefore(targetHead, newLinkElement, before, false);

    //  Set the new link element's href to linkHref. This loads the style
    //  sheet rules asynchronously.
    TP.elementSetAttribute(newLinkElement, 'href', linkHref);

    if (TP.notFalse(shouldSignal)) {
        //  Signal from the new element that we added.
        TP.signal(TP.tpdoc(newLinkElement),
                    'TP.sig.MutationStyleChange',
                    TP.hc('mutationTarget', TP.wrap(newLinkElement),
                            'operation', TP.CREATE));
    }

    return newLinkElement;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentAddCSSStyleElement',
function(targetDoc, styleText, beforeNode, shouldSignal) {

    /**
     * @method documentAddCSSStyleElement
     * @summary Adds a 'style' element to the target document with the
     *     optionally provided styleText as the rule text.
     * @param {Document} targetDoc The document to which the new style element
     *     should be added.
     * @param {String} styleText The optional rule text to use in the newly
     *     created style element.
     * @param {Node} beforeNode Optional 'insertion point'.
     * @param {Boolean} [shouldSignal=true] If false no signaling occurs.
     * @exception TP.sig.InvalidDocument
     * @returns {HTMLElement} The new style element that was added.
     */

    var targetHead,
        newStyleElement,

        before;

    if (!TP.isDocument(targetDoc)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  Make sure that the target document has a valid 'head' element or
    //  we're going nowhere.
    targetHead = TP.documentEnsureHeadElement(targetDoc);

    //  Create a new 'style' element
    newStyleElement = TP.documentConstructCSSStyleElement(targetDoc);

    //  Got to do this *before* we try to set the text content of the style
    //  element.

    before = TP.ifInvalid(beforeNode, null);

    //  We don't have to worry about reassignment of newStyleElement to the
    //  return value of this method since we know we created it in
    //  targetDoc.
    TP.nodeInsertBefore(targetHead, newStyleElement, before, false);

    if (TP.isString(styleText)) {
        //  Set the content of the style element to the new style text.
        TP.cssStyleElementSetContent(newStyleElement, styleText, shouldSignal);
    }

    if (TP.notFalse(shouldSignal)) {
        //  Signal from the new element that we added.
        TP.signal(TP.tpdoc(newStyleElement),
                    'TP.sig.MutationStyleChange',
                    TP.hc('mutationTarget', TP.wrap(newStyleElement),
                            'operation', TP.CREATE));
    }

    return newStyleElement;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentConstructCSSStyleElement',
function(targetDoc) {

    /**
     * @method documentConstructCSSStyleElement
     * @summary Constructs a 'style' element on the target document.
     * @param {Document} targetDoc The document to which the new style element
     *     should be added.
     * @exception TP.sig.InvalidDocument
     * @returns {HTMLElement} The new style element that was added.
     */

    var newStyleElement;

    if (!TP.isDocument(targetDoc)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  Create a new 'style' element
    newStyleElement = TP.documentConstructElement(targetDoc, 'style',
                                                    TP.w3.Xmlns.XHTML);

    TP.elementSetAttribute(newStyleElement, 'type', TP.CSS_TEXT_ENCODED);

    return newStyleElement;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentCopyCSSElements',
function(cssElements, targetDoc, shouldSignal) {

    /**
     * @method documentCopyCSSElements
     * @summary Copies style information from the 'link' and 'style' elements
     *     supplied in the element array and creates new 'link' and 'style'
     *     elements with that information in the target document.
     * @param {Element[]} cssElements The Array of 'style' and 'link' elements
     *     that will have their style information copied and used in the target
     *     document.
     * @param {Document} targetDoc The document whose style nodes should be
     *     updated.
     * @param {Boolean} [shouldSignal=true] If false no signaling occurs.
     * @exception TP.sig.InvalidDocument
     * @exception TP.sig.InvalidArray
     */

    var i,
        aCSSElement,

        localName;

    if (!TP.isDocument(targetDoc)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    if (!TP.isArray(cssElements)) {
        return TP.raise(this, 'TP.sig.InvalidArray');
    }

    for (i = 0; i < cssElements.getSize(); i++) {
        aCSSElement = cssElements.at(i);

        localName = TP.elementGetLocalName(aCSSElement).toLowerCase();

        if (localName === 'link') {
            TP.documentCopyCSSLinkElement(
                    aCSSElement, targetDoc, false, false, shouldSignal);
        } else if (localName === 'style') {
            TP.documentCopyCSSStyleElement(
                    aCSSElement, targetDoc, false, false, shouldSignal);
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentCopyCSSLinkElement',
function(anElement, targetDoc, inlineRuleText, onlyIfAbsent, shouldSignal) {

    /**
     * @method documentCopyCSSLinkElement
     * @summary Copies style information from the supplied 'link' element and
     *     creates a new 'link' element with that information in the target
     *     document. NB: The caller *must* supply a 'link' element here, with a
     *     'rel' attribute of 'stylesheet', or an TP.sig.InvalidElement
     *     exception will be thrown.
     * @param {HTMLElement} anElement The 'link' element that should be copied
     *     into the target document.
     * @param {Document} targetDoc The document to which the CSS text should be
     *     added.
     * @param {Boolean} [inlineRuleText=false] Whether or not the rule text
     *     should be 'inlined' into the document.
     * @param {Boolean} [onlyIfAbsent=false] Whether or not the style
     *     element/link should be added only if it doesn't already exist.
     * @param {Boolean} [shouldSignal=true] If false no signaling occurs.
     * @exception TP.sig.InvalidDocument
     * @exception TP.sig.InvalidElement
     */

    var shouldOnlyIfAbsent,

        linkHref,

        targetHead,

        existingLinkElements,
        i,

        sourceDirectory,

        resp,
        cssText,

        newNativeElem;

    if (!TP.isDocument(targetDoc)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.elementGetLocalName(anElement).toLowerCase() !== 'link' ||
        TP.elementGetAttribute(anElement, 'rel') !== 'stylesheet') {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    shouldOnlyIfAbsent = TP.ifInvalid(onlyIfAbsent, false);

    linkHref = TP.elementGetAttribute(anElement, 'href');
    targetHead = targetDoc.getElementsByTagName('head')[0];

    //  If shouldOnlyIfAbsent is true, then we need to make sure that the
    //  target document doesn't already have a 'link' element with an 'href'
    //  equal to linkHref.
    if (TP.isElement(targetHead) && shouldOnlyIfAbsent) {
        existingLinkElements = TP.nodeGetElementsByTagName(targetHead,
                                                            'link');

        for (i = 0; i < existingLinkElements.getSize(); i++) {
            if (existingLinkElements.at(i).rel === 'stylesheet' &&
                TP.elementGetAttribute(
                        existingLinkElements.at(i), 'href') === linkHref) {
                return existingLinkElements.at(i);
            }
        }
    }

    //  Grab the 'source directory' of the text. To do this, we go back to
    //  the document *of the original style element*, grab its location and
    //  then get the collection (i.e. 'directory') URL of that path.
    sourceDirectory = TP.uriCollectionPath(
                            TP.documentGetLocation(
                                TP.nodeGetDocument(anElement)));

    if (TP.isTrue(inlineRuleText)) {

        //  If inlineRuleText is true, then we load the style rule text
        //  synchronously. If its not empty, we use that style text to add
        //  under a 'style' element.

        resp = TP.uc(linkHref).getResource(
                                TP.hc('async', false, 'resultType', TP.TEXT));
        cssText = resp.get('result');

        newNativeElem = TP.documentAddCSSStyleElement(
                                targetDoc,
                                cssText,
                                null,
                                shouldSignal);
    } else {
        newNativeElem = TP.documentAddCSSLinkElement(
                                targetDoc,
                                TP.uriJoinPaths(sourceDirectory, linkHref),
                                null,
                                shouldSignal);
    }

    return newNativeElem;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentCopyCSSStyleElement',
function(anElement, targetDoc, shouldSignal) {

    /**
     * @method documentCopyCSSStyleElement
     * @summary Copies style information from the supplied 'style' element and
     *     creates a new 'style' element with that information in the target
     *     document. NB: The caller *must* supply a 'style' element here, or an
     *     'TP.sig.InvalidElement' exception will be thrown.
     * @param {HTMLElement} anElement The 'style' element that should be copied
     *     into the target document.
     * @param {Document} targetDoc The document to which the CSS text should be
     *     added.
     * @param {Boolean} [shouldSignal=true] If false no signaling occurs.
     * @exception TP.sig.InvalidDocument
     * @exception TP.sig.InvalidElement
     * @returns {HTMLElement|null} The newly added 'style' element if the style
     *     was *not* processed by the CSS processor or null if it was.
     */

    var cssText,

        newNativeElem;

    if (!TP.isDocument(targetDoc)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.elementGetLocalName(anElement).toLowerCase() !== 'style') {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    cssText = TP.cssStyleElementGetContent(anElement);

    newNativeElem = TP.documentAddCSSStyleElement(
                            targetDoc, cssText, null, shouldSignal);

    return newNativeElem;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetNativeCSSElements',
function(aDocument) {

    /**
     * @method documentGetNativeCSSElements
     * @summary Returns the supplied document's style sheet elements, if any.
     *     Note that this returns both 'style' elements and 'link' elements that
     *     have a 'rel' attribute with a value of 'stylesheet'. If the document
     *     has no head element or style elements, this method returns an empty
     *     Array.
     * @param {Document} aDocument The document to use.
     * @exception TP.sig.InvalidDocument
     * @returns {Element[]} An Array of either the 'link' or 'style' elements in
     *     the supplied document.
     */

    var targetHead,

        headElems,

        linkElems,
        res;

    if (!TP.isDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  Make sure that the source document has a valid 'head' element or
    //  we're going nowhere.
    headElems = TP.nodeGetElementsByTagName(aDocument, 'head');
    if (!TP.isElement(targetHead = headElems.at(0))) {
        return TP.ac();
    }

    linkElems = TP.nodeGetElementsByTagName(targetHead, 'link');

    //  Select 'link' elements that are 'stylesheet' links.
    res = linkElems.select(
        function(aLinkElement) {

            if (TP.elementGetAttribute(aLinkElement, 'rel') ===
                                                    'stylesheet' &&
                TP.elementGetAttribute(aLinkElement, 'type') ===
                                                    TP.CSS_TEXT_ENCODED) {
                return true;
            }

            return false;
        });

    //  Add all 'style' elements to the result array.
    res.addAll(TP.nodeGetElementsByTagName(targetHead, 'style'));

    return res;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetNativeStyleRules',
function(aDocument) {

    /**
     * @method documentGetNativeStyleRules
     * @summary Returns all of the CSS style rules for the supplied document.
     *     Because this routine uses the TP.styleSheetGetStyleRules() function,
     *     it will also return any rules found in embedded @import statements in
     *     CSS.
     * @param {HTMLDocument} aDocument The document to retrieve all style rules
     *     for.
     * @exception TP.sig.InvalidDocument
     * @returns {CSSStyleRule[]} The list of CSS rules for the supplied document.
     */

    var allSheets,
        allRules,

        i;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  Grab all of the style sheets in the document, whether they were linked
    //  in or defined in the head of the document. Note that this is given in
    //  'tree order', according to the CSS OM specification.
    allSheets = aDocument.styleSheets;

    allRules = TP.ac();

    //  Loop over the sheets, grabbing each one's rules and adding them all
    //  to our overall collection. Note here how we *do* expand imports, but we
    //  do *not* filter for CSSRule.STYLE_RULE types of rules.
    for (i = 0; i < allSheets.length; i++) {
        allRules.addAll(TP.styleSheetGetStyleRules(allSheets[i]), true, false);
    }

    return allRules;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetStyleRules',
function(aDocument) {

    /**
     * @method documentGetStyleRules
     * @summary Returns all of the CSS style rules for the supplied document.
     * @description If the TP.sys.shouldProcessCSS() flag is 'true' (the
     *     default) this call will return an Array of TP.core.Hashes that
     *     represent all of the rules in this document. If it is false, this
     *     method will return the result of calling
     *     TP.documentGetNativeStyleRules() and the result will be an Array of
     *     native 'rule' objects for this browser.
     * @param {HTMLDocument} aDocument The document to retrieve all style rules
     *     for.
     * @exception TP.sig.InvalidDocument
     * @returns {CSSStyleRule[]} An Array of native browser 'rule' objects
     *     representing the CSS rules for the supplied document.
     */

    return TP.documentGetNativeStyleRules(aDocument);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentInlineCSSURIContent',
function(aDocument, styleURI, inlinedStyleContent, beforeNode, refreshImports) {

    /**
     * @method documentInlineCSSUriContent
     * @summary Adds a 'style' element to the target document with the provided
     *     content as the element's content.
     * @description Note that this method also recursively resolves any @import
     *     statements and inlines their content as well. Additionally, it also
     *     rewrites any CSS 'url(...)' values by resolving them against the
     *     stylesheet's URL.
     * @param {Document} aDocument The document where the inlined CSS content
     *     will be added.
     * @param {TP.uri.URI} styleURI The URI of the original content that the
     *     inlined content will be acting in place of.
     * @param {String} inlinedStyleContent The style content that will be
     *     inlined into the style element.
     * @param {Node} beforeNode Optional 'insertion point'.
     * @param {Boolean} refreshImports Whether or not to refresh the content
     *     from any @import statements from their remote location.
     * @exception TP.sig.InvalidDocument
     * @returns {HTMLElement} The new style element that was added.
     */

    var shouldRefresh,

        inlinedStyleElem,

        docHead,

        addedNewStyleElement,

        processedStyleContent,

        inlinedCollectionLoc,

        processedContentNode;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    shouldRefresh = TP.ifInvalid(refreshImports, false);

    //  First, see if we've processed this style URI into an *XHTML* style
    //  element before. Note that we make sure to go after only HTML style
    //  elements here.
    inlinedStyleElem = TP.byCSSPath('html|style[tibet|originalhref=' +
                                        '"' +
                                        styleURI.getOriginalSource() +
                                        '"]',
                                    aDocument,
                                    true,
                                    false);

    //  If not, create one.
    if (!TP.isElement(inlinedStyleElem)) {

        inlinedStyleElem = TP.documentConstructCSSStyleElement(aDocument);

        //  Track the original source from the URI - this is what the author
        //  originally typed and might be a virtual URI. We'd like to track it
        //  here.
        TP.elementSetAttribute(inlinedStyleElem,
                                'tibet:originalhref',
                                styleURI.getOriginalSource(),
                                true);

        docHead = TP.documentEnsureHeadElement(aDocument);

        //  Insert it into document head. It's empty, but it needs to be there
        //  so that, if we recurse because of '@import' statements below, the
        //  'insertBefore()' will work.
        TP.nodeInsertBefore(docHead,
                            inlinedStyleElem,
                            beforeNode,
                            false);

        addedNewStyleElement = true;
    } else {
        addedNewStyleElement = false;
    }

    processedStyleContent = inlinedStyleContent;

    inlinedCollectionLoc = TP.uriCollectionPath(
                                styleURI.getRootAndPath());

    //  Scan the content for @import rules. If found, resolve their value
    //  against the collection URI of the URI we're currently processing (which
    //  will act as the based) and recursively create a new 'style' element with
    //  that new value, using the element we just created as the 'before
    //  element'. This keeps ordering intact in an attempt to follow CSS
    //  precedence rules.
    TP.regex.CSS_IMPORT_RULE.lastIndex = 0;
    if (TP.regex.CSS_IMPORT_RULE.test(processedStyleContent)) {

        TP.regex.CSS_IMPORT_RULE.lastIndex = 0;
        processedStyleContent = processedStyleContent.replace(
                TP.regex.CSS_IMPORT_RULE,
                function(wholeMatch, leadingText, importLocation) {

                    var importedStyleLocation,
                        importedStyleURI,

                        fetchOptions,
                        importedStyleContent;

                    if (TP.notEmpty(importLocation)) {

                        //  Compute the value for the URL at the end of the
                        //  @import statement by joining it with the 'collection
                        //  location' for the stylesheet it was found in.
                        importedStyleLocation =
                                    TP.uriJoinPaths(
                                        inlinedCollectionLoc,
                                        importLocation);

                        importedStyleURI =
                                    TP.uc(importedStyleLocation);

                        //  Fetch content from the URI's resource

                        //  Note how we force 'refresh' to false, since we'll be
                        //  reading from inlined content.
                        fetchOptions = TP.hc('async', false,
                                                'resultType', TP.TEXT,
                                                'refresh', shouldRefresh);
                        importedStyleContent =
                            importedStyleURI.getResource(
                                        fetchOptions).get('result');

                        //  Recurse, adding a style element for the found URI
                        //  and using the element that we're adding in the outer
                        //  scope as the insertion point.
                        TP.documentInlineCSSURIContent(
                                        aDocument,
                                        importedStyleURI,
                                        importedStyleContent,
                                        inlinedStyleElem,
                                        shouldRefresh);
                    }

                    //  Return the empty String, which will actually remove the
                    //  @import statement from the CSS source text.
                    return '';
                });
    }

    //  Scan the content for url(...) property values. If found, resolve their
    //  value against the collection URI of the URI we're currently processing.
    TP.regex.CSS_URL_PROPERTY.lastIndex = 0;
    if (TP.regex.CSS_URL_PROPERTY.test(processedStyleContent)) {

        TP.regex.CSS_URL_PROPERTY.lastIndex = 0;
        processedStyleContent = processedStyleContent.replace(
                TP.regex.CSS_URL_PROPERTY,
                function(wholeMatch, leadingText, locationValue) {

                    var importedStyleLocation;

                    if (TP.notEmpty(locationValue)) {

                        //  If the url is absolute and starts with a '/'
                        //  (absolute urls can also start with a scheme), then
                        //  it's a 'root relative path'. Expand it after
                        //  prepending a '~app' onto the front of it.
                        if (TP.uriIsAbsolute(locationValue) &&
                            locationValue.startsWith('/')) {
                            importedStyleLocation =
                                TP.uriExpandPath('~app' + locationValue);
                        } else {
                            //  Compute the value for the URL in the url(...)
                            //  property by joining it with the 'collection
                            //  location' for the stylesheet it was found in.
                            importedStyleLocation =
                                        TP.uriJoinPaths(
                                            inlinedCollectionLoc,
                                            locationValue);
                        }
                    }

                    //  Return the String that must exactly replace what the
                    //  RegExp matched (we default to enclosing the value in
                    //  double quotes - the RegExp strips all quoting anyway).
                    return ': ' +
                            'url("' + importedStyleLocation + '")';
                });
    }

    //  Scan the content for url(...) values in general. If found, resolve their
    //  value against the values available for all virtual URIs in TIBET.
    TP.regex.CSS_VIRTUAL_URL_VALUE.lastIndex = 0;
    if (TP.regex.CSS_VIRTUAL_URL_VALUE.test(processedStyleContent)) {

        TP.regex.CSS_VIRTUAL_URL_VALUE.lastIndex = 0;
        processedStyleContent = processedStyleContent.replace(
                TP.regex.CSS_VIRTUAL_URL_VALUE,
                function(wholeMatch, leadingText, locationValue) {

                    var loc;

                    if (TP.notEmpty(locationValue)) {

                        //  Compute the value for the URL in the
                        //  url(...) property by joining it with the
                        //  'collection location' for the stylesheet it
                        //  was found in.
                        loc = TP.uc(locationValue).getLocation();
                    }

                    //  Return the String that must exactly replace what
                    //  the RegExp matched (we default to enclosing the
                    //  value in double quotes - the RegExp strips all
                    //  quoting anyway).
                    return 'url("' + loc + '")';
                });
    }

    if (addedNewStyleElement) {

        if (TP.isXMLDocument(aDocument)) {
            //  Create a CDATA section to hold the processed style content
            processedContentNode =
                aDocument.createCDATASection(processedStyleContent);
        } else {
            //  Create a Text node to hold the processed style content
            processedContentNode =
                aDocument.createTextNode(processedStyleContent);
        }

        //  Append it to the new style element
        TP.nodeAppendChild(inlinedStyleElem, processedContentNode, false);

        //  Awaken it. This will cause the new style element to observe changes
        //  via the 'tibet:originalhref' attribute.
        TP.nodeAwakenContent(inlinedStyleElem);
    } else {

        //  Note how we specify false here to avoid signaling when the content
        //  is set. That makes the semantic match the above where no signaling
        //  occurred (at least the style mutation signaling).
        TP.cssStyleElementSetContent(
            inlinedStyleElem, processedStyleContent, false);
    }

    return inlinedStyleElem;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$documentRefreshAppliedRulesCaches',
function(aDocument, flushCaches) {

    /**
     * @method $documentRefreshAppliedRulesCaches
     * @summary Refreshes all style rules for every element in the document.
     *     The end result of running this function is that every element in the
     *     document will have a 'TP.APPLIED_RULES' property that contains an
     *     Array of CSS style rules that apply to it.
     * @description As this function iterates over every CSS rule in the
     *     document, querying the document for matching elements and then adding
     *     to that element's 'TP.APPLIED_RULES' property with that rule.
     *     Therefore, this can be a time consuming process.
     * @param {HTMLDocument} aDocument The document to refresh all of the
     *     elements of.
     * @param {Boolean} [flushCaches=false] Whether or not we should flush the
     *     element-level rule caches. After this method is executed, elements
     *     will have cached Arrays containing the Rule objects applying to them.
     *     Passing true here will cause those caches to flush.
     * @exception TP.sig.InvalidDocument
     */

    var shouldFlushCaches,

        docRules,

        leni,
        i,
        aRule,

        parentSS,

        styleElem,

        elementsMatchingRule,

        lenj,
        j,
        matchingElement,

        appliedRules;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    shouldFlushCaches = TP.ifInvalid(flushCaches, false);

    //  Grab all of the document's CSS rules.
    docRules = TP.documentGetNativeStyleRules(aDocument);

    //  Iterate over them, querying the document for any elements that match
    //  the selector text of the rule. Then, iterate over those elements and add
    //  the rule to its 'appliedRules' Array.
    leni = docRules.getSize();
    for (i = 0; i < leni; i++) {

        aRule = docRules.at(i);

        //  Not a CSSRule.STYLE_RULE? Must be an @import or a @namespace - move
        //  on.
        if (aRule.type !== CSSRule.STYLE_RULE) {
            continue;
        }

        //  Find the style sheet associated with the element that inserted the
        //  rule's stylesheet (because of @import, it might not be the sheet in
        //  the 'parentStyleSheet' slot of the rule itself).
        parentSS = aRule.parentStyleSheet;
        while (parentSS.parentStyleSheet) {
            parentSS = parentSS.parentStyleSheet;
        }

        styleElem = TP.styleSheetGetOwnerNode(parentSS);

        //  If the stylesheet came from a private TIBET stylesheet (normally
        //  used for IDE or other purposes), then don't consider it.
        if (styleElem[TP.TIBET_PRIVATE]) {
            continue;
        }

        //  Grab any elements that match the rule's selector
        elementsMatchingRule = TP.nodeEvaluateCSS(aDocument,
                                                    aRule.selectorText);

        //  Iterate over those elements, and add the rule object to that
        //  element's list of applicable rules
        lenj = elementsMatchingRule.getSize();
        for (j = 0; j < lenj; j++) {

            if (j === 0 && shouldFlushCaches) {
                matchingElement[TP.APPLIED_RULES] = null;
            }

            matchingElement = elementsMatchingRule.at(j);

            appliedRules = matchingElement[TP.APPLIED_RULES];

            if (TP.notValid(appliedRules)) {
                appliedRules = TP.ac();
                matchingElement[TP.APPLIED_RULES] = appliedRules;
            }

            appliedRules.push(aRule);
            appliedRules.unique();
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentReloadCSSLinkElementHref',
function(aDocument, anHref, shouldSignal) {

    /**
     * @method documentReloadCSSLinkElementHref
     * @summary Reloads any style 'link' element pointing to the supplied
     *     href, if it can be found in the supplied Document.
     * @param {Document} aDocument The document to look for 'link' elements
     *     in.
     * @param {String} anHref The href to try to find to reload.
     * @param {Boolean} [shouldSignal=true] If false no signaling occurs.
     * @exception TP.sig.InvalidDocument
     * @exception TP.sig.InvalidString
     */

    var currentTopLevelLinkElems,

        existingHrefs,

        oldHref,

        len,
        i,

        index,

        linkElem;

    if (!TP.isDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    if (TP.isEmpty(anHref)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    //  Gather the hrefs of the current 'top-level' 'link' elements in the
    //  supplied element's document. The reason we do this rather than just
    //  query for an element's authored 'href=' value is that the '.href'
    //  property will be the *fully expanded* href value and that's the one(s)
    //  we'll need for comparison.
    currentTopLevelLinkElems =
                TP.byCSSPath('link[rel="stylesheet"]', aDocument, false, false);
    existingHrefs = currentTopLevelLinkElems.collect(
                function(anElem) {
                    var href;

                    //  In case a previous run of this method was the generator
                    //  of this element, we need to strip out any 'unique query'
                    //  parameters that we added to force the reload in order to
                    //  do a proper comparison.
                    href = TP.uriRemoveUniqueQuery(anElem.href);

                    return href;
                });

    //  In case a previous run of this method was the generator of this element,
    //  we need to strip out any 'unique query' parameters that we added to
    //  force the reload in order to do a proper comparison.
    oldHref = TP.uriRemoveUniqueQuery(anHref);

    //  If the existing hrefs in the document do not contain the href we're
    //  looking for, then it may be in an @import. Flatten out those @import
    //  statements (recursively), generating a top level 'link' element for each
    //  one (in the order they were found to preserve CSS specificity rules).
    if (!existingHrefs.contains(oldHref)) {

        len = currentTopLevelLinkElems.getSize();
        for (i = 0; i < len; i++) {
            TP.cssLinkElementFlattenImports(currentTopLevelLinkElems.at(i));
        }

        //  Re-run the query. This time, there will be a fully realized value
        //  as the href, so we can use it here.
        currentTopLevelLinkElems =
                TP.byCSSPath('link[rel="stylesheet"][href="' + oldHref + '"]',
                            aDocument,
                            false,
                            false);

        if (TP.isEmpty(currentTopLevelLinkElems)) {
            //  Still couldn't find it even after flattening all of the
            //  referenced @imports. Exit here.
            //  TODO: Raise an exception?
            return;
        }

        //  Requery for the now existing hrefs (we don't need to worry about
        //  detecting and stripping any '_tibet_nocache' prefix here because
        //  these are all new).
        existingHrefs = currentTopLevelLinkElems.collect(
                            function(anElem) {
                                return anElem.href;
                            });
    }

    //  Look for the href in the set of existing hrefs we have. That will be the
    //  same index as the 'link' element that we found or generated.
    index = TP.NOT_FOUND;

    len = existingHrefs.getSize();
    for (i = 0; i < len; i++) {
        if (existingHrefs.at(i) === oldHref) {
            index = i;
            break;
        }
    }

    //  If we actually found an index, then grab the element at that spot, set
    //  it's 'href' to the supplied href, adding a query that will ensure that
    //  any caching is busted and it reloads from the server.
    if (index !== TP.NOT_FOUND) {
        linkElem = currentTopLevelLinkElems.at(index);
        linkElem.href = TP.uriAddUniqueQuery(oldHref);

        if (TP.notFalse(shouldSignal)) {
            //  Signal from the new element that we added.
            TP.signal(TP.tpdoc(linkElem),
                        'TP.sig.MutationStyleChange',
                        TP.hc('mutationTarget', TP.wrap(linkElem),
                                'operation', TP.UPDATE));
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentGetUnusedStyleRules',
function(aDocument) {

    /**
     * @method documentGetUnusedStyleRules
     * @summary Returns all of the unused CSS style rules for the supplied
     *     document.
     * @description This method will get all of the CSS style rules referenced
     *     in a particular Document and see if any elements in that Document
     *     match those rules at the point in time that this method is invoked.
     * @param {HTMLDocument} aDocument The document to retrieve all unused style
     *     rules for.
     * @exception TP.sig.InvalidDocument
     * @returns {CSSStyleRule[]} An Array of native browser 'rule' objects
     *     representing the unused CSS rules for the supplied document.
     */

    var unusedRules,
        allRules,

        selectorText,

        i;

    if (!TP.isHTMLDocument(aDocument) && !TP.isXHTMLDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    unusedRules = TP.ac();

    allRules = TP.documentGetStyleRules(aDocument);

    for (i = 0; i < allRules.getSize(); i++) {

        //  If this is not a CSSRule.STYLE_RULE, then it's probably some kind of
        //  '@' rule and we can't determine whether those are unused or not
        //  without a *much* more sophisticated analysis.
        if (allRules.at(i).type !== CSSRule.STYLE_RULE) {
            continue;
        }

        selectorText = allRules.at(i).selectorText;

        if (TP.isEmpty(TP.nodeEvaluateCSS(aDocument, selectorText))) {
            unusedRules.push(allRules.at(i));
        }
    }

    return unusedRules;
});

//  ------------------------------------------------------------------------
//  ELEMENT PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('elementConvertUnitLengthToPixels',
function(anElement, aValue, targetProperty, wantsTransformed) {

    /**
     * @method elementConvertUnitLengthToPixels
     * @summary A routine that computes a number of pixels from the supplied
     *     CSS unit value.
     * @description Note that the supplied value here must be a 'CSS unit value'
     *     (i.e. '3em' or '27%'). It cannot be a CSS value such as 'normal' or
     *     'inherit'.
     * @param {HTMLElement} anElement The element to use to compute the pixel
     *     value from.
     * @param {String} aValue The size value to convert into pixels.
     * @param {String} targetProperty The name of the property being converted.
     *     This isn't strictly required, but is desired to produce the most
     *     accurate results.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidString
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidStyleDeclaration
     * @returns {Number} The number of pixels that the supplied value will be in
     *     pixels for the supplied Element.
     */

    var targetPropName,

        styleObj,

        elementCurrentStyleVal,
        computedStyle,

        valueInPixels;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(aValue)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    //  If the value is not expressed using 'unit length' (i.e. it is a keyword
    //  such as 'inherit', 'initial', 'none', etc.), then we bail out here -
    //  can't do anything.
    if (!TP.regex.CSS_UNIT.test(aValue)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    targetPropName = TP.ifInvalid(targetProperty, 'left');
    targetPropName = targetPropName.toLowerCase();

    styleObj = TP.elementGetStyleObj(anElement);

    //  Capture the inline 'style' for the target property (note that we're
    //  *not* interested in the computed style here - just if any value has been
    //  placed directly in the target property on the 'style' object, either by
    //  JavaScript or by using the 'style' attribute).
    //  Note that if no value has been specified by either of these mechanisms,
    //  this value will be null (or the empty String).
    elementCurrentStyleVal = styleObj[targetPropName];

    //  Set the target property on element to the supplied value (or 0, if the
    //  value isn't valid).
    styleObj[targetPropName] = aValue || 0;

    //  Grab the computed style for the element.
    if (TP.notValid(computedStyle =
                    TP.elementGetComputedStyleObj(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    //  We wrap this in a try...catch, since sometimes Mozilla throws an
    //  exception when attempting to get the computed value, especially on the
    //  'body' element.
    try {
        //  Get the value in pixels by using the 'getPropertyValue' call of
        //  the computed style, asking for 'pixels' as type of the return value.
        valueInPixels = TP.elementGetPixelValue(
                        anElement,
                        computedStyle.getPropertyValue(targetPropName),
                        targetPropName.asDOMName(),
                        wantsTransformed);
    } catch (e) {
        //  Can't compute the value anyway, so just return 0.
        return 0;
    }

    //  Reset the inline style back to what it was (maybe the empty String...
    //  see above).
    styleObj[targetPropName] = elementCurrentStyleVal;

    //  If the computation returned NaN, be nice and return 0.
    if (TP.isNaN(valueInPixels)) {
        return 0;
    }

    if (TP.isTrue(wantsTransformed)) {
        return TP.elementTransformCSSPixelValue(anElement,
                                                valueInPixels,
                                                targetPropName);
    }

    return valueInPixels;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetComputedStyleObj',
function(anElement) {

    /**
     * @method elementGetComputedStyleObj
     * @summary Returns the computed (resolved) style of the element. The
     *     result of intersecting the various inputs on style which affect the
     *     element in question.
     * @param {Element} anElement The element to inspect.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidDocument
     * @returns {Object} An object whose getPropertyValue function can be used
     *     to get individual style data values.
     */

    var doc;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (!TP.isDocument(doc = TP.nodeGetDocument(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    return TP.nodeGetWindow(doc).getComputedStyle(anElement, null);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetPixelValue',
function(anElement, aValue, targetProperty, wantsTransformed) {

    /**
     * @method elementGetPixelValue
     * @summary A handy routine that returns pixel values regardless of what
     *     the CSS units were. This means that web developers can mix and match
     *     measurement units in their style sheets. it is not uncommon to
     *     express something like padding in "em" units while border thickness
     *     is most often expressed in pixels.
     * @param {HTMLElement} anElement The element to use to compute the pixel
     *     value from.
     * @param {String} aValue The size value to convert into pixels.
     * @param {String} targetProperty The name of the property being converted.
     *     This is only required if a percentage value is given, but is desired
     *     to produce the most accurate results.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @returns {Number} The number of pixels that the supplied value will be in
     *     pixels for the supplied Element. Note that this routine can also
     *     return NaN, if it cannot compute a numeric value.
     */

    var val,

        parentElem,

        results,
        numericPart,
        unitPart,
        pixelsPerPoint;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  No value for this property? Then it's pixel value is 0.
    if (TP.isEmpty(aValue)) {
        return 0;
    }

    val = TP.trim(aValue);

    //  If it's just a pixel value, then we can do a simple parse here and
    //  return.
    if (TP.regex.CSS_PIXEL.test(val)) {
        if (TP.isNaN(results = parseFloat(val))) {
            return 0;
        }

        return TP.isTrue(wantsTransformed) ?
                 TP.elementTransformCSSPixelValue(
                                        anElement,
                                        results,
                                        targetProperty) :
                 results;
    }

    //  If the value is not expressed using 'unit length' (i.e. it is a
    //  keyword such as 'inherit', 'initial', 'none', etc.), then we try to
    //  'do the right thing', based on a property name if one was supplied.
    if (!TP.regex.CSS_UNIT.test(val)) {
        switch (val) {
            case 'inherit':

                //  We inherited the property - return whatever our *parent
                //  node* ('inherit' *always* refers to the parent node) has
                //  as a value for this property.
                if (TP.isElement(parentElem = anElement.parentNode)) {
                    return TP.elementGetPixelValue(parentElem,
                                                    val,
                                                    targetProperty,
                                                    wantsTransformed);
                }

                break;

            case 'initial':
                //  TODO: This is a CSS3 value - what to do here?
                return NaN;

            case 'normal':
                //  TODO: Not sure what to do here
                return NaN;

            case 'thin':
            case 'medium':
            case 'thick':

                //  Could be border values... check further
                if (/border.*?Width/.test(targetProperty)) {
                    switch (val) {
                        case 'thin':
                            results = 2;
                            break;

                        case 'medium':
                            results = 4;
                            break;

                        case 'thick':
                            results = 6;
                            break;

                        default:
                            break;
                    }

                    return TP.isTrue(wantsTransformed) ?
                             TP.elementTransformCSSPixelValue(
                                                    anElement,
                                                    results,
                                                    targetProperty) :
                             results;
                }

                return NaN;

                //  Otherwise, return NaN
            case 'auto':
            case 'none':
            default:
                return NaN;
        }

        return;
    }

    //  If the value is expressed using a 'non-relative' unit measurement
    //  (i.e. not '%', 'em' or 'ex'), then we can try to convert it just
    //  using the 'pixelsPerPoint' computation.
    if (TP.regex.CSS_NON_RELATIVE_UNIT.test(val)) {
        results = TP.regex.CSS_NON_RELATIVE_UNIT.exec(val);
        numericPart = parseFloat(results.at(2));
        unitPart = results.at(3);

        //  Grab the number of 'pixels per point'.
        pixelsPerPoint = TP.getPixelsPerPoint();

        //  Based on the units expressed, return the proper number of
        //  pixels.
        switch (unitPart) {
            case 'pt':

                results = pixelsPerPoint * numericPart;

                break;

            case 'in':

                results = pixelsPerPoint * numericPart * 72;

                break;

            case 'pc':

                results = pixelsPerPoint * numericPart * 12;

                break;

            case 'mm':

                results = pixelsPerPoint * (numericPart / (7.2 / 2.54));

                break;

            case 'cm':

                results = pixelsPerPoint * (numericPart / (72 / 2.54));

                break;

            default:
                break;
        }

        return TP.isTrue(wantsTransformed) ?
                 TP.elementTransformCSSPixelValue(
                                        anElement,
                                        results,
                                        targetProperty) :
                 results;
    }

    //  If it's a percentage value and we've been supplied with a target
    //  property, then we can determine the pixel value by calling a routine
    //  that, based on the property name, will return the correct number of
    //  pixels.
    if (TP.regex.PERCENTAGE.test(val)) {
        if (TP.notValid(targetProperty)) {
            TP.ifError() ?
                TP.error('Percentage computation needs target property',
                            TP.CSS_LOG) : 0;

            return 0;
        }

        return TP.elementGetNumericValueFromPercentage(anElement,
                                                        targetProperty,
                                                        val,
                                                        wantsTransformed);
    }

    return TP.elementConvertUnitLengthToPixels(anElement,
                                                val,
                                                targetProperty,
                                                wantsTransformed);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetPseudoInlineStyleObj',
function(anElement) {

    /**
     * @method elementGetPseudoInlineStyleObj
     * @summary Returns a 'pseudo inline' style object. This is really the
     *     style object from a created CSS rule, since non-(X)HTML elements
     *     don't support the inline '.style' property / the 'style' attribute.
     * @param {HTMLElement} anElement The element to use to compute the pixel
     *     value from.
     * @exception TP.sig.InvalidElement
     * @returns {CSSStyleDeclaration} The inline CSS style object of the
     *     supplied element.
     */

    var result,

        newSheet,

        styleElem,
        styleSheet,
        sheetRules,

        indexNum,
        rule,

        elemID,
        selectorText,

        i;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  See if we have a cached style object corresponding to the 'pseudo inline
    //  style element'. This is faster than computing one each time.
    result = anElement[TP.PSEUDO_INLINE_STYLE];
    if (TP.isValid(result)) {
        return result;
    }

    //  Initially set the flag to say that we haven't created a new sheet.
    newSheet = false;

    //  Try to obtain the style element and its sheet - if its not
    //  available, create one and grab its sheet
    styleElem = TP.nodeGetElementById(TP.nodeGetDocument(anElement),
                                        'pseudo_inline_rules_generated');
    if (!TP.isElement(styleElem)) {
        //  Note here how we pass 'false' as the final parameter to avoid having
        //  this call signal and possibly cause a recursion.
        styleElem = TP.documentAddCSSStyleElement(TP.nodeGetDocument(anElement),
                                                    null,
                                                    null,
                                                    false);
        if (!TP.isElement(styleElem)) {
            //  TODO: Raise an exception and return
            void 0;
        }

        //  Uniquely identify the 'pseudo inline style element'
        TP.elementSetAttribute(
                    styleElem, 'id', 'pseudo_inline_rules_generated');

        //  We did create a new sheet
        newSheet = true;
    }

    //  Grab the style sheet object and its rules.

    styleSheet = TP.cssElementGetStyleSheet(styleElem);

    sheetRules = styleSheet.cssRules;

    //  If the supplied element has a style rule index number, then it
    //  must've been assigned that before
    if (TP.isNumber(indexNum = anElement._pseudoInlineRuleIndex)) {
        //  See if we can locate a rule at that index and make sure its a
        //  'style rule' (i.e. not an AT_RULE or something).
        if (TP.isValid(rule = sheetRules[indexNum]) &&
                rule.type === CSSRule.STYLE_RULE) {
            //  Return the style object associated with the rule.
            result = rule.style;
            anElement[TP.PSEUDO_INLINE_STYLE] = result;

            return result;
        }
    }

    //  Make sure the element has an 'id' attribute and pass true to force
    //  assignment if its not there.
    elemID = TP.lid(anElement, true);

    //  We also use a second attribute to force more specificity.
    TP.elementSetAttribute(anElement, 'pseudo-inline', elemID);

    //  Compute the selector text
    selectorText = '#' + elemID + '[pseudo-inline="' + elemID + '"]';

    //  If we didn't create a new sheet, then maybe we just lost the rule
    //  somewhere in the existing sheet...

    if (!newSheet) {
        //  We didn't create a new sheet - look for a style rule matching
        for (i = 0; i < sheetRules.length; i++) {
            //  If we find a rule that's both a style rule and where the
            //  selector matches, then shove its index onto the element and
            //  return the style object associated with the rule.
            if (sheetRules[i].type === sheetRules[i].STYLE_RULE &&
                sheetRules[i].selectorText === selectorText) {
                rule = sheetRules[i];
                anElement._pseudoInlineRuleIndex = i;

                result = rule.style;
                anElement[TP.PSEUDO_INLINE_STYLE] = result;

                return result;
            }
        }
    }

    //  Create a new rule and add it to the end of the stylesheet.
    TP.styleSheetInsertRule(styleSheet, selectorText, '', null, false);

    sheetRules = styleSheet.cssRules;

    //  The element's rule index will be the last rule's index
    anElement._pseudoInlineRuleIndex = sheetRules.length - 1;

    //  Return the style object associated with the new rule.
    result = sheetRules[sheetRules.length - 1].style;

    //  Cache the style object on the element for faster performance.
    anElement[TP.PSEUDO_INLINE_STYLE] = result;

    return result;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementTransformCSSPixelValue',
function(anElement, pixelValue, aPropertyName) {

    /**
     * @method elementTransformCSSPixelValue
     * @summary Transforms a pixel value from the given value to a value that
     *     takes into account any CSS transformations that have been applied to
     *     the element.
     * @param {HTMLElement} anElement The element to transform the pixel value
     *     against.
     * @param {Number} pixelValue The pixel value to transform.
     * @param {String} aPropertyName The name of the property that the pixel
     *     value came from. This name needs to have one of the following words
     *     in it in order for the value to convert properly: "top", "right",
     *     "bottom", "left".
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidNumber
     * @exception TP.sig.InvalidParameter
     * @returns {Number} The transformed pixel value.
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (!TP.isNumber(pixelValue)) {
        return TP.raise(this, 'TP.sig.InvalidNumber');
    }

    if (!TP.isString(aPropertyName)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  If the property name is either a *[t|T]op* or *[b|B]ottom*, then we're
    //  converting the Y value
    if (/(top|bottom)/i.test(aPropertyName)) {
        return TP.elementLocalToGlobalXY(anElement, 0, pixelValue).last();
    } else if (/(left|right)/i.test(aPropertyName)) {
        //  Otherwise, if the property name is either a *[l|L]eft* or
        //  *[r|R]ight*, then we're converting the X value
        return TP.elementLocalToGlobalXY(anElement, pixelValue, 0).first();
    } else {
        return pixelValue;
    }
});

//  ------------------------------------------------------------------------
//  STYLE PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('cssElementGetCustomCSSPropertyValue',
function(anElement, selectorText, aPropertyName, aRuleIndex) {

    /**
     * @method cssElementGetCustomCSSProperty
     * @summary Gets the value of the named custom CSS property found in the
     *     supplied CSS element.
     * @param {Element} anElement The 'link' or 'style' element to get the
     *     custom property value in.
     * @param {String} selectorText The text of the selector to match.
     * @param {String} aPropertyName The CSS custom property name to get the
     *     value of.
     * @param {Number} [aRuleIndex=0] The index of the rule to obtain the value
     *     from if there is more than 1 rule that has the same selector.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidStyleSheet
     * @exception TP.sig.InvalidStyleRule
     * @returns {Object|null} The property value or null.
     */

    var styleSheet,

        styleRules,

        index,
        targetRule,

        val;

    //  Make sure we were handed a 'link' or 'style' element.
    if (!TP.isElement(anElement) ||
        TP.elementGetLocalName(anElement).toLowerCase() !== 'link' &&
        TP.elementGetLocalName(anElement).toLowerCase() !== 'style') {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(selectorText)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  Grab the stylesheet associated with the supplied CSS element.
    styleSheet = TP.cssElementGetStyleSheet(anElement);
    if (!TP.isStyleSheet(styleSheet)) {
        return TP.raise(this, 'TP.sig.InvalidStyleSheet');
    }

    //  Grab all of the style rules from the stylesheet that match the supplied
    //  selector.
    styleRules = TP.styleSheetGetStyleRulesMatching(styleSheet, selectorText);
    if (TP.isEmpty(styleRules)) {
        return null;
    }

    //  If a rule index isn't supplied, then we default it to 0. There may be
    //  more than one rule with the same selector in the stylesheet.
    index = TP.ifInvalid(aRuleIndex, 0);

    //  Grab the desired style rule.
    targetRule = styleRules.at(index);
    if (!TP.isStyleRule(targetRule)) {
        return TP.raise(this, 'TP.sig.InvalidStyleRule');
    }

    val = targetRule.style.getPropertyValue(aPropertyName);

    return val;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('cssElementResolveVirtualURIs',
function(anElement) {

    /**
     * @method cssElementResolveVirtualURIs
     * @summary Resolves any virtual URIs in the stylesheet of the supplied
     *     element. The element should be a CSS 'link' or 'style' element.
     * @param {Element} anElement The 'link' or 'style' element to resolve the
     *     virtual URIs in.
     * @exception TP.sig.InvalidElement
     */

    var replaceURLValues,

        sheet,
        rules,

        i,

        currentRuleText,
        newRuleText;

    //  Make sure we were handed a 'link' or 'style' element.
    if (!TP.isElement(anElement) ||
        TP.elementGetLocalName(anElement).toLowerCase() !== 'link' &&
        TP.elementGetLocalName(anElement).toLowerCase() !== 'style') {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  Define a Function that can replace 'url(...)' values.
    replaceURLValues = function(origRuleText) {

        var replacedRuleText;

        //  Scan the content for url(...) values. If found, resolve their
        //  value.

        TP.regex.CSS_VIRTUAL_URL_VALUE.lastIndex = 0;
        replacedRuleText = origRuleText.replace(
                TP.regex.CSS_VIRTUAL_URL_VALUE,
                function(wholeMatch, leadingText, locationValue) {

                    var loc;

                    if (TP.notEmpty(locationValue)) {

                        //  Compute the value for the URL in the
                        //  url(...) property by joining it with the
                        //  'collection location' for the stylesheet it
                        //  was found in.
                        loc = TP.uc(locationValue).getLocation();
                    }

                    //  Return the String that must exactly replace what
                    //  the RegExp matched (we default to enclosing the
                    //  value in double quotes - the RegExp strips all
                    //  quoting anyway).
                    return 'url("' + loc + '")';
                });

        return replacedRuleText;
    };

    //  Grab the stylesheet rules.
    sheet = TP.cssElementGetStyleSheet(anElement);
    rules = sheet.cssRules;

    //  Iterate over them and, if they're of type CSSRule.STYLE_RULE or
    //  CSSRule.FONT_FACE_RULE, then use the Function above to see if they need
    //  to have URI content replaced.
    for (i = 0; i < rules.length; i++) {

        currentRuleText = rules[i].cssText;

        TP.regex.CSS_VIRTUAL_URL_VALUE.lastIndex = 0;
        if (TP.regex.CSS_VIRTUAL_URL_VALUE.test(currentRuleText)) {

            newRuleText = replaceURLValues(currentRuleText);

            sheet.deleteRule(i);
            sheet.insertRule(newRuleText, i);
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('cssElementSetCustomCSSPropertyValue',
function(anElement, selectorText, aPropertyName, aPropertyValue, aRuleIndex,
         shouldSignal) {

    /**
     * @method cssElementSetCustomCSSProperty
     * @summary Sets the value of the named custom CSS property found in the
     *     supplied CSS element.
     * @param {Element} anElement The 'link' or 'style' element to set the
     *     custom property value in.
     * @param {String} selectorText The text of the selector to match.
     * @param {String} aPropertyName The CSS custom property name to set the
     *     value of.
     * @param {String} aPropertyValue The value to set the CSS custom property
     *     to.
     * @param {Number} [aRuleIndex=0] The index of the rule to change if there
     *     is more than 1 rule that has the same selector.
     * @param {Boolean} [shouldSignal=true] If false no signaling occurs.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidStyleSheet
     * @exception TP.sig.InvalidStyleRule
     */

    var styleSheet,

        styleRules,

        index,
        targetRule,

        oldVal,
        operation;

    //  Make sure we were handed a 'link' or 'style' element.
    if (!TP.isElement(anElement) ||
        TP.elementGetLocalName(anElement).toLowerCase() !== 'link' &&
        TP.elementGetLocalName(anElement).toLowerCase() !== 'style') {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(selectorText)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  Grab the stylesheet associated with the supplied CSS element.
    styleSheet = TP.cssElementGetStyleSheet(anElement);
    if (!TP.isStyleSheet(styleSheet)) {
        return TP.raise(this, 'TP.sig.InvalidStyleSheet');
    }

    //  Grab all of the style rules from the stylesheet that match the supplied
    //  selector.
    styleRules = TP.styleSheetGetStyleRulesMatching(styleSheet, selectorText);
    if (TP.isEmpty(styleRules)) {
        return;
    }

    //  If a rule index isn't supplied, then we default it to 0. There may be
    //  more than one rule with the same selector in the stylesheet.
    index = TP.ifInvalid(aRuleIndex, 0);

    //  Grab the desired style rule.
    targetRule = styleRules.at(index);
    if (!TP.isStyleRule(targetRule)) {
        return TP.raise(this, 'TP.sig.InvalidStyleRule');
    }

    oldVal = targetRule.style.getPropertyValue(aPropertyName);

    //  Use the setProperty call to set the custom property on the rule's style
    //  object.
    targetRule.style.setProperty(aPropertyName, aPropertyValue);

    if (TP.notFalse(shouldSignal)) {
        operation = TP.notEmpty(oldVal) ? TP.UPDATE : TP.CREATE;

        //  Signal from our (wrapped) owner element that we modified a style
        //  rule.
        TP.signal(TP.tpdoc(anElement),
                    'TP.sig.MutationStylePropertyChange',
                    TP.hc('mutationTarget', TP.wrap(anElement),
                            'mutatedRule', targetRule,
                            'mutatedProperty', aPropertyName,
                            'operation', operation,
                            TP.OLDVAL, oldVal,
                            TP.NEWVAL, aPropertyValue));
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('cssLinkElementFlattenImports',
function(anElement) {

    /**
     * @method cssLinkElementFlattenImports
     * @summary 'Flatten's any @import statements in the supplied 'link'
     *     element's out into 'link' elements in the supplied element's
     *     document. Note that this method will *not* overwrite any existing
     *     'link' elements that have the same 'href' as the @import'ed
     *     stylesheet.
     * @param {Element} anElement The 'link' element to flatten the CSS @imports
     *     under.
     * @exception TP.sig.InvalidElement
     */

    var doc,

        currentTopLevelLinkElems,

        existingHrefs,

        sheets,
        startSheet,

        hrefsToAdd,

        len,
        i,

        sheetHref;

    //  Make sure we were handed a 'link' element.
    if (!TP.isElement(anElement) ||
        TP.elementGetLocalName(anElement).toLowerCase() !== 'link') {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    doc = TP.nodeGetDocument(anElement);

    //  Gather the hrefs of the current 'top-level' 'link' elements in the
    //  supplied element's document. The reason we do this rather than just
    //  query for an element's authored 'href=' value is that the '.href'
    //  property will be the *fully expanded* href value and that's the one(s)
    //  we'll need for comparison.
    currentTopLevelLinkElems =
                TP.byCSSPath('link[rel="stylesheet"]', doc, false, false);
    existingHrefs = currentTopLevelLinkElems.collect(
                                                function(anElem) {
                                                    return anElem.href;
                                                });

    //  Now, gather the sheets (recursively) for all of the @imports referenced
    //  by the supplied 'link' element
    sheets = TP.ac();

    //  Start with the style sheet of the supplied element.
    startSheet = TP.cssElementGetStyleSheet(anElement);
    sheets.push(startSheet);

    //  This method will recursively gather the @import sheets (in order, to
    //  preserve CSS specificity order).
    sheets = sheets.concat(TP.styleSheetGetImportSheets(startSheet));

    hrefsToAdd = TP.ac();

    //  Iterate over them and, if the href *isn't* in the list of the top-level
    //  'link' elements above, add it to the list to process.
    len = sheets.getSize();
    for (i = 0; i < len; i++) {

        sheetHref = sheets.at(i).href;

        if (!existingHrefs.contains(sheetHref)) {
            hrefsToAdd.push(sheetHref);
        }
    }

    //  If there are hrefs to add, generate a 'link' element for each one.
    if (TP.notEmpty(hrefsToAdd)) {

        len = hrefsToAdd.getSize();
        for (i = 0; i < len; i++) {

            //  Note here that we pass false to avoid style mutation change
            //  signaling.
            TP.documentAddCSSLinkElement(doc, hrefsToAdd.at(i), null, false);
        }

        //  We added a bunch of hrefs representing the (recursively gathered)
        //  @import'ed URLs. We should disable the main 'link' element that was
        //  holding them all.
        anElement.disabled = true;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('cssStyleElementGetContent',
function(anElement) {

    /**
     * @method cssStyleElementGetContent
     * @summary Returns the all of the CSS text under anElement, which should
     *     be a 'style' element. NB: The caller *must* supply a 'style' element
     *     here, or an 'TP.sig.InvalidElement' exception will be thrown.
     * @param {Element} anElement The 'style' element to retrieve the CSS text
     *     for.
     * @exception TP.sig.InvalidElement
     * @returns {String} The CSS text under anElement.
     */

    if (!TP.isElement(anElement) ||
        TP.elementGetLocalName(anElement).toLowerCase() !== 'style') {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.notValid(anElement.firstChild)) {
        return '';
    }

    return anElement.firstChild.nodeValue;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('cssStyleElementSetContent',
function(anElement, styleText, shouldSignal) {

    /**
     * @method cssStyleElementSetContent
     * @summary Sets the all of the CSS text under anElement, which should be a
     *     'style' element. NB: The caller *must* supply a 'style' element here,
     *     or an 'TP.sig.InvalidElement' exception will be thrown.
     * @param {Element} anElement The 'style' element to set the CSS text for.
     * @param {String} styleText The CSS text to use as the rule text for the
     *     style element.
     * @param {Boolean} [shouldSignal=true] If false no signaling occurs.
     * @exception TP.sig.InvalidElement
     */

    var styleTextNode;

    if (!TP.isElement(anElement) ||
        TP.elementGetLocalName(anElement).toLowerCase() !== 'style') {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  If there's no valid text node under the style element, create one
    //  with the content.
    styleTextNode = anElement.firstChild;
    if (!TP.isTextNode(styleTextNode) &&
        !TP.isCDATASectionNode(styleTextNode)) {
        TP.nodeAppendChild(
            anElement,
            TP.nodeGetDocument(anElement).createTextNode(styleText),
            false);
    } else {
        styleTextNode.nodeValue = styleText;
    }

    if (TP.notFalse(shouldSignal)) {
        //  Signal from the new element that we added.
        TP.signal(TP.tpdoc(anElement),
                    'TP.sig.MutationStyleChange',
                    TP.hc('mutationTarget', TP.wrap(anElement),
                            'operation', TP.UPDATE));
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('styleRuleGetRuleInfo',
function(aStyleRule, allDocumentStyleSheets) {

    /**
     * @method styleRuleGetRuleInfo
     * @summary Returns an Array of TP.core.Hashes that contain style
     *     information for the supplied rule.
     * @description The reason that an Array is returned here is that the rule
     *     may have simple selectors separated by a ','. Each simple selector is
     *     returned in its own entry along with the rest of the rule
     *     information.
     * @param {CSSStyleRule} aStyleRule The style rule to retrieve the rule
     *     information for.
     * @param {CSSStyleSheet[]} allDocumentStyleSheets All of the style sheets
     *     that are present in the same document as the style rule is in.
     * @returns {TP.core.Hash[]} An Array of TP.core.Hash objects with style
     *     rule information for each style rule that matches the supplied
     *     element.
     *          originalSelector:   The original 'whole' selector
     *          selector:           The simple selector split out from the whole
     *                              selector.
     *          specificityInfo:    Specificity information about the selector.
     *                              See the
     *                              calculateSingleCSSSelectorSpecificity()
     *                              method for more information on the values
     *                              here.
     *          sheetLocation:      The URL location of the stylesheet.
     *          sheetPosition:      The position of the stylesheet in the list
     *                              of stylesheets in a document.
     *          rulePosition:       The position of the rule in the list of
     *                              rules in its stylesheet.
     *          rule:               The original CSSStyleRule object.
     * @exception TP.sig.InvalidParameter
     */

    var rulePos,
        ruleStyleSheet,

        sheetLoc,

        sheetPos,
        possiblePos,
        sheetMatchingHref,

        selectorText,
        simpleSelectors,

        entries,

        selectorsLen,
        i,

        ruleEntry;

    if (!TP.isStyleRule(aStyleRule)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  Grab the rule's stylesheet
    ruleStyleSheet = aStyleRule.parentStyleSheet;

    //  Compute the rule's 'position' within its stylesheet. This is used in
    //  some scenarios of selector sorting.
    rulePos = TP.ac(ruleStyleSheet.cssRules).indexOf(aStyleRule);

    //  Grab the rule's location using the TIBET mechanism to do so. This will
    //  use other metadata if the original href that loaded the sheet is not
    //  present.
    sheetLoc = TP.styleSheetGetLocation(ruleStyleSheet);

    //  Now try to compute the sheet's 'position' within its overall document.
    //  Because sometimes the sheet cannot be found in the document's set of
    //  stylesheets, an alternate method is also used that compares the sheet's
    //  'hrefs' and will return that.
    sheetPos = allDocumentStyleSheets.indexOf(ruleStyleSheet);
    if (sheetPos === TP.NOT_FOUND) {
        possiblePos = -1;
        sheetMatchingHref = allDocumentStyleSheets.detect(
                               function(aSheet, index) {
                                   possiblePos = index;
                                   return aSheet.href === ruleStyleSheet.href;
                               });
        if (TP.isValid(sheetMatchingHref)) {
            sheetPos = possiblePos;
        }
    }

    selectorText = aStyleRule.selectorText.trim();

    entries = TP.ac();

    simpleSelectors = selectorText.split(',');

    //  Iterate over all of the simple selectors, making an entry for each one.
    selectorsLen = simpleSelectors.getSize();
    for (i = 0; i < selectorsLen; i++) {
        ruleEntry = TP.hc(
            'originalSelector',
            selectorText,
            'selector',
            simpleSelectors.at(i).trim(),
            'specificityInfo',
            TP.calculateSingleCSSSelectorSpecificity(simpleSelectors.at(i)),
            'sheetLocation',
            sheetLoc,
            'sheetPosition',
            sheetPos,
            'rulePosition',
            rulePos,
            'rule',
            aStyleRule);

        entries.push(ruleEntry);
    }

    return entries;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('styleRuleGetDeclarationsSource',
function(aStyleRule) {

    /**
     * @method styleRuleGetDeclarationsSource
     * @summary Retrieves the declarations source of the supplied rule.
     * @param {CSSStyleRule} aStyleRule The style rule to retrieve the rule
     *     declarations source for.
     * @returns {String} The property declarations of the supplied rule.
     * @exception TP.sig.InvalidParameter
     */

    var declsSource;

    if (!TP.isStyleRule(aStyleRule)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    declsSource = aStyleRule.cssText;

    //  The '.cssText' property will start with the selector. We need to slice
    //  it off along with the leading and trailing braces. We then trim
    //  whitespace.
    declsSource = TP.trim(declsSource.slice(
                            declsSource.indexOf('{') + 1,
                            declsSource.lastIndexOf('}')));

    return declsSource;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('styleRuleGetSourceInfo',
function(aStyleRule, sourceASTs, aStyleURI) {

    /**
     * @method styleRuleGetSourceInfo
     * @summary Returns source information for the supplied style rule.
     * @param {CSSStyleRule} aStyleRule The style rule to retrieve the source
     *     information for.
     *     inlined content will be acting in place of.
     * @param {TP.core.Hash} sourceASTs A cache, supplied by the caller, that
     *     this method will use to generate the AST for a particular sheet only
     *     once and then cache in this object. In this way, this method can be
     *     called more than once (maybe in a loop) and the ASTs will not be
     *     generated for each rule in each sheet.
     * @param {TP.uri.URI} [styleURI] The URI of the CSS content that will
     *     act as the source to produce style information from. If this
     *     parameter is not supplied, then the raw content from the style sheet
     *     that the supplied style rule belongs to will be used.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.core.Hash} A hash containing the source information for the
     *     supplied rule.
     */

    var results,

        ownerSheet,
        nativeRuleIndex,

        sheetLoc,
        styleElem,

        httpObj,
        srcText,

        request,

        sheetAST,

        vendorPrefix,
        nonPlatformMatcher,

        rules,

        index,
        len,
        i,
        rule,

        embeddedRules,
        embeddedLength,

        selectors,
        nonPlatformSelectorCount,
        j,

        args,

        declaration,

        ruleInfo;

    if (!TP.isStyleRule(aStyleRule)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  First, we need to get the stylesheet of the style rule and its index
    //  in the stylesheet
    results = TP.styleRuleGetStyleSheetAndIndex(aStyleRule);

    ownerSheet = results.first();
    nativeRuleIndex = results.last();

    sheetLoc = ownerSheet.href;

    //  See if a Hash was passed into that caches sheet ASTs. This allows the
    //  caller to process an entire batch of rules without fetching the source
    //  and building an AST for the entire CSS sheet for each call into this
    //  method, which only processes a single rule.

    /* eslint-disable no-extra-parens */
    if (!TP.isHash(sourceASTs) ||
        (TP.isHash(sourceASTs) &&
            TP.notValid(sheetAST = sourceASTs.at(sheetLoc)))) {
    /* eslint-enable no-extra-parens */

        //  If the supplied style URI is real fetch it's contents
        //  *synchronously*.
        if (TP.isURI(aStyleURI)) {
            request = TP.request('async', false, 'signalChange', false);
            srcText = aStyleURI.getContent(request);

            //  Always get the String, in case we get a
            //  TP.core.CSSStyleSheetContent object
            srcText = srcText.asString();
        }

        if (TP.isEmpty(srcText)) {
            //  If there is no sheet location, then it must be a sheet that was
            //  generated for an inline 'style' element.
            if (!TP.isString(sheetLoc)) {
                styleElem = TP.styleSheetGetOwnerNode(ownerSheet);
                if (!TP.isElement(styleElem)) {
                    return TP.hc();
                }

                //  The sheet location is the global ID of the style element and
                //  the source text to process is the content of that element.
                sheetLoc = TP.gid(styleElem);
                srcText = TP.nodeGetTextContent(styleElem);
            } else {

                //  Otherwise, it's an external sheet - fetch it's contents
                //  *synchronously*.
                //  TODO:   rebuilt to eliminate the sync call here.
                request = TP.request('async', false);
                TP.httpGet(sheetLoc, request);
                httpObj = request.at('commObj');
                srcText = httpObj.responseText;
            }
        }

        //  If we couldn't get source text, then we return an empty Hash.
        if (TP.isEmpty(srcText)) {
            return TP.hc();
        }

        //  Generate an AST from the CSS text.
        sheetAST = TP.extern.cssParser.parse(
            srcText,
            {
                source: sheetLoc
            });

        if (TP.isHash(sourceASTs)) {
            sourceASTs.atPut(sheetLoc, sheetAST);
        }
    }

    //  Compute a vendor prefix.
    if (TP.sys.isUA('GECKO')) {
        vendorPrefix = '-moz-';
        nonPlatformMatcher = /-ms-|-webkit-/;
    } else if (TP.sys.isUA('WEBKIT')) {
        vendorPrefix = '-webkit-';
        nonPlatformMatcher = /-moz-|-ms-/;
    }

    //  Now iterate through all results in the AST, looking for the style rule
    //  with the same index.

    //  Note here how we make a copy of this Array, in case we modify it below
    //  by splicing @media rules into it.

    //  NB: We're going after all of the rules (including those imported from
    //  @import statements) by going after the '.rules' Array here, not
    //  '.cssRules'.
    rules = TP.copy(sheetAST.stylesheet.rules);

    index = 0;

    len = rules.getSize();
    for (i = 0; i < len; i++) {
        rule = rules.at(i);

        //  We process @media rules by grabbing their inner style rules and
        //  splicing them into the Array and adjusting our 'len' to count to the
        //  end. This is important because our native rule index will have been
        //  computed taking these rules into account and so we need to do so
        //  here.
        if (rule.type === 'media') {

            embeddedRules = rule.rules;
            embeddedLength = embeddedRules.length;

            args = TP.ac(i + 1, 0).concat(embeddedRules);
            Array.prototype.splice.apply(rules, args);
            len += embeddedLength;

            continue;
        }

        //  We skip comments, namespaces and charsets (namespaces are skipped by
        //  our primitive method call at the top of this method and charsets are
        //  skipped by the native browser machinery per the spec).
        if (rule.type === 'comment' ||
            rule.type === 'namespace' ||
            rule.type === 'charset') {
            continue;
        }

        //  Iterate over all of the selectors. If they *all* match vendor
        //  prefixes that are *not* supported on this browser, then move on.
        selectors = rule.selectors;
        nonPlatformSelectorCount = 0;
        for (j = 0; j < selectors.getSize(); j++) {
            if (nonPlatformMatcher.test(selectors.at(j))) {
                nonPlatformSelectorCount++;
            }
        }

        //  They all had vendor prefixes that did *not* match the currently
        //  executing browser.
        if (nonPlatformSelectorCount === selectors.getSize()) {
            continue;
        }

        //  We skip @keyframes rules that don't pertain to our platform. The
        //  native rule index, as calculated by the browser, won't have counted
        //  rules that are not for our current platform.
        if (rule.type === 'keyframes' && rule.vendor !== vendorPrefix) {
            continue;
        }

        //  We skip @document rules that don't pertain to our platform. The
        //  native rule index, as calculated by the browser, won't have counted
        //  rules that are not for our current platform.
        if (rule.type === 'document' && rule.vendor !== vendorPrefix) {
            continue;
        }

        //  If the index is the same as the native index calculated for our
        //  rule, then we break and exit.
        if (index === nativeRuleIndex) {

            //  Before we return the data, we need to make sure that the values
            //  for the declarations defined in this ruleInfo are updated with
            //  any changes that the supplied native style rule has which might
            //  have been set dynamically.
            for (j = 0; j < rule.declarations.getSize(); j++) {
                declaration = rule.declarations.at(j);
                if (declaration.type === 'declaration') {
                    declaration.value =
                            aStyleRule.style[declaration.property.asDOMName()];
                }
            }

            ruleInfo = rule;

            break;
        }

        index++;
    }

    if (TP.isValid(ruleInfo)) {
        return TP.hc(ruleInfo);
    }

    return TP.hc();
}, {
    dependencies: [TP.extern.cssParser]
});

//  ------------------------------------------------------------------------

TP.definePrimitive('styleRuleGetStyleSheet',
function(aStyleRule) {

    /**
     * @method styleRuleGetStyleSheet
     * @summary Returns the native style sheet object associated with the
     *     supplied style rule.
     * @param {CSSStyleRule} aStyleRule The style rule to retrieve the
     *     stylesheet of.
     * @exception TP.sig.InvalidParameter
     * @returns {CSSStyleSheet} The stylesheet object containing the rule.
     */

    if (!TP.isStyleRule(aStyleRule)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  The DOM standard is to just return the parentStyleSheet property of
    //  the rule.

    return aStyleRule.parentStyleSheet;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('styleRuleGetStyleSheetAndIndex',
function(aStyleRule, filterNonStyleRules) {

    /**
     * @method styleRuleGetStyleSheetAndIndex
     * @summary Returns the native style sheet object associated with the
     *     supplied style rule and the index that the rule can be found within
     *     that style sheet.
     * @description Note that this will filter out all CSS rules except
     *     CSSRule.STYLE_RULE (i.e. no @namespace rules, @import rules, etc.)
     *     *before* it computes the returned index. Therefore, the indexes are
     *     relative to the subset that are CSSRule.STYLE_RULE rules.
     * @param {CSSStyleRule} aStyleRule The style rule to retrieve the
     *     stylesheet of.
     * @param {Boolean} [filterNonStyleRules=true] If true, the list is filtered
     *     for non-style rules.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidStyleSheet
     * @returns {Array<CSSStyleRule,Number>} An Array of the stylesheet object
     *     containing the rule and the index the rule can be found in the sheet.
     */

    var styleSheet,
        allRules,
        styleRules,
        i;

    if (!TP.isStyleRule(aStyleRule)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    styleSheet = TP.styleRuleGetStyleSheet(aStyleRule);

    if (!TP.isStyleSheet(styleSheet)) {
        return TP.raise(this, 'TP.sig.InvalidStyleSheet');
    }

    //  NB: Note how we do *not* expand imports here and we do *not* filter for
    //  CSSRule.STYLE_RULE types of rules.
    allRules = TP.styleSheetGetStyleRules(styleSheet, false, false);

    if (TP.isFalse(filterNonStyleRules)) {
        styleRules = allRules;
    } else {
        //  Filter out all non CSSRule.STYLE_RULE 'rules'.
        styleRules = allRules.filter(
                    function(aRule) {
                        return aRule.type === CSSRule.STYLE_RULE;
                    });
    }

    for (i = 0; i < styleRules.getSize(); i++) {
        if (styleRules.at(i) === aStyleRule) {
            return TP.ac(styleSheet, i);
        }
    }

    return TP.ac(styleSheet, TP.NOT_FOUND);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('styleRuleSetProperty',
function(aStyleRule, aPropertyName, aPropertyValue, shouldSignal) {

    /**
     * @method styleRuleSetProperty
     * @summary Sets the supplied style property in the supplied rule to the
     *     supplied style value.
     * @param {CSSStyleRule} aStyleRule The style rule to set the property in.
     * @param {String} aPropertyName The CSS property name to set the value of.
     * @param {String} aPropertyValue The value to set the CSS property to.
     * @param {Boolean} [shouldSignal=true] If false no signaling occurs.
     * @exception TP.sig.InvalidStyleRule
     * @exception TP.sig.InvalidParameter
     */

    var oldVal,

        stylesheet,
        ownerElem,

        operation;

    if (!TP.isStyleRule(aStyleRule)) {
        return TP.raise(this, 'TP.sig.InvalidStyleRule');
    }

    if (TP.isEmpty(aPropertyName) || TP.isEmpty(aPropertyValue)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    oldVal = aStyleRule.style.getPropertyValue(aPropertyName);

    aStyleRule.style.setProperty(aPropertyName, aPropertyValue);

    if (TP.notFalse(shouldSignal)) {
        stylesheet = TP.styleRuleGetStyleSheet(aStyleRule);
        if (TP.isStyleSheet(stylesheet)) {
            ownerElem = TP.styleSheetGetOwnerNode(stylesheet);

            if (TP.isElement(ownerElem)) {
                operation = TP.notEmpty(oldVal) ? TP.UPDATE : TP.CREATE;

                //  Signal from our (wrapped) owner element that we modified a
                //  style rule.
                TP.signal(TP.tpdoc(ownerElem),
                            'TP.sig.MutationStylePropertyChange',
                            TP.hc('mutationTarget', TP.wrap(ownerElem),
                                    'mutatedRule', aStyleRule,
                                    'mutatedProperty', aPropertyName,
                                    'operation', operation,
                                    TP.OLDVAL, oldVal,
                                    TP.NEWVAL, aPropertyValue));
            }
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('styleRuleRemoveProperty',
function(aStyleRule, aPropertyName, shouldSignal) {

    /**
     * @method styleRuleRemoveProperty
     * @summary Removes the supplied style property from the supplied rule.
     * @param {CSSStyleRule} aStyleRule The style rule to remove the property
     *     from.
     * @param {String} aPropertyName The name of the CSS property to remove.
     * @param {Boolean} [shouldSignal=true] If false no signaling occurs.
     * @exception TP.sig.InvalidStyleRule
     * @exception TP.sig.InvalidParameter
     */

    var oldVal,

        stylesheet,
        ownerElem;

    if (!TP.isStyleRule(aStyleRule)) {
        return TP.raise(this, 'TP.sig.InvalidStyleRule');
    }

    if (TP.isEmpty(aPropertyName)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    oldVal = aStyleRule.style.getPropertyValue(aPropertyName);

    aStyleRule.style.removeProperty(aPropertyName);

    if (TP.notFalse(shouldSignal)) {
        stylesheet = TP.styleRuleGetStyleSheet(aStyleRule);
        if (TP.isStyleSheet(stylesheet)) {
            ownerElem = TP.styleSheetGetOwnerNode(stylesheet);

            if (TP.isElement(ownerElem)) {

                //  Signal from our (wrapped) owner element that we modified a
                //  style rule.
                TP.signal(TP.tpdoc(ownerElem),
                            'TP.sig.MutationStylePropertyChange',
                            TP.hc('mutationTarget', TP.wrap(ownerElem),
                                    'mutatedRule', aStyleRule,
                                    'mutatedProperty', aPropertyName,
                                    'operation', TP.DELETE,
                                    TP.OLDVAL, oldVal));
            }
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$styleSheetAddMissingNamespaceRules',
function(aStylesheet, selectorText, shouldSignal) {

    /**
     * @method $styleSheetAddMissingNamespaceRules
     * @summary Adds any missing @namespace rules to the supplied sheet based on
     *     any namespace prefixes found in the supplied selector text.
     * @param {CSSStyleSheet} aStylesheet The style sheet to add missing
     *     namespace rules to.
     * @param {String} selectorText The text of the selector to scan for CSS
     *     namespace prefixes.
     * @param {Boolean} [shouldSignal=true] If false no signaling occurs.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidString
     * @returns {Number} The number of @namespace rules added.
     */

    var rules,
        nsRules,
        i,

        undefinedPrefixes,
        nsPrefixUsages,
        nsPrefix,

        foundMatch,

        j,
        ownerElem,

        uri,

        removedRules,
        endIndex,

        nsRulesAdded,

        rule,

        len;

    if (!TP.isStyleSheet(aStylesheet)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  NB: We allow empty rule text
    if (TP.isEmpty(selectorText)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    rules = aStylesheet.cssRules;

    //  Gather all of the existing @namespace rules. We'll test them to make
    //  sure that any namespace prefixes used in the supplied selector text are
    //  defined.
    nsRules = TP.ac();
    for (i = 0; i < rules.length; i++) {
        if (rules[i].type === CSSRule.NAMESPACE_RULE) {
            nsRules.push(rules[i]);
        }
    }

    //  Scan the selector for prefixes and check those against the gathered
    //  @namespace rules. If we find undefined ones, we add them to our list.

    undefinedPrefixes = TP.ac();

    nsPrefixUsages = selectorText.match(/\w+\|\w*/g);
    for (i = 0; i < nsPrefixUsages.getSize(); i++) {

        //  Grab the prefix and slice off from the first character to the last
        //  occurrence of '|'
        nsPrefix = nsPrefixUsages.at(i);
        nsPrefix = nsPrefix.slice(0, nsPrefix.lastIndexOf('|'));

        //  Iterate over the list of gathered @namespace rules and see if we
        //  have a match.
        foundMatch = false;
        for (j = 0; j < nsRules.getSize(); j++) {
            if (nsRules.at(j).prefix === nsPrefix) {
                foundMatch = true;
                break;
            }
        }

        //  No match found? Add it to the list.
        if (!foundMatch) {
            undefinedPrefixes.push(nsPrefix);
        }
    }

    if (TP.notEmpty(undefinedPrefixes)) {

        //  Because of the way the spec works, we cannot have any non
        //  @import or @namespace rules in the sheet when we insert new
        //  @namespace rules. So we iterate and remove all of the
        //  non-@import/non-@namespace rules in the sheet and add them back
        //  in after we insert our new @namespace rules. Sigh.

        removedRules = TP.ac();

        //  NB: It's easier to do this from the end of the list, since
        //  @import and @namespace rules (per the spec) will be clustered at
        //  the top. In fact, once we reach those rules, we will stop.

        //  Also note that 'rules' (i.e. cssRules) is a *live* list and
        //  we're leveraging that here, but we have to capture the list length
        //  first.
        len = rules.length;
        for (i = 0; i < len; i++) {

            endIndex = rules.length - 1;

            if (rules[endIndex].type === CSSRule.NAMESPACE_RULE ||
                rules[endIndex].type === CSSRule.IMPORT_RULE) {
                break;
            }

            //  Keep the removed rule in our list of removed rules and remove
            //  the rule.
            removedRules.unshift(rules[endIndex]);
            aStylesheet.removeRule(endIndex);
        }

        //  Keep track of the number of rules we added.
        nsRulesAdded = 0;

        //  Iterate over the list of undefined prefixes.
        len = undefinedPrefixes.getSize();
        for (i = 0; i < len; i++) {

            //  Grab the URI that goes with the undefined prefix.
            uri = TP.w3.Xmlns.getNSURIForPrefix(undefinedPrefixes.at(i));
            if (TP.isEmpty(uri)) {
                return TP.raise(this, 'TP.sig.InvalidValue');
            }

            //  Insert a new @namespace rule for the prefix and its
            //  corresponding namespace URI.
            aStylesheet.insertRule(
                '@namespace ' + nsPrefix + ' url("' + uri + '");',
                rules.length);

            nsRulesAdded++;

            if (TP.notFalse(shouldSignal)) {
                //  Grab the rule that we're inserting.
                rule = aStylesheet.cssRules[rules.length - 1];

                ownerElem = TP.styleSheetGetOwnerNode(aStylesheet);

                if (TP.isElement(ownerElem)) {

                    //  Signal from our (wrapped) owner element that we added a
                    //  @namespace rule.
                    TP.signal(TP.tpdoc(ownerElem),
                                'TP.sig.MutationStyleRuleChange',
                                TP.hc('mutationTarget', TP.wrap(ownerElem),
                                        'mutatedRule', rule,
                                        'ruleIndex', rules.length - 1,
                                        'operation', TP.CREATE));
                }
            }
        }

        //  Iterate over the rules that we removed earlier and append them back
        //  into stylesheet. This should put them back in the order in which
        //  they were originally found.
        len = removedRules.getSize();
        for (i = 0; i < len; i++) {
            aStylesheet.insertRule(
                removedRules.at(i).cssText,
                rules.length);
        }
    }

    return nsRulesAdded;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('styleSheetGetImportHrefs',
function(aStylesheet, expandImports) {

    /**
     * @method styleSheetGetImportHrefs
     * @summary Retrieves the imported hrefs from the supplied stylesheet.
     * @param {CSSStyleSheet} aStylesheet The style sheet to retrieve the
     *     imported hrefs from.
     * @param {Boolean} [expandImports=true] Whether or not @import statements
     *     should be recursively 'expanded' and the hrefs gathered from them
     *     too. This defaults to true.
     * @exception TP.sig.InvalidParameter
     * @returns {String[]} A list of imported hrefs.
     */

    var resultSheets,

        hrefs;

    if (!TP.isStyleSheet(aStylesheet)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    resultSheets = TP.styleSheetGetImportSheets(aStylesheet, expandImports);

    hrefs = resultSheets.collect(
                            function(aSheet) {
                                return aSheet.href;
                            });

    return hrefs;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('styleSheetGetImportSheets',
function(aStylesheet, expandImports) {

    /**
     * @method styleSheetGetImportSheets
     * @summary Retrieves the imported stylesheets from the supplied stylesheet.
     * @param {CSSStyleSheet} aStylesheet The style sheet to retrieve the
     *     imported stylesheets from.
     * @param {Boolean} [expandImports=true] Whether or not @import statements
     *     should be recursively 'expanded' and the stylesheets gathered from
     *     them too. This defaults to true.
     * @exception TP.sig.InvalidParameter
     * @returns {CSSStyleSheet[]} A list of imported stylesheets.
     */

    var resultSheets,
        sheetRules,

        shouldExpand,

        i;

    if (!TP.isStyleSheet(aStylesheet)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    shouldExpand = TP.ifInvalid(expandImports, true);

    resultSheets = TP.ac();

    //  Grab the rules from the sheet.
    sheetRules = aStylesheet.cssRules;

    //  Loop over each rule in the sheet and, if the rule is an 'IMPORT_RULE',
    //  add it to our result Array - and recurse if the shouldExpand parameter
    //  is true.
    for (i = 0; i < sheetRules.length; i++) {

        //  If the rule is an '@import' rule, call this function recursively
        //  on the rule's 'stylesheet' property (which will be the actual
        //  stylesheet object of the stylesheet being imported) and add all
        //  of the hrefs found there to our result array.
        if (sheetRules[i].type === CSSRule.IMPORT_RULE) {

            if (shouldExpand) {
                resultSheets.addAll(
                    TP.styleSheetGetImportSheets(sheetRules[i].styleSheet));
            }

            resultSheets.push(sheetRules[i].styleSheet);
        }
    }

    return resultSheets;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('styleSheetGetLocation',
function(aStylesheet) {

    /**
     * @method styleSheetGetLocation
     * @summary Retrieves the location for the supplied stylesheet. Note that
     *     some stylesheets, like those produced from compiled or processed CSS,
     *     will be associated with an XHTML 'style' element that doesn't have an
     *     'href' pointing back to the source of the sheet. In this case, we
     *     have stamped one of several TIBETan attributes on it that point back
     *     to the original source.
     * @description Determining the location of the stylesheet uses the
     *     following logic:
     *         1. If the rule came from a sheet that is associated to a regular
     *         CSS <link> element, then we obtain its href value as the source
     *         location as the source location of the rule.
     *         2. If the rule came from a sheet that is associated to a regular
     *         CSS <style> element with no 'tibet:originalhref' or 'tibet:for'
     *         attribute, then it is not associated with any source location,
     *         which will be null.
     *         3. If the rule came from a sheet that is associated to a
     *         'generated' CSS <style> element, then we can try to trace the
     *         source of the rule.
     *             a. If the <style> element has a 'tibet:originalhref'
     *             attribute, then we obtain that as the source location of the
     *             rule.
     *             b. If the <style> element has a 'tibet:for' attribute, then
     *             there will be a <tibet:style> element that has an 'href'
     *             attribute. We obtain that as the source location of the rule.
     * @param {CSSStyleSheet} aStylesheet The style sheet to retrieve the
     *     location of.
     * @exception TP.sig.InvalidParameter
     * @returns {String} The location URL of the source of the stylesheet.
     */

    var loc,
        ownerElem,

        forRef,
        realOwnerElem;

    if (!TP.isStyleSheet(aStylesheet)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  If it has an 'href' property, use it.
    loc = aStylesheet.href;
    if (TP.notEmpty(loc)) {
        return loc;
    }

    //  Otherwise, if we can get to the stylesheet's owner node, then we run a
    //  set of alternate checks. return whatever
    ownerElem = TP.styleSheetGetOwnerNode(aStylesheet);
    if (TP.isElement(ownerElem)) {

        //  If the stylesheet's owner element has a 'tibet:originalhref'
        //  attribute that's not empty, return the value of that.
        loc = TP.elementGetAttribute(ownerElem, 'tibet:originalhref', true);
        if (TP.notEmpty(loc)) {
            //  Note here how we expand it to match the semantics of the value
            //  that we'll get from using the '.href' property at the start of
            //  this method.
            return TP.uriExpandPath(loc);
        }

        //  If the stylesheet's owner element has a 'tibet:for' attribute, then
        //  it's representing style content that has been processed or compiled
        //  in some way. This attribute will link this style element back to the
        //  originating element.
        forRef = TP.elementGetAttribute(ownerElem, 'tibet:for', true);
        if (TP.notEmpty(forRef)) {
            realOwnerElem = TP.byId(forRef,
                                    TP.nodeGetDocument(ownerElem),
                                    false);

            //  If we were able to compute a real owner element and it has an
            //  'href' attribute that's not empty, return the value of that..
            if (TP.isElement(realOwnerElem)) {
                loc = TP.elementGetAttribute(realOwnerElem, 'href', true);
                if (TP.notEmpty(loc)) {
                    //  Note here how we expand it to match the semantics of the
                    //  value that we'll get from using the '.href' property at
                    //  the start of this method.
                    return TP.uriExpandPath(loc);
                }
            }
        }
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('styleSheetGetOwnerNode',
function(aStylesheet) {

    /**
     * @method styleSheetGetOwnerNode
     * @summary Returns the 'owning node' (i.e. Element)  for the supplied
     *     stylesheet.
     * @param {CSSStyleSheet} aStylesheet The style sheet to retrieve the
     *     owner node of.
     * @exception TP.sig.InvalidParameter
     * @returns {Node} The owner node for the supplied stylesheet
     */

    var node,
        parentSS;

    if (!TP.isStyleSheet(aStylesheet)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  If there is an 'ownerNode', use it.
    node = aStylesheet.ownerNode;
    if (TP.isNode(node)) {
        return node;
    }

    parentSS = aStylesheet.parentStyleSheet;
    while (TP.isValid(parentSS) && !TP.isNode(parentSS.ownerNode)) {
        parentSS = parentSS.parentStyleSheet;
    }

    if (TP.isNode(parentSS.ownerNode)) {
        return parentSS.ownerNode;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('styleSheetGetStyleRules',
function(aStylesheet, expandImports, filterNonStyleRules) {

    /**
     * @method styleSheetGetStyleRules
     * @summary Retrieves the rules from the supplied stylesheet. Note that
     *     this function also recursively descends through CSS @import
     *     statements to retrieve any imported style rules.
     * @param {CSSStyleSheet} aStylesheet The style sheet to retrieve the rules
     *     from.
     * @param {Boolean} [expandImports=true] Whether or not @import statements
     *     should be recursively 'expanded' and the rules gathered from them
     *     from. This defaults to true.
     * @param {Boolean} [filterNonStyleRules=true] If true, the list is filtered
     *     for non-style rules.
     * @exception TP.sig.InvalidParameter
     * @returns {CSSStyleRule[]} A list of CSSStyleRule objects in the supplied
     *     CSSStyleSheet, including those that may have been imported using an.
     *     @import statement.
     */

    var resultRules,
        sheetRules,

        shouldExpand,

        i;

    if (!TP.isStyleSheet(aStylesheet)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    shouldExpand = TP.ifInvalid(expandImports, true);

    resultRules = TP.ac();

    //  Grab the rules from the sheet.
    sheetRules = aStylesheet.cssRules;

    //  Loop over each rule in the sheet and add the rule to our result
    //  Array.
    for (i = 0; i < sheetRules.length; i++) {
        //  If the rule is an '@import' rule, call this function recursively
        //  on the rule's 'stylesheet' property (which will be the actual
        //  stylesheet object of the stylesheet being imported) and add all
        //  of the rules found there to our result array.
        if (shouldExpand && sheetRules[i].type === CSSRule.IMPORT_RULE) {

            if (TP.isValid(sheetRules[i].styleSheet)) {
                resultRules.addAll(
                    TP.styleSheetGetStyleRules(
                        sheetRules[i].styleSheet, true, filterNonStyleRules));
            }
        } else {
            resultRules.push(sheetRules[i]);
        }
    }

    if (TP.isFalse(filterNonStyleRules)) {
        //  empty
    } else {
        //  Filter out all non CSSRule.STYLE_RULE 'rules'.
        resultRules = resultRules.filter(
                        function(aRule) {
                            return aRule.type === CSSRule.STYLE_RULE;
                        });
    }

    return resultRules;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('styleSheetGetStyleRulesMatching',
function(aStylesheet, selectorText) {

    /**
     * @method styleSheetGetStyleRulesMatching
     * @summary Retrieves the rules from the supplied stylesheet whose selector
     *     matches the supplied selector text. Note that this function also
     *     recursively descends through CSS @import statements to retrieve any
     *     imported style rules.
     * @param {CSSStyleSheet} aStylesheet The style sheet to retrieve the rules
     *     from.
     * @param {String} selectorText The text of the selector to match.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidString
     * @returns {CSSStyleRule[]} A list of CSS rules in the supplied style sheet,
     *     including those that may have been imported using an. @import
     *     statement, whose selector match the supplied selector text.
     */

    var resultRules,
        sheetRules,

        i;

    if (!TP.isStyleSheet(aStylesheet)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    if (TP.isEmpty(selectorText)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    resultRules = TP.ac();

    //  Grab the rules from the sheet.
    sheetRules = aStylesheet.cssRules;

    //  Loop over each rule in the sheet and add the rule to our result
    //  Array.
    for (i = 0; i < sheetRules.length; i++) {
        //  If the rule is an '@import' rule, call this function recursively
        //  on the rule's 'stylesheet' property (which will be the actual
        //  stylesheet object of the stylesheet being imported) and add all
        //  of the rules found there to our result array.
        if (sheetRules[i].type === CSSRule.IMPORT_RULE) {
            resultRules.addAll(
                    TP.styleSheetGetStyleRulesMatching(
                                    sheetRules[i].styleSheet,
                                    selectorText));
        } else if (sheetRules[i].selectorText === selectorText) {
            resultRules.push(sheetRules[i]);
        }
    }

    return resultRules;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('styleSheetInsertRule',
function(aStylesheet, selectorText, ruleText, ruleIndex, shouldSignal) {

    /**
     * @method styleSheetInsertRule
     * @summary Inserts a rule into the stylesheet specified at the specified
     *     rule index. Note that the rule text should *not* have the leading and
     *     trailing brackets.
     * @param {CSSStyleSheet} aStylesheet The style sheet to add the rule to.
     * @param {String} selectorText The CSS selectorText to use when applying
     *     the rule.
     * @param {String} ruleText The style text of the rule. This should *not*
     *     include the surrounding opening and closing braces ('{' and '}').
     * @param {Number} ruleIndex The index to insert the style rule at. If not
     *     supplied, the rule will be inserted at the end.
     * @param {Boolean} [shouldSignal=true] If false no signaling occurs.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidString
     * @returns {Number} The index of the newly created rule within the
     *     stylesheet element's rule set. This is important in case the rule
     *     needs to be deleted later. If the index was supplied to this method,
     *     this value will be the same as that supplied.
     */

    var nsRulesAdded,

        newRuleIndex,

        theRuleText,

        rule,
        ownerElem;

    if (!TP.isStyleSheet(aStylesheet)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  NB: We allow empty rule text
    if (TP.isEmpty(selectorText)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    //  If the selector text has namespace-qualified selector content, make sure
    //  that the namespace is defined.
    if (TP.regex.HAS_PIPE.test(selectorText)) {
        nsRulesAdded = TP.$styleSheetAddMissingNamespaceRules(
                            aStylesheet, selectorText, shouldSignal);
        if (TP.isNumber(ruleIndex)) {
            newRuleIndex = ruleIndex + nsRulesAdded;
        } else {
            newRuleIndex = aStylesheet.cssRules.length;
        }

    } else {
        newRuleIndex = TP.ifInvalid(ruleIndex, aStylesheet.cssRules.length);
    }

    newRuleIndex = TP.ifInvalid(ruleIndex, aStylesheet.cssRules.length);

    theRuleText = TP.ifInvalid(ruleText, '');

    newRuleIndex = aStylesheet.insertRule(
                        TP.join(selectorText, ' {', theRuleText, '}'),
                        newRuleIndex);

    if (TP.notFalse(shouldSignal)) {
        //  Grab the rule that we're inserting.
        rule = aStylesheet.cssRules[newRuleIndex];

        ownerElem = TP.styleSheetGetOwnerNode(aStylesheet);
        if (TP.isElement(ownerElem)) {

            //  Signal from our (wrapped) owner element that we added a style
            //  rule.
            TP.signal(TP.tpdoc(ownerElem),
                        'TP.sig.MutationStyleRuleChange',
                        TP.hc('mutationTarget', TP.wrap(ownerElem),
                                'mutatedRule', rule,
                                'ruleIndex', newRuleIndex,
                                'operation', TP.CREATE));
        }
    }

    return newRuleIndex;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$styleSheetRefreshAppliedRulesCaches',
function(aStylesheet) {

    /**
     * @method $styleSheetRefreshAppliedRulesCaches
     * @summary Refreshes all style rules for every element that will match
     *     style rules in the supplied style sheet.
     *     The end result of running this function is that every element in the
     *     document will have a 'TP.APPLIED_RULES' property that contains an
     *     Array of CSS style rules from the supplied stylesheet that apply to
     *     it.
     * @param {CSSStyleSheet} aStylesheet The style sheet to obtain the rules
     *     from.
     * @exception TP.sig.InvalidParameter
     */

    var sheetRules,

        parentSS,

        styleElem,

        doc,

        leni,
        i,
        aRule,

        elementsMatchingRule,

        lenj,
        j,
        matchingElement,

        appliedRules;

    if (!TP.isStyleSheet(aStylesheet)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  Iterate (if necessary) to find the stylesheet associated with the actual
    //  node (link, style, etc. element) that inserted it (because of @import,
    //  the supplied style sheet's 'parentStyleSheet' might not be that sheet).
    parentSS = aStylesheet;
    while (parentSS.parentStyleSheet) {
        parentSS = parentSS.parentStyleSheet;
    }

    styleElem = TP.styleSheetGetOwnerNode(parentSS);

    //  If the stylesheet came from a private TIBET stylesheet (normally
    //  used for IDE or other purposes), then don't consider it.
    if (styleElem[TP.TIBET_PRIVATE]) {
        return;
    }

    //  Grab all the stylesheets's CSS rules. Note here how we *do* expand
    //  imports, but we do *not* filter for CSSRule.STYLE_RULE types of rules.
    sheetRules = TP.styleSheetGetStyleRules(aStylesheet, true, false);

    doc = TP.nodeGetDocument(styleElem);

    //  Iterate over them, querying the document for any elements that match
    //  the selector text of the rule. Then, iterate over those elements and add
    //  the rule to its 'appliedRules' Array.
    leni = sheetRules.getSize();
    for (i = 0; i < leni; i++) {

        aRule = sheetRules.at(i);

        //  Not a CSSRule.STYLE_RULE? Must be an @import or a @namespace - move
        //  on.
        if (aRule.type !== CSSRule.STYLE_RULE) {
            continue;
        }

        //  Grab any elements that match the rule's selector
        elementsMatchingRule = TP.nodeEvaluateCSS(doc, aRule.selectorText);

        //  Iterate over those elements, and add the rule object to that
        //  element's list of applicable rules
        lenj = elementsMatchingRule.getSize();
        for (j = 0; j < lenj; j++) {

            matchingElement = elementsMatchingRule.at(j);

            appliedRules = matchingElement[TP.APPLIED_RULES];

            //  If the element doesn't have a TP.APPLIED_RULES property, we
            //  *don't* create one here. Otherwise, that cache will be
            //  out-of-date because it will only reflect the rules in the
            //  imported sheet. Much better to not install one and let the
            //  element force a refresh of the document styles, which will
            //  reflect all of the rules from all of the sheets that will be
            //  applied to this element.
            if (TP.notValid(appliedRules)) {
                continue;
            }

            appliedRules.push(aRule);
            appliedRules.unique();
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('styleSheetRemoveRule',
function(aStylesheet, ruleIndex, shouldSignal) {

    /**
     * @method styleSheetRemoveRule
     * @summary Removes the stylesheet rule at the rule index of the stylesheet
     *     element specified.
     * @param {CSSStyleSheet} aStylesheet The style sheet to remove the rule
     *     from.
     * @param {Number} ruleIndex The index of the rule within the stylesheet to
     *     remove.
     * @param {Boolean} [shouldSignal=true] If false no signaling occurs.
     * @exception TP.sig.InvalidParameter
     */

    var rule,
        ownerElem;

    if (!TP.isStyleSheet(aStylesheet)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  Grab the rule that we're deleting.
    rule = aStylesheet.cssRules[ruleIndex];

    //  The W3C standard is 'deleteRule'.
    aStylesheet.deleteRule(ruleIndex);

    if (TP.notFalse(shouldSignal)) {

        ownerElem = TP.styleSheetGetOwnerNode(aStylesheet);
        if (TP.isElement(ownerElem)) {

            //  Signal from our (wrapped) owner element that we removed a style
            //  rule.
            TP.signal(TP.tpdoc(ownerElem),
                        'TP.sig.MutationStyleRuleChange',
                        TP.hc('mutationTarget', TP.wrap(ownerElem),
                                'mutatedRule', rule,
                                'ruleIndex', ruleIndex,
                                'operation', TP.DELETE));
        }
    }

    return;
});

//  ------------------------------------------------------------------------
//  ELEMENT-LEVEL FUNCTIONS
//  ------------------------------------------------------------------------

TP.definePrimitive('cssElementGetStyleSheet',
function(anElement) {

    /**
     * @method cssElementGetStyleSheet
     * @summary Returns the CSS style sheet object belonging to anElement,
     *     which must be either a 'link' or a 'style' element. NB: The caller
     *     *must* supply a 'link' or 'style' element here, or an
     *     'TP.sig.InvalidElement' exception will be thrown.
     * @param {Element} anElement The element to retrieve the CSS style sheet
     *     object for.
     * @exception TP.sig.InvalidElement
     * @returns {CSSStyleSheet} The style sheet object.
     */

    var localName;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    localName = TP.elementGetLocalName(anElement).toLowerCase();

    if (localName !== 'link' && localName !== 'style') {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    return anElement.sheet;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETCSSPrimitivesPlatform.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
Platform-specific functionality related to CSS operations.
*/

//  ------------------------------------------------------------------------
//  ELEMENT PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('$elementCSSFlush',
TP.hc(
    TP.DEFAULT,
    function(anElement) {

        /**
         * @method $elementCSSFlush
         * @summary Jiggers the element to flush out any CSS changes. IE should
         *     do this automatically, but won't sometimes, especially for
         *     'custom' attributes.
         * @param {Element} anElement The element to flush the CSS style changes
         *     for.
         * @exception TP.sig.InvalidElement
         */

        var styleObj;

        styleObj = TP.elementGetStyleObj(anElement);

        styleObj.transform = 'rotateZ(0deg)';
        styleObj.transform = 'none';

        return;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('elementClearStyleProperty',
TP.hc(
    TP.DEFAULT,
    function(anElement, propertyName) {

        /**
         * @method elementClearStyleProperty
         * @summary Clears the style property on the element provided.
         * @param {Element} anElement The element to clear the style property
         *     on.
         * @param {String} propertyName The name of the CSS property to clear on
         *     the provided element.
         */

        TP.elementGetStyleObj(anElement)[propertyName] = '';

        return;
    }
));

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETCSSPrimitivesPost.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 */

//  ========================================================================
//  CSS2/CSS3 SUPPORT
//  ========================================================================

/*
*/

//  ------------------------------------------------------------------------
//  Global variables
//  ------------------------------------------------------------------------

(function() {
    var cssKeys;

    //  Strange that Gecko does this in a different way, but we obtain a similar
    //  result. Note that we have to filter out keys containing a '-' (which
    //  curiously are duplicates of the camel case DOM versions of the property
    //  names).
    if (TP.sys.isUA('GECKO')) {
        cssKeys = Object.getOwnPropertyNames(
                    Object.getPrototypeOf(document.documentElement.style));
        cssKeys = cssKeys.filter(
                    function(aKey) {
                        return aKey.indexOf('-') === TP.NOT_FOUND;
                    });
    } else {
        cssKeys = Object.getOwnPropertyNames(document.documentElement.style);
    }

    cssKeys.sort();

    TP.CSS_ALL_PROPERTIES = cssKeys;

    if (TP.notValid(window.CSS)) {
        window.CSS = {};
    }

    if (TP.notValid(window.CSS.prototype)) {
        window.CSS.prototype = {};
    }

    cssKeys.forEach(
            function(aKey) {
                CSS.prototype[aKey] = aKey.asCSSName();
            });
}());

TP.CSS_COLOR_PROPERTIES = TP.ac('backgroundColor',
                                'borderColor',
                                'borderBottomColor',
                                'borderLeftColor',
                                'borderRightColor',
                                'borderTopColor',
                                'color',
                                'outlineColor');

TP.CSS_LENGTH_PROPERTIES = TP.ac('borderWidth',
                                    'borderBottomWidth',
                                    'borderLeftWidth',
                                    'borderRightWidth',
                                    'borderTopWidth',
                                    'bottom',
                                    'fontSize',
                                    'height',
                                    'left',
                                    'letterSpacing',
                                    'lineHeight',
                                    'margin',
                                    'marginBottom',
                                    'marginLeft',
                                    'marginRight',
                                    'marginTop',
                                    'maxHeight',
                                    'maxWidth',
                                    'minHeight',
                                    'minWidth',
                                    'outlineWidth',
                                    'padding',
                                    'paddingBottom',
                                    'paddingLeft',
                                    'paddingRight',
                                    'paddingTop',
                                    'right',
                                    'textIndent',
                                    'top',
                                    'verticalAlign',
                                    'width',
                                    'wordSpacing');

TP.CSS_UNITLESS_PROPERTIES = TP.ac('opacity',
                                    'orphans',
                                    'widows',
                                    'zIndex');

TP.CSS_DISALLOW_NEGATIVE_VALUES = TP.ac('borderWidth',
                                        'borderBottomWidth',
                                        'borderLeftWidth',
                                        'borderRightWidth',
                                        'borderTopWidth',
                                        'fontSize',
                                        'height',
                                        'lineHeight',
                                        'maxHeight',
                                        'maxWidth',
                                        'minHeight',
                                        'minWidth',
                                        'opacity',
                                        'outlineWidth',
                                        'paddingBottom',
                                        'paddingLeft',
                                        'paddingRight',
                                        'paddingTop',
                                        'width');

TP.regex.CSS_NON_NEGATIVE_PROPERTIES = new RegExp(
    '^' +
    TP.CSS_DISALLOW_NEGATIVE_VALUES.collect(
        function(domName) {
            return domName.asCSSName();
        }).join('|') +
    '$');

TP.CSS_INHERITED_PROPERTIES = TP.ac('azimuth',
                                    'borderCollapse',
                                    'borderSpacing',
                                    'captionSide',
                                    'color',
                                    'cursor',
                                    'direction',
                                    'elevation',
                                    'emptyCells',
                                    'fontFamily',
                                    'fontSize',
                                    'fontStyle',
                                    'fontVariant',
                                    'fontWeight',
                                    'fontSizeAdjust',
                                    'fontStretch',
                                    'font',
                                    'letterSpacing',
                                    'lineHeight',
                                    'listStyleImage',
                                    'listStylePosition',
                                    'listStyleType',
                                    'listStyle',
                                    'orphans',
                                    'pitchRange',
                                    'pitchQuotes',
                                    'quotes',
                                    'richness',
                                    'speakHeader',
                                    'speakNumeric',
                                    'speakPunctuation',
                                    'speak',
                                    'speechRate',
                                    'stress',
                                    'tabSize',
                                    'textAlign',
                                    'textAlignLast',
                                    'textDecorationColor',
                                    'textIndent',
                                    'textJustify',
                                    'textShadow',
                                    'textTransform',
                                    'visibility',
                                    'voiceFamily',
                                    'volume',
                                    'whiteSpace',
                                    'widows',
                                    'wordBreak',
                                    'wordSpacing',
                                    'wordWrap');

TP.regex.CSS_COLOR_PROPERTY = /color/i;

//  A TP.core.Hash of CSS color names. Note that the CSS3 color module
//  specification states that these should be case-insensitive, but for
//  comparison purposes, we lowercase them all.
TP.CSS_COLOR_NAMES = TP.hc(
                        'aliceblue', '#F0F8FF',
                        'antiquewhite', '#FAEBD7',
                        'aqua', '#00FFFF',
                        'aquamarine', '#7FFFD4',
                        'azure', '#F0FFFF',
                        'beige', '#F5F5DC',
                        'bisque', '#FFE4C4',
                        'black', '#000000',
                        'blanchedalmond', '#FFEBCD',
                        'blue', '#0000FF',
                        'blueviolet', '#8A2BE2',
                        'brown', '#A52A2A',
                        'burlywood', '#DEB887',
                        'cadetblue', '#5F9EA0',
                        'chartreuse', '#7FFF00',
                        'chocolate', '#D2691E',
                        'coral', '#FF7F50',
                        'cornflowerblue', '#6495ED',
                        'cornsilk', '#FFF8DC',
                        'crimson', '#DC143C',
                        'cyan', '#00FFFF',
                        'darkblue', '#00008B',
                        'darkcyan', '#008B8B',
                        'darkgoldenrod', '#B8860B',
                        'darkgray', '#A9A9A9',
                        'darkgrey', '#A9A9A9',
                        'darkgreen', '#006400',
                        'darkkhaki', '#BDB76B',
                        'darkmagenta', '#8B008B',
                        'darkolivegreen', '#556B2F',
                        'darkorange', '#FF8C00',
                        'darkorchid', '#9932CC',
                        'darkred', '#8B0000',
                        'darksalmon', '#E9967A',
                        'darkseagreen', '#8FBC8F',
                        'darkslateblue', '#483D8B',
                        'darkslategray', '#2F4F4F',
                        'darkslategrey', '#2F4F4F',
                        'darkturquoise', '#00CED1',
                        'darkviolet', '#9400D3',
                        'deeppink', '#FF1493',
                        'deepskyblue', '#00BFFF',
                        'dimgray', '#696969',
                        'dimgrey', '#696969',
                        'dodgerblue', '#1E90FF',
                        'firebrick', '#B22222',
                        'floralwhite', '#FFFAF0',
                        'forestgreen', '#228B22',
                        'fuchsia', '#FF00FF',
                        'gainsboro', '#DCDCDC',
                        'ghostwhite', '#F8F8FF',
                        'gold', '#FFD700',
                        'goldenrod', '#DAA520',
                        'gray', '#808080',
                        'grey', '#808080',
                        'green', '#00FF00',
                        'greenyellow', '#ADFF2F',
                        'honeydew', '#F0FFF0',
                        'hotpink', '#FF69B4',
                        'indianred', '#CD5C5C',
                        'indigo', '#4B0082',
                        'ivory', '#FFFFF0',
                        'khaki', '#F0E68C',
                        'lavender', '#E6E6FA',
                        'lavenderblush', '#FFF0F5',
                        'lawngreen', '#7CFC00',
                        'lemonchiffon', '#FFFACD',
                        'lightblue', '#ADD8E6',
                        'lightcoral', '#F08080',
                        'lightcyan', '#E0FFFF',
                        'lightgoldenrodyellow', '#FAFAD2',
                        'lightgray', '#D3D3D3',
                        'lightgrey', '#D3D3D3',
                        'lightgreen', '#90EE90',
                        'lightpink', '#FFB6C1',
                        'lightsalmon', '#FFA07A',
                        'lightseagreen', '#20B2AA',
                        'lightskyblue', '#87CEFA',
                        'lightslategray', '#778899',
                        'lightslategrey', '#778899',
                        'lightsteelblue', '#B0C4DE',
                        'lightyellow', '#FFFFE0',
                        'lime', '#00FF00',
                        'limegreen', '#32CD32',
                        'linen', '#FAF0E6',
                        'magenta', '#FF00FF',
                        'maroon', '#800000',
                        'mediumaquamarine', '#66CDAA',
                        'mediumblue', '#0000CD',
                        'mediumorchid', '#BA55D3',
                        'mediumpurple', '#9370D8',
                        'mediumseagreen', '#3CB371',
                        'mediumslateblue', '#7B68EE',
                        'mediumspringgreen', '#00FA9A',
                        'mediumturquoise', '#48D1CC',
                        'mediumvioletred', '#C71585',
                        'midnightblue', '#191970',
                        'mintcream', '#F5FFFA',
                        'mistyrose', '#FFE4E1',
                        'moccasin', '#FFE4B5',
                        'navajowhite', '#FFDEAD',
                        'navy', '#000080',
                        'oldLace', '#FDF5E6',
                        'olive', '#808000',
                        'olivedrab', '#6B8E23',
                        'orange', '#FFA500',
                        'orangered', '#FF4500',
                        'orchid', '#DA70D6',
                        'palegoldenrod', '#EEE8AA',
                        'palegreen', '#98FB98',
                        'paleturquoise', '#AFEEEE',
                        'palevioletred', '#D87093',
                        'papayawhip', '#FFEFD5',
                        'peachpuff', '#FFDAB9',
                        'peru', '#CD853F',
                        'pink', '#FFC0CB',
                        'plum', '#DDA0DD',
                        'powderblue', '#B0E0E6',
                        'purple', '#800080',
                        'rebeccapurple', '#663399',
                        'red', '#FF0000',
                        'rosybrown', '#BC8F8F',
                        'royalblue', '#4169E1',
                        'saddlebrown', '#8B4513',
                        'salmon', '#FA8072',
                        'sandybrown', '#F4A460',
                        'seagreen', '#2E8B57',
                        'seashell', '#FFF5EE',
                        'sienna', '#A0522D',
                        'silver', '#C0C0C0',
                        'skyblue', '#87CEEB',
                        'slateblue', '#6A5ACD',
                        'slategray', '#708090',
                        'slategrey', '#708090',
                        'snow', '#FFFAFA',
                        'springgreen', '#00FF7F',
                        'steelblue', '#4682B4',
                        'tan', '#D2B48C',
                        'teal', '#008080',
                        'thistle', '#D8BFD8',
                        'tomato', '#FF6347',
                        'turquoise', '#40E0D0',
                        'violet', '#EE82EE',
                        'wheat', '#F5DEB3',
                        'white', '#FFFFFF',
                        'whitesmoke', '#F5F5F5',
                        'yellow', '#FFFF00',
                        'yellowgreen', '#9ACD32');

//  Note that we need to use older 'new RegExp' syntax here because of
//  bootstrapping issues.
TP.regex.JQUERY_EXTENDED_SELECTORS =
    new RegExp('(:first|:last|:even|:odd|' +
                ':eq|:gt|:lt|' +
                ':header|:animated|:contains|:has|:parent|' +
                ':hidden|:visible|' +
                ':input|:text|:password|:radio|:checkbox|:submit|:image|' +
                ':reset|:button|:file|:hidden|' +
                ':selected)');

//  ------------------------------------------------------------------------
//  COLOR PRIMITIVES
//  ------------------------------------------------------------------------

TP.definePrimitive('colorStringAsHex',
function(aString) {

    /**
     * @method colorStringAsHex
     * @summary Converts a String containing a color value to a String
     *     containing the hex-formatted value: #RRGGBB
     * @description The supplied String can be in one of nine formats: FFFFFF
     *     #FFFFFF FFF #FFF rgb(255, 255, 255) rgba(255, 255, 255, .5) hsl(120,
     *     50%, 50%) hsla(120, 50%, 50%, .5) <aColorName>
     * @param {String} aString The String containing color information to
     *     convert.
     * @exception TP.sig.InvalidParameter
     * @returns {String} A String having this color value expressed as a hex
     *     color: #RRGGBB.
     */

    var strSize,

        parts,
        colorString,

        rgbResults;

    if (!TP.isString(aString)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    if (/transparent/.test(aString)) {
        return aString;
    }

    //  If its already a hex color, canonicalize it (a '#' followed by 7
    //  uppercase characters).
    if (TP.regex.CSS_HEX.test(aString)) {
        strSize = aString.getSize();

        //  If its 7 characters, then its already canonicalized
        if (strSize === 7) {
            colorString = aString;
        } else if (strSize === 6) {
            //  Otherwise, its just missing its '#' character
            colorString = '#' + aString;
        } else if (strSize === 3 || strSize === 4) {
            //  Grab the result of the second grouping (since this isn't a
            //  'full' CSS value, there won't be anything in the first
            //  grouping) and split it into individual characters.
            parts = TP.regex.CSS_HEX.exec(aString).at(2).split('');

            //  Prepend a '#' and then double each character found.
            colorString = TP.join('#',
                            parts.at(0), parts.at(0),
                            parts.at(1), parts.at(1),
                            parts.at(2), parts.at(2));
        } else {
            //  The hex string wasn't either 4 or 7 and there was no valid
            //  colorString (by using the lookup for a color name above), so
            //  we can't do anything else and bail out here.
            return null;
        }

        //  Make sure its all uppercase for consistency.
        return colorString.toUpperCase();
    }

    colorString = null;

    rgbResults = null;

    if (TP.regex.CSS_RGB.test(aString) ||
        TP.regex.CSS_RGBA.test(aString) ||
        TP.regex.CSS_HSL.test(aString) ||
        TP.regex.CSS_HSLA.test(aString)) {
        rgbResults = TP.colorStringAsArray(aString);
    }

    if (TP.isArray(rgbResults)) {
        //  If the results had an alpha value, pop it off since we can't use
        //  it here anyway.
        if (rgbResults.getSize() === 4) {
            rgbResults.pop();
        }

        //  Start with a '#'.
        colorString = '#';

        //  Run a collect, converting each String bit into the
        //  corresponding hex value (and making sure it's 0 padded to 2
        //  places).
        rgbResults = rgbResults.collect(
            function(numStr) {

                var componentString;

                componentString =
                    parseInt(numStr, 10).toString(16).pad(2, '0', TP.RIGHT);

                return componentString;
            });

        //  Join it and uppercase it to form the #RRGGBB
        colorString += rgbResults.join('').toUpperCase();

        return colorString;
    }

    //  It wasn't a color starting with 'rgb(', and it didn't start with
    //  '#', so see if its one of the 'color names' as defined in the
    //  CSS_COLOR_NAMES on this object (this map hands back #RRGGBB values).
    //  If it's not, this will just return null.
    if (TP.notValid(colorString = TP.CSS_COLOR_NAMES.at(
                                                aString.toLowerCase()))) {
        return null;
    }

    return colorString;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('colorStringAsArray',
function(aString) {

    /**
     * @method colorStringAsArray
     * @summary Converts a String containing a color to an Array containing,
     *     [r, g, b]
     * @description The supplied String can be in one of nine formats: FFFFFF
     *     #FFFFFF FFF #FFF rgb(255, 255, 255) rgba(255, 255, 255, .5) hsl(120,
     *     50%, 50%) hsla(120, 50%, 50%, .5) <aColorName>
     * @param {String} aString The String containing color information to
     *     convert.
     * @exception TP.sig.InvalidParameter
     * @returns {Number[]} An Array having this color value expressed as 3 Numbers
     *     [r, g, b].
     */

    var results,

        colorString,

        r,
        g,
        b;

    if (!TP.isString(aString)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  If its an 'rgba' color, then process it separately and bail out
    //  here.
    if (TP.regex.CSS_RGBA.test(aString)) {
        //  Pull the 4 numbers out of the String.
        results = TP.regex.CSS_RGBA.match(aString);

        //  Get rid of the 'whole match'
        results.shift();

        //  Convert the results to Numbers

        //  Red, Green, Blue
        results.atPut(0, parseInt(results.at(0), 10));
        results.atPut(1, parseInt(results.at(1), 10));
        results.atPut(2, parseInt(results.at(2), 10));

        //  Alpha
        results.atPut(3, parseFloat(results.at(3)));

        return results;
    }

    //  If its an 'rgb' color, then process it separately and bail out
    //  here.
    if (TP.regex.CSS_RGB.test(aString)) {
        //  Pull the 3 numbers out of the String.
        results = TP.regex.CSS_RGB.match(aString);

        //  Get rid of the 'whole match'
        results.shift();

        //  Convert the results to Numbers

        //  Red, Green, Blue
        results.atPut(0, parseInt(results.at(0), 10));
        results.atPut(1, parseInt(results.at(1), 10));
        results.atPut(2, parseInt(results.at(2), 10));

        return results;
    }

    //  If its an 'hsla' color, then process it separately and bail out
    //  here.
    if (TP.regex.CSS_HSLA.test(aString)) {
        //  Pull the 4 numbers out of the String.
        results = TP.regex.CSS_HSLA.match(aString);

        //  Get rid of the 'whole match'
        results.shift();

        //  Convert the results to Numbers

        //  Hue, Saturation, Lightness, Alpha

        //  Convert to RGB
        results = TP.rgbaValuesAsHSLA(parseFloat(results.at(0)),
                                        parseFloat(results.at(1)) / 100,
                                        parseFloat(results.at(2)) / 100,
                                        parseFloat(results.at(3)));

        return results;
    }

    //  If its an 'hsl' color, then process it separately and bail out
    //  here.
    if (TP.regex.CSS_HSL.test(aString)) {
        //  Pull the 4 numbers out of the String.
        results = TP.regex.CSS_HSL.match(aString);

        //  Get rid of the 'whole match'
        results.shift();

        //  Convert the results to Numbers

        //  Hue, Saturation, Lightness, Alpha

        //  Convert to RGB
        results = TP.rgbaValuesAsHSLA(parseFloat(results.at(0)),
                                        parseFloat(results.at(1)) / 100,
                                        parseFloat(results.at(2)) / 100);

        return results;
    }

    //  Get the color string canonicalized into a form of '#RRGGBB'
    colorString = TP.colorStringAsHex(aString);

    if (TP.isEmpty(colorString)) {
        return null;
    }

    //  Loop over the color, slicing out the hex digits, and turn them into
    //  decimal Number values to populate the array.
    r = parseInt(colorString.slice(0 * 2 + 1, 0 * 2 + 3), 16);
    g = parseInt(colorString.slice(1 * 2 + 1, 1 * 2 + 3), 16);
    b = parseInt(colorString.slice(2 * 2 + 1, 2 * 2 + 3), 16);

    return TP.ac(r, g, b);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('colorStringAsLongNumber',
function(aString) {

    /**
     * @method colorStringAsLongNumber
     * @summary Converts a String containing a color value to a 'long' number
     *     representing the color numerically.
     * @description The supplied String can be in one of nine formats: FFFFFF
     *     #FFFFFF FFF #FFF rgb(255, 255, 255) rgba(255, 255, 255, .5) hsl(120,
     *     50%, 50%) hsla(120, 50%, 50%, .5) <aColorName>
     * @param {String} aString The String containing color information to
     *     convert.
     * @exception TP.sig.InvalidParameter
     * @returns {Number} A 'long' number (one between 0 and 16777215 -
     *     parseInt('FFFFFF',16) ).
     */

    var hexString;

    if (!TP.isString(aString)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    if (TP.isString(hexString = TP.colorStringAsHex(aString))) {
        //  Make sure and slice off the '#'
        return parseInt(hexString.slice(1), 16);
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('colorValuesInterpolate',
function(color1, color2, aPercentage) {

    /**
     * @method colorValuesInterpolate
     * @summary Interpolates a mixture of color2 into color1 according to the
     *     supplied percentage.
     * @description This algorithm from Oliver Steele (http://osteele.com).
     * @param {Number} color1 A 'long' number (one between 0 and 16777215 -
     *     parseInt('FFFFFF',16) ) that specifies the color to start from.
     * @param {Number} color2 A 'long' number (one between 0 and 16777215 -
     *     parseInt('FFFFFF',16) ) that specifies the color to end at.
     * @param {Number} aPercentage The percentage of color2 that should be mixed
     *     into color1.
     * @exception TP.sig.InvalidNumber
     * @returns {Number} The number that is a mix of color1 and color using the
     *     supplied percentage.
     */

    var n,

        i,

        ca,
        cb,
        cc;

    if (!TP.isNumber(color1) ||
        !TP.isNumber(color2) ||
        !TP.isNumber(aPercentage)) {
        return TP.raise(this, 'TP.sig.InvalidNumber');
    }

    n = 0;

    /* eslint-disable no-constant-condition,no-extra-parens,semi-spacing */
    for (i = 24; (i -= 8) >= 0;) {
        ca = (color1 >> i) & 0xFF;
        cb = (color2 >> i) & 0xFF;
        cc = Math.floor(ca * (1 - aPercentage) + cb * aPercentage);
        n |= cc << i;
    }
    /* eslint-enable no-constant-condition,no-extra-parens,semi-spacing */

    return n;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('longNumberAsColorString',
function(aLongNumber) {

    /**
     * @method longNumberAsColorString
     * @summary Converts a 'long' number representing a color numerically to
     *     the equivalent 'hex' color (#RRGGBB) used for CSS colors.
     * @description This algorithm from Oliver Steele (http://osteele.com).
     * @param {Number} aLongNumber A 'long' number (one between 0 and 16777215 -
     *     parseInt('FFFFFF',16) ).
     * @exception TP.sig.InvalidNumber
     * @returns {String} A color 'hex' String.
     */

    var hexChars,
        str,

        i;

    if (!TP.isNumber(aLongNumber)) {
        return TP.raise(this, 'TP.sig.InvalidNumber');
    }

    hexChars = '0123456789ABCDEF';
    str = '#';

    /* eslint-disable no-constant-condition,no-extra-parens,semi-spacing */
    for (i = 24; (i -= 4) >= 0;) {
        str += hexChars.charAt((aLongNumber >> i) & 0xF);
    }
    /* eslint-enable no-constant-condition,no-extra-parens,semi-spacing */

    return str;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('rgbValuesAsHue',
function(m1, m2, aHue) {

    /**
     * @method rgbValuesAsHue
     * @summary Converts the supplied hue (given by the values) to its RGB
     *     equivalent.
     * @description This uses the CSS3 Color Module algorithm for converting
     *     hsla values to rgba.
     * @param {Number} m1
     * @param {Number} m2
     * @param {Number} aHue The color hue information.
     * @exception TP.sig.InvalidParameter
     * @returns {Number} The converted number.
     */

    var hue,
        hue6;

    if (!TP.isNumber(m1) || !TP.isNumber(m2) || !TP.isNumber(aHue)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    hue = aHue;

    if (hue < 0) {
        hue++;
    }

    if (hue > 1) {
        hue--;
    }

    hue6 = hue * 6;

    if (hue6 < 1) {
        return m1 + (m2 - m1) * hue6;
    }

    /* eslint-disable no-extra-parens */
    if ((hue * 2) < 1) {
        return m2;
    }

    if ((hue * 3) < 2) {
        return m1 + (m2 - m1) * (2 / 3 - hue) * 6;
    }
    /* eslint-enable no-extra-parens */

    return m1;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('rgbaValuesAsHSLA',
function(aHue, aSaturation, aLightness, anAlpha) {

    /**
     * @method rgbaValuesAsHSLA
     * @summary Converts the supplied hue, saturation, lightness and alpha
     *     values to their RGB equivalents.
     * @description This uses the CSS3 Color Module algorithm for converting
     *     hsla values to rgba.
     * @param {Number} aHue The color hue information.
     * @param {Number} aSaturation The color saturation information, given as a
     *     fractional number between 0 and 1.
     * @param {Number} aLightness The color lightness information, given as a
     *     fractional number between 0 and 1.
     * @param {Number} anAlpha The color alpha information.
     * @exception TP.sig.InvalidParameter
     * @returns {Number[]} The color expressed as an RGBA value in an Array of [r,
     *     g, b, a].
     */

    var theHue,

        m1,
        m2,

        redVal,
        blueVal,
        greenVal,

        rgbVal;

    //  NB: We don't check alpha here since it is optional and is just
    //  copied over anyway.
    if (!TP.isNumber(aHue) ||
        !TP.isNumber(aSaturation) ||
        !TP.isNumber(aLightness)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    /* eslint-disable no-extra-parens */

    theHue = ((aHue % 360) + 360) % 360 / 360;

    if (aLightness <= 0.5) {
        m2 = aLightness * (aSaturation + 1);
    } else {
        m2 = aLightness + aSaturation - (aLightness * aSaturation);
    }

    m1 = (aLightness * 2) - m2;

    //  Red value
    redVal = TP.rgbValuesAsHue(m1, m2, theHue + (1 / 3)) * 256;

    //  Blue value
    blueVal = TP.rgbValuesAsHue(m1, m2, theHue) * 256;

    //  Green value
    greenVal = TP.rgbValuesAsHue(m1, m2, theHue - (1 / 3)) * 256;

    /* eslint-enable no-extra-parens */

    rgbVal = TP.ac(redVal, blueVal, greenVal);

    //  If an alpha value was supplied, go ahead and push it here.
    if (TP.isNumber(anAlpha)) {
        rgbVal.push(anAlpha);
    }

    return rgbVal;
});

//  ------------------------------------------------------------------------
//  CSS QUERYING
//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetNumericValueFromPercentage',
function(anElement, aPropertyName, aPercentage, wantsTransformed) {

    /**
     * @method elementGetNumericValueFromPercentage
     * @summary This method computes the numeric value for the given element
     *     name, property name and percentage value and the property name. Note
     *     that, for properties that compute a percentage of the (possibly
     *     offset) parent, this method will recurse upwards if that parent is
     *     also found to have a percentage value.
     * @description Depending on the property being requested, a percentage
     *     value can mean different things. In most cases, it is computed as a
     *     percentage of the containing block, but there are a few exceptions:
     *
     *     font-size: relative to font-size of parent element
     *
     *     line-height: relative to font-size of element itself
     *
     *     vertical-align: relative to line-height of element itself
     *
     *     word-spacing: relative to the width of a space (U+0020)
     *
     *     text-indent: relative to width of containing block
     *
     *     height: height of containing block width: width of containing block
     *     min-height: height of containing block min-width: width of containing
     *     block max-height: height of containing block max-width: width of
     *     containing block
     *
     *     margin-top: width of containing block margin-right: width of
     *     containing block margin-bottom: width of containing block
     *     margin-left: width of containing block
     *
     *     padding-top: width of containing block padding-right: width of
     *     containing block padding-bottom: width of containing block
     *     padding-left: width of containing block
     *
     *     top: height of containing block right: width of containing block
     *     bottom: height of containing block left: width of containing block
     *
     *
     * @param {HTMLElement} anElement The element to obtain the numeric value
     *     for.
     * @param {String} aPropertyName The property name to obtain the numeric
     *     value for.
     * @param {String} aPercentage The percentage value to use to compute the
     *     numeric value.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidParameter
     * @returns {Number} A number of that can be computed from the supplied
     *     element, property and percentage.
     */

    var theValue,
        factor,

        targetElement,

        pixelValue;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(aPropertyName) || TP.isEmpty(aPercentage)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    /* eslint-disable no-fallthrough */

    //  Different properties compute their percentages differently. Switch
    //  based on the name of the desired property and grab both the element
    //  that we're targeting to get a real value from so that we multiply
    //  below against the supplied percentage.
    switch (aPropertyName) {
        case 'fontSize':

            //  When fontSize is a percentage, it is computed from the
            //  element's *parent node* fontSize.
            if (!TP.isElement(targetElement = anElement.parentNode)) {
                return 0;
            }
            theValue = TP.elementGetComputedStyleValueInPixels(
                                                        targetElement,
                                                        'fontSize');

            break;

        case 'lineHeight':

            //  When lineHeight is a percentage, it is computed from the
            //  element's fontSize.
            targetElement = anElement;
            theValue = TP.elementGetComputedStyleValueInPixels(
                                                        targetElement,
                                                        'fontSize');

            break;

        case 'verticalAlign':

            //  When verticalAlign is a percentage, it is computed from the
            //  element's lineHeight.
            targetElement = anElement;
            theValue = TP.elementGetComputedStyleValueInPixels(
                                                        targetElement,
                                                        'lineHeight');
            break;

        case 'height':
        case 'minHeight':
        case 'maxHeight':

        case 'top':
        case 'bottom':

            //  These are all computed from the *height* of the
            //  offsetParent.

            //  Vertical measurements are computed from the *offset
            //  parent*, not the parent node.
            if (!TP.isElement(targetElement =
                                TP.elementGetOffsetParent(anElement))) {
                //  If its the body element, then we can go ahead and use
                //  the parent node, since we know that's the document
                //  element.
                if (anElement ===
                        TP.documentGetBody(TP.nodeGetDocument(anElement))) {
                    targetElement = anElement.parentNode;
                } else {
                    return 0;
                }
            }

            theValue = targetElement.offsetHeight;
            break;

        case 'width':
        case 'minWidth':
        case 'maxWidth':

        case 'left':
        case 'right':

            //  Weird that margin/padding - top/bottom are computed from the
            //  containing block's *width*, but that's what the spec says...
        case 'marginTop':
        case 'marginRight':
        case 'marginLeft':
        case 'marginBottom':

        case 'paddingTop':
        case 'paddingRight':
        case 'paddingLeft':
        case 'paddingBottom':

        case 'textIndent':

            //  These are all computed from the *width* of the
            //  offsetParent.

            //  Horizontal (and other) measurements are computed from the
            //  *offset parent*, not the parent node, unless its the body
            //  element ;-).
            if (!TP.isElement(targetElement =
                                TP.elementGetOffsetParent(anElement))) {
                //  If its the body element, then we can go ahead and use
                //  the parent node, since we know that's the document
                //  element.
                if (anElement ===
                        TP.documentGetBody(TP.nodeGetDocument(anElement))) {
                    targetElement = anElement.parentNode;
                } else {
                    return 0;
                }
            }

            theValue = targetElement.offsetWidth;
            break;

        case 'wordSpacing':

            //  percentage of the width of a space (U+0020) glyph

            //  TODO: Do this

            break;

        default:

            //  If the property wasn't in our list, bail out here with 0.

            //  This includes the following properties that look like they
            //  should accept percentages, but don't:

            //  borderWidth
            //  borderBottomWidth
            //  borderLeftWidth
            //  borderRightWidth
            //  borderTopWidth
            //  letterSpacing
            //  opacity
            //  outlineWidth
            //  zIndex

            return 0;
    }
    /* eslint-enable no-fallthrough */

    //  If the returned value is itself a percentage, then we need to
    //  recurse upward to whatever the 'target element' was, in an attempt
    //  to get to a non-percentage value.
    if (TP.regex.PERCENTAGE.test(theValue)) {
        theValue = TP.elementGetNumericValueFromPercentage(
                                targetElement, aPropertyName, theValue);
    }

    //  Grab the pixel value of the value as computed against our target
    //  element. This is in case we have a value like '3em'.
    pixelValue = TP.elementGetPixelValue(targetElement,
                                            theValue,
                                            aPropertyName);

    //  If we didn't get back a Number, bail out here with 0.
    if (TP.isNaN(pixelValue)) {
        return 0;
    }

    //  Compute the factor by parsing a Number from the percentage and
    //  dividing it by 100. If that's successful, multiply the pixel value
    //  by it.
    if (TP.isNumber(factor = parseFloat(aPercentage) / 100)) {
        pixelValue *= factor;
    } else {
        //  If we couldn't compute a Number, bail out here with 0.
        return 0;
    }

    if (TP.isTrue(wantsTransformed)) {
        pixelValue = TP.elementTransformCSSPixelValue(targetElement,
                                                        pixelValue,
                                                        aPropertyName);
    }

    return pixelValue;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetPropertyValueAsNumber',
function(anElement, aPropertyName, aPropertyValue, wantsTransformed) {

    /**
     * @method elementGetPropertyValueAsNumber
     * @summary Returns the value of the supplied property on the supplied
     *     element as a Number. This method also manages percentage value
     *     formats.
     * @param {HTMLElement} anElement The element to retrieve the numeric value
     *     for.
     * @param {String} aPropertyName The property name to return the numeric
     *     value for.
     * @param {String} aPropertyValue The property value to convert to a numeric
     *     value.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidParameter
     * @returns {Number} The property value converted to a numeric value.
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(aPropertyName) || TP.isEmpty(aPropertyValue)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  If the value is a percentage, then use the routine defined above to
    //  compute the proper number of pixels from that percentage.
    if (TP.regex.PERCENTAGE.test(aPropertyValue)) {
        return TP.elementGetNumericValueFromPercentage(anElement,
                                                        aPropertyName,
                                                        aPropertyValue,
                                                        wantsTransformed);
    }

    if (TP.isTrue(wantsTransformed)) {
        return TP.elementTransformCSSPixelValue(anElement,
                                                aPropertyName,
                                                parseFloat(aPropertyValue));
    }

    //  Otherwise, just try to parse a Number out of it.
    return parseFloat(aPropertyValue);
});

//  ------------------------------------------------------------------------
//  INLINE STYLE PRIMITIVES
//  ------------------------------------------------------------------------

/*
In TIBET we reserve inline style use for animations and tools. We don't use
it for anything else, since that would interfere with both of those goals.
Still, having decent wrappers for dealing with inline style is useful, so
here they are.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('elementAddStyleValue',
function(anElement, aProperty, aValue) {

    /**
     * @method elementAddStyleValue
     * @summary Adds a style value to the property provided. Note that many of
     *     the properties in CSS don't actually allow the value to have
     *     space-separated content so this is only viable for a small subset of
     *     property names.
     * @param {HTMLElement} anElement The element to retrieve the inline CSS
     *     style for.
     * @param {String} aProperty The property name to add.
     * @param {String} aValue The value for the property to be added.
     * @exception TP.sig.InvalidElement
     * @returns {String} The inline CSS style of the supplied element/property,
     *     or null if not found.
     */

    var style,
        dict,

        name,
        value;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    style = TP.elementGetStyleString(anElement);
    dict = TP.styleStringAsHash(style);

    name = aProperty.asDOMName();

    value = dict.at(name);
    if (TP.isEmpty(value)) {
        dict.atPut(name, aValue);
    } else {
        dict.atPut(name, TP.join(value, ' ', aValue));
    }

    style = TP.styleStringFromHash(dict);
    TP.elementSetStyleString(anElement, style);

    return anElement;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetAppliedNativeStyleRules',
function(anElement, flushCaches) {

    /**
     * @method elementGetAppliedNativeStyleRules
     * @summary Returns an Array of CSSRule objects that apply to the supplied
     *     element.
     * @param {Element} anElement The element to retrieve the CSS style rules
     *     for.
     * @param {Boolean} [flushCaches=false] Whether or not to flush the
     *     element's cached ruleset. Note that if this is forced to false (i.e.
     *     it is specified and the value is false) and the element does *not*
     *     have a rules cache, then the document-level rules cache will *not* be
     *     refreshed and an empty Array will be returned.
     * @exception TP.sig.InvalidElement
     * @returns {CSSStyleRule[]} The native style rules.
     */

    var ruleArray,

        i,
        parentSS;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isTrue(flushCaches)) {
        anElement[TP.APPLIED_RULES] = null;
    }

    ruleArray = TP.ac();

    //  We check to see if the element has a 'TP.APPLIED_RULES' Array. If not,
    //  we have to run the refresh call (which can be slow).
    if (TP.notValid(anElement[TP.APPLIED_RULES]) && TP.notFalse(flushCaches)) {
        TP.$documentRefreshAppliedRulesCaches(TP.nodeGetDocument(anElement));
    }

    //  Grab the 'applied rules' cache on the element.
    ruleArray = anElement[TP.APPLIED_RULES];

    if (TP.notValid(ruleArray)) {
        return TP.ac();
    }

    //  Make sure that any rules that are associated with stale style sheets get
    //  pruned. NB: We fetch the ruleArray's size *each time* through the loop,
    //  since we could be shortening the Array as we go.
    for (i = 0; i < ruleArray.getSize(); i++) {

        //  Find the style sheet associated with the element that inserted the
        //  rule's stylsheet (because of @import, it might not be the sheet in
        //  the 'parentStyleSheet' slot of the rule itself).
        parentSS = ruleArray.at(i).parentStyleSheet;
        while (parentSS.parentStyleSheet) {
            parentSS = parentSS.parentStyleSheet;
        }

        //  Make sure that stylesheet still has an owner node. If not, prune it.
        if (!TP.isNode(parentSS.ownerNode)) {

            //  If it has, remove the rule from the rule Array
            ruleArray.splice(i, 1);
        }
    }

    return ruleArray;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetAppliedStyleInfo',
function(anElement, flushCaches) {

    /**
     * @method elementGetAppliedStyleInfo
     * @summary Returns an Array of TP.core.Hashes that contain information
     *     about the style rules that apply to the supplied Element
     * @param {Element} anElement The element to retrieve the CSS style
     *     info for.
     * @param {Boolean} [flushCaches=false] Whether or not to flush the
     *     element's cached ruleset. Note that if this is forced to false (i.e.
     *     it is specified and the value is false) and the element does *not*
     *     have a rules cache, then the document-level rules cache will *not* be
     *     refreshed and an empty Array will be returned.
     * @exception TP.sig.InvalidElement
     * @returns {TP.core.Hash[]} An Array of TP.core.Hash objects with style
     *     rule information for each style rule that matches the supplied
     *     element.
     *          originalSelector:   The original 'whole' selector
     *          selector:           The simple selector split out from the whole
     *                              selector.
     *          specificityInfo:    Specificity information about the selector.
     *                              See the
     *                              calculateSingleCSSSelectorSpecificity()
     *                              method for more information on the values
     *                              here.
     *          sheetLocation:      The URL location of the stylesheet.
     *          sheetPosition:      The position of the stylesheet in the list of
     *                              stylesheets in a document.
     *          rulePosition:       The position of the rule in the list of
     *                              rules in its stylesheet.
     *          rule:               The original CSSStyleRule object.
     */

    var doc,
        allStyleSheets,

        rules,

        ruleInfo,

        rulesLen,
        i,

        newEntries;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    doc = TP.nodeGetDocument(anElement);
    allStyleSheets = TP.ac(doc.styleSheets);

    rules = TP.elementGetAppliedNativeStyleRules(anElement, flushCaches);

    ruleInfo = TP.ac();

    //  Iterate over all of the rules and obtain rule information for them. Note
    //  that this may expand the number of rules that we process, since an
    //  individual entry will be made for each simple selector (i.e. if a
    //  selector has a set of simple selectors separated by commas, this method
    //  makes an individual entry for each one).
    rulesLen = rules.getSize();
    for (i = 0; i < rulesLen; i++) {

        //  Note that getting the rule info here may expand the number of
        //  entries that we're processing beyond the original rule set, since an
        //  individual entry will be made for each simple selector. In other
        //  word, if a selector has a set of simple selectors separated by
        //  commas, this method makes an individual entry for each one.
        newEntries = TP.styleRuleGetRuleInfo(rules.at(i), allStyleSheets);

        ruleInfo.push(newEntries);
    }

    //  We have an Array of nested Arrays - flatten them.
    ruleInfo = ruleInfo.flatten();

    //  Now, because when computing the rule info, we might have had multiple
    //  selectors joined by ',', there will be individual rules that the element
    //  might not actually match (because it was joined with a ',' to a selector
    //  that it *did* match). So we do a further filtering here.
    ruleInfo = ruleInfo.filter(
                function(aRuleEntry) {
                    return TP.elementMatchesCSS(
                            anElement, aRuleEntry.at('selector'));
                });

    //  Sort the remaining rules by CSS specificity and order.
    ruleInfo.sort(TP.sort.CSS_RULE_SORT);

    return ruleInfo;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetComputedStyleString',
function(anElement, aProperty) {

    /**
     * @method elementGetComputedStyleString
     * @summary Returns the element's computed style as a String, or the value
     *     of a specific property if one is provided. When acquiring the entire
     *     style string you can get a TP.core.Hash of those values using
     *     TP.core.Hash.fromCSSString(str);
     * @param {HTMLElement} anElement The element to retrieve the computed style
     *     for.
     * @param {String|String[]} aProperty An optional property name or names to
     *     query for.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidStyleDeclaration
     * @returns {String} The computed style of the supplied element/property, or
     *     the empty String if there was no style.
     */

    var compStyleObj,
        properties,

        styleStr;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (!TP.isStyleDeclaration(
            compStyleObj = TP.elementGetComputedStyleObj(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    if (TP.isString(aProperty)) {
        return TP.join(aProperty.asCSSName(),
                        ':',
                        compStyleObj[aProperty.asDOMName()],
                        ';');
    }

    if (TP.isEmpty(properties = aProperty)) {
        properties = TP.CSS_ALL_PROPERTIES;
    }

    styleStr = TP.ac();

    properties.perform(
        function(propName) {
            var value;

            value = compStyleObj[propName.asDOMName()];
            if (TP.notEmpty(value)) {
                styleStr.push(propName.asCSSName(), ':', value, ';');
            }
        });

    return styleStr.join('');
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetComputedStyleProperty',
function(anElement, aProperty) {

    /**
     * @method elementGetComputedStyleProperty
     * @summary Gets the element's *computed* style property named by the
     *     supplied property name.
     * @param {HTMLElement} anElement The element to get the computed style
     *     property from.
     * @param {String} aProperty The name of the style property to get.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidStyleDeclaration
     * @returns {Object} The current computed value of the style property named
     *     by aProperty on the supplied element.
     */

    var compStyleObj,
        value;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(aProperty)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    if (!TP.isStyleDeclaration(
            compStyleObj = TP.elementGetComputedStyleObj(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    //  If the property is a CSS custom property, then use the
    //  getPropertyValue() API
    if (TP.regex.CSS_CUSTOM_PROPERTY_NAME.test(aProperty)) {
        value = compStyleObj.getPropertyValue(aProperty);
    } else {
        value = compStyleObj[aProperty.asDOMName()];
    }

    return value;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetStyleString',
function(anElement, aProperty) {

    /**
     * @method elementGetStyleString
     * @summary Returns the element's CSS style (its 'inline style') as a
     *     String, or the value of a specific property if one is provided. When
     *     acquiring the entire style string you can get a TP.core.Hash of those
     *     values using TP.core.Hash.fromCSSString(str);
     * @param {HTMLElement} anElement The element to retrieve the inline CSS
     *     style for.
     * @param {String|String[]} aProperty An optional property name or names to
     *     query for.
     * @exception TP.sig.InvalidElement
     * @returns {String} The inline CSS style of the supplied element/property,
     *     or the empty String if there was no style.
     */

    var style,
        styleHash,

        properties,

        styleStr;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    style = TP.elementGetStyleObj(anElement).cssText.toLowerCase();

    //  If the user doesn't want a particular property, or the 'cssText' is
    //  empty, we just return the cssText.
    if (TP.isEmpty(aProperty) || TP.isEmpty(style)) {
        return style;
    }

    styleHash = TP.styleStringAsHash(style);
    if (TP.isString(aProperty)) {
        return TP.join(aProperty.asCSSName(),
                        ':',
                        styleHash.at(aProperty.asDOMName()),
                        ';');
    } else {
        properties = aProperty;
    }

    styleStr = TP.ac();

    properties.perform(
        function(propName) {
            var value;

            value = styleHash.at(propName.asDOMName());
            if (TP.notEmpty(value)) {
                styleStr.push(propName.asCSSName(), ':', value, ';');
            }
        });

    return styleStr.join('');
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetStyleObj',
function(anElement) {

    /**
     * @method elementGetStyleObj
     * @summary Returns the element's CSS style object (its 'inline style').
     * @param {HTMLElement} anElement The element to retrieve the inline CSS
     *     style object for.
     * @exception TP.sig.InvalidElement
     * @returns {Object} The inline CSS style object of the supplied element.
     */

    var styleObj;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isStyleDeclaration(styleObj = anElement.style)) {
        return styleObj;
    }

    return TP.elementGetPseudoInlineStyleObj(anElement);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementGetStyleProperty',
function(anElement, aProperty) {

    /**
     * @method elementGetStyleProperty
     * @summary Gets the style property named by the supplied property name on
     *     the style of the supplied element.
     * @param {HTMLElement} anElement The element to get the style property
     *     from.
     * @param {String} aProperty The name of the style property to get.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidParameter
     * @returns {String} The current value of the style property named by
     *     aProperty on the supplied element.
     */

    var style,
        styleHash;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(aProperty)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    style = TP.elementGetStyleObj(anElement).cssText.toLowerCase();

    styleHash = TP.styleStringAsHash(style);

    return styleHash.at(aProperty.asDOMName());
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementHasStyleString',
function(anElement, aProperty) {

    /**
     * @method elementHasStyleString
     * @summary Returns true if the element has 'inline style'. If a property
     *     is provided the return value is based on whether that property is
     *     inline for the element.
     * @param {HTMLElement} anElement The element to test.
     * @param {String} aProperty A CSS property name.
     * @exception TP.sig.InvalidElement
     * @returns {Boolean} True if the element's inline style is not empty.
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    return TP.notEmpty(TP.elementGetStyleString(anElement, aProperty));
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementPeekStyleProperty',
function(anElement, aProperty) {

    /**
     * @method elementPeekStyleProperty
     * @summary 'Peek's the previously pushed style property named by aProperty
     *     from the receiver and returns that value. NB: This call does *not*
     *     set any style properties of the supplied element.
     * @param {HTMLElement} anElement The element to peek the style property
     *     from.
     * @param {String} aProperty The name of the style property to peek.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidParameter
     * @returns {Object} The value of the style property named by aProperty on
     *     anElement that had been pushed earlier.
     */

    var vals;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(aProperty)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    if (TP.isArray(vals = anElement[aProperty + '_vals'])) {
        return vals.last();
    } else {
        return null;
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementPopStyleProperty',
function(anElement, aProperty) {

    /**
     * @method elementPopStyleProperty
     * @summary 'Pop's the previously pushed style property named by aProperty
     *     from the receiver and returns that value. NB: This call does *not*
     *     set any style properties of the supplied element.
     * @param {HTMLElement} anElement The element to pop the style property
     *     from.
     * @param {String} aProperty The name of the style property to pop.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidParameter
     * @returns {Object} The value of the style property named by aProperty on
     *     anElement that had been pushed earlier.
     */

    var vals;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(aProperty)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    if (TP.isArray(vals = anElement[aProperty + '_vals'])) {
        return vals.pop();
    } else {
        return null;
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementPopAndSetStyleProperty',
function(anElement, aProperty) {

    /**
     * @method elementPopAndSetStyleProperty
     * @summary 'Pop's the previously pushed style property named by aProperty
     *     from the receiver, uses that value as the new value for the property
     *     on the supplied element and returns that value.
     * @param {HTMLElement} anElement The element to pop the style property
     *     from.
     * @param {String} aProperty The name of the style property to pop and set.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidParameter
     * @returns {Object} The value of the style property named by aProperty on
     *     anElement that had been pushed earlier.
     */

    var val;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(aProperty)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    val = TP.elementPopStyleProperty(anElement, aProperty);
    TP.elementSetStyleProperty(anElement, aProperty, val);

    return val;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementPreserveStyle',
function(anElement) {

    /**
     * @method elementPreserveStyle
     * @summary Saves anElement's current inline style, if it exists. This can
     *     later be restored using TP.elementRestoreStyle().
     * @param {HTMLElement} anElement The element to test.
     * @exception TP.sig.InvalidElement
     * @returns {Element} The element.
     */

    //  Go ahead and set this, even if the style is the empty String.
    TP.elementSetAttribute(anElement,
                            'tibet:style',
                            TP.elementGetStyleString(anElement),
                            true);

    return anElement;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementPushStyleProperty',
function(anElement, aProperty, aPropertyValue) {

    /**
     * @method elementPushStyleProperty
     * @summary Pushes a value for the style property named by aProperty on the
     *     supplied element using the supplied property value. NB: This call
     *     does *not* set any style properties of the supplied element.
     * @param {HTMLElement} anElement The element to push the style property on.
     * @param {String} aProperty The name of the style property to push.
     * @param {String|Number} aPropertyValue The value to push.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidParameter
     */

    var propVal,
        vals;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(aProperty)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  NB: We allow aPropertyValue to be empty, but not null or undefined,
    //  here, since we very well may be capturing the fact that the element
    //  has no 'inline' style property set.

    propVal = TP.ifInvalid(aPropertyValue, '');

    if (TP.isArray(vals = anElement[aProperty + '_vals'])) {
        vals.push(propVal);
    } else {
        vals = TP.ac(propVal);
        anElement[aProperty + '_vals'] = vals;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementPushAndSetStyleProperty',
function(anElement, aProperty, aPropertyValue) {

    /**
     * @method elementPushAndSetStyleProperty
     * @summary Pushes the *current* value for the style property named by
     *     aProperty on the supplied element and sets the style property to the
     *     supplied property value.
     * @param {HTMLElement} anElement The element to push the style property on.
     * @param {String} aProperty The name of the style property to push.
     * @param {String|Number} aPropertyValue The value to set as the new value.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidParameter
     */

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(aProperty)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  Get the current value of the style property and 'push' it onto the
    //  tracked property values for this element.
    TP.elementPushStyleProperty(
                        anElement,
                        aProperty,
                        TP.elementGetStyleProperty(anElement, aProperty));

    //  Set the style property of the element to the supplied value.
    TP.elementSetStyleProperty(anElement, aProperty, aPropertyValue);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementRemoveStyleValue',
function(anElement, aProperty) {

    /**
     * @method elementRemoveStyleValue
     * @summary Removes a property from the element's inline style, or all
     *     inline style if no property is provided.
     * @param {HTMLElement} anElement The element to test.
     * @param {String} aProperty The property name to remove.
     * @exception TP.sig.InvalidElement
     * @returns {Element} The element.
     */

    var str,
        re,
        css;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    css = TP.elementGetStyleString(anElement);
    if (TP.isEmpty(css)) {
        return anElement;
    }

    if (TP.isEmpty(aProperty)) {
        str = '';
    } else {
        re = TP.rc(aProperty.asCSSName() + '(.*)?;');
        str = css.strip(re);
    }

    return TP.elementSetStyleString(anElement, str);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementRemoveStyleProperty',
function(anElement, aProperty) {

    /**
     * @method elementRemoveStyleProperty
     * @summary Removes the style property named by the supplied property name
     *     from the style of the supplied element.
     * @param {HTMLElement} anElement The element to remove the style property
     *     from.
     * @param {String|String[]} aProperty The name of the style property to
     *     remove.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidParameter
     */

    var style,
        styleHash,

        i;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(aProperty)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    style = TP.elementGetStyleObj(anElement).cssText.toLowerCase();

    //  just one property? then return just that item as a string
    styleHash = TP.styleStringAsHash(style);

    if (TP.isArray(aProperty)) {
        for (i = 0; i < aProperty.getSize(); i++) {
            styleHash.removeKey(aProperty.at(i).asDOMName());
        }
    } else {
        styleHash.removeKey(aProperty.asDOMName());
    }

    TP.elementSetStyleString(anElement, styleHash);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementReplaceStyleValue',
function(anElement, aProperty, oldValue, newValue) {

    /**
     * @method elementReplaceStyleValue
     * @summary Replaces a property value in the receiver's inline style.
     * @param {HTMLElement} anElement The element to test.
     * @param {String} aProperty The property name to replace.
     * @param {String} oldValue The current value to find.
     * @param {String} newValue The new value to set.
     * @exception TP.sig.InvalidElement
     * @returns {Element} The element.
     */

    var str,
        re,
        css;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    css = TP.elementGetStyleString(anElement);
    if (TP.isEmpty(css)) {
        return anElement;
    }

    if (TP.isEmpty(aProperty)) {
        str = '';
    } else {
        re = TP.rc(aProperty.asCSSName() + '(.*)?;');
        str = css.strip(re);
    }

    return TP.elementSetStyleString(anElement, str);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementResetAppliedNativeStyleRules',
function(anElement) {

    /**
     * @method elementResetAppliedNativeStyleRules
     * @summary Resets the element *and all of its descendants* Arrays of
     *     CSSRule objects that apply to them to null.
     * @param {Element} anElement The element to begin resetting the CSS style
     *     rules for.
     * @exception TP.sig.InvalidElement
     */

    var descendants,

        len,
        i;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    anElement[TP.APPLIED_RULES] = null;

    descendants = TP.nodeGetDescendantElements(anElement);

    len = descendants.getSize();
    for (i = 0; i < len; i++) {
        descendants.at(i)[TP.APPLIED_RULES] = null;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementRestoreStyle',
function(anElement) {

    /**
     * @method elementRestoreStyle
     * @summary Restores anElement's preserved style, if it exists.
     * @param {HTMLElement} anElement The element to test.
     * @exception TP.sig.InvalidElement
     * @returns {Element} The element.
     */

    if (TP.elementHasAttribute(anElement, 'tibet:style', true)) {
        TP.elementSetStyleString(
                anElement,
                TP.elementGetAttribute(anElement, 'tibet:style', true));
    }

    return anElement;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementSetStyleString',
function(anElement, theStyle) {

    /**
     * @method elementSetStyleString
     * @summary Sets the element's CSS style (its 'inline style') to the
     *     supplied CSS-formatted style String.
     * @param {HTMLElement} anElement The element to set the inline CSS style
     *     for.
     * @param {String|TP.core.Hash} theStyle A string or hash of style content.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidParameter
     * @returns {Element} The element.
     */

    var styleObj;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    styleObj = TP.elementGetStyleObj(anElement);

    if (TP.notValid(theStyle)) {
        styleObj.cssText = null;
    } else if (TP.isString(theStyle)) {
        styleObj.cssText = theStyle;
    } else if (TP.isHash(theStyle)) {
        //  Pass 'false' to not quote values with whitespace.
        styleObj.cssText = TP.styleStringFromHash(theStyle, false);
    } else {
        return TP.raise(this, 'InvalidParameter',
                        'Style content must be string or TP.core.Hash');
    }

    return anElement;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elementSetStyleProperty',
function(anElement, aProperty, aPropertyValue) {

    /**
     * @method elementSetStyleProperty
     * @summary Sets the style property named by the supplied property name on
     *     the style of the supplied element using the supplied property value.
     * @param {HTMLElement} anElement The element to set the style property on.
     * @param {String} aProperty The name of the style property to set.
     * @param {String|Number} aPropertyValue The value to set the style property
     *     to.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidStyleDeclaration
     */

    var styleObj;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    if (TP.isEmpty(aProperty)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    if (!TP.isStyleDeclaration(styleObj = TP.elementGetStyleObj(anElement))) {
        return TP.raise(this, 'TP.sig.InvalidStyleDeclaration');
    }

    //  If the property is a CSS custom property, then use the setProperty()
    //  API.
    if (TP.regex.CSS_CUSTOM_PROPERTY_NAME.test(aProperty)) {
        styleObj.setProperty(aProperty, aPropertyValue);
    } else {
        styleObj[aProperty.asDOMName()] = aPropertyValue;
    }

    return;
});

//  ------------------------------------------------------------------------
//  STYLE STRING CONVERSION
//  ------------------------------------------------------------------------

TP.definePrimitive('styleStringAsHash',
function(aStyleString) {

    /**
     * @method styleStringAsHash
     * @summary Converts a properly formatted CSS style string into the
     *     equivalent TP.core.Hash. The keys in the hash are in their "DOM"
     *     form, i.e. 'float' becomes 'cssFloat', etc.
     * @param {String} aStyleString A string of the form key:value;key:value;.
     * @returns {TP.core.Hash} A new hash of CSS property/value pairs.
     */

    if (TP.isEmpty(aStyleString)) {
        return TP.hc();
    }

    return TP.core.Hash.fromString(aStyleString);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('styleStringFromHash',
function(aHash, quoteWhitespaceValues) {

    /**
     * @method styleStringFromHash
     * @summary Returns the provided hash's key/value pairs as a valid CSS
     *     style string. Each key in the hash is processed via the asCSSName()
     *     String method to try to ensure a valid result.
     * @param {TP.core.Hash} aHash A valid TP.core.Hash containing keys suitable
     *     for a CSS string.
     * @param {Boolean} quoteWhitespaceValues Whether or not whitespace values
     *     should be quoted.
     * @returns {String} A String in the format of a CSS style string.
     */

    var str,

        keys,
        len,
        i,

        val,
        quote;

    if (TP.isEmpty(aHash)) {
        return '';
    }

    str = TP.ac();

    keys = TP.keys(aHash);
    len = keys.getSize();
    quote = TP.ifInvalid(quoteWhitespaceValues, false);

    for (i = 0; i < len; i++) {
        if (/ /.test(val = aHash.at(keys.at(i))) && quote) {
            val = val.quoted('"');
        }

        str.push(keys.at(i).asCSSName(), ':', val, '; ');
    }

    str = str.join('');

    //  Slice off the last space
    return str.slice(0, str.getSize() - 1);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('cssDimensionValuesFromString',
function(aValueString) {

    /**
     * @method cssDimensionValuesFromString
     * @summary Extracts dimension values from the supplied String, according
     *     to the standard CSS rules for doing so.
     * @description The CSS rules used for parsing values for dimensional
     *     properties, like padding, are:
     *
     *     1 value applies to all sides 2 values first value applies to top &
     *     bottom, second value to right & left 3 values first value applies to
     *     top, second value to right & left and third value to bottom 4 values
     *     first value applies to top, second value to right, third value to
     *     left and fourth value to bottom.
     * @param {String} aValueString The String containing the values to extract
     *     the values from.
     * @returns {TP.core.Hash} The hash of values containing the following keys:
     *     top, right, bottom, left.
     */

    var origValues;

    if (TP.isEmpty(aValueString)) {
        return TP.hc();
    }

    origValues = aValueString.split(' ');

    switch (origValues.getSize()) {
        case 1:

            return TP.hc('top', origValues.at(0),
                            'right', origValues.at(0),
                            'bottom', origValues.at(0),
                            'left', origValues.at(0));
        case 2:

            return TP.hc('top', origValues.at(0),
                            'right', origValues.at(1),
                            'bottom', origValues.at(0),
                            'left', origValues.at(1));
        case 3:

            return TP.hc('top', origValues.at(0),
                            'right', origValues.at(1),
                            'bottom', origValues.at(2),
                            'left', origValues.at(1));
        case 4:

            return TP.hc('top', origValues.at(0),
                            'right', origValues.at(1),
                            'bottom', origValues.at(2),
                            'left', origValues.at(3));
        default:
            break;
    }

    return;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETHTTPPrimitivesPre.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @Support functions for HTTP operation. These include common error handling,
 *     status checking, and encoding routines.
 */

//  ------------------------------------------------------------------------

TP.definePrimitive('httpCleanse',
function(anObj) {

    /**
     * @method httpCleanse
     * @summary Cleanses a URI string or Request to mask off any authentication
     *     data which may be in the content. Typically used by the logging
     *     routine httpError to avoid logging failed login user/pass data.
     * @param {String|Request} anObj The object to be cleansed.
     * @returns {Object}
     */

    var obj;

    if (TP.isString(anObj)) {
        return TP.uriCleansePath(anObj);
    }

    //  TODO:   cleanse the request...
    if (!TP.canInvokeInterface(anObj, ['at', 'atPut'])) {
        return anObj;
    }

    //  Cleanse an uri value in the request.
    anObj.atPut('uri', TP.uriCleansePath(anObj.at('uri')));

    //  Can also end up with username/password data in the request body. Our
    //  best chance in that case is if it's JSON...
    try {
        obj = JSON.parse(anObj.at('body'));
        if (TP.isValid(obj.username)) {
            obj.username = 'xxx';
        }
        if (TP.isValid(obj.password)) {
            obj.password = 'xxx';
        }
        anObj.atPut('body', JSON.stringify(obj));

        obj = JSON.parse(anObj.at('finalbody'));
        if (TP.isValid(obj.username)) {
            obj.username = 'xxx';
        }
        if (TP.isValid(obj.password)) {
            obj.password = 'xxx';
        }
        anObj.atPut('finalbody', JSON.stringify(obj));
    } catch (e) {
        //  Not JSON? Can't really process intelligently then.
        void 0;
    }

    return anObj;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('httpConstruct',
function(targetUrl) {

    /**
     * @method httpConstruct
     * @summary Returns a platform-specific XMLHttpRequest object for use.
     * @param {String} targetUrl The request's target URL.
     * @returns {XMLHttpRequest}
     */

    var xhr,
        url;

    xhr = new XMLHttpRequest();

    if (TP.notValid(xhr)) {
        TP.httpError(targetUrl, 'HTTPConstructException',
            TP.hc('message', 'Unable to instantiate XHR object.'));
        return;
    }

    //  URL instances which make use of "comm objects" support API to access the
    //  last used object and its data provided we keep that reference updated.
    if (TP.isValid(targetUrl) &&
            TP.isValid(TP.sys.getTypeByName('TP.uri.URI'))) {
        url = TP.uc(targetUrl);
        url.$set('commObject', xhr);
    }

    return xhr;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('httpDidSucceed',
function(httpObj) {

    /**
     * @method httpDidSucceed
     * @summary Returns true if the request is done and was successful.
     * @description In essence this simply tests the status code to see if it is
     *     in the range of 200 to 207. Normally success is 200, but for
     *     operations like WebDAV MkCol, Lock, etc. we may receive other 2xx
     *     codes which signify success. A status code of 304 (Not-Modified) is
     *     returned by certain servers, particularly when using ETag data for
     *     performance but it also indicates a success. A status code of 0 can
     *     also mean success when using an HTTP request to access the local file
     *     system.
     *
     *     The codes are:
     *
     *     0, OK if file system access was being performed 200, 'OK', 201,
     *     'Created', 202, 'Accepted', 203, 'Non-Authoritative Information',
     *     204, 'No Content', 205, 'Reset Content', 206, 'Partial Content', 207,
     *     'WebDAV Multi-Status', 304, 'Not Modified', (ETag and/or Opera)
     *
     *
     * @param {XMLHttpRequest} httpObj An XMLHttpRequest which was used for a
     *     server call.
     * @returns {Boolean} True if the request was successful.
     */

    var stat;

    //  If the XHR mechanism has aborted in Mozilla, it will cause the
    //  '.status' property to throw an exception if it is read.
    try {
        stat = httpObj.status;

        //  OK, Created, and Accepted are considered success codes
        if (stat >= 200 && stat <= 207 || stat === 304) {
            return true;
        }

        //  file access often returns status of 0 (improperly we realize)
        if (stat === 0 && (httpObj.responseXML || httpObj.responseText)) {
            return true;
        }
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'HTTP status error.'),
                        TP.IO_LOG) : 0;
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('httpDidRedirect',
function(httpObj) {

    /**
     * @method httpDidRedirect
     * @summary Returns true if the request provided has a status code
     *     indicating a redirect.
     * @description TIBET considers all 300-series codes other than a 304 (Not
     *     Modified) to be valid redirection indicators. We avoid 304 in
     *     particular so we can support HTTP Validation via ETag headers. The
     *     300 series codes are:
     *
     *     300, 'Multiple Choices', 301, 'Moved Permanently', 302, 'Found',
     *     303, 'See Other', 304, 'Not Modified', 305, 'Use Proxy', 306,
     *     '(Unused)', 307, 'Temporary Redirect',
     *
     *
     * @param {XMLHttpRequest} httpObj An XMLHttpRequest which was used for a
     *     server call.
     * @returns {Boolean} True for redirection responses.
     */

    var stat;

    //  If the XHR mechanism has aborted in Mozilla, it will cause the
    //  '.status' property to throw an exception if it is read.
    try {
        stat = httpObj.status;

        //  from Multiple Choices to Temporary Redirect
        if (stat >= 300 && stat <= 307) {

            //  Not Modified will be false, all others are true.
            /* eslint-disable no-extra-parens */
            return (stat !== 304);
            /* eslint-enable no-extra-parens */
        }
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'HTTP redirect error.'),
                        TP.IO_LOG) : 0;
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('httpEncode',
function(aPayload, aMIMEType, aSeparator, multipartMIMETypes, anEncoding) {

    /**
     * @method httpEncode
     * @summary Provides URI and data encoding support for commonly used MIME
     *     types. The data is returned, either ready to be appended to the
     *     targetUrl, or ready for use as content for a POST, PUT, or similar
     *     operation. NOTE that if the data is a string already, or is
     *     null/undefined no new content is created and the data is returned as
     *     is.
     * @description Encoding of data can be performed a number of ways but this
     *     method handles the most common formats related to content types
     *     typically used to communicate with web servers and web services.
     *     Supported MIME types include:
     *
     *     application/json
     *     application/x-www-form-urlencoded
     *     application/xml
     *     application/xml+rpc
     *     application/vnd.tpi.hidden-fields
     *     multipart/form-data
     *     multipart/related
     *
     * @param {Object} aPayload The call data to encode along with the URL. Note
     *     that when this is a string it won't be altered in any form.
     * @param {String} aMIMEType One of the standard HTTP MIME type formats such
     *     as application/x-www-form-urlencoded or multipart/form-data.
     * @param {String} aSeparator Used for url encoding, this is normally the &
     *     used to separate individual key/value pairs.
     * @param {String[]} multipartMIMETypes Used when encoding multipart
     *     messages, 1 per message part.
     * @param {String} anEncoding The character set/encoding to use. Default is
     *     'UTF-8'. NOTE that changing this can cause certain encodings to be
     *     inconsistent so use caution when changing this value.
     * @returns {String} The encoded data, in string form so it can be sent to
     *     the server or stored on disk.
     */

    var data,

        mimetype,
        charset,
        separator,
        firstPartMIMEType,

        arr,
        list,
        item,
        size,
        i,
        j,
        len,
        el,
        val,
        boundary,
        content;

    //  when the data is a string already we presume it's in the proper
    //  form, which may not be true but we're not gonna parse it now :) We
    //  also don't go any further for data that isn't actually there.
    if (TP.notValid(aPayload)) {
        return aPayload;
    }

    //  if we got handed a String, see if we can turn it into a Node. If we
    //  can't, or all we get from that process is a Text node, then just return
    //  what we got handed.
    if (TP.isString(aPayload)) {

        //  Note here how we don't supply a default namespace, nor do we want
        //  this call to report XML parsing errors - if we have them, the
        //  payload is unusable as XML so we'll just return it.
        if (!TP.isNode(data = TP.nodeFromString(aPayload, null, false))) {
            return aPayload;
        }
        //  If it's a Text node, then just return the original payload.
        if (TP.isTextNode(data)) {
            return aPayload;
        }
    } else if (TP.isPlainObject(aPayload)) {
        data = TP.hc(aPayload);
    } else {
        data = aPayload;
    }

    //  default mime type is the one used for most GET/POST/PUT calls
    mimetype = TP.ifInvalid(aMIMEType, TP.URL_ENCODED);

    charset = TP.ifInvalid(anEncoding, TP.UTF8);

    separator = TP.ifInvalid(aSeparator, '&');

    if (TP.notEmpty(multipartMIMETypes)) {
        firstPartMIMEType = multipartMIMETypes.first();
    }

    switch (mimetype) {
        case TP.JSON_ENCODED:

            if (TP.canInvoke(data, 'asJSONSource')) {
                return data.asJSONSource();
            } else {
                data = TP.unwrap(data);
                if (TP.isNode(data)) {
                    return TP.xml2json(data);
                } else {
                    return TP.js2json(data);
                }
            }

        case TP.URL_ENCODED:

            //  this format is typically used with GET requests, but it can
            //  also be used with other call types such as POST or PUT. Note
            //  that XForms allows this with POST, but considers it to be a
            //  deprecated format

            arr = TP.ac();

            data = TP.unwrap(data);

            if (TP.isNode(data)) {
                //  we follow the XForms approach for encoding here, using
                //  non-empty elements containing text nodes and discarding
                //  everything else. Note that we have to ensure the node
                //  itself gets encoded by putting it in the list.
                list = TP.nodeGetElementsByTagName(data, '*');
                list.unshift(data);

                len = list.getSize();
                for (i = 0; i < len; i++) {
                    el = list.at(i);
                    if (TP.notEmpty(el)) {    //  empty node means no children
                        if (TP.notEmpty(val = TP.nodeGetTextContent(el))) {
                            arr.push(TP.join(TP.elementGetLocalName(el),
                                            '=',
                                            encodeURIComponent(val)));
                        }
                    }
                }
            } else {
                list = TP.keys(data);

                len = list.getSize();
                for (i = 0; i < len; i++) {
                    if (TP.notEmpty(val = data.at(list.at(i)))) {
                        arr.push(TP.join(list.at(i),
                                        '=',
                                        encodeURIComponent(val)));
                    } else {
                        //  if there's no value, we just push on the key
                        arr.push(list.at(i));
                    }
                }
            }

            //  join using the separator provided, but return a null if the
            //  data ends up empty to avoid sending '' as content
            return TP.ifEmpty(arr.join(separator), null);

        case TP.XML_ENCODED:

            //  If this is a Node wrapper, then see if it responds to
            //  'asXMLString' to get its XML representation. Otherwise, we're
            //  going to use either native node stringification or we're going
            //  to convert from JS to XML below.

            if (TP.isKindOf(data, TP.core.Node) &&
                TP.canInvoke(data, 'asXMLString')) {
                return data.asXMLString();
            }

            data = TP.unwrap(data);

            //  we don't do much here other than serialize the content if
            //  it's a node so we get the best rep possible. any filtering
            //  of the XML had to happen at a higher level (i.e. XForms)
            if (TP.isNode(data)) {
                return TP.nodeAsString(data);
            }

            //  not a node container or a native node, so who knows?
            return TP.nodeAsString(TP.js2xml(data));

        case TP.XMLRPC_ENCODED:

            data = TP.unwrap(data);

            //  another common format for server communication, particularly
            //  with several open source applications like OpenGroupware
            return TP.nodeAsString(TP.js2xmlrpc(data));

        case TP.FIELD_ENCODED:

            //  not a standard, but something we found useful for certain
            //  situations -- encode data as if it had been in an html form.
            //  This can then be POSTed as form content.

            arr = TP.ac();

            data = TP.unwrap(data);

            if (TP.isNode(data)) {
                list = TP.nodeGetElementsByTagName(data, '*');
                list.unshift(data);

                len = list.getSize();
                for (i = 0; i < len; i++) {
                    el = list.at(i);
                    if (TP.notEmpty(el)) {    //  empty node means no children
                        if (TP.notEmpty(val = TP.nodeGetTextContent(el))) {
                            arr.push(
                                '<input type="hidden" name="',
                                el.tagName,
                                '" value="',
                                val.replace(/"/g, '&quot;'),
                                '" />\n');
                        }
                    }
                }
            } else {
                list = TP.keys(data);

                len = list.getSize();
                for (i = 0; i < len; i++) {
                    item = data.at(list.at(i));
                    if (TP.isArray(item)) {
                        size = item.getSize();
                        for (j = 0; j < size; j++) {
                            arr.push(
                                '<input type="hidden" name="',
                                list.at(i),
                                '" value="',
                                TP.str(
                                    data.at(
                                        list.at(i)).at(j)).replace(
                                                /"/g, '&quot;'),
                                '" />\n');
                        }
                    } else {
                        arr.push(
                            '<input type="hidden" name="',
                            list.at(i),
                            '" value="',
                            TP.str(item).replace(/"/g, '&quot;'),
                            '" />\n');
                    }
                }
            }

            return TP.ifEmpty(arr.join(''), null);

        case TP.MP_RELATED_ENCODED:

            data = TP.unwrap(data);

            arr = TP.ac();
            boundary = TP.genID('part');

            //  here we follow the XForms definition, encoding XML as a
            //  single part, and any binary as other parts (unsupported)

            //  start the show :)
            arr.push(TP.join('Content-Type: ', TP.MP_RELATED_ENCODED,
                            '; boundary=', boundary));

            //  According to the spec, the type of the first chunk of data
            //  should appear in a 'type=' parameter before the first boundary.
            if (TP.isArray(data)) {
                arr.push(
                    TP.join('; type=', TP.ifInvalid(firstPartMIMEType,
                                                      TP.PLAIN_TEXT_ENCODED)));
            } else if (TP.isNode(data)) {
                //  if the data is a Node, we use the supplied media type or
                //  TP.XML_ENCODED if that's not defined, and the same
                //  charset as the overall multipart content

                //  and charset from the content as a whole and encode the
                //  data as XML, forming a single block.
                arr.push(
                    TP.join('; type=',
                                TP.ifInvalid(firstPartMIMEType,
                                                TP.XML_ENCODED),
                            '; charset=',
                                charset));
            } else {
                arr.push(
                    TP.join('; type=',
                                TP.ifInvalid(firstPartMIMEType,
                                                TP.PLAIN_TEXT_ENCODED),
                            '; charset=',
                                charset));
            }

            //  We leave the preamble empty.

            //  place first boundary
            arr.push('--' + boundary);

            //  TODO: we don't currently support binary chunks processed via
            //  an upload element, but maybe in the future...

            //  if the data is an Array, then each item in the Array should
            //  be a TP.core.Hash containing keys that would be the same as
            //  a regular data request, such as 'body', 'multipartypes',
            //  'encoding', 'separator', etc.

            //  We then loop over those, encoding each one using the
            //  encoding data and information in each TP.core.Hash.
            if (TP.isArray(data)) {
                data.perform(
                    function(anItem, anIndex) {

                        var itemContent,

                            itemMIMEType,
                            itemEncoding,
                            itemSeparator;

                        //  Make sure that we have 'body' data to encode
                        if (TP.notValid(itemContent = anItem.at('body'))) {
                            //  TODO: Log an error here?
                            return;
                        }

                        //  Get the data into it's rawest form
                        itemContent = TP.unwrap(itemContent);

                        if (TP.notEmpty(multipartMIMETypes)) {
                            itemMIMEType = anItem.atIfInvalid(
                                                'mimetype',
                                                multipartMIMETypes.at(anIndex));
                        }
                        if (TP.isEmpty(itemMIMEType)) {
                            if (TP.isNode(itemContent)) {
                                itemMIMEType = TP.XML_ENCODED;
                            } else {
                                itemMIMEType = TP.PLAIN_TEXT_ENCODED;
                            }
                        }

                        itemEncoding = anItem.atIfInvalid('encoding', charset);

                        if (TP.notEmpty(itemMIMEType)) {
                            arr.push(
                                TP.join('Content-Type: ', itemMIMEType,
                                        '; charset=', itemEncoding));
                        }

                        itemSeparator =
                                anItem.atIfInvalid('separator', separator);

                        arr.push('Content-ID: ' + anIndex);

                        //  honor the 'noencode' flag here
                        if (TP.notTrue(anItem.at('noencode'))) {
                            //  Note here how we supply the item's 'media type'
                            //  as the MIME type to this recursive call to
                            //  TP.httpEncode() and a 'null' for the list of
                            //  multipart mime types. This is the correct
                            //  behavior but it effectively prevents *nested*
                            //  multipart/related encoding.
                            itemContent = TP.httpEncode(
                                            itemContent,
                                            itemMIMEType,
                                            itemSeparator,
                                            null,
                                            itemEncoding);
                        }

                        arr.push('', itemContent);

                        arr.push('--' + boundary);
                    });
            } else if (TP.isNode(data)) {
                //  if the data is a Node, we use the supplied media type or
                //  TP.XML_ENCODED if that's not defined, and the same
                //  charset as the overall multipart content

                //  and charset from the content as a whole and encode the
                //  data as XML, forming a single block.

                //  root
                arr.push(
                    TP.join('Content-Type: ',
                                TP.ifInvalid(firstPartMIMEType,
                                                TP.XML_ENCODED),
                            '; charset=',
                                charset),
                    'Content-ID: 0');

                //  Note here how we supply the item's 'media type'
                //  (defaulted here to XML encoding) as the MIME type to
                //  this recursive call to TP.httpEncode() and a 'null' for
                //  media type. This is the correct behavior but it
                //  effectively prevents *nested* multipart/related
                //  encoding.
                content = TP.httpEncode(
                                data,
                                TP.ifInvalid(firstPartMIMEType,
                                                TP.XML_ENCODED),
                                separator,
                                null,
                                charset);

                arr.push(content);

                arr.push('--' + boundary);
            } else {
                //  If a defined media type was supplied, we use that and
                //  the charset used for the overall multipart content.
                //  Otherwise, we omit those.

                //  Then, for each key, we obtain the data as a String, thus
                //  forming the block for each part.

                list = TP.keys(data);

                len = list.getSize();
                for (i = 0; i < len; i++) {
                    if (TP.notEmpty(multipartMIMETypes) &&
                        TP.notEmpty(multipartMIMETypes.at(i))) {
                        arr.push(
                            TP.join('Content-Type: ', multipartMIMETypes.at(i),
                                    '; charset=', charset,
                                    ' '));
                    }

                    arr.push('Content-ID: ' + list.at(i));

                    content = TP.str(data.at(list.at(i)));
                    arr.push(content);

                    arr.push('--' + boundary);
                }
            }

            //  terminate final boundary - we need to take the last item and
            //  append '--\r\n' to be spec compliant.
            arr.atPut(arr.getSize() - 1, arr.last() + '--\r\n');

            return arr.join('\r\n');

        case TP.MP_FORMDATA_ENCODED:

            //  provided for XForms compliance with older servers. The basic
            //  idea here is that each element or key/value pair gets its
            //  own chunk in the content string, with type/encoding data to
            //  describe that chunk.

            arr = TP.ac();
            boundary = TP.genID('part');

            data = TP.unwrap(data);

            //  per XForms spec the default here is application/octet-stream

            //  start the show :)
            arr.push(TP.join('Content-Type: ', TP.MP_FORMDATA_ENCODED,
                            '; boundary=', boundary));

            //  place first boundary
            arr.push('--' + boundary);

            if (TP.isNode(data)) {
                //  we follow the XForms approach for encoding here, using
                //  non-empty elements containing text nodes and discarding
                //  everything else
                list = TP.nodeGetElementsByTagName(data, '*');
                list.unshift(data); //  not just children, but the node too

                len = list.getSize();
                for (i = 0; i < len; i++) {
                    el = list.at(i);

                    //  According to the spec we want Elements that have no
                    //  children *Elements* (but do have children *text nodes*)

                    //  We don't want completely empty Elements.
                    if (TP.notEmpty(el)) {
                        //  But we do want ones that don't have child
                        //  *Elements*
                        if (TP.nodeGetChildElements(el).getSize() > 0) {
                            continue;
                        }
                        if (TP.notEmpty(val = TP.nodeGetTextContent(el))) {
                            arr.push(
                                TP.join(
                                    'Content-disposition: form-data',
                                    '; name="', TP.elementGetLocalName(el), '"',
                                    '\r\n',
                                    'Content-Type: ', TP.PLAIN_TEXT_ENCODED,
                                    '; charset=', charset),
                                val,
                                '--' + boundary);
                        }
                    }
                }
            } else {
                if (TP.isArray(data)) {
                    list = data.getIndices();
                } else {
                    list = TP.keys(data);
                }

                len = list.getSize();
                for (i = 0; i < len; i++) {
                    arr.push(
                        TP.join(
                            'Content-disposition: form-data',
                            '; name="', list.at(i), '"',
                            '\r\n',
                            'Content-Type: ', TP.PLAIN_TEXT_ENCODED,
                            '; charset=', charset),
                        TP.str(data.at(list.at(i))),
                        '--' + boundary);
                }
            }

            //  terminate final boundary - we need to take the last item and
            //  append '--\r\n' to be spec compliant.
            arr.atPut(arr.getSize() - 1, arr.last() + '--\r\n');

            return arr.join('\r\n');

        default:

            //  nothing we can do but return the string version
            return TP.str(data);
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('httpEncodeRequestBody',
function(aRequest) {

    /**
     * @method httpEncodeRequestBody
     * @summary Encodes the request body for transmission. Processing in this
     *     method makes use of keys in the request to drive a call to the
     *     TP.httpEncode() primitive. If you don't want this processing to occur
     *     you can put a key of 'noencode' with a value of true in the request.
     * @param {TP.sig.HTTPRequest} aRequest The request whose parameters define
     *     the HTTP request.
     * @returns {String} The string value of the encoded body content.
     */

    var body,
        mimetype,
        separator,
        multiparttypes,
        encoding;

    body = aRequest.at('body');
    if (TP.notValid(body)) {
        return;
    }

    //  check for "please don't change my body content" flag
    if (TP.isTrue(aRequest.at('noencode'))) {
        return body;
    }

    //  check for "my body content is already encoded" flag
    if (TP.isTrue(aRequest.at('isencoded'))) {
        return body;
    }

    //  REQUIRED value for the encoding process
    mimetype = aRequest.at('mimetype');

    //  only used for URL_ENCODING, but we need to pass it along
    separator = aRequest.at('separator');

    //  only used for the multi-part encodings, but just in case :)
    multiparttypes = aRequest.at('multiparttypes');

    //  should be left alone 99% of the time so it defaults to UTF-8
    encoding = aRequest.at('encoding');

    return TP.httpEncode(body, mimetype, separator, multiparttypes, encoding);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('httpError',
function(targetUrl, aSignal, aRequest, shouldSignal) {

    /**
     * @method httpError
     * @summary Low-level error handler for TP.httpCall processing. This
     *     function will cause both the IO log and Error log to be updated to
     *     reflect the error condition.
     * @description aRequest could contain 1 or more of the following keys:
     *
     *     'uri' - the targetUrl
     *     'uriparams' - URI query parameters
     *     'headers' - call headers
     *     'method' - the command method
     *     'body' - string content
     *     'commObj' - xml http request
     *     'response' - TP.sig.Response
     *     'object' - any error object
     *     'message' - error string
     *     'direction' - send/recv
     *     'async' - true/false
     *     'redirect' - boolean
     *
     * @param {String} targetUrl The URL being accessed when the error occurred.
     * @param {String|TP.sig.Signal} aSignal The signal which should be raised
     *     by this call.
     * @param {TP.core.Hash|TP.sig.Request} aRequest A request/hash with keys.
     * @param {Boolean} [shouldSignal=true] Whether to signal failure/completed
     *     which will close out the request properly.
     * @exception HTTPException
     * @throws Error Throws an Error containing aString.
     */

    var args,
        signal,
        error,
        type,
        sig,
        id;

    //  make sure we've got at least a basic TP.sig.Request to work with
    args = aRequest || TP.request();

    //  make sure we tuck away the url if there's no prior value
    args.atPutIfAbsent('uri', targetUrl);

    //  rarely null, but just in case
    signal = TP.ifInvalid(aSignal, 'HTTPException');

    //  make sure the IO log contains this data to show a complete record for
    //  access to the targetUrl
    args.atPut('message', 'HTTP request exception.');

    //  if we didn't get an error we can relay a new one
    error = args.at('object');
    if (TP.notValid(error)) {
        error = new Error(args.at('message'));
    }
    args.atPut('error', error);

    this.httpCleanse(args);

    //  get a response object for the request that we can use to convey the bad
    //  news in a consistent fashion with normal success processing.
    if (TP.notValid(type = TP.sys.getTypeByName('TP.sig.HTTPResponse',
                                                    false))) {
        if (TP.notValid(type = TP.sys.getTypeByName('TP.sig.Response',
                                                        false))) {
            //  real problems...typically crashing during boot since none of
            //  the core kernel response types appear to be valid.
            return;
        }
    }

    sig = type.construct(args);
    id = args.getRequestID();

    //  start with most specific
    sig.setSignalName(signal);
    sig.fire(id);

    //  move on to general failure
    sig.setSignalName('TP.sig.IOFailed');
    sig.fire(id);

    //  success or failure all operations "complete" so that's last
    sig.setSignalName('TP.sig.IOCompleted');
    sig.fire(id);

    //  if the signal handler said to prevent default then don't continue, just
    //  stop and avoid throw logic entirely.
    if (sig.shouldPrevent()) {
        return;
    }

    if (args && TP.notTrue(args.get('logged'))) {
        if (TP.ifError()) {
            args.set('logged', true);
            try {
                TP.error(TP.IO_LOG, args);
            } catch (e) {
                void 0;
            }
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('httpGetDefaultHeaders',
function() {

    /**
     * @method httpGetDefaultHeaders
     * @summary Builds and returns a set of default headers for a web call.
     * @returns {TP.core.Hash} A hash of default headers which can be used for a
     *     standard web call.
     */

    //  NOTE that we build a new hash each time so it can be modified as
    //  needed by each request. Also note that this is done lazily so that
    //  we're sure we're getting a full hash object, not a TP.boot.PHash.
    return TP.hc('Accept', TP.ac(TP.JS_TEXT_ENCODED,
                                    TP.JSON_ENCODED,
                                    TP.JSON_TEXT_ENCODED,
                                    TP.XML_ENCODED,
                                    TP.XML_TEXT_ENCODED,
                                    TP.XHTML_ENCODED,
                                    TP.HTML_TEXT_ENCODED,
                                    '*/*'));
});

//  ------------------------------------------------------------------------

TP.definePrimitive('httpRequestPassesSimpleCORSRestrictions',
function(aRequest) {

    /**
     * @method httpRequestPassesSimpleCORSRestrictions
     * @summary Checks a set of information about the supplied HTTP request to
     *     make sure that a 'simple CORS' request can be made. This includes
     *     checking the requests 'method', 'mimetype' and 'headers'.
     * @param {TP.sig.HTTPRequest} aRequest The request to be checked to see if
     *     it is 'simple CORS' capable.
     * @returns {Boolean} Whether or not the request is 'simple CORS' capable.
     */

    var method,
        mimetype,

        headers,
        headerKeys,
        len,
        i;

    method = aRequest.at('method');
    if (!TP.HTTP_ALLOWED_SIMPLE_CORS_METHODS.contains(method)) {
        TP.ifWarn() ?
            TP.warn('HTTP method: \'' + method + '\' is not a usable' +
                    ' \'simple CORS\' method') : 0;
        return false;
    }

    mimetype = aRequest.at('mimetype');
    if (!TP.HTTP_ALLOWED_SIMPLE_CORS_ENCODINGS.contains(mimetype)) {
        TP.ifWarn() ?
            TP.warn('HTTP encoding: \'' + mimetype + '\' is not a usable' +
                    ' \'simple CORS\' encoding') : 0;
        return false;
    }

    headers = aRequest.at('headers');
    headerKeys = headers.getKeys();
    len = headerKeys.getSize();
    for (i = 0; i < len; i++) {
        if (!TP.HTTP_ALLOWED_SIMPLE_CORS_HEADERS.contains(headerKeys.at(i))) {
            TP.ifWarn() ?
                TP.warn('HTTP header: \'' + headerKeys.at(i) +
                        '\' is not a usable \'simple CORS\' header') : 0;
            return false;
        }
    }

    return true;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('httpSetHeaders',
function(targetUrl, aRequest, httpObj) {

    /**
     * @method httpSetHeaders
     * @summary Sets the HTTP headers on httpObj for the URL, call type (HTTP
     *     method), and header collection provided.
     * @description TIBET manages certain headers by default, in particular
     *     Cache-control and Pragma headers that help ensure that requests for
     *     data get current data whenever possible. You can override this by
     *     simply providing those keys in the header collection to tell TIBET
     *     you have your own plans for how to manage the headers.
     *
     *     Also note that certain header management is handled by the TPHTTPURI
     *     type to help ensure that ETag processing and other cache-related
     *     behavior is done properly.
     * @param {String} targetUrl The URL accessed by the request.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
     *     additional parameters.
     * @param {XMLHttpRequest} httpObj The request object to configure.
     * @returns {String} The headers in string form, for logging. Note that the
     *     httpObj provided will contain the new headers on return from this
     *     method.
     */

    var request,
        headers,

        simpleCORSOnly,

        header,
        token,
        hash,

        keys,
        len,
        i,
        key,
        val,
        j,
        body,
        url,

        altMethod;

    request = aRequest || TP.request();

    headers = TP.ifKeyInvalid(request, 'headers',
                                TP.httpGetDefaultHeaders());
    request.atPut('headers', headers);

    //  NOTE we use the string of the body content here for Content-Length
    body = request.at('finalbody');
    url = request.at('uri');

    simpleCORSOnly = TP.sys.cfg('http.simple_cors_only') ||
                        request.at('simple_cors_only');

    //  Default the mimetype based on body type as best we can.
    if (TP.notDefined(request.at('mimetype'))) {
        request.atPut('mimetype',
            TP.ietf.mime.guessMIMEType(body, TP.uc(url), TP.URL_ENCODED));
    }

    //  typically we turn off cache behavior for these requests so we're
    //  sure we're getting the most current data. In the case where we have a
    //  URI that need privileges and the caller has specified 'simple CORS',
    //  though, we can't specify these headers since they are not part of
    //  simple CORS.

    if (TP.uriNeedsPrivileges(targetUrl) && simpleCORSOnly) {
        //  targetUrl needs privileges but we're configured for 'simple
        //  CORS' only, which disallows these headers.
        void 0;
    } else {
        //  on moz we have to avoid duplication of this header, which seems
        //  to appear as if by magic...
        if (TP.sys.isUA('GECKO')) {
            if (TP.isDefined(header = headers.at('Pragma'))) {
                if (header === 'no-cache') {
                    headers.removeKey('Pragma');
                } else if (TP.isArray(header)) {
                    header.remove('no-cache');
                }
            }
        }
    }

    //  add a header for Content-Type if not already found. default is
    //  standard form encoding
    if (TP.notDefined(headers.at('Content-Type'))) {
        headers.atPut('Content-Type', request.at('mimetype'));
    }

    //  identify the request as coming from an XMLHttpRequest (ala Rails), but
    //  only if we'
    if (TP.notDefined(headers.at('X-Requested-With'))) {
        if (TP.uriNeedsPrivileges(targetUrl) && simpleCORSOnly) {
            //  targetUrl needs privileges but we're configured for 'simple
            //  CORS' only, which disallows custom 'X-' headers.
            void 0;
        } else {
            headers.atPut('X-Requested-With', 'XMLHttpRequest');
        }
    }

    //  if the request would like us to try to authenticate as part of the
    //  request (avoiding the initial round trip for the browser), we can
    //  try that here. Note that we only support 'HTTP Basic' authentication
    //  for now ('HTTP Digest' authentication requires a round-trip to the
    //  server anyway for the 'server nonce').
    if (request.at('auth') === TP.HTTP_BASIC) {
        //  if 'Authorization' authentication header wasn't supplied but a
        //  username/password was, then compute an 'HTTP Basic'
        //  authentication header
        if (TP.notDefined(headers.at('Authorization')) &&
                TP.isDefined(request.at('username')) &&
                TP.isDefined(request.at('password'))) {
            hash = TP.btoa(
                    TP.join(request.at('username'),
                            ':',
                            request.at('password')));

            headers.atPut('Authorization', 'Basic ' + hash);
        }
    }

    //  If the user didn't already define an 'X-HTTP-Method-Override' header and
    //  the regular method was set to POST and there is an 'alternate method'
    //  provided, then set a 'X-HTTP-Method-Override' header with the alternate
    //  method. But only do this if we're not doing simple CORS.
    if (TP.notDefined(headers.at('X-HTTP-Method-Override'))) {
        if (request.at('method') === TP.HTTP_POST &&
            TP.notEmpty(altMethod = request.at('altmethod'))) {
            if (TP.uriNeedsPrivileges(targetUrl) && simpleCORSOnly) {
                //  targetUrl needs privileges but we're configured for 'simple
                //  CORS' only, which disallows custom 'X-' headers.
                void 0;
            } else {
                headers.atPut('X-HTTP-Method-Override', altMethod);
            }
        }
    }
    //  If there's a client-side JWT token, send it as well.
    token = TP.global.sessionStorage.getItem('TIBET.boot.tibet_token');
    if (TP.notEmpty(token)) {
        headers.atPut('x-access-token', token);
    }

    //  now that we've got our header collection in place for this call we
    //  need to actually add those headers to the current request object
    keys = TP.keys(headers);
    len = keys.getSize();
    for (i = 0; i < len; i++) {
        key = keys.at(i);
        val = headers.at(key);

        if (TP.isArray(val)) {
            if (TP.sys.isUA('WEBKIT')) {
                //  It's an Array of settings, so we join it with a ', '
                httpObj.setRequestHeader(key, val.join(', '));
            } else {
                for (j = 0; j < val.getSize(); j++) {
                    httpObj.setRequestHeader(key, val.at(j));
                }
            }
        } else {
            httpObj.setRequestHeader(key, val);
        }
    }

    return TP.str(headers);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$httpTimeout',
function(targetUrl, aRequest, httpObj) {

    /**
     * @method $httpTimeout
     * @summary Notifies the proper callback handlers and provides common
     *     signaling upon timeout of an HTTP request. This method is invoked
     *     automatically by the TP.httpCall method when an asynchronous
     *     request times out.
     * @param {String} targetUrl The full target URI in string form.
     * @param {TP.sig.Request} aRequest The request object holding parameter
     *     data.
     * @param {XMLHttpRequest} httpObj The native XMLHttpRequest object used to
     *     service the request.
     */

    var request,
        type,
        sig,
        id;

    //  kill the native request activity so no other callbacks will fire
    TP.httpAbort(httpObj);

    request = TP.request(aRequest);

    //  make sure the request has access to the native http request object
    request.atPut('commObj', httpObj);

    //  configure the request's final output parameters to record the error
    request.atPut('direction', TP.RECV);
    request.atPut('object', new Error('Timeout'));
    request.atPut('message', 'HTTP request failed: Timeout');

    //  log it consistently with any other error
    TP.httpError(targetUrl, 'HTTPSendException', request, false);

    //  get a response object for the request that we can use to convey the
    //  bad news in a consistent fashion with normal success processing.
    if (TP.notValid(type = TP.sys.getTypeByName('TP.sig.HTTPResponse',
                                                    false))) {
        if (TP.notValid(type = TP.sys.getTypeByName('TP.sig.Response',
                                                        false))) {
            //  real problems...typically crashing during boot since none of
            //  the core kernel response types appear to be valid.
            return;
        }
    }

    sig = type.construct(request);
    id = request.getRequestID();

    //  start with most specific, the fact we timed out
    sig.setSignalName('TP.sig.IOTimeout');
    sig.fire(id);

    //  move on to general failure, timeout is considered a failure
    sig.setSignalName('TP.sig.IOFailed');
    sig.fire(id);

    //  success or failure all operations "complete" so that's last
    sig.setSignalName('TP.sig.IOCompleted');
    sig.fire(id);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$httpWrapup',
function(targetUrl, aRequest, httpObj) {

    /**
     * @method $httpWrapup
     * @summary Notifies the proper callback handlers and provides common
     *     signaling upon completion of an HTTP request. Note that both
     *     synchronous and asynchronous requests will invoke this on completion
     *     of the request.
     * @param {String} targetUrl The full target URI in string form.
     * @param {TP.sig.Request} aRequest The request object holding parameter
     *     data.
     * @param {XMLHttpRequest} httpObj The native XMLHttpRequest object used to
     *     service the request.
     */

    var request,
        url,
        redirect,
        async,
        xhr,
        type,
        sig,
        id;

    request = aRequest || TP.request();

    url = targetUrl;
    if (TP.notValid(url)) {
        url = request.at('uri');
    }

    //  typically we'll allow redirects, but TP.httpDelete and others may
    //  set this to false to avoid potential problems
    redirect = request.atIfInvalid('redirect', true);

    //  if we got a redirection status we'll need to resubmit, provided that
    //  the particular request is not turning off redirection
    if (redirect && TP.httpDidRedirect(httpObj)) {
        //  update the url to the referred location...once
        url = httpObj.getResponseHeader('Location');

        //  if the original request was async that might cause another
        //  async call here...but we want to avoid that level of
        //  complexity here so we adjust when redirected
        async = request.at('async');
        if (TP.isTrue(async)) {
            //  TODO:   this could create a potential "hang" condition if
            //  the redirected site isn't available
            request.atPut('async', false);
        }

        try {
            //  NOTE that httpCall will store 'commObj' for us.
            TP.httpCall(url, request);
        } finally {
            request.atPut('async', async);
        }
    } else {
        xhr = httpObj;
        request.atPut('commObj', xhr);
    }

    //  create a signal that will carry the request to any callbacks in a
    //  fashion that allows it to treat it like a proper response object
    if (TP.notValid(type = TP.sys.getTypeByName('TP.sig.HTTPResponse',
                                                    false))) {
        if (TP.notValid(type = TP.sys.getTypeByName('TP.sig.Response',
                                                        false))) {
            //  real problems...typically crashing during boot since none of
            //  the core kernel response types appear to be valid.
            return;
        }
    }

    sig = type.construct(request);
    id = request.getRequestID();

    //  Make sure the signal we'll be sending is also mapped as the response for
    //  the original request.
    request.setResponse(sig);

    //  TODO:   do we want to signal something like an IORedirect as needed?

    //  with/without redirect, did we succeed?
    if (!TP.httpDidSucceed(xhr)) {
        //  NB: This method will signal 'TP.sig.IOFailed' and
        //  'TP.sig.IOCompleted'
        TP.httpError(url, 'HTTPException', request, false);

        //  Fail the request here with the failure message and whatever Error
        //  object was produced by the TP.httpError method.
        request.fail(request.at('message'),
                        request.getFaultCode(),
                        TP.hc('error', request.at('error'),
                                'message', request.at('message')));
    } else {
        sig.setSignalName('TP.sig.IOSucceeded');
        sig.fire(id);

        sig.setSignalName('TP.sig.IOCompleted');
        sig.fire(id);
    }

    //  Make sure to complete this request if it hasn't already been completed.
    //  Normally, if request is an instance of the proper HTTP request type,
    //  this isn't necessary because HTTP type will have done this when it
    //  handles the IO* signal.
    if (!request.didComplete()) {
        request.complete();
    }

    return;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETHTTPPrimitivesBase.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * HTTP method support functions.
 */

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETHTTPPrimitivesPlatform.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * Platform-specific HTTP method support via XMLHttpRequest.
 * @description Note how we do *not* wrap ANY of the debugging messages below
 *     into TP.sc() calls, because when localization occurs, and we've booted
 *     over an HTTP-based URL, it tries to use this routine to do the
 *     localization, which causes major recursion problems.
 */

/* global Components:false
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('$httpObtainSecurityInfo',
TP.hc(
    'test',
    'gecko',
    'true',
    function(httpObj) {

        /**
         * @method $httpObtainSecurityInfo
         * @summary Obtains Gecko-specific security information from the
         *     supplied httpObj's channel, if it has one.
         * @param {XHR} httpObj The XMLHttpRequest object containing the channel
         *     to retrieve security information from.
         * @returns {String} The security information contained in the channel
         *     of the supplied XHR object.
         */

        var successfulExec,
            retMsg;

        retMsg = TP.ac();

        /* eslint-disable new-cap */
        successfulExec = TP.executePrivileged(
            TP.ACCESS_XDOMAIN_XMLHTTP,
            'This TIBET-based application would like to read XMLHttpRequest security information',
            'This TIBET-based application cannot read XMLHttpRequest security information',
            false,      //  don't bother trying to do this without privileges
            function() {

                var channel,
                    compInf,

                    securityInfo,

                    cert,
                    verificationResult,

                    validity;

                try {
                    channel = httpObj.channel;
                    compInf = Components.interfaces;

                    if (!(channel instanceof compInf.nsIChannel)) {
                        //  No channel available.
                        return;
                    }

                    securityInfo = channel.securityInfo;

                    if (securityInfo instanceof
                                    compInf.nsITransportSecurityInfo) {
                        securityInfo.QueryInterface(
                                compInf.nsITransportSecurityInfo);

                        retMsg.push('Security state: ');

                        //  Check security state flags
                        if ((securityInfo.securityState &
                            compInf.nsIWebProgressListener.STATE_IS_SECURE) ===
                        compInf.nsIWebProgressListener.STATE_IS_SECURE) {
                            retMsg.push('secure\n');
                        } else if ((securityInfo.securityState &
                            compInf.nsIWebProgressListener.STATE_IS_INSECURE) ===
                        compInf.nsIWebProgressListener.STATE_IS_INSECURE) {
                            retMsg.push('insecure\n');
                        } else if ((securityInfo.securityState &
                            compInf.nsIWebProgressListener.STATE_IS_BROKEN) ===
                        compInf.nsIWebProgressListener.STATE_IS_BROKEN) {
                            retMsg.push('unknown\n');
                        }

                        retMsg.push('\tSecurity description: ',
                                    securityInfo.shortSecurityDescription,
                                    '\n');
                        retMsg.push('\tSecurity error message: ',
                                    securityInfo.errorMessage,
                                    '\n');
                    } else {
                        retMsg.push(
                            '\tNo security info available for this channel\n');
                    }

                    //  Print SSL certificate details
                    if (securityInfo instanceof compInf.nsISSLStatusProvider) {
                        cert = securityInfo.QueryInterface(
                        compInf.nsISSLStatusProvider).SSLStatus.QueryInterface(
                            compInf.nsISSLStatus).serverCert;
                        retMsg.push('\nCertificate Status:\n');

                        verificationResult = cert.verifyForUsage(
                                    compInf.nsIX509Cert.CERT_USAGE_SSLServer);
                        retMsg.push('\tVerification: ');

                        switch (verificationResult) {
                            case compInf.nsIX509Cert.VERIFIED_OK:

                                retMsg.push('OK');
                                break;

                            case compInf.nsIX509Cert.NOT_VERIFIED_UNKNOWN:

                                retMsg.push('not verfied/unknown');
                                break;

                            case compInf.nsIX509Cert.CERT_REVOKED:

                                retMsg.push('revoked');
                                break;

                            case compInf.nsIX509Cert.CERT_EXPIRED:

                                retMsg.push('expired');
                                break;

                            case compInf.nsIX509Cert.CERT_NOT_TRUSTED:

                                retMsg.push('not trusted');
                                break;

                            case compInf.nsIX509Cert.ISSUER_NOT_TRUSTED:

                                retMsg.push('issuer not trusted');
                                break;

                            case compInf.nsIX509Cert.ISSUER_UNKNOWN:

                                retMsg.push('issuer unknown');
                                break;

                            case compInf.nsIX509Cert.INVALID_CA:

                                retMsg.push('invalid CA');
                                break;

                            default:

                                retMsg.push('unexpected failure');
                                break;
                        }

                        retMsg.push('\n');

                        retMsg.push('\tCommon name (CN) = ',
                                    cert.commonName, '\n');
                        retMsg.push('\tOrganisation = ',
                                    cert.organization, '\n');
                        retMsg.push('\tIssuer = ',
                                    cert.issuerOrganization, '\n');
                        retMsg.push('\tSHA1 fingerprint = ',
                                    cert.sha1Fingerprint, '\n');

                        validity = cert.validity.QueryInterface(
                                            compInf.nsIX509CertValidity);
                        retMsg.push('\tValid from ',
                                    validity.notBeforeGMT, '\n');
                        retMsg.push('\tValid until ',
                                    validity.notAfterGMT, '\n');
                    }
                } catch (e) {
                    retMsg.push(TP.str(e));
                }
            });
            /* eslint-enable new-cap */

        if (successfulExec) {
            return retMsg.join('');
        }

        return null;
    },
    TP.DEFAULT,
    function(httpObj) {

        //  NB: Other browsers don't need this call - just return.
        return;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('httpCall',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(targetUrl, aRequest) {

        /**
         * @method httpCall
         * @summary Performs an XMLHttpRequest based on the information
         *     provided in aRequest. NOTE that the request object is updated
         *     with a number of keys which define the actual data used for the
         *     current HTTP call.
         * @param {String} targetUrl The request's target URL.
         * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
         *     additional parameters.
         * @exception TP.sig.InvalidURI
         * @exception TP.sig.PrivilegeException
         * @exception TP.sig.HTTPException
         * @exception TP.sig.HTTPHeaderException
         * @exception TP.sig.HTTPSendException
         * @throws Error Various HTTP-related errors.
         * @returns {TP.sig.Response} The response object for the request used.
         */

        var request,
            url,
            query,

            method,
            async,

            content,
            contentString,

            httpObj,

            username,
            password,

            job,
            estr;

        //  ensure we've got a default request object to avoid problems
        //  below
        request = TP.request(aRequest);

        //  with request mapping ensured we can now test for viable target
        //  URI
        url = targetUrl || request.at('uri');
        if (TP.isEmpty(url)) {
            TP.httpError(targetUrl, 'TP.sig.InvalidURI', request);
            return;
        }

        if (!TP.isURIString(url)) {
            TP.httpError(url, 'TP.sig.InvalidParameter', request);
            return;
        }

        //  expand the url as needed using any query data in the request.
        //  NOTE that we do this for all request types, so any URL can be
        //  augmented by adding a query string or query hash to the request
        //  without actually altering the original URI. ALSO NOTE that we do
        //  NOT rewrite here, that must be done in higher-level methods so
        //  this call can be certain of what's being requested
        url = url.getLocation();
        request.addIfAbsent('uri', url);

        if (TP.notEmpty(query = request.at('uriparams'))) {
            //  when using x-www-form-urlencoded the return value is the
            //  "query" portion which needs to be added to the URI before
            //  sending
            query = TP.httpEncode(query, TP.URL_ENCODED);
            if (TP.notEmpty(query)) {
                url = TP.uriJoinQuery(url, query);
            }
        }
        request.atPut('finaluri', url);

        //  TODO: if nocache is true we want to add a unique ID to the
        //  query/url

        request.addIfAbsent('method', TP.HTTP_GET);
        method = request.at('method');

        request.addIfAbsent('async', true);
        async = request.at('async');

        //  we want to send the string representation whenever there's data
        content = request.at('body');
        if (TP.isValid(content)) {
            contentString = TP.httpEncodeRequestBody(request);
            request.atPut('finalbody', contentString);
            if (TP.isNode(content)) {
                request.atIfInvalid('bodyWantsXMLDeclaration', false);
            }
        }

        //  set up the actual request
        try {
            httpObj = TP.httpConstruct(url);
            request.atPut('commObj', httpObj);

            //  NOTE: As of Chrome 19+, etc. using the username/password fields
            //  of the 'open()' method below is unsupported because that will
            //  result in a 'URL embedded entity' (i.e.
            //  'username:password@foo.com'). We can't get rid of these request
            //  parameters, because they're used by things like the 'basic auth'
            //  header generator, but we don't extract them here
            //  username = request.at('username');
            //  password = request.at('password');

            //  if either username or password use our special value, TP.NONE,
            //  set them to null so that the word 'none' isn't used and so that
            //  we are XHR spec compliant
            if (request.at('username') === TP.NONE) {
                username = null;
            }

            if (request.at('password') === TP.NONE) {
                password = null;
            }

            httpObj.open(method, url, async, username, password);
        } catch (e) {
            request.atPut('object', e);
            request.atPut('message', TP.str(e));

            TP.httpError(targetUrl, 'HTTPException', request);
            return;
        }

        if (TP.isValid(request.at('withCredentials')) &&
            'withCredentials' in httpObj) {
            httpObj.withCredentials = request.at('withCredentials');
        }

        //  configure headers based on URI and header collection
        try {
            TP.httpSetHeaders(url, request, httpObj);
        } catch (e) {
            request.atPut('object', e);
            request.atPut('message', TP.str(e));

            TP.httpError(targetUrl, 'HTTPHeaderException', request);
            return;
        }

        //  We've assembled all of the information we need to see if a 'simple
        //  CORS' request is doable. If the caller has specified 'simple CORS'
        //  then we should check it and return if it's not doable. Note that the
        //  method we call here will log warnings with more information.
        if (TP.sys.cfg('http.simple_cors_only') ||
            request.at('simple_cors_only')) {
            if (!TP.httpRequestPassesSimpleCORSRestrictions(request)) {
                return;
            }
        }

        //  configure for async processing as needed
        if (async) {
            //  going to be async? then we'll want a timeout option
            //  via a job
            job = TP.schedule(
                TP.hc('step',
                        function() {

                            TP.$httpTimeout(targetUrl, request,
                                            httpObj);

                            return true;
                        },
                        'delay',
                            TP.ifInvalid(
                                    request.at('timeout'),
                                    TP.sys.cfg('http.timeout'))));

            //  creating a closure lets us manage the timeout job,
            //  handle logging of the request data, and process the
            //  results easier
            httpObj.onreadystatechange = function() {

                //  the only state we bother with is "complete"
                if (httpObj.readyState !== 4) {
                    return;
                }

                //  close out the timeout job silently
                job.kill(true);

                request.atPut('direction',
                                TP.RECV);
                request.atPut('message',
                                'HTTP request completed.');

                TP.ifInfo() && TP.sys.shouldLogIO() ?
                    TP.sys.logIO(request, TP.INFO) :
                    0;

                TP.$httpWrapup(targetUrl, request, httpObj);
            };
        }

        //  isolate the actual send call for finer-grained error
        //  handling
        try {
            request.atPut('direction', TP.SEND);
            request.atPut('message', 'HTTP request initiated.');

            TP.ifInfo() && TP.sys.shouldLogIO() ?
                TP.sys.logIO(request, TP.INFO) : 0;

            //  NB: We have to "'' +" the content string here to
            //  get a primitive string - for some reason, Gecko
            //  doesn't like to send 'String Objects'. But we only
            //  do this if contentString is valid.
            if (TP.isString(contentString)) {
                contentString = '' + contentString;
            }

            try {
                //  the actual send
                httpObj.send(contentString);
            } catch (e2) {

                estr = TP.tostr(e2);
                if (TP.isString(estr) && /0x80004005/.test(estr)) {
                    if (TP.uriNeedsPrivileges(targetUrl)) {
                        //  Probably a CORS request that failed
                        estr = 'The URL needs privileges and' +
                                    ' couldn\'t obtain them. Bad' +
                                    ' CORS request?';
                    } else if (httpObj.status === 0 &&
                        TP.isEmpty(estr =
                                    TP.$httpObtainSecurityInfo(
                                        httpObj))) {
                        //  domain probably missing but no valid status
                        //  comes back
                        estr = 'XHR status is 0 and there' +
                                    ' was no security info.' +
                                    ' URL missing domain or bad' +
                                    ' certificate?';
                    }

                    TP.ifWarn() ? TP.warn(estr) : 0;
                } else {
                    //  throw so the outer catch block can handle it
                    throw e2;
                }
            }

            //  if we're not relying on the asynch handler to log we
            //  do it here
            if (TP.notTrue(async)) {
                request.atPut('direction', TP.RECV);
                request.atPut('message', 'HTTP request completed.');

                TP.ifInfo() && TP.sys.shouldLogIO() ?
                    TP.sys.logIO(request, TP.INFO) : 0;

                TP.$httpWrapup(targetUrl, request, httpObj);
            }
        } catch (e) {
            if (TP.isValid(job)) {
                //  close out the timeout job silently
                job.kill(true);
            }

            request.atPut('direction', TP.RECV);
            request.atPut('object', e);
            request.atPut('message', 'HTTP request failed: ' +
                                        TP.str(e));

            TP.httpError(targetUrl, 'HTTPSendException', request);
            return;
        }

        //  NOTE:   appears to be a Moz bug here when the connection
        //          is refused, the httpObj goes away and no
        //          exception is thrown.
        if (TP.notValid(httpObj)) {
            request.atPut('message',
                            'The server may have refused the ' +
                                    'connection. Is the URI a valid ' +
                                    'target?');

            TP.httpError(targetUrl, 'HTTPException', request);
            return;
        }

        return request.getResponse();
    },
    'webkit',
    function(targetUrl, aRequest) {

        /**
         * @method httpCall
         * @summary Performs an XMLHttpRequest based on the information
         *     provided in aRequest. NOTE that the request object is updated
         *     with a number of keys which define the actual data used for the
         *     current HTTP call.
         * @param {String} targetUrl The request's target URL.
         * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
         *     additional parameters.
         * @throws Error Various HTTP-related errors.
         * @exception TP.sig.InvalidURI
         * @exception TP.sig.PrivilegeException
         * @exception TP.sig.HTTPException
         * @exception TP.sig.HTTPHeaderException
         * @exception TP.sig.HTTPSendException
         * @returns {TP.sig.Response} The response object for the request used.
         */

        var request,
            url,
            query,

            method,
            async,

            content,
            contentString,

            username,
            password,

            httpObj,
            job;

        //  ensure we've got a default request object to avoid problems
        //  below
        request = TP.request(aRequest);

        //  with request mapping ensured we can now test for viable target
        //  URI
        url = targetUrl || request.at('uri');
        if (TP.isEmpty(url)) {
            TP.httpError(targetUrl, 'TP.sig.InvalidURI', request);
            return;
        }

        if (!TP.isURIString(url)) {
            TP.httpError(url, 'TP.sig.InvalidParameter', request);
            return;
        }

        //  On Webkit, if we launched over HTTP and do *not* have CORS support,
        //  we can *only* query against the domain we launched from. If we
        //  launched from the file system, we can (try to) query any URL.
        if (TP.sys.isHTTPBased() &&
            TP.uriNeedsPrivileges(targetUrl) &&
            !('withCredentials' in new XMLHttpRequest())) {

            request.atPut('message', 'Permission not available to ' +
                                        'make cross-domain HTTP call');

            TP.httpError(targetUrl, 'TP.sig.PrivilegeViolation', request);
            return;
        }

        //  expand the url as needed using any query data in the request.
        //  NOTE that we do this for all request types, so any URL can be
        //  augmented by adding a query string or query hash to the request
        //  without actually altering the original URI. ALSO NOTE that we do
        //  NOT rewrite here, that must be done in higher-level methods so
        //  this call can be certain of what's being requested
        url = url.getLocation();
        request.addIfAbsent('uri', url);

        if (TP.notEmpty(query = request.at('uriparams'))) {
            //  when using x-www-form-urlencoded the return value is the
            //  "query" portion which needs to be added to the URI before
            //  sending
            query = TP.httpEncode(query, TP.URL_ENCODED);
            if (TP.notEmpty(query)) {
                url = TP.uriJoinQuery(url, query);
            }
        }
        request.atPut('finaluri', url);

        //  TODO: if nocache is true we want to add a unique ID to the
        //  query/url

        request.addIfAbsent('method', TP.HTTP_GET);
        method = request.at('method');

        request.addIfAbsent('async', true);
        async = request.at('async');

        //  we want to send the string representation whenever there's data
        content = request.at('body');
        if (TP.isValid(content)) {
            contentString = TP.httpEncodeRequestBody(request);
            request.atPut('finalbody', contentString);
            if (TP.isNode(content)) {
                request.atIfInvalid('bodyWantsXMLDeclaration', false);
            }
        }

        //  set up the actual request
        try {
            httpObj = TP.httpConstruct(url);
            request.atPut('commObj', httpObj);

            //  NOTE: As of Chrome 19+, etc. using the username/password fields
            //  of the 'open()' method below is unsupported because that will
            //  result in a 'URL embedded entity' (i.e.
            //  'username:password@foo.com'). We can't get rid of these request
            //  parameters, because they're used by things like the 'basic auth'
            //  header generator, but we don't extract them here
            //  username = request.at('username');
            //  password = request.at('password');

            //  if either username or password use our special value, TP.NONE,
            //  set them to null so that the word 'none' isn't used and so that
            //  we are XHR spec compliant
            if (request.at('username') === TP.NONE) {
                username = null;
            }

            if (request.at('password') === TP.NONE) {
                password = null;
            }

            httpObj.open(method, url, async, username, password);
        } catch (e) {
            request.atPut('object', e);
            request.atPut('message', TP.str(e));

            TP.httpError(targetUrl, 'HTTPException', request);
            return;
        }

        if (TP.isValid(request.at('withCredentials')) &&
            'withCredentials' in httpObj) {
            httpObj.withCredentials = request.at('withCredentials');
        }

        //  configure headers based on URI and header collection
        try {
            TP.httpSetHeaders(url, request, httpObj);
        } catch (e) {
            request.atPut('object', e);
            request.atPut('message', TP.str(e));

            TP.httpError(targetUrl, 'HTTPHeaderException', request);
            return;
        }

        //  We've assembled all of the information we need to see if a 'simple
        //  CORS' request is doable. If the caller has specified 'simple CORS'
        //  then we should check it and return if it's not doable. Note that the
        //  method we call here will log warnings with more information.
        if (TP.sys.cfg('http.simple_cors_only') ||
            request.at('simple_cors_only')) {
            if (!TP.httpRequestPassesSimpleCORSRestrictions(request)) {
                return;
            }
        }

        //  configure for async processing as needed
        if (async) {
            //  going to be async? then we'll want a timeout option via a
            //  job
            job = TP.schedule(
                TP.hc('step',
                        function() {

                            TP.$httpTimeout(targetUrl,
                                            request,
                                            httpObj);

                            return true;
                        },
                        'delay', TP.ifInvalid(
                                            request.at('timeout'),
                                            TP.sys.cfg('http.timeout'))));

            //  creating a closure lets us manage the timeout job, handle
            //  logging of the request data, and process the results easier
            httpObj.onreadystatechange = function() {

                //  the only state we bother with is "complete"
                if (httpObj.readyState !== 4) {
                    return;
                }

                //  close out the timeout job silently
                job.kill(true);

                request.atPut('direction', TP.RECV);
                request.atPut('message', 'HTTP request completed.');

                TP.ifInfo() && TP.sys.shouldLogIO() ?
                    TP.sys.logIO(request, TP.INFO) : 0;

                TP.$httpWrapup(targetUrl, request, httpObj);
            };
        }

        //  isolate the actual send call for finer-grained error handling
        try {
            request.atPut('direction', TP.SEND);
            request.atPut('message', 'HTTP request initiated.');

            TP.ifInfo() && TP.sys.shouldLogIO() ?
                TP.sys.logIO(request, TP.INFO) : 0;

            //  NB: For Mozilla, we "'' +" the content string here to get a
            //  primitive string - here, we just do it for consistency with
            //  Mozilla. But we only do this if contentString is valid.
            if (TP.isString(contentString)) {
                contentString = '' + contentString;
            }

            //  the actual send
            httpObj.send(contentString);

            //  if we're not relying on the asynch handler to log we do it
            //  here
            if (TP.notTrue(async)) {
                request.atPut('direction', TP.RECV);
                request.atPut('message', 'HTTP request completed.');

                TP.ifInfo() && TP.sys.shouldLogIO() ?
                        TP.sys.logIO(request, TP.INFO) : 0;

                TP.$httpWrapup(targetUrl, request, httpObj);
            }
        } catch (e) {
            if (TP.isValid(job)) {
                //  close out the timeout job silently
                job.kill(true);
            }

            request.atPut('direction', TP.RECV);
            request.atPut('object', e);
            request.atPut('message', 'HTTP request failed: ' + TP.str(e));

            TP.httpError(targetUrl, 'HTTPSendException', request);
            return;
        }

        return request.getResponse();
    }
));

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETHTTPPrimitivesPost.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
Common HTTP method support. Each of the calls in this file ultimately relies
on the low-level TP.httpCall function in one of the browser-specific HTTP
support files. The value of these wrappers lies in their pre-built request
configuration logic, which helps keep things easier for callers and in their
common response handling.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('httpAbort',
function(httpObj) {

    /**
     * @method httpAbort
     * @summary Aborts an in-process XMLHttpRequest, clearing any handlers
     *     which may be present.
     * @param {XMLHttpRequest} httpObj The native XMLHttpRequest to abort.
     * @returns {XMLHttpRequest} The aborted XHR object.
     */

    if (TP.notValid(httpObj)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  IE prefers an empty function here
    httpObj.onreadystatechange = TP.RETURN_NULL;

    //  NOTE we used to call httpObj.abort() here but doing that will clear any
    //  data on the object depending on the browser in question. So don't do
    //  that :).

    return httpObj;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('httpConnect',
function(targetUrl, aRequest) {

    /**
     * @method httpConnect
     * @summary Sends the data contained in the 'body' parameter of the request
     *     to the targetUrl using an HTTP CONNECT request.
     * @param {String} targetUrl The request's target URL.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
     *     additional parameters.
     * @exception TP.sig.InvalidURI
     * @returns {TP.sig.Response} The response object for the request used.
     */

    return TP.$httpSend(TP.HTTP_CONNECT, targetUrl, aRequest);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('httpDelete',
function(targetUrl, aRequest) {

    /**
     * @method httpDelete
     * @summary Attempts to delete the target URL via an HTTP DELETE. On
     *     success the return value's status property will be TP.core.HTTP.OK.
     *     Note that no redirect processing is used in this call to avoid any
     *     potential confusion related to the true target unless you
     *     specifically add a key of 'redirect' with a value of true to the
     *     request.
     * @param {String} targetUrl The request's target URL.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
     *     additional parameters.
     * @exception TP.sig.InvalidURI
     * @exception TP.sig.HTTPException
     * @returns {TP.sig.Response} The response object for the request used.
     */

    var request;

    //  we use httpSend which is used for state-change methods and their
    //  processing. but we make sure the request says noredirect for DELETE
    //  and we also turn off query and payload processing
    request = TP.request(aRequest);
    request.atPutIfAbsent('redirect', false);

    return TP.$httpSend(TP.HTTP_DELETE, targetUrl, request);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('httpGet',
function(targetUrl, aRequest) {

    /**
     * @method httpGet
     * @summary Gets the named resource via an HTTP GET call. You can pass
     *     parameters to the root url by using the query parameter of aRequest.
     *     The query is application/x-www-form-urlencoded and appended to the
     *     targetUrl. If no query is provided then the URI is assumed to be
     *     complete and is used "as is". For GET calls the Content-Type is
     *     automatically set to the encoding format of the data to ensure
     *     consistency.
     * @param {String} targetUrl The request's target URL, or the root of that
     *     URL, ready for the addition of any encoded data values.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
     *     additional parameters.
     * @exception TP.sig.InvalidURI
     * @exception TP.sig.HTTPException
     * @returns {TP.sig.Response} The response object for the request used.
     */

    var request,
        headers,
        contentType;

    request = TP.request(aRequest);

    //  here we ensure the proper Content-Type header is set for GET. Note
    //  that, unlike in PUT and POST, we force x-www-form-urlencoded and log
    //  a warning if they tried to supply another Content-Type.
    headers = request.at('headers');
    if (TP.notValid(headers)) {
        headers = TP.hc('Content-Type', TP.URL_ENCODED);
        request.atPutIfAbsent('headers', headers);
    } else {
        if (TP.notEmpty(contentType = headers.at('Content-Type'))) {
            if (contentType !== TP.URL_ENCODED) {
                TP.ifWarn() ?
                    TP.warn('Content-Type supplied to GET call.' +
                                ' Forcing to be ' + TP.URL_ENCODED + '.',
                            TP.IO_LOG) : 0;
            }
        }

        headers.atPut('Content-Type', TP.URL_ENCODED);
    }

    return TP.$httpQuery(TP.HTTP_GET, targetUrl, request);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('httpHead',
function(targetUrl, aRequest) {

    /**
     * @method httpHead
     * @summary Makes an HTTP HEAD call to the specified URL.
     * @param {String} targetUrl The request's target URL.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
     *     additional parameters.
     * @exception TP.sig.InvalidURI
     * @returns {TP.sig.Response} The response object for the request used.
     */

    return TP.$httpQuery(TP.HTTP_HEAD, targetUrl, aRequest);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('httpOptions',
function(targetUrl, aRequest) {

    /**
     * @method httpOptions
     * @summary Makes an OPTIONS request of the URL provided. The 'Allow'
     *     header from the response, available via getResponseHeader, provides
     *     the option list.
     * @param {String} targetUrl The request's target URL.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
     *     additional parameters.
     * @exception TP.sig.InvalidURI
     * @returns {TP.sig.Response} The response object for the request used.
     */

    return TP.$httpQuery(TP.HTTP_OPTIONS, targetUrl, aRequest);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('httpPatch',
function(targetUrl, aRequest) {

    /**
     * @method httpPatch
     * @summary Sends the data contained in the 'body' parameter of the request
     *     to the targetUrl using an HTTP PATCH request.
     * @param {String} targetUrl The request's target URL.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
     *     additional parameters.
     * @exception TP.sig.InvalidURI
     * @returns {TP.sig.Response} The response object for the request used.
     */

    return TP.$httpSend(TP.HTTP_PATCH, targetUrl, aRequest);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('httpPost',
function(targetUrl, aRequest) {

    /**
     * @method httpPost
     * @summary Sends the data contained in the 'body' parameter of the request
     *     to the targetUrl using an HTTP POST.
     * @param {String} targetUrl The request's target URL.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
     *     additional parameters.
     * @exception TP.sig.InvalidURI
     * @returns {TP.sig.Response} The response object for the request used.
     */

    return TP.$httpSend(TP.HTTP_POST, targetUrl, aRequest);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('httpPut',
function(targetUrl, aRequest) {

    /**
     * @method httpPut
     * @summary Sends the data contained in the 'body' parameter of the request
     *     to the targetUrl using an HTTP PUT.
     * @param {String} targetUrl The request's target URL.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
     *     additional parameters.
     * @exception TP.sig.InvalidURI
     * @returns {TP.sig.Response} The response object for the request used.
     */

    return TP.$httpSend(TP.HTTP_PUT, targetUrl, aRequest);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('httpTrace',
function(targetUrl, aRequest) {

    /**
     * @method httpTrace
     * @summary Makes an HTTP TRACE call to the specified URL.
     * @param {String} targetUrl The request's target URL.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
     *     additional parameters.
     * @exception TP.sig.InvalidURI
     * @returns {TP.sig.Response} The response object for the request used.
     */

    return TP.$httpQuery(TP.HTTP_TRACE, targetUrl, aRequest);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$httpQuery',
function(httpMethod, targetUrl, aRequest) {

    /**
     * @method $httpQuery
     * @summary Returns a response object containing the result of an HTTP
     *     "query", meaning a non-state-changing request, with the specified
     *     method, URL, and associated parameters. This routine is the common
     *     handler for GET, HEAD, OPTIONS, and TRACE. You can pass parameters to
     *     the root url by using the query parameter of aRequest. The query's
     *     key/value pairs are then application/x-www-form-urlencoded and
     *     appended to the URL.
     * @param {String} httpMethod TP.HTTP_GET, TP.HTTP_HEAD, TP.HTTP_OPTIONS, or
     *     TP.HTTP_TRACE.
     * @param {String} targetUrl The request's target URL.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
     *     additional parameters.
     * @exception TP.sig.InvalidURI
     * @returns {TP.sig.Response} The response object for the request used.
     */

    var request;

    request = TP.request(aRequest);

    request.atPut('uri', targetUrl);
    request.atPut('method', httpMethod);

    if (TP.isEmpty(targetUrl)) {
        TP.httpError(targetUrl, 'TP.sig.InvalidURI', request);
        return;
    }

    try {
        TP.httpCall(targetUrl, request);
    } catch (e) {
        request.atPut('object', e);
        request.atPut('message', TP.str(e));

        TP.httpError(targetUrl,
            TP.ifKeyInvalid(request, 'exceptionType', 'HTTPException'),
            request);
        return;
    }

    return request.getResponse();
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$httpSend',
function(httpMethod, targetUrl, aRequest) {

    /**
     * @method $httpSend
     * @summary Sends the data contained in the 'body' parameter of the request
     *     to the targetUrl using the command method provided (normally
     *     TP.HTTP_POST or TP.HTTP_PUT).
     * @param {String} httpMethod TP.HTTP_POST, TP.HTTP_PUT, etc.
     * @param {String} targetUrl The request's target URL.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
     *     additional parameters.
     * @exception TP.sig.InvalidURI
     * @returns {TP.sig.Response} The response object for the request used.
     */

    var request,
        headers;

    request = TP.request(aRequest);
    request.atPut('uri', targetUrl);
    request.atPut('method', httpMethod);

    if (TP.isEmpty(targetUrl)) {
        TP.httpError(targetUrl, 'TP.sig.InvalidURI', request);
        return;
    }

    //  Ensure headers are converted to a hash
    headers = TP.hc(request.at('headers'));
    request.atPut('headers', headers);

    try {
        TP.httpCall(targetUrl, request);
    } catch (e) {
        request.atPut('object', e);
        request.atPut('message', TP.str(e));

        TP.httpError(targetUrl,
            TP.ifKeyInvalid(request, 'exceptionType', 'HTTPException'),
            request);
        return;
    }

    return request.getResponse();
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETURIPrimitivesPre.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 */

//  ------------------------------------------------------------------------
//  FILE PATHS
//  ------------------------------------------------------------------------

/**
 * File path manipulation. These provide a foundation for TIBET to operate on
 * files accessible via either HTTP or FILE urls. Also, we try to adapt to
 * platform variations like the need to quote filenames on Windows that may
 * include spaces in them.
 */

//  ------------------------------------------------------------------------

TP.definePrimitive('isURIString',
function(anObject, schemeOptional) {

    /**
     * @method isURIString
     * @summary Returns true if the supplied String matches the URI format.
     * @param {Object} anObject The object to test.
     * @param {Boolean} [schemeOptional=false] Whether or not the URI scheme is
     *     optional in the String being tested.
     * @returns {Boolean} True if the object appears to match a URI-formatted
     *     String.
     */

    if (!TP.isString(anObject)) {
        return false;
    }

    if (schemeOptional) {
        return TP.regex.URI_LIKELY.test(anObject) &&
            !TP.regex.HAS_LINEBREAK.test(anObject);
    }

    return TP.regex.SCHEME.test(anObject) &&
        !TP.regex.HAS_LINEBREAK.test(anObject) &&
        TP.regex.URI_STRICT.test(anObject);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriAddUniqueQuery',
function(aPath) {

    /**
     * @method uriAddUniqueQuery
     * @summary Adds a unique query parameter to the path. This is normally used
     *     to 'bust' caches for things like CSS URLs.
     * @param {String} aPath The path to add a unique query string to.
     * @exception TP.sig.InvalidURI
     * @returns {String} The path with the unique query added to it.
     */

    var path;

    if (!TP.isString(aPath)) {
        return TP.raise(this, 'TP.sig.InvalidURI');
    }

    path = aPath +
            (aPath.contains('?') ? '&' : '?') +
            '_tibet_nocache=' + Date.now();

    return path;
});

//  ----------------------------------------------------------------------------

TP.definePrimitive('uriBaseParameters',
function(aURI, textOnly) {

    /**
     * @method uriBaseParameters
     * @summary Returns the parameters found on the base URL, if any. Base
     *     parameters are effectively server-side parameters since they are not
     *     part of the fragment and hence not processed by the TIBET client.
     * @param {String|TP.uri.URI} aURI The URI to process.
     * @param {Boolean} [textOnly=true] Return just the text parameter string
     *     if any.
     * @returns {String} The URI base parameter values.
     */

    var url,
        base,
        params;

    url = TP.str(aURI);
    if (TP.isEmpty(url)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    base = TP.uriHead(url);

    if (/\?/.test(base)) {
        params = base.slice(base.indexOf('?') + 1);
        if (TP.notFalse(textOnly)) {
            return params;
        }
    }

    if (params) {
        return TP.hc(TP.boot.$parseURIParameters(params));
    }

    return TP.notFalse(textOnly) ? '' : {};
});

//  ----------------------------------------------------------------------------

TP.definePrimitive('uriBasePath',
function(aURI) {

    /**
     * @method uriBasePath
     * @summary Returns the path portion of the URL base, the portion of the URL
     *     after the uriRoot and before any uriBaseParams. This essentially is
     *     the "server route" component.
     * @param {String|TP.uri.URI} aURI The URI to process.
     * @returns {String} The URI base path value.
     */

    var url,
        path;

    url = TP.str(aURI);
    if (TP.isEmpty(url)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    path = TP.uriHead(url);

    if (/\?/.test(path)) {
        path = path.slice(0, path.indexOf('?'));
    }

    //  Remove the root portion since we only want "path" segment.
    path = path.replace(TP.uriRoot(url), '');

    //  Remove any trailing /
    if (path.last() === '/') {
        path = path.slice(0, -1);
    }

    return path;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriCleansePath',
function(aPath) {

    /**
     * @method uriCleansePath
     * @summary Returns a version of the url provided with any user/pass
     *     information masked out. This is used for prompts and logging where
     *     basic auth data could potentially be exposed to view.
     * @param {String} aPath The URL to mask.
     * @returns {String} The masked URL.
     */

    var regex,
        match,
        newurl;

    //  scheme://(user):(pass)@hostetc...
    regex = /(.*)\/\/(.*):(.*)@(.*)/;

    if (!regex.test(aPath)) {
        return aPath;
    }

    match = regex.exec(aPath);
    newurl = match[1] + '//' + 'xxx:xxx@' + match[4];

    return newurl;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriCollapsePath',
function(aPath) {

    /**
     * @method uriCollapsePath
     * @summary Normalizes a URI path to remove any embedded . or .. segments
     *     which may exist by adjusting the path segments properly to resolve
     *     the relative portions.
     *
     *     NOTE that as part of processing, all \'s in the path are temporarily
     *     replaced with /'s, then reversed on completion. As a result, paths
     *     with a combination of /'s and \'s will be corrupted by this routine.
     *     Properly formatted paths such as C:\a\b\c, or file:///usr/local/bin
     *     are unaffected by this, but an invalid path such as file:///c:\a\b\c
     *     will be further corrupted as a result of this routine
     *     (file:\\\c:\a\b\c).
     * @param {String} aPath The path to normalize.
     * @exception TP.sig.InvalidURI
     * @returns {String}
     */

    var path,
        reverse,
        newpath;

    if (!TP.isString(aPath)) {
        return TP.raise(this, 'TP.sig.InvalidURI');
    }

    //  start by "normalizing" so we match our test/conversion regexes
    path = aPath.replace(/\\/g, '/');
    if (path !== aPath) {
        reverse = true;
    }

    //  if the path has /. in it anywhere we've got an offset of some kind,
    //  but otherwise we can return with minimal overhead
    if (!TP.regex.HAS_PATH_OFFSET.test(path)) {
        //  return original path if we aren't going to process it
        return aPath;
    }

    while (TP.regex.HAS_PATH_OFFSET.test(path)) {
        newpath = path.strip(TP.regex.REMOVE_PATH_OFFSET);
        if (newpath === path) {
            break;
        }
        path = newpath;
    }

    while (TP.regex.HAS_PATH_NOOP.test(path)) {
        newpath = path.strip(TP.regex.REMOVE_PATH_NOOP);
        if (newpath === path) {
            break;
        }
        path = newpath;
    }

    //  if the path came in as a local path return it in that format
    if (reverse) {
        path = path.replace(/\//g, '\\');
    }

    return path;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriCollectionPath',
function(aPath) {

    /**
     * @method uriCollectionPath
     * @summary Returns the 'collection path' for the URI, i.e. the entire path
     *     minus any file-specific portion.
     * @param {String} aPath The URI to slice to access the collection href.
     * @exception TP.sig.InvalidURI
     * @returns {String} The uri's collection path.
     */

    var path,
        index,
        slash;

    if (!TP.isString(aPath)) {
        return TP.raise(this, 'TP.sig.InvalidURI');
    }

    path = aPath;

    //  paths containing backslashes, such as paths on Windows, will use
    //  backslash as their test slash
    if (/\\/.test(aPath)) {
        slash = '\\';
    } else {
        slash = '/';
    }

    index = path.lastIndexOf(slash);

    //  If a slash was found, slice from the beginning of the entire path to
    //  that slash to obtain the 'collection' path.
    if (index !== TP.NOT_FOUND) {
        path = path.slice(0, index);
    }

    return path;
});

//  ----------------------------------------------------------------------------

TP.definePrimitive('uriCompose',
function(parts) {

    /**
     * @method uriCompose
     * @summary Builds up a proper URL from the parts provided. This routine
     *     is often used to compose new URLs from parts of other URLs such
     *     as the base components of a link combined with the fragment
     *     parameters of the launch url (boot parameters).
     * @param {TP.core.Hash|Object} parts An object containing strings for root,
     *     basePath, baseParams, fragmentPath, and fragmentParams. Missing
     *     parameters are ignored.
     * @returns {String} A new url assembled from the parts provided.
     */

    var root,
        basePath,
        baseParams,
        fragPath,
        fragParams,

        url;

    if (TP.isEmpty(parts)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    root = parts.at('root');
    basePath = parts.at('basePath');
    baseParams = parts.at('baseParams');
    fragPath = parts.at('fragmentPath');
    fragParams = parts.at('fragmentParams');

    if (TP.isEmpty(root)) {
        return;
    }

    //  This should be scheme etc. as in http(s):// or file://
    url = root;

    //  If this has any value at all it should be placed right behind root.
    if (TP.notEmpty(basePath)) {
        url += basePath;
    }

    //  Base parameters are parameters on the base uri, prior to the fragment.
    if (TP.notEmpty(baseParams)) {
        url += '?' +
            (TP.isString(baseParams) ? baseParams : baseParams.asQueryString());
    }

    //  Fragment path is any portion of the fragment prior to fragment params.
    //  By default an empty path is '/' to be consistent with location.pathname.
    if (fragPath !== '/' && TP.notEmpty(fragPath)) {

        //  If we're about to put on fragment don't leave base path empty.
        if (TP.isEmpty(basePath)) {
            url += '/';
        }

        //  Make sure that the fragment also has a leading '#', thereby
        url += '#' + fragPath;
    }

    //  Fragment parameters, aka boot parameters, are parameters which are part
    //  of the TIBET configuration system which are found in the fragment.
    if (TP.notEmpty(fragParams)) {

        //  Make sure that we're always within a fragment by forcing leading #.
        if (!/#/.test(url)) {

            //  If we're about to put on fragment don't leave base path empty.
            if (TP.isEmpty(basePath)) {
                url += '/';
            }
            url += '#';
        }

        url += '?' +
            (TP.isString(fragParams) ? fragParams : fragParams.asQueryString());
    }

    return url;
});

//  ----------------------------------------------------------------------------

TP.definePrimitive('uriDecompose',
function(aURI, textOnly) {

    /**
     * @method uriDecompose
     * @summary Splits a URL into constituent parts suitable for passing them to
     *     the uriCompose routine.
     * @param {String|TP.uri.URI} aURI The URI to process.
     * @param {Boolean} [textOnly=true] Return just text parameter strings
     *     rather than objects in the result object.
     * @returns {TP.core.Hash} The URI parts in key/value form.
     */

    var url,
        root,
        basePath,
        baseParams,
        fragPath,
        fragParams;

    url = TP.str(aURI);
    if (TP.isEmpty(url)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    root = TP.uriRoot(url);
    basePath = TP.uriBasePath(url);
    baseParams = TP.uriBaseParameters(url, textOnly);
    fragPath = TP.uriFragmentPath(url);
    fragParams = TP.uriFragmentParameters(url, textOnly);

    return TP.hc('root', root,
                    'basePath', basePath,
                    'baseParams', baseParams,
                    'fragmentPath', fragPath,
                    'fragmentParams', fragParams);
});

//  ----------------------------------------------------------------------------

TP.definePrimitive('uriExpandHome',
function(aURI) {

    /**
     * @method uriExpandHome
     * @summary Returns a URI representing the home page for any URI which is an
     *     implicit path to that page. Examples are "/" and the launch URL. NOTE
     *     that the resulting URL will include any path/parameter portions from
     *     the launch URL as needed.
     * @param {String|URI} aURI The uri to expand.
     * @returns {String} The expanded uri.
     */

    var url,
        urlParams,
        home,
        homeParts,
        params;

    //  For our expansion testing and history tracking we want a fully-expanded
    //  and normalized version of the URL here.
    url = TP.str(aURI);
    url = TP.uriExpandPath(url);
    url = decodeURIComponent(url);

    urlParams = TP.uriFragmentParameters(url, true);

    //  The pushState handlers in TIBET don't push homepage URLs directly, they
    //  always short to '/' or the launch URL. We need to actually setLocation
    //  with a real URI for the related home page tho so we convert here.
    if (url === '/' || TP.uriHead(url) === TP.uriHead(TP.sys.getLaunchURL())) {

        //  From a route perspective '/' means UICANVAS should get the home
        //  page. We don't want launch URLs here since this isn't about top.
        home = TP.uriExpandPath(TP.sys.getHomeURL());
        homeParts = TP.uriDecompose(home);

        //  Preserve any base parameters from launch if not overridden.
        if (TP.isEmpty(homeParts.at('baseParams'))) {
            homeParts.atPut('baseParams',
                            TP.uriBaseParameters(TP.sys.getLaunchURL(), true));
        }

        //  Preserve any fragment path (route) from the original URL provided.
        if (homeParts.at('fragmentPath') === '/') {
            homeParts.atPut('fragmentPath', TP.uriFragmentPath(url));
        }

        //  Have to add any launch parameters here as well or the rewrite will
        //  cause our reboot trigger on boot parameters to fire.
        if (TP.isEmpty(homeParts.at('fragmentParams'))) {

            params = TP.ifEmpty(urlParams,
                TP.uriFragmentParameters(TP.sys.getLaunchURL(), true));

            homeParts.atPut('fragmentParams', params);
        }

        url = TP.uriCompose(homeParts);
    }

    return url;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriExpandPath',
function(aPath) {

    /**
     * @method uriExpandPath
     * @summary Returns the expanded form of the TIBET '~' (tilde) path
     *     provided. This method is used extensively to help low-level URI
     *     primitives operate effectively with TIBET paths.
     * @param {String} aPath The TIBET path to expand.
     * @exception TP.sig.InvalidURI
     * @returns {String} A newly constructed path string.
     */

    var path,
        arr,
        variable,
        value,
        start;

    //  not a real path, but we can't assume what should come next
    if (TP.isEmpty(aPath)) {
        return '';
    }

    if (aPath === '/') {
        return TP.sys.getLaunchRoot();
    }

    path = TP.str(aPath);

    if (path.indexOf('/') === 0 || /^[a-zA-Z]{1}:/.test(path)) {
        //  Launch root doesn't include a trailing slash, so avoid possible
        //  recursion via uriJoinPaths and just concatenate.
        return TP.sys.getLaunchRoot() + path;
    }

    start = path.replace('tibet:///~', '~');

    //  if the path starts with '~' we adjust to the proper root
    if (start.indexOf('~') !== 0) {
        return start;
    }

    path = start;

    if (path === '~') {
        return TP.getAppHead();
    } else if (path === '~app') {
        return TP.getAppRoot();
    } else if (path === '~lib') {
        return TP.getLibRoot();
    } else if (path.indexOf('~/') === 0) {
        //  Note here how we also slice off the leading slash so that
        //  TP.uriJoinPaths() doesn't think 'path' is an absolute path.
        path = TP.uriJoinPaths(TP.getAppHead(), path.slice(2));
    } else if (path.indexOf('~app/') === 0) {
        //  Note here how we also slice off the leading slash so that
        //  TP.uriJoinPaths() doesn't think 'path' is an absolute path.
        path = TP.uriJoinPaths(TP.getAppRoot(), path.slice(5));
    } else if (path.indexOf('~lib/') === 0) {
        //  Note here how we also slice off the leading slash so that
        //  TP.uriJoinPaths() doesn't think 'path' is an absolute path.
        path = TP.uriJoinPaths(TP.getLibRoot(), path.slice(5));
    } else {
        arr = path.match(/~([^\/]*)\/(.*)/);
        if (TP.notValid(arr)) {
            arr = path.match(/~([^\/]*)/);
        }

        if (arr) {
            variable = arr.at(1);

            //  NOTE we resolve these variables from the config data
            if (TP.isString(value = TP.sys.cfg('path.' + variable))) {
                //  If we're replacing something of the form ~variable/stuff we
                //  don't want to get something of the form value//stuff back so
                //  we trim off any trailing '/' on the value.
                if (path !== '~' + variable) {
                    if (value.charAt(value.length - 1) === '/') {
                        value = value.slice(0, -1);
                    }
                }

                //  patch the original path for testing
                path = start.replace('~' + variable, value);
            } else {
                //  Might be a class name...
                value = TP.bySystemId(variable);
                if (TP.isValid(value)) {
                    value = TP.objectGetSourceCollectionPath(value);
                    if (TP.notEmpty(value)) {
                        //  patch the original path for testing
                        path = start.replace('~' + variable, value);
                    }
                }
            }
        }
    }

    //  variable expansions can sometimes create additional ~ paths
    if (path !== start && path.indexOf('~') === 0) {
        return TP.boot.$uriExpandPath(path);
    }

    return path;
});

//  ----------------------------------------------------------------------------

TP.definePrimitive('uriFragment',
function(aURI) {

    /**
     * @method uriFragment
     * @summary Returns the fragment portion, if any, from the URL.
     * @param {String|TP.uri.URI} aURI The URI to process.
     * @returns {String} The fragment portion or the empty string.
     */

    var url;

    url = TP.str(aURI);
    if (TP.isEmpty(url)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    if (/#/.test(url)) {
        return url.slice(url.indexOf('#') + 1);
    }

    return '';
});

//  ----------------------------------------------------------------------------

TP.definePrimitive('uriFragmentParameters',
function(aURI, textOnly) {

    /**
     * @method uriFragmentParameters
     * @summary Parses the given URL for any TIBET-specific argument block.
     *     The URL hash is checked for any & segment and that segment is
     *     split just as if it were a set of server parameters. For example,
     *     http://localhost/index.html#foo&boot.debug=true results in the
     *     argument object containing {'boot.debug':true};
     * @param {String|TP.uri.URI} aURI The URI to process.
     * @param {Boolean} [textOnly=true] Return just the text parameter string
     *     if any.
     * @returns {Object||TP.core.Hash} The fragment parameters.
     */

    var url,
        hash,
        params;

    url = TP.str(aURI);
    if (TP.isEmpty(url)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    //  Process any hash portion of the URL string.
    if (!/#/.test(url)) {
        return TP.notFalse(textOnly) ? '' : {};
    }
    hash = url.slice(url.indexOf('#') + 1);
    hash = decodeURIComponent(hash);

    if (hash.indexOf('?') === TP.NOT_FOUND) {

        return TP.notFalse(textOnly) ? '' : {};
    } else {

        params = hash.slice(hash.indexOf('?') + 1);

        if (TP.notFalse(textOnly)) {
            return params;
        }
    }

    if (params) {
        return TP.hc(TP.boot.$parseURIParameters(params));
    }

    return TP.notFalse(textOnly) ? '' : {};
});

//  ----------------------------------------------------------------------------

TP.definePrimitive('uriFragmentPath',
function(aURI) {

    /**
     * @method uriFragmentPath
     * @summary Returns the path portion of the URL fragment if any. Note that
     *     anchor values in the URI will not produce a path with a leading '/'
     *     to avoid confusing anchors with routes. An empty fragment however
     *     will produce a value of '/' implying a "home route".
     * @param {String|TP.uri.URI} aURI The URI to process.
     * @returns {String} The fragment path value.
     */

    var fragment,
        url;

    url = TP.str(aURI);
    if (TP.isEmpty(url)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    fragment = TP.uriFragment(url);
    if (TP.isEmpty(fragment)) {
        return '/';
    }

    //  Remove any trailing parameter content.
    if (/\?/.test(fragment)) {
        fragment = fragment.slice(0, fragment.indexOf('?'));
    }

    //  Always return home route signifier for any empty/explicit value.
    if (TP.isEmpty(fragment) || fragment === '/') {
        return '/';
    }

    //  Remove any trailing / from paths longer that a single segment.
    if (fragment.last() === '/') {
        fragment = fragment.slice(0, -1);
    }

    return fragment;
});

//  ----------------------------------------------------------------------------

TP.definePrimitive('uriGetTIBETType',
function(aURI) {

    /**
     * @method uriGetTIBETType
     * @summary Returns the TIBET type whose type definition is contained in the
     *     resource pointed to by the URL.
     * @param {String|TP.uri.URI} aURI The URI that might contain a TIBET type
     *     definition.
     * @returns {TP.meta.*|null} The TIBET type whose type definition is
     *     contained in the resource pointed to by the URL.
     */

    var url,
        name,
        typeName,
        type;

    url = TP.str(aURI);
    if (TP.isEmpty(url)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    name = TP.uriName(url);

    typeName = name.slice(0, name.lastIndexOf('.'));
    typeName = typeName.replace(/_/, ':');

    if (TP.isType(type = typeName.asType())) {
        return type;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriGetXPointerData',
function(aURI, aNode, shouldClone) {

    /**
     * @method uriGetXPointerData
     * @summary Returns the XML data defined by the XPointer relative to the
     *     node provided. The node is presumed to be the content node from the
     *     URI's document href.
     * @param {String} aURI A uri String defining an XPointer fragment.
     * @param {Node} aNode A node containing the overall document content for
     *     the URI provided.
     * @param {Boolean} shouldClone True will cause the nodes found to be cloned
     *     rather than returned as is. The default is true.
     * @exception TP.sig.InvalidURI
     * @exception TP.sig.InvalidNode
     * @returns {Node[]} An array containing zero or more Nodes.
     */

    var resultElements,
        uriParts,
        xpathExpr,
        clone,
        node,
        arr,
        pointer,
        pathStr,
        parts;

    if (!TP.isString(aURI)) {
        return TP.raise(this, 'TP.sig.InvalidURI');
    }

    if (TP.notValid(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    if (TP.isNode(aNode)) {
        node = aNode;
    } else if (TP.canInvoke(aNode, 'getNativeNode')) {
        node = aNode.getNativeNode();
    } else {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    clone = TP.ifInvalid(shouldClone, true);

    //  get the pointer portion by splitting on the required #
    uriParts = aURI.asString().split('#');
    switch (uriParts.getSize()) {
        case 1:
            //  no #? then we're not really looking for a part of a
            //  document, we're looking for the whole thing...
            if (clone) {
                resultElements = TP.ac(TP.nodeCloneNode(node, true));
            } else {
                resultElements = TP.ac(node);
            }

            arr = resultElements.collect(
                        function(item) {

                            if (TP.isDocument(item)) {
                                return item.documentElement;
                            }

                            return item;
                        });
            return arr;

        case 2:
            //  found, the pointer is in position 1
            pointer = uriParts.at(1);
            break;
        default:
            //  either 0 (?how?) or more than 2
            uriParts.shift();
            pointer = uriParts.join('#');

            break;
    }

    //  If it doesn't actually have the 'xpointer' or 'xpath1' String as part of
    //  the URI, then its considered to be a 'bare name'. This means that
    //  whatever follows the '#' should be considered the 'id' of an element
    //  within the content.
    if (TP.notValid(xpathExpr = pointer.match(TP.regex.XPOINTER))) {
        //  TODO:   add element() scheme support here

        //  special case is scheme://blah#document, which is how you can ask
        //  for the document element of the Document node
        if (pointer === 'document') {
            if (TP.isDocument(node)) {
                resultElements = node.documentElement;
            }
        } else {
            //  Grab the results of running an 'id' search within the
            //  contentElement. need the true here to force a complete
            //  search since the odds of a DTD for ID refs are low
            resultElements = TP.nodeGetElementById(node, pointer, true);
        }

        resultElements = TP.ac(resultElements);
    } else {
        //  Otherwise, its a real xpointer()/xpath1() with an XPath expression.
        //  Run it (once we get it out of the enclosing quotes since it will
        //  look like #xpointer("foo") or #xpath1("foo"))
        pathStr = xpathExpr.at(2);
        if (TP.notEmpty(pathStr)) {
            //  we can optimize ID lookups if we have a match with
            //  xpointer(id()) or xpath1(id()) as the pointer text
            if (TP.notEmpty(parts = pointer.match(TP.regex.ID_POINTER))) {
                pathStr = parts.at(1).unquoted();
                resultElements = TP.nodeGetElementById(node, pathStr, true);
                resultElements = TP.ac(resultElements);
            } else {
                pathStr = pathStr.unquoted();

                //  Otherwise, we replace 'id(...)' calls in the XPath with
                //  an 'match attributes named id' expression and try
                //  again...
                if (TP.regex.XPATH_HAS_ID.test(pathStr)) {
                    arr = pathStr.match(TP.regex.XPATH_HAS_ID);

                    pathStr = pathStr.replace(
                                arr.first(),
                                '*[@id="' + arr.last().unquoted() + '"]');
                }

                resultElements = TP.nodeEvaluateXPath(node,
                                                        pathStr,
                                                        TP.NODESET);
            }
        } else {
            return TP.ac();
        }
    }

    //  if we didn't find anything we can stop here
    if (TP.isEmpty(resultElements)) {
        return resultElements;
    }

    if (clone) {
        //  Make sure and return a clone of what got pulled out of the
        //  content. This avoids DOM pointer weirdness.
        arr = resultElements.collect(
            function(item) {

                return TP.nodeCloneNode(item, true);
            });

        return arr;
    } else {
        return resultElements;
    }
});

//  ----------------------------------------------------------------------------

TP.definePrimitive('uriHead',
function(aURI) {

    /**
     * @method uriHead
     * @summary Returns the "head" portion of the URL fragment, the portion
     *     prior to any fragment. The return value includes both the base path
     *     and base parameters, if any.
     * @param {String|TP.uri.URI} aURI The URI to process.
     * @returns {String} The URI base value.
     */

    var url;

    url = TP.str(aURI);

    if (TP.isEmpty(url)) {
        return;
    }

    if (/#/.test(url)) {
        url = url.slice(0, url.indexOf('#'));

        return url.last() === '/' ?
                url.slice(0, -1) :
                url;
    }

    return url;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriInLocalFormat',
function(aPath) {

    /**
     * @method uriInLocalFormat
     * @summary Returns the path used by the local operating system to access a
     *     particular path's resource. On Windows this will return a path of the
     *     form [drive]:\segment\segment while on *NIX platforms it will be a
     *     path of the form /segment/segment
     *
     *     NOTE that this method will unescape any escape() processing on the
     *     return value. Also NOTE that this method will _not_ quote paths with
     *     spaces since the majority of lower-level browser calls will fail on
     *     quoted input.
     * @param {String} aPath The path to repair.
     * @exception TP.sig.InvalidURI
     * @returns {String}
     */

    var path;

    if (!TP.isString(aPath)) {
        return TP.raise(this, 'TP.sig.InvalidURI');
    }

    //  On Windows we can be drive:\something or \\something. All others
    //  need a /something path for this test to work
    if (TP.sys.isWin() &&
            (TP.regex.WINDOWS_PATH.test(aPath) ||
                TP.regex.UNC_PATH.test(aPath)) ||
        TP.regex.ROOT_PATH.test(aPath)) {
        return window.unescape(aPath);
    }

    //  make sure we've got the fully-expanded path for what follows
    path = TP.uriExpandPath(aPath);

    //  if, after expansion, we're looking at a non-file URI just return it
    //  since there's not enough information to do anything else with it
    if (path.indexOf('file:') !== 0) {
        //  NOTE that we don't return the expanded path, we leave the
        //  incoming path in whatever form it came in, minus any escaping
        return window.unescape(aPath);
    }

    //  remove the file scheme prefix. we clearly won't need that
    path = window.unescape(TP.uriMinusFileScheme(path));

    //  if we're not on Windows we're done. should have a path of the form
    //  /blah, or ../blah, etc.
    if (!TP.sys.isWin()) {
        return path;
    }

    //  for Windows convert to reversed slashes
    path = path.replace(/\//g, '\\');

    //  should match our Windows test patterns now
    if (TP.regex.WINDOWS_PATH.test(path) ||
        TP.regex.UNC_PATH.test(path)) {
        return path;
    }

    //  didn't look right after conversion? return original path minus any
    //  file scheme and hope for the best
    return window.unescape(TP.uriMinusFileScheme(aPath));
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriInTIBETFormat',
function(aPath) {

    /**
     * @method uriInTIBETFormat
     * @summary Returns the path with typical TIBET prefixes for app_cfg,
     *     lib_cfg, app_root, and lib_root replaced with their TIBET aliases.
     *     This is typically used to shorten log output.
     * @param {String} aPath The URI path to process.
     * @returns {String} The supplied path with typical TIBET prefixes.
     */

    if (!TP.isString(aPath)) {
        return TP.raise(this, 'TP.sig.InvalidURI');
    }

    //  Just map over the TP.boot version
    return TP.boot.$uriInTIBETFormat(aPath);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriInWebFormat',
function(aPath, aRoot) {

    /**
     * @method uriInWebFormat
     * @summary Returns the path with proper adjustments made to represent a
     *     proper URI (forward slashes, scheme prefixing, etc). NOTE that the
     *     response is _not_ escape()'d so it will be in the form expected by
     *     the rest of TIBET's functions and in the form more readable/typical
     *     for an end user.
     * @param {String} aPath The path to repair.
     * @param {String} aRoot The root to use for relative path resolution.
     *     Default is TP.getAppRoot();.
     * @returns {String}
     */

    var path;

    if (TP.isEmpty(aPath)) {
        return aPath;
    }

    //  already has a scheme and it's not tibet:? consider it done
    if (TP.regex.HAS_SCHEME.test(aPath) &&
        !TP.regex.TIBET_SCHEME.test(aPath)) {
        return aPath;
    }

    //  local? definately need to convert
    if (TP.regex.WINDOWS_PATH.test(aPath) || TP.regex.UNC_PATH.test(aPath)) {
        path = aPath.replace(/\\\\/g, '/').replace(/\\/g, '/');
        return TP.uriPlusFileScheme(path.unquoted());
    }

    //  may be virtual, in which case we'll just expand and return
    path = TP.uriExpandPath(aPath);
    if (path !== aPath) {
        return path;
    }

    //  last option is a path that probably needs a root. we expand out here
    //  and then make sure we add on the necessary file scheme if a scheme
    //  doesn't come back from our root expansion
    return TP.uriPlusFileScheme(TP.uriWithRoot(aPath, aRoot));
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriIsAbsolute',
function(aPath) {

    /**
     * @method uriIsAbsolute
     * @summary Returns true if the path provided is an absolute path.
     * @param {String} aPath The path to test.
     * @returns {Boolean} True if the path is absolute rather than relative to
     *     some root.
     */

    var path;

    if (TP.isEmpty(aPath)) {
        return false;
    }

    //  expand any virtual paths so our test will function properly. if this
    //  doesn't expand a path into a leading scheme it's likely relative
    path = TP.uriExpandPath(aPath);

    //  tilde prefixes are absolute, as are scheme'd paths
    if (TP.regex.VIRTUAL_URI_PREFIX.test(path) ||
        TP.regex.HAS_SCHEME.test(path)) {
        return true;
    }

    if (TP.sys.isWin()) {
        //  on Windows we can also have either drive:\blah, or \\blah paths
        //  which are considered absolute
        return TP.regex.WINDOWS_PATH.test(path) || TP.regex.UNC_PATH.test(path);
    } else {
        //  non-Windows paths need a leading slash
        return path.first() === '/';
    }
});

//  ----------------------------------------------------------------------------

TP.definePrimitive('uriIsAppResource',
function(aPath) {

    /**
     * @method uriIsAppResource
     * @summary Returns true if the path provided appears to be an application
     *     resource (it's rooted below ~app).
     * @param {String} aPath The path to be tested.
     * @returns {Boolean} True if the path is an application resource path.
     */

    var path;

    if (TP.isEmpty(aPath)) {
        return false;
    }

    path = TP.uriExpandPath(aPath);

    return path.indexOf(TP.uriExpandPath('~app')) === 0;
});

//  ----------------------------------------------------------------------------

TP.definePrimitive('uriIsInlined',
function(aPath, aType) {

    /**
     * @method uriIsInlined
     * @summary Returns true if the path provided is an 'inlined' resource. This
     *     will be different depending on whether the supplied path points to a
     *     'lib' resource or an 'app' resource.
     * @param {String} aPath The path to be tested.
     * @param {TP.meta.lang.RootObject} [aType] An optional type that will allow
     *     this method to be smarter around determining whether something is
     *     truly a lib or app resource (i.e. if it loads 'alacarte', it will
     *     report as a lib resource, but it is really an app resource).
     * @returns {Boolean} True if the path points to an inlined resource.
     */

    var inlined,

        packageChainPaths;

    if (TP.isEmpty(aPath)) {
        return false;
    }

    //  If the system is running with inlined resources we create 'style'
    //  elements rather than 'link' elements for CSS files.
    if (TP.uriIsLibResource(aPath)) {

        //  If a real type was supplied, use a smarter mechanism to determine
        //  whether it is inlined or not.
        if (TP.isType(aType)) {

            //  If the type's package itself is 'alacarte' or in investigating
            //  it's 'package chain paths' it can be determined to be an
            //  'alacarte' resoure, then it is really an app resource and should
            //  refer to the 'boot.inlined' flag.
            packageChainPaths = TP.sys.getPackageChainPaths(aType.getName());
            if (TP.boot.$isAlacarteResource(aPath, packageChainPaths)) {
                inlined = TP.sys.cfg('boot.inlined');
            }
        }

        //  If the inlined local variable still doesn't have a value, then it
        //  wasn't an alacarte resource - use the lib-level logic, which is to
        //  determine whether we're running with the 'boot.teamtibet' flag on.
        if (TP.notValid(inlined)) {
            inlined = !TP.sys.cfg('boot.teamtibet');
        }
    } else if (TP.uriIsAppResource(aPath)) {
        inlined = TP.sys.cfg('boot.inlined');
    } else {
        inlined = false;
    }

    return inlined;
});

//  ----------------------------------------------------------------------------

TP.definePrimitive('uriIsLibResource',
function(aPath) {

    /**
     * @method uriIsLibResource
     * @summary Returns true if the path provided appears to be a TIBET library
     *     resource (it's rooted below ~lib).
     * @param {String} aPath The path to be tested.
     * @returns {Boolean} True if the path is a library resource path.
     */

    var path;

    if (TP.isEmpty(aPath)) {
        return false;
    }

    path = TP.uriExpandPath(aPath);

    return path.indexOf(TP.uriExpandPath('~lib')) === 0;
});

//  ----------------------------------------------------------------------------

TP.definePrimitive('uriIsVirtual',
function(aPath) {

    /**
     * @method uriIsVirtual
     * @summary Returns true if the path provided appears to be a virtual path.
     * @param {String} aPath The path to be tested.
     * @returns {Boolean} True if the path is virtual.
     */

    if (TP.isEmpty(aPath)) {
        return false;
    }

    return aPath.indexOf('~') === 0 ||
        aPath.indexOf('tibet:') === 0 ||
        aPath.indexOf('urn:') === 0;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriJoinFragments',
function(aPath, aFragment) {

    /**
     * @method uriJoinFragments
     * @summary Joins a URI and a pointer fragment.
     * @description Note that the fragment has precedence, meaning that if it
     *     appears to be a whole URI path the path isn't used and the fragment
     *     is returned unchanged. Also, if the fragment expression (extracted
     *     from the xpointer type) is an 'absolute one' (per the expression
     *     path type) it will be returned whole as the fragment expression.
     * @param {String} aPath The URI string used as the prefix.
     * @param {String} aFragment The pointer fragment. Note that this may
     *     contain an XPointer and, if the path contains one as well and they
     *     don't match, the path will be returned unchanged.
     * @exception TP.sig.InvalidURI
     * @returns {String} A properly joined URI/Query string.
     */

    var result,
        i,

        url,
        expr,

        pathFragment,
        pathScheme,
        pathExpr,

        parts,
        results,

        fragmentScheme,

        joinChar;

    //  deal with looping when more than two args
    if (arguments.length > 2) {
        result = arguments[0];
        for (i = 1; i < arguments.length; i++) {
            result = TP.uriJoinFragments(result, arguments[i]);
        }

        return result;
    }

    if (!TP.isString(aPath)) {
        return TP.raise(this, 'TP.sig.InvalidString');
    }

    if (TP.isEmpty(aFragment)) {
        return aPath;
    }

    //  If the fragment is '.' or '$_', that a self-reference. Just return the
    //  main path.
    if (TP.regex.ONLY_PERIOD.test(aFragment) ||
        TP.regex.ONLY_STDIN.test(aFragment)) {
        return aPath;
    }

    //  If the fragment is a whole URI string, we just return that (per the
    //  method description).
    if (TP.isURIString(aFragment)) {
        return aFragment;
    }

    url = '';
    expr = '';

    //  Capture any fragment data that the path itself is providing.
    pathFragment = '';
    if (TP.regex.URI_FRAGMENT.test(aPath)) {

        parts = aPath.split('#');
        url = parts.first();

        pathFragment = parts.last();

        //  See if the path fragment contains an XPointer. If so, grab it's
        //  scheme and expression.
        if (TP.notEmpty(results = TP.regex.ANY_POINTER.match(pathFragment))) {
            pathScheme = results.at(1);
            pathExpr = results.at(2);
        }
    } else {
        url = aPath;
    }

    //  We do not process barename XPointers any further.
    if (TP.notEmpty(pathFragment) &&
        TP.regex.BARENAME.test('#' + pathFragment)) {
        return aPath;
    }

    //  If the pointer has actual XPointer content (whether or not preceded by a
    //  '#'), extract it
    if (TP.notEmpty(results = TP.regex.ANY_POINTER.match(aFragment))) {
        fragmentScheme = results.at(1);
        expr = results.at(2);
    } else {
        expr = aFragment;
    }

    //  If no scheme could be computed from the fragment, but the path did have
    //  a scheme, then set the fragment's scheme to the path's scheme.
    if (TP.isEmpty(fragmentScheme) && TP.notEmpty(pathScheme)) {
        fragmentScheme = pathScheme;
    }

    //  If the fragment still doesn't have a scheme, try to guess it.
    if (TP.isEmpty(fragmentScheme)) {
        fragmentScheme = TP.getPointerScheme(aFragment);
    }

    //  If we now have both a path scheme and a fragment scheme but they're not
    //  the same, then just return the original path.
    if (TP.notEmpty(pathScheme) &&
        TP.notEmpty(fragmentScheme) &&
        pathScheme !== fragmentScheme) {
        return aPath;
    }

    //  If there was an existing path expression, join it together with the
    //  fragment's expression using the standard 'join character'.
    if (TP.notEmpty(pathExpr)) {
        switch (fragmentScheme) {
            case 'css':
                joinChar = ' ';
                break;

            case 'tibet':
            case 'jpath':

                //  If a JSONPath starts with a '$', then it's an absolute path.
                //  Don't use any of the supplied path.
                if (expr.charAt(0) === '$') {
                    return url + '#' + fragmentScheme + '(' + expr + ')';
                }

                if (expr.charAt(0) === '[') {
                    joinChar = '';
                } else {
                    joinChar = '.';
                }

                break;

            case 'xpath1':
            case 'xpointer':

                //  If an XPath starts with a '/', then it's an absolute path.
                //  Don't use any of the supplied path.
                if (expr.charAt(0) === '/') {
                    return url + '#' + fragmentScheme + '(' + expr + ')';
                }

                if (expr.charAt(0) === '[') {
                    joinChar = '';
                } else {
                    joinChar = '/';
                }

                break;

            default:
                joinChar = '';
        }

        //  If the leading character of the expression is already a valid join
        //  character for this expression type, then set the joinChar to the
        //  empty String.
        if (expr.charAt(0) === joinChar) {
            joinChar = '';
        }

        expr = pathExpr + joinChar + expr;
    }

    //  Return a fully-formed URL, including the computed fragment scheme and
    //  expression.
    result = url + '#' + fragmentScheme + '(' + expr + ')';

    return result;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriJoinPaths',
function(firstPath, secondPath) {

    /**
     * @method uriJoinPaths
     * @summary Returns the two path components joined appropriately. Note that
     *     the second path has precedence, meaning that if the second path
     *     appears to be an absolute path the first path isn't used.
     * @param {String} firstPath The 'root' path.
     * @param {String} secondPath The 'tail' path.
     * @returns {String} The two paths joined together in an appropriate
     *     fashion.
     */

    var i,
        val,
        first,
        second,
        path;

    //  deal with looping when more than two args
    if (arguments.length > 2) {
        path = arguments[0];
        for (i = 1; i < arguments.length; i++) {
            path = TP.uriJoinPaths(path, arguments[i]);
        }

        return path;
    }

    if (TP.isEmpty(firstPath)) {
        return secondPath;
    }

    if (TP.isEmpty(secondPath)) {
        return firstPath;
    }

    //  any other absolute path in the second position is valid
    if (TP.uriIsAbsolute(secondPath)) {
        return secondPath;
    }

    //  work around mozilla bug
    if (firstPath.indexOf('about:blank') === 0) {
        first = firstPath.slice('about:blank'.getSize());
    } else {
        first = firstPath;
    }

    //  if the first path starts with '~' we adjust to the proper root
    if (first.indexOf('~') === 0) {
        path = TP.uriExpandPath(first);

        if (path !== firstPath) {
            //  cause re-evaluation with the expanded variable
            //  value
            return TP.uriJoinPaths(path, secondPath);
        }
    }

    //  copy to a local so we can manipulate as needed
    second = secondPath;

    //  adjust for an OSX bug around "absolute paths"
    if (second.indexOf('/Volumes') === 0) {
        //  one case is where path is completely contained in first path
        if (first.indexOf(second) !== TP.NOT_FOUND) {
            return first;
        }

        if (second.indexOf(first) !== TP.NOT_FOUND) {
            return second;
        }

        if (first.indexOf(TP.uriPlusFileScheme(second))) {
            return first;
        }

        if (second.indexOf(TP.uriPlusFileScheme(first)) !== TP.NOT_FOUND) {
            return second;
        }

        if (TP.uriPlusFileScheme(first).indexOf(second) !== TP.NOT_FOUND) {
            return TP.uriPlusFileScheme(first);
        }

        if (TP.uriPlusFileScheme(second).indexOf(first) !== TP.NOT_FOUND) {
            return TP.uriPlusFileScheme(second);
        }

        //  second is still an absolute path so go with that since the first
        //  is usually a "prefix" which is probably incorrect for the
        //  typically more concrete second path
        return TP.uriPlusFileScheme(second);
    }

    //  deal with second path starting with './'
    if (second.indexOf('./') === 0) {
        //  note we leave on the slash, that will be dealt with later
        second = second.slice(1);
    }

    //  now for the '../' case...first we'll need to remove any trailing
    //  slash from the first path so we can back up accurately
    if (first.charAt(first.getSize() - 1) === '/') {
        //  strange IE question here...reading a basedir ending in /
        //  gives us //. check for it and adjust as needed here
        if (first.lastIndexOf('//') === first.getSize() - 2) {
            first = first.slice(0, first.getSize() - 2);
        } else {
            first = first.slice(0, first.getSize() - 1);
        }
    }

    //  while we're being told to 'back up' the path, do so
    while (second.indexOf('..') === 0) {
        if (second.charAt(2) === '/') {
            second = second.slice(3, second.getSize());
        } else {
            second = second.slice(2, second.getSize());
        }
        first = first.slice(0, first.lastIndexOf('/'));
    }

    //  join the resulting chunks while paying attention to separator(s).
    if (first.charAt(first.length - 1) === '/') {
        if (second.charAt(0) === '/') {
            val = first + second.slice(1);
        } else if (second.charAt(0) === '#') {
            val = first.slice(-1) + second;
        } else {
            val = first + second;
        }
    } else {
        //  First does not end in '/'...
        if (second.charAt(0) === '/') {
            val = first + second;
        } else if (second.charAt(0) === '#') {
            val = first + second;
        } else {
            val = first + '/' + second;
        }
    }

    return val;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriJoinQuery',
function(aPath, aQuery) {

    /**
     * @method uriJoinQuery
     * @summary Joins a URI and query fragment, ensuring the proper join
     *     character is used. The path is a String, while the query can be a
     *     string or hash of key/value pairs.
     * @param {String} aPath The URI string used as the prefix.
     * @param {String} aQuery The query fragment.
     * @exception TP.sig.InvalidURI
     * @returns {String} A properly joined URI/Query string.
     */

    var url,
        query,
        fragment,
        parts,
        delim;

    if (!TP.isString(aPath)) {
        return TP.raise(this, 'TP.sig.InvalidURI');
    }

    if (TP.isEmpty(aQuery)) {
        return aPath;
    }

    url = aPath;

    //  convert hashes to viable query string components
    query = TP.isString(aQuery) ? aQuery : aQuery.asQueryString();

    //  may need to remove any XPointer from tail before joining
    fragment = '';
    if (TP.regex.URI_FRAGMENT.test(url)) {
        parts = url.split('#');
        url = parts.first();
        fragment = parts.last();
    }

    //  if the URI already has a portion of a query we don't want another ?
    //  as the prefix to our new set of query parameters
    delim = /\?/.test(url) ? '&' : '?';

    if (TP.notEmpty(fragment)) {
        return url + delim + query + '#' + fragment;
    } else {
        return url + delim + query;
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriMinusFileScheme',
function(aPath) {

    /**
     * @method uriMinusFileScheme
     * @summary Returns the filename trimmed of any leading file://[/] chars.
     *     This is often necessary for proper use based on host platform.
     * @param {String} aPath The path to trim.
     * @exception TP.sig.InvalidURI
     * @returns {String} The path with any leading file:// portion trimmed off.
     */

    var path;

    if (!TP.isString(aPath)) {
        return TP.raise(this, 'TP.sig.InvalidURI');
    }

    if (aPath.toLowerCase().indexOf('file:') !== 0) {
        return aPath;
    }

    //  slice off the file:// number of chars, removing the base prefix
    path = aPath.slice('file://'.length);

    //  on Windows we may need to slice 1 more character if the path
    //  matches /drive: rather than a UNC path
    if (TP.sys.isWin() && /^\/\w:/.test(path)) {
        path = path.slice(1);
    }

    return path;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriNeedsPrivileges',
function(aPath) {

    /**
     * @method uriNeedsPrivileges
     * @summary Returns true if accessing the supplied path requires special
     *     browser security privileges to be accessed, based on where TIBET got
     *     launched from.
     * @param {String} aPath The path to test.
     * @exception TP.sig.InvalidURI
     * @returns {Boolean} True if the path requires special privileges to
     *     access.
     */

    if (!TP.isString(aPath)) {
        return TP.raise(this, 'TP.sig.InvalidURI');
    }

    //  If the path doesn't start with the launch root, then we can assume
    //  that it needs special security privileges.
    /* eslint-disable no-extra-parens */
    return (aPath.indexOf(TP.sys.getLaunchRoot()) !== 0);
    /* eslint-enable no-extra-parens */
});

//  ----------------------------------------------------------------------------

TP.definePrimitive('uriNormalize',
function(aURI) {

    /**
     * @method uriNormalize
     * @summary Processes a URL to produce a value we can rely on to have a
     *     consistent form. This is typically used on window.location values to
     *     remove trailing '/' from certain path forms et.
     * @param {String|TP.uri.URI} aURI The URI to process.
     * @returns {String} The normalized URI value.
     */

    var url;

    url = TP.str(aURI);
    if (TP.isEmpty(url)) {
        return;
    }

    if (TP.uriIsVirtual(url)) {
        url = TP.uriInTIBETFormat(TP.uriExpandPath(url));
    }

    return url.last() === '/' ? url.slice(0, -1) : url;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriPlusFileScheme',
function(aPath) {

    /**
     * @method uriPlusFileScheme
     * @summary Returns the filename padded with leading file://[/] characters
     *     appropriate for the current operating system platform.
     * @param {String} aPath The path to pad.
     * @exception TP.sig.InvalidURI
     * @returns {String}
     */

    var prefix,
        path;

    if (!TP.isString(aPath)) {
        return TP.raise(this, 'TP.sig.InvalidURI');
    }

    if (aPath.toLowerCase().indexOf('file:') === 0) {
        return aPath;
    }

    prefix = 'file://';

    if (TP.sys.isWin() && /^\w:/.test(aPath)) {
        prefix = prefix + '/';
    }

    path = prefix + aPath;

    //  one last check for UNC paths on windows is that we don't want to end
    //  up with four slashes...
    if (/file:\/\/\/\//.test(path)) {
        path = path.replace(/file:\/\//, 'file:');
    }

    return path;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriRelativeToPath',
function(firstPath, secondPath, filePath) {

    /**
     * @method uriRelativeToPath
     * @summary Returns a "relativized" version of the firstPath at it relates
     *     to the second path. In essence, what path would you have to append to
     *     the secondPath to acquire the resource defined by the first path.
     * @description This method is a core method for helping stored files remain
     *     "relocatable". When storing TIBET metadata or processed pages their
     *     internal references are automatically adjusted to relative paths
     *     using this routine. For example, given a path of ~lib_cfg/tibet.xml
     *     as the firstPath and a path of ~lib_dat as the secondPath we'd
     *     expect the return value to be ./cfg/tibet.xml. Note that since the
     *     path returned is relative to a directory it is occasionally necessary
     *     to assist TIBET with whether it should treat the last element of the
     *     second path as a file or not. For example, if our secondPath in the
     *     previous example were ~lib_cfg/tibet_kernel.xml we'd want the path to
     *     be returned as ./tibet.xml, not ../tibet.xml as it would be if the
     *     last element were a directory.
     * @param {String} firstPath The path to convert.
     * @param {String} secondPath The path to be relative to.
     * @param {Boolean} filePath True if the absolute path includes a file
     *     reference. This is important since the offset is relative to
     *     directories, not files. Defaults to true since the vast majority of
     *     URI references are to files.
     * @returns {String}
     */

    var file,
        first,
        second,
        prefix,
        path,
        count,
        ndx,
        i,
        partial;

    //  the "path we append" to the second path to get the first path when
    //  the first path doesn't exist is null
    if (TP.isEmpty(firstPath)) {
        return;
    }

    //  a "valid path" relative to some non-existent path is presumed to be
    //  the original path itself. we don't presume a "default root" here
    if (TP.isEmpty(secondPath)) {
        return firstPath;
    }

    //  are they the same path? then the relative path is '.'
    if (firstPath === secondPath) {
        return '.';
    }

    //  expand the paths to avoid issues with ~ prefixing and collapse out
    //  any relative '.' or '..' paths, so that the logic below works.
    first = TP.uriCollapsePath(TP.uriExpandPath(firstPath));
    second = TP.uriCollapsePath(TP.uriExpandPath(secondPath));

    //  get the first path normalized
    if (first.length > 1 && first.lastIndexOf('/') === first.length - 1) {
        //  if the first path ended in a '/' we can safely remove it since
        //  it's the same directory path with or without the trailing /
        first = first.slice(0, -1);
    }

    //  normalize the second path next

    if (TP.isTrue(filePath)) {
        //  forced to interpret second path as a file path, so if there's
        //  any / in the second path we use that as the point of trimming
        //  the last segment
        if ((ndx = second.lastIndexOf('/')) !== TP.NOT_FOUND) {

            /* eslint-disable no-extra-parens */
            if (second.lastIndexOf('/') === (second.length - 1)) {
                second = second.slice(0, -1);
                second = second.slice(0, second.lastIndexOf('/'));
            } else {
                second = second.slice(0, second.lastIndexOf('/'));
            }
            /* eslint-enable no-extra-parens */
        } else {
            //  entire second path is a file name, so our example is
            //  something like file:///thisdir relative to foo.xml. We can't
            //  know where foo.xml is, but we might presume that it's in the
            //  same location as the first path's file (if first has a file
            //  reference, or that it's in the same directory as the first
            //  when the first is a directory path
            if (TP.regex.FILE_PATH.test(firstPath)) {
                //  first path has a file location, and we're assuming we're
                //  in the same directory, so the path would be '.'
                return '.' + first.slice(first.lastIndexOf('/'));
            } else {
                //  assuming second path file is in first path directory
                //  we'll return '.'
                return '.';
            }
        }
    } else if (TP.isFalse(filePath)) {
        //  not able to alter second path too much, we're being forced to
        //  interpret it as a directory no matter what, but

        /* eslint-disable no-extra-parens */
        if (second.lastIndexOf('/') === (second.length - 1)) {
            second = second.slice(0, -1);
        }
        /* eslint-enable no-extra-parens */
    } else {
        //  try to determine if the second path is a file path or a
        //  directory path...the easiest check is does it end with a '/',
        //  after which we can check for an extension on the last portion

        /* eslint-disable no-extra-parens */
        if (second.lastIndexOf('/') === (second.length - 1)) {
            file = false;
            second = second.slice(0, -1);
        } else {
            //  if we can split the last element (having already split on
            //  '/') and find an extension then it's likely a file path
            if (TP.regex.FILE_PATH.test(second)) {
                file = true;
                second = second.slice(0, second.lastIndexOf('/'));
            } else {
                file = false;
            }
        }
        /* eslint-enable no-extra-parens */
    }

    //  after normalization we run our quick checks again

    //  the "path we append" to the second path to get the first path when
    //  the first path doesn't exist is null
    if (TP.isEmpty(first)) {
        return;
    }

    //  a "valid path" relative to some non-existent path is presumed to be
    //  the original path itself. we don't presume a "default root" here
    if (TP.isEmpty(second)) {
        return first;
    }

    //  are they the same path? then the relative path is '.'
    if (first === second) {
        return '.';
    }

    //  now for the other common cases, which hopefully helps us keep this
    //  running a little faster

    //  page processing often wants a path relative to the cache directory
    //  or similar structure, meaning the first path is a subset of the
    //  second path (~ vs. ~app_tmp) so check for that
    if (second.indexOf(first) !== TP.NOT_FOUND) {
        path = second.strip(first);
        if (path.indexOf('/') === 0) {
            path = path.slice(1);
        }

        path = path.split('/');
        for (i = 0; i < path.length; i++) {
            path[i] = '..';
        }

        return path.join('/');
    }

    //  a large (predominant) number of these calls are asking for a full
    //  path relative to a directory higher up the tree (as in an app file
    //  relative to either the lib root or app root). in these cases the
    //  second path is completely contained in the first path and we're
    //  simply trying to detemine how many segments to remove from the path
    //  before we tack on a leading './'. we can determine that condition by
    //  simply replacing the secondPath with a '.' and seeing if we end up
    //  with a './' path meaning the replacement was clean on a directory
    //  boundary
    if ((path = first.replace(second, '.')) !== first) {
        //  we know there was at least a match, but did it produce a valid
        //  relative path?
        if (path.indexOf('./') === 0) {
            return path;
        }
    }

    //  if the first path is relative we can shortcut the test
    if (first.indexOf('.') === 0) {
        //  we're often forced, when resolving two paths, to adapt a path
        //  relative to a file (think about href values being resolved
        //  against their window.location) so we need an extra .. prefix
        if (file) {
            //  if it's a "local" file we don't want to return .././foo so
            //  we remove the internal ./ portion and make it ../foo,
            //  otherwise it's ../something and we want ../../something to
            //  ensure we skip past the file element of the second path
            if (first.indexOf('./') === 0) {
                return '../' + first.slice(2);
            } else {
                return '../' + first;
            }
        }

        return first;
    }

    //  a second common case is when we're looking for a directory in
    //  the middle of a larger absolute path (as when trying to locate
    //  basedir or libroot references)
    if ((ndx = second.indexOf(first)) !== TP.NOT_FOUND) {
        //  looks like the first path is a point in the second path, so the
        //  question now is how many segments "up" in the second path is it

        //  get the 'tail' from the match down as our starting point and
        //  remove the matching portion. so if we had something like
        //  file://foo/bar/tibet/baz/tp_cfg.html and 'tibet' or '/tibet' as
        //  a relative portion we're now holding /baz/tp_cfg.html...
        partial = second.slice(ndx).strip(first);

        count = partial.split('/').length;
        prefix = '';
        for (i = 0; i < count; i++) {
            prefix = prefix + '../';
        }

        return prefix + first;
    }

    //  neither path is contained in the other, which means we're going to
    //  have to work a bit harder by looking for a common branch point in
    //  the middle of the two paths...

    count = 0;
    ndx = second.lastIndexOf('/');
    while (ndx !== TP.NOT_FOUND) {
        //  peel off the last segment
        second = second.slice(0, ndx);

        //  see if we can replace it as a subset of the first path now...
        if ((path = first.replace(second, '..')) !== first) {
            //  if we can then all we need to do is put the proper number of
            //  jumps (../) on the front so we've adjusted
            if (path.indexOf('../') === 0) {
                prefix = '';
                for (i = 0; i < count; i++) {
                    prefix = prefix + '../';
                }

                return prefix + path;
            }
        }

        //  count so we know to add when we find a match
        count++;

        ndx = second.lastIndexOf('/');
    }

    //  no common elements in the paths at all if we got here..., and the
    //  path wasn't relative so we have to assume absolute and just return
    return first;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriRemoveUniqueQuery',
function(aPath) {

    /**
     * @method uriRemoveUniqueQuery
     * @summary Removes any unique query that was added to the path by the
     *     'uriAddUniqueQuery' method. See that method for more information
     *     about why unique queries are used.
     * @param {String} aPath The path to remove a unique query string from.
     * @exception TP.sig.InvalidURI
     * @returns {String} The path with the unique query removed from it.
     */

    var path;

    if (!TP.isString(aPath)) {
        return TP.raise(this, 'TP.sig.InvalidURI');
    }

    if (aPath.contains('_tibet_nocache')) {

        //  If there is a '&', that means there were other parameters on the URL
        //  that we don't want to replace.
        if (aPath.contains('&')) {
            path = aPath.strip(/&?_tibet_nocache=(\d+)(\?|&)?/);
        } else {
            path = aPath.strip(/\?_tibet_nocache=(\d+)/);
        }
    } else {
        path = aPath;
    }

    return path;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriResolvePaths',
function(aRootPath, aRelativePath, filePath) {

    /**
     * @method uriResolvePaths
     * @summary Returns an absolute path to the second referenced resource when
     *     resolved relative to the leading path. This method is often called to
     *     resolve HREF or SRC paths within a document. NOTE that this method is
     *     similar in form to the methods which create relative paths, but that
     *     the first two arguments are reversed with the root path being first.
     * @param {String} aRootPath The absolute path to resolve relative to.
     * @param {String} aRelativePath The "relative" path to adjust into absolute
     *     form.
     * @param {Boolean} filePath True if the absolute path includes a file
     *     reference. This is important since the offset is relative to
     *     directories, not files.
     * @exception TP.sig.InvalidURI
     * @returns {String}
     */

    var first,
        second;

    first = aRootPath;

    if (filePath) {
        second = TP.uriRelativeToPath(second, first, filePath);
    } else {
        second = aRelativePath;
    }

    return TP.uriJoinPaths(first, second);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriResolveVirtualPath',
function(aPath, resourceOnly) {

    /**
     * @method uriResolveVirtualPath
     * @summary Returns a string with the URI path provided fully resolved to
     *     an absolute path of some form.
     * @param {String} aPath The TIBET URI string to resolve.
     * @param {Boolean} resourceOnly Strip off any prefixing canvas? Default is
     *     false.
     * @exception TP.sig.InvalidURI
     * @exception TP.sig.InvalidCanvas
     * @returns {String} The fully resolved path.
     */

    var url,
        parts,
        path,
        pointer,
        arr,
        variable,
        value,
        type,
        canvas;

    if (!TP.isString(aPath)) {
        return TP.raise(this, 'TP.sig.InvalidURI');
    }

    url = aPath;

    //  has to start with tibet: or ~ to be resolvable
    if (!TP.regex.TIBET_URL.test(aPath)) {
        return aPath;
    }

    pointer = '';

    //  for scheme-based paths we can split to get the parts
    if (url.indexOf('tibet:') === 0) {
        parts = url.match(TP.regex.TIBET_URL_SPLITTER);
        if (TP.isArray(parts)) {
            //  whole, jid, resource, canvas, uri, path, pointer
            path = parts.at(5);

            if (TP.isEmpty(path)) {
                //  curious, means we apparently only have a canvas ref
                return aPath;
            }

            pointer = TP.ifInvalid(parts.at(6), '');
        } else {
            //  TODO:   is this an error? started with tibet: but didn't
            //          match our URI pattern
            return aPath;
        }
    } else {
        //  path should start with ~ since we're in a TIBET URI
        path = url;
    }

    /* eslint-disable no-script-url */

    //  with the path portion extracted we can check for the most common
    //  cases now, which are those involving ~ references (otherwise why use
    //  a TIBET URI :))
    if (path === '~app') {
        return TP.getAppRoot();
    } else if (path === '~lib') {
        return TP.getLibRoot();
    } else if (path === '~') {
        return TP.getAppHead();
    } else if (path === '/') {
        return TP.sys.getLaunchRoot();
    } else if (path.indexOf('~app/') === 0) {
        arr = path.match(/~app\/(.*)/);
        path = TP.uriJoinPaths(TP.getAppRoot(), arr.last());
    } else if (path.indexOf('~lib/') === 0) {
        arr = path.match(/~lib\/(.*)/);
        path = TP.uriJoinPaths(TP.getLibRoot(), arr.last());
    } else if (path.indexOf('~/') === 0) {
        arr = path.match(/~\/(.*)/);
        path = TP.uriJoinPaths(TP.getAppHead(), arr.last());
    } else if (path.indexOf('~') === 0) {
        arr = path.match(/~([^\/]*)\/(.*)/);
        if (TP.notValid(arr)) {
            arr = path.match(/~([^\/]*)/);
            if (TP.notValid(arr)) {
                return path + pointer;
            }
        }

        variable = arr.at(1);

        if (TP.isString(value = TP.sys.cfg('path.' + variable))) {
            //  If we're replacing something of the form ~variable/stuff we
            //  don't want to get something of the form value//stuff back so
            //  we trim off any trailing '/' on the value.
            if (path !== '~' + variable) {
                if (value.charAt(value.length - 1) === '/') {
                    value = value.slice(0, -1);
                }
            }

            path = aPath.replace('~' + variable, value);
            if (path !== aPath) {
                //  cause re-evaluation with the expanded variable value
                return TP.uriResolveVirtualPath(path);
            }
        } else if (TP.isType(type = TP.sys.getTypeByName(variable))) {
            value = TP.objectGetSourceCollectionPath(type);

            //  If we're replacing something of the form ~variable/stuff we
            //  don't want to get something of the form value//stuff back so
            //  we trim off any trailing '/' on the value.
            if (path !== '~' + variable) {
                if (value.charAt(value.length - 1) === '/') {
                    value = value.slice(0, -1);
                }
            }

            path = aPath.replace('~' + variable, value);
            if (path !== aPath) {
                //  cause re-evaluation with the expanded variable value
                return TP.uriResolveVirtualPath(path);
            }
        }
    } else if (path.indexOf('javascript:') === 0) {
        //  if we split a tibet: uri we'll have a canvas ID
        if (TP.isArray(parts)) {
            canvas = TP.ifInvalid(parts.at(3), '');
        } else {
            canvas = '';
        }

        //  note we push the canvas spec into place before the remaining
        //  elements here if it isn't already in place to ensure the proper
        //  context is used - but only if it's not the codeframe spec
        if (path.indexOf('javascript:' + canvas) !== 0 &&
            canvas !== TP.gid(window).strip(/tibet:\/\//)) {
            path = path.replace('javascript:',
                                'javascript:' + canvas + '.');
        }
    }

    /* eslint-enable no-script-url */

    //  if we had tibet:/// with no canvas spec we allow that to be removed,
    //  but all other cases where a canvas is defined we must preserve

    if (TP.notTrue(resourceOnly) && url.indexOf('tibet:') === 0) {
        parts = url.match(TP.regex.TIBET_URL_SPLITTER);
        if (TP.isArray(parts) && TP.notEmpty(parts.at(3))) {
            return 'tibet:' + parts.at(1) + '/' + parts.at(2) + '/' +
                        parts.at(3) + '/' + path + pointer;
        }
    }

    //  http, https, file, etc can just return the path
    return path + pointer;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriResult',
function(text, type, report) {

    /**
     * @method uriResult
     * @summary Returns the proper result format given the result text and
     *     result type, typically from an XMLHttpRequest's responseText.
     * @param {String} text The response text to process.
     * @param {TP.DOM|TP.TEXT|null} type The result type desired. If no value is
     *     provided this method tries to return DOM if possible, otherwise TEXT.
     * @param {Boolean} report True if errors during document creation should be
     *     reported.
     * @returns {String|Document|Array<String,Node>} An XML document, response
     *     text, or an Array containing the text and DOM node in that order.
     */

    var doc,
        docText;

    if (TP.isEmpty(text)) {
        return null;
    }

    if (type === TP.TEXT) {
        return text;
    }

    try {
        //  Make sure to convert HTML entities to XML entities,
        //  especially for IE's XML parser
        docText = TP.htmlEntitiesToXMLEntities(text);
        doc = TP.documentFromString(docText, null, report);
    } catch (e) {
        if (TP.notFalse(report)) {
            TP.raise(this,
                    'TP.sig.DOMParseException',
                    TP.ec(e, TP.join('Unable to parse: ', text)));
        }

        //  "best" or null result type should default to the text.
        if (type !== TP.DOM) {
            return text;
        }

        return null;
    }

    //  watch out for "empty documents"
    if (TP.isDocument(doc) && doc.childNodes.length > 0) {
        return doc;
    }

    //  "best" or null result type should default to the text.
    if (type !== TP.DOM) {
        return text;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriResultType',
function(targetUrl, resultType) {

    /**
     * @method uriResultType
     * @summary Returns a reasonable result type, TP.TEXT or TP.DOM, based on
     *     examination of the targetUrl's extension. The extensions for XML are
     *     kept in TP.boot.$xmlMimes so if a match isn't happening check there.
     *     If a resultType is provided it is always returned as the result.
     * @param {String} targetUrl A url to define a result type for.
     * @param {TP.TEXT|TP.DOM|null} resultType A result type constant.
     * @exception TP.sig.InvalidURI
     * @returns {Object} TP.TEXT|TP.DOM|null.
     */

    if (!TP.isString(targetUrl)) {
        return TP.raise(this, 'TP.sig.InvalidURI');
    }

    return TP.boot.$uriResultType(targetUrl, resultType);
});

//  ----------------------------------------------------------------------------

TP.definePrimitive('uriRoot',
function(aURI) {

    /**
     * @method uriRoot
     * @summary Returns the root of the URL, essentially the scheme and
     *     scheme-specific lead-in content. This routine essentially gives you
     *     back the http://, https://, or file:// portion which does not include
     *     any of the path.
     * @param {String|TP.uri.URI} aURI The URI to process.
     * @returns {String} The root of the URI.
     */

    var url,
        path,
        str,
        parts;

    url = TP.str(aURI);
    if (TP.isEmpty(url)) {
        return TP.raise(this, 'TP.sig.InvalidParameter');
    }

    path = TP.uriHead(url);
    if (TP.isEmpty(path)) {
        return;
    }

    //  If there's no :// portion this won't provide interesting results.
    if (!/:\/\//.test(path)) {
        return;
    }

    //  On HTTP uris you need the host:port portion as a root. To find that
    //  we essentially scan for the 3rd '/' since that sets off the root
    //  from the remaining portions of the URL. On windows if you don't
    //  include the drive spec in the root the files won't be found. This is
    //  consistent with IE behavior.
    parts = path.split('://');

    if (/\//.test(parts.at(1))) {
        //  If there's a path portion split that off.
        str = parts.at(0) +
                '://' +
                parts.at(1).slice(0, parts.at(1).indexOf('/'));
    } else {
        str = path;
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriSplitFragment',
function(aFragment, aScheme) {

    /**
     * @method uriSplitFragment
     * @summary Splits the supplied fragment into parts, according to the
     *     XPointer scheme of the fragment, if present, or a supplied XPointer
     *     scheme. See the TP.getAccessPathParts() method for more information
     *     on what may be returned from this method.
     * @param {String} aFragment The pointer fragment. Note that this may
     *     contain an XPointer and, if the path contains one as well and they
     *     don't match, the path will be returned unchanged.
     * @param {String} [aScheme] An optional XPointer scheme to use when it
     *     cannot be determined from the supplied fragment.
     * @returns {String[]} The fragment split into its constituent parts.
     */

    var pathFragment,

        fragmentScheme,
        fragmentExpr,

        results;

    if (TP.isEmpty(aFragment)) {
        return TP.ac(aFragment);
    }

    //  If the fragment is '.' or '$_', that a self-reference. Just return it.
    if (TP.regex.ONLY_PERIOD.test(aFragment) ||
        TP.regex.ONLY_STDIN.test(aFragment)) {
        return TP.ac(aFragment);
    }

    pathFragment = aFragment;

    //  See if the path fragment contains an XPointer. If so, grab it's
    //  scheme and expression.
    if (TP.notEmpty(results = TP.regex.ANY_POINTER.match(pathFragment))) {
        fragmentScheme = results.at(1);
        fragmentExpr = results.at(2);
    } else {
        //  If we were supplied a scheme, try to use it with the path
        if (TP.notEmpty(aScheme)) {
            if (TP.notEmpty(results = TP.regex.ANY_POINTER.match(
                                        aScheme + '(' + pathFragment + ')'))) {
                fragmentScheme = results.at(1);
                fragmentExpr = results.at(2);
            }
        }
    }

    //  Couldn't compute result
    if (TP.isEmpty(results)) {
        //  We do not process barename XPointers any further - just return the
        //  barename.
        if (TP.regex.BARENAME.test('#' + pathFragment)) {
            return TP.ac(pathFragment);
        }
    }

    //  No fragment expression? There is no fragment.
    if (TP.isEmpty(fragmentExpr)) {
        return null;
    }

    //  Couldn't slice out a scheme? Try the supplied one.
    if (TP.isEmpty(fragmentScheme)) {
        fragmentScheme = aScheme;
    }

    //  Probably a barename
    if (TP.isEmpty(fragmentScheme)) {
        if (TP.regex.BARENAME.test('#' + fragmentExpr)) {
            return TP.ac(fragmentExpr);
        }
    }

    //  Go ahead and grab the path parts.
    if (TP.notEmpty(fragmentExpr)) {
        return TP.getAccessPathParts(fragmentExpr, fragmentScheme);
    }

    return null;
});

//  ------------------------------------------------------------------------
//  FILE NAME
//  ------------------------------------------------------------------------

/*
Utilities to extract file name information from file paths.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('uriExtension',
function(aPath, aSeparator) {

    /**
     * @method uriExtension
     * @summary Returns the file extension for the file path provided.
     * @param {String} aPath The path to the file.
     * @param {String} aSeparator A single character. Default is '.'.
     * @exception TP.sig.InvalidURI
     * @returns {String}
     */

    var name,
        ndx,
        sep;

    if (!TP.isString(aPath)) {
        return TP.raise(this, 'TP.sig.InvalidURI');
    }

    name = TP.uriName(aPath);

    //  we're looking for a separator here, but only if it's not
    //  the first character in the name. we don't want to return .vimrc as a
    //  file extension for our .vimrc file after all ;)
    sep = TP.ifInvalid(aSeparator, '.');
    ndx = name.lastIndexOf(sep);

    if (ndx === TP.NOT_FOUND || ndx === 0) {
        return '';
    } else {
        return name.slice(ndx + 1);
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriName',
function(aPath) {

    /**
     * @method uriName
     * @summary Returns the file name, minus any path information.
     * @param {String} aPath The path to the file.
     * @exception TP.sig.InvalidURI
     * @returns {String}
     */

    var slash,
        index;

    if (!TP.isString(aPath)) {
        return TP.raise(this, 'TP.sig.InvalidURI');
    }

    //  paths containing backslashes, such as paths on Windows, will use
    //  backslash as their test slash
    if (/\\/.test(aPath)) {
        slash = '\\';
    } else {
        slash = '/';
    }

    index = aPath.lastIndexOf(slash);
    if (index !== TP.NOT_FOUND) {
        return aPath.slice(index + 1);
    }

    return aPath;
});

//  ------------------------------------------------------------------------
//  FILE ROOTS
//  ------------------------------------------------------------------------

/*
To support dynamic loading of TIBET components it's often necessary to rely
on a 'root path' from which to construct full path names to components. The
functions here support operations focused on either the overall library or
the current application root paths.
*/

//  ------------------------------------------------------------------------

TP.defineMethod('getAppHead',
function() {

    /**
     * @method getAppHead
     * @summary Returns the path to the head portion of index.html or whichever
     * file trigged TIBET to launch.
     * @returns {String}
     */

    return TP.boot.$getAppHead();
});

//  ------------------------------------------------------------------------

TP.defineMethod('getAppRoot',
function() {

    /**
     * @method getAppRoot
     * @summary Returns the path to the application. This is the directory just
     *     above the boot directory tree in the bootfile parameter value. That
     *     value is set by the boot system on startup.
     * @returns {String}
     */

    return TP.boot.$getAppRoot();
});

//  ------------------------------------------------------------------------

TP.defineMethod('getLibRoot',
function() {

    /**
     * @method getLibRoot
     * @summary Returns the root path from which TIBET can be found (i.e. where
     *     'tibet/..' was loaded from). This information can be used to allow
     *     developers to use relative paths in their application constructed
     *     from the root path. Note that the path returned always includes a
     *     trailing '/'.
     * @returns {String}
     */

    return TP.boot.$getLibRoot();
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriWithRoot',
function(targetUrl, aRoot) {

    /**
     * @method uriWithRoot
     * @summary Returns the filename provided with any additional root
     *     information which is necessary to create a full path name.
     * @param {String} targetUrl A url to expand as needed.
     * @param {String} aRoot Optional root (libroot or approot usually) to root
     *     from.
     * @exception TP.sig.InvalidURI
     * @returns {String} The url, after ensuring a root exists.
     */

    var root,
        url;

    if (!TP.isString(targetUrl)) {
        return TP.raise(this, 'TP.sig.InvalidURI');
    }

    if (TP.uriIsAbsolute(targetUrl)) {
        url = TP.uriResolvePaths(targetUrl);
    } else {
        root = aRoot;
        if (TP.notValid(root)) {
            root = TP.sys.getLaunchRoot();
        }
        url = TP.uriResolvePaths(root, targetUrl);
    }

    return TP.uriExpandPath(url);
});

//  ------------------------------------------------------------------------

TP.defineMethod('fileWithRoot', TP.uriWithRoot.copy());

//  ------------------------------------------------------------------------
//  TEMP FILES
//  ------------------------------------------------------------------------

TP.definePrimitive('uriTempFileName',
function(targetUrl, filePrefix, fileSuffix) {

    /**
     * @method uriTempFileName
     * @summary Returns a generated file name which can be used in building a
     *     temporary file. The targetUrl is used as the root directory for the
     *     temp file while the prefix and suffix will be used to create more
     *     "regular" names that are groupable.
     * @param {String} targetUrl A directory name in which to locate the file.
     *     Default is path.app_tmp.
     * @param {String} filePrefix An optional prefix for the file which allows
     *     you to group like-named temp files in listings etc.
     * @param {String} fileSuffix An optional suffix for the file. Default is
     *     'tmp'.
     * @returns {String} A new file name with the directory and a new temp file
     *     name.
     */

    var root,
        prefix,
        suffix,
        origPrefix,
        name;

    //  we'll use web format here to help the join work consistently. NOTE
    //  that this call will also expand virtual URI syntax for us
    root = TP.uriInWebFormat(TP.ifEmpty(targetUrl, TP.sys.cfg('path.app_tmp')));

    prefix = TP.ifInvalid(filePrefix, '');
    suffix = TP.ifInvalid(fileSuffix, 'tmp');

    //  trick here is that we don't want $'s in file names, so we ensure
    //  we're controlling the prefix from the OID generation here
    try {
        origPrefix = TP.OID_PREFIX;
        TP.OID_PREFIX = '_';

        name = TP.uriJoinPaths(root, TP.join(TP.genID(prefix), '.', suffix));
    } catch (e) {
        void 0;
    } finally {
        TP.OID_PREFIX = origPrefix;
    }

    return name;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================

TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETURIPrimitivesBase.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 */

//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETURIPrimitivesPlatform.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
Platform-specific functionality related to file access operations.
*/

/**
 * @File access primitives containing platform-specific coding.
 *
 *     Note that many of the Mozilla-based methods here have, over time, been
 *     converted to leverage HTTP requests to access either file or directory
 *     content rather than using the XPCOM calls. This was done to avoid
 *     permissionrequests that arise when trying to access file system data
 *     _even when webooted from that directory_.
 *
 *     IE doesn't do that, apparently it's ok with us asking about other files
 *     inthe directory we booted from.
 *
 *     Webkit-based browsers don't, in general, allow file-system access.
 */

/* global Components:false,
          netscape:false
*/

/* eslint-disable new-cap */

//  ------------------------------------------------------------------------
//  UTILITY METHODS
//  ------------------------------------------------------------------------

TP.definePrimitive('$fileIsDirectory',
TP.hc(
    TP.DEFAULT,
    function(targetUrl, aRequest) {

        //  NB: Other browsers don't need this call - just return.
        return;
    }
));

//  ------------------------------------------------------------------------
//  FILE DELETION
//  ------------------------------------------------------------------------

TP.definePrimitive('$fileDelete',
TP.hc(
    'test',
    TP.sys.getBrowser,
    'firefox',
    function(targetUrl, aRequest) {

        /**
         * @method $fileDelete
         * @summary Removes the targetUrl from the local file system, provided
         *     you have proper permissions. This method is rarely called
         *     directly, but it is used indirectly by the TP.$fileExecute() call
         *     to clean up temporary files.
         * @param {String} targetUrl The file URI to remove.
         * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
         *     call parameters.
         * @exception TP.sig.InvalidURI
         * @exception TP.sig.InvalidOperation
         * @exception TP.sig.URIException
         * @returns {Boolean} True if the delete appears successful.
         */

        var path,
            msg,
            retVal,
            request;

        if (!TP.isString(targetUrl)) {
            return TP.raise(this, 'TP.sig.InvalidURI');
        }

        //  expand to support virtual uri input
        path = TP.uriExpandPath(targetUrl);

        //  make sure that any fragments ('#' followed by word characters)
        //  is trimmed off
        if (/#/.test(path)) {
            path = path.slice(0, path.indexOf('#'));
        }

        request = TP.request(aRequest);

        if (TP.regex.HTTP_SCHEME.test(path.toLowerCase())) {
            msg = TP.sc('Local file deletion not supported for HTTP URI ',
                        path);

            TP.raise(this, 'TP.sig.InvalidOperation', msg);
            request.fail(msg);

            return false;
        }

        //  We need to request privileges from Gecko to perform this
        //  operation. We don't bother trying this operation without
        //  privileges because we still need them, even if we were launched
        //  from the 'same domain' (i.e. the file system).

        retVal = false;

        TP.executePrivileged(
            TP.HOST_FILE_DELETE,
                TP.sc('This TIBET-based application would like to delete file: ', path),
                TP.sc('This TIBET-based application cannot delete file: ', path),
            false,      //  don't even attempt this without privileges
            function() {

                var fname,
                    FP,
                    file,
                    message;

                //  following operation uses local name, not web format
                fname = TP.uriInLocalFormat(path);

                try {
                    FP = new Components.Constructor(
                                '@mozilla.org/file/local;1',
                                'nsILocalFile',
                                'initWithPath');

                    file = new FP(fname);

                    //  pass false to avoid recursive delete
                    file.remove(false);
                } catch (e) {
                    message = TP.sc('Unable to delete ', fname);
                    TP.raise(this, 'TP.sig.URIException', TP.ec(e, message));

                    retVal = false;
                    request.fail(message);

                    return;
                }

                retVal = true;
                request.complete(retVal);

                return;
            });

        return retVal;
    },
    'safari',
    function(targetUrl, aRequest) {

        /**
         * @method $fileDelete
         * @summary Removes the targetUrl from the local file system, provided
         *     you have proper permissions. This method is rarely called
         *     directly, but it is used indirectly by the TP.$fileExecute() call
         *     to clean up temporary files.
         * @param {String} targetUrl The file URI to remove.
         * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
         *     call parameters.
         * @exception TP.sig.InvalidOperation
         * @exception TP.sig.URIException
         * @returns {Boolean} True if the delete appears successful.
         */

        var request;

        request = TP.request(aRequest);

        TP.raise(this, 'TP.sig.UnsupportedOperation');
        request.fail('Unsupported operation.');

        return false;
    },
    'chrome',
    function(targetUrl, aRequest) {

        /**
         * @method $fileDelete
         * @summary Removes the targetUrl from the local file system, provided
         *     you have proper permissions. This method is rarely called
         *     directly, but it is used indirectly by the TP.$fileExecute() call
         *     to clean up temporary files.
         * @param {String} targetUrl The file URI to remove.
         * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
         *     call parameters.
         * @exception TP.sig.InvalidURI
         * @exception TP.sig.InvalidOperation
         * @exception TP.sig.URIException
         * @returns {Boolean} True if the delete appears successful.
         */

        var request,

            path,
            fname,

            result,

            msg;

        if (!TP.isString(targetUrl)) {
            return TP.raise(this, 'TP.sig.InvalidURI');
        }

        request = TP.request(aRequest);

        //  expand to support virtual uri input
        path = TP.uriExpandPath(targetUrl);

        //  make sure that any fragments ('#' followed by word characters)
        //  is trimmed off
        if (/#/.test(path)) {
            path = path.slice(0, path.indexOf('#'));
        }

        if (TP.sys.cfg('boot.context') === 'electron' &&
                                                    !TP.sys.inExtension()) {
            //  following operation uses local name, not web format
            fname = TP.uriInLocalFormat(path);

            //  Call the external Electron utilities to delete the file
            result = TP.extern.electron_lib_utils.fileDelete(fname);

            if (result.ok === false) {
                TP.raise(this, 'TP.sig.IOFailed');

                msg = TP.sc('File could not be deleted: ', path,
                                '. Reason: ' + result.msg);
                request.fail(msg);

                return false;
            } else {
                request.complete(true);

                return true;
            }

        } else {
            TP.raise(this, 'TP.sig.UnsupportedOperation');
            request.fail('Unsupported operation.');
        }

        return false;
    }
));

//  ------------------------------------------------------------------------
//  FILE EXISTENCE
//  ------------------------------------------------------------------------

/*
Any time we are provided with a file name we check for its existence using
an appropriate mechanism.

Both Mozilla and IE provide utilities for this purpose at the file system
level. Likewise, both provide an HTTP interface which can be used to test
for file existence. This helps avoid uncaught 404's etc.

Webkit provides limited facilities for its browsers.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('$fileExists',
TP.hc(
    'test',
    TP.sys.getBrowser,
    'firefox',
    function(targetUrl, aRequest) {

        /**
         * @method $fileExists
         * @summary Returns true if targetUrl exists in the file system.
         * @param {String} targetUrl URL of the target file.
         * @param {TP.sig.Request|TP.core.Hash} aRequest An optional object
         *     with call parameters.
         * @exception TP.sig.InvalidURI
         * @returns {Boolean} True if the file exists.
         */

        var path,
            httpObj,
            request;

        if (!TP.isString(targetUrl)) {
            return TP.raise(this, 'TP.sig.InvalidURI');
        }

        //  expand to support virtual uri input
        path = TP.uriExpandPath(targetUrl);

        //  make sure that any fragments ('#' followed by word characters)
        //  is trimmed off
        if (/#/.test(path)) {
            path = path.slice(0, path.indexOf('#'));
        }

        request = TP.request(aRequest);

        try {
            httpObj = TP.httpConstruct(path);
            if (TP.canInvoke(request, 'atPut')) {
                request.atPut('commObj', httpObj);
            }

            httpObj.open(TP.HTTP_GET, path, false);
            httpObj.send(null);
        } catch (e) {
            request.fail(e);

            return false;
        }

        //  NOTE the true here as our return value/completion value.
        request.complete(true);

        return true;
    },
    'safari',
    function(targetUrl, aRequest) {

        /**
         * @method $fileExists
         * @summary Returns true if targetUrl exists in the file system.
         * @param {String} targetUrl URL of the target file.
         * @param {TP.sig.Request|TP.core.Hash} aRequest An optional object
         *     with call parameters.
         * @exception TP.sig.InvalidURI
         * @returns {Boolean} True if the file exists.
         */

        var path,
            request,
            httpObj;

        if (!TP.isString(targetUrl)) {
            return TP.raise(this, 'TP.sig.InvalidURI');
        }

        //  expand to support virtual uri input
        path = TP.uriExpandPath(targetUrl);

        //  make sure that any fragments ('#' followed by word characters)
        //  is trimmed off
        if (/#/.test(path)) {
            path = path.slice(0, path.indexOf('#'));
        }

        request = TP.request(aRequest);

        try {
            httpObj = TP.httpConstruct(path);
            if (TP.canInvoke(request, 'atPut')) {
                request.atPut('commObj', httpObj);
            }

            httpObj.open(TP.HTTP_GET, path, false);
            httpObj.send(null);
        } catch (e) {
            //  It threw an exception, which means that it definitely didn't
            //  find it so we always return false if we get here.
            request.fail(e);

            return false;
        }

        //  Webkit usually won't throw an exception if it can't find a URI,
        //  but will return a variety of status codes, depending on the
        //  exact browser (i.e. Safari or Chrome).

        //  Safari 4.X - all platforms
        if (httpObj.status === 404) {
            request.complete(false);

            return false;
        }

        //  Safari 4.X - Windows
        if (TP.sys.isWin() && httpObj.status === -1100) {
            request.complete(false);

            return false;
        }

        //  Safari 3.1 - Mac
        if (TP.sys.isMac() &&
            (httpObj.status === -1100 || httpObj.status === 400)) {
            request.complete(false);

            return false;
        }

        //  Safari 3.1 - Windows
        if (TP.sys.isWin() && httpObj.status === 1789378560) {
            request.complete(false);

            return false;
        }

        request.complete(true);

        return true;
    },
    'chrome',
    function(targetUrl, aRequest) {

        /**
         * @method $fileExists
         * @summary Returns true if targetUrl exists in the file system.
         * @param {String} targetUrl URL of the target file.
         * @param {TP.sig.Request|TP.core.Hash} aRequest An optional object
         *     with call parameters.
         * @exception TP.sig.InvalidURI
         * @returns {Boolean} True if the file exists.
         */

        var path,

            request,

            fname,
            result,

            msg,

            httpObj;

        if (!TP.isString(targetUrl)) {
            return TP.raise(this, 'TP.sig.InvalidURI');
        }

        //  expand to support virtual uri input
        path = TP.uriExpandPath(targetUrl);

        //  make sure that any fragments ('#' followed by word characters)
        //  is trimmed off
        if (/#/.test(path)) {
            path = path.slice(0, path.indexOf('#'));
        }

        request = TP.request(aRequest);

        if (TP.sys.cfg('boot.context') === 'electron' &&
                                                    !TP.sys.inExtension()) {
            //  following operation uses local name, not web format
            fname = TP.uriInLocalFormat(path);

            //  Call the external Electron utilities to test the file for
            //  existence.
            result = TP.extern.electron_lib_utils.fileExists(fname);

            if (result.ok === false) {
                TP.raise(this, 'TP.sig.IOFailed');

                msg = TP.sc('File could not be tested for existence: ', path,
                            '. Reason: ' + result.msg);
                request.fail(msg);

                return false;
            } else {
                //  The file check completed successfully - complete the request
                //  with the value of the 'exists' field of the result.
                request.complete(result.exists);

                //  And return that value.
                return result.exists;
            }

        } else {

            try {
                httpObj = TP.httpConstruct(path);
                if (TP.canInvoke(request, 'atPut')) {
                    request.atPut('commObj', httpObj);
                }

                httpObj.open(TP.HTTP_GET, path, false);
                httpObj.send(null);
            } catch (e) {
                //  It threw an exception, which means that it definitely didn't
                //  find it so we always return false if we get here.
                request.fail(e);

                return false;
            }

            //  Webkit usually won't throw an exception if it can't find a URI,
            //  but will return a variety of status codes, depending on the
            //  exact browser (i.e. Safari or Chrome).

            //  Chrome workaround -- sigh.
            if (httpObj.status === 0 && httpObj.responseText === '') {

                //  The file didn't exist - complete the request with a value of
                //  false.
                request.complete(false);

                //  And return false.
                return false;
            }

            //  The file did exist - complete the request with a value of true.
            request.complete(true);

            //  And return true.
            return true;
        }
    }
));

//  ------------------------------------------------------------------------
//  FILE LOAD
//  ------------------------------------------------------------------------

/*
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('$fileLoad',
TP.hc(
    'test',
    TP.sys.getBrowser,
    'firefox',
    function(targetUrl, aRequest) {

        /**
         * @method $fileLoad
         * @summary Loads the content of targetUrl, returning data as text.
         * @param {String} targetUrl URL of the target file.
         * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
         *     call parameters.
         * @exception TP.sig.InvalidURI
         * @exception TP.sig.PrivilegeViolation
         * @exception TP.sig.IOException
         * @returns {String}
         */

        var request,
            path,
            text,
            httpObj,
            msg,

            FP,
            IOS,
            IS,

            file,
            fname,

            channel,
            stream;

        if (!TP.isString(targetUrl)) {
            return TP.raise(this, 'TP.sig.InvalidURI');
        }

        //  expand to support virtual uri input
        path = TP.uriExpandPath(targetUrl);

        //  make sure that any fragments ('#' followed by word characters)
        //  is trimmed off
        if (/#/.test(path)) {
            path = path.slice(0, path.indexOf('#'));
        }

        request = TP.request(aRequest);

        //  NOTE this flag is set during boot if the system detects that the
        //  xpcom interface must be used for local file access
        if (TP.sys.cfg('boot.moz_xpcom')) {
            //  file system access in Mozilla requires UniversalXPConnect
            try {
                TP.ifInfo() && TP.sys.cfg('log.privilege_requests') ?
                    TP.info('Privilege request at TP.$fileLoad') : 0;

                netscape.security.PrivilegeManager.enablePrivilege(
                                                    'UniversalXPConnect');
            } catch (e) {
                msg = TP.sc('PrivilegeError. url: ', path);
                TP.raise(this, 'TP.sig.PrivilegeViolation',
                            TP.ec(e, msg));

                request.fail(msg);

                return;
            }

            try {
                //  mozilla-specific components, see Moz's FileUtils.js etc.
                FP = new Components.Constructor(
                            '@mozilla.org/file/local;1',
                            'nsILocalFile', 'initWithPath');

                IOS = Components.
                        classes['@mozilla.org/network/io-service;1'].getService(
                            Components.interfaces.nsIIOService);

                IS = new Components.Constructor(
                            '@mozilla.org/scriptableinputstream;1',
                            'nsIScriptableInputStream');
            } catch (e) {
                msg = TP.sc('FileComponentError. url: ', path);
                TP.raise(this, 'TP.sig.IOException',
                            TP.ec(e, msg));

                request.fail(msg);

                return;
            }

            //  adjust file name for platform and access path
            fname = TP.uriMinusFileScheme(TP.uriInLocalFormat(path));

            //  make sure that any spaces or other escaped characters in the
            //  file name get unescaped properly.
            fname = window.unescape(fname);

            //  now for the fun part, files and channels and streams, oh my!
            try {
                file = new FP(fname);
                if (file.exists()) {
                    channel = IOS.newChannelFromURI(IOS.newFileURI(file));
                    stream = new IS();

                    stream.init(channel.open());
                    text = stream.read(file.fileSize);
                    stream.close();
                }
            } catch (e) {
                msg = TP.sc('AccessViolation. url: ', path);
                TP.raise(this, 'TP.sig.PrivilegeViolation',
                            TP.ec(e, msg));

                request.fail(msg);

                return;
            }
        } else {
            try {
                httpObj = TP.httpConstruct(path);
                if (TP.canInvoke(request, 'atPut')) {
                    request.atPut('commObj', httpObj);
                }

                httpObj.open(TP.HTTP_GET, path, false);
                httpObj.send(null);

                text = httpObj.responseText;
            } catch (e) {
                msg = TP.sc('Unable to locate: ', path);
                TP.ifInfo() ? TP.info(msg) : 0;

                request.fail(msg);

                return null;
            }
        }

        request.complete(text);

        return text;
    },
    'safari',
    function(targetUrl, aRequest) {

        /**
         * @method $fileLoad
         * @summary Loads the content of targetUrl, returning data as text.
         * @param {String} targetUrl URL of the target file.
         * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
         *     call parameters.
         * @exception TP.sig.InvalidURI
         * @exception TP.sig.PrivilegeViolation
         * @exception TP.sig.IOException
         * @returns {String}
         */

        var path,
            request,
            msg,
            text,
            httpObj;

        if (!TP.isString(targetUrl)) {
            return TP.raise(this, 'TP.sig.InvalidURI');
        }

        //  expand to support virtual uri input
        path = TP.uriExpandPath(targetUrl);

        //  make sure that any fragments ('#' followed by word characters)
        //  is trimmed off
        if (/#/.test(path)) {
            path = path.slice(0, path.indexOf('#'));
        }

        request = TP.request(aRequest);

        try {
            httpObj = TP.httpConstruct(path);
            if (TP.canInvoke(request, 'atPut')) {
                request.atPut('commObj', httpObj);
            }

            httpObj.open(TP.HTTP_GET, path, false);
            httpObj.send(null);

            text = httpObj.responseText;
        } catch (e) {
            //  It threw an exception, which means that it definitely didn't
            //  find it so we always return null if we get here.
            msg = TP.sc('Unable to locate: ', path);
            TP.ifInfo() ? TP.info(msg) : 0;

            request.fail(msg);

            return;
        }

        //  Webkit usually won't throw an exception if it can't find a URI,
        //  but will return a variety of status codes, depending on the
        //  exact browser (i.e. Safari or Chrome).

        //  Safari 4.X - all platforms
        if (httpObj.status === 404) {
            msg = TP.sc('Unable to locate: ', path);
            TP.ifInfo() ? TP.info(msg) : 0;

            request.fail(msg);

            return;
        }

        //  Safari 4.X - Windows
        if (TP.sys.isWin() && httpObj.status === -1100) {
            msg = TP.sc('Unable to locate: ', path);
            TP.ifInfo() ? TP.info(msg) : 0;

            request.fail(msg);

            return;
        }

        //  Safari 3.1 - Mac
        if (TP.sys.isMac() &&
            (httpObj.status === -1100 || httpObj.status === 400)) {
            msg = TP.sc('Unable to locate: ', path);
            TP.ifInfo() ? TP.info(msg) : 0;

            request.fail(msg);

            return;
        }

        //  Safari 3.1 - Windows
        if (TP.sys.isWin() && httpObj.status === 1789378560) {
            msg = TP.sc('Unable to locate: ', path);
            TP.ifInfo() ? TP.info(msg) : 0;

            request.fail(msg);

            return;
        }

        request.complete(text);

        return text;
    },
    'chrome',
    function(targetUrl, aRequest) {

        /**
         * @method $fileLoad
         * @summary Loads the content of targetUrl, returning data as text.
         * @param {String} targetUrl URL of the target file.
         * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
         *     call parameters.
         * @exception TP.sig.InvalidURI
         * @exception TP.sig.PrivilegeViolation
         * @exception TP.sig.IOException
         * @returns {String}
         */

        var path,
            request,
            fname,
            msg,
            text,
            httpObj,
            result;

        if (!TP.isString(targetUrl)) {
            return TP.raise(this, 'TP.sig.InvalidURI');
        }

        //  expand to support virtual uri input
        path = TP.uriExpandPath(targetUrl);

        //  make sure that any fragments ('#' followed by word characters)
        //  is trimmed off
        if (/#/.test(path)) {
            path = path.slice(0, path.indexOf('#'));
        }

        request = TP.request(aRequest);

        if (TP.sys.cfg('boot.context') === 'electron' &&
                                                    !TP.sys.inExtension()) {
            //  following operation uses local name, not web format
            fname = TP.uriInLocalFormat(path);

            //  Call the external Electron utilities to load the file
            result = TP.extern.electron_lib_utils.fileLoad(fname);

            if (result.ok === false) {
                TP.raise(this, 'TP.sig.IOFailed');

                msg = TP.sc('File could not be loaded: ', path,
                            '. Reason: ' + result.msg);
                request.fail(msg);

                return;
            }

            text = result.content;

        } else {

            try {
                httpObj = TP.httpConstruct(path);
                if (TP.canInvoke(request, 'atPut')) {
                    request.atPut('commObj', httpObj);
                }

                httpObj.open(TP.HTTP_GET, path, false);
                httpObj.send(null);

                text = httpObj.responseText;

            } catch (e) {
                //  It threw an exception, which means that it definitely didn't
                //  find it so we always return null if we get here.
                msg = TP.sc('Unable to locate: ', path);
                TP.ifInfo() ? TP.info(msg) : 0;

                request.fail(msg);

                return;
            }

            //  Webkit usually won't throw an exception if it can't find a URI,
            //  but will return a variety of status codes, depending on the
            //  exact browser (i.e. Safari or Chrome).

            //  Chrome workaround -- sigh.
            if (httpObj.status === 0 && httpObj.responseText === '') {
                msg = TP.sc('Unable to locate: ', path);
                TP.ifInfo() ? TP.info(msg) : 0;

                request.fail(msg);

                return;
            }
        }

        request.complete(text);

        return text;
    }
));

//  ------------------------------------------------------------------------
//  FILE SAVE
//  ------------------------------------------------------------------------

/*
Primitive functions supporting file save operations. Note that the HTTP
versions require the assistance of the TIBET Data Server components or an
equivalent set of CGI scripts/Servlets on the server side while the FILE
versions require varying permissions.

Primitive functions supporting file save operations. Note that the HTTP
versions require the assistance of server-side components such as a WebDAV
capable server or a REST-based (Rails perhaps ;)) server with PUT support.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('$fileSave',
TP.hc(
    'test',
    TP.sys.getBrowser,
    'firefox',
    function(targetUrl, aRequest) {

        /**
         * @method $fileSave
         * @summary Saves content to the targetUrl provided using parameters
         *     and content taken from aRequest.
         * @param {String} targetUrl URL of the target file.
         * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
         *     parameters which control the operation including: body String The
         *     content of the file to save. append Boolean True to append to an
         *     existing file, otherwise the file will be created if needed and
         *     written to. backup Boolean True if a backup '~' file should be
         *     created. Ignored by the HTTP scheme versions. method String
         *     TP.HTTP_PUT or TP.HTTP_POST. Default is TP.HTTP_POST. permissions
         *     String A *NIX-style permission key such as '0755' or '0644'.
         * @exception TP.sig.InvalidURI
         * @exception TP.sig.URIException
         * @exception TP.sig.InvalidMode
         * @exception TP.sig.AccessViolation
         * @returns {Boolean} True on success, false on failure.
         */

        var path,
            fname,
            request,
            append,
            mode,
            body,

            permissions,
            retVal;

        if (!TP.isString(targetUrl)) {
            return TP.raise(this, 'TP.sig.InvalidURI');
        }

        //  expand to support virtual uri input
        path = TP.uriExpandPath(targetUrl);

        //  make sure that any fragments ('#' followed by word characters)
        //  is trimmed off
        if (/#/.test(path)) {
            path = path.slice(0, path.indexOf('#'));
        }

        //  following operation uses local name, not web format
        fname = TP.uriInLocalFormat(targetUrl);

        request = TP.request(aRequest);

        //  default is to blow away old copy if any and create a new file
        append = TP.ifKeyInvalid(request, 'append', false);
        mode = append ? TP.APPEND : TP.WRITE;

        //  try to get a 'permissions mask' from the paramsHash, but default
        //  it if the paramsHash is empty (or not defined) or if there is no
        //  entry for permissions in the paramsHash. We default it to the
        //  standard Unix file permissions of 0644.
        permissions = TP.ifKeyInvalid(request, 'permissions', '0644');

        retVal = false;

        //  We need to request privileges from Mozilla to perform this
        //  operation. We don't bother trying this operation without
        //  privileges because we still need them, even if we were launched
        //  from the 'same domain' (i.e. the file system).

        TP.executePrivileged(
            TP.HOST_FILE_SAVE,
            TP.sc('This TIBET-based application would like to save file: ',
                    path),
            TP.sc('This TIBET-based application cannot save file: ', path),
            false,      //  don't even attempt this without privileges
            function() {

                var FP,
                    stream,
                    backup,
                    file,
                    currentData,
                    flags,
                    msg;

                //  mozilla-specific components, see Moz's FileUtils.js etc.
                try {
                    FP = new Components.Constructor(
                                '@mozilla.org/file/local;1',
                                'nsILocalFile', 'initWithPath');

                    stream = Components.classes[
                            '@mozilla.org/network/file-output-stream;1'
                            ].createInstance(
                                Components.interfaces.nsIFileOutputStream);
                } catch (e) {
                    msg = TP.sc('Unable to get component(s) for: ', path);
                    TP.raise(this, 'TP.sig.URIException',
                                TP.ec(e, msg));

                    retVal = false;
                    request.fail(msg);

                    return retVal;
                }

                try {
                    file = new FP(fname);

                    backup = TP.ifKeyInvalid(request, 'backup', true);
                    if (backup && file.exists()) {
                        try {
                            currentData = TP.$fileLoad(path);
                            TP.$fileSave(
                                path + '~',
                                TP.request('body', currentData,
                                            'backup', false));
                        } catch (e) {
                            //  can't create backup copy? then we're not
                            //  going to move ahead since a write would blow
                            //  away the old data and we've been told to
                            //  save it
                            msg = TP.sc(
                                    'Terminated save.',
                                    ' Unable to create backup copy of: ',
                                    path);
                            TP.raise(this,
                                        'TP.sig.URIException',
                                        TP.ec(e, msg));

                            retVal = false;
                            request.fail(msg);

                            return retVal;
                        }
                    }

                    body = TP.ifKeyInvalid(request, 'body', '');

                    if (mode === TP.WRITE) {
                        flags = TP.MOZ_FILE_CREATE |
                                TP.MOZ_FILE_TRUNCATE |
                                TP.MOZ_FILE_WRONLY;

                        stream.init(file, flags, permissions, null);
                        stream.write(body, body.getSize());
                        stream.flush();
                        stream.close();

                        retVal = true;
                        request.complete(retVal);

                        return retVal;
                    } else if (mode === TP.APPEND) {
                        if (file.exists()) {
                            flags = TP.MOZ_FILE_APPEND |
                                    TP.MOZ_FILE_SYNC |
                                    TP.MOZ_FILE_RDWR;

                            stream.init(file, flags, permissions, null);
                            stream.write(body, body.getSize());
                            stream.flush();
                            stream.close();

                            retVal = true;
                            request.complete(retVal);

                            return retVal;
                        } else {
                            //  TODO:   do we want a parameter to drive this
                            //  logic?

                            //  append, but if not there we'll just create
                            //  and move on
                            flags = TP.MOZ_FILE_CREATE |
                                    TP.MOZ_FILE_TRUNCATE |
                                    TP.MOZ_FILE_WRONLY;

                            stream.init(file, flags, permissions, null);
                            stream.write(body, body.getSize());
                            stream.flush();
                            stream.close();

                            retVal = true;
                            request.complete(retVal);

                            return retVal;
                        }
                    } else {
                        msg = TP.sc('Invalid file save mode ', mode,
                                    ' for ', fname);
                        TP.raise(this, 'InvalidMode', msg);

                        request.fail(msg);
                    }
                } catch (e) {
                    msg = TP.sc('Unable to access: ', fname);
                    TP.raise(this, 'AccessViolation', TP.ec(e, msg));

                    request.fail(msg);
                }

                retVal = false;

                return retVal;
            });

        return retVal;
    },
    'safari',
    function(targetUrl, aRequest) {

        /**
         * @method $fileSave
         * @summary Saves content to the targetUrl provided using parameters
         *     and content taken from aRequest.
         * @param {String} targetUrl URL of the target file.
         * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
         *     parameters which control the operation including: body String The
         *     content of the file to save. append Boolean True to append to an
         *     existing file, otherwise the file will be created if needed and
         *     written to. backup Boolean True if a backup '~' file should be
         *     created. Ignored by the HTTP scheme versions. method String
         *     TP.HTTP_PUT or TP.HTTP_POST. Default is TP.HTTP_POST. permissions
         *     String A *NIX-style permission key such as '0755' or '0644'.
         * @exception TP.sig.InvalidURI
         * @exception TP.sig.URIException
         * @exception TP.sig.InvalidMode
         * @exception TP.sig.AccessViolation
         * @returns {Boolean} True on success, false on failure.
         */

        var request;

        request = TP.request(aRequest);

        TP.raise(this, 'TP.sig.UnsupportedOperation');
        request.fail('Unsupported operation.');

        return false;
    },
    'chrome',
    function(targetUrl, aRequest) {

        /**
         * @method $fileSave
         * @summary Saves content to the targetUrl provided using parameters
         *     and content taken from aRequest.
         * @param {String} targetUrl URL of the target file.
         * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
         *     parameters which control the operation including: body String The
         *     content of the file to save. append Boolean True to append to an
         *     existing file, otherwise the file will be created if needed and
         *     written to. backup Boolean True if a backup '~' file should be
         *     created. Ignored by the HTTP scheme versions. method String
         *     TP.HTTP_PUT or TP.HTTP_POST. Default is TP.HTTP_POST. permissions
         *     String A *NIX-style permission key such as '0755' or '0644'.
         * @exception TP.sig.InvalidURI
         * @exception TP.sig.URIException
         * @exception TP.sig.InvalidMode
         * @exception TP.sig.AccessViolation
         * @returns {Boolean} True on success, false on failure.
         */

        var request,

            path,

            append,
            mode,

            body,

            fname,

            result,

            msg;

        request = TP.request(aRequest);

        //  expand to support virtual uri input
        path = TP.uriExpandPath(targetUrl);

        //  make sure that any fragments ('#' followed by word characters)
        //  is trimmed off
        if (/#/.test(path)) {
            path = path.slice(0, path.indexOf('#'));
        }

        //  default is to blow away old copy if any and create a new file
        append = TP.ifKeyInvalid(request, 'append', false);
        mode = append ? TP.APPEND : TP.WRITE;

        body = TP.ifKeyInvalid(request, 'body', '');

        if (TP.sys.cfg('boot.context') === 'electron' &&
                                                    !TP.sys.inExtension()) {
            //  following operation uses local name, not web format
            fname = TP.uriInLocalFormat(path);

            //  Call the external Electron utilities to save the file
            result = TP.extern.electron_lib_utils.fileSave(fname, body, mode);

            if (result.ok === false) {
                TP.raise(this, 'TP.sig.IOFailed');

                msg = TP.sc('File could not be saved: ', path,
                                '. Reason: ' + result.msg);
                request.fail(msg);

                return false;
            } else {
                request.complete(true);

                return true;
            }

        } else {
            TP.raise(this, 'TP.sig.UnsupportedOperation');
            request.fail('Unsupported operation.');
        }

        return false;
    }
));

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETURIPrimitivesPost.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 */

//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETXSLTPrimitivesBase.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETXSLTPrimitivesPlatform.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
Platform-specific functionality related to XSLT operations.
*/

//  ------------------------------------------------------------------------
//  XSLT PRIMITIVES
//  ------------------------------------------------------------------------

//  First, we execute some functions that will set up certain data
//  structures for Gecko.
TP.runConditionalFunction(
TP.hc(
    'test',
    'gecko',
    'true',
    function() {

        //  (More) friendly error messages for common XSLT exceptions for
        //  the Mozilla Transformiix XSLT processor.

        TP.MOZ_XSLT_ERROR_CODES =
        TP.hc(
                '0x80600001',
                    'XSLT parse exception ' +
                        '(NS_ERROR_XSLT_PARSE_FAILURE)',
                '0x80600002',
                    'XPath parse failure exception ' +
                        '(NS_ERROR_XPATH_PARSE_FAILURE)',
                '0x80600003',
                    'XSLT already set exception ' +
                        '(NS_ERROR_XSLT_ALREADY_SET)',
                '0x80600004',
                    'XSLT execution failure exception. Missing include or' +
                    ' import? ' +
                        '(NS_ERROR_XSLT_EXECUTION_FAILURE)',
                '0x80600005',
                    'XPath unknown function exception ' +
                        '(NS_ERROR_XPATH_UNKNOWN_FUNCTION)',
                '0x80600006',
                    'XSLT bad recursion exception ' +
                        '(NS_ERROR_XSLT_BAD_RECURSION)',
                '0x80600007',
                    'XSLT bad value exception ' +
                        '(NS_ERROR_XSLT_BAD_VALUE)',
                '0x80600008',
                    'XSLT nodeset expected exception ' +
                        '(NS_ERROR_XSLT_NODESET_EXPECTED)',
                '0x80600009',
                    'XSLT aborted exception ' +
                        '(NS_ERROR_XSLT_ABORTED)',
                '0x8060000a',
                    'XSLT network error exception ' +
                        '(NS_ERROR_XSLT_NETWORK_ERROR)',
                '0x8060000b',
                    'XSLT wrong MIME type exception ' +
                        '(NS_ERROR_XSLT_WRONG_MIME_TYPE)',
                '0x8060000c',
                    'XSLT load recursion exception ' +
                        '(NS_ERROR_XSLT_LOAD_RECURSION)',
                '0x8060000d',
                    'XPath bad argument count exception ' +
                        '(NS_ERROR_XPATH_BAD_ARGUMENT_COUNT)',
                '0x8060000e',
                    'XPath bad extension function exception ' +
                        '(NS_ERROR_XPATH_BAD_EXTENSION_FUNCTION)',
                '0x8060000f',
                    'XPath parenthesis expected exception ' +
                        '(NS_ERROR_XPATH_PAREN_EXPECTED)',
                '0x80600010',
                    'XPath invalid axis exception ' +
                        '(NS_ERROR_XPATH_INVALID_AXIS)',
                '0x80600011',
                    'XPath no node type test exception ' +
                        '(NS_ERROR_XPATH_NO_NODE_TYPE_TEST)',
                '0x80600012',
                    'XPath bracket expected exception ' +
                        '(NS_ERROR_XPATH_BRACKET_EXPECTED)',
                '0x80600013',
                    'XPath invalid variable name exception ' +
                        '(NS_ERROR_XPATH_INVALID_VAR_NAME)',
                '0x80600014',
                    'XPath unexpected end exception ' +
                        '(NS_ERROR_XPATH_UNEXPECTED_END)',
                '0x80600015',
                    'XPath operator expected exception ' +
                        '(NS_ERROR_XPATH_OPERATOR_EXPECTED)',
                '0x80600016',
                    'XPath unclosed literal exception ' +
                        '(NS_ERROR_XPATH_UNCLOSED_LITERAL)',
                '0x80600017',
                    'XPath bad colon exception ' +
                        '(NS_ERROR_XPATH_BAD_COLON)',
                '0x80600018',
                    'XPath bad bang exception ' +
                        '(NS_ERROR_XPATH_BAD_BANG)',
                '0x80600019',
                    'XPath illegal character exception ' +
                        '(NS_ERROR_XPATH_ILLEGAL_CHAR)',
                '0x8060001a',
                    'XPath binary expected exception ' +
                        '(NS_ERROR_XPATH_BINARY_EXPECTED)',
                '0x8060001b',
                    'XSLT loading error. Check file paths. ' +
                        '(NS_ERROR_XSLT_LOAD_BLOCKED_ERROR)',
                '0x8060001c',
                    'XPath invalid expression evaluated exception ' +
                        '(NS_ERROR_XPATH_INVALID_EXPRESSION_EVALUATED)',
                '0x8060001d',
                    'XPath unbalanced curly brace exception ' +
                        '(NS_ERROR_XSLT_UNBALANCED_CURLY_BRACE)',
                '0x8060001e',
                    'XSLT bad node name exception ' +
                        '(NS_ERROR_XSLT_BAD_NODE_NAME)',
                '0x80004005',
                    'XSLT error. Missing or misnamed parameter or' +
                        ' variable?',
                '0x804b000a',
                    'URI error. Malformed URI.'
        );

        //  A RegExp to extract the XSLT exception failure code number.
        TP.regex.ERROR = TP.rc('Component returned failure code: (\\w+)');

        return;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('$documentEscapeContent',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(aDocument, tagNameArray) {

        /**
         * @method $documentEscapeContent
         * @summary Escapes the content under the all of the tags named in the
         *     tags array in the supplied document with CDATA sections.
         * @description This works around a bug in the Mozilla XSLT engine,
         *     Transformiix, that assumes that escaping content is the same as
         *     placing it in CDATA sections, which its not - especially if its
         *     the output of (X)HTML 'style' or 'script'.
         * @param {XMLDocument} aDocument The XML document to escape the content
         *     in.
         * @param {String[]} tagNameArray An Array of tag names to escape the
         *     content of.
         */

        var i,
            len,
            i2,
            len2,
            name,
            elem,
            elementsToEscape;

        //  Loop over those element names.
        len = tagNameArray.getSize();
        for (i = 0; i < len; i++) {
            name = tagNameArray[i];

            //  Grab an Array of elements in the result document
            //  that we're supposed to escape.
            elementsToEscape = TP.nodeGetElementsByTagName(aDocument, name);

            //  Loop over them and grab their first child,
            //  which should be a text child, and replace it
            //  with a CDATA section wrapping the node value of
            //  that text node.
            len2 = elementsToEscape.getSize();
            for (i2 = 0; i2 < len2; i2++) {
                elem = elementsToEscape.at(i2);

                //  Make sure to do this only if the first
                //  child is a text node.

                if (TP.isTextNode(elem.firstChild)) {
                    TP.nodeReplaceChild(
                        elem,
                        aDocument.createCDATASection(
                                            elem.firstChild.nodeValue),
                        elem.firstChild);
                }
            }
        }

        return;
    },
    'webkit',
    function(aDocument, tagNameArray) {

        /**
         * @method $documentEscapeContent
         * @summary Escapes the content under the all of the tags named in the
         *     tags array in the supplied document with CDATA sections.
         * @description This works around a bug in the Mozilla XSLT engine,
         *     Transformiix, that assumes that escaping content is the same as
         *     placing it in CDATA sections, which its not - especially if its
         *     the output of (X)HTML 'style' or 'script'. TODO: It is unknown
         *     whether Webkit actually needs to do this - it needs testing.
         * @param {XMLDocument} aDocument The XML document to escape the content
         *     in.
         * @param {String[]} tagNameArray An Array of tag names to escape the
         *     content of.
         */

        var i,
            len,
            i2,
            len2,
            name,
            elem,
            elementsToEscape;

        //  Loop over those element names.
        len = tagNameArray.getSize();
        for (i = 0; i < len; i++) {
            name = tagNameArray.at(i);

            //  Grab an Array of elements in the result document
            //  that we're supposed to escape.
            elementsToEscape = TP.nodeGetElementsByTagName(aDocument, name);

            //  Loop over them and grab their first child,
            //  which should be a text child, and replace it
            //  with a CDATA section wrapping the node value of
            //  that text node.
            len2 = elementsToEscape.getSize();
            for (i2 = 0; i2 < len2; i2++) {
                elem = elementsToEscape.at(i2);

                //  Make sure to do this only if the first
                //  child is a text node.

                if (TP.isTextNode(elem.firstChild)) {
                    TP.nodeReplaceChild(
                        elem,
                        aDocument.createCDATASection(
                                            elem.firstChild.nodeValue),
                        elem.firstChild);
                }
            }
        }
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('$fixupNamespacedAttributesPre',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(inputNode) {

        /**
         * @method $fixupNamespacedAttributesPre
         * @summary Encodes namespace attributes from their original form to a
         *     form that will survive Mozilla's XSLT transformation. They will
         *     be restored to their original form by the 'post' routine below.
         * @description Unfortunately, Mozilla's XSLT processor does not
         *     currently support namespace nodes. Even worse, it actually
         *     removes 'xmlns' attributes from transformed Nodes (instead of
         *     just leaving them alone).
         * @param {Node} inputNode The input data element.
         */

        var allElements,
            j,
            len,
            elem,
            attrLength,
            i;

        //  Since the XPath processor knows nothing about 'xmlns' (or
        //  'xmlns:...') attributes (but the DOM does), we've got to this
        //  the 'old fashioned' way -- via the DOM. Sigh...

        //  Grab all elements
        allElements = TP.nodeGetElementsByTagName(inputNode, '*');

        len = allElements.getSize();
        for (j = 0; j < len; j++) {
            elem = allElements.at(j);

            attrLength = elem.attributes.length;

            //  Loop over each attribute on the element. The 'xmlns'
            //  (or 'xmlns:...') attributes will be exposed here because
            //  this is the DOM, not XPath
            for (i = 0; i < attrLength; i++) {
                //  The 'namespace namespace' is defined by the W3C as
                //  'http://www.w3.org/2000/xmlns/' and we can use that
                //  here to see if the attribute itself has that
                //  namespace. If so, then its an 'xmlns' (or
                //  'xmlns:...') attribute, so we add a 'hack' attribute
                //  that encodes it.
                if (TP.nodeGetNSURI(elem.attributes[i]) ===
                        TP.w3.Xmlns.XMLNS) {
                    //  We append the attribute's local name (which
                    //  will either be 'xmlns' or a prefix in front of
                    //  'xmlns', depending on whether this is defining
                    //  a default namespace or not.
                    TP.elementSetAttribute(
                        elem,
                        'tibet_XSLTNSHack__' +
                            TP.attributeGetLocalName(elem.attributes[i]),
                        elem.attributes[i].value);
                }
            }
        }

        return;
    },
    'webkit',
    function(inputNode) {

        /**
         * @method $fixupNamespacedAttributesPre
         * @summary Encodes namespace attributes from their original form to a
         *     form that will survive Mozilla's XSLT transformation. They will
         *     be restored to their original form by the 'post' routine below.
         * @description Unfortunately, Mozilla's XSLT processor does not
         *     currently support namespace nodes. Even worse, it actually
         *     removes 'xmlns' attributes from transformed Nodes (instead of
         *     just leaving them alone). TODO: It is unknown whether Webkit
         *     actually needs to do this - it needs testing.
         * @param {Node} inputNode The input data element.
         */

        var allElements,
            j,
            len,
            elem,
            attrLength,
            i;

        //  Since the XPath processor knows nothing about 'xmlns' (or
        //  'xmlns:...') attributes (but the DOM does), we've got to this
        //  the 'old fashioned' way -- via the DOM. Sigh...

        //  Grab all elements
        allElements = TP.nodeGetElementsByTagName(inputNode, '*');

        len = allElements.getSize();
        for (j = 0; j < len; j++) {
            elem = allElements.at(j);

            attrLength = elem.attributes.length;

            //  Loop over each attribute on the element. The 'xmlns'
            //  (or 'xmlns:...') attributes will be exposed here because
            //  this is the DOM, not XPath
            for (i = 0; i < attrLength; i++) {
                //  The 'namespace namespace' is defined by the W3C as
                //  'http://www.w3.org/2000/xmlns/' and we can use that
                //  here to see if the attribute itself has that
                //  namespace. If so, then its an 'xmlns' (or
                //  'xmlns:...') attribute, so we add a 'hack' attribute
                //  that encodes it.
                if (TP.nodeGetNSURI(elem.attributes[i]) ===
                        TP.w3.Xmlns.XMLNS) {
                    //  We append the attribute's local name (which
                    //  will either be 'xmlns' or a prefix in front of
                    //  'xmlns', depending on whether this is defining
                    //  a default namespace or not.
                    TP.elementSetAttribute(
                        elem,
                        'tibet_XSLTNSHack__' +
                            TP.attributeGetLocalName(elem.attributes[i]),
                        elem.attributes[i].value);
                }
            }
        }

        return;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('$fixupNamespacedAttributesPost',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(inputNode, resultDoc) {

        /**
         * @method $fixupNamespacedAttributesPost
         * @summary Restores namespace attributes to their original form from
         *     having been processed by the 'pre' routine above.
         * @param {Node} inputNode The input data element.
         * @param {XMLDocument} resultDoc The result XML document after
         *     transformation.
         */

        var xsltHackAttrs,
            ownerElement,
            prefixName,
            i,
            len,
            anAttr;

        //  Replace any 'tibet_XSLTNSHack' attributes that got put on the
        //  original input node by us in the 'pre' routine above.

        //  Search for any attributes named 'tibet_XSLTNSHack' using an
        //  XPath expression. This works on this document (unlike in the
        //  'pre' function above) because these are just regular attributes
        //  and are therefore 'visible' to the XPath processor.
        xsltHackAttrs =
            TP.nodeEvaluateXPath(
                    inputNode,
                    '//@*[starts-with(local-name(),"tibet_XSLTNSHack")]',
                    TP.NODESET);

        //  Loop over the found attributes.
        len = xsltHackAttrs.getSize();
        for (i = 0; i < len; i++) {
            anAttr = xsltHackAttrs.at(i);

            ownerElement = TP.attributeGetOwnerElement(anAttr);

            //  Remove the 'XSLTHack' attribute node.
            ownerElement.removeAttributeNode(anAttr);
        }

        //  Replace any 'tibet_XSLTNSHack' attributes that got copied on the
        //  result document by the XSLT transformation with an 'xmlns' (or
        //  'xmlns:...') attribute, thereby restoring the original
        //  namespace.

        //  First, check to make sure we have a valid document element
        if (TP.notValid(resultDoc.documentElement)) {
            return;
        }

        //  Search for any attributes named 'tibet_XSLTNSHack' using an
        //  XPath expression.
        xsltHackAttrs =
            TP.nodeEvaluateXPath(
                    resultDoc,
                    '//@*[starts-with(local-name(),"tibet_XSLTNSHack")]',
                    TP.NODESET);

        len = xsltHackAttrs.getSize();
        for (i = 0; i < len; i++) {
            anAttr = xsltHackAttrs.at(i);

            ownerElement = TP.attributeGetOwnerElement(anAttr);
            prefixName = anAttr.name.split('__').at(1);

            //  If the prefixName isn't 'xmlns', that means that it
            //  was a 'prefixed namespace definition' that was
            //  encoded and the prefixName needs to be prepended
            //  with 'xmlns:'.
            if (prefixName !== 'xmlns') {
                prefixName = 'xmlns:' + prefixName;
            }

            //  Restore the namespace attribute by using
            //  'setAttributeNS' with the 'namespace namespace' ;-).
            ownerElement.setAttributeNS(
                    TP.w3.Xmlns.XMLNS,
                    prefixName,
                    anAttr.value);

            //  Remove the 'XSLTHack' attribute node.
            ownerElement.removeAttributeNode(anAttr);
        }

        return;
    },
    'webkit',
    function(inputNode, resultDoc) {

        /**
         * @method $fixupNamespacedAttributesPost
         * @summary Restores namespace attributes to their original form from
         *     having been processed by the 'pre' routine above.
         * @description TODO: It is unknown whether Webkit actually needs to do
         *     this - it needs testing.
         * @param {Node} inputNode The input data element.
         * @param {XMLDocument} resultDoc The result XML document after
         *     transformation.
         */

        var xsltHackAttrs,
            ownerElement,
            prefixName,
            i,
            len,
            anAttr;

        //  Replace any 'tibet_XSLTNSHack' attributes that got put on the
        //  original input node by us in the 'pre' routine above.

        //  Search for any attributes named 'tibet_XSLTNSHack' using an
        //  XPath expression. This works on this document (unlike in the
        //  'pre' function above) because these are just regular attributes
        //  and are therefore 'visible' to the XPath processor.
        xsltHackAttrs =
            TP.nodeEvaluateXPath(
                    inputNode,
                    '//@*[starts-with(local-name(),"tibet_XSLTNSHack")]',
                    TP.NODESET);

        //  Loop over the found attributes.
        len = xsltHackAttrs.getSize();
        for (i = 0; i < len; i++) {
            anAttr = xsltHackAttrs.at(i);

            ownerElement = TP.attributeGetOwnerElement(anAttr);

            //  Remove the 'XSLTHack' attribute node.
            ownerElement.removeAttributeNode(anAttr);
        }

        //  Replace any 'tibet_XSLTNSHack' attributes that got copied on the
        //  result document by the XSLT transformation with an 'xmlns' (or
        //  'xmlns:...') attribute, thereby restoring the original
        //  namespace.

        //  First, check to make sure we have a valid document element
        if (TP.notValid(resultDoc.documentElement)) {
            return;
        }

        //  Search for any attributes named 'tibet_XSLTNSHack' using an
        //  XPath expression.
        xsltHackAttrs =
            TP.nodeEvaluateXPath(
                    resultDoc,
                    '//@*[starts-with(local-name(),"tibet_XSLTNSHack")]',
                    TP.NODESET);

        len = xsltHackAttrs.getSize();
        for (i = 0; i < len; i++) {
            anAttr = xsltHackAttrs.at(i);

            ownerElement = TP.attributeGetOwnerElement(anAttr);
            prefixName = anAttr.name.split('__').at(1);

            //  If the prefixName isn't 'xmlns', that means that it
            //  was a 'prefixed namespace definition' that was
            //  encoded and the prefixName needs to be prepended
            //  with 'xmlns:'.
            if (prefixName !== 'xmlns') {
                prefixName = 'xmlns:' + prefixName;
            }

            //  Restore the namespace attribute by using
            //  'setAttributeNS' with the 'namespace namespace' ;-).
            ownerElement.setAttributeNS(
                    TP.w3.Xmlns.XMLNS,
                    prefixName,
                    anAttr.value);

            //  Remove the 'XSLTHack' attribute node.
            ownerElement.removeAttributeNode(anAttr);
        }

        return;
    }
));

//  ------------------------------------------------------------------------

TP.definePrimitive('documentTransformNode',
TP.hc(
    'test',
    TP.sys.getBrowserUI,
    'gecko',
    function(styleDoc, inputNode, paramHash) {

        /**
         * @method documentTransformNode
         * @summary Transforms the inputNode using the XSLT style sheet node
         *     provided, returning a node with the result data.
         * @param {XMLDocument} styleDoc The XSLT style document.
         * @param {Node} inputNode The input data element.
         * @param {TP.core.Hash} paramHash A hash of optional parameters to be
         *     passed to the style sheet. A key of 'xmlns:fixup' set to true
         *     will repair xmlns attributes.
         * @exception TP.sig.XSLTException
         * @exception TP.sig.InvalidXMLDocument
         * @returns {Node} The transformed Node.
         */

        var gotDoc,
            inputDoc,
            resultDoc,
            processor,

            realStyleDoc,

            paramNodes,
            len,
            i,
            node,

            fixupXMLNSAttrs,

            outputNodes,
            cdataSectionElementNames,

            exceptionMsgParts,
            exceptionWarningMsg,
            srcURI,

            docAttrs,
            foundDefaultNSAttr;

        if (!TP.isXMLDocument(styleDoc)) {
            return TP.raise(this, 'TP.sig.InvalidXMLDocument');
        }

        //  have to have a document or the tranformation will fail
        gotDoc = TP.isXMLDocument(inputNode);
        if (!gotDoc) {
            try {
                inputDoc = TP.documentFromNode(
                                TP.nodeCloneNode(inputNode, true));
            } catch (e) {
                return TP.raise(this, 'TP.sig.InvalidXMLDocument',
                                TP.ec(e));
            }
        } else {
            inputDoc = inputNode;
        }

        //  Normally, we let the caller decide if they want to fix xmlns
        //  attributes, but if the inputDoc itself is an XSLT, then we
        //  *know* that we need to make sure to preserve namespaces (as they
        //  will get used in things like template match XPaths).
        if (TP.nodeGetNSURI(inputDoc.documentElement) === TP.w3.Xmlns.XSLT) {
            fixupXMLNSAttrs = true;
        } else {
            fixupXMLNSAttrs = TP.ifKeyInvalid(paramHash,
                                                'xmlns:fixup',
                                                true);
        }

        if (TP.notValid(processor)) {
            try {
                //  create an xslt processor we can use to transform the
                //  data
                processor = new XSLTProcessor();

                if (TP.notEmpty(paramHash)) {
                    paramNodes = TP.ac();

                    paramHash.perform(
                        function(kvPair) {

                            var paramName,
                                paramValue;

                            paramName = kvPair.first();
                            paramValue = TP.ifInvalid(kvPair.last(), '');

                            //  We can't have parameter names that start with
                            //  '$' - that conflicts with XSLT variables.
                            if (/^\$/.test(paramName)) {
                                return;
                            }

                            processor.setParameter(
                                        null,
                                        paramName,
                                        paramValue);
                        });
                }

                //  Mozilla is very strict about having an XML declaration on
                //  the XSLT document itself, so we 'recreate' the style
                //  document to make sure it has one.
                realStyleDoc = TP.doc(TP.nodeAsString(styleDoc, true, false));

                //  NB: We *must* import the stylesheet *after* we set the
                //  parameters, in case any of them were 'node set'
                //  parameters.
                processor.importStylesheet(realStyleDoc);
            } catch (e) {
                //  See if we can extract the failure code from the
                //  exception message.
                exceptionMsgParts = TP.str(e).match(TP.regex.ERROR);

                //  If we successfully extracted an error code, it will be
                //  in position 1, and if that can be found in our list of
                //  error codes, then log a warning with our nicer error
                //  message.
                if (TP.isArray(exceptionMsgParts) &&
                    exceptionMsgParts.getSize() > 1 &&
                    TP.isString(exceptionWarningMsg =
                                TP.MOZ_XSLT_ERROR_CODES.at(
                                                exceptionMsgParts.at(1)))) {
                    if (TP.notEmpty(srcURI = styleDoc[TP.SRC_LOCATION])) {
                        exceptionWarningMsg += ' in: ' + srcURI;
                    }

                    TP.ifWarn() ?
                        TP.warn(exceptionWarningMsg,
                                TP.TRANSFORM_LOG) : 0;
                }

                TP.raise(this, 'TP.sig.XSLTException', TP.ec(e));

                return;
            }
        }

        try {
            //  Because of Mozilla's lack of support for namespaces in its
            //  XSLT processing (see above), we have to do some 'fixups'
            //  before we process the inputNode. We only do this if
            //  fixupXMLNSAttrs is true (which is the default).
            if (fixupXMLNSAttrs) {
                TP.$fixupNamespacedAttributesPre(inputDoc);
            }

            //  watch out for CSS within XHTML...can crash Mozilla
            inputDoc = TP.$nodeEscapeCSSConstructs(inputDoc);

            //  Do the deed...
            resultDoc = processor.transformToDocument(inputDoc);

            //  If we didn't get a valid result document, raise an exception
            //  and exit here.
            if (!TP.isXMLDocument(resultDoc) ||
                TP.notValid(resultDoc.documentElement)) {
                TP.raise(this, 'TP.sig.XSLTException',
                            'Unable to produce valid XML document.');

                return;
            }

            //  Now, if fixupXMLNSAttrs is true, undo whatever sort of
            //  strange machinations we had to do due to Mozilla's lack of
            //  namespace support.
            if (fixupXMLNSAttrs) {
                TP.$fixupNamespacedAttributesPost(inputDoc, resultDoc);
            }

            //  If there are any 'xsl:output' elements, grab the first (and
            //  should be only) one and check to see if it has a
            //  'cdata-section-elements' attribute on it. This means that
            //  the author of the stylesheet wanted certain elements to have
            //  their text content wrapped in CDATA sections, but since
            //  Transformiix refuses to do that, we'll do it manually here.
            if (TP.notEmpty(outputNodes = TP.nodeGetElementsByTagName(
                                                    styleDoc, 'xsl:output'))) {
                //  If there was actually content for the
                //  'cdata-section-elements' attribute, split it on space to
                //  get an Array of element names that we're supposed to
                //  wrap text child content for.
                if (TP.notEmpty(cdataSectionElementNames =
                                TP.elementGetAttribute(
                                                outputNodes.at(0),
                                                'cdata-section-elements'))) {
                    cdataSectionElementNames =
                                cdataSectionElementNames.split(' ');

                    TP.$documentEscapeContent(resultDoc,
                                                cdataSectionElementNames);
                }
            }

            //  Go ahead and auto-escape 'html:script' and 'html:style'
            //  elements in the output.
            TP.$documentEscapeContent(resultDoc,
                                        TP.ac('script',
                                            'style',
                                            'html:script',
                                            'html:style',
                                            'tibet_style'));

            if (TP.isArray(paramNodes)) {
                //  Remove any 'node set' parameter values that we added
                //  above.
                //  We do this by cleaning out all children under the
                //  parameter node.
                len = paramNodes.getSize();
                for (i = 0; i < len; i++) {
                    node = paramNodes.at(i);
                    TP.nodeDetach(node.firstChild);
                }
            }
        } catch (e) {
            //  See if we can extract the failure code from the exception
            //  message.
            exceptionMsgParts = TP.str(e).match(TP.regex.ERROR);

            //  If we successfully extracted an error code, it will be in
            //  position 1, and if that can be found in our list of error
            //  codes, then log a warning with our nicer error message.
            if (TP.isArray(exceptionMsgParts) &&
                exceptionMsgParts.getSize() > 1 &&
                TP.isString(exceptionWarningMsg =
                                    TP.MOZ_XSLT_ERROR_CODES.at(
                                        exceptionMsgParts.at(1)))) {
                if (TP.notEmpty(srcURI = styleDoc[TP.SRC_LOCATION])) {
                    exceptionWarningMsg += ' in: ' + srcURI;
                }

                TP.ifWarn() ?
                    TP.warn(exceptionWarningMsg,
                            TP.TRANSFORM_LOG) : 0;
            }

            TP.raise(this, 'TP.sig.XSLTException', TP.ec(e));

            return;
        }

        //  return the resultDoc as our return value as long as it's valid
        //  and has a document element
        if (!TP.isDocument(resultDoc) ||
            TP.notValid(resultDoc.documentElement)) {
            return;
        }

        //  We only do this if the documentElement doesn't have a prefix.
        //  This avoids an XMLSerializer bug on Mozilla.
        if (TP.isEmpty(resultDoc.documentElement.prefix)) {
            //  If the documentElement has a namespaceURI, the XSLTProcessor
            //  might have ripped out any default namespace attribute that
            //  it had, which will eventually cause the XMLSerializer to
            //  produce that 'a0' junk that we hate so much.

            //  The following code detects whether there's a default
            //  namespace or not and, if not, puts a default namespace
            //  attribute on the documentElement that is the namespace it
            //  has anyway, but this time set as the default namespace.
            //  This makes the XMLSerializer shut up about that 'a0' stuff.
            //  Note that, if this routine detects a default namespace, it
            //  will leave it alone even if its not the same namespace as
            //  the document element's namespace. This avoids problems when
            //  XSLTing an XSLT itself, since it very rarely uses the XSLT
            //  namespace as its default namespace.
            foundDefaultNSAttr = false;

            docAttrs = resultDoc.documentElement.attributes;
            for (i = 0; i < docAttrs.length; i++) {
                if (TP.attributeGetLocalName(docAttrs[i]) === 'xmlns') {
                    foundDefaultNSAttr = true;
                    break;
                }
            }

            if (!foundDefaultNSAttr) {
                resultDoc.documentElement.setAttributeNS(
                            TP.w3.Xmlns.XMLNS,
                            'xmlns',
                            TP.nodeGetNSURI(resultDoc.documentElement));
            }
        }

        //  if we didn't get a document then don't return one, return the
        //  document element instead
        if (!gotDoc) {
            return resultDoc.documentElement;
        }

        return resultDoc;
    },
    'webkit',
    function(styleDoc, inputNode, paramHash) {

        /**
         * @method documentTransformNode
         * @summary Transforms the inputNode using the XSLT style sheet node
         *     provided, returning a node with the result data.
         * @param {XMLDocument} styleDoc The XSLT style document.
         * @param {Node} inputNode The input data element.
         * @param {TP.core.Hash} paramHash A hash of optional parameters to be
         *     passed to the style sheet. A key of 'xmlns:fixup' set to true
         *     will repair xmlns attributes.
         * @exception TP.sig.XSLTException
         * @exception TP.sig.InvalidXMLDocument
         * @returns {Node} The transformed Node.
         */

        var gotDoc,
            inputDoc,
            resultDoc,
            processor,

            realStyleDoc,

            paramNodes,
            len,
            i,
            node,

            fixupXMLNSAttrs,

            outputNodes,
            cdataSectionElementNames,

            docAttrs,
            foundDefaultNSAttr;

        if (!TP.isXMLDocument(styleDoc)) {
            return TP.raise(this, 'TP.sig.InvalidXMLDocument');
        }

        //  have to have a document or the tranformation will fail
        gotDoc = TP.isXMLDocument(inputNode);
        if (!gotDoc) {
            try {
                inputDoc = TP.documentFromNode(
                                TP.nodeCloneNode(inputNode, true));
            } catch (e) {
                return TP.raise(this, 'TP.sig.InvalidXMLDocument',
                                TP.ec(e));
            }
        } else {
            inputDoc = inputNode;
        }

        //  Normally, we let the caller decide if they want to fix xmlns
        //  attributes, but if the inputDoc itself is an XSLT, then we
        //  *know* that we need to make sure to preserve namespaces (as they
        //  will get used in things like template match XPaths).
        if (TP.nodeGetNSURI(inputDoc.documentElement) === TP.w3.Xmlns.XSLT) {
            fixupXMLNSAttrs = true;
        } else {
            fixupXMLNSAttrs = TP.ifKeyInvalid(paramHash,
                                                'xmlns:fixup',
                                                true);
        }

        if (TP.notValid(processor)) {
            try {
                //  create an xslt processor we can use to transform the
                //  data
                processor = new XSLTProcessor();

                if (TP.notEmpty(paramHash)) {
                    paramNodes = TP.ac();

                    //  We clone the style doc since we might need to alter it
                    //  below.
                    realStyleDoc = TP.nodeCloneNode(styleDoc, true);

                    paramHash.perform(
                        function(kvPair) {

                            var paramName,
                                paramValue,

                                paramElem,

                                newElem;

                            paramName = kvPair.first();
                            paramValue = TP.ifInvalid(kvPair.last(), '');

                            //  We can't have parameter names that start with
                            //  '$' - that conflicts with XSLT variables.
                            if (/^\$/.test(paramName)) {
                                return;
                            }

                            //  Webkit-based browsers have a long-standing bug
                            //  with using Nodes as parameters... sigh
                            //  https://bugs.webkit.org/show_bug.cgi?id=14101
                            if (TP.isNode(paramValue)) {
                                //  Search the style doc to see if there's an
                                //  'xsl:param' element with a name matching
                                //  paramName
                                if (TP.isElement(
                                    paramElem = TP.nodeEvaluateXPath(
                                        realStyleDoc,
                                        '//xsl:param[@name="' + paramName + '"]',
                                        TP.FIRST_NODE))) {

                                    //  Create an 'xsl:variable' element and set
                                    //  it's name to be the same as the
                                    //  'xsl:param'
                                    newElem = TP.documentConstructElement(
                                                        realStyleDoc,
                                                        'xsl:variable',
                                                        TP.w3.Xmlns.XSLT);
                                    TP.elementSetAttribute(
                                                    newElem, 'name', paramName);

                                    //  Swap in the 'xsl:variable' element for
                                    //  the 'xsl:param' element.
                                    newElem = TP.nodeReplaceChild(
                                                    paramElem.parentNode,
                                                    newElem,
                                                    paramElem);

                                    //  Append the content under the
                                    //  'xsl:variable' element.
                                    TP.nodeAppendChild(
                                                    newElem, paramValue, false);
                                }
                            } else {
                                processor.setParameter(
                                            null,
                                            paramName,
                                            paramValue);
                            }
                        });
                } else {
                    realStyleDoc = styleDoc;
                }

                //  NB: We *must* import the stylesheet *after* we set the
                //  parameters, in case any of them were 'node set'
                //  parameters.
                processor.importStylesheet(realStyleDoc);
            } catch (e) {
                TP.raise(this, 'TP.sig.XSLTException', TP.ec(e));

                return;
            }
        }

        try {
            //  Because of Mozilla's lack of support for namespaces in its
            //  XSLT processing (see above), we have to do some 'fixups'
            //  before we process the inputNode. We only do this if
            //  fixupXMLNSAttrs is true (which is the default).
            if (fixupXMLNSAttrs) {
                TP.$fixupNamespacedAttributesPre(inputDoc);
            }

            //  watch out for CSS within XHTML...can crash Mozilla
            inputDoc = TP.$nodeEscapeCSSConstructs(inputDoc);

            //  Do the deed...
            resultDoc = processor.transformToDocument(inputDoc);

            //  If we didn't get a valid result document, raise an exception
            //  and exit here.
            if (!TP.isXMLDocument(resultDoc) ||
                TP.notValid(resultDoc.documentElement)) {
                TP.raise(this, 'TP.sig.XSLTException',
                            'Unable to produce valid XML document.');

                return;
            }

            //  Now, if fixupXMLNSAttrs is true, undo whatever sort of
            //  strange machinations we had to do due to Mozilla's lack of
            //  namespace support.
            if (fixupXMLNSAttrs) {
                TP.$fixupNamespacedAttributesPost(inputDoc, resultDoc);
            }

            //  If there are any 'xsl:output' elements, grab the first (and
            //  should be only) one and check to see if it has a
            //  'cdata-section-elements' attribute on it. This means that
            //  the author of the stylesheet wanted certain elements to have
            //  their text content wrapped in CDATA sections, but since
            //  Transformiix refuses to do that, we'll do it manually here.
            if (TP.notEmpty(outputNodes = TP.nodeGetElementsByTagName(
                                                    styleDoc, 'xsl:output'))) {
                //  If there was actually content for the
                //  'cdata-section-elements' attribute, split it on space to
                //  get an Array of element names that we're supposed to
                //  wrap text child content for.
                if (TP.notEmpty(cdataSectionElementNames =
                                TP.elementGetAttribute(
                                                outputNodes.at(0),
                                                'cdata-section-elements'))) {
                    cdataSectionElementNames =
                                cdataSectionElementNames.split(' ');

                    TP.$documentEscapeContent(resultDoc,
                                                cdataSectionElementNames);
                }
            }

            //  Go ahead and auto-escape 'html:script' and 'html:style'
            //  elements in the output.
            TP.$documentEscapeContent(resultDoc,
                                        TP.ac('script',
                                            'style',
                                            'html:script',
                                            'html:style',
                                            'tibet_style'));

            if (TP.isArray(paramNodes)) {
                //  Remove any 'node set' parameter values that we added
                //  above.
                //  We do this by cleaning out all children under the
                //  parameter node.
                len = paramNodes.getSize();
                for (i = 0; i < len; i++) {
                    node = paramNodes.at(i);
                    TP.nodeDetach(node.firstChild);
                }
            }
        } catch (e) {
            TP.raise(this, 'TP.sig.XSLTException', TP.ec(e));

            return;
        }

        //  return the resultDoc as our return value as long as it's valid
        //  and has a document element
        if (!TP.isDocument(resultDoc) ||
            TP.notValid(resultDoc.documentElement)) {
            return;
        }

        //  We only do this if the documentElement doesn't have a prefix.
        //  This avoids an XMLSerializer bug on Mozilla.

        //  TODO: Check to see if we need to do this on Webkit...
        if (TP.isEmpty(resultDoc.documentElement.prefix)) {
            //  If the documentElement has a namespaceURI, the XSLTProcessor
            //  might have ripped out any default namespace attribute that
            //  it had, which will eventually cause the XMLSerializer to
            //  produce that 'a0' junk that we hate so much.

            //  The following code detects whether there's a default
            //  namespace or not and, if not, puts a default namespace
            //  attribute on the documentElement that is the namespace it
            //  has anyway, but this time set as the default namespace.
            //  This makes the XMLSerializer shut up about that 'a0' stuff.
            //  Note that, if this routine detects a default namespace, it
            //  will leave it alone even if its not the same namespace as
            //  the document element's namespace. This avoids problems when
            //  XSLTing an XSLT itself, since it very rarely uses the XSLT
            //  namespace as its default namespace.
            foundDefaultNSAttr = false;

            docAttrs = resultDoc.documentElement.attributes;
            for (i = 0; i < docAttrs.length; i++) {
                if (TP.attributeGetLocalName(docAttrs[i]) === 'xmlns') {
                    foundDefaultNSAttr = true;
                    break;
                }
            }

            if (!foundDefaultNSAttr) {
                resultDoc.documentElement.setAttributeNS(
                            TP.w3.Xmlns.XMLNS,
                            'xmlns',
                            TP.nodeGetNSURI(resultDoc.documentElement));
            }
        }

        //  if we didn't get a document then don't return one, return the
        //  document element instead
        if (!gotDoc) {
            return resultDoc.documentElement;
        }

        return resultDoc;
    }
));

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETXSLTPrimitivesPost.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @To support efficient DOM manipulations for various functions we leverage the
 *     XSLT support in the modern browsers. Both IE and Mozilla provide
 *     operationswhich allow the loading and processing of XSLT style sheets.
 *     The TIBETkernel includes XSLT style sheets supporting common DOM
 *     operations/transforms.
 */

//  ------------------------------------------------------------------------

TP.definePrimitive('uriTransformFile',
function(styleUrl, inputUrl, paramHash) {

    /**
     * @method uriTransformFile
     * @summary Loads the two URLs and transforms the input using the style
     *     sheet provided.
     * @param {String} styleUrl The URL of the style sheet.
     * @param {String} inputUrl The URL of the input data file.
     * @param {TP.core.Hash} paramHash A hash of optional parameters to be
     *     passed to the style sheet. A key of 'xmlns:fixup' set to true will
     *     repair xmlns attributes.
     * @exception TP.sig.XSLTException
     * @exception TP.sig.InvalidNode
     * @exception TP.sig.InvalidURI
     * @exception TP.sig.URINotFound
     * @returns {Document} A document object containing the results.
     */

    var resp,

        url1,
        node1,

        url2,
        node2;

    if (TP.notValid(url1 = TP.uc(styleUrl))) {
        this.raise('TP.sig.InvalidURI', styleUrl);

        return;
    }

    resp = url1.getNativeNode(TP.hc('async', false));
    node1 = resp.get('result');

    if (TP.notValid(url2 = TP.uc(inputUrl))) {
        this.raise('TP.sig.InvalidURI', inputUrl);

        return;
    }

    resp = url2.getNativeNode(TP.hc('async', false));
    node2 = resp.get('result');

    return TP.documentTransformFile(node1, node2, paramHash);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uriTransformNode',
function(styleUrl, inputNode, paramHash) {

    /**
     * @method uriTransformNode
     * @summary Loads the style sheet URL provided and applies the resulting
     *     style to the input node.
     * @param {String} styleUrl The URL of the style sheet.
     * @param {Node} inputNode The input data element.
     * @param {TP.core.Hash} paramHash A hash of optional parameters to be
     *     passed to the style sheet. A key of 'xmlns:fixup' set to true will
     *     repair xmlns attributes.
     * @exception TP.sig.XSLTException
     * @exception TP.sig.InvalidNode
     * @exception TP.sig.InvalidURI
     * @exception TP.sig.URINotFound
     * @returns {Document} A document object containing the results.
     */

    var resp,
        url1,
        node1;

    if (TP.notValid(url1 = TP.uc(styleUrl))) {
        this.raise('TP.sig.InvalidURI', styleUrl);

        return;
    }

    resp = url1.getNativeNode(TP.hc('async', false));
    node1 = resp.get('result');

    return TP.documentTransformNode(node1, inputNode, paramHash);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentTransformFile',
function(styleNode, inputUrl, paramHash) {

    /**
     * @method documentTransformFile
     * @summary Loads the input URL and transforms the data using the style
     *     sheet node provided.
     * @param {Node} styleNode The XSLT style document or fragment.
     * @param {String} inputUrl The URL of the input data file.
     * @param {TP.core.Hash} paramHash A hash of optional parameters to be
     *     passed to the style sheet. A key of 'xmlns:fixup' set to true will
     *     repair xmlns attributes.
     * @exception TP.sig.XSLTException
     * @exception TP.sig.InvalidNode
     * @exception TP.sig.InvalidURI
     * @exception TP.sig.URINotFound
     * @returns {Document} A document object containing the results.
     */

    var resp,

        url2,
        node2;

    if (TP.notValid(url2 = TP.uc(inputUrl))) {
        this.raise('TP.sig.InvalidURI', inputUrl);
        return;
    }

    resp = url2.getNativeNode(TP.hc('async', false));
    node2 = resp.get('result');

    return TP.documentTransformNode(styleNode, node2, paramHash);
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETContentPrimitives.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
Low-level content processing support.
*/

//  ========================================================================
//  JSON
//  ========================================================================

/**
 * @subject JSON JavaScript Object Notation (JSON) is a restricted subset of
 *     JavaScript source code which is suitable for use as a simple data
 *     transport format.
 *
 *     Due to what some consider to be a security loophole in all current
 *     browsers-- one that will likely remain unpatched for the forseeable
 *     future -- JSONrequests made via dynamic script node addition can be used
 *     to circumvent cross-domain scripting restrictions enforced by
 *     XMLHttpRequest. This has made it popular with developers who don't have
 *     strong XML requirements.
 */

//  ------------------------------------------------------------------------

TP.regex.JSON_ISODATE =
    /^(\d{4})-?(\d{2})?-?(\d{2})?(T(\d{2})(:(\d{2})(:(\d{2})(\.(\d{1,3}))?)?)?)?(Z)?([\+\-]\d{2}:\d{2})?$/;

TP.regex.JSON_ERRMSG = /^JSONP call error: /;

//  ------------------------------------------------------------------------

TP.definePrimitive('getJSONPIFrame',
function() {

    /**
     * @method getJSONPIFrame
     * @summary Retrieves the iframe used to fetch and/or parse JSON results.
     * @description The iframe returned by this routine is created (once) if it
     *     doesn't exist. It is used by the jsonpCall() to load the actual
     *     results and then scrub it through a serialize/parse cycle to try to
     *     avoid malformed/malicious JSON data.
     * @returns {Element} The iframe element used to manage JSON data.
     */

    var win,
        iframeName,
        iframeElem;

    win = TP.sys.getWindowById(TP.sys.cfg('tibet.top_win_name'));
    if (TP.notValid(win)) {
        win = window;
    }

    //  Look up the frame name, or default to an easy-to-spot name.
    iframeName = TP.sys.cfg('jsonp.frame_id') || 'JSONP';

    if (!TP.isElement(iframeElem =
                        TP.nodeGetElementById(win.document, iframeName))) {
        iframeElem = TP.documentConstructIFrameElement(win.document,
                                                        null,
                                                        iframeName);
        TP.elementSetAttribute(iframeElem, 'style', 'display: none');
    }

    return iframeElem;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('reformatJSToJSON',
function(aString, shouldConvertArrayBrackets) {

    /**
     * @method reformatJSToJSON
     * @summary Formats a JS string into a JSON String that can then be parsed
     *     as JSON. This routine also 'TP.' values to be resolved into their
     *     real values.
     * @description An example of an unquoted JSON string with 'TP.' references
     *     is:
     *          {index:1,position:TP.BEFORE}
     *     from which this method will produce:
     *          {"index":1,"position":"before"}
     * @param {String} aString The string to reformat into proper JSON.
     * @param {Boolean} [shouldConvertArrayBrackets=true] Whether or not to
     *     convert Array brackets (i.e. '[' and ']') to real Arrays. The default
     *     is true.
     * @returns {String} A properly quoted JSON string.
     */

    var convertArrayBrackets,

        lastNonSpaceToken,
        nextNonSpaceToken,
        lastTokenNeedsQuote,
        nextTokenNeedsQuote,

        tokens,

        str,

        token,
        val,

        context,

        useGlobalContext,

        len,
        i,

        lastNSToken,
        nextNSToken;

    //  TODO: This is a bit cheesy - make TP.$tokenize() smarter or, better yet,
    //  write a new routine to JSONize strings.

    //  Temporarily delete the 'data' property from TP.boot.$uriSchemes so that
    //  this call won't try to convert things like 'data:' (which may very well
    //  be a property name) into a URI.
    delete TP.boot.$uriSchemes.data;

    convertArrayBrackets = TP.notFalse(shouldConvertArrayBrackets);

    if (convertArrayBrackets) {
        //  Tokenize the input string, supplying our own set of 'operators'.
        tokens = TP.$tokenize(
                        aString,
                        TP.ac('{', ':', '}', '[', ']', '.', ','),
                        true);  //  We specify 'tsh' (meaning that we want URI
                                //  parsing)
    } else {
        //  Tokenize the input string, supplying our own set of 'operators'.
        tokens = TP.$tokenize(
                        aString,
                        TP.ac('{', ':', '}', '.', ','),
                        true);  //  We specify 'tsh' (meaning that we want URI
                                //  parsing)
    }


    //  Restore the 'data' property.
    TP.boot.$uriSchemes.data = 'data';

    str = '';

    //  Note that we track a 'context' in this method so that values to our
    //  "JSON" (so to speak) can be things like 'TP.sys.foo' that will resolve
    //  properly.
    context = null;

    //  When this flag is true, we can use identifier/string/uri values to look
    //  up properties on the global object to set the context.
    useGlobalContext = true;

    len = tokens.getSize();

    //  A function to find the last non-space token starting at an index
    lastNonSpaceToken = function(startIndex) {
        var j;

        for (j = startIndex - 1; j >= 0; j--) {
            if (tokens.at(j).name !== 'space') {
                return tokens.at(j);
            }
        }
    };

    //  A function to find the next non-space token starting at an index
    nextNonSpaceToken = function(startIndex) {
        var j;

        for (j = startIndex + 1; j < len; j++) {
            if (tokens.at(j).name !== 'space') {
                return tokens.at(j);
            }
        }
    };

    lastTokenNeedsQuote = function(startIndex) {
        var lastToken;

        lastToken = lastNonSpaceToken(startIndex);

        if (convertArrayBrackets) {
            if (lastToken.value === '}' || lastToken.value === ']') {
                return false;
            }
        } else {
            if (lastToken.value === '}') {
                return false;
            }
        }

        return true;
    };

    nextTokenNeedsQuote = function(startIndex) {
        var nextToken;

        nextToken = nextNonSpaceToken(startIndex);

        if (convertArrayBrackets) {
            if (nextToken.value === '{' || nextToken.value === '[') {
                return false;
            }
        } else {
            if (nextToken.value === '{') {
                return false;
            }
        }

        return true;
    };

    for (i = 0; i < len; i++) {

        token = tokens.at(i);
        val = token.value;

        switch (token.name) {

            case 'identifier':
            case 'string':
            case 'uri':

                if (TP.isValid(context)) {
                    context = context[val];
                } else {
                    //  If useGlobalContext is true and the value is a property
                    //  *in the approved list of globals* (i.e. in
                    //  TP.sys.$globals), then set the context to the value of
                    //  that property on TP.global (which is the window/global
                    //  object).
                    if (useGlobalContext && TP.sys.$globals.hasKey(val)) {
                        context = TP.global[val];
                    } else {
                        //  There was no context or value that resolved to a
                        //  context, so we trim the value and then unquote the
                        //  result (but only unquote double quotes - leave
                        //  single quotes alone).
                        str += TP.trim(val).unquoted('"');
                    }
                }

                //  Flip useGlobalContext to false - we won't allow it anymore
                useGlobalContext = false;

                break;

            case 'operator':
                if (val === '.' && TP.isValid(tokens.at(i - 1))) {

                    //  If there isn't a valid context, test to see if we can
                    //  obtain one or not.
                    if (TP.notValid(context)) {

                        //  If useGlobalContext is still true, try to use the
                        //  previous token's value as the context.
                        if (useGlobalContext) {
                            context = tokens.at(i - 1).value;

                            //  If we got an empty (or whitespace only) context,
                            //  then we don't really have a context at all, but
                            //  a standalone '.'. Just append it and move on.
                            context = TP.trim(context);
                            if (TP.isEmpty(context)) {
                                useGlobalContext = false;
                                str += '.';
                            }

                            if (context === ']' || context === '}') {
                                context = null;
                                str += '.';
                            }
                        } else {
                            //  Otherwise, if we've already flipped
                            //  useGlobalContext to false, then we're not at the
                            //  'first segment' of a '.' separated value and so
                            //  we just append the '.' and move on.
                            str += '.';
                        }
                    }

                    break;
                } else if (val === '{') {
                    str += '{';

                    if (nextTokenNeedsQuote(i)) {
                        str += '"';
                    }

                    context = null;
                } else if (val === '[' && convertArrayBrackets) {
                    str += '[';

                    if (nextTokenNeedsQuote(i)) {
                        str += '"';
                    }

                    context = null;
                } else if (val === ':') {
                    if (lastTokenNeedsQuote(i)) {
                        str += '"';
                    }

                    str += ':';

                    if (nextTokenNeedsQuote(i)) {
                        str += '"';
                    }

                    context = null;

                    //  We're at the end of a key - need to reset for the next
                    //  value.
                    useGlobalContext = true;
                } else if (val === ',') {

                    //  We're at the end of a value - need to consume the
                    //  context.
                    if (TP.isValid(context)) {
                        val = context;
                        str += val;
                    }

                    if (lastTokenNeedsQuote(i)) {
                        str += '"';
                    }

                    str += ',';

                    if (nextTokenNeedsQuote(i)) {
                        str += '"';
                    }

                    context = null;

                    //  We're at the end of a value - need to reset for the next
                    //  value.
                    useGlobalContext = true;
                } else if (val === ']' && convertArrayBrackets) {

                    //  We're at the end of a value - need to consume the
                    //  context.
                    if (TP.isValid(context)) {
                        val = context;
                        str += val;
                    }

                    if (lastTokenNeedsQuote(i)) {
                        str += '"';
                    }

                    str += ']';

                    context = null;

                    //  We're at the end of a value - need to reset for the next
                    //  value.
                    useGlobalContext = true;
                } else if (val === '}') {

                    //  We're at the end of a value - need to consume the
                    //  context.
                    if (TP.isValid(context)) {
                        val = context;
                        str += val;
                    }

                    if (lastTokenNeedsQuote(i)) {
                        str += '"';
                    }

                    str += '}';

                    context = null;

                    //  We're at the end of a value - need to reset for the next
                    //  value.
                    useGlobalContext = true;
                } else {
                    str += val;
                }
                break;

            case 'space':

                lastNSToken = lastNonSpaceToken(i);
                nextNSToken = nextNonSpaceToken(i);

                /* eslint-disable no-extra-parens */
                if (lastNSToken.value === '{' ||
                    (lastNSToken.value === '[' && convertArrayBrackets) ||
                    lastNSToken.value === ':' ||
                    lastNSToken.value === ',' ||
                    lastNSToken.value === '"') {
                    break;
                }

                if (nextNSToken.value === '}' ||
                    (nextNSToken.value === ']' && convertArrayBrackets) ||
                    nextNSToken.value === ':' ||
                    nextNSToken.value === ',' ||
                    nextNSToken.value === '"') {
                    break;
                }
                /* eslint-enable no-extra-parens */

                //  it's a space - leave it alone
                str += val;

                break;

            default:
                //  leave everything else alone - but trim it.
                str += TP.trim(val);

                break;
        }
    }

    //  Change any *standalone* numeric or boolean double-quoted expression into
    //  unquoted content (i.e. {"foo":"1"} becomes {"foo":1})
    TP.regex.DOUBLE_QUOTED_NUMBER_OR_BOOLEAN.lastIndex = 0;
    str = str.replace(TP.regex.DOUBLE_QUOTED_NUMBER_OR_BOOLEAN, '$1');

    //  Because JSON doesn't allow for escaped single quotes, we have to make
    //  sure to replace them all here.
    str = str.replace(/\\'/g, '\'');

    return str;
});

//  ------------------------------------------------------------------------
//  JSON source conversions
//  ------------------------------------------------------------------------

TP.definePrimitive('isJSONString',
function(aString) {

    /**
     * @method isJSONString
     * @summary Returns whether or not the supplied String can be parsed into a
     *     JSON string.
     * @description This method will only return true if the supplied String is
     *     what is normally considered a 'JSON string' - that is, a String
     *     containing 'JSON structure'. So, even though officially a standalone
     *     Number or Boolean value is considered JSON by the JSON specification,
     *     they will return false here, as will any String not containing a
     *     fully formed 'JSON structure' (i.e. Object or Array).
     * @param {String} aString A JSON-formatted string.
     * @returns {Boolean} Whether or not the supplied String is a JSON-formatted
     *     String.
     */

    var text;

    if (!TP.isString(aString)) {
        return false;
    }

    if (TP.isEmpty(aString)) {
        return false;
    }

    if (TP.regex.ANY_NUMBER.test(aString)) {
        return false;
    }

    if (TP.regex.BOOLEAN_ID.test(aString)) {
        return false;
    }

    //  test to see if the supplied string starts with some sort of JSON
    //  structure. Since we return false if the string contained only a number
    //  or boolean, we check next for JSON structures.

    //  This check is here purely for performance. This RegExp is only useful in
    //  this context, where we're checking before moving on to a 'full JSON
    //  parse'. Therefore, we don't make this RegExp a global 'TP.regex'
    //  property to avoid misuse in other circumstances.
    if (!/^\s*[[{]/.test(aString)) {
        return false;
    }

    //  avoid changing parameter value
    text = aString;

    try {
        //  Call the 'parse' method on the 'JSON' object.
        JSON.parse(text);

        return true;
    } catch (e) {
        //  We never report here - just return false
        return false;
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('json2js',
function(aString, smartConversion, shouldReport) {

    /**
     * @method json2js
     * @summary Transforms a JSON-formatted string into the equivalent
     *     JavaScript objects.
     * @param {String} aString A JSON-formatted string.
     * @param {Boolean} smartConversion Whether or not to 'smart convert' the
     *     JSON into JS. This causes the construction of TP.core.Hashes instead
     *     of Objects. This defaults to true.
     * @param {Boolean} shouldReport False to suppress errors. Default is true.
     * @returns {Object|undefined} A JavaScript object containing the JSON data.
     * @exception InvalidJSON
     */

    var text,

        shouldConvert,

        obj,

        tpHashInstProto;

    //  avoid changing parameter value
    text = aString;

    //  we default to smart conversion
    shouldConvert = TP.ifInvalid(smartConversion, true);

    try {

        //  If we're not doing smart conversion, then we can just return the
        //  result of calling the 'parse' method on the 'JSON' object supplied.
        if (!shouldConvert) {
            return JSON.parse(text);
        }

        //  Otherwise, we play some serious trickery here to make any Objects
        //  that would be created by turning JSON into JavaScript into
        //  TP.core.Hashes so that they can fully participate in TIBET.

        //  Note that this technique relies on being able to manipulate (both
        //  read and write) the __proto__ slot of a JavaScript object instance.
        //  This is now supported in all environments we run in.

        //  To do this, we first grab the 'instance prototype' of TP.core.Hash
        tpHashInstProto = TP.core.Hash.Inst;

        //  NB: Some of the constructs in the following loop are 'bare JS' to
        //  get the required performance.

        //  Call JSON.parse() with our custom conversion function
        obj = JSON.parse(
                    text,
                    function(key, value) {

                        var newVal,
                            newHashPOJO;

                        //  If the value is real and it's an Object (note here
                        //  that we can do this direct test since the JSON parse
                        //  routine is guaranteed to create plain JS objects),
                        //  then create a new object with its __proto__ to be
                        //  the TP.core.Hash's instance prototype and set its
                        //  '$$type' to TP.core.Hash.
                        if (value &&
                            value.constructor.prototype === TP.ObjectProto) {

                            //  Create a new value to replace the object handed
                            //  to us by the parse routine and set its prototype
                            //  to the hash instance prototype obtained above.
                            newVal = Object.create(tpHashInstProto);

                            newVal.$$type = TP.core.Hash;

                            //  Note here that set an ID here because real
                            //  TP.core.Hashes are required to have an unique ID
                            //  from the start (but we tweak the ID prefix to
                            //  let inspectors/debuggers know that they're
                            //  dealing with a 'sort of' TP.core.Hash).
                            newVal.$$id = TP.genID('Pseudo_TP.core.Hash');

                            //  Now, create a new hash object with a null
                            //  __proto__.
                            newHashPOJO = Object.create(null);

                            //  Copy all of the enumerable, 'own' slots from the
                            //  parsed value object onto our null __proto__ hash
                            //  POJO.
                            Object.assign(newHashPOJO, value);

                            //  Assign the internal '$$hash' property to the new
                            //  hash POJO.
                            newVal.$$hash = newHashPOJO;

                            return newVal;
                        }

                        //  Not an Object - just return the value handed to us.
                        return value;
                    });

        return obj;
    } catch (e) {
        if (TP.notFalse(shouldReport)) {
            return TP.raise(this, 'TP.sig.InvalidJSON', TP.ec(e, aString));
        }

        return;
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('js2json',
function(anObject, aReplacer, aPadding) {

    /**
     * @method js2json
     * @alias json
     * @summary Transforms an object into a representation in a JSON string.
     * @description Since JSON is a limited subset of JavaScript this
     *     representation may not be a complete copy of the object (in
     *     particular, since these primitives use the open source JSON
     *     serializer found at: http://www.json.org, Function objects will not
     *     be serialized).
     * @param {Object} anObject The object to transform.
     * @param {Function} [aReplacer] A function that alters
     *     the behavior of the stringification process. Note that, unlike the
     *     JSON.stringify call, this parameter *CANNOT* be an array of String
     *     and Number that serve as an allowlist for selecting/filtering the
     *     properties of the value object to be included in the JSON string. If
     *     this value is null or not provided, all properties of the object are
     *     included in the resulting JSON string.
     * @param {String|Number} [aPadding] A String or Number object that's used
     *     to insert white space into the output JSON string for readability
     *     purposes. If this is a Number, it indicates the number of space
     *     characters to use as white space; this number is capped at 10 (if it
     *     is greater, the value is just 10). Values less than 1 indicate that
     *     no space should be used. If this is a String, the string (or the
     *     first 10 characters of the string, if it's longer than that) is used
     *     as white space. If this parameter is not provided (or is null), no
     *     white space is used.
     * @returns {String} A JavaScript String containing the JSON data.
     * @exception TP.sig.JSONSerializationException
     */

    var str,

        debugKey,
        debugVal,

        hasReplacer;

    //  NOTE: No checks for invalid values here - JSON.stringify knows what to
    //  do with 'null' and 'undefined'.

    debugKey = null;
    debugVal = null;

    hasReplacer = TP.isCallable(aReplacer);

    try {
        str = JSON.stringify(
                    anObject,
                    function(key, value) {

                        debugKey = key;
                        debugVal = value;

                        //  Make sure there are no internal slots we don't want
                        //  to expose.
                        if (TP.regex.INTERNAL_SLOT.test(key)) {
                            return;
                        }

                        if (hasReplacer) {
                            return aReplacer(value);
                        }

                        return value;
                    },
                    aPadding);
    } catch (e) {
        return TP.raise(this,
                        'TP.sig.JSONSerializationException',
                        TP.ec(
                            e,
                            'key: ' + debugKey +
                            ' value: ' + TP.id(debugVal)));
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('json', TP.js2json);

//  ------------------------------------------------------------------------
//  XML source conversions
//  ------------------------------------------------------------------------

TP.definePrimitive('isXMLString',
function(aString) {

    /**
     * @method isXMLString
     * @summary Returns whether or not the supplied String can be parsed into an
     *     XML string. To some extent you can always produce XML but this test
     *     explicitly eliminates text nodes from consideration.
     * @param {String} aString An XML-formatted string.
     * @returns {Boolean} Whether or not the supplied String is an XML-formatted
     *     String.
     */

    var node;

    if (TP.isEmpty(aString)) {
        return false;
    }

    //  Check to see if the supplied String contains element markup before
    //  sending it on the parser. This is a significant performance win.
    if (TP.regex.IS_ELEM_MARKUP.test(aString)) {
        return true;
    }

    //  Note here how we supply a null default namespace and pass false so that
    //  parser errors are *not* reported - we're really only interested if the
    //  String is XML or not.
    node = TP.nodeFromString(aString, null, false);

    return TP.isNode(node) && !TP.isTextNode(node);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('js2xml',
function(anObject, aFilterName) {

    /**
     * @method js2xml
     * @summary Transforms a JavaScript object into roughly equivalent XML
     *     using the built-in JSON<->XML Badgerfish conversions.
     * @param {Object} anObject The object to transform.
     * @param {String} aFilterName A get*Interface() filter spec.
     * @returns {Node} An XML node representing the same data structures found
     *     in the Object.
     */

    var obj,

        str,

        xmlStr,
        doc,
        node;

    obj = anObject;

    //  If we can't invoke this, it's probably because it's already a plain JS
    //  object.
    if (TP.canInvoke(obj, 'asObject')) {
        //  Make sure that we have a native JS object here (Object, Array,
        //  Number, String, Boolean, etc.)
        obj = anObject.asObject();
    }

    //  If the object has more than 1 key, then put it in another object with a
    //  single slot, 'value'. This makes it easier on the JSON<->XML conversion.
    if (TP.objectGetKeys(obj).getSize() > 1) {
        obj = {
            value: obj
        };
    }

    //  Make sure that this is a Badgerfish convention-following String
    str = TP.js2bfjson(obj);

    //  This takes a JSON String and converts it to an XML String using the
    //  Badgerfish convention.
    xmlStr = TP.bfjson2xml(str);

    if (TP.isXMLDocument(doc = TP.doc(xmlStr, null, true))) {
        node = doc.documentElement;
    }

    if (!TP.isNode(node)) {
        TP.raise(this, 'TP.sig.InvalidXML',
            'Unable to convert object ' + TP.id(anObject) + 'to XML.');
    }

    return node;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('xml2js',
function(aNode, smartConversion) {

    /**
     * @method xml2js
     * @summary Transforms an XML node into a roughly equivalent JavaScript
     *     object.
     * @description If the XML is in XMLRPC format this call attempts to
     *      reconstitute an Object from that, otherwise the node is processed
     *      using a processor that uses the Badgerfish convensions.
     * @param {Node} aNode An XML node.
     * @param {Boolean} smartConversion Whether or not to 'smart convert' the
     *     resultant JSON into JS. This causes the construction of
     *     TP.core.Hashes instead of Objects. This defaults to true.
     * @returns {Object} The JavaScript object constructed from the supplied
     *     XML.
     */

    var node,
        str;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    //  collections (nodes with a content model) are ok, but we need to work
    //  with element nodes when possible
    if (TP.isDocument(aNode)) {
        if (TP.elementGetLocalName(aNode.documentElement) === 'struct') {
            node = aNode.documentElement;
        } else {
            node = aNode;
        }
    } else if (TP.isElement(aNode) || TP.isFragment(aNode)) {
        node = aNode;
    } else if (TP.isAttributeNode(aNode)) {
        return TP.hc(aNode.name, aNode.value);
    } else if (TP.isPINode(aNode)) {
        return TP.hc('target', aNode.target, 'data', aNode.data);
    } else {
        //  not a "collection" node, so we can only assume text value
        return TP.nodeGetTextContent(aNode);
    }

    if (TP.isElement(node)) {
        //  If we're looking at XMLRPC data then we can use the XMLRPC type's
        //  objectFromNode(). We use a fairly trivial test here for struct as
        //  the outer element since all JSON strings are ultimately enclosed in
        //  '{'s.
        if (TP.elementGetLocalName(node) === 'struct') {
            return TP.dom.XMLRPCNode.objectFromNode(node);
        }
    }

    //  This takes an XML node and converts it to a JSON String using the
    //  Badgerfish convention.
    str = TP.xml2bfjson(node);

    return TP.json2js(str, smartConversion);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('js2bfjson',
function(anObject) {

    /**
     * @method js2bfjson
     * @summary Transforms a JavaScript Object into a JSON representation
     *     following the Badgerfish conventions.
     * @param {Object} anObject A JavaScript object
     * @returns {String} A JSON-formatted string that follows the Badgerfish
     *     XML<->JSON convention.
     */

    var obj,

        str,

        debugKey,
        debugVal;

    //  If we can't invoke this, it's probably because it's already a plain JS
    //  object.
    if (TP.canInvoke(obj, 'asObject')) {
        //  Make sure that we have a native JS object here (Object, Array,
        //  Number, String, Boolean, etc.)
        obj = anObject.asObject();
    }

    obj = anObject;

    //  NOTE: No checks for invalid values here - JSON.stringify knows what to
    //  do with 'null' and 'undefined'.

    debugKey = null;
    debugVal = null;

    try {
        str = JSON.stringify(
                    obj,
                    function(key, value) {

                        debugKey = key;
                        debugVal = value;

                        //  Make sure there are no internal slots we don't want
                        //  to expose.
                        if (TP.regex.INTERNAL_SLOT.test(key)) {
                            return;
                        }

                        //  If the key isn't '$' and the value is 'non-mutable'
                        //  (i.e. a String, Number or Boolean), then we return a
                        //  POJO with '$' as the key and the value. This is what
                        //  allows us to conform to Badgerfish conventions.
                        if (key !== '$' && !TP.isMutable(value)) {
                            return {
                                $: value
                            };
                        }

                        return value;
                    });
    } catch (e) {
        return TP.raise(this,
                        'TP.sig.JSONSerializationException',
                        TP.ec(
                            e,
                            'key: ' + debugKey +
                            ' value: ' + TP.id(debugVal)));
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('xml2bfjson',
function(aNode) {

    /**
     * @method xml2bfjson
     * @summary Transforms an XML node into a JSON representation following the
     *     Badgerfish conventions.
     * @description Code adapted to use TIBET coding conventions from:
     *     http://ruchirawageesha.blogspot.com/2011/06/xml-to-json-and-json-to-xml-conversion.html
     * @param {Node} aNode An XML node.
     * @returns {String} A JSON-formatted string that follows the Badgerfish
     *     XML<->JSON convention.
     */

    var jsobj,
        cloneNS,
        process;

    jsobj = {};

    cloneNS = function(ns) {
        var nns,
            n;

        nns = {};
        for (n in ns) {
            if (ns.hasOwnProperty(n)) {
                nns[n] = ns[n];
            }
        }
        return nns;
    };

    process = function(node, obj, ns) {

        var p,
            nodeName,
            i,

            attr,
            name,
            value,

            prefix,

            j,
            k;

        if (node.nodeType === Node.TEXT_NODE) {

            if (!node.nodeValue.match(/[\S]+/)) {
                return;
            }

            if (obj.$ instanceof Array) {
                obj.$.push(node.nodeValue);
            } else if (obj.$ instanceof Object) {
                obj.$ = [obj.$, node.nodeValue];
            } else {
                obj.$ = node.nodeValue;
            }

        } else if (node.nodeType === Node.ELEMENT_NODE) {

            p = {};
            nodeName = node.nodeName;

            for (i = 0; node.attributes && i < node.attributes.length; i++) {

                attr = node.attributes[i];
                name = attr.nodeName;
                value = attr.nodeValue;

                if (name === 'xmlns') {
                    ns.$ = value;
                } else if (name.indexOf('xmlns:') === 0) {
                    ns[name.substr(name.indexOf(':') + 1)] = value;
                } else {
                    p['@' + name] = value;
                }
            }

            for (prefix in ns) {

                if (ns.hasOwnProperty(prefix)) {
                    p['@xmlns'] = p['@xmlns'] || {};
                    p['@xmlns'][prefix] = ns[prefix];
                }
            }

            if (obj[nodeName] instanceof Array) {
                obj[nodeName].push(p);
            } else if (obj[nodeName] instanceof Object) {
                obj[nodeName] = [obj[nodeName], p];
            } else {
                obj[nodeName] = p;
            }

            for (j = 0; j < node.childNodes.length; j++) {
                process(node.childNodes[j], p, cloneNS(ns));
            }
        } else if (node.nodeType === Node.DOCUMENT_NODE) {

            for (k = 0; k < node.childNodes.length; k++) {
                process(node.childNodes[k], obj, cloneNS(ns));
            }
        }
    };

    process(aNode, jsobj, {});

    return JSON.stringify(jsobj);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('bfjson2xml',
function(aString) {

    /**
     * @method bfjson2xml
     * @summary Transforms JSON representation of XML that follows the
     *     Badgerfish conventions into an XML String.
     * @description Code adapted to use TIBET coding conventions from:
     *     http://ruchirawageesha.blogspot.com/2011/06/xml-to-json-and-json-to-xml-conversion.html
     * @param {String} aString A JSON-formatted string that follows the
     *     Badgerfish XML<->JSON convention.
     * @returns {String} A String of XML.
     */

    var data,

        cloneNS,
        processLeaf,

        leafName;

    //  Notice how we pass 'false' here for smart conversion - this routine
    //  relies on JS primitive constructs and we don't want smart conversion.
    data = TP.json2js(aString, false);

    if (TP.notEmpty(data)) {

        cloneNS = function(ns) {
            var nns,
                n;

            nns = {};
            for (n in ns) {
                if (ns.hasOwnProperty(n)) {
                    nns[n] = ns[n];
                }
            }

            return nns;
        };

        processLeaf = function(lname, child, ns) {
            var body,
                i,
                el,
                attributes,
                text,

                xmlns,
                prefix,

                key,
                obj;

            body = '';
            if (child instanceof Array) {
                for (i = 0; i < child.length; i++) {
                    body += processLeaf(lname, child[i], cloneNS(ns));
                }
                return body;
            } else if (typeof child === 'object') {

                el = '<' + lname;
                attributes = '';
                text = '';

                if (child['@xmlns']) {
                    xmlns = child['@xmlns'];
                    for (prefix in xmlns) {
                        if (xmlns.hasOwnProperty(prefix)) {
                            if (prefix === '$') {
                                if (ns[prefix] !== xmlns[prefix]) {
                                    attributes += ' ' + 'xmlns="' +
                                                    xmlns[prefix] + '"';
                                    ns[prefix] = xmlns[prefix];
                                }
                            } else if (!ns[prefix] ||
                                        /* eslint-disable no-extra-parens */
                                        (ns[prefix] !== xmlns[prefix])) {
                                        /* eslint-enable no-extra-parens */
                                attributes += ' xmlns:' + prefix + '="' +
                                                    xmlns[prefix] + '"';
                                ns[prefix] = xmlns[prefix];
                            }
                        }
                    }
                }

                for (key in child) {
                    if (child.hasOwnProperty(key) && key !== '@xmlns') {
                        obj = child[key];
                        if (key === '$') {
                            text += obj;
                        } else if (key.indexOf('@') === 0) {
                            attributes += ' ' + key.substring(1) + '="' +
                                            obj + '"';
                        } else {
                            body += processLeaf(key, obj, cloneNS(ns));
                        }
                    }
                }

                body = text + body;

                /* eslint-disable no-extra-parens */
                return (body !== '') ?
                /* eslint-enable no-extra-parens */
                    el + attributes + '>' + body + '</' + lname + '>' :
                    el + attributes + '/>';
            }
        };

        for (leafName in data) {

            if (data.hasOwnProperty(leafName) && leafName.indexOf('@') ===
                                                            TP.NOT_FOUND) {
                return processLeaf(leafName, data[leafName], {});
            }
        }

        return null;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('json2xml',
function(aString) {

    /**
     * @method json2xml
     * @summary Transforms a JSON-formatted string into roughly equivalent XML.
     * @description The transformation is in two steps, first to JS and then
     *     into simple XML where keys are element names and values are content
     *     text nodes.
     * @param {String} aString A JSON-formatted string.
     * @returns {Node} An XML node representing the same data structures found
     *     in the JSON string.
     */

    var data;

    //  the conversion to JS should be lossless, as is the conversion to
    //  XMLRPC for standard JS key/value data or array content

    data = TP.json2js(aString);

    if (TP.notEmpty(data)) {
        return TP.js2xml(data);
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$jsonObj2xml',
function(anObject, rootName) {

    /**
     * @method $jsonObj2xml
     * @summary Converts a ("plain") JavaScript object that was produced
     *     directly from parsing JSON into an XML representation.
     * @description This method is used by TIBET internal machinery to produce a
     *     specific XML format for use with JSONPaths. Therefore, it is not
     *     intended to be a general purpose transformation for JavaScript -> XML
     *     data. Use the public TP.json2xml() method for that purpose.
     * @param {Object} anObject The object to transform.
     * @param {String} rootName The name of the root tag. This defaults to
     *     'root'.
     * @returns {Node} An XML node representing the same data structures found
     *     in the Object, using to a very specific, purpose-built algorithm for
     *     TIBET's JSONPath support.
     */

    var jsonObjAsXMLStr,

        dataRoot,
        rootKeys,

        name,

        str,
        doc,

        result;

    jsonObjAsXMLStr = function(obj, aSlotName) {

        //  NB: We use native JS language constructs in this Function for
        //  performance reasons.

        var slotName,

            theType,
            i,
            keys;

        if (!TP.regex.XML_NAMEREF.match(aSlotName)) {
            TP.ifWarn() ?
                TP.warn('Stripping invalid XML name in JSON conversion: ' +
                aSlotName) : 0;
            return;
        }

        slotName = aSlotName;

        //  If the slot name contains colons (':'), replace them with '__'.
        //  Otherwise, we'll have XML names that won't resolve because of
        //  'namespaces'.
        if (TP.regex.HAS_COLON.test(slotName)) {
            slotName = slotName.replace(/:/g, '__');
        }

        theType = typeof obj;

        switch (theType) {

            case 'undefined':
                str += '<' + slotName + ' type="' + theType + '">' +
                        'undefined' +
                        '</' + slotName + '>';
                break;

            case 'boolean':
            case 'number':
            case 'string':

                str += '<' + slotName + ' type="' + theType + '">' +
                        TP.xmlLiteralsToEntities(obj.toString()) +
                        '</' + slotName + '>';
                break;

            case 'object':

                if (obj === null) {
                    str += '<' + slotName + ' type="null">' +
                            'null' +
                            '</' + slotName + '>';
                } else {
                    switch (true) {
                        case obj instanceof Date:
                            str += '<' + slotName + ' type="date">' +
                                    obj.toISOString() +
                                    '</' + slotName + '>';
                            break;

                        case obj instanceof Array:

                            str += '<' + slotName + ' type="array">';
                            for (i = 0; i < obj.length; i++) {
                                jsonObjAsXMLStr(obj[i], slotName);
                            }
                            str += '</' + slotName + '>';
                            break;

                        default:

                            keys = TP.objectGetKeys(obj);
                            str += '<' + slotName + ' type="object">';
                            for (i = 0; i < keys.length; i++) {
                                if (TP.regex.PRIVATE_OR_INTERNAL_SLOT.test(
                                                                    keys[i])) {
                                    continue;
                                }

                                jsonObjAsXMLStr(obj[keys[i]], keys[i]);
                            }
                            str += '</' + slotName + '>';
                            break;
                    }
                }
                break;

            default:
                break;
        }
    };

    name = TP.ifInvalid(rootName, 'root');

    dataRoot = anObject;

    //  If the object has more than 1 key, then put it in another object with a
    //  single slot keyed under the root name. This is because the translation
    //  machinery cannot handle multi-keyed objects - it needs a 'rooted'
    //  object.
    rootKeys = TP.objectGetKeys(anObject);
    if (rootKeys.getSize() > 1) {
        dataRoot = {};
        dataRoot[name] = anObject;
    }

    //  Build a String, starting at the root object. This function, defined
    //  above, recursively calls itself to build out the entire structure.
    str = '';
    jsonObjAsXMLStr(dataRoot, name);

    //  Try to turn that a real XML DOM.
    doc = new DOMParser().parseFromString(str, 'application/xml');

    if (TP.isXMLDocument(doc) &&
        TP.notValid(doc.getElementsByTagName('parsererror')[0])) {

        //  If we a real result, then we either use the documentElement's
        //  firstChild or, if there are multiple children under the
        //  documentElement, then the documentElement itself.
        result = TP.doc();
        if (doc.documentElement.childNodes.length > 0) {
            result.appendChild(doc.documentElement.firstChild);
        } else {
            result.appendChild(doc.documentElement);
        }

        return result;
    } else {
        TP.ifWarn() ?
            TP.warn('Unable to convert JSON to XML for: ' + str) : 0;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('xml2json',
function(aNode) {

    /**
     * @method xml2json
     * @summary Transforms an XML node into a roughly equivalent JSON string.
     * @description If the XML is in XMLRPC format this transformation is very
     *     close to lossless, otherwise the node is processed according to the
     *     rules found in XForms which focus on non-empty element nodes and
     *     their text content.
     * @param {Node} aNode An XML node.
     * @returns {String} A JavaScript String containing the JSON data.
     */

    var data;

    data = TP.xml2js(aNode);

    if (TP.notEmpty(data)) {
        return TP.js2json(data);
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('$xml2jsonObj',
function(aNode) {

    /**
     * @method $xml2jsonObj
     * @summary Converts an XML representation into a ("plain") JavaScript
     *     object that can directly produce 'clean' JSON.
     * @description This method is used by TIBET internal machinery to produce a
     *     JavaScript object from a specific XML format used with TIBET's
     *     implementation of JSONPaths (it is the inverse of the
     *     'TP.$jsonObj2xml' method). Therefore, it is not intended to be a
     *     general purpose transformation for XML -> JavaScript data. Use the
     *     public TP.xml2json() method for that purpose.
     * @param {Node} aNode An XML node.
     * @returns {Object} A JavaScript Object representing the same data
     *     structures found in the XML, using to a very specific, purpose-built
     *     algorithm for TIBET's JSONPath support.
     */

    var xmlNodeAsJSONObj,

        node,

        root;

    xmlNodeAsJSONObj = function(anElement, parentObj) {

        var elemName,

            newObj,
            i,

            currentChild,

            itemObj,
            children,

            key;

        elemName = anElement.nodeName;

        //  If any of the element names have '__', it's because they contained
        //  colons (':') and we needed to convert them in the $jsonObj2xml
        //  method. Convert them back here.
        if (/__/.test(elemName)) {
            elemName = elemName.replace(/__/g, ':');
        }

        switch (anElement.getAttribute('type')) {

            case 'null':

                parentObj[elemName] = null;
                break;

            case 'undefined':

                parentObj[elemName] = undefined;
                break;

            case 'boolean':

                /* eslint-disable no-extra-parens */
                parentObj[elemName] = (anElement.textContent === 'true');
                /* eslint-enable no-extra-parens */
                break;

            case 'number':

                parentObj[elemName] = parseFloat(anElement.textContent);
                break;

            case 'string':

                parentObj[elemName] = anElement.textContent;
                break;

            case 'date':

                parentObj[elemName] = Date.parse(anElement.textContent);
                break;

            case 'array':

                newObj = [];

                itemObj = {};

                if (!(children = anElement.children)) {
                    children = TP.nodeGetChildElements(anElement);
                }

                for (i = 0; i < children.length; i++) {

                    currentChild = children[i];

                    xmlNodeAsJSONObj(currentChild, itemObj);
                    key = TP.objectGetKeys(itemObj)[0];

                    newObj.push(itemObj[key]);
                    itemObj[key] = null;
                }

                parentObj[elemName] = newObj;
                break;

            case 'object':

                newObj = {};

                if (!(children = anElement.children)) {
                    children = TP.nodeGetChildElements(anElement);
                }

                for (i = 0; i < children.length; i++) {

                    currentChild = children[i];

                    xmlNodeAsJSONObj(currentChild, newObj);
                }

                parentObj[elemName] = newObj;
                break;

            default:
                break;
        }
    };

    //  If we got back a Text node, just return it's node value - we must've
    //  been translating a scalar value.
    if (TP.isTextNode(aNode)) {
        return aNode.nodeValue;
    } else if (TP.isDocument(node = aNode)) {
        node = aNode.documentElement;
    }

    root = {};

    xmlNodeAsJSONObj(node, root);

    return root;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('xmlStringGetUndefinedPrefixes',
function(aString) {

    /**
     * @method xmlStringGetUndefinedPrefixes
     * @summary Returns an Array of XML namespace prefixes that occur in the
     *     supplied String, but are currently undefined in TIBET.
     * @param {String} aString The XML string content to find undefined
     *     namespace prefixes in.
     * @returns {String[]} An Array of undefined XML (either element or
     *     attribute level) prefixes in the supplied String.
     */

    var elemResults,
        attrResults,

        allResults;

    //  Extract all of the element prefixes from the supplied String. Note that
    //  they will all contain a leading less than ('<') and a trailing colon
    //  (':').
    TP.regex.ALL_ELEM_PREFIXES.lastIndex = 0;
    elemResults = TP.regex.ALL_ELEM_PREFIXES.match(aString);

    if (TP.isArray(elemResults)) {
        //  We're only interested in one occurrence per prefix.
        elemResults.unique();

        //  Strip off the leading less than and trailing colon from each one.
        elemResults = elemResults.collect(
                        function(aPrefix) {
                            //  Slice off the '<' and ':'
                            return aPrefix.slice(1, -1);
                        });
    } else {
        elemResults = TP.ac();
    }

    //  Extract all of the attribute prefixes from the supplied String. Note
    //  that they will all contain a colon (':') followed by the attribute name
    //  and an equals ('=') that we don't care about.
    TP.regex.ALL_ATTR_PREFIXES.lastIndex = 0;
    attrResults = TP.regex.ALL_ATTR_PREFIXES.match(aString);

    if (TP.isArray(attrResults)) {
        //  We're only interested in one occurrence per prefix.
        attrResults.unique();

        //  Strip off the leading less than and trailing colon from each one.
        attrResults = attrResults.collect(
                        function(aPrefix) {
                            //  Slice off from the index ':'
                            return aPrefix.slice(0, aPrefix.indexOf(':'));
                        });
    } else {
        attrResults = TP.ac();
    }

    allResults = elemResults.concat(attrResults);

    //  Filter the results to only those that do *not* have a definition in our
    //  common namespace URI dictionary.
    allResults = allResults.filter(
                    function(aPrefix) {
                        return TP.notValid(TP.w3.Xmlns.getNSURIForPrefix(aPrefix)) &&
                                TP.notValid(TP.boot.$uriSchemes[aPrefix]);
                    });

    return allResults.unique();
});

//  ------------------------------------------------------------------------
//  XML-RPC support
//  ------------------------------------------------------------------------

TP.definePrimitive('js2xmlrpc',
function(anObject) {

    /**
     * @method js2xmlrpc
     * @summary Transforms a JavaScript object into roughly equivalent XMLRPC
     *     node.
     * @param {Object} anObject The object to transform.
     * @returns {Node} An XMLRPC node representing the same data structures
     *     found in the Object.
     */

    if (TP.notValid(anObject)) {
        return;
    }

    //  window and self
    if (TP.isWindow(anObject)) {
        return;
    }

    //  the special TP.core.Browser instance
    if (anObject === TP.core.Browser) {
        return;
    }

    //  at the moment we don't process html docs into xmlrpc
    if (TP.isHTMLDocument(anObject)) {
        return;
    }

    //  for now we skip turning types into xmlrpc
    if (TP.isType(anObject)) {
        return;
    }

    //  defer to object itself whenever possible
    if (TP.canInvoke(anObject, 'asTP_dom_XMLRPCNode')) {
        return anObject.asTP_dom_XMLRPCNode();
    }

    return TP.dom.XMLRPCNode.from(anObject);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('json2xmlrpc',
function(aString) {

    /**
     * @method json2xmlrpc
     * @summary Transforms a JSON-formatted string into roughly equivalent XML.
     * @description The transformation is in two steps, first to JS and then
     *     into simple XML where keys are element names and values are content
     *     text nodes.
     * @param {String} aString A JSON-formatted string.
     * @returns {Node} An XML node representing the same data structures found
     *     in the JSON string. XMLRPC format is used since its a common exchange
     *     format in TIBET and the source format for a number of built in XSLT
     *     transformations.
     */

    //  the conversion to JS should be lossless, as is the conversion to
    //  XMLRPC for standard JS key/value data or array content
    return TP.js2xmlrpc(TP.json2js(aString));
});

//  ------------------------------------------------------------------------
//  Download support
//  ------------------------------------------------------------------------

TP.definePrimitive('documentDownloadContent',
function(aDocument, content, filename) {

    /**
     * @method documentDownloadContent
     * @summary Downloads the supplied content to the user's local file system.
     * @description This mechanism generates a link to an internally-generated
     *     URL which points to an encoded version of the supplied content and
     *     then activates that link via a synthetic 'click' event.
     * @param {Document} aDocument The document that the download link element
     *     will be generated into (and removed from when complete).
     * @param {String} content The content to download.
     * @param {String} filename The filename to make the downloaded data
     *     available under.
     */

    var win,

        blob,
        url,

        anchorElem,
        evt;

    if (!TP.isDocument(aDocument)) {
        return;
    }

    if (TP.isEmpty(content) || TP.isEmpty(filename)) {
        return;
    }

    //  Grab the Window of the supplied document.
    win = TP.nodeGetWindow(aDocument);

    //  Create a new Blob object with the supplied content, encoding it as
    //  'octet/stream'.
    blob = new Blob(TP.ac(content), {type: 'octet/stream'});

    //  Create a URL and put the blob in there as the URL's resource.
    url = win.URL.createObjectURL(blob);

    //  Create a new anchor and set various attributes on it to allow us to
    //  treat it as a 'download' link.
    anchorElem = TP.documentConstructElement(aDocument, 'a', TP.w3.Xmlns.XHTML);

    //  NB: These properties must be set directly for this approach to work. We
    //  cannot use TP.elementSetAttribute here.
    anchorElem.href = url;
    anchorElem.download = filename;

    //  Append the anchor to the document's body. This will allow us to activate
    //  it.
    TP.nodeAppendChild(TP.documentGetBody(aDocument), anchorElem, false);

    //  Create a 'click' Event and dispatch it against the anchor. This will
    //  activate the anchor and begin the download process.
    evt = TP.documentConstructEvent(aDocument, TP.hc('type', 'click'));
    anchorElem.dispatchEvent(evt);

    //  We're done with it - detach it from it's parent node.
    TP.nodeDetach(anchorElem);

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('documentDownloadURL',
function(aDocument, aURL) {

    /**
     * @method documentDownloadURL
     * @summary Downloads the content pointed to by the supplied URL (which
     *     should exist on the same-origin server) to the user's local file
     *     system.
     * @description This mechanism generates a link to the supplied URL which
     *     and then activates that link via a synthetic 'click' event.
     * @param {Document} aDocument The document that the download link element
     *     will be generated into (and removed from when complete).
     * @param {String} aURL The server URL to download.
     */

    var anchorElem,
        evt;

    if (!TP.isDocument(aDocument)) {
        return;
    }

    if (TP.isEmpty(aURL)) {
        return;
    }

    //  Create a new anchor and set various attributes on it to allow us to
    //  treat it as a 'download' link.
    anchorElem = TP.documentConstructElement(aDocument, 'a', TP.w3.Xmlns.XHTML);

    //  NB: These properties must be set directly for this approach to work. We
    //  cannot use TP.elementSetAttribute here.
    anchorElem.href = aURL;

    //  Append the anchor to the document's body. This will allow us to activate
    //  it.
    TP.nodeAppendChild(TP.documentGetBody(aDocument), anchorElem, false);

    //  Create a 'click' Event and dispatch it against the anchor. This will
    //  activate the anchor and begin the download process.
    evt = TP.documentConstructEvent(aDocument, TP.hc('type', 'click'));
    anchorElem.dispatchEvent(evt);

    //  We're done with it - detach it from it's parent node.
    TP.nodeDetach(anchorElem);

    return;
});

//  ------------------------------------------------------------------------
//  JSONP call support
//  ------------------------------------------------------------------------

TP.definePrimitive('jsonpCall',
function(aURI, aCallback, aCallbackFuncName, aCallbackParamName, aDocument,
         shouldRaise) {

    /**
     * @method jsonpCall
     * @summary Uses the JSON-associated mechanism of creating a dynamic script
     *     node to access the data at the target URI, then cleans up the script
     *     node to avoid clutter. The resulting data can be found on the
     *     document provided. If no document is provided then the document of
     *     the TIBET frame is used.
     *
     *
     * @description !!!USE THIS CALL ONLY WITH SITES YOU CAN EXPLICITLY TRUST!!!
     *
     *     The code in script files referenced in this fashion is run
     *     automatically by the browser without any checking for cross-domain
     *     security. Yes, people use this _hack_ as a way to load data without
     *     running into cross-domain security notifications supported by
     *     XMLHttpRequest -- at their PERIL.
     *
     *     Yes, it has been reported as a security bug, but since a) it's
     *     supported by all major browsers and b) it's leveraged by Google et.
     *     al. for shoving ads at you (which means $$$), no, it won't be fixed
     *     in our lifetime.
     *
     *     How does it work? The script is run as if it were found in the
     *     "local domain" of the browser, i.e. the domain that the browser
     *     thinks loaded the script with this (TP.jsonpCall) function in it. No
     *     checks are performed, the script is simply run the moment it arrives
     *     in the browser (provided that it was served with a MIME type of
     *     text/javascript).
     *
     *     BE PARTICULARLY CAREFUL when launching code supporting this feature
     *     from the file system since this means the browser's local domain is
     *     your local machine. So, if the script you load decides to read your
     *     hard disk, or write to it, or do anything else JS will let it do,
     *     there's nothing to stop it.
     *
     *     TIBET does try to take one precaution around this call - the call is
     *     made inside of another iframe and then the results are 'washed
     *     through' a serialize / parse cycle to at least protect against
     *     malformed JSON data.
     * @param {String} aURI The URI string referencing the desired JavaScript
     *     file.
     * @param {Function} aCallback An optional callback function to be invoked
     *     when the JSON results have loaded. The JSON result object is passed
     *     as the only parameter to this function. This follows the 'JSONP'
     *     model.
     * @param {String} aCallbackFuncName The optional name of the callback
     *     function that will be called from the result data.
     * @param {String} aCallbackParamName The optional name of the 'callback'
     *     parameter generated into the GET url for the JSON call. Both Google
     *     and Yahoo use the name 'callback', which is what this parameter
     *     defaults to.
     * @param {Document} aDocument The document to use for loading the script,
     *     which allows you to control which context the code runs in. By
     *     default, an iframe will be created to load the 'script' (i.e. data).
     * @param {Boolean} shouldRaise Whether or not an invalid JSONP call or
     *     invalid results should raise a TIBET exception. The default is true.
     * @returns {Node} The script node used, after being removed from the
     *     document.
     */

    var contextDoc,
        contextElem,
        contextWin,

        paramName,

        callback,
        callbackID,
        url,

        elem,
        head;

    //  if a context document is not supplied, create an iframe and hand
    //  that back. This keeps JSON data safely away from TIBET until we can
    //  let the JSON parser take care of it.
    if (!TP.isDocument(contextDoc = aDocument)) {
        contextElem = TP.getJSONPIFrame();
        contextDoc = TP.elementGetIFrameDocument(contextElem);
    }

    //  can only do this properly with an HTML document since we'll be
    //  loading a script element that needs HTML-specific processing
    if (!TP.isHTMLDocument(contextDoc)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  Grab the context window
    contextWin = TP.nodeGetWindow(contextDoc);

    //  get a callback hook ready
    callback = TP.isCallable(aCallback) ? aCallback : TP.RETURN_THIS;

    contextWin.onerror = function(msg, uri, line) {

        var errMsg;

        errMsg = TP.join('JSONP call error: ', msg, ' from: ', uri);

        if (TP.notFalse(shouldRaise)) {
            TP.raise(this, 'TP.sig.JSONException', errMsg);
            callback(errMsg);
        }

        //  Remove the callback Function to avoid littering things up. Note
        //  that we just set this to 'null' to avoid IE problems
        contextWin[callbackID] = null;
    };

    if (TP.notValid(callbackID = aCallbackFuncName)) {
        //  generate a unique ID for the actual callback. We'll invoke the
        //  supplied callback from there.
        callbackID = 'jsoncallback_' + TP.lid(callback).replace(/\$/g, '_');
    }

    //  Set a slot on the contextWin window object with the callbackID.
    //  This slot will be removed either inside of this call, or by a fork
    //  later if the supplied callback Function has an error.
    contextWin[callbackID] =
        function(resultObj) {

            var cleanResult;

            //  'Scrub' the JSON data by 'stringifying' it and turning
            //  that string back into JavaScript in the 'other document'
            cleanResult = TP.json2js(TP.js2json(resultObj));

            callback(cleanResult);

            //  Remove the callback Function to avoid littering things up.
            //  Note that we just set this to 'null' to avoid IE problems
            contextWin[callbackID] = null;
        };

    //  Build the 'script element' URL

    //  default the JSONP 'callback' parameter name to 'callback'
    paramName = TP.ifInvalid(aCallbackParamName, 'callback');

    //  get the string version of the URI, which will process TP.uri.URIs as
    //  needed so we're consistently working with a string URI
    url = aURI.asString();

    //  If the url already has parameters, then tack on an '&' and proceed.
    if (/\?/.test(url)) {
        url += '&';
    } else {
        //  Otherwise, tack on a '?' and proceed.
        url += '?';
    }

    url += paramName + '=' + callbackID;

    //  Create a script element using this document and adding a parameter
    //  on the end that contains the JSONP callback name and our callback
    //  function ID (which the caller will return).
    elem = TP.documentConstructScriptElement(
            contextDoc,
            url,
            function() {

                TP.nodeDetach(elem);

                //  Make sure the slot on the context windows is cleared
                //  after 1 second after this function is called (which is
                //  called after the callback function whose reference is
                //  embedded in the JSON).
                setTimeout(function() {

                    if (TP.isCallable(contextWin[callbackID])) {
                        //  Note that we just set this to 'null' to avoid IE
                        //  problems
                        contextWin[callbackID] = null;
                    }
                }, TP.sys.cfg('jsonp.delay'));
            });

    //  adding the elem to the 'head' will start the loading process
    try {
        //  Make sure that the target document has a valid 'head' element or
        //  we're going nowhere.
        head = TP.documentEnsureHeadElement(contextDoc);
        if (TP.isElement(head)) {
            //  Note reassignment since the elem we're adding might have
            //  come from another document.
            elem = TP.nodeAppendChild(head, elem, false);
        }
    } catch (e) {
        TP.raise(this, 'TP.sig.JSONException', TP.ec(e));
        callback(TP.join('JSONP call error: ', TP.str(e)));
    }

    return elem;
});

//  ========================================================================
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETImportExport.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

TP.sys.defineMethod('fetchScriptInto',
function(aURI, aDocument, aRequest, scriptElemAttrs) {

    /**
     * @method fetchScriptInfo
     * @summary Loads the uri provided (which should be a JavaScript uri) into
     *     the supplied document's context. Note that this call is done in a
     *     synchronous fashion, even though a callback function may be provided.
     * @param {TP.uri.URI|String} aURI A TP.uri.URI or String referencing the
     *     script location.
     * @param {Document} aDocument The document to add the script code to.
     * @param {TP.sig.Request|TP.core.Hash} [aRequest] A optional set of request
     *     parameters. The only meaningful one here is 'callback' which should
     *     point to a function to call on complete.
     * @param {TP.core.Hash} [scriptElemAttrs] A optional hash of attributes to
     *     put on generated script elements.
     * @returns {Promise} A promise which resolves based on success.
     */

    var url,
        request,

        callback,

        docHead,

        newPromise;

    url = TP.uc(aURI);
    if (TP.notValid(url)) {
        this.raise('TP.sig.InvalidURI');

        return TP.extern.Promise.reject(new Error('InvalidURI'));
    }

    //  Adjust the path per any rewrite rules in place for the URI. Note that we
    //  only do this if the url is absolute.
    if (TP.uriIsAbsolute(url.getLocation())) {
        url = url.rewrite();
    }

    request = TP.request(aRequest);
    TP.ifInfo() ? TP.info('Fetching script: ' +
                            TP.str(url) +
                            ' into: ' +
                            TP.gid(aDocument)) : 0;

    //  Grab any callback that was defined by the request
    callback = TP.ifKeyInvalid(request, 'callback', null);

    docHead = TP.documentEnsureHeadElement(aDocument);

    newPromise = TP.extern.Promise.construct(
        function(resolver, rejector) {
            var targetLoc,

                loadedCB,
                scriptElem,

                err;

            targetLoc = url.getLocation();

            loadedCB = function() {

                var req;

                //  Start by removing the 'onload' handler from our script
                //  element.
                scriptElem.removeEventListener('load', loadedCB, false);

                //  Activate any "awakening logic" specific to the script.
                req = TP.request();
                req.atPut('node', scriptElem);
                TP.html.script.tagAttachDOM(req);

                //  If the request provided a callback, then use it.
                if (TP.isCallable(callback)) {
                    callback(scriptElem);
                }

                //  Complete the request and resolve the Promise with the script
                //  element that the script is loaded into.

                request.complete(scriptElem);

                return resolver(scriptElem);
            };

            //  Construct an XHTML script element on the supplied document
            //  and will the target location.
            scriptElem = TP.documentConstructScriptElement(
                                    aDocument,
                                    targetLoc);

            //  Mark this element as one that was generated by TIBET and
            //  shouldn't be considered in CSS queries, etc.
            scriptElem[TP.GENERATED] = true;

            //  If additional script element attributes were supplied, then put
            //  them on the script element.
            if (TP.notEmpty(scriptElemAttrs)) {
                TP.elementSetAttributes(scriptElem, scriptElemAttrs, true);
            }

            //  Set our loaded callback as the 'onload' handler for the
            //  script element.
            scriptElem.addEventListener('load', loadedCB, false);

            if (TP.notValid(scriptElem) || TP.isError(scriptElem)) {
                err = new Error('Error fetching source URL: ' + targetLoc);
                request.fail(err);

                return rejector(err);
            }

            //  Append it into the document head - this will start the
            //  loading process.
            TP.nodeAppendChild(docHead, scriptElem, false);
        });

    return newPromise;
}, {
    dependencies: [TP.extern.Promise]
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getAllScriptPaths',
async function(packageConfig, phase, useCache) {

    /**
     * @method getAllScriptPaths
     * @summary Returns all script paths found in the supplied package and
     *     config.
     * @param {String} packageConfig The package name to locate and import along
     *     with an optional [@config] section. For example 'hello@base'.
     * @param {String} [phase] Optional phase specifier. Use TP.PHASE_ONE or
     *     TP.PHASE_TWO to set a specific phase. Default is both.
     * @param {Boolean} [useCache=true] Should packages containing the scripts
     *     use the boot system package cache. If false, the supplied package
     *     will be flushed from the cache and reloaded.
     * @returns {String[]} An Array of script paths in the supplied package and
     *     config.
     */

    var packageProfile,
        packageProfileParts,

        pkgName,
        cfgName,

        uri,

        packageParts,
        packageName,
        configName,

        packageAssets,
        packageScriptPaths,

        phaseOne,
        phaseTwo;

    //  Process the incoming package@config value.
    packageParts = packageConfig.split('@');
    packageName = packageParts.first();
    configName = packageParts.last();

    //  Default the packageName and configName to what can be extracted from the
    //  packaging profile.
    packageProfile = TP.sys.cfg('project.packaging.profile', 'main@base');
    packageProfileParts = packageProfile.split('@');

    pkgName = TP.ifEmpty(packageName, packageProfileParts.first());
    cfgName = TP.ifEmpty(configName, packageProfileParts.last());

    //  Normalize the incoming package name to produce a viable config file.
    uri = TP.uriExpandPath(pkgName);
    if (!TP.isURIString(uri)) {
        uri = TP.uriJoinPaths('~app_cfg', uri);
    }

    if (TP.isEmpty(TP.uriExtension(uri))) {
        uri += '.xml';
    }

    //  Get the full list of package script files. This defines the list of
    //  scripts the system will accept for importing.
    try {
        phaseOne = TP.sys.cfg('boot.phase_one');
        phaseTwo = TP.sys.cfg('boot.phase_two');

        TP.sys.setcfg('boot.phase_one',
            TP.isValid(phase) ? phase === TP.PHASE_ONE : true);
        TP.sys.setcfg('boot.phase_two',
            TP.isValid(phase) ? phase === TP.PHASE_TWO : true);
        packageAssets = await TP.boot.$listPackageAssets(
                                        uri, cfgName, null, useCache);
    } catch (e) {
        //  Could be an unloaded/unexpanded manifest...meaning we can't really
        //  tell what the script list is.
        return null;
    } finally {
        TP.sys.setcfg('boot.phase_one', phaseOne);
        TP.sys.setcfg('boot.phase_two', phaseTwo);
    }

    //  Normalize the list of scripts (and filter out any asset that doesn't
    //  have a 'src' - which means it's not a script).
    packageScriptPaths = packageAssets.map(
                            function(node) {
                                var tn,
                                    src;

                                tn = node.tagName.toLowerCase();
                                if (tn !== 'script') {
                                    return '';
                                }

                                src = node.getAttribute('src');
                                if (src) {
                                    return TP.boot.$getFullPath(node, src);
                                }

                                return '';
                            });

    //  Remove any empty paths
    TP.compact(packageScriptPaths, TP.isEmpty);

    return packageScriptPaths;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getAllPackagePaths',
async function(packageConfig, phase, useCache) {

    /**
     * @method getAllPackagePaths
     * @summary Returns all package paths found in the supplied package and
     *     config.
     * @param {String} packageConfig The package name to locate and import along
     *     with an optional [@config] section. For example 'hello@base'.
     * @param {String} [phase] Optional phase specifier. Use TP.PHASE_ONE or
     *     TP.PHASE_TWO to set a specific phase. Default is both.
     * @param {Boolean} [useCache=true] Should packages containing the scripts
     *     use the boot system package cache. If false, the supplied package
     *     will be flushed from the cache and reloaded.
     * @returns {String[]} An Array of package paths in the supplied package and
     *     config.
     */

    var packageProfile,
        packageProfileParts,

        packageParts,
        packageName,
        configName,

        pkgName,
        cfgName,

        uri,

        packageAssets,
        packagePackagePaths,

        phaseOne,
        phaseTwo;

    //  Process the incoming package@config value.
    packageParts = packageConfig.split('@');
    packageName = packageParts.first();
    configName = packageParts.last();

    //  Default the packageName and configName to what can be extracted from the
    //  packaging profile.
    packageProfile = TP.sys.cfg('project.packaging.profile', 'main@base');
    packageProfileParts = packageProfile.split('@');

    pkgName = TP.ifEmpty(packageName, packageProfileParts.first());
    cfgName = TP.ifEmpty(configName, packageProfileParts.last());

    //  Normalize the incoming package name to produce a viable config file.
    uri = TP.uriExpandPath(pkgName);
    if (!TP.isURIString(uri)) {
        uri = TP.uriJoinPaths('~app_cfg', uri);
    }

    if (TP.isEmpty(TP.uriExtension(uri))) {
        uri += '.xml';
    }

    //  Get the full list of package package files. This defines the list of
    //  packages the system will use for importing.
    try {
        phaseOne = TP.sys.cfg('boot.phase_one');
        phaseTwo = TP.sys.cfg('boot.phase_two');

        TP.sys.setcfg('boot.phase_one',
            TP.isValid(phase) ? phase === TP.PHASE_ONE : true);
        TP.sys.setcfg('boot.phase_two',
            TP.isValid(phase) ? phase === TP.PHASE_TWO : true);
        packageAssets = await TP.boot.$listPackageAssets(
                                        uri, cfgName, null, useCache, true);
    } catch (e) {
        //  Could be an unloaded/unexpanded manifest...meaning we can't really
        //  tell what the script list is.
        return null;
    } finally {
        TP.sys.setcfg('boot.phase_one', phaseOne);
        TP.sys.setcfg('boot.phase_two', phaseTwo);
    }

    //  Normalize the list of packages (and filter out any asset that doesn't
    //  have a 'src' - which means it's not a package).
    packagePackagePaths = packageAssets.map(
                            function(node) {
                                var tn,
                                    src;

                                tn = node.tagName.toLowerCase();
                                if (tn !== 'package') {
                                    return '';
                                }

                                src = node.getAttribute('src');
                                if (src) {
                                    return TP.boot.$getFullPath(node, src);
                                }

                                return '';
                            });

    //  Remove any empty paths
    TP.compact(packagePackagePaths, TP.isEmpty);

    return packagePackagePaths;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getUsedScriptPaths',
function() {

    /**
     * @method getUsedScriptPaths
     * @summary Returns a list of source file paths that are currently being
     *     used by the system. This is determined by looking at all of the
     *     methods that were invoked and their source paths.
     * @description This method requires the 'oo.$$track_invocations' flag to be
     *     true, otherwise there will be no data for this method to use for its
     *     computation and it return an empty hash.
     * @returns {String[]} An Array of script paths that are used in the
     *     currently running system.
     */

    var usedMethods,
        usedMethodPaths,

        expandedPaths;

    if (TP.isFalse(TP.sys.cfg('oo.$$track_invocations'))) {
        TP.ifError() ?
            TP.error('Attempt to retrieve used types when invocation' +
                        ' data isn\'t available.') : 0;
        return null;
    }

    //  Collect all of the paths of the used methods.
    usedMethods = TP.sys.getUsedMethods();

    //  Collect up all of their source paths.
    usedMethodPaths = usedMethods.collect(
                        function(kvPair) {

                            var methodPath;

                            methodPath = kvPair.last()[TP.SOURCE_PATH];
                            return methodPath;
                        });

    usedMethodPaths.unique();
    TP.compact(usedMethodPaths, TP.isEmpty);

    //  Expand all of the paths for consistency.
    expandedPaths = usedMethodPaths.collect(
                                function(aPath) {
                                    return TP.uriExpandPath(aPath);
                                });

    return expandedPaths;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getUsedPackagingInfo',
function() {

    /**
     * @method getUsedPackagingInfo
     * @summary Returns a hash that has two Arrays: one of packages of code that
     *     are used and can be represented by 'package' definitions and one of
     *     'extra' source file paths for code that is used but is outside of
     *     those packages.
     * @description This method requires the 'oo.$$track_invocations' flag to be
     *     true, otherwise there will be no data for this method to use for its
     *     computation and it returns an empty hash.
     * @returns {TP.core.Hash} A hash of two Arrays of paths to code used by the
     *     system - one for packages and one for 'extra' source files outside of
     *     those packages.
     */

    var usedMethods,
        entries,

        packageEntries,
        len,

        extraSourceEntries;

    if (TP.isFalse(TP.sys.cfg('oo.$$track_invocations'))) {
        TP.ifError() ?
            TP.error('Attempt to retrieve used types when invocation' +
                        ' data isn\'t available.') : 0;
        return null;
    }

    //  Get all of the used methods.
    usedMethods = TP.sys.getUsedMethods();

    entries = TP.ac();

    //  Iterate over all of the used method records and grab any dependencies
    //  that that method might be dependent on.
    usedMethods.perform(
        function(kvPair) {

            var methodObj;

            methodObj = kvPair.last();

            entries.push(methodObj.getDependencies());
        });

    entries = entries.flatten();

    //  Concatenate all of the dependency entries that were manually registered
    //  by the system. These are needed, for instance, for types that are used
    //  for custom tags, but no methods on them are ever invoked.
    entries = entries.concat(TP.sys.getManualDependencies());

    //  Unique the entries by their OID (which could either be an '$$oid' slot
    //  or their SOURCE_PATH).
    entries.unique();

    //  Sort the remaining entries by their load order.
    entries.sort(function(entryA, entryB) {
        return entryA[TP.LOAD_INDEX] - entryB[TP.LOAD_INDEX];
    });

    //  Collect up all of the entries that are 'whole package' entries.
    packageEntries = entries.select(
                            function(anEntry) {
                                return TP.isValid(anEntry.wholePackageInfo);
                            });

    len = packageEntries.getSize();

    //  Now, iterate over all of the entries and collect up all of the source
    //  paths for the objects that are *not* represented in one of the 'whole
    //  package entries'
    extraSourceEntries = TP.ac();
    entries.perform(
        function(anEntry) {
            var i,
                entry;

            if (TP.isString(anEntry)) {
                entry = TP.bySystemId(anEntry);
                if (TP.notValid(entry)) {
                    /* eslint-disable no-console */
                    console.error('Undefined object dependency ' + anEntry);
                    /* eslint-enable no-console */
                }
            } else {
                entry = anEntry;
            }

            //  If the entry is a 'whole package' entry, then just move to the
            //  next one.
            if (TP.isValid(entry.wholePackageInfo)) {
                return;
            }

            //  If there are no 'whole package' entries, then just add the
            //  source path of the entry and move on.
            if (len === 0) {
                extraSourceEntries.push(entry);
                return;
            }

            //  Otherwise, iterate over all of the 'whole package' entries. If
            //  both the TP.SOURCE_PACKAGE and the TP.SOURCE_CONFIG from the
            //  entry are also represented by one of the 'whole package'
            //  entries, then we do *not* add that source path to the list of
            //  source paths. It will be represented by the package.
            for (i = 0; i < len; i++) {
                /* eslint-disable brace-style */
                if (entry[TP.SOURCE_PACKAGE] ===
                        packageEntries.at(i)[TP.SOURCE_PACKAGE] &&
                    entry[TP.SOURCE_CONFIG] ===
                        packageEntries.at(i)[TP.SOURCE_CONFIG])
                {
                    return;
                }
                /* eslint-enable brace-style */
            }

            extraSourceEntries.push(entry);
        });

    //  Since all entries were sorted above, this should only remove duplicate
    //  entries with higher load order numbers than the first entry.
    extraSourceEntries.unique(
                    function(anEntry) {
                        return anEntry[TP.SOURCE_PATH];
                    });

    TP.compact(extraSourceEntries,
                function(anEntry) {
                    return TP.isEmpty(anEntry[TP.SOURCE_PATH]);
                });

    //  Expand the source path for consistency and assign that to the 'packaging
    //  representation'.
    extraSourceEntries.forEach(
                function(anEntry) {
                    anEntry[TP.PACKAGING_REP] =
                        TP.uriExpandPath(anEntry[TP.SOURCE_PATH]);
                });

    //  'Stringify' the package entries into the canonical TIBET format for
    //  them and assign that to the 'packaging representation'.
    packageEntries.forEach(
                function(aPackageEntry) {
                    aPackageEntry[TP.PACKAGING_REP] =
                        TP.uriExpandPath(aPackageEntry[TP.SOURCE_PACKAGE]) +
                            '@' +
                            aPackageEntry[TP.SOURCE_CONFIG];
                });

    return TP.hc('wholePackageEntries', packageEntries,
                    'extraSourceEntries', extraSourceEntries);
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getMissingPackagingInfo',
async function(packageConfig) {

    /**
     * @method getMissingPackagingInfo
     * @summary Returns a hash that has two Arrays: one of packages of code that
     *     are used and can be represented by 'package' definitions, but are
     *     missing from the supplied package/config combo and one of 'extra'
     *     source file paths for code that is used but is outside of those
     *     packages and are also missing from the supplied package/config combo.
     * @description This method requires the 'oo.$$track_invocations' flag to be
     *     true, otherwise there will be no data for this method to use for its
     *     computation and it returns an empty hash.
     * @param {String} packageConfig The package name to locate and import along
     *     with an optional [@config] section. For example 'hello@base'.
     * @returns {TP.core.Hash} A hash of two Arrays of paths to code used by the
     *     system - one for packages and one for 'extra' source files outside of
     *     those packages - but are missing from the supplied package/config
     *     combo.
     */

    var usedMethodInfo,
        usedMethodEntries,

        configScriptPaths,
        missingScriptEntries,

        filters,
        filteredScriptEntries,

        allPackagePaths,

        usedPackageEntries,
        missingPackageEntries,
        filteredPackageEntries;

    if (TP.isFalse(TP.sys.cfg('oo.$$track_invocations'))) {
        TP.ifError() ?
            TP.error('Attempt to retrieve used types when invocation' +
                        ' data isn\'t available.') : 0;
        return null;
    }

    //  Grab all of the scripts paths that are currently used by the system.
    //  This uses invocation data to determine which methods got invoked and
    //  then messages them for their source paths.
    usedMethodInfo = TP.sys.getUsedPackagingInfo();

    usedMethodEntries = usedMethodInfo.at('extraSourceEntries');

    //  Grab all of the script paths in the named packages and configs. This
    //  will be all of the paths that are contained in that package and config.
    configScriptPaths = await TP.sys.getAllScriptPaths(packageConfig);

    //  Compute the config script paths against our master list of expanded
    //  paths. This will produce a list of paths that the system knows about
    //  given the runtime information of used types and methods but isn't
    //  represented in the supplied package and config.
    missingScriptEntries = TP.ac();
    usedMethodEntries.forEach(
        function(anEntry) {
            var rep;

            rep = anEntry[TP.PACKAGING_REP];

            if (!configScriptPaths.contains(rep)) {
                missingScriptEntries.push(anEntry);
            }
        });

    //  Filter out script paths for developer tools, boot system, etc. using a
    //  predetermined list of RegExps.
    filters = TP.EXCLUDE_INVOCATION_TRACKED_PATHS;
    filteredScriptEntries = missingScriptEntries.filter(
                                function(anEntry) {

                                    var rep,

                                        filterPath,

                                        len,
                                        i;

                                    rep = anEntry[TP.PACKAGING_REP];

                                    filterPath = false;

                                    len = filters.getSize();
                                    for (i = 0; i < len; i++) {
                                        if (filters.at(i).test(rep)) {
                                            filterPath = true;
                                            break;
                                        }
                                    }

                                    return !filterPath;
                                });

    //  We obtain all reachable package paths from the named packages and
    //  configs.
    usedPackageEntries = usedMethodInfo.at('wholePackageEntries');

    //  We obtain all reachable package paths from the named packages and
    //  configs.
    allPackagePaths = await TP.sys.getAllPackagePaths(packageConfig);

    //  Compute all package paths against our list of used package paths. This
    //  will produce a list of paths that the system knows about given the
    //  runtime information of used types and methods but isn't represented in
    //  the supplied package and config.
    missingPackageEntries = TP.ac();
    usedPackageEntries.forEach(
        function(anEntry) {
            var rep;

            rep = TP.uriExpandPath(anEntry[TP.SOURCE_PATH]);

            if (!allPackagePaths.contains(rep)) {
                missingPackageEntries.push(anEntry);
            }
        });

    //  Filter out package paths for developer tools, boot system, etc. using a
    //  predetermined list of RegExps.
    filters = TP.EXCLUDE_INVOCATION_TRACKED_PACKAGES;

    filteredPackageEntries = missingPackageEntries.filter(
                        function(anEntry) {

                            var rep,

                                filterPath,

                                len,
                                i;

                            rep = anEntry[TP.PACKAGING_REP];

                            filterPath = false;

                            len = filters.getSize();
                            for (i = 0; i < len; i++) {
                                if (filters.at(i).test(rep)) {
                                    filterPath = true;
                                    break;
                                }
                            }

                            return !filterPath;
                        });

    //  Return a hash containing the two arrays that we computed.
    return TP.hc('packageEntries', filteredPackageEntries,
                    'scriptEntries', filteredScriptEntries);
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getMethodUsage',
function() {

    var results;

    results = [];

    TP.sys.$$meta_methods.perform(
            function(kvPair) {

                var methodKey,
                    methodBody,

                    methodEntry;

                methodKey = kvPair.first();
                methodBody = kvPair.last();

                methodEntry = {
                    name: methodKey,
                    invocationCount: methodBody.invocationCount,
                    loadPath: methodBody[TP.LOAD_PATH],
                    loadPackage: methodBody[TP.LOAD_PACKAGE],
                    loadConfig: methodBody[TP.LOAD_CONFIG],
                    loadStage: methodBody[TP.LOAD_STAGE],
                    loadIndex: methodBody[TP.LOAD_INDEX],
                    sourcePath: methodBody[TP.SOURCE_PATH],
                    sourcePackage: methodBody[TP.SOURCE_PACKAGE],
                    sourceConfig: methodBody[TP.SOURCE_CONFIG]
                };

                results.push(methodEntry);
            });

    return results;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('importPackage',
async function(packageConfig, useCache, shouldSignal) {

    /**
     * @method importPackage
     * @summary Imports a specific package/config file's script resources. Note
     *     that when dealing with rollups this also includes the package's
     *     rolled up resources in the form of TP.uc() content.
     * @param {String} packageConfig The package name to locate and import along
     *     with an optional [@config] section. For example 'hello@base'.
     * @param {Boolean} [useCache=true] Should packages containing the scripts
     *     use the boot system package cache. If false, the supplied package
     *     will be flushed from the cache and reloaded.
     * @param {Boolean} [shouldSignal=false] Should scripts signal Change once
     *     they've completed their import process?
     * @returns {Promise} A promise which resolves based on success.
     */

    var packageScriptPaths,
        loadedScripts,
        missingScripts,

        promise;

    packageScriptPaths = await TP.sys.getAllScriptPaths(
                                        packageConfig, null, useCache);
    if (TP.isNull(packageScriptPaths)) {
        //  Could be an unloaded/unexpanded manifest...meaning we can't really
        //  tell what the script list is. Trigger a failure.
        return TP.extern.Promise.reject();
    }

    //  Determine which scripts haven't already been loaded.
    loadedScripts = TP.boot.$$loadpaths;
    missingScripts = packageScriptPaths.difference(loadedScripts);

    //  We need to import all of the scripts, but do so in a synchronous
    //  fashion. Otherwise, all of the load paths, etc. will be messed up
    //  because they'll just be the values for the last file loaded.
    promise = TP.extern.Promise.each(
                missingScripts,
                function(path) {

                    //  NB: TP.sys.importScript returns a Promise.
                    return TP.sys.importScript(
                            path,
                            TP.request('callback', function() {
                                var url;

                                loadedScripts.push(path);

                                if (shouldSignal) {
                                    url = TP.uc(path);
                                    url.$changed();
                                }
                            }));
                });

    //  Return a promise that resolves if all imports worked, or rejects if any
    //  of them failed.
    return promise;
}, {
    dependencies: [TP.extern.Promise]
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('importScript',
function(aURI, aRequest) {

    /**
     * @method importScript
     * @summary Loads the uri provided (which should be a JavaScript uri),
     *     adding its code to the currently running application. Note that this
     *     call is done in a synchronous fashion, even though a callback
     *     function may be provided.
     * @param {TP.uri.URI|String} aURI A TP.uri.URI or String referencing the
     *     script location.
     * @param {TP.sig.Request|TP.core.Hash} [aRequest] A optional set of request
     *     parameters. The only meaningful one here is 'callback' which should
     *     point to a function to call on complete.
     * @returns {Promise} A promise which resolves based on success.
     */

    var url,
        request,

        callback,

        newPromise;

    url = TP.uc(aURI);
    if (TP.notValid(url)) {
        this.raise('TP.sig.InvalidURI');

        return TP.extern.Promise.reject(new Error('InvalidURI'));
    }

    //  Adjust the path per any rewrite rules in place for the URI. Note that we
    //  only do this if the url is absolute.
    if (TP.uriIsAbsolute(url.getLocation())) {
        url = url.rewrite();
    }

    request = TP.request(aRequest);
    TP.ifInfo() ? TP.info('Importing script URL: ' + TP.str(url)) : 0;

    //  Grab any callback that was defined by the request
    callback = TP.ifKeyInvalid(request, 'callback', null);

    newPromise = TP.extern.Promise.construct(
        function(resolver, rejector) {
            var targetLoc,

                loadedCB,
                scriptElem,

                err;

            targetLoc = url.getLocation();

            loadedCB = function() {

                var req;

                //  Activate any "awakening logic" specific to the script.
                req = TP.request();
                req.atPut('node', scriptElem);
                TP.html.script.tagAttachDOM(req);

                TP.signal(TP.sys,
                            'TP.sig.ScriptImported',
                            TP.hc('node', scriptElem));

                //  If the request provided a callback, then use it.
                if (TP.isCallable(callback)) {
                    callback(scriptElem);
                }

                //  Complete the request and resolve the Promise with the script
                //  element that the script is loaded into.

                request.complete(scriptElem);

                return resolver(scriptElem);
            };

            scriptElem = TP.boot.$sourceUrlImport(targetLoc, null, loadedCB);

            if (TP.notValid(scriptElem) || TP.isError(scriptElem)) {
                err = new Error('Error importing source URL: ' + targetLoc);
                request.fail(err);

                return rejector(err);
            }
        }).catch(
        function(err) {
            //  Make sure to fail our request in case it didn't get properly
            //  failed. If it's already completed this will be a no-op.
            if (TP.isValid(request)) {
                request.fail(err);
            }

            //  Be sure to throw here or invoking items like importPackage won't
            //  see the error, it's being caught here.
            if (TP.isValid(err)) {
                throw err;
            } else {
                throw new Error('ImportScriptError');
            }
        });

    return newPromise;
}, {
    dependencies: [TP.extern.Promise]
});

//  ----------------------------------------------------------------------------

TP.sys.defineMethod('importSourceText',
function(targetUrl) {

    /**
     * @method importSourceText
     * @summary Imports a target script's text *asynchronously* and then adds
     *     that script source as inlined script source text that integrates the
     *     *text* of that with the JS with the currently running "image".
     * @param {String} targetUrl URL of the target resource.
     * @exception TP.sig.InvalidURI Raised when a valid URI has not been
     *     supplied to the method.
     * @returns {Element} The script element that was created to contain the
     *     source.
     */

    var url,
        request;

    url = TP.uc(targetUrl);
    if (!TP.isURI(url)) {
        this.raise('TP.sig.InvalidURI');

        return TP.extern.Promise.reject(new Error('InvalidURI'));
    }

    //  Adjust the path per any rewrite rules in place for the URI. Note
    //  that we only do this if the url is absolute
    if (TP.uriIsAbsolute(url.getLocation())) {
        url = url.rewrite();
    }

    request = TP.request('async', true,
                            'refresh', true,
                            'resultType', TP.TEXT,
                            'signalChange', false);
    TP.ifInfo() ? TP.info('Importing script text from URL: ' + TP.str(url)) : 0;

    return url.getResource(request).then(
        function(result) {
            var targetLoc,

                scriptElem,
                req;

            targetLoc = url.getLocation();

            scriptElem = TP.boot.$sourceImport(result, null, targetLoc);
            if (TP.notValid(scriptElem) || TP.isError(scriptElem)) {
                throw new Error('Error importing source text: ' + targetLoc);
            }

            //  Activate any "awakening logic" specific to the script.
            req = TP.request();
            req.atPut('node', scriptElem);
            TP.html.script.tagAttachDOM(req);

            TP.signal(TP.sys,
                        'TP.sig.ScriptImported',
                        TP.hc('node', scriptElem));

            return scriptElem;

        }).catch(
        function(err) {
            //  Make sure to fail our request in case it didn't get properly
            //  failed. If it's already completed this will be a no-op.
            if (TP.isValid(request)) {
                request.fail(err);
            }

            //  Be sure to throw here or invoking items like importPackage won't
            //  see the error, it's being caught here.
            if (TP.isValid(err)) {
                throw err;
            } else {
                throw new Error('ImportSourceTextError');
            }
        });
}, {
    dependencies: [TP.extern.Promise]
});

//  ------------------------------------------------------------------------
//  Package Information
//  ------------------------------------------------------------------------

TP.sys.defineMethod('getPackageChainPaths',
function(aTypeName) {

    /**
     * @method getPackageChainPaths
     * @summary Returns a 'hierarchical' chain of paths (location urls and
     *     configs) that loaded the supplied type name, from the 'root' package
     *     that the app is currently loading all the way down to the package
     *     that had the script entry that contained the supplied type.
     * @param {String} aTypeName The type name to resolve to a type and list the
     *     package chain paths for.
     * @exception TP.sig.InvalidType Raised when a valid type cannot be resolved
     *     from the type name provided to the method.
     * @returns {String[]|null} A list of the chain of package paths that loaded
     *     the type of the supplied type name.
     */

    var type,

        leafPackage,

        packageChainPaths;

    type = TP.sys.getTypeByName(aTypeName);

    if (!TP.isType(type)) {
        this.raise('TP.sig.InvalidType');
        return null;
    }

    //  Grab the package that the actual script entry that loaded the type was a
    //  part of.
    leafPackage = type[TP.LOAD_PACKAGE];
    if (TP.notEmpty(leafPackage)) {
        //  Grab the set of 'package paths' all the way from the 'root' down
        //  that loaded the type.
        packageChainPaths = TP.boot.$$packages[leafPackage].PACKAGE_CHAIN_PATHS;
    }

    if (TP.notValid(packageChainPaths)) {
        return TP.ac();
    }

    return packageChainPaths;
});

//  ------------------------------------------------------------------------
//  Synchronous Loading
//  ------------------------------------------------------------------------

TP.sys.defineMethod('require',
function(aTypeName) {

    /**
     * @method require
     * @summary Imports a type by name. If the type is already loaded the
     *     current type is returned unless shouldReload is set to true.
     * @param {String} aTypeName The type name to locate and import as needed.
     * @returns {TP.lang.RootObject} A Type object.
     */

    //  TODO:   formerly we'd check metadata for information on where to find a
    //  particular type and then we'd load that script. Until we add support for
    //  defer and type lists on manifest nodes we'll just stub as a replacement
    //  for getTypeByName.

    return TP.sys.getTypeByName(aTypeName);
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETPrimitivesShortcuts.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
While we'd like to use polymorphic interfaces for everything (ie. just
messaging whatever value we might have) the browser environment doesn't
allow that -- too many issues arise around the fact that null/undefined
aren't objects, ActiveX controls show up now and again, etc. As a result
it's necessary to have a way to leverage OO while avoiding the fact that
you can't be sure a return value can respond to your query.

The functions here help encapsulate TIBET's common operations in the form
of easy-to-type functions with a $ prefix signifying a global function.
*/

//  ------------------------------------------------------------------------
//  SHORTCUT UTILITIES
//  ------------------------------------------------------------------------

TP.definePrimitive('context',
function(varargs) {

    /**
     * @method context
     * @summary Returns a useful context for constraining a search for one or
     *     more elements. This operation is used during the various TP.by*
     *     calls to try to optimize lookup times. Typical arguments include
     *     windows, documents, or elements which might be used to root a search.
     *     The first true element found is returned, followed by the best
     *     documentElement possible.
     * @param {arguments} varargs Zero or more valid objects or IDs to choose
     *     between.
     * @returns {Document|Element} The best search root.
     */

    var len,
        i,
        obj,
        doc,
        win,
        context;

    len = arguments.length;
    for (i = 0; i < len; i++) {
        obj = TP.unwrap(arguments[i]);
        if (TP.isString(obj)) {
            win = TP.sys.getWindowById(obj);
            if (TP.notValid(win)) {
                win = TP.sys.getWindowById(obj, TP.sys.getUICanvas(true));
            }

            if (TP.isWindow(win)) {
                doc = TP.doc(win);
                if (TP.isDocument(doc)) {
                    return doc;
                }
            }
        } else if (TP.isElement(obj)) {
            return obj;
        } else if (TP.isTextNode(obj) ||
                    TP.isCDATASectionNode(obj) ||
                    TP.isCommentNode(obj)) {
            return obj.parentNode;
        } else if (TP.isNode(obj) || TP.isWindow(obj)) {
            doc = TP.doc(obj);
            if (TP.isDocument(doc)) {
                return doc;
            }
        }
    }

    if (TP.notValid(context)) {
        context = TP.isWindow(win) ? win :
            TP.sys.getWindowById(TP.sys.getUICanvasName());
    }

    //  don't want windows as search roots, only documents or elements
    if (TP.isWindow(context)) {
        context = context.document;
    }

    return context;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('idcall',
function(aMethodName, elemOrId, nodeContext, varargs) {

    /**
     * @method idcall
     * @summary Messages the element in question, if possible. The element is
     *     acquired and wrapped, and then the resulting wrapper's method is
     *     invoked if possible, otherwise the method is attempted on the
     *     unwrapped element directly.
     * @param {String} aMethodName The name of a method on the TP object (i.e.
     *     'nodeGetElementsByTagName');.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @param {arguments} varargs Optional additional arguments to pass to the
     *     method.
     * @returns {Object} The results of the method invocation, or an array of
     *     such results.
     */

    var obj,

        elem,
        arglist,
        arr,
        len,
        i,
        item,
        wrapper;

    if (TP.notValid(elemOrId)) {
        obj = TP.sys.getWindowById(TP.sys.getUICanvasName());
    } else {
        obj = elemOrId;
    }

    //  use a combination of element and context to find the focal
    //  element(s) for the call
    elem = TP.isString(obj) ?
                TP.byId(obj, TP.context(nodeContext), false) :
                TP.elem(obj);

    arglist = TP.args(arguments, 3);

    if (TP.isArray(elem)) {
        arr = TP.ac();
        len = elem.getSize();

        for (i = 0; i < len; i++) {
            item = elem.at(i);

            if (TP.isElement(item)) {
                wrapper = TP.wrap(item);

                if (TP.canInvoke(wrapper, aMethodName)) {
                    arr.push(wrapper[aMethodName].apply(wrapper, arglist));
                } else if (TP.canInvoke(item, aMethodName)) {
                    arr.push(item[aMethodName].apply(item, arglist));
                }
            }
        }

        return arr;
    } else if (TP.isElement(elem)) {
        wrapper = TP.wrap(elem);

        if (TP.canInvoke(wrapper, aMethodName)) {
            return wrapper[aMethodName].apply(wrapper, arglist);
        } else if (TP.canInvoke(item, aMethodName)) {
            return item[aMethodName].apply(item, arglist);
        }
    }

    return elem;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('tpcall',
function(aMethodName, elemOrId, nodeContext, varargs) {

    /**
     * @method tpcall
     * @summary A common wrapper for calling a TP primitive with an optional
     *     root element, an optional canvas context, and one or more optional
     *     arguments to forward to the method being invoked.
     * @param {String} aMethodName The name of a method on the TP object (i.e.
     *     'nodeGetElementsByTagName');.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @param {arguments} varargs Optional additional arguments to pass to the
     *     method.
     * @returns {Object} The results of the method invocation, or an array of
     *     such results.
     */

    var obj,

        elem,
        arglist,
        arr,
        len,
        i,
        item;

    if (TP.notValid(elemOrId)) {
        obj = TP.sys.getWindowById(TP.sys.getUICanvasName());
    } else {
        obj = elemOrId;
    }

    //  use a combination of element and context to find the focal
    //  element(s) for the call
    elem = TP.isString(obj) ?
                TP.byId(obj, TP.context(nodeContext), false) :
                TP.elem(obj);

    arglist = TP.args(arguments, 3);
    arglist.unshift(null);              //  make room on front for item

    if (TP.isArray(elem)) {
        arr = TP.ac();
        len = elem.getSize();

        for (i = 0; i < len; i++) {
            item = elem.at(i);

            if (TP.isElement(item)) {
                if (TP.canInvoke(TP, aMethodName)) {
                    arglist[0] = item;
                    arr.push(TP[aMethodName].apply(TP, arglist));
                } else {
                    //  not a TP primitive apparently
                    break;
                }
            }
        }

        return arr;
    } else if (TP.isValid(elem)) {
        arglist[0] = elem;

        return TP[aMethodName].apply(TP, arglist);
    }

    return elem;
});

//  ------------------------------------------------------------------------
//  QUERY SHORTCUTS
//  ------------------------------------------------------------------------

TP.definePrimitive('byContent',
function(textOrRegExp, nodeContext, autoCollapse) {

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.definePrimitive('byCSSPath',
function(cssExpr, nodeContext, autoCollapse, shouldWrap) {

    /**
     * @method byCSSPath
     * @summary Returns the result of running a TP.nodeEvaluateCSS() call using
     *     the context provided, or the current window's document.
     * @param {String} cssExpr The CSS expression to use for the query.
     * @param {Object} nodeContext A context in which to resolve the CSS
     *     query.
     *     Default is the current canvas.
     * @param {Boolean} [autoCollapse=false] Whether to collapse Array results
     *     if there's only one item in them.
     * @param {Boolean} [shouldWrap=true] Whether or not the results should
     *     wrapped into a TIBET wrapper object.
     * @exception TP.sig.InvalidString
     * @returns {TP.dom.ElementNode|Element|Array<Element,TP.dom.ElementNode>}
     *     The Array of matched wrapped elements or unwrapped elements or a
     *     single wrapped or unwrapped element if single-item Arrays are being
     *     collapsed.
     */

    var node;

    if (TP.notValid(cssExpr)) {
        return TP.raise(TP.byCSSPath, 'TP.sig.InvalidString',
                        'Empty CSS expression not allowed.');
    }

    node = TP.context(nodeContext);

    if (TP.isFalse(shouldWrap)) {
        return TP.nodeEvaluateCSS(node, cssExpr, autoCollapse);
    }

    return TP.wrap(TP.nodeEvaluateCSS(node, cssExpr, autoCollapse));
});

//  ------------------------------------------------------------------------

TP.definePrimitive('byId',
function(anID, nodeContext, shouldWrap) {

    /**
     * @method byId
     * @summary Returns the result of running a TP.nodeGetElementById() call
     *     using the context provided, or the current window's document.
     * @param {String} anID The ID to search for.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @param {Boolean} [shouldWrap=true] Whether or not the results should
     *     wrapped into a TIBET wrapper object.
     * @exception TP.sig.InvalidID
     * @returns {TP.dom.ElementNode|Element|Array<Element,TP.dom.ElementNode}
     *     The wrapped element, unwrapped element, if found, or an array when
     *     more than one ID was provided.
     */

    var id,
        node,

        list,
        len,

        arr,
        i;

    if (TP.notValid(anID)) {
        return TP.raise(TP.byId, 'TP.sig.InvalidID',
                                                'Empty ID not allowed.');
    }

    if (TP.isNode(anID)) {
        return anID;
    }

    if (TP.isWindow(anID)) {
        return anID.document;
    }

    if (TP.isNodeList(anID)) {
        if (TP.isArray(anID)) {
            return anID;
        }

        return TP.ac(anID);
    }

    if (TP.regex.HAS_PERIOD.test(anID)) {
        TP.raise(TP.byId, 'TP.sig.InvalidID', 'Path-style IDs not allowed.');
        return;
    }

    id = TP.str(anID);
    node = TP.context(nodeContext);
    if (TP.notValid(node)) {
        node = TP.sys.getUICanvas();
    }

    //  allow either string or array as ID definition, but turn into an
    //  array of 1 or more IDs to locate
    list = TP.isString(id) ? id.split(' ') : id;
    len = list.getSize();

    if (len > 1) {
        arr = TP.ac();
        for (i = 0; i < len; i++) {
            if (TP.isFalse(shouldWrap)) {
                arr.atPut(i, TP.nodeGetElementById(node, list.at(i), true));
            } else {
                arr.atPut(i, TP.wrap(
                                TP.nodeGetElementById(node, list.at(i), true)));
            }
        }

        //  remove nulls for any IDs not found and hook contents
        return arr.compact();
    } else {
        //  NOTE we force XPath usage when not found and XML
        if (TP.isFalse(shouldWrap)) {
            return TP.nodeGetElementById(node, id, true);
        } else {
            return TP.wrap(TP.nodeGetElementById(node, id, true));
        }
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('bySystemId',
function(anID, nodeContext) {

    /**
     * @method bySystemId
     * @summary A convenience wrapper for the TP.sys.getObjectById() call.
     *     NOTE: unlike the other TP.by* calls this function begins its search
     *     with the TIBET object registry and proceeds to check the UI
     *     canvas/context only after registrations and other sources have been
     *     tested. Use TP.byId() if you are focused on the UI only.
     * @param {String|String[]} anID The ID to search for. NOTE: one advantage
     *     of this call is that the ID can be either a String or an Array. In
     *     String form a space-separated list becomes an array.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {TP.lang.Object[]} An array of TP.lang.Objects sharing the name
     *     provided.
     */

    var id,
        context,

        list,
        len,

        arr,
        i;

    id = TP.str(anID);
    context = TP.context(nodeContext);
    if (TP.notValid(context)) {
        context = TP.sys.getUICanvas();
    }

    list = TP.isString(id) ? id.split(' ') : id;
    len = list.getSize();

    if (len > 1) {
        arr = TP.ac();
        for (i = 0; i < len; i++) {
            arr.atPut(i, TP.sys.getObjectById(list.at(i), false, context));
        }

        //  remove nulls from the result set
        return arr.compact();
    } else {
        return TP.sys.getObjectById(id, false, context);
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('byPath',
function(pathExpr, nodeContext, autoCollapse, shouldWrap) {

    /**
     * @method byPath
     * @summary Returns the result of running a TP.nodeEvaluatePath() call
     *     using the context provided, or the current window's document.
     * @param {String} pathExpr The path expression to use for the query.
     * @param {Object} nodeContext A context in which to resolve the path
     *     query.
     *     Default is the current canvas.
     * @param {Boolean} [autoCollapse=false] Whether to collapse Array results
     *     if there's only one item in them.
     * @param {Boolean} [shouldWrap=true] Whether or not the results should
     *     wrapped into a TIBET wrapper object.
     * @exception TP.sig.InvalidString
     * @returns {TP.dom.ElementNode|Element|Array<Element,TP.dom.ElementNode>}
     *     The Array of matched wrapped elements or unwrapped elements or a
     *     single wrapped or unwrapped element if single-item Arrays are being
     *     collapsed.
     */

    var node;

    if (TP.notValid(pathExpr)) {
        return TP.raise(TP.byPath, 'TP.sig.InvalidString',
                        'Empty path expression not allowed.');
    }

    node = TP.context(nodeContext);

    if (TP.isFalse(shouldWrap)) {
        return TP.nodeEvaluatePath(node, pathExpr, null, autoCollapse);
    }

    return TP.wrap(TP.nodeEvaluatePath(node, pathExpr, null, autoCollapse));
});

//  ------------------------------------------------------------------------
//  ATTRIBUTE SHORTCUTS
//  ------------------------------------------------------------------------

TP.definePrimitive('addAttr',
function(elemOrId, attrName, attrValue, checkAttrNSURI, nodeContext) {

    /**
     * @method addAttr
     * @summary A convenience wrapper for TP.elementAddAttributeValue. The
     *     element definition is resolved via TP.byId(). The resulting
     *     element(s) are then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String} attrName The attribute name value to find, with optional
     *     NS: prefix.
     * @param {String} attrValue The attribute value to add.
     * @param {Boolean} [checkAttrNSURI=false] True will cause this method to be
     *     more rigorous in its checks for prefixed attributes, looking via
     *     internal TIBET mechanisms in addition to the standard platform
     *     mechanism. The default is false (to keep things faster).
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     */

    return TP.tpcall(
                'elementAddAttributeValue',
                elemOrId, nodeContext, attrName, attrValue, checkAttrNSURI);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('getAttr',
function(elemOrId, attrName, checkAttrNSURI, nodeContext) {

    /**
     * @method getAttr
     * @summary A convenience wrapper for TP.elementGetAttribute. The element
     *     definition is resolved via TP.byId(). The resulting element(s) are
     *     then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String} attrName The attribute name value to find, with optional
     *     NS: prefix.
     * @param {Boolean} [checkAttrNSURI=false] True will cause this method to be
     *     more rigorous in its checks for prefixed attributes, looking via
     *     internal TIBET mechanisms in addition to the standard platform
     *     mechanism. The default is false (to keep things faster).
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {String} The attribute value, if found or null if the element
     *     couldn't be obtained.
     */

    return TP.tpcall('elementGetAttribute',
                        elemOrId, nodeContext, attrName, checkAttrNSURI);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('hasAttr',
function(elemOrId, attrName, checkAttrNSURI, nodeContext) {

    /**
     * @method hasAttr
     * @summary A convenience wrapper for TP.elementHasAttribute. The element
     *     definition is resolved via TP.byId(). The resulting element(s) are
     *     then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String} attrName The attribute name value to find, with optional
     *     NS: prefix.
     * @param {Boolean} [checkAttrNSURI=false] True will cause this method to be
     *     more rigorous in its checks for prefixed attributes, looking via
     *     internal TIBET mechanisms in addition to the standard platform
     *     mechanism. The default is false (to keep things faster).
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Boolean} True if the attribute exists.
     */

    return TP.tpcall('elementHasAttribute',
                        elemOrId, nodeContext, attrName, checkAttrNSURI);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('removeAttr',
function(elemOrId, attrName, checkAttrNSURI, nodeContext) {

    /**
     * @method removeAttr
     * @summary A convenience wrapper for TP.elementRemoveAttribute. The
     *     element definition is resolved via TP.byId(). The resulting
     *     element(s) are then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String} attrName The attribute name value to remove, with
     *     optional NS: prefix.
     * @param {Boolean} [checkAttrNSURI=false] True will cause this method to be
     *     more rigorous in its checks for prefixed attributes, looking via
     *     internal TIBET mechanisms in addition to the standard platform
     *     mechanism. The default is false (to keep things faster).
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     */

    return TP.tpcall('elementRemoveAttribute',
                        elemOrId, nodeContext, attrName, checkAttrNSURI);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('replaceAttr',
function(elemOrId, attrName, oldValue, newValue, checkAttrNSURI, nodeContext) {

    /**
     * @method replaceAttr
     * @summary A convenience wrapper for TP.elementReplaceAttributeValue. The
     *     element definition is resolved via TP.byId(). The resulting
     *     element(s) are then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String} attrName The attribute name value to set, with optional
     *     NS: prefix.
     * @param {String} oldValue The attribute value to find.
     * @param {String} newValue The attribute value to set.
     * @param {Boolean} [checkAttrNSURI=false] True will cause this method to be
     *     more rigorous in its checks for prefixed attributes, looking via
     *     internal TIBET mechanisms in addition to the standard platform
     *     mechanism. The default is false (to keep things faster).
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     */

    return TP.tpcall(
        'elementReplaceAttributeValue',
        elemOrId, nodeContext, attrName, oldValue, newValue, checkAttrNSURI);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('setAttr',
function(elemOrId, attrName, attrValue, checkAttrNSURI, nodeContext) {

    /**
     * @method setAttr
     * @summary A convenience wrapper for TP.elementSetAttribute. The element
     *     definition is resolved via TP.byId(). The resulting element(s) are
     *     then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String} attrName The attribute name value to set, with optional
     *     NS: prefix.
     * @param {String} attrValue The attribute value to set.
     * @param {Boolean} [checkAttrNSURI=false] True will cause this method to be
     *     more rigorous in its checks for prefixed attributes, looking via
     *     internal TIBET mechanisms in addition to the standard platform
     *     mechanism. The default is false (to keep things faster).
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     */

    return TP.tpcall(
                'elementSetAttribute',
                elemOrId, nodeContext, attrName, attrValue, checkAttrNSURI);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('toggleAttr',
function(elemOrId, attrName, nodeContext) {

    /**
     * @method toggleAttr
     * @summary A convenience wrapper which will toggle a Boolean attribute,
     *     meaning that if the attribute is currently set to 'true' it will be
     *     toggled to 'false' and vice versa. If the attribute is not present
     *     the value is considered to be 'false' and a new attribute is added
     *     with a value of 'true'. The element definition is resolved via
     *     TP.byId(). The resulting element(s) are then used as roots for the
     *     operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String} attrName The attribute name value to set, with optional
     *     NS: prefix.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     */

    var value;

    value = TP.bc(TP.getAttr(elemOrId, nodeContext, attrName));

    if (value) {
        return TP.tpcall('elementSetAttribute',
                            elemOrId, nodeContext, attrName, 'false');
    } else {
        return TP.tpcall('elementSetAttribute',
                            elemOrId, nodeContext, attrName, 'true');
    }
});

//  ------------------------------------------------------------------------
//  CLASS SHORTCUTS
//  ------------------------------------------------------------------------

TP.definePrimitive('addClass',
function(elemOrId, className, nodeContext) {

    /**
     * @method addClass
     * @summary A convenience wrapper for TP.elementAddClass. The element
     *     definition is resolved via TP.byId(). The resulting element(s) are
     *     then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String} className The class value to add.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    return TP.tpcall('elementAddClass',
                        elemOrId, nodeContext, className);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('getClass',
function(elemOrId, nodeContext) {

    /**
     * @method getClass
     * @summary A convenience wrapper for TP.elementGetClass. The element
     *     definition is resolved via TP.byId(). The resulting element(s) are
     *     then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {String} An potentially space-separated string of class names.
     */

    return TP.tpcall('elementGetClass',
                        elemOrId, nodeContext);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('hasClass',
function(elemOrId, className, nodeContext) {

    /**
     * @method hasClass
     * @summary A convenience wrapper for TP.elementHasClass. The element
     *     definition is resolved via TP.byId(). The resulting element(s) are
     *     then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String} className The class value to check.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Boolean} True if the element has the named class.
     */

    return TP.tpcall('elementHasClass',
                        elemOrId, nodeContext, className);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('removeClass',
function(elemOrId, className, nodeContext) {

    /**
     * @method removeClass
     * @summary A convenience wrapper for TP.elementRemoveClass. The element
     *     definition is resolved via TP.byId(). The resulting element(s) are
     *     then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String} className The class value to remove.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    return TP.tpcall('elementRemoveClass',
                        elemOrId, nodeContext, className);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('replaceClass',
function(elemOrId, oldClass, newClass, nodeContext) {

    /**
     * @method replaceClass
     * @summary A convenience wrapper for TP.elementReplaceClass. The element
     *     definition is resolved via TP.byId(). The resulting element(s) are
     *     then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String} oldClass The class value to find.
     * @param {String} newClass The class value to set.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    return TP.tpcall('elementReplaceClass',
                        elemOrId, nodeContext, oldClass, newClass);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('setClass',
function(elemOrId, className, nodeContext) {

    /**
     * @method setClass
     * @summary A convenience wrapper for TP.elementSetClass. The element
     *     definition is resolved via TP.byId(). The resulting element(s) are
     *     then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String} className The class value to set.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    return TP.tpcall('elementSetClass',
                        elemOrId, nodeContext, className);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('toggleClass',
function(elemOrId, className, nodeContext) {

    /**
     * @method toggleClass
     * @summary A convenience wrapper which will toggle a class, meaning that
     *     if the class is present it is removed, and if it's not present it
     *     will be added. The element definition is resolved via TP.byId(). The
     *     resulting element(s) are then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String} className The class value to toggle.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    if (TP.hasClass(elemOrId, nodeContext, className)) {
        return TP.tpcall('elementRemoveClass',
                            elemOrId, nodeContext, className);
    } else {
        return TP.tpcall('elementAddClass',
                            elemOrId, nodeContext, className);
    }
});

//  ------------------------------------------------------------------------
//  CONTENT SHORTCUTS
//  ------------------------------------------------------------------------

TP.definePrimitive('addContent',
function(elemOrId, newContent, aRequest, nodeContext) {

    /**
     * @method addContent
     * @summary A convenience wrapper for TP.dom.Node's addContent call. The
     *     element definition is resolved via TP.byId(). The resulting
     *     element(s) are then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {Object} newContent A new content string, node, or other suitable
     *     content.
     * @param {TP.sig.Request} aRequest A request containing control parameters.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    return TP.idcall('addContent',
                        elemOrId, nodeContext, newContent, aRequest);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('getContent',
function(elemOrId, nodeContext) {

    /**
     * @method getContent
     * @summary A convenience wrapper for TP.dom.Node's getContent call. The
     *     element definition is resolved via TP.byId(). The resulting
     *     element(s) are then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    return TP.idcall('getContent', elemOrId, nodeContext);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('insertContent',
function(elemOrId, newContent, aLocation, aRequest, nodeContext) {

    /**
     * @method insertContent
     * @summary A convenience wrapper for TP.dom.Node's insertContent call.
     *     The element definition is resolved via TP.byId(). The resulting
     *     element(s) are then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {Object} newContent A new content string, node, or other suitable
     *     content.
     * @param {String} aLocation A TP location constant such as:
     *     TP.BEFORE_BEGIN, TP.AFTER_BEGIN, TP.AFTER_END, or TP.BEFORE_END (the
     *     default).
     * @param {TP.sig.Request} aRequest A request containing control parameters.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    return TP.idcall('insertContent',
                    elemOrId, nodeContext, newContent, aLocation, aRequest);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('removeContent',
function(elemOrId, nodeContext) {

    /**
     * @method removeContent
     * @summary A convenience wrapper for TP.dom.CollectionNode's empty call.
     *     The element definition is resolved via TP.byId(). The resulting
     *     element(s) are then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    return TP.idcall('empty', elemOrId, nodeContext);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('setContent',
function(elemOrId, newContent, aRequest, nodeContext) {

    /**
     * @method setContent
     * @summary A convenience wrapper for TP.dom.Node's setContent call. The
     *     element definition is resolved via TP.byId(). The resulting
     *     element(s) are then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {Object} newContent A new content string, node, or other suitable
     *     content.
     * @param {TP.sig.Request} aRequest A request containing control parameters.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    return TP.idcall('setContent',
                        elemOrId, nodeContext, newContent, aRequest);
});

//  ------------------------------------------------------------------------
//  ELEMENT SHORTCUTS
//  ------------------------------------------------------------------------

TP.definePrimitive('removeElem',
function(elemOrId, nodeContext) {

    /**
     * @method removeElem
     * @summary Removes an element from the DOM. This method operates by
     *     locating the element's parentNode and asking it to remove the child.
     *     The element definition is resolved via TP.byId(). The resulting
     *     element(s) are then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    var elem,
        len,
        i,
        ancestor;

    elem = TP.byId(elemOrId, TP.context(nodeContext));

    if (TP.isArray(elem)) {
        len = elem.length;
        for (i = 0; i < len; i++) {
            ancestor = elem[i].parentNode;
            if (TP.isElement(ancestor)) {
                return TP.nodeRemoveChild(ancestor, elem[i]);
            }
        }
    } else {
        ancestor = elem.parentNode;
        if (TP.isElement(ancestor)) {
            return TP.nodeRemoveChild(ancestor, elem);
        }
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('replaceElem',
function(oldElemOrId, newElemOrId, nodeContext) {

    /**
     * @method replaceElem
     * @summary Removes an element from the DOM. This method operates by
     *     locating the element's parentNode and asking it to remove the child.
     *     The element definition is resolved via TP.byId(). The resulting
     *     element(s) are then used as roots for the operation.
     * @param {String|Element} oldElemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String|Element} newElemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    var elem,
        newelem,

        len,
        i;

    elem = TP.byId(oldElemOrId, TP.context(nodeContext), false);
    newelem = TP.byId(newElemOrId, TP.context(nodeContext), false);

    if (TP.isArray(newelem)) {
        return TP.raise(this, 'TP.sig.InvalidParameter',
                            'New element must be single ID or element');
    }

    if (TP.isArray(elem)) {
        len = elem.length;
        for (i = 0; i < len; i++) {
            return TP.elementReplaceWith(
                                elem[i], TP.nodeCloneNode(newelem));
        }
    } else {
        return TP.elementReplaceWith(elem, newelem);
    }
});

//  ------------------------------------------------------------------------
//  STYLE STRING SHORTCUTS
//  ------------------------------------------------------------------------

/**
 * @NOTE NOTE NOTE:
 *
 *     Manipulating the style property directly using these methods is STRONGLY
 *     DISCOURAGED except during animation or effect processing. For "permanent"
 *     alterations to an element's style you should be leveraging a CSS id,
 *     classor attribute selector and manipulating the element's class/attribute
 *     values.
 *
 *     ALSO, if you are going to animate or alter an element's style you may
 *     wantto wrap your calls in a $preserveStyle/$restoreStyle pair so any
 *     valueswhich might have existed are reset on completion.
 */

//  ------------------------------------------------------------------------

TP.definePrimitive('addStyle',
function(elemOrId, aProperty, aValue, nodeContext) {

    /**
     * @method addStyle
     * @summary A convenience wrapper for TP.elementAddStyleValue. The element
     *     definition is resolved via TP.byId(). The resulting element(s) are
     *     then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String} aProperty The style property to modify.
     * @param {String} aValue The property value to add.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    return TP.tpcall('elementAddStyleValue',
                        elemOrId, nodeContext, aProperty, aValue);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('getStyle',
function(elemOrId, aProperty, nodeContext) {

    /**
     * @method getStyle
     * @summary A convenience wrapper for TP.elementGetStyleString. The element
     *     definition is resolved via TP.byId(). The resulting element(s) are
     *     then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String} aProperty The style property to get. Default is empty,
     *     which returns the entire style string.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {String} A CSS style string.
     */

    return TP.tpcall('elementGetStyleString', elemOrId, nodeContext, aProperty);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('hasStyle',
function(elemOrId, aProperty, nodeContext) {

    /**
     * @method hasStyle
     * @summary A convenience wrapper for TP.elementHasStyleString. The element
     *     definition is resolved via TP.byId(). The resulting element(s) are
     *     then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String} aProperty The style property to get. Default is empty,
     *     which returns the entire style string.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Boolean} True if the element has inline style with the property
     *     name, or inline style.
     */

    return TP.tpcall('elementHasStyleString', elemOrId, nodeContext, aProperty);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('preserveStyle',
function(elemOrId, nodeContext) {

    /**
     * @method preserveStyle
     * @summary A convenience wrapper for TP.elementPreserveStyle. The element
     *     definition is resolved via TP.byId(). The resulting element(s) are
     *     then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    return TP.tpcall('elementPreserveStyle', elemOrId, nodeContext);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('removeStyle',
function(elemOrId, aProperty, nodeContext) {

    /**
     * @method removeStyle
     * @summary A convenience wrapper for TP.elementRemoveStyleValue. The
     *     element definition is resolved via TP.byId(). The resulting
     *     element(s) are then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String} aProperty The style property to remove.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    return TP.tpcall('elementRemoveStyleValue',
                        elemOrId, nodeContext, aProperty);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('replaceStyle',
function(elemOrId, aProperty, oldStyle, newStyle, nodeContext) {

    /**
     * @method replaceStyle
     * @summary A convenience wrapper for TP.elementReplaceStyleValue. The
     *     element definition is resolved via TP.byId(). The resulting
     *     element(s) are then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String} aProperty The style property to update.
     * @param {String} oldStyle The style value to find.
     * @param {String} newStyle The style value to set.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    return TP.tpcall('elementReplaceStyleValue',
                        elemOrId, nodeContext, aProperty, oldStyle, newStyle);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('restoreStyle',
function(elemOrId, nodeContext) {

    /**
     * @method restoreStyle
     * @summary A convenience wrapper for TP.elementRestoreStyle. The element
     *     definition is resolved via TP.byId(). The resulting element(s) are
     *     then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    return TP.tpcall('elementRestoreStyle', elemOrId, nodeContext);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('setStyle',
function(elemOrId, aProperty, aValue, nodeContext) {

    /**
     * @method setStyle
     * @summary A convenience wrapper for TP.elementSetStyleString. The element
     *     definition is resolved via TP.byId(). The resulting element(s) are
     *     then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String} aProperty The style property to update.
     * @param {String} aValue The style value to set.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    return TP.tpcall('elementSetStyleString',
                        elemOrId, nodeContext, aProperty, aValue);
});

//  ------------------------------------------------------------------------
//  EFFECTS
//  ------------------------------------------------------------------------

TP.definePrimitive('animate',
function(anElement, propertyName, animationParams, nodeContext) {

    /**
     * @method animate
     * @summary A convenience wrapper for invoking a
     *     TP.gui.CSSPropertyTransition. The element definition is resolved via
     *     TP.byId(). The resulting element(s) are then used as the targets of
     *     the transition.
     * @param {String|Element|Element[]} anElement An element specification, or
     *     element, suitable for TP.byId().
     * @param {String} propertyName The name of the property to transition.
     * @param {TP.core.Hash} animationParams A hash of parameters to use for the
     *     transition.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {TP.core.Job} The TP.core.Job object that is managing the
     *     transition.
     */

    var elems,

        animationJob;

    //  If its a String, then return an Element or an Array matching the one
    //  or more ids given in the String.
    if (TP.isString(anElement)) {
        //  If its a String, then it might be one or more element ids.
        elems = TP.byId(anElement, TP.context(nodeContext));
    } else {
        elems = anElement;
    }

    animationJob = TP.gui.CSSPropertyTransition.transition(
                                elems,
                                propertyName,
                                animationParams);

    return animationJob;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('effect',
function(anElement, effectName, effectParams, nodeContext) {

    /**
     * @method effect
     * @summary A convenience wrapper for invoking a subtype of TP.core.Effect.
     *     The element definition is resolved via TP.byId(). The resulting
     *     element(s) are then used as the targets of the effect.
     * @description The name of the effect type to use to run the supplied
     *     effect name is computed by taking the supplied effect name,
     *     capitalizing the first letter and then prefixing it with 'TP.core.'
     *     and suffixing it with 'Effect'. E.g. 'puff' becomes
     *     'TP.core.PuffEffect'.
     * @param {String|Element|Element[]} anElement An element specification, or
     *     element, suitable for TP.byId().
     * @param {String} effectName The name of the effect to use.
     * @param {TP.core.Hash} effectParams A hash of parameters to use for the
     *     effect.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {TP.core.Job} The TP.core.Job object that is managing the
     *     effect.
     */

    var effectTypeName,
        effectType,

        ctrlAndStepParams,
        ctrlParams,
        stepParams,

        computeFunction,

        newEffect,
        transitionJob,

        elems;

    //  The effect type name is computed by doing an initial caps to the
    //  supplied name and appending 'Effect'.
    effectTypeName = TP.makeStartUpper(effectName) + 'Effect';

    //  Make sure that we have a real type here.

    if (TP.notValid(effectType = effectTypeName.asType())) {
        //  Try again with the 'TP.core.' prefix.
        effectTypeName = 'TP.core.' + TP.makeStartUpper(effectName) + 'Effect';

        //  Still didn't find it? Bail out and raise an exception.
        if (TP.notValid(effectType = effectTypeName.asType())) {
            TP.raise(TP.effect, 'TP.sig.InvalidType',
                        effectTypeName);

            return;
        }
    }

    //  If a hash of effect parameters was supplied, we copy it (to leave
    //  the original pristine) for the control params and use selected
    //  values for the step parameters. Otherwise, we just create blank
    //  ones.
    if (TP.isValid(effectParams)) {
        ctrlAndStepParams = TP.core.Job.splitParams(effectParams);

        ctrlParams = ctrlAndStepParams.first();
        stepParams = ctrlAndStepParams.last();
    } else {
        ctrlParams = TP.hc();
        stepParams = TP.hc();
    }

    //  Make sure that, if a compute function was defined, we have a real
    //  Function object.

    if (TP.isCallable(computeFunction = ctrlParams.at('compute')) &&
        !TP.isCallable(computeFunction)) {
        //  Try to see if it can be looked up on the TP.core.Job object,
        //  since that's where compute functions are located.
        computeFunction = TP.core.Job[computeFunction];

        //  Still didn't find it? Bail out and raise an exception.
        if (!TP.isCallable(computeFunction)) {
            TP.raise(TP.effect, 'TP.sig.InvalidFunction',
                    ctrlParams.at('compute'));

            return;
        }

        ctrlParams.atPut('compute', computeFunction);
    }

    //  If its a String, then return an Element or an Array matching the one
    //  or more ids given in the String.
    if (TP.isString(anElement)) {
        elems = TP.byId(anElement, TP.context(nodeContext), false);
    } else {
        elems = anElement;
    }

    //  Make sure that we supply the element(s) to the stepParams.
    stepParams.atPut('target', elems);

    //  If its an Array, then we already have what we need. Otherwise, we
    //  assume its a single element and wrap it into an Array.
    if (!TP.isArray(elems)) {
        elems = TP.ac(elems);
    }

    //  Construct an instance of the effect. This will construct the job,
    //  but not run it.
    newEffect = effectType.construct(ctrlParams, stepParams);
    transitionJob = newEffect.get('transitionJob');

    //  Install a 'post' function that will clear any cached references to
    //  the job that we use in case it needs to be stopped early.
    transitionJob.set(
        'post',
        function(job, params) {

            /* eslint-disable no-unused-vars */

            var theElements,

                postFunc,

                dummyVal;

            //  Note here how we grab both the target elements and the
            //  property from the supplied job. This is to avoid closure
            //  problems with previous invocations of this method.
            if (TP.isEmpty(theElements = params.at('target'))) {
                return;
            }

            //  Run any existing 'post' function that was defined as
            //  part of our parameters.
            if (TP.isCallable(postFunc = ctrlParams.at('post'))) {
                postFunc(job, params);
            }

            //  NB: We assign to dummyVal below to ensure that the JS engine is
            //  forced to access (and assign) the value so that it can't
            //  optimize it away.

            if (TP.isArray(theElements)) {
                theElements.perform(
                    function(anElem) {

                        //  If the element already had a job running that
                        //  was associated with the same effect that we're
                        //  invoking, clear it.
                        if (TP.isValid(anElem['effect_' + effectName])) {
                            anElem['effect_' + effectName] = null;
                        }
                    });

                //  Make sure that any drawing that needed to 'flush' to the
                //  window does so.
                dummyVal = TP.documentGetBody(TP.nodeGetDocument(
                                    theElements.first())).offsetHeight;
            } else {
                //  If the element already had a job running that was
                //  associated with the same effect that we're invoking,
                //  clear it.
                if (TP.isValid(theElements['effect_' + effectName])) {
                    theElements['effect_' + effectName] = null;
                }

                //  Make sure that any drawing that needed to 'flush' to the
                //  window does so.
                dummyVal = TP.documentGetBody(TP.nodeGetDocument(
                                    theElements)).offsetHeight;
            }

            /* eslint-enable no-unused-vars */
        });

    //  Instrument the individual elements that we are touching with the
    //  job. These will allow the deactivation routine below to prematurely
    //  terminate the job if another TP.effect() call is called on the same
    //  element.

    elems.perform(
        function(anElem) {

            var prevJob,
                params,
                allElems,
                i;

            //  If the target element already had a job running that was
            //  animating that property, shut it down.

            //  If the element has a TP.core.Job registered under a slot
            //  named 'effect_' + the name of the effect and that
            //  TP.core.Job hasn't already finished (or been told to finish
            //  by 'shutting down' another element sharing the job), then we
            //  begin the process to shut down the job.
            if (TP.isValid(prevJob = anElem['effect_' + effectName]) &&
                !prevJob.didComplete()) {
                //  If the job has elements that it is animating and there
                //  is more than 1 element in that set, then we're not the
                //  only one, so we just remove ourself from the list of
                //  elements.
                if (TP.isValid(params = prevJob.$get('parameters')) &&
                    TP.isArray(allElems = params.at('target')) &&
                    allElems.length > 1) {
                    for (i = 0; i < allElems.length; i++) {
                        if (allElems[i] === anElem) {
                            //  Remove the element from the job's 'target'
                            //  Array so that this property is no longer
                            //  animated by that job.
                            allElems.splice(i, 1);
                            break;
                        }
                    }
                } else {
                    //  Otherwise, we're the only element left in the job so
                    //  we try to shut the job down as cleanly as possible.
                    prevJob.shutdown();
                }
            }

            //  Cache the new animation job on the element, so that it can
            //  be shutdown in the future if necessary.
            anElem['effect_' + effectName] = transitionJob;
        });

    //  Do the deed, supplying the step parameters.
    newEffect.start(stepParams);

    return transitionJob;
});

//  ------------------------------------------------------------------------
//  EVENTS
//  ------------------------------------------------------------------------

TP.definePrimitive('arm',
function(aNodeOrList, eventNames, aHandler, aPolicy, nodeContext) {

    /**
     * @method arm
     * @summary Arms a node or list of them with the event or events given.
     * @param {Node|String} aNodeOrList The node or list of nodes to arm with
     *     the event(s) specified. This can also be the TP.ANY constant,
     *     indicating that the event is to be observed coming from any node.
     * @param {String|String[]} eventNames The names or types of the events to
     *     arm the element with.
     * @param {Function} aHandler An (optional) parameter that defines a native
     *     handler to be used instead of sending the event into the TIBET
     *     signaling system.
     * @param {Function} aPolicy An (optional) parameter that defines the
     *     "firing" policy.
     * @param {Window} nodeContext An optional window to search for the
     *     element(s). If not provided then the TP.context() method is used to
     *     find one.
     */

    var target,
        context,
        signals,
        len,
        i,
        signal,
        type;

    if (TP.isEmpty(eventNames)) {
        TP.raise(this, 'TP.sig.InvalidParameter',
                'Must supply a Signal.');

        return;
    }

    target = TP.ifInvalid(aNodeOrList, TP.ANY);
    context = TP.context(nodeContext);

    /* eslint-disable no-nested-ternary */
    signals = / /.test(eventNames) ?
                eventNames.split(' ') :
                TP.isArray(eventNames) ?
                    eventNames :
                    TP.ac(eventNames);
    /* eslint-enable no-nested-ternary */

    len = signals.getSize();
    for (i = 0; i < len; i++) {
        signal = signals.at(i);
        if (TP.isString(signal)) {
            type = TP.sys.getTypeByName(signal);
        } else {
            type = signal;
        }

        if (TP.canInvoke(type, 'arm')) {
            type.arm(target, aHandler, aPolicy, context);
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('button',
function(anEvent) {

    /**
     * @method button
     * @summary Returns the button code for the supplied event, which is one of
     *     the following constants: TP.LEFT, TP.MIDDLE, or TP.RIGHT.
     * @param {Event} anEvent The event object to extract the button code from.
     * @returns {String} The button code extracted from the supplied Event
     *     object.
     */

    return TP.eventGetButton(anEvent);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('coord',
function(anObject, nodeContext) {

    /**
     * @method coord
     * @summary Returns the 'document-level' X and Y for the supplied event or
     *     element object.
     * @param {Event|String|} anObject An event object or an
     *     Element|TP.core.Hash| element specification, Array|TP.gui.Point or
     *     element, suitable for TP.byId() or a hash or point with 'x' and 'y'
     *     values or an array with an X 'value' in the first position and a Y
     *     value in the second.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Number[]} The X and Y as a point pair.
     */

    var elem;

    if (TP.isEvent(anObject)) {
        return TP.eventGetPageXY(anObject);
    }

    if (TP.isArray(anObject)) {
        return anObject;
    }

    if (TP.isHash(anObject) ||
        TP.isKindOf(anObject, TP.gui.Point)) {
        return TP.ac(anObject.at('x'), anObject.at('y'));
    }

    //  use a combination of element and context to find the focal
    //  element(s) for the call
    elem = TP.isString(anObject) ?
                TP.byId(anObject, TP.context(nodeContext), false) :
                TP.elem(anObject);

    if (TP.isElement(elem)) {
        return TP.elementGetPageXY(elem);
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('disarm',
function(aNodeOrList, eventNames, aHandler, nodeContext) {

    /**
     * @method disarm
     * @summary Disarms a node or list of them for the event or events.
     * @param {Node|String} aNodeOrList The node or list of nodes to disarm with
     *     the event(s) specified. This can also be the TP.ANY constant.
     * @param {String|String[]} eventNames The names or types of the events to
     *     disarm.
     * @param {Function} aHandler An (optional) parameter that defines a native
     *     handler to be used instead of sending the event into the TIBET
     *     signaling system.
     * @param {Window} nodeContext An optional window to search for the
     *     element(s).
     *     If not provided then the TP.context() method is used to fine one.
     */

    var target,
        context,
        signals,
        len,
        i,
        signal,
        type;

    if (TP.isEmpty(eventNames)) {
        TP.raise(this, 'TP.sig.InvalidParameter',
                'Must supply a Signal.');

        return;
    }

    target = TP.ifInvalid(aNodeOrList, TP.ANY);
    context = TP.context(nodeContext);

    /* eslint-disable no-nested-ternary */
    signals = / /.test(eventNames) ?
                eventNames.split(' ') :
                TP.isArray(eventNames) ?
                    eventNames :
                    TP.ac(eventNames);
    /* eslint-enable no-nested-ternary */

    len = signals.getSize();
    for (i = 0; i < len; i++) {
        signal = signals.at(i);
        if (TP.isString(signal)) {
            type = TP.sys.getTypeByName(signal);
        } else {
            type = signal;
        }

        if (TP.canInvoke(type, 'disarm')) {
            type.disarm(target, aHandler, context);
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('event',
function(anEvent) {

    /**
     * @method event
     * @summary Returns a normalized event, meaning a native event that has
     *     been instrumented to conform to the W3C standard and to have properly
     *     adjusted values for key, shift, alt, meta, etc.
     * @param {Event} anEvent The native event to normalize. Default is
     *     window.event so this can be called with an empty value on IE.
     * @returns {Event} The normalized native event.
     */

    return TP.eventNormalize(anEvent || window.event);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('eventGetDOMSignalName',
function(anEvent) {

    /**
     * @method eventGetDOMSignalName
     * @summary Returns the properly adjusted DOM signal name for the DOM. This
     *     should be correct provided that the event was acquired from a
     *     TP.sig.DOMKeySignal rather than prior to TP.core.Keyboard handling.
     * @param {Event} anEvent The event object to extract the signal name from.
     * @returns {String} The full signal name such as DOM_Shift_Enter_Up.
     */

    return TP.core.Keyboard.getDOMSignalName(anEvent);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('keyname',
function(anEvent) {

    /**
     * @method keyname
     * @summary Returns the properly adjusted key name for the event. This
     *     should be correct provided that the event was acquired from a
     *     DOMKeySignal rather than prior to TP.core.Keyboard handling.
     * @param {Event} anEvent The event object to extract the key name from.
     * @returns {String} The base key name, such as A, Escape, etc.
     */

    return TP.core.Keyboard.getVirtualKeyName(anEvent);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('wheel',
function(anEvent) {

    /**
     * @method wheel
     * @summary Returns the wheel delta value from the event provided. The
     *     event should have been either a DOMMouseScroll or mousewheel event
     *     depending on the platform in question.
     * @param {Event} anEvent The native mouse event.
     * @returns {Number} The delta. Positive is down, negative is up.
     */

    return TP.eventGetWheelDelta(anEvent);
});

//  ------------------------------------------------------------------------
//  CONTENT SHORTCUTS
//  ------------------------------------------------------------------------

TP.definePrimitive('compact',
function(anObject, aFilter) {

    /**
     * @method compact
     * @summary Returns a compacted version of the object. For arrays this
     *     removes nulls, for Strings it removes consecutive sequences of
     *     whitespace (and trims the string). Other objects may have their own
     *     approach to this, for example, a TP.core.Hash will remove keys whose
     *     values are undefined or null.
     * @param {Object} anObject The object to compact.
     * @param {Function} aFilter An optional filtering function which should
     *     return true for value which should be removed. The default function
     *     is TP.notValid().
     * @returns {Object} The compacted object, which may be a new object.
     */

    if (TP.canInvoke(anObject, 'compact')) {
        return anObject.compact(aFilter);
    }

    return anObject;
});

//  ------------------------------------------------------------------------
//  GETTER/SETTER SHORTCUTS
//  ------------------------------------------------------------------------

TP.definePrimitive('elemget',
function(elemOrId, anAspect, nodeContext) {

    /**
     * @method elemget
     * @summary Returns the element(s) response to a get(anAspect), or a direct
     *     property access when necessary. The aspect defaults to 'value', so
     *     TP.elemget(id) is essentially equivalent to TP.val(TP.byId(id)), but
     *     TP.elemget() supports lists of objects. The element definition is
     *     resolved via TP.byId(). The resulting element(s) are then used as
     *     roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String} anAspect The property to access. Default is 'value' so
     *     TP.elemGet(id) will return the 'value' of the element or elements
     *     TP.byId().
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Object} The object value(s).
     */

    var aspect,
        list,
        arr,
        len,
        i;

    aspect = anAspect || 'value';

    list = TP.byId(elemOrId, nodeContext, false);

    if (TP.isArray(list)) {
        arr = TP.ac();
        len = list.getSize();
        for (i = 0; i < len; i++) {
            //  TODO:   should we wrap the list.at(i) here?
            arr.push(TP.val(list.at(i), aspect));
        }

        return arr;
    } else {
        //  TODO:   should we wrap the list here?
        return TP.val(list, aspect);
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('elemset',
function(elemOrId, anAspect, aValue, nodeContext) {

    /**
     * @method elemset
     * @summary Sets the value of the element(s) anAspect slot to aValue. The
     *     element definition is resolved via TP.byId(). The resulting
     *     element(s) are then used as roots for the operation.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {String} anAspect The property name to be set, which defaults to
     *     'value'.
     * @param {Object} aValue A value suitable for the target. This is typically
     *     a string.
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Object} The element, or elements that were changed.
     */

    var aspect,
        list,
        len,
        i,
        obj;

    aspect = anAspect || 'value';

    list = TP.byId(elemOrId, nodeContext, false);
    if (TP.isArray(list)) {
        len = list.getSize();
        for (i = 0; i < len; i++) {
            obj = TP.wrap(list.at(i));

            if (TP.canInvoke(obj, 'set')) {
                obj.set(aspect, aValue);
            } else if (TP.canInvoke(obj, 'atPut')) {
                obj.atPut(aspect, aValue);
            } else if (!TP.isXMLNode(obj)) {
                try {
                    obj[aspect] = aValue;
                } catch (e) {
                    TP.ifError() ?
                        TP.error(
                            TP.ec(e, 'Unable to set element: ' + obj)) : 0;
                }
            } else {
                //  TODO:   warn?
                void 0;
            }
        }
    } else {
        list = TP.wrap(list);

        if (TP.canInvoke(list, 'set')) {
            list.set(aspect, aValue);
        } else if (TP.canInvoke(list, 'atPut')) {
            list.atPut(aspect, aValue);
        } else if (!TP.isXMLNode(list)) {
            try {
                list[aspect] = aValue;
            } catch (e) {
                TP.ifError() ?
                    TP.error(
                        TP.ec(e, 'Unable to obtain element: ' + list)) : 0;
            }
        } else {
            //  TODO:   warn?
            void 0;
        }
    }

    return list;
});

//  ------------------------------------------------------------------------
//  ELEMENT "BUILT-IN" SHORTCUTS
//  ------------------------------------------------------------------------

/*
Native form elements often support one or more methods such as focus, reset,
and select. Convenience wrappers for dealing with these are provided here.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('focus',
function(elemOrId, nodeContext) {

    /**
     * @method focus
     * @summary Focuses the element in question, if possible. The element is
     *     acquired and wrapped, and then the resulting wrapper's focus() method
     *     is invoked if possible, otherwise a focus is attempted on the
     *     unwrapped element directly.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    return TP.idcall('focus', elemOrId, nodeContext);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('reset',
function(elemOrId, nodeContext) {

    /**
     * @method reset
     * @summary Resets the element in question, if possible. The element is
     *     acquired and wrapped, and then the resulting wrapper's reset() method
     *     is invoked if possible, otherwise a reset is attempted on the
     *     unwrapped element directly.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    return TP.idcall('reset', elemOrId, nodeContext);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('select',
function(elemOrId, nodeContext) {

    /**
     * @method select
     * @summary Selects the element in question, if possible. The element is
     *     acquired and wrapped, and then the resulting wrapper's select()
     *     method is invoked if possible, otherwise a select is attempted on the
     *     unwrapped element directly.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    return TP.idcall('select', elemOrId, nodeContext);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('submit',
function(elemOrId, nodeContext) {

    /**
     * @method submit
     * @summary Submits the element in question, if possible. The element is
     *     acquired and wrapped, and then the resulting wrapper's submit()
     *     method is invoked if possible, otherwise a submit is attempted on the
     *     unwrapped element directly.
     * @param {String|Element} elemOrId An element specification, or element,
     *     suitable for TP.byId().
     * @param {Object} nodeContext A context in which to resolve element IDs.
     *     Default is the current canvas.
     * @returns {Element} The element.
     */

    return TP.idcall('submit', elemOrId, nodeContext);
});

//  ------------------------------------------------------------------------
//  REFLECTION BASE
//  ------------------------------------------------------------------------

TP.definePrimitive('dump',
function(anObject, depth, level) {

    /**
     * @method dump
     * @summary Returns the key/value pairs of the object formatted in a
     *     non-markup string.
     * @param {The} anObject object whose properties and simple dump/logging
     *     string should be returned.
     * @param {Number} [depth=1] The depth to dump the object to.
     * @returns {String} A simple logging string for the object.
     */

    var str,

        arr,
        len,
        i,
        $depth,
        $level,
        rules;

    str = '[' + TP.tname(anObject) + ' :: ';

    if (anObject === null) {
        str += 'null' + ']';
        return str;
    } else if (anObject === undefined) {
        str += 'undefined' + ']';
        return str;
    }

    //  XMLHttpRequest can have permission issues, so check early
    if (TP.isXHR(anObject)) {
        str += '(' + anObject.status + ' : ' + anObject.responseText + ')' + ']';
        return str;
    }

    //  native nodes are the next-most likely object being passed to this
    //  routine, so we'll try to build up a proper string here
    if (TP.isNode(anObject)) {
        str += TP.nodeAsString(anObject) + ']';
        return str;
    }

    //  got to check Errors next... they freak out if handed to TP.isString().
    if (TP.isError(anObject)) {
        str += TP.errorAsString(anObject) + ']';
        return str;
    }

    if (TP.isString(anObject)) {
        str += anObject + ']';
        return str;
    }

    if (!TP.isMutable(anObject)) {
        //  TODO:   does this really deal with all the special constants
        //  like NaN, Number.POSITIVE_INFINITY, etc.?
        str += TP.objectToString(anObject) + ']';
        return str;
    }

    //  The top-level Window has TIBET loaded into it, so it will respond to
    //  'asString' properly, but other iframes, etc. won't so we have to handle
    //  Windows in a special manner here.
    if (TP.isWindow(anObject)) {
        str += TP.windowAsString(anObject) + ']';
        return str;
    }

    //  Event objects
    if (TP.isEvent(anObject)) {
        str += TP.eventAsString(anObject) + ']';
        return str;
    }

    //  NodeList objects
    if (TP.isNodeList(anObject)) {
        arr = TP.ac();

        len = anObject.length;
        for (i = 0; i < len; i++) {
            arr.push(TP.str(anObject[i]));
        }

        str += '(' + arr.join(', ') + ')' + ']';
        return str;
    }

    //  NamedNodeMap objects
    if (TP.isNamedNodeMap(anObject)) {
        arr = TP.ac();

        len = anObject.length;
        for (i = 0; i < len; i++) {
            arr.push(TP.name(anObject.item(i)) + ': ' +
                         TP.val(anObject.item(i)));
        }

        str += '(' + arr.join(', ') + ')' + ']';
        return str;
    }

    //  Stylesheet objects
    if (TP.isStyleSheet(anObject)) {

        //  NB: Note how we do *not* expand imports here and we do *not* filter
        //  for CSSRule.STYLE_RULE types of rules.
        rules = TP.styleSheetGetStyleRules(anObject, false, false);

        arr = TP.ac();

        len = rules.length;
        for (i = 0; i < len; i++) {
            arr.push(rules[i].cssText);
        }
        str += '(' + arr.join(' ') + ')' + ']';
        return str;
    }

    //  Style rule objects
    if (TP.isStyleRule(anObject)) {
        str += anObject.cssText + ']';
        return str;
    }

    //  Style declaration objects
    if (TP.isStyleDeclaration(anObject)) {
        str += anObject.cssText + ']';
        return str;
    }

    if (TP.canInvoke(anObject, 'asDumpString')) {

        $depth = TP.ifInvalid(depth, 1);
        $level = TP.ifInvalid(level, 0);

        str = anObject.asDumpString($depth, $level);
        if (TP.regex.NATIVE_CODE.test(str)) {
            str = '[' + TP.tname(anObject) + ' :: ' + 'native code' + ']';
        }

        return str;
    }

    //  worst case we just produce our best source-code representation
    str += TP.boot.$stringify(anObject) + ']';

    return str;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('interface',
function(anObject, aFilter, aDiscriminator) {

    /**
     * @method interface
     * @summary Returns the interface of anObject, optionally filtered by the
     *     discriminator provided.
     * @param {Object} anObject The object to reflect upon.
     * @param {Object|String} aFilter An object containing getInterface filter
     *     properties or a name of one of the keys registered under
     *     TP.SLOT_FILTERS. The default is 'unique_methods'.
     * @param {String|RegExp} aDiscriminator A 'filter' function or a pattern
     *     used to filter the list of returned keys.
     * @returns {String[]} An array of filtered property keys.
     */

    var filter,

        arr,
        obj,

        attributesOnly,
        methodsOnly,

        includeHidden,

        dontTraverse,
        inheritedOnly,
        overriddenOnly,

        keys,

        proto;

    if (TP.notValid(anObject)) {
        return TP.ac();
    }

    if (TP.isString(aFilter)) {
        filter = TP.SLOT_FILTERS[aFilter];
    } else if (TP.notValid(aFilter)) {
        filter = TP.SLOT_FILTERS.unique_methods;
    } else {
        filter = aFilter;
    }

    if (TP.canInvoke(anObject, 'getInterface')) {
        arr = anObject.getInterface(filter);
    } else {

        if (TP.isValid(filter)) {

            attributesOnly = filter.attributes;
            methodsOnly = filter.methods;

            includeHidden = filter.hidden;

            dontTraverse = filter.scope === TP.INTRODUCED ||
                            filter.scope === TP.LOCAL;

            inheritedOnly = filter.scope === TP.INHERITED;
            overriddenOnly = filter.scope === TP.OVERRIDDEN;
        }

        arr = TP.ac();

        if (inheritedOnly || overriddenOnly) {
            obj = Object.getPrototypeOf(anObject);
        } else {
            obj = anObject;
        }

        /* eslint-disable no-loop-func */
        do {
            keys = TP.objectGetKeys(obj);

            //  We always filter by the INTERNAL_SLOT regex
            keys = keys.filter(
                    function(aKey) {
                        return !TP.regex.INTERNAL_SLOT.test(aKey);
                    });

            //  If we're not including hidden slots, then we also filter by
            //  the PRIVATE_SLOT regex
            if (!includeHidden) {
                keys = keys.filter(
                        function(aKey) {
                            return !TP.regex.PRIVATE_SLOT.test(aKey);
                        });
            }

            if (attributesOnly) {

                //  This filter for methods avoids touching the slot or its
                //  contents, but uses its property descriptor to test whether
                //  it contains a Function. This is necessary on some browsers
                //  because those slots can throw Errors if we try to touch
                //  them.
                keys = keys.filter(
                        function(testSlot) {
                            var desc;

                            desc = Object.getOwnPropertyDescriptor(
                                                            obj, testSlot);
                            if (!desc.value || TP.isCallable(desc.value)) {
                                return true;
                            }

                            return false;
                        });
            } else if (methodsOnly) {

                //  This filter for methods avoids touching the slot or its
                //  contents, but uses its property descriptor to test whether
                //  it contains a Function. This is necessary on some browsers
                //  because those slots can throw Errors if we try to touch
                //  them.
                keys = keys.filter(
                        function(testSlot) {
                            var desc;

                            desc = Object.getOwnPropertyDescriptor(
                                                            obj, testSlot);
                            if (desc.value && TP.isCallable(desc.value)) {
                                return true;
                            }

                            return false;
                        });
            }

            proto = Object.getPrototypeOf(obj);

            if (overriddenOnly) {
                keys = keys.filter(
                        function(aKey) {

                            try {
                                return obj[aKey] === proto[aKey];
                            } catch (e) {
                                return false;
                            }
                        });
            }

            arr.push(keys);
            if (dontTraverse) {
                break;
            }

            obj = proto;
        } while (obj);
        /* eslint-enable no-loop-func */

        arr = Array.prototype.concat.apply([], arr);
    }

    if (TP.isFunction(aDiscriminator)) {
        return arr.select(aDiscriminator).sort();
    } else if (TP.isValid(aDiscriminator)) {
        return arr.grep(aDiscriminator).sort();
    } else {
        return arr.sort();
    }
});

//  ------------------------------------------------------------------------

TP.definePrimitive('pretty',
function(anObject) {

    /**
     * @method pretty
     * @summary Returns the content of the object in a "best looking" form of
     *     markup. For example, a function body would be returned in syntax
     *     colored markup. The largest consumer of this method is the TIBET
     *     console which takes the return value from this method and uses it as
     *     the receiver's console representation.
     * @param {The} anObject object whose properties and simple print string
     *     should be returned.
     * @returns {String} A simple print string for the object.
     */

    var xhrStatus,

        str,

        arr,
        len,
        i,

        rules;

    if (anObject === null) {
        return '<dl class="pretty Null"><dt/><dd>null</dd></dl>';
    } else if (anObject === undefined) {
        return '<dl class="pretty Undefined"><dt/><dd>undefined</dd></dl>';
    }

    //  XMLHttpRequest can have permission issues, so check early
    if (TP.isXHR(anObject)) {
        //  If the XHR mechanism has aborted in Mozilla, it will cause the
        //  '.status' property to throw an exception if it is read.
        try {
            xhrStatus = anObject.status;
        } catch (e) {
            xhrStatus = 'none';
        }

        return '<dl class="pretty ' + TP.escapeTypeName(TP.tname(anObject)) +
                        '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' + TP.tname(anObject) +
                        '</dd>' +
                    '<dt class="pretty key">Status</dt>' +
                    '<dd class="pretty value">' + xhrStatus + '</dd>' +
                    '<dt class="pretty key">Response text</dt>' +
                    '<dd class="pretty value">' +
                        TP.str(anObject.responseText).asEscapedXML() +
                    '</dd>' +
                '</dl>';
    }

    //  native nodes are the next-most likely object being passed to this
    //  routine, so we'll try to build up a proper string here
    if (TP.isNode(anObject)) {
        return '<dl class="pretty ' + TP.escapeTypeName(TP.tname(anObject)) +
                        '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' + TP.tname(anObject) +
                        '</dd>' +
                    '<dt class="pretty key">Content</dt>' +
                    '<dd class="pretty value">' +
                        TP.nodeAsString(anObject).asEscapedXML() +
                    '</dd>' +
                '</dl>';
    }

    //  got to check Errors next... they freak out if handed to TP.isString().
    if (TP.isError(anObject)) {
        return '<dl class="pretty ' + TP.escapeTypeName(TP.tname(anObject)) +
                        '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' + TP.tname(anObject) +
                        '</dd>' +
                    '<dt class="pretty key">Message</dt>' +
                    '<dd class="pretty value">' +
                        TP.str(anObject.message) +
                    '</dd>' +
                '</dl>';
    }

    //  Since these are all non-mutable, we must do this before the next check
    if (TP.isString(anObject) ||
        TP.isNumber(anObject) ||
        TP.isBoolean(anObject)) {
        return anObject.asPrettyString();
    }

    if (!TP.isMutable(anObject)) {
        //  TODO:   does this really deal with all the special constants
        //  like NaN, Number.POSITIVE_INFINITY, etc.?
        return TP.objectToString(anObject);
    }

    //  The top-level Window has TIBET loaded into it, so it will respond to
    //  'asString' properly, but other iframes, etc. won't so we have to handle
    //  Windows in a special manner here.
    if (TP.isWindow(anObject)) {
        return TP.windowAsPrettyString(anObject);
    }

    //  Event objects
    if (TP.isEvent(anObject)) {
        return TP.eventAsPrettyString(anObject);
    }

    //  NodeList objects
    if (TP.isNodeList(anObject)) {
        arr = TP.ac();

        len = anObject.length;
        for (i = 0; i < len; i++) {
            arr.push('<dt class="pretty key">', i, '</dt>',
                        '<dd class="pretty value">', TP.nodeAsString(anObject[i]).asEscapedXML(), '</dd>');
        }

        return '<dl class="pretty ' + TP.escapeTypeName(TP.tname(anObject)) + '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' + TP.tname(anObject) + '</dd>' +
                    arr.join('') +
                '</dl>';
    }

    //  NamedNodeMap objects
    if (TP.isNamedNodeMap(anObject)) {
        arr = TP.ac();

        len = anObject.length;
        for (i = 0; i < len; i++) {
            arr.push('<dt class="pretty key">', TP.name(anObject.item(i)), '</dt>',
                        '<dd class="pretty value">', TP.val(anObject.item(i)), '</dd>');
        }

        return '<dl class="pretty ' + TP.escapeTypeName(TP.tname(anObject)) + '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' + TP.tname(anObject) + '</dd>' +
                    arr.join('') +
                '</dl>';
    }

    //  Stylesheet objects
    if (TP.isStyleSheet(anObject)) {

        //  NB: Note how we do *not* expand imports here and we do *not* filter
        //  for CSSRule.STYLE_RULE types of rules.
        rules = TP.styleSheetGetStyleRules(anObject, false, false);

        arr = TP.ac();

        len = rules.length;
        for (i = 0; i < len; i++) {
            arr.push('<dt class="pretty key">', i, '</dt>',
                        '<dd class="pretty value">', rules[i].cssText, '</dd>');
        }

        return '<dl class="pretty ' + TP.escapeTypeName(TP.tname(anObject)) + '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' + TP.tname(anObject) + '</dd>' +
                    arr.join('') +
                '</dl>';
    }

    //  Style rule objects
    if (TP.isStyleRule(anObject)) {
        return '<dl class="pretty ' + TP.escapeTypeName(TP.tname(anObject)) + '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' + TP.tname(anObject) + '</dd>' +
                    '<dt class="pretty key">Content</dt>' +
                    '<dd class="pretty value">' + anObject.cssText + '</dd>' +
                '</dl>';
    }

    //  Style declaration objects
    if (TP.isStyleDeclaration(anObject)) {
        return '<dl class="pretty ' + TP.escapeTypeName(TP.tname(anObject)) + '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' + TP.tname(anObject) + '</dd>' +
                    '<dt class="pretty key">Content</dt>' +
                    '<dd class="pretty value">' + anObject.cssText + '</dd>' +
                '</dl>';
    }

    if (TP.canInvoke(anObject, 'asPrettyString')) {
        str = anObject.asPrettyString();
        //  NB: No special detection of NATIVE_CODE functions here - just return
        //  what a Function would normally produce.
        return str;
    }

    //  worst case we just produce our best html representation
    return TP.htmlstr(anObject);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('recursion',
function(anObject, aKey) {

    /**
     * @method recursion
     * @summary Returns a string representation of the object which is used
     *     when the object is encountered in a circularly referenced manner
     *     during the production of some sort of formatted String
     *     representation.
     * @param {Object} anObject The object whose properties triggered a
     *     circular reference recursion.
     * @param {aKey} aKey The operation key which marked the circularity.
     * @returns {String} A recursion string rep for the object.
     */

    var obj,
        gid,
        key;

    try {
        //  Remove our recursion marker from the object.
        delete anObject[aKey];

        //  Update our key to the original key name.
        key = aKey.replace('$$recursive_', '');
        gid = TP.gid(anObject);

        TP.warn('Circular reference(s) in ' + gid + ' (' + key + ')');
    } catch (e) {
        void 0;
    }

    obj = TP.wrap(anObject);
    if (obj !== anObject) {
        if (TP.canInvoke(anObject, 'asRecursionString')) {
            return anObject.asRecursionString();
        }
    }

    if (TP.canInvoke(anObject, 'asRecursionString')) {
        return anObject.asRecursionString();
    }

    //  Do up a manual form of recursion string here.
    gid = TP.gid(obj);
    if (TP.sys.cfg('debug.register_recursion')) {

        gid = 'urn:tibet:' + gid;
        TP.uc(gid).setResource(obj);

        return gid;
    }

    return '@' + gid;
});

//  ------------------------------------------------------------------------
//  COLLECTIONS
//  ------------------------------------------------------------------------

TP.definePrimitive('contains',
function(anObject, aValue) {

    /**
     * @method contains
     * @summary Returns true if the object can be shown to clearly contain the
     *     value provided. Indeterminate cases (where the object can't be tested
     *     effectively) return false.
     * @param {Object} anObject The object to test.
     * @param {Object} aValue The value to check for containment.
     * @returns {Boolean} True if the value is clearly contained.
     */

    if (TP.notValid(anObject)) {
        return false;
    }

    if (TP.canInvoke(anObject, 'contains')) {
        return anObject.contains(aValue);
    }

    //  TODO:   what about a fuzzy return value here ala "undefined".
    return false;
});

//  ------------------------------------------------------------------------
//  TRAVERSAL SHORTCUTS
//  ------------------------------------------------------------------------

TP.definePrimitive('chain',
function(anObject, aProperty) {

    /**
     * @method chain
     * @summary Returns an Array of objects acquired by recursively invoking
     *     get(aProperty) on anObject. When the object is a node the property is
     *     typically something such as parentNode which provides a list of all
     *     the node's ancestors.
     * @param {Object} anObject The object to root the query at.
     * @param {String} aProperty A property name to query for.
     * @returns {Object[]} An array of zero to N result objects.
     */

    var arr,
        obj;

    if (TP.isNode(anObject)) {
        return TP.nodeSelectChain(anObject, aProperty);
    }

    arr = TP.ac();

    if (TP.isEmpty(aProperty)) {
        //  TODO: warn?
        return arr;
    }

    obj = anObject;

    while (TP.isValid(obj)) {
        obj = TP.val(obj, aProperty);

        if (TP.notValid(obj)) {
            break;
        }

        arr.push(obj);
    }

    return arr;
});

//  ------------------------------------------------------------------------
//  SPECIAL FEATURES
//  ------------------------------------------------------------------------

TP.definePrimitive('go2',
function(aURIOrRoute, winContext, event) {

    /**
     * @method go2
     * @summary A general wrapper function used during processing of link
     *     elements to give TIBET control over the link traversal process. The
     *     go2 call ultimately results in either a route change or page change
     *     depending on the content of the original href value. To define a
     *     route you must provide a value with a leading '#' to force this call
     *     to recognize the path as a 'client path' rather than a server path.
     * @param {TP.uri.URI|String} aURIOrRoute The URI or route to go to.
     * @param {Window} [winContext] An option window with the original link
     *     element. If this is not supplied, then the current UI canvas is used.
     * @param {Event} [event] An optional event when this method is called from
     *     a native event handler. If this parameter is a keyboard or mouse
     *     event, then the proper TIBET object will be called upon to invoke its
     *     observers.
     * @exception TP.sig.InvalidURI
     * @returns {Boolean} Always returns 'false' to avoid anchor link traversal.
     */

    var evtProps,

        context,
        loc,
        head,
        tail,
        path,
        router;

    if (TP.notValid(aURIOrRoute)) {
        TP.raise(this, 'TP.sig.InvalidURI');
        return false;
    }

    if (TP.isEvent(event)) {
        //  NB: We don't really use these keys, but testing to see which set
        //  they are in is a useful way to tell whether they are mouse or
        //  keyboard events. We ignore other types of events here.
        evtProps = TP.eventGetPropertyKeys(event);
        switch (evtProps) {
            case TP.DOM_KEY_EVENT_PROPERTIES:
                TP.core.Keyboard.invokeObservers(TP.eventGetType(event), event);
                break;
            case TP.DOM_MOUSE_EVENT_PROPERTIES:
                TP.core.Mouse.invokeObservers(TP.eventGetType(event), event);
                break;
            default:
                break;
        }
    }

    //  If we get a "route" rather than a full URI update the hash and let the
    //  system respond to that to route correctly.
    if (aURIOrRoute === '/' || /^#/.test(aURIOrRoute)) {

        //  A route has to be '#/' or '#?', so only trigger the router if we see
        //  that pattern.
        if (aURIOrRoute === '/' || /^#(\/|\?)/.test(aURIOrRoute)) {

            router = TP.sys.getRouter();

            if (TP.isValid(router)) {
                router.setRoute(TP.str(aURIOrRoute).slice(1));
            }

            return false;
        } else {
            //  This is a link anchor target - build up the proper adjusted
            //  path and set it.
            loc = TP.topWindow.location.toString();

            head = TP.uriHead(loc);
            tail = TP.uriFragmentParameters(loc);

            if (TP.notEmpty(tail)) {
                tail = '?' + tail;
            } else {
                tail = '';
            }

            path = head + aURIOrRoute + tail;
            TP.sys.getHistory().pushLocation(path);

            return true;
        }
    }

    if (!TP.isURIString(aURIOrRoute)) {
        TP.raise(this, 'TP.sig.InvalidURI');
        return false;
    }

    context = winContext;
    if (TP.notValid(context)) {
        //  NB: We go after the native Window here to match this call's API.
        context = TP.sys.getUICanvas(true);
    }

    if (!TP.isWindow(context)) {
        TP.raise(this, 'TP.sig.InvalidWindow');
        return false;
    }

    //  Push the location. This will trigger TIBET's route() machinery to handle
    //  the actual page/canvas update.
    TP.sys.getHistory().pushLocation(aURIOrRoute);

    return false;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('handle',
function(anObject, aSignal, aHandlerName, ignoreMisses) {

    /**
     * @method handle
     * @summary Directly invokes a signal handler, ensuring that any signal
     *     stack manipulation necessary to keep the overall signaling system in
     *     sync is performed. This is the preferred method of invoking a handler
     *     directly from within your code.
     * @param {Object} anObject The object to handle the signal.
     * @param {TP.sig.Signal} aSignal The signal to handle.
     * @param {String} aHandlerName An optional specific handler name, used
     *     instead of 'handle' to speed dispatch to the handler function by
     *     bypassing normal callBestMethod() lookup semantics for the signal.
     * @param {Boolean} ignoreMisses True to turn off warnings when the handler
     *     can't be invoked.
     */

    var ignore,
        handlerName,

        oldHandler,

        retVal;

    handlerName = TP.ifEmpty(aHandlerName, 'handle');
    ignore = TP.ifInvalid(ignoreMisses, false);

    if (!TP.canInvoke(anObject, handlerName)) {
        TP.ifWarn() && !ignore && TP.sys.shouldLogSignals() ?
            TP.warn(TP.annotate(anObject,
                'Direct ' + handlerName + ' invocation failed.'),
                TP.SIGNAL_LOG) : 0;

        return;
    }

    if (TP.notValid(aSignal)) {
        TP.ifWarn() && !ignore && TP.sys.shouldLogSignals() ?
            TP.warn(TP.join('Direct ', handlerName, ' invocation failed. ',
                'No signal name or instance provided.'),
                TP.SIGNAL_LOG) : 0;

        return;
    }

    //  preserve 'ignore semantics' so even direct invocations through this
    //  mechanism can't override a decision by a handler to be ignored.
    if (aSignal.hasNotified(anObject, anObject) ||
        aSignal.hasNotified(anObject[handlerName], anObject)) {
        return;
    }

    //  the thing about forcing manual invocation of handlers is that it can
    //  get the signal stack out of sync, so we manage it directly here
    TP.$signal_stack.push(aSignal);

    try {
        oldHandler = aSignal.$get('currentHandler');
        aSignal.$set('currentHandler', anObject[handlerName], false);
        retVal = anObject[handlerName](aSignal);
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'Handler invocation error.')) : 0;
    } finally {
        TP.$signal_stack.pop();

        aSignal.trackHandler(anObject, anObject);
        aSignal.trackHandler(anObject[handlerName], anObject);

        aSignal.$set('currentHandler', oldHandler, false);
    }

    return retVal;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETHousekeeping.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'vm';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
Early-stage boot system and kernel elements as well as various native functions
get registered here so that TIBET's reflection subsystem can interrogate them
for name, owner, and track information effectively.

Over time we'll be migrating the registration methods lower and lower into the
kernel so we can reduce the amount of housekeeping required here.
*/

//  ------------------------------------------------------------------------

//  ---
//  tibet_boot.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/boot/tibet_boot.js';

TP.boot.defineMethod('$$importAsync', TP.boot.$$importAsync);

TP.sys.defineMethod('hasLoaded', TP.sys.hasLoaded);
TP.sys.defineMethod('hasKernel', TP.sys.hasKernel);
TP.sys.defineMethod('hasInitialized', TP.sys.hasInitialized);
TP.sys.defineMethod('hasStarted', TP.sys.hasStarted);

TP.boot.defineMethod('$$getprop', TP.boot.$$getprop);
TP.boot.defineMethod('$$setprop', TP.boot.$$setprop);

TP.sys.defineMethod('cfg', TP.sys.cfg);
TP.sys.defineMethod('getcfg', TP.sys.getcfg);
TP.sys.defineMethod('setcfg', TP.sys.setcfg);

TP.sys.defineMethod('env', TP.sys.env);
TP.boot.defineMethod('$getenv', TP.boot.$getenv);
TP.boot.defineMethod('$$setenv', TP.boot.$$setenv);

TP.sys.defineMethod('hasFeature', TP.sys.hasFeature);
TP.sys.defineMethod('hasPackage', TP.sys.hasPackage);

TP.sys.defineMethod('defineGlobal', TP.sys.defineGlobal);

//  This is for Karma - it will overwrite the 'alert', 'prompt' and 'confirm'
//  slots but this registration will check for 'asMethod' on these and we really
//  don't need to do them for Karma ('notify' is a TIBET method, but is
//  sometimes aliased to 'alert').
if (!TP.sys.hasFeature('karma')) {
    TP.boot.defineMethod('$alert', TP.boot.$alert);
    TP.boot.defineMethod('$prompt', TP.boot.$prompt);
    TP.boot.defineMethod('$confirm', TP.boot.$confirm);

    TP.boot.defineMethod('$notify', TP.boot.$notify);
}

TP.boot.defineMethod('$stderr', TP.boot.$stderr);
TP.boot.defineMethod('$stdin', TP.boot.$stdin);
TP.boot.defineMethod('$stdout', TP.boot.$stdout);

TP.boot.defineMethod('$raise', TP.boot.$raise);

TP.sys.defineMethod('isHTTPBased', TP.sys.isHTTPBased);
TP.sys.defineMethod('isMac', TP.sys.isMac);
TP.sys.defineMethod('isNix', TP.sys.isNix);
TP.sys.defineMethod('isWin', TP.sys.isWin);

TP.sys.defineMethod('isUA', TP.sys.isUA);

TP.sys.defineMethod('isObsolete', TP.sys.isObsolete);
TP.sys.defineMethod('isSupported', TP.sys.isSupported);

TP.sys.defineMethod('getLaunchRoot', TP.sys.getLaunchRoot);
TP.sys.defineMethod('getLaunchURL', TP.sys.getLaunchURL);
TP.sys.defineMethod('getLaunchHost', TP.sys.getLaunchHost);
TP.sys.defineMethod('getLaunchPathname', TP.sys.getLaunchPathname);
TP.sys.defineMethod('getLaunchPort', TP.sys.getLaunchPort);
TP.sys.defineMethod('getLaunchScheme', TP.sys.getLaunchScheme);

TP.boot.defineMethod('$httpConstruct', TP.boot.$httpConstruct);
TP.boot.defineMethod('$httpError', TP.boot.$httpError);
TP.boot.defineMethod('$httpCall', TP.boot.$httpCall);

TP.boot.defineMethod('$uriCollapsePath', TP.boot.$uriCollapsePath);
TP.boot.defineMethod('$uriExpandPath', TP.boot.$uriExpandPath);
TP.boot.defineMethod('$uriInLocalFormat', TP.boot.$uriInLocalFormat);
TP.boot.defineMethod('$uriJoinPaths', TP.boot.$uriJoinPaths);
TP.boot.defineMethod('$uriMinusFileScheme', TP.boot.$uriMinusFileScheme);
TP.boot.defineMethod('$uriPlusFileScheme', TP.boot.$uriPlusFileScheme);
TP.boot.defineMethod('$uriRelativeToPath', TP.boot.$uriRelativeToPath);
TP.boot.defineMethod('$uriResult', TP.boot.$uriResult);
TP.boot.defineMethod('$uriResultType', TP.boot.$uriResultType);

TP.boot.defineMethod('$uriWithRoot', TP.boot.$uriWithRoot);

TP.boot.defineMethod('$uriLoad', TP.boot.$uriLoad);
TP.boot.defineMethod('$uriLoadCommonFile', TP.boot.$uriLoadCommonFile);
TP.boot.defineMethod('$uriLoadIEFile', TP.boot.$uriLoadIEFile);
TP.boot.defineMethod('$uriLoadMozFile', TP.boot.$uriLoadMozFile);
TP.boot.defineMethod('$uriLoadCommonHttp', TP.boot.$uriLoadCommonHttp);

TP.boot.defineMethod('$sourceImport', TP.boot.$sourceImport);

TP.boot.defineMethod('$documentConstruct', TP.boot.$documentConstruct);
TP.boot.defineMethod('$activeXDocumentConstructIE',
                                        TP.boot.$activeXDocumentConstructIE);

TP.boot.defineMethod('$nodeAppendChild', TP.boot.$nodeAppendChild);
TP.boot.defineMethod('$nodeInsertBefore', TP.boot.$nodeInsertBefore);
TP.boot.defineMethod('$nodeReplaceChild', TP.boot.$nodeReplaceChild);

TP.boot.defineMethod('$documentFromString', TP.boot.$documentFromString);
TP.boot.defineMethod('$documentFromStringCommon',
                                        TP.boot.$documentFromStringCommon);
TP.boot.defineMethod('$documentFromStringIE',
                                        TP.boot.$documentFromStringIE);

TP.boot.defineMethod('$nodeAsString', TP.boot.$nodeAsString);
TP.boot.defineMethod('$nodeAsStringCommon', TP.boot.$nodeAsStringCommon);

TP.sys.defineMethod('getWindowById', TP.sys.getWindowById);
TP.definePrimitive('windowIsInstrumented', TP.windowIsInstrumented);

TP.boot.defineMethod('$elementAddClass', TP.boot.$elementAddClass);
TP.boot.defineMethod('$elementSetInnerContent',
                                        TP.boot.$elementSetInnerContent);

TP.boot.defineMethod('$stringify', TP.boot.$stringify);

TP.boot.defineMethod('$trim', TP.boot.$trim);

TP.boot.defineMethod('$currentDocumentLocation',
                                        TP.boot.$currentDocumentLocation);

TP.boot.defineMethod('$annotate', TP.boot.$annotate);
TP.boot.defineMethod('$ec', TP.boot.$ec);
TP.boot.defineMethod('$join', TP.boot.$join);
TP.boot.defineMethod('$str', TP.boot.$str);

TP.sys.defineMethod('getBootLog', TP.sys.getBootLog);

TP.boot.defineMethod('log', TP.boot.log);

TP.boot.defineMethod('$releaseUIElements', TP.boot.$releaseUIElements);

TP.boot.defineMethod('$getProgressBarElement',
                                    TP.boot.$getProgressBarElement);

TP.boot.defineMethod('$setStage', TP.boot.$setStage);

TP.boot.defineMethod('$getAppRoot', TP.boot.$getAppRoot);
TP.boot.defineMethod('$getLibRoot', TP.boot.$getLibRoot);
TP.boot.defineMethod('$getRootPath', TP.boot.$getRootPath);
TP.boot.defineMethod('$setAppRoot', TP.boot.$setAppRoot);
TP.boot.defineMethod('$setLibRoot', TP.boot.$setLibRoot);

TP.boot.defineMethod('$configureEnvironment',
                                    TP.boot.$configureEnvironment);

TP.boot.defineMethod('$ifUnlessPassed', TP.boot.$ifUnlessPassed);
TP.boot.defineMethod('$getElementCount', TP.boot.$getElementCount);
TP.boot.defineMethod('$uniqueNodeList', TP.boot.$uniqueNodeList);

TP.boot.defineMethod('$importApplication', TP.boot.$importApplication);
TP.boot.defineMethod('$importComponents', TP.boot.$importComponents);

TP.sys.defineMethod('writeBootLog', TP.sys.writeBootLog);

TP.boot.defineMethod('boot', TP.boot.boot);
TP.boot.defineMethod('$config', TP.boot.$config);

TP.boot.defineMethod('launch', TP.boot.launch);

TP.boot.defineMethod('main', TP.boot.main);

//  ---
//  tibet_hook.js
//  ---

//  whether or not we can move on to phase two processing
TP.sys.defineGlobal('$$phase_two', null);

TP.boot.defineMethod('$isElement', TP.boot.$isElement);
TP.boot.defineMethod('$isEmpty', TP.boot.$isEmpty);
TP.boot.defineMethod('$isValid', TP.boot.$isValid);
TP.boot.defineMethod('$isWindow', TP.boot.$isWindow);
TP.boot.defineMethod('$notValid', TP.boot.$notValid);

TP.boot.defineMethod('$byId', TP.boot.$byId);

TP.boot.defineMethod('hideContent', TP.boot.hideContent);
TP.boot.defineMethod('hideUIRoot', TP.boot.hideUIRoot);

TP.boot.defineMethod('showUICanvas', TP.boot.showUICanvas);
TP.boot.defineMethod('showUIRoot', TP.boot.showUIRoot);

//  ---
//  TIBETGlobals.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETGlobals.js';

TP.sys.defineMethod('defineGlobal', TP.sys.defineGlobal);
TP.sys.defineMethod('getGlobals', TP.sys.getGlobals);

TP.definePrimitive('LOG_ARGS', TP.LOG_ARGS);
TP.definePrimitive('NOTIFY_ARGS', TP.NOTIFY_ARGS);

TP.definePrimitive('TEST_HANDLER', TP.TEST_HANDLER);

TP.definePrimitive('RETURN_NULL', TP.RETURN_NULL);
TP.definePrimitive('RETURN_THIS', TP.RETURN_THIS);
TP.definePrimitive('RETURN_TRUE', TP.RETURN_TRUE);
TP.definePrimitive('RETURN_FALSE', TP.RETURN_FALSE);

TP.definePrimitive('RETURN_ARG0', TP.RETURN_ARG0);
TP.definePrimitive('RETURN_ARGS', TP.RETURN_ARGS);

TP.definePrimitive('RETURN_FIRST', TP.RETURN_FIRST);
TP.definePrimitive('RETURN_LAST', TP.RETURN_LAST);

TP.definePrimitive('RETURN_EMPTY_ARRAY', TP.RETURN_EMPTY_ARRAY);
TP.definePrimitive('RETURN_EMPTY_STRING', TP.RETURN_EMPTY_STRING);
TP.definePrimitive('RETURN_SPACE', TP.RETURN_SPACE);

TP.definePrimitive('RETURN_ORIG', TP.RETURN_ORIG);
TP.definePrimitive('RETURN_NEW', TP.RETURN_NEW);

TP.definePrimitive('RETURN_TOSTRING', TP.RETURN_TOSTRING);

//  ---
//  version.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/version.js';

//  ---
//  TIBETPrimitivesPre.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETPrimitivesPre.js';

TP.sys.defineGlobal(TP.ID, null);

//  ---
//  TIBETPrimitivesBase.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETPrimitivesBase.js';

//  ---
//  TIBETPrimitivesPost.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETPrimitivesPost.js';

//  unusual, but this keeps environment config centralized on TP.boot
TP.boot.defineMethod('$configurePluginEnvironment',
                                    TP.boot.$configurePluginEnvironment);

//  Enhanced methods for slot lookup
TP.boot.defineAttribute('$simplePropertyRetriever',
                                    TP.boot.$simplePropertyRetriever);

//  ---
//  TIBETDOMPrimitivesPre.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETDOMPrimitivesPre.js';

//  ---
//  TIBETDOMPrimitivesBase.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETDOMPrimitivesBase.js';

//  ---
//  TIBETDOMPrimitivesPost.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETDOMPrimitivesPost.js';

//  ---
//  TIBETDevicePrimitivesPre.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETDevicePrimitivesPre.js';

//  ---
//  TIBETDevicePrimitivesBase.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETDevicePrimitivesBase.js';

//  ---
//  TIBETDevicePrimitivesPost.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETDevicePrimitivesPost.js';

//  ---
//  TIBETDHTMLPrimitivesPre.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETDHTMLPrimitivesPre.js';

//  ---
//  TIBETDHTMLPrimitivesBase.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETDHTMLPrimitivesBase.js';

//  ---
//  TIBETDHTMLPrimitivesPost.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETDHTMLPrimitivesPost.js';

//  This slot is used by TP.windowIsInstrumented() below on a Window,
//  which means that it needs to be tracked as a global.
TP.sys.defineGlobal('$$instrumented', null);

//  ---
//  TIBETGraphicsPrimitivesPre.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETGraphicsPrimitivesPre.js';

//  ---
//  TIBETGraphicsPrimitivesBase.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETGraphicsPrimitivesBase.js';

//  ---
//  TIBETStringPrimitivesPost.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETStringPrimitivesPost.js';

//  ---
//  TIBETCSSPrimitivesPre.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETCSSPrimitivesPre.js';

//  ---
//  TIBETCSSPrimitivesBase.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETCSSPrimitivesBase.js';

//  ---
//  TIBETCSSPrimitivesPost.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETCSSPrimitivesPost.js';

//  ---
//  TIBETEncapsulation.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETEncapsulation.js';

//  ---
//  TIBETRegistration.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETRegistration.js';

//  ---
//  TIBETFoundation.js
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETFoundation.js';

//  ---
//  TIBETImportExport :)
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETImportExport.js';

//  ---
//  TIBETPrimitivesShortcuts
//  ---

TP.boot[TP.SOURCE_PATH] = '~lib_src/tibet/kernel/TIBETPrimitivesShortcut.js';

//  ------------------------------------------------------------------------
//  BUILT-IN METHODS
//  ------------------------------------------------------------------------

//  Faking out a load info here for the builtins

//  NB: We do this inside of a closure to try to hide the local variables from
//  the global scope
(function() {

    var currentLoadPath,
        currentLoadPackage,
        currentLoadConfig,
        currentLoadStage,

        currentSourcePath,
        currentSourcePackage,
        currentSourceConfig;

    currentLoadPath = TP.boot[TP.LOAD_PATH];
    currentLoadPackage = TP.boot[TP.LOAD_PACKAGE];
    currentLoadConfig = TP.boot[TP.LOAD_CONFIG];
    currentLoadStage = TP.boot[TP.LOAD_STAGE];

    currentSourcePath = TP.boot[TP.SOURCE_PATH];
    currentSourcePackage = TP.boot[TP.SOURCE_PACKAGE];
    currentSourceConfig = TP.boot[TP.SOURCE_CONFIG];

    TP.boot[TP.LOAD_PATH] = '';
    TP.boot[TP.LOAD_PACKAGE] = '';
    TP.boot[TP.LOAD_CONFIG] = '';
    TP.boot[TP.LOAD_STAGE] = '';

    TP.boot[TP.SOURCE_PATH] = '';
    TP.boot[TP.SOURCE_PACKAGE] = '';
    TP.boot[TP.SOURCE_CONFIG] = '';

    //  Go ahead and instrument the builtins by 'defining' them, according to
    //  TIBET

    //  Array.Type.defineMethod('from', Array.from); // E6
    Array.Type.defineMethod('isArray', Array.isArray);
    //  Array.Type.defineMethod('of', Array.of); // E6

    //  Array.Inst.defineMethod('copyWithin', TP.ArrayProto.copyWithin); // E6
    Array.Inst.defineMethod('concat', TP.ArrayProto.concat);
    Array.Inst.defineMethod('every', TP.ArrayProto.every);
    Array.Inst.defineMethod('filter', TP.ArrayProto.filter);
    //  Array.Inst.defineMethod('fill', TP.ArrayProto.fill); // E6
    //  Array.Inst.defineMethod('find', TP.ArrayProto.find); // E6
    //  Array.Inst.defineMethod('findIndex', TP.ArrayProto.findIndex); // E6
    Array.Inst.defineMethod('forEach', TP.ArrayProto.forEach);
    Array.Inst.defineMethod('indexOf', TP.ArrayProto.indexOf);
    Array.Inst.defineMethod('join', TP.ArrayProto.join);
    //  Array.Inst.defineMethod('keys', TP.ArrayProto.keys); // E6
    Array.Inst.defineMethod('lastIndexOf', TP.ArrayProto.lastIndexOf);
    Array.Inst.defineMethod('map', TP.ArrayProto.map);
    Array.Inst.defineMethod('pop', TP.ArrayProto.pop);
    Array.Inst.defineMethod('push', TP.ArrayProto.push);
    Array.Inst.defineMethod('reduce', TP.ArrayProto.reduce);
    Array.Inst.defineMethod('reduceRight', TP.ArrayProto.reduceRight);
    Array.Inst.defineMethod('reverse', TP.ArrayProto.reverse);
    Array.Inst.defineMethod('shift', TP.ArrayProto.shift);
    Array.Inst.defineMethod('slice', TP.ArrayProto.slice);
    Array.Inst.defineMethod('some', TP.ArrayProto.some);
    Array.Inst.defineMethod('sort', TP.ArrayProto.sort);
    Array.Inst.defineMethod('splice', TP.ArrayProto.splice);
    Array.Inst.defineMethod('toLocaleString', TP.ArrayProto.toLocaleString);
    Array.Inst.defineMethod('toString', TP.ArrayProto.toString);
    Array.Inst.defineMethod('unshift', TP.ArrayProto.unshift);
    //  Array.Inst.defineMethod('values', TP.ArrayProto.values); // E6

    Boolean.Inst.defineMethod('toString', TP.BooleanProto.toString);
    Boolean.Inst.defineMethod('valueOf', TP.BooleanProto.valueOf);

    Date.Type.defineMethod('now', Date.now);
    Date.Type.defineMethod('parse', Date.parse);
    Date.Type.defineMethod('UTC', Date.UTC);

    Date.Inst.defineMethod('getDate', TP.DateProto.getDate);
    Date.Inst.defineMethod('getDay', TP.DateProto.getDay);
    Date.Inst.defineMethod('getFullYear', TP.DateProto.getFullYear);
    Date.Inst.defineMethod('getHours', TP.DateProto.getHours);
    Date.Inst.defineMethod('getMilliseconds', TP.DateProto.getMilliseconds);
    Date.Inst.defineMethod('getMinutes', TP.DateProto.getMinutes);
    Date.Inst.defineMethod('getMonth', TP.DateProto.getMonth);
    Date.Inst.defineMethod('getSeconds', TP.DateProto.getSeconds);
    Date.Inst.defineMethod('getTime', TP.DateProto.getTime);
    Date.Inst.defineMethod('getTimezoneOffset', TP.DateProto.getTimezoneOffset);
    Date.Inst.defineMethod('getUTCDate', TP.DateProto.getUTCDate);
    Date.Inst.defineMethod('getUTCDay', TP.DateProto.getUTCDay);
    Date.Inst.defineMethod('getUTCFullYear', TP.DateProto.getUTCFullYear);
    Date.Inst.defineMethod('getUTCHours', TP.DateProto.getUTCHours);
    Date.Inst.defineMethod('getUTCMilliseconds', TP.DateProto.getUTCMilliseconds);
    Date.Inst.defineMethod('getUTCMinutes', TP.DateProto.getUTCMinutes);
    Date.Inst.defineMethod('getUTCMonth', TP.DateProto.getUTCMonth);
    Date.Inst.defineMethod('getUTCSeconds', TP.DateProto.getUTCSeconds);
    Date.Inst.defineMethod('getYear', TP.DateProto.getYear);
    Date.Inst.defineMethod('setDate', TP.DateProto.setDate);
    Date.Inst.defineMethod('setFullYear', TP.DateProto.setFullYear);
    Date.Inst.defineMethod('setHours', TP.DateProto.setHours);
    Date.Inst.defineMethod('setMilliseconds', TP.DateProto.setMilliseconds);
    Date.Inst.defineMethod('setMinutes', TP.DateProto.setMinutes);
    Date.Inst.defineMethod('setMonth', TP.DateProto.setMonth);
    Date.Inst.defineMethod('setSeconds', TP.DateProto.setSeconds);
    Date.Inst.defineMethod('setTime', TP.DateProto.setTime);
    Date.Inst.defineMethod('setUTCDate', TP.DateProto.setUTCDate);
    Date.Inst.defineMethod('setUTCFullYear', TP.DateProto.setUTCFullYear);
    Date.Inst.defineMethod('setUTCHours', TP.DateProto.setUTCHours);
    Date.Inst.defineMethod('setUTCMilliseconds', TP.DateProto.setUTCMilliseconds);
    Date.Inst.defineMethod('setUTCMinutes', TP.DateProto.setUTCMinutes);
    Date.Inst.defineMethod('setUTCMonth', TP.DateProto.setUTCMonth);
    Date.Inst.defineMethod('setUTCSeconds', TP.DateProto.setUTCSeconds);
    Date.Inst.defineMethod('setYear', TP.DateProto.setYear);
    Date.Inst.defineMethod('toDateString', TP.DateProto.toDateString);
    Date.Inst.defineMethod('toGMTString', TP.DateProto.toGMTString);
    Date.Inst.defineMethod('toISOString', TP.DateProto.toISOString);
    Date.Inst.defineMethod('toJSON', TP.DateProto.toJSON);
    Date.Inst.defineMethod('toLocaleDateString', TP.DateProto.toLocaleDateString);
    Date.Inst.defineMethod('toLocaleString', TP.DateProto.toLocaleString);
    Date.Inst.defineMethod('toLocaleTimeString', TP.DateProto.toLocaleTimeString);
    Date.Inst.defineMethod('toString', TP.DateProto.toString);
    Date.Inst.defineMethod('toTimeString', TP.DateProto.toTimeString);
    Date.Inst.defineMethod('toUTCString', TP.DateProto.toUTCString);
    Date.Inst.defineMethod('valueOf', TP.DateProto.valueOf);

    //  Error Object: no methods

    Function.Inst.defineMethod('apply', TP.FunctionProto.apply);
    //  We don't register 'bind' because we define our own version
    //  Function.Inst.defineMethod('bind', TP.FunctionProto.bind);
    Function.Inst.defineMethod('call', TP.FunctionProto.call);
    Function.Inst.defineMethod('toString', TP.FunctionProto.toString);

    //  Math Object: don't expose publicly. See Number extensions.

    //  Number.Inst.defineMethod('isFinite', TP.NumberProto.isFinite); // E6
    //  Number.Inst.defineMethod('isInteger', TP.NumberProto.isInteger); // E6
    //  Number.Inst.defineMethod('isNaN', TP.NumberProto.isNaN); // E6
    //  Number.Inst.defineMethod('isSafeInteger', TP.NumberProto.isSafeInteger); // E6
    Number.Inst.defineMethod('toExponential', TP.NumberProto.toExponential);
    Number.Inst.defineMethod('toFixed', TP.NumberProto.toFixed);
    Number.Inst.defineMethod('toLocaleString', TP.NumberProto.toLocaleString);
    Number.Inst.defineMethod('toPrecision', TP.NumberProto.toPrecision);
    Number.Inst.defineMethod('toString', TP.NumberProto.toString);
    Number.Inst.defineMethod('valueOf', TP.NumberProto.valueOf);

    //  Object.Type.defineMethod('assign', Object.assign); // E6
    Object.Type.defineMethod('create', Object.create);
    Object.Type.defineMethod('defineProperty', Object.defineProperty);
    Object.Type.defineMethod('defineProperties', Object.defineProperties);
    Object.Type.defineMethod('freeze', Object.freeze);
    Object.Type.defineMethod('getOwnPropertyDescriptor', Object.getOwnPropertyDescriptor);
    Object.Type.defineMethod('getOwnPropertyNames', Object.getOwnPropertyNames);
    //  Object.Type.defineMethod('getOwnPropertySymbols', Object.getOwnPropertySymbols); // E6
    Object.Type.defineMethod('getPrototypeOf', Object.getPrototypeOf);
    //  Object.Type.defineMethod('is', Object.is); // E6
    Object.Type.defineMethod('isExtensible', Object.isExtensible);
    Object.Type.defineMethod('isFrozen', Object.isFrozen);
    Object.Type.defineMethod('isSealed', Object.isSealed);
    Object.Type.defineMethod('keys', Object.keys);
    Object.Type.defineMethod('preventExtensions', Object.preventExtensions);
    Object.Type.defineMethod('seal', Object.seal);
    //  Object.Type.defineMethod('setPrototypeOf', Object.setPrototypeOf); // E6

    //  We don't expose an 'Object.Inst', but we need to register these methods.
    //  We have to be very careful here, though, so that we avoid creating slots
    //  on Object.prototype, which would cause problems when iterating through
    //  native objects being used as Hashes. So we register them with the
    //  metadata system using a 'light touch' (i.e. without calling
    //  TP.defineMethodSlot()).

    TP.ObjectProto.hasOwnProperty.asMethod(
            TP.ObjectProto,
            'hasOwnProperty',
            TP.INST_TRACK,
            'Object.Inst.hasOwnProperty');
    TP.sys.addMetadata(
            Object,
            TP.ObjectProto.hasOwnProperty,
            TP.METHOD,
            TP.INST_TRACK);

    TP.ObjectProto.isPrototypeOf.asMethod(
            TP.ObjectProto,
            'isPrototypeOf',
            TP.INST_TRACK,
            'Object.Inst.isPrototypeOf');
    TP.sys.addMetadata(
            Object,
            TP.ObjectProto.isPrototypeOf,
            TP.METHOD,
            TP.INST_TRACK);

    TP.ObjectProto.propertyIsEnumerable.asMethod(
            TP.ObjectProto,
            'propertyIsEnumerable',
            TP.INST_TRACK,
            'Object.Inst.propertyIsEnumerable');
    TP.sys.addMetadata(
            Object,
            TP.ObjectProto.propertyIsEnumerable,
            TP.METHOD,
            TP.INST_TRACK);

    TP.ObjectProto.toLocaleString.asMethod(
            TP.ObjectProto,
            'toLocaleString',
            TP.INST_TRACK,
            'Object.Inst.toLocaleString');
    TP.sys.addMetadata(
            Object,
            TP.ObjectProto.toLocaleString,
            TP.METHOD,
            TP.INST_TRACK);

    TP.ObjectProto.toString.asMethod(
            TP.ObjectProto,
            'toString',
            TP.INST_TRACK,
            'Object.Inst.toString');
    TP.sys.addMetadata(
            Object,
            TP.ObjectProto.toString,
            TP.METHOD,
            TP.INST_TRACK);

    TP.ObjectProto.valueOf.asMethod(
            TP.ObjectProto,
            'valueOf',
            TP.INST_TRACK,
            'Object.Inst.valueOf');
    TP.sys.addMetadata(
            Object,
            TP.ObjectProto.valueOf,
            TP.METHOD,
            TP.INST_TRACK);

    //  Now we track those slot names because they're not obtainable by
    //  reflection
    TP.OBJECT_PROTO_SLOTS = [
        'hasOwnProperty',
        'isPrototypeOf',
        'propertyIsEnumerable',
        'toLocaleString',
        'toString',
        'valueOf'
    ];

    RegExp.Inst.defineMethod('exec', TP.RegExpProto.exec);
    RegExp.Inst.defineMethod('test', TP.RegExpProto.test);
    RegExp.Inst.defineMethod('toString', TP.RegExpProto.toString);

    String.Type.defineMethod('fromCharCode', String.fromCharCode);
    //  String.Type.defineMethod('fromCodePoint', String.fromCodePoint); // E6
    //  String.Type.defineMethod('raw', String.raw); // E6

    String.Inst.defineMethod('anchor', TP.StringProto.anchor);
    String.Inst.defineMethod('big', TP.StringProto.big);
    String.Inst.defineMethod('blink', TP.StringProto.blink);
    String.Inst.defineMethod('bold', TP.StringProto.bold);
    String.Inst.defineMethod('fixed', TP.StringProto.fixed);
    String.Inst.defineMethod('fontcolor', TP.StringProto.fontcolor);
    String.Inst.defineMethod('fontsize', TP.StringProto.fontsize);
    String.Inst.defineMethod('italics', TP.StringProto.italics);
    String.Inst.defineMethod('link', TP.StringProto.link);
    String.Inst.defineMethod('small', TP.StringProto.small);
    String.Inst.defineMethod('strike', TP.StringProto.strike);
    String.Inst.defineMethod('sub', TP.StringProto.sub);
    String.Inst.defineMethod('sup', TP.StringProto.sup);

    String.Inst.defineMethod('charAt', TP.StringProto.charAt);
    String.Inst.defineMethod('charCodeAt', TP.StringProto.charCodeAt);
    //  String.Inst.defineMethod('codePointAt', TP.StringProto.codePointAt); // E6
    String.Inst.defineMethod('concat', TP.StringProto.concat);
    //  String.Inst.defineMethod('includes', TP.StringProto.includes); // E6
    String.Inst.defineMethod('indexOf', TP.StringProto.indexOf);
    String.Inst.defineMethod('lastIndexOf', TP.StringProto.lastIndexOf);
    String.Inst.defineMethod('localeCompare', TP.StringProto.localeCompare);
    String.Inst.defineMethod('match', TP.StringProto.match);
    //  String.Inst.defineMethod('normalize', TP.StringProto.normalize); // E6
    //  String.Inst.defineMethod('repeat', TP.StringProto.repeat); // E6
    String.Inst.defineMethod('replace', TP.StringProto.replace);
    String.Inst.defineMethod('search', TP.StringProto.search);
    String.Inst.defineMethod('slice', TP.StringProto.slice);
    String.Inst.defineMethod('split', TP.StringProto.split);
    String.Inst.defineMethod('substring', TP.StringProto.substring);
    String.Inst.defineMethod('substr', TP.StringProto.substr);
    String.Inst.defineMethod('toLocaleLowerCase',
                            TP.StringProto.toLocaleLowerCase);
    String.Inst.defineMethod('toLocaleUpperCase',
                            TP.StringProto.toLocaleUpperCase);
    String.Inst.defineMethod('toLowerCase', TP.StringProto.toLowerCase);
    String.Inst.defineMethod('toString', TP.StringProto.toString);
    String.Inst.defineMethod('toUpperCase', TP.StringProto.toUpperCase);
    String.Inst.defineMethod('trim', TP.StringProto.trim);
    String.Inst.defineMethod('valueOf', TP.StringProto.valueOf);

    //  Restore the real load information
    TP.boot[TP.LOAD_PATH] = currentLoadPath;
    TP.boot[TP.LOAD_PACKAGE] = currentLoadPackage;
    TP.boot[TP.LOAD_CONFIG] = currentLoadConfig;
    TP.boot[TP.LOAD_STAGE] = currentLoadStage;

    TP.boot[TP.SOURCE_PATH] = currentSourcePath;
    TP.boot[TP.SOURCE_PACKAGE] = currentSourcePackage;
    TP.boot[TP.SOURCE_CONFIG] = currentSourceConfig;

}());

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETLocalization.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
The types and methods in this file are here to support localization in a variety
of forms. Of particular interest is providing support for localizing strings,
data formats, and data validations for built-in types like Number, Boolean, and
Date.

Extension types such as phone numbers, social security numbers, and other types
which are locale-specific are found in the xml/lang section of the library.
These are often loaded using the import functionality in TIBET to let the system
load specific "language packs" on demand. Much of the functionality in those
modules relies on TIBET "type clusters" which return a locale-specific subtype
from a top-level type's construct() call.

The TIBET object maintains the "current locale" while the various TP.i18n.Locale
subtypes provide the actual functionality for localization. The language code
for the current locale is used by "localized" types such as TP.tibet.PhoneNumber
to determine the specific subtype to use.

Methods on the TIBET hash for aqcuiring the current "source language" and the
current "target language" provide the default values translation.
*/

//  ========================================================================
//  TIBET Locale Extensions
//  ========================================================================

//  the default locale, which is configured lazily to support setting via
//  the application startup process
TP.sys.defineAttribute('locale');

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getLocale',
function(iso) {

    /**
     * @method getLocale
     * @summary Return the current locale type.
     * @returns {TP.meta.i18n.Locale} A TP.i18n.Locale subtype type object.
     */

    var locale;

    if (TP.notEmpty(iso)) {
        return TP.i18n.Locale.getLocaleById(iso);
    }

    locale = this.$get('locale');

    if (TP.notValid(locale)) {
        return TP.i18n.Locale;
    }

    return locale;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('setLocale',
function(aLocale) {

    /**
     * @method setLocale
     * @summary Sets the current locale, which is used by numerous types to
     *     provide localization support.
     * @param {TP.meta.i18n.Locale} A TP.i18n.Locale subtype type object.
     */

    var lang,
        locale;

    if (TP.isEmpty(aLocale)) {
        //  no locale? request for default one based on users language when
        //  possible, or US-EN when not available.
        lang = TP.sys.env('tibet.xmllang', 'en-us').toLowerCase();

        locale = TP.i18n.Locale.getLocaleById(lang);

        if (TP.notValid(locale)) {
            locale = TP.i18n.Locale;
        }
    } else {
        if (TP.isString(aLocale)) {
            //  this might be null, but clearing the value will cause the
            //  getLocale() routine to return the default
            locale = TP.i18n.Locale.getLocaleById(aLocale);
        } else if (TP.canInvoke(aLocale, 'localizeString')) {
            locale = aLocale;
        } else {
            this.raise('TP.sig.InvalidParameter');

            locale = TP.i18n.Locale;
        }
    }

    //  We don't force locales to load string tables if they're not going to
    //  ever be activated via setLocale, but if we're going to use the locale we
    //  need to activate it so we can switch string tables etc.
    locale.activate();

    this.$set('locale', locale);

    return this;
});

//  ========================================================================
//  Object Extensions
//  ========================================================================

TP.defineCommonMethod('localize',
function(aLocale) {

    /**
     * @method localize
     * @summary Returns a localized string version of the receiver.
     * @param {TP.i18n.Locale|String} aLocale The locale to use for resolution.
     * @returns {Object} A localized version of the source object.
     */

    var locale,
        localeObj;

    locale = aLocale;
    if (TP.notValid(locale)) {
        locale = TP.sys.getLocale();
    }

    //  allow passage of the locale's ID string
    if (TP.isString(locale)) {
        localeObj = TP.i18n.Locale.getLocaleById(locale);
    } else {
        localeObj = locale;
    }

    if (TP.notValid(localeObj)) {
        //  The best we can do is log a warning and return the original
        //  object unlocalized.

        TP.ifWarn() ?
            TP.warn('Couldn\'t find locale for: ' + locale) : 0;

        return this;
    }

    return localeObj.localize(this);
});

//  ========================================================================
//  TP.i18n.Locale
//  ========================================================================

/**
 * @type {TP.i18n.Locale}
 * @summary TP.i18n.Locale is the supertype from which all locales inherit.
 *     Locales are the control point for localization in TP.sys.
 * @summary TP.i18n.Locales are the focal point of TIBET's
 *     internationalization system. Each locale is associated with a
 *     language/country code as specified in ISO 639. Therefore, the
 *     TP.i18n.Locale for U.S. English is registered under the key 'en-us'. If a
 *     locale existed for French Canadian, it would be registered under 'fr-ca'.
 *
 *     The TIBET boot property 'locale' defines the default locale to load when
 *     an application starts. If this value is not specified it defaults to
 *     'en-us'.
 *
 *     When the current locale is set (via TP.sys.setLocale(aLocale)), it takes
 *     over responsibility for several localization functions including offering
 *     support for string translation, data formats, and data validations. Also
 *     supported are parse routines specific to dealing with Boolean, Number,
 *     Date, and String input.
 *
 *     Additional support for localization of content is provided by the
 *     TP.uri.URI type's rewrite function, which uses the current locale's
 *     language code as a qualifier for locating URI aliases and other mapping
 *     data. See the TP.uri.URI type for more information.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('i18n.Locale');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  the language code for this locale. this value is typically set by the locale
//  as part of the type's definition. we default them to empty strings to avoid
//  getting null values when building out our ID etc.
TP.i18n.Locale.Type.defineAttribute('langCode', '');

//  the country code for the locale. not set in all cases, but a good example is
//  'us' for en-us and 'gb' for en-gb as defined by those locales.
TP.i18n.Locale.Type.defineAttribute('countryCode', '');

//  Boolean defaults
TP.i18n.Locale.Type.defineAttribute('falseStrings',
            TP.ac('0', '', 'n', 'N', 'no', 'No', 'NO', 'f', 'F',
                'false', 'False', 'FALSE'));

TP.i18n.Locale.Type.defineAttribute('trueStrings',
            TP.ac('1', 'y', 'Y', 'yes', 'Yes', 'YES', 't', 'T',
                'true', 'True', 'TRUE'));

//  Date defaults
TP.i18n.Locale.Type.defineAttribute('longMonthNames',
            TP.ac('January', 'February', 'March', 'April',
                'May', 'June', 'July', 'August', 'September', 'October',
                'November', 'December'));

TP.i18n.Locale.Type.defineAttribute('longWeekdayNames',
            TP.ac('Sunday', 'Monday', 'Tuesday',
                'Wednesday', 'Thursday', 'Friday', 'Saturday'));

TP.i18n.Locale.Type.defineAttribute('shortMonthNames',
            TP.ac('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
                'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'));

TP.i18n.Locale.Type.defineAttribute('shortWeekdayNames',
            TP.ac('Sun', 'Mon', 'Tue', 'Wed', 'Thu',
                'Fri', 'Sat'));

TP.i18n.Locale.Type.defineAttribute('dateFormat',
    '%{yyyy}-%{mm}-%{dd}T%{hhi}:%{mmn}:%{ss}Z');    //  iso UTC
    // '%{dddd}, %{mmmm} %{dd}, %{yyyy} %{hhi}:%{mmn}:%{ss}'); //   UTC

//  Number defaults
TP.i18n.Locale.Type.defineAttribute('numberFormat', '#{#,###.##########}');
TP.i18n.Locale.Type.defineAttribute('thousandsMatcher', /,/g);
TP.i18n.Locale.Type.defineAttribute('thousandsSeparator', ',');
TP.i18n.Locale.Type.defineAttribute('decimalPoint', '.');
TP.i18n.Locale.Type.defineAttribute('thousandsGroupSize', 3);

//  the ISO key, which is the language code plus country code if the country
//  code isn't empty.
TP.i18n.Locale.Type.defineAttribute('langID');

TP.i18n.Locale.Type.defineAttribute('locales', TP.hc());

//  ------------------------------------------------------------------------
//  Type.Local Attributes/Methods
//  ------------------------------------------------------------------------

//  The system string table. All string localization calls ultimately try to
//  find a key/value mapping in this object, which is maintained in raw form
//  to support usage of slices of this content as the system's TP.msg object.
//  NOTE that this is a raw object, not a hash or other augmented object so
//  as a result we have to use the full descriptor syntax of defineAttribute.
TP.i18n.Locale.defineAttribute('strings', {});

//  ------------------------------------------------------------------------

TP.i18n.Locale.defineConstant('ROOT_ISO_KEY', 'root');

//  ------------------------------------------------------------------------

TP.i18n.Locale.defineMethod('registerLocale',
function(aLocale, aKey) {

    /**
     * @method registerLocale
     * @summary Registers the locale provided under the locale's language code,
     *     allowing it to be found quickly. Note that by using one or more calls
     *     and different keys you can map a particular locale as the handler for
     *     a number of language and country code combinations.
     * @param {TP.meta.Locale} aLocale A TP.i18n.Locale subtype type object.
     * @param {String} aKey The language-country code key to use to register
     *     this locale.
     * @returns {TP.meta.Locale} A TP.i18n.Locale subtype type object.
     */

    var key;

    if (!TP.isSubtypeOf(aLocale, TP.i18n.Locale)) {
        return this.raise('TP.sig.InvalidLocale', aLocale);
    }

    key = aKey;
    if (TP.notValid(key)) {
        key = aLocale.getISOKey();
    }

    //  NOTE the reference to the TP.i18n.Locale type here rather than
    //  "this", so we use the shared hash
    TP.i18n.Locale.get('locales').atPut(key, aLocale);

    return this;
});

//  ------------------------------------------------------------------------

TP.i18n.Locale.defineMethod('getLocaleById',
function(aLocaleID) {

    /**
     * @method getLocaleById
     * @summary Returns the TP.i18n.Locale subtype registered under the
     *     language code provided. Note that the language code should be the
     *     full four-character language code, such as en-us or fr-ca when
     *     possible, to ensure proper resolution.
     * @param {String} aLocaleID The language-country code to look up.
     * @returns {TP.meta.i18n.Locale|undefined} A TP.i18n.Locale subtype type
     *     object.
     */

    var loc;

    //  first test is for an exact match
    if (TP.isType(loc = this.get('locales').at(aLocaleID))) {
        return loc;
    }

    //  perhaps not registered, but can be found by name?
    if (TP.isType(loc = TP.sys.getTypeByName(
                aLocaleID.strip('-').toUpperCase() + 'Locale'))) {
        TP.i18n.Locale.registerLocale(loc);
        return loc;
    }

    //  alternative is for the language without country code
    if (TP.isType(loc =
                    this.get('locales').at(aLocaleID.split('-').first()))) {
        return loc;
    }

    //  perhaps not registered, but can be found for language only?
    if (TP.isType(loc = TP.sys.getTypeByName(
                aLocaleID.split('-').first().toUpperCase() + 'Locale'))) {
        TP.i18n.Locale.registerLocale(loc);
        return loc;
    }

    return;
});

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('activate',
function() {

    /**
     * @method activate
     * @summary Ensures any resources such as string table content is loaded for
     *     the receiver.
     * @returns {TP.meta.i18n.Locale} The receiver.
     */

    var locales,
        msg;

    msg = {};

    //  Loop over our supertypes to ensure we catch things like en for en-gb.
    locales = this.getSupertypes();
    locales.unshift(this);
    locales = locales.slice(0, locales.indexOf(TP.i18n.Locale) + 1);
    locales.reverse();

    locales.forEach(
            function(locale) {
                var dict;

                dict = locale.getISOStrings();
                TP.keys(dict).forEach(function(key) {
                    msg[key] = dict[key];
                });
            });

    //  Update the map reference.
    TP.msg = msg;

    return this;
});

//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('getISOKey',
function() {

    /**
     * @method getISOKey
     * @summary Returns the receiver's ISO key, for a Locale the language code
     *     plus country code if the country code isn't empty.
     * @returns {String} The receiver's language code.
     */

    var id,
        country;

    if (TP.notEmpty(id = this.get('langID'))) {
        return id;
    }

    if (TP.notEmpty(country = this.$get('countryCode'))) {
        id = TP.join(this.get('langCode'), '-', country);
    } else {
        id = this.get('langCode');
    }

    this.$set('langID', id);

    return id;
});

//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('getISOStrings',
function(aKey) {

    /**
     * @method getISOStrings
     * @param {String} aKey The language-country code key to use to register
     *     this locale.
     * @returns {Object} The populated string dictionary for the key.
     */

    var iso,
        strings,
        dict;

    //  Get the key we'll be registering under. This depends on the receiving
    //  locale's iso key by default.
    iso = aKey;
    if (TP.notValid(iso)) {
        iso = this.getISOKey();
    }
    iso = TP.ifEmpty(iso, TP.i18n.Locale.ROOT_ISO_KEY);

    //  Check for existing string definitions for this locale/key and create it
    //  if it's not found.
    strings = TP.i18n.Locale.get('strings');
    if (TP.notValid(strings)) {
        strings = {};
        TP.i18n.Locale.set('strings', strings);
    }

    dict = strings[iso];
    if (TP.notValid(dict)) {
        dict = {};
        strings[iso] = dict;
    }

    return dict;
});

//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('registerStrings',
function(dictionary) {

    /**
     * @method registerStrings
     * @summary Registers one or more key/value pairs as localizable strings. If
     *     the root locale is messaged the dictionary should include a top level
     *     which is keyed by ISO key such as { en: { // english strings }}. If
     *     no top-level ISO keys are found the strings are registered with the
     *     current default locale. If this method is invoked on a specific
     *     locale the receiving locale's ISO key is used and the dictionary
     *     should just be key/value pairs for strings to be registered.
     * @param {String|Object|TP.lang.Hash} dictionary The set of key/value pairs,
     *     enclosed in an outer ISO-key indexed dictionary as needed. If a
     *     string is provided is must be valid JSON which can parse correctly.
     * @returns {Object} The resulting populated string lookup object.
     */

    var data,
        keys,
        found,
        dict,
        current;

    if (TP.isEmpty(dictionary)) {
        return this.raise('InvalidParameter',
            'Empty or non-existing string data.');
    }

    if (TP.isString(dictionary)) {
        try {
            data = JSON.parse(dictionary);
        } catch (e) {
            return this.raise('InvalidParameter',
                'Non-JSON string table data in string form.');
        }
    } else {
        data = dictionary;
    }

    data = TP.hc(data);
    keys = data.getKeys();

    //  If we're messaging the top-level locale we need to know if we're dealing
    //  with multiple ISO keys or just a key/value dictionary of strings.
    if (this === TP.i18n.Locale) {
        found = keys.detect(function(key) {
            return TP.isValid(TP.i18n.Locale.getLocaleById(key));
        });

        if (found) {
            keys.forEach(function(key) {
                var locale;

                locale = TP.i18n.Locale.getLocaleById(key);
                if (TP.isValid(locale)) {
                    locale.registerStrings(data.at(key));
                }
            });
        } else {
            return TP.sys.getLocale().registerStrings(data);
        }
    }

    //  Get our locale-specific string table, building as necessary.
    dict = this.getISOStrings();

    //  Iterate over data (hash, obj, etc) and load up our strings.
    keys.forEach(function(key) {
        dict[key] = data.at(key);
    });

    //  Force reactivation of the current locale. We can't be sure that the
    //  strings just registered don't fall somewhere along the lookup chain.
    current = TP.sys.getLocale();
    if (this === current) {
        this.activate();
    }

    return dict;
});

//  ========================================================================
//  Formatting Support
//  ========================================================================

/**
 * @The localize() series of methods provide for localized formatting of data,
 *     i.e. "output formatting".
 */

//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('localize',
function(anObject) {

    /**
     * @method localize
     * @summary Returns a localized version of the object provided. This method
     *     serves as a top-level dispatcher which directs the object to a proper
     *     handler function by type. NOTE that no localization is attempted by
     *     the TP.i18n.Locale type itself, so unless a locale is installed via
     *     TP.sys.setLocale() this method will return the original object.
     * @param {Object} anObject The object to localize.
     * @returns {Object} A localized version of the source object.
     */

    var tname,
        fname;

    //  we'll be using the type name to switch, or build a method lookup key
    //  so we start there
    tname = TP.tname(anObject);

    //  the "big four" for localization are boolean, date, number, and
    //  string which we test for here
    switch (tname) {
        case 'String':

            return this.localizeString(anObject);
        case 'Boolean':

            return this.localizeBoolean(anObject);
        case 'Number':

            return this.localizeNumber(anObject);
        case 'Date':

            return this.localizeDate(anObject);
        default:

            //  default is to do simplified "callBestMethod" approach
            fname = 'localize' + tname;
            if (TP.canInvoke(this, fname)) {
                return this.fname(anObject);
            }

            break;
    }

    //  if all else fails we just return the object
    return anObject;
});

//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('localizeBoolean',
function(aBoolean) {

    /**
     * @method localizeBoolean
     * @summary Returns the translated string value of the boolean provided.
     * @param {Boolean} aBoolean The boolean to localize.
     * @returns {String} The translation of the boolean, or the boolean if no
     *     translation was found.
     */

    var str;

    str = aBoolean.toString();

    return this.localizeString(str);
});

//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('getFalseStrings',
function() {

    /**
     * @method getFalseStrings
     * @summary Returns the strings used for comparing to the 'false' value. In
     *     this type, this method does nothing. Subtypes should override to
     *     provide real functionality.
     * @returns {String[]} The array of string values that is considered to be
     *     'false'.
     */

    return this.$get('falseStrings');
});

//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('getTrueStrings',
function() {

    /**
     * @method getTrueStrings
     * @summary Returns the strings used for comparing to the 'true' value. In
     *     this type, this method does nothing. Subtypes should override to
     *     provide real functionality.
     * @returns {String[]} The array of string values that is considered to be
     *     'true'.
     */

    return this.$get('trueStrings');
});

//  ------------------------------------------------------------------------
//  Date Formatting
//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('localizeDate',
function(aDate) {

    /**
     * @method localizeDate
     * @summary Returns the translated string value of the date provided.
     * @param {Date} aDate The date to localize.
     * @returns {String} The translation of the date, or the date if no
     *     translation was found.
     */

    var format,

        i,
        en,
        str,

        names;

    if (TP.notEmpty(format = this.getDateFormat())) {
        str = format.transformDate(aDate);
    } else {
        str = aDate.toString();
    }

    //  first pass always produces english since that's what JS works from,
    //  now we want to process that into an alternative based on the locale

    //  TODO:   optimize this series by creating/escaping a RegExp and doing
    //          replacement. This is pure brute force and pretty slow :(

    en = TP.i18n.Locale.getLongMonthNames();
    names = this.getLongMonthNames();

    for (i = 0; i < en.length; i++) {
        str = str.replace(en.at(i), names.at(i));
    }

    en = TP.i18n.Locale.getLongWeekdayNames();
    names = this.getLongWeekdayNames();

    for (i = 0; i < en.length; i++) {
        str = str.replace(en.at(i), names.at(i));
    }

    en = TP.i18n.Locale.getShortMonthNames();
    names = this.getShortMonthNames();

    for (i = 0; i < en.length; i++) {
        str = str.replace(en.at(i), names.at(i));
    }

    en = TP.i18n.Locale.getShortWeekdayNames();
    names = this.getShortWeekdayNames();

    for (i = 0; i < en.length; i++) {
        str = str.replace(en.at(i), names.at(i));
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('getDateFormat',
function() {

    /**
     * @method getDateFormat
     * @summary Returns the substitution format ('%{m}%{d}%{y}') to use as the
     *     format for localized dates.
     * @returns {String} The formatting date string.
     */

    return this.$get('dateFormat');
});

//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('getLongMonthNames',
function() {

    /**
     * @method getLongMonthNames
     * @summary Returns an array of long month names with values that are
     *     similar to 'January' to 'December' in this locale corresponding to
     *     integers 0 - 11. In this type, this method does nothing. Subtypes
     *     should override to provide real functionality.
     * @returns {String[]} An array of long month names.
     */

    return this.$get('longMonthNames');
});

//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('getLongWeekdayNames',
function() {

    /**
     * @method getLongWeekdayNames
     * @summary Returns an array of long weekday names with values that are
     *     similar to 'Sunday' to 'Saturday' in this locale corresponding to
     *     integers 0 - 7. In this type, this method does nothing. Subtypes
     *     should override to provide real functionality.
     * @returns {String[]} An array of long weekday names.
     */

    return this.$get('longWeekdayNames');
});

//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('getShortMonthNames',
function() {

    /**
     * @method getShortMonthNames
     * @summary Returns an array of short month names with values that are
     *     similar to 'Jan' to 'Dec' in this locale corresponding to integers 0
     *     - 11. In this type, this method does nothing. Subtypes should
     *     override to provide real functionality.
     * @returns {String[]} An array of short month names.
     */

    return this.$get('shortMonthNames');
});

//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('getShortWeekdayNames',
function() {

    /**
     * @method getShortWeekdayNames
     * @summary Returns an array of short weekday names with values that are
     *     similar to 'Sun' to 'Sat' in this locale corresponding to integers 0
     *     - 7. In this type, this method does nothing. Subtypes should override
     *     to provide real functionality.
     * @returns {String[]} An array of short weekday names.
     */

    return this.$get('shortWeekdayNames');
});

//  ------------------------------------------------------------------------
//  Number Formatting
//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('localizeNumber',
function(aNumber) {

    /**
     * @method localizeNumber
     * @summary Returns the translated string value of the number provided.
     * @param {Number} aNumber The number to localize.
     * @returns {String} The translation of the number, or the number if no
     *     translation was found.
     */

    var oldLocale,
        format,

        retVal;

    //  Because Number formatting relies on properties of the 'current locale'
    //  such as 'thousandsSeparator', etc. and these properties are accessed on
    //  *the current locale* as the Number is formatted, we must temporarily set
    //  the current locale to ourself.

    oldLocale = TP.sys.getLocale();
    TP.sys.setLocale(this);

    if (TP.notEmpty(format = this.getNumberFormat())) {
        retVal = format.transformNumber(aNumber);
    } else {
        retVal = aNumber;
    }

    //  Restore the locale we came in with
    TP.sys.setLocale(oldLocale);

    return retVal;
});

//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('getNumberFormat',
function() {

    /**
     * @method getNumberFormat
     * @summary Returns the substitution format (i.e. '#{#,###}') to use as the
     *     format for localized numbers.
     * @returns {String} The formatting string.
     */

    return this.$get('numberFormat');
});

//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('getThousandsMatcher',
function() {

    /**
     * @method getThousandsMatcher
     * @summary Returns a regex used when detecting thousands digits.
     * @returns {String} The regular expression used to match thousands.
     */

    return this.$get('thousandsMatcher');
});

//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('getThousandsSeparator',
function() {

    /**
     * @method getThousandsSeparator
     * @summary Returns the character used when separating thousands digits. In
     *     this type, this method does nothing. Subtypes should override to
     *     provide real functionality.
     * @returns {String} The character used to separate thousands.
     */

    return this.$get('thousandsSeparator');
});

//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('getDecimalPoint',
function() {

    /**
     * @method getDecimalPoint
     * @summary Returns the character used for a decimal point. In this type,
     *     this method does nothing. Subtypes should override to provide real
     *     functionality.
     * @returns {String} The character used for a decimal point.
     */

    return this.$get('decimalPoint');
});

//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('getThousandsGroupSize',
function() {

    /**
     * @method getThousandsGroupSize
     * @summary Returns the size of the thousands grouping. For most locales
     *     this is 3, however Japan uses 4.
     * @returns {Number} The size of the thousands group.
     */

    return this.$get('thousandsGroupSize');
});

//  ------------------------------------------------------------------------
//  String Formatting
//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('localizeString',
function(aString) {

    /**
     * @method localizeString
     * @summary Returns the translated value of the string if one has been
     * registered via registerString(s).
     * @param {String} aString The string to localize.
     * @returns {String} The translation of the string, or the string if no
     *     translation was found.
     */

    var str,
        dict;

    if (TP.isEmpty(aString)) {
        return aString;
    }

    //  Make sure we have a string primitive.
    str = '' + aString;

    //  If we're current then we can defer to the TP.msg content.
    if (TP.sys.getLocale() === this) {
        return TP.msg[str] || str;
    }

    dict = this.getISOStrings();

    return dict[str] || str;
});

//  ========================================================================
//  Parsing Support
//  ========================================================================

//  ------------------------------------------------------------------------
//  Boolean Parsing
//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('parseBoolean',
function(aString) {

    /**
     * @method parseBoolean
     * @summary Returns the Boolean value of the string provided, as localized
     *     for the receiving locale.
     * @param {String} aString The input string to parse.
     * @returns {Boolean} The localized Boolean value.
     */

    var str;

    str = this.localizeString(aString);

    //  match against our false strings and consider everything else true
    return !this.getFalseStrings().containsString(str);
});

//  ------------------------------------------------------------------------
//  Date Parsing
//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('parseDate',
function(aString) {

    /**
     * @method parseDate
     * @summary Returns the Date value of the string provided, as localized for
     *     the receiving locale.
     * @param {String} aString The input string to parse.
     * @returns {Date} The localized Date value.
     */

    //  the typical originator for a parse() is the object itself, so we'll
    //  normally have gone through Date.parse() which first tries the TIBET
    //  supplied parsers for maximum correctness and flexibility and then
    //  the now-somewhat-less sad (as of ECMAScript E5) native Date.parse()
    //  routine.
    //  By the time we get here all we can do is use the standard Date
    //  constructor or hope a subtype overrides with smarter logic for that
    //  locale.
    return new Date(aString);
});

//  ------------------------------------------------------------------------
//  Number Parsing
//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('parseNumber',
function(aString) {

    /**
     * @method parseNumber
     * @summary Returns the Number value of the string provided, as localized
     *     for the receiving locale.
     * @param {String} aString The input string to parse.
     * @returns {Number} The localized Number value.
     */

    var str,
        sep;

    str = aString;

    //  watch for strings with "thousandsSeparators" in them
    sep = this.getThousandsSeparator();
    str = str.strip(sep, '');

    //  with thousands separator gone we now change decimal point to
    //  the one JS expects ('.')
    sep = this.getDecimalPoint();
    str = str.replace(sep, '.');

    /* eslint-disable no-new-wrappers */
    return new Number(str);
    /* eslint-enable no-new-wrappers */
});

//  ------------------------------------------------------------------------
//  String Parsing
//  ------------------------------------------------------------------------

TP.i18n.Locale.Type.defineMethod('parseString',
function(aString) {

    /**
     * @method parseString
     * @summary Returns the String value of the string provided, as localized
     *     for the receiving locale.
     * @param {String} aString The input string to parse.
     * @returns {String} The localized String value.
     */

    return this.localizeString(aString);
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETFormatting.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
The types and methods in this file support data formatting, particularly
producing string representations for various input/output requirements.

NOTE: The functionality here is integrated with TP.i18n.Locale support to enable
formatters to be driven by the current locale.
*/

//  ========================================================================
//  Object Formatters
//  ========================================================================

/**
The methods defined in this section provide support for common data formats via
TIBET's as() and from() method interfaces. Using obj.as(format) where format is
any type will cause TIBET to automatically dispatch to either a local method
specific to the receiver, or to the type to invoke it's from() method. The
formats here support string and Node representations suitable for display or
storage of HTML, XML (defaulting to XMLRPC), or JSON strings.

When the format is a string the receiver's asString method is called. Many of
the common types in TIBET will respond to this by using type-specific rules for
processing format strings. For example, Date and Number allow you to provide a
UTC #35 (http://www.unicode.org/reports/tr35/tr35-4.html) format string.
*/

//  ------------------------------------------------------------------------
//  "AS" Support
//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('asHTMLNode',
function(aDocument) {

    /**
     * @method asHTMLNode
     * @summary Produces an HTML node representation of the receiver if
     *     possible. By default this method relies on the markup string produced
     *     by asHTMLString for source text. NOTE that when a string would
     *     produce multiple "top level" nodes for the receiver a document
     *     fragment is returned with the list.
     * @param {HTMLDocument} aDocument The document which should own the result
     *     node. Defaults to the current canvas's document.
     * @returns {Node} The receiver in HTML node format.
     */

    return TP.stringAsHTMLNode(this.asHTMLString(), aDocument);
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver. By
     *     default this method returns the receiver's string value without
     *     changes.
     * @returns {String} The receiver in XML string format.
     */

    var marker,
        arr,
        keys,
        len,
        i,
        key;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asHTMLString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }

    //  NB: For 'Object', we put this in a try...catch since some native Objects
    //  (i.e. XHR objects) don't like to have slots placed on them.
    try {
        this[marker] = true;
    } catch (e) {
        void 0;
    }

    //  perform a simple conversion based on filtering rule if any

    arr = TP.ac();

    keys = this.getKeys();
    len = keys.getSize();

    arr.push('<span class="Object ', TP.escapeTypeName(TP.tname(this)), '">');

    try {
        for (i = 0; i < len; i++) {
            key = keys.at(i);
            arr.push('<span data-name="', key, '">',
                          TP.htmlstr(this.at(key)),
                        '</span>');
        }
    } finally {
        arr.push('</span>');
        try {
            delete this[marker];
        } catch (e) {
            void 0;
        }
    }

    return arr.join('');
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('asKvPairs',
function() {

    /**
     * @method asKvPairs
     * @summary Returns the receiver's keys and values as key/value pairs.
     * @returns {Array[]} The receivers key/value pairs.
     */

    return this.getKVPairs();
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('asXHTMLNode',
function() {

    /**
     * @method asXHTMLNode
     * @summary Produces an XHTML node representation of the receiver if
     *     possible. By default this method relies on the markup string produced
     *     by asXHTMLString for source text.
     * @returns {Node} The receiver in XHTML node format.
     */

    return TP.nodeFromString(this.asXHTMLString());
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('asXHTMLString',
function() {

    /**
     * @method asXHTMLString
     * @summary Produces an XHTML string representation of the receiver. By
     *     default this method returns the receiver's string value without
     *     changes.
     * @returns {String} The receiver in XHTML string format.
     */

    return this.asString();
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('asXMLNode',
function() {

    /**
     * @method asXMLNode
     * @summary Produces an XML node representation of the receiver if
     *     possible. By default this method relies on the markup string produced
     *     by asXMLString for source text.
     * @returns {Node} The receiver in XML node format.
     */

    return TP.nodeFromString(this.asXMLString());
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('asXMLString',
function(aFilterName) {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver. By
     *     default this method returns the receiver's string value without
     *     changes.
     * @param {String} aFilterName A get*Interface() filter spec.
     * @returns {String} The receiver in XML string format.
     */

    var marker,
        arr,
        keys,
        len,
        i,
        key;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asXMLString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }

    //  NB: For 'Object', we put this in a try...catch since some native Objects
    //  (i.e. XHR objects) don't like to have slots placed on them.
    try {
        this[marker] = true;
    } catch (e) {
        void 0;
    }

    //  perform a simple conversion based on filtering rule if any

    arr = TP.ac();

    keys = this.getKeys();
    len = keys.getSize();

    try {
        for (i = 0; i < len; i++) {
            key = keys.at(i);
            arr.push('<', key, '>', TP.xmlstr(this.at(key)), '</', key, '>');
        }
    } finally {
        try {
            delete this[marker];
        } catch (e) {
            void 0;
        }
    }

    return arr.join('');
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    var marker,
        joinCh,
        joinArr,
        str,
        thisref,
        $depth,
        $level;

    this.$sortIfNeeded();

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asDumpString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    joinCh = this.$get('delimiter');

    if (!TP.isString(joinCh)) {
        //  If 'joinCh' is not a String, maybe it's a hash or other Object with
        //  a 'join' property.
        if (!TP.isString(joinCh = joinCh.get('join'))) {
            joinCh = '';
        }
    }

    str = '[' + TP.tname(this) + ' :: ';

    $depth = TP.ifInvalid(depth, 1);
    $level = TP.ifInvalid(level, 0);

    thisref = this;
    try {
        joinArr = this.collect(
            function(item, index) {
                if (item === thisref) {
                    if (TP.canInvoke(item, 'asRecursionString')) {
                        return item.asRecursionString();
                    } else {
                        return 'this';
                    }
                }

                if ($level > $depth && TP.isMutable(this)) {
                    return str + '@' + TP.id(this) + ']';
                } else {
                    return TP.dump(item, $depth, $level + 1);
                }
            });

        str += '[' + joinArr.join(joinCh) + ']]';
    } catch (e) {
        str += '[' + this.join(', ') + ']]';
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    var len,

        marker,
        arr,
        i;

    len = this.getSize();
    if (len === 0) {
        return '[]';
    }

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asJSONSource';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    arr = TP.ac();
    arr.push('[');

    try {
        for (i = 0; i < len; i++) {
            arr.push(TP.jsonsrc(this.at(i)), ',');
        }

        arr.pop();
    } finally {
        arr.push(']');
        delete this[marker];
    }

    return arr.join('');
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver. By
     *     default this method returns the receiver's string value without
     *     changes.
     * @returns {String} The receiver in HTML string format.
     */

    var marker,
        arr,
        len,
        i;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asHTMLString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    arr = TP.ac();
    len = this.getSize();
    arr.push('<span class="Array">');

    try {
        for (i = 0; i < len; i++) {
            arr.push(
                '<span data-name="', i, '">',
                    TP.htmlstr(this.at(i)),
                '</span>');
        }
    } finally {
        arr.push('</span>');
        delete this[marker];
    }

    return arr.join('');
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} A new String containing the 'pretty print' string of
     *     the receiver.
     */

    var marker,
        joinArr,
        i,
        len,
        joinStr;

    this.$sortIfNeeded();

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asPrettyString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    joinArr = TP.ac();
    len = this.getSize();

    try {
        for (i = 0; i < len; i++) {
            joinArr.push(
                TP.join('<dt class="pretty key">', i, '</dt>',
                        '<dd class="pretty value">',
                            TP.pretty(this.at(i)),
                        '</dd>'));
        }

        joinStr = '<dl class="pretty ' + TP.escapeTypeName(TP.tname(this)) +
                        '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' +
                        this.getTypeName() +
                    '</dd>' +
                    joinArr.join('') +
                    '</dl>';
    } catch (e) {
        joinStr = Object.prototype.toString.call(this);
    } finally {
        delete this[marker];
    }

    return joinStr;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver. By
     *     default this method returns the receiver's string value without
     *     changes.
     * @returns {String} The receiver in XML string format.
     */

    var marker,
        arr,
        len,
        i;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asXMLString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    //  perform a simple conversion based on filtering rule if any
    arr = TP.ac();
    len = this.getSize();

    try {
        for (i = 0; i < len; i++) {
            arr.push(
                '<item index="', i, '">',
                    TP.xmlstr(this.at(i)),
                '</item>');
        }
    } finally {
        delete this[marker];
    }

    return arr.join('');
});

//  ------------------------------------------------------------------------

Boolean.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver. By
     *     default this method returns the receiver's string value without
     *     changes.
     * @returns {String} The receiver in HTML string format.
     */

    return TP.str(this);
});

//  ------------------------------------------------------------------------

Boolean.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} A new String containing the 'pretty print' string of
     *     the receiver.
     */

    return '<dl class="pretty Boolean"><dt/><dd>' +
            TP.str(this) +
            '</dd></dl>';
});

//  ------------------------------------------------------------------------

Boolean.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver. By
     *     default this method returns the receiver's string value without
     *     changes.
     * @returns {String} The receiver in XML string format.
     */

    return TP.str(this);
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    var str;

    str = '[' + TP.tname(this) + ' :: ';

    try {
        if (TP.sys.hasKernel()) {
            str += TP.sys.getLocale().localizeDate(this) + ']';
        } else {
            str += this.toUTCString() + ']';
        }
    } catch (e) {
        str += TP.id(this) + ']';
    }

    return str;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver. By
     *     default this method returns the receiver's string value without
     *     changes.
     * @returns {String} The receiver in HTML string format.
     */

    return TP.str(this);
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    return this.toISOString().quoted('"');
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} A new String containing the 'pretty print' string of
     *     the receiver.
     */

    //  '.toISOString()' is an ECMA ed5 addition
    return '<dl class="pretty Date"><dt/><dd>' +
            TP.str(this) +
            '</dd></dl>';
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver. By
     *     default this method returns the receiver's string value without
     *     changes.
     * @returns {String} The receiver in XML string format.
     */

    return TP.str(this);
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    var str;

    str = '[' + TP.tname(this) + ' :: ';

    //  The only way to discern between Function objects that are one of the
    //  native constructors (types) and a regular Function object.
    if (TP.isNativeType(this)) {
        return str + this.getName() + ']';
    }

    //  Function instances dump their signature.
    return str + this.getSignature() + ']';
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver. By
     *     default this method returns the receiver's string value without
     *     changes.
     * @returns {String} The receiver in HTML string format.
     */

    //  The only way to discern between Function objects that are one of the
    //  native constructors (types) and a regular Function object.
    if (TP.isNativeType(this)) {
        return '<span class="NativeType">' +
                this.getName() +
                '</span>';
    }

    return TP.str(this);
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('asJSONSource',
function(aFilterName, aLevel) {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @param {String} aFilterName Ignored.
     * @param {Number} aLevel If 0, returns function() {...}
     * @returns {String} A JSON-formatted string.
     */

    var supertypeName,

        str,
        lvl;

    //  The only way to discern between Function objects that are one of the
    //  native constructors (types) and a regular Function object.
    if (TP.isNativeType(this)) {
        supertypeName = this !== Object ? '"Object"' : '""';

        return '{"type":"NativeType",' +
                '"data":{"name":' + this.getName().quoted('"') + ',' +
                '"supertypes":[' + supertypeName + ']}}';
    }

    if (TP.isType(this)) {
        return TP.join(this.getSupertype().getName(),
                        '.defineSubtype(\'', this.getNamespacePrefix(), ':',
                        this.getLocalName(), '\');');
    }

    lvl = TP.notDefined(aLevel) ? TP.sys.cfg('stack.max_descent') :
                                Math.max(0, aLevel);

    if (lvl === 0) {
        str = '(function () {})';
    } else {
        str = TP.join(
                '(',
                this.toString().tokenizeWhitespace().replace('{ }', '{}'),
                ')');
        str = str.quoted('"');
    }

    return str;
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} A new String containing the 'pretty print' string of
     *     the receiver.
     */

    //  The only way to discern between Function objects that are one of the
    //  native constructors (types) and a regular Function object.
    if (TP.isNativeType(this)) {
        return '<dl class="pretty NativeType">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' +
                        'NativeType.&lt;' + TP.name(this) + '&gt;' +
                    '</dd>' +
                    '<dt/>' +
                    '<dd class="pretty value">' +
                        this.getName() +
                    '</dd>' +
                    '</dl>';
    }

    return '<dl class="pretty Function"><dt/><dd>' +
            TP.objectToString(this) +
            '</dd></dl>';
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver. By
     *     default this method returns the receiver's string value without
     *     changes.
     * @returns {String} The receiver in XML string format.
     */

    //  The only way to discern between Function objects that are one of the
    //  native constructors (types) and a regular Function object.
    if (TP.isNativeType(this)) {
        return '<type>' + this.getName() + '</type>';
    }

    return TP.str(this);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver. By
     *     default this method returns the receiver's string value without
     *     changes.
     * @returns {String} The receiver in HTML string format.
     */

    return TP.str(this);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} A new String containing the 'pretty print' string of
     *     the receiver.
     */

    return '<dl class="pretty Number"><dt/><dd>' +
            TP.str(this) +
            '</dd></dl>';
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver. By
     *     default this method returns the receiver's string value without
     *     changes.
     * @returns {String} The receiver in XML string format.
     */

    return TP.str(this);
});

//  ------------------------------------------------------------------------

RegExp.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    //   We use 'toString()' rather than the 'source' property, since it
    //   includes the flags, etc.
    return '[' + TP.tname(this) + ' :: ' + this.toString() + ']';
});

//  ------------------------------------------------------------------------

RegExp.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver. By
     *     default this method returns the receiver's string value without
     *     changes.
     * @returns {String} The receiver in HTML string format.
     */

    return TP.str(this);
});

//  ------------------------------------------------------------------------

RegExp.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    //   We use 'toString()' rather than the 'source' property, since it
    //   includes the flags, etc.
    return this.toString().quoted('"');
});

//  ------------------------------------------------------------------------

RegExp.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} A new String containing the 'pretty print' string of
     *     the receiver.
     */

    return '<dl class="pretty RegExp"><dt/><dd>' +
            this.toString() +
            '</dd></dl>';
});

//  ------------------------------------------------------------------------

RegExp.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver. By
     *     default this method returns the receiver's string value without
     *     changes.
     * @returns {String} The receiver in XML string format.
     */

    return TP.str(this);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver. By
     *     default this method returns the receiver's string value without
     *     changes.
     * @returns {String} The receiver in HTML string format.
     */

    var str;

    str = this.toString();

    if (TP.regex.IS_ELEM_MARKUP.test(str)) {
        return str;
    }

    return TP.htmlLiteralsToEntities(str);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} A new String containing the 'pretty print' string of
     *     the receiver.
     */

    var str;

    str = this.toString();

    if (TP.regex.CONTAINS_ELEM_MARKUP.test(str)) {

        str = str.asEscapedXML();
    }

    return '<dl class="pretty String"><dt/><dd>' +
            str +
            '</dd></dl>';
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver. By
     *     default this method returns the receiver's string value without
     *     changes.
     * @returns {String} The receiver in XML string format.
     */

    var str;

    str = this.toString();

    if (TP.regex.IS_ELEM_MARKUP.test(str)) {
        return str;
    }

    return TP.xmlLiteralsToEntities(TP.htmlEntitiesToXMLEntities(str));
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    return '[' + TP.tname(this) + ' :: ' + this.getName() + ']';
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver.
     * @returns {String} The receiver in HTML string format.
     */

    return '<span class="TP.lang.RootObject">' +
            this.getName() +
            '</span>';
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    var stNames;

    stNames = this.getSupertypeNames().collect(
                                function(aName) {
                                    return aName.quoted('"');
                                });

    return '{' +
            '"type":' + this.getTypeName().quoted('"') + ',' +
            '"data":' +
                '{' +
                    '"name":' + this.getName().quoted('"') + ',' +
                    '"abstract":' + this.isAbstract() + ',' +
                    '"nsRoot":' + this.get('nsRoot').quoted('"') + ',' +
                    '"nsPrefix":' + this.get('nsPrefix').quoted('"') + ',' +
                    '"localName":' + this.get('localName').quoted('"') + ',' +
                    '"supertypes":[' + stNames.join(',') + ']' +
                '}' +
            '}';
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} A new String containing the 'pretty print' string of
     *     the receiver.
     */

    return '<dl class="pretty TP.lang.RootObject">' +
                '<dt>Type name</dt>' +
                '<dd class="pretty typename">' +
                    'TP.lang.RootObject.&lt;' + TP.name(this) + '&gt;' +
                '</dd>' +
                '<dt/>' +
                '<dd class="pretty value">' +
                    this.getName() +
                '</dd>' +
                '</dl>';
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver.
     * @returns {String} The receiver in XML string format.
     */

    return '<type>' + this.getName() + '</type>';
});

//  ------------------------------------------------------------------------

TP.lang.Object.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    var marker,
        joinArr,
        keys,
        len,
        i,
        str,
        val,
        $depth,
        $level;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asDumpString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    joinArr = TP.ac();
    keys = TP.keys(this);
    len = keys.getSize();

    str = '[' + TP.tname(this) + ' :: ';

    $depth = TP.ifInvalid(depth, 1);
    $level = TP.ifInvalid(level, 0);

    try {
        for (i = 0; i < len; i++) {
            //  Filter out internal keys.
            if (TP.regex.INTERNAL_SLOT.test(keys.at(i))) {
                continue;
            }

            val = this.get(keys.at(i));

            if (val === this) {
                if (TP.canInvoke(val, 'asRecursionString')) {
                    joinArr.push(
                        TP.join(keys.at(i), ' => ', val.asRecursionString()));
                } else {
                    joinArr.push(TP.join(keys.at(i), ' => this'));
                }
            } else {
                if ($level > $depth && TP.isMutable(this)) {
                    joinArr.push(TP.join(keys.at(i), ' => ',
                        '@' + TP.id(this) + ']'));
                } else {
                    joinArr.push(TP.join(keys.at(i), ' => ',
                        TP.dump(val, $depth, $level + 1)));
                }
            }
        }

        str += '(' + joinArr.join(', ') + ')' + ']';
    } catch (e) {
        TP.warn(e.message + ' in ' + TP.id(this) + ' dump string for key ' +
            keys.at(i));
        str += '(' + TP.str(this) + ')' + ']';
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.lang.Object.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver.
     * @returns {String} The receiver in HTML string format.
     */

    var marker,
        joinArr,
        keys,
        len,
        i,
        joinStr;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asHTMLString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    joinArr = TP.ac();
    keys = TP.keys(this);
    len = keys.getSize();

    try {
        for (i = 0; i < len; i++) {
            joinArr.push(
                    TP.join('<span data-name="', keys.at(i), '">',
                            TP.htmlstr(this.get(keys.at(i))),
                            '</span>'));
        }

        joinStr = '<span class="TP_lang_Object ' +
                        TP.escapeTypeName(TP.tname(this)) + '">' +
                     joinArr.join('') +
                     '</span>';
    } catch (e) {
        joinStr = Object.prototype.toString.call(this);
    } finally {
        delete this[marker];
    }

    return joinStr;
});

//  ------------------------------------------------------------------------

TP.lang.Object.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    var marker,
        joinArr,
        keys,
        len,
        i,
        joinStr;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asJSONSource';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    joinArr = TP.ac();
    keys = TP.keys(this);
    len = keys.getSize();

    try {
        for (i = 0; i < len; i++) {
            joinArr.push(
                    TP.join(keys.at(i).quoted('"'),
                            ':',
                            TP.jsonsrc(this.get(keys.at(i)))));
        }

        joinStr = '{"type":"' + TP.tname(this) + '",' +
                    '"data":{' + joinArr.join(',') + '}}';
    } catch (e) {
        joinStr = Object.prototype.toString.call(this);
    } finally {
        delete this[marker];
    }

    return joinStr;
});

//  ------------------------------------------------------------------------

TP.lang.Object.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} A new String containing the 'pretty print' string of
     *     the receiver.
     */

    var marker,
        joinArr,
        keys,
        len,
        i,
        joinStr;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asPrettyString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    joinArr = TP.ac();
    keys = TP.keys(this);
    len = keys.getSize();

    try {
        for (i = 0; i < len; i++) {
            joinArr.push(
                TP.join('<dt class="pretty key">', keys.at(i), '</dt>',
                        '<dd class="pretty value">',
                            TP.pretty(this.at(keys.at(i))),
                        '</dd>'));
        }

        joinStr = '<dl class="pretty ' + TP.escapeTypeName(TP.tname(this)) +
                        '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' +
                        this.getTypeName() +
                    '</dd>' +
                    joinArr.join('') +
                    '</dl>';
    } catch (e) {
        joinStr = Object.prototype.toString.call(this);
    } finally {
        delete this[marker];
    }

    return joinStr;
});

//  ------------------------------------------------------------------------

TP.lang.Object.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver.
     * @returns {String} The receiver in XML string format.
     */

    var marker,
        joinArr,
        keys,
        len,
        i,
        joinStr;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asXMLString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    joinArr = TP.ac();
    keys = TP.keys(this);
    len = keys.getSize();

    try {
        for (i = 0; i < len; i++) {
            joinArr.push(
                    TP.join('<', keys.at(i), '>',
                            TP.xmlstr(this.get(keys.at(i))),
                            '</', keys.at(i), '>'));
        }

        joinStr = '<instance type="' + TP.tname(this) + '">' +
                     joinArr.join('') +
                     '</instance>';
    } catch (e) {
        joinStr = Object.prototype.toString.call(this);
    } finally {
        delete this[marker];
    }

    return joinStr;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETCalendaring.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @summary Types supporting various date, time, timezone, and calendar
 *     functionality.
 */

//  ========================================================================
//  TP.iso.ISO8601
//  ========================================================================

/**
 * @type {TP.iso.ISO8601}
 * @summary A type which can produce a representation of a Date in a valid ISO
 *     8601 format or parse a string in a valid 8601 format into a native
 *     JavaScript Date object.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('iso.ISO8601');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.iso.ISO8601.Type.defineConstant('ISO_DATE_REGEX',
        /^(\d{4})-?(\d{2})?-?(\d{2})?(T(\d{2})(:(\d{2})(:(\d{2})(\.(\d{1,3}))?)?)?)?(Z)?([\+\-]\d{2}:\d{2})?$/);

TP.iso.ISO8601.Type.defineConstant('ISO_TZ_REGEX', /([\+\-])(\d{2}):(\d{2})/);

//  ---
//  Formatting
//  ---

TP.iso.ISO8601.Type.defineConstant('FORMATS', TP.hc());

//  ---
//  Date component formats
//  ---

TP.iso.ISO8601.FORMATS.atPut('YYYY', '%{yyyy}');

//  year/month/day
TP.iso.ISO8601.FORMATS.atPut('YYYYMM', '%{yyyy}%{mm}');
TP.iso.ISO8601.FORMATS.atPut('YYYYMMDD', '%{yyyy}%{mm}%{dd}');

TP.iso.ISO8601.FORMATS.atPut('YYYY-MM', '%{yyyy}-%{mm}');
TP.iso.ISO8601.FORMATS.atPut('YYYY-MM-DD', '%{yyyy}-%{mm}-%{dd}');

//  year/week/day
TP.iso.ISO8601.FORMATS.atPut('YYYYWWW', '%{yyyy}W%{ww}');
TP.iso.ISO8601.FORMATS.atPut('YYYYWWWD', '%{yyyy}W%{ww}%{dw}');

TP.iso.ISO8601.FORMATS.atPut('YYYY-WWW', '%{yyyy}-W%{ww}');
TP.iso.ISO8601.FORMATS.atPut('YYYY-WWWD', '%{yyyy}-W%{ww}%{dw}');
TP.iso.ISO8601.FORMATS.atPut('YYYY-WWW-D', '%{yyyy}-W%{ww}-%{dw}');

//  year/day-of-year
TP.iso.ISO8601.FORMATS.atPut('YYYYDDD', '%{yyyy}%{dy}');
TP.iso.ISO8601.FORMATS.atPut('YYYY-DDD', '%{yyyy}-%{dy}');

//  ---
//  Time component formats
//  ---

//  the formats here will optionally have a trailing Z for zulu time, or a
//  plus (+) to symbolize using an offset time
TP.iso.ISO8601.FORMATS.atPut('HH', '%{hhi}');
TP.iso.ISO8601.FORMATS.atPut('HHZ', '%{hhi}Z');
TP.iso.ISO8601.FORMATS.atPut('HH+', '%{hhi}+');

TP.iso.ISO8601.FORMATS.atPut('HHMM', '%{hhi}%{mmn}');
TP.iso.ISO8601.FORMATS.atPut('HHMMZ', '%{hhi}%{mmn}Z');
TP.iso.ISO8601.FORMATS.atPut('HHMM+', '%{hhi}%{mmn}+');

TP.iso.ISO8601.FORMATS.atPut('HHMMSS', '%{hhi}%{mmn}%{ss}');
TP.iso.ISO8601.FORMATS.atPut('HHMMSSZ', '%{hhi}%{mmn}%{ss}Z');
TP.iso.ISO8601.FORMATS.atPut('HHMMSS+', '%{hhi}%{mmn}%{ss}+');

TP.iso.ISO8601.FORMATS.atPut('HH:MM', '%{hhi}:%{mmn}');
TP.iso.ISO8601.FORMATS.atPut('HH:MMZ', '%{hhi}:%{mmn}Z');
TP.iso.ISO8601.FORMATS.atPut('HH:MM+', '%{hhi}:%{mmn}+');

TP.iso.ISO8601.FORMATS.atPut('HH:MM:SS', '%{hhi}:%{mmn}:%{ss}');
TP.iso.ISO8601.FORMATS.atPut('HH:MM:SSZ', '%{hhi}:%{mmn}:%{ss}Z');
TP.iso.ISO8601.FORMATS.atPut('HH:MM:SS+', '%{hhi}:%{mmn}:%{ss}+');

//  ---
//  Date/Time combination formats
//  ---

//  year/month/day plus time, expanded -- this one's the default ISO
TP.iso.ISO8601.FORMATS.atPut('YYYY-MM-DDTHH:MM:SS',
                            '%{yyyy}-%{mm}-%{dd}T%{hhi}:%{mmn}:%{ss}');
TP.iso.ISO8601.FORMATS.atPut('YYYY-MM-DDTHH:MM:SSZ',
                            '%{yyyy}-%{mm}-%{dd}T%{hhi}:%{mmn}:%{ss}Z');
TP.iso.ISO8601.FORMATS.atPut('YYYY-MM-DDTHH:MM:SS+',
                            '%{yyyy}-%{mm}-%{dd}T%{hhi}:%{mmn}:%{ss}+');

//  year/month/day plus time, date condensed -- this one's used by XML-RPC
TP.iso.ISO8601.FORMATS.atPut('YYYYMMDDTHH:MM:SS',
                            '%{yyyy}%{mm}%{dd}T%{hhi}:%{mmn}:%{ss}');
TP.iso.ISO8601.FORMATS.atPut('YYYYMMDDTHH:MM:SSZ',
                            '%{yyyy}%{mm}%{dd}T%{hhi}:%{mmn}:%{ss}Z');
TP.iso.ISO8601.FORMATS.atPut('YYYYMMDDTHH:MM:SS+',
                            '%{yyyy}%{mm}%{dd}T%{hhi}:%{mmn}:%{ss}+');

//  year/month/day plus time, condensed
TP.iso.ISO8601.FORMATS.atPut('YYYYMMDDTHHMMSS',
                            '%{yyyy}%{mm}%{dd}T%{hhi}%{mmn}%{ss}');
TP.iso.ISO8601.FORMATS.atPut('YYYYMMDDTHHMMSSZ',
                            '%{yyyy}%{mm}%{dd}T%{hhi}%{mmn}%{ss}Z');
TP.iso.ISO8601.FORMATS.atPut('YYYYMMDDTHHMMSS+',
                            '%{yyyy}%{mm}%{dd}T%{hhi}%{mmn}%{ss}+');

//  year/week/day plus time, expanded
TP.iso.ISO8601.FORMATS.atPut('YYYY-WWW-DTHH:MM:SS',
                            '%{yyyy}-W%{ww}-%{dw}T%{hhi}:%{mmn}:%{ss}');
TP.iso.ISO8601.FORMATS.atPut('YYYY-WWW-DTHH:MM:SSZ',
                            '%{yyyy}-W%{ww}-%{dw}T%{hhi}:%{mmn}:%{ss}Z');
TP.iso.ISO8601.FORMATS.atPut('YYYY-WWW-DTHH:MM:SS+',
                            '%{yyyy}-W%{ww}-%{dw}T%{hhi}:%{mmn}:%{ss}+');

//  year/week/day plus time, condensed
TP.iso.ISO8601.FORMATS.atPut('YYYYWWWDTHHMMSS',
                            '%{yyyy}W%{ww}%{dw}T%{hhi}%{mmn}%{ss}');
TP.iso.ISO8601.FORMATS.atPut('YYYYWWWDTHHMMSSZ',
                            '%{yyyy}W%{ww}%{dw}T%{hhi}%{mmn}%{ss}Z');
TP.iso.ISO8601.FORMATS.atPut('YYYYWWWDTHHMMSS+',
                            '%{yyyy}W%{ww}%{dw}T%{hhi}%{mmn}%{ss}+');

//  year/day-of-year plus time, expanded
TP.iso.ISO8601.FORMATS.atPut('YYYY-DDDTHH:MM:SS',
                            '%{yyyy}-%{dy}T%{hhi}:%{mmn}:%{ss}');
TP.iso.ISO8601.FORMATS.atPut('YYYY-DDDTHH:MM:SSZ',
                            '%{yyyy}-%{dy}T%{hhi}:%{mmn}:%{ss}Z');
TP.iso.ISO8601.FORMATS.atPut('YYYY-DDDTHH:MM:SS+',
                            '%{yyyy}-%{dy}T%{hhi}:%{mmn}:%{ss}+');

//  year/day-of-year plus time, condensed
TP.iso.ISO8601.FORMATS.atPut('YYYYDDDTHHMMSS',
                            '%{yyyy}%{dy}T%{hhi}%{mmn}%{ss}');
TP.iso.ISO8601.FORMATS.atPut('YYYYDDDTHHMMSSZ',
                            '%{yyyy}%{dy}T%{hhi}%{mmn}%{ss}Z');
TP.iso.ISO8601.FORMATS.atPut('YYYYDDDTHHMMSS+',
                            '%{yyyy}%{dy}T%{hhi}%{mmn}%{ss}+');

//  named formats
TP.iso.ISO8601.FORMATS.atPut('XMLRPC',
                            '%{yyyy}%{mm}%{dd}T%{hhi}:%{mmn}:%{ss}');
TP.iso.ISO8601.FORMATS.atPut('TIMESTAMP',
                            '%{yyyy}%{mm}%{dd}T%{hhi}%{mmn}%{ss}.%{fff}');

Date.addParser(TP.iso.ISO8601);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.iso.ISO8601.Type.defineMethod('fromDate',
function(aDate, aFormat) {

    /**
     * @method fromDate
     * @summary Returns an instance of String that encodes aDate in the format
     *     according to the format string provided.
     * @description This method is used as the standard output method for most
     *     date strings. It attempts to produce a valid ISO 8601 string from the
     *     date provided according to the instructions found in the format
     *     string.
     *
     *     While the Date type in TIBET has been extended to support a wide
     *     variety of formatting strings you can only use one of the specific
     *     named formats in this call to ensure a valid 8601 string is produced.
     *
     *     There are three major variations for the date portion of an ISO 8601
     *     string:
     *
     *     YYYY[-]MM[-]DD Year, Month, Day, where each element other than year
     *     is optional.
     *
     *     YYYY[-]W[WW]-[D] Year, WeekOfYear, DayOfWeek (Note that the 'W' is
     *     an explicit 'W' here and the Day is the number of the day of the week
     *     where Monday is day 1 and Sunday is day 7 (unlike JS). Week numbers
     *     are from 01 to 53.
     *
     *     YYYY[-][D] Year, DayOfYear where DayOfYear is from 1 to 366
     *     (supports leap years).
     *
     *     These variations can optionally be combined with a time portion by
     *     adding an uppercase T between the parts as in:
     *
     *     2006-05-08T12:01:23
     *
     *     The time portion of an ISO 8601 string follows the form:
     *
     *     HH[:]MM[:]SS[.mmm][Z|[+|-]th:tm]
     *
     *     If no time zone data is provided the time is considered to be in the
     *     currently active time zone. A trailing Z indicates "zulu" or UTC
     *     time, all other values define an offset from UFC either + or - in
     *     HH:MM terms.
     * @param {Date} aDate The Date to format.
     * @param {String} aFormat The format string to use.
     * @returns {String} The formatted Date value.
     */

    if (!TP.isDate(aDate)) {
        return this.raise('TP.sig.InvalidParameter', aDate);
    }

    if (TP.isEmpty(aFormat)) {
        //  default is ISO with UTC zone
        return 'YYYY-MM-DDTHH:MM:SSZ'.transformDate(aDate);
    }

    return aFormat.transformDate(aDate);
});

//  ------------------------------------------------------------------------

TP.iso.ISO8601.Type.defineMethod('fromString',
function(aString, sourceLocale) {

    /**
     * @method fromString
     * @summary Attempts to parse the string provided into a Date, then convert
     *     that Date into a valid TP.iso.ISO8601 formatted string. If successful
     *     the ISO string is returned.
     * @param {String} aString The potential date string.
     * @param {TP.i18n.Locale|String} sourceLocale A source xml:lang or locale
     *     defining the language the string is now in.
     * @returns {String} An TP.iso.ISO8601 string.
     */

    var dateStr;

    //  use Date's fromString routine since it's the most flexible parser
    dateStr = Date.fromString(aString, sourceLocale);

    //  if we got a valid date then format it as TP.iso.ISO8601
    if (TP.isDate(dateStr)) {
        return this.fromDate(dateStr);
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.iso.ISO8601.Type.defineMethod('parse',
function(aString) {

    /**
     * @method parse
     * @summary Return the Date defined by the string provided.
     * @description This routine is invoked by the Date type when running its
     *     list of registered Date parsers in an attempt to parse an input
     *     string.
     *
     *     ISO 8601 is the default date format for TIBET both in terms of
     *     output and input. This type is automatically registered with the Date
     *     type as a date parser to ensure we can at least process standard JS
     *     date and ISO 8601 date formats.
     *
     *     There are three major variations for the date portion of an ISO 8601
     *     string:
     *
     *     YYYY[-]MM[-]DD Year, Month, Day
     *
     *     YYYY[-]W[KK]-[D] Year, WeekOfYear, DayOfWeek (Note that the 'W' is
     *     an explicit 'W' here and the Day is the number of the day of the week
     *     where Monday is day 1 and Sunday is day 7 (unlike JS). Week numbers
     *     are from 01 to 53.
     *
     *     YYYY[-][D] Year, DayOfYear where DayOfYear is from 1 to 366 (in leap
     *     years).
     *
     *     These variations can optionally be combined with a time portion by
     *     adding an uppercase T between the parts as in:
     *
     *     2006-05-08T12:01:23
     *
     *     The time portion of an ISO 8601 string follows the form:
     *
     *     HH[:]MM[:]SS[.mmm][Z|[+|-]th:tm]
     *
     *     If no time zone data is provided the time is considered to be in the
     *     currently active time zone. A trailing Z indicates "zulu" or UTC
     *     time, all other values define an offset from UFC either + or - in
     *     HH:MM terms.
     * @param {String} aString An TP.iso.ISO8601 string.
     * @exception TP.sig.InvalidParameter
     * @returns {Date|null} A new Date object representing the Date encoded in
     *     the parameter.
     */

    var parts,
        dateStr,
        timeStr,

        isUTC,
        arr,
        newDate,
        dow,
        duration,
        timeMatcher,
        zoneMatcher;

    if (!TP.isString(aString)) {
        return null;
    }

    //  someone who's better with regular expressions can probably do this
    //  a lot faster, but we'll take it in smaller steps...

    //  split on T so we can deal with date and time separately
    parts = aString.split('T');
    dateStr = parts.at(0);
    timeStr = parts.at(1);

    //  now the question is, what do we do when there's no 'T' since YYYY
    //  and HHMM look a lot alike to a regex :)

    //  if the time portion is empty (no T), but we see a :, Z, +, or - then
    //  we're really looking at a time specification, not a date
    if (TP.notValid(timeStr) && /[Z:\+\-]/.test(dateStr)) {
        timeStr = dateStr;
        dateStr = null;
    }

    //  when there's a time component and we've got either a Z or offset
    //  then all our other operations have to be UTC-based
    if (TP.isString(timeStr) && TP.regex.HAS_TIMEZONE.test(timeStr)) {
        isUTC = true;
    } else {
        isUTC = false;
    }

    //  process date component if any
    if (TP.isString(dateStr)) {
        //  remove optional dashes to make this easier
        dateStr = dateStr.strip(/\-/g);

        //  date portion could be y, y-m, y-m-d, y-w, y-w-d, or y-d
        if (/W/.test(dateStr)) {
            //  either y-w or y-w-d with optional -'s
            if (TP.isEmpty(arr =
                            dateStr.match(/^(\d{4})W(\d{2})(\d{1})?$/))) {
                return null;
            }

            //  must be a year and week if there was a match
            newDate = isUTC ?
                        Date.constructUTCDayOne(arr.at(1)) :
                        Date.constructDayOne(arr.at(1));

            newDate.setISOWeek(arr.at(2));

            //  the day is optional, and defines the day of the week
            //  intended...
            if (TP.isString(arr.at(3))) {
                if (arr.at(3) !== 1) {
                    dow = isUTC ?
                            newDate.getUTCDayOfWeek() :
                            newDate.getDayOfWeek();

                    duration = TP.join('P', arr.at(3) - dow, 'D');
                    newDate = newDate.addDuration(duration);
                }
            }
        } else if (dateStr.getSize() === 7) {
            //  no W but only 7 digits means year plus day-of-year
            if (TP.notValid(arr = dateStr.match(/^(\d{4})(\d{3})$/))) {
                return null;
            }

            //  must be a year and day if there was a match
            newDate = isUTC ?
                        Date.constructUTCDayOne(arr.at(1)) :
                        Date.constructDayOne(arr.at(1));

            duration = TP.join('P', arr.at(2) - 1, 'D');
            newDate = newDate.addDuration(duration);
        } else {
            //  4, 6, or 8 digits
            if (TP.notValid(arr =
                            dateStr.match(/^(\d{4})(\d{2})?(\d{2})?$/))) {
                return null;
            }

            if (isUTC) {
                newDate = Date.constructUTCDayOne(arr.at(1));
                TP.isString(arr.at(2)) ?
                        newDate.setUTCMonth(arr.at(2) - 1) : null;
                TP.isString(arr.at(3)) ?
                        newDate.setUTCDate(arr.at(3)) : null;
            } else {
                newDate = Date.constructDayOne(arr.at(1));
                TP.isString(arr.at(2)) ?
                        newDate.setMonth(arr.at(2) - 1) : null;
                TP.isString(arr.at(3)) ?
                        newDate.setDate(arr.at(3)) : null;
            }
        }
    }

    //  process time component if any
    if (TP.isString(timeStr)) {
        //  if this is a time-only entry then it's for today
        if (TP.notValid(newDate)) {
            newDate = isUTC ? Date.todayUTC() : Date.today();
        }

        //  first remove colons to make things easier
        timeStr = timeStr.strip(/:/g);

        //  no time zone in this portion, just hh:mn:ss.fff
        timeMatcher = /^(\d{2})(\d{2})?(\d{2})?(\.(\d*))?/;

        if (TP.notValid(arr = timeStr.match(timeMatcher))) {
            return null;
        }

        //  set hours, minutes, seconds, milliseconds as needed
        if (isUTC) {
            TP.isString(arr.at(1)) ?
                    newDate.setUTCHours(arr.at(1)) : null;
            TP.isString(arr.at(2)) ?
                    newDate.setUTCMinutes(arr.at(2)) : null;
            TP.isString(arr.at(3)) ?
                    newDate.setUTCSeconds(arr.at(3)) : null;
            TP.isString(arr.at(5)) ?
                    newDate.setUTCMilliseconds(arr.at(5)) : null;
        } else {
            TP.isString(arr.at(1)) ?
                    newDate.setHours(arr.at(1)) : null;
            TP.isString(arr.at(2)) ?
                    newDate.setMinutes(arr.at(2)) : null;
            TP.isString(arr.at(3)) ?
                    newDate.setSeconds(arr.at(3)) : null;
            TP.isString(arr.at(5)) ?
                    newDate.setMilliseconds(arr.at(5)) : null;
        }

        //  utc here means there's timezone data involved
        if (isUTC) {
            if (/Z/.test(timeStr)) {
                //  no offset, GMT...and we're already there so return
                return newDate;
            } else {
                //  offset time, hhmm
                zoneMatcher = /[\+\-](\d{2})(\d{2})$/;

                if (TP.notValid(arr = timeStr.match(zoneMatcher))) {
                    return null;
                }

                //  use +/- to determine what to do with the offset duration
                //  data since we can't actually set the timezone
                if (/\+/.test(timeStr)) {
                    newDate = newDate.addDuration(
                        TP.join('PT', arr.at(1), 'H', arr.at(2), 'M'));
                } else {
                    newDate = newDate.subtractDuration(
                        TP.join('PT', arr.at(1), 'H', arr.at(2), 'M'));
                }
            }
        }
    }

    return newDate;
});

//  ------------------------------------------------------------------------

TP.iso.ISO8601.Type.defineMethod('validate',
function(anObj) {

    /**
     * @method validate
     * @summary Tests the incoming value to see if it represents a valid
     *     instance of the receiver.
     * @param {Object} anObj The object to test.
     * @returns {Boolean} True if the object is 'valid'.
     */

    //  if we can turn it into a date using our parse logic it's valid
    return TP.isDate(this.parse(anObj));
});

//  ========================================================================
//  TP.core.Duration
//  ========================================================================

/**
 * @type {TP.core.Duration}
 * @summary A helper class that represents a clock duration.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.Duration');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.Duration.Type.defineMethod('validate',
function(anObject) {

    /**
     * @method validate
     * @summary Returns true if the object provided it meets the criteria for a
     *     valid Duration string.
     * @param {Object} anObject The object whose value should be verified.
     * @returns {Boolean} True if the object is 'valid'.
     */

    var momentObj;

    if (!TP.isString(anObject)) {
        return false;
    }

    momentObj = TP.extern.moment(anObject, TP.ac('hh:mm a', 'HH:mm'));

    return momentObj.isValid();
});

//  ========================================================================
//  TP.core.Time
//  ========================================================================

/**
 * @type {TP.core.Time}
 * @summary A helper class that represents a clock time.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.Time');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.Time.Type.defineMethod('validate',
function(anObject) {

    /**
     * @method validate
     * @summary Returns true if the object provided it meets the criteria for a
     *     valid time string with optional time zone data.
     * @param {Object} anObject The object whose value should be verified.
     * @returns {Boolean} True if the object is 'valid'.
     */

    var momentObj;

    if (!TP.isString(anObject)) {
        return false;
    }

    momentObj = TP.extern.moment(anObject, TP.ac('hh:mm a', 'HH:mm'));

    return momentObj.isValid();
});

//  ========================================================================
//  TP.core.TimeZone
//  ========================================================================

/**
 * @type {TP.core.TimeZone}
 * @summary A helper class for xs:time, xs:date, and similar XMLSchema types
 *     which require timezone formatting/validation assistance.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.TimeZone');

//  ------------------------------------------------------------------------

//  a regex capable of validating the lexical format and splitting the
//  various segments out into a match result for further testing
TP.core.TimeZone.Type.defineConstant('ZONE_REGEX',
                            /^([Z\+\-])([0-9]{2})*[:]*([0-9]{2})*$/);

//  indexes into the match result produced by the previous RegExp
TP.core.TimeZone.Type.defineConstant('ZONE_INDEX', 1);
TP.core.TimeZone.Type.defineConstant('ZONE_HOUR_INDEX', 2);
TP.core.TimeZone.Type.defineConstant('ZONE_MINUTE_INDEX', 3);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.TimeZone.Type.defineMethod('validate',
function(anObject) {

    /**
     * @method validate
     * @summary Returns true if the object provided it meets the criteria for a
     *     valid time string with optional time zone data.
     * @param {Object} anObject The object whose value should be verified.
     * @returns {Boolean} True if the object is 'valid'.
     */

    var str,
        zoneMatch,

        zoneIndex,
        zoneHour,
        zoneMinute;

    if (!TP.isString(anObject)) {
        return false;
    }

    //  allow validation of a time zone as "local timezone"
    if (TP.isEmpty(anObject)) {
        return true;
    }

    str = anObject;

    zoneMatch = str.match(this.get('ZONE_REGEX'));
    if (TP.notValid(zoneMatch)) {
        return false;
    }

    //  ---
    //  TIME ZONE
    //  ---

    zoneIndex = zoneMatch.at(this.get('ZONE_INDEX'));
    zoneHour = zoneMatch.at(this.get('ZONE_HOUR_INDEX'));
    zoneMinute = zoneMatch.at(this.get('ZONE_MINUTE_INDEX'));

    //  can't be Z if there's a ZH or ZM (has to be a +)
    if (zoneIndex === 'Z') {
        if (TP.isString(zoneHour) || TP.isString(zoneMinute)) {
            return false;
        }
    } else if (zoneIndex === '+' || zoneIndex === '-') {
        if (TP.notValid(zoneHour) || TP.notValid(zoneMinute)) {
            return false;
        }

        //  hours can't be more than 14
        if (parseInt(zoneHour, 10) > 14) {
            return false;
        }

        //  if zone hours are 14, zone minutes must be 0
        if (parseInt(zoneHour, 10) === 14 && parseInt(zoneMinute, 10) !== 0) {
            return false;
        }
    }

    //  made it through the gauntlet
    return true;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETNativeTypes.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
Native type extensions specific to TIBET. Note that the native types which
are collections (Array, Object, and String) are managed in the
TIBETCollections component. Notice that String is in that list. TIBET treats
String objects as collections of characters rather than a primitive type,
and supports a variety of collection API methods on them as a result. See
the TIBETCollections.js file for more information.
*/

//  ========================================================================
//  Object
//  ========================================================================

TP.defineCommonMethod('asEscapedHTML',
function() {

    /**
     * @method asEscapedHTML
     * @summary Converts the receiver into a String where any HTML entities
     *     have been converted into their escaped equivalent (i.e. have been
     *     "entitified")
     * @returns {String} The receiver with escaped HTML entities.
     */

    return TP.htmlLiteralsToEntities(TP.str(this));
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('asEscapedXML',
function() {

    /**
     * @method asEscapedXML
     * @summary Converts the receiver into a String where any XML entities have
     *     been converted into their escaped equivalent (i.e. have been
     *     "entitified")
     * @returns {String} The receiver with escaped XML entities.
     */

    return TP.xmlLiteralsToEntities(
                    TP.htmlEntitiesToXMLEntities(TP.str(this)));
});

//  ========================================================================
//  Array
//  ========================================================================

Array.Type.defineMethod('from',
function(anObj, mapFunc, thisRef) {

    /**
     * @method from
     * @summary Constructs a new instance from the incoming object.
     * @description Array's implementation of 'from' has a native ES6 peer that
     *     we try to be compatible with. While TIBET has had as/from for a
     *     decade or more the semantics are slightly different. TIBET typically
     *     looks for a 'from{Type}' method to process 'from' calls while Array's
     *     native implementation works only for certain types and offers map
     *     functions for special conversions. Our approach here is that if there
     *     is a map function we defer entirely to the native invocation. When
     *     there's only one parameter we try to use Array's native approach but
     *     will redispatch to our callBestMethod approach if the result is [].
     * @param {Object} anObj The source object to use.
     * @param {Function} mapFunc An optional mapping function (which if present
     *     will force use of the native routine).
     * @param {Object} thisRef An optional binding reference for the mapFunc.
     * @returns {Object} A new instance of the receiver.
     */

    var arr,
        trimmed;

    //  Native from call fails on invalid inputs so let's be consistent.
    if (TP.notValid(anObj)) {
        return Array.ECMAfrom();
    }

    //  If there's more than just the object parameter the caller assumes
    //  it's talking to the native version so delegate there.
    if (TP.isValid(mapFunc)) {
        return Array.ECMAfrom(anObj, mapFunc, thisRef);
    }

    //  TIBET treats strings slightly differently. If it looks like JSON we try
    //  to de-serialize it to create the array.
    if (TP.isString(anObj)) {
        trimmed = anObj.trim();
        if (trimmed.startsWith('[') && trimmed.endsWith(']')) {
            try {
                return JSON.parse(anObj);
            } catch (err) {
                //  If an error then it's just a string...
                return Array.ECMAfrom(anObj);
            }
        }
    }

    //  Native Array, Map, Set collections are quickly convertible.
    if (TP.isValid(anObj[Symbol.iterator])) {
        return Array.ECMAfrom(anObj);
    }

    //  If it's a native data object we can also try the native routine first.
    if (TP.isNativeObject(anObj)) {
        arr = Array.ECMAfrom(anObj);

        if (TP.isEmpty(arr)) {
            return this.callBestMethod(arguments, anObj,
                'from', null, 'fromObject');
        }
    } else {
        return this.callBestMethod(arguments, anObj,
            'from', null, 'fromObject');
    }

    return arr;

});

//  ========================================================================
//  Boolean
//  ========================================================================

Boolean.Type.defineMethod('parseString',
function(aString, sourceLocale) {

    /**
     * @method parseString
     * @summary Returns the Boolean value of the string provided, as localized
     *     for the target locale.
     * @param {String} aString The input string to parse.
     * @param {String|TP.i18n.Locale} sourceLocale A source xml:lang or
     *     TP.i18n.Locale defining the language or locale the string is now in.
     * @returns {Boolean} The localized Boolean value.
     */

    return TP.sys.getLocale().parseBoolean(aString, sourceLocale);
});

//  ========================================================================
//  Date
//  ========================================================================

/**
 * @summary Extensions that make using Date a bit easier.
 * @description This file contains a number of conveniences for using a Date
 *     object, including adding and subtracting days, determining whether a
 *     particular year is a leap year, getting the number of days in a
 *     particular month, etc.
 */

//  ------------------------------------------------------------------------
//  Patches
//  ------------------------------------------------------------------------

if (new Date().getYear() > 1900) {
    Date.Inst.defineMethod('getYear',
    function() {

        return this.getFullYear() - 1900;
    });

    Date.Inst.defineMethod('setYear',
    function(year) {

        return this.setFullYear(year + 1900);
    });
}

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  a regex capable of validating the lexical format and splitting the
//  various segments out into a match result for further testing
Date.Type.defineConstant('DURATION_REGEX',
    TP.rc('^([-])*P([0-9]+Y)*([0-9]+M)*([0-9]+D)*([T])*([0-9]+H)*([0-9]+M)*([0-9]+(\\u002e[0-9]+)*S)*$'));

//  indexes into the match result produced by the previous RegExp
Date.Type.defineConstant('DURATION_MINUS_INDEX', 1);
Date.Type.defineConstant('DURATION_YEAR_INDEX', 2);
Date.Type.defineConstant('DURATION_MONTH_INDEX', 3);
Date.Type.defineConstant('DURATION_DAY_INDEX', 4);
Date.Type.defineConstant('DURATION_T_INDEX', 5);
Date.Type.defineConstant('DURATION_HOUR_INDEX', 6);
Date.Type.defineConstant('DURATION_MINUTE_INDEX', 7);
Date.Type.defineConstant('DURATION_SECOND_INDEX', 8);
Date.Type.defineConstant('DURATION_TIME_INDEX', 9);

Date.Type.defineConstant('SPERMIN', 60);
Date.Type.defineConstant('SPERHOUR', 3600);
Date.Type.defineConstant('SPERDAY', 86400);

Date.Type.defineConstant('MSPERMIN', 60000);
Date.Type.defineConstant('MSPERHOUR', 3600000);
Date.Type.defineConstant('MSPERDAY', 86400000);

Date.Type.defineConstant('THIS_YEAR', TP.dc().getFullYear());

//  NOTE: use the daysInFebruary method for any methods that need it
Date.Type.defineConstant('DAYS_PER_MONTH',
                    TP.ac(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31));

//  NOTE: These are the default names that get loaded with the Date type.
//  If a TP.i18n.Locale gets loaded it will replace the functions that
//  get values from these arrays with ones from the locale that gets set.
//  Therefore, DO NOT access these arrays directly. Use getDayName(),
//  getShortDayName(), getMonthName(), getShortMonthName().
Date.Type.defineConstant('LONG_WEEKDAY_NAMES',
                    TP.ac('Sunday', 'Monday', 'Tuesday', 'Wednesday',
                            'Thursday', 'Friday', 'Saturday'));

Date.Type.defineConstant('SHORT_WEEKDAY_NAMES',
                    TP.ac('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'));

Date.Type.defineConstant('LONG_MONTH_NAMES',
                    TP.ac('January', 'February', 'March', 'April', 'May',
                            'June', 'July', 'August', 'September',
                            'October', 'November', 'December'));

Date.Type.defineConstant('SHORT_MONTH_NAMES',
                    TP.ac('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul',
                            'Aug', 'Sep', 'Oct', 'Nov', 'Dec'));

Date.Type.defineConstant('LOCALTIME_TOKENS',
    TP.hc(
    'd', function(target) {

        return target.getDayOfMonth();
    },
    'dd', function(target) {

        return '#{00}'.transformNumber(target.getDayOfMonth());
    },
    'ddd', function(target) {

        return target.getShortDayName();
    },
    'dddd', function(target) {

        return target.getDayName();
    },
    'dw', function(target) {

        return target.getISODayOfWeek();
    },
    'dy', function(target) {

        return '#{000}'.transformNumber(target.getDayOfYear());
    },
    'ww', function(target) {

        return '#{00}'.transformNumber(target.getISOWeek());
    },
    'm', function(target) {

        return target.getISOMonth();
    },
    'mm', function(target) {

        return '#{00}'.transformNumber(target.getISOMonth());
    },
    'mmm', function(target) {

        return target.getShortMonthName();
    },
    'mmmm', function(target) {

        return target.getMonthName();
    },
    'yy', function(target) {

        return target.getFullYear().asString().slice(2);
    },
    'yyyy', function(target) {

        return target.getFullYear();
    },
    'h', function(target) {

        var hours;

        hours = target.getHours();

        if (hours > 12) {
            hours -= 12;
        }
        return hours;
    },
    'hi', function(target) {

        var hours;

        hours = target.getHours();

        return hours;
    },
    'hh', function(target) {

        var hours;

        hours = target.getHours();

        if (hours > 12) {
            hours -= 12;
        }
        return '#{00}'.transformNumber(hours);
    },
    'hhi', function(target) {

        var hours;

        hours = target.getHours();

        return '#{00}'.transformNumber(hours);
    },
    'mn', function(target) {

        return target.getMinutes();
    },
    'mmn', function(target) {

        return '#{00}'.transformNumber(target.getMinutes());
    },
    's', function(target) {

        return target.getSeconds();
    },
    'ss', function(target) {

        return '#{00}'.transformNumber(target.getSeconds());
    },
    'f', function(target) {

        return '#{0}'.transformNumber(target.getMilliseconds());
    },
    'ff', function(target) {

        return '#{00}'.transformNumber(target.getMilliseconds());
    },
    'fff', function(target) {

        return '#{000}'.transformNumber(target.getMilliseconds());
    },
    'ffff', function(target) {

        return '#{0000}'.transformNumber(target.getMilliseconds());
    },
    'fffff', function(target) {

        return '#{00000}'.transformNumber(target.getMilliseconds());
    },
    'ffffff', function(target) {

        return '#{000000}'.transformNumber(target.getMilliseconds());
    },
    'fffffff', function(target) {

        return '#{0000000}'.transformNumber(target.getMilliseconds());
    },
    'ffffffff', function(target) {

        return '#{00000000}'.transformNumber(target.getMilliseconds());
    },
    'fffffffff', function(target) {

        return '#{000000000}'.transformNumber(target.getMilliseconds());
    },
    'AMPM', function(target) {

        if (target.getHours() > 12) {
            return 'PM';
        }
        return 'AM';
    },
    'ampm', function(target) {

        if (target.getHours() > 12) {
            return 'pm';
        }
        return 'am';
    },
    'AP', function(target) {

        if (target.getHours() > 12) {
            return 'P';
        }
        return 'A';
    },
    'ap', function(target) {

        if (target.getHours() > 12) {
            return 'p';
        }
        return 'a';
    }
    ));

Date.Type.defineConstant('UTC_TOKENS',
        TP.hc(
    'd', function(target) {

        return target.getUTCDayOfMonth();
    },
    'dd', function(target) {

        return '#{00}'.transformNumber(target.getUTCDayOfMonth());
    },
    'ddd', function(target) {

        return target.getUTCShortDayName();
    },
    'dddd', function(target) {

        return target.getUTCDayName();
    },
    'dw', function(target) {

        return target.getUTCISODay();
    },
    'dy', function(target) {

        return '#{000}'.transformNumber(target.getUTCDayOfYear());
    },
    'ww', function(target) {

        return '#{00}'.transformNumber(target.getUTCISOWeek());
    },
    'm', function(target) {

        return target.getUTCISOMonth();
    },
    'mm', function(target) {

        return '#{00}'.transformNumber(target.getUTCISOMonth());
    },
    'mmm', function(target) {

        return target.getUTCShortMonthName();
    },
    'mmmm', function(target) {

        return target.getUTCMonthName();
    },
    'yy', function(target) {

        return target.getUTCFullYear().asString().slice(2);
    },
    'yyyy', function(target) {

        return target.getUTCFullYear();
    },
    'h', function(target) {

        var hours;

        hours = target.getUTCHours();

        if (hours > 12) {
            hours -= 12;
        }
        return hours;
    },
    'hi', function(target) {

        var hours;

        hours = target.getUTCHours();

        return hours;
    },
    'hh', function(target) {

        var hours;

        hours = target.getUTCHours();

        if (hours > 12) {
            hours -= 12;
        }
        return '#{00}'.transformNumber(hours);
    },
    'hhi', function(target) {

        var hours;

        hours = target.getUTCHours();

        return '#{00}'.transformNumber(hours);
    },
    'mn', function(target) {

        return target.getUTCMinutes();
    },
    'mmn', function(target) {

        return '#{00}'.transformNumber(target.getUTCMinutes());
    },
    's', function(target) {

        return target.getUTCSeconds();
    },
    'ss', function(target) {

        return '#{00}'.transformNumber(target.getUTCSeconds());
    },
    'f', function(target) {

        return '#{0}'.transformNumber(target.getUTCMilliseconds());
    },
    'ff', function(target) {

        return '#{00}'.transformNumber(target.getUTCMilliseconds());
    },
    'fff', function(target) {

        return '#{000}'.transformNumber(target.getUTCMilliseconds());
    },
    'ffff', function(target) {

        return '#{0000}'.transformNumber(target.getUTCMilliseconds());
    },
    'fffff', function(target) {

        return '#{00000}'.transformNumber(target.getUTCMilliseconds());
    },
    'ffffff', function(target) {

        return '#{000000}'.transformNumber(target.getUTCMilliseconds());
    },
    'fffffff', function(target) {

        return '#{0000000}'.transformNumber(target.getUTCMilliseconds());
    },
    'ffffffff', function(target) {

        return '#{00000000}'.transformNumber(target.getUTCMilliseconds());
    },
    'fffffffff', function(target) {

        return '#{000000000}'.transformNumber(target.getUTCMilliseconds());
    },
    'AMPM', function(target) {

        if (target.getUTCHours() > 12) {
            return 'PM';
        }
        return 'AM';
    },
    'ampm', function(target) {

        if (target.getUTCHours() > 12) {
            return 'pm';
        }
        return 'am';
    },
    'AP', function(target) {

        if (target.getUTCHours() > 12) {
            return 'P';
        }
        return 'A';
    },
    'ap', function(target) {

        if (target.getUTCHours() > 12) {
            return 'p';
        }
        return 'a';
    }
    ));

Date.Type.defineConstant('FORMATS',
    TP.hc('MMDDYY', '%{mm}%{dd}%{yy}',
            'MMDDYYYY', '%{mm}%{dd}%{yyyy}',
            'MM-DD-YY', '%{mm}-%{dd}-%{yy}',
            'MM-DD-YYYY', '%{mm}-%{dd}-%{yyyy}',
            'HH:MM ampm', '%{hh}:%{mn}%{ampm}',     //  NOTE the MM->mn here
            'HH:MM AP', '%{hh}:%{mn} %{AP}',        //  NOTE the MM->mn here
            'HH:MM ap', '%{hh}:%{mn} %{ap}',        //  NOTE the MM->mn here
            'ISO_SHORT', '%{yyyy}-%{mm}-%{dd} %{hhi}:%{mmn}:%{ss}',
            'HTTP_FORMAT', '%{ddd}, %{d} %{mmm} %{yyyy} %{hhi}:%{mmn}:%{ss}'
        ));

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  Cache the start and end DST dates for this year for higher performance
//  NB: These *MUST* be recomputed if a new locale is installed.
Date.Type.defineAttribute('thisYearStartDSTDate');
Date.Type.defineAttribute('thisYearEndDSTDate');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

Date.Type.defineMethod('addDurations',
function(firstDuration, secondDuration) {

    /**
     * @method addDurations
     * @summary Returns a new xs:duration formatted string representing the two
     *     durations added together.
     * @param {String} firstDuration An xs:duration formatted string.
     * @param {String} secondDuration An xs:duration formatted string.
     * @exception TP.sig.InvalidParameter
     * @returns {String} A new xs:duration formatted string value.
     */

    var s1,
        s2,

        sum;

    if (TP.notValid(s1 = Date.getSecondsInDuration(firstDuration))) {
        return this.raise('TP.sig.InvalidParameter',
                'First duration not a valid duration string.');
    }

    if (TP.notValid(s2 = Date.getSecondsInDuration(secondDuration))) {
        return this.raise('TP.sig.InvalidParameter',
                'Second duration not a valid duration string.');
    }

    sum = s1 + s2;

    return Date.normalizeDuration('PT' + sum + 'S');
});

//  ------------------------------------------------------------------------

Date.Type.defineMethod('normalizeDuration',
function(aDuration) {

    /**
     * @method normalizeDuration
     * @summary Returns a "normalized" duration in which the values of all day,
     *     hour, minute, and second values have been adjusted to their minimal
     *     values without altering the specified duration's length.
     * @param {String} aDuration The xs:duration formatted string to normalize.
     * @returns {String} An xs:duration formatted string.
     */

    var sum,

        years,
        months,

        days,
        hours,
        minutes,
        seconds;

    if (TP.notValid(sum = Date.getMonthsInDuration(aDuration))) {
        return this.raise('TP.sig.InvalidDuration');
    }

    years = parseInt(sum / 12, 10);
    sum -= years * 12;
    months = sum;

    sum = Date.getSecondsInDuration(aDuration);

    days = parseInt(sum / Date.SPERDAY, 10);
    sum -= days * Date.SPERDAY;

    hours = parseInt(sum / Date.SPERHOUR, 10);
    sum -= hours * Date.SPERHOUR;

    minutes = parseInt(sum / Date.SPERMIN, 10);
    sum -= minutes * Date.SPERMIN;

    seconds = sum;

    return TP.join('P', years, 'Y', months, 'M', days, 'DT', hours, 'H',
                    minutes, 'M', seconds, 'S');
});

//  ------------------------------------------------------------------------

Date.Type.defineMethod('constructAtEpoch',
function() {

    /**
     * @method constructAtEpoch
     * @summary Returns a new Date at the beginning of the epoch.
     * @description This method returns a new Date with all of its settings set
     *     to 0. This gives a Date from the beginning of when Javascript can
     *     give a date (that is, January 1, 1970, UTC).
     * @returns {Date} A new Date set to the beginning of the epoch.
     */

    var newDate;

    newDate = this.construct();
    newDate.setTime(0);

    return newDate;
});

//  ------------------------------------------------------------------------

Date.Type.defineMethod('constructDayOne',
function(aYear) {

    /**
     * @method constructDayOne
     * @summary Returns a date representing the first day (at exactly 00:00:00)
     *     of the year provided.
     * @param {Number} aYear The year to compute for.
     * @returns {Date} A Date object representing YYYY-01-01T00:00:00.
     */

    return TP.dc(TP.join('01 Jan ', aYear, ' 00:00:00'));
});

//  ------------------------------------------------------------------------

Date.Type.defineMethod('constructUTCDayOne',
function(aYear) {

    /**
     * @method constructUTCDayOne
     * @summary Returns a date representing the first day (at exactly 00:00:00)
     *     of the year provided in UTC.
     * @param {Number} aYear The year to compute for.
     * @returns {Date} A Date object representing YYYY-01-01T00:00:00Z.
     */

    return TP.dc(TP.join('01 Jan ', aYear, ' 00:00:00 GMT'));
});

//  ------------------------------------------------------------------------

Date.Type.defineMethod('daysInFebruary',
function(aYear) {

    /**
     * @method daysInFebruary
     * @summary Return the number of days in February for the year provided.
     * @param {Number} aYear The year to return the number of days in February
     *     for.
     * @exception TP.sig.InvalidParameter
     * @returns {Number} The number of days in February for aYear.
     */

    if (this.isLeapYear(aYear)) {
        return 29;
    }

    return 28;
});

//  ------------------------------------------------------------------------

Date.Type.defineMethod('daysInMonth',
function(aMonth, aYear) {

    /**
     * @method daysInMonth
     * @summary Return the number of days in the month/year provided.
     * @param {Number} aMonth A month number, starting with 1 for January (note
     *     the difference from the getMonth() return value here. Use
     *     getISOMonth()). Defaults to the current month.
     * @param {Number} aYear The year number to check against. Defaults to the
     *     current year.
     * @returns {Number} The number of days in the month and year provided.
     */

    var month,
        year;

    month = aMonth;
    if (TP.notValid(month)) {
        month = TP.dc().getISOMonth();
    }

    //  if month is feb, adjust for leap years as needed
    if (month === 2) {
        year = aYear;
        if (TP.notValid(year)) {
            year = TP.dc().getFullYear();
        }
        return this.daysInFebruary(year);
    }

    return this.DAYS_PER_MONTH.at(month - 1);
});

//  ------------------------------------------------------------------------

Date.Type.defineMethod('daysInYear',
function(aYear) {

    /**
     * @method daysInYear
     * @summary Return the number of days in the year provided.
     * @param {Number} aYear The year to return the number of days in.
     * @exception TP.sig.InvalidParameter
     * @returns {Number} The number of days in the year provided.
     */

    if (this.isLeapYear(aYear)) {
        return 366;
    }

    return 365;
});

//  ------------------------------------------------------------------------

Date.Type.defineMethod('fromDate',
function(aDate) {

    /**
     * @method fromDate
     * @summary Returns the Date provided.
     * @param {Date} aDate An existing Date object.
     * @returns {Date} The date provided.
     */

    return aDate;
});

//  ------------------------------------------------------------------------

Date.Type.defineMethod('fromString',
function(aString, sourceLocale) {

    /**
     * @method fromString
     * @summary Return the Date as parsed from the string passed in. This
     *     routine will attempt to parse the incoming date string using the
     *     current Date parsing pipeline. The default format is ISO 8601:
     *     CCCC[-]MM[-]DDTHH[:]MM[:]SS[.ss][Z|[+-]th:tm].
     * @description Date parsing from strings is a weak area in JavaScript, one
     *     that we've tried to address with TIBET. The first step in this
     *     process is to create an TP.iso.ISO8601 type which can parse and
     *     format date strings. The second is to allow you to add custom date
     *     parsers via the addParser method. And finally, we automatically
     *     attempt to parse using the current TP.i18n.Locale type in effect, so
     *     localized input can be managed.
     * @param {String} aString The Date to be parsed.
     * @param {TP.i18n.Locale|String} sourceLocale A source xml:lang or
     *     TP.i18n.Locale defining the language the string is now in.
     * @exception TP.sig.InvalidParameter
     * @returns {Date} A new Date object representing the Date encoded in the
     *     parameter.
     */

    //  kernel isn't loaded completely? use native call
    if (!TP.sys.hasKernel()) {
        return new Date(aString);
    }

    return new Date(this.parse(aString, sourceLocale));
});

//  ------------------------------------------------------------------------

Date.Type.defineMethod('getDSTEndDate',
function(aYear) {

    /**
     * @method getDSTEndDate
     * @summary Returns a new Date which is the Daylight Saving Time end date
     *     for the United States.
     * @param {Number} aYear The year to compute the Daylight Saving Time end
     *     date for.
     * @returns {Date} A new Date set to the end date for the supplied year's
     *     Daylight Saving Time.
     */

    var endDay,
        endDate;

    if (!TP.isNumber(aYear)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  Here, we compute the day in October when DST will end. Note that
    //  this is valid for the U.S. only. If a TP.i18n.Locale gets loaded it
    //  should override this method and provide the correct end day for DST
    //  (Summer) time.

    /* eslint-disable no-extra-parens */
    endDay = (31 - (((aYear * 5) / 4).floor() + 1) % 7);
    /* eslint-enable no-extra-parens */

    //  DST ends on the last Sunday in October at 02:00 in the U.S.

    //  NB: October to JS is '9', since JS counts months starting at 0
    endDate = TP.dc(aYear, 9, endDay, 2);

    //  For EU (this needs to go into some locales to become live):
    //  DST ends on the last Sunday in October at 01:00 in the E.U.

    //  endDay = (31 - (((aYear * 5) / 4).floor() + 1) % 7);
    //  endDate = TP.dc(aYear,9,endDay,1);

    return endDate;
});

//  ------------------------------------------------------------------------

Date.Type.defineMethod('getDSTStartDate',
function(aYear) {

    /**
     * @method getDSTStartDate
     * @summary Returns a new Date which is the Daylight Saving Time start date
     *     for the United States.
     * @param {Number} aYear The year to compute the Daylight Saving Time start
     *     date for.
     * @returns {Date} A new Date set to the start date for the supplied year's
     *     Daylight Saving Time.
     */

    var startDay,
        startDate;

    if (!TP.isNumber(aYear)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  Here, we compute the day in April when DST will start. Note that
    //  this is valid for the U.S. only. If a TP.i18n.Locale gets loaded it
    //  should override this method and provide the correct start day for
    //  DST (Summer) time.

    /* eslint-disable no-extra-parens */
    startDay = (2 + (6 * aYear) - (aYear / 4).floor()) % 7 + 1;
    /* eslint-enable no-extra-parens */

    //  DST starts on the first Sunday in April at 02:00 in the U.S.

    //  NB: April to JS is '3', since JS counts months starting at 0
    startDate = TP.dc(aYear, 3, startDay, 2);

    //  For EU (this needs to go into some locales to become live):
    //  DST starts on the last Sunday in March at 01:00 in the E.U.

    //  startDay = (31 - (((aYear * 5) / 4).floor() + 4) % 7);
    //  startDate = TP.dc(aYear,2,startDay,1);

    return startDate;
});

//  ------------------------------------------------------------------------

Date.Type.defineMethod('getMillisecondsInDuration',
function(aDuration) {

    /**
     * @method getMillisecondsInDuration
     * @summary Returns the number of milliseconds represented by the
     *     xs:duration provided. Note that the implementation does not use
     *     information other than the D, H, M, and S time components.
     * @param {xs:duration} aDuration The duration to convert.
     * @returns {Number} The number of milliseconds as a decimal value.
     */

    var theMatch,
        val,
        str,
        units;

    if (!TP.isString(aDuration)) {
        return this.raise('TP.sig.InvalidDuration');
    }

    str = aDuration;

    if (!Date.DURATION_REGEX.test(str)) {
        return this.raise('TP.sig.InvalidDuration');
    }

    //  split into chunks we can manage
    theMatch = str.match(Date.DURATION_REGEX);

    //  start with zero unit count
    units = 0;

    //  compute days value if any
    if (TP.notEmpty(val = theMatch.at(Date.DURATION_DAY_INDEX))) {
        units += parseInt(val.slice(0, -1), 10) * 86400;
    }

    //  compute hours value if any
    if (TP.notEmpty(val = theMatch.at(Date.DURATION_HOUR_INDEX))) {
        units += parseInt(val.slice(0, -1), 10) * 3600;
    }

    //  add minute value if any
    if (TP.notEmpty(val = theMatch.at(Date.DURATION_MINUTE_INDEX))) {
        units += parseInt(val.slice(0, -1), 10) * 60;
    }

    //  multiply the total number of units by 1000 to get an accurate
    //  millisecond number
    units = units * 1000;

    //  add second value if any
    if (TP.notEmpty(val = theMatch.at(Date.DURATION_SECOND_INDEX))) {
        units += parseInt(parseFloat(val.slice(0, -1)) * 1000, 10);
    }

    //  TODO:   verify this against XForms spec
    //  is it a negative duration? then it's a negative number of units
    if (TP.notEmpty(theMatch.at(Date.DURATION_MINUS_INDEX))) {
        return 0 - units;
    }

    return units;
});

//  ------------------------------------------------------------------------

Date.Type.defineMethod('getMonthsInDuration',
function(aDuration) {

    /**
     * @method getMonthsInDuration
     * @summary Returns the number of months represented by the xs:duration
     *     provided. Note that the implementation does not use information other
     *     than the Y and M segments in the duration.
     * @param {xs:duration} aDuration The duration to convert.
     * @returns {Number} The number of months as an integer value.
     */

    var theMatch,
        val,
        str,
        units;

    if (!TP.isString(aDuration)) {
        return this.raise('TP.sig.InvalidDuration');
    }

    str = aDuration;

    if (!Date.DURATION_REGEX.test(str)) {
        return this.raise('TP.sig.InvalidDuration');
    }

    //  split into chunks we can manage
    theMatch = str.match(Date.DURATION_REGEX);

    //  start with zero month count
    units = 0;

    //  compute year/month value if any
    if (TP.notEmpty(val = theMatch.at(Date.DURATION_YEAR_INDEX))) {
        units += parseInt(val.slice(0, -1), 10) * 12;
    }

    //  add month value if any
    if (TP.notEmpty(val = theMatch.at(Date.DURATION_MONTH_INDEX))) {
        units += parseInt(val.slice(0, -1), 10);
    }

    //  TODO:   verify this against XForms spec
    //  is it a negative duration? then it's a negative number of months
    if (TP.notEmpty(theMatch.at(Date.DURATION_MINUS_INDEX))) {
        return 0 - units;
    }

    return units;
});

//  ------------------------------------------------------------------------

Date.Type.defineMethod('getSecondsInDuration',
function(aDuration) {

    /**
     * @method getSecondsInDuration
     * @summary Returns the number of seconds represented by the xs:duration
     *     provided. Note that the implementation does not use information other
     *     than the D, H, M, and S time components.
     * @param {xs:duration} aDuration The duration to convert.
     * @returns {Number} The number of seconds as a decimal value.
     */

    var theMatch,
        val,
        str,
        units;

    if (!TP.isString(aDuration)) {
        return this.raise('TP.sig.InvalidDuration');
    }

    str = aDuration;

    if (!Date.DURATION_REGEX.test(str)) {
        return this.raise('TP.sig.InvalidDuration');
    }

    //  split into chunks we can manage
    theMatch = str.match(Date.DURATION_REGEX);

    //  start with zero unit count
    units = 0;

    //  compute days value if any
    if (TP.notEmpty(val = theMatch.at(Date.DURATION_DAY_INDEX))) {
        units += parseInt(val.slice(0, -1), 10) * 86400;
    }

    //  compute hours value if any
    if (TP.notEmpty(val = theMatch.at(Date.DURATION_HOUR_INDEX))) {
        units += parseInt(val.slice(0, -1), 10) * 3600;
    }

    //  add minute value if any
    if (TP.notEmpty(val = theMatch.at(Date.DURATION_MINUTE_INDEX))) {
        units += parseInt(val.slice(0, -1), 10) * 60;
    }

    //  add second value if any
    if (TP.notEmpty(val = theMatch.at(Date.DURATION_SECOND_INDEX))) {
        units += parseInt(val.slice(0, -1), 10);
    }

    //  TODO:   verify this against XForms spec
    //  is it a negative duration? then it's a negative number of units
    if (TP.notEmpty(theMatch.at(Date.DURATION_MINUS_INDEX))) {
        return 0 - units;
    }

    return units;
});

//  ------------------------------------------------------------------------

Date.Type.defineMethod('isLeapYear',
function(aYear) {

    /**
     * @method isLeapYear
     * @summary Return true if the year provided is a leap year.
     * @param {Number} aYear The year to test.
     * @exception TP.sig.InvalidParameter
     * @returns {Boolean} Whether or not the provided year is a leap year.
     */

    if (!TP.isNumber(aYear)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    /* eslint-disable no-extra-parens */

    //  multiples of 400 are always a leap year
    if ((aYear % 400) === 0) {
        return true;
    }

    //  can't be a leap year if it isn't divisible by 4
    if ((aYear % 4) !== 0) {
        return false;
    }

    //  we know it's divisible by 4 and not a multiple of 400 so we only
    //  need to say false if its a century mark
    if ((aYear % 100) === 0) {
        return false;
    }

    /* eslint-enable no-extra-parens */

    return true;
});

//  ------------------------------------------------------------------------

Date.Type.defineMethod('today',
function() {

    /**
     * @method today
     * @summary Returns a date representing the current day (at exactly
     *     00:00:00).
     * @returns {Date} A Date object representing today.
     */

    var today;

    today = TP.dc();
    today.setHours(0);
    today.setMinutes(0);
    today.setSeconds(0);
    today.setMilliseconds(0);

    return today;
});

//  ------------------------------------------------------------------------

Date.Type.defineMethod('todayUTC',
function() {

    /**
     * @method todayUTC
     * @summary Returns a date representing the current day (at exactly
     *     00:00:00) UTC.
     * @returns {Date} A Date object representing today in UTC.
     */

    var today;

    today = TP.dc();

    today.setUTCHours(0);
    today.setUTCMinutes(0);
    today.setUTCSeconds(0);
    today.setUTCMilliseconds(0);

    return today;
});

//  ------------------------------------------------------------------------

Date.Type.defineMethod('validate',
function(anObject) {

    /**
     * @method validate
     * @summary Returns true if the object provided it meets the criteria for a
     *     valid date.
     * @param {Object} anObject The object whose value should be verified.
     * @returns {Boolean} True if the object is 'valid'.
     */

    var str,
        dateInst;

    str = TP.str(anObject);

    if (!TP.isString(str)) {
        return false;
    }

    dateInst = this.construct(str);

    return TP.isDate(dateInst);
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

Date.Inst.defineMethod('add',
function(aValue) {

    /**
     * @method add
     * @summary Adds a number of milliseconds or duration to the receiver,
     *     returning the new date produced.
     * @param {Number|String} aValue A number or string value defining the
     *     quantity to be added to the receiver. Numbers and strings are treated
     *     as durations. NOTE that this means the number should be a millisecond
     *     count defining a span of time, not a date.
     * @returns {Date} A new Date instance.
     */

    if (TP.isNumber(aValue)) {
        return TP.dc(this.getTime() + aValue);
    } else if (TP.isString(aValue)) {
        return this.addDuration(aValue);
    }

    return this.raise('TP.sig.InvalidParameter');
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('addDuration',
function(aDuration) {

    /**
     * @method addDuration
     * @summary Returns a new Date instance that is the specified duration
     *     further into the future.
     * @param {String} aDuration An xs:duration formatted string defining the
     *     duration to add.
     * @exception TP.sig.InvalidParameter
     * @returns {Date} A Date object set numDays more days than the receiver.
     */

    var aDate,
        months,
        secs;

    //  first step is to get the months in the duration and get them added
    //  to the current date's value so we advance the calendar by that
    //  number of months...
    months = Date.getMonthsInDuration(aDuration);

    aDate = TP.dc(this.getTime());
    aDate.setUTCMonth(aDate.getUTCMonth() + months);

    secs = Date.getSecondsInDuration(aDuration);

    /* eslint-disable no-extra-parens */
    return TP.dc(aDate.getTime() + (secs * 1000));
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('formatHTTPDate',
function() {

    /**
     * @method formatHTTPDate
     * @summary Returns the 'HTTP Date' format of the receiver.
     * @returns {String} The receiver formatted into HTTP Date format.
     */

    var str;

    str = TP.join('HTTP_FORMAT'.transformDate(this),
                    ' ',
                    this.getISOTimezone().strip(/[+:]/g));

    return str;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getDayName',
function() {

    /**
     * @method getDayName
     * @summary Returns the localized long format name of the day computed from
     *     the receiver.
     * @returns {String} The long format name of the day.
     */

    return TP.sys.getLocale().localizeString(
                                Date.LONG_WEEKDAY_NAMES.at(this.getDay()));
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getDayOfMonth',
function() {

    /**
     * @method getDayOfMonth
     * @summary Returns the numeric day, for example 20 for the 20th of the
     *     month.
     * @returns {Number} The numerical day number, starting with 1.
     */

    return this.getDate();
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getDayOfWeek',
function() {

    /**
     * @method getDayOfWeek
     * @summary Returns the numeric day of the week using the JavaScript view
     *     of weeks so Sunday is day 0,and Saturday is day 6. Use getISODay to
     *     return ISO 8601 day of week numbers.
     * @returns {Number} The numerical day number, starting with 1.
     */

    return this.getDay();
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getDayOfYear',
function() {

    /**
     * @method getDayOfYear
     * @summary Returns the numeric day of the year represented by the
     *     receiver.
     * @returns {Number}
     */

    return this.getDaysBetween(
                        TP.dc('01 Jan ' + this.getISOYear())) + 1;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getDaysBetween',
function(aDate) {

    /**
     * @method getDaysBetween
     * @summary Returns the number of days between the receiver and aDate.
     * @param {Date} aDate The date to use as the other boundary.
     * @exception TP.sig.InvalidParameter
     * @returns {Date} The number of days between the receiver and aDate.
     */

    if (!TP.isDate(aDate)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    return ((aDate.getTime() - this.getTime()) /
                Date.MSPERDAY).round().abs();
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getDaysExpired',
function() {

    /**
     * @method getDaysExpired
     * @summary Returns the number of days that have expired so far in the
     *     receiver's year.
     * @returns {Number} The number of days expired in the receiver's year.
     */

    var days,
        month,
        index;

    month = this.getMonth();
    days = this.getDate();

    for (index = 0; index < month; index++) {
        days += Date.DAYS_PER_MONTH[index];
    }

    /* eslint-disable no-extra-parens */
    if (Date.isLeapYear(this.getFullYear()) && (month > 1)) {
        days += 1;
    }
    /* eslint-enable no-extra-parens */

    return days;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getDaysLeft',
function() {

    /**
     * @method getDaysLeft
     * @summary Returns the number of days that are left in the receiver's
     *     year.
     * @returns {Number} The number of days left in the receiver's year.
     */

    return this.getDaysInYear() - this.getDaysExpired();
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getDaysInYear',
function() {

    /**
     * @method getDaysInYear
     * @summary Return the number of days in the receiver's year.
     * @returns {Number} The number of days in the year.
     */

    if (Date.isLeapYear(this.getFullYear())) {
        return 366;
    }

    return 365;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getDaysOfMonth',
function() {

    /**
     * @method getDaysOfMonth
     * @summary Returns an array of Date instances for the days of the month
     *     for the receiver's month.
     * @returns {Date[]} An array containing instances of Date.
     */

    var days,
        daysInMonth,

        i;

    days = TP.ac();
    daysInMonth = Date.daysInMonth(this.getISOMonth(),
                                    this.getFullYear());

    for (i = 0; i < daysInMonth; i++) {
        days.add(TP.dc(this.getFullYear(), this.getMonth(), i + 1));
    }

    return days;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getDaysOfWeek',
function() {

    /**
     * @method getDaysOfWeek
     * @summary Returns an array containing instances of Date for each day in
     *     the receiver's week.
     * @returns {Date[]} An array containing instances of Date.
     */

    var weekdays,
        ms,
        day,
        offset,
        sunday;

    //  calculate ms value of the sunday in week of day provided
    day = this.getDay();
    offset = day * Date.MSPERDAY;
    ms = this.getTime();
    sunday = ms - offset;

    /* eslint-disable no-extra-parens,no-implicit-coercion */

    //  construct array of ms values for that week
    weekdays = TP.ac();
    weekdays.add(sunday);
    weekdays.add(sunday + (1 * Date.MSPERDAY));
    weekdays.add(sunday + (2 * Date.MSPERDAY));
    weekdays.add(sunday + (3 * Date.MSPERDAY));
    weekdays.add(sunday + (4 * Date.MSPERDAY));
    weekdays.add(sunday + (5 * Date.MSPERDAY));
    weekdays.add(sunday + (6 * Date.MSPERDAY));

    /* eslint-enable no-extra-parens,no-implicit-coercion */

    //  convert ms values into date instances
    weekdays.convert(
            function(item) {

                return TP.dc(item);
            });

    return weekdays;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getISODay',
function() {

    /**
     * @method getISODay
     * @summary Returns the day number as defined by ISO 8601.
     * @description The ISO 8601 standard defines Monday as day 1 through Sunday
     *     day 7. JavaScript also defines Monday as day 1, but treats Sunday as
     *     day 0, not day 7. This routine returns Sunday's day number as 7 as
     *     defined by ISO 8601.
     * @returns {Number} The number of the receiver's day, according to ISO
     *     8601.
     */

    var day;

    day = this.getDay();

    /* eslint-disable no-extra-parens */
    //  If it's Sunday, return 7
    return (day === 0) ? 7 : day;
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getISOMonth',
function() {

    /**
     * @method getISOMonth
     * @summary Returns the month number as defined in ISO 8601, where months
     *     start with 1 for January rather than the 0 provided by native
     *     JavaScript.
     * @returns {Number} The calendar month number, starting with 1.
     */

    return this.getMonth() + 1;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getISOTime',
function(aFormat) {

    /**
     * @method getISOTime
     * @summary Returns the ISO 8601 time string for the receiver in the format
     *     provided.
     * @param {String} aFormat An TP.iso.ISO8601 time component FORMAT.
     * @returns {String} An ISO 8601 time string.
     */

    var format;

    if (TP.notEmpty(aFormat)) {
        if (/%/.test(aFormat)) {
            format = aFormat;
        } else {
            format = TP.iso.ISO8601.FORMATS.at(aFormat);
            if (TP.notValid(format)) {
                return this.raise('TP.sig.InvalidFormat',
                                    aFormat);
            }
        }
    } else {
        format = TP.iso.ISO8601.FORMATS.at('HH:MM:SS');
    }

    return this.as('TP.iso.ISO8601', format);
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getISOTimezone',
function() {

    /**
     * @method getISOTimezone
     * @summary Returns the timezone the browser is currently executing in in
     *     ISO standard notation (e.g. '-8:00').
     * @description This method returns the timezone expressed in the ISO
     *     standard notation. For 'Zulu' (UTC) time, this is the character 'Z'.
     *     For all other timezones, it is a plus or minus character ('+' or '-')
     *     followed by the hours offset, followed by a colon (':'), followed by
     *     the minutes offset. E.g. '+12:00'.
     * @returns {String} An ISO 8601 time zone string.
     */

    var offset,

        offsetHours,
        offsetMinutes,

        minuteString,
        hourString;

    offset = this.getTimezoneOffset();

    offsetHours = offset / 60;
    if (offsetHours === 0) {
        //  we're the same as UTC (that's 'Zulu' time for you military types
        //  out there). The ISO spec says to return 'Z'.
        return 'Z';
    }

    offsetMinutes = offset % 60;

    if (offsetMinutes === 0) {
        minuteString = '00';
    } else {
        minuteString = '#{0#}'.transformNumber(offsetMinutes);
    }

    //  This will strip a negative sign if we have one.
    hourString = '#{0#}'.transformNumber(offsetHours);

    //  For some reason, negative offsets mean that its 'UTC+'...
    if (offsetHours.isNegative()) {
        return TP.join('+', hourString, ':', minuteString);
    }

    return TP.join('-', hourString, ':', minuteString);
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getISOWeek',
function() {

    /**
     * @method getISOWeek
     * @summary Returns the week number as defined by ISO 8601.
     * @description Officially, week 1 of any year is the week that contains 4
     *     January (that is, the week that contains the first Thursday in
     *     January). Almost all years have 52 weeks, but years that start on a
     *     Thursday and leap years that start on a Wednesday have 53 weeks using
     *     this metric.
     *
     *     NB: This algorithm was discovered on the web page of Claus Tondering
     *     (claus@tondering.dk). He credits Stephan Potthast for it. Thanks to
     *     both Claus and Stephan!
     * @returns {Number} The number of the receiver's week, according to ISO
     *     8601.
     */

    var julianDay,
        d4,
        L,
        d1,

        weekNum;

    julianDay = this.getJulianDay().round();

    /* eslint-disable no-extra-parens */

    d4 = (julianDay + 31741 - (julianDay % 7)) % 146097 % 36524 % 1461;

    L = (d4 / 1460).floor();
    d1 = ((d4 - L) % 365) + L;

    weekNum = (d1 / 7).floor() + 1;

    /* eslint-enable no-extra-parens */

    return weekNum;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getISOYear',
function() {

    /**
     * @method getISOYear
     * @summary Returns the year number as defined in ISO 8601, also known in
     *     JavaScript as the "full year".
     * @returns {Number}
     */

    return this.getFullYear();
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getJulianDay',
function() {

    /**
     * @method getJulianDay
     * @summary Returns Julian day computed from the receiver.
     * @returns {Number} The number of the Julian day computed from the
     *     receiver.
     */

    var theMonth,
        theYear,
        theDate,
        theHour,
        theMinutes,
        theSeconds,
        theOffset,

        universalTime,

        julianDay;

    theMonth = this.getMonth() + 1;
    theYear = this.getFullYear();
    theDate = this.getDate();
    theHour = this.getHours();
    theMinutes = this.getMinutes();
    theSeconds = this.getSeconds();
    theOffset = this.getTimezoneOffset();

    universalTime = theHour + (theMinutes + theOffset) / 60.0 +
                                                    theSeconds / 3600.0;

    if (theMonth <= 2) {
        theMonth = theMonth + 12;
        theYear = theYear - 1;
    }

    julianDay = (365.25 * theYear).floor() +
                    (30.6001 * (theMonth + 1)).floor() -
                    15 + 1720996.5 + theDate + universalTime / 24.0;

    return julianDay;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getMonthName',
function() {

    /**
     * @method getMonthName
     * @summary Returns the long format name of the month computed from the
     *     receiver.
     * @returns {String} The long format name of the month.
     */

    return TP.sys.getLocale().localizeString(
                        Date.LONG_MONTH_NAMES.at(this.getMonth()));
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getShortDayName',
function() {

    /**
     * @method getShortDayName
     * @summary Returns the short format name of the day computed from the
     *     receiver.
     * @returns {String} The short format name of the day.
     */

    return TP.sys.getLocale().localizeString(
                        Date.SHORT_WEEKDAY_NAMES.at(this.getDay()));
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getShortMonthName',
function() {

    /**
     * @method getShortMonthName
     * @summary Returns the short format name of the month computed from the
     *     receiver.
     * @returns {String} The short format name of the month.
     */

    return TP.sys.getLocale().localizeString(
                        Date.SHORT_MONTH_NAMES.at(this.getMonth()));
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getStartOfMonth',
function() {

    /**
     * @method getStartOfMonth
     * @summary Returns the time in ms at which the current month started.
     * @returns {Number} The start of the current month in ms.
     */

    var ms,
        offset,
        newDay;

    //  Get today at the 'start' of the day
    newDay = Date.today();

    //  getDate returns the day of month, so we remove 1 to set the index to
    //  0 as JS wants it and compute the offset
    ms = newDay.getTime();
    offset = (newDay.getDate() - 1) * Date.MSPERDAY;

    return ms - offset;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getStartOfWeek',
function() {

    /**
     * @method getStartOfWeek
     * @summary Returns the time in ms at which the current week started
     *     (assuming weeks start on Sunday at 00:00.00.000).
     * @returns {Number} The start of the current week in ms.
     */

    var ms,
        offset,
        newDay;

    //  Get today at the 'start' of the day
    newDay = Date.today();

    //  get Day returns the proper day offset so we can use it
    ms = newDay.getTime();
    offset = newDay.getDay() * Date.MSPERDAY;

    return ms - offset;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCDayName',
function() {

    /**
     * @method getUTCDayName
     * @summary Returns the localized long format name of the day computed from
     *     the receiver's UTC day.
     * @returns {String} The long format name of the day.
     */

    return TP.sys.getLocale().localizeString(
                        Date.LONG_WEEKDAY_NAMES.at(this.getUTCDay()));
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCDayOfMonth',
function() {

    /**
     * @method getUTCDayOfMonth
     * @summary Returns the numeric day, for example 20 for the 20th of the
     *     month for the receiver's UTC day.
     * @returns {Number} The numerical day number, starting with 1.
     */

    return this.getUTCDate();
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCDayOfWeek',
function() {

    /**
     * @method getUTCDayOfWeek
     * @summary Returns the numeric day of the week using the JavaScript view
     *     of weeks so Sunday is day 0,and Saturday is day 6. Use getISODay to
     *     return ISO 8601 day of week numbers.
     * @returns {Number} The numerical day number, starting with 1.
     */

    return this.getUTCDay();
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCDayOfYear',
function() {

    /**
     * @method getUTCDayOfYear
     * @summary Returns the numeric day of the year represented by the
     *     receiver.
     * @returns {Number}
     */

    return this.getDaysBetween(
                    TP.dc('01 Jan ' + this.getUTCISOYear())) + 1;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCDaysExpired',
function() {

    /**
     * @method getUTCDaysExpired
     * @summary Returns the number of days that have expired so far in the
     *     receiver's year.
     * @returns {Number} The number of days expired in the receiver's year.
     */

    var days,
        month,
        index;

    month = this.getUTCMonth();
    days = this.getUTCDate();

    for (index = 0; index < month; index++) {
        days += Date.DAYS_PER_MONTH[index];
    }

    if (Date.isLeapYear(this.getUTCFullYear()) && month > 1) {
        days += 1;
    }

    return days;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCDaysLeft',
function() {

    /**
     * @method getUTCDaysLeft
     * @summary Returns the number of days that are left in the receiver's
     *     year.
     * @returns {Number} The number of days left in the receiver's year.
     */

    return this.getUTCDaysInYear() - this.getUTCDaysExpired();
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCDaysInYear',
function() {

    /**
     * @method getUTCDaysInYear
     * @summary Return the number of days in the receiver's year.
     * @returns {Number} The number of days in the year.
     */

    if (Date.isLeapYear(this.getUTCFullYear())) {
        return 366;
    }

    return 365;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCDaysOfMonth',
function() {

    /**
     * @method getUTCDaysOfMonth
     * @summary Returns an array of Date instances for the days of the
     *     receiver's month.
     * @returns {Date[]} An array containing instances of Date.
     */

    var days,

        daysInMonth,
        index;

    days = TP.ac();

    daysInMonth = Date.daysInMonth(this.getUTCISOMonth(),
                                    this.getUTCFullYear());

    for (index = 0; index < daysInMonth; index++) {
        days.add(TP.dc(this.getUTCFullYear(),
                        this.getUTCISOMonth(),
                        index + 1));
    }

    return days;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCDaysOfWeek',
function() {

    /**
     * @method getUTCDaysOfWeek
     * @summary Returns an array containing instances of Date for each day in
     *     the receiver's week.
     * @returns {Date[]} An array containing instances of Date.
     */

    var weekdays,
        ms,
        day,
        offset,
        sunday;

    //  calculate ms value of the sunday in week of day provided
    day = this.getUTCDay();
    offset = day * Date.MSPERDAY;
    ms = this.getTime();
    sunday = ms - offset;

    /* eslint-disable no-extra-parens,no-implicit-coercion */

    //  construct array of ms values for that week
    weekdays = TP.ac();
    weekdays.add(sunday);
    weekdays.add(sunday + (1 * Date.MSPERDAY));
    weekdays.add(sunday + (2 * Date.MSPERDAY));
    weekdays.add(sunday + (3 * Date.MSPERDAY));
    weekdays.add(sunday + (4 * Date.MSPERDAY));
    weekdays.add(sunday + (5 * Date.MSPERDAY));
    weekdays.add(sunday + (6 * Date.MSPERDAY));

    /* eslint-enable no-extra-parens,no-implicit-coercion */

    //  convert ms values into date instances
    weekdays.convert(
            function(item) {

                return TP.dc(item);
            });

    return weekdays;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCISODay',
function() {

    /**
     * @method getUTCISODay
     * @summary Returns the day number as defined by ISO 8601.
     * @description The ISO 8601 standard defines Monday as day 1 through Sunday
     *     day 7. JavaScript also defines Monday as day 1, but treats Sunday as
     *     day 0, not day 7. This routine returns Sunday's day number as 7 as
     *     defined by ISO 8601.
     * @returns {Number} The number of the receiver's day, according to ISO
     *     8601.
     */

    var day;

    day = this.getUTCDay();

    /* eslint-disable no-extra-parens */
    //  If it's Sunday, return 7
    return (day === 0) ? 7 : day;
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCISOMonth',
function() {

    /**
     * @method getUTCISOMonth
     * @summary Returns the month number as defined in ISO 8601, where months
     *     start with 1 for January rather than the 0 provided by native
     *     JavaScript.
     * @returns {Number} The calendar month number, starting with 1.
     */

    return this.getUTCMonth() + 1;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCISOTime',
function(aFormat) {

    /**
     * @method getUTCISOTime
     * @summary Returns the ISO 8601 time string for the receiver in the format
     *     provided.
     * @param {String} aFormat An ISO8601 time component FORMAT.
     * @returns {String} An ISO 8601 time string.
     */

    var format;

    if (TP.notEmpty(aFormat)) {
        if (/%/.test(aFormat)) {
            format = aFormat;
        } else {
            format = TP.iso.ISO8601.FORMATS.at(aFormat);
        }

        //  has to be valid and end in either + or Z to force UTC lookups
        if (TP.notValid(format) || !/[Z\+]$/.test(format)) {
            return this.raise('TP.sig.InvalidFormat', aFormat);
        }
    } else {
        //  NOTE the trailing Z here to force Zulu time
        format = TP.iso.ISO8601.FORMATS.at('HH:MM:SSZ');
    }

    return this.as('TP.iso.ISO8601', format);
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCISOTimezone',
function() {

    /**
     * @method getUTCISOTimezone
     * @summary Returns the timezone the browser is currently executing in in
     *     ISO standard notation (e.g. '-8:00'). For UTC time this is always the
     *     constant value 'Z'.
     * @returns {String}
     */

    return 'Z';
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCISOWeek',
function() {

    /**
     * @method getUTCISOWeek
     * @summary Returns the week number as defined by ISO 8601.
     * @description Officially, week 1 of any year is the week that contains 4
     *     January (that is, the week that contains the first Thursday in
     *     January). Almost all years have 52 weeks, but years that start on a
     *     Thursday and leap years that start on a Wednesday have 53 weeks using
     *     this metric.
     *
     *     NB: This algorithm was discovered on the web page of Claus Tondering
     *     (claus@tondering.dk). He credits Stephan Potthast for it. Thanks to
     *     both Claus and Stephan!
     * @returns {Number} The number of the receiver's week, according to ISO
     *     8601.
     */

    var julianDay,
        d4,
        L,
        d1,

        weekNum;

    julianDay = this.getUTCJulianDay().round();

    /* eslint-disable no-extra-parens */

    d4 = (julianDay + 31741 - (julianDay % 7)) % 146097 % 36524 % 1461;

    L = (d4 / 1460).floor();
    d1 = ((d4 - L) % 365) + L;

    weekNum = (d1 / 7).floor() + 1;

    /* eslint-enable no-extra-parens */

    return weekNum;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCISOYear',
function() {

    /**
     * @method getUTCISOYear
     * @summary Returns the year number as defined in ISO 8601, also known in
     *     JavaScript as the "full year".
     * @returns {Number}
     */

    return this.getUTCFullYear();
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCJulianDay',
function() {

    /**
     * @method getUTCJulianDay
     * @summary Returns Julian day computed from the receiver.
     * @returns {Number} The number of the Julian day computed from the
     *     receiver.
     */

    var theMonth,
        theYear,
        theDate,
        theHour,
        theMinutes,
        theSeconds,
        theOffset,

        universalTime,

        julianDay;

    theMonth = this.getUTCMonth() + 1;
    theYear = this.getUTCFullYear();
    theDate = this.getUTCDate();
    theHour = this.getUTCHours();
    theMinutes = this.getUTCMinutes();
    theSeconds = this.getUTCSeconds();
    theOffset = this.getUTCTimezoneOffset();

    universalTime = theHour + (theMinutes + theOffset) / 60.0 +
                                                    theSeconds / 3600.0;

    if (theMonth <= 2) {
        theMonth = theMonth + 12;
        theYear = theYear - 1;
    }

    julianDay = (365.25 * theYear).floor() +
                    (30.6001 * (theMonth + 1)).floor() -
                    15 + 1720996.5 + theDate + universalTime / 24.0;

    return julianDay;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCMonthName',
function() {

    /**
     * @method getUTCMonthName
     * @summary Returns the long format name of the month computed from the
     *     receiver.
     * @returns {String} The long format name of the month.
     */

    return TP.sys.getLocale().localizeString(
                        Date.LONG_MONTH_NAMES.at(this.getUTCMonth()));
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCShortDayName',
function() {

    /**
     * @method getUTCShortDayName
     * @summary Returns the short format name of the day computed from the
     *     receiver.
     * @returns {String} The short format name of the day.
     */

    return TP.sys.getLocale().localizeString(
                        Date.SHORT_WEEKDAY_NAMES.at(this.getUTCDay()));
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCShortMonthName',
function() {

    /**
     * @method getUTCShortMonthName
     * @summary Returns the short format name of the month computed from the
     *     receiver.
     * @returns {String} The short format name of the month.
     */

    return TP.sys.getLocale().localizeString(
                        Date.SHORT_MONTH_NAMES.at(this.getUTCMonth()));
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCStartOfMonth',
function() {

    /**
     * @method getUTCStartOfMonth
     * @summary Returns the time in ms at which the current month started.
     * @returns {Number} The start of the current month in ms.
     */

    var newDay,
        ms,
        offset;

    //  Get today at the 'start' of the day
    newDay = Date.todayUTC();

    //  getDate returns the day of month, so we remove 1 to set the index to
    //  0 as JS wants it and compute the offset
    ms = newDay.getTime();
    offset = (newDay.getUTCDate() - 1) * Date.MSPERDAY;

    return ms - offset;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCStartOfWeek',
function() {

    /**
     * @method getUTCStartOfWeek
     * @summary Returns the time in ms at which the current week started
     *     (assuming weeks start on Sunday at 00:00.00.000).
     * @returns {Number} The start of the current week in ms.
     */

    var newDay,
        ms,
        offset;

    //  Get today at the 'start' of the day
    newDay = Date.todayUTC();

    //  get Day returns the proper day offset so we can use it
    ms = newDay.getTime();
    offset = newDay.getUTCDay() * Date.MSPERDAY;

    return ms - offset;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getUTCWeek',
function() {

    /**
     * @method getUTCWeek
     * @summary Returns the week number as commonly defined in the U.S. where
     *     week 1 is the week in which January 1 falls. Note that this value may
     *     differ from the ISO week number which defines week 1 as the first
     *     week with more days in January than in the previous December (i.e. at
     *     least 4 days).
     * @returns {Number} The number of the receiver's week, according to ISO
     *     8601.
     */

    var first,
        wk1start,
        since;

    //  get the first 'moment' of the year
    first = TP.dc('01 Jan ' + this.getUTCFullYear());
    first.setUTCHours(0);
    first.setUTCMinutes(0);
    first.setUTCSeconds(0);
    first.setUTCMilliseconds(0);

    //  based on that date's day of the week we need to find the first prior
    //  sunday...which will be the day number offset backwards. in other
    //  words, if the first's day number is 1 we're a monday and need to
    //  subtract 1 day to find the sunday in that week...
    wk1start = first.subtractDuration(TP.join('P', first.getUTCDay(), 'D'));

    since = this.getDaysBetween(wk1start);

    return (since / 7).floor().integer() + 1;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('getWeek',
function() {

    /**
     * @method getWeek
     * @summary Returns the week number as commonly defined in the U.S. where
     *     week 1 is the week in which January 1 falls. Note that this value may
     *     differ from the ISO week number which defines week 1 as the first
     *     week with more days in January than in the previous December (i.e. at
     *     least 4 days).
     * @returns {Number} The number of the receiver's week, according to ISO
     *     8601.
     */

    var first,
        wk1start,
        since;

    //  get the first 'moment' of the year
    first = TP.dc('01 Jan ' + this.getFullYear());
    first.setHours(0);
    first.setMinutes(0);
    first.setSeconds(0);
    first.setMilliseconds(0);

    //  based on that date's day of the week we need to find the first prior
    //  sunday...which will be the day number offset backwards. in other
    //  words, if the first's day number is 1 we're a monday and need to
    //  subtract 1 day to find the sunday in that week...
    wk1start = first.subtractDuration(TP.join('P', first.getDay(), 'D'));

    since = this.getDaysBetween(wk1start);

    return (since / 7).floor().integer() + 1;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('isBefore',
function(aDate) {

    /**
     * @method isBefore
     * @summary Returns true if the receiver is a date/time which occurs before
     *     the date/time provided.
     * @param {Date|String} aDate A date or date string.
     * @returns {Boolean}
     */

    var d;

    if (!TP.isDate(d = TP.dc(aDate))) {
        return this.raise('TP.sig.InvalidDate');
    }

    return this.getTime() < d.getTime();
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('isDSTDate',
function() {

    /**
     * @method isDSTDate
     * @summary Return true if the date is a daylight saving time (or "Summer
     *     Time" in the EU) date.
     * @exception TP.sig.InvalidParameter
     * @returns {Boolean} Whether or not its a DST date.
     */

    var aDateYear,

        thisYearStartDate,
        thisYearEndDate,

        startDateMS,
        endDateMS,
        aDateMS;

    //  Grab the year from the date.
    aDateYear = this.getFullYear();

    //  If the date we are asking about's year is the same as this year,
    //  then use precomputed start and end date values that have been (or
    //  will be if they haven't been constructed) cached on this type.
    if (aDateYear === Date.THIS_YEAR) {
        //  Construct and cache the start and end dates if they haven't
        //  already been done.

        if (TP.notValid(thisYearStartDate =
                        Date.get('thisYearStartDSTDate'))) {
            Date.set('thisYearStartDSTDate',
                        thisYearStartDate =
                            Date.getDSTStartDate(Date.THIS_YEAR));
        }

        if (TP.notValid(thisYearEndDate =
                        Date.get('thisYearEndDSTDate'))) {
            Date.set('thisYearEndDSTDate',
                        thisYearEndDate =
                            Date.getDSTEndDate(Date.THIS_YEAR));
        }

        //  Use the precomputed DST start and end dates for this year.
        startDateMS = thisYearStartDate.getTime();
        endDateMS = thisYearEndDate.getTime();
    } else {
        //  Compute the DST start and end dates using the installed DST
        //  computation functions (these can vary depending on the locale
        //  installed).
        startDateMS = Date.getDSTStartDate(this.getFullYear()).getTime();
        endDateMS = Date.getDSTEndDate(this.getFullYear()).getTime();
    }

    //  Grab the date we are asking about's MS count
    aDateMS = this.getTime();

    //  If the date we are asking about's MS count is greater than or equal
    //  to the start date's MS count or less than or equal to the end
    //  date's MS count, then it falls within the half of the year that is
    //  considered to be 'Daylight Saving Time' (or 'Summer Time' in some
    //  places).
    if (aDateMS >= startDateMS && aDateMS <= endDateMS) {
        return true;
    } else {
        return false;
    }
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('isUTCDSTDate',
function() {

    /**
     * @method isUTCDSTDate
     * @summary Return true if the date is a daylight saving time (or "Summer
     *     Time" in the EU) date.
     * @exception TP.sig.InvalidParameter
     * @returns {Boolean} Whether or not its a DST date.
     */

    var aDateYear,

        thisYearStartDate,
        thisYearEndDate,

        startDateMS,
        endDateMS,
        aDateMS;

    //  Grab the year from the date.
    aDateYear = this.getUTCFullYear();

    //  If the date we are asking about's year is the same as this year,
    //  then use precomputed start and end date values that have been (or
    //  will be if they haven't been constructed) cached on this type.
    if (aDateYear === Date.THIS_YEAR) {
        //  Construct and cache the start and end dates if they haven't
        //  already been done.

        if (TP.notValid(thisYearStartDate =
                        Date.get('thisYearStartDSTDate'))) {
            Date.set('thisYearStartDSTDate',
                        thisYearStartDate =
                            Date.getDSTStartDate(Date.THIS_YEAR));
        }

        if (TP.notValid(thisYearEndDate =
                        Date.get('thisYearEndDSTDate'))) {
            Date.set('thisYearEndDSTDate',
                        thisYearEndDate =
                            Date.getDSTEndDate(Date.THIS_YEAR));
        }

        //  Use the precomputed DST start and end dates for this year.
        startDateMS = thisYearStartDate.getTime();
        endDateMS = thisYearEndDate.getTime();
    } else {
        //  Compute the DST start and end dates using the installed DST
        //  computation functions (these can vary depending on the locale
        //  installed).
        startDateMS = Date.getDSTStartDate(this.getUTCFullYear()).getTime();
        endDateMS = Date.getDSTEndDate(this.getUTCFullYear()).getTime();
    }

    //  Grab the date we are asking about's MS count
    aDateMS = this.getTime();

    //  If the date we are asking about's MS count is greater than or equal
    //  to the start date's MS count or less than or equal to the end
    //  date's MS count, then it falls within the half of the year that is
    //  considered to be 'Daylight Saving Time' (or 'Summer Time' in some
    //  places).
    if (aDateMS >= startDateMS && aDateMS <= endDateMS) {
        return true;
    } else {
        return false;
    }
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('isSameDay',
function(aDate) {

    /**
     * @method isSameDay
     * @summary Returns true if the receiver is the same day as the date
     *     provided.
     * @param {Date} aDate The Date to use for comparison.
     * @exception TP.sig.InvalidParameter
     * @returns {Boolean}
     */

    if (!TP.isDate(aDate)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    /* eslint-disable no-extra-parens */
    return (this.getUTCFullYear() === aDate.getUTCFullYear() &&
            this.getUTCMonth() === aDate.getUTCMonth() &&
            this.getUTCDate() === aDate.getUTCDate());
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('isSameMonth',
function(aDate) {

    /**
     * @method isSameMonth
     * @summary Returns true if the receiver is the same month as the date
     *     provided.
     * @param {Date} aDate The Date to use for comparison.
     * @exception TP.sig.InvalidParameter
     * @returns {Boolean}
     */

    if (!TP.isDate(aDate)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    /* eslint-disable no-extra-parens */
    return (this.getUTCFullYear() === aDate.getUTCFullYear() &&
            this.getUTCMonth() === aDate.getUTCMonth());
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('isSameWeek',
function(aDate) {

    /**
     * @method isSameWeek
     * @summary Returns true if the receiver is the same week as the date
     *     provided.
     * @param {Date} aDate The Date to use for comparison.
     * @exception TP.sig.InvalidParameter
     * @returns {Boolean}
     */

    if (!TP.isDate(aDate)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    /* eslint-disable no-extra-parens */
    return (aDate.getTime() >= this.getUTCStartOfWeek() &&
            aDate.getTime() <= (this.getUTCStartOfWeek() +
                                                (Date.MSPERDAY * 7)));
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('isSameYear',
function(aDate) {

    /**
     * @method isSameYear
     * @summary Returns true if the receiver is the same year as the date
     *     provided.
     * @param {Date} aDate The Date to use for comparison.
     * @exception TP.sig.InvalidParameter
     * @returns {Boolean}
     */

    if (!TP.isDate(aDate)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    /* eslint-disable no-extra-parens */
    return (this.getUTCFullYear() === aDate.getUTCFullYear());
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

Date.Type.defineMethod('parseString',
function(aString, sourceLocale) {

    /**
     * @method parseString
     * @summary Returns the Date value of the string provided, as localized for
     *     the target locale.
     * @param {String} aString The input string to parse.
     * @param {String|TP.i18n.Locale} sourceLocale A source xml:lang or
     *     TP.i18n.Locale defining the language or locale the string is now in.
     * @returns {Date} The localized Date value.
     */

    return TP.sys.getLocale().parseDate(aString, sourceLocale);
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('setISOWeek',
function(aWeekNumber) {

    /**
     * @method setISOWeek
     * @summary Sets the receiver to be the same day of the week and time, but
     *     in week number N as defined by ISO 8601.
     * @description Officially, week 1 of any year is the week that contains 4
     *     January (that is, the week that contains the first Thursday in
     *     January). Almost all years have 52 weeks, but years that start on a
     *     Thursday and leap years that start on a Wednesday have 53 weeks using
     *     this metric.
     * @param {Number} aWeekNumber The number of the week in ISO 8601 terms.
     * @returns {Date} The receiver.
     */

    var week,
        sec,
        ms,

        oldVal,
        newVal;

    week = this.getISOWeek();

    if (week === aWeekNumber) {
        return this;
    }

    //  compute the difference in milliseconds
    sec = Date.getSecondsInDuration(
                TP.join('P', ((aWeekNumber - week) * 7).abs(), 'D'));

    ms = sec * 1000;

    oldVal = this.getTime();

    //  only question now is do we add or subtract :)
    if (week > aWeekNumber) {
        newVal = oldVal - ms;
    } else {
        newVal = oldVal + ms;
    }

    this.setTime(newVal);

    this.changed('time',
                    TP.UPDATE,
                    TP.hc(TP.OLDVAL, oldVal, TP.NEWVAL, newVal));

    return this;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('setUTCISOWeek',
function(aWeekNumber) {

    /**
     * @method setUTCISOWeek
     * @summary Sets the receiver to be the same day of the week and time, but
     *     in week number N as defined by ISO 8601.
     * @description Officially, week 1 of any year is the week that contains 4
     *     January (that is, the week that contains the first Thursday in
     *     January). Almost all years have 52 weeks, but years that start on a
     *     Thursday and leap years that start on a Wednesday have 53 weeks using
     *     this metric.
     * @param {Number} aWeekNumber The number of the week in ISO 8601 terms.
     * @returns {Date} The receiver.
     */

    var week,
        sec,
        ms,

        oldVal,
        newVal;

    week = this.getUTCISOWeek();

    if (week === aWeekNumber) {
        return this;
    }

    //  compute the difference in milliseconds
    sec = Date.getSecondsInDuration(
                TP.join('P', ((aWeekNumber - week) * 7).abs(), 'D'));

    ms = sec * 1000;

    oldVal = this.getTime();

    //  only question now is do we add or subtract :)
    if (week > aWeekNumber) {
        newVal = oldVal - ms;
    } else {
        newVal = oldVal + ms;
    }

    this.setTime(newVal);

    this.changed('time',
                    TP.UPDATE,
                    TP.hc(TP.OLDVAL, oldVal, TP.NEWVAL, newVal));

    return this;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('setUTCWeek',
function(aWeekNumber) {

    /**
     * @method setUTCWeek
     * @summary Sets the receiver to be the same day of the week and time, but
     *     in week number N as commonly used in the U.S.
     * @param {Number} aWeekNumber The number of the week in ISO 8601 terms.
     * @returns {Date} The receiver.
     */

    var week,
        sec,
        ms,

        oldVal,
        newVal;

    week = this.getUTCWeek();

    if (week === aWeekNumber) {
        return this;
    }

    //  compute the difference in milliseconds
    sec = Date.getSecondsInDuration(
                TP.join('P', ((aWeekNumber - week) * 7).abs(), 'D'));

    ms = sec * 1000;

    oldVal = this.getTime();

    //  only question now is do we add or subtract :)
    if (week > aWeekNumber) {
        newVal = oldVal - ms;
    } else {
        newVal = oldVal + ms;
    }

    this.setTime(newVal);

    this.changed('time',
                    TP.UPDATE,
                    TP.hc(TP.OLDVAL, oldVal, TP.NEWVAL, newVal));

    return this;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('setWeek',
function(aWeekNumber) {

    /**
     * @method setWeek
     * @summary Sets the receiver to be the same day of the week and time, but
     *     in week number N as commonly used in the U.S.
     * @param {Number} aWeekNumber The number of the week to set.
     * @returns {Date} The receiver.
     */

    var week,
        sec,
        ms,

        oldVal,
        newVal;

    week = this.getWeek();

    if (week === aWeekNumber) {
        return this;
    }

    //  compute the difference in milliseconds
    sec = Date.getSecondsInDuration(
                TP.join('P', ((aWeekNumber - week) * 7).abs(), 'D'));

    ms = sec * 1000;

    oldVal = this.getTime();

    //  only question now is do we add or subtract :)
    if (week > aWeekNumber) {
        newVal = oldVal - ms;
    } else {
        newVal = oldVal + ms;
    }

    this.setTime(newVal);

    this.changed('time',
                    TP.UPDATE,
                    TP.hc(TP.OLDVAL, oldVal, TP.NEWVAL, newVal));

    return this;
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('subtract',
function(anObject) {

    /**
     * @method subtract
     * @summary Subtracts a number of milliseconds or a duration from the
     *     receiver, returning a new Date. To subtract Dates to produce
     *     durations of the difference in time use subtractDate.
     * @param {Number|String} anObject A number of milliseconds or a duration
     *     string.
     * @exception TP.sig.InvalidParameter
     * @returns {Date} A new date.
     */

    if (TP.isNumber(anObject)) {
        return TP.dc(this.getTime() - anObject);
    } else if (TP.isString(anObject)) {
        return this.subtractDuration(anObject);
    }

    return this.raise('TP.sig.InvalidParameter');
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('subtractDate',
function(aDate) {

    /**
     * @method subtractDate
     * @summary Returns a duration string representing the difference between
     *     the two dates.
     * @param {Date} aDate The date to subtract from the receiver.
     * @exception TP.sig.InvalidParameter
     * @returns {String} An xs:duration formatted string containing the
     *     difference in the two date values.
     */

    return TP.dc(this.getTime() - aDate.getTime());
});

//  ------------------------------------------------------------------------

Date.Inst.defineMethod('subtractDuration',
function(aDuration) {

    /**
     * @method subtractDuration
     * @summary Returns a new Date which represents the receiver adjusted by
     *     the duration string provided.
     * @param {String} aDuration An xs:duration formatted string.
     * @exception TP.sig.InvalidParameter
     * @returns {Date} A Date object.
     */

    var aDate,
        months,
        secs;

    //  first step is to get the months in the duration and get them
    //  subtracted from the current date's value so we reverse the calendar
    //  by that number of months...
    months = Date.getMonthsInDuration(aDuration);

    aDate = TP.dc(this.getTime());
    aDate.setUTCMonth(aDate.getUTCMonth() - months);

    secs = Date.getSecondsInDuration(aDuration);

    /* eslint-disable no-extra-parens */
    return TP.dc(aDate.getTime() - (secs * 1000));
    /* eslint-enable no-extra-parens */
});

//  ========================================================================
//  Number
//  ========================================================================

/**
 * @summary Extensions that make using Number a bit easier.
 * @description This file contains functionality for the Number type that make
 *     using Numbers easier, including convenience wrappers to cover
 *     interactions with the built-in Math object. Therefore, it is no longer
 *     necessary to pass Numbers into the Math object, one can simply send the
 *     proper message to a Number.
 */

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  Constants copied over from the Math object
Number.Type.defineConstant('E', Math.E);
Number.Type.defineConstant('LN10', Math.LN10);
Number.Type.defineConstant('LN2', Math.LN2);
Number.Type.defineConstant('LOG10E', Math.LOG10E);
Number.Type.defineConstant('LOG2E', Math.LOG2E);
Number.Type.defineConstant('PI', Math.PI);
Number.Type.defineConstant('SQRT1_2', Math.SQRT1_2);
Number.Type.defineConstant('SQRT2', Math.SQRT2);

Number.Type.defineConstant('TWO_PI', Math.PI * 2);
Number.Type.defineConstant('QUARTER_PI', Math.PI / 4);
Number.Type.defineConstant('EIGHTH_PI', Math.PI / 8);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

/**
 * @These are here to support requirements for StringCollectionExtensions
 *     regarding the various formatting functions related to the substitute
 *     call.
 */

//  ------------------------------------------------------------------------

Number.Type.defineMethod('getDecimalPoint',
function() {

    /**
     * @method getDecimalPoint
     * @summary Returns the character used as the decimal point.
     * @returns {String} The decimal point character.
     */

    return TP.sys.getLocale().getDecimalPoint();
});

//  ------------------------------------------------------------------------

Number.Type.defineMethod('getThousandsGroupSize',
function() {

    /**
     * @method getThousandsGroupSize
     * @summary Returns the size of the grouping for thousands. In most Western
     *     countries, this is 3.
     * @returns {Number} The thousands grouping size.
     */

    return TP.sys.getLocale().getThousandsGroupSize();
});

//  ------------------------------------------------------------------------

Number.Type.defineMethod('getThousandsMatcher',
function() {

    /**
     * @method getThousandsMatcher
     * @summary Returns the character used to separate thousands groupings.
     * @returns {String} The thousands separator.
     */

    return TP.sys.getLocale().getThousandsMatcher();
});

//  ------------------------------------------------------------------------

Number.Type.defineMethod('getThousandsSeparator',
function() {

    /**
     * @method getThousandsSeparator
     * @summary Returns the character used to separate thousands groupings.
     * @returns {String} The thousands separator.
     */

    return TP.sys.getLocale().getThousandsSeparator();
});

//  ------------------------------------------------------------------------

Number.Type.defineMethod('random',
function() {

    /**
     * @method random
     * @summary Returns a pseudo-random number between 0.0 and 1.0.
     * @returns {Number} A number between 0.0 and 1.0.
     */

    return Math.random();
});

//  ------------------------------------------------------------------------

Number.Type.defineMethod('randomInt',
function(min, max) {

    /**
     * @method randomInt
     * @summary Returns a pseudo-random integer between the supplied min and
     *     max bounds.
     * @param {Number} min The minimum bounds of the random integer.
     * @param {Number} max The maximum bounds of the random integer.
     * @exception TP.sig.InvalidParameter
     * @returns {Number} An integer between min and max.
     */

    var div,
        randNum,

        i;

    if (!TP.isNumber(min) || !TP.isNumber(max)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    /* eslint-disable no-extra-parens */
    div = (max - min) + 1;
    /* eslint-enable no-extra-parens */
    randNum = Math.random();

    for (i = 0; i <= div - 1; i++) {
        if (randNum >= i / div && randNum < (i + 1) / div) {
            return i + min;
        }
    }
});

//  ------------------------------------------------------------------------

Number.Type.defineMethod('validate',
function(anObj) {

    /**
     * @method validate
     * @summary Tests the incoming value to see if it represents a valid
     *     instance of the receiver.
     * @param {Object} anObj The object to test.
     * @returns {Boolean} True if the object is 'valid'.
     */

    return !TP.isNaN(parseFloat(anObj));
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

Number.Inst.defineMethod('abs',
function() {

    /**
     * @method abs
     * @summary Returns the absolute value of the receiver.
     * @returns {Number} The receiver's absolute value.
     */

    return Math.abs(this);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('acos',
function() {

    /**
     * @method acos
     * @summary Returns the arc cosine of the receiver.
     * @returns {Number} The receiver's arc cosine.
     */

    return Math.acos(this);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('acosD',
function() {

    /**
     * @method acosD
     * @summary Returns the arc cosine of the receiver in degrees.
     * @returns {Number} The receiver's arc cosine in degrees.
     */

    return Math.acos(this * (180 / Math.PI));
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('almostEquals',
function(aComparison, aTolerance) {

    /**
     * @method almostEquals
     * @summary Returns whether the receiver and the supplied comparison value
     *     are equal, within the supplied tolerance.
     * @param {Number} aComparison The number to compare the receiver to.
     * @param {Number} aTolerance The tolerance to use in the comparison.
     *     Defaults to 0.
     * @returns {Boolean} Whether or not the receiver is equal to the supplied
     *     comparison, within the supplied tolerance.
     */

    var tolerance;

    tolerance = TP.ifInvalid(aTolerance, 0);

    if (this - aComparison <= tolerance) {
        return true;
    }

    return false;
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('angleDifference',
function(anAngle) {

    /**
     * @method angleDifference
     * @summary Returns the difference between the receiver (which should be an
     *     angle expressed in degrees) and the supplied angle (which should also
     *     be an angle expressed in degrees.
     * @param {Number} anAngle An angle to use expressed in degrees.
     * @returns {Number} The difference between the receiver and the supplied
     *     angle expressed in degrees.
     */

    var diff;

    diff = anAngle.standardizeAngle() - this.standardizeAngle();

    if (diff > 180) {
        diff -= 360;
    } else if (diff <= -180) {
        diff += 360;
    }

    return diff;
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('angleDx',
function(anAngle, aRadius) {

    /**
     * @method angleDx
     * @summary Returns the X part of the distance computed using the supplied
     *     angle and radius.
     * @param {Number} anAngle The angle to use expressed in degrees.
     * @param {Number} aRadius The radius to use.
     * @returns {Number} The X part of the distance for the given angle and
     *     radius.
     */

    return aRadius * anAngle.degreesToRadians().cos();
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('angleDy',
function(anAngle, aRadius) {

    /**
     * @method angleDy
     * @summary Returns the Y part of the distance computed using the supplied
     *     angle and radius.
     * @param {Number} anAngle The angle to use expressed in degrees.
     * @param {Number} aRadius The radius to use.
     * @returns {Number} The Y part of the distance for the given angle and
     *     radius.
     */

    return aRadius * anAngle.degreesToRadians().sin();
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('asColor',
function() {

    /**
     * @method asColor
     * @summary Returns the color value of the receiver (a 2 digit hex value
     *     without the leading '0x').
     * @returns {String} The receiver's color value.
     */

    var res;

    //  TODO:   remove this restriction
    if (this > 255) {
        return this.raise('TP.sig.InvalidRange');
    }

    if (this < 16) {
        res = '0' + this.toString(16);
    } else {
        res = this.toString(16);
    }

    return res;
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('asDuration',
function() {

    /**
     * @method asDuration
     * @summary Returns the 'xs:duration' value of the receiver. The receiver
     *     is assumed to be a number of millisecond count that will be
     *     translated into a duration with a fractional number of seconds.
     * @returns {String} The receiver's 'xs:duration' value.
     */

    var res,
        msFraction;

    res = 'PT';

    msFraction = (this + 0) / 1000;

    if (msFraction < 1 && msFraction.toString().charAt(0) !== '0') {
        res += '0';
    }

    res += msFraction + 'S';

    return res;
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('asHex',
function() {

    /**
     * @method asHex
     * @summary Returns the hexadecimal value of the receiver.
     * @returns {String} The receiver's hex value.
     */

    var res;

    //  TODO:   remove this restriction
    if (this > 255) {
        return this.raise('TP.sig.InvalidRange');
    }

    res = '0x';

    if (this < 16) {
        res += '0' + this.toString(16);
    } else {
        res += this.toString(16);
    }

    return res;
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('asin',
function() {

    /**
     * @method asin
     * @summary Returns the arc sine of the receiver.
     * @returns {Number} The receiver's arc sine.
     */

    return Math.asin(this);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('asinD',
function() {

    /**
     * @method asinD
     * @summary Returns the arc sine of the receiver in degrees.
     * @returns {Number} The receiver's arc sine in degrees.
     */

    return Math.asin(this * (180 / Math.PI));
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('atan',
function() {

    /**
     * @method atan
     * @summary Returns the arc tangent of the receiver.
     * @returns {Number} The receiver's arc tangent.
     */

    return Math.atan(this);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('atanD',
function() {

    /**
     * @method atanD
     * @summary Returns the arc tangent of the receiver in degrees.
     * @returns {Number} The receiver's arc tangent in degrees.
     */

    return Math.atan(this * (180 / Math.PI));
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('atan2',
function(xSize) {

    /**
     * @method atan2
     * @summary Returns the counterclockwise angle using the positive X size
     *     and the receiver as a positive Y size.
     * @param {Number} xSize The X size to use with the receiver in computing
     *     the counterclockwise angle.
     * @exception TP.sig.InvalidParameter
     * @returns {Number} The counterclockwise angle using the receiver and
     *     xSize.
     */

    if (!TP.isNumber(xSize)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    return Math.atan2(this, xSize);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('atan2D',
function(xSize) {

    /**
     * @method atan2D
     * @summary Returns the counterclockwise angle, in degrees, using the
     *     positive X size and the receiver as a positive Y size.
     * @param {Number} xSize The X size to use with the receiver in computing
     *     the counterclockwise angle.
     * @exception TP.sig.InvalidParameter
     * @returns {Number} The counterclockwise angle in degrees using the
     *     receiver and xSize.
     */

    if (!TP.isNumber(xSize)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    return Math.atan2(this, xSize) * (180 / Math.PI);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('ceil',
function() {

    /**
     * @method ceil
     * @summary Returns the closest integer value that is greater than or equal
     *     to the receiver.
     * @returns {Number} The closest integer greater than or equal to the
     *     receiver.
     */

    return Math.ceil(this);
});


//  ------------------------------------------------------------------------

Number.Inst.defineMethod('cos',
function() {

    /**
     * @method cos
     * @summary Returns the cosine of the receiver.
     * @returns {Number} The receiver's cosine.
     */

    return Math.cos(this);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('cosD',
function() {

    /**
     * @method cosD
     * @summary Returns the cosine of the receiver in degrees.
     * @returns {Number} The receiver's cosine in degrees.
     */

    return Math.cos(this * (Math.PI / 180));
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('degreesToRadians',
function() {

    /**
     * @method degreesToRadians
     * @summary Returns the receiver's value as radians, assuming that the
     *     receiver contains a number of degrees.
     * @returns {Number} The receiver's value in radians.
     */

    /* eslint-disable no-extra-parens */
    return (this * Math.PI) / 180;
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('exp',
function() {

    /**
     * @method exp
     * @summary Returns 'e' (natural log) to the power of the receiver.
     * @returns {Number} The natural log to the power of the receiver.
     */

    return Math.exp(this);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('factorial',
function() {

    /**
     * @method factorial
     * @summary Returns the factorial of the receiver.
     * @returns {Number} The factorial of the receiver.
     */

    var val,
        i;

    //  Can't do this with a negative number
    if (this < 0) {
        return 0;
    }

    val = 1;

    for (i = 1; i <= this; i++) {
        val *= i;
    }

    return val;
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('floor',
function() {

    /**
     * @method floor
     * @summary Returns the closest integer value that is lesser than or equal
     *     to the receiver.
     * @returns {Number} The closest integer lesser than or equal to the
     *     receiver.
     */

    return Math.floor(this);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('fraction',
function(aCount) {

    /**
     * @method fraction
     * @summary Returns the fractional part of the receiver without doing any
     *     rounding i.e. (123.456).fraction(2) returns 0.45.
     * @param {Number} aCount The number of decimal places.
     * @returns {Number}
     */

    var str,

        end,
        val;

    //  use primitive here to get the '.' version
    str = this.toString();

    if (!TP.regex.HAS_PERIOD.test(str)) {
        return 0;
    }

    end = TP.ifInvalid(aCount, Number.POSITIVE_INFINITY);
    val = '0.' + str.split('.').last().slice(0, end);

    return parseFloat(val);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('integer',
function() {

    /**
     * @method integer
     * @summary Returns the integer portion of the receiver.
     * @returns {Number}
     */

    if (this < 0) {
        return this.ceil();
    } else {
        return this.floor();
    }
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('isBetween',
function(minValue, maxValue) {

    /**
     * @method isBetween
     * @summary Returns whether the receiver is between the minValue and
     *     maxValue (not including the values themselves).
     * @param {Number} minValue The minimum value that the receiver has to be
     *     greater than.
     * @param {Number} maxValue The maximum value that the receiver has to be
     *     lesser than.
     * @exception TP.sig.InvalidParameter
     * @returns {Boolean} Whether the receiver is between minValue and maxValue.
     */

    if (!TP.isNumber(minValue) || !TP.isNumber(maxValue)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    /* eslint-disable no-extra-parens */
    return (this > minValue && this < maxValue);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('isBetweenInclusive',
function(minValue, maxValue) {

    /**
     * @method isBetweenInclusive
     * @summary Returns whether the receiver is between the minValue and
     *     maxValue (including the values themselves).
     * @param {Number} minValue The minimum value that the receiver has to be
     *     greater than or equal to.
     * @param {Number} maxValue The maximum value that the receiver has to be
     *     lesser than or equal to.
     * @exception TP.sig.InvalidParameter
     * @returns {Boolean} Whether the receiver is between minValue and maxValue
     *     inclusive.
     */

    if (!TP.isNumber(minValue) || !TP.isNumber(maxValue)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    /* eslint-disable no-extra-parens */
    return (this >= minValue && this <= maxValue);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('isEven',
function() {

    /**
     * @method isEven
     * @summary Returns whether the receiver is an even number.
     * @returns {Boolean} Whether or not the receiver is even.
     */

    /* eslint-disable no-extra-parens */
    return (this % 2 === 0);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('isInteger',
function() {

    /**
     * @method isInteger
     * @summary Returns whether the receiver is an integer. An integer number
     *     is defined as a number that has no fractional component.
     * @returns {Boolean} Whether or not the receiver is an integer.
     */

    /* eslint-disable no-extra-parens */
    return (this % 1 === 0);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('isNegative',
function() {

    /**
     * @method isNegative
     * @summary Returns whether the receiver is a negative number or not. A
     *     negative number is defined as a number that is less than 0.
     * @returns {Boolean} Whether or not the receiver is negative.
     */

    /* eslint-disable no-extra-parens */
    return (this < 0);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('isOdd',
function() {

    /**
     * @method isOdd
     * @summary Returns whether the receiver is an odd number.
     * @returns {Boolean} Whether or not the receiver is odd.
     */

    /* eslint-disable no-extra-parens */
    return (this % 2 === 1);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('isPositive',
function() {

    /**
     * @method isPositive
     * @summary Returns whether the receiver is a positive number or not. A
     *     positive number is defined as a number that is greater than or equal
     *     to 0.
     * @returns {Boolean} Whether or not the receiver is positive.
     */

    /* eslint-disable no-extra-parens */
    return (this >= 0);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('log2',
function() {

    /**
     * @method log2
     * @summary Returns the base-2 logarithm of the receiver.
     * @returns {Number} The receiver's base-2 logarithm.
     */

    return Math.LOG2E * Math.log(this);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('log10',
function() {

    /**
     * @method log10
     * @summary Returns the base-10 logarithm of the receiver.
     * @returns {Number} The receiver's base-10 logarithm.
     */

    return Math.LOG10E * Math.log(this);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('log',
function() {

    /**
     * @method log
     * @summary Returns the natural logarithm of the receiver.
     * @returns {Number} The receiver's natural logarithm.
     */

    return Math.log(this);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('max',
function(varargs) {

    /**
     * @method max
     * @summary Returns the largest value from the receiver and arguments. Note
     *     that you can pass multiple values to this call.
     * @param {arguments} varargs A variable list of 0 to N elements to place in
     *     the array.
     * @exception TP.sig.InvalidParameter
     * @returns {Number} The largest value found.
     */

    var result,
        i,
        check;

    /* eslint-disable consistent-this */
    result = this;
    /* eslint-enable consistent-this */

    for (i = 0; i < arguments.length; i++) {
        check = arguments[i];

        if (!TP.isNumber(check)) {
            return this.raise('TP.sig.InvalidParameter', check);
        }

        result = Math.max(result, check);
    }

    return result;
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('min',
function(varargs) {

    /**
     * @method min
     * @summary Returns the smallest value from the receiver and arguments.
     * @param {arguments} varargs A variable list of 0 to N elements to place in
     *     the array.
     * @exception TP.sig.InvalidParameter
     * @returns {Number} The smallest value found.
     */

    var result,
        i,
        check;

    /* eslint-disable consistent-this */
    result = this;
    /* eslint-enable consistent-this */

    for (i = 0; i < arguments.length; i++) {
        check = arguments[i];

        if (!TP.isNumber(check)) {
            return this.raise('TP.sig.InvalidParameter', check);
        }

        result = Math.min(result, check);
    }

    return result;
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('minMax',
function(minNum, maxNum) {

    /**
     * @method minMax
     * @summary Returns the receiver, if it is between the minNum and the
     *     maxNum, the minNum if the receiver is less than it is and the maxNum
     *     if the receiver is more than it is.
     * @param {Number} minNum The minimum number.
     * @param {Number} maxNum The maximum number.
     * @exception TP.sig.InvalidParameter
     * @returns {Number} The receiver or the minNum or the maxNum according to
     *     the method comment.
     */

    if (!TP.isNumber(minNum) || !TP.isNumber(maxNum)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    return Math.max(Math.min(this, maxNum), minNum);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('modulo',
function(aDivisor) {

    /**
     * @method modulo
     * @summary Returns the modulus of dividing the receiver by the supplied
     *     divisor.
     * @description JavaScript's modulo operator operates such that it will take
     *     the same sign as the receiver (the dividend). Other languages operate
     *     in such a way that they will return a result that has the same sign
     *     as the supplied divisor. This routine supplies an implementation of
     *     the second.
     * @param {Number} aDivisor The divisor to use in the computation.
     * @returns {Number} The modulus value that takes the same sign as the
     *     supplied divisor.
     */

    var remainder;

    remainder = this % aDivisor;

    /* eslint-disable no-extra-parens */
    return (remainder * aDivisor < 0) ? remainder + aDivisor : remainder;
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

Number.Type.defineMethod('parseString',
function(aString, sourceLocale) {

    /**
     * @method parseString
     * @summary Returns the Number value of the string provided, as localized
     *     for the target locale.
     * @param {String} aString The input string to parse.
     * @param {String|TP.i18n.Locale} sourceLocale A source xml:lang or
     *     TP.i18n.Locale defining the language or locale the string is now in.
     * @returns {Number} The localized Number value.
     */

    return TP.sys.getLocale().parseNumber(aString, sourceLocale);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('pow',
function(power) {

    /**
     * @method pow
     * @summary Returns the receiver raised to the power of 'power'.
     * @param {Number} power The power to raise the receiver to.
     * @exception TP.sig.InvalidParameter
     * @returns {Number} The receiver raised to 'power'.
     */

    if (!TP.isNumber(power)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    return Math.pow(this, power);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('radiansToDegrees',
function() {

    /**
     * @method radiansToDegrees
     * @summary Returns the receiver's value as degrees, assuming that the
     *     receiver contains a number of radians.
     * @returns {Number} The receiver's value in degrees.
     */

    /* eslint-disable no-extra-parens */
    return (this * 180) / Math.PI;
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('round',
function(places) {

    /**
     * @method round
     * @summary Returns a rounding of the receiver up or down to the nearest
     *     integer.
     * @description This function rounds .5 up. It also extends the standard
     *     'Math.round' method by taking a number of places that the receiver
     *     will be rounded to.
     * @param {Number} places The number of places to round the receiver to.
     * @returns {Number} The receiver rounded up or down.
     */

    var placesShift;

    if (TP.isNumber(places)) {
        placesShift = Math.pow(10, places);
        return Math.round(this * placesShift) / placesShift;
    }

    return Math.round(this);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('sin',
function() {

    /**
     * @method sin
     * @summary Returns the sine of the receiver.
     * @returns {Number} The receiver's sine.
     */

    return Math.sin(this);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('sinD',
function() {

    /**
     * @method sinD
     * @summary Returns the sine of the receiver in degrees.
     * @returns {Number} The receiver's sine in degrees.
     */

    return Math.sin(this * (Math.PI / 180));
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('sqrt',
function() {

    /**
     * @method sqrt
     * @summary Returns the square root of the receiver.
     * @returns {Number} The receiver's square root.
     */

    return Math.sqrt(this);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('standardizeAngle',
function() {

    /**
     * @method standardizeAngle
     * @summary Returns the supplied angle 'standardized' to be an exact number
     *     of degrees between 0 and 360.
     * @returns {Number} The receiver 'standardized' between 0 and 360.
     */

    return this.modulo(360);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('tan',
function() {

    /**
     * @method tan
     * @summary Returns the tangent of the receiver.
     * @returns {Number} The receiver's tangent.
     */

    return Math.tan(this);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('tanD',
function() {

    /**
     * @method tanD
     * @summary Returns the tangent of the receiver in degrees.
     * @returns {Number} The receiver's tangent in degrees.
     */

    return Math.tan(this * (Math.PI / 180));
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('quoted',
function(aQuoteChar) {

    /**
     * @method quoted
     * @summary Returns the receiver as a quoted string.
     * @param {String} aQuoteChar The quote char to use. Default is single
     *     quotes.
     * @returns {String}
     */

    return this.asString().quoted(aQuoteChar);
});

//  ========================================================================
//  RegExp
//  ========================================================================

/**
 * @summary Extensions that make using RegExp a bit easier.
 * @description This file contains a set of premade constant RegExps that define
 *     common punctuation characters, numbers, etc.
 */

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

RegExp.Type.defineMethod('escapeMetachars',
function(aString) {

    /**
     * @method escapeMetachars
     * @summary Escapes any RegExp metacharacters found in the supplied String.
     * @param {String} aString The String to escape any RegExp metacharacters
     *     in.
     * @returns {String} The supplied String with RegExp metacharacters escaped.
     */

    return TP.regExpEscape(aString);
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

RegExp.Inst.defineMethod('match',
function(anObject) {

    /**
     * @method match
     * @summary Returns the result of running the expression against the string
     *     value of the object provided. This method is provided so that you can
     *     pass either a String or RegExp to methods that need to query based on
     *     string/regex content.
     * @param {Object} anObject The object whose string value should be tested.
     * @returns {String[]|undefined} An array identical to the one produced by
     *     String.match().
     */

    var str;

    str = TP.str(anObject);
    if (TP.isString(str)) {
        return str.match(this);
    }

    return;
});

//  ========================================================================
//  String
//  ========================================================================

/**
 * @summary Extensions that make using Strings a bit easier, and which add
 *     support for elements such as string substitutions for output formatting.
 * @description
 */

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

String.Type.defineAttribute('$allHashMarker', TP.rc('[^?0]+', 'g'));

//  ------------------------------------------------------------------------
//  Type Methods
//  ----------------------------------------------------------------------------

String.Type.defineMethod('initialize',
function(aName) {

    /**
     * @method initialize
     * @summary There is no initialization here, but we need a method stub to
     *     satisfy the runtime system on startup. This is required because of
     *     ECMAScript6+ type proxies and they're interaction with String when
     *     String is used to "initialize" a type that can only be found by name.
     */

    return;
});

//  ------------------------------------------------------------------------

String.Type.defineMethod('getRegisteredSubstitutions',
function() {

    /**
     * @method getRegisteredSubstitutions
     * @summary Returns a collection of registered string substitution
     *     functions.
     * @description String substitutions are done using registered substitition
     *     functions. This method returns the current registrations.
     * @returns {Object}
     */

    if (TP.notValid(this.$substitutions)) {
        this.$substitutions = new TP.boot.PHash();
    }

    return this.$substitutions;
});

//  ------------------------------------------------------------------------

String.Type.defineMethod('getSubstitution',
function(aSymbol) {

    /**
     * @method getSubstitution
     * @summary Returns a substitution registration or undefined.
     * @param {String} aSymbol A single character symbol used to identify the
     *     substitution.
     * @returns {Object}
     */

    return this.getRegisteredSubstitutions().at(aSymbol);
});

//  ------------------------------------------------------------------------

String.Type.defineMethod('parseString',
function(aString, sourceLocale) {

    /**
     * @method parseString
     * @summary Returns the String value of the string provided, as localized
     *     for the target locale. Obviously this seems a little strange, but the
     *     localization point is key here, not the type conversion aspect.
     * @param {String} aString The input string to parse.
     * @param {String|TP.i18n.Locale} sourceLocale A source xml:lang or
     *     TP.i18n.Locale defining the language the string is now in. Defaults
     *     to getTargetLanguage() which is based on the current locale's
     *     language-country value.
     * @returns {String} The localized String value.
     */

    return TP.sys.getLocale().parseString(aString, sourceLocale);
});

//  ------------------------------------------------------------------------

String.Type.defineMethod('registerSubstitution',
function(aSymbol, anExistenceTest, aDataSymbol, aRegExp, aHandler) {

    /**
     * @method registerSubstitution
     * @summary Registers a string substitution pattern and handler pair.
     * @description String substitution uses a pattern String to contain
     *     patterns of characters that will be replaced by one or more
     *     'substitution' handlers. The substitution will take place if a regex
     *     that is built of all of the 'existence tests' for all of the
     *     registered substitutions matches text in the pattern. The system
     *     automatically registers a number of these substitutions.
     *
     *     One of the most commonly used subsitutions is the 'eval'
     *     substitution, which uses delimiters similar to TSH shell syntax (ala
     *     `...`). This particular substitution is special-cased by its own
     *     regex, as it needs to be performed before all other substitutions.
     *
     *     In any case, this method is used to register a particular
     *     substitution entry with the String type.
     * @param {String} aSymbol The symbol used to identify entities for this
     *     substitution. This is what anExistenceTest should find in order to
     *     invoke this substitution.
     * @param {String} anExistenceTest This substitution's regex (as a String
     *     that will joined with other substitutions regexs) that will be used
     *     to determine if expressions processed by this substitution exist in
     *     the pattern.
     * @param {String} aDataSymbol If the dataSource has data for multiple
     *     substitution patterns, the data for this substitution will be found
     *     under this key.
     * @param {RegExp} aRegExp The regular expression used to extract content
     *     for the handler to process.
     * @param {Function} aHandler The function used to process content.
     * @returns {String} The receiver.
     */

    var subs;

    //  Register the substitution with the substitution registry
    subs = this.getRegisteredSubstitutions();
    subs.atPut(aSymbol, TP.hc('dataSymbol', aDataSymbol,
                                'matcher', aRegExp,
                                'handler', aHandler));

    //  If the String for the overall test RegExp exists, then it will be
    //  in the form of '(sub1test|sub2test)'. Slice off the last paren and
    //  add the registering substitution's existence test to the end.
    if (TP.isString(String.$subsReStr)) {
        String.$subsReStr = String.$subsReStr.slice(0, -1) +
                                '|' + anExistenceTest + ')';
    } else {
        //  Otherwise, initialize the String for the overall test RegExp to
        //  the proper value.
        String.$subsReStr = '(' + anExistenceTest + ')';
    }

    //  Make the overall test RegExp from its String.
    String.$subsRe = TP.rc(String.$subsReStr);

    return this;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

String.Inst.defineAttribute('delimiter', '');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

String.Inst.defineMethod('add',
function(varargs) {

    /**
     * @method add
     * @summary Adds one or more items, usually strings, to the receiver.
     * @param {arguments} varargs One or more objects to concatentate to the
     *     receiver in string form.
     * @returns {String} A newly formed string.
     */

    var len,
        arr,
        i;

    len = arguments.length;
    if (len > 1) {
        arr = TP.ac();
        for (i = 0; i < len; i++) {
            arr.push(arguments[i]);
        }

        return this.toString() + arr.join('');
    }

    return this.toString() + TP.str(arguments[0]);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asCleanString',
function() {

    /**
     * @method asCleanString
     * @summary Returns the 'clean' string representation of the receiver.
     *     This may have transformations in it to 'clean' the String, such as
     *     removing unnecessary namespace definitions, etc. For this type, it
     *     just returns the receiver itself.
     * @returns {String} The receiver in clean string form.
     */

    return this;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asHash',
function() {

    /**
     * @method asHash
     * @summary Returns the receiver as a TP.core.Hash using parsers
     *     available for the TP.core.Hash type. Strings conforming to query
     *     strings, CSS declarations, and other forms depend on TP.core.Hash to
     *     parse them properly. If no parser can convert the string into a
     *     proper TP.core.Hash instance then a TP.core.Hash containing the
     *     receiver as the only key will be returned.
     * @returns {TP.core.Hash} A hash of key/value pairs represented by the
     *     receiver.
     */

    var hash;

    hash = TP.core.Hash.fromString(this.asString());

    if (TP.notValid(hash)) {
        return TP.hc(this.asString(), null);
    }
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asHashedNumber',
function() {

    /**
     * @method asHashedNumber
     * @summary Returns the receiver as a hashed number using a one-way hashing
     *     function.
     * @returns {Number} The receiver as a hashed number.
     */

    /* eslint-disable no-extra-parens */
    return this.split('').reduce(
                function(a, b) {
                    var retVal;

                    retVal = ((a << 5) - a) + b.charCodeAt(0);
                    return retVal & retVal;
                },
                0);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

//  Alias this over for the convenience of the as()/format() calls
String.Inst.defineMethod('asLowerCase', TP.StringProto.toLowerCase);

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asMD5',
function(formatParams) {

    /**
     * @method asMD5
     * @summary Returns the receiver as hashed by the MD5 hash.
     * @param {TP.core.Hash|TP.sig.Request} formatParams Optional format
     *     parameters. These are parameters to a hashing result format and
     *     should contain a key of 'hashFormat' that has one of the following
     *     values:
     *          TP.HASH_B64
     *          TP.HASH_LATIN1
     *          TP.HASH_HEX
     *      The default is TP.HASH_HEX
     * @returns {String} The receiver as an MD5 hash.
     */

    var params;

    params = TP.hc(formatParams);
    params.atPutIfAbsent('hashFormat', TP.HASH_HEX);

    return TP.hash(this.asString(), TP.HASH_MD5, params.at('hashFormat'));
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asSHA1',
function(formatParams) {

    /**
     * @method asSHA1
     * @summary Returns the receiver as hashed by the SHA-1 hash.
     * @param {TP.core.Hash|TP.sig.Request} formatParams Optional format
     *     parameters. These are parameters to a hashing result format and
     *     should contain a key of 'hashFormat' that has one of the following
     *     values:
     *          TP.HASH_B64
     *          TP.HASH_LATIN1
     *          TP.HASH_HEX
     *      The default is TP.HASH_HEX
     * @returns {String} The receiver as an SHA-1 hash.
     */

    var params;

    params = TP.hc(formatParams);
    params.atPutIfAbsent('hashFormat', TP.HASH_HEX);

    return TP.hash(this.asString(), TP.HASH_SHA1, params.at('hashFormat'));
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asQueryString',
function() {

    /**
     * @method asQueryString
     * @summary Converts the receiver into a String where any characters that
     *     need to be escaped in a URI query string have been converted into
     *     their escaped equivalent.
     * @returns {String} The receiver with URI entities escaped.
     */

    return encodeURIComponent(this);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asUnicodeLiteral',
function() {

    /**
     * @method asUnicodeLiteral
     * @summary Returns a Unicode literal representation of the receiver. For
     *     instance, for a single character String of 'b', this method will
     *     return '\u0062'.
     * @returns {String} The Unicode literal String representation of the
     *     receiver.
     */

    var str,
        unicodeRetStr,
        i,
        unicodeCharStr;

    str = this.toString();
    unicodeRetStr = '';

    //  Loop and build up a 4 character Unicode representation for each
    //  character in the receiver.
    for (i = 0; i < str.length; i++) {

        unicodeCharStr = str.charCodeAt(i).toString(16).toUpperCase();

        //  Front-pad it with '0's
        while (unicodeCharStr.length < 4) {
            unicodeCharStr = '0' + unicodeCharStr;
        }

        //  Prepend a '\u' and move on to the next character in the receiver.
        unicodeCharStr = '\\u' + unicodeCharStr;
        unicodeRetStr += unicodeCharStr;
    }

    return unicodeRetStr;
});

//  ------------------------------------------------------------------------

//  Alias this over for the convenience of the as()/format() calls
String.Inst.defineMethod('asUpperCase', TP.StringProto.toUpperCase);

//  ------------------------------------------------------------------------

String.Inst.defineMethod('charToLowerCase',
function(index) {

    /**
     * @method charToLowerCase
     * @summary Returns the receiver with the character at position index in
     *     lowercase format.
     * @param {Number} index The index of the character to make lower case.
     * @exception TP.sig.InvalidIndex
     * @returns {String} The string with the character at index in lower case.
     */

    return this.slice(0, index) +
            this.charAt(index).toLowerCase() +
            this.slice(index + 1);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('charToUpperCase',
function(index) {

    /**
     * @method charToUpperCase
     * @summary Returns the receiver with the character at position index in
     *     uppercase format.
     * @param {Number} index The index of the character to make upper case.
     * @exception TP.sig.InvalidIndex
     * @returns {String} The string with the character at index in upper case.
     */

    return this.slice(0, index) +
            this.charAt(index).toUpperCase() +
            this.slice(index + 1);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('chop',
function(aTail) {

    /**
     * @method chop
     * @summary Returns the receiver with aTail removed provided the receiver
     *     ends with that character sequence.
     * @param {String} aTail The character(s) to remove if found.
     * @returns {String} A new string minus the tail.
     */

    if (this.endsWith(aTail)) {
        return this.slice(0, 0 - aTail.getSize());
    }

    //  Make sure to force the conversion to a primitive string.
    return this.toString();
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('chunkToWidth',
function(aWidth) {

    /**
     * @method chunkToWidth
     * @summary Returns an array containing the pieces of the receiver after
     *     splitting it into chunks no wider than aWidth. This is a more
     *     primitive method used by the splitToWidth method to break apart
     *     substrings without any whitespace.
     * @param {Number} aWidth The width to split the receiver chunks into.
     * @returns {String[]} The receiver split by the width provided.
     */

    var i,
        tmparr;

    tmparr = TP.ac();

    i = 0;
    while (i < this.getSize()) {
        tmparr.add(this.substr(i, aWidth));
        i += aWidth;
    }

    return tmparr;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('collapseWhitespace',
function() {

    /**
     * @method collapseWhitespace
     * @summary Returns the receiver with multiple occurrences of the space
     *     character condensed to a single occurrence in accordance with the XML
     *     Schema rules for whitespace collapse. If you also want to convert
     *     newlines and tabs to spaces, call replaceWhitespace() first. Note
     *     that leading and trailing spaces are also removed as a result of this
     *     call.
     * @returns {String} The receiver.
     */

    var res,
        re;

    res = this.replace(/\u0020\u0020/g, '\u0020');

    re = /\u0020\u0020/;
    while (re.test(res)) {
        res = res.replace(/\u0020\u0020/g, '\u0020');
    }

    res = res.trim();

    return res;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('compact',
function(aFilter) {

    /**
     * @method compact
     * @summary Returns a compact version of the receiver. In the case of
     *     string instances this is done by removing duplicate character
     *     sequences such as repeated spaces or tabs rather than by removing
     *     nulls as with other collection types.
     * @param {Selector} aFilter A Function, RegExp, or character (String) which
     *     defines which characters to compact.
     * @returns {String} A new string with the compaction done.
     */

    var filter,
        arr,
        last,
        wi,
        len,
        i,
        ch;

    //  optimize for character strings
    if (this.length < 2) {
        return this.toString();     //  watch out for moz
    }

    filter = aFilter || TP.regex.WHITESPACE;

    arr = this.split('');
    last = arr.at(0);

    wi = 1;
    len = arr.getSize();
    for (i = 1; i < len; i++) {
        ch = arr.at(i);

        //  two cases "work"...the char is not a dup of the last char, or it
        //  is a dup but that char isn't being compacted
        if (last !== ch) {
            arr[wi] = ch;
            last = ch;
            wi++;
        } else if (!filter.test(ch)) {
            arr[wi] = ch;
            last = ch;
            wi++;
        }
    }

    if (wi < len) {
        arr.length = wi;
    }

    return arr.join('');
});

//  ------------------------------------------------------------------------

//  ECMA E6 defines 'endsWith', so only install here if it doesn't exist.

if (!TP.isFunction(TP.StringProto.endsWith)) {
    String.Inst.defineMethod('endsWith',
    function(aSuffix, fromIndex) {

        /**
         * @method endsWith
         * @summary Returns true if the receiver ends with the suffix provided.
         * @param {String} aSuffix The string to check as a suffix.
         * @param {Number} [fromIndex] An optional position to start the search
         *     from.
         * @returns {Boolean} Whether or not the receiver ends with the
         *     supplied index.
         */

        var ind;

        if (TP.isEmpty(aSuffix)) {
            return false;
        }

        if ((ind = this.lastIndexOf(aSuffix, fromIndex)) === TP.NOT_FOUND) {
            return false;
        }

        /* eslint-disable no-extra-parens */
        return ind === (this.length - aSuffix.length);
        /* eslint-enable no-extra-parens */
    });
} else {
    //  Otherwise, just register the builtin.
    String.Inst.defineMethod('endsWith', TP.StringProto.endsWith); //   E6
}

//  ------------------------------------------------------------------------

String.Inst.defineMethod('escapeWhitespace',
function() {

    /**
     * @method escapeWhitespace
     * @summary Escapes any JavaScript constructs that have meaning to JS code
     *     like newlines, returns and tabs.
     * @returns {String} The string with its JS code constructs escaped.
     */

    var str;

    //  doubling escapes means we'll always have an even number in the
    //  string so they come back in properly when eval'd
    str = this.replace(/\\/g, '\\\\');

    //  convert anything that might give us an auto-semicolonoscopy ;)
    str = str.replace(/\n/g, '\\n');
    str = str.replace(/\r/g, '\\r');

    //  other common escapes should also be updated to their JS rep
    str = str.replace(/\t/g, '\\t');

    return str;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('getContent',
function() {

    /**
     * @method getContent
     * @summary Returns the receiver. This method is used in content processing
     *     to support polymorphic access to String data.
     * @returns {String}
     */

    //  Make sure to force the conversion to a primitive string.
    return this.toString();
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('getLocation',
function() {

    /**
     * @method getLocation
     * @summary Returns the receiver. This method is used to conform to the
     *     TP.uri.URI API.
     * @returns {String}
     */

    //  Make sure to force the conversion to a primitive string.
    return this.toString();
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('isSourceString',
function() {

    /**
     * @method isSourceString
     * @summary Returns true if the receiver can be thought of as a KeyValue
     *     string, meaning that it begins and ends with []s or {}s and contains
     *     at least one comma ([]) or colon ({}) and has room for at least 1
     *     character for a key and value. Due to bugs in IE with trailing commas
     *     as in [1,] we don't validate this.
     * @returns {Boolean}
     */

    if (this.getSize() < 5) {
        //  can't be a kvstring with no room for data
        return false;
    }

    if (this.first() === '{' && this.last() === '}') {
        return this.containsString(':');
    }

    if (this.first() === '[' && this.last() === ']') {
        return this.containsString(',');
    }

    return false;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('hasFragment',
function() {

    /**
     * @method hasFragment
     * @summary Returns true if the path contains a fragment reference. This is
     *     typically associated with anchors, barenames, or full XPointers.
     *     Provided for polymorphic API with TP.uri.URI.
     * @returns {Boolean}
     */

    return TP.regex.URI_FRAGMENT.test(this);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('multiReplace',
function(aHash) {

    /**
     * @method multiReplace
     * @summary Performs a 'multiple replace' on the receiver, with the
     *     supplied hash supplying the character sequences to look for and the
     *     replacements for those sequences as keys and values.
     * @description This method replaces the String found as each key in the
     *     supplied hash with the corresponding value found there.
     * @param {TP.core.Hash} aHash The replacements to perform on the receiver.
     * @returns {String} The receiver with any Strings found by matching each
     *     key in the supplied hash replaced by their corresponding value in the
     *     hash.
     */

    var str;

    //  Make sure to force the conversion to a primitive string.
    str = this.toString();

    TP.keys(aHash).perform(
        function(aKey) {
            str = str.replace(TP.rc(aKey, 'g'), aHash.at(aKey));
        });

    return str;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('overlayCharacters',
function(aSource, aChar) {

    /**
     * @method overlayCharacters
     * @summary Each char matching aChar (which defaults to @) in the
     *     receiver is replaced with a character from aSource as in:
     *
     *     "(@@@) @@@-@@@@".overlayCharacters(3035551212); ... (303) 555-1212
     * @param {Object} aSource The data source providing new characters.
     * @param {String} aChar The character to replace. Defaults to "@".
     * @returns {String} The receiver.
     * @abtract Replaces in a one-for-one fashion the characters in the receiver
     *     matching aChar with characters from aSource.
     */

    var ch,

        thePattern,

        counter,
        theMatcher,

        theSource,
        sourceSize,

        results;

    ch = TP.ifInvalid(aChar, '@');

    //  Make sure to force the conversion to a primitive string.
    thePattern = this.toString();

    counter = 0;
    theMatcher = TP.rc(ch + '{1}', 'g');

    if (!TP.canInvokeInterface(aSource, ['asString', 'getSize', 'at'])) {
        this.raise('TP.sig.InvalidOverlaySource', aSource);
        return this;
    }

    //  Get the string representation of aSource.
    theSource = aSource.asString();
    sourceSize = theSource.getSize();

    //  Loop over the pattern, looking for matching replacement characters
    //  If one is found, replace it with the character found in the source
    //  at counter.
    results = thePattern.replace(
                theMatcher,
                function(wholeMatch) {

                    var result;

                    result = theSource.at(counter);
                    counter++;

                    //  If counter is equal to the source's length, then
                    //  we've come to the end of the source's character
                    //  data, so wrap around.
                    if (counter === sourceSize) {
                        counter = 0;
                    }

                    return result;
                });

    return results;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('overlayFloat',
function(aSource) {

    /**
     * @method overlayFloat
     * @summary Formats a floating point number according to the template
     *     information in the receiver.
     * @param {Number} aSource A data source to format.
     * @exception TP.sig.InvalidNumericTemplate
     * @returns {String} A formatted number string.
     */

    var patParts,

        sourceInteger,

        fracPat,
        fracPatSize,
        sourceFraction,

        leftPart,
        rightPart;

    //  Split the pattern along the decimal point character always used in
    //  patterns ('.') and manage parts separately
    patParts = this.split('.');

    //  If there is more than one decimal point, then something is
    //  seriously wrong...
    if (patParts.getSize() > 2) {
        this.raise('TP.sig.InvalidNumericTemplate');
        return this;
    }

    if (!TP.canInvokeInterface(aSource, ['integer', 'round'])) {
        this.raise('TP.sig.InvalidOverlaySource', aSource);
        return this;
    }

    sourceInteger = aSource.integer();

    if (TP.notEmpty(fracPat = patParts.at(1))) {
        fracPatSize = fracPat.getSize();
    }

    //  found decimal point so treat each part individually
    if (patParts.getSize() === 2) {
        sourceFraction = aSource.round(fracPatSize).fraction(fracPatSize);

        //  If fracPat is empty, then the pattern had a decimal point, but no
        //  format on the right side. Therefore, no right hand digits will be
        //  displayed, but if the first right hand digit is greater than 4, then
        //  it will round the left part up...
        if (TP.isEmpty(fracPat)) {
            //  If the sourceFraction isn't zero, then it might be either
            //  .5 or 0.5, depending on the platform (.5 - Nav, 0.5 - IE)
            //  or greater, in which case we need to round up the
            //  sourceInteger. In any case, convert it to a String, split it
            //  and look at the first character in the second split segment
            //  as converted back to a Number. If it is greater than 4, then
            //  we have to round the sourceInteger up one.
            if (sourceFraction !== 0) {
                if (parseInt(
                    sourceFraction.asString().split('.').at(1).at(0),
                    10) > 4) {
                    sourceInteger++;
                }
            }

            //  In any case, there is no right hand part to the result.
            rightPart = '';
        } else {
            //  Otherwise, there were real formatting characters in the
            //  right hand side of the format.

            //  If the sourceFraction isn't zero, assign the formatted
            //  sourceFraction to the right hand part of the result. Note
            //  that the sourceFraction might either be '.x' or '0.x',
            //  depending on the platform (.x - Nav, 0.x - IE). Therefore,
            //  we need to convert it to aString, split it and format the
            //  result in the second split segment as converted back to a
            //  Number
            if (sourceFraction !== 0) {
                rightPart = fracPat.overlayInteger(
                            sourceFraction.asString().split('.').at(1),
                            TP.RIGHT);
            } else {
                //  Otherwise, just assign a formatted 0 to the right hand
                //  part of the result.
                rightPart = fracPat.overlayInteger(
                            0,
                            TP.RIGHT);
            }
        }

        leftPart = patParts.at(0).overlayInteger(
                                    sourceInteger,
                                    TP.LEFT);

        if (TP.isEmpty(leftPart) && TP.isEmpty(rightPart)) {
            return '';
        }

        if (sourceInteger.isNegative()) {
            leftPart = '-' + leftPart;
        }

        //  Put the two halves back together, using the decimal point
        //  character as determined by the Number type (which will use any
        //  locale information if it is loaded).
        return leftPart + Number.getDecimalPoint() + rightPart;
    }

    sourceFraction = aSource.fraction(1);

    //  If patParts has only 1 entry, then the pattern had no format on the
    //  right side. Therefore, no right hand digits will be displayed. But
    //  if the sourceFraction isn't zero, then it might be either .5 or
    //  0.5, depending on the platform (.5 - Nav, 0.5 - IE) or greater, in
    //  which case we need to round up the sourceInteger. In any case,
    //  convert it to a String, split it and look at the first character in
    //  the second split segment as converted back to a Number. If it is
    //  greater than 4, then we have to round the sourceInteger up one.
    if (sourceFraction !== 0) {
        if (parseInt(
            sourceFraction.asString().split('.').at(1).at(0),
            10) > 4) {
            sourceInteger++;
        }
    }

    //  In any case, return just formatting the sourceInteger

    if (sourceInteger.isNegative()) {
        return '-' + patParts.at(0).overlayInteger(sourceInteger, TP.LEFT);
    }

    return patParts.at(0).overlayInteger(sourceInteger, TP.LEFT);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('overlayInteger',
function(aSource, aSide) {

    /**
     * @method overlayInteger
     * @summary Formats an "integer" number (meaning a whole number), according
     *     to the format in the receiver. It has different rules depending on
     *     the 'side' of a possible overall 'real' number it is being formatted
     *     as a part of.
     * @description This method does *NOT* deal with negative numbers. All
     *     incoming sources are converted to Numbers and are then abs()ed. Users
     *     of this method must deal with marking up negative numbers in their
     *     own way.
     * @param {String} aSource The data source being formatted. Should be a
     *     String with a whole number.
     * @param {String} aSide The side of the decimal point the integer is on.
     *     This is useful for formatting floats in parts. This should be either
     *     TP.LEFT or TP.RIGHT.
     * @returns {String} A formatted number string.
     */

    var theSource,
        hasThousands,
        matcher,
        patStr,
        patStrLength,
        sourceStr,
        index,
        lastDigit,
        side,
        str;

    //  Quick exit - if we are empty, there is nothing to do.
    if (TP.isEmpty(this)) {
        return '';
    }

    //  Quick exit - If aSource is 0 and the format only has octothorp
    //  characters ('#'), then nothing is going to come out anyway, so just
    //  return the empty string here.
    String.$allHashMarker.lastIndex = 0;
    if (parseInt(aSource, 10) === 0 && String.$allHashMarker.test(this)) {
        return '';
    }

    side = TP.ifInvalid(aSide, TP.LEFT);

    hasThousands = false;

    /* eslint-disable consistent-this */
    patStr = this;
    /* eslint-enable consistent-this */
    patStrLength = patStr.getSize();

    //  If we're formatting a number so that it can go on the left-hand
    //  side of an overall larger real number...
    if (side === TP.LEFT) {
        //  NOTE: WE DO NOT DEAL WITH NEGATIVE NUMBERS HERE. THIS METHOD'S
        //  USERS MUST DEAL WITH NEGATIVITY IN THEIR OWN WAY!!!
        theSource = parseInt(aSource, 10).abs();
        if (!TP.canInvoke(theSource, 'toString')) {
            this.raise('TP.sig.InvalidOverlaySource', aSource);
            return this;
        }
        sourceStr = theSource.toString();   //  don't let it recurse by
                                            //  calling asString here!

        //  If thousands are specified, then strip them out of the pattern
        //  and set the hasThousands flag
        matcher = Number.getThousandsMatcher();
        matcher.lastIndex = 0;
        if (matcher.test(patStr)) {
            matcher.lastIndex = 0;
            patStr = patStr.strip(matcher);
            patStrLength = patStr.getSize();
            hasThousands = true;
        }

        //  If the source string and the pattern string have the same
        //  number of characters, or the source string has a greater number
        //  of characters than the pattern string, then there is no real
        //  formatting to do, except for thousands formatting, if
        //  necessary.
        if (sourceStr.getSize() >= patStrLength) {
            if (hasThousands) {
                return sourceStr.overlayThousands();
            }

            return sourceStr;
        }

        //  Otherwise, there are fewer characters in the source string than
        //  in the pattern string, so we just need to use the source string
        //  and then prepend the proper characters onto the front,
        //  depending on the format.

        //  If theSource isn't zero, then set the initial value of the
        //  result to the source's String representation and the index to
        //  begin filling in to the difference in length between the
        //  pattern and the result (minus 1).
        if (theSource !== 0) {
            str = sourceStr;
            index = patStrLength - str.getSize() - 1;
        } else {
            //  Otherwise, there is no content in the source's String
            //  representation to start with.
            str = '';
            index = patStrLength - 1;
        }

        //  Loop backwards along the pattern string. If the character is a
        //  octothorp ('#'), place nothing and move on. If the character is
        //  a zero, place a '0' and if its a question mark, place a ' '.
        for (; index >= 0; index--) {
            if (patStr.at(index) === '#') {
                continue;
            } else if (patStr.at(index) === '0') {
                str = '0' + str;
            } else if (patStr.at(index) === '?') {
                str = ' ' + str;
            }
        }

        //  Do thousands formatting, if necessary, and return the result.
        if (hasThousands) {
            return str.overlayThousands();
        }

        //  We're done - we can exit here.
        return str;
    }

    //  If we're formatting a number so that it can go on the right-hand
    //  side of an overall larger real number...
    if (side === TP.RIGHT) {
        theSource = parseInt(aSource, 10).abs();

        //  NB: We don't detect here whether we've been passed a negative
        //  number. This would be unusual in a TP.RIGHT hand side format
        //  anyway but it also has the bad side effect of converting '01'
        //  to '1' and, although that's ok for TP.LEFT hand side format,
        //  its not for TP.RIGHT.
        sourceStr = aSource.asString();

        //  Thousands aren't allowed on the right hand side of the decimal
        matcher = Number.getThousandsMatcher();
        matcher.lastIndex = 0;
        if (matcher.test(sourceStr)) {
            this.raise('TP.sig.InvalidNumericTemplate');

            return this;
        }

        //  If the source string and the pattern string have the same
        //  number of characters, then there is no real formatting to do.
        //  Return the source string.
        if (sourceStr.getSize() === patStrLength) {
            return sourceStr;
        }

        //  If the source string is larger than the pattern string then,
        //  because we're to the right of the decimal, we're going to chop
        //  it at the number of characters in the pattern string. Also, if
        //  the digit right after the chopping index is 5 or greater, we
        //  round up the last digit in the chopped value.
        if (sourceStr.getSize() > patStrLength) {
            str = sourceStr.slice(0, 0 - (patStrLength - 1));

            if (parseInt(sourceStr.at(patStrLength), 10) > 4) {
                lastDigit = parseInt(sourceStr.at(patStrLength - 1), 10);
                str = sourceStr.slice(0, patStrLength - 1);

                /* eslint-disable no-extra-parens */
                str += (lastDigit + 1);
                /* eslint-enable no-extra-parens */
            }

            return str;
        }

        //  Otherwise, there are fewer characters in the source string than
        //  in the pattern string, so we just need to use the source string
        //  and then prepend the proper characters onto the front,
        //  depending on the format.

        //  If theSource isn't zero, then set the initial value of the
        //  result to the source's String representation and the index to
        //  begin filling in to the source's String representation's
        //  length.
        if (theSource !== 0) {
            str = sourceStr;
            index = sourceStr.getSize();
        } else {
            //  Otherwise, there is no content in the source's String
            //  representation to start with.
            str = '';
            index = 0;
        }

        //  Loop forwards along the pattern string. If the character is a
        //  hash ('#'), place nothing and move on. If the character is a
        //  zero, place a '0' and if its a question mark, place a ' '.

        //  NOTE, the leading ; is not a bug, we set the index above
        for (; index < patStrLength; index++) {
            if (patStr.at(index) === '#') {
                continue;
            } else if (patStr.at(index) === '0') {
                str += '0';
            } else if (patStr.at(index) === '?') {
                str += ' ';
            }
        }

        return str;
    }

    return null;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('overlayThousands',
function() {

    /**
     * @method overlayThousands
     * @summary Replaces/inserts the properly localized "comma" from
     *     Number.getThousandsSeparator() in the proper locations based on
     *     Number.getThousandsGroupSize().
     * @returns {String} The modified string.
     */

    var groupSize,
        separator,

        str,

        start,
        index,

        indexOfSpace,
        matcher,
        spaceyChunk,
        nonSpaceyChunk;

    groupSize = Number.getThousandsGroupSize();
    separator = Number.getThousandsSeparator();

    str = '';

    //  Loop over the receiver, slicing it back from the end according to
    //  the group size and prepending the separator onto the front of it.
    start = this.getSize() - groupSize;
    for (index = start; index >= 0; index = index - groupSize) {
        str = separator + this.slice(index, index + groupSize) + str;
    }

    //  Prepend any remaining text that didn't fit the grouping size onto
    //  the front of the result.
    str = this.slice(0, index + groupSize) + str;

    //  If we find a space in the result, then we need to find the index of
    //  the last space, slice from the beginning to just beyond it, and
    //  replace any separators with spaces. This avoids problem formats
    //  like: ' ,  1,234.56'. Then rebuild the result string with the new
    //  front piece.
    indexOfSpace = str.lastIndexOf(' ');
    if (indexOfSpace !== TP.NOT_FOUND) {
        matcher = Number.getThousandsMatcher();
        matcher.lastIndex = 0;

        spaceyChunk = str.slice(0, indexOfSpace + 1);
        spaceyChunk = spaceyChunk.strip(matcher);
        nonSpaceyChunk = str.slice(indexOfSpace + 1);

        if (nonSpaceyChunk.indexOf(',') === 0) {
            nonSpaceyChunk = nonSpaceyChunk.slice(1);
        }

        str = spaceyChunk + nonSpaceyChunk;
    } else {
        //  If the receiver divides evenly into the groupSize, then there
        //  will be a extra separator on the front of the result. Slice it
        //  off.
        if (this.getSize() % groupSize === 0) {
            str = str.slice(1);
        }
    }

    return str;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('processTP_sig_Request',
function(aRequest) {

    /**
     * @method processTP_sig_Request
     * @summary Processes the receiver's content using the request to provide
     *     control parameters. If the string can be converted into a valid XML
     *     node that node is processed, otherwise the processing is performed
     *     via the substitute method.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request or hash
     *     containing control parameters.
     * @returns {TP.sig.Response} A response containing the processing results.
     */

    var doc,
        node,
        dataSource,
        keySource,

        request,
        result,
        response;

    request = TP.request(aRequest);

    //  if the string represents markup then we work from that perspective
    if (TP.isValid(doc = TP.dom.Node.from(this))) {
        node = doc.getDocumentElement();
        return TP.process(node, request);
    }

    if (TP.isValid(request)) {
        dataSource = request.at('dataSource');
        keySource = TP.ifKeyInvalid(request, 'keySource', null);
    }

    if (TP.isValid(dataSource)) {
        result = this.substitute(dataSource, keySource);
    } else {
        /* eslint-disable consistent-this */
        result = this;
        /* eslint-enable consistent-this */
    }

    response = request.getResponse(result);
    request.complete(result);

    return response;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('quoted',
function(aQuoteChar) {

    /**
     * @method quoted
     * @summary Returns the receiver as a quoted string with embedded quotes
     *     escaped. The default quote character is a single quote in keeping
     *     with TIBET coding standards which use single quoted strings for
     *     JavaScript and double quoted strings for *ML.
     * @param {String} aQuoteChar A quoting character to use. Default is "'"
     *     (single quote/apostrophe).
     * @returns {String} The string as a quoted string.
     */

    var quote,
        str;

    quote = aQuoteChar || '\'';

    //  presume if we're quoted we're already ok (and we're not a single
    //  character length)

    //  if we're quoted already (make sure to check we're not a 1 character
    //  String), we're already ok.
    if (this.first() === quote &&
        this.last() === quote &&
        this.length > 1) {
        //  Make sure to force the conversion to a primitive string.
        return this.toString();
    }

    //  Escape any JavaScript 'code constructs' (i.e. newlines, returns, tab
    //  characters, etc.)
    str = this.escapeWhitespace();

    //  now we can escape any quotes that are left and put on our outer
    //  quotation marks
    str = str.replace(TP.rc(quote, 'g'), '\\' + quote);

    return quote + str + quote;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('replaceBetweenDelimiters',
function(startDelim, endDelim, aFunction) {

    /**
     * @method replaceBetweenDelimiters
     * @summary This method finds chunks of text between two delimiters and
     *     runs the standard String 'replace()' function on each chunk, using
     *     the supplied Function as the replacement Function.
     * @param {RegExp} startDelim The RegExp to match the starting position of
     *     the chunk of text to be replaced.
     * @param {RegExp} endDelim The RegExp to match the ending position of the
     *     chunk of text to be replaced.
     * @param {Function} aFunction The Function to use to replace the text.
     * @returns {String} The entries processed for use in JavaScript Functions.
     */

    var startDelimStr,
        endDelimStr,

        fullRegExp,
        theString,

        endIndex,
        arr,
        lastLastIndex,
        results;

    //  Grab the start delimiter's RegExp, convert it to a standard String
    //  and slice off the '/'s on either end.
    startDelimStr = startDelim.toString();
    startDelimStr = startDelimStr.slice(1, startDelimStr.getSize() - 1);

    //  Grab the end delimiter's RegExp, convert it to a standard String
    //  and slice off the '/'s on either end.
    endDelimStr = endDelim.toString();
    endDelimStr = endDelimStr.slice(1, endDelimStr.getSize() - 1);

    //  Build a RegExp that uses the RegExp 'description strings' for the
    //  start and end delimiters that will ind a start delimiter and an end
    //  delimiter before any more start delimiters.
    fullRegExp = TP.rc(startDelimStr +
                                '(((.|\\n)(?!' + startDelimStr + '))+?)' +
                                endDelimStr,
                            'g');

    endIndex = 0;
    arr = TP.ac();
    lastLastIndex = 0;

    /* eslint-disable consistent-this */
    theString = this;
    /* eslint-enable consistent-this */

    //  While the results that get returned from processing theString
    //  continue to be valid, run the replacement function over the chunk
    //  of text that is found between the start and end delimiters.
    while (TP.isArray(results = fullRegExp.exec(theString))) {
        //  Set the ending index to be the index where a match was found.
        endIndex = results.index;

        //  Slice from the 'last' last index to the endIndex and append
        //  that to the result. This appends any text that was found
        //  between the last match and this match to the results.
        arr.push(theString.slice(lastLastIndex, endIndex));

        //  Grab the last index (that is, the first position of the match)
        //  and store it away.
        lastLastIndex = fullRegExp.lastIndex;

        //  Execute the replacement function supplying the result arguments
        //  at 0 and 1 (which will be the full match and the text between
        //  the delimiters, respectively) and append that to the result.
        arr.push(aFunction(results.at(0), results.at(1)));

        //  Restore the setting of the last index.
        fullRegExp.lastIndex = lastLastIndex;
    }

    //  Append whatever is left from the lastLastIndex to the end of the
    //  array
    arr.push(theString.slice(lastLastIndex));

    return arr.join('');
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('replaceWhitespace',
function(aString) {

    /**
     * @method replaceWhitespace
     * @summary Returns a copy of the string with all tabs (#x9), linefeeds
     *     (#xA), and carriage returns (#xD) replaced with spaces (#x20) per the
     *     XML Schema rules for whitespace replacement, or with aString if
     *     provided.
     * @param {String} aString The replacement string to use. This defaults to
     *     the space character (#x20).
     * @returns {String} A new string with the receiver's content after
     *     whitespace replacement.
     */

    var replacement;

    replacement = TP.ifInvalid(aString, '\u0020');

    /* eslint-disable no-control-regex */
    return this.replace(/[\u0009\u000A\u000D]/g, replacement);
    /* eslint-enable no-control-regex */
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('setDelimiter',
function(aString) {

    /**
     * @method setDelimiter
     * @summary Sets the string used to split() the receiver.
     * @param {String} aString The delimiter string. Defaults to '' to create
     *     character arrays.
     * @returns {String} The receiver.
     */

    var str;

    str = TP.ifInvalid(aString, '');

    if (this.$get('delimiter') !== str) {
        this.$set('delimiter', str);
    }

    //  Make sure to force the conversion to a primitive string.
    return this.toString();
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('sliceFrom',
function(delimiter, inclusive, last) {

    /**
     * @method sliceFrom
     * @summary Slices the receiver up to the character or string provided.
     * @param {String} delimiter The string to slice to.
     * @param {Boolean} inclusive True to include the delimiter in the returned
     *     string.
     * @param {Boolean} last True if the delimiter should be the last occurrence
     *     in the receiver.
     * @returns {String} The sliced content.
     */

    var str,
        ind,
        len;

    str = this.toString();

    ind = last === true ?
            this.lastIndexOf(delimiter) :
            this.indexOf(delimiter);

    if (ind === TP.NOT_FOUND) {
        return str;
    }
    len = delimiter.getSize();

    /* eslint-disable no-extra-parens */
    return (inclusive === true) ? str.slice(ind) : str.slice(ind + len);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('sliceTo',
function(delimiter, inclusive, last) {

    /**
     * @method sliceTo
     * @summary Slices the receiver up to the character or string provided.
     * @param {String} delimiter The string to slice to.
     * @param {Boolean} inclusive True to include the delimiter in the returned
     *     string.
     * @param {Boolean} last True if the delimiter should be the last occurrence
     *     in the receiver.
     * @returns {String} The sliced content.
     */

    var str,
        ind;

    str = this.toString();

    ind = last === true ?
            this.lastIndexOf(delimiter) :
            this.indexOf(delimiter);

    if (ind === TP.NOT_FOUND) {
        return str;
    }

    return str.slice(0, ind) + (inclusive === true) ? delimiter : '';
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('splitAtIndex',
function(index) {

    /**
     * @method splitAtIndex
     * @summary Returns an array containing the pieces of the receiver after
     *     splitting it at the index provided. The character at the specified
     *     index is placed in the second segment.
     * @param {Number} index The index to split the receiver at.
     * @exception TP.sig.InvalidIndex
     * @returns {String} The receiver split at the index provided.
     */

    var tmparr;

    tmparr = TP.ac();
    tmparr.add(this.slice(0, index));
    tmparr.add(this.slice(index));

    return tmparr;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('splitToWidth',
function(aWidth, justified, forRendering, joinChar, splitMark) {

    /**
     * @method splitToWidth
     * @summary Takes a string and splits it into an array whose contents are
     *     the longest substrings possible. The break is done using whitespace
     *     whenever possible, but can also force a break in long strings so they
     *     won't cause horizontal scrolling. The resulting array is then joined
     *     using the character provided in the 'joinChar' parameter.
     * @param {Number} aWidth The width to fit the string to.
     * @param {Boolean} justified Should output formatting try to fill text
     *     blocks in justified form, or leave a ragged right edge?
     * @param {Boolean} forRendering True if the string is intended for
     *     rendering and is likely to contain markup content to work around.
     * @param {String} joinChar The character to use to join the split array
     *     elements.
     * @param {String} splitMark The string to use for replacement of content
     *     during processing. The default is ##MARK## which shouldn't be found
     *     in most content. But on the off chance you have data that might use
     *     that you can change it here.
     * @returns {String} The split/joined string result.
     */

    var i,
        j,
        ch,
        it,
        len,
        str,
        arr,
        arr1,
        arr2,
        size,
        mark,
        width,
        resarr,
        tmparr,

        restr,
        sizer;

    width = TP.ifInvalid(aWidth, 80);

    if (this.getSize() <= width) {
        return this;
    }

    //  set a string we can use to help with format breaks. note that we
    //  allow this to be altered via parameter just in case
    mark = TP.ifInvalid(splitMark, '##MARK##');

    //  we default to newline and expect that any newlines will be converted
    //  to br's as needed based on the rendering requirements
    ch = TP.ifInvalid(joinChar, '\n');

    //  we'll do the easy case first. when we're not planning on rendering
    //  the output (at least not without escaping it) we can rely on the
    //  length we see in the string and work directly with it
    if (TP.notTrue(forRendering)) {
        //  RegExp based split
        restr = '((.){0,' + width + '}[ \\t\\n]|(.){' + width + '})';
        sizer = TP.rc(restr, 'g');

        return this.replace(sizer, '$1' + ch);
    }

    //  next case is where we have to deal with markup. the first question
    //  is whether the markup is quoted or not. if it is, we have to leave
    //  it alone, but if not we want to leverage breaks as newlines and
    //  split on them to get things started

    if (TP.isTrue(forRendering)) {
        tmparr = TP.ac();
        if (/"([^"])*<br([^"])*"/.test(this) ||
            /'([^'])*<br([^'])*'/.test(this)) {
            //  quoted, so we'll need to ignore it
            tmparr.add(this);
        } else if (/<br.?>/.test(this)) {
            //  split lines with embedded, non-quoted br's
            tmparr.add(this.split(/<br.?>/));
        } else {
            tmparr.add(this);
        }
    }

    //  at this point we have an array whose elements have been split if
    //  they had unquoted br's in them, but otherwise they're untouched...
    if (TP.isTrue(forRendering)) {
        for (i = 0; i < tmparr.length; i++) {
            //  need to work around the fact that the markup itself will
            //  throw off our length computations if we don't find a way to
            //  ignore it
            str = tmparr[i].replace(/</g, mark + '<');
            str = str.replace(/>/g, '>' + mark);
            arr = str.split(mark);

            //  odd chunks are non-markup content. this breaks apart any
            //  of them which are individually too long for the width
            for (j = 0; j < arr.length; j += 2) {
                if (TP.notEmpty(arr.at(j))) {
                    arr1 = arr.at(j).splitToWidth(width, false,
                                                    false, mark);
                    arr2 = arr1.split(mark);
                    arr.atPut(j, arr2);
                }
            }

            //  flatten out any embedded arrays so we can do final iteration
            arr = arr.flatten();

            //  odd chunks now have to be added using 'non-rendering' rules
            //  get our result array ready to accept the chunks
            resarr = TP.ac();
            resarr[0] = '';

            len = 0;
            for (j = 0; j < arr.length; j++) {
                it = arr.at(j);
                if (TP.notEmpty(it)) {
                    if (it.first() === '<' && it.last() === '>') {
                        resarr[resarr.length - 1] += it;
                    } else {

                        size = it.replace(/&.+?;/g, ' ').getSize();

                        if (len + size <= width) {

                            len += size;
                            resarr[resarr.length - 1] += it;

                        } else {

                            len = size;
                            resarr.push(it);

                        }
                    }
                }
            }

            tmparr[i] = resarr.join(ch);
            // tmparr[i] = arr.join('');
        }

        return tmparr.join(ch);
    }
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('stripComments',
function(stripSingle, stripMulti) {

    /**
     * @method stripComments
     * @summary Returns a copy of the string with all comments stripped.
     * @param {Boolean} stripSingle Should we strip single-line comments?
     *     Default is true.
     * @param {Boolean} stripMulti Should we strip multi-line comments? Default
     *     is true.
     * @returns {String}
     */

    var src,
        len,
        last,
        arr,
        inApos,
        inQuote,
        inSingle,
        inMulti,
        offset,
        ch,
        j,
        i,
        strCnt;

    src = this.toString();
    len = src.length;
    offset = 1;

    arr = TP.ac();

    last = '';
    inApos = false;
    inQuote = false;
    inSingle = false;
    inMulti = false;

    for (i = 0; i < len; i += offset) {
        ch = src.charAt(i);
        offset = 1;

        //  first question, are we currently in a comment?
        if (inSingle) {
            if (ch === '\n') {
                //  end char for the comment,
                inSingle = false;

                //  if the comment was the only thing on the line this will
                //  end up creating an empty line, but we'll put up with
                //  that for now.
                arr.push(ch);
            }

            last = ch;
            if (stripSingle === false) {
                arr.push(ch);
            }
            continue;
        } else if (inMulti) {
            //  end will be '*' + '/'
            if (last === '*' && ch === '/') {
                inMulti = false;
            }

            last = ch;
            if (stripMulti === false) {
                arr.push(ch);
            }
            continue;
        }

        //  we're not in comment so process the character for quotes etc.
        switch (ch) {
            //  might be starting/ending a string
            case '\'':

                if (inApos) {
                    if (last !== '\\') {
                        //  ending our apos string
                        inApos = false;
                    } else {
                        //  have to figure out how many leading \'s
                        //  we have. if it's an odd number we're escaped
                        j = i - 1;
                        strCnt = 0;
                        while (src.charAt(j) === '\\') {
                            strCnt++;
                            j--;
                        }

                        //  even? we're _NOT_ escaped
                        if (strCnt % 2 === 0) {
                            inApos = false;
                        }
                    }
                } else if (!inQuote && last !== '\\') {
                    //  starting an apos string
                    inApos = true;
                }

                arr.push(ch);
                break;

            //  might be starting/ending a string
            case '"':

                if (inQuote) {
                    if (last !== '\\') {
                        //  ending our string
                        inQuote = false;
                    } else {
                        //  have to figure out how many leading \'s
                        //  we have. if it's an odd number we're escaped
                        j = i - 1;
                        strCnt = 0;
                        while (src.charAt(j) === '\\') {
                            strCnt++;
                            j--;
                        }

                        //  even? we're _NOT_ escaped
                        if (strCnt % 2 === 0) {
                            inQuote = false;
                        }
                    }
                } else if (!inApos && last !== '\\') {
                    //  starting a quote string
                    inQuote = true;
                }

                arr.push(ch);
                break;

            case '/':

                //  special cases here... '/' + '/',
                //      and '/' + '*' or '*' + '/'
                //  but the last case '*' + '/' will
                //  be caught by inMulti test above

                //  if in quotes just output it
                if (inApos || inQuote) {
                    arr.push(ch);
                    break;
                }

                //  not quoted, might be single-line comment
                if (last === '/') {
                    inSingle = true;
                    last = ch;
                    break;
                }

                //  not quoted, could be lead-in to a comment
                if (src.charAt(i + 1) === '*' ||
                    src.charAt(i + 1) === '/') {
                    //  the regex /\//g inspired this check
                    if (src.charAt(i - 1) === '\\') {
                        //  we're escaped, not a comment lead-in
                        last = null;
                    } else if (stripMulti !== false &&
                                src.charAt(i + 1) === '*') {
                        //  multi-line comment lead in...capture it and
                        //  don't push to result
                        last = ch;
                        break;
                    } else if (stripSingle !== false &&
                                src.charAt(i + 1) === '/') {
                        //  single-line comment lead in...capture it and
                        //  don't push to result
                        last = ch;
                        break;
                    }
                }

                //  just a slash
                arr.push(ch);
                break;

            case '*':

                //  two special cases here... '/' + '*' and '*' + '/'
                //  but latter one is caught by inMulti test above

                //  if in quotes just output it
                if (inApos || inQuote) {
                    last = ch;
                    arr.push(ch);
                    break;
                }

                //  start of a multi-line comment
                if (last === '/') {
                    inMulti = true;
                    last = ch;
                    break;
                }

                //  just a '*'
                arr.push(ch);
                break;

            default:

                arr.push(ch);
                break;
        }

        //  keep track of what we processed last
        last = ch;
    }

    return arr.join('');
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('stripEnclosingQuotes',
function() {

    /**
     * @method stripEnclosingQuotes
     * @summary Strips enclosing quotes that are at the beginning and end of
     *     the receiver (they must be balanced quotes of the same type).
     * @returns {String} A new string with the contents of the receiver stripped
     *     of leading and trailing quotes.
     */

    return this.replace(TP.regex.QUOTED_CONTENT, '$2');
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('stripExternalBodyContent',
function() {

    /**
     * @method stripExternalBodyContent
     * @summary Returns a copy of the string with all 'external body content'
     *     (that is, img content) removed. This is part of 'sanitizing' inbound
     *     (X)HTML data.
     * @returns {String} A new string with the receiver's content but no
     *     embedded img tags.
     */

    var str;

    str = this.toString();

    TP.regex.HTML_IMG_ELEM.lastIndex = 0;
    str = str.strip(TP.regex.HTML_IMG_ELEM);

    return str;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('stripExternalHeadContent',
function() {

    /**
     * @method stripExternalHeadContent
     * @summary Returns a copy of the string with all 'external head content'
     *     (that is, script, link to stylesheets and style content) removed.
     *     This is part of 'sanitizing' inbound (X)HTML data.
     * @returns {String} A new string with the receiver's content but no
     *     embedded script, link or style tags.
     */

    var str;

    str = this.toString();

    TP.regex.HTML_SCRIPT_ELEM.lastIndex = 0;
    str = str.strip(TP.regex.HTML_SCRIPT_ELEM);

    TP.regex.HTML_CSS_LINK_ELEM.lastIndex = 0;
    str = str.strip(TP.regex.HTML_CSS_LINK_ELEM);

    TP.regex.HTML_CSS_STYLE_ELEM.lastIndex = 0;
    str = str.strip(TP.regex.HTML_CSS_STYLE_ELEM);

    return str;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('stripTags',
function() {

    /**
     * @method stripTags
     * @summary Returns a copy of the string with all tags (<blah>) stripped.
     * @returns {String} A new string with the receiver's content but no
     *     embedded tags.
     */

    return this.strip(/<\/?[^>]+>/gi);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('stripWhitespace',
function() {

    /**
     * @method stripWhitespace
     * @summary Returns a copy of the string with all whitespace stripped.
     * @returns {String} A new string with the receiver's content but no
     *     whitespace.
     */

    //  interesting thing...our RegExp patch broke this call in IE so we
    //  had to patch our patch.
    return this.strip(/\s/g);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('substitute',
function(aDataSource, aKeySource, aScope) {

    /**
     * @method substitute
     * @summary Formats aDataSource according to the template in the receiver.
     * @description Strings support a substitution operation via substitutions
     *     registered on the type. This method is the 'top-level' method
     *     supporting this operation. The built-in substitution operations
     *     supplied with this type support a "formatting" operation via
     *     substitute that allows strings of the form:
     *
     *     "aSymbol{substitutedContent}"
     *
     *     to act as format strings. The symbol defines which string
     *     substitution code should be used (see registerSubstitution()). The
     *     substitute method takes a TP.core.Hash for aDataSource and aKeySource
     *     unless the data source is atomic.
     * @param {TP.core.Hash} aDataSource An object or hash to be used for data.
     * @param {TP.core.Hash} aKeySource An object or hash to be used for
     *     resolving % {} entity keys. The values in the key hash can be simple
     *     objects which return a value or functions which operate on the
     *     corresponding data source value and return an appropriate value.
     * @param {Object} aScope The object to be used for the context of
     *     evaluating embedded JS expressions.
     * @returns {String} A formatted string.
     */

    var str,
        theDataSource,
        theKeySource,
        results;

    //  exit hatch -- no more substitution entities
    if (TP.notValid(String.$subsRe) || !String.$subsRe.test(this)) {
        return this.toString();
    }

    theDataSource = TP.ifInvalid(aDataSource, '');
    theKeySource = aKeySource;
    if (TP.notValid(theKeySource)) {
        theKeySource = TP.hc();
    }

    str = this.toString();

    //  If there are patterns matching the existence patterns for any other
    //  registered substitutions in the system, process them.
    if (TP.isRegExp(String.$subsRe)) {
        while (TP.isArray(results = str.match(String.$subsRe))) {
            str = str.substituteFor(
                        results[1],
                        theDataSource,
                        theKeySource,
                        aScope);
        }
    }

    //  recurse until exit hatch triggers (values which were substituted in
    //  the result string might themselves have expressions which need to
    //  be processed)
    return str.substitute(aDataSource, aKeySource, aScope);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('substituteFor',
function(aSymbol, aDataSource, aKeySource, aScope) {

    /**
     * @method substituteFor
     * @summary Substitutes for a single string substitution symbol.
     * @description This method handles processing for a single string
     *     substitution symbol. The substitute call passes control to this
     *     method to process each of the symbols found in the registration hash.
     * @param {String} aSymbol The symbol used to locate a substitution
     *     registration.
     * @param {TP.api.Collection} aDataSource The data source(s) being
     *     formatted.
     * @param {TP.core.Hash} aKeySource The hash for keyed formatters.
     * @param {Object} aScope The object to be used for the context of
     *     evaluating embedded JS expressions.
     * @returns {String} A formatted string.
     */

    var str,

        data,
        keys,

        thePattern,
        arr,
        counter,

        matchResult,

        sourceIndex;

    //  Attempt to retrieve a registered substitution for the symbol
    //  supplied.
    str = this.getType().getSubstitution(aSymbol);
    if (TP.notValid(str)) {
        return this;
    }

    data = TP.ifInvalid(aDataSource, '');
    keys = aKeySource;
    if (TP.notValid(keys)) {
        keys = TP.hc();
    }

    /* eslint-disable consistent-this */
    thePattern = this;
    /* eslint-enable consistent-this */

    arr = TP.ac();
    counter = 0;

    //  While the execution of the substitution's 'matcher' still finds
    //  expressions that it can process
    while (TP.isArray(matchResult = str.at('matcher').exec(thePattern))) {
        arr.push(RegExp.leftContext);

        //  Must capture this before we call any handlers in case they use
        //  RegExps too.
        thePattern = RegExp.rightContext;

        //  If aDataSource is an Array, then use the value at 'sourceIndex'
        //  in the Array as the data to the substitution's 'handler'
        //  function. Note how the sourceIndex's computation causes the
        //  index to 'wrap around' if there are more pattern expressions
        //  than there are data source values.
        if (TP.isArray(data)) {

            /* eslint-disable no-extra-parens */
            sourceIndex = counter - ((counter / data.getSize()).
                                                            integer() *
                                    data.getSize());
            /* eslint-enable no-extra-parens */

            //  Call the substitution's handler with the pattern expression
            //  found and the data at the sourceIndex in aDataSource.
            arr.push(str.at('handler')(matchResult.first(),
                                        data.at(sourceIndex),
                                        keys,
                                        aScope));
            counter++;
        } else {
            //  Call the substitution's handler with the pattern expression
            //  found and the data in aDataSource.
            arr.push(str.at('handler')(matchResult.first(),
                                        data,
                                        keys,
                                        aScope));
        }
    }

    //  Concat anything left in thePattern that did not match the
    //  substitution's 'matcher' onto the result String.
    arr.push(thePattern);

    return arr.join('');
});

//  ------------------------------------------------------------------------

//  Register a substitution for simple character substitution patterns.
//  Simple substitution patterns perform a character by character
//  substitution operation.

//  '@{@@@-@@@@}'.substitute('5551212');

String.registerSubstitution(
        '@{', '@\\{', '@', TP.rc('@\\{(.+?)\\}'),
function(anItem, aDataSource, aKeySource) {

    var theItem;

    //  Slice out the actual pattern from the enclosing '@{' and '}'
    theItem = anItem.slice(2, anItem.getSize() - 1);

    //  this is the transformation function for simple alpha substitution
    return theItem.overlayCharacters(aDataSource, '@');
});

//  ------------------------------------------------------------------------

//  Register a substitution for keyed patterns. Keyed patterns allow a value
//  or function to be associated with a particular key in the pattern:

//  No data source; object value for key
//  '%{aKey}'.substitute(null, TP.hc('aKey', '32'));

//  No data source; function value for key
//  '%{aKey}'.substitute(null, TP.hc('aKey', function () {return 'hi there'}));

//  Data source; function value for key (data value is passed into function)
//  '%{aKey}'.substitute('Bill',
//      TP.hc('aKey', function (item) {return 'Hi. My name is: ' + item}));

String.registerSubstitution(
        '%{', '%\\{', '%', TP.rc('%\\{(.+?)\\}'),
function(anItem, aDataSource, aKeySource) {

    var theItem,
        theHandler;

    //  Slice out the actual key from the enclosing '%{' and '}'
    theItem = anItem.slice(2, anItem.getSize() - 1);

    theHandler = TP.val(aKeySource, theItem);
    if (TP.notValid(theHandler)) {
        //  might be a bogus format where no key source or no key
        TP.ifWarn() ?
            TP.warn('Format handler not found for: ' + anItem) : 0;

        return aDataSource;
    }

    //  notice the call to getValue() here to allow either functions or
    //  other types to be a part of the map
    return theHandler.getValue(aDataSource);
});

//  ------------------------------------------------------------------------

/*
    Register a substitution for numeric patterns. Numeric patterns have
    special characters that they use to format numbers in certain ways. Note
    that the decimal point in the pattern plays a crucial role in how these
    special characters behave. Note also that the actual character used for
    for the decimal point in the result from a substitution is determined by
    the Number type, which uses locale information if it is loaded.

    The '#' character:

        If the pattern has exactly the same number of '#' characters as the
        source number has digits, the number is formatted appropriately:
            '#{###.##}'.substitute(123.45)      --      123.45

        If the pattern has fewer '#' characters to the right of the decimal
        point than the source number has digits, the source number is
        rounded to fit the pattern:
            '#{###.##}'.substitute(123.456)     --      123.46

        If the pattern has fewer '#' characters to the left of the decimal
        point than the source number has digits, the extra digits from the
        source number are placed anyway:
            '#{###.##}'.substitute(9123.45)     --      9123.45

        If the pattern has '#' characters to the right of the decimal and
        the source number has no digits to the right of the decimal, the
        decimal point is still displayed:
            '#{###.##}'.substitute(123)         --      123.

        If the pattern has '#' characters to the right of the decimal and
        the source number has a decimal point or a decimal point followed
        by a zero, only the decimal point is still displayed:
            '#{###.##}'.substitute(123.)        --      123.
            '#{###.##}'.substitute(123.0)       --      123.

        If the pattern has '#' characters to the left of the decimal and
        the source number has no digits to the left of the decimal other
        than '0', no digits are displayed to the right of decimal:
            '#{###.##}'.substitute(.45)         --      .45
            '#{###.##}'.substitute(0.45)        --      .45

        If the pattern has no '#' characters to the right of the decimal
        and the source number has digits to the right of the decimal and
        the first digit is 5 or greater, the number to the left of the
        decimal will be rounded up by 1:
            '#{###}'.substitute(123.55)         --      124

    The '0' character:

        This character follows the same rules as the '#' character in some
        cases:
            '#{000.00}'.substitute(123.45)      --      123.45
            '#{000.00}'.substitute(123.456)     --      123.46
            '#{000.00}'.substitute(9123.45)     --      9123.45

        except that if the source number has fewer digits than the pattern
        (either to the right or the left of the decimal place), then a '0'
        is placed in that spot:
            '#{000.00}'.substitute(123)         --      123.00
            '#{000.00}'.substitute(123.4)       --      123.40
            '#{000.00}'.substitute(.45)         --      000.45
            '#{000.00}'.substitute(0.45)        --      000.45
            '#{000.00}'.substitute(12.34)       --      012.34

    The '?' character:

        This character follows the same rules as the '0' character, except
        that a space will be placed instead of a '0' when the source number
        has fewer digits than the pattern (either to the right or the left
        of the decimal place) (here, a space is denoted by an underscore
        '_'):
            '#{???.??}'.substitute(123)         --      123.__
            '#{???.??}'.substitute(123.4)       --      123.4_
            '#{???.??}'.substitute(.45)         --      ___.45
            '#{???.??}'.substitute(0.45)        --      ___.45
            '#{???.??}'.substitute(12.34)       --      _12.34

        Note that using this character in patterns can sometimes produce a
        result that cannot be converted back into a number:
            '#{???.?0}'.substitute(123)         --      123._0

    The ',' character:

        This character is unique in that it acts as a 'toggle' to switch on
        thousands grouping'. Therefore, the mere presence of this character
        anywhere in the format 'switches on' thousands grouping. Note that
        the actual character used for the thousands separator and the
        grouping sizes are determined by the Number type, which uses locale
        information if it is loaded:
            '#{#,###.##}'.substitute(9123.45)   --      9,123.45
            '#{###,#.##}'.substitute(9123.45)   --      9,123.45

    Here is one last example that shows a commonly used format and that is
    for U.S. currency:
            '$#{#,###.00}'.substitute(89123.4)  --      $89,123.40
*/

//  ------------------------------------------------------------------------

String.registerSubstitution(
        '#{', '#\\{', '#', TP.rc('#\\{(.+?)\\}'),
function(anItem, aDataSource, aKeySource) {

    var theItem;

    //  Slice out the actual pattern from the enclosing '#{' and '}'
    theItem = anItem.slice(2, anItem.getSize() - 1);

    return theItem.overlayFloat(aDataSource);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('tabsToSpaces',
function(spaceCount) {

    /**
     * @method tabsToSpaces
     * @summary Returns a new string with any tab characters of the receiver
     *     converted to 'spaceCount' number of spaces. The default count is 4
     *     spaces per tab.
     * @param {Number} spaceCount A number of spaces per tab. Defaults to 4.
     * @returns {String} A string having the contents of the receiver with
     *     leading and trailing whitespace removed.
     */

    var repStr,
        count;

    count = TP.ifInvalid(spaceCount, 4);

    repStr = ' '.times(count);

    return this.replace(/\t/g, repStr);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('tokenizeWhitespace',
function() {

    /**
     * @method tokenizeWhitespace
     * @summary Returns the receiver with whitespace trimmed from each end, all
     *     non-space whitespace converted to spaces, and all sets of multiple
     *     spaces collapsed to a single space. This matches the requirements of
     *     XML Schema for types other than xs:string and xs:normalizedString.
     * @returns {String} A new string representing the receiver in converted
     *     form.
     */

    return this.replaceWhitespace().collapseWhitespace();
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('trimLeft',
function(aChar) {

    /**
     * @method trimLeft
     * @summary Returns a new string with the contents of the receiver after
     *     having stripped of any characters up to and including the character
     *     provided.
     * @param {String} aChar The char to trim to.
     * @returns {String} A string.
     */

    var startx;

    startx = 0;
    if (this.indexOf(aChar) !== TP.NOT_FOUND) {
        startx = this.indexOf(aChar) + 1;
    }

    return this.slice(startx);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('trimRight',
function(aChar) {

    /**
     * @method trimRight
     * @summary Returns a new string with the contents of the receiver after
     *     having stripped of any characters trailing the last occurrence of
     *     aChar.
     * @param {String} aChar The character to trim behind.
     * @returns {String} A string.
     */

    var endx;

    endx = this.getSize();
    if (this.lastIndexOf(aChar) !== TP.NOT_FOUND) {
        endx = this.lastIndexOf(aChar);
    }

    return this.slice(0, endx);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('truncate',
function(aSize, aTail) {

    /**
     * @method truncate
     * @summary Returns a new string shortened to the size specified and ending
     *     in the tail provided. If the string didn't have to be shortened it is
     *     returned directly without the tail.
     * @param {Number} aSize The size of the returned String including the
     *     length of the tail. Defaults to TP.DEFAULT_STRLEN.
     * @param {String} aTail A trailing set of characters to use to "finish" the
     *     string. Default is '...' (ellipsis).
     * @exception TP.sig.InvalidParameter
     * @returns {String} The receiver shortened to aSize with a possible
     *     ellipsis.
     */

    var tail;

    tail = TP.ifInvalid(aTail, '...');

    if (this.getSize() <= aSize) {
        //  Make sure to force the conversion to a primitive string.
        return this.toString();
    }

    return this.substr(0, aSize - tail.getSize()) + tail;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('unicodeEscaped',
function() {

    /**
     * @method unicodeEscaped
     * @summary Returns a new string with the contents of the receiver
     *     converted to escaped unicode.
     * @returns {String} A string having the contents of the receiver converted
     *     to escaped unicode.
     */

    var i,
        len,
        arr;

    arr = TP.ac();

    len = this.getSize();
    for (i = 0; i < len; i++) {
        arr.push(
            '\\u',
            this.charCodeAt(i).asHex().split('x').last().pad(4, '0'));
    }

    return arr.join('');
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('unquoted',
function(aQuoteChar) {

    /**
     * @method unquoted
     * @summary Returns the receiver with any enclosing quotes removed. Note
     *     that embedded quotes are unescaped by this process. This operation
     *     works on both single and double-quoted strings.
     * @param {String} aQuoteChar A quoting character to use. If not provided
     *     then any enclosing quotes are removed regardless of symbol.
     * @returns {String} The string as an unquoted string.
     */

    var len,
        str,
        re;

    if (TP.notEmpty(aQuoteChar)) {
        len = aQuoteChar.length;
        if (this.first(len) === aQuoteChar &&
            this.last(len) === aQuoteChar) {
            str = this.slice(len, this.getSize() - len);
            re = TP.rc('\\' + aQuoteChar, 'g');

            return str.replace(re, aQuoteChar);
        }

        return this.toString();
    }

    if (this.first() === '"' && this.last() === '"') {
        str = this.slice(1, this.getSize() - 1);

        return str.replace(/\\"/g, '"');
    }

    if (this.first() === '\'' && this.last() === '\'') {
        str = this.slice(1, this.getSize() - 1);

        return str.replace(/\\'/g, '\'');
    }

    //  Make sure to force the conversion to a primitive string.
    return this.toString();
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETCollections.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

//  ------------------------------------------------------------------------
//  TP.api.Collection API
//  ------------------------------------------------------------------------

/**
 * @type {TP.api.Collection}
 * @summary The TP.api.Collection API, which defines the core methods we
 *     consider appropriate for a rich set of collections.
 */

//  ------------------------------------------------------------------------

TP.api.Collection =
    TP.ac(
        'add',
        'addAll',
        'addAllIfAbsent',
        'addIfAbsent',
        'addItem',
        'addWithCount',
        'asArray',
        'asHash',
        'asIterator',
        'asRange',
        'asString',
        'collapse',
        'collect',
        'collectGet',
        'collectInvoke',
        'compact',
        'conform',
        'contains',
        'containsAll',
        'containsAny',
        'containsString',
        'convert',
        'countOf',
        'detect',
        'detectInvoke',
        'detectMax',
        'detectMin',
        'difference',
        'disjunction',
        'empty',
        'flatten',
        'getItems',
        'getIterator',
        'getIteratorType',
        'getSize',
        'getValues',
        'grep',
        'groupBy',
        'injectInto',
        'intersection',
        'isSortedCollection',
        'merge',
        'partition',
        'perform',
        'performInvoke',
        'performSet',
        'performUntil',
        'performWhile',
        'performWith',
        'reject',
        'remove',
        'removeAll',
        'replace',
        'replaceAll',
        'select',
        'union',
        'unique'
    );

//  ------------------------------------------------------------------------
//  TP.api.IndexedCollection API
//  ------------------------------------------------------------------------

/**
 * @type {TP.api.IndexedCollection}
 * @summary The TP.api.IndexedCollection API, which adds support for accessing
 *     elements of a collection by index and for working with the indexes
 *     themselves.
 */

//  ------------------------------------------------------------------------

TP.api.IndexedCollection =
    TP.ac(
        'addAt',
        'addAllAt',
        'at',
        'atAll',
        'atAllPut',
        'atIfInvalid',
        'atIfNull',
        'atIfUndefined',
        'atPut',
        'atPutIfAbsent',
        'containsKey',
        'containsValue',
        'detectKeyAt',
        'getKeys',
        'getKeysForValue',
        'getKVPairs',
        'getPosition',
        'getPositions',
        'grepKeys',
        'pad',
        'performOver',
        'removeAt',
        'removeAtAll',
        'removeKey',
        'removeKeys',
        'transpose'
    );

//  ------------------------------------------------------------------------
//  TP.api.OrderedCollection API
//  ------------------------------------------------------------------------

/**
 * @type {TP.api.OrderedCollection}
 * @summary The TP.api.OrderedCollection API, which adds methods which deal
 *     with ordered element access.
 */

//  ------------------------------------------------------------------------

TP.api.OrderedCollection =
    TP.ac(
        'addAfter',
        'addAllAfter',
        'addAllBefore',
        'addAllFirst',
        'addAllLast',
        'addBefore',
        'addFirst',
        'addLast',
        'after',
        'before',
        'first',
        'getLastPosition',
        'last',
        'orderedBy',
        'removeFirst',
        'removeLast',
        'replaceFirst',
        'replaceLast',
        'reverse'
    );

//  ------------------------------------------------------------------------
//  TP.api.OrderedPair API
//  ------------------------------------------------------------------------

/**
 * @type {TP.api.OrderedPair}
 * @summary The API required of objects which act as ordered pairs.
 * @description TP.api.OrderedPair API is an interface which can be implemented
 *     by any object which may be used to hold key/value pairs. Objects in the
 *     core which implement this API include Array, Object, and TP.core.Hash.
 */

//  ------------------------------------------------------------------------

TP.api.OrderedPair =
    TP.ac(

        /**
         * @method getPair
         * @summary Returns an array containing the key and value of the
         *     receiver.
         * @description This method expects the receiver to have only a single
         *     key/value pair. Objects can be used as ordered pairs as in:
         *
         *     {'a':1}
         *
         *     but it it MUCH more efficient to use Arrays instead. This method
         *     is here primarily for flexibility and polymorphism.
         * @exception TP.sig.InvalidPairRequest
         * @returns {TP.api.OrderedPair} The key/value pair.
         */

        'getPair',

        //  ---

        /**
         * @method first
         * @summary Returns the first element of the ordered pair.
         * @returns {Object} An Object.
         */

        'first',

        //  ---

        /**
         * @method last
         * @summary Returns the second (last) element of the ordered pair.
         * @returns {Object} An Object.
         */

        'last'
    );

//  ------------------------------------------------------------------------
//  TP.api.SortedCollection API
//  ------------------------------------------------------------------------

/**
 * @type {TP.api.SortedCollection}
 * @summary The API required of objects which act as sorted collections.
 * @description TP.api.SortedCollection API is an interface which various
 *     collections may implement as needed. Array is the only type in the system
 *     which has native sorting capability so the interface is typically
 *     implemented by types which use an array to manage either their internal
 *     data storage or indexes on same.
 */

//  ------------------------------------------------------------------------

TP.sys.SortedCollection =
    TP.ac(

        /**
         * @method getSortFunction
         * @summary Returns the sort function, if any, which has been assigned
         *     to handle sorting discrimination. Array takes a sort function
         *     which will allow control over how contents are sorted. This
         *     method returns whatever function has been assigned. If no
         *     function has been assigned an ALPHA sort will be performed by
         *     calls to sort().
         * @returns {Function} A Function or null.
         */

        'getSortFunction',

        //  ---

        /**
         * @method setSortFunction
         * @summary Sets the sort function which will be used to determine the
         *     ordering of items in the collection. The value can be null if the
         *     desired sort is an ALPHA sort.
         * @param {Function} aFunction A function or null. If a function is
         *     passed it should take two parameters for testing and return -1 if
         *     the first is "less than" the second, +1 if the first is "greater
         *     than" the second and 0 if the two are "equal" in value.
         * @exception TP.sig.InvalidFunction
         */

        'setSortFunction',

        //  ---

        /**
         * @method sort
         * @summary Performs a sort on the underlying collection.
         * @returns {Collection} The receiver.
         */

        'sort'
    );

//  ------------------------------------------------------------------------
//  TP.api.IterationAPI
//  ------------------------------------------------------------------------

/**
 * @type {TP.api.IterationAPI}
 * @summary The API required of objects which can support a TP.core.Iterator.
 * @description The TP.api.IterationAPI is an interface definition for the
 *     methods required by a collection to support TP.core.Iterator management
 *     of the collection. TIBET interfaces are essentially just collections of
 *     method names in the current version. The ability to do multiple
 *     inheritance is supported via the concept of multiple inheritance and is
 *     orthagonal to the definition of a public interface (assuming semantic
 *     consistency in the library).
 */

//  ------------------------------------------------------------------------

TP.api.IterationAPI =
    TP.ac(

        /**
         * @method at
         * @summary Returns the value at the index provided.
         * @param {Number} anIndex
         * @exception TP.sig.InvalidIndex
         * @returns {Object} The item at the index provided or undefined.
         */

        'at',

        //  ---

        /**
         * @method atAll
         * @summary Returns a new collection containing the items in the
         *     receiver at the various indexes contained in the collection
         *     provided.
         * @param {TP.api.Collection} anIndexCollection
         * @exception TP.sig.InvalidParameter
         * @exception TP.sig.InvalidCollection
         * @returns {Object[]} An array of zero or more items.
         */

        'atAll',

        //  ---

        /**
         * @method getKeys
         * @summary Returns an array of keys for the underlying collection. In
         *     the case of an object with an Array for a data structure this
         *     results in an array containing the indices whose contents are not
         *     undefined. For Object data stores the result is the set of unique
         *     keys for the object.
         * @returns {Object[]} An array of 'keys' for the underlying collection.
         */

        'getKeys',

        //  ---

        /**
         * @method getSize
         * @summary Returns a count of the items in the receiving collection.
         * @returns {Number}
         */

        'getSize'

    );

//  ========================================================================
//  Array Extensions
//  ========================================================================

/**
 * @type {Array}
 * @summary Collection-oriented API's for Array base class.
 * @description The vast majority of functional support for the collection
 *     module. Most other collection classes rely on Array for their internal
 *     storage needs either for data, keys, or both. Array implements all of the
 *     TP.api.Collection, TP.api.IndexedCollection, and TP.api.OrderedCollection
 *     APIs as well as the TP.api.OrderedPair and TP.api.SortedCollection
 *     interfaces.
 * @example See the /tibet/test directory for collection tests which provide a
 *     good view of usage.
 */

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

Array.Type.defineMethod('generateNumericSequence',
function(fromIndex, toIndex) {

    /**
     * @method generateNumericSequence
     * @summary Generates a simple monotonic sequence of numbers from the
           starting index to the ending index (inclusive).
     * @returns {Number[]} An Array of Numbers from the start to the end index,
     *     inclusive.
     */

    var nums,
        i;

    nums = TP.ac();

    for (i = fromIndex; i <= toIndex; i++) {
        nums.push(i);
    }

    return nums;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('clearTextContent',
function() {

    /**
     * @method clearTextContent
     * @summary Clears out any text content of mutable items in the receiver,
     *     thereby clearing all of the non-mutable (primitive) items and leaving
     *     just the data structure.
     * @returns {Array} The receiver.
     */

    var len,
        i,
        it;

    len = this.length;
    for (i = 0; i < len; i++) {

        it = this[i];

        //  Make sure that the item is both mutable and implements a 'clear'
        //  method.
        if (TP.isMutable(it) && TP.canInvoke(it, 'clear')) {
            it.clear();
        } else {
            this[i] = '';
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('$$isCollection',
function() {

    /**
     * @method $$isCollection
     * @summary Returns true if the receiver is a collection instance.
     * @returns {Boolean} True if the receiver is a collection.
     */

    return true;
});

//  ------------------------------------------------------------------------
//  $$isPair                    Kernel
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('getIndices',
function() {

    /**
     * @method getIndices
     * @summary Returns the indices of the receiver. That is, all indices that
     *     have an actual value. This is different from getKeys() for an Array,
     *     since the results of that method also include the key 'length'.
     * @returns {Number[]} The indices of the receiver.
     */

    var keys;

    //  NB: We don't want any keys besides the ones that this object owns (not
    //  even 'length').
    keys = this.getKeys();
    keys.splice(keys.indexOf('length'), 1);

    return keys;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('vslice',
function(startIndexOrSpec, endIndex, aStep) {

    /**
     * @method vslice
     * @summary Returns a 'virtual slice' as a TP.core.Range that allows
     *     iteration over contents of the receiver.
     * @description This method can take a 'range spec' as the first argument.
     *     This range spec follows the Python syntax for 'slicing' (which has
     *     also been proposed for JavaScript):
     *     [1:3]    -> slice items 1 and 2
     *     [:3]     -> slice items 0, 1 and 2
     *     [2:]     -> slice from item 2 to the end of the Array
     *     [2:-1]   -> slice from item 2 to the second to last element
     *     [1:6:2]  -> slice from item 1 to item 5 stepping by 2
     *     [6:1:-2] -> slice from item 6 to item 2 stepping by -2 (i.e.
     *                 reversing)
     * @param {Number|String} startIndexOrSpec A Number specifying the starting
     *     index or a String containing the 'range spec' as discussed above. If
     *     this argument is null, the starting index will be set to 0.
     * @param {Number} endIndex A Number specifying the ending index. If this
     *     argument is null or undefined and the start index is not a range
     *     spec, the ending index will be set to the length of the receiver.
     * @param {Number} aStep A Number specifying the 'step' of the slice. If
     *     this argument is null or undefined and the start index is not a range
     *     spec, the step will be set to 1.
     * @example Construct an Array and vslices on that Array:
     *     <code>
     *          myArr = TP.ac(0, 1, 2, 3, 4, 5, 6, 7, 8, 9);
     *          myArr.vslice(6, 1, -2).perform(
     *          function(item) {
     *              TP.info(item);
     *          });
     *          <samp>6 4 2</samp>
     *          myArr.vslice('[2:6:2]').perform(
     *          function(item) {
     *              TP.info(item);
     *          });
     *          <samp>2 4</samp>
     *     </code>
     * @returns {TP.core.Range} The newly constructed TP.core.Range.
     */

    var rangeSpec,

        len,

        step,

        start,
        end,

        atEnd,

        swap,

        newRange;

    //  If its a String, see if we can split along ':' - at least one is
    //  required.
    if (TP.isString(startIndexOrSpec)) {
        if (TP.isEmpty(rangeSpec = startIndexOrSpec.split(':'))) {
            return null;
        }

        //  The format is 'start:end:step' - they're all optional, but we'll
        //  get at least 2 values by splitting along a single colon, which
        //  ensures that at least empty values are at 0 and 1.

        //  Make sure to strip off the leading '['
        start = rangeSpec.at(0).slice(1).asNumber();

        if (rangeSpec.getSize() > 2) {
            end = rangeSpec.at(1).asNumber();

            //  Make sure to strip off the trailing '['
            step = rangeSpec.at(2).slice(
                        0, rangeSpec.at(2).getSize() - 1).asNumber();
        } else {
            //  Make sure to strip off the trailing '['
            end = rangeSpec.at(1).slice(
                        0, rangeSpec.at(1).getSize() - 1).asNumber();
        }
    } else {
        start = startIndexOrSpec;
        end = endIndex;
        step = aStep;
    }

    //  Default step to be 1.
    if (TP.notValid(step) || TP.isNaN(step = step.asNumber())) {
        step = 1;
    }

    //  Default start to be 0 (or one off the size, if we're stepping
    //  backwards).
    if (TP.notValid(start) || TP.isNaN(start = start.asNumber())) {
        if (step.isNegative()) {
            start = this.getSize() - 1;
        } else {
            start = 0;
        }
    }

    atEnd = false;

    //  Default end to be the size (or 0, if we're stepping backwards).
    if (TP.notValid(end) || TP.isNaN(end = end.asNumber())) {
        atEnd = true;

        if (step.isNegative()) {
            end = 0;
        } else {
            end = this.getSize() - 1;
        }
    }

    len = this.getSize();

    //  Adjust for how TP.core.Ranges work.

    //  TP.core.Ranges don't support negative start indexes, but slices do,
    //  so we adjust the start and end.

    //  Normalize start and end as per Brendan's slicing proposal for a
    //  future version of JavaScript:
    //      http://wiki.ecmascript.org/doku.php?id=proposals:slice_syntax

    if (start.isNegative()) {
        start = (len + start).max(0);
    } else {
        start = start.min(len);
    }

    if (end.isNegative()) {
        end = (len + end).max(0);
    } else {
        end = end.min(len);
    }

    //  TP.core.Ranges always include the end index - slicing doesn't
    if (!atEnd) {
        if (step.isPositive()) {
            end -= 1;
        } else {
            end += 1;
        }
    }

    //  If start is greater than end (and we're not stepping negatively),
    //  swap them to make the TP.core.Range work right.
    if (start > end && !step.isNegative()) {
        swap = end;
        end = start;
        start = swap;
    }

    //  Construct the new TP.core.Range and set its 'values' to be ourself
    //  (and it will therefore iterate over our items).
    newRange = TP.core.Range.construct(start, end, step);

    return newRange;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('truncate',
function(aSize) {

    /**
     * @method truncate
     * @summary Reduces the size of the receiver to the size specified.
     * @description If the size provided is larger than the receiver the
     *     receiver is unaltered. If the size provided is negative the receiver
     *     is emptied. If no size is provided this method does nothing.
     * @param {Number} aSize The new size (if smaller than current).
     * @returns {Array} The receiver.
     * @fires Change
     */

    var size,
        len;

    size = parseInt(aSize, 10);
    len = this.length;

    if (!TP.isNumber(size)) {
        return this;
    }

    size = size.max(0);
    if (size > this.getSize()) {
        return this;
    }

    this.length = size;
    if (len !== size) {
        this.changed('length', TP.DELETE,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));
    }

    return this;
});

//  ------------------------------------------------------------------------
//  TP.api.Collection API
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('add',
function(varargs) {

    /**
     * @method add
     * @summary Adds (appends) the argument(s) provided.
     * @param {arguments} varargs A variable list of arguments.
     * @returns {Array} The receiver.
     * @fires Change
     */

    var len;

    if (arguments.length > 0) {

        len = this.length;
        this.push.apply(this, arguments);

        this.changed('length', TP.INSERT,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));
    }

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('addAll',
function(aCollection) {

    /**
     * @method addAll
     * @summary Adds all items from the collection as elements of the receiver.
     * @param {TP.api.Collection} aCollection The collection to add items from.
     * @returns {Array} The receiver.
     */

    var thisref,
        len;

    len = this.length;

    thisref = this;

    if (TP.isArray(aCollection)) {
        this.push.apply(this, aCollection);
    } else {
        if (!TP.canInvoke(aCollection, 'perform')) {
            return this.raise('TP.sig.InvalidCollection');
        }

        aCollection.perform(
            function(item) {
                thisref.push(item);
            });
    }

    if (this.length !== len) {
        this.changed('length', TP.INSERT,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));
    }

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('addAllIfAbsent',
function(aCollection) {

    /**
     * @method addAllIfAbsent
     * @summary Adds all items from the collection provided which are not
     *     currently found in the receiver.
     * @param {TP.api.Collection} aCollection The collection to add items from.
     * @returns {Array} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('addIfAbsent',
function(anObject, aTest) {

    /**
     * @method addIfAbsent
     * @summary Adds an object to the receiver if it isn't already in the
     *     collection.
     * @description Note that the semantics of this call are slightly different
     *     between Array and Hash. In the case of Array the object is added if
     *     it isn't contained in the Array, meaning the test is against the
     *     _value_. In the case of a Hash the object (a pair) is added if the
     *     _key_ isn't found so the value itself isn't altered for existing
     *     keys.
     * @param {Object} anObject The object to add.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Array} The receiver.
     * @fires Change
     */

    if (this.contains(anObject, aTest)) {
        return this;
    }

    return this.add(anObject);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('addItem',
function(anItem) {

    /**
     * @method addItem
     * @summary Adds a single item to the receiver.
     * @description As mentioned in other contexts an item may have different
     *     properties. For an array an item is a value unless that value happens
     *     to be an ordered pair whose first element is a number. In that case
     *     the receiver works like a numerically-indexed hash and adds the
     *     last() element of anItem at the index defined by the first() element.
     * @param {Object|Pair} anItem The item to add.
     * @returns {Array} The receiver.
     * @fires Change
     */

    //  a numerically-indexed pair is considered special to this method, a
    //  way of defining a key/value pair rather than just a value.
    if (TP.isPair(anItem) && TP.isNumber(anItem.first())) {
        this.atPut(anItem.first(), anItem.last());
    } else {
        this.add(anItem);
    }

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('addWithCount',
function(anObject, aCount) {

    /**
     * @method addWithCount
     * @summary Adds the object N times, where N defaults to 0. NOTE that in
     *     the absence of a valid count the object is not added.
     * @param {Object} anObject The object to add.
     * @param {Number} aCount A number of times to add the object. Default is 0.
     * @returns {Array} The receiver.
     * @fires Change
     */

    var i,
        count,

        len;

    //  no count? no work to do
    if (TP.notValid(aCount)) {
        return this;
    }

    //  count, but not a number? won't try to convert, just warn/exit
    count = parseInt(aCount, 10);
    if (!TP.isNumber(count)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    len = this.length;

    for (i = 0; i < count; i++) {
        this.push(anObject);
    }

    if (count > 1) {
        this.changed('length', TP.INSERT,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));
    }

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('asArray',
function() {

    /**
     * @method asArray
     * @summary Returns the receiver in Array form. For an Array instance this
     *     method simply returns the array.
     * @returns {Array} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('asHash',
function() {

    /**
     * @method asHash
     * @alias asTP_core_Hash
     * @summary Returns a hash containing the key/value pairs of the array. The
     *     indexes of this hash are the numerical indices of the receiver for
     *     which the value TP.isDefined().
     * @description The resulting hash's keys are the indices of the array from
     *     0 to array.length. Note that if the receiver is an ordered pair the
     *     result is a hash containing the key/value data from the single
     *     ordered pair.
     * @returns {TP.core.Hash} A new TP.core.Hash.
     */

    var result,
        len,
        i;

    //  Unlike the hash constructor being used to construct a Hash from an
    //  Array, we use numeric indexes from an Array as the keys
    result = TP.hc();

    len = this.length;
    for (i = 0; i < len; i++) {
        result.atPut(i, this[i]);
    }

    return result;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('asTP_core_Hash', Array.getInstPrototype().asHash);

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('asIterator',
function(aStep) {

    /**
     * @method asIterator
     * @summary Returns a new iterator on the receiver.
     * @param {Number} aStep Defines the increment size the iteration should
     *     use. The default value is 1.
     * @returns {TP.core.Iterator} The new iterator.
     */

    //  sort first because the iterator will copy our keys on init()
    this.$sortIfNeeded();

    return this.getIteratorType().construct(this, aStep);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('asObject',
function() {

    /**
     * @method asObject
     * @summary Returns a 'plain JavaScript object' version of the receiver -
     *     and makes sure that any nested content is also converted to its plain
     *     JavaScript equivalent.
     * @returns {Object} The receiver - and its content - as plain JavaScript
     *     objects.
     */

    var marker,
        len,
        obj,
        i,
        val;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asObject';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    len = this.getSize();
    obj = [];

    try {
        for (i = 0; i < len; i++) {
            val = this.at(i);

            //  Make sure to recurse in so that we end up with plain Object
            //  versions of all values.
            obj[i] = TP.obj(val);
        }
    } finally {
        delete this[marker];
    }

    return obj;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('asRange',
function() {

    /**
     * @method asRange
     * @summary Returns a new TP.core.Range based on the size of the receiver.
     * @exception TP.sig.TypeNotFound
     * @returns {TP.core.Range} The receiver as a range.
     */

    var type;

    //  TP.core.Range is an optional type, so we'll need to try to load it
    if (TP.notValid(type = TP.sys.getTypeByName('TP.core.Range'))) {
        return this.raise('TP.sig.TypeNotFound');
    }

    //  use size of array to configure the range
    return type.construct(1, this.length);
});

//  ------------------------------------------------------------------------
//  asString                    Kernel
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('collapse',
function() {

    /**
     * @method collapse
     * @summary Returns the "simplest" form of the receiver possible, meaning
     *     that when the receiver has only one item that item is returned,
     *     otherwise the receiver is returned.
     * @returns {Array|Object} The receiver or its single item.
     */

    if (this.getSize() === 1) {
        return this.at(0);
    }

    return this;
});

//  ------------------------------------------------------------------------
//  collect                     Kernel
//  ------------------------------------------------------------------------
//  collectGet                  Kernel
//  ------------------------------------------------------------------------
//  collectInvoke               Kernel
//  ------------------------------------------------------------------------
//  compact                     Kernel
//  ------------------------------------------------------------------------
//  conform                     Kernel
//  ------------------------------------------------------------------------
//  contains                    Kernel
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('containsAll',
function(aCollection, aTest) {

    /**
     * @method containsAll
     * @summary Returns true if all the values in the collection provided are
     *     found in the receiver.
     * @param {TP.api.Collection} aCollection The collection of elements all of
     *     which must be equal to at least one element in the receiver for this
     *     method to return true.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception TP.sig.InvalidCollection
     * @returns {Boolean} Whether or not the receiver contains all of the values
     *     in the collection provided.
     */

    var comp,
        copy,
        found;

    if (TP.isArray(aCollection)) {
        if (TP.isEmpty(aCollection)) {
            return false;
        }

        comp = aCollection.copy();
    } else {
        if (!TP.canInvoke(aCollection, 'asArray')) {
            return this.raise('TP.sig.InvalidCollection');
        }

        comp = aCollection.asArray();
        if (TP.isEmpty(comp)) {
            return false;
        }
    }

    //  we'll be sorting so let's work on a copy
    copy = this.copy();

    if (aTest === TP.IDENTITY) {
        copy.sort(TP.sort.IDENTITY);
        comp.sort(TP.sort.IDENTITY);
    } else {
        copy.sort(TP.sort.EQUALITY);
        comp.sort(TP.sort.EQUALITY);
    }

    //  iterating on the incoming data means item is what we'll be looking
    //  for in ourselves (or at least, our copy of ourselves). the first
    //  detected missing value will terminate the loop here
    found = comp.detect(
        function(item, index) {

            return !copy.contains(item, aTest);
        });

    return TP.notValid(found);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('containsAny',
function(aCollection, aTest) {

    /**
     * @method containsAny
     * @summary Returns true if any of the values in the collection provided
     *     are found in the receiver.
     * @param {TP.api.Collection} aCollection The collection of elements any of
     *     which must be equal to any element in the receiver for this method to
     *     be true.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception TP.sig.InvalidCollection
     * @returns {Boolean} Whether or not the receiver contains any of the values
     *     in the collection provided.
     */

    var comp,
        copy,
        found;

    if (TP.isArray(aCollection)) {
        if (TP.isEmpty(aCollection)) {
            return false;
        }

        comp = aCollection.copy();
    } else {
        if (!TP.canInvoke(aCollection, 'asArray')) {
            return this.raise('TP.sig.InvalidCollection');
        }

        comp = aCollection.asArray();
        if (TP.isEmpty(comp)) {
            return false;
        }
    }

    //  we'll be sorting so let's work on a copy
    copy = this.copy();

    if (aTest === TP.IDENTITY) {
        copy.sort(TP.sort.IDENTITY);
        comp.sort(TP.sort.IDENTITY);
    } else {
        copy.sort(TP.sort.EQUALITY);
        comp.sort(TP.sort.EQUALITY);
    }

    //  iterating on the incoming data means item is what we'll be looking
    //  for in ourselves (or at least, our copy of ourselves). the first
    //  detected found value will terminate the loop here
    found = comp.detect(
        function(item, index) {

            return copy.contains(item, aTest);
        });

    return TP.isValid(found);
});

//  ------------------------------------------------------------------------
//  containsString              Kernel
//  ------------------------------------------------------------------------
//  convert                     Kernel
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('countOf',
function(anItem, aTest) {

    /**
     * @method countOf
     * @summary Returns a count of the number of times anItem is found in the
     *     array.
     * @param {Object} anItem The element whose value is checked against.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Number} The number of occurrences of anItem.
     */

    return this.select(
        function(item, index) {

            switch (aTest) {
                case TP.IDENTITY:
                    return TP.identical(item, anItem);
                default:
                    return TP.equal(item, anItem);
            }
        }).getSize();
});

//  ------------------------------------------------------------------------
//  detect                      Kernel
//  ------------------------------------------------------------------------
//  detectInvoke                Kernel
//  ------------------------------------------------------------------------
//  detectMax                   Kernel
//  ------------------------------------------------------------------------
//  detectMin                   Kernel
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('difference',
function(aCollection, aTest) {

    /**
     * @method difference
     * @summary Returns the elements contained in the receiver which are not in
     *     the collection provided.
     * @description This method can be thought of as subtracting all elements
     *     found in the collection provided from the receiver. What's left are
     *     those elements unique to the receiver.
     * @param {TP.api.Collection} aCollection The collection to difference
     *     against the receiver.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception TP.sig.InvalidCollection
     * @returns {Object[]} The difference between aCollection and the receiver.
     */

    var arr;

    if (!TP.canInvoke(aCollection, 'asArray')) {
        return this.raise('TP.sig.InvalidCollection');
    }

    arr = aCollection.asArray();

    return this.select(
        function(item, index) {
            return !arr.contains(item, aTest);
        });
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('disjunction',
function(aCollection, aTest) {

    /**
     * @method disjunction
     * @summary Returns the 'symmetric difference' or those elements which are
     *     disjunct between the collections (in one or the other but not both).
     * @description This method returns a new array containing the disjunction
     *     between the receiver and aCollection. This means that only those
     *     elements which occur in one of the collections but not the other are
     *     returned.
     * @param {TP.api.Collection} aCollection The collection to disjunct against
     *     the receiver.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Object[]} The disjunction of aCollection and the receiver.
     */

    var thisref,
        diffs;

    thisref = this;

    //  the disjunction is the combined differences so start with the one
    //  set...
    diffs = this.difference(aCollection);

    //  and provide that to a second iteration to be filled out further
    diffs = aCollection.injectInto(
                diffs,
                function(item, accum, index) {

                    if (!thisref.contains(item, aTest)) {
                        accum.push(item);
                    }

                    return accum;
                });

    return diffs;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('empty',
function() {

    /**
     * @method empty
     * @summary Empties the receiver.
     * @returns {Array} The receiver.
     * @fires Change
     */

    var len;

    len = this.length;
    this.length = 0;

    this.changed('length', TP.DELETE,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('flatten',
function() {

    /**
     * @method flatten
     * @summary Extracts embedded elements which may exist and flattens them.
     * @returns {Object[]} A new array containing the elements of the receiver
     *     in flattened form.
     */

    var result,
        len,
        i,
        it;

    result = TP.ac();

    len = this.length;
    for (i = 0; i < len; i++) {
        it = this[i];
        if (TP.isArray(it)) {
            result.addAll(it.flatten());
        } else {
            result.push(it);
        }
    }

    return result;
});

//  ------------------------------------------------------------------------
//  getItems                    Kernel
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('getIterator',
function() {

    /**
     * @method getIterator
     * @summary Returns the receiver's internal iterator. If no iterator exists
     *     a new one is constructed and assigned. You shouldn't count on the
     *     iterator being at the start() when you receive it. If you need
     *     multiple iterators use asIterator().
     * @returns {TP.core.Iterator} An iterator on the receiver.
     */

    if (TP.notValid(this.$get('iterator'))) {
        this.$set('iterator', this.asIterator());
    }

    return this.$get('iterator');
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('getIteratorType',
function() {

    /**
     * @method getIteratorType
     * @summary Returns the type of iterator used for the receiver.
     * @returns {TP.core.Iterator} The type of the iterator.
     */

    var type;

    if (TP.notValid(type = TP.sys.getTypeByName('TP.core.Iterator'))) {
        return this.raise('TP.sig.TypeNotFound');
    }

    return type;
});

//  ------------------------------------------------------------------------
//  getSize                     Kernel
//  ------------------------------------------------------------------------
//  getValues                   Kernel
//  ------------------------------------------------------------------------
//  grep                        Kernel
//  ------------------------------------------------------------------------
//  groupBy                     Kernel
//  ------------------------------------------------------------------------
//  injectInto                  Kernel
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('intersection',
function(aCollection, aTest) {

    /**
     * @method intersection
     * @summary Returns the intersection of the two collections.
     * @description This method returns a collection of those elements which
     *     occur in BOTH the receiver and in aCollection.
     * @param {TP.api.Collection} aCollection The collection to intersect the
     *     receiver with.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception TP.sig.InvalidCollection
     * @returns {Object[]} An array of elements occurring in both.
     */

    if (!TP.canInvoke(aCollection, 'contains')) {
        return this.raise('TP.sig.InvalidCollection');
    }

    return this.select(
        function(item) {

            return aCollection.contains(item, aTest);
        });
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('isSortedCollection',
function() {

    /**
     * @method isSortedCollection
     * @summary Returns true if the receiver is behaving as a sorted
     *     collection. Effectively true any time the receiver has a valid sort
     *     function assigned.
     * @description Arrays can maintain their content in a sorted fashion so
     *     that any access of the underlying data will be against a sorted data
     *     set. This method returns true if the receiver is operating in that
     *     fashion.
     * @returns {Boolean}
     */

    return TP.isCallable(this.getSortFunction());
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('merge',
function(varargs) {

    /**
     * @method merge
     * @summary Merge the receiver's elements with elements from one or more
     *     collections. In some sense the reverse of partition, using an
     *     optional function to determine which elements of a set of collections
     *     should be grouped into pairs/triplets/quads etc.
     * @param {arguments} varargs Variable-length argument list of ordered
     *     pairs.
     * @returns {Object[]} An array containing ordered pairs (or triplets,
     *     quads, etc.) constructed from the receiver and incoming collection
     *     elements.
     */

    var arr,
        result,
        i,
        len;

    //  collections go into a new list and we go on the front so our items
    //  are first in line in the results
    arr = TP.args(arguments);
    arr.unshift(this);

    result = TP.ac();

    //  iterate on this to run the proper number of times, collecting the
    //  new content as we go. each iteration returns an array built by
    //  asking each collection in turn for the content at the current index
    len = this.length;
    for (i = 0; i < len; i++) {
        result.push(arr.collectGet(i));
    }

    return result;
});

//  ------------------------------------------------------------------------
//  partition                   Kernel
//  ------------------------------------------------------------------------
//  perform                     Kernel
//  ------------------------------------------------------------------------
//  performInvoke               Kernel
//  ------------------------------------------------------------------------
//  performSet                  Kernel
//  ------------------------------------------------------------------------
//  performUntil                Kernel
//  ------------------------------------------------------------------------
//  performWhile                Kernel
//  ------------------------------------------------------------------------
//  performWith                 Kernel
//  ------------------------------------------------------------------------
//  reject                      Kernel
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('remove',
function(anItem, aTest) {

    /**
     * @method remove
     * @summary Removes a value from the receiver.
     * @description In this method, all instances of the value are removed. To
     *     remove only the first instance use 'removeFirst()'. The array is
     *     updated in place. NOTE that this method won't remove nulls so
     *     remove(null) or remove() won't work. You have to use compact so TIBET
     *     can be sure that you intended the removal and didn't get a null
     *     argument by accident, altering the receiver unintentionally.
     * @param {Object} anItem The item to be removed.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Number} The number of elements removed.
     * @fires Change
     */

    var i,
        len,
        wi,
        val,
        deleted;

    //  nothing to remove. have to use compact to remove nulls
    if (TP.notValid(anItem)) {
        return 0;
    }

    wi = 0;
    len = this.length;
    for (i = 0; i < len; i++) {
        val = this[i];
        switch (aTest) {
            case TP.IDENTITY:
                if (!TP.identical(val, anItem)) {
                    this[wi] = val;
                    wi++;
                }
                break;
            default:
                if (!TP.equal(val, anItem)) {
                    this[wi] = val;
                    wi++;
                }
                break;
        }
    }

    deleted = 0;
    if (wi < len) {
        deleted = len - wi;
        this.length = wi;

        this.changed('length', TP.DELETE,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));
    }

    return deleted;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('removeAll',
function(aCollection, aTest) {

    /**
     * @method removeAll
     * @summary Removes the values contained in the collection from the
     *     receiver.
     * @param {TP.api.Collection} aCollection The collection of elements that
     *     removed elements need to be equal to.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception TP.sig.InvalidCollection
     * @returns {Number} The number of elements removed.
     * @fires Change
     */

    var arr,
        deleted,
        thisref,

        shouldSignal,

        len;

    if (TP.isArray(aCollection)) {
        arr = aCollection;
    } else {
        if (!TP.canInvoke(aCollection, 'asArray')) {
            return this.raise('TP.sig.InvalidCollection');
        }

        arr = aCollection.asArray();
    }

    if (TP.isEmpty(arr)) {
        return 0;
    }

    deleted = 0;
    thisref = this;

    //  turn off change signaling
    shouldSignal = this.shouldSignalChange();
    this.shouldSignalChange(false);

    len = this.length;

    try {
        arr.perform(
            function(item, index) {
                deleted += thisref.remove(item, aTest);
            });
    } finally {
        //  re-enable change notification
        this.shouldSignalChange(shouldSignal);
    }

    if (deleted > 0) {
        this.changed('length', TP.DELETE,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));
    }

    return deleted;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('replace',
function(oldValue, newValue, aTest) {

    /**
     * @method replace
     * @summary Replaces the element having the value oldValue with an element
     *     having the value newValue whereever it occurs in the receiver.
     * @param {Object} oldValue The old value to look for.
     * @param {Object} newValue The new value to replace the old value with.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Array} The receiver.
     * @fires Change
     */

    var shouldSignal,

        replaced,

        len;

    //  turn off change signaling
    shouldSignal = this.shouldSignalChange();
    this.shouldSignalChange(false);

    replaced = 0;

    len = this.length;

    try {
        this.convert(
            function(item, index) {

                switch (aTest) {
                    case TP.IDENTITY:
                        if (TP.identical(item, oldValue)) {
                            replaced++;
                            return newValue;
                        }
                        break;
                    default:
                        if (TP.equal(item, oldValue)) {
                            replaced++;
                            return newValue;
                        }
                        break;
                }

                return item;
            });
    } finally {
        //  re-enable change signaling
        this.shouldSignalChange(shouldSignal);
    }

    if (replaced > 0) {
        this.changed('length', TP.UPDATE,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));
    }

    return replaced;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('replaceAll',
function(aCollection, newValue, aTest) {

    /**
     * @method replaceAll
     * @summary Replaces all values in aCollection with a newValue using the
     *     test provided to determine a match. The default test is TP.EQUALITY.
     * @param {TP.api.Collection} aCollection A collection containing the
     *     elements to replace.
     * @param {Object} newValue A new value to replace objects with.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception TP.sig.InvalidCollection
     * @returns {Array} The receiver.
     * @fires Change
     */

    var arr,
        replaced,
        thisref,

        len,

        shouldSignal;

    if (TP.isArray(aCollection)) {
        arr = aCollection;
    } else {
        if (!TP.canInvoke(aCollection, 'asArray')) {
            return this.raise('TP.sig.InvalidCollection');
        }

        arr = aCollection.asArray();
    }

    if (TP.isEmpty(arr)) {
        return 0;
    }

    replaced = 0;
    thisref = this;

    len = this.length;

    //  turn off change signaling
    shouldSignal = this.shouldSignalChange();
    this.shouldSignalChange(false);

    try {
        arr.perform(
            function(item, index) {
                replaced += thisref.replace(item, newValue, aTest);
            });
    } finally {
        //  re-enable change notification
        this.shouldSignalChange(shouldSignal);
    }

    if (replaced > 0) {
        this.changed('length', TP.UPDATE,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));
    }

    return replaced;
});

//  ------------------------------------------------------------------------
//  select                      Kernel
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('union',
function(aCollection) {

    /**
     * @method union
     * @summary Returns a new array containing the members of both arrays.
     * @description This method computes a new array of elements, placing into
     *     it all elements from this array and all elements from aCollection.
     * @param {TP.api.Collection} aCollection The other collection to union this
     *     array against.
     * @exception TP.sig.InvalidCollection
     * @returns {Object[]} The new array containing elements from both arrays.
     */

    var arr;

    if (!TP.canInvoke(aCollection, 'injectInto')) {
        return this.raise('TP.sig.InvalidCollection');
    }

    arr = this.copy();
    arr = aCollection.injectInto(
                arr,
                function(item, accum, index) {

                    accum.push(item);
                    return accum;
                });

    return arr;
});

//  ------------------------------------------------------------------------
//  unique                      Kernel
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  TP.api.IndexedCollection API
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('addAt',
function(anItem, anIndex) {

    /**
     * @method addAt
     * @summary Adds the value provided at anIndex. Note that this does not
     *     replace the item at that location, it splices the new value into
     *     place hence the 'add' terminology. To replace use atPut() or set().
     * @param {Object} anItem The element to add at anIndex.
     * @param {Number} anIndex The index to add anItem at.
     * @returns {Array} The receiver.
     * @fires Change
     */

    var index,
        len;

    index = parseInt(anIndex, 10);
    if (!TP.isNumber(index)) {
        return this.raise('TP.sig.InvalidIndex');
    }

    /* eslint-disable no-extra-parens */
    index = (index > 0) ? index : this.normalizeIndex(index);
    /* eslint-enable no-extra-parens */

    len = this.length;

    //  if we're not that long yet just use the sparse array indexing
    //  behavior to add the element. if data already exists at the location
    //  in question we splice the new element into place
    if (this.length < index) {
        //  primitive so we control signaling
        this[index] = anItem;
    } else {
        this.splice(index, 0, anItem);
    }

    this.changed('length', TP.INSERT,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('addAllAt',
function(aCollection, anIndex) {

    /**
     * @method addAllAt
     * @summary Adds all the elements of aCollection beginning at the index
     *     provided.
     * @param {TP.api.Collection} aCollection The collection to add elements
     *     from.
     * @param {Number} anIndex The index to begin adding elements.
     * @exception TP.sig.InvalidCollection
     * @exception TP.sig.InvalidIndex
     * @returns {Array} The receiver.
     * @fires Change
     */

    var arr,
        index,

        len,

        tmparr;

    index = parseInt(anIndex, 10);
    if (!TP.isNumber(index)) {
        return this.raise('TP.sig.InvalidIndex');
    }

    if (TP.isArray(aCollection)) {
        arr = aCollection;
    } else {
        if (!TP.canInvoke(aCollection, 'asArray')) {
            return this.raise('TP.sig.InvalidCollection');
        }

        arr = aCollection.asArray();
    }

    tmparr = TP.ac();
    /* eslint-disable no-extra-parens */
    index = (index > 0) ? index : this.normalizeIndex(index);
    /* eslint-enable no-extra-parens */

    len = this.length;

    //  build argument array for splicing without deletion
    if (this.length < index) {
        //  work around spec's inability to support sparseness with
        //  splice()
        this[index] = '$$BOGON$$';
        tmparr.push(index, 1);
    } else {
        tmparr.push(index, 0);
    }

    //  we use apply so we 'unroll' the collection at items
    this.splice.apply(this, tmparr.addAll(arr));

    this.changed('length', TP.INSERT,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));

    return this;
});

//  ------------------------------------------------------------------------
//  at                          Kernel
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('atAll',
function(aCollection) {

    /**
     * @method atAll
     * @summary Returns an array containing the values at each of the indices
     *     provided.
     * @param {TP.api.Collection} aCollection The collection of indexes.
     * @exception TP.sig.InvalidCollection
     * @exception TP.sig.InvalidIndex
     * @returns {Object[]} A new array containing the values collected.
     */

    var arr,
        tmparr,
        thisref;

    if (TP.isArray(aCollection)) {
        arr = aCollection;
    } else {
        if (!TP.canInvoke(aCollection, 'asArray')) {
            return this.raise('TP.sig.InvalidCollection');
        }

        arr = aCollection.asArray();
    }

    this.$sortIfNeeded();

    thisref = this;
    tmparr = TP.ac();

    arr.perform(
        function(item, index) {
            //  the at call here will normalize index
            tmparr.push(thisref.at(item));
        });

    return tmparr;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('atAllPut',
function(aCollection, anItem) {

    /**
     * @method atAllPut
     * @summary Inserts anItem at a set of locations.
     * @description Places anItem at each location in the receiver. If the
     *     optional collection is provided the indices listed in the collection
     *     are updated rather than the entire array.
     * @param {TP.api.Collection} aCollection An optional collection specifying
     *     indexes which should be altered to contain anItem.
     * @param {Object} anItem The element to put at all the locations in this
     *     array (unless aCollection of indexes is provided).
     * @exception TP.sig.InvalidCollection
     * @returns {Array} The receiver.
     * @fires Change
     */

    var arr,
        altered,
        thisref,

        len;

    if (TP.isArray(aCollection)) {
        arr = aCollection;
    } else {
        if (!TP.canInvoke(aCollection, 'asArray')) {
            return this.raise('TP.sig.InvalidCollection');
        }

        arr = aCollection.asArray();
    }

    this.$sortIfNeeded();

    altered = 0;
    thisref = this;

    len = this.length;

    arr.perform(
        function(item, index) {
            //  only count true changes
            if (!TP.equal(thisref.at(item), anItem)) {
                altered++;
                thisref.atPut(item, anItem);
            }
        });

    if (altered > 0) {
        this.changed('length', TP.UPDATE,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));
    }

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('atIfInvalid',
function(anIndex, aDefault) {

    /**
     * @method atIfInvalid
     * @summary Returns the value at the index provided or the default value if
     *     the key returns an invalid value.
     * @description If a Function is supplied as the default value to this
     *     method, it will be executed and its value will be returned as the
     *     value. Therefore, this method cannot be used if the Function object
     *     itself is what is desired as the returned value.
     * @param {Number} anIndex The index of the value to return.
     * @param {Object} aDefault The default value to return if undefined.
     *     Functions are executed to return their value in response.
     * @returns {Object} The element at anIndex in this collection.
     */

    var value;

    if (TP.isValid(value = this.at(anIndex))) {
        return value;
    } else if (TP.isCallable(aDefault)) {
        return aDefault();
    } else {
        return aDefault;
    }
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('atIfNull',
function(anIndex, aDefault) {

    /**
     * @method atIfNull
     * @summary Returns the value at the index provided or the default value if
     *     the key returns null (and not undefined).
     * @description If a Function is supplied as the default value to this
     *     method, it will be executed and its value will be returned as the
     *     value. Therefore, this method cannot be used if the Function object
     *     itself is what is desired as the returned value.
     * @param {Number} anIndex The index of the value to return.
     * @param {Object} aDefault The default value to return if undefined.
     *     Functions are executed to return their value in response.
     * @returns {Object} The element at anIndex in this collection.
     */

    var value;

    if (TP.notNull(value = this.at(anIndex))) {
        return value;
    } else if (TP.isCallable(aDefault)) {
        return aDefault();
    } else {
        return aDefault;
    }
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('atIfUndefined',
function(anIndex, aDefault) {

    /**
     * @method atIfUndefined
     * @summary Returns the value at the index provided or the default value if
     *     the key returns undefined.
     * @description If a Function is supplied as the default value to this
     *     method, it will be executed and its value will be returned as the
     *     value. Therefore, this method cannot be used if the Function object
     *     itself is what is desired as the returned value.
     * @param {Number} anIndex The index of the value to return.
     * @param {Object} aDefault The default value to return if undefined.
     *     Functions are executed to return their value in response.
     * @returns {Object} The element at anIndex in this collection.
     */

    var value;

    if (TP.isDefined(value = this.at(anIndex))) {
        return value;
    } else if (TP.isCallable(aDefault)) {
        return aDefault();
    } else {
        return aDefault;
    }
});

//  ------------------------------------------------------------------------
//  atPut                       Kernel
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('atPutIfAbsent',
function(aKey, aValue) {

    /**
     * @method atPutIfAbsent
     * @summary Add the key and value if the key doesn't already exist. NOTE
     *     that the value isn't relevant in this test, the value may be null, or
     *     undefined, and as long at the key has been defined at some point this
     *     method will not update the value.
     * @param {Object} aKey The key to test and optionally add to the receiver.
     * @param {Object} aValue Optional value to store when the first argument is
     *     a string.
     * @exception InvalidPair
     * @returns {Object} The key's value after processing.
     * @fires Change
     */

    if (!TP.isNumber(aKey)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    if (TP.notDefined(this[aKey])) {
        this.atPut(aKey, aValue);
    }

    return this.at(aKey);
});

//  ------------------------------------------------------------------------
//  containsKey                 Kernel
//  ------------------------------------------------------------------------
//  containsValue               Kernel
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('detectKeyAt',
function(aKey, anIndex) {

    /**
     * @method detectKeyAt
     * @summary Searches for the first nested element whose value at(anIndex)
     *     matches aKey. This can be a useful detection for finding data in an
     *     ordered collection (array, sorted hash, or node) by the value at a
     *     particular index or attribute location.
     * @param {String|RegExp} aKey The string or regular expression selector to
     *     match with.
     * @param {Number} anIndex The "column" index to check in each nested array.
     * @returns {Object[]} The nested array whose value at anIndex matches aKey.
     */

    var index;

    index = TP.ifInvalid(anIndex, 0);

    return this.detect(
        function(obj) {

            if (!TP.isArray(obj)) {
                return;
            }

            return TP.isValid(aKey.match(obj.at(index)));
        });
});

//  ------------------------------------------------------------------------
//  getKeys                     Kernel
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('getKeysForValue',
function(aValue, aTest) {

    /**
     * @method getKeysForValue
     * @summary Returns an array containing the keys where the value matches the
     *     supplied value, according to the test.
     * @param {Object} aValue The value to check.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {String[]} An array of the keys for the supplied value.
     */

    var arr,
        i,
        val;

    arr = TP.ac();

    for (i = 0; i < this.length; i++) {

        val = this[i];

        switch (aTest) {
            case TP.IDENTITY:
                if (TP.identical(aValue, val)) {
                    arr.push(i);
                }
                break;
            default:
                if (TP.equal(aValue, val)) {
                    arr.push(i);
                }
        }
    }

    return arr;
});

//  ------------------------------------------------------------------------
//  getKVPairs                  Kernel
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('getPosition',
function(anItem, startIndex, aTest) {

    /**
     * @method getPosition
     * @summary Returns the first index of anItem in the receiver.
     * @param {Object} anItem The element to search for.
     * @param {Number} startIndex The index to start looking for anItem.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Number} The first index of an element equal to anItem.
     */

    var found;

    found = TP.NOT_FOUND;

    //  we'll use detect since that will stop once our test succeeds and
    //  will adjust for a negative index if provided for a start... it'll
    //  also sortIfNeeded()
    this.detect(
        function(item, index) {

            switch (aTest) {
                case TP.IDENTITY:
                    if (TP.identical(item, anItem)) {
                        found = index;
                        return true;
                    }
                    break;
                default:
                    if (TP.equal(item, anItem)) {
                        found = index;
                        return true;
                    }
                    break;
            }
        },
        startIndex);

    return found;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('getPositions',
function(anItem, startIndex, aTest) {

    /**
     * @method getPositions
     * @summary Returns an array containing all indexes where anItem exists.
     * @param {Object} anItem The value to search for.
     * @param {Number} startIndex The index to start looking for anItem.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Number[]} A new array of indexes.
     */

    var tmparr,
        start,
        test,
        len,
        i;

    start = TP.ifInvalid(this.normalizeIndex(startIndex), 0);

    this.$sortIfNeeded();

    tmparr = TP.ac();
    test = aTest === TP.IDENTITY ? TP.identical : TP.equal;

    len = this.length;
    for (i = start; i < len; i++) {
        if (test(this.at(i), anItem)) {
            tmparr.push(i);
        }
    }

    return tmparr;
});

//  ------------------------------------------------------------------------
//  grepKeys                    Kernel
//  ------------------------------------------------------------------------
//  performOver                 Kernel
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('pad',
function(places, padContent, appendIndex) {

    /**
     * @method pad
     * @summary Pads the receiver out to the number of places supplied
     * @param {Number} numPlaces The number of places to pad the receiver out
     *     to.
     * @param {Object} padContent The content to put into each padded place.
     * @param {Boolean} [appendIndex=false] Whether or not to append each index
     *     onto the padding content as it is filled out.
     * @returns {Array} The receiver.
     * @fires Change
     */

    var startIndex,
        len,

        i;

    //  If we've already got the number of places supplied, then just exit.
    if (this.length >= places) {
        return this;
    }

    startIndex = this.length;
    len = places - this.length;

    //  Iterate over the padding indexes, placing the padding content into each
    //  one.
    for (i = startIndex; i < startIndex + len; i++) {
        if (appendIndex) {
            this.atPut(i, padContent + '_' + i);
        } else {
            this.atPut(i, padContent);
        }
    }

    this.changed('length', TP.DELETE,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('removeAt',
function(anIndex) {

    /**
     * @method removeAt
     * @summary Removes the element at the index provided.
     * @param {Number} anIndex The index at which to remove the element.
     * @exception TP.sig.InvalidIndex
     * @returns {Array} The receiver.
     * @fires Change
     */

    var index,

        len;

    index = parseInt(anIndex, 10);
    if (!TP.isNumber(index)) {
        return this.raise('TP.sig.InvalidIndex');
    }

    this.$sortIfNeeded();

    /* eslint-disable no-extra-parens */
    index = (index > 0) ? index : this.normalizeIndex(index);
    /* eslint-enable no-extra-parens */

    len = this.length;

    this.splice(index, 1);

    this.changed('length', TP.DELETE,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('removeAtAll',
function(aCollection) {

    /**
     * @method removeAtAll
     * @summary Removes the elements at the indexes (keys) contained in the
     *     collection provided. Upon completion the remaining elements are
     *     shifted into new positions.
     * @param {TP.api.Collection} aCollection The collection of indexes.
     *     TP.EQUALITY.
     * @exception TP.sig.InvalidCollection
     * @returns {Array} The receiver.
     * @fires Change
     */

    var arr,
        deleted,
        thisref,

        len;

    deleted = 0;
    thisref = this;

    if (TP.isArray(aCollection)) {
        //  we'll be sorting, so make a copy
        arr = aCollection.copy();
    } else {
        if (!TP.canInvoke(aCollection, 'asArray')) {
            return this.raise('TP.sig.InvalidCollection');
        }

        arr = aCollection.asArray();
    }

    if (TP.isEmpty(arr)) {
        return this;
    }

    //  sort the indexes so we can process them in order
    arr.sort();

    len = this.length;

    arr.perform(
        function(index) {
            thisref.splice(thisref.normalizeIndex(index) - deleted, 1);
            deleted++;
        });

    if (deleted > 0) {
        this.changed('length', TP.DELETE,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));
    }

    return this;
});

//  ------------------------------------------------------------------------
//  removeKey                   Kernel
//  ------------------------------------------------------------------------
//  removeKeys                  Kernel
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('transpose',
function() {

    /**
     * @method transpose
     * @summary Transposes the rows and columns of an array whose elements are
     *     other arrays. For example, [[1,2],[3,4],[5,6]] becomes an array
     *     containing [[1,3,5],[2,4,6]].
     * @returns {Object[]} An array containing ordered pairs (or triplets,
     *     quads, etc.) constructed from the receiver and incoming collection
     *     elements.
     */

    var items,
        first;

    //  items is our current "row set"
    items = this.getItems();

    //  peel off the first one so we have a starting array to work with
    first = items.shift();

    //  ask it to merge, which will splice the elements (columns) together
    //  but use apply here so items "unrolls" into an argument list
    return first.merge.apply(first, items);
});

//  ------------------------------------------------------------------------
//  TP.api.OrderedCollection API
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('addAfter',
function(aValue, anItem, aTest) {

    /**
     * @method addAfter
     * @summary Adds the value provided after the element provided.
     * @param {Object} aValue The value to add after anItem.
     * @param {Object} anItem The item located to define the index.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception NotFound
     * @returns {Array} The receiver.
     * @fires Change
     */

    var ind;

    ind = this.getPosition(anItem, 0, aTest);
    if (ind === TP.NOT_FOUND) {
        return this.raise('TP.sig.NotFound');
    }

    return this.addAt(aValue, ind + 1);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('addAllAfter',
function(aCollection, anItem, aTest) {

    /**
     * @method addAllAfter
     * @summary Adds the collection of elements after the element provided.
     * @param {TP.api.Collection} aCollection The collection containing the
     *     elements to add after aValue.
     * @param {Object} anItem The element used to locate the index for the
     *     addition.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception NotFound
     * @returns {Array} The receiver.
     * @fires Change
     */

    var ind;

    ind = this.getPosition(anItem, 0, aTest);
    if (ind === TP.NOT_FOUND) {
        return this.raise('TP.sig.NotFound');
    }

    return this.addAllAt(aCollection, ind + 1);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('addAllBefore',
function(aCollection, anItem, aTest) {

    /**
     * @method addAllBefore
     * @summary Adds the collection of elements before the element equal to the
     *     value provided.
     * @param {TP.api.Collection} aCollection The collection containing the
     *     elements to add before aValue.
     * @param {Object} anItem The element used to locate the insertion index.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception NotFound
     * @returns {Array} The receiver.
     * @fires Change
     */

    var ind;

    ind = this.getPosition(anItem, 0, aTest);
    if (ind === TP.NOT_FOUND) {
        return this.raise('TP.sig.NotFound');
    }

    return this.addAllAt(aCollection, ind);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('addAllFirst',
function(aCollection) {

    /**
     * @method addAllFirst
     * @summary Adds the elements of the collection at the start of the array.
     * @param {TP.api.Collection} aCollection The collection containing the
     *     elements to prepend.
     * @returns {Array} The receiver.
     * @fires Change
     */

    return this.addAllAt(aCollection, 0);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('addAllLast',
function(aCollection) {

    /**
     * @method addAllLast
     * @summary Appends the elements of the collection to the receiver.
     * @param {TP.api.Collection} aCollection The collection containing the
     *     elements to append.
     * @returns {Array} The receiver.
     * @fires Change
     */

    return this.addAllAt(aCollection, this.length);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('addBefore',
function(aValue, anItem, aTest) {

    /**
     * @method addBefore
     * @summary Adds aValue prior to the first occurrence of anItem
     * @param {Object} aValue The value to add before the search element.
     * @param {Object} anItem The element used to locate the insertion point.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception NotFound
     * @returns {Array} The receiver.
     * @fires Change
     */

    var ind;

    ind = this.getPosition(anItem, 0, aTest);
    if (ind === TP.NOT_FOUND) {
        return this.raise('TP.sig.NotFound');
    }

    return this.addAt(aValue, ind);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('addFirst',
function(varargs) {

    /**
     * @method addFirst
     * @summary Adds the values provided to the start of the receiver.
     * @param {arguments} varargs A variable list of arguments.
     * @returns {Array} The receiver.
     * @fires Change
     */

    var len;

    if (arguments.length > 0) {

        len = this.length;
        this.unshift.apply(this, arguments);

        this.changed('length', TP.INSERT,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));
    }

});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('addLast',
function(varargs) {

    /**
     * @method addLast
     * @summary Appends the values provided to the end of the receiver.
     * @param {arguments} varargs A variable list of arguments.
     * @returns {Array} The receiver.
     * @fires Change
     */

    var len;

    if (arguments.length > 0) {

        len = this.length;
        this.push.apply(this, arguments);

        this.changed('length', TP.INSERT,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));
    }

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('after',
function(anItem, aTest) {

    /**
     * @method after
     * @summary Returns the element, if any, after the element provided.
     * @param {Object} anItem The item to search for.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception NotFound
     * @returns {Object} An object or undefined.
     */

    var ind;

    ind = this.getPosition(anItem, 0, aTest);
    if (ind === TP.NOT_FOUND) {
        return;
    }

    return this.at(ind + 1);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('before',
function(anItem, aTest) {

    /**
     * @method before
     * @summary Returns the element, if any, before the element provided.
     * @param {Object} anItem The item to search for.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception NotFound
     * @returns {Object} An object or undefined.
     */

    var ind;

    ind = this.getPosition(anItem, 0, aTest);
    if (ind === TP.NOT_FOUND || ind === 0) {
        return;
    }

    return this.at(ind - 1);
});

//  ------------------------------------------------------------------------
//  first                       Kernel
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('getLastPosition',
function(anItem, startIndex, aTest) {

    /**
     * @method getLastPosition
     * @summary Returns the last index of anItem in the receiver.
     * @param {Object} anItem The item to search for.
     * @param {Number} startIndex What index should search "start" from keeping
     *     in mind that we're working backwards so this will be the "last" index
     *     that is checked.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Number} The last index of the element equal to anItem.
     */

    var found,
        item,
        i,
        len,
        test;

    found = TP.NOT_FOUND;

    test = aTest === TP.IDENTITY ? TP.identical : TP.equal;

    len = this.getSize();
    for (i = len - 1; i >= 0; i--) {
        item = this.at(i);
        if (test(item, anItem)) {
            found = i;
            break;
        }
    }

    return found;
});

//  ------------------------------------------------------------------------
//  last                        Kernel
//  ------------------------------------------------------------------------
//  orderedBy                   Kernel
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('removeFirst',
function(anItem, aTest) {

    /**
     * @method removeFirst
     * @summary Removes the first occurrence of anItem in the receiver.
     * @param {Object} anItem The item to remove.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Array} The receiver.
     * @fires Change
     */

    var ind,

        len;

    ind = this.getPosition(anItem, 0, aTest);
    if (ind !== TP.NOT_FOUND) {

        len = this.length;

        this.splice(ind, 1);

        this.changed('length', TP.DELETE,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));
    }

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('removeLast',
function(anItem, aTest) {

    /**
     * @method removeLast
     * @summary Removes the last occurrence of anItem in the receiver, or the
     *     last element if no specific element is provided.
     * @param {Object} anItem The item to remove.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Array} The receiver.
     * @fires Change
     */

    var len,

        ind;

    len = this.length;

    if (TP.notValid(anItem)) {
        this.length = this.length - 1;

        this.changed('value', TP.DELETE,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));
    } else {
        ind = this.getLastPosition(anItem, this.getSize(), aTest);

        if (ind !== TP.NOT_FOUND) {
            this.splice(ind, 1);

            this.changed('value', TP.DELETE,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('replaceFirst',
function(oldValue, newValue, aTest) {

    /**
     * @method replaceFirst
     * @summary Replaces the first element having the value oldValue with an
     *     element having the value newValue.
     * @param {Object} oldValue The old value to look for.
     * @param {Object} newValue The new value to replace the old value with.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Array} The receiver.
     * @fires Change
     */

    var index;

    index = this.getPosition(oldValue, 0, aTest);
    if (index === TP.NOT_FOUND) {
        return this;
    }

    this.atPut(index, newValue);

    return this;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('replaceLast',
function(oldValue, newValue, aTest) {

    /**
     * @method replaceLast
     * @summary Replaces the last element having the value oldValue with an
     *     element having the value newValue.
     * @param {Object} oldValue The old value to look for.
     * @param {Object} newValue The new value to replace the old value with.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Array} The receiver.
     * @fires Change
     */

    var index;

    index = this.getLastPosition(oldValue, aTest);
    if (index === TP.NOT_FOUND) {
        return this;
    }

    this.atPut(index, newValue);

    return this;
});

//  ------------------------------------------------------------------------
//  reverse                     built-in
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  TP.api.SortedCollection
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('getSortFunction',
function() {

    /**
     * @method getSortFunction
     * @summary Returns the current sort function or null.
     * @returns {Function} This array's sort function.
     */

    return this.sortFunction;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('isSorted',
function() {

    /**
     * @method isSorted
     * @summary Returns true if the receiver is sorted.
     * @returns {Boolean}
     */

    return !this.$needsSort;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('setSortFunction',
function(aFunction) {

    /**
     * @method setSortFunction
     * @summary Sets the receiver's internal sort function.
     * @description This function will be called any time the receiver has been
     *     updated without being sorted and a request for a value is made. This
     *     method will flag the receiver so that a re-sort will occur on the
     *     next data access call.
     * @param {Function} aFunction The function to set this array's sort
     *     function to.
     * @exception TP.sig.InvalidFunction
     * @returns {Array} The receiver.
     * @fires Change
     */

    //  no change? don't waste time
    if (TP.identical(aFunction, this.sortFunction)) {
        return this;
    }

    this.sortFunction = aFunction;
    this.$firstSort = true;

    //  notify, since our order will be different for consumers
    this.changed('order', TP.SORTED);

    return this;
});

//  ------------------------------------------------------------------------
//  sort                        built-in
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  Math
//  ------------------------------------------------------------------------

Array.Inst.defineMethod('avg',
function() {

    /**
     * @method avg
     * @summary Returns the average value from an array of numbers. This is
     *     equivalent to sum()/getSize();
     * @returns {Number} The average of numeric values in the receiver.
     */

    return this.sum() / this.getSize();
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('max',
function() {

    /**
     * @method max
     * @summary Returns the numerical maximum value from the receiver.
     * @returns {Number} The highest value number in the receiver.
     */

    return this.detectMax(TP.RETURN_ARG0);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('min',
function() {

    /**
     * @method min
     * @summary Returns the numerical minimum value from the receiver.
     * @returns {Number} The lowest value number in the receiver.
     */

    return this.detectMin(TP.RETURN_ARG0);
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('sum',
function() {

    /**
     * @method sum
     * @summary Adds the numeric values in the receiver to produce a sum.
     * @returns {Number} The sum of all numeric values in the receiver.
     */

    var sum;

    sum = 0;
    sum = this.injectInto(
        sum,
        function(item, accum, index) {

            var num;

            num = parseInt(item, 10);
            if (TP.isNumber(num)) {
                return accum + num;
            }

            return accum;
        });

    return sum;
});

//  ------------------------------------------------------------------------

Array.Inst.defineMethod('times',
function(aCount, inline) {

    /**
     * @method times
     * @summary Expands the receiver's content multiple times. For example, an
     *     array containing 1,2,3 * 3 becomes 1,2,3,1,2,3,1,2,3.
     * @param {Number} aCount The number of times to duplicate the receiver's
     *     content.
     * @param {Boolean} inline False to construct a new instance, otherwise the
     *     receiver is modified.
     * @returns {Array|Object[]} The receiver, or a new instance if inline is
     *     false.
     */

    var arr,
        dat;

    if (aCount < 2) {
        return TP.isFalse(inline) ? this.copy() : this;
    }

    /* eslint-disable consistent-this */
    if (TP.isFalse(inline)) {
        dat = this;
        arr = this.copy();
    } else {
        dat = this.copy();
        arr = this;
    }
    /* eslint-enable consistent-this */

    (aCount - 1).perform(
            function() {
                arr.addAll(dat);
            });

    return arr;
});

//  ========================================================================
//  Object Extensions
//  ========================================================================

/**
 * @type {Object}
 * @summary Collection API extensions for Object.
 * @description Because of the problems associated with keeping a clear
 *     distinction between keys which are "content" and keys which are
 *     "properties" we _STRONGLY_ discourage using Objects as hashes. But for
 *     polymorphic reasons we add a few methods in the kernel so if you get an
 *     Object rather than a TP.core.Hash once in a while it hopefully won't
 *     cause everything to break.
 * @subject Collection Extensions
 */

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.defineCommonMethod('collapse',
function() {

    /**
     * @method collapse
     * @summary Returns the receiver.
     * @description This method is defined purely for polymorphic reasons so
     *     that the system can just send 'collapse' to any object. For Arrays
     *     and other collections, the first item is returned.
     * @returns {Object} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('asHash',
function() {

    /**
     * @method asHash
     * @summary Returns the receiver as a suitable hash.
     * @returns {TP.core.Hash} The receiver as a TP.core.Hash.
     */

    var dict;

    dict = TP.hc();

    this.perform(
        function(item, index) {
            dict.atPut(item.first(), item.last(), false);
        });

    return dict;
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('removeKey',
function(aKey) {

    /**
     * @method removeKey
     * @summary Removes the key provided if the collection contains it. Note
     *     that this won't remove a key if the key references a method.
     * @param {Object} aKey The key value to remove.
     * @exception TP.sig.InvalidParameter
     * @returns {Object|undefined} The receiver.
     * @fires Change
     */

    var k;

    if (TP.notValid(aKey)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    k = this.at(aKey);
    if (TP.notDefined(k)) {
        return;
    }

    if (TP.isMethod(k)) {
        return this.raise('TP.sig.InvalidOperation',
            'Attempt to replace/remove method: ' + k);
    }

    delete this[aKey];

    this.changed('value', TP.DELETE);

    return this;
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('removeKeys',
function(aKeyArray) {

    /**
     * @method removeKeys
     * @summary Removes the keys provided if the collection contains them. Note
     *     that this won't remove a key if the key references a method.
     * @param {Object[]} aKeyArray The key values to remove.
     * @exception TP.sig.InvalidParameter
     * @returns {Object} The receiver.
     * @fires Change
     */

    var changed,
        len,
        i,
        key,
        slot;

    if (TP.notValid(aKeyArray)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    changed = false;

    len = aKeyArray.getSize();
    for (i = 0; i < len; i++) {
        key = aKeyArray.at(i);
        slot = this.at(key);

        if (TP.notDefined(slot)) {
            continue;
        }

        if (TP.isMethod(slot)) {
            this.raise('TP.sig.InvalidOperation',
                'Attempt to replace/remove method: ' + slot);
            break;
        }

        changed = true;
        delete this[key];
    }

    if (changed) {
        this.changed('value', TP.DELETE);
    }

    return this;
});

//  ========================================================================
//  Map Extensions
//  ========================================================================

Map.Inst.defineMethod('asString',
function() {
    return this.getItems().asString();
});

//  ------------------------------------------------------------------------

Map.Inst.defineMethod('at',
function(aKey) {
    return this.get(aKey);
});

//  ------------------------------------------------------------------------

Map.Inst.defineMethod('getKeys',
function() {
    return Array.ECMAfrom(this.keys());
});

//  ------------------------------------------------------------------------

Map.Inst.defineMethod('getItems',
function() {
    return Array.ECMAfrom(this.entries());
});

//  ------------------------------------------------------------------------

Map.Inst.defineMethod('getValues',
function() {
    return Array.ECMAfrom(this.values());
});

//  ========================================================================
//  Number Extensions
//  ========================================================================

/**
 * @type {Number}
 * @summary Extensions to Number for collection-related behavior.
 */

//  ------------------------------------------------------------------------
//  Type Definition
//  ------------------------------------------------------------------------

//  don't let numbers get treated like collections unless you want add(123)
//  to result in [1,2,3].
TP.backstop(['asIterator'], TP.NumberProto);

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

Number.Inst.defineMethod('asRange',
function(startIndex, aStep) {

    /**
     * @method asRange
     * @summary Returns a TP.core.Range from startIndex to the receiver by
     *     step.
     * @param {Number} startIndex What index should begin the range. The default
     *     is 0.
     * @param {Number} aStep What step should we use? The default is 1.
     * @returns {TP.core.Range}
     */

    var step,
        start;

    start = TP.ifInvalid(this.normalizeIndex(startIndex), 0);
    step = TP.ifInvalid(aStep, 1);

    /* eslint-disable no-extra-parens */
    return (start).to(this).by(step);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('getItems',
function() {

    /**
     * @method getItems
     * @summary Returns the "values" of the receiver, in this case a
     *     TP.core.Range representing those values suitable for iteration.
     * @returns {TP.core.Range} A range from 0 to N where N is the value of the
     *     receiver.
     */

    return this.asRange();
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('getPosition',
function(aValue) {

    /**
     * @method getPosition
     * @summary Returns the first index of the element provided or undefined if
     *     the element isn't found.
     * @description For numbers this is a bit of a strange concept but it tends
     *     to get invoked when dealing with numerical keys in hashes.
     * @param {Object} aValue What to search for.
     * @returns {Number} The index of the value or undefined.
     */

    return this.toString().getPosition(aValue);
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('times',
function(anObject) {

    /**
     * @method times
     * @summary Performs an operation the number of times defined by the
     *     receiver, for example (10).times(x) will process 'x' ten times.
     * @description The return value of this method will vary based on what type
     *     of object was provided. When a string is passed the return value is
     *     that string's value concatenated that number of times. When a
     *     function is passed this method works like perform() to run the
     *     function a number of times.
     * @param {Object} anObject The object to "multiply".
     * @returns {Object} See the 'discussion' above.
     */

    var count;

    if (TP.notValid(anObject)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  obvious one is math
    count = parseInt(anObject, 10);
    if (TP.isNumber(count)) {
        return this * count;
    }

    //  function? do a perform then
    if (TP.isCallable(anObject)) {
        return this.perform(anObject);
    }

    //  less obvious is do "double dispatch" here and let the type handle it
    if (TP.canInvoke(anObject, 'times')) {
        return anObject.times(this);
    }

    //  not sure what else to do here, just return as if multiplied by 1
    return this;
});

//  ------------------------------------------------------------------------

Number.Inst.defineMethod('to',
function(endIndex) {

    /**
     * @method to
     * @summary Constructs a range from the receiver to the number provided.
     * @param {Number} endIndex A numerical index for the end of the range.
     * @exception TP.sig.TypeNotFound
     * @returns {TP.core.Range} A newly constructed TP.core.Range.
     */

    var type;

    if (TP.notValid(type = TP.sys.getTypeByName('TP.core.Range'))) {
        return this.raise('TP.sig.TypeNotFound');
    }

    return type.construct(this, endIndex);
});

//  ========================================================================
//  Set Extensions
//  ========================================================================

Set.Inst.defineMethod('asString',
function() {
    return this.getValues().asString();
});

//  ------------------------------------------------------------------------

Set.Inst.defineMethod('getKeys',
function() {
    return Array.ECMAfrom(this.keys());
});

//  ------------------------------------------------------------------------

Set.Inst.defineMethod('getItems',
function() {
    return Array.ECMAfrom(this.entries());
});

//  ------------------------------------------------------------------------

Set.Inst.defineMethod('getValues',
function() {
    return Array.ECMAfrom(this.values());
});

//  ========================================================================
//  String Extensions
//  ========================================================================

/**
 * @type {String}
 * @summary Extensions allowing strings to perform more powerful operations.
 *     NOTE that we don't implement any of the mutation methods since native
 *     String types aren't mutable.
 * @subject Collection Extensions
 */

//  ------------------------------------------------------------------------

String.Inst.defineMethod('$$isPair',
function() {

    /**
     * @method $$isPair
     * @summary Returns true if the receiver can be thought of as an ordered
     *     pair. Strings are never considered ordered pairs.
     * @returns {Boolean} Whether or not the receiver is considered to be an
     *     ordered pair. For Strings, this is always false.
     */

    return false;
});

//  ------------------------------------------------------------------------
//  TP.api.Collection
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  add                         Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  addAll                      Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  addAllIfAbsent              Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  addIfAbsent                 Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  addItem                     Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  addWithCount                Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  asArray                     Kernel
//  ------------------------------------------------------------------------

String.Inst.defineMethod('asHash',
function() {

    /**
     * @method asHash
     * @summary Returns the receiver as a TP.core.Hash.
     * @returns {TP.core.Hash} The receiver converted into a TP.core.Hash.
     */

    var str;

    //  Make sure to '.toString()' this to get the primitive value.
    str = this.toString();

    if (TP.isJSONString(str)) {
        return TP.json2js(str);
    } else {
        return TP.hc('value', str);
    }
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asIterator',
function(aStep) {

    /**
     * @method asIterator
     * @summary Returns a new iterator on the receiver.
     * @param {Number} aStep Defines the increment size the iteration should
     *     use. The default value is 1.
     * @returns {TP.core.Iterator} The new iterator.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asRange',
function() {

    /**
     * @method asRange
     * @summary Returns a new TP.core.Range based on the size of the receiver.
     * @exception TP.sig.TypeNotFound
     * @returns {TP.core.Range} The receiver as a range.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------
//  asString                    Kernel
//  ------------------------------------------------------------------------

String.Inst.defineMethod('collapse',
function() {

    /**
     * @method collapse
     * @summary Returns the "simplest" form of the receiver possible, meaning
     *     that when the receiver has only one item that item is returned,
     *     otherwise the receiver is returned.
     * @returns {String|Object|null} The receiver or its single item or null if
     *     empty.
     */

    if (this.getSize() === 1) {
        return this.charAt(0);
    }

    if (TP.isEmpty(this)) {
        return null;
    }

    return this;
});

//  ------------------------------------------------------------------------
//  collect                     Kernel
//  ------------------------------------------------------------------------
//  collectGet                  Kernel
//  ------------------------------------------------------------------------
//  collectInvoke               Kernel
//  ------------------------------------------------------------------------
//  compact                     Kernel
//  ------------------------------------------------------------------------
//  conform                     Kernel
//  ------------------------------------------------------------------------

String.Inst.defineMethod('contains',
function(aValue) {

    /**
     * @method contains
     * @summary Returns true if the receiver contains the value.
     * @param {String} aValue The value that at least one element in the
     *     receiver should be equal to for this method to return true.
     * @returns {Boolean} Whether or not the receiver contains the value
     *     provided.
     */

    return this.indexOf(aValue) !== TP.NOT_FOUND;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('containsAll',
function(aCollection) {

    /**
     * @method containsAll
     * @summary Returns true if all the values in the collection provided are
     *     found in the receiver.
     * @param {TP.api.Collection} aCollection The collection of elements all of
     *     which must be equal to at least one element in the receiver for this
     *     method to return true.
     * @exception TP.sig.InvalidCollection
     * @returns {Boolean} Whether or not the receiver contains all of the values
     *     in the collection provided.
     */

    var arr,
        found,
        thisref;

    if (TP.isArray(aCollection)) {
        arr = aCollection;
    } else {
        if (!TP.canInvoke(aCollection, 'asArray')) {
            return this.raise('TP.sig.InvalidCollection');
        }

        arr = aCollection.asArray();
    }

    if (TP.isEmpty(arr)) {
        return false;
    }

    thisref = this;

    found = arr.detect(
        function(item, index) {

            return TP.notTrue(thisref.contains(item));
        });

    //  if we found a "failed" element then no, we don't
    return TP.notValid(found);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('containsAny',
function(aCollection) {

    /**
     * @method containsAny
     * @summary Returns true if any of the values in the collection provided
     *     are found in the receiver.
     * @param {TP.api.Collection} aCollection The collection of elements any of
     *     which must be equal to any element in the receiver for this method to
     *     be true.
     * @exception TP.sig.InvalidCollection
     * @returns {Boolean} Whether or not the receiver contains any of the values
     *     in the collection provided.
     */

    var arr,
        found,
        thisref;

    if (TP.isArray(aCollection)) {
        arr = aCollection;
    } else {
        if (!TP.canInvoke(aCollection, 'asArray')) {
            return this.raise('TP.sig.InvalidCollection');
        }

        arr = aCollection.asArray();
    }

    if (TP.isEmpty(arr)) {
        return false;
    }

    thisref = this;

    found = arr.detect(
        function(item, index) {

            return thisref.contains(item);
        });

    return TP.isValid(found);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('containsString',
function(aValue) {

    /**
     * @method containsString
     * @summary Returns true if the receiver contains the string provided.
     * @param {String} aValue The value that at least one element in the
     *     receiver should be equal to for this method to return true.
     * @returns {Boolean} Whether or not the receiver contains the String
     *     provided.
     */

    return this.indexOf(aValue) !== TP.NOT_FOUND;
});

//  ------------------------------------------------------------------------
//  convert                     Mutator - not implemented for String
//  ------------------------------------------------------------------------

String.Inst.defineMethod('countOf',
function(aValue, aTest) {

    /**
     * @method countOf
     * @summary Returns a count of the number of times aValue is found in the
     *     string.
     * @param {String} aValue The value that elements in the string must be
     *     equal to to be counted.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Number} The number of occurrences of aValue.
     */

    return this.getPositions(aValue).getSize();
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('detect',
function(aFunction, startIndex) {

    /**
     * @method detect
     * @summary Returns the first element in the receiver which matches the
     *     criteria provided or null if the element isn't found.
     * @param {Function} aFunction A function which should return true if the
     *     element it is passed passes the function's test, or false if it does
     *     not.
     * @param {Number} startIndex A starting index for the search.
     * @returns {Object} The element detected or undefined.
     */

    var retval,
        start,
        len,
        i,
        c;

    start = TP.ifInvalid(this.normalizeIndex(startIndex), 0);

    retval = undefined;

    len = this.length;
    for (i = start; i < len; i++) {
        c = this.charAt(i);
        if (aFunction(c, i)) {
            retval = c;
            break;
        }
    }

    return retval;
});

//  ------------------------------------------------------------------------
//  detectInvoke                Kernel
//  ------------------------------------------------------------------------
//  detectMax                   Kernel
//  ------------------------------------------------------------------------
//  detectMin                   Kernel
//  ------------------------------------------------------------------------

String.Inst.defineMethod('difference',
function(aCollection, aTest) {

    /**
     * @method difference
     * @summary Returns the elements contained in the receiver which are not in
     *     the collection provided.
     * @description This method can be thought of as subtracting all elements
     *     found in the collection provided from the receiver. What's left are
     *     those elements unique to the receiver.
     * @param {TP.api.Collection} aCollection The collection to difference
     *     against the receiver.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception TP.sig.InvalidCollection
     * @returns {String} The difference between aCollection and the receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('disjunction',
function(aCollection, aTest) {

    /**
     * @method disjunction
     * @summary Returns the 'symmetric difference' or those elements which are
     *     disjunct between the two collections.
     * @description This method returns a new string containing the disjunction
     *     between the receiver and aCollection. This means that only those
     *     characters which occur in one of the collections but not the other
     *     are returned.
     * @param {TP.api.Collection} aCollection The collection to disjunct against
     *     the receiver.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {String} The disjunction of aCollection and the receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------
//  empty                       Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  flatten                     Kernel
//  ------------------------------------------------------------------------

String.Inst.defineMethod('getIterator',
function() {

    /**
     * @method getIterator
     * @summary Returns the receiver's internal iterator. If no iterator exists
     *     a new one is constructed and assigned. You shouldn't count on the
     *     iterator being at the start() when you receive it. If you need
     *     multiple iterators use asIterator().
     * @returns {TP.core.Iterator} An iterator on the receiver.
     */

    if (TP.notValid(this.$get('iterator'))) {
        this.$set('iterator', this.asIterator());
    }

    return this.$get('iterator');
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('getIteratorType',
function() {

    /**
     * @method getIteratorType
     * @summary Returns the type of iterator used for the receiver.
     * @returns {TP.core.Iterator} The type of the iterator.
     */

    var type;

    if (TP.notValid(type = TP.sys.getTypeByName('TP.core.Iterator'))) {
        return this.raise('TP.sig.TypeNotFound');
    }

    return type;
});

//  ------------------------------------------------------------------------
//  getSize                     Kernel
//  ------------------------------------------------------------------------
//  getValues                   Kernel
//  ------------------------------------------------------------------------
//  grep                        Kernel
//  ------------------------------------------------------------------------
//  groupBy                     Kernel
//  ------------------------------------------------------------------------
//  injectInto                  Kernel
//  ------------------------------------------------------------------------

String.Inst.defineMethod('intersection',
function(aCollection) {

    /**
     * @method intersection
     * @summary Returns the intersection of the two collections.
     * @description This method returns a collection of those elements which
     *     occur in BOTH the receiver and in aCollection.
     * @param {TP.api.Collection} aCollection The collection to intersect the
     *     receiver with.
     * @exception TP.sig.InvalidCollection
     * @returns {Object[]} An array of elements occurring in both.
     */

    if (!TP.canInvoke(aCollection, 'contains')) {
        return this.raise('TP.sig.InvalidCollection');
    }

    return this.select(
        function(item) {

            return aCollection.contains(item);
        });
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('isSortedCollection',
function() {

    /**
     * @method isSortedCollection
     * @summary Returns true if the receiver is a sorted collection. String
     *     subtypes are NOT sorted.
     * @returns {Boolean} Always false.
     */

    return false;
});

//  ------------------------------------------------------------------------
//  merge                       Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  partition                   Kernel
//  ------------------------------------------------------------------------
//  perform                     Kernel
//  ------------------------------------------------------------------------
//  performInvoke               Kernel
//  ------------------------------------------------------------------------
//  performSet                  Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  performUntil                Kernel
//  ------------------------------------------------------------------------
//  performWhile                Kernel
//  ------------------------------------------------------------------------
//  performWith                 Kernel
//  ------------------------------------------------------------------------
//  reject                      Kernel
//  ------------------------------------------------------------------------
//  remove                      Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  removeAll                   Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  replace                     Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  replaceAll                  Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  select                      Kernel
//  ------------------------------------------------------------------------

String.Inst.defineMethod('union',
function(aCollection) {

    /**
     * @method union
     * @summary Returns a new string containing the members of both strings.
     * @description This method computes a new string of characters, placing
     *     into it all characters from this string and all elements from
     *     aCollection.
     * @param {TP.api.Collection} aCollection The other collection to union this
     *     string against.
     * @exception TP.sig.InvalidCollection
     * @returns {Object[]} The new string containing elements from both
     *     collections.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------
//  unique                      Mutator - not implemented for String
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  TP.api.IndexedCollection
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  addAt                       Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  addAllAt                    Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  at                          Kernel
//  ------------------------------------------------------------------------

String.Inst.defineMethod('atAll',
function(aCollection) {

    /**
     * @method atAll
     * @summary Returns a new collection containing the characters in the
     *     receiver at the various indexes contained in the collection provided.
     * @param {TP.api.Collection} aCollection The collection of numeric indices
     *     to use.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidCollection
     * @returns {String[]} An array of zero or more items.
     */

    return this.split('').atAll(aCollection);
});

//  ------------------------------------------------------------------------
//  atAllPut                    Mutator - not implemented for String
//  ------------------------------------------------------------------------

String.Inst.defineMethod('atIfInvalid',
function(anIndex, aDefault) {

    /**
     * @method atIfInvalid
     * @summary Returns the value at the index provided or the default value if
     *     the key returns an invalid value.
     * @description If a Function is supplied as the default value to this
     *     method, it will be executed and its value will be returned as the
     *     value. Therefore, this method cannot be used if the Function object
     *     itself is what is desired as the returned value.
     * @param {Number} anIndex The index of the value to return.
     * @param {Object} aDefault The default value to return if undefined.
     *     Functions are executed to return their value in response.
     * @returns {Object} The element at anIndex in this collection.
     */

    var value;

    if (TP.isValid(value = this.at(anIndex))) {
        return value;
    } else if (TP.isCallable(aDefault)) {
        return aDefault();
    } else {
        return aDefault;
    }
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('atIfNull',
function(anIndex, aDefault) {

    /**
     * @method atIfNull
     * @summary Returns the value at the index provided or the default value if
     *     the key returns null (and not undefined).
     * @description If a Function is supplied as the default value to this
     *     method, it will be executed and its value will be returned as the
     *     value. Therefore, this method cannot be used if the Function object
     *     itself is what is desired as the returned value.
     * @param {Number} anIndex The index of the value to return.
     * @param {Object} aDefault The default value to return if undefined.
     *     Functions are executed to return their value in response.
     * @returns {Object} The element at anIndex in this collection.
     */

    var value;

    if (TP.notNull(value = this.at(anIndex))) {
        return value;
    } else if (TP.isCallable(aDefault)) {
        return aDefault();
    } else {
        return aDefault;
    }
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('atIfUndefined',
function(anIndex, aDefault) {

    /**
     * @method atIfUndefined
     * @summary Returns the value at the index provided or the default value if
     *     the key returns undefined.
     * @description If a Function is supplied as the default value to this
     *     method, it will be executed and its value will be returned as the
     *     value. Therefore, this method cannot be used if the Function object
     *     itself is what is desired as the returned value.
     * @param {Number} anIndex The index of the value to return.
     * @param {Object} aDefault The default value to return if undefined.
     *     Functions are executed to return their value in response.
     * @returns {Object} The element at anIndex in this collection.
     */

    var value;

    if (TP.isDefined(value = this.at(anIndex))) {
        return value;
    } else if (TP.isCallable(aDefault)) {
        return aDefault();
    } else {
        return aDefault;
    }
});

//  ------------------------------------------------------------------------
//  atPut                       Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  atPutIfAbsent               Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  containsKey                 Kernel
//  ------------------------------------------------------------------------
//  containsValue               Kernel
//  ------------------------------------------------------------------------

String.Inst.defineMethod('detectKeyAt',
function(aKey, anIndex) {

    /**
     * @method detectKeyAt
     * @summary Searches for the first nested element whose value at(anIndex)
     *     matches aKey. This can be a useful detection for finding data in an
     *     ordered collection (array, sorted hash, or node) by the value at a
     *     particular index or attribute location.
     * @param {String|RegExp} aKey The string or regular expression selector to
     *     match with.
     * @param {Number} anIndex The "column" index to check in each nested array.
     * @returns {String[]} The nested array whose value at anIndex matches aKey.
     */

    var index;

    index = TP.ifInvalid(anIndex, 0);

    return this.detect(
        function(obj) {

            if (!TP.isArray(obj)) {
                return;
            }

            return TP.isValid(aKey.match(obj.at(index)));
        });
});

//  ------------------------------------------------------------------------
//  getKeys                     Kernel
//  ------------------------------------------------------------------------
//  getKVPairs                  Kernel
//  ------------------------------------------------------------------------

String.Inst.defineMethod('getPosition',
function(anItem, startIndex) {

    /**
     * @method getPosition
     * @summary Returns the first index of anItem in the receiver.
     * @param {Object} anItem The element to search for.
     * @param {Number} startIndex The index to start looking for anItem.
     * @returns {Number} The first index of an element equal to anItem.
     */

    return this.indexOf(anItem, startIndex);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('getPositions',
function(aValue, startIndex) {

    /**
     * @method getPositions
     * @summary Returns a collection of all indexes where the value is found.
     * @param {String} aValue The character to look for.
     * @param {Number} startIndex The index to start looking for aValue.
     * @returns {Number[]} An array containing indexes for the value provided.
     *     May be empty.
     */

    var tmparr,
        start;

    tmparr = TP.ac();

    start = this.indexOf(aValue, startIndex);
    while (start !== TP.NOT_FOUND) {
        tmparr.add(start);
        start = this.indexOf(aValue, start + 1);
    }

    return tmparr;
});

//  ------------------------------------------------------------------------
//  grepKeys                    Kernel
//  ------------------------------------------------------------------------
//  performOver                 Kernel
//  ------------------------------------------------------------------------
//  removeAt                    Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  removeAtAll                 Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  removeKey                   Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  removeKeys                  Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  transpose                   Mutator - not implemented for String
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  TP.api.OrderedCollection
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  addAfter                    Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  addAllAfter                 Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  addAllBefore                Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  addAllFirst                 Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  addAllLast                  Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  addBefore                   Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  addFirst                    Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  addLast                     Mutator - not implemented for String
//  ------------------------------------------------------------------------

String.Inst.defineMethod('after',
function(substring) {

    /**
     * @method after
     * @summary Returns the portion of the receiver after the substring
     *     provided.
     * @param {String} substring The substring to search for.
     * @returns {String|undefined} The next element or undefined.
     */

    var ind;

    ind = this.indexOf(substring);
    if (ind === TP.NOT_FOUND) {
        return;
    }

    return this.slice(ind + substring.getSize(), this.getSize());
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('before',
function(substring) {

    /**
     * @method before
     * @summary Returns the portion of the receiver preceding the substring
     *     provided.
     * @param {String} substring The substring to search for.
     * @returns {String|undefined} The previous substring.
     */

    var ind;

    ind = this.indexOf(substring);
    if (ind === TP.NOT_FOUND) {
        return;
    }

    return this.slice(0, ind);
});

//  ------------------------------------------------------------------------
//  first                       Kernel
//  ------------------------------------------------------------------------

String.Inst.defineMethod('getLastPosition',
function(anItem, startIndex, aTest) {

    /**
     * @method getLastPosition
     * @summary Returns the last index of anItem in the receiver.
     * @param {Object} anItem The element to search for.
     * @param {Number} startIndex The index to start looking for anItem.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY.
     *     Ignore for this type.
     * @returns {Number} The last index of an element equal to anItem.
     */

    return this.lastIndexOf(anItem, startIndex);
});

//  ------------------------------------------------------------------------
//  last                        Kernel
//  ------------------------------------------------------------------------
//  orderedBy                   Kernel
//  ------------------------------------------------------------------------
//  removeFirst                 Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  removeLast                  Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  replaceFirst                Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  replaceLast                 Mutator - not implemented for String
//  ------------------------------------------------------------------------
//  reverse                     Mutator - not implemented for String
//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.core.Hash
//  ========================================================================

/**
 * @type {TP.core.Hash}
 * @summary Collection-oriented API's for TP.core.Hash base class.
 * @description TIBET's hash (dictionary, associative array) type. You should
 *     always use a TP.core.Hash (available via TP.hc()) when dealing with data
 *     in key/value form. In TIBET it's a dangerous, and potentially slow
 *     practice to use a regular object ({}) as a hash. We recommend you never
 *     use an Object as a hash since there's no clear separation between
 *     properties that represent content and those that represent the state
 *     and/or behavior of the hash itself. In addition, iteration on a standard
 *     object in TIBET using for/in can be quite slow.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.Hash');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  NOTE: Make sure this parser is installed first! Because of ambiguities
//  in syntax, the URI parsers below will also match a 'style string' and we
//  want to give one first crack at it.
TP.core.Hash.Type.defineConstant('STYLE_STRING_PARSER',
function(aString) {

    /**
     * @method STYLE_STRING_PARSER
     * @summary A parse function specific to CSS style strings.
     * @description The input is checked for conformance to key:value; syntax
     *     and parsed into a valid hash if it matches. In addition the keys are
     *     converted into their proper DOM equivalents so that 'float' in CSS
     *     becomes 'cssFloat' in the hash.
     * @param {String} aString A valid CSS style string.
     * @returns {TP.core.Hash} A new instance.
     */

    var dict;

    TP.regex.STYLE_STRING.lastIndex = 0;
    if (TP.regex.STYLE_STRING.test(aString)) {
        dict = TP.hc();
        TP.regex.STYLE_STRING.performWith(
            function(whole, key, value, index, str) {

                var styleKey;

                //  don't make keys of undefined, and don't let trailing ;
                //  mess things up if the regex matched to that separator

                /* eslint-disable no-extra-parens */
                if ((styleKey = key.strip(';').asDOMName())) {
                    dict.atPut(styleKey, value);
                }
                /* eslint-enable no-extra-parens */
            }, aString);
    } else {
        //  We don't match a style string.
        return null;
    }

    return dict;
});

//  ------------------------------------------------------------------------

TP.core.Hash.addParser(TP.core.Hash.STYLE_STRING_PARSER);

//  ------------------------------------------------------------------------

TP.core.Hash.Type.defineConstant('ATTRIBUTE_STRING_PARSER',
function(aString) {

    /**
     * @method ATTRIBUTE_STRING_PARSER
     * @summary A parse function specific to XML attribute strings.
     * @description The input is checked for conformance to key="value" syntax
     *     and parsed into a valid hash if it matches.
     * @param {String} aString A valid XML attribute string.
     * @returns {TP.core.Hash} A new instance.
     */

    var dict;

    TP.regex.ATTRIBUTE_STRING.lastIndex = 0;
    if (TP.regex.ATTRIBUTE_STRING.test(aString)) {
        dict = TP.hc();
        TP.regex.ATTRIBUTE_STRING.performWith(
            function(whole, key, quoteChar, value, index, str) {

                //  don't make keys of undefined
                if (TP.notEmpty(key)) {
                    dict.atPut(key, value);
                }
            }, aString);
    } else {
        //  We don't match an attribute string.
        return null;
    }

    return dict;
});

//  ------------------------------------------------------------------------

TP.core.Hash.addParser(TP.core.Hash.ATTRIBUTE_STRING_PARSER);

//  ------------------------------------------------------------------------

TP.core.Hash.Type.defineConstant('URI_STRING_PARSER',
function(aString) {

    /**
     * @method URI_STRING_PARSER
     * @summary A parse function specific to URI strings.
     * @param {String} aString A valid URI string.
     * @returns {TP.core.Hash} A new instance.
     */

    var dict,

        urlRegExp,

        match,
        partNames,

        i,

        queryPart,
        queryDict;

    dict = TP.hc();

    //   The 'scheme' will be the first result here, so if its empty, that
    //   means this wasn't a valid URL.
    if (TP.notEmpty(TP.regex.URI_STRICT.exec(aString).at(1))) {
        urlRegExp = TP.regex.URI_STRICT;
    } else if (TP.notEmpty(TP.regex.URI_LOOSE.exec(aString).at(1))) {
        urlRegExp = TP.regex.URI_LOOSE;
    } else {
        //  We don't match a URI, either strictly or loosely.
        return null;
    }

    //  Run the RegExp and get the match results.
    match = urlRegExp.exec(aString);

    partNames = TP.ac('source',
                        'scheme',
                        'authority',
                            'userInfo', 'user', 'password',
                            'hostname', 'port',
                        'relative',
                            'path',
                                'directory',
                                'file',
                            'query',
                            'fragment');

    //  Now, gather up the pieces by running a replace using a RegExp
    for (i = 0; i < partNames.getSize(); i++) {
        dict.atPut(partNames.at(i),
                    TP.notEmpty(match.at(i)) ? match.at(i) : '');
    }

    //  If we also got a query, construct a TP.core.Hash from it.
    if (TP.notEmpty(queryPart = dict.at('query'))) {
        queryDict = TP.core.Hash.fromString(queryPart);
        dict.atPut('queryDict', queryDict);
    }

    return dict;
});

//  ------------------------------------------------------------------------

TP.core.Hash.addParser(TP.core.Hash.URI_STRING_PARSER);

//  ------------------------------------------------------------------------

TP.core.Hash.Type.defineConstant('QUERY_STRING_PARSER',
function(aString) {

    /**
     * @method QUERY_STRING_PARSER
     * @summary A parse function specific to URI query strings.
     * @description The input is checked for conformance to key=value[&|;]...
     *     syntax and parsed into a valid hash if it matches. NOTE that a
     *     leading ? is allowed, and discarded by this routine (and in fact the
     *     entire URI can be passed to this routine if necessary). This method
     *     automatically decodes query values by calling decodeURIParameter() on
     *     them.
     * @param {String} aString A valid URI query string.
     * @returns {TP.core.Hash} A new instance.
     */

    var dict;

    dict = TP.hc();

    TP.regex.URI_QUERY.lastIndex = 0;
    if (!TP.regex.URI_QUERY.test(aString)) {
        //  We don't match a URI query
        return null;
    }

    TP.regex.URI_QUERY.lastIndex = 0;
    aString.replace(
        TP.regex.URI_QUERY,
        function(wholeMatch, aKey, aValue) {

            if (TP.notEmpty(aKey)) {
                dict.atPut(aKey,
                    TP.ifEmpty(decodeURIComponent(aValue), true));
            }
        });

    return dict;
});

//  ------------------------------------------------------------------------

TP.core.Hash.addParser(TP.core.Hash.QUERY_STRING_PARSER);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.Hash.Type.defineMethod('construct',
function() {

    /**
     * @method construct
     * @summary Construct and return a new hash, populating it with initial
     *     data based on the argument list.
     * @description Input data can be provided in a variety of formats including
     *     an array of ordered pairs, an array of key, value sequences, an
     *     Object (not recommended for speed reasons), a hash of key/value
     *     pairs, or a simple argument list of key, value sequences.
     * @returns {TP.core.Hash} A new instance.
     */

    var newVal,
        obj,
        i,
        pair,
        attrs,
        len,
        val;

    newVal = Object.create(TP.core.Hash.Inst);
    newVal.$$type = TP.core.Hash;

    //  NB: For performance reasons, there are multiple occurrences of setting
    //  the internal hash to an orphan object here. This is due to the desire to
    //  minimize checking and object creation.
    switch (arguments.length) {
        case 0:
            newVal.$$hash = Object.create(null);
            break;

        case 1:
            obj = arguments[0];

            if (TP.notValid(obj)) {
                newVal.$$hash = Object.create(null);
            } else {

                //  If the supplied object is a primitive Hash, just grab the
                //  POJO that's its Hash and process that below.
                if (obj.$$prototype &&
                    obj.$$prototype.constructor === TP.boot.PHash) {
                    obj = obj.$$hash;
                }

                if (TP.isPlainObject(obj) && !TP.isPrototype(obj)) {
                    newVal.$$hash = Object.create(null);
                    TP.objectGetKeys(obj).forEach(
                            function(key) {
                                var value;

                                value = obj[key];
                                if (TP.isPlainObject(value) &&
                                    !TP.isPrototype(value)) {
                                    value = TP.core.Hash.construct(value);
                                }

                                newVal.atPut(
                                    key,
                                    TP.notDefined(value) ? null : value);
                            });
                } else if (TP.isArray(obj)) {
                    //  allocate internal hash - note that it is a
                    //  prototype-less object.
                    newVal.$$hash = Object.create(null);

                    if (TP.isPair(obj[0])) {
                        //  pair syntax [['a', 1], ['b', 2], ['c', 3]]
                        for (i = 0; i < obj.length; i++) {
                            pair = obj[i];
                            val = pair[1];
                            newVal.atPut(
                                pair[0],
                                TP.notDefined(val) ? null : val,
                                false);
                        }
                    } else {
                        //  array syntax ['a', 1, 'b', 2, 'c', 3]
                        for (i = 0; i < obj.length; i += 2) {
                            val = obj[i + 1];
                            newVal.atPut(
                                obj[i],
                                TP.notDefined(val) ? null : val,
                                false);
                        }
                    }
                } else if (TP.isString(obj)) {
                    return TP.core.Hash.fromString(obj);
                } else if (TP.isElement(obj)) {
                    //  allocate internal hash - note that it is a
                    //  prototype-less object.
                    newVal.$$hash = Object.create(null);

                    attrs = obj.attributes;
                    len = attrs.length;

                    for (i = 0; i < len; i++) {
                        newVal.atPut(attrs[i].name, attrs[i].value);
                    }
                } else if (TP.isHash(obj)) {
                    return obj;
                } else {

                    //  JSON conversions can fail so protect against that.
                    try {
                        val = TP.js2json(obj);
                        if (TP.isValid(val)) {
                            val = TP.json2js(val);
                            if (TP.isValid(val)) {
                                //  Note how we grab the '$$hash' prototype-less
                                //  object and make that *our* $$hash.
                                newVal.$$hash = val.$$hash;
                            } else {
                                newVal.$$hash = Object.create(null);
                            }
                        }
                    } catch (e) {
                        return;
                    }
                }
            }
            break;

        default:
            //  allocate internal hash - note that it is a prototype-less
            //  object.
            newVal.$$hash = Object.create(null);

            //  arguments syntax 'a', 1, 'b', 2, 'c', 3
            for (i = 0; i < arguments.length; i += 2) {
                val = arguments[i + 1];
                newVal.$$hash[arguments[i]] = TP.notDefined(val) ? null : val;
            }

            break;
    }

    return newVal;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('hc', TP.core.Hash.construct);

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  The internal hash of this object.
TP.core.Hash.Inst.defineAttribute('$$hash');

//  what delim should be used when joining array elements into a string
TP.core.Hash.Inst.defineAttribute('delimiter', ', ');

//  ------------------------------------------------------------------------

TP.core.Hash.Type.defineMethod('fromObject',
function(anObject) {

    /**
     * @method fromObject
     * @summary Constructs a new hash from the object(s) provided as arguments.
     * @param {Object} anObject The source object.
     * @returns {TP.core.Hash} A new instance.
     */

    //  the constructor handles most everything possible that'll actually
    //  work
    return this.construct(anObject);
});

//  ------------------------------------------------------------------------

TP.core.Hash.Type.defineMethod('fromOrphan',
function(anObject) {

    /**
     * @method fromOrphan
     * @summary Constructs a new hash from the orphan object (i.e. one with no
     *     prototype) provided.
     * @param {Object} anObject An orphan source object.
     * @returns {TP.core.Hash} A new instance.
     */

    var newInst;

    newInst = this.construct();

    newInst.$set('$$hash', TP.copy(anObject), false);

    return newInst;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Type.defineMethod('fromString',
function(anObject) {

    /**
     * @method fromString
     * @summary Constructs a new hash from the String provided.
     * @param {String} anObject The source object.
     * @returns {TP.core.Hash} A new instance.
     */

    var newInst,
        val;

    newInst = this.construct();

    if (TP.isJSONString(anObject)) {

        val = TP.json2js(anObject);
        if (TP.isValid(val)) {
            //  Note how we grab the '$$hash' prototype-less
            //  object and make that *our* $$hash.
            newInst.$set('$$hash', val.$$hash, false);

            return newInst;
        }
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod(Symbol.iterator,
function() {

    /**
     * @method Symbol.iterator
     * @summary The ECMA2015 iterator method that allows TP.core.Hash to be
     *     used in iteration contexts, such as ECMA2015 for...of loops.
     * @description This method allows TP.core.Hash to participate in ECMA2015
     *     iteration contexts. As such, it's 'name' is actually Symbol.iterator
     *     and is not a String. It returns an Object that has one slot: the
     *     'next' Function, per the specification's requirements.
     * @returns {Object} A POJO with a single slot containing the Function that
     *     will be invoked to return the 'next' iterable chunk. Note that for
     *     TP.core.Hash objects, this is a key/value pair.
     */

    var count,
        keys,
        size,

        hash;

    count = 0;
    keys = this.getKeys();
    size = keys.getSize();

    hash = this.$get('$$hash');

    return {
        next: function() {
            var key,
                val;

            if (count < size) {
                key = keys[count];
                val = hash[key];
                count++;
                return {done: false, value: [key, val]};
            } else {
                return {done: true, value: undefined};
            }
        }
    };
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('addAllKeys',
function(aCollection) {

    /**
     * @method addAllKeys
     * @summary Adds all the keys contained in aCollection.
     * @description This is a fast way to get a simple lookup table from an
     *     array. The values are initialized to their index, effectively
     *     inverting the array into the hash. You can use the resulting hash to
     *     do containment checking against a hash key instead of scanning the
     *     original array by using hash.containsKey().
     * @param {TP.api.Collection} aCollection A collection of one or more keys.
     * @returns {TP.core.Hash} The receiver.
     * @fires Change
     */

    var keys,
        hash,
        keyArr,
        i,
        len,
        item;

    if (!TP.canInvoke(aCollection, 'getKeys')) {
        this.raise('TP.sig.InvalidCollection');
        return this;
    }

    keys = TP.isArray(aCollection) ? aCollection : aCollection.getKeys();

    hash = this.$get('$$hash');
    keyArr = this.getKeys();

    len = keys.getSize();
    for (i = 0; i < len; i++) {
        item = keys[i];

        //  If we don't know about this value, or its a property but not on
        //  us.
        if (TP.notDefined(hash[item]) || !TP.owns(hash, item)) {
            hash[item] = i;
        }
    }

    if (len > 0) {
        this.changed('keys', TP.INSERT,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, keyArr.getSize()));
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('asAttributeString',
function() {

    /**
     * @method asAttributeString
     * @summary Returns the receiver in an XML attribute string format, meaning
     *     each key/value pair becomes key="value" and each pair is separated by
     *     a single space. The resulting string is suitable for inclusion in
     *     strings used to construct nodes.
     * @returns {String} The receiver as an attribute String.
     */

    return TP.attributeStringFromHash(this);
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    var marker,
        joinCh,
        joinArr,
        keys,
        len,
        i,
        val,
        str,
        $depth,
        $level;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asDumpString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    joinCh = this.$get('delimiter');

    if (!TP.isString(joinCh)) {
        //  If 'joinCh' is not a String, maybe it's a hash or other Object with
        //  a 'join' property.
        if (!TP.isString(joinCh = joinCh.get('join'))) {
            joinCh = '';
        }
    }

    str = '[' + TP.tname(this) + ' :: ';

    $depth = TP.ifInvalid(depth, 1);
    $level = TP.ifInvalid(level, 0);

    joinArr = TP.ac();

    try {
        keys = TP.keys(this);
        len = keys.getSize();

        for (i = 0; i < len; i++) {

            val = this.at(keys.at(i));

            if (val === this) {
                if (TP.canInvoke(val, 'asRecursionString')) {
                    joinArr.push(
                        TP.join(keys.at(i), ' => ', val.asRecursionString()));
                } else {
                    joinArr.push(TP.join(keys.at(i), ' => this'));
                }
            } else {
                if ($level > $depth && TP.isMutable(val)) {
                    joinArr.push(TP.join(keys.at(i), ' => ',
                        '@' + TP.id(val)));
                } else {
                    joinArr.push(TP.join(keys.at(i), ' => ',
                        TP.dump(val, $depth, $level + 1)));
                }
            }
        }

        str += joinArr.join(joinCh) + ']';
    } catch (e) {
        str += this.toString() + ']';
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver.
     * @returns {String} The receiver in HTML string format.
     */

    var marker,
        joinArr,
        keys,
        len,
        i,
        joinStr;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asHTMLString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    joinArr = TP.ac();

    try {
        keys = TP.keys(this);
        len = keys.getSize();

        for (i = 0; i < len; i++) {
            joinArr.push(
                    TP.join('<span data-name="', keys.at(i), '">',
                            TP.htmlstr(this.at(keys.at(i))),
                            '</span>'));
        }

        joinStr = '<span class="TP_core_Hash">' +
                     joinArr.join('') +
                     '</span>';
    } catch (e) {
        joinStr = this.toString();
    } finally {
        delete this[marker];
    }

    return joinStr;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    var marker,
        joinArr,
        keys,
        len,
        i,
        joinStr;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asJSONSource';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    joinArr = TP.ac();

    try {
        keys = TP.keys(this);
        len = keys.getSize();

        for (i = 0; i < len; i++) {
            joinArr.push(
                    TP.join(keys.at(i).quoted('"'),
                            ':',
                            TP.jsonsrc(this.at(keys.at(i)))));
        }

        joinStr = '{' + joinArr.join(',') + '}';
    } catch (e) {
        joinStr = this.toString();
    } finally {
        delete this[marker];
    }

    return joinStr;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('asObject',
function() {

    /**
     * @method asObject
     * @summary Returns a 'plain JavaScript object' version of the receiver -
     *     and makes sure that any nested content is also converted to its plain
     *     JavaScript equivalent.
     * @returns {Object} The receiver - and its content - as plain JavaScript
     *     objects.
     */

    var marker,
        keys,
        len,
        obj,
        i,
        val;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asObject';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    keys = TP.keys(this);
    len = keys.getSize();
    obj = {};

    try {
        for (i = 0; i < len; i++) {
            val = this.at(keys[i]);

            //  Make sure to recurse in so that we end up with plain Object
            //  versions of all values.
            obj[keys[i]] = TP.obj(val);
        }
    } finally {
        delete this[marker];
    }

    return obj;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('toJSON',
function() {

    /**
     * @method toJSON
     * @summary Returns the object to use in JSON representations.
     * @returns {Object} The object to use in a JSON representation.
     */

    //  Return the plain JS object version of this object.
    return this.asObject();
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} A new String containing the 'pretty print' string of
     *     the receiver.
     */

    var marker,
        joinArr,
        keys,
        len,
        i,
        joinStr;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asPrettyString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    joinArr = TP.ac();

    try {
        keys = TP.keys(this);
        len = keys.getSize();

        for (i = 0; i < len; i++) {
            joinArr.push(
                TP.join('<dt class="pretty key">', keys.at(i), '</dt>',
                        '<dd class="pretty value">',
                            TP.pretty(this.at(keys.at(i))),
                        '</dd>'));
        }

        joinStr = '<dl class="pretty ' + TP.escapeTypeName(TP.tname(this)) +
                        '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' +
                        this.getTypeName() +
                    '</dd>' +
                    joinArr.join('') +
                    '</dl>';
    } catch (e) {
        joinStr = this.toString();
    } finally {
        delete this[marker];
    }


    return joinStr;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('asQueryString',
function(aSeparator, undefVal) {

    /**
     * @method asQueryString
     * @summary Returns the receiver in URI query string form, meaning each
     *     key/value pair becomes key=value and each pair is separated by a
     *     single & or separator as provided.
     * @description This method automatically encodes query values by calling
     *     encodeURIComponent() on them.
     * @param {String} aSeparator The default is '&'.
     * @param {String} undefVal The value to use when a key's value is
     *     undefined.
     * @returns {String} The receiver as a valid query string.
     */

    var delim,
        arr,
        keys,
        thisref,
        len,
        undef;

    if (!TP.isString(delim = aSeparator)) {
        delim = '&';
    }

    undef = TP.ifInvalid(undefVal, '');

    arr = TP.ac();
    thisref = this;

    keys = this.getKeys();
    len = keys.getSize();
    keys.forEach(function(key, index) {
        var val;

        arr.push(key);
        val = thisref.at(key);
        if (TP.isValid(val)) {
            arr.push('=', encodeURIComponent(thisref.at(key)));
        } else if (TP.notEmpty(undef)) {
            arr.push('=', encodeURIComponent(undef));
        }
        if (index < len - 1) {
            arr.push(delim);
        }
    });

    return arr.join('');
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a TIBET source code string.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    var marker,
        keys,
        len,
        arr,
        i;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asSource';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    keys = TP.keys(this);
    len = keys.getSize();
    arr = TP.ac();

    try {
        for (i = 0; i < len; i++) {
            arr.push(
                TP.join(TP.src(keys[i]),
                        ', ',
                        TP.src(this.at(keys[i]))));
        }
    } finally {
        delete this[marker];
    }


    return TP.join('TP.hc(', arr.join(', '), ')');
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('asStyleString',
function() {

    /**
     * @method asStyleString
     * @summary Returns the receiver in CSS style attribute string form,
     *     meaning each key/value pair becomes key:value and each pair is
     *     separated by a single
     * @returns {String} The receiver as a String.
     */

    return TP.styleStringFromHash(this);
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver.
     * @returns {String} The receiver in XML string format.
     */

    var marker,
        joinArr,
        keys,
        len,
        i,
        joinStr;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asXMLString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    joinArr = TP.ac();

    try {
        keys = TP.keys(this);
        len = keys.getSize();

        for (i = 0; i < len; i++) {
            joinArr.push(
                    TP.join('<', keys.at(i), '>',
                            TP.xmlstr(this.at(keys.at(i))),
                            '</', keys.at(i), '>'));
        }

        joinStr = '<instance type="' + TP.tname(this) + '">' +
                     joinArr.join('') +
                     '</instance>';
    } catch (e) {
        joinStr = this.toString();
    } finally {
        delete this[marker];
    }

    return joinStr;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('atAllPutKeys',
function() {

    /**
     * @method atAllPutKeys
     * @summary Assigns the value in each location in the collection to be
     *     equal to the key at that location. This works as an initializer for
     *     certain operations.
     * @returns {Object} The receiver.
     * @fires Change
     */

    this.convert(
        function(it, ind) {
            return it.first();
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('clearTextContent',
function() {

    /**
     * @method clearTextContent
     * @summary Clears out any text content of mutable items in the receiver,
     *     thereby clearing all of the non-mutable (primitive) items and leaving
     *     just the data structure.
     * @returns {TP.core.Hash} The receiver.
     */

    var hash,
        keys,

        len,
        i,
        it;

    hash = this.$get('$$hash');
    keys = this.getKeys();

    len = keys.getSize();
    for (i = 0; i < len; i++) {

        it = this.at(keys.at(i));

        //  Make sure that the item is both mutable and implements a 'clear'
        //  method.
        if (TP.isMutable(it) && TP.canInvoke(it, 'clear')) {
            it.clear();
        } else {
            hash[keys.at(i)] = '';
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('copy',
function(deep, aFilterNameOrKeys, contentOnly) {

    /**
     * @method copy
     * @summary Returns a copy of the receiver. If contentOnly is true then a
     *     TP.core.Hash is returned contains only the content values (key, val,
     *     key, val ...), and no 'special values' on the receiver are copied.
     *     The filter defines which keys are used to select from the receiver.
     * @param {Boolean} [deep=false] True to force clones to be deep.
     * @param {String|String[]} [aFilterNameOrKeys] get*Interface() filter or
     *     key array.
     * @param {Boolean} [contentOnly=true] Copy content only? This parameter is
     *     ignored for this type.
     * @returns {TP.core.Hash} A copy of the receiver.
     */

    var onlyContent,

        newinst,

        filter,
        keys,

        len,
        i,
        ndx,
        val;

    onlyContent = TP.ifInvalid(contentOnly, true);

    newinst = this.getType().construct();

    if (!onlyContent) {
        //  Any reasonable filter should not include '$$hash' or '$$keys'.
        filter = TP.ifInvalid(aFilterNameOrKeys, TP.UNIQUE);

        if (TP.isString(filter)) {
            keys = this.getLocalInterface(filter);
        } else if (TP.isArray(filter)) {
            keys = filter;
        } else {
            //  Unusable filter
            return newinst;
        }

        len = keys.getSize();

        for (i = 0; i < len; i++) {
            ndx = keys.at(i);
            val = this.at(ndx);

            if (TP.isTrue(deep) && TP.isReferenceType(val)) {
                //  NB: We do *not* pass along the filter name or keys here
                val = TP.copy(val, deep, null, contentOnly);
            }

            newinst.$set(ndx, val, false);
        }
    } else {
        if (!TP.isArray(keys = aFilterNameOrKeys)) {
            keys = TP.keys(this);
        }

        len = keys.getSize();

        for (i = 0; i < len; i++) {
            ndx = keys.at(i);
            val = this.at(ndx);

            if (TP.isTrue(deep) && TP.isReferenceType(val)) {
                //  NB: We do *not* pass along the filter name or keys here
                val = TP.copy(val, deep, null, contentOnly);
            }

            newinst.atPut(ndx, val, false);
        }
    }

    return newinst;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('get',
function(attributeName) {

    /**
     * @method get
     * @summary Returns the value of attributeName from the receiver.
     * @description Note that get() operates on the object's methods first and
     *     then searches its content and properties. In other words, if the
     *     receiver has both a method named 'foo' and a key/value pair under the
     *     key 'foo' you won't get the value back, you'll get the result of
     *     getFoo() if that's a valid method for a hash. After methods the
     *     content of the hash is checked, followed by the hash's slots. Use
     *     at() if you want to focus exclusively on the content of the hash and
     *     never acquire method results or property values. Use $get if you want
     *     to focus exclusively on the hash's slot values.
     * @param {String} attributeName The name of the attribute to return.
     * @returns {Object} The value contained in the named attribute on the
     *     receiver.
     */

    var path,
        pathStr,

        args,

        funcName,

        val;

    //  If the attribute name is just '.', then that's the shortcut to just
    //  return ourself.
    if (TP.regex.ONLY_PERIOD.test(attributeName)) {
        return this;
    }

    //  Now we separately test for '$_' here because we need to do a key
    //  check and make sure that we don't have a valid key for '$_'.
    if (TP.regex.ONLY_STDIN.test(attributeName) && !this.hasKey('$_')) {
        return this;
    }

    //  If we got handed an 'access path', then we need to let it handle this.
    if (!TP.isString(attributeName) && attributeName.isAccessPath()) {
        path = attributeName;

        //  If the path's String representation is a simple JS_IDENTIFIER, then
        //  we need to check to see if this is just a TIBET path with a name to
        //  an 'aliased' access path (i.e. 'lastname' -> 'foo.bar.lastname').
        //  So, here we check to see if there is an access path for this simple
        //  identifier and, if there is, we use *that* path as the way to access
        //  the underlying data. NOTE: Unlike other overrides of 'get', we do
        //  NOT check for custom getters and setters here - we treat
        //  TP.core.Hash very specially around get/set and at/atPut.
        if (TP.regex.JS_IDENTIFIER.test(pathStr = path.get('srcPath'))) {
            if (TP.notValid(path = this.getAccessPathFor(pathStr, 'value'))) {
                //  There wasn't a valid access path aliased to that identifier,
                //  so just use the path we were originally going to use.
                path = attributeName;
            }
        }
    } else if (TP.regex.NON_SIMPLE_PATH.test(attributeName)) {
        path = TP.apc(attributeName, TP.hc('shouldCollapse', true));
    }

    if (TP.notValid(path)) {
        //  try common naming convention first
        funcName = 'get' + TP.makeStartUpper(attributeName);
        if (TP.canInvoke(this, funcName)) {
            switch (arguments.length) {
                case 1:
                    return this[funcName]();
                default:
                    args = TP.args(arguments, 1);
                    return this[funcName].apply(this, args);
            }
        }

        //  This part is specific to TP.core.Hash - we check with our internal
        //  hash.
        if (TP.isDefined(val = this.at(attributeName))) {
            return val;
        }
    }

    //  If we got a valid path above or if we have a 'value' facet that has an
    //  access path, then invoke the path.
    if (TP.isValid(path) ||
        TP.isValid(path = this.getAccessPathFor(attributeName, 'value'))) {

        pathStr = path.asString();

        //  If the path is just '.', then that's the shortcut to just return
        //  ourself.
        if (TP.regex.ONLY_PERIOD.test(pathStr)) {
            return this;
        }

        //  Now we separately test for '$_' here because we need to do a key
        //  check and make sure that we don't have a valid key for '$_'.
        if (TP.regex.ONLY_STDIN.test(pathStr) && !this.hasKey('$_')) {
            return this;
        }

        //  Note here how, if we were given more than 1 arguments, we grab all
        //  of the arguments supplied, make our path source the first argument
        //  and invoke with an apply(). Otherwise, we make an Array that has our
        //  path source and our 'path parameters' as the last argument. In both
        //  cases, this is because executeGet() takes varargs (in case the path
        //  is parameterized).
        if (arguments.length > 1) {
            args = TP.args(arguments);
            args.atPut(0, this.getPathSource(path));
        } else {
            args = TP.ac(this.getPathSource(path), this.getPathParameters());
        }

        return path.executeGet.apply(path, args);
    }

    //  let the standard mechanism handle it
    return this.getProperty(attributeName);
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('getContent',
function() {

    /**
     * @method getContent
     * @summary Overrides from supertype to check to see if our internal
     *     content has a slot named 'content'. If so, that is returned.
     *     Otherwise, a standard 'getValue()' is performed.
     * @returns The value of our 'content' slot if we have one.
     */

    if (this.hasKey('content')) {
        return this.at('content');
    }

    //  This is what our supertype does.
    return this.getValue();
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('$getEqualityValue',
function() {

    /**
     * @method $getEqualityValue
     * @summary Returns the value which should be used for testing equality
     *     for the receiver. For hashes, this is the underlying POJO object used
     *     to store values. Note that this does result in a deep compare for
     *     the hash's values.
     * @returns {Object} A value appropriate for use in equality comparisons.
     */

    return this.$get('$$hash');
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('getName',
function() {

    /**
     * @method getName
     * @summary An override of the getName() operation that returns any value
     *     that the receiver has in it's internal hash for the key 'name'. If
     *     one doesn't exist, then this method returns whatever the supertype
     *     returns (which is usually the receiver's OID).
     * @returns {String} The receiver's name.
     */

    var val;

    val = this.at('name');
    if (TP.isValid(val)) {
        return val;
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('getParameters',
function() {

    /**
     * @method getParameters
     * @summary Returns the receiver's parameters. For a TP.core.Hash this
     *     returns the hash itself.
     * @returns {Object} A TP.core.Hash or TP.sig.Request containing parameter
     *     data (typically).
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('getPayload',
function() {

    /**
     * @method getPayload
     * @summary Returns the receiver.
     * @returns {TP.core.Hash} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('hasKey',
function(aKey) {

    /**
     * @method hasKey
     * @summary Returns true if aKey has been defined for the receiver.
     * @param {String} aKey The string key to test for.
     * @returns {Boolean} True if the key is defined.
     */

    //  Note how we use 'TP.FunctionProto.hasOwnProperty.call'... this is due
    //  to the fact that the hash itself is a prototype-less Object and
    //  therefore 'hasOwnProperty' won't exist.
    return TP.FunctionProto.hasOwnProperty.call(this.$get('$$hash'), aKey);
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('$$isPair',
function() {

    /**
     * @method $$isPair
     * @summary This method always returns false for TP.core.Hash.
     * @returns {Boolean} False as TP.core.Hash is never an ordered pair.
     */

    return false;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('populate',
function(propertyHash, defaultSource, defaultsPrompt, onlyMissing) {

    /**
     * @method populate
     * @summary Populates the keys listed in the propertyHash by prompting the
     *     user. Information in the propertyHash provides the keys to populate,
     *     the prompts to use, and optionally the aspects to use when querying
     *     the defaultSource for values.
     * @param {TP.core.Hash} propertyHash A hash whose keys are the names of the
     *     properties to populate and whose values are either the prompts to use
     *     or arrays containing the prompt and the aspect name to use with the
     *     defaultSource for lookups.
     * @param {Object} defaultSource An optional object to query for default
     *     values using the default property name(s) given.
     * @param {Boolean} defaultsPrompt Should the default values be used or be
     *     prompts? Default is false.
     * @param {Boolean} onlyMissing Should all keys be updated or only those
     *     which are missing? Default is true.
     * @returns {TP.core.Hash} The receiver.
     * @example:
            hash.populate(TP.hc('uri', TP.ac('uri', 'Enter Service URI'),
     *                          'password', 'Enter password');
     * @fires Change
     */

    var keys,
        len,
        i,
        key,
        item,
        defkey,
        query,
        fname,
        defval,
        newval;

    keys = TP.keys(propertyHash);
    len = keys.getSize();

    for (i = 0; i < len; i++) {
        key = keys.at(i);

        if (TP.isDefined(this.at(key)) && TP.notFalse(onlyMissing)) {
            continue;
        }

        item = propertyHash.at(key);
        defkey = TP.isArray(item) ? item.first() : key;
        query = TP.isArray(item) ? item.last() : item;

        //  prefer at over get, and make sure it's really callable
        fname = TP.canInvoke(defaultSource, 'at') ? 'at' : 'get';
        if (TP.canInvoke(defaultSource, fname)) {
            defval = defaultSource[fname](defkey);
            if (TP.isValid(defval) && TP.notTrue(defaultsPrompt)) {
                this.atPut(key, defval);

                continue;
            }
        }

        //  NOTE that we're accessing the value of the property hash here
        //  and getting either the prompt (last) or
        newval = prompt(query, defval);

        this.atPut(key, newval);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('$removeInternalKey',
function(aKey) {

    /**
     * @method $removeInternalKey
     * @summary A private method that removes a key from our private, internal
     *     hash.
     * @param {Object} aKey The key value to remove.
     * @returns {TP.core.Hash} The receiver.
     */

    var hash;

    hash = this.$get('$$hash');

    //  Make sure that the supplied key matches a property on our internal hash.
    if (!TP.owns(hash, aKey)) {
        return this;
    }

    delete hash[aKey];

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('removeValue',
function(aValue, aTest) {

    /**
     * @method removeValue
     * @summary Removes the value provided if the collection contains it. This
     *     removes all keys which contain the value.
     * @param {Object} aValue The value to remove.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception TP.sig.InvalidParameter
     * @returns {Object} The receiver.
     * @fires Change
     */

    var tmparr,

        changed,

        len,
        i;

    tmparr = this.getPositions(aValue, aTest);
    if (tmparr.getSize() < 1) {
        return this;
    }

    changed = false;

    len = tmparr.getSize();
    for (i = 0; i < len; i++) {
        this.$removeInternalKey(tmparr.at(i));
        changed = true;
    }

    if (changed) {
        this.changed('value', TP.DELETE);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('replaceKey',
function(oldKey, newKey) {

    /**
     * @method replaceKey
     * @summary Replaces the key/value pair oldKey/value with newKey/value.
     * @param {String} oldKey The old key to find the value with.
     * @param {String} newKey The new key to register the value under.
     * @exception TP.sig.InvalidKey
     * @returns {Object} The receiver.
     * @fires Change
     */

    var val,
        shouldSignal;

    if (TP.isEmpty(oldKey) || TP.isEmpty(newKey)) {
        return this.raise('TP.sig.InvalidKey');
    }

    //  nothing to do here...
    if (TP.equal(oldKey, newKey)) {
        return this;
    }

    val = this.at(oldKey);

    //  turn off change signaling
    shouldSignal = this.shouldSignalChange();
    this.shouldSignalChange(false);

    try {
        this.removeKey(oldKey);
        this.atPut(newKey, val);
    } finally {
        //  re-enable change notification
        this.shouldSignalChange(shouldSignal);
    }

    this.changed('keys', TP.UPDATE,
                        TP.hc(TP.OLDVAL, oldKey, TP.NEWVAL, newKey));

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('replaceValue',
function(oldValue, newValue, aTest) {

    /**
     * @method replaceValue
     * @summary Replaces all occurrences of oldValue with newValue.
     * @param {Object} oldValue The value to replace.
     * @param {Object} newValue The new value to update with.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Object} The receiver.
     * @fires Change
     */

    var replaced,

        shouldSignal;

    replaced = 0;

    //  turn off change signaling
    shouldSignal = this.shouldSignalChange();
    this.shouldSignalChange(false);

    try {
        this.convert(
            function(item, index) {
                switch (aTest) {
                    case TP.IDENTITY:
                        if (TP.identical(item.last(), oldValue)) {
                            replaced++;
                            return newValue;
                        }
                        break;
                    default:
                        if (TP.equal(item.last(), oldValue)) {
                            replaced++;
                            return newValue;
                        }
                        break;
                }

                //  default is to return old value, leaving item unchanged
                return item.last();
            });
    } finally {
        //  re-enable change notification
        this.shouldSignalChange(shouldSignal);
    }

    if (replaced > 0) {
        this.changed('values', TP.UPDATE,
                        TP.hc(TP.OLDVAL, oldValue, TP.NEWVAL, newValue));
    }

    return replaced;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('set',
function(attributeName, attributeValue, shouldSignal) {

    /**
     * @method set
     * @summary Sets the value of the named attribute to the value provided. If
     *     no value is provided the value null is used.
     * @param {String|TP.path.AccessPath} attributeName The name of the
     *     attribute to set.
     * @param {Object} attributeValue The value to set.
     * @param {Boolean} shouldSignal If false no signaling occurs. Defaults to
     *     this.shouldSignalChange().
     * @returns {TP.core.Hash} The receiver.
     * @fires Change
     */

    var path,
        pathStr,

        funcName,

        args,

        sigFlag,
        oldFlag;

    if (TP.isEmpty(attributeName)) {
        return this.raise('TP.sig.InvalidKey');
    }

    //  If we got handed an 'access path', then we need to let it handle this.
    if (!TP.isString(attributeName) && attributeName.isAccessPath()) {
        path = attributeName;

        //  If the path's String representation is a simple JS_IDENTIFIER, then
        //  we need to check to see if this is just a TIBET path with a name to
        //  an 'aliased' access path (i.e. 'lastname' -> 'foo.bar.lastname').
        //  So, here we check to see if there is an access path for this simple
        //  identifier and, if there is, we use *that* path as the way to access
        //  the underlying data. NOTE: Unlike other overrides of 'set', we do
        //  NOT check for custom getters and setters here - we treat
        //  TP.core.Hash very specially around get/set and at/atPut.
        if (TP.regex.JS_IDENTIFIER.test(pathStr = path.get('srcPath'))) {
            if (TP.notValid(path = this.getAccessPathFor(pathStr, 'value'))) {
                //  There wasn't a valid access path aliased to that identifier,
                //  so just use the path we were originally going to use.
                path = attributeName;
            }
        }
    } else if (TP.regex.NON_SIMPLE_PATH.test(attributeName)) {
        path = TP.apc(attributeName, TP.hc('shouldCollapse', true));
    }

    if (TP.notValid(path)) {
        //  try common naming convention first
        funcName = 'set' + TP.makeStartUpper(attributeName);
        if (TP.canInvoke(this, funcName)) {
            switch (arguments.length) {
                case 1:
                    return this[funcName]();
                default:
                    args = TP.args(arguments, 1);
                    return this[funcName].apply(this, args);
            }
        }
    }

    //  If we got a valid path above or if we have a 'value' facet that has an
    //  access path, then invoke the path.
    if (TP.isValid(path) ||
        TP.isValid(path = this.getAccessPathFor(attributeName, 'value'))) {

        //  Note here how, if we were given more than 3 arguments, we grab all
        //  of the arguments supplied, make our path source the first argument
        //  and invoke with an apply(). Otherwise, we make an Array that has our
        //  path source and our 'path parameters' as the last argument. In both
        //  cases, this is because executeGet() takes varargs (in case the path
        //  is parameterized).
        if (arguments.length > 3) {
            args = TP.args(arguments);
            args.atPut(0, this.getPathSource(path));
        } else {
            args = TP.ac(this.getPathSource(path), attributeValue, shouldSignal,
                            this.getPathParameters());
        }

        return path.executeSet.apply(path, args);
    }

    //  NB: Use this construct this way for better performance
    if (TP.notValid(sigFlag = shouldSignal)) {
        sigFlag = this.shouldSignalChange();
    }

    //  if its defined, we want to know (true or false)
    if (TP.isDefined(sigFlag)) {
        oldFlag = this.shouldSignalChange();

        this.shouldSignalChange(sigFlag);

        //  let the standard mechanism handle it
        this.atPut(attributeName, attributeValue);

        this.shouldSignalChange(oldFlag);
    } else {
        //  let the standard mechanism handle it
        this.atPut(attributeName, attributeValue);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('setDelimiter',
function(aString) {

    /**
     * @method setDelimiter
     * @summary Sets the join delimiter to use when converting the hash to and
     *     from a string.
     * @param {String} aString The string used to join() the array.
     * @returns {TP.core.Hash} The receiver.
     */

    var str;

    str = TP.ifInvalid(aString, ', ');

    if (this.$get('delimiter') !== str) {
        this.$set('delimiter', str);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('shift',
function() {

    /**
     * @method shift
     * @summary Removes and returns the first element in the hash, as if the
     *     hash had been turned into an array and the shift had been performed
     *     on that collection.
     * @returns {Object[]} An ordered pair containing the first item in the hash
     *     based on the current sort function.
     * @fires Change
     */

    var item;

    item = this.first();
    this.remove(item);

    return item;
});

//  ------------------------------------------------------------------------
//  TP.api.Collection API
//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('add',
function(varargs) {

    /**
     * @method add
     * @summary Adds one or more key/value pairs to the receiver. The input can
     *     be provided in a variety of formats including an array of ordered
     *     pairs, an array of key, value sequences, an Object (not recommended
     *     for speed reasons), a hash of key/value pairs, or a simple argument
     *     list of key, value sequences.
     * @param {arguments} varargs Variable-length argument list of ordered
     *     pairs.
     * @returns {TP.core.Hash} The receiver.
     * @fires Change
     */

    var count,
        i,
        pair,
        obj,

        keys,
        len;

    count = 0;

    switch (arguments.length) {
        case 0:
            return this;
        case 1:
            obj = arguments[0];
            if (TP.isArray(obj)) {
                if (TP.isPair(obj[0])) {
                    //  pair syntax [['a', 1], ['b', 2], ['c', 3]]
                    for (i = 0; i < obj.length; i++) {
                        pair = obj[i];
                        this.atPut(
                            pair[0],
                            TP.notDefined(pair[1]) ? null : pair[1],
                            false);

                        count++;
                    }
                } else {
                    //  array syntax ['a', 1, 'b', 2, 'c', 3]
                    for (i = 0; i < obj.length; i += 2) {
                        this.atPut(
                            obj[i],
                            TP.notDefined(obj[i + 1]) ? null : obj[i + 1],
                            false);

                        count++;
                    }
                }
            } else {
                //  NB: We're only interested in the local keys here.
                keys = TP.$getOwnKeys(obj);
                len = keys.getSize();

                for (i = 0; i < len; i++) {
                    this.atPut(keys.at(i), obj[keys.at(i)], false);
                    count++;
                }
            }
            break;
        case 2:
            this.atPut(arguments[0], arguments[1], false);
            count++;
            break;
        default:
            //  arguments syntax 'a', 1, 'b', 2, 'c', 3
            for (i = 0; i < arguments.length; i += 2) {
                this.atPut(
                    arguments[i],
                    TP.notDefined(arguments[i + 1]) ?
                                    null :
                                    arguments[i + 1],
                    false);
                count++;
            }
            break;
    }

    if (count > 0) {
        this.changed('value', TP.INSERT);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('addAll',
function(aCollection, aFunction) {

    /**
     * @method addAll
     * @summary Adds all the ordered pairs contained in the collection to the
     *     receiver. The optional function can be used to decide which value
     *     will be used when a duplicate key is found.
     * @param {TP.api.Collection} aCollection A collection of ordered pairs to
     *     add.
     * @param {Function} aFunction A function accepting a key and two values
     *     (key, old, new) which returns the value to use for the key.
     * @returns {TP.core.Hash} The receiver.
     * @fires Change
     */

    var thisref,
        count;

    //  arrays of ordered pairs are handled nicely by add() as long as we're
    //  not trying to check for duplicates
    if (TP.isArray(aCollection) && !TP.isCallable(aFunction)) {
        return this.add(aCollection);
    }

    //  anything else has to be able to give us items during a perform
    if (!TP.canInvoke(aCollection, 'perform')) {
        return this.raise('TP.sig.InvalidCollection');
    }

    thisref = this;
    count = 0;

    //  typically don't have a dup function test, so avoid overhead
    if (!TP.isCallable(aFunction)) {
        aCollection.perform(
            function(item, index) {
                thisref.atPut(item.first(), item.last(), false);
                count++;
            });
    } else {
        aCollection.perform(
            function(item, index) {
                var val,
                    newval;

                val = thisref.at(item.first());
                if (TP.isDefined(val)) {
                    newval = aFunction(item.first(), val, item.last());
                    if (newval !== val) {
                        thisref.atPut(item.first(), newval, false);
                        count++;
                    }
                } else {
                    thisref.atPut(item.first(), item.last(), false);
                    count++;
                }
            });
    }

    if (count > 0) {
        this.changed('value', TP.INSERT);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('addAllIfAbsent',
function(aCollection) {

    /**
     * @method addAllIfAbsent
     * @summary Adds all the ordered pairs contained in the collection to the
     *     receiver where the keys are not already in the target collection.
     * @param {TP.api.Collection} aCollection A collection of ordered pairs to
     *     add.
     * @returns {TP.core.Hash} The receiver.
     * @fires Change
     */

    var thisref;

    thisref = this;

    return this.addAll(aCollection,
        function(key, oldval, newval) {

            if (thisref.containsKey(key)) {
                return oldval;
            }

            return newval;
        });
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('addIfAbsent',
function(anItemOrKey, aValue, varargs) {

    /**
     * @method addIfAbsent
     * @summary Using the key/value pair provided assign the value to the key
     *     in the receiver if the key doesn't already exist. Additional
     *     key/value pairs can be provided just as with the TP.core.Hash
     *     constructor to avoid having to call this routine multiple times with
     *     each pair.
     * @param {TP.api.OrderedPair|String} anItemOrKey The ordered pair to add,
     *     or the key for a pair.
     * @param {Object} aValue Optional value to store when the first argument is
     *     a string.
     * @param {arguments} varargs Additional key signifying that more key/value
     *     pairs are available. When this is defined the routine will loop
     *     across all input arguments and attempt to add all valid key/value
     *     pairings that can be found.
     * @exception TP.sig.InvalidParameter
     * @returns {Object|undefined} The key's value after processing.
     * @fires Change
     */

    var i,
        len,
        key,
        val;

    //  most cases are single values so optimize a bit for that case
    if (TP.isString(anItemOrKey)) {
        key = anItemOrKey;
        val = aValue;
    } else if (TP.isPair(anItemOrKey)) {
        //  TODO:   hopefully we don't say Hashes are ordered pairs
        key = anItemOrKey.first();
        val = anItemOrKey.last();
    } else {
        this.raise('TP.sig.InvalidParameter', 'Invalid key or item.');

        return;
    }

    if (TP.notDefined(this.at(key))) {
        this.atPut(key, val);
    }

    if (TP.notDefined(varargs)) {
        return this.at(key);
    }

    len = arguments.length - 2;
    for (i = 2; i < len; i += 2) {
        key = arguments[i];
        val = arguments[i + 1];

        if (TP.notDefined(this.at(key))) {
            this.atPut(key, val);
        }
    }

    return this.at(key);
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('addItem',
function(anItem) {

    /**
     * @method addItem
     * @summary Adds a single item to the receiver. If the key already exists
     *     the new value is inserted.
     * @param {The} anItem item to add.
     * @returns {TP.core.Hash} The receiver.
     * @fires Change
     */

    if (!TP.isPair(anItem)) {
        this.raise('InvalidPair');
        return this;
    }

    this.atPut(anItem.first(), anItem.last());

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('addWithCount',
function(anObject, aCount) {

    /**
     * @method addWithCount
     * @summary Adds the object N times, where N defaults to 0. NOTE that in
     *     the absence of a valid count the object is not added. For a Hash the
     *     outcome is either no addition, or one new item since the key/value
     *     can only occupy on location in the Hash.
     * @param {Object} anObject The object to add.
     * @param {Number} aCount A number of times to add the object. Default is 0.
     * @returns {TP.core.Hash} The receiver.
     * @fires Change
     */

    var count;

    //  no count? no work to do
    if (TP.notValid(aCount)) {
        return this;
    }

    //  count, but not a number? won't try to convert, just warn/exit
    count = parseInt(aCount, 10);
    if (!TP.isNumber(count)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  number, but less than 1? no work to do
    if (count < 1) {
        return this;
    }

    //  this will check for a valid pair for us
    this.addItem(anObject);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('asArray',
function() {

    /**
     * @method asArray
     * @summary Returns the receiver as an array of key/value pairs. For
     *     example TP.hc('a',1,'b',2).asArray() returns the equivalent of [['a',
     *     1], ['b', 2]].
     * @returns {Object[]} The receiver as an Array.
     */

    var hash;

    hash = this.$get('$$hash');

    return Object.entries(hash);
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('asHash',
function() {

    /**
     * @method asHash
     * @summary Returns the receiver as a suitable hash. In this type this
     *     method returns the receiver.
     * @returns {TP.core.Hash} The receiver as a TP.core.Hash.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('asIterator',
function(aStep) {

    /**
     * @method asIterator
     * @summary Returns a newly initialized interator on the receiver.
     * @param {Number} aStep The step size for iteration over the receiver.
     * @returns {TP.core.Iterator} An iterator on the receiver.
     */

    return this.getIteratorType().construct(this, aStep);
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('asRange',
function() {

    /**
     * @method asRange
     * @summary Returns a new TP.core.Range based on the size of the receiver.
     * @returns {TP.core.Range} The new range object.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns the hash as a string.
     * @description Constructs a new string from the hash.
     *     The join is done using the receiver's current 'delimiter' value,
     *     normally ', '. Set the 'delimiter' value on the receiver to use a
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the TP.core.Hash's String representation. The default is true.
     * @returns {String} The receiver as a String.
     */

    var marker,
        wantsVerbose,
        joinCh,
        joinArr,
        keys,
        len,
        i,
        joinStr;

    wantsVerbose = TP.ifInvalid(verbose, true);
    if (!wantsVerbose) {
        return TP.objectToString(this);
    }

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    joinCh = this.$get('delimiter');

    if (!TP.isString(joinCh)) {
        //  If 'joinCh' is not a String, maybe it's a hash or other Object with
        //  a 'join' property.
        if (!TP.isString(joinCh = joinCh.get('join'))) {
            joinCh = '';
        }
    }

    joinArr = TP.ac();

    try {
        keys = TP.keys(this);
        len = keys.getSize();

        for (i = 0; i < len; i++) {
            joinArr.push(
                        TP.join(keys.at(i),
                                ' => ',
                                TP.str(this.at(keys.at(i)), false)));
        }

        joinStr = joinArr.join(joinCh);
    } catch (e) {
        joinStr = this.toString();
    } finally {
        delete this[marker];
    }

    return joinStr;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('collapse',
function() {

    /**
     * @method collapse
     * @summary Returns the receiver.
     * @description This method is defined purely for polymorphic reasons so
     *     that the system can just send 'collapse' to any object. For Arrays
     *     and other collections, the first item is returned.
     * @returns {Object} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------
//  collect                     Kernel
//  ------------------------------------------------------------------------
//  collectGet                  Kernel
//  ------------------------------------------------------------------------
//  collectInvoke               Kernel
//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('compact',
function(aFilter) {

    /**
     * @method compact
     * @summary Returns the receiver with all null/undefined values removed,
     *     meaning any keys whose values are null/undefined will be removed. If
     *     a filtering function is provided then items for which the function
     *     returns true will be removed and all other values will be retained.
     *     In this sense using compact with a filter is like doing a reject()
     *     inline.
     * @param {Function} aFilter An optional filtering function which should
     *     return true for value which should be removed. The default function
     *     is TP.notValid().
     * @returns {Array} The receiver.
     * @fires Change
     */

    var items,
        filter,

        shouldSignal,

        len,

        thisref;

    filter = aFilter ||
                function(item) {
                    return TP.notValid(item.last());
                };

    items = this.select(
        function(item, index) {

            return filter(item);
        });

    //  turn off change signaling
    shouldSignal = this.shouldSignalChange();
    this.shouldSignalChange(false);

    len = this.getSize();

    thisref = this;

    items.perform(
        function(item) {
            thisref.removeKey(item.first());
        });

    //  re-enable change notification
    this.shouldSignalChange(shouldSignal);

    if (items.getSize() > 0) {
        this.changed('length', TP.DELETE,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.getSize()));
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('conform',
function(anInterface, inline) {

    /**
     * @method conform
     * @summary Returns the receiver with all values which don't implement the
     *     interface removed. The resulting collection's values will, on
     *     completion of this method, respond to the next iteration
     *     (collectInvoke perhaps) that you want to run.
     * @param {String|Array} anInterface A method name or collection of them to
     *     test against.
     * @param {Boolean} inline False to return a new array instead of collapsing
     *     inline. Default is true.
     * @returns {TP.core.Hash} The receiver.
     * @fires Change
     */

    var thisref;

    //  simple select when a new collection is desired
    if (TP.isFalse(inline)) {
        return TP.hc(
            this.select(
                    function(item) {

                        return TP.canInvokeInterface(item, anInterface);
                    }));
    }

    thisref = this;

    //  this loop will clear any values where the value isn't conforming,
    //  which sets the collection up for a compact to remove all nulls
    //  (since they don't conform to any interface)
    this.perform(
        function(item, index) {
            //  NOTE the use of last() here, which is where this differs
            //  from array processing
            if (!TP.canInvokeInterface(item.last(), anInterface)) {
                thisref.atPut(index, null, false);
            }
        });

    return this.compact();
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('contains',
function(anItem, aTest) {

    /**
     * @method contains
     * @summary Returns true if the item (anItem) provided is found in the
     *     receiver. So that hash and array containers can be used for common
     *     operations if anItem is a simple string this method returns true if
     *     that string is a key in the receiver.
     * @param {TP.api.OrderedPair} anItem The item to find in the receiver.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception InvalidPair
     * @returns {Boolean} Whether or not the receiver contains the value
     *     provided.
     */

    var val,
        test;

    //  allow contains to work somewhat polymorphically between Hash and
    //  Array types, but note that we
    if (TP.isString(anItem)) {
        return this.containsKey(anItem);
    }

    if (!TP.isPair(anItem)) {
        return this.raise('InvalidPair');
    }

    test = TP.ifInvalid(aTest, TP.EQUALITY);

    if (TP.notDefined(val = this.at(anItem.first()))) {
        return false;
    }

    if (test === TP.EQUALITY) {
        return TP.equal(val, anItem.last());
    } else {
        return TP.identical(val, anItem.last());
    }
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('containsAll',
function(aCollection, aTest) {

    /**
     * @method containsAll
     * @summary Returns true if all the values in the collection provided are
     *     found in the receiver.
     * @param {TP.api.Collection} aCollection The collection of elements all of
     *     which must be equal to at least one element in the receiver for this
     *     method to return true.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception TP.sig.InvalidCollection
     * @returns {Boolean} Whether or not the receiver contains all of the values
     *     in the collection provided.
     */

    var arr,
        retval,
        len,
        i;

    if (TP.isArray(aCollection)) {
        arr = aCollection;
    } else {
        if (!TP.canInvoke(aCollection, 'asArray')) {
            return this.raise('TP.sig.InvalidCollection');
        }

        arr = aCollection.asArray();
    }

    if (TP.isEmpty(arr)) {
        return false;
    }

    retval = true;

    len = arr.getSize();
    for (i = 0; i < len; i++) {
        if (!this.contains(arr.at(i), aTest)) {
            retval = false;
            break;
        }
    }

    return retval;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('containsAny',
function(aCollection, aTest) {

    /**
     * @method containsAny
     * @summary Returns true if any of the values in the collection provided
     *     are found in the receiver.
     * @param {TP.api.Collection} aCollection The collection of elements any of
     *     which must be equal to any element in the receiver for this method to
     *     be true.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception TP.sig.InvalidCollection
     * @returns {Boolean} Whether or not the receiver contains any of the values
     *     in the collection provided.
     */

    var arr,
        retval,
        len,
        i;

    if (TP.isArray(aCollection)) {
        arr = aCollection;
    } else {
        if (!TP.canInvoke(aCollection, 'asArray')) {
            return this.raise('TP.sig.InvalidCollection');
        }

        arr = aCollection.asArray();
    }

    if (TP.isEmpty(arr)) {
        return false;
    }

    retval = false;

    len = arr.getSize();
    for (i = 0; i < len; i++) {
        if (this.contains(arr.at(i), aTest)) {
            retval = true;
            break;
        }
    }

    return retval;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('containsString',
function(aString) {

    /**
     * @method containsString
     * @summary Returns true if the receiver contains the string provided.
     * @param {String} aString The string value to check for as a value.
     * @returns {Boolean}
     */

    return this.containsValue(aString);
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('convert',
function(aFunction) {

    /**
     * @method convert
     * @summary Converts the values of the receiver in place, altering the
     *     receiver such that the return value of aFunction is used as the new
     *     value for each key/value pair in the receiver.
     * @param {Function} aFunction A function which should return the new value
     *     given an item to process.
     * @returns {TP.core.Hash} The receiver.
     */

    var thisref,

        shouldSignal;

    //  turn off change signaling
    shouldSignal = this.shouldSignalChange();
    this.shouldSignalChange(false);

    thisref = this;

    this.perform(
        function(item, index) {
            thisref.atPut(item.first(), aFunction(item, index));
        });

    //  re-enable change notification
    this.shouldSignalChange(shouldSignal);

    this.changed('value', TP.UPDATE);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('countOf',
function(anItem, aTest) {

    /**
     * @method countOf
     * @summary Returns a count of the number of times anItem is found in the
     *     hash.
     * @param {TP.api.OrderedPair} anItem The item/pair whose value is checked
     *     against.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Number} The number of occurrences of anItem.
     */

    //  since it's an item...key/value...the answer is either 0 or 1...
    return this.contains(anItem, aTest) ? 1 : 0;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('deltas',
function(aHash, aTest) {

    /**
     * @method deltas
     * @summary Compares two hashes as if they are "versions" of the same hash.
     *     The result is an array of triplets containing key, value, and
     *     operation where operation is TP.INSERT, TP.UPDATE, or TP.DELETE.
     *     The incoming hash is treated as the target version while the receiver
     *     is considered the source version. For updates the value provided is
     *     the new value to set in the source to produce the target.
     * @param {TP.core.Hash} aHash The hash to be compared.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Object[]} The change set from aHash to the receiver.
     */

    var sourceKeys,
        targetKeys,
        sourceItem,
        targetItem,
        changeSet,
        thisref;

    if (!TP.isHash(aHash)) {
        return this.raise('InvalidHash', aHash);
    }

    thisref = this;
    changeSet = TP.ac();
    sourceKeys = this.getKeys();
    targetKeys = aHash.getKeys();

    //  Things in the source missing from target were "deleted".
    sourceKeys.difference(targetKeys).forEach(
        function(key) {
            changeSet.push(TP.ac(key, thisref.at(key), TP.DELETE));
        });

    //  Things in the target missing from the source were "inserted".
    targetKeys.difference(sourceKeys).forEach(
        function(key) {
            changeSet.push(TP.ac(key, aHash.at(key), TP.INSERT));
        });

    //  Keys in both are compared by value equality/identity for "updates"
    sourceKeys.intersection(targetKeys).forEach(
        function(key) {
            sourceItem = thisref.at(key);
            targetItem = aHash.at(key);

            switch (aTest) {
                case TP.IDENTITY:
                    if (!TP.identical(sourceItem, targetItem)) {
                        changeSet.push(TP.ac(key, targetItem, TP.UPDATE));
                    }
                    break;
                default:
                    if (!TP.equal(sourceItem, targetItem)) {
                        changeSet.push(TP.ac(key, targetItem, TP.UPDATE));
                    }
                    break;
            }
        });

    return changeSet;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('detect',
function(aFunction) {

    /**
     * @method detect
     * @summary Returns the first element in the receiver which matches the
     *     criteria provided or null if the element isn't found. NOTE that for a
     *     hash the ordering is arbitrary, so this is more like a simple "find"
     *     that's useful when trying to find based on the value rather than key.
     * @param {Function} aFunction A function which should return true if the
     *     element it is passed passes the function's test, or false if it does
     *     not.
     * @returns {Object} The element detected or undefined.
     */

    var retval,
        keys,
        len,
        i,
        key,
        value,
        item;

    keys = this.getKeys();
    len = keys.getSize();

    for (i = 0; i < len; i++) {
        key = keys.at(i);
        value = this.at(key);
        item = [key, value];
        if (aFunction(item, i)) {
            retval = item;
            break;
        }
    }

    return retval;
});

//  ------------------------------------------------------------------------
//  detectInvoke                Kernel
//  ------------------------------------------------------------------------
//  detectMax                   Kernel
//  ------------------------------------------------------------------------
//  detectMin                   Kernel
//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('difference',
function(aCollection, aTest) {

    /**
     * @method difference
     * @summary Returns the elements contained in the receiver which are not in
     *     the collection provided.
     * @description This method can be thought of as subtracting all elements
     *     found in the collection provided from the receiver. What's left are
     *     those elements unique to the receiver.
     * @param {TP.api.Collection} aCollection The collection to difference
     *     against the receiver.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception TP.sig.InvalidCollection
     * @returns {Object[]} An array containing the key/value pairs that differ.
     *     Since keys might have different values in different hashes we don't
     *     attempt to turn the list back into a hash.
     */

    var arr;

    if (TP.isArray(aCollection)) {
        arr = aCollection;
    } else {
        if (!TP.canInvoke(aCollection, 'asArray')) {
            return this.raise('TP.sig.InvalidCollection');
        }

        arr = aCollection.asArray();
    }

    return arr.difference(this.getItems(), aTest);
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('disjunction',
function(aCollection, aTest) {

    /**
     * @method disjunction
     * @summary Returns the 'symmetric difference' or those elements which are
     *     disjunct between the two collections. NOTE: this method does not
     *     return a new hash since there may have been key overlaps that would
     *     cause data to be missing from the resulting hash. The array of
     *     ordered pairs returned from this method doesn't suffer from that
     *     problem.
     * @description This method returns a new array containing the disjunction
     *     between the receiver and aCollection. This means that only those
     *     elements which occur in one of the collections but not the other are
     *     returned.
     * @param {TP.api.Collection} aCollection The collection to disjunct against
     *     the receiver.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception TP.sig.InvalidCollection
     * @returns {Object[]} An array containing the key/value pairs that differ.
     *     Since keys might have different values in different hashes we don't
     *     attempt to turn the list back into a hash.
     */

    var arr;

    if (TP.isArray(aCollection)) {
        arr = aCollection;
    } else {
        if (!TP.canInvoke(aCollection, 'asArray')) {
            return this.raise('TP.sig.InvalidCollection');
        }

        arr = aCollection.asArray();
    }

    return arr.disjunction(this.getItems(), aTest);
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('empty',
function() {

    /**
     * @method empty
     * @summary Empties the receiver.
     * @returns {TP.core.Hash} The receiver.
     * @fires Change
     */

    var hash,
        keys,
        len,
        i;

    hash = this.$get('$$hash');

    keys = this.getKeys();
    len = keys.getSize();

    for (i = 0; i < len; i++) {
        delete hash[keys[i]];
    }

    this.changed('length', TP.DELETE, TP.hc(TP.OLDVAL, len, TP.NEWVAL, 0));

    return this;
});

//  ------------------------------------------------------------------------
//  flatten                     Kernel
//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('getKeysForValue',
function(aValue, aTest) {

    /**
     * @method getKeysForValue
     * @summary Returns an array containing the keys where the value matches the
     *     supplied value, according to the test.
     * @param {Object} aValue The value to check.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {String[]} An array of the keys for the supplied value.
     */

    var arr,

        keys,
        hash,

        val,

        i;

    arr = TP.ac();

    keys = TP.keys(this);

    if (TP.notNull(hash = this.$get('$$hash'))) {
        for (i = 0; i < keys.length; i++) {

            val = hash[keys[i]];

            switch (aTest) {
                case TP.IDENTITY:
                    if (TP.identical(aValue, val)) {
                        arr.push(keys[i]);
                    }
                    break;
                default:
                    if (TP.equal(aValue, val)) {
                        arr.push(keys[i]);
                    }
            }
        }
    }

    return arr;
});

//  ------------------------------------------------------------------------
//  getItems                    Kernel
//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('getIterator',
function() {

    /**
     * @method getIterator
     * @summary Returns the iterator used for the receiver. You shouldn't count
     *     on this being set at the start or in having any particular ordering.
     *     See the TP.core.Iterator type for information on how to order the
     *     iteration.
     * @returns {TP.core.Iterator} The iterator.
     */

    if (TP.notValid(this.$get('iterator'))) {
        this.$set('iterator', this.asIterator());
    }

    return this.$get('iterator');
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('getIteratorType',
function() {

    /**
     * @method getIteratorType
     * @summary Returns the type of iterator used for the receiver.
     * @returns {TP.core.Iterator} The type of the iterator.
     */

    var type;

    if (TP.notValid(type = TP.sys.getTypeByName('TP.core.Iterator'))) {
        return this.raise('TP.sig.TypeNotFound');
    }

    return type;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('getSize',
function() {

    /**
     * @method getSize
     * @summary Returns the size of the receiver.
     * @returns {Number} The size.
     */

    return this.getKeys().getSize();
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('getValues',
function() {

    /**
     * @method getValues
     * @summary Returns an array containing the values for the objects'
     *     attributes.
     * @returns {Object[]} An array of the values for the receiver's keys.
     */

    var hash;

    hash = this.$get('$$hash');

    return Object.values(hash);
});

//  ------------------------------------------------------------------------
//  grep                        Kernel
//  ------------------------------------------------------------------------
//  groupBy                     Kernel
//  ------------------------------------------------------------------------
//  injectInto                  Kernel
//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('intersection',
function(aCollection, aTest) {

    /**
     * @method intersection
     * @summary Returns the intersection of the two collections as a new
     *     TP.core.Hash.
     * @description This method returns a hash of those elements which occur in
     *     BOTH the receiver and in aCollection. NOTE that both the keys and the
     *     values are used in testing.
     * @param {TP.api.Collection} aCollection The collection to intersect the
     *     receiver with.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception TP.sig.InvalidCollection
     * @returns {TP.core.Hash} A hash containing the elements in the
     *     intersection of the two collections.
     */

    var arr;

    if (TP.isArray(aCollection)) {
        arr = aCollection;
    } else {
        if (!TP.canInvoke(aCollection, 'asArray')) {
            return this.raise('TP.sig.InvalidCollection');
        }

        arr = aCollection.asArray();
    }

    return arr.intersection(this.getItems(), aTest).asHash();
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('$$isCollection',
function() {

    /**
     * @method $$isCollection
     * @summary Returns true if the receiver is a collection instance.
     * @returns {Boolean} True if the receiver is a collection.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('isSortedCollection',
function() {

    /**
     * @method isSortedCollection
     * @summary Returns true if the receiver is behaving as a sorted
     *     collection. Effectively true any time the receiver has a valid sort
     *     function assigned.
     * @description Objects cannot maintain their content in a sorted fashion
     *     although their keys may be sorted if a sort function has been
     *     defined. In that case this method returns true.
     * @returns {Boolean} Whether this hash is a sorted collection or not.
     */

    return TP.isCallable(this.getSortFunction());
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('merge',
function(varargs) {

    /**
     * @method merge
     * @summary Merge the receiver's elements with elements from one or more
     *     collections.
     * @param {arguments} varargs Variable-length argument list of other
     *     collections
     * @returns {TP.core.Hash} A hash containing the merged values from the
     *     receiver and all of the supplied collections.
     */

    var arr,

        result,

        len,
        i,

        otherCollection,
        otherKeys,

        len2,
        j;

    arr = TP.args(arguments);
    arr.unshift(this);

    result = TP.hc();

    len = arr.getSize();
    for (i = 0; i < len; i++) {
        otherCollection = arr.at(i);
        otherKeys = otherCollection.getKeys();
        len2 = otherKeys.getSize();

        for (j = 0; j < len2; j++) {
            result.atPut(otherKeys.at(j),
                            otherCollection.at(otherKeys.at(j)));
        }
    }

    return result;
});

//  ------------------------------------------------------------------------
//  partition                   Kernel
//  ------------------------------------------------------------------------
//  perform                     Kernel
//  ------------------------------------------------------------------------
//  performInvoke               Kernel
//  ------------------------------------------------------------------------
//  performSet                  Kernel
//  ------------------------------------------------------------------------
//  performUntil                Kernel
//  ------------------------------------------------------------------------
//  performWhile                Kernel
//  ------------------------------------------------------------------------
//  performWith                 Kernel
//  ------------------------------------------------------------------------
//  reject                      Kernel
//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('remove',
function(anItem, aTest) {

    /**
     * @method remove
     * @summary Removes an item from the receiver.
     * @description In this method, all instances of the item are removed. The
     *     key and value must match for the item to be removed. If you want to
     *     remove the key without concern for whether the value matches use
     *     removeKey or removeAt.
     * @param {TP.api.OrderedPair} anItem The item to be removed.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception InvalidItem
     * @exception InvalidPair
     * @returns {Number} The count of items removed.
     * @fires Change
     */

    var count;

    count = this.contains(anItem, aTest) ? 1 : 0;

    if (count > 0) {
        //  should signal for us
        this.removeKey(anItem.first());
    }

    return count;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('removeAll',
function(aCollection, aTest) {

    /**
     * @method removeAll
     * @summary Removes the items contained in the collection from the
     *     receiver.
     * @param {TP.api.Collection} aCollection The collection of items to remove.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidCollection
     * @returns {Number} The count of items removed.
     * @fires Change
     */

    var arr,
        count,
        thisref,

        len,

        shouldSignal;

    if (TP.isArray(aCollection)) {
        arr = aCollection;
    } else {
        if (!TP.canInvoke(aCollection, 'asArray')) {
            this.raise('TP.sig.InvalidCollection');
            return 0;
        }

        arr = aCollection.asArray();
    }

    count = 0;
    thisref = this;

    len = this.getSize();

    shouldSignal = this.shouldSignalChange();

    try {
        arr.perform(
            function(item, index) {
                //  turn off change signaling - 'remove' will reset this
                //  setting, so redo each time through loop.
                thisref.shouldSignalChange(false);

                count += thisref.remove(item, aTest);
            });
    } finally {
        //  re-enable change notification
        this.shouldSignalChange(shouldSignal);
    }

    if (count > 0) {
        this.changed('value', TP.DELETE,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.getSize()));
    }

    return count;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('replace',
function(oldItem, newItem, aTest) {

    /**
     * @method replace
     * @summary Replaces the item having the value oldItem with an item having
     *     the value newItem.
     * @param {TP.api.OrderedPair} oldItem The old item to look for.
     * @param {TP.api.OrderedPair} newItem The new item to replace the old item
     *     with.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception TP.sig.InvalidParameter
     * @exception InvalidPair
     * @returns {Object} The receiver.
     * @fires Change
     */

    var shouldSignal;

    if (!TP.isPair(oldItem) || !TP.isPair(newItem)) {
        this.raise('InvalidPair');

        return 0;
    }

    //  do we have a match or not?
    if (!this.contains(oldItem, aTest)) {
        return 0;
    }

    //  turn off change signaling
    shouldSignal = this.shouldSignalChange();
    this.shouldSignalChange(false);

    try {
        this.remove(oldItem, aTest);
        this.add(newItem);

        this.changed('value', TP.UPDATE);
    } finally {
        //  re-enable change notification
        this.shouldSignalChange(shouldSignal);
    }

    return 1;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('replaceAll',
function(aCollection, newItem, aTest) {

    /**
     * @method replaceAll
     * @summary Replaces all the items in aCollection with the newItem.
     * @param {TP.api.Collection} aCollection A collection of old items to
     *     replace.
     * @param {TP.api.OrderedPair} newItem The new item to replace the old items
     *     with.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception TP.sig.InvalidCollection
     * @exception TP.sig.InvalidPair,
     * @exception TP.sig.InvalidParameter
     * @returns {Object} The receiver.
     * @fires Change
     */

    var arr,
        count,
        thisref,

        shouldSignal;

    if (TP.isArray(aCollection)) {
        arr = aCollection;
    } else {
        if (!TP.canInvoke(aCollection, 'asArray')) {
            return this.raise('TP.sig.InvalidCollection');
        }

        arr = aCollection.asArray();
    }

    count = 0;
    thisref = this;

    shouldSignal = this.shouldSignalChange();

    try {
        arr.perform(
            function(item, index) {
                //  turn off change signaling - 'replace' will reset this
                //  setting, so redo each time through loop.
                thisref.shouldSignalChange(false);

                count += thisref.replace(item, newItem, aTest);
            });
    } finally {
        //  re-enable change notification
        this.shouldSignalChange(shouldSignal);
    }

    if (count > 0) {
        this.changed('value', TP.UPDATE);
    }

    return count;
});

//  ------------------------------------------------------------------------
//  select                      Kernel
//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('transpose',
function() {

    /**
     * @method transpose
     * @summary Transposes the keys and values of the receiver, creating a
     *     reverse-lookup version of the receiver.
     * @description Note that the sort order (if any) of the keys determines how
     *     duplicate values will ultimately be handled (ie. which key 'wins'
     *     when there are multiple values whose keys will collide).
     * @returns {TP.core.Hash} A new instance with the values and keys reversed.
     */

    var dict;

    dict = TP.hc();

    return this.injectInto(
            dict,
            function(item, accum, index) {

                var key;

                if (TP.isValid(key = item.last())) {
                    accum.atPut(key, item.first());
                }

                return accum;
            });
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('union',
function(aCollection, aFunction) {

    /**
     * @method union
     * @summary Returns a new Hash containing the items combining the keys and
     *     values of both objects. When aFunction is provided it is used to
     *     produce a return value for duplicate keys, otherwise the incoming
     *     collection's values will replace the receiver's values.
     * @param {TP.api.Collection} aCollection An object containing key/value
     *     data to be combined with the receiver.
     * @param {Function} aFunction A function accepting a key and two values
     *     (key, old, new) which returns the value to use for the key.
     * @returns {TP.core.Hash} A new hash containing items from both
     *     collections.
     */

    var dups,
        hash,

        thisref;

    if (!TP.canInvoke(aCollection, 'getKeys')) {
        return this.raise('TP.sig.InvalidCollection',
                'Collection must support getKeys for union operation.');
    }

    hash = this.copy();

    thisref = this;

    if (TP.isCallable(aFunction)) {
        //  going to try to resolve duplicate key issues so we need to
        //  collect the actual values via the function
        dups = this.getKeys().intersection(aCollection.getKeys());

        if (TP.notEmpty(dups)) {

            dups.convert(
                function(key) {

                    return TP.ac(key,
                                aFunction(key,
                                            thisref.at(key),
                                            aCollection.at(key)));
                });

            hash.addAll(aCollection);
            hash.addAll(dups);

            return hash;
        }
    }

    return hash.addAll(aCollection);
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('unique',
function(aTest) {

    /**
     * @method unique
     * @summary Collapses the receiver to contain only 1 of each unique value.
     *     For a hash this is a no-op since each item is inherently a unique
     *     key/value combination.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Object} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------
//  TP.api.IndexedCollection Interface
//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('addAt',
function(aValue, anIndex) {

    /**
     * @method addAt
     * @summary Adds the value provided at anIndex.
     * @param {Object} aValue The value to add at anIndex.
     * @param {Number} anIndex The index to add aValue at.
     * @exception TP.sig.InvalidIndex
     * @returns {Object} The receiver.
     * @fires Change
     */

    if (TP.notValid(anIndex)) {
        return this.raise('TP.sig.InvalidIndex');
    }

    return this.atPut(anIndex, aValue);
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('addAllAt',
function(aCollection, anIndex) {

    /**
     * @method addAllAt
     * @summary Adds aCollection at the index provided. NOTE that the entire
     *     collection becomes the value for the key provided.
     * @param {TP.api.Collection} aCollection The collection to add.
     * @param {Number} anIndex The index to add elements.
     * @exception TP.sig.InvalidIndex
     * @returns {Object} The receiver.
     * @fires Change
     */

    return this.addAt(aCollection, anIndex);
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('at',
function(anIndex) {

    /**
     * @method at
     * @summary Returns the value at the index provided.
     * @param {Object} anIndex The index to use for locating the value. Note
     *     that this is usually a string, but could be any object. This method
     *     is designed to protect against returning any of the receiver's
     *     methods.
     * @returns {Object|undefined} The item at the index provided or undefined.
     */

    var hash;

    hash = this.$get('$$hash');

    //  Make sure that our internal hash is real.
    if (!hash) {
        return;
    }

    //  null or undefined will be distinguished properly for callers.
    return hash[anIndex];
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('atAll',
function(aCollection) {

    /**
     * @method atAll
     * @summary Returns an array containing the values at each of the indices
     *     provided.
     * @param {TP.api.Collection} aCollection The collection of indexes.
     * @exception TP.sig.InvalidCollection
     * @returns {Object[]} A new array containing the values collected.
     */

    var arr,
        thisref;

    if (!TP.canInvoke(aCollection, 'perform')) {
        return this.raise(
                    'TP.sig.InvalidCollection',
                    'Collection must support perform for atAll operation.');
    }

    arr = TP.ac();
    thisref = this;

    aCollection.perform(
        function(item, index) {
            arr.push(thisref.at(item));
        });

    return arr;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('atAllPut',
function(aCollection, aValue) {

    /**
     * @method atAllPut
     * @summary Inserts aValue at a set of locations.
     * @description Places aValue at each location in the receiver. If the
     *     optional collection is provided the indices listed in the collection
     *     are updated rather than the entire collection.
     * @param {TP.api.Collection} aCollection An optional collection specifying
     *     indexes which should be altered to contain aValue.
     * @param {Object} aValue The element to put at all the locations in this
     *     collection (unless aCollection of indexes is provided).
     * @exception TP.sig.InvalidCollection
     * @returns {Object} The receiver.
     * @fires Change
     */

    var count,
        thisref;

    if (!TP.canInvoke(aCollection, 'perform')) {
        this.raise('TP.sig.InvalidCollection',
                    'Collection must support perform for atAll operation.');
        return this;
    }

    count = 0;
    thisref = this;

    aCollection.perform(
        function(item, index) {
            if (!TP.equal(thisref.at(item), aValue)) {
                thisref.atPut(item, aValue, false);
                count++;
            }

            return;
        });

    if (count > 0) {
        this.changed('value', TP.UPDATE);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('atIfInvalid',
function(anIndex, aDefault) {

    /**
     * @method atIfInvalid
     * @summary Returns the value at the index provided or the default value if
     *     the key doesn't exist.
     * @description If a Function is supplied as the default value to this
     *     method, it will be executed and its value will be returned as the
     *     value. Therefore, this method cannot be used if the Function object
     *     itself is what is desired as the returned value.
     * @param {Object} anIndex The index of the value to return.
     * @param {Object} aDefault The default value to return if invalid.
     * @returns {Object} The element at anIndex in this collection.
     */

    var value;

    if (TP.isValid(value = this.at(anIndex))) {
        return value;
    } else if (TP.isCallable(aDefault)) {
        return aDefault();
    } else {
        return aDefault;
    }
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('atIfNull',
function(anIndex, aDefault) {

    /**
     * @method atIfNull
     * @summary Returns the value at the index provided or the default value if
     *     the key returns a value of null (not undefined).
     * @description If a Function is supplied as the default value to this
     *     method, it will be executed and its value will be returned as the
     *     value. Therefore, this method cannot be used if the Function object
     *     itself is what is desired as the returned value.
     * @param {Object} anIndex The index of the value to return.
     * @param {Object} aDefault The default value to return if null.
     * @returns {Object} The element at anIndex in this collection.
     */

    var value;

    if (TP.notNull(value = this.at(anIndex))) {
        return value;
    } else if (TP.isCallable(aDefault)) {
        return aDefault();
    } else {
        return aDefault;
    }
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('atIfUndefined',
function(anIndex, aDefault) {

    /**
     * @method atIfUndefined
     * @summary Returns the value at the index provided or the default value if
     *     the key returns undefined.
     * @description If a Function is supplied as the default value to this
     *     method, it will be executed and its value will be returned as the
     *     value. Therefore, this method cannot be used if the Function object
     *     itself is what is desired as the returned value.
     * @param {Object} anIndex The index of the value to return.
     * @param {Object} aDefault The default value to return if undefined.
     * @returns {Object} The element at anIndex in this collection.
     */

    var value;

    if (TP.isDefined(value = this.at(anIndex))) {
        return value;
    } else if (TP.isCallable(aDefault)) {
        return aDefault();
    } else {
        return aDefault;
    }
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('atPath',
function(anIndex) {

    /**
     * @method atPath
     * @summary Retrieves the value at the 'end' of set of TP.core.Hashes that
     *     should each match an entry in the dot-separated index.
     * @param {String} anIndex The 'dot separated' path to retrieve the value
     *     from.
     * @returns {Object|undefined} The item at the index provided or undefined.
     */

    var entry,
        indices,

        len,
        i,

        index,

        item;

    if (!/\./.test(anIndex)) {
        //  TODO: Throw an exception here?
        return;
    }

    /* eslint-disable consistent-this */
    entry = this;

    indices = anIndex.split('.');

    len = indices.getSize();
    for (i = 0; i < len; i++) {
        index = indices.at(i);

        //  If we're at the last position, then we get the real value
        if (i === len - 1) {
            return entry.at(index);
        } else {
            //  Otherwise, we see if there's a TP.core.Hash at that
            //  position. If not, we return null. Otherwise, we set the next
            //  'entry' to be the 'next TP.core.Hash in line'
            item = entry.at(index);

            if (!TP.isHash(item)) {
                return null;
            }

            entry = item;
        }
    }
    /* eslint-enable consistent-this */

    return null;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('atPathPut',
function(anIndex, aValue) {

    /**
     * @method atPathPut
     * @summary Places the supplied value at the 'end' of set of TP.core.Hashes
     *     that should each match an entry in the dot-separated index. If a
     *     TP.core.Hash isn't found at that entry in the hash at the current
     *     entry point, one is created.
     * @param {String} anIndex The 'dot separated' path to put aValue into.
     * @param {Object} aValue The value to place at the end of the path.
     * @example Construct a series of TP.core.Hashes 'along a path' and place a
     *     value in the last one:
     *     <code>
     *          myHash = TP.hc();
     *          myHash.atPathPut('foo.bar.baz', 'moo');
     *          myHash.asSource();
     *          <samp>TP.hc('foo', TP.hc('bar', TP.hc('baz', 'moo')))</samp>
     *     </code>
     * @returns {TP.core.Hash} The receiver.
     * @fires Change
     */

    var entry,
        indices,

        shouldSignal,

        op,

        len,
        i,

        index,

        val,
        item;

    if (!/\./.test(anIndex)) {
        //  TODO: Throw an exception here?
        return this;
    }

    /* eslint-disable consistent-this */
    entry = this;

    indices = anIndex.split('.');

    //  Turn off change signaling (after capturing the previous setting).
    //  We'll signal ourself using the path at the bottom.
    shouldSignal = this.shouldSignalChange();
    this.shouldSignalChange(false);

    op = null;

    len = indices.getSize();
    for (i = 0; i < len; i++) {
        index = indices.at(i);

        //  If we're at the last position, then we set the real value
        if (i === len - 1) {
            //  If an op wasn't already set below (i.e. we didn't
            //  actually create any hashes), and we were signaling Change
            //  then set it to either TP.INSERT or TP.UPDATE.
            if (TP.notValid(op) && shouldSignal) {
                if (TP.notDefined(val = entry.at(index))) {
                    op = TP.INSERT;
                } else {
                    //  We need to compare values to see if this is truly a
                    //  TP.UPDATE (which will only occur if the *values are
                    //  different*).
                    if (!TP.equal(val, aValue)) {
                        op = TP.UPDATE;
                    }
                }
            }

            entry.atPut(index, aValue);
        } else {
            //  Otherwise, we see if there's a TP.core.Hash at that
            //  position. If not, we create one. In either case, we set the
            //  next 'entry' to be the 'next TP.core.Hash in line'
            item = entry.at(index);

            if (!TP.isHash(item)) {
                item = TP.hc();
                entry.atPut(index, item);
                op = TP.INSERT;
            }

            entry = item;
        }
    }
    /* eslint-enable consistent-this */

    //  set change signaling back to its previous setting
    this.shouldSignalChange(shouldSignal);

    //  'changed' will check further to see if we signal Change.
    if (TP.isValid(op)) {
        this.changed(anIndex, op);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('atPut',
function(anIndex, aValue) {

    /**
     * @method atPut
     * @summary Replaces the value at anIndex with aValue.
     * @param {Object} anIndex The index to put aValue into.
     * @param {Object} aValue The value to place at anIndex.
     * @returns {TP.core.Hash} The receiver.
     * @fires Change
     */

    var hash,
        shouldSignal,
        op,
        val,
        changeRecord,
        changeRecordHash;

    hash = this.$get('$$hash');
    shouldSignal = this.shouldSignalChange();
    op = null;

    //  three things matter here...that we add the index to our key array,
    //  that we update our hash with the key/value pair, and that we
    //  signal changes

    //  setting a key to undefined deletes it
    if (TP.notDefined(aValue)) {
        //  This method will take care of both removing the key and deleting
        //  the slot on our internal hash.
        this.$removeInternalKey(anIndex);
        op = TP.DELETE;
    } else {
        //  If we don't know about this value, or its a property but not on
        //  us, then this is an insert and requires a key array update.
        if (TP.notDefined(hash[anIndex]) || !TP.owns(hash, anIndex)) {
            hash[anIndex] = aValue;

            op = TP.INSERT;
        } else {
            //  Otherwise, this is an update.

            //  If we're signaling Change, we need to compare values to see
            //  if this is truly a TP.UPDATE (which will only occur if the
            //  *values are different*).
            if (shouldSignal) {
                val = hash[anIndex];

                if (!TP.equal(val, aValue)) {
                    hash[anIndex] = aValue;
                    if (TP.notValid(op)) {
                        op = TP.UPDATE;
                    }
                }
            } else {
                hash[anIndex] = aValue;
            }
        }

        //  Otherwise, we're not gonna signal Change so we just return.
        if (TP.notValid(op)) {
            return this;
        }
    }

    //  'changed' will check further to see if we signal Change.
    if (TP.isValid(op) && shouldSignal) {
        //  NB: Here, we cannot use the normal TP.hc(arguments...) form of the
        //  constructor or we'll loop endlessly back into this method. We must
        //  use lower-level constructs.
        //  this.changed(anIndex, op, TP.hc(TP.OLDVAL, val, TP.NEWVAL, aValue));

        changeRecord = TP.hc();

        changeRecordHash = changeRecord.$get('$$hash');

        changeRecordHash[TP.OLDVAL] = val;
        changeRecordHash[TP.NEWVAL] = aValue;

        this.changed(anIndex, op, changeRecord);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('atPutIfAbsent',
function(aKey, aValue) {

    /**
     * @method atPutIfAbsent
     * @summary Add the key and value if the key doesn't already exist. NOTE
     *     that the value isn't relevant in this test, the value may be null, or
     *     undefined, and as long at the key has been defined at some point this
     *     method will not update the value.
     * @param {Object} aKey The key to test and optionally add to the receiver.
     * @param {Object} aValue Optional value to store when the first argument is
     *     a string.
     * @exception InvalidPair
     * @returns {Object} The key's value after processing.
     * @fires Change
     */

    return this.addIfAbsent(aKey, aValue);
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('containsKey',
function(aKey) {

    /**
     * @method containsKey
     * @summary Returns true if the receiver contains the key provided.
     * @param {Object} aKey The key to test.
     * @returns {Boolean}
     */

    return TP.isDefined(this.at(aKey));
});

//  ------------------------------------------------------------------------
//  containsValue               Kernel
//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('detectKeyAt',
function(aKey, anIndex) {

    /**
     * @method detectKeyAt
     * @summary Searches for the first nested element whose value at(anIndex)
     *     matches aKey. This can be a useful detection for finding data in an
     *     ordered collection (array, sorted hash, or node) by the value at a
     *     particular index or attribute location.
     * @param {String|RegExp} aKey The string or regular expression selector to
     *     match with.
     * @param {Number} anIndex The "column" index to check in each nested array.
     * @returns {Object[]} The nested array whose value at anIndex matches aKey.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('getKeys',
function() {

    /**
     * @method getKeys
     * @summary Returns the unique keys of the receiver.
     * @description If the receiver has a sort function defined the keys are
     *     sorted. The result is that all methods which use the key array as a
     *     focal point for iteration effectively work to produce output sorted
     *     by the ordering of the keys.
     * @returns {String[]} An array containing the receiver's keys.
     */

    var arr,
        func;

    arr = TP.objectGetKeys(this.$get('$$hash'));

    arr = arr.filter(
            function(aKey) {
                return !TP.regex.INTERNAL_SLOT.test(aKey);
            });

    func = this.getSortFunction();
    if (!func) {
        return arr;
    }

    return arr.sort(func);
});

//  ------------------------------------------------------------------------
//  getKVPairs                  Kernel
//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('getPosition',
function(aValue, aTest) {

    /**
     * @method getPosition
     * @summary Returns the first index of the element provided or undefined if
     *     the element isn't found. For hashes with a sort function the ordering
     *     will be relevant, otherwise it will be random and the results will be
     *     unpredictable.
     * @param {Object} aValue What to search for.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Object|undefined} The index of the value or undefined.
     */

    var found;

    found = this.detect(
        function(item, index) {

            switch (aTest) {
                case TP.IDENTITY:
                    return TP.identical(item.last(), aValue);
                default:
                    return TP.equal(item.last(), aValue);
            }
        });

    if (TP.isValid(found)) {
        return found.first();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('getPositions',
function(aValue, aTest) {

    /**
     * @method getPositions
     * @summary Returns an array containing all indexes where aValue exists. No
     *     particular order is implied however sorted hashes will return the
     *     indexes in the order defined by their sort function.
     * @param {Object} aValue The value to search for.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Number[]} A new array of indexes.
     */

    var items;

    items = this.select(
        function(item, index) {

            switch (aTest) {
                case TP.IDENTITY:
                    return TP.identical(item.last(), aValue);
                default:
                    return TP.equal(item.last(), aValue);
            }
        });

    //  return the keys from our itemset, those are our 'indexes'
    return items.collect(
                    function(item) {
                        return item.first();
                    });
});

//  ------------------------------------------------------------------------
//  grepKeys                    Kernel
//  ------------------------------------------------------------------------
//  performOver                 Kernel
//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('removeAt',
function(anIndex) {

    /**
     * @method removeAt
     * @summary Removes the element at the index provided.
     * @param {Object} anIndex The index at which to remove the element.
     * @returns {Object} The receiver.
     * @fires Change
     */

    return this.removeKey(anIndex);
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('removeAtAll',
function(aCollection) {

    /**
     * @method removeAtAll
     * @summary Provides a way to remove a collection of keys (and their
     *     values) from the collection.
     * @param {TP.api.Collection} aCollection A collection of keys.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidCollection
     * @returns {Object} The receiver.
     * @fires Change
     */

    var count,
        thisref,

        shouldSignal;

    if (!TP.canInvoke(aCollection, 'perform')) {
        return this.raise(
                    'TP.sig.InvalidCollection',
                    'Collection must support perform for atAll operation.');
    }

    count = 0;
    thisref = this;

    shouldSignal = this.shouldSignalChange();

    try {
        aCollection.perform(
            function(item, index) {
                //  duplicate test, but we want to know if we should count
                if (TP.isDefined(thisref.at(item))) {
                    //  turn off change signaling - 'removeKey' will reset
                    //  this setting, so redo each time through loop.
                    thisref.shouldSignalChange(false);

                    thisref.removeKey(item);
                    count++;
                }

                return this;
            });
    } finally {
        //  re-enable change notification
        this.shouldSignalChange(shouldSignal);
    }

    if (count > 0) {
        this.changed('value', TP.DELETE);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('removeKey',
function(aKey) {

    /**
     * @method removeKey
     * @summary Removes the key provided if the collection contains it. Note
     *     that this won't remove a key if the key references a method.
     * @param {Object} aKey The key value to remove.
     * @exception TP.sig.InvalidParameter
     * @returns {Object} The receiver.
     * @fires Change
     */

    if (TP.isEmpty(aKey)) {
        return this.raise(
                    'TP.sig.InvalidParameter',
                    'Empty key provided.');
    }

    if (TP.isDefined(this.at(aKey))) {
        this.$removeInternalKey(aKey);

        this.changed(aKey, TP.DELETE);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('removeKeys',
function(aKeyArray) {

    /**
     * @method removeKeys
     * @summary Removes the keys provided if the collection contains them. Note
     *     that this won't remove a key if the key references a method.
     * @param {String[]} aKeyArray The key values to remove.
     * @exception TP.sig.InvalidParameter
     * @returns {Object} The receiver.
     * @fires Change
     */

    var changed,

        len,
        i;

    if (!TP.isArray(aKeyArray)) {
        return this.raise('TP.sig.InvalidParameter',
                            'Invalid key array provided.');
    }

    changed = false;

    len = aKeyArray.getSize();
    for (i = 0; i < len; i++) {
        if (TP.isDefined(this.at(aKeyArray.at(i)))) {
            this.$removeInternalKey(aKeyArray.at(i));
            changed = true;
        }
    }

    if (changed) {
        this.changed('value', TP.DELETE);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('transpose',
function() {

    /**
     * @method transpose
     * @summary
     * @returns {TP.core.Hash}
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------
//  TP.api.SortedCollection
//  ------------------------------------------------------------------------

/*
By associating a sort function with the Hash we allow you to effectively use
a Hash as a sorted collection. The sort function is applied to the getKeys
calls used to drive iteration, thereby allowing you to have predictable
ordering to the Hash. NOTE that there is no default sort block so without
setting a sort function for the Hash no sort overhead is incurred.
*/

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('getSortFunction',
function() {

    /**
     * @method getSortFunction
     * @summary Returns the current sort function or null.
     * @returns {Function} This array's sort function.
     */

    return this.sortFunction;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('setSortFunction',
function(aFunction) {

    /**
     * @method setSortFunction
     * @summary Sets the receiver's internal sort function.
     * @description This function will be called any time the receiver has been
     *     updated without being sorted and a request for a value is made. This
     *     method will flag the receiver so that a re-sort will occur on the
     *     next data access call.
     * @param {Function} aFunction The function to set this array's sort
     *     function to.
     * @exception TP.sig.InvalidFunction
     * @returns {TP.core.Hash} The receiver.
     * @fires Change
     */

    //  no change? don't waste time
    if (TP.identical(aFunction, this.sortFunction)) {
        return this;
    }

    this.sortFunction = aFunction;

    //  notify, since our order will be different for consumers
    this.changed('order', TP.SORTED);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('sort',
function(aSortFunction) {

    /**
     * @method sort
     * @summary Sorts the receiver's keys, possibly reordering the items in the
     *     receiver. NOTE that if no function is supplied here and the receiver
     *     doesn't have a sort function installed via setSortFunction(), the
     *     results are sorted alphabetically by key string values.
     * @param {Function} aSortFunction A function capable of sorting the
     *     receiver's key array.
     * @returns {TP.core.Hash} The receiver.
     */

    var func;

    func = aSortFunction || this.getSortFunction();

    //  Have to avoid passing null to sort() on FF or it freaks out.
    if (TP.isCallable(func)) {
        TP.keys(this).sort(func);
    } else {
        TP.keys(this).sort();
    }

    this.changed('order', TP.SORTED);

    return this;
});

//  ------------------------------------------------------------------------
//  DNU HANDLING
//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('canResolveDNU',
function(anOrigin, aMethodName, anArgArray, callingContext) {

    /**
     * @method canResolveDNU
     * @summary Provides an instance that has triggered the DNU machinery with
     *     an opportunity to handle the problem itself. For TP.core.Hash
     *     instances this results in a test to see if the method is a getter and
     *     whether the receiver has a key fitting a pattern such that at() would
     *     resolve the query.
     * @param {Object} anOrigin The object asking for help. The receiver in this
     *     case.
     * @param {String} aMethodName The method name that failed.
     * @param {Object[]} anArgArray Optional arguments to function.
     * @param {Function|arguments} callingContext The calling context.
     * @returns {Boolean} TRUE means resolveDNU() will be called. FALSE means
     *     the standard DNU machinery will continue processing. The default is
     *     FALSE.
     */

    var key;

    if (TP.regex.GETTER.test(aMethodName)) {

        key = aMethodName.replace(
                TP.regex.GETTER,
                function(whole, part) {

                    return part.toLowerCase();
                });

        return TP.isDefined(this.at(key));
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.core.Hash.Inst.defineMethod('resolveDNU',
function(anOrigin, aMethodName, anArgArray, callingContext) {

    /**
     * @method resolveDNU
     * @summary Invoked by the main DNU machinery when the instance has
     *     responded TRUE to canResolveDNU() for the parameters given. For a
     *     hash this means returning the key in question based on the "getter"
     *     prefix being removed.
     * @param {Object} anOrigin The object asking for help.
     * @param {String} aMethodName The method name that failed.
     * @param {Object[]} anArgArray Optional arguments to function.
     * @param {Function|arguments} callingContext The calling context.
     * @returns {Object} The results of function resolution.
     */

    var key;

    key = aMethodName.replace(
            TP.regex.GETTER,
            function(whole, part) {

                return part.toLowerCase();
            });

    return this.at(key);
});

//  ========================================================================

/**
 * @type {TP.core.Iterator}
 * @summary TP.core.Iterator supports collection iteration.
 * @description TP.core.Iterator implements the TP.api.IterationAPI protocol as
 *     well as defining some basic constants and function implementions.
 * @example
 *     //  to print out a collection's elements
 *     var it = aCollection.asIterator();
 *     while (!it.atEnd()) {
 *         TP.info(it.nextValue());
 *     }
 *
 *     //   to do it in reverse
 *     var it = aCollection.asIterator();
 *     it.reverse();
 *     while (!it.atEnd()) {
 *         TP.info(it.nextValue());
 *     }
 *
 *     //  to locate a value and get the index of it
 *     while (!it.atEnd()) {
 *         if (it.nextValue() == aValue) {
 *             return it.currentKey();
 *         }
 *     }
 *
 *     //  slicing
 *     it.seek(start);
 *     while (!it.atEnd() && (it.currentKey() != end) {
 *         arr.push(it.nextValue());
 *     }
 *
 *     //   get current value (what nextValue() last returned)
 *     it.currentValue();
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.Iterator');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  the current step amount, always a positive increment
TP.core.Iterator.Inst.defineAttribute('step');

//  create the range we're working with, the "viewport" of indices
TP.core.Iterator.Inst.defineAttribute('range');

//  the collection we're iterating on
TP.core.Iterator.Inst.defineAttribute('coll');

//  are we "active", i.e. have we started iterating??
TP.core.Iterator.Inst.defineAttribute('active', false);

//  the keys for the collection, which is what we really iterate on
TP.core.Iterator.Inst.defineAttribute('keys');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('init',
function(aCollection, aStep) {

    /**
     * @name init
     * @summary Initialize the iterator instance.
     * @param {TP.api.Collection} aCollection The collection to iterate over.
     * @param {Number} aStep The step size to use. Iteration can occur in
     *     "steps" by setting a size other than 1. The default is 1.
     * @exception TP.sig.InvalidCollection
     * @returns {TP.core.Iterator} A new instance.
     * @todo
     */

    var i,
        step,
        range;

    if (TP.notValid(aCollection)) {
        return TP.raise(this, 'TP.sig.InvalidCollection', arguments);
    }

    this.callNextMethod();

    step = TP.ifInvalid(aStep, 1);
    this.$set('step', (1).max(step));
    step = this.$get('step');

    //  range is our internal set of indices
    range = TP.ac();
    this.$set('range', range);

    //  set up for 0 thru step-1 as starting range "ready" but not "active"
    for (i = 0; i < step; i++) {
        range.atPut(i, i);
    }

    //  capture the collection reference
    this.$set('coll', aCollection);

    this.$set('keys', aCollection.getKeys());

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('atEnd',
function() {

    /**
     * @name atEnd
     * @summary Returns true if the iterator is positioned at the end. The
     *     'end' may be the front of the collection if reverse() has been
     *     called.
     * @returns {Boolean}
     */

    var range;

    //  where we are only matters if we've been activated via next*()
    if (this.get('active')) {
        range = this.get('range');

        //  if no new data can be reached by incrementing the range then
        //  we're 'atEnd'
        return range.at(range.getSize() - 1) >=
            this.get('keys').getSize() - 1;
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('atStart',
function() {

    /**
     * @name atStart
     * @summary Returns true if the iterator is positioned at the start. The
     *     'start' may be the end of the collection if reverse() has been
     *     called.
     * @returns {Boolean}
     */

    return this.get('range').at(0) === 0;
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('currentItem',
function() {

    /**
     * @name currentItem
     * @summary Returns the current "item" of the iterator. Items consist of a
     *     key/value pair i.e. they are "ordered pairs".
     * @returns {Object|undefined} The item of the underlying collection at the
     *     current iterator location or undefined.
     */

    var arr;

    if (!this.get('active')) {
        return;
    }

    if (this.get('step') > 1) {
        return;
    }

    arr = TP.ac();
    arr.atPut(0, this.currentKey());
    arr.atPut(1, this.get('coll').at(this.currentKey()));

    return arr;
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('currentItems',
function() {

    /**
     * @name currentItems
     * @summary Returns the current "items" of the iterator. Items consist of a
     *     key/value pair i.e. they are "ordered pairs".
     * @returns {Object[]|undefined} The items of the underlying collection at
     *     the current iterator location or undefined.
     * @todo
     */

    var i,
        k,
        arr,
        tmparr,
        coll;

    if (!this.get('active')) {
        return;
    }

    k = this.currentKeys();
    if (TP.notValid(k)) {
        return;
    }

    coll = this.get('coll');
    tmparr = TP.ac();
    for (i = 0; i < k.getSize(); i++) {
        arr = TP.ac();
        arr.atPut(0, k.at(i));
        arr.atPut(1, coll.at(k.at(i)));

        tmparr.add(arr);
    }

    return tmparr;
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('currentKey',
function() {

    /**
     * @name currentKey
     * @summary Returns the current key of the iterator.
     * @description Iterators work from the keys/indices of thier underlying
     *     collection. This method returns the current key rather than the
     *     current value. If the iterator has a step greater than 1 this method
     *     returns undefined; use currentKeys() to get the set of keys. If the
     *     iterator hasn't yet been used via next*(), this method will return
     *     undefined.
     * @returns {Object|undefined} The key/index of the underlying collection at
     *     the current iterator location or undefined.
     */

    if (!this.get('active')) {
        return;
    }

    if (this.get('step') > 1) {
        return;
    }

    return this.get('keys').at(this.get('range').at(0));
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('currentKeys',
function() {

    /**
     * @name currentKeys
     * @summary Returns an array containing the current keys of the iterator.
     * @description This array will contain "step" number of keys so if the
     *     iterator has a step of five an array of five keys will be returned.
     *     If the iterator hasn't yet been used via next*(), this method returns
     *     undefined.
     * @returns {String[]|undefined} An array of keys or undefined.
     * @todo
     */

    var i,
        tmparr,
        step,
        keys,
        coll,
        range,
        len;

    if (!this.get('active')) {
        return;
    }

    tmparr = TP.ac();

    step = this.get('step');
    keys = this.get('keys');
    coll = this.get('coll');
    range = this.get('range');
    len = coll.getSize();

    for (i = 0; i < step; i++) {
        if (range.at(i) < len) {
            tmparr.add(keys.at(range.at(i)));
        }
    }

    return tmparr;
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('currentValue',
function() {

    /**
     * @name currentValue
     * @summary Returns the element of the collection at the iterator's
     *     currentKey().
     * @description If the iterator hasn't been used via next*() this method
     *     returns undefined. If the iterator has a step value > 1 this method
     *     returns undefined -- use currentValues() for iterators with larger
     *     step sizes.
     * @exception TP.sig.InvalidIndex
     * @returns {Object|undefined} An object or undefined.
     */

    if (!this.get('active')) {
        return;
    }

    if (this.get('step') > 1) {
        return;
    }

    return this.get('coll').at(this.currentKey());
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('currentValues',
function() {

    /**
     * @name currentValues
     * @summary Returns an array of elements from the currentKeys(). If the
     *     iterator hasn't yet been used this method returns undefined.
     * @returns {Object[]|undefined} An array, or undefined.
     * @todo
     */

    if (!this.get('active')) {
        return;
    }

    return this.get('coll').atAll(this.currentKeys());
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('nextItem',
function() {

    /**
     * @name nextItem
     * @summary Returns the next key/value pair from the iterator.
     * @returns {Object|undefined} An ordered pair/item.
     */

    if (TP.notValid(this.nextKey())) {
        return;
    }

    //  note that the previous line (nextKey()) incremented for us
    return this.currentItem();
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('nextItems',
function() {

    /**
     * @name nextItems
     * @summary Returns an array of items from the currentKeys() locations in
     *     the underlying collection.
     * @returns {Object[]|undefined} An array of items or undefined.
     * @todo
     */

    if (TP.notValid(this.nextKeys())) {
        return;
    }

    //  note that the previous line (nextKeys()) incremented for us
    return this.currentItems();
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('nextKey',
function() {

    /**
     * @name nextKey
     * @summary Returns the next available key from the iterator or undefined
     *     if atEnd(). If the iterator has a step size > 1 this method returns
     *     undefined. Use nextKeys() in cases where the iterator has a larger
     *     step size.
     * @returns {Object|undefined} An object or undefined.
     * @signals PositionChange
     * @todo
     */

    var i,
        range;

    if (this.atEnd()) {
        return;
    }

    if (this.get('step') > 1) {
        return;
    }

    range = this.get('range');
    if (this.get('active')) {
        for (i = 0; i < range.getSize(); i++) {
            range.atPut(i, range.at(i) + this.get('step'));
        }
    } else {
        this.set('active', true);
    }

    this.changed('position', TP.UPDATE);

    return this.currentKey();
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('nextKeys',
function() {

    /**
     * @name nextKeys
     * @summary Returns an array containing the next "step" number of keys for
     *     the iterator. If the iterator is atEnd() the result is undefined.
     * @returns {String[]|undefined} An array or undefined.
     * @signals PositionChange
     * @todo
     */

    var i,
        range;

    if (this.atEnd()) {
        return;
    }

    range = this.get('range');
    if (this.get('active')) {
        for (i = 0; i < range.getSize(); i++) {
            range.atPut(i, range.at(i) + this.get('step'));
        }
    } else {
        this.set('active', true);
    }

    this.changed('position', TP.UPDATE);

    return this.currentKeys();
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('nextValue',
function() {

    /**
     * @name nextValue
     * @summary Returns the next available element from the iterator or
     *     undefined if the element doesn't exist. This method also returns
     *     undefined if the iterator has a step size > 1.
     * @exception TP.sig.InvalidIndex
     * @returns {Object|undefined} An object or undefined.
     * @signals PositionChange
     * @todo
     */

    var k;

    if (this.get('step') > 1) {
        return;
    }

    k = this.nextKey();
    if (TP.notValid(k)) {
        return;
    }

    return this.get('coll').at(k);
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('nextValues',
function() {

    /**
     * @name nextValues
     * @summary Returns an array containing the next "step" number of elements
     *     from the collection. This is the preferred method to call when using
     *     a step size other than 1.
     * @exception TP.sig.InvalidIndex
     * @returns {Object[]|undefined} An array or undefined.
     * @signals PositionChange
     * @todo
     */

    var k;

    k = this.nextKeys();
    if (TP.notValid(k)) {
        return;
    }

    return this.get('coll').atAll(k);
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('peekNextKeys',
function() {

    /**
     * @name peekNextKeys
     * @summary Returns an array containing the current keys of the iterator
     *     (but DOES NOT advance the iterator!).
     * @description This array will contain "step" number of keys so if the
     *     iterator has a step of five an array of five keys will be returned.
     *     If the iterator hasn't yet been used via next*(), this method returns
     *     undefined.
     * @returns {String[]|undefined} An array of keys or undefined.
     * @todo
     */

    var i,
        tmparr,
        step,
        range,
        keys;

    if (!this.get('active')) {
        return;
    }

    if (this.atEnd()) {
        return;
    }

    tmparr = TP.ac();

    step = this.get('step');
    range = this.get('range');
    keys = this.get('keys');

    if (this.get('active')) {
        for (i = 0; i < step; i++) {
            tmparr.add(keys.at(range.at(i) + step));
        }
    } else {
        this.set('active', true);
    }

    return tmparr;
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('previousItem',
function() {

    /**
     * @name previousItem
     * @summary Returns the previous item from the iterator's collection or
     *     undefined.
     * @returns {Object|undefined} An object or undefined.
     * @signals PositionChange
     * @todo
     */

    if (TP.notValid(this.previousKey())) {
        return;
    }

    //  note that the previous line (previousKey()) decremented for us
    return this.currentItem();
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('previousItems',
function() {

    /**
     * @name previousItems
     * @summary Returns an array containing the previous items from the
     *     iterators collection.
     * @returns {Object[]|undefined} An Array or undefined.
     * @signals PositionChange
     * @todo
     */

    if (TP.notValid(this.previousKeys())) {
        return;
    }

    //  note that the previous line (previousKeys()) decremented for us
    return this.currentItems();
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('previousKey',
function() {

    /**
     * @name previousKey
     * @summary Returns the previous available key from the iterator or
     *     undefined if atStart(). If the iterator has a step size > 1 this
     *     method returns undefined. Use previousKeys() in cases where the
     *     iterator has a larger step size.
     * @returns {Object|undefined} An object or undefined.
     * @signals PositionChange
     * @todo
     */

    var i,
        range,
        step;

    //  avoid decrementing below 0
    if (this.atStart()) {
        return;
    }

    if (this.get('step') > 1) {
        return;
    }

    range = this.get('range');
    step = this.get('step');

    if (this.get('active')) {
        for (i = 0; i < range.getSize(); i++) {
            range.atPut(i, range.at(i) - step);
        }
        this.changed('position', TP.UPDATE);
    }

    return this.currentKey();
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('previousKeys',
function() {

    /**
     * @name previousKeys
     * @summary Returns an array containing the previous "step" number of keys
     *     for the iterator. If the iterator is atEnd() the result is undefined.
     * @returns {String[]|undefined} An array or undefined.
     * @signals PositionChange
     * @todo
     */

    var i,
        step,
        range;

    //  avoid decrementing below 0
    if (this.atStart()) {
        return;
    }

    step = this.get('step');
    range = this.get('range');

    if (this.get('active')) {
        for (i = 0; i < range.getSize(); i++) {
            range.atPut(i, range.at(i) - step);
        }
        this.changed('position', TP.UPDATE);
    }

    return this.currentKeys();
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('previousValue',
function() {

    /**
     * @name previousValue
     * @summary Returns the previous element from the iterator or undefined.
     *     This method also returns undefined if the iterator has a step value >
     *     1.
     * @returns {Object|undefined} An object or undefined.
     * @signals PositionChange
     * @todo
     */

    var k;

    if (this.get('step') > 1) {
        return;
    }

    k = this.previousKey();
    if (TP.notValid(k)) {
        return;
    }

    return this.get('coll').at(k);
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('previousValues',
function() {

    /**
     * @name previousValues
     * @summary Returns an array containing the previous "step" number of
     *     elements from the collection. If the iterator is atStart() or hasn't
     *     yet be used via next*() this method returns undefined.
     * @returns {Object[]|undefined} An array or undefined.
     * @signals PositionChange
     * @todo
     */

    var k;

    k = this.previousKeys();
    if (TP.notValid(k)) {
        return;
    }

    return this.get('coll').atAll(k);
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('reverse',
function() {

    /**
     * @name reverse
     * @summary Changes the direction of the iterator. This method can only be
     *     used when the iterator is atEnd() or atStart().
     * @returns {TP.core.Iterator} The receiver or undefined.
     * @signals PositionChange
     * @todo
     */

    if (!this.atEnd() && !this.atStart()) {
        return this;
    }

    this.get('keys').reverse();
    this.seek(0);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('rewind',
function() {

    /**
     * @name rewind
     * @summary Sets the iterator back to the start of the collection if
     *     iterating forward or to the end if iterating backwards.
     * @returns {TP.core.Iterator} The receiver.
     * @signals PositionChange
     * @todo
     */

    return this.seek(0);
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('seek',
function(anIndex) {

    /**
     * @name seek
     * @summary Sets the iterator to the index location provided. If no
     *     index/key is provided the iterator 'rewinds' to the starting
     *     location.
     * @param {Number} anIndex A numerical index to seek.
     * @returns {TP.core.Iterator} The receiver.
     * @signals PositionChange
     * @todo
     */

    var ind,
        i,
        range;

    ind = TP.ifInvalid(anIndex, 0);

    if (ind < 0) {
        //  deal with negative indexes
        ind = (0).max(this.get('keys').getSize() + ind);
    }

    range = this.get('range');
    for (i = 0; i < range.getSize(); i++) {
        range.atPut(i, ind + i);
    }

    if (ind === 0) {
        this.set('active', false);
    }

    this.changed('position', TP.SEEK);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('seekToKey',
function(aKey) {

    /**
     * @name seekToKey
     * @summary Sets the iterator to the index of the key provided. If no key
     *     is provided (or the key cannot be found) the iterator 'rewinds' to
     *     the starting location.
     * @param {The} aKey key to seek to.
     * @returns {TP.core.Iterator} The receiver.
     * @signals PositionChange
     * @todo
     */

    this.seek(this.get('keys').indexOf(aKey));

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Iterator.Inst.defineMethod('sort',
function(aSortFunction) {

    /**
     * @name sort
     * @summary Sorts the iterator's internal keys so that subsequent iteration
     *     occurs in a sorted fashion. As with reverse() this operation can only
     *     be performed when the iterator is atStart() or atEnd().
     * @param {Function} aSortFunction A function conforming to the rules for
     *     array sort functions used to sort the keys.
     * @returns {TP.core.Iterator} The receiver.
     * @signals OrderChange, PositionChange
     * @todo
     */

    if (!this.atEnd() && !this.atStart()) {
        return this;
    }

    //  apparently "undefined" isn't a "valid sort argument" :)
    if (TP.isCallable(aSortFunction)) {
        this.get('keys').sort(aSortFunction);
    } else {
        this.get('keys').sort();
    }

    this.seek(0);
    this.changed('order', TP.SORTED);

    return this;
});

//  ------------------------------------------------------------------------
/*
TP.core.Iterator.Inst.defineMethod('getCurrentItem',
                TP.core.Iterator.getInstPrototype().currentItem.copy());
TP.core.Iterator.Inst.defineMethod('getCurrentItems',
                TP.core.Iterator.getInstPrototype().currentItems.copy());
TP.core.Iterator.Inst.defineMethod('getCurrentKey',
                TP.core.Iterator.getInstPrototype().currentKey.copy());
TP.core.Iterator.Inst.defineMethod('getCurrentKeys',
                TP.core.Iterator.getInstPrototype().currentKeys.copy());
TP.core.Iterator.Inst.defineMethod('getCurrentValue',
                TP.core.Iterator.getInstPrototype().currentValue.copy());
TP.core.Iterator.Inst.defineMethod('getCurrentValues',
                TP.core.Iterator.getInstPrototype().currentValues.copy());

TP.core.Iterator.Inst.defineMethod('getNextItem',
                TP.core.Iterator.getInstPrototype().currentItem.copy());
TP.core.Iterator.Inst.defineMethod('getNextItems',
                TP.core.Iterator.getInstPrototype().currentItems.copy());
TP.core.Iterator.Inst.defineMethod('getNextKey',
                TP.core.Iterator.getInstPrototype().currentKey.copy());
TP.core.Iterator.Inst.defineMethod('getNextKeys',
                TP.core.Iterator.getInstPrototype().currentKeys.copy());
TP.core.Iterator.Inst.defineMethod('getNextValue',
                TP.core.Iterator.getInstPrototype().currentValue.copy());
TP.core.Iterator.Inst.defineMethod('getNextValues',
                TP.core.Iterator.getInstPrototype().currentValues.copy());

TP.core.Iterator.Inst.defineMethod('getPreviousItem',
                TP.core.Iterator.getInstPrototype().currentItem.copy());
TP.core.Iterator.Inst.defineMethod('getPreviousItems',
                TP.core.Iterator.getInstPrototype().currentItems.copy());
TP.core.Iterator.Inst.defineMethod('getPreviousKey',
                TP.core.Iterator.getInstPrototype().currentKey.copy());
TP.core.Iterator.Inst.defineMethod('getPreviousKeys',
                TP.core.Iterator.getInstPrototype().currentKeys.copy());
TP.core.Iterator.Inst.defineMethod('getPreviousValue',
                TP.core.Iterator.getInstPrototype().currentValue.copy());
TP.core.Iterator.Inst.defineMethod('getPreviousValues',
                TP.core.Iterator.getInstPrototype().currentValues.copy());
*/
//  ========================================================================

/**
 * @type {TP.core.Range}
 * @summary TP.core.Range provides a simple interface to a range of numbers.
 *     This allows for interesting iteration possibilities such as:
 *
 *     (1).to(10).perform(function (ind) {alert('index is: ' + ind)});
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.Range');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.core.Range.Inst.defineAttribute('start');
TP.core.Range.Inst.defineAttribute('end');

TP.core.Range.Inst.defineAttribute('step');

TP.core.Range.Inst.defineAttribute('keys');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.Range.Inst.defineMethod('init',
function(startIndex, endIndex, aStep) {

    /**
     * @method init
     * @summary Initializes a new instance
     * @param {Number} startIndex The beginning index of the range.
     * @param {Number} endIndex The end index of the range.
     * @param {Number} aStep The range increment for interation. When the start
     *     is smaller than the end this defaults to 1, when the start is larger
     *     than the end the step defaults to -1.
     * @returns {TP.core.Range} A new instance.
     */

    var startInd,
        endInd;

    this.callNextMethod();

    //  convert to Numbers to be sure
    if (TP.notValid(startIndex) || TP.isNaN(startInd = startIndex.asNumber())) {
        startInd = 0;
    }

    if (TP.notValid(endIndex) || TP.isNaN(endInd = endIndex.asNumber())) {
        endInd = TP.MAX_DOUBLE;
    }

    this.set('start', startInd);
    this.set('end', endInd);

    //  step defaults based on direction
    if (startInd > endInd) {
        this.set('step', TP.ifInvalid(aStep, -1));
    } else {
        this.set('step', TP.ifInvalid(aStep, 1));
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Range.Inst.defineMethod('asArray',
function() {

    /**
     * @method asArray
     * @summary Returns the receiver in array form (as an Array of its keys).
     * @returns {Object[]} The receiver as an Array.
     */

    var vals;

    vals = TP.ac();

    this.perform(
        function(aVal) {
            vals.push(aVal);
        });

    return vals;
});

//  ------------------------------------------------------------------------

TP.core.Range.Inst.defineMethod('at',
function(anIndex) {

    /**
     * @method at
     * @summary Returns the range key at the index provided.
     * @param {Number} anIndex The index to access.
     * @returns {Object} The object at the index provided.
     */

    var arr;

    if (TP.notValid(arr = this.get('keys'))) {
        return null;
    }

    return arr.at(anIndex);
});

//  ------------------------------------------------------------------------

TP.core.Range.Inst.defineMethod('by',
function(aStep) {

    /**
     * @method by
     * @summary Sets the range iteration step size.
     * @param {Number} aStep The numerical step size.
     * @returns {TP.core.Range} The receiver.
     */

    //  new step? then use it
    if (!TP.isNumber(aStep)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  truncate
    this.empty();

    this.set('step', aStep);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Range.Inst.defineMethod('empty',
function() {

    /**
     * @method empty
     * @summary Clears the range's internal index cache, if it exists.
     * @returns {TP.core.Range} The receiver.
     */

    this.$set('keys', null);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Range.Inst.defineMethod('getKeys',
function() {

    /**
     * @method getKeys
     * @summary Returns an array containing the keys of the receiver.
     * @returns {String[]} The receiver as an array of key values.
     */

    var keys,

        step,
        start,
        end,

        i;

    if (TP.notValid(keys = this.$get('keys'))) {
        keys = TP.ac();

        step = this.get('step');
        start = this.get('start');
        end = this.get('end');

        if (step.isPositive()) {
            for (i = start; i <= end; i = i + step) {
                keys.push(i);
            }
        } else {
            //  still adding step, it's negative...
            for (i = start; i >= end; i = i + step) {
                keys.push(i);
            }
        }

        this.set('keys', keys);
    }

    return keys;
});

//  ------------------------------------------------------------------------

TP.core.Range.Inst.defineMethod('perform',
function(aFunction) {

    /**
     * @method perform
     * @summary Iterates over the range and invokes aFunction on each
     *     iteration.
     * @param {Function} aFunction The function to invoke on each iteration.
     *     This function should accept the loop count as its only parameter.
     * @returns {TP.core.Range} The receiver.
     */

    var count,

        step,
        start,
        end,
        i;

    count = 0;

    step = this.get('step');
    start = this.get('start');
    end = this.get('end');

    /* eslint-disable no-extra-parens */
    if (step.isPositive()) {
        for (i = start; i <= end; i = i + step) {
            if (aFunction(i, count) === TP.BREAK) {
                break;
            }
            count++;
        }
    } else {
        //  still adding step, it's negative...
        for (i = start; i >= end; i = i + step) {
            if (aFunction(i, count) === TP.BREAK) {
                break;
            }

            count++;
        }
    }
    /* eslint-enable no-extra-parens */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Range.Inst.defineMethod('performUntil',
function(aFunction, terminateFunction) {

    /**
     * @method performUntil
     * @summary Performs the function on each iteration of the receiver until
     *     terminateFunction returns true.
     * @description performUntil can be used as an alternative to constructing
     *     repeat loops to iterate over a range.
     * @param {Function} aFunction A function which performs some action with
     *     each iteration.
     * @param {Function} terminateFunction A test Function which ends the loop.
     *     This should be a Function that returns a Boolean. It is passed the
     *     same data as the performed function.
     * @returns {TP.core.Range} The receiver.
     */

    var f,
        tst,
        count,
        step,
        start,
        end,
        i;

    f = TP.RETURN_FALSE;
    tst = terminateFunction;

    if (!TP.isCallable(tst)) {
        tst = f;
    }

    count = 0;

    step = this.get('step');
    start = this.get('start');
    end = this.get('end');

    if (step.isPositive()) {
        for (i = start; i <= end; i = i + step) {
            aFunction(i, count);
            if (tst(i, count)) {
                break;
            }
            count++;
        }
    } else {
        //  still adding step, it's negative...
        for (i = start; i >= end; i = i + step) {
            aFunction(i, count);
            if (tst(i, count)) {
                break;
            }
            count++;
        }
    }
    /* eslint-enable no-extra-parens */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Range.Inst.defineMethod('performWhile',
function(aFunction, terminateFunction) {

    /**
     * @method performWhile
     * @summary Performs the function on each iteration of the receiver while
     *     terminateFunction returns true.
     * @description performUntil can be used as an alternative to constructing
     *     while loops to iterate over a range
     * @param {Function} aFunction A function which performs some action with
     *     each iteration index.
     * @param {Function} terminateFunction A test Function which ends the loop.
     *     This should be a Function that returns a Boolean. It is passed the
     *     same data as the performed function.
     * @returns {TP.core.Range} The receiver.
     */

    var count,
        step,
        start,
        end,
        i;

    count = 0;

    step = this.get('step');
    start = this.get('start');
    end = this.get('end');

    if (step.isPositive()) {
        for (i = start; i <= end; i = i + step) {
            if (TP.notTrue(terminateFunction(i, count))) {
                break;
            }
            aFunction(i, count);
            count++;
        }
    } else {
        //  still adding step, it's negative...
        for (i = start; i >= end; i = i + step) {
            if (TP.notTrue(terminateFunction(i, count))) {
                break;
            }
            aFunction(i, count);
            count++;
        }
    }
    /* eslint-enable no-extra-parens */

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETURITypes.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
The TP.uri.URI type and its subtypes are central to development with TIBET.

Everything in TIBET has a URI, from the data you work with on a remote server to
the data cached in the client to the elements in your UI. Access to these
objects for purposes of manipulation or data binding is done by leveraging the
features of the TP.uri.URI type and its subtypes.

TP.uri.URL is the root for most common URIs including those for the http: and
file: schemes most web developers are familiar with. Most of the time when
you're working with a data source you're working with an instance of some
concrete TP.uri.URL subtype such as TP.uri.HTTPURL or TP.uri.FileURL.

TP.uri.URN (urn:*) is the typical URI form for "named objects" such as the
types in the TIBET system or other objects for which a public name is useful or
necessary. Most URNs in TIBET use a namespace ID (NID) of 'tibet' so most URN
instances start off with urn:tibet: followed by the actual name string.
Instances of TP.uri.URN are typically instances of an NID-specific subtype so
that each subtype can process the namespace specific string (NSS) portion in a
namespace-specific fashion. TP.uri.TIBETURN is the most common TP.uri.URN
subtype.

TP.uri.TIBETURN (urn:tibet:*) is a TIBET-specific URL type which provides
extensions to the general URI addressing model. In particular, TIBET URLs allow
for dynamic resolution and targeting of objects in "browser space". TIBET URLs
will be created when a virtual URI path is specified (i.e. one that uses a
leading ~ prefix to create paths such as ~lib/ or ~app/ which refer to "the
TIBET library root" and "the current application root" respectively. See below
for more information on virtual URIs.

TIBET's URI types each have the ability to manage a cache for their data so that
bandwidth can be managed efficiently. The focal point for caching is the URI
instance itself, which also manages header and content data for all access to
that instance's target resource. URI caching for things like client-side
templates and common lookup code tables is a typical use case.

URI-related standards like XInclude and XPointer are also supported by the
appropriate URI subtypes. These standards provide additional ways to help you
modularize your application for better maintainability and performance. By
leveraging XPointer for example, you can slice content from template files or
access portions of a REST response with ease.

See the individual type documentation for more information and examples.

Note that the underlying 'URI primitives' capability of TIBET, in addition to
standard URI 'slicing and dicing' operations, also support what are known as
"virtual URIs". These are URIs that have a leading tilde ('~') prefix and that
resolve to a value at run time using the built in configuration system. For
instance, a path of '~lib_xsl' will use the value in the configuration system
named 'path.lib_xsl'. There are a number of shortcuts that can be used with
virtual URIs:

    ~app    The application root
    ~lib    The library root

*/

//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.uri.URI
//  ========================================================================

/**
 * @type {TP.uri.URI}
 * @summary An abstract type that models Uniform Resource Identifiers in the
 *     TIBET system. While abstract, this type's constructor should always be
 *     used directly or via the TP.uc() primitive.
 * @description The top-level URI type in the TIBET system is an abstract type.
 *     This follows the somewhat 'classical' view of the W3C spec, where URIs
 *     represent the overall Web addressing and naming scheme and various
 *     scheme-specific forms manage the concrete data. When you ask for an
 *     instance of URI in TIBET you get back an instance of a subtype specific
 *     to the URI scheme you provided. This is consistent with the reality that
 *     only a scheme-specific parser and processor can truly manage each
 *     scheme's URI format and requirements.
 *
 *     When asked for content, the TP.uri.URI types typically return content
 *     objects based on the MIME type of the content. If a type representing the
 *     content MIME type is registered as a content handler in TIBET's
 *     TP.ietf.mime map that type's constructContentObject() method is used to
 *     construct an instance for the new data. For example, JSON data, which has
 *     a TP.ietf.mime type definition, will return a JavaScript instance which
 *     may further resolve its type based on JSON rules. In a similar fashion,
 *     CSS files return specific CSS content wrappers. You can extend this
 *     approach to support your own custom data formats as you require by
 *     pairing the MIME type your server sends with a client-side handler.
 *
 *     For flexibility, TP.uri.URI uses a combination of URI "helpers" and URI
 *     "handlers". Certain operations on a URI such as load, save, or delete
 *     are first checked for rewrite and remap data which would either change
 *     the concrete URI or delegate it to a different concrete handler.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('uri.URI');

//  TP.uri.URI is an abstract type in TIBET terms, meaning you can't
//  construct a concrete instance of TP.uri.URI (but you can invoke the
//  constructor to get a specialized subtype returned to you.)
TP.uri.URI.isAbstract(true);

//  Add support methods for sync vs. async mode and request rewriting.
TP.uri.URI.addTraits(TP.core.SyncAsync);

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineAttribute('BEST_URIMAP_SORT',
function(a, b) {
    var aMatch,
        bMatch;

    aMatch = a[0];
    bMatch = b[0];

    //  First criteria is number of parts matches.
    if (aMatch.length > bMatch.length) {
        return -1;
    } else if (aMatch.length < bMatch.length) {
        return 1;
    } else {
        //  Second criteria is length of the full match string...but we exempt
        //  the '/.*/' pattern from this consideration since it's a universal
        //  match that should only trigger as a last resort.
        if (a[1].at(a[2]).toString() === '/.*/') {
            return 1;
        } else if (b[1].at(b[2]).toString() === '/.*/') {
            return -1;
        }

        if (aMatch[0].length > bMatch[0].length) {
            return -1;
        } else if (aMatch[0].length < bMatch[0].length) {
            return 1;
        } else {
            //  All else being equal last definition wins.
            return -1;
        }
    }
});

//  ------------------------------------------------------------------------

//  regex used to scan uri map configuration settings for pattern keys.
TP.uri.URI.Type.defineConstant('URI_PATTERN_REGEX',
    /^uri\.map\.(?:.*)\.pattern$/);

//  placeholder for the scheme specific to the receiving type
TP.uri.URI.Type.defineConstant('SCHEME');

//  special aspects for URIs that will broadcast 'Change', but should mostly be
//  ignored by observers (certainly data-binding observers).
TP.uri.URI.Type.defineConstant('SPECIAL_ASPECTS',
    TP.ac('dirty', 'expired', 'loaded'));

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  most URI access is synchronous (file:, urn:, etc) so we
//  start with that here and override for http:, jsonp:, etc.
TP.uri.URI.set('supportedModes', TP.core.SyncAsync.SYNCHRONOUS);
TP.uri.URI.set('mode', TP.core.SyncAsync.SYNCHRONOUS);

//  holder for path-to-instance registrations.
TP.uri.URI.Type.defineAttribute(
            'instances',
            TP.ifInvalid(TP.uri.URI.$get('instances'), TP.hc()));

//  holder for scheme-to-type registrations.
TP.uri.URI.Type.defineAttribute(
            'schemeHandlers',
            TP.ifInvalid(TP.uri.URI.$get('schemeHandlers'), TP.hc()));

//  holder for URIs that have had their remote resources changed but that
//  haven't been refreshed.
TP.uri.URI.Type.defineAttribute('remoteChangeList', TP.hc());

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    this.defineDependencies('TP.extern.Promise');

    return;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('construct',
function(aURI, aResource) {

    /**
     * @method construct
     * @summary Returns a new instance of URI. The actual type of URI is based
     *     on the scheme and other related data. This method serves as a
     *     common factory for URI instances.
     * @param {String} aURI Ultimately an absolute path but normally a path
     *     starting with '.','/','-', or '~' which is expanded as needed.
     * @param {Object} [aResource] Optional value for the targeted resource.
     * @exception {TP.sig.NoConcreteType} When no concrete type can be found to
     *     construct an instance from.
     * @returns {TP.uri.URI|undefined} The new instance.
     */

    var url,
        check,
        flag,
        inst,
        type,
        err,
        built;

    //  Most common case is a string hoping to become a URI when it grows up. We
    //  want to check all variations of the incoming string before falling
    //  through into construction cycle.
    if (TP.isString(aURI)) {

        //  empty string?
        if (!aURI.trim()) {
            return;
        }

        //  Look for most common cases first (urn and virtual path)
        inst = TP.uri.URI.getInstanceById(TP.uriExpandPath(aURI));
        if (TP.notValid(inst)) {
            inst = TP.uri.URI.getInstanceById(TP.uriInTIBETFormat(aURI));
        }

        if (TP.notValid(inst)) {

            //  Assign so we can use a consistent name for input checks below.
            url = aURI;

            if (TP.regex.HAS_LINEBREAK.test(url)) {
                return;
            }

            //  Deal with common shorthands and other formatting variations.
            if (TP.regex.HAS_BACKSLASH.test(url)) {
                url = TP.uriInWebFormat(url);
            }

            if (url.indexOf('~') === 0 || url.indexOf('tibet:') === 0) {
                type = TP.uri.TIBETURL;
                check = TP.uriResolveVirtualPath(url);

                inst = TP.uri.URI.getInstanceById(check);
            } else if (url.indexOf('urn:') === 0) {
                url = url.replace('urn::', 'urn:tibet:');
                type = url.indexOf('urn:tibet:') === 0 ?
                        TP.uri.TIBETURN :
                        TP.uri.URN;

                inst = TP.uri.URI.getInstanceById(url);
            } else if (url.indexOf('#') === 0) {
                type = TP.uri.TIBETURL;
                url = 'tibet://uicanvas/' + url;

                inst = TP.uri.URI.getInstanceById(url);
            } else if (!TP.regex.URI_LIKELY.test(url) ||
                    TP.regex.REGEX_LITERAL_STRING.test(url)) {
                //  several areas in TIBET will try to resolve strings to URIs.
                //  try to eliminate the non-starters early.
                return;
            } else {
                //  normalize if possible, removing embedded './', '..', etc.,
                //  but we have to use a check here for ~ or tibet:///~ path
                url = TP.uriCollapsePath(url);
                inst = TP.uri.URI.getInstanceById(url);
            }

            if (TP.notValid(inst) && !TP.isType(type)) {
                //  One last adjustment is when a developer uses a typical url
                //  of the form '/' or './' etc. In those cases we need to
                //  update the url to include the current root.
                url = TP.uriWithRoot(url);
                inst = TP.uri.URI.getInstanceById(url);
            }
        }

    } else if (TP.notValid(aURI)) {
        return;
    } else if (TP.isKindOf(aURI, TP.uri.URI)) {
        inst = aURI;
    } else {
        //  TODO:   invoke a "by parts" variant if we get a TP.core.Hash
        //          with URI components (via rewrite() or other means).
        return;
    }

    if (TP.notValid(inst)) {
        //  we don't want to see exceptions when certain URI resolutions fail
        flag = TP.sys.shouldLogRaise();
        TP.sys.shouldLogRaise(false);

        try {
            type = type || this.getConcreteType(url);
            if (TP.isType(type)) {
                //  NOTE we skip this method and go directly to alloc/init
                //  version.
                inst = type.$construct(url);
                built = true;
            } else {
                //  !!!NOTE NOTE NOTE this WILL NOT LOG!!!
                return this.raise(
                    'TP.sig.NoConcreteType',
                    'Unable to locate concrete type for URI: ' + url);
            }
        } catch (e) {
            err = TP.ec(
                    e,
                    TP.join(TP.sc('URI construct produced error for: '), url));
            return this.raise('TP.sig.URIException', err);
        } finally {
            TP.sys.shouldLogRaise(flag);
        }
    }

    if (TP.isValid(inst)) {
        if (built) {
            inst.register();
        }

        if (TP.isValid(aResource)) {
            //  NEVER signal change during construction...no request made.
            inst.setResource(aResource, TP.hc('signalChange', false));
        }
    }

    return inst;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('uc',
function(aURI, aResource) {

    /**
     * @method uc
     * @summary A shorthand method for TP.uri.URI.construct().
     * @param {String} aURI Typically an absolute path but possibly a path
     *     starting with '.','/','-', or '~' which is adjusted as needed.
     * @param {Object} [aResource] Optional value for the targeted resource.
     * @returns {TP.uri.URI} The new instance.
     */

    return TP.uri.URI.construct(aURI, aResource);
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('asURI',
function() {

    /**
     * @method asURI
     * @summary A shorthand method for TP.uri.URI.construct().
     * @returns {TP.uri.URI} The new instance.
     */

    return TP.uri.URI.construct(this.asString());
});

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('fromDocument',
function(aDocument) {

    /**
     * @method fromDocument
     * @summary Constructs and returns a new instance by interrogating a
     *     document for its location information.
     * @param {Document} aDocument The document to interrogate for location
     *     data.
     * @exception {TP.sig.InvalidDocument} When aDocument isn't a valid
     *     Document.
     * @returns {TP.uri.URI|undefined} A new instance.
     */

    var path;

    if (!TP.isDocument(aDocument)) {
        this.raise('TP.sig.InvalidDocument');

        return;
    }

    //  document objects can be flagged by TIBET, in which case that wins...
    path = aDocument[TP.SRC_LOCATION];
    if (TP.notEmpty(path)) {
        return this.construct(path + '#document');
    }

    //  they also have their own location
    return this.construct(aDocument.location + '#document');
});

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('fromString',
function(aURIString) {

    /**
     * @method fromString
     * @summary Constructs and returns a new TP.uri.URI instance from a
     *     String.
     * @param {String} aURIString A String containing a proper URI.
     * @returns {TP.uri.URI} A new instance.
     */

    return this.construct(aURIString);
});

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('fromTP_uri_URI',
function(aURI) {

    /**
     * @method fromTP_uri_URI
     * @summary Returns the URI provided to help ensure unique entries exist.
     * @param {TP.uri.URI} aURI An existing URI.
     * @returns {TP.uri.URI} A new instance.
     */

    return aURI;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('fromWindow',
function(aWindow) {

    /**
     * @method fromWindow
     * @summary Constructs and returns a new instance by interrogating a window
     *     for its location information.
     * @param {Window} aWindow The window to interrogate to make the URI from.
     * @exception {TP.sig.InvalidWindow} When aWindow isn't a valid Window.
     * @returns {TP.uri.URI|undefined} A new instance.
     */

    if (!TP.isWindow(aWindow)) {
        this.raise('TP.sig.InvalidWindow');
        return;
    }

    //  NOTE that we force a string here; we don't want a location object,
    //  and for whatever reason certain older browsers can actually fail if
    //  you try to toString the darn thing.
    return this.construct('' + aWindow.location);
});

//  ------------------------------------------------------------------------
//  Type Registration
//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('getConcreteType',
function(aPath) {

    /**
     * @method getConcreteType
     * @summary Returns the type to use for a particular URI path.
     * @param {String} aPath A URI string providing at least a scheme which can
     *     be looked up for a concrete type.
     * @returns {TP.lang.RootObject} A type object.
     */

    var schemeRoot;

    schemeRoot = this.$get('schemeHandlers').at(
                                aPath.slice(0, aPath.indexOf(':')));

    //  Further allow each subtype to refine the concrete type being
    //  assigned. A specific example is TP.uri.URN which can specialize
    //  based on the specific NID.
    if (TP.owns(schemeRoot, 'getConcreteType')) {
        return schemeRoot.getConcreteType(aPath);
    }

    return schemeRoot;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('registerForScheme',
function(aScheme) {

    /**
     * @method registerForScheme
     * @summary Registers the receiving type for handling construction of URI
     *     instances for a particular scheme.
     * @param {String} aScheme A URI scheme such as http, file, etc.
     * @exception {TP.sig.InvalidParameter} When the scheme isn't a string.
     * @returns {TP.meta.uri.Type} The receiver.
     */

    var theScheme;

    if (!TP.isString(aScheme)) {
        return this.raise('TP.sig.InvalidParameter',
                            'Scheme is empty or null.');
    }

    theScheme = aScheme.strip(':');
    TP.uri.URI.$get('schemeHandlers').atPut(theScheme, this);

    //  TP.boot objects are primitive, so don't assume at() will work here.
    if (TP.notValid(TP.boot.$uriSchemes[theScheme])) {
        //  Add the scheme to TP.boot's '$uriSchemes' object so that the
        //  shell, etc. will treat the URIs using the scheme properly.
        TP.boot.$uriSchemes[theScheme] = theScheme;

        //  Rewrite the TP.regex.URI_LIKELY so that it reflects the new
        //  scheme as well.
        TP.regex.URI_LIKELY =
            TP.rc(TP.join('^~|^/|^\\.\\/|^\\.\\.\\/',
                            '|^',
                            TP.keys(TP.boot.$uriSchemes).join(':|^'),
                            ':',
                            '|^(?:\\w+):(?:.*)\\/'));

        //  Rewrite the TP.regex.ALL_SCHEMES so that it reflects the new
        //  scheme as well.
        TP.regex.ALL_SCHEMES =
            TP.rc(TP.join(TP.keys(TP.boot.$uriSchemes).join(':|'),
                            ':'));
    }

    return this;
});

//  ------------------------------------------------------------------------
//  Instance Registration
//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('getInstanceById',
function(anID) {

    /**
     * @method getInstanceById
     * @summary Returns the existing URI instance whose "ID" or path is the
     *     path provided. This uses the TP.uri.URI instance registry as the
     *     lookup location.
     * @param {String} anID A URI ID, which is typically the URI's
     *     fully-expanded and normalized location.
     * @returns {TP.uri.URI} A matching instance, if found.
     */

    return TP.uri.URI.$get('instances').at(anID);
});

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('hasInstance',
function(anID) {

    /**
     * @method hasInstance
     * @summary Returns whether a URI object with the supplied URI ID is in the
     *     TP.uri.URI instance registry.
     * @param {String} anID A URI ID, which is typically the URI's
     *     fully-expanded and normalized location.
     * @returns {Boolean} Whether or not an instance is registered with the
     *     type.
     */

    return TP.uri.URI.$get('instances').hasKey(anID);
});

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('registerInstance',
function(anInstance, aKey) {

    /**
     * @method registerInstance
     * @summary Registers an instance under that instance's URI string.
     *     Subsequent calls to construct an instance for that URI string will
     *     return the cached instance.
     * @param {TP.uri.URI} anInstance The instance to register.
     * @param {String} [aKey] The optional key to store the instance under.
     * @exception {TP.sig.InvalidURI}
     * @returns {TP.meta.uri.URI} The receiver.
     */

    var dict,
        key,
        current;

    //  update our instance registry with the instance, keying it under the
    //  URI ID.
    dict = this.$get('instances');

    key = aKey;
    if (TP.notValid(key)) {
        return this.raise('InvalidKey');
    }

    current = dict.at(key);
    if (TP.isValid(current) && current !== anInstance) {
        TP.warn('Replacing URI instance for registration key: ' + key);
    }

    //  Note here how we use the value of the 'uri' attribute - we want the
    //  original (but normalized) URI value - not the resolved 'location'.
    dict.atPut(key, anInstance);

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('removeInstance',
function(anInstance) {

    /**
     * @method removeInstance
     * @summary Removes an instance under all keys that instance is registered
     *     under.
     * @param {TP.uri.URI} anInstance The instance to remove.
     * @exception {TP.sig.InvalidURI}
     * @returns {TP.meta.uri.URI} The receiver.
     */

    var dict,
        seconds;

    if (!TP.isKindOf(anInstance, TP.uri.URI)) {
        return this.raise('InvalidURI');
    }

    //  update our instance registry by removing the instance, finding its key
    //  under the fully-expanded URI ID.
    dict = this.$get('instances');

    //  If the URI has sub URIs we need to remove them as well.
    if (TP.notEmpty(seconds = anInstance.getSecondaryURIs())) {
        seconds.forEach(
                    function(secondary) {
                        TP.uri.URI.removeInstance(secondary);
                        dict.removeValue(secondary, TP.IDENTITY);
                    });
    }

    //  remove all references to this URI, regardless of the particular key.
    dict.removeValue(anInstance, TP.IDENTITY);

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('validate',
function(anObject) {

    /**
     * @method validate
     * @summary Returns true if the object provided it meets the criteria for a
     *     valid URI.
     * @param {Object} anObject The object whose value should be verified.
     * @returns {Boolean} True if the object is 'valid'.
     */

    var str,
        uriInst;

    str = TP.str(anObject);

    if (!TP.isString(str)) {
        return false;
    }

    uriInst = this.construct(str);

    return TP.isValid(uriInst);
});

//  ------------------------------------------------------------------------
//  Rewriting/Routing Support
//  ------------------------------------------------------------------------

/**
 * URI rewriting is common on the server, where patterns like FrontController
 * are used to map requests in the form of URIs to the proper controller type.
 * In TIBET's case URI rewriting is used as a way of "virtualizing" URIs to
 * avoid hard-coded references to specific servers/resources. It also can be
 * used to good effect to switch URIs when moving between online and offline
 * operation, when moving between development, production, and test environments
 * or when using different "mocks" for various testing purposes.
 */

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('$getDefaultHandler',
function(aURI, aRequest) {

    /**
     * @method $getDefaultHandler
     * @summary Returns the default handler for a URI and request pair. This is
     *     typically the type defined by TP.sys.cfg('uri.handler.default') which
     *     defaults to TP.uri.URIHandler.
     * @param {TP.uri.URI|String} aURI The URI to obtain the default handler
     *     for.
     * @param {TP.sig.Request} aRequest The request whose values should inform
     *     the routing assignment.
     * @exception {TP.sig.TypeNotFound}
     * @returns {TP.meta.uri.URIHandler} A TP.uri.URIHandler subtype type object
     *     or a type object conforming to that interface.
     */

    var tname,
        type;

    //  default handler is mapped in the configuration settings
    tname = TP.sys.cfg('uri.handler.default');
    if (TP.isEmpty(tname)) {
        this.raise('TP.sig.InvalidConfiguration',
                    'uri.handler.default has no type name specified.');

        //  always return at least our default type
        return TP.uri.URIHandler;
    }

    type = TP.sys.getTypeByName(tname);
    if (TP.notValid(type)) {
        this.raise('TP.sig.TypeNotFound', tname);

        //  always return at least our default type
        return TP.uri.URIHandler;
    }

    return type;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('$getURIMap',
function(aURI) {

    /**
     * @method $getURIMap
     * @summary Scans configuration data for uri.map entries representing the
     *     best match for the URI provided. Only entries from a single mapping
     *     will be returned and only if a match is found.
     * @param {TP.uri.URI|String} aURI The URI to locate mapping data for.
     * @exception {TP.sig.InvalidURI}
     * @returns {TP.core.Hash|undefined} A dictionary of matching key values,
     *     if any.
     */

    var url,
        str,
        config,
        patterns,
        exact,
        matches,
        mapname,
        map;

    if (TP.notValid(aURI)) {
        return this.raise('InvalidURI');
    }

    url = TP.uc(aURI);
    if (TP.notValid(url)) {
        return this.raise('InvalidURI');
    }

    //  check the uri instance for a map. if it exists use that cached map.
    map = url.$get('$uriMap');
    if (TP.isValid(map)) {
        return map;
    }

    //  Pattern matching requires the string version of our URI.
    str = TP.str(aURI);

    config = TP.sys.cfg();

    //  Scan for any uri map patterns of any kind.
    if (TP.canInvoke(config, 'getKeys')) {
        patterns = config.getKeys().filter(
                        function(key) {
                            return TP.uri.URI.Type.URI_PATTERN_REGEX.test(key);
                        });
    } else {
        patterns = TP.keys(config).filter(
                        function(key) {
                            return TP.uri.URI.Type.URI_PATTERN_REGEX.test(key);
                        });
    }

    //  No patterns means no mappings.
    if (TP.isEmpty(patterns)) {
        return;
    }

    //  We have at least one pattern. Run each one, collecting match data so we
    //  can sort it in the next step to determine the best match. NOTE we use
    //  some() here to allow for quick return when we find an exact mapping.
    matches = TP.ac();
    patterns.some(
        function(key) {
            var pattern,
                regex,
                match;

            pattern = TP.sys.cfg(key);
            mapname = key.slice(0, key.lastIndexOf('.'));

            if (TP.isString(pattern)) {
                //  A special case here. If the string is a virtual path we
                //  expand it and match the value for the URI. If it's identical
                //  we call that an exact match and communicate that.
                if (TP.uriExpandPath(pattern) === str) {
                    exact = key;
                    return true;
                }

                regex = TP.rc(pattern, null, true);
            } else {
                regex = pattern;
            }

            if (TP.isRegExp(regex)) {
                match = regex.match(str);
                if (TP.notEmpty(match)) {
                    matches.push(TP.ac(match, TP.sys.cfg(mapname), key));
                }
            }

            return false;
        });

    //  If the search found a pattern value that expanded to an exact file match
    //  that one "wins" and we need to return that configuration block.
    if (TP.notEmpty(exact)) {
        map = TP.sys.cfg(mapname);

        //  Adjust keys since the caller won't know pattern prefix etc.
        map.getKeys().forEach(function(key) {
            map.atPut(key.slice(key.lastIndexOf('.') + 1), map.at(key));
        });

        //  Ensure we cache a map as needed.
        if (TP.sys.hasStarted()) {
            url.$set('$uriMap', map, false);
        }

        return map;
    }

    //  No matches means the URI is "unmapped".
    if (TP.isEmpty(matches)) {
        return;
    }

    //  Sort based on criteria for a best fit (more segments, longest match).
    matches = matches.sort(TP.uri.URI.BEST_URIMAP_SORT);

    //  Get the entire set of keys for that mapping entry.
    map = matches.first().at(1);

    //  Adjust keys since the caller won't know pattern prefix etc.
    map.getKeys().forEach(function(key) {
        map.atPut(key.slice(key.lastIndexOf('.') + 1), map.at(key));
    });

    //  Ensure we cache a map as needed.
    if (TP.sys.hasStarted()) {
        url.$set('$uriMap', map, false);
    }

    return map;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('remap',
function(aURI, aRequest) {

    /**
     * @method remap
     * @summary Directs the operation implied by any data in aRequest to a
     *     viable handler for the URI and request.
     * @description This typically results in the request being passed to a
     *     TP.uri.URIHandler type/subtype. Note that the URI is expected to
     *     have been rewritten as needed prior to this call so that the
     *     operation is appropriate for the concrete URI being accessed.
     * @param {TP.uri.URI|String} aURI The URI to map.
     * @param {TP.sig.Request} aRequest The request whose values should inform
     *     the routing assignment.
     * @returns {TP.meta.uri.URIHandler} A TP.uri.URIHandler subtype type object
     *     that can handle the request for the supplied URI.
     */

    var mapper,
        type;

    mapper = TP.sys.cfg('uri.mapper');
    type = TP.sys.getTypeByName(mapper);

    if (TP.canInvoke(type, 'remap')) {
        return type.remap(aURI, aRequest);
    } else {
        TP.ifWarn() ?
            TP.warn('URI mapper: ' + mapper +
                    ' does not support remap(); using default.',
                    TP.IO_LOG) : 0;

        return TP.uri.URIMapper.remap(aURI, aRequest);
    }
});

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('rewrite',
function(aURI, aRequest) {

    /**
     * @method rewrite
     * @summary Rewrites the incoming URI as appropriate by invoking the
     *     current TP.sys.cfg('uri.rewriter') responsible for URI rewriting.
     * @description This rewriting step is performed prior to any operations
     *     which require a URI handler such as load or save.
     * @param {TP.uri.URI|String} aURI The URI to rewrite.
     * @param {TP.sig.Request} [aRequest] An optional request whose values may
     *     inform the rewrite.
     * @returns {TP.uri.URI} The rewritten URI in TP.uri.URI form.
     */

    var rewriter,
        type;

    rewriter = TP.sys.cfg('uri.rewriter');
    type = TP.sys.getTypeByName(rewriter);

    if (TP.canInvoke(type, 'rewrite')) {
        return type.rewrite(aURI, aRequest);
    } else {
        TP.ifWarn() ?
            TP.warn('URI rewriter: ' + rewriter +
                        ' does not support rewrite(); using default.',
                    TP.IO_LOG) : 0;

        return TP.uri.URIRewriter.rewrite(aURI, aRequest);
    }
});

//  ------------------------------------------------------------------------
//  Remote Resource Change Handling
//  ------------------------------------------------------------------------

/**
 * Remote resources can sometimes notify TIBET when they are changed. This
 * provides support for TIBET to manage a queue of URIs whose remote resource
 * has changed and to process that queue.
 */

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('processRemoteResourceChange',
function(aURI) {

    /**
     * @method processRemoteResourceChange
     * @summary Processes a 'remote resource' change for the supplied URI.
     *     Invoked automatically by the TDS and Couch URL handlers to notify
     *     the system that a remote resource has changed value.
     * @description Depending on whether the supplied URI 'getWatched' and
     *     therefore will process changes from its remote resource or not, this
     *     method will either refresh the URI (via refreshFromRemoteResource) or
     *     it will put an entry for the supplied URI into a hash that tracks
     *     URIs that have had their remote resources changed without refreshing.
     * @param {TP.uri.URI|String} aURI The URI that had its remote resource
     *     changed.
     * @returns {Promise|undefined} A promise which resolves based on success.
     */

    var shouldProcess,
        watched,

        loc,

        resourceHash,
        locHash,

        count;

    //  Track system-wide process flag.
    shouldProcess = TP.sys.cfg('uri.source.process_changes');
    watched = aURI.getWatched();

    //  If we're supposed to process AND the uri is configured for processing
    //  then let it refresh from its remote data source.
    if (shouldProcess && watched) {
        return aURI.refreshFromRemoteResource();
    }

    //  Either processing is off or the resource is marked to not process. If
    //  it's marked not to process then we can just exit. It shouldn't be in the
    //  resource hash for changed resources if it's not watched.
    if (!watched) {
        return;
    }

    //  All marked but unprocessed locations get tracked for later processing.
    //  These entries will be removed in the refreshFromRemoteResource method
    //  when all processing is complete.
    loc = aURI.getLocation();
    resourceHash = TP.uri.URI.get('remoteChangeList');
    locHash = resourceHash.at(loc);

    if (TP.notValid(locHash)) {
        locHash = TP.hc('count', 0, 'targetURI', aURI);
        resourceHash.atPut(loc, locHash);
    }

    count = locHash.at('count');
    locHash.atPut('count', count + 1);

    aURI.signal('RemoteResourceChanged', TP.hc('isDirty', true));

    return TP.extern.Promise.resolve();
});

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('processRemoteChangeList',
function() {

    /**
     * @method processRemoteChangeList
     * @summary Forces a refresh of all of the queued URIs that had their remote
     * resource changed. The queue is then emptied.
     * @returns {TP.meta.uri.URI} The receiver.
     */

    var resourceHash,
        keys;

    resourceHash = TP.uri.URI.get('remoteChangeList');
    keys = resourceHash.getKeys();

    //  NOTE we iterate in this fashion so we don't remove a referenced URI
    //  unless we're sure processing it doesn't throw an error.
    keys.perform(
        function(key) {
            var hash;

            hash = resourceHash.at(key);
            try {
                hash.at('targetURI').refreshFromRemoteResource();
            } catch (e) {
                TP.error('Error processing URI refresh for ' +
                            hash.at('targetURI'), e);
            }
        });

    return this;
});

//  ------------------------------------------------------------------------
//  Local Resource Change Handling
//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('getLocalChangeList',
function() {

    /**
     * @method getLocalChangeList
     * @summary Retrieves data for locally dirty URIs. This list is generated on
     *     the fly from the overall URI instance list.
     * @returns {TP.core.Hash} The locally dirty change list, keyed by the
     *     normalized virtual location and having the URI object as the value.
     */

    var hash;

    hash = TP.hc();

    TP.uri.URI.instances.perform(
            function(item) {
                var uri,
                    loc;

                uri = item.last();
                if (!uri.isDirty()) {
                    return;
                }

                //  We only display URLs (and not TIBETURLs)
                if (!TP.isKindOf(uri, TP.uri.URL) ||
                    TP.isKindOf(uri, TP.uri.TIBETURL)) {
                    return;
                }

                //  This creates a more consistent TIBET URI representation.
                loc = TP.uriInTIBETFormat(TP.uriExpandPath(item.first()));

                hash.atPut(loc, item.last());
            });

    return hash;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('pushLocalChangeList',
function() {

    /**
     * @method pushLocalChangeList
     * @summary Pushes any changes for locally dirty URIs which are watched.
     * @returns {TP.meta.uri.URI} The receiver.
     */

    var hash;

    //  Grab the hash that represents the locally changed URI list. This will be
    //  keyed by the normalized virtual location and its value will be the URI
    //  object itself.
    hash = this.getLocalChangeList();

    hash.perform(
            function(item) {
                try {
                    item.last().save();
                } catch (e) {
                    TP.error('Error saving ' + item.first(), e);
                }
            });

    return this;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  the receiver's copy of the original uri used for construction if any,
//  and a decoded variant of that for normal use
TP.uri.URI.Inst.defineAttribute('uri');
TP.uri.URI.Inst.defineAttribute('decoded');

//  the primary location, the portion in front of any # fragment, and any
//  associated TP.uri.URI instance constructed to reference it.
TP.uri.URI.Inst.defineAttribute('primaryLocation');
TP.uri.URI.Inst.defineAttribute('primaryURI');

//  any potentially cached fragment portion. NOTE that caching the fragment
//  portion is a bit dicey since it can be manipulated by various means and
//  must be keep synchronized in such cases.
TP.uri.URI.Inst.defineAttribute('fragment');

//  whether the receiver is HTTP-based
TP.uri.URI.Inst.defineAttribute('httpBased');

//  the resource object for the primary href
TP.uri.URI.Inst.defineAttribute('resource');
TP.uri.URI.Inst.defineAttribute('resourceCache');

//  whether the receiver 'creates content' when setting it
TP.uri.URI.Inst.defineAttribute('shouldCreateContent');

//  holder for this instance's uri lookup properties
TP.uri.URI.Inst.defineAttribute('uriNodes');
TP.uri.URI.Inst.defineAttribute('uriRegex');

//  the scheme which was actually used for this instance, usually the same
//  as the scheme for the type.
TP.uri.URI.Inst.defineAttribute('scheme');

//  the portion of the URI without the scheme. this is the string parsed by
//  the scheme-specific parsing logic.
TP.uri.URI.Inst.defineAttribute('schemeSpecificPart');

//  a container for any headers associated with this instance.  Note that
//  while only HTTP uris are likely to have true headers TIBET can leverage
//  this structure for other URIs to achieve similar results.
TP.uri.URI.Inst.defineAttribute('headers');

//  cached date instance for last update time
TP.uri.URI.Inst.defineAttribute('lastUpdated', null);

//  flag controlling expiration overrides
TP.uri.URI.Inst.defineAttribute('expired', false);

//  cached data on whether this URI exists so we can avoid checking too
//  often. NOTE that we start out null so we don't imply a true/false
TP.uri.URI.Inst.defineAttribute('found', null);

//  content change tracking flag
TP.uri.URI.Inst.defineAttribute('$dirty', false);

//  load status flag
TP.uri.URI.Inst.defineAttribute('$loaded', false);

//  uri mapping/rewriting configuration
TP.uri.URI.Inst.defineAttribute('$uriMap', null);

//  uri handler type based on remap process caching
TP.uri.URI.Inst.defineAttribute('$uriHandler', null);

//  uri as rewritten based on rewrite process caching
TP.uri.URI.Inst.defineAttribute('$uriRewrite', null);

//  the default content type for this instance
TP.uri.URI.Inst.defineAttribute('defaultContentType');

//  the default MIME type for this instance
TP.uri.URI.Inst.defineAttribute('defaultMIMEType');

//  the computed MIME type for this instance
TP.uri.URI.Inst.defineAttribute('computedMIMEType');

//  the controller instance for this instance
TP.uri.URI.Inst.defineAttribute('controller');

//  other URIs that depend on this one (used for reloading, etc.)
TP.uri.URI.Inst.defineAttribute('dependentURIs');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('init',
function(aURIString, aResource) {

    /**
     * @method init
     * @summary Initialize the instance. A key piece of the processing here is
     *     breaking the string into scheme and scheme-specific-part and then
     *     letting each subtype parse the URI components based on
     *     scheme-specific rules.
     * @param {String} aURIString A String containing a proper URI.
     * @param {Object} [aResource] Optional value for the targeted resource.
     * @exception {TP.sig.InvalidURI} When the receiver cannot be initialized
     *     from the supplied URI String.
     * @returns {TP.uri.URI} The receiver.
     */

    var index,
        ssp,
        parts;

    this.callNextMethod();

    //  break the URI string into scheme and scheme-specific-part and then
    //  let the particular type parse the URI components based on
    //  scheme-specific parsing rules.

    index = aURIString.indexOf(':');

    //  NOTE: These '$set' calls use 'false' to avoid notification!! This is
    //  necessary when creating a URI, since otherwise the change notification
    //  mechanism will cause errors trying to get observations set up before
    //  everything is in place.

    this.$set('uri', aURIString, false);
    this.$set('scheme', aURIString.slice(0, index), false);

    ssp = aURIString.slice(index + 1);
    this.$set('schemeSpecificPart', ssp, false);

    //  defer to other methods to handle things each subtype likely needs to
    //  override to finalize instance initialization.
    parts = this.$parseSchemeSpecificPart(ssp);

    if (!this.$initURIComponents(parts)) {
        //  before we try to raise we need at least a uri slot.
        this.$set('uri', aURIString);

        return this.raise('TP.sig.InvalidURI', 'Invalid URL: ' + aURIString);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('addResource',
function(existingResource, newResource, aRequest) {

    /**
     * @method addResource
     * @summary Adds to the receiver's resource object, the object TIBET will
     *     treat as the resource for any subsequent processing.
     * @param {Object} existingResource The existing resource assigned to this
     *     object, if available.
     * @param {Object} newResource The resource object to add to the resource of
     *     the receiver.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
     *     optional parameters.
     * @returns {TP.uri.URL|TP.sig.Response} The receiver or a TP.sig.Response
     *     when the resource must be acquired in an async fashion prior to
     *     setting any fragment value.
     */

    var retVal;

    if (TP.canInvoke(existingResource, 'addContent')) {
        //  Note that we do not pass in aRequest as the second parameter here.
        //  This matches the 'set content' call in $setResultContent().
        retVal = existingResource.addContent(newResource);
    } else if (TP.canInvoke(existingResource, 'add')) {
        retVal = existingResource.add(newResource);
    } else {
        retVal = this.setResource(TP.str(existingResource) +
                                    TP.str(newResource));
    }

    aRequest.complete(retVal);

    return retVal;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('$initURIComponents',
function(parts) {

    /**
     * @method $initURIComponents
     * @summary Performs any post-parsing initialization appropriate for the
     *     URI components which were parsed during scheme-specific parsing. The
     *     default routine simply returns.
     * @param {TP.core.Hash} parts The parsed URI components.
     * @returns {TP.uri.URI} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('$parseSchemeSpecificPart',
function(schemeSpecificString) {

    /**
     * @method $parseSchemeSpecificPart
     * @summary Parses inbound URI string content in a fashion specific to the
     *     scheme(s) being managed by the receiver. The baseline version ensures
     *     that the primary/fragment portions are properly parsed and stored,
     *     all other processing of the primary href and/or fragment should be
     *     done via override.
     * @param {String} schemeSpecificString A String containing the
     *     "scheme-specific-part" of a URI.
     * @returns {TP.core.Hash|undefined} The parsed URI 'components'.
     */

    var primaryLocation,
        fragment;

    if (TP.isEmpty(schemeSpecificString)) {
        return;
    }

    //  TODO: Review this entire block of code. It seems that it never gets
    //  called, since most subtypes override this method. They also return an
    //  actual TP.core.Hash, when this method does not.

    //  NOTE: These '$set' calls use 'false' to avoid notification!! This is
    //  necessary when creating a URI, since otherwise the change notification
    //  mechanism will cause errors trying to get observations set up before
    //  everything is in place.

    if (schemeSpecificString.indexOf('#') !== TP.NOT_FOUND) {
        primaryLocation = schemeSpecificString.slice(
                        0, schemeSpecificString.indexOf('#'));

        this.$set('primaryLocation',
                    TP.join(this.$get('scheme'), ':', primaryLocation),
                    false);

        if (TP.notEmpty(fragment = schemeSpecificString.slice(
                                    schemeSpecificString.indexOf('#') + 1))) {

            //  Make sure that the fragment conforms to one of the kinds of
            //  fragments we support (barenames, #document fragments or any kind
            //  of XPointer). Note here how we prepend a '#' to the fragment for
            //  testing for '#document' and for barenames, as those RegExps
            //  require a leading '#'.
            if (TP.regex.DOCUMENT_ID.test('#' + fragment) ||
                TP.regex.BARENAME.test('#' + fragment) ||
                TP.regex.ANY_POINTER.test(fragment)) {

                this.$set('fragment', fragment, false);
            } else {
                this.raise('TP.sig.InvalidFragment');
            }
        }
    } else {
        this.$set('primaryLocation',
                    TP.join(this.$get('scheme'), ':', schemeSpecificString),
                    false);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('constructRequest',
function(aRequest) {

    /**
     * @method constructRequest
     * @summary Constructs a viable request for URI processing using any
     *     optionally provided request as input. If the request provided is
     *     truly a TP.sig.Request then the original request is simply returned
     *     for use.
     * @param {TP.sig.Request|TP.core.Hash} [aRequest] An optional object
     *     defining control parameters.
     * @returns {TP.sig.Request} The original request or a suitable new request
     *     for use.
     */

    var req;

    req = TP.request(aRequest);

    //  If the two aren't the same we built an actual request. As a result we
    //  want to avoid signaling, there won't be any observers for complete etc.
    if (req !== aRequest) {
        req.atPutIfAbsent('shouldSignal', false);
    }

    return req;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('constructSubrequest',
function(aRequest) {

    /**
     * @method constructSubrequest
     * @summary Constructs a subrequest for URI processing using any optionally
     *     provided request as input.
     * @description Subrequest creation differs from 'root' request creation in
     *     that subrequests are always new request objects which simply use the
     *     original request payload (when available).
     * @param {TP.sig.Request|TP.core.Hash} [aRequest] An optional object
     *     defining control parameters.
     * @returns {TP.sig.Request} The original request or a suitable new request
     *     for use.
     */

    var subrequest,
        payload;

    //  If we're going to have to request the data then the key thing we
    //  want to avoid is having an incoming request complete() before the
    //  entire process is finished. That means ensuring we have a clean
    //  subrequest instance we can locally modify.
    if (TP.canInvoke(aRequest, 'getPayload')) {
        payload = aRequest.getPayload();
        if (TP.isValid(payload)) {
            subrequest = TP.sig.Request.construct(payload.copy());
        } else {
            subrequest = TP.sig.Request.construct();
        }
    } else {
        subrequest = TP.sig.Request.construct(aRequest);
    }

    return subrequest;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    var marker,
        str;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asDumpString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    str = '[' + TP.tname(this) + ' :: ';

    try {
        str += '(' + TP.str(this.getLocation()) + ')' + ']';
    } catch (e) {
        str += '(' + TP.str(this) + ')' + ']';
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver.
     * @returns {String} The receiver in HTML string format.
     */

    return '<span class="TP_uri_URI ' +
                TP.escapeTypeName(TP.tname(this)) + '">' +
            TP.htmlstr(this.asString()) +
            '</span>';
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    return '{"type":' + TP.tname(this).quoted('"') + ',' +
             '"data":' + this.asString().quoted('"') + '}';
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} A new String containing the 'pretty print' string of
     *     the receiver.
     */

    return '<dl class="pretty ' +
                TP.escapeTypeName(TP.tname(this)) +
            '"><dt/><dd>' +
            TP.pretty(this.asString()) +
            '</dd></dl>';
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns a string representation of the receiver.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the TP.uri.URI's String representation. This flag is ignored in
     *     this version of this method.
     * @returns {String} The receiver's String representation.
     */

    return TP.str(this.getLocation());
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a TIBET source code string.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    return 'TP.uc(\'' + this.getLocation() + '\')';
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver.
     * @returns {String} The receiver in XML string format.
     */

    return '<instance type="' + TP.tname(this) + '">' +
                    TP.xmlstr(this.asString()) +
                    '</instance>';
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('asTP_uri_URI',
function() {

    /**
     * @method asTP_uri_URI
     * @summary Returns the receiver.
     * @returns {TP.uri.URI} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('$changed',
function(anAspect, anAction, aDescription) {

    /**
     * @method $changed
     * @summary Notifies observers that some aspect of the receiver has
     *     changed. The fundamental data-driven dependency method.
     * @description See the supertype method for more information.
     * @param {String} anAspect The aspect of the receiver that changed. This is
     *     usually an attribute name.
     * @param {String} anAction The action which caused the change. This usually
     *     'add', 'remove', etc.
     * @param {TP.core.Hash} aDescription A hash describing details of the
     *     change.
     * @fires {TP.sig.Change}
     * @returns {TP.uri.URI} The receiver.
     */

    var primaryResource,

        secondaryURIs,

        desc,

        subDesc,
        sigName,

        i;

    //  Note how we grab the *primary URI's* resource's result. This is the
    //  target that the path query will be executed against to obtain any value.
    //  NB: We assume 'async' of false here
    primaryResource =
        this.getPrimaryURI().getResource(TP.hc('refresh', false)).get('result');

    //  If this this doesn't have any sub URIs, then we'll just let all of
    //  the parameters default in the supertype call, except we do provide the
    //  'path' and 'target' here.
    if (TP.isEmpty(secondaryURIs = this.getSecondaryURIs())) {

        desc = TP.isValid(aDescription) ? aDescription : TP.hc();
        desc.atPutIfAbsent('path', this.getFragmentExpr());
        desc.atPutIfAbsent('target', primaryResource);
        desc.atPutIfAbsent(TP.NEWVAL, primaryResource);

        return this.callNextMethod(anAspect, anAction, desc);
    } else {

        //  Otherwise, this is a primary URI and we need to send change
        //  notifications from all of its secondaryURIs, if it has any.

        //  Note here how we signal one of the types of TP.sig.StructureChange.
        //  This is because the whole value of the primary URI has changed so,
        //  as far as the secondaryURIs are concerned, the whole structure has
        //  changed.

        subDesc = TP.hc('action', anAction,
                        'aspect', 'value',
                        'facet', 'value',
                        'target', primaryResource
                        );

        switch (anAction) {
            case TP.CREATE:
            case TP.INSERT:
            case TP.APPEND:

                //  CREATE, INSERT or APPEND means an 'insertion structural
                //  change' in the data.
                sigName = 'TP.sig.StructureInsert';
                break;

            case TP.DELETE:

                //  DELETE means a 'deletion structural change' in the data.
                sigName = 'TP.sig.StructureDelete';
                break;

            default:

                //  The default is the supertype TP.sig.StructureChange signal.
                sigName = 'TP.sig.StructureChange';
                break;
        }

        for (i = 0; i < secondaryURIs.getSize(); i++) {

            subDesc.atPut('path', secondaryURIs.at(i).getFragmentExpr());

            secondaryURIs.at(i).signal(sigName, subDesc);
        }

        //  Now that we're done signaling the sub URIs, it's time to signal a
        //  TP.sig.ValueChange from ourself (our 'whole value' is changing).

        //  If we got a valid description, use that.
        if (TP.isValid(aDescription)) {
            desc = aDescription;
        } else {
            //  Otherwise, build a Hash with the same parameters as we used for
            //  the sub URIs, but without the 'path' (which doesn't make sense
            //  at a 'whole URI' level).
            desc = TP.hc('action', anAction,
                            'aspect', 'value',
                            'facet', 'value',
                            'target', primaryResource
                            );
        }

        this.signal('TP.sig.ValueChange', desc);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('$constructPrimaryResourceStub',
function(aPathType) {

    /**
     * @method $constructPrimaryResource
     * @summary Constructs a primary resource 'stub' when the primary resource
     *     is missing for a secondary URI that is trying to access it.
     * @param {String} aPathType The 'path type' of the path created from the
     *     secondary URI's fragment.
     * @returns {Object|null} The object to use as the primary resource stub.
     */

    var result;

    switch (aPathType) {
        case TP.TIBET_PATH_TYPE:
        case TP.JSON_PATH_TYPE:
            result = TP.hc();
            break;
        case TP.CSS_PATH_TYPE:
        case TP.XPATH_PATH_TYPE:
        case TP.BARENAME_PATH_TYPE:
        case TP.XPOINTER_PATH_TYPE:
        case TP.ELEMENT_PATH_TYPE:
        case TP.XTENSION_POINTER_PATH_TYPE:
            result = TP.constructDocument();
            break;
        default:
            break;
    }

    return result;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('clearCaches',
function() {

    /**
     * @method clearCaches
     * @summary Clears any content caches related to the receiver, returning
     *     things to their pre-loaded state. For URIs with a separate resource
     *     URI this will also clear the resource URI's caches.
     * @returns {TP.uri.URI} The receiver.
     */

    var url;

    //  clear our simple content caches
    this.$clearCaches();

    //  TODO:   should we put this behind a "deep" parameter?
    if ((url = this.getPrimaryURI()) !== this) {
        url.clearCaches();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('$clearCaches',
function() {

    /**
     * @method $clearCaches
     * @summary Clears the internal caches of the receiver. This method is
     *     expected to be overridden by subtypes so they can clear any
     *     specialized cache data, but it should be invoked by any overriding
     *     method.
     * @returns {TP.uri.URI} The receiver.
     */

    var resource;

    TP.ifTrace() ?
        TP.sys.logTransform('Clearing content cache for: ' + this.getID(),
            TP.DEBUG) : 0;

    if (TP.isValid(resource = this.$get('resource'))) {
        this.ignore(resource, 'Change');
    }

    //  empty the resource cache(s) - note that we *must* use $set() here to
    //  avoid all of the ID comparison and change notification machinery in the
    //  regular setResource call. Force no notification, we cleared the cache,
    //  we didn't change the value.
    this.$set('resource', null, false);

    //  update expiration status as well as any potentially obsolete headers
    this.set('headers', null);
    this.$set('expired', false);

    //  clear any internal state flags that might cause issues reloading
    this.isLoaded(false);
    this.isDirty(false, true);

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('empty',
function() {

    /**
     * @method empty
     * @summary Clears any stored content of the receiver, or of its resource
     *     URI if it has one which stores its data. Note that only the data is
     *     cleared, not the remaining cache data such as headers etc. This
     *     operation dirties the receiver.
     * @returns {TP.uri.URI} The receiver.
     */

    var url;

    //  TODO: should this only happen when "deep" parameter would be true?
    if ((url = this.getPrimaryURI()) !== this) {
        url.empty();
    }

    //  Clear the actual data cache. This clears the data, but nothing else.
    this.set('resource', null);

    //  Dirty the receiver. The presumption is that a URI with content that
    //  we empty is now ready to be saved with new content of ''/null.
    this.set('$dirty', true);
    this.set('$loaded', true);

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('equalTo',
function(aURI) {

    /**
     * @method equalTo
     * @summary Two URLs are considered equal if their locations are equal.
     * @param {TP.uri.URI|String} aURI The URI to compare.
     * @returns {Boolean} Whether or not the receiver is equal to the passed in
     *     parameter.
     */

    var uri,
        loc;

    if (TP.isURIString(aURI)) {
        uri = aURI;
    } else if (!TP.isString(aURI) && TP.isURI(aURI)) {
        uri = aURI.getLocation();
    } else {
        return false;
    }

    loc = this.getLocation();

    return TP.uriExpandPath(uri) === loc;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('expire',
function(aFlag) {

    /**
     * @method expire
     * @summary Sets the expiration flag for the receiver to true, forcing a
     *     one-time override of any computation-based expiration.
     * @param {Boolean} [aFlag=true] The value to set the expiration flag to.
     *     Defaults to true.
     * @returns {Boolean} Whether or not the content of the receiver is expired.
     */

    var url;

    //  When there's a primary URI we defer entirely to that URI since all
    //  core data caches are managed by the primary.
    if ((url = this.getPrimaryURI()) !== this) {
        url.expire(aFlag);
        return url.isExpired();
    }

    this.$set('expired', TP.ifInvalid(aFlag, true), false);

    return this.isExpired();
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getConcreteURI',
function() {

    /**
     * @method getConcreteURI
     * @summary Return's the receiver's 'concrete' URI. At this level, this
     *     method just returns the receiver. Subtypes may override this method
     *     to return a different URI as the concrete URI. See TP.uri.TIBETURL
     *     for an example of this.
     * @returns {Object} The receiver's 'concrete' URI.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getContent',
function(aRequest) {

    /**
     * @method getContent
     * @summary Returns the URI's resource, forcing any fetch to be synchronous.
     *     If you need async access use getResource.
     * @returns {Object} The immediate value of the receiver's resource result.
     */

    var request;

    request = this.constructRequest(aRequest);
    request.atPut('async', false);

    //  Track initial state so we can properly process flags/results.
    request.atPut('operation', 'get');
    request.atPut('loaded', this.isLoaded());

    return this.getResource(request).get('result');
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('$getDefaultHandler',
function(aRequest) {

    /**
     * @method $getDefaultHandler
     * @summary Returns the default handler for a URI and request pair. This is
     *     typically the type defined by TP.sys.cfg('uri.handler.default'),
     *     which defaults to TP.uri.URIHandler.
     * @param {TP.sig.Request} aRequest The request whose values should inform
     *     the handler assignment.
     * @returns {TP.meta.uri.URIHandler} A TP.uri.URIHandler subtype type object
     *     or a type object conforming to that interface.
     */

    return this.getType().$getDefaultHandler(this, aRequest);
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('$getFilteredResult',
function(anObject, aRequest, collapse) {

    /**
     * @method $getFilteredResult
     * @summary Processes a value to ensure it matches a request's stated
     *     resultType preferences. When the data doesn't match that preference a
     *     conversion is attempted and the return value of that conversion is
     *     returned.
     * @description If the data can't be converted properly this method returns
     *     undefined. If no resultType is specified then a "best fit" result is
     *     returned. The best fit result processing attempts to construct a
     *     valid TP.dom.Node, then a viable JavaScript object by parsing for
     *     JSON strings, and finally just the object itself.
     * @param {Object} anObject The object to "type check".
     * @param {Object} aRequest The request object used to original fetch data.
     * @param {Boolean} [collapse=true] False to skip collapsing node lists to a
     *     single node.
     * @returns {Object} The desired return value type.
     */

    var obj,
        saved,
        resultType,
        contentType,
        type,
        request;

    request = this.constructRequest(aRequest);
    resultType = request.at('resultType');

    if (TP.isValid(anObject)) {
        switch (resultType) {
            case TP.DOM:

                //  Often dealing with TP.core.Content types so we have to work
                //  from the data, not the object in those cases.
                if (TP.canInvoke(anObject, 'getNativeNode')) {
                    obj = anObject.getNativeNode();
                } else {
                    obj = anObject;
                }

                if (TP.notFalse(collapse)) {
                    obj = TP.collapse(obj);
                    if (TP.isValid(obj)) {
                        obj = TP.node(obj, null, false);
                    }
                } else {
                    obj = TP.node(obj, null, false);
                }
                return obj;

            case TP.TEXT:

                obj = anObject;
                if (TP.notFalse(collapse)) {
                    obj = TP.collapse(obj);
                    if (TP.isValid(obj)) {
                        obj = TP.str(obj);
                    } else {
                        obj = '';
                    }
                } else {
                    obj = TP.str(obj, false);
                }
                return obj;

            case TP.WRAP:

                //  Often dealing with TP.core.Content types so we have to work
                //  from the data, not the object in those cases.
                if (TP.isKindOf(anObject, TP.core.XMLContent)) {
                    obj = anObject.getData();
                } else {
                    obj = anObject;
                }

                //  don't want to convert anything that's already in
                //  reasonable object form...so the primary test is whether
                //  the object is a string that might be parseable into a
                //  more object form
                if (TP.isString(obj) && TP.notEmpty(obj)) {
                    //  mirror "best" in some sense, attempting to find XML,
                    //  then JSON, then any parseable object we might be
                    //  able to detect.
                    saved = obj;

                    //  Note here that we turn XML parsing error reporting off
                    //  and, if it resolves to a single Text node, we will try
                    //  to convert it further.
                    if (TP.notValid(obj = TP.tpnode(obj, null, false)) ||
                        TP.isKindOf(obj, TP.dom.TextNode)) {
                        //  json?
                        if (TP.notValid(obj = TP.json2js(
                                                saved, null, false))) {
                            //  date or other parsable object?
                            if (TP.notValid(obj = TP.parse('Date', saved))) {
                                //  default back to original object. not
                                //  great, but apparently it's not parseable
                                obj = saved;
                            }
                        }
                    }

                    if (TP.notFalse(collapse)) {
                        obj = TP.collapse(obj);
                    }
                } else if (TP.isNode(obj)) {
                    if (TP.notFalse(collapse)) {
                        obj = TP.collapse(obj);
                    }

                    obj = TP.tpnode(obj);
                } else {
                    if (TP.notFalse(collapse)) {
                        obj = TP.collapse(obj);
                    }

                    obj = TP.wrap(obj);

                    if (TP.notValid(obj)) {
                        if (TP.notFalse(collapse)) {
                            obj = TP.collapse(obj);
                        }
                    }
                }
                return obj;

            case TP.CONTENT:
                //  fall through to default handling.
            default:

                contentType = TP.ifInvalid(
                                request.at('contentType'),
                                this.get('defaultContentType'));
                if (TP.notValid(contentType)) {
                    return anObject;
                }

                type = TP.sys.getTypeByName(contentType);

                if (TP.isType(type)) {
                    //  Don't recreate instances of the same type.
                    if (TP.canInvoke(anObject, 'getType') &&
                        type === anObject.getType()) {
                        obj = anObject;
                    } else {
                        obj = type.from(anObject, this);
                    }
                } else {
                    obj = anObject;
                }

                return obj;
        }
    }

    //  There was no valid object - return null
    return null;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getFragment',
function() {

    /**
     * @method getFragment
     * @summary Returns the fragment portion of the receiver as a String.
     * @returns {String} The fragment string.
     */

    //  NOTE that we rely on the initial parse operation to populate any
    //  fragment portion, otherwise we'd be recomputing.
    return this.$get('fragment');
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getFragmentAccessPath',
function() {

    /**
     * @method getFragmentAccessPath
     * @summary Returns an instance of an access path from the path encoded in
     *     the fragment expression of the receiver (if its fragment forms an
     *     expression that can be considered an access path).
     * @returns {TP.path.AccessPath|null} An access path created from the
     *     receiver's fragment.
     */

    var fragment,
        fragmentAccessor;

    fragment = this.getFragment();
    if (TP.isEmpty(fragment)) {
        return null;
    }

    if (TP.regex.ANY_POINTER.test(fragment)) {
        fragmentAccessor = TP.apc(fragment);
        return fragmentAccessor;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getFragmentAccessPathType',
function() {

    /**
     * @method getFragmentAccessPathType
     * @summary Returns the type of the access path encoded in the fragment
     *     expression of the receiver (if its fragment forms an expression that
     *     can be considered an access path).
     * @returns {String} One of the 'path type' constants:
     *     TP.TIBET_PATH_TYPE
     *     TP.JSON_PATH_TYPE
     *     TP.CSS_PATH_TYPE
     *     TP.XPATH_PATH_TYPE
     *     TP.BARENAME_PATH_TYPE
     *     TP.XPOINTER_PATH_TYPE
     *     TP.ELEMENT_PATH_TYPE
     *     TP.XTENSION_POINTER_PATH_TYPE
     */

    var fragment,
        fragmentAccessor,

        fragExpr;

    //  The most robust way to do this is to create a TP.path.AccessPath object
    //  from the fragment and ask that object.
    fragment = this.getFragment();
    if (TP.isEmpty(fragment)) {
        return TP.NOT_FOUND;
    }

    if (TP.regex.ANY_POINTER.test(fragment)) {
        fragmentAccessor = TP.apc(fragment);
        return fragmentAccessor.getPathType();
    }

    //  As a fallback, we can try to compute the access path type by looking at
    //  the raw fragment expression.
    fragExpr = this.getFragmentExpr();
    if (TP.isEmpty(fragExpr)) {
        return TP.NOT_FOUND;
    }

    return TP.getAccessPathType(fragExpr);
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getFragmentExpr',
function() {

    /**
     * @method getFragmentExpr
     * @summary Returns the fragment text of the receiver as a String without
     *     the fragment scheme portion.
     * @returns {String} The fragment string.
     */

    var frag,
        results;

    //  NOTE that we rely on the initial parse operation to populate any
    //  fragment portion, otherwise we'd be recomputing.
    frag = this.$get('fragment');

    if (TP.notEmpty(results = TP.regex.ANY_POINTER.match(frag))) {
        return results.at(2);
    }

    if (TP.regex.XML_IDREF.test(frag)) {
        return frag;
    }

    return '';
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getFragmentParameters',
function(textOnly) {

    /**
     * @method getFragmentParameters
     * @summary Returns any "parameters" from the receiver's fragment string.
     *     The parameter set is derived by treating a fragment as a potential
     *     URI and processing it using normal parsing based on & and =.
     * @param {Boolean} [textOnly=false] Return just the text fragment string
     *     if any.
     * @returns {TP.core.Hash} The fragment parameters if any.
     */

    var text,
        hash;

    text = this.getFragment();
    hash = TP.hc();

    //  don't bother if fragment is a pointer of some kind.
    if (TP.regex.ANY_POINTER.test(text)) {
        if (textOnly) {
            return '';
        }
        return hash;
    }

    if (textOnly) {
        return text;
    }

    return TP.hc(TP.boot.$parseURIParameters(text));
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getFragmentPath',
function() {

    /**
     * @method getFragmentPath
     * @summary Returns any "path portion" of a fragment string. The path
     *     portion is based on treating a fragment as a potential URI itself and
     *     processing it using normal parsing for path vs. parameter data. Note
     *     that the path value is always prefixed with a '/' for consistency
     *     with base URL path values.
     * @returns {String|undefined} The fragment path if any.
     */

    var text;

    text = this.getFragment();

    //  don't confuse xpointer prefix with path content.
    if (TP.isEmpty(text) || TP.regex.ANY_POINTER.test(text)) {
        return;
    }

    if (/\?/.test(text)) {
        text = text.slice(0, text.indexOf('?'));
    }

    if (text.charAt(0) !== '/') {
        text = '/' + text;
    }

    return text;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getFragmentWeight',
function() {

    /**
     * @method getFragmentWeight
     * @summary Returns the 'weight' of the fragment. Typically this is how many
     *     'parts' the fragment has in any path in it.
     * @returns {Number} The fragment weight.
     */

    var frag,

        results;

    //  NOTE that we rely on the initial parse operation to populate any
    //  fragment portion, otherwise we'd be recomputing.
    frag = this.$get('fragment');

    //  We do an isValid check since an empty Array is ok - it will just report
    //  a size of 0.
    //
    if (TP.isValid(results = TP.uriSplitFragment(frag))) {
        return results.getSize();
    }

    return 0;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getHeader',
function(aHeaderName) {

    /**
     * @method getHeader
     * @summary Returns the value of the named header, or null if the header
     *     value isn't found.
     * @param {String} aHeaderName The name of the header to retrieve.
     * @returns {String|undefined} The value of the header named with the
     *     supplied name.
     */

    var dict;

    dict = this.$get('headers');
    if (TP.isEmpty(dict)) {
        return;
    }

    return dict.at(aHeaderName);
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getID',
function() {

    /**
     * @method getID
     * @summary Returns the ID of the receiver, which for URIs is their URI in
     *     a fully-expanded format so minor variations in syntax are removed.
     * @returns {String} The ID of the receiver.
     */

    var id;

    //  Make sure that, if the receiver is a prototype, we just return the value
    //  of the TP.ID slot. Otherwise, we're trying to get an ID from an object
    //  that represents only a partially formed instance for this type.
    if (TP.isPrototype(this)) {
        return this[TP.ID];
    }

    //  the next question is do we have our *own* id (otherwise, we'll report
    //  the value inherited from the prototype)
    if (TP.owns(this, TP.ID)) {
        return this.$get(TP.ID);
    }

    id = this.getLocation();
    this.$set(TP.ID, id);

    return id;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getLastUpdateDate',
function() {

    /**
     * @method getLastUpdateDate
     * @summary Returns the last update time for the receiver as recorded in
     *     the URI's header content -- specifically the Date header.
     * @returns {Date|undefined} The date the receiver was last updated.
     */

    var dateStr,
        theDate;

    if (TP.notEmpty(theDate = this.$get('lastUpdated'))) {
        return theDate;
    }

    dateStr = this.getHeader('Date');
    if (TP.notEmpty(dateStr)) {
        theDate = Date.from(dateStr);
    } else {
        TP.ifTrace() && TP.$DEBUG && TP.$VERBOSE ?
            TP.trace(this.getID() +
                            ' has no Last-Updated information') : 0;
        return;
    }

    TP.ifTrace() && TP.$DEBUG && TP.$VERBOSE ?
        TP.trace(this.getID() +
                        ' returning cached Last-Updated: ' +
                        theDate) : 0;

    this.$set('lastUpdated', theDate);

    return theDate;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getLocalPath',
function() {

    /**
     * @method getLocalPath
     * @summary Returns the locally-formatted absolute path to the URI's
     *     resource.
     * @description Note that no rewriting is performed in the production of
     *     this value. The returned URI is simply adjusted for the current
     *     platform's semantics.
     * @returns {String} The receiver's local path.
     */

    return TP.uriInLocalFormat(this.getLocation());
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getLocation',
function() {

    /**
     * @method getLocation
     * @summary Returns the true location of the URI. For most URIs this value
     *     is the same as the original URI, but for virtual URIs it represents
     *     the expanded URI value.
     * @returns {String} The receiver's location.
     */

    var url;

    if (TP.notValid(url = this.$get('decoded'))) {
        url = this.$get('uri');
        if (TP.notEmpty(url)) {
            url = decodeURI(encodeURI(url));
            this.$set('decoded', url);
        }
    }

    return url;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getMIMEType',
function(newResource) {

    /**
     * @method getMIMEType
     * @summary Returns the MIME type of the receiver, if available. See the
     *     TP.ietf.mime.getMIMEType() method for more information about how
     *     TIBET tries to guess the MIME type based on file name and data
     *     content.
     * @param {Object} [newResource] An optional resource object that will be
     *     used to compute the MIME type. If this is not supplied, then the
     *     receiver's existing resource object will be used.
     * @returns {String} The receiver's MIME type.
     */

    var url,
        mimeType,

        resource,
        fragment,
        content;

    //  if there's a valid computed MIME we can use it first
    if (TP.notEmpty(mimeType = this.get('computedMIMEType'))) {
        return mimeType;
    }

    //  TODO:   if we're a fragment then is it possible that our MIME type
    //  could differ from that of our container?
    //  Always defer to the primary URI if we have a distinct one.
    if ((url = this.getPrimaryURI()) !== this) {
        return url.getMIMEType();
    }

    //  Need to avoid recursion here so we check the resource slot, but
    //  don't actually invoke getResource
    if (TP.isValid(newResource)) {
        content = newResource;
    } else if (this.isLoaded()) {
        resource = this.$get('resource');
        if (this.hasFragment() && TP.canInvoke(resource, 'get')) {
            fragment = this.getFragment();
            if (TP.isKindOf(resource, TP.dom.Node)) {
                fragment = fragment.startsWith('#') ?
                            fragment :
                            '#' + fragment;
            }
            content = resource.get(fragment);
        } else {
            content = resource;
        }
    }

    //  assuming we got content we can ask it, which is what we'd
    //  prefer to do to get the best value
    if (TP.canInvoke(content, 'getContentMIMEType')) {
        mimeType = content.getContentMIMEType(content);

        //  if we found one cache it for next time :)
        if (TP.isString(mimeType)) {
            this.$set('computedMIMEType', mimeType);

            return mimeType;
        }
    }

    //  if we couldn't ask the content then we can try to guess via the
    //  MIME type itself
    mimeType = TP.ietf.mime.guessMIMEType(
                                content, this, this.get('defaultMIMEType'));

    if (TP.isString(mimeType)) {
        this.$set('computedMIMEType', mimeType);
        return mimeType;
    }

    return this.get('defaultMIMEType');
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getName',
function() {

    /**
     * @method getName
     * @summary An override of the getName() operation that returns the
     *     receiver's *OID* as the 'Name'. This is necessary because this type
     *     override's getID() (normally used by the getName() method) to return
     *     special IDs for URIs.
     * @returns {String} The receiver's name.
     */

    return this.$getOID();
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getNativeObject',
function() {

    /**
     * @method getNativeObject
     * @summary Returns the native object that the receiver is wrapping. In the
     *     case of TP.uri.URIs, this is the receiver's string instance.
     * @returns {String} The receiver's native object.
     */

    return this.getLocation();
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getOriginalSource',
function() {

    /**
     * @method getOriginalSource
     * @summary Returns the 'original source' representation that the receiver
     *     was constructed with.
     * @returns {String} The receiver's original source.
     */

    //  For most TP.uri.URIs, this is its location.
    return this.getLocation();
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getPrimaryLocation',
function() {

    /**
     * @method getPrimaryLocation
     * @summary Returns the primary resource's URIs location. This is the
     *     portion of the URI which isn't qualified by a fragment, the portion
     *     you can send to a server without causing an error.
     * @returns {String} The primary href as a String.
     */

    var str;

    //  If we have a locally cached value return that. We only compute this
    //  when the receiver didn't defer to a primary URI.
    if (TP.notEmpty(str = this.$get('primaryLocation'))) {
        return str;
    }

    //  Fully expand and then trim off any fragment portion.
    str = this.getLocation();
    if (this.hasFragment()) {
        str = str.split('#').at(0);
    }

    this.$set('primaryLocation', str);

    return str;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('$getPrimaryResource',
function(aRequest, filterResult) {

    /**
     * @method $getPrimaryResource
     * @summary Returns a receiver-specific object representing the "primary"
     *     resource being accessed (i.e. the resource referenced by the base
     *     resource path without any fragment. This is the routine most subtypes
     *     override to perform their low-level data access. Fragment processing
     *     is typically done by the getResource() call which can usually be
     *     defaulted.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @param {Boolean} [filterResult=false] True if the resource result will be
     *     used directly and should be filtered to match any resultType
     *     definition found in the request.
     * @returns {TP.sig.Response} A TP.sig.Response created with the resource's
     *     content set as its result.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getPrimaryURI',
function() {

    /**
     * @method getPrimaryURI
     * @summary Returns the actual resource URI used for content access. This
     *     may be the receiver or it may be the URI referencing the primary
     *     resource data for the receiver if the receiver has a fragment, or it
     *     may be an "embedded" URI in the case of schemes which support
     *     embedding URIs such as tibet:.
     * @returns {TP.uri.URI} The receiver's primary resource URI.
     */

    var url;

    //  If we have a locally cached value return that.
    if (TP.isURI(url = this.$get('primaryURI'))) {
        return url;
    }

    //  When there's no fragment the receiver is the primary, otherwise we
    //  need to get a reference to the primary.
    /* eslint-disable consistent-this */
    url = this;
    /* eslint-enable consistent-this */
    if (this.hasFragment()) {
        url = TP.uc(this.getPrimaryLocation());
    }

    return url;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getResource',
function(aRequest) {

    /**
     * @method getResource
     * @summary Returns a receiver-specific object representing the "secondary"
     *     resource being accessed (i.e. the resource referenced by the base
     *     resource path subset identified by any fragment portion. If there is
     *     no fragment this method returns the same value as
     *     $getPrimaryResource()).
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} A TP.sig.Response created with the requested
     *     content set as its result.
     */

    var request;

    request = this.constructRequest(aRequest);

    //  Track initial state so we can properly process flags/results.
    request.atPutIfAbsent('operation', 'get');
    request.atPutIfAbsent('loaded', this.isLoaded());

    //  When we're primary or we don't have a fragment we can keep it
    //  simple and just defer to $getPrimaryResource.
    if (this.isPrimaryURI() ||
        !this.hasFragment() ||
        this.getFragment() === 'document') {
        return this.$getPrimaryResource(request, true);
    }

    return this.$requestContent(request,
                                '$getPrimaryResource',
                                '$getResultFragment');
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getRoot',
function() {

    /**
     * @method getRoot
     * @summary Returns the root of the receiver.
     * @returns {String} The receiver's root.
     */

    return TP.uriRoot(this.getLocation());
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getRootAndPath',
function() {

    /**
     * @method getRootAndPath
     * @summary Returns the root and path of the receiver. Note that this can be
     *     different than the receiver's location if (as in the case of HTTP
     *     URLs), as the location could contain query parameters, etc. and this
     *     will not.
     * @returns {String} The receiver's root and path.
     */

    return this.get('root') + this.get('path');
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('$getResultFragment',
function(aRequest, aResult, aResource) {

    /**
     * @method $getResultFragment
     * @summary Invoked as a "success body" function for the getResource call
     *     with the purpose of returning the secondary resource of the result
     *     object being provided.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An optional object
     *     defining control parameters.
     * @param {Object} aResult The result of a content access call.
     * @param {Object} [aResource] Optional data from set* invocations.
     * @returns {Object} The return value for the content operation using this
     *     as a success body function.
     */

    var fragment,
        result,
        shouldCollapse;

    fragment = this.getFragment();
    if (TP.notEmpty(fragment)) {

        fragment = fragment.indexOf('#') === 0 ? fragment : '#' + fragment;

        if (TP.regex.DOCUMENT_ID.test(fragment) ||
                TP.regex.BARENAME.test(fragment)) {
            //  empty
        } else if (TP.regex.ANY_POINTER.test(fragment)) {
            //  Note that we don't worry about setting the path to collapse
            //  results here, since we collapse whatever we got below.
            fragment = TP.apc(fragment);
        }

        //  NB: The result must be a Node to get wrapped into a TP.dom.Node,
        //  otherwise we just use the result itself.
        result = TP.isNode(aResult) ? TP.tpnode(aResult) : aResult;

        //  Make sure that we obtain the 'shouldCollapse' value from the request
        //  (if it has one - defaulted to true) and if the fragment is an access
        //  path, configure it with the same setting.

        //  Note here that if we do collapse, we do so to just to make sure to
        //  have consistent results across 'get' calls... what ultimately gets
        //  returned from this method is determined by the $getFilteredResult
        //  call below.

        shouldCollapse = TP.ifKeyInvalid(aRequest, 'shouldCollapse', true);

        if (fragment.isAccessPath()) {
            fragment.set('shouldCollapse', shouldCollapse);
        }

        result = TP.canInvoke(result, 'get') ? result.get(fragment) : undefined;

        //  If collapsing wasn't specifically set to false, then collapse the
        //  result.
        if (TP.notFalse(shouldCollapse)) {
            result = TP.isCollection(result) ? TP.collapse(result) : result;
        }
    } else {
        result = aResult;
    }

    //  filter to any result type which was specified.
    result = this.$getFilteredResult(result, aRequest);

    return result;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getScheme',
function() {

    /**
     * @method getScheme
     * @summary Returns the scheme of the receiver, the string which starts off
     *     URIs of this type or for this particular instance.
     * @returns {String} The receiver's scheme.
     */

    return this.$get('scheme') || this.getType().get('SCHEME');
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getSize',
function() {

    /**
     * @method getSize
     * @summary Returns the size of the URI in string form. This is used for
     *     testing whether the URI is empty when passed as a string.
     * @returns {Number} The size in bytes of the receiver as a String.
     */

    return this.asString().getSize();
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getSecondaryURIs',
function(onlyShallow) {

    /**
     * @method getSecondaryURIs
     * @summary Returns an Array of secondary URIs of the receiver. These are
     *     URIs which point to the same primary resource as the receiver, but
     *     also have a secondary resource pointed to by a fragment. If the
     *     receiver has a secondary resource itself, it returns null.
     * @description This method also will create an 'empty pointer' URI
     *     consisting of the receiver's primary URI location, the scheme and an
     *     empty parentheses. This allows consistent results for when this empty
     *     pointer URI might not have been created explicitly.
     * @param {Boolean} [onlyShallow=false] Whether or not to only include
     *     secondary URIs that are 'the shallowest possible set'. I.e. if the
     *     set of secondary URIs consisted of 'urn:tibet:stuff#tibet(foo)' and
     *     'urn:tibet:stuff#tibet(foo.bar)', then only the first one will be
     *     returned.
     * @returns {TP.uri.URI[]} An Array of TP.uri.URI objects corresponding to
     *     the 'secondary URI's of the receiver.
     */

    var secondaryURIs,
        uriGroupings,

        schemeOnlySecondaryURI,

        scheme;

    secondaryURIs = this.getSubURIs(true);

    if (TP.notEmpty(secondaryURIs)) {

        if (onlyShallow) {

            //  Group the secondary URIs by their 'fragment weight'. We want
            //  only the ones in the group with the lowest weight.
            uriGroupings = secondaryURIs.groupBy(
                                function(aURI) {
                                    return aURI.getFragmentWeight();
                                });

            //  Make sure the hash keys are sorted sorted
            uriGroupings.sort(TP.sort.NUMERIC);

            //  Get the first item's (a key-value pair) last item, which will
            //  be an Array.
            secondaryURIs = uriGroupings.first().last();
        }

        //  Grab the fragment scheme from the first secondary URI
        scheme = TP.getPointerScheme(secondaryURIs.first().getFragment());

        //  Compute the 'empty pointer' URI location.
        schemeOnlySecondaryURI =
            this.getPrimaryURI().getLocation() + '#' + scheme + '()';

        //  Create and push a URI instance representing the empty pointer.
        secondaryURIs.push(TP.uc(schemeOnlySecondaryURI));

        //  Unique the list in case the empty pointer already existed.
        secondaryURIs.unique();
    }

    return secondaryURIs;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getSubURIs',
function(onlySecondaries) {

    /**
     * @method getSubURIs
     * @summary Returns an Array of sub URIs of the receiver.
     * @description Sub URIs are URIs which match the front part of the URI,
     *     but could have any trailing portion. So 'urn:tibet:fooBar' is
     *     considered a 'sub URI' of 'urn:tibet:foo'.
     *     Note that subURIs could also consist of a URI pointing to a
     *     secondary resource of the main URI. In this case, 'urn:tibet:foo#baz'
     *     is considered a secondary URI of the 'urn:tibet:foo' but
     *     'urn:tibet:fooBar' is not.
     * @param {Boolean} [onlySecondaries=false] Whether or not to only include
     *     secondary resources (i.e. those with a hash)
     * @returns {TP.uri.URI[]} An Array of TP.uri.URI objects corresponding to
     *     the 'sub URI's of the receiver.
     */

    var loc,
        matchLoc,

        registeredURIs,
        matcher,

        subURIKeys;

    loc = this.getLocation();

    if (this.hasFragment()) {

        //  Construct a RegExp looking for our location followed our full
        //  location, including an XPointer (with the trailing ')' sliced off so
        //  that we match any 'more specific' XPointer paths - thereby giving us
        //  our 'subURIs').
        matchLoc = loc;
        if (matchLoc.charAt(matchLoc.getSize() - 1) === ')') {
            matchLoc = matchLoc.slice(0, -1);
        }
        matchLoc = TP.regExpEscape(matchLoc);

        matcher = TP.rc('^' + matchLoc);
    } else {
        if (onlySecondaries) {
            //  Construct a RegExp starting by looking for our location
            //  followed by a hash.
            matcher = TP.rc('^' + loc + '#');
        } else {
            //  Construct a RegExp starting by looking for our location
            //  followed by anything.
            matcher = TP.rc('^' + loc + '.*');
        }
    }

    //  Get all of the registered URIs
    registeredURIs = this.getType().get('instances');

    //  Select the keys of the URIs that match our location plus a hash out of
    //  all of the registered URIs keys. Note here how we compare to our own
    //  location so that we don't return ourself in the list of subURIs (the
    //  generated RegExp will match ourself because of its open-endedness)
    subURIKeys = registeredURIs.getKeys().select(
                        function(uriLocation) {
                            /* eslint-disable no-extra-parens */
                            return (matcher.test(uriLocation) &&
                                    uriLocation !== loc);
                            /* eslint-enable no-extra-parens */
                        });

    //  Iterate over the subURI keys and get the actual URI instance for them.
    return subURIKeys.collect(
                function(aKey) {
                    return registeredURIs.at(aKey);
                });
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getURI',
function() {

    /**
     * @method getURI
     * @summary Returns a URI which can be used to acquire the receiver.
     *     TP.uri.URI differs slightly in that it returns itself.
     * @returns {TP.uri.URI} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getSuperURIWithResourceType',
function(aType) {

    /**
     * @method getSuperURIWithResourceType
     * @summary Returns a URI whose resource type matches the supplied type. If
     *     one cannot be found, this method will return the receiver.
     * @param {TP.lang.RootObject|String} aType A Type object, or type name.
     * @returns {TP.uri.URI} The URI whose resource type matches the supplied
     * type. This could be the receiver.
     */

    var pathType,

        primaryLoc,

        resultURI,

        pathParts,
        len,
        i,

        pathPart,
        newPath,

        newURI,
        newResource;

    //  If there is no path type, then we can't proceed - this may be a URI
    //  without a fragment or a fragment that isn't a path.
    pathType = this.getFragmentAccessPathType();
    if (pathType === TP.NOT_FOUND) {
        return this;
    }

    //  Grab our primary location - we'll use this to join with the path as we
    //  walk it back, trying to find a resource whose type is the supplied type.
    primaryLoc = this.getPrimaryLocation();

    /* eslint-disable consistent-this */
    resultURI = this;
    /* eslint-enable consistent-this */

    switch (pathType) {
        case TP.JSON_PATH_TYPE:

            //  Grab the path parts from the fragment's access path
            pathParts = this.getFragmentAccessPath().getPathParts();
            len = pathParts.getSize();

            for (i = len - 1; i >= 0; i--) {
                pathPart = pathParts.at(i);

                //  Slice from the start of the path to the chunk just before
                //  the one we're currently processing.
                newPath = pathParts.slice(0, i);

                //  If it ends with a *numeric* path part (not another kind of
                //  predicate), then slice that off.
                if (TP.regex.ENDS_WITH_NUMERIC_PATH.test(pathPart)) {
                    newPath.push(
                        pathPart.slice(0, pathPart.lastIndexOf('[')));
                } else {
                    newPath.push(pathPart);
                }

                //  Compute a new URI based on the new path, which should be
                //  'one step above' the fragment piece that we tested
                //  previously.
                newURI =
                    TP.uc(primaryLoc + '#jpath(' + newPath.join('.') + ')');

                //  Grab the resource (synchronously and not collapsing) and see
                //  if its type matches our supplied type.
                newResource = newURI.getResource(
                        TP.hc('async', false, 'shouldCollapse', false)).
                                                            get('result');
                if (TP.isKindOf(newResource, aType)) {
                    resultURI = newURI;
                    break;
                }
            }

            break;
        default:
            break;
    }

    return resultURI;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getValue',
function() {

    /**
     * @method getValue
     * @summary Returns the value of the URI, essentially the 'resource'.
     * @returns {Object} The value of the receiver's resource.
     */

    return this.$get('resource');
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getVirtualLocation',
function() {

    /**
     * @method getVirtualLocation
     * @summary Returns the virtual location of the URI. This will return a
     *     String with a format matching a 'TIBET virtual URI'.
     * @returns {String} The receiver's virtual location.
     */

    var loc;

    if (TP.notEmpty(loc = this.getLocation())) {
        loc = this.getLocation();
        return TP.uriInTIBETFormat(loc);
    }

    return '';
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('getWebPath',
function() {

    /**
     * @method getWebPath
     * @summary Returns the web-formatted absolute path to the URI's source.
     * @description Note that no rewriting is performed in the production of
     *     this value. The URI is simply converted to its equivalent web format
     *     (forward slashes rather than backslash etc.)
     * @returns {String} The receiver's uri value as a 'web formatted URI'.
     */

    return TP.uriInWebFormat(this.getLocation());
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineHandler('Change',
function(aSignal) {

    /**
     * @method handleChange
     * @summary Handles changes to the value of the receiver's resource.
     * @description URIs listen for changes to their resource's value and this
     *     method is invoked when it changes. The supplied signal could have a
     *     TP.CHANGE_PATHS property in its payload, which is an Array of path
     *     Strings that referenced the resource at some point. If this property
     *     is present, those paths are compared against any fragments of
     *     'secondary URIs' of the receiver and, if a match is made, that
     *     secondary URI is added to a list of changed URIs kept under the
     *     TP.CHANGE_URIS property in the payload.
     *     Whether or not the signal has a TP.CHANGE_PATHS property, this URI
     *     will signal Change from itself.
     * @param {TP.sig.Change} aSignal The signal indicating a change has
     *     happened in the resource.
     * @returns {TP.uri.URI} The receiver.
     */

    var resource,

        secondaryURIs,

        path,

        changedURIs,

        i,

        fragText,

        primaryAspect;

    //  NB: We assume 'async' of false here
    resource = this.getResource().get('result');

    //  If TP.CHANGE_PATHS were supplied in the signal, filter them against any
    //  'secondary URI's of the receiver and add those sub URIs to the payload
    //  of the signal.

    //  Secondary URIs are URIs that have the same primary resource as us, but
    //  also have a fragment, indicating that they also have a secondary
    //  resource pointed to by the fragment.
    secondaryURIs = this.getSecondaryURIs();

    if (TP.notEmpty(aSignal.at(TP.CHANGE_PATHS))) {

        if (TP.notEmpty(secondaryURIs)) {

            path = aSignal.at('aspect');

            changedURIs = TP.ac();

            for (i = 0; i < secondaryURIs.getSize(); i++) {

                fragText = secondaryURIs.at(i).getFragmentExpr();

                //  If the fragment without the 'pointer indicator' matches the
                //  path, then push the secondary URI onto our list of changed
                //  URIs.
                if (fragText === path) {
                    changedURIs.push(secondaryURIs.at(i));
                }
            }

            //  Add the list of changed URIs to the signal.
            aSignal.atPut(TP.CHANGE_URIS, changedURIs);
        }

        //  If we have URIs that match the paths that changed, then iterate over
        //  them and send a change signal for each one.
        if (TP.notEmpty(changedURIs)) {
            changedURIs.forEach(
                    function(aURI) {
                        aURI.signal(aSignal.getSignalName(),
                                    aSignal.getPayload(),
                                    TP.INHERITANCE_FIRING,
                                    aSignal.getType());
                    });
        }

        //  Now we signal from ourself with the whole payload, which now
        //  includes the list of changed URIs.
        this.signal(aSignal.getSignalName(),
                    aSignal.getPayload(),
                    TP.INHERITANCE_FIRING,
                    aSignal.getType());

    } else {

        //  If we didn't have any paths, then just signal from our secondary
        //  URIs (if we have any) and ourself.

        if (TP.notEmpty(secondaryURIs)) {

            //  Note that we change the 'aspect' here to 'value' (after
            //  capturing the original aspect used by the primary URI) -
            //  because the 'entire value' of the subURI itself has changed.
            //  We also include a 'path' for convenience, so that observers
            //  can use that against the primary URI to obtain this URI's
            //  value, if they wish.
            primaryAspect = aSignal.at('aspect');
            aSignal.atPut('aspect', 'value');

            aSignal.atPut('target', resource);

            for (i = 0; i < secondaryURIs.getSize(); i++) {

                path = secondaryURIs.at(i).getFragmentExpr();

                //  If the path is just a JS identifier, then this is probably a
                //  'tibet(...)' pointer. If that does not match the primary
                //  aspect, then we don't send the signal. This avoids
                //  oversignaling.
                if (TP.regex.JS_IDENTIFIER.test(path) &&
                        path !== primaryAspect) {
                    continue;
                }

                aSignal.atPut('path', path);

                secondaryURIs.at(i).signal(
                        aSignal.getSignalName(),
                        aSignal.getPayload(),
                        TP.INHERITANCE_FIRING,
                        aSignal.getType());
            }

            //  Put the signal back to what it was before we mucked with it
            //  above.
            aSignal.atPut('aspect', primaryAspect);
            aSignal.removeKey('path');
            aSignal.removeKey('target');
        }

        this.signal(aSignal.getSignalName(),
                    aSignal.getPayload(),
                    TP.INHERITANCE_FIRING,
                    aSignal.getType());
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('hasFragment',
function() {

    /**
     * @method hasFragment
     * @summary Returns true if the path contains a fragment reference. This is
     *     typically associated with anchors, barenames, or XPointers.
     * @returns {Boolean} Whether or not the receiver contains a fragment
     *     reference.
     */

    return TP.notEmpty(this.getFragment());
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('$flag',
function(aProperty, aFlag) {

    /**
     * @method $flag
     * @summary Sets a specific property value to a boolean based on aFlag.
     * @param {String} aProperty The name of the boolean property being tested
     *     and/or manipulated.
     * @param {Boolean} [aFlag] The new value to optionally set.
     * @exception {TP.sig.InvalidParameter} When aProperty isn't a String.
     * @returns {Boolean|undefined} The current flag state.
     */

    if (!TP.isString(aProperty)) {
        this.raise('TP.sig.InvalidParameter');
        return;
    }

    if (TP.isBoolean(aFlag)) {
        //  NOTE we never signal change for a flag update.
        this.$set('$' + aProperty, aFlag, false);
    }

    return this.$get('$' + aProperty);
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('isDirty',
function(aFlag, shouldSignal) {

    /**
     * @method isDirty
     * @summary Returns true if the receiver's content has changed since it was
     *     last loaded from its source URI or content data without being saved.
     * @param {Boolean} [aFlag] The new value to optionally set.
     * @param {Boolean} [shouldSignal=false] Should changes to the value be
     *     signaled?
     * @returns {Boolean} Whether or not the content of the receiver is 'dirty'.
     */

    var wasDirty;

    if (TP.isValid(aFlag) && shouldSignal) {
        wasDirty = this.$flag('dirty');
        this.$flag('dirty', aFlag);

        if (wasDirty !== aFlag) {
            TP.$changed.call(
                        this,
                        'dirty',
                        TP.UPDATE,
                        TP.hc(TP.OLDVAL, wasDirty, TP.NEWVAL, aFlag));
        }

        return this.$flag('dirty');
    } else {
        return this.$flag('dirty', aFlag);
    }
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('isExpired',
function(aFlag) {

    /**
     * @method isExpired
     * @summary Returns true if the receiver's content has been expired.
     * @param {Boolean} [aFlag] The new value to optionally set.
     * @returns {Boolean} Whether or not the content of the receiver is expired.
     */

    return this.$flag('expired', aFlag);
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('isHTTPBased',
function() {

    /**
     * @method isHTTPBased
     * @summary Returns true if the receiver's absolute path is HTTP based.
     * @returns {Boolean} Whether or not the receiver is 'http'-based.
     */

    var http;

    http = this.$get('httpBased');
    if (TP.notValid(http)) {
        http = TP.regex.HTTP_SCHEME.test(this.getLocation());
        this.$set('httpBased', http);
    }

    return http;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('isLoaded',
function(aFlag) {

    /**
     * @method isLoaded
     * @summary Returns true if the receiver's content has been loaded either
     *     manually via a setResource or init, or by loading the receiver's
     *     URI location.
     * @param {Boolean} [aFlag] The new value to optionally set.
     * @returns {Boolean} Whether or not the content of the receiver is loaded.
     */

    return this.$flag('loaded', aFlag);
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('isPrimaryURI',
function() {

    /**
     * @method isPrimaryURI
     * @summary Returns true if the receiver is a primary URI, meaning it has
     *     no fragment portion and can store data.
     * @returns {Boolean} True if the receiver is a primary URI.
     */

    return !this.hasFragment();
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('$normalizeRequestedResource',
function(aResource) {

    /**
     * @method $normalizeRequestedResource
     * @summary 'Normalizes' the resource object. This means that certain
     *     common constructs that this particular type of TP.uri.URI needs will
     *     be computed and instrumented onto the resource via this method.
     * @param {Object} aResource The resource object to normalize.
     * @returns {Object} The normalized resource.
     */

    //  At this level, there are no constructs that the receiver needs to put
    //  onto the supplied resource, so we just return it.
    return aResource;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('refreshFromRemoteResource',
function() {

    /**
     * @method refreshFromRemoteResource
     * @summary Refreshes the receiver's content from the remote resource it
     *     represents. Upon refreshing the content this method will invoke
     *     processRefreshedContent to perform any post-processing of the
     *     content appropriate for the target URI. The default implementation
     *     must by overridden by subtypes.
     * @returns {Promise} A promise which resolves on completion.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('register',
function() {

    /**
     * @method register
     * @summary Registers the instance under a common key.
     */

    TP.uri.URI.registerInstance(this, TP.uriExpandPath(this.getLocation()));

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('$requestContent',
function(aRequest, contentFName, successFName, failureFName, aResource) {

    /**
     * @method $requestContent
     * @summary A generic sync/async content request processing routine used by
     *     the various get/set calls dealing with content, resource, or primary
     *     resource access.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @param {String} contentFName A content access function name such as
     *     $getPrimaryResource or getResource.
     * @param {String} successFName A function name for a URI method taking a
     *     'result' object as a single parameter.
     * @param {String} failureFName A function name for a URI method taking a
     *     failure code and failure string as parameters.
     * @param {Object} [aResource] Optional data used for set* methods.
     * @exception {TP.sig.InvalidParameter} When the receiver can't invoke the
     *     method named by contentFName.
     * @returns {TP.sig.Response|undefined} A TP.sig.Response created with the
     *     requested content set as its result.
     */

    var fragment,

        async,

        subrequest,
        thisref;

    if (!TP.canInvoke(this, contentFName)) {
        this.raise('TP.sig.InvalidParameter',
            'Must supply content accessor function name.');

        return;
    }

    //  capture and process fragment (if any) so it can be used as a path to
    //  a set or get call.
    fragment = this.getFragment();
    if (TP.notEmpty(fragment)) {
        fragment = fragment.indexOf('#') === 0 ? fragment : '#' + fragment;
    }

    //  we'll need this to help decide which branch to take below.
    async = this.rewriteRequestMode(aRequest);

    //  If we're going to have to request the data then the key thing we
    //  want to avoid is having an incoming request complete() before the
    //  entire process is finished. That means ensuring we have a clean
    //  subrequest instance we can locally modify.
    subrequest = this.constructSubrequest(aRequest);

    //  hold a this reference the functions below can close around.
    thisref = this;

    subrequest.defineMethod(
        'completeJob',
        function(aResult) {

            var result;

            result = aResult;
            if (TP.canInvoke(thisref, successFName)) {
                //  Note that two of these parameters come from the outer
                //  function and only aResult is provided by the inner one.
                result = thisref[successFName](aRequest,
                                                aResult,
                                                aResource);
            }

            //  rewrite the request result object so we hold on to the
            //  processed content rather than the inbound content.
            subrequest.set('result', result);

            subrequest.$wrapupJob('Succeeded', TP.SUCCEEDED, result);

            //  if there was an original request complete it, which will
            //  take care of putting the result in place for async calls.
            if (TP.canInvoke(aRequest, 'complete')) {
                aRequest.complete(result);
            }
        });

    subrequest.defineMethod(
        'failJob',
        function(aFaultString, aFaultCode, aFaultInfo) {

            var info,
                subrequests;

            info = TP.hc(aFaultInfo);
            if (TP.isValid(subrequests = info.at('subrequests'))) {
                subrequests.push(subrequest);
            } else {
                subrequests = TP.ac(subrequest);
                info.atPut('subrequests', subrequests);
            }

            if (TP.canInvoke(thisref, failureFName)) {
                thisref[failureFName](aFaultString, aFaultCode, info);
            }

            subrequest.$wrapupJob('Failed', TP.FAILED);

            //  if there was an original request fail it too.
            if (TP.canInvoke(aRequest, 'fail')) {
                aRequest.fail(aFaultString, aFaultCode, info);
            }
        });

    //  Remember this can run async, so any result here can be either data
    //  or a TP.sig.Response when async. We can safely ignore it.
    this[contentFName](subrequest, true);

    //  If async we can only return the result/response being used to
    //  actually process the async activity.
    //  NOTE that we need to re-read the async state in case our underlying
    //  resource is async-only and potentially rewrote the value.
    async = this.rewriteRequestMode(subrequest);
    if (async) {
        aRequest.andJoinChild(subrequest);

        //  hand back the response object for the "outer" request, which
        //  will be either the originating request or our internally
        //  constructed one (which was also used as the subrequest)
        if (TP.canInvoke(aRequest, 'getResponse')) {
            return aRequest.getResponse();
        } else {
            return subrequest.getResponse();
        }
    }

    //  If the routine was invoked synchronously then the data will have
    //  been placed in the subrequest.
    return subrequest.getResponse();
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('remap',
function(aRequest) {

    /**
     * @method remap
     * @summary Directs the operation implied by any data in aRequest to a
     *     viable handler for the URI. This typically results in the request
     *     being passed to a TP.uri.URIHandler type/subtype. Note that the URI
     *     is expected to have been rewritten as needed prior to this call so
     *     that the handler is appropriate for the concrete URI being accessed.
     * @param {TP.sig.Request} aRequest The request whose values should inform
     *     the routing assignment.
     * @returns {TP.meta.uri.URIHandler} A TP.uri.URIHandler subtype type object
     *     that can handle the request for the supplied URI.
     */

    return this.getType().remap(this, aRequest);
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('rewrite',
function(aRequest) {

    /**
     * @method rewrite
     * @summary Rewrites the receiver to its appropriate 'concrete' URI value
     *     based on current runtime values and rewriting rules.
     * @param {TP.sig.Request} [aRequest] An optional request whose values may
     *     inform the rewrite.
     * @returns {TP.uri.URI} The rewritten URI in TP.uri.URI form.
     */

    return this.getType().rewrite(this, aRequest);
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('$sendDependentURINotifications',
function(oldResource, newResource, pathInfos, primaryOnly) {

    /**
     * @method $sendDependentURINotifications
     * @summary Causes any 'dependent URIs' (either this URI's primary URI or
     *     any URIs containing in the optional 'path info records' that are
     *     supplied in 'pathInfos') to send a notification that they
     *     changed.
     *     defining control parameters.
     * @param {Object} oldResource The old value of the resource that this URI
     *     had.
     * @param {Object} newResource The new value of the resource that this URI
     *     was set to.
     * @param {String[]} [pathInfos] Optional data detailing which paths
     *     changed. If this data isn't supplied, then a single notification is
     *     sent from this URI's primary URI.
     * @param {Boolean} [primaryOnly=false] Should we only signal the primary?
     * @returns {TP.uri.URI} The receiver.
     */

    var primaryURI,

        fragExpr,

        description,

        primaryLoc,

        uriRegistry,
        registryKeys,

        leni,
        i,

        info,

        keyMatcher,

        lenj,
        j,

        matchedURI;

    primaryURI = this.getPrimaryURI();

    if (TP.notValid(pathInfos)) {

        fragExpr = this.getFragmentExpr();

        //  Now that we're done signaling the sub URIs, it's time to signal a
        //  TP.sig.ValueChange from ourself (our 'whole value' is changing).
        description = TP.hc(
            'action', TP.UPDATE,
            'aspect', TP.isEmpty(fragExpr) ? 'value' : fragExpr,
            'facet', 'value',

            'path', fragExpr,

            'target', newResource,
            'oldTarget', oldResource
            );

        primaryURI.signal('TP.sig.ValueChange', description);

        return this;
    }

    primaryLoc = primaryURI.getLocation();

    uriRegistry = TP.uri.URI.get('instances');
    registryKeys = uriRegistry.getKeys();

    leni = pathInfos.getSize();
    for (i = 0; i < leni; i++) {

        info = pathInfos.at(i);

        description = TP.copy(info.at('description'));

        //  Grab the fragment from the 'aspect' of the change record and use it
        //  to try to match a URI's fragment that would indicate that a change
        //  notification should be sent from it.
        fragExpr = description.at('aspect');

        //  Compute a RegExp that looks for that fragment as part of a URI.
        keyMatcher = TP.rc(primaryLoc + '#\\w+\\(' + fragExpr + '\\)');

        //  Iterate over all of the registered URIs, looking for ones that have
        //  a fragment that matches the computed RegExp.
        lenj = registryKeys.getSize();
        for (j = 0; j < lenj; j++) {

            if (keyMatcher.test(registryKeys.at(j))) {
                matchedURI = uriRegistry.at(registryKeys.at(j));
                break;
            }
        }

        //  If we found one, use it to signal.
        if (TP.notTrue(primaryOnly) && TP.isURI(matchedURI)) {
            description.atPut('aspect', 'value');
            description.atPut('path', fragExpr);

            description.atPut('oldTarget', oldResource);

            matchedURI.signal(info.at('sigName'), description);
        }

        //  In any case, signal from the primary URI, using that fragment as the
        //  'aspect' that changed.
        description.atPut('aspect', fragExpr);
        primaryURI.signal(info.at('sigName'), description);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('$sendSecondaryURINotifications',
function(oldResource, newResource) {

    /**
     * @method $sendSecondaryURINotifications
     * @summary Causes any 'secondary URIs' (URIs that point to the same primary
     *     resource as the receiver, but also have a secondary resource pointed
     *     to by a fragment) to send a notification that they changed.
     *     defining control parameters.
     * @param {Object} oldResource The old value of the resource that this URI
     *     had.
     * @param {Object} newResource The new value of the resource that this URI
     *     was set to.
     * @returns {TP.uri.URI} The receiver.
     */

    var secondaryURIs,

        description,

        i,
        fragText,

        facetedAspects,
        primaryLoc;

    secondaryURIs = this.getSecondaryURIs();

    if (TP.notEmpty(secondaryURIs)) {

        //  The 'action' here is TP.DELETE, since the entire resource got
        //  changed. This very well may mean structural changes occurred and
        //  the resource that the subURI pointed to doesn't even exist
        //  anymore.

        //  The 'aspect' here is 'value' - because the 'entire value' of the
        //  subURI itself has changed. We also include a 'path' for
        //  convenience, so that observers can use that against the primary
        //  URI to obtain this URI's value, if they wish.

        //  The 'target' here is computed by running the fragment against
        //  the resource.
        description = TP.hc(
                'action', TP.DELETE,
                'aspect', 'value',
                'facet', 'value',
                'target', newResource,

                //  NB: We supply the old resource and the fragment text
                //  here for ease of obtaining values.
                'oldTarget', oldResource
                );

        //  If we have sub URIs, then observers of them will be expecting to
        //  get a TP.sig.StructureDelete with 'value' as the aspect that
        //  changed (we swapped out the entire resource, so the values of
        //  those will have definitely changed).
        for (i = 0; i < secondaryURIs.getSize(); i++) {

            fragText = secondaryURIs.at(i).getFragmentExpr();

            description.atPut('path', fragText);

            secondaryURIs.at(i).signal('TP.sig.StructureDelete',
                                        description);
        }
    }

    //  Now that we're done signaling the sub URIs, it's time to signal a
    //  TP.sig.ValueChange from ourself (our 'whole value' is changing).
    description = TP.hc(
        'action', TP.UPDATE,
        'aspect', 'value',
        'facet', 'value',

        'path', this.getFragmentExpr(),

        //  NB: We supply these values here for consistency with the 'no
        //  secondaryURIs logic' below.
        'target', newResource,
        'oldTarget', oldResource,
        TP.OLDVAL, oldResource,
        TP.NEWVAL, newResource
    );

    this.signal('TP.sig.ValueChange', description);

    //  If we can invoke 'getFacetedAspectNames' on the new resource, then we
    //  want to query for and check those facets.
    if (TP.canInvoke(newResource, 'getFacetedAspectNames')) {

        //  Grab the faceted aspect names.
        facetedAspects = newResource.getFacetedAspectNames();

        //  If there were faceted aspects, then create '#tibet' URIs with
        //  aspects as the fragments for each one. This will force the system to
        //  signal from those URIs as well.
        if (TP.notEmpty(facetedAspects)) {

            primaryLoc = this.getPrimaryURI().getLocation();
            facetedAspects.forEach(
                function(anAspect) {
                    var aspectLoc;

                    //  The 'aspect location' is the primary location with a
                    //  '#tibet' fragment and the aspect name.
                    aspectLoc = primaryLoc + '#tibet(' + anAspect + ')';

                    //  Create the URI. Note that we don't worry about the
                    //  return value here as the URI machinery will cache the
                    //  instance.
                    TP.uc(aspectLoc);
                });

            //  Check the facets.
            newResource.checkFacets(facetedAspects);
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('setContent',
function(contentData, aRequest) {

    /**
     * @method setContent
     * @summary Sets the receiver's content to the object provided.
     * @param {Object} contentData A new content object.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
     *     optional parameters.
     * @returns {TP.sig.Response} A TP.sig.Response created with the requested
     *     content set as its result.
     */

    var request;

    request = this.constructRequest(aRequest);

    //  Track initial state so we can properly process flags/results.
    request.atPutIfAbsent('operation', 'set');
    request.atPutIfAbsent('loaded', this.isLoaded());

    //  Make sure we don't try to load a URI just because we're setting content.
    //  A URI that's not loaded (and may not even exist) shouldn't be invoking
    //  load just to access a possibly undefined resource.
    request.atPutIfAbsent('refresh', false);

    return this.$requestContent(request,
                                'getResource',
                                '$setResultContent',
                                null,
                                contentData);
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('$setFacet',
function(aspectName, facetName, facetValue, shouldSignal) {

    /**
     * @method $setFacet
     * @summary Sets the value of the named facet of the named aspect to the
     *     value provided. This method should be called from any 'custom facet
     *     setter' in order to a) set the property and b) signal a change, if
     *     configured.
     * @description For this type and its subtypes, this method only operates on
     *     facets named 'value'.
     * @param {String} aspectName The name of the aspect to set.
     * @param {String} facetName The name of the facet to set.
     * @param {Boolean} facetValue The value to set the facet to.
     * @param {Boolean} [shouldSignal=this.getShouldSignalChange()] If false no
     *     signaling occurs. Note that we *ignore* this value for TP.uri.URIs
     *     and always let the resource decide whether it will broadcast change
     *     or not.
     * @returns {Boolean} Whether or not the value was changed from the value it
     *     had before this method was called.
     */

    var resourceContent,
        facetSlotName,
        currentFacetVal;

    //  We have no notion of any other facet for URIs.
    if (facetName !== 'value') {
        return this;
    }

    //  The internal facet slot name will always be something like
    //  '$SSN_required'.
    facetSlotName = '$' + aspectName + '_' + facetName;

    //  Grab the current value of the internal slot and compare it to the
    //  supplied value. Only go through the act of setting it and signaling a
    //  change if they're different.

    //  NB: Make sure to use $get() here. Otherwise, we end up doing path
    //  lookups, etc. for private facet slot values.
    currentFacetVal = this.$get(facetSlotName);
    if (!TP.equal(currentFacetVal, facetValue)) {

        //  NOTE: We ignore the shouldSignal flag here on purpose - the resource
        //  will decide if it wants to signal change.

        //  If this isn't a primary URI, then we won't use any supplied aspect, but
        //  we'll use the fragment text instead.
        if (!this.isPrimaryURI()) {

            //  NB: We assume 'async' of false here
            this.getPrimaryURI().getResource().get('result').set(
                        this.getFragmentExpr(), facetValue);
        } else {

            //  Make sure we have a real content object - if not, stub it in.
            //  NB: We assume 'async' of false here
            if (TP.notValid(resourceContent = this.getResource().get('result'))) {
                //  Stub out new content.
                this.stubResourceContent();
                //  Get that new content.
                resourceContent = this.getResource().get('result');
            }
            resourceContent.set(aspectName, facetValue);
        }

        //  Return true because the value of the facet changed.
        return true;
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('setLastUpdateDate',
function(aDate) {

    /**
     * @method setLastUpdateDate
     * @summary Sets the update time for the receiver. This is the last time
     *     the receiver's data was loaded from its source.
     * @param {Date} [aDate] The date to set the 'last updated' property of the
     *     receiver to. Defaults to the receiver's header Date.
     * @returns {String} The string value set for the update time.
     */

    var theDate,
        dict;

    //  note the default here to the value of the Date header which is
    //  normally served via HTTP and which is configured by TIBET for files
    theDate = aDate;
    if (TP.notValid(theDate)) {
        theDate = this.getHeader('Date');
    }

    //  note that if theDate is null we'll get a new date with current time
    theDate = TP.dc(theDate);

    //  cache so we avoid date creation overhead
    this.$set('lastUpdated', theDate, false);

    dict = this.$get('headers');
    if (TP.notValid(dict)) {
        dict = TP.hc();
        this.$set('headers', dict, false);
    }
    this.get('headers').atPut('Date', theDate.toUTCString());

    return theDate;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('$setPrimaryResource',
function(aResource, aRequest, shouldSignal) {

    /**
     * @method $setPrimaryResource
     * @summary Sets the receiver's resource object, the object TIBET will
     *     treat as the primary resource for any subsequent processing.
     * @param {Object} aResource The resource object to assign.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
     *     optional parameters.
     * @param {Boolean} [shouldSignal=true] Should changes to the value be
     *     signaled? By default true, but occasionally set to false when a
     *     series of changes is being performed etc.
     * @returns {TP.uri.URI|TP.sig.Response} The receiver or a TP.sig.Response
     *     when the resource must be acquired in an async fashion prior to
     *     setting any fragment value.
     */

    var url,
        request,

        dirty,
        loaded,

        oldResource,
        newResource,

        shouldSignalChange;

    //  If the receiver isn't a "primary URI" then it really shouldn't be
    //  holding data, it should be pushing it to the primary...
    if ((url = this.getPrimaryURI()) !== this) {
        return url.$setPrimaryResource(aResource, aRequest);
    }

    //  ---
    //  URI <-> data correlation
    //  ---

    request = this.constructRequest(aRequest);

    loaded = request.at('loaded');

    oldResource = this.$get('resource');

    //  Wrap and augment inbound resource if appropriate (adds XMLBase, etc).
    newResource = this.$normalizeRequestedResource(aResource);

    if (request.hasParameter('isDirty')) {
        dirty = request.at('isDirty');
    } else {
        //  If we're already loaded we need to know if we're changing the value.
        if (this.resourcesAreAlike(oldResource, newResource)) {
            dirty = false;
        } else {
            if (TP.sys.hasStarted()) {
                /*
                console.log(this.getLocation() +
                    ' dirty:\n\n' +
                    TP.getStackInfo().join('\n') +
                    TP.dump(oldResource) + '\n\n' + TP.dump(newResource));
                */
            }

            //  NOTE we don't consider setting a value to the processed version
            //  of the same value as an operation that dirties the URI.
            if (request.at('processedResult') === true) {
                dirty = false;
            } else {
                dirty = true;
            }
        }
    }

    //  If we already have a resource, make sure to 'ignore' it for changes.
    if (TP.isValid(oldResource) && TP.isMutable(oldResource)) {
        this.ignore(oldResource, 'Change');
    }

    //  If the new resource is valid and the request parameters don't contain a
    //  false value for the flag for observing our resource, then observe it for
    //  all *Change signals.
    if (TP.notFalse(request.at('observeResource')) &&
        TP.isMutable(newResource)) {
        //  Observe the new resource object for changes.
        this.observe(newResource, 'Change');
    }

    //  Use request info or current loaded state (CHECKED BEFORE WE UPDATE IT)
    //  to determine if we should signal change.
    if (TP.isValid(shouldSignal)) {
        shouldSignalChange = shouldSignal;
    } else if (request.hasParameter('signalChange')) {
        shouldSignalChange = request.at('signalChange');
    } else {
        shouldSignalChange = dirty;
    }

    //  What we do with value and flags depends on the originating operation.
    switch (request.at('operation')) {
        case 'load':
            //  fallthrough
        case 'get':
            this.$set('resource', newResource, false);
            this.isLoaded(true);
            this.isDirty(false, true);
            break;
        case 'set':
            this.$set('resource', newResource, false);
            this.isLoaded(true);    //  arguable semantics but important for
                                    //  preloaded URIs
            if (loaded) {
                this.isDirty(dirty, true);
            } else {
                this.isDirty(false, true);
            }
            break;
        case 'save':
            //  NOTE we don't save results for save..., it's usually an empty
            //  response.
            this.isLoaded(true);
            this.isDirty(false, true);

            //  We don't signal since we're only pushing data, not altering it.
            shouldSignalChange = false;
            break;
        case 'delete':
            //  NOTE we don't save results for delete..., it's usually an empty
            //  response.
            this.isLoaded(false);
            this.isDirty(false, true);

            //  We always signal since whatever value was there is now undefined.
            shouldSignalChange = true;
            break;
        default:
            return this.raise('InvalidOperation', request.at('operation'));
    }

    //  clear any expiration computations
    this.expire(false);

    if (shouldSignalChange) {
        if (TP.sys.hasStarted()) {
            // console.log('signaling secondaries via primary for ' + this.getLocation());
        }
        this.$sendSecondaryURINotifications(oldResource, newResource);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('setResource',
function(aResource, aRequest) {

    /**
     * @method setResource
     * @summary Sets the receiver's resource object, the object TIBET will
     *     treat as the resource for any subsequent processing.
     * @param {Object} aResource The resource object to assign.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
     *     optional parameters.
     * @returns {TP.sig.Response} A TP.sig.Response created with the newly set
     *     content set as its result.
     */

    var request;

    request = this.constructRequest(aRequest);

    //  Track initial state so we can properly process flags/results.
    request.atPutIfAbsent('operation', 'set');
    request.atPutIfAbsent('loaded', this.isLoaded());

    //  Make sure we don't try to load a URI just because we're setting data.
    //  A URI that's not loaded (and may not even exist) shouldn't be invoking
    //  load just to access a possibly undefined resource.
    request.atPutIfAbsent('refresh', false);

    //  When we're primary or we don't have a fragment we can keep it
    //  simple and just defer to $setPrimaryResource.
    if (this.isPrimaryURI() ||
        !this.hasFragment() ||
        this.getFragment() === 'document') {
        return this.$setPrimaryResource(aResource, request);
    }

    //  If we have a fragment then we need to do the more complex approach
    //  of getting the primary resource and setting the fragment value with
    //  respect to that object.
    return this.$requestContent(request,
                                '$getPrimaryResource',
                                '$setResultFragment',
                                null,
                                aResource);
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('setResourcePortion',
function(aPath, aValue, aRequest) {

    /**
     * @method setResourcePortion
     * @summary Sets a portion of the resource using the supplied path to 'drill
     *     into' the resource pointed to by the receiver.
     * @param {TP.path.AccessPath|String} aPath The path to use to drill into
     *     the receiver's resource.
     * @param {Object} aValue The value to set the referenced portion of the
     *     resource to.
     * @param {TP.sig.Request} [aRequest] An optional request used to retrieve
     *     the receiver's resource.
     * @exception {TP.sig.InvalidParameter} When the supplied path is not valid.
     * @returns {TP.uri.URI} The receiver.
     */

    var req,
        result,
        path;

    //  Copy the request and make sure it's configured for an 'sync' fetch.
    req = TP.request(aRequest).copy();
    req.atPut('async', false);

    result = this.getResource(req).get('result');

    if (aPath.isAccessPath()) {
        path = TP.copy(aPath);
    } else if (TP.isString(aPath)) {
        path = TP.apc(aPath);
    }

    //  Note here how we set buildout to true by default. This allows us maximum
    //  convenience in setting the resource's portion.
    if (TP.isValid(result)) {
        path.set('buildout', true);
        path.executeSet(result, aValue);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('setResourceToResultOf',
function(aURI, aRequest, shouldCopy) {

    /**
     * @method setResourceToResultOf
     * @summary Sets the receiver's resource object to the result of the
     *     resource pointed to by aURI. If the shouldCopy flag is true, then a
     *     copy of the result is made before setting it as the resource of the
     *     receiver.
     * @param {TP.uri.URI} aURI The URI of the resource object to use as the
     *     resource source.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
     *     optional parameters.
     * @param {Boolean} [shouldCopy=false] Whether or not to make a copy of the
     *     result before using it as the receiver's resource. Note that this
     *     will cause a *deep copy* of the receiver's resource to be made.
     * @returns {TP.sig.Response|null} A TP.sig.Response created with the newly
     *     set content set as its result or null if there was no content in the
     *     result.
     */

    var req,

        result,
        newResult;

    //  Copy the request and make sure it's configured for an 'sync' fetch.
    req = TP.request(aRequest).copy();
    req.atPut('async', false);

    result = aURI.getResource(req).get('result');
    if (TP.isValid(result)) {

        if (TP.isTrue(shouldCopy)) {
            newResult = TP.copy(result, true);
        } else {
            newResult = result;
        }

        this.set('shouldCreateContent', true);

        return this.setResource(newResult, aRequest);
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('$setResultContent',
function(aRequest, aResult, aResource) {

    /**
     * @method $setResultContent
     * @summary Invoked as a "success body" function for the setContent call
     *     with the purpose of updating the content of the result object being
     *     provided.
     * @param {TP.sig.Request|TP.core.Hash} [aRequest] An optional object
     *     defining control parameters.
     * @param {Object} aResult The result of a content access call.
     * @param {Object} [aResource] Optional data used for set* methods.
     * @exception {TP.sig.InvalidResource} When the target resource is not
     *     modifiable.
     * @returns {Object} The return value for the content operation using this
     *     as a success body function.
     */

    var result,
        request,
        wasDirty,
        isDirty;

    request = this.constructRequest(aRequest);

    if (TP.isKindOf(aResult, 'TP.sig.Response')) {
        result = aResult.getResult();
    } else {
        result = aResult;
    }

    //  Try to collapse and process using the smartest objects possible.
    result = TP.isCollection(result) ? TP.collapse(result) : result;
    result = TP.isNode(result) ? TP.wrap(result) : result;

    if (TP.canInvoke(result, 'set')) {

        wasDirty = this.isDirty();

        //  Since we observe our resource for Change, we need to ignore handling
        //  Change from it, set the resource and then resume observing it.
        this.ignore(result, 'Change');
        result.set('content', aResource);
        this.observe(result, 'Change');

        isDirty = this.isDirty(true);

        if (this.$get('resource') !== result) {
            this.$set('resource', result);
        }

        //  Then, we broadcast change from ourself as if we were re-broadcasting
        //  a Change notification from our resource.
        this.signal('TP.sig.ValueChange',
                    TP.hc('action', TP.UPDATE,
                            'aspect', 'value',
                            'facet', 'value',
                            'target', result),
                    TP.INHERITANCE_FIRING,
                    TP.sig.ValueChange);

        //  If the result isn't a TP.core.Content, then since we won't have
        //  broadcast a 'dirty' change above when we set the content (due to the
        //  ignore/observe shuffle), we go ahead and send it here if the flag
        //  has changed. If the result is a TP.core.Content, then it will send a
        //  dirty from us when it changes.
        if (!TP.isKindOf(result, TP.core.Content) &&
            isDirty !== wasDirty) {
            TP.$changed.call(
                        this,
                        'dirty',
                        TP.UPDATE,
                        TP.hc(TP.OLDVAL, wasDirty, TP.NEWVAL, isDirty));
        }

        //  We set the content of the object that we're holding as our resource
        //  - no sense to reset the content itself.
        return result;
    } else if (!this.isLoaded()) {
        result = TP.core.Content.construct(aResource, this);
    } else {
        return this.raise('TP.sig.InvalidResource',
                            'Unable to modify target resource.');
    }

    this.$setPrimaryResource(result, request);

    return result;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('$setResultFragment',
function(aRequest, aResult, aResource, shouldSignal) {

    /**
     * @method $setResultFragment
     * @summary Invoked as a "success body" function for the setResource call
     *     with the purpose of setting the secondary resource.
     * @param {TP.sig.Request|TP.core.Hash} [aRequest] An optional object
     *     defining control parameters.
     * @param {Object} aResult The result of a content access call.
     * @param {Object} [aResource] Optional data used for set* methods.
     * @param {Boolean} [shouldSignal=true] Should changes to the value be
     *     signaled? By default true, but occasionally set to false when a
     *     series of changes is being performed etc.
     * @exception {TP.sig.InvalidResource} When the target resource is not
     *     modifiable.
     * @returns {Object} The return value for the content operation using this
     *     as a success body function.
     */

    var fragment,
        result,
        request,
        fragmentAccessor,
        oldResource,
        pathInfo,
        shouldSignalChange;

    request = this.constructRequest(aRequest);

    //  Signal change any time value changes...unless explicitly turned off.
    if (TP.isValid(shouldSignal)) {
        shouldSignalChange = shouldSignal;
    } else if (request.hasParameter('signalChange')) {
        shouldSignalChange = request.at('signalChange');
    } else if (!this.resourcesAreAlike(oldResource, aResource)) {
        shouldSignalChange = true;
    }

    //  aResult here will be the resource for the primary URI. Therefore, if we
    //  are the primary URI, it will be our whole data object. If we are a
    //  'secondary URI' pointing to a fragment, then we try to access the slice
    //  of the overall resource and set it using the optionally provided object
    //  in aResource.

    fragment = this.getFragment();
    if (TP.notEmpty(fragment)) {
        fragment = fragment.indexOf('#') === 0 ? fragment : '#' + fragment;

        //  Try to collapse and wrap to use the smartest objects possible for
        //  the query.
        result = TP.isCollection(aResult) ? TP.collapse(aResult) : aResult;
        result = TP.isNode(result) ? TP.wrap(result) : result;

        if (TP.regex.DOCUMENT_ID.test(fragment) ||
                TP.regex.BARENAME.test(fragment)) {
            fragmentAccessor = fragment;
        } else if (TP.regex.ANY_POINTER.test(fragment)) {
            fragmentAccessor = TP.apc(fragment, TP.hc('shouldCollapse', true));

            //  If we're configured to create content, then flip the fragment
            //  accessor's flag to make structures.
            if (TP.isTrue(this.get('shouldCreateContent'))) {

                fragmentAccessor.set('buildout', true);

                //  If result was not valid, then our primary URI doesn't have
                //  valid object for us to use as a starting point - try to
                //  create one based on our path type.
                if (TP.notValid(result)) {

                    result = this.$constructPrimaryResourceStub(
                                    fragmentAccessor.getPathType());

                    if (TP.isValid(result)) {
                        this.getPrimaryURI().setResource(result);
                    }
                }
            }
        }

        if (TP.canInvoke(result, 'set')) {
            oldResource = result.get(fragmentAccessor);
            result.set(fragmentAccessor, aResource, shouldSignalChange);
        } else {
            this.raise('TP.sig.InvalidResource',
                'Unable to modify target resource.');
        }
    } else {
        this.raise('TP.sig.InvalidFragment');
    }

    if (fragmentAccessor.isAccessPath()) {

        //  Grab the set of 'path info records' that contain data about the
        //  paths that changed when the 'set' was executed above. This will be
        //  used by the notification method to send changed notifications from
        //  other URIs that contain paths (as their fragments) that are
        //  'dependent' on that new data that was set.
        pathInfo = fragmentAccessor.getLastChangedPathsInfo(result);
        if (shouldSignalChange) {

            //  Send notification from the other URIs that are dependent on the
            //  new data.
            this.$sendDependentURINotifications(
                        oldResource, aResource, pathInfo);
        } else {
            //  NOTE the 'true' here signifies 'primary only' so we'll always at
            //  least tell our primary we changed something.
            this.$sendDependentURINotifications(
                oldResource, aResource, pathInfo, true);
        }
    }

    //  If there was already a value then we consider new values to dirty the
    //  resource from a state perspective. If we weren't loaded yet we consider
    //  ourselves to be 'clean' until a subsequent change.
    if (request.at('loaded')) {
        if (!this.resourcesAreAlike(oldResource, aResource)) {
            this.isDirty(true, true);
        }
    } else {
        this.isLoaded(true);
        this.isDirty(false, true);
    }

    return result;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('setValue',
function(aValue) {

    /**
     * @method setValue
     * @summary Sets the 'value' of the receiver. This method provides
     *     polymorphic behavior by calling the receiver's 'setContent' method.
     * @param {Object} aValue The value to set the value of the receiver to.
     * @returns {Boolean} Whether or not the value was changed from the value it
     *     had before this method was called.
     */

    this.setContent(aValue);

    return true;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('stubResourceContent',
function() {

    /**
     * @method stubResourceContent
     * @summary 'Stubs' the resource content to have a single instance of
     *     TP.lang.Object with a 'value' slot. This object is also configured to
     *     be a 'good' resource for the URI by turning on its change mechanism.
     * @description This method is used to 'stub in' very basic object that can
     *     store a value in its 'value' slot and will signal a notification
     *     when that value changes. This is necessary in scenarios like data
     *     binding when bindings are triggered into this URI and no resource has
     *     been set.
     * @returns {TP.uri.URI} The receiver.
     */

    var resourceContent;

    //  This only gets done for primary URIs, so if we're not one, we call up to
    //  that (the check below will make sure that if the primary URI has a
    //  resource it won't be replaced).
    if (!this.isPrimaryURI()) {
        return this.getPrimaryURI().stubResourceContent();
    }

    //  If the receiver doesn't have a real resource result, replace it.
    if (TP.notValid(resourceContent = this.getResource().get('result'))) {

        //  Construct a simple TP.lang.Object, define a 'value' slot on it and
        //  give it an initial value of the empty String. Also, configure it be
        //  a good citizen as a resource for URIs by signaling change.
        resourceContent = TP.lang.Object.construct();

        resourceContent.defineAttribute('value');
        resourceContent.set('value', '', false);

        resourceContent.shouldSignalChange(true);

        this.setResource(resourceContent);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('shouldSignalChange',
function(aFlag) {

    /**
     * @method shouldSignalChange
     * @summary Defines whether the receiver should actively signal change
     *     notifications.
     * @description In general URI objects do not signal changes from their own
     *      properties, because they act as 'value holders' for their resources.
     *      They will signal Change when their resources do so, acting as a
     *      'forwarding' mechanism for their resources.
     * @param {Boolean} aFlag true/false signaling status.
     * @returns {Boolean} The current status.
     */

    //  Yes, TP.uri.URIs are hardcoded to return false here.
    return false;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('resourcesAreAlike',
function(resourceA, resourceB) {

    /**
     * @method resourcesAreAlike
     * @summary Returns whether or not the resources are alike in some
     *     receiver-defined way (e.g. either equality or identity) such that
     *     setting the receiver to the new resource would consider it to be
     *     not 'dirty'.
     * @param {Object} resourceA The first resource object to use for
     *     comparison.
     * @param {Object} resourceB The second resource object to use for
     *     comparison.
     * @returns {Boolean} Whether or not the resources are alike in some
     *     receiver-defined way.
     */

    return TP.equal(resourceA, resourceB);
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('transform',
function(aDataSource, aRequest) {

    /**
     * @method transform
     * @summary Uses the receiver's URI content as a template and performs a
     *     transform operation. The data to transform is provided in aDataSource
     *     while parameters to the transformation operation should be placed in
     *     aRequest.
     * @description Note that since this method calls getResource() the
     *     parameter list is provided to both getResource() and transform(),
     *     creating the potential for confusion if parameter names overlap. If
     *     this is possible you should invoke getResource() and transform
     *     separately.
     * @param {Object} aDataSource The object supplying the data to use in the
     *     transformation.
     * @param {TP.core.Hash|TP.sig.Request} aRequest A parameter container
     *     responding to at(). For string transformations a key of 'repeat' with
     *     a value of true will cause iteration to occur (if aDataSource is an
     *     'ordered collection' this flag needs to be set to 'true' in order to
     *     have 'automatic' iteration occur). Additional keys of '$STARTINDEX'
     *     and '$REPEATCOUNT' determine the range of the iteration.
     * @returns {TP.sig.Response} A TP.sig.Response created with the transformed
     *     content set as its result.
     */

    var request,

        subrequest,
        async;

    request = this.constructRequest(aRequest);

    //  If we're going to have to request the data then the key thing we
    //  want to avoid is having an incoming request complete() before the
    //  entire process is finished. That means ensuring we have a clean
    //  subrequest instance we can locally modify.
    subrequest = this.constructSubrequest(request);
    subrequest.atPut('async', false);

    subrequest.defineMethod(
            'completeJob',
            function(aResult) {

                var resource,
                    result;

                if (TP.isDefined(aResult)) {
                    //  In case aResult returned an Array (very likely if it
                    //  ran some sort of 'getter path'), we collapse it here
                    //  - can't transform from an Array of TP.dom.Nodes.
                    result = TP.collapse(aResult);
                    resource = TP.wrap(result);
                }

                if (TP.canInvoke(resource, 'transform')) {
                    result = resource.transform(aDataSource, request);

                    //  rewrite the request result object so we hold on to
                    //  the processed content rather than the inbound
                    //  content.
                    subrequest.set('result', result);
                }

                subrequest.$wrapupJob('Succeeded', TP.SUCCEEDED, result);

                if (TP.canInvoke(request, 'complete')) {
                    //  Note that this could be null if there's no result,
                    //  or if the transform call isn't supported, or if the
                    //  transform simply produces a null result.
                    if (TP.isValid(result)) {
                        request.complete(result);
                    } else {
                        request.complete();
                    }
                }

                subrequest.getResponse(result);
            });

    subrequest.defineMethod(
            'failJob',
            function(aFaultString, aFaultCode, aFaultInfo) {

                var info,
                    subrequests;

                info = TP.hc(aFaultInfo);
                if (TP.isValid(subrequests = info.at('subrequests'))) {
                    subrequests.push(subrequest);
                } else {
                    subrequests = TP.ac(subrequest);
                    info.atPut('subrequests', subrequests);
                }

                subrequest.$wrapupJob('Failed', TP.FAILED);

                if (TP.canInvoke(request, 'fail')) {
                    request.fail(aFaultString, aFaultCode, info);
                }
            });

    //  trigger the invocation and rely on the handlers for the rest.
    this.getResource(subrequest, TP.hc('resultType', TP.WRAP));

    //  If async we can only return the result/response being used to
    //  actually process the async activity.
    //  NOTE that we need to re-read the async state in case our underlying
    //  resource is async-only and potentially rewrote the value.
    async = this.rewriteRequestMode(subrequest);
    if (async) {
        request.andJoinChild(subrequest);

        //  hand back the response object for the "outer" request, which
        //  will be either the originating request or our internally
        //  constructed one (which was also used as the subrequest)
        if (TP.canInvoke(request, 'getResponse')) {
            return request.getResponse();
        } else {
            return subrequest.getResponse();
        }
    }

    //  If the routine was invoked synchronously then the data will have
    //  been placed in the subrequest.
    return subrequest.getResponse();
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('unregister',
function() {

    /**
     * @method unregister
     * @summary Unregisters the receiver from the overall TP.uri.URI registry.
     * @returns {TP.uri.URI} The receiver.
     */

    var oldResource;

    //  If we are loaded, then we may be observing our resource for *Change
    //  signals. If so, we need to ignore it for those.
    if (this.isLoaded()) {
        oldResource = this.$get('resource');
        this.ignore(oldResource, 'Change');
    }

    TP.uri.URI.removeInstance(this);

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Inst.defineMethod('updateHeaders',
function(headerData) {

    /**
     * @method updateHeaders
     * @summary Updates the receiver's headers, usually from a set of HTTP
     *     headers returned from the last HTTP request used to load this URIs
     *     content.
     * @param {Object} headerData A string, hash, or request object containing
     *     header data.
     * @returns {TP.uri.URI} The receiver.
     */

    var dict,
        str,
        xhr,

        arr,
        i,
        len,

        parts,
        key,
        value,

        theDate;

    dict = this.$get('headers');

    if (TP.isHash(headerData)) {
        if (TP.isValid(dict)) {
            dict.addAll(headerData);
        } else {
            dict = headerData.copy();
        }
    } else if (TP.isValid(headerData)) {
        if (TP.isString(headerData)) {
            str = headerData;
        } else if (TP.isXHR(headerData)) {
            str = TP.ifEmpty(headerData.getAllResponseHeaders(), '');
        } else if (TP.canInvoke(headerData, 'at')) {
            if (TP.isXHR(xhr = headerData.at('commObj'))) {
                str = TP.ifEmpty(xhr.getAllResponseHeaders(), '');
            }
        }

        //  if we were able to find a string then we can process it into its
        //  component parts
        if (TP.notEmpty(str)) {
            if (TP.notValid(dict)) {
                dict = TP.hc();
            }

            arr = str.split('\n');

            len = arr.getSize();
            for (i = 0; i < len; i++) {
                parts = arr.at(i).split(':');
                key = parts.shift();
                value = parts.join(':');

                if (TP.notEmpty(key)) {
                    dict.atPut(key, value);
                }
            }
        }
    }

    if (TP.notValid(dict)) {
        dict = TP.hc();
    }

    //  finally make sure we have the minimum required headers
    if (TP.notValid(dict.at('Date'))) {
        //  cache so we avoid date creation overhead
        theDate = TP.dc();
        this.$set('lastUpdated', theDate, false);

        dict.atPut('Date', theDate.toUTCString());
    }

    //  be sure to save back as needed
    this.$set('headers', dict, false);

    return this;
});

//  ========================================================================
//  TP.uri.URN
//  ========================================================================

/**
 * @type {TP.uri.URN}
 * @summary A subtype of TP.uri.URI that models Uniform Resource Names in the
 *     TIBET system. A URN identifies its resource by specifying a name. Each
 *     "namespace identifier" (NID) tends to have a custom subtype of
 *     TP.uri.URN to handle namespace-specific processing needs.
 * @description Note that the spec requires this name to be globally unique and
 *     persistent, even after the resource it points to no longer exists or is
 *     reachable. This condition is not enforced. Also, this type does not limit
 *     the namespace ID to less than 32 characters, per the URN RFC 2141, nor
 *     does it limit which non-alphanumeric characters can be in the namespace
 *     specific string per that same spec.
 */

//  ------------------------------------------------------------------------

TP.uri.URI.defineSubtype('URN');

//  You can't have a generic URN, you have to have a subtype specific to the
//  namespace identification string.
TP.uri.URN.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.uri.URN.Type.defineConstant('URN_REGEX',
                            TP.rc('urn:([a-zA-Z0-9]*):(\\S+)'));

TP.uri.URN.Type.defineConstant('URN_NSS_REGEX',
                            TP.rc('^([a-zA-Z0-9]+):(\\S+)'));

TP.uri.URN.Type.defineConstant('SCHEME', 'urn');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  registry for subtypes based on the NID they are responsible for.
//  'urn:' scheme is sync-only so configure for that
TP.uri.URN.Type.defineAttribute('supportedModes',
                                TP.core.SyncAsync.SYNCHRONOUS);
TP.uri.URN.Type.defineAttribute('mode',
                                TP.core.SyncAsync.SYNCHRONOUS);

TP.uri.URN.Type.defineAttribute('nidHandlers', TP.hc());

TP.uri.URN.registerForScheme('urn');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.uri.URN.Type.defineMethod('getConcreteType',
function(aPath) {

    /**
     * @method getConcreteType
     * @summary Returns the type to use for a particular URI path.
     * @param {String} aPath A URI string providing at least a scheme which can
     *     be looked up for a concrete type.
     * @returns {TP.lang.RootObject|undefined} A type object.
     */

    var parts,
        nid,
        type;

    parts = aPath.split(':');
    if (parts.at(0) !== 'urn') {
        return;
    }

    nid = TP.ifEmpty(parts.at(1), 'tibet');

    //  make sure urn:tibet:something
    if (nid === 'tibet') {
        if (TP.isEmpty(parts.at(2))) {
            return;
        }

        if (!parts.at(2).isJSIdentifier()) {
            return;
        }
    }

    type = TP.uri.URN.$get('nidHandlers').at(nid);
    if (TP.isType(type) && !type.isAbstract()) {
        return type;
    }

    //  TODO:   convention...build a type name and look for it.
    return;
});

//  ------------------------------------------------------------------------

TP.uri.URN.Type.defineMethod('registerForNID',
function(aNID) {

    /**
     * @method registerForNID
     * @summary Registers the receiving type for handling construction of URN
     *     instances for a particular namespace ID (NID).
     * @param {String} aNID A URN namespace ID such as 'oid', or 'tibet'.
     * @exception {TP.sig.InvalidParameter} When the scheme isn't a string.
     * @returns {TP.meta.uri.URN} The receiver.
     */

    var theNID;

    if (!TP.isString(aNID)) {
        return this.raise('TP.sig.InvalidParameter',
                            'Scheme is empty or null.');
    }

    theNID = aNID.strip(':');
    TP.uri.URN.$get('nidHandlers').atPut(theNID, this);

    return this;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  the Namespace ID (NID) from the URN specification
TP.uri.URN.Inst.defineAttribute('nid');

//  the Namespaces Specific String (NSS)
TP.uri.URN.Inst.defineAttribute('nss');

//  The "name" portion as TIBET perceives it. This is effectively the NSS
//  minus any concept of fragment.
TP.uri.URN.Inst.defineAttribute('name');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.uri.URN.Inst.defineMethod('$initURIComponents',
function(parts) {

    /**
     * @method $initURIComponents
     * @summary Performs any post-parsing initialization appropriate for the
     *     URI components which were parsed during scheme-specific parsing.
     * @param {TP.core.Hash} parts The parsed URI components.
     * @returns {TP.uri.URI} The receiver.
     */

    //  NOTE: These '$set' calls use 'false' to avoid notification!! This is
    //  necessary when creating a URI, since otherwise the change notification
    //  mechanism will cause errors trying to get observations set up before
    //  everything is in place.

    if (TP.canInvoke(parts, 'at')) {
        this.$set('nid', parts.at('nid'), false);
        this.$set('nss', parts.at('nss'), false);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URN.Inst.defineMethod('$parseSchemeSpecificPart',
function(schemeSpecificString) {

    /**
     * @method $parseSchemeSpecificPart
     * @summary Parses inbound URI string content in a fashion specific to the
     *     scheme(s) being managed by the receiver.
     * @param {String} schemeSpecificString A String containing the
     *     "scheme-specific-part" of a URI.
     * @returns {TP.core.Hash} The parsed URI 'components'.
     */

    var match,
        hash;

    this.callNextMethod();

    match = TP.uri.URN.URN_NSS_REGEX.exec(schemeSpecificString);
    if (TP.isArray(match)) {
        hash = TP.hc('nid', match.at(1), 'nss', match.at(2));
    }

    return hash;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.uri.URN.Inst.defineMethod('$getPrimaryResource',
function(aRequest, filterResult) {

    /**
     * @method $getPrimaryResource
     * @summary Returns the object registered under the receiver's "name".
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @param {Boolean} filterResult True if the resource result will be used
     *     directly and should be filtered to match any resultType definition
     *     found in the request. The default is false.
     * @returns {TP.sig.Response} A TP.sig.Response created with the resource's
     *     content set as its result.
     */

    var url,

        refresh,
        request,
        result,
        response;

    request = this.constructRequest(aRequest);

    //  If we're not the primary URI, that means we have a fragment. So we have
    //  to get the 'whole' resource from the primary URI and then proceed
    //  forward. Note that, in this case, the original request passed in will be
    //  configured to retrieve the value of the fragment, so we have to use a
    //  new, one-time, request here.
    if ((url = this.getPrimaryURI()) !== this) {

        //  The primary resource for a URN is always a URN, so we don't have to
        //  worry about asynchronicity.
        result = url.$getPrimaryResource(
            TP.request('async', false, 'shouldSignal', false),
                filterResult).get('result');
    } else {

        //  Things that we do only if we're the primary URI

        refresh = TP.ifKeyInvalid(request, 'refresh', null);
        result = this.$get('resource');

        if (TP.notValid(result) || refresh) {
            result = this.$resolveName(this.getName());

            //  Store the result as our resource, we just refreshed.
            this.$set('resource', result, false);
        }
    }

    //  filter any remaining data
    if (TP.isTrue(filterResult) && TP.isValid(result)) {
        result = this.$getFilteredResult(result, request, false);
    }

    response = request.getResponse(result);
    request.complete(result);

    return response;
});

//  ------------------------------------------------------------------------

TP.uri.URN.Inst.defineMethod('getName',
function() {

    /**
     * @method getName
     * @summary Returns the receiver's "name" as TIBET perceives it, which is
     *     effectively the NSS (Namespace Specific String) portion of the
     *     receiver's location string minus any fragment where the concept of
     *     fragment here is a TIBET extension.
     * @returns {String} The NSS or name.
     */

    var loc,
        name;

    if (TP.owns(this, 'name') && TP.notEmpty(name = this.$get('name'))) {
        return name;
    }

    loc = this.getLocation();
    if (TP.notValid(loc)) {
        //  Default to same as URI, the OID. Usually for prototype(s).
        name = this.$getOID();
    } else {
        name = loc.split(':').slice(2).join(':').split('#').first();
    }
    this.$set('name', name);

    return name;
});

//  ------------------------------------------------------------------------

TP.uri.URN.Inst.defineMethod('$resolveName',
function(aName) {

    /**
     * @method $resolveName
     * @summary Resolves the receiver's "name" or the name value provided,
     *     returning the referenced resource. This method is invoked by the
     *     $getPrimaryResource call to perform type-specific name resolution
     *     logic.
     * @param {String} aName The name to resolve.
     * @returns {Object} The resource referenced by the receiver's name or name
     *     value.
     */

    return this.$get('resource');
});

//  ------------------------------------------------------------------------

TP.uri.URN.Inst.defineMethod('resourcesAreAlike',
function(resourceA, resourceB) {

    /**
     * @method resourcesAreAlike
     * @summary Returns whether or not the resources are alike in some
     *     receiver-defined way (e.g. either equality or identity) such that
     *     setting the receiver to the new resource would consider it to be
     *     not 'dirty'.
     * @param {Object} resourceA The first resource object to use for
     *     comparison.
     * @param {Object} resourceB The second resource object to use for
     *     comparison.
     * @returns {Boolean} Whether or not the resources are alike in some
     *     receiver-defined way.
     */

    return TP.identical(resourceA, resourceB);
});

//  ------------------------------------------------------------------------
//  Storage Management
//  ------------------------------------------------------------------------

TP.uri.URN.Inst.defineMethod('load',
function(aRequest) {

    /**
     * @method load
     * @summary For the most part, no-op for URNs.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    var request,
        url,
        handler;

    request = this.constructRequest(aRequest);

    //  rewriting means we'll get to the concrete URI for the receiver so we
    //  put the data where it really belongs
    url = this.rewrite(request);

    request.atPut('operation', 'load');

    //  NB: We hard-code 'TP.uri.URIHandler' as our handler here, since it
    //  really just completes the request properly and doesn't do much else. See
    //  that type for more information.
    handler = TP.uri.URIHandler;

    return handler.load(url, request);
});

//  ------------------------------------------------------------------------

TP.uri.URN.Inst.defineMethod('delete',
function(aRequest) {

    /**
     * @method delete
     * @summary For the most part, a no-op for URNs.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    var request,
        url,
        handler;

    request = this.constructRequest(aRequest);

    //  rewriting means we'll get to the concrete URI for the receiver so we
    //  put the data where it really belongs
    url = this.rewrite(request);

    request.atPut('operation', 'delete');

    //  NB: We hard-code 'TP.uri.URIHandler' as our handler here, since it
    //  really just completes the request properly and doesn't do much else. See
    //  that type for more information
    handler = TP.uri.URIHandler;

    return handler.delete(url, request);
});

//  ------------------------------------------------------------------------

TP.uri.URN.Inst.defineMethod('save',
function(aRequest) {

    /**
     * @method save
     * @summary For the most part, a no-op for URNs.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    var request,
        url,
        handler;

    request = this.constructRequest(aRequest);

    //  rewriting means we'll get to the concrete URI for the receiver so we
    //  put the data where it really belongs
    url = this.rewrite(request);

    request.atPut('operation', 'save');

    //  NB: We hard-code 'TP.uri.URIHandler' as our handler here, since it
    //  really just completes the request properly and doesn't do much else. See
    //  that type for more information
    handler = TP.uri.URIHandler;

    return handler.save(url, request);
});

//  ========================================================================
//  TP.uri.TIBETURN
//  ========================================================================

/**
 * @type {TP.uri.TIBETURN}
 * @summary A subtype of TP.uri.URN specific to the urn:tibet 'namespace'.
 * @description When creating URNs the portion after the scheme is what is known
 *     as the "NIS" or Namespace Identification String". This is followed by the
 *     "NSS" or Namespace Specific String. To ensure proper parsing of the
 *     latter we use subtypes specific to each URN namespace, the most common of
 *     which is the 'tibet' NIS.
 */

//  ------------------------------------------------------------------------

TP.uri.URN.defineSubtype('TIBETURN');

TP.uri.TIBETURN.registerForNID('tibet');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.uri.TIBETURN.Inst.defineMethod('$resolveName',
function(aName) {

    /**
     * @method $resolveName
     * @summary Resolves the receiver's "name" or the name value provided,
     *     returning the referenced resource. This method is invoked by the
     *     $getPrimaryResource call to perform type-specific name resolution
     *     logic.
     * @param {String} aName The name to resolve.
     * @returns {Object} The resource referenced by the receiver's name or name
     *     value.
     */

    var str,
        result,

        parts,
        obj;

    str = aName || this.getName();

    if (TP.regex.TIBET_URN.test(str)) {
        str = str.slice(TP.TIBET_URN_PREFIX.length);
    }

    //  We want registered objects to take precedence over types.
    result = this.$get('resource');
    if (TP.notValid(result)) {

        //  And we want types to take precedence over global objects.
        result = TP.sys.getTypeByName(str);

        //  And we want namespace objects to take precedence over global
        //  objects.
        if (TP.notValid(result) && TP.regex.VALID_NAMESPACENAME.test(str)) {
            parts = TP.regex.VALID_NAMESPACENAME.match(str);
            obj = TP.global[parts.at(1)][parts.at(2)];
            if (TP.isValid(obj) && TP.isNamespace(obj)) {
                result = obj;
            }
        }

        //  Note that we only return a global here *if the name is in the
        //  globals dictionary*
        if (TP.notValid(result) && TP.sys.$globals.hasKey(str)) {
            try {
                result = TP.global[str];
            } catch (e) {
                //  Ignore errors attempting lookup.
                void 0;
            }
        }
    }

    return result;
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURN.Inst.defineMethod('$setPrimaryResource',
function(aResource, aRequest, shouldSignal) {

    /**
     * @method $setPrimaryResource
     * @summary Sets the receiver's resource object, the object TIBET will
     *     treat as the primary resource for any subsequent processing.
     * @param {Object} aResource The resource object to assign.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
     *     optional parameters.
     * @param {Boolean} [shouldSignal=true] Should changes to the value be
     *     signaled? By default true, but occasionally set to false when a
     *     series of changes is being performed etc.
     * @returns {TP.uri.URL|TP.sig.Response} The receiver or a TP.sig.Response
     *     when the resource must be acquired in an async fashion prior to
     *     setting any fragment value.
     */

    var url,
        request,
        oldResource,
        newResource,
        hasID,
        dirty,
        loaded,
        shouldSignalChange;

    //  If the receiver isn't a "primary URI" then it really shouldn't be
    //  holding data, it should be pushing it to the primary...
    if ((url = this.getPrimaryURI()) !== this) {
        return url.$setPrimaryResource(aResource, aRequest);
    }

    request = this.constructRequest(aRequest);

    loaded = request.at('loaded');

    oldResource = this.$get('resource');

    //  NOTE for URN we don't normalize the resource, we leave it as is.
    newResource = aResource;

    //  If the resource doesn't already have a user-set ID (i.e. its ID is the
    //  same as its OID), we're going to set it to our 'name'.
    if (TP.isValid(newResource)) {
        /* eslint-disable no-extra-parens */
        hasID = (newResource[TP.ID] !== newResource.$$oid);
        /* eslint-enable no-extra-parens */

        if (!hasID) {
            if (TP.canInvoke(newResource, 'setID')) {
                newResource.setID(this.getName());
            }
        }
    }

    //  Core question of whether we're dirty or not, will value change.
    if (this.resourcesAreAlike(oldResource, newResource)) {
        dirty = false;
    } else {
        //  NOTE we don't consider setting a value to the processed version of
        //  the same value as an operation that dirties the URI.
        if (request.at('processedResult') === true) {
            dirty = false;
        } else {
            dirty = true;
        }
    }

    //  If we already have a resource, make sure to 'ignore' it for changes.
    //  Unfortunately, even if we're about to get the same resource set we have
    //  to cycle the observations since we can't be sure we observed initially.
    if (TP.isValid(oldResource) && TP.isMutable(oldResource)) {
        this.ignore(oldResource, 'Change');
    }

    //  If the request parameters contain the flag for observing our
    //  resource, then observe it for all *Change signals.

    //  NOTE!! We do this here because, if the resource is a TP.core.Content
    //  object, which will observe it's underlying data, it may already have
    //  a URI created for it (when that observation is made). In that case,
    //  if we enter this logic because, the caller here is be providing the
    //  same resource, it may want to observe this URI for change.
    if (TP.notFalse(request.at('observeResource')) &&
        TP.isMutable(newResource)) {
        //  Observe the new resource object for changes.
        this.observe(newResource, 'Change');
    }

    //  Use request info or current loaded state (CHECKED BEFORE WE UPDATE IT)
    //  to determine if we should signal change.
    if (TP.isDefined(shouldSignal)) {
        shouldSignalChange = shouldSignal;
    } else if (request.hasParameter('signalChange')) {
        shouldSignalChange = request.at('signalChange');
    } else {
        shouldSignalChange = dirty;
    }

    //  What we do with value and flags depends on the originating operation.
    switch (request.at('operation')) {
        case 'load':
            //  fallthrough
        case 'get':
            this.$set('resource', newResource, false);
            this.isLoaded(true);
            this.isDirty(false, true);
            break;
        case 'set':
            this.$set('resource', newResource, false);
            this.isLoaded(true);    //  arguable semantics but important for
                                    //  preloaded URIs
            if (loaded) {
                this.isDirty(dirty);
            } else {
                this.isDirty(false, true);
            }
            break;
        case 'save':
            //  NOTE we don't save results for save..., it's usually an empty
            //  response.
            this.isLoaded(true);
            this.isDirty(false, true);

            //  We don't signal since we're only pushing data, not altering it.
            shouldSignalChange = false;
            break;
        case 'delete':
            //  NOTE we don't save results for delete..., it's usually an empty
            //  response.
            this.isLoaded(false);
            this.isDirty(false, true);

            //  We always signal since whatever value was there is now undefined.
            shouldSignalChange = true;
            break;
        default:
            return this.raise('InvalidOperation', request.at('operation'));
    }

    //  clear any expiration computations
    this.expire(false);

    if (shouldSignalChange) {
        this.$sendSecondaryURINotifications(oldResource, newResource);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURN.Inst.defineMethod('getResource',
function(aRequest) {

    /**
     * @method getResource
     * @summary Returns a receiver-specific object representing the "secondary"
     *     resource being accessed. This method is overridden from its supertype
     *     to provide more direct access to the underlying resource, since
     *     TIBETURNs are really just memory locations and are always available
     *     synchronously.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} A TP.sig.Response created with the resource's
     *     content set as its result.
     */

    var primaryResource,

        request,
        result,

        response;

    //  NB: The call to $get('resource') here - this does *NOT* return a
    //  response, but the real object. We can assume 'async' is false since this
    //  is a URN.
    if (TP.notValid(primaryResource = this.getPrimaryURI().$get('resource'))) {
        return this.callNextMethod();
    }

    request = this.constructRequest(aRequest);

    //  Track initial state so we can properly process flags/results.
    request.atPutIfAbsent('operation', 'get');
    request.atPutIfAbsent('loaded', this.isLoaded());

    //  When we're primary or we don't have a fragment we can keep it simple and
    //  return primaryResource.
    if (this.isPrimaryURI() ||
        !this.hasFragment() ||
        this.getFragment() === 'document') {
        result = this.$getFilteredResult(primaryResource, request);
    } else {
        result = this.$getResultFragment(aRequest, primaryResource);
    }

    //  synchronous? complete any request we might actually have.
    if (TP.canInvoke(request, 'complete')) {
        request.complete(result);
    }

    response = request.getResponse(result);

    return response;
});

//  ========================================================================
//  TP.uri.URL
//  ========================================================================

/**
 * @type {TP.uri.URL}
 * @summary A subtype of TP.uri.URI that models Uniform Resource Locators in
 *     the TIBET system. A URL identifies its resource by specifying the network
 *     location.
 * @description The API of this object matches that of the Location object in
 *     the browser, although one can have multiple instances of these objects to
 *     represent many URLs that would be encountered in a TIBET program.
 */

//  ------------------------------------------------------------------------

TP.uri.URI.defineSubtype('URL');

//  TP.uri.URL is an abstract type - the scheme will cause a concrete type
//  to be created.
TP.uri.URL.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.uri.URL.Type.defineConstant('SCHEME', null);

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  the 'path' varies by scheme but is typically found behind any host:port
//  or file: prefixes
TP.uri.URL.Inst.defineAttribute('path');
TP.uri.URL.Inst.defineAttribute('lastRequest');

//  whether or not the URI is being watched for change. NOTE: do NOT set this
//  to false without changing the getWatched method logic. Null implies true.
TP.uri.URL.Inst.defineAttribute('watched', null);

//  whether or not we should try to PATCH this instance
TP.uri.URL.Inst.defineAttribute('$shouldPatch');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('asURL',
function() {

    /**
     * @method asURL
     * @summary Returns the receiver as a URL (this).
     * @returns {TP.uri.URL} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('canDiffPatch',
function() {

    /**
     * @method canDiffPatch
     * @summary Returns whether or not the receiver can 'diff patch' its remote
     *     resource.
     * @description In order to be 'diff patchable', URLs (currently) need to be
     *     served from the TDS and be a particular resource type:
     *
     *          XML
     *          JSON
     *          XHTML
     *          XSLT
     *          PLAIN TEXT
     *          CSS
     *
     *      They also need to have an extension.
     * @returns {Boolean} Whether or not the URL contains a resource that is
     *     'diff patchable'.
     */

    var mimeType;

    if (TP.isFalse(this.get('$shouldPatch'))) {
        return false;
    }

    //  Mime type must match one we can actually diff.
    mimeType = this.getMIMEType();

    switch (mimeType) {
        case TP.XML_ENCODED:
        case TP.JSON_ENCODED:
        case TP.XHTML_ENCODED:
        case TP.XSLT_ENCODED:
        case TP.PLAIN_TEXT_ENCODED:
        case TP.CSS_TEXT_ENCODED:
        case TP.HTML_TEXT_ENCODED:
        case TP.XML_TEXT_ENCODED:
        case TP.JSON_TEXT_ENCODED:
        case TP.JS_TEXT_ENCODED:
            return TP.notEmpty(this.getExtension());

        default:
            return false;
    }
});

//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('computeDiffPatchAgainst',
function(aContent, alternateContent) {

    /**
     * @method computeDiffPatchAgainst
     * @summary Computes a patch between the two data sources and returns a
     *     String that contains the patch in 'unified diff' format.
     * @param {String} aContent The 'new content' to use to generate the diff.
     * @param {String} [alternateContent] The content to use as the 'alternate
     *     content' to generate the diff, if the receiver's current *remote*
     *     content is not to be used. If this is not supplied, the receiver's
     *     current *remote* content is fetched and used.
     * @returns {Promise} A Promise whose resolved value will be the patch as
     *     computed between the two sources in 'unified diff' format.
     */

    var newContent,
        promise;

    if (!this.canDiffPatch()) {
        return this.raise('TP.sig.InvalidOperation',
                            'This URI is not patchable: ' + this.getLocation());
    }

    //  Without the Diff library, we can't compute a patch in any case
    if (TP.notValid(TP.extern.Diff)) {
        return this.raise('TP.sig.InvalidObject',
                            'The Diff library is not loaded.');
    }

    if (TP.isEmpty(aContent)) {
        return this.raise('TP.sig.InvalidParameter',
                            'Empty comparison content.');
    }

    //  Grab the String representation of the new content
    newContent = TP.str(aContent);

    //  In order to produce a proper patch, we need the remote content *in text
    //  form* and *how it currently exactly exists on the server* but *without
    //  updating the receiver's resource*. To accomplish this, we fetch using a
    //  low-level routine.
    promise = TP.extern.Promise.construct(
                function(resolver, rejector) {

                    var req,
                        currentContent;

                    if (TP.isEmpty(alternateContent)) {

                        //  Note that we ask for the *text*
                        req = TP.request('resultType', TP.TEXT);
                        req.defineHandler(
                            'IOSucceeded',
                            function(ioSignal) {

                                var content;

                                content = ioSignal.get(
                                                    'request').at(
                                                    'commObj').responseText;

                                if (TP.isEmpty(content)) {
                                    return this.raise('TP.sig.InvalidString',
                                                        'Empty content for: ' +
                                                        this.getLocation());
                                }

                                resolver(content);
                            });

                        req.defineHandler(
                            'IOFailed',
                            function(ioSignal) {

                                rejector();
                            });

                        //  Fetch the content asynchronously
                        TP.httpGet(this.getLocation(), req);

                    } else {
                        currentContent = TP.str(alternateContent);

                        if (TP.isEmpty(currentContent)) {
                            return this.raise('TP.sig.InvalidString',
                                                'Empty content for: ' +
                                                this.getLocation());
                        }

                        resolver(currentContent);
                    }
                }.bind(this));

    //  Create the patch based on the two pieces of content.
    promise = promise.then(
                function(currentContent) {

                    var virtualLoc,
                        patchLoc,
                        patch;

                    //  The post diff patch call wants a virtual location and so
                    //  we need to include the same virtual location in the
                    //  patch.
                    virtualLoc = this.getVirtualLocation();

                    //  But we only want the most-specific portion.
                    patchLoc = virtualLoc.slice(
                                    virtualLoc.lastIndexOf('/') + 1);

                    //  Generate the patch using the TP.extern.Diff library.
                    patch = TP.extern.Diff.createPatch(
                                        patchLoc, currentContent, newContent);

                    return patch;
                }.bind(this));

    return promise;
}, {
    dependencies: [TP.extern.Diff]
});

//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('getExtension',
function(aSeparator) {

    /**
     * @method getExtension
     * @summary Returns any extension that the URI's path may have. NOTE that
     *     no rewriting is performed in the production of this result.
     * @param {String} aSeparator The separator to use to find the extension.
     *     This defaults to the period (.).
     * @returns {String} The receiver's path extension, if it has one.
     */

    if (this.hasFragment()) {
        return TP.uriExtension(this.getPrimaryLocation(), aSeparator);
    }

    return TP.uriExtension(this.getLocation(), aSeparator);
});

//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('getNativeNode',
function(aRequest) {

    /**
     * @method getNativeNode
     * @summary Returns the content node of the receiver without its normal
     *     TP.dom.Node wrapper. This value may vary from the text value of the
     *     receiver if ACP-enhanced markup was provided to initialize the
     *     content.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} A TP.sig.Response created with the resource's
     *     node content set as its result.
     */

    var request,
        subrequest,
        async;

    request = this.constructRequest(aRequest);

    subrequest = this.constructSubrequest(request);

    subrequest.defineMethod(
            'completeJob',
            function(aResult) {

                var result;

                result = TP.isValid(aResult) ? TP.node(aResult) : aResult;

                subrequest.set('result', result);

                subrequest.$wrapupJob('Succeeded', TP.SUCCEEDED, result);

                if (TP.canInvoke(request, 'complete')) {
                    request.complete(result);
                }
            });

    subrequest.defineMethod(
            'failJob',
            function(aFaultString, aFaultCode, aFaultInfo) {

                var info,
                    subrequests;

                info = TP.hc(aFaultInfo);
                if (TP.isValid(subrequests = info.at('subrequests'))) {
                    subrequests.push(subrequest);
                } else {
                    subrequests = TP.ac(subrequest);
                    info.atPut('subrequests', subrequests);
                }

                subrequest.$wrapupJob('Failed', TP.FAILED);

                if (TP.canInvoke(request, 'fail')) {
                    request.fail(aFaultString, aFaultCode, info);
                }
            });

    subrequest.atPut('resultType', TP.DOM);
    this.getResource(subrequest);

    //  If async we can only return the result/response being used to
    //  actually process the async activity.
    //  NOTE that we need to re-read the async state in case our underlying
    //  resource is async-only and potentially rewrote the value.
    async = this.rewriteRequestMode(subrequest);
    if (async) {
        request.andJoinChild(subrequest);

        //  hand back the response object for the "outer" request, which
        //  will be either the originating request or our internally
        //  constructed one (which was also used as the subrequest)
        if (TP.canInvoke(request, 'getResponse')) {
            return request.getResponse();
        } else {
            return subrequest.getResponse();
        }
    }

    //  If the routine was invoked synchronously then the data will have
    //  been placed in the subrequest.
    return subrequest.getResponse();
});

//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('getPath',
function() {

    /**
     * @method getPath
     * @summary Returns the path portion of the receiver.
     * @description The value returned from this method will vary between
     *     subtypes. For 'file' urls it will be the file path which starts after
     *     the file:// portion while for 'http' urls it is the portion between
     *     the host:port and ?query specs. Note that on windows this will not
     *     start with a leading "/" when using file urls (so file:///c:/foo
     *     returns a path of c:/foo, not /c:/foo).
     * @returns {String} A scheme-specific path string.
     */

    var path,
        url;

    //  for HTTP URLs, this very well may be the empty String, in which case
    //  its still valid and just returns
    if (TP.notValid(path = this.$get('path'))) {
        //  try to figure out the path from the uri
        if (TP.notValid(url = this.getLocation())) {
            return '';
        }

        path = this.$getPath(url);

        this.$set('path', path, false);
    }

    return path;
});

//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('$getPath',
function(url) {

    /**
     * @method $getPath
     * @summary Parses the url for the path portion as that concept is defined
     *     for the receiving type. Note that different URI types consider
     *     different parts of their HREF to be the 'path'.
     * @param {String} url The URI string to parse.
     * @returns {String} The path subset of the string provided.
     */

    var path;

    //  by default the 'path' is whatever comes after the scheme
    path = url.slice(url.indexOf(':') + 1);

    //  then we chop off any leading '//', if its there
    if (path.startsWith('//')) {
        path = path.slice(2);
    }

    //  now remove any parameter or fragment portions...
    if (/\?/.test(path)) {
        path = path.slice(0, path.indexOf('?'));
    }

    if (/#/.test(path)) {
        path = path.slice(0, path.indexOf('#'));
    }

    return path;
});

//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('getPathParts',
function() {

    /**
     * @method getPathParts
     * @summary Returns the path portions as an Array
     * @returns {String[]} An Array of Strings comprising the parts of the path.
     */

    var path;

    if (TP.isEmpty(path = this.getPath())) {
        return TP.ac();
    }

    //  There isn't always a leading slash... see getPath()
    if (path.charAt(0) === '/') {
        path = path.slice(1);
    }

    return path.split('/');
});

//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('getRelativePath',
function(secondPath, filePath) {

    /**
     * @method getRelativePath
     * @summary Returns the receiver's path converted to a relative path when
     *     compared to second path. If the secondPath contains a file reference
     *     then the filePath argument should be true so that the resulting
     *     relative path is always produced with respect to a directory target.
     * @description Note that there is one special case to this process which
     *     revolves around how to resolve against paths which end with a file
     *     reference. When dealing with ~lib/foo.xml relative to ~lib we can
     *     see it should be ./foo.xml, but what about when we have
     *     ~lib/foo.xml relative to ~lib/bar.xml? Is that ./foo.xml or
     *     ../foo.xml. The answer depends on whether bar.xml is a file or
     *     directory reference, hence the flag.
     * @param {String} secondPath The path to be relative to.
     * @param {Boolean} filePath True if the absolute (second) path includes a
     *     file reference. This is important since the offset is relative to
     *     directories, not files.
     * @returns {String}
     */

    return TP.uriRelativeToPath(this.getLocation(), secondPath, filePath);
});

//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('$getPrimaryResource',
function(aRequest, filterResult) {

    /**
     * @method $getPrimaryResource
     * @summary Returns the resource referenced by the receiver's primary href,
     *     the portion prior to any #-delimited fragment for those schemes for
     *     which a fragment is valid.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @param {Boolean} filterResult True if the resource result will be used
     *     directly and should be filtered to match any resultType definition
     *     found in the request. The default is false.
     * @returns {TP.sig.Response} A TP.sig.Response created with the resource's
     *     primary content set as its result.
     */

    var url,
        request,
        subrequest,
        loaded,
        refresh,
        async,
        thisref,
        response,
        resource;

    //  TODO:   do we need a fragment check here for any reason?
    if ((url = this.getPrimaryURI()) !== this) {
        return url.$getPrimaryResource(aRequest, filterResult);
    }

    request = this.constructRequest(aRequest);

    //  If we're going to have to request the data then the key thing we
    //  want to avoid is having an incoming request complete() before the
    //  entire process is finished. That means ensuring we have a clean
    //  subrequest instance we can locally modify.
    subrequest = this.constructSubrequest(request);

    loaded = this.isLoaded();

    refresh = subrequest.at('refresh');
    if (TP.notValid(refresh)) {
        //  may need to force refresh to true if the content hasn't been loaded
        //  and there wasn't a specific value for refresh.
        refresh = !loaded;

        //  Make sure to put this value into the subrequest before we call
        //  rewriteRequestMode below. That call looks at this value to compute
        //  whether this request should fetch asynchronously or not.
        subrequest.atPut('refresh', refresh);
    }

    //  verify sync/async and warn when inbound value doesn't match up.
    async = this.rewriteRequestMode(subrequest);

    //  put in our "request" for sync/async, but be aware the handler
    //  gets the final say during load processing.
    subrequest.atPut('async', async);

    //  capture a this reference for our complete routine below.
    thisref = this;

    subrequest.defineMethod(
            'completeJob',
            function(aResult) {

                var result;

                //  Default our result, and filter if requested. We do this
                //  here as well to ensure we don't complete() an incoming
                //  request with unfiltered result data.
                result = aResult;

                if (TP.isTrue(filterResult) && TP.isValid(aResult)) {
                    result = thisref.$getFilteredResult(aResult, request,
                        false);
                }

                //  If we fetched the initial resource and are just going to be
                //  filtering result format then don't call setter here. we
                //  don't want to adjust content just because of alternative
                //  request response types.
                if (!thisref.resourcesAreAlike(
                                aResult, thisref.$get('resource'))) {
                    thisref.$setPrimaryResource(result, request);
                } else if (TP.isTrue(subrequest.at('refresh'))) {
                    thisref.isDirty(false, true);
                }

                //  rewrite the request result object so we hold on to the
                //  processed content rather than the inbound content.
                subrequest.set('result', result);

                subrequest.$wrapupJob('Succeeded', TP.SUCCEEDED, result);

                if (TP.canInvoke(request, 'complete')) {
                    request.complete(result);
                }
            });

    subrequest.defineMethod(
            'failJob',
            function(aFaultString, aFaultCode, aFaultInfo) {

                var info,
                    subrequests;

                info = TP.hc(aFaultInfo);
                if (TP.isValid(subrequests = info.at('subrequests'))) {
                    subrequests.push(subrequest);
                } else {
                    subrequests = TP.ac(subrequest);
                    info.atPut('subrequests', subrequests);
                }

                subrequest.$wrapupJob('Failed', TP.FAILED);

                if (TP.canInvoke(request, 'fail')) {
                    request.fail(aFaultString, aFaultCode, info);
                }
            });

    //  refresh will have been forced to true when we're not loaded, so
    //  we'll load() any time explicitly asked to, or when unloaded.
    if (refresh) {
        //  ensure refresh is true in the request and not just defaulted
        subrequest.atPut('refresh', true);

        //  Don't forget that this could be asynchronous....
        response = this.load(subrequest);

        //  re-read the request in case load() processing rewrote the
        //  request mode on us.
        async = this.rewriteRequestMode(subrequest);
    } else {

        if (!async) {
            resource = this.$get('resource');

            //  Fake completion of the subrequest and related request.
            subrequest.complete(resource);
        } else {
            setTimeout(function() {
                resource = this.$get('resource');

                //  Fake completion of the subrequest and related request.
                subrequest.complete(resource);
            }.bind(this), TP.sys.cfg('queue.delay'));
        }

        return subrequest.getResponse();
    }

    if (async) {
        request.andJoinChild(subrequest);

        //  if we have a response we must have done a refresh, otherwise
        //  we're working with whatever data we had cached. In that case we
        //  need to construct a response wrapping that value so we can fake
        //  the async operation in terms of return value.
        if (TP.notValid(response)) {
            //  didn't do a refresh so we got the data synchronously from
            //  our cache. now we just need to "fake" a response, which we
            //  want to associate with the original request object if there
            //  was one.
            if (TP.canInvoke(request, 'getResponse')) {
                response = request.getResponse();
            } else {
                response = subrequest.getResponse();
            }
        }

        return response;
    }

    //  If the routine was invoked synchronously then the data will have
    //  been placed in the subrequest.
    return subrequest.getResponse();
});

//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('getRequestedResource',
function(aRequest) {

    /**
     * @method getRequestedResource
     * @summary Returns the resource object appropriate for the request. This
     *     typically becomes the request's result object and can be used to
     *     set the URI resource directly.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {Object} The requested form of the cached resource. The cached
     *     resource is typically a Content object of some form however the
     *     return value will conform to the 'resultType' provided in the request
     *     (if any).
     */

    var contentType,

        resource,
        newResult,
        currentResult,

        dat,
        dom,
        tname,
        map,

        handler,
        type,

        mime,

        resourceIsContent,
        resultIsContent;

    if (TP.notValid(aRequest)) {
        return this.raise('TP.sig.InvalidParameter',
                            'No request object.');
    }

    //  Certain operations like save() will return empty or non-relevant
    //  results on completion. We don't refresh content from those results,
    //  which will be flagged with a false value for refreshContent.
    if (TP.isFalse(aRequest.at('refreshContent'))) {
        return this.$getFilteredResult(this.$get('resource'), aRequest);
    }

    //  the default mime type can often be determined by the Content-Type
    //  header but we have to split off any charset encoding portion
    contentType = this.getHeader('Content-Type');
    if (TP.isString(contentType)) {
        contentType = contentType.split(';').first().trim();
    }

    //  Note that we set the 'default' MIME type here, which denotes
    //  the MIME type that was handed to us via the web server. We'll
    //  try to compute a more specific MIME type when getMIMEType() is
    //  called for the first time.
    this.set('defaultMIMEType', contentType, false);

    //  capture our current resource so we can replace wrapped content
    //  without replacing the container when possible.
    resource = this.$get('resource');

    newResult = aRequest.getResult();

    //  In cases of refresh we'll often be called with the data we already have
    //  as the result.

    currentResult = this.$getFilteredResult(resource, aRequest);

    //  Core question of whether we're dirty or not, will value change.
    if (this.resourcesAreAlike(currentResult, newResult)) {
        return currentResult;
    }

    //  ---
    //  discriminate the "raw data" of the result
    //  ---

    //  capture the raw result data from the request. This is typically
    //  a string, node, or pair based on the original request parameters.
    if (TP.isArray(newResult) && newResult.getSize() === 2) {
        dat = newResult.first();
        dom = newResult.last();

        //  TODO: what if it's an array that doesn't contain a string and a
        //  node?
    } else if (TP.isNode(newResult)) {
        dom = newResult;
    } else if (TP.isXHR(newResult)) {
        dat = newResult.responseText;

        try {
            dom = newResult.responseXML;

            //  IE has the nasty habit of making an empty '#document' node
            //  here that passes TP.isNode(...) tests, but has no content
            //  because it couldn't be parsed into real XML. Therefore, we do
            //  this low-level testing.
            if (dom && dom.childNodes && dom.childNodes.length === 0) {
                dom = null;
            }
        } catch (e) {
            dom = TP.node(newResult.responseText);
        }
    } else {
        dat = newResult;
    }

    //  ---
    //  Wrap content in best-fit container.
    //  ---

    //  result content handler invocation...if possible (but not if the
    //  requestor wants raw TP.TEXT).
    handler = aRequest.at('contentType');
    if (TP.notValid(handler)) {
        handler = aRequest.at('contenttype');
        if (TP.isValid(handler)) {
            TP.ifWarn() ?
                TP.warn('Deprecated "contenttype" request parameter: ' +
                    aRequest) : 0;
        }
    }

    if (TP.notValid(handler) && aRequest.at('resultType') !== TP.TEXT) {
        //  check on uri mapping to see if the URI maps define a wrapper.
        map = TP.uri.URI.$getURIMap(this);
        if (TP.isValid(map)) {
            handler = map.at('contenttype');
        }

        if (TP.notValid(handler)) {
            //  other possibility is a wrapper based on Content-type header
            //  or MIME value from the response itself.

            //  Set the computed MIME type to null to force recomputation based
            //  on the possibly new MIME type of 'dat'.
            this.$set('computedMIMEType', null);

            mime = this.getMIMEType(dom || dat);
            handler = TP.ietf.mime.getConcreteType(mime);
        } else {
            //  Make sure that handler is a type.
            handler = TP.sys.getTypeByName(handler);
        }

        //  Should almost always provide a viable option for content.
        if (TP.notValid(handler) && !TP.isKindOf(resource, TP.core.Content)) {
            handler = TP.core.Content.getConcreteType(TP.ifInvalid(dom, dat));
        }
    }

    if (TP.isType(handler)) {
        type = TP.sys.getTypeByName(handler);
        if (TP.canInvoke(type, 'constructContentObject')) {
            //  NOTE that this returns us a "content object" whose purpose
            //  is to be able to "reconstitute" the data as needed
            newResult = type.constructContentObject(dom || dat, this);
            if (TP.notValid(newResult)) {
                return this.raise('',
                    'Content handler failed to produce output.');
            }
        } else {
            return this.raise('TP.sig.InvalidParameter',
                            'Content handler API not supported.');
        }
    } else if (TP.isNode(dom)) {
        //  wait for wrapping during post-processing below.
        newResult = dom;
    } else if (TP.isString(dat)) {
        //  when looking for a content object (a text-specific object)
        //  we work from MIME type as a starting point. Proper XML won't
        //  normally be run through this routine since getResource looks
        //  for a node wrapper first. we're normally dealing with
        //  non-XML content here -- like CSS, JSON, etc.

        //  Set the computed MIME type to null to force recomputation based on
        //  the possibly new MIME type of 'dat'.
        this.$set('computedMIMEType', null);

        mime = this.getMIMEType(dat);
        type = TP.ietf.mime.getConcreteType(mime);

        if (TP.canInvoke(type, 'constructContentObject')) {
            //  NOTE that this returns us a "content object" whose purpose
            //  is to be able to "reconsitute" the data as needed
            newResult = type.constructContentObject(dat, this);
        } else {
            //  No concrete handler type for the MIME type? Use the string.
            newResult = dat;
        }
    } else if (TP.isHash(dat)) {
        tname = dat.at('type');
        if (TP.isString(tname) &&
            TP.isType(type = TP.sys.getTypeByName(tname)) &&
            TP.canInvoke(type, 'constructContentObject')) {
            newResult = type.constructContentObject(dat, this);
        }
    } else {
        //  some other form of non-standard result object.
        newResult = TP.ifInvalid(dom, dat);
    }

    //  ---
    //  post-process to maintain internal containers.
    //  ---

    //  Now, set the resource or result based on data types of what we already
    //  have and what we are going to be setting.

    //  NOTE: THIS IS ORDER DEPENDENT - DO *NOT* CHANGE the testing order here
    //  without testing extensively.

    resourceIsContent = TP.isKindOf(resource, TP.core.Content);
    resultIsContent = TP.isKindOf(newResult, TP.core.Content);

    if (TP.canInvoke(newResult, 'getNativeNode') && !resourceIsContent) {
        //  result _is_ a wrapper object of some form.
        resource = this.$normalizeRequestedResource(newResult);
    } else if (resourceIsContent && !resultIsContent) {

        //  Make sure that the Content object that is the resource can handle
        //  the result content. We may be holding a Content object that is
        //  incompatible with the new content. We can check this by asking the
        //  content's type if we could construct a new one given the data.
        if (resource.getType().canConstruct(newResult, this)) {
            resource.set('data', newResult, false);
        } else {
            resource = this.$normalizeRequestedResource(newResult);
        }
    } else if (TP.canInvoke(resource, 'setNativeNode') &&
                TP.isNode(newResult)) {
        TP.ifTrace() && TP.$DEBUG && TP.$VERBOSE ?
            TP.sys.logIO('Refreshing current node container.',
                        TP.DEBUG) : 0;

        resource.setNativeNode(newResult, false);
    } else if (TP.isNode(newResult)) {
        TP.ifTrace() && TP.$DEBUG && TP.$VERBOSE ?
            TP.sys.logIO('Creating new node container.',
                        TP.DEBUG) : 0;

        //  note that we pass ourselves along to establish "ownership"
        newResult = TP.dom.Node.construct(newResult);
        newResult.set('uri', this);

        resource = this.$normalizeRequestedResource(newResult);
    } else {
        resource = this.$normalizeRequestedResource(newResult);
    }

    //  NOTE that callers are responsible for defining the context of
    //  whether the resulting data dirties/loads the URI in question.

    //  clear any expiration computations.
    this.expire(false);

    return this.$getFilteredResult(resource, aRequest);
});

//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('$normalizeRequestedResource',
function(aResource) {

    /**
     * @method $normalizeRequestedResource
     * @summary 'Normalizes' the resource object. This means that certain
     *     common constructs that this particular type of TP.uri.URI needs will
     *     be computed and instrumented onto the resource via this method.
     * @param {Object} aResource The resource object to normalize.
     * @returns {Object} The normalized resource.
     */

    var obj;

    obj = TP.wrap(aResource);

    if (TP.canInvokeInterface(
            obj, TP.ac('addTIBETSrc', 'addXMLBase', '$set'))) {
        //  place our URI value into the node wrapper and node content
        obj.$set('uri', this, false);

        //  make sure the node knows where it loaded from.
        obj.addTIBETSrc(this);

        //  then, an 'xml:base' attribute. this helps ensure that xml:base
        //  computations will work more consistently during tag processing
        obj.addXMLBase();
    }

    return obj;
});

//  ------------------------------------------------------------------------
//  Content Processing
//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('hasReachedPhase',
function(targetPhase, targetPhaseList) {

    /**
     * @method hasReachedPhase
     * @summary Returns true if the receiver's content has been processed to
     *     the phase defined, relative to an optional phase list.
     * @param {String} targetPhase A TIBET content "process phase" string such
     *     as 'Includes'.
     * @param {String[]} targetPhaseList An array of phase names. The default is
     *     TP.shell.TSH.NOCACHE.
     * @returns {Boolean} Whether or not the content of the receiver has reached
     *     the supplied phase in its processing.
     */

    var content,
        resp;

    //  if we're not loaded we can't have reached a particular phase.
    if (!this.isLoaded()) {
        return false;
    }

    //  force refresh to false, we only want cached data access here. NOTE
    //  that this avoids any async issues as well.
    resp = this.getResource(TP.hc('refresh', false, 'async', false));
    content = resp.get('result');

    if (TP.canInvoke(content, 'hasReachedPhase')) {
        return content.hasReachedPhase(targetPhase, targetPhaseList);
    }

    //  no content? can't have reached any phase then.
    return false;
});

//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('processTP_sig_Request',
function(aRequest) {

    /**
     * @method processTP_sig_Request
     * @summary Processes the receiver's content, typically by dispatching to
     *     the receiver's content object itself.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request or parameter
     *     hash with control parameters. The 'targetPhase' parameter is the most
     *     important here. Default is 'Finalized'.
     * @returns {TP.sig.Response} A TP.sig.Response created with the resource's
     *     processed content set as its result.
     */

    var request,
        subrequest1,
        subrequest2,
        thisref,
        async;

    request = this.constructRequest(aRequest);

    //  This request will be used for transformation processing.
    subrequest1 = this.constructSubrequest(request);
    subrequest1.atPutIfAbsent('targetPhase', 'Finalize');

    //  The subrequest here is used for content acquisition.
    subrequest2 = this.constructSubrequest(request);

    thisref = this;

    subrequest2.defineMethod(
            'completeJob',
            function(aResult) {

                var resource,
                    resp,
                    result,

                    returnProcessedResult,
                    returnResult;

                resource = TP.tpnode(aResult);

                if (TP.canInvoke(resource, 'transform')) {

                    /*
                    //  Update the resource, passing subrequest2 so we keep the
                    //  original request params (like operation) flowing through.
                    //  TODO: setting the resource here has a bad habit of
                    //  triggering a cyclic change series from processed to
                    //  unprocessed data. Not convinced we should set it at all
                    //  here since we're essentially responding _after_ a
                    //  getResource call to process the result data.
                    thisref.$setPrimaryResource(resource, subrequest2);
                    */

                    //  Start out by configuring to use the processed result.
                    returnProcessedResult = true;

                    //  If, however, a Node can be obtained from the resource,
                    //  then clone that, wrap it and use that as the return
                    //  result. Flip the flag off so we don't pick up the
                    //  processed result as the return result

                    //  TODO: verify this is correct in all cases, and
                    //  decide if we need to assign a "save result" flag to
                    //  control this.
                    if (TP.canInvoke(resource, 'getNativeNode')) {
                        returnResult = TP.wrap(
                            TP.nodeCloneNode(resource.getNativeNode()));
                        returnProcessedResult = false;
                    }

                    resp = TP.process(resource, subrequest1);
                    result = resp.get('result');

                    //  If the flag is true, then use the processed result as
                    //  the return result.
                    if (returnProcessedResult) {
                        returnResult = result;
                    }

                    if (subrequest1.didFail()) {
                        request.fail(subrequest1.getFaultText(),
                                      subrequest1.getFaultCode(),
                                      subrequest1.getFaultInfo());
                        subrequest2.fail(subrequest1.getFaultText(),
                                          subrequest1.getFaultCode(),
                                          subrequest1.getFaultInfo());
                        return;
                    }

                    //  rewrite the request result object so we hold on to
                    //  the processed content rather than the inbound
                    //  content.
                    subrequest2.set('result', result);

                    //  the return result should become the new resource
                    thisref.set('resource',
                                returnResult,
                                TP.request('signalChange', false,
                                            'processedResult', true));
                }

                subrequest2.$wrapupJob('Succeeded', TP.SUCCEEDED, result);

                //  Inform any originally inbound request of our status.
                if (TP.canInvoke(request, 'complete')) {
                    //  Note that this could be null if there's no result,
                    //  or if the transform call isn't supported, or if the
                    //  transform simply produces a null result.
                    request.complete(result);
                }
            });

    subrequest2.defineMethod('failJob',
        function(aFaultString, aFaultCode, aFaultInfo) {

            var info,
                subrequests;

            info = TP.hc(aFaultInfo);
            if (TP.isValid(subrequests = info.at('subrequests'))) {
                subrequests.push(subrequest2);
            } else {
                subrequests = TP.ac(subrequest2);
                info.atPut('subrequests', subrequests);
            }

            subrequest2.$wrapupJob('Failed', TP.FAILED);

            //  Inform any originally inbound request of our status.
            if (TP.canInvoke(request, 'fail')) {
                request.fail(aFaultString, aFaultCode, info);
            }
        });

    //  trigger the invocation and rely on the handlers for the rest.
    this.getResource(subrequest2);

    //  re-read the request in case load() processing rewrote the request mode
    //  on us.
    async = this.rewriteRequestMode(subrequest2);
    if (async) {
        request.andJoinChild(subrequest2);

        //  if we're async then the data may not be ready, we need to return a
        //  viable response object instead.
        if (TP.canInvoke(request, 'getResponse')) {
            return request.getResponse();
        } else {
            return subrequest2.getResponse();
        }
    }

    return subrequest2.getResponse();
});

//  ------------------------------------------------------------------------
//  Storage Management
//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('load',
function(aRequest) {

    /**
     * @method load
     * @summary Loads the content of the receiver from whatever is the
     *     currently mapped storage location. This method relies on both
     *     rewriting and routing which ultimately hand off to a
     *     TP.uri.URIHandler of some type to perform the actual load.
     * @description This method is rarely called directly, it's typically
     *     invoked by the get*Content() calls when the receiver has not yet been
     *     loaded, or when a refresh is being requested. Note that this is a
     *     "mapped" action, meaning the URI undergoes rewriting and mapping as
     *     part of the load process.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    var request,
        url,
        handler;

    TP.ifTrace() && TP.$DEBUG && TP.$VERBOSE ?
        TP.sys.logIO('Loading content data for ID: ' +
                    TP.ifInvalid(this.getLocation(), 'FROM_SOURCE'),
                    TP.DEBUG) : 0;

    request = this.constructRequest(aRequest);

    //  rewriting always comes first. if we end up altering the actual URI
    //  during this process then we're not the "keeper of the data", the
    //  rewritten URI instance is
    url = this.rewrite(request);

    //  map the load operation so we get the right handler based on any
    //  rewriting and routing logic in place for the original URI
    request.atPut('operation', 'load');
    handler = url.remap(this, request);

    return handler.load(url, request);
});

//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('delete',
function(aRequest) {

    /**
     * @method delete
     * @summary Destroys the target URL at the storage location.
     * @description This method is a "mapped" action, meaning the URI undergoes
     *     rewriting and routing as part of the delete process. This may, as you
     *     might expect, alter the physical location being targeted for
     *     destruction. You should probably verify these targets before invoking
     *     delete.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    var request,
        url,
        handler;

    //  TODO:   when the receiver has a fragment what then? Are we supposed
    //  to remove only the fragment subset of the receiver?

    request = this.constructRequest(aRequest);

    url = this.rewrite(request);

    request.atPut('operation', 'delete');
    handler = url.remap(this, request);

    return handler.delete(url, request);
});

//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('getWatched',
function() {

    /**
     * @method getWatched
     * @summary Returns whether or not the URI should watch changes to its
     *     remote content.
     * @returns {Boolean} Whether or not the resource watches remote changes.
     */

    return TP.notFalse(this.$get('watched'));
});

//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('save',
function(aRequest) {

    /**
     * @method save
     * @summary Saves the receiver's content to its URI path. The request's
     *     fileMode key defaults to 'w' so that any existing content is replaced
     *     when operating on file URIs.
     * @description This method is a "mapped" action, meaning the URI undergoes
     *     rewriting and routing as part of the save process. This may, as you
     *     might expect, alter the physical location in which the data is
     *     stored.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    var request,
        url,
        handler;

    //  TODO:   when the receiver has a fragment what then? Should just
    //          update "document href" and save that?

    request = this.constructRequest(aRequest);

    //  rewriting means we'll get to the concrete URI for the receiver so we
    //  put the data where it really belongs
    url = this.rewrite(request);

    request.atPut('operation', 'save');
    handler = url.remap(this, request);

    return handler.save(url, request);
});

//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('setShouldPatch',
function(shouldBePatched) {

    /**
     * @method setShouldPatch
     * @summary Sets whether the URI is patched or not when storing to the
     *     server. For TIBETURLs, this passes through to the concrete URI's
     *     'patched' property.
     * @param {Boolean} shouldBePatched Whether the URI should be patched or
     *     not.
     * @returns {TP.uri.URL} The receiver.
     */

    return this.getConcreteURI().set('$shouldPatch', shouldBePatched);
});

//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('setWatched',
function(shouldBeWatched) {

    /**
     * @method setWatched
     * @summary Sets whether or not the URI should watch changes to its
     *     remote content.
     * @param {Boolean} shouldBeWatched Whether the URI should be watched or
     *     not.
     * @returns {TP.uri.URL} The receiver.
     */

    return this.$set('watched', shouldBeWatched);
});

//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('refreshFromRemoteResource',
async function() {

    /**
     * @method refreshFromRemoteResource
     * @summary Refreshes the receiver's content from the remote resource it
     *     represents. Upon refreshing the content this method will invoke
     *     processRefreshedContent to perform any post-processing of the
     *     content appropriate for the target URI.
     * @returns {Promise} A promise which resolves on completion.
     */

    var callback,
        secondaryURIs,
        changedLoc,
        normalizedLoc,

        isLoadableScript;

    if (this.getWatched()) {
        this.isLoaded(false);
    }

    //  Make sure to let secondaryURIs know too.
    if (TP.notEmpty(secondaryURIs = this.getSecondaryURIs())) {
        secondaryURIs.forEach(
                function(aURI) {
                    if (aURI.getWatched()) {
                        aURI.isLoaded(false);
                    }
                });
    }

    changedLoc = this.getLocation();
    normalizedLoc = TP.uriInTIBETFormat(changedLoc);

    //  Force a reload. Note that we approach this two ways depending on the
    //  nature of the URI. Source code needs to be loaded via the boot system so
    //  it properly loads and runs, whereas other resources can load via XHR.
    callback = async function(result) {

        var url,
            resourceHash,
            pkgcfg;

        if (TP.isError(result)) {
            TP.error(result);
            return;
        }

        url = TP.uc(changedLoc);

        //  Make sure to set isLoaded() to true here, since we set it to false
        //  above. This will ensure that the URL doesn't think it's still dirty
        //  after we've reloaded it per the semantics of this method.
        if (url.getWatched()) {
            url.isLoaded(true);
        }

        //  Set the URL to not be dirty.
        url.isDirty(false);

        //  Is the changed location one of our loaded package files? If so we
        //  need to process it as a package, not a random file or script.
        if (TP.boot.$getLoadedPackages().contains(normalizedLoc)) {

            //  Import any new scripts that would have booted with the system.
            //  NOTE we pass 'true' to the shouldSignal flag here to tell this
            //  particular import we want scripts to signal Change on load.
            pkgcfg = TP.isEmpty(TP.boot.$$bootconfig) ?
                TP.boot.$$bootfile :
                TP.boot.$$bootfile + '@' + TP.boot.$$bootconfig;
            await TP.sys.importPackage(pkgcfg, false, true);
        }

        //  Trigger post-processing for specific URIs.
        url.processRefreshedContent();

        //  Grab the resource hash of changed remotes and remote the url that we
        //  just processed from the list.
        resourceHash = TP.uri.URI.get('remoteChangeList');
        resourceHash.removeKey(url.getLocation());

        url.signal('RemoteResourceChanged', TP.hc('isDirty', false));
    };

    //  Is the changed location one of our loaded package files? If so we
    //  need to process it as a package, not a random file or script.
    if (TP.boot.$getLoadedPackages().contains(normalizedLoc)) {

        //  Force refresh of any package data, particularly related to the
        //  URI we're referencing.
        await TP.boot.$refreshPackages(changedLoc);

        callback();

    } else {
        isLoadableScript = await TP.boot.$isLoadableScript(changedLoc);

       if (isLoadableScript) {
            //  If the receiver refers to a file that was loaded (meaning it's
            //  mentioned in a TIBET package config) we source it back in rather
            //  than just loading via simple XHR.
            TP.debug('Sourcing in updates to ' + changedLoc);

            return TP.sys.importSourceText(changedLoc).then(callback, callback);
        } else {
            TP.debug('Reading in changes to ' + changedLoc);

            return this.getResource(TP.hc('signalChange', false)).then(
                                                        callback, callback);
        }
    }
});

//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('processRefreshedContent',
function() {

    /**
     * @method processRefreshedContent
     * @summary Invoked when remote resource changes have been loaded to provide
     *     the receiver with the chance to post-process those changes. If you
     *     override this method you should signal Change (this.$changed) once
     *     you have completed processing to notify potential observers.
     * @returns {TP.uri.URL} The receiver.
     */

    this.$changed();

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('watch',
function() {

    /**
     * @method watch
     * @summary Flags the URL as being active for remote change processing. When
     *     uri.source.watch_changes is true and uri.source.process_changes is
     *     true this flag will be checked to ensure the specific URI is not
     *     excluded from processing. It's not usually necessary to set this to
     *     true if the URL would pass remote URL isWatchableURI testing.
     * @returns {TP.uri.URL} The receiver.
     */

    var url,
        request,
        handler;

    //  Early exit if we're already set so we avoid request/rewrite/remap work.
    if (TP.isTrue(this.getWatched())) {
        return this;
    }

    //  We need to get a request and go through rewrite/mapping to get the
    //  proper handler type for the receiver. That type can then tell us if the
    //  receiver is a watchable instance.
    request = this.constructRequest();
    request.atPut('operation', 'watch');

    url = this.rewrite(request);
    handler = url.remap(this, request);

    //  NOTE we don't assume true, we still check that the receiver is a
    //  watchable URI based on any remote URL filtering for the handler.
    this.setWatched(handler.isWatchableURI(this));

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URL.Inst.defineMethod('unwatch',
function() {

    /**
     * @method unwatch
     * @summary Flags the URL as not processing remote change notices. When
     *     uri.source.watch_changes is true and uri.source.process_changes is
     *     true this flag will be checked to ensure the specific URI is not
     *     excluded from processing.
     * @returns {TP.uri.URL} The receiver.
     */

    var request,
        url;

    //  Early exit if we're already set so we avoid request/rewrite/remap work.
    if (TP.isFalse(this.getWatched())) {
        return this;
    }

    request = this.constructRequest();

    url = this.rewrite(request);
    if (url !== this) {
        url.unwatch();
    }

    this.setWatched(false);

    return this;
});

//  ========================================================================
//  TP.uri.BlobURL
//  ========================================================================

/**
 * @type {TP.uri.BlobURL}
 * @summary A subtype of TP.uri.URL specific to the Blob scheme.
 */

//  ------------------------------------------------------------------------

TP.uri.URL.defineSubtype('BlobURL');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.uri.BlobURL.Type.defineConstant('SCHEME', 'blob');

TP.uri.BlobURL.registerForScheme('blob');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  the most recent 'communication' object (i.e. the native XHR or WebSocket
//  object). Not used for this type, but here to avoid warnings around instance
//  attributes.
TP.uri.BlobURL.Inst.defineAttribute('commObject');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.uri.BlobURL.Inst.defineMethod('$parseSchemeSpecificPart',
function(schemeSpecificString) {

    /**
     * @method $parseSchemeSpecificPart
     * @summary Parses inbound URI string content in a fashion specific to the
     *     scheme(s) being managed by the receiver.
     * @param {String} schemeSpecificString A String containing the
     *     "scheme-specific-part" of a URI.
     * @returns {TP.core.Hash} The parsed URI 'components'.
     */

    var dict;

    this.callNextMethod();

    //  TODO TODO TODO TODO TODO
    //  TODO: relying on TP.core.Hash for parsing is a poor design, we
    //  should change that so the parsing is local to this type. Here, we
    //  invoke the parser directly because of the ambiguities with the style
    //  string parser.
    /* eslint-disable new-cap */
    dict = TP.core.Hash.URI_STRING_PARSER('blob:' +
                                            schemeSpecificString);
    /* eslint-enable new-cap */

    this.set('path', dict.at('path'));

    return dict;
});

//  ========================================================================
//  TP.uri.ChromeExtURL
//  ========================================================================

/**
 * @type {TP.uri.ChromeExtURL}
 * @summary A subtype of TP.uri.URL specific to the Chrome Extension scheme.
 */

//  ------------------------------------------------------------------------

TP.uri.URL.defineSubtype('ChromeExtURL');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.uri.ChromeExtURL.Type.defineConstant('SCHEME', 'chrome-extension');

TP.uri.ChromeExtURL.registerForScheme('chrome-extension');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.uri.ChromeExtURL.Type.defineMethod('$getDefaultHandler',
function(aURI, aRequest) {

    /**
     * @method $getDefaultHandler
     * @summary Returns the default handler for a URI and request pair. For
     *     Chrome-Extension urls this is the TP.uri.FileURLHandler type.
     * @param {TP.uri.URI|String} aURI The URI to obtain the default handler
     *     for.
     * @param {TP.sig.Request} aRequest The request whose values should inform
     *     the routing assignment.
     * @returns {TP.meta.uri.URIHandler} A TP.uri.URIHandler subtype type object
     *     or a type object conforming to that interface.
     */

    return TP.uri.FileURLHandler;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  the most recent 'communication' object (i.e. the native XHR or WebSocket
//  object). Not used for this type, but here to avoid warnings around instance
//  attributes.
TP.uri.ChromeExtURL.Inst.defineAttribute('commObject');

//  the 'component id' that Chrome assigns to the extension.
TP.uri.ChromeExtURL.Inst.defineAttribute('componentID');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.uri.ChromeExtURL.Inst.defineMethod('$parseSchemeSpecificPart',
function(schemeSpecificString) {

    /**
     * @method $parseSchemeSpecificPart
     * @summary Parses inbound URI string content in a fashion specific to the
     *     scheme(s) being managed by the receiver.
     * @param {String} schemeSpecificString A String containing the
     *     "scheme-specific-part" of a URI.
     * @returns {TP.core.Hash} The parsed URI 'components'.
     */

    var dict;

    this.callNextMethod();

    //  TODO TODO TODO TODO TODO
    //  TODO: relying on TP.core.Hash for parsing is a poor design, we
    //  should change that so the parsing is local to this type. Here, we
    //  invoke the parser directly because of the ambiguities with the style
    //  string parser.
    /* eslint-disable new-cap */
    dict = TP.core.Hash.URI_STRING_PARSER('chrome-extension:' +
                                            schemeSpecificString);
    /* eslint-enable new-cap */

    this.set('path', dict.at('path'));
    this.set('componentID', dict.at('hostname'));

    return dict;
});

//  ========================================================================
//  TP.uri.CommURL
//  ========================================================================

/**
 * @type {TP.uri.CommURL}
 * @summary A trait class designed to add "comm" (mostly XHR) access methods.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('TP.uri.CommURL');

TP.uri.CommURL.isAbstract(true);       //  Always set for a trait.

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  the most recent 'communication' object
//  (i.e. the native XHR or WebSocket object)
TP.uri.CommURL.Inst.defineAttribute('commObject');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.uri.CommURL.Inst.defineMethod('commDidSucceed',
function() {

    /**
     * @method commDidSucceed
     * @summary Returns true if the last comm request (xhr etc) to the server
     *     was successful based on status information in the comm object.
     * @returns {Boolean|undefined} True for successful communications.
     */

    var comm;

    comm = this.getCommObject();
    if (TP.isValid(comm)) {
        return TP.httpDidSucceed(comm);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.uri.CommURL.Inst.defineMethod('getCommObject',
function() {

    /**
     * @method getCommObject
     * @summary Returns the last communication channel object leveraged by the
     *     receiver.
     * @returns {XHR|WebSocket|undefined} The receiver's last communication
     *     object.
     */

    var comm,
        url;

    comm = this.$get('commObject');
    if (TP.isValid(comm)) {
        return comm;
    }

    url = this.getPrimaryURI();
    if (url !== this) {
        return url.getCommObject();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.uri.CommURL.Inst.defineMethod('getCommResponse',
function() {

    /**
     * @method getCommResponse
     * @summary Returns response data from the last communication object (xhr
     *     etc) used in the receiver's interactions with the server.
     * @returns {Object|undefined} The result data from the last comm request.
     */

    var comm;

    comm = this.getCommObject();
    if (TP.isValid(comm)) {
        return comm.response;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.uri.CommURL.Inst.defineMethod('getCommResponseText',
function() {

    /**
     * @method getCommResponseText
     * @summary Returns response text from the last communication object (xhr
     *     etc) used in the receiver's interactions with the server.
     * @returns {String|undefined} The result text from the last comm request.
     */

    var comm;

    comm = this.getCommObject();
    if (TP.isValid(comm)) {
        return comm.responseText;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.uri.CommURL.Inst.defineMethod('getCommResponseType',
function() {

    /**
     * @method getCommResponseType
     * @summary Returns the response type from the last communication object
     * (xhr etc) used in the receiver's interactions with the server.
     * @returns {String|undefined} A string from the XMLHttpRequest API with one
     *     of the following values: "", arraybuffer, blob, document, json, or
     *     text. The default ("") means a DOMString value just as with "text".
     */

    var comm;

    comm = this.getCommObject();
    if (TP.isValid(comm)) {
        return comm.responseType;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.uri.CommURL.Inst.defineMethod('getCommResponseXML',
function() {

    /**
     * @method getCommResponseXML
     * @summary Returns response XML from the last communication object (xhr
     *     etc) used in the receiver's interactions with the server.
     * @returns {String|undefined} The result XML from the last comm request.
     */

    var comm;

    comm = this.getCommObject();
    if (TP.isValid(comm)) {
        return comm.responseXML;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.uri.CommURL.Inst.defineMethod('getCommStatusCode',
function() {

    /**
     * @method getCommStatusCode
     * @summary Returns the last comm (usually xhr) status code from the
     *     receiver's interactions with the server.
     * @returns {Number|undefined} The status code from the last comm request.
     */

    var comm;

    comm = this.getCommObject();
    if (TP.isValid(comm)) {
        return comm.status;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.uri.CommURL.Inst.defineMethod('getCommStatusText',
function() {

    /**
     * @method getCommStatusText
     * @summary Returns the last comm (usually xhr) status text from the
     *     receiver's interactions with the server.
     * @returns {String|undefined} The status message from the last comm
     *     request.
     */

    var comm;

    comm = this.getCommObject();
    if (TP.isValid(comm)) {
        return comm.statusText;
    }

    return;
});

//  ========================================================================
//  TP.uri.HTTPURL
//  ========================================================================

/**
 * @type {TP.uri.HTTPURL}
 * @summary A subtype of TP.uri.URL specific to the HTTP scheme.
 */

//  ------------------------------------------------------------------------

TP.uri.URL.defineSubtype('HTTPURL');

TP.uri.HTTPURL.addTraits(TP.uri.CommURL);

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  note that by setting this to http we allow https to match as well
TP.uri.HTTPURL.Type.defineConstant('SCHEME', 'http');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  HTTP URIs can support access via either sync or async requests
TP.uri.HTTPURL.Type.defineAttribute('supportedModes',
                                    TP.core.SyncAsync.DUAL_MODE);
TP.uri.HTTPURL.Type.defineAttribute('mode',
                                    TP.core.SyncAsync.ASYNCHRONOUS);

TP.uri.HTTPURL.registerForScheme('http');
TP.uri.HTTPURL.registerForScheme('https');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.uri.HTTPURL.Type.defineMethod('$getDefaultHandler',
function(aURI, aRequest) {

    /**
     * @method $getDefaultHandler
     * @summary Returns the default handler for a URI and request pair. For
     *     non-mapped HTTP urls this is the TP.uri.HTTPURLHandler type.
     * @param {TP.uri.URI|String} aURI The URI to obtain the default handler
     *     for.
     * @param {TP.sig.Request} aRequest The request whose values should inform
     *     the routing assignment.
     * @returns {TP.meta.uri.URIHandler} A TP.uri.URIHandler subtype type object
     *     or a type object conforming to that interface.
     */

    var tname,
        type;

    tname = TP.sys.cfg('uri.handler.http');
    if (TP.isEmpty(tname)) {
        return TP.uri.HTTPURLHandler;
    }

    type = TP.sys.getTypeByName(tname);
    if (TP.notValid(type)) {
        this.raise('TP.sig.TypeNotFound', tname);

        return TP.uri.HTTPURLHandler;
    }

    return type;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  cached redirection location
TP.uri.HTTPURL.Inst.defineAttribute('location');

//  note that there are 'scheme', 'path' and 'fragment' ivars on
//  TP.uri.URI / TP.uri.URL
TP.uri.HTTPURL.Inst.defineAttribute('user');
TP.uri.HTTPURL.Inst.defineAttribute('password');
TP.uri.HTTPURL.Inst.defineAttribute('hostname');
TP.uri.HTTPURL.Inst.defineAttribute('port');
TP.uri.HTTPURL.Inst.defineAttribute('query');
TP.uri.HTTPURL.Inst.defineAttribute('queryDict');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.uri.HTTPURL.Inst.defineMethod('$initURIComponents',
function(parts) {

    /**
     * @method $initURIComponents
     * @summary Performs any post-parsing initialization appropriate for the
     *     URI components which were parsed during scheme-specific parsing.
     * @param {TP.core.Hash} parts The parsed URI components.
     * @returns {TP.uri.HTTPURL} The receiver.
     */

    this.callNextMethod();

    //  NOTE: These 'set' calls use 'false' to avoid notification!! This is
    //  necessary when creating a URI, since otherwise the change notification
    //  mechanism will cause errors trying to get observations set up before
    //  everything is in place.

    this.set('user', parts.at('user'), false);
    this.set('password', parts.at('password'), false);

    this.set('hostname', parts.at('hostname'), false);
    this.set('port', parts.at('port'), false);

    this.set('path', parts.at('path'), false);
    this.set('fragment', parts.at('fragment'), false);
    this.set('query', parts.at('query'), false);
    this.set('queryDict', parts.at('queryDict'), false);

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.HTTPURL.Inst.defineMethod('$parseSchemeSpecificPart',
function(schemeSpecificString) {

    /**
     * @method $parseSchemeSpecificPart
     * @summary Parses inbound URI string content in a fashion specific to the
     *     scheme(s) being managed by the receiver.
     * @param {String} schemeSpecificString A String containing the
     *     "scheme-specific-part" of a URI.
     * @returns {TP.core.Hash} The parsed URI 'components'.
     */

    var str,

        natURL,
        dict,

        queryPart,
        queryDict;

    if (this.uri.startsWith('https')) {
        str = 'https:' + schemeSpecificString;
    } else if (this.uri.startsWith('http')) {
        str = 'http:' + schemeSpecificString;
    }

    natURL = new URL(str);

    dict = TP.hc(
            'source', str,
            'scheme', natURL.protocol.slice(0, -1),
            'authority', natURL.host,
            'userinfo', natURL.username + ':' + natURL.password,
            'user', natURL.username,
            'password', natURL.password,
            'hostname', natURL.hostname,
            'port', natURL.port,
            'relative', natURL.pathname,
            'path', natURL.pathname,
            'directory',
                natURL.pathname.slice(0, natURL.pathname.lastIndexOf('/') + 1),
            'file',
                natURL.pathname.slice(natURL.pathname.lastIndexOf('/') + 1),
            'query', natURL.search,
            'fragment', decodeURIComponent(natURL.hash.slice(1))
            );

    //  If we also got a query, construct a TP.core.Hash from it.
    if (TP.notEmpty(queryPart = dict.at('query'))) {
        queryDict = TP.core.Hash.fromString(queryPart);
        dict.atPut('queryDict', queryDict);
    }

    return dict;
});

//  ------------------------------------------------------------------------

TP.uri.HTTPURL.Inst.defineMethod('httpConnect',
function(aRequest) {

    /**
     * @method httpConnect
     * @summary Uses the receiver as a target URI and invokes an HTTP CONNECT
     *     with aRequest.
     * @param {TP.sig.Request} aRequest The original request being processed.
     * @returns {TP.sig.Response} The request's response object.
     */

    return TP.httpConnect(this.asString(), aRequest);
});

//  ------------------------------------------------------------------------

TP.uri.HTTPURL.Inst.defineMethod('httpDelete',
function(aRequest) {

    /**
     * @method httpDelete
     * @summary Uses the receiver as a target URI and invokes an HTTP DELETE
     *     with aRequest.
     * @param {TP.sig.Request} aRequest The original request being processed.
     * @returns {TP.sig.Response} The request's response object.
     */

    return TP.httpDelete(this.asString(), aRequest);
});

//  ------------------------------------------------------------------------

TP.uri.HTTPURL.Inst.defineMethod('httpGet',
function(aRequest) {

    /**
     * @method httpGet
     * @summary Uses the receiver as a target URI and invokes an HTTP GET
     *     with aRequest.
     * @param {TP.sig.Request} aRequest The original request being processed.
     * @returns {TP.sig.Response} The request's response object.
     */

    return TP.httpGet(this.asString(), aRequest);
});

//  ------------------------------------------------------------------------

TP.uri.HTTPURL.Inst.defineMethod('httpHead',
function(aRequest) {

    /**
     * @method httpHead
     * @summary Uses the receiver as a target URI and invokes an HTTP HEAD
     *     with aRequest.
     * @param {TP.sig.Request} aRequest The original request being processed.
     * @returns {TP.sig.Response} The request's response object.
     */

    return TP.httpHead(this.asString(), aRequest);
});

//  ------------------------------------------------------------------------

TP.uri.HTTPURL.Inst.defineMethod('httpOptions',
function(aRequest) {

    /**
     * @method httpOptions
     * @summary Uses the receiver as a target URI and invokes an HTTP OPTIONS
     *     with aRequest.
     * @param {TP.sig.Request} aRequest The original request being processed.
     * @returns {TP.sig.Response} The request's response object.
     */

    return TP.httpOptions(this.asString(), aRequest);
});

//  ------------------------------------------------------------------------

TP.uri.HTTPURL.Inst.defineMethod('httpPatch',
function(aRequest) {

    /**
     * @method httpPatch
     * @summary Uses the receiver as a target URI and invokes an HTTP PATCH
     *     with aRequest.
     * @param {TP.sig.Request} aRequest The original request being processed.
     * @returns {TP.sig.Response} The request's response object.
     */

    return TP.httpPatch(this.asString(), aRequest);
});

//  ------------------------------------------------------------------------

TP.uri.HTTPURL.Inst.defineMethod('httpPost',
function(aRequest) {

    /**
     * @method httpPost
     * @summary Uses the receiver as a target URI and invokes an HTTP POST
     *     with aRequest.
     * @param {TP.sig.Request} aRequest The original request being processed.
     * @returns {TP.sig.Response} The request's response object.
     */

    return TP.httpPost(this.asString(), aRequest);
});

//  ------------------------------------------------------------------------

TP.uri.HTTPURL.Inst.defineMethod('httpPut',
function(aRequest) {

    /**
     * @method httpPut
     * @summary Uses the receiver as a target URI and invokes an HTTP PUT
     *     with aRequest.
     * @param {TP.sig.Request} aRequest The original request being processed.
     * @returns {TP.sig.Response} The request's response object.
     */

    return TP.httpPut(this.asString(), aRequest);
});

//  ------------------------------------------------------------------------

TP.uri.HTTPURL.Inst.defineMethod('httpTrace',
function(aRequest) {

    /**
     * @method httpTrace
     * @summary Uses the receiver as a target URI and invokes an HTTP TRACE
     *     with aRequest.
     * @param {TP.sig.Request} aRequest The original request being processed.
     * @returns {TP.sig.Response} The request's response object.
     */

    return TP.httpTrace(this.asString(), aRequest);
});

//  ========================================================================
//  TP.uri.FileURL
//  ========================================================================

/**
 * @type {TP.uri.FileURL}
 * @summary A URL specific to file references.
 */

//  ------------------------------------------------------------------------

TP.uri.URL.defineSubtype('FileURL');

TP.uri.FileURL.addTraits(TP.uri.CommURL);

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.uri.FileURL.Type.defineConstant('SCHEME', 'file');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  'file:' scheme is sync-only so configure for that
TP.uri.FileURL.Type.defineAttribute('supportedModes',
                                    TP.core.SyncAsync.SYNCHRONOUS);
TP.uri.FileURL.Type.defineAttribute('mode',
                                    TP.core.SyncAsync.SYNCHRONOUS);

TP.uri.FileURL.registerForScheme('file');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.uri.FileURL.Type.defineMethod('$getDefaultHandler',
function(aURI, aRequest) {

    /**
     * @method $getDefaultHandler
     * @summary Returns the default handler for a URI and request pair. For
     *     non-mapped HTTP urls this is the TP.uri.HTTPURLHandler type.
     * @param {TP.uri.URI|String} aURI The URI to obtain the default handler
     *     for.
     * @param {TP.sig.Request} aRequest The request whose values should inform
     *     the routing assignment.
     * @returns {TP.meta.uri.URIHandler} A TP.uri.URIHandler subtype type object
     *     or a type object conforming to that interface.
     */

    var tname,
        type;

    tname = TP.sys.cfg('uri.handler.file');
    if (TP.isEmpty(tname)) {
        return TP.uri.FileURLHandler;
    }

    type = TP.sys.getTypeByName(tname);
    if (TP.notValid(type)) {
        this.raise('TP.sig.TypeNotFound', tname);

        return TP.uri.FileURLHandler;
    }

    return type;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  note that there are 'scheme', 'path' and 'fragment' ivars on
//  TP.uri.URI / TP.uri.URL

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.uri.FileURL.Inst.defineMethod('$initURIComponents',
function(parts) {

    /**
     * @method $initURIComponents
     * @summary Performs any post-parsing initialization appropriate for the
     *     URI components which were parsed during scheme-specific parsing.
     * @param {TP.core.Hash} parts The parsed URI components.
     * @returns {TP.uri.FileURL} The receiver.
     */

    var thePath;

    this.callNextMethod();

    /*
    if (TP.notEmpty(thePath = parts.at('path')) &&
        thePath.startsWith('/')) {
        thePath = thePath.slice(1);
    }
    */

    //  NOTE: These 'set' calls use 'false' to avoid notification!! This is
    //  necessary when creating a URI, since otherwise the change notification
    //  mechanism will cause errors trying to get observations set up before
    //  everything is in place.

    this.set('path', thePath, false);

    //  generate the internal href
    this.asString();

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.FileURL.Inst.defineMethod('$parseSchemeSpecificPart',
function(schemeSpecificString) {

    /**
     * @method $parseSchemeSpecificPart
     * @summary Parses inbound URI string content in a fashion specific to the
     *     scheme(s) being managed by the receiver.
     * @param {String} schemeSpecificString A String containing the
     *     "scheme-specific-part" of a URI.
     * @returns {TP.core.Hash} The parsed URI 'components'.
     */

    this.callNextMethod();

    //  TODO TODO TODO TODO TODO
    //  TODO: relying on TP.core.Hash for parsing is a poor design, we
    //  should change that so the parsing is local to this type. Here, we
    //  invoke the parser directly because of the ambiguities with the style
    //  string parser.
    /* eslint-disable new-cap */
    return TP.core.Hash.URI_STRING_PARSER('file:' + schemeSpecificString);
    /* eslint-enable new-cap */
});

//  ------------------------------------------------------------------------

TP.uri.FileURL.Inst.defineMethod('$getPath',
function(url) {

    /**
     * @method $getPath
     * @summary Parses the url for the path portion as that concept is defined
     *     for the receiving type. Note that different URI types consider
     *     different parts of their HREF to be the 'path'.
     * @param {String} url The URI string to parse.
     * @returns {String} The path subset of the string provided.
     */

    var path;

    //  by default the 'path' is whatever comes after the scheme
    if (TP.sys.isWin()) {
        path = url.slice(url.indexOf(':///') + 4);
    } else {
        path = url.slice(url.indexOf('://') + 3);
    }

    return path;
});

//  ========================================================================
//  TP.uri.JSURI
//  ========================================================================

/**
 * @type {TP.uri.JSURI}
 * @summary A subtype of TP.uri.URI that stores a 'javascript:' URI. These
 *     URIs are used in web browsers when a JavaScript expression needs to be
 *     executed upon traversal of the URI. This type is also used as the content
 *     object for text/javascript MIME content.
 */

//  ------------------------------------------------------------------------

TP.uri.URI.defineSubtype('JSURI');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

/* eslint-disable no-script-url */
TP.uri.JSURI.Type.defineConstant('JSURI_REGEX', TP.rc('javascript:\\s*'));
/* eslint-enable no-script-url */

TP.uri.JSURI.Type.defineConstant('SCHEME', 'javascript');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  'javascript:' scheme is sync-only so configure for that
TP.uri.JSURI.Type.defineAttribute('supportedModes',
                                TP.core.SyncAsync.SYNCHRONOUS);
TP.uri.JSURI.Type.defineAttribute('mode',
                                TP.core.SyncAsync.SYNCHRONOUS);

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.uri.JSURI.Inst.defineAttribute('jsSource');

TP.uri.JSURI.registerForScheme('javascript');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.uri.JSURI.Type.defineMethod('constructContentObject',
function(content, aURI) {

    /**
     * @method constructContentObject
     * @summary Returns a content object for the URI provided. This method is
     *     invoked as part of MIME-type specific handling for URIs vended as
     *     text/javascript or a similar MIME type specifying that their content
     *     is JavaScript source code.
     * @param {String} content The string content to process.
     * @param {TP.uri.URI} [aURI] The source URI.
     * @returns {String} The JavaScript source code in text form.
     */

    return content;
});

//  ------------------------------------------------------------------------

TP.uri.JSURI.Inst.defineMethod('$getPath',
function(url) {

    /**
     * @method $getPath
     * @summary Parses the url for the path portion as that concept is defined
     *     for the receiving type. Note that different URI types consider
     *     different parts of their HREF to be the 'path'.
     * @param {String} url The URI string to parse.
     * @returns {String} The path subset of the string provided.
     */

    //   There is no valid "path" concept in a javascript: URI.
    return '';
});

//  ------------------------------------------------------------------------

TP.uri.JSURI.Type.defineMethod('validate',
function(aString) {

    /**
     * @method validate
     * @summary Returns true if the string parameter is valid JavaScript. For
     *     security reasons this method currently defaults to true rather than
     *     actually executing the string.
     * @param {String} aString A string to test.
     * @returns {Boolean} Whether or not JavaScript code could be successfully
     *     evaluated from the supplied String.
     */

    //  TODO:   parse/tokenize looking for nasty security issues?
    return true;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.uri.JSURI.Inst.defineMethod('isPrimaryURI',
function() {

    /**
     * @method isPrimaryURI
     * @summary Returns true if the receiver is a primary URI, meaning it has
     *     no fragment portion and can store data. JavaScript URIs are always
     *     primary URIs, there is no concept of a fragment.
     * @returns {Boolean} True if the receiver is a primary URI.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.uri.JSURI.Inst.defineMethod('$parseSchemeSpecificPart',
function(schemeSpecificString) {

    /**
     * @method $parseSchemeSpecificPart
     * @summary Parses inbound URI string content in a fashion specific to the
     *     scheme(s) being managed by the receiver.
     * @param {String} schemeSpecificString A String containing the
     *     "scheme-specific-part" of a URI.
     * @returns {TP.core.Hash|undefined} The parsed URI 'components'.
     */

    //  TODO: Review this method - shouldn't we be returning a TP.core.Hash?

    //  NOTE that the concept of 'primary' and 'fragment' aren't relevant
    //  for this type, so we don't invoke the supertype method here, we set
    //  our primary href directly.
    this.$set('primaryLocation',
                this.$get('scheme') + ':' + schemeSpecificString);

    this.$set('jsSource',
                schemeSpecificString.strip(TP.uri.JSURI.JSURI_REGEX));

    return;
});

//  ------------------------------------------------------------------------

TP.uri.JSURI.Inst.defineMethod('$getPrimaryResource',
function(aRequest, filterResult) {

    /**
     * @method $getPrimaryResource
     * @summary Returns the result of evaluating the JS expression represented
     *     by the receiver. Note that while the async flag in aRequest is used
     *     to determine whether the return value is a TP.sig.Response object or
     *     the actual result there's no truly asynchronous processing occurring.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @param {Boolean} filterResult True if the resource result will be used
     *     directly and should be filtered to match any resultType definition
     *     found in the request. The default is false.
     * @returns {TP.sig.Response} A TP.sig.Response created with the resource's
     *     primary content set as its result.
     */

    var request,

        str,

        $$result,
        result,
        msg,
        response;

    request = this.constructRequest(aRequest);

    //  get rid of leading javascript: portion so we can eval the rest
    str = this.get('jsSource');
    try {
        //  TODO: security check
        /* eslint-disable no-eval */
        eval('$$result = ' + str);
        result = $$result;
    } catch (e) {
        msg = TP.sc('Error acquiring resource via: ') + str;
        request.fail(msg);
        result = TP.ec(e, msg);
    }

    if (TP.isTrue(filterResult) && TP.isValid(result)) {
        result = this.$getFilteredResult(result, request, false);
    }

    response = request.getResponse(result);
    request.complete(result);

    return response;
});

//  ------------------------------------------------------------------------

TP.uri.JSURI.Inst.defineMethod('isDirty',
function(aFlag, shouldSignal) {

    /**
     * @method isDirty
     * @summary Returns true if the receiver's content has changed since it was
     *     last loaded from its source URI or content data without being saved.
     * @param {Boolean} aFlag The new value to optionally set.
     * @param {Boolean} [shouldSignal=false] Should changes to the value be
     *     signaled?
     * @returns {Boolean} Whether or not the content of the receiver is 'dirty'.
     */

    //  We basically assume that a JS URI would always return new data. This
    //  isn't likely to be true obviously, but we effectively want JS URIs.
    return true;
});

//  ------------------------------------------------------------------------

TP.uri.JSURI.Inst.defineMethod('isLoaded',
function(aFlag) {

    /**
     * @method isLoaded
     * @summary Returns true if the receiver's content has been loaded either
     *     manually via a setContent or init, or by loading the receiver's URI
     *     location.
     * @param {Boolean} aFlag The new value to optionally set.
     * @returns {Boolean} Whether or not the content of the receiver is loaded.
     */

    //  A JavaScript URI is never considered loaded, it has to be able to
    //  refresh by default in all cases.
    return false;
});

//  ------------------------------------------------------------------------
//  Storage Management
//  ------------------------------------------------------------------------

TP.uri.JSURI.Inst.defineMethod('load',
function(aRequest) {

    /**
     * @method load
     * @summary For the most part, no-op for JSURIs.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    var request,
        url,
        handler;

    request = this.constructRequest(aRequest);

    //  rewriting means we'll get to the concrete URI for the receiver so we
    //  put the data where it really belongs
    url = this.rewrite(request);

    request.atPut('operation', 'load');

    //  NB: We hard-code 'TP.uri.URIHandler' as our handler here, since it
    //  really just completes the request properly and doesn't do much else. See
    //  that type for more information
    handler = TP.uri.URIHandler;

    return handler.load(url, request);
});

//  ------------------------------------------------------------------------

TP.uri.JSURI.Inst.defineMethod('delete',
function(aRequest) {

    /**
     * @method delete
     * @summary For the most part, a no-op for JSURIs.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    var request,
        url,
        handler;

    request = this.constructRequest(aRequest);

    //  rewriting means we'll get to the concrete URI for the receiver so we
    //  put the data where it really belongs
    url = this.rewrite(request);

    request.atPut('operation', 'delete');

    //  NB: We hard-code 'TP.uri.URIHandler' as our handler here, since it
    //  really just completes the request properly and doesn't do much else. See
    //  that type for more information
    handler = TP.uri.URIHandler;

    return handler.delete(url, request);
});

//  ------------------------------------------------------------------------

TP.uri.JSURI.Inst.defineMethod('save',
function(aRequest) {

    /**
     * @method save
     * @summary For the most part, a no-op for JSURIs.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    var request,
        url,
        handler;

    request = this.constructRequest(aRequest);

    //  rewriting means we'll get to the concrete URI for the receiver so we
    //  put the data where it really belongs
    url = this.rewrite(request);

    request.atPut('operation', 'save');

    //  NB: We hard-code 'TP.uri.URIHandler' as our handler here, since it
    //  really just completes the request properly and doesn't do much else. See
    //  that type for more information
    handler = TP.uri.URIHandler;

    return handler.save(url, request);
});

//  ========================================================================
//  TP.uri.WSURL
//  ========================================================================

/**
 * @type {TP.uri.WSURL}
 * @summary A subtype of TP.uri.URL specific to the WebSocket scheme.
 */

//  ------------------------------------------------------------------------

TP.uri.URL.defineSubtype('WSURL');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.uri.WSURL.Type.defineConstant('SCHEME', 'ws');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  WebSocket URIs can support only async requests
TP.uri.WSURL.Type.defineAttribute('supportedModes',
                                    TP.core.SyncAsync.ASYNCHRONOUS);
TP.uri.WSURL.Type.defineAttribute('mode',
                                    TP.core.SyncAsync.ASYNCHRONOUS);

TP.uri.WSURL.registerForScheme('ws');
TP.uri.WSURL.registerForScheme('wss');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  cached redirection location
TP.uri.WSURL.Inst.defineAttribute('webSocketObj');

//  note that there are 'scheme', 'path' and 'fragment' ivars on
//  TP.uri.URI / TP.uri.URL
TP.uri.WSURL.Inst.defineAttribute('hostname');
TP.uri.WSURL.Inst.defineAttribute('port');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.uri.WSURL.Inst.defineMethod('$initURIComponents',
function(parts) {

    /**
     * @method $initURIComponents
     * @summary Performs any post-parsing initialization appropriate for the
     *     URI components which were parsed during scheme-specific parsing.
     * @param {TP.core.Hash} parts The parsed URI components.
     * @returns {TP.uri.WSURL} The receiver.
     */

    this.callNextMethod();

    //  NOTE: These 'set' calls use 'false' to avoid notification!! This is
    //  necessary when creating a URI, since otherwise the change notification
    //  mechanism will cause errors trying to get observations set up before
    //  everything is in place.

    this.set('hostname', parts.at('hostname'), false);
    this.set('port', parts.at('port'), false);

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.WSURL.Inst.defineMethod('$parseSchemeSpecificPart',
function(schemeSpecificString) {

    /**
     * @method $parseSchemeSpecificPart
     * @summary Parses inbound URI string content in a fashion specific to the
     *     scheme(s) being managed by the receiver.
     * @param {String} schemeSpecificString A String containing the
     *     "scheme-specific-part" of a URI.
     * @returns {TP.core.Hash} The parsed URI 'components'.
     */

    this.callNextMethod();

    //  TODO TODO TODO TODO TODO
    //  TODO: relying on TP.core.Hash for parsing is a poor design, we
    //  should change that so the parsing is local to this type. Here, we
    //  invoke the parser directly because of the ambiguities with the style
    //  string parser.
    /* eslint-disable new-cap */
    return TP.core.Hash.URI_STRING_PARSER('ws:' + schemeSpecificString);
    /* eslint-enable new-cap */
});

//  ========================================================================
//  TP.uri.TIBETURL
//  ========================================================================

/**
 * @type {TP.uri.TIBETURL}
 * @summary A subtype of TP.uri.URI that stores a 'tibet:' URI. These URIs
 *     provide access to TIBET components, files, and other resources and are
 *     the preferred URI format for TIBET.
 * @description TIBET uses tibet: URIs as a way of referring to things which a
 *     standard URI such as a file: or http: URI can't reference. A common
 *     example is document references which require dynamic relative paths since
 *     file: and http: URIs don't have a way to handle dynamic values.
 *     Canvas-specific addresses are also handled by TIBET URLs as are remote
 *     XMPP-accessible addresses.
 *
 *     TIBET URL FORMAT:
 *
 *     The overall format of a TIBET URL is:
 *
 *     tibet:[node @domain:port]/[resource]/[canvas]/[uri | path]
 *
 *     In this format the [node @domain:port/[resource] segment mirrors the JID
 *     format of the XMPP protocol, allowing TIBET URLs to point to remote
 *     resources addressable via JID. In normal use these values are empty with
 *     the result that all local TIBET URL references begin with tibet:// and
 *     hence appear like "normal" file or http URIs.
 *
 *     The canvas portion allows TIBET URLs to reference objects by their
 *     location within the visual environment of the browser, so an object whose
 *     ID is "OKButton" in one frame is not the same as an object with that ID
 *     in a second frame.
 *
 *     tibet://myWin/#OKButton
 *
 *     You can also use 'uicanvas' as a generic identifier for the current UI
 *     canvas used by the application. This latter option lets you avoid hard
 *     window/frame references in your code:
 *
 *     tibet://uicanvas/#OKButton
 *
 *     Note that for convenience you can also construct a URI from a simple
 *     barename as in:
 *
 *     url = TP.uc('#OKButton'); // OK button in the current UI canvas
 *
 *     becomes
 *
 *     tibet://uicanvas/#OKButton
 *
 *     The remaining element of the tibet: URI scheme is either another URI (a
 *     file:, http:, javascript:, or similar URI format) or an "access path"
 *     understood by TIBET URLs.
 *
 *     TIBET URLS WITH EMBEDDED URIS
 *
 *     For URI-style forms there are a few special cases:
 *      - "virtual" URIs
 *      - URNs
 *      - javascript: URIs.
 *
 *     Any embedded URI starting with ~ is resolved to either a file or http
 *     URI using a simple set of rules modeled on the UNIX concept of "home".
 *     Using this model a single ~ resolves to "app home" or what TIBET refers
 *     to as "app root". All other references can be thought of as "$foo home"
 *     where $foo is "tibet", "lib_xsl", etc.
 *
 *     Note that these virtual URIs ensure that whether you boot from the file
 *     system or over HTTP the URIs will resolve to the proper origin without
 *     code changes on your part.
 *
 *     Specific examples are:
 *
 *     tibet:///~app        app root
 *     tibet:///~lib        lib root
 *     tibet:///~lib_xsl    the library's xslt path
 *
 *     When using a TIBET URL of this form you can leave off the leading
 *     tibet:/// as in:
 *
 *     ~app         app root
 *     ~lib         lib root
 *     ~lib_xsl     the library's xslt path
 *
 *     Note that in these cases the canvas is empty so it defaults to the 'code
 *     frame', effectively a non-visual memory reference where the returned
 *     values are typically going to refer to XML objects, system types, or
 *     instances of TIBET types. It is important to avoid placing a canvas
 *     reference in URIs of this form unless you are specifically asking for an
 *     element within a visual canvas whose ID is the expanded ~ URI string, or
 *     that you provide an explicit prefix of tibet://[canvas]/~... when you are
 *     specifically attempting access to a visual canvas.
 *
 *     In addition to virtual URIs TIBET provides ways to map any data within
 *     your application to a URI, in particular to a URN.
 *
 *     Examples of URNs are urn:tibet:TP.sys (the TP.sys object), or
 *     urn:tibet:TP.sig.Signal (the TP.sig.Signal type), etc.
 *
 *     TIBET URLs can include embedded URN values if necessary, however it's
 *     rarely useful since you can use the URN directly in many cases. However,
 *     if you find that using the urn: syntax is running afoul of the browser
 *     you can embed them via tibet:///.
 *
 *     The final special case is javascript: URIs. You can use a javascript:
 *     URI within a TIBET URL as an alternative way of referring to a
 *     canvas-specific object as in:
 *
 *     tibet://uicanvas/javascript:TP // in the ui canvas
 *
 *     This isn't used often, but occasionally TIBET will build URIs of this
 *     form as a way of "contextualizing" a JavaScript URI. Note that TIBET will
 *     typically insert the canvas specification for you if it isn't found (and
 *     isn't the code frame) so that:
 *
 *     tibet://uicanvas/javascript:TP
 *
 *     becomes
 *
 *     tibet:///javascript:[uicanvasref].TP
 *
 *     Note that by pushing the canvas specification onto the front of any text,
 *     evaluating the remaining portion will access the context of the named
 *     canvas as its root.
 *
 *     VISUAL vs. NON-VISUAL DOM REFERENCES
 *
 *     Let's revisit the subject of multiple canvases for a moment. As
 *     discussed earlier, the TIBET URL for a button whose ID is "OKButton" in
 *     the page ~app_xml/search.xml when displayed in the uicanvas frame would
 *     be:
 *
 *     tibet://uicanvas/~app_xml/search.xml#OKButton
 *
 *     This might expand, when run via an application hosted and rooted at
 *     http://foo.com/app to an equivalent global ID form of:
 *
 *     tibet://uicanvas/http://foo.com/app/TIBET-INF/xml/search.xml#OKButton
 *
 *     When TIBET sees this it acquires the canvas, verifies that it holds
 *     content from http://foo.com/app/TIBET-INF/xml/search.xml, and then looks
 *     for an element whose id attribute holds OKButton. This is consistent with
 *     web standards if you consider that the OKButton's XPointer reference is
 *     that URI when trying to access it from any other browsing environment.
 *
 *     TIBET treats references in the code frame (those having no canvas
 *     specification) a little differently in that it essentially ignores the
 *     canvas reference and instead uses the URI itself to acquire the resource.
 *     So the same reference to OKButton without a canvas would be:
 *
 *     tibet:///~app_xml/search.xml#OKButton
 *
 *     In response TIBET will reference the "concrete URI":
 *
 *     http://foo.com/app/TIBET-INF/xml/search.xml#OKButton
 *
 *     This URI will be used to acquire the object by loading the file
 *     search.xml from the location provided and then evaluating the XPointer
 *     barename OKButton to get a handle to the button instance in the
 *     non-visual DOM. Note that there will actually be three URIs constructed
 *     and encached in this case:
 *
 *     tibet:///~app_xml/search.xml#OKButton
 *     http://foo.com/app/TIBET-INF/xml/search.xml
 *     http://foo.com/app/TIBET-INF/xml/search.xml#OKButton
 *
 *     The URI in the middle, without the OKButton reference is the one
 *     containing the data for the document search.xml. All XPointer URIs
 *     referencing that root document share the content found at that location
 *     to avoid problems with inconsistent data.
 */

//  ------------------------------------------------------------------------

TP.uri.URL.defineSubtype('TIBETURL');

TP.uri.TIBETURL.addTraits(TP.uri.CommURL);

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  indexes into the match results from the url splitter regex
TP.uri.TIBETURL.Type.defineConstant('JID_INDEX', 1);
TP.uri.TIBETURL.Type.defineConstant('RESOURCE_INDEX', 2);
TP.uri.TIBETURL.Type.defineConstant('CANVAS_INDEX', 3);
TP.uri.TIBETURL.Type.defineConstant('URL_INDEX', 4);
TP.uri.TIBETURL.Type.defineConstant('PATH_INDEX', 5);
TP.uri.TIBETURL.Type.defineConstant('FRAGMENT_INDEX', 6);

TP.uri.TIBETURL.Type.defineConstant('SCHEME', 'tibet');

TP.uri.TIBETURL.registerForScheme('tibet');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  the canvas (window) name referenced by this URI. this is only used when
//  the value is cacheable, meaning it was explicitly defined in the URI
TP.uri.TIBETURL.Inst.defineAttribute('canvasName');

//  a handle to any internally generated URI for file/http references which
//  are resolved from the original TIBET URL string
TP.uri.TIBETURL.Inst.defineAttribute('nestedURI');

//  a cached value for whether the instance's path and pointer components
//  are empty, which helps keep getResource running faster
TP.uri.TIBETURL.Inst.defineAttribute('uriKey');

//  cached copy of the portions of the TIBET URI, used to access canvas name and
//  other components of the virtual uri.
TP.uri.URI.Inst.defineAttribute('uriParts');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('init',
function(aURIString, aResource) {

    /**
     * @method init
     * @summary Initialize the instance. Note that once an instance is
     *     constructed the individual parts of the URI can't be altered,
     *     although variable references (such as uicanvas) may allow it to
     *     resolve to different concrete elements during its life.
     * @param {String} aURIString A String containing a proper URI.
     * @param {Object} [aResource] Optional value for the targeted resource.
     * @returns {TP.uri.TIBETURL} The receiver.
     */

    //  make sure we come in with tibet: scheme or that we add it
    if (TP.regex.TIBET_SCHEME.test(aURIString) &&
        TP.regex.TIBET_URL_SPLITTER.test(aURIString)) {
        return this.callNextMethod();
    } else if (TP.regex.VIRTUAL_URI_PREFIX.test(aURIString)) {
        //  URIs starting with ~ don't resolve to a canvas.
        return this.callNextMethod('tibet:///' + aURIString);
    } else {
        //  before we try to raise we need at least a uri slot.
        this.$set('uri', aURIString);

        return this.raise('TP.sig.InvalidURI',
                    'Invalid TIBET URL prefix or scheme: ' + aURIString);
    }
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('$initURIComponents',
function(parts) {

    /**
     * @method $initURIComponents
     * @summary Performs any post-parsing initialization appropriate for the
     *     URI components which were parsed during scheme-specific parsing. Note
     *     that TP.uri.URI's implementation ensures that the uri, scheme,
     *     primary, and fragment portions of a URI string will be set.
     * @param {TP.core.Hash} parts The parsed URI components.
     * @returns {TP.uri.TIBETURL|undefined} The receiver.
     */

    //  force ID expansion if it didn't already happen. this will also force
    //  our parts to be encached for us.
    if (TP.isEmpty(this.getID())) {
        //  If no ID could be produced then the URI isn't truly valid and we
        //  don't want to return a proper instance.
        return;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output. TIBET URLs containing valid resource URIs typically respond
     *     with that string for compatibility with their file/http counterparts.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    //  TIBET URLs with no canvas are effectively simply aliases to the
    //  concrete URI.
    if (TP.isEmpty(this.getCanvasName())) {
        return this.getConcreteURI().asDumpString(depth, level);
    }

    //  Otherwise, call up
    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver. TIBET
     *     URLs containing valid resource URIs typically respond with that
     *     string for compatibility with their file/http counterparts.
     * @returns {String} The receiver in HTML string format
     */

    //  TIBET URLs with no canvas are effectively simply aliases to the
    //  concrete URI.
    if (TP.isEmpty(this.getCanvasName())) {
        return this.getConcreteURI().asHTMLString();
    }

    //  Otherwise, call up
    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    //  TIBET URLs with no canvas are effectively simply aliases to the
    //  concrete URI.
    if (TP.isEmpty(this.getCanvasName())) {
        return this.getConcreteURI().asJSONSource();
    }

    //  Otherwise, call up
    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Produces a pretty string representation of the receiver. TIBET
     *     URLs containing valid resource URIs typically respond with that
     *     string for compatibility with their file/http counterparts.
     * @returns {String} The receiver in pretty string format
     */

    //  TIBET URLs with no canvas are effectively simply aliases to the
    //  concrete URI.
    if (TP.isEmpty(this.getCanvasName())) {
        return this.getConcreteURI().asPrettyString();
    }

    //  Otherwise, call up
    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns a string representation of the receiver. TIBET URLs
     *     containing valid resource URIs typically respond with that string for
     *     compatibility with their file/http counterparts.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the TP.uri.TIBETURL's String representation. The default is for
     *     TP.uri.TIBETURLs is false, which is different than for most types.
     * @returns {String} The receiver's String representation.
     */

    //  TIBET URLs with no canvas are effectively simply aliases to the
    //  concrete URI.
    if (TP.isEmpty(this.getCanvasName())) {
        return this.getConcreteURI().asString(verbose);
    }

    //  Otherwise, call up
    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver. TIBET
     *     URLs containing valid resource URIs typically respond with that
     *     string for compatibility with their file/http counterparts.
     * @returns {String} The receiver in XML string format
     */

    //  TIBET URLs with no canvas are effectively simply aliases to the
    //  concrete URI.
    if (TP.isEmpty(this.getCanvasName())) {
        return this.getConcreteURI().asXMLString();
    }

    //  Otherwise, call up
    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('getCanvas',
function() {

    /**
     * @method getCanvas
     * @summary Returns the canvas (window, frame, iframe) this URI references
     *     by traversing any optional 'paths' defined in our canvas name. If no
     *     canvas name is specified the canvas defaults to the current UI canvas
     *     for TIBET.
     * @returns {Window|undefined} The receiver's resource canvas.
     */

    var name;

    //  our canvas name is the starting point, which should be an
    //  optionally dot-separated list of window/frame/iframe names
    name = this.getCanvasName();
    if (TP.notEmpty(name)) {
        return TP.sys.getWindowById(name);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('getCanvasName',
function() {

    /**
     * @method getCanvasName
     * @summary Returns the name of the canvas this URI refers to.
     * @returns {String} The receiver's resource canvas name.
     */

    var parts,
        name;

    //  our original split value is here
    parts = this.getURIParts();

    //  whole, jid, resource, canvas, path, pointer
    name = parts.at(TP.uri.TIBETURL.CANVAS_INDEX);

    if (TP.isEmpty(name)) {
        name = '';  //  leave empty, this URI doesn't specify a canvas.
    } else if (name === 'uicanvas' || name === 'UICANVAS') {
        return TP.sys.getUICanvasName();
    } else if (name === 'uiroot' || name === 'UIROOT') {
        return TP.sys.getUIRootName();
    }

    return name;
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('getID',
function() {

    /**
     * @method getID
     * @summary Returns the ID of the receiver, which for URIs is their unique
     *     URI value. In the case of TIBET URLs it is the fully-expanded version
     *     of the URI so all variants can be identified as the same instance.
     * @returns {String} The unique ID of the receiver.
     */

    var id,
        url,
        concrete,
        parts,
        canvas,
        loc;

    //  Make sure that, if the receiver is a prototype, we just return the value
    //  of the TP.ID slot. Otherwise, we're trying to get an ID from an object
    //  that represents only a partially formed instance for this type.
    if (TP.isPrototype(this)) {
        return this[TP.ID];
    }

    id = this.$get(TP.ID);

    //  the next question is do we have our *own* id (otherwise, we'll report
    //  the value inherited from the prototype)
    if (TP.owns(this, TP.ID)) {
        return id;
    }

    //  then the question is what do we have now, an OID or TIBET URL string?

    //  if our ID already starts with tibet then we've been here before,
    //  otherwise we'll be looking at a standard TIBET OID here...
    if (TP.regex.TIBET_SCHEME.test(id)) {
        return id;
    }

    //  our internal (and initial) URI should be here, tibet: prefixed
    url = this.$get('uri');

    //  first check is a regex that should work on all valid TIBET URLs
    if (!TP.regex.TIBET_URL_SPLITTER.test(url)) {
        return TP.raise(url, 'TP.sig.InvalidURI', url);
    }

    parts = this.getURIParts();

    //  with parts in place we can ask for the canvas name
    canvas = this.getCanvasName();

    //  the second part is our resource URI, which may include a ~ that
    //  needs to be expanded before we have all the components of the ID
    if (TP.isEmpty(canvas)) {
        //  when we have a concrete uri we can ask it for the location
        concrete = this.getConcreteURI();
        if (TP.notValid(concrete)) {
            return TP.raise(url, 'TP.sig.InvalidURI', url);
        }
        loc = concrete.getLocation();
    } else {
        //  the path and pointer portions of our regex match are the
        //  location when there wasn't a valid resource URI value
        loc = TP.ifInvalid(parts.at(TP.uri.TIBETURL.PATH_INDEX), '') +
                TP.ifInvalid(parts.at(TP.uri.TIBETURL.FRAGMENT_INDEX), '');
    }

    //  build up the ID from the various parts
    id = TP.join('tibet:',
        TP.ifInvalid(parts.at(TP.uri.TIBETURL.JID_INDEX), ''), '/',
        TP.ifInvalid(parts.at(TP.uri.TIBETURL.RESOURCE_INDEX), ''), '/',
        canvas, '/',
        loc);

    //  cache our efforts so we don't have to do this again
    this.$set(TP.ID, id);

    return id;
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('getLocation',
function() {

    /**
     * @method getLocation
     * @summary Returns the URIs location, adjusting for any virtual URI
     *     components to return the actual resource URI value.
     * @returns {String} The receiver's location.
     */

    //  TIBET URLs with no canvas are effectively simply aliases to the
    //  concrete URI.
    if (TP.isEmpty(this.getCanvasName())) {
        return this.getConcreteURI().getLocation();
    }

    //  supertype will compute a decent default value as an alternative.
    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('getOriginalSource',
function() {

    /**
     * @method getOriginalSource
     * @summary Returns the 'original source' representation that the receiver
     *     was constructed with.
     * @returns {String} The receiver's original source.
     */

    //  For TP.uri.TIBETURLs, this is what the user originally initialized us
    //  with. It can be found at the 5th position in URI parts.
    return this.getURIParts().at(4);
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('getConcreteURI',
function(forceRefresh) {

    /**
     * @method getConcreteURI
     * @summary Return's the receiver's 'concrete' URI. For TP.uri.TIBETURL,
     *     this will return the concrete URI that the TIBETURL is a holder for.
     *     This is typically the file: or http: URI for the content the receiver
     *     references.
     * @param {Boolean} forceRefresh True will force any cached value for
     *     resource URI to be ignored.
     * @returns {TP.uri.TIBETURL|undefined} A concrete URI if the receiver
     *     resolves to one.
     */

    var resource,
        retVal,
        url,
        parts,
        path;

    //  When there's a canvas reference the receiver is a pointer to a DOM
    //  element and not an indirect reference to some other concrete URI. In
    //  that case we will grab the resource, get its global ID and then compute
    //  a new URL from that.
    if (TP.notEmpty(this.getCanvasName())) {

        //  NB: We assume 'async' of false here
        if (TP.isValid(resource = this.getResource().get('result'))) {
            //  If it's a Window, hand back a TIBET URI, but pointing to the
            //  'more concrete' URI that includes the Window's global ID.
            if (TP.isKindOf(resource, TP.core.Window)) {
                retVal = TP.uc('tibet://' + TP.gid(resource));
            } else {
                retVal = TP.uc(TP.gid(resource));
            }
        } else {
            return;
        }

        //  Make sure that we're not just ending up with ourself. Otherwise,
        //  we'll be back here again in an endless recursion.
        if (TP.isURI(retVal) && retVal.getLocation() !== this.getLocation()) {
            return retVal;
        }
    }

    //  we don't allow runtime alteration to virtual paths largely due to
    //  the fact that we cache this value. clearing it should allow a URI to
    //  "float" again
    if (TP.notTrue(forceRefresh)) {
        if (TP.isURI(url = this.$get('nestedURI'))) {
            return url;
        }
    }

    //  work from the path...NOTE NOTE NOTE do not work from ID, that will
    //  recurse since our ID is built in part from the expanded resource URI
    parts = this.getURIParts();
    if (TP.isEmpty(parts)) {
        path = TP.uriResolveVirtualPath(this.$get('uri'), true);
        parts = path.match(TP.regex.TIBET_URL_SPLITTER);
    }

    path = parts.at(TP.uri.TIBETURL.URL_INDEX);
    if (TP.isEmpty(path)) {
        return;
    }

    //  this resolves the path as cleanly as possible, returning a path that
    //  typically starts with one of the schemes we consider "resource"
    //  schemes. NOTE we pass true for resourceOnly here to strip tibet:
    //  prefixes for canvased URIs
    path = TP.uriResolveVirtualPath(path, true);
    if (TP.regex.SCHEME.test(path)) {
        url = TP.uc(path);
        if (TP.isURI(url)) {
            this.set('nestedURI', url);
        } else {
            TP.ifWarn() ?
                TP.warn('Invalid URI specification: ' + path) : 0;

            return;
        }
    }

    return url;
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('getPath',
function() {

    /**
     * @method getPath
     * @summary Returns the path portion of the receiver. For TIBET URLs this
     *     is the entire URI string.
     * @returns {String} A scheme-specific path string.
     */

    //  ensure a string
    return this.getLocation() || '';
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('getPrimaryLocation',
function() {

    /**
     * @method getPrimaryLocation
     * @summary Returns the primary resource's URIs location. This is the
     *     portion of the URI which isn't qualified by a fragment, the portion
     *     you can send to a server without causing an error.
     * @returns {String} The primary href as a String.
     */

    //  TIBET URLs with no canvas are effectively simply aliases to the
    //  concrete URI.
    if (TP.isEmpty(this.getCanvasName())) {
        return this.getConcreteURI().getPrimaryLocation();
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('$getPrimaryResource',
function(aRequest, filterResult) {

    /**
     * @method $getPrimaryResource
     * @summary Returns the TIBET object referenced by the receiver. When the
     *     TIBET path resolves to another URI form (i.e. when a ~ is used for a
     *     "virtual" file or http URI) the resource (content) of that URI is
     *     returned.
     * @description TIBET URLs are used to support a wide variety of access
     *     paths to objects in the system. This is unfortunately necessary since
     *     the standard URI schemes don't allow for client-side object
     *     referencing in any real sense, nor do they support the kind of
     *     "runtime evaluation" we often require of URIs for application
     *     development. The result is that this method has to handle a wide
     *     variety of cases and still try to remain reasonably fast. Preference
     *     is given here to the kinds of object references most likely to be
     *     used relative to the UI since that's typically the most
     *     time-sensitive object access path.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @param {Boolean} filterResult True if the resource result will be used
     *     directly and should be filtered to match any resultType definition
     *     found in the request. The default is false.
     * @returns {TP.sig.Response|undefined} A TP.sig.Response created with the
     *     resource's content set as its result.
     */

    var request,
        refresh,
        filter,

        parts,
        canvas,

        async,
        url,

        path,
        pointer,
        key,

        win,
        err,

        result,

        locRoot,
        pathRoot,

        tpwin,
        inst;

    request = this.constructRequest(aRequest);
    refresh = request.at('refresh');
    filter = filterResult || false;

    //  may need to force refresh under certain circumstances so we need to
    //  take care of that before proceeding
    if (!this.isLoaded() || TP.notValid(refresh)) {
        refresh = false;

        //  never loaded means we have to load/refresh the first time
        if (!this.isLoaded()) {
            refresh = true;
        }

        //  if we're pointing into a live window we also want to refresh,
        //  content in windows is changing constantly and we don't try to
        //  manage that change back to the uris that reference into it
        parts = this.getURIParts();

        //  with parts in place we can ask for the canvas name
        canvas = this.getCanvasName();
        if (TP.notEmpty(canvas)) {
            refresh = true;
        }
    }

    async = this.rewriteRequestMode(request);

    //  not forced to refresh? then our best-fit object is our resource if
    //  we have one, or its the data from our primary URI in unrefreshed
    //  form.
    if (TP.notTrue(refresh)) {
        if ((url = this.getPrimaryURI()) !== this) {
            result = url.$get('resource');
        } else {
            result = this.$get('resource');
        }
        result = this.$getResourceResult(request, result, async, filter);

        if (TP.canInvoke(aRequest, 'complete')) {
            aRequest.complete(result);
        }

        if (TP.canInvoke(aRequest, 'getResponse')) {
            return aRequest.getResponse(result);
        } else {
            return this.constructRequest().getResponse(result);
        }
    }

    //  most common cases are a) loading external file content b)
    //  referencing a UI element via a barename, c) referring back into
    //  codeframe for an XML peer element via a barename. The second and
    //  third cases are the ones that require the most optimized access
    //  since the first involves IO latency that offsets anything else

    //  the original parts of the URI give us the best view of the real
    //  intent. these typically are split during initialization and cached
    parts = parts || this.getURIParts();

    //  with parts in place we can ask for the canvas name
    canvas = this.getCanvasName();

    path = parts.at(TP.uri.TIBETURL.PATH_INDEX);
    pointer = parts.at(TP.uri.TIBETURL.FRAGMENT_INDEX);

    //  this key helps drive switch logic down below to keep things a little
    //  clearer from a logic/branching perspective
    if (TP.notValid(key = this.$get('uriKey'))) {
        key = TP.join(TP.str(TP.isEmpty(path)),
                        '_',
                        TP.str(TP.isEmpty(pointer)));
        this.$set('uriKey', key, false);
    }

    //  top-level branch is based on XML or HTML tree (ui or code frame).
    //  when the canvas has been specified and it's not the code frame we'll
    //  need a handle to the window to do the work below. most file access
    //  is based on empty canvas specifications (implying codeframe)
    if (TP.notEmpty(canvas)) {
        if (!TP.isWindow(win = TP.sys.getWindowById(canvas))) {
            err = TP.join(TP.sc('Unable to locate window '), canvas,
                        TP.sc(' for URI: '), this.getPath());

            TP.ifWarn() ? TP.warn(err) : 0;

            request.fail(err);

            return this.$getResourceResult(request,
                                            undefined,
                                            async,
                                            filter);
        }
    }

    //  "normalize" path for comparisons so tibet:///~something, ~something,
    //  and the expanded version of ~something all produce the same string
    if (TP.notEmpty(path)) {
        path = TP.uriExpandPath(path);
    }

    if (TP.isWindow(win)) {
        //  real window? then we're hunting for UI content of some kind
        //  unless the path is a javascript: path requesting evaluation
        //  in the window's context

        //  deal with the javascript: option first so we keep things cleaner
        //  down below
        if (TP.regex.JS_SCHEME.test(path)) {
            try {
                //  If the canvas name is *not* empty, then this URI has a
                //  canvas specifier, which means it needs to be rewritten as a
                //  'JS traversal path':
                //      tibet://top.UIROOT.screen_0/javascript:globalVar
                //          becomes
                //      tibet:///javascript:top.UIROOT.screen_0.globalVar
                if (TP.notEmpty(this.getCanvasName())) {
                    //  Build a URL by using a TIBET URL scheme with a blank
                    //  canvas identifier, the canvas name and the current path
                    //  with the 'javascript:' bit sliced off.
                    url = TP.uc('tibet:///javascript:' +
                                this.getCanvasName() + '.' + path.slice(11));

                    //  This will always be synchronous - it's a 'javascript:'
                    //  URL.
                    result = url.getResource().get('result');

                    return this.$getResourceResult(request,
                                                    result,
                                                    async,
                                                    filter);
                } else {
                    //  NOTE the special case here, no cache
                    if ((url = this.getPrimaryURI()) !== this) {
                        return url.$getPrimaryResource(request, filterResult);
                    }
                }
            } catch (e) {
                err = TP.ec(e,
                        TP.join(TP.sc('URI access produced error for: '),
                                this.asString()));
                this.raise('TP.sig.URIException', err);
                request.fail(err);

                return this.$getResourceResult(request,
                                                undefined,
                                                async,
                                                filter);
            }
        }

        //  key is whether pathIsEmpty_pointerIsEmpty
        switch (key) {
            case 'true_true':

                //  both empty? window ID only, we're done
                result = TP.tpwin(win);
                return this.$getResourceResult(request,
                                                result,
                                                async,
                                                filter);

            case 'false_false':
            case 'false_true':

                //  path with/without pointer?
                if (TP.notEmpty(path) &&
                    (url = this.getPrimaryURI()) !== this) {

                    locRoot = TP.uriRoot(TP.documentGetLocation(win.document));
                    pathRoot = TP.uriRoot(path);

                    //  If our path root matches the current document location
                    //  root or our pointer is '#document', return the wrapped
                    //  Document.
                    if (locRoot === pathRoot || pointer === '#document') {
                        //  NB: We don't set the result's 'uri' here since
                        //  the result is the document and we probably don't
                        //  represent the document.
                        result = TP.dom.DocumentNode.construct(
                                                        win.document);

                        return this.$getResourceResult(request,
                                                        result,
                                                        async,
                                                        filter);
                    }

                    return this.$getResourceResult(request,
                                                    undefined,
                                                    async,
                                                    filter);
                } else {
                    //  Path is empty, or we don't have a content URI to
                    //  match, so either way we should return the document.

                    //  NB: We don't set the result's 'uri' here since the
                    //  result is the document and we probably don't
                    //  represent the document.
                    result = TP.dom.DocumentNode.construct(win.document);

                    return this.$getResourceResult(request,
                                                    result,
                                                    async,
                                                    filter);
                }

            case 'true_false':

                //  pointer references window.document subset without
                //  constraining it to a particular file's content.

                //  NB: We don't set the result's 'uri' here since the
                //  result is the document and we probably don't represent
                //  the document.
                result = TP.dom.DocumentNode.construct(win.document);

                return this.$getResourceResult(request,
                                                result,
                                                async,
                                                filter);

            default:
                break;
        }
    } else {
        if ((url = this.getPrimaryURI()) !== this) {
            return url.$getPrimaryResource(request, filterResult);
        }

        //  no window, so this is a codeframe reference to either a resource
        //  URI's content or to an object we can get via
        //  TP.sys.getObjectById() (provided we don't trigger a recursion :)
        //  or by access path traversal (or both). A common and time-sensitive
        //  call here is one that's trying to locate an xctrls:instance or a
        //  part of the data within that instance for data binding purposes.

        //  key is whether pathIsEmpty_pointerIsEmpty
        switch (key) {
            case 'true_true':

                //  no window, no path, no pointer? not much to work with...
                //  what does tibet:/// refer to?
                return this.$getResourceResult(request,
                                                undefined,
                                                async,
                                                filter);

            case 'false_false':
            case 'false_true':

                //  path with/without pointer? entire resource document
                //  request, provided we have a content URI. If we don't
                //  have a content URI then the TIBET URL is being used as
                //  if it were a urn: which is no longer supported.
                if ((url = this.getPrimaryURI()) !== this) {
                    inst = url.$getPrimaryResource(request, filter);
                    async = this.rewriteRequestMode(request);

                    if (async) {
                        //  inst will be a TP.sig.Response when async.
                        return inst;
                    }

                    return this.$getResourceResult(request,
                                                    inst,
                                                    async,
                                                    filter);
                }
                return;

            case 'true_false':

                //  pointer only? with no window the window is the UICANVAS
                //  to make it easier for consumers to just type tibet:///
                //  and we want that document as our target.
                tpwin = TP.sys.getUICanvas();
                if (TP.isValid(tpwin)) {
                    result = tpwin.getDocument();
                }

                if (TP.isValid(result)) {
                    return this.$getResourceResult(request,
                                                    result,
                                                    async,
                                                    filter);
                }
                return;

            default:
                break;
        }
    }

    //  fallthrough, our goal here is to see if the reference is something
    //  simple like a memory reference via tibet:///objID etc. so we want to
    //  make sure we use the target, or win, or the current window as our
    //  object and the pointer or path if pointer is empty (which it will be
    //  if we're looking at a simple object reference
    result = TP.objectValue(result || win || window, pointer || path);

    return this.$getResourceResult(request, result, async, filter);
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('getPrimaryURI',
function() {

    /**
     * @method getPrimaryURI
     * @summary Returns the actual resource URI used for content access. This
     *     may be the receiver or it may be the URI referencing the primary
     *     resource data for the receiver if the receiver has a fragment, or it
     *     may be an "embedded" URI in the case of schemes which support
     *     embedding URIs such as tibet:.
     * @returns {TP.uri.TIBETURL} The receiver's primary resource URI.
     */

    //  TIBET URLs with no canvas are effectively simply aliases to the
    //  concrete URI.
    if (TP.isEmpty(this.getCanvasName())) {
        return this.getConcreteURI().getPrimaryURI();
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('getResource',
function(aRequest) {

    /**
     * @method getResource
     * @summary Returns a receiver-specific object representing the "secondary"
     *     resource being accessed (i.e. the resource referenced by the base
     *     resource path subset identified by any fragment portion. If there is
     *     no fragment this method returns the same value as
     *     $getPrimaryResource()).
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} A TP.sig.Response created with the requested
     *     content set as its result.
     */

    if (TP.isEmpty(this.getCanvasName())) {
        return this.getConcreteURI().getResource(aRequest);
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('$getResourceResult',
function(request, result, async, filter) {

    /**
     * @method $getResourceResult
     * @summary Handles common result processing for sync/async results.
     * @param {TP.sig.Request} request The original request being processed.
     * @param {Object} result The result data for the request.
     * @param {Boolean} async Whether the request is aynchronous.
     * @param {Boolean} filter True if the resource result will be used directly
     *     and should be filtered to match any resultType definition found in
     *     the request. The default is false.
     * @returns {TP.sig.Response} A TP.sig.Response created with the resource's
     *     content set as its result.
     */

    var resource,
        response;

    resource = result;

    if (TP.isValid(resource)) {
        if (TP.isTrue(filter)) {
            resource = this.$getFilteredResult(resource, request, false);
        }

        if (!this.isLoaded()) {
            this.$setPrimaryResource(resource, request);
        }
    }

    response = request.getResponse(resource);
    request.complete(resource);

    return response;
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('getURIParts',
function() {

    /**
     * @method getURIParts
     * @summary Returns the URI in split form.
     * @returns {String[]} The split parts.
     */

    var parts,
        uri;

    parts = this.$get('uriParts');
    if (TP.notEmpty(parts)) {
        return parts;
    }

    uri = this.$get('uri');

    //  Multiple choices here. May be tibet:, may by expanded.
    if (uri.indexOf('tibet:') === 0) {
        parts = uri.match(TP.regex.TIBET_URL_SPLITTER);
        this.$set('uriParts', parts);
    } else {
        parts = uri.match(TP.regex.URL_SPLITTER);
        this.$set('uriParts', parts);
    }

    return parts;
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('getWatched',
function() {

    /**
     * @method getWatched
     * @summary Returns whether the URI is watched or not. For TIBETURLs, this
     *     passes through to the concrete URI's 'watched' property.
     * @returns {Boolean} Whether or not the URI is watched.
     */

    return this.getConcreteURI().getWatched();
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('$parseSchemeSpecificPart',
function(schemeSpecificString) {

    /**
     * @method $parseSchemeSpecificPart
     * @summary Parses inbound URI string content in a fashion specific to the
     *     scheme(s) being managed by the receiver.
     * @param {String} schemeSpecificString A String containing the
     *     "scheme-specific-part" of a URI.
     * @returns {TP.core.Hash} The parsed URI 'components'.
     */

    //  TODO:   replace with logic from getID() and related parsing.
    this.callNextMethod();

    return;
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('httpConnect',
function(aRequest) {

    /**
     * @method httpConnect
     * @summary Uses the receiver as a target URI and invokes an HTTP CONNECT
     *     with aRequest.
     * @param {TP.sig.Request} aRequest The original request being processed.
     * @returns {TP.sig.Response} The request's response object.
     */

    if (this.isHTTPBased()) {
        return TP.httpConnect(this.asString(), aRequest);
    } else {
        this.raise('TP.sig.UnsupportedOperation', this.asString());
    }
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('httpDelete',
function(aRequest) {

    /**
     * @method httpDelete
     * @summary Uses the receiver as a target URI and invokes an HTTP DELETE
     *     with aRequest.
     * @param {TP.sig.Request} aRequest The original request being processed.
     * @returns {TP.sig.Response} The request's response object.
     */

    if (this.isHTTPBased()) {
        return TP.httpDelete(this.asString(), aRequest);
    } else {
        this.raise('TP.sig.UnsupportedOperation', this.asString());
    }
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('httpGet',
function(aRequest) {

    /**
     * @method httpGet
     * @summary Uses the receiver as a target URI and invokes an HTTP GET
     *     with aRequest.
     * @param {TP.sig.Request} aRequest The original request being processed.
     * @returns {TP.sig.Response} The request's response object.
     */

    if (this.isHTTPBased()) {
        return TP.httpGet(this.asString(), aRequest);
    } else {
        this.raise('TP.sig.UnsupportedOperation', this.asString());
    }
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('httpHead',
function(aRequest) {

    /**
     * @method httpHead
     * @summary Uses the receiver as a target URI and invokes an HTTP HEAD
     *     with aRequest.
     * @param {TP.sig.Request} aRequest The original request being processed.
     * @returns {TP.sig.Response} The request's response object.
     */

    if (this.isHTTPBased()) {
        return TP.httpHead(this.asString(), aRequest);
    } else {
        this.raise('TP.sig.UnsupportedOperation', this.asString());
    }
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('httpOptions',
function(aRequest) {

    /**
     * @method httpOptions
     * @summary Uses the receiver as a target URI and invokes an HTTP OPTIONS
     *     with aRequest.
     * @param {TP.sig.Request} aRequest The original request being processed.
     * @returns {TP.sig.Response} The request's response object.
     */

    if (this.isHTTPBased()) {
        return TP.httpOptions(this.asString(), aRequest);
    } else {
        this.raise('TP.sig.UnsupportedOperation', this.asString());
    }
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('httpPatch',
function(aRequest) {

    /**
     * @method httpPatch
     * @summary Uses the receiver as a target URI and invokes an HTTP PATCH
     *     with aRequest.
     * @param {TP.sig.Request} aRequest The original request being processed.
     * @returns {TP.sig.Response} The request's response object.
     */

    if (this.isHTTPBased()) {
        return TP.httpPatch(this.asString(), aRequest);
    } else {
        this.raise('TP.sig.UnsupportedOperation', this.asString());
    }
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('httpPost',
function(aRequest) {

    /**
     * @method httpPost
     * @summary Uses the receiver as a target URI and invokes an HTTP POST
     *     with aRequest.
     * @param {TP.sig.Request} aRequest The original request being processed.
     * @returns {TP.sig.Response} The request's response object.
     */

    if (this.isHTTPBased()) {
        return TP.httpPost(this.asString(), aRequest);
    } else {
        this.raise('TP.sig.UnsupportedOperation', this.asString());
    }
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('httpPut',
function(aRequest) {

    /**
     * @method httpPut
     * @summary Uses the receiver as a target URI and invokes an HTTP PUT
     *     with aRequest.
     * @param {TP.sig.Request} aRequest The original request being processed.
     * @returns {TP.sig.Response} The request's response object.
     */

    if (this.isHTTPBased()) {
        return TP.httpPut(this.asString(), aRequest);
    } else {
        this.raise('TP.sig.UnsupportedOperation', this.asString());
    }
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('httpTrace',
function(aRequest) {

    /**
     * @method httpTrace
     * @summary Uses the receiver as a target URI and invokes an HTTP TRACE
     *     with aRequest.
     * @param {TP.sig.Request} aRequest The original request being processed.
     * @returns {TP.sig.Response} The request's response object.
     */

    if (this.isHTTPBased()) {
        return TP.httpTrace(this.asString(), aRequest);
    } else {
        this.raise('TP.sig.UnsupportedOperation', this.asString());
    }
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('isDirty',
function(aFlag, shouldSignal) {

    /**
     * @method isDirty
     * @summary Returns true if the receiver's content has changed since it was
     *     last loaded from its source URI or content data without being saved.
     * @param {Boolean} aFlag The new value to optionally set.
     * @param {Boolean} [shouldSignal=false] Should changes to the value be
     *     signaled?
     * @returns {Boolean} Whether or not the content of the receiver is 'dirty'.
     */

    //  TIBET URLs with no canvas are effectively simply aliases to the
    //  concrete URI.
    if (TP.isEmpty(this.getCanvasName())) {
        return this.getConcreteURI().isDirty(aFlag, shouldSignal);
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('isLoaded',
function(aFlag) {

    /**
     * @method isLoaded
     * @summary Returns true if the receiver's content has been loaded either
     *     manually via a setContent or init, or by loading the receiver's URI
     *     location.
     * @param {Boolean} aFlag The new value to optionally set.
     * @returns {Boolean} Whether or not the content of the receiver is loaded.
     */

    //  TIBET URLs with no canvas are effectively simply aliases to the
    //  concrete URI.
    if (TP.isEmpty(this.getCanvasName())) {
        return this.getConcreteURI().isLoaded(aFlag);
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('isPrimaryURI',
function() {

    /**
     * @method isPrimaryURI
     * @summary Returns true if the receiver is a primary URI, meaning it has
     *     no fragment portion and is responsible for data.
     * @returns {Boolean} True if the receiver is a primary URI.
     */

    //  TIBET URLs with no canvas are effectively simply aliases to the
    //  content URI.
    if (TP.isEmpty(this.getCanvasName())) {
        //  When we're just an alias we obviously aren't a primary URI.
        return false;
    }

    //  If we have a canvas spec then we're a primary if we don't have a
    //  fragment, otherwise the version of this URI sans fragment is the
    //  primary.
    return !this.hasFragment();
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('processRefreshedContent',
function() {

    /**
     * @method processRefreshedContent
     * @summary Invoked when remote resource changes have been loaded to provide
     *     the receiver with the chance to post-process those changes.
     * @returns {TP.uri.TIBETURL} The receiver.
     */

    var concreteURI;

    concreteURI = this.getConcreteURI();

    if (TP.isValid(concreteURI) && concreteURI !== this) {
        return concreteURI.processRefreshedContent();
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('register',
function() {

    /**
     * @method register
     * @summary Registers the instance under a common key.
     */

    TP.uri.URI.registerInstance(this, TP.uriInTIBETFormat(this.getLocation()));

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('load',
function(aRequest) {

    /**
     * @method load
     * @summary For this type, this method loads the receiver's concrete URI.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    var concreteURI;

    concreteURI = this.getConcreteURI();

    if (TP.isValid(concreteURI) && concreteURI !== this) {
        return concreteURI.load(aRequest);
    }
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('delete',
function(aRequest) {

    /**
     * @method delete
     * @summary For this type, this method deletes the receiver's concrete URI.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    var concreteURI;

    concreteURI = this.getConcreteURI();

    if (TP.isValid(concreteURI) && concreteURI !== this) {
        return concreteURI.delete(aRequest);
    }
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('save',
function(aRequest) {

    /**
     * @method save
     * @summary For this type, this method saves the receiver's concrete URI.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    var concreteURI;

    concreteURI = this.getConcreteURI();

    if (TP.isValid(concreteURI) && concreteURI !== this) {
        return concreteURI.save(aRequest);
    }
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('setWatched',
function(shouldBeWatched) {

    /**
     * @method setWatched
     * @summary Sets whether the URI is watched or not. For TIBETURLs, this
     *     passes through to the concrete URI's 'watched' property.
     * @param {Boolean} shouldBeWatched Whether the URI should be watched or
     *     not.
     * @returns {TP.uri.TIBETURL} The receiver.
     */

    return this.getConcreteURI().setWatched(shouldBeWatched);
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('$setPrimaryResource',
function(aResource, aRequest) {

    /**
     * @method $setPrimaryResource
     * @summary Sets the receiver's resource object, the object TIBET will
     *     treat as the primary resource for any subsequent processing.
     * @param {Object} aResource The resource object to assign.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
     *     optional parameters.
     * @returns {TP.uri.TIBETURL|TP.sig.Response} The receiver or a
     *     TP.sig.Response when the resource must be acquired in an async
     *     fashion prior to setting any fragment value.
     */

    var parts;

    parts = this.getURIParts();

    //  If the receiver has a non-empty canvas name, but an empty URL and empty
    //  fragment, then grab the Window matching the canvas name and use that as
    //  the resource. Otherwise, we end up setting a #document node for a
    //  TIBETURL that should be pointing at a Window.
    if (TP.notEmpty(parts.at(TP.uri.TIBETURL.CANVAS_INDEX)) &&
        TP.isEmpty(parts.at(TP.uri.TIBETURL.URL_INDEX)) &&
        TP.isEmpty(parts.at(TP.uri.TIBETURL.FRAGMENT_INDEX))) {

        return this.callNextMethod(
            TP.sys.getWindowById(parts.at(TP.uri.TIBETURL.CANVAS_INDEX)),
            aRequest);
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('updateHeaders',
function(headerData) {

    /**
     * @method updateHeaders
     * @summary TIBET URLs containing valid resource URIs respond to this
     *     method by updating the headers for that URI.
     * @param {Object} headerData A string, hash, or request object containing
     *     header data.
     * @returns {TP.uri.TIBETURL} The receiver.
     */

    //  TIBET URLs with no canvas are effectively simply aliases to the
    //  concrete URI.
    if (TP.isEmpty(this.getCanvasName())) {
        return this.getConcreteURI().updateHeaders(headerData);
    }

    //  No concept of headers for a UI target, just return.
    return this;
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('getRequestedResource',
function(aRequest) {

    /**
     * @method getRequestedResource
     * @summary TIBET URLs containing valid resource URIs respond to this
     *     method by updating the content cache for that URI.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {Object} The resource stored in the cache on completion.
     */

    var url;

    //  if we're just an alias for a concrete URL then we continue to look like
    //  a proxy for that reference in string form
    if ((url = this.getPrimaryURI()) !== this) {
        return url.getRequestedResource(aRequest);
    }

    if (TP.isValid(aRequest)) {
        return this.$getFilteredResult(this.$get('resource'), aRequest);
    } else {
        return this.$get('resource');
    }
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('watch',
function(aRequest) {

    /**
     * @method watch
     * @summary Watches for changes to the URLs remote resource, if the server
     *     that is supplying the remote resource notifies us when the URL has
     *     changed. For TIBETURLs, this passes through to the concrete URI's
     *     'watched' property.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    return this.getConcreteURI().watch(aRequest);
});

//  ------------------------------------------------------------------------

TP.uri.TIBETURL.Inst.defineMethod('unwatch',
function(aRequest) {

    /**
     * @method unwatch
     * @summary Removes any watches for changes to the URLs remote resource. See
     *     this type's 'watch' method for more information. For TIBETURLs, this
     *     passes through to the concrete URI's 'watched' property.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    return this.getConcreteURI().unwatch(aRequest);
});

//  ========================================================================
//  TP.uri.URIHandler
//  ========================================================================

/**
 * @type {TP.uri.URIHandler}
 * @summary TP.uri.URIHandler provides a top-level supertype for URI-specific
 *     handler classes.
 * @description When TIBET attempts to operate on a URI for load or save
 *     operations it first rewrites the URI and then directs the URI/operation
 *     pair to a handler type. The handler types are responsible for managing
 *     the URI's data in a scheme-specific way that can also respect request and
 *     URI parameter content as needed. One reason for URI handlers in TIBET is
 *     construction of stubs/mocks for web services testing and parallel
 *     development processes since they allow you to swap in a set of test
 *     handler types which simulate real operations.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('uri.URIHandler');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.uri.URIHandler.Type.defineMethod('isWatchableURI',
function(targetURI) {

    /**
     * @method isWatchableURI
     * @summary Tests a URI against include/exclude filters to determine if
     *     changes to the URI should be considered for processing.
     * @description This is the supertype of all URI handlers and at this type
     *     level, this method always returns false.
     * @param {String|TP.uri.URI} targetURI The URI to test.
     * @returns {Boolean} This method always returns false at this type leve.
     */

    return false;
});

//  ------------------------------------------------------------------------

TP.uri.URIHandler.Type.defineMethod('load',
function(targetURI, aRequest) {

    /**
     * @method load
     * @summary Loads URI data content, returning the TP.sig.Response object
     *     used to manage the low-level service response.
     * @param {TP.uri.URI} targetURI The URI to load. Note that this call is
     *     typically made via the load call of a URI and so rewriting and
     *     routing have already occurred.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The response.
     */

    //  DB, File and HTTP urls have their own handlers. This default handler
    //  is typically leveraged only by javascript: and urn: resources whose
    //  data isn't really "loaded" from a particular resource location.

    return targetURI.$getPrimaryResource(aRequest);
});

//  ------------------------------------------------------------------------

TP.uri.URIHandler.Type.defineMethod('delete',
function(targetURI, aRequest) {

    /**
     * @method delete
     * @summary Deletes a URI entirely, returning the TP.sig.Response object
     *     used to manage the low-level service response.
     * @param {TP.uri.URI} targetURI The URI to delete. Note that this call is
     *     typically made via the delete call of a URI and so rewriting and
     *     routing have already occurred.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The response.
     */

    var request,
        response;

    TP.todo('Implement delete for non-file/http/db urls.');

    //  DB, File and HTTP urls have their own handlers. This default handler
    //  is typically leveraged only by javascript: and urn: resources whose
    //  data isn't really deleted from a particular resource location.

    //  fake success via request/response semantics for consistency
    request = targetURI.constructRequest(aRequest);
    response = request.getResponse();

    request.complete(true);

    return response;
});

//  ------------------------------------------------------------------------

TP.uri.URIHandler.Type.defineMethod('save',
function(targetURI, aRequest) {

    /**
     * @method save
     * @summary Saves URI data content. This is the default data persistence
     *     method for most URI content.
     * @description By creating alternative URI handlers and ensuring that URI
     *     routing can find them you can alter how data is managed for different
     *     URI instances. See TP.uri.URIRewriter and TP.uri.URIMapper for more
     *     information. Important keys include 'append', 'body', and 'backup',
     *     which define whether this save should append or write new content,
     *     what content is being saved, and whether a backup should be created
     *     if possible (for 'file' scheme uris).
     * @param {String|TP.uri.URI} targetURI A target URI.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The response.
     */

    var request,
        response;

    //  DB, File and HTTP urls have their own handlers. This default handler
    //  is typically leveraged only by javascript: and urn: resources whose
    //  data isn't really "saved" to a particular resource location.

    //  fake success via request/response semantics for consistency
    request = targetURI.constructRequest(aRequest);
    response = request.getResponse();

    request.complete(true);

    return response;
});

//  ========================================================================
//  TP.uri.URIRewriter
//  ========================================================================

/**
 * @type {TP.uri.URIRewriter}
 * @summary TP.uri.URIRewriter processes any uri.map.*.rewrite entries which
 *     match a particular URI based on that map entry's pattern value. This
 *     rewrite capability allows TIBET's URIs to work more like "keys" than
 *     "values". Rewrite ability is limited to simple URI "part substitution"
 *     by default. To perform more advanced operations you can create your own
 *     rewriter(s) or simply override the rewrite method of the desired URI.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('uri.URIRewriter');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.uri.URIRewriter.Type.defineMethod('rewrite',
function(aURI, aRequest) {

    /**
     * @method rewrite
     * @summary Rewrites the receiver based on any uri.map configuration data
     *     which matches the URI. The rewrite is limited to replacing specific
     *     portions of the uri with fixed strings.
     * @param {TP.uri.URI|String} aURI The URI to rewrite.
     * @param {TP.sig.Request} [aRequest] An optional request whose values may
     *     inform the rewrite.
     * @returns {TP.uri.URI} The true URI for the resource.
     */

    var uri,
        map,
        rewrites,
        str,
        scheme,
        ssp,
        parts,
        newuri;

    uri = TP.isString(aURI) ? TP.uri.URI.construct(aURI) : aURI;

    //  Return cached rewrite if found, avoiding additional overhead.
    newuri = uri.$get('$uriRewrite');
    if (TP.isValid(newuri)) {
        return newuri;
    }

    //  the request can decline rewriting via flag...check that first
    if (TP.isValid(aRequest) && TP.isTrue(aRequest.at('no_rewrite'))) {
        return uri;
    }

    //  capture the best uri map configuration data for the URI.
    map = TP.uri.URI.$getURIMap(uri);
    if (TP.isEmpty(map)) {
        //  No mappings means we can avoid overhead in the future.
        return uri;
    }

    rewrites = map.getKeys().filter(function(key) {
        return /\.rewrite\./.test(key);
    });

    if (TP.isEmpty(rewrites)) {
        return uri;
    }

    //  Pull the URI apart using scheme-specific parsing.
    str = TP.str(uri);
    scheme = str.slice(0, str.indexOf(':'));
    ssp = str.slice(str.indexOf(':') + 1);
    parts = uri.$parseSchemeSpecificPart(ssp);
    parts.atPut('scheme', scheme);

    //  At least one rewrite property so process them, updating any named
    //  portions in the parts list with the rewrite value.
    rewrites.forEach(
        function(key) {
            var slot,
                value;

            slot = key.slice(key.lastIndexOf('.') + 1);
            value = TP.sys.cfg(key);

            parts.atPut(slot, value);
        });

    //  Build a new URI using the updated parts.
    newuri = TP.uc(parts);

    uri.$set('$uriRewrite', newuri, false);

    return newuri;
});

//  ========================================================================
//  TP.uri.URIMapper
//  ========================================================================

/**
 * @type {TP.uri.URIMapper}
 * @summary TP.uri.URIMapper types manage mapping requests for URI operations
 *     to appropriate handlers. This is somewhat analogous to server-side
 *     front-controllers which examine a URI and determine which class should be
 *     invoked to perform the actual processing. The actual action processing in
 *     TIBET is done by TP.uri.URIHandler subtypes.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('uri.URIMapper');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.uri.URIMapper.Type.defineMethod('remap',
function(aURI, aRequest) {

    /**
     * @method remap
     * @summary Locates and returns the proper TP.uri.URIHandler type for the
     *     URI and request pair provided. The handler type defaults to the type
     *     returned by the uri's getDefaultHandler method.
     * @param {TP.uri.URI} aURI The URI to map the request for.
     * @param {TP.sig.Request} aRequest The request whose values should inform
     *     the routing assignment.
     * @returns {TP.meta.uri.URIHandler} A TP.uri.URIHandler subtype type object
     *     that can handle the request for the supplied URI.
     */

    var uri,
        map,
        handler,
        type;

    uri = TP.isString(aURI) ? TP.uri.URI.construct(aURI) : aURI;

    //  the request can decline rewriting via flag...check that first
    if (TP.isValid(aRequest) && TP.isTrue(aRequest.at('no_remap'))) {
        return uri;
    }

    //  Return cached type if found, avoiding additional overhead.
    type = uri.$get('$uriHandler');
    if (TP.isValid(type)) {
        return type;
    }

    //  capture the best uri map configuration data for the URI.
    map = TP.uri.URI.$getURIMap(uri);
    if (TP.notValid(map) || TP.isEmpty(map)) {
        type = uri.$getDefaultHandler(aRequest);
        uri.$set('$uriHandler', type, false);

        return type;
    }

    handler = map.at('urihandler');
    if (TP.isEmpty(handler)) {
        type = uri.$getDefaultHandler(aRequest);
        uri.$set('$uriHandler', type, false);

        return type;
    }

    type = TP.sys.getTypeByName(handler);
    if (TP.notValid(type)) {
        TP.ifWarn() ?
            TP.warn('Unable to load handler: ' + handler) : 0;

        TP.ifTrace() && TP.$DEBUG && TP.$VERBOSE ?
            TP.trace('Returning default handler for instance.') : 0;

        type = uri.$getDefaultHandler(aRequest);
        uri.$set('$uriHandler', type, false);

        return type;
    }

    TP.ifTrace() && TP.$DEBUG && TP.$VERBOSE ?
        TP.trace('Found mapping \'' + handler + '\' for uri: ' + uri) : 0;

    //  went to some trouble to come up with this, so cache it for next time
    uri.$set('$uriHandler', type, false);

    return type;
});

//  ========================================================================
//  TP.uri.URIRouter
//  ========================================================================

/**
 * @type {TP.uri.URIRouter}
 * @summary TP.uri.URIRouter types process changes to the client URL and
 *     respond by triggering an appropriate handler either directly or
 *     indirectly via signaling. A URIRouter is typically triggered from the
 *     current application history object in response to URI changes.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('uri.URIRouter');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.uri.URIRouter.Type.defineAttribute('BEST_ROUTE_SORT',
function(a, b) {
    var aMatch,
        bMatch;

    aMatch = a.first();
    bMatch = b.first();

    //  First criteria is number of parts matches.
    if (aMatch.length > bMatch.length) {
        return -1;
    } else if (aMatch.length < bMatch.length) {
        return 1;
    } else {
        //  Second criteria is length of the full match string...but we exempt
        //  the '/.*/' pattern from this consideration since it's a universal
        //  match that should only trigger as a last resort.
        if (a.last().at('pattern').toString() === '/.*/') {
            return 1;
        } else if (b.last().at('pattern').toString() === '/.*/') {
            return -1;
        }

        if (aMatch.first().length > bMatch.first().length) {
            return -1;
        } else if (aMatch.first().length < bMatch.first().length) {
            return 1;
        } else {
            //  All else being equal last definition wins.
            return -1;
        }
    }
});

/**
 * An array of path-matching patterns to be processed coupled to a function
 * to use for translating matched URLs and any token names for parameters.
 * @type {Array<RegExp, Function, String[]>}
 */
TP.uri.URIRouter.Type.defineAttribute('processors');

/**
 * The route name to use for the "Root" or "/" route. Default is 'Home'.
 * @type {String}
 */
TP.uri.URIRouter.Type.defineAttribute('root', TP.sys.cfg('route.root', 'Home'));

/**
 * The list of route names that we've visited.
 * @type {String[]}
 */
TP.uri.URIRouter.Type.defineAttribute('visited', TP.ac());

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.uri.URIRouter.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    this.$set('processors', TP.ac());

    //  Always need a route to match "anything" as our backstop. If no routes
    //  are ever defined this routine should still produce something reasonable.
    this.definePath(/.*/, this.processMatch.bind(this));

    //  Define the root pattern route for "empty paths".
    this.definePath(/^\/$/, this.get('root'));

    //  Configure routing data from cfg() parameters.
    this.$configureRoutes();

    return;
});

//  ------------------------------------------------------------------------

TP.uri.URIRouter.Type.defineMethod('compilePattern',
function(pattern) {

    /**
     * @method compilePattern
     * @summary Converts a pattern into a fully-functional regular expression
     *     for use in route matching and returns the pattern and a list of token
     *     names to assign to matched positions. The resulting data is used to
     *     detect matching routes and to process them to ensure proper names are
     *     assigned to any token segments.
     * @param {String|RegExp} pattern The pattern to process.
     * @exception {TP.sig.InvalidParameter} When pattern isn't a String.
     * @returns {Array<String,String[]>} An array containing the pattern and
     *     zero or more string names for embedded token values being matched.
     */

    var str,
        regex,
        parts,
        mappedParts,
        names;

    if (TP.isRegExp(pattern)) {
        return TP.ac(pattern, TP.ac());
    }

    if (!TP.isString(pattern)) {
        this.raise('InvalidParameter', pattern);
    }

    names = TP.hc();

    if (pattern.charAt(0) === '/') {
        if (pattern.last() === '/') {
            regex = RegExp.construct(pattern);
            if (TP.notValid(regex)) {
                this.raise('InvalidRegExp', pattern);
            }
            return TP.ac(regex, names);
        }
        str = pattern.slice(1);
    } else {
        str = pattern;
    }

    //  TODO:   need to parse rather than split to avoid embedded / impact. Done
    //  properly we could potentially mix regex, token, and "normal" segments.
    parts = str.split('/');

    mappedParts = parts.map(
            function(item, index) {
                var re,
                    reParts;

                //  Check for a token pattern of this name.
                if (item.charAt(0) === ':') {

                    names.atPut(index, item.slice(1));
                    re = TP.sys.cfg('route.tokens.' + item.slice(1));

                    if (TP.notEmpty(re)) {
                        reParts = TP.stringRegExpComponents(re);
                        return '(' + reParts.first() + ')';
                    } else {
                        return '([^/]*?)';
                    }
                }

                //  NOTE we capture each item, even when static, to keep
                //  indexing and name construction functional.
                return '(' + item + ')';
            });

    //  don't put leading / on if pattern didn't have it...
    str = pattern.charAt(0) === '/' ? '\\/' : '';
    str += mappedParts.join('\\/');

    regex = RegExp.construct(str);
    if (TP.notValid(regex)) {
        this.raise('InvalidRegExp', str);
    }

    return TP.ac(regex, names);
});

//  ------------------------------------------------------------------------

TP.uri.URIRouter.Type.defineMethod('$configureRoutes',
function() {

    /**
     * @method $configureRoutes
     * @summary Configures the routes from the tokens and paths that are in the
     *     cfg() data. If the route cfg() data is altered, this method should be
     *     called to update internal structures.
     * @returns {TP.meta.uri.URIRouter} The receiver.
     */

    var cfg,
        thisref,
        keys;

    thisref = this;

    //  process config-based token definitions
    cfg = TP.sys.cfg('route.tokens');
    if (TP.notEmpty(cfg)) {
        keys = TP.keys(cfg);
        keys.forEach(
                function(key) {
                    var val;

                    val = cfg.at(key);
                    thisref.defineToken(key.replace('route.tokens.', ''), val);
                });
    }

    //  process config-based path-to-routename definitions
    cfg = TP.sys.cfg('route.paths');
    if (TP.notEmpty(cfg)) {
        keys = TP.keys(cfg);
        keys.forEach(
                function(key) {
                    var val;

                    val = cfg.at(key);
                    thisref.definePath(key.replace('route.paths.', ''), val);
                });
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URIRouter.Type.defineMethod('definePath',
function(pattern, signalOrProcessor, processor) {

    /**
     * @method definePath
     * @summary Expresses interest in a specific URL pattern, optionally
     *     defining a function used to produce the signal and payload values to
     *     be fired when the pattern is matched by the routing engine.
     * @param {String|RegExp} pattern The string or regular expression to match.
     * @param {String|Function} signalOrProcessor Either a signal name to use
     *     for the path when matched, or a path processor function.
     * @param {Function} [processor=this.processMatch] A function taking a path,
     *     match result, and token names which should function as a replacement
     *     for the default processMatch function of the router for this path.
     * @exception {TP.sig.InvalidRoute} When pattern isn't either a RegExp or
     *     cannot be processed from the supplied pattern String.
     * @exception {TP.sig.InvalidParameter} When signalOrProcessor isn't a
     *     String or a Function.
     * @returns {Object} A route entry consisting of pattern, signal, processor,
     *     and parameter names/positions.
     */

    var result,
        regex,
        names,
        signal,
        func,
        entry,
        processors,
        index;

    //  We need patterns to be in regex form and to watch for tokens so we
    //  process any string values into regular expression form.
    result = this.compilePattern(pattern);
    regex = result.at(0);
    names = result.at(1);

    //  Exception will have raised during processing, just exit.
    if (TP.notValid(regex)) {
        return this.raise('InvalidRoute',
            'Unable to produce RegExp for path/pattern ' + pattern);
    }

    //  Check param 2 for either signal name or processor function.
    if (TP.isString(signalOrProcessor)) {
        signal = signalOrProcessor;
        func = processor;
    } else if (TP.isFunction(signalOrProcessor)) {
        func = signalOrProcessor;
    } else if (TP.isValid(signalOrProcessor)) {
        return this.raise('InvalidParameter',
            'Should provide signal name or path processor function: ' +
            signalOrProcessor);
    }

    //  Default the processor function to our standard one.
    if (TP.notValid(func)) {
        func = this.processMatch.bind(this);
    }

    //  NOTE we push the new route onto the front so we iterate from most recent
    //  to oldest route definition.
    entry = TP.hc('pattern', regex,
                    'signal', signal,
                    'processor', func,
                    'parameters', names);

    //  If a pattern is already identical in the list then replace it, otherwise
    //  push the new pattern into place.
    processors = this.get('processors');
    index = TP.NOT_FOUND;
    processors.some(
            function(item, i) {
                if (TP.equal(item.at('pattern'), regex)) {
                    index = i;
                    return true;
                }

                return false;
            });

    if (index !== TP.NOT_FOUND) {
        processors.atPut(index, entry);
    } else {
        processors.unshift(entry);
    }

    return entry;
});

//  ------------------------------------------------------------------------

TP.uri.URIRouter.Type.defineMethod('defineToken',
function(token, pattern) {

    /**
     * @method defineToken
     * @summary Associates a token name with a pattern used to match the value
     *     for that token. Any time that token is used in a route the pattern
     *     will be substituted for the token and any matched value will be
     *     provided to the route under the token name.
     * @param {String} token The name of the token being described.
     * @param {String|RegExp} pattern The string or regular expression to match.
     * @exception {TP.sig.InvalidToken} When the supplied token isn't a String.
     * @exception {TP.sig.InvalidPattern} When the supplied pattern isn't a
     *     RegExp.
     * @returns {TP.meta.uri.URIRouter} The receiver.
     */

    var regex;

    if (!TP.isString(token)) {
        this.raise('InvalidToken', token);
    }

    regex = pattern;
    if (!TP.isRegExp(regex)) {
        regex = TP.rc(pattern);
        if (!TP.isRegExp(regex)) {
            this.raise('InvalidPattern', pattern);
        }
    }

    TP.sys.setcfg('route.tokens.' + token, TP.str(regex));

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URIRouter.Type.defineMethod('getLastRoute',
function() {

    /**
     * @method getLastRoute
     * @summary Returns the last route the application was set to. If the
     *     application hasn't yet been set to a specific route this method
     *     returns the 'route.root' or 'root' value as the default value.
     * @returns {String} The route, or route.root if no last route exists.
     */

    var hist,
        loc;

    hist = TP.sys.getHistory();
    loc = hist.getLastLocation();

    if (TP.notValid(loc)) {
        return this.get('root');
    }

    return this.getRoute(loc);
});

//  ------------------------------------------------------------------------

TP.uri.URIRouter.Type.defineMethod('getRoute',
function(aURI) {

    /**
     * @method getRoute
     * @summary Returns the currently active route, if any. Note that when the
     *     application is currently on the home page the route is set by the
     *     root property even though that value will not be visible in the URI
     *     fragment path. On any other URI if the fragment path is empty the
     *     route is empty.
     * @param {TP.uri.URI|String} [aURI=top.location] The URI to test. Defaults
     *     to the value of TP.uriNormalize(top.location.toString()).
     * @returns {String|undefined} The route name or empty string.
     */

    var route,
        path,
        home,
        url;

    if (TP.isValid(aURI)) {
        url = TP.uriNormalize(TP.str(aURI));
    } else {
        url = TP.uriNormalize(TP.sys.getHistory().getLocation());
    }

    path = TP.uriFragmentPath(url);

    //  Ignore fragments that don't start with a /, they're anchors not routes.
    if (path && path.charAt(0) !== '/') {
        return;
    }

    if (path === '/' || TP.isEmpty(path)) {

        //  Compare against home page to see if this is a match.
        home = TP.uriExpandPath(TP.sys.getHomeURL());
        if (TP.uriHead(TP.uriExpandHome(url)) === TP.uriHead(home)) {
            route = this.get('root') || 'Home';
        }

    } else {

        //  Process the route against any registered route matchers.
        route = this.processRoute(path);
        if (TP.notEmpty(route)) {
            //  Route matches are returned as an array containing the route name
            //  and a hash of route parameters. We just want the name for now.
            return route.at(0);
        }

        //  If not matched just remove any leading '/'. Hopefully the route is
        //  simple enough to pass.
        route = path.charAt(0) === '/' ? path.slice(1) : path;
    }

    return route;
});

//  ------------------------------------------------------------------------

TP.uri.URIRouter.Type.defineMethod('getRouteSignalName',
function(hash, usemap) {

    /**
     * @method getRouteSignalName
     * @summary Produces the best signal name from a processor result hash (the
     *     return value from processMatch/processResult). This means looking for
     *     a specified name and optionally any remapping of that name in the
     *     configuration route.map.{route} entries if any.
     * @param {TP.core.Hash} hash The result hash from a route processor
     *     function. Normally has 'route', 'signal', and 'parameters' keys.
     * @param {Boolean} usemap Should mapping be used? Default is true.
     * @returns {String} The signal name.
     */

    var route,
        routeKey,
        config,
        signame,
        configInfo,
        info;

    if (TP.notValid(hash)) {
        return this.raise('InvalidParameter', hash);
    }

    //  Use explicit signal name or synthetic name plus 'Route' suffix.
    signame = hash.at('signal');
    signame = TP.ifInvalid(signame, hash.at('route') + 'Route');

    if (TP.isFalse(usemap)) {
        return signame;
    }

    //  If usemap wasn't turned off explicitly see if the name provided has been
    //  remapped in the route maps, if any.
    route = hash.at('route');
    routeKey = 'route.map.' + route;
    config = TP.sys.cfg(routeKey);

    if (TP.notEmpty(config)) {
        if (TP.isString(config)) {
            configInfo = TP.json2js(TP.reformatJSToJSON(config));
            if (TP.isEmpty(configInfo)) {
                TP.error('InvalidObject',
                    'Unable to build config data from entry: ' + config);
                return this.getRouteSignalName(hash, false);
            }
            TP.sys.setcfg(routeKey, configInfo);
        } else {
            configInfo = config;
        }
    }

    if (TP.isEmpty(configInfo)) {
        return signame;
    }

    info = configInfo.at(routeKey + '.signal');
    info = TP.ifInvalid(info, configInfo.at('signal'));
    if (TP.notEmpty(info)) {
        signame = info;
    }

    return signame;
});

//  ------------------------------------------------------------------------

TP.uri.URIRouter.Type.defineMethod('getRouteControllerType',
function() {

    /**
     * @method getRouteControllerType
     * @summary Returns the route controller type that will be used for whatever
     *     the receiver considers to be the current route.
     * @description The controller type is computed thusly:
     *     1. If the current route doesn't have a route map entry, the
     *     TP.core.RouteController type will be returned.
     *     2. If the route map entry has a '.controller' entry, then that will
     *     be used as the type name.
     *     3. If the route map entry has no '.controller', then a type name will
     *     be computed by using 'APP.' + the project name + '.' + the route in
     *     title case + 'Controller'.
     *     4. If no type object can be found by using the type name from the
     *     above steps, TP.core.RouteController will be returned.
     * @returns {TP.meta.*|TP.meta.core.Controller} A computed controller type.
     */

    var route,
        routeKey,
        config,
        configInfo,
        controllerName,
        controller,
        appDefault,
        defaulted;

    controllerName = 'APP.' + TP.sys.cfg('project.name') + '.' +
        'RouteController';
    appDefault = TP.sys.getTypeByName(controllerName);

    route = this.getRoute();
    if (TP.isEmpty(route)) {
        return TP.ifInvalid(appDefault, TP.core.RouteController);
    }

    //  See if the value is a route configuration key.
    routeKey = 'route.map.' + route;
    config = TP.sys.cfg(routeKey);

    if (TP.isEmpty(config)) {
        //  NOTE we effectively skip using 'map' here and roll up such that the
        //  later lookup ends up being for 'route.controller' as a very
        //  high-level generic controller lookup.
        routeKey = 'route';
        config = TP.sys.cfg(routeKey);
        if (TP.isEmpty(config)) {
            return TP.ifInvalid(appDefault, TP.core.RouteController);
        }
    }

    //  If we got real config data, then turn it into real JSON if it isn't
    //  already.
    if (TP.isString(config)) {
        configInfo = TP.json2js(TP.reformatJSToJSON(config));
        if (TP.isEmpty(configInfo)) {
            this.raise('InvalidObject',
                        'Unable to build config data from entry: ' + config);

            return TP.ifInvalid(appDefault, TP.core.RouteController);
        }
        TP.sys.setcfg(routeKey, configInfo);
    } else {
        configInfo = config;
    }

    //  Try to obtain a controller type name
    controllerName = configInfo.at(routeKey + '.controller');
    controllerName = TP.ifInvalid(controllerName, configInfo.at('controller'));

    //  If there was no controller type name entry, default one by concatenating
    //  'APP' with the project and route name and the word 'Controller'.
    if (TP.isEmpty(controllerName)) {
        controllerName = 'APP.' +
                            TP.sys.cfg('project.name') +
                            '.' +
                            route.asTitleCase() +
                            'Controller';
        defaulted = true;
    }

    //  See if the controller is a type name.
    controller = TP.sys.getTypeByName(controllerName);

    if (TP.notValid(controller)) {
        //  Note here how we only warn if the controller name was specified and
        //  not generated here.
        TP.ifWarn() && !defaulted ?
            TP.warn('InvalidRouteController', controllerName, 'for',
                routeKey + '.controller') : 0;
    }

    return TP.ifInvalid(controller,
        TP.ifInvalid(appDefault, TP.core.RouteController));
});

//  ------------------------------------------------------------------------

TP.uri.URIRouter.Type.defineMethod('processMatch',
function(signal, match, names) {

    /**
     * @method processMatch
     * @summary Invoked when a defined path is matched. This function provides a
     *     default processor for definePath which can produce a signal
     *     name and payload for the majority of use cases.
     * @param {String} [signal] An optional signal name to be used.
     * @param {String[]} match The "match" Array returned by RegExp match()
     *     calls. The first slot is the "full match" while any parenthesized
     *     capture portions will populate slots 1 through N.
     * @param {String[]} names An array of token names for any named path
     *     segments in the pattern which matched the path.
     * @returns {Array<String, TP.core.Hash>} An ordered pair containing the
     *     route name and hash containing parameters from the match.
     */

    var parts,
        route,
        name,
        params;

    params = TP.hc();

    //  Only a full match value, no parameterized/captured sections.
    if (match.getSize() === 1) {

        route = match.at(0).slice(1);
        params.atPut('route', route);
        parts = route.split('/');

        name = parts.reduce(
                function(prev, current, index, array) {

                    //  Treat identifiers as signal name segments.
                    if (TP.regex.JS_IDENTIFIER.test(current)) {
                        return prev + current.asTitleCase();
                    }

                    //  Treat everything else with a real value like an
                    //  argument.
                    params.atPut('arg' + params.getSize(), current);

                    return prev;

                },
                '');
    } else {

        //  Throw away the full-match portion. This will also shift the list so
        //  our naming indexes should resolve correctly.
        match.shift();

        name = match.reduce(
                function(prev, current, index, array) {
                    var token;

                    token = names.at(index);
                    if (TP.notEmpty(token)) {
                        //  Found a named parameter segment.
                        params.atPut(token, current);
                    } else if (TP.regex.JS_IDENTIFIER.test(current)) {
                        return prev + current.asTitleCase();
                    } else {
                        params.atPut('arg' + params.getSize(), current);
                    }
                    return prev;

                },
                '');
    }

    return TP.hc('route', TP.ifEmpty(signal, name),
        'signal', signal, 'parameters', params);
});

//  ------------------------------------------------------------------------

TP.uri.URIRouter.Type.defineMethod('processRoute',
function(path) {

    /**
     * @method processRoute
     * @summary Processes a route, searching for the best matching route.
     *     If the route matches a path pattern the associated processor function
     *     is invoked to convert the route into a signal name/payload pair.
     * @param {String} path The URL fragment path segment (route) to process.
     * @exception {TP.sig.RouteProcessingException} When the system throws an
     *     Error by attempting to navigate to the route.
     * @returns {Array<String, TP.core.Hash>|undefined} The signal name/payload
     *     pair.
     */

    var processors,
        matches,
        best,
        match,
        entry,
        signal,
        processor,
        parameters,
        result;

    processors = this.get('processors');
    matches = TP.ac();

    //  First step is finding all patterns that match the inbound
    //  fragment/route.
    processors.forEach(
            function(mapping) {
                var pattern,
                    arr;

                pattern = mapping.at('pattern');
                arr = pattern.match(path);

                if (TP.notEmpty(arr)) {
                    matches.push(TP.ac(arr, mapping));
                }
            });

    //  TODO:   make the sort here configurable. Maybe by weight but maybe by
    //          simple definition order, etc.
    matches.sort(TP.uri.URIRouter.BEST_ROUTE_SORT);

    best = matches.first();
    if (TP.isEmpty(best)) {
        return;
    }

    match = best.first();
    entry = best.last();

    signal = entry.at('signal');
    processor = entry.at('processor');
    parameters = entry.at('parameters');

    try {
        result = processor(signal, match, parameters);
    } catch (e) {
        this.raise('RouteProcessingException', e);
    }

    return result;
});

//  ------------------------------------------------------------------------

TP.uri.URIRouter.Type.defineMethod('route',
function(aURIOrPushState, aDirection) {

    /**
     * @method route
     * @summary Checks a URI for potentially routable changes and triggers the
     *     appropriate response to any changes found. This method is invoked in
     *     response to popstate events and whenever TIBET is asked to push or
     *     replace state on the native history object.
     * @param {String|Object} aURIOrPushState The full URI which should be
     *     processed for routing or a push state object containing that URI.
     *     Keys of interest in the push state are 'url' and 'pushed'.
     * @param {String} [aDirection] An optional direction hint provided by some
     *     invocation pathways. It is always used when available.
     * @fires {RouteEnter} If the URI has changed the fragment path (route).
     * @fires {RouteExit} If the URI has changed the fragment path (route).
     * @fires {RouteFinalize} If the URI has changed the fragment path (route).
     * @exception {TP.sig.InvalidOperation} When an operation cannot be computed
     *     by comparing the old route parameters from the new route parameters.
     * @returns {TP.meta.uri.URIRouter} The receiver.
     */

    var history,
        direction,
        last,
        lastParts,
        state,
        url,
        urlParts,
        canvas,
        fragPath,
        result,
        signame,
        payload,
        type,
        signal,
        lastFragmentPath,
        lastRoute,
        guard,
        home,
        routeKey,
        config,
        configInfo,
        reroute,
        deeproot,
        urlParams,
        lastParams,
        paramDiff,
        bootParams,
        route,
        visited;

    //  Report what we're being asked to route.
    if (TP.sys.cfg('log.routes')) {
        TP.debug('route(\'' + TP.str(aURIOrPushState) + '\');');
    }

    history = TP.sys.getHistory();

    //  ---
    //  Determine direction so we know what to compare
    //  ---

    direction = TP.ifEmpty(aDirection, history.get('direction'));
    switch (direction) {
        case 'back':
            last = TP.ifEmpty(history.get('lastURI'),
                                history.getNextLocation());
            break;
        case 'forward':
            last = TP.ifEmpty(history.get('lastURI'),
                                history.getLastLocation());
            break;
        case 'replace':
            last = history.get('lastURI');
            break;
        default:
            //  Oops. Shouldn't be here...except if we're starting up.
            if (TP.sys.hasStarted()) {
                TP.warn('Invalid route direction.');
            }
            break;
    }

    //  Clear the direction and URI so we have to reset/recompute with each
    //  change and don't end up working from obsolete data.
    history.set('direction', null);
    history.set('lastURI', null);

    if (TP.isString(aURIOrPushState)) {
        url = aURIOrPushState;
        state = {};
    } else {
        state = aURIOrPushState;
        url = state.url;
    }

    //  For our expansion testing and history tracking we want a fully-expanded
    //  and normalized version of the URL here.
    url = TP.str(url);
    url = TP.uriExpandPath(url);
    url = decodeURIComponent(url);

    //  The pushState handlers in TIBET don't push homepage URLs directly, they
    //  always short to '/' or the launch URL. We need to actually setLocation
    //  with a real URI for the related home page tho so we convert here.
    if (TP.notEmpty(last) &&
        (TP.$$nested_loader || url === '/' ||
            TP.uriHead(url) === TP.uriHead(TP.sys.getLaunchURL()))) {

        //  Clear any flag regarding loading the index or other loader page.
        //  Those are all considered variations on 'load the home page'.
        TP.$$nested_loader = false;

        url = TP.uriExpandHome(url);

        //  Normalize last as well so we can compare apples to apples.
        last = TP.uriExpandHome(last);
    }

    //  No change? No work to do.
    if (last === url) {
        return this;
    }

    //  ---
    //  Compare paths to determine what aspect(s) changed
    //  ---

    urlParts = TP.uriDecompose(url);
    if (TP.notEmpty(last)) {
        lastParts = TP.uriDecompose(last);
    }

    //  ---
    //  If root domain change we reboot...normally.
    //  ---

    if (TP.isValid(lastParts) &&
        urlParts.at('root') !== lastParts.at('root')) {
        //  TODO: could verify subdomains etc. here.
        if (TP.uriNormalize(top.location.toString()) !== url) {
            top.location = url;
        }

        return this;
    }

    //  ---
    //  If base params changed only the server can determine what to do.
    //  ---

    if (TP.isValid(lastParts) &&
        urlParts.at('baseParams') !== lastParts.at('baseParams')) {
        if (TP.uriNormalize(top.location.toString()) !== url) {
            top.location = url;
        }

        return this;
    }

    //  ---
    //  If fragment (boot) params change we reboot...sometimes
    //  ---

    if (TP.isValid(lastParts) &&
            urlParts.at('fragmentParams') !== lastParts.at('fragmentParams')) {

        //  Goal is to see if any boot parameters actually changed so we diff
        //  the two and then scan for keys in the diff that include boot.
        urlParams = urlParts.at('fragmentParams');
        lastParams = lastParts.at('fragmentParams');
        paramDiff = TP.hc(lastParams).deltas(TP.hc(urlParams));

        if (TP.sys.cfg('log.routes')) {
            TP.debug('client param change(\'' +
                TP.str(paramDiff) + '\');');
        }

        //  Find any boot-related key. We only need to find one to restart.
        bootParams = paramDiff.detect(
                            function(pair) {
                                return pair.first().startsWith('boot.');
                            });

        //  If a boot-related parameter changed restart, otherwise update.
        if (TP.notEmpty(bootParams)) {
            top.location = url;
        } else {
            //  If we just altered other values then use setcfg to update.
            paramDiff.perform(
                        function(triple) {
                            var operation,
                                value;

                            operation = triple.last();
                            switch (operation) {
                                case TP.INSERT:
                                    TP.sys.setcfg(triple.first(), triple.at(1));
                                    break;
                                case TP.UPDATE:
                                    TP.sys.setcfg(triple.first(), triple.at(1));
                                    break;
                                case TP.DELETE:
                                    value = triple.at(1);
                                    if (TP.isTrue(value)) {
                                        TP.sys.setcfg(triple.first(), false);
                                    } else if (TP.isFalse(value)) {
                                        TP.sys.setcfg(triple.first(), true);
                                    } else {
                                        //  No way to do this. We don't track
                                        //  "defaults".
                                        void 0;
                                    }
                                    break;
                                default:
                                    return this.raise('InvalidOperation',
                                                        operation);
                            }
                        });
        }

        return this;
    }

    //  ---
    //  If base path changed but not root domain it's a canvas uri.
    //  ---

    canvas = TP.sys.getUICanvas();

    //  Tricky part here is that we have to watch for comparisons regarding '/'
    //  and or launch with the home page. Those aren't considered "different".
    if (TP.isValid(lastParts)) {

        home = TP.uriExpandPath(TP.sys.getHomeURL());

        //  if basePath was '/' that's essentially the index/home page. We
        //  update last so a comparison below will see homepage and '/' as the
        //  same URI.
        if (TP.isEmpty(lastParts.at('basePath'))) {
            lastParts.atPut('basePath', TP.uriBasePath(home));
        }
    }

    if (TP.isValid(lastParts) &&
        urlParts.at('basePath') !== lastParts.at('basePath')) {

        //  Update the canvas if not currently displaying the proposed page.
        if (canvas.getLocation() !== TP.uriHead(url)) {
            canvas.setLocation(TP.uriHead(url));

            //  If we reset the base and we're in fragment_only mode then we
            //  need to adjust the fragment to keep up with what was pushed
            //  rather than what is in the actual URL.
            if (TP.notFalse(TP.sys.cfg('route.fragment_only'))) {
                fragPath = urlParts.at('basePath');
                if (fragPath === TP.uriBasePath(home)) {
                    fragPath = urlParts.at('fragmentPath');
                } else {
                    if (TP.notEmpty(TP.uriExtension(fragPath))) {
                        fragPath = fragPath.replace(
                                    '.' + TP.uriExtension(fragPath),
                                    '');
                    }
                }
            }
        }
    }

    if (TP.notValid(fragPath)) {
        fragPath = urlParts.at('fragmentPath');
    }

    //  ---
    //  If fragment path changed it's a route
    //  ---

    //  Run the route through our route matching process to see if there's a
    //  matcher for it.
    result = this.processRoute(fragPath);
    if (TP.notEmpty(result)) {
        route = result.at('route');
    } else {
        //  No processed result. Remove the leading '/' for checks we need to
        //  run below for type names, urls, etc.
        route = fragPath.slice(1);
    }

    if (TP.isEmpty(route)) {
        return this;
    }

    if (TP.sys.cfg('log.routes')) {
        TP.debug('checking \'' + route + '\' route configuration...');
    }

    //  See if the value is a route configuration key.
    routeKey = 'route.map.' + route;
    config = TP.sys.cfg(routeKey);

    if (TP.notEmpty(config)) {

        if (TP.sys.cfg('log.routes')) {
            TP.debug('route \'' + route + '\' mapped to: ' + TP.str(config));
        }

        if (TP.isString(config)) {
            configInfo = TP.json2js(TP.reformatJSToJSON(config));
            if (TP.isEmpty(configInfo)) {
                this.raise('InvalidObject',
                    'Unable to build config data from entry: ' + config);
                return this;
            }
            TP.sys.setcfg(routeKey, configInfo);
        } else {
            configInfo = config;
        }

        //  Check for redirection. If found, update to that route immediately.
        reroute = configInfo.at(routeKey + '.reroute');
        reroute = TP.ifInvalid(reroute, configInfo.at('reroute'));
        if (TP.notEmpty(reroute)) {
            if (reroute.charAt(0) !== '#') {
                if (reroute.charAt(0) !== '/') {
                    TP.go2('#/' + reroute);
                } else {
                    TP.go2('#' + reroute);
                }
            } else {
                TP.go2(reroute);
            }

            return this;
        }

        reroute = configInfo.at(routeKey + '.redirect');
        reroute = TP.ifInvalid(reroute, configInfo.at('redirect'));
        if (TP.notEmpty(reroute)) {
            TP.go2(reroute);

            return this;
        }

    } else {
        configInfo = TP.hc();
    }

    //  Deal with deep link issues. Not all routes can be linked directly so if
    //  this is the first route (no last route in history) it has to be one that
    //  is flagged as a deeproot.
    if (TP.notValid(last)) {

        deeproot = configInfo.at(routeKey + '.deeproot');
        deeproot = TP.ifInvalid(deeproot, configInfo.at('deeproot'));
        if (deeproot !== true) {

            //  Not a deep link? Route to the application home.
            TP.go2('/');

            //  Make sure that, either way we navigate, that the history's last
            //  valid index also gets set to 0. This way, any movement forward
            //  will be trapped.
            TP.core.History.set('lastValidIndex', 0);
        } else {

            //  The current route is a deeproot. Make sure that the history's
            //  last valid index is the same as its index.
            TP.core.History.set('lastValidIndex', TP.core.History.get('index'));
        }
    }

    //  If the route changed be sure to refresh the controller list.
    TP.sys.getApplication().refreshControllers();

    //  ---
    //  Route Signaling
    //  ---

    payload = TP.isValid(result) ? result.at('parameters') : TP.hc();

    //  Support remapping route name to a different signal, but ensure that
    //  signal follows our standard rules for signal names specific to routes
    //  unless a specific one came back from the result set earlier.
    signame = this.getRouteSignalName(result);

    //  Determine the signal type, falling back as needed since expandSignalName
    //  will return TP.sig. as a default prefix.
    type = TP.sys.getTypeByName(signame);

    //  If that type couldn't be found, try the same local signal name, but with
    //  a root namespace of 'APP.' instead of 'TP.'
    if (!TP.isType(type)) {

        //  APP.sig.*
        signame = signame.replace(/^TP\./, 'APP.');
        type = TP.sys.getTypeByName(signame);

        //  If that type couldn't be found, then change the non-root namespace
        //  from 'sig' to the name of the project.
        if (!TP.isType(type)) {
            //  APP.{project.name}.*
            signame = signame.replace(
                        /\.sig\./,
                        '.' + TP.sys.cfg('project.name') + '.');
            type = TP.sys.getTypeByName(signame);
        }
    }

    //  Build the signal instance we'll fire and set its name as needed.
    if (TP.isType(type)) {
        signal = type.construct(payload);
    } else {

        //  Couldn't find a valid signal type above, so we just use
        //  TP.sig.RouteFinalize as the type and set a 'spoofed' signal name
        //  using the same algorithm as above.
        signal = TP.sig.RouteFinalize.construct(payload);
        signame = this.getRouteSignalName(result);
        signal.setSignalName(signame);
    }

    //  For origin we use ANY since all routes are from 'top' anyway. This
    //  also helps avoid multiple dispatch for origin differences.
    signal.setOrigin(TP.ANY);

    if (TP.sys.cfg('log.routes')) {
        TP.info('Signaling: ' + signal.getSignalName() + ' with: ' +
                    TP.ifEmpty(
                        TP.str(signal.getPayload()),
                        '{}'));
    }

    payload.atPut('route', route);

    //  If there are parts of a 'last route', then use them to populate
    //  information about the last route into the signal payload.
    if (TP.notEmpty(lastParts)) {
        lastFragmentPath = lastParts.at('fragmentPath');

        //  If there was a last route fragment, then 'process' it (to provide
        //  results consistent with when it was the current route) and put that
        //  into the signal payload.
        if (TP.notEmpty(lastFragmentPath)) {
            lastRoute = this.processRoute(lastFragmentPath);
            payload.atPut('lastroute', lastRoute);
        }
    }

    //  Now, we first a series of 3 signals matching the routing sequence:

    //  Fire a RouteExit signal, using the last route that was set (this method
    //  is being executed *after* the route has been set - the browsers provide
    //  no mechanism for trapping *before* a route has been navigated to). Note
    //  here how we append 'RouteExit' onto that for consistency with routing
    //  signal naming.
    guard = TP.sig.RouteExit.construct(payload);
    guard.setSignalName(this.getLastRoute() + 'RouteExit');
    guard.fire();

    //  Fire a RouteEnter signal, using the current route that is being set.
    //  Note here how we append 'RouteEnter' onto that for consistency with
    //  routing signal naming.
    guard = TP.sig.RouteEnter.construct(payload);
    guard.setSignalName(route + 'RouteEnter');
    guard.fire();

    //  Fire the signal that we computed above, which should be an instance of
    //  either RouteFinalize or a subtype of RouteFinalize.
    signal.fire();

    //  Now that we're done servicing the route we need to capture the route in
    //  the list of visited routes. Note how we unique the list since we might
    //  have already been through here.
    visited = this.get('visited');
    visited.push(route);
    visited.unique();

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URIRouter.Type.defineMethod('setRoute',
function(aRoute) {

    /**
     * @method setRoute
     * @summary Updates the fragment path portion which defines the current
     *     route in TIBET terms. Any boot parameters on the existing URL are
     *     preserved by this call.
     * @description Routes in TIBET are signified by the "fragment path" portion
     *     of the URI which we define as the section of the URI fragment prior
     *     to any '?' which sets off the "fragment parameters" (aka boot
     *     parameters). Changes to this section of the URI result in a Route
     *     signal being fired so application logic can respond to route changes.
     * @param {String} aRoute The route information.
     * @returns {String} The route as set into TIBET's history object.
     */

    var route,
        home,
        loc,
        path,
        parts;

    //  Normalize route name ensuring it's got the leading '/' which
    //  differentiates it from an anchor when on the URL.
    route = TP.str(aRoute);
    if (route.charAt(0) !== '/') {
        route = '/' + route;
    }

    //  Normalize Home to just the root path.
    if (route === '/Home' || route === '/home') {
        route = '/';
    }

    //  Capture the page we're currently viewing in the canvas.
    loc = TP.core.History.getLocation();

    //  If we're routing home but not showing the home page we need to update.
    if (route === '/' || TP.isEmpty(route)) {

        //  Compare against home page to see if this is a match.
        home = TP.uriExpandPath(TP.sys.getHomeURL());

        if (TP.uriHead(TP.uriExpandHome(loc)) !== TP.uriHead(home)) {
            TP.sys.getHistory().pushLocation(home);

            return home;
        }
    }

    //  If we're about to set the same route don't bother.
    path = TP.uriFragmentPath(loc);
    if (route === path) {
        if (TP.sys.cfg('log.routes')) {
            TP.trace('setRoute ignoring duplicate route setting of: ' + route);
        }

        return route;
    }

    //  Rebuild a version of the current URI with the new route portion.
    parts = TP.uriDecompose(loc);
    parts.atPut('fragmentPath', route);
    route = TP.uriCompose(parts);

    TP.sys.getHistory().pushLocation(route);

    return route;
});

//  ========================================================================
//  TP.uri.FileURLHandler
//  ========================================================================

TP.uri.URIHandler.defineSubtype('FileURLHandler');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.uri.FileURLHandler.Type.defineMethod('load',
function(targetURI, aRequest) {

    /**
     * @method load
     * @summary Loads URI data content, returning the TP.sig.Response object
     *     used to manage the low-level service response.
     * @param {TP.uri.URI} targetURI The URI to load. NOTE that this URI will
     *     not have been rewritten/ resolved.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response|undefined} The request's response object.
     */

    var request,
        subrequest,
        targetLoc,
        response;

    request = targetURI.constructRequest(aRequest);

    //  reuse the incoming request's payload/parameters but don't use that
    //  instance so we can manage complete/fail logic more effectively.
    subrequest = targetURI.constructSubrequest(request);

    //  most supported browsers can handle at least loading from the file
    //  system via an XMLHttpRequest if nothing else, but just in case....
    if (!TP.canInvoke(TP, '$fileLoad')) {
        this.raise('TP.sig.UnsupportedOperation');
        if (TP.canInvoke(request, 'fail')) {
            request.fail('Unsupported operation.');
        }
        return;
    }

    if (!TP.canInvoke(targetURI, 'getLocation')) {
        this.raise('TP.sig.InvalidURI');
        if (TP.canInvoke(request, 'fail')) {
            request.fail('Invalid URI: ' + targetURI);
        }

        return;
    }

    //  rewriting happens prior to handler lookup, so we just want the
    //  concrete resource URI location so we can load it.
    targetLoc = targetURI.getLocation();

    subrequest.atPutIfAbsent('async', false);
    subrequest.atPutIfAbsent('shouldReport', false);

    //  the low-level file call will potentially complete an incoming
    //  request and we need that to not happen without ensuring headers
    //  and content cache are updated...
    subrequest.defineMethod(
            'completeJob',
            function(aResult) {

                var result;

                result = aResult;

                //  update the target's header and content information, in
                //  that order so that any content change signaling happens
                //  after headers are current.
                targetURI.updateHeaders(subrequest);

                //  NOTE we call both the getRequestedResource and
                //  setPrimaryResource methods here. File URLs don't go through
                //  the low-level HTTP handlers so they need both halves of the
                //  former updateResourceCache method to be called here.
                result = targetURI.getRequestedResource(subrequest);
                targetURI.$setPrimaryResource(result, subrequest);

                subrequest.$wrapupJob('Succeeded', TP.SUCCEEDED, result);

                if (TP.canInvoke(request, 'complete')) {
                    //  Use the return value from cache update since it's
                    //  the "best form" the cache/result check could
                    //  produce. The data will be filtered higher up for
                    //  requests that care.
                    request.complete(result);
                }
            });

    subrequest.defineMethod(
            'failJob',
            function(aFaultString, aFaultCode, aFaultInfo) {

                var info,
                    subrequests;

                info = TP.hc(aFaultInfo);
                if (TP.isValid(subrequests = info.at('subrequests'))) {
                    subrequests.push(subrequest);
                } else {
                    subrequests = TP.ac(subrequest);
                    info.atPut('subrequests', subrequests);
                }

                //  update the target's header and content information, in
                //  that order so that any content change signaling happens
                //  after headers are current.
                targetURI.updateHeaders(subrequest);

                //  Ensure the URI value is cleared. We don't want it to be
                //  retained if the process failed.
                targetURI.$setPrimaryResource(undefined);

                subrequest.$wrapupJob('Failed', TP.FAILED);

                if (TP.canInvoke(request, 'fail')) {
                    request.fail(aFaultString, aFaultCode, info);
                }
            });

    //  do the work of loading content. for file operations this call is
    //  synchronous and returns the actual data
    TP.$fileLoad(targetLoc, subrequest);

    //  Note: We do *not* set the result for these responses here.
    //  complete() already did that in the call above. If we do that again
    //  here, we'll undo any wrapping or filtering.
    if (TP.canInvoke(request, 'getResponse')) {
        response = request.getResponse();
    } else {
        response = subrequest.getResponse();
    }

    //  return the response object so it can pass up the chain
    return response;
});

//  ------------------------------------------------------------------------

TP.uri.FileURLHandler.Type.defineMethod('delete',
function(targetURI, aRequest) {

    /**
     * @method delete
     * @summary Deletes a URI entirely, returning the TP.sig.Response object
     *     used to manage the low-level service response.
     * @param {TP.uri.URI} targetURI The URI to delete. NOTE that this URI will
     *     not have been rewritten/ resolved.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response|undefined} The request's response object.
     */

    var request,
        subrequest,
        targetLoc,
        response;

    request = targetURI.constructRequest(aRequest);

    //  reuse the incoming request's payload/parameters but don't use that
    //  instance so we can manage complete/fail logic more effectively.
    subrequest = targetURI.constructSubrequest(request);

    //  only IE and Moz currently support file deletes so if we're down
    //  to this handler we're hopefully on one of those browsers :)
    if (!TP.canInvoke(TP, '$fileDelete')) {
        this.raise('TP.sig.UnsupportedOperation');
        if (TP.canInvoke(request, 'fail')) {
            request.fail('Unsupported operation.');
        }
        return;
    }

    if (!TP.canInvoke(targetURI, 'getLocation')) {
        this.raise('TP.sig.InvalidURI');
        if (TP.canInvoke(request, 'fail')) {
            request.fail('Invalid URI: ' + targetURI);
        }
        return;
    }

    subrequest.defineMethod(
            'completeJob',
            function(aResult) {

                if (TP.isTrue(aResult)) {
                    targetURI.isDirty(false, true);
                    targetURI.isLoaded(false);

                    subrequest.$wrapupJob('Succeeded', TP.SUCCEEDED, aResult);

                    if (TP.canInvoke(request, 'complete')) {
                        request.complete(aResult);
                    }
                } else if (TP.canInvoke(request, 'fail')) {

                    subrequest.$wrapupJob('Failed', TP.FAILED);

                    request.fail();
                }
            });

    subrequest.defineMethod(
            'failJob',
            function(aFaultString, aFaultCode, aFaultInfo) {

                var info,
                    subrequests;

                info = TP.hc(aFaultInfo);
                if (TP.isValid(subrequests = info.at('subrequests'))) {
                    subrequests.push(subrequest);
                } else {
                    subrequests = TP.ac(subrequest);
                    info.atPut('subrequests', subrequests);
                }

                subrequest.$wrapupJob('Failed', TP.FAILED);

                if (TP.canInvoke(request, 'fail')) {
                    request.fail(aFaultString, aFaultCode, info);
                }
            });

    //  rewriting happens prior to handler lookup, so we just want the
    //  concrete resource URI location so we can save it.
    targetLoc = targetURI.getLocation();

    TP.$fileDelete(targetLoc, subrequest);

    //  Note: We do *not* set the result for these responses here.
    //  complete() already did that in the call above. If we do that again
    //  here, we'll undo any wrapping or filtering.
    if (TP.canInvoke(request, 'getResponse')) {
        response = request.getResponse();
    } else {
        response = subrequest.getResponse();
    }

    return response;
});

//  ------------------------------------------------------------------------

TP.uri.FileURLHandler.Type.defineMethod('save',
function(targetURI, aRequest) {

    /**
     * @method save
     * @summary Saves URI data content. This is the default data persistence
     *     method for most URI content.
     * @description By creating alternative URI handlers and ensuring that URI
     *     routing can find them you can alter how data is managed for different
     *     URI instances. See TP.uri.URIRewriter and TP.uri.URIMapper for more
     *     information. Important keys include 'append', 'body', and 'backup',
     *     which define whether this save should append or write new content,
     *     what content is being saved, and whether a backup should be created
     *     if possible (for 'file' scheme uris).
     * @param {TP.uri.URI} targetURI The URI to save. NOTE that this URI will
     *     not have been rewritten/ resolved.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response|undefined} The request's response object.
     */

    var request,
        subrequest,
        targetLoc,
        content,
        resp,
        response;

    request = targetURI.constructRequest(aRequest);

    //  reuse the incoming request's payload/parameters but don't use that
    //  instance so we can manage complete/fail logic more effectively.
    subrequest = targetURI.constructSubrequest(request);

    //  only IE and Moz currently support file save access so if we're down
    //  to this handler we're hopefully on one of those browsers :)
    if (!TP.canInvoke(TP, '$fileSave')) {
        this.raise('TP.sig.UnsupportedOperation');
        if (TP.canInvoke(request, 'fail')) {
            request.fail('Unsupported operation.');
        }

        return;
    }

    if (!TP.canInvoke(targetURI, 'getLocation')) {
        this.raise('TP.sig.InvalidURI');
        if (TP.canInvoke(request, 'fail')) {
            request.fail('Invalid URI: ' + targetURI);
        }

        return;
    }

    //  rewriting happens prior to handler lookup, so we just want the
    //  concrete resource URI location so we can save it.
    targetLoc = targetURI.getLocation();

    subrequest.atPutIfAbsent('async', false);
    subrequest.atPutIfAbsent('append', false);
    subrequest.atPutIfAbsent('backup', true);

    subrequest.atPutIfAbsent('refreshContent', false);

    //  No body? Don't go any further.
    if (TP.notValid(subrequest.at('body'))) {
        //  NOTE: 'refresh' is false here! We do *not* want to fetch data from
        //  the server if the body is undefined.
        resp = targetURI.getResource(TP.hc('async', false, 'refresh', false));
        content = resp.get('result');

        if (TP.isEmpty(content)) {
            return this.raise(
                    'TP.sig.InvalidContent',
                    'No content to save for: ' + targetLoc);
        } else {
            subrequest.atPut('body', content);
        }
    }

    subrequest.defineMethod(
            'completeJob',
            function(aResult) {

                if (TP.isTrue(aResult)) {

                    targetURI.isDirty(false, true);
                    targetURI.isLoaded(true);

                    subrequest.$wrapupJob('Succeeded', TP.SUCCEEDED, aResult);

                    if (TP.canInvoke(request, 'complete')) {
                        request.complete(aResult);
                    }
                } else if (TP.canInvoke(request, 'fail')) {

                    subrequest.$wrapupJob('Failed', TP.FAILED);

                    request.fail();
                }
            });

    subrequest.defineMethod(
            'failJob',
            function(aFaultString, aFaultCode, aFaultInfo) {

                var info,
                    subrequests;

                info = TP.hc(aFaultInfo);
                if (TP.isValid(subrequests = info.at('subrequests'))) {
                    subrequests.push(subrequest);
                } else {
                    subrequests = TP.ac(subrequest);
                    info.atPut('subrequests', subrequests);
                }

                subrequest.$wrapupJob('Failed', TP.FAILED);

                if (TP.canInvoke(request, 'fail')) {
                    request.fail(aFaultString, aFaultCode, info);
                }
            });

    //  do the work of saving content. for file operations this call is
    //  synchronous and returns a boolean for success (true/false)
    TP.$fileSave(targetLoc, subrequest);

    //  Note: We do *not* set the result for these responses here.
    //  complete() already did that in the call above. If we do that again
    //  here, we'll undo any wrapping or filtering.
    if (TP.canInvoke(request, 'getResponse')) {
        response = request.getResponse();
    } else {
        response = subrequest.getResponse();
    }

    return response;
});

//  =======================================================================
//  TP.uri.HTTPURLHandler
//  ========================================================================

/**
 * @type {TP.uri.HTTPURLHandler}
 * @summary Supports operations specific to loading/saving URI data for HTTP
 *     URIs.
 */

//  ------------------------------------------------------------------------

TP.uri.URIHandler.defineSubtype('HTTPURLHandler');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.uri.HTTPURLHandler.Type.defineMethod('load',
function(targetURI, aRequest) {

    /**
     * @method load
     * @summary Loads URI data content, returning the TP.sig.Response object
     *     used to manage the low-level service response.
     * @param {TP.uri.URI} targetURI The URI to load. NOTE that this URI will
     *     not have been rewritten/ resolved.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    var request,
        response,
        targetLoc,
        loadRequest;

    request = targetURI.constructRequest(aRequest);
    response = request.getResponse();

    if (!TP.canInvoke(targetURI, 'getLocation')) {
        request.fail();
        return response;
    }

    //  rewriting happens prior to handler lookup, so we just want the
    //  concrete resource URI location so we can load it.
    targetLoc = targetURI.getLocation();

    //  NOTE that when doing this only methods on the payload are mapped
    //  so this is more applicable to generic TP.sig.Requests constructed
    //  via hashes passed to the getResource call (typical usage
    //  admittedly).
    loadRequest = TP.sig.HTTPLoadRequest.construct(request);

    //  make the request that was provided dependent upon the one we just
    //  constructed so it won't process/complete until the child request
    //  does.
    request.andJoinChild(loadRequest);

    //  ensure the required settings are available for this operation
    loadRequest.atPut('uri', targetLoc);
    if (TP.notEmpty(loadRequest.at('body'))) {
        loadRequest.atPutIfAbsent('method', TP.HTTP_POST);
    } else {
        loadRequest.atPutIfAbsent('method', TP.HTTP_GET);
    }

    //  this could be either sync or async, but the TP.sig.HTTPLoadRequest's
    //  handle* methods should be processing correctly in either case.
    TP.uri.HTTPService.handle(loadRequest);

    //  Make sure that the 2 requests match on sync/async
    request.updateRequestMode(loadRequest);

    return response;
});

//  ------------------------------------------------------------------------

TP.uri.HTTPURLHandler.Type.defineMethod('delete',
function(targetURI, aRequest) {

    /**
     * @method delete
     * @summary Deletes a URI entirely, returning the TP.sig.Response object
     *     used to manage the low-level service response.
     * @param {TP.uri.URI} targetURI The URI to delete. NOTE that this URI will
     *     not have been rewritten/ resolved.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    var request,
        response,

        targetLoc,

        deleteRequest,
        resp,
        content,

        useWebDAV;

    request = targetURI.constructRequest(aRequest);
    response = request.getResponse();

    if (!TP.canInvoke(targetURI, 'getLocation')) {
        request.fail();
        return response;
    }

    //  rewriting happens prior to handler lookup, so we just want the
    //  concrete resource URI location so we can load it.
    targetLoc = targetURI.getLocation();

    //  NOTE that when doing this only methods on the payload are mapped
    //  so this is more applicable to generic TP.sig.Requests constructed
    //  via hashes passed to the getResource call (typical usage
    //  admittedly).
    deleteRequest = TP.sig.HTTPDeleteRequest.construct(request);

    //  make the request that was provided dependent upon the one we just
    //  constructed so it won't process/complete until the child request
    //  does.
    request.andJoinChild(deleteRequest);

    //  Yes, delete requests can have a body. Note that this will get encoded
    //  via the httpEncode() call in lower layers, so we don't touch it here.
    if (TP.notValid(deleteRequest.at('body'))) {
        resp = targetURI.getResource(TP.hc('async', false, 'refresh', false));
        content = TP.ifInvalid(resp.get('result'), '');

        deleteRequest.atPut('body', content);
    }

    //  ensure the required settings are available for this operation
    deleteRequest.atPut('uri', targetLoc);
    if (TP.isEmpty(deleteRequest.at('method'))) {
        //  when webdav is enabled we can set the 'method' to a TP.HTTP_DELETE
        useWebDAV = TP.ifInvalid(deleteRequest.at('iswebdav'),
                                    TP.sys.cfg('http.use_webdav'));

        if (useWebDAV) {
            deleteRequest.atPut('method', TP.HTTP_DELETE);
        } else {
            //  all other situations require a 'method' of TP.HTTP_POST, and an
            //  'altmethod' of TP.HTTP_DELETE (which eventually translates into
            //  the increasingly standard 'X-HTTP-Method-Override' header).
            deleteRequest.atPut('method', TP.HTTP_POST);
            deleteRequest.atPut('altmethod', TP.HTTP_DELETE);
        }
    }

    //  this could be either sync or async, but the TP.sig.HTTPLoadRequest's
    //  handle* methods should be processing correctly in either case.
    TP.uri.HTTPService.handle(deleteRequest);

    //  subrequests can be rewritten so we need to be in sync on async
    request.atPut('async', deleteRequest.at('async'));

    return response;
});

//  ------------------------------------------------------------------------

TP.uri.HTTPURLHandler.Type.defineMethod('save',
function(targetURI, aRequest) {

    /**
     * @method save
     * @summary Saves URI data content. This is the default data persistence
     *     method for most URI content. Important request keys include 'method',
     *     'crud', and 'body'. Method will typically default to a POST unless
     *     TP.sys.cfg(http.use_webdav) is true and the crud parameter is set to
     *     'insert', in which case a PUT is used. The crud parameter effectively
     *     defaults to 'update' so you should set it to 'insert' when new
     *     content is being created. The 'body' should contain the new/updated
     *     content, but this is normally configured by the URI's save() method
     *     itself.
     * @param {TP.uri.URI} targetURI The URI to save. NOTE that this URI will
     *     not have been rewritten/ resolved.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    var request,
        response,
        targetLoc,
        saveRequest,
        resp,
        content,
        useWebDAV;

    request = targetURI.constructRequest(aRequest);
    response = request.getResponse();

    if (!TP.canInvoke(targetURI, 'getLocation')) {
        request.fail();
        return response;
    }

    //  rewriting happens prior to handler lookup, so we just want the
    //  concrete resource URI location so we can load it.
    targetLoc = targetURI.getLocation();

    //  NOTE that when doing this only methods on the payload are mapped
    //  so this is more applicable to generic TP.sig.Requests constructed
    //  via hashes passed to the getResource call (typical usage
    //  admittedly).
    saveRequest = TP.sig.HTTPSaveRequest.construct(request);

    //  make the request that was provided dependent upon the one we just
    //  constructed so it won't process/complete until the child request
    //  does.
    request.andJoinChild(saveRequest);

    //  Save operations shouldn't use their result as new URI content, the
    //  content is already in place, we just want to commit it.
    saveRequest.atPut('refreshContent', false);

    //  Make sure we have content. Note that this will get encoded via the
    //  httpEncode() call in lower layers, so we don't touch it here.
    if (TP.notValid(saveRequest.at('body'))) {

        //  NOTE: 'refresh' is false here! We do *not* want to fetch data from
        //  the server if the body is undefined.
        resp = targetURI.getResource(TP.hc('async', false, 'refresh', false));
        content = resp.get('result');

        //  NOTE: We use the 'not valid' check here. That is because the value
        //  could be 'empty' (i.e. the empty String) which is perfectly viable
        //  for certain kinds of 'save' operations. Therefore, we allow empty
        //  Strings to pass here without raising and to be set as the 'body'.
        if (TP.notValid(content)) {
            return this.raise(
                    'TP.sig.InvalidContent',
                    'No content to save for: ' + targetLoc);
        } else {
            saveRequest.atPut('body', content);
        }
    }

    //  ensure the required settings are available for this operation
    saveRequest.atPut('uri', targetLoc);
    if (TP.isEmpty(saveRequest.at('method'))) {
        //  when webdav is enabled we can set the 'method' to a TP.HTTP_PUT
        //  for insert or use TP.HTTP_POST as our default.
        useWebDAV = TP.ifInvalid(saveRequest.at('iswebdav'),
                                    TP.sys.cfg('http.use_webdav'));

        if (useWebDAV) {
            if (saveRequest.at('crud') === TP.CREATE) {
                saveRequest.atPut('method', TP.HTTP_PUT);
            } else {
                saveRequest.atPut('method', TP.HTTP_POST);
            }
        } else {
            //  all other situations require a 'method' of TP.HTTP_POST, and a
            //  'method' of TP.HTTP_PUT or TP.HTTP_POST (which eventually
            //  translates into the increasingly standard
            //  'X-HTTP-Method-Override' header).
            saveRequest.atPut('method', TP.HTTP_POST);

            if (saveRequest.at('crud') === TP.CREATE) {
                saveRequest.atPut('altmethod', TP.HTTP_PUT);
            } else {
                saveRequest.atPut('altmethod', TP.HTTP_POST);
            }
        }
    }

    //  this could be either sync or async, but the TP.sig.HTTPSaveRequest's
    //  handle* methods should be processing correctly in either case.
    TP.uri.HTTPService.handle(saveRequest);

    //  subrequests can be rewritten so we need to be in sync on async
    request.atPut('async', saveRequest.at('async'));

    return response;
});

//  =======================================================================
//  TP.uri.RemoteURLWatchHandler
//  ========================================================================

/**
 * @type {TP.uri.RemoteURLWatchHandler}
 * @summary Mixin supporting response processing for remote resources that
 *     can notify of server side changes. This type is normally used as a trait
 *     to the main handler type. TDS and Couch URL handlers are the primary
 *     consumers of this mixin.
 */

//  ------------------------------------------------------------------------

TP.uri.URIHandler.defineSubtype('RemoteURLWatchHandler');

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation
TP.uri.RemoteURLWatchHandler.isAbstract(true);

//  ------------------------------------------------------------------------
//  TypeLocal Attributes
//  ------------------------------------------------------------------------

//  Helper function for escaping regex metacharacters. NOTE that we need to
//  take "ignore format" things like path/* and make it path/.* or the regex
//  will fail. Also note we special case ~ to allow virtual path matches.
TP.uri.RemoteURLWatchHandler.defineConstant('INCLUDE_EXCLUDE_ESCAPER',
function(str) {
    return str.replace(
        /\*/g, '.*').replace(
        /\./g, '\\.').replace(
        /\~/g, '\\~').replace(
        /\//g, '\\/');
});

//  The list of methods any object which registered with this type must
//  implement.
TP.uri.RemoteURLWatchHandler.defineConstant('REMOTE_WATCH_API',
    TP.ac('activateRemoteWatch', 'deactivateRemoteWatch'));

//  A list of registered watchers, objects that will be activated/deactivated at
//  application startup and shutdown to manage remote change handling.
TP.uri.RemoteURLWatchHandler.defineAttribute('watchers');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  Regular expressions built based on include/exclude configuration data for
//  the remote url watcher types which mix this in.
TP.uri.RemoteURLWatchHandler.Type.defineAttribute('includeRE');
TP.uri.RemoteURLWatchHandler.Type.defineAttribute('excludeRE');

//  Configuration names for the include/exclude configuration settings for the
//  remote url watcher types which mix this in.
TP.uri.RemoteURLWatchHandler.Type.defineAttribute('includeConfigName');
TP.uri.RemoteURLWatchHandler.Type.defineAttribute('excludeConfigName');
TP.uri.RemoteURLWatchHandler.Type.defineAttribute('uriConfigName');

//  ------------------------------------------------------------------------
//  TypeLocal Methods
//  ------------------------------------------------------------------------

TP.uri.RemoteURLWatchHandler.defineMethod('activateWatchers',
function() {

    /**
     * @method activateWatchers
     * @summary Activates any registered remote URL watchers.
     * @returns {TP.uri.RemoteURLWatchHandler} The receiver.
     */

    var watchers;

    //  Don't watch if running in headless or karma (both are test environments
    //  that will cause issues).
    if (TP.sys.cfg('boot.context') === 'headless' ||
        TP.sys.hasFeature('karma')) {
        return this;
    }

    TP.sys.setcfg('uri.source.watch_changes', true);

    //  These get registered by the types which want activate/deactivate calls.
    watchers = TP.uri.RemoteURLWatchHandler.get('watchers');
    if (TP.isEmpty(watchers)) {
        return this;
    }

    //  Iterate over all of the watchers and observe them.
    watchers.perform(
                function(watcher) {
                    watcher.activateRemoteWatch();
                });

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.RemoteURLWatchHandler.defineMethod('deactivateWatchers',
function(aFilterFunction) {

    /**
     * @method deactivateWatchers
     * @summary Deactivates any registered remote URL watchers.
     * @returns {TP.uri.RemoteURLWatchHandler} The receiver.
     */

    var watchers;

    TP.sys.setcfg('uri.source.watch_changes', false);

    watchers = TP.uri.RemoteURLWatchHandler.get('watchers');
    if (TP.isEmpty(watchers)) {
        return this;
    }

    //  Iterate over all of the watchers and ignore them.
    watchers.perform(
                function(watcher) {
                    watcher.deactivateRemoteWatch();
                });

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.RemoteURLWatchHandler.defineMethod('registerWatcher',
function(aWatcher) {

    /**
     * @method registerWatcher
     * @summary Registers a specific object as a remote URL watcher. Registered
     *     watchers are activated/deactivated in response to the
     *     activateWatchers/deactivateWatchers methods on this type.
     * @param {Object} aWatcher A potential remote URL watcher. This object must
     *     conform to the receiver's REMOTE_WATCH_API.
     * @returns {TP.uri.RemoteURLWatchHandler} The receiver.
     */

    var watchers;

    if (!TP.canInvokeInterface(
        aWatcher,
        TP.uri.RemoteURLWatchHandler.REMOTE_WATCH_API)) {
        return this.raise('InvalidURLWatcher', aWatcher);
    }

    watchers = this.$get('watchers');
    if (TP.notValid(watchers)) {
        watchers = TP.ac();
        this.$set('watchers', watchers);
    }

    if (watchers.contains(aWatcher, TP.IDENTITY)) {
        return this;
    }

    watchers.push(aWatcher);

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.RemoteURLWatchHandler.defineHandler('AppShutdown',
function(aSignal) {

    /**
     * @method handleAppShutdown
     * @summary Handles when the app is about to be shut down. This is used to
     *     deactivateWatchers to get them to close any open connections.
     * @param {TP.sig.AppShutdown} aSignal The signal indicating that the
     *     application is to be shut down.
     * @returns {TP.uri.RemoteURLWatchHandler} The receiver.
     */

    this.deactivateWatchers();

    //  Make sure to remove our observation of AppShutdown.
    this.ignore(TP.sys, 'TP.sig.AppShutdown');

    return this;
});

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.uri.RemoteURLWatchHandler.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize.
     * @summary Performs one-time setup for the type on startup/import.
     * @description For this type that includes signing up for AppShutdown and
     *     activating any registered watchers if uri.source.watch_changes is
     *     set.
     */

    //  Ensure we always attempt to shut down and active watch channels.
    this.observe(TP.sys, 'TP.sig.AppShutdown');

    //  Activate if we're already set to watch based on startup config data.
    if (TP.sys.cfg('uri.source.watch_changes')) {
        TP.uri.RemoteURLWatchHandler.activateWatchers();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.uri.RemoteURLWatchHandler.Type.defineMethod('activateRemoteWatch',
function() {

    /**
     * @method activateRemoteWatch
     * @summary Performs any processing necessary to activate observation of
     *     remote URL changes.
     * @returns {TP.meta.uri.RemoteURLWatchHandler} The receiver.
     */

    var sourceType,
        sourceURI,
        signalSource,
        signalType;

    if (!TP.sys.isHTTPBased()) {
        return this;
    }

    sourceType = this.getWatcherSourceType();
    sourceURI = this.getWatcherSourceURI();

    signalSource = sourceType.construct(sourceURI.getLocation());
    if (TP.notValid(signalSource)) {
        return this.raise('InvalidURLWatchSource');
    }

    signalType = this.getWatcherSignalType();
    this.observe(signalSource, signalType);

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.RemoteURLWatchHandler.Type.defineMethod('deactivateRemoteWatch',
function() {

    /**
     * @method deactivateRemoteWatch
     * @summary Performs any processing necessary to shut down observation of
     *     remote URL changes.
     * @returns {TP.meta.uri.RemoteURLWatchHandler} The receiver.
     */

    var sourceType,
        sourceURI,
        signalSource,
        signalType;

    sourceType = this.getWatcherSourceType();
    sourceURI = this.getWatcherSourceURI();

    signalSource = sourceType.construct(sourceURI.getLocation());
    if (TP.notValid(signalSource)) {
        return this.raise('InvalidURLWatchSource');
    }

    signalType = this.getWatcherSignalType();
    this.ignore(signalSource, signalType);

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.RemoteURLWatchHandler.Type.defineMethod('getWatcherSignalType',
function() {

    /**
     * @method getWatcherSignalType
     * @summary Returns the TIBET type of the watcher signal. This will be the
     *     signal that the signal source sends when it wants to notify URIs of
     *     changes.
     * @returns {TP.sig.RemoteURLChange} The type that will be instantiated
     *     to construct new signals that notify observers that the *remote*
     *     version of the supplied URI's resource has changed.
     */

    return TP.sig.RemoteURLChange;
});

//  ------------------------------------------------------------------------

TP.uri.RemoteURLWatchHandler.Type.defineMethod('getWatcherSourceType',
function() {

    /**
     * @method getWatcherSourceType
     * @summary Returns the TIBET type of the watcher signal source. Typically,
     *     this is one of the prebuilt TIBET watcher types, like
     *     TP.core.SSEMessageSource for Server-Sent Event sources.
     * @returns {TP.core.SSEMessageSource} The type that will be instantiated to
     *     make a watcher for the supplied URI.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.uri.RemoteURLWatchHandler.Type.defineMethod('getWatcherSourceURI',
function() {

    /**
     * @method getWatcherSourceURI
     * @summary Returns the URI to the resource that acts as a watcher to watch
     *     for changes to the resource of the supplied URI.
     * @returns {TP.uri.URI} A URI pointing to the resource that will notify
     *     TIBET when the supplied URI's resource changes.
     */

    var watcherURI;

    watcherURI = TP.uc(TP.uriJoinPaths(
                        TP.sys.cfg('path.app_root'),
                        TP.sys.cfg(this.get('uriConfigName'))));

    //  Make sure to switch *off* remote refreshing for the watcher URI itself
    watcherURI.unwatch();

    return watcherURI;
});

//  ------------------------------------------------------------------------

TP.uri.RemoteURLWatchHandler.Type.defineMethod('isWatchableURI',
function(targetURI) {

    /**
     * @method isWatchableURI
     * @summary Tests a URI against include/exclude filters to determine if
     *     changes to the URI should be considered for processing.
     * @param {String|TP.uri.URI} targetURI The URI to test.
     * @returns {Boolean} true if the URI passes include/exclude filters.
     */

    var includeRE,
        excludeRE,

        targetLoc,
        targetVirtual,

        escaper,

        cfgName,

        includes,
        excludes;

    //  NOTE each type which mixes this in gets it own copy of the values here.
    includeRE = this.get('includeRE');
    excludeRE = this.get('excludeRE');

    targetLoc = targetURI.getLocation();
    targetVirtual = TP.uriInTIBETFormat(targetLoc);

    if (TP.notValid(includeRE)) {

        escaper = TP.uri.RemoteURLWatchHandler.INCLUDE_EXCLUDE_ESCAPER;

        cfgName = this.get('includeConfigName');
        if (TP.notEmpty(cfgName)) {
            includes = TP.sys.cfg(cfgName);
            if (TP.notEmpty(includes)) {

                //  First normalize any virtual path values.
                includes = includes.map(
                            function(item) {
                                    return TP.uriInTIBETFormat(
                                                TP.uriExpandPath(item));
                            });

                //  Now produce a single source string for regex construct.
                includes = includes.reduce(
                            function(str, item) {
                                return str ?
                                    str + '|' + escaper(item) :
                                    escaper(item);
                            }, '');

                try {
                    //  Use 'new' here to keep escaping simple.
                    includeRE = new RegExp(includes);
                } catch (e) {
                    this.raise('InvalidWatchIncludes', includes);
                }
            }
        }

        includeRE = TP.ifInvalid(includeRE, /.*/);

        cfgName = this.get('excludeConfigName');
        if (TP.notEmpty(cfgName)) {
            excludes = TP.sys.cfg(cfgName);
            if (TP.notEmpty(excludes)) {

                //  First normalize any virtual path values.
                excludes = excludes.map(
                            function(item) {
                                    return TP.uriInTIBETFormat(
                                                TP.uriExpandPath(item));
                            });

                //  Now produce a single source string for regex construct.
                excludes = excludes.reduce(
                            function(str, item) {
                                return str ?
                                    str + '|' + escaper(item) :
                                    escaper(item);
                            }, '');

                try {
                    //  Use 'new' here to keep escaping simple.
                    excludeRE = new RegExp(excludes);
                } catch (e) {
                    this.raise('InvalidWatchExcludes', excludes);
                }
            }
        }

        this.set('includeRE', includeRE);
        this.set('excludeRE', excludeRE);
    }

    if (TP.isValid(excludeRE) && TP.notEmpty(excludes)) {
        TP.info('checking ' + targetLoc + ' not in: ' + excludes);
        if (excludeRE.test(targetVirtual)) {
            return false;
        }
    }

    if (TP.isValid(includeRE) && TP.notEmpty(includes)) {
        TP.info('checking ' + targetLoc + ' in: ' + includes);
        return includeRE.test(targetVirtual);
    }

    return true;
});

//  ========================================================================
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETWWWTypes.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
Core types specific to web technology including types to support the HTTP
protocol, WebDAV, MIME types, XMLNS namespaces, TP.w3.DocType elements,
URIs of various schemes, Cookies, and more.

The TP.uri.URI type and its subtypes are a particularly important type in
TIBET. The TP.uri.TIBETURL type, whose scheme is 'tibet:', provides
extensions to the normal URI addressing schemes for http: and file: URIs so
that any object in the web, or more importantly within the local browser,
can have a URI.

XML standards like XInclude and XPointer are supported by TP.uri.URI to
help meet the goal of "universal addressibility" where every object,
including those within a visual DOM or a client-side XML data model, has an
address.

Also included in this file are the core support types/methods for content
handling of different text dialects such as CSS or JSON.
*/

//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.w3.DocType
//  ========================================================================

/**
 * @type {TP.w3.DocType}
 * @summary A type that represents a Document Type in the TIBET system, as
 *     defined by the DOCTYPE information that it is holding.
 * @description This is TIBET's data structure for a Document Type Declaration,
 *     which would usually be found at the top of a document before any of the
 *     markup begins. These declarations indicate to the browser which DTD that
 *     the markup in this page in going to conform to. Older browsers typically
 *     did not use Document Type Declarations as they didn't support any other
 *     markup besides HTML, and thought it unnecessary to worry about which
 *     version of that they were rendering. Newer browsers support these
 *     declarations as part of their integrated support for XML. The DOM Level 1
 *     allows access to the declaration but not, unfortunately, to the 'public
 *     id' that is necessary to distinguish exactly which version of 'HTML' or
 *     'XHTML', for instance, that the browser is currently rendering. DOM Level
 *     2 (used by Navigator 6/Mozilla) allows this access.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('w3.DocType');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.w3.DocType.Type.defineAttribute('docTypeRegistry', TP.ac());

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.w3.DocType.Inst.defineAttribute('docTypeName');
TP.w3.DocType.Inst.defineAttribute('publicID');
TP.w3.DocType.Inst.defineAttribute('systemID');

TP.w3.DocType.Inst.defineAttribute('dtdInfo');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.w3.DocType.Type.defineMethod('docTypeForInfo',
function(docTypeInfo) {

    /**
     * @method docTypeForInfo
     * @summary Search for a matching document type object based on the
     *     document type information passed in.
     * @param {TP.core.Hash} docTypeInfo The document type information. The keys
     *     needed to match are 'docTypeName' and 'publicID'.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.meta.w3.DocType} A TP.w3.DocType subtype type object
     *     matching the info in docTypeInfo or null if one can't be found.
     */

    var foundItem;

    if (TP.notValid(docTypeInfo)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    foundItem = this.get('docTypeRegistry').detect(
                    function(item) {

                        //  NB: We don't compare the systemID to see if two
                        //  document type infos are equal.
                        if (item.get('docTypeName').equalTo(
                                        docTypeInfo.at('docTypeName')) &&
                            item.get('publicID').equalTo(
                                        docTypeInfo.at('publicID'))) {
                            return true;
                        }
                    });

    return foundItem;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.w3.DocType.Inst.defineAttribute('str');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.w3.DocType.Inst.defineMethod('init',
function(docTypeName, publicID, systemID) {

    /**
     * @method init
     * @summary Initialize the instance.
     * @param {String} docTypeName The name of the document type.
     * @param {String} publicID The document type's public identifier.
     * @param {String} systemID The document type's system identifier.
     * @returns {TP.w3.DocType} The receiver.
     */

    this.callNextMethod();

    this.set('docTypeName', docTypeName);
    this.set('publicID', publicID);
    this.set('systemID', systemID);

    //  Add the newly constructed doc type instance to this type's registry.
    this.getType().get('docTypeRegistry').add(this);

    return this;
});

//  ------------------------------------------------------------------------

TP.w3.DocType.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    var publicID,
        systemID,

        repStr,
        str;

    if (TP.notValid(repStr = this.$get('str'))) {

        publicID = this.get('publicID');
        systemID = this.get('systemID');

        repStr = TP.join(
                    '<!DOCTYPE ',
                    this.get('docTypeName'),
                    TP.notEmpty(publicID) ? ' PUBLIC "' + publicID + '"' : '',
                    TP.notEmpty(systemID) ? ' "' + systemID + '"' : '',
                    '>');

        this.$set('str', repStr);
    }

    str = '[' + TP.tname(this) + ' :: ';
    str += '(' + repStr + ')' + ']';

    return str;
});

//  ------------------------------------------------------------------------

TP.w3.DocType.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver.
     * @returns {String} The receiver in HTML string format.
     */

    return '<span class="TP_w3_DocType ' +
            TP.escapeTypeName(TP.tname(this)) + '">' +
                '<span data-name="doctypename">' +
                    TP.htmlstr(this.get('docTypeName')) +
                '</span>' +
                '<span data-name="publicID">' +
                    TP.htmlstr(this.get('publicID')) +
                '</span>' +
                '<span data-name="systemID">' +
                    TP.htmlstr(this.get('systemID')) +
                '</span>' +
            '</span>';
});

//  ------------------------------------------------------------------------

TP.w3.DocType.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    var str;

    try {
        str = '{"type":' + TP.tname(this).quoted('"') + ',' +
                '"data":{' +
                    '"DOCTYPE":"' + this.get('docTypeName') + '",' +
                    '"PUBLIC":"' + this.get('publicID') + '",' +
                    '"SYSTEM":"' + this.get('systemID') + '"' +
                '}}';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.w3.DocType.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} A new String containing the 'pretty print' string of
     *     the receiver.
     */

    return '<dl class="pretty ' + TP.escapeTypeName(TP.tname(this)) + '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' +
                        this.getTypeName() +
                    '</dd>' +
                    '<dt class="pretty key">DOCTYPE:</dt>' +
                    '<dd class="pretty value">' +
                        this.get('docTypeName') +
                    '</dd>' +
                    '<dt class="pretty key">PUBLIC:</dt>' +
                    '<dd class="pretty value">' +
                        this.get('publicID') +
                    '</dd>' +
                    '<dt class="pretty key">SYSTEM:</dt>' +
                    '<dd class="pretty value">' +
                        this.get('systemID') +
                    '</dd>' +
                    '</dl>';
});

//  ------------------------------------------------------------------------

TP.w3.DocType.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a TIBET source code string.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    return TP.join('TP.w3.DocType.construct(\'',
                    this.get('docTypeName'), '\',\'',
                    this.get('publicID'), '\',\'',
                    this.get('systemID'), '\')');
});

//  ------------------------------------------------------------------------

TP.w3.DocType.Inst.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns the receiver formatted in the standard Document Type
     *     Declaration format.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the TP.w3.DocType's String representation. This flag is ignored in
     *     this version of this method.
     * @returns {String} The receiver in standard Document Type Declaration
     *     format.
     */

    var publicID,
        systemID,

        repStr;

    if (TP.notValid(repStr = this.$get('str'))) {

        publicID = this.get('publicID');
        systemID = this.get('systemID');

        repStr = TP.join(
                    '<!DOCTYPE ',
                    this.get('docTypeName'),
                    TP.notEmpty(publicID) ? ' PUBLIC "' + publicID + '"' : '',
                    TP.notEmpty(systemID) ? ' "' + systemID + '"' : '',
                    '>');

        this.$set('str', repStr);
    }

    return repStr;
});

//  ------------------------------------------------------------------------

TP.w3.DocType.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver.
     * @returns {String} The receiver in XML string format.
     */

    return '<instance type="' + TP.tname(this) + '">' +
                        '<doctypename>' +
                            TP.xmlstr(this.get('docTypeName')) +
                        '</doctypename>' +
                        '<publicID>' +
                            TP.xmlstr(this.get('publicID')) +
                        '</publicID>' +
                        '<systemID>' +
                            TP.xmlstr(this.get('systemID')) +
                        '</systemID>' +
                    '</instance>';
});

//  ------------------------------------------------------------------------

(function() {

    //  "Canonical Instances"

    TP.w3.DocType.Type.defineConstant('XHTML_10_TRANSITIONAL',
        TP.w3.DocType.construct(
            'html',
            '-//W3C//DTD XHTML 1.0 Transitional//EN',
            'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'));

    TP.w3.DocType.Type.defineConstant('XHTML_10_STRICT',
        TP.w3.DocType.construct(
            'html',
            '-//W3C//DTD XHTML 1.0 Strict//EN',
            'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd'));

    TP.w3.DocType.Type.defineConstant('XHTML_10_FRAMESET',
        TP.w3.DocType.construct(
            'html',
            '-//W3C//DTD XHTML 1.0 Frameset//EN',
            'http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd'));

    TP.w3.DocType.Type.defineConstant('HTML_401_TRANSITIONAL',
        TP.w3.DocType.construct(
            'HTML',
            '-//W3C//DTD HTML 4.01 Transitional//EN',
            'http://www.w3.org/TR/html4/loose.dtd'));

    TP.w3.DocType.Type.defineConstant('HTML_401_STRICT',
        TP.w3.DocType.construct(
            'HTML',
            '-//W3C//DTD HTML 4.01 Strict//EN',
            'http://www.w3.org/TR/html4/strict.dtd'));

    TP.w3.DocType.Type.defineConstant('HTML_401_FRAMESET',
        TP.w3.DocType.construct(
            'HTML',
            '-//W3C//DTD HTML 4.01 Frameset//EN',
            'http://www.w3.org/TR/html4/frameset.dtd'));

    TP.w3.DocType.Type.defineConstant('HTML_32_FINAL',
        TP.w3.DocType.construct(
            'HTML',
            '-//W3C//DTD HTML 3.2 Final//EN',
            ''));   //  No system ID defined for HTML 3.2

    TP.w3.DocType.Type.defineConstant('SVG_10',
        TP.w3.DocType.construct(
            'svg',
            '-//W3C//DTD SVG 1.0//EN',
            'http://www.w3.org/TR/2001/REC-SVG-20010904/DTD/svg10.dtd'));

    TP.w3.DocType.Type.defineConstant('MATHML_20',
        TP.w3.DocType.construct(
            'math',
            '-//W3C//DTD MathML 2.0//EN',
            'http://www.w3.org/TR/MathML2/dtd/mathml2.dtd'));

    TP.w3.DocType.Type.defineConstant('XHTML_50',
        TP.w3.DocType.construct(
            'html',
            '',
            ''));

    return;
}());

//  ========================================================================
//  TP.core.HTTP
//  ========================================================================

/**
 * @type {TP.core.HTTP}
 * @summary Provides registration and lookup services for HTTP data.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.HTTP');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  lookup table of HTTP status codes and their meanings
TP.core.HTTP.Type.defineConstant('CODES',
                TP.hc(100, 'Continue',
                        101, 'Switching Protocols',

                        200, 'OK',
                        201, 'Created',
                        202, 'Accepted',
                        203, 'Non-Authoritative Information',
                        204, 'No Content',
                        205, 'Reset Content',
                        206, 'Partial Content',

                        300, 'Multiple Choices',
                        301, 'Moved Permanently',
                        302, 'Found',
                        303, 'See Other',
                        304, 'Not Modified',
                        305, 'Use Proxy',
                        306, 'Unused',
                        307, 'Temporary Redirect',

                        400, 'Bad Request',
                        401, 'Unauthorized',
                        402, 'Payment Required',
                        403, 'Forbidden',
                        404, 'Not Found',
                        405, 'Method Not Allowed',
                        406, 'Not Acceptable',
                        407, 'Proxy Authentication Required',
                        408, 'Request Timeout',
                        409, 'Conflict',
                        410, 'Gone',
                        411, 'Length Required',
                        412, 'Precondition Failed',
                        413, 'Request Entity Too Large',
                        414, 'Request URI Too Long',
                        415, 'Unsupported Media Type',
                        416, 'Requested Range Not Satisfiable',
                        417, 'Expectation Failed',

                        500, 'Internal Server Error',
                        501, 'Not Implemented',
                        502, 'Bad Gateway',
                        503, 'Service Unavailable',
                        504, 'Gateway Timeout',
                        505, 'Version Not Supported'));

//  ------------------------------------------------------------------------

(function() {

    //  using the prior hash construct constants for each string so code
    //  can use constructs like TP.core.HTTP.NOT_FOUND
    TP.core.HTTP.CODES.perform(
        function(item) {
            TP.core.HTTP.Type.defineConstant(
                    item.last().toUpperCase().replace(/ /g, '_'),
                    item.first());
        });

    return;
}());

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.HTTP.Type.defineMethod('getStatusText',
function(aStatusCode) {

    /**
     * @method getStatusText
     * @summary Returns the string representation of an HTTP status code.
     * @param {Number} aStatusCode A numerical HTTP status code.
     * @returns {String|undefined} The status text corresponding to the supplied
     *     numerical status code.
     */

    if (TP.notValid(aStatusCode)) {
        return;
    }

    return TP.ifInvalid(TP.core.HTTP.CODES.at(aStatusCode.asNumber()), '');
});

//  ========================================================================
//  TP.ietf.mime
//  ========================================================================

/**
 * @type {TP.ietf.mime}
 * @summary Provides registration and lookup services for MIME data.
 * @description The TP.ietf.mime type is largely a container for constants to
 *     make working with MIME strings easier. One feature of this type that is
 *     more interesting is the ability to register "content handlers" for
 *     different MIME types. The canonical example for this is the CSS MIME type
 *     (text/css), which has a specific content handler that knows how to parse
 *     CSS style sheets. This type also provides support for simple "sniffing"
 *     to try to narrow down the specific format of content data.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('ietf.mime');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.ietf.mime.Type.defineConstant('PLAIN', TP.PLAIN_TEXT_ENCODED);
TP.ietf.mime.Type.defineConstant('CSV', 'text/csv');

TP.ietf.mime.Type.defineConstant('ICAL', 'text/calendar');

TP.ietf.mime.Type.defineConstant('CSS', TP.CSS_TEXT_ENCODED);
TP.ietf.mime.Type.defineConstant('HTML', TP.HTML_TEXT_ENCODED);
TP.ietf.mime.Type.defineConstant('ECMASCRIPT', 'text/ecmascript');
TP.ietf.mime.Type.defineConstant('JS', TP.JS_TEXT_ENCODED);
TP.ietf.mime.Type.defineConstant('JSON', TP.JSON_ENCODED);
TP.ietf.mime.Type.defineConstant('JSX', TP.JSX_TEXT_ENCODED);
TP.ietf.mime.Type.defineConstant('XHTML', TP.XHTML_ENCODED);

TP.ietf.mime.Type.defineConstant('TSH', 'text/vnd.TPI.TSH');

TP.ietf.mime.Type.defineConstant('GIF', 'image/gif');
TP.ietf.mime.Type.defineConstant('JPEG', 'image/jpeg');
TP.ietf.mime.Type.defineConstant('PNG', 'image/png');

TP.ietf.mime.Type.defineConstant('FLASH', 'application/x-shockwave-flash');
TP.ietf.mime.Type.defineConstant('SILVERLIGHT', 'application/x-silverlight');
TP.ietf.mime.Type.defineConstant('SMIL', 'application/smil+xml');
TP.ietf.mime.Type.defineConstant('SVG', 'application/svg+xml');

TP.ietf.mime.Type.defineConstant('XSLT', 'application/xslt+xml');

TP.ietf.mime.Type.defineConstant('ATOM', 'application/atom+xml');
TP.ietf.mime.Type.defineConstant('RDF', 'application/rdf+xml');
TP.ietf.mime.Type.defineConstant('RSS', 'application/rss+xml');

TP.ietf.mime.Type.defineConstant('SOAP', TP.SOAP_ENCODED);
TP.ietf.mime.Type.defineConstant('XMLRPC', TP.XMLRPC_ENCODED);
TP.ietf.mime.Type.defineConstant('XML', TP.XML_ENCODED);

TP.ietf.mime.Type.defineConstant('VCARD', 'text/vcard');

TP.ietf.mime.Type.defineConstant('XMPP', 'application/xmpp+xml');

TP.ietf.mime.Type.defineConstant('TIBET_CSS', 'text/x-tibet-css');

TP.ietf.mime.Type.defineConstant('$KEYS', TP.ac('mimetype',
                                            'alias',
                                            'handler',
                                            'tpDocNodeType',
                                            'extensions'));

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  Define an 'info' hash that will contain the following information
//  about a particular MIME type:
//      'mimetype'      ->  A copy of the MIME type string (i.e. text/css)
//      'alias'         ->  The registered alias for the mime type.
//      'handler'       ->  Any registered content handler type.
//      'tpDocNodeType' ->  The registered node type to use for the mime
//                          type.
//      'extensions'    ->  One or more extensions for this MIME type in
//                          space-separated form ("htm html"). NOTE that not
//                          all MIME types have a unique extension, in
//                          particular the various XML dialects often do not
//                          have unique extensions.

TP.ietf.mime.Type.defineAttribute('info', TP.hc());

//  a placeholder for a reverse-lookup hash from extension to TP.ietf.mime
TP.ietf.mime.Type.defineAttribute('extensionInfo', TP.hc());

//  ------------------------------------------------------------------------

(function() {

    var info;

    info = TP.ietf.mime.get('info');

    info.addAll(
        TP.hc(
            TP.ietf.mime.PLAIN,
                TP.hc('mimetype', TP.ietf.mime.PLAIN,
                        'alias', 'PLAIN',
                        'extensions', 'txt',
                        'tshtag', 'html:span'),
            TP.ietf.mime.CSV,
                TP.hc('mimetype', TP.ietf.mime.CSV,
                        'alias', 'CSV',
                        'extensions', 'csv',
                        'tshtag', 'html:span'),
            TP.ietf.mime.ICAL,
                TP.hc('mimetype', TP.ietf.mime.ICAL,
                        'alias', 'ICAL',
                        'extensions', 'ics',
                        'tshtag', 'html:span'),

            TP.ietf.mime.CSS,
                TP.hc('mimetype', TP.ietf.mime.CSS,
                        'alias', 'CSS',
                        'extensions', 'css',
                        'handler', 'TP.core.CSSStyleSheetContent',
                        'tshtag', 'html:style'),
            TP.ietf.mime.HTML,
                TP.hc('mimetype', TP.ietf.mime.HTML,
                        'alias', 'HTML',
                        'extensions', 'html htm',
                        'tshtag', 'html:html'),
            TP.ietf.mime.ECMASCRIPT,
                TP.hc('mimetype', TP.ietf.mime.ECMASCRIPT,
                        'alias', 'ECMASCRIPT',
                        'handler', 'TP.uri.JSURI',
                        'extensions', 'js jscript',
                        'tshtag', 'tsh:script'),
            TP.ietf.mime.JS,
                TP.hc('mimetype', TP.ietf.mime.JS,
                        'alias', 'JS',
                        'extensions', 'js jscript',
                        'handler', 'TP.uri.JSURI',
                        'tshtag', 'tsh:script'),
            TP.ietf.mime.JSX,
                TP.hc('mimetype', TP.ietf.mime.JSX,
                        'alias', 'JSX',
                        'extensions', 'jsx',
                        'tshtag', 'html:span'),
            TP.ietf.mime.JSON,
                TP.hc('mimetype', TP.ietf.mime.JSON,
                        'alias', 'JSON',
                        'extensions', 'json',
                        'handler', 'TP.core.JSONContent',
                        'tshtag', 'tsh:script'),
            TP.ietf.mime.XHTML,
                TP.hc('mimetype', TP.ietf.mime.XHTML,
                        'alias', 'XHTML',
                        'extensions', 'xhtml xht',
                        'tshtag', 'html:html',
                        'objectNodeType',
                                'TP.html.iframe',
                        'tpDocNodeType', 'TP.dom.XHTMLDocumentNode'),
            TP.ietf.mime.TSH,
                TP.hc('mimetype', TP.ietf.mime.TSH,
                        'alias', 'TSH',
                        'extensions', 'tsh',
                        'handler', 'tsh:script',
                        'tshtag', 'tsh:script'),

            TP.ietf.mime.GIF,
                TP.hc('mimetype', TP.ietf.mime.GIF,
                        'alias', 'GIF',
                        'extensions', 'gif',
                        'handler', 'html:img',
                        'tshtag', 'html:img'),
            TP.ietf.mime.JPEG,
                TP.hc('mimetype', TP.ietf.mime.JPEG,
                        'alias', 'JPEG',
                        'extensions', 'jpg jpeg',
                        'handler', 'html:img',
                        'tshtag', 'html:img'),
            TP.ietf.mime.PNG,
                TP.hc('mimetype', TP.ietf.mime.PNG,
                        'alias', 'PNG',
                        'extensions', 'png',
                        'handler', 'html:img',
                        'tshtag', 'html:img'),
            TP.ietf.mime.FLASH,
                TP.hc('mimetype', TP.ietf.mime.FLASH,
                        'alias', 'FLASH',
                        'extensions', 'swf fla',
                        'objectNodeType',
                                'TP.dom.FlashObjectElementNode',
                        'embedNodeType',
                                'TP.dom.FlashEmbedElementNode',
                        'tshtag', 'html:object'),
            TP.ietf.mime.SILVERLIGHT,
                TP.hc('mimetype', TP.ietf.mime.SILVERLIGHT,
                        'alias', 'SILVERLIGHT',
                        'extensions', 'xaml',
                        'objectNodeType',
                                'TP.dom.SilverlightObjectElementNode',
                        'embedNodeType',
                                'TP.dom.SilverlightEmbedElementNode',
                        'tshtag', 'html:object'),
            TP.ietf.mime.SMIL,
                TP.hc('mimetype', TP.ietf.mime.SMIL,
                        'alias', 'SMIL',
                        'extensions', 'smil'),
            TP.ietf.mime.SVG,
                TP.hc('mimetype', TP.ietf.mime.SVG,
                        'alias', 'SVG',
                        'extensions', 'svg'),

            TP.ietf.mime.XSLT,
                TP.hc('mimetype', TP.ietf.mime.XSLT,
                        'alias', 'XSLT',
                        'extensions', 'xsl xslt',
                        'tpDocNodeType', 'TP.dom.XSLDocumentNode'),

            TP.ietf.mime.ATOM,
                TP.hc('mimetype', TP.ietf.mime.ATOM,
                        'alias', 'ATOM',
                        'extensions', 'atom xml'),
            TP.ietf.mime.RDF,
                TP.hc('mimetype', TP.ietf.mime.RDF,
                        'alias', 'RDF',
                        'extensions', 'rdf'),
            TP.ietf.mime.RSS,
                TP.hc('mimetype', TP.ietf.mime.RSS,
                        'alias', 'RSS',
                        'extensions', 'rss xml',
                        'handler', 'TPRSSContent',
                        'tpDocNodeType', 'TP.rss.RSSFeed'),

            TP.ietf.mime.SOAP,
                TP.hc('mimetype', TP.ietf.mime.SOAP,
                        'alias', 'SOAP'),
            TP.ietf.mime.XMLRPC,
                TP.hc('mimetype', TP.ietf.mime.XMLRPC,
                        'alias', 'XMLRPC'),
            TP.ietf.mime.XML,
                TP.hc('mimetype', TP.ietf.mime.XML,
                        'alias', 'XML',
                        'extensions', 'xml',
                        'tpDocNodeType', 'TP.dom.XMLDocumentNode'),

            TP.ietf.mime.XMPP,
                TP.hc('mimetype', TP.ietf.mime.XMPP,
                        'alias', 'XMPP')
        ));

    //  populate the initial extensions values from the 'info' hash
    TP.ietf.mime.get('info').getValues().perform(
        function(item) {

            var mime,
                exts,
                i;

            mime = item.at('mimetype');
            exts = item.at('extensions');

            if (TP.notEmpty(exts)) {
                exts = exts.split(' ');
                for (i = 0; i < exts.getSize(); i++) {
                    TP.ietf.mime.get('extensionInfo').atPut(exts.at(i), mime);
                }
            }
        });

    return;
}());

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.ietf.mime.Type.defineMethod('getAlias',
function(aMIMEType) {

    /**
     * @method getAlias
     * @summary Returns an easier-to-use 'alias' for the given MIME type. For
     *     instance, if the MIME type is 'application/xhtml+xml' this method
     *     will return the string 'XHTML'.
     * @param {String} aMIMEType The MIME type to return an alias for.
     * @returns {String} An alias for the supplied MIME type or the MIME type
     *     itself if no alias could be found.
     */

    var info;

    //  grab the hash and if we find one return the type/typename
    if (TP.isValid(info = TP.ietf.mime.get('info').at(aMIMEType))) {
        return TP.ifInvalid(info.at('alias'), aMIMEType);
    }

    return aMIMEType;
});

//  ------------------------------------------------------------------------

TP.ietf.mime.Type.defineMethod('getConcreteType',
function(aMIMEType) {

    /**
     * @method getConcreteType
     * @summary Looks up a TIBET Type for the MIME type provided. This type is
     *     used to handle content in an intelligent fashion.
     * @description This method will return any MIME-specific content handler
     *     type which may be registered. The common example in TIBET is the
     *     handler for TP.ietf.mime.CSS which can parse a CSS style sheet,
     *     making CSS content "smarter" than pure text.
     *
     *     By registering MIME types and handlers for specific text formats you
     *     can create intelligent content handlers for your internal document
     *     formats. For this to work properly TIBET has to properly discern the
     *     MIME type for the content. See getMIMEType() for more information.
     * @param {String} aMIMEType The MIME type to return a wrapper type for.
     * @returns {TP.meta.ietf.mime|undefined} A TP.ietf.mime subtype type object.
     */

    var info,
        typeName,
        type;

    //  grab the hash and if we find one return the type/typename
    if (TP.isValid(info = TP.ietf.mime.get('info').at(aMIMEType))) {
        typeName = info.at('handler');

        //  dynaload handler types as needed
        if (TP.notEmpty(typeName)) {
            type = TP.sys.getTypeByName(typeName);
            if (TP.isType(type) && !type.isAbstract()) {
                return type;
            }
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.ietf.mime.Type.defineMethod('getExtensions',
function(aMIMEType) {

    /**
     * @method getExtensions
     * @summary Returns an array of file extensions for the given MIME type.
     *     For instance, if the MIME type is 'application/xhtml+xml' this method
     *     will return ['xht', 'xhtml'].
     * @param {String} aMIMEType The MIME type to look up.
     * @returns {String[]|undefined} An array of strings denoting extensions.
     */

    var info,
        exts;

    //  grab the hash and if we find one return the type/typename
    if (TP.isValid(info = TP.ietf.mime.get('info').at(aMIMEType))) {
        if (TP.notEmpty(exts = info.at('extensions'))) {
            return exts.split(' ');
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.ietf.mime.Type.defineMethod('getExtensionType',
function(anExtension) {

    /**
     * @method getExtensionType
     * @summary Returns the MIME type of the extension provided -- almost
     *     guaranteed to be wrong at least some of the time. When in doubt this
     *     routine defaults to returning text/plain.
     * @param {String} anExtension The extension to try to match a MIME type to.
     * @returns {String} The TP.ietf.mime type constant for the extension, if
     *     found.
     */

    return TP.ifInvalid(
            TP.ietf.mime.get('extensionInfo').at(anExtension.toLowerCase()),
            TP.ietf.mime.PLAIN);
});

//  ------------------------------------------------------------------------

TP.ietf.mime.Type.defineMethod('guessMIMEType',
function(aContent, aURI, defaultMIME) {

    /**
     * @method guessMIMEType
     * @summary Guesses the MIME type of the incoming content data, using a
     *     multi-pronged approach that hopefully provides an accurate answer
     *     based on content testing followed by extension tests.
     * @description This method tries to guess the MIME type of the receiver.
     *     The testing starts with testing for XML and moves on to testing text
     *     content and URI extension information using the TP.ietf.mime 'info'
     *     hash to help with resolution. The specific steps used are: 1. If XML,
     *     try to obtain the namespace of the content node's document's
     *     documentElement, then try to match that to a mime value contained in
     *     the XMLNS 'info' hash. 2. If step #1 fails, try to obtain the
     *     document element name of the content node's document's
     *     documentElement, then try to match that to a 'rootElement' value
     *     contained in the XMLNS 'info' hash. 3. If step #2 fails, and a URI
     *     was provided with the call, try to obtain a MIME type using the
     *     extension from the URI. 4. If step #3 fails and it was XML we default
     *     to TP.ietf.mime.XML, otherwise we default to TP.ietf.mime.PLAIN
     * @param {Node|String} aContent The content, either as a Node or String. If
     *     a Node, then an attempt will be made to use this object to determine
     *     a MIME type. If a String, then this parameter is tested to see if a
     *     Node can be created from it. If so, then Node testing will proceed as
     *     described. If not, then TP.ietf.mime.PLAIN will be returned. This
     *     parameter is optional.
     * @param {TP.uri.URI} aURI The URI that will be used to try to determine
     *     the MIME type, based on its extension. This parameter is optional.
     * @param {String} defaultMIME The MIME type that will be used if one cannot
     *     be determined from either the content or the URI. This parameter is
     *     optional.
     * @returns {String} The MIME type as determined from one of the three
     *     parameters.
     */

    var content,

        node,

        elem,
        ns,
        info,
        mime,
        name,
        item,
        ext;

    TP.ifTrace() && TP.$DEBUG ?
        TP.sys.logTransform(
                TP.annotate(this,
                            'Guessing MIME type for content ID: ' + aURI),
            TP.DEBUG) : 0;

    if (TP.isValid(content = aContent)) {
        //  often get a TP.dom.Node here
        if (TP.canInvoke(content, 'getNativeNode')) {
            node = content.getNativeNode();
        } else if (TP.isNode(content)) {
            node = content;
        } else {
            //  Otherwise, try to turn it into a node (note here we pass 'false'
            //  to avoid reporting errors)
            node = TP.node(content, null, false);
        }
    } else {
        content = '';
    }

    //  If we have valid node content (that's not just a Text node created
    //  above), then we contain some sort of real XML
    if (TP.isNode(node) && !TP.isTextNode(node)) {

        //  Try to get the 'most representative' node from the content.
        elem = TP.nodeGetBestNode(node);

        //  Make sure that this is both an Element *and it doesn't have a
        //  prefix*. This ensures that no prefixed element will be used to
        //  derive MIME type, since it's sort of 'out of band' of the default
        //  content.
        if (TP.isElement(elem) && TP.isEmpty(elem.prefix)) {

            //  If the element has a valid namespace, then use that to try to
            //  look up a 'mimetype' entry in the XMLNS 'info'
            ns = TP.nodeGetNSURI(elem);
            if (TP.notEmpty(ns) &&
                TP.isValid(info = TP.w3.Xmlns.get('info').at(ns))) {
                mime = info.at('mimetype');
            }

            //  If it's not just 'bland' XML, then we go ahead return the
            //  computed MIME type here - otherwise, we go on trying.
            if (TP.notEmpty(mime) && mime !== TP.XML_ENCODED) {
                TP.ifTrace() && TP.$DEBUG ?
                    TP.sys.logTransform('Returning computed MIME type ' +
                                        mime + ' for content ID: ' + aURI,
                        TP.DEBUG) : 0;

                return mime;
            }

            //  for name we want to use local name, no prefix
            name = TP.elementGetLocalName(elem);

            //  Try to look up a 'rootElement' entry in the TP.w3.Xmlns
            //  'info'
            item = TP.w3.Xmlns.get('info').detect(
                function(kvPair) {

                    if (kvPair.last().at('rootElement') === name) {
                        return true;
                    }
                });

            if (TP.isValid(item)) {
                mime = item.last().at('mimetype');
            }

            //  If it's not just 'bland' XML, then we go ahead return the
            //  computed MIME type here - otherwise, we go on trying.
            if (TP.notEmpty(mime) && mime !== TP.XML_ENCODED) {
                TP.ifTrace() && TP.$DEBUG ?
                    TP.sys.logTransform('Returning computed MIME type ' +
                                        mime + ' for content ID: ' + aURI,
                        TP.DEBUG) : 0;

                return mime;
            }
        }

        //  we know it's XML, so we at least want to fall back to that
        //  but we apparently need help determining what kind of XML

        //  if a URI was supplied, see if we can extract the MIME type from
        //  the URI's extension.
        if (TP.isURI(aURI) &&
            TP.isString(ext = TP.uriExtension(aURI.asString()))) {
            mime = TP.ietf.mime.getExtensionType(ext);
        }

        if (TP.isEmpty(mime) || mime === TP.ietf.mime.PLAIN) {
            if (/xml/.test(defaultMIME)) {
                mime = defaultMIME;
            } else {
                mime = TP.ietf.mime.XML;
            }
        }
    } else {
        //  not a node, so some form of text content

        //  If we didn't find a valid MIME type via the URI's extension but
        //  we determine from the content that it's a JSON string, then set
        //  it to TP.ietf.mime.JSON
        if (TP.isJSONString(content)) {
            mime = TP.ietf.mime.JSON;
        }

        //  if a URI was supplied, see if we can extract the MIME type from
        //  the URI's extension.
        if (TP.isEmpty(mime) && TP.isURI(aURI) &&
            TP.isString(ext = TP.uriExtension(aURI.asString()))) {
            mime = TP.ietf.mime.getExtensionType(ext);
        }

        //  If we still haven't found a valid MIME type, then just set it to
        //  either the supplied 'defaultMIME' or TP.ietf.mime.PLAIN if that's
        //  not been supplied.
        if (TP.isEmpty(mime) || mime === TP.ietf.mime.PLAIN) {
            mime = defaultMIME || TP.ietf.mime.PLAIN;
        }
    }

    TP.ifTrace() && TP.$DEBUG ?
        TP.sys.logTransform('Returning computed MIME type ' +
                            mime + ' for content ID: ' + aURI,
            TP.DEBUG) : 0;

    return mime;
});

//  ------------------------------------------------------------------------

TP.ietf.mime.Type.defineMethod('registerMIMEInfo',
function(aMIMEType, aHash) {

    /**
     * @method registerMIMEInfo
     * @summary Registers information about the MIME type provided. If an info
     *     hash already exists the new hash's keys are merged with the existing
     *     registration, replacing any existing values for the new keys, but
     *     preserving other values not defined in the incoming hash.
     * @param {String} aMIMEType A TP.ietf.mime type constant such as
     *     TP.ietf.mime.CSS or the equivalent MIME type string (text/css).
     * @param {TP.core.Hash} aHash A hash whose keys match those defined for
     *     this type.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.meta.ietf.mime} The receiver.
     */

    var info,
        exts,
        i;

    if (TP.notValid(aHash)) {
        return this.raise('TP.sig.InvalidParameter',
                                    'Must provide registration data.');
    }

    info = TP.ietf.mime.get('info').at(aMIMEType);
    if (TP.notValid(info)) {
        info = aHash;
        TP.ietf.mime.get('info').atPut(aMIMEType, info);
    } else {
        //  merge in the keys we need
        TP.ietf.mime.$KEYS.perform(
                function(key) {

                    var val;

                    if (TP.isValid(val = aHash.at(key))) {
                        info.atPut(key, val);
                    }
                });
    }

    //  make sure the MIME type name is also in the hash
    info.atPut('mimetype', aMIMEType);

    //  update the extension list so we can do reverse lookups
    if (TP.notEmpty(exts = info.at('extensions'))) {
        exts = exts.split(' ');
        for (i = 0; i < exts.getSize(); i++) {
            TP.ietf.mime.get('extensionInfo').atPut(exts.at(i), aMIMEType);
        }
    }

    return this;
});

//  ========================================================================
//  TP.w3.Xmlns
//  ========================================================================

/**
 * @type {TP.w3.Xmlns}
 * @summary The TP.w3.Xmlns type provides registration and lookup services for
 *     information about common XML namespaces.
 * @description A large number of TIBET features rely on namespace support,
 *     which requires information regarding common prefixes, MIME types,
 *     document element names, etc. which are all managed by the TP.w3.Xmlns
 *     type.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('w3.Xmlns');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  NB: These constants are defined as an alias to the actual namespace URI
//  of the namespace being registered.

TP.w3.Xmlns.Type.defineConstant(
        'ACL',
        'http://www.technicalpursuit.com/2005/acl');

TP.w3.Xmlns.Type.defineConstant(
        'ACP',
        'http://www.technicalpursuit.com/1999/acp');

TP.w3.Xmlns.Type.defineConstant(
        'BIND',
        'http://www.technicalpursuit.com/2005/binding');

TP.w3.Xmlns.Type.defineConstant(
        'CSSML',
        'http://www.technicalpursuit.com/2008/cssml');

TP.w3.Xmlns.Type.defineConstant(
        'DRAG',
        'http://www.technicalpursuit.com/2005/drag');

TP.w3.Xmlns.Type.defineConstant(
        'DND',
        'http://www.technicalpursuit.com/2005/drag-and-drop');

TP.w3.Xmlns.Type.defineConstant(
        'HTTP',
        'http://www.technicalpursuit.com/2020/http');

TP.w3.Xmlns.Type.defineConstant(
        'LAMA',
        'http://www.technicalpursuit.com/2020/lama');

TP.w3.Xmlns.Type.defineConstant(
        'ON',
        'http://www.technicalpursuit.com/2014/on');

TP.w3.Xmlns.Type.defineConstant(
        'PCLASS',
        'urn:tibet:pseudoclass');

TP.w3.Xmlns.Type.defineConstant(
        'SIGNALS',
        'http://www.technicalpursuit.com/1999/signals');

TP.w3.Xmlns.Type.defineConstant(
        'SHERPA',
        'http://www.technicalpursuit.com/2014/sherpa');

TP.w3.Xmlns.Type.defineConstant(
        'TIBET',
        'http://www.technicalpursuit.com/1999/tibet');

TP.w3.Xmlns.Type.defineConstant(
        'TSH',
        'http://www.technicalpursuit.com/1999/tshell');

TP.w3.Xmlns.Type.defineConstant(
        'UI',
        'http://www.technicalpursuit.com/2015/ui');

TP.w3.Xmlns.Type.defineConstant(
        'XCONTROLS',
        'http://www.technicalpursuit.com/2005/xcontrols');

//  ---

TP.w3.Xmlns.Type.defineConstant(
        'BPEL',
         'http://schemas.xmlsoap.org/ws/2004/03/business-process/');

TP.w3.Xmlns.Type.defineConstant(
        'KML',
        'http://www.opengis.net/kml/2.2');

TP.w3.Xmlns.Type.defineConstant(
        'MATHML',
        'http://www.w3.org/1998/Math/MathML');

TP.w3.Xmlns.Type.defineConstant(
        'RDF',
        'http://www.w3.org/1999/02/22-rdf-syntax-ns#');

TP.w3.Xmlns.Type.defineConstant(
        'RSS20',
        'http://backend.userland.com/rss2');

TP.w3.Xmlns.Type.defineConstant(
        'SMIL',
        'http://www.w3.org/2005/SMIL21/');

TP.w3.Xmlns.Type.defineConstant(
        'SVG',
        'http://www.w3.org/2000/svg');

TP.w3.Xmlns.Type.defineConstant(
        'TMX',
        'http://www.lisa.org/tmx14');

TP.w3.Xmlns.Type.defineConstant(
        'VML',
        'urn:schemas-microsoft-com:vml');

TP.w3.Xmlns.Type.defineConstant(
        'VCARD',
        'urn:ietf:params:xml:ns:vcard-4.0');

TP.w3.Xmlns.Type.defineConstant(
        'VCARD_EXT',
        'http://www.technicalpursuit.com/vcard-ext');

TP.w3.Xmlns.Type.defineConstant(
        'WSDL',
        'http://schemas.xmlsoap.org/wsdl');

TP.w3.Xmlns.Type.defineConstant(
        'XFORMS',
        'http://www.w3.org/2002/xforms');

TP.w3.Xmlns.Type.defineConstant(
        'XHTML',
        'http://www.w3.org/1999/xhtml');

TP.w3.Xmlns.Type.defineConstant(
        'XINCLUDE',
        'http://www.w3.org/2001/XInclude');

TP.w3.Xmlns.Type.defineConstant(
        'XLINK',
        'http://www.w3.org/1999/xlink');

TP.w3.Xmlns.Type.defineConstant(
        'XLINKBASE',
        'http://www.w3.org/1999/xlink/properties/linkbase');

TP.w3.Xmlns.Type.defineConstant(
        'XML',
        'http://www.w3.org/XML/1998/namespace');

TP.w3.Xmlns.Type.defineConstant(
        'XMLNS',
        'http://www.w3.org/2000/xmlns/');   //  NOTE the trailing slash is
                                            //  required on this URI

TP.w3.Xmlns.Type.defineConstant(
        'XML_CATALOG',
        'urn:oasis:names:tc:entity:xmlns:xml:catalog');

TP.w3.Xmlns.Type.defineConstant(
        'XML_EVENTS',
        'http://www.w3.org/2001/xml-events');

TP.w3.Xmlns.Type.defineConstant(
        'XML_SCHEMA',
        'http://www.w3.org/2001/XMLSchema');

TP.w3.Xmlns.Type.defineConstant(
        'XML_SCHEMA_INSTANCE',
        'http://www.w3.org/2001/XMLSchema-instance');

TP.w3.Xmlns.Type.defineConstant(
        'XSLT',
        'http://www.w3.org/1999/XSL/Transform');

TP.w3.Xmlns.Type.defineConstant(
        'XUL',
        'http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul');

//  ---

TP.w3.Xmlns.Type.defineConstant('$KEYS', TP.ac('uri',
                                                'mimetype',
                                                'handler',
                                                'prefix',
                                                'rootElement',
                                                'defaultNodeType',
                                                'transforms',
                                                'native'));

//  ---

//  a sort function that will sort namespaces according to their 'processing
//  priority'. Namespaces that don't have a processing priority will
//  'bubble' to the front of the Array.
TP.w3.Xmlns.Type.defineConstant(
        'PROCESS_ORDER_SORT',
        function(a, b) {

            var aWeight,
                bWeight;

            if (TP.notValid(aWeight = TP.w3.Xmlns.get('info').at(a)) ||
                TP.notValid(aWeight = aWeight.at('procPriority'))) {
                return -1;
            }

            if (TP.notValid(bWeight = TP.w3.Xmlns.get('info').at(b)) ||
                TP.notValid(bWeight = bWeight.at('procPriority'))) {
                return 1;
            }

            return bWeight - aWeight;
        });

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  custom tag and ns detection XPaths used to avoid element-level DOM
//  iterations during content processing
TP.w3.Xmlns.Type.defineAttribute('customNSDetectionXPath');
TP.w3.Xmlns.Type.defineAttribute('customTagDetectionXPath');

TP.w3.Xmlns.Type.defineAttribute('nativePrefixes');
TP.w3.Xmlns.Type.defineAttribute('nativeURIs');
TP.w3.Xmlns.Type.defineAttribute('nonNativePrefixes');
TP.w3.Xmlns.Type.defineAttribute('nonNativeURIs');

//  A String containing all known TP.w3.Xmlns definitions for use in
//  markup. See 'getXMLNSDefs()' below for more information.
TP.w3.Xmlns.Type.defineAttribute('XMLNSDefs');

//  a placeholder for a reverse-lookup hash from prefix to URI
TP.w3.Xmlns.Type.defineAttribute('prefixes', TP.hc());

TP.w3.Xmlns.Type.defineAttribute('info', TP.hc());

//  A list of commonly-used namespaces that get installed on new documents, etc.
TP.w3.Xmlns.Type.defineAttribute('commonNamespaces');

//  A list of implicit XHTML namespace URIs
TP.w3.Xmlns.Type.defineAttribute('$xhtmlURIs');

//  ------------------------------------------------------------------------

(function() {

    //  Define an 'info' hash that will contain the following information
    //  about a particular namespace:
    //      'uri'               ->  A copy of the namespace URI for easier
    //                              lookups.
    //      'mimetype'          ->  Any particular MIME type that
    //                              corresponds to the namespace.
    //      'handler'           ->  The namespace type (or type name) for
    //                              this namespace, usually the type whose
    //                              name is prefix:' for this type's
    //                              canonical prefix.
    //      'prefix'            ->  The commonly used namespace prefix used
    //                              with the namespace.
    //      'rootElement'       ->  Any 'root' (document) element defined
    //                              for the namespace.
    //      'defaultNodeType'   ->  An optional type used to replace
    //                              TP.dom.ElementNode as the default type
    //                              for elements this namespace.
    //      'transforms'        ->  An optional array of XSLT uris for
    //                              transforms that should be run when
    //                              processing content with this namespace
    //                              in it.
    //      'native'            ->  An optional marker for whether the
    //                              namespace is natively supported on the
    //                              current browser. NOTE: this is filled in
    //                              by the TP.core.Browser types.
    //      'procPriority'      ->  An optional number for in what order the
    //                              TIBET markup processing system should
    //                              process this namespace. Higher numbers
    //                              cause the namespace to be processed
    //                              earlier. NB: No two namespaces should
    //                              have the same number.

    var info;

    info = TP.w3.Xmlns.get('info');

    info.addAll(
        TP.hc(
            TP.w3.Xmlns.ACL,
                    TP.hc('uri', TP.w3.Xmlns.ACL,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'acl',
                            'rootElement', ''),
            TP.w3.Xmlns.ACP,
                    TP.hc('uri', TP.w3.Xmlns.ACP,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'acp',
                            'rootElement', ''),
            TP.w3.Xmlns.BIND,
                    TP.hc('uri', TP.w3.Xmlns.BIND,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'bind',
                            'rootElement', '',
                            'defaultNodeType', 'bind:info',
                            'procPriority', 2),
/*
            TP.w3.Xmlns.BPEL,
                    TP.hc('uri', TP.w3.Xmlns.BPEL,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'bpel',
                            'rootElement', 'process'),
*/
            TP.w3.Xmlns.CSSML,
                    TP.hc('uri', TP.w3.Xmlns.CSSML,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'css',
                            'rootElement', 'sheet'),
            TP.w3.Xmlns.DRAG,
                    TP.hc('uri', TP.w3.Xmlns.DRAG,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'drag',
                            'rootElement', '',
                            'defaultNodeType', 'drag:info'),
            TP.w3.Xmlns.DND,
                    TP.hc('uri', TP.w3.Xmlns.DND,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'dnd',
                            'rootElement', '',
                            'defaultNodeType', 'dnd:info'),
            TP.w3.Xmlns.HTTP,
                    TP.hc('uri', TP.w3.Xmlns.HTTP,
                            'prefix', 'http'),
            TP.w3.Xmlns.KML,
                    TP.hc('uri', TP.w3.Xmlns.KML,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'kml',
                            'rootElement', 'kml'),
            TP.w3.Xmlns.LAMA,
                    TP.hc('uri', TP.w3.Xmlns.LAMA,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'lama',
                            'rootElement', ''),
            TP.w3.Xmlns.MATHML,
                    TP.hc('uri', TP.w3.Xmlns.MATHML,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'mml',
                            'rootElement', 'math'),
            TP.w3.Xmlns.ON,
                    TP.hc('uri', TP.w3.Xmlns.ON,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'on'),
            TP.w3.Xmlns.PCLASS,
                    TP.hc('uri', TP.w3.Xmlns.PCLASS,
                            'prefix', 'pclass',
                            'rootElement', ''),
            TP.w3.Xmlns.RDF,
                    TP.hc('uri', TP.w3.Xmlns.RDF,
                            'mimetype', TP.ietf.mime.RDF,
                            'prefix', 'rdf',
                            'rootElement', 'rdf'),
            TP.w3.Xmlns.RSS20,
                    TP.hc('uri', TP.w3.Xmlns.RSS20,
                            'mimetype', TP.ietf.mime.RSS,
                            'prefix', 'rss',
                            'rootElement', 'rss',
                            'defaultNodeType', 'TP.rss.RSSElement'),
            TP.w3.Xmlns.SHERPA,
                    TP.hc('uri', TP.w3.Xmlns.SHERPA,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'sherpa',
                            'rootElement', ''),
            TP.w3.Xmlns.SIGNALS,
                    TP.hc('uri', TP.w3.Xmlns.SIGNALS,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'sig'),
/*
            TP.w3.Xmlns.SMIL,
                    TP.hc('uri', TP.w3.Xmlns.SMIL,
                            'mimetype', TP.ietf.mime.SMIL,
                            'prefix', 'smil',
                            'rootElement', 'smil'),
*/
            TP.w3.Xmlns.SVG,
                    TP.hc('uri', TP.w3.Xmlns.SVG,
                            'mimetype', TP.ietf.mime.SVG,
                            'prefix', 'svg',
                            'rootElement', 'svg'),
            TP.w3.Xmlns.TIBET,
                    TP.hc('uri', TP.w3.Xmlns.TIBET,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'tibet',
                            'rootElement', ''),
            TP.w3.Xmlns.TMX,
                    TP.hc('uri', TP.w3.Xmlns.TMX,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'tmx',
                            'rootElement', 'tmx'),
            TP.w3.Xmlns.TSH,
                    TP.hc('uri', TP.w3.Xmlns.TSH,
                            'mimetype', TP.ietf.mime.TSH,
                            'prefix', 'tsh',
                            'rootElement', 'script'),
            TP.w3.Xmlns.UI,
                    TP.hc('uri', TP.w3.Xmlns.UI,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'ui',
                            'rootElement', ''),
            TP.w3.Xmlns.VCARD,
                    TP.hc('uri', TP.w3.Xmlns.VCARD,
                            'mimetype', TP.ietf.mime.VCARD,
                            'prefix', 'vcard',
                            'rootElement', 'vcard'),
            TP.w3.Xmlns.VCARD_EXT,
                    TP.hc('uri', TP.w3.Xmlns.VCARD_EXT,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'vcard-ext'),
            TP.w3.Xmlns.XCONTROLS,
                    TP.hc('uri', TP.w3.Xmlns.XCONTROLS,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'xctrls',
                            'rootElement', '',
                            'procPriority', 3,
                            'defaultNodeType', 'TP.xctrls.GenericElement'),
            TP.w3.Xmlns.XFORMS,
                    TP.hc('uri', TP.w3.Xmlns.XFORMS,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'xforms',
                            'rootElement', '',
                            'procPriority', 4),
            TP.w3.Xmlns.XHTML,
                    TP.hc('uri', TP.w3.Xmlns.XHTML,
                            'mimetype', TP.ietf.mime.XHTML,
                            'prefix', 'html',
                            'rootElement', 'html',
                            'procPriority', 0),
            TP.w3.Xmlns.XINCLUDE,
                    TP.hc('uri', TP.w3.Xmlns.XINCLUDE,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'xi',
                            'rootElement', ''),
            TP.w3.Xmlns.XLINK,
                    TP.hc('uri', TP.w3.Xmlns.XLINK,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'xlink',
                            'rootElement', ''),
            TP.w3.Xmlns.XML,
                    TP.hc('uri', TP.w3.Xmlns.XML,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'xml',
                            'rootElement', ''),
            TP.w3.Xmlns.XML_CATALOG,
                    TP.hc('uri', TP.w3.Xmlns.XML_CATALOG,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'cat',
                            'rootElement', 'cat:catalog'),
            TP.w3.Xmlns.XML_EVENTS,
                    TP.hc('uri', TP.w3.Xmlns.XML_EVENTS,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'ev',
                            'rootElement', '',
                            'procPriority', 1),
            TP.w3.Xmlns.XMLNS,
                    TP.hc('uri', TP.w3.Xmlns.XMLNS,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'xmlns',
                            'rootElement', ''),
            TP.w3.Xmlns.XML_SCHEMA,
                    TP.hc('uri', TP.w3.Xmlns.XML_SCHEMA,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'xs',
                            'rootElement', 'schema'),
            TP.w3.Xmlns.XML_SCHEMA_INSTANCE,
                    TP.hc('uri', TP.w3.Xmlns.XML_SCHEMA_INSTANCE,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'xsi',
                            'rootElement', ''),
            TP.w3.Xmlns.XSLT,
                    TP.hc('uri', TP.w3.Xmlns.XSLT,
                            'mimetype', TP.ietf.mime.XSLT,
                            'prefix', 'xsl',
                            'rootElement', 'stylesheet'),
            TP.w3.Xmlns.XUL,
                    TP.hc('uri', TP.w3.Xmlns.XUL,
                            'mimetype', TP.ietf.mime.XUL,
                            'prefix', 'xul',
                            'rootElement', ''),
            TP.w3.Xmlns.VML,
                    TP.hc('uri', TP.w3.Xmlns.VML,
                            'mimetype', '',
                            'prefix', 'v',
                            'rootElement', ''),
            TP.w3.Xmlns.WSDL,
                    TP.hc('uri', TP.w3.Xmlns.WSDL,
                            'mimetype', TP.ietf.mime.XML,
                            'prefix', 'wsdl',
                            'rootElement', '')
        ));

    //  populate reference values from the 'info' hash
    TP.w3.Xmlns.get('info').getValues().perform(
        function(item) {
            TP.w3.Xmlns.get('prefixes').atPut(
                                item.at('prefix'),
                                item.at('uri'));
        });

    TP.w3.Xmlns.set('commonNamespaces',
                TP.ac(
                    TP.w3.Xmlns.ACL,
                    TP.w3.Xmlns.BIND,
                    TP.w3.Xmlns.ON,
                    TP.w3.Xmlns.PCLASS,
                    TP.w3.Xmlns.TIBET,
                    TP.w3.Xmlns.TSH,
                    TP.w3.Xmlns.XHTML
                    )
                );

    return;
}());

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('addCommonNSURIsTo',
function(anElement) {

    /**
     * @method addCommonNSURIsTo
     * @summary Adds commonly used namespaces (the list is defined on this
     *     type) to the element.
     * @param {Element} anElement The element to install the namespaces on.
     * @exception TP.sig.InvalidElement
     * @returns {TP.meta.w3.Xmlns} The receiver.
     */

    var namespaces,
        i;

    if (TP.notValid(anElement)) {
        return this.raise('TP.sig.InvalidElement');
    }

    namespaces = this.get('commonNamespaces');

    for (i = 0; i < namespaces.getSize(); i++) {
        this.addNSURITo(namespaces.at(i), anElement);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('addNSURITo',
function(anNSURI, anElement) {

    /**
     * @method addNSURITo
     * @summary Adds the namespace supplied in anNSURI to the element.
     * @description One of the constants available on the TP.w3.Xmlns type must
     *     be used as the URI as this method will try to determine the canonical
     *     prefix to install the namespace under. Otherwise, if a canonical
     *     prefix cannot be found this method will fail. See the lower-level
     *     TP.elementAddNSURI() function to install namespaces (including
     *     default namespaces) that are unknown to the TP.w3.Xmlns type.
     * @param {String} anNSURI A namespace URI, often acquired from a native
     *     node via TP.nodeGetNSURI().
     * @param {Element} anElement The element to install the namespace on.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidURI
     * @returns {TP.meta.w3.Xmlns} The receiver.
     */

    var prefix;

    if (TP.notValid(anElement)) {
        return this.raise('TP.sig.InvalidElement');
    }

    if (TP.notValid(anNSURI)) {
        return this.raise('TP.sig.InvalidURI');
    }

    if (TP.notValid(prefix = this.getCanonicalPrefix(anNSURI))) {
        return this;
    }

    TP.elementAddNSURI(anElement, prefix, anNSURI);

    return this;
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('addTransform',
function(anNSURI, aTransformURI) {

    /**
     * @method addTransform
     * @summary Adds an XSLT tranformation for the namespace which will be used
     *     during content processing.
     * @param {String} anNSURI A namespace URI, often acquired from a native
     *     node via TP.nodeGetNSURI().
     * @param {String} aTransformURI A URI pointing to an XSLT.
     * @exception TP.sig.InvalidURI
     * @returns {String} The canonical prefix, if found.
     */

    var arr,
        info;

    if (TP.notValid(anNSURI)) {
        return this.raise('TP.sig.InvalidURI');
    }

    info = TP.w3.Xmlns.get('info').at(anNSURI.asString());
    if (TP.isValid(info)) {
        arr = info.at('transforms');
        if (TP.notValid(arr)) {
            arr = TP.ac();
            info.atPut('transforms', arr);
        }

        arr.add(aTransformURI);
    }

    return info;
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('computeCustomNSDetectionXPath',
function() {

    /**
     * @method computeCustomNSDetectionXPath
     * @summary Computes and returns an XPath suitable for locating custom
     *     namespaces (i.e. non-native namespaces) in a document or element.
     *     This path is built based on knowledge in the registry of namespace
     *     URI data.
     * @returns {String} An XPath string.
     */

    var nsStr,
        path;

    //  try to be lazy and compute this only once
    if (TP.notEmpty(path = this.$get('customNSDetectionXPath'))) {
        return path;
    }

    //  have to compute it...

    nsStr = TP.ac();

    //  Grab all of the namespaces that are handled natively by this
    //  browser and generate a 'namespace-uri() !=' query around them.
    TP.w3.Xmlns.getNativeNSURIs().perform(
        function(nativeXMLNS) {

            nsStr.push('(namespace-uri() != "', nativeXMLNS, '") and ');
        });

    //  Also, make sure that the namespace-uri() is not empty. We want
    //  default namespaces to fall through.
    nsStr.push('(namespace-uri() != \'\')');

    nsStr = nsStr.join('');

    //  Use the namespace part of the query that we've built in queries for
    //  both elements and attributes. Note that we also ignore elements
    //  (and any of their descendants) that have been tagged with the
    //  'tibet:opaque' flag attribute.
    //  Note here how we write the 'tibet:opaque' attribute test so that no
    //  namespace node is required for namespace resolution.
    path = TP.join(
        'descendant-or-self::*[',
        nsStr,
        ' and not(ancestor-or-self::*/@*[name() = "tibet:opaque"])] | ',
        'descendant-or-self::*/@*[',
        nsStr,
        ' and not(../ancestor-or-self::*/@*[name() = "tibet:opaque"])]');

    //  save it for next time
    this.$set('customNSDetectionXPath', path);

    return path;
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('computeCustomTagDetectionXPath',
function() {

    /**
     * @method computeCustomTagDetectionXPath
     * @summary Computes and returns an XPath suitable for locating custom tags
     *     in a document or element. This path is built based on knowledge in
     *     the registry of namespace URI data.
     * @returns {String} An XPath string.
     */

    var path;

    //  try to be lazy and compute this only once
    if (TP.notEmpty(path = this.$get('customTagDetectionXPath'))) {
        return path;
    }

    //  have to compute it...

    //  Compute an XPath that would detect non-native namespaces and
    //  elements that don't have an 'tibet:opaque' attribute on itself or
    //  any ancestor

    path = TP.ac('descendant-or-self::*[');

    //  Grab all of the namespaces that are handled natively by this
    //  browser and generate a 'not namespace-uri()' query around them.
    TP.w3.Xmlns.getNativeNSURIs().perform(
            function(nativeXMLNS) {

                path.push('(namespace-uri() != "', nativeXMLNS, '") and ');
            });

    //  Also, make sure that the namespace-uri() is not empty. We want
    //  default namespaces to fall through. Note that we also ignore
    //  elements (and any of their descendants) that have been tagged with
    //  the 'tibet:opaque' flag attribute.
    //  Note here how we write the 'tibet:opaque' attribute test so that no
    //  namespace node is required for namespace resolution.
    path.push(
        '(namespace-uri() != \'\')',
        ' and not(ancestor-or-self::*/@*[name() = "tibet:opaque"])]');

    path = path.join('');

    //  save it for next time
    this.$set('customTagDetectionXPath', path);

    return path;
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('fromMIMEType',
function(aMimeType) {

    /**
     * @method fromMIMEType
     * @summary Returns a hash of namespace data corresponding to the supplied
     *     MIME type.
     * @param {String} aMimeType The MIME type to use to retrieve the namespace
     *     data.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.core.Hash|undefined} A hash of data corresponding to the
     *     'info' entries on this type.
     */

    var info,
        xmlnsEntry;

    if (TP.notValid(aMimeType)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    info = TP.w3.Xmlns.get('info');

    xmlnsEntry = info.detect(
                    function(kvPair) {
                        return kvPair.last().at('mimetype') === aMimeType;
                    });

    if (TP.isValid(xmlnsEntry)) {
        return xmlnsEntry.last();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('getCanonicalPrefix',
function(anNSURI) {

    /**
     * @method getCanonicalPrefix
     * @summary Returns the canonical prefix for the namespace URI provided.
     * @param {String} anNSURI A namespace URI, often acquired from a native
     *     node via TP.nodeGetNSURI().
     * @exception TP.sig.InvalidURI
     * @returns {String|undefined} The canonical prefix, if found.
     */

    var info;

    if (TP.notValid(anNSURI)) {
        return this.raise('TP.sig.InvalidURI');
    }

    info = TP.w3.Xmlns.get('info').at(anNSURI.asString());
    if (TP.isValid(info)) {
        return info.at('prefix');
    }

    return;
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('getRootElementName',
function(anNSURI) {

    /**
     * @method getRootElementName
     * @summary Returns the root element tag name for documents in the
     *     namespace provided.
     * @param {String} anNSURI A namespace URI, often acquired from a native
     *     node via TP.nodeGetNSURI().
     * @exception TP.sig.InvalidURI
     * @returns {String} The root element tag name, if appropriate.
     */

    var info;

    if (TP.notValid(anNSURI)) {
        return this.raise('TP.sig.InvalidURI');
    }

    info = TP.w3.Xmlns.get('info').at(anNSURI.asString());
    if (TP.isValid(info)) {
        return TP.ifInvalid(info.at('rootElement'), '');
    }

    return '';
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('getMIMEType',
function(anNSURI) {

    /**
     * @method getMIMEType
     * @summary Returns the default MIME type for the namespace URI provided.
     * @param {String} anNSURI A namespace URI, often acquired from a native
     *     node via TP.nodeGetNSURI().
     * @exception TP.sig.InvalidURI
     * @returns {String|undefined} The MIME type, if found.
     */

    var info;

    if (TP.notValid(anNSURI)) {
        return this.raise('TP.sig.InvalidURI');
    }

    info = TP.w3.Xmlns.get('info').at(anNSURI.asString());
    if (TP.isValid(info)) {
        return info.at('mimetype');
    }

    return;
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('getNativePrefixes',
function() {

    /**
     * @method getNativePrefixes
     * @summary Returns an array of canonical prefixes supported natively on
     *     the current browser.
     * @returns {String[]} The list of native prefixes.
     */

    var arr;

    if (TP.notEmpty(arr = this.$nativePrefixes)) {
        return arr;
    }

    arr = TP.w3.Xmlns.get('info').collect(
        function(item) {

            var val;

            val = item.last();
            if (TP.isTrue(val.at('native'))) {
                return val.at('prefix');
            }

            return;
        });

    arr = arr.select(
                function(item) {

                    return TP.isValid(item);
                });

    this.$nativePrefixes = arr;

    return arr;
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('getNativeNSURIs',
function() {

    /**
     * @method getNativeNSURIs
     * @summary Returns an array of natively supported namespace URIs on the
     *     current browser.
     * @returns {String[]} The list of native namespace URIs.
     */

    var arr;

    if (TP.notEmpty(arr = this.$nativeURIs)) {
        return arr;
    }

    arr = TP.w3.Xmlns.get('info').collect(
        function(item) {

            var val;

            val = item.last();
            if (TP.isTrue(val.at('native'))) {
                return val.at('uri');
            }

            return;
        });

    arr = arr.select(
                function(item) {

                    return TP.isValid(item);
                });

    this.$nativeURIs = arr;

    return arr;
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('getNonNativePrefixes',
function() {

    /**
     * @method getNonNativePrefixes
     * @summary Returns an array of canonical prefixes which are known but not
     *     supported on the current browser.
     * @returns {String[]} The list of non-native prefixes.
     */

    var arr;

    if (TP.notEmpty(arr = this.$nonNativePrefixes)) {
        return arr;
    }

    arr = TP.w3.Xmlns.get('info').collect(
        function(item) {

            var val;

            val = item.last();
            if (TP.notTrue(val.at('native'))) {
                return val.at('prefix');
            }

            return;
        });

    arr = arr.select(
                function(item) {

                    return TP.isValid(item);
                });

    this.$nonNativePrefixes = arr;

    return arr;
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('getNonNativeNSURIs',
function() {

    /**
     * @method getNonNativeNSURIs
     * @summary Returns an array of known URIs which are not native to the
     *     current browser.
     * @returns {String[]} The list of non-native namespace URIs.
     */

    var arr;

    if (TP.notEmpty(arr = this.$nonNativeURIs)) {
        return arr;
    }

    arr = TP.w3.Xmlns.get('info').collect(
        function(item) {

            var val;

            val = item.last();
            if (TP.notTrue(val.at('native'))) {
                return val.at('uri');
            }

            return;
        });

    arr = arr.select(
                function(item) {

                    return TP.isValid(item);
                });

    this.$nonNativeURIs = arr;

    return arr;
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('getNSHandlerForNSURI',
function(anNSURI) {

    /**
     * @method getNSHandlerForNSURI
     * @summary Returns the type responsible for handling the namespace whose
     *     URI is provided, if available.
     * @param {String} anNSURI A namespace URI, often acquired from a native
     *     node via TP.nodeGetNSURI().
     * @returns {TP.meta.core.XMLNamespace} A TP.core.XMLNamespace subtype type
     *     object.
     */

    var info,
        type,
        prefix;

    if (TP.notValid(anNSURI)) {
        return this.raise('TP.sig.InvalidURI');
    }

    info = TP.w3.Xmlns.get('info').at(anNSURI.asString());
    if (TP.isValid(info)) {
        type = info.at('handler');
        if (TP.notEmpty(type)) {
            if (TP.isType(type)) {
                return type;
            }

            if (TP.isString(type)) {
                return TP.sys.getTypeByName(type);
            }
        } else {
            prefix = info.at('prefix');
            if (TP.notEmpty(prefix)) {
                return TP.sys.getTypeByName(prefix + ':');
            }
        }
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('getNSURIForPrefix',
function(aPrefix) {

    /**
     * @method getNSURIForPrefix
     * @summary Returns the namespace URI whose canonical prefix matches the
     *     one provided.
     * @param {String} aPrefix A canonical prefix such as "xforms".
     * @exception TP.sig.InvalidParameter
     * @returns {String|undefined} The namespace URI.
     */

    if (TP.isEmpty(aPrefix)) {
        this.raise('TP.sig.InvalidParameter',
                    'Must supply a prefix.');

        return;
    }

    return this.get('prefixes').at(aPrefix);
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('getTransforms',
function(anNSURI) {

    /**
     * @method getTransforms
     * @summary Returns any registered XSLT transforms for the namespace URI
     *     provided. These are registered when a namespace has custom XSLTs
     *     which can assist with content processing. See the process call in
     *     TP.core.XMLNamespace for more info.
     * @param {String} anNSURI A namespace URI, often acquired from a native
     *     node via TP.nodeGetNSURI().
     * @exception TP.sig.InvalidURI
     * @returns {String[]|undefined} An array or undefined if no transforms are
     *     registered.
     */

    var info;

    if (TP.notValid(anNSURI)) {
        return this.raise('TP.sig.InvalidURI');
    }

    info = TP.w3.Xmlns.get('info').at(anNSURI.asString());
    if (TP.isValid(info)) {
        return info.at('transforms');
    }

    return;
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('getPrefixForNSURI',
function(anNSURI, aNode) {

    /**
     * @method getPrefixForNSURI
     * @summary Returns the prefix used for the URI provided, either in
     *     canonical terms, or specifically within the node provided.
     * @param {String} anNSURI A namespace URI, often acquired from a native
     *     node via TP.nodeGetNSURI().
     * @param {Node} aNode The node (document or element) for which a prefix is
     *     required.
     * @returns {String} The first declared namespace prefix.
     */

    var prefixes,
        prefix;

    //  when there's no node we'll just use the canonical one
    if (!TP.isNode(aNode)) {
        return this.getCanonicalPrefix(anNSURI);
    }

    //  if we've got a node we'll see if it has a different prefix for that
    //  URI
    prefixes = TP.nodeGetNSPrefixes(aNode, anNSURI);
    if (TP.notEmpty(prefixes)) {
        prefix = prefixes.at(0);
    }

    return TP.ifEmpty(prefix, this.getCanonicalPrefix(anNSURI));
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('getXHTMLNSURIs',
function() {

    /**
     * @method getXHTMLNSURIs
     * @summary Returns an array of namespace URIs which are implicitly part of
     *     the XHTML5 specification.
     * @returns {String[]} The list of XHTML namespace URIs.
     */

    var nsURIs;

    nsURIs = this.get('$xhtmlURIs');

    if (TP.notEmpty(nsURIs)) {
        return nsURIs;
    }

    nsURIs = TP.ac(TP.w3.Xmlns.XHTML,
                    TP.w3.Xmlns.MATHML,
                    TP.w3.Xmlns.SVG);

    this.set('$xhtmlURIs', nsURIs);

    return nsURIs;
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('getXMLNSDefs',
function() {

    /**
     * @method getXMLNSDefs
     * @summary Returns a string containing all known XMLNS definitions that
     *     have been registered. This string is added to node creation text when
     *     command tags are entered so that input doesn't have to include xmlns
     *     declarations.
     * @returns {String} A string of xmlns declarations.
     */

    var defs,
        arr;

    //  Note here how we use '$get()' to avoid recursion.
    if (TP.notEmpty(defs = this.$get('XMLNSDefs'))) {
        return defs;
    }

    arr = TP.ac();
    TP.w3.Xmlns.get('prefixes').perform(
                    function(item) {

                        if (TP.notEmpty(item.first()) &&
                            TP.notEmpty(item.last())) {
                            //  skip xml and xmlns declarations, they just
                            //  cause bugs
                            if (item.first().startsWith('xml')) {
                                return;
                            }

                            arr.push(' xmlns:', item.first(),
                                        '="', item.last(), '"');
                        }
                    });

    defs = arr.join('');

    //  Slice off the leading space
    defs = defs.slice(1);

    this.set('XMLNSDefs', defs);

    return defs;
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('isNativeNS',
function(anNSURI) {

    /**
     * @method isNativeNS
     * @summary Returns true if the namespace URI is natively supported on the
     *     current browser. Note that the result of this call is
     *     browser-specific.
     * @param {String} anNSURI A namespace URI, often acquired from a native
     *     node via TP.nodeGetNSURI().
     * @exception TP.sig.InvalidURI
     * @returns {Boolean} True if the namespace is natively supported.
     */

    var info;

    if (TP.notValid(anNSURI)) {
        return this.raise('TP.sig.InvalidURI');
    }

    info = TP.w3.Xmlns.get('info').at(anNSURI.asString());
    if (TP.isValid(info)) {
        //  not registered? then default to false
        return TP.ifEmpty(info.at('native'), false);
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('isNativeMarkup',
function(aMarkupString) {

    /**
     * @method isNativeMarkup
     * @summary Returns true if *all* of the namespace URIs in the supplied
     *     markup are considered to belong to native namespaces. If just one is
     *     not, then this method will return false.
     * @param {String} aMarkupString The markup string to test.
     * @exception TP.sig.InvalidString
     * @returns {Boolean} True if the markup contains namespaces that are
     *     natively supported.
     */

    var testElement;

    if (TP.notValid(aMarkupString)) {
        return this.raise('TP.sig.InvalidString');
    }

    if (!TP.regex.STARTS_WITH_ELEM_MARKUP.test(aMarkupString)) {
        return false;
    }

    //  Create an Element from the supplied markup so that we can extract the
    //  namespace URIs from it. Note how we specify a null default namespace and
    //  ask *not* to report errors from the parsing process here. We're only
    //  interested in whether we get a valid Element or not.
    testElement = TP.elem(aMarkupString, null, false);
    if (TP.isElement(testElement)) {
        return this.isNativeNode(testElement);
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('isNativeNode',
function(aNode) {

    /**
     * @method isNativeNode
     * @summary Returns true if *all* of the namespace URIs on the supplied
     *     node are considered to belong to native namespaces. If just one is
     *     not, then this method will return false.
     * @param {Document|Element} aNode The node to test.
     * @exception TP.sig.InvalidNode
     * @returns {Boolean} True if the node contains namespaces that are
     *     natively supported.
     */

    var testNode,

        isNative,

        allNSURIs,
        len,
        i;

    if (!TP.isDocument(aNode) && !TP.isElement(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    if (TP.isDocument(aNode)) {
        testNode = aNode.documentElement;
    } else {
        testNode = aNode;
    }

    isNative = true;

    //  Grab all of the namespace URIs, supplying true as the second
    //  parameter here to get all of the namespace URIs 'deeply'.
    allNSURIs = TP.nodeGetNSURIs(testNode, true);

    //  Iterate and if any of the detected namespaces are not native, flip
    //  the flag to false and break.
    len = allNSURIs.getSize();
    for (i = 0; i < len; i++) {
        if (!TP.w3.Xmlns.isNativeNS(allNSURIs.at(i))) {
            isNative = false;
            break;
        }
    }

    return isNative;
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('registerNSInfo',
function(anNSURI, aHash) {

    /**
     * @method registerNSInfo
     * @summary Registers information about the namespaceURI provide, merging
     *     the data from aHash if an entry already exists for that URI.
     * @param {String} anNSURI A namespace URI, often acquired from a native
     *     node via TP.nodeGetNSURI().
     * @param {TP.core.Hash} aHash A hash whose keys match those defined for
     *     this type.
     * @exception TP.sig.InvalidURI
     * @exception TP.sig.InvalidParameter
     * @returns {TP.meta.w3.Xmlns} The receiver.
     */

    var uriStr,

        allInfos,

        newPrefix,

        allKeys,

        len,
        i,

        prefix,

        info,
        constName;

    if (TP.notValid(anNSURI)) {
        return this.raise('TP.sig.InvalidURI');
    }

    if (TP.notValid(aHash)) {
        return this.raise('TP.sig.InvalidParameter',
                                    'Must provide registration data.');
    }

    uriStr = anNSURI.asString();

    //  we do this just in case since there may be changes to our
    //  computation of XPaths when the registration data changes
    this.$set('customNSDetectionXPath', null);
    this.$set('customTagDetectionXPath', null);

    //  clear any caches for prefixes or uris
    this.$set('nativePrefixes', null);
    this.$set('nativeURIs', null);
    this.$set('nonNativePrefixes', null);
    this.$set('nonNativeURIs', null);

    //  clear the xmlns definitions used for qualifying markup
    this.$set('XMLNSDefs', null);

    allInfos = TP.w3.Xmlns.get('info');

    //  If the caller is trying to define a new prefix, make sure one hasn't
    //  already been defined.
    newPrefix = aHash.at('prefix');

    if (TP.notEmpty(newPrefix)) {

        allKeys = TP.keys(allInfos);
        len = allKeys.getSize();

        for (i = 0; i < len; i++) {
            prefix = allInfos.at(allKeys.at(i)).at('prefix');
            if (TP.notEmpty(prefix) && prefix === newPrefix) {
                return this.raise(
                        'TP.sig.InvalidParameter',
                        'Namespace prefix already defined: ' + prefix);
            }
        }
    }

    info = allInfos.at(uriStr);
    if (TP.notValid(info)) {
        info = aHash;
        allInfos.atPut(uriStr, info);
    } else {
        //  merge in the keys we need
        TP.w3.Xmlns.$KEYS.perform(
                function(key) {

                    var val;

                    if (TP.isValid(val = aHash.at(key))) {
                        info.atPut(key, val);
                    }
                });
    }

    //  make sure the URI key is also in the hash
    info.atPut('uri', uriStr);

    //  update the prefix list so we can do reverse lookups by prefix
    if (TP.notEmpty(newPrefix)) {
        TP.w3.Xmlns.get('prefixes').atPut(newPrefix, uriStr);

        //  as a final step, register an uppercase version of the prefix with
        //  the TP.w3.Xmlns type.

        constName = newPrefix.toUpperCase();
        if (TP.notValid(TP.w3.Xmlns[constName])) {
            TP.w3.Xmlns.Type.defineConstant(constName, uriStr);
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.w3.Xmlns.Type.defineMethod('unregisterNSInfo',
function(anNSURI) {

    /**
     * @method unregisterNSInfo
     * @summary Removes any information about the namespaceURI provided. This
     *     method can be used prior to a registerNamespace call to clear any
     *     pre-existing registration data.
     * @param {String} anNSURI A namespace URI, often acquired from a native
     *     node via TP.nodeGetNSURI().
     * @exception TP.sig.InvalidURI
     * @returns {TP.meta.w3.Xmlns} The receiver.
     */

    var info;

    if (TP.notValid(anNSURI)) {
        return this.raise('TP.sig.InvalidURI');
    }

    info = TP.w3.Xmlns.get('info').at(anNSURI.asString());
    if (TP.isValid(info)) {
        info.removeKey(anNSURI.asString());

        //  we do this just in case since there may be changes to our
        //  computation of XPaths when the registration data changes
        this.$set('customNSDetectionXPath', null);
        this.$set('customTagDetectionXPath', null);
    }

    return this;
});

//  ========================================================================
//  TP.core.XMLNamespace
//  ========================================================================

/**
 * @type {TP.core.XMLNamespace}
 * @summary This type is the common supertype of all objects representing XML
 *     namespaces in the TIBET system.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.XMLNamespace');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.XMLNamespace.Type.defineMethod('activate',
function(declarationName, declarationValue, affectedElements) {

    /**
     * @method activate
     * @summary Activates the supplied CSS declaration.
     * @description At this level, this method does nothing. Subtypes must
     *     implement this to provide real functionality.
     * @param {String} declarationName The name of the declaration.
     * @param {String} declarationValue The value of the declaration.
     * @param {Element[]} affectedElements An Array of the elements that were
     *     affected that the custom CSS declaration might need to change.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.core.XMLNamespace.Type.defineMethod('deactivate',
function(declarationName, declarationValue, affectedElements) {

    /**
     * @method deactivate
     * @summary Deactivates the supplied CSS declaration.
     * @description At this level, this method does nothing. Subtypes must
     *     implement this to provide real functionality.
     * @param {String} declarationName The name of the declaration.
     * @param {String} declarationValue The value of the declaration.
     * @param {Element[]} affectedElements An Array of the elements that were
     *     affected that the custom CSS declaration might need to change.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.core.XMLNamespace.Type.defineMethod('getCanonicalName',
function() {

    /**
     * @method getCanonicalName
     * @summary Returns the receiver's canonical tag name. For namespace types,
     *     this is the tag prefix (usually corresponding to the tag type's
     *     namespace) followed by a colon (':').
     * @returns {String} The receiver's tag name.
     */

    return this.get('nsPrefix') + ':';
});

//  ========================================================================
//  TP.core.XHTMLNamespace
//  ========================================================================

/**
 * @type {TP.html.XMLNS}
 * @summary Represents the XHTML namespace (http://www.w3.org/1999/xhtml) in
 *     the tag processing system.
 */

//  ------------------------------------------------------------------------

TP.core.XMLNamespace.defineSubtype('html.XMLNS');

//  ========================================================================
//  TP.core.XIncludeNamespace
//  ========================================================================

/**
 * @type {TP.xi.XMLNS}
 * @summary The XInclude namespace (http://www.w3.org/2001/XInclude).
 */

//  ------------------------------------------------------------------------

TP.core.XMLNamespace.defineSubtype('xi.XMLNS');

//  ========================================================================
//  TP.core.XSLTNamespace
//  ========================================================================

/**
 * @type {TP.xsl.XMLNS}
 * @summary The XSLT namespace (http://www.w3.org/1999/XSL/Transform).
 */

//  ------------------------------------------------------------------------

TP.core.XMLNamespace.defineSubtype('xsl.XMLNS');

//  ========================================================================
//  TP.core.Cookie
//  ========================================================================

/**
 * @type {TP.core.Cookie}
 * @summary TP.core.Cookie provides simple utility routines for setting and
 *     getting browser cookie values.
 * @description The storage format is basically an escaped source code form so
 *     you can do the following:
 *
 *     TP.core.Cookie.setCookie('name', someObject); ... myObj =
 *     TP.core.Cookie.getCookie('name');
 *
 *     At the end of this little sequence, someObject.equalTo(myObj) will be
 *     true for the most common cases.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.Cookie');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.Cookie.Type.defineMethod('cookiesEnabled',
function() {

    /**
     * @method cookiesEnabled
     * @summary Returns true if cookies appear to be enabled in the current
     *     environment.
     * @returns {Boolean} True if cookies are enabled, false if they are not.
     */

    var testCookie,
        testValue,
        result;

    testCookie = TP.genID();
    testValue = TP.genID();

    this.setCookie(testCookie, testValue);

    try {
        result = this.getCookie(testCookie);
    } catch (e) {
        return false;
    }

    return result === testValue;
});

//  ------------------------------------------------------------------------

TP.core.Cookie.Type.defineMethod('getCookie',
function(aName) {

    /**
     * @method getCookie
     * @summary Returns the value of the named cookie or undefined.
     * @description The value returned is a source-code form string derived from
     *     the original object so using eval on it will effectively construct a
     *     new instance of the original object -- provided that you are working
     *     primarily with hashes or arrays etc.
     * @param {String} aName The name of the desired cookie.
     * @returns {String|undefined} The value of the cookie matching the supplied
     *     name.
     */

    var cooky;

    cooky = document.cookie;
    if (cooky === '') {
        //  no cookies
        return;
    }

    return this.getCookieFromText(aName, cooky);
});

//  ------------------------------------------------------------------------

TP.core.Cookie.Type.defineMethod('getCookieFromText',
function(aName, aCookieText) {

    /**
     * @method getCookieFromText
     * @summary Returns the value of the named cookie or null.
     * @param {String} aName The name of the desired cookie.
     * @param {String} aCookieText The text to extract the cookie from.
     * @returns {Object|undefined} The value of the cookie matching the supplied
     *     name and the supplied chunk of cookie text.
     */

    var start,
        end,

        result;

    start = aCookieText.indexOf(aName + '=');
    if (start === TP.NOT_FOUND) {
        //  not found
        return;
    }

    end = aCookieText.indexOf(';', start + aName.getSize());
    if (end === TP.NOT_FOUND) {
        end = aCookieText.getSize();
    }

    //  slice off the 'name=' portion and return just the value. Note that
    //  we encodeURI()'ed out semicolons, commas, spaces, etc. since cookies
    //  cannot have those in them in the setCookie() method, so we have to
    //  decodeURI() them here.
    result = decodeURI(aCookieText.slice(
                        start + aName.getSize() + 1, end));

    return result;
});

//  ------------------------------------------------------------------------

TP.core.Cookie.Type.defineMethod('removeCookie',
function(aName, aPath, aDomain) {

    /**
     * @method removeCookie
     * @summary Removes the named cookie.
     * @param {String} aName The name of the cookie to remove.
     * @param {String} aPath The path of the cookie to remove.
     * @param {String} aDomain The domain of the cookie to remove.
     * @returns {Boolean} Whether the cookie was successfully removed or not.
     */

    return this.setCookie(aName,
                            '',
                            TP.dc().subtractDuration('P1Y'),
                            aPath,
                            aDomain);
});

//  ------------------------------------------------------------------------

TP.core.Cookie.Type.defineMethod('setCookie',
function(aName, aValue, expiresAt, aPath, aDomain, wantsSecurity) {

    /**
     * @method setCookie
     * @summary Sets the value of the named cookie with associated params. The
     *     values and rules for the various params are documented in most JS
     *     texts. See JSTDG3 for a good discussion.
     * @param {String} aName The cookie name.
     * @param {String} aValue The cookie value.
     * @param {Date} expiresAt The cookie expiration date/time.
     * @param {String} aPath The cookie's path.
     * @param {String} aDomain An alternate cookie domain.
     * @param {Boolean} wantsSecurity Whether security is desired.
     * @returns {Boolean} Whether the cookie was successfully set or not.
     */

    var cooky;

    if (TP.notValid(aName) || TP.notValid(aValue)) {
        return false;
    }

    //  Note that we encodeURI() out things like semicolons, commas, spaces,
    //  etc. since cookies cannot have those in them. We decodeURI() them in
    //  the getCookieFromText() method.
    cooky =
        TP.join(
            aName,
            '=',
            encodeURI(aValue),
            TP.notValid(expiresAt) ? '' : '; expires=' +
                                                expiresAt.toGMTString(),
            TP.notTrue(wantsSecurity) ? '' : '; secure',
            TP.isEmpty(aDomain) ? '' : '; domain=' + aDomain,
            TP.isEmpty(aPath) ? '' : '; path=' + aPath
        );

    //  Try to set the cookie. If it fails, return false.
    try {
        document.cookie = cooky;
    } catch (e) {
        return false;
    }

    return true;
});

//  ------------------------------------------------------------------------
//  CONTENT METHODS
//  ------------------------------------------------------------------------

TP.core.Cookie.Type.defineMethod('load',
function(aURI, aRequest, logError) {

    /**
     * @method load
     * @summary Loads URI data content and returns it on request. This is a
     *     template method which defines the overall process used for loading
     *     URI data and ensuring that the URI's cache and header content are
     *     kept up to date. You should normally override one of the more
     *     specific load* methods in subtypes if you're doing custom load
     *     handling.
     * @param {TP.uri.URI} aURI The URI to load. NOTE that this URI will not
     *     have been rewritten/ resolved.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @param {Boolean} logError Whether or not this call logs errors if the
     *     data cannot be retrieved.
     * @exception TP.sig.InvalidURI
     * @exception TP.sig.InvalidRequest
     * @returns {TP.sig.Response} A valid response object for the request.
     */

    var request,
        response,

        cookie;

    if (TP.notValid(aURI)) {
        return this.raise('TP.sig.InvalidURI');
    }

    if (TP.notValid(aRequest)) {
        return this.raise('TP.sig.InvalidRequest');
    }

    request = TP.request(aRequest);
    response = request.getResponse();

    cookie = this.getCookie(aURI.get('cname'));

    request.set('result', cookie);

    return response;
});

//  ------------------------------------------------------------------------

TP.core.Cookie.Type.defineMethod('delete',
function(aURI, aRequest) {

    /**
     * @method delete
     * @summary Deletes the target URL.
     * @param {TP.uri.URI} aURI The URI to delete. NOTE that this URI will not
     *     have been rewritten/ resolved.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @exception TP.sig.InvalidURI
     * @exception TP.sig.InvalidRequest
     * @returns {TP.sig.Response} A valid response object for the request.
     */

    var request,
        response;

    if (TP.notValid(aURI)) {
        return this.raise('TP.sig.InvalidURI');
    }

    if (TP.notValid(aRequest)) {
        return this.raise('TP.sig.InvalidRequest');
    }

    request = TP.request(aRequest);
    response = request.getResponse();

    if (!this.removeCookie(aURI.get('cname'),
                                        aURI.get('path'),
                                        aURI.get('domain'))) {
        request.fail();
    }

    return response;
});

//  ------------------------------------------------------------------------

TP.core.Cookie.Type.defineMethod('save',
function(aURI, aRequest) {

    /**
     * @method save
     * @summary Attempts to save data using standard TIBET save primitives to
     *     the URI (after rewriting) that is provided.
     * @param {TP.uri.URI} aURI The URI to save. NOTE that this URI will not
     *     have been rewritten/ resolved.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @exception TP.sig.InvalidURI
     * @exception TP.sig.InvalidRequest
     * @returns {TP.sig.Response} A valid response object for the request.
     */

    var request,
        response,

        contentToSet,
        query;

    if (TP.notValid(aURI)) {
        return this.raise('TP.sig.InvalidURI');
    }

    if (TP.notValid(aRequest)) {
        return this.raise('TP.sig.InvalidRequest');
    }

    request = TP.request(aRequest);
    response = request.getResponse();

    //  Grab the content either from the request body or from the receiver.
    contentToSet = TP.ifInvalid(
                        request.at('body'),
                        aURI.getContent());

    contentToSet = TP.str(contentToSet);

    //  Make sure and set a result type (which normally wouldn't be there
    //  for 'save' requests), so that we get some sort of value back.
    request.atPut('resultType', TP.TEXT);

    query = aURI.get('queryDict');
    if (TP.notValid(query)) {
        query = TP.hc();
    }

    if (!this.setCookie(aURI.get('cname'),
                                    contentToSet,
                                    query.at('expires'),
                                    aURI.get('path'),
                                    aURI.get('domain'),
                                    query.at('secure'))) {
        request.fail();
    }

    return response;
});

//  ========================================================================
//  TP.uri.CookieURL
//  ========================================================================

/**
 * @type {TP.uri.CookieURL}
 * @summary A subtype of TP.uri.URL specific to the 'cookie://' scheme.
 * @description The overall format of a cookie URI is:
 *
 *     cookie://[domain]/[path]/[cookie_name]?[expires=<value>]&[secure=true]
 *
 *
 * @example

 *     Session #1. Store the data in the default domain and path. This will be
 *     cached in the URI until its cache is flushed or this session is shutdown
 *     and another one started:
 *
 *     myCookieURI = TP.uc('cookie:///last_visited');
 *
 *     Set the content to a Date of 'now':
 *
 *     myCookieURI.setContent(TP.dc().asString()); myCookieURI.save();
 *
 *     Session #2. Read the data back:
 *
 *     myCookieURI = TP.uc('cookie:///last_visited');
 *
 *     fetch the content and cache it in the URL the first time:
 *
 *     myCookieURI.getResource().get('result'); // -> Returns the date set
 *
 *     OR Fetch the content and ignore the URL cache, going to the database each
 *     time:
 *
 *     myCookieURI.getResource(TP.hc('refresh', true)).get('result'); -> The
 *     date set.
 *
 *     Session #3. Store the data using non-default values:
 *
 *     Set a cookie for the 'foo.com' domain, storing the data along the
 *     'user_info' path under the 'last_visited' cookie name. Also, set security
 *     to false and the expiration date to 'now + 2 days':
 *
 *     myCookieURI = TP.uc(
 *          TP.join('cookie://foo.com/user_info/last_visited?expires="',
 *          encodeURIComponent(TP.dc().addDuration('P2D')), '"&secure=false'));
 *
 *     Set the content to a Date of 'now':
 *
 *     myCookieURI.setContent(TP.dc().asString()); myCookieURI.save();
 *
 *     Fetch the content and cache it in the URL the first time:
 *
 *     myCookieURI.getResource().get('result'); // -> Returns the date set
 */

//  ------------------------------------------------------------------------

TP.uri.URL.defineSubtype('CookieURL');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  This RegExp splits up the URL into the following components:
//  cookie://[domain]/[path]/[cookie_name]?[expires=<value>]&[secure=true]
TP.uri.CookieURL.Type.defineConstant('COOKIE_REGEX',
        TP.rc('cookie://([^/]*)/?([^?]+)\\??(\\S*)'));

TP.uri.CookieURL.Type.defineConstant('SCHEME', 'cookie');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  'cookie:' scheme is sync-only so configure for that
TP.uri.CookieURL.Type.defineAttribute('supportedModes',
                                    TP.core.SyncAsync.SYNCHRONOUS);
TP.uri.CookieURL.Type.defineAttribute('mode',
                                    TP.core.SyncAsync.SYNCHRONOUS);

TP.uri.CookieURL.registerForScheme('cookie');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  note that there are 'scheme', 'path' and 'fragment' ivars on
//  TP.uri.URI / TP.uri.URL
TP.uri.CookieURL.Inst.defineAttribute('domain');
TP.uri.CookieURL.Inst.defineAttribute('path');

//  The cookie name
TP.uri.CookieURL.Inst.defineAttribute('cname');

TP.uri.CookieURL.Inst.defineAttribute('queryDict');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.uri.CookieURL.Type.defineMethod('$getDefaultHandler',
function(aURI, aRequest) {

    /**
     * @method $getDefaultHandler
     * @summary Return the default URI handler type for this URI type.
     * @param {TP.uri.URI|String} aURI The URI to obtain the default handler
     *     for.
     * @param {TP.sig.Request} aRequest The request whose values should inform
     *     the routing assignment.
     * @returns {TP.meta.uri.URIHandler} A TP.uri.URIHandler subtype type
     *     object.
     */

    return TP.core.Cookie;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.uri.CookieURL.Inst.defineMethod('init',
function(aURIString) {

    /**
     * @method init
     * @summary Initialize the instance.
     * @param {String} aURIString A String containing a proper URI.
     * @returns {TP.uri.CookieURL|undefined} A new instance.
     */

    var results,
        pathAndName,

        uriQuery,
        queryDict;

    this.callNextMethod();

    //  Run the type's RegExp and grab the pieces of the URL.
    results = this.getType().COOKIE_REGEX.exec(aURIString);
    if (TP.notValid(results)) {
        return;
    }

    this.set('domain', results.at(1));

    pathAndName = results.at(2);
    if (pathAndName.contains('/')) {
        this.set('path',
                    '/' + pathAndName.slice(0, pathAndName.indexOf('/')));
        this.set('cname',
                    pathAndName.slice(pathAndName.indexOf('/') + 1));
    } else {
        this.set('path', '/');
        this.set('cname', pathAndName);
    }

    //  If there are parameters in the query, process them into a hash.
    if (TP.notEmpty(uriQuery = results.at(3))) {
        //  Construct a hash from the query string.
        queryDict = TP.core.Hash.fromString(uriQuery);

        this.set('queryDict', queryDict);

        if (TP.isEmpty(this.get('queryDict').at('expires'))) {
            this.get('queryDict').atPut(
                    'expires',
                    TP.dc(TP.dc().setFullYear(TP.dc().getFullYear() + 1)));
        }
    }

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETBrowserTypesPre.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.core.Browser}
 * @summary A type containing common data and functions for the browser.
 * @description TP.core.Browser is responsible for containing browser-specific
 *     features such as event registration and dispatch functions.
 *
 *     This type is also registered under the global 'browser' to make it
 *     symmetric with the 'window' and 'document' globals with which it is
 *     associated.
 *
 *     Note that this type loads in sections, the first section provides the
 *     common functionality and base methods, the second section is loaded via
 *     the boot system's conditional loading model so that browser-specific
 *     implementations of certain methods are loaded, completing the type's
 *     definition.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.Browser');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  note dependency on TP.ietf.mime object here
TP.core.Browser.Type.defineConstant('DEFAULT_MIME_TYPE', TP.ietf.mime.HTML);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.core.Browser.Type.defineAttribute('nativeNamespacesInstalled', false);
TP.core.Browser.Type.defineAttribute('nonNativeNamespacesInstalled', false);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.Browser.Type.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    return '[' + TP.tname(this) + ' :: ' + 'browser' + ']';
});

//  ------------------------------------------------------------------------

TP.core.Browser.Type.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver. By
     *     default this method returns the receiver's string value without
     *     changes.
     * @returns {String} The receiver in HTML string format.
     */

    return 'browser';
});

//  ------------------------------------------------------------------------

TP.core.Browser.Type.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} A new String containing the 'pretty print' string of
     *     the receiver.
     */

    return 'browser';
});

//  ------------------------------------------------------------------------

TP.core.Browser.Type.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns the string representation of the receiver. The
     *     TP.core.Browser type is special here, it returns the string
     *     'browser', which is intended to mirror 'window', 'document', and
     *     similar terms.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the TP.core.Browser's String representation. The default is true.
     * @returns {String} The browser string.
     */

    return 'browser';
});

//  ------------------------------------------------------------------------

TP.core.Browser.Type.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver. By
     *     default this method returns the receiver's string value without
     *     changes.
     * @returns {String} The receiver in XML string format.
     */

    return 'browser';
});

//  ========================================================================
//  Browser Signals
//  ========================================================================

/*
Signaling support types related to browser/window/document operations.
*/

//  ------------------------------------------------------------------------
//  TP.sig.DocumentSignal
//  ------------------------------------------------------------------------

/**
 * @type {TP.sig.DocumentSignal}
 * @summary The supertype of both TP.sig.DocumentLoaded and
 *     TP.sig.DocumentUnloaded which can provide the window's global ID that the
 *     document is being loaded into or unloaded from.
 */

//  ------------------------------------------------------------------------

TP.sig.Signal.defineSubtype('DocumentSignal');

TP.sig.DocumentSignal.Type.isControllerSignal(true);
TP.sig.DocumentSignal.isControllerRoot(true);

//  ------------------------------------------------------------------------

TP.sig.DocumentSignal.Inst.defineMethod('getWindowName',
function() {

    /**
     * @method getWindowName
     * @summary Returns the global ID of the window that the page was loaded
     *     into or unloaded out of.
     * @returns {String} The global ID of the Window.
     */

    return this.getPayload();
});

//  ------------------------------------------------------------------------
//  TP.sig.DocumentUnloaded
//  ------------------------------------------------------------------------

TP.sig.DocumentSignal.defineSubtype('DocumentUnloaded');

//  ------------------------------------------------------------------------
//  TP.sig.DocumentLoaded
//  ------------------------------------------------------------------------

TP.sig.DocumentSignal.defineSubtype('DocumentLoaded');

//  ------------------------------------------------------------------------
//  TP.sig.DocumentVisibility
//  ------------------------------------------------------------------------

TP.sig.DocumentSignal.defineSubtype('DocumentVisibility');
TP.sig.DocumentVisibility.defineSubtype('DocumentVisible');
TP.sig.DocumentVisibility.defineSubtype('DocumentInvisible');

//  ------------------------------------------------------------------------

/**
 * @type {TP.sig.WindowSignal}
 * @summary A window-related signal type which provides the supertype for
 *     TP.sig.WindowClosed and other window events.
 */

//  ------------------------------------------------------------------------

TP.sig.Signal.defineSubtype('WindowSignal');

//  ------------------------------------------------------------------------

TP.sig.WindowSignal.Inst.defineMethod('getWindowName',
function() {

    /**
     * @method getWindowName
     * @summary Returns the global ID of the window involved in activity.
     * @returns {String} The global ID of the Window.
     */

    return this.getPayload();
});

//  ------------------------------------------------------------------------
//  TP.sig.WindowClosed
//  ------------------------------------------------------------------------

TP.sig.WindowSignal.defineSubtype('WindowClosed');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETBrowserTypesBase.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @subject Common extensions to TP.core.Browser.
 */

//  ------------------------------------------------------------------------

TP.core.Browser.Type.defineMethod('installNativeNamespaces',
function() {

    /**
     * @method installNativeNamespaces
     * @summary Installs namespace support for tag processing for namespaces
     *     that are natively supported on this browser.
     * @returns {TP.meta.core.Browser} The receiver.
     */

    //  We only install the native namespaces if they haven't been installed
    //  yet and then we flip the flag so that they don't get installed
    //  again.
    if (!this.get('nativeNamespacesInstalled')) {
        TP.w3.Xmlns.registerNSInfo(TP.w3.Xmlns.XML,
                                        TP.hc('native', true));
        TP.w3.Xmlns.registerNSInfo(TP.w3.Xmlns.XHTML,
                                        TP.hc('native', true));
        TP.w3.Xmlns.registerNSInfo(TP.w3.Xmlns.XSLT,
                                        TP.hc('native', true));
        TP.w3.Xmlns.registerNSInfo(TP.w3.Xmlns.TIBET,
                                        TP.hc('native', true));
        TP.w3.Xmlns.registerNSInfo(TP.w3.Xmlns.SVG,
                                        TP.hc('native', true));

        this.set('nativeNamespacesInstalled', true);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Browser.Type.defineMethod('installNonNativeNamespaces',
function() {

    /**
     * @method installNonNativeNamespaces
     * @summary Installs namespace support for tag processing for namespaces
     *     that are not natively supported on this browser.
     * @returns {TP.meta.core.Browser} The receiver.
     */

    //  We only install the non-native namespaces if they haven't been
    //  installed yet and then we flip the flag so that they don't get
    //  installed again.
    if (!this.get('nonNativeNamespacesInstalled')) {
        this.set('nonNativeNamespacesInstalled', true);
    }

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETBrowserTypesPost.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETUICanvasTypesPre.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.core.UICanvas
//  ========================================================================

/**
 * @type {TP.core.UICanvas}
 * @summary A type intended to be used as a trait type for objects which
 *     provide UI canvas support such as windows, frames, iframes, and the
 *     Mozilla "canvas" object.
 * @description UI canvases are the surfaces you use to display content to the
 *     user. In TIBET these can be a variety of things including windows,
 *     iframes, and canvas objects. When dealing with IFRAME elements in
 *     particular there are a few complexities since an IFRAME exists within a
 *     window and document, but also "contains" a window and document, what
 *     TIBET refers to as the "content window" and "content document". For many
 *     other types these are synonyms for the window and document, but it's
 *     important to use the "content" versions of the API when you want to work
 *     with a canvas's content rather than its container.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.UICanvas');

//  This type is intended to be used as a trait type only, so don't allow
//  instance creation
TP.core.UICanvas.isAbstract(true);

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.UICanvas.Inst.defineMethod('getCanvasID',
function() {

    /**
     * @method getCanvasID
     * @summary Returns the canvas ID for the receiver. For non-canvas elements
     *     this is the ID of their containing canvas (window, iframe, or canvas
     *     object). For canvases themselves it is the global ID of the canvas.
     * @returns {String} The canvas's global ID.
     */

    return this.getGlobalID();
});

//  ------------------------------------------------------------------------

TP.core.UICanvas.Inst.defineMethod('getContentDocument',
function() {

    /**
     * @method getContentDocument
     * @summary Returns a TP.dom.Document instance wrapping the receiver's
     *     document object. To get the native document object use
     *     getNativeDocument.
     * @returns {TP.dom.Document}
     */

    //  rely on the content window so we can leverage caching behavior
    return this.getContentWindow().getContentDocument();
});

//  ------------------------------------------------------------------------

TP.core.UICanvas.Inst.defineMethod('getContentNode',
function() {

    /**
     * @method getContentNode
     * @summary Returns the native node of the TP.dom.DocumentNode wrapping
     *     the receiver's document object.
     * @returns {TP.dom.Document}
     */

    //  rely on the content window so we can leverage caching behavior
    return this.getContentWindow().getContentDocument();
});

//  ------------------------------------------------------------------------

TP.core.UICanvas.Inst.defineMethod('getContentWindow',
function() {

    /**
     * @method getContentWindow
     * @summary Returns the content window (that is the 'contained window') of
     *     the receiver as a TP.core.Window wrapper.
     * @returns {TP.core.Window} The Window contained by the receiver.
     */

    //  NOTE that TP.core.Window's are uniqued so this instance is usually
    //  being reused at the TP.core.Window level
    return TP.core.Window.construct(this.getNativeContentWindow());
});

//  ------------------------------------------------------------------------

TP.core.UICanvas.Inst.defineMethod('getGlobalID',
function(assignIfAbsent) {

    /**
     * @method getGlobalID
     * @summary Returns the global ID for the receiver.
     * @param {Boolean} assignIfAbsent True if an ID should be assigned when one
     *     isn't present. Default is false.
     * @returns {String} The canvas's global ID.
     */

    return TP.gid(this.getNativeContentWindow(), assignIfAbsent);
});

//  ------------------------------------------------------------------------

TP.core.UICanvas.Inst.defineMethod('getLocalID',
function(assignIfAbsent) {

    /**
     * @method getLocalID
     * @summary Returns the local ID for the receiver.
     * @param {Boolean} assignIfAbsent True if an ID should be assigned when one
     *     isn't present. Default is false.
     * @returns {String} The canvas's local ID.
     */

    return TP.lid(this.getNativeContentWindow(), assignIfAbsent);
});

//  ------------------------------------------------------------------------

TP.core.UICanvas.Inst.defineMethod('getNativeContentDocument',
function() {

    /**
     * @method getNativeContentDocument
     * @summary Returns the content document (that is the contained 'document')
     *     of the receiver in a TP.dom.Document wrapper.
     * @returns {TP.dom.Document} The Document object contained by the
     *     receiver.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.core.UICanvas.Inst.defineMethod('getNativeContentWindow',
function() {

    /**
     * @method getNativeContentWindow
     * @summary Returns the content window (that is the 'contained window') of
     *     the receiver.
     * @returns {Window} The Window object contained by the receiver.
     */

    return TP.nodeGetWindow(this.getNativeContentDocument());
});

//  ------------------------------------------------------------------------
//  DNU/Backstop
//  ------------------------------------------------------------------------

TP.core.UICanvas.Inst.defineMethod('canResolveDNU',
function(anOrigin, aMethodName, anArgArray, callingContext) {

    /**
     * @method canResolveDNU
     * @summary Provides an instance that has triggered DNU machinery with an
     *     opportunity to handle the problem itself. For TP.core.Window and
     *     other UI canvas types we typically check the native window and the
     *     content document to see if either one can respond reasonably to the
     *     method.
     * @param {Object} anOrigin The object asking for help. The receiver in this
     *     case.
     * @param {String} aMethodName The method name that failed.
     * @param {Object[]} anArgArray Optional arguments to function.
     * @param {Function|arguments} callingContext The calling context.
     * @returns {Boolean} TRUE means resolveDNU() will be called. FALSE means
     *     the standard DNU machinery will continue processing. The default is
     *     TRUE for TP.dom.Node subtypes.
     */

    var win,
        doc;

    //  TODO:   is this something to raise() about?
    if (TP.isEmpty(aMethodName)) {
        return false;
    }

    win = this.getContentWindow();

    //  watch out for recursion by drilling down another level when the
    //  canvas's content window wrapper is the canvas object itself
    if (win === this) {
        win = this.getNativeContentWindow();
    }

    //  if it's a callable (non-dnu) function we can resolve it
    if (TP.canInvoke(win, aMethodName)) {
        return true;
    }

    //  if the window object wrapper can answer then we'll defer to it
    if (TP.canInvoke(win, 'canResolveDNU')) {
        return win.canResolveDNU(anOrigin,
                                    aMethodName,
                                    anArgArray,
                                    callingContext);
    }

    //  "phase two", check the document
    doc = this.getContentDocument();

    if (TP.canInvoke(doc, aMethodName)) {
        return true;
    }

    if (TP.canInvoke(doc, 'canResolveDNU')) {
        return doc.canResolveDNU(anOrigin,
                                    aMethodName,
                                    anArgArray,
                                    callingContext);
    }

    //  out of options
    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.core.UICanvas.Inst.defineMethod('resolveDNU',
function(anOrigin, aMethodName, anArgArray, callingContext) {

    /**
     * @method resolveDNU
     * @summary Invoked by the main DNU machinery when the instance has
     *     responded TRUE to canResolveDNU() for the parameters given.
     * @description Handles resolution of methods which have triggered the
     *     inferencer. For TP.core.Window the resolution process is used in
     *     conjunction with method aspects to allow the receiver to translate
     *     method calls.
     * @param {Object} anOrigin The object asking for help.
     * @param {String} aMethodName The method name that failed.
     * @param {Object[]} anArgArray Optional arguments to function.
     * @param {Function|arguments} callingContext The calling context.
     * @returns {Object} The result of invoking the method using the native
     *     window object.
     */

    var win,
        func;

    //  some canvases can leverage the content window object wrappers
    if (TP.notValid(win = this.getContentWindow())) {
        return this.raise('TP.sig.InvalidCanvas');
    }

    //  watch out for recursion by drilling down another level when the
    //  canvas's content window wrapper is the canvas object itself
    if (win === this) {
        if (TP.notValid(win = this.getNativeContentWindow())) {
            return this.raise('TP.sig.InvalidCanvas');
        }
    }

    try {
        if (!TP.isCallable(func = win[aMethodName])) {
            return win.resolveDNU(anOrigin,
                                    aMethodName,
                                    anArgArray,
                                    callingContext);
        }
    } catch (e) {
        TP.ifError() ?
                TP.error(
                    TP.ec(e, 'Unable to resolve DNU: ' + aMethodName)) : 0;
    }

    //  If there weren't any arguments in the arg array, then we have
    //  only to call the func.
    if (TP.notValid(anArgArray) || anArgArray.length === 0) {
        //  Return the execution of the func
        return win.func();
    }

    //  Return the application of the func using the array of
    //  arguments as the argument array for invocation.
    return func.apply(win, anArgArray);
});

//  ------------------------------------------------------------------------
//  Content
//  ------------------------------------------------------------------------

TP.core.UICanvas.Inst.defineMethod('getContentMIMEType',
function() {

    /**
     * @method getContentMIMEType
     * @summary Returns the receiver's "content MIME type", that is the MIME
     *     type that the receiver can render most effectively.
     * @returns {String} The receiver's MIME type.
     */

    return this.getContentDocument().getContentMIMEType();
});

//  ------------------------------------------------------------------------

TP.core.UICanvas.Inst.defineMethod('setContent',
function(aContentObject, aRequest) {

    /**
     * @method setContent
     * @summary Sets the content of the receiver's native DOM counterpart to
     *     the node supplied.
     * @param {Object} aContentObject An object to use for content.
     * @param {TP.sig.Request} aRequest A request containing control parameters.
     * @returns {TP.dom.Node} The result of setting the content of the
     *     receiver.
     */

    return this.getContentDocument().setContent(aContentObject, aRequest);
});

//  ========================================================================
//  TP.core.Window
//  ========================================================================

/**
 * @type {TP.core.Window}
 * @summary TP.core.Window is a top-level type for wrapping windows and frames.
 * @description In TIBET you typically operate with documents and elements via
 *     the TP.dom.Node hierarchy. The TP.core.Window hierarchy is intended to
 *     provide functional support for window-level operations. When creating a
 *     TP.core.Window the specific subtype vended back on construct().
 *
 *     The registerWindow function constructs a hash of information for each
 *     window managed by this object and which are used by various methods in
 *     the system to handle onload events, etc. There are several keys which get
 *     registered with this hash:
 *
 *     'nativeWindow' -> A reference to the native Window. 'tpWindow' -> A
 *     TP.core.Window object that acts the 'wrapper' for the window.
 *     'loadFunctions' -> An Array of Functions to run when the Window's
 *     document is (re)loaded. This Array is cleared after every onload is
 *     fired. 'shouldAwake' -> A Boolean that determines whether or not to
 *     awaken content that has just been written into the window's document,
 *     completely replacing the document's current content. This flag is cleared
 *     after every onload is fired.
 *
 *     Keep in mind that TP.core.Window instances are fundamentally wrappers
 *     around native windows and frames, they are not some form of OS-level
 *     window themselves.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.Window');

//  Trait in UI canvas behavior, then any methods we define will override the
//  defaults (this would be true in any case unless we force overrides)
TP.core.Window.addTraits(TP.core.UICanvas);

TP.core.Window.Inst.resolveTraits(TP.ac('canResolveDNU', 'resolveDNU'),
                                    TP.core.UICanvas);

//  ------------------------------------------------------------------------

TP.definePrimitive('tpwin',
function(anObject) {

    /**
     * @method tpwin
     * @summary A general purpose routine that can return a TP.core.Window
     *     based on a variety of input object types.
     * @param {Object} anObject A window, node, or other object which can
     *     provide a TP.core.Window or be used to acquire one.
     * @returns {TP.core.Window|undefined} A TIBET window wrapper.
     */

    var win;

    if (TP.notValid(anObject)) {
        return TP.core.Window.construct();
    } else if (TP.isWindow(anObject)) {
        return TP.core.Window.construct(anObject);
    } else if (TP.isElement(anObject) &&
                (anObject.tagName.toLowerCase() === 'iframe' ||
                    anObject.tagName.toLowerCase() === 'object')) {
        return TP.core.Window.construct(
                                TP.elementGetIFrameWindow(anObject));
    } else if (TP.isKindOf(anObject, TP.core.Window)) {
        return anObject;
    } else if (TP.isNode(anObject)) {
        if (TP.notValid(win = TP.nodeGetWindow(anObject))) {
            return;
        }

        return TP.core.Window.construct(win);
    } else if (TP.isKindOf(anObject, TP.dom.Node)) {
        return anObject.getWindow();
    }

    return;
});

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  the default window spec for instances of this type
TP.core.Window.Type.defineAttribute('$defaultWindowSpec');

//  hash containing window information by global ID
TP.core.Window.Type.defineAttribute('windowRegistry', TP.hc());

//  a slot used by various system files to tell if the window's document is
//  currently being written into.
TP.core.Window.Type.defineAttribute('$isDocumentWriting');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.Window.Type.defineMethod('construct',
function(aWindow, aName, aSpec) {

    /**
     * @method construct
     * @summary Constructs a new instance of the receiver, or returns the
     *     previously constructed instance for the window provided. When
     *     creating a new window you can provide a URI, name, and specification
     *     (feature) string/hash as with open().
     * @param {Window|String} aWindow A window handle. If the handle is an
     *     actual window reference a proper subtype is returned. If the handle
     *     is a string the assumption is a new OS window object if no '.' is in
     *     the name.
     * @param {String} aName The name to give this window. This must be unique.
     * @param {TP.core.Hash|String} aSpec A 'spec string' of key=value pairs or
     *     a hash that can be used to produce a feature string. You should use
     *     'top' and 'left' on all browsers and TIBET will convert as needed.
     * @returns {TP.core.Window} The new instance.
     */

    var theWindow,
        inst;

    //  If no valid native window was supplied, then execute the type's
    //  open method. It will turn around and execute this method with
    //  a native window handle
    if (TP.notValid(aWindow)) {
        //  This will call us back -- we definitely need to return here
        return TP.core.Window.open('', aName, aSpec);
    }

    if (TP.isString(aWindow) && TP.regex.VALID_WINDOWNAME.test(aWindow)) {
        theWindow = TP.sys.getWindowById(aWindow);
        if (!TP.isWindow(theWindow)) {
            return this.raise('WindowNotFound', aWindow);
        }
    } else if (!TP.isWindow(aWindow)) {
        //  NOTE that we want to ensure that the object provided is at least
        //  a kind of the receiving type, otherwise we can't return it
        if (!TP.isKindOf(aWindow, this)) {
            return this.raise('TP.sig.InvalidParameter');
        } else {
            //  It's already a TP.core.Window, return it.
            return aWindow;
        }
    } else {
        //  It's a native window...wrap it below.
        theWindow = aWindow;
    }

    //  if we've got an instance registered for this window we can return it
    inst = TP.core.Window.getWindowInfo(theWindow, 'tpWindow');
    if (TP.isValid(inst)) {
        return inst;
    }

    //  allocate and build the instance
    inst = this.callNextMethod();

    //  ensure the window can integrate with TIBET
    TP.core.Window.instrument(theWindow);

    //  register the window for easy reference/uniquing
    TP.core.Window.registerWindow(theWindow);
    TP.core.Window.setWindowInfo(theWindow, 'tpWindow', inst);

    return inst;
});

//  ------------------------------------------------------------------------

TP.core.Window.Type.defineMethod('closeRegisteredWindows',
function() {

    /**
     * @method closeRegisteredWindows
     * @summary Closes any "auxillary" windows opened by TIBET. Typically
     *     called when you exit the TIBET window.
     * @returns {TP.meta.core.Window} The receiver.
     */

    var dict,
        keys;

    dict = this.get('windowRegistry');
    keys = TP.keys(dict);

    keys.perform(
        function(key) {

            var win,
                info;

            info = dict.at(key);
            win = info.at('nativeWindow');

            if (TP.isWindow(win)) {
                //  don't operate on the codebase window or its children
                if (win !== top && win.parent !== top) {
                    win.close();
                }
            }
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Window.Type.defineMethod('getOpenWindows',
function() {

    /**
     * @method getOpenWindows
     * @summary Returns an array of all windows TIBET is aware of (registered
     *     windows) that are open.
     * @returns {Window[]} An array of native window instances.
     */

    var dict,
        keys,
        arr;

    arr = TP.ac();

    dict = this.get('windowRegistry');
    keys = TP.keys(dict);

    keys.perform(
        function(key) {

            var win,
                info;

            info = dict.at(key);
            win = info.at('nativeWindow');

            if (TP.isWindow(win) && !win.closed) {
                arr.push(win);
            }
        });

    return arr;
});

//  ------------------------------------------------------------------------

TP.core.Window.Type.defineMethod('getWindowInfo',
function(aWindowOrID, aKey) {

    /**
     * @method getWindowInfo
     * @summary Return the hash of information (load signals, onload signals,
     *     etc.) for the window, or window ID and key provided. If no key is
     *     provided the entire hash of window information is returned.
     * @param {Window|String} aWindowOrID The window, or window ID to use as the
     *     first key.
     * @param {String} aKey The key into the specific window's info hash.
     * @returns {Object} The value registered for the key provided.
     */

    var winID,
        dict;

    //  get the ID
    winID = TP.gid(aWindowOrID);

    dict = TP.core.Window.get('windowRegistry').at(winID);

    //  when we have a hash and key we return the value we find
    if (TP.isValid(dict) && TP.notEmpty(aKey)) {
        return dict.at(aKey);
    }

    //  may or may not be a hash, but there's also no key so we return
    //  the hash if there is one
    return dict;
});

//  ------------------------------------------------------------------------

TP.core.Window.Type.defineMethod('getWindowSpec',
function() {

    /**
     * @method getWindowSpec
     * @summary Returns the window specification hash used by default when
     *     creating instances of this type.
     * @returns {TP.core.Hash}
     */

    return this.$get('$defaultWindowSpec');
});

//  ------------------------------------------------------------------------

TP.core.Window.Type.defineMethod('getWindowType',
function() {

    /**
     * @method getWindowType
     * @summary Returns the type object which should be used to construct new
     *     instances of OS window wrappers.
     * @returns {TP.meta.core.Window} The TP.core.Window type object.
     */

    return this.$get('defaultWindowType').asType();
});

//  ------------------------------------------------------------------------

TP.core.Window.Type.defineMethod('installWindowBase',
function(aWindow) {

    /**
     * @method installWindowBase
     * @summary Installs a set of common functions onto aWindow to enhance that
     *     window's capability within the TIBET framework.
     * @param {The} aWindow window to install the TIBET functionality on.
     * @returns {TP.meta.core.Window} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Window.Type.defineMethod('installDocumentBase',
function(aWindow) {

    /**
     * @method installDocumentBase
     * @summary Instruments the document belonging to aWindow with TIBET
     *     specific functions.
     * @param {Window} aWindow The window of the document to install the
     *     functions on.
     * @returns {TP.meta.core.Window} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Window.Type.defineMethod('instrument',
function(aWindow) {

    /**
     * @method instrument
     * @summary Instruments a native window to set it up for use with TIBET.
     * @description This method instruments a native window to provide common
     *     facilities to consumers of the window, such as component acquisition,
     *     DHTML or event facilties. This also includes setting the opener, the
     *     onerror handler, etc.
     * @param {Window|TP.core.Window} aWindow The window to instrument.
     * @returns {TP.meta.core.Window} The receiver.
     */

    var nativeWindow;

    if (TP.isWindow(aWindow)) {
        nativeWindow = aWindow;
    } else if (TP.isKindOf(aWindow, TP.core.Window)) {
        nativeWindow = aWindow.getNativeWindow();
    } else {
        return this.raise('TP.sig.InvalidWindow');
    }

    //  NB: Do this again in case the 'native window' call from above is not
    //  valid
    if (TP.notValid(nativeWindow)) {
        return this.raise('TP.sig.InvalidWindow');
    }

    //  If the native window is already instrumented, return here.
    if (TP.windowIsInstrumented(nativeWindow)) {
        return this;
    }

    //  Set the other common TIBET root objects, used for constants etc.
    nativeWindow.TP = window.TP;

    //  Set the native window's onerror handler to the standard TIBET
    //  onerror handler, so that errors that occur in the window are
    //  processed by the TIBET error handling system.
    nativeWindow.onerror = TP.sys.onerror;

    //  install common (base) functions on window/document
    TP.core.Window.installWindowBase(nativeWindow);
    TP.core.Window.installDocumentBase(nativeWindow);

    //  install custom (extension) functions on window/document
    TP.core.Window.installWindowExtensions(nativeWindow);
    TP.core.Window.installDocumentExtensions(nativeWindow);

    //  Go ahead and set the flag that we have been instrumented. Putting
    //  this window in the window registry really has nothing to do with
    //  whether we were instrumented or not.
    nativeWindow.$$instrumented = true;

    //  If the window is an iframe window, make sure that its name is set to
    //  the id of the iframe element holding it.
    if (TP.isIFrameWindow(nativeWindow)) {
        nativeWindow.name = nativeWindow.frameElement.id;
    }

    //  Assign ids to common elements, such as the root element, the head
    //  element and the body element.
    TP.windowAssignCommonIds(nativeWindow);

    //  Register the native window
    TP.core.Window.registerWindow(nativeWindow);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Window.Type.defineMethod('open',
function(url, aName, aSpec, shouldReplace) {

    /**
     * @method open
     * @summary Constructs a new TP.core.Window instance (having retrieved a
     *     real native window to go underneath it and having set it up for use
     *     with TIBET).
     * @param {TP.uri.URI|String} url The URL to load into the window.
     * @param {String} aName The name to give this window. This must be unique.
     * @param {TP.core.Hash|String} aSpec A 'spec string' of key=value pairs or
     *     a hash that can be used to produce a feature string. You should use
     *     'top' and 'left' on all browsers and TIBET will convert as needed.
     * @param {Boolean} shouldReplace Whether the content should be replaced if
     *     the window is already open.
     * @returns {Window} The newly constructed window.
     */

    var theURL,
        theName,
        win,
        newWindow;

    //  if the URI is blank ('') this will return null
    theURL = TP.uc(url);
    if (TP.notValid(theURL)) {
        //  use the application-specific "blank" so we stay consistent with
        //  the application's look and feel requirements while avoiding
        //  Mozilla's about:blank noise
        theURL = TP.uc(TP.sys.cfg('path.blank_page'));
    }

    theURL = theURL.getLocation();

    //  Don't let any windows get constructed without a unique name
    if (TP.isEmpty(aName)) {
        theName = TP.getNextWindowName();
    } else {
        theName = aName;
    }

    //  NOTE that our TP.open() call will convert the spec for us, and that
    //  we ignore the URI for now so the open will be synchronous

    /* eslint-disable no-extra-parens */
    if ((win = TP.open('', theName, aSpec, shouldReplace))) {
        //  we have to have a valid win reference here or the construct call
        //  will call back to TP.open() and we'll recurse
        newWindow = this.construct(win);
        newWindow.setLocation(theURL);

        return newWindow;
    }
    /* eslint-enable no-extra-parens */

    //  Couldn't get a real native window so there's no sense in creating a
    //  wrapper. Return null here.
    return null;
});

//  ------------------------------------------------------------------------

TP.core.Window.Type.defineMethod('registerOnloadFunction',
function(aWindowOrID, aFunction, runFirst) {

    /**
     * @method registerOnloadFunction
     * @summary Registers a function to be executed when the onload is fired in
     *     the window provided. Since this registration is separate from the
     *     actual existence of the window (you can register by ID) this can be
     *     done without requiring the window to exist.
     * @param {Window|String} aWindowOrID The window, or window ID to use as the
     *     first key.
     * @param {Function} aFunction The function to register which will be run
     *     when the 'onload' event is triggered for aWindow.
     * @param {Boolean} runFirst Whether or not the function should run before
     *     the other functions in the list.
     * @returns {TP.meta.core.Window} The receiver.
     */

    var shouldRunFirst,

        winID,
        arr;

    shouldRunFirst = TP.ifInvalid(runFirst, false);

    //  get the ID value
    winID = TP.gid(aWindowOrID);

    //  note that we build this array lazily
    arr = TP.core.Window.getWindowInfo(winID, 'loadFunctions');
    if (TP.notValid(arr)) {
        arr = TP.ac();
        TP.core.Window.setWindowInfo(winID, 'loadFunctions', arr);
    }

    if (shouldRunFirst) {
        arr.unshift(aFunction);
    } else {
        arr.add(aFunction);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Window.Type.defineMethod('registerWindow',
function(aWindow) {

    /**
     * @method registerWindow
     * @summary Registers aWindow with the window information registry.
     * @description If aWindow is already registered with the window registry,
     *     this method will just return. Otherwise, it will check to make sure
     *     that this window isn't registered under another name (it might have
     *     been, if it was registered before the real global ID could have been
     *     computed). If it isn't found it will be registered and a new
     *     information hash will be constructed for it.
     * @param {Window} aWindow The window to register.
     * @returns {TP.meta.core.Window} The receiver.
     */

    var winID,
        info,
        registry,
        foundOne;

    if (!TP.isWindow(aWindow)) {
        return this.raise('TP.sig.InvalidWindow');
    }

    //  get the ID
    winID = TP.gid(aWindow);

    //  If aWindow is already registered under its globalID
    info = TP.core.Window.getWindowInfo(winID);
    if (TP.notEmpty(info) && info.at('nativeWindow') === aWindow) {
        return this;
    }

    //  Otherwise, make sure its not registered under another name. This
    //  window might have registered under another name if its globalID
    //  couldn't have been computed at the time of registration. If one is
    //  found, reregister it under the new globalID
    foundOne = false;

    registry = TP.core.Window.get('windowRegistry');

    registry.perform(
        function(itemPair) {

            if (TP.notValid(itemPair) || TP.notValid(itemPair.last())) {
                foundOne = false;
            } else {
                if (itemPair.last().at('nativeWindow') === aWindow) {
                    registry.replaceKey(itemPair.first(), winID);
                    foundOne = true;
                }
            }
        });

    if (foundOne) {
        return this;
    }

    //  if we found a hash for that key, but the window reference has
    //  shifted for some reason, we'll update our map
    if (TP.notEmpty(info)) {
        info.atPut('nativeWindow', aWindow);
    } else {
        //  Otherwise, it's completely new so put a new information
        //  hash into the registry (note here that we also capture the
        //  window's because on Mozilla 1.8+, this reference will be reset
        //  if we don't capture it here).
        registry.atPut(winID, TP.hc('nativeWindow', aWindow));
    }

    //  make sure the window's ID is a unique global value
    if (TP.notValid(TP.global[winID])) {
        //  make the window's ID a global handle to it
        TP.global[winID] = aWindow;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Window.Type.defineMethod('removeWindowInfo',
function(aWindowOrID, aKey) {

    /**
     * @method removeWindowInfo
     * @summary Removes a value in the window's information hash, or the entire
     *     hash when no key is provided.
     * @param {Window|String} aWindowOrID The window, or window ID to use as the
     *     first key.
     * @param {String} aKey The key into the specific window's info hash.
     * @returns {TP.meta.core.Window} The receiver.
     */

    var winID,
        dict,
        registry;

    //  get the ID
    winID = TP.gid(aWindowOrID);

    registry = TP.core.Window.get('windowRegistry');

    if (TP.notValid(dict = registry.at(winID))) {
        return this;
    }

    //  no key? remove hash entirely
    if (TP.isEmpty(aKey)) {
        registry.removeKey(winID);
    } else {
        dict.removeKey(aKey);
    }

    //  TODO: Should we also remove window info for iframes that may be
    //  embedded in this window?

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Window.Type.defineMethod('$setWindowContent',
function(aWindowOrID, theContent, aLoadedFunction) {

    /**
     * @method $setWindowContent
     * @summary Sets the content of aWindowOrID's window to the content
     *     provided. The content is typically specified as a URI string whose
     *     content is acquired and processed.
     * @param {Window|String} aWindowOrID The window or window name.
     * @param {String|URI|Node} theContent The content.
     * @param {Function} aLoadedFunction An optional 'loaded' function that will
     *     execute when the content is finished loading.
     * @returns {TP.meta.core.Window} The receiver.
     */

    var win,
        url,
        resp,
        content;

    win = TP.sys.getWindowById(aWindowOrID);
    if (TP.notValid(win)) {
        this.raise('TP.sig.InvalidWindow',
                    'Unable to find window: ' + aWindowOrID);

        return this;
    }

    if (TP.isString(theContent)) {
        url = TP.uc(theContent);
        if (TP.isURI(url)) {
            //  NB: We assume 'async' false here.
            resp = url.getResource(TP.hc('async', false));
            content = resp.get('result');
        } else {
            content = theContent;
        }
    } else if (TP.isNode(theContent)) {
        content = theContent;
    } else if (TP.isKindOf(theContent, TP.uri.URI)) {
        //  NB: We assume 'async' false here.
        resp = theContent.getResource(TP.hc('async', false));
        content = resp.get('result');
    } else {
        this.raise('TP.sig.InvalidParameter');

        return this;
    }

    //  TODO: feed the content to the shell for processing...
    TP.htmlDocumentSetContent(win.document, content, aLoadedFunction);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Window.Type.defineMethod('setWindowInfo',
function(aWindowOrID, aKey, aValue) {

    /**
     * @method setWindowInfo
     * @summary Sets a value in the window's information hash. When the hash
     *     doesn't exist yet it is constructed as a result of this call.
     * @param {Window|String} aWindowOrID The window, or window ID to use as the
     *     first key.
     * @param {String} aKey The key into the specific window's info hash.
     * @param {Object} aValue The value to set for the key.
     * @returns {TP.meta.core.Window} The receiver.
     */

    var winID,
        registry,
        dict;

    //  get the ID
    winID = TP.gid(aWindowOrID);

    registry = TP.core.Window.get('windowRegistry');

    if (TP.notValid(dict = registry.at(winID))) {
        dict = TP.hc();
        registry.atPut(winID, dict);
    }

    dict.atPut(aKey, aValue);

    return this;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  the id (global ID) of our native window
TP.core.Window.Inst.defineAttribute('$windowID');

//  the TP.dom.Document wrapper for the window's document. This is managed
//  by the setContent method on TP.core.Window to keep the native document
//  current
TP.core.Window.Inst.defineAttribute('contentDoc');

//  a holder for common instance data associated with the various locations
//  which are displayed by this window
TP.core.Window.Inst.defineAttribute('instanceData');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('init',
function(aWindow) {

    /**
     * @method init
     * @summary Initializes a new instance.
     * @param {Window|String} aWindow A window handle. If the handle is an
     *     actual window reference a proper subtype is returned. If the handle
     *     is a string the assumption is a new OS window object if no '.' is in
     *     the name.
     * @returns {TP.core.Window} The new instance.
     */

    var winID;

    //  allocate and build the instance
    this.callNextMethod();

    //  Make sure that any native window passed in has a unique name.
    //  Note that simply by asking we'll force window naming to occur
    //  for any windows not currently named
    winID = TP.gid(aWindow);

    //  save our window ID for later use in window acquisition
    this.$set('$windowID', winID);

    //  set our actual TIBET ID to the window ID so they're equivalent.
    this.setID(winID);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('setLocation',
function(aURL, aRequest) {

    /**
     * @method setLocation
     * @summary Sets the window's location to the URL provided. This method is
     *     similar to the native '<windowRef>.location =' call, except that it
     *     will process content at the end of the URL and set up proper TIBET
     *     constructs in the receiver's native window.
     * @param {String|TP.uri.URI} aURL The URL of the content to load into this
     *     window.
     * @param {TP.sig.Request} aRequest A request containing control parameters.
     * @returns {TP.core.Window} The receiver.
     */

    var url,
        blank,
        win,
        thisref,

        request,
        processContent,

        frame,
        needsPrivileges,
        handler,
        reqLoadFunc,
        blankURI;

    //  Default URL to the blank page when empty or null/undefined.
    if (TP.isEmpty(aURL)) {
        url = TP.sys.cfg('path.blank_page');
        blank = true;
    } else {
        url = aURL;
    }

    TP.sys.logLink(url, TP.INFO);

    //  need a valid URI and creating one ensures we have one regardless of
    //  what we were originally provided. NOTE that we do this operation
    //  after checking for '' as a location which is how we clear content.
    if (TP.notValid(url = TP.uc(url))) {
        return this.raise('TP.sig.InvalidURI');
    }

    win = this.getNativeWindow();

    thisref = this;

    request = TP.request(aRequest);
    processContent = request.atIfInvalid('processContent', true);

    //  If the target is an XML rendering surface, which it normally should be,
    //  we can setContent directly. If not we can attempt to "double pump" it by
    //  loading a blank.xhtml file and hooking into the onload (which works if
    //  we're dealing with an iframe).
    if (TP.isXMLDocument(this.getNativeDocument()) && processContent) {
        //  NOTE that we strip any fragment here to avoid having the setContent
        //  call attempt to resolve XPointer content slices etc. We're setting a
        //  location so the key is the root URL value.
        this.setContent(url, request);
    } else if (TP.isIFrameWindow(win)) {

        //  Capture variable binding references.
        frame = win.frameElement;

        //  See if the URI needs special privileges (i.e. is outside our
        //  domain). If so, then just use 'window.location' to load it.
        needsPrivileges = TP.uriNeedsPrivileges(url.getLocation());

        handler = function(evt) {
            frame.removeEventListener('load', handler, false);

            //  If it wasn't the blank xhtml file URL and it didn't need
            //  privileges but we're processing content, then use setContent()
            //  to set its content. Note that this will invoke any callback
            //  Function in the request's TP.ONLOAD slot, so we don't have to do
            //  it here.
            if (!blank && !needsPrivileges && processContent) {
                thisref.setContent(url, request);
            } else if (TP.isValid(request)) {
                //  If there was a callback Function defined, make sure to
                //  invoke it.
                if (TP.isCallable(reqLoadFunc = request.at(TP.ONLOAD))) {
                    reqLoadFunc(evt);
                }
            }

            request.complete();
        };
        frame.addEventListener('load', handler, false);

        //  If the URL points to the blank xhtml file.or needs privileges or
        //  we're *not* processing content, then just use 'window.location' to
        //  load it.
        if (blank || needsPrivileges || !processContent) {
            win.location = url.getLocation();
        } else {
            blankURI = TP.uc(TP.sys.cfg('path.blank_page'));
            win.location = blankURI.getLocation();
        }
    } else {
        //  Not XML surface, not an IFRAME, just set location.
        win.location = url.getLocation();

        //  A bit optimistic but we don't have a choice really. Hopefully the
        //  request completion processing doesn't rely on rendering being
        //  complete since it may not be.
        if (TP.isValid(request)) {
            request.complete();
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('setTheme',
function(themeName) {

    /**
     * @method setTheme
     * @summary Sets a data-theme attribute on the receiving window's document
     *     body to help drive themed CSS.
     * @param {String} themeName The theme name to set.
     * @returns {TP.core.Window} The receiver.
     */

    this.getDocument().setTheme(themeName);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('queueAfterNextReload',
function(aFunction) {

    /**
     * @method queueAfterNextReload
     * @summary Registers a function to be executed *after* the onload is fired
     *     in the receiver.
     * @param {Function} aFunction The function to register which will be run
     *     when the 'onload' event is triggered for aWindow.
     * @exception TP.sig.InvalidFunction
     * @returns {TP.core.Window} The receiver.
     */

    if (!TP.isCallable(aFunction)) {
        this.raise('TP.sig.InvalidFunction',
                    'Supplied function must be runnable.');

        return this;
    }

    this.getType().registerOnloadFunction(
        this.getNativeWindow(),
        function() {
            setTimeout(
                function() {
                    aFunction();
                }, 0);
        });

    return this;
});

//  ------------------------------------------------------------------------
//  TP.core.UICanvas Interface
//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    var marker,
        str,
        $depth,
        $level;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asDumpString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    str = '[' + TP.tname(this) + ' :: ';

    $depth = TP.ifInvalid(depth, 1);
    $level = TP.ifInvalid(level, 0);

    try {
        if ($level > $depth) {
            str += '@' + TP.id(this) + ']';
        } else {
            str += '(' + TP.dump(this.getNativeWindow(), $depth, $level + 1) +
                ')' + ']';
        }
    } catch (e) {
        str += '(' + TP.str(this.getNativeWindow()) + ')' + ']';
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    var marker,
        str;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asJSONSource';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    try {
        str = '{"type":' + TP.tname(this).quoted('"') + ',' +
                '"data":{' + TP.jsonsrc(this.getNativeWindow()) + '}}';
    } catch (e) {
        str = this.toString();
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver.
     * @returns {String} The receiver in HTML string format.
     */

    var marker,
        str;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asHTMLString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    try {
        str = '<span class="TP_core_Window ' +
                    TP.escapeTypeName(TP.tname(this)) + '">' +
                TP.htmlstr(this.getNativeWindow()) +
                '</span>';
    } catch (e) {
        str = this.toString();
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} A new String containing the 'pretty print' string of
     *     the receiver.
     */

    var marker,
        str;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asPrettyString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    try {
        str = '<dl class="pretty ' + TP.escapeTypeName(TP.tname(this)) + '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' +
                        this.getTypeName() +
                    '</dd>' +
                    TP.pretty(this.getNativeWindow()) +
                    '</dl>';
    } catch (e) {
        str = this.toString();
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a TIBET source code string.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    return TP.join('TP.core.Window.construct(' +
                     TP.src(this.getNativeWindow()) +
                     ')');
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns the receiver as a string.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the TP.core.Window's String representation. The default is true.
     * @returns {String} The receiver as a String.
     */

    var wantsVerbose,
        marker,
        str;

    wantsVerbose = TP.ifInvalid(verbose, true);
    if (!wantsVerbose) {
        return TP.objectToString(this);
    }

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    try {
        str = TP.tname(this) +
                    ' :: ' +
                    '(' + TP.str(this.getNativeWindow()) + ')';
    } catch (e) {
        str = this.toString();
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver.
     * @returns {String} The receiver in XML string format.
     */

    var marker,
        str;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asXMLString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    try {
        str = '<instance type="' + TP.tname(this) + '">' +
                    TP.xmlstr(this.getNativeWindow()) +
                    '</instance>';
    } catch (e) {
        str = this.toString();
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('close',
function() {

    /**
     * @method close
     * @summary Closes the receiver.
     * @returns {TP.core.Window} The receiver.
     */

    //  this will close the window, and the unload hook should do the rest
    this.getNativeWindow().close();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('getCanvasID',
function() {

    /**
     * @method getCanvasID
     * @summary Returns the receiver's "canvas ID" or global ID.
     * @returns {String} The window's global ID.
     */

    //  cached on creation
    return this.$get('$windowID');
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('getContentDocument',
function() {

    /**
     * @method getContentDocument
     * @summary Returns a TP.dom.Document instance wrapping the receiver's
     *     document object. To get the native document object use
     *     getNativeDocument().
     * @returns {TP.dom.Document} The TP.dom.Document object wrapping the
     *     receiver's native document object.
     */

    var win,
        doc;

    if (TP.notValid(win = this.getNativeWindow())) {
        return this.raise('TP.sig.InvalidWindow');
    }

    //  try to reuse one TP.dom.Document if at all possible
    if (TP.isDocument(doc = this.$get('contentDoc'))) {
        //  need to check Document objects - they can become detached or
        //  otherwise messed with
        if (doc.getNativeNode() === win.document) {
            return doc;
        }
    }

    //  build/save a new wrapper for the current document object
    doc = TP.dom.Document.construct(win.document);
    this.$set('contentDoc', doc, false);

    return doc;
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('getContentWindow',
function() {

    /**
     * @method getContentWindow
     * @summary Returns the content window (that is the 'contained window') of
     *     the receiver as a TP.core.Window wrapper. For TP.core.Window
     *     instances this returns the instance itself.
     * @returns {TP.core.Window} The Window contained by the receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('getGlobalID',
function(assignIfAbsent) {

    /**
     * @method getGlobalID
     * @summary Returns the receiver's global ID.
     * @param {Boolean} assignIfAbsent True if an ID should be assigned when one
     *     isn't present. Default is false.
     * @returns {String} The window's global ID (it's fully-qualified name).
     */

    //  cached on creation
    return this.$get('$windowID');
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('getLocation',
function() {

    /**
     * @method getLocation
     * @summary Returns the location (URL) currently set for the receiver's
     *     document. Note that this is often NOT the native window's location
     *     property due to TIBET's use of setContent/setLocation which are not
     *     always able to properly update the location value.
     * @returns {String} The window's document location.
     */

    return TP.documentGetLocation(this.getNativeDocument());
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('getLocalID',
function(assignIfAbsent) {

    /**
     * @method getLocalID
     * @summary Returns the receiver's "local ID", also known as it's 'name',
     *     but without any prefixes for parent windows.
     * @param {Boolean} assignIfAbsent True if an ID should be assigned when one
     *     isn't present. Default is false.
     * @returns {String} The window's local ID (it's non-qualified name).
     */

    var win;

    if (TP.notValid(win = this.getNativeWindow())) {
        return this.raise('TP.sig.InvalidWindow');
    }

    return TP.lid(win, assignIfAbsent);
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('getNativeContentDocument',
function() {

    /**
     * @method getNativeContentDocument
     * @summary Returns the content document (that is the contained 'document')
     *     of the receiver in a TP.dom.Document wrapper.
     * @returns {TP.dom.Document} The TP.dom.Document object contained by the
     *     receiver.
     */

    return this.getNativeDocument();
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('getNativeContentWindow',
function() {

    /**
     * @method getNativeContentWindow
     * @summary Returns the content window (that is the 'contained window') of
     *     the receiver.
     * @returns {Window} The Window object contained by the receiver.
     */

    return this.getNativeWindow();
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineHandler('DOMClose',
function(aSignal) {

    /**
     * @method handleDOMClose
     * @summary Closes the receiver.
     * @param {TP.sig.DOMClose} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.core.Window} The receiver.
     */

    this.close();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('setContent',
function(aContentObject, aRequest) {

    /**
     * @method setContent
     * @summary Sets the content of the receiver's native DOM counterpart to
     *     the node supplied.
     * @param {Object} aContentObject An object to use for content.
     * @param {TP.sig.Request} aRequest A request containing control parameters.
     * @returns {TP.dom.Node} The result of setting the content of the
     *     receiver.
     */

    var request,

        doc,

        reqLoadFunc,
        loadFunc,

        retval;

    request = TP.request(aRequest);

    doc = this.getContentDocument();

    //  Refresh the UI canvas frame's whole document to start things  off. This
    //  will update any data bindings that need it throughout the whole
    //  document. Note that, in a non-Lama-loaded app, that the UI canvas frame
    //  and the UI root frame are the same. In either case, what we want to
    //  update is the *canvas* frame here.

    //  NOTE: If the request already has a TP.ONLOAD function, we grab it and
    //  invoke it first before refreshing our document.
    if (TP.isCallable(reqLoadFunc = request.at(TP.ONLOAD))) {
        loadFunc =
            function(targetNode, newNode) {
                reqLoadFunc(targetNode, newNode);

                doc.refresh();
            };
    } else {
        loadFunc =
            function(targetNode, newNode) {
                doc.refresh();
            };
    }

    request.atPut(TP.ONLOAD, loadFunc);

    retval = doc.setContent(aContentObject, request);

    //  A couple of things can go wrong in the setContent chain. One is that the
    //  content may not be found if aContentObject is a URI for example, and
    //  that URI ends up failing to load. In that case we need to check request.
    if (request.didFail()) {
        if (request.at(TP.ONFAIL)) {
            request.at(TP.ONFAIL)(request);
        }
    }

    return retval;
});

//  ------------------------------------------------------------------------
//  GENERAL
//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('attachSTDIO',
function(aProvider) {

    /**
     * @method attachSTDIO
     * @summary Attaches the receiver's stdio hooks to a STDIO provider, an
     *     object which implements those hooks for reuse.
     * @param {Object} aProvider An object implementing stdin, stdout, and
     *     stderr hook functions.
     * @returns {TP.core.Window} The receiver.
     */

    var natWin;

    if (!TP.canInvokeInterface(
                    aProvider,
                    TP.ac('notify', 'stdin', 'stdout', 'stderr'))) {
        return this.raise(
            'TP.sig.InvalidProvider',
            'STDIO provider must implement stdin, stdout, and stderr');
    }

    natWin = this.getNativeWindow();

    natWin.TP.boot.$notify =
        function(anObject, aRequest) {

            return aProvider.notify(anObject, aRequest);
        };

    natWin.TP.stdin =
        function(aQuery, aDefault, aRequest) {

            return aProvider.stdin(aQuery, aDefault, aRequest);
        };

    natWin.TP.stdout =
        function(anObject, aRequest) {

            return aProvider.stdout(anObject, aRequest);
        };

    natWin.TP.stderr =
        function(anError, aRequest) {

            return aProvider.stderr(anError, aRequest);
        };

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('blur',
function() {

    /**
     * @method blur
     * @summary Blurs the receiver.
     * @returns {TP.core.Window} The receiver.
     */

    this.getNativeWindow().blur();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('constructObject',
function(constructorName, varargs) {

    /**
     * @method constructObject
     * @summary Constructs an object in the receiver's native window.
     * @description Note that all parameters to this method are passed along in
     *     the object creation process. Therefore, arguments to the 'new', if
     *     you will, should be passed after the constructorName.
     * @param {String} constructorName The name of the constructor to use to
     *     construct the object.
     * @param {arguments} varargs Zero or more arguments to pass to the construct
     *     call being invoked.
     * @returns {Object} The object constructed in the receiver's native window.
     */

    var args,
        win;

    //  constructorName was only pointed out above for documentation
    //  purposes. We pass along *all* arguments after inserting our native
    //  window to the front of the Array.
    win = this.getNativeWindow();
    args = TP.args(arguments);
    args.unshift(win);

    return TP.windowConstructObject.apply(win, args);
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('getDocument',
function() {

    /**
     * @method getDocument
     * @summary Returns a TP.dom.Document instance wrapping the receiver's
     *     document object. To get the native document object use
     *     getNativeDocument.
     * @description Windows are unique in that their content document and their
     *     document are the same object. For other UICanvas objects the content
     *     document is contained within the canvas, but the document contains
     *     the canvas. Windows sit at the boundary.
     * @returns {TP.dom.Document}
     */

    return this.getContentDocument();
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('getNativeDocument',
function() {

    /**
     * @method getNativeDocument
     * @summary Returns the receiver's native document object without creating
     *     a TP.dom.Document wrapper.
     * @returns {Document} A native document instance.
     */

    var win;

    if (TP.notValid(win = this.getNativeWindow())) {
        return this.raise('TP.sig.InvalidWindow');
    }

    return win.document;
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('getNativeNode',
function() {

    /**
     * @method getNativeNode
     * @summary Returns the native node representing the receiver's content,
     *     which for a window is actually the native document node.
     * @returns {Document} The receiver's document object.
     */

    return this.getNativeDocument();
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('getNativeObject',
function() {

    /**
     * @method getNativeObject
     * @summary Returns the native object that the receiver is wrapping. In the
     *     case of TP.core.Window, this is the receiver's native window object.
     * @returns {Window} The receiver's native object.
     */

    return this.getNativeWindow();
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('getNativeWindow',
function() {

    /**
     * @method getNativeWindow
     * @summary Returns the window object itself.
     * @returns {Window} The receiver's window instance.
     */

    var winID,
        win;

    winID = this.getGlobalID();

    //  If the native window is still registered with the TP.core.Window
    //  type we can just return it
    if (TP.isWindow(win =
                    TP.core.Window.getWindowInfo(winID, 'nativeWindow'))) {
        return win;
    }

    //  note the use of the window acquisition primitive from the boot
    //  system here -- which should get us our native window reference
    if (TP.notValid(win = TP.sys.getWindowById(winID))) {
        return this.raise('TP.sig.InvalidWindow');
    }

    return win;
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('getProperty',
function(attributeName) {

    /**
     * @method getProperty
     * @summary Returns the value of the named attribute.
     * @param {String} attributeName The attribute to get.
     * @returns {Object}
     */

    var win,
        val;

    //  no model? return local value
    if (TP.isPrototype(this) || TP.notValid(win = this.getNativeWindow())) {
        return this.$get(attributeName);
    }

    //  note the primitive slot access here which we mask from IE via the
    //  try/catch
    try {
        val = win[attributeName];
    } catch (e) {
        TP.ifError() ?
                TP.error(
                    TP.ec(e, 'Unable to property: ' + attributeName)) : 0;
    }

    //  non-existent on model? try locally
    if (TP.notDefined(val)) {
        val = this.$get(attributeName);
    }

    return val;
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('getWindow',
function() {

    /**
     * @method getWindow
     * @summary Returns the receiver.
     * @description This method exists for polymorphism purposes.
     * @returns {TP.core.Window} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('focus',
function() {

    /**
     * @method focus
     * @summary Focuses the receiver, possibly bringing it to the front.
     * @returns {TP.core.Window} The receiver.
     */

    this.getNativeWindow().focus();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('isInstrumented',
function() {

    /**
     * @method isInstrumented
     * @summary Returns true if the window's native window has been
     *     instrumented with TIBET features.
     * @returns {Boolean} True if the window has been instrumented.
     */

    return TP.windowIsInstrumented(this.getNativeWindow());
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('refresh',
function(shouldRender, shouldRefreshBindings) {

    /**
     * @method refresh
     * @summary Updates the receiver's content by refreshing all bound elements
     *     in the window's document.
     * @param {Boolean} [shouldRender] Whether or not to force (or not force)
     *     re-rendering if the data source changes. If not supplied, this
     *     parameter will default to true if the bound data changed and false if
     *     it didn't.
     * @param {Boolean} [shouldRefreshBindings] Whether or not to refresh data
     *     bindings from the receiver down (in a 'sparse' fashion). If not
     *     supplied, this parameter will default to true.
     * @returns {TP.core.Window} The receiver.
     */

    this.getContentDocument().refresh(shouldRender, shouldRefreshBindings);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Window.Inst.defineMethod('reload',
function(forceReload) {

    /**
     * @method reload
     * @summary Reloads the resource currently displayed in the receiver.
     * @param {Boolean} forceReload An optional parameter that determines
     *     whether the browser should reload the page from the server or from
     *     its cache. The default value is false.
     * @returns {TP.core.Window} The receiver.
     */

    //  this will reload the window, and the unload/load hook should do the rest
    this.getNativeWindow().location.reload(forceReload);

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETUICanvasTypesBase.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @subject Common extensions to the base TP.core.Window type.
 */

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.Window.Type.defineMethod('installDocumentExtensions',
function(aWindow) {

    /**
     * @method installDocumentExtensions
     * @summary Instruments the document belonging to aWindow with TIBET
     *     specific functions.
     * @param {Window} aWindow The window of the document to install the
     *     functions on.
     * @returns {TP.meta.core.Window} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Window.Type.defineMethod('installLoadUnloadHooks',
function(aWindow) {

    /**
     * @method installLoadUnloadHooks
     * @summary This method installs the TIBET load/unload hooks onto the
     *     supplied native window so that load/unload events on that window can
     *     be caught by TIBET and rebroadcast into the system as signals.
     * @param {Window} aWindow The Window to install the load/unload hooks onto.
     * @returns {TP.meta.core.Window} The receiver.
     */

    var msg,
        tibetWin,
        dclListener,
        unloadListener;

    if (!TP.isWindow(aWindow)) {
        return this.raise('TP.sig.InvalidWindow');
    }

    //  Ignore if already instrumented.
    if (TP.isValid(aWindow.dclListener) && TP.isValid(aWindow.unloadListener)) {
        return this;
    }

    if (TP.sys.cfg('log.hook') && TP.sys.cfg('boot.context') !== 'headless') {
        msg = 'Arming window: ' + TP.gid(aWindow) + '.';
        TP.boot.$stdout(msg, TP.DEBUG);
    }

    //  Set the native window's onerror handler to the standard TIBET
    //  onerror handler, so that errors that occur in the window are
    //  processed by the TIBET error handling system.
    aWindow.onerror = TP.sys.onerror;

    //  assign our codebase window to the var we'll close around
    tibetWin = window;

    //  Note that, because this method is called from the hook file which might,
    //  itself, be being processed as part of a load cycle, we need to make sure
    //  that the window doesn't already have these handlers installed.

    //  Therefore, to maximize symmetry for these methods, and to make sure they
    //  don't get registered multiple times we go ahead and put the slots on the
    //  window for both and don't install them if they're already installed.

    if (TP.notValid(aWindow.dclListener)) {

        dclListener = function(anEvent) {

            if (TP.eventGetTarget(anEvent) !== aWindow.document) {
                if (TP.$$DEBUG) {
                    TP.boot.$stdout(
                        'Ignoring DOMContentLoaded from target: ' +
                        TP.eventGetTarget(anEvent) + '.', TP.DEBUG);
                }

                return;
            }

            //  NOTE that this signal is only triggered in
            //  response to a location change. altering the DOM
            //  of the document element won't trigger it.
            if (TP.$$DEBUG) {
                TP.boot.$stdout('DOMContentLoaded at: ' +
                    TP.str(TP.eventGetTarget(anEvent)), TP.DEBUG);
            }


            //  remove so we don't trigger again due to
            //  processDocumentLoaded invocation(s)
            aWindow.removeEventListener(
                    'DOMContentLoaded',
                    dclListener,
                    false);

            aWindow.dclListener = null;

            //  writing handler is false, we're the location
            //  handler
            tibetWin.TP.$$processDocumentLoaded(aWindow);
        };
        aWindow.dclListener = dclListener;

        aWindow.addEventListener('DOMContentLoaded', dclListener, false);
    }

    if (TP.notValid(aWindow.unloadListener)) {
        unloadListener = function(anEvent) {

            if (TP.eventGetTarget(anEvent) !== aWindow.document) {
                if (TP.$$DEBUG) {
                    TP.boot.$stdout(
                        'Ignoring unload from target: ' +
                        TP.eventGetTarget(anEvent) + '.', TP.DEBUG);
                }

                return;
            }

            //  NOTE that this signal is only triggered in
            //  response to a location change. altering the DOM
            //  of the document element won't trigger it.
            if (TP.$$DEBUG) {
                TP.boot.$stdout('unload at: ' +
                    TP.str(TP.eventGetTarget(anEvent)), TP.DEBUG);
            }

            aWindow.removeEventListener(
                    'unload',
                    unloadListener,
                    false);

            aWindow.unloadListener = null;

            tibetWin.TP.$$processDocumentUnloaded(aWindow);
        };
        aWindow.unloadListener = unloadListener;

        aWindow.addEventListener('unload', unloadListener, false);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Window.Type.defineMethod('installWindowExtensions',
function(aWindow) {

    /**
     * @method installWindowExtensions
     * @summary Installs a set of common functions onto aWindow to enhance that
     *     window's capability within the TIBET framework.
     * @param {Window} aWindow The window to install the functions on.
     * @returns {TP.meta.core.Window} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETUICanvasTypesPost.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETSignalTypes.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 */

//  ========================================================================
//  TP.core.Monitor
//  ========================================================================

/**
 * @type {TP.core.Monitor}
 * @summary A TP.core.Monitor is an object whose responsibility is to
 *     essentially poll one or more target objects, testing them for some
 *     condition and reporting via signal when the condition is true.
 * @description There are a variety of things in a browser which we'd like to be
 *     able to monitor such as style changes or similar aspects which don't have
 *     native events associated with them (yet). In these cases you can use a
 *     TP.core.Monitor to observe the object(s) and test them for a condition.
 *
 *     For example, you might set up a monitor on an element's background color
 *     which signals "UIColorChange" when the background goes from blue to red.
 *     You'd do this by passing the monitor constructor a simple function which
 *     checks the condition you're interested in and returns true when the
 *     signal should be fired.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.Monitor');

TP.core.Monitor.addTraits(TP.core.JobStatus);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  the default testing interval for the monitor's underlying job
TP.core.Monitor.Type.defineAttribute('defaultInterval', 100);

//  the signal type which will be signaled by default for this type
TP.core.Monitor.Type.defineAttribute('defaultSignal');

//  the default test function this type runs to detect monitor events
TP.core.Monitor.Type.defineAttribute('defaultTest');

//  a baseline set of control parameters for the job. these are overlaid
//  with any inbound parameters passed during job construction
TP.core.Monitor.Type.defineAttribute('controlParameters',
                        TP.hc('interval', TP.core.Job.ZERO_DECAY,
                                'limit', TP.core.Job.FOREVER));

//  a baseline set of step parameters for the underlying job. these are
//  merged with any specific parameters passed at job start
TP.core.Monitor.Type.defineAttribute('stepParameters', TP.hc());

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.Monitor.Type.defineMethod('getDefaultSignal',
function() {

    /**
     * @method getDefaultSignal
     * @summary Returns the default signal type to signal.
     * @returns {String|TP.sig.Signal} The signal type or signal type name.
     */

    return this.$get('defaultSignal');
});

//  ------------------------------------------------------------------------

TP.core.Monitor.Type.defineMethod('getDefaultTest',
function() {

    /**
     * @method getDefaultTest
     * @summary Returns the default test function used to detect monitor
     *     events.
     * @returns {Function} The default test function.
     */

    return this.$get('defaultTest');
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  the TP.core.Job instance used to manage the work of the monitor
TP.core.Monitor.Inst.defineAttribute('job');

//  the (variable) list of target objects to monitor
TP.core.Monitor.Inst.defineAttribute('targets');

//  what test (function) do we run to detect monitor events?
TP.core.Monitor.Inst.defineAttribute('test');

//  what signal should we send out when we detect a valid monitor event?
TP.core.Monitor.Inst.defineAttribute('notifier');

//  the step (function) that will be executed to acquire the target and run the
//  test function against it.
TP.core.Monitor.Inst.defineAttribute('stepFunction');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.Monitor.Inst.defineMethod('init',
function(aTarget, aTest, aSignal) {

    /**
     * @method init
     * @summary Initializes a new instance of monitor.
     * @param {Object} aTarget An object or object ID which identifies the
     *     object being monitored. When an ID is used it should be a valid
     *     TP.uri.URI or a String which can be resolved via the
     *     TP.sys.getObjectById() call.
     * @param {Function} [aTest] A function which defines the test being run on
     *     each target object. This should return true to cause the monitor to
     *     signal. If not supplied, the default test as defined by this type
     *     will be used.
     * @param {String|TP.sig.Signal} [aSignal] The signal to fire when/if the
     *     test condition passes. If not supplied, the default signal as defined
     *     by this type will be used.
     * @returns {TP.core.Monitor} A newly initialized instance.
     */

    var test,
        signal,
        func;

    this.callNextMethod();

    //  test can be defaulted on a type-by-type basis so that subtypes of
    //  monitor can be constructed for common cases.
    test = aTest;
    if (TP.notValid(test)) {
        test = this.getType().getDefaultTest();
    }

    if (!TP.isCallable(test)) {
        this.raise('TP.sig.InvalidParameter',
                    'Test must be a runnable function.');

        return this;
    }

    this.$set('test', test);

    //  signal type can be defaulted on a type-by-type basis so subtypes can
    //  avoid requiring a signal name during instance construction
    signal = aSignal;
    if (TP.notValid(signal)) {
        signal = this.getType().getDefaultSignal();
    }

    if (TP.notValid(signal)) {
        this.raise('TP.sig.InvalidParameter',
                    'Signal must be valid signal name or type.');

        return this;
    }

    this.$set('notifier', signal);

    //  configure the target list, which is passed to the test function.
    this.$set('targets', TP.ac());
    this.addTarget(aTarget);

    //  build a step function that incorporates the target/test logic and
    //  construct the job instance we'll use to actually manage the
    //  monitoring
    func = this.constructStepFunction();
    this.constructJob(TP.hc('step', func));

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Monitor.Inst.defineMethod('addTarget',
function(aTarget) {

    /**
     * @method addTarget
     * @summary Adds a new target to the list of objects to monitor.
     * @param {String|TP.uri.URI|Function} aTarget A target specification in
     *     one of a variety of forms: TP.uri.URI, string ID, or acquisition
     *     function (or an array of them).
     * @returns {TP.core.Monitor} The receiver.
     */

    var targets,
        len,
        i,
        target;

    if (TP.isArray(aTarget)) {
        targets = aTarget;
    } else {
        targets = TP.ac(aTarget);
    }

    len = targets.getSize();
    for (i = 0; i < len; i++) {
        target = targets.at(i);
        this.$get('targets').add(target);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Monitor.Inst.defineMethod('cleanupResolvedTarget',
function(aTarget) {

    /**
     * @method cleanupResolvedTarget
     * @summary Cleans up any 'instance programmed' state that the monitor might
     *     have placed on the supplied resolved target. At this level, this
     *     method does nothing.
     * @param {Object} aTarget The resolved target (i.e. the Object that was
     *     found by using a piece of targeting information) to clean up.
     * @returns {TP.core.Monitor} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Monitor.Inst.defineMethod('cleanupResolvedTargets',
function() {

    /**
     * @method cleanupResolvedTargets
     * @summary Iterates over the receiver's target, resolves them to an Object
     *     of some type and messages the receiver with the
     *     'cleanupResolvedTarget()' message and that resolved object to clean
     *     up any 'instance programmed' state data that the monitor might have
     *     placed on it.
     * @returns {TP.core.Monitor} The receiver.
     */

    var targets,

        len,
        i,
        target,

        obj;

    targets = this.get('targets');

    //  since we're dealing with a reference type in the form of an
    //  array here the size may vary if add/remove was called between
    //  invocations of the step function
    len = targets.getSize();
    for (i = 0; i < len; i++) {
        target = targets.at(i);
        if (TP.isCallable(target)) {
            try {
                obj = target();
            } catch (e) {
                //  empty
                //  ignore errors in acquisition functions
            }
        } else if (TP.isString(target)) {
            obj = TP.sys.getObjectById(target);
        } else if (TP.isKindOf(target, TP.uri.URI)) {
            //  NB: We assume 'async' of false here.
            obj = target.getResource().get('result');
        } else {
            obj = target;
        }

        //  ignore targets we can't find, it's the same as having not
        //  met the conditional requirements since the monitor might be
        //  testing for existence as the condition to signal for
        if (TP.notValid(obj)) {
            continue;
        }

        this.cleanupResolvedTarget(obj);
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.core.Monitor.Inst.defineMethod('constructJob',
function(controlParameters) {

    /**
     * @method constructJob
     * @summary Constructs the job instance used to manage the work of the
     *     monitor in terms of scheduling etc.
     * @param {TP.core.Hash} controlParameters The job's control parameters, set
     *     when the job is first constructed.
     * @returns {TP.core.Job} The newly constructed job instance.
     */

    var job;

    job = TP.core.Job.construct(
                    this.getControlParameters(controlParameters));

    this.$set('job', job);

    return job;
});

//  ------------------------------------------------------------------------

TP.core.Monitor.Inst.defineMethod('constructStepFunction',
function() {

    /**
     * @method constructStepFunction
     * @summary Builds a step function specific to the requirements of this
     *     monitor instance. The overall logic of this function is to run
     *     through each target, invoking the test function and signaling the
     *     target signal whenever the test function returns true.
     * @returns {Function} The newly created step function instance.
     */

    var targets,
        test,
        signal,

        retFunc;

    //  we capture these outside the step function so it has the least work
    //  to do internally, just check and return

    targets = this.get('targets');
    test = this.get('test');
    signal = this.get('notifier');

    retFunc = function() {

        var len,
            i,
            target,

            obj;

        //  since we're dealing with a reference type in the form of an
        //  array here the size may vary if add/remove was called between
        //  invocations of the step function
        len = targets.getSize();
        for (i = 0; i < len; i++) {
            target = targets.at(i);
            if (TP.isCallable(target)) {
                try {
                    obj = target();
                } catch (e) {
                    //  empty
                    //  ignore errors in acquisition functions
                }
            } else if (TP.isString(target)) {
                obj = TP.sys.getObjectById(target);
            } else if (TP.isKindOf(target, TP.uri.URI)) {
                //  NB: We assume 'async' of false here.
                obj = target.getResource().get('result');
            } else {
                obj = target;
            }

            //  ignore targets we can't find, it's the same as having not
            //  met the conditional requirements since the monitor might be
            //  testing for existence as the condition to signal for
            if (TP.notValid(obj)) {
                continue;
            }

            try {
                if (test(obj)) {
                    TP.signal(obj, signal);
                }
            } catch (e) {
                TP.ifError() ?
                    TP.error('Couldn\'t process step function signal: ' +
                                    signal.getSignalName()) : 0;
            }
        }

        return;
    };

    //  NOTE that we don't need to bind the function, it has no this refs
    this.$set('stepFunction', retFunc);

    return retFunc;
});

//  ------------------------------------------------------------------------

TP.core.Monitor.Inst.defineMethod('removeTarget',
function(aTarget) {

    /**
     * @method removeTarget
     * @summary Removes a target from the list of objects to monitor.
     * @param {String|TP.uri.URI|Function} aTarget A target specification in
     *     one of a variety of forms: TP.uri.URI, string ID, or acquisition
     *     function (or an array of them).
     * @returns {TP.core.Monitor} The receiver.
     */

    var targets,
        len,
        i,
        target;

    if (TP.isArray(aTarget)) {
        targets = aTarget;
    } else {
        targets = TP.ac(aTarget);
    }

    len = targets.getSize();
    for (i = 0; i < len; i++) {
        target = targets.at(i);
        this.$get('targets').remove(target, TP.IDENTITY);
    }

    return this;
});

//  ------------------------------------------------------------------------
//  Job Configuration Methods
//  ------------------------------------------------------------------------

TP.core.Monitor.Inst.defineMethod('getControlParameters',
function(controlParameters) {

    /**
     * @method getControlParameters
     * @summary Returns a hash of control parameters for the receiver's
     *     underlying job instance. The return value is a merged copy of the
     *     receiving type's default parameters and any parameter information
     *     passed in.
     * @param {TP.core.Hash} controlParameters An optional set of parameters
     *     used during job creation.
     * @returns {TP.core.Hash} The control parameters for this monitor.
     */

    var params;

    params = this.getType().get('controlParameters').copy();
    params.atPut('lastInterval', this.getType().get('defaultInterval'));

    if (TP.isValid(controlParameters)) {
        params.addAll(controlParameters);
    }

    return params;
});

//  ------------------------------------------------------------------------

TP.core.Monitor.Inst.defineMethod('getJob',
function() {

    /**
     * @method getJob
     * @summary Returns the job instance used by this monitor.
     * @returns {TP.core.Job} The receiver's internal job instance.
     */

    return this.$get('job');
});

//  ------------------------------------------------------------------------

TP.core.Monitor.Inst.defineMethod('getStepParameters',
function(stepParameters) {

    /**
     * @method getStepParameters
     * @summary Returns a hash of step parameters for the receiver's underlying
     *     job instance. The return value is a merged copy of the receiving
     *     type's default parameters and any parameter information passed in.
     * @param {TP.core.Hash} stepParameters An optional set of parameters used
     *     to control job steps.
     * @returns {TP.core.Hash} The step parameters for this monitor.
     */

    var params;

    params = this.getType().get('stepParameters').copy();
    if (TP.isValid(stepParameters)) {
        params.addAll(stepParameters);
    }

    return params;
});

//  ------------------------------------------------------------------------
//  Job Control Methods
//  ------------------------------------------------------------------------

TP.core.Monitor.Inst.defineMethod('cancel',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method cancel
     * @summary Cancels the monitor, stopping all monitoring.
     * @param {String} aFaultString A string description of the cancellation.
     * @param {Object} aFaultCode A code providing additional information on the
     *     reason for the cancellation.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the cancellation.
     * @returns {TP.core.Monitor} The receiver.
     */

    this.cleanupResolvedTargets();

    this.getJob().cancel(aFaultString, aFaultCode, aFaultInfo);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Monitor.Inst.defineMethod('complete',
function(aResult) {

    /**
     * @method complete
     * @summary Completes (ends with success) the monitor, stopping it.
     * @param {Object} aResult An optional result object associated with the
     *     job.
     * @returns {TP.core.Monitor} The receiver.
     */

    this.cleanupResolvedTargets();

    this.getJob().complete(aResult);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Monitor.Inst.defineMethod('fail',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method fail
     * @summary Terminates the monitor, stopping all monitoring.
     * @param {String} aFaultString A string description of the fault.
     * @param {Object} aFaultCode A code providing additional information on the
     *     reason for the failure.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the failure.
     * @returns {TP.core.Monitor} The receiver.
     */

    this.cleanupResolvedTargets();

    this.getJob().fail(aFaultString, aFaultCode, aFaultInfo);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Monitor.Inst.defineMethod('start',
function(stepParameters) {

    /**
     * @method start
     * @summary Starts the monitor, causing it to begin monitoring its targets
     *     for monitor events.
     * @param {TP.core.Hash} stepParameters An optional set of parameters used
     *     to control job steps.
     * @returns {TP.core.Monitor} The receiver.
     */

    this.getJob().start(this.getStepParameters(stepParameters));

    return this;
});

//  ========================================================================
//  TP.core.DOMElementMonitor
//  ========================================================================

/**
 * @type {TP.core.DOMElementMonitor}
 * @summary A TP.core.Monitor subtype that monitors elements for a variety of
 *     changes which might be triggered via CSS shifts or other activity which
 *     won't normally trigger a native event.
 */

//  ------------------------------------------------------------------------

TP.core.Monitor.defineSubtype('DOMElementMonitor');

//  need a monitor of a specific subtype
TP.core.DOMElementMonitor.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  the monitor singleton instance that we're managing.
TP.core.DOMElementMonitor.Type.defineAttribute('$monitor');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.DOMElementMonitor.Type.defineMethod('addObserver',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method addObserver
     * @summary Adds a local signal observation which is roughly like a DOM
     *     element adding an event listener. The observer is typically the
     *     handler provided to an observe() call while the signal is a signal or
     *     string which the receiver is likely to signal or is intercepting for
     *     centralized processing purposes.
     * @param {Object|Object[]} anOrigin One or more origins to observe.
     * @param {Object|Object[]} aSignal One or more signals to observe from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn on observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to add the observation, false otherwise.
     */

    var origins,
        signals,

        monitor,

        ourDefaultSignalName,

        len,
        i,
        signal,

        len2,
        j,

        obj;

    if (TP.notValid(anOrigin)) {
        return false;
    }

    if (!TP.isArray(anOrigin)) {
        origins = TP.ac(anOrigin);
    } else {
        origins = anOrigin;
    }

    if (TP.isArray(aSignal)) {
        signals = aSignal;
    } else if (TP.isString(aSignal)) {
        signals = aSignal.split(' ');
    } else if (TP.isType(aSignal)) {
        signals = TP.ac(aSignal);
    } else {
        this.raise('TP.sig.InvalidParameter',
                    'Improper signal definition.');

        return false;
    }

    //  Get the singleton instance that we manage for 'auto monitoring' when the
    //  consumer is using this through the signaling interface.
    monitor = this.get('$monitor');

    ourDefaultSignalName = this.getDefaultSignal().getSignalName();

    len = signals.getSize();

    for (i = 0; i < len; i++) {

        signal = signals.at(i).getSignalName();

        //  The only signals we're interested in are our own kind of signals
        if (signal !== ourDefaultSignalName) {
            continue;
        }

        len2 = origins.getSize();
        for (j = 0; j < len2; j++) {

            obj = origins.at(j);

            if (TP.isString(obj)) {
                obj = TP.sys.getObjectById(obj);
            }

            obj = TP.elem(TP.unwrap(obj));

            //  We didn't get an Element, even after resolving and unwrapping -
            //  that's a problem.
            if (!TP.isElement(obj)) {
                return this.raise('TP.sig.InvalidElement');
            }

            //  No valid singleton instance? Create one here and start here
            //  (supplying the target).
            if (TP.notValid(monitor)) {

                monitor = this.construct(obj);
                monitor.start();

                this.set('$monitor', monitor);
            } else {

                //  We already have a running singleton instance - just add the
                //  target.
                monitor.addTarget(obj);
            }
        }
    }

    return true;
});

//  ------------------------------------------------------------------------

TP.core.DOMElementMonitor.Type.defineMethod('removeObserver',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method removeObserver
     * @summary Removes a local signal observation which is roughly like a DOM
     *     element adding an event listener. The observer is typically the
     *     handler provided to an observe call while the signal is a signal or
     *     string which the receiver is likely to signal or is intercepting for
     *     centralized processing purposes.
     * @param {Object|Object[]} anOrigin One or more origins to ignore.
     * @param {Object|Object[]} aSignal One or more signals to ignore from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn off observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to remove the observation, false otherwise.
     */

    var origins,
        signals,

        monitor,

        ourDefaultSignalName,

        len,
        i,
        signal,

        len2,
        j,

        obj;

    if (TP.notValid(anOrigin)) {
        return false;
    }

    if (!TP.isArray(anOrigin)) {
        origins = TP.ac(anOrigin);
    } else {
        origins = anOrigin;
    }

    if (TP.isArray(aSignal)) {
        signals = aSignal;
    } else if (TP.isString(aSignal)) {
        signals = aSignal.split(' ');
    } else if (TP.isType(aSignal)) {
        signals = TP.ac(aSignal);
    } else {
        this.raise('TP.sig.InvalidParameter',
                    'Improper signal definition.');

        return false;
    }

    //  Get the singleton instance that we manage for 'auto monitoring' when the
    //  consumer is using this through the signaling interface.
    monitor = this.get('$monitor');

    //  No valid singleton instance? Exit here and return false to not have the
    //  main observation system unregister the observer - it won't be there.
    if (TP.notValid(monitor)) {
        return false;
    }

    ourDefaultSignalName = this.getDefaultSignal().getSignalName();

    len = signals.getSize();

    for (i = 0; i < len; i++) {

        signal = signals.at(i).getSignalName();

        //  The only signals we're interested in are our own kind of signals
        if (signal !== ourDefaultSignalName) {
            continue;
        }

        len2 = origins.getSize();
        for (j = 0; j < len2; j++) {

            obj = origins.at(j);

            if (TP.isString(obj)) {
                obj = TP.sys.getObjectById(obj);
            }

            obj = TP.elem(TP.unwrap(obj));

            //  We didn't get an Element, even after resolving and unwrapping -
            //  that's a problem.
            if (!TP.isElement(obj)) {
                return this.raise('TP.sig.InvalidElement');
            }

            //  Remove the Element from the singleton.
            monitor.removeTarget(obj);
        }
    }

    //  If there are no targets left in the monitor, we shut it down and
    //  set our instance attribute to null
    if (TP.isValid(monitor) && TP.isEmpty(monitor.get('targets'))) {
        monitor.complete();
        this.set('$monitor', null);
    }

    return true;
});

//  ========================================================================
//  TP.core.ResizeMonitor
//  ========================================================================

/**
 * @type {TP.core.ResizeMonitor}
 * @summary A TP.core.DOMElementMonitor subtype that monitors elements for size
 *     changes which might be triggered via CSS shifts or other activity which
 *     won't normally trigger a native event.
 */

//  ------------------------------------------------------------------------

TP.core.DOMElementMonitor.defineSubtype('ResizeMonitor');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.core.ResizeMonitor.Type.defineAttribute('defaultInterval', 50);
TP.core.ResizeMonitor.Type.defineAttribute('defaultSignal', 'TP.sig.DOMMonitoredResize');

TP.core.ResizeMonitor.Type.defineAttribute(
    'defaultTest',
    function(target) {

        var elem,

            oldHeight,
            oldWidth,

            newHeight,
            newWidth;

        elem = TP.elem(target);
        if (!TP.isElement(elem)) {
            return;
        }

        oldWidth = elem[TP.OLD_WIDTH];
        oldHeight = elem[TP.OLD_HEIGHT];

        //  NB: Since all we're interested in here is a *difference* in width
        //  and height, regular offsetWidth and offsetHeight are fine and are
        //  much faster than the more complete
        //  TP.elementGetWidth()/TP.elementGetHeight() calls.
        newHeight = elem.offsetHeight;
        newWidth = elem.offsetWidth;

        elem[TP.OLD_WIDTH] = newWidth;
        elem[TP.OLD_HEIGHT] = newHeight;

        //  don't signal the first time through
        if (TP.isEmpty(oldHeight)) {
            return false;
        }

        if (oldHeight !== newHeight || oldWidth !== newWidth) {
            return true;
        }

        return false;
    });

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.ResizeMonitor.Type.defineMethod('addObserver',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method addObserver
     * @summary Adds a local signal observation which is roughly like a DOM
     *     element adding an event listener. The observer is typically the
     *     handler provided to an observe() call while the signal is a signal or
     *     string which the receiver is likely to signal or is intercepting for
     *     centralized processing purposes.
     * @description This method is overridden on this type because the
     *     TP.sig.DOMMonitoredResize signal is a 'dual purpose' signal in that,
     *     if you observe a Window or Document for 'resized', you will use the
     *     native browser's machinery but if you observe an Element for 'resized',
     *     there is no native browser event for such a thing and so you will use
     *     a shared TP.core.Monitor to monitor the Element(s) for sizing
     *     changes.
     * @param {Object|Object[]} anOrigin One or more origins to observe.
     * @param {Object|Object[]} aSignal One or more signals to observe from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn on observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to add the observation, false otherwise.
     */

    var origin;

    //  Unwrap the supplied origin.
    origin = TP.unwrap(anOrigin);

    //  If its a String, it might be a GID, so try to resolve it.
    if (TP.isString(origin)) {
        origin = TP.sys.getObjectById(origin);
        origin = TP.unwrap(origin);
    }

    //  If it's a Window or Document, just return true to tell the signaling
    //  system to add the observation to the main notification engine.
    if (TP.isWindow(origin) || TP.isDocument(origin)) {
        return true;
    }

    //  Otherwise, it's probably an Element, so do what our supertype does (i.e.
    //  use the singleton Monitor to monitor the element, etc.)
    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.core.ResizeMonitor.Type.defineMethod('removeObserver',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method removeObserver
     * @summary Removes a local signal observation which is roughly like a DOM
     *     element adding an event listener. The observer is typically the
     *     handler provided to an observe call while the signal is a signal or
     *     string which the receiver is likely to signal or is intercepting for
     *     centralized processing purposes.
     * @param {Object|Object[]} anOrigin One or more origins to ignore.
     * @param {Object|Object[]} aSignal One or more signals to ignore from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn off observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to remove the observation, false otherwise.
     */

    var origin;

    //  Unwrap the supplied origin.
    origin = TP.unwrap(anOrigin);

    //  If its a String, it might be a GID, so try to resolve it.
    if (TP.isString(origin)) {
        origin = TP.sys.getObjectById(origin);
        origin = TP.unwrap(origin);
    }

    //  If it's a Window or Document, just return true to tell the signaling
    //  system to remove the observation from the main notification engine.
    if (TP.isWindow(origin) || TP.isDocument(origin)) {
        return true;
    }

    //  Otherwise, it's probably an Element, so do what our supertype does (i.e.
    //  remove the element from the singleton Monitor, etc.)
    return this.callNextMethod();
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.ResizeMonitor.Inst.defineMethod('cleanupResolvedTarget',
function(aTarget) {

    /**
     * @method cleanupResolvedTarget
     * @summary Cleans up any 'instance programmed' state that the monitor might
     *     have placed on the supplied resolved target.
     * @param {Object} aTarget The resolved target (i.e. the Object that was
     *     found by using a piece of targeting information) to clean up.
     * @returns {TP.core.ResizeMonitor} The receiver.
     */

    aTarget[TP.OLD_WIDTH] = null;
    aTarget[TP.OLD_HEIGHT] = null;

    return this;
});

//  ========================================================================
//  TP.core.RepositionMonitor
//  ========================================================================

/**
 * @type {TP.core.RepositionMonitor}
 * @summary A TP.core.DOMElementMonitor subtype that monitors elements for
 *     position changes which might be triggered via CSS shifts or other
 *     activity which won't normally trigger a native event.
 */

//  ------------------------------------------------------------------------

TP.core.DOMElementMonitor.defineSubtype('RepositionMonitor');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.core.RepositionMonitor.Type.defineAttribute('defaultInterval', 50);
TP.core.RepositionMonitor.Type.defineAttribute('defaultSignal',
                                                'TP.sig.DOMMonitoredReposition');

TP.core.RepositionMonitor.Type.defineAttribute(
    'defaultTest',
    function(target) {

        var elem,

            win,
            topWin,
            frameOffsetXAndY,

            oldTop,
            oldLeft,

            newTop,
            newLeft;

        elem = TP.elem(target);
        if (!TP.isElement(elem)) {
            return;
        }

        //  This monitor checks global position - if the target element's Window
        //  is not it's 'top' Window, then we need to make sure to compute the
        //  offset.
        win = TP.nodeGetWindow(elem);
        topWin = TP.nodeGetTopWindow(elem);

        if (win !== topWin) {
            frameOffsetXAndY = TP.windowComputeWindowOffsets(topWin, win);
        } else {
            frameOffsetXAndY = TP.ac(0, 0);
        }

        oldLeft = elem[TP.OLD_LEFT];
        oldTop = elem[TP.OLD_TOP];

        //  NB: Since all we're interested in here is a *difference* in left
        //  and/or top, regular offsetLeft and offsetTop are fine and are
        //  much faster than the more complete TP.elementGetBorderBox() calls.
        newLeft = elem.offsetLeft + frameOffsetXAndY.first();
        newTop = elem.offsetTop + frameOffsetXAndY.last();

        elem[TP.OLD_LEFT] = newLeft;
        elem[TP.OLD_TOP] = newTop;

        //  don't signal the first time through
        if (TP.isEmpty(oldTop)) {
            return false;
        }

        if (oldTop !== newTop || oldLeft !== newLeft) {
            return true;
        }

        return false;
    });

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.RepositionMonitor.Inst.defineMethod('cleanupResolvedTarget',
function(aTarget) {

    /**
     * @method cleanupResolvedTarget
     * @summary Cleans up any 'instance programmed' state that the monitor might
     *     have placed on the supplied resolved target.
     * @param {Object} aTarget The resolved target (i.e. the Object that was
     *     found by using a piece of targeting information) to clean up.
     * @returns {TP.core.RepositionMonitor} The receiver.
     */

    aTarget[TP.OLD_LEFT] = null;
    aTarget[TP.OLD_TOP] = null;

    return this;
});

//  ========================================================================
//  TAG PROCESSING SIGNALS
//  ========================================================================

TP.sig.Signal.defineSubtype('ProcessingComplete');

TP.sig.ProcessingComplete.defineSubtype('CompileComplete');
TP.sig.ProcessingComplete.defineSubtype('AttachComplete');
TP.sig.ProcessingComplete.defineSubtype('DetachComplete');

//  ========================================================================
//  MUTATION SIGNALS
//  ========================================================================

TP.sig.Signal.defineSubtype('MutationComplete');

TP.sig.MutationComplete.defineSubtype('MutationAttach');
TP.sig.MutationComplete.defineSubtype('MutationDetach');

TP.sig.MutationComplete.defineSubtype('MutationStyleChange');

TP.sig.MutationStyleChange.Type.defineAttribute('defaultPolicy',
                                                TP.INHERITANCE_FIRING);
TP.sig.MutationStyleChange.defineSubtype('MutationStyleRuleChange');
TP.sig.MutationStyleChange.defineSubtype('MutationStylePropertyChange');

TP.sig.Signal.defineSubtype('NodeWillRecast');
TP.sig.Signal.defineSubtype('NodeDidRecast');

//  ========================================================================
//  SYSTEM SIGNALS
//  ========================================================================

TP.sig.Signal.defineSubtype('RemoteResourceChanged');

TP.sig.Signal.defineSubtype('ScriptImported');

TP.sig.Signal.defineSubtype('TypeAdded');
TP.sig.Signal.defineSubtype('MethodAdded');

//  ========================================================================
//  CHANGE SIGNALS
//  ========================================================================

TP.sig.Change.defineSubtype('AttributeChange');

//  ========================================================================
//  BIND SIGNALS
//  ========================================================================

TP.sig.Signal.defineSubtype('BINDSignal');

TP.sig.BINDSignal.Type.defineAttribute('defaultPolicy', TP.BIND_FIRING);

TP.sig.BINDSignal.Type.defineAttribute('bubbling', true);
TP.sig.BINDSignal.Type.defineAttribute('cancelable', true);

TP.sig.BINDSignal.defineSubtype('BINDItemSignal');

TP.sig.BINDItemSignal.defineSubtype('SetContent');
TP.sig.BINDItemSignal.defineSubtype('ClearContent');

TP.sig.BINDItemSignal.defineSubtype('CloneItem');
TP.sig.BINDItemSignal.defineSubtype('InsertItem');
TP.sig.BINDItemSignal.defineSubtype('DeleteItem');

TP.sig.BINDSignal.defineSubtype('BINDSelectionSignal');

TP.sig.BINDSelectionSignal.defineSubtype('UpdateSelection');
TP.sig.BINDSelectionSignal.defineSubtype('DeleteSelection');

//  ========================================================================
//  RESPONDER SIGNALS
//  ========================================================================

TP.sig.Signal.defineSubtype('ResponderSignal');

TP.sig.ResponderSignal.Type.defineAttribute('defaultPolicy',
    TP.RESPONDER_FIRING);

//  ResponderSignals should traverse the controller chain...but not
//  ResponderSignal itself. NOTE that being a controller signal is inherited but
//  acting as the root is a LOCAL assignment so it's not inherited.
TP.sig.ResponderSignal.Type.isControllerSignal(true);
TP.sig.ResponderSignal.isControllerRoot(true);

TP.sig.ResponderSignal.Type.defineAttribute('bubbling', true);
TP.sig.ResponderSignal.Type.defineAttribute('cancelable', true);

//  ------------------------------------------------------------------------

TP.sig.ResponderSignal.Type.defineMethod('defineSubtype',
function() {

    /**
     * @method defineSubtype
     * @summary Creates a new subtype. This particular override ensures that all
     *     direct subtypes of TP.sig.ResponderSignal serve as signaling roots,
     *     meaning that you never signal a raw TP.sig.ResponderSignal.
     * @returns {TP.sig.Signal} A new signal-derived type object.
     */

    var type;

    type = this.callNextMethod();

    if (this === TP.sig.ResponderSignal) {
        type.isSignalingRoot(true);
    }

    return type;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.ResponderSignal.Inst.defineMethod('getDocument',
function() {

    /**
     * @method getDocument
     * @summary Returns the document from which the signal originated. For
     *     responder signals, this will be the document that it's trigger signal
     *     occurred in.
     * @returns {TP.dom.Document} The document that the signal originated in.
     */

    var trigger,
        evt,

        domSignal;

    //  Responder signals are *not* DOM signals, but if they've been triggered
    //  because of a DOM signal, they should have the low-level event in their
    //  payload.
    trigger = this.at('trigger');

    if (TP.isValid(trigger)) {
        evt = trigger.getEvent();
        if (TP.isEvent(evt)) {

            //  Wrap the event into a TIBET DOM signal of some type.
            domSignal = TP.wrap(evt);

            return domSignal.getDocument();
        }
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.sig.ResponderSignal.Inst.defineMethod('getDOMTarget',
function() {

    /**
     * @method getDOMTarget
     * @summary Returns the DOM target of the receiver. If the receiver was
     *     triggered because of a DOM signal, this method will return the *DOM*
     *     target of the signal.
     * @description When triggered via a DOM signal, Responder signals set their
     *     target to their origin so that responder chain semantics work
     *     properly. This method allows access to the original *DOM* target of
     *     the signal.
     * @returns {TP.dom.UIElementNode} The DOM target of the receiver.
     */

    var trigger,
        evt,

        domSignal;

    //  Responder signals are *not* DOM signals, but if they've been triggered
    //  because of a DOM signal, they should have the low-level event in their
    //  payload.
    trigger = this.at('trigger');

    if (TP.isValid(trigger)) {
        evt = trigger.getEvent();
        if (TP.isEvent(evt)) {

            //  Wrap the event into a TIBET DOM signal of some type.
            domSignal = TP.wrap(evt);

            return domSignal.getTarget();
        }
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.sig.ResponderSignal.Inst.defineMethod('getResolvedDOMTarget',
function() {

    /**
     * @method getResolvedDOMTarget
     * @summary Returns the *resolved* DOM target of the receiver. If the
     *     receiver was triggered because of a DOM signal, this method will
     *     return the *resolved* *DOM* target of the signal. See DOM signals for
     *     more information on the difference between targets and resolved
     *     targets.
     * @description When triggered via a DOM signal, Responder signals set their
     *     target to their origin so that responder chain semantics work
     *     properly. This method allows access to the original *resolved* *DOM*
     *     target of the signal.
     * @returns {TP.dom.UIElementNode} The resolved DOM target of the receiver.
     */

    var evt,
        domSignal;

    //  Responder signals are *not* DOM signals, but if they've been triggered
    //  because of a DOM signal, they should have the low-level event in their
    //  payload.
    if (TP.isEvent(evt = this.at('trigger').getEvent())) {

        //  Wrap the event into a TIBET DOM signal of some type.
        domSignal = TP.wrap(evt);

        return domSignal.getResolvedTarget();
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.Inst.defineMethod('getWindow',
function() {

    /**
     * @method getWindow
     * @summary Returns the window from which the signal originated. For
     *     responder signals, this will be the document that it's trigger signal
     *     occurred in.
     * @returns {TP.core.Window} The window object that the receiver occurred
     *     in.
     */

    var trigger,
        evt,

        domSignal;

    //  Responder signals are *not* DOM signals, but if they've been triggered
    //  because of a DOM signal, they should have the low-level event in their
    //  payload.
    trigger = this.at('trigger');

    if (TP.isValid(trigger)) {
        evt = trigger.getEvent();
        if (TP.isEvent(evt)) {

            //  Wrap the event into a TIBET DOM signal of some type.
            domSignal = TP.wrap(evt);

            return domSignal.getWindow();
        }
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.sig.ResponderSignal.Inst.defineMethod('shouldStop',
function(aFlag) {

    /**
     * @method shouldStop
     * @summary Returns true if the signal should stop propagating. If a flag
     *     is provided this flag is used to set the propagation status.
     * @description This method is overridden from its supertype to return true
     *     if *either the signal itself OR its trigger has been configured to
     *     stop propagating. Note that this method does not signal 'Change',
     *     even if it's 'shouldSignalChange' attribute is true.
     * @param {Boolean} aFlag Stop propagating: yes or no?
     * @returns {Boolean} True if the signal should stop propagation.
     */

    var trigger;

    //  if we're not cancelable this is a no-op
    if (!this.isCancelable()) {
        return false;
    }

    if (TP.isDefined(aFlag)) {
        this.$shouldStop = aFlag;
    }

    //  Responder signals are *not* DOM signals, but if they've been triggered
    //  because of a DOM signal, the trigger will be the DOM signal.
    trigger = this.at('trigger');

    if (TP.isValid(trigger)) {
        //  NB: Note here how we're only interested in the return value of the
        //  shouldStop of the trigger (which is why we don't pass the
        //  parameter).
        return this.$shouldStop || trigger.shouldStop();
    }

    return this.$shouldStop;
});

//  ------------------------------------------------------------------------

TP.sig.ResponderSignal.Inst.defineMethod('shouldStopImmediately',
function(aFlag) {

    /**
     * @method shouldStopImmediately
     * @summary Returns true if the signal should stop propagating immediately.
     *     If a flag is provided this flag is used to set the propagation state.
     * @description This method is overridden from its supertype to return true
     *     if *either the signal itself OR its trigger has been configured to
     *     stop propagating immediately. Note that this method does not signal
     *     'Change', even if it's 'shouldSignalChange' attribute is true.
     * @param {Boolean} aFlag Stop propagating immediately: yes or no?
     * @returns {Boolean} True if the signal should stop propagation
     *     immediately.
     */

    var trigger;

    //  if we're not cancelable this is a no-op
    if (!this.isCancelable()) {
        return false;
    }

    if (TP.isDefined(aFlag)) {
        this.$shouldStopImmediately = aFlag;
    }

    //  Responder signals are *not* DOM signals, but if they've been triggered
    //  because of a DOM signal, the trigger will be the DOM signal.
    trigger = this.at('trigger');

    if (TP.isValid(trigger)) {
        //  NB: Note here how we're only interested in the return value of the
        //  shouldStopImmediately of the trigger (which is why we don't pass the
        //  parameter).
        return this.$shouldStopImmediately || trigger.shouldStopImmediately();
    }

    return this.$shouldStopImmediately;
});

//  ------------------------------------------------------------------------
//  Responder Notification Signals
//  ------------------------------------------------------------------------

TP.sig.ResponderSignal.defineSubtype('ResponderNotificationSignal');

TP.sig.ResponderNotificationSignal.Type.defineAttribute('cancelable', false);

//  ------------------------------------------------------------------------

TP.sig.ResponderNotificationSignal.defineSubtype('UIDidActivate');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidDeactivate');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidAlert');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidBlur');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidBusy');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidClose');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidCollapse');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidDelete');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidDeselect');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidDuplicate');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidEndEffect');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidExpand');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidFocus');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidPopFocus');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidPushFocus');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidIdle');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidHelp');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidHide');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidHint');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidInsert');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidOpen');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidScroll');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidSelect');
TP.sig.ResponderNotificationSignal.defineSubtype('UIDidShow');

//  ------------------------------------------------------------------------
//  Responder Interaction Signals
//  ------------------------------------------------------------------------

TP.sig.ResponderSignal.defineSubtype('ResponderInteractionSignal');

//  These are interaction signals, since they're cancelable.
TP.sig.ResponderInteractionSignal.defineSubtype('UIActivate');
TP.sig.ResponderInteractionSignal.defineSubtype('UIDeactivate');

//  ------------------------------------------------------------------------
//  Responder Focus Interaction Signals
//  ------------------------------------------------------------------------

TP.sig.ResponderInteractionSignal.defineSubtype('UIFocusChange');

//  ------------------------------------------------------------------------

TP.sig.UIFocusChange.defineSubtype('UIBlur');
TP.sig.UIFocusChange.defineSubtype('UIFocus');
TP.sig.UIFocusChange.defineSubtype('UIFocusAndSelect');

//  ------------------------------------------------------------------------

TP.sig.ResponderInteractionSignal.defineSubtype('UIFocusComputation');

//  ------------------------------------------------------------------------

TP.sig.UIFocusComputation.defineSubtype('UIFocusFirst');
TP.sig.UIFocusFirst.Type.defineAttribute(
                        'moveAction', TP.FIRST);

TP.sig.UIFocusComputation.defineSubtype('UIFocusLast');
TP.sig.UIFocusLast.Type.defineAttribute(
                        'moveAction', TP.LAST);

TP.sig.UIFocusComputation.defineSubtype('UIFocusPrevious');
TP.sig.UIFocusPrevious.Type.defineAttribute(
                        'moveAction', TP.PREVIOUS);

TP.sig.UIFocusComputation.defineSubtype('UIFocusNext');
TP.sig.UIFocusNext.Type.defineAttribute(
                        'moveAction', TP.NEXT);

TP.sig.UIFocusComputation.defineSubtype('UIFocusFollowing');
TP.sig.UIFocusFollowing.Type.defineAttribute(
                        'moveAction', TP.FOLLOWING);

TP.sig.UIFocusComputation.defineSubtype('UIFocusPreceding');
TP.sig.UIFocusPreceding.Type.defineAttribute(
                        'moveAction', TP.PRECEDING);

TP.sig.UIFocusComputation.defineSubtype('UIFocusFirstInGroup');
TP.sig.UIFocusFirstInGroup.Type.defineAttribute(
                        'moveAction', TP.FIRST_IN_GROUP);

TP.sig.UIFocusComputation.defineSubtype('UIFocusLastInGroup');
TP.sig.UIFocusLastInGroup.Type.defineAttribute(
                        'moveAction', TP.LAST_IN_GROUP);

TP.sig.UIFocusComputation.defineSubtype('UIFocusFirstInNextGroup');
TP.sig.UIFocusFirstInNextGroup.Type.defineAttribute(
                        'moveAction', TP.FIRST_IN_NEXT_GROUP);

TP.sig.UIFocusComputation.defineSubtype('UIFocusFirstInPreviousGroup');
TP.sig.UIFocusFirstInPreviousGroup.Type.defineAttribute(
                        'moveAction', TP.FIRST_IN_PREVIOUS_GROUP);

//  ------------------------------------------------------------------------

TP.sig.ResponderInteractionSignal.defineSubtype('UIShow');
TP.sig.ResponderInteractionSignal.defineSubtype('UIHide');

TP.sig.ResponderInteractionSignal.defineSubtype('UIClose');
TP.sig.ResponderInteractionSignal.defineSubtype('UIOpen');

TP.sig.ResponderInteractionSignal.defineSubtype('UICollapse');
TP.sig.ResponderInteractionSignal.defineSubtype('UIExpand');

TP.sig.ResponderInteractionSignal.defineSubtype('UIBusy');
TP.sig.ResponderInteractionSignal.defineSubtype('UIIdle');

TP.sig.ResponderInteractionSignal.defineSubtype('UIAlert');
TP.sig.ResponderInteractionSignal.defineSubtype('UIHelp');     //  XForms
TP.sig.ResponderInteractionSignal.defineSubtype('UIHint');     //  XForms

TP.sig.ResponderInteractionSignal.defineSubtype('UIRefresh');  //  XForms

TP.sig.ResponderInteractionSignal.defineSubtype('UIEdit');

TP.sig.ResponderInteractionSignal.defineSubtype('UIToggle');

/*
TP.sig.ResponderInteractionSignal.defineSubtype('UIRevalidate');   //  XForms
TP.sig.ResponderInteractionSignal.defineSubtype('UIRecalculate');  //  XForms

TP.sig.ResponderInteractionSignal.defineSubtype('UIReset');   //  XForms
*/

//  ------------------------------------------------------------------------

TP.sig.ResponderInteractionSignal.defineSubtype('UIDataWillSend');

//  ------------------------------------------------------------------------

TP.sig.ResponderNotificationSignal.defineSubtype('UIDataSignal');

TP.sig.UIDataSignal.defineSubtype('UIDataReceived');
TP.sig.UIDataSignal.defineSubtype('UIDataFailed');
TP.sig.UIDataSignal.defineSubtype('UIDataSent');
TP.sig.UIDataSignal.defineSubtype('UIDataSerialize');

TP.sig.UIDataSignal.defineSubtype('UIDataConstruct');
TP.sig.UIDataSignal.defineSubtype('UIDataDestruct');

//  ------------------------------------------------------------------------

TP.sig.ResponderInteractionSignal.defineSubtype('UIValueChange');   //  XForms

TP.sig.ResponderInteractionSignal.defineSubtype('UISelect');        //  XForms
TP.sig.ResponderInteractionSignal.defineSubtype('UIDeselect');      //  XForms

TP.sig.ResponderInteractionSignal.defineSubtype('UIScroll');

TP.sig.ResponderInteractionSignal.defineSubtype('UIInsert');        //  XForms
TP.sig.ResponderInteractionSignal.defineSubtype('UIDelete');        //  XForms

TP.sig.ResponderInteractionSignal.defineSubtype('UIDuplicate');

TP.sig.ResponderInteractionSignal.defineSubtype('UIPageEnd');
TP.sig.ResponderInteractionSignal.defineSubtype('UIPageNext');
TP.sig.ResponderInteractionSignal.defineSubtype('UIPagePrevious');
TP.sig.ResponderInteractionSignal.defineSubtype('UIPageStart');

TP.sig.ResponderInteractionSignal.defineSubtype('UIPageSet');

//  ------------------------------------------------------------------------

TP.sig.ResponderInteractionSignal.defineSubtype('UIStateChange');

TP.sig.UIStateChange.defineSubtype('UIFocused');
TP.sig.UIStateChange.defineSubtype('UIBlurred');

TP.sig.UIStateChange.defineSubtype('UIValid');          //  XForms
TP.sig.UIStateChange.defineSubtype('UIInvalid');        //  XForms

TP.sig.UIStateChange.defineSubtype('UIReadonly');       //  XForms
TP.sig.UIStateChange.defineSubtype('UIReadwrite');      //  XForms

TP.sig.UIStateChange.defineSubtype('UIRequired');       //  XForms
TP.sig.UIStateChange.defineSubtype('UIOptional');       //  XForms

TP.sig.UIStateChange.defineSubtype('UIEnabled');        //  XForms
TP.sig.UIStateChange.defineSubtype('UIDisabled');       //  XForms

TP.sig.UIStateChange.defineSubtype('UIInRange');        //  XForms
TP.sig.UIStateChange.defineSubtype('UIOutOfRange');     //  XForms

//  ========================================================================
//  APP SIGNALS
//  ========================================================================

TP.sig.ResponderSignal.defineSubtype('ApplicationSignal');

TP.sig.ApplicationSignal.shouldUseSingleton(true);

TP.sig.ApplicationSignal.defineSubtype('AppWillInitialize');
TP.sig.AppWillInitialize.Type.defineAttribute('cancelable', true);

TP.sig.ApplicationSignal.defineSubtype('AppInitialize');
TP.sig.ApplicationSignal.defineSubtype('AppDidInitialize');

TP.sig.ApplicationSignal.defineSubtype('AppWillStart');
TP.sig.ApplicationSignal.defineSubtype('AppStart');
TP.sig.ApplicationSignal.defineSubtype('AppDidStart');

TP.sig.ApplicationSignal.defineSubtype('AppStop');

TP.sig.ApplicationSignal.defineSubtype('AppWillShutdown');
TP.sig.AppWillShutdown.Type.defineAttribute('cancelable', true);

TP.sig.ApplicationSignal.defineSubtype('AppShutdown');

TP.sig.ApplicationSignal.defineSubtype('TargetIn');
TP.sig.ApplicationSignal.defineSubtype('TargetOut');

//  ========================================================================
//  DOM SIGNALS
//  ========================================================================

TP.sig.Signal.defineSubtype('DOMSignal');

TP.sig.DOMSignal.Type.defineAttribute('defaultPolicy', TP.DOM_FIRING);

TP.sig.DOMSignal.Type.defineAttribute('bubbling', true);
TP.sig.DOMSignal.Type.defineAttribute('cancelable', true);

//  ------------------------------------------------------------------------
//  DOM Initialization Signals
//  ------------------------------------------------------------------------

TP.sig.DOMSignal.defineSubtype('DOMInitializationSignal');

//  DOM initialization signals are *not* cancelable.
TP.sig.DOMInitializationSignal.Type.defineAttribute('cancelable', false);

//  ------------------------------------------------------------------------
//  DOM Content Signals
//  ------------------------------------------------------------------------

//  Fired when a DOM node is loaded - this might be an opaque element, like
//  an <object> element
TP.sig.DOMSignal.defineSubtype('DOMLoaded');

//  Fired when a DOM node is unloaded - this might be an opaque element, like
//  an <object> element
TP.sig.DOMSignal.defineSubtype('DOMUnloaded');

//  Fired when the content of a DOM node is loaded.
TP.sig.DOMLoaded.defineSubtype('DOMContentLoaded');

//  Fired when the content of a DOM node is unloaded.
TP.sig.DOMUnloaded.defineSubtype('DOMContentUnloaded');

//  ------------------------------------------------------------------------

//  Fired when a DOM node is ready - it's dynamic content has been loaded, other
//  dynamically loaded assets are realized, etc.
TP.sig.DOMSignal.defineSubtype('DOMReady');   //  XForms

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.sig.DOMLoaded.Type.defineMethod('shouldLog',
function() {

    /**
     * @method shouldLog
     * @summary Returns true when the signal can be logged during signal
     *     processing. At this level, this method returns whether TIBET should
     *     be logging 'TP.sig.DOMLoaded' signals.
     * @returns {Boolean}
     */

    return TP.sys.shouldLogDOMLoadedSignals();
});

//  ------------------------------------------------------------------------
//  DOM Interaction Signals
//  ------------------------------------------------------------------------

TP.sig.DOMSignal.defineSubtype('DOMInteractionSignal');

TP.sig.DOMInteractionSignal.defineSubtype('DOMClose');

//  ------------------------------------------------------------------------
//  DOM Notification Signals
//  ------------------------------------------------------------------------

TP.sig.DOMSignal.defineSubtype('DOMNotificationSignal');

//  DOM notification signals are *not* cancelable.
TP.sig.DOMNotificationSignal.Type.defineAttribute('cancelable', false);

//  ------------------------------------------------------------------------
//  DOM EXCEPTIONS
//  ------------------------------------------------------------------------

TP.sig.ERROR.defineSubtype('DOMException');

TP.sig.DOMException.defineSubtype('ElementNotFound');

TP.sig.DOMException.defineSubtype('InvalidMarkup');
TP.sig.DOMException.defineSubtype('InvalidNode');
TP.sig.DOMException.defineSubtype('InvalidNodeList');
TP.sig.DOMException.defineSubtype('InvalidNamedNodeMap');

TP.sig.InvalidNode.defineSubtype('InvalidDocument');
TP.sig.InvalidNode.defineSubtype('InvalidXMLDocument');
TP.sig.InvalidNode.defineSubtype('InvalidAttributeNode');
TP.sig.InvalidNode.defineSubtype('InvalidElement');

TP.sig.DOMException.defineSubtype('SerializationException');
TP.sig.DOMException.defineSubtype('DOMParseException');

TP.sig.DOMException.defineSubtype('DOMComponentException');

TP.sig.DOMException.defineSubtype('InvalidStyleDeclaration');
TP.sig.DOMException.defineSubtype('InvalidStyleRule');
TP.sig.DOMException.defineSubtype('InvalidStyleSheet');

//  ------------------------------------------------------------------------
//  DOM Error Indication Signals
//  ------------------------------------------------------------------------

TP.sig.DOMNotificationSignal.defineSubtype('DOMErrorIndicationSignal');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.DOMErrorIndicationSignal.Inst.defineMethod('getLevel',
function() {

    /**
     * @method getLevel
     * @summary Returns the error level for the receiving signal.
     * @returns {Number}
     */

    return TP.ERROR;
});

//  ------------------------------------------------------------------------

TP.sig.DOMErrorIndicationSignal.defineSubtype('DOMOutputError');           //  XForms
TP.sig.DOMErrorIndicationSignal.defineSubtype('DOMSubmitError');           //  XForms

//  ------------------------------------------------------------------------

TP.sig.DOMErrorIndicationSignal.defineSubtype('DOMLinkException');     //  XForms
TP.sig.DOMErrorIndicationSignal.defineSubtype('DOMLinkError');         //  XForms
TP.sig.DOMErrorIndicationSignal.defineSubtype('DOMComputeException');      //  XForms

//  ------------------------------------------------------------------------
//  DOM Service Signals
//  ------------------------------------------------------------------------

TP.sig.DOMInteractionSignal.defineSubtype('DOMService');

TP.sig.DOMInteractionSignal.defineSubtype('DOMServiceRequestConstruct');
TP.sig.DOMInteractionSignal.defineSubtype('DOMServiceRequestConstructDone');

TP.sig.DOMInteractionSignal.defineSubtype('DOMServiceResponseConstruct');
TP.sig.DOMInteractionSignal.defineSubtype('DOMServiceResponseConstructDone');

TP.sig.DOMNotificationSignal.defineSubtype('DOMServiceTransmitDone');

TP.sig.DOMNotificationSignal.defineSubtype('DOMServiceDone');

TP.sig.DOMErrorIndicationSignal.defineSubtype('DOMServiceError');

//  ========================================================================
//  DOM UI signals
//  ========================================================================

/**
 * @type {TP.sig.DOMUISignal}
 * @summary TP.sig.DOMUISignal is the supertype for all DOM-related UI signals
 *     in the TIBET framework.
 * @description TP.sig.DOMUISignal and its subtypes handle UI signals thrown
 *     from pages and are basically types that map a browser's native events
 *     into TIBET signal types.
 *
 *     We do define TIBET signal mappings for some of the DOM Level 3 Events at
 *     the bottom of this file. These are used throughout TIBET in our quest for
 *     standards-compliance :-).
 *
 *     At the TP.sig.DOMUISignal level, all signals are configured to return
 *     'false' to the native event handler. Therefore, the following signals
 *     have the following behavior:
 *
 *     TP.sig.DOMClick: We don't want to perform the default behavior (esp.
 *     for Links, which would be to follow the link).
 *
 *     TP.sig.DOMContextMenu: We don't want the context menu to show.
 *
 *     TP.sig.DOMMouseDown: We don't want the mouse down's default action to
 *     happen.
 *
 *     TP.sig.DOMMouseUp: We don't want the mouse up's default action to happen.
 *
 *     TP.sig.DOMReset: In general, we don't reset FORMs this way in TIBET.
 *
 *     TP.sig.DOMSubmit: In general, we don't submit FORMs this way in TIBET.
 *
 *     The following signal types override that behavior and return 'true':
 *
 *     TP.sig.DOMKeySignal: All subtypes of the key signal want to perform their
 *     default behavior, which is to allow the key stroke.
 *
 *     TP.sig.DOMMouseOver: Don't show Link URLs in the status bar.
 *
 *     This parameter can always be set to a different value in the signal
 *     handlers themselves.
 */
//  ------------------------------------------------------------------------

TP.sig.DOMSignal.defineSubtype('DOMUISignal');

TP.sig.DOMUISignal.isSignalingRoot(true);

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  Does this signal type require low-level arming for signal hooks.
TP.sig.DOMUISignal.Type.defineAttribute('needsArming', false);

//  The handler function installed when events of this type are armed
TP.sig.DOMUISignal.Type.defineAttribute('armingHandler',
                                    TP.$dispatchEventToTIBET);

//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.Type.defineMethod('arm',
function(anOrigin, aHandler, aPolicy, windowContext) {

    /**
     * @method arm
     * @summary Arms one or more origins to ensure they trigger signals of the
     *     receiver's type.
     * @param {Object|Object[]|String} anOrigin The origin or origins to arm.
     * @param {Function} aHandler An (optional) parameter that defines a native
     *     handler to be used instead of routing the event to TIBET.
     * @param {String|Function} aPolicy An (optional) parameter that defines the
     *     firing policy which should be used when firing.
     * @param {Window} windowContext An optional window to search for the
     *     element(s). If not provided then the TP.context() method is used to
     *     find one.
     * @returns {TP.meta.sig.DOMUISignal} The receiver.
     */

    var context,
        handler,
        policy;

    if (!this.requiresArming()) {
        return this;
    }

    context = windowContext;
    if (TP.notValid(context)) {
        context = TP.nodeGetWindow(anOrigin);
        if (TP.notValid(context)) {
            context = TP.sys.getUICanvas(true);
        }
    }

    if (TP.isDocument(context)) {
        context = TP.nodeGetWindow(context);
    }

    handler = aHandler;
    if (TP.notValid(handler)) {
        handler = this.get('armingHandler');
    }

    policy = aPolicy;
    if (TP.notValid(policy)) {
        policy = this.get('defaultPolicy');
    }

    TP.windowArmNode(context,
                        TP.byId(anOrigin, context, false),
                        this.getSignalName(),
                        handler,
                        policy);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.Type.defineMethod('disarm',
function(anOrigin, aHandler, windowContext) {

    /**
     * @method disarm
     * @summary Disarms an origin so it no longer triggers events of the
     *     receiver's type. NOTE that this doesn't always work if there have
     *     been additional low-level listeners installed.
     * @param {Object|Object[]|String} anOrigin The origin or origins to disarm.
     * @param {Function} aHandler An (optional) parameter that defines a native
     *     handler to be used instead of routing the event to TIBET.
     * @param {Window} windowContext An optional window to search for the
     *     element(s). If not provided then the TP.context() method is used to
     *     find one.
     * @returns {TP.meta.sig.DOMUISignal} The receiver.
     */

    var context,
        handler;

    if (!this.requiresArming()) {
        return this;
    }

    context = windowContext;
    if (TP.notValid(context)) {
        context = TP.nodeGetWindow(anOrigin);
        if (TP.notValid(context)) {
            context = TP.sys.getUICanvas(true);
        }
    }


    if (TP.isDocument(context)) {
        context = TP.nodeGetWindow(context);
    }

    handler = aHandler;
    if (TP.notValid(handler)) {
        handler = this.get('armingHandler');
    }

    TP.windowDisarmNode(context,
                        TP.byId(anOrigin, context, false),
                        this.getSignalName(),
                        handler);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.Type.defineMethod('requiresArming',
function(aFlag) {

    /**
     * @method requiresArming
     * @summary Combined setter/getter for the receiver's arming control flag.
     *     When a signal observation is made the signal is queried to determine
     *     if arming for the origin is required for that type of signal. Most
     *     signal types return false.
     * @param {Boolean} aFlag The new arming flag value.
     * @returns {Boolean} True if the receiving type requires arming of native
     *     nodes or other structures to actually receive events.
     */

    if (TP.isBoolean(aFlag)) {
        this.$set('needsArming', aFlag);
    }

    return this.$get('needsArming');
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.Inst.defineMethod('init',
function(aPayload, noEvent) {

    /**
     * @method init
     * @summary Initialize the instance.
     * @description For a TP.sig.DOMUISignal the typical payload is a native
     *     event object or an array whose first item is the native event. You
     *     can also provide a TP.core.Hash as the payload and it will be treated
     *     as a container for the event properties normally associated with an
     *     Event.
     * @param {Object} aPayload A subtype-specific argument object.
     * @param {Boolean} noEvent True to skip event fabrication when there's no
     *     event provided. [False].
     * @returns {TP.sig.DOMUISignal} The receiver.
     */

    var obj;

    //  regardless of payload type this will store the event as our payload
    //  slot. Below we then reset that value (via setEvent()) to a
    //  'normalized' event object.
    this.callNextMethod();

    if (TP.isTrue(noEvent) && TP.notValid(aPayload)) {
        return this;
    }

    //  two cases are common for passing in an actual event, the payload or
    //  a payload whose first element is the event. in either case we want
    //  to normalize the event before we go any further
    if (TP.isEvent(aPayload)) {
        this.setEvent(TP.event(aPayload));
    } else if (TP.isArray(aPayload)) {
        obj = aPayload.first();
        if (TP.isEvent(obj)) {
            this.setEvent(TP.event(obj));
        }
    }

    //  if we don't have a native event its a little trickier since we want
    //  to allow TP.core.Hash input, or potentially native object input and
    //  we want to end up with an object that simulates all the event slots
    if (TP.notValid(this.getEvent())) {
        obj = this.$fabricateEvent(aPayload);
        this.setEvent(obj);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.Inst.defineMethod('copy',
function(deep, aFilterNameOrKeys, contentOnly) {

    /**
     * @method copy
     * @summary Returns a 'copy' of the receiver. Actually, a new instance
     *     whose value is equalTo that of the receiver.
     * @param {Boolean} [deep=false] True to force clones to be deep.
     * @param {String|String[]} aFilterNameOrKeys get*Interface() filter or key
     *     array.
     * @param {Boolean} [contentOnly=true] Copy content only?
     * @returns {TP.sig.DOMUISignal} A copy of the receiver.
     */

    var newinst;

    newinst = this.callNextMethod();

    //  Use the low-level 'copy()' method added to Event.prototype
    newinst.event = this.getEvent().copy();

    return newinst;
});

//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.Inst.defineMethod('$fabricateEvent',
function(aPayload) {

    /**
     * @method $fabricateEvent
     * @summary Constructs a normalized event object suitable for the payload
     *     provided. This is typically only invoked via the init function and
     *     only when a native Event isn't provided.
     * @param {Object} aPayload The signal's payload object.
     * @returns {Event|Object} A native Event or Object with Event slots.
     */

    var hash;

    hash = TP.isHash(aPayload) ? aPayload : TP.hc();
    hash.addIfAbsent(
            'target', null,
            'currentTarget', null,
            'relatedTarget', null,

            'type', this.getType().NATIVE_NAME,

            'timeStamp', new Date().getTime(),

            'clientX', 0,
            'clientY', 0,
            'offsetX', 0,
            'offsetY', 0,

            'view', null,

            'pageX', 0,
            'pageY', 0,
            'screenX', 0,
            'screenY', 0,

            'keyCode', 0,

            'altKey', false,
            'ctrlKey', false,
            'shiftKey', false,

            'metaKey', false,

            'button', 0,

            'wheelDelta', 0,

            //  Specific to Mozilla/Webkit
            'charCode', 0,

            //  Specific to Mozilla
            'which', null,

            //  Specific to IE
            'returnValue', false,
            'cancelBubble', false
            );


    //  either we can create a native event or we'll use the hash itself and
    //  hope it has the right keys :)
    return TP.documentConstructEvent(null, hash) || hash;
});

//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.Inst.defineMethod('getAltKey',
function() {

    /**
     * @method getAltKey
     * @summary Returns the alt key setting at the time of the event.
     * @returns {Boolean} Returns true if the alt key was pressed, false if it
     *     wasn't.
     */

    return TP.eventGetAltKey(this.getEvent());
});

//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.Inst.defineMethod('getCtrlKey',
function() {

    /**
     * @method getCtrlKey
     * @summary Returns the ctrl key setting at the time of the event.
     * @returns {Boolean} Returns true if the ctrl key was pressed, false if it
     *     wasn't.
     */

    return TP.eventGetCtrlKey(this.getEvent());
});

//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.Inst.defineMethod('getMetaKey',
function() {

    /**
     * @method getMetaKey
     * @summary Returns the meta key setting at the time of the event.
     * @description Internet Explorer does not support a 'meta key' setting,
     *     therefore this method will always return false in that browser.
     * @returns {Boolean} Returns true if the meta key was pressed, false if it
     *     wasn't.
     */

    return TP.eventGetMetaKey(this.getEvent());
});

//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.Inst.defineMethod('getShiftKey',
function() {

    /**
     * @method getShiftKey
     * @summary Returns the shift key setting at the time of the event.
     * @returns {Boolean} Returns true if the shift key was pressed, false if it
     *     wasn't.
     */

    return TP.eventGetShiftKey(this.getEvent());
});

//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.Inst.defineMethod('getEvent',
function() {

    /**
     * @method getEvent
     * @summary Returns the event object containing event information for this
     *     signal.
     * @returns {Object} The event object for this signal.
     */

    return this.getPayload();
});

//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.Inst.defineMethod('getEventType',
function() {

    /**
     * @method getEventType
     * @summary Returns the event type of the native event.
     * @returns {String} The event type.
     */

    return TP.eventGetType(this.getEvent());
});

//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.Inst.defineMethod('getNativeObject',
function() {

    /**
     * @method getNativeObject
     * @summary Returns the native object that the receiver is wrapping. In the
     *     case of TP.sig.DOMUISignals, this is the receiver's native Event
     *     object that it contains
     * @returns {Event} The receiver's native Event object.
     */

    return this.getEvent();
});

//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.Inst.defineMethod('getResolvedTarget',
function() {

    /**
     * @method getResolvedTarget
     * @summary Returns the 'resolved target', the element that was resolved
     *     using the 'resolvedTarget' getter instrumented onto Event.prototype
     *     in the hook file. That getter method uses TP.eventResolveTarget().
     *     See that method for more information.
     * @returns {Element} The 'resolved target' of the signal.
     */

    return TP.eventGetResolvedTarget(this.getEvent());
});

//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.Inst.defineMethod('getTarget',
function() {

    /**
     * @method getTarget
     * @summary Returns the target of the receiver's event.
     * @returns {Node} The target of event/signal.
     */

    return TP.eventGetTarget(this.getEvent());
});

//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.Inst.defineMethod('getTime',
function() {

    /**
     * @method getTime
     * @summary Returns the time that the signal/event was fired.
     * @returns {Number} The time that the signal/event was fired.
     */

    var firingTime;

    //  If a firing time isn't in the signal itself (usually, for non-GUI
    //  signals, this is set when the signal is fired), then use the firing time
    //  encoded in the underlying native Event object.
    if (!TP.isNumber(firingTime = this.$get('time'))) {
        firingTime = TP.eventGetTime(this.getEvent());
    }

    return firingTime;
});

//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.Inst.defineMethod('getWindow',
function() {

    /**
     * @method getWindow
     * @summary Returns the window object that the native event occurred in.
     * @returns {TP.core.Window} The window containing the source element that
     *     generated the event.
     */

    return TP.tpwin(TP.eventGetWindow(this.getEvent()));
});

//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.Inst.defineMethod('setEvent',
function(normalizedEvent) {

    /**
     * @method setEvent
     * @summary Sets the native event which this signal instance represents.
     * @param {Event} normalizedEvent The native event containing the signal's
     *     raw data.
     * @returns {TP.sig.DOMUISignal} The receiver.
     */

    this.setPayload(normalizedEvent);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.Inst.defineMethod('shouldPrevent',
function(aFlag) {

    /**
     * @method shouldPrevent
     * @summary Returns true if the signal handler(s) should not perform the
     *     default action. If a flag is provided this flag is used to set the
     *     prevent status.
     * @param {Boolean} aFlag Whether or not the signal should perform the
     *     default action.
     * @returns {Boolean} Whether or not this signal is going to prevent the
     *     default action from happening.
     */

    var retValue,
        evt;

    retValue = this.callNextMethod();

    if (TP.isEvent(evt = this.getEvent())) {
        if (TP.isTrue(aFlag)) {
            //  The hook file patches all native events to support this
            //  call. Note that we put this in an empty try...catch. Some native
            //  events don't like to have preventDefault called on them.
            try {
                evt.preventDefault();
            } catch (e) {
                //  Empty
            }
        }
    }

    return retValue;
});

//  ------------------------------------------------------------------------
//  COMMON SUBTYPES
//  ------------------------------------------------------------------------

//  ========================================================================
//  DOM Level 0 Event Signals
//  ========================================================================

TP.sig.DOMUISignal.defineSubtype('DOMAbort');
TP.sig.DOMAbort.Type.defineConstant('NATIVE_NAME', 'abort');

//  ---

TP.sig.DOMUISignal.defineSubtype('DOMAnimationEnd');
TP.sig.DOMAnimationEnd.Type.defineConstant('NATIVE_NAME', 'animationend');

//  ---

TP.sig.DOMUISignal.defineSubtype('DOMBlur');
TP.sig.DOMBlur.Type.defineConstant('NATIVE_NAME', 'blur');

//  DOMBlur signals are *not* cancelable.
TP.sig.DOMBlur.Type.defineAttribute('cancelable', false);

TP.sig.DOMBlur.Type.defineMethod('shouldLog',
function() {

    /**
     * @method shouldLog
     * @summary Returns true when the signal can be logged during signal
     *     processing. At this level, this method returns whether TIBET should
     *     be logging 'TP.sig.DOMFocus' signals.
     * @returns {Boolean}
     */

    return TP.sys.shouldLogDOMFocusSignals();
});

//  ---

TP.sig.DOMUISignal.defineSubtype('DOMChange');
TP.sig.DOMChange.Type.defineConstant('NATIVE_NAME', 'change');

//  ---

TP.sig.DOMUISignal.defineSubtype('DOMCopy');
TP.sig.DOMCopy.Type.defineConstant('NATIVE_NAME', 'copy');

//  ---

TP.sig.DOMUISignal.defineSubtype('DOMCut');
TP.sig.DOMCut.Type.defineConstant('NATIVE_NAME', 'cut');

//  ---

TP.sig.DOMUISignal.defineSubtype('DOMError');
TP.sig.DOMError.Type.defineConstant('NATIVE_NAME', 'error');

//  ---

TP.sig.DOMUISignal.defineSubtype('DOMFocus');
TP.sig.DOMFocus.Type.defineConstant('NATIVE_NAME', 'focus');

//  DOMFocus signals are *not* cancelable.
TP.sig.DOMFocus.Type.defineAttribute('cancelable', false);

TP.sig.DOMFocus.Type.defineMethod('shouldLog',
function() {

    /**
     * @method shouldLog
     * @summary Returns true when the signal can be logged during signal
     *     processing. At this level, this method returns whether TIBET should
     *     be logging 'TP.sig.DOMFocus' signals.
     * @returns {Boolean}
     */

    return TP.sys.shouldLogDOMFocusSignals();
});

//  ---

TP.sig.DOMUISignal.defineSubtype('DOMLoad');
TP.sig.DOMLoad.Type.defineConstant('NATIVE_NAME', 'load');

//  ---

TP.sig.DOMUISignal.defineSubtype('DOMMove');
TP.sig.DOMMove.Type.defineConstant('NATIVE_NAME', 'move');

//  ---

TP.sig.DOMUISignal.defineSubtype('DOMPaste');
TP.sig.DOMPaste.Type.defineConstant('NATIVE_NAME', 'paste');

//  ---

TP.sig.DOMUISignal.defineSubtype('DOMReset');
TP.sig.DOMReset.Type.defineConstant('NATIVE_NAME', 'reset');

//  ---

TP.sig.DOMUISignal.defineSubtype('DOMMonitoredResize');
TP.sig.DOMMonitoredResize.Type.defineConstant('NATIVE_NAME', 'resize');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.sig.DOMMonitoredResize.Type.defineMethod('getSignalOwner',
function() {

    /**
     * @method getSignalOwner
     * @summary Returns the Object or Type responsible for signals of this
     *     type.
     * @returns {Object|TP.lang.RootObject} The signal type's owner.
     */

    return TP.core.ResizeMonitor;
});

//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.defineSubtype('DOMResize');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.sig.DOMResize.Type.defineMethod('getSignalOwner',
function() {

    /**
     * @method getSignalOwner
     * @summary Returns the Object or Type responsible for signals of this
     *     type.
     * @returns {Object|TP.lang.RootObject} The signal type's owner.
     */

    return TP.core.ResizeSignalSource;
});

//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.defineSubtype('DOMVisibility');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.sig.DOMVisibility.Type.defineMethod('getSignalOwner',
function() {

    /**
     * @method getSignalOwner
     * @summary Returns the Object or Type responsible for signals of this
     *     type.
     * @returns {Object|TP.lang.RootObject} The signal type's owner.
     */

    return TP.core.VisibilitySignalSource;
});

//  ---

TP.sig.DOMVisibility.defineSubtype('DOMVisible');
TP.sig.DOMVisibility.defineSubtype('DOMHidden');

//  ------------------------------------------------------------------------

TP.sig.DOMUISignal.defineSubtype('DOMScroll');
TP.sig.DOMScroll.Type.defineConstant('NATIVE_NAME', 'scroll');

//  ---

TP.sig.DOMUISignal.defineSubtype('DOMSubmit');
TP.sig.DOMSubmit.Type.defineConstant('NATIVE_NAME', 'submit');

//  ---

TP.sig.DOMUISignal.defineSubtype('DOMTransitionEnd');
TP.sig.DOMTransitionEnd.Type.defineConstant('NATIVE_NAME', 'transitionend');

//  ---

TP.sig.DOMUISignal.defineSubtype('DOMUnload');
TP.sig.DOMUnload.Type.defineConstant('NATIVE_NAME', 'unload');

//  ========================================================================
//  DOM REPOSITION SIGNAL
//  ========================================================================

TP.sig.DOMUISignal.defineSubtype('DOMMonitoredReposition');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.sig.DOMMonitoredReposition.Type.defineMethod('getSignalOwner',
function() {

    /**
     * @method getSignalOwner
     * @summary Returns the Object or Type responsible for signals of this
     *     type.
     * @returns {Object|TP.lang.RootObject} The signal type's owner.
     */

    return TP.core.RepositionMonitor;
});

//  ========================================================================
//  DOM Level 3 Event Signals
//  ========================================================================

//  This isn't the (now deprecated) DOMFocusIn taken from the XForms spec -
//  this is the TIBET signal wrapper for the (new) 'focusin' event as
//  spec'ed in DOM Level 3.
TP.sig.DOMUISignal.defineSubtype('DOMFocusIn');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.sig.DOMFocusIn.Type.defineConstant('NATIVE_NAME', 'focusin');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.sig.DOMFocusIn.Type.defineMethod('shouldLog',
function() {

    /**
     * @method shouldLog
     * @summary Returns true when the signal can be logged during signal
     *     processing. At this level, this method returns whether TIBET should
     *     be logging 'TP.sig.DOMFocus' signals.
     * @returns {Boolean}
     */

    return TP.sys.shouldLogDOMFocusSignals();
});

//  ------------------------------------------------------------------------

//  This isn't the (now deprecated) DOMFocusOut taken from the XForms spec -
//  this is the TIBET signal wrapper for the (new) 'focusout' event as
//  spec'ed in DOM Level 3.
TP.sig.DOMUISignal.defineSubtype('DOMFocusOut');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.sig.DOMFocusOut.Type.defineConstant('NATIVE_NAME', 'focusout');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.sig.DOMFocusOut.Type.defineMethod('shouldLog',
function() {

    /**
     * @method shouldLog
     * @summary Returns true when the signal can be logged during signal
     *     processing. At this level, this method returns whether TIBET should
     *     be logging 'TP.sig.DOMFocus' signals.
     * @returns {Boolean}
     */

    return TP.sys.shouldLogDOMFocusSignals();
});

//  ------------------------------------------------------------------------

//  This is the TIBET signal wrapper for the (new) 'input' event as spec'ed in
//  DOM Level 3.
TP.sig.DOMUISignal.defineSubtype('DOMInput');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.sig.DOMInput.Type.defineConstant('NATIVE_NAME', 'input');

//  ========================================================================
//  DOM MOUSE SIGNALS
//  ========================================================================

TP.sig.DOMUISignal.defineSubtype('DOMMouseSignal');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Type.defineMethod('getSignalOwner',
function() {

    /**
     * @method getSignalOwner
     * @summary Returns the Object or Type responsible for signals of this
     *     type.
     * @returns {Object|TP.lang.RootObject} The signal type's owner.
     */

    return TP.sys.getTypeByName('TP.core.Mouse');
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getButton',
function() {

    /**
     * @method getButton
     * @summary Returns a TIBET constant signifying which mouse button was
     *     pressed in the native event that generated this signal.
     * @returns {String} The TIBET constant signifying which button was pressed.
     *     This can be TP.LEFT, TP.MIDDLE, TP.RIGHT.
     */

    return TP.eventGetButton(this.getEvent());
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getClientX',
function() {

    /**
     * @method getClientX
     * @summary Returns the X coordinate of the signal relative to the window
     *     containing the source element.
     * @returns {Number} The X coordinate of the signal relative to its window.
     */

    var evt;

    evt = this.getEvent();

    return TP.ifInvalid(evt.$$clientX, evt.clientX);
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getClientY',
function() {

    /**
     * @method getClientY
     * @summary Returns the Y coordinate of the signal relative to the window
     *     containing the source element.
     * @returns {Number} The Y coordinate of the signal relative to its window.
     */

    var evt;

    evt = this.getEvent();

    return TP.ifInvalid(evt.$$clientY, evt.clientY);
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getClientPoint',
function() {

    /**
     * @method getClientPoint
     * @summary Returns the X/Y TP.gui.Point of the signal relative to the
     *     window containing the source element.
     * @returns {TP.gui.Point} The X/Y point of the signal relative to its
     *     window.
     */

    var evt,
        point;

    evt = this.getEvent();

    if (TP.notValid(point = evt.$$clientPt)) {
        point = TP.pc(this.getClientX(), this.getClientY());
        evt.$$clientPt = point;
    }

    return point;
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getElementAtPagePoint',
function() {

    /**
     * @method getElementAtPagePoint
     * @summary Returns the element currently under the receiver's 'page point'.
     * @description On occasion, events will be dispatched between nested
     *     iframes from the 'most nested' iframe - not taking into account the
     *     nesting even when the mouse is not 'over' the most nested iframe.
     *     This method allows the caller to consistently compute the element
     *     that the mouse is over, no matter which iframe it is hosted in.
     * @returns {Element|null} The element at the receiver's page point.
     */

    var targetDoc,
        targetWin,

        pageX,
        pageY,

        computedTargetElem,

        frameElementWin,

        frameOffsetXAndY;

    targetDoc = this.getDocument().getNativeNode();
    targetWin = TP.nodeGetWindow(targetDoc);

    pageX = this.at('pageX');
    pageY = this.at('pageY');

    //  Try to get the element from the original target document. This very well
    //  may be hosted in the 'most nested iframe'.
    computedTargetElem = targetDoc.elementFromPoint(pageX, pageY);

    frameElementWin = targetWin;

    //  If we couldn't compute a target element, we iterate up through any
    //  nested frames to try to compute one from the parent frames.
    while (!TP.isElement(computedTargetElem)) {

        //  If the current frame element window is not an iframe window, then we
        //  must have reached 'top' without being able to compute a proper
        //  element. Just return null.
        if (!TP.isIFrameWindow(frameElementWin)) {
            return null;
        }

        //  Reset the current frame element window by obtaining the window of
        //  the frame element's window. This will be its 'parent window'.
        frameElementWin = TP.nodeGetWindow(frameElementWin.frameElement);

        //  We need to offset the pageX/pageY from the original target window to
        //  the frame window that we're currently processing.
        frameOffsetXAndY = TP.windowComputeWindowOffsets(
                            frameElementWin,
                            targetWin,
                            false);
        pageX += frameOffsetXAndY.first();
        pageY += frameOffsetXAndY.last();

        //  Try to compute a target element using the new current frame element
        //  window and translated coordinates.
        computedTargetElem =
            frameElementWin.document.elementFromPoint(pageX, pageY);
    }

    return computedTargetElem;
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getGlobalX',
function(wantsTransformed) {

    /**
     * @method getGlobalX
     * @summary Returns the X coordinate of the signal relative to its overall
     *     *top level* window.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @returns {Number} The X coordinate of the signal relative to its overall
     *     top level window.
     */

    var globalPoint;

    if (TP.isValid(globalPoint = this.getGlobalPoint())) {
        return globalPoint.getX();
    }

    return -1;
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getGlobalY',
function(wantsTransformed) {

    /**
     * @method getGlobalY
     * @summary Returns the Y coordinate of the signal relative to its overall
     *     *top level* window.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @returns {Number} The Y coordinate of the signal relative to its overall
     *     top level window.
     */

    var globalPoint;

    if (TP.isValid(globalPoint = this.getGlobalPoint())) {
        return globalPoint.getY();
    }

    return -1;
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getGlobalPoint',
function(wantsTransformed) {

    /**
     * @method getGlobalPoint
     * @summary Returns the X/Y TP.gui.Point of the signal as a global
     *     position. The global position is the signal's mouse position
     *     relative to its overall *top level* window.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @returns {TP.gui.Point} The X/Y point of the signal relative to its
     *     overall top level window.
     */

    var evt,
        point,

        evtWin,
        target,
        topWin,

        winFrameElem,

        eventOffsetXAndY;

    evt = this.getEvent();

    if (TP.isValid(point = evt.$$globalPt)) {
        return point;
    }

    evtWin = TP.eventGetWindow(evt);

    if (TP.isElement(winFrameElem = evtWin.frameElement)) {
        target = TP.eventGetTarget(evt);
        if (TP.isElement(target)) {
            topWin = TP.nodeGetTopWindow(target);
        } else {
            topWin = TP.topWindow;
        }

        //  Note here that we pass the result of obtaining the top window for
        //  the supplied element as the first argument since we really just want
        //  the offset of winFrameElem from the top (which will be 0,0 offset
        //  from itself).
        eventOffsetXAndY = TP.windowComputeWindowOffsets(
                            topWin,
                            TP.elementGetIFrameWindow(winFrameElem),
                            wantsTransformed);
    } else {
        eventOffsetXAndY = TP.ac(0, 0);
    }

    point = TP.pc(this.getPageX() + eventOffsetXAndY.first(),
                    this.getPageY() + eventOffsetXAndY.last());

    evt.$$globalPt = point;

    return point;
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getOffsetX',
function() {

    /**
     * @method getOffsetX
     * @summary Returns the X coordinate of the signal relative to the
     *     containing source element.
     * @returns {Number} The X coordinate of the signal relative to its
     *     containing element.
     */

    var evt;

    evt = this.getEvent();

    return TP.ifInvalid(evt.$$offsetX, evt.offsetX);
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getOffsetXAdjustedFor',
function(anElement) {

    /**
     * @method getOffsetXAdjustedFor
     * @summary Returns the X coordinate of the signal relative to the
     *     containing source element, but adjusted to the supplied element.
     *     If the supplied element is in a different window than the signal's
     *     source element, the return value is adjusted to take into account the
     *     difference between the two.
     * @returns {Element} anElement The element whose window will be compared to
     *     the signal's source window for offset computation purposes (if
     *     they're different).
     * @returns {Number} The X coordinate of the signal relative to its
     *     containing element, but adjusted to any offset in the windows between
     *     where the signal occurred and the window of the supplied element (if
     *     they're different).
     */

    var offsetX,

        elemWin,
        evtWin,

        frameOffsetXAndY;

    offsetX = this.getOffsetX();

    elemWin = TP.nodeGetWindow(anElement);
    evtWin = TP.eventGetWindow(this.getEvent());
    if (elemWin === evtWin) {
        return offsetX;
    }

    frameOffsetXAndY = TP.core.Mouse.computeWindowOffsetsBetween(
                                                        evtWin, elemWin);
    offsetX -= frameOffsetXAndY.first();

    return offsetX;
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getOffsetY',
function() {

    /**
     * @method getOffsetY
     * @summary Returns the Y coordinate of the signal relative to the
     *     containing source element.
     * @returns {Number} The Y coordinate of the signal relative to its
     *     containing element.
     */

    var evt;

    evt = this.getEvent();

    return TP.ifInvalid(evt.$$offsetY, evt.offsetY);
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getOffsetYAdjustedFor',
function(anElement) {

    /**
     * @method getOffsetYAdjustedFor
     * @summary Returns the Y coordinate of the signal relative to the
     *     containing source element, but adjusted to the supplied element.
     *     If the supplied element is in a different window than the signal's
     *     source element, the return value is adjusted to take into account the
     *     difference between the two.
     * @returns {Element} anElement The element whose window will be compared to
     *     the signal's source window for offset computation purposes (if
     *     they're different).
     * @returns {Number} The Y coordinate of the signal relative to its
     *     containing element, but adjusted to any offset in the windows between
     *     where the signal occurred and the window of the supplied element (if
     *     they're different).
     */

    var offsetY,

        elemWin,
        evtWin,

        frameOffsetXAndY;

    offsetY = this.getOffsetY();

    elemWin = TP.nodeGetWindow(anElement);
    evtWin = TP.eventGetWindow(this.getEvent());
    if (elemWin === evtWin) {
        return offsetY;
    }

    frameOffsetXAndY = TP.core.Mouse.computeWindowOffsetsBetween(
                                                        evtWin, elemWin);
    offsetY -= frameOffsetXAndY.last();

    return offsetY;
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getOffsetPoint',
function() {

    /**
     * @method getOffsetPoint
     * @summary Returns the X/Y TP.gui.Point of the signal relative to the
     *     containing source element.
     * @returns {TP.gui.Point} The X/Y point of the signal relative to its
     *     containing element.
     */

    var evt,
        point;

    evt = this.getEvent();

    if (TP.notValid(point = evt.$$offsetPt)) {
        point = TP.pc(this.getOffsetX(), this.getOffsetY());
        evt.$$offsetPt = point;
    }

    return point;
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getOffsetPointAdjustedFor',
function(anElement) {

    /**
     * @method getOffsetPointAdjustedFor
     * @summary Returns the X/Y TP.gui.Point of the signal relative to the
     *     the containing source element, but adjusted to the supplied element.
     *     If the supplied element is in a different window than the signal's
     *     source element, the return value is adjusted to take into account the
     *     difference between the two.
     * @returns {Element} anElement The element whose window will be compared to
     *     the signal's source window for offset computation purposes (if
     *     they're different).
     * @returns {TP.gui.Point} The X/Y point of the signal relative to its
     *     containing element, but adjusted to any offset in the windows between
     *     where the signal occurred and the window of the supplied element (if
     *     they're different).
     */

    var point;

    point = TP.pc(this.getOffsetXAdjustedFor(anElement),
                    this.getOffsetYAdjustedFor(anElement));

    return point;
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getPageX',
function() {

    /**
     * @method getPageX
     * @summary Returns the X coordinate of the signal relative to the page
     *     containing the source element.
     * @returns {Number} The X coordinate of the signal relative to the overall
     *     page.
     */

    var evt;

    evt = this.getEvent();

    return TP.ifInvalid(evt.$$pageX, evt.pageX);
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getPageXAdjustedFor',
function(anElement) {

    /**
     * @method getPageXAdjustedFor
     * @summary Returns the X coordinate of the signal relative to the page
     *     containing the source element, but adjusted to the supplied element.
     *     If the supplied element is in a different window than the signal's
     *     source element, the return value is adjusted to take into account the
     *     difference between the two.
     * @returns {Element} anElement The element whose window will be compared to
     *     the signal's source window for offset computation purposes (if
     *     they're different).
     * @returns {Number} The X coordinate of the signal relative to the overall
     *     page, but adjusted to any offset in the windows between where the
     *     signal occurred and the window of the supplied element (if they're
     *     different).
     */

    var pageX,

        elemWin,
        evtWin,

        frameOffsetXAndY;

    pageX = this.getPageX();

    elemWin = TP.nodeGetWindow(anElement);
    evtWin = TP.eventGetWindow(this.getEvent());
    if (elemWin === evtWin) {
        return pageX;
    }

    frameOffsetXAndY = TP.core.Mouse.computeWindowOffsetsBetween(
                                                        evtWin, elemWin);
    pageX -= frameOffsetXAndY.first();

    return pageX;
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getPageY',
function() {

    /**
     * @method getPageY
     * @summary Returns the Y coordinate of the signal relative to the page
     *     containing the source element.
     * @returns {Number} The Y coordinate of the signal relative to the overall
     *     page.
     */

    var evt;

    evt = this.getEvent();

    return TP.ifInvalid(evt.$$pageY, evt.pageY);
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getPageYAdjustedFor',
function(anElement) {

    /**
     * @method getPageYAdjustedFor
     * @summary Returns the Y coordinate of the signal relative to the page
     *     containing the source element, but adjusted to the supplied element.
     *     If the supplied element is in a different window than the signal's
     *     source element, the return value is adjusted to take into account the
     *     difference between the two.
     * @returns {Element} anElement The element whose window will be compared to
     *     the signal's source window for offset computation purposes (if
     *     they're different).
     * @returns {Number} The Y coordinate of the signal relative to the overall
     *     page, but adjusted to any offset in the windows between where the
     *     signal occurred and the window of the supplied element (if they're
     *     different).
     */

    var pageY,

        elemWin,
        evtWin,

        frameOffsetXAndY;

    pageY = this.getPageY();

    elemWin = TP.nodeGetWindow(anElement);
    evtWin = TP.eventGetWindow(this.getEvent());
    if (elemWin === evtWin) {
        return pageY;
    }

    frameOffsetXAndY = TP.core.Mouse.computeWindowOffsetsBetween(
                                                        evtWin, elemWin);
    pageY -= frameOffsetXAndY.last();

    return pageY;
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getPagePoint',
function() {

    /**
     * @method getPagePoint
     * @summary Returns the X/Y TP.gui.Point of the signal relative to the
     *     page containing the source element.
     * @returns {TP.gui.Point} The X/Y point of the signal relative to its
     *     overall page.
     */

    var evt,
        point;

    evt = this.getEvent();

    if (TP.notValid(point = evt.$$pagePt)) {
        point = TP.pc(this.getPageX(), this.getPageY());
        evt.$$pagePt = point;
    }

    return point;
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getPagePointAdjustedFor',
function(anElement) {

    /**
     * @method getPagePointAdjustedFor
     * @summary Returns the X/Y TP.gui.Point of the signal relative to the
     *     page containing the source element, but adjusted to the supplied
     *     element. If the supplied element is in a different window than the
     *     signal's source element, the return value is adjusted to take into
     *     account the difference between the two.
     * @returns {Element} anElement The element whose window will be compared to
     *     the signal's source window for offset computation purposes (if
     *     they're different).
     * @returns {TP.gui.Point} The X/Y point of the signal relative to its
     *     overall page, but adjusted to any offset in the windows between where
     *     the signal occurred and the window of the supplied element (if
     *     they're different).
     */

    var point;

    point = TP.pc(this.getPageXAdjustedFor(anElement),
                    this.getPageYAdjustedFor(anElement));

    return point;
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getScreenX',
function() {

    /**
     * @method getScreenX
     * @summary Returns the X coordinate of the signal relative to the video
     *     screen.
     * @returns {Number} The X coordinate of the signal relative to the video
     *     screen.
     */

    var evt;

    evt = this.getEvent();

    return TP.ifInvalid(evt.$$screenX, evt.screenX);
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getScreenY',
function() {

    /**
     * @method getScreenY
     * @summary Returns the Y coordinate of the signal relative to the video
     *     screen.
     * @returns {Number} The Y coordinate of the signal relative to the video
     *     screen.
     */

    var evt;

    evt = this.getEvent();

    return TP.ifInvalid(evt.$$screenY, evt.screenY);
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getScreenPoint',
function() {

    /**
     * @method getScreenPoint
     * @summary Returns the X/Y TP.gui.Point of the signal relative to the
     *     video screen
     * @returns {TP.gui.Point} The X/Y point of the signal relative to its
     *     video screen.
     */

    var evt,
        point;

    evt = this.getEvent();

    if (TP.notValid(point = evt.$$screenPt)) {
        point = TP.pc(this.getScreenX(), this.getScreenY());
        evt.$$screenPt = point;
    }

    return point;
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseSignal.Inst.defineMethod('getTransformedPoint',
function() {

    /**
     * @method getTransformedPoint
     * @summary Returns the X/Y TP.gui.Point of the signal relative to the
     *     target element while taking into account any CSS transformations to
     *     that element.
     * @returns {TP.gui.Point} The X/Y point of the signal relative to its
     *     target element, including any CSS transformations.
     */

    var evt,
        point;

    evt = this.getEvent();

    if (TP.notValid(point = evt.$$transPt)) {
        point = TP.pc(TP.elementGlobalToLocalXY(TP.eventGetTarget(evt),
                                                 evt.pageX,
                                                 evt.pageY));
        evt.$$transPt = point;
    }

    return point;
});

//  ------------------------------------------------------------------------
//  COMMON SUBTYPES
//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.sig.DOMMouseDown
//  ========================================================================

TP.sig.DOMMouseSignal.defineSubtype('DOMMouseDown');
TP.sig.DOMMouseDown.Type.defineConstant('NATIVE_NAME', 'mousedown');

//  ========================================================================
//  TP.sig.DOMMouseEnter
//  ========================================================================

TP.sig.DOMMouseSignal.defineSubtype('DOMMouseEnter');
TP.sig.DOMMouseEnter.Type.defineConstant('NATIVE_NAME', 'mouseenter');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.DOMMouseEnter.Inst.defineMethod('getRelatedTarget',
function() {

    /**
     * @method getRelatedTarget
     * @summary Returns the related target, the element the mouse is over now,
     *     having just left the current event's target.
     * @returns {Element} The element the mouse is now over.
     */

    return TP.eventGetRelatedTarget(this.getEvent());
});

//  ========================================================================
//  TP.sig.DOMMouseLeave
//  ========================================================================

TP.sig.DOMMouseSignal.defineSubtype('DOMMouseLeave');
TP.sig.DOMMouseLeave.Type.defineConstant('NATIVE_NAME', 'mouseleave');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.DOMMouseLeave.Inst.defineMethod('getRelatedTarget',
function() {

    /**
     * @method getRelatedTarget
     * @summary Returns the related target, the element the mouse is over now,
     *     having just left the current event's target.
     * @returns {Element} The element the mouse is now over.
     */

    return TP.eventGetRelatedTarget(this.getEvent());
});

//  ---

TP.sig.DOMMouseSignal.defineSubtype('DOMMouseUp');
TP.sig.DOMMouseUp.Type.defineConstant('NATIVE_NAME', 'mouseup');

//  ---

TP.sig.DOMMouseSignal.defineSubtype('DOMClick');
TP.sig.DOMClick.Type.defineConstant('NATIVE_NAME', 'click');

//  ---

TP.sig.DOMMouseSignal.defineSubtype('DOMDblClick');
TP.sig.DOMDblClick.Type.defineConstant('NATIVE_NAME', 'dblclick');

//  ---

TP.sig.DOMMouseSignal.defineSubtype('DOMContextMenu');
TP.sig.DOMContextMenu.Type.defineConstant('NATIVE_NAME', 'contextmenu');

//  ---

TP.sig.DOMMouseSignal.defineSubtype('DOMMouseMove');
TP.sig.DOMMouseMove.Type.defineConstant('NATIVE_NAME', 'mousemove');

//  ========================================================================
//  TP.sig.DOMMouseOut
//  ========================================================================

TP.sig.DOMMouseSignal.defineSubtype('DOMMouseOut');
TP.sig.DOMMouseOut.Type.defineConstant('NATIVE_NAME', 'mouseout');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.DOMMouseOut.Inst.defineMethod('getRelatedTarget',
function() {

    /**
     * @method getRelatedTarget
     * @summary Returns the related target, the element the mouse is over now,
     *     having just left the current event's target.
     * @returns {Element} The element the mouse is now over.
     */

    return TP.eventGetRelatedTarget(this.getEvent());
});

//  ========================================================================
//  TP.sig.DOMMouseOver
//  ========================================================================

TP.sig.DOMMouseSignal.defineSubtype('DOMMouseOver');
TP.sig.DOMMouseOver.Type.defineConstant('NATIVE_NAME', 'mouseover');

//  ------------------------------------------------------------------------

TP.sig.DOMMouseOver.Inst.defineMethod('getRelatedTarget',
function() {

    /**
     * @method getRelatedTarget
     * @summary Returns the related target, the element the mouse was just over
     *     prior to the current event.
     * @returns {Element} The element the mouse was over.
     */

    return TP.eventGetRelatedTarget(this.getEvent());
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseOver.Inst.defineMethod('shouldPrevent',
function(aFlag) {

    /**
     * @method shouldPrevent
     * @summary Returns true if the signal handler(s) should not perform the
     *     default action. If a flag is provided this flag is used to set the
     *     prevent status.
     * @param {Boolean} aFlag yes or no?
     * @returns {Boolean}
     */

    var retValue,
        evt;

    retValue = this.callNextMethod();

    if (TP.isEvent(evt = this.getEvent())) {
        if (TP.isTrue(aFlag)) {
            //  The hook file patches all native events to support this
            //  call.
            evt.preventDefault();
        }
    }

    return retValue;
});

//  ========================================================================
//  TP.sig.DOMMouseWheel
//  ========================================================================

TP.sig.DOMMouseSignal.defineSubtype('DOMMouseWheel');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

if (TP.sys.isUA('GECKO')) {
    TP.sig.DOMMouseWheel.Type.defineConstant('NATIVE_NAME', 'DOMMouseScroll');
}

if (TP.sys.isUA('WEBKIT')) {
    TP.sig.DOMMouseWheel.Type.defineConstant('NATIVE_NAME', 'mousewheel');
}

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.sig.DOMMouseWheel.Type.defineMethod('shouldLog',
function() {

    /**
     * @method shouldLog
     * @summary Returns true when the signal can be logged during signal
     *     processing. At this level, this method returns false.
     * @returns {Boolean}
     */

    return false;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.DOMMouseWheel.Inst.defineMethod('getDirection',
function() {

    /**
     * @method getDirection
     * @summary Returns the mouse wheel direction as either TP.UP or TP.DOWN
     *     depending on the specific delta direction.
     * @returns {TP.UP|TP.DOWN}
     */

    /* eslint-disable no-extra-parens */
    return (this.getWheelDelta() > 0) ? TP.UP : TP.DOWN;
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.sig.DOMMouseWheel.Inst.defineMethod('getWheelDelta',
function() {

    /**
     * @method getWheelDelta
     * @summary Returns the mouse wheel delta value from a mouse wheel event.
     * @returns {Number} The delta. Positive is down, negative is up.
     */

    return TP.eventGetWheelDelta(this.getEvent());
});

//  ========================================================================
//  TP.sig.DOMMouseHover
//  ========================================================================

TP.sig.DOMMouseSignal.defineSubtype('DOMMouseHover');

//  ------------------------------------------------------------------------

TP.sig.DOMMouseHover.Inst.defineMethod('setEvent',
function(normalizedEvent) {

    /**
     * @method setEvent
     * @summary Sets the 'native event' of the signal.
     * @param {Event} normalizedEvent The native event containing the signal's
     *     raw data.
     * @returns {TP.sig.DOMMouseHover} The receiver.
     */

    //  Call to supertype to set the event.
    this.callNextMethod();

    //  Make sure normalizedEvent is real - sometimes it's a null.
    if (TP.isEvent(normalizedEvent)) {
        //  This is fake, but needed because TP.sig.DOMMouseHover signals reuse
        //  mouse move signals.
        normalizedEvent.$$type = 'mousehover';
    }

    return this;
});

//  ========================================================================
//  DOM KEY SIGNALS
//  ========================================================================

TP.sig.DOMUISignal.defineSubtype('DOMKeySignal');

TP.sig.DOMKeySignal.shouldUseSingleton(false);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.sig.DOMKeySignal.Type.defineMethod('getSignalOwner',
function() {

    /**
     * @method getSignalOwner
     * @summary Returns the Object or Type responsible for signals of this
     *     type.
     * @returns {Object|TP.lang.RootObject} The signal type's owner.
     */

    return TP.sys.getTypeByName('TP.core.Keyboard');
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.DOMKeySignal.Inst.defineMethod('computeSignalName',
function() {

    /**
     * @method computeSignalName
     * @summary Computes the signal name. For key signals, the 'default' signal
     *     name is 'TP.sig.' followed by whatever the TP.core.Keyboard type
     *     reports as the 'DOM signal name' for the event that this signal
     *     represents. This would be something like
     *     'TP.sig.DOM_Shift_Enter_Up'.
     * @returns {String} The signal name of the receiver.
     */

    //  NOTE that we return the signal name here based on information in the
    //  key event. This means that all signals of this type are 'spoofed'
    //  signals (i.e. their signal name might be something like
    //  'TP.sig.DOM_Shift_Enter_Up' while their signal *type* name - in that
    //  case - would be 'TP.sig.DOMKeyUp')
    return 'TP.sig.' + TP.core.Keyboard.getDOMSignalName(this.getEvent());
});

//  ------------------------------------------------------------------------

TP.sig.DOMKeySignal.Inst.defineMethod('getKeyName',
function() {

    /**
     * @method getKeyName
     * @summary Returns the 'key name' for the receiver.
     * @description This is a name (e.g. 'DOM_Shift_Enter_up') based on a
     *     computation involving the underlying Event object's charCode,
     *     keyCode, modifier key states all matched with entries in the
     *     currently active keyboard map.
     * @returns {String} The key name of the receiver.
     */

    return TP.core.Keyboard.getDOMSignalName(this.getEvent());
});

//  ------------------------------------------------------------------------

TP.sig.DOMKeySignal.Inst.defineMethod('getKeyCode',
function() {

    /**
     * @method getKeyCode
     * @summary Returns the code of the key that was pressed to generate this
     *     key signal.
     * @returns {Number} The key code of the key that was pressed.
     */

    return TP.eventGetKeyCode(this.getEvent());
});

//  ------------------------------------------------------------------------

TP.sig.DOMKeySignal.Inst.defineMethod('getSignalNames',
function() {

    /**
     * @method getSignalNames
     * @summary Returns the 'signal names' to use when dispatching signals of
     *     this type.
     * @description TP.sig.DOMKeySignals have a bit of complexity when providing
     *     their signal names. First, there is the 'virtual key' signal name
     *     (i.e. 'TP.sig.DOM_b_Up', which is the default value. Next, there is
     *     (sometimes) a 'Unicode literal' signal name (i.e.
     *     'TP.sig.DOM_U0062_Up'). Last, there is hierarchy of real type names
     *     of this signal (i.e. 'TP.sig.DOMKeyUp' and higher).
     * @returns {String[]} An Array of signal names.
     */

    var sigNames,
        unicodeSigName;

    sigNames = this.callNextMethod();

    //  If we can compute a Unicode signal name, we splice it in just after the
    //  signal name (i.e. the specific, spoofed signal name that contains the
    //  exact key in its name) and the signal type name.
    if (TP.notEmpty(unicodeSigName = this.getUnicodeSignalName())) {
        sigNames = TP.copy(sigNames);
        sigNames.splice(1, 0, unicodeSigName);
    }

    return sigNames;
});

//  ------------------------------------------------------------------------

TP.sig.DOMKeySignal.Inst.defineMethod('getUnicodeSignalName',
function() {

    /**
     * @method getUnicodeSignalName
     * @summary Returns the 'Unicode literal' signal name of the receiver.
     *     This would be something like 'TP.sig.DOM_U0062_Up'.
     * @returns {String} The 'Unicode literal' signal name of the receiver.
     */

    var evt,
        keyname,
        signame;

    evt = this.getEvent();

    //  If keyname is empty, it must be a key that doesn't have a corresponding
    //  Unicode value (i.e. an arrow key). Return the empty String.
    if (TP.isEmpty(keyname = TP.eventGetUnicodeCharCode(evt))) {
        return '';
    }

    //  Otherwise, compute the signal name by adding whatever modifiers and
    //  'action' (down, press or up) to the key name. Note how we pass in the
    //  value of whether the Shift key was down separately here for better
    //  control (sometimes we want to spoof).
    signame = 'TP.sig.DOM_' + TP.core.Keyboard.computeFullSignalName(
                                        evt,
                                        keyname,
                                        TP.eventGetShiftKey(evt));

    return signame;
});

//  ------------------------------------------------------------------------

TP.sig.DOMKeySignal.Inst.defineMethod('getVirtualKeyName',
function() {

    /**
     * @method getVirtualKeyName
     * @summary Returns the normalized virtual key name for the receiver's
     *     event.
     * @description For example, a TP.sig.DOMKeySignal with a keyCode of 13 will
     *     produce the identifier 'Enter'.
     * @returns {String} The virtual key name, such as 'Enter'.
     */

    return TP.core.Keyboard.getVirtualKeyName(this.getEvent());
});

//  ------------------------------------------------------------------------
//  COMMON SUBTYPES
//  ------------------------------------------------------------------------

TP.sig.DOMKeySignal.defineSubtype('DOMKeyDown');
TP.sig.DOMKeyDown.Type.defineConstant('NATIVE_NAME', 'keydown');

//  ---

TP.sig.DOMKeySignal.defineSubtype('DOMKeyPress');
TP.sig.DOMKeyPress.Type.defineConstant('NATIVE_NAME', 'keypress');

//  ---

TP.sig.DOMKeySignal.defineSubtype('DOMKeyUp');
TP.sig.DOMKeyUp.Type.defineConstant('NATIVE_NAME', 'keyup');

//  ---

//  ========================================================================
//  TP.sig.DOMModifierKeyChange
//  ========================================================================

TP.sig.DOMKeySignal.defineSubtype('DOMModifierKeyChange');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.DOMModifierKeyChange.Inst.defineMethod('getSignalNames',
function() {

    /**
     * @method getSignalNames
     * @summary Returns the 'signal names' to use when dispatching signals of
     *     this type.
     * @description Normally, DOMKeySignals return an Array of signal names that
     *     include both their signal name (which will correspond to a particular
     *     key) and the hierarchy of type names. But we want
     *     DOMKeyModifierChange signals to only return their type name so that
     *     observers have to observe this type name directly. If observers want
     *     to observe things like the Shift key going up, they should observe
     *     'DOM_Shift_Up', etc. which will be sent directly as a result of the
     *     Shift key going up, not as a manufactured event like this one.
     * @returns {String[]} An Array of signal names.
     */

    return TP.ac(this.getTypeName());
});

//  ------------------------------------------------------------------------

TP.sig.DOMModifierKeyChange.Inst.defineMethod('setEvent',
function(normalizedEvent) {

    /**
     * @method setEvent
     * @summary Sets the native event which this signal instance represents.
     * @param {Event} normalizedEvent The native event containing the signal's
     *     raw data.
     * @returns {TP.sig.DOMModifierKeyChange} The receiver.
     */

    //  NOTE that we don't callNextMethod here specifically to avoid having
    //  the signal name adjusted to match the specifics of the key event.

    this.setPayload(normalizedEvent);

    return this;
});

//  ========================================================================
//  DOM DRAG SIGNALS
//  ========================================================================

TP.sig.DOMMouseDown.defineSubtype('DOMDragDown');
TP.sig.DOMMouseMove.defineSubtype('DOMDragMove');
TP.sig.DOMMouseUp.defineSubtype('DOMDragUp');

TP.sig.DOMMouseOver.defineSubtype('DOMDragOver');
TP.sig.DOMMouseOut.defineSubtype('DOMDragOut');

TP.sig.DOMMouseHover.defineSubtype('DOMDragHover');

//  ========================================================================
//  DOM DND SIGNALS
//  ========================================================================

TP.sig.DOMSignal.defineSubtype('DOMDNDSignal');

TP.sig.DOMDNDSignal.defineSubtype('DOMDNDInitiate');
TP.sig.DOMDNDSignal.defineSubtype('DOMDNDTerminate');

TP.sig.DOMDNDSignal.defineSubtype('DOMDNDWillVend');
TP.sig.DOMDNDSignal.defineSubtype('DOMDNDWillAccept');

TP.sig.DOMDNDSignal.defineSubtype('DOMDNDCancelled');

TP.sig.DOMDNDSignal.defineSubtype('DOMDNDCompleted');
TP.sig.DOMDNDSignal.defineSubtype('DOMDNDFailed');
TP.sig.DOMDNDSignal.defineSubtype('DOMDNDSucceeded');

TP.sig.DOMDNDSignal.defineSubtype('DOMDNDTargetSignal');

TP.sig.DOMDNDTargetSignal.defineSubtype('DOMDNDTargetOver');
TP.sig.DOMDNDTargetSignal.defineSubtype('DOMDNDTargetOut');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.DOMDNDTargetSignal.Inst.defineMethod('getDOMTarget',
function() {

    /**
     * @method getDOMTarget
     * @summary Returns the DOM target of the receiver. If the receiver was
     *     triggered because of a DOM signal, this method will return the *DOM*
     *     target of the signal.
     * @description DND targeting signals, such as TP.sig.DOMDNDTargetOver and
     *     TP.sig.DOMDNDTargetOut capture the event that caused them to trigger.
     *     This can be very useful when wanting to refine the target.
     * @returns {TP.dom.UIElementNode} The DOM target of the receiver.
     */

    var evt,
        domSignal;

    //  Responder signals are *not* DOM signals, but if they've been triggered
    //  because of a DOM signal, they should have the low-level event in their
    //  payload.
    if (TP.isEvent(evt = this.at('event'))) {

        //  Wrap the event into a TIBET DOM signal of some type.
        domSignal = TP.wrap(evt);

        return domSignal.getTarget();
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.sig.DOMDNDTargetSignal.Inst.defineMethod('getResolvedDOMTarget',
function() {

    /**
     * @method getResolvedDOMTarget
     * @summary Returns the *resolved* DOM target of the receiver. If the
     *     receiver was triggered because of a DOM signal, this method will
     *     return the *resolved* *DOM* target of the signal. See DOM signals for
     *     more information on the difference between targets and resolved
     *     targets.
     * @description When triggered via a DOM signal, Responder signals set their
     *     target to their origin so that responder chain semantics work
     *     properly. This method allows access to the original *resolved* *DOM*
     *     target of the signal.
     * @returns {TP.dom.UIElementNode} The resolved DOM target of the receiver.
     */

    var evt,
        domSignal;

    //  Responder signals are *not* DOM signals, but if they've been triggered
    //  because of a DOM signal, they should have the low-level event in their
    //  payload.
    if (TP.isEvent(evt = this.at('event'))) {

        //  Wrap the event into a TIBET DOM signal of some type.
        domSignal = TP.wrap(evt);

        return domSignal.getResolvedTarget();
    }

    return null;
});

//  ========================================================================
//  GEOLOCATION SIGNALS
//  ========================================================================

TP.sig.Signal.defineSubtype('GeoLocationChange');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.sig.GeoLocationChange.Type.defineMethod('getSignalOwner',
function() {

    /**
     * @method getSignalOwner
     * @summary Returns the Object or Type responsible for signals of this
     *     type.
     * @returns {Object|TP.lang.RootObject} The signal type's owner.
     */

    return TP.sys.getTypeByName('TP.core.Window');
});

//  ------------------------------------------------------------------------

//  ========================================================================
//  CSS MEDIA SIGNALS
//  ========================================================================

TP.sig.Signal.defineSubtype('CSSMediaChange');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.sig.CSSMediaChange.Type.defineMethod('getSignalOwner',
function() {

    /**
     * @method getSignalOwner
     * @summary Returns the Object or Type responsible for signals of this
     *     type.
     * @returns {Object|TP.lang.RootObject} The signal type's owner.
     */

    return TP.sys.getTypeByName('TP.core.Window');
});

//  ------------------------------------------------------------------------

TP.sig.CSSMediaChange.defineSubtype('CSSMediaActive');
TP.sig.CSSMediaChange.defineSubtype('CSSMediaInactive');

//  ========================================================================
//  TP.sig.WARNING SIGNALS
//  ========================================================================

TP.sig.WARN.defineSubtype('Deprecated');
TP.sig.WARN.defineSubtype('DoesNotUnderstand');
TP.sig.WARN.defineSubtype('TODO');
TP.sig.WARN.defineSubtype('UnsupportedFeature');

//  ========================================================================
//  TP.sig.ERROR SIGNALS
//  ========================================================================

TP.sig.ERROR.defineSubtype('MissingOverride');

TP.sig.ERROR.defineSubtype('InvalidAccessMode');
TP.sig.ERROR.defineSubtype('InvalidCollection');
TP.sig.ERROR.defineSubtype('InvalidConstraint');
TP.sig.ERROR.defineSubtype('InvalidContext');
TP.sig.ERROR.defineSubtype('InvalidDescriptor');
TP.sig.ERROR.defineSubtype('InvalidDirectory');
TP.sig.ERROR.defineSubtype('InvalidHandlerName');
TP.sig.ERROR.defineSubtype('InvalidFrame');
TP.sig.ERROR.defineSubtype('InvalidFunction');
TP.sig.ERROR.defineSubtype('InvalidModel');
TP.sig.ERROR.defineSubtype('InvalidNumber');
TP.sig.ERROR.defineSubtype('InvalidOperation');
TP.sig.ERROR.defineSubtype('InvalidOrigin');
TP.sig.ERROR.defineSubtype('InvalidParameter');
TP.sig.ERROR.defineSubtype('InvalidQuery');
TP.sig.ERROR.defineSubtype('InvalidRequest');
TP.sig.ERROR.defineSubtype('InvalidSignal');
TP.sig.ERROR.defineSubtype('InvalidValue');
TP.sig.ERROR.defineSubtype('InvalidName');
TP.sig.ERROR.defineSubtype('InvalidURI');
TP.sig.ERROR.defineSubtype('InvalidWindow');
TP.sig.ERROR.defineSubtype('InvalidXML');

TP.sig.ERROR.defineSubtype('AccessViolation');
TP.sig.ERROR.defineSubtype('MutabilityViolation');
TP.sig.ERROR.defineSubtype('PrivilegeViolation');

TP.sig.ERROR.defineSubtype('MarshallingException');

//  ------------------------------------------------------------------------
//  INHERITANCE SIGNALS/EXCEPTIONS
//  ------------------------------------------------------------------------

TP.sig.ERROR.defineSubtype('InheritanceException');

TP.sig.InheritanceException.defineSubtype('TypeNotFound');

TP.sig.InheritanceException.defineSubtype('InvalidType');
TP.sig.InheritanceException.defineSubtype('InvalidInstantiation');
TP.sig.InheritanceException.defineSubtype('InvalidOwnerRequest');
TP.sig.InheritanceException.defineSubtype('InvalidTrackRequest');
TP.sig.InheritanceException.defineSubtype('InvalidFunctionTrack');

TP.sig.InheritanceException.defineSubtype('NoOwner');
TP.sig.InheritanceException.defineSubtype('NoConcreteType');
TP.sig.InheritanceException.defineSubtype('NoMetaInformation');
TP.sig.InheritanceException.defineSubtype('NoNextTypeMethod');
TP.sig.InheritanceException.defineSubtype('NoNextInstMethod');
TP.sig.InheritanceException.defineSubtype('NoNextTypeLocalMethod');
TP.sig.InheritanceException.defineSubtype('NoNextInstLocalMethod');
TP.sig.InheritanceException.defineSubtype('NoNextGlobalMethod');

//  ------------------------------------------------------------------------
//  COLLECTION SIGNALS/EXCEPTIONS
//  ------------------------------------------------------------------------

TP.sig.ERROR.defineSubtype('CollectionException');

TP.sig.CollectionException.defineSubtype('InvalidArrayOperation');
TP.sig.CollectionException.defineSubtype('InvalidHashOperation');
TP.sig.CollectionException.defineSubtype('InvalidStringOperation');

TP.sig.CollectionException.defineSubtype('InvalidCollectionRequest');

TP.sig.InvalidCollectionRequest.defineSubtype('InvalidKeyRequest');
TP.sig.InvalidCollectionRequest.defineSubtype('InvalidItemRequest');
TP.sig.InvalidCollectionRequest.defineSubtype('InvalidPairRequest');
TP.sig.InvalidCollectionRequest.defineSubtype('InvalidValueRequest');

TP.sig.CollectionException.defineSubtype('IndexException');

TP.sig.IndexException.defineSubtype('InvalidIndex');
TP.sig.IndexException.defineSubtype('NotFound');

TP.sig.CollectionException.defineSubtype('ItemException');

TP.sig.ItemException.defineSubtype('InvalidItem');
TP.sig.ItemException.defineSubtype('InvalidPair');

TP.sig.CollectionException.defineSubtype('KeyException');

TP.sig.KeyException.defineSubtype('InvalidKey');
TP.sig.KeyException.defineSubtype('DuplicateKey');

//  ------------------------------------------------------------------------
//  INVOCATION SIGNALS/EXCEPTIONS
//  ------------------------------------------------------------------------

TP.sig.Signal.defineSubtype('InvocationSignal');

TP.sig.InvocationSignal.defineSubtype('InvokeComplete');

TP.sig.ERROR.defineSubtype('InvokeFailed');

//  ------------------------------------------------------------------------
//  IO EXCEPTIONS
//  ------------------------------------------------------------------------

TP.sig.ERROR.defineSubtype('IOException');

TP.sig.IOException.defineSubtype('ConnectionFailed');

TP.sig.IOException.defineSubtype('URIException');

TP.sig.URIException.defineSubtype('URINotFound');
TP.sig.URIException.defineSubtype('URIComponentException');

//  ------------------------------------------------------------------------
//  RESOURCE SIGNALS/EXCEPTIONS
//  ------------------------------------------------------------------------

TP.sig.ERROR.defineSubtype('ResourceException');

TP.sig.ERROR.defineSubtype('TemplateTokenizationFailed');
TP.sig.ERROR.defineSubtype('TemplateCompilationFailed');
TP.sig.ERROR.defineSubtype('TransformFailed');

//  ------------------------------------------------------------------------
//  SERVICE SIGNALS/EXCEPTIONS
//  ------------------------------------------------------------------------

TP.sig.Exception.defineSubtype('ServiceException');

TP.sig.ServiceException.defineSubtype('ServiceUnavailable');
TP.sig.ServiceException.defineSubtype('RequestNotFound');

//  ------------------------------------------------------------------------
//  RENDERING SIGNALS/EXCEPTIONS
//  ------------------------------------------------------------------------

TP.sig.Signal.defineSubtype('DidRender');
TP.sig.DidRender.Type.defineAttribute('defaultPolicy', TP.INHERITANCE_FIRING);
TP.sig.DidRender.defineSubtype('DidRenderData');

//  ------------------------------------------------------------------------
//  VALIDATION SIGNALS/EXCEPTIONS
//  ------------------------------------------------------------------------

TP.sig.Signal.defineSubtype('InputNull');

//  ------------------------------------------------------------------------
//  XSLT SIGNALS/EXCEPTIONS
//  ------------------------------------------------------------------------

TP.sig.ERROR.defineSubtype('XSLTException');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETSourceTypes.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ========================================================================
//  Signal Sources
//  ========================================================================

/*
TP.core.SignalSource is the core signaling type from which all other signal
sources derive. Signal sources are objects that throw off signals; devices like
mice and keyboards and remote sources like server-sent event servers.
*/

TP.lang.Object.defineSubtype('core.SignalSource');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.SignalSource.Type.defineMethod('addObserver',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method addObserver
     * @summary Invoked by observe() to add an observation or activate
     *     underlying signaling hooks necessary to ensure proper signaling.
     * @param {Object|Object[]} anOrigin One or more origins to observe.
     * @param {Object|Object[]} aSignal One or more signals to observe from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn on observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to add the observation, false otherwise.
     */

    TP.override();
});

//  ------------------------------------------------------------------------

TP.core.SignalSource.Type.defineMethod('removeObserver',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method removeObserver
     * @summary Invoked by ignore() to remove an observation or deactivate
     *     underlying signaling hooks necessary to ensure proper signaling.
     * @param {Object|Object[]} anOrigin One or more origins to ignore.
     * @param {Object|Object[]} aSignal One or more signals to ignore from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn off observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to remove the observation, false otherwise.
     */

    TP.override();
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.core.SignalSource.Inst.defineAttribute('observers');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.SignalSource.Inst.defineMethod('addObserver',
function(aSignal, aHandler, aPolicy) {

    /**
     * @method addObserver
     * @summary Adds a local signal observation which is roughly like a DOM
     *     element adding an event listener.
     * @param {Object|Object[]} aSignal One or more signals to observe from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn on observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to add the observation, false otherwise.
     */

    TP.override();
});

//  ------------------------------------------------------------------------

TP.core.SignalSource.Inst.defineMethod('hasObservers',
function() {

    /**
     * @method hasObservers
     * @summary Returns whether or not the receiver has observers.
     * @returns {Boolean} Whether or not the receiver has observers.
     */

    var observers;

    observers = this.$get('observers');

    return !TP.isEmpty(observers);
});

//  ------------------------------------------------------------------------

TP.core.SignalSource.Inst.defineMethod('removeObserver',
function(aSignal, aHandler, aPolicy) {

    /**
     * @method removeObserver
     * @summary Removes a local signal observation which is roughly like a DOM
     *     element adding an event listener.
     * @param {Object|Object[]} aSignal One or more signals to ignore from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn off observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to remove the observation, false otherwise.
     */

    TP.override();
});

//  ========================================================================
//  TP.core.URISignalSource
//  ========================================================================

/*
 * TP.core.URISignalSource is a set of traits for various signal source subtypes
 * which use a URI to define their endpoint (SSE, socket, etc.).
 */

TP.core.SignalSource.defineSubtype('URISignalSource');

//  This is intended for use as a set of traits, not a concrete type.
TP.core.URISignalSource.isAbstract(true);

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.core.URISignalSource.Inst.defineAttribute('uri');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.URISignalSource.Inst.defineMethod('setURI',
function(aURI) {

    /**
     * @method setURI
     * @summary Defines the endpoint URI for the receiver.
     * @param {TP.uri.URI} aURI The URI representing the signal endpoint.
     * @exception TP.sig.InvalidURI
     * @returns {TP.core.SignalSource} A new instance.
     */

    var uri;

    //  Not a valid URI? We can't initialize properly then...
    if (!TP.isURI(uri = TP.uc(aURI))) {
        return this.raise('TP.sig.InvalidURI');
    }

    this.set('uri', uri);

    return this;
});

//  ========================================================================
//  TP.core.MessageSource
//  ========================================================================

/*
TP.core.MessageSource provides a common supertype for objects with an onmessage
interface. Examples include web sockets and server-sent events.
*/

TP.core.SignalSource.defineSubtype('MessageSource');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  The list of standard handler names that instances of this type will
//  automatically add listeners for.
TP.core.MessageSource.Type.defineAttribute(
    '$standardEventHandlerNames', TP.ac('open', 'close', 'error', 'message'));

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.core.MessageSource.Inst.defineAttribute('active', false);

//  The private TP.core.Hash containing a map of custom event names to the
//  handlers that were installed for each one so that we can unregister them.
TP.core.MessageSource.Inst.defineAttribute('$customEventHandlers');

TP.core.MessageSource.Inst.defineAttribute('errorCount', 0);

TP.core.MessageSource.Inst.defineAttribute('source');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.MessageSource.Inst.defineMethod('init',
function() {

    /**
     * @method init
     * @summary Initialize a new signal instance.
     * @returns {TP.core.MessageSource} A new instance.
     */

    this.callNextMethod();

    this.set('$customEventHandlers', TP.hc());

    //  Push ourself as a controller onto the application's controller stack.
    //  This will allow us to receive the TP.sig.AppShutdown signal below.
    TP.sys.getApplication().pushController(this);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.MessageSource.Inst.defineMethod('activate',
function() {

    /**
     * @method activate
     * @summary Activates observation of the message source. In most cases
     *     this will be a variation on adding a listener to a native source.
     * @returns {Boolean} Whether or not the activation was successful.
     */

    //  The receiver is now active.
    this.isActive(true);

    return true;
});

//  ------------------------------------------------------------------------

TP.core.MessageSource.Inst.defineMethod('addObserver',
function(aSignal, aHandler, aPolicy) {

    /**
     * @method addObserver
     * @summary Invoked by observe() to add an observation or activate
     *     underlying signaling hooks necessary to ensure proper signaling.
     * @param {Object|Object[]} aSignal One or more signals to observe from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn on observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to add the observation, false otherwise.
     */

    var sigTypes;

    if (TP.notValid(aSignal)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  If we're not already active try to activate now. If that fails
    //  we'll skip any attempt to register...we can't get to the endpoint.
    if (TP.notValid(this.get('source')) || !this.isActive()) {
        if (!this.activate()) {
            TP.warn('Unable to activate message source. Ignoring observation.');
            return false;
        }
    }

    //  Signal can be singular or an array of them. Normalize to an array.
    if (!TP.isArray(sigTypes = aSignal)) {
        sigTypes = TP.ac(aSignal);
    }

    //  Process the signal array into an array of all signal types that are
    //  being requested including their subtypes for inheritance firing.
    sigTypes = sigTypes.collect(
                function(aSignalType) {
                    var sigType,
                        subs;

                    //  Convert any signal names to the actual type objects.
                    sigType = TP.isType(aSignalType) ?
                        aSignalType :
                        TP.sys.getTypeByName(aSignalType);

                    //  To support "inheritance firing" we need any subtypes.
                    if (TP.notValid(subs = sigType.getSubtypes())) {
                        return sigType;
                    }

                    return TP.ac(sigType, subs);
                });

    sigTypes = sigTypes.flatten();

    //  Configure any custom event handlers necessary for the signals given.
    this.setupCustomHandlers(sigTypes);

    //  Tell the notification to register our handler, etc.
    return true;
});

//  ------------------------------------------------------------------------

TP.core.MessageSource.Inst.defineMethod('deactivate',
function(closed) {

    /**
     * @method deactivate
     * @summary Deactivates observation of the message source.
     * @param {Boolean} [closed=false] True to tell deactivate any remote
     *     connection that the receiver is managing is already closed so skip
     *     any internal close call.
     * @returns {Boolean} Whether or not the connection closed successfully.
     */

    var source;

    if (!this.isActive()) {
        return true;
    }

    //  The receiver is now inactive.
    this.isActive(false);

    source = this.get('source');
    if (TP.notValid(source)) {
        //  NOTE we don't raise here since this is often called during shutdown
        //  and we don't want to report on errors we can't do anything about.
        return false;
    }

    if (TP.notTrue(closed)) {
        try {
            source.close();
        } catch (e) {
            void 0;
        }
    }

    this.signal('TP.sig.SourceClosed', TP.hc('source', source));

    this.set('source', null);

    //  Empty whatever remaining custom handlers that weren't unregistered (we
    //  don't have to worry about removing them as event listeners from the
    //  event source object since we're disposing of it).
    this.get('$customEventHandlers').empty();

    return true;
});

//  ------------------------------------------------------------------------

TP.core.MessageSource.Inst.defineMethod('isActive',
function(aFlag) {

    /**
     * @method isActive
     * @summary A source is active if activate() has been called and no
     *     corresponding deactivate() call has been made.
     * @param {Boolean} [aFlag] If present, sets the state rather than gets it.
     * @returns {Boolean} Whether or not the source is open.
     */

    if (TP.isValid(aFlag)) {
        this.$set('active', aFlag);
    }

    return TP.isTrue(this.$get('active'));
});

//  ------------------------------------------------------------------------

TP.core.MessageSource.Inst.defineMethod('removeObserver',
function(aSignal, aHandler, aPolicy) {

    /**
     * @method removeObserver
     * @summary Removes a local signal observation which is roughly like a DOM
     *     element adding an event listener. The observer is typically the
     *     handler provided to an observe call while the signal is a signal or
     *     string which the receiver is likely to signal or is intercepting for
     *     centralized processing purposes.
     * @param {Object|Object[]} aSignal One or more signals to ignore from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn off observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to remove the observation, false otherwise.
     */

    var sigTypes;

    if (TP.notValid(aSignal)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    if (!this.hasObservers()) {
        return true;
    }

    //  Signal can be a single instance or array. Normalize to array.
    if (!TP.isArray(sigTypes = aSignal)) {
        sigTypes = TP.ac(aSignal);
    }

    //  Convert any string-based signals/instances into signal types including
    //  any subtypes to support inheritance-style observe/ignore semantics.
    sigTypes = sigTypes.collect(
                function(aSignalType) {
                    var sigType,
                        subs;

                    //  Grab the real type object if it wasn't supplied.
                    sigType = TP.isType(aSignalType) ?
                        aSignalType :
                        TP.sys.getTypeByName(aSignalType);

                    if (TP.notValid(subs = sigType.getSubtypes())) {
                        return sigType;
                    }

                    return TP.ac(sigType, subs);
                });
    sigTypes = sigTypes.flatten();

    //  Remove any custom handlers we installed for proper signaling.
    this.teardownCustomHandlers(sigTypes);

    if (!this.hasObservers()) {
        this.deactivate();
    }

    //  Always tell the notification system to remove our handler, etc.
    //  presuming this was invoked indirectly via ignore().
    return true;
});

//  ------------------------------------------------------------------------

TP.core.MessageSource.Inst.defineMethod('setupCustomHandlers',
function(signalTypes) {

    /**
     * @method setupCustomHandlers
     * @summary Configures handlers for custom messages coming from a remote
     *     connection.
     * @param {TP.sig.SourceSignal[]} signalTypes An Array of
     *     TP.sig.SourceSignal subtypes to check for custom handler
     *     registration.
     * @returns {TP.core.MessageSource} The receiver.
     */

    TP.override();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.MessageSource.Inst.defineMethod('setupStandardHandlers',
function() {

    /**
     * @method setupStandardHandlers
     * @summary Sets up the 'standard' handlers for messages coming from a
     *     remote connection.
     * @exception TP.sig.InvalidSource
     * @returns {TP.core.MessageSource} The receiver.
     */

    var source,
        thisref;

    source = this.get('source');

    if (TP.notValid(source)) {
        this.raise('TP.sig.InvalidSource');
        return this;
    }

    thisref = this;

    //  Connect our local 'on*' methods to their related native listeners.
    this.getType().get('$standardEventHandlerNames').forEach(
        function(op) {
            if (TP.canInvoke(thisref, 'on' + op)) {
                //  Replace method with bound version to support removal.
                thisref['on' + op] = thisref['on' + op].bind(thisref);
                source.addEventListener(op, thisref['on' + op], false);
            }
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.core.MessageSource.Inst.defineMethod('teardownCustomHandlers',
function(signalTypes) {

    /**
     * @method teardownCustomHandlers
     * @summary Tears down the 'standard' handlers for messages coming from a
     *     remote connection.
     * @param {TP.sig.SourceSignal[]} signalTypes An Array of
     *     TP.sig.SourceSignal subtypes to check for custom handler
     *     registration.
     * @returns {TP.core.MessageSource} The receiver.
     */

    TP.override();
});

//  ------------------------------------------------------------------------

TP.core.MessageSource.Inst.defineMethod('teardownStandardHandlers',
function(signalTypes) {

    /**
     * @method teardownStandardHandlers
     * @summary Tears down the 'standard' handlers for messages coming from a
     *     remote connection.
     * @returns {TP.core.MessageSource} The receiver.
     */

    var source,
        thisref;

    source = this.get('source');
    if (TP.notValid(source)) {
        this.raise('TP.sig.InvalidSource');
        return this;
    }

    thisref = this;

    //  Disconnect our local 'on*' methods from their related native listeners.
    this.getType().get('$standardEventHandlerNames').forEach(
        function(op) {
            if (TP.canInvoke(thisref, 'on' + op)) {
                source.removeEventListener(op, thisref['on' + op]);
            }
        });

    return this;
});

//  ------------------------------------------------------------------------
//  Instance Handlers
//  ------------------------------------------------------------------------

TP.core.MessageSource.Inst.defineHandler('AppShutdown',
function(aSignal) {

    /**
     * @method handleAppShutdown
     * @summary Handles when the app is about to be shut down. Used to
     *     deactivate the signal source to avoid leaving open connections.
     * @param {TP.sig.AppShutdown} aSignal The signal indicating that the
     *     application is to be shut down.
     * @returns {TP.core.MessageSource} The receiver.
     */

    this.deactivate();

    return this;
});

//  ========================================================================
//  TP.core.MessageConnection
//  ========================================================================

/*
TP.core.MessageSource provides a common supertype for objects with an onmessage
interface. Examples include worker threads, server sent events, etc.
*/

TP.core.MessageSource.defineSubtype('MessageConnection');

TP.core.MessageConnection.isAbstract(true);

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.MessageConnection.Inst.defineMethod('send',
function(message) {

    /**
     * @method send
     * @summary Sends text to the remote end of the connection for connections
     *     which support it. Connections which are server-to-client only throw
     *     an UnsupportedOperation exception.
     * @param {String|Object} message The message to send. If the message is
     *     not a String it it serialized via the receivers implementation of
     *     serializeMessage.
     */

    return this.sendMessage(this.serializeMessage(message));
});

//  ------------------------------------------------------------------------

TP.core.MessageConnection.Inst.defineMethod('sendMessage',
function(message) {

    /**
     * @method sendMessage
     * @summary Sends a string to the remote end of the connection. This method
     *     does not serialize content. Use send() if you want serialization.
     * @param {String} message The string to send to the end of the connection.
     */

    TP.override();
});

//  ------------------------------------------------------------------------

TP.core.MessageConnection.Inst.defineMethod('serializeMessage',
function(message) {

    /**
     * @method serializeMessage
     * @summary Serializes a message object to produce a representation that can
     *     be sent as a message. If the message object implements an 'asMessage'
     *     method that method is invoked, otherwise the default representation
     *     is returned as one that the message channel can understand.
     * @param {Object} message The object to serialize.
     * @returns {Object} The supplied message serialized.
     */

    if (TP.isString(message)) {
        return message;
    }

    if (TP.canInvoke('asMessage')) {
        return message.asMessage();
    }

    //  The default for all message connections is a String of JSON.
    return JSON.stringify(message);
});

//  ========================================================================
//  TP.core.RemoteMessageSource
//  ========================================================================

TP.core.MessageSource.defineSubtype('RemoteMessageSource');

TP.core.RemoteMessageSource.addTraits(TP.core.URISignalSource);

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.core.RemoteMessageSource.Inst.defineAttribute('sourceParams');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.RemoteMessageSource.Inst.defineMethod('init',
function(aURI, sourceParams) {

    /**
     * @method init
     * @summary Initialize a new signal instance.
     * @param {TP.uri.URI} aURI The endpoint URI representing the remote
     *     messaging source.
     * @param {TP.core.Hash} [sourceParams] Optional parameters used by the
     *     receiver to configure the message source.
     * @returns {TP.core.RemoteMessageSource} A new instance.
     */

    this.callNextMethod();

    //  Invoke mixed-in setter to capture the URI value.
    this.setURI(aURI);

    //  Grab any parameters that the caller wants us to use to configure the
    //  remote source.
    this.set('sourceParams', sourceParams);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.RemoteMessageSource.Inst.defineMethod('activate',
function() {

    /**
     * @method activate
     * @summary Opens the connection to a remote messaging source.
     * @exception TP.sig.InvalidURI
     * @exception TP.sig.InvalidSource
     * @exception TP.sig.InvalidSourceType
     * @returns {Boolean} Whether or not the connection opened successfully.
     */

    var source,
        sourceType;

    //  If we're active and have a real source object nothing to do.
    if (this.isActive() && TP.isValid(this.get('source'))) {
        return true;
    }

    //  Reset any error count so we can reactivate without issues.
    this.set('errorCount', 0);

    sourceType = this.getSourceType();

    //  NB: We use a TP.notValid check here because the type we get back from
    //  getSourceType is (or should be) a native platform constructor.
    if (TP.notValid(sourceType)) {

        this.raise('InvalidSourceType');
        return false;
    }

    try {
        source = this.constructSource();
    } catch (e) {
        this.raise('TP.sig.InvalidSource', e);
        return false;
    }

    //  Couldn't construct an instance of our source type? Raise an exception
    //  and exit here.
    if (TP.notValid(source)) {

        this.raise('TP.sig.InvalidSource');
        return false;
    }

    this.set('source', source);
    this.setupStandardHandlers();

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.core.RemoteMessageSource.Inst.defineMethod('constructSource',
function() {

    /**
     * @method constructSource
     * @summary Constructs an instance of the underlying system-level object
     *     that is going to be sending and receiving remote messages.
     * @returns {Object} The system object that will send and receive messages.
     */

    var srcType,
        uriStr,
        options;

    srcType = this.getSourceType();

    uriStr = this.get('uri').asString();

    //  Make sure that, one or another, we end up with POJO.
    options = this.get('sourceParams');
    if (TP.isValid(options)) {
        options = options.asObject();
    } else {
        options = {};
    }

    //  NB: We use old-style JS syntax here because the type we get back from
    //  getSourceType is (or should be) a native platform constructor.
    return new srcType(uriStr, options);
});

//  ------------------------------------------------------------------------

TP.core.RemoteMessageSource.Inst.defineMethod('getSourceType',
function() {

    /**
     * @method getSourceType
     * @summary The JavaScript constructor of the underlying system-level object
     *     that is going to be sending and receiving remote messages.
     * @returns {Function} The constructor of the system object that will send
     *     and receive messages.
     */

    TP.override();
});

//  ------------------------------------------------------------------------

TP.core.RemoteMessageSource.Inst.defineMethod('deactivate',
function(closed) {

    /**
     * @method deactivate
     * @summary Deactivates observation of the message source.
     * @param {Boolean} [closed=false] True to tell deactivate any remote
     *     connection that the receiver is managing is already closed so skip
     *     any internal close call.
     * @returns {Boolean} Whether or not the connection closed successfully.
     */

    var source;

    if (TP.notTrue(closed)) {
        source = this.get('source');
        if (TP.isValid(source)) {
            source.close();
        }
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.core.RemoteMessageSource.Inst.defineMethod('onopen',
function(evt) {

    /**
     * @method onopen
     * @summary The method that is invoked when the remote messaging source that
     *     the receiver is managing has opened a connection to its remote
     *     server.
     * @param {MessageEvent} evt The event sent by the underlying system.
     * @returns {TP.core.RemoteMessageSource} The receiver.
     */

    var source,
        payload;

    source = this.get('source');

    payload = TP.hc(
        'source', source,
        'sourceURL', this.get('uri')
    );

    this.signal('TP.sig.SourceOpen', payload);

    return this;
});

//  ========================================================================
//  TP.core.SSEMessageSource
//  ========================================================================

TP.core.RemoteMessageSource.defineSubtype('SSEMessageSource');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  The list of standard handler names that instances of this type will
//  automatically add listeners for. We override this from our supertype to
//  remove 'message' from the list. We handle 'onmessage' events differently at
//  this type level.
TP.core.SSEMessageSource.Type.defineAttribute(
    '$standardEventHandlerNames', TP.ac('open', 'close', 'error'));

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.SSEMessageSource.Type.defineMethod('isSupported',
function() {

    /**
     * @method isSupported
     * @summary Whether or not events from this source can be sent.
     * @returns {Boolean} Whether or not events can be sent.
     */

    return TP.isValid(TP.global.EventSource);
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.SSEMessageSource.Inst.defineMethod('getSourceType',
function() {

    /**
     * @method getSourceType
     * @summary The JavaScript constructor of the Server-Sent Events system
     *     object.
     * @returns {EventSource} The constructor of the Server-Sent Events system
     *     object.
     */

    return TP.global.EventSource;
});

//  ------------------------------------------------------------------------

TP.core.SSEMessageSource.Inst.defineMethod('onerror',
function(evt) {

    /**
     * @method onerror
     * @summary The default method that is invoked when the server-sent events
     *     system that the receiver is managing has generated an error.
     * @param {ErrorEvent} evt The event sent by the underlying system.
     * @returns {TP.sig.SSEMessageSource} The receiver.
     */

    var payload,
        errorCount,
        source;

    errorCount = this.get('errorCount');
    source = this.get('source');

    //  Too many errors.
    if (errorCount > TP.sys.cfg('sse.max_errors')) {
        this.raise('TP.sig.UnstableConnection');
        this.deactivate();
        return this;
    }

    this.set('errorCount', errorCount++);

    //  If the readyState is set to EventSource.CLOSED, then the browser is
    //  'failing the connection'. In this case, we signal a
    //  'TP.sig.SourceClosed' and return.
    if (source.readyState === EventSource.CLOSED) {
        this.deactivate();
        return this;
    }

    //  If the readyState is set to EventSource.CONNECTING, then the browser is
    //  trying to 'reestablish the connection'. In this case, we signal a
    //  'TP.sig.SourceReconnecting' and return.
    if (source.readyState === EventSource.CONNECTING) {
        this.signal('TP.sig.SourceReconnecting', payload);
        return this;
    }

    //  Otherwise, there was truly some sort of error, so we signal
    //  'TP.sig.SourceError' with some information
    payload = TP.hc(
        'sourceURL', source.url,
        'withCredentials', source.withCredentials,
        'readyState', source.readyState
    );

    this.signal('TP.sig.SourceError', payload);

    this.deactivate();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.SSEMessageSource.Inst.defineMethod('onmessage',
function(evt) {

    /**
     * @method onmessage
     * @summary The default method that is invoked when the server-sent events
     *     system that the receiver is managing has received data and has posted
     *     a message back into this content containing that data.
     * @param {MessageEvent} evt The event sent by the underlying system.
     * @returns {TP.sig.SSEMessageSource} The receiver.
     */

    var source,
        data,
        payload,
        signalName;

    source = this.get('source');

    try {
        data = TP.json2js(evt.data);
    } catch (e) {
        data = evt.data;
    }

    payload = TP.hc(
                'origin', evt.origin,
                'data', data,
                'lastEventId', evt.lastEventId,
                'sourceURL', source.url
                );

    //  If a signalName was placed onto the event by the caller, then use it.
    signalName = evt.signalName || 'TP.sig.SourceDataReceived';

    this.signal(signalName, payload);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.SSEMessageSource.Inst.defineMethod('setupCustomHandlers',
function(signalTypes) {

    /**
     * @method setupCustomHandlers
     * @summary Sets up handlers for 'custom' server-side events.
     * @description The Server-Sent Events specification does not specify that
     *     the 'onmessage' handler will fire when there is a custom 'event' (as
     *     specified by the 'event:' tag in the received data). We check the
     *     signal types being observed for a REMOTE_NAME which allows it to
     *     adapt to server event names which should map to that signal type and
     *     register a low-level handler accordingly.
     * @param {TP.sig.SourceSignal[]} signalTypes An Array of
     *     TP.sig.SourceSignal subtypes to check for custom handler
     *     registration.
     * @exception TP.sig.InvalidSource
     * @returns {TP.core.RemoteMessageSource} The receiver.
     */

    var source,
        thisref,
        handlerRegistry;

    if (TP.notValid(source = this.get('source'))) {
        this.raise('TP.sig.InvalidSource');
        return this;
    }

    //  A map that we need to keep up-to-date for handler unregistration
    handlerRegistry = this.get('$customEventHandlers');

    thisref = this;

    signalTypes.perform(
            function(aSignalType) {
                var eventName,
                    signalName,
                    handlerFunc;

                signalName = aSignalType.getSignalName();

                //  Get the eventName from the signal type. This might be null
                //  or undefined, which means that we'll take a different path
                //  below.
                eventName = aSignalType.REMOTE_NAME;

                //  If there's already a handler registered for this native
                //  event type then just return here. We don't want multiple
                //  handlers for the same native event.
                if (handlerRegistry.hasKey(eventName)) {
                    return;
                }

                //  Look for a method to match the eventName to use as the
                //  handler.
                if (TP.canInvoke(thisref, 'on' + eventName)) {
                    handlerFunc = thisref['on' + eventName].bind(thisref);
                } else {
                    //  No special handler so rely on a wrapped copy of
                    //  onmessage that we pass the specific signal name to.
                    handlerFunc = function(evt) {
                        evt.signalName = signalName;
                        this.onmessage(evt);
                    }.bind(thisref);

                    //  We need to default the eventName to 'message' here, so
                    //  that if one wasn't supplied, the addEventListener below
                    //  will work.
                    eventName = TP.ifInvalid(eventName, 'message');
                }

                //  Put it in the handler registry in case we went to
                //  unregister it interactively later.
                handlerRegistry.atPut(eventName, handlerFunc);

                //  Add the custom event listener to the event source.
                source.addEventListener(eventName, handlerFunc, false);
            });

    return this;
});

//  ------------------------------------------------------------------------

TP.core.SSEMessageSource.Inst.defineMethod('teardownCustomHandlers',
function(signalTypes) {

    /**
     * @method teardownCustomHandlers
     * @summary Tears down handlers for 'custom' server-side events.
     * @description Because the Server-Sent Events specification does not
     *     specify that the general 'message' handler will fire when there is a
     *     custom 'event' (as specified by the 'event:' tag in the received
     *     data), we look at the signals being registered and if they have a
     *     'REMOTE_NAME' slot, we use that to unregister a handler with our
     *     private source object.
     * @param {TP.sig.SourceSignal[]} signalTypes An Array of
     *     TP.sig.SourceSignal subtypes to check for custom handler
     *     registration.
     * @returns {TP.core.RemoteMessageSource} The receiver.
     */

    var source,
        handlerRegistry;

    if (TP.notValid(source = this.get('source'))) {
        //  NOTE we don't raise here since this is often called during shutdown
        //  and we don't want to report on errors we can't do anything about.
        return this;
    }

    //  A map that we have kept up-to-date for handler unregistration
    handlerRegistry = this.get('$customEventHandlers');

    //  Loop over the signal types (or their names) and see if they need a
    //  custom handler registered for them.
    signalTypes.perform(
        function(aSignalType) {
            var customName,

                handlerFunc;

            customName = TP.ifInvalid(aSignalType.REMOTE_NAME, 'message');

            //  If there is a callable function registered in the handler
            //  registry under the custom event name, remove it.
            if (TP.isCallable(handlerFunc =
                                handlerRegistry.atPut(customName))) {

                handlerRegistry.removeKey(customName);
                source.removeEventListener(customName, handlerFunc, false);
            }
        });

    return this;
});

//  ========================================================================
//  TP.core.Socket
//  ========================================================================

TP.core.RemoteMessageSource.defineSubtype('Socket');

//  Mix in send capability.
TP.core.Socket.addTraits(TP.core.MessageConnection);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.core.Socket.defineConstant('DEFAULT_PROTOCOLS', TP.ac());

TP.core.Socket.defineConstant('STATES', {
    CONNECTING: 0,
    OPEN: 1,
    CLOSING: 2,
    CLOSED: 3
});

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.Socket.Type.defineMethod('isSupported',
function() {

    /**
     * @method isSupported
     * @summary Whether or not events from this source can be sent.
     * @returns {Boolean} Whether or not events can be sent.
     */

    return TP.isValid(TP.global.WebSocket);
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.core.Socket.Inst.defineAttribute('protocols');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.Socket.Inst.defineMethod('init',
function(aURI, protocols) {

    /**
     * @method init
     * @summary Initialize a new signal instance.
     * @param {TP.uri.URI} aURI The endpoint URI representing the WebSocket
     *     messaging source.
     * @param {String[]} protocols An Array of custom WebSocket protocols that
     *     the connection should be configured for.
     * @returns {TP.core.Socket} A new instance.
     */

    this.callNextMethod();

    if (TP.isValid(protocols)) {
        this.$set('protocols', protocols);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Socket.Inst.defineMethod('constructSource',
function() {

    /**
     * @method constructSource
     * @summary Constructs an instance of the underlying system-level object
     *     that is going to be sending and receiving remote messages.
     * @returns {Object} The system object that will send and receive messages.
     */

    var type,
        uri,
        protocols;

    type = this.getSourceType();

    uri = this.get('uri').asString();

    protocols = this.getProtocols();

    if (TP.notEmpty(protocols)) {
        return new type(uri, protocols);
    } else {
        return new type(uri);
    }
});

//  ------------------------------------------------------------------------

TP.core.Socket.Inst.defineMethod('getProtocols',
function() {

    /**
     * @method getProtocols
     * @summary The custom protocols that the receiver's WebSocket connection
     *     should be configured for.
     * @returns {String[]} An Array of custom WebSocket protocols that the
     *     connection is configured for.
     */

    var list;

    list = this.$get('protocols');

    return TP.isValid(list) ? list : this.getType().get('DEFAULT_PROTOCOLS');
});

//  ------------------------------------------------------------------------

TP.core.Socket.Inst.defineMethod('getSourceType',
function() {

    /**
     * @method getSourceType
     * @summary The JavaScript constructor of the WebSockets system object.
     * @returns {WebSocket} The constructor of the WebSockets system object.
     */

    return TP.global.WebSocket;
});

//  ------------------------------------------------------------------------

TP.core.Socket.Inst.defineMethod('isClosed',
function() {

    /**
     * @method isClosed
     * @summary Whether or not the underlying WebSocket connection is closed.
     * @returns {Boolean} Whether or not the underlying WebSocket connection
     *     is closed.
     */

    var source;

    source = this.$get('source');
    if (TP.notValid(source)) {
        return true;
    }

    return source.readyState === TP.core.Socket.STATES.CLOSED ||
            source.readyState === TP.core.Socket.STATES.CLOSING;
});

//  ------------------------------------------------------------------------

TP.core.Socket.Inst.defineMethod('onclose',
function(evt) {

    /**
     * @method onclose
     * @summary The method that is invoked when the web socket that the receiver
     *     is managing has closed.
     * @param {CloseEvent} evt The event sent by the underlying system.
     * @returns {TP.core.Socket} The receiver.
     */

    var source,
        payload;

    source = this.get('source');

    //  Repackage WebSocket data into a hash to use as the payload for the
    //  SourceClosed signal.
    payload = TP.hc(
                'code', evt.code,
                'reason', evt.reason,
                'sourceURL', source.url
                );

    this.signal('TP.sig.SourceClosed', payload);

    //  Deactivate but force it to skip any close() operation that might trigger
    //  a recursion.
    this.deactivate(true);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Socket.Inst.defineMethod('onerror',
function(evt) {

    /**
     * @method onerror
     * @summary The method that is invoked when the web socket that the receiver
     *     is managing has encountered an error.
     * @param {ErrorEvent} evt The event sent by the underlying system.
     * @returns {TP.core.Socket} The receiver.
     */

    TP.error(evt);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Socket.Inst.defineMethod('onmessage',
function(evt) {

    /**
     * @method onmessage
     * @summary The method that is invoked when the web socket that the receiver
     *     is managing has data ready to be processed.
     * @param {MessageEvent} evt The event sent by the underlying system.
     * @returns {TP.core.Socket} The receiver.
     */

    TP.info(evt.data);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Socket.Inst.defineMethod('sendMessage',
function(message) {

    /**
     * @method sendMessage
     * @summary Sends a string to the remote end of the connection. This method
     *     does not serialize content. Use send() if you want serialization.
     * @param {String} message The string to send to the end of the connection.
     * @returns TP.core.Socket The receiver.
     */

    var source;

    source = this.get('source');

    source.send(message);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Socket.Inst.defineMethod('setupCustomHandlers',
function(signalTypes) {

    /**
     * @method setupCustomHandlers
     * @summary Configures handlers for custom events from the server. This
     *     method normally does nothing for a Socket. You can use it to support
     *     custom protocols as you require.
     * @param {TP.sig.SourceSignal[]} signalTypes An Array of
     *     TP.sig.SourceSignal subtypes to check for custom handler
     *     registration.
     * @returns {TP.core.Socket} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Socket.Inst.defineMethod('teardownCustomHandlers',
function(signalTypes) {

    /**
     * @method teardownCustomHandlers
     * @summary Tears down handlers for custom events from the server. This
     *     method normally does nothing for a Socket. You can use it to support
     *     custom protocols as you require.
     * @param {TP.sig.SourceSignal[]} signalTypes An Array of
     *     TP.sig.SourceSignal subtypes to check for custom handler
     *     registration.
     * @returns {TP.core.Socket} The receiver.
     */

    return this;
});

//  ========================================================================
//  TP.sig.GeolocationSignal
//  ========================================================================

TP.sig.Signal.defineSubtype('GeolocationSignal');
TP.sig.GeolocationSignal.defineSubtype('GeolocationChange');
TP.sig.GeolocationSignal.defineSubtype('GeolocationError');

//  ========================================================================
//  TP.core.Geolocation
//  ========================================================================

TP.core.MessageSource.defineSubtype('Geolocation');

/**
 * Dictionary of window GID to geo watch objects. Used to capture registrations
 * so we can removeObserver correctly by clearing the watch on the window.
 */
TP.core.Geolocation.Type.defineAttribute('$watches', TP.hc());

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.Geolocation.Type.defineMethod('addObserver',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method addObserver
     * @summary Invoked by observe() to add an observation or activate
     *     underlying signaling hooks necessary to ensure proper signaling.
     * @param {Object|Object[]} anOrigin One or more origins to observe.
     * @param {Object|Object[]} aSignal One or more signals to observe from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn on observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to add the observation, false otherwise.
     */

    var map,
        origin,
        originID,
        geoWatch;

    if (TP.notValid(window.geolocation)) {
        return this.raise('UnsupportedOperation');
    }

    map = this.get('$watches');

    if (TP.notValid(anOrigin) || TP.notValid(aSignal)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    if (TP.isWindow(anOrigin)) {
        origin = anOrigin;
    } else if (TP.isString(anOrigin)) {
        origin = TP.getWindowById(anOrigin);
        if (TP.notValid(origin)) {
            return this.raise('TP.sig.InvalidOrigin');
        }
    } else {
        return this.raise('TP.sig.InvalidOrigin');
    }

    originID = TP.gid(origin);

    if (TP.isValid(origin.navigator.geolocation)) {

        //  Set up the 'watch' with a success callback that signals a
        //  GeolocationChange and an error callback that signals a
        //  GeolocationError
        geoWatch = origin.navigator.geolocation.watchPosition(
            function(position) {
                var coords,
                    data;

                coords = position.coords;

                //  Break up the returned data into a well structured
                //  hash data structure.
                data = TP.hc(
                        'latitude', coords.latitude,
                        'longitude', coords.longitude,
                        'altitude', coords.altitude,
                        'accuracy', coords.accuracy,
                        'altitudeAccuracy', coords.altitudeAccuracy,
                        'heading', coords.heading,
                        'speed', coords.speed,
                        'timestamp', position.timestamp
                        );

                TP.signal(origin, 'TP.sig.GeolocationChange', data);
            },
            function(error) {
                var errorMsg;

                errorMsg = '';

                //  Check for known errors
                switch (error.code) {

                    case error.PERMISSION_DENIED:
                        errorMsg = TP.sc('This website does not have ',
                                            'permission to use ',
                                            'the Geolocation API');
                        break;

                    case error.POSITION_UNAVAILABLE:
                        errorMsg = TP.sc('The current position could ',
                                            'not be determined.');
                        break;

                    case error.PERMISSION_DENIED_TIMEOUT:
                        errorMsg = TP.sc('The current position could ',
                                            'not be determined ',
                                            'within the specified ',
                                            'timeout period.');
                        break;

                    default:
                        break;
                }

                //  If it's an unknown error, build a errorMsg that
                //  includes information that helps identify the
                //  situation so that the error handler can be updated.
                if (errorMsg === '') {
                    errorMsg = TP.sc('The position could not be ',
                                        'determined due to an unknown ',
                                        'error (Code: ') +
                                        error.code.toString() +
                                        ').';
                }

                TP.signal(origin, 'TP.sig.GeolocationError', errorMsg);
            });

        map.atPut(originID, geoWatch);
    }

    //  Always tell the notification system to register our handler, etc.
    return true;
});

//  ------------------------------------------------------------------------

TP.core.Geolocation.Type.defineMethod('removeObserver',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method removeObserver
     * @summary Invoked by ignore() to remove an observation or deactivate
     *     underlying signaling hooks necessary to ensure proper signaling.
     * @param {Object|Object[]} anOrigin One or more origins to ignore.
     * @param {Object|Object[]} aSignal One or more signals to ignore from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn off observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to remove the observation, false otherwise.
     */

    var map,
        origin,
        originID,
        geoWatch;

    map = this.get('$watches');

    if (TP.isWindow(anOrigin)) {
        origin = anOrigin;
    } else if (TP.isString(anOrigin)) {
        origin = TP.getWindowById(anOrigin);
        if (TP.notValid(origin)) {
            return this.raise('TP.sig.InvalidOrigin');
        }
    } else {
        return this.raise('TP.sig.InvalidOrigin');
    }

    originID = TP.gid(origin);

    //  If our 'queries' map has an entry for the query, then it's a
    //  registration that we care about.
    if (TP.isValid(geoWatch = map.at(originID))) {
        if (TP.isValid(origin.navigator.geolocation)) {
            origin.navigator.geolocation.clearWatch(geoWatch);
        }

        map.removeKey(originID);
    }

    //  Always tell the notification system to remove our handler, etc.
    return true;
});

//  ========================================================================
//  TP.core.MediaQuery
//  ========================================================================

TP.core.MessageSource.defineSubtype('MediaQuery');

/**
 * The count of observers. Incremented via addObserver, decremented via
 * removeObserver. When decrementing if the count reaches 0 the observer hook is
 * removed.
 * @type {Number}
 */
TP.core.MediaQuery.Inst.defineAttribute('$count', 0);

/**
 * The hook function used to activate the observation.
 * @type {Function}
 */
TP.core.MediaQuery.Inst.defineAttribute('$hook');

/**
 * The query object returned from the native interface used to de-register.
 * @type {Object}
 */
TP.core.MediaQuery.Inst.defineAttribute('$mediaQuery');

/**
 * The media query string. Should start with '@media'.
 * @type {String}
 */
TP.core.MediaQuery.Inst.defineAttribute('$query');

/**
 * The target window. Defaults to UICANVAS.
 * @type {Window}
 */
TP.core.MediaQuery.Inst.defineAttribute('$window');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.MediaQuery.Inst.defineMethod('init',
function(query, win) {

    /**
     * @method init
     * @summary Initializes a new instance of the receiver.
     * @param {String} query The query to use when observing changes to the
     *     document associated with the supplied Window.
     * @param {Window} win The window that the supplied media query should
     *     execute in.
     * @returns {TP.core.MediaQuery} A new instance.
     */

    var source;

    if (TP.notValid(query)) {
        return this.raise('InvalidParameter');
    }

    if (!/@media /.test(query)) {
        return this.raise('InvalidParameter');
    }

    source = win;
    if (TP.notValid(source)) {
        source = TP.getUICanvas().getNativeWindow();
    }

    if (!TP.isWindow(source)) {
        return this.raise('InvalidWindow');
    }

    this.$set('$query', query);
    this.$set('$window', source);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.MediaQuery.Inst.defineMethod('addObserver',
function(aSignal, aHandler, aPolicy) {

    /**
     * @method addObserver
     * @summary Adds a local signal observation which is roughly like a DOM
     *     element adding an event listener.
     * @param {Object|Object[]} aSignal One or more signals to observe from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn on observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to add the observation, false otherwise.
     */

    var origin,
        query,
        count,
        handler,
        mediaQuery;

    //  Already activated? Just return true to tell notification system to keep
    //  processing the registration.
    if (TP.isValid(this.$get('$mediaQuery'))) {
        return true;
    }

    count = this.$get('$count');
    this.$set('count', count + 1);

    origin = this.$get('$window');
    query = this.$get('$query');

    //  Define a handler that will signal CSSMediaActive or CSSMediaInactive
    //  depending on whether the query matches or not.
    handler = function(aQuery) {
        if (aQuery.matches) {
            TP.signal(origin, 'TP.sig.CSSMediaActive', aQuery.media);
        } else {
            TP.signal(origin, 'TP.sig.CSSMediaInactive', aQuery.media);
        }
    };
    this.$set('$hook', handler);

    //  Perform the query and get the MediaQueryList back. Note that this will
    //  also register the handler so that the callback fires when the
    //  environment changes.
    mediaQuery = TP.windowQueryCSSMedia(origin, query, handler);
    this.$set('$mediaQuery', mediaQuery);

    //  Always tell the notification system to register our handler, etc.
    return true;
});

//  ------------------------------------------------------------------------

TP.core.MediaQuery.Inst.defineMethod('removeObserver',
function(aSignal, aHandler, aPolicy) {

    /**
     * @method removeObserver
     * @summary Removes a local signal observation which is roughly like a DOM
     *     element removing an event listener.
     * @param {Object|Object[]} aSignal One or more signals to ignore from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn off observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to remove the observation, false otherwise.
     */

    var count,
        hook,
        mediaQuery;

    count = this.$get('$count');
    if (count === 0) {
        return true;
    }

    this.$set('count', count - 1);
    if (count > 0) {
        return true;
    }

    mediaQuery = this.$get('$mediaQuery');
    if (TP.notValid(mediaQuery)) {
        return true;
    }

    hook = this.$get('$hook');
    if (TP.isMediaQueryList(mediaQuery)) {
        mediaQuery.removeListener(hook);
    }

    //  Always tell the notification system to remove our handler, etc.
    return true;
});

//  ========================================================================
//  TP.core.MutationSignalSource
//  ========================================================================

/*
*/

TP.core.SignalSource.defineSubtype('MutationSignalSource');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.core.MutationSignalSource.Type.defineAttribute('queries');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.MutationSignalSource.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    //  We capture this in the outer scope for one of the mutation filter
    //  functions below. In this way, we don't have to fetch it each time.
    var hasLama,
        lamaObj;

    hasLama = TP.sys.hasFeature('lama');

    this.set('queries', TP.hc());

    //  Add a managed Mutation Observer filter Function that will filter
    //  mutation records for:
    //
    //      - style attribute changes.

    TP.addMutationObserverFilter(
        function(aMutationRecord) {

            if (aMutationRecord.type === 'attributes') {

                switch (aMutationRecord.attributeName) {

                    case 'style':
                        return false;

                    default:
                        break;
                }
            }

            return true;
        },
        TP.ALL);

    //  Add a managed Mutation Observer filter Function that will filter
    //  mutation records for:
    //
    //      - generated nodes

    TP.addMutationObserverFilter(
        function(aMutationRecord) {

            var len,
                i,

                node;

            if (TP.notEmpty(aMutationRecord.addedNodes)) {

                len = aMutationRecord.addedNodes.length;
                for (i = 0; i < len; i++) {

                    node = aMutationRecord.addedNodes[i];

                    //  Nodes that are generated by TIBET, such as dragging
                    //  elements and resize trackers.
                    if (TP.isTrue(node[TP.GENERATED])) {
                        return false;
                    }
                }
            }

            if (TP.notEmpty(aMutationRecord.removedNodes)) {

                len = aMutationRecord.removedNodes.length;
                for (i = 0; i < len; i++) {

                    node = aMutationRecord.removedNodes[i];

                    //  Nodes that are generated by TIBET, such as dragging
                    //  elements and resize trackers.
                    if (TP.isTrue(node[TP.GENERATED])) {
                        return false;
                    }
                }
            }

            return true;
        },
        TP.ALL);

    //  Add a managed Mutation Observer filter Function that will filter
    //  mutation records for cases where the target itself or one of its
    //  ancestors has configured itself to not participate in mutation tracking.
    TP.addMutationObserverFilter(
        function(aMutationRecord) {

            var target,

                ans,
                val;

            target = aMutationRecord.target;

            //  If the target isn't an Element, we allow the mutation.
            if (!TP.isElement(target)) {
                return true;
            }

            //  See if the Lama is currently processing DOM mutations. If so,
            //  then that means that we should just return true here.
            if (hasLama) {
                if (TP.notValid(lamaObj)) {
                    lamaObj = TP.bySystemId('Lama');
                }

                if (TP.isValid(lamaObj) &&
                    lamaObj.get('shouldProcessDOMMutations')) {
                    return true;
                }
            }

            //  If the target has a 'tibet:no-mutations' attribute on it
            //  that has a value of 'ancestor or self' on it, then we return
            //  false, filtering it from the list.
            val = TP.elementGetAttribute(
                            target, 'tibet:no-mutations', true);
            if (val === TP.ANCESTOR_OR_SELF) {
                return false;
            }

            //  Search for an ancestor that has the 'tibet:no-mutations'
            //  attribute.
            ans = TP.nodeDetectAncestorMatchingCSS(
                            target,
                            '*[tibet|no-mutations]');

            //  If we found one, then check *it's* 'tibet:nomutation' value. If
            //  it's either 'true' or 'ancestor', then we return false,
            //  filtering *this* element from the list.
            if (TP.isElement(ans)) {

                val = TP.elementGetAttribute(
                            ans, 'tibet:no-mutations', true);

                if (val === 'true' || val === TP.ANCESTOR) {
                    return false;
                }
            }

            return true;
        },
        TP.ALL);

    return;
});

//  ------------------------------------------------------------------------

TP.core.MutationSignalSource.Type.defineMethod('watchDocument',
function(aDocument) {

    /**
     * @method watchDocument
     * @summary Sets up observations for mutation on the document provided.
     * @param {Document} aDocument The document to register a Mutation Observer
     *     on.
     * @exception TP.sig.InvalidNode
     * @returns {TP.meta.core.MutationSignalSource} The MutationSignalSource
     *     type.
     */

    var method,

        recordsHandler,
        observerConfig,

        mutationObserverID,

        styleChangesHandler;

    method = TP.composeHandlerName('MutationEvent');

    //  Install a managed MutationObserver that will monitor the document for
    //  changes, filter them down to a consistent set of records, and use the
    //  TIBET signaling system to send change.

    recordsHandler = function(mutationRecords) {

        var recordGroups;

        //  Group the mutation records by target, so that we're only calling the
        //  recordsHandler once per target. We can do this because we're only
        //  processing childList and subtree mutations and therefore only care
        //  about added/removed nodes (which we coalesce below), not attribute
        //  changes. If we cared about attribute changes, then we would have to
        //  call the method we computed above individually for each mutation
        //  record.
        recordGroups = mutationRecords.groupBy(
                            function(aRecord) {
                                //  Use the target's GID (and assign it if
                                //  necessary).
                                return TP.gid(aRecord.target, true);
                            });

        //  Iterate over the groups that were produced (i.e. groups of
        //  MutationRecords, grouped by the target).
        recordGroups.perform(
            function(kvPair) {

                var likeRecords,

                    len,
                    i,

                    likeRecord,

                    addedNodes,
                    removedNodes,

                    newRecord;

                //  NB: We don't care about the key here - it was just a way of
                //  uniquing based on the target node.
                likeRecords = kvPair.last();

                addedNodes = TP.ac();
                removedNodes = TP.ac();

                len = likeRecords.getSize();
                for (i = 0; i < len; i++) {

                    likeRecord = likeRecords.at(i);

                    addedNodes = addedNodes.concat(
                                    TP.ac(likeRecord.addedNodes));
                    removedNodes = removedNodes.concat(
                                    TP.ac(likeRecord.removedNodes));
                }

                newRecord = {};

                newRecord.target = likeRecords.at(0).target;
                newRecord.type = likeRecords.at(0).type;
                newRecord.addedNodes = addedNodes;
                newRecord.removedNodes = removedNodes;

                this[method](newRecord);

            }.bind(this));

    }.bind(this);

    //  Configure the underlying native Mutation Observer to be interested in
    //  DOM tree changes, but not DOM attribute changes.
    observerConfig = {
        childList: true,
        subtree: true,
        attributes: false,
        attributeOldValue: false
    };

    //  We will be installing this per-Document, so we need to unique it by the
    //  target Document's global ID.
    mutationObserverID = 'DOCUMENT_OBSERVER_' + TP.gid(aDocument);

    //  Add it as a managed Mutation Observer.
    TP.addMutationObserver(
            recordsHandler,
            observerConfig,
            mutationObserverID);

    //  Activate it.
    TP.activateMutationObserver(aDocument, mutationObserverID);

    //  Install a managed MutationObserver that will observe changes to style
    //  sheet elements (link, style, etc.) and will refresh the rules caches
    //  that elements keep to report which style rules apply to them.

    styleChangesHandler = function(mutationRecords) {

        var targets,

            len,
            i,
            record,

            target,

            targetTagName,

            styleType,
            fname;

        targets = TP.ac();

        len = mutationRecords.getSize();
        for (i = 0; i < len; i++) {

            record = mutationRecords.at(i);

            target = record.target;

            //  Switch depending on the type of mutation that occurred.
            switch (record.type) {

                //  If it was 'characterData', then we're only interested in
                //  XHTML 'style' elements because they're the only ones where
                //  character data can change.
                case 'characterData':

                    target = record.target.parentNode;
                    targetTagName = target.tagName.toLowerCase();

                    if (targetTagName === 'style') {
                        targets.push(target);
                    }

                    break;

                //  If it was 'attributes', then we're only interested in XHTML
                //  'link' elements and their 'href' attributes.
                case 'attributes':

                    targetTagName = target.tagName.toLowerCase();

                    if (targetTagName === 'link' &&
                        record.attributeName === 'href') {
                        targets.push(target);
                    }

                    break;

                default:
                    break;
            }
        }

        //  'targets' will be a list of 'style', 'link', etc. elements that have
        //  changed in some way. Refresh element caches from the stylesheets
        //  contained by these changed elements.
        if (TP.notEmpty(targets)) {

            targets.unique();

            len = targets.getSize();
            for (i = 0; i < len; i++) {

                target = targets.at(i);

                //  Refresh the rules cache for any elements that are affected
                //  by the stylesheet of the newly loaded style element.
                TP.$styleSheetRefreshAppliedRulesCaches(
                                        TP.cssElementGetStyleSheet(target));

                styleType = TP.wrap(target).getType();

                //  Allow the stylesheet to process the fact that it has been
                //  reloaded.
                fname = 'mutationUpdatedStyle';
                if (TP.canInvoke(styleType, fname)) {
                    styleType[fname](target, targets);
                }
            }
        }
    };

    observerConfig = {
        subtree: true,
        attributes: true,
        characterData: true
    };

    //  We will be installing this per-Document, so we need to unique it by the
    //  target Document's global ID.
    mutationObserverID = 'STYLE_CHANGES_OBSERVER_' + TP.gid(aDocument);

    TP.addMutationObserver(
            styleChangesHandler,
            observerConfig,
            mutationObserverID);

    //  Activate it.
    TP.activateMutationObserver(
        TP.documentEnsureHeadElement(aDocument),
        mutationObserverID);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.MutationSignalSource.Type.defineMethod('unwatchDocument',
function(aDocument) {

    /**
     * @method unwatchDocument
     * @summary Removes mutation observation for the document provided.
     * @param {Document} aDocument The document to remove a Mutation Observer
     *     from.
     * @exception TP.sig.InvalidNode
     * @returns {TP.meta.core.MutationSignalSource} The MutationSignalSource
     *     type.
     */

    TP.removeMutationObserver('DOCUMENT_OBSERVER_' + TP.gid(aDocument));
    TP.removeMutationObserver('STYLE_CHANGES_OBSERVER_' + TP.gid(aDocument));

    return this;
});

//  ------------------------------------------------------------------------

TP.core.MutationSignalSource.Type.defineHandler('MutationEvent',
function(aMutationRecord) {

    /**
     * @method handleMutationEvent
     * @summary Responds to notifications that a mutation has occurred.
     * @param {MutationRecord} aMutationRecord The incoming mutation record.
     * @exception TP.sig.InvalidNode
     * @returns {TP.meta.core.MutationSignalSource} The MutationSignalSource
     *     type.
     */

    var targetNode,

        processForLama,
        lamaObj,

        targetShouldTrack,

        targetType,

        mutationType,

        fname,

        attrName,

        prevValue,
        newValue,
        operation,

        args,

        addedNodes,
        removedNodes,

        queryEntries,

        queryContext,
        targetDoc,
        doc,
        queryKeys,
        len,
        i,
        entry;

    //  Make sure that the target is a Node
    if (!TP.isNode(targetNode = aMutationRecord.target)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  See if the Lama is currently processing DOM mutations. If so, then
    //  that will factor into whether or not we will ignore this event or not.
    processForLama = false;
    lamaObj = TP.bySystemId('Lama');
    if (TP.isValid(lamaObj) &&
        lamaObj.get('shouldProcessDOMMutations')) {
        processForLama = true;
    }

    //  If the target is an Element and it has a 'tibet:no-mutations'
    //  attribute on it that's either set to look at itself or at one of its
    //  ancestors or itself to determine whether or not it should process
    //  mutation signals, then process it.
    if (TP.isElement(targetNode)) {
        targetShouldTrack = TP.elementGetAttribute(
                targetNode, 'tibet:no-mutations', true);

        //  NB: Note how we also take processForLama into account here.
        if ((targetShouldTrack === 'true' ||
            targetShouldTrack === TP.ANCESTOR_OR_SELF) &&
            !processForLama) {
                return this;
            }
    }

    //  And make sure that we can computed a TIBET type for it.
    if (!TP.isType(targetType = TP.wrap(targetNode).getType())) {
        return this;
    }

    //  Make sure that the target is in a Window.
    doc = targetNode.ownerDocument;
    if (!TP.isDocument(doc)) {
        return this;
    }

    if (!TP.isWindow(doc.defaultView)) {
        return this;
    }

    //  Switch on the type of mutation that cause this to trigger.
    mutationType = aMutationRecord.type;

    switch (mutationType) {
        case 'attributes':

            //  We can only process attribute changes for Elements - make sure
            //  the target is one.
            if (!TP.isElement(targetNode)) {
                return this.raise('TP.sig.InvalidElement');
            }

            //  If we can invoke 'mutationChangedAttribute' on the TIBET type
            //  that we computed above, then go ahead and do so.
            fname = 'mutationChangedAttribute';
            if (TP.canInvoke(targetType, fname)) {
                attrName = aMutationRecord.attributeName;

                //  We configured this MutationObserver to capture old attribute
                //  values above, so grab it along with the new value here.
                prevValue = aMutationRecord.oldValue;
                newValue = TP.elementGetAttribute(targetNode, attrName, true);

                //  If there was no previous value, but there is a new value,
                //  then the attribute was created.
                if (TP.notValid(prevValue) &&
                    TP.elementHasAttribute(targetNode, attrName, true)) {
                    operation = TP.CREATE;
                } else if (!TP.elementHasAttribute(targetNode, attrName, true)) {
                    //  Otherwise, if the target Element no longer has the
                    //  attribute, then the attribute was deleted.
                    operation = TP.DELETE;
                } else {
                    //  Otherwise, they're both present, so this is an update.
                    operation = TP.UPDATE;
                }

                //  Go ahead and invoke 'mutationChangedAttribute' on the TIBET
                //  type with the various pieces of information.
                args = TP.hc('attrName', aMutationRecord.attributeName,
                                'newValue', newValue,
                                'prevValue', prevValue,
                                'operation', operation);

                targetType[fname](targetNode, args);
            }

            break;

        case 'childList':

            //  NB: We run the mutation removals first

            //  If the mutation record has removed nodes
            removedNodes = aMutationRecord.removedNodes;

            if (TP.isValid(removedNodes)) {

                if (!TP.isArray(removedNodes)) {
                    removedNodes = TP.ac(removedNodes);
                }

                //  Need to check the nodes individually for mutation tracking
                //  stoppage.
                removedNodes = removedNodes.filter(
                        function(aNode) {

                            var ans,
                                val;

                            //  If the node that got removed is an Element and
                            //  it has a value of TP.ANCESTOR_OR_SELF for the
                            //  'tibet:no-mutations' attribute, then
                            //  return false to filter out this node from the
                            //  'removed' data set. Note that we do *NOT* check
                            //  for a value of 'true' here. The element is
                            //  supposed to be looking to its *ancestor*, not to
                            //  itself, as to whether it should be tracked from
                            //  a mutation perspective. In other words, a
                            //  'tibet:no-mutations' attribute with a
                            //  simple value of 'true' will have *no* effect on
                            //  this element - only its descendants. There is a
                            //  workaround to this by using TP.ANCESTOR_OR_SELF.
                            if (TP.isElement(aNode)) {

                                val = TP.elementGetAttribute(
                                    aNode, 'tibet:no-mutations', true);

                                //  NB: Note how we also take processForLama
                                //  into account here.
                                if (val === TP.ANCESTOR_OR_SELF &&
                                    !processForLama) {
                                    return false;
                                }
                            }

                            //  If the node that got removed is an Element and
                            //  an Element can be found in the node's ancestor
                            //  chain that has an attribute with a name of
                            //  'tibet:no-mutations' and that attribute
                            //  has a value of 'true' or 'ans', then return
                            //  false to filter out this node from the 'removed'
                            //  data set.
                            if (TP.isElement(aNode) &&
                                TP.isElement(
                                    ans = TP.nodeDetectAncestorMatchingCSS(
                                                aNode,
                                                '*[tibet|no-mutations]'))) {

                                val = TP.elementGetAttribute(
                                        ans, 'tibet:no-mutations', true);

                                //  NB: Note how we also take processForLama
                                //  into account here.
                                if ((val === 'true' || val === TP.ANCESTOR) &&
                                    !processForLama) {
                                    return false;
                                }
                            }

                            return true;
                        });
            }

            //  If, after filtering, there are still nodes in the 'removed' data
            //  data, then invoke 'mutationRemovedNodes' on the TIBET type.
            if (TP.notEmpty(removedNodes)) {
                fname = 'mutationRemovedNodes';
                if (TP.canInvoke(targetType, fname)) {
                    targetType[fname](targetNode, removedNodes);
                }
            }

            //  ---

            addedNodes = aMutationRecord.addedNodes;

            if (TP.isValid(addedNodes)) {

                if (!TP.isArray(addedNodes)) {
                    addedNodes = TP.ac(addedNodes);
                }

                //  Need to check the nodes individually for mutation tracking
                //  stoppage.
                addedNodes = addedNodes.filter(
                        function(aNode) {

                            var ans,
                                val;

                            //  If the node that got added is an Element and
                            //  it has a value of TP.ANCESTOR_OR_SELF for the
                            //  'tibet:no-mutations' attribute, then
                            //  return false to filter out this node from the
                            //  'added' data set. Note that we do *NOT* check
                            //  for a value of 'true' here. The element is
                            //  supposed to be looking to its *ancestor*, not to
                            //  itself, as to whether it should be tracked from
                            //  a mutation perspective. In other words, a
                            //  'tibet:no-mutations' attribute with a
                            //  simple value of 'true' will have *no* effect on
                            //  this element - only its descendants. There is a
                            //  workaround to this by using TP.ANCESTOR_OR_SELF.
                            if (TP.isElement(aNode)) {

                                val = TP.elementGetAttribute(
                                    aNode, 'tibet:no-mutations', true);

                                //  NB: Note how we also take processForLama
                                //  into account here.
                                if (val === TP.ANCESTOR_OR_SELF &&
                                    !processForLama) {
                                    return false;
                                }
                            }

                            //  If the node that got added is an Element and
                            //  an Element can be found in the node's ancestor
                            //  ancestor chain that has an attribute with a name
                            //  of 'tibet:no-mutations' and that attribute
                            //  has a value of 'true' or 'ans', then return
                            //  false to filter out this node from the 'added'
                            //  data set.
                            if (TP.isElement(aNode) &&
                                TP.isElement(
                                    ans = TP.nodeDetectAncestorMatchingCSS(
                                                aNode,
                                                '*[tibet|no-mutations]'))) {

                                val = TP.elementGetAttribute(
                                        ans, 'tibet:no-mutations', true);

                                //  NB: Note how we also take processForLama
                                //  into account here.
                                if ((val === 'true' || val === TP.ANCESTOR) &&
                                    !processForLama) {
                                    return false;
                                }
                            }

                            return true;
                        });
            }

            //  If, after filtering, there are still nodes in the 'removed' data
            //  data, then invoke 'mutationRemovedNodes' on the TIBET type.
            if (TP.notEmpty(addedNodes)) {
                fname = 'mutationAddedNodes';
                if (TP.canInvoke(targetType, fname)) {
                    targetType[fname](targetNode, addedNodes);
                }
            }

            //  ---

            //  If subtree queries have been registered, then grab the document
            //  of the node that changed and, if that document and the query's
            //  document match, execute the query against it.
            if (TP.notEmpty(queryEntries = this.get('queries'))) {

                targetDoc = TP.nodeGetDocument(targetNode);

                queryKeys = queryEntries.getKeys();
                len = queryKeys.getSize();

                //  Iterate over all of the queries
                for (i = 0; i < len; i++) {
                    entry = queryEntries.at(queryKeys.at(i));

                    //  NB: 'queryContext' won't be used if there is no query
                    //  path object, but default it to the documentElement if
                    //  it wasn't supplied.
                    if (!TP.isElement(queryContext = entry.at('context'))) {
                        queryContext = targetDoc.documentElement;
                    }

                    if (!queryContext.contains(targetNode)) {
                        continue;
                    }

                    //  If the two documents match, execute the query and
                    //  dispatch signals if necessary.
                    if (entry.at('document') === targetDoc) {
                        this.executeSubtreeQueryAndDispatch(
                                queryKeys.at(i),
                                entry,
                                addedNodes,
                                removedNodes,
                                targetDoc);
                    }
                }
            }

            break;

        default:
            break;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.MutationSignalSource.Type.defineMethod('addSubtreeQuery',
function(observer, queryPath, queryContext) {

    /**
     * @method addSubtreeQuery
     * @summary Adds a 'subtree' query.
     * @description Subtree queries are used as a convenient way to listen for
     *     mutations and then query the document that the mutation occurred in
     *     using an optional path. If the path is not supplied, any mutations
     *     that occur in the document of the observer will be sent to the
     *     observer.
     * @param {Node} observer The object that is interested in subtree
     *     mutations in its document.
     * @param {TP.path.AccessPath} [queryPath] The optional access path that
     *     will be used to filter mutations in the observer's document.
     * @param {Node} [queryContext=observer.ownerDocument] The optional context
     *     to execute the query in. Defaults to the observer's Document. NOTE:
     *     If the supplied observer isn't a Node, this parameter *must* be
     *     supplied.
     * @exception TP.sig.InvalidNode
     * @returns {TP.meta.core.MutationSignalSource} The receiver.
     */

    var observerGID,
        observerDoc;

    if (!TP.isNode(observer) && !TP.isNode(queryContext)) {
        return this.raise('TP.sig.InvalidParameter',
                'Observer is not a Node - must supply a Node queryContext.');
    }

    observerGID = TP.gid(observer, true);

    if (TP.isNode(observer)) {
        observerDoc = TP.nodeGetDocument(observer);
    } else {
        observerDoc = TP.nodeGetDocument(queryContext);
    }

    this.get('queries').atPut(observerGID,
                                TP.hc('document', observerDoc,
                                        'path', queryPath,
                                        'context', queryContext));

    return this;
});

//  ------------------------------------------------------------------------

TP.core.MutationSignalSource.Type.defineMethod('removeSubtreeQuery',
function(observer) {

    /**
     * @method removeSubtreeQuery
     * @summary Removes a 'subtree' query.
     * @description Subtree queries are used as a convenient way to listen for
     *     mutations and then query the document that the mutation occurred in
     *     using an optional path. If the path is not supplied, any mutations
     *     that occur in the document of the observer will be sent to the
     *     observer.
     * @param {Node} observer The object that was interested in subtree
     *     mutations in its document.
     * @exception TP.sig.InvalidNode
     * @returns {TP.meta.core.MutationSignalSource} The receiver.
     */

    this.get('queries').removeKey(TP.gid(observer));

    return this;
});

//  ------------------------------------------------------------------------

TP.core.MutationSignalSource.Type.defineMethod('executeSubtreeQueryAndDispatch',
function(queryObserverGID, queryEntry, addedNodes, removedNodes, aDocument) {

    /**
     * @method executeSubtreeQueryAndDispatch
     * @summary Executes a 'subtree' query and invokes the proper added or
     *     removed methods depending on the mutation.
     * @description Note that this won't be invoked unless the observer's
     *     document and the document that the mutation occurred in are
     *     identical.
     * @param {String} queryObserverGID The global ID of the observer that is
     *     interested in subtree mutations in its document.
     * @param {TP.core.Hash} queryEntry A hash of query data containing the
     *     query path, query context and query document.
     * @param {Node[]} addedNodes The nodes that were added in the mutation.
     * @param {Node[]} removedNodes The nodes that were removed in the mutation.
     * @param {Document} aDocument The document that the mutation occurred in.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.meta.core.MutationSignalSource} The receiver.
     */

    var queryObserver,
        queryPath,
        queryContext,

        addedNodesInContext,
        removedNodesInContext,

        results,

        matchingNodes;

    //  Make sure that we can get the Element that is registered under observer
    //  GID.
    if (!TP.isValid(queryObserver = TP.bySystemId(queryObserverGID))) {
        //  TODO: Raise an InvalidParameter here
        return this;
    }

    //  This might be null if the receiver is interested in all added/removed
    //  nodes.
    queryPath = queryEntry.at('path');

    //  NB: 'queryContext' won't be used if there is no query path object, but
    //  default it to the documentElement if it wasn't supplied.
    if (!TP.isElement(queryContext = queryEntry.at('context'))) {
        queryContext = aDocument.documentElement;
    }

    //  If there is a real addedNodes Array, make sure all of the nodes in it
    //  exist under the queryContext node.
    if (TP.isArray(addedNodes)) {
        addedNodesInContext = addedNodes.filter(
                                function(aNode) {
                                    return queryContext.contains(aNode);
                                });
    }

    //  If there is a real removedNodes Array, make sure all of the nodes in it
    //  exist under the queryContext node.
    if (TP.isArray(removedNodes)) {
        removedNodesInContext = removedNodes.filter(
                                function(aNode) {
                                    return queryContext.contains(aNode);
                                });
    }

    //  If both of these Arrays are empty, exit here. No need to run a
    //  (relatively expensive) query path.
    if (TP.isEmpty(addedNodesInContext) && TP.isEmpty(removedNodesInContext)) {
        return this;
    }

    //  If there is a valid path, then execute it.
    if (TP.notEmpty(queryPath)) {
        results = queryPath.executeGet(queryContext);
    }

    //  If there are added nodes, invoke that machinery.
    if (TP.notEmpty(addedNodesInContext)) {

        //  If we had results from our query, intersect them against the added
        //  nodes.
        if (TP.notEmpty(results)) {
            matchingNodes = results.intersection(
                                        addedNodesInContext, TP.IDENTITY);
        } else if (TP.isEmpty(queryPath)) {
            //  Otherwise, if there is no query, just use all of the added nodes.
            matchingNodes = addedNodesInContext;
        }

        //  If there are matching nodes and we can invoke
        //  'mutationAddedFilteredNodes' against the observer, then do so.
        if (TP.notEmpty(matchingNodes) &&
            TP.canInvoke(queryObserver, 'mutationAddedFilteredNodes')) {
            queryObserver.mutationAddedFilteredNodes(
                                        matchingNodes, queryEntry);
        }
    }

    //  If there are removed nodes, invoke that machinery.
    if (TP.notEmpty(removedNodesInContext)) {

        //  NOTE: Since we can't run the query against nodes that have already
        //  been removed the DOM, we just pass the entire Array of removed nodes
        //  to the handler. It is up to that method to do whatever filtering is
        //  required.
        matchingNodes = removedNodesInContext;

        //  If there are matching nodes and we can invoke
        //  'mutationRemovedFilteredNodes' against the observer, then do so.
        if (TP.notEmpty(matchingNodes) &&
            TP.canInvoke(
                    queryObserver, 'mutationRemovedFilteredNodes')) {
            queryObserver.mutationRemovedFilteredNodes(
                                        matchingNodes, queryEntry);
        }
    }

    return this;
});

//  ========================================================================
//  TP.core.ResizeSignalSource
//  ========================================================================

TP.core.SignalSource.defineSubtype('ResizeSignalSource');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.core.ResizeSignalSource.Type.defineAttribute('defaultSignal',
    'TP.sig.DOMResize');

//  The low-level handler function
TP.core.ResizeSignalSource.Type.defineAttribute('$handlerFunc');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.ResizeSignalSource.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time type initialization.
     */

    this.set('$handlerFunc', function() {
        //  NB: 'this' is the element that the resize handler was
        //  installed for - don't bind this unless you want to lose the
        //  reference.
        TP.wrap(this).signal(TP.core.ResizeSignalSource.get('defaultSignal'));
    });

    return;
});

//  ------------------------------------------------------------------------

TP.core.ResizeSignalSource.Type.defineMethod('addObserver',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method addObserver
     * @summary Invoked by observe() to add an observation or activate
     *     underlying signaling hooks necessary to ensure proper signaling.
     * @description This method is overridden on this type because the
     *     TP.sig.DOMResize signal is a 'dual purpose' signal in that, if you
     *     observe a Window or Document for 'resized', you will use the native
     *     browser's machinery but if you observe an Element for 'resized',
     *     there is no native browser event for such a thing and so you will use
     *     TIBET's 'resize listener' function to watch the Element(s) for sizing
     *     changes.
     * @param {Object|Object[]} anOrigin One or more origins to observe.
     * @param {Object|Object[]} aSignal One or more signals to observe from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn on observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to add the observation, false otherwise.
     */

    var origins,
        signals,

        ourDefaultSignalName,
        handlerFunc,

        len,
        i,
        signal,

        len2,
        j,

        obj;

    if (TP.notValid(anOrigin)) {
        return false;
    }

    //  If we're running in headless mode, just return false to tell the
    //  signaling system to *not* add the observation to the main
    //  notification engine.
    if (TP.sys.cfg('boot.context') === 'headless') {
        return false;
    }

    //  If it's a Window or Document, just return true to tell the signaling
    //  system to add the observation to the main notification engine.
    if (TP.isWindow(anOrigin) || TP.isDocument(anOrigin)) {
        return true;
    }

    if (!TP.isArray(anOrigin)) {
        origins = TP.ac(anOrigin);
    } else {
        origins = anOrigin;
    }

    if (TP.isArray(aSignal)) {
        signals = aSignal;
    } else if (TP.isString(aSignal)) {
        signals = aSignal.split(' ');
    } else if (TP.isType(aSignal)) {
        signals = TP.ac(aSignal);
    } else {
        this.raise('TP.sig.InvalidParameter',
                    'Improper signal definition.');

        return false;
    }

    ourDefaultSignalName = this.get('defaultSignal');

    handlerFunc = this.get('$handlerFunc');

    len = signals.getSize();

    for (i = 0; i < len; i++) {

        signal = signals.at(i).getSignalName();

        //  The only signals we're interested in are our own kind of signals
        if (signal !== ourDefaultSignalName) {
            continue;
        }

        len2 = origins.getSize();
        for (j = 0; j < len2; j++) {

            obj = origins.at(j);

            if (TP.isString(obj)) {
                obj = TP.sys.getObjectById(obj);
            }

            obj = TP.elem(TP.unwrap(obj));

            //  We didn't get an Element, even after resolving and unwrapping -
            //  that's a problem.
            if (!TP.isElement(obj)) {
                return this.raise('TP.sig.InvalidElement');
            }

            //  Add our shared handler Function as a resize listener on the
            //  Element.
            TP.elementAddResizeListener(
                obj,
                handlerFunc);
        }
    }

    //  Tell the notification to register our handler, etc.
    return true;
});

//  ------------------------------------------------------------------------

TP.core.ResizeSignalSource.Type.defineMethod('removeObserver',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method removeObserver
     * @summary Invoked by ignore() to remove an observation or deactivate
     *     underlying signaling hooks necessary to ensure proper signaling.
     * @param {Object|Object[]} anOrigin One or more origins to ignore.
     * @param {Object|Object[]} aSignal One or more signals to ignore from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn off observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to remove the observation, false otherwise.
     */

    var handlerFunc,
        i,
        j,
        len,
        len2,
        obj,
        origins,
        ourDefaultSignalName,
        signal,
        signals;

    if (TP.notValid(anOrigin)) {
        return false;
    }

    //  If we're running in headless mode, just return false to tell the
    //  signaling system to *not* remove the observation from the main
    //  notification engine.
    if (TP.sys.cfg('boot.context') === 'headless') {
        return false;
    }

    //  If it's a Window or Document, just return true to tell the signaling
    //  system to remove the observation from the main notification engine.
    if (TP.isWindow(anOrigin) || TP.isDocument(anOrigin)) {
        return true;
    }

    if (!TP.isArray(anOrigin)) {
        origins = TP.ac(anOrigin);
    } else {
        origins = anOrigin;
    }

    if (TP.isArray(aSignal)) {
        signals = aSignal;
    } else if (TP.isString(aSignal)) {
        signals = aSignal.split(' ');
    } else if (TP.isType(aSignal)) {
        signals = TP.ac(aSignal);
    } else {
        this.raise('TP.sig.InvalidParameter',
                    'Improper signal definition.');

        return false;
    }

    ourDefaultSignalName = this.get('defaultSignal');

    handlerFunc = this.get('$handlerFunc');

    len = signals.getSize();

    for (i = 0; i < len; i++) {

        signal = signals.at(i).getSignalName();

        //  The only signals we're interested in are our own kind of signals
        if (signal !== ourDefaultSignalName) {
            continue;
        }

        len2 = origins.getSize();
        for (j = 0; j < len2; j++) {

            obj = origins.at(j);

            if (TP.isString(obj)) {
                obj = TP.sys.getObjectById(obj);
            }

            obj = TP.elem(TP.unwrap(obj));

            //  We didn't get an Element, even after resolving and unwrapping -
            //  that's a problem.
            if (!TP.isElement(obj)) {
                return this.raise('TP.sig.InvalidElement');
            }

            //  Remove our shared handler Function from a resize listener on the
            //  Element.
            TP.elementRemoveResizeListener(obj, handlerFunc);
        }
    }

    //  Always tell the notification system to add our handler, etc.
    //  presuming this was invoked indirectly via observe().
    return true;
});

//  ========================================================================
//  TP.core.VisibilitySignalSource
//  ========================================================================

TP.core.SignalSource.defineSubtype('VisibilitySignalSource');

//  ------------------------------------------------------------------------

TP.core.VisibilitySignalSource.Type.defineMethod('addObserver',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method addObserver
     * @summary Invoked by observe() to add an observation or activate
     *     underlying signaling hooks necessary to ensure proper signaling.
     * @description This method is overridden on this type because the
     *     TP.sig.DOMVisibility signal uses the 'IntersectionObserver' object to
     *     monitor an element's visibility. There is no native browser event for
     *     such a thing.
     * @param {Object|Object[]} anOrigin One or more origins to observe.
     * @param {Object|Object[]} aSignal One or more signals to observe from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn on observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to add the observation, false otherwise.
     */

    var origins,
        signals,

        len,
        i,
        signal,

        len2,
        j,

        obj;

    if (TP.notValid(anOrigin)) {
        return false;
    }

    //  If it's a Window or Document, just return true to tell the signaling
    //  system to add the observation to the main notification engine.
    if (TP.isWindow(anOrigin) || TP.isDocument(anOrigin)) {
        return true;
    }

    if (!TP.isArray(anOrigin)) {
        origins = TP.ac(anOrigin);
    } else {
        origins = anOrigin;
    }

    if (TP.isArray(aSignal)) {
        signals = aSignal;
    } else if (TP.isString(aSignal)) {
        signals = aSignal.split(' ');
    } else if (TP.isType(aSignal)) {
        signals = TP.ac(aSignal);
    } else {
        this.raise('TP.sig.InvalidParameter',
                    'Improper signal definition.');

        return false;
    }

    len = signals.getSize();

    for (i = 0; i < len; i++) {

        signal = signals.at(i).getSignalName();

        //  The only signals we're interested in are our own kind of signals.
        if (signal !== 'TP.sig.DOMVisible' && signal !== 'TP.sig.DOMHidden') {
            continue;
        }

        len2 = origins.getSize();
        for (j = 0; j < len2; j++) {

            obj = origins.at(j);

            if (TP.isString(obj)) {
                obj = TP.sys.getObjectById(obj);
            }

            obj = TP.elem(TP.unwrap(obj));

            //  We didn't get an Element, even after resolving and unwrapping -
            //  that's a problem.
            if (!TP.isElement(obj)) {
                return this.raise('TP.sig.InvalidElement');
            }

            //  If the global IntersectionObserver that manages our visibility
            //  events hasn't been allocated and initialized with the callback
            //  function, do so now.
            if (TP.notValid(TP.VISIBILITY_INTERSECTION_OBSERVER)) {
                TP.VISIBILITY_INTERSECTION_OBSERVER =
                    new IntersectionObserver(
                        function(entries) {
                            entries.forEach(
                                function(anEntry) {
                                    var target;

                                    //  The target will be the target Element
                                    //  whose intersection with the root element
                                    //  has changed. Make sure it's an Element
                                    //  and then signal the proper signal type
                                    //  depending on whether it is now
                                    //  intersecting or not.
                                    target = anEntry.target;

                                    if (!TP.isElement(target)) {
                                        return;
                                    }

                                    if (anEntry.isIntersecting) {
                                        TP.wrap(target).signal(
                                                        'TP.sig.DOMVisible');
                                    } else {
                                        TP.wrap(target).signal(
                                                        'TP.sig.DOMHidden');
                                    }
                                });
                        },
                        {
                            root: null,
                            rootMargin: '0px'
                        });
            }

            TP.VISIBILITY_INTERSECTION_OBSERVER.observe(obj);
        }
    }

    //  Tell the notification to register our handler, etc.
    return true;
});

//  ------------------------------------------------------------------------

TP.core.VisibilitySignalSource.Type.defineMethod('removeObserver',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method removeObserver
     * @summary Invoked by ignore() to remove an observation or deactivate
     *     underlying signaling hooks necessary to ensure proper signaling.
     * @param {Object|Object[]} anOrigin One or more origins to ignore.
     * @param {Object|Object[]} aSignal One or more signals to ignore from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn off observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to remove the observation, false otherwise.
     */

    var i,
        j,
        len,
        len2,
        obj,
        origins,
        signal,
        signals;

    if (TP.notValid(anOrigin)) {
        return false;
    }

    //  If it's a Window or Document, just return true to tell the signaling
    //  system to remove the observation from the main notification engine.
    if (TP.isWindow(anOrigin) || TP.isDocument(anOrigin)) {
        return true;
    }

    if (!TP.isArray(anOrigin)) {
        origins = TP.ac(anOrigin);
    } else {
        origins = anOrigin;
    }

    if (TP.isArray(aSignal)) {
        signals = aSignal;
    } else if (TP.isString(aSignal)) {
        signals = aSignal.split(' ');
    } else if (TP.isType(aSignal)) {
        signals = TP.ac(aSignal);
    } else {
        this.raise('TP.sig.InvalidParameter',
                    'Improper signal definition.');

        return false;
    }

    len = signals.getSize();

    for (i = 0; i < len; i++) {

        signal = signals.at(i).getSignalName();

        //  The only signals we're interested in are our own kind of signals
        if (signal !== 'TP.sig.DOMVisible' && signal !== 'TP.sig.DOMHidden') {
            continue;
        }

        len2 = origins.getSize();
        for (j = 0; j < len2; j++) {

            obj = origins.at(j);

            if (TP.isString(obj)) {
                obj = TP.sys.getObjectById(obj);
            }

            obj = TP.elem(TP.unwrap(obj));

            //  We didn't get an Element, even after resolving and unwrapping -
            //  that's a problem.
            if (!TP.isElement(obj)) {
                return this.raise('TP.sig.InvalidElement');
            }

            //  Remove the element from the global IntersectionObserver
            //  machinery.
            if (TP.isValid(TP.VISIBILITY_INTERSECTION_OBSERVER)) {
                TP.VISIBILITY_INTERSECTION_OBSERVER.unobserve(obj);
            }
        }
    }

    //  Always tell the notification system to add our handler, etc.
    //  presuming this was invoked indirectly via observe().
    return true;
});

//  ========================================================================
//  TP.core.Worker
//  ========================================================================

/**
 * @type {TP.core.Worker}
 * @summary This type provides an interface to the browser's 'worker thread'
 *     capability.
 */

//  ------------------------------------------------------------------------

TP.core.URISignalSource.defineSubtype('Worker');

//  Mix in send capability.
TP.core.Worker.addTraits(TP.core.MessageConnection);

TP.core.Worker.Inst.resolveTraits(TP.ac('sendMessage'), TP.core.Worker);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  a pool of worker objects, keyed by the worker type name. Note that this is a
//  LOCAL attribute
TP.core.Worker.defineAttribute('$workerPoolDict');

//  the maximum number of workers allowed in the pool for this type
TP.core.Worker.Type.defineAttribute('$maxWorkerCount');

//  the total number of workers currently allocated for this type
TP.core.Worker.Type.defineAttribute('$currentWorkerCount');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.Worker.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    this.defineDependencies('TP.extern.Promise');

    this.set('$workerPoolDict', TP.hc());

    return;
});

//  ------------------------------------------------------------------------

TP.core.Worker.Type.defineMethod('fromFunction',
function(aFunction) {

    /**
     * @method fromFunction
     * @summary Returns an instance of TP.core.Worker that has a copy of the
     *     supplied Function running in a worker thread.
     * @param {Function} aFunction The Function to copy into the thread. Note
     *     that this function will be turned into a String and will therefore
     *     not be the original function object.
     * @returns {TP.core.Worker} A new instance.
     */

    var funcSrc,

        blob,
        url,
        newinst;

    //  Stringify the Function object, wrapping it as an IIFE.
    funcSrc = `(${aFunction})();`;

    //  Create a Blob from that source, supplying the correct type for
    //  JavaScript.
    blob = new Blob(TP.ac(funcSrc), {type: 'application/javascript'});

    //  Create an 'object URL' for that content. This stores it and returns us
    //  the URL string.
    url = URL.createObjectURL(blob);

    //  Create a new instance of ourself with that URL.
    newinst = this.construct(url);

    return newinst;
});

//  ------------------------------------------------------------------------

TP.core.Worker.Type.defineMethod('getWorker',
function() {

    /**
     * @method getWorker
     * @summary Returns a worker either from a pool of workers that exist for
     *     the type being messaged or a new worker, if no workers are available
     *     in the pool for the receiving type.
     * @returns TP.core.Worker A worker of the type being messaged.
     */

    var poolDict,
        pool,

        worker;

    //  The dictionary of pools is on the TP.core.Worker type itself as a type
    //  local.
    poolDict = TP.core.Worker.get('$workerPoolDict');

    //  See if there is a pool for this receiving type, keyed by its name (the
    //  type name). If not, create one and register it.
    if (TP.notValid(pool = poolDict.at(this.getName()))) {
        pool = TP.ac();
        poolDict.atPut(this.getName(), pool);
        this.set('$currentWorkerCount', 0);
    }

    //  If there are workers available for this receiving type, use one of them.
    if (TP.notEmpty(pool)) {
        worker = pool.shift();
    } else if (this.get('$currentWorkerCount') < this.get('$maxWorkerCount')) {
        //  Otherwise, if the current worker count is less than the max worker
        //  count for this type, then go ahead and construct one and increment
        //  the current count.
        worker = this.construct();
        this.set('$currentWorkerCount', this.get('$currentWorkerCount') + 1);
    } else {
        //  Otherwise, the pool was empty and if we allocated another worker
        //  we'd be over our max limit, so we warn.
        TP.ifWarn() ?
            TP.warn('Maximum number of workers reached for: ' +
                    this.getName() +
                    '.') : 0;
    }

    return worker;
});

//  ------------------------------------------------------------------------

TP.core.Worker.Type.defineMethod('repoolWorker',
function(worker) {

    /**
     * @method repoolWorker
     * @summary Puts the supplied Worker into the pool for the receiving type.
     * @param {TP.core.Worker} worker The worker to put into the pool.
     * @returns TP.meta.core.Worker The receiver.
     */

    var poolDict,
        pool;

    //  The dictionary of pools is on the TP.core.Worker type itself as a type
    //  local.
    poolDict = TP.core.Worker.get('$workerPoolDict');

    //  See if there is a pool for this receiving type, keyed by its name (the
    //  type name). If not, create one and register it.
    if (TP.notValid(pool = poolDict.at(this.getName()))) {
        pool = TP.ac();
        poolDict.atPut(this.getName(), pool);
    }

    //  Put the worker into the pool, ready to be used again.
    pool.push(worker);

    return this;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  a worker thread object used by this object to interface with the worker
//  thread.
TP.core.Worker.Inst.defineAttribute('$thread');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.Worker.Inst.defineMethod('init',
function(aURI, onmessage, onerror) {

    /**
     * @method init
     * @summary Initializes a new instance of the receiver.
     * @param {String|URI} [aURI=tibet_worker.js] The URI used to initialize the
     *     worker. Defaults to the tibet_worker.js helper script.
     * @param {Function} [onmessage] Optional onmessage handler. Defaults to the
     *     receiving type's onmessage method, allowing you to create custom
     *     worker subtypes with specific methods for message protocol handling.
     * @param {Function} [onerror] Optional onerror handler. Defaults to the
     *     receiving type's onerror method, allowing you to create custom
     *     worker subtypes with specific methods for message error handling.
     * @returns {TP.core.Worker} A new instance.
     */

    var uri,
        thread,
        handler;

    //  Default the URI before invoking supertype constructor.
    uri = TP.ifInvalid(aURI, '~lib_build/tibet_worker.js');
    uri = TP.uc(uri);

    this.callNextMethod(uri);

    try {

        //  Spin off a new Worker thread.
        thread = new Worker(uri.getLocation());

        //  Set up the onmessage handler by either using the supplied one or
        //  binding to our method.
        handler = onmessage;
        if (TP.notValid(handler)) {
            handler = this.onmessage.bind(this);
        }
        thread.onmessage = handler;

        //  Set up the onerror handler by either using the supplied one or
        //  binding to our method.
        handler = onerror;
        if (TP.notValid(handler)) {
            handler = this.onerror.bind(this);
        }
        thread.onerror = handler;

    } catch (e) {
        return this.raise('WorkerError', e);
    }

    this.set('$thread', thread);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Worker.Inst.defineMethod('onerror',
function(evt) {

    /**
     * @method onerror
     * @summary The default method that is invoked when the worker thread that
     *     the receiver is managing has posted a error back into this context.
     * @param {ErrorEvent} evt The event sent by the underlying system.
     * @returns {TP.core.Worker} The receiver.
     */

    var err;

    //  Convert from an ErrorEvent into a real Error object
    err = new Error(evt.message, evt.filename, evt.lineno);

    TP.error(err);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Worker.Inst.defineMethod('onmessage',
function(evt) {

    /**
     * @method onmessage
     * @summary The default method that is invoked when the worker thread that
     *     the receiver is managing has posted a message back into this context.
     * @param {MessageEvent} evt The event sent by the underlying system.
     * @returns {TP.core.Worker} The receiver.
     */

    TP.info(evt.data);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Worker.Inst.defineMethod('repool',
function() {

    /**
     * @method repool
     * @summary Puts the receiver into the pool for its type.
     * @returns TP.core.Worker The receiver.
     */

    this.getType().repoolWorker(this);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Worker.Inst.defineMethod('sendMessage',
function(message) {

    /**
     * @method sendMessage
     * @summary Sends a string to the remote end of the connection. This method
     *     does not serialize content. Use send() if you want serialization.
     * @param {String} message The string to send to the end of the connection.
     * @returns TP.core.Worker The receiver.
     */

    var thread;

    thread = this.$get('$thread');

    thread.postMessage(message);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Worker.Inst.defineMethod('sendMessageAndWait',
function(message, resultProcessor, errorProcessor) {

    /**
     * @method sendMessageAndWait
     * @summary Sends a string to the remote end of the connection and awaits
     *     for a result from that remote end (which is when the returned Promise
     *     resolves).
     * @param {String} message The string to send to the end of the connection.
     * @param {Function} [resultProcessor] An optional Function to process
     *     results when they come in. This Function should take a single
     *     parameter which will be the raw result data and should return data
     *     processed in whatever way the caller wants it.
     * @param {Function} [errorProcessor] An optional Function to process
     *     errors when they come in. This Function should take a single
     *     parameter which will be an Error object and should return an Error
     *     object constructed in whatever way the caller wants it.
     * @returns Promise A promise that will resolve when the send is complete.
     */

    var workerThread,
        newPromise;

    if (TP.isEmpty(message)) {
        return this.raise('InvalidParameter', 'No message provided.');
    }

    workerThread = this.get('$thread');

    //  Construct a Promise around sending the supplied source code to the
    //  worker for evaluation.
    newPromise = TP.extern.Promise.construct(
        function(resolver, rejector) {

            workerThread.onmessage = function(e) {

                var data,
                    result;

                data = e.data;
                result = data.result;

                if (TP.isCallable(resultProcessor)) {
                    result = resultProcessor(result);
                }

                if (TP.isValid(result)) {
                    //  Run the Promise resolver with the result returned in the
                    //  message event.
                    return resolver(result);
                } else {
                    return resolver();
                }
            };

            workerThread.onerror = function(e) {

                var err;

                if (TP.isEvent(e)) {
                    //  Convert from an ErrorEvent into a real Error object.
                    err = new Error(e.message, e.filename, e.lineno);
                } else {
                    err = e;
                }

                if (TP.isCallable(errorProcessor)) {
                    err = errorProcessor(err);
                }

                if (TP.isError(err)) {
                    //  Run the Promise rejector with the Error object
                    //  constructed from the data returned in the error event
                    //  and possibly massaged by the error processor.
                    return rejector(err);
                } else {
                    return rejector();
                }
            };

            //  Send a message to the worker. Note that this method will
            //  automatically serialize the message.
            this.send(message);
        }.bind(this));

    return newPromise;
});

//  ------------------------------------------------------------------------

TP.core.Worker.Inst.defineMethod('serializeMessage',
function(message) {

    /**
     * @method serializeMessage
     * @summary Serializes a message object to produce a representation that can
     *     be sent as a message. If the message object implements an 'asMessage'
     *     method that method is invoked, otherwise the default representation
     *     is returned as one that the message channel can understand.
     * @param {Object} message The object to serialize.
     * @returns {Object} The supplied message serialized.
     */

    if (TP.isString(message)) {
        return message;
    }

    if (TP.canInvoke('asMessage')) {
        return message.asMessage();
    }

    //  Worker threads will use the standard Structured Clone Algorithm to
    //  serialize their data when sent data via postMessage, so we just return
    //  the original object (making sure it's a POJO).
    return TP.obj(message);
});

//  ========================================================================
//  TP.core.GenericWorker
//  ========================================================================

TP.core.Worker.defineSubtype('GenericWorker');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.GenericWorker.Inst.defineMethod('init',
function(aURI) {

    /**
     * @method init
     * @summary Initializes a new instance of the receiver. Note that
     *     GenericWorker ignores any URI provided, forcing the underlying
     *     worker thread to use the tibet_helper.js script as the base.
     *     Use the 'import' function of the returned instance to add a target
     *     script with a returned Promise you can chain to.
     * @returns {TP.core.GenericWorker|undefined} A new instance.
     */

    var uri;

    if (TP.isValid(aURI)) {
        this.raise('InvalidParameter');
        return;
    }

    uri = TP.uc('~lib_build/tibet_worker.js');

    return this.callNextMethod(uri);
});

//  ------------------------------------------------------------------------

TP.core.GenericWorker.Inst.defineMethod('eval',
function(jsSrc) {

    /**
     * @method eval
     * @summary Evaluates the supplied JavaScript source code inside of the
     *     worker thread that this object represents and returns the value.
     * @param {String} jsSrc The source code to evaluate inside of the worker.
     * @returns Promise A promise that will resolve when the evaluation is
     *     complete with the value that was produced by executing the code in
     *     the receiver's thread.
     */

    if (TP.isEmpty(jsSrc)) {
        return this.raise('InvalidParameter', 'No source code provided.');
    }

    //  Post a message telling the worker helper stub code loaded into the
    //  thread to evaluate the supplied source code.
    return this.sendMessageAndWait(TP.hc(
            'funcRef', 'evalJS',    //  func ref in worker
            'thisRef', 'self',      //  this ref in worker
            'params', TP.ac(jsSrc)  //  params ref - JSONified structure
    ));
});

//  ------------------------------------------------------------------------

TP.core.GenericWorker.Inst.defineMethod('$evalNoReturn',
function(jsSrc) {

    /**
     * @method $evalNoReturn
     * @summary Evaluates the supplied JavaScript source code inside of the
     *     worker thread that this object represents.
     * @param {String} jsSrc The source code to evaluate inside of the worker.
     * @returns Promise A promise that will resolve when the evaluation is
     *     complete.
     */

    if (TP.isEmpty(jsSrc)) {
        return this.raise('InvalidParameter', 'No source code provided.');
    }

    //  Post a message telling the worker helper stub code loaded into the
    //  thread to evaluate the supplied source code.
    return this.sendMessageAndWait(TP.hc(
            'funcRef', 'evalJSNoReturn',    //  func ref in worker
            'thisRef', 'self',              //  this ref in worker
            'params', TP.ac(jsSrc)          //  params ref - JSONified structure
    ));
});

//  ------------------------------------------------------------------------

TP.core.GenericWorker.Inst.defineMethod('import',
function(aCodeURL) {

    /**
     * @method import
     * @summary Imports the JavaScript source code referred to by the supplied
     *     URL into the worker thread that this object represents.
     * @param {TP.uri.URL|String} aCodeURL The URL referring to the resource
     *     containing the source code to import inside of the worker.
     * @returns Promise A promise that will resolve when the importation is
     *     complete.
     */

    var url;

    if (!TP.isURIString(aCodeURL) && !TP.isURI(aCodeURL)) {
        return this.raise('InvalidURL',
                            'Not a valid URL to JavaScript source code.');
    }

    url = TP.uc(aCodeURL).getLocation();

    //  Post a message telling the worker helper stub code loaded into the
    //  thread to import source code from the supplied URL.
    return this.sendMessageAndWait(TP.hc(
            'funcRef', 'importJS',  //  func ref in worker
            'thisRef', 'self',      //  'this' ref in worker
            'params', TP.ac(url)    //  params ref - JSONified structure
    ));
});

//  ------------------------------------------------------------------------

TP.core.GenericWorker.Inst.defineMethod('defineWorkerMethod',
function(name, body, async) {

    /**
     * @method defineWorkerMethod
     * @summary Defines a method inside of the worker represented by the
     *     receiver and a peer method on the receiver that calls it, thereby
     *     presenting a seamless interface to it. The peer method will return a
     *     Promise that will resolve when the worker has posted results back for
     *     that call.
     * @param {String} name The name of the method.
     * @param {Function} body The body of the method.
     * @param {Boolean} async Whether or not the method is itself asynchronous.
     *     If so, it is important that it be written in such a way to take a
     *     callback as it's last formal parameter. In that way, it can inform
     *     the worker it is done and the worker can post the results back to
     *     this object. The default is false.
     * @returns Promise A promise that will resolve when the definition is
     *     complete.
     */

    var methodSrc,
        isAsync,

        promise;

    if (TP.isEmpty(name)) {
        return this.raise('InvalidString', 'Invalid method name');
    }

    if (!TP.isCallable(body)) {
        return this.raise('InvalidFunction', 'Invalid method body');
    }

    //  Get the source of the method body handed in and prepend
    //  'self.<methodName>' onto the front.
    //  NOTE: We do *not* use TP.global here since this code will be running
    //  in the worker thread and that's not defined there!!
    methodSrc = 'self.' + name + ' = ' + body.toString();

    isAsync = TP.ifInvalid(async, false);

    //  Use our '$evalNoReturn' method to evaluate the code. This is *not* the
    //  regular JS 'eval' global call - this method evaluates the code over in
    //  worker thread and returns a Promise that will resolve when that is done.
    /* eslint-disable no-eval */
    promise = this.$evalNoReturn(methodSrc);
    /* eslint-enable no-eval */

    //  Attach to the Promise that was returned from evaluating the code.
    promise = promise.then(
        function() {

            var peerMethod;

            //  Now, define that method on *this* object to call over into the
            //  worker thread to invoke what we just eval'ed over there.
            peerMethod = function() {
                var args;

                args = Array.prototype.slice.call(arguments);

                return this.sendMessageAndWait(TP.hc(
                            'funcRef', name,    //  func ref in worker
                            'thisRef', 'self',  //  this ref in worker
                            'params', args,     //  params ref - JSONified
                                                //  structure
                            'async', isAsync
                ));
            };

            //  Install that method on ourself.
            this.defineMethod(name, peerMethod);
        }.bind(this)).catch(
        function(err) {
            TP.ifError() ?
                TP.error('Error creating TP.core.GenericWorker Promise: ' +
                            TP.str(err)) : 0;
        });

    return promise;
});

//  ========================================================================
//  REMOTE SIGNAL SOURCE SIGNALS
//  ========================================================================

TP.sig.Signal.defineSubtype('RemoteSourceSignal');

TP.sig.RemoteSourceSignal.Type.defineAttribute('defaultPolicy',
    TP.INHERITANCE_FIRING);

TP.sig.RemoteSourceSignal.defineSubtype('SourceOpen');
TP.sig.RemoteSourceSignal.defineSubtype('SourceDataReceived');
TP.sig.RemoteSourceSignal.defineSubtype('SourceClosed');
TP.sig.RemoteSourceSignal.defineSubtype('SourceReconnecting');
TP.sig.RemoteSourceSignal.defineSubtype('SourceError');

TP.sig.RemoteSourceSignal.defineSubtype('RemoteURLChange');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETWorkflowTypes.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/*
 * Types specific to workflow in terms of requests, resources, and their
 * responses. The types here, particularly TP.sig.Request, TP.core.Service,
 * and TP.sig.Response provide the foundation of TIBET's "service layer".
 *
 * Also included here are TIBET's Controller and Application types along with
 * helpers for things like History etc.
 */

//  ========================================================================
//  TP.core.Triggered
//  ========================================================================

TP.lang.Object.defineSubtype('TP.core.Triggered');

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation
TP.core.Triggered.isAbstract(true);

//  The set of ordered pairs (origin/signal) which define object's triggers.
TP.core.Triggered.Type.defineAttribute('triggers');

//  ------------------------------------------------------------------------
//  Type Definition
//  ------------------------------------------------------------------------

TP.core.Triggered.Type.defineMethod('addTrigger',
function(anOrigin, aSignal) {

    /**
     * @method addTrigger
     * @summary Stores a trigger definition (an ordered pair of origin and
     *     signal) as part of the receiver's set of triggers.
     * @param {String} anOrigin What origin is being observed?
     * @param {String} aSignal What signal is being observed?
     * @returns {TP.meta.core.Triggered} The receiver.
     */

    var triggers,
        trigger;

    switch (arguments.length) {
        case 1:
            if (TP.isArray(anOrigin)) {
                trigger = anOrigin;
            } else {
                this.raise('InvalidTrigger');
            }
            break;
        case 2:
            trigger = TP.ac(anOrigin, aSignal);
            break;
        default:
            return this.raise('InvalidParameter');
    }

    triggers = this.getTriggers();
    triggers.push(trigger);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Triggered.Type.defineMethod('addTriggers',
function(originSignalPairs) {

    /**
     * @method addTriggers
     * @summary Stores a set of trigger definitions (list of ordered pairs with
     *     origin and signal) as part of the receiver's set of triggers.
     * @param {String[][]} originSignalPairs The origin/signal pairs to use as
     *     triggers.
     * @returns {TP.meta.core.Triggered} The receiver.
     */

    var thisref;

    thisref = this;

    if (TP.notEmpty(originSignalPairs)) {
        originSignalPairs.forEach(
                            function(pair) {
                                thisref.addTrigger.apply(thisref, pair);
                            });
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Triggered.Type.defineMethod('getTriggers',
function() {

    /**
     * @method getTriggers
     * @summary Returns one or more trigger signals for the TIBET signaling
     *     system which should cause the receiver to respond to triggers.
     * @returns {String[][]} An array of origin/signal ordered pairs.
     */

    var triggers;

    if (TP.notValid(triggers = this.$get('triggers'))) {
        triggers = TP.ac();
        this.$set('triggers', triggers);
    }

    return triggers;
});

//  ------------------------------------------------------------------------

TP.core.Triggered.Type.defineMethod('ignoreTriggers',
function() {

    /**
     * @method ignoreTriggers
     * @summary Turns off registration (ignores) the receivers triggers.
     * @returns {TP.meta.core.Triggered} The receiver.
     */

    var triggers,
        thisref;

    triggers = this.getTriggers();

    thisref = this;

    triggers.forEach(
                function(pair) {
                    thisref.ignore(pair.first(), pair.last());
                });

    return this;
});


//  ------------------------------------------------------------------------

TP.core.Triggered.Type.defineMethod('observeTriggers',
function() {

    /**
     * @method observeTriggers
     * @summary Tells the receiver to observe its trigger signals so it can
     *     begin to respond to them.
     * @returns {TP.meta.core.Triggered} The receiver.
     */

    var triggers,
        thisref;

    triggers = this.getTriggers();

    thisref = this;

    triggers.forEach(
                function(pair) {
                    thisref.observe(pair.first(), pair.last());
                });

    return this;
});

//  ------------------------------------------------------------------------
//  Instance Definition
//  ------------------------------------------------------------------------

//  these default to the values installed on the type, but can be altered
//  at the instance level
TP.core.Triggered.Inst.defineAttribute('triggers');

//  ------------------------------------------------------------------------

TP.core.Triggered.Inst.defineMethod('addTrigger',
function(anOrigin, aSignal) {

    /**
     * @method addTrigger
     * @summary Stores a trigger definition (an ordered pair of origin and
     *     signal) as part of the receiver's set of triggers.
     * @param {String} anOrigin What origin is being observed?
     * @param {String} aSignal What signal is being observed?
     * @returns {TP.core.Triggered} The receiver.
     */

    var triggers,
        trigger;

    switch (arguments.length) {
        case 1:
            if (TP.isArray(anOrigin)) {
                trigger = anOrigin;
            } else {
                this.raise('InvalidTrigger');
            }
            break;
        case 2:
            trigger = TP.ac(anOrigin, aSignal);
            break;
        default:
            return this.raise('InvalidParameter');
    }

    triggers = this.getTriggers();
    triggers.push(trigger);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Triggered.Inst.defineMethod('addTriggers',
function(originSignalPairs) {

    /**
     * @method addTriggers
     * @summary Stores a set of trigger definitions (list of ordered pairs with
     *     origin and signal) as part of the receiver's set of triggers.
     * @param {String[][]} originSignalPairs
     * @returns {TP.core.Triggered} The receiver.
     */

    var thisref;

    thisref = this;

    if (TP.notEmpty(originSignalPairs)) {
        originSignalPairs.forEach(
                            function(pair) {
                                thisref.addTrigger.apply(thisref, pair);
                            });
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Triggered.Inst.defineMethod('getTriggers',
function() {

    /**
     * @method getTriggers
     * @summary Returns one or more trigger signals for the TIBET signaling
     *     system which should cause the receiver to respond to triggers.
     * @returns {Array<Object,Object|String>} An array of origin/signal ordered
     *     pairs.
     */

    var triggers;

    if (TP.notValid(triggers = this.$get('triggers'))) {

        triggers = this.getType().get('triggers');

        if (TP.notValid(triggers)) {
            triggers = TP.ac();
            this.$set('triggers', triggers);
        } else {
            //  Make a copy, we don't want to alter our type's list.
            triggers = TP.copy(triggers);
            this.$set('triggers', triggers);
        }
    }

    return triggers;
});

//  ------------------------------------------------------------------------

TP.core.Triggered.Inst.defineMethod('ignoreTriggers',
function() {

    /**
     * @method ignoreTriggers
     * @summary Turns off registration (ignores) the receivers triggers.
     * @returns {TP.core.Triggered} The receiver.
     */

    var triggers,
        thisref;

    triggers = this.getTriggers();

    thisref = this;

    triggers.forEach(
                function(pair) {
                    thisref.ignore(pair.first(), pair.last());
                });

    return this;
});


//  ------------------------------------------------------------------------

TP.core.Triggered.Inst.defineMethod('observeTriggers',
function() {

    /**
     * @method observeTriggers
     * @summary Tells the receiver to observe its trigger signals so it can
     *     begin to respond to them.
     * @returns {TP.core.Triggered} The receiver.
     */

    var triggers,
        thisref;

    triggers = this.getTriggers();

    thisref = this;

    triggers.forEach(
                function(pair) {
                    thisref.observe(pair.first(), pair.last());
                });

    return this;
});

//  ========================================================================
//  TP.core.Resource
//  ========================================================================

/**
 * @type {TP.core.Resource}
 * @summary Root type for TIBET resources.
 * @description In a strict workflow sense resources are elements which can
 *     perform tasks. Using that definition, specific resource types would
 *     include people and machines. In TIBET we model people as 'users' (note
 *     that each person may well have more than one login/username they use). We
 *     model machines as a collection of services. Each of these resources
 *     (TP.core.User or TP.core.Service) has the ability to respond to requests
 *     of various types and, in fact, there are times when they can stand in for
 *     each other.
 *
 *     To integrate the concept/requirement for permission-based resource
 *     allocation TIBET assigns TP.core.Role and TP.core.Unit objects to users
 *     and services, providing them with both permissions via the role and unit
 *     keyrings, and functionality through the various methods implemented on
 *     those roles and units.
 *
 *     When a resource is asked to handle a request it will first look locally
 *     for a viable method, but it will then defer to its roles and units (in
 *     that order) to see if there's a viable handler. This allows you to
 *     organize functionality around roles and units and then associate it with
 *     the current user via that user's assigned roles and units.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.Resource');

//  add sync and async mode support along with necessary constants.
TP.core.Resource.addTraits(TP.core.SyncAsync);
TP.core.Resource.addTraits(TP.core.Triggered);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  keep a hash of all resource instances, by ID. this helps to ensure
//  we only construct one of each resource ID.
TP.core.Resource.Type.defineAttribute('instances', TP.hc());

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.Resource.Type.defineMethod('addResource',
function(aResource) {

    /**
     * @method addResource
     * @summary Adds a new resource instance to the global resource hash.
     * @param {TP.core.Resource} aResource The resource to add.
     */

    if (TP.notValid(aResource)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    if (this.getResourceById(aResource.get('resourceID'))) {
        return this.raise('TP.sig.NonUniqueID');
    }

    return this.get('instances').atPut(
                                aResource.get('resourceID'), aResource);
});

//  ------------------------------------------------------------------------

TP.core.Resource.Type.defineMethod('construct',
function(resourceID) {

    /**
     * @method construct
     * @summary Constructs a new instance of the receiver. If the resourceID
     *     provided is a duplicate an exception is thrown.
     * @param {TP.core.Resource} resourceID The resource ID for the new resource
     *     being constructed.
     * @exception TP.sig.NonUniqueID
     */

    var inst;

    //  no id means no resource instance
    if (TP.notValid(resourceID)) {
        return this.raise('TP.sig.InvalidResourceID');
    }

    if (TP.isValid(inst = TP.core.Resource.getResourceById(resourceID))) {
        return inst;
    }

    //  id looks unique? go ahead and process the request normally.
    inst = this.callNextMethod();

    //  note that this may actually be invoked multiple times, but only
    //  during the construct process itself so we still avoid ever putting a
    //  duplicate resource in
    if (TP.isValid(inst)) {
        this.get('instances').atPut(resourceID, inst);
    }

    return inst;
});

//  ------------------------------------------------------------------------

TP.core.Resource.Type.defineMethod('getResourceById',
function(anID) {

    /**
     * @method getResourceById
     * @summary Returns the resource instance with the given ID.
     * @param {String} anID The resource ID to look up.
     * @returns {TP.core.Resource}
     */

    return this.get('instances').at(anID);
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  has the resource registered for requests yet? registration isn't
//  strictly required except for signal-based invocation
TP.core.Resource.Inst.defineAttribute('registered', false);

//  Current access keys, which are essentially cached from the current vcard
//  and updated if the vcard data for the resource is altered.
TP.core.Resource.Inst.defineAttribute('accessKeys');

//  the current vcard associated with this resource, and indirectly the
//  resulting role and unit types
TP.core.Resource.Inst.defineAttribute('vcard');

//  Resource parameters that have default values. These are checked during
//  parameter population.
TP.core.Resource.Type.defineAttribute('defaultedParameters');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.Resource.Inst.defineMethod('init',
function(resourceID) {

    /**
     * @method init
     * @summary Initializes a new instance of the receiver.
     * @param {String} resourceID A unique TIBET identifier. By unique we mean
     *     an ID which will not conflict with any other ID registered using
     *     TIBET's object registration methods.
     * @exception TP.sig.InvalidResourceID
     * @returns {TP.core.Resource} A new instance.
     */

    //  construct the instance from the root down
    this.callNextMethod();

    //  our public name is our resource ID
    this.setID(resourceID);

    //  try to locate a matching vcard

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Resource.Inst.defineMethod('acceptRequest',
function(aRequest) {

    /**
     * @method acceptRequest
     * @summary Does the work necessary to ensure that the receiver and the
     *     request are properly associated via responder links etc.
     * @param {TP.sig.Request} aRequest The request to accept.
     * @returns {TP.core.Resource} The receiver.
     */

    //  make sure the request can get back to us as the resource which
    //  responded to the request
    aRequest.set('responder', this);

    //  set the request's status code so we keep observers informed
    aRequest.isActive(true);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Resource.Inst.defineMethod('getAccessKeys',
function() {

    /**
     * @method getAccessKeys
     * @summary Returns the receiver's permission keys, based on any vcard that
     *     may have been assigned.
     * @returns {TP.core.Hash} The receiver's permission keys.
     */

    var keys,
        vcard;

    keys = this.$get('accessKeys');
    if (TP.isValid(keys)) {
        return keys;
    }

    if (TP.isValid(vcard = this.getVcard())) {
        keys = vcard.getAccessKeys();
    } else {
        keys = TP.ac();
    }

    this.$set('accessKeys', keys);

    return keys;
});

//  ------------------------------------------------------------------------

TP.core.Resource.Inst.defineMethod('getPrimaryRole',
function() {

    /**
     * @method getPrimaryRole
     * @summary Returns the primary role, the first role in the receiver's
     *     vcard, if any.
     * @description Note the ordering here. Unlike unit assignments which
     *     typically go from least specific to most specific the presumption
     *     here is that the user's roles are defined in order from most-specific
     *     to least-specific (or at least to "least important") so the first
     *     role is considered to be the primary role.
     * @returns {TP.core.Role|undefined} A subtype of TP.core.Role.
     */

    var vcard;

    if (TP.isValid(vcard = this.getVcard())) {
        return vcard.getRoles().first();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.core.Resource.Inst.defineMethod('getPrimaryUnit',
function() {

    /**
     * @method getPrimaryUnit
     * @summary Returns the primary unit, the _last_ unit in the receiver's
     *     vcard, if any.
     * @description Note the subtle distinction here. Units are normally defined
     *     in hierarchy order, so the first unit is actually the least specific
     *     one. For that reason we return the last unit in line as the primary
     *     (most-specific) unit.
     * @returns {TP.core.Unit|undefined} A subtype of TP.core.Unit.
     */

    var vcard;

    if (TP.isValid(vcard = this.getVcard())) {
        return vcard.getUnits().last();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.core.Resource.Inst.defineMethod('getResourceID',
function() {

    /**
     * @method getResourceID
     * @summary Returns the unique resource identifier for the receiver.
     * @returns {String}
     */

    return this.getID();
});

//  ------------------------------------------------------------------------

TP.core.Resource.Inst.defineMethod('getRoles',
function() {

    /**
     * @method getRoles
     * @summary Returns the list of roles in the receiver's vcard, if any.
     * @returns {TP.core.Role[]} An array of TP.core.Role instances.
     */

    var vcard;

    if (TP.isValid(vcard = this.getVcard())) {
        return vcard.getRoles();
    }

    return TP.ac();
});

//  ------------------------------------------------------------------------

TP.core.Resource.Inst.defineMethod('getUnits',
function() {

    /**
     * @method getUnits
     * @summary Returns the list of units in the receiver's vcard, if any.
     * @returns {TP.core.Unit[]} An array of TP.core.Unit instances.
     */

    var vcard;

    if (TP.isValid(vcard = this.getVcard())) {
        return vcard.getUnits();
    }

    return TP.ac();
});

//  ------------------------------------------------------------------------

TP.core.Resource.Inst.defineMethod('getVcard',
function() {

    /**
     * @method getVcard
     * @summary Returns the receiver's vcard, if one has been set.
     * @returns {TP.ietf.vcard} A TIBET vcard wrapper element.
     */

    return this.$get('vcard');
});

//  ------------------------------------------------------------------------

TP.core.Resource.Inst.defineMethod('handle',
function(aSignal) {

    /**
     * @method handle
     * @summary Handles notification of an incoming signal.
     * @description For TP.core.Resources this method provides the same lookup
     *     semantics as a normal TIBET object, but checks specifically for
     *     TP.sig.Request and TP.sig.Response objects to keep things moving as
     *     quickly as possible with respect to processing requests and
     *     responses.
     * @param {TP.sig.Signal} aSignal The specific signal to handle.
     * @returns {Object|undefined} The handler function's results.
     */

    var request,
        handler;

    //  not a request, defer to standard lookup semantics
    if (!TP.isKindOf(aSignal, 'TP.sig.Request')) {
        return this.callNextMethod();
    }

    request = aSignal;

    //  if the request is already being worked by another responder then we
    //  don't want to work on it twice
    if (request.isActive() || request.isCompleted()) {
        return;
    }

    //  if we can't handle the request let it go by and hope another
    //  resource picks it up and handles it
    if (!this.isAvailable(request)) {
        return;
    }

    //  look up a handler, forcing lookup to find only handlers that
    //  properly match custom signal name overrides
    handler = this.getBestHandler(
        request,
        {
            startSignal: null,
            dontTraverseSpoofs: true
        });

    if (TP.isCallable(handler)) {
        try {
            this.acceptRequest(request);

            return handler.apply(this, arguments);
        } catch (e) {
            TP.ifError() ?
                TP.error(TP.ec(e, 'Error in handler: ' + TP.str(handler))) : 0;

            return;
        }
    }

    return TP.NOT_FOUND;
});

//  ------------------------------------------------------------------------

TP.core.Resource.Inst.defineHandler('Request',
function(aRequest) {

    /**
     * @method handleRequest
     * @summary Default request-type handling method. Intended to be overridden
     *     in specific resource subtypes, or to have a more specific handler
     *     catching requests before they reach this default handler.
     * @description When a handle call is received the search for a handler
     *     proceeds through the type hierarchy of the request and terminates at
     *     handleRequest. This implementation raises a MissingOverride
     *     Exception.
     * @param {TP.sig.Request} aRequest The request to be serviced.
     * @returns {TP.sig.Response}
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.core.Resource.Inst.defineMethod('hasAccessKey',
function(aKey) {

    /**
     * @method hasAccessKey
     * @summary Returns true if the receiver has the access key provided by
     *     virtue of their current vcard assignment.
     * @param {String} aKey The access key to check for.
     * @returns {Boolean} True if the receiver's vcard data includes the key
     *     provided.
     */

    return this.getAccessKeys().contains(aKey);
});

//  ------------------------------------------------------------------------

TP.core.Resource.Inst.defineMethod('isAvailable',
function(aRequest) {

    /**
     * @method isAvailable
     * @summary Returns true if the receiver is available to service the
     *     request provided.
     * @param {TP.sig.Request} aRequest The request to be serviced.
     * @returns {Boolean}
     */

    var sync;

    sync = aRequest.isSynchronous(this);

    if (sync && this.getType().isAsyncOnly()) {
        return false;
    }

    if (!sync && this.getType().isSyncOnly()) {
        return false;
    }

    //  check whether we a) are the specified target, b) are runnable based
    //  on any prerequisite requirements etc.
    return this.isTargeted(aRequest) && this.isEnabled(aRequest);
});

//  ------------------------------------------------------------------------

TP.core.Resource.Inst.defineMethod('isEnabled',
function(aRequest) {

    /**
     * @method isEnabled
     * @summary Returns a boolean defining whether the receiver is runnable. If
     *     the receiver has prerequisites this would be where testing for them
     *     would be appropriate.
     * @param {TP.sig.Request} aRequest The request to be serviced.
     * @returns {Boolean}
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.core.Resource.Inst.defineMethod('isRegistered',
function(aFlag) {

    /**
     * @method isRegistered
     * @summary Returns a boolean defining whether the receiver has registered
     *     to observe its triggers. Resources only need to register if they are
     *     going to be triggered by signals rather than by direct invocation.
     * @param {Boolean} aFlag A new value for this property. Optional.
     * @returns {Boolean}
     */

    if (TP.isBoolean(aFlag)) {
        this.$set('registered', aFlag);
    }

    return this.$get('registered');
});

//  ------------------------------------------------------------------------

TP.core.Resource.Inst.defineMethod('isTargeted',
function(aRequest) {

    /**
     * @method isTargeted
     * @summary Returns a boolean defining whether the receiver matches the
     *     target resourceID of the request. Not all requests target a specific
     *     ID and if they don't this call will return true.
     * @param {TP.sig.Request} aRequest The request to be serviced.
     * @returns {Boolean}
     */

    var resID;

    //  requests can target a specific resource ID. if this one does and we
    //  don't match that ID then return 'no'.
    if (TP.isValid(resID = aRequest.get('resourceID'))) {
        if (this.get('resourceID') !== resID) {
            return false;
        }
    }

    return true;
});

//  ------------------------------------------------------------------------

TP.core.Resource.Inst.defineMethod('populateMissingVCardData',
function(aParamInfo, aRequest) {

    /**
     * @method populateMissingVCardData
     * @summary Populates any missing parameters in the request from the
     *     receiver's vcard.
     * @description This method uses the information in the supplied 'parameter
     *     info' to perform this process. This hash has the following format:
     *
     *     TP.hc('<name_of_param>', TP.ac('<vcard_name>', <prompt_message>'));
     *
     *
     * @param {TP.core.Hash} aParamInfo A parameter info hash that contains
     *     information on how to populate the request from the vcard.
     * @param {TP.sig.Request} aRequest The request to populate.
     * @returns {TP.core.Resource} The receiver.
     */

    var sourceCard,
        defaults,

        currentUser,
        credentials,
        resourceID,

        saveCredentials;

    if (TP.notValid(sourceCard = this.getVcard()) &&
        TP.notValid(aParamInfo)) {
        return this;
    }

    defaults = this.getType().get('defaultedParameters');
    if (TP.notValid(defaults)) {
        defaults = TP.hc();
    }

    //  Grab our current user - we may need it later
    currentUser = TP.sys.getEffectiveUser();

    //  Our resource ID is our ID
    resourceID = this.getID();

    //  Initially, we don't need to save any credentials
    saveCredentials = false;

    //  Loop over the param info.
    aParamInfo.perform(
        function(kvPair) {

            var paramName,

                vcardPropName,
                promptText,
                isRequired,

                paramValue;

            //  The name of the parameter to populate on the request will be the
            //  key of the parameter info entry.
            paramName = kvPair.first();

            //  If that parameter is not also defined on the request, go ahead
            //  and try to populate it.
            if (TP.notValid(aRequest.at(paramName))) {
                //  First, we check to see if it is in our list of 'defaulted
                //  parameters'. If so, use that value.
                if (TP.notEmpty(paramValue = defaults.at(paramName))) {
                    aRequest.atPut(paramName, paramValue);

                    return;
                }

                //  The vcard property name is in the first position of the
                //  value Array
                vcardPropName = kvPair.last().at(0);

                //  The text to prompt the user with is in the second position
                //  of the value Array
                promptText = kvPair.last().at(1);

                isRequired = kvPair.last().at(2);

                //  If an entry was found on the vcard, use it as the value.
                if (TP.isValid(sourceCard) &&
                    TP.notEmpty(paramValue = sourceCard.get(vcardPropName))) {
                    //  If the parameter value is '{USER}', then the user object
                    //  should be queried for credentials matching this resource
                    //  and the value looked for there.
                    if (paramValue === '{USER}') {
                        //  Ask the user for credentials for ourself (as the
                        //  resource)
                        credentials = currentUser.getCredentialsFor(resourceID);

                        //  If there is no value for the property we're looking
                        //  for in the credentials, then prompt the user for it,
                        //  put that value in the credentials and make sure that
                        //  we flip the 'saveCredentials' flag to true.
                        if (TP.isEmpty(paramValue = credentials.at(
                                        vcardPropName))) {
                            if (TP.isEmpty(paramValue =
                                            prompt(promptText))) {
                                paramValue = TP.isFalse(isRequired) ?
                                                TP.NULL : null;
                            }

                            credentials.atPut(vcardPropName, paramValue);
                            saveCredentials = true;
                        }
                    } else if (paramValue === '{PROMPT}') {
                        //  Otherwise, if the parameter value is '{PROMPT}',
                        //  then we prompt the user for it but *DO NOT* store it
                        //  in the credentials database.
                        paramValue = prompt(promptText);
                    }
                } else {
                    //  Otherwise, ask the user for credentials for ourself (as
                    //  the resource)
                    credentials = currentUser.getCredentialsFor(resourceID);

                    //  If there is no value for the property we're looking for
                    //  in the credentials, then prompt the user for it, put
                    //  that value in the credentials and make sure that we flip
                    //  the 'saveCredentials' flag to true.
                    if (TP.isEmpty(paramValue =
                                    credentials.at(vcardPropName))) {
                        if (TP.isEmpty(paramValue =
                                        prompt(promptText))) {
                            paramValue = TP.isFalse(isRequired) ?
                                            TP.NULL : null;
                        }

                        credentials.atPut(vcardPropName, paramValue);
                        saveCredentials = true;
                    }
                }
            }

            if (TP.isValid(paramValue)) {
                aRequest.atPut(paramName, paramValue);
            }
        });

    //  We must've modified the credential store above - tell the user object to
    //  save them to the credentials store.
    if (saveCredentials) {
        currentUser.saveCredentials();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Resource.Inst.defineMethod('register',
function() {

    /**
     * @method register
     * @summary Registers the receiver and observes its trigger signals so that
     *     requests will cause activation of the service.
     * @returns {TP.core.Resource} The receiver.
     */

    TP.sys.registerObject(this);

    this.observeTriggers();

    this.isRegistered(true);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Resource.Inst.defineMethod('setVCard',
function(aVCard) {

    /**
     * @method setVCard
     * @summary Sets the VCard description for the resource.
     * @param {TP.ietf.vcard} aVCard The vcard description for the
     *     resource.
     * @returns {TP.core.Resource} The receiver.
     */

    this.$set('vcard', aVCard);

    //  Clear the access key cache. It will be refreshed if the getAccessKeys
    //  call is made again.
    this.$set('accessKeys', null);

    //  altering the vcard may alter role and unit which affect uri filters
    TP.sys.setcfg('tibet.uriprofile', null);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Resource.Inst.defineMethod('unregister',
function() {

    /**
     * @method unregister
     * @summary Turns off registration (ignores) the receivers triggers.
     * @returns {TP.core.Resource} The receiver.
     */

    TP.sys.unregisterObject(this);

    this.ignoreTriggers();

    this.isRegistered(false);

    return this;
});

//  ========================================================================
//  TP.sig.WorkflowSignal
//  ========================================================================

/**
 * @type {TP.sig.WorkflowSignal}
 * @summary Top level workflow signal type.
 * @description The TP.sig.WorkflowSignal type is a root signal type for
 *     workflow request/response signal types such as TP.sig.Request and
 *     TP.sig.Response.
 */

//  ------------------------------------------------------------------------

TP.sig.Signal.defineSubtype('WorkflowSignal');

//  add job status behavior to the receiver so we can track progress. this
//  adds methods such as fail, complete, etc.
TP.sig.WorkflowSignal.addTraits(TP.core.JobStatus);

TP.sig.WorkflowSignal.Type.resolveTrait('getSignalName', TP.sig.Signal);

TP.sig.WorkflowSignal.Inst.resolveTrait('resume', TP.core.JobStatus);

TP.sig.WorkflowSignal.Inst.resolveTraits(
        TP.ac('asDumpString', 'asHTMLString', 'asJSONSource', 'asPrettyString',
                'asRecursionString', 'asSource', 'asString', 'asXMLString',
                'at', 'atPut', 'copy', 'getProperty', 'getSignalName', 'init',
                'isRecyclable', 'recycle', 'removeKey'),
        TP.sig.Signal);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.sig.WorkflowSignal.Type.defineAttribute('defaultPolicy',
                                            TP.INHERITANCE_FIRING);

//  WorkflowSignals should traverse the controller chain...but not
//  WorkflowSignal itself. NOTE that being a controller signal is inherited but
//  acting as the root is a LOCAL assignment so it's not inherited.
TP.sig.WorkflowSignal.Type.isControllerSignal(true);
TP.sig.WorkflowSignal.isControllerRoot(true);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.sig.WorkflowSignal.Type.defineMethod('defineSubtype',
function() {

    /**
     * @method defineSubtype
     * @summary Creates a new subtype. This particular override ensures that all
     *     direct subtypes of TP.sig.WorkflowSignal serve as signaling roots,
     *     meaning that you never signal a raw TP.sig.WorkflowSignal.
     * @returns {TP.sig.Signal} A new signal-derived type object.
     */

    var type;

    type = this.callNextMethod();

    if (this === TP.sig.WorkflowSignal) {
        type.isSignalingRoot(true);
    }

    return type;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.WorkflowSignal.Inst.defineMethod('fire',
function(anOrigin, aPayload, aPolicy) {

    /**
     * @method fire
     * @summary Fires the signal so that registered observers are notified.
     * @description For TP.sig.WorkflowSignals and their subtypes the firing
     *     policy is TP.INHERITANCE_FIRING meaning that observers of any form of
     *     TP.sig.WorkflowSignal are notified. Also, the origin is typically the
     *     request ID for the signal's associated request so that "processes"
     *     can be constructed using the request ID as the common reference.
     * @param {Object} anOrigin An optional firing origin for this activation.
     *     Defaults to the receiver's request ID.
     * @param {Object} aPayload Optional arguments.
     * @param {Function} aPolicy A firing policy. The default is INHERITANCE.
     * @returns {TP.sig.WorkflowSignal} The receiver.
     */

    var origin,
        policy;

    //  NOTE that we don't want to callNextMethod in this implementation
    //  since it will actually signal...and we need to control that
    //  ourselves here

    //  allow refiring. initial handling will turn off propagation so we
    //  need to re-enable it to reuse the signal
    this.stopPropagation(false);

    //  also, we don't want to preventDefault unless told to do so
    //  explicitly by one of our handlers
    this.preventDefault(false);

    //  workflow signals always use a request ID as their origin so that
    //  they can tie together "processes" which are embodied as signal
    //  chains related to an originating request, unless explicitly altered
    origin = anOrigin;
    if (TP.notValid(origin)) {
        origin = this.getRequestID();
    }
    this.setOrigin(origin);

    //  workflow signals are fired using an inheritance-based signal model
    //  unless specifically told otherwise
    policy = aPolicy;
    if (TP.notValid(policy)) {
        policy = this.getType().getDefaultPolicy();
    }

    //  instrument with current firing time
    this.$set('time', Date.now());

    //  fire using the firing origin (defaults to this) so we target better
    TP.signal(origin, this, aPayload, policy);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.WorkflowSignal.Inst.defineMethod('getValue',
function() {

    /**
     * @method getValue
     * @summary Returns the receiving signal's value, typically the 'result'
     *     data from either then request and/or response.
     * @returns {Object}
     */

    return this.get('result');
});

//  ========================================================================
//  Additional workflow signal types.
//  ========================================================================

TP.sig.WorkflowSignal.defineSubtype('WillRun');
TP.sig.WorkflowSignal.defineSubtype('DidRun');

//  ========================================================================
//  TP.sig.Request
//  ========================================================================

/**
 * @type {TP.sig.Request}
 * @summary TIBET's main workflow request signal type. This type most closely
 *     relates to a 'work item' in a formal workflow model by binding a 'case'
 *     (the payload/args data) to a task (a set of one or more steps for
 *     processing a case -- i.e. the handler logic of the responding resource
 *     and the request type itself.
 * @description In workflow systems the binding between a particular 'case' and
 *     a particular 'task' is a 'work item'. In TIBET the tasks can be thought
 *     of as the specific handlers implemented by resource objects while the
 *     'case' is represented by the data contained within request signals, also
 *     known as the request's payload.
 *
 *     Creating a TP.sig.Request is therefore analogous to creating a work item
 *     which must then be allocated to a resource for processing.
 *
 *     TIBET's allocation scheme isn't as formal as most workflow systems.
 *     Instead TIBET uses a combination of subscription via observe and
 *     presence/acceptance (via isAvailable) to push work to the various
 *     resources which might be able to respond.
 *
 *     The TP.sig.Request signal type provides support for making and tracking
 *     a particular request throughout its lifecycle. All information about the
 *     request, the responder, and the response reside with this object.
 *
 *     When a request's response is being prepared by the lower-level
 *     services/resources the various TP.core.JobStatus methods fail, cancel,
 *     and complete are used to finalize the request and signal that it is
 *     complete (regardless of its success/failure state).
 */

//  ------------------------------------------------------------------------

TP.sig.WorkflowSignal.defineSubtype('Request');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  this type's response type, the type that will be created in response to
//  a getResponse message. this is typically redefined in subtypes so
//  that custom response manipulation logic can be implemented efficiently
TP.sig.Request.Type.defineAttribute('responseType', 'TP.sig.Response');

//  a template for the request, normally empty but subtypes can prebuild
//  reusable payload templates if desired
TP.sig.Request.Type.defineAttribute('requestTemplate');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.definePrimitive('request',
function(varargs) {

    /**
     * @method request
     * @summary Constructs a standard TP.sig.Request populated differently
     *     depending on the nature of the argument list.
     * @description When no arguments are given this is a synonym for
     *     TP.sig.Request.construct(), when a single argument is given if it's a
     *     TP.sig.Signal of any kind then the signal's payload becomes the
     *     request's payload, otherwise the object itself becomes the request
     *     payload. When multiple arguments are given they are passed to TP.hc()
     *     and the resulting hash becomes the request's payload.
     * @param {arguments} varargs One or more objects to place in the request. The
     *     format is similar to that used by TP.hc() with alternating keys and
     *     values.
     * @returns {TP.sig.Request} A request whose payload is a hash containing
     *     the parameter values provided.
     */

    switch (arguments.length) {
        case 0:
            return TP.sig.Request.construct();

        case 1:
            if (TP.isKindOf(varargs, 'TP.sig.Request')) {
                return varargs;
            } else if (TP.canInvoke(varargs, 'getPayload')) {
                return TP.sig.Request.construct(varargs.getPayload());
            } else {
                return TP.sig.Request.construct(varargs);
            }

        default:
            return TP.sig.Request.construct(TP.hc.apply(null, arguments));
    }
});

//  ------------------------------------------------------------------------

TP.sig.Request.Type.defineMethod('getWrapupMethodName',
function(aState) {

    /**
     * @method getWrapupMethodName
     * @summary Returns the proper method name to invoke during wrapup depending
     *      on the state name provided.
     * @param {String} aState The state (TP.FAILED, TP.CANCELLED, etc).
     * @returns {String|undefined} The method name such as 'cancel' or 'fail'.
     */

    switch (aState) {
        case TP.CANCELLED:
            return 'cancel';
        case TP.ERRORED:
            return 'error';
        case TP.FAILED:
            return 'fail';
        default:
            return 'cancel';
    }
});

//  ------------------------------------------------------------------------

TP.sig.Request.Type.defineMethod('isSynchronous',
function() {

    /**
     * @method isSynchronous
     * @summary Returns true if the instances of the receiver can support
     *     synchronous operation. This method is called from the instance-level
     *     'isSynchronous' method if a mode cannot be determined from the
     *     request instance or from the resource it is being fired against.
     * @returns {Boolean}
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Type.defineMethod('shouldLog',
function() {

    /**
     * @method shouldLog
     * @summary Returns whether or not this request should be logged. The
     *     default at this level is to return whether TIBET is logging request
     *     signals in general.
     * @returns {Boolean} Whether or not this signal will be logged.
     */

    return TP.sys.shouldLogRequestSignals();
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  NOTE: the request parameters themselves are contained in the payload

//  when using "targeted" requests this will hold the ID of the resource
//  being requested. If present, a resourceID should refer to a registered
//  TP.core.Resource such as a named TP.core.Service. Normally this is empty
//  so that the request can be handled by any resource instance that's
//  capable and available for processing
TP.sig.Request.Inst.defineAttribute('resourceID');

//  the 'who' in the request. this is the object that is responsible for
//  creating the request in the first place, but is an optional value. When
//  a request is complete its requestor is notified if that object isn't the
//  rqeuest itself
TP.sig.Request.Inst.defineAttribute('requestor');

//  the object/resource which ultimately responds to the request. this is
//  typically a TP.core.Resource of some type, usually a TP.core.Service
//  instance.
TP.sig.Request.Inst.defineAttribute('responder');

//  the associated response object for this request, typically a subtype of
//  TP.sig.Response, which may have had its response name configured to help
//  differentiate handler dispatch
TP.sig.Request.Inst.defineAttribute('response');

//  the specific signal name to use when signaling a response is ready.
//  used to differentiate responses without having to create custom response
//  types or when communicating to the resource or low-level service which
//  "callback channel" to use
TP.sig.Request.Inst.defineAttribute('responseName');

//  the status code, used to define current state of the request.
//  NOTE NOTE NOTE that we define this attribute only on TP.sig.Request, not
//  on TP.sig.WorkflowSignal so that TP.sig.Response instances defer to
//  their request.
TP.sig.Request.Inst.defineAttribute('statusCode', TP.READY);

//  the fault/failure code, used to provide information on a request failure
//  NOTE NOTE NOTE that we define this attribute only on TP.sig.Request, not
//  on TP.sig.WorkflowSignal so that TP.sig.Response instances defer to
//  their request.
TP.sig.Request.Inst.defineAttribute('faultCode', null);

//  the fault/failure message, providing a textual message about a failure.
TP.sig.Request.Inst.defineAttribute('faultText');

//  the fault/failure info, providing additional information about a failure.
TP.sig.Request.Inst.defineAttribute('faultInfo');

//  if the current signal is part of a thread of messages the threadID
//  should be set to the requestID of the initial (root) signal.
TP.sig.Request.Inst.defineAttribute('threadID');

//  optional hash of child requests used for simple workflow configurations
TP.sig.Request.Inst.defineAttribute('childJoins');

//  optional hash of parent requests used for simple workflow configurations
TP.sig.Request.Inst.defineAttribute('parentJoins');

//  optional hash of peer requests used for simple workflow configurations
TP.sig.Request.Inst.defineAttribute('peerJoins');

//  resolver and rejector for an optional deferred Promise used for 'then'
//  ('Promises/A+' compatible) chaining
TP.sig.Request.Inst.defineAttribute('$deferredPromiseResolver');
TP.sig.Request.Inst.defineAttribute('$deferredPromiseRejector');

/**
 * Whether this request has been logged. Normally not used but if errors occur
 * during the request this slot is used to avoid logging multiple times.
 * @type {Boolean}
 */
TP.sig.Request.Inst.defineAttribute('logged');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('init',
function(aRequest, aResourceID, aThreadID) {

    /**
     * @method init
     * @summary Initialize a new request. Each request is composed of a request
     *     payload (usually a hash), and optional resourceID and threadID
     *     elements. The resourceID allows a request to target a particular
     *     resource while the threadID allows the request to be associated with
     *     an ongoing request/response 'conversation' between parties. When
     *     creating the instance TP.sig.Request will use any type-specific
     *     requestTemplate and merge it with any incoming request information.
     * @param {TP.core.Hash} aRequest An object containing specific request
     *     parameters which will by used by the request's responder to process
     *     the request. NOTE that this takes the same parameter slot as the root
     *     payload for TP.sig.Signal. This should be specific to the signal
     *     type.
     * @param {String} aResourceID A unique resource identifier.
     * @param {String} aThreadID A unique thread identifier.
     * @returns {TP.sig.Request} A new instance.
     */

    var request;

    //  assign the variables we can process without any extra effort
    this.$set('resourceID', aResourceID);
    this.$set('threadID', aThreadID);

    //  generate a viable request object using any template for this type
    request = this.$initTemplate(aRequest);

    //  note that we pass the 'request' up so it ends up in the payload
    //  since TP.sig.Requests are ultimately TP.sig.Signals
    //  (TP.sig.WorkflowSignals)
    return this.callNextMethod(request);
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('$initTemplate',
function(aRequest) {

    /**
     * @method $initTemplate
     * @summary Generates and returns a viable request payload from the
     *     incoming payload object and any local template for the receiver. When
     *     both a template and a request are provided the keys in the template
     *     missing in the request are merged to fill in those default values.
     * @param {TP.core.Hash} aRequest An object containing parameters for the
     *     request.
     * @param {A} TP.core.Hash viable payload object. NOTE that when no request
     *     or template exist the return value is NULL so no payload is implied
     *     for the call.
     */

    var template,
        request,
        keys,
        len,
        i,
        key;

    template = this.getType().get('requestTemplate');

    if (TP.notValid(aRequest)) {
        if (TP.isValid(template)) {
            request = template.copy();
        } else {
            request = TP.hc();
        }
    } else if (TP.isKindOf(aRequest, TP.sig.Request)) {
        request = TP.copy(aRequest.getPayload());
    } else if (TP.isHash(aRequest)) {
        request = aRequest;
    } else {
        request = TP.hc(aRequest);
    }

    //  merge keys found in the template into the request, but don't
    //  overwrite existing keys
    if (TP.isValid(template)) {
        keys = TP.keys(template);
        len = keys.getSize();
        for (i = 0; i < len; i++) {
            key = keys.at(i);
            if (TP.notDefined(request.at(key))) {
                request.atPut(key, template.at(key));
            }
        }
    }

    //  map handle* "methods" in the payload into the receiver
    if (TP.canInvokeInterface(request, TP.ac('at', 'getKeys'))) {
        keys = TP.keys(request);
        len = keys.getSize();
        for (i = 0; i < len; i++) {
            key = keys.at(i);
            if (TP.regex.HANDLER_NAME.test(key)) {
                this.defineMethod(key,
                    request.at(key),
                    null, null, true);
            }
        }
    }

    return request;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('asQueryString',
function() {

    /**
     * @method asQueryString
     * @summary Returns the receiver's "query string" content, the parameters
     *     which make up the query portion of an HTTP URI.
     * @returns {String} The query string, or an empty string.
     */

    var query;

    query = this.at('uriparams');

    return TP.isValid(query) ? query.asQueryString() : '';
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('configureSTDIO',
function(aRequest) {

    /**
     * @method configureSTDIO
     * @summary Maps STDIO functions and content from one request to another so
     *     the subrequest/peer can leverage the IO channels of the original
     *     request.
     * @param {TP.sig.Request} aRequest The object to map IO from.
     * @returns {TP.sig.Request} The receiver.
     */

    var obj;

    if (TP.isValid(aRequest)) {
        if (TP.isValid(obj = aRequest.at(TP.STDIO))) {
            this.atPut(TP.STDIO, obj);
        }

        if (TP.isValid(obj = aRequest.at(TP.STDIN))) {
            this.atPut(TP.STDIN, obj);
        }
        this.stdin = aRequest.stdin ? aRequest.stdin : this.stdin;

        if (TP.isValid(obj = aRequest.at(TP.STDOUT))) {
            this.atPut(TP.STDOUT, obj);
        }
        this.stdout = aRequest.stdout ? aRequest.stdout : this.stdout;

        if (TP.isValid(obj = aRequest.at(TP.STDERR))) {
            this.atPut(TP.STDERR, obj);
        }
        this.stderr = aRequest.stderr ? aRequest.stderr : this.stderr;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('fire',
function(anOrigin, aPayload, aPolicy) {

    /**
     * @method fire
     * @summary Fires the signal so that registered observers are notified.
     * @description For TP.sig.WorkflowSignal types the signaling origin is
     *     typically the request ID for the signal's associated request so that
     *     "processes" can be constructed using the request ID as the common
     *     reference.
     *     Note that, unlike it's supertype, this type returns it's *response*
     *     from this method.
     * @param {Object} anOrigin An optional firing origin for this activation.
     *     Defaults to the receiver's request ID.
     * @param {Object} aPayload Optional arguments.
     * @param {Function} aPolicy A firing policy. The default is INHERITANCE.
     * @returns {TP.sig.Response} The receiver's response.
     */

    //  If we're not done processing we shouldn't clear things like status,
    //  response, deferred, etc.
    if (this.isActive()) {
        return this.raise('InvalidOperation');
    }

    //  clear any response we may have from a prior execution
    this.$set('response', null);

    //  if we had resolvers and rejectors for a deferred Promise, they should be
    //  cleared.
    this.$set('$deferredPromiseResolver', null);
    this.$set('$deferredPromiseRejector', null);

    //  clear status code back to original
    this.set('statusCode', TP.READY);

    //  clear failure/fault code/text/info back to original
    this.set('faultCode', null);
    this.set('faultText', null);
    this.set('faultInfo', null);

    this.callNextMethod();

    return this.getResponse();
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('getDelegate',
function() {

    /**
     * @method getDelegate
     * @summary Returns the receiver's delegate, the object used by the
     *     TP.delegate utility function when constructing delegation methods.
     *     For TP.sig.Request this is the request's response.
     * @returns {Object} The receiver's delegation object.
     */

    return this.getResponse();
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('getRequestID',
function() {

    /**
     * @method getRequestID
     * @summary Returns the request ID for this request. The request ID may be
     *     a standard OID, a URL, or whatever is appropriate for the type of
     *     request. The default is an OID. The important thing about a request
     *     ID is that they serve as origins for any response signals which are
     *     generated so they should be reasonably unique.
     * @returns {String} A request ID which can take any form.
     */

    return this.getID();
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('getRequestor',
function() {

    /**
     * @method getRequestor
     * @summary Returns the receiver's requestor, the object that is configured
     *     to receive notifications of results/callbacks. The request itself is
     *     the default requestor, meaning without some explicit setter the
     *     request is called back with results when any low-level processing is
     *     complete.
     * @returns {Object} The requestor, often the TP.sig.Request itself.
     */

    var obj;

    obj = this.$get('requestor');

    //  NOTE the defaulting behavior here, we want the request to be thought
    //  of as the requestor when there isn't an explicit one
    return TP.isValid(obj) ? obj : this;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('getResponder',
function() {

    /**
     * @method getResponder
     * @summary Returns the object which responded to this request. Only viable
     *     after the request has been activated.
     * @returns {Object}
     */

    return this.$get('responder');
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('getResponse',
function(aResult) {

    /**
     * @method getResponse
     * @summary The default method for getting a response instance for the
     *     request. This method is invoked automatically by services when
     *     building up responses to incoming requests. The returned instance is
     *     then updated with the result data and fired when ready.
     * @param {Object} aResult A result object.
     * @returns {TP.sig.Response}
     */

    var response,
        responseName;

    response = this.$get('response');

    //  don't allow a request to get more than one instance of response
    if (TP.isValid(response)) {
        if (TP.isDefined(aResult)) {
            response.set('result', aResult, null, true);
        }

        return response;
    }

    //  construct a new instance and hold on to it
    response = this.getResponseType().construct(this, aResult);
    this.$set('response', response, false);

    //  adjust the response instance built from our response type with the
    //  specific response name if they're different
    responseName = this.getResponseName();
    if (responseName !== response.getTypeName()) {
        response.setSignalName(responseName);
    }

    return response;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('getResponseName',
function() {

    /**
     * @method getResponseName
     * @summary Returns the response name for this request. The response name
     *     is the signal name that should be used when signaling a response.
     *     Normally this defaults to the type name of the response type, but you
     *     can alter it when you want to fine tune handler lookup without having
     *     to create new subtypes of TP.sig.Response.
     * @returns {String} The response signal name.
     */

    var name;

    name = this.$get('responseName');

    return TP.ifEmpty(name, this.getResponseType().getName());
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('getResponseType',
function() {

    /**
     * @method getResponseType
     * @summary Returns the type of response this request expects. By default
     *     this is TP.sig.Response but custom subtypes can be used to provide
     *     specific response processing.
     * @returns {TP.meta.sig.Response} A TP.sig.Response subtype type object.
     */

    var typename,
        type;

    //  value is taken from local instance backed up by the type
    typename = this.$get('responseType') ||
                this.getType().get('responseType');

    //  convert to a type if it was a string, loaded it as needed
    type = TP.sys.getTypeByName(typename);

    if (TP.notValid(type)) {
        TP.ifWarn() ?
            TP.warn('Unable to locate response type: ' + typename +
                    '. Defaulting to TP.sig.Response.') : 0;

        return TP.sig.Response;
    }

    return type;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('getResult',
function() {

    /**
     * @method getResult
     * @summary Returns the request result, the object returned as a result of
     *     processing the receiver's request.
     * @returns {Object|undefined}
     */

    var response;

    response = this.get('response');
    if (TP.canInvoke(response, 'getResult')) {
        return response.getResult();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('getResultNode',
function() {

    /**
     * @method getResultNode
     * @summary Returns the receiver's result in TP.dom.Node form if possible.
     *     When the result isn't valid XML this method returns null.
     * @returns {Node|undefined} A valid Node instance.
     */

    var response;

    response = this.get('response');
    if (TP.canInvoke(response, 'getResultNode')) {
        return response.getResultNode();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('getResultObject',
function() {

    /**
     * @method getResultObject
     * @summary Returns the receiver's result in object form.
     * @returns {Object|undefined}
     */

    var response;

    response = this.get('response');
    if (TP.canInvoke(response, 'getResultObject')) {
        return response.getResultObject();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('getResultText',
function() {

    /**
     * @method getResultText
     * @summary Returns the receiver's content in text (String) form.
     * @returns {String|undefined}
     */

    var response;

    response = this.get('response');
    if (TP.canInvoke(response, 'getResultText')) {
        return response.getResultText();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('getRootID',
function() {

    /**
     * @method getRootID
     * @summary Returns the root ID for this request, the ID of the receiver's
     *     rootRequest if any.
     * @returns {String} A request ID.
     */

    return this.getRootRequest().getID();
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('getRootRequest',
function() {

    /**
     * @method getRootRequest
     * @summary Returns the root request for the receiver, or the receiver if
     *     the receiver is the root request.
     * @returns {TP.sig.Request} The root request.
     */

    var root,
        result;

    /* eslint-disable */
    result = this;
    while (TP.isValid(root = result.at('rootRequest'))) {
        result = root;
    }
    /* eslint-enable */

    return TP.ifInvalid(result, this);
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('handle',
function(aSignal) {

    /**
     * @method handle
     * @summary The top-level signal hander for this type. To ensure proper
     *     response processing while allowing the default handleResponse method
     *     to be the override point we handle some response-specific
     *     housekeeping here. NOTE that it is still up to the individual
     *     response handling methods to fail, cancel, or complete the request.
     * @param {TP.sig.Signal} aSignal The signal to handle.
     * @returns {Object|undefined} The handler function's results.
     */

    var request,
        handler;

    //  not a response, defer to standard lookup semantics
    if (!TP.isKindOf(aSignal, 'TP.sig.Response')) {
        return this.callNextMethod();
    }

    //  the originating request will be the response signal's answer to
    //  getRequest. if that's not us then we shouldn't do anything
    request = aSignal.getRequest();
    if (TP.notValid(request) || request !== this) {
        return;
    }

    //  look up a handler, forcing lookup to find only handlers that
    //  properly match custom signal name overrides
    handler = this.getBestHandler(
        aSignal,
        {
            startSignal: null,
            dontTraverseSpoofs: true
        });

    if (TP.isCallable(handler)) {
        try {
            return handler.apply(this, arguments);
        } catch (e) {
            TP.ifError() ?
                TP.error(TP.ec(e, 'Error in handler: ' + TP.str(handler))) : 0;

            return;
        }
    }

    return TP.NOT_FOUND;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineHandler('Response',
function(aSignal) {

    /**
     * @method handleResponse
     * @summary Generic response handling method. When using simple
     *     request/response processing it's possible to leverage the request
     *     instances themselves as responders so this method is often invoked to
     *     perform response processing.
     * @description Default response processing ensures that observation of the
     *     request/response ID are turned off, that the request is removed from
     *     any pending request queues, and that a RequestCompleted is signaled
     *     with the request's ID.
     * @param {TP.sig.Response} aSignal The TP.sig.Response instance.
     * @returns {TP.sig.Request} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('hasParameter',
function(aKey) {

    /**
     * @method hasParameter
     * @summary Returns true if the request has a parameter registered under the
     *     supplied key.
     * @param {String} aKey The key to check for.
     * @returns {Boolean} Whether or not the request has the parameter indicated
     *     by the supplied key.
     */

    var payload;

    payload = this.$get('payload');
    if (TP.canInvoke(payload, 'hasKey')) {
        return payload.hasKey(aKey);
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('isSynchronous',
function(aResource) {

    /**
     * @method isSynchronous
     * @summary Returns true if the request specifies a synchronous response.
     * @param {TP.core.Resource} aResource The resource to check for
     *     synchronicity settings if the receiver has no explicit 'async'
     *     setting.
     * @returns {Boolean} Whether or not the request will be generating a
     *     synchronous response.
     */

    var async;

    //  NOTE that as a request we care about our async payload parameter
    //  rather than a specific type setting.

    if (TP.isValid(async = this.at('async'))) {
        return !TP.bc(async);
    }

    if (TP.canInvoke(aResource, 'isSynchronous')) {
        return aResource.isSynchronous();
    }

    return this.getType().isSynchronous();
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('recycle',
function() {

    /**
     * @method recycle
     * @summary Prepares the receiver for a new usage cycle.
     * @returns {Object} The receiver.
     */

    this.callNextMethod();

    //  reset job control parameters
    this.reset();

    //  clear any response we may have from a prior execution
    this.$set('response', null);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('setRequest',
function(aRequest) {

    /**
     * @method setRequest
     * @summary Sets the receiver's internal request hash. This is the same as
     *     setting the receiver's signal "payload" via setPayload.
     * @param {TP.core.Hash} aRequest A set of key/value pairs defining the
     *     request specifics.
     * @returns {TP.sig.Request} The receiver.
     */

    this.setPayload(aRequest);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('setRequestID',
function(aRequestID) {

    /**
     * @method setRequestID
     * @summary Sets the receiver's request ID. This effectively changes the
     *     request for purposes of most operations since requestors and
     *     responders use the request ID to correlate instances. If you are
     *     going to change this value you should do it once, prior to initiating
     *     the signal the first time. You might do this as a way of maintaining
     *     your own "well-known IDs" for requests.
     * @param {String} aRequestID A valid TIBET object ID.
     * @returns {TP.sig.Request} The receiver.
     */

    this.setID(aRequestID);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('setRequestor',
function(aRequestor) {

    /**
     * @method setRequestor
     * @summary Sets the receiver's requestor, the object that will be
     *     configured to receive notifications of results. NOTE that a null
     *     value is valid here as a way of clearing a requestor.
     * @param {Object} aRequestor The object to register for notifications.
     * @returns {TP.sig.Request} The receiver.
     */

    return this.$set('requestor', aRequestor);
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('setResponder',
function(aResource) {

    /**
     * @method setResponder
     * @summary Sets the receiver's responder, the object which is handling the
     *     request. This should be a valid TP.core.Resource, typically a
     *     TP.core.Service of some type. This is typically invoked by the
     *     responder itself when it accepts responsibility for the request.
     * @param {TP.core.Resource} aResource The receiver's responder.
     * @returns {TP.sig.Request} The receiver.
     */

    this.$set('responder', aResource, false);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('setResponse',
function(aResponse) {

    /**
     * @method setResponse
     * @summary Sets the associated response instance for the receiver.
     * @param {TP.sig.Response} aResponse The associated response instance.
     * @returns {TP.sig.Request} The receiver.
     */

    if (!TP.isKindOf(aResponse, 'TP.sig.Response')) {
        return this.raise('TP.sig.InvalidParameter',
                            'Must supply an instance of TP.sig.Response ' +
                            'or a suitable subtype.');
    }

    this.$set('response', aResponse);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('setResponseName',
function(aName) {

    /**
     * @method setResponseName
     * @summary Sets the receiver's response name, the name of the specific
     *     signal that should be used when signaling a response. Under normal
     *     circumstances this defaults to the receiving object type's response
     *     type name, but it can be changed to create more focused response
     *     handling scenarios that don't require construction of custom response
     *     types.
     * @param {String} aName The response name. Default is the receiving type's
     *     response type name.
     * @returns {TP.sig.Request} The receiver.
     */

    this.$set('responseName', aName, false);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('setResponseType',
function(aType) {

    /**
     * @method setResponseType
     * @summary Sets the receiver's response type, the type used to construct
     *     the receiver's response instance. This value is typically taken from
     *     the receiver's type, but it can be overridden for a specific request
     *     using this method.
     * @param {TP.lang.RootObject|String} aType The response type or type name.
     * @returns {TP.sig.Request} The receiver.
     */

    this.$set('responseType', aType, false);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('setResult',
function(aResult) {

    /**
     * @method setResult
     * @summary Defines the request's result, the object returned as a result
     *     of processing the request.
     * @param {Object} aResult The result of request processing.
     * @returns {Object}
     */

    //  calling getResponse will construct/get the response as needed
    this.getResponse(aResult);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('updateRequestMode',
function(aRequest) {

    /**
     * @method updateRequestMode
     * @summary Updates the receiver's request mode to match that of the
     *     supplied request, with particular regards to asynchronous behavior.
     * @description If the receiver is configured for synchronous operation, but
     *     the supplied request is configured for asynchronous operation, the
     *     receiver will be configured for asynchronous operation. NOTE: The
     *     reverse is *NOT* true - if the receiver is asynchronous, but the
     *     supplied request is synchronous, the receiver will be left as
     *     asynchronous.
     * @param {TP.sig.Request} aRequest The request to examine for
     *     (a)synchronous behavior.
     * @returns {TP.sig.Request} The receiver.
     */

    var async;

    //  If we're already set to be 'async=true', then we're good to go.
    if (TP.isTrue(this.at('async'))) {
        return this;
    }

    //  If the supplied request is not set to be 'async=true', then we're
    //  also good to go because it doesn't want async.
    if (TP.notTrue(async = aRequest.at('async'))) {
        return this;
    }

    //  Otherwise, we put a 'true' value in our 'async' slot.
    this.atPut('async', async);

    return this;
});

//  ------------------------------------------------------------------------
//  Simple Workflow
//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('andJoin',
function(aRequest, aState) {

    /**
     * @method andJoin
     * @summary Adds a peer request and state to the list of requests which
     *     must reach a prescribed state before the receiver will fire.
     * @description The andJoin call allows a request to wait on multiple
     *     request prerequisites before it will fire. Because most pipes should
     *     stop processing if an error occurs in an early segment the default
     *     state is TP.SUCCEEDED. A failed prerequisite request will typically
     *     not cause the receiver to "join" and hence the receiver will never
     *     fire.
     * @param {TP.sig.Request} aRequest A request instance to observe as a
     *     trigger.
     * @param {Number|String} aState A job control state or suffix such as
     *     TP.SUCCEEDED (the default) or TP.FAILED.
     * @returns {TP.sig.Request} The receiver.
     */

    var ands,
        state;

    state = TP.ifInvalid(aState, TP.SUCCEEDED);

    //  tell ourselves, the "waiting request", about our prerequisite
    ands = this.getJoins(TP.AND);
    ands.push(TP.ac(aRequest, state));

    //  tell the prerequisite about us so it can notify on state
    aRequest.$wrapupJoin(this, TP.AND, state);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('andJoinChild',
function(aChildRequest) {

    /**
     * @method andJoinChild
     * @summary Adds a child request to the list of requests which must
     *     complete before the receiver can complete. Note that a single failed
     *     child will cause the parent request to fail.
     * @param {TP.sig.Request} aChildRequest A request instance to observe for
     *     completion.
     * @returns {TP.sig.Request} The receiver.
     */

    var ands;

    //  tell ourselves, the "waiting request", about our child
    ands = this.getChildJoins(TP.AND);
    ands.push(TP.ac(aChildRequest, TP.COMPLETED));

    //  tell the child about us so it can notify on completion
    aChildRequest.$wrapupJoin(this, TP.AND, TP.COMPLETED, true);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('$cancelJoin',
function(aChildRequest, aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method $cancelJoin
     * @summary Tells the receiver to cancel its join processing. This method
     *     is called internally to finalize processing for a parent request
     *     which had one or more child join requests.
     * @param {TP.sig.Request} aChildRequest A child request which cancelled.
     * @param {String} aFaultString A string description of the fault.
     * @param {Object} aFaultCode An optional object to set as the fault code.
     *     Usually a String or Number instance.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the cancellation.
     * @returns {TP.sig.Request|undefined} The receiver.
     */

    //  already done? don't go further
    if (this.didCancel() || this.didFail()) {
        return;
    }

    //  propagate child results upward
    this.$set('faultText', aChildRequest.getFaultText(), false);
    this.$set('faultCode', aChildRequest.getFaultCode(), false);
    this.$set('faultInfo', aChildRequest.getFaultInfo(), false);

    //  don't push empty values into the argument list or we risk creating
    //  'undefined' as one of the values inappropriately.
    switch (arguments.length) {
        case 2:
            return this.cancel(aFaultString);
        case 3:
            return this.cancel(aFaultString, aFaultCode);
        case 4:
            return this.cancel(aFaultString, aFaultCode, aFaultInfo);
        default:
            return this.cancel();
    }
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('canComplete',
function() {

    /**
     * @method canComplete
     * @summary Returns true if the receiver has no pending child joins haven't
     *     joined, meaning the receiver probably has pending asynchronous child
     *     requests and should not complete.
     * @returns {TP.sig.Request[]} The current and-joined or or-joined requests.
     */

    var joins,
        list;

    //  by checking if we're already complete we accomplish two things,
    //  first we canComplete if we already did. second we know that we
    //  don't have to iterate over our child joins individually, we just
    //  need to know if we have any.
    if (this.didComplete()) {
        return true;
    }

    joins = this.$get('childJoins');
    if (TP.isEmpty(joins)) {
        return true;
    }

    //  since we're not already complete if we have any OR children we can't
    //  complete.
    list = joins.at(TP.OR);
    if (TP.notEmpty(list)) {
        return false;
    }

    //  if all our AND children had joined we'd already be complete, but
    //  since we aren't we know at least one is still outstanding.
    list = joins.at(TP.AND);
    if (TP.notEmpty(list)) {
        return false;
    }

    return true;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('canJoinStates',
function(targetState, testState) {

    /**
     * @method canJoinStates
     * @summary Compares a test state to a target state and returns true if the
     *     test state is a reasonable match for the target state.
     * @param {Number} targetState The target state, usually TP.FAILED,
     *     TP.CANCELLED, TP.COMPLETED, TP.SUCCEEDED, etc.
     * @param {Number} testState The job control state, usually TP.FAILING,
     *     TP.CANCELLING, or TP.SUCCEEDING.
     * @returns {Boolean} True if the receiving request
     */

    var absTarget,
        absTest;

    if (this.didComplete() || this.isCompleting()) {
        return false;
    }

    absTarget = Math.abs(targetState);
    absTest = Math.abs(testState);

    if (absTarget === absTest) {
        return true;
    }

    if (absTarget === TP.COMPLETED) {
        return absTest === TP.SUCCEEDED ||
            absTest === TP.FAILED ||
            absTest === TP.CANCELLED;
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('$completeJoin',
function(aChildRequest, aResult) {

    /**
     * @method $completeJoin
     * @summary Tells the receiver to "complete" its join processing. This
     *     method is called internally to finalize processing for a parent
     *     request which had one or more child join requests.
     * @param {TP.sig.Request} aChildRequest A child request which completed.
     * @param {Object} aResult An optional result to output.
     * @returns {TP.sig.Request|undefined} The receiver.
     */

    //  already done? don't go further
    if (this.didCancel() || this.didFail()) {
        return;
    }

    //  propagate child results upward
    this.set('result', aChildRequest.getResult(), null, true);

    //  don't push an undefined into the complete call unless it's "real"
    if (arguments.length > 1) {
        return this.complete(aResult);
    }

    return this.complete();
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('$failJoin',
function(aChildRequest, aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method $failJoin
     * @summary Tells the receiver to fail its join processing. This method is
     *     called internally to finalize processing for a parent request which
     *     had one or more child join requests.
     * @param {TP.sig.Request} aChildRequest A child request which cancelled.
     * @param {String} aFaultString A string description of the fault.
     * @param {Object} aFaultCode An optional object to set as the fault code.
     *     Usually a String or Number instance.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the failure.
     * @returns {TP.sig.Request|undefined} The receiver.
     */

    //  already done? don't go further
    if (this.didCancel() || this.didFail()) {
        return;
    }

    //  propagate child results upward
    this.$set('faultText', aChildRequest.getFaultText(), false);
    this.$set('faultCode', aChildRequest.getFaultCode(), false);
    this.$set('faultInfo', aChildRequest.getFaultInfo(), false);

    //  don't push empty values into the argument list or we risk creating
    //  'undefined' as one of the values inappropriately.
    switch (arguments.length) {
        case 2:
            return this.fail(aFaultString);
        case 3:
            return this.fail(aFaultString, aFaultCode);
        case 4:
            return this.fail(aFaultString, aFaultCode, aFaultInfo);
        default:
            return this.fail();
    }
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('getChildJoins',
function(aJoinKey) {

    /**
     * @method getChildJoins
     * @summary Returns the joined requests which will be checked during join
     *     processing to see if the receiver 'hasJoined'.
     * @param {String} aJoinKey The key to look up, which should be either the
     *     TP.AND or TP.OR constant.
     * @returns {TP.sig.Request[]} The current and-joined or or-joined requests.
     */

    var joins,
        list;

    if (TP.isEmpty(aJoinKey)) {
        return this.raise('TP.sig.InvalidParameter', 'No valid join key.');
    }

    joins = this.$get('childJoins');
    if (TP.notValid(joins)) {
        joins = TP.hc();
        this.$set('childJoins', joins);
    }

    list = joins.at(aJoinKey);
    if (TP.notValid(list)) {
        list = TP.ac();
        joins.atPut(aJoinKey, list);
    }

    return list;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('getDescendantJoins',
function(aJoinKey) {

    /**
     * @method getDescendantJoins
     * @summary Returns the joined requests which will be checked during join
     *     processing to see if the receiver 'hasJoined'.
     * @param {String} aJoinKey The key to look up, which should be either the
     *     TP.AND or TP.OR constant.
     * @returns {TP.sig.Request[]} The current and-joined or or-joined requests.
     */

    var childJoins,

        len,
        i,

        result;

    if (TP.isEmpty(aJoinKey)) {
        return this.raise('TP.sig.InvalidParameter', 'No valid join key.');
    }

    //  Get all of the child joins under a particular key (AND or OR)
    childJoins = this.getChildJoins(aJoinKey);
    len = childJoins.getSize();

    //  Loop over them and recursively call this method on the found child
    //  joins, concatenating them all up together into a single Array.
    result = TP.ac();
    if (TP.notEmpty(childJoins)) {
        for (i = 0; i < len; i++) {
            result = result.concat(
                        childJoins.at(i).first(),
                        childJoins.at(i).first().getDescendantJoins(aJoinKey));
        }
    }

    return result;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('getJoins',
function(aJoinKey) {

    /**
     * @method getJoins
     * @summary Returns the joined requests which will be checked during join
     *     processing to see if the receiver 'hasJoined'.
     * @param {String} aJoinKey The key to look up, which should be either the
     *     TP.AND or TP.OR constant, or a specific wrapup state code.
     * @returns {TP.sig.Request[]} The current and-joined or or-joined requests.
     */

    var joins,
        list;

    if (TP.isEmpty(aJoinKey)) {
        return this.raise('TP.sig.InvalidParameter', 'No valid join key.');
    }

    joins = this.$get('peerJoins');
    if (TP.notValid(joins)) {
        joins = TP.hc();
        this.$set('peerJoins', joins);
    }

    list = joins.at(aJoinKey);
    if (TP.notValid(list)) {
        list = TP.ac();
        joins.atPut(aJoinKey, list);
    }

    return list;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('getParentJoins',
function(aJoinKey) {

    /**
     * @method getParentJoins
     * @summary Returns the joined requests which will be checked during join
     *     processing to see if the receiver 'hasJoined'.
     * @param {String} aJoinKey The key to look up, which should be either the
     *     TP.AND or TP.OR constant.
     * @returns {TP.sig.Request[]} The current and-joined or or-joined requests.
     */

    var joins,
        list;

    if (TP.isEmpty(aJoinKey)) {
        return this.raise('TP.sig.InvalidParameter', 'No valid join key.');
    }

    joins = this.$get('parentJoins');
    if (TP.notValid(joins)) {
        joins = TP.hc();
        this.$set('parentJoins', joins);
    }

    list = joins.at(aJoinKey);
    if (TP.notValid(list)) {
        list = TP.ac();
        joins.atPut(aJoinKey, list);
    }

    return list;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('hasJoined',
function(aRequest, childJoin) {

    /**
     * @method hasJoined
     * @summary Invoked by requests which have been joined to the receiver in
     *     some form or another when those requests complete. If the receiver
     *     checks its join configuration and recognizes that conditions for
     *     triggering have been met it returns true so the invoker can
     *     subsequently trigger the receiver to fire.
     * @param {TP.sig.Request} aRequest The request whose state just changed.
     *     Typically the caller.
     * @param {Boolean} childJoin True when the join test is for child join
     *     completion.
     * @returns {Boolean} True if the receiver has reached a valid join state to
     *     support triggering.
     */

    var list,
        len,
        i,
        item,
        request;

    list = TP.isTrue(childJoin) ? this.getChildJoins(TP.OR) :
                                this.getJoins(TP.OR);
    len = list.getSize();
    for (i = 0; i < len; i++) {
        item = list.at(i);
        request = item.first();
        if (childJoin) {
            return request.didComplete();
        } else {
            //  NOTE we take the absolute value here because when we're
            //  checking a state we may be "pending" or "final" and those
            //  values are +/- of each other.
            if (Math.abs(request.get('statusCode')) === Math.abs(item.last())) {
                return true;
            }
        }
    }

    list = TP.isTrue(childJoin) ? this.getChildJoins(TP.AND) :
                                this.getJoins(TP.AND);
    len = list.getSize();
    for (i = 0; i < len; i++) {
        item = list.at(i);
        request = item.first();
        if (childJoin) {
            if (request.didFail() || request.didCancel()) {
                return false;
            }
        } else {
            //  NOTE we take the absolute value here because when we're
            //  checking a state we may be "pending" or "final" and those
            //  values are +/- of each other.
            if (Math.abs(request.get('statusCode')) === Math.abs(item.last())) {
                return false;
            }
        }
    }

    return true;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('joinTo',
function(aRequest, aState, aCondition) {

    /**
     * @method joinTo
     * @summary Joins the receiver to a downstream peer request. When the
     *     receiver reaches aState it will check the downstream request to see
     *     if it should be triggered based on any other requests which might
     *     also be joined to that request. By default this method uses an orJoin
     *     mechanism so calling joinTo with just a request parameter results in
     *     a simple "call when done" kind of semantic.
     * @param {TP.sig.Request} aRequest A downstream request which should be
     *     triggered when the receiver reaches aState.
     * @param {Number|String} aState A job control state or suffix such as
     *     TP.SUCCEEDED or "Succeeded" (the default).
     * @param {String} aCondition TP.AND or TP.OR (default is TP.OR so only the
     *     receiver is necessary to trigger firing.
     * @returns {TP.sig.Request} The downstream request. This helps support
     *     chained calls like r1.joinTo(r2).joinTo(r3).
     */

    if (aCondition === TP.AND) {
        aRequest.andJoin(this, aState);
    } else {
        aRequest.orJoin(this, aState);
    }

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('orJoin',
function(aRequest, aState) {

    /**
     * @method orJoin
     * @summary Adds a request and state to the list of requests which may
     *     reach a prescribed state before the receiver can trigger. For orJoin
     *     requests only one pair must match for the receiver to trigger in
     *     response.
     * @param {TP.sig.Request} aRequest A request instance to observe as a
     *     trigger.
     * @param {Number|String} aState A job control state or suffix such as
     *     TP.SUCCEEDED or "Succeeded" (the default).
     * @returns {TP.sig.Request} The receiver.
     */

    var ors,
        state;

    state = TP.ifInvalid(aState, TP.SUCCEEDED);

    //  tell ourselves, the "waiting request", about our prerequisite
    ors = this.getJoins(TP.OR);
    ors.push(TP.ac(aRequest, state));

    //  tell the prerequisite about us so it can notify on state
    aRequest.$wrapupJoin(this, TP.OR, state);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('orJoinChild',
function(aChildRequest) {

    /**
     * @method orJoinChild
     * @summary Adds a child request to the list of requests which must
     *     complete before the receiver can complete. Note that a single failed
     *     child will cause the parent request to fail.
     * @param {TP.sig.Request} aChildRequest A request instance to observe for
     *     completion.
     * @returns {TP.sig.Request} The receiver.
     */

    var ors;

    //  tell ourselves, the "waiting request", about our child
    ors = this.getChildJoins(TP.OR);
    ors.push(TP.ac(aChildRequest, TP.COMPLETED));

    //  tell the child about us so it can notify on completion
    aChildRequest.$wrapupJoin(this, TP.OR, TP.COMPLETED, true);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('$wrapupJoin',
function(aRequest, aJoinKey, aState, childJoin) {

    /**
     * @method $wrapupJoin
     * @summary Invoked internally to register a request and state for join
     *     testing during job wrapup processing.
     * @param {TP.sig.Request} aRequest A request instance to observe as a
     *     trigger.
     * @param {String} aJoinKey The key to look up, which should be either the
     *     TP.AND or TP.OR constant.
     * @param {Number|String} aState A job control state or suffix such as
     *     TP.SUCCEEDED or "Succeeded" (the default).
     * @param {Boolean} childJoin True to signify that this join is a child
     *     join.
     * @returns {TP.sig.Request} The receiver.
     */

    var state,
        list;

    state = TP.ifInvalid(aState, TP.SUCCEEDED);

    //  NOTE that when we're defining joins to check upon wrapup we are
    //  looking at our peers and parents in terms of other requests which
    //  should be notified.
    list = TP.isTrue(childJoin) ? this.getParentJoins(aJoinKey) :
                                this.getJoins(aJoinKey);
    list.push(TP.ac(aRequest, state));

    return this;
});

//  ------------------------------------------------------------------------
//  TP.core.JobStatus Methods
//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('cancelJob',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method cancelJob
     * @summary Tells the receiver to "cancel", meaning whatever work is needed
     *     to get to a TP.CANCELLED state.
     * @param {String} aFaultString A string description of the fault.
     * @param {Object} aFaultCode An optional object to set as the fault code.
     *     Usually a String or Number instance.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the cancellation.
     * @returns {TP.sig.Request} The receiver.
     */

    var joins,
        len,
        i;

    //  if we've got child requests then cancel them...we're terminated
    joins = this.getChildJoins(TP.AND).copy().addAll(
        this.getChildJoins(TP.OR)).unique();

    len = joins.getSize();
    for (i = 0; i < len; i++) {
        //  NOTE that this won't do anything if the job already cancelled so
        //  we shouldn't see looping or extra overhead here.
        joins.at(i).first().cancel(aFaultString, aFaultCode, aFaultInfo);
    }

    //  don't push empty values into the argument list or we risk creating
    //  'undefined' as one of the values inappropriately.
    switch (arguments.length) {
        case 1:
            return this.$wrapupJob('Cancelled', TP.CANCELLED, aFaultString);
        case 2:
            return this.$wrapupJob('Cancelled', TP.CANCELLED, aFaultString,
                                    aFaultCode);
        case 3:
            return this.$wrapupJob('Cancelled', TP.CANCELLED, aFaultString,
                                    aFaultCode, aFaultInfo);
        default:
            return this.$wrapupJob('Cancelled', TP.CANCELLED);
    }
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('completeJob',
function(aResult) {

    /**
     * @method completeJob
     * @summary Tells the receiver to "complete", meaning whatever work is
     *     needed to get to a proper TP.SUCCEEDED state.
     * @param {Object} aResult An optional object to set as the result of the
     *     request.
     * @returns {TP.sig.Request} The receiver.
     */

    //  completing a job should ensure the result gets properly set in any
    //  response object we have.
    this.getResponse(aResult);

    //  don't push empty values into the argument list or we risk creating
    //  'undefined' as one of the values inappropriately.
    if (arguments.length > 0) {
        return this.$wrapupJob('Succeeded', TP.SUCCEEDED, aResult);
    }

    return this.$wrapupJob('Succeeded', TP.SUCCEEDED);
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('failJob',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method failJob
     * @summary Tells the receiver to "fail", meaning whatever work is needed
     *     to get to a TP.FAILED state.
     * @param {String} aFaultString A string description of the fault.
     * @param {Object} aFaultCode An optional object to set as the fault code.
     *     Usually a String or Number instance.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the failure.
     * @returns {TP.sig.Request} The receiver.
     */

    var joins,
        len,
        i;

    //  if we've got child requests then cancel them...we're terminated
    joins = this.getChildJoins(TP.AND).copy().addAll(
        this.getChildJoins(TP.OR)).unique();

    len = joins.getSize();
    for (i = 0; i < len; i++) {
        //  NOTE that this won't do anything if the job already cancelled so
        //  we shouldn't see looping or extra overhead here.
        joins.at(i).first().fail(aFaultString, aFaultCode, aFaultInfo);
    }

    //  don't push empty values into the argument list or we risk creating
    //  'undefined' as one of the values inappropriately.
    switch (arguments.length) {
        case 1:
            return this.$wrapupJob('Failed', TP.FAILED, aFaultString);
        case 2:
            return this.$wrapupJob('Failed', TP.FAILED, aFaultString,
                                    aFaultCode);
        case 3:
            return this.$wrapupJob('Failed', TP.FAILED, aFaultString,
                                    aFaultCode, aFaultInfo);
        default:
            return this.$wrapupJob('Failed', TP.FAILED);
    }
});

//  ------------------------------------------------------------------------

TP.sig.Request.Inst.defineMethod('$wrapupJob',
function(aSuffix, aState, aResultOrFault, aFaultCode, aFaultInfo) {

    /**
     * @method $wrapupJob
     * @summary Handles notifying the common parties to a request, the request,
     *     responder, and requestor of request completion and ensures any joined
     *     requests are triggered properly based on the final request status.
     * @description The various job control methods (completeJob, failJob,
     *     cancelJob) invoke this wrapup method to handle their final
     *     notification and join work.
     * @param {String} aSuffix The suffix provided is typically based on the
     *     state and usually is 'Cancelled', 'Failed', or 'Succeeded' to match
     *     the common signal suffixes observed.
     * @param {Number} aState The job control state, usually TP.FAILED,
     *     TP.CANCELLED, or TP.SUCCEEDED.
     * @param {Object} aResultOrFault A valid result object when in a
     *     non-failure state and a fault string when in a failure state.
     * @param {Object} aFaultCode An optional object to set as the fault code.
     *     Usually a String or Number instance.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the failure.
     * @returns {TP.sig.Request} The receiver.
     */

    var end,

        response,
        request,
        responder,
        requestor,
        result,

        id,
        suffixes,
        signals,

        signame,

        i,
        j,
        leni,
        lenj,
        suffix,

        handlerName,
        methodName,

        state,
        joins,
        ancestor,
        join,
        arglen,

        err,

        resolver,
        rejector;

    //  consider this to be "end of processing" time since what follows is
    //  largely about notifying rather than "real work" for the request
    if (TP.isValid(this.at('cmdStart'))) {
        end = Date.now();
        this.atPut('cmdEnd', end);
    }

    //  get a handle to the response object for the request.
    response = this.getResponse();

    //  three objects get special consideration with respect to notification
    //  to keep observe/ignore overhead to a minimum.
    /* eslint-disable consistent-this */
    request = this;
    /* eslint-enable consistent-this */
    responder = this.get('responder');
    requestor = this.get('requestor');

    //  now we ensure we don't have duplicate objects to notify, request and
    //  requestor will often default to the same request instance.
    responder = responder === request ? null : responder;
    requestor = requestor === request ? null : requestor;
    requestor = requestor === responder ? null : requestor;

    id = this.getRequestID();

    result = TP.ifUndefined(aResultOrFault, this.getResult());

    //  TODO: move this logic to a TP.sig.Request-specific method that can
    //  cache the result value for all instances of the request type.

    //  the request's signal name is our signal names' "body". Note that
    //  this returns all of the signal type names from the receiver's signal
    //  type up through TP.sig.Signal.
    signals = this.getTypeSignalNames().copy();

    //  Slice off all signal types before TP.sig.Request
    signals = signals.slice(0, signals.indexOf('TP.sig.Request') + 1);

    leni = signals.getSize();

    //  ensure we at least have a completed state to signal
    suffixes = TP.ac(aSuffix, 'Completed');
    lenj = suffixes.getSize();

    arglen = arguments.length;

    //  process each signal, letting first the request, then the requestor,
    //  and then signal observers know about each step in order
    for (i = 0; i < leni; i++) {
        signame = signals.at(i);

        for (j = 0; j < lenj; j++) {
            suffix = suffixes.at(j);

            //  Make sure that we have a real signal type.
            if (!TP.isType(TP.sys.getTypeByName(signame))) {
                continue;
            }

            handlerName = TP.composeHandlerName({
                signal: signame + suffix
            });

            response.setSignalName(signame + suffix);

            //  notify the request itself, it will often be locally
            //  programmed with custom callback hooks
            TP.handle(request, response, handlerName, true);
            if (response.shouldPrevent() || response.shouldStop()) {
                break;
            }

            //  notify responder...typically the service which did the
            //  actual processing. we give it one last chance to finish up
            //  any housekeeping for the request/response before requestor
            TP.handle(responder, response, handlerName, true);
            if (response.shouldPrevent() || response.shouldStop()) {
                break;
            }

            TP.handle(requestor, response, handlerName, true);
            if (response.shouldPrevent() || response.shouldStop()) {
                break;
            }

            if (TP.notFalse(this.at('shouldSignal'))) {
                //  signal the request for any remaining observers which might
                //  exist. NOTE that since we've been manipulating the signal
                //  name we don't use inheritance firing here... implying that
                //  observers of response signals have to be observing
                //  specifically.
                TP.signal(id, response, null, TP.FIRE_ONE);
            }
        }
    }

    //  ---
    //  peer requests
    //  ---

    //  once all standard processing of the request has been completed we
    //  look for any joined requests and see which we should activate as
    //  members of a downstream pipeline.
    state = aState;
    if (TP.notValid(state)) {
        state = this.get('statusCode');
    }
    if (state === TP.SUCCEEDING || state === TP.SUCCEEDED) {
        //  If we're succeeding we can include 'AND' joins since they rely on
        //  us being successful.
        joins = this.getJoins(TP.AND).copy().addAll(
            this.getJoins(TP.OR)).unique();
    } else {
        methodName = TP.sig.Request.getWrapupMethodName(state);
        //  If we're not succeeding we can only invoke our OR joins and we
        //  should be finalizing the AND joins.
        joins = this.getJoins(TP.AND);
        joins.forEach(function(item) {
            item.first()[methodName](
                request.get('faultText'),
                request.get('faultCode'),
                request.get('faultInfo'));
        });

        joins = this.getJoins(TP.OR);
    }

    joins = joins.filter(function(item) {
        //  If the state for the join is identical, or one that represents
        //  completing/completed and we're doing that in some form it matches.
        return item.first().canJoinStates(item.last(), state);
    });

    if (TP.notEmpty(joins)) {
        leni = joins.getSize();
        for (i = 0; i < leni; i++) {
            join = joins.at(i).first();
            if (join.hasJoined(this)) {
                //  Patch STDIO
                if (arglen > 2) {
                    join.atPut(TP.STDIN, TP.ac(result));
                }
                join.fire();
            }
        }
    }

    //  ---
    //  parent requests
    //  ---

    //  after checking for peer requests we also want to look for parent
    //  requests which care about either our exact status code (success vs.
    //  failure), or which care simply that we're done processing.

    state = aState;
    if (TP.notValid(state)) {
        state = this.get('statusCode');
    }
    if (state === TP.SUCCEEDING || state === TP.SUCCEEDED) {
        //  If we're succeeding we can include 'AND' joins since they rely on
        //  us being successful.
        joins = this.getParentJoins(TP.AND).copy().addAll(
            this.getParentJoins(TP.OR)).unique();
    } else {
        methodName = TP.sig.Request.getWrapupMethodName(state);
        //  If we're not succeeding we can only invoke our OR joins and we
        //  should be finalizing the AND joins.
        joins = this.getParentJoins(TP.AND);
        joins.forEach(function(item) {
            item.first()[methodName](
                request.get('faultText'),
                request.get('faultCode'),
                request.get('faultInfo'));
        });

        joins = this.getParentJoins(TP.OR);
    }

    joins = joins.filter(function(item) {
        //  If the state for the join is identical, or one that represents
        //  completing/completed and we're doing that in some form it matches.
        return item.first().canJoinStates(item.last(), state);
    });

    if (TP.notEmpty(joins)) {
        leni = joins.getSize();
        for (i = 0; i < leni; i++) {
            ancestor = joins.at(i).first();

            //  whether the parent thinks it has joined or not, if we failed
            //  or cancelled the parent should be told directly
            if (this.isFailing() || this.didFail()) {
                switch (arglen) {
                    case 3:
                        ancestor.$failJoin(this, result);
                        break;
                    case 4:
                        ancestor.$failJoin(this, result,
                                                aFaultCode);
                        break;
                    case 5:
                        ancestor.$failJoin(this, result,
                                                aFaultCode,
                                                aFaultInfo);
                        break;
                    default:
                        ancestor.$failJoin(this);
                        break;
                }
            } else if (this.isCancelling() || this.didCancel()) {
                switch (arglen) {
                    case 3:
                        ancestor.$cancelJoin(this, result);
                        break;
                    case 4:
                        ancestor.$cancelJoin(this, result,
                                                    aFaultCode);
                        break;
                    case 5:
                        ancestor.$cancelJoin(this, result,
                                                    aFaultCode,
                                                    aFaultInfo);
                        break;
                    default:
                        ancestor.$cancelJoin(this);
                        break;
                }
            } else if (ancestor.hasJoined(this, true)) {
                if (arglen > 2) {
                    ancestor.$completeJoin(this, result);
                } else {
                    ancestor.$completeJoin(this);
                }
            }
        }
    }

    //  If we had a deferred Promise hooked up to us (as indicated by whether
    //  we have a handle to a Promise's resolver Function), then (depending on
    //  success or not) resolve it or reject it.
    resolver = this.get('$deferredPromiseResolver');
    if (TP.isCallable(resolver)) {
        if (aState === TP.SUCCEEDED) {
            resolver(request.getResult());
        } else {
            if (TP.isValid(aFaultInfo)) {
                err = aFaultInfo.at('error');
            }
            if (TP.notValid(err)) {
                //  NOTE this isn't 'result' since that may default to the
                //  result value from the request. We only want failure data.
                err = new Error(aResultOrFault || 'UnknownRequestFault');
            }

            //  We know that we have a rejector, since we had a resolver, so we
            //  don't have to check here.
            rejector = this.get('$deferredPromiseRejector');
            rejector(err);
        }
    }

    return this;
});

//  ========================================================================
//  TP.sig.Response
//  ========================================================================

/**
 * @type {TP.sig.Response}
 * @summary Top-level response signal for TP.sig.Request signals. All response
 *     signals are subtypes of this signal. When a TP.sig.Request is handled by
 *     a resource the resource's handle calls will construct and eventually
 *     signal a TP.sig.Response of the proper name/type to notify any observers.
 *     The response instance is also returned by the handler immediately as a
 *     way of providing consistent access to the response, pending or otherwise.
 *
 *     Note that by allowing different response types TIBET allows you to
 *     construct smart wrappers around the data that's returned by the various
 *     services you may access.
 */

//  ------------------------------------------------------------------------

TP.sig.WorkflowSignal.defineSubtype('Response');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  the original request which drove this response's creation
TP.sig.Response.Inst.defineAttribute('request');

//  the result data managed by this response type
TP.sig.Response.Inst.defineAttribute('result');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('init',
function(aRequest, aResult) {

    /**
     * @method init
     * @summary Initialize a new instance. The request should be the original
     *     TP.sig.Request instance while the optional result is whatever data
     *     should be assigned to the request as the result.
     * @param {TP.sig.Request} aRequest A request object. In the case of
     *     TP.sig.Response instances the request object provided here must be a
     *     TP.sig.Request instance, not one of the more loosely typed "request
     *     hash" types used by other request-oriented methods.
     * @param {Object} aResult A result object.
     * @returns {TP.sig.Response} A new instance.
     */

    //  initialize the signal -- note we don't pass along the TP.sig.Request
    //  instance as payload or a 'request hash'
    this.callNextMethod(null);

    //  NOTE we force a request from either TP.sig.Request or TP.core.Hash
    //  here to ensure we've got something we can process effectively with
    this.$set('request', TP.request(aRequest), false);

    //  if we received a value (including null) as a result then set it.
    if (TP.isDefined(aResult)) {
        this.$set('result', aResult, false, true);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('asPromise',
function() {

    /**
     * @method then
     * @summary A method which returns a 'Promises/A+' compliant Promise object.
     * @description The returned Promise will be resolved (fulfilled or
     *     rejected) when the TP.sig.Request for this TP.sig.Response completes.
     * @returns {Promise} A promise that can be used to be the 'next step' in a
     *     chain of promises.
     */

    var request,
        promise,
        fault,
        err;

    request = this.getRequest();

    //  Stash away references to the resolver and rejector of the Promise).
    //  We'll need them to resolve() or reject() the Promise later when the
    //  request completes.
    promise = TP.extern.Promise.construct(
        function(resolver, rejector) {
            request.set('$deferredPromiseResolver', resolver);
            request.set('$deferredPromiseRejector', rejector);
        });

    if (request.didComplete()) {
        if (request.didSucceed()) {
            request.get('$deferredPromiseResolver')(request.getResult());
        } else {
            fault = request.get('faultInfo');
            if (TP.isValid(fault)) {
                err = fault.at('error');
            }
            if (TP.notValid(err)) {
                err = new Error('UnknownRequestFault');
            }
            request.get('$deferredPromiseRejector')(err);
        }
    }

    return promise;
}, {
    dependencies: [TP.extern.Promise]
});

//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('cancelJob',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method cancelJob
     * @summary Tells the receiver to "cancel", meaning whatever work is needed
     *     to get to a TP.CANCELLED state.
     * @param {String} aFaultString A string description of the fault.
     * @param {Object} aFaultCode An optional object to set as the fault code.
     *     Usually a String or Number instance.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the cancellation.
     * @returns {TP.sig.Response|undefined} The receiver.
     */

    var request;

    request = this.get('request');
    if (TP.canInvoke(request, 'cancelJob')) {
        return request.cancelJob(aFaultString, aFaultCode, aFaultInfo);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('completeJob',
function(aResult) {

    /**
     * @method completeJob
     * @summary Tells the receiver to "complete", meaning whatever work is
     *     needed to get to a proper TP.SUCCEEDED state.
     * @param {Object} aResult An optional object to set as the result of the
     *     request.
     * @returns {TP.sig.Response|undefined} The receiver.
     */

    var request;

    request = this.get('request');
    if (TP.canInvoke(request, 'completeJob')) {
        //  Don't make the called routine thing we're setting 'undefined' as a
        //  result by accident.
        if (arguments.length > 0) {
            return request.completeJob(aResult);
        } else {
            return request.completeJob();
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('failJob',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method failJob
     * @summary Tells the receiver to "fail", meaning whatever work is needed
     *     to get to a TP.FAILED state.
     * @param {String} aFaultString A string description of the fault.
     * @param {Object} aFaultCode An optional object to set as the fault code.
     *     Usually a String or Number instance.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the failure.
     * @returns {TP.sig.Response|undefined} The receiver.
     */

    var request;

    request = this.get('request');
    if (TP.canInvoke(request, 'failJob')) {
        return request.failJob(aFaultString, aFaultCode, aFaultInfo);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('fire',
function(anOrigin, aPayload, aPolicy) {

    /**
     * @method fire
     * @summary Fires the response using either the request ID or null ID. NOTE
     *     that the request itself is considered a local listener and is
     *     notified directly via this call. Other response observers may exist
     *     however, so this call still fires the response signal as its last
     *     step.
     * @param {Object} anOrigin An optional firing origin for this activation.
     *     NOTE that this is only used when no request ID is available for the
     *     response's request object to ensure that responses can be properly
     *     matched to their requests.
     * @param {Object} aPayload Optional parameter(s).
     * @param {Function} aPolicy A firing policy defining how the response
     *     should propogate.
     * @returns {TP.sig.Response} The receiver.
     */

    var origin,
        request,
        policy,
        signame;

    //  make sure our payload is in place for the request's handler
    if (TP.isValid(aPayload)) {
        this.setPayload(aPayload);
    }

    //  workflow signals always use a request ID as their origin so that
    //  they can tie together "processes" which are embodied as signal
    //  chains related to an originating request, unless explicitly altered
    origin = anOrigin;
    if (TP.notValid(origin)) {
        origin = this.getRequestID();
    }
    this.setOrigin(origin);

    //  to avoid thrashing on request/response observations too much we
    //  don't actually register the request via the notification system,
    //  we invoke its handle call directly here. TP.handle() will deal with
    //  any ignore semantics etc to avoid calling the request multiple
    //  times.
    request = this.getRequest();
    TP.handle(request, this);

    //  check response see if we should continue with remaining signaling.
    //  this can be managed by the request to keep overhead down
    if (this.shouldPrevent() || this.shouldStop()) {
        return this;
    }

    policy = aPolicy;
    if (TP.notValid(policy)) {
        //  when a signal name is specified inheritance is "off" and we
        //  target a very specific handler or none at all, otherwise we
        //  presume that we should use the default policy to fire.
        signame = this.getSignalName();
        if (signame !== this.getTypeName()) {
            policy = TP.FIRE_ONE;
        } else {
            policy = this.getType().getDefaultPolicy();
        }
    }

    //  instrument with current firing time
    this.$set('time', Date.now());

    //  signal using the request id as a channel identifier. this is done
    //  primarily for external observers...the requestor should be notified
    //  in the logic above
    TP.signal(origin, this, aPayload, policy);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('getDelegate',
function() {

    /**
     * @method getDelegate
     * @summary Returns the receiver's delegate, the object used by the
     *     TP.delegate utility function when constructing delegation methods.
     *     For TP.sig.Response this is the request object.
     * @returns {Object} The receiver's delegation object.
     */

    return this.getRequest();
});

//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('getFaultCode',
function() {

    /**
     * @method getFaultCode
     * @summary Returns the fault code of the receiver.
     * @returns {Number|undefined} A TIBET fault code constant.
     */

    var request;

    request = this.get('request');
    if (TP.canInvoke(request, 'getFaultCode')) {
        return request.getFaultCode();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('getFaultInfo',
function() {

    /**
     * @method getFaultInfo
     * @summary Returns the fault info of the receiver.
     * @returns {TP.core.Hash|undefined} A hash that will contain additional
     *     information about the failure.
     */

    var request;

    request = this.get('request');
    if (TP.canInvoke(request, 'getFaultInfo')) {
        return request.getFaultInfo();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('getFaultText',
function() {

    /**
     * @method getFaultText
     * @summary Returns the fault string (description) of the receiver.
     * @returns {String|undefined} A text description of the fault.
     */

    var request;

    request = this.get('request');
    if (TP.canInvoke(request, 'getFaultText')) {
        return request.getFaultText();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('getPayload',
function() {

    /**
     * @method getPayload
     * @summary Returns the optional arguments to the signal. If the response
     *     contains a payload it is returned by this call, otherwise any payload
     *     used by the original request is returned.
     * @returns {Object} The receiver's payload.
     */

    var payload;

    if (TP.notValid(payload = this.callNextMethod())) {
        return this.getRequest().getPayload();
    }

    return payload;
});

//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('getRequest',
function() {

    /**
     * @method getRequest
     * @summary Returns the receiver's original request object.
     * @returns {TP.sig.Request} The request this is the response for.
     */

    return this.$get('request');
});

//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('getRequestID',
function() {

    /**
     * @method getRequestID
     * @summary Returns the request ID for this request. The request ID may be
     *     a standard OID, a URL, or whatever is appropriate for the type of
     *     request. The default is an OID. The important thing about a request
     *     ID is that they serve as origins for any response signals which are
     *     generated so they should be reasonably unique.
     * @returns {String|undefined} A request ID which can take any form.
     */

    var request;

    request = this.get('request');
    if (TP.canInvoke(request, 'getRequestID')) {
        return request.getRequestID();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('getResult',
function() {

    /**
     * @method getResult
     * @summary Returns the request result, the object returned as a result of
     *     processing the receiver's request.
     * @returns {Object}
     */

    return this.$get('result');
});

//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('getResultNode',
function() {

    /**
     * @method getResultNode
     * @summary Returns the receiver's result in TP.dom.Node form if possible.
     *     When the result isn't valid XML this method returns null.
     * @returns {Node} A valid Node instance.
     */

    return TP.tpnode(this.getResult());
});

//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('getResultObject',
function() {

    /**
     * @method getResultObject
     * @summary Returns the receiver's result in object form.
     * @returns {Object}
     */

    return this.getResult();
});

//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('getResultText',
function() {

    /**
     * @method getResultText
     * @summary Returns the receiver's content in text (String) form.
     * @returns {String}
     */

    return TP.str(this.getResult());
});

//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('getStatusCode',
function() {

    /**
     * @method getStatusCode
     * @summary Returns the job status code of the receiver.
     * @returns {Number|undefined} A TIBET status code constant.
     */

    var request;

    request = this.get('request');
    if (TP.canInvoke(request, 'getStatusCode')) {
        return request.getStatusCode();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('getStatusText',
function() {

    /**
     * @method getStatusText
     * @summary Returns the job status of the receiver in text form.
     * @returns {String|undefined} The current status in text form.
     */

    var request;

    request = this.get('request');
    if (TP.canInvoke(request, 'getStatusText')) {
        return request.getStatusText();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('setRequest',
function(aRequest) {

    /**
     * @method setRequest
     * @summary Sets the receiver's request object.
     * @param {TP.sig.Request} aRequest The response's request.
     * @returns {TP.sig.Response} The receiver.
     */

    this.$set('request', aRequest, false);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('setResult',
function(aResult) {

    /**
     * @method setResult
     * @summary Defines the request's result, the object returned as a result
     *     of processing the request. This method is often overridden in
     *     subtypes so they can manage how the result data is stored.
     * @param {Object} aResult The result of request processing.
     * @returns {Object}
     */

    this.$set('result', aResult, false, true);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Response.Inst.defineMethod('then',
function(onFulfilled, onRejected) {

    /**
     * @method then
     * @summary A method which returns a 'Promises/A+' compliant Promise object
     *     after installing the supplied fulfillment/rejection Functions.
     * @description The returned Promise will be resolved (fulfilled or
     *     rejected) when the TP.sig.Request for this TP.sig.Response completes.
     * @param {Function} onFulfilled A Function that will be executed if the
     *     promise reaches it's fulfilled state.
     * @param {Function} onRejected A Function that will be executed if the
     *     promise reaches it's rejected state.
     * @returns {Promise} A promise that can be used to be the 'next step' in a
     *     chain of promises.
     */

    var request,
        promise,
        fault,
        err;

    request = this.getRequest();

    //  Stash away references to the resolver and rejector of the Promise).
    //  We'll need them to resolve() or reject() the Promise later when the
    //  request completes.
    promise = TP.extern.Promise.construct(
        function(resolver, rejector) {
            request.set('$deferredPromiseResolver', resolver);
            request.set('$deferredPromiseRejector', rejector);
        });

    if (TP.isCallable(onRejected)) {
        promise = promise.then(onFulfilled, onRejected);
    } else {
        promise = promise.then(onFulfilled);
    }

    if (request.didComplete()) {
        if (request.didSucceed()) {
            request.get('$deferredPromiseResolver')(request.getResult());
        } else {
            fault = request.get('faultInfo');
            if (TP.isValid(fault)) {
                err = fault.at('error');
            }
            if (TP.notValid(err)) {
                err = new Error('UnknownRequestFault');
            }
            request.get('$deferredPromiseRejector')(err);
        }
    }

    return promise;
}, {
    dependencies: [TP.extern.Promise]
});

//  ========================================================================
//  TP.core.PermissionGroup
//  ========================================================================

/**
 * @type {TP.core.PermissionGroup}
 * @summary An object whose primary purpose is to hold permission-specific
 *     behavior and one or more keyrings that provide permissions to members of
 *     the group.
 * @description Roles and units in a workflow sense are mapped to permission
 *     groups in TIBET. These permission groups are then assigned by way of
 *     vcard entries which are typically assigned to TP.core.User instances
 *     representing the "real" and "effective" user.
 *
 *     One of the important things to note here is that the features of a
 *     permission group are type-level features. This is done so that
 *     permission-specific behavior is associated with an object that is easily
 *     autoloaded when needed.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.PermissionGroup');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.core.PermissionGroup.Type.defineAttribute('keyrings');
TP.core.PermissionGroup.Type.defineAttribute('accessKeys');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.PermissionGroup.Type.defineMethod('addKeyring',
function(keyringName) {

    /**
     * @method addKeyring
     * @summary Adds a keyring to the receiver, granting it the permissions
     *     defined by the keys contained in the keyring.
     * @description When defining different permission group types one of the
     *     operations needed is to define the keyrings which that group has
     *     access to. This is typically done by string name so that the keyrings
     *     don't have to exist at the time of the assignment -- allowing
     *     definitions to be made with less overhead. The individual keyrings
     *     will be loaded the first time a request is made for the actual keys.
     *     NOTE: it is not necessary to add key rings whose name matches that of
     *     a particular role/unit, they are fetched automatically.
     * @param {String} keyringName The name of the keyring.
     * @returns {TP.meta.core.PermissionGroup} The receiver.
     */

    var ring,
        rings;

    ring = TP.tibet.keyring.getInstanceById(keyringName);
    if (TP.notValid(ring)) {
        return this.raise('TP.sig.InvalidParameter',
            'Keyring: \'' + keyringName + '\' not found.');
    }

    //  NOTE the getKeyrings call will always return an array, even if it builds
    //  it on the fly in response to this request.
    rings = this.getKeyrings(); //  We don't pass name, we're about to add it.
    rings.add(ring);

    //  Any time we reconfigure the keyrings we need to flush any cached
    //  dictionary we have for access keys so it will rebuild on next query.
    this.$set('accessKeys', null);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.PermissionGroup.Type.defineMethod('getAccessKeys',
function(keyringNames) {

    /**
     * @method getAccessKeys
     * @summary Returns an array of the permission keys associated with the
     *     receiver by virtue of its associated keyrings. If a specific set of
     *     keyring names is listed then the keys for that list are returned.
     * @param {String[]} keyringNames An array of one or more keyring names to
     *     specifically access the keys for. This is used at the top-level where
     *     no custom permission group type exists for a role, unit, etc.
     * @returns {String[]} An array containing the receiver's access keys.
     */

    var id,
        dict,
        keys,
        rings;

    if (TP.notEmpty(keyringNames)) {
        id = keyringNames.join(TP.JOIN);
    } else {
        id = this.getTypeName();
    }

    //  See if we've got a cached list of keys already.
    dict = this.$get('accessKeys');
    if (TP.isValid(dict)) {
        keys = dict.at(id);
        if (TP.isValid(keys)) {
            return keys;
        }
    } else {
        dict = TP.hc();
        this.$set('accessKeys', dict);
    }

    //  Build up cached set from our associated keyrings. NOTE the getKeyrings
    //  call will always return an array, even if it builds it on the fly.
    rings = this.getKeyrings(keyringNames);

    //  build an empty array we can inject into the following processes
    keys = TP.ac();

    keys = rings.injectInto(
                keys,
                function(ring, accum) {
                    //  the apply will flatten the nested keys into the keyset
                    accum.push.apply(accum, ring.getAccessKeys());

                    //  injectInto requires that we return the injected data
                    return accum;
                });

    //  Cache the result of our effort for future calls.
    dict.atPut(id, keys);

    return keys;
});

//  ------------------------------------------------------------------------

TP.core.PermissionGroup.Type.defineMethod('getKeyrings',
function(keyringNames) {

    /**
     * @method getKeyrings
     * @summary Returns the list of keyring instances associated with the
     *     receiver.
     * @param {String[]} keyringNames An array of one or more keyring names to
     *     specifically access the keys for. This is used at the top-level where
     *     no custom permission group type exists for a role, unit, etc.
     * @returns {TP.tibet.keyring[]} The array of keyrings.
     */

    var rings,
        inst;

    rings = this.$get('keyrings');
    if (TP.notValid(rings)) {
        rings = TP.ac();

        //  Populate with either keyringNames or type name from receiver (if a
        //  matching keyring exists)
        if (keyringNames) {
            keyringNames.perform(function(name) {
                var ring;

                ring = TP.tibet.keyring.getInstanceById(name);
                if (TP.isValid(ring)) {
                    rings.push(ring);
                }
            });
        } else {
            inst = TP.tibet.keyring.getInstanceById(this.getTypeName());
            if (TP.isValid(inst)) {
                rings.push(inst);
            }
        }

        //  Note here how we use 'Type.set()' so that this type and all of its
        //  subtypes can 'see' the value set here.
        this.Type.set('keyrings', rings);
    }

    return rings;
});

//  ========================================================================
//  TP.core.Role
//  ========================================================================

/**
 * @type {TP.core.Role}
 * @summary A functionally-oriented permission group capable of providing both
 *     permissions and behavior to a TP.core.Resource.
 * @description Roles are typically used as a way of grouping capabilities
 *     related to a specific job function such as "Manager" or "Clerk" in an
 *     application. This is in contrast to TP.core.Unit, which allows you to
 *     organize functionality and permissions based on organizational boundaries
 *     such as "Sales" or "Development".
 */

//  ------------------------------------------------------------------------

TP.core.PermissionGroup.defineSubtype('Role');

//  ========================================================================
//  public-guest
//  ========================================================================

//  Build a default role for "public" organization and "guest" role.
TP.core.Role.defineSubtype('role.public-guest');

//  ========================================================================
//  TP.core.Unit
//  ========================================================================

/**
 * @type {TP.core.Unit}
 * @summary A organizationally-oriented permission group capable of providing
 *     both permissions and behavior to a TP.core.Resource.
 * @description Units are used as a way of grouping functionality along
 *     organizational lines and can be useful when designing applications which
 *     deploy across organizational boundaries.
 */

//  ------------------------------------------------------------------------

TP.core.PermissionGroup.defineSubtype('Unit');

//  ========================================================================
//  public-public
//  ========================================================================

//  Build a default unit for "public" organization and "public" unit.
TP.core.Unit.defineSubtype('role.public-public');

//  ========================================================================
//  TP.sig.UserRequest
//  ========================================================================

/**
 * @type {TP.sig.UserRequest}
 */

//  ------------------------------------------------------------------------

TP.sig.Request.defineSubtype('UserRequest');

//  ========================================================================
//  TP.core.User
//  ========================================================================

/**
 * @type {TP.core.User}
 * @summary A resource specific to the application user.
 * @description TP.core.User is a somewhat special, and perhaps unexpected,
 *     resource.
 *
 *     TIBET thinks of the user as another resource, one that can service
 *     requests (i.e. act as a data "source") or one that can act as a data
 *     "sink" when the application is simply providing the user with output.
 *
 *     You can think of the various logins as being represented by different
 *     TP.core.User instances. Since each login may be found in a different
 *     portion of the application user interface it's quite conceivable that you
 *     may want application logic to "request" a specific user instance, which
 *     results in a TP.sig.UserIORequest. The TIBET console uses this model
 *     extensively as a way of communicating with you via the command prompt.
 *
 *     More commonly TP.core.User instances, by virtue of their associated
 *     vcards, define the permissions associated with a specific login by virtue
 *     of the vcard's role and unit definitions. When a user's vcard is altered,
 *     or the real/effective user settings are altered at the TP.core.User type
 *     level, TIBET updates the currently available body elements with the real
 *     and effective key strings for the current user instance(s). CSS rules
 *     built to take advantage of this automatic update can then drive
 *     permission-specific user interface operations.
 */

//  ------------------------------------------------------------------------

TP.core.Resource.defineSubtype('User');

//  ------------------------------------------------------------------------
//  Type Initialization
//  ------------------------------------------------------------------------

TP.core.User.set('mode', TP.core.SyncAsync.DUAL_MODE);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  what signals will trigger a TP.core.User instance?
TP.core.User.Type.defineAttribute(
    'triggers', TP.ac(TP.ac(TP.ANY, 'TP.sig.UserRequest')));

//  the current effective TP.core.User instance
TP.core.User.Type.defineAttribute('effectiveUser');

//  the current "real" TP.core.User instance, typically the instance mapped
//  to the currently logged in/session-enabled user (ie. the one the server
//  (when there's a server ;)) thinks is the client's user).
TP.core.User.Type.defineAttribute('realUser');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.User.Type.defineMethod('construct',
function(resourceID) {

    /**
     * @method construct
     * @summary Constructs and returns a new TP.core.User instance. Also
     *     ensures that the first TP.core.User instance constructed is
     *     automatically set to be the real user.
     * @param {String} aResourceID A unique resource identifier.
     * @returns {TP.core.User} A newly constructed user instance.
     */

    var inst;

    inst = this.callNextMethod();

    if (TP.notValid(this.$get('realUser'))) {
        this.set('realUser', inst);
    }

    return inst;
});

//  ------------------------------------------------------------------------

TP.core.User.Type.defineMethod('$distributeEffectiveAccessKeys',
function() {

    /**
     * @method $distributeEffectiveAccessKeys
     * @summary Updates all open window body elements to contain the current
     *     "effective user" key string value. This method is invoked any time
     *     the effective user is changed, or has its vcard set to a new value.
     * @returns {TP.meta.core.User} The receiver.
     */

    var windows;

    windows = TP.core.Window.getOpenWindows();
    windows.perform(
        function(win) {
            TP.windowAssignACLKeys(win, TP.ACL_EFFECTIVE);
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.core.User.Type.defineMethod('$distributeRealAccessKeys',
function() {

    /**
     * @method $distributeRealAccessKeys
     * @summary Updates all open window body elements to contain the current
     *     "real user" key string value. This method is invoked any time the
     *     real user is changed, or has its vcard set to a new value.
     * @returns {TP.meta.core.User} The receiver.
     */

    var windows;

    windows = TP.core.Window.getOpenWindows();
    windows.perform(
        function(win) {
            TP.windowAssignACLKeys(win, TP.ACL_REAL);
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.core.User.Type.defineMethod('extractFullName',
function(vcardXML) {

    /**
     * @method extractFullName
     * @summary Extracts the full name for the user from the supplied vCard XML.
     * @param {Element} vcardXML The XML to extract the full name.
     * @returns {String} The full name extracted from the supplied vCard XML.
     */

    return TP.nodeEvaluateXPath(vcardXML, 'string(//$def:fn/$def:text/text())');
});

//  ------------------------------------------------------------------------

TP.core.User.Type.defineMethod('getEffectiveAccessKeys',
function() {

    /**
     * @method getEffectiveAccessKeys
     * @summary Returns the effective access keys, the access keys owned by the
     *     effective user instance if there is one.
     * @returns {String[]} An array of the effective user's access keys.
     */

    var keys,
        user;

    user = this.getEffectiveUser();
    if (TP.isValid(user)) {
        keys = user.getAccessKeys();
    } else {
        keys = TP.ac();
    }

    return keys;
});

//  ------------------------------------------------------------------------

TP.core.User.Type.defineMethod('getEffectiveUser',
function() {

    /**
     * @method getEffectiveUser
     * @summary Returns the current "effective" user instance. Defaults to the
     *     current real user when no effective user instance has been set.
     * @returns {TP.core.User} The current effective user instance.
     */

    var user;

    user = this.$get('effectiveUser');

    if (TP.notValid(user)) {
        return this.getRealUser();
    }

    return user;
});

//  ------------------------------------------------------------------------

TP.core.User.Type.defineMethod('getInstanceById',
function(aUserID) {

    /**
     * @method getInstanceById
     * @summary Returns the instance with the ID provided, if available.
     * @param {String} aUserID The user ID to look up.
     * @returns {TP.core.User} The user instance with the ID provided.
     */

    var res;

    if (TP.isValid(res = this.getResourceById(aUserID))) {
        if (TP.isKindOf(res, this)) {
            return res;
        }
    }

    return res;
});

//  ------------------------------------------------------------------------

TP.core.User.Type.defineMethod('getRealAccessKeys',
function() {

    /**
     * @method getRealAccessKeys
     * @summary Returns the real user access keys, the access keys owned by the
     *     real user instance if there is one.
     * @returns {String[]} An array of the real user's access keys.
     */

    var keys,
        user;

    user = this.getRealUser();
    if (TP.isValid(user)) {
        keys = user.getAccessKeys();
    } else {
        keys = TP.ac();
    }

    return keys;
});

//  ------------------------------------------------------------------------

TP.core.User.Type.defineMethod('getRealUser',
function() {

    /**
     * @method getRealUser
     * @summary Returns the "real" user instance, the one most typically
     *     associated with the server session, when there is a server.
     * @returns {TP.core.User} The current real user instance.
     */

    var realUser;

    if (TP.notValid(realUser = this.$get('realUser'))) {

        //  Constructing a user will set it as the realUser if no previous value
        //  was configured.
        TP.core.User.construct(TP.sys.cfg('user.default_name'));

        realUser = this.$get('realUser');
    }

    return realUser;
});

//  ------------------------------------------------------------------------

TP.core.User.Type.defineMethod('setEffectiveUser',
function(aUser) {

    /**
     * @method setEffectiveUser
     * @summary Sets the application's effective user to the instance provided.
     *     This will cause certain UI updates to potentially occur as TIBET
     *     updates the effective role/unit permissions.
     * @param {TP.core.User} aUser The instance to make effective.
     * @returns {TP.meta.core.User|undefined} The TP.core.User type object.
     */

    if (!TP.isKindOf(aUser, this)) {
        this.raise('TP.sig.InvalidUser');

        return;
    }

    this.$set('effectiveUser', aUser);

    //  altering the user may alter role and unit which affect uri filters
    TP.sys.setcfg('tibet.uriprofile', null);

    //  trigger the UI changes via a key update
    this.$distributeEffectiveAccessKeys();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.User.Type.defineMethod('setRealUser',
function(aUser) {

    /**
     * @method setRealUser
     * @summary Sets the application's real user to the instance provided. This
     *     will cause certain UI updates to potentially occur as TIBET updates
     *     the effective role/unit permissions.
     * @param {TP.core.User} aUser The instance to make "real".
     * @returns {TP.meta.core.User|undefined} The TP.core.User type object.
     */

    if (!TP.isKindOf(aUser, this)) {
        this.raise('TP.sig.InvalidUser');

        return;
    }

    this.$set('realUser', aUser);

    //  altering the user may alter role and unit which affect uri filters
    TP.sys.setcfg('tibet.uriprofile', null);

    //  trigger the UI changes via a key update
    this.$distributeRealAccessKeys();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.User.Type.defineMethod('setupUserResources',
function() {

    /**
     * @method setupUserResources
     * @summary Sets up user information under specific resource URNs.
     * @description This method register the effective user object under
     *     'urn:tibet:user' and the effective user's vCard under
     *     'urn:tibet:userinfo'.
     * @returns {TP.meta.core.User} The TP.core.User type object.
     */

    TP.uc('urn:tibet:user').setResource(
                                this.getEffectiveUser());
    TP.uc('urn:tibet:userinfo').setResource(
                                this.getEffectiveUser().get('vcard'));

    return this;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  A TP.core.Hash of remote pubsub topics that the user might be
//  subscribed.
TP.core.User.Inst.defineAttribute('remoteSubscriptions');

//  A TP.core.Hash of credential sets that the user has available to them.
//  These are sets of credentials used for things like logging into remote
//  servers. They are keyed by a 'resource ID'.
TP.core.User.Inst.defineAttribute('credentials');

//  The 'credentials password' used to access the credentials database.
TP.core.User.Inst.defineAttribute('credentialsPassword');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.User.Inst.defineMethod('init',
function(resourceID) {

    /**
     * @method init
     * @summary Initializes a new user instance. This method extends the
     *     default resource initializer to automatically search for a matching
     *     vcard entry for the user ID.
     * @param {String} resourceID A unique user identifier. This ID will be used
     *     to look for an initial vcard entry for the named user.
     * @returns {TP.core.User}
     */

    var vcard;

    this.callNextMethod();

    this.set('remoteSubscriptions', TP.hc());
    this.set('credentials', TP.hc());

    //  We do this last so any changes that we may want to add which trigger
    //  based on the current vcard will occur and override anything we defaulted
    //  to in the prior portion of this method.
    vcard = TP.ietf.vcard.getInstanceById(resourceID);
    if (TP.isValid(vcard)) {
        this.setVCard(vcard);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.User.Inst.defineMethod('clearCredentialsFor',
function(resourceID) {

    /**
     * @method clearCredentialsFor
     * @summary Clears the credentials information for the specified resource.
     * @param {String} resourceID A unique TIBET identifier. By unique we mean
     *     an ID which will not conflict with any other ID registered using
     *     TIBET's object registration methods.
     * @returns {TP.core.User} The receiver.
     */

    if (TP.notEmpty(this.getCredentialsFor(resourceID))) {
        this.get('credentials').removeKey(resourceID);
        this.saveCredentials();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.User.Inst.defineMethod('getCredentialsFor',
function(resourceID) {

    /**
     * @method getCredentialsFor
     * @summary Returns the credentials information for the specified resource.
     * @param {String} resourceID A unique TIBET identifier. By unique we mean
     *     an ID which will not conflict with any other ID registered using
     *     TIBET's object registration methods.
     * @returns {TP.core.Hash} A hash containing the user's credentials for the
     *     specified resource.
     */

    var credentialsPW,

        credentials,

        credentialsStorage,

        credentialsDBStr,
        credentialsDB;

    //  If we can't find an existing hash in our credentials store for the
    //  specified resource, then build one.
    if (TP.notValid(credentials = this.get('credentials').at(resourceID))) {

        //  If the user was already prompted to enter a password for the
        //  credentials DB, but didn't, the password is set to TP.NULL. If this
        //  is the case, there is no sense in continuing.
        if ((credentialsPW = this.get('credentialsPassword')) === TP.NULL) {
            //  TODO: Should we warn?
            credentials = TP.hc();
            this.get('credentials').atPut(resourceID, credentials);

            return credentials;
        }

        credentialsStorage = TP.core.SessionStorage.construct();

        //  See if there is a credentials store in the credentials storage place
        //  (named by TP.CREDENTIALS_DB_NAME) using our password. This will
        //  return a JSONified String of the credentials information.
        credentialsDBStr = credentialsStorage.atEncrypted(
                            TP.CREDENTIALS_DB_NAME,
                            credentialsPW);

        if (TP.isEmpty(credentialsDBStr)) {
            credentials = TP.hc();
        } else {
            //  We found an existing JSONified String... turn it into an object
            //  (i.e. a TP.core.Hash) if we can and grab the credentials at
            //  the specified resource ID. If we cannot, just allocate an empty
            //  hash.
            if (TP.isValid(credentialsDB = TP.json2js(credentialsDBStr))) {
                credentials = credentialsDB.at(resourceID);
            } else {
                credentials = TP.hc();
            }
        }

        this.get('credentials').atPut(resourceID, credentials);
    }

    return credentials;
});

//  ------------------------------------------------------------------------

TP.core.User.Inst.defineMethod('getCredentialsPassword',
function() {

    /**
     * @method getCredentialsPassword
     * @summary Returns the password used for saving the user's credentials.
     * @returns {TP.core.String} The credentials password.
     */

    var password;

    if (TP.isEmpty(password = this.$get('credentialsPassword'))) {

        //  If the object has a 'recursion marker', that means a String
        //  representation of some sort is being produced and we should just
        //  return the current value here.
        if (TP.objectHasMarker(this)) {
            return password;
        }

        if (TP.isEmpty(
            password = prompt('Please enter your credentials password'))) {

            //  The user didn't enter a password - keep this from continuing to
            //  prompt by setting it to TP.NULL
            password = TP.NULL;
        }

        this.set('credentialsPassword', password);
    }

    return password;
});

//  ------------------------------------------------------------------------

TP.core.User.Inst.defineMethod('getUsername',
function() {

    /**
     * @method getUsername
     * @summary Returns the receiver's username.
     * @returns {TP.core.String} The receiver's username.
     */

    var vcard;

    vcard = this.get('vcard');
    if (TP.isValid(vcard)) {
        return vcard.get('nickname');
    } else {
        return TP.sys.cfg('user.default_name');
    }
});

//  ------------------------------------------------------------------------

TP.core.User.Inst.defineMethod('saveCredentials',
function() {

    /**
     * @method saveCredentials
     * @summary Saves the user's credentials information.
     * @returns {TP.core.User} The receiver.
     */

    var credentialsStorage;

    //  If the user was already prompted to enter a password for the credentials
    //  DB, but didn't, the password is set to TP.NULL. If this is the case,
    //  there is no sense in continuing.
    if (this.get('credentialsPassword') === TP.NULL) {
        //  TODO: Should we warn?
        return this;
    }

    credentialsStorage = TP.core.SessionStorage.construct();

    //  Put the credentials into storage. Note how we convert our 'credentials'
    //  hash into a regular Object for more compact JSONification.
    credentialsStorage.atPutEncrypted(
                            TP.CREDENTIALS_DB_NAME,
                            this.get('credentials').asObject().asJSONSource(),
                            this.get('credentialsPassword'));

    return this;
});

//  ========================================================================
//  TP.core.Service
//  ========================================================================

/**
 * @type {TP.core.Service}
 * @summary A processing resource.
 */

//  ------------------------------------------------------------------------

TP.core.Resource.defineSubtype('Service');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  storage for a default instance that will take the ID of the type itself but
//  without any namespace prefixing (so typically just the 'service name'.
TP.core.Service.Type.defineAttribute('defaultInstance');

//  is the service registered to accept the initial request?
TP.core.Service.Type.defineAttribute('registered', false);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.Service.Type.defineMethod('getDefaultInstance',
function(resourceID, aSignal) {

    /**
     * @method getDefaultInstance
     * @summary Returns the instance with the service ID provided, if
     *     available.
     * @param {String} resourceID A unique TIBET identifier. By unique we mean
     *     an ID which will not conflict with any other ID registered using
     *     TIBET's object registration methods.
     * @param {TP.sig.Signal} aSignal The signal which triggered this activity.
     * @returns {TP.core.Service|undefined} A valid service instance if one can
     *     be constructed.
     */

    var inst,
        id;

    inst = this.$get('defaultInstance');

    if (TP.notValid(inst)) {
        //  create as "typenameDefault" for identification unless otherwise
        //  specified; and make sure it's registered to take over as a
        //  handler for type-level triggers

        //  Note here how we use the type's 'local name' (i.e. without the
        //  namespace) to compute the default service ID
        id = TP.ifEmpty(resourceID, this.getLocalName());

        //  NOTE that not all services can construct instances without
        //  additional parameters...those that can't have to use constructed
        //  instances rather than a Default...
        TP.raise.$suspended = true;
        TP.signal.$suspended = true;

        try {
            //  note that it's up to the shell instances to get themselves
            //  ready to process real requests as part of the construct/init
            inst = this.construct(id, aSignal);
        } catch (e) {
            TP.ifWarn() ?
                TP.warn(TP.ec(e, 'Couldn\'t construct default instance: ')) : 0;

            if (TP.isValid(aSignal)) {
                //  can't construct an instance...have to let some other
                //  instance deal with it possibly
                if (aSignal.shouldStop()) {
                    //  if stop propagation was set during acceptRequest we
                    //  need to refire otherwise we should just return
                    return aSignal.fire();
                }
            }

            return;
        } finally {
            TP.raise.$suspended = false;
            TP.signal.$suspended = false;
        }

        if (TP.isValid(inst)) {
            this.$set('defaultInstance', inst, false);
            inst.register();
        }
    }

    return inst;
});

//  ------------------------------------------------------------------------

TP.core.Service.Type.defineMethod('getInstanceById',
function(aServiceID) {

    /**
     * @method getInstanceById
     * @summary Returns the instance with the service ID provided, if
     *     available.
     * @param {String} aServiceID The service ID to look up.
     * @returns {TP.core.Service} The instance whose ID matches the supplied
     *     service ID.
     */

    var res;

    if (TP.isValid(res = this.getResourceById(aServiceID))) {
        if (TP.isKindOf(res, this)) {
            return res;
        }
    }

    return res;
});

//  ------------------------------------------------------------------------

TP.core.Service.Type.defineHandler('Request',
function(aSignal) {

    /**
     * @method handleRequest
     * @summary Handles requests by creating a default instance on demand and
     *     forwarding the work to that instance. Once the instance has been
     *     constructed the receiver ignores future request signals so that it is
     *     no longer part of the request cycle.
     * @param {TP.sig.Request} aSignal The signal that triggered this handler.
     * @returns {Object|null} The result of processing the signal.
     */

    var id,
        inst;

    //  get the default instance, creating it as necessary so that it can
    //  take over for the type in terms of generic registrations
    //  Note here how we use the type's 'local name' (i.e. without the
    //  namespace) to compute the default service ID
    id = this.getLocalName();
    inst = this.getDefaultInstance(id, aSignal);

    //  turn off future invocations of the service as a request handler.
    //  the default instance should be handling that, and if we were unable
    //  to get the instance it's not likely we'll be successful in the
    //  future
    this.unregister();

    //  since the first section may fail we'll test again here
    if (TP.isValid(inst)) {
        //  delegate to the instance, but start at the outermost handle call
        //  so the instance can specialize as much as possible
        return TP.handle(inst, aSignal);
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.core.Service.Type.defineMethod('isRegistered',
function(aFlag) {

    /**
     * @method isRegistered
     * @summary Returns a boolean defining whether the receiver has registered
     *     to observe its triggers. Services register so they can avoid instance
     *     creation until the first request.
     * @param {Boolean} aFlag A new value for this property. Optional.
     * @returns {Boolean}
     */

    if (TP.isBoolean(aFlag)) {
        this.$set('registered', aFlag);
    }

    return this.$get('registered');
});

//  ------------------------------------------------------------------------

TP.core.Service.Type.defineMethod('register',
function() {

    /**
     * @method register
     * @summary Registers the receiver observe its trigger signals so that
     *     requests will cause activation of the service. In the case of the
     *     type itself this is done by certain subtypes which want to avoid
     *     explicit instance creation/registration before a request can be
     *     serviced.
     * @returns {TP.meta.core.Service} The receiver.
     */

    //  Make sure to register this object with the system, if necessary, before
    //  we start observing things so that our registration URI will not be
    //  created as a 'handler URI' that will be cleared when 'ignore' is called.
    TP.sys.registerObject(this, null, true);

    this.observeTriggers();

    this.isRegistered(true);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Service.Type.defineMethod('unregister',
function() {

    /**
     * @method unregister
     * @summary Unregisters the receiver observe its trigger signals so that
     *     future requests will no longer trigger the type as a potential
     *     handler.
     * @returns {TP.meta.core.Service} The receiver.
     */

    if (!this.isRegistered()) {
        return this;
    }

    this.ignoreTriggers();

    this.isRegistered(false);

    //  Reverse what we did above.
    TP.sys.unregisterObject(this);

    return this;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  flag controlling whether the service is ready for requests
TP.core.Service.Inst.defineAttribute('serviceEnabled', true);

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.Service.Inst.defineMethod('init',
function(resourceID, aRequest) {

    /**
     * @method init
     * @summary Initializes a new instance of the receiver, providing it with a
     *     unique resourceID and any parameters that might be needed via an
     *     optional request/parameter hash.
     * @param {String} resourceID A unique TIBET identifier. By unique we mean
     *     an ID which will not conflict with any other ID registered using
     *     TIBET's object registration methods.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A hash or request object
     *     that should provide any additional parameters necessary to construct
     *     an instance.
     * @exception TP.sig.InvalidResourceID
     * @returns {TP.core.Resource} A new instance.
     */

    var vcard;

    //  construct the instance from the root down
    this.callNextMethod();

    //  if there's a service-level vcard which identifies the service then
    //  associate that with the service instance now. Note that we check
    //  even for default instances, since some external services like XMPP,
    //  etc. have vcards defined for their 'default' instance.
    vcard = TP.ietf.vcard.getInstanceById(resourceID);
    if (TP.isValid(vcard)) {
        this.setVCard(vcard);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Service.Inst.defineMethod('clearAuthData',
function() {

    /**
     * @method clearAuthData
     * @summary Clears any stored authentication data from the receiver and any
     *     backing store.
     * @returns {TP.core.Service} The receiver.
     */

    TP.sys.getEffectiveUser().clearCredentialsFor(this.getID());

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Service.Inst.defineMethod('configureAuthData',
function(aRequest) {

    /**
     * @method configureAuthData
     * @summary Configures authentication data for the receiver. This method
     *     should be overridden by subtypes to do something real.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An optional request or
     *     hash containing a serviceURI if the service is going to be tied to a
     *     particular target location.
     * @returns {TP.core.Service} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Service.Inst.defineMethod('isEnabled',
function() {

    /**
     * @method isEnabled
     * @summary Returns true if the service can process requests.
     * @returns {Boolean} Whether or not the service is enabled.
     */

    return this.get('serviceEnabled');
});

//  ------------------------------------------------------------------------

TP.core.Service.Inst.defineMethod('register',
function() {

    /**
     * @method register
     * @summary Registers the receiver observe its trigger signals.
     * @returns {TP.core.Service} The receiver.
     */

    this.callNextMethod();

    //  Make sure to unregister the type (if its registered). That way, the
    //  'default instance' of the service won't be created if it hasn't been
    //  created already. This allows this instance of the service to handle
    //  all (untargeted) requests of the types defined in 'triggers'
    //  to be handled by this instance.
    this.getType().unregister();

    return this;
});

//  ========================================================================
//  TP.sig.FunctionRequest
//  ========================================================================

TP.sig.Request.defineSubtype('FunctionRequest');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.sig.FunctionRequest.Type.defineAttribute('responseType',
                                        'TP.sig.FunctionResponse');

//  ========================================================================
//  TP.sig.FunctionResponse
//  ========================================================================

TP.sig.Response.defineSubtype('FunctionResponse');

//  ========================================================================
//  TP.core.FunctionService
//  ========================================================================

TP.core.Service.defineSubtype('FunctionService');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.core.FunctionService.Type.defineAttribute(
    'triggers', TP.ac(TP.ac(TP.ANY, 'TP.sig.FunctionRequest')));

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.core.FunctionService.Type.defineAttribute(
                        'supportedModes', TP.core.SyncAsync.DUAL_MODE);
TP.core.FunctionService.Type.defineAttribute(
                        'mode', TP.core.SyncAsync.DUAL_MODE);

TP.core.FunctionService.register();

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.FunctionService.Inst.defineHandler('FunctionRequest',
function(aRequest) {

    /**
     * @method handleFunctionRequest
     * @summary Handles when an TP.sig.FunctionRequest is fired. Since
     *     this service will register itself as the default handler for these
     *     kinds of requests, the default instance of it will usually handle all
     *     of these kinds of requests.
     * @param {TP.sig.FunctionRequest} aRequest The request object to take
     *     the request parameters from.
     * @returns {TP.core.FunctionService} The receiver.
     */

    var request,
        handler,

        result;

    request = TP.request(aRequest);

    //  rewrite the mode, whether we're async or sync. This will only change
    //  the value if it hasn't been set to something already, but it may
    //  warn when the value appears to be inconsistent with what the service
    //  is capable of processing.
    request.atPut('async', this.rewriteRequestMode(request));

    //  For a Function request, we look in the 'handler' slot of the payload and
    //  make sure that the value there is callable. If not, we fail the request,
    //  but if it is we apply the Function with the supplied (or created)
    //  request as the only argument.
    if (!TP.isCallable(handler = request.at('handler'))) {
        request.fail('Handler not callable');
    } else {
        //  TODO: Need to handle when a Promise might be returned here for true
        //  asynchronicity. Also, can't this 'apply()' just be a regular
        //  invocation?
        result = handler.apply(request, TP.ac(request));
        request.complete(result);
    }

    return this;
});

//  ------------------------------------------------------------------------
//  Function Additions
//  ------------------------------------------------------------------------

Function.Inst.defineMethod('asFunctionRequest',
function() {

    /**
     * @method asFunctionRequest
     * @summary A convenience wrapper method to turn a Function into a
     *     FunctionRequest.
     * @returns {TP.core.FunctionRequest} A new FunctionRequest containing the
     *     receiving Function.
     */

    return TP.sig.FunctionRequest.construct(TP.hc('handler', this));
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('fire',
function() {

    /**
     * @method fire
     * @summary A convenience wrapper method to 'fire' a Function. This first
     *     converts the a Function into a FunctionRequest and then 'fire()'s it.
     * @returns {TP.core.FunctionResponse} The supplied FunctionRequest's
     *     response object.
     */

    return this.asFunctionRequest().fire();
});

//  ========================================================================
//  TP.sig.IORequest
//  ========================================================================

/**
 * @type {TP.sig.IORequest}
 * @summary Common supertype for IO-related requests.
 */

//  ------------------------------------------------------------------------

TP.sig.Request.defineSubtype('IORequest');

//  ========================================================================
//  TP.sig.IOResponse
//  ========================================================================

/**
 * @type {TP.sig.IOResponse}
 * @summary Common supertype for IO-related responses.
 */

//  ------------------------------------------------------------------------

TP.sig.Response.defineSubtype('IOResponse');

//  ========================================================================
//  TP.core.IOService
//  ========================================================================

/**
 * @type {TP.core.IOService}
 * @summary Common supertype for IO-related responses.
 * @description This type adds polling capability to TP.core.Service.
 */

//  ------------------------------------------------------------------------

TP.core.Service.defineSubtype('IOService');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  The TP.core.Job that is actually performing the polling.
TP.core.IOService.Inst.defineAttribute('$pollingJob');

//  The last request that was fired 'manually'. During polling, the last
//  signal that was fired manually is fired over and over by the polling
//  process.
TP.core.IOService.Inst.defineAttribute('lastRequest');

//  The 'starting' value for the interval controlling the polling. We start
//  at 3000ms. Note that you have to set this value before starting the
//  polling behavior.
TP.core.IOService.Inst.defineAttribute('firstInterval', 3000);

//  The 'maximum' value for the interval controlling the polling. We never
//  allow more than 60000ms (1 minute) to pass without polling. Note that
//  you have to set this value before starting the polling behavior.
TP.core.IOService.Inst.defineAttribute('maxInterval', 60000);

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.IOService.Inst.defineMethod('isPolling',
function() {

    /**
     * @method isPolling
     * @summary Returns true if the receiver is currently 'actively polling'.
     *     This means that the receiver is a polling mode and is not paused.
     * @returns {Boolean} Whether or not the service is in a polling mode.
     */

    var pollingJob;

    pollingJob = this.get('$pollingJob');

    /* eslint-disable no-extra-parens */
    return (TP.isValid(pollingJob) &&
            pollingJob.isActive() &&
            !pollingJob.isPaused());
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.core.IOService.Inst.defineMethod('inPollMode',
function() {

    /**
     * @method inPollMode
     * @summary Returns true if the receiver is currently in a polling mode.
     * @description The receiver might not actually be polling at the time, but
     *     it is in an 'active poll' mode. Note also that pausing the polling
     *     behavior will cause this method to return false.
     * @returns {Boolean} Whether or not the service is in a polling mode.
     */

    var pollingJob;

    pollingJob = this.get('$pollingJob');

    return TP.isValid(pollingJob);
});

//  ------------------------------------------------------------------------

TP.core.IOService.Inst.defineMethod('$computeInterval',
function(aJob) {

    /**
     * @method $computeInterval
     * @summary Returns a value which grows slowly over time by adding 1 second
     *     to the delay with each iteration when the service did not get data
     *     the last time it polled. If it did get data, the initial interval
     *     value is used and the decay process starts all over again.
     * @param {TP.core.Job} aJob An instance whose processing data may be used
     *     to feed the computation of a new delay time.
     * @returns {Number} A computed delay time.
     */

    if (TP.notValid(this.get('lastRequest'))) {
        return aJob.get('firstInterval');
    }

    if (TP.notEmpty(this.get('lastRequest').getResponse().getResultText())) {
        return aJob.get('firstInterval');
    } else {
        return aJob.get('maxInterval').min(aJob.get('lastInterval') + 1000);
    }
});

//  ------------------------------------------------------------------------

TP.core.IOService.Inst.defineHandler('RequestFailed',
function(aSignal) {

    /**
     * @method handleRequestFailed
     * @summary Handles any signal being managed by this service that has
     *     unsuccessfully completed.
     * @param {TP.sig.Response} aSignal The response masquerading as a "Failed"
     *     signal.
     * @returns {TP.sig.Response} The supplied response signal.
     */

    //  The request failed - stop the polling.
    if (this.inPollMode()) {
        this.stopPolling();
    }

    return aSignal;
});

//  ------------------------------------------------------------------------

TP.core.IOService.Inst.defineHandler('RequestSucceeded',
function(aSignal) {

    /**
     * @method handleRequestSucceeded
     * @summary Handles any signal being managed by this service that has
     *     successfully completed.
     * @param {TP.sig.Response} aSignal The response masquerading as a
     *     "Succeeded" signal.
     * @returns {TP.sig.Response} The supplied response signal.
     */

    var request;

    request = aSignal.getRequest();

    if (this.inPollMode()) {
        //  Note the identity test - we want to know if 'request' is the
        //  exact same object as the one we're holding.
        if (request !== this.get('lastRequest')) {
            this.set('lastRequest', request);
        }
    }

    //  This parameter can either be a Boolean value or a Function.
    if (TP.isValid(request.at('poll'))) {
        //  If the 'poll' parameter has a value of false and we're polling,
        //  shut off polling.
        if (TP.isFalse(request.at('poll')) && this.inPollMode()) {
            this.stopPolling();
        } else if (TP.notFalse(request.at('poll') && !this.inPollMode())) {
            //  Otherwise, if the poll parameter is not false (either true
            //  or a Function), then start polling (supplying the request so
            //  that polling can be configured by using that request).
            this.startPolling(request);
            this.set('lastRequest', request);
        }
    }

    return aSignal;
});

//  ------------------------------------------------------------------------

TP.core.IOService.Inst.defineMethod('pausePolling',
function() {

    /**
     * @method pausePolling
     * @summary Pauses any current polling behavior.
     * @returns {TP.core.IOService} The receiver.
     */

    //  We're not actively polling - no sense in pausing anything.
    if (!this.isPolling()) {
        return this;
    }

    this.get('$pollingJob').pause();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.IOService.Inst.defineMethod('$poll',
function() {

    /**
     * @method $poll
     * @summary Polls the server for new data.
     * @returns {Boolean} Always returns true.
     */

    var lastRequest;

    if (TP.isValid(lastRequest = this.get('lastRequest'))) {
        //  Refire the last request.
        lastRequest.fire();
    }

    return true;
});

//  ------------------------------------------------------------------------

TP.core.IOService.Inst.defineMethod('resumePolling',
function() {

    /**
     * @method resumePolling
     * @summary Resumes any previously paused polling behavior.
     * @returns {TP.core.IOService} The receiver.
     */

    //  We're already actively polling - no sense in resuming anything.
    if (this.isPolling()) {
        return this;
    }

    this.get('$pollingJob').resume();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.IOService.Inst.defineMethod('startPolling',
function(pollParams) {

    /**
     * @method startPolling
     * @summary Start the service's polling behavior.
     * @description The polling parameters supplied to this method can contain a
     *     'polling interval computation' Function in the 'poll' key. This
     *     Function will be bound to this object (so the 'this' reference point
     *     to this service) and will take the polling job as the only parameter.
     *     An example can be seen in the default Function that is used when this
     *     Function is not supplied in the polling parameters - this type's
     *     '$computeInterval' Function.
     * @param {TP.core.Hash|TP.sig.Request} pollParams Polling configuration
     *     parameters. These may include: 'poll' [true|false|Function]
     *     'pollFirstInterval' Number 'pollMaxInterval' Number.
     * @returns {TP.core.IOService} The receiver.
     */

    var firstInterval,
        maxInterval,

        controlParams,
        val,

        pollingJob;

    //  If we're already in 'poll mode', bail out.
    if (this.inPollMode()) {
        return this;
    }

    //  Construct the polling job with the following parameters:
    //      limit           TP.RETURN_FALSE         This job has no limit.
    //                                              It will not terminate
    //                                              until we explicitly tell
    //                                              it to do so.
    //      step            Polling function        The polling function.
    //                                              This should return true
    //                                              if data was received or
    //                                              false if not. That will
    //                                              be used by the decay
    //                                              function to determine
    //                                              whether it should decay
    //                                              more or reset to the
    //                                              firstInterval setting.
    //      interval        Interval function       Recomputed the polling
    //                                              interval after every
    //                                              poll. The default
    //                                              version of this function
    //                                              decays the interval by
    //                                              1000ms every time no
    //                                              data has been received
    //                                              by the polling process.
    //      firstInterval   firstInterval           The initial polling
    //                                              interval we should use.
    //                                              This will be adjusted by
    //                                              the decay function. The
    //                                              default is 3000ms.
    //      maxInterval     maxInterval             The maximum polling
    //                                              interval we should use.
    //                                              There will never be an
    //                                              interval longer than
    //                                              this between polls. The
    //                                              default is 60000ms.

    //  The initial job interval is whatever our 'firstInterval' is
    //  (defaults to 3000ms)
    firstInterval = this.get('firstInterval');

    //  The max interval is whatever our 'maxInterval' is (defaults to
    //  60000ms)
    maxInterval = this.get('maxInterval');

    if (TP.notValid(pollParams)) {
        controlParams = TP.hc('limit',
                                    TP.RETURN_FALSE,
                                'step',
                                    this.$poll.bind(this),
                                'interval',
                                    this.$computeInterval.bind(this),
                                'firstInterval',
                                    firstInterval,
                                'maxInterval',
                                    maxInterval);
    } else {
        controlParams = TP.hc('limit', TP.RETURN_FALSE,
                                'step', this.$poll.bind(this));

        if (TP.isValid(val = pollParams.at('poll')) && TP.isCallable(val)) {
            controlParams.atPut('interval', val.bind(this));
        } else {
            controlParams.atPut('interval',
                                this.$computeInterval.bind(this));
        }

        controlParams.atPut(
                    'firstInterval',
                    TP.isValid(pollParams.at('pollFirstInterval')) ?
                            pollParams.at('pollFirstInterval') :
                            firstInterval);

        controlParams.atPut(
                    'maxInterval',
                    TP.isValid(pollParams.at('pollMaxInterval')) ?
                            pollParams.at('pollMaxInterval') :
                            maxInterval);
    }

    pollingJob = TP.core.Job.construct(controlParams);

    this.set('$pollingJob', pollingJob);

    //  Start the polling job.
    pollingJob.start();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.IOService.Inst.defineMethod('stopPolling',
function() {

    /**
     * @method stopPolling
     * @summary Stop the service's polling behavior.
     * @returns {TP.core.IOService} The receiver.
     */

    //  If we're not already in 'poll mode', bail out.
    if (!this.inPollMode()) {
        return this;
    }

    //  complete is the nice way to shut down a job
    this.get('$pollingJob').complete();

    //  Set all 'polling-related' ivars back to their pre-polling state, in
    //  case we start polling again.
    this.set('$pollingJob', null);
    this.set('lastRequest', null);

    return this;
});

//  ========================================================================
//  TP.core.AuthenticatedService
//  ========================================================================

/**
 * @type {TP.core.AuthenticatedService}
 * @summary Traits type for authenticated services.
 */

TP.core.Service.defineSubtype('AuthenticatedService');

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation
TP.core.AuthenticatedService.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.AuthenticatedService.Type.defineMethod('isAuthenticated',
function(serviceName) {

    /**
     * @method isAuthenticated
     * @summary Returns whether or not the service is authenticated.
     * @param {String} [serviceName=this.getID()] The service name to test to
     *     see if its authenticated.
     * @returns {Boolean} true if the service is authenticated.
     */

    var name,
        inst;

    name = TP.ifInvalid(serviceName, this.getID());

    inst = this.getResourceById(name);

    if (TP.isValid(inst)) {
        return inst.isAuthenticated();
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.core.AuthenticatedService.Type.defineMethod('authenticate',
function(serviceName) {

    /**
     * @method authenticate
     * @summary Authenticate the service associated with the supplied name.
     * @param {String} serviceName The name of the service to authenticate. This
     *     should have been already registered with the receiver as a registered
     *     instance using this name.
     * @returns {TP.sig.AuthenticationRequest} The authentication request.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.AuthenticatedService.Inst.defineMethod('isAuthenticated',
function() {

    /**
     * @method isAuthenticated
     * @summary Returns whether or not the service is authenticated.
     * @returns {Boolean} true if the service is authenticated.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.core.AuthenticatedService.Inst.defineMethod('authenticateAndHandle',
function(aRequest) {

    /**
     * @method authenticateAndHandle
     * @param {TP.sig.Request} aRequest The request to handle after
     *     authentication (if necessary).
     * @returns {TP.core.AuthenticatedService} The receiver.
     */

    var isAuthenticated,

        authRequest;

    isAuthenticated = this.isAuthenticated();

    if (isAuthenticated) {
        this.processAuthenticatedRequest(aRequest);
    } else {
        authRequest = this.getType().authenticate(this.getID());

        //  The authentication succeeded.
        authRequest.defineHandler('RequestSucceeded',
            function(aResponse) {
                this.processAuthenticatedRequest(aRequest);
            }.bind(this));

        //  The authentication failed.
        authRequest.defineHandler('RequestFailed',
            function(aResponse) {
                aRequest.fail(aResponse);
            });
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.AuthenticatedService.Inst.defineMethod('processAuthenticatedRequest',
function(aRequest) {

    /**
     * @method processAuthenticatedRequest
     * @summary Processes the supplied request in an authenticated context. This
     *     means that the TIBET machinery has ensured that any required
     *     authentication has taken place (if necessary).
     * @param {TP.sig.Request} aRequest The request to handle after
     *     authentication (if necessary).
     * @returns {TP.core.AuthenticatedService} The receiver.
     */

    return this;
});

//  ========================================================================
//  TP.sig.AuthenticationRequest
//  ========================================================================

/**
 * @type {TP.sig.AuthenticationRequest}
 * @summary Common supertype for authentication requests.
 */

//  ------------------------------------------------------------------------

TP.sig.Request.defineSubtype('AuthenticationRequest');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.sig.AuthenticationRequest.Type.defineAttribute('responseType',
'TP.sig.AuthenticationResponse');

//  ========================================================================
//  TP.sig.AuthenticationResponse
//  ========================================================================

/**
 * @type {TP.sig.AuthenticationResponse}
 * @summary Common supertype for authentication responses.
 */

//  ------------------------------------------------------------------------

TP.sig.Response.defineSubtype('AuthenticationResponse');

//  ========================================================================
//  TP.sig.URIRequest
//  ========================================================================

/**
 * @type {TP.sig.URIRequest}
 * @summary Common supertype for URI-related requests.
 */

//  ------------------------------------------------------------------------

TP.sig.IORequest.defineSubtype('URIRequest');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.sig.URIRequest.Type.defineAttribute('responseType', 'TP.sig.URIResponse');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.URIRequest.Inst.defineMethod('getFinalURI',
function() {

    /**
     * @method getFinalURI
     * @summary Returns the final URI associated with this request.
     * @description There are effectively two URIs that are related to a
     *     request, the original "request URI" and the "final URI" which is the
     *     request URI with any uriparams expanded and applied to the URI query
     *     portion. This method returns the latter, the URI actually sent to the
     *     service during IO.
     * @returns {TP.uri.URI} The final request URI.
     */

    return this.at('finaluri') || this.getRequestURI();
});

//  ------------------------------------------------------------------------

TP.sig.URIRequest.Inst.defineMethod('getRequestURI',
function() {

    /**
     * @method getRequestURI
     * @summary Returns the target URI associated with this request.
     * @description There are effectively two URIs that are related to a
     *     request, the original "request URI" and the "final URI" which is the
     *     request URI with any uriparams expanded and applied to the URI query
     *     portion. This method returns the former, the URI used as the "root"
     *     of the request.
     * @returns {TP.uri.URI} The original request URI.
     */

    var responder;

    responder = this.get('responder');
    if (TP.isValid(responder)) {
        return responder.getRequestURI(this);
    }

    return this.at('uri');
});

//  ========================================================================
//  TP.sig.URIResponse
//  ========================================================================

/**
 * @type {TP.sig.URIResponse}
 * @summary Common supertype for URI-related responses.
 */

//  ------------------------------------------------------------------------

TP.sig.IOResponse.defineSubtype('URIResponse');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.URIResponse.Inst.defineMethod('getFinalURI',
function() {

    /**
     * @method getFinalURI
     * @summary Returns the final URI associated with this request.
     * @description There are effectively two URIs that are related to a
     *     request, the original "request URI" and the "final URI" which is the
     *     request URI with any uriparams expanded and applied to the URI query
     *     portion. This method returns the latter, the URI actually sent to the
     *     service during IO.
     * @returns {TP.uri.URI|undefined} The final request URI.
     */

    var request;

    request = this.get('request');
    if (TP.canInvoke(request, 'getFinalURI')) {
        return request.getFinalURI();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.URIResponse.Inst.defineMethod('getRequestURI',
function() {

    /**
     * @method getRequestURI
     * @summary Returns the target URI associated with this request.
     * @description There are effectively two URIs that are related to a
     *     request, the original "request URI" and the "final URI" which is the
     *     request URI with any uriparams expanded and applied to the URI query
     *     portion. This method returns the former, the URI used as the "root"
     *     of the request.
     * @returns {TP.uri.URI|undefined} The original request URI.
     */

    var request;

    request = this.get('request');
    if (TP.canInvoke(request, 'getRequestURI')) {
        return request.getRequestURI();
    }

    return;
});

//  ========================================================================
//  TP.uri.URIService
//  ========================================================================

/**
 * @type {TP.uri.URIService}
 * @summary Provides common functionality for services focused on processing
 *     URI-targeted requests. TP.uri.URIServices can be given an initial URI
 *     which will be used for all requests they process, or they can be
 *     initialized to handle certain request types with a variety of specific
 *     URIs provided by the requests themselves.
 */

//  ------------------------------------------------------------------------

TP.core.IOService.defineSubtype('uri.URIService');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  type-level service URI, used by all instances without their own which
//  respond to requests without a uri key
TP.uri.URIService.Type.defineAttribute('serviceURI');

//  This base type is configured to ignore username, pasword, auth and
//  iswebdav. Subtypes can provide an alternate hash.
TP.uri.URIService.Type.defineAttribute('defaultedParameters',
                            TP.hc('username', TP.NONE,
                                    'password', TP.NONE,
                                    'auth', TP.NONE,
                                    'iswebdav', false));

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  instance-specific service URI used by the instance when request doesn't
//  specify one
TP.uri.URIService.Inst.defineAttribute('serviceURI');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.uri.URIService.Inst.defineMethod('init',
function(resourceID, aRequest) {

    /**
     * @method init
     * @summary Returns an initialized instance of the receiver. If aRequest is
     *     provided it can help define the service's operation by providing a
     *     default serviceURI for the receiver. This uri is used when incoming
     *     requests don't provide a specific value.
     * @param {String} resourceID A unique service identifier.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An optional request or
     *     hash containing a serviceURI if the service is going to be tied to a
     *     particular target location.
     * @returns {TP.uri.URIService} A new instance.
     */

    var paramDict,

        serviceURI,
        requestURI;

    //  get the basic instance ready, ensuring it gets its resourceID
    this.callNextMethod(resourceID);

    //  define the server name based on:
    //  a)  any incoming request object that might be used to
    //      template/initiate the service
    //  b)  any vcard entry that the server might have in the application's
    //      configuration
    //  c)  prompting the user for the value(s)

    //  If a request was supplied, we can use that to store the values.
    //  Otherwise, just construct a hash to store them.
    if (TP.isValid(aRequest)) {
        paramDict = aRequest;
    } else {
        paramDict = TP.hc();
    }

    //  Check first to see if the request has 'serviceURI' parameter. This
    //  will override all other mechanisms.
    serviceURI = paramDict.at('serviceURI');

    //  Didn't have a 'serviceURI' parameter
    if (TP.isEmpty(serviceURI)) {
        //  If the request has a 'uri' parameter and its an absolute path,
        //  then use that as the serviceURI
        if (TP.notEmpty(requestURI = paramDict.at('uri')) &&
            TP.uriIsAbsolute(requestURI)) {
            serviceURI = requestURI;
        } else {
            //  Otherwise to populate any missing 'serviceURI' parameter in
            //  the request from the receiver's vcard entry using the vcard
            //  property matching the 'url' key.
            this.populateMissingVCardData(
                        TP.hc('serviceURI',
                                TP.ac('url',
                                    'Enter service URI: ')
                            ),
                        paramDict);

            //  Still don't have a valid service URI.
            if (TP.isEmpty(serviceURI = paramDict.at('serviceURI'))) {
                aRequest.fail(
                    TP.sc('Missing required URI parameter in request: ') +
                        'serviceURI');

                return this;
            }
        }
    }

    this.set('serviceURI', serviceURI);

    //  Try to populate any missing 'username' and 'password' parameters in
    //  the request from the receiver's vcard entry.
    this.populateMissingVCardData(
        TP.hc(
            'username',
            TP.ac('username',
                'Enter username: '),
            'password',
                TP.ac('password',
                'Enter password: '),
            'auth',
                TP.ac('auth',
                'Enter authentication scheme ("BASIC" or "DIGEST"): '),
            'iswebdav',
                TP.ac(
                'iswebdav',
                'Should server comm use WebDAV methods ("true or "false"): ')
            ),
        paramDict);

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.URIService.Inst.defineMethod('getRequestURI',
function(aRequest) {

    /**
     * @method getRequestURI
     * @summary Returns the URI to use for the request. This method ensures
     *     that each request has a viable target URI by defaulting to the
     *     receiver's serviceURI value if the request doesn't specify a URI of
     *     its own.
     * @param {TP.sig.Request} aRequest The request to check for a URI.
     * @returns {TP.uri.URI|undefined} The request URI.
     */

    var url;

    if (TP.notValid(url = aRequest.at('uri'))) {
        if (TP.notValid(url = this.get('serviceURI'))) {
            this.raise('TP.sig.InvalidURI',
                                'Request has no service URI.');
            return;
        }
    }

    return url;
});

//  ------------------------------------------------------------------------

TP.uri.URIService.Inst.defineMethod('getServiceURI',
function() {

    /**
     * @method getServiceURI
     * @summary Returns the default service URI for the receiver. This is the
     *     URI used when an individual request does not override it with an
     *     alternative URI.
     * @returns {TP.uri.URI} The receiver's default URI.
     */

    //  start with instance and work outward to the type
    return this.$get('serviceURI') || this.getType().get('serviceURI');
});

//  ------------------------------------------------------------------------

TP.uri.URIService.Inst.defineMethod('rewriteRequestURI',
function(aRequest) {

    /**
     * @method rewriteRequestURI
     * @summary Rewrites the request's URI, ensuring it defaults to the service
     *     URI and is rewritten to the current concrete location based on
     *     TIBET's rewriting rules.
     * @param {TP.sig.Request} aRequest The request to rewrite.
     * @returns {TP.uri.URI|undefined} The new/updated URI instance.
     */

    var requestURI,
        serviceURI,

        url;

    //  this will ensure we get the serviceURI if the request doesn't have
    //  one and that proper URI rewriting will occur across all requests

    requestURI = aRequest.at('uri');
    serviceURI = this.get('serviceURI');

    if (TP.notValid(requestURI) && TP.notValid(serviceURI)) {
        this.raise('TP.sig.InvalidURI',
                    'Request has no service URI.');

        return;
    }

    //  if we had a valid request URI, try to use it.
    if (TP.isURIString(requestURI)) {
        //  if request URI is absolute, we use that
        if (TP.uriIsAbsolute(requestURI)) {
            url = requestURI;
        } else if (TP.isURI(serviceURI)) {
            //  otherwise, the request URI must be relative - if we have a
            //  service URI, let's join paths with it.
            url = TP.uriJoinPaths(TP.uriCollectionPath(serviceURI),
                                    requestURI);
        } else {
            //  'requestURI' isn't absolute, but we don't have a service
            //  URI, so just use it and see what happens.
            url = requestURI;
        }
    } else {
        //  no request URI - just use the service URI.
        url = serviceURI;
    }

    //  do whatever rewriting we can to resolve to a concrete reference, but
    //  only if url is an absolute URI
    if (TP.uriIsAbsolute(url)) {
        url = TP.uri.URI.rewrite(url, aRequest).getLocation();
    }

    return url;
});

//  ------------------------------------------------------------------------

TP.uri.URIService.Inst.defineMethod('updateServiceURI',
function(aRequest) {

    /**
     * @method updateServiceURI
     * @summary If the supplied request has either a 'serviceURI' parameter or
     *     a 'uri' parameter that has an 'absolute path' value, we update our
     *     service URI to that value. This allows on-the-fly per-request
     *     retargeting of the endpoint URI that we represent.
     * @param {TP.sig.Request} aRequest The request to check for a new service
     *     URI.
     * @returns {TP.uri.URIService} The receiver.
     */

    var serviceURI;

    //  If either the request specified a 'serviceURI' or the 'uri' supplied
    //  in the request pointed to an absolute path, use that value as the
    //  new serviceURI.
    if (TP.isURI(serviceURI = aRequest.at('serviceURI')) ||
        TP.uriIsAbsolute(serviceURI = aRequest.at('uri'))) {
        this.set('serviceURI', serviceURI);
    }

    return this;
});

//  ========================================================================
//  TP.core.PromiseProvider
//  ========================================================================

TP.lang.Object.defineSubtype('TP.core.PromiseProvider');

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation
TP.core.PromiseProvider.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.PromiseProvider.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    this.defineDependencies('TP.extern.Promise');

    return;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

/**
 * A promise reference that points to the 'last promise' that was
 * allocated/initialized. Therefore, this promise reference can change as the
 * test case logic adds new Promises.
 * @type {Promise}
 */
TP.core.PromiseProvider.Inst.defineAttribute('$internalPromise');

/**
 * A promise reference that is kept by the test case for use by test case
 * logic as the case works its way through any 'stacking' logic whereby
 * fulfillment or rejection handlers have 'chain' statements within
 * the handler itself. See the 'chain' method for more information.
 * @type {Promise}
 */
TP.core.PromiseProvider.Inst.defineAttribute('$currentPromise');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.PromiseProvider.Inst.defineMethod('andAllowGUIRefresh',
function(windowContext) {

    /**
     * @method andAllowGUIRefresh
     * @summary A convenience method to give the GUI a chance to refresh.
     * @param {TP.core.Window} windowContext The window context to wait to be
     *     refreshed.
     * @returns {TP.core.PromiseProvider} The receiver.
     */

    this.chainPromise(TP.extern.Promise.construct(
        function(resolver, rejector) {
            resolver.queueAfterNextRepaint(windowContext.getNativeWindow());
        }));

    return this;
});

//  ------------------------------------------------------------------------

TP.core.PromiseProvider.Inst.defineMethod('andWait',
function(delayMS) {

    /**
     * @method andWait
     * @summary A convenience method to wait a certain number of milliseconds.
     * @param {Number} delayMS The number of milliseconds to wait.
     * @returns {TP.core.PromiseProvider} The receiver.
     */

    this.chainPromise(TP.extern.Promise.delay(delayMS));

    return this;
});

//  ------------------------------------------------------------------------

TP.core.PromiseProvider.Inst.defineMethod('andWaitFor',
function(anOrigin, aSignal, timeoutMS) {

    /**
     * @method andWaitFor
     * @summary A convenience method to wait until an origin has fired a
     *     certain signal.
     * @param {Object} anOrigin The signal origin to observe.
     * @param {TP.sig.Signal|String} aSignal The signal type or name to observe.
     * @param {Number} [timeoutMS] The number of milliseconds before timing out.
     * @returns {TP.core.PromiseProvider} The receiver.
     */

    var timeout;

    timeout = TP.ifInvalid(timeoutMS,
                            TP.sys.cfg('test.case_mslimit', 10000));

    this.chainPromise(TP.extern.Promise.construct(
        function(resolver, rejector) {
            var sigName,
                sigType,

                needsObserve,

                sigInst,
                currentHandler,

                handler;

            //  Compute the full signal name and/or the signal type.
            if (TP.isString(aSignal)) {
                sigName = TP.expandSignalName(aSignal);
                sigType = TP.sys.getTypeByName(sigName);
            } else {
                sigType = aSignal;
                sigName = aSignal.getSignalName();
            }

            if (TP.isType(sigType)) {

                //  If the signal type's default firing policy says that we need
                //  to observe in order to receive signals, then we'll do that.
                needsObserve = sigType.needsObserve();
            } else {
                //  Otherwise, it's probably a spoofed signal (i.e. one without
                //  a type), so we just set needsObserve to false (it's probably
                //  a RESPONDER_FIRING signal).
                needsObserve = false;
            }

            //  If the signal is one that needs observation, then set up an
            //  observation handler that will ignore the signal when its fired
            //  and then invoke the Promise's resolver.
            if (needsObserve) {
                handler = function(firedSignal) {
                    handler.ignore(anOrigin, aSignal);
                    resolver(firedSignal);
                };

                handler.observe(anOrigin, aSignal);
            } else {
                //  Otherwise, grab the handler on the origin (or it's
                //  supertype) that will execute when the signal fires.
                sigInst = TP.sig.SignalMap.$getSignalInstance(aSignal);
                currentHandler = anOrigin.getBestHandler(sigInst);

                //  Install a handler *locally* on the origin that will
                //  'callNextMethod' to do whatever the origin's type defines
                //  and then a) restores the handler to what it was and b)
                //  invokes the Promise's resolver.
                anOrigin.defineHandler(
                        aSignal,
                        function(firedSignal) {
                            this.callNextMethod();

                            anOrigin[currentHandler[TP.NAME]] = currentHandler;
                            resolver(firedSignal);
                        }, {
                            patchCallee: true
                        });
            }
        }).timeout(timeout));

    return this;
}, {
    patchCallee: false
});

//  ------------------------------------------------------------------------

TP.core.PromiseProvider.Inst.defineMethod('andIfNotValidWaitFor',
function(aCondition, anOrigin, aSignal, timeoutMS) {

    /**
     * @method andIfNotValidWaitFor
     * @summary A convenience method to test the return value of the supplied
     *     Function and, if its not valid, to wait until an original has fired a
     *     certain signal.
     * @description Note that, if the supplied function returned a not valid
     *     value and the signal is waited upon, that the function will be
     *     executed again once the signal is received, but the return value will
     *     *not* be checked..
     * @param {Function} aCondition The function to execute to determine the
     *     validity condition. This function *must* return the value to test for
     *     validity.
     * @param {Object} anOrigin The signal origin to observe.
     * @param {TP.sig.Signal|String} aSignal The signal type or name to observe.
     * @param {Number} [timeoutMS] The number of milliseconds before timing out.
     * @returns {TP.core.PromiseProvider} The receiver.
     */

    var result;

    result = aCondition();
    if (TP.isValid(result)) {
        return this;
    }

    this.andWaitFor(anOrigin, aSignal, timeoutMS);

    this.chain(
        function() {
            aCondition();
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.core.PromiseProvider.Inst.defineMethod('chain',
function(onFulfilled, onRejected) {

    /**
     * @method chain
     * @summary Queues a new promise with the receiver to be run after any other
     *     previously installed/queued promises complete. NOTE that this method
     *     is similar to 'then' but is intended for use in test suites and test
     *     cases to avoid issues with certain promise nesting scenarios.
     * @param {Function} onFulfilled The Function to run to if the Promise has
     *     been fulfilled.
     * @param {Function} onRejected The Function to run to if the Promise has
     *     been rejected.
     * @returns {TP.core.PromiseProvider} The receiver.
     */

    var internalPromise,
        lastPromise,

        thisref,

        _callback,
        _errback,

        newPromise;

    //  First, see if there's an existing internal promise. If not, create one
    //  and set the internal promise to be that.
    if (TP.notValid(internalPromise = this.$get('$internalPromise'))) {
        internalPromise = TP.extern.Promise.resolve();
        this.$set('$internalPromise', internalPromise);
    }

    //  Next, see if there's a 'current promise'. This is a Promise reference
    //  that would've been set 'higher up' (i.e. one frame back in a nested set
    //  of promises). If so, use that as the 'last promise' that we're going to
    //  append to. If not, use our internal promise.
    if (TP.notValid(lastPromise = this.$get('$currentPromise'))) {
        lastPromise = internalPromise;
    }

    thisref = this;

    //  Make sure that a callback function is defined. Either the supplied one
    //  or a simple one that returns the value.
    if (!TP.isCallable(_callback = onFulfilled)) {
        _callback = function(value) {
            return value;
        };
    }

    //  Make sure that an errback function is defined. Either the supplied one
    //  or a simple one that rejects with the reason
    if (!TP.isCallable(_errback = onRejected)) {
        _errback = function(reason) {
            return TP.extern.Promise.reject(reason);
        };
    }

    //  'then' onto our last promise with fulfillment/rejection handlers that
    //  manage a 'stacking' of nested Promises.
    newPromise = lastPromise.then(
        function(result) {

            var subPromise,
                maybe,
                subReturnPromise;

            //  First, allocated a 'sub promise' and set it as the 'current
            //  promise'. This will be used as the 'last promise' (see above)
            //  for any nested 'chain' statements *inside* of the fulfillment
            //  handler.
            subPromise = TP.extern.Promise.resolve();
            thisref.$set('$currentPromise', subPromise);

            //  Protect the callback in a try...catch to make sure that any
            //  errors result in the promise being rejected.
            try {
                maybe = _callback(result);
            } catch (e) {
                maybe = TP.extern.Promise.reject(e);
            }

            //  The fulfillment handler will have set the 'new promise' that it
            //  created as the 'current promise' (see below). We need that here.
            //  Note how we then null out the current promise - this is
            //  important to keep things straight.
            subReturnPromise = thisref.$get('$currentPromise');
            thisref.$set('$currentPromise', null);

            //  If we got a Promise back from the fulfillment handler, chain it
            //  on to the 'sub return promise' here.
            if (TP.isThenable(maybe)) {
                subReturnPromise = subReturnPromise.then(
                                        function() {
                                            return maybe;
                                        });
            }

            return subReturnPromise;
        },
        function(reason) {

            var subPromise,
                maybe,
                subReturnPromise;

            //  All of the same stuff above, except we're dealing with the
            //  rejection handler.

            subPromise = TP.extern.Promise.resolve();
            thisref.$set('$currentPromise', subPromise);

            //  Protect the errback in a try...catch to make sure that any
            //  errors that could happen as part of the errback itself result in
            //  the promise being rejected.
            try {
                maybe = _errback(reason);
            } catch (e) {
                maybe = TP.extern.Promise.reject(e);
            }

            subReturnPromise = thisref.$get('$currentPromise');
            thisref.$set('$currentPromise', null);

            if (TP.isThenable(maybe)) {
                subReturnPromise = subReturnPromise.then(
                                        function() {
                                            return maybe;
                                        });
            }

            return subReturnPromise;
        });

    //  Set both our 'internal promise' (used to track the last promise
    //  allocated) and the 'current promise' to the new promise we just
    //  obtained (which will either by the internal promise as obtained when we
    //  entered this method or the current promise set by our parent stack frame
    //  'earlier' in our computation).
    this.$set('$currentPromise', newPromise);
    this.$set('$internalPromise', newPromise);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.PromiseProvider.Inst.defineMethod('chainCatch',
function(aFunction) {

    /**
     * @method chainCatch
     * @summary A convenience mechanism to handling errors in test suite and
     *     test case promise chains.
     * @param {Function} aFunction The Function to run when an Error occurs.
     * @returns {TP.core.PromiseProvider} The receiver.
     */

    var internalPromise,

        lastPromise,
        newPromise;

    //  First, see if there's an existing internal promise. If not, create one
    //  and set the internal promise to be that.
    if (TP.notValid(internalPromise = this.$get('$internalPromise'))) {
        internalPromise = TP.extern.Promise.resolve();
        this.$set('$internalPromise', internalPromise);
    }

    //  Next, see if there's a 'current promise'. This is a Promise reference
    //  that would've been set 'higher up' (i.e. one frame back in a nested set
    //  of promises). If so, use that as the 'last promise' that we're going to
    //  append to. If not, use our internal promise.
    if (TP.notValid(lastPromise = this.$get('$currentPromise'))) {
        lastPromise = internalPromise;
    }

    //  'catch' onto our last promise, chaining on the promise we just
    //  allocated.
    newPromise = lastPromise.catch(aFunction);

    //  Set both our 'internal promise' (used to track the last promise
    //  allocated) and the 'current promise' to the new promise we just obtained
    //  by 'then'ing onto the 'last promise' (which will either by the
    //  internal promise as obtained when we entered this method or the current
    //  promise set by our parent stack frame 'earlier' in our computation.
    this.$set('$currentPromise', newPromise);
    this.$set('$internalPromise', newPromise);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.PromiseProvider.Inst.defineMethod('chainPromise',
function(aPromise) {

    /**
     * @method chainPromise
     * @summary Creates a Promise with the supplied Function and 'appends it'
     *     (if you will) onto the current internally-held Promise. Note that
     *     this operation will also reset the internally-held Promise to be the
     *     new Promise that it creates.
     * @param {TP.extern.Promise} aPromise The promise instance to chain.
     * @returns {TP.core.PromiseProvider} The receiver.
     */

    var internalPromise,
        lastPromise,
        newPromise;

    //  First, see if there's an existing internal promise. If not, create one
    //  and set the internal promise to be that.
    if (TP.notValid(internalPromise = this.$get('$internalPromise'))) {
        internalPromise = TP.extern.Promise.resolve();
        this.$set('$internalPromise', internalPromise);
    }

    //  Next, see if there's a 'current promise'. This is a Promise reference
    //  that would've been set 'higher up' (i.e. one frame back in a nested set
    //  of promises). If so, use that as the 'last promise' that we're going to
    //  append to. If not, use our internal promise.
    if (TP.notValid(lastPromise = this.$get('$currentPromise'))) {
        lastPromise = internalPromise;
    }

    //  'then' onto our last promise, chaining on the promise we just
    //  allocated.
    newPromise = lastPromise.then(
        function() {
            return aPromise;
        });

    //  Set both our 'internal promise' (used to track the last promise
    //  allocated) and the 'current promise' to the new promise we just obtained
    //  by 'then'ing onto the 'last promise' (which will either by the
    //  internal promise as obtained when we entered this method or the current
    //  promise set by our parent stack frame 'earlier' in our computation.
    this.$set('$currentPromise', newPromise);
    this.$set('$internalPromise', newPromise);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.PromiseProvider.Inst.defineMethod('reset',
function(options) {

    /**
     * @method reset
     * @summary Resets the receiver, putting instance variables back to their
     *     original values so it can be run again.
     * @param {TP.core.Hash} options A dictionary of test options.
     * @returns {TP.core.PromiseProvider} The receiver.
     */

    this.$set('$internalPromise', null);
    this.$set('$currentPromise', null);

    return this;
});

//  ========================================================================
//  TP.core.Controller
//  ========================================================================

/**
 * @type {TP.core.Controller}
 * @summary This type is a common supertype for all 'TIBET controllers',
 *     objects which form the top layers of the TIBET responder chain.
 *     Per the original Smalltalk-style definition a Controller is an object
 *     responsible primarily for event handling. As such TP.core.Controller
 *     instances are typically used in the "controller chain" or attached to
 *     elements via the tibet:ctrl attribute for "responder chain" usage.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.Controller');

//  ------------------------------------------------------------------------
//  Type Initialization
//  ------------------------------------------------------------------------

TP.core.Controller.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    TP.core.Controller.addTraits(TP.core.StateResponder);

    //  NOTE:   we define this method here because it's overriding a traited
    //  method and we need the traits to be in place or the callNextMethod
    //  invocation in the method will fail to find the traited version.
    TP.core.Controller.Inst.defineMethod('addStateMachine',
    function(aStateMachine) {

        /**
         * @method addStateMachine
         */

        var machines;

        machines = this.getStateMachines();
        if (machines.getSize() > 0) {
            return;
        }

        return this.callNextMethod();
    });

    return;
}, {
    patchCallee: false
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.Controller.Inst.defineMethod('getCurrentState',
function() {

    /**
     * @method getCurrentState
     * @summary Returns the state name of the most specific state of the
     *     receiver's state machine. This is the value of the state for the most
     *     nested state machine, if nested, or the core state machine itself.
     * @returns {String} The current most-specific state name.
     */

    return this.getCurrentStates().first();
});

//  ------------------------------------------------------------------------

TP.core.Controller.Inst.defineMethod('getCurrentStates',
function() {

    /**
     * @method getCurrentStates
     * @summary Returns an array of state names, from most specific to least
     *     specific in terms of most-nested child to outer-most state machine.
     * @returns {String[]} The current controller state list.
     */

    var stateMachine;

    stateMachine = this.getStateMachine();
    if (TP.isValid(stateMachine)) {
        return stateMachine.getCurrentStates();
    }

    return TP.ac();
});

//  ------------------------------------------------------------------------

TP.core.Controller.Inst.defineMethod('getStateMachine',
function() {

    /**
     * @method getStateMachine
     * @summary Returns the receiver's state machine, if it has one.
     * @returns {TP.core.StateMachine|undefined} The receiver's state machine
     *     instance.
     */

    //  During early signaling if we haven't initialized the type yet the state
    //  responder methods won't be live. We can fix that with this trick.
    if (TP.sys.hasInitialized()) {

        TP.core.Controller.Inst.defineMethod('getStateMachine',
        function() {
            return this.getStateMachines().first();
        });

        return this.getStateMachines().first();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.core.Controller.Inst.defineMethod('setStateMachine',
function(aStateMachine) {

    /**
     * @method setStateMachine
     * @summary Assigns a state machine instance to the receiver. Controllers
     *     which have state machines can leverage the current state as part of
     *     their signal processing to filter handlers based on state.
     * @param {TP.core.StateMachine} aStateMachine The new state machine
     *     instance.
     * @returns {TP.core.Controller} The receiver.
     */

    var machines;

    machines = this.getStateMachines();
    machines.empty();

    this.addStateMachine(aStateMachine);

    return this;
});

//  ========================================================================
//  TP.core.RouteController
//  ========================================================================

/**
 * @type {TP.core.RouteController}
 * @summary This type is a common supertype for all route controllers. The key
 *     aspect of this type is that it defines use of a singleton instance.
 */

//  ------------------------------------------------------------------------

TP.core.Controller.defineSubtype('RouteController');

TP.core.RouteController.Type.shouldUseSingleton(true);

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.core.RouteController.Inst.defineAttribute('router');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.RouteController.Inst.defineHandler('RouteFinalize',
function(aSignal) {

    /**
     * @method handleRouteFinalize
     * @summary A handler for any finalizations to the current application
     *     route.
     * @param {TP.sig.RouteFinalize} aSignal The finalization signal.
     * @returns {TP.core.RouteController} The receiver.
     */

     var refreshAction,

         route,

         contentTPElem,
         newContentTPElem,

         evt;

    //  'finalizeAction' is the action that should be taken when the route is
    //  finalized. It defaults to 'setcontent'.
    refreshAction = TP.ifEmpty(aSignal.at('finalizeAction'), 'setcontent');

    route = aSignal.at('route');

    switch (refreshAction) {
        case 'setcontent':
            //  If this route defines content and a target, then set it.
            contentTPElem = this.setContentForRoute(route);
            break;
        case 'refresh':
            //  If the route is configured to 'refresh only', then we're not
            //  going to give it new content - we're just going to refresh any
            //  data bindings under it.
            contentTPElem = this.getTargetElementForRoute(route);
            contentTPElem.setValue(route);
            contentTPElem.refresh();
            break;
        case 'norefresh':
            //  If the route is configured to not refresh, then don't refresh
            //  or set new content.
            contentTPElem = this.getTargetElementForRoute(route);
            contentTPElem.setValue(route);
            break;
        default:
            break;
    }

    //  If there was a valid content element associate with the route, query it
    //  to see if it can return a more specific content element.
    if (TP.isValid(contentTPElem)) {
        if (TP.canInvoke(contentTPElem, 'getContentForRoute')) {
            newContentTPElem = contentTPElem.getContentForRoute(route);
            if (TP.isValid(newContentTPElem)) {
                //  The content element had a more specific element to use as
                //  content - reset contentTPElem to it.
                contentTPElem = newContentTPElem;
            }
        }

        //  Send a custom native event to allow 3rd party libraries to know
        //  that the router has transitioned to a new route that has been
        //  finalized.

        evt = contentTPElem.getNativeDocument().createEvent('Event');
        evt.initEvent('TIBETRouteFinalized', true, true);

        //  Pass along the refresh action in the custom native event.
        /* eslint-disable quote-props,quotes */
        evt.detail = {'refreshAction': refreshAction};
        /* eslint-enable quote-props,quotes */

        contentTPElem.getNativeNode().dispatchEvent(evt);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.RouteController.Inst.defineMethod('getTargetElementForRoute',
function(aRoute) {

    /**
     * @method getTargetElementForRoute
     * @summary Returns the target element that is associated with the supplied
     *     route.
     * @param {String} [aRoute=URIRoute.getRoute()] The route to use. Defaults
     *     to the current application route acquired from the URI Router.
     * @returns {TP.dom.ElementNode|null} The route's associated target element,
           if one was associated with the route.
     */

    var route,

        routeKey,
        config,

        configInfo,
        routeTarget,
        targetTPElem,
        canvas;

    route = aRoute;

    //  If the route is empty, then set it to the current application route.
    if (TP.isEmpty(route)) {
        route = TP.sys.getRouter().getRoute();
    }

    //  If the route is still empty it's a reference to the home route.
    if (TP.isEmpty(route) || route === '/') {
        route = TP.sys.cfg('route.root', 'Home');
    }

    //  See if the value is a route configuration key.
    routeKey = 'route.map.' + route;
    config = TP.sys.cfg(routeKey);

    //  No configuration means no target/content information.
    if (TP.isEmpty(config)) {

        //  Don't warn for the Home route - many times, the app won't have a
        //  defined Home route.
        if (route !== TP.sys.cfg('route.root', 'Home')) {
            TP.warn('Unable to find route cfg info for: ' + route);
        }

        return null;
    }

    //  Convert any value we find into JSON so we can access values.
    if (TP.isString(config)) {
        configInfo = TP.json2js(TP.reformatJSToJSON(config));

        if (TP.isEmpty(configInfo)) {
            this.raise('InvalidObject',
                'Unable to build config data from entry: ' + config);
            return null;
        }
    } else {
        configInfo = config;
    }

    //  Grab the current UI canvas - we'll use this below to either obtain a
    //  target element or to set its location.
    canvas = TP.sys.getUICanvas();

    //  The target should be a 'path' (CSS selector, XPath, etc.) that can be
    //  used to obtain a target element.
    routeTarget = TP.ifInvalid(configInfo.at(routeKey + '.target'),
                                configInfo.at('target'));

    if (TP.notEmpty(routeTarget)) {

        //  NB: We want autocollapsed, but wrapped content here.
        targetTPElem = TP.byPath(routeTarget, canvas, true);
        if (!TP.isKindOf(targetTPElem, 'TP.dom.ElementNode')) {
            this.raise('InvalidElement',
                        'Unable to find route target: ' + routeTarget);
            return null;
        }

        return targetTPElem;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.core.RouteController.Inst.defineMethod('setContentForRoute',
function(aRoute) {

    /**
     * @method setContentForRoute
     * @summary Reads the configuration data for the route provided (or the
     *     current application route) and updates any identified target with
     *     the value of the 'content' key. Target is typically a URI pointing
     *     to some portion of the UI while 'content' is often a custom tag
     *     name or template URI which defines the content to be set.
     * @param {String} [aRoute=URIRoute.getRoute()] The route to use. Defaults
     *     to the current application route acquired from the URI Router.
     * @returns {TP.dom.ElementNode|null} The route's associated target element,
           if one was associated with the route.
     */

    var route,

        routeKey,
        config,

        configInfo,
        content,
        routeTarget,
        targetTPElem,
        canvas,
        type,
        url;

    route = aRoute;

    //  If the route is empty, then set it to the current application route.
    if (TP.isEmpty(route)) {
        route = TP.sys.getRouter().getRoute();
    }

    //  If the route is still empty it's a reference to the home route.
    if (TP.isEmpty(route) || route === '/') {
        route = TP.sys.cfg('route.root', 'Home');
    }

    //  See if the value is a route configuration key.
    routeKey = 'route.map.' + route;
    config = TP.sys.cfg(routeKey);

    //  No configuration means no target/content information.
    if (TP.isEmpty(config)) {

        //  Don't warn for the Home route - many times, the app won't have a
        //  defined Home route.
        if (route !== TP.sys.cfg('route.root', 'Home')) {
            TP.warn('Unable to find route cfg info for: ' + route);
        }

        return null;
    }

    //  Convert any value we find into JSON so we can access values.
    if (TP.isString(config)) {
        configInfo = TP.json2js(TP.reformatJSToJSON(config));

        if (TP.isEmpty(configInfo)) {
            this.raise('InvalidObject',
                'Unable to build config data from entry: ' + config);
            return null;
        }
    } else {
        configInfo = config;
    }

    //  ---
    //  Route-to-Content/Target mapping
    //  ---

    //  The content can be a tag type name, a URI or a String and if found we
    //  will use that content to update either a specific target or the body of
    //  the current UI canvas.
    content = TP.ifInvalid(configInfo.at(routeKey + '.content'),
                            configInfo.at('content'));
    if (TP.isEmpty(content)) {
        return null;
    }

    //  Grab the current UI canvas - we'll use this below to either obtain a
    //  target element or to set its location.
    canvas = TP.sys.getUICanvas();

    //  The target should be a 'path' (CSS selector, XPath, etc.) that can be
    //  used to obtain a target element.
    routeTarget = TP.ifInvalid(configInfo.at(routeKey + '.target'),
                                configInfo.at('target'));

    if (TP.notEmpty(routeTarget)) {

        //  NB: We want autocollapsed, but wrapped content here.
        targetTPElem = TP.byPath(routeTarget, canvas, true);
        if (!TP.isKindOf(targetTPElem, 'TP.dom.ElementNode')) {
            this.raise('InvalidElement',
                        'Unable to find route target: ' + routeTarget);
            return null;
        }
    }

    //  See if the content is a type name.
    type = TP.sys.getTypeByName(content);
    if (TP.canInvoke(type, 'generateMarkupContent')) {

        if (TP.notValid(targetTPElem)) {
            targetTPElem = canvas.getDocument().getBody();
        }

        //  Inject the content.
        targetTPElem.setContent(type.generateMarkupContent(),
                                TP.hc('sourceType', type));
    } else {

        //  Otherwise, see if the value looks like a URL for location.
        url = TP.uc(content);
        if (TP.isURI(url)) {

            url = TP.uriExpandHome(url);
            if (TP.sys.cfg('log.routes')) {
                TP.debug('setting location to: ' + TP.str(url));
            }

            //  If we weren't able to obtain a target, then just set the
            //  location of the canvas to the head of the URL.
            if (TP.notValid(targetTPElem)) {
                canvas.setLocation(TP.uriHead(url));
            } else {
                //  Otherwise, set the content of the target to the
                //  content of the URL
                targetTPElem.setContent(url);
            }
        } else {

            //  Otherwise, the content was a String. If we couldn't get
            //  a target, then use the document's body as the target and
            //  set the content.
            if (TP.notValid(targetTPElem)) {
                targetTPElem = canvas.getDocument().getBody();
            }

            //  Set the content of the target element. Note here how we supply
            //  the route name as the 'contentKey'. This can be used by
            //  intelligent elements to decide how to handle content that they
            //  might see more than once.
            targetTPElem.setContent(content, TP.request('contentKey', route));
        }
    }

    return targetTPElem;
});

//  ========================================================================
//  TP.core.Application
//  ========================================================================

/**
 * @type {TP.core.Application}
 * @summary TIBET's primary application controller type. All TIBET applications
 *     have an instance of Application as the root of their responder chain. The
 *     main application type is also responsible for handling the various
 *     signals involved in application startup such as AppStart.
 */

//  ------------------------------------------------------------------------

TP.core.Controller.defineSubtype('core.Application');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  The 'singleton' of this application's 'application object', normally
//  accessed through 'TP.sys.getApplication()'
TP.core.Application.Type.defineAttribute('singleton');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

/**
 * An array of controller instances which represent the current controller
 * stack. The list always ends with an Application instance or Lama instance
 * which serve as common backstops for controller signal handling.
 * @type {TP.core.Object[]}
 */
TP.core.Application.Inst.defineAttribute('controllers');

/**
 * An array of custom controllers pushed/popped via the pushController and
 * popController methods. Note that these controllers are always backed by
 * the current route controller, application instance, and Lama instance.
 * @type {TP.core.Object[]}
 */
TP.core.Application.Inst.defineAttribute('customControllers');

/**
 * Reference to an optional messagePort bridge between devtools and the running
 * TIBET application. This bridge connects TIBET instances running in apps with
 * the TIBET instance running in the optional Lama devtools extension.
 */
TP.core.Application.Inst.defineAttribute('devtoolsBridge');

/**
 * The router type whose route method is used to process client-side routes.
 * @type {TP.uri.URIRouter}
 */
TP.core.Application.Inst.defineAttribute('router');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.Application.Inst.defineMethod('finalizeGUI',
function() {

    /**
     * @method finalizeGUI
     * @summary Performs any UI presentation work necessary for startup. This
     *     method should be called by the application when it is ready to show
     *     its start GUI.
     * @returns {TP.core.Application} The receiver.
     */

    //  Show the UI root frame.
    TP.boot.showUIRoot();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Application.Inst.defineMethod('getControllers',
function(aSignal) {

    /**
     * @method getControllers
     * @summary Returns a list of controllers that are currently active.
     * @param {TP.sig.Signal} aSignal The signal currently being dispatched.
     * @returns {Object[]} The list of controllers.
     */

    var controllers;

    controllers = this.$get('controllers');

    if (TP.notValid(controllers)) {
        controllers = this.refreshControllers();
    }

    return controllers;
});

//  ------------------------------------------------------------------------

TP.core.Application.Inst.defineMethod('refreshControllers',
function() {

    /**
     * @method refreshControllers
     * @summary Rebuilds the list of controllers that the system uses as TIBET's
     *     "signal responder chain".
     * @param {TP.sig.Signal} aSignal The signal currently being dispatched.
     * @returns {Object[]} The list of controllers.
     */

    var controllers,

        lama,

        router,
        routeControllerType,
        routeController,

        customs;

    TP.debug('Refreshing controller stack...');

    controllers = TP.ac();
    this.$set('controllers', controllers, false);

    //  If the system has initialized and we're loading the Lama, then try to
    //  make it the last (i.e. topmost) controller if an instance can be found
    //  under the system ID 'Lama'.
    if (TP.sys.hasInitialized() && TP.sys.hasFeature('lama')) {
        lama = TP.bySystemId('Lama');
        if (TP.isValid(lama)) {
            controllers.push(lama);
        }
    }

    //  The application instance is always a member of this list
    controllers.push(this);

    //  We have to be far enough along that type initialization has happened or
    //  too much of the history/route processing infrastructure will be missing.
    if (!TP.sys.hasInitialized()) {
        controllers.reverse();
        return controllers;
    }

    //  Once we've started we also include any current route controller.

    //  Grab our router and the route controller type for the current route.
    router = this.getRouter();
    routeControllerType = router.getRouteControllerType();

    //  If we have a real type, then construct an instance. Note that, by
    //  default, the TP.core.RouteController (and, therefore, subtypes) are
    //  configured as singletons, which means we'll be reusing their state.
    if (TP.isType(routeControllerType)) {
        routeController = routeControllerType.construct();
        routeController.set('router', router);

        if (TP.isValid(routeController)) {
            controllers.push(routeController);
        }
    }

    //  Add in any custom controllers that have been registered with the
    //  application object.
    customs = this.$get('customControllers');
    if (TP.notEmpty(customs)) {
        controllers = controllers.concat(customs);
        this.$set('controllers', controllers, false);
    }

    //  Since we've been 'push'ing, we need to reverse to make sure things are
    //  in the proper order (most specific controllers to least specific - like
    //  Application, Lama, etc.).
    controllers.reverse();

    this.changed('Controllers', TP.UPDATE, TP.hc(TP.NEWVAL, controllers));

    return controllers;
});

//  ------------------------------------------------------------------------

TP.core.Application.Inst.defineMethod('getDevtoolsBridge',
function() {

    /**
     * @method getDevtoolsBridge
     * @summary Returns any current instance of extension bridge used to message
     *     between the application and TIBET-driven devtools extensions.
     * @returns {TP.lama.ExtensionBridge} An optional bridge instance.
     */

    return this.$get('devtoolsBridge');
});

//  ------------------------------------------------------------------------

TP.core.Application.Inst.defineMethod('getHistory',
function() {

    /**
     * @method getHistory
     * @summary Returns the current object responsible for managing history for
     *     the application, which focuses on history for the UICANVAS window.
     * @returns {TP.core.History} A History object.
     */

    //  NB: All TP.core.History functionality is type-level, which is why we
    //  return the type itself here.
    return TP.core.History;
});

//  ------------------------------------------------------------------------

TP.core.Application.Inst.defineMethod('getRouter',
function() {

    /**
     * @method getRouter
     * @summary Returns the current router instance used by the application.
     * @returns {TP.uri.URIRouter|null} The active router.
     */

    var type,
        name;

    type = this.$get('router');
    if (TP.canInvoke(type, 'route')) {
        return type;
    }

    name = TP.sys.cfg('uri.router');
    type = TP.sys.getTypeByName(name);

    if (TP.canInvoke(type, 'route')) {
        this.$set('router', type);
        return type;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.core.Application.Inst.defineMethod('getTheme',
function() {

    /**
     * @method getTheme
     * @summary Returns the *current* UI 'project' theme.
     * @description Note that the current UI canvas might be configured with
     *     both a 'lib' theme and a 'project' theme. The value returned here
     *     will always be the 'project' theme and will taken from the current
     *     canvas's data-theme value or the value for project.theme.default if
     *     no theme is currently set.
     * @returns {String} The name of the current UI theme.
     */

    var uiTPDoc,
        docTheme;

    uiTPDoc = TP.sys.getUICanvas().getDocument();
    if (TP.isValid(uiTPDoc)) {
        docTheme = uiTPDoc.getTheme();
    }

    return TP.ifEmpty(docTheme,
                        TP.sys.getcfg('project.theme.default',
                            TP.sys.getcfg('tibet.theme.default')));
});

//  ------------------------------------------------------------------------

TP.core.Application.Inst.defineMethod('popController',
function() {

    /**
     * @method popController
     * @summary Pops the current top controller off the controller stack. The
     *     application instance will not be removed if it is the only controller
     *     remaining.
     * @returns {TP.core.Controller|undefined} The controller that was popped.
     */

    var controllers;

    controllers = this.$get('customControllers');
    if (TP.notValid(controllers)) {
        return;
    }

    return controllers.pop();
});

//  ------------------------------------------------------------------------

TP.core.Application.Inst.defineMethod('pushController',
function(aController) {

    /**
     * @method pushController
     * @summary Pushes a new controller onto the controller stack. The
     *     controller stack is a built-in part of TIBET's "signal responder
     *     chain" so managing the controller stack is a key part of managing
     *     application event processing.
     * @param {TP.core.Controller} aController The controller to push.
     * @returns {TP.core.Application} The receiver.
     */

    var controllers;

    if (TP.notValid(aController)) {
        return this.raise('InvalidController');
    }

    controllers = this.$get('customControllers');
    if (TP.notValid(controllers)) {
        controllers = TP.ac();
        this.$set('customControllers', controllers, false);
    }

    //  Make sure that the list of custom controllers doesn't already include
    //  the supplied controller.
    if (!controllers.contains(aController, TP.IDENTITY)) {
        controllers.push(aController);

        //  Refresh the main list of controllers.
        this.refreshControllers();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Application.Inst.defineMethod('removeController',
function(aController) {

    /**
     * @method removeController
     * @summary Removes the supplied controller from the controller stack.
     * @param {TP.core.Controller} aController The controller to remove.
     * @returns {TP.core.Application} The receiver.
     */

    var controllers;

    if (TP.notValid(aController)) {
        return this.raise('InvalidController');
    }

    controllers = this.$get('customControllers');
    if (TP.notValid(controllers)) {
        return this;
    }

    //  Make sure that the list of custom controllers includes the supplied
    //  controller because once we remove then we have to rebuild the controller
    //  list.
    if (controllers.contains(aController, TP.IDENTITY)) {
        controllers.remove(aController, TP.IDENTITY);

        //  Refresh the main list of controllers.
        this.refreshControllers();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Application.Inst.defineMethod('setControllers',
function(aList) {

    /**
     * @method setControllers
     * @summary Defines the list of controllers that are currently active.
     * @param {Object[]} aList The new list of controllers.
     * @returns {TP.core.Application} The receiver.
     */

    var controllers;

    controllers = aList;
    if (TP.notValid(controllers)) {
        controllers = TP.ac();
    }
    if (!TP.isArray(controllers)) {
        return this.raise('InvalidParameter');
    }

    this.$set('customControllers', controllers, false);

    //  Refresh the main list of controllers.
    this.refreshControllers();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Application.Inst.defineMethod('setTheme',
function(themeName) {

    /**
     * @method setTheme
     * @summary Defines the current application theme. The value provided is
     *     placed on the UICANVAS's body element as the value for data-theme
     *     and an appropriate change signal is triggered for observers to update
     *     if they respond to changes in theme.
     * @param {String} themeName The name of the new theme.
     * @returns {TP.core.Application} The receiver.
     */

    var canvas;

    //  Update the current canvas to reflect any changes.
    canvas = TP.sys.getUICanvas();
    if (TP.isValid(canvas)) {
        canvas.setTheme(themeName);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Application.Inst.defineMethod('setRouter',
function(aRouter) {

    /**
     * @method setRouter
     * @summary Sets the supplied router instance as TIBET's active router.
     * @param {TP.uri.URIRouter} aRouter The router to set as the active
     *     router.
     * @returns {TP.core.Application} The receiver.
     */

    if (TP.canInvoke(aRouter, 'route')) {
        this.$set('router', aRouter);
    } else {
        return this.raise('InvalidRouter');
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Application.Inst.defineMethod('start',
function(aSignal) {

    /**
     * @method start
     * @summary Starts the application, performing any initialization necessary
     *     for startup.
     * @param {TP.sig.AppStart} aSignal The  start signal that triggered out
     *     startup sequence.
     * @returns {TP.core.Application} The receiver.
     */

    var signal;

    signal = aSignal;

    //  Do any final steps to ensure the UI is ready for operation.
    this.finalizeGUI();

    (function() {

        var elem,
            rootWin,
            homeURL,
            bridge,
            evt;

        //  If we're not running in a Chromium extension, then focus the root
        //  window, set up the home page configuration and populate the window's
        //  history.
        if (TP.sys.inExtension() !== true) {

            //  Grab the UI root window and focus it if possible.
            if (TP.isElement(elem = signal.at('ApplicationTag'))) {
                if (TP.isWindow(rootWin = TP.nodeGetWindow(elem))) {
                    rootWin.focus();
                }
            }

            //  Note that we check and clear sessionStorage here to avoid having
            //  any values set by a bookmark or reload operation on a hooked file
            //  from hanging around and affecting future operations.
            if (TP.global.sessionStorage) {
                homeURL = TP.global.sessionStorage.getItem(
                    'TIBET.project.home_page');
                if (TP.notEmpty(homeURL)) {
                    //  Preserve the value in runtime config to support the
                    //  TP.sys.getHomeURL call.
                    TP.sys.setcfg('session.home_page', homeURL);

                    TP.global.sessionStorage.removeItem(
                                    'TIBET.project.home_page');
                }
            }

            //  If we're asked to trigger routing on startup do that to properly
            //  set the initial path context.
            if (TP.notEmpty(homeURL)) {
                this.getHistory().pushLocation(homeURL);
            } else if (TP.sys.cfg('route.onstart')) {
                this.getRouter().route(TP.topWindow.location.toString());
            }
        }

        //  Install debugger bridge as needed. Installation is done by the
        //  bridge instance when it's created.
        if (TP.sys.inExtension() === true ||
                TP.sys.hasFeature('lama') &&
                TP.isValid(TP.bySystemId('TP.lama.ExtensionBridge'))) {
            bridge = TP.lama.ExtensionBridge.construct();
            this.set('devtoolsBridge', bridge);
        }

        try {
            TP.boot.$setStage('liftoff');
        } finally {
            //  Set our final stage/state flags so dependent pieces of logic can
            //  switch to their "started" states (ie. no more boot log usage
            //  etc.)
            TP.sys.hasStarted(true);
        }

        //  Either way, we should broadcast a native TIBETAppDidStart event to
        //  let components (especially those in Chromium extensions) know that
        //  TIBET is started.
        evt = TP.topWindow.document.createEvent('Event');
        evt.initEvent('TIBETAppDidStart', true, true);
        TP.topWindow.document.body.dispatchEvent(evt);

        //  Signal that everything is ready and that the application did start.
        this.signal('TP.sig.AppDidStart');
    }.bind(this)).queueAfterNextRepaint(TP.sys.uiwin(true));

    return this;
});

//  ------------------------------------------------------------------------
//  Handlers
//  ------------------------------------------------------------------------

TP.core.Application.Inst.defineHandler('AppStart',
function(aSignal) {

    /**
     * @method handleAppStart
     * @summary A handler that is called when the system has loaded everything
     *     and is ready to activate your TIBET application.
     * @param {TP.sig.AppStart} aSignal The start signal.
     * @returns {TP.core.Application} The receiver.
     */

    TP.core.Application.get('singleton').start(aSignal);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Application.Inst.defineHandler('AppStop',
function(aSignal) {

    /**
     * @method handleAppStop
     * @summary A handler that is called when the user is ready to terminate
     *     your TIBET application.
     * @param {TP.sig.AppStop} aSignal The stop signal.
     * @returns {TP.core.Application} The receiver.
     */

    var exitToURI;

    //  If the signal defines an 'exitTo' property in its payload, then try to
    //  create a URI from that.
    exitToURI = aSignal.at('exitTo');

    if (TP.notEmpty(exitToURI)) {
        exitToURI = exitToURI.unquoted();

        //  If the URI that the user wants to exit to starts with a '/', then
        //  prepend the primary location of the concrete URI of '~' onto it.
        //  Since this value has a trailing slash, we slice off the '/' from the
        //  supplied value.
        if (exitToURI.startsWith('/') && exitToURI.getSize() > 1) {
            exitToURI = TP.uc('~').getConcreteURI().get('primaryLocation') +
                        exitToURI.slice(1);
        }
        exitToURI = TP.uc(exitToURI);
    }

    //  Call terminate and, if it was defined, navigate to the URI given.
    TP.sys.terminate(exitToURI);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Application.Inst.defineHandler('DevtoolsInput',
function(aSignal) {

    //  DevtoolsInput is our from app to devtools signal. If we're in
    //  the app we want to ignore these.
    if (!TP.sys.inExtension() || aSignal.getOrigin() === this) {
        aSignal.preventDefault();
        aSignal.stopPropagation();
        return this;
    }

    TP.debug('the app sends its love...');
    TP.debug('...and: ' + aSignal.getPayload());

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Application.Inst.defineHandler('DevtoolsMessage',
function(aSignal) {

    /**
     * @method handleDevtoolsMessage
     * @summary Handles requests to send information across the devtools
     *     extension bridge (if active). Consumers of the bridge signal a
     *     'DevtoolsMessage' and it's picked up here, then forwarded to
     *     the bridge instance to handle.
     * @param {TP.sig.DevtoolsMessage} aSignal The message-bearing signal.
     * @returns {TP.core.Application} The receiver.
     */

    var bridge;

    bridge = this.getDevtoolsBridge();
    if (TP.isValid(bridge)) {
        return bridge.send(aSignal);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Application.Inst.defineHandler('DevtoolsOutput',
function(aSignal) {

    //  DevtoolsOutput is from extension to app signal. If we're in the
    //  extension we want to ignore these.
    if (TP.sys.inExtension() || aSignal.getOrigin() === this) {
        aSignal.preventDefault();
        aSignal.stopPropagation();
        return this;
    }

    TP.debug('devtools sends its love...');
    TP.debug('...and: ' + aSignal.getPayload());

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Application.Inst.defineHandler('RouteFinalize',
function(aSignal) {

    /**
     * @method handleRouteFinalize
     * @summary A handler for any finalizations to the current application
     *     route. The default integrates route change notifications with any
     *     current application state machine to let the application state
     *     reflect the current route.
     * @param {TP.sig.RouteFinalize} aSignal The finalization signal.
     * @returns {TP.core.Application} The receiver.
     */

    var machine,
        signame,
        route,
        targets;

    //  Grab the current state machine
    machine = this.getStateMachine();

    //  If it's valid and active, and if the signal has a supplied route, then
    //  compute a state name from the signal's type name, removing the 'Route'
    //  part of the name.
    if (TP.isValid(machine) && machine.isActive()) {

        route = aSignal.at('route');
        if (TP.isEmpty(route)) {
            signame = TP.expandSignalName(aSignal.getSignalName());
            route = signame.split('.').last().strip(/Route/);
        }

        targets = machine.getTargetStates();
        if (targets.contains(TP.core.StateMachine.normalizeState(route))) {
            //  NOTE: do NOT send the route signal back into the transition here
            //  or things will get recursive. We can pass payload data though.
            machine.transition(route, aSignal.getPayload());
        }
    }

    return this;
});

//  ========================================================================
//  APP.headless.Application
//  ========================================================================

//  Only here to allow Puppeteer et. al. to potentially have their own type for
//  managing application-level logic.
TP.core.Application.defineSubtype('APP.headless.Application');

//  ========================================================================
//  TP.core.History
//  ========================================================================

/**
 * @type {TP.core.History}
 * @summary This type provides an interface to the window history for use
 *     in managing history-related events and activities. Its most important
 *     role is in handling low-level onpopstate events and triggering the
 *     application URI routing machinery as well as tracking any back/forward
 *     button operations.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.History');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  tracks the last direction of history traversal recorded.
TP.core.History.Type.defineAttribute('direction', null);

//  the last URI in place prior to any action by the history object. this value
//  is used for comparison during route() calls in the URIRouter.
TP.core.History.Type.defineAttribute('lastURI', null);

//  a list of the locations which this object has traversed.
TP.core.History.Type.defineAttribute('history');

//  the current index in the history list. Note this value may not correspond to
//  the actual browser's view of the world if low-level API has been used.
TP.core.History.Type.defineAttribute('index', 0);

//  the 'last valid' index at the end of history that the user can move to.
//  Sometimes if the user has reloaded and we had stored history, and the user
//  tries to move forward in that history, checks for the last valid index can
//  prevent this
TP.core.History.Type.defineAttribute('lastValidIndex', 0);

//  an index offset used to help track direction of any operation in progress.
//  Should be null when computation of an offset can't be done properly.
TP.core.History.Type.defineAttribute('offset', null);

//  a flag to turn off onpopstate handing during operations which incorrectly
//  fire it on Chrome et. al.
TP.core.History.Type.defineAttribute('popstate', true);

//  an alternative native location that should be reported when calling
//  getNativeLocation() on this type.
TP.core.History.Type.defineAttribute('$$overrideLocation', null);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    var sessionHistory;

    //  Install a popstate handler to catch changes due to history API. Note
    //  that installing this on the main code frame (i.e. top level window)
    //  probably won't have much effect since navigations will come from UI
    //  events in the canvas window. A popstate event hook is installed for them
    //  in the loader.
    window.addEventListener('popstate',
                            function(evt) {
                                this.onpopstate(evt);
                            }.bind(this), false);

    //  See if the session storage had a stored session history. If so, restore
    //  our history from that.
    sessionHistory = TP.global.sessionStorage.getItem(
                                                'TIBET.boot.session_history');
    if (TP.isValid(sessionHistory)) {

        //  Restore the session history from the (JSON) value stored in session
        //  storage.
        this.restoreSessionHistory(sessionHistory);
    } else {

        //  Otherwise, we're starting fresh.

        //  Create a history list the size of the current native list.
        this.$set('history', TP.ac());

        //  Capture initial history location as our starting point.
        this.captureHistory();

        //  Store off the session history in the browser's session storage.
        this.saveSessionHistory();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('back',
function() {

    /**
     * @method back
     * @summary Causes the receiver to go back a page in browser history.
     * @returns {TP.meta.core.History} The receiver.
     */

    this.set('direction', 'back', false);
    this.set('lastURI', this.getLocation(), false);

    this.getNativeWindow().history.back();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('captureDocumentLocation',
function(aDocument) {

    /**
     * @method captureDocumentLocation
     * @summary Captures history information from the document provided. This is
     *     typically called in response to document changes in the UICANVAS to
     *     ensure the top-level history reflects the content page.
     * @param {Document} aDocument The native document to capture from.
     * @returns {Array<Object, String, String>|undefined} The history entry with
     *     state object, title, and url.
     */

    var loc,
        locParts,
        url,
        urlParts;

    if (!TP.isDocument(aDocument)) {
        this.raise('InvalidDocument');
        return;
    }

    loc = TP.documentGetLocation(aDocument);
    if (TP.isEmpty(loc)) {
        return;
    }

    //  The pushLocation call can handle parameters but it won't get the route
    //  rebuilt from "last" properly so we do that here.
    url = TP.sys.getHistory().getLocation();

    locParts = TP.uriDecompose(loc);
    urlParts = TP.uriDecompose(url);

    if (locParts.at('fragmentPath') === '/') {
        locParts.atPut('fragmentPath', urlParts.at('fragmentPath'));
    }

    loc = TP.uriCompose(locParts);

    return TP.sys.getHistory().pushLocation(loc, true);
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('captureHistory',
function(anIndex) {

    /**
     * @method captureHistory
     * @summary Captures the current state, title, and url data for the browser
     *     at the moment of invocation. Used internally to capture state when
     *     a history event occurs which affects the top URL bar value.
     * @param {Number} [anIndex] The index to update. Default is current index.
     * @returns {Array<Object, String, String>} The history entry with state
     *     object, title, and url.
     */

    var win,
        index,
        state,
        entry,
        title,
        url;

    //  Capture startup history information.
    win = this.getNativeWindow();
    title = win.title || '';
    url = TP.uriNormalize(win.location.toString());

    index = anIndex;
    if (TP.notValid(index)) {
        index = this.get('index');
    }
    state = {};
    state.index = index;

    entry = TP.ac(state, title, url);

    //  Save the entry as our current entry for current index. This should
    //  update our history list as we traverse back/forth.
    this.get('history').atPut(index, entry);

    if (TP.sys.cfg('log.history')) {
        this.reportLocation();
    }

    return entry;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('forward',
function() {

    /**
     * @method forward
     * @summary Causes the receiver to go forward a page in browser history.
     * @returns {TP.meta.core.History} The receiver.
     */

    this.set('direction', 'forward', false);
    this.set('lastURI', this.getLocation(), false);

    this.getNativeWindow().history.forward();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('getHistory',
function() {

    /**
     * @method getHistory
     * @summary Returns the current local history list.
     * @returns {String[]} The current history list.
     */

    var history;

    history = this.$get('history');
    if (TP.notValid(history)) {
        history = TP.ac();
        this.$set('history', history);
    }

    return history;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('getIndex',
function() {

    /**
     * @method getIndex
     * @summary Returns the current index in the history list.
     * @returns {Number} The current history list index.
     */

    return this.$get('index');
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('getLastDeepRootIndex',
function() {

    /**
     * @method getLastDeepRootIndex
     * @summary Returns the last 'deep root' index. That is, the index of the
     *     history entry closest to the 'end' (or the 'top') of the history that
     *     that can be considered a deep root
     * @returns {Number} The index of the last deep root.
     */

    var entries,

        len,
        i,

        url;

    entries = this.get('history');

    //  Iterate backwards through the history list.
    len = entries.getSize();
    for (i = len; i--; i >= 0) {

        //  The URL is always in the second position of the entry.
        url = entries.at(i).at(2);

        //  If the URL has a '?' along with trailing parameter content, then
        //  slice the '?' and that content off.
        if (url.contains('?')) {
            url = url.slice(0, url.indexOf('?'));
        }

        //  If the URL does not contain '/#' or contains '/#', but does not end
        //  with it, then it can be considered the 'last deep root'.
        /* eslint-disable no-extra-parens */
        if (!url.contains('/#') ||
            (url.contains('/#') && !url.endsWith('/#'))) {
            return i;
        }
        /* eslint-enable no-extra-parens */
    }

    return TP.NOT_FOUND;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('getLastLocation',
function() {

    /**
     * @method getLastLocation
     * @summary Returns the previous location in the history list, if any.
     * @returns {String|null} The location at the prior history index.
     */

    var entry;

    //  NOTE we can't use "at()" here since it supports negative indexes and we
    //  may produce one if we're at the start of the list (index 0).
    entry = this.get('history')[this.get('index') - 1];

    if (TP.isValid(entry)) {
        return entry.at(2);
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('getLocation',
function() {

    /**
     * @method getLocation
     * @summary Returns the current location in the history list.
     * @returns {String} The location at the current history index.
     */

    var history,
        entry,
        index;

    history = this.get('history');
    index = this.get('index');
    entry = history.at(index);

    if (TP.notValid(entry)) {
        entry = this.captureHistory();
    }

    return entry.at(2);
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('getLocationIndexes',
function(aLocation) {

    /**
     * @method getLocationIndexes
     * @summary Returns any array of history indexes where the location can be
     *     found. This is used to inform the updateIndex routine.
     * @param {String} [aLocation] The location to search for. Defaults to the
     *     current native location.
     * @returns {String} The location at the current history index.
     */

    var loc,
        list;

    loc = TP.str(aLocation) || this.getNativeLocation();
    list = TP.ac();

    this.get('history').forEach(
                        function(entry, index) {
                            if (entry.at(2) === loc) {
                                list.push(index);
                            }
                        });

    return list;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('getNativeLocation',
function() {

    /**
     * @method getNativeLocation
     * @summary Retrieves the native window location.
     * @returns {String} The current native window location.
     */

    var loc;

    //  First, see if an overriding location has been supplied. If not, then use
    //  the location of our window.
    loc = this.get('$$overrideLocation');
    if (TP.notValid(loc)) {
        loc = TP.uriNormalize(this.getNativeWindow().location.toString());
    }

    return loc;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('getNativeState',
function() {

    /**
     * @method getNativeState
     * @summary Returns any state object associated with the browser history
     *     location.
     * @returns {Object} Any state object associated via pushState or
     *     replaceState for the current browser location.
     */

    return this.getNativeWindow().history.state;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('getNativeTitle',
function() {

    /**
     * @method getNativeTitle
     * @summary Returns any title associated with the browser history location.
     * @returns {String} The title of the native window.
     */

    return this.getNativeWindow().title;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('getNativeWindow',
function() {

    /**
     * @method getNativeWindow
     * @summary Retrieves the native window the history object manages.
     * @returns {Window} The native window instance.
     */

    return window;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('getNextLocation',
function() {

    /**
     * @method getNextLocation
     * @summary Returns the next location in the history list, if any.
     * @returns {String|null} The location at the next history index.
     */

    var entry;

    entry = this.get('history').at(this.get('index') + 1);

    if (TP.isValid(entry)) {
        return entry.at(2);
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('getSize',
function() {

    /**
     * @method getSize
     * @summary Returns the number of entries in the history list.
     * @returns {Number} The number of entries in the local history list.
     */

    return this.get('history').getSize();
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('getState',
function() {

    /**
     * @method getState
     * @summary Returns any state object associated with the current history
     *     location.
     * @returns {Object} Any state object associated via pushState or
     *     replaceState for the current location.
     */

    return this.get('history').at(this.get('index')).at(0);
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('getTitle',
function() {

    /**
     * @method getTitle
     * @summary Returns any title associated with the current local history
     *     location.
     * @returns {String} Any title associated via pushState or replaceState
     *     for the current location.
     */

    return this.get('history').at(this.get('index')).at(1);
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('go',
function(anOffset) {

    /**
     * @method go
     * @summary Causes the receiver to go to a specific offset from the current
     *     location in window history.
     * @param {Number} anOffset A positive or negative number of pages to go in
     *     the browser history.
     * @returns {TP.meta.core.History} The receiver.
     */

    if (!TP.isNumber(anOffset)) {
        return this.raise('InvalidParameter', anOffset);
    }

    //  no-op
    if (anOffset === 0) {
        return this;
    }

    this.set('direction', anOffset < 0 ? 'back' : 'forward', false);
    this.set('lastURI', this.getLocation(), false);

    this.getNativeWindow().history.go(anOffset);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('gotoFirst',
function() {

    /**
     * @method gotoFirst
     * @summary Causes the receiver to go to the first location entry in window
     *         history.
     * @returns {TP.meta.core.History} The receiver.
     */

    var currentIndex;

    currentIndex = this.get('index');

    //  no-op
    if (currentIndex === 0) {
        return this;
    }

    this.go(-currentIndex);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('gotoLast',
function() {

    /**
     * @method gotoLast
     * @summary Causes the receiver to go to the last location entry in window
     *         history.
     * @returns {TP.meta.core.History} The receiver.
     */

    var lastIndex,
        currentIndex;

    lastIndex = this.getSize() - 1;

    currentIndex = this.get('index');

    //  no-op
    if (currentIndex === lastIndex) {
        return this;
    }

    this.go(lastIndex - currentIndex);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('isLocationRoutable',
function(aLocation) {

    /**
     * @method isLocationRoutable
     * @summary Returns true if the supplied location is routable, that is, if
     *     the TIBET router is going to handle it. Otherwise, its just a link
     *     traversla.
     * @param {String} aLocation The location to check.
     * @returns {Boolean} Whether or not the supplied location is routable.
     */

    var loc,
        appHead;

    if (!TP.isString(aLocation)) {
        return this.raise('InvalidParameter', aLocation);
    }

    //  The route has a '#/' or '#?', so return true
    if (/#(\/|\?)/.test(aLocation)) {
        return true;
    }

    //  Normalize the location with a trailing slash.
    loc = aLocation;
    if (!loc.endsWith('/')) {
        loc += '/';
    }

    //  Grab the appHead. This will be the head of the URL before any fragment
    //  identifiers.
    appHead = TP.getAppHead();

    return loc === appHead;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('onpopstate',
function(anEvent) {

    /**
     * @method onpopstate
     * @summary A native browser-level event handler invoked when the user
     *     has changed the window URL through use of the back or forward buttons
     *     or the developer used back(), forward(), go(), or 'location' slot.
     * @param {Event} anEvent The native event that caused this handler to trip.
     * @returns {TP.meta.core.History} The receiver.
     */

    var historyWindow,
        eventWindow,

        state,
        eventState,

        index,

        eventInCanvas,

        stateIndex,

        eventLocation,

        direction,

        newIndex,

        newState,

        router,
        loc;

    //  We use a flag to turn off handling on Chrome in particular since it has
    //  a habit of signaling this for a number of incorrect cases.
    if (TP.isFalse(this.get('popstate'))) {
        return this;
    }

    historyWindow = this.getNativeWindow();
    eventWindow = TP.eventGetTarget(anEvent);

    state = this.getNativeState();
    eventState = anEvent.state;

    index = this.get('index');

    eventInCanvas = false;

    //  If the event window is the same as our native window (the top-level
    //  window where we're tracking history), then we can use the history,
    //  state, etc. from our history object to navigate.
    if (historyWindow === eventWindow) {

        if (TP.isValid(state)) {
            //  The url is what we really set as content, the 'pushed' value is
            //  what the URL bar was set to (which will often vary for base path
            //  usage).
            loc = state.url;
        }

        //  If we couldn't compute a location from the state, then (because this
        //  navigation was targeted at the top-level window - which means it was
        //  probably the user clicking the back/forward buttons), the URL will
        //  already have changed and we can just use that.
        if (TP.notValid(loc)) {
            loc = TP.uriNormalize(historyWindow.location.toString());
        }

    } else {
        //  The 'popstate' event got fired against a window which is not the
        //  codeframe. This is a complex situation. A link traversal could've
        //  come from clicking an anchor with an href value of '#' (in which
        //  case we don't want to do any state/history/routing at all) or it
        //  could be coming from the user clicking the forward/backward arrows,
        //  in which case we want to dispatch as if the event got dispatched
        //  against the top-level window.

        eventInCanvas = true;

        if (TP.notValid(state)) {
            stateIndex = 0;
        } else {
            stateIndex = state.index;
        }

        //  One way to detect if this a real movement or not is to compare the
        //  index in the state that we monitor with the index that we cache on
        //  ourself. If they're the same, then we're not traversing.
        if (index === stateIndex) {

            //  Get the location of the window that the event occurred in. If
            //  it ends with a '#', then this was just the user clicking an
            //  anchor with a 'href="#"'.
            eventLocation = TP.uriNormalize(eventWindow.location.toString());

            //  If there is no next location and the location in the window that
            //  the event occurred in ends with 'blank.html#', then that means
            //  it's one of these anchors.
            if (TP.isEmpty(this.getNextLocation()) &&
                eventLocation.endsWith('blank.xhtml#')) {
                return this;
            }
        }

        direction = this.get('direction');
        if (TP.notValid(direction)) {
            if (index > stateIndex) {
                direction = 'back';
            } else if (index <= stateIndex) {
                direction = 'forward';
            }
        }

        if (direction === 'back') {
            loc = this.getHistory().at(stateIndex - 1).at(2);
        } else if (direction === 'forward') {
            loc = this.getHistory().at(stateIndex + 1).at(2);
        }

        //  Set the overriding location that will be reported by the
        //  getNativeLocation() call to what we computed above. This is
        //  important for the 'updateIndex' call below so compute the correct
        //  index and update this object's instance variable states properly.
        this.set('$$overrideLocation', loc);
    }

    //  Just because we got this event doesn't mean location actually changed.
    //  At least one browser will trigger these even if you set the window
    //  location to the same value it currently holds so we have to verify a
    //  true change to avoid extra overhead/duplicate work.
    if (loc === TP.sys.getHistory().getLocation()) {
        return this;
    }

    //  If there is a valid state, then make sure to check its index against the
    //  last valid index. If it's greater than the last valid index, then the
    //  user is trying to move forward in history using the forward arrow or
    //  keystroke to a place 'beyond' where we want them to go. Force them back
    //  using the history object's 'go()' call.
    if (TP.isValid(eventState)) {
        if (eventState.index > this.get('lastValidIndex')) {
            historyWindow.history.go(-eventState.index);
            return this;
        }
    }

    //  The popstate event can come from a number of sources so we need to
    //  ensure we get the right index adjustments in our internal history.
    newIndex = this.updateIndex(eventState);

    //  A route has to be routable so only trigger the router if it is.
    if (this.isLocationRoutable(loc)) {

        //  If the event occurred in the canvas window, then manage the state
        //  before routing so that the URL in the browser URL bar matches up.
        if (eventInCanvas === true) {

            //  Clear the override location.
            this.set('$$overrideLocation', null);

            //  If the newly calculated index is 0, that means we're at the
            //  beginning of the 'location stack', so to be consistent for when
            //  TIBET boots, we set a null newState.
            if (newIndex === 0) {
                newState = null;
            } else {
                newState = {
                    index: newIndex,
                    title: '',
                    url: loc
                };
            }

            //  Replace the current state with the new state to make the URL bar
            //  have the proper value.
            historyWindow.history.replaceState(newState, '', loc);

            //  Make sure to null state here. We don't want to pass along state
            //  to the 'route' call below - we want it to use the location.
            state = null;
        }

        router = TP.sys.getRouter();
        if (TP.isValid(router)) {
            router.route(TP.ifInvalid(state, loc));
        }
    } else {
        //  This is a link anchor target - act accordingly
        return this;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('pushLocation',
function(aURL, fromDoc) {

    /**
     * @method pushLocation
     * @summary Pushes a new URL onto the history stack using the native
     *     pushState operation while keeping a local version of the stack. Note
     *     that URI values which refer to the project home page are translated
     *     so the actual home page location is not pushed, but instead the
     *     project's launch URL is pushed in keeping with the idea of "/".
     * @param {TP.uri.URI|String} aURL The location to push onto the history
     *     stack.
     * @param {Boolean} [fromDoc=false] An optional flag signifying the push is
     *     coming from a loaded document handler.
     * @returns {TP.meta.core.History} The receiver.
     */

    var url,
        urlParts,
        home,
        launch,
        launchParts;

    if (TP.notValid(aURL)) {
        TP.raise(this, 'TP.sig.InvalidURI');
        return this;
    }

    //  For our expansion testing and history tracking we want a fully-expanded
    //  and normalized version of the URL here.
    url = TP.str(aURL);
    url = TP.uriExpandPath(url);
    url = decodeURIComponent(url);

    if (!TP.isURIString(url)) {
        TP.raise(this, 'TP.sig.InvalidURI');
        return this;
    }

    //  We need launch parameters to be mapped in all cases to avoid changes to
    //  the boot parameters which would otherwise trigger a relaunch.
    launch = TP.sys.getLaunchURL();
    launchParts = TP.uriDecompose(launch);

    //  Convert urls pointing to the home page into their "normalized" form.
    home = TP.uriExpandPath(TP.sys.getHomeURL());
    if (TP.uriHead(url) === TP.uriHead(home)) {
        urlParts = TP.uriDecompose(url);
        urlParts.atPut('basePath', launchParts.at('basePath'));
        urlParts.atPut('baseParams', launchParts.at('baseParams'));
    }

    //  Make sure we can deal with URL parts below.
    if (TP.notValid(urlParts)) {
        urlParts = TP.uriDecompose(url);
    }

    //  For both path and parameters migrate any from the launch URL as long as
    //  we don't overlay anything specific from the inbound URL. NOTE that the
    //  fragmentPath is never "empty", it's "/" when there's no path/route data.
    if (TP.isEmpty(urlParts.at('fragmentParams'))) {
        urlParts.atPut('fragmentParams', launchParts.at('fragmentParams'));
    }

    url = TP.uriCompose(urlParts);

    //  Dampening happens in pushState so we can just pass value through. Note
    //  that this method returns undefined.
    return this.pushState({}, '', url, fromDoc);
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('pushState',
function(stateObj, aTitle, aURL, fromDoc) {

    /**
     * @method pushState
     * @summary Changes the current location of the browser and sets it to an
     *     encoded version of the supplied URL.
     * @param {Object} stateObj The object to associate with the history entry
     *     that will be created with this method. This can be useful for storing
     *     entry-specific state.
     * @param {String} aTitle The title of the state that is being pushed.
     * @param {String} aURL The location to use when displaying this history
     *     entry in the URL bar.
     * @param {Boolean} [fromDoc=false] An optional flag signifying the push is
     *     coming from a loaded document handler.
     * @exception {TP.sig.InvalidURI} When an invalid URL string is supplied.
     * @returns {TP.meta.core.History} The receiver.
     */

    var url,
        state,
        current,
        entry,
        index,
        title,
        router,
        history,
        loc,
        parts,
        basePath,
        pushable;

    if (!TP.isURIString(aURL)) {
        TP.raise(this, 'TP.sig.InvalidURI');
        return this;
    }

    url = TP.str(aURL);
    current = this.getLocation();
    title = aTitle || '';

    //  Dampen changes that aren't really changes.
    if (current === url) {
        return this;
    }

    this.set('direction', 'forward', false);
    this.set('lastURI', current, false);

    //  Update our internal history, and track the index in the state object so
    //  we can update when we get notifications.
    history = this.get('history');
    index = this.get('index');

    //  Truncate the list to current location. This seems consistent with
    //  browser behavior where if you use back() or go(-n) to back up in the
    //  list and then set location='url' you can't go forward, the list ends.
    history.length = index + 1;

    //  Configure the supplied state object or a new one. Note here how we have
    //  to use a POJO, since this gets used below in the native 'pushState'
    //  call.
    state = stateObj || {};
    state.index = index + 1;
    state.title = title;
    state.url = url;

    //  We also track it in our internal history object.
    entry = TP.ac(state, title, url);
    history.push(entry);

    //  Make sure to increment both of these.
    this.set('index', index + 1);
    this.set('lastValidIndex', index + 1);

    //  work around bug(s) on chrome et. al. which fire popstate on pushState
    try {

        this.set('popstate', false);

        if (TP.sys.cfg('log.history')) {
            TP.debug('pushState(' + JSON.stringify(state) +
                    ', \'' + entry.at(1) + '\', \'' + url + '\')');
        }

        loc = TP.topWindow.location.toString();

        //  Compute the right path to push. We don't push changes to the base
        //  URL unless configured explicitly for that feature. In all other
        //  cases we update the fragment path to reflect the base path change.
        if (TP.notFalse(TP.sys.cfg('route.fragment_only')) &&
                        TP.uriHead(loc) !== TP.uriHead(url)) {

            parts = TP.hc();

            //  preserve the current root elements to avoid changing base.
            parts.atPut('root', TP.uriRoot(loc));
            parts.atPut('basePath', TP.uriBasePath(loc));
            parts.atPut('baseParams', TP.uriBaseParameters(loc));

            //  build up the new fragment using the proposed base path and
            //  parameter combination. This will cause the "page path" to
            //  be reflected in the fragment path as if it were a route.
            basePath = TP.uriBasePath(url);
            if (basePath === parts.at('basePath')) {
                parts.atPut('fragmentPath', TP.uriFragmentPath(url));
            } else {
                parts.atPut('fragmentPath', basePath);
            }
            parts.atPut('fragmentParams', TP.uriFragmentParameters(url));

            //  adjust any extension since we don't want to expose those in
            //  route paths.
            if (TP.notEmpty(TP.uriExtension(basePath))) {
                parts.atPut(
                        'fragmentPath',
                        basePath.replace('.' + TP.uriExtension(basePath), ''));
            }

            pushable = TP.uriCompose(parts);
        } else {
            //  Allow the entire URL as proposed to be pushed to native history.
            pushable = url;
        }

        //  Track the ultimately pushed URL separately from the original so we
        //  can tell when we're looking at an adjusted path.
        state.pushed = pushable;

        if (TP.sys.cfg('log.history')) {
            TP.debug('pushState pushing: ' + pushable);
        }

        //  Update the native window history and URL bar value. This will show
        //  the "routable" value but not the actual canvas URI in some cases.
        this.getNativeWindow().history.pushState(state, title, pushable);

        //  Store off the session history in the browser's session storage.
        this.saveSessionHistory();

        //  If we're here due to a direct change via a document being loaded
        //  don't allow further processing.
        if (TP.isTrue(fromDoc)) {
            return this;
        }

        //  If the URI we're pushing contains '#' followed by '/' or '?', then
        //  grab the router and, if the router can route, then move 'forward'
        //  with that route.
        if (/#(\/|\?)/.test(pushable)) {

            router = TP.sys.getRouter();
            if (TP.canInvoke(router, 'route')) {
                router.route(url, 'forward');
            }
        }
    } finally {
        this.set('popstate', true);
    }

    if (TP.sys.cfg('log.history')) {
        this.reportLocation();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('replaceLocation',
function(aURL) {

    /**
     * @method replaceLocation
     * @summary Replaces the current location of the browser and sets it to an
     *     encoded version of the supplied history value.
     * @param {String} aURL The location to use to replace the state on the
     *     native history object.
     * @returns {TP.meta.core.History} The receiver.
     */

    return this.replaceState({}, '', aURL);
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('replaceState',
function(stateObj, aTitle, aURL) {

    /**
     * @method replaceState
     * @summary Replaced the current location of the browser and sets it to an
     *     encoded version of the supplied URL.
     * @param {Object} stateObj The object to associate with the history entry
     *     that will be created with this method. This can be useful for storing
     *     entry-specific state.
     * @param {String} aTitle The title of the state that is being pushed.
     * @param {String} aURL The location to use when displaying this history
     *     entry in the URL bar.
     * @exception {TP.sig.InvalidURI} When an invalid URL string is supplied.
     * @returns {TP.meta.core.History} The receiver.
     */

    var url,
        state,
        title,
        index,
        current,
        entry,
        router,
        history;

    if (!TP.isURIString(aURL)) {
        TP.raise(this, 'TP.sig.InvalidURI');
        return this;
    }

    url = TP.str(aURL);
    url = decodeURIComponent(url);
    title = aTitle || '';

    //  Capture this before the replace so we have something to compare.
    current = this.getLocation();

    //  Dampen changes that aren't really changes.
    if (current === url) {
        return this;
    }

    this.set('direction', 'replace', false);
    this.set('lastURI', current, false);

    //  Update our internal history, and track the index in the state object so
    //  we can update when we get notifications.
    history = this.get('history');
    index = this.get('index');

    //  Configure the supplied state object or a new one. Note here how we have
    //  to use a POJO, since this gets used below in the native 'pushState'
    //  call.
    state = stateObj || {};
    state.index = index;
    state.title = title;
    state.url = url;

    //  We also track it in our internal history object.
    entry = TP.ac(state, title, url);
    history.atPut(index, entry);

    //  work around bug(s) on chrome et. al. which fire popstate on pushState
    try {
        this.set('popstate', false);

        if (TP.sys.cfg('log.history')) {
            TP.debug('replaceState(' +
                        JSON.stringify(state) +
                        ', \'' + entry.at(1) + '\', \'' + url + '\')');
        }

        //  Update the native window history and URL bar value. This will show
        //  the "routable" value but not the actual canvas URI in some cases.
        this.getNativeWindow().history.replaceState(state, title, url);

        //  If the URI we're pushing contains '#' followed by '/' or '?', then
        //  grab the router and, if the router can route, then 'replace' with
        //  that route.
        router = TP.sys.getRouter();
        if (TP.canInvoke(router, 'route')) {
            router.route(url, 'replace');
        }
    } finally {
        this.set('popstate', true);
    }

    if (TP.sys.cfg('log.history')) {
        this.reportLocation();
    }

    //  Store off the session history in the browser's session storage.
    this.saveSessionHistory();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('reportLocation',
function(anIndex) {

    /**
     * @method reportLocation
     * @summary Logs the history location at an index.
     * @param {Number} [anIndex] An index to report, or the current index.
     * @returns {TP.meta.core.History} The receiver.
     */

    var index,
        entry,
        nativeLoc,
        local,
        method;

    nativeLoc = this.getNativeLocation();
    index = anIndex;

    if (TP.notValid(index)) {
        index = this.get('index');
    }

    entry = this.get('history').at(index);
    local = entry.at(2);

    if (TP.notFalse(TP.sys.cfg('route.fragment_only'))) {
        //  when using fragment-only updates we'll often fail to match if
        //  alternative pages have been loading in the UICANVAS.
        method = 'debug';
    } else {
        method = local === nativeLoc ? 'debug' : 'error';
    }

    if (TP.isValid(entry)) {
        TP[method]('history.at(' + index + ') -> ' + local + '.');
    } else {
        TP[method]('history.at(' + index + ') -> ' + 'empty.');
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('restoreSessionHistory',
function(aJSONString) {

    /**
     * @method restoreSessionHistory
     * @summary Restores the session history (the history index and entries)
     *     from the supplied JSON string.
     * @param {String} aJSONString The JSON-ified history information that was
     *     generated and stored using the saveSessionHistory method.
     * @returns {TP.meta.core.History} The receiver.
     */

    var obj;

    obj = TP.json2js(aJSONString);

    this.$set('index', obj.at('index'));
    this.$set('history', obj.at('entries'));

    return this;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('saveSessionHistory',
function() {

    /**
     * @method saveSessionHistory
     * @summary Saves the session history (the history index and entries) to the
     *     browser's session storage.
     * @returns {TP.meta.core.History} The receiver.
     */

    var info,
        str;

    info = TP.hc(
            'index', this.get('index'),
            'entries', this.get('history')
            );

    str = TP.js2json(info);

    TP.global.sessionStorage.setItem('TIBET.boot.session_history', str);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('setIndex',
function(anIndex) {

    /**
     * @method setIndex
     * @summary Updates the receiver's internal history index to a new offset.
     * @param {Number} anIndex The index to set the current index to.
     * @exception {TP.sig.InvalidParameter} If index in not a number.
     * @exception {TP.sig.InvalidIndex} If index would be out of range.
     * @returns {TP.meta.core.History} The receiver.
     */

    if (!TP.isNumber(anIndex)) {
        return this.raise('InvalidParameter');
    }

    if (anIndex < 0 || anIndex > this.getSize() - 1) {
        return this.raise('InvalidIndex');
    }

    this.$set('index', anIndex);

    //  Store off the session history in the browser's session storage.
    this.saveSessionHistory();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.History.Type.defineMethod('updateIndex',
function(aState) {

    /**
     * @method updateIndex
     * @summary Updates the current history index by comparing data for the
     *     current location with known history entries.
     * @param {Object} aState A history 'state' object triggering this
     *     update request. The index value of this object, if available, will
     *     identify the new index traversed to.
     * @returns {Number} The new index.
     */

    var last,
        next,
        native,
        history,
        index,
        state,
        stateIndex,
        offset,
        indexes,
        min,
        max,
        len,
        i;

    history = this.get('history');
    index = this.get('index');

    //  The state in anEvent may include an index...which would be our answer.
    //  We just need to compute the offset.
    if (TP.isValid(aState)) {
        state = aState;

        if (TP.isValid(state)) {
            stateIndex = state.index;

            if (TP.isNumber(stateIndex)) {
                this.set('offset', stateIndex - index);
            }
        }
    }

    offset = this.get('offset');
    if (TP.isValid(offset)) {

        if (offset > 0) {
            this.set('direction', 'forward');
        } else if (offset === 0) {
            this.set('direction', 'replace');
        } else {
            this.set('direction', 'back');
        }

        this.set('index', index + offset);

        //  Clear the offset so we don't reuse it by accident.
        this.set('offset', null);

        return this.get('index');
    }

    //  Shouldn't be here...all operations should route back through a popstate
    //  event only after we've been able to pushState or somehow otherwise
    //  ensured there's always an offset...but hey, it's a browser :)...

    last = this.getLastLocation();
    next = this.getNextLocation();
    native = this.getNativeLocation();

    if (native === last) {

        if (native !== next) {
            //  back
            this.set('direction', 'back');
            this.set('index', index - 1);
        } else {
            //  in-between a cyclic entry...have to pick one. We go back since
            //  you can always navigate forward by retracing steps, but you
            //  can't get back if we keep forcing a true back "forward".
            TP.warn('Ambiguous history event. Defaulting to back.');

            this.set('direction', 'back');
            this.set('index', index - 1);
        }
    } else if (native === next) {
        //  forward
        this.set('direction', 'forward');
        this.set('index', index + 1);
    } else {
        //  either brand new, or more than one index away...go(n);
        indexes = this.getLocationIndexes(native);

        if (TP.isEmpty(indexes)) {
            //  Never seen it...must be forward.
            history.push(TP.ac({index: index + 1}, '', native));

            this.set('direction', 'forward');
            this.set('index', index + 1);
        } else {
            //  If all indexes are > than ours it's got to be a forward jump. If
            //  they're all < ours it has to be a backward jump.
            min = indexes.getSize() + 1;
            max = -1;

            indexes.forEach(
                    function(ind) {
                        min = Math.min(min, ind);
                        max = Math.max(max, ind);
                    });

            if (min > index) {
                this.set('direction', 'forward');
                this.set('index', index + 1);
            } else if (max < index) {
                this.set('direction', 'back');
                this.set('index', index - 1);
            } else {
                TP.warn('Ambiguous history event. Defaulting to back.');

                this.set('direction', 'back');

                //  Have to locate the index closest to us that's prior to the
                //  current index.
                len = indexes.getSize();
                for (i = 0; i < len; i++) {
                    if (indexes.at(i) < index && indexes.at(i + 1) > index) {
                        stateIndex = indexes.at(i);
                    }
                }

                //  If there was no index less than our index and no index
                //  greater than our index, then since we're 'defaulting to
                //  back', just set the stateIndex to our index - 1
                if (TP.notValid(stateIndex)) {
                    stateIndex = index - 1;
                }

                this.set('index', stateIndex);
            }
        }
    }

    //  If the session storage is *not* storing a session history, then we can
    //  go ahead and capture history here. Otherwise, we do *not* want to do
    //  this or it messes up our history values.
    if (TP.notValid(TP.global.sessionStorage.getItem(
                                            'TIBET.boot.session_history'))) {
        this.captureHistory();
    }

    return this.get('index');
});

//  ========================================================================
//  TIBET convenience methods
//  ========================================================================

TP.sys.defineMethod('getApplication',
function() {

    /**
     * @method getApplication
     * @summary Retrieves the application singleton object.
     * @returns {TP.core.Application} The application instance.
     */

    var inst;

    //  Don't let this return null. Always build a default instance.
    inst = TP.core.Application.get('singleton');
    if (TP.notValid(inst)) {
        inst = TP.sys.buildAndConfigAppInstance();
    }

    return inst;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getHistory',
function() {

    /**
     * @method getHistory
     * @summary Retrieves the application history object.
     * @returns {TP.core.History} The TIBET history object.
     */

    return this.getApplication().getHistory();
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getRoute',
function() {

    /**
     * @method getRoute
     * @summary Retrieves the current application route name.
     * @returns {String} The current route.
     */

    return this.getRouter().getRoute();
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getRouter',
function() {

    /**
     * @method getRouter
     * @summary Retrieves the application uri router.
     * @returns {TP.uri.URIRouter} The TIBET router.
     */

    return this.getApplication().getRouter();
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('getState',
function() {

    /**
     * @method getState
     * @summary Returns the current state, which is a string representing the
     *     current operation or "state" of the application (editing, viewing,
     *     printing, etc).
     * @returns {String} The current value for application state.
     */

    return TP.sys.getApplication().getCurrentState();
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('setRoute',
function(aRoute) {

    /**
     * @method setRoute
     * @summary Updates the fragment path portion which defines the current
     *     route in TIBET terms. Any boot parameters on the existing URL are
     *     preserved by this call.
     * @description Routes in TIBET are signified by the "fragment path" portion
     *     of the URI which we define as the section of the URI fragment prior
     *     to any '?' which sets off the "fragment parameters" (aka boot
     *     parameters). Changes to this section of the URI result in a Route
     *     signal being fired so application logic can respond to route changes.
     * @param {String} aRoute The route information.
     * @returns {String} The current route.
     */

    return this.getRouter().setRoute(aRoute);
});

//  ========================================================================
//  APP convenience methods
//  ========================================================================

APP.defineMethod('getApplication',
function() {

    /**
     * @method getApplication
     * @summary Retrieves the application singleton object.
     * @returns {TP.core.Application} The application instance.
     */

    return TP.sys.getApplication();
});

//  ------------------------------------------------------------------------

APP.defineMethod('getHistory',
function() {

    /**
     * @method getHistory
     * @summary Retrieves the application history object.
     * @returns {TP.core.History} The TIBET history object.
     */

    return TP.sys.getHistory();
});

//  ------------------------------------------------------------------------

APP.defineMethod('getRoute',
function() {

    /**
     * @method getRoute
     * @summary Retrieves the current application route name.
     * @returns {String} The current route.
     */

    return TP.sys.getRoute();
});

//  ------------------------------------------------------------------------

APP.defineMethod('getRouter',
function() {

    /**
     * @method getRouter
     * @summary Retrieves the application uri router.
     * @returns {TP.uri.URIRouter} The TIBET router.
     */

    return TP.sys.getRouter();
});

//  ------------------------------------------------------------------------

APP.defineMethod('setRoute',
function(aRoute) {

    /**
     * @method setRoute
     * @summary Updates the fragment path portion which defines the current
     *     route in TIBET terms. Any boot parameters on the existing URL are
     *     preserved by this call.
     * @description Routes in TIBET are signified by the "fragment path" portion
     *     of the URI which we define as the section of the URI fragment prior
     *     to any '?' which sets off the "fragment parameters" (aka boot
     *     parameters). Changes to this section of the URI result in a Route
     *     signal being fired so application logic can respond to route changes.
     * @param {String} aRoute The route information.
     * @returns {String} The current route.
     */

    return TP.sys.setRoute(aRoute);
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETStateMachineTypes.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/*
 *  Simple state machine support for TIBET. State machines in TIBET provide a
 *  way to manage states and to have the system respond to transition signals
 *  as a means of helping manage code. Your signals in TIBET are always aware of
 *  the current application and/or controller state as well so you can easily
 *  define signal handlers dependent on specific states.
 */

//  ========================================================================
//  TP.sig.StateSignal
//  ========================================================================

TP.sig.Signal.defineSubtype('StateSignal');

TP.sig.StateSignal.Type.defineAttribute('defaultPolicy', TP.OBSERVER_FIRING);

TP.sig.StateSignal.Inst.defineAttribute('$shouldScanSupers', true);

TP.sig.StateSignal.Type.isControllerSignal(true);
TP.sig.StateSignal.isControllerRoot(true);

// ---

TP.sig.StateSignal.defineSubtype('StateInput');

TP.sig.StateSignal.defineSubtype('StateExit');
TP.sig.StateSignal.defineSubtype('StateTransition');
TP.sig.StateSignal.defineSubtype('StateEnter');

//  ========================================================================
//  TP.core.StateMachine
//  ========================================================================

/**
 * @type {TP.core.StateMachine}
 * @summary A small state machine implementation. The basic elements of a state
 *     machine regarding state testing are managed here and signaling is used to
 *     notify when a transition occurs.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('TP.core.StateMachine');

TP.core.StateMachine.addTraits(TP.core.Triggered);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  The maximum number of entries maintained in a StateMachine transition log.
TP.core.StateMachine.Type.defineConstant('LOG_MAX', 100);

//  ------------------------------------------------------------------------
//  Local Methods
//  ------------------------------------------------------------------------

TP.core.StateMachine.defineMethod('normalizeState',
function(aState) {

    if (!TP.isString(aState)) {
        if (TP.notValid(aState)) {
            return 'Null';
        }

        return this.raise('InvalidState');
    }

    return aState.asTitleCase();
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  Lookup container for states by initial state. This gives you a list of
//  states a particular state could transition to. "Potential states" per se.
TP.core.StateMachine.Inst.defineAttribute('byInitial');

//  Lookup container for composite states. This is a simple hash of state names
//  and nested state machines which handle the details of those states.
TP.core.StateMachine.Inst.defineAttribute('byParent');

//  Lookup container for states by target state. This gives you a list of states
//  a particular state can be reached from. "Prerequisite states" as it were.
TP.core.StateMachine.Inst.defineAttribute('byTarget');

//  The receiver's child state machine, if any is currently active.
TP.core.StateMachine.Inst.defineAttribute('child');

//  The receiver's parent state machine, if any. This value is only appropriate
//  for a nested state machine instance.
TP.core.StateMachine.Inst.defineAttribute('parent');

//  The current state.
TP.core.StateMachine.Inst.defineAttribute('state');

//  The log of state transitions this state machine has undergone. This is
//  trimmed to TP.core.StateMachine.LOG_MAX avoid large-scale leaking.
TP.core.StateMachine.Inst.defineAttribute('stateLog');

//  The last time a trigger signal was fired. We track this to avoid multiple
//  firings of the trigger signal when doing a transition.
TP.core.StateMachine.Inst.defineAttribute('$lastTriggerTime');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('init',
function(aParent) {

    /**
     * @method init
     * @summary Initializes a new instance of the receiver.
     * @param {TP.core.StateMachine} [aParent] An optional parent state machine
     *     which should handle inputs which aren't processed by the receiver.
     * @returns {TP.core.StateMachine} A new instance.
     */

    this.callNextMethod();

    //  Set up our internal configuration containers.
    this.set('stateLog', TP.ac());

    this.set('byParent', TP.hc());
    this.set('byInitial', TP.hc());
    this.set('byTarget', TP.hc());

    if (TP.isValid(aParent)) {
        this.set('parent', aParent);
    }

    //  Give subtypes a place to override which would set up a set of
    //  default states and handlers, avoiding too much instance creation
    //  overhead.
    this.defineStates();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('activate',
function(aState) {

    /**
     * @method activate
     * @summary Activates the instance, causing it to transition into its start
     *     state. The state must have no prerequisite states to be a valid start
     *     state and any guard function for that state must return true.
     * @param {String} [aState] An optional start state to use. If not provided
     *     the list of target states is checked for any without initial states.
     *     If one-and-only-one is found that state is used as the start state.
     * @returns {Boolean} True if the activation was successful.
     */

    var start,
        state,
        states;

    state = this.getStateName(aState);

    //  Can't activate when there's already a current state.
    if (TP.notEmpty(this.get('state'))) {
        this.raise('InvalidOperation',
            'Cannot activate an active state machine.');
        return false;
    }

    //  Can't activate without a valid start state to transition to.
    if (TP.notEmpty(aState)) {
        //  Verify we know about this state...and that it's a viable start state
        //  based on having at least one path with no prereq.
        states = this.$getStartStates();
        if (states.indexOf(state) !== TP.NOT_FOUND) {
            start = state;
        } else {
            //  Not a valid start state.
            this.raise('InvalidStartState', state);
            return false;
        }
    } else {
        //  Find one we can default to by checking our list of known target
        //  states and hopefully finding one (and only one) with no prereq.
        states = this.$getStartStates();
        switch (states.getSize()) {
            case 0:
                this.raise('InvalidStartState', 'No defined start state(s).');
                return false;
            case 1:
                start = states.at(0);
                break;
            default:
                this.raise('InvalidStartState',
                    'Multiple startable states: ' + TP.str(states));
                return false;
        }
    }

    //  Clear the state log since we're starting a new activation sequence.
    this.$get('stateLog').empty();

    //  Verify no guard conditions prevent the transition.
    if (!this.mayTransition(null, start)) {
        return false;
    }

    this.transition(start);

    this.activateTriggers();

    return true;
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('activateTriggers',
function() {

    /**
     * @method activateTriggers
     * @summary Activates the receiver's triggers, typically by invoking
     *     observeTriggers. This method can be overridden as needed to ensure
     *     any other triggering setup occurs.
     * @returns {TP.core.StateMachine} The receiver.
     */

    this.observeTriggers();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('deactivate',
function(force) {

    /**
     * @method deactivate
     * @summary Shuts down the state machine, returning it to an indeterminate
     *     state. This is typically called as part of the final state transition
     *     processing when the state machine transitions to its final state.
     * @exception {TP.sig.InvalidFinalState} If the state machine isn't in its
     *     final state when this method is called.
     * @param {Boolean} [force=false] True to force deactivation regardless of
     *     whether the receiver is in a final state.
     * @returns {Boolean} True if deactivation was successful.
     */

    var child,
        current,
        states;

    //  Can't deactivate when there's no current state.
    if (TP.notTrue(force) && TP.isEmpty(this.get('state'))) {
        this.raise('InvalidOperation',
            'Cannot deactivate an inactive state machine.');
        return false;
    }

    if (TP.isValid(child = this.get('child'))) {
        child.deactivate(force);
    }

    //  Turn off any observations we may have in place regarding input
    //  events. Regardless of errors we may raise we honor the request to
    //  deactivate the inbound triggering.
    this.deactivateTriggers();

    //  Should be in a final state. If not that's an error.
    current = this.get('state');
    states = this.$getFinalStates();

    if (states.indexOf(current) === TP.NOT_FOUND && !this.isOnOffOnly()) {
        //  Not a final state...
        if (TP.notTrue(force)) {
            this.raise('InvalidFinalState', 'Deactivating in non-final state.');
            return false;
        }
    }

    //  Clear the state flag manually. Using the setter will cause either an
    //  error or a true string value.
    this.state = null;

    return true;
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('deactivateTriggers',
function() {

    /**
     * @method deactivateTriggers
     * @summary Deactivates the receiver's triggers, typically by invoking
     *     ignoreTriggers. This method can be overridden as needed to ensure
     *     any other triggering shutdown occurs.
     * @returns {TP.core.StateMachine} The receiver.
     */

    this.ignoreTriggers();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('defineStates',
function() {

    /**
     * @method defineStates
     * @summary Invoked by the init method to set up initial states for the
     *     receiver. If this method is not used via a subtype you must use
     *     other direct calls to properly configure the state machine.
     * @returns {TP.core.StateMachine} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('defineState',
function(initialState, targetState, transitionDetails) {

    /**
     * @method defineState
     * @summary Adds a single state pathway, which consists of initial state(s)
     *     and target state(s). The state machine itself serves as a potential
     *     guard function repository. Methods of the form 'accept{State}' will
     *     be invoked during transitions.
     * @param {String|String[]} [initialState] The name of the initial state(s).
     *     Defaults to null since start states may not have an initial state.
     * @param {String|String[]} [targetState] The name of the target state(s).
     *     Defaults to null since final states may not have target states.
     * @param {TP.core.Hash} [transitionDetails] A hash containing details on
     *     the transition such as triggers and nested machine activation.
     * @param {String|String[]} [transitionDetails.signal]
     * @param {TP.core.StateMachine|String} [transitionDetails.nested]. The type
     *     name for a nested state machine, or the state machine itself.
     */

    var initials,
        parents,
        targets,
        initial,
        target,
        nulls,
        options,
        trigger,
        triggers,
        nested,
        machine;

    if (this.isActive()) {
        this.raise('InvalidOperation',
                    'Cannot modify an active state machine.');

        return this;
    }

    /* eslint-disable consistent-this */

    machine = this;

    initial = TP.isArray(initialState) ? initialState : TP.ac(initialState);
    initial = initial.map(
                function(state) {
                    return machine.getStateName(state);
                });

    target = TP.isArray(targetState) ? targetState : TP.ac(targetState);
    target = target.map(
                function(state) {
                    return machine.getStateName(state);
                });

    initials = this.get('byInitial');
    parents = this.get('byParent');
    targets = this.get('byTarget');

    options = TP.hc(transitionDetails);
    nested = options.at('nested');

    //  Normalize singular/multiple triggers into a single set.
    triggers = options.at('triggers');
    if (TP.notValid(triggers)) {
        triggers = TP.ac();
    }

    trigger = options.at('trigger');
    if (TP.isValid(trigger)) {
        //  Clear it so we only look for triggers after this process.
        options.removeKey('trigger');

        //  Trigger should be an array and should include an origin and a
        //  signal. If we're not seeing that we warn and try to treat the
        //  value as a signal (and TP.ANY as the origin).
        if (TP.isArray(trigger)) {
            triggers.push(trigger);
        } else if (TP.isString(trigger) ||
                TP.isKindOf(trigger, TP.sig.Signal)) {
            TP.warn('State machine triggers should define origin and signal.');
            triggers.push(TP.ac(TP.ANY, trigger));
        } else {
            this.raise('InvalidTrigger', trigger);
        }
    }

    //  Register all normalized triggers.
    if (TP.notEmpty(triggers)) {
        options.atPut('triggers', triggers);
        this.addTriggers(triggers);
    }

    //  ---
    //  start states
    //  ---

    if (TP.notValid(initialState)) {

        if (TP.notValid(targetState)) {
            return this.raise('InvalidStateDefinition');
        }

        nulls = initials.at(this.getStateName(null));
        if (TP.notValid(nulls)) {
            nulls = TP.ac();
            initials.atPut(this.getStateName(null), nulls);
        }

        target.forEach(
            function(key) {
                var list,
                    exists;

                list = targets.at(machine.getStateName(key));

                if (TP.notValid(list)) {
                    list = TP.ac();
                    targets.atPut(machine.getStateName(key), list);
                } else {
                    //  Check for duplicates.
                    exists = list.some(
                                function(item) {
                                    return item.at(0) ===
                                        machine.getStateName(null);
                                });

                    if (TP.isTrue(exists)) {
                        machine.raise('DuplicateStateDefinition',
                                    'null -> ' + key);
                    }
                }

                //  Once we know it's not a duplicate push ordered pairs into
                //  the initial list's null keyset and the targeted key's list.
                nulls.push([key, options]);
                list.push([machine.getStateName(null), options]);

                if (TP.isValid(nested)) {
                    parents.atPut(machine.getStateName(key), nested);
                }
            });

        return this;
    }

    //  ---
    //  final states
    //  ---

    if (TP.notValid(targetState)) {

        if (TP.notValid(initialState)) {
            return this.raise('InvalidStateDefinition');
        }

        nulls = targets.at(this.getStateName(null));
        if (TP.notValid(nulls)) {
            nulls = TP.ac();
            targets.atPut(this.getStateName(null), nulls);
        }

        initial.forEach(
            function(key) {
                var list,
                    exists;

                list = initials.at(machine.getStateName(key));

                if (TP.notValid(list)) {
                    list = TP.ac();
                    initials.atPut(machine.getStateName(key), list);
                } else {
                    //  Check for duplicates.
                    exists = list.some(
                                function(item) {
                                    return item.at(0) ===
                                        machine.getStateName(null);
                                });

                    if (TP.isTrue(exists)) {
                        machine.raise('DuplicateStateDefinition',
                                    key + ' -> null');
                    }
                }

                //  Once we know it's not a duplicate push ordered pairs into
                //  the initial list's null keyset and the targeted key's list.
                nulls.push([key, options]);
                list.push([machine.getStateName(null), options]);
            });

        return this;
    }

    //  If we're this far we're dealing with a definition that has valid values
    //  for both initial and target states.

    //  ---
    //  byInitial
    //  ---

    initial.forEach(
        function(key) {
            var list;

            list = initials.at(machine.getStateName(key));

            if (TP.notValid(list)) {
                list = TP.ac();
                initials.atPut(machine.getStateName(key), list);

                target.forEach(
                    function(item) {
                        list.push([item, options]);
                    });

            } else {

                //  Check for duplicates as we iterate and push new items.
                target.forEach(
                    function(tname) {
                        var exists;

                        exists = list.some(
                            function(item) {
                                return item.at(0) === tname;
                            });

                        if (TP.isTrue(exists)) {
                            machine.raise('DuplicateStateDefinition',
                                        key + ' -> ' + tname);
                        } else {
                            list.push([tname, options]);
                        }
                    });
            }
        });

    //  ---
    //  byTarget
    //  ---

    target.forEach(
        function(key) {
            var list;

            list = targets.at(machine.getStateName(key));

            if (TP.notValid(list)) {
                list = TP.ac();
                targets.atPut(machine.getStateName(key), list);

                initial.forEach(
                    function(item) {
                        list.push([item, options]);
                    });

            } else {

                //  Check for duplicates as we iterate and push new items.
                initial.forEach(
                    function(iname) {
                        var exists;

                        exists = list.some(
                            function(item) {
                                return item.at(0) === iname;
                            });

                        if (TP.isTrue(exists)) {
                            machine.raise('DuplicateStateDefinition',
                                        key + ' -> ' + iname);
                        } else {
                            list.push([iname, options]);
                        }
                    });
            }

            if (TP.isValid(nested)) {
                parents.atPut(machine.getStateName(key), nested);
            }
        });

    /* eslint-enable consistent-this */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('exit',
function(details, nested) {

    /**
     * @method exit
     * @summary Performs exit processing, ensuring that any nested state
     *     machines exit before their outer composite state machines.
     * @param {TP.core.Hash} details Transition information including
     *     'state' (the new state), and 'trigger' (origin/signal pair).
     * @param {Boolean} [nested] True if the call is being invoked by a parent
     *     on a nested child state machine.
     * @returns {TP.core.StateMachine} The receiver.
     */

    var child,
        state,
        signal;

    if (TP.isValid(child = this.get('child'))) {
        //  Exit the child, telling it it's being deactivated by a parent.
        child.exit(details, true);

        //  Clear the child reference. We're exiting the state that "owned" it.
        this.set('child', null);
    }

    //  Exit works with whatever local state we're currently in.
    state = this.get('state');

    //  {Old}Exit or StateExit[When{Old}]
    signal = this.getActionSignal(state, TP.EXIT);
    signal.setPayload(details);
    signal.fire();

    if (TP.isTrue(nested)) {
        //  If we're being exited "top down" from the parent then we need to
        //  clear up any leftover state.
        this.set('parent', null);
        this.deactivate(true);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('getActionName',
function(stateAction) {

    /**
     * @method getActionName
     * @summary Constructs a valid signal or function suffix for the provided
     *     action.
     * @param {String} stateAction TP.ENTER, TP.EXIT, or TP.TRANSITION.
     * @returns {String} The action suffix.
     */

    switch (stateAction) {
        case TP.ENTER:
            return 'Enter';
        case TP.EXIT:
            return 'Exit';
        case TP.INPUT:
            return 'Input';
        default:
            return 'Transition';
    }
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('getActionSignal',
function(stateName, stateAction) {

    /**
     * @method getActionSignal
     * @summary Constructs a valid state transition signal for the state name
     *     and state action being processed.
     * @param {String} stateName The name of the state.
     * @param {String} stateAction TP.ENTER, TP.EXIT, TP.INPUT, or TP.TRANSITION.
     * @returns {TP.sig.StateSignal} The state signal.
     */

    var name,
        sigType,
        signal;

    //  Compute a name based on the state and the action name
    name = this.getStateName(stateName) + this.getActionName(stateAction);

    //  See if that name can be resolved to either an APP.sig or TP.sig signal.
    sigType = TP.sys.getTypeByName('APP.sig.' + name);
    if (!TP.isType(sigType)) {
        sigType = TP.sys.getTypeByName('TP.sig.' + name);
    }

    //  If so, construct one, set it's origin and return that.
    if (TP.isType(sigType)) {
        signal = sigType.construct();
        signal.setOrigin(this);

        return signal;
    }

    //  Otherwise, we construct a 'generic' state signal subtype of
    //  TP.sig.StateSignal, based on the state action.
    switch (stateAction) {
        case TP.ENTER:
            sigType = TP.sig.StateEnter;
            break;
        case TP.EXIT:
            sigType = TP.sig.StateExit;
            break;
        case TP.INPUT:
            sigType = TP.sig.StateInput;
            break;
        default:
            sigType = TP.sig.StateTransition;
            break;
    }

    //  Construct it and set it's name locally to the fully expanded signal name
    //  (if possible - this is a spoofed signal anyway).
    signal = sigType.construct();
    signal.setSignalName(TP.expandSignalName(name));
    signal.setOrigin(this);

    return signal;
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('getCurrentState',
function(childExit) {

    /**
     * @method getCurrentState
     * @summary Returns the current state as a string with the canonical name.
     * @param {Boolean} [childExit=false] True if this is being called by the
     *     child during exit processing. This is required to ensure that when
     *     the parent transitions it knows to ignore client state.
     * @returns {String|undefined} The normalized state name.
     */

    var child,
        state;

    if (TP.notTrue(childExit) && TP.isValid(child = this.get('child'))) {
        return child.getCurrentState();
    }

    state = this.$get('state');
    if (TP.notValid(state)) {
        return;
    }

    return state;
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('getCurrentStates',
function() {

    /**
     * @method getCurrentStates
     * @summary Returns the list of all current state names from most-nested
     *     child state to the receiver.
     * @returns {String[]} The list of state names.
     */

    var arr,
        child,
        state;

    if (TP.isValid(child = this.get('child'))) {
        arr = child.getCurrentStates();
    } else {
        arr = TP.ac();
    }
    state = this.get('state');

    if (TP.isValid(state)) {
        arr.push(state);
    }

    return arr;
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('$getFinalStates',
function() {

    /**
     * @method $getFinalStates
     * @summary Scans the list of known states and returns a list of any which
     *     have at least one path to a null targetState.
     * @returns {String[]} The list of final state names.
     */

    var hash,
        items;

    hash = this.get('byTarget');
    items = hash.at(this.getStateName(null));

    if (TP.notValid(items)) {
        return TP.ac();
    }

    return items.collect(function(item) {
        return item.first();
    });
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('$getStartStates',
function() {

    /**
     * @method $getStartStates
     * @summary Scans the list of known states and returns a list of any which
     *     have at least one path from a null initialState.
     * @returns {String[]} The list of start state names.
     */

    var hash,
        items;

    hash = this.get('byInitial');
    items = hash.at(this.getStateName(null));

    if (TP.notValid(items)) {
        return TP.ac();
    }

    return items.collect(
                function(item) {
                    return item.first();
                });
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('getStateName',
function(aState) {

    /**
     * @method getStateName
     * @summary Returns the current state as a string with the canonical name.
     * @param {String} [aState] The state name to normalize. Defaults to the
     *     current state.
     * @returns {String} The normalized state name.
     */

    return TP.core.StateMachine.normalizeState(aState);
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('getTargetStates',
function(initial) {

    /**
     * @method getTargetStates
     * @summary Returns the list of all potential target state names from a
     *     particular state (or the current state).
     * @param {String} [initial=currentState] The state to use as a start state
     *     in the target state search.
     * @returns {String[]} The list of state names.
     */

    var start,
        initials;

    //  NOTE we use arguments.length test here since we have a null state as the
    //  pre-start state and can use that to list 'start states'.
    start = arguments.length === 0 ? this.getCurrentState() : initial;
    start = this.getStateName(start);

    initials = this.$get('byInitial').at(start);

    if (TP.notValid(initials)) {
        return TP.ac();
    }

    return initials.collect(function(item) {
        return item.first();
    }).unique();
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineHandler('Signal',
function(aSignal) {

    /**
     * @method handleSignal
     * @summary Responds to notifications of a signal/event that makes up part
     *     of the state machine's "input event stream". This method is invoked
     *     when you connect a state machine to an event stream via observe()
     *     without providing an explicit handler.
     * @param {TP.sig.Signal} aSignal The signal.
     * @returns {TP.core.StateMachine} The receiver.
     */

    this.updateCurrentState(aSignal);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('isActive',
function() {

    /**
     * @method isActive
     * @summary Returns whether or not the receiver is in an active state.
     * @returns {Boolean} Whether or not the receiver is active.
     */

    return TP.notEmpty(this.get('state'));
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('isOnOffOnly',
function() {

    /**
     * @method isOnOffOnly
     * @summary Checks if the receiver only has one state other than 'Null'.
     *     This type of state machine can be defined by using a single
     *     defineState(null, 'On') statement. In such a machine there should
     *     be no warnings/errors about transitions or transitions to 'Null'
     *     based on triggers. Only activate() and deactivate() (on and off)
     *     are valid operations.
     * @returns {Boolean} Whether or not the receiver is on/off only.
     */

    var starts,
        start,
        targets;

    //  There can be only one... start state (aka the 'ON' state).
    starts = this.$getStartStates();
    if (starts.getSize() !== 1) {
        return false;
    }

    start = starts.at(0);

    //  The start state can only transition back to 'OFF' or.stay 'ON'
    targets = this.getTargetStates(start);
    switch (targets.getSize()) {
    case 0:
            //  defineState(null, 'on') only... no target state defs.
            return true;
    case 1:
            //  defineState(null, 'on'); defineState('on'); only.
            return targets.at(0) === start ||
                targets.at(0) === 'Null';
    case 2:
            return targets.indexOf(start) !== TP.NOT_FOUND &&
                targets.indexOf('Null') !== TP.NOT_FOUND;
    default:
            return false;
    }
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('mayTransition',
function(initialState, targetState, trigger) {

    /**
     * @method mayTransition
     * @summary Returns true if no guards or other conditions block the
     *     potential transition being suggested.
     * @param {String} initialState The initial state.
     * @param {String} targetState The target state.
     * @param {String|TP.sig.Signal} [trigger] Triggering signal or name.
     * @returns {Boolean} True if the transition isn't blocked by a guard.
     */

    var guard,
        details,
        initial,
        target,
        triggers,
        conditional;

    initial = this.getStateName(initialState);
    target = this.getStateName(targetState);

    //  On/Off only machines do not auto-deactivate via transitions.
    if (this.isOnOffOnly() && target === 'Null') {
        return false;
    }

    if (TP.notValid(initialState)) {
        details = this.get('byInitial').at(this.getStateName(null));
    } else {
        details = this.get('byInitial').at(initial);
    }

    if (TP.isValid(details)) {
        details = details.filter(function(item) {
            return item.at(0) === target;
        }).first().last();
    }

    if (TP.isValid(details)) {

        triggers = details.at('triggers');
        if (TP.notEmpty(triggers)) {

            //  There's at least one trigger 'guarding' the transition. At least
            //  one of them must provide for conditional success to move ahead.
            conditional = triggers.some(function(pair) {
                var signal,
                    origin;

                origin = pair.first();
                signal = pair.last();

                if (TP.isValid(trigger)) {
                    if (origin !== TP.ANY) {
                        if (origin !== trigger.getOrigin()) {
                            return false;
                        }
                    }

                    if (TP.isString(signal)) {
                        return trigger.getSignalNames().contains(signal);
                    } else {
                        return TP.isKindOf(signal, trigger);
                    }
                } else {
                    //  Nothing to match/test against but we had a
                    //  requirement that was specified. When we have a guard
                    //  condition but can't verify we fail.
                    return false;
                }
            });
        } else {
            //  No trigger checks, let any guard functions run. If there aren't
            //  any guards the value here will be returned, implying conditional
            //  success (no triggers filtered it, no guards filtered it).
            conditional = true;
        }

        if (TP.isTrue(conditional)) {
            guard = details.at('guard');
            if (TP.isValid(guard)) {
                if (TP.isFunction(guard)) {
                    return guard(trigger);
                } else if (TP.canInvoke(this, guard)) {
                    return this[guard](trigger);
                } else {
                    this.raise('InvalidStateGuard', guard);
                    return false;
                }
            }
        } else {
            return conditional;
        }
    }

    //  Didn't have a valid guard function. Check for local method guards.
    guard = 'accept' + this.getStateName(target) +
            'When' + this.getStateName(initial);

    if (TP.canInvoke(this, guard)) {
        return this[guard](trigger);
    } else {
        guard = 'accept' + this.getStateName(target);
        if (TP.canInvoke(this, guard)) {
            return this[guard](trigger);
        }
    }

    //  If no local method guard return any conditional trigger value.
    return conditional;
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('$setState',
function(newState) {

    /**
     * @method $setState
     * @summary Sets the current state of the receiver without invoking any
     *     handlers for state transitions. Note that this call can cause the
     *     state machine to become inconsistent if not used carefully.
     * @param {Number} newState A TP state code value.
     * @returns {Number} A TP state code value.
     */

    var log,
        state;

    state = this.getStateName(newState);

    this.$set('state', state);

    //  Log the new state, truncating the log to ensure that it doesn't grow
    //  beyond a maximum threshold.
    log = this.get('stateLog');
    log.push(newState);
    log.length = log.length.min(TP.core.StateMachine.LOG_MAX);

    return this.get('state');
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('transition',
function(aState, signalOrParams, childExit) {

    /**
     * @method transition
     * @summary Performs transition processing for both internal (input only)
     *     and full transitions.
     * @description There are officially two types of transition, so-called
     *     "internal" transitions which simply update internal state variables
     *     and the more general transitions which cause the invocation of any
     *     transition actions such as enter, exit, etc. This method deals with
     *     internal transitions by searching the receiver for any methods which
     *     follow the getBestMethod pattern for handling the input trigger(s).
     *     For general transitions this method simply coordinates signaling of
     *     the proper transition events to allow observers to update based on
     *     the new state and to run any enter/exit/transition methods they have.
     * @param {String} aState The state to transition to.
     * @param {TP.sig.Signal|TP.core.Hash|Array} signalOrParams
     *     Triggering information, usually a signal or parameter data.
     * @param {Boolean} [childExit=false] True if this is being called by the
     *     child during exit processing. This is required to ensure that when
     *     the parent transitions it knows to ignore client state.
     * @returns {TP.core.StateMachine} The receiver.
     */

    var oldState,
        newState,
        details,
        triggerTime,
        lastTriggerTime,
        internal,
        trigger,
        handler,
        signal,
        parent,
        type,
        child,
        states,
        reachables,
        names,
        name;

    oldState = this.getCurrentState(childExit);
    newState = this.getStateName(aState);
    trigger = signalOrParams;

    details = TP.hc();
    details.atPut('prior', oldState);
    details.atPut('state', newState);
    details.atPut('trigger', trigger);

    // TP.info('TP.core.StateMachine :: transition -' +
    //          ' oldState: ' + oldState +
    //          ' newState: ' + newState +
    //          ' trigger: ' + TP.str(details.at('trigger')));

    //  If the state isn't changing this is an internal transition request.

    //  If we are triggered try to directly respond to that triggering
    //  signal as our first priority.

    //  If we can obtain a time from the trigger (i.e. it's a TP.sig.Signal of
    //  some sort), then we do so. We'll use this in a comparison below.
    if (TP.isKindOf(trigger, 'TP.sig.Signal')) {
        triggerTime = trigger.get('time');
    } else {
        //  Otherwise, we just set the last trigger time to 0.
        this.set('$lastTriggerTime', 0);
    }

    //  Certain cases seem to misbehave here if we don't force parens.
    /* eslint-disable no-extra-parens */
    internal = (oldState === newState);
    /* eslint-enable no-extra-parens */

    if (internal) {

        //  If our last trigger time matches the trigger time for this signal,
        //  then we exit here. This is because we might have already fired this
        //  signal (as part of our 'fire the INPUT signal' convenience) just
        //  before we transitioned out of a state (see below) and we don't want
        //  it to fire again.
        lastTriggerTime = this.get('$lastTriggerTime');
        if (TP.isNumber(lastTriggerTime) &&
            triggerTime === lastTriggerTime) {
            return this;
        }

        //  If we are triggered try to directly respond to that triggering
        //  signal as our first priority.
        if (TP.isKindOf(trigger, 'TP.sig.Signal')) {

            //  Try to handle locally within this state machine.
            handler = this.getBestHandler(
                trigger,
                {
                    startSignal: null,
                    skipName: 'Signal'
                });

            if (TP.isFunction(handler)) {
                handler.call(this, trigger);
            } else {
                //  Try bubbling to parent if not handled.
                if (TP.isValid(parent = this.get('parent'))) {
                    handler = parent.getBestHandler(
                        trigger,
                        {
                            startSignal: null,
                            skipName: 'Signal'
                        });

                    if (TP.isFunction(handler)) {
                        handler.call(parent, trigger);
                    }
                }
            }
        }

        //  Fire any input signal as a 'convenience'

        //  {Old}Input or StateInputWhen{Old}
        signal = this.getActionSignal(oldState, TP.INPUT);
        signal.setPayload(details);

        //  Try to handle it locally. The state machine itself gets first chance
        //  at any input/internal transition signals. NOTE that we have to watch
        //  out for invoking our update routine recursively via handleSignal :).
        handler = this.getBestHandler(
            signal,
            {
                startSignal: null,
                skipName: 'Signal'
            });

        if (TP.isFunction(handler)) {
            handler.call(this, signal);
        } else {
            //  If this is a nested state machine bubble the option to handle
            //  the input to our outer composite state. This is the fundamental
            //  feature of a truly nested state machine.
            if (TP.isValid(parent = this.get('parent'))) {
                handler = parent.getBestHandler(
                    signal,
                    {
                        startSignal: null,
                        skipName: 'Signal'
                    });

                if (TP.isFunction(handler)) {
                    handler.call(parent, signal);
                }
            }
        }

        //  Note that if the signal has been stopped this won't do much.
        if (!signal.shouldStop() && !signal.shouldStopImmediately()) {
            signal.fire();
        }

    } else {

        if (TP.notEmpty(oldState)) {
            //  The first thing we do before we transition out of the current
            //  state is fire the INPUT signal, as a 'convenience'.

            //  {Old}Input or StateInputWhen{Old}
            signal = this.getActionSignal(oldState, TP.INPUT);
            signal.setPayload(details);

            //  Try to handle it locally. The state machine itself gets first
            //  chance at any input/internal transition signals. NOTE that we
            //  have to watch out for invoking our update routine recursively
            //  via handleSignal :).
            handler = this.getBestHandler(
                signal,
                {
                    startSignal: null,
                    skipName: 'Signal'
                });

            if (TP.isFunction(handler)) {
                handler.call(this, signal);
            } else {
                //  If this is a nested state machine bubble the option to
                //  handle the input to our outer composite state. This is the
                //  fundamental feature of a truly nested state machine.
                if (TP.isValid(parent = this.get('parent'))) {
                    handler = parent.getBestHandler(
                        signal,
                        {
                            startSignal: null,
                            skipName: 'Signal'
                        });

                    if (TP.isFunction(handler)) {
                        handler.call(parent, signal);
                    }
                }
            }

            //  Note that if the signal has been stopped this won't do much.
            if (!signal.shouldStop() && !signal.shouldStopImmediately()) {
                signal.fire();
            }
        }

        //  Now go ahead and do the state transition

        //  When processing a start state there is no state to exit.
        if (TP.notEmpty(oldState)) {

            //  Invoke the exit routine to ensure any child exit processing
            //  occurs in the right order.
            this.exit(details);
        }

        //  {New}Transition or StateTransition[When{Old}]
        signal = this.getActionSignal(newState, TP.TRANSITION);
        signal.setPayload(details);
        signal.fire();

        //  Transition our state. We do this here to ensure that any "When"
        //  clause construction will be using accurate transition values.
        if (oldState !== newState) {
            this.$setState(newState);
        }

        //  {New}Enter or StateEnterWhen{New}
        signal = this.getActionSignal(newState, TP.ENTER);
        signal.setPayload(details);
        signal.fire();

        //  If the state is mapped to a nested state machine that machine should
        //  now be activated. This operation is required to occur after the
        //  composite state "enter" function has completed.
        child = this.get('byParent').at(newState);
        if (TP.isValid(child)) {
            if (!TP.isKindOf(child, 'TP.core.StateMachine')) {
                type = TP.sys.getTypeByName(child);
                if (TP.isType(type)) {
                    child = type.construct();
                } else {
                    this.raise('InvalidStateMachine',
                        'Invalid nested state machine specification: ' +
                        child);
                    child = null;
                }
            }

            if (TP.isValid(child)) {
                this.set('child', child);
                child.set('parent', this);
                child.activate();
            }
        }

        //  We can automatically deactivate when we reach the final state if
        //  that state is "final only" meaning it can't transition to any other
        //  state as an alternative route.
        if (TP.notEmpty(oldState) && !this.isOnOffOnly()) {
            states = this.$getFinalStates();
            if (states.indexOf(newState) !== TP.NOT_FOUND) {

                //  A final state. Obtain states that newState can transition to
                //  and ask if it is a "final only" state.
                states = this.get('byInitial');
                reachables = states.at(newState);

                names = reachables.map(
                            function(item) {
                                return item.at(0);
                            });

                if (names.length === 1) {
                    name = names.at(0);

                    if (name !== oldState &&
                        name === this.getStateName(null)) {

                        this.deactivate();

                        //  If we're a nested state machine we're essentially
                        //  done, but we need to also trigger our parent to
                        //  update since the child has reached a terminal point.
                        if (TP.isValid(parent = this.get('parent'))) {
                            //  NOTE that this should cause a parent transition
                            //  which ultimately exits the parent and cleans up
                            //  references.
                            parent.updateCurrentState(details, true);
                        }
                    }
                }
            }
        }
    }

    //  Capture the time that the last trigger signal fired.
    this.set('$lastTriggerTime', triggerTime, false);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.StateMachine.Inst.defineMethod('updateCurrentState',
function(signalOrParams, childExit) {

    /**
     * @method updateCurrentState
     * @summary Sets the receiver's state as necessary based on parameter input.
     *     In all cases a transition is requested but it may be an internal
     *     transition if the data doesn't necessitate a full state change.
     * @param {TP.sig.Signal|Object} signalOrParams An object containing
     *     information which might help determine the state. Usually a signal
     *     instance provided from the receiver's trigger configuration.
     * @param {Boolean} [childExit=false] True if this is being called by the
     *     child during exit processing. This is required to ensure that when
     *     the parent transitions it knows to ignore client state.
     * @returns {String} The current state name upon exit.
     */

    var machine,
        oldState,
        newState,
        stateTargets,
        stateCount,
        len,
        i,
        targetState,
        stateName;

    /* eslint-disable consistent-this */

    machine = this;

    //  Check the various state test functions and determine what our state
    //  should be.

    oldState = this.getCurrentState(childExit);
                // this.getStateName(this.get('state'));

    newState = oldState;

    // TP.info('TP.core.StateMachine :: updateCurrentState -' +
    //          ' oldState: ' + oldState +
    //          ' newState: ' + newState);

    //  Get the list of potential target states to be checked.
    stateTargets = TP.ifInvalid(this.get('byInitial').at(oldState), TP.ac());

    if (TP.isEmpty(stateTargets) && !this.isOnOffOnly()) {
        //  No target states means we're at a final state, but apparently didn't
        //  deactivate since we're still receiving input from our triggers.
        TP.ifWarn() ?
            TP.warn('State update request yielded no targets for: ' +
                    oldState +
                    '.') : 0;

        return oldState;
    } else {
        //  We can get 0, which means no new state, 1...which means we have
        //  a new state, or > 1 which means we have an inconsistent state
        //  machine config/definition because more than one state test
        //  passed and we have more than one potential transition.
        stateCount = 0;

        len = stateTargets.getSize();

        //  If this is not a 'final only' state, then disqualify transitioning
        //  to a deactivated state. Require explicit deactivation instead.
        if (len > 1) {
            stateTargets = stateTargets.filter(
                            function(target) {
                                return target.first() !==
                                    machine.getStateName(null);
                            });
        }

        //  Make sure to refetch len in case we filtered some out.
        len = stateTargets.getSize();
        for (i = 0; i < len; i++) {

            stateName = stateTargets.at(i).first();

            if (this.mayTransition(oldState, stateName, signalOrParams)) {
                targetState = stateName;
                stateCount++;
            }
        }

        if (stateCount > 1) {
            this.raise('InvalidStateTransition',
                'Multiple valid target states for transition from: ' +
                oldState);
            return oldState;
        } else if (stateCount === 1) {
            newState = targetState;
        }
    }

    //  Invoke the transition machinery. Note that there's no requirement here
    //  that the two states (old, new) be different. The transition call deals
    //  with both true transitions and with "internal" transitions/stateInput.
    this.transition(newState, signalOrParams, childExit);

    /* eslint-enable consistent-this */

    return newState;
});

//  ========================================================================
//  TP.core.StateResponder
//  ========================================================================

/**
 * @type {TP.core.StateResponder}
 * @summary A common supertype for StateMachine event responders.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('TP.core.StateResponder');

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation
TP.core.StateResponder.isAbstract(true);

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  Optional array of specific states in which responder receives input signals
//  and their associated redirected triggers.
TP.core.StateResponder.Inst.defineAttribute('inputStates');

//  The state machine that the responder is listening to for state changes and
//  input signals.
TP.core.StateResponder.Inst.defineAttribute('stateMachines');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.StateResponder.Inst.defineMethod('addInputState',
function(aState) {

    /**
     * @method addInputState
     * @summary Adds an individual input state name to the list of states in
     *     which the receiver will process input signals from the state machine.
     * @param {String} aState The name of the state to add.
     * @returns {TP.core.StateResponder} The receiver.
     */

    var state,
        inputs;

    state = TP.core.StateMachine.normalizeState(aState);

    inputs = this.$get('inputStates');
    if (TP.notValid(inputs)) {
        inputs = TP.ac();
    }
    inputs.push(state);
    this.$set('inputStates', inputs, false);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.StateResponder.Inst.defineMethod('addStateMachine',
function(aStateMachine) {

    /**
     * @method addStateMachine
     * @summary Adds a state machine to the list of state machines the receiver
     *     will observe and respond to.
     * @param {TP.core.StateMachine} aStateMachine The state machine to add.
     * @returns {TP.core.StateResponder} The receiver.
     */

    var machines;

    if (TP.notValid(aStateMachine)) {
        return this.raise('InvalidParameter');
    }

    machines = this.getStateMachines();
    machines.push(aStateMachine);

    this.observe(aStateMachine, TP.sig.StateSignal);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.StateResponder.Inst.defineMethod('getStateMachines',
function() {

    /**
     * @method getStateMachines
     * @summary Returns the receiver's list of state machines.
     * @returns {TP.core.StateMachine[]} The list of state machines.
     */

    var machines;

    machines = this.$get('stateMachines');
    if (TP.notValid(machines)) {
        machines = TP.ac();
        this.$set('stateMachines', machines);
    }

    return machines;
});

//  ------------------------------------------------------------------------

TP.core.StateResponder.Inst.defineMethod('removeStateMachine',
function(aStateMachine) {

    /**
     * @method removeStateMachine
     * @summary Removes a state machine from the list of state machines the
     *     receiver observes and responds to.
     * @param {TP.core.StateMachine} aStateMachine The state machine to add.
     * @returns {TP.core.StateResponder} The receiver.
     */

    var machines;

    if (TP.notValid(aStateMachine)) {
        return this.raise('InvalidParameter');
    }

    machines = this.getStateMachines();
    machines.remove(aStateMachine);

    this.ignore(aStateMachine, TP.sig.StateSignal);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.StateResponder.Inst.defineMethod('setInputStates',
function(anArray) {

    /**
     * @method setInputStates
     * @summary Sets an explicit array of input states, states in which the
     *     responder will receive input signals or input-phase trigger signals.
     * @param {String[]} anArray The array of input states.
     * @returns {TP.core.StateResponder} The receiver.
     */

    this.$set('inputStates', anArray, false);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.StateResponder.Inst.defineMethod('teardownStateResponder',
function() {

    /**
     * @method teardownStateResponder
     * @summary Tears down the responder. This causes the responder to ignore
     *     all known state machines and to then empty its state machine list.
     * @returns {TP.core.StateResponder} The receiver.
     */

    var thisref,
        machines;

    thisref = this;

    machines = this.getStateMachines();
    machines.forEach(
            function(aStateMachine) {
                thisref.ignore(aStateMachine, TP.sig.StateSignal);
            });
    machines.empty();

    return this;
});

//  ------------------------------------------------------------------------
//  Handlers
//  ------------------------------------------------------------------------

TP.core.StateResponder.Inst.defineHandler('StateSignal',
function(aSignal) {

    /**
     * @method handleStateSignal
     * @summary Responder for top-level StateSignal instance. This method serves
     *     as a common backstop for all StateReponders.
     * @returns {TP.core.StateResponder} The receiver.
     */

    if (TP.sys.shouldLogSignals()) {
        TP.debug('StateSignal: ' + TP.str(aSignal));
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.StateResponder.Inst.defineHandler('StateInput',
function(aSignal) {

    /**
     * @method handleStateInput
     * @summary Handles 'input signals' from the state machine. This method
     *     serves as a kind of 'redirector' for StateResponder instances,
     *     allowing them to observe state input signals but have their handlers
     *     for the specific triggering signals invoked as a result.
     * @param {TP.sig.StateInput} aSignal The signal that caused the state
     *     machine to get further input. The original triggering signal will
     *     be in this signal's payload under the key 'trigger'.
     * @returns {TP.core.StateResponder} The receiver.
     */

    var inputs,
        trigger,
        triggerSignal;

    inputs = this.$get('inputStates');
    if (TP.isValid(inputs)) {
        //  NOTE we check against 'prior' here since input signals are passed
        //  'prior' (aka current) and 'state' (aka future).
        if (!inputs.contains(aSignal.at('prior'))) {
            return this;
        }
    }

    if (TP.sys.shouldLogSignals()) {
        TP.debug('StateInput: ' + TP.str(aSignal));
    }

    trigger = aSignal.getPayload().at('trigger');
    if (TP.isKindOf(trigger, TP.sig.Signal)) {
        this.handle(trigger);
    } else if (TP.canInvoke(trigger, 'at')) {
        triggerSignal = trigger.at('trigger');
        if (TP.isKindOf(trigger, TP.sig.Signal)) {
            this.handle(triggerSignal);
        }
    }

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETDeviceTypes.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @
 */

//  ========================================================================
//  TP.core.Device
//  ========================================================================

TP.core.SignalSource.defineSubtype('core.Device');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  the forwarding function used when we need to pass events to the main
//  notification center.
TP.core.Device.Type.defineConstant('REDIRECTOR',
    function(aSignal) {

        var normalizedEvent,
            targetElem;

        normalizedEvent = aSignal.getEvent();

        if (TP.isElement(targetElem =
                            TP.eventGetResolvedTarget(normalizedEvent))) {
            //  NOTE that device events are natively DOM events so we fire
            //  with a DOM_FIRING policy here
            aSignal.fire(
                TP.elementGetEventOrigins(targetElem, normalizedEvent),
                normalizedEvent,
                TP.DOM_FIRING);
        }
    });

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.Device.Type.defineMethod('addObserver',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method addObserver
     * @summary Adds a local signal observation which is roughly like a DOM
     *     element adding an event listener. The observer is typically the
     *     handler provided to an observe() call while the signal is a signal or
     *     string which the receiver is likely to signal or is intercepting for
     *     centralized processing purposes.
     * @param {Object|Object[]} anOrigin One or more origins to observe.
     * @param {Object|Object[]} aSignal One or more signals to observe from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn on observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to add the observation, false otherwise.
     */

    var signals,
        len,
        map,
        i,
        signal,
        count,
        handler,
        dict,
        arr;

    if (TP.isArray(aSignal)) {
        signals = aSignal;
    } else if (TP.isString(aSignal)) {
        signals = aSignal.split(' ');
    } else if (TP.isType(aSignal)) {
        signals = TP.ac(aSignal);
    } else {
        this.raise('TP.sig.InvalidParameter',
                    'Improper signal definition.');

        return false;
    }

    len = signals.getSize();

    //  If there's a policy or the origin is specific rather than the receiver's
    //  device name then we just want to set up a "redirect" handler that pushes
    //  the signal to the notification system where things like policy and
    //  origin targeting can be processed.

    /* eslint-disable no-extra-parens */
    if (TP.notEmpty(aPolicy) ||
        (anOrigin !== this && anOrigin !== this.getName())) {
    /* eslint-enable no-extra-parens */

        //  we have to track observe/ignore stats more closely when we set up
        //  redirections since each ignore says to remove the redirector, but we
        //  need to keep at least one as long as we've got more observes than we
        //  do ignores
        map = this.get('redirections');

        for (i = 0; i < len; i++) {
            signal = signals.at(i).getSignalName();
            count = map.at(signal);

            if (TP.isNumber(count) && count > 1) {
                //  increment the count
                map.atPut(signal, count + 1);
            } else {
                map.atPut(signal, 1);
            }
        }

        handler = this.REDIRECTOR;
    } else {
        handler = aHandler;
    }

    //  invalid handler, no response can happen
    if (TP.notValid(handler)) {
        this.raise('TP.sig.InvalidHandler');

        return false;
    }

    dict = this.get('observers');

    for (i = 0; i < len; i++) {
        signal = signals.at(i).getSignalName();

        //  Signal paths are signals with a '__' separation. We use a subtype
        //  specific method to process those. Keyboard shortcuts are the
        //  typically use of this syntax.
        if (/__/.test(signal)) {
            this.addShortcutObserver(signal, handler);
        } else {
            if (TP.notValid(arr = dict.at(signal))) {
                arr = TP.ac();
                dict.atPut(signal, arr);
            }

            arr.push(handler);

            //  unfortunately there's a bit of potential overhead here since we
            //  need to unique for each possible signal name in the list
            arr.unique();
        }
    }

    //  if the handler we registered was not the original one then we swapped it
    //  out for the redirector and we want the notification center to go ahead
    //  and register it.

    /* eslint-disable no-extra-parens */
    return (handler !== aHandler);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.core.Device.Type.defineMethod('addShortcutObserver',
function(aSignal, aHandler) {

    /**
     * @method addShortcutObserver
     * @summary Adds a local signal observation for a "signal path", which is
     *     effectively a "gesture". Keyboard shortcuts are the primary example
     *     of signal paths. The default implementation simply returns.
     * @param {Object|Object[]} aSignal One or more signals to observe from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn on observations
     *     for.
     * @returns {Object[]} The handler array with the new observer added.
     */

    return TP.ac();
});

//  ------------------------------------------------------------------------

TP.core.Device.Type.defineMethod('getDOMSignalName',
function(normalizedEvent) {

    /**
     * @method getDOMSignalName
     * @summary Returns the DOM signal name for a particular event.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {String} The key event DOM signal name.
     */

    return TP.DOM_SIGNAL_TYPE_MAP.at(TP.eventGetType(normalizedEvent));
});

//  ------------------------------------------------------------------------

TP.core.Device.Type.defineMethod('invokeObservers',
function(singletonName, normalizedEvent, aSignal) {

    /**
     * @method invokeObservers
     * @summary Runs the event handlers for any registered observers.
     * @description Each native event type has a singleton TIBET signal instance
     *     registered with the device type. This singleton is acquired, updated,
     *     and then passed to each handler for processing. The normalizedEvent
     *     becomes the payload/native event for the signal and is thereby
     *     available to each handler for use.
     * @param {String} singletonName The attribute name used to acquire a
     *     singleton signal instance for the invocation.
     * @param {Event} normalizedEvent A normalized (augmented) native event
     *     object conforming to a set of common and W3-compliant methods.
     * @param {TP.sig.Signal} aSignal Optional signal to use rather than the
     *     singleton/event pair.
     * @returns {TP.sig.Signal} The TIBET signal instance used during
     *     notification.
     */

    TP.override();

    return aSignal;
});

//  ------------------------------------------------------------------------

TP.core.Device.Type.defineMethod('removeObserver',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method removeObserver
     * @summary Removes a local signal observation which is roughly like a DOM
     *     element adding an event listener. The observer is typically the
     *     handler provided to an observe call while the signal is a signal or
     *     string which the receiver is likely to signal or is intercepting for
     *     centralized processing purposes.
     * @param {Object|Object[]} anOrigin One or more origins to ignore.
     * @param {Object|Object[]} aSignal One or more signals to ignore from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn off observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to remove the observation, false otherwise.
     */

    var signals,
        len,
        map,
        i,
        signal,
        count,
        handler,
        dict,
        arr;

    if (TP.isArray(aSignal)) {
        signals = aSignal;
    } else if (TP.isString(aSignal)) {
        signals = aSignal.split(' ');
    } else if (TP.isType(aSignal)) {
        signals = TP.ac(aSignal);
    } else {
        this.raise('TP.sig.InvalidParameter',
                    'Improper signal definition.');

        return false;
    }

    len = signals.getSize();

    /* eslint-disable no-extra-parens */
    if (TP.notEmpty(aPolicy) ||
        (anOrigin !== this && anOrigin !== this.getName())) {
    /* eslint-enable no-extra-parens */

        map = this.get('redirections');

        for (i = 0; i < len; i++) {
            signal = signals.at(i).getSignalName();
            count = map.at(signal);

            if (TP.isNumber(count) && count > 1) {
                //  decrement the count
                map.atPut(signal, count - 1);
            } else {
                map.atPut(signal, 0);
            }
        }

        handler = this.REDIRECTOR;
    } else {
        handler = aHandler;
    }

    dict = this.get('observers');
    for (i = 0; i < len; i++) {
        signal = signals.at(i).getSignalName();

        //  Signal paths are signals with a '__' separation. We use a
        //  subtype specific method to process those. Keyboard shortcuts are
        //  the typically use of this syntax.
        if (/__/.test(signal)) {
            this.removeShortcutObserver(signal, handler);
        } else {
            if (TP.isArray(arr = dict.at(signal))) {
                //  NOTE: We use an *identical* compare here - otherwise,
                //  the system wanders all over trying to compute equality
                //  values for the handlers.
                arr.remove(handler, TP.IDENTITY);
                if (TP.isEmpty(arr)) {
                    dict.removeKey(signal);
                }
            }
        }
    }

    //  If we've changed the handler to the redirector we need to make sure
    //  the notification center removes it as well.

    /* eslint-disable no-extra-parens */
    return (handler !== aHandler);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.core.Device.Type.defineMethod('removeShortcutObserver',
function(aSignal, aHandler) {

    /**
     * @method removeShortcutObserver
     * @summary Removes a local signal observation for a "signal path", which
     *     is effectively a "gesture". Keyboard shortcuts are the primary
     *     example of signal paths. The default implementation simply returns.
     * @param {Object|Object[]} aSignal One or more signals to observe from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn on observations
     *     for.
     * @returns {Number} The number of handlers that were removed.
     */

    return 0;
});

//  ------------------------------------------------------------------------

TP.core.Device.Type.defineMethod('signalObservers',
function(anOrigin, aSignal, aPayload, aPolicy, aType, isCancelable,
         isBubbling) {

    /**
     * @method signalObservers
     * @summary Signals a local signal observation which is roughly like a DOM
     *     element throwing an event. The observer is typically the handler
     *     provided to a signal() call while the signal is a signal or string
     *     which the receiver is likely to signal or is intercepting for
     *     centralized processing purposes.
     * @param {Object} anOrigin The originator of the signal.
     * @param {String|TP.sig.Signal} aSignal The signal to fire.
     * @param {Object} aPayload Optional argument object.
     * @param {Function} aPolicy A "firing" policy that will define how the
     *     signal is fired.
     * @param {String|TP.sig.Signal} aType A default type to use when the signal
     *     type itself isn't found and a new signal subtype must be constructed.
     *     Defaults to TP.sig.Signal.
     * @param {Boolean} isCancelable Optional flag for dynamic signals defining
     *     if they can be cancelled.
     * @param {Boolean} isBubbling Optional flag for dynamic signals defining
     *     whether they bubble (when using TP.DOM_FIRING).
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to signal the signal, false otherwise.
     */

    var signals,
        len,
        i,
        signame,
        signal,
        typename,
        type;

    //  have to recast this into something we can pass to the invoke
    //  observers call, or we have to duplicate that logic when provided
    //  with a signal that somehow didn't originate from the lower-level
    //  device traps...perhaps it's a synthetic key/mouse event.

    if (anOrigin !== this && anOrigin !== this.getName()) {
        return true;
    }

    if (TP.isArray(aSignal)) {
        signals = aSignal;
    } else if (TP.isString(aSignal)) {
        signals = aSignal.split(' ');
    } else if (TP.isType(aSignal)) {
        signals = TP.ac(aSignal);
    } else {
        this.raise('TP.sig.InvalidParameter',
                    'Improper signal definition.');

        return false;
    }

    len = signals.getSize();

    for (i = 0; i < len; i++) {
        signal = signals.at(i);
        if (!TP.isKindOf(signal, TP.sig.Signal)) {
            if (TP.regex.KEY_EVENT.test(signal)) {
                if (signal.indexOf('_Up') !== TP.NOT_FOUND) {
                    typename = 'TP.sig.DOMKeyUp';
                } else if (signal.indexOf('_Press') !== TP.NOT_FOUND) {
                    typename = 'TP.sig.DOMKeyPress';
                } else {
                    typename = 'TP.sig.DOMKeyDown';
                }
            } else {
                typename = signal;
            }

            //  might be a type if the signal is already real
            type = TP.isTypeName(typename) ?
                    TP.sys.getTypeByName(typename) :
                    TP.sys.getTypeByName(typename);

            if (TP.notValid(type)) {
                this.raise('TP.sig.InvalidType',
                            'Unable to find signal type: ' + typename);

                return false;
            }

            signame = signal;

            signal = type.construct(aPayload);
            if (TP.notValid(signal)) {
                this.raise(
                    'TP.sig.InvalidSignal',
                    'Unable to construct signal instance: ' + signame);

                return false;
            }

            signal.setSignalName(signame);
        }

        this.invokeObservers(null, aPayload, signal);
    }

    return false;
});

//  ========================================================================
//  TP.core.Keyboard
//  ========================================================================

TP.core.Device.defineSubtype('Keyboard');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  overall hash of observations made locally to a specific device
TP.core.Keyboard.Type.defineAttribute('observers', TP.hc());

//  map of signals which we've placed redirectors for
TP.core.Keyboard.Type.defineAttribute('redirections', TP.hc());

//  last event for each of down, press, and up events
TP.core.Keyboard.Type.defineAttribute('lastDown');
TP.core.Keyboard.Type.defineAttribute('lastPress');
TP.core.Keyboard.Type.defineAttribute('lastUp');

//  encached instances of prebuilt signals
TP.core.Keyboard.Type.defineAttribute('keyup');
TP.core.Keyboard.Type.defineAttribute('keydown');
TP.core.Keyboard.Type.defineAttribute('keypress');

//  container for a singleton TP.sig.DOMModifierKeyChange signal used for
//  notification of a change in one or more modifier keys
TP.core.Keyboard.Type.defineAttribute('modifierkeychange');

//  current state of the modifier keys (alt, ctrl, meta/command, and shift)
TP.core.Keyboard.Type.defineAttribute('altDown', false);
TP.core.Keyboard.Type.defineAttribute('ctrlDown', false);
TP.core.Keyboard.Type.defineAttribute('metaDown', false);
TP.core.Keyboard.Type.defineAttribute('shiftDown', false);

//  the current keyboard subtype the user has configured
TP.core.Keyboard.Type.defineAttribute('currentKeyboard');

//  the keyboard's XML map URI, whose contentNode is the actual map
TP.core.Keyboard.Type.defineAttribute('mapuri');

//  a common cache for the current keyboard's XML map
TP.core.Keyboard.Type.defineAttribute('mapxml');

//  a timer used in certain situations to wait for press before signaling
TP.core.Keyboard.Type.defineAttribute('downTimer');

//  a timer used when the keyboard is processing keyboard shortcuts.
TP.core.Keyboard.Type.defineAttribute('shortcutsTimer');

//  a date containing the start time of when keyboard processing of shortcuts is
//  taking place.
TP.core.Keyboard.Type.defineAttribute('shortcutsStartTime');

//  a map of keyboard shortcuts which have been observed via a__b syntax
TP.core.Keyboard.Type.defineAttribute('shortcuts', TP.hc());
TP.core.Keyboard.Type.defineAttribute('shortcutIndex', TP.core.Keyboard.shortcuts);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    var name,
        type;

    //  construct a template instance for signals we care about
    this.$set('keyup',
        TP.sys.getTypeByName('TP.sig.DOMKeyUp').construct(null, true));
    this.$set('keydown',
        TP.sys.getTypeByName('TP.sig.DOMKeyDown').construct(null, true));
    this.$set('keypress',
        TP.sys.getTypeByName('TP.sig.DOMKeyPress').construct(null, true));
    this.$set('modifierkeychange',
        TP.sys.getTypeByName('TP.sig.DOMModifierKeyChange').construct(null,
                                                                true));

    //  load the current keyboard type and its associated keymap
    name = TP.ifInvalid(TP.sys.cfg('tibet.keyboard'),
                        'TP.core.USAscii101Keyboard');

    type = TP.sys.getTypeByName(name) ||
            TP.sys.getTypeByName('TP.core.USAscii101Keyboard');

    if (TP.notValid(type)) {
        TP.ifError() ?
                TP.error('Unable to install keyboard type: ' + name) : 0;

        return;
    }

    //  configure the initial keyboard (and load the initial keymap)
    this.setCurrentKeyboard(type);

    return;
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('addShortcutObserver',
function(aSignal, aHandler) {

    /**
     * @method addShortcutObserver
     * @summary Adds a local signal observation for a "signal path", which is
     *     effectively a "gesture".
     * @description Keyboard shortcuts are stored as a nested set of hashes
     *     where each hash contains the name of the overall shortcut signal, an
     *     optional hash of shortcuts which extend the current one, and an
     *     optional array of handler objects/functions (observers).
     * @param {Object|Object[]} aSignal One or more signals to observe from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn on observations
     *     for.
     * @returns {Object[]} The handler array with the new observer added.
     */

    var shortcutData,
        handlers;

    shortcutData = this.getShortcutData(aSignal, true);
    if (TP.notValid(handlers = shortcutData.at('handlers'))) {
        handlers = TP.ac();
        shortcutData.atPut('handlers', handlers);
    }

    handlers.push(aHandler);
    handlers.unique();

    return handlers;
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('resetEventData',
function(filterWindow) {

    /**
     * @method resetEventData
     * @summary Resets any event data cached by the receiver. It is important
     *     to call this when the GUI is flushed between page refreshes to avoid
     *     having obsolete references to old DOM structures.
     * @param {Window} filterWindow The window to filter cached events by. If
     *     the event occurred in this window, it will be cleared.
     * @returns {TP.meta.core.Keyboard} The receiver.
     */

    var evtTestFunc,
        sigTestFunc;

    evtTestFunc = function(sigName) {

        var event;

        event = this.get(sigName);

        if (TP.isEvent(event) &&
            TP.eventGetWindow(event) === filterWindow) {
            return true;
        }

        return false;
    }.bind(this);

    sigTestFunc = function(sigName) {

        var signal;

        signal = this.get(sigName);

        if (TP.isValid(signal) &&
            TP.isValid(signal.getPayload()) &&
            TP.unwrap(signal.getWindow()) === filterWindow) {
            return true;
        }

        return false;
    }.bind(this);

    if (evtTestFunc('lastDown')) {
        this.set('lastDown', null);
    }

    if (evtTestFunc('lastPress')) {
        this.set('lastPress', null);
    }

    if (evtTestFunc('lastUp')) {
        this.set('lastUp', null);
    }

    if (sigTestFunc('keyup')) {
        this.get('keyup').setEvent(null);
    }

    if (sigTestFunc('keydown')) {
        this.get('keydown').setEvent(null);
    }

    if (sigTestFunc('keypress')) {
        this.get('keypress').setEvent(null);
    }

    if (sigTestFunc('modifierkeychange')) {
        this.get('modifierkeychange').setEvent(null);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('getShortcutData',
function(aSignal, shouldBuild) {

    /**
     * @method getShortcutData
     * @summary Returns the hash used to store shortcut information for a
     *     specific signal path.
     * @param {Object|Object[]} aSignal One or more signals to observe from the
     *     origin(s).
     * @param {Boolean} shouldBuild
     * @returns {TP.core.Hash|undefined} The shortcut data.
     */

    var shortcuts,

        path,
        name,
        parts,

        len,
        i,
        part,

        dict,
        subS;

    /*
        shortcuts = {
            a:
            {
                h = [...],
                s =
                {
                    b:
                    {
                        h = [...],
                        s =
                        {
                            c:
                            {
                                h = [...],
                                n = 'a__b__c'
                            }
                        }
                        n = 'a__b'
                    }
                }
                n = 'a'
            }
        }
    */

    shortcuts = this.get('shortcuts');

    path = '';
    name = aSignal.getSignalName();
    parts = name.split('__');

    len = parts.getSize();
    for (i = 0; i < len; i++) {
        part = parts.at(i);

        path = TP.isEmpty(path) ? part : path + '__' + part;
        dict = shortcuts.at(part);

        if (TP.notValid(dict)) {
            if (TP.notTrue(shouldBuild)) {
                return;
            }

            dict = TP.hc();
            subS = TP.hc();

            dict.atPut('shortcuts', subS);
            dict.atPut('name', path);
            dict.atPut('handlers', TP.ac());

            shortcuts.atPut(part, dict);
        }

        shortcuts = dict.at('shortcuts');
    }

    return dict;
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('loadKeymap',
function() {

    /**
     * @method loadKeymap
     * @summary Loads the XML keyboard map for the receiving keyboard type.
     * @exception TP.sig.InvalidKeymap When the XML keyboard map file can't be
     *     loaded.
     * @returns {TP.meta.core.Keyboard} The receiver.
     */

    var response,
        fname,
        path,
        thisref,

        url,
        resp;

    //  Note that we expand the paths here first before creating a URI. In
    //  this way, all of the 'metadata' URIs are uniformly concrete URIs
    //  instead of TIBET URIs.

    //  the local file name is the type name
    fname = this.getName();

    //  look for a config parameter mapping the keyboard away from ~lib_dat
    path = TP.sys.cfg(fname + '.xml');
    if (!path) {
        path = TP.uriExpandPath('~lib_dat/' + fname + '.xml');
    }

    thisref = this;

    url = TP.uc(path);
    response = url.getResource(TP.hc('async', true));
    response.then(
        function(result) {
            if (TP.isValid(result)) {
                return result.getData().getNativeNode();
            }
        }).then(
        function(result) {
            if (TP.notValid(result)) {
                resp = url.getNativeNode(TP.hc('async', true));
                resp.then(
                    function(aResult) {
                        if (TP.notValid(aResult)) {
                            return thisref.raise('TP.sig.InvalidKeymap');
                        }

                        thisref.$set('mapuri', url);

                        //  cache the XML for speed in other lookups
                        TP.core.Keyboard.$set('mapxml', aResult);
                    });
            } else {
                thisref.$set('mapuri', url);

                //  cache the XML for speed in other lookups
                TP.core.Keyboard.$set('mapxml', result);
            }
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('getCurrentKeyboard',
function() {

    /**
     * @method getCurrentKeyboard
     * @summary Returns the currently active keyboard instance used to perform
     *     all key-event related lookups and processing.
     * @returns {TP.core.Keyboard} The current keyboard instance.
     */

    return TP.core.Keyboard.$get('currentKeyboard');
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('get',
function(attributeName) {

    /**
     * @method get
     * @summary Returns the value for attributeName. TP.core.Keyboard subtypes
     *     look first on themselves and then look to the root TP.core.Keyboard
     *     type for responses to this method.
     * @param {String} attributeName The attribute name to look up.
     * @returns {Object} The attribute value.
     */

    var value;

    //  look locally first using the standard lookup mechanisms (note that
    //  we do *not* callNextMethod) here because of performance reasons.
    value = this.$get(attributeName);

    //  check the root TP.core.Keyboard type in case it's a 'shared'
    //  variable
    if (TP.notValid(value) && this !== TP.core.Keyboard) {
        value = TP.core.Keyboard.get(attributeName);
    }

    return value;
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('invokeObservers',
function(singletonName, normalizedEvent, aSignal) {

    /**
     * @method invokeObservers
     * @summary Runs the event handlers for any registered observers.
     * @description Each native event type has a singleton TIBET signal instance
     *     registered with the device type. This singleton is acquired, updated,
     *     and then passed to each handler for processing. The normalizedEvent
     *     becomes the payload/native event for the signal and is thereby
     *     available to each handler for use.
     * @param {String} singletonName The attribute name used to acquire a
     *     singleton signal instance for the invocation.
     * @param {Event} normalizedEvent A normalized (augmented) native event
     *     object conforming to a set of common and W3-compliant methods.
     * @param {TP.sig.Signal} aSignal Optional signal to use rather than the
     *     singleton/event pair.
     * @returns {TP.sig.Signal|undefined} The signal that was actually
     *     triggered.
     */

    var targetElem,

        fname,
        elemType,

        signal,
        redirector,

        dict,

        signames,

        matchedShortcutSegment,
        shouldClearTimer,
        wasAnUp,

        len,
        i,

        logInfo,

        handlers,

        handlersLen,
        j,

        handler,
        signame,

        shortcutData,
        shortcutName,
        shortcutSig,
        shortcuts,

        timer,

        shortcutSignalName,
        shortcutSignalType,
        completionTimeout;

    if (!TP.sys.hasInitialized()) {
        return;
    }

    //  Sometimes this method is invoked for a synthetic event (like updating
    //  the modifier keys or a TIBET drag event). The normalized event object
    //  will have the real platform event in it (i.e. keydown) which should
    //  *not* be dispatched to the on* call in the case of a synthetic
    //  event.
    //  Therefore, we check here to make sure that the singleton name matches
    //  the real event name before calling on*
    if (singletonName === TP.eventGetType(normalizedEvent)) {

        if (TP.isElement(targetElem =
                            TP.eventGetResolvedTarget(normalizedEvent))) {
            fname = 'on' + TP.eventGetType(normalizedEvent);

            elemType = TP.wrap(targetElem).getType();

            //  Message the type for the element that is 'responsible' for
            //  this event. It's native control sent this event and we need
            //  to let the type know about it.
            if (TP.canInvoke(elemType, fname)) {
                elemType[fname](targetElem, normalizedEvent);
            }

            //  If the native event was prevented, then we should just bail out
            //  here.
            //  NB: 'defaultPrevented' is a DOM Level 3 property, which seems to
            //  be well supported on TIBET's target browser environments.
            if (normalizedEvent.defaultPrevented === true) {
                return;
            }
        }
    }

    //  when we're provided with a signal we don't need to build one.
    signal = aSignal;
    if (TP.notValid(signal)) {
        //  build up a true signal from our template instance
        if (TP.notValid(signal = this.get(singletonName))) {
            TP.ifWarn() ?
                TP.warn('Event singleton not found for: ' + singletonName) : 0;
            return;
        }

        //  Make sure to recycle the signal instance to clear any previous
        //  state.
        signal.recycle();

        //  let the signal type manage updates on signal naming etc through
        //  the setEvent functions they can optionally implement.
        signal.setEvent(normalizedEvent);

        //  when we reuse singleton we need to initialize origin to the resolved
        //  target
        signal.set('origin', signal.getResolvedTarget());
    }

    //  capture the information we'll need to see about redirections
    redirector = this.REDIRECTOR;

    dict = this.get('observers');

    signames = signal.getSignalNames();

    matchedShortcutSegment = false;
    shouldClearTimer = false;

    //  Detect whether the most specific key signal name was an 'Up'. We use
    //  this flag down below to make sure we're only looking at 'Up'-type
    //  signals. Note that the less specific signal names in this list (as we
    //  work our way up the signal type hierarchy) very well might not have 'Up'
    //  as part of their name, so we set the flag based on the first, most
    //  specific, one.
    wasAnUp = /Up$/.test(signames.first());

    len = signames.getSize();
    for (i = 0; i < len; i++) {

        signame = signames.at(i);

        //  Set the signal name to the currently processing signal name since
        //  key signals have a variety of signal names (virtual, Unicode, type
        //  names).
        signal.setSignalName(signame);

        if (TP.sys.shouldLogKeys() && /DOMKey/.test(signame)) {

            logInfo = TP.hc(
                'target', TP.isValid(normalizedEvent.$$target) ?
                            TP.id(normalizedEvent.$$target) :
                            TP.id(normalizedEvent.target),
                'relatedTarget',
                            TP.isValid(normalizedEvent.$$relatedTarget) ?
                            TP.id(normalizedEvent.$$relatedTarget) :
                            TP.id(normalizedEvent.relatedTarget),
                'resolvedTarget',
                            TP.isValid(normalizedEvent.$$_resolvedTarget) ?
                            TP.id(normalizedEvent.$$_resolvedTarget) :
                            TP.id(normalizedEvent.resolvedTarget),
                'type', TP.isValid(normalizedEvent.$$type) ?
                            normalizedEvent.$$type :
                            normalizedEvent.type,
                'timestamp', TP.isValid(normalizedEvent.$$timestamp) ?
                            normalizedEvent.$$timestamp :
                            normalizedEvent.timestamp,
                'view', TP.isValid(normalizedEvent.$$view) ?
                            normalizedEvent.$$view :
                            normalizedEvent.view,

                'keyCode', TP.isValid(normalizedEvent.keyCode) ?
                                        normalizedEvent.keyCode : '',
                //  NB: We report $$keyCode separately here - it's normalized by
                //  TIBET
                '$$keyCode', TP.isValid(normalizedEvent.$$keyCode) ?
                                        normalizedEvent.$$keyCode : '',
                'charCode', TP.isValid(normalizedEvent.charCode) ?
                                        normalizedEvent.charCode : '',
                'unicode', TP.isValid(normalizedEvent.$unicodeCharCode) ?
                                        normalizedEvent.$unicodeCharCode : '',
                'which', TP.isValid(normalizedEvent.which) ?
                                        normalizedEvent.which : '',

                'shift', normalizedEvent.shiftKey,
                'alt', normalizedEvent.altKey,
                'ctrl', normalizedEvent.ctrlKey,
                'meta', normalizedEvent.metaKey,

                'low_level_signame', singletonName,
                'high_level_signame', signame,
                'specific_signame', this.getDOMSignalName(normalizedEvent),

                'keyname', this.getVirtualKeyName(normalizedEvent),
                'special', TP.isValid(normalizedEvent.$special) ?
                            normalizedEvent.$special : false
                );

            TP.sys.logKey(logInfo, null);
        }

        //  Look for keyboard shortcut. As we see each key signal we look in
        //  the current shortcut hash for that signal. If we find one we check
        //  for a non-hash value (indicating we're complete and the shortcut
        //  should fire) or another hash (indicating more keys to follow). A
        //  value of undefined means this isn't a keyboard shortcut sequence.
        if (TP.isValid(shortcutData = this.get('shortcutIndex').at(signame))) {
            /*
                shortcuts = {
                    a:
                    {
                        h = [...],
                        s =
                        {
                            b:
                            {
                                h = [...],
                                s =
                                {
                                    c:
                                    {
                                        h = [...],
                                        n = 'a__b__c'
                                    }
                                }
                                n = 'a__b'
                            }
                        }
                        n = 'a'
                    }
                }
            */

            //  Each shortcut ends in a hash with two optional keys, an array
            //  of handlers and a hash of child shortcuts. If we're at that end
            //  hash, that means we've 'satisfied' a sequence and it's time to
            //  fire it.
            if (TP.notEmpty(handlers = shortcutData.at('handlers'))) {

                shortcutName = shortcutData.at('name');
                handlersLen = handlers.getSize();

                if (handlersLen > 0) {

                    //  See if we can compute a type from the shortcut name. If
                    //  not, we'll use our signal type.
                    shortcutSignalName = 'TP.sig.' +
                                            TP.contractSignalName(shortcutName);

                    shortcutSignalType =
                        TP.sys.getTypeByName(shortcutSignalName);

                    if (!TP.isType(shortcutSignalType)) {
                        shortcutSignalType = signal.getType();
                    }

                    //  See if the signal type itself has a completion timeout.
                    //  If it does and the current time minus that timeout is
                    //  greater than or equal to when the first shortcut key was
                    //  pressed, then we take no action and set the flag to
                    //  clear the timer.
                    completionTimeout = shortcutSignalType.COMPLETION_TIMEOUT;
                    if (TP.isNumber(completionTimeout) &&
                        Date.now() - completionTimeout >=
                            TP.core.Keyboard.$get('shortcutsStartTime')) {
                        //  empty
                    } else {

                        shortcutSig = shortcutSignalType.construct(
                                                        signal.getPayload());
                        shortcutSig.setSignalName(shortcutName);
                        shortcutSig.setOrigin(signal.getOrigin());

                        for (j = 0; j < handlersLen; j++) {
                            if (shortcutSig.shouldStop()) {
                                break;
                            }

                            handler = handlers.at(j);

                            try {
                                TP.handle(handler, shortcutSig);
                            } catch (e) {
                                TP.raise(this, 'TP.sig.HandlerException',
                                            TP.ec(e));
                            }
                        }
                    }
                }

                shouldClearTimer = true;

                //  Reset to the top-most hash since we just fired a sequence
                this.set('shortcutIndex', this.get('shortcuts'));
            } else if (TP.notEmpty(shortcuts = shortcutData.at('shortcuts'))) {

                matchedShortcutSegment = true;

                /* eslint-disable no-loop-func */
                TP.core.Keyboard.$set('shortcutsTimer',
                    setTimeout(
                        function() {

                            //  clear so press/up don't get confused and try to
                            //  process their timer-specific logic
                            TP.core.Keyboard.$set('shortcutsTimer', null);
                            TP.core.Keyboard.$set('shortcutsStartTime', null);

                            //  Reset to the top-most hash because we couldn't
                            //  complete a shortcut in the allotted amount of
                            //  time.
                            this.set('shortcutIndex', this.get('shortcuts'));
                        }.bind(this),
                            TP.sys.cfg('keyboard.shortcut_cancel_delay')));
                /* eslint-enable no-loop-func */

                TP.core.Keyboard.$set('shortcutsStartTime', Date.now());

                //  If we're not at the end of the sequence migrate our hash
                //  reference "down" to the next level and mark the fact that we
                //  found a shortcut segment for this signal name.
                this.set('shortcutIndex', shortcuts);
            } else {
                shouldClearTimer = true;

                //  Reset to the top-most hash if we're at the end of a shortcut
                //  sequence (or didn't find one at all).
                this.set('shortcutIndex', this.get('shortcuts'));
            }
        } else if (i === len - 1 &&
                    wasAnUp &&
                    this.get('shortcuts') !== this.get('shortcutIndex') &&
                    !matchedShortcutSegment) {

            //  if this is the last signal name we're processing

            //  AND what we've been processing is an 'Up' signal of some sort.

            //  AND we didn't find shortcut data (but we were in the middle of
            //  trying to, which means the current shortcut index is different
            //  that the overall shortcuts hash)

            //  AND none of the other signal names found a shortcut segment THEN

            //  we reset to the 'top-level' hash.

            //  Note that we only reset to the top for Up events. Down and Press
            //  are ignored which avoids problems with modifier keys and
            //  intermediate events.

            //  if it's an up and it's a modifier-only, then don't reset
            if (/^(Shift|Alt|Ctrl)_Up/.test(normalizedEvent.$computedName)) {
                //  Reset to the top-most hash if we're at the end of a shortcut
                continue;
            }

            shouldClearTimer = true;

            this.set('shortcutIndex', this.get('shortcuts'));
        }

        if (shouldClearTimer) {
            //  We found handlers at the current shortcut level - cancel the
            //  'reset shortcuts timer'
            if (TP.isNumber(timer = TP.core.Keyboard.$get('shortcutsTimer'))) {
                clearTimeout(timer);
                TP.core.Keyboard.$set('shortcutsTimer', null);
                TP.core.Keyboard.$set('shortcutsStartTime', null);
            }
        }

        //  Process the handlers registered under the signal name.
        if (TP.notEmpty(handlers = dict.at(signame))) {
            handlersLen = handlers.getSize();
            for (j = 0; j < handlersLen; j++) {
                if (signal.shouldStop()) {
                    break;
                }

                handler = handlers.at(j);

                //  when we're using the redirector as the handler we need to
                //  push the original origin back into place, otherwise we set
                //  it to the receiver (since observe is for the device).
                if (handler !== redirector) {
                    signal.set('origin', this);
                }

                try {
                    TP.handle(handler, signal);
                } catch (e) {
                    TP.raise(this, 'TP.sig.HandlerException',
                                TP.ec(e));
                }
            }
        }
    }

    return signal;
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('removeShortcutObserver',
function(aSignal, aHandler) {

    /**
     * @method removeShortcutObserver
     * @summary Removes a local signal observation for a "signal path", which
     *     is effectively a "gesture". Keyboard shortcuts are the primary
     *     example of signal paths.
     * @param {Object|Object[]} aSignal One or more signals to observe from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn off.
     * @returns {Number} The number of handlers that were removed.
     */

    var sd,
        handlers;

    sd = this.getShortcutData(aSignal);
    if (TP.notValid(sd) || TP.notValid(handlers = sd.at('handlers'))) {
        return 0;
    }

    return handlers.remove(aHandler, TP.IDENTITY);
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('setCurrentKeyboard',
function(aKeyboard) {

    /**
     * @method setCurrentKeyboard
     * @summary Defines the currently active keyboard instance used to perform
     *     all key-event related lookups and processing.
     * @param {TP.core.Keyboard} aKeyboard The keyboard instance to use for all
     *     key-event related processing.
     * @returns {TP.core.Keyboard} The current keyboard instance.
     */

    TP.core.Keyboard.$set('currentKeyboard', aKeyboard);

    //  force the new keyboard's map to become the one we cache etc.
    aKeyboard.loadKeymap();

    return TP.core.Keyboard.$get('currentKeyboard');
});

//  ------------------------------------------------------------------------
//  EVENT HANDLING
//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('$$handleKeyEvent',
function(nativeEvent) {

    /**
     * @method $$handleKeyEvent
     * @summary Responds to notification of a native keyboard event. This is
     *     the primary entry point for all keyboard event handling.
     * @param {Event} nativeEvent The native event.
     * @returns {TP.meta.core.Keyboard} The receiver.
     */

    var ev,
        lastEventName,
        timer;

    if (!TP.sys.hasInitialized()) {
        return this;
    }

    //  Don't come through this handler twice for the same Event
    if (nativeEvent.$captured) {
        return this;
    }
    nativeEvent.$captured = true;

    //  normalize the event
    ev = TP.event(nativeEvent);

    //  If TIBET shouldn't handle the event, then we return here. Note that this
    //  will still allow other third-party libraries to trap and process events.
    if (TP.isFalse(TP.targetShouldHandleEvent(ev))) {
        return this;
    }

    switch (TP.eventGetType(ev)) {
        case 'keydown':

            //  Clear all history to avoid confusion in state.
            TP.core.Keyboard.$set('lastPress', null);
            TP.core.Keyboard.$set('lastUp', null);

            //  Capture the event into a variable that will keep a reference
            //  to the last time this event happened. This is used in a
            //  variety of ways in the $$handle* calls, and both the event
            //  and the slot may be altered during the course of that call.
            lastEventName = 'lastDown';
            TP.core.Keyboard.$set(lastEventName, ev);

            if (TP.isNumber(timer = TP.core.Keyboard.$get('downTimer'))) {
                clearTimeout(timer);
                TP.core.Keyboard.$set('downTimer', null);
            }

            TP.core.Keyboard.getCurrentKeyboard().$$handleKeyDown(ev);

            break;

        case 'keypress':

            //  Capture the event into a variable that will keep a reference
            //  to the last time this event happened. This is used in a
            //  variety of ways in the $$handle* calls, and both the event
            //  and the slot may be altered during the course of that call.
            lastEventName = 'lastPress';
            TP.core.Keyboard.$set(lastEventName, ev);

            TP.core.Keyboard.getCurrentKeyboard().$$handleKeyPress(ev);

            break;

        case 'keyup':

            //  Capture the event into a variable that will keep a reference
            //  to the last time this event happened. This is used in a
            //  variety of ways in the $$handle* calls, and both the event
            //  and the slot may be altered during the course of that call.
            lastEventName = 'lastUp';
            TP.core.Keyboard.$set(lastEventName, ev);

            TP.core.Keyboard.getCurrentKeyboard().$$handleKeyUp(ev);

            break;

        default:
            return this;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('$$handleKeyDown',
function(normalizedEvent) {

    /**
     * @method $$handleKeyDown
     * @summary Responds to notifications that a keydown event has occurred.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.Keyboard} The receiver.
     */

    this.$$updateModifierStates(normalizedEvent);

    this[TP.composeHandlerName('KeyDown')](normalizedEvent);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineHandler('KeyDown',
function(normalizedEvent) {

    /**
     * @method handleKeyDown
     * @summary A method which subtypes override to perform key handling
     *     specific to keydown events.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.Keyboard} The receiver.
     */

    TP.override();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('$$handleKeyPress',
function(normalizedEvent) {

    /**
     * @method $$handleKeyPress
     * @summary Responds to notifications that a keypress event has occurred.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.Keyboard} The receiver.
     */

    this[TP.composeHandlerName('KeyPress')](normalizedEvent);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineHandler('KeyPress',
function(normalizedEvent) {

    /**
     * @method handleKeyPress
     * @summary A method which subtypes override to perform key handling
     *     specific to keypress events.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.Keyboard} The receiver.
     */

    TP.override();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('$$handleKeyUp',
function(normalizedEvent) {

    /**
     * @method $$handleKeyUp
     * @summary Responds to notifications that a keyup event has occurred.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.Keyboard} The receiver.
     */

    this.$$updateModifierStates(normalizedEvent);

    this[TP.composeHandlerName('KeyUp')](normalizedEvent);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineHandler('KeyUp',
function(normalizedEvent) {

    /**
     * @method handleKeyUp
     * @summary A method which subtypes override to perform key handling
     *     specific to keyup events.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.Keyboard} The receiver.
     */

    TP.override();

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('$$updateModifierStates',
function(normalizedEvent) {

    /**
     * @method $$updateModifierStates
     * @summary Updates the modifier status based on the supplied Event.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.Keyboard} The receiver.
     */

    var key,
        dirty;

    dirty = false;

    key = TP.eventGetAltKey(normalizedEvent);
    if (this.isAltDown() !== key) {
        dirty = true;
        this.isAltDown(key);
    }

    key = TP.eventGetShiftKey(normalizedEvent);
    if (this.isShiftDown() !== key) {
        dirty = true;
        this.isShiftDown(key);
    }

    key = TP.eventGetCtrlKey(normalizedEvent);
    if (this.isCtrlDown() !== key) {
        dirty = true;
        this.isCtrlDown(key);
    }

    key = TP.eventGetMetaKey(normalizedEvent);
    if (this.isMetaDown() !== key) {
        dirty = true;
        this.isMetaDown(key);
    }

    if (dirty) {
        this.invokeObservers('modifierkeychange', normalizedEvent);
    }

    return this;
});

//  ------------------------------------------------------------------------
//  KEY/STATE QUERIES
//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('computeFullSignalName',
function(normalizedEvent, keyName, shift) {

    /**
     * @method computeFullSignalName
     * @summary Returns the 'full' signal name for a particular event. This
     *     method takes the key name and adds a prefix of 'Shift_', 'Alt_',
     *     'Ctrl_' or 'Meta_' and a suffix of '_Down', '_Press', '_Up', all
     *     dependent on the event's modifier states and 'action' (i.e. down,
     *     press or up).
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @param {String} keyName The key name.
     * @param {Boolean} shift Whether or not the key was shifted. Note that we
     *     allow the caller to supply this rather than calculating it from the
     *     supplied event so that the caller can 'spoof' it.
     * @returns {String} The 'full' key event DOM signal name.
     */

    var sigkey,
        signame;

    //  Make sure that any key name that is *only* a lowercase alpha character
    //  ([a-z]) is uppercased. So that, instead of returning 'DOM_Meta_z_Down',
    //  this method will return 'DOM_Meta_Z_Down' (which is how TIBET normalizes
    //  this situation - if the caller wants uppercase, they should specify
    //  'Shift_' somewhere in the signal name).
    sigkey = keyName;
    if (/^[a-z]{1}$/.test(sigkey)) {
        sigkey = keyName.toUpperCase();
    }

    //  Because the modifier name for 'Control' is 'Ctrl', users of TIBET will
    //  expect that, when trying to observe *the Control key itself*, that they
    //  can use the word 'Ctrl'. In other words, because they can subscribe to
    //  'DOM_Ctrl_K_Press' that they will also be able to subscribe to
    //  'DOM_Ctrl_Press'. The W3C name for Control is 'Control', but that's not
    //  what will be expected.
    if (keyName === 'Control') {
        sigkey = 'Ctrl';
    }

    //  All key events get a suffix suitable to that event
    switch (TP.eventGetType(normalizedEvent)) {
        case 'keyup':

            signame = sigkey + '_Up';
            break;

        case 'keydown':

            signame = sigkey + '_Down';
            break;

        case 'keypress':

            signame = sigkey + '_Press';
            break;

        default:

            signame = sigkey;
            break;
    }

    //  Modifier keys are prefixes which effectively start with optional
    //  Ctrl, Alt, or Meta followed by optional Shift state.
    if (shift && sigkey !== 'Shift') {
        signame = 'Shift_' + signame;
    }

    if (TP.eventGetAltKey(normalizedEvent) && sigkey !== 'Alt') {
        signame = 'Alt_' + signame;
    }

    if (TP.eventGetCtrlKey(normalizedEvent) && sigkey !== 'Ctrl') {
        signame = 'Ctrl_' + signame;
    }

    if (TP.eventGetMetaKey(normalizedEvent) && sigkey !== 'Meta') {
        signame = 'Meta_' + signame;
    }

    return signame;
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('getDOMSignalName',
function(normalizedEvent) {

    /**
     * @method getDOMSignalName
     * @summary Returns the DOM signal name for a particular event.
     * @description The returned signal name is based largely on the current
     *     keyboard's mapping for the particular event information including
     *     charCode, keyCode, and modifier key states. For example, a keyup
     *     event with the shift key active and a keycode of 13 on a US ASCII 101
     *     keyboard would return a signal name of DOM_Shift_Enter_Up.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {String} The key event DOM signal name.
     */

    return 'DOM_' + this.$getVirtualKeySignalName(normalizedEvent);
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('getPrintableGlyph',
function(anEvent) {

    /**
     * @method getPrintableGlyph
     * @summary Returns the printable glyph (if available) for the keycode in
     *     the event provided.
     * @param {Event} anEvent A native key event.
     * @returns {String|null} The printable glyph or null if the keycode
     *     doesn't match a printable glyph.
     */

    var entry,
        glyph;

    //  Grab the XML element from the receiver's XML key map.
    entry = this.getVirtualKeyEntry(anEvent);

    if (!TP.isElement(entry)) {
        return null;
    }

    glyph = TP.elementGetAttribute(entry, 'glyph', true);

    if (TP.isEmpty(glyph)) {
        return null;
    }

    return glyph;
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('getVirtualKeyEntry',
function(anEvent) {

    /**
     * @method getVirtualKeyEntry
     * @summary Returns the current keyboard's virtual key entry in its XML
     *     lookup table for the keycode in the event provided.
     * @param {Event|Signal} anEvent The event or signal containing the event.
     * @returns {Element|undefined} The virtual key entry, or undefined when not
     *     found.
     */

    var ev,
        type,

        xml,

        key,
        shift,

        path,
        elems,
        elem;

    if (TP.notValid(anEvent)) {
        this.raise('TP.sig.InvalidEvent');
        return;
    }

    ev = TP.isEvent(anEvent) ? anEvent : anEvent.get('event');
    type = TP.eventGetType(ev);

    if (!TP.regex.KEY_EVENT.test(type)) {
        return;
    }

    if (TP.notValid(xml = TP.core.Keyboard.get('mapxml'))) {
        return;
    }

    key = TP.eventGetKeyCode(ev);

    //  bit of a trick here to avoid a Shift_Shift in particular
    if (key !== TP.SHIFT_KEY) {
        shift = TP.eventGetShiftKey(ev);
    }

    //  if the event was 'shift'ed, then we have to query twice, once for the
    //  'shift'ed code and, if an entry wasn't found, query again for the
    //  un'shift'ed code.
    if (shift) {
        path = TP.join(
                '//*[@keycode="_', key, '_shifted"]',
                '[(@platform="', TP.$platform,
                    '" and @browser="', TP.sys.getBrowser(), '")',
                ' or (@browser="', TP.sys.getBrowser(), '")',
                ' or (@platform="', TP.$platform, '")',
                ' or .]');

        elems = TP.nodeEvaluateXPath(xml, path, TP.NODESET);
    }

    //  If either the Shift key wasn't down or it was but we didn't get a valid
    //  set of entries, then query.
    if (TP.isEmpty(elems)) {

        path = TP.join(
                '//*[@keycode="_', key, '"]',
                '[(@platform="', TP.$platform,
                    '" and @browser="', TP.sys.getBrowser(), '")',
                ' or (@browser="', TP.sys.getBrowser(), '")',
                ' or (@platform="', TP.$platform, '")',
                ' or .]');

        elems = TP.nodeEvaluateXPath(xml, path, TP.NODESET);
    }

    //  If more than one element was returned, that means that we must have
    //  entries for specific browser, platform or both. Sort them so that
    //  entries with platform, then browser, then browser and platform (least to
    //  most specific) are towards the end of the list and use the last one.
    if (elems.getSize() > 1) {
        elems.sort(TP.sort.KEYMAP_ELEMENT);
        elem = elems.last();
    } else {
        //  There was only one.
        elem = elems.first();
    }

    return elem;
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('getVirtualKeyName',
function(anEvent) {

    /**
     * @method getVirtualKeyName
     * @summary Returns the current keyboard's virtual key name for the keycode
     *     in the event provided.
     * @param {Event|Signal} anEvent The event or signal containing the event.
     * @returns {String|undefined} The virtual key name, or undefined when not
     *     found.
     */

    var ev,
        type,

        xml,

        key,
        shift,

        path,
        elems,
        elem,

        vk;

    if (TP.notValid(anEvent)) {
        this.raise('TP.sig.InvalidEvent');
        return;
    }

    ev = TP.isEvent(anEvent) ? anEvent : anEvent.get('event');
    type = TP.eventGetType(ev);

    if (!TP.regex.KEY_EVENT.test(type)) {
        return;
    }

    if (TP.notValid(xml = TP.core.Keyboard.get('mapxml'))) {
        return;
    }

    key = TP.eventGetKeyCode(ev);

    //  bit of a trick here to avoid a Shift_Shift in particular
    if (key !== TP.SHIFT_KEY) {
        shift = TP.eventGetShiftKey(ev);
    }

    //  if the event was 'shift'ed, then we have to query twice, once for the
    //  'shift'ed code and, if an entry wasn't found, query again for the
    //  un'shift'ed code.
    if (shift) {
        path = TP.join(
                '//*[@keycode="_', key, '_shifted"]',
                '[(@platform="', TP.$platform,
                    '" and @browser="', TP.sys.getBrowser(), '")',
                ' or (@browser="', TP.sys.getBrowser(), '")',
                ' or (@platform="', TP.$platform, '")',
                ' or .]');

        elems = TP.nodeEvaluateXPath(xml, path, TP.NODESET);
    }

    //  If either the Shift key wasn't down or it was but we didn't get a valid
    //  set of entries, then query.
    if (TP.isEmpty(elems)) {

        path = TP.join(
                '//*[@keycode="_', key, '"]',
                '[(@platform="', TP.$platform,
                    '" and @browser="', TP.sys.getBrowser(), '")',
                ' or (@browser="', TP.sys.getBrowser(), '")',
                ' or (@platform="', TP.$platform, '")',
                ' or .]');

        elems = TP.nodeEvaluateXPath(xml, path, TP.NODESET);
    }

    //  If there was still no entry found, then see if we can derive it from the
    //  character code produced by the String type.
    if (TP.isEmpty(elems)) {
        if (TP.core.Keyboard.isPrintable(anEvent)) {
            vk = String.fromCharCode(key);
        }
    } else {

        //  If more than one element was returned, that means that we must have
        //  entries for specific browser, platform or both. Sort them so that
        //  entries with platform, then browser, then browser and platform
        //  (least to most specific) are towards the end of the list and use the
        //  last one.
        if (elems.getSize() > 1) {
            elems.sort(TP.sort.KEYMAP_ELEMENT);
            elem = elems.last();
        } else {
            //  There was only one.
            elem = elems.first();
        }

        //  Now get the virtual key value from either the key or glyph
        //  attribute.
        vk = TP.ifEmpty(
                    TP.elementGetAttribute(elem, 'key'),
                    TP.elementGetAttribute(elem, 'glyph'));
    }

    //  No char was there? Guess we'll use the key code itself in string form
    if (TP.notValid(vk)) {
        vk = 'KeyCode' + (TP.isString(key) ? key : '');
    }

    return vk;
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('getKeyCodeForKeyNamed',
function(keyNameOrGlyph) {

    /**
     * @method getKeyCodeForKeyNamed
     * @summary Returns the current keyboard's virtual key code for the name
     *     provided.
     * @param {String} keyNameOrGlyph The name or glyph of the key to look up.
     *     If a key name, this would be something like 'Backspace'. If a key
     *     glyph, it would be something like 'D'.
     * @exception TP.sig.InvalidParameter
     * @returns {Number} The virtual key code, or -1 when not found.
     */

    var xml,

        path,
        elems,

        keyCode,

        elem;

    if (!TP.isString(keyNameOrGlyph)) {
        this.raise('TP.sig.InvalidParameter');
        return TP.NOT_FOUND;
    }

    if (TP.notValid(xml = TP.core.Keyboard.get('mapxml'))) {
        return TP.NOT_FOUND;
    }

    path = TP.join(
            '//*[@key="', keyNameOrGlyph, '"]',
            '[(@platform="', TP.$platform,
                '" and @browser="', TP.sys.getBrowser(), '")',
            ' or (@browser="', TP.sys.getBrowser(), '")',
            ' or (@platform="', TP.$platform, '")',
            ' or .]');

    if (TP.isEmpty(elems = TP.nodeEvaluateXPath(xml, path, TP.NODESET))) {
        path = TP.join(
                '//*[@glyph="', keyNameOrGlyph, '"]',
                '[(@platform="', TP.$platform,
                    '" and @browser="', TP.sys.getBrowser(), '")',
                ' or (@browser="', TP.sys.getBrowser(), '")',
                ' or (@platform="', TP.$platform, '")',
                ' or .]');

        //  Couldn't find an entry using either 'key' or 'glyph'
        if (TP.isEmpty(elems = TP.nodeEvaluateXPath(xml, path, TP.NODESET))) {
            return TP.NOT_FOUND;
        }
    }

    //  If more than one element was returned, that means that we must have
    //  entries for specific browser, platform or both. Sort them so that
    //  entries with platform, then browser, then browser and platform
    //  (least to most specific) are towards the end of the list and use the
    //  last one.
    if (elems.getSize() > 1) {
        elems.sort(TP.sort.KEYMAP_ELEMENT);
        elem = elems.last();
    } else {
        //  There was only one.
        elem = elems.first();
    }

    if (TP.notEmpty(keyCode = TP.elementGetAttribute(elem, 'keycode'))) {
        //  Slice off the '_' and make it a Number
        return keyCode.slice(1).asNumber();
    }

    return TP.NOT_FOUND;
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('$getVirtualKeySignalName',
function(normalizedEvent) {

    /**
     * @method $getVirtualKeySignalName
     * @summary Returns the 'raw key' signal name for a particular event. This
     *     will then be prepended by 'DOM_' by the getDOMSignalName() method to
     *     generate the proper 'full' signal name.
     * @description The returned signal name is based largely on the current
     *     keyboard's mapping for the particular event information including
     *     charCode, keyCode, and modifier key states. For example, a keyup
     *     event with the shift key active and a keycode of 13 on a US ASCII 101
     *     keyboard would return a signal name of Shift_Enter_Up.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {String} The key event DOM signal name.
     */

    var signame,

        shift,
        key,

        xml,

        vk,

        path,
        elems,
        elem;

    //  If we've already cached the name, then return it.
    if (TP.isString(signame = normalizedEvent.$computedName)) {
        return signame;
    }

    key = TP.eventGetKeyCode(normalizedEvent);

    if (key) {    //  not null and not 0
        if (TP.notValid(xml = TP.core.Keyboard.get('mapxml'))) {
            //  if no keymap is found we've got a real problem. our only
            //  potential option is to hope the key is a character code
            //  don't get string versions of control characters
            if (TP.core.Keyboard.isPrintable(normalizedEvent)) {
                vk = String.fromCharCode(key);
                normalizedEvent.$unicodeCharCode =
                    vk.asUnicodeLiteral().replace('\\u', 'U');
            }
        } else {
            //  bit of a trick here to avoid a Shift_Shift in particular
            if (key !== TP.SHIFT_KEY) {
                shift = TP.eventGetShiftKey(normalizedEvent);
            }

            //  if the event was 'shift'ed, then we have to query twice, once
            //  for the 'shift'ed code and, if an entry wasn't found, query
            //  again for the un'shift'ed code.
            if (shift) {
                path = TP.join(
                        '//*[@keycode="_', key, '_shifted"]',
                        '[(@platform="', TP.$platform,
                            '" and @browser="', TP.sys.getBrowser(), '")',
                        ' or (@browser="', TP.sys.getBrowser(), '")',
                        ' or (@platform="', TP.$platform, '")',
                        ' or .]');

                elems = TP.nodeEvaluateXPath(xml, path, TP.NODESET);
            }

            //  If either the Shift key wasn't down or it was but we didn't get
            //  a valid set of entries, then query.
            if (TP.isEmpty(elems)) {

                path = TP.join(
                        '//*[@keycode="_', key, '"]',
                        '[(@platform="', TP.$platform,
                            '" and @browser="', TP.sys.getBrowser(), '")',
                        ' or (@browser="', TP.sys.getBrowser(), '")',
                        ' or (@platform="', TP.$platform, '")',
                        ' or .]');

                elems = TP.nodeEvaluateXPath(xml, path, TP.NODESET);
            }

            //  If there was still no entry found, then see if we can derive it
            //  from the character code produced by the String type.
            if (TP.isEmpty(elems)) {
                //  don't get string versions of control characters
                if (TP.core.Keyboard.isPrintable(normalizedEvent)) {
                    vk = String.fromCharCode(key);
                    normalizedEvent.$unicodeCharCode =
                        vk.asUnicodeLiteral().replace('\\u', 'U');
                }
            } else {

                //  If more than one element was returned, that means that we
                //  must have entries for specific browser, platform or both.
                //  Sort them so that entries with platform, then browser, then
                //  browser and platform (least to most specific) are towards
                //  the end of the list and use the last one.
                if (elems.getSize() > 1) {
                    elems.sort(TP.sort.KEYMAP_ELEMENT);
                    elem = elems.last();
                } else {
                    //  There was only one.
                    elem = elems.first();
                }

                //  When we find a shifted value we make sure to not put
                //  'Shift_' onto the signal name... the vk name is all we
                //  want to see. In other words, we'll never generate
                //  'Shift_Asterisk'...
                if (shift && TP.elementGetAttribute(
                                    elem, 'keycode').endsWith('_shifted')) {
                    shift = false;
                }

                //  Otherwise, get it from either the key or glyph attribute.
                vk = TP.ifEmpty(
                        TP.elementGetAttribute(elem, 'key'),
                        TP.elementGetAttribute(elem, 'glyph'));

                normalizedEvent.$unicodeCharCode =
                        TP.elementGetAttribute(elem, 'char');
            }
        }
    }

    //  No char was there? Guess we'll use the key code itself in string form
    if (TP.notValid(vk)) {
        vk = 'KeyCode' + (TP.isString(key) ? key : 'UNKNOWN');
    }

    signame = this.computeFullSignalName(normalizedEvent, vk, shift);

    normalizedEvent.$computedName = signame;

    return signame;
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('isAltDown',
function(aFlag) {

    /**
     * @method isAltDown
     * @summary Returns true if the Alt key is currently pressed.
     * @param {Boolean} aFlag Set the 'isDown' state of the key to true or
     *     false.
     * @returns {Boolean} True if the Alt key is down.
     */

    if (TP.isBoolean(aFlag)) {
        this.$set('altDown', aFlag);
    }

    return this.$get('altDown');
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('isCtrlDown',
function(aFlag) {

    /**
     * @method isCtrlDown
     * @summary Returns true if the Ctrl key is currently pressed.
     * @param {Boolean} aFlag Set the 'isDown' state of the key to true or
     *     false.
     * @returns {Boolean} True if the Ctrl key is down.
     */

    if (TP.isBoolean(aFlag)) {
        this.$set('ctrlDown', aFlag);
    }

    return this.$get('ctrlDown');
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('isMetaDown',
function(aFlag) {

    /**
     * @method isMetaDown
     * @summary Returns true if the Meta key is currently pressed.
     * @param {Boolean} [aFlag] An optional flag to set the value.
     * @returns {Boolean} True if the Meta key is down.
     */

    if (TP.isBoolean(aFlag)) {
        this.$set('metaDown', aFlag);
    }

    return this.$get('metaDown');
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('isPrintable',
function(anEvent) {

    /**
     * @method isPrintable
     * @summary Returns true if the event represents a character that should be
     *     printable given the current keyboard mapping.
     * @param {Event} anEvent A native key event.
     * @returns {Boolean} True if the event's keycode/charcode should produce a
     *     printable character given the current keyboard.
     */

    return this.getCurrentKeyboard().isPrintable(anEvent);
});

//  ------------------------------------------------------------------------

TP.core.Keyboard.Type.defineMethod('isShiftDown',
function(aFlag) {

    /**
     * @method isShiftDown
     * @summary Returns true if the Shift key is currently pressed.
     * @param {Boolean} aFlag Set the 'isDown' state of the key to true or
     *     false.
     * @returns {Boolean} True if the Shift key is down.
     */

    if (TP.isBoolean(aFlag)) {
        this.$set('shiftDown', aFlag);
    }

    return this.$get('shiftDown');
});

//  ========================================================================
//  TP.core.USAscii101Keyboard
//  ========================================================================

TP.core.Keyboard.defineSubtype('USAscii101Keyboard');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.USAscii101Keyboard.Type.defineHandler('KeyDown',
function(normalizedEvent) {

    /**
     * @method handleKeyDown
     * @summary Handles key down events for the TP.core.USAscii101Keyboard
     *     type.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.USAscii101Keyboard} The receiver.
     */

    var key;
        // lastDown;

    key = TP.eventGetKeyCode(normalizedEvent);

    if (TP.sys.isUA('GECKO') && TP.sys.isMac()) {
        //  hozed on some keys, they report 0 as keyCode. have to wait for
        //  press event...thankfully moz will produce one (for now)
        if (key === 0) {
            normalizedEvent.$notSignaled = true;

            return this;
        }
    }

    /*
    //  arrow keys suck pretty much across the board. can't tell if it's an
    //  arrow or a %, &, (, or ' until the press event...but only Moz will
    //  provide a press event if it's actually an arrow. Also, home and $
    //  are confused. Cool huh?
    if (key >= 36 && key <= 40) {
        if (TP.sys.isUA('GECKO')) {
            //  wait for press to decide
            normalizedEvent.$notSignaled = true;

            return this;
        } else {
            //  Won't get a press from an arrow on IE or Safari so we have
            //  to hack it a little differently. A non-special key will get
            //  an immediate press and can cancel the following timer,
            //  otherwise the up handler can do it, provided that the down
            //  doesn't signal if the key is simply held down for some time.
            //  The variable here is how long is the delay between down and
            //  press event notification so the timeout coordinates with
            //  press properly.
            lastDown = TP.core.Keyboard.get('lastDown');
            if (!TP.isEvent(lastDown)) {
                return this;
            }

            lastDown.$notSignaled = true;
            lastDown.$special = true;

            TP.core.Keyboard.$set('downTimer',
                setTimeout(
                    function() {

                        //  clear so press/up don't get confused and try to
                        //  process their timer-specific logic
                        TP.core.Keyboard.$set('downTimer', null);

                        //  if the timer doesn't get cancelled by a press or
                        //  an up then we can presume we got a down on a key
                        //  that won't get a press...meaning it must be
                        //  special and hence an arrow key or similarly
                        //  hozed up key event.
                        lastDown.$notSignaled = null;

                        TP.core.Keyboard.invokeObservers('keydown',
                                                            lastDown);
                    }, 10));

            return;
        }
    }
    */

    this.invokeObservers('keydown', normalizedEvent);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.USAscii101Keyboard.Type.defineHandler('KeyPress',
function(normalizedEvent) {

    /**
     * @method handleKeyPress
     * @summary Handles key press events for the TP.core.USAscii101Keyboard
     *     type.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.USAscii101Keyboard} The receiver.
     */

    var lastDown,
        special,
        lastKey,
        key;
        // timer;

    if (TP.sys.isUA('GECKO')) {
        lastDown = TP.core.Keyboard.get('lastDown');

        special = normalizedEvent.which === 0;
        if (special) {
            if (TP.isEvent(lastDown) && lastDown.$notSignaled) {
                lastDown.$special = true;
                lastDown.$notSignaled = null;

                this.invokeObservers('keydown', lastDown);
            }

            //  suppress to match DOM Level 3 standard and IE/Safari
            TP.core.Keyboard.$set('lastPress', null);

            return this;
        }

        //  press keys are often wrong...map to what was seen onkeydown
        //  unless that was 0
        if ((lastKey = TP.eventGetKeyCode(lastDown)) !== 0) {
            if (TP.isNumber(lastKey)) {
                normalizedEvent.$$keyCode = lastKey;
            }
        }

        key = TP.eventGetKeyCode(normalizedEvent);

        if (TP.isEvent(lastDown) && lastDown.$notSignaled) {
            lastDown.$notSignaled = null;
            lastDown.$special = null;
            lastDown.$$keyCode = key;

            this.invokeObservers('keydown', lastDown);
        }
    } else {
        //  if there's a down timer running then the key was in a range
        //  where we needed to wait for a press or up to tell what it was.
        //  clear the timer if we get a press since that means the key
        //  wasn't special on IE or Safari, just a normal key with an ascii
        //  code we can look up.
        /*
        if (TP.isNumber(timer = TP.core.Keyboard.$get('downTimer'))) {
            clearTimeout(timer);
            TP.core.Keyboard.$set('downTimer', null);

            lastDown = TP.core.Keyboard.get('lastDown');
            if (TP.isEvent(lastDown)) {
                lastDown.$notSignaled = null;
                lastDown.$special = null;

                this.invokeObservers('keydown', lastDown);
            }
        } else {
        */
        //  no timer and we got a press, must be a valid key in a range
        //  where the down was already signaled. for consistency we
        //  could potentially bring the down key's data forward and we
        //  actually need to do that since some codes report incorrectly
        //  due to ascii offsets of 32 etc.
        lastDown = TP.core.Keyboard.get('lastDown');
        if (TP.isEvent(lastDown) &&
            (lastKey = TP.eventGetKeyCode(lastDown)) !== 0) {
            normalizedEvent.$$keyCode = lastKey;
        }
        // }
    }

    this.invokeObservers('keypress', normalizedEvent);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.USAscii101Keyboard.Type.defineHandler('KeyUp',
function(normalizedEvent) {

    /**
     * @method handleKeyUp
     * @summary Handles key up events for the TP.core.USAscii101Keyboard type.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.USAscii101Keyboard} The receiver.
     */

    var key,
        lastEvent,
        lastKey;
        // timer;

    if (TP.sys.isUA('GECKO')) {
        lastEvent = TP.core.Keyboard.get('lastPress') ||
                    TP.core.Keyboard.get('lastDown');

        if (TP.isEvent(lastEvent)) {
            normalizedEvent.$special = lastEvent.$special;
        }

        key = TP.eventGetKeyCode(normalizedEvent);
        if (key === 0) {
            if (TP.isEvent(lastEvent) &&
                (lastKey = TP.eventGetKeyCode(lastEvent)) !== 0) {
                normalizedEvent.$$keyCode = lastKey;
            }
        }
    } else {
        //  if there's a down timer running then the key was in a range
        //  where we needed to wait for a press or up to tell what it was.
        //  if we got an up and the timer's still valid that means there was
        //  no press event, hence the key was special (an arrow key etc)
        /*
        if (TP.isNumber(timer = TP.core.Keyboard.$get('downTimer'))) {
            clearTimeout(timer);
            TP.core.Keyboard.$set('downTimer', null);

            //  unless we map over the value we'll likely report
            //  incorrectly...remember what goes down must come up ;)
            lastEvent = TP.core.Keyboard.get('lastDown');
            if (TP.isEvent(lastEvent)) {
                normalizedEvent.$$keyCode = lastEvent.$$keyCode;
                normalizedEvent.$special = lastEvent.$special;

                this.invokeObservers('keydown', lastEvent);
            }
        } else {
        */
        //  no timer means key wasn't in the special range where we had
        //  to set a timer. should be a simple matter of ensuring we map
        //  over any knowledge that the key was special because we saw a
        //  press event etc.
        lastEvent = TP.core.Keyboard.get('lastPress') ||
                    TP.core.Keyboard.get('lastDown');
        if (TP.isEvent(lastEvent)) {
            normalizedEvent.$special = lastEvent.$special;
        }
        // }
    }

    this.invokeObservers('keyup', normalizedEvent);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.USAscii101Keyboard.Type.defineMethod('isPrintable',
function(anEvent) {

    /**
     * @method isPrintable
     * @summary Returns true if the event represents a character that should be
     *     printable given the current keyboard mapping.
     * @param {Event} anEvent A native key event.
     * @returns {Boolean} True if the event's keycode/charcode should produce a
     *     printable character given the current keyboard.
     */

    var entry;

    //  Grab the XML element from the receiver's XML key map.
    entry = this.getVirtualKeyEntry(anEvent);

    //  If we got a valid entry and that entry has a 'glyph', then it's a
    //  printable character.
    return TP.isElement(entry) && TP.elementHasAttribute(entry, 'glyph', true);
});

//  ========================================================================
//  TP.core.Mouse
//  ========================================================================

TP.core.Device.defineSubtype('Mouse');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.core.Mouse.Type.defineAttribute(
        'hoverFunc',
        function() {

            var lastMove,
                lastOver,

                hoverRepeat,
                targetElem,
                targetRepeat,
                repeatAncestor,

                func;

            //  clean up after ourselves.
            TP.core.Mouse.$set('overTimer', null);
            TP.core.Mouse.$set('hoverTimer', null);
            TP.core.Mouse.$set('hoverRepeatTimer', null);

            //  make sure we've got a last move to work from
            lastMove = TP.core.Mouse.$get('lastMove');
            if (!TP.isEvent(lastMove)) {
                return;
            }

            if (TP.core.Mouse.$$isDragging(lastMove)) {
                TP.eventSetType(lastMove, 'draghover');

                TP.core.Mouse.invokeObservers(
                        'draghover',
                        lastMove);
            } else {
                TP.eventSetType(lastMove, 'mousehover');

                TP.core.Mouse.invokeObservers(
                        'mousehover',
                        lastMove);
            }

            //  we use the 'lastOver' to obtain the repeat value, if it has
            //  one. We don't want to pick up repeat values from every
            //  element we go over, in case we're in drag mode.
            if (!TP.isEvent(lastOver = TP.core.Mouse.$get('lastOver'))) {
                return;
            }

            hoverRepeat = TP.sys.cfg('mouse.hover_repeat');

            //  Get a resolved event target, given the event. This takes
            //  into account disabled elements and will look for a target
            //  element with the appropriate 'enabling attribute', if
            //  possible.
            if (TP.isElement(targetElem =
                            TP.eventGetResolvedTarget(lastOver))) {

                //  If the event target has an 'tibet:hoverrepeat' attribute,
                //  try to convert it to a Number and if that's successful,
                //  set hoverRepeat to it.
                targetRepeat = TP.elementGetAttribute(
                                            targetElem,
                                            'tibet:hoverrepeat',
                                            true);

                //  If we got a hover repeat value, then try to convert it to a
                //  Number and use it.
                if (TP.notEmpty(targetRepeat)) {
                    targetRepeat = targetRepeat.asNumber();

                    if (TP.isNumber(targetRepeat)) {
                        hoverRepeat = targetRepeat;
                    }
                } else {

                    //  Otherwise, search up the ancestor chain looking for an
                    //  element with a hover repeat attribute.
                    repeatAncestor = TP.nodeDetectAncestorMatchingCSS(
                                            targetElem, '*[tibet|hoverrepeat]');

                    //  If we found an ancestor that had a hover repeat
                    //  attribute, then obtain its value, try to convert it to a
                    //  Number and use it.
                    if (TP.isElement(repeatAncestor)) {
                        targetRepeat = TP.elementGetAttribute(
                                                            repeatAncestor,
                                                            'tibet:hoverrepeat',
                                                            true);
                        targetRepeat = targetRepeat.asNumber();

                        if (TP.isNumber(targetRepeat)) {
                            hoverRepeat = targetRepeat;
                        }
                    }
                }
            }

            func =
                function() {

                    var priorMove,
                        doc;
                        // obs;

                    priorMove = TP.core.Mouse.$get('lastMove');

                    //  If there was no 'last move' native event that we can
                    //  leverage, then we can't do much so we exit here and
                    //  don't reschedule the timer.
                    if (!TP.isEvent(priorMove)) {
                        return;
                    }

                    //  If there are no mouse/drag hover subscriptions,
                    //  then there is no point in continuing so we exit here
                    //  and don't reschedule the timer.
                    //  TODO: This doesn't work with using 'on:mousehover' or
                    //  'on:draghover', so we comment it out for now. It's
                    //  doesn't seem to have a huge effect on performance.
                    // obs = TP.core.Mouse.get('observers');
                    // if (!obs.hasKey('TP.sig.DOMMouseHover') &&
                     //   !obs.hasKey('TP.sig.DOMDragHover')) {
                      //  return;
                    // }

                    //  If the document doesn't itself have focus or doesn't
                    //  have an active element, then that probably means
                    //  this window isn't in focus to the user, which means
                    //  hover events don't mean much. So we exit here and
                    //  don't reschedule the timer.
                    doc = TP.eventGetWindow(priorMove).document;
                    if (!doc.hasFocus() || !doc.activeElement) {
                        return;
                    }

                    //  If we're in a dragging state, then send invoke
                    //  observers for 'draghover', otherwise invoke the ones
                    //  for 'mousehover'.
                    if (TP.core.Mouse.$$isDragging(priorMove)) {
                        TP.eventSetType(priorMove, 'draghover');

                        TP.core.Mouse.invokeObservers(
                                'draghover',
                                priorMove);
                    } else {
                        TP.eventSetType(priorMove, 'mousehover');

                        TP.core.Mouse.invokeObservers(
                                'mousehover',
                                priorMove);
                    }

                    //  reschedule the repeat timer
                    TP.core.Mouse.$set(
                        'hoverRepeatTimer',
                        setTimeout(func, hoverRepeat));
                };

            //  set up the hover repeat timer
            TP.core.Mouse.$set(
                'hoverRepeatTimer',
                setTimeout(func, hoverRepeat));
        });

//  overall hash of observations made locally to a specific device
TP.core.Mouse.Type.defineAttribute('observers', TP.hc());

//  map of signals which we've placed redirectors for
TP.core.Mouse.Type.defineAttribute('redirections', TP.hc());

//  timers for click vs. dblclick and hover delay
TP.core.Mouse.Type.defineAttribute('clickTimer');
TP.core.Mouse.Type.defineAttribute('overTimer');
TP.core.Mouse.Type.defineAttribute('hoverTimer');
TP.core.Mouse.Type.defineAttribute('hoverRepeatTimer');

//  whether or not we've sent the 'dragdown' signal
TP.core.Mouse.Type.defineAttribute('$sentDragDown', false);

//  if we're not in a valid drag target
TP.core.Mouse.Type.defineAttribute('$notValidDragTarget', false);

//  a hash of any window offsets that were computed between a mouse down/drag
//  and a mouse up. This is cleared in the mouse up and (re)created when the
//  call is made to compute the window offsets.
TP.core.Mouse.Type.defineAttribute('$interWindowPointOffsets');

TP.core.Mouse.Type.defineAttribute('leftDown', false);
TP.core.Mouse.Type.defineAttribute('middleDown', false);
TP.core.Mouse.Type.defineAttribute('rightDown', false);

TP.core.Mouse.Type.defineAttribute('lastDown');
TP.core.Mouse.Type.defineAttribute('lastMove');
TP.core.Mouse.Type.defineAttribute('lastUp');

TP.core.Mouse.Type.defineAttribute('lastOver');
TP.core.Mouse.Type.defineAttribute('lastOut');

TP.core.Mouse.Type.defineAttribute('lastEnter');
TP.core.Mouse.Type.defineAttribute('lastLeave');

TP.core.Mouse.Type.defineAttribute('lastClick');
TP.core.Mouse.Type.defineAttribute('lastDblClick');
TP.core.Mouse.Type.defineAttribute('lastContextMenu');

TP.core.Mouse.Type.defineAttribute('lastMouseWheel');

//  encached copies of native event wrapper signals
TP.core.Mouse.Type.defineAttribute('mousedown');
TP.core.Mouse.Type.defineAttribute('mousemove');
TP.core.Mouse.Type.defineAttribute('mouseup');

TP.core.Mouse.Type.defineAttribute('mouseover');
TP.core.Mouse.Type.defineAttribute('mouseout');

TP.core.Mouse.Type.defineAttribute('mouseenter');
TP.core.Mouse.Type.defineAttribute('mouseleave');

TP.core.Mouse.Type.defineAttribute('click');
TP.core.Mouse.Type.defineAttribute('dblclick');
TP.core.Mouse.Type.defineAttribute('contextmenu');

TP.core.Mouse.Type.defineAttribute('mousewheel');

TP.core.Mouse.Type.defineAttribute('mousehover');

//  drag signals
TP.core.Mouse.Type.defineAttribute('dragdown');
TP.core.Mouse.Type.defineAttribute('dragmove');
TP.core.Mouse.Type.defineAttribute('dragup');

TP.core.Mouse.Type.defineAttribute('dragover');
TP.core.Mouse.Type.defineAttribute('dragout');

TP.core.Mouse.Type.defineAttribute('draghover');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.Mouse.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    //  construct a template instance for signals we care about
    this.$set('mousedown',
            TP.sys.getTypeByName('TP.sig.DOMMouseDown').construct(null, true));
    this.$set('mousemove',
            TP.sys.getTypeByName('TP.sig.DOMMouseMove').construct(null, true));
    this.$set('mouseup',
            TP.sys.getTypeByName('TP.sig.DOMMouseUp').construct(null, true));

    this.$set('mouseover',
            TP.sys.getTypeByName('TP.sig.DOMMouseOver').construct(null, true));
    this.$set('mouseout',
            TP.sys.getTypeByName('TP.sig.DOMMouseOut').construct(null, true));

    this.$set('mouseenter',
            TP.sys.getTypeByName('TP.sig.DOMMouseEnter').construct(null, true));
    this.$set('mouseleave',
            TP.sys.getTypeByName('TP.sig.DOMMouseLeave').construct(null, true));

    this.$set('click',
            TP.sys.getTypeByName('TP.sig.DOMClick').construct(null, true));
    this.$set('dblclick',
            TP.sys.getTypeByName('TP.sig.DOMDblClick').construct(null, true));
    this.$set('contextmenu',
            TP.sys.getTypeByName('TP.sig.DOMContextMenu').construct(null, true));

    this.$set('mousewheel',
            TP.sys.getTypeByName('TP.sig.DOMMouseWheel').construct(null, true));

    this.$set('mousehover',
            TP.sys.getTypeByName('TP.sig.DOMMouseHover').construct(null, true));

    //  drag signals
    this.$set('dragdown',
            TP.sys.getTypeByName('TP.sig.DOMDragDown').construct(null, true));
    this.$set('dragmove',
            TP.sys.getTypeByName('TP.sig.DOMDragMove').construct(null, true));
    this.$set('dragup',
            TP.sys.getTypeByName('TP.sig.DOMDragUp').construct(null, true));

    this.$set('dragover',
            TP.sys.getTypeByName('TP.sig.DOMDragOver').construct(null, true));
    this.$set('dragout',
            TP.sys.getTypeByName('TP.sig.DOMDragOut').construct(null, true));

    this.$set('draghover',
            TP.sys.getTypeByName('TP.sig.DOMDragHover').construct(null, true));

    return;
});

//  ------------------------------------------------------------------------

TP.core.Mouse.Type.defineMethod('computeWindowOffsetsBetween',
function(aWindow, otherWindow) {

    /**
     * @method computeWindowOffsetsBetween
     * @summary Computes (and possibly caches) window offset data between two
     *     windows. Note that any cache built here is reset with every mouse up
     *     event.
     * @param {Window} aWindow The first window to compute the offset between.
     * @param {Window} otherWindow The second window to compute the offset
     *     between.
     * @returns {Number[]} An Array of two Numbers where the first number is the
     *     X offset between the two windows and the second number is the Y
     *     offset between the two windows.
     */

    var win1GID,
        win2GID,

        info,
        win1Info,

        offsets;

    win1GID = TP.gid(aWindow);
    win2GID = TP.gid(otherWindow);

    //  A set of nested hashes, keyed first on the first window and then on the
    //  second window.
    info = this.$get('$interWindowPointOffsets');

    //  Cascade logic to first try to find a valid hash, then a valid nested
    //  hash under the first window's GID and then an Array of offsets under the
    //  second window's GID in the nested hash.

    //  Note here that we only compute the offsets when *absolutely* necessary.
    //  The whole purpose of this caching scheme is to avoid window offset
    //  computations during operations like mouse dragging.
    if (TP.isValid(info)) {
        win1Info = info.at(win1GID);
        if (TP.isValid(win1Info)) {
            offsets = win1Info.at(win2GID);
            if (TP.isValid(offsets)) {
                return offsets;
            }
            offsets = TP.windowComputeWindowOffsets(
                                aWindow, otherWindow, false);
            win1Info.atPut(win2GID, offsets);
        } else {
            offsets = TP.windowComputeWindowOffsets(
                                aWindow, otherWindow, false);
            info.atPut(win1GID, TP.hc(win2GID, offsets));
        }
    } else {
        offsets = TP.windowComputeWindowOffsets(aWindow, otherWindow, false);
        info = TP.hc(win1GID, TP.hc(win2GID, offsets));
        this.$set('$interWindowPointOffsets', info);
    }

    return offsets;
});

//  ------------------------------------------------------------------------

TP.core.Mouse.Type.defineMethod('isDragging',
function() {

    /**
     * @method isDragging
     * @summary Returns true if the mouse is currently in a 'dragging' mode.
     * @returns {Boolean} True if dragging, false otherwise.
     */

    var lastMove;

    lastMove = TP.core.Mouse.$get('lastMove');

    return this.$$isDragging(lastMove);
});

//  ------------------------------------------------------------------------

TP.core.Mouse.Type.defineMethod('resetEventData',
function(filterWindow) {

    /**
     * @method resetEventData
     * @summary Resets any event data cached by the receiver. It is important
     *     to call this when the GUI is flushed between page refreshes to avoid
     *     having obsolete references to old DOM structures.
     * @param {Window} filterWindow The window to filter cached events by. If
     *     the event occurred in this window, it will be cleared.
     * @returns {TP.meta.core.Mouse} The receiver.
     */

    var evtTestFunc,
        sigTestFunc;

    evtTestFunc = function(sigName) {

        var event;

        event = this.get(sigName);

        if (TP.isEvent(event) &&
            TP.eventGetWindow(event) === filterWindow) {
            return true;
        }

        return false;
    }.bind(this);

    sigTestFunc = function(sigName) {

        var signal;

        signal = this.get(sigName);

        if (TP.isValid(signal) &&
            TP.isValid(signal.getPayload()) &&
            signal.getWindow() === filterWindow) {
            return true;
        }

        return false;
    }.bind(this);

    if (evtTestFunc('lastDown')) {
        this.set('lastDown', null);
    }

    if (evtTestFunc('lastMove')) {
        this.set('lastMove', null);
    }

    if (evtTestFunc('lastUp')) {
        this.set('lastUp', null);
    }

    if (evtTestFunc('lastOver')) {
        this.set('lastOver', null);
    }

    if (evtTestFunc('lastOut')) {
        this.set('lastOut', null);
    }

    if (evtTestFunc('lastClick')) {
        this.set('lastClick', null);
    }

    if (evtTestFunc('lastDblClick')) {
        this.set('lastDblClick', null);
    }

    if (evtTestFunc('lastContextMenu')) {
        this.set('lastContextMenu', null);
    }

    if (evtTestFunc('lastMouseWheel')) {
        this.set('lastMouseWheel', null);
    }

    if (sigTestFunc('mousedown')) {
        this.get('mousedown').setEvent(null);
    }

    if (sigTestFunc('mousemove')) {
        this.get('mousemove').setEvent(null);
    }

    if (sigTestFunc('mouseup')) {
        this.get('mouseup').setEvent(null);
    }

    if (sigTestFunc('mouseover')) {
        this.get('mouseover').setEvent(null);
    }

    if (sigTestFunc('mouseout')) {
        this.get('mouseout').setEvent(null);
    }

    if (sigTestFunc('mouseenter')) {
        this.get('mouseenter').setEvent(null);
    }

    if (sigTestFunc('mouseleave')) {
        this.get('mouseleave').setEvent(null);
    }

    if (sigTestFunc('click')) {
        this.get('click').setEvent(null);
    }

    if (sigTestFunc('dblclick')) {
        this.get('dblclick').setEvent(null);
    }

    if (sigTestFunc('contextmenu')) {
        this.get('contextmenu').setEvent(null);
    }

    if (sigTestFunc('mousewheel')) {
        this.get('mousewheel').setEvent(null);
    }

    if (sigTestFunc('mousehover')) {
        this.get('mousehover').setEvent(null);
    }

    if (sigTestFunc('dragdown')) {
        this.get('dragdown').setEvent(null);
    }

    if (sigTestFunc('dragmove')) {
        this.get('dragmove').setEvent(null);
    }

    if (sigTestFunc('dragup')) {
        this.get('dragup').setEvent(null);
    }

    if (sigTestFunc('dragover')) {
        this.get('dragover').setEvent(null);
    }

    if (sigTestFunc('dragout')) {
        this.get('dragout').setEvent(null);
    }

    if (sigTestFunc('draghover')) {
        this.get('draghover').setEvent(null);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Mouse.Type.defineMethod('invokeObservers',
function(singletonName, normalizedEvent, aSignal) {

    /**
     * @method invokeObservers
     * @summary Runs the event handlers for any registered observers.
     * @description Each native event type has a singleton TIBET signal instance
     *     registered with the device type. This singleton is acquired, updated,
     *     and then passed to each handler for processing. The normalizedEvent
     *     becomes the payload/native event for the signal and is thereby
     *     available to each handler for use.
     * @param {String} singletonName The attribute name used to acquire a
     *     singleton signal instance for the invocation.
     * @param {Event} normalizedEvent A normalized (augmented) native event
     *     object conforming to a set of common and W3-compliant methods.
     * @param {TP.sig.Signal} aSignal Optional signal to use rather than the
     *     singleton/event pair.
     * @returns {TP.sig.Signal|undefined} The signal that was actually
     *     triggered.
     */

    var targetElem,

        fname,
        elemType,

        signal,
        redirector,
        redirected,
        dict,

        logInfo,

        handlers,

        len,
        i,
        handler,

        typename;

    if (!TP.sys.hasInitialized()) {
        return;
    }

    if (TP.isElement(targetElem =
                        TP.eventGetResolvedTarget(normalizedEvent))) {
        fname = 'on' + TP.eventGetType(normalizedEvent);

        elemType = TP.wrap(targetElem).getType();

        //  Message the type for the element that is 'responsible' for
        //  this event. It's native control sent this event and we need
        //  to let the type know about it.
        if (TP.canInvoke(elemType, fname)) {
            elemType[fname](targetElem, normalizedEvent);
        }

        //  If the native event was prevented, then we should just bail out
        //  here.
        //  NB: 'defaultPrevented' is a DOM Level 3 property, which seems to
        //  be well supported on TIBET's target browser environments.
        if (normalizedEvent.defaultPrevented === true) {
            return;
        }
    }

    //  when we're provided with a signal we don't need to build one.
    signal = aSignal;
    if (TP.notValid(signal)) {
        //  build up a true signal from our template instance
        if (TP.notValid(signal = this.get(singletonName))) {
            TP.ifWarn() ?
                TP.warn('Event singleton not found for: ' + singletonName) : 0;

            return;
        }

        //  Make sure to recycle the signal instance to clear any previous
        //  state.
        signal.recycle();

        //  let the signal type manage updates on signal naming etc through
        //  the setEvent functions they can optionally implement.
        signal.setEvent(normalizedEvent);

        //  when we reuse singleton we need to initialize origin to the resolved
        //  target
        signal.set('origin', signal.getResolvedTarget());
    }

    //  capture the information we'll need to see about redirections
    redirector = this.REDIRECTOR;

    //  we force redirection but we only want to do it once. this flag keeps us
    //  from dispatching the same signal to the redirector twice.
    redirected = false;

    dict = this.get('observers');

    //  We process both the specific signal and the overall signal type so
    //  both kinds of observations will succeed.

    if (TP.sys.shouldLogMouse()) {

        logInfo = TP.hc(
            'target', TP.isValid(normalizedEvent.$$target) ?
                        TP.id(normalizedEvent.$$target) :
                        TP.id(normalizedEvent.target),
            'relatedTarget',
                        TP.isValid(normalizedEvent.$$relatedTarget) ?
                        TP.id(normalizedEvent.$$relatedTarget) :
                        TP.id(normalizedEvent.relatedTarget),
            'resolvedTarget',
                        TP.isValid(normalizedEvent.$$_resolvedTarget) ?
                        TP.id(normalizedEvent.$$_resolvedTarget) :
                        TP.id(normalizedEvent.resolvedTarget),
            'type', TP.isValid(normalizedEvent.$$type) ?
                        normalizedEvent.$$type :
                        normalizedEvent.type,
            'timestamp', TP.isValid(normalizedEvent.$$timestamp) ?
                        normalizedEvent.$$timestamp :
                        normalizedEvent.timestamp,
            'view', TP.isValid(normalizedEvent.$$view) ?
                        normalizedEvent.$$view :
                        normalizedEvent.view,

            'clientX', TP.isValid(normalizedEvent.$$clientX) ?
                        normalizedEvent.$$clientX :
                        normalizedEvent.clientX,
            'clientY', TP.isValid(normalizedEvent.$$clientY) ?
                        normalizedEvent.$$clientY :
                        normalizedEvent.clientY,
            'offsetX', TP.isValid(normalizedEvent.$$offsetX) ?
                        normalizedEvent.$$offsetX :
                        normalizedEvent.offsetX,
            'offsetY', TP.isValid(normalizedEvent.$$offsetY) ?
                        normalizedEvent.$$offsetY :
                        normalizedEvent.offsetY,
            'pageX', TP.isValid(normalizedEvent.$$pageX) ?
                        normalizedEvent.$$pageX :
                        normalizedEvent.pageX,
            'pageY', TP.isValid(normalizedEvent.$$pageY) ?
                        normalizedEvent.$$pageY :
                        normalizedEvent.pageY,
            'screenX', TP.isValid(normalizedEvent.$$screenX) ?
                        normalizedEvent.$$screenX :
                        normalizedEvent.screenX,
            'screenY', TP.isValid(normalizedEvent.$$screenY) ?
                        normalizedEvent.$$screenY :
                        normalizedEvent.screenY,

            'button', TP.isValid(normalizedEvent.$$button) ?
                        normalizedEvent.$$button :
                        normalizedEvent.button,
            'wheelDelta', TP.isValid(normalizedEvent.$$wheelDelta) ?
                        normalizedEvent.$$wheelDelta :
                        normalizedEvent.wheelDelta,

            'which', TP.isValid(normalizedEvent.which) ?
                                    normalizedEvent.which : '',

            'shift', normalizedEvent.shiftKey,
            'alt', normalizedEvent.altKey,
            'ctrl', normalizedEvent.ctrlKey,
            'meta', normalizedEvent.metaKey,

            'low_level_signame', singletonName,
            'high_level_signame', signal.getSignalName(),

            'special', TP.isValid(normalizedEvent.$special) ?
                        normalizedEvent.$special : false
            );

        TP.sys.logMouse(logInfo, null);
    }

    //  Process the handlers registered under the signal name.
    if (TP.notEmpty(handlers = dict.at(signal.getSignalName()))) {
        len = handlers.getSize();
        for (i = 0; i < len; i++) {
            if (signal.shouldStop()) {
                break;
            }

            handler = handlers.at(i);

            //  when we're using the redirector as the handler we need to
            //  push the original origin back into place, otherwise we set
            //  it to the receiver (since observe is for the device).
            if (handler !== redirector) {
                signal.set('origin', this);
            } else {
                redirected = true;
            }

            try {
                TP.handle(handler, signal);
            } catch (e) {
                TP.raise(this, 'TP.sig.HandlerException', TP.ec(e));
            }
        }
    } else {
        redirected = true;
        TP.handle(redirector, signal);
    }

    //  If the signal name wasn't the same as the signal's signal name then
    //  we go ahead and process the handlers registered under the type name,
    //  because its a spoofed signal.

    typename = signal.getName();

    if (signal.getSignalName() !== typename) {

        //  Reset the signal name to the type name because we need to
        //  signal to observers of the type name.
        signal.setSignalName(typename);

        if (TP.notEmpty(handlers = dict.at(typename))) {
            len = handlers.getSize();
            for (i = 0; i < len; i++) {
                if (signal.shouldStop()) {
                    break;
                }

                handler = handlers.at(i);

                //  when we're using the redirector as the handler we need
                //  to push the original origin back into place, otherwise
                //  we set it to the receiver (since observe is for the
                //  device).
                if (handler !== redirector) {
                    signal.set('origin', this);
                }

                try {
                    TP.handle(handler, signal);
                } catch (e) {
                    TP.raise(this, 'TP.sig.HandlerException',
                                TP.ec(e));
                }
            }
        } else if (!redirected) {
            TP.handle(redirector, signal);
        }
    }

    return signal;
});

//  ------------------------------------------------------------------------

TP.core.Mouse.Type.defineMethod('$$handleClick',
function(normalizedEvent) {

    /**
     * @method $$handleClick
     * @summary Responds to notifications from the native event system that a
     *     click event has occurred.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.Mouse} The receiver.
     */

    var lastDown,

        clickDelay,
        targetElem,
        targetDelay,

        theEvent;

    if (TP.isNumber(TP.core.Mouse.$$clickTimer)) {
        return this;
    }

    lastDown = this.get('lastDown');

    //  If we can't compute a distance from the last mousedown then we assume
    //  this is a valid click event
    if (!TP.isEvent(lastDown)) {
        this.invokeObservers('click', normalizedEvent);

        return this;
    }

    //  make sure that we're not dragging...
    if (TP.core.Mouse.$$isDragging(normalizedEvent)) {
        return this;
    }

    //  The clickDelay is used when a piece of UI has been authored in such a
    //  way that a real distinction wants to be made between 'click' and 'double
    //  click' (rather than 'double click' just being 'more click'). If another
    //  click happens within the clickDelay time, the double click handler
    //  cancels the timeout and no 'click' handlers are fired.

    //  Initially set the clickDelay to the system configured click delay. This
    //  is usually set to 0 such that there is no delay and has the effect that
    //  'double click' is just 'more click'.
    clickDelay = TP.sys.cfg('mouse.click_delay');

    //  Get a resolved event target, given the event. This takes into account
    //  disabled elements and will look for a target element with the
    //  appropriate 'enabling attribute', if possible.
    if (TP.isElement(targetElem = TP.eventGetResolvedTarget(normalizedEvent))) {
        //  If the event target has an 'tibet:clickdelay' attribute, try to
        //  convert it to a Number and if that's successful, set clickDelay to
        //  it.
        if (TP.isNumber(targetDelay =
                            TP.elementGetAttribute(
                                            targetElem,
                                            'tibet:clickdelay',
                                            true).asNumber())) {
            clickDelay = targetDelay;
        }
    }

    //  Use a timer that can be cancelled by dblclick events so we don't cause
    //  event-level confusion. the semantics should be maintained by the
    //  application however that dblclick is "more click".
    theEvent = normalizedEvent;

    TP.core.Mouse.$$clickTimer = setTimeout(
        function() {

            TP.core.Mouse.invokeObservers('click', theEvent);

            TP.core.Mouse.$$clickTimer = undefined;
        }, clickDelay);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Mouse.Type.defineMethod('$$handleContextMenu',
function(normalizedEvent) {

    /**
     * @method $$handleContextMenu
     * @summary Responds to notifications from the native event system that a
     *     context menu event has occurred.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.Mouse} The receiver.
     */

    var signal;

    signal = this.invokeObservers('contextmenu', normalizedEvent);
    if (TP.isKindOf(signal, 'TP.sig.Signal')) {
        if (signal.shouldPrevent()) {
            normalizedEvent.preventDefault();
        }

        if (signal.shouldStop()) {
            normalizedEvent.stopPropagation();
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Mouse.Type.defineMethod('$$handleDblClick',
function(normalizedEvent) {

    /**
     * @method $$handleDblClick
     * @summary Responds to notifications from the native event system that a
     *     dblclick event has occurred.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.Mouse} The receiver.
     */

    //  clear any click timer...double-click overrides click at the raw
    //  event level
    if (TP.isNumber(TP.core.Mouse.$$clickTimer)) {
        clearTimeout(TP.core.Mouse.$$clickTimer);
        TP.core.Mouse.$$clickTimer = undefined;
    }

    this.invokeObservers('dblclick', normalizedEvent);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Mouse.Type.defineMethod('$$handleMouseEvent',
function(nativeEvent) {

    /**
     * @method $$handleMouseEvent
     * @summary Responds to notification of a native mouse event.
     * @param {Event} nativeEvent The native event.
     * @returns {TP.meta.core.Mouse} The receiver.
     */

    var ev,
        lastEventName;

    //  Don't come through this handler twice for the same Event
    if (nativeEvent.$captured) {
        return this;
    }
    nativeEvent.$captured = true;

    //  normalize the event
    ev = TP.event(nativeEvent);

    //  If TIBET shouldn't handle the event, then we return here. Note that this
    //  will still allow other third-party libraries to trap and process events.
    if (TP.isFalse(TP.targetShouldHandleEvent(ev))) {
        return this;
    }

    //  we'll switch on type here so we can fine-tune each event type's
    //  logic as needed

    //  Note here that for every one of these cases we capture the event
    //  into a variable that will keep a reference to the last time this
    //  event happened. This is used in a variety of ways in the
    //  $$handle* calls, and both the event and the slot may be altered
    //  during the course of that call.
    switch (TP.eventGetType(ev)) {
        case 'mousedown':

            lastEventName = 'lastDown';
            TP.core.Mouse.$set(lastEventName, ev);

            TP.core.Mouse.$$handleMouseDown(ev);
            break;

        case 'mousemove':

            lastEventName = 'lastMove';
            TP.core.Mouse.$set(lastEventName, ev);

            TP.core.Mouse.$$handleMouseMove(ev);
            break;

        case 'mouseup':

            lastEventName = 'lastUp';
            TP.core.Mouse.$set(lastEventName, ev);

            TP.core.Mouse.$$handleMouseUp(ev);
            break;

        case 'mouseover':

            lastEventName = 'lastOver';
            TP.core.Mouse.$set(lastEventName, ev);

            TP.core.Mouse.$$handleMouseOver(ev);
            break;

        case 'mouseout':

            lastEventName = 'lastOut';
            TP.core.Mouse.$set(lastEventName, ev);

            TP.core.Mouse.$$handleMouseOut(ev);
            break;

        case 'mouseenter':

            lastEventName = 'lastEnter';
            TP.core.Mouse.$set(lastEventName, ev);

            TP.core.Mouse.$$handleMouseEnter(ev);
            break;

        case 'mouseleave':

            lastEventName = 'lastLeave';
            TP.core.Mouse.$set(lastEventName, ev);

            TP.core.Mouse.$$handleMouseLeave(ev);
            break;

        case 'click':

            //  If the 'detail' field on the native event is '0', that means
            //  that this is a simulated 'click' event. Most browsers simulate a
            //  click event when the user releases the 'enter' key over a
            //  focusable control. We don't want these signals (TIBET handles
            //  events/signals in a much smarter - and more explicit - way) and
            //  so we dampen them here.
            if (ev.detail !== 0) {
                lastEventName = 'lastClick';
                TP.core.Mouse.$set(lastEventName, ev);

                TP.core.Mouse.$$handleClick(ev);
            }
            break;

        case 'dblclick':

            lastEventName = 'lastDblClick';
            TP.core.Mouse.$set(lastEventName, ev);

            TP.core.Mouse.$$handleDblClick(ev);
            break;

        case 'contextmenu':

            lastEventName = 'lastContextMenu';
            TP.core.Mouse.$set(lastEventName, ev);

            TP.core.Mouse.$$handleContextMenu(ev);
            break;

        case 'mousewheel':
        case 'DOMMouseScroll':

            //  NOTE the translation for Moz vs. IE in the signal names via
            //  fallthrough on the cases above

            lastEventName = 'lastMouseWheel';
            TP.core.Mouse.$set(lastEventName, ev);

            TP.core.Mouse.$$handleMouseWheel(ev);
            break;

        default:
            return this;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Mouse.Type.defineMethod('$$handleMouseDown',
function(normalizedEvent) {

    /**
     * @method $$handleMouseDown
     * @summary Responds to notifications from the native event system that a
     *     mouse down event has occurred.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.Mouse} The receiver.
     */

    //  Update button state(s)
    this.$$updateButtonStates(normalizedEvent);

    //  'dragdown' isn't triggered in this way (because of further tolerance
    //  computations that need to be done), only 'mousedown'.
    this.invokeObservers('mousedown', normalizedEvent);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Mouse.Type.defineMethod('$$handleMouseMove',
function(normalizedEvent) {

    /**
     * @method $$handleMouseMove
     * @summary Responds to notifications from the native event system that a
     *     mouse move event has occurred.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.Mouse} The receiver.
     */

    var dragDownEvent,
        doc;

    //  TODO:   verify whether this is still required on target browsers
    TP.core.Keyboard.getCurrentKeyboard().$$updateModifierStates(
                                                        normalizedEvent);

    if (this.$$isDragging(normalizedEvent)) {
        if (TP.notTrue(this.$get('$sentDragDown'))) {
            //  Need to 'copy and retask' the 'last down' event, so that the
            //  correct targeting is performed and so that the proper kind
            //  of signal type, etc. is selected. We can do this by copying
            //  the 'last down' event and setting its 'event type'.
            if (TP.isEvent(dragDownEvent = this.get('lastDown'))) {
                dragDownEvent = dragDownEvent.copy();
                TP.eventSetType(dragDownEvent, 'dragdown');

                //  Make sure to suspend all mutation observer machinery for
                //  performance here during a drag session. This significantly
                //  increases drag performance during the session and gets
                //  switched back on in $$handleMouseUp.
                TP.suspendAllMutationObservers();

                this.invokeObservers('dragdown', dragDownEvent);

                this.$set('$sentDragDown', true);
            }
        }

        TP.eventSetType(normalizedEvent, 'dragmove');

        doc = TP.eventGetTargetDocument(normalizedEvent);
        if (TP.isDocument(doc)) {

            if (doc.selection) {
                doc.selection.empty();
            } else {
                doc.defaultView.getSelection().removeAllRanges();
            }
        }

        this.invokeObservers('dragmove', normalizedEvent);
    } else {
        this.invokeObservers('mousemove', normalizedEvent);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Mouse.Type.defineMethod('$$handleMouseWheel',
function(normalizedEvent) {

    /**
     * @method $$handleMouseWheel
     * @summary Responds to notifications from the native event system that a
     *     mouse wheel event has occurred.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.Mouse} The receiver.
     */

    if (TP.$mousewheel_capturer_cache.indexOf(normalizedEvent.target) !==
        TP.NOT_FOUND) {
        return this;
    }

    this.invokeObservers('mousewheel', normalizedEvent);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Mouse.Type.defineMethod('$$handleMouseUp',
function(normalizedEvent) {

    /**
     * @method $$handleMouseUp
     * @summary Responds to notifications from the native event system that a
     *     mouse up event has occurred.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.Mouse} The receiver.
     */

    var wasDragging,
        doc;

    //  Note how we do this before we update the button state.
    wasDragging = this.$$isDragging(normalizedEvent);

    //  Update button state(s) - the user needs to know which button went up
    //  in their handler.
    this.$$updateButtonStates(normalizedEvent);

    if (wasDragging) {
        TP.eventSetType(normalizedEvent, 'dragup');

        doc = TP.eventGetTargetDocument(normalizedEvent);
        if (TP.isDocument(doc)) {

            if (doc.selection) {
                doc.selection.empty();
            } else {
                doc.defaultView.getSelection().removeAllRanges();
            }
        }

        //  Resume all mutation observer machinery. Note how we do this *before*
        //  we invoke the dragup observers. That way, if any of them do DOM
        //  manipulation, mutation observer firing will again be taking place
        //  for those operations.
        TP.resumeAllMutationObservers();

        this.invokeObservers('dragup', normalizedEvent);

        this.$set('$sentDragDown', false);
    } else {
        this.invokeObservers('mouseup', normalizedEvent);
    }

    this.$set('$notValidDragTarget', false);

    try {
        clearTimeout(this.$get('overTimer'));
        clearTimeout(this.$get('hoverTimer'));
        clearTimeout(this.$get('hoverRepeatTimer'));
    } catch (e) {
        TP.ifError() ?
                TP.error('Unable to clear hover timeout') : 0;
    }

    this.$set('$interWindowPointOffsets', null);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Mouse.Type.defineMethod('$$handleMouseOver',
function(normalizedEvent) {

    /**
     * @method $$handleMouseOver
     * @summary Responds to notifications from the native event system that a
     *     mouse over event has occurred.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.Mouse} The receiver.
     */

    var targetElem,

        overDelay,
        targetOverDelay,

        overAncestor,

        overHandler;

    //  Get a resolved event target, given the event. This takes into
    //  account disabled elements and will look for a target element
    //  with the appropriate 'enabling attribute', if possible.

    targetElem = TP.eventGetResolvedTarget(normalizedEvent);

    overDelay = TP.sys.cfg('mouse.over_delay');

    //  Get a resolved event target, given the event. This takes into account
    //  disabled elements and will look for a target element with the
    //  appropriate 'enabling attribute', if possible.
    if (TP.isElement(targetElem)) {

        //  If the event target has an 'tibet:overdelay' attribute, try to
        //  convert it to a Number and if that's successful, set overDelay to
        //  it.
        targetOverDelay = TP.elementGetAttribute(targetElem,
                                                    'tibet:overdelay',
                                                    true);

        //  If we got a over delay value, then try to convert it to a Number and
        //  use it.
        if (TP.notEmpty(targetOverDelay)) {
            targetOverDelay = targetOverDelay.asNumber();

            if (TP.isNumber(targetOverDelay)) {
                overDelay = targetOverDelay;
            }
        } else {

            //  Otherwise, search up the ancestor chain looking for an element
            //  with a over delay attribute.
            overAncestor = TP.nodeDetectAncestorMatchingCSS(
                                        targetElem, '*[tibet|overdelay]');

            //  If we found an ancestor that had a over delay attribute, then
            //  obtain its value, try to convert it to a Number and use it.
            if (TP.isElement(overAncestor)) {
                targetOverDelay = TP.elementGetAttribute(
                                                    overAncestor,
                                                    'tibet:overdelay',
                                                    true);
                targetOverDelay = targetOverDelay.asNumber();

                if (TP.isNumber(targetOverDelay)) {
                    overDelay = targetOverDelay;
                }
            }
        }
    }

    overHandler = function() {

        var hoverDelay,
            targetHoverDelay,

            hoverAncestor;

        if (this.$$isDragging(normalizedEvent)) {
            TP.eventSetType(normalizedEvent, 'dragover');

            this.invokeObservers('dragover', normalizedEvent);
        } else {
            this.invokeObservers('mouseover', normalizedEvent);
        }

        hoverDelay = TP.sys.cfg('mouse.hover_delay');

        //  Get a resolved event target, given the event. This takes into
        //  account disabled elements and will look for a target element
        //  with the appropriate 'enabling attribute', if possible.
        if (TP.isElement(targetElem)) {

            //  If the event target has an 'tibet:hoverdelay' attribute, try
            //  to convert it to a Number and if that's successful, set
            //  hoverDelay to it.
            targetHoverDelay = TP.elementGetAttribute(
                                                targetElem,
                                                'tibet:hoverdelay',
                                                true);

            //  If we got a hover delay value, then try to convert it to a
            //  Number and use it.
            if (TP.notEmpty(targetHoverDelay)) {
                targetHoverDelay = targetHoverDelay.asNumber();

                if (TP.isNumber(targetHoverDelay)) {
                    hoverDelay = targetHoverDelay;
                }
            } else {

                //  Otherwise, search up the ancestor chain looking for an
                //  element with a hover delay attribute.
                hoverAncestor = TP.nodeDetectAncestorMatchingCSS(
                                            targetElem, '*[tibet|hoverdelay]');

                //  If we found an ancestor that had a hover delay attribute,
                //  then obtain its value, try to convert it to a Number and use
                //  it.
                if (TP.isElement(hoverAncestor)) {
                    targetHoverDelay = TP.elementGetAttribute(
                                                        hoverAncestor,
                                                        'tibet:hoverdelay',
                                                        true);
                    targetHoverDelay = targetHoverDelay.asNumber();

                    if (TP.isNumber(targetHoverDelay)) {
                        hoverDelay = targetHoverDelay;
                    }
                }
            }
        }

        TP.core.Mouse.$set('hoverTimer',
                            setTimeout(this.$get('hoverFunc'), hoverDelay));
    }.bind(this);

    TP.core.Mouse.$set('overTimer',
                        setTimeout(overHandler, overDelay));

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Mouse.Type.defineMethod('$$handleMouseOut',
function(normalizedEvent) {

    /**
     * @method $$handleMouseOut
     * @summary Responds to notifications from the native event system that a
     *     mouse over event has occurred.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.Mouse} The receiver.
     */

    //  Get a resolved event target, given the event. This takes into
    //  account disabled elements and will look for a target element
    //  with the appropriate 'enabling attribute', if possible.

    if (this.$$isDragging(normalizedEvent)) {
        TP.eventSetType(normalizedEvent, 'dragout');

        this.invokeObservers('dragout', normalizedEvent);
    } else {
        this.invokeObservers('mouseout', normalizedEvent);
    }

    try {
        clearTimeout(this.$get('overTimer'));
        clearTimeout(this.$get('hoverTimer'));
        clearTimeout(this.$get('hoverRepeatTimer'));
    } catch (e) {
        TP.ifError() ?
                TP.error('Unable to clear hover timeout') : 0;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Mouse.Type.defineMethod('$$handleMouseEnter',
function(normalizedEvent) {

    /**
     * @method $$handleMouseEnter
     * @summary Responds to notifications from the native event system that a
     *     mouse enter event has occurred.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.Mouse} The receiver.
     */

    this.invokeObservers('mouseenter', normalizedEvent);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Mouse.Type.defineMethod('$$handleMouseLeave',
function(normalizedEvent) {

    /**
     * @method $$handleMouseLeave
     * @summary Responds to notifications from the native event system that a
     *     mouse leave event has occurred.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.Mouse} The receiver.
     */

    this.invokeObservers('mouseleave', normalizedEvent);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Mouse.Type.defineMethod('$$isDragging',
function(normalizedEvent) {

    /**
     * @method $$isDragging
     * @summary Returns true if the mouse is currently in a 'dragging' mode.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {Boolean} True if dragging, false otherwise.
     */

    var dragButtonDown,

        lastDown,

        target,
        val,
        ans,

        distance,

        dragDistance,
        dragDelay,

        targetElem,

        targetDistance,
        targetDelay,

        elapsedTime;

    //  If we've sent a 'drag down', then we're in the middle of dragging...
    //  short stop it here.
    if (TP.isTrue(this.$get('$sentDragDown'))) {
        return true;
    }

    if (TP.isTrue(this.$get('$notValidDragTarget'))) {
        return false;
    }

    /* eslint-disable no-extra-parens */
    dragButtonDown =
                (this.$get('leftDown') &&
                    TP.sys.cfg('mouse.drag_buttons').contains('left')) ||
                (this.$get('middleDown') &&
                    TP.sys.cfg('mouse.drag_buttons').contains('middle')) ||
                (this.$get('rightDown') &&
                    TP.sys.cfg('mouse.drag_buttons').contains('right'));
    /* eslint-enable no-extra-parens */

    if (dragButtonDown) {
        if (!TP.isEvent(lastDown = this.get('lastDown'))) {
            return false;
        }

        //  Compute whether or not the target wants to allow dragging (and cache
        //  the value if it doesn't).
        target = TP.eventGetTarget(normalizedEvent);
        val = TP.elementGetAttribute(
                        target, 'tibet:no-dragtrap', true);
        if (val === 'true') {
            this.$set('$notValidDragTarget', true);
            return false;
        }

        if (TP.isElement(
            ans = TP.nodeDetectAncestorMatchingCSS(
                        target,
                        '*[tibet|no-dragtrap]'))) {

            val = TP.elementGetAttribute(
                        ans, 'tibet:no-dragtrap', true);
            if (val === 'true') {
                this.$set('$notValidDragTarget', true);
                return false;
            }
        }

        distance = TP.computeDistance(lastDown, normalizedEvent);

        //  Initially, set the drag pixel distance to the value from the
        //  TP.sys.cfg() variable
        dragDistance = TP.sys.cfg('mouse.drag_distance');

        //  Initially, set the drag time delay to the value from the
        //  TP.sys.cfg() variable
        dragDelay = TP.sys.cfg('mouse.drag_delay');

        //  Get a resolved event target, given the event. This takes into
        //  account disabled elements and will look for a target element
        //  with the appropriate 'enabling attribute', if possible.
        if (TP.isElement(targetElem = TP.eventGetResolvedTarget(
                                                        normalizedEvent))) {
            //  If the event target has an 'tibet:dragdistance' attribute, try
            //  to convert it to a Number and if that's successful, set
            //  dragDistance to it.
            if (TP.isNumber(targetDistance =
                                TP.elementGetAttribute(
                                            targetElem,
                                            'tibet:dragdistance',
                                            true).asNumber())) {
                dragDistance = targetDistance;
            }

            //  If the event target has an 'tibet:dragdelay' attribute, try
            //  to convert it to a Number and if that's successful, set
            //  dragDelay to it.
            if (TP.isNumber(targetDelay =
                                TP.elementGetAttribute(
                                            targetElem,
                                            'tibet:dragdelay',
                                            true).asNumber())) {
                dragDelay = targetDelay;
            }
        }

        elapsedTime = TP.eventGetTime(normalizedEvent) -
                        TP.eventGetTime(lastDown);

        /* eslint-disable no-extra-parens */
        return (distance >= dragDistance && elapsedTime >= dragDelay);
        /* eslint-enable no-extra-parens */
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.core.Mouse.Type.defineMethod('$$updateButtonStates',
function(normalizedEvent) {

    /**
     * @method $$updateButtonStates
     * @summary Updates the button status based on the supplied Event.
     * @param {Event} normalizedEvent A normalized (W3 compatible) Event object.
     * @returns {TP.meta.core.Mouse} The receiver.
     */

    var button,
        value;

    button = TP.button(normalizedEvent);

    value = normalizedEvent.type === 'mousedown' ? true : false;

    switch (button) {
        case TP.LEFT:

            this.$set('leftDown', value);
            break;

        case TP.MIDDLE:

            this.$set('middleDown', value);
            break;

        case TP.RIGHT:

            this.$set('rightDown', value);
            break;

        default:
            break;
    }

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETHTTPTypes.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.sig.HTTPRequest
//  ========================================================================

/**
 * @type {TP.sig.HTTPRequest}
 * @summary Top-level request type for HTTP-based services.
 */

//  ------------------------------------------------------------------------

TP.sig.URIRequest.defineSubtype('HTTPRequest');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.sig.HTTPRequest.Type.defineAttribute('responseType', 'TP.sig.HTTPResponse');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.HTTPRequest.Inst.defineMethod('failJob',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method failJob
     * @summary Fails the HTTP request, aborting any underlying native
     *     XMLHttpRequest object as well. NOTE that this would have to be an
     *     asynchronous request for this to work effectively.
     * @param {String} aFaultString A text description of the reason for the
     *     failure.
     * @param {Object} aFaultCode A reason for the failure.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the failure.
     * @returns {TP.sig.HTTPRequest}
     */

    var httpObj,
        msg,
        url,
        uri;

    //  presumably we can do this only because the request is async and
    //  we've got some cycles...so do what we can to turn off the request
    if (TP.isXHR(httpObj = this.at('commObj'))) {
        TP.httpAbort(httpObj);
    }

    msg = aFaultCode + ' ' + aFaultString;

    this.atPut('direction', TP.RECV);
    this.atPut('message',
        TP.isEmpty(msg) ? 'HTTP request aborted.' :
                        'HTTP request aborted: ' + msg);

    TP.ifInfo() && TP.sys.shouldLogIO() ?
            TP.sys.logIO(this, TP.INFO) : 0;

    //  TODO: migrate to the TP.core.HTTPURIHandler

    //  update what we consider to be our "final uri", the qualified URI
    //  based on parameter data etc.
    url = this.at('finaluri');
    if (TP.isURIString(url)) {
        uri = TP.uc(url);
        if (TP.isURI(uri)) {
            uri.isLoaded(false);
            //  Note here that we don't alter the status of the dirty flag. If
            //  the resource is dirty, it stays dirty. If not, we don't alter
            //  that.
        }
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.sig.HTTPRequest.Inst.defineMethod('cancelJob',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method cancelJob
     * @summary Cancels an HTTP request, aborting any underlying native
     *     XMLHttpRequest object as well. NOTE that this would have to
     * @param {String} aFaultString A text description of the reason for the
     *     cancellation.
     * @param {Object} aFaultCode A reason for the cancellation.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the cancellation.
     * @returns {TP.sig.HTTPRequest}
     */

    var httpObj,
        msg,
        url,
        uri;

    //  presumably we can do this only because the request is async and
    //  we've got some cycles...so do what we can to turn off the request
    if (TP.isXHR(httpObj = this.at('commObj'))) {
        TP.httpAbort(httpObj);
    }

    msg = aFaultCode + ' ' + aFaultString;

    this.atPut('direction', TP.RECV);
    this.atPut('message',
        TP.isEmpty(msg) ? 'HTTP request cancelled.' :
                        'HTTP request cancelled: ' + msg);

    TP.ifInfo() && TP.sys.shouldLogIO() ?
            TP.sys.logIO(this, TP.INFO) : 0;

    //  TODO: migrate to the TP.core.HTTPURIHandler

    //  update what we consider to be our "final uri", the qualified URI
    //  based on parameter data etc.
    url = this.at('finaluri');
    if (TP.isURIString(url)) {
        uri = TP.uc(url);
        if (TP.isURI(uri)) {
            uri.isLoaded(false);
            //  Note here that we don't alter the status of the dirty flag. If
            //  the resource is dirty, it stays dirty. If not, we don't alter
            //  that.
        }
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.sig.HTTPRequest.Inst.defineMethod('completeJob',
function(aResult) {

    /**
     * @method completeJob
     * @summary Completes the request, peforming any wrapup that might be
     *     necessary to ensure proper capture of the result data.
     *     TP.sig.URIRequests will attempt to update their target URI instance
     *     with any result data in response to this call.
     * @param {Object} aResult An optional object to set as the result of the
     *     request.
     * @returns {TP.sig.HTTPRequest}
     */

    var httpObj,
        url,
        uri,
        data,
        result,

        wasRefreshingContent;

    httpObj = this.at('commObj');

    //  update what we consider to be our "final uri", the qualified URI
    //  based on parameter data etc.
    url = this.at('finaluri');
    if (TP.isURIString(url)) {
        uri = TP.uc(url);
        if (TP.isURI(uri)) {
            uri.updateHeaders(httpObj);

            //  Get the filtered resource result as our request response. This
            //  does not change the uri's internally held resource (although it
            //  may change the internal data of a content object resource).
            data = uri.getRequestedResource(this);
        }
    }

    result = TP.ifInvalid(aResult, data);

    switch (this.at('resultType')) {
        case TP.DOM:
            if (!TP.isNode(result)) {
                result = httpObj.responseXML;
            }
            break;
        case TP.TEXT:
            if (!TP.isString(result)) {
                result = httpObj.responseText;
            }
            break;
        case TP.XHR:
        case TP.NATIVE:
            if (!TP.isXHR(result)) {
                result = httpObj;
            }
            break;
        default:    //  TP.WRAP
            break;
    }

    //  Set the result to the new data (or to the old data if the new data was
    //  invalid, per our switch statement above).
    this.set('result', result);

    //  Now, if we have a valid URI, update the resource cache again, which will
    //  use the result we just set and will update it to the new (or maybe old)
    //  data. NOTE: we capture the result and return it as the result from the
    //  HTTP call. This is important so that we get the last, most up-to-date
    //  data representation.
    if (TP.isValid(uri)) {

        //  Note how we force the 'refreshContent' setting to true here - this
        //  will make sure that the resource cache is updated with the content
        //  from this request and that the proper result is returned.
        wasRefreshingContent = this.at('refreshContent');
        this.atPut('refreshContent', true);

        //  Get the filtered resource result as our request response. This does
        //  not change the uri's internally held resource (although it may
        //  change the internal data of a content object resource).
        result = uri.getRequestedResource(this);

        this.atPut('refreshContent', wasRefreshingContent);
    }

    return this.callNextMethod(result);
});

//  ------------------------------------------------------------------------

TP.sig.HTTPRequest.Inst.defineHandler('IOFailed',
function(aSignal) {

    /**
     * @method handleIOFailed
     * @summary Handles notification that the underlying IO operation failed
     *     for some reason. The reason for the failure should be recorded in the
     *     response's faultCode/faultText content. IFF the receiver handles the
     *     specific status code, i.e. it has a method such as handle404, then
     *     that handler is called before processing a fail call.
     * @param {TP.sig.IOFailed} aSignal A response object containing the native
     *     XMLHttpRequest as 'commObj'.
     * @returns {TP.sig.HTTPRequest} The receiver.
     */

    var request,
        httpObj,
        code,
        handlerName,
        defer,
        faultCode,
        result;

    request = aSignal.getPayload();
    if (TP.isValid(request)) {
        httpObj = request.at('commObj');
        this.atPut('commObj', httpObj);
    }

    //  If the XHR mechanism has aborted in Mozilla, it will cause the
    //  '.status' property to throw an exception if it is read.
    try {
        //  the next thing to try is to see if we handle the status code in
        //  question, which lets us defer to handle404 etc.
        code = httpObj.status;

        //  set the fault code, which might be cleared if the handler is
        //  able to recover gracefully.
        this.set('faultCode', code);

        //  set the fault text, if any. this should be cleared by any handler
        //  function as needed.
        this.set('faultText', httpObj.statusText);

        handlerName = TP.composeHandlerName(code);
        if (TP.canInvoke(request, handlerName)) {
            defer = true;
            request[handlerName](aSignal);
        } else if (TP.canInvoke(this, handlerName)) {
            defer = true;
            this[handlerName](aSignal);
        }
    } finally {
        //  When we've deferred to a status-specific handler that handler is
        //  responsible for completion of the job since some handlers may
        //  need to make additional asynchronous calls to resolve things.
        if (TP.notTrue(defer)) {
            if (TP.isValid(faultCode = this.getFaultCode())) {
                this.fail(this.getFaultText(), faultCode, this.getFaultInfo());
            } else {
                result = aSignal.getResult();
                if (TP.isValid(result)) {
                    this.complete(result);
                } else {
                    this.complete();
                }
            }
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.HTTPRequest.Inst.defineHandler('IOSucceeded',
function(aSignal) {

    /**
     * @method handleIOSucceeded
     * @summary A handler which is invoked when the request's low-level IO has
     *     completed successfully.
     * @param {TP.sig.IOSucceeded} aSignal The signal, whose payload is includes
     *     the low-level request object itself as httpObj.
     * @returns {TP.sig.HTTPRequest} The receiver.
     */

    var request,
        httpObj,
        code,
        defer,
        handlerName,
        faultCode,
        result;

    //  first step is to make sure that if the incoming signal's request
    //  isn't actually the receiver we still tuck away the xhr for reference
    request = aSignal.getPayload();
    if (TP.isValid(request)) {
        httpObj = request.at('commObj');
        this.atPut('commObj', httpObj);
    }

    //  If the XHR mechanism has aborted in Mozilla, it will cause the
    //  '.status' property to throw an exception if it is read.
    try {
        //  the next thing to try is to see if we handle the status code in
        //  question, which lets us defer to handle304 etc.
        code = httpObj.status;

        handlerName = TP.composeHandlerName(code);
        if (TP.canInvoke(request, handlerName)) {
            defer = true;
            request[handlerName](aSignal);
        } else if (TP.canInvoke(this, handlerName)) {
            defer = true;
            this[handlerName](aSignal);
        }
    } finally {
        //  When we've deferred to a status-specific handler that handler is
        //  responsible for completion of the job since some handlers may
        //  need to make additional asynchronous calls to resolve things.
        if (TP.notTrue(defer)) {
            if (TP.isValid(faultCode = this.getFaultCode())) {
                this.fail(this.getFaultText(), faultCode, this.getFaultInfo());
            } else {
                result = aSignal.getResult();
                if (TP.isValid(result)) {
                    this.complete(result);
                } else {
                    this.complete();
                }
            }
        }
    }

    return this;
});

//  ========================================================================
//  TP.sig.HTTPResponse
//  ========================================================================

/**
 * @type {TP.sig.HTTPResponse}
 * @summary Provides a general purpose HTTP response wrapper.
 */

//  ------------------------------------------------------------------------

TP.sig.URIResponse.defineSubtype('HTTPResponse');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.sig.HTTPResponse.Inst.defineAttribute('responseXML');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.HTTPResponse.Inst.defineMethod('getFaultCode',
function() {

    /**
     * @method getFaultCode
     * @summary Returns the fault code if any.
     * @returns {String|undefined} A fault code.
     */

    var httpObj,
        statusCode;

    httpObj = this.getRequest().at('commObj');
    if (TP.isXHR(httpObj)) {
        if (!TP.httpDidSucceed(httpObj)) {
            //  If the XHR mechanism has aborted in Mozilla, it will cause
            //  the '.status' property to throw an exception if it is read.
            try {
                statusCode = httpObj.status;
            } catch (e) {
                statusCode = null;
            } finally {
                /* eslint-disable no-unsafe-finally */
                return statusCode;
                /* eslint-enable no-unsafe-finally */
            }
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.HTTPResponse.Inst.defineMethod('getFaultText',
function() {

    /**
     * @method getFaultText
     * @summary Returns the fault message string if any.
     * @returns {String|undefined} A fault message string.
     */

    var httpObj;

    httpObj = this.getRequest().at('commObj');
    if (TP.isXHR(httpObj)) {
        if (!TP.httpDidSucceed(httpObj)) {
            return httpObj.statusText;
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.HTTPResponse.Inst.defineMethod('getNativeObject',
function() {

    /**
     * @method getNativeObject
     * @summary Returns the native XMLHttpRequest object which serves as the
     *     container for the response data managed by this type. This method is
     *     consistent with the requirements of TP.unwrap() so that
     *     TP.unwrap()ing a TP.sig.HTTPResponse will return you the native
     *     XMLHttpRequest that it contains.
     * @returns {XMLHttpRequest} The native XMLHttpRequest.
     */

    //  if we have one it'll be stored with our request in the 'commObj' key
    return this.getRequest().at('commObj');
});

//  ------------------------------------------------------------------------

TP.sig.HTTPResponse.Inst.defineMethod('getResponseHeader',
function(headerName) {

    /**
     * @method getResponseHeader
     * @summary Returns the value of the named response header.
     * @param {String} headerName The HTTP header to return.
     * @returns {String|undefined}
     */

    var httpObj,
        header;

    httpObj = this.getNativeObject();
    if (TP.notValid(httpObj)) {
        return;
    }

    try {
        header = httpObj.getResponseHeader(headerName);
    } catch (e) {
        //  moz likes to toss its cookies rather than be sensible here when
        //  a header isn't found :(
        return;
    }

    return header;
});

//  ------------------------------------------------------------------------

TP.sig.HTTPResponse.Inst.defineMethod('getResponseHeaders',
function() {

    /**
     * @method getResponseHeaders
     * @summary Returns a hash containing all response header key/value pairs.
     * @returns {TP.core.Hash|undefined}
     */

    var httpObj,

        str,

        dict,
        arr,

        i,

        parts,
        key,
        value;

    httpObj = this.getNativeObject();
    if (TP.notValid(httpObj)) {
        return;
    }

    str = httpObj.getAllResponseHeaders();

    dict = TP.hc();
    arr = str.split('\n');

    for (i = 0; i < arr.getSize(); i++) {
        parts = arr.at(i).split(':');
        key = parts.shift();
        value = parts.join(':');

        if (TP.notEmpty(key)) {
            dict.atPut(key, value);
        }
    }

    return dict;
});

//  ------------------------------------------------------------------------

TP.sig.HTTPResponse.Inst.defineMethod('getResponseStatusCode',
function() {

    /**
     * @method getResponseStatusCode
     * @summary Returns the HTTP status code (200 for success) of the response.
     * @returns {Number|undefined} The status code.
     */

    var httpObj;

    httpObj = this.getNativeObject();
    if (TP.notValid(httpObj)) {
        return;
    }

    //  If the XHR mechanism has aborted in Mozilla, it will cause the
    //  '.status' property to throw an exception if it is read.
    try {
        return httpObj.status;
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'Error retrieving status code.')) : 0;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.HTTPResponse.Inst.defineMethod('getResponseStatusText',
function() {

    /**
     * @method getResponseStatusText
     * @summary Returns the status message (text) of the response.
     * @returns {String|undefined}
     */

    var httpObj;

    httpObj = this.getNativeObject();
    if (TP.notValid(httpObj)) {
        return;
    }

    try {
        return httpObj.statusText;
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'Error retrieving status text.')) : 0;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.HTTPResponse.Inst.defineMethod('getResponseText',
function() {

    /**
     * @method getResponseText
     * @summary Returns the response text.
     * @returns {String|undefined}
     */

    var httpObj,
        text;

    httpObj = this.getNativeObject();
    if (TP.notValid(httpObj)) {
        return;
    }

    try {
        text = httpObj.responseText;
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'Error retrieving response text.')) : 0;
    }

    return text;
});

//  ------------------------------------------------------------------------

TP.sig.HTTPResponse.Inst.defineMethod('getResponseXML',
function() {

    /**
     * @method getResponseXML
     * @summary Returns the DOM Node containing the response in XML form.
     * @returns {XMLDocument|undefined}
     */

    var xml,
        httpObj,
        url,
        text,

        xmlnsInfo,
        defaultNS;

    //  did we already build it? just return it
    if (TP.isNode(xml = this.$get('responseXML'))) {
        return xml;
    }

    httpObj = this.getNativeObject();
    if (TP.notValid(httpObj)) {
        return;
    }

    try {
        //  Moz needs to work from text to avoid tainting-related
        //  exceptions and other browsers mess with responseXML as well, so
        //  we just use the text.
        text = httpObj.responseText;

        if (TP.notEmpty(text)) {

            //  Try to guess the default XML namespace from the MIME type
            //  computed from the supplied text and URL.
            url = TP.uc(this.getRequest().at('finaluri'));
            if (TP.isValid(xmlnsInfo =
                            TP.w3.Xmlns.fromMIMEType(
                                TP.ietf.mime.guessMIMEType(text, url)))) {
                defaultNS = xmlnsInfo.at('uri');
            } else {
                defaultNS = null;
            }

            //  NOTE not everything we go after actually _is_ XML to tell
            //  the parse step to work quietly
            xml = TP.documentFromString(text, defaultNS, false);
        }
    } catch (e) {
        xml = null;
    }

    if (TP.isNode(xml)) {
        this.$set('responseXML', xml);
    }

    return xml;
});

//  ------------------------------------------------------------------------

TP.sig.HTTPResponse.Inst.defineMethod('getResult',
function(aFormat) {

    /**
     * @method getResult
     * @summary Returns the request result.
     * @description If a result type is specified in the responder's payload
     *     under the 'resultType' key, that is the result type used. Otherwise,
     *     by default it tries to return the XML representation, followed by the
     *     text representation if the XML can't be formed from the response. An
     *     explicit return type can be forced by supplying a format constant.
     * @param {Number} aFormat One of the TP constants for low-level result
     *     data: TP.DOM, TP.TEXT, or TP.NATIVE.
     * @returns {Object} The object in the requested format.
     */

    var format,
        result;

    format = aFormat;
    if (TP.notValid(format)) {
        format = this.at('resultType');
    }

    switch (format) {
        case TP.DOM:
            return this.getResponseXML();
        case TP.TEXT:
            return this.getResponseText();
        case TP.XHR:
        case TP.NATIVE:
            return this.getRequest().at('commObj');
        default:
            //  Default is to try to find the best object possible at the
            //  low level.
            result = this.$get('result');
            if (TP.notValid(result)) {
                result = this.getResponseXML();
            }

            if (TP.notValid(result)) {
                result = this.getResponseText();
            }
            return result;
    }
});

//  ========================================================================
//  TP.uri.HTTPService
//  ========================================================================

/**
 * @type {TP.uri.HTTPService}
 * @summary The top-level service for all services which use HTTP-based
 *     primitives for their transport layer. This service is capable of
 *     performing all the basic requirements of making XMLHttpRequest calls
 *     while offering several template methods that subtypes can override to
 *     perform service-specific adjustments to the overall request processing
 *     logic.
 */

//  ------------------------------------------------------------------------

TP.uri.URIService.defineSubtype('HTTPService');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  the default MIME type to use for encoding the body
TP.uri.HTTPService.Type.defineAttribute('mimetype', TP.PLAIN_TEXT_ENCODED);

//  the default method to use for services of this type
TP.uri.HTTPService.Type.defineAttribute('httpMethod', TP.HTTP_GET);

//  HTTP services can support access via either sync or async requests
TP.uri.HTTPService.Type.defineAttribute('supportedModes',
                                        TP.core.SyncAsync.DUAL_MODE);
TP.uri.HTTPService.Type.defineAttribute('mode',
                                        TP.core.SyncAsync.ASYNCHRONOUS);

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.uri.HTTPService.Inst.defineMethod('finalizeRequest',
function(aRequest) {

    /**
     * @method finalizeRequest
     * @summary Perform any final updates or processing on the request to make
     *     sure it is ready to send to TP.httpCall for processing.
     * @param {TP.sig.Request} aRequest The request being finalized.
     * @returns {TP.sig.HTTPRequest} The request to send. NOTE that this may not
     *     be the original request.
     */

    var mimetype,

        body,
        boundaryMarker,

        headers;

    mimetype = aRequest.at('mimetype');

    //  If the MIME type is set to be one of the 'multipart' encoding types
    //  that we support, then we need to grab the 'boundary' that will be
    //  found throughout the body, but we grab the one at the end surrounded
    //  by '--' and '--'.
    if (mimetype === TP.MP_RELATED_ENCODED ||
        mimetype === TP.MP_FORMDATA_ENCODED) {

        body = aRequest.at('body');
        boundaryMarker = /--([$\w]+)--/.match(body);

        headers = aRequest.at('headers');

        //  If we successfully got a boundary value, then add it to the
        //  'Content-Type' header.
        if (TP.isValid(boundaryMarker) && TP.notEmpty(boundaryMarker.at(1))) {
            headers.atPut('Content-Type',
                            TP.join(mimetype,
                                    '; boundary="',
                                    boundaryMarker.at(1),
                                    '"'));
        } else {
            headers.atPut('Content-Type', mimetype);
        }
    }

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.uri.HTTPService.Inst.defineMethod('getMIMEType',
function() {

    /**
     * @method getMIMEType
     * @summary Returns the MIME type this service uses for body encoding by
     *     default. This value is only used when a request does not specify a
     *     mimetype directly.
     * @returns {String} A constant suitable for TP.httpEncode.
     */

    return this.$get('mimetype') || this.getType().get('mimetype');
});

//  ------------------------------------------------------------------------

TP.uri.HTTPService.Inst.defineMethod('getHTTPMethod',
function() {

    /**
     * @method getHTTPMethod
     * @summary Returns the HTTP method used for this service type by default.
     *     In some cases this value isn't simply a default, it's the value used
     *     for all requests made via this service.
     * @returns {String} A TIBET HTTP method constant such as TP.HTTP_GET.
     */

    return this.$get('httpMethod') || this.getType().get('httpMethod');
});

//  ------------------------------------------------------------------------

TP.uri.HTTPService.Inst.defineHandler('HTTPRequest',
function(aRequest) {

    /**
     * @method handleHTTPRequest
     * @summary Constructs an appropriate response for the request provided,
     *     working to manage asynchronous calls in a manner consistent with the
     *     rest of the service/request/response model.
     * @param {TP.sig.HTTPRequest} aRequest The request whose parameters define
     *     the HTTP request.
     * @exception TP.sig.InvalidRequest
     * @exception TP.sig.InvalidURI
     * @returns {TP.sig.HTTPResponse|undefined} The service's response to the
     *     request.
     */

    var request,
        url,
        response;

    if (!TP.isKindOf(aRequest, 'TP.sig.HTTPRequest')) {
        this.raise('TP.sig.InvalidRequest');

        return;
    }

    //  If either a new 'serviceURI' parameter or a 'uri' parameter with an
    //  absolute path is supplied in the request, we reset our serviceURI to
    //  that value.
    this.updateServiceURI(aRequest);

    request = aRequest;

    //  start by rewriting the uri to target the proper concrete location
    request.atPut('uri', this.rewriteRequestURI(request));

    //  rewriting sometimes still fails to produce a viable url. when that
    //  happens the rewrite call will have signaled the error so we just
    //  fail the request.
    url = request.at('uri');
    if (TP.notValid(url)) {
        return request.fail('TP.sig.InvalidURI');
    }

    //  rewrite the method as needed. some services require POST etc.
    request.atPut('method', this.rewriteRequestMethod(request));

    //  rewrite the mode, whether we're async or sync. This will only change
    //  the value if it hasn't been set to something already, but it may
    //  warn when the value appears to be inconsistent with what the service
    //  is capable of processing.
    request.atPut('async', this.rewriteRequestMode(request));

    //  NOTE that we need to do this prior to the body processing
    request.atPut('mimetype', this.rewriteRequestMIMEType(request));

    //  rewrite/update the request body content
    request.atPut('body', this.rewriteRequestBody(request));

    //  Since we just encoded the body, we don't need to do it again.
    request.atPut('isencoded', true);

    //  rewrite/update the headers as needed for this service
    //  NOTE that we do this last so all body transformations are done in
    //  case we want to manipulate the headers based on body content
    request.atPut('headers', this.rewriteRequestHeaders(request));

    //  one last chance to tweak things before we ship it to the primitive
    //  and NOTE NOTE NOTE that we capture the return value here which
    //  allows the entire request to be reconstructed if necessary
    request = this.finalizeRequest(request);

    //  with all request tweaking in place we can now construct our
    //  response, which may have had the type/name altered by request
    //  rewriting
    response = request.getResponse();

    //  go ahead and perform the HTTP call
    this.performHTTPCall(request);

    //  we return a response specific to the request, but note that it may
    //  not be complete if the call was async
    return response;
});

//  ------------------------------------------------------------------------

TP.uri.HTTPService.Inst.defineMethod('performHTTPCall',
function(aRequest) {

    /**
     * @method performHTTPCall
     * @summary Performs the HTTP call. This is the method that actually does
     *     the work and can be overridden in subtypes of this type that have
     *     special types of HTTP calling semantics (WebDAV is a good example of
     *     this).
     * @param {TP.sig.HTTPRequest} aRequest The request whose parameters define
     *     the HTTP request.
     * @exception TP.sig.InvalidURI
     * @returns {TP.sig.HTTPRequest|undefined} The supplied request.
     */

    var url;

    //  Make sure we have a viable URL.
    url = aRequest.at('uri');
    if (TP.notValid(url)) {
        return aRequest.fail('TP.sig.InvalidURI');
    }

    try {
        //  TP.$httpWrapup() processing will call back to the request via
        //  handleIO* based on success/failure and the rest is handled
        //  there...see the request type's handleIO* methods for more
        TP.httpCall(url, aRequest);
    } catch (e) {
        aRequest.atPut('object', e);
        aRequest.atPut('message', TP.str(e));

        TP.httpError(url,
            TP.ifKeyInvalid(aRequest, 'exceptionType', 'HTTPException'),
            aRequest);
        return;
    }

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.uri.HTTPService.Inst.defineMethod('rewriteRequestBody',
function(aRequest) {

    /**
     * @method rewriteRequestBody
     * @summary Encodes the request body for transmission. Processing in this
     *     method makes use of keys in the request to drive a call to the
     *     TP.httpEncode() primitive. If you don't want this processing to occur
     *     you can put a key of 'noencode' with a value of true in the request.
     * @param {TP.sig.HTTPRequest} aRequest The request whose parameters define
     *     the HTTP request.
     * @returns {String|undefined} The string value of the encoded body content.
     */

    var body;

    body = aRequest.at('body');
    if (TP.notValid(body)) {
        return;
    }

    //  Use whatever the body object reports back as it's 'best HTTP value'
    body = body.asHTTPValue();
    aRequest.atPut('body', body);

    return TP.httpEncodeRequestBody(aRequest);
});

//  ------------------------------------------------------------------------

TP.uri.HTTPService.Inst.defineMethod('rewriteRequestMIMEType',
function(aRequest) {

    /**
     * @method rewriteRequestMIMEType
     * @summary Returns the MIME type this service uses for body encoding.
     * @param {TP.sig.HTTPRequest} aRequest The request to rewrite for.
     * @returns {String} A constant suitable for TP.httpEncode.
     */

    //  Return the MIME type using the following hierarchy:
    //      1.  The request's mimetype. If empty:
    //      2.  The service instance's mimetype. If empty:
    //      3.  The MIME type that can be guessed from the content and the URI,
    //          defaulting to the service type's mime type.
    return TP.ifEmpty(
            aRequest.at('mimetype'),
            TP.ifEmpty(
                this.$get('mimetype'),
                TP.ietf.mime.guessMIMEType(
                    aRequest.at('body'),
                    TP.uc(aRequest.at('uri')),
                    this.getType().get('mimetype'))
                )
            );
});

//  ------------------------------------------------------------------------

TP.uri.HTTPService.Inst.defineMethod('rewriteRequestHeaders',
function(aRequest) {

    /**
     * @method rewriteRequestHeaders
     * @summary Returns a TP.core.Hash of HTTP headers appropriate for the
     *     service.
     * @param {TP.sig.HTTPRequest} aRequest The request whose parameters define
     *     the HTTP request.
     * @returns {TP.core.Hash} The hash of rewritten request headers.
     */

    var headers,
        url;

    //  make sure we can define header values as needed to control the call
    headers = aRequest.at('headers');
    if (TP.notValid(headers)) {
        headers = TP.hc();
    }

    //  Make sure we have a viable URL.
    url = aRequest.at('uri');
    if (TP.notValid(url)) {
        return aRequest.fail('TP.sig.InvalidURI');
    }

    //  If there is no header defined for Content-Type in the request, use the
    //  MIME type that was determined for body encoding.
    headers.atPutIfAbsent('Content-Type', aRequest.at('mimetype'));

    return headers;
});

//  ------------------------------------------------------------------------

TP.uri.HTTPService.Inst.defineMethod('rewriteRequestMethod',
function(aRequest) {

    /**
     * @method rewriteRequestMethod
     * @summary Returns the HTTP method to use for the request. For many
     *     services the value in the request will be used, but some services
     *     force the method to be a specific one, such as XML-RPC where POST is
     *     a requirement.
     * @param {TP.sig.HTTPRequest} aRequest The request whose parameters define
     *     the HTTP request.
     * @returns {String} A TIBET HTTP method constant such as TP.HTTP_GET.
     */

    return TP.ifEmpty(aRequest.at('method'), this.getHTTPMethod());
});

//  ========================================================================
//  TP.sig.HTTPLoadRequest
//  ========================================================================

TP.sig.HTTPRequest.defineSubtype('HTTPLoadRequest');

//  ========================================================================
//  TP.sig.HTTPDeleteRequest
//  ========================================================================

TP.sig.HTTPRequest.defineSubtype('HTTPDeleteRequest');

//  ========================================================================
//  TP.sig.HTTPSaveRequest
//  ========================================================================

TP.sig.HTTPRequest.defineSubtype('HTTPSaveRequest');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETContentTypes.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

//  ========================================================================
//  TP.lang.Object Extensions
//  ========================================================================

TP.lang.Object.Type.defineMethod('constructContentObject',
function(content, aURI) {

    /**
     * @method constructContentObject
     * @summary Returns a content handler for the URI provided. This method is
     *     invoked as part of MIME-type specific handling for URIs.
     * @param {Object} content The content to set into the content object.
     * @param {TP.uri.URI} aURI The source URI. Ignored for this type.
     * @returns {Object} The object representation of the content.
     */

    return this.construct(content);
});

//  ========================================================================
//  TP.core.Selection
//  ========================================================================

/**
 * @type {TP.core.Selection}
 * @summary A type, usually added as a trait, that manages selection indexes.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.Selection');

//  can't construct concrete instances of this
TP.core.Selection.isAbstract(true);

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  An Array of indexes representing the selection
TP.core.Selection.Inst.defineAttribute('selectionIndexes');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.Selection.Inst.defineMethod('addSelectionIndexes',
function(newIndexes) {

    /**
     * @method addSelectionIndexes
     * @summary Adds the supplied index or indexes to the selection indexes for
     *     the receiver. Note that selection indexes are uniqued by this method,
     *     so repeated indexes will only be represented once.
     * @param {Number[]} newIndexes The indexes to add to the tracked selection
     *     indexes.
     * @returns {Number[]} An Array of numbers representing the selection
     *     indexes.
     */

    var indexes;

    indexes = this.get('selectionIndexes');

    //  Add all of the indexes from the supplied Array.
    indexes.addAll(newIndexes);

    //  Unique the indexes so that we don't have more than one represented.
    indexes.unique();

    return indexes;
});

//  ------------------------------------------------------------------------

TP.core.Selection.Inst.defineMethod('getSelectionIndex',
function() {

    /**
     * @method getSelectionIndex
     * @summary Return the index of the first item of the current selection.
     * @returns {Number} The first item's index.
     */

    var indexes;

    if (!TP.isArray(indexes = this.$get('selectionIndexes'))) {
        return TP.NO_SIZE;
    }

    return indexes.first();
});

//  ------------------------------------------------------------------------

TP.core.Selection.Inst.defineMethod('getSelectionIndexes',
function() {

    /**
     * @method getSelectionIndexes
     * @summary Return the indexes of the current selection.
     * @returns {Number[]} An Array of numbers representing the selection
     *     indexes.
     */

    var indexes;

    if (!TP.isArray(indexes = this.$get('selectionIndexes'))) {
        indexes = TP.ac();
        this.set('selectionIndexes', indexes, false);
    }

    return indexes;
});

//  ------------------------------------------------------------------------

TP.core.Selection.Inst.defineMethod('removeSelectionIndexes',
function(oldIndexes) {

    /**
     * @method removeSelectionIndexes
     * @summary Removes the supplied index or indexes from the selection indexes
     *     for the receiver.
     * @param {Number[]} oldIndexes The indexes to remove from the tracked
     *     selection indexes.
     * @returns {Number[]} An Array of numbers representing the selection
     *     indexes.
     */

    var indexes;

    indexes = this.get('selectionIndexes');

    //  Remove all of the indexes from the supplied Array.
    indexes.removeAll(oldIndexes);

    return indexes;
});

//  ========================================================================
//  TP.core.Content
//  ========================================================================

/**
 * @type {TP.core.Content}
 * @summary A content handler specific to the TP.core.Content format.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.Content');

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation
TP.core.Content.addTraits(TP.core.Selection);

//  This type's constructor functions to locate the best matching subtype.
TP.core.Content.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.Content.Type.defineMethod('constructContentObject',
function(content, aURI) {

    /**
     * @method constructContentObject
     * @summary Returns a content handler for the URI provided. This method is
     *     invoked as part of MIME-type specific handling for URIs.
     * @param {String} content The string content to process.
     * @param {TP.uri.URI} [aURI] The source URI.
     * @returns {Object} The object representation of the content.
     */

    return this.construct(content, aURI);
});

//  ------------------------------------------------------------------------

TP.core.Content.Type.defineMethod('getConcreteType',
function(content, aURI) {

    /**
     * @method getConcreteType
     * @summary Returns the type to use for a particular access path.
     * @param {Object} content The data to find a concrete type for.
     * @param {TP.uri.URI} [aURI] The source URI.
     * @returns {TP.meta.core.Content} A viable subtype for enclosing the
     *     content.
     */

    if (TP.isType(content)) {
        return TP.core.OpaqueContent;
    }

    if (TP.isNode(content) || TP.isKindOf(content, TP.dom.Node)) {
        return TP.core.XMLContent;
    }

    if (TP.core.XMLContent.canConstruct(content, aURI)) {
        return TP.core.XMLContent;
    }

    if (TP.core.CSSStyleSheetContent.canConstruct(content, aURI)) {
        return TP.core.CSSStyleSheetContent;
    }

    if (TP.core.JSONContent.canConstruct(content, aURI)) {
        return TP.core.JSONContent;
    }

    if (TP.isString(content) || TP.isFunction(content)) {
        return TP.core.TextContent;
    }

    return TP.core.OpaqueContent;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  A URI that is acting as our public reference
TP.core.Content.Inst.defineAttribute('$publicURI');

//  The source URI providing our data, if any.
TP.core.Content.Inst.defineAttribute('sourceURI');

//  The content's JavaScript representation
TP.core.Content.Inst.defineAttribute('data');

//  does this content act transactionally?
TP.core.Content.Inst.defineAttribute('transactional');

//  current checkpoint index, used by back/forward and getData to manage which
//  version of a transactional content object is current.
TP.core.Content.Inst.defineAttribute('currentIndex');

//  the snapshot stack when the receiver is using transactions
TP.core.Content.Inst.defineAttribute('snaps');

//  the checkpoint hash, used when the receiver is checkpointing
TP.core.Content.Inst.defineAttribute('points');

//  whether or not to create new structure on the receiver.
TP.core.Content.Inst.defineAttribute('buildout');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.Content.Type.defineMethod('fromString',
function(aString, aURI) {

    /**
     * @method fromString
     * @summary Returns a new instance from the string provided.
     * @param {Object} data The data to use for this content.
     * @param {TP.uri.URI} aURI The source URI.
     * @returns {TP.core.Content} A new instance.
     */

    return this.construct(aString, aURI);
});

//  ------------------------------------------------------------------------

TP.core.Content.Type.defineMethod('fromTP_core_Content',
function(aContent) {

    /**
     * @method fromTP_core_Content
     * @summary Returns the TP.core.Content object provided.
     * @param {TP.core.Content} aContent A content object.
     * @returns {TP.core.Content} The supplied object.
     */

    return this.construct(aContent.get('data'), aContent.get('sourceURI'));
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('init',
function(data, aURI) {

    /**
     * @method init
     * @summary Returns a newly constructed Object from inbound content.
     * @param {Object} data The data to use for this content.
     * @param {TP.uri.URI} aURI The source URI.
     * @returns {TP.core.Content} A new instance.
     */

    this.callNextMethod();

    this.set('sourceURI', aURI, false);
    this.set('data', data, false);

    //  Execute the data getter once just to get private data structures
    //  initialized.
    if (TP.isValid(data)) {
        this.get('data');
    }

    this.set('transactional', false, false);

    //  NB: buildout has a setter defined in XPath paths.
    this.set('buildout', false, false);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('addObserver',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method addObserver
     * @summary Adds a local signal observation which is roughly like a DOM
     *     element adding an event listener. The observer is typically the
     *     handler provided to an observe() call while the signal is a signal or
     *     string which the receiver is likely to signal or is intercepting for
     *     centralized processing purposes.
     * @param {Object|Object[]} anOrigin One or more origins to observe.
     * @param {Object|Object[]} aSignal One or more signals to observe from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn on observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to add the observation, false otherwise.
     */

    var facetFunctions;

    facetFunctions = this.$get('$facetFunctions');

    if (TP.isURI(aHandler) && TP.isEmpty(facetFunctions)) {
        this.setupFacetObservations();
        this.$set('$publicURI', aHandler, false);
    }

    return true;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('asString',
function() {

    /**
     * @method asString
     * @summary Returns the common string representation of the receiver.
     * @returns {String} The content object in string form.
     */

    return TP.str(this.get('data'));
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('asCleanString',
function(storageInfo) {

    /**
     * @method asCleanString
     * @summary Returns the 'clean' string representation of the receiver.
     *     This may have transformations in it to 'clean' the String, such as
     *     removing unnecessary namespace definitions, etc.
     * @param {TP.core.Hash} [storageInfo] A hash containing various flags for
     *     and results of the serialization process. Notable keys include:
     *          'wantsXMLDeclaration': Whether or not the receiver's document
     *          node should include an 'XML declaration' at the start of its
     *          serialization. The default is false.
     *          'wantsPrefixedXMLNSAttrs': Whether or not the receiver and its
     *          decendant elements should generate prefixed (i.e. 'xmlns:foo')
     *          attributes to support their proper serialization. The default is
     *          true.
     * @returns {String} The content object in clean string form.
     */

    //  At this level, we just return the String representation.
    return this.asString();
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('changed',
function(anAspect, anAction, aDescription) {

    /**
     * @method changed
     * @summary Notifies observers that some aspect of the receiver has
     *     changed. The fundamental data-driven dependency method.
     * @description We override this method at this level to tell the underlying
     *     data to signal a change.
     * @param {String} anAspect The aspect of the receiver that changed. This is
     *     usually an attribute name.
     * @param {String} anAction The action which caused the change. This usually
     *     'add', 'remove', etc.
     * @param {TP.core.Hash} aDescription A hash describing details of the
     *     change.
     * @returns {TP.core.Content} The receiver.
     * @fires Change
     */

    var srcURI,

        batchID,
        changedAddresses,
        changedPaths;

    //  NB: For new objects, this relies on 'undefined' being a 'falsey' value.
    //  We don't normally do this in TIBET, but this method is used heavily and
    //  is a hotspot.
    if (!this.shouldSignalChange()) {
        return this;
    }

    //  when a change has happened we need to adjust to the current index so
    //  things like a combination of a back() and a set() will throw away the
    //  data after the current data, but when the aspect is current index itself
    //  we skip this since what's happening is just a forward or back call
    //  shifting the current "visible" data
    if (TP.isEmpty(anAspect) || anAspect !== 'currentIndex') {
        this.discardCheckpointSnaps();
    }

    //  with possible snaps list adjustments we now need to update the name
    //  to index hash entries
    this.discardCheckpointNames();

    if (anAspect === 'currentIndex') {
        this.callNextMethod();
        this.$changed('value', TP.UPDATE);
    } else {
        if (TP.isValid(this.get('data'))) {

            //  We need this purely so that any machinery that relies on signal
            //  batching (i.e. the markup-based data binding) knows that this
            //  signal represents an entire batch.
            batchID = TP.genID('SIGNAL_BATCH');

            changedAddresses = TP.ac(anAspect);
            changedPaths = TP.hc(anAspect, TP.hc(TP.UPDATE, changedAddresses));

            TP.signal(this.getID(),
                        'TP.sig.ValueChange',
                        TP.hc('action', anAction,
                                'addresses', changedAddresses,
                                'aspect', anAspect,
                                'facet', 'value',
                                TP.CHANGE_PATHS, changedPaths,
                                'target', this,
                                TP.CHANGE_URIS, null,
                                TP.START_SIGNAL_BATCH, batchID,
                                TP.END_SIGNAL_BATCH, batchID));
        }

        srcURI = this.get('sourceURI');
        if (TP.isURI(srcURI)) {
            srcURI.isDirty(true, true);
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('copy',
function(deep, aFilterNameOrKeys, contentOnly) {

    /**
     * @method copy
     * @summary Returns a 'copy' of the receiver. Actually, a new instance
     *     whose value is equalTo that of the receiver.
     * @param {Boolean} [deep=false] True to force clones to be deep.
     * @param {String|String[]} aFilterNameOrKeys get*Interface() filter or key
     *     array.
     * @param {Boolean} [contentOnly=true] Copy content only?
     * @returns {TP.core.Content} A copy of the receiver.
     */

    var dataCopy,
        newinst;

    dataCopy = TP.copy(this.get('data'), deep, aFilterNameOrKeys, contentOnly);

    newinst = this.getType().construct(dataCopy, this.get('sourceURI'));

    //  NB: We do *not* copy '$publicURI' here

    newinst.$set('transactional', this.$get('transactional'), false);
    newinst.$set('currentIndex', this.$get('currentIndex'), false);
    newinst.$set('snaps', TP.copy(this.$get('snaps')), false);
    newinst.$set('points', TP.copy(this.$get('points')), false);

    return newinst;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('getData',
function() {

    /**
     * @method getData
     * @summary Returns the underlying data object.
     * @returns {Object} The receiver's underlying data object.
     */

    var ndx,
        data,
        snaps;

    if (!this.$get('transactional')) {
        return this.$get('data');
    }

    ndx = this.$get('currentIndex');
    snaps = this.$get('snaps');

    //  NOTE:   we use $get here since we don't want to recurse over
    //          getProperty() calls that use getNativeNode
    if (TP.isValid(ndx)) {
        data = snaps.at(ndx);
    } else {
        data = this.$get('data');
    }

    return data;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('$getEqualityValue',
function() {

    /**
     * @method $getEqualityValue
     * @summary Returns the value which should be used for testing equality
     *     for the receiver.
     * @returns {Object} A value appropriate for use in equality comparisons.
     */

    var data;

    data = this.get('data');

    if (TP.canInvoke(data, '$getEqualityValue')) {
        return data.$getEqualityValue();
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('getFacetedAspectNames',
function() {

    /**
     * @method getFacetedAspectNames
     * @summary Returns an Array of the names of the aspects that are faceted on
     *     the receiver.
     * @returns {String[]} A list of the names of aspects that are faceted on
     *     the receiver.
     */

    var aspectsToCheck,
        index;

    aspectsToCheck = this.callNextMethod();

    //  We want to filter out the 'data' slot
    if ((index = aspectsToCheck.indexOf('data')) !== TP.NOT_FOUND) {
        aspectsToCheck.splice(index, 1);
    }

    return aspectsToCheck;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('getNativeObject',
function(aRequest) {

    /**
     * @method getNativeObject
     * @summary Returns the underlying data object.
     */

    return this.getData();
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('getPathSource',
function(aPath) {

    /**
     * @method getPathSource
     * @summary Return the current source object being used by the executeGet()
     *     and executeSet() methods. At this level, this method returns the
     *     underlying data object.
     * @param {TP.path.AccessPath} aPath The path that the path source will be
     *     used with.
     * @returns {Object} The object used as the current path source object.
     */

    return this.$get('data');
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('getResource',
function(aRequest) {

    /**
     * @method getResource
     * @summary Returns the underlying data object.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An optional request object.
     * @returns {TP.sig.Response} A response for the request containing the
     *     receiver's data.
     */

    var request,
        response,
        data;

    request = TP.request(aRequest);
    response = request.getResponse();

    data = this.getData();

    request.complete(data);

    return response;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('getValue',
function() {

    /**
     * @method getValue
     * @summary Returns the 'value' of the receiver. For this type, this method
     *     returns the underlying data.
     * @returns {Object} The value of the receiver - in this case, it's 'data'.
     */

    return this.get('data');
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('getValidatingAspectNames',
function() {

    /**
     * @method getValidatingAspectNames
     * @summary Returns an Array of the names of the aspects to validate on the
     *     receiver.
     * @returns {String[]} A list of the names of aspects to validate on the
     *     receiver.
     */

    var aspectsToCheck,
        index;

    aspectsToCheck = this.callNextMethod();

    //  We want to filter out the 'data' slot
    if ((index = aspectsToCheck.indexOf('data')) !== TP.NOT_FOUND) {
        aspectsToCheck.splice(index, 1);
    }

    return aspectsToCheck;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('isEmpty',
function() {

    /**
     * @method isEmpty
     * @summary Returns whether or not the receiver is considered 'empty'.
     * @description For content objects, they are considered empty if their data
     *     is considered empty.
     * @returns {Boolean} Whether or not the receiver is empty.
     */

    return TP.isEmpty(this.getData());
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineHandler('Change',
function(aSignal) {

    /**
     * @method handleChange
     * @summary Handles changes to the receiver's resource.
     * @description Content objects listen for changes to their data objects and
     *     then, using their access path aliases, rebroadcast those changes to
     *     listeners.
     * @param {TP.sig.Change} aSignal The signal indicating a change has
     *     happened in the resource.
     * @returns {TP.core.Content} The receiver.
     */

    var sigName,
        payload,

        aspect,
        action,

        pathAspectAliases,
        aliasesLen,

        description,

        oldTarget,

        originID,

        i,

        aspectName,
        aspectSigName;

    payload = aSignal.getPayload();

    aspect = payload.at('aspect');

    action = payload.at('action');
    switch (action) {
        case TP.CREATE:
        case TP.INSERT:
        case TP.APPEND:

            //  CREATE, INSERT or APPEND means an 'insertion structural change'
            //  in the data.
            sigName = 'TP.sig.StructureInsert';
            break;

        case TP.DELETE:

            //  DELETE means a 'deletion structural change' in the data.
            sigName = 'TP.sig.StructureDelete';
            break;

        case TP.UPDATE:

            //  UPDATE means just a value changed.
            sigName = 'TP.sig.ValueChange';
            break;

        default:

            //  The default is the TP.sig.ValueChange signal.
            sigName = 'TP.sig.ValueChange';
            break;
    }

    pathAspectAliases = this.getAccessPathAliases(aspect);

    description = payload.copy();

    //  Because we want any querying of the signal's value to happen with *this*
    //  object as the query target, we grab the old target and put ourself in as
    //  the target.
    oldTarget = description.at('target');
    description.atPut('target', this);

    originID = this.getID();

    //  If we found any path aliases, then loop over them and dispatch
    //  using their aspect name.
    if (TP.isValid(pathAspectAliases)) {
        aliasesLen = pathAspectAliases.getSize();

        for (i = 0; i < aliasesLen; i++) {
            aspectName = pathAspectAliases.at(i);

            description.atPut('aspect', aspectName);

            aspectSigName = TP.makeStartUpper(aspectName) + 'Change';

            //  Note that we force the firing policy here. This allows observers
            //  of a generic Change to see 'aspect'Change notifications, even if
            //  those 'aspect'Change signals haven't been defined as being
            //  subtypes of Change.

            //  Also note how we supply either 'TP.sig.Change' (the top level
            //  for simple attribute changes) or one of the subtypes of
            //  'TP.sig.StructureChange' (the top level for structural changes,
            //  mostly used in 'path'ed attributes) as the default signal type
            //  here so that undefined aspect signals will use that type.
            TP.signal(originID, aspectSigName, description,
                        TP.INHERITANCE_FIRING, sigName);
        }
    } else {
        //  Otherwise send the generic signal.
        TP.signal(originID, sigName, description);
    }

    //  Restore the old target since we mucked with it.
    description.atPut('target', oldTarget);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('removeObserver',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method removeObserver
     * @summary Removes a local signal observation which is roughly like a DOM
     *     element adding an event listener. The observer is typically the
     *     handler provided to an observe call while the signal is a signal or
     *     string which the receiver is likely to signal or is intercepting for
     *     centralized processing purposes.
     * @param {Object|Object[]} anOrigin One or more origins to ignore.
     * @param {Object|Object[]} aSignal One or more signals to ignore from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn off observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to remove the observation, false otherwise.
     */

    if (TP.isURI(aHandler) && aHandler === this.$get('$publicURI')) {
        this.teardownFacetObservations();
        this.$set('$publicURI', null, false);
    }

    //  Always tell the notification to remove our handler, etc.
    return true;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('getAccessPathFor',
function(attributeName, facetName, originalPath) {

    /**
     * @method getAccessPathFor
     * @summary Returns any access path facet value, if any, for the attribute
     *     and facet provided. See the 'TP.sys.addMetadata()' call for more
     *     information about facets.
     * @param {String} attributeName The name of the attribute to get the access
     *     path facet value for.
     * @param {String} facetName The name of the facet to get the access path
     *     facet value for.
     * @param {TP.core.AccessPath} [originalPath] An optional access path that
     *     the attribute name might have been derived from. Sometimes it is
     *     useful to have access to the original path.
     * @returns {Object} Any access path value of the supplied facet of the
     *     supplied attribute. If there is no access path, this method returns
     *     null.
     */

    //  If we're trying to get or set the 'data', we always return the original
    //  path so that the get/set machinery will use this path instead of trying
    //  to use a custom getter/setter (which will return different results than
    //  what we desire for this slot).
    if (attributeName === 'data') {
        return originalPath;
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('getFacetedAspectNames',
function() {

    /**
     * @method getFacetedAspectNames
     * @summary Returns an Array of the names of the aspects that are faceted on
     *     the receiver.
     * @returns {String[]} A list of the names of aspects that are faceted on
     *     the receiver.
     */

    var aspects;

    if (TP.owns(this, '$$faceted_aspects')) {
        return this.$$faceted_aspects;
    }

    //  Gather whatever our supertype thinks we should have as aspect names that
    //  have facets.
    aspects = this.callNextMethod();

    //  We filter out aspect names that are used to track our internal data,
    //  while allowing ones that our subtypes might have defined.
    aspects = aspects.filter(
                function(anAspect) {
                    if (anAspect !== 'data' &&
                        anAspect !== '$publicURI' &&
                        anAspect !== 'sourceURI' &&
                        anAspect !== 'transactional' &&
                        anAspect !== 'currentIndex' &&
                        anAspect !== 'snaps' &&
                        anAspect !== 'points' &&
                        anAspect !== 'buildout') {
                        return true;
                    }

                    return false;
                });

    this.$$faceted_aspects = aspects;

    return aspects;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('removeRowsMatchingFrom',
function(aRowPath, aCollectionPath) {

    /**
     * @method removeRowsMatchingFrom
     * @summary Removes all rows of data matching the supplied row path from
     *     the target collection (which should be a subset of data contained
     *     in the receiver).
     * @param {TP.path.AccessPath} aRowPath The access path used to specify the
     *     'data row' to be removed.
     * @param {TP.path.AccessPath} aCollectionPath The access path used to
     *     specify the collection to remove the data row from.
     * @exception TP.sig.InvalidPath Raised if either supplied path is not an
     *     access Path
     * @returns {TP.core.Content} The receiver.
     */

    var result,
        targetCollection,

        indexes,

        len,
        i,

        collectionURI;

    if (!TP.isKindOf(aRowPath, TP.path.AccessPath) ||
        !TP.isKindOf(aCollectionPath, TP.path.AccessPath)) {
        return this.raise('TP.sig.InvalidPath');
    }

    result = aRowPath.executeGet(this);
    targetCollection = aCollectionPath.executeGet(this);

    //  Get the indexes from the collection of each item.
    indexes = TP.ac();

    len = result.getSize();
    for (i = 0; i < len; i++) {
        indexes.push(targetCollection.indexOf(result.at(i)));
    }

    collectionURI = TP.uc(TP.uriJoinFragments(
                            this.get('$publicURI').getPrimaryLocation(),
                            aCollectionPath.asString()));

    //  Remove the row with that index from the receiver.
    this.removeRowsFromAt(collectionURI, indexes);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('set',
function(attributeName, attributeValue, shouldSignal) {

    /**
     * @method set
     * @summary Sets the value of the named attribute to the value provided. If
     *     no value is provided the value null is used.
     * @description This is overridden from its supertype to automatically check
     *     facets after the value is set.
     * @param {String|TP.path.AccessPath} attributeName The name of the
     *     attribute to set.
     * @param {Object} attributeValue The value to set.
     * @param {Boolean} shouldSignal If false no signaling occurs. Defaults to
     *     this.shouldSignalChange().
     * @returns {TP.core.Content} The receiver.
     */

    var retVal,
        attrName;

    retVal = this.callNextMethod();

    //  This might be an access path
    attrName = TP.str(attributeName);

    //  If it's a JS identifier (i.e. simple path), then we can check its
    //  facets. Note here how we filter out attribute (i.e. aspect) names that
    //  are used to track our internal data, while allowing ones that our
    //  subtypes might have defined.
    if (TP.regex.JS_IDENTIFIER.test(attrName)) {
        if (attrName !== 'data' &&
            attrName !== '$publicURI' &&
            attrName !== 'sourceURI' &&
            attrName !== 'transactional' &&
            attrName !== 'currentIndex' &&
            attrName !== 'snaps' &&
            attrName !== 'points' &&
            attrName !== 'buildout') {

            //  We only do this if this instance attribute has a descriptor.
            if (TP.isValid(this.getType().getInstDescriptorFor(attrName))) {
                this.checkFacets(attrName);
            }
        }
    }

    return retVal;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('setContent',
function(aDataObject, shouldSignal) {

    /**
     * @method setContent
     * @summary Sets the receiver's data object to the supplied object.
     * @param {Object} aDataObject The object to set the receiver's internal
     *     data to.
     * @param {Boolean} [shouldSignal=false] Whether or not to signal change.
     * @returns {TP.core.Content} The receiver.
     */

    return this.setData(aDataObject, shouldSignal);
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('setData',
function(aDataObject, shouldSignal) {

    /**
     * @method setData
     * @summary Sets the receiver's data object to the supplied object.
     * @param {Object} aDataObject The object to set the receiver's internal
     *     data to.
     * @param {Boolean} [shouldSignal=false] Whether or not to signal change.
     * @returns {TP.core.Content} The receiver.
     */

    var oldDataObject;

    //  NB: We use '$get()' here because we want access to the real underlying
    //  object - subtypes and local objects might have reprogrammed 'getData()'
    //  to return other objects or have special handling logic.
    oldDataObject = this.$get('data');
    if (TP.isValid(oldDataObject) && TP.isMutable(oldDataObject)) {
        this.ignore(oldDataObject, 'Change');
    }

    this.$set('data', aDataObject, false);

    //  If the data object is mutable, then we observe it for change. NOTE: This
    //  will also 'turn on' change signaling for this object. That way, change
    //  signals will propagate 'up' from the data object, through us, to
    //  observers.
    if (TP.isMutable(aDataObject)) {
        this.observe(aDataObject, 'Change');
    } else {
        //  Otherwise, we manually turn on change signaling for this object.
        //  That way, change signals from our swapping out the non-mutable
        //  object that is our data will still inform any objects observing us.
        this.shouldSignalChange(true);
    }

    if (TP.notFalse(shouldSignal)) {

        //  Note that we do not use $changed here - we still let the data
        //  object decide whether it wants to send changed.
        //  TODO: Find out why this needs to be this way. If shouldSignal is
        //  true, we should be forcing change via $changed(). But changing that
        //  here causes all of the tests to break.
        this.changed('value', TP.UPDATE);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('setID',
function(anID) {

    /**
     * @method setID
     * @summary Sets the public ID of the receiver.
     * @param {String} anID The value to use as a public ID.
     * @returns {String} The ID that was set.
     */

    var dataObject,
        retVal;

    //  NB: We use '$get()' here because we want access to the real underlying
    //  object - subtypes and local objects might have reprogrammed 'getData()'
    //  to return other objects or have special handling logic.
    if (TP.isValid(dataObject = this.$get('data'))) {

        //  Ignore our data object under our 'old ID'
        this.ignore(dataObject, 'Change');

        //  Go ahead and get new ID assigned.
        retVal = this.callNextMethod();

        //  Observe our data object under our 'new ID'
        this.observe(dataObject, 'Change');
    } else {

        //  We have no data - just do whatever our supertype does.
        retVal = this.callNextMethod();
    }

    return retVal;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('setValue',
function(aValue, shouldSignal) {

    /**
     * @method setValue
     * @summary Sets the value of the receiver.
     * @param {Object} aValue The value to set the value of the receiver to.
     * @param {Boolean} shouldSignal Should changes be notified. If false
     *     changes are not signaled. Defaults to this.shouldSignalChange().
     * @returns {Boolean} Whether or not the value was changed from the value it
     *     had before this method was called.
     */

    var oldValue,
        flag;

    oldValue = this.get('data');

    this.set('data', aValue);

    //  NB: Use this construct this way for better performance
    if (TP.notValid(flag = shouldSignal)) {
        flag = this.shouldSignalChange();
    }

    if (flag) {
        this.$changed('content', TP.UPDATE,
                        TP.hc(TP.OLDVAL, oldValue, TP.NEWVAL, aValue));
    }

    return true;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('shouldSignalChange',
function(aFlag) {

    /**
     * @method shouldSignalChange
     * @summary Defines whether the receiver should actively signal change
     *     notifications.
     * @description In general objects do not signal changes when no observers
     *     exist. This flag is triggered by observe where the signal being
     *     observed is a form of Change signal to "arm" the object for change
     *     notification. You can also manipulate it during multi-step
     *     manipulations to signal only when a series of changes has been
     *     completed.
     * @param {Boolean} aFlag true/false signaling status.
     * @returns {Boolean} The current status.
     */

    var data,

        dataChanges,
        receiverChanges;

    data = this.get('data');

    if (TP.isValid(data)) {
        if (TP.canInvoke(data, 'shouldSignalChange')) {
            //  Note we can't do 'if (flag)' here because of its Boolean nature.
            if (arguments.length) {
                dataChanges = data.shouldSignalChange(aFlag);
            } else {
                dataChanges = data.shouldSignalChange();
            }
        }
    }

    receiverChanges = this.callNextMethod();

    return receiverChanges || dataChanges;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('toJSON',
function() {

    /**
     * @method toJSON
     * @summary Returns the object to use in JSON representations.
     * @returns {Object} The object to use in a JSON representation.
     */

    var data;

    data = this.getData();

    if (TP.canInvoke(data, 'toJSON')) {
        return data.toJSON();
    }

    return data;
});

//  ------------------------------------------------------------------------
//  CONTENT "TRANSACTIONS"
//  ------------------------------------------------------------------------

/*
Operations which form the core of the TP.core.Content "transaction" support
which allows content to serve as a model supporting undo/redo operations via
back/forward (temporary) and commit/rollback (permanent) methods.
*/

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('back',
function(aName) {

    /**
     * @method back
     * @summary Moves the receiver's current snapshot index back to the named
     *     checkpoint index, or by one checkpoint such that requests for
     *     information about the receiver resolve to that state. No checkpoints
     *     are removed and a forward() will undo the effect of this call --
     *     unless you alter the state of the snapshot after calling back().
     * @param {String} aName The name of a specific checkpoint to index to.
     *     Defaults to the prior checkpoint location.
     * @exception TP.sig.InvalidCheckpoint
     * @returns {TP.core.Content} The receiver.
     */

    var snaps,
        points,
        ndx;

    if (!this.getTransactional()) {
        return this;
    }

    if (TP.notValid(snaps = this.get('snaps'))) {
        //  if user thought there was a named checkpoint but we don't have any
        //  then we consider that an error
        if (TP.isString(aName)) {
            return this.raise('TP.sig.InvalidCheckpoint',
                'No active checkpoints have been made.');
        } else {
            //  if no name provided we can consider this a no-op
            return this;
        }
    }

    if (TP.notEmpty(aName)) {

        points = this.get('points');
        if (TP.notValid(points)) {
            //  if user thought there was a checkpoint but we don't have any
            //  then we consider that an error
            return this.raise('TP.sig.InvalidCheckpoint',
                'No active checkpoints have been named.');
        }

        ndx = points.at(aName);
        if (TP.notValid(ndx)) {
            return this.raise('TP.sig.InvalidCheckpoint',
                'Checkpoint ' + aName + ' not found.');
        }

    } else {

        //  decrement the index, but don't let it go below 0
        ndx = this.get('currentIndex');
        if (ndx === 0) {
            return this;
        } else if (TP.notValid(ndx)) {
            //  Set to the end of the snapshot list.
            ndx = snaps.getSize() - 1;
        }

        //  back up one index
        ndx = ndx - 1;
    }

    //  Make sure we're not backing up past the start of the list.
    ndx = ndx.max(0);

    //  if the value changes here a change notice will fire...
    this.set('currentIndex', ndx);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('checkpoint',
function(aName) {

    /**
     * @method checkpoint
     * @summary Checkpoints the current content, making it available for future
     *     rollback operations via either name or position.
     * @param {String} aName An optional name to assign to the checkpoint which
     *     can be supplied to rollback() calls.
     * @returns {Number} The number of checkpoints after the new checkpoint has
     *     been added.
     */

    var snaps,
        ndx,
        points;

    if (!this.getTransactional()) {
        return this;
    }

    //  if no snaps list yet then construct one so we can store the data
    if (TP.notValid(snaps = this.get('snaps'))) {
        snaps = TP.ac();
        this.$set('snaps', snaps, false);
    }

    //  here's a bit of a twist, if we checkpoint while looking at an indexed
    //  location we have to clear the rest of the list and remove any checkpoint
    //  name references to points later in the list
    if (TP.isNumber(ndx = this.get('currentIndex'))) {
        //  set length to trim off elements past the current index location,
        //  discarding their changes, this will cause the discardCheckpoint
        //  routine to consider checkpoints referencing indexes past that
        //  point to be invalid so they get removed
        snaps.length = ndx + 1;

        //  since we've adjusted the snaps list length we need to update the
        //  index reference data
        this.discardCheckpointNames();
    }

    //  are we naming this one?
    if (TP.notEmpty(aName)) {
        //  construct a hash for named checkpoint references
        if (TP.notValid(points = this.get('points'))) {
            points = TP.hc();
            this.$set('points', points, false);
        }

        //  correlate name with current 'end of list' index which points to
        //  the snaps just prior to cloning it to save state at the "old"
        //  location
        points.atPut(aName, snaps.getSize());
    }

    //  with the snaps list in shape we can now add the new data.
    snaps.add(this.snapshotData());

    //  clear the current index since we're essentially saying we want to
    //  operate at the current location and start to float with checkpoint
    //  state again
    this.set('currentIndex', null);

    return snaps.getSize();
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('commit',
function() {

    /**
     * @method commit
     * @summary Collapses the list of available snaps into a single committed
     *     copy of the receiver containing all changes made.
     * @returns {TP.core.Content} The receiver.
     */

    var data,
        snaps,
        points;

    if (!this.getTransactional()) {
        return this;
    }

    //  Get the data - if there were snapshots in place, this will get the data
    //  from the 'currently active' one.
    data = this.get('data');

    snaps = this.$get('snaps');
    if (TP.isValid(snaps)) {
        snaps.length = 1;
    }

    points = this.$get('points');
    if (TP.isValid(points)) {
        points.getKeys().forEach(
            function(point) {
                if (points.at(point) > 0) {
                    points.removeKey(point);
                }
            });
    }

    this.$set('currentIndex', 0, false);

    //  Note how we use the regular 'set()' call here (because we might want
    //  custom setter logic to run), but we don't signal change because, to all
    //  outward appearances, this is the same data.
    this.set('data', data, false);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('discardCheckpointSnaps',
function() {

    /**
     * @method discardCheckpointSnaps
     * @summary Flushes any stored checkpoint data after the current snapshot
     *     index. When using back() and forward() along with checkpoint,
     *     rollback, or any mutation operations this method will be called to
     *     clear the obsolete data itself.
     * @returns {TP.core.Content} The receiver.
     */

    var ndx,
        snaps;

    if (!this.getTransactional()) {
        return this;
    }

    if (TP.notValid(snaps = this.get('snaps'))) {
        //  no-op since we've never checkpointed
        return this;
    }

    //  when there's no index set there have been no back calls and so we're
    //  at the end, or a previous forward cleared it because we reached the
    //  end...
    if (TP.notValid(ndx = this.get('currentIndex'))) {
        return this;
    }

    //  we've got a valid index, which indicates where we're currently
    //  looking. we want to discard everything from that point on...
    snaps.length = ndx + 1;

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('discardCheckpointNames',
function() {

    /**
     * @method discardCheckpointNames
     * @summary Flushes any stored checkpoint names which come after the
     *     current snapshot list length.
     * @description When using back() and forward() along with checkpoint,
     *     rollback, or any mutation operations this method will be called to
     *     clear name references to indexes into the snaps list which no longer
     *     exist.
     * @returns {TP.core.Content} The receiver.
     */

    var snaps,
        points;

    if (!this.getTransactional()) {
        return this;
    }

    if (TP.notValid(snaps = this.get('snaps'))) {
        //  no-op since we've never checkpointed
        return this;
    }

    if (TP.isEmpty(snaps)) {
        //  when there are no snaps all points are invalid...
        this.set('points', null);
    } else if (TP.isArray(points = this.get('points'))) {
        //  clear out point references to non-existent entries
        points.perform(
            function(item) {

                if (item.last() > snaps.getSize() - 1) {
                    points.removeKey(item.first());
                }
            });
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('forward',
function(aName) {

    /**
     * @method forward
     * @summary Moves the receiver's current snapshot index forward to the named
     *     checkpoint index, or by one checkpoint such that requests for
     *     information about the receiver resolve to that state.
     * @param {String} aName The name of a specific checkpoint to index to.
     *     Defaults to the next checkpoint location available.
     * @exception TP.sig.InvalidCheckpoint
     * @returns {TP.core.Content} The receiver.
     */

    var snaps,
        ndx,
        points;

    if (!this.getTransactional()) {
        return this;
    }

    if (TP.notValid(snaps = this.get('snaps'))) {
        //  no-op since we've never checkpointed
        return this;
    }

    //  when there's no index set there have been no back calls and so we're
    //  at the end, or a previous forward cleared it because we reached the
    //  end...
    if (TP.notValid(ndx = this.get('currentIndex'))) {
        return this;
    }

    if (TP.notEmpty(aName)) {
        if (TP.notValid(points = this.get('points'))) {
            //  if user thought there was a checkpoint but we don't have
            //  any then we consider that an error
            return this.raise('TP.sig.InvalidCheckpoint',
                                'No active checkpoints have been named.');
        }

        ndx = points.at(aName);
        if (TP.notValid(ndx)) {
            return this.raise('TP.sig.InvalidCheckpoint',
                                'Checkpoint ' + aName + ' not found.');
        }

        //  this will trigger a change notice so observers can update
        this.set('currentIndex', ndx);
    } else {
        //  increment the index, but don't let it go off the end
        ndx = this.get('currentIndex') + 1;
        if (ndx < snaps.getSize()) {
            this.set('currentIndex', ndx);
        } else {
            //  if forward would go off the end then we'll reset so we
            //  start to float again. Note here how we do *not* signal change.
            this.set('currentIndex', null);
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('getTransactional',
function() {

    /**
     * @method getTransactional
     * @summary Returns whether the receiver has been told to support
     *     transactional behavior via checkpoint, commit, and rollback.
     * @returns {Boolean} The current transaction state, after any optional
     *     set() operation has occurred.
     */

    return this.$get('transactional');
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('hasCheckpoint',
function(aName) {

    /**
     * @method hasCheckpoint
     * @summary Looks up the named checkpoint and returns true if it exists.
     * @param {String} aName An optional name to look up.
     * @returns {Boolean} True if the receiver has the named checkpoint.
     */

    var points;

    if (!TP.isString(aName)) {
        return false;
    }

    if (TP.notValid(points = this.get('points'))) {
        return false;
    }

    return TP.isValid(points.at(aName));
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('rollback',
function(aName) {

    /**
     * @method rollback
     * @summary Rolls back changes made since the named checkpoint provided in
     *     the first parameter, or all changes if no checkpoint name is
     *     provided. Note that unlike 'back' this routine will discard any
     *     checkpoints after the target checkpoint.
     * @param {String} aName An optional name provided when a checkpoint call
     *     was made, identifying the specific point to roll back to.
     * @exception TP.sig.InvalidRollback
     * @returns {TP.core.Content} The receiver.
     */

    var snaps,
        points,
        ndx;

    if (!this.getTransactional()) {
        return this;
    }

    if (TP.notValid(snaps = this.get('snaps'))) {
        //  if user thought there was a named checkpoint but we don't have any
        //  then we consider that an error
        if (TP.isString(aName)) {
            return this.raise('TP.sig.InvalidCheckpoint',
                'No active checkpoints have been made.');
        } else {
            //  if no name provided we can consider this a no-op
            return this;
        }
    }

    points = this.get('points');
    if (TP.notEmpty(aName)) {

        if (TP.notValid(points)) {
            //  if user thought there was a checkpoint but we don't have any
            //  then we consider that an error
            return this.raise('TP.sig.InvalidCheckpoint',
                'No active checkpoints have been named.');
        }

        ndx = points.at(aName);
        if (TP.notValid(ndx)) {
            return this.raise('TP.sig.InvalidCheckpoint',
                'Checkpoint ' + aName + ' not found.');
        }

    } else {

        //  If no checkpoint name is provided then we're resetting to the
        //  initial snapshot.
        ndx = 0;
    }

    //  Make sure we're not backing up past the start of the list.
    ndx = ndx.max(0);

    //  throw away snapshots beyond the one we'll be adjusting to.
    snaps.length = ndx + 1;

    //  NOTE we also have to remove any named checkpoints which point to
    //  indexes beyond our current index.
    if (TP.isValid(points)) {
        points.getKeys().forEach(
            function(point) {
                if (points.at(point) > ndx) {
                    points.removeKey(point);
                }
            });
    }

    //  if the value changes here a change notice will fire...
    this.set('currentIndex', ndx);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('setTransactional',
function(aFlag) {

    /**
     * @method setTransactional
     * @summary Set whether the receiver has been told to support transactional
     *     behavior via checkpoint, commit, and rollback.
     * @param {Boolean} aFlag The state of the content's transaction flag, which
     *     will be set when provided.
     * @returns {TP.core.Content} The receiver.
     */

    if (TP.isTrue(this.$get('transactional'))) {

        if (!aFlag) {
            //  was transactional, clearing it now...

            //  TODO: check for unsaved changes etc...

            this.$set('snaps', null, false);
            this.$set('points', null, false);
            this.$set('currentIndex', null, false);
        }

    } else {

        if (aFlag) {
            //  wasn't transactional, turning it on...

            this.$set('transactional', aFlag, false);
            this.checkpoint();
        }
    }

    this.$set('transactional', aFlag, false);

    if (aFlag && !TP.sys.shouldUseContentCheckpoints()) {
        TP.ifWarn() ?
            TP.warn('Content transactions have been activated but ' +
                        'content is not being checkpointed.') : 0;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.Content.Inst.defineMethod('snapshotData',
function() {

    /**
     * @method snapshotData
     * @summary Returns a snapshot of the receiver's underlying data for use by
     *     the transactional data management routines of the receiver.
     * @returns {Object} The snapshot data.
     */

    return TP.override();
});

//  ========================================================================
//  TP.core.OpaqueContent
//  ========================================================================

/**
 */

//  ------------------------------------------------------------------------

TP.core.Content.defineSubtype('core.OpaqueContent');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.OpaqueContent.Type.defineMethod('canConstruct',
function(data, uri) {

    /**
     * @method canConstruct
     * @summary Returns true if the receiver can construct a valid instance
     *     given the parameters provided.
     * @param {String} data The content data in question.
     * @param {URI} uri The TIBET URI object which loaded the content.
     * @returns {Boolean} Whether or not an instance of this can be constructed
     *     from the parameters provided.
     */

    if (TP.regex.CONTAINS_CSS.test(data)) {
        return false;
    }

    if (TP.isJSONString.test(data)) {
        return false;
    }

    if (TP.isString.test(data)) {
        return false;
    }

    if (TP.isNode(data) || TP.isXMLString(TP.str(data))) {
        return false;
    }

    return true;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.OpaqueContent.Inst.defineMethod('asString',
function() {

    /**
     * @method asString
     * @summary Returns the common string representation of the receiver.
     * @returns {String} The content object in string form.
     */

    var data;

    data = this.get('data');

    if (TP.canInvoke(data, 'asJSONSource')) {
        return data.asJSONSource();
    }

    return TP.json(data);
});

//  ------------------------------------------------------------------------

TP.core.OpaqueContent.Inst.defineMethod('getContentMIMEType',
function() {

    /**
     * @method getContentMIMEType
     * @summary Returns the receiver's "content MIME type", the MIME type the
     *     content can render most effectively.
     * @returns {String} The content MIME type.
     */

    return TP.OCTET_ENCODED;
});

//  ========================================================================
//  TP.core.CSSStyleSheetContent
//  ========================================================================

/**
 */

//  ------------------------------------------------------------------------

TP.core.Content.defineSubtype('core.CSSStyleSheetContent');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.CSSStyleSheetContent.Type.defineMethod('canConstruct',
function(data, uri) {

    /**
     * @method canConstruct
     * @summary Returns true if the receiver can construct a valid instance
     *     given the parameters provided.
     * @param {String} data The content data in question.
     * @param {URI} uri The TIBET URI object which loaded the content.
     * @returns {Boolean} Whether or not an instance of this can be constructed
     *     from the parameters provided.
     */

    if (TP.regex.CONTAINS_CSS.test(data)) {
        return true;
    }

    //  Not all style sheets have actual content. Check the URI.
    if (TP.canInvoke(uri, 'getExtension')) {
        return uri.getExtension() === 'css';
    }
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.CSSStyleSheetContent.Inst.defineMethod('getContentMIMEType',
function() {

    /**
     * @method getContentMIMEType
     * @summary Returns the receiver's "content MIME type", the MIME type the
     *     content can render most effectively.
     * @returns {String} The content MIME type.
     */

    return TP.CSS_TEXT_ENCODED;
});

//  ========================================================================
//  TP.core.JSONContent
//  ========================================================================

/**
 * @type {TP.core.JSONContent}
 * @summary A content handler specific to the TP.core.JSONContent format.
 */

//  ------------------------------------------------------------------------

TP.core.Content.defineSubtype('core.JSONContent');

//  ------------------------------------------------------------------------

TP.definePrimitive('jsoncc',
function(data) {

    /**
     * @method jsoncc
     * @summary Returns a newly initialized JSONContent instance.
     * @param {Object} data The data to use for this content.
     * @returns {TP.core.JSONContent} The new instance.
     */

    return TP.core.JSONContent.construct(data);
});

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.JSONContent.Type.defineMethod('canConstruct',
function(data, uri) {

    /**
     * @method canConstruct
     * @summary Returns true if the receiver can construct a valid instance
     *     given the parameters provided.
     * @param {String|Object} data The content data in question.
     * @param {URI} uri The TIBET URI object which loaded the content.
     * @returns {Boolean} Whether or not an instance of this can be constructed
     *     from the parameters provided.
     */

    return TP.isJSONString(data) || TP.isPlainObject(data);
});

//  ------------------------------------------------------------------------

TP.core.JSONContent.Type.defineMethod('fromObject',
function(anObj) {

    /**
     * @method fromObject
     * @summary Constructs a new instance from the incoming object. The default
     *     implementation forwards to construct.
     * @description We override this method here because our inherited method
     *     treats POJOs as a 'description' of what the object should be rather
     *     than here, where we merely treat a POJO as a data object.
     * @param {Object} anObj The source object.
     * @returns {Object} A new instance of the receiver.
     */

    var newObj;

    newObj = this.construct.apply(this, arguments);

    return newObj;
});

//  ------------------------------------------------------------------------

TP.core.JSONContent.Type.defineMethod('validate',
function(anObject, includeFacetChecks) {

    /**
     * @method validate
     * @summary Returns true if the string parameter is valid
     *     TP.core.JSONContent.
     * @param {Object} anObject The object to test.
     * @param {Boolean} [includeFacetChecks=true] Whether or not to include
     *     'facet checks' or just do trivial checking to see if the data is even
     *     in the correct format for this content type.
     * @returns {Boolean} True if the object can be validated.
     */

    var anObj,
        str,

        isJSON;

    if (TP.notValid(anObj = anObject.get('data'))) {
        anObj = anObject;
    }

    //  First, check to make sure that it's even valid JSON. If it is, then call
    //  next method to check facets, etc.
    str = TP.js2json(anObj);
    isJSON = TP.isJSONString(str);

    if (isJSON && TP.notFalse(includeFacetChecks)) {
        return this.callNextMethod();
    }

    return isJSON;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.JSONContent.Inst.defineMethod('init',
function(data, aURI) {

    /**
     * @method init
     * @summary Returns a newly constructed Object from inbound content.
     * @param {Object} data The data to use for this content.
     * @param {TP.uri.URI} aURI The source URI.
     * @returns {TP.core.JSONContent} A new instance.
     */

    var contentData;

    contentData = data;

    if (TP.notValid(contentData)) {
        //  If the supplied content wasn't valid, then initialize our content
        //  with a blank POJO.
        contentData = {};
    }

    this.callNextMethod(contentData, aURI);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JSONContent.Inst.defineMethod('asHTTPValue',
function() {

    /**
     * @method asHTTPValue
     * @summary Returns the best value to be used for the receiver to send via
     *     HTTP.
     * @returns {String} The best value for HTTP sending.
     */

    return this.asJSONSource();
});

//  ------------------------------------------------------------------------

TP.core.JSONContent.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    //  Callers will be interested in our data, not the 'data' structure
    //  itself.
    return TP.json(this.get('data'));
});

//  ------------------------------------------------------------------------

TP.core.JSONContent.Inst.defineMethod('asString',
function() {

    /**
     * @method asString
     * @summary Returns the common string representation of the receiver.
     * @returns {String} The content object in string form.
     */

    return this.asJSONSource();
});

//  ------------------------------------------------------------------------

TP.core.JSONContent.Inst.defineMethod('getContentMIMEType',
function() {

    /**
     * @method getContentMIMEType
     * @summary Returns the receiver's "content MIME type", the MIME type the
     *     content can render most effectively.
     * @returns {String} The content MIME type.
     */

    return TP.JSON_ENCODED;
});

//  ------------------------------------------------------------------------

TP.core.JSONContent.Inst.defineMethod('getData',
function() {

    /**
     * @method getData
     * @summary Returns the underlying data object.
     * @returns {Object|undefined} The receiver's underlying data object.
     */

    var jsonData;

    jsonData = this.$get('data');

    //  If a String was handed in, it's probably JSON - try to convert it.
    if (TP.isString(jsonData) && TP.notEmpty(jsonData)) {

        //  NB: We pass false as the 2nd parameter to these TP.json2js calls to
        //  get a standard POJO (not TP.core.Hashes) from the JSON.

        jsonData = TP.json2js(jsonData, false);

        //  When first loading from server content the first pass can often
        //  return just a transformed string. If the first char of that is a
        //  curly brace we want to do a second pass.
        if (TP.isString(jsonData) && jsonData.charAt(0) === '{') {
            jsonData = TP.json2js(jsonData, false);
        }

        //  TP.json2js will raise for us.
        if (TP.notValid(jsonData)) {
            return;
        }

        this.set('data', jsonData, false);
    }

    return jsonData;
});

//  ------------------------------------------------------------------------

TP.core.JSONContent.Inst.defineMethod('getPathSource',
function(aPath) {

    /**
     * @method getPathSource
     * @summary Return the current source object being used by the executeGet()
     *     and executeSet() methods. At this level, this method returns the
     *     underlying data object.
     * @param {TP.path.AccessPath} aPath The path that the path source will be
     *     used with.
     * @returns {Object} The object used as the current path source object.
     */

    //  If we're going to be used with a JSONPath, then we are the path source -
    //  otherwise our data is.
    if (TP.isKindOf(aPath, TP.path.JSONPath)) {
        return this;
    }

    //  TODO: Put a warning here that this conversion should really only be used
    //  in 'get' operations using this path.

    return this.getData();
});

//  ------------------------------------------------------------------------

TP.core.JSONContent.Inst.defineHandler('CloneItem',
function(aSignal) {

    /**
     * @method handleCloneItem
     * @summary Handles when an item is to be cloned and inserted into the
     *     receiver's data.
     * @param {TP.sig.CloneItem} aSignal The signal instance which triggered
     *     this handler.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidURI
     * @returns {TP.core.JSONContent} The receiver.
     */

    var scope,
        scopeURI,

        source,

        index,

        targetElem;

    //  The 'scope' should be a URI location to find the overall collection to
    //  insert the item into. It should be either the whole collection
    //  representing the data of the receiver or a subcollection of that data.
    if (TP.isEmpty(scope = aSignal.at('scope'))) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  Make sure we can create a real URI from it.
    if (!TP.isURI(scopeURI = TP.uc(scope))) {
        return this.raise('TP.sig.InvalidURI');
    }

    source = TP.tpc(TP.str(aSignal.atIfInvalid('source', '[0]')));

    //  Grab the index if one was specified in the signal.
    index = aSignal.at('index');
    if (index === TP.TARGET) {

        //  If the index was 'TP.TARGET', then we're going to use the 'repeat
        //  index' of the target.
        targetElem = aSignal.at('trigger').getTarget();
        if (TP.isElement(targetElem)) {
            index = TP.wrap(targetElem).$getNearestRepeatIndex();
        }
    } else {
        //  Otherwise, if the index is a Number, then we use. If not, then we
        //  set it to null, instructing the insertion method just use the end of
        //  the collection
        index = parseInt(index, 10);
        if (TP.isNaN(index)) {
            index = null;
        }
    }

    //  Go ahead and insert the cloned data.
    this.insertRowIntoAt(
            scopeURI,
            source,
            index,
            aSignal.at('position'),
            true,
            true);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JSONContent.Inst.defineMethod('insertRowIntoAt',
function(aCollectionURIOrPath, aDataRowOrURIOrPath, anInsertIndex, aPosition,
         shouldClone, shouldEmpty) {

    /**
     * @method insertRowIntoAt
     * @summary Inserts a row of data into the collection as defined by the
     *     supplied collection URI. This collection should be either the whole
     *     collection representing the data of the receiver or a subcollection
     *     of that data.
     * @param {TP.uri.URI|TP.path.AccessPath} aCollectionURIOrPath The URI
     *     pointing to the collection to add the row to or a path that, in
     *     combination with the receiver's 'public facing' URI, can be used to
     *     obtain a collection to add the row to.
     * @param {Array|TP.uri.URI|TP.path.AccessPath} aDataRowOrURIOrPath The URI
     *     or path that points to data or the object itself to insert into the
     *     collection.
     * @param {Number} [anInsertIndex] The index to insert the item at in the
     *     collection. Note that this works with the supplied position to
     *     determine whether the insertion should happen before or after. If not
     *     specified, the item will be inserted at the end of the collection.
     * @param {String} [aPosition=TP.AFTER] A value of TP.BEFORE, TP.AFTER or
     *     null. This determines the position of the insertion. If no position
     *     is supplied, TP.AFTER is assumed.
     * @param {Boolean} [shouldClone=false] Whether or not to clone the data
     *     before inserting it. The default is false.
     * @param {Boolean} [shouldEmpty=false] Whether or not to empty any cloned
     *     data before inserting it. The default is false. NOTE: This parameter
     *     is only used if the shouldClone parameter is true.
     * @returns {TP.core.JSONContent} The receiver.
     */

    var targetURIOrPath,

        targetURI,
        publicURI,

        targetCollection,

        dataRow,

        keys,

        fragmentExpr,

        queryURI,

        insertIndex,

        changedAddresses,
        changedIndex,
        changedAspect,
        changedPaths,

        batchID;

    //  Obtain a URI that will be pointing at a collection.

    targetURIOrPath = aCollectionURIOrPath;
    publicURI = this.get('$publicURI');

    //  If targetURIOrPath is null or is not a TP.uri.URI (maybe its a
    //  path...), then set targetURI to publicURI (if its real).
    if (!TP.isURI(targetURIOrPath)) {

        //  publicURI isn't real - nothing to do here.
        if (!TP.isURI(publicURI)) {
            //  TODO: Raise exception
            return this;
        }

        targetURI = publicURI;
        if (targetURIOrPath.isAccessPath()) {
            //  NB: We assume 'async' of false here.
            targetCollection =
                targetURI.getResource(
                    TP.hc('async', false)).get('result').get(targetURIOrPath);

            //  Now, make sure that we're dealing with an Array
            if (!TP.isArray(targetCollection)) {
                targetCollection = TP.ac(targetCollection);
            }

            fragmentExpr = targetURIOrPath.asString();

        } else {
            //  Not a real path either.
            //  TODO: Raise exception
            return this;
        }

    } else {

        //  A URI was supplied to begin with.
        targetURI = targetURIOrPath;

        //  We should make sure that at least the primary URIs of the supplied
        //  URI and our source content URI are the same.
        if (targetURI.getPrimaryURI() !== publicURI.getPrimaryURI()) {
            //  TODO: Raise exception
            return this;
        }

        //  NB: We assume 'async' of false here.
        targetCollection = targetURI.getResource(
                            TP.hc('async', false,
                                    'shouldCollapse', false)).get('result');

        //  Now, make sure that we're dealing with an Array
        if (!TP.isArray(targetCollection)) {
            targetCollection = TP.ac(targetCollection);
        }

        fragmentExpr = targetURI.getFragmentExpr();
    }

    if (TP.isURI(aDataRowOrURIOrPath)) {
        //  NB: We assume 'async' of false here.
        dataRow = aDataRowOrURIOrPath.getResource(
                                TP.hc('async', false)).get('result');

    } else if (!TP.isPlainObject(aDataRowOrURIOrPath) &&
                aDataRowOrURIOrPath.isAccessPath()) {

        queryURI = aCollectionURIOrPath;

        if (!TP.isURI(queryURI)) {

            queryURI = publicURI;

            //  Neither aCollectionURIOrPath or publicURI isn't real - nothing
            //  to do here.
            if (!TP.isURI(queryURI)) {
                //  TODO: Raise exception
                return this;
            }
        }

        //  NB: We assume 'async' of false here.
        dataRow =
            queryURI.getResource(
                TP.hc('async', false)).get('result').get(aDataRowOrURIOrPath);

    } else {
        dataRow = aDataRowOrURIOrPath;
    }

    //  If we got a JSON content object, then we want it's data.
    if (TP.isKindOf(dataRow, TP.core.JSONContent)) {
        dataRow = dataRow.get('data');
    }

    if (TP.isTrue(shouldClone)) {

        dataRow = TP.copy(dataRow);

        if (TP.isTrue(shouldEmpty)) {
            if (TP.canInvoke(dataRow, 'clearTextContent')) {
                //  Clear out all of the 'text content' - that is, all of the
                //  scalar values in the newly cloned item. This will descend
                //  through the new item's data structure and cleanse it all of
                //  previous values.
                dataRow.clearTextContent();
            } else {
                keys = TP.keys(dataRow);
                keys.forEach(
                    function(aKey) {
                        dataRow[aKey] = '';
                    });
            }
        }
    }

    //  NB: The insertion index is computed to represent the row that will come
    //  *after* the new row after the insertion operation is complete (per
    //  'insertBefore()' semantics).

    if (TP.isNumber(insertIndex = anInsertIndex)) {
        insertIndex++;
    } else {

        //  No index specified - we will be manipulating the end of the
        //  collection.
        insertIndex = targetCollection.getSize();
    }

    //  TP.BEFORE was specified - subtract a position back off.
    if (aPosition === TP.BEFORE) {
        insertIndex--;
    }

    //  Splice it into the collection.
    targetCollection.splice(insertIndex, 0, dataRow);

    /* TODO: This doesn't seem to be necessary and it causes the resource in the
     * URI to change to be the collection, which is definitely wrong. At worst,
     * this should replace the URI's resource with a new instance of it's own
     * class ('this' is the content object and the URI's resource should be
     * another one). Review this.

    //  NB: We *must* reset the targetURI's resource here since we've modified
    //  it 'outside' of the normal set()/get() behavior and observers that are
    //  observing this object for changes will be depending on having a
    //  queryable structure when they receive their notification. Note also how
    //  we do *not* signal change when we set this value. We don't want those
    //  observers to trigger early, but instead use the richer notification
    //  they'll receive from the code below.
    targetURI.setResource(targetCollection, TP.request('signalChange', false));
    */

    //  The index that changed.
    changedIndex = insertIndex;

    //  The aspect that changed is just the collection along with the index that
    //  changed.
    changedAspect = fragmentExpr + '[' + changedIndex + ']';

    //  For these paths, the changed addresses are just an Array of the changed
    //  aspect.
    changedAddresses = TP.ac(changedAspect);

    //  Construct a 'changed paths' data structure that observers will expect to
    //  see.
    changedPaths = TP.hc(changedAspect, TP.hc(TP.INSERT, changedAddresses));

    //  We need this purely so that any machinery that relies on signal batching
    //  (i.e. the markup-based data binding) knows that this signal represents
    //  an entire batch.
    batchID = TP.genID('SIGNAL_BATCH');

    TP.signal(this.getID(),
                'TP.sig.StructureInsert',
                TP.hc('action', TP.INSERT,
                        'addresses', changedAddresses,
                        'aspect', changedAspect,
                        'facet', 'value',
                        TP.CHANGE_PATHS, changedPaths,
                        'target', this,
                        'indexes', TP.ac(changedIndex),
                        TP.CHANGE_URIS, null,
                        TP.START_SIGNAL_BATCH, batchID,
                        TP.END_SIGNAL_BATCH, batchID));

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JSONContent.Inst.defineMethod('removeRowsFromAt',
function(aCollectionURI, aDeleteIndex) {

    /**
     * @method removeRowsFromAt
     * @summary Removes a row of data from the collection as defined by the
     *     supplied collection URI. This collection should be either the whole
     *     collection representing the data of the receiver or a subcollection
     *     of that data.
     * @param {TP.uri.URI} aCollectionURI The URI pointing to the collection to
     *     remove the row from.
     * @param {Number|Number[]} aDeleteIndex The index(es) to remove the item
     *     from in the collection.
     * @returns {TP.core.JSONContent} The receiver.
     */

    var targetURI,
        publicURI,

        targetCollection,

        realArrayURI,

        deleteIndexes,

        removedData,

        changedAddresses,

        len,
        i,

        changedAspect,
        changedPaths,

        batchID;

    targetURI = aCollectionURI;

    //  If targetURI is null or is not a TP.uri.URI, then set it to the
    //  receiver's publicURI (if its real).
    if (!TP.isURI(targetURI)) {
        publicURI = this.get('$publicURI');

        //  publicURI isn't real - nothing to do here.
        if (!TP.isURI(publicURI)) {
            //  TODO: Raise exception
            return this;
        }

        targetURI = publicURI;
    }

    //  If the supplied URI really resolves to an Array, then remove the proper
    //  row.

    //  NB: We assume 'async' of false here. We also want to make sure that we
    //  don't collapse results, since what we're looking for is an Array.
    targetCollection = targetURI.getResource(
                                TP.hc('async', false,
                                        'shouldCollapse', false)).get('result');

    if (!TP.isArray(targetCollection)) {
        realArrayURI = targetURI.getSuperURIWithResourceType(Array);
        targetCollection = realArrayURI.getResource(
                                TP.hc('async', false,
                                        'shouldCollapse', false)).get('result');
    } else {
        realArrayURI = targetURI;
    }

    if (TP.isArray(targetCollection)) {

        //  If a deletion index was supplied or we have numbers in our selection
        //  indexes, then use those as the deletion indexes.
        if (TP.isNumber(deleteIndexes = aDeleteIndex)) {
            deleteIndexes = TP.ac(aDeleteIndex);
        } else if (TP.isArray(aDeleteIndex)) {
            deleteIndexes = aDeleteIndex;
        } else if (TP.notEmpty(deleteIndexes = this.get('selectionIndexes'))) {
            //  empty
        } else {
            deleteIndexes = TP.ac(targetCollection.getSize() - 1);
        }

        //  If we have an Array of deletion indexes, use a TIBET convenience
        //  method.
        if (TP.isArray(deleteIndexes)) {
            removedData = targetCollection.atAll(deleteIndexes);
            targetCollection.removeAtAll(deleteIndexes);
        } else {
            removedData = targetCollection.splice(deleteIndexes, 1);
        }

    } else {
        //  Allocate and push 0 separately to avoid oldtime JS behavior around
        //  an Array with a single Number as its argument.
        deleteIndexes = TP.ac();
        deleteIndexes.push(0);
    }

    changedAddresses = TP.ac();

    len = deleteIndexes.getSize();
    for (i = 0; i < len; i++) {
        //  The aspect that changed is just the collection along with the index
        //  that changed.
        changedAspect = realArrayURI.getFragmentExpr() +
                        '[' + deleteIndexes.at(i) + ']';

        //  For these paths, the changed addresses are just an Array of the
        //  changed aspect.
        changedAddresses.push(changedAspect);
    }

    //  Just set the changed aspect to the first address that changed -
    //  observers can dig into the changedAddresses Array to find out exactly
    //  which aspects changed if more than 1 did.
    changedAspect = changedAddresses.first();

    //  Construct a 'changed paths' data structure that observers will expect to
    //  see.
    changedPaths = TP.hc(changedAspect, TP.hc(TP.DELETE, changedAddresses));

    //  We need this purely so that any machinery that relies on signal batching
    //  (i.e. the markup-based data binding) knows that this signal represents
    //  an entire batch.
    batchID = TP.genID('SIGNAL_BATCH');

    TP.signal(this.getID(),
                'TP.sig.StructureDelete',
                TP.hc('action', TP.DELETE,
                        'addresses', changedAddresses,
                        'aspect', changedAspect,
                        'facet', 'value',
                        TP.CHANGE_PATHS, changedPaths,
                        'target', this,
                        'indexes', deleteIndexes,
                        'removedData', removedData,
                        TP.CHANGE_URIS, null,
                        TP.START_SIGNAL_BATCH, batchID,
                        TP.END_SIGNAL_BATCH, batchID));

    return this;
});

//  ------------------------------------------------------------------------

TP.core.JSONContent.Inst.defineMethod('snapshotData',
function() {

    /**
     * @method snapshotData
     * @summary Returns a snapshot of the receiver's underlying data for use by
     *     the transactional data management routines of the receiver.
     * @returns {Object} The snapshot data.
     */

    var data;

    data = TP.js2json(this.getData());

    //  NB: We pass false as the 2nd parameter to this TP.json2js call to get a
    //  standard POJO (not TP.core.Hashes) from the JSON.
    data = TP.json2js(data, false);

    return data;
});

//  ========================================================================
//  TP.core.TextContent
//  ========================================================================

/**
 */

//  ------------------------------------------------------------------------

TP.core.Content.defineSubtype('core.TextContent');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.TextContent.Type.defineMethod('canConstruct',
function(data, uri) {

    /**
     * @method canConstruct
     * @summary Returns true if the receiver can construct a valid instance
     *     given the parameters provided.
     * @param {String} data The content data in question.
     * @param {URI} uri The TIBET URI object which loaded the content.
     * @returns {Boolean} Whether or not an instance of this can be constructed
     *     from the parameters provided.
     */

    return TP.isString(data);
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.TextContent.Inst.defineMethod('getContentMIMEType',
function() {

    /**
     * @method getContentMIMEType
     * @summary Returns the receiver's "content MIME type", the MIME type the
     *     content can render most effectively.
     * @returns {String} The content MIME type.
     */

    return TP.PLAIN_TEXT_ENCODED;
});

//  ========================================================================
//  TP.core.XMLContent
//  ========================================================================

/**
 * @type {TP.core.XMLContent}
 * @summary A content handler specific to the TP.core.XMLContent format.
 */

//  ------------------------------------------------------------------------

TP.core.Content.defineSubtype('core.XMLContent');

//  ------------------------------------------------------------------------

TP.definePrimitive('xmlcc',
function(data, aURI) {

    /**
     * @method xmlcc
     * @summary Returns a newly initialized XMLContent instance.
     * @param {Object} data The data to use for this content.
     * @param {TP.uri.URI|String} aURI The source URI.
     * @returns {TP.core.XMLContent} The new instance.
     */

    return TP.core.XMLContent.construct(data, aURI);
});

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.XMLContent.Type.defineMethod('canConstruct',
function(data, uri) {

    /**
     * @method canConstruct
     * @summary Returns true if the receiver can construct a valid instance
     *     given the parameters provided.
     * @param {String} data The content data in question.
     * @param {URI} uri The TIBET URI object which loaded the content.
     * @returns {Boolean} Whether or not an instance of this can be constructed
     *     from the parameters provided.
     */

    return TP.isNode(data) || TP.isXMLString(TP.str(data));
});

//  ------------------------------------------------------------------------

TP.core.XMLContent.Type.defineMethod('validate',
function(anObject, includeFacetChecks) {

    /**
     * @method validate
     * @summary Returns true if the string parameter is valid
     *     TP.core.XMLContent.
     * @param {Object} anObject The object to test.
     * @param {Boolean} [includeFacetChecks=true] Whether or not to include
     *     'facet checks' or just do trivial checking to see if the data is even
     *     in the correct format for this content type.
     * @returns {Boolean} True if the object can be validated.
     */

    var anObj,
        str,

        isNode;

    if (TP.notValid(anObj = anObject.get('data'))) {
        anObj = anObject;
    }

    //  First, check to make sure that it's even valid XML. If it is, then call
    //  next method to check facets, etc.
    str = TP.str(anObj);
    isNode = TP.isNode(TP.node(str));

    if (isNode && TP.notFalse(includeFacetChecks)) {
        return this.callNextMethod();
    }

    return isNode;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.XMLContent.Inst.defineMethod('init',
function(data, aURI) {

    /**
     * @method init
     * @summary Returns a newly constructed Object from inbound content.
     * @param {Object} data The data to use for this content.
     * @param {TP.uri.URI} aURI The source URI.
     * @returns {TP.core.XMLContent} A new instance.
     */

    var contentData;

    contentData = data;

    if (TP.isKindOf(contentData, TP.dom.Node)) {
        contentData = contentData.getNativeNode();
    } else if (TP.notValid(contentData)) {
        //  If the supplied content wasn't valid, then initialize our content
        //  with a blank TP.dom.DocumentNode.
        contentData = TP.tpdoc();
    }

    this.callNextMethod(contentData, aURI);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.XMLContent.Inst.defineMethod('getPathSource',
function(aPath) {

    /**
     * @method getPathSource
     * @summary Return the current source object being used by the executeGet()
     *     and executeSet() methods. At this level, this method returns the
     *     underlying data object.
     * @param {TP.path.AccessPath} aPath The path that the path source will be
     *     used with.
     * @returns {Object} The object used as the current path source object.
     */

    //  If we're going to be used with a XMLPath, then we are the path source -
    //  otherwise our data is.
    if (TP.isKindOf(aPath, TP.path.XMLPath)) {
        return this;
    }

    //  TODO: Put a warning here that this conversion should really only be used
    //  in 'get' operations using this path.

    return this.getData();
});

//  ------------------------------------------------------------------------

TP.core.XMLContent.Inst.defineHandler('CloneItem',
function(aSignal) {

    /**
     * @method handleCloneItem
     * @summary Handles when an item is to be cloned and inserted into the
     *     receiver's data.
     * @param {TP.sig.CloneItem} aSignal The signal instance which triggered
     *     this handler.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidURI
     * @returns {TP.core.XMLContent} The receiver.
     */

    var scope,
        scopeURI,

        source,

        index,

        targetElem;

    //  The 'scope' should be a URI location to find the overall collection to
    //  insert the item into. It should be either the whole collection
    //  representing the data of the receiver or a subcollection of that data.
    if (TP.isEmpty(scope = aSignal.at('scope'))) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  Make sure we can create a real URI from it.
    if (!TP.isURI(scopeURI = TP.uc(scope))) {
        return this.raise('TP.sig.InvalidURI');
    }

    source = aSignal.at('source');
    if (TP.notEmpty(source)) {
        source = TP.str(source.unquoted());
        source = TP.xpc(source);
    } else {
        source = TP.tpc(TP.str(aSignal.atIfInvalid('source', '[0]')));
    }

    //  Grab the index if one was specified in the signal.
    index = aSignal.at('index');
    if (index === TP.TARGET) {

        //  If the index was 'TP.TARGET', then we're going to use the 'repeat
        //  index' of the target.
        targetElem = aSignal.at('trigger').getTarget();
        if (TP.isElement(targetElem)) {
            index = TP.wrap(targetElem).$getNearestRepeatIndex();
        }
    } else {
        //  Otherwise, if the index is a Number, then we use. If not, then we
        //  set it to null, instructing the insertion method just use the end of
        //  the collection
        index = parseInt(index, 10);
        if (TP.isNaN(index)) {
            index = null;
        }
    }

    //  Go ahead and insert the cloned data.
    this.insertRowIntoAt(
            scopeURI,
            source,
            index,
            aSignal.at('position'),
            true,
            true);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.XMLContent.Inst.defineMethod('insertRowIntoAt',
function(aCollectionURIOrPath, aDataRowOrURIOrPath, anInsertIndex, aPosition,
         shouldClone, shouldEmpty) {

    /**
     * @method insertRowIntoAt
     * @summary Inserts a row of data into the collection as defined by the
     *     supplied collection URI. This collection should be either the whole
     *     collection representing the data of the receiver or a subcollection
     *     of that data.
     * @param {TP.uri.URI|TP.path.AccessPath} aCollectionURIOrPath The URI
     *     pointing to the collection to add the row to or a path that, in
     *     combination with the receiver's 'public facing' URI, can be used to
     *     obtain a collection to add the row to.
     * @param {Array|TP.uri.URI|TP.path.AccessPath} aDataRowOrURIOrPath The URI
     *     or path that points to data or the object itself to insert into the
     *     collection.
     * @param {Number} [anInsertIndex] The index to insert the item at in the
     *     collection. Note that this works with the supplied position to
     *     determine whether the insertion should happen before or after. If not
     *     specified, the item will be inserted at the end of the collection.
     * @param {String} [aPosition=TP.AFTER] A value of TP.BEFORE, TP.AFTER or
     *     null. This determines the position of the insertion. If no position
     *     is supplied, TP.AFTER is assumed.
     * @param {Boolean} [shouldClone=false] Whether or not to clone the data
     *     before inserting it. The default is false.
     * @param {Boolean} [shouldEmpty=false] Whether or not to empty any cloned
     *     data before inserting it. The default is false. NOTE: This parameter
     *     is only used if the shouldClone parameter is true.
     * @returns {TP.core.XMLContent} The receiver.
     */

    var targetURIOrPath,

        targetURI,
        publicURI,

        targetCollection,

        dataRow,

        fragmentExpr,

        queryURI,

        insertIndex,

        insertionNode,

        insertionPath,

        newTPNode,

        changedAddresses,
        changedIndex,
        changedAspect,
        changedPaths,

        batchID;

    //  Obtain a URI that will be pointing at a collection.

    targetURIOrPath = aCollectionURIOrPath;
    publicURI = this.get('$publicURI');

    //  If targetURIOrPath is null or is not a TP.uri.URI (maybe its a
    //  path...), then set targetURI to publicURI (if its real).
    if (!TP.isURI(targetURIOrPath)) {

        //  publicURI isn't real - nothing to do here.
        if (!TP.isURI(publicURI)) {
            //  TODO: Raise exception
            return this;
        }

        targetURI = publicURI;
        if (targetURIOrPath.isAccessPath()) {
            //  NB: We assume 'async' of false here.
            targetCollection =
                targetURI.getResource(
                    TP.hc('async', false)).get('result').get(targetURIOrPath);

            //  Now, make sure that we're dealing with an Array
            if (!TP.isArray(targetCollection)) {
                targetCollection = TP.ac(targetCollection);
            }

            fragmentExpr = targetURIOrPath.asString();

        } else {
            //  Not a real path either.
            //  TODO: Raise exception
            return this;
        }

    } else {

        //  A URI was supplied to begin with.
        targetURI = targetURIOrPath;

        //  We should make sure that at least the primary URIs of the supplied
        //  URI and our source content URI are the same.
        if (targetURI.getPrimaryURI() !== publicURI.getPrimaryURI()) {
            //  TODO: Raise exception
            return this;
        }

        //  Make sure that we have a TP.dom.CollectionNode

        //  NB: We assume 'async' of false here.
        targetCollection = targetURI.getResource(
                            TP.hc('resultType', TP.WRAP,
                                    'async', false,
                                    'shouldCollapse', false)).get('result');

        if (!TP.isArray(targetCollection)) {
            targetCollection = TP.ac(targetCollection);
        }

        fragmentExpr = targetURI.getFragmentExpr();
    }

    if (TP.isURI(aDataRowOrURIOrPath)) {
        //  NB: We assume 'async' of false here.
        dataRow = aDataRowOrURIOrPath.getResource(
                                TP.hc('async', false)).get('result');

    } else if (aDataRowOrURIOrPath.isAccessPath()) {

        queryURI = aCollectionURIOrPath;

        if (!TP.isURI(queryURI)) {

            queryURI = publicURI;

            //  Neither aCollectionURIOrPath or publicURI isn't real - nothing
            //  to do here.
            if (!TP.isURI(queryURI)) {
                //  TODO: Raise exception
                return this;
            }
        }

        //  NB: We assume 'async' of false here.
        dataRow =
            queryURI.getResource(
                TP.hc('async', false)).get('result').get(aDataRowOrURIOrPath);

    } else {
        dataRow = aDataRowOrURIOrPath;
    }

    //  If we got a XML content object, then we want it's data.
    if (TP.isKindOf(dataRow, TP.core.XMLContent)) {
        dataRow = dataRow.get('data');
    }

    dataRow = TP.wrap(dataRow);

    if (TP.isTrue(shouldClone)) {

        //  Get the item to clone and clone it.
        dataRow = dataRow.clone(true);

        if (TP.isTrue(shouldEmpty)) {
            //  Clear out all of the 'text content' - that is, all of the scalar
            //  values in the newly cloned item. This will descend through the
            //  new item's data structure and cleanse it all of previous values.
            dataRow.clearTextContent();
        }
    }

    //  NB: The insertion index is computed to represent the row that will come
    //  *after* the new row after the insertion operation is complete (per
    //  'insertBefore()' semantics).

    if (TP.isNumber(insertIndex = anInsertIndex)) {

        if (aPosition !== TP.BEFORE) {
            insertIndex++;
        }

        insertionPath = './*[' + insertIndex + ']';

    } else {

        //  No index specified - we will be manipulating the end of the
        //  collection.
        if (aPosition === TP.BEFORE) {
            insertionPath = './*[last()]';
            insertIndex = targetCollection.getSize();
        } else {
            //  Add one because the collection size isn't taking our new size
            //  into account.
            insertIndex = targetCollection.getSize() + 1;
        }
    }

    insertionNode = targetCollection.first().getParentNode();

    //  If the insertion path is not empty, that means that we're not just
    //  appending to the end.
    if (TP.notEmpty(insertionPath)) {
        newTPNode = insertionNode.insertRawContent(
                            dataRow, insertionPath, null, false);
    } else {
        //  We're just appending to the end.
        newTPNode = insertionNode.addRawContent(
                            dataRow, null, false);
    }

    //  Grab the address of the node that changed.
    changedAddresses = TP.ac(newTPNode.getDocumentPosition());

    //  And the index that changed.
    changedIndex = insertIndex;

    //  The aspect that changed is just the collection along with the
    //  index that changed.
    changedAspect = fragmentExpr + '[' + changedIndex + ']';

    //  Construct a 'changed paths' data structure that observers will expect to
    //  see.
    changedPaths = TP.hc(changedAspect, TP.hc(TP.INSERT, changedAddresses));

    //  We need this purely so that any machinery that relies on signal batching
    //  (i.e. the markup-based data binding) knows that this signal represents
    //  an entire batch.
    batchID = TP.genID('SIGNAL_BATCH');

    TP.signal(this.getID(),
                'TP.sig.StructureInsert',
                TP.hc('action', TP.INSERT,
                        'addresses', changedAddresses,
                        'aspect', changedAspect,
                        'facet', 'value',
                        TP.CHANGE_PATHS, changedPaths,
                        'target', this,
                        'indexes', TP.ac(changedIndex),
                        TP.CHANGE_URIS, null,
                        TP.START_SIGNAL_BATCH, batchID,
                        TP.END_SIGNAL_BATCH, batchID));

    return this;
});

//  ------------------------------------------------------------------------

TP.core.XMLContent.Inst.defineMethod('getContentMIMEType',
function() {

    /**
     * @method getContentMIMEType
     * @summary Returns the receiver's "content MIME type", the MIME type the
     *     content can render most effectively.
     * @returns {String} The content MIME type.
     */

    return TP.XML_ENCODED;
});

//  ------------------------------------------------------------------------

TP.core.XMLContent.Inst.defineMethod('getData',
function() {

    /**
     * @method getData
     * @summary Returns the underlying data object.
     * @returns {Object|undefined} The receiver's underlying data object.
     */

    var xmlData,

        uri,

        newData,

        defaultNS,
        mimeType,
        nsEntry;

    xmlData = this.callNextMethod();

    uri = this.get('sourceURI');

    newData = false;

    if (TP.isString(xmlData) && TP.notEmpty(xmlData)) {

        defaultNS = null;

        //  Try to determine a default namespace based on the extension of the
        //  URI.
        if (TP.notEmpty(uri)) {

            //  Guess the MIME type based on the data and the URI
            mimeType = TP.ietf.mime.guessMIMEType(xmlData, uri);

            //  Try to get a 'namespace entry' from that. The namespace URI can
            //  be found under 'uri'.
            nsEntry = TP.w3.Xmlns.fromMIMEType(mimeType);
            if (TP.isValid(nsEntry)) {
                defaultNS = nsEntry.at('uri');
            }
        }

        //  TP.tpdoc() will raise for us if we supply 'true' as the 3rd
        //  parameter.
        xmlData = TP.tpdoc(xmlData, defaultNS, true);

        if (TP.notValid(xmlData)) {
            return;
        }

        newData = true;
    } else if (TP.isNode(xmlData)) {
        xmlData = TP.wrap(xmlData);
        newData = true;
    }

    if (newData) {
        //  If we have a valid URI, set the underlying XML wrapper node's 'uri'
        //  property and trigger it to add 'tibet:src' and 'xml:base'. NB: This
        //  *MUST* be done *before* we call set('data', ...) below, otherwise
        //  the underlying XML will end up with bad global IDs.
        if (TP.notEmpty(uri)) {
            xmlData.$set('uri', uri, false);
            xmlData.addTIBETSrc(uri);
            xmlData.addXMLBase(uri);
        }

        this.set('data', xmlData, false);
    }

    return xmlData;
});

//  ------------------------------------------------------------------------

TP.core.XMLContent.Inst.defineMethod('getNativeNode',
function() {

    /**
     * @method getNativeNode
     * @summary Returns the native node of the underlying data object.
     * @returns {Object} The receiver's underlying data object's native node.
     */

    var xmlData;

    xmlData = this.get('data');

    if (TP.isKindOf(xmlData, TP.dom.Node)) {
        xmlData = xmlData.getNativeNode();
    }

    return xmlData;
});

//  ------------------------------------------------------------------------

TP.core.XMLContent.Inst.defineMethod('removeRowsFromAt',
function(aCollectionURI, aDeleteIndex) {

    /**
     * @method removeRowsFromAt
     * @summary Removes a row of data from the collection as defined by the
     *     supplied collection URI. This collection should be either the whole
     *     collection representing the data of the receiver or a subcollection
     *     of that data.
     * @param {TP.uri.URI} aCollectionURI The URI pointing to the collection to
     *     remove the row from.
     * @param {Number|Number[]} aDeleteIndex The index(es) to remove the item
     *     from in the collection.
     * @exception TP.sig.InvalidNode
     * @returns {TP.core.XMLContent} The receiver.
     */

    var targetURI,
        publicURI,

        targetCollection,

        preDeleteSize,

        deleteIndexes,
        deletionPath,

        itemParent,

        i,

        path,

        removedData,

        changedAddresses,
        changedIndex,
        changedAspect,
        changedPaths,

        batchID;

    targetURI = aCollectionURI;

    //  If targetURI is null or is not a TP.uri.URI, then set it to the
    //  receiver's publicURI (if its real).
    if (!TP.isURI(targetURI)) {
        publicURI = this.get('$publicURI');

        //  publicURI isn't real - nothing to do here.
        if (!TP.isURI(publicURI)) {
            //  TODO: Raise exception
            return this;
        }

        targetURI = publicURI;
    }

    //  Make sure that we have a TP.dom.CollectionNode

    //  NB: We assume 'async' of false here.
    targetCollection = targetURI.getResource(
                    TP.hc('resultType', TP.WRAP, 'async', false)).get('result');

    if (!TP.isArray(targetCollection)) {
        targetCollection = TP.ac(targetCollection);
    }

    preDeleteSize = targetCollection.getSize();

    //  Compute an XPath to do the deletion.

    //  If a deletion index was supplied or we have numbers in our selection
    //  indexes, then use those as the deletion indexes.
    if (TP.isNumber(deleteIndexes = aDeleteIndex)) {

        deletionPath = './*[' + aDeleteIndex + ']';

        deleteIndexes = TP.ac(aDeleteIndex);
    } else if (TP.isArray(deleteIndexes = aDeleteIndex)) {

        deletionPath = './*[';

        for (i = 0; i < deleteIndexes.getSize(); i++) {
            deletionPath += 'position = ' + deleteIndexes.at(i) + ' or ';
        }

        deletionPath = deletionPath.slice(0, -4) + ']';
    } else if (TP.notEmpty(deleteIndexes = this.get('selectionIndexes'))) {

        deletionPath = './*[';

        for (i = 0; i < deleteIndexes.getSize(); i++) {
            deletionPath += 'position = ' + deleteIndexes.at(i) + ' or ';
        }

        deletionPath = deletionPath.slice(0, -4) + ']';
    } else {

        //  Otherwise, just delete the last item.
        deletionPath = './*[last()]';

        //  Allocate and push a Number representing the end of the collection
        //  separately to avoid oldtime JS behavior around an Array with a
        //  single Number as its argument.
        deleteIndexes = TP.ac();

        //  Don't substract 1 due XPath 1-based-ness
        deleteIndexes.push(preDeleteSize);
    }

    itemParent = TP.wrap(targetCollection.first()).getParentNode();

    //  Create an XPathPath object from the computed path and execute a delete.
    //  Note here how we supply 'false' as to whether we want the path machinery
    //  to signal a change. We'll do that here.
    path = TP.xpc(deletionPath);
    removedData = path.exec(itemParent, false);

    changedAddresses = path.execRemove(itemParent, false);

    //  And the first index that changed.
    changedIndex = deleteIndexes.first();

    //  The aspect that changed is just the collection along with the
    //  index that changed.
    changedAspect = targetURI.getFragmentExpr() + '[' + changedIndex + ']';

    //  Construct a 'changed paths' data structure that observers will expect to
    //  see.
    changedPaths = TP.hc(changedAspect, TP.hc(TP.DELETE, changedAddresses));

    //  We need this purely so that any machinery that relies on signal batching
    //  (i.e. the markup-based data binding) knows that this signal represents
    //  an entire batch.
    batchID = TP.genID('SIGNAL_BATCH');

    TP.signal(this.getID(),
                'TP.sig.StructureDelete',
                TP.hc('action', TP.DELETE,
                        'addresses', changedAddresses,
                        'aspect', changedAspect,
                        'facet', 'value',
                        TP.CHANGE_PATHS, changedPaths,
                        'target', this,
                        'indexes', deleteIndexes,
                        'removedData', removedData,
                        TP.CHANGE_URIS, null,
                        TP.START_SIGNAL_BATCH, batchID,
                        TP.END_SIGNAL_BATCH, batchID));

    return this;
});

//  ------------------------------------------------------------------------

TP.core.XMLContent.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Returns an XML string representation of the receiver.
     * @returns {String} An XML-formatted string.
     */

    //  Callers will be interested in our data, not the 'data' structure
    //  itself.
    return TP.str(this.get('data'));
});

//  ------------------------------------------------------------------------

TP.core.XMLContent.Inst.defineMethod('asHTTPValue',
function() {

    /**
     * @method asHTTPValue
     * @summary Returns the best value to be used for the receiver to send via
     *     HTTP.
     * @returns {Node} The best value for HTTP sending.
     */

    return this.getNativeNode();
});

//  ------------------------------------------------------------------------

TP.core.XMLContent.Inst.defineMethod('asString',
function() {

    /**
     * @method asString
     * @summary Returns the common string representation of the receiver.
     * @returns {String} The content object in string form.
     */

    return this.asXMLString();
});

//  ------------------------------------------------------------------------

TP.core.XMLContent.Inst.defineMethod('asCleanString',
function(storageInfo) {

    /**
     * @method asCleanString
     * @summary Returns the 'clean' string representation of the receiver.
     *     This may have transformations in it to 'clean' the String, such as
     *     removing unnecessary namespace definitions, etc.
     * @param {TP.core.Hash} [storageInfo] A hash containing various flags for
     *     and results of the serialization process. Notable keys include:
     *          'wantsXMLDeclaration': Whether or not the receiver's document
     *          node should include an 'XML declaration' at the start of its
     *          serialization. The default is false.
     *          'wantsPrefixedXMLNSAttrs': Whether or not the receiver and its
     *          decendant elements should generate prefixed (i.e. 'xmlns:foo')
     *          attributes to support their proper serialization. The default is
     *          true.
     * @returns {String} The content object in clean string form.
     */

    var serializationStorage,

        data,

        uri,
        loc,

        str;

    if (TP.isHash(storageInfo)) {
        serializationStorage = TP.copy(storageInfo);
    } else {
        serializationStorage = TP.hc();
    }

    data = this.get('data');

    uri = this.get('sourceURI');
    loc = uri.getLocation();

    //  Set a location for the 'store' based on our URI location. This is the
    //  'top-level' store in the serialization mechanism, so it should be
    //  representative of the 'whole document'.
    serializationStorage.atPut('store', loc);

    //  Message the TP.dom.Document to begin the serialization.
    data.serializeForStorage(serializationStorage);

    //  The representation we're interested in will be the one at our URI, since
    //  we're interested in the 'whole document'.
    str = serializationStorage.at('stores').at(loc);

    return str;
});

//  ------------------------------------------------------------------------

TP.core.XMLContent.Inst.defineMethod('snapshotData',
function() {

    /**
     * @method snapshotData
     * @summary Returns a snapshot of the receiver's underlying data for use by
     *     the transactional data management routines of the receiver.
     * @returns {Object} The snapshot data.
     */

    var data;

    data = this.getNativeNode();
    data = TP.nodeCloneNode(data, true, true);

    return TP.wrap(data);
});

//  ------------------------------------------------------------------------

TP.core.XMLContent.Inst.defineMethod('transform',
function(anObject, aParamHash) {

    /**
     * @method transform
     * @summary Transforms the supplied Node (or TP.dom.Node) by using the
     *     content of the receiver.
     * @param {Object} anObject The object supplying the data to use in the
     *     transformation.
     * @param {TP.core.Hash|TP.sig.Request} aParamHash A parameter container
     *     responding to at(). For string transformations a key of 'repeat' with
     *     a value of true will cause iteration to occur (if anObject is an
     *     'ordered collection' this flag needs to be set to 'true' in order to
     *     have 'automatic' iteration occur). Additional keys of '$STARTINDEX'
     *     and '$REPEATCOUNT' determine the range of the iteration. A special
     *     key of 'xmlns:fixup' should be set to true to fix up 'xmlns'
     *     attributes such that they won't be lost during the transformation.
     * @returns {String} The string resulting from the transformation process.
     */

    var xmlData;

    xmlData = this.get('data');

    if (TP.isKindOf(xmlData, TP.dom.Node)) {
        return xmlData.transform(anObject, aParamHash);
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.core.XMLContent.Inst.defineMethod('setNativeNode',
function(aNode, shouldSignal) {

    /**
     * @method setNativeNode
     * @summary Sets the receiver's native DOM node object.
     * @param {Node} aNode The node to wrap.
     * @param {Boolean} shouldSignal If false this operation will not trigger a
     *     change notification. This defaults to the return value of sending
     *     shouldSignalChange() to the receiver.
     * @exception TP.sig.InvalidNode
     * @returns {TP.core.XMLContent} The receiver.
     */

    var oldNode,

        nodes,
        ndx,

        flag;

    if (!TP.isNode(aNode)) {
        return this.raise('TP.sig.InvalidNode', aNode);
    }

    //  Notice here how we use the 'fast' native node get method to avoid any
    //  sorts of recursion issues.
    oldNode = this.getNativeNode();

    //  what we do here varies by whether we're checkpointing or not...
    if (TP.isArray(nodes = this.get('snaps'))) {
        ndx = this.get('currentIndex');
        if (TP.isValid(ndx)) {
            //  working in the middle of the list, have to truncate
            nodes.length = ndx;
            nodes.add(aNode);

            //  clear the index since we're basically defining the end of
            //  the list now
            this.$set('currentIndex', null, false);
        } else {
            nodes.atPut(nodes.getSize() - 1, aNode);
        }
    } else {
        this.get('data').$set('node', aNode, false);
    }

    //  NB: Use this construct this way for better performance
    if (TP.notValid(flag = shouldSignal)) {
        flag = this.shouldSignalChange();
    }

    if (flag) {
        this.$changed('content', TP.UPDATE,
                        TP.hc(TP.OLDVAL, oldNode, TP.NEWVAL, aNode));
    }

    return this;
});

//  ========================================================================
//  TP.path.AccessPath
//  ========================================================================

/**
 * @type {TP.path.AccessPath}
 * @summary A common supertype for access paths, which can get used in TIBET
 *     get() and set() calls to provide sophisticated data access. Common
 *     subtypes include types to access TIBETan JS objects, 'plain' JSON data
 *     objects and XML data objects.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('path.AccessPath');

//  This is an abstract supertype - need a concrete subtype to get real work
//  done.
TP.path.AccessPath.isAbstract(true);

//  ------------------------------------------------------------------------

TP.definePrimitive('apc',
function(aPath, config) {

    /**
     * @method apc
     * @summary Returns a newly initialized access path instance.
     * @param {String} aPath The path as a String.
     * @param {TP.core.Hash} config The configuration for this path.
     * @returns {TP.path.AccessPath} The new instance.
     */

    return TP.path.AccessPath.construct(aPath, config);
});

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.path.AccessPath.Type.defineAttribute('$observedAddresses');

TP.path.AccessPath.Type.defineAttribute('$executedPaths');

TP.path.AccessPath.Type.defineAttribute('$changedAddresses');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.path.AccessPath.Type.defineMethod('construct',
function(aPath, config) {

    /**
     * @method construct
     * @summary Returns a new instance of an access path or aPath if it is
     *     already a path.
     * @param {String} aPath The String to build the instance from.
     * @param {TP.core.Hash} config The configuration for this path.
     * @returns {TP.path.AccessPath} A new instance or aPath if it's already a
     *     path.
     */

    if (aPath.isAccessPath()) {
        return aPath;
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Type.defineMethod('getConcreteType',
function(aPath) {

    /**
     * @method getConcreteType
     * @summary Returns the type to use for a particular access path.
     * @param {String} aPath A path string from which the subtype will be
     *     determined.
     * @returns {TP.meta.path.AccessPath} A TP.path.AccessPath subtype type
     *     object.
     */

    var path;

    //  Need at least a path to test.
    if (TP.isEmpty(path = aPath)) {
        return TP.raise(this, 'TP.sig.InvalidPath',
                        'Unable to create an path from empty spec.');
    }

    //  If the path is a composite path, then create one and let it handle
    //  creation of its subpaths.
    if (TP.regex.COMPOSITE_PATH.test(aPath)) {
        return TP.path.CompositePath;
    }

    //  If the path is just '.' or '$_', then that's the shortcut to just return
    //  the target object itself.
    if (TP.regex.ONLY_PERIOD.test(aPath) || TP.regex.ONLY_STDIN.test(aPath)) {
        return TP.path.SimpleTIBETPath;
    }

    //  Note that we only allow numeric ACP expressions in paths
    if (TP.regex.HAS_ACP.test(path)) {

        //  Strip out any numeric expressions and recheck
        TP.regex.ACP_NUMERIC.lastIndex = 0;
        path = path.replace(TP.regex.ACP_NUMERIC, TP.DEFAULT);

        //  If it still has ACP expressions, then it's an invalid path
        if (TP.regex.HAS_ACP.test(path)) {
            return this.raise('TP.sig.InvalidPath');
        }

        //  Now, so as to not change the overall meaning of the path, go back
        //  to the original path and substitute '0's - remember that we're only
        //  doing path type detection here, so we're not changing the meaning
        //  of the path.
        TP.regex.ACP_NUMERIC.lastIndex = 0;
        path = aPath.replace(TP.regex.ACP_NUMERIC, '0');
    }

    //  If we're handed a '#jpath(...)' pointer, then we know what kind of
    //  path it is (or should be, anyway)
    if (TP.regex.JSON_POINTER.test(path)) {
        return TP.path.JSONPath;
    }

    //  If we're handed a '#tibet(...)' pointer, then we know what kind of
    //  path it is (or should be, anyway)
    if (TP.regex.TIBET_POINTER.test(path)) {

        path = TP.regex.TIBET_POINTER.match(path);

        if (TP.regex.COMPOSITE_PATH.test(path.at(1))) {
            return TP.path.CompositePath;
        } else if (TP.regex.TIBET_PATH.test(path.at(1))) {
            //  Otherwise, if it just has 'TIBETan' access path characters,
            //  create a 'complex' TIBET path to deal with it.
            return TP.path.ComplexTIBETPath;
        } else {
            //  Otherwise, it's just a simple path
            return TP.path.SimpleTIBETPath;
        }
    }

    //  Barename (i.e. ID) paths
    if (TP.regex.BARENAME.test(path)) {
        return TP.path.BarenamePath;
    }

    //  It could be some kind of XPointer - either xpointer(), xpath1() or
    //  element() scheme
    if (TP.regex.XPOINTER.test(path)) {

        //  If we're handed an '#element(...)' pointer, then we know what kind
        //  of path it is (or should be, anyway)

        //  NB: We do *not* check against TP.regex.ELEMENT_PATH here, since it
        //  matches all IDs ("#"), attributes ("@"), etc.
        if (TP.regex.ELEMENT_POINTER.test(path)) {
            return TP.path.ElementPath;
        } else {
            return TP.path.XPathPath;
        }
    }

    //  If we're handed an '#css(...)' or other kind of 'xtension' pointer,
    //  then we know what kind of path it is (or should be, anyway)
    if (TP.regex.XTENSION_POINTER.test(path)) {
        return TP.path.XTensionPath;
    }

    //  attribute paths
    if (TP.regex.ATTRIBUTE.test(path)) {
        return TP.path.SimpleXMLPath;
    }

    //  Other kinds of XML paths
    if (TP.regex.XPATH_PATH.test(path) ||
        TP.regex.HAS_SLASH.test(path)) {
        return TP.path.XPathPath;
    }

    //  JSON Paths
    if (TP.regex.JSON_PATH.test(path)) {
        return TP.path.JSONPath;
    }

    //  If there is no 'path punctuation' (only JS identifer characters), or
    //  it's a simple numeric path like '2' or '[2]', that means it's a 'simple
    //  path'.
    //  TODO: This is hacky - figure out how to combine them into one RegExp.
    if (TP.regex.JS_IDENTIFIER.test(path) ||
        TP.regex.ONLY_NUM.test(path) ||
        TP.regex.SIMPLE_NUMERIC_PATH.test(path)) {
        return TP.path.SimpleTIBETPath;
    }

    //  Otherwise, if it has 'TIBETan' access path characters, create a TIBET
    //  path to deal with it.
    if (TP.regex.TIBET_PATH.test(path)) {
        return TP.path.ComplexTIBETPath;
    }

    return TP.path.CSSPath;
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Type.defineMethod('$getExecutedPaths',
function() {

    /**
     * @method $getExecutedPaths
     * @summary Returns the hash to use to register executed paths. This
     *     method is supplied to avoid problems with this hash not being
     *     initialized when TIBET is starting up.
     * @returns {TP.core.Hash} The executed paths hash.
     */

    var theHash;

    if (TP.notValid(theHash = this.$get('$executedPaths'))) {
        theHash = TP.hc();
        this.set('$executedPaths', theHash);
    }

    return theHash;
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Type.defineMethod('$getChangedAddresses',
function() {

    /**
     * @method $getChangedAddresses
     * @summary Returns the Array to use to register changed addresses. This
     *     method is supplied to avoid problems with this hash not being
     *     initialized when TIBET is starting up.
     * @returns {String[]} The changed addresses array.
     */

    var theArray;

    if (TP.notValid(theArray = this.$get('$changedAddresses'))) {
        theArray = TP.ac();
        this.set('$changedAddresses', theArray);
    }

    return theArray;
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Type.defineMethod('$getObservedAddresses',
function() {

    /**
     * @method $getObservedAddresses
     * @summary Returns the hash to use to register observed addresses. This
     *     method is supplied to avoid problems with this hash not being
     *     initialized when TIBET is starting up.
     * @returns {TP.core.Hash} The observed addresses hash.
     */

    var theHash;

    if (TP.notValid(theHash = this.$get('$observedAddresses'))) {
        theHash = TP.hc();
        this.set('$observedAddresses', theHash);
    }

    return theHash;
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Type.defineMethod('registerChangedAddress',
function(anAddress, anAction) {

    /**
     * @method registerChangedAddress
     * @summary Registers a 'data address' (i.e. a unique location in the
     *     source object that is currently being processed by the receiver) as
     *     a 'changed' address (i.e. a location where the data has been
     *     changed).
     * @param {String} anAddress The data address where the data change took
     *     place.
     * @param {String} anAction The 'action' that was taken by the 'set'
     *     machinery. This should be one of:
     *          TP.CREATE
     *          TP.UPDATE
     *          TP.DELETE
     * @returns {Object} The receiver.
     */

    TP.path.AccessPath.$getChangedAddresses().push(
        TP.hc('address', anAddress, 'action', anAction));

    return this;
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Type.defineMethod('registerObservedAddresses',
function(addresses, sourceObjectID, interestedPath) {

    /**
     * @method registerObservedAddresses
     * @summary Registers the supplied 'data addresses' (i.e. unique locations
     *     in the source object that are currently being processed by the
     *     receiver) as 'observed' addresses (i.e. locations where the data has
     *     been retrieved and observers might be interested in changes there).
     * @param {String[]} addresses The data addresses where the data retrieval
     *     took place.
     * @param {String} sourceObjectID The unique ID of the source object.
     * @param {String} interestedPath The String representation of the path
     *     that is interested in changes at the supplied addresses.
     * @returns {Object} The receiver.
     */

    var addressMap,

        sources,

        uniquedAddresses,

        len,
        i,

        paths;

    //  Build a map that looks like this:
    //  {
    //      <sourceObjID>  :    {
    //                              <address>   :   [pathStr1, pathStr2, ...]
    //                          }
    //  }

    //  All observed addresses in the system
    addressMap = TP.path.AccessPath.$getObservedAddresses();

    //  Observed addresses are only interesting in the combination between the
    //  path *and* the data object it was executed against.

    sources = addressMap.atPutIfAbsent(sourceObjectID, TP.hc());

    //  Copy the incoming list of addresses and unique them. This will ensure
    //  that we only visit that address's path Array once.
    uniquedAddresses = TP.copy(addresses);
    uniquedAddresses.unique();

    //  Iterate over the uniqued addresses, retrieving each one's path Array and
    //  adding the referenced path to it.
    len = uniquedAddresses.getSize();
    for (i = 0; i < len; i++) {

        //  Grab the address's path Array and add the referenced path.
        paths = sources.atPutIfAbsent(uniquedAddresses.at(i), TP.ac());
        paths.push(interestedPath);

        //  Make sure to unique the paths so that we don't have more than one
        //  occurrence of the same path for a particular address.
        paths.unique();
    }

    return this;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  The path's internal path
TP.path.AccessPath.Inst.defineAttribute('srcPath');

//  Whether or not to make data structures on execution
TP.path.AccessPath.Inst.defineAttribute('buildout');

//  How to make data structures on execution (if we are making them)
TP.path.AccessPath.Inst.defineAttribute('packageWith');

//  Whether or not to collapse results into a single value
TP.path.AccessPath.Inst.defineAttribute('shouldCollapse');

//  How to extract a 'final value'
TP.path.AccessPath.Inst.defineAttribute('extractWith');

//  If a 'not valid' value is found, this Function can create values
TP.path.AccessPath.Inst.defineAttribute('fallbackWith');

//  Paths that would have been invalidated due to structural mutations
TP.path.AccessPath.Inst.defineAttribute('$invalidatedPaths');

//  Addresses to remove due to structural mutations
TP.path.AccessPath.Inst.defineAttribute('$addressesToRemove');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('init',
function(aPath, config) {

    /**
     * @method init
     * @summary Initialize the instance.
     * @param {String} aPath The String to build the instance from.
     * @param {TP.core.Hash} config The configuration for this path.
     * @returns {TP.path.AccessPath} The receiver.
     */

    this.callNextMethod();

    this.$set('srcPath', aPath, false);

    //  We specifically set buildout to null because, when run
    //  against a content object, if the content object has a setting and that
    //  isn't 'overridden' by us, the path, then that setting will be used.

    if (TP.isHash(config)) {
        //  NB: buildout has a setter defined in XPath paths.
        this.set('buildout', config.atIfInvalid('buildout', null), false);

        this.$set('packageWith',
                    config.atIfInvalid('packageWith', null), false);
        this.$set('shouldCollapse',
                    config.atIfInvalid('shouldCollapse', false));
        this.$set('extractWith',
                    config.atIfInvalid('extractWith', null), false);
        this.$set('fallbackWith',
                    config.atIfInvalid('fallbackWith', null), false);
    } else {
        //  NB: buildout has a setter defined in XPath paths.
        this.set('buildout', null, false);
        this.$set('shouldCollapse', false, false);
    }

    this.$set('$invalidatedPaths', TP.ac(), false);
    this.$set('$addressesToRemove', TP.ac(), false);

    return this;
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a TIBET source code string.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    var str,
        val;

    str = TP.tname(this) + '.construct(\'' + this.$get('srcPath') +
           '\')';

    if ((val = this.$get('buildout')) === true) {
        str += '.set(\'buildout\', ' + val + ')';
    }

    if ((val = this.$get('shouldCollapse')) === true) {
        str += '.set(\'shouldCollapse\', ' + val + ')';
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    var path,
        repStr,
        str;

    str = '[' + TP.tname(this) + ' :: ';

    path = this.$get('srcPath');

    repStr = TP.isEmpty(path) ? this.toString() : this.asString();

    str += '(' + repStr + ')' + ']';

    return str;
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver.
     * @returns {String} The receiver in HTML string format.
     */

    return '<span class="TP_path_AccessPath ' +
                    TP.escapeTypeName(TP.tname(this)) + '">' +
                this.asString() +
            '</span>';
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    var str;

    try {
        str = '{"type":' + TP.tname(this).quoted('"') + ',' +
                '"data":' + this.$get('srcPath').asString().quoted('"') + '}';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} A new String containing the 'pretty print' string of
     *     the receiver.
     */

    return '<dl class="pretty ' + TP.escapeTypeName(TP.tname(this)) + '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' +
                        this.getTypeName() +
                    '</dd>' +
                    '<dt class="pretty key">Path:</dt>' +
                    '<dd class="pretty value">' +
                        this.asString() +
                    '</dd>' +
                    '</dl>';
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('asString',
function() {

    /**
     * @method asString
     * @summary Returns the String representation of the receiver.
     * @returns {String} The String representation of the receiver.
     */

    return this.$get('srcPath');
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver.
     * @returns {String} The receiver in XML string format.
     */

    return '<instance type="' + TP.tname(this) + '"' +
                    ' path="' + this.asString() + '"/>';
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('asXPointerString',
function() {

    /**
     * @method asXPointerString
     * @summary Produces an XPointer string representation of the receiver.
     * @returns {String} The receiver in XPointer string format.
     */

    return '#' + this.getPointerScheme() + '(' + this.asString() + ')';
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('computeCommonLeadingParts',
function(otherPath) {

    /**
     * @method computeCommonLeadingParts
     * @summary Returns the common leading parts of comparing the receiver
     *     with the supplied path.
     * @param {TP.path.AccessPath} otherPath The other path to compare the
     *     receiver to in order to compute a leading portion.
     * @returns {String[]} An Array of path parts that are common between the
     *     receiver and the supplied path starting from the beginning of both
     *     paths.
     */

    var result,

        thisParts,
        otherParts,

        len,
        i;

    result = TP.ac();

    thisParts = this.getPathParts();
    otherParts = otherPath.getPathParts();

    len = thisParts.getSize();
    for (i = 0; i < len; i++) {
        if (thisParts.at(i) === otherParts.at(i)) {
            result.push(thisParts.at(i));
        } else {
            break;
        }
    }

    return result;
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('copy',
function(deep, aFilterNameOrKeys, contentOnly) {

    /**
     * @method copy
     * @summary Returns a 'copy' of the receiver. Actually, a new instance
     *     whose value is equalTo that of the receiver.
     * @param {Boolean} [deep=false] True to force clones to be deep. Ignored
     *     for this type.
     * @param {String|String[]} aFilterNameOrKeys get*Interface() filter or key
     *     array. Ignored for this type.
     * @param {Boolean} [contentOnly=true] Copy content only? Ignored for this
     *     type.
     * @returns {TP.path.AccessPath} A copy of the receiver.
     */

    var config,
        newinst;

    config = TP.hc(
                'buildout', this.$get('buildout'),
                'packageWith', this.$get('packageWith'),
                'shouldCollapse', this.$get('shouldCollapse'),
                'extractWith', this.$get('extractWith'),
                'fallbackWith', this.$get('fallbackWith')
                );

    newinst = this.getType().construct(this.$get('srcPath'), config);

    return newinst;
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('isAccessPath',
function() {

    /**
     * @method isAccessPath
     * @summary Returns whether or not the receiver is an access path object.
     * @returns {Boolean} True - the receiver is an access path.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('isEmpty',
function() {

    /**
     * @method isEmpty
     * @summary Returns whether or not the receiver is an 'empty object',
     *     according to a collection API. This type returns false.
     * @returns {Boolean} Whether or not the receiver is empty. Always false
     *     for this type.
     */

    return false;
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('executeGet',
function(targetObj, varargs) {

    /**
     * @method executeGet
     * @summary Returns the result of executing the path in a 'get' fashion -
     *     i.e. with the intent of retrieving data from the supplied target
     *     object.
     * @param {Object} targetObj The object to execute the receiver against
     *     to get data.
     * @param {arguments} varargs The arguments to execute the get with. The
     *     first argument should be the object to execute the receiver against
     *     to retrieve data. Any remaining arguments will be used as values for
     *     a templated substitution in the path itself.
     * @returns {Object} The result of executing a 'get' against the target
     *     object using the receiver.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('executeSet',
function(targetObj, attributeValue, shouldSignal, varargs) {

    /**
     * @method executeSet
     * @summary Executes the path in a 'set' fashion - i.e. with the intent of
     *     setting the supplied data into the supplied target object.
     * @param {Object} targetObj The object to execute the receiver against to
     *     set data.
     * @param {Object} attributeValue The object to use as the value to set
     *     into the target object.
     * @param {Boolean} shouldSignal If false, no signaling occurs. Defaults to
     *     targetObj.shouldSignalChange().
     * @param {arguments} varargs Any remaining arguments will be used as values
     *     for a templated substitution in the path itself.
     * @returns {Object} The result of executing a 'set' against the target
     *     object using the receiver.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('getFirstSimplePath',
function() {

    /**
     * @method getFirstSimplePath
     * @summary Returns the first 'simple path' of the receiver. For instance,
     *     in a simple path such as '1.2.3', this method will return '1'.
     * @returns {String} The first simple path of the receiver.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('getPathParts',
function() {

    /**
     * @method getPathParts
     * @summary Returns the receiver's parts.
     * @returns {String[]} An Array of the receiver's parts.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('getPathType',
function() {

    /**
     * @method getPathType
     * @summary Returns the receiver's 'path type'.
     * @returns {String} A path type
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('getPointerScheme',
function() {

    /**
     * @method getPointerScheme
     * @summary Returns the receiver's 'pointer scheme'.
     * @returns {String} An XPointer scheme depending on path type.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('getLastChangedPathsInfo',
function(targetObj, filterOutSignalSupertypes) {

    /**
     * @method getLastChangedPathsInfo
     * @summary Retrieves a set of 'path info records' that contain data about
     *     the last changed paths, data addresses and signal types that got
     *     computed the last time the receiving path was executed.
     * @param {Object} targetObj The object to use to retrieve the 'last changed
     *     paths' for.
     * @param {Boolean} [filterOutSignalSupertypes=true] Whether or not to
     *     filter out records where a signal subtype is already present in
     *     another record in the result set (and, therefore, the signal
     *     supertype will be signaled anyway, assuming INHERITANCE_FIRING). The
     *     default is true.
     * @returns {TP.core.Hash[]} An Array of 'path info records' that could
     *     contain a signal name, a 'signal description' record, a signal policy
     *     and a signal type.
     */

    var target,

        allAddresses,

        observedAddresses,

        executedPaths,

        changedAddresses,
        changedPaths,

        signalNameForAction,

        infos,

        pathKeys,
        keysLen,
        i,

        pathAspectAliases,
        j,

        pathEntry,
        actions,
        description,

        actionsLen,

        pathAction,
        pathAddresses,

        sigName,

        aliasesLen,
        k,
        aspectName,
        aspectSigName,

        filteredInfos,

        leni,
        lenj,

        iAspect,
        iSigType,

        shouldAdd,

        jAspect,
        jSigType;

    //  TODO: This logic is very similar to sendChangedSignal() (and, in fact,
    //  was derived from there). Refactor that method to use the data from this
    //  one.

    //  '$observedAddresses' is a map that looks like this:
    //  {
    //      <sourceObjID>  :    {
    //                              <address>   :   [path1, path2, ...]
    //                          }
    //  }

    target = targetObj;
    if (TP.isKindOf(target, TP.core.Content)) {
        target = target.$get('data');
    }

    allAddresses = TP.path.AccessPath.$getObservedAddresses();

    observedAddresses = allAddresses.at(TP.id(target));

    //  If we couldn't find any 'observed' addresses for the target object,
    //  then we should try to compute them - at least for this path. This is
    //  normally done by doing a 'get'.

    if (TP.isEmpty(observedAddresses)) {
        this.executeGet(targetObj);

        observedAddresses = allAddresses.at(TP.id(target));

        //  If we still can't find any, then we just exit
        if (TP.isEmpty(observedAddresses)) {
            return TP.ac();
        }
    } else {

        //  Make sure that this path is registered in 'executed paths' - to
        //  make sure that at least observers of this path will be notified.
        executedPaths = TP.path.AccessPath.$getExecutedPaths().at(
                            TP.id(target));

       //  If we can't find any executed paths for the source, or not one for
       //  this path, then execute a get - this will register this path in both
       //  'executed paths' and, more importantly, will register any addresses
       //  that this path references in the data object
        if (TP.notValid(executedPaths) ||
            TP.notValid(executedPaths.at(this.$get('srcPath')))) {
            this.executeGet(target);
        }
    }

    //  Grab all of the data addresses that changed. We'll iterate over this,
    //  comparing with the 'observed' addresses and then collect the paths that
    //  did those observations.

    changedAddresses = TP.path.AccessPath.$getChangedAddresses();

    //  Generate a data structure with a data path as its key and
    //  action/addresses as the value:
    //
    //  {
    //      <path1>  :  {
    //                      <action>   :   [address1, address2, ...]
    //                  }
    //  }

    changedPaths = TP.hc();

    observedAddresses.perform(
        function(addressPair) {
            var observedAddress,
                interestedPaths,

                l,
                record,

                m,

                action,
                thePath,

                addressesEntry,
                actionEntry;

            observedAddress = addressPair.first();

            //  Note that this is an Array of paths
            interestedPaths = addressPair.last();

            for (l = 0; l < changedAddresses.getSize(); l++) {

                record = changedAddresses.at(l);

                //  We found an address match between changed and observed
                //  addresses. Add the paths from the observed address and
                //  the action from the changed address into the Array of
                //  'changed paths'.

                if (record.at('address') === observedAddress) {
                    action = record.at('action');

                    //  Loop over all of the interested paths
                    for (m = 0; m < interestedPaths.getSize(); m++) {
                        thePath = interestedPaths.at(m);

                        //  If there isn't an action/addresses entry for the
                        //  path, create one.
                        if (TP.notValid(actionEntry =
                                        changedPaths.at(thePath))) {

                            addressesEntry = TP.ac();
                            actionEntry = TP.hc(action, addressesEntry);

                            changedPaths.atPut(thePath, actionEntry);
                        } else {
                            //  Otherwise, if there was an entry for the path,
                            //  but not for the action, create one.
                            if (TP.notValid(addressesEntry =
                                            actionEntry.at(action))) {

                                addressesEntry = TP.ac();
                                actionEntry.atPut(action, addressesEntry);
                            }
                        }

                        //  Push the observed address into the list of addresses
                        //  for this action for this path.
                        addressesEntry.push(observedAddress);
                    }
                }
            }
        });

    //  Define a Function to compute a signal name from an action
    signalNameForAction = function(anAction) {

        switch (anAction) {
            case TP.CREATE:
            case TP.INSERT:
            case TP.APPEND:

                //  CREATE, INSERT or APPEND means an 'insertion structural
                //  change' in the data.
                return 'TP.sig.StructureInsert';

            case TP.DELETE:

                //  DELETE means a 'deletion structural change' in the data.
                return 'TP.sig.StructureDelete';

            case TP.UPDATE:
            default:

                //  UPDATE means just a value changed.
                return 'TP.sig.ValueChange';
        }
    };

    infos = TP.ac();

    //  Now, process all of the changed paths and send changed signals. The
    //  signal type sent will be based on their action.

    pathKeys = changedPaths.getKeys();

    //  Loop over all of the changed paths.
    keysLen = pathKeys.getSize();
    for (i = 0; i < keysLen; i++) {

        //  Get any aliases that are associated with the particular path.
        pathAspectAliases = target.getAccessPathAliases(pathKeys.at(i));

        //  This will be a hash
        pathEntry = changedPaths.at(pathKeys.at(i));

        //  Loop over all of the entries for this particular path. Each one
        //  will contain an Array of the addresses that changed and the action
        //  that changed them (TP.CREATE, TP.DELETE or TP.UPDATE)
        actions = pathEntry.getKeys();

        description = TP.hc(
                        'target', target,
                        'facet', 'value',
                        TP.CHANGE_PATHS, changedPaths);

        actionsLen = actions.getSize();
        for (j = 0; j < actionsLen; j++) {

            pathAction = actions.at(j);
            description.atPut('action', pathAction);

            pathAddresses = pathEntry.at(pathAction);
            description.atPut('addresses', pathAddresses);

            //  Compute the signal name based on the action.
            sigName = signalNameForAction(pathAction);

            //  If we found any path aliases, then loop over them and dispatch
            //  individual signals using their aspect name.
            if (TP.isValid(pathAspectAliases)) {

                aliasesLen = pathAspectAliases.getSize();

                for (k = 0; k < aliasesLen; k++) {
                    aspectName = pathAspectAliases.at(k);

                    description.atPut('aspect', aspectName);

                    aspectSigName = TP.makeStartUpper(aspectName) + 'Change';

                    infos.push(
                        TP.hc('sigName', aspectSigName,
                                'description', TP.copy(description),
                                'policy', TP.INHERITANCE_FIRING,
                                'sigType', sigName));
                }
            } else {

                description.atPut('aspect', pathKeys.at(i));

                infos.push(
                    TP.hc('sigName', sigName,
                            'description', TP.copy(description),
                            'sigType', sigName));
            }
        }
    }

    //  De-dup the records according to a 'aspect :: sigType' key
    infos.unique(
        function(anInfo) {
            return anInfo.at('description').at('aspect') +
                    ' :: ' +
                    anInfo.at('sigType');
        });

    //  If we're not filtering records by signal types, then just return them
    //  all here.
    if (TP.isFalse(filterOutSignalSupertypes)) {
        return infos;
    }

    //  Now, iterate through all of the records, looking for ones that have the
    //  same aspect but different signal types. Filter out those that are signal
    //  supertypes of others, since those will be signaled anyway.

    filteredInfos = TP.ac();

    leni = infos.getSize();
    for (i = 0; i < leni; i++) {

        iAspect = infos.at(i).at('description').at('aspect');
        iSigType = TP.sys.getTypeByName(infos.at(i).at('sigType'));

        shouldAdd = true;

        lenj = filteredInfos.getSize();
        for (j = 0; j < lenj; j++) {

            jAspect = filteredInfos.at(j).at('description').at('aspect');
            jSigType = TP.sys.getTypeByName(filteredInfos.at(j).at('sigType'));

            if (jAspect === iAspect) {
                if (TP.isSubtypeOf(jSigType, iSigType)) {
                    //  What is already in the filtered records is a subtype of
                    //  what we're trying to add - don't add.
                    shouldAdd = false;
                    break;
                } else if (TP.isKindOf(iSigType, jSigType)) {
                    //  What is already in the filtered records is a supertype
                    //  of what we're trying to add - replace what's already
                    //  there (and don't add it again, obviously).
                    filteredInfos.splice(j, 1, infos.at(i));
                    shouldAdd = false;
                    break;
                }
            }
        }

        if (shouldAdd) {
            filteredInfos.push(infos.at(i));
        }
    }

    return filteredInfos;
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('processFinalValue',
function(aReturnValue, targetObj) {

    /**
     * @method processFinalValue
     * @summary Processes the final value before it is returned from the
     *     receiver
     * @description This method postprocesses the final value before it is
     *     returned from the receiver. This postprocessing includes the
     *     following steps, if they are configured on the receiver:
     *          1.  Collapsing any single-valued Collection results
     *          2.  Using an extractor to extract a final value 'beyond' the
     *          last path step
     *          3.  Packaging any remaining results into a type or by using a
     *          Function
     *          4.  Using a fallback Function to create a result if one
     *          couldn't be found (i.e. the value is not valid).
     * @param {Object} aReturnValue The initial return value from this path.
     * @param {Object} targetObj The object to that the receiver has just
     *     executed against.
     * @returns {Object} The final value to be returned from this path.
     */

    return TP.processValueUsingConfig(
            aReturnValue,
            targetObj,
            this.$get('shouldCollapse'),
            this.$get('extractWith'),
            this.$get('packageWith'),
            this.$get('fallbackWith'));
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('updateRegistrationsAfterSignaling',
function(targetObj) {

    /**
     * @method updateRegistrationsAfterSignaling
     * @summary Updates any path registrations and their attendant address
     *     information after signaling a change. This method is called to
     *     provide any 'cleanup' for paths that reference data that no longer
     *     exist and to reset them to data that might now exist at the same
     *     address.
     * @param {Object} targetObj The object to update the path and address
     *     information for.
     * @returns {TP.path.AccessPath} The receiver.
     */

    var observedAddresses,

        executedPaths,

        invalidatedPaths,
        addressesToRemove;

    observedAddresses = TP.path.AccessPath.$getObservedAddresses().at(
                            TP.id(targetObj));

    if (TP.isEmpty(observedAddresses)) {
        return this;
    }

    addressesToRemove = this.$get('$addressesToRemove');

    //  Remove old addresses that are now no longer valid (since we signaled
    //  them with a TP.DELETE). If we created structure as well (i.e. replaced
    //  one tree with another tree), then executing the 'get' below will
    //  repopulate this with addresses that are still valid.
    observedAddresses.removeKeys(addressesToRemove);

    executedPaths = TP.path.AccessPath.$getExecutedPaths().at(
                            TP.id(targetObj));
    invalidatedPaths = this.$get('$invalidatedPaths');

    if (TP.notEmpty(invalidatedPaths)) {
        //  Remove the matching paths that were invalid from the executed paths.
        //  Again, if we created structure, then executing the 'get' below will
        //  repopulate this with paths that are still valid.
        executedPaths.removeAtAll(invalidatedPaths);

        //  Now, we need to go through the invalidated paths and rerun their
        //  'get' to re-execute and re-register their path.
        invalidatedPaths.perform(
                function(aPath) {
                    TP.apc(aPath).executeGet(targetObj);
                });

        invalidatedPaths.empty();
    }

    addressesToRemove.empty();

    return this;
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('updateRegistrationsBeforeSignaling',
function(targetObj) {

    /**
     * @method updateRegistrationsBeforeSignaling
     * @summary Updates any path registrations and their attendant address
     *     information before signaling a change. This method is called to
     *     mark any paths that match addresses that reference data that might
     *     be being deleted or whose structure is changing. This information is
     *     then used after signaling change to 'clean up' these referred to
     *     paths and addresses.
     * @param {Object} targetObj The object to update the path and address
     *     information for.
     * @returns {TP.path.AccessPath} The receiver.
     */

    var observedAddresses,
        observedAddressesKeys,

        changedAddresses,

        invalidatedPaths,
        addressesToRemove;

    //  We need to clear the path information registered for the addresses
    //  'under' the data that changed.
    observedAddresses = TP.path.AccessPath.$getObservedAddresses().at(
                            TP.id(targetObj));

    if (TP.isEmpty(observedAddresses)) {
        return this;
    }

    observedAddressesKeys = TP.keys(observedAddresses);

    //  Go through the addresses that changed and match them against any
    //  entries in observedAddresses
    changedAddresses = TP.path.AccessPath.$getChangedAddresses();

    invalidatedPaths = this.$get('$invalidatedPaths');
    addressesToRemove = this.$get('$addressesToRemove');

    changedAddresses.perform(
            function(locAddrPair) {
                var anAddress,

                    i,
                    len,

                    theKey;

                anAddress = locAddrPair.at('address');

                len = observedAddressesKeys.getSize();
                for (i = 0; i < len; i++) {

                    theKey = observedAddressesKeys.at(i);

                    //  Since we're removing keys along the way (and altering
                    //  the data structure as we go), we need this check
                    if (!observedAddresses.hasKey(theKey)) {
                        continue;
                    }

                    if (theKey === anAddress) {
                        //  An address/action pair has already been entered for
                        //  the actual changed address at the root, so we don't
                        //  need to do anything here.
                        continue;
                    } else if (theKey.startsWith(anAddress)) {
                        invalidatedPaths = invalidatedPaths.concat(
                                        observedAddresses.at(theKey));
                        addressesToRemove.push(theKey);

                        TP.path.AccessPath.registerChangedAddress(
                                theKey, TP.DELETE);
                    }
                }
            });

    invalidatedPaths = invalidatedPaths.unique();

    this.$set('$invalidatedPaths', invalidatedPaths, false);
    this.$set('$addressesToRemove', addressesToRemove, false);

    return this;
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('sendChangedSignal',
function(targetObj) {

    /**
     * @method sendChangedSignal
     * @summary Sends a signal using the supplied target object as the origin
     *     to let observers know that we have changed.
     * @param {Object} targetObj The object to send the 'changed signal' from.
     * @returns {TP.path.AccessPath} The receiver.
     */

    var allAddresses,

        observedAddresses,

        executedPaths,

        changedAddresses,
        changedPaths,

        signalNameForAction,

        pathKeys,
        keysLen,
        i,

        pathAspectAliases,
        j,

        pathEntry,
        actions,
        description,
        batchID,

        actionsLen,

        pathAction,
        pathAddresses,

        sigName,

        aliasesLen,
        k,
        aspectName,
        aspectSigName;

    //  '$observedAddresses' is a map that looks like this:
    //  {
    //      <sourceObjID>  :    {
    //                              <address>   :   [path1, path2, ...]
    //                          }
    //  }

    allAddresses = TP.path.AccessPath.$getObservedAddresses();

    observedAddresses = allAddresses.at(TP.id(targetObj));

    //  If we couldn't find any 'observed' addresses for the target object,
    //  then we should try to compute them - at least for this path. This is
    //  normally done by doing a 'get'.

    if (TP.isEmpty(observedAddresses)) {
        this.executeGet(targetObj);

        observedAddresses = allAddresses.at(TP.id(targetObj));

        //  If we still can't find any, then we just exit
        if (TP.isEmpty(observedAddresses)) {
            return this;
        }
    } else {

        //  Make sure that this path is registered in 'executed paths' - to
        //  make sure that at least observers of this path will be notified.
        executedPaths = TP.path.AccessPath.$getExecutedPaths().at(
                            TP.id(targetObj));

       //  If we can't find any executed paths for the source, or not one for
       //  this path, then execute a get - this will register this path in both
       //  'executed paths' and, more importantly, will register any addresses
       //  that this path references in the data object
        if (TP.notValid(executedPaths) ||
            TP.notValid(executedPaths.at(this.$get('srcPath')))) {
            this.executeGet(targetObj);
        }
    }

    //  Grab all of the data addresses that changed. We'll iterate over this,
    //  comparing with the 'observed' addresses and then collect the paths that
    //  did those observations.

    changedAddresses = TP.path.AccessPath.$getChangedAddresses();

    //  Generate a data structure with a data path as its key and
    //  action/addresses as the value:
    //
    //  {
    //      <path1>  :  {
    //                      <action>   :   [address1, address2, ...]
    //                  }
    //  }

    changedPaths = TP.hc();

    observedAddresses.perform(
        function(addressPair) {
            var observedAddress,
                interestedPaths,

                l,
                record,

                m,

                action,
                thePath,

                addressesEntry,
                actionEntry;

            observedAddress = addressPair.first();

            //  Note that this is an Array of paths
            interestedPaths = addressPair.last();

            for (l = 0; l < changedAddresses.getSize(); l++) {

                record = changedAddresses.at(l);

                //  We found an address match between changed and observed
                //  addresses. Add the paths from the observed address and
                //  the action from the changed address into the Array of
                //  'changed paths'.

                if (record.at('address') === observedAddress) {
                    action = record.at('action');

                    //  Loop over all of the interested paths
                    for (m = 0; m < interestedPaths.getSize(); m++) {
                        thePath = interestedPaths.at(m);

                        //  If there isn't an action/addresses entry for the
                        //  path, create one.
                        if (TP.notValid(actionEntry =
                                        changedPaths.at(thePath))) {

                            addressesEntry = TP.ac();
                            actionEntry = TP.hc(action, addressesEntry);

                            changedPaths.atPut(thePath, actionEntry);
                        } else {
                            //  Otherwise, if there was an entry for the path,
                            //  but not for the action, create one.
                            if (TP.notValid(addressesEntry =
                                            actionEntry.at(action))) {

                                addressesEntry = TP.ac();
                                actionEntry.atPut(action, addressesEntry);
                            }
                        }

                        //  Push the observed address into the list of addresses
                        //  for this action for this path.
                        addressesEntry.push(observedAddress);
                    }
                }
            }
        });

    //  Define a Function to compute a signal name from an action
    signalNameForAction = function(anAction) {

        switch (anAction) {
            case TP.CREATE:
            case TP.INSERT:
            case TP.APPEND:

                //  CREATE, INSERT or APPEND means an 'insertion structural
                //  change' in the data.
                return 'TP.sig.StructureInsert';

            case TP.DELETE:

                //  DELETE means a 'deletion structural change' in the data.
                return 'TP.sig.StructureDelete';

            case TP.UPDATE:
            default:

                //  UPDATE means just a value changed.
                return 'TP.sig.ValueChange';
        }
    };

    //  Now, process all of the changed paths and send changed signals. The
    //  signal type sent will be based on their action.

    pathKeys = changedPaths.getKeys();

    //  Loop over all of the changed paths.
    keysLen = pathKeys.getSize();
    for (i = 0; i < keysLen; i++) {

        //  Get any aliases that are associated with the particular path.
        pathAspectAliases = targetObj.getAccessPathAliases(pathKeys.at(i));

        //  This will be a hash
        pathEntry = changedPaths.at(pathKeys.at(i));

        //  Loop over all of the entries for this particular path. Each one
        //  will contain an Array of the addresses that changed and the action
        //  that changed them (TP.CREATE, TP.DELETE or TP.UPDATE)
        actions = pathEntry.getKeys();

        description = TP.hc(
                        'target', targetObj,
                        'facet', 'value',
                        TP.CHANGE_PATHS, changedPaths);

        //  This method supports 'batching' of signals. Some receivers (like
        //  TIBET's markup-based binding machinery) only want to update when the
        //  end of a 'batch' of signals is received. Therefore, we mark our
        //  signals with a unique 'batch ID'.
        //  For the first signal in the batch, we stamp in the unique batch ID
        //  under the TP.START_SIGNAL_BATCH key in the signal's payload and,
        //  conversely under the TP.END_SIGNAL_BATCH key for the last signal in
        //  the batch. All signals carry the batch ID under the TP.SIGNAL_BATCH
        //  key.

        //  First signal... generate and stamp in the batch ID under both
        //  TP.START_SIGNAL_BATCH and TP.SIGNAL_BATCH. We'll clear
        //  TP.START_SIGNAL_BATCH below, after the signal is sent.
        if (i === 0) {
            batchID = TP.genID('SIGNAL_BATCH');
            description.atPut(TP.START_SIGNAL_BATCH, batchID);

            description.atPut(TP.SIGNAL_BATCH, batchID);
        }

        actionsLen = actions.getSize();
        for (j = 0; j < actionsLen; j++) {

            pathAction = actions.at(j);
            description.atPut('action', pathAction);

            pathAddresses = pathEntry.at(pathAction);
            description.atPut('addresses', pathAddresses);

            //  Compute the signal name based on the action.
            sigName = signalNameForAction(pathAction);

            //  Last signal... stamp in the batch ID under TP.END_SIGNAL_BATCH
            if (i === keysLen - 1 && j === actionsLen - 1) {
                description.atPut(TP.END_SIGNAL_BATCH, batchID);
            }

            //  If we found any path aliases, then loop over them and dispatch
            //  individual signals using their aspect name.
            if (TP.isValid(pathAspectAliases)) {

                aliasesLen = pathAspectAliases.getSize();

                for (k = 0; k < aliasesLen; k++) {
                    aspectName = pathAspectAliases.at(k);

                    description.atPut('aspect', aspectName);

                    aspectSigName = TP.makeStartUpper(aspectName) + 'Change';

                    //  Note that we force the firing policy here. This allows
                    //  observers of a generic Change to see 'aspect'Change
                    //  notifications, even if those 'aspect'Change signals
                    //  haven't been defined as being subtypes of Change.

                    //  Also note how we supply either 'TP.sig.Change' (the top
                    //  level for simple attribute changes) or one of the
                    //  subtypes of 'TP.sig.StructureChange' (the top level for
                    //  structural changes, mostly used in 'path'ed attributes)
                    //  as the default signal type here so that undefined aspect
                    //  signals will use that type.
                    TP.signal(targetObj, aspectSigName, description,
                                TP.INHERITANCE_FIRING, sigName);
                }
            } else {

                description.atPut('aspect', pathKeys.at(i));

                TP.signal(targetObj, sigName, description);
            }
        }

        //  First signal... remove the batch ID under TP.START_SIGNAL_BATCH
        if (i === 0) {
            description.removeKey(TP.START_SIGNAL_BATCH);
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.path.AccessPath.Inst.defineMethod('valuesAreAlike',
function(objectA, objectB) {

    /**
     * @method valuesAreAlike
     * @summary Returns whether or not the objects are alike in some
     *     receiver-defined way (e.g. either equality or identity).
     * @param {Object} objectA The first object to use for comparison.
     * @param {Object} objectB The second object to use for comparison.
     * @returns {Boolean} Whether or not the resources are alike in some
     *     receiver-defined way.
     */

    var bothAreSimpleObjs;

    bothAreSimpleObjs = !TP.isReferenceType(objectA) &&
                        !TP.isReferenceType(objectB);

    if (bothAreSimpleObjs) {
        return TP.equal(objectA, objectB);
    }

    return TP.identical(objectA, objectB);
});

//  ========================================================================
//  TP.path.CompositePath
//  ========================================================================

TP.path.AccessPath.defineSubtype('CompositePath');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  The set of paths that this composite path holds. It chains them together to
//  get or set a value when executing.
TP.path.CompositePath.Inst.defineAttribute('paths');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.path.CompositePath.Inst.defineMethod('init',
function(aPath, config) {

    /**
     * @method init
     * @summary Initialize the instance.
     * @param {String} aPath The String to build the instance from.
     * @param {TP.core.Hash} config The configuration for this path.
     * @returns {TP.path.CompositePath} The receiver.
     */

    var path,

        pathStrs,
        i,

        paths;

    path = aPath;

    //  If the path has a '#tibet(...)' scheme wrapping it, slice that off. It
    //  will cause the split below to be off.
    if (TP.regex.TIBET_POINTER.test(path)) {
        path = path.slice(7, -1);
    }

    this.callNextMethod(path, config);

    //  Split along '.(' or ').'
    pathStrs = path.split(/(\.\(|\)\.)/);

    //  Strip any leading parenthesis from the first item and any trailing
    //  parenthesis from the last item.
    pathStrs.atPut(0, pathStrs.first().strip(/^\(/));
    pathStrs.atPut(pathStrs.getSize() - 1, pathStrs.last().strip(/\)$/));

    //  Create the set of subpaths that we will use by iterating over the path
    //  strings that we extracted. Note that the 'odd' positions will contain
    //  the '.(' or ').' that we split on, so we skip those by incrementing by
    //  2.
    paths = TP.ac();
    for (i = 0; i < pathStrs.getSize(); i += 2) {
        paths.push(TP.apc(pathStrs.at(i), TP.hc('shouldCollapse', true)));
    }

    if (TP.isValid(config)) {
        //  Configure the 'last path' to honor the shouldCollapse flag.
        paths.last().$set('shouldCollapse', config.at('shouldCollapse'), false);
    }

    this.set('paths', paths);

    return this;
});

//  ------------------------------------------------------------------------

TP.path.CompositePath.Inst.defineMethod('executeGet',
function(targetObj, varargs) {

    /**
     * @method executeGet
     * @summary Returns the result of executing the path in a 'get' fashion -
     *     i.e. with the intent of retrieving data from the supplied target
     *     object.
     * @param {Object} targetObj The object to execute the receiver against to
     *     get data.
     * @param {arguments} varargs The arguments to execute the get with. The
     *     first argument should be the object to execute the receiver against
     *     to retrieve data. Any remaining arguments will be used as values for
     *     a templated substitution in the path itself.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidPath
     * @returns {Object} The result of executing a 'get' against the target
     *     object using the receiver.
     */

    var paths,

        len,
        i,

        retVal,
        nextPath,
        pathStr,
        val;

    if (TP.notValid(targetObj)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  The initial return value is the object itself.
    retVal = targetObj;

    //  Iterate over this object's subpaths.
    paths = this.get('paths');

    len = paths.getSize();
    for (i = 0; i < len; i++) {

        //  If it's null or undefined, don't try to message it - just exit here.
        if (TP.notValid(retVal)) {
            break;
        }

        //  If the return value cannot execute a 'get', then wrap it.
        if (!TP.canInvoke(retVal, 'get')) {
            retVal = TP.wrap(retVal);
        }

        nextPath = paths.at(i);

        //  If the path is a JSON path, but the content isn't a JSONContent,
        //  convert it so that the path runs correctly.
        if (nextPath.getPathType() === TP.JSON_PATH_TYPE &&
            !TP.isKindOf(retVal, TP.core.JSONContent)) {
            retVal = TP.core.JSONContent.construct(retVal);
        }

        //  Grab the path String. If the path is just '.' or '$_', then we may
        //  be able to shortcut and just continue with the loop.
        pathStr = nextPath.asString();
        if (TP.regex.ONLY_PERIOD.test(pathStr) ||
            TP.regex.ONLY_STDIN.test(pathStr)) {

            //  Sometimes we get a POJO, in which case an undefined 'val' is
            //  just fine.
            if (TP.canInvoke(retVal, 'get')) {
                val = retVal.get(nextPath);
            }

            //  If the return value didn't have a value that could be extracted
            //  under the '.' or '$_' path, then we just continue without
            //  reassigning it to the extracted value.
            if (TP.notValid(val)) {
                continue;
            } else {
                //  Otherwise, reassign the return value to the extracted value.
                retVal = val;
            }
        } else {
            //  Execute the 'get()' and reassign the return value.
            retVal = retVal.get(nextPath);
        }

        //  If the return value is a callable Function, then call it and
        //  reassign the return value to the result.
        if (TP.isCallable(retVal)) {
            retVal = retVal(targetObj);
        }
    }

    return this.processFinalValue(retVal, targetObj);
});

//  -----------------------------------------------------------------------

TP.path.CompositePath.Inst.defineMethod('executeSet',
function(targetObj, attributeValue, shouldSignal, varargs) {

    /**
     * @method executeSet
     * @summary Executes the path in a 'set' fashion - i.e. with the intent of
     *     setting the supplied data into the supplied target object.
     * @param {Object} targetObj The object to execute the receiver against to
     *     set data.
     * @param {Object} attributeValue The object to use as the value to set
     *     into the target object.
     * @param {Boolean} shouldSignal If false, no signaling occurs. Defaults to
     *     targetObj.shouldSignalChange().
     * @param {arguments} varargs Any remaining arguments will be used as values
     *     for a templated substitution in the path itself.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidPath
     * @returns {Object} The result of executing a 'set' against the target
     *     object using the receiver.
     */

    var paths,
        i,
        retVal,

        pathWantsToBuild;

    if (TP.notValid(targetObj)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  The initial return value is the object itself.
    retVal = targetObj;

    //  Iterate over this object's subpaths, except the last one, and perform a
    //  'get()'.
    paths = this.get('paths');
    for (i = 0; i < paths.getSize() - 1; i++) {

        //  If it's null or undefined, don't try to message it - just exit here.
        if (TP.notValid(retVal)) {
            break;
        }

        //  Execute the 'get()' and reassign the return value.
        retVal = retVal.get(paths.at(i));

        //  If the return value is a callable Function, then call it and
        //  reassign the return value to the result.
        if (TP.isCallable(retVal)) {
            retVal = retVal(targetObj);
        }
    }

    //  See if the path wants to build structures. If it doesn't have either
    //  true or false defined for that value, then set it to our value of
    //  whether we're building structures or not.
    pathWantsToBuild = paths.last().$get('buildout');
    if (!TP.isDefined(pathWantsToBuild)) {
        paths.last().set('buildout', this.$get('buildout'), false);
    }

    //  Execute the 'set()' and reassign the return value.
    retVal = retVal.set(paths.last(), attributeValue, shouldSignal);

    //  The path didn't originally have any value defined for whether it was
    //  building structures or not, so set it back to null.
    if (!TP.isDefined(pathWantsToBuild)) {
        //  NB: buildout has a setter defined in XPath paths.
        paths.last().set('buildout', null, false);
    }

    return retVal;
});

//  ------------------------------------------------------------------------

TP.path.CompositePath.Inst.defineMethod('getPathParts',
function() {

    /**
     * @method getPathParts
     * @summary Returns the receiver's parts.
     * @returns {String[]} An Array of the receiver's parts.
     */

    var paths,

        parts,
        i;

    //  Iterate over this object's subpaths and concatenate together the Arrays
    //  produced by getting the path parts of each subpath.
    paths = this.get('paths');

    parts = paths.at(0).getPathParts();
    for (i = 1; i < paths.getSize(); i++) {
        parts = parts.concat(paths.at(i).getPathParts());
    }

    return parts;
});

//  ------------------------------------------------------------------------

TP.path.CompositePath.Inst.defineMethod('getPathType',
function() {

    /**
     * @method getPathType
     * @summary Returns the receiver's 'path type'.
     * @returns {String} A path type
     */

    return TP.COMPOSITE_PATH_TYPE;
});

//  ========================================================================
//  TP.path.JSONPath
//  ========================================================================

/**
 * @type {TP.path.JSONPath}
 */

//  ------------------------------------------------------------------------

TP.path.AccessPath.defineSubtype('JSONPath');

//  ------------------------------------------------------------------------

//  avoid binding and apply issues by creating our alias as a wrapper
TP.definePrimitive('jpc',
function(aPath, config) {

    /**
     * @method jpc
     * @summary Returns a newly initialized JSONPath instance. Note that if
     * @param {String} aPath The JSONPath as a String.
     * @param {TP.core.Hash} config The configuration for this path.
     * @returns {TP.path.JSONPath} The new instance.
     */

    return TP.path.JSONPath.construct.apply(TP.path.JSONPath, arguments);
});

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.path.JSONPath.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    this.defineDependencies('TP.extern.jsonpath');

    return;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.path.JSONPath.Inst.defineMethod('init',
function(aPath, config) {

    /**
     * @method init
     * @summary Initialize the instance.
     * @param {String} aPath The String to build the instance from.
     * @param {TP.core.Hash} config The configuration for this path.
     * @returns {TP.path.JSONPath} The receiver.
     */

    var path;

    //  Make sure that any 'access path' scheme is stripped off
    if (TP.regex.JSON_POINTER.test(aPath)) {
        path = TP.regex.JSON_POINTER.match(aPath).at(1);
    } else {
        path = aPath;
    }

    this.callNextMethod(path, config);

    if (TP.isHash(config)) {
        this.$set('shouldCollapse',
                    config.atIfInvalid('shouldCollapse', true),
                    false);
    } else {
        this.$set('shouldCollapse', true, false);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.path.JSONPath.Inst.defineMethod('executeGet',
function(targetObj, varargs) {

    /**
     * @method executeGet
     * @summary Returns the result of executing the path in a 'get' fashion -
     *     i.e. with the intent of retrieving data from the supplied target
     *     object.
     * @param {targetObj} Object The object to execute the receiver against to
     *     get data.
     * @param {arguments} varargs The arguments to execute the get with. The
     *     first argument should be the object to execute the receiver against
     *     to retrieve data. Any remaining arguments will be used as values for
     *     a templated substitution in the path itself.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidPath
     * @exception TP.sig.InvalidNode
     * @returns {Object} The result of executing a 'get' against the target
     *     object using the receiver.
     */

    var sourceObjectID,
        data,

        targetNdx,
        targetSnaps,
        targetData,

        srcPath,
        path,
        args,

        executedPaths,

        results,
        addresses,

        retVal;

    if (TP.notValid(targetObj)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  This kind of path will only work against TP.core.JSONContent objects
    if (!TP.isKindOf(targetObj, TP.core.JSONContent)) {
        return this.raise(
            'TP.sig.InvalidPath',
            'Target is not a TP.core.JSONContent, but is a: ' +
                TP.tname(targetObj));
    }

    srcPath = this.$get('srcPath');

    //  If the path is empty or just '$', then that's the shortcut to just
    //  return the target object itself.
    if (TP.isEmpty(srcPath) || srcPath === '$') {
        return targetObj;
    }

    path = srcPath;

    //  If the path has ACP expressions ('{{...}}') in it, then template them
    //  out with the source object(s) from the 2nd parameter onwards.
    if (TP.regex.HAS_ACP.test(path)) {
        //  Grab the arguments and slice the first one off (since it's the
        //  targetObj, which we already have).
        args = TP.args(arguments, 1);

        //  Run the transform with the arguments after the 1st one.
        path = path.transform(args);
    }

    sourceObjectID = targetObj.getID();

    if (targetObj.$get('transactional')) {

        targetNdx = targetObj.$get('currentIndex');
        targetSnaps = targetObj.$get('snaps');

        //  NOTE:   we use $get here since we don't want to recurse over
        //          getProperty() calls that use getNativeNode
        if (TP.isValid(targetNdx)) {
            targetData = targetSnaps.at(targetNdx);
        } else {
            targetData = targetObj.get('data');
        }

        data = targetData;
    } else {
        data = targetObj.get('data');
    }

    if (TP.notValid(data)) {
        //  unable to query - there is no data
        TP.ifWarn() ?
            TP.warn(TP.annotate(
                this,
                'Null data value. Unable to get value for path: ' + path)) : 0;

        return null;
    }

    executedPaths = TP.path.AccessPath.$getExecutedPaths().atPutIfAbsent(
                    TP.id(targetObj),
                    TP.hc());

    executedPaths.atPut(path, this);

    //  Invoke the external JSONPath engine and get back a list of results. This
    //  will be an Array of POJO structures that will contain information about
    //  each match.
    results = TP.extern.jsonpath.nodes(data, path);

    //  An Array to gather up the referenced addresses for each result.
    addresses = TP.ac();

    //  An Array to gather up the value for each result.
    retVal = TP.ac();

    //  Process each result by capturing its referenced address and value.
    results.forEach(
        function(anEntry) {
            addresses.push(anEntry.path.join('.'));
            retVal.push(anEntry.value);
        });

    //  Use the referenced addresses to specify the fact that this path (and
    //  therefore users of this path) are interested in those data locations,
    //  should they change.
    TP.path.AccessPath.registerObservedAddresses(
                                        addresses, sourceObjectID, srcPath);

    //  If we got at least one valid return value.
    if (TP.notEmpty(retVal)) {

        //  If the Array of return values only has one item, then collapse it
        //  down to the value itself.
        retVal = TP.collapse(retVal);
    }

    return this.processFinalValue(retVal, targetObj);
}, {
    patchCallee: false
});

//  -----------------------------------------------------------------------

TP.path.JSONPath.Inst.defineMethod('executeSet',
function(targetObj, attributeValue, shouldSignal, varargs) {

    /**
     * @method executeSet
     * @summary Executes the path in a 'set' fashion - i.e. with the intent of
     *     setting the supplied data into the supplied target object.
     * @param {targetObj} Object The object to execute the receiver against to
     *     set data.
     * @param {attributeValue} Object The object to use as the value to set
     *     into the target object.
     * @param {shouldSignal} Boolean If false, no signaling occurs. Defaults to
     *     targetObj.shouldSignalChange().
     * @param {arguments} varargs Any remaining arguments will be used as values
     *     for a templated substitution in the path itself.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidPath
     * @returns {TP.path.JSONPath} The receiver.
     */

    var data,

        shouldBuild,

        srcPath,
        path,
        args,

        oldVal,

        ops,
        newStructs,

        setFunc,
        buildFunc,
        createdStructure,

        results,

        sigFlag,

        executedPaths,
        obsAddresses,

        mutatedStructure;

    if (TP.notValid(targetObj)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  This kind of path will only work against TP.core.JSONContent objects
    if (!TP.isKindOf(targetObj, TP.core.JSONContent)) {
        return this.raise(
            'TP.sig.InvalidPath',
            'Target is not a TP.core.JSONContent, but is a: ' +
                TP.tname(targetObj));
    }

    srcPath = this.$get('srcPath');
    //  If the path is empty or just '$', then that's the shortcut to just
    //  return the target object itself.
    if (TP.isEmpty(srcPath) || srcPath === '$') {
        return targetObj;
    }

    path = srcPath;

    //  If the path has ACP expressions ('{{...}}') in it, then template them
    //  out with the source object(s) from the 4th parameter onwards.
    if (TP.regex.HAS_ACP.test(path)) {
        //  Grab the arguments and slice the first three off (since they're
        //  targetObj, attributeValue and shouldSignal which we already have).
        args = TP.args(arguments, 3);

        //  Run the transform with the arguments after the 3rd one.
        path = path.transform(args);
    }

    //  If the old value is equal to the value that we're setting, then there
    //  is nothing to do here and we exit. This is important to avoid endless
    //  recursion when doing a 'two-ended bind' to data referenced by this
    //  path.
    //  Note that we handle empty Arrays specially here since, if we're not
    //  reducing Arrays, an empty Array handed in as the value will compare as
    //  'true' here and this routine will exit.
    if (this.valuesAreAlike(oldVal, attributeValue)) {
        if (TP.isEmptyArray(attributeValue)) {
            void 0;
        } else {
            return oldVal;
        }
    }

    data = targetObj.get('data');

    //  Whether or not we build structures depends on whether we are configured
    //  to build structures. If the we have no configuration one way or the
    //  other (neither true or false), then however the source object is
    //  configured will be used.
    shouldBuild = TP.ifInvalid(this.$get('buildout'),
                                targetObj.$get('buildout'));

    ops = TP.ac();
    newStructs = TP.ac();

    //  Construct a Function that will used to 'set' values at the end of paths
    //  that are executed by external JSONPath engine. This Function takes the
    //  current value as its only parameter and returns the value to be placed
    //  into that spot in the JS data structure.
    setFunc = function(currentVal) {
        var op,

        deletedNodes,

        srcPathParts,

        len,
        i,

        trackingPath;

        //  The current value is identical to the new value, so there is no
        //  change.
        if (currentVal === attributeValue) {
            return currentVal;
        }

        //  If there is no new value or the current value is a POJO or an Array,
        //  then this is a DELETE operation.
        if (TP.notValid(attributeValue) ||
            TP.isPlainObject(currentVal) ||
            TP.isArray(currentVal)) {

            //  If the current value is not mutable, then it can't be queried,
            //  no matter what the path is. In this case, it's just the
            //  attribute value updating the current val.
            if (!TP.isMutable(currentVal)) {
                op = TP.UPDATE;
                return attributeValue;
            }

            op = TP.DELETE;

            //  Grab all of the nodes deeply under the current value. If that is
            //  not empty, then grab the first path to the current value. This
            //  gives us the common base path to all nodes that we're removing.
            //  We then compute a tracking path to each piece of data being
            //  removed and register each one of those changed addresses with
            //  DELETE as the operation.
            deletedNodes = TP.extern.jsonpath.nodes(currentVal, '$..*');
            if (TP.notEmpty(deletedNodes)) {

                srcPathParts = TP.extern.jsonpath.paths(data, path).at(0);

                len = deletedNodes.getSize();
                for (i = 0; i < len; i++) {
                    trackingPath = srcPathParts.concat(
                                    deletedNodes.at(i).path.slice(1));
                    trackingPath = trackingPath.join('.');

                    TP.path.AccessPath.registerChangedAddress(
                                            trackingPath,
                                            TP.DELETE);
                }
            }
        } else if (TP.isDefined(currentVal)) {

            //  If the current value was created as part of our 'making
            //  structure' Function below, then it's a CREATE operation.
            if (newStructs.contains(currentVal, TP.IDENTITY)) {
                op = TP.CREATE;
            } else {
                //  Otherwise, it's an UPDATE operation.
                op = TP.UPDATE;
            }
        } else {
            //  If there was no value already at this spot in the data
            //  structure, then this is a CREATE operation.
            op = TP.CREATE;
        }

        ops.push(op);

        return attributeValue;
    };

    //  Construct a Function that will used to 'make structure' values at the
    //  end of paths that are executed by external JSONPath engine. This
    //  Function takes the internal partial data structure built by the external
    //  JSONPath engine, along with the value and reference being built and
    //  returns whether or not structure was actually built.
    buildFunc = function(partial, value, ref) {

        var partialPath,

            comp,
            nextComp,

            pathToHere,

            branchStruct,

            pathToStruct,

            mainDataVal,

            leafStruct;

        //  Grab the pieces of the partial that we'll need. This includes the
        //  path to the partial, the current parsed path token, and the next
        //  parsed path token (if any).

        //  This is an Array of path parts.
        partialPath = partial.path;

        //  These are token POJO data structures.
        comp = partial.component;
        nextComp = partial.nextComponent;

        //  Copy the path parts to the partial so that we can manipulate them.
        pathToHere = TP.copy(partialPath);

        //  If there is no next token component, then we're at the end of a
        //  path.
        if (!nextComp) {

            //  If the value of the partial itself is not either a POJO or an
            //  Array, then we need to build a branch structure, reset the
            //  partial value to that, and then build a leaf structure to go
            //  under the 'ref' of that branch structure.
            if (!TP.isPlainObject(value) && !TP.isArray(value)) {

                //  Build a branch structure.
                branchStruct = {};
                newStructs.push(branchStruct);

                //  The path to the branch structure (which will be the
                //  partial's new value) will be the partial's path with the
                //  last item sliced off.
                pathToStruct = partialPath.slice(0, -1);

                //  Grab the current value at the end of that path.
                mainDataVal = TP.extern.jsonpath.value(
                        data,
                        TP.extern.jsonpath.stringify(pathToStruct));

                //  Set the branch structure to be the slot on that value that
                //  matches the last segment of the partial's path (the segment
                //  we sliced off above).
                mainDataVal[partialPath.last()] = branchStruct;

                //  Set the partial's value itself to that branch.
                partial.value = branchStruct;

                //  Register a changed address with the whole path and an
                //  operation of UPDATE.
                TP.path.AccessPath.registerChangedAddress(
                                    pathToHere.join('.'), TP.UPDATE);

                //  Now that the branch structure is in place, create a leaf
                //  structure that will be placed in the slot named by ref on
                //  the new branch structure.
                leafStruct = {};
                branchStruct[ref] = leafStruct;

            } else if (comp.operation === 'member') {
                //  If the token component's operation was 'member', then we
                //  need to build a POJO structure.
                leafStruct = {};
                value[ref] = leafStruct;
            } else if (comp.operation === 'subscript') {
                //  If the token component's operation was 'subscript', then we
                //  need to build an Array structure.
                leafStruct = [];
                value[ref] = leafStruct;
            }

            newStructs.push(leafStruct);

            return true;
        }

        //  There was a next token component, so we must not be at the end of
        //  the path. At this point, structure will definitely be built and its
        //  considered to be 'branch structure'.

        //  If the next token component's operation was 'member', then we need
        //  to build a POJO structure.
        if (nextComp.operation === 'member') {
            branchStruct = {};
        } else if (nextComp.operation === 'subscript') {
            //  Otherwise, it's a subscript, then we need to build an Array
            //  structure.
            branchStruct = [];
        }

        //  If a real branchStruct was defined, then add to the list of new
        //  structures we're building, set it as the value of the 'ref' on the
        //  supplied value (which will be the 'parent' in this context), push
        //  the 'ref' on the end of the tracking path and then register a
        //  changed address with that path and an operation of CREATE.
        if (branchStruct) {
            newStructs.push(branchStruct);

            value[ref] = branchStruct;

            pathToHere.push(ref);

            TP.path.AccessPath.registerChangedAddress(
                                pathToHere.join('.'), TP.CREATE);

            return true;
        }

        return false;
    };

    //  Empty out all of the changed addresses that we're currently tracking.
    TP.path.AccessPath.$getChangedAddresses().empty();

    //  If we're configured to 'build structures', then we supply the Function
    //  defined above responsible for building structures.
    if (shouldBuild) {
        results = TP.extern.jsonpath.apply(data, path, setFunc, buildFunc);
    } else {
        results = TP.extern.jsonpath.apply(data, path, setFunc);
    }

    //  If, after the 'apply' call, we added new structures, newStructs will not
    //  be empty and that will let us know that we actually created structures.
    createdStructure = TP.notEmpty(newStructs);

    //  Register any changed addresses for the main query.
    results.forEach(
        function(anEntry, anIndex) {
            TP.path.AccessPath.registerChangedAddress(anEntry.path.join('.'),
                                                        ops.at(anIndex));
        });

    //  If we 'created structure', that means that all of the previously
    //  executed paths need to be run, because they could now refer to new
    //  addresses.
    if (createdStructure) {

        //  Grab the Array of executed paths registered under the ID of the
        //  target object.
        executedPaths = TP.path.AccessPath.$getExecutedPaths().at(
                                                        TP.id(targetObj));

        if (TP.notEmpty(executedPaths)) {

            //  Grab the Array of observed addresses registered under the ID of
            //  the target object.
            obsAddresses = TP.path.AccessPath.$getObservedAddresses().at(
                                            TP.id(targetObj));

            //  Empty it if it isn't already.
            if (TP.notEmpty(obsAddresses)) {
                obsAddresses.empty();
            }

            //  Rerun all of the paths in a 'get' mode. This will cause the
            //  observed addresses Array to fill back up with (possibly
            //  different) addresses.
            executedPaths.perform(
                    function(pathEntry) {
                        pathEntry.last().executeGet(targetObj);
                    });
        }
    }

    //  Compute the flag as to whether we should signal or not by looking first
    //  at the supplied parameter and then as to whether the target object is
    //  configured to signal change.
    if (TP.isValid(shouldSignal)) {
        sigFlag = shouldSignal;
    } else if (TP.isValid(targetObj)) {
        sigFlag = targetObj.shouldSignalChange();
    }

    if (sigFlag) {

        //  If the supplied attribute was a reference type then we *mutated*
        //  structure (which is not necessarily the same thing as *creating*
        //  structure).
        mutatedStructure = TP.isReferenceType(attributeValue);

        //  If we mutated structure, then we need to clear the path information
        //  registered for the addresses 'under' the node that changed.
        if (mutatedStructure) {
            this.updateRegistrationsBeforeSignaling(targetObj);
        }

        //  Send the changed signal
        this.sendChangedSignal(targetObj);

        //  If we mutated structure, we may very well have removed some
        //  structure. After signaling that fact, we should no longer keep those
        //  registrations around.
        if (mutatedStructure) {
            this.updateRegistrationsAfterSignaling(targetObj);
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.path.JSONPath.Inst.defineMethod('getPathParts',
function() {

    /**
     * @method getPathParts
     * @summary Returns the receiver's parts.
     * @returns {String[]} An Array of the receiver's parts.
     */

    return TP.getAccessPathParts(this.$get('srcPath'), 'jpath');
});

//  ------------------------------------------------------------------------

TP.path.JSONPath.Inst.defineMethod('getPathType',
function() {

    /**
     * @method getPathType
     * @summary Returns the receiver's 'path type'.
     * @returns {String} A path type
     */

    return TP.JSON_PATH_TYPE;
});

//  ------------------------------------------------------------------------

TP.path.JSONPath.Inst.defineMethod('getPointerScheme',
function() {

    /**
     * @method getPointerScheme
     * @summary Returns the receiver's 'pointer scheme'.
     * @returns {String} An XPointer scheme depending on path type.
     */

    return 'jpath';
});

//  ========================================================================
//  TP.path.SimpleTIBETPath
//  ========================================================================

/**
 * @type {TP.path.SimpleTIBETPath}
 */

//  ------------------------------------------------------------------------

TP.path.AccessPath.defineSubtype('SimpleTIBETPath');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.path.SimpleTIBETPath.Type.defineAttribute('$traversalLevel');
TP.path.SimpleTIBETPath.Type.defineAttribute('$prefixParts');

TP.path.SimpleTIBETPath.Type.defineAttribute('$currentSource');
TP.path.SimpleTIBETPath.Type.defineAttribute('$currentPath');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.path.SimpleTIBETPath.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    this.Type.$set('$traversalLevel', 0, false);
    this.Type.set('$prefixParts', TP.ac());

    return;
});

//  ------------------------------------------------------------------------

TP.path.SimpleTIBETPath.Type.defineMethod('endChangedAddress',
function() {

    /**
     * @method endChangedAddress
     * @returns {TP.meta.path.SimpleTIBETPath} The receiver.
     */

    this.get('$prefixParts').pop();

    return this;
});

//  ------------------------------------------------------------------------

TP.path.SimpleTIBETPath.Type.defineMethod('endObservedAddress',
function(theVal, observedAddressRecord) {

    /**
     * @method endObservedAddress
     * @summary End computing an 'observed address' that will used to track
     *     which data addresses are being observed by a data path. Note that
     *     this (along with its counterpart startObservedAddress) will be
     *     called as many times as there are 'path parts' since we build an
     *     address from those path parts as we recurse 'down' a JS object data
     *     structure.
     * @param {Object} theVal The value that we use to test as to whether to
     *     save this address (i.e. register the supplied address record).
     * @param {Array} observedAddressRecord The record of address information
     *     that will be registered if the test of the supplied value passes.
     * @returns {TP.meta.path.SimpleTIBETPath} The receiver.
     */

    var srcObj;

    srcObj = TP.path.SimpleTIBETPath.$get('$currentSource');
    if (TP.owns(srcObj, '$$noPathTracking')) {
        return this;
    }

    this.get('$prefixParts').pop();

    //  If we have a defined value, then make an 'observed address' from the
    //  supplied record.
    if (TP.isDefined(theVal)) {
        TP.path.AccessPath.registerObservedAddresses(
                                TP.ac(observedAddressRecord.at(0)),
                                observedAddressRecord.at(1),
                                observedAddressRecord.at(2));
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.path.SimpleTIBETPath.Type.defineMethod('getChangedAddress',
function() {

    /**
     * @method getChangedAddress
     * @returns {String}
     */

    //  Note here the conversion from 'foo.[1]' to 'foo[1]'
    return this.get('$prefixParts').join('.').replace(/\.\[/g, '[');
});

//  ------------------------------------------------------------------------

TP.path.SimpleTIBETPath.Type.defineMethod('startChangedAddress',
function(addressPart) {

    /**
     * @method startChangedAddress
     * @param {String} addressPart
     * @returns {TP.meta.path.SimpleTIBETPath} The receiver.
     */

    var prefixParts;

    prefixParts = this.get('$prefixParts');

    prefixParts.push(addressPart);

    return this;
});

//  ------------------------------------------------------------------------

TP.path.SimpleTIBETPath.Type.defineMethod('startObservedAddress',
function(addressPart) {

    /**
     * @method startObservedAddress
     * @summary Start computing an 'observed address' that will used to track
     *     which data addresses are being observed by a data path. Note that
     *     this will be called as many times as there are 'path parts' since we
     *     build an address from those path parts as we recurse 'down' a JS
     *     object data structure.
     * @param {String} addressPart The 'local' portion of the address to add to
     *     the overall address that we're computing.
     * @returns {Array} An Array of the address, the source object ID and the
     *     source path, all used by the endObservedAddress method to make a
     *     observed address record.
     */

    var srcObj,

        prefixParts,

        address,

        srcPath,
        sourceObjectID,

        addressRecord;

    srcObj = TP.path.SimpleTIBETPath.$get('$currentSource');
    if (TP.owns(srcObj, '$$noPathTracking')) {
        return this;
    }

    prefixParts = this.get('$prefixParts');

    prefixParts.push(addressPart);

    //  Note here the conversion from 'foo.[1]' to 'foo[1]'
    address = prefixParts.join('.').replace(/\.\[/g, '[');

    srcPath = TP.path.SimpleTIBETPath.$get('$currentPath').$get('srcPath');

    //  Note here the conversion from 'foo.[1]' to 'foo[1]'
    srcPath = srcPath.replace(/\.\[/g, '[');

    //  Grab the ID of the current source object
    sourceObjectID = TP.id(srcObj);

    addressRecord = TP.ac(address, sourceObjectID, srcPath);

    return addressRecord;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  Whether or not the receiver 'created structure' on it's latest run. This is
//  reset after each 'setter run' of the path.
TP.path.SimpleTIBETPath.Inst.defineAttribute('$createdStructure');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.path.SimpleTIBETPath.Inst.defineMethod('init',
function(aPath, config) {

    /**
     * @method init
     * @summary Initialize the instance.
     * @param {String} aPath The String to build the instance from.
     * @param {TP.core.Hash} config The configuration for this path.
     * @returns {TP.path.SimpleTIBETPath} The receiver.
     */

    var path;

    //  Make sure that any 'access path' scheme is stripped off
    if (TP.regex.TIBET_POINTER.test(aPath)) {
        path = TP.regex.TIBET_POINTER.match(aPath).at(1);
    } else {
        path = aPath;
    }

    this.callNextMethod(path, config);

    if (TP.isHash(config)) {
        this.$set('shouldCollapse',
                    config.atIfInvalid('shouldCollapse', true),
                    false);
    } else {
        this.$set('shouldCollapse', true, false);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.path.SimpleTIBETPath.Inst.defineMethod('executeGet',
function(targetObj, varargs) {

    /**
     * @method executeGet
     * @summary Returns the result of executing the path in a 'get' fashion -
     *     i.e. with the intent of retrieving data from the supplied target
     *     object.
     * @param {targetObj} Object The object to execute the receiver against to
     *     get data.
     * @param {arguments} varargs The arguments to execute the get with. The
     *     first argument should be the object to execute the receiver against
     *     to retrieve data. Any remaining arguments will be used as values for
     *     a templated substitution in the path itself.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidPath
     * @returns {Object} The result of executing a 'get' against the target
     *     object using the receiver.
     */

    var args,

        srcPath,
        path,

        addressRecord,

        retVal;

    if (TP.notValid(targetObj)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  This kind of path won't work against native XML (but will against
    //  wrapped XML).
    if (TP.isNode(targetObj)) {
        return this.raise(
            'TP.sig.InvalidPath',
            'Target is native XML, but this path needs wrapped XML.');
    }

    //  Fill in any templated expressions in the path (which must be numeric
    //  positions) with data from the passed arguments.
    srcPath = this.$get('srcPath');

    //  If the path is empty or just '.', then that's the shortcut to just
    //  return the target object itself.
    if (TP.isEmpty(srcPath) || TP.regex.ONLY_PERIOD.test(srcPath)) {
        return targetObj;
    }

    path = srcPath;

    //  If the path has ACP expressions ('{{...}}') in it, then template them
    //  out with the source object(s) from the 2nd parameter onwards.
    if (TP.regex.HAS_ACP.test(path)) {
        //  Grab the arguments and slice the first one off (since it's the
        //  targetObj, which we already have).
        args = TP.args(arguments, 1);

        //  Run the transform with the arguments after the 1st one.
        path = path.transform(args);
    }

    //  Trigger the actual 'get' mechanism, tracking addresses as we go.

    this.preGetAccess(targetObj);

    //  NB: We use the original source path to register with the address change
    //  notification mechanism
    addressRecord = this.getType().startObservedAddress(srcPath);

    //  If the path is something like '[0]', then slice off the brackets to
    //  just produce '0'.
    if (TP.regex.SIMPLE_NUMERIC_PATH.test(path)) {
        path = path.slice(1, -1);
    }

    retVal = targetObj.get(path);

    this.getType().endObservedAddress(retVal, addressRecord);

    this.postGetAccess(targetObj);

    return this.processFinalValue(retVal, targetObj);
});

//  -----------------------------------------------------------------------

TP.path.SimpleTIBETPath.Inst.defineMethod('executeSet',
function(targetObj, attributeValue, shouldSignal, varargs) {

    /**
     * @method executeSet
     * @summary Executes the path in a 'set' fashion - i.e. with the intent of
     *     setting the supplied data into the supplied target object.
     * @param {targetObj} Object The object to execute the receiver against to
     *     set data.
     * @param {attributeValue} Object The object to use as the value to set
     *     into the target object.
     * @param {shouldSignal} Boolean If false, no signaling occurs. Defaults to
     *     targetObj.shouldSignalChange().
     * @param {arguments} varargs Any remaining arguments will be used as values
     *     for a templated substitution in the path itself.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidPath
     * @returns {Object} The result of executing a 'set' against the target
     *     object using the receiver.
     */

    var srcPath,
        path,

        thisType,

        shouldBuild,

        oldVal,

        op,

        args,

        retVal,
        traversalLevel,

        executedPaths,

        obsAddresses,

        sigFlag,

        mutatedStructure;

    if (TP.notValid(targetObj)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  This kind of path won't work against native XML (but will against
    //  wrapped XML).
    if (TP.isNode(targetObj)) {
        return this.raise(
            'TP.sig.InvalidPath',
            'Target is native XML, but this path needs wrapped XML.');
    }

    srcPath = this.$get('srcPath');
    path = srcPath;

    thisType = this.getType();

    //  Whether or not we build structures depends on whether we are configured
    //  to build structures. If the we have no configuration one way or the
    //  other (neither true or false), then however the source object is
    //  configured will be used.
    shouldBuild = TP.ifInvalid(this.$get('buildout'),
                                targetObj.$get('buildout'));

    //  If an old value wasn't defined and the 'buildout' flag is
    //  false, then we don't do anything and just return here.
    oldVal = targetObj.get(srcPath);
    if (TP.notDefined(oldVal) && !shouldBuild) {
        return;
    }

    if (TP.notValid(attributeValue)) {
        op = TP.DELETE;
    } else if (TP.isDefined(oldVal)) {
        op = TP.UPDATE;
    } else {
        op = TP.CREATE;
        //  Make sure to let this path know that we created structure - this
        //  makes a difference when signaling change if we're being used as part
        //  of an over 'complex' TIBET path.
        this.$set('$createdStructure', true, false);
    }

    //  If the old value is equal to the value that we're setting, then there
    //  is nothing to do here and we exit. This is important to avoid endless
    //  recursion when doing a 'two-ended bind' to data referenced by this
    //  path.
    if (this.valuesAreAlike(oldVal, attributeValue)) {
        return oldVal;
    }

    //  If the path has ACP expressions ('{{...}}') in it, then template them
    //  out with the source object(s) from the 4th parameter onwards.
    if (TP.regex.HAS_ACP.test(path)) {
        //  Grab the arguments and slice the first three off (since they're
        //  targetObj, attributeValue and shouldSignal which we already have).
        args = TP.args(arguments, 3);

        //  Run the transform with the arguments after the 3rd one.
        path = path.transform(args);
    }

    traversalLevel = TP.path.SimpleTIBETPath.$get('$traversalLevel');
    if (traversalLevel === 0) {

        //  Empty the changed addresses before we start another run.
        TP.path.AccessPath.$getChangedAddresses().empty();
    }

    //  Trigger the actual 'set' mechanism, tracking changed addresses as we
    //  go.

    this.preSetAccess(targetObj);

    //  NB: We use the original source path to register with the address change
    //  notification mechanism
    thisType.startChangedAddress(srcPath);

    //  If the path is something like '[0]', then slice off the brackets to
    //  just produce '0'.
    if (TP.regex.SIMPLE_NUMERIC_PATH.test(path)) {
        path = path.slice(1, -1);
    }

    //  If we're doing a TP.UPDATE, but we're replacing something that has
    //  structure (i.e. it's not just a scalar value), then we change to
    //  registering a TP.DELETE, followed by a TP.CREATE for that.
    if (op === TP.UPDATE && TP.isReferenceType(oldVal)) {
        thisType.registerChangedAddress(thisType.getChangedAddress(),
                                        TP.DELETE);
        thisType.registerChangedAddress(thisType.getChangedAddress(),
                                        TP.CREATE);
    } else {
        thisType.registerChangedAddress(thisType.getChangedAddress(), op);
    }

    //  Note here how we always do the set with a 'false' and then send a
    //  'changed' message later with additional information. We also pass a
    //  second 'false' to avoid warnings on undeclared attributes.

    //  If it's not a hash, then define it as an attribute. A 'set()' on a hash
    //  will do an atPut().
    if (!TP.isKindOf(targetObj, TP.core.Hash)) {
        targetObj.defineAttribute(path);
    }
    retVal = targetObj.set(path, attributeValue, false);

    thisType.endChangedAddress();

    this.postSetAccess(targetObj);

    //  We're all done - acquire the traversal level again. We have to do this
    //  a second time, since the pre/post calls manipulate it.
    traversalLevel = TP.path.SimpleTIBETPath.$get('$traversalLevel');

    if (traversalLevel === 0) {

        //  If we 'created structure', that means that all of the previously
        //  executed paths need to be run, because they could now refer to new
        //  addresses.
        if (this.$get('$createdStructure')) {

            //  Grab the Array of executed paths registered under the ID of the
            //  target object.
            executedPaths = TP.path.AccessPath.$getExecutedPaths().at(
                                    TP.id(targetObj));

            //  If the Array is not empty, then reprocess the observed
            //  addresses.
            if (TP.notEmpty(executedPaths)) {

                //  Grab the Array of observed addresses registered under the ID
                //  of the target object.
                obsAddresses = TP.path.AccessPath.$getObservedAddresses().at(
                                                TP.id(targetObj));

                //  Empty it if it isn't already.
                if (TP.notEmpty(obsAddresses)) {
                    obsAddresses.empty();
                }

                //  Rerun all of the paths in a 'get' mode. This will cause the
                //  observed addresses Array to fill back up with (possibly
                //  different) addresses.
                executedPaths.perform(
                        function(pathEntry) {
                            pathEntry.last().executeGet(targetObj);
                        });
            }
        }

        //  Compute the flag as to whether we should signal or not by looking
        //  first at the supplied parameter and then as to whether the target
        //  object is configured to signal change.
        if (TP.isValid(shouldSignal)) {
            sigFlag = shouldSignal;
        } else if (TP.isValid(targetObj)) {
            sigFlag = targetObj.shouldSignalChange();
        }

        if (sigFlag) {

            //  If the supplied attribute was a reference type then we *mutated*
            //  structure (which is not necessarily the same thing as *creating*
            //  structure).
            mutatedStructure = TP.isReferenceType(attributeValue);

            //  If we mutated structure, then we need to clear the path
            //  information registered for the addresses 'under' the node that
            //  changed.
            if (mutatedStructure) {
                this.updateRegistrationsBeforeSignaling(targetObj);
            }

            //  Send the changed signal
            this.sendChangedSignal(targetObj);

            //  If we mutated structure, we may very well have removed some
            //  structure. After signaling that fact, we should no longer keep
            //  those registrations around.
            if (mutatedStructure) {
                this.updateRegistrationsAfterSignaling(targetObj);
            }
        }
    }

    return retVal;
});

//  ------------------------------------------------------------------------

TP.path.SimpleTIBETPath.Inst.defineMethod('getFirstSimplePath',
function() {

    /**
     * @method getFirstSimplePath
     * @summary Returns the first 'simple path' of the receiver. For instance,
     *     in a simple path such as '1.2.3', this method will return '1'.
     * @returns {String} The first simple path of the receiver.
     */

    //  For simple paths, our whole path is the first simple path.
    return this.$get('srcPath');
});

//  ------------------------------------------------------------------------

TP.path.SimpleTIBETPath.Inst.defineMethod('getPathParts',
function() {

    /**
     * @method getPathParts
     * @summary Returns the receiver's parts.
     * @returns {String[]} An Array of the receiver's parts.
     */

    return TP.getAccessPathParts(this.$get('srcPath'), 'tibet');
});

//  ------------------------------------------------------------------------

TP.path.SimpleTIBETPath.Inst.defineMethod('getPathType',
function() {

    /**
     * @method getPathType
     * @summary Returns the receiver's 'path type'.
     * @returns {String} A path type
     */

    return TP.TIBET_PATH_TYPE;
});

//  ------------------------------------------------------------------------

TP.path.SimpleTIBETPath.Inst.defineMethod('getPointerScheme',
function() {

    /**
     * @method getPointerScheme
     * @summary Returns the receiver's 'pointer scheme'.
     * @returns {String} An XPointer scheme depending on path type.
     */

    return 'tibet';
});

//  ------------------------------------------------------------------------

TP.path.SimpleTIBETPath.Inst.defineMethod('preGetAccess',
function(targetObj) {

    /**
     * @method preGetAccess
     * @param {targetObj} Object
     * @returns {TP.path.SimpleTIBETPath} The receiver.
     */

    var executedPaths;

    executedPaths = TP.path.AccessPath.$getExecutedPaths().atPutIfAbsent(
                    TP.id(targetObj),
                    TP.hc());

    executedPaths.atPut(this.$get('srcPath'), this);

    TP.path.SimpleTIBETPath.$set(
        '$currentSource',
        TP.ifInvalid(
            TP.path.SimpleTIBETPath.$get('$currentSource'), targetObj),
        false);
    TP.path.SimpleTIBETPath.$set(
        '$currentPath',
        TP.ifInvalid(
            TP.path.SimpleTIBETPath.$get('$currentPath'), this),
        false);

    TP.path.SimpleTIBETPath.$set(
        '$traversalLevel',
        TP.path.SimpleTIBETPath.get('$traversalLevel') + 1,
        false);

    return this;
});

//  ------------------------------------------------------------------------

TP.path.SimpleTIBETPath.Inst.defineMethod('preSetAccess',
function(targetObj) {

    /**
     * @method preSetAccess
     * @param {targetObj} Object
     * @returns {TP.path.SimpleTIBETPath} The receiver.
     */

    TP.path.SimpleTIBETPath.$set(
        '$traversalLevel',
        TP.path.SimpleTIBETPath.get('$traversalLevel') + 1,
        false);

    return this;
});

//  ------------------------------------------------------------------------

TP.path.SimpleTIBETPath.Inst.defineMethod('postGetAccess',
function(targetObj) {

    /**
     * @method postGetAccess
     * @param {targetObj} Object
     * @returns {TP.path.SimpleTIBETPath} The receiver.
     */

    var traversalLevel;

    traversalLevel = TP.path.SimpleTIBETPath.$get('$traversalLevel') - 1;

    TP.path.SimpleTIBETPath.$set('$traversalLevel', traversalLevel, false);

    if (traversalLevel === 0) {
        TP.path.SimpleTIBETPath.$set('$currentSource', null, false);
        TP.path.SimpleTIBETPath.$set('$currentPath', null, false);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.path.SimpleTIBETPath.Inst.defineMethod('postSetAccess',
function(targetObj) {

    /**
     * @method postSetAccess
     * @param {targetObj} Object
     * @returns {TP.path.SimpleTIBETPath} The receiver.
     */

    var traversalLevel;

    traversalLevel = TP.path.SimpleTIBETPath.$get('$traversalLevel') - 1;

    TP.path.SimpleTIBETPath.$set('$traversalLevel', traversalLevel, false);

    return this;
});

//  ========================================================================
//  TP.path.ComplexTIBETPath
//  ========================================================================

/**
 * @type {TP.path.ComplexTIBETPath}
 */

//  ------------------------------------------------------------------------

TP.path.SimpleTIBETPath.defineSubtype('ComplexTIBETPath');

//  ------------------------------------------------------------------------

//  avoid binding and apply issues by creating our alias as a wrapper
TP.definePrimitive('tpc',
function(aPath, config) {

    /**
     * @method tpc
     * @summary Returns a newly initialized SimpleTIBETPath or ComplexTIBETPath
     *     instance.
     * @param {String} aPath The path as a String.
     * @param {TP.core.Hash} config The configuration for this path.
     * @returns {TP.path.SimpleTIBETPath|TP.path.ComplexTIBETPath} The new
     *     instance.
     */

    var path;

    //  Make sure that any 'access path' scheme is stripped off
    if (TP.regex.TIBET_POINTER.test(aPath)) {
        path = TP.regex.TIBET_POINTER.match(aPath).at(1);
    } else {
        path = aPath;
    }

    //  If there is no 'path punctuation' (only JS identifer characters), or
    //  it's a simple numeric path like '2' or '[2]', that means it's a 'simple
    //  path'.
    //  TODO: This is hacky - figure out how to combine them into one RegExp.
    if (TP.regex.JS_IDENTIFIER.test(path) ||
        TP.regex.ONLY_NUM.test(path) ||
        TP.regex.ONLY_PERIOD.test(path) ||
        TP.regex.SIMPLE_NUMERIC_PATH.test(path)) {
        return TP.path.SimpleTIBETPath.construct.apply(
                        TP.path.SimpleTIBETPath, arguments);
    }

    //  Otherwise, if it has 'TIBETan' access path characters, create a TIBET
    //  path to deal with it.
    if (TP.regex.TIBET_PATH.test(path)) {
        return TP.path.ComplexTIBETPath.construct.apply(
                            TP.path.ComplexTIBETPath, arguments);
    }

    return null;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  The transformed path we actually execute - it may have templated
//  expressions.
TP.path.ComplexTIBETPath.Inst.defineAttribute('$transformedPath');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.path.ComplexTIBETPath.Inst.defineMethod('init',
function(aPath, config) {

    /**
     * @method init
     * @summary Initialize the instance.
     * @param {String} aPath The String to build the instance from.
     * @param {TP.core.Hash} config The configuration for this path.
     * @returns {TP.path.ComplexTIBETPath} The receiver.
     */

    var path;

    //  Make sure that any 'access path' scheme is stripped off
    if (TP.regex.TIBET_POINTER.test(aPath)) {
        path = TP.regex.TIBET_POINTER.match(aPath).at(1);
    } else {
        path = aPath;
    }

    return this.callNextMethod(path, config);
});

//  ------------------------------------------------------------------------

TP.path.ComplexTIBETPath.Inst.defineMethod('checkValueEquality',
function(objectA, objectB) {

    /**
     * @method checkValueEquality.
     * @summary Checks to see if the two supplied parameters 'lead to' equal
     *     values. This is used when trying to determine whether or not to
     *     proceed with a 'set' operation (and broadcast changes).
     * @description This method takes into account the kind of data that this
     *     path manages when doing it's comparison.
     * @param {objectA} Object The first object to compare.
     * @param {objectB} Object The second object to compare.
     * @returns {Boolean} Whether or not the two values are equal.
     */

    if (TP.isArray(objectA) && objectA.getSize() === 1) {
        return TP.equal(objectA.first(), objectB);
    }

    if (TP.isArray(objectB) && objectB.getSize() === 1) {
        return TP.equal(objectA, objectB.first());
    }

    return TP.equal(objectA, objectB);
});

//  ------------------------------------------------------------------------

TP.path.ComplexTIBETPath.Inst.defineMethod('executeGet',
function(targetObj, varargs) {

    /**
     * @method executeGet
     * @summary Returns the result of executing the path in a 'get' fashion -
     *     i.e. with the intent of retrieving data from the supplied target
     *     object.
     * @param {targetObj} Object The object to execute the receiver against to
     *     get data.
     * @param {arguments} varargs The arguments to execute the get with. The
     *     first argument should be the object to execute the receiver against
     *     to retrieve data. Any remaining arguments will be used as values for
     *     a templated substitution in the path itself.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidPath
     * @returns {Object} The result of executing a 'get' against the target
     *     object using the receiver.
     */

    var args,

        srcPath,
        path,

        retVal;

    if (TP.notValid(targetObj)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  This kind of path won't work against native XML (but will against
    //  wrapped XML).
    if (TP.isNode(targetObj)) {
        return this.raise(
            'TP.sig.InvalidPath',
            'Target is native XML, but this path needs wrapped XML.');
    }

    this.preGetAccess(targetObj);

    //  Fill in any templated expressions in the path (which must be numeric
    //  positions) with data from the passed arguments.
    srcPath = this.$get('srcPath');

    //  If the path is empty or just '.', then that's the shortcut to just
    //  return the target object itself.
    if (TP.isEmpty(srcPath) || TP.regex.ONLY_PERIOD.test(srcPath)) {
        return targetObj;
    }

    path = srcPath;

    //  If the path has ACP expressions ('{{...}}') in it, then template them
    //  out with the source object(s) from the 2nd parameter onwards.
    if (TP.regex.HAS_ACP.test(path)) {
        //  Grab the arguments and slice the first one off (since it's the
        //  targetObj, which we already have).
        args = TP.args(arguments, 1);

        //  Run the transform with the arguments after the 1st one.
        path = path.transform(args);
    }
    this.$set('$transformedPath', path, false);

    if (TP.isString(targetObj)) {
        retVal = this.$executeStringGet(targetObj);
    } else if (TP.isArray(targetObj)) {
        retVal = this.$executeArrayGet(targetObj);
    } else {
        retVal = this.$executeObjectGet(targetObj);
    }

    this.postGetAccess(targetObj);

    return this.processFinalValue(retVal, targetObj);
});

//  ------------------------------------------------------------------------

TP.path.ComplexTIBETPath.Inst.defineMethod('executeSet',
function(targetObj, attributeValue, shouldSignal, varargs) {

    /**
     * @method executeSet
     * @summary Executes the path in a 'set' fashion - i.e. with the intent of
     *     setting the supplied data into the supplied target object.
     * @param {targetObj} Object The object to execute the receiver against to
     *     set data.
     * @param {attributeValue} Object The object to use as the value to set
     *     into the target object.
     * @param {shouldSignal} Boolean If false, no signaling occurs. Defaults to
     *     targetObj.shouldSignalChange().
     * @param {arguments} varargs Any remaining arguments will be used as values
     *     for a templated substitution in the path itself.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidPath
     * @returns {Object} The result of executing a 'set' against the target
     *     object using the receiver.
     */

    var srcPath,
        path,

        args,

        retVal,
        traversalLevel,
        oldVal,

        executedPaths,
        obsAddresses,

        sigFlag,

        mutatedStructure;

    if (TP.notValid(targetObj)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  This kind of path won't work against native XML (but will against
    //  wrapped XML).
    if (TP.isNode(targetObj)) {
        return this.raise(
            'TP.sig.InvalidPath',
            'Target is native XML, but this path needs wrapped XML.');
    }

    //  Fill in any templated expressions in the path (which must be numeric
    //  positions) with data from the passed arguments.
    srcPath = this.$get('srcPath');
    path = srcPath;

    //  If the path has ACP expressions ('{{...}}') in it, then template them
    //  out with the source object(s) from the 4th parameter onwards.
    if (TP.regex.HAS_ACP.test(path)) {
        //  Grab the arguments and slice the first three off (since they're
        //  targetObj, attributeValue and shouldSignal which we already have).
        args = TP.args(arguments, 3);

        //  Run the transform with the arguments after the 3rd one.
        path = path.transform(args);
    }
    this.$set('$transformedPath', path, false);

    //  Trigger the actual 'set' mechanism, tracking changed addresses as we
    //  go.

    this.$set('$createdStructure', false, false);

    //  If our traversal level is 0, that means we're the top level path and we
    //  can check to see if the end result value is equal to the value we're
    //  setting. If so, we can just bail out here.
    traversalLevel = TP.path.SimpleTIBETPath.$get('$traversalLevel');
    if (traversalLevel === 0) {

        if (TP.regex.HAS_ACP.test(srcPath)) {
            //  Grab the arguments and slice the first three off (since they're
            //  targetObj, attributeValue and shouldSignal which we already
            //  have).
            args = TP.args(arguments, 3);

            args.unshift(targetObj);
            oldVal = this.executeGet.apply(this, args);
        } else {
            oldVal = this.executeGet(targetObj);
        }

        //  If the old value is equal to the value that we're setting, then
        //  there is nothing to do here and we exit. This is important to avoid
        //  endless recursion when doing a 'two-ended bind' to data referenced
        //  by this path and to avoid a lot of unnecessary signaling.
        if (this.checkValueEquality(oldVal, attributeValue)) {
            return oldVal;
        }

        //  Empty the changed addresses before we start another run.
        TP.path.AccessPath.$getChangedAddresses().empty();
    }

    //  Note here how we always do the set with a 'false' and then send a
    //  'changed' message later with additional information.

    this.preSetAccess(targetObj);

    if (TP.isArray(targetObj)) {
        retVal = this.$executeArraySet(targetObj, attributeValue, false);
    } else {
        retVal = this.$executeObjectSet(targetObj, attributeValue, false);
    }

    this.postSetAccess(targetObj);

    //  We're all done - acquire the traversal level again. We have to do this
    //  a second time, since the pre/post calls manipulate it.
    traversalLevel = TP.path.SimpleTIBETPath.$get('$traversalLevel');

    //  Only signal change if we're the 'top level' TIBET path - we could've
    //  had more 'complex paths' buried under us.
    if (traversalLevel === 0) {

        //  If we 'created structure', that means that all of the previously
        //  executed paths need to be run, because they could now refer to new
        //  addresses.
        if (this.$get('$createdStructure')) {

            //  Grab the Array of executed paths registered under the ID of the
            //  target object.
            executedPaths = TP.path.AccessPath.$getExecutedPaths().at(
                                    TP.id(targetObj));

            if (TP.notEmpty(executedPaths)) {

                //  Grab the Array of observed addresses registered under the ID
                //  of the target object.
                obsAddresses = TP.path.AccessPath.$getObservedAddresses().at(
                                                TP.id(targetObj));

                //  Empty it if it isn't already.
                if (TP.notEmpty(obsAddresses)) {
                    obsAddresses.empty();
                }

                //  Rerun all of the paths in a 'get' mode. This will cause the
                //  observed addresses Array to fill back up with (possibly
                //  different) addresses.
                executedPaths.perform(
                        function(pathEntry) {
                            pathEntry.last().executeGet(targetObj);
                        });
            }
        }

        //  Compute the flag as to whether we should signal or not by looking
        //  first at the supplied parameter and then as to whether the target
        //  object is configured to signal change.
        if (TP.isValid(shouldSignal)) {
            sigFlag = shouldSignal;
        } else if (TP.isValid(targetObj)) {
            sigFlag = targetObj.shouldSignalChange();
        }

        if (sigFlag) {

            //  If the supplied attribute was a reference type then we *mutated*
            //  structure (which is not necessarily the same thing as *creating*
            //  structure).
            mutatedStructure = TP.isReferenceType(attributeValue);

            //  If we mutated structure, then we need to clear the path
            //  information registered for the addresses 'under' the node that
            //  changed.
            if (mutatedStructure) {
                this.updateRegistrationsBeforeSignaling(targetObj);
            }

            //  Send the changed signal
            this.sendChangedSignal(targetObj);

            //  If we mutated structure, we may very well have removed some
            //  structure. After signaling that fact, we should no longer keep
            //  those registrations around.
            if (mutatedStructure) {
                this.updateRegistrationsAfterSignaling(targetObj);
            }
        }

        //  Flip this back off for the next run.
        this.$set('$createdStructure', false, false);
    }

    return retVal;
});

//  ------------------------------------------------------------------------
//  Getter Methods
//  ------------------------------------------------------------------------

TP.path.ComplexTIBETPath.Inst.defineMethod('$executeArrayGet',
function(targetObj) {

    /**
     * @method $executeArrayGet
     * @summary Returns the result of executing the path in a 'get' fashion
     *     against an object of type 'Array'.
     * @param {targetObj} Array The object to execute the receiver against to
     *     retrieve data.
     * @returns {Object} The result of executing a 'get' against the target
     *     object using the receiver.
     */

    var path,

        parts,
        head,
        tail,

        thisType,

        hadNaN,

        queryParts,

        val,

        mainAddressRecord,

        tailPath,

        retVal;

    path = this.$get('$transformedPath');

    //  See if we need to traverse down via a period ('.') or if this is a
    //  a complete range that we handle here.

    parts = this.$extractPathHeadAndTail(path);
    head = parts.at(0);
    tail = parts.at(1);

    thisType = this.getType();

    if (/[,:]/.test(head)) {
        val = TP.ac();

        if (TP.regex.HAS_COLON.test(head)) {

            //  If there is no tail, that means that there was nothing left
            //  after consuming our own head. In that case, we just return an
            //  Array with our items.
            if (TP.notValid(tail)) {
                targetObj.vslice(head).perform(
                        function(index) {

                            var itemVal,
                                addressRecord;

                            addressRecord =
                                thisType.startObservedAddress(index);

                            itemVal = targetObj.at(index);

                            //  If the return value is a callable Function, then
                            //  call it and reassign the return value to the
                            //  result.
                            if (TP.isCallable(itemVal)) {
                                itemVal = itemVal(targetObj);
                            }

                            val.push(itemVal);

                            thisType.endObservedAddress(itemVal, addressRecord);
                        });
            } else {
                //  Otherwise, we take each one of our items and capture the
                //  return value of its 'get'.
                targetObj.vslice(head).perform(
                        function(index) {

                            var itemVal,
                                addressRecord;

                            addressRecord =
                                thisType.startObservedAddress(index);

                            itemVal = targetObj.at(index);

                            //  If the return value is a callable Function, then
                            //  call it and reassign the return value to the
                            //  result.
                            if (TP.isCallable(itemVal)) {
                                itemVal = itemVal(targetObj);
                            }

                            val.push(itemVal.get(TP.tpc(tail)));

                            thisType.endObservedAddress(itemVal, addressRecord);
                        });
            }
        } else {
            //  Make sure to strip off the leading '[' and trailing ']'
            head = head.slice(1, head.getSize() - 1);

            hadNaN = false;

            queryParts = head.split(',').convert(
                                function(item) {

                                    var itemVal;

                                    if (!TP.isNumber(
                                            itemVal = item.asNumber())) {
                                        hadNaN = true;
                                    }

                                    return itemVal;
                                });

            if (hadNaN) {
                return undefined;
            }

            //  If there is no tail, that means that there was nothing left
            //  after consuming our own head. In that case, we just return an
            //  Array with our items.
            if (TP.notValid(tail)) {
                targetObj.performOver(
                        function(item, key) {

                            var itemVal,
                                addressRecord;

                            addressRecord = thisType.startObservedAddress(key);

                            itemVal = item;

                            //  If the return value is a callable Function, then
                            //  call it and reassign the return value to the
                            //  result.
                            if (TP.isCallable(itemVal)) {
                                itemVal = itemVal(targetObj);
                            }

                            val.push(itemVal);

                            thisType.endObservedAddress(itemVal, addressRecord);
                        }, queryParts);
            } else {
                //  Otherwise, we take each one of our items and capture the
                //  return value of its 'get'.
                targetObj.performOver(
                        function(item, key) {

                            var itemVal,
                                addressRecord;

                            addressRecord = thisType.startObservedAddress(key);

                            itemVal = item;

                            //  If the return value is a callable Function, then
                            //  call it and reassign the return value to the
                            //  result.
                            if (TP.isCallable(itemVal)) {
                                itemVal = itemVal(targetObj);
                            }

                            if (TP.isValid(itemVal)) {
                                val.push(itemVal.get(TP.tpc(tail)));
                            } else {
                                val.push(itemVal);
                            }

                            thisType.endObservedAddress(itemVal, addressRecord);

                        }, queryParts);
            }
        }

        return val;
    }

    //  call back in with first part of access path
    if (TP.notValid(val = targetObj.get(head))) {
        return val;
    }

    //  If the return value is a callable Function, then call it and reassign
    //  the return value to the result.
    if (TP.isCallable(val)) {
        val = val(targetObj);
    }

    //  only continue if the tail is valid and the result object can
    //  stay with the program :)
    if (TP.isString(tail) && TP.canInvoke(val, 'get')) {
        mainAddressRecord = thisType.startObservedAddress(head);

        tailPath = TP.tpc(tail);
        tailPath.$set('shouldCollapse', this.$get('shouldCollapse'), false);

        retVal = val.get(tailPath);

        thisType.endObservedAddress(retVal, mainAddressRecord);

        return retVal;
    } else if (TP.isString(tail) && TP.isPlainObject(val)) {
        mainAddressRecord = thisType.startObservedAddress(head);

        if (tail.indexOf('.') !== TP.NOT_FOUND) {
            return TP.objectValue(val, tail);
        } else {
            retVal = val[tail];
        }

        thisType.endObservedAddress(retVal, mainAddressRecord);

        return retVal;
    } else {
        return val;
    }
});

//  ------------------------------------------------------------------------

TP.path.ComplexTIBETPath.Inst.defineMethod('$executeObjectGet',
function(targetObj) {

    /**
     * @method $executeObjectGet
     * @summary Returns the result of executing the path in a 'get' fashion
     *     against an object of type 'Object'.
     * @param {targetObj} Object The object to execute the receiver against to
     *     retrieve data.
     * @returns {Object} The result of executing a 'get' against the target
     *     object using the receiver.
     */

    var path,

        parts,
        head,
        tail,

        thisType,

        queryParts,

        val,

        mainAddressRecord,

        tailPath,

        retVal;

    path = this.$get('$transformedPath');

    parts = this.$extractPathHeadAndTail(path);
    head = parts.at(0);
    tail = parts.at(1);

    thisType = this.getType();

    if (/,/.test(head)) {
        //  Make sure to strip off the leading '[' and trailing ']'
        head = head.slice(1, head.getSize() - 1);

        queryParts = head.split(',');

        val = TP.ac();

        //  If there is no tail, that means that there was nothing left
        //  after consuming our own head. In that case, we just return an Array
        //  with our items.
        if (TP.notValid(tail)) {
            targetObj.performOver(
                    function(item, key) {

                        var itemVal,
                            addressRecord;

                        addressRecord = thisType.startObservedAddress(key);

                        itemVal = item;

                        //  If the return value is a callable Function, then
                        //  call it and reassign the return value to the result.
                        if (TP.isCallable(itemVal)) {
                            itemVal = itemVal(targetObj);
                        }

                        val.push(itemVal);

                        thisType.endObservedAddress(itemVal, addressRecord);
                    }, queryParts);
        } else {
            //  Otherwise, we take each one of our items and capture the return
            //  value of its 'get'.
            targetObj.performOver(
                    function(item, key) {

                        var itemVal,
                            addressRecord;

                        addressRecord = thisType.startObservedAddress(key);

                        itemVal = item;

                        //  If the return value is a callable Function, then
                        //  call it and reassign the return value to the result.
                        if (TP.isCallable(itemVal)) {
                            itemVal = itemVal(targetObj);
                        }

                        if (TP.isValid(itemVal)) {
                            val.push(itemVal.get(TP.tpc(tail)));
                        } else {
                            val.push(itemVal);
                        }

                        thisType.endObservedAddress(itemVal, addressRecord);

                    }, queryParts);
        }

        return val;
    }

    //  call back in with first part of access path
    if (head !== tail) {

        if (TP.notValid(val = targetObj.get(head))) {
            //  could be a hash key instead...
            return targetObj.getProperty(tail);
        }
    }

    //  If the return value is a callable Function, then call it and reassign
    //  the return value to the result.
    if (TP.isCallable(val)) {
        val = val(targetObj);
    }

    //  only continue if the tail is valid and the result object can stay
    //  with the program :)
    if (TP.isString(tail) && TP.canInvoke(val, 'get')) {
        mainAddressRecord = thisType.startObservedAddress(head);

        tailPath = TP.tpc(tail);
        tailPath.$set('shouldCollapse', this.$get('shouldCollapse'), false);

        retVal = val.get(tailPath);

        thisType.endObservedAddress(retVal, mainAddressRecord);

        return retVal;
    } else if (TP.isString(tail) && TP.isPlainObject(val)) {
        mainAddressRecord = thisType.startObservedAddress(head);

        if (tail.indexOf('.') !== TP.NOT_FOUND) {
            return TP.objectValue(val, tail);
        } else {
            retVal = val[tail];
        }

        thisType.endObservedAddress(retVal, mainAddressRecord);

        return retVal;
    } else {
        return val;
    }
});

//  ------------------------------------------------------------------------

TP.path.ComplexTIBETPath.Inst.defineMethod('$executeStringGet',
function(targetObj) {

    /**
     * @method $executeStringGet
     * @summary Returns the result of executing the path in a 'get' fashion
     *     against an object of type 'String'.
     * @param {targetObj} String The object to execute the receiver against to
     *     retrieve data.
     * @returns {Object} The result of executing a 'get' against the target
     *     object using the receiver.
     */

    var path,

        parts,
        head,
        tail,

        val,

        hadNaN,
        queryParts;

    path = this.$get('$transformedPath');

    parts = this.$extractPathHeadAndTail(path);
    head = parts.at(0);
    tail = parts.at(1);

    if (/[,:]/.test(tail)) {
        val = TP.ac();

        if (TP.regex.HAS_COLON.test(tail)) {

            targetObj.asArray().vslice(tail).perform(
                    function(index) {

                        var itemVal;

                        itemVal = targetObj.at(index);

                        //  If the return value is a callable Function, then
                        //  call it and reassign the return value to the
                        //  result.
                        if (TP.isCallable(itemVal)) {
                            itemVal = itemVal(targetObj);
                        }

                        val.push(itemVal);
                    });
        } else {
            //  Make sure to strip off the leading '[' and trailing ']'
            head = head.slice(1, head.getSize() - 1);

            hadNaN = false;

            queryParts = head.split(',').convert(
                        function(item) {

                            var itemVal;

                            if (!TP.isNumber(itemVal = item.asNumber())) {
                                hadNaN = true;
                            }

                            return itemVal;
                        });

            if (hadNaN) {
                return undefined;
            }

            targetObj.asArray().performOver(
                    function(item) {

                        val.push(item);
                    }, queryParts);
        }

        return val.join('');
    }

    if (TP.notValid(tail)) {
        return undefined;
    }

    //  Had an access character, but it must be one that Strings don't support
    //  - let standard method do the work
    return targetObj.get(tail);
});

//  ------------------------------------------------------------------------
//  Setter Methods
//  ------------------------------------------------------------------------

TP.path.ComplexTIBETPath.Inst.defineMethod('$executeArraySet',
function(targetObj, attributeValue, shouldSignal) {

    /**
     * @method $executeArraySet
     * @summary Executes the path in a 'set' fashion against an object of type
     *     'Array'.
     * @param {targetObj} Array The object to execute the receiver against to
     *     set data.
     * @param {attributeValue} Object The object to use as the value to set
     *     into the target object.
     * @param {shouldSignal} Boolean If false, no signaling occurs. Defaults to
     *     targetObj.shouldSignalChange().
     * @returns {Array|undefined} The targetObj or undefined.
     */

    var path,

        parts,
        head,
        tail,

        thisType,
        shouldBuild,

        val,

        queryParts,

        attrIsNumber,
        firstSimplePath,

        setPath;

    path = this.$get('$transformedPath');

    parts = this.$extractPathHeadAndTail(path);
    head = parts.at(0);
    tail = parts.at(1);

    thisType = this.getType();

    shouldBuild = TP.ifInvalid(this.$get('buildout'),
                                targetObj.$get('buildout'));

    if (/[,:]/.test(head)) {

        if (TP.regex.HAS_COLON.test(head)) {
            //  If there is no tail, that means that there was nothing left
            //  after consuming our own head. In that case, we just set our own
            //  items using the supplied attribute value.
            if (TP.notValid(tail)) {
                targetObj.vslice(head).perform(
                        function(index, count) {

                            var op;

                            if (TP.notValid(attributeValue)) {
                                op = TP.DELETE;
                            } else if (TP.isDefined(targetObj.at(index))) {
                                op = TP.UPDATE;
                            } else {
                                op = TP.CREATE;
                            }

                            thisType.startChangedAddress(index);

                            thisType.registerChangedAddress(
                                thisType.getChangedAddress(), op);

                            targetObj.atPut(
                                    index,
                                    attributeValue);

                            thisType.endChangedAddress();
                        });
            } else {
                //  Otherwise, we take each one of our items and send it a
                //  'set' message with the attribute value.

                firstSimplePath = TP.tpc(tail).getFirstSimplePath();
                attrIsNumber = TP.isNumber(firstSimplePath.asNumber());

                //  If an Array was not supplied, then we use the supplied
                //  value in a repeating fashion.
                targetObj.vslice(head).perform(
                    function(index, count) {

                        var indexVal,
                            op;

                        indexVal = targetObj.at(index);

                        thisType.startChangedAddress(index);

                        //  If item is not valid, or it's not a reference type,
                        //  then we blow away the entry and make it a reference
                        //  type - we need to set the slot...
                        if (shouldBuild &&
                            (TP.notValid(indexVal) ||
                             !TP.isReferenceType(indexVal))) {

                            //  If the slot was already defined, but wasn't a
                            //  reference type, then we're just updating it.
                            if (TP.isDefined(indexVal)) {
                                op = TP.UPDATE;
                            } else {
                                op = TP.CREATE;
                                targetObj.defineAttribute(index);
                            }

                            if (attrIsNumber) {
                                indexVal = TP.ac();
                            } else {
                                indexVal = TP.lang.Object.construct();
                                indexVal.defineAttribute(firstSimplePath);
                            }

                            //  And we set it back onto the targetObj
                            targetObj.atPut(index, indexVal);

                            //  Need to register this as a changed address
                            //  since we altered what was at this slot.
                            thisType.registerChangedAddress(
                                thisType.getChangedAddress(), op);

                            //  Make sure to let this path know that we created
                            //  structure - this makes a difference when
                            //  signaling change.
                            this.$set('$createdStructure', true, false);
                        }

                        if (TP.notValid(indexVal) ||
                            !TP.isReferenceType(indexVal)) {
                            thisType.endChangedAddress();

                            return;
                        }

                        //  This 'set' call will take care of registering the
                        //  changed address.
                        indexVal.set(
                            TP.tpc(
                                tail,
                                TP.hc('buildout', shouldBuild)),
                            attributeValue,
                            false);

                        thisType.endChangedAddress();
                    }.bind(this));
            }
        } else if (/,/.test(head)) {
            //  Make sure to strip off the leading '[' and trailing ']'
            head = head.slice(1, head.getSize() - 1);

            queryParts = head.split(',').convert(
                                function(item) {

                                    return item.asNumber();
                                });

            //  If there is no tail, that means that there was nothing left
            //  after consuming our own head. In that case, we just set our own
            //  items using the supplied attribute value.
            if (TP.notValid(tail)) {
                targetObj.performOver(
                        function(item, index, count) {

                            var op;

                            if (TP.notValid(attributeValue)) {
                                op = TP.DELETE;
                            } else if (TP.isDefined(targetObj.at(index))) {
                                op = TP.UPDATE;
                            } else {
                                op = TP.CREATE;
                            }

                            thisType.startChangedAddress(index);

                            thisType.registerChangedAddress(
                                thisType.getChangedAddress(), op);

                            targetObj.atPut(
                                    index,
                                    attributeValue);

                            thisType.endChangedAddress();
                        }, queryParts);
            } else {
                //  Otherwise, we take each one of our items and send it a
                //  'set' message with the attribute value.

                firstSimplePath = TP.tpc(tail).getFirstSimplePath();
                attrIsNumber = TP.isNumber(firstSimplePath.asNumber());

                targetObj.performOver(
                    function(item, index, count) {

                        var itemVal,
                            op;

                        itemVal = item;

                        thisType.startChangedAddress(index);

                        //  If item is not valid, or it's not a reference type,
                        //  then we blow away the entry and make it a reference
                        //  type - we need to set the slot...
                        if (shouldBuild &&
                            (TP.notValid(itemVal) ||
                             !TP.isReferenceType(itemVal))) {

                            //  If the slot was already defined, but wasn't a
                            //  reference type, then we're just updating it.
                            if (TP.isDefined(itemVal)) {
                                op = TP.UPDATE;
                            } else {
                                op = TP.CREATE;
                                targetObj.defineAttribute(index);
                            }

                            if (attrIsNumber) {
                                itemVal = TP.ac();
                            } else {
                                itemVal = TP.lang.Object.construct();
                                itemVal.defineAttribute(firstSimplePath);
                            }

                            //  And we set it back onto the targetObj
                            targetObj.set(index, itemVal, false);

                            //  Need to register this as a changed address
                            //  since we altered what was at this slot.
                            thisType.registerChangedAddress(
                                thisType.getChangedAddress(), op);

                            //  Make sure to let this path know that we created
                            //  structure - this makes a difference when
                            //  signaling change.
                            this.$set('$createdStructure', true, false);
                        }

                        if (TP.notValid(itemVal) ||
                            !TP.isReferenceType(itemVal)) {
                            thisType.endChangedAddress();

                            return;
                        }

                        //  This 'set' call will take care of registering the
                        //  changed address.
                        itemVal.set(
                            TP.tpc(
                                tail,
                                TP.hc('buildout', shouldBuild)),
                            attributeValue,
                            false);

                        thisType.endChangedAddress();
                    }.bind(this), queryParts);
            }
        }

        return targetObj;
    }

    //  Retrieve what's at the first part of access path in targetObj

    val = targetObj.get(head);

    //  If we should create structural data and targetObj either doesn't have a
    //  value or doesn't have a reference type value at the place pointed to by
    //  'head', then we create a reference type (either an Object or an Array)
    //  and set it into place.
    if (shouldBuild &&
        (TP.notValid(val) || !TP.isReferenceType(val))) {
        firstSimplePath = TP.tpc(tail).getFirstSimplePath();
        if (TP.isNumber(firstSimplePath.asNumber())) {
            val = TP.ac();
        } else {
            val = TP.lang.Object.construct();
            val.defineAttribute(firstSimplePath);
        }

        setPath = TP.tpc(
                    head,
                    TP.hc('buildout', shouldBuild));
        targetObj.set(setPath, val, false);

        //  If the setter path created structure, we flip our value of that flag
        //  to 'true' to 'propagate it up' the setter chain and rest the setter
        //  path's value back to 'false' for future runs. Note that we only do
        //  this is the setter path's value is 'true'.
        if (TP.isTrue(setPath.$get('$createdStructure'))) {
            this.$set('$createdStructure', true, false);
            setPath.$set('$createdStructure', false, false);
        }
    }

    if (TP.notValid(val) || !TP.isReferenceType(val)) {
        //  Had an access character and needed a reference type, but we can't
        //  create the Object (probably had shouldBuild turned off)
        return;
    }

    //  only continue if the result object can stay with the program :)
    if (TP.isString(tail) && TP.canInvoke(val, 'set')) {
        thisType.startChangedAddress(head);

        setPath = TP.tpc(
                    tail,
                    TP.hc('buildout', shouldBuild));

        //  This 'set' call will take care of registering the changed address.
        val.set(setPath, attributeValue, false);

        //  If the setter path created structure, we flip our value of that flag
        //  to 'true' to 'propagate it up' the setter chain and rest the setter
        //  path's value back to 'false' for future runs. Note that we only do
        //  this is the setter path's value is 'true'.
        if (TP.isTrue(setPath.$get('$createdStructure'))) {
            this.$set('$createdStructure', true, false);
            setPath.$set('$createdStructure', false, false);
        }

        thisType.endChangedAddress();

        //  typically we want to return the original object from a set()
        return targetObj;
    }

    //  Had an access character, but we can't compute the path.
    return;
});

//  ------------------------------------------------------------------------

TP.path.ComplexTIBETPath.Inst.defineMethod('$executeObjectSet',
function(targetObj, attributeValue, shouldSignal) {

    /**
     * @method $executeObjectSet
     * @summary Executes the path in a 'set' fashion against an object of type
     *     'Object'.
     * @param {targetObj} Object The object to execute the receiver against to
     *     set data.
     * @param {attributeValue} Object The object to use as the value to set
     *     into the target object.
     * @param {shouldSignal} Boolean If false, no signaling occurs. Defaults to
     *     targetObj.shouldSignalChange().
     * @returns {Object|undefined} The targetObj or undefined.
     */

    var path,

        parts,
        head,
        tail,

        thisType,
        shouldBuild,

        val,

        queryParts,

        attrIsNumber,
        firstSimplePath,

        setPath;

    path = this.$get('$transformedPath');

    parts = this.$extractPathHeadAndTail(path);
    head = parts.at(0);
    tail = parts.at(1);

    thisType = this.getType();

    //  Whether or not we build structures depends on whether we are configured
    //  to build structures. If the we have no configuration one way or the
    //  other (neither true or false), then however the source object is
    //  configured will be used.
    shouldBuild = TP.ifInvalid(this.$get('buildout'),
                                targetObj.$get('buildout'));

    if (/,/.test(head)) {
        //  Make sure to strip off the leading '[' and trailing ']'
        head = head.slice(1, head.getSize() - 1);

        queryParts = head.split(',');

        //  If there is no tail, that means that there was nothing left
        //  after consuming our own head. In that case, we just set our own
        //  items using the supplied attribute value.
        if (TP.notValid(tail)) {
            targetObj.performOver(
                    function(item, index, count) {

                        var op;

                        if (TP.notValid(attributeValue)) {
                            op = TP.DELETE;
                        } else if (TP.isDefined(targetObj.get(index))) {
                            op = TP.UPDATE;
                        } else {
                            op = TP.CREATE;
                        }

                        thisType.startChangedAddress(index);

                        thisType.registerChangedAddress(
                            thisType.getChangedAddress(), op);

                        targetObj.set(index, attributeValue, false);

                        thisType.endChangedAddress();
                    }, queryParts);
        } else {
            //  Otherwise, we take each one of our items and send it a 'set'
            //  message with the attribute value.

            firstSimplePath = TP.tpc(tail).getFirstSimplePath();
            attrIsNumber = TP.isNumber(firstSimplePath.asNumber());

            targetObj.performOver(
                function(item, index, count) {

                    var itemVal,
                        op;

                    itemVal = item;

                    thisType.startChangedAddress(index);

                    //  If item is not valid, or it's not a reference type,
                    //  then we blow away the entry and make it a reference
                    //  type - we need to set the slot...
                    if (shouldBuild &&
                        (TP.notValid(itemVal) ||
                         !TP.isReferenceType(itemVal))) {

                        //  If the slot was already defined, but wasn't a
                        //  reference type, then we're just updating it.
                        if (TP.isDefined(itemVal)) {
                            op = TP.UPDATE;
                        } else {
                            op = TP.CREATE;
                            targetObj.defineAttribute(index);
                        }

                        if (attrIsNumber) {
                            itemVal = TP.ac();
                        } else {
                            itemVal = TP.lang.Object.construct();
                            itemVal.defineAttribute(firstSimplePath);
                        }

                        //  And we set it back onto the targetObj
                        targetObj.set(index, itemVal, false);

                        //  Need to register this as a changed address since we
                        //  altered what was at this slot.
                        thisType.registerChangedAddress(
                            thisType.getChangedAddress(), op);

                        //  Make sure to let this path know that we created
                        //  structure - this makes a difference when signaling
                        //  change.
                        this.$set('$createdStructure', true, false);
                    }

                    if (TP.notValid(itemVal) ||
                        !TP.isReferenceType(itemVal)) {
                        thisType.endChangedAddress();

                        return;
                    }

                    //  This 'set' call will take care of registering the
                    //  changed address.
                    itemVal.set(
                            TP.tpc(
                                tail,
                                TP.hc('buildout', shouldBuild)),
                            attributeValue,
                            false);

                    thisType.endChangedAddress();
                }.bind(this), queryParts);
        }

        return targetObj;
    }

    //  Retrieve what's at the first part of access path in targetObj

    val = targetObj.get(head);

    //  If we should create structural data and targetObj either doesn't have a
    //  value or doesn't have a reference type value at the place pointed to by
    //  'head', then we create a reference type (either an Object or an Array)
    //  and set it into place.
    if (shouldBuild &&
        (TP.notValid(val) || !TP.isReferenceType(val))) {

        firstSimplePath = TP.tpc(tail).getFirstSimplePath();
        if (TP.isNumber(firstSimplePath.asNumber())) {
            val = TP.ac();
        } else {
            val = TP.lang.Object.construct();
            val.defineAttribute(firstSimplePath);
        }

        setPath = TP.tpc(
                    head, TP.hc('buildout', shouldBuild));
        targetObj.set(setPath, val, false);

        if (TP.isTrue(setPath.$get('$createdStructure'))) {
            this.$set('$createdStructure', true, false);
            setPath.$set('$createdStructure', false, false);
        }
    }

    if (TP.notValid(val) || !TP.isReferenceType(val)) {
        //  Had an access character and needed a reference type, but we can't
        //  create the Object (probably had shouldBuild turned off)
        return;
    }

    //  only continue if the result object can stay with the program :)
    if (TP.isString(tail) && TP.canInvoke(val, 'set')) {
        thisType.startChangedAddress(head);

        setPath = TP.tpc(
                    tail, TP.hc('buildout', shouldBuild));

        //  This 'set' call will take care of registering the changed address.
        val.set(setPath, attributeValue, false);

        if (TP.isTrue(setPath.$get('$createdStructure'))) {
            this.$set('$createdStructure', true, false);
            setPath.$set('$createdStructure', false, false);
        }

        thisType.endChangedAddress();

        //  typically we want to return the original object from a set()
        return targetObj;
    }

    //  Had an access character, but we can't compute the path.
    return;
});

//  ------------------------------------------------------------------------

TP.path.ComplexTIBETPath.Inst.defineMethod('$extractPathHeadAndTail',
function(aPath) {

    /**
     * @method $extractPathHeadAndTail
     * @summary Returns the head and tail of the supplied path.
     * @param {String} aPath The path to extract the head and tail from.
     * @returns {String[]} A pair of the [head, tail].
     */

    var dottedPath,

        parts,

        head,
        tail;

    //  Split along '[', if there are some, and add a leading '.' (unless that
    //  bracket already has a leading '.')
    dottedPath = aPath.replace(/([^\.])\[/, '$1.[');
    parts = dottedPath.split('.');

    //  If the first item was empty, then slice it off.
    if (dottedPath.at(0) === '') {
        parts = parts.slice(1);
    }

    //  The head will always be the first item
    head = parts.at(0);

    //  If we ended up with more than 2 parts, slice off the first one and join
    //  the rest together with a '.'
    if (parts.getSize() > 2) {
        tail = parts.slice(1).join('.');
    } else {
        //  Otherwise, the tail is just the second item.
        tail = parts.at(1);
    }

    return TP.ac(head, tail);
});

//  ------------------------------------------------------------------------

TP.path.ComplexTIBETPath.Inst.defineMethod('getFirstSimplePath',
function() {

    /**
     * @method getFirstSimplePath
     * @summary Returns the first 'simple path' of the receiver. For instance,
     *     in a simple path such as '1.2.3', this method will return '1'.
     * @returns {String} The first simple path of the receiver.
     */

    var srcPath,

        paths,
        firstPath;

    srcPath = this.$get('srcPath');

    //  First, split by '.'
    paths = srcPath.split('.');

    firstPath = paths.first();

    if (/[,:]/.test(firstPath)) {

        //  Strip off the leading and trailing '[' and ']'
        firstPath = firstPath.slice(1, firstPath.getSize() - 1);

        if (TP.regex.HAS_COLON.test(firstPath)) {
            firstPath = firstPath.split(':').first();
        } else {
            firstPath = firstPath.split(',').first();
        }
    }

    return firstPath;
});

//  ========================================================================
//  TP.path.XMLPath
//  ========================================================================

/**
 * @type {TP.path.XMLPath}
 */

//  ------------------------------------------------------------------------

TP.path.AccessPath.defineSubtype('XMLPath');

//  This is an abstract supertype - need a concrete subtype to get real work
//  done.
TP.path.XMLPath.isAbstract(true);

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  The path we use to register interest for change notification
TP.path.XMLPath.Inst.defineAttribute('$interestedPath');

//  The transformed path we actually execute - it may have templated
//  expressions.
TP.path.XMLPath.Inst.defineAttribute('$transformedPath');

//  Whether or not to make scalar data slots on execution
TP.path.XMLPath.Inst.defineAttribute('buildvals');

//  -----------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.path.XMLPath.Inst.defineMethod('init',
function(aPath, config) {

    /**
     * @method init
     * @summary Initialize the instance.
     * @param {String} aPath The String to build the instance from.
     * @param {TP.core.Hash} config The configuration for this path.
     * @returns {TP.path.XMLPath} The receiver.
     */

    this.callNextMethod();

    if (TP.isHash(config)) {
        this.set('buildvals', config.atIfInvalid('buildvals', true));
        this.$set('shouldCollapse',
                    config.atIfInvalid('shouldCollapse', true),
                    false);
    } else {
        this.set('buildvals', true);
        this.$set('shouldCollapse', true, false);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.path.XMLPath.Inst.defineMethod('$addChangedAddressFromNode',
function(aNode, prevNode, aValue) {

    /**
     * @method $addChangedAddressFromNode
     * @summary Adds the supplied node's address and action to
     *     TP.path.AccessPath's 'changed address list'.
     * @param {Node} aNode The Node to extract the address and action from.
     * @param {Node} prevNode Any previous content that was at the place in the
     *     data structure where aNode is now. This is used to determine what
     *     kind of change action to compute.
     * @param {Object} aValue The value that the node is being set to. Note that
     *     this isn't necessary a Node / markup value, but is useful for
     *     comparison purposes.
     * @returns {TP.path.XMLPath} The receiver.
     */

    var address,

        attrName,
        elem,

        action;

    if (TP.isAttributeNode(aNode)) {

        attrName = TP.attributeGetLocalName(aNode);
        elem = TP.attributeGetOwnerElement(aNode);

        //  We need to test the owner element to see if it already has an
        //  appropriate action (i.e. TP.CREATE if this attribute has just been
        //  created). Otherwise, we set it to TP.UPDATE.

        if (TP.notValid(action = TP.elementGetChangeAction(
                                                elem, TP.ATTR + attrName))) {
            action = TP.UPDATE;
        }

        //  Obtain the node's document position - we will use this as our
        //  address.
        address = TP.nodeGetDocumentPosition(aNode);

    } else if (TP.isTextNode(aNode)) {

        elem = aNode.parentNode;

        //  We need to test the owner element to see if it already has an
        //  appropriate action (i.e. TP.CREATE if this text node has just been
        //  created). Otherwise, we set it to TP.UPDATE.

        if (TP.notValid(action = TP.elementGetChangeAction(elem, TP.SELF))) {
            action = TP.UPDATE;
        }

        //  Obtain our parent node's document position - we will use this as
        //  our address.
        address = TP.nodeGetDocumentPosition(aNode.parentNode);

    } else if (TP.isElement(elem = aNode)) {

        //  We need to flag changes on the content element, but not if the
        //  '$$getContentForSetOperation()' created this element. It will
        //  have tagged it with a TP.CREATE action already.

        if (TP.notValid(action = TP.elementGetChangeAction(elem, TP.SELF))) {
            action = TP.UPDATE;
        }

        //  Obtain the node's document position - we will use this as our
        //  address.
        address = TP.nodeGetDocumentPosition(aNode);
    }

    //  If we're doing a TP.UPDATE *with a valid value*, we message ourself to
    //  determine whether to change an 'update' to a 'delete'/'create'
    //  combination. If so, then we change to registering a TP.DELETE, followed
    //  by a TP.CREATE for that. Note that this is an invalid value (null or
    //  undefined) then the new value is 'nulling out' the old and it is indeed
    //  an update, not a combination of delete followed by create.
    if (TP.isValid(aValue) &&
        action === TP.UPDATE &&
        this.$updateOpsBecomeDeleteInsertOps(aNode, prevNode)) {
        TP.path.AccessPath.registerChangedAddress(address, TP.DELETE);
        TP.path.AccessPath.registerChangedAddress(address, TP.CREATE);
    } else {
        TP.path.AccessPath.registerChangedAddress(address, action);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.path.XMLPath.Inst.defineMethod('checkValueEquality',
function(objectA, objectB) {

    /**
     * @method checkValueEquality.
     * @summary Checks to see if the two supplied parameters 'lead to' equal
     *     values. This is used when trying to determine whether or not to
     *     proceed with a 'set' operation (and broadcast changes).
     * @description This method takes into account the kind of data that this
     *     path manages when doing it's comparison.
     * @param {objectA} Object The first object to compare.
     * @param {objectB} Object The second object to compare.
     * @returns {Boolean} Whether or not the two values are equal.
     */

    if (TP.isArray(objectA) && objectA.getSize() === 1) {
        return TP.equal(objectA.first(), objectB);
    }

    if (TP.isArray(objectB) && objectB.getSize() === 1) {
        return TP.equal(objectA, objectB.first());
    }

    if (TP.isNode(objectA) && !TP.isReferenceType(objectB)) {
        return TP.nodeGetTextContent(objectA) === TP.str(objectB);
    }

    if (!TP.isReferenceType(objectA) && TP.isNode(objectB)) {
        return TP.str(objectA) === TP.nodeGetTextContent(objectB);
    }

    return TP.equal(objectA, objectB);
});

//  ------------------------------------------------------------------------

TP.path.XMLPath.Inst.defineMethod('executeGet',
function(targetObj, varargs) {

    /**
     * @method executeGet
     * @summary Returns the result of executing the path in a 'get' fashion -
     *     i.e. with the intent of retrieving data from the supplied target
     *     object.
     * @param {targetObj} Object The object to execute the receiver against to
     *     get data.
     * @param {arguments} varargs The arguments to execute the get with. The
     *     first argument should be the object to execute the receiver against
     *     to retrieve data. Any remaining arguments will be used as values for
     *     a templated substitution in the path itself.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidNode
     * @returns {Object} The result of executing a 'get' against the target
     *     object using the receiver.
     */

    var target,

        args,

        srcPath,

        executedPaths,

        natTargetObj,

        path,

        nodes,
        finalValue,

        nodePath,

        addresses,

        doc,
        sourceObjectID,

        interestedPath,

        extractWith;

    target = targetObj;

    if (TP.notValid(target)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    if (TP.isKindOf(target, TP.core.XMLContent)) {
        target = target.get('data');
    }

    //  This kind of path only works against XML
    if (!TP.isNode(target) && !TP.isKindOf(target, TP.dom.Node)) {
        if (TP.isWindow(target) || TP.isKindOf(target, TP.core.Window)) {
            target = TP.unwrap(target).document;
            if (!TP.isXMLDocument(target)) {
                return this.raise('InvalidDocument');
            }
        } else {
            return this.raise('TP.sig.InvalidNode');
        }
    }

    srcPath = this.$get('srcPath');

    //  If the path is empty or just '.', then that's the shortcut to just
    //  return the target object itself.
    if (TP.isEmpty(srcPath) || TP.regex.ONLY_PERIOD.test(srcPath)) {
        return target;
    }

    executedPaths = TP.path.AccessPath.$getExecutedPaths().atPutIfAbsent(
                    TP.id(target),
                    TP.hc());

    executedPaths.atPut(srcPath, this);

    path = this.$get('srcPath');

    //  Fill in any templated expressions in the path (which must be numeric
    //  positions) with data from the passed arguments.
    if (TP.regex.HAS_ACP.test(path)) {
        //  Grab the arguments and slice the first one off (since it's the
        //  target, which we already have).
        args = TP.args(arguments, 1);

        path = path.transform(args);
    }
    this.$set('$transformedPath', path, false);

    //  Make sure the target object is unwrapped
    natTargetObj = TP.unwrap(target);

    nodes = TP.nodeEvaluatePath(
                natTargetObj, path, this.getPathType(), false);

    //  If the return value is not an Array, that means a scalar value was
    //  returned (because we forced false on autoCollapse).
    if (!TP.isArray(nodes)) {

        //  Capture the scalar as the final value - we want to return this.
        finalValue = nodes;

        //  Compute a 'node path' by starting with the path.
        nodePath = path;

        //  If there's a 'wrapping scalar conversion' (i.e. 'string(...)'), then
        //  we need to strip it off of the path so that we can get to nodes, not
        //  scalar values.
        if (TP.regex.XPATH_HAS_SCALAR_CONVERSION.test(nodePath)) {
            nodePath = TP.regex.XPATH_HAS_SCALAR_CONVERSION.match(
                                                        nodePath).at(1);
        }

        //  If the path ends with some sort of attribute path, then we
        //  reevaluate, using a construct at the end that will return an
        //  Attribute *node*.
        if (TP.regex.ATTRIBUTE_ENDS.test(nodePath)) {
            nodes = TP.nodeEvaluatePath(
                        natTargetObj,
                        nodePath +
                            '/../' +
                            nodePath.slice(nodePath.indexOf('@')),
                        this.getPathType(),
                        false);
        } else if (TP.regex.TEXT_NODE_ENDS.test(nodePath)) {
            nodes = TP.nodeEvaluatePath(
                        natTargetObj,
                        nodePath.slice(0, -7),
                        this.getPathType(),
                        false);
        } else {
            //  Otherwise, reevaluate and just try to capture the Node above
            //  the result.
            nodes = TP.nodeEvaluatePath(
                        natTargetObj,
                        nodePath + '/..',
                        this.getPathType(),
                        false);
        }
    }

    addresses = TP.ac();

    //  Gather all addresses from the returned nodes. Each call to
    //  TP.nodeGetAncestorPositions() returns an Array of positions all the way
    //  down
    nodes.perform(
            function(aNode) {
                var address;

                address = TP.nodeGetAncestorPositions(aNode, true);

                if (address !== TP.NOT_FOUND) {
                    addresses = addresses.concat(address);
                }
            });

    //  Now unique the values in addresses, in case there were duplicates
    addresses.unique();

    doc = !TP.isDocument(natTargetObj) ?
                natTargetObj.ownerDocument :
                natTargetObj;

    sourceObjectID = TP.wrap(doc).getID();

    //  Get our 'interested path' (the path representation used to register
    //  interest for change notification). This will default to the path we just
    //  created above.
    interestedPath = TP.ifInvalid(this.get('$interestedPath'), path);

    TP.path.AccessPath.registerObservedAddresses(
                                addresses, sourceObjectID, interestedPath);

    //  If there is a valid final value *or* we were trying to do a scalar
    //  conversion (and maybe got a null value - which is what we would want if
    //  we were trying to get scalar and the node was empty or some such) then
    //  just return the final value here.
    if (TP.isValid(finalValue) ||
        TP.regex.XPATH_HAS_SCALAR_CONVERSION.test(path)) {
        return finalValue;
    }

    //  To maintain consistency with other data types, if we ended up with an
    //  empty Array of result nodes and the caller has defined a property to
    //  extract a value with, then just return the result of doing that.
    if (TP.isEmptyArray(nodes)) {
        extractWith = this.$get('extractWith');

        if (TP.notEmpty(extractWith)) {
            return TP.ac();
        }
    }

    return this.processFinalValue(nodes, target);
});

//  -----------------------------------------------------------------------

TP.path.XMLPath.Inst.defineMethod('executeSet',
function(targetObj, attributeValue, shouldSignal, varargs) {

    /**
     * @method executeSet
     * @summary Executes the path in a 'set' fashion - i.e. with the intent of
     *     setting the supplied data into the supplied target object.
     * @param {targetObj} Object The object to execute the receiver against to
     *     set data.
     * @param {attributeValue} Object The object to use as the value to set
     *     into the target object.
     * @param {shouldSignal} Boolean If false, no signaling occurs. Defaults to
     *     targetObj.shouldSignalChange().
     * @param {arguments} varargs Any remaining arguments will be used as values
     *     for a templated substitution in the path itself.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidPath
     * @returns {TP.path.XPathPath} The receiver.
     */

    var target,

        args,
        oldVal,

        newVal,

        natTargetObj,
        targetDoc,
        targetTPDoc,

        signalChange,

        leaveFlaggedChanges,

        path,

        traversalLevel,

        createdStructure,
        changeAction,

        sigFlag,

        content,

        mutatedStructure,

        attrValue,
        value,

        oldcontent,

        affectedElems,

        tpcontent,

        ownerElem,

        len,
        i,

        contentnode,

        executedPaths,
        obsAddresses;

    if (TP.notValid(targetObj)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    target = targetObj;

    if (TP.isKindOf(target, TP.core.XMLContent)) {
        target = target.$get('data');
    }

    //  This kind of path only works against XML
    if (!TP.isNode(target) && !TP.isKindOf(target, TP.dom.Node)) {
        if (TP.isWindow(target) || TP.isKindOf(target, TP.core.Window)) {
            target = TP.wrap(TP.unwrap(target).document);
        } else {
            return this.raise('TP.sig.InvalidNode');
        }
    }

    if (TP.regex.HAS_ACP.test(this.$get('srcPath'))) {
        //  Grab the arguments and slice the first three off (since they're
        //  target, attributeValue and shouldSignal which we already have).
        args = TP.args(arguments, 3);

        args.unshift(target);
        oldVal = this.executeGet.apply(this, args);
    } else {
        oldVal = this.executeGet(target);
    }

    newVal = attributeValue;

    /* eslint-disable no-extra-parens */
    if (this.$get('shouldCollapse')) {

        //  By default, if newVal is an Array and is empty, collapsing it will
        //  set newVal to null, but we don't want that there. So we only do this
        //  if it's not empty
        if (TP.notEmpty(newVal)) {
            newVal = TP.collapse(newVal);
        }
    }
    /* eslint-enable no-extra-parens */

    //  If the old value is equal to the value that we're setting, then there
    //  is nothing to do here and we exit. This is important to avoid endless
    //  recursion when doing a 'two-ended bind' to data referenced by this path
    //  and to avoid a lot of unnecessary signaling.

    //  Note that we handle empty Arrays specially here since, if we're not
    //  reducing Arrays, an empty Array handed in as the value will compare as
    //  'true' here and this routine will exit.
    if (this.checkValueEquality(oldVal, newVal)) {
        if (TP.isEmptyArray(newVal)) {
            void 0;
        } else {
            return oldVal;
        }
    }

    natTargetObj = TP.unwrap(target);

    targetDoc = !TP.isDocument(natTargetObj) ?
                        TP.wrap(natTargetObj.ownerDocument) :
                        TP.wrap(natTargetObj);

    targetTPDoc = TP.wrap(targetDoc);

    if (TP.isValid(shouldSignal)) {
        signalChange = shouldSignal;
    } else if (TP.isValid(targetTPDoc)) {
        signalChange = targetTPDoc.shouldSignalChange();
    }

    path = this.$get('srcPath');

    //  If the path has ACP expressions ('{{...}}') in it, then template them
    //  out with the source object(s) from the 4th parameter onwards.
    if (TP.regex.HAS_ACP.test(path)) {
        //  Grab the arguments and slice the first three off (since they're
        //  target, attributeValue and shouldSignal which we already have).
        args = TP.args(arguments, 3);

        //  Run the transform with the arguments after the 3rd one.
        path = path.transform(args);
    }
    this.$set('$transformedPath', path, false);

    traversalLevel = TP.path.SimpleTIBETPath.$get('$traversalLevel');
    if (traversalLevel === 0) {

        //  Empty the changed addresses before we start another run.
        TP.path.AccessPath.$getChangedAddresses().empty();
    }

    //  First, we have to get the nodes that we can use to set the value - if
    //  we can't do that, then we're dead in the water...

    //  Note here how we pass 'true' to *always* flag changes in any content
    //  that we generate and that we also pass the *original* target object (so
    //  that we can query it for things like 'shouldBuild').
    if (TP.notValid(content = this.$$getContentForSetOperation(
                                            natTargetObj, true, targetObj))) {

        //  unable to build nodes...path may not be specific enough
        TP.ifWarn() ?
            TP.warn(TP.annotate(
                        this,
                        'Unable to set value for path: ' + path)) : 0;

        return this;
    }

    //  If the target object is flagging changes, then we set a flag to leave
    //  the flagged changes to true. Otherwise, we set the flag to false to
    //  strip them out.
    if (TP.wrap(target).shouldFlagChanges()) {
        leaveFlaggedChanges = true;
    } else {
        leaveFlaggedChanges = false;
    }

    //  Turn off 'DOMContentLoaded' signaling here - but capture the current
    //  setting to restore it before we exit this method.
    sigFlag = TP.sys.shouldSignalDOMLoaded();
    TP.sys.shouldSignalDOMLoaded(false);

    //  At this point, content will always be a TP.NODESET... see if we can
    //  collapse it down to a single node. Our tests later are optimized for
    //  single nodes, so it's better if we collapse down.
    content = TP.collapse(content);

    createdStructure = false;

    if (!TP.isArray(content)) {
        if (TP.isElement(content)) {
            changeAction = TP.elementGetChangeAction(content, TP.SELF);
        } else if (TP.isAttributeNode(content)) {
            changeAction = TP.elementGetChangeAction(
                                TP.attributeGetOwnerElement(content),
                                TP.ATTR + content.name);
        } else if (TP.isTextNode(content)) {
            changeAction = TP.elementGetChangeAction(
                                content.parentNode,
                                TP.SELF);
        }

        /* eslint-disable no-extra-parens */
        createdStructure = (changeAction === TP.CREATE);
        /* eslint-enable no-extra-parens */
    } else {
        createdStructure =
            TP.isValid(
                    content.detect(
                        function(item) {
                            if (TP.isElement(item)) {
                                return TP.elementGetChangeAction(
                                            item, TP.SELF) === TP.CREATE;
                            }
                            return false;
                        }));
    }

    //  ---
    //  update target node values
    //  ---

    //  normalize inbound nodes to elements so we don't try to put a document
    //  where it can't be appended
    attrValue = TP.isDocument(newVal) ? TP.elem(newVal) : newVal;

    //  there are four primary variations we have to account for if we're
    //  going to get this correct: S-M, S-S, M-M, M-S. also, we have to keep
    //  in mind that we've got a second set of considerations about elements
    //  vs. attributes, and a third set around nodes vs. javascript objects

    affectedElems = TP.ac();

    if (TP.isNode(content)) {

        //  If the attrValue is a Node, clone it so that we don't remove it
        //  from it's original DOM, etc.
        if (TP.isNode(value = attrValue)) {
            value = TP.nodeCloneNode(attrValue, true);
        }

        oldcontent = TP.nodeCloneNode(content);

        //  Finalize the set value.
        mutatedStructure = this.valueIsStructural(content, value);
        value = this.finalizeSetValue(content, value);

        //  If the value is null or undefined, then we're removing the value so
        //  empty the content.
        if (TP.notValid(value)) {
            TP.nodeEmptyContent(content);
        } else {
            //  leverage TP.dom.Node wrappers to manage update intelligently
            tpcontent = TP.wrap(content);
            tpcontent.setRawContent(value);
        }

        //  99% is single value targeting a single element, attribute node or
        //  text node
        if (TP.isElement(content)) {
            ownerElem = TP.isDocument(content.parentNode) ?
                        content :
                        content.parentNode;

            //  add the element's address to the list of changed addresses.
            affectedElems.push(content);

            //  Note here how we pass in 'false', because we don't want to
            //  overwrite any existing change flag record for the TP.SELF
            //  address on this element.
            TP.elementFlagChange(content, TP.SELF, TP.UPDATE, false);

            this.$addChangedAddressFromNode(content, oldcontent, value);

            if (TP.notEmpty(
                TP.elementGetChangeAction(ownerElem, TP.SELF))) {
                affectedElems.push(ownerElem);
                this.$addChangedAddressFromNode(ownerElem, null, false);
            }
        } else if (TP.isAttributeNode(content)) {
            ownerElem = TP.attributeGetOwnerElement(content);

            //  add the attribute's address to the list of changed addresses.
            affectedElems.push(ownerElem);

            //  Note here how we pass in 'false', because we don't want to
            //  overwrite any existing change flag record for the TP.ATTR +
            //  content.name address on this element.
            TP.elementFlagChange(
                    ownerElem, TP.ATTR + content.name, TP.UPDATE, false);

            this.$addChangedAddressFromNode(content, null, false);
        } else if (TP.isTextNode(content)) {
            ownerElem = content.parentNode;

            //  Add the element's address to the list of changed addresses.
            affectedElems.push(ownerElem);

            //  Note here how we pass in 'false', because we don't want to
            //  overwrite any existing change flag record for the TP.ATTR +
            //  content.name address on this element.
            TP.elementFlagChange(
                    ownerElem, TP.SELF, TP.UPDATE, false);

            this.$addChangedAddressFromNode(content, null, false);
        }
    } else if (TP.isArray(content)) {
        len = content.getSize();
        for (i = 0; i < len; i++) {
            contentnode = content.at(i);

            //  If the attrValue is a Node, clone it so that we don't remove it
            //  from it's original DOM, etc.
            if (TP.isNode(value = attrValue)) {
                value = TP.nodeCloneNode(attrValue, true);
            }

            oldcontent = TP.nodeCloneNode(contentnode);

            mutatedStructure = this.valueIsStructural(contentnode, value);
            value = this.finalizeSetValue(contentnode, value);

            //  If the value is null or undefined, then we're removing the value
            //  so empty the content.
            if (TP.notValid(value)) {
                TP.nodeEmptyContent(contentnode);
            } else {
                //  leverage TP.dom.Node wrappers to manage update
                //  intelligently
                tpcontent = TP.wrap(contentnode);
                tpcontent.setRawContent(value);
            }

            if (TP.isNode(contentnode)) {
                if (TP.isElement(contentnode)) {
                    ownerElem = TP.isDocument(contentnode.parentNode) ?
                                contentnode :
                                contentnode.parentNode;

                    //  Add the element's address to the list of changed
                    //  addresses.
                    affectedElems.push(contentnode);

                    //  Note here how we pass in 'false', because we don't
                    //  want to overwrite any existing change flag record
                    //  for the TP.SELF address on this element.
                    TP.elementFlagChange(
                            contentnode, TP.SELF, TP.UPDATE, false);

                    this.$addChangedAddressFromNode(contentnode,
                                                    oldcontent,
                                                    value);

                    if (TP.notEmpty(TP.elementGetChangeAction(
                                                    ownerElem, TP.SELF))) {
                        affectedElems.push(ownerElem);
                        this.$addChangedAddressFromNode(ownerElem,
                                                        null,
                                                        value);
                    }
                } else if (TP.isAttributeNode(contentnode)) {
                    ownerElem = TP.attributeGetOwnerElement(contentnode);

                    //  Add the attribute's address to the list of changed
                    //  addresses.
                    affectedElems.push(ownerElem);

                    //  Note here how we pass in 'false', because we don't
                    //  want to overwrite any existing change flag record
                    //  for the TP.ATTR + contentnode.name address on this
                    //  element.
                    TP.elementFlagChange(
                            ownerElem,
                            TP.ATTR + contentnode.name,
                            TP.UPDATE,
                            false);

                    this.$addChangedAddressFromNode(contentnode,
                                                    null,
                                                    value);
                } else if (TP.isTextNode(contentnode)) {
                    ownerElem = contentnode.parentNode;

                    //  Add the attribute's address to the list of changed
                    //  addresses.
                    affectedElems.push(ownerElem);

                    //  Note here how we pass in 'false', because we don't
                    //  want to overwrite any existing change flag record
                    //  for the TP.ATTR + contentnode.name address on this
                    //  element.
                    TP.elementFlagChange(
                            ownerElem,
                            TP.SELF,
                            TP.UPDATE,
                            false);

                    this.$addChangedAddressFromNode(contentnode,
                                                    null,
                                                    value);
                } else {
                    //  not a node or collection of them? only real option is
                    //  that the XPath returned a scalar value, which we can't
                    //  process anyway...
                    TP.ifWarn() ?
                        TP.warn(TP.annotate(
                                    this,
                                    'Path probably points to scalar value.' +
                                    ' Unable to set value.')) : 0;

                    //  Make sure to put the 'shouldSignalDOMLoaded' flag back
                    //  to it's prior setting before exiting.
                    TP.sys.shouldSignalDOMLoaded(sigFlag);

                    return this;
                }
            }
        }
    } else {
        //  not a node or collection of them? only real option is that the
        //  XPath returned a scalar value, which we can't process anyway...

        TP.ifWarn() ?
            TP.warn(TP.annotate(
                        this,
                        'Path probably points to scalar value.' +
                        ' Unable to set value.')) : 0;

        //  Make sure to put the 'shouldSignalDOMLoaded' flag back to it's prior
        //  setting before exiting.
        TP.sys.shouldSignalDOMLoaded(sigFlag);

        return this;
    }

    //  If we 'created structure', that means that all of the previously
    //  executed paths need to be run, because they could now refer to new
    //  addresses.
    if (createdStructure) {

        //  Grab the Array of executed paths registered under the ID of the
        //  target object.
        executedPaths = TP.path.AccessPath.$getExecutedPaths().at(
                                                targetTPDoc.getID());

        if (TP.notEmpty(executedPaths)) {

            //  Grab the Array of observed addresses registered under the ID
            //  of the target object.
            obsAddresses = TP.path.AccessPath.$getObservedAddresses().at(
                                            TP.id(targetObj));

            //  Empty it if it isn't already.
            if (TP.notEmpty(obsAddresses)) {
                obsAddresses.empty();
            }

            //  Rerun all of the paths in a 'get' mode. This will cause the
            //  observed addresses Array to fill back up with (possibly
            //  different) addresses.
            executedPaths.perform(
                    function(pathEntry) {
                        pathEntry.last().executeGet(target);
                    });
        }
    }

    if (signalChange) {

        //  If we mutated structure, then we need to clear the path information
        //  registered for the addresses 'under' the node that changed.
        if (mutatedStructure) {
            this.updateRegistrationsBeforeSignaling(targetTPDoc);
        }

        //  Send the changed signal
        this.sendChangedSignal(target);

        //  If we mutated structure, we may very well have removed some
        //  structure. After signaling that fact, we should no longer keep those
        //  registrations around.
        if (mutatedStructure) {
            this.updateRegistrationsAfterSignaling(targetTPDoc);
        }
    }

    //  If the node wasn't originally configured to flag changes, then (now
    //  that we've registered all addresses that have changed) we need to
    //  strip it out.
    if (!leaveFlaggedChanges) {
        affectedElems.perform(
                function(anElem) {
                    TP.elementStripChangeFlags(anElem);
                });
    }

    //  Make sure to put the 'shouldSignalDOMLoaded' flag back to it's prior
    //  setting before exiting.
    TP.sys.shouldSignalDOMLoaded(sigFlag);

    return this;
});

//  -----------------------------------------------------------------------

TP.path.XMLPath.Inst.defineMethod('finalizeSetValue',
function(content, value) {

    /**
     * @method finalizeSetValue
     * @summary 'Finalizes' the value used when calling executeSet(). This may
     *     adjust the value to allow for more intelligent placement in the
     *     storage data structure.
     * @param {content} Node The content node that the value will be placed
     *     into.
     * @param {value} Object The value to finalize.
     * @returns {Object} The finalized value.
     */

    if (TP.isNode(value)) {
        return value;
    }

    return TP.str(value);
});

//  ------------------------------------------------------------------------

TP.path.XMLPath.Inst.defineMethod('$$getContentForSetOperation',
function(aNode, flagChanges, targetObj) {

    /**
     * @method $$getContentForSetOperation
     * @summary Creates any content that is required in order to perform a
     *     'set' operation.
     * @param {aNode} Node The node to use as the common ancestor to build out
     *     any content that is required for a 'set' operation.
     * @param {Boolean} flagChanges True if any newly created nodes should be
     *     flagged.
     * @param {Object} targetObj The original target object that contains aNode
     *     in some form or fashion.
     * @returns {Node[]} The array of Nodes that got built.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.path.XMLPath.Inst.defineMethod('getPathType',
function() {

    /**
     * @method getPathType
     * @summary Returns the receiver's 'path type'.
     * @returns {String} A path type
     */

    //  Note here that we return null, allowing the low-level primitive call to
    //  determine the path type. Subtypes of this type can override this to
    //  specify the path type.
    return null;
});

//  ------------------------------------------------------------------------

TP.path.XMLPath.Inst.defineMethod('getPathParts',
function() {

    /**
     * @method getPathParts
     * @summary Returns the receiver's parts.
     * @returns {String[]} An Array of the receiver's parts.
     */

    return TP.getAccessPathParts(this.$get('srcPath'), 'xpointer');
});

//  ------------------------------------------------------------------------

TP.path.XMLPath.Inst.defineMethod('getPointerScheme',
function() {

    /**
     * @method getPointerScheme
     * @summary Returns the receiver's 'pointer scheme'.
     * @returns {String} An XPointer scheme depending on path type.
     */

    //  Note here that we return null, allowing the low-level primitive call to
    //  determine the path type. Subtypes of this type can override this to
    //  specify the path type.
    return null;
});

//  ------------------------------------------------------------------------

TP.path.XMLPath.Inst.defineMethod('$updateOpsBecomeDeleteInsertOps',
function(aNode, prevNode) {

    /**
     * @method $updateOpsBecomeDeleteInsertOps
     * @summary Returns whether 'update's to the data model should instead
     *     become 'delete'/'insert' pairs. This is dependent on the semantics of
     *     the underlying data structure.
     * @param {Node} aNode The current content Node.
     * @param {Node} prevNode Any previous content that was at the place in the
     *     data structure where aNode is now. This is used to determine what
     *     kind of change action to compute.
     * @returns {Boolean} Whether or not to change 'update's into
     *     'delete'/'insert's.
     */

    //  If we're doing a TP.UPDATE, but we're replacing a Node that had child
    //  Element content (detected either by new element child content or by
    //  previous Element content) then we return 'true' to turn 'update's into
    //  'delete/insert's.
    return TP.isCollectionNode(aNode) &&
               (TP.notEmpty(TP.nodeGetChildElements(aNode)) ||
                    TP.notEmpty(TP.nodeGetChildElements(prevNode)));
});

//  -----------------------------------------------------------------------

TP.path.XMLPath.Inst.defineMethod('valueIsStructural',
function(content, value) {

    /**
     * @method valueIsStructural
     * @summary Returns whether or not the value is considered 'structural', and
     *     will therefore 'mutate structure' if it is used as the value to set
     *     using the receiver.
     * @param {content} Node The content node that the value was placed into.
     * @param {value} Object The value to test.
     * @returns {Boolean} Whether or not the value is considered to be
     *     'structural'
     */

    return TP.isNode(value);
});

//  ========================================================================
//  TP.path.SimpleXMLPath
//  ========================================================================

TP.path.XMLPath.defineSubtype('SimpleXMLPath');

//  ------------------------------------------------------------------------

TP.path.SimpleXMLPath.Inst.defineMethod('$$getContentForSetOperation',
function(aNode, flagChanges, targetObj) {

    /**
     * @method $$getContentForSetOperation
     * @summary Creates any content that is required in order to perform a
     *     'set' operation.
     * @param {aNode} Node The node to use as the common ancestor to build out
     *     any content that is required for a 'set' operation.
     * @param {Boolean} flagChanges True if any newly created nodes should be
     *     flagged.
     * @param {Object} targetObj The original target object that contains aNode
     *     in some form or fashion.
     * @returns {Node[]} The array of Nodes that got built.
     */

    var path,
        attrName,

        shouldBuild,

        retVal;

    if (TP.notValid(path = this.$get('$transformedPath'))) {
        path = this.$get('srcPath');
    }

    //  We can create an Attribute, if this is an attribute-only path (and
    //  shouldBuild is true)
    if (TP.isElement(aNode) && TP.regex.ATTRIBUTE.test(path)) {

        attrName = path.slice(1);

        if (TP.elementHasAttribute(aNode, attrName, true)) {
            return TP.elementGetAttributeNode(aNode, attrName);
        }

        shouldBuild = TP.ifInvalid(this.$get('buildout'),
                                    targetObj.$get('buildout'));

        if (shouldBuild) {
            TP.elementSetAttribute(aNode, attrName, '', true);
            retVal = TP.elementGetAttributeNode(aNode, attrName);
            TP.elementFlagChange(aNode, TP.ATTR + attrName, TP.CREATE);
        }

        return retVal;
    }

    return null;
});

//  ========================================================================
//  TP.path.ElementPath
//  ========================================================================

TP.path.XMLPath.defineSubtype('ElementPath');

//  ------------------------------------------------------------------------

TP.path.ElementPath.Inst.defineMethod('$$getContentForSetOperation',
function(aNode, flagChanges, targetObj) {

    /**
     * @method $$getContentForSetOperation
     * @summary Creates any content that is required in order to perform a
     *     'set' operation.
     * @param {aNode} Node The node to use as the common ancestor to build out
     *     any content that is required for a 'set' operation.
     * @param {Boolean} flagChanges True if any newly created nodes should be
     *     flagged.
     * @param {Object} targetObj The original target object that contains aNode
     *     in some form or fashion.
     * @returns {Node[]} The array of Nodes that got built.
     */

    var path,
        content;

    if (TP.notValid(path = this.$get('$transformedPath'))) {
        path = this.$get('srcPath');
    }

    //  element schemes are fine as long as they reference an existing object.
    //  we can't build new content down an element path

    //  Note that TP.nodeEvaluateElementScheme() will only ever return one node
    //  (the 'path' down to the node must be unique).
    content = TP.nodeEvaluateElementScheme(aNode, path);

    if (!TP.isElement(content)) {
        TP.ifWarn() ?
            TP.warn(TP.annotate(
                        this,
                        'Unable to obtain content to set for path: ' +
                        path)) : 0;
    } else {
        //  To be API compliant, we wrap the single Element in an Array
        content = TP.ac(content);
    }

    return content;
});

//  ========================================================================
//  TP.path.XTensionPath
//  ========================================================================

TP.path.XMLPath.defineSubtype('XTensionPath');

//  ------------------------------------------------------------------------

TP.path.XTensionPath.Inst.defineMethod('$$getContentForSetOperation',
function(aNode, flagChanges, targetObj) {

    /**
     * @method $$getContentForSetOperation
     * @summary Creates any content that is required in order to perform a
     *     'set' operation.
     * @param {aNode} Node The node to use as the common ancestor to build out
     *     any content that is required for a 'set' operation.
     * @param {Boolean} flagChanges True if any newly created nodes should be
     *     flagged.
     * @param {Object} targetObj The original target object that contains aNode
     *     in some form or fashion.
     * @returns {Node[]} The array of Nodes that got built.
     */

    var path,
        content;

    if (TP.notValid(path = this.$get('$transformedPath'))) {
        path = this.$get('srcPath');
    }

    //  Evaluate the XTension syntax.
    content = TP.nodeEvaluateXTension(aNode, path, false);

    if (TP.notValid(content)) {
        TP.ifWarn() ?
            TP.warn(TP.annotate(
                        this,
                        'Unable to obtain content to set for path: ' +
                        path)) : 0;
    }

    return content;
});

//  ========================================================================
//  TP.path.CSSPath
//  ========================================================================

TP.path.XTensionPath.defineSubtype('CSSPath');

//  ------------------------------------------------------------------------

//  avoid binding and apply issues by creating our alias as a wrapper
TP.definePrimitive('cpc',
function(aPath, config) {

    /**
     * @method cpc
     * @summary Returns a newly initialized CSSPath instance.
     * @param {String} aPath The CSS path as a String.
     * @param {TP.core.Hash} config The configuration for this path.
     * @returns {TP.path.CSSPath} The new instance.
     */

    return TP.path.CSSPath.construct.apply(TP.path.CSSPath, arguments);
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.path.CSSPath.Inst.defineMethod('getPathType',
function() {

    /**
     * @method getPathType
     * @summary Returns the receiver's 'path type'.
     * @returns {String} A path type
     */

    return TP.CSS_PATH_TYPE;
});

//  ------------------------------------------------------------------------

TP.path.CSSPath.Inst.defineMethod('getPathParts',
function() {

    /**
     * @method getPathParts
     * @summary Returns the receiver's parts.
     * @returns {String[]} An Array of the receiver's parts.
     */

    return TP.getAccessPathParts(this.$get('srcPath'), 'css');
});

//  ------------------------------------------------------------------------

TP.path.CSSPath.Inst.defineMethod('getPointerScheme',
function() {

    /**
     * @method getPointerScheme
     * @summary Returns the receiver's 'pointer scheme'.
     * @returns {String} An XPointer scheme depending on path type.
     */

    return 'css';
});

//  ========================================================================
//  TP.path.BarenamePath
//  ========================================================================

TP.path.XMLPath.defineSubtype('BarenamePath');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.path.BarenamePath.Inst.defineMethod('$$getContentForSetOperation',
function(aNode, flagChanges, targetObj) {

    /**
     * @method $$getContentForSetOperation
     * @summary Creates any content that is required in order to perform a
     *     'set' operation.
     * @param {aNode} Node The node to use as the common ancestor to build out
     *     any content that is required for a 'set' operation.
     * @param {Boolean} flagChanges True if any newly created nodes should be
     *     flagged.
     * @param {Object} targetObj The original target object that contains aNode
     *     in some form or fashion.
     * @returns {Node[]} The array of Nodes that got built.
     */

    var path,
        shouldBuild,
        content;

    if (TP.notValid(path = this.$get('$transformedPath'))) {
        path = this.$get('srcPath');
    }

    shouldBuild = TP.ifInvalid(this.$get('buildout'),
                                targetObj.$get('buildout'));

    //  Note we return an Array if we didn't get one to keep the API
    //  consistent (we can get an Array of attributes here due to 'special
    //  TIBET barename' syntax).
    if (!TP.isArray(content = TP.nodeEvaluateBarename(
                                    aNode,
                                    path,
                                    false,
                                    shouldBuild))) {
        content = TP.ac(content);
    }

    if (TP.notValid(content)) {
        TP.ifWarn() ?
            TP.warn(TP.annotate(
                        this,
                        'Unable to obtain content to set for path: ' +
                        path)) : 0;
    }

    return content;
});

//  ------------------------------------------------------------------------

TP.path.BarenamePath.Inst.defineMethod('getPathType',
function() {

    /**
     * @method getPathType
     * @summary Returns the receiver's 'path type'.
     * @returns {String} A path type
     */

    return TP.BARENAME_PATH_TYPE;
});

//  ------------------------------------------------------------------------

TP.path.BarenamePath.Inst.defineMethod('getPointerScheme',
function() {

    /**
     * @method getPointerScheme
     * @summary Returns the receiver's 'pointer scheme'.
     * @returns {String} An XPointer scheme depending on path type.
     */

    return '';
});

//  ========================================================================
//  XPath support
//  ========================================================================

//  ========================================================================
//  TP.extern.XPathFunctionResolver
//  ========================================================================

/*
Note that the setup for this type is handled dynamically during processing
of the getFunctionResolver method on TP.path.XPathPath.
*/

/* eslint-disable no-empty-function */
TP.extern.XPathFunctionResolver = function() {};
/* eslint-enable no-empty-function */

//  ========================================================================
//  TP.extern.XPathNamespaceResolver
//  ========================================================================

/*
Note that the setup for this type is handled dynamically during processing
of the getNSResolver method on TP.path.XPathPath.
*/

/* eslint-disable no-empty-function */
TP.extern.XPathNamespaceResolver = function() {};
/* eslint-enable no-empty-function */

//  ========================================================================
//  TP.extern.XPathVariableResolver
//  ========================================================================

/*
Note that the setup for this type is handled dynamically during processing
of the getVariableResolver method on TP.path.XPathPath.
*/

/* eslint-disable no-empty-function */
TP.extern.XPathVariableResolver = function() {};
/* eslint-enable no-empty-function */

//  ========================================================================
//  TP.path.XPathPath
//  ========================================================================

/**
 * @type {TP.path.XPathPath}
 */

//  ------------------------------------------------------------------------

TP.path.XMLPath.defineSubtype('XPathPath');

//  ------------------------------------------------------------------------

//  avoid binding and apply issues by creating our alias as a wrapper
TP.definePrimitive('xpc',
function(aPath, config, forceNative) {

    /**
     * @method xpc
     * @summary Returns a newly initialized XPathPath instance. Note that if
     *     you specify a non native path, the external XPath parser will be
     *     loaded. The default is a native path, unless namespace-qualified
     *     extension functions are found.
     * @param {String} aPath The XPath as a String.
     * @param {TP.core.Hash} config The configuration for this path.
     * @param {Boolean} forceNative Whether or not the path should be 'forced'
     *     to be a native path, rather than letting this type compute whether
     *     it is either a native or non-native path. See this type's
     *     discussion for more information.
     * @returns {TP.path.XPathPath} The new instance.
     */

    return TP.path.XPathPath.construct.apply(TP.path.XPathPath, arguments);
});

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  This RegExp detects paths with either custom XPath variable references
//  in it ('$' followed by word characters) or custom XPath namespaced
//  functions in it (word characters followed by colon followed by word
//  characters followed by an opening parenthesis).
TP.path.XPathPath.Type.defineConstant('NON_NATIVE_PATH_REGEX',
                                TP.rc('\\$\\w+|\\w+:[\\w-]+\\('));

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.path.XPathPath.Type.defineAttribute('$tpParser');
TP.path.XPathPath.Type.defineAttribute('$nsResolver');
TP.path.XPathPath.Type.defineAttribute('$fnResolver');
TP.path.XPathPath.Type.defineAttribute('$varResolver');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineAttribute('isNative');

TP.path.XPathPath.Inst.defineAttribute('$origPath');
TP.path.XPathPath.Inst.defineAttribute('$tpPath');
TP.path.XPathPath.Inst.defineAttribute('$tpContext');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.path.XPathPath.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    this.defineDependencies('TP.extern.XPathParser');

    return;
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Type.defineMethod('canonicalizePath',
function(aPath) {

    /**
     * @method canonicalizePath
     * @summary Returns the 'canonical' version of the supplied path. The
     *     canonical version is one where all shortcuts have been expanded.
     *     Note that this call will force loading of the non-native XPath
     *     parser to provide the canonical path expansion.
     * @param {String} aPath The path to canonicalize.
     * @returns {String} The canonicalized path.
     */

    var parser,
        primitiveXPathObj;

    parser = this.getParser();

    primitiveXPathObj = parser.parse(aPath);

    return primitiveXPathObj.expression.toString();
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Type.defineMethod('getFunctionResolver',
function() {

    /**
     * @method getFunctionResolver
     * @summary Returns the function resolver instance, a single instance used
     *     by the type to resolve XPaths with extension functions.
     * @returns {TP.extern.XPathFunctionResolver} A function resolver instance.
     */

    var resolver;

    if (TP.notValid(resolver = this.$get('$fnResolver'))) {
        //  Make sure to force the parser to load.
        this.getParser();

        //  now we can set up the TP.extern.XPathFunctionResolver type
        //  properly since we've got the TP.extern.XPathParser imported
        TP.extern.XPathFunctionResolver.prototype =
                        new TP.extern.XPathParser.FunctionResolver();

        TP.extern.XPathFunctionResolver.prototype.constructor =
                        TP.extern.XPathFunctionResolver;
        TP.extern.XPathFunctionResolver.prototype.superclass =
                        TP.extern.XPathParser.FunctionResolver.prototype;

        TP.extern.XPathFunctionResolver.prototype.getFunctionWithName =
            function(ns, ln, c) {

                var canonicalPrefix,
                    namespaceType;

                if (TP.notEmpty(ns) &&
                    TP.notEmpty(canonicalPrefix =
                                TP.w3.Xmlns.getCanonicalPrefix(ns))) {
                    if (TP.isType(namespaceType =
                                    (canonicalPrefix + ':').asType())) {
                        if (TP.isCallable(namespaceType[ln])) {
                            return namespaceType[ln];
                        }
                    }
                }

                return this.superclass.getFunctionWithName.bind(this)(
                                                                ns, ln, c);
            };

        resolver = new TP.extern.XPathFunctionResolver();

        this.$set('$fnResolver', resolver);
    }

    return resolver;
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Type.defineMethod('getNSResolver',
function() {

    /**
     * @method getNSResolver
     * @summary Returns the namespace resolver instance, a single instance
     *     used by the type to resolve namespace-related XPaths.
     * @returns {TP.extern.XPathNamespaceResolver} A namespace resolver
     *     instance.
     */

    var resolver;

    if (TP.notValid(resolver = this.$get('$nsResolver'))) {
        //  Make sure to force the parser to load.
        this.getParser();

        //  now we can set up the TP.extern.XPathNamespaceResolver type
        //  properly since we've got the TP.extern.XPathParser imported
        TP.extern.XPathNamespaceResolver.prototype =
                        new TP.extern.XPathParser.NamespaceResolver();

        TP.extern.XPathNamespaceResolver.prototype.constructor =
                        TP.extern.XPathNamespaceResolver;
        TP.extern.XPathNamespaceResolver.prototype.superclass =
                        TP.extern.XPathParser.NamespaceResolver.prototype;

        TP.extern.XPathNamespaceResolver.prototype.getNamespace =
            function(prefix, n) {

                var namespace;

                if (TP.notEmpty(prefix) &&
                    TP.isString(namespace =
                                TP.w3.Xmlns.getNSURIForPrefix(prefix))) {
                    return namespace;
                }

                return this.superclass.getNamespace.bind(this)(prefix, n);
            };

        resolver = new TP.extern.XPathNamespaceResolver();

        this.$set('$nsResolver', resolver);
    }

    return resolver;
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Type.defineMethod('getParser',
function() {

    /**
     * @method getParser
     * @summary Returns the receiver's non-native XPath parser instance.
     * @returns {TP.extern.XPathParser|undefined} A function resolver instance.
     */

    var parser;

    if (TP.notValid(parser = this.$get('$tpParser'))) {
        if (TP.notValid(TP.extern.XPathParser)) {
            TP.ifWarn() ?
                TP.warn(TP.annotate(
                            this,
                            'Unable to obtain valid XPath parser')) : 0;
            return;
        }

        parser = new TP.extern.XPathParser();
        this.$set('$tpParser', parser);
    }

    return parser;
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Type.defineMethod('getVariableResolver',
function() {

    /**
     * @method getVariableResolver
     * @summary Returns the variable resolver instance, a single instance used
     *     by the type to resolve XPaths with variables.
     * @returns {TP.extern.XPathVariableResolver} A variable resolver instance.
     */

    var resolver;

    if (TP.notValid(resolver = this.$get('$varResolver'))) {
        //  Make sure to force the parser to load.
        this.getParser();

        //  now we can set up the TP.extern.XPathVariableResolver type
        //  properly since we've got the TP.extern.XPathParser imported
        TP.extern.XPathVariableResolver.prototype =
                        new TP.extern.XPathParser.VariableResolver();

        TP.extern.XPathVariableResolver.prototype.constructor =
                        TP.extern.XPathVariableResolver;
        TP.extern.XPathVariableResolver.prototype.superclass =
                        TP.extern.XPathParser.VariableResolver.prototype;

        TP.extern.XPathVariableResolver.prototype.getVariableWithName =
            function(ns, ln, c) {

                var $$result,

                    newNodeSet;

                switch (ln) {
                    case 'rowIndex':

                        return new TP.extern.XPathParser.XNumber(100);

                    default:

                        /* eslint-disable no-eval */
                        eval('$$result = ' + ln);
                        /* eslint-enable no-eval */

                        if (TP.isNumber($$result)) {
                            return new TP.extern.XPathParser.XNumber(
                                                                $$result);
                        } else if (TP.isBoolean($$result)) {
                            return new TP.extern.XPathParser.XBoolean(
                                                                $$result);
                        } else if (TP.isNode($$result)) {
                            newNodeSet =
                                    new TP.extern.XPathParser.XNodeSet();
                            newNodeSet.add($$result);
                        } else {
                            return new TP.extern.XPathParser.XString(
                                                    $$result.asString());
                        }

                        break;
                }

                return;
            };

        resolver = new TP.extern.XPathVariableResolver();

        this.$set('$varResolver', resolver);
    }

    return resolver;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineMethod('init',
function(aPath, config, forceNative) {

    /**
     * @method init
     * @summary Returns a newly initialized instance. Note that if you specify
     *     a non native path the external XPath parser will be loaded. The
     *     default is a native path, unless namespace-qualified extension
     *     functions are found.
     * @param {String} aPath The XPath as a String.
     * @param {TP.core.Hash} config The configuration for this path.
     * @param {Boolean} forceNative Whether or not the path should be 'forced'
     *     to be a native path, rather than letting this type compute whether
     *     it is either a native or non-native path. See this type's
     *     discussion for more information.
     * @returns {TP.path.XPathPath} The new instance.
     */

    var thePath,
        tnTestPath;

    //  Make sure that any 'xpath path' scheme is stripped off
    if (TP.regex.XPATH_POINTER.test(aPath)) {
        thePath = TP.regex.XPATH_POINTER.match(aPath).at(2);
    } else {
        thePath = aPath;
    }

    this.set('$origPath', thePath);

    //  Allow the shortcut convenience that TIBET provides of specifying the
    //  '$def:' prefix (intentionally illegal because it leads with a '$')
    //  for elements that are in the default namespace.
    TP.regex.XPATH_DEFAULTNS.lastIndex = 0;
    thePath = thePath.replace(TP.regex.XPATH_DEFAULTNS, '*[name()="$1"]');

    this.setPath(thePath, forceNative);

    //  Note here how we pass the modified path so that 'srcPath' gets properly
    //  set (even though 'setPath' did that above, our supertype won't know
    //  that).
    this.callNextMethod(thePath, config);

    if (TP.regex.XPATH_HAS_SCALAR_CONVERSION.test(thePath)) {
        tnTestPath = TP.regex.XPATH_HAS_SCALAR_CONVERSION.match(thePath).at(1);
    } else {
        tnTestPath = thePath;
    }

    if (TP.regex.TEXT_NODE_ENDS.test(tnTestPath)) {
        if (TP.isHash(config)) {
            this.$set('shouldCollapse',
                        config.atIfInvalid('shouldCollapse', true),
                        false);
        } else {
            this.$set('shouldCollapse', true, false);
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineMethod('asReplacedString',
function(replacementFunction) {

    /**
     * @method asReplacedString
     * @summary Returns a String representation of the receiver after
     *     substitutions have taken place at each location step.
     * @description For a non-native path substitutions will be performed by
     *     the supplied Function which should take a single argument, that of
     *     the location step that the parser is currently at. For a native
     *     path no alteration occurs and the path's string value is returned
     *     unchanged.
     * @param {Function} replacementFunction The Function that will perform the
     *     replacement at each location step in the receiver.
     * @returns {String} The replaced String representation of the receiver.
     */

    var path;

    if (TP.notEmpty(path = this.$get('$tpPath'))) {
        return path.expression.toReplacedString(replacementFunction);
    }

    return this.asString();
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a TIBET source code string.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    var str,
        val;

    str = 'TP.path.XPathPath.construct(\'' + this.get('$origPath') +
            '\', ' +
            this.get('isNative') + ')';

    if ((val = this.$get('buildout')) === true) {
        str += '.set(\'buildout\', ' + val + ')';
    }

    if ((val = this.$get('shouldCollapse')) === true) {
        str += '.set(\'shouldCollapse\', ' + val + ')';
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns the String representation of the receiver. For
     *     non-native paths this is the string representation of the parsed
     *     expression (which is canonicalized).
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the TP.path.XPathPath's String representation. The default is
     *     true.
     * @returns {String} The String representation of the receiver.
     */

    var wantsVerbose,

        path,
        repStr;

    wantsVerbose = TP.ifInvalid(verbose, true);

    if (wantsVerbose && TP.notEmpty(path = this.$get('$tpPath'))) {
        repStr = path.expression.toString();
    } else {
        repStr = this.$get('$origPath');
    }

    return repStr;
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineMethod('$$createNodesForPath',
function(aNode, flagChanges) {

    /**
     * @method $$createNodesForPath
     * @summary Builds a set of nodes into the receiver's native node using
     *     the supplied path expression.
     * @description This method traverses up the given path expression, looking
     *     for matching nodes. If it finds them, it then works back down the
     *     expression, building out the nodes necessary for the expression to
     *     be able to work against a real tree.
     * @param {Node} aNode The node to start building the node tree based on
     *     the supplied expression.
     * @param {Boolean} flagChanges True if any newly created nodes should be
     *     flagged.
     * @returns {Node[]} The array of Nodes that got built.
     */

    var wasNative,
        oldbuild,

        results;

    //  We need to temporarily switch the XPath to make sure it uses the
    //  non-native parser, so we save the settings of the path type and whether
    //  the parser is configured to create nodes as it executes.
    wasNative = this.get('isNative');

    //  NB: We're not interested in the content object's setting of
    //  'shouldBuild' here - only the path's (since we just capturing
    //  it to set it back).
    oldbuild = this.$get('buildout');

    //  Switch the path type to a non native path and the create nodes on
    //  execution to true.
    this.set('isNative', false);

    //  NB: buildout has a setter defined in XPath paths.
    this.set('buildout', true, false);

    //  created. note that we pass the flagging state here so the path can flag
    //  anything it has to create when the node is flagging changes
    results = this.execOnNative(aNode, TP.NODESET, false, flagChanges);

    //  Set the path type and the create nodes on execution switches back to
    //  their previous value.
    this.set('isNative', wasNative);
    this.set('buildout', oldbuild, false);

    return results;
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineMethod('$createNonNativeParserContext',
function(aPath) {

    /**
     * @method $createNonNativeParserContext
     * @summary Sets up the context information for the non-native XPath
     *     parser for the receiver.
     * @param {String} aPath The XPath as a String. Defaults to the receiver's
     *     current path.
     * @returns {TP.path.XPathPath} The receiver.
     */

    var path,
        context,
        parser;

    //  have we been here before for this path?
    if (aPath === this.$get('srcPath') &&
        TP.isValid(this.$get('$tpContext'))) {
        return this;
    }

    //  default to our internal path if one isn't provided
    path = TP.ifEmpty(aPath, this.$get('srcPath'));

    //  Use the parser that we allocated on the type and parse the path into
    //  the path construct used by the non-native parser. NOTE that
    //  requesting the parser in this fashion will force loading of the
    //  TP.extern.XPathParser code if it isn't already loaded
    parser = this.getType().getParser();

    this.$set('$tpPath', parser.parse(path));

    //  Allocate and initialize a TP.extern.XPathParser.XPathContext and
    //  supply the namespace and function resolver that we defined on the
    //  type.
    context = new TP.extern.XPathParser.XPathContext(
                                this.getType().getVariableResolver(),
                                this.getType().getNSResolver(),
                                this.getType().getFunctionResolver());

    context.shouldCreateNodes = false;

    this.$set('$tpContext', context);

    return this;
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineMethod('exec',
function(aTPNode, resultType, logErrors, flagChanges) {

    /**
     * @method exec
     * @summary 'Executes' the XPath by evaluating it against the supplied
     *     TP.dom.Node.
     * @param {TP.dom.Node} aTPNode The TP.dom.Node to execute the receiver
     *     against.
     * @param {Number} resultType The type of result desired, either TP.NODESET
     *     or TP.FIRST_NODE.
     * @param {Boolean} logErrors Used to turn off error notification,
     *     particularly during operations such as String localization which can
     *     cause recusion issues.
     * @param {Boolean} flagChanges True if any newly created nodes should be
     *     flagged. Defaults to the value set by the TP.dom.Node being
     *     processed.
     * @returns {Object} The result of evaluating the receiver against the
     *     supplied TP.dom.Node. Will be one of: String, Number, Boolean or
     *     Array (of Nodes).
     */

    var flag;

    if (TP.isValid(flag)) {
        flag = flagChanges;
    } else {
        flag = aTPNode.shouldFlagChanges();
    }

    return this.execOnNative(
                    aTPNode.getNativeNode(),
                    resultType,
                    logErrors,
                    flag);
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineMethod('execOnNative',
function(aNode, resultType, logErrors, flagChanges) {

    /**
     * @method execOnNative
     * @summary 'Executes' the XPath by evaluating it against the supplied
     *     Node.
     * @param {Node} aNode The Node to execute the receiver against.
     * @param {Number} resultType The type of result desired, either TP.NODESET
     *     or TP.FIRST_NODE.
     * @param {Boolean} logErrors Used to turn off error notification,
     *     particularly during operations such as string localization which can
     *     cause recusion issues.
     * @param {Boolean} flagChanges True if any newly created nodes should be
     *     flagged.
     * @returns {Object} The result of evaluating the receiver against the
     *     supplied TP.dom.Node. Will be one of: String, Number, Boolean or
     *     Array (of Nodes).
     */

    var flag,
        path,
        context,
        result;

    flag = TP.ifEmpty(flagChanges, false);

    if (TP.notValid(path = this.$get('$transformedPath'))) {
        path = this.$get('srcPath');
    }

    //  One thing to note is that if you run an XPath against an HTML document
    //  you have to use the external XPath parser _EVEN_ if there are no
    //  non-native constructs in the path. Which means, in essence, that
    //  we're only a native path at execution time if we're native in terms of
    //  syntax, AND being evaluated against a valid XML document... oh and we
    //  can't be requesting to flag changes :)
    if (this.isNativePath() &&
        TP.isXMLDocument(TP.nodeGetDocument(aNode)) &&
        !flag) {
        //  Note here how we use the primitive call. If we used
        //  TP.dom.Node's evaluateXPath(), we'd likely recurse because we
        //  are most likely being called from there.
        return TP.nodeEvaluateXPath(aNode, path, resultType, logErrors);
    }

    //  If we're here its because we're either not a native path, or we're
    //  being run against an HTML document, or we're being asked to flag
    //  changes.
    //  Either way we need to process the path using the non-native XPath
    //  processor...

    //  create a non-native context if necessary
    if (TP.notValid(context = this.$get('$tpContext'))) {
        this.$createNonNativeParserContext(path);
        context = this.$get('$tpContext');
    }

    //  configure the context node to the node provided
    context.expressionContextNode = aNode;

    //  tag the context with our change flagging status
    context.shouldFlagNodes = flag;

    //  set error logging control flag as well
    context.logErrors = TP.ifInvalid(logErrors, true);

    //  run that baby!
    result = this.$get('$tpPath').evaluate(context);

    //  We need to switch on result's constructor to find out the type of what
    //  was returned and then convert it to a native JavaScript object. Note
    //  that the default case is for when we've had a node set returned and we
    //  must convert it to a JS array.
    switch (result.constructor) {
        case TP.extern.XPathParser.XString:

            return result.stringValue();

        case TP.extern.XPathParser.XNumber:

            return result.numberValue();

        case TP.extern.XPathParser.XBoolean:

            return result.booleanValue();

        default:

            if (resultType === TP.FIRST_NODE) {
                return result.first();
            } else {
                return result.toArray();
            }
    }
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineMethod('execRemove',
function(aTPNode, shouldSignal) {

    /**
     * @method execRemove
     * @summary Removes all nodes under the receiver which match the XPath
     *     provided. This method is typically called via remove when an XPath
     *     is provided as the attributeName.
     * @param {TP.dom.Node} aTPNode The TP.dom.Node to execute the receiver
     *     against.
     * @param {shouldSignal} Boolean If false, no signaling occurs. Defaults to
     *     targetObj.shouldSignalChange().
     * @returns {String[]} An Array of the changed Node addresses.
     */

    var node,

        oldbuild,
        results,

        targetTPDoc,
        signalChange,

        changedAddresses,

        len,
        i,

        elem;

    node = aTPNode.getNativeNode();

    //  NB: We're not interested in the content object's setting of
    //  'shouldBuild' here - only the path's (since we just capturing
    //  it to set it back).
    oldbuild = this.$get('buildout');

    //  NB: buildout has a setter defined in XPath paths.
    this.set('buildout', false, false);

    this.set('isNative', false);
    results = this.execOnNative(node, TP.NODESET, false);

    //  NB: buildout has a setter defined in XPath paths.
    this.set('buildout', oldbuild, false);

    //  If there were no results, there probably wasn't a valid XPath.
    //  Exit here.
    if (TP.notValid(results) || results.getSize() === 0) {
        return this;
    }

    targetTPDoc = aTPNode.getDocument();

    if (TP.isValid(shouldSignal)) {
        signalChange = shouldSignal;
    } else if (TP.isValid(targetTPDoc)) {
        signalChange = targetTPDoc.shouldSignalChange();
    }

    changedAddresses = TP.ac();

    len = results.getSize();

    //  Found something, so now we have to remove it (and/or flag as needed)
    for (i = 0; i < len; i++) {
        node = results[i];

        changedAddresses.push(TP.nodeGetDocumentPosition(node));

        //  If what we have is an attribute then we are being asked to remove
        //  it from it's containing element
        if (node.nodeType === Node.ATTRIBUTE_NODE) {
            elem = TP.attributeGetOwnerElement(node);

            //  flag the attribute's owner element as having changed
            if (aTPNode.shouldFlagChanges()) {
                TP.elementFlagChange(elem, TP.ATTR + node.name, TP.DELETE);
            }

            //  Rip out the attribute itself so it won't be seen in any
            //  serialization of the DOM. Unfortunately our current flagging
            //  model doesn't allow filtering as we do at the element level, so
            //  we have to do this here and rely on the flagging to say that
            //  this attribute once existed.
            elem.removeAttributeNode(node);

            if (signalChange) {
                this.$changed('@' + node.name, TP.DELETE);
            }
        } else {
            //  when dealing with other elements we get their parent node so
            //  we can remove when needed
            elem = node.parentNode;

            if (aTPNode.shouldFlagChanges()) {
                //  if we're flagging rather than 'doing' then we set the
                //  change flag to TP.DELETE and that's all
                TP.elementFlagChange(node, TP.SELF, TP.DELETE);

                TP.ifTrace() && TP.$DEBUG ?
                    TP.trace('Node flagged: ' + TP.nodeAsString(node)) : 0;
            } else {
                //  if we're not flagging then just rip it out of the DOM
                TP.nodeRemoveChild(elem, node);
            }

            if (signalChange) {
                TP.wrap(elem).$changed('content', TP.DELETE);
            }
        }
    }

    return changedAddresses;
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineMethod('$$getContentForSetOperation',
function(aNode, flagChanges, targetObj) {

    /**
     * @method $$getContentForSetOperation
     * @summary Creates any content that is required in order to perform a
     *     'set' operation.
     * @param {aNode} Node The node to use as the common ancestor to build out
     *     any content that is required for a 'set' operation.
     * @param {Boolean} flagChanges True if any newly created nodes should be
     *     flagged.
     * @param {Object} targetObj The original target object that contains aNode
     *     in some form or fashion.
     * @returns {Node[]} The array of Nodes that got built.
     */

    var shouldBuild,

        newPath,

        results,

        path,
        lastSegment,
        ndx;

    //  Whether or not we build structures depends on whether we are configured
    //  to build structures. If the we have no configuration one way or the other
    //  (neither true or false), then however the source object is configured
    //  will be used.
    shouldBuild = TP.ifInvalid(this.$get('buildout'),
                                targetObj.$get('buildout'));

    if (TP.notValid(path = this.$get('$transformedPath'))) {
        path = this.$get('srcPath');
    }

    if (TP.regex.XPATH_HAS_SCALAR_CONVERSION.test(path)) {
        newPath = TP.regex.XPATH_HAS_SCALAR_CONVERSION.match(path).at(1);

        if (TP.notEmpty(newPath)) {
            newPath = TP.xpc(newPath);

            //  Since we're now dealing with a scalar path, we change
            //  shouldBuild to be the value of 'buildvals'.
            shouldBuild = this.get('buildvals');

            results = newPath.execOnNative(
                                    aNode, TP.NODESET, false, flagChanges);
        }
    } else {
        //  We pass 'false' to not log errors here - we may be constructing.
        results = this.execOnNative(aNode, TP.NODESET, false, flagChanges);
    }

    //  If we found content by executing ourself against the target object,
    //  then most other concerns are moot - we got at least one targeted node
    //  (even if that's an attribute node) and we can set it's value.

    //  If we didn't, well we've more work to do.
    if (TP.isEmpty(results)) {

        //  only support build on demand behavior if the flag is set
        if (TP.notTrue(shouldBuild)) {
            TP.ifWarn() ?
                TP.warn(TP.annotate(
                            this,
                            'Unable to obtain content to set for path: ' +
                            path)) : 0;

            return TP.ac();
        }

        //  attribute-targeting paths can make life interesting since we may
        //  want to access the elements and add the attribute when not found,
        //  or we may want to only operate on pre-existing attribute nodes.
        //  Although standard technologies such as XForms (section 4.2.2)
        //  implies we don't build new attributes when they're missing from
        //  existing instances, we don't think that's particularly practical
        //  from a development perspective so we tend to build them and manage
        //  relevancy separately from whether the data exists or not
        if (TP.regex.HAS_AT.test(path)) {
            lastSegment = path;

            if ((ndx = path.lastIndexOf('/')) !== TP.NOT_FOUND) {
                lastSegment = path.slice(ndx + 1);
            }

            //  We have a choice here based on how we want to deal with
            //  attribute-targeting paths where the nodes don't exist yet. If
            //  we only want to process those nodes that exist we leave the
            //  attribute portion on the XPath and let it return attribute
            //  nodes. If we want to be able to build those attributes on the
            //  fly when they're missing we need to strip off the attribute
            //  portion of the path and run it to get the elements being
            //  targeted. As it turns out we always build them for binding
            //  support so we have to strip off the tail and run with that.

            //  If the first character of the last segment is a '@', or the
            //  last segment starts with 'attribute::' then we're dealing with
            //  an attribute path after all
            if (lastSegment.charAt(0) === '@') {
                newPath = TP.xpc(path.slice(0, ndx));
            } else if (lastSegment.startsWith('attribute::')) {
                newPath = TP.xpc(path.slice(0, ndx));
            }
        }

        if (TP.notValid(newPath)) {
            /* eslint-disable consistent-this */
            newPath = this;
            /* eslint-enable consistent-this */
        }

        //  Note that results will always be a TP.NODESET
        results = newPath.$$createNodesForPath(aNode, flagChanges);

        if (TP.isEmpty(results)) {
            //  unable to build nodes... path may not be specific enough
            TP.ifWarn() ?
                TP.warn(TP.annotate(
                            this,
                            'Unable to build content for path: ' + path)) : 0;

            return TP.ac();
        }
    }

    return results;
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineMethod('getPathType',
function() {

    /**
     * @method getPathType
     * @summary Returns the receiver's 'path type'.
     * @returns {String} A path type
     */

    return TP.XPATH_PATH_TYPE;
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineMethod('getPointerScheme',
function() {

    /**
     * @method getPointerScheme
     * @summary Returns the receiver's 'pointer scheme'.
     * @returns {String} An XPointer scheme depending on path type.
     */

    return 'xpath1';
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineMethod('getShouldBuild',
function() {

    /**
     * @method getShouldBuild
     * @summary Returns whether the receiver is currently configured to create
     *     Nodes as it is executed against a particular context node.
     * @returns {Boolean} Whether the receiver is configured to create nodes as
     *     it executes.
     */

    var context;

    //  if we have a context it will know, otherwise we assume false since
    //  we'd have to have a context to process otherwise
    if (TP.isValid(context = this.$get('$tpContext'))) {
        return context.shouldCreateNodes;
    }

    //  Note that we use $get() here to avoid endless recursion
    return this.$get('buildout');
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineMethod('getReferencedNodes',
function(aNode) {

    /**
     * @method getReferencedNodes
     * @summary Returns an Array of the Nodes that are referenced by this
     *     path, using aNode as the 'context node' (e.g. starting point).
     * @param {Node|TP.dom.Node} aNode The Node to execute the receiver
     *     against.
     * @returns {TP.dom.Node[]} The array of TP.dom.Nodes referenced by the
     *     receiver.
     */

    var context,

        pathExprs,
        parser,
        stepNodes,

        len,
        i,
        expr,

        tpPath,
        tpResult;

    //  force creation of a non-native path processing context
    if (TP.notValid(context = this.$get('$tpContext'))) {
        this.$createNonNativeParserContext();
        context = this.$get('$tpContext');
    }

    //  collect the location "subpaths" in this XPath
    pathExprs = this.getReferencedLocationPaths();

    //  if the location subpaths contains 1 path it's the path itself, so there
    //  are no 'referenced nodes'
    if (pathExprs.getSize() === 1) {
        return TP.ac();
    }

    //  Grab the non-native context and parser objects and configure them
    //  in preparation for executing the path at each referenced location

    //  Make sure to TP.unwrap() aNode - it might have been a TP.dom.Node.
    context.expressionContextNode = TP.unwrap(aNode);

    parser = this.getType().getParser();

    stepNodes = TP.ac();

    //  Loop over each referenced location path, parsing and evaluating
    //  each path and adding the results to stepNodes.
    len = pathExprs.getSize();
    for (i = 0; i < len; i++) {
        expr = pathExprs.at(i);

        tpPath = parser.parse(expr);
        tpResult = tpPath.evaluate(context);

        stepNodes.add(tpResult.toArray());
    }

    //  flatten stepNodes out as it probably has multiple Arrays (if more
    //  than one stepExpr had results, which is highly likely).
    stepNodes = stepNodes.flatten();

    return stepNodes;
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineMethod('getReferencedLocationPaths',
function() {

    /**
     * @method getReferencedLocationPaths
     * @summary Returns an Array of the location path Strings that are used by
     *     this path any place in its expression.
     * @returns {String[]} An array of Strings that represent location paths
     *     referenced by the expression in the receiver.
     */

    var locationPaths;

    //  Grab all of the location paths referenced by the receiver and
    //  transform them into their String representation.
    locationPaths = this.$getReferencedLocationPathObjects();
    locationPaths.convert(
            function(aPathObj) {
                //  These are Objects produced by the custom XPath parser - we
                //  need to '.toString()' them.
                return aPathObj.toString();
            });

    return locationPaths;
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineMethod('$getReferencedLocationPathObjects',
function() {

    /**
     * @method $getReferencedLocationPathObjects
     * @summary Returns an Array of the location path objects that are used by
     *     this path any place in its expression.
     * @returns {String[]} The array of PathExpr objects that represent location
     *     paths referenced by the expression in the receiver.
     */

    var locationPaths;

    //  force creation of a non-native path processing context, which will
    //  ensure that we get a parsed path set in the tpPath attribute
    if (TP.notValid(this.$get('$tpContext'))) {
        this.$createNonNativeParserContext();
    }

    locationPaths = TP.ac();

    //  Grab all of the location paths referenced by the receiver.
    this.$get('$tpPath').expression.gatherLocationPathsInto(locationPaths);

    return locationPaths;
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineMethod('getReferencedLocationStepsAtPath',
function(aPathIndex) {

    /**
     * @method getReferencedLocationStepsAtPath
     * @summary Returns an Array of location steps that make up the location
     *     path at the index supplied.
     * @param {Number} aPathIndex The index of the location path to obtain the
     *     steps for. This will default to 0 if not supplied.
     * @returns {String[]} An array of Strings that represent location steps
     *     that make up the location path at the supplied index.
     */

    var pathIndex,
        locationPaths,
        locationSteps;

    pathIndex = TP.ifInvalid(aPathIndex, 0);

    //  Grab all of the location paths referenced by the receiver.
    locationPaths = this.$getReferencedLocationPathObjects();

    if (TP.isEmpty(locationPaths)) {
        return TP.ac();
    }

    locationSteps = locationPaths.at(pathIndex).locationPath.steps;
    locationSteps.convert(
            function(aStepObj) {
                //  These are Objects produced by the custom XPath parser - we
                //  need to '.toString()' them.
                return aStepObj.toString();
            });

    return locationSteps;
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineMethod('isAbsolute',
function() {

    /**
     * @method isAbsolute
     * @summary Returns whether or not the receiver contains an 'absolute'
     *     XPath (that is, one that starts with a '/').
     * @returns {Boolean} Whether or not the receiver contains an 'absolute'
     *     XPath.
     */

    var path;

    //  if we've got a tpPath (non-native parsed path content) we can ask it
    if (TP.isValid(path = this.$get('$tpPath'))) {
        return path.expression.locationPath.absolute;
    }

    //  simple check on native paths is does it start with "/"
    return this.$get('srcPath').startsWith('/');
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineMethod('isNativePath',
function(aFlag) {

    /**
     * @method isNativePath
     * @summary Returns true if the receiver can execute using the browser's
     *     native XPath parser. The default for most paths is true, however if
     *     you've requested special processing such as node creation or
     *     extension function handling this will return false.
     * @param {Boolean} aFlag True will force the path to be a native path if
     *     possible, false will set it to non native path.
     * @returns {Boolean} Whether or not native processing is sufficient.
     */

    var path;

    if (TP.isBoolean(aFlag)) {
        path = this.$get('srcPath');

        if (aFlag) {
            if (TP.path.XPathPath.NON_NATIVE_PATH_REGEX.test(path)) {
                TP.ifWarn() ?
                    TP.warn('Found non-native XPath constructs in XPath: ' +
                            path +
                            '. Forcing XPath to use non native parser.') : 0;

                this.set('isNative', false);

                this.$createNonNativeParserContext(path);
            } else {
                this.set('isNative', true);
            }
        } else {
            this.set('isNative', false);

            this.$createNonNativeParserContext(path);
        }
    }

    return this.get('isNative');
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineMethod('setBuildout',
function(build) {

    /**
     * @method setBuildout
     * @summary Sets whether the receiver is currently configured to create
     *     Nodes as it is executed against a particular context node.
     * @param {Boolean} build the receiver should be configured to
     *     create nodes as it executes.
     * @returns {TP.path.XPathPath} The receiver.
     */

    var context;

    if (TP.isTrue(build)) {
        //  force creation of a non-native parsing context, and set ourselves
        //  to be a non-native path (can't do this operation with native paths)
        this.isNativePath(false);
    }

    //  If we've got a context already then update it, but don't create one
    //  just to say "false"
    if (TP.isValid(context = this.$get('$tpContext'))) {
        context.shouldCreateNodes = build;
    }

    //  Note that we use $set() here to avoid endless recursion
    this.$set('buildout', build, false);

    return this;
});

//  ------------------------------------------------------------------------

TP.path.XPathPath.Inst.defineMethod('setPath',
function(aPath, forceNative) {

    /**
     * @method setPath
     * @summary Sets the XPath expression for the receiver to the supplied
     *     path. The caller can also force the path type to be of a particular
     *     type, but if the path contains namespace-qualified extension
     *     functions it will force the path to be a non native path.
     * @param {String} aPath The XPath as a String.
     * @param {Boolean} forceNative Whether or not the path should be 'forced'
     *     to be a native path, rather than letting this type compute whether
     *     it is either a native or non-native path. See this type's
     *     discussion for more information.
     * @returns {TP.path.XPathPath} The receiver.
     */

    var pathType;

    if (TP.notValid(forceNative)) {
        //  based on whether it looks like a non-native path we'll either
        //  accept their input or ensure consistent processing
        if (TP.path.XPathPath.NON_NATIVE_PATH_REGEX.test(aPath)) {
            if (forceNative) {
                TP.ifWarn() ?
                    TP.warn('Found non-native XPath constructs in XPath: ' +
                            aPath +
                            '. Forcing XPath to use non native parser.') : 0;
            }

            pathType = false;
        } else {
            pathType = true;
        }
    } else {
        pathType = forceNative;
    }

    this.set('isNative', pathType);

    //  If we're a non-native path we'll need additional processing assistance
    //  so we get that configured once at initialization time
    if (pathType === TP.path.XPathPath.NON_NATIVE_PATH) {
        this.$createNonNativeParserContext(aPath);
    }

    //  Save the path itself, but NOTE that we do this last so that the
    //  $createNonNativeParserContext processing can test against the "current"
    //  path, not the new one to see if a new context needs to be created.
    this.$set('srcPath', aPath, false);

    return this;
});

//  ========================================================================
//  TP.w3.DTDInfo
//  ========================================================================

/**
 * @type {TP.w3.DTDInfo}
 * @summary This type of JSONContent provides convenience routines for
 *     accessing and validating DTD data as processed by the scripts located
 *     here: https://github.com/djwmarks/html4-dtd-json
 * @description This type accesses data that has a structure that could contain
 *     items such as these. Note that this is not a complete description of the
 *     data schema. See the data file itself for more structural elements:
 *
 *     'data': { 'element': { 'ul': { 'attributes': { 'id': { 'default': '',
 *     'type': '#implied', 'value': 'cdata', } }, 'cdata': false,
 *     'childElements': [], 'contentType': 'element', 'contentModel': {
 *     'expanded': { 'sequenceGroup': { 'children': [], 'elements': ['li'],
 *     'text': false } } }, 'empty': false, 'omitStart': false, 'omitEnd':
 *     false, 'text': false } } }
 */

//  ------------------------------------------------------------------------

TP.core.JSONContent.defineSubtype('w3.DTDInfo');

TP.w3.DTDInfo.Type.defineAttribute('schemaInfo');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.w3.DTDInfo.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    var dtdInfo;

    dtdInfo = this.$get('schemaInfo');
    if (TP.isValid(dtdInfo)) {
        TP.w3.DocType.HTML_401_STRICT.set('dtdInfo', this.construct(dtdInfo));
    }

    return;
});

//  ------------------------------------------------------------------------

TP.w3.DTDInfo.Type.defineMethod('canConstruct',
function(data, uri) {

    /**
     * @method canConstruct
     * @summary Returns true if the receiver can construct a valid instance
     *     given the parameters provided.
     * @param {String} data The content data in question.
     * @param {URI} uri The TIBET URI object which loaded the content.
     * @returns {Boolean} Whether or not an instance of this can be constructed
     *     from the parameters provided.
     */

    //  Must be JSON for starters...but we also want to restrict it to
    //  JSON with keys hopefully unique to the DTD result dataset.
    return TP.isJSONString(data) &&
            /childElements/.test(data) &&
            /contentModel/.test(data);
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.w3.DTDInfo.Inst.defineAttribute(
    'elements', TP.apc('element', TP.hc('shouldCollapse', true)));

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.w3.DTDInfo.Inst.defineMethod('elementIsValidChildOf',
function(childElementName, parentElementName) {

    /**
     * @method elementIsValidChildOf
     * @summary Returns whether or not the child element is a valid child of
     *     the parent element given the information in the contained schema.
     * @param {String} childElementName The name of the child element.
     * @param {String} parentElementName The name of the parent element.
     * @returns {Boolean} Whether or not the child element is a valid child of
     *     the parent element.
     */

    var parentContentModels,
        groupElem,
        childElems,
        len,
        i,
        contentModel;

    parentContentModels = this.get('elements').at(
                            parentElementName).at(
                            'contentModel').at(
                            'expanded');

    //  There could be more than one parent content model describing valid
    //  child elements. We must iterate through them all. They can take the
    //  form of an 'orGroup', 'andGroup' or 'sequenceGroup'.
    len = parentContentModels.getSize();
    for (i = 0; i < len; i++) {
        contentModel = parentContentModels.at(i);

        if (TP.isEmpty(groupElem = contentModel.at('orGroup'))) {
            if (TP.isEmpty(groupElem =
                            contentModel.at('sequenceGroup'))) {
                groupElem = contentModel.at('andGroup');
            }
        }

        if (TP.isElement(groupElem) &&
                TP.isArray(childElems = groupElem.at('elements'))) {
            break;
        }
    }

    if (TP.isEmpty(childElems)) {
        return false;
    }

    return childElems.contains(childElementName);
});

//  ========================================================================
//  JSONPath Parser
//  ========================================================================

//  Generate this by executing the following command (assuming NodeJS is
//  available):

//  pegjs --export-var 'TP.$JSONPathParser' <tibet_dir>/src/tibet/grammars/jsonpath_parser.pegjs

/* eslint-disable */
TP.$JSONPathParser = (function() {
  /*
   * Generated by PEG.js 0.8.0.
   *
   * http://pegjs.majda.cz/
   */

  function peg$subclass(child, parent) {
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor();
  }

  function SyntaxError(message, expected, found, offset, line, column) {
    this.message  = message;
    this.expected = expected;
    this.found    = found;
    this.offset   = offset;
    this.line     = line;
    this.column   = column;

    this.name     = "SyntaxError";
  }

  peg$subclass(SyntaxError, Error);

  function parse(input) {
    var options = arguments.length > 1 ? arguments[1] : {},

        peg$FAILED = {},

        peg$startRuleFunctions = { start: peg$parsestart },
        peg$startRuleFunction  = peg$parsestart,

        peg$c0 = [],
        peg$c1 = peg$FAILED,
        peg$c2 = function(body) {return {expression: {type: "root", value: body}}},
        peg$c3 = function(body) {return {operation: "member", scope: "child", expression:{ type: "identifier", value: body }}},
        peg$c4 = function() {return {expression: {type: "root", value: "$"}}},
        peg$c5 = function(body) {body.operation = "member"; return body},
        peg$c6 = function(body) {body.operation = "subscript"; return body},
        peg$c7 = function(body) {return {scope: "descendant", value: body}},
        peg$c8 = function(body) {return {scope: "child", value: body}},
        peg$c9 = function(body) {return {scope: "parent", value: body}},
        peg$c10 = null,
        peg$c11 = void 0,
        peg$c12 = function(body) {return body},
        peg$c13 = function(body) {return {scope: "child", operation: "member", value: body}},
        peg$c14 = function(body) {return {expression: {type: "wildcard", value: body}}},
        peg$c15 = function(body) {return {expression: {type: "identifier", value: body}}},
        peg$c16 = function(body) {return {expression: {type: "script_expression", value: body}}},
        peg$c17 = function(body) {return {expression: {type: "numeric_literal", value: parseInt(body)}}},
        peg$c18 = "[",
        peg$c19 = { type: "literal", value: "[", description: "\"[\"" },
        peg$c20 = "]",
        peg$c21 = { type: "literal", value: "]", description: "\"]\"" },
        peg$c22 = ",",
        peg$c23 = { type: "literal", value: ",", description: "\",\"" },
        peg$c24 = function(content) {return content},
        peg$c25 = function(first, rest) {return {expression: {type: "union", value: [first].concat(rest)}}},
        peg$c26 = function(body) {return {expression: {type:"wildcard", value: body}}},
        peg$c27 = function(body) {return {expression: {type:"slice", value: body}}},
        peg$c28 = function(body) {return {expression: {type:"index", value: body}}},
        peg$c29 = function(body) {return {expression: {type:"identifier", value: body}}},
        peg$c30 = function(body) {return {expression: {type:"script_expression", value: body}}},
        peg$c31 = function(body) {return {expression: {type:"filter_expression", value: body}}},
        peg$c32 = function(body) {return {expression: {type:"string_literal", value: body}}},
        peg$c33 = /^[a-zA-Z0-9_{}]/,
        peg$c34 = { type: "class", value: "[a-zA-Z0-9_{}]", description: "[a-zA-Z0-9_{}]" },
        peg$c35 = function(body) {return body.join("")},
        peg$c36 = ":",
        peg$c37 = { type: "literal", value: ":", description: "\":\"" },
        peg$c38 = function(start, end) {return {start:start, end:end}},
        peg$c39 = function() {return parseInt(text());},
        peg$c40 = function(chars) {return chars.join("")},
        peg$c41 = "?",
        peg$c42 = { type: "literal", value: "?", description: "\"?\"" },
        peg$c43 = function(inner) {return inner},
        peg$c44 = "(",
        peg$c45 = { type: "literal", value: "(", description: "\"(\"" },
        peg$c46 = ")",
        peg$c47 = { type: "literal", value: ")", description: "\")\"" },
        peg$c48 = { type: "any", description: "any character" },
        peg$c49 = "\\(",
        peg$c50 = { type: "literal", value: "\\(", description: "\"\\\\(\"" },
        peg$c51 = function(body) {return "(" + body.join("") + ")"},
        peg$c52 = function(body) {return "("+ body.join("") +")"},
        peg$c53 = "$",
        peg$c54 = { type: "literal", value: "$", description: "\"$\"" },
        peg$c55 = "..",
        peg$c56 = { type: "literal", value: "..", description: "\"..\"" },
        peg$c57 = ".",
        peg$c58 = { type: "literal", value: ".", description: "\".\"" },
        peg$c59 = "*",
        peg$c60 = { type: "literal", value: "*", description: "\"*\"" },
        peg$c61 = "^",
        peg$c62 = { type: "literal", value: "^", description: "\"^\"" },
        peg$c63 = { type: "other", description: "number" },
        peg$c64 = function() { return parseFloat(text()); },
        peg$c65 = /^[1-9]/,
        peg$c66 = { type: "class", value: "[1-9]", description: "[1-9]" },
        peg$c67 = /^[eE]/,
        peg$c68 = { type: "class", value: "[eE]", description: "[eE]" },
        peg$c69 = "-",
        peg$c70 = { type: "literal", value: "-", description: "\"-\"" },
        peg$c71 = "+",
        peg$c72 = { type: "literal", value: "+", description: "\"+\"" },
        peg$c73 = "0",
        peg$c74 = { type: "literal", value: "0", description: "\"0\"" },
        peg$c75 = { type: "other", description: "string" },
        peg$c76 = function(chars) { return chars.join(""); },
        peg$c77 = "\"",
        peg$c78 = { type: "literal", value: "\"", description: "\"\\\"\"" },
        peg$c79 = "\\",
        peg$c80 = { type: "literal", value: "\\", description: "\"\\\\\"" },
        peg$c81 = "/",
        peg$c82 = { type: "literal", value: "/", description: "\"/\"" },
        peg$c83 = "b",
        peg$c84 = { type: "literal", value: "b", description: "\"b\"" },
        peg$c85 = function() { return "\b"; },
        peg$c86 = "f",
        peg$c87 = { type: "literal", value: "f", description: "\"f\"" },
        peg$c88 = function() { return "\f"; },
        peg$c89 = "n",
        peg$c90 = { type: "literal", value: "n", description: "\"n\"" },
        peg$c91 = function() { return "\n"; },
        peg$c92 = "r",
        peg$c93 = { type: "literal", value: "r", description: "\"r\"" },
        peg$c94 = function() { return "\r"; },
        peg$c95 = "t",
        peg$c96 = { type: "literal", value: "t", description: "\"t\"" },
        peg$c97 = function() { return "\t"; },
        peg$c98 = "u",
        peg$c99 = { type: "literal", value: "u", description: "\"u\"" },
        peg$c100 = function(digits) {
                  return String.fromCharCode(parseInt(digits, 16));
                },
        peg$c101 = function(sequence) { return sequence; },
        peg$c102 = /^[ -!#-[\]-\u10FFFF]/,
        peg$c103 = { type: "class", value: "[ -!#-[\\]-\\u10FFFF]", description: "[ -!#-[\\]-\\u10FFFF]" },
        peg$c104 = /^[0-9]/,
        peg$c105 = { type: "class", value: "[0-9]", description: "[0-9]" },
        peg$c106 = /^[0-9a-f]/i,
        peg$c107 = { type: "class", value: "[0-9a-f]i", description: "[0-9a-f]i" },
        peg$c108 = { type: "other", description: "whitespace" },
        peg$c109 = /^[ \t\n\r]/,
        peg$c110 = { type: "class", value: "[ \\t\\n\\r]", description: "[ \\t\\n\\r]" },

        peg$currPos          = 0,
        peg$reportedPos      = 0,
        peg$cachedPos        = 0,
        peg$cachedPosDetails = { line: 1, column: 1, seenCR: false },
        peg$maxFailPos       = 0,
        peg$maxFailExpected  = [],
        peg$silentFails      = 0,

        peg$result;

    if ("startRule" in options) {
      if (!(options.startRule in peg$startRuleFunctions)) {
        throw new Error("Can't start parsing from rule \"" + options.startRule + "\".");
      }

      peg$startRuleFunction = peg$startRuleFunctions[options.startRule];
    }

    function text() {
      return input.substring(peg$reportedPos, peg$currPos);
    }

    function offset() {
      return peg$reportedPos;
    }

    function line() {
      return peg$computePosDetails(peg$reportedPos).line;
    }

    function column() {
      return peg$computePosDetails(peg$reportedPos).column;
    }

    function expected(description) {
      throw peg$buildException(
        null,
        [{ type: "other", description: description }],
        peg$reportedPos
      );
    }

    function error(message) {
      throw peg$buildException(message, null, peg$reportedPos);
    }

    function peg$computePosDetails(pos) {
      function advance(details, startPos, endPos) {
        var p, ch;

        for (p = startPos; p < endPos; p++) {
          ch = input.charAt(p);
          if (ch === "\n") {
            if (!details.seenCR) { details.line++; }
            details.column = 1;
            details.seenCR = false;
          } else if (ch === "\r" || ch === "\u2028" || ch === "\u2029") {
            details.line++;
            details.column = 1;
            details.seenCR = true;
          } else {
            details.column++;
            details.seenCR = false;
          }
        }
      }

      if (peg$cachedPos !== pos) {
        if (peg$cachedPos > pos) {
          peg$cachedPos = 0;
          peg$cachedPosDetails = { line: 1, column: 1, seenCR: false };
        }
        advance(peg$cachedPosDetails, peg$cachedPos, pos);
        peg$cachedPos = pos;
      }

      return peg$cachedPosDetails;
    }

    function peg$fail(expected) {
      if (peg$currPos < peg$maxFailPos) { return; }

      if (peg$currPos > peg$maxFailPos) {
        peg$maxFailPos = peg$currPos;
        peg$maxFailExpected = [];
      }

      peg$maxFailExpected.push(expected);
    }

    function peg$buildException(message, expected, pos) {
      function cleanupExpected(expected) {
        var i = 1;

        expected.sort(function(a, b) {
          if (a.description < b.description) {
            return -1;
          } else if (a.description > b.description) {
            return 1;
          } else {
            return 0;
          }
        });

        while (i < expected.length) {
          if (expected[i - 1] === expected[i]) {
            expected.splice(i, 1);
          } else {
            i++;
          }
        }
      }

      function buildMessage(expected, found) {
        function stringEscape(s) {
          function hex(ch) { return ch.charCodeAt(0).toString(16).toUpperCase(); }

          return s
            .replace(/\\/g,   '\\\\')
            .replace(/"/g,    '\\"')
            .replace(/\x08/g, '\\b')
            .replace(/\t/g,   '\\t')
            .replace(/\n/g,   '\\n')
            .replace(/\f/g,   '\\f')
            .replace(/\r/g,   '\\r')
            .replace(/[\x00-\x07\x0B\x0E\x0F]/g, function(ch) { return '\\x0' + hex(ch); })
            .replace(/[\x10-\x1F\x80-\xFF]/g,    function(ch) { return '\\x'  + hex(ch); })
            .replace(/[\u0180-\u0FFF]/g,         function(ch) { return '\\u0' + hex(ch); })
            .replace(/[\u1080-\uFFFF]/g,         function(ch) { return '\\u'  + hex(ch); });
        }

        var expectedDescs = new Array(expected.length),
            expectedDesc, foundDesc, i;

        for (i = 0; i < expected.length; i++) {
          expectedDescs[i] = expected[i].description;
        }

        expectedDesc = expected.length > 1
          ? expectedDescs.slice(0, -1).join(", ")
              + " or "
              + expectedDescs[expected.length - 1]
          : expectedDescs[0];

        foundDesc = found ? "\"" + stringEscape(found) + "\"" : "end of input";

        return "Expected " + expectedDesc + " but " + foundDesc + " found.";
      }

      var posDetails = peg$computePosDetails(pos),
          found      = pos < input.length ? input.charAt(pos) : null;

      if (expected !== null) {
        cleanupExpected(expected);
      }

      return new SyntaxError(
        message !== null ? message : buildMessage(expected, found),
        expected,
        found,
        pos,
        posDetails.line,
        posDetails.column
      );
    }

    function peg$parsestart() {
      var s0, s1;

      s0 = [];
      s1 = peg$parseJSON_PATH();
      while (s1 !== peg$FAILED) {
        s0.push(s1);
        s1 = peg$parseJSON_PATH();
      }

      return s0;
    }

    function peg$parseJSON_PATH() {
      var s0, s1, s2;

      s0 = peg$currPos;
      s1 = peg$parseDOLLAR();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsePATH_COMPONENTS();
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c2(s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$parseLEADING_CHILD_MEMBER_EXPRESSION();
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$parseLEADING_CHILD_MEMBER_EXPRESSION();
          if (s1 !== peg$FAILED) {
            s2 = peg$parsePATH_COMPONENTS();
            if (s2 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c3(s2);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$parseDOLLAR();
            if (s1 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c4();
            }
            s0 = s1;
          }
        }
      }

      return s0;
    }

    function peg$parsePATH_COMPONENTS() {
      var s0, s1;

      s0 = [];
      s1 = peg$parsePATH_COMPONENT();
      if (s1 !== peg$FAILED) {
        while (s1 !== peg$FAILED) {
          s0.push(s1);
          s1 = peg$parsePATH_COMPONENT();
        }
      } else {
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsePATH_COMPONENT() {
      var s0, s1;

      s0 = peg$currPos;
      s1 = peg$parseMEMBER_COMPONENT();
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c5(s1);
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseSUBSCRIPT_COMPONENT();
        if (s1 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c6(s1);
        }
        s0 = s1;
      }

      return s0;
    }

    function peg$parseMEMBER_COMPONENT() {
      var s0, s1;

      s0 = peg$currPos;
      s1 = peg$parseDESCENDANT_MEMBER_COMPONENT();
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c7(s1);
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseCHILD_MEMBER_COMPONENT();
        if (s1 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c8(s1);
        }
        s0 = s1;
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$parsePARENT_MEMBER_COMPONENT();
          if (s1 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c9(s1);
          }
          s0 = s1;
        }
      }

      return s0;
    }

    function peg$parseCHILD_MEMBER_COMPONENT() {
      var s0, s1, s2, s3, s4;

      s0 = peg$currPos;
      s1 = peg$parseDOT();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseMEMBER_EXPRESSION();
        if (s2 === peg$FAILED) {
          s2 = peg$c10;
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$currPos;
          peg$silentFails++;
          s4 = peg$parseCIRCUMFLEX();
          peg$silentFails--;
          if (s4 === peg$FAILED) {
            s3 = peg$c11;
          } else {
            peg$currPos = s3;
            s3 = peg$c1;
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c12(s2);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseDESCENDANT_MEMBER_COMPONENT() {
      var s0, s1, s2, s3, s4;

      s0 = peg$currPos;
      s1 = peg$parseDOT_DOT();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseMEMBER_EXPRESSION();
        if (s2 === peg$FAILED) {
          s2 = peg$c10;
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$currPos;
          peg$silentFails++;
          s4 = peg$parseCIRCUMFLEX();
          peg$silentFails--;
          if (s4 === peg$FAILED) {
            s3 = peg$c11;
          } else {
            peg$currPos = s3;
            s3 = peg$c1;
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c12(s2);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsePARENT_MEMBER_COMPONENT() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      s1 = peg$parseDOT();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseCIRCUMFLEX();
        if (s2 !== peg$FAILED) {
          s3 = peg$parseMEMBER_EXPRESSION();
          if (s3 === peg$FAILED) {
            s3 = peg$c10;
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c12(s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseLEADING_CHILD_MEMBER_EXPRESSION() {
      var s0, s1;

      s0 = peg$currPos;
      s1 = peg$parseMEMBER_EXPRESSION();
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c13(s1);
      }
      s0 = s1;

      return s0;
    }

    function peg$parseMEMBER_EXPRESSION() {
      var s0, s1;

      s0 = peg$currPos;
      s1 = peg$parseSTAR();
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c14(s1);
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseIDENTIFIER();
        if (s1 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c15(s1);
        }
        s0 = s1;
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$parseSCRIPT_EXPRESSION();
          if (s1 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c16(s1);
          }
          s0 = s1;
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$parseINDEX();
            if (s1 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c17(s1);
            }
            s0 = s1;
          }
        }
      }

      return s0;
    }

    function peg$parseSUBSCRIPT_COMPONENT() {
      var s0, s1;

      s0 = peg$currPos;
      s1 = peg$parseDESCENDANT_SUBSCRIPT_COMPONENT();
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c7(s1);
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseCHILD_SUBSCRIPT_COMPONENT();
        if (s1 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c8(s1);
        }
        s0 = s1;
      }

      return s0;
    }

    function peg$parseCHILD_SUBSCRIPT_COMPONENT() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 91) {
        s1 = peg$c18;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c19); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parseSUBSCRIPT();
        if (s2 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 93) {
            s3 = peg$c20;
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c21); }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c12(s2);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseDESCENDANT_SUBSCRIPT_COMPONENT() {
      var s0, s1, s2, s3, s4;

      s0 = peg$currPos;
      s1 = peg$parseDOT_DOT();
      if (s1 !== peg$FAILED) {
        if (input.charCodeAt(peg$currPos) === 91) {
          s2 = peg$c18;
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c19); }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parseSUBSCRIPT();
          if (s3 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 93) {
              s4 = peg$c20;
              peg$currPos++;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c21); }
            }
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c12(s3);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseSUBSCRIPT() {
      var s0;

      s0 = peg$parseSUBSCRIPT_EXPRESSION_LIST();
      if (s0 === peg$FAILED) {
        s0 = peg$parseSUBSCRIPT_EXPRESSION();
      }

      return s0;
    }

    function peg$parseSUBSCRIPT_EXPRESSION_LIST() {
      var s0, s1, s2, s3, s4, s5, s6, s7;

      s0 = peg$currPos;
      s1 = peg$parseSUBSCRIPT_EXPRESSION();
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$currPos;
        s4 = [];
        s5 = peg$parsewhitespace();
        while (s5 !== peg$FAILED) {
          s4.push(s5);
          s5 = peg$parsewhitespace();
        }
        if (s4 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 44) {
            s5 = peg$c22;
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c23); }
          }
          if (s5 !== peg$FAILED) {
            s6 = [];
            s7 = peg$parsewhitespace();
            while (s7 !== peg$FAILED) {
              s6.push(s7);
              s7 = peg$parsewhitespace();
            }
            if (s6 !== peg$FAILED) {
              s7 = peg$parseSUBSCRIPT_EXPRESSION();
              if (s7 !== peg$FAILED) {
                peg$reportedPos = s3;
                s4 = peg$c24(s7);
                s3 = s4;
              } else {
                peg$currPos = s3;
                s3 = peg$c1;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c1;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c1;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$c1;
        }
        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$currPos;
            s4 = [];
            s5 = peg$parsewhitespace();
            while (s5 !== peg$FAILED) {
              s4.push(s5);
              s5 = peg$parsewhitespace();
            }
            if (s4 !== peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 44) {
                s5 = peg$c22;
                peg$currPos++;
              } else {
                s5 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c23); }
              }
              if (s5 !== peg$FAILED) {
                s6 = [];
                s7 = peg$parsewhitespace();
                while (s7 !== peg$FAILED) {
                  s6.push(s7);
                  s7 = peg$parsewhitespace();
                }
                if (s6 !== peg$FAILED) {
                  s7 = peg$parseSUBSCRIPT_EXPRESSION();
                  if (s7 !== peg$FAILED) {
                    peg$reportedPos = s3;
                    s4 = peg$c24(s7);
                    s3 = s4;
                  } else {
                    peg$currPos = s3;
                    s3 = peg$c1;
                  }
                } else {
                  peg$currPos = s3;
                  s3 = peg$c1;
                }
              } else {
                peg$currPos = s3;
                s3 = peg$c1;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c1;
            }
          }
        } else {
          s2 = peg$c1;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c25(s1, s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseSUBSCRIPT_EXPRESSION() {
      var s0, s1;

      s0 = peg$currPos;
      s1 = peg$parseSTAR();
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c26(s1);
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseARRAY_SLICE();
        if (s1 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c27(s1);
        }
        s0 = s1;
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$parseINDEX();
          if (s1 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c28(s1);
          }
          s0 = s1;
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$parseIDENTIFIER();
            if (s1 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c29(s1);
            }
            s0 = s1;
            if (s0 === peg$FAILED) {
              s0 = peg$currPos;
              s1 = peg$parseSCRIPT_EXPRESSION();
              if (s1 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c30(s1);
              }
              s0 = s1;
              if (s0 === peg$FAILED) {
                s0 = peg$currPos;
                s1 = peg$parseFILTER_EXPRESSION();
                if (s1 !== peg$FAILED) {
                  peg$reportedPos = s0;
                  s1 = peg$c31(s1);
                }
                s0 = s1;
                if (s0 === peg$FAILED) {
                  s0 = peg$currPos;
                  s1 = peg$parseSTRING_LITERAL();
                  if (s1 !== peg$FAILED) {
                    peg$reportedPos = s0;
                    s1 = peg$c32(s1);
                  }
                  s0 = s1;
                }
              }
            }
          }
        }
      }

      return s0;
    }

    function peg$parseSTRING_LITERAL() {
      var s0, s1;

      s0 = peg$currPos;
      s1 = peg$parsestring();
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c12(s1);
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseQ_STRING();
        if (s1 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c12(s1);
        }
        s0 = s1;
      }

      return s0;
    }

    function peg$parseIDENTIFIER() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      s1 = [];
      if (peg$c33.test(input.charAt(peg$currPos))) {
        s2 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s2 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c34); }
      }
      if (s2 !== peg$FAILED) {
        while (s2 !== peg$FAILED) {
          s1.push(s2);
          if (peg$c33.test(input.charAt(peg$currPos))) {
            s2 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c34); }
          }
        }
      } else {
        s1 = peg$c1;
      }
      if (s1 !== peg$FAILED) {
        s2 = [];
        if (peg$c33.test(input.charAt(peg$currPos))) {
          s3 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c34); }
        }
        while (s3 !== peg$FAILED) {
          s2.push(s3);
          if (peg$c33.test(input.charAt(peg$currPos))) {
            s3 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c34); }
          }
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c35(s1);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseARRAY_SLICE() {
      var s0, s1, s2, s3, s4, s5;

      s0 = peg$currPos;
      s1 = peg$parseINDEX();
      if (s1 === peg$FAILED) {
        s1 = peg$c10;
      }
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parsewhitespace();
        while (s3 !== peg$FAILED) {
          s2.push(s3);
          s3 = peg$parsewhitespace();
        }
        if (s2 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 58) {
            s3 = peg$c36;
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c37); }
          }
          if (s3 !== peg$FAILED) {
            s4 = [];
            s5 = peg$parsewhitespace();
            while (s5 !== peg$FAILED) {
              s4.push(s5);
              s5 = peg$parsewhitespace();
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parseINDEX();
              if (s5 === peg$FAILED) {
                s5 = peg$c10;
              }
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c38(s1, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c1;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseINDEX() {
      var s0, s1, s2;

      s0 = peg$currPos;
      s1 = peg$parseminus();
      if (s1 === peg$FAILED) {
        s1 = peg$c10;
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parseint();
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c39();
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseQ_STRING() {
      var s0, s1, s2;

      s0 = peg$currPos;
      s1 = [];
      s2 = peg$parsechar();
      while (s2 !== peg$FAILED) {
        s1.push(s2);
        s2 = peg$parsechar();
      }
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c40(s1);
      }
      s0 = s1;

      return s0;
    }

    function peg$parseSCRIPT_EXPRESSION() {
      var s0, s1;

      s0 = peg$currPos;
      s1 = peg$parseEXPR();
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c35(s1);
      }
      s0 = s1;

      return s0;
    }

    function peg$parseFILTER_EXPRESSION() {
      var s0, s1, s2;

      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 63) {
        s1 = peg$c41;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c42); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parseEXPR();
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c35(s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseEXPR() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      s1 = peg$parseEXPR_START();
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parseEXPR_INNER();
        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$parseEXPR_INNER();
          }
        } else {
          s2 = peg$c1;
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parseEXPR_END();
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c43(s2);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseEXPR_START() {
      var s0;

      if (input.charCodeAt(peg$currPos) === 40) {
        s0 = peg$c44;
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c45); }
      }

      return s0;
    }

    function peg$parseEXPR_END() {
      var s0;

      if (input.charCodeAt(peg$currPos) === 41) {
        s0 = peg$c46;
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c47); }
      }

      return s0;
    }

    function peg$parseEXPR_INNER() {
      var s0, s1, s2;

      s0 = peg$currPos;
      s1 = peg$parseEXPR_CONTENT();
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c12(s1);
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseEMPTY_EXPR_CONTENT();
        if (s1 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c12(s1);
        }
        s0 = s1;
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$currPos;
          peg$silentFails++;
          s2 = peg$parseEXPR_END();
          peg$silentFails--;
          if (s2 === peg$FAILED) {
            s1 = peg$c11;
          } else {
            peg$currPos = s1;
            s1 = peg$c1;
          }
          if (s1 !== peg$FAILED) {
            if (input.length > peg$currPos) {
              s2 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s2 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c48); }
            }
            if (s2 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c12(s2);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            if (input.substr(peg$currPos, 2) === peg$c49) {
              s1 = peg$c49;
              peg$currPos += 2;
            } else {
              s1 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c50); }
            }
            if (s1 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c12(s1);
            }
            s0 = s1;
          }
        }
      }

      return s0;
    }

    function peg$parseEMPTY_EXPR_CONTENT() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 40) {
        s1 = peg$c44;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c45); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 === peg$FAILED) {
          s2 = peg$c10;
        }
        if (s2 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 41) {
            s3 = peg$c46;
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c47); }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c51(s2);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseEXPR_CONTENT() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 40) {
        s1 = peg$c44;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c45); }
      }
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parseEXPR_CONTENT_INNER();
        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$parseEXPR_CONTENT_INNER();
          }
        } else {
          s2 = peg$c1;
        }
        if (s2 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 41) {
            s3 = peg$c46;
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c47); }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c52(s2);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseEXPR_CONTENT_INNER() {
      var s0, s1, s2;

      s0 = peg$parseEMPTY_EXPR_CONTENT();
      if (s0 === peg$FAILED) {
        s0 = [];
        s1 = peg$parseEXPR_CONTENT();
        if (s1 !== peg$FAILED) {
          while (s1 !== peg$FAILED) {
            s0.push(s1);
            s1 = peg$parseEXPR_CONTENT();
          }
        } else {
          s0 = peg$c1;
        }
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$currPos;
          peg$silentFails++;
          if (input.charCodeAt(peg$currPos) === 41) {
            s2 = peg$c46;
            peg$currPos++;
          } else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c47); }
          }
          peg$silentFails--;
          if (s2 === peg$FAILED) {
            s1 = peg$c11;
          } else {
            peg$currPos = s1;
            s1 = peg$c1;
          }
          if (s1 !== peg$FAILED) {
            if (input.length > peg$currPos) {
              s2 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s2 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c48); }
            }
            if (s2 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c12(s2);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        }
      }

      return s0;
    }

    function peg$parseDOLLAR() {
      var s0;

      if (input.charCodeAt(peg$currPos) === 36) {
        s0 = peg$c53;
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c54); }
      }

      return s0;
    }

    function peg$parseDOT_DOT() {
      var s0;

      if (input.substr(peg$currPos, 2) === peg$c55) {
        s0 = peg$c55;
        peg$currPos += 2;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c56); }
      }

      return s0;
    }

    function peg$parseDOT() {
      var s0;

      if (input.charCodeAt(peg$currPos) === 46) {
        s0 = peg$c57;
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c58); }
      }

      return s0;
    }

    function peg$parseSTAR() {
      var s0;

      if (input.charCodeAt(peg$currPos) === 42) {
        s0 = peg$c59;
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c60); }
      }

      return s0;
    }

    function peg$parseCIRCUMFLEX() {
      var s0;

      if (input.charCodeAt(peg$currPos) === 94) {
        s0 = peg$c61;
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c62); }
      }

      return s0;
    }

    function peg$parseBRACKET_LEFT() {
      var s0;

      if (input.charCodeAt(peg$currPos) === 91) {
        s0 = peg$c18;
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c19); }
      }

      return s0;
    }

    function peg$parseBRACKET_RIGHT() {
      var s0;

      if (input.charCodeAt(peg$currPos) === 93) {
        s0 = peg$c20;
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c21); }
      }

      return s0;
    }

    function peg$parsenumber() {
      var s0, s1, s2, s3, s4;

      peg$silentFails++;
      s0 = peg$currPos;
      s1 = peg$parseminus();
      if (s1 === peg$FAILED) {
        s1 = peg$c10;
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parseint();
        if (s2 !== peg$FAILED) {
          s3 = peg$parsefrac();
          if (s3 === peg$FAILED) {
            s3 = peg$c10;
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$parseexp();
            if (s4 === peg$FAILED) {
              s4 = peg$c10;
            }
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c64();
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }
      peg$silentFails--;
      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c63); }
      }

      return s0;
    }

    function peg$parsedecimal_point() {
      var s0;

      if (input.charCodeAt(peg$currPos) === 46) {
        s0 = peg$c57;
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c58); }
      }

      return s0;
    }

    function peg$parsedigit1_9() {
      var s0;

      if (peg$c65.test(input.charAt(peg$currPos))) {
        s0 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c66); }
      }

      return s0;
    }

    function peg$parsee() {
      var s0;

      if (peg$c67.test(input.charAt(peg$currPos))) {
        s0 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c68); }
      }

      return s0;
    }

    function peg$parseexp() {
      var s0, s1, s2, s3, s4;

      s0 = peg$currPos;
      s1 = peg$parsee();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseminus();
        if (s2 === peg$FAILED) {
          s2 = peg$parseplus();
        }
        if (s2 === peg$FAILED) {
          s2 = peg$c10;
        }
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$parseDIGIT();
          if (s4 !== peg$FAILED) {
            while (s4 !== peg$FAILED) {
              s3.push(s4);
              s4 = peg$parseDIGIT();
            }
          } else {
            s3 = peg$c1;
          }
          if (s3 !== peg$FAILED) {
            s1 = [s1, s2, s3];
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsefrac() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      s1 = peg$parsedecimal_point();
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parseDIGIT();
        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$parseDIGIT();
          }
        } else {
          s2 = peg$c1;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseint() {
      var s0, s1, s2, s3;

      s0 = peg$parsezero();
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parsedigit1_9();
        if (s1 !== peg$FAILED) {
          s2 = [];
          s3 = peg$parseDIGIT();
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$parseDIGIT();
          }
          if (s2 !== peg$FAILED) {
            s1 = [s1, s2];
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      }

      return s0;
    }

    function peg$parseminus() {
      var s0;

      if (input.charCodeAt(peg$currPos) === 45) {
        s0 = peg$c69;
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c70); }
      }

      return s0;
    }

    function peg$parseplus() {
      var s0;

      if (input.charCodeAt(peg$currPos) === 43) {
        s0 = peg$c71;
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c72); }
      }

      return s0;
    }

    function peg$parsezero() {
      var s0;

      if (input.charCodeAt(peg$currPos) === 48) {
        s0 = peg$c73;
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c74); }
      }

      return s0;
    }

    function peg$parsestring() {
      var s0, s1, s2, s3;

      peg$silentFails++;
      s0 = peg$currPos;
      s1 = peg$parsequotation_mark();
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parsechar();
        while (s3 !== peg$FAILED) {
          s2.push(s3);
          s3 = peg$parsechar();
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parsequotation_mark();
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c76(s2);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }
      peg$silentFails--;
      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c75); }
      }

      return s0;
    }

    function peg$parsechar() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

      s0 = peg$parseunescaped();
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseescape();
        if (s1 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 34) {
            s2 = peg$c77;
            peg$currPos++;
          } else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c78); }
          }
          if (s2 === peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 92) {
              s2 = peg$c79;
              peg$currPos++;
            } else {
              s2 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c80); }
            }
            if (s2 === peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 47) {
                s2 = peg$c81;
                peg$currPos++;
              } else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c82); }
              }
              if (s2 === peg$FAILED) {
                s2 = peg$currPos;
                if (input.charCodeAt(peg$currPos) === 98) {
                  s3 = peg$c83;
                  peg$currPos++;
                } else {
                  s3 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c84); }
                }
                if (s3 !== peg$FAILED) {
                  peg$reportedPos = s2;
                  s3 = peg$c85();
                }
                s2 = s3;
                if (s2 === peg$FAILED) {
                  s2 = peg$currPos;
                  if (input.charCodeAt(peg$currPos) === 102) {
                    s3 = peg$c86;
                    peg$currPos++;
                  } else {
                    s3 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c87); }
                  }
                  if (s3 !== peg$FAILED) {
                    peg$reportedPos = s2;
                    s3 = peg$c88();
                  }
                  s2 = s3;
                  if (s2 === peg$FAILED) {
                    s2 = peg$currPos;
                    if (input.charCodeAt(peg$currPos) === 110) {
                      s3 = peg$c89;
                      peg$currPos++;
                    } else {
                      s3 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$c90); }
                    }
                    if (s3 !== peg$FAILED) {
                      peg$reportedPos = s2;
                      s3 = peg$c91();
                    }
                    s2 = s3;
                    if (s2 === peg$FAILED) {
                      s2 = peg$currPos;
                      if (input.charCodeAt(peg$currPos) === 114) {
                        s3 = peg$c92;
                        peg$currPos++;
                      } else {
                        s3 = peg$FAILED;
                        if (peg$silentFails === 0) { peg$fail(peg$c93); }
                      }
                      if (s3 !== peg$FAILED) {
                        peg$reportedPos = s2;
                        s3 = peg$c94();
                      }
                      s2 = s3;
                      if (s2 === peg$FAILED) {
                        s2 = peg$currPos;
                        if (input.charCodeAt(peg$currPos) === 116) {
                          s3 = peg$c95;
                          peg$currPos++;
                        } else {
                          s3 = peg$FAILED;
                          if (peg$silentFails === 0) { peg$fail(peg$c96); }
                        }
                        if (s3 !== peg$FAILED) {
                          peg$reportedPos = s2;
                          s3 = peg$c97();
                        }
                        s2 = s3;
                        if (s2 === peg$FAILED) {
                          s2 = peg$currPos;
                          if (input.charCodeAt(peg$currPos) === 117) {
                            s3 = peg$c98;
                            peg$currPos++;
                          } else {
                            s3 = peg$FAILED;
                            if (peg$silentFails === 0) { peg$fail(peg$c99); }
                          }
                          if (s3 !== peg$FAILED) {
                            s4 = peg$currPos;
                            s5 = peg$currPos;
                            s6 = peg$parseHEXDIG();
                            if (s6 !== peg$FAILED) {
                              s7 = peg$parseHEXDIG();
                              if (s7 !== peg$FAILED) {
                                s8 = peg$parseHEXDIG();
                                if (s8 !== peg$FAILED) {
                                  s9 = peg$parseHEXDIG();
                                  if (s9 !== peg$FAILED) {
                                    s6 = [s6, s7, s8, s9];
                                    s5 = s6;
                                  } else {
                                    peg$currPos = s5;
                                    s5 = peg$c1;
                                  }
                                } else {
                                  peg$currPos = s5;
                                  s5 = peg$c1;
                                }
                              } else {
                                peg$currPos = s5;
                                s5 = peg$c1;
                              }
                            } else {
                              peg$currPos = s5;
                              s5 = peg$c1;
                            }
                            if (s5 !== peg$FAILED) {
                              s5 = input.substring(s4, peg$currPos);
                            }
                            s4 = s5;
                            if (s4 !== peg$FAILED) {
                              peg$reportedPos = s2;
                              s3 = peg$c100(s4);
                              s2 = s3;
                            } else {
                              peg$currPos = s2;
                              s2 = peg$c1;
                            }
                          } else {
                            peg$currPos = s2;
                            s2 = peg$c1;
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
          if (s2 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c101(s2);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      }

      return s0;
    }

    function peg$parseescape() {
      var s0;

      if (input.charCodeAt(peg$currPos) === 92) {
        s0 = peg$c79;
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c80); }
      }

      return s0;
    }

    function peg$parsequotation_mark() {
      var s0;

      if (input.charCodeAt(peg$currPos) === 34) {
        s0 = peg$c77;
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c78); }
      }

      return s0;
    }

    function peg$parseunescaped() {
      var s0;

      if (peg$c102.test(input.charAt(peg$currPos))) {
        s0 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c103); }
      }

      return s0;
    }

    function peg$parseDIGIT() {
      var s0;

      if (peg$c104.test(input.charAt(peg$currPos))) {
        s0 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c105); }
      }

      return s0;
    }

    function peg$parseHEXDIG() {
      var s0;

      if (peg$c106.test(input.charAt(peg$currPos))) {
        s0 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c107); }
      }

      return s0;
    }

    function peg$parse_() {
      var s0, s1;

      peg$silentFails++;
      s0 = [];
      s1 = peg$parsewhitespace();
      while (s1 !== peg$FAILED) {
        s0.push(s1);
        s1 = peg$parsewhitespace();
      }
      peg$silentFails--;
      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c108); }
      }

      return s0;
    }

    function peg$parsewhitespace() {
      var s0;

      if (peg$c109.test(input.charAt(peg$currPos))) {
        s0 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c110); }
      }

      return s0;
    }

    peg$result = peg$startRuleFunction();

    if (peg$result !== peg$FAILED && peg$currPos === input.length) {
      return peg$result;
    } else {
      if (peg$result !== peg$FAILED && peg$currPos < input.length) {
        peg$fail({ type: "end", description: "end of input" });
      }

      throw peg$buildException(null, peg$maxFailExpected, peg$maxFailPos);
    }
  }

  return {
    SyntaxError: SyntaxError,
    parse:       parse
  };
})();
/* eslint-enable */

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETTemplating.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
General-purpose support for data templating.
*/

//  ========================================================================
//  STRING TEMPLATING
//  ========================================================================

TP.defineMetaInstMethod('transform',
function(aDataSource, transformParams) {

    /**
     * @method transform
     * @summary Performs a transformation on the supplied data source object
     *     using the receiver.
     * @description At this level, this method merely calls transform<Type>
     *     where <type> is the type of the data source. If that type has no
     *     transform method, transformObject() will be called as the default.
     * @param {Object} aDataSource The object supplying the data to use in the
     *     transformation.
     * @param {TP.core.Hash|TP.sig.Request} transformParams A parameter
     *     container responding to at(). For string transformations a key of
     *     'repeat' with a value of true will cause iteration to occur (if
     *     aDataSource is an 'ordered collection' this flag needs to be set to
     *     'true' in order to have 'automatic' iteration occur). Additional keys
     *     of '$REPEAT_START' and '$REPEAT_LIMIT' determine the range of the
     *     iteration.
     * @returns {String} The string resulting from the transformation process.
     */

    //  context, specializer, prefix, suffix, fallback, arglist
    return this.callBestMethod(arguments, aDataSource,
                                'transform', null,
                                'transformObject');
});

//  ------------------------------------------------------------------------

TP.defineCommonMethod('transformObject',
function(aDataSource, transformParams) {

    /**
     * @method transformObject
     * @summary Performs a transformation on the supplied data source object
     *     using the receiver.
     * @description At this level, this method is providing the 'fallback' for
     *     the 'transform()' method. It provides no functionality.
     * @param {Object} aDataSource The object supplying the data to use in the
     *     transformation.
     * @param {TP.core.Hash|TP.sig.Request} transformParams A parameter
     *     container responding to at(). For string transformations a key of
     *     'repeat' with a value of true will cause iteration to occur (if
     *     aDataSource is an 'ordered collection' this flag needs to be set to
     *     'true' in order to have 'automatic' iteration occur). Additional keys
     *     of '$REPEAT_START' and '$REPEAT_LIMIT' determine the range of the
     *     iteration.
     * @returns {String} The string resulting from the transformation process.
     */

    return null;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('compile',
function(templateName, ignoreCache, shouldRegister, sourceVarNames, echoFormat, annotateMarkup) {

    /**
     * @method compile
     * @summary Compiles the receiver string template and registers it under
     *     the key provided. If no template name is provided all cache and
     *     registration flags are effectively ignored.
     * @param {String} templateName The template's lookup ID.
     * @param {Boolean} [ignoreCache=false] If true, this method ignores the
     *     template cache and will compile and register the template, even if it
     *     has done so before.
     * @param {Boolean} [shouldRegister=true] If false, this method does not
     *     register the template in the template cache.
     * @param {String[]} sourceVarNames An Array of variable names that have a
     *     '$' as their first character, but that we want the templating engine
     *     to treat as coming from the data source instead of the params (the
     *     engine will usually treat '$' variables specially and draw their data
     *     from the 'params' argument instead of the source).
     * @param {Boolean} [echoFormat=true] Whether or not to 'echo' the format
     *     out to the result if no source object can be computed for it.
     * @param {Boolean} [annotateMarkup=true] Whether or not to annotate markup
     *     output with embedded XHTML 'span' elements that wrap ACP expressions
     *     and contain the ACP expression in a 'tibet:templateexpr' attribute
     *     on that element.
     * @returns {Function|undefined} The compiled template Function.
     */

    var str,
        regName,
        uri,

        shouldEcho,

        func,

        tokens,

        newTokens,
        len,
        i,

        tokenType,
        tokenText,
        lastTokenText;

    //  Force a string representation. This ensures certain Mozilla bugs
    //  don't get triggered by referencing 'this' alone.
    if (TP.isEmpty(str = this.toString())) {
        return null;
    }

    //  If the template name contains 'substitution characters' (i.e. '#@%',
    //  etc. - which can happen when using them standalone) then make sure to
    //  escape the name before trying to use it as a URI name to register the
    //  template under.
    if (TP.regex.FORMAT_SUBSTITUTION.test(regName = templateName)) {
        regName = window.escape(regName);
    }

    //  Check under any regName provided if we're supposed to check the cache.
    if (TP.notEmpty(regName) && TP.notTrue(ignoreCache)) {

        //  Build a URI and check to see if it already has a resource result -
        //  if so, it's the template function.
        uri = TP.uc(TP.TIBET_URN_PREFIX + regName);
        if (TP.isURI(uri)) {

            //  NB: We assume 'async' of false here.
            if (TP.isFunction(func = uri.getResource().get('result'))) {
                return func;
            }
        }
    }

    shouldEcho = TP.ifInvalid(echoFormat, true);

    //  No dynamic ACP content? The function is one that returns a simple static
    //  string.
    if (!TP.regex.HAS_ACP.test(str)) {

        func =
            function(aDataSource) {
                return str;
            };

    } else {
        //  Tokenize the String template. {{}} constructs will appear in the
        //  output as 'value' tokens
        try {
            tokens = TP.$templateParser.parse(str);
        } catch (e) {
            return this.raise(
                    'TP.sig.TemplateTokenizationFailed',
                    TP.ec(e,
                        TP.sc('Tokenization failed at: ', e.line || 'unknown',
                                ' in template named: ', templateName,
                                ' with source: ' + str)));
        }

        //  If the invoker hasn't explicitly set annotateMarkup to false, and
        //  the result output contains markup, then annotate it with XHTML span
        //  elements.
        if (TP.notFalse(annotateMarkup) &&
            TP.regex.CONTAINS_ELEM_MARKUP.test(str)) {

            //  Allocate our Array of 'new tokens'.
            newTokens = TP.ac();

            len = tokens.getSize();
            for (i = 0; i < len; i++) {

                //  Grab the token type and test it to see if it's a 'value' or
                //  'control' token.
                tokenType = tokens.at(i).at(0);
                tokenText = tokens.at(i).at(1);

                if (TP.regex.ACP_VALUE_TOKEN.test(tokenType) ||
                    TP.regex.ACP_CONTROL_TOKEN.test(tokenType)) {

                    //  Grab the token text for the 'last' token.
                    lastTokenText = tokens.at(i - 1).at(1);

                    //  If the last token's text contains only the start of an
                    //  XML attribute or element, then we don't want to embed
                    //  markup inside of that - just push the token and move on.
                    if (TP.regex.CONTAINS_ONLY_ATTR_START.test(lastTokenText) ||
                        TP.regex.CONTAINS_ONLY_ELEM_START.test(lastTokenText)) {
                        newTokens.push(tokens.at(i));
                    } else {

                        //  Otherwise, push 2 additional 'text' tokens 'around'
                        //  the original token that contain a text blob of the
                        //  starting and ending markup.
                        newTokens.push(
                            TP.ac('text',
                                    '<span' +
                                    ' tibet:templateexpr="' + tokenText + '"' +
                                    '>'),
                                    tokens.at(i),
                                    TP.ac('text', '</span>'));
                    }
                } else {

                    //  Otherwise, just push the token and move on.
                    newTokens.push(tokens.at(i));
                }
            }

            //  Make the tokens that we'll use the 'new tokens'.
            tokens = newTokens;
        }

        //  Compile the tokenized template into a Function object
        func = this.$compileTemplateTokens(
                        tokens, templateName, sourceVarNames, shouldEcho);
    }

    //  Compilation/creation of a template function failed.
    if (!TP.isFunction(func)) {
        this.raise('TP.sig.InvalidTemplate',
                    'Unable to compile string: ' + str);

        return;
    }

    //  Register as a compiled template for reuse provided we have a valid
    //  regName to use.
    if (TP.notEmpty(regName) && TP.notFalse(shouldRegister)) {
        TP.uc(TP.TIBET_URN_PREFIX + regName).setResource(func);
    }

    return func;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('$compileTemplateTokens',
function(tokenList, templateName, sourceVarNames, echoFormat) {

    /**
     * @method $compileTemplateTokens
     * @summary Compiles the supplied template tokens into a JavaScript
     *     Function object.
     * @param {String[]} tokenList The list of tokens representing the template.
     * @param {String} templateName The template's lookup ID. In this method,
     *     this is used by inline templates to qualify their name.
     * @param {String[]} sourceVarNames An Array of variable names that have a
     *     '$' as their first character, but that we want the templating engine
     *     to treat as coming from the data source instead of the params (the
     *     engine will usually treat '$' variables specially and draw their data
     *     from the 'params' argument instead of the source).
     * @param {Boolean} [echoFormat] Whether or not to 'echo' the format out to
     *     the result if no source object can be computed for it.
     * @returns {Function} The compiled template Function.
     */

    var srcVars,

        newlineChar,
        inlineCount,

        ignoreNull,
        formattedValue,

        generators,
        commands,

        funcParts,
        funcBody,

        templateFunc,

        scopedParams,
        scopedSourceNames,

        funcStr;

    srcVars = sourceVarNames;
    if (TP.notValid(srcVars)) {
        srcVars = TP.ac();
    }

    scopedParams = TP.ac();
    scopedSourceNames = TP.ac();

    inlineCount = 0;

    newlineChar = '__NEW_LINE__';

    ignoreNull = 'return TP.isNull(result) ? \'\' : TP.str(result);';

    formattedValue = function(faultText, argFormat, isRepeating) {
        //  Returns an expression that will return the value formatted according
        //  to the supplied format, and whether it's a repeating format.

        var retVal;

        if (TP.notEmpty(argFormat)) {

            //  Had a format
            if (isRepeating) {

                //  It's a repeating format
                if (echoFormat) {
                    retVal = '(TP.format(TP.ifInvalid(result, ' +
                                            '\'{{' + faultText + '}}\'),' +
                                    ' "' + argFormat + '", ' +
                                    'params.atPut(\'repeat\', true)))';
                } else {
                    retVal = '(TP.format(TP.ifInvalid(result, ' +
                                            '\'\'),' +
                                    ' "' + argFormat + '", ' +
                                    'params.atPut(\'repeat\', true)))';
                }
            } else {

                //  It's a non-repeating format
                if (echoFormat) {
                    retVal = '(TP.format(TP.ifInvalid(result, ' +
                                            '\'{{' + faultText + '}}\'),' +
                                    ' "' + argFormat + '", params))';
                } else {
                    retVal = '(TP.format(TP.ifInvalid(result, ' +
                                            '\'\'),' +
                                    ' "' + argFormat + '", params))';
                }
            }
        } else {

            //  No format - just the value 'formatted' as a String
            if (echoFormat) {
                retVal = '(TP.format(TP.ifInvalid(result, ' +
                                            '\'{{' + faultText + '}}\'),' +
                                    ' "' + 'String' + '"))';
            } else {
                retVal = '(TP.format(TP.ifInvalid(result, ' +
                                            '\'\'),' +
                                    ' "' + 'String' + '"))';
            }
        }

        return retVal;
    };

    generators = {

        defineUndefined: function(arg) {
            //  Returns an expression that returns an empty String if the
            //  argument is not defined.

            return 'if (!TP.isDefined(' +
                    generators.escapedIdentifier(arg) +
                    ')) { return \'\'; };';
        },

        escape: function(str) {
            //  Returns any single quote within the str as escaped quotes.

            return str.replace(/'/g, '\\\'');
        },

        escapedIdentifier: function(str) {
            //  Returns any supplied identifier as a 'hashed number' if it can't
            //  be expressed as a JavaScript identifier

            if (!TP.regex.JS_IDENTIFIER.test(str)) {
                return '_' + str.asHashedNumber().abs();
            }

            return str;
        },

        guardCollection: function(arg) {
            //  Returns an expression that will tested the provided argument to
            //  see if it is defined. If so, it will be used - otherwise it will
            //  return an empty Array

            return '!TP.isDefined(' +
                    generators.escapedIdentifier(arg) +
                    ') ? TP.ac() : ' +
                arg;
        },

        getFromArgs: function(propName) {
            //  Returns an expression that will try to extract a value for the
            //  property named by the propName parameter. The source object for
            //  this will either be the data source or the params handed to the
            //  generated Function or a source variable 'in scope'.

            var identName,

                retVal,
                sourceName;

            identName = generators.escapedIdentifier(propName);

            //  If the propName starts with a '$' and isn't in the 'special
            //  list' of 'source variable' supplied by the caller, then it
            //  should get its value from the 'params' parameter to the template
            //  Function
            if (TP.regex.IS_ACP_VARIABLE.test(propName) &&
                !srcVars.contains(propName)) {
                sourceName = 'params';
            } else {
                //  Otherwise, if a list of 'scoped source' names is being kept
                //  (we're probably being generated inside of a control
                //  structure of some sort), check with that list. If there is
                //  no entry there, then use 'source'.
                if (TP.isEmpty(sourceName = scopedSourceNames.last())) {
                    sourceName = 'source';
                }
            }

            //  Generate the expression.
            retVal = 'var ' + identName + ' = ' +
                        'TP.objectValue(' + sourceName + ',' +
                                    ' ' + propName.quoted() + ',' +
                                    ' true);' + newlineChar;

            retVal += identName + ' = TP.wrap(' + identName + ');';

            return retVal;
        },

        guardValue: function(arg) {
            //  Returns an expression that will tested the provided argument to
            //  see if it is defined. If so, it will be used - otherwise it will
            //  return a null.

            return '!TP.isDefined(' +
                    generators.escapedIdentifier(arg) + ') ? ' +
                    'null : ' + arg;
        },

        handle: function(item) {
            //  Handles processing a particular kind of token

            var args,
                command;

            //  item is a tuple [command, args, [,args]]
            args = item;
            command = args.shift();

            if (!TP.isCallable(commands[command])) {
                return this.raise(
                        'TP.sig.TemplateCompilationFailed',
                            TP.sc('Compilation failed.',
                                    ' Unknown handler for: ', command,
                                    ' with args: ' + args.shift()));
            }

            return commands[command].apply(this, args);
        }.bind(this),

        loop: function(input, joinChar) {
            //  Loops over the stream of tokens represented by input, invokes
            //  'handle' on each one, and concats it all together into a single
            //  expression

            return input.map(generators.handle).join(
                                joinChar || ' +' + newlineChar);
        },

        returnWrap: function(code) {
            //  Returns an expression that returns whatever the supplied code
            //  returns.

            return generators.wrap('return ' + code);
        },

        wrap: function(code) {
            //  Wraps the supplied code into a Function closure that is then
            //  executed.

            return '(function() {' + code + '})()';
        },

        valueFromVar: function(varName) {

            var valueGet,
                defaultStr,
                str;

            if (TP.notEmpty(scopedParams) &&
                (scopedParams.last().contains(varName) ||
                 scopedParams.last().contains(TP.ALL))) {
                valueGet = '';
            } else {
                valueGet = generators.getFromArgs(varName);
            }

            str = '(function() {\n' +
                valueGet + newlineChar +
                generators.defineUndefined(varName) + newlineChar +
                'var arg = (' + generators.escapedIdentifier(varName) + ');' +
                    newlineChar +
                'arg = TP.isCallable(arg) ? arg(params) : arg;' + newlineChar +
                defaultStr +
                'if (TP.isArray(arg)) {arg.$set(\'delimiter\', \'\')};' +
                    newlineChar +
                'var result = ' + varName + ';' + newlineChar +
                ignoreNull +
                '})()';

            return str;
        },

        valueStatement: function(expr) {

            var valueGet,
                str;

            if (TP.notEmpty(scopedParams) &&
                (scopedParams.last().contains(expr) ||
                 scopedParams.last().contains(TP.ALL))) {
                valueGet = '';
            } else {
                valueGet = generators.getFromArgs(expr);
            }

            str =
                valueGet + newlineChar +
                generators.defineUndefined(expr) + newlineChar +
                'result = (' + generators.escapedIdentifier(expr) + ');' +
                    newlineChar +
                'result = TP.isCallable(result) ? result(params) : result;' +
                    newlineChar +
                'if (TP.isArray(result)) ' +
                    '{result.$set(\'delimiter\', \'\')};' +
                    newlineChar;

            return str;
        },
        formatStatement: function(faultText, format, isRepeating) {

            var str;

            str = 'result = ' + formattedValue(faultText, format, isRepeating) +
                    ';' +
                    newlineChar;

            return str;
        },
        defaultStatement: function(expr) {

            var str;

            str =
                'if (TP.isEmpty(result)) {' +
                    'result = ' + expr + '; ' +
                    'if (TP.isArray(result)) {' +
                        'result.$set(\'delimiter\', \'\')};' +
                '}' + newlineChar;

            return str;
        }
    };

    commands = {
        comment: function() {
            //  For comments, just return a Function returning the empty string.

            return generators.returnWrap('\'\'');
        },

        text: function(text) {
            //  For comments, just return a Function returning a string with
            //  escaped text.

            return generators.returnWrap(
                    '\'' + generators.escape(text) + '\';');
        },

        value: function(arg) {

            var src,
                tokens,

                len,
                i,

                expr,
                currentOp,

                wroteStart,
                escapedTemplate,

                result,

                token,
                val,

                inlineTemplate,
                inlineName,

                formatFaultText;

            src = arg;

            TP.regex.ACP_OPERATORS.lastIndex = 0;
            src = src.replace(TP.regex.ACP_OPERATORS, ' $1 ');

            tokens = TP.$tokenize(
                        src,
                        //  All of the JS operators *and* the TSH operators
                        TP.tsh.script.$tshAndJSOperators,
                        true, true, false, true);

            expr = '';
            currentOp = null;
            wroteStart = false;
            escapedTemplate = '';

            result = '(function() {' + newlineChar +
                        'var result;' + newlineChar;

            len = tokens.getSize();
            for (i = 0; i < len; i++) {

                token = tokens.at(i);
                val = token.value;

                switch (token.name) {

                    case 'operator':

                        TP.regex.ACP_OPERATORS.lastIndex = 0;
                        if (TP.isValid(currentOp) &&
                            TP.regex.ACP_OPERATORS.test(val)) {

                            expr = TP.trim(expr);

                            //  Escaped template - slice out the escaping '\'
                            //  characters from either end (making sure to
                            //  append '}}' to reconstruct the template) and
                            //  exit here.
                            if (expr.at(0) === '\\') {
                                escapedTemplate = expr.slice(1, -3) + '}}';

                                expr = '';
                                currentOp = null;

                                break;
                            } else {
                                formatFaultText =
                                    TP.sc('<NOT_FOUND: ', expr, ' >');

                                switch (currentOp) {
                                    case '.%':
                                        result += generators.formatStatement(
                                                formatFaultText, expr, false);
                                        break;
                                    case '.%*':
                                        result += generators.formatStatement(
                                                formatFaultText, expr, true);
                                        break;
                                    case '.||':
                                        result += generators.defaultStatement(
                                                expr);
                                        break;
                                    default:
                                        break;
                                }
                            }

                            expr = '';
                            currentOp = null;
                        }

                        switch (val) {
                            case '.%':
                            case '.%*':
                            case '.||':
                                currentOp = val;
                                break;
                            default:
                                //  leave everything else alone
                                expr += val;
                                break;
                        }

                        break;

                    case 'template':

                        inlineTemplate = val;

                        //  compute a unique name for the 'inline' template
                        inlineName = templateName + '_inline_' + inlineCount++;

                        //  compile and register it (ignoring any previously
                        //  cached value)
                        inlineTemplate.compile(inlineName, true);

                        expr = inlineName;

                        if (TP.isValid(currentOp)) {

                            formatFaultText = TP.sc('<NOT_FOUND: ', expr, ' >');

                            switch (currentOp) {
                                case '.%':
                                    result += generators.formatStatement(
                                                formatFaultText, expr, false);
                                    break;
                                case '.%*':
                                    result += generators.formatStatement(
                                                formatFaultText, expr, true);
                                    break;
                                default:
                                    break;
                            }

                            expr = '';
                            currentOp = null;
                        }

                        break;

                    case 'identifier':

                        //  TODO: This is a hack due to a bug in the tokenizer
                        if (val === '($') {
                            val = '$';
                        }

                        //  Note the fallthrough

                    default:
                        //  leave everything else alone
                        expr += val;

                        break;
                }

                if (TP.isValid(currentOp) && !wroteStart) {
                    expr = TP.trim(expr);

                    result += generators.valueStatement(expr);

                    wroteStart = true;
                    expr = '';

                    continue;
                }
            }

            expr = TP.trim(expr);
            if (!wroteStart) {
                result += generators.valueStatement(expr);
            } else if (TP.isValid(currentOp)) {

                formatFaultText = TP.sc('<NOT_FOUND: ', expr, ' >');

                if (TP.notEmpty(expr)) {

                    //  Escaped template - slice out the escaping '\' characters
                    //  from either end (making sure to append '}}' to
                    //  reconstruct the template).
                    if (expr.at(0) === '\\') {
                        escapedTemplate = expr.slice(1, -3) + '}}';
                    } else {
                        switch (currentOp) {
                            case '.%':
                                result += generators.formatStatement(
                                                formatFaultText, expr, false);
                                break;
                            case '.%*':
                                result += generators.formatStatement(
                                                formatFaultText, expr, true);
                                break;
                            case '.||':
                                result += generators.defaultStatement(expr);
                                break;
                            default:
                                break;
                        }
                    }
                }
            }

            //  If there's an escaped template, we ignore all other computed
            //  results and just output a statement to return it quoted.
            if (TP.notEmpty(escapedTemplate)) {
                result = '(function() {' + newlineChar +
                            'return ' + escapedTemplate.quoted('\'');
            } else {
                result += ignoreNull + newlineChar;
            }

            result += '})()';

            return result;
        },

        html: function(arg) {
            return generators.returnWrap(generators.valueFromVar(arg));
        },

        for: function(data, blocks) {
            //  For 'for' statements, generate an expression that does the
            //  looping and manages closured variables.

            var aspectName,
                argNames,

                collection,

                retVal;

            //  If there were arguments supplied, then 'data' will be a hash of
            //  'data' (the aspectName) and 'args' (the arguments to the control
            //  block)
            if (TP.isValid(argNames = data.args)) {
                aspectName = data.data;
                argNames = argNames.split(',');
            } else {
                //  Otherwise, the aspectName *is* the data and we default the
                //  arguments to '(item, index)'
                aspectName = data;
                argNames = TP.ac('item', 'index');
            }

            //  Push the Array of argument names onto the 'scoped parameters'
            //  list. This gets used when generating expressions that extract
            //  set up local variable values. If there are scoped parameters,
            //  then these 'setup expressions' will *not* be generated and
            //  values will come from the enclosing scope.
            scopedParams.push(argNames);

            //  Guard the collection in case it's null
            collection = generators.guardCollection(aspectName);

            //  Generate the expression that will extract the value from the
            //  data source.
            retVal = generators.getFromArgs(aspectName);

            //  Make the aspectName (i.e. 'item' or whatever was supplied)
            //  available as a 'scoped source'.
            scopedSourceNames.push(
                    generators.escapedIdentifier(argNames.first()));

            //  Generate an expression that does a 'collect' over the embedded
            //  control structure expression and returns that result. Note that
            //  the expression does a 'getValues()' on the collection in case
            //  it's not an Array.
            retVal =
                generators.wrap(
                    retVal +
                    'return ' + collection +
                    '.getValues().collect(function(' +
                                            argNames.join(', ') +
                                            ')' +
                    '{return ' + generators.loop(blocks) + '}).join(\'\')');

            //  Pop off whatever we pushed onto the 'scoped source' stack.
            scopedSourceNames.pop();

            //  Pop off whatever we pushed onto the 'scoped parameters' stack.
            scopedParams.pop();

            return retVal;
        },

        with: function(aspectName, blocks) {
            //  For 'with' statements, generate an expression that manages
            //  closured variables.

            var retVal;

            //  Generate the expression that will extract the value from the
            //  data source.
            retVal = generators.getFromArgs(aspectName);

            //  Make the aspectName available as a 'scoped source'.
            scopedSourceNames.push(generators.escapedIdentifier(aspectName));

            //  Generate an expression that will return looping over each block
            //  'under' the 'with.
            retVal = generators.wrap(
                        retVal +
                        'return ' + generators.loop(blocks));

            //  Pop off whatever we pushed onto the 'scoped source' stack.
            scopedSourceNames.pop();

            return retVal;
        },

        if: function(aspectName, blocks, else_blocks) {
            //  For 'if' statements, generate an expression that executes only
            //  if the data at the end of the aspect path exists

            var retVal,
                tail;

            //  Generate the expression that will extract the value from the
            //  data source.
            retVal = generators.getFromArgs(aspectName);

            //  Make the aspectName available as a 'scoped source'.
            scopedSourceNames.push(generators.escapedIdentifier(aspectName));

            //  If there are any 'else' statements, generate the proper code for
            //  them.
            tail = else_blocks ?
                    generators.loop(else_blocks, ' ') :
                    'else {return \'\'}';

            //  Generate an expression that does the 'if' logic.
            retVal = generators.wrap(
                    retVal +
                    'if (' + generators.escapedIdentifier(aspectName) + ')' +
                        '{return ' + generators.loop(blocks) + '}' + tail);

            //  Pop off whatever we pushed onto the 'scoped source' stack.
            scopedSourceNames.pop();

            return retVal;
        },

        else: function(args, block) {
            //  For 'else' statements, we just generate what we need to fit up
            //  under an 'if' block
            return 'else if (' + args + ')' +
                        '{return ' + generators.loop(block) + '}';
        }
    };

    //  Loop over all of the tokens and generate expressions. Then take any
    //  newlines and returns and converted them to escaped newlines.
    funcBody = generators.loop(tokenList).replace(/\n|\r/ig, '\\n');

    funcBody = funcBody.replace(/__NEW_LINE__/g, '\n');

    //  Couldn't generate a String? - exit here.
    if (TP.isEmpty(funcBody)) {
        //  TODO: Raise an exception
        return null;
    }

    funcParts = TP.ac();

    funcParts.push(
        'var params,\n',
        '    source;\n',
        '\n',
        'params = TP.ifInvalid(aParamHash, TP.hc());\n',
        'params.$$noPathTracking = true;\n',
        'source = TP.wrap(aDataSource);\n',
        '\n\n',

        'try\n',
        '{\n',

        'return (', funcBody, ')\n',

        '}\n',
        'catch(e)\n',
        '{\n',
            'TP.ifError() ? TP.error(TP.ec(e)): 0;\n',
        '};\n');

    funcStr = funcParts.join('');

    try {
        templateFunc = TP.fc('aDataSource', 'aParamHash', funcStr);
    } catch (e) {
        TP.ifError() ?
            TP.error(
                TP.ec(e, 'Error generating template function: ' + funcStr)) : 0;
    }

    return templateFunc;
});

//  ------------------------------------------------------------------------

String.Inst.defineMethod('transform',
function(aDataSource, transformParams) {

    /**
     * @method transform
     * @summary Performs a transformation on the supplied data source object
     *     using the receiver.
     * @description At this level, this method performs a TIBET-specific string
     *     interpolation (a fancy word for substitutions) of a particular form.
     *     In TIBET we support the {{varname}} for performing interpolation. See
     *     Function's version of 'transform' for more information on how
     *     transform() works.
     * @param {Object} aDataSource The object supplying the data to use in the
     *     transformation.
     * @param {TP.core.Hash|TP.sig.Request} transformParams A parameter
     *     container responding to at(). For string transformations a key of
     *     'repeat' with a value of true will cause iteration to occur (if
     *     aDataSource is an 'ordered collection' this flag needs to be set to
     *     'true' in order to have 'automatic' iteration occur). Additional keys
     *     of '$REPEAT_START' and '$REPEAT_LIMIT' determine the range of the
     *     iteration.
     * @returns {String|undefined} The string resulting from the transformation
     *     process.
     */

    var str,

        template,

        retVal,

        type,

        urnBuilt,
        urn,
        url;

    if (TP.isEmpty(str = this.toString())) {
        return;
    }

    //  type names can only have JS chars and colon, nothing more, so that's
    //  a quick check to see if we got a templating string
    if (TP.regex.HAS_ACP.test(str)) {

        //  concat here is to force string to be a primitive string
        template = '' + str;

        //  If there is escaped quoted content, then double escape it to avoid
        //  problems when the Function is created from the string.
        if (TP.regex.CONTENT_WITH_ESCAPED_QUOTES.test(template)) {
            template = template.replace(/\\/g, '\\\\');
        }

        //  If there are valid transform parameters, then pass any value of
        //  'sourcevars' to the compile method. This allows the caller to tell
        //  the template Function generation routine that certain '$' variables
        //  should be resolved against the source (normally, special '$'
        //  variables are resolved using the transform params itself as the data
        //  source).
        if (TP.isValid(transformParams)) {
            template = template.compile(
                        null,
                        false,
                        true,
                        transformParams.at('sourcevars'),
                        transformParams.at('shouldEcho'),
                        transformParams.at('annotateMarkup'));
        } else {
            template = template.compile(null, false, true);
        }

        if (TP.isCallable(template)) {
            return template.transform(aDataSource, transformParams);
        } else {
            TP.ifError() ?
                TP.error('Unable to compile formatting template: ' +
                                str) : 0;
            return;
        }
    } else if (TP.regex.FORMAT_SUBSTITUTION.test(str)) {
        //  context, specializer, prefix, suffix, fallback, arglist
        return this.callBestMethod(arguments, aDataSource,
                                    'transform', null,
                                    'transformObject');
    } else if (TP.isType(type = TP.sys.getTypeByName(str))) {
        if (TP.canInvoke(type, 'transform')) {
            TP.$$templateContext = transformParams;
            retVal = type.transform(aDataSource, transformParams);
            TP.$$templateContext = null;
            return retVal;
        } else {
            return TP.raise(this, 'TP.sig.InvalidFormat',
                            str + ' does not support transform call.');
        }
    } else {

        //  See if the format is a URI string. If so, see if there's a real URL
        //  that we can use to do the formatting.

        //  Note that this code is structured to purposely avoid creating a URI
        //  via TP.uc for testing purposes. This avoids filling up the URI map
        //  with URIs that don't really have resources.

        urn = TP.uriExpandPath(str);
        if (!TP.isURIString(urn)) {
            urn = TP.TIBET_URN_PREFIX + urn;
        }

        //  If we have a URI string and there's already a registered instance of
        //  a URI matching that, then go ahead and use it.
        if (TP.isURIString(urn) && TP.uri.URI.hasInstance(urn)) {
            url = TP.uri.URI.getInstanceById(urn);
            //  NB: We assume 'async' of false here.
            if (TP.isValid(template = url.getResource().get('result'))) {
                return template.transform(aDataSource, transformParams);
            } else if (TP.notTrue(urnBuilt)) {
                //  If we didn't "augment" in an attempt to create a valid URI
                //  then the one provided didn't resolve/find a resource.
                TP.ifError() ?
                    TP.error('Unable to locate formatting template URN: ' +
                                    urn) : 0;
                return;
            }
        }
    }

    //  context, specializer, prefix, suffix, fallback, arglist
    return this.callBestMethod(arguments, aDataSource,
                                'transform', null,
                                'transformObject');
});

//  ------------------------------------------------------------------------

Function.Inst.defineMethod('transform',
function(aDataSource, transformParams) {

    /**
     * @method transform
     * @summary Performs a transformation on the supplied data source object
     *     using the receiver.
     * @description At this level, this method performs a TIBET-specific string
     *     interpolation (a fancy word for substitutions) of a particular form.
     *     In TIBET we support the {{varname}} for performing interpolation.
     *     In TIBET you can think of both the 'xpath' and 'varname' portions as
     *     representing an 'aspect' which is passed to the get() method for the
     *     target object. Normal get() processing takes over at that point so
     *     XML nodes will check for any supported access path syntax, as will
     *     JavaScript objects.
     * @param {Object} aDataSource The object supplying the data to use in the
     *     transformation.
     * @param {TP.core.Hash|TP.sig.Request} transformParams A parameter
     *     container responding to at(). For string transformations a key of
     *     'repeat' with a value of true will cause iteration to occur (if
     *     aDataSource is an 'ordered collection' this flag needs to be set to
     *     'true' in order to have 'automatic' iteration occur). Additional keys
     *     of '$REPEAT_START' and '$REPEAT_LIMIT' determine the range of the
     *     iteration.
     * @returns {String} The string resulting from the transformation process.
     */

    var dataSource,

        params,

        oldSource,

        retVal,

        isOrdered,

        source,

        start,
        limit,

        len,
        arr,
        i,

        val;

    //  NOTE!!! We do *not* change for validity of the data source. Some
    //  templating expressions can be executed without a data source. If no data
    //  source was supplied, we just use an empty TP.core.Hash.
    if (TP.notValid(dataSource = aDataSource)) {
        dataSource = TP.hc();
    }

    if (TP.isValid(transformParams)) {
        if (TP.canInvoke(transformParams, 'getPayload')) {
            params = transformParams.getPayload().copy();
        } else {
            params = transformParams.copy();
        }
    } else {
        params = TP.hc();
    }

    //  Supply the dataSource as $INPUT. This will be used in both iterating
    //  and non-iterating contexts.
    params.atPutIfAbsent('$INPUT', dataSource);

    //  It's not a collection OR it is a collection, but the caller has not
    //  specified to repeat, we run ourself and return the results.
    if (!TP.isCollection(dataSource) || TP.notTrue(params.at('repeat'))) {
        try {

            //  In a non-iterating context, '$_' is an alias for $INPUT
            params.atPutIfAbsent('$_', dataSource);

            oldSource = params.at('$_');

            TP.$$templateContext = params;
            retVal = this(dataSource, params);
            TP.$$templateContext = null;

            //  In case any nested templates messed with the $INPUT, restore it
            //  to the value we set before template execution.
            params.atPut('$INPUT', oldSource);

            //  In a non-iterating context, '$_' is an alias for $INPUT
            params.atPut('$_', oldSource);

            //  Make sure to return the primitive String
            return '' + retVal;
        } catch (e) {
            return this.raise('TP.sig.TransformFailed',
                                TP.ec(e, 'Transform failed'));
        }
    }

    //  Now that we've determined we should repeat, we remove the 'repeat'
    //  parameter from the params hash. This may seem strange, but we don't
    //  want to affect nested templates who will be reusing this parameter
    //  hash. They have mechanisms by which they can specify whether they
    //  want to repeat or not.
    params.removeKey('repeat');

    isOrdered = TP.isArray(dataSource) || TP.isNodeList(dataSource);
    if (isOrdered) {
        source = dataSource;
    } else if (TP.canInvoke(dataSource, 'getItems')) {
        source = dataSource.getItems();
    } else {
        return this.raise('TP.sig.InvalidParameter',
            'Argument must be a valid collection or object with items.');
    }

    //  More special variables which can be used along with '$INPUT' and
    //  '$INDEX' when iterating.
    start = TP.ifKeyInvalid(params,
                            '$REPEAT_START',
                            0);
    limit = TP.ifKeyInvalid(params,
                            '$REPEAT_LIMIT',
                            Number.POSITIVE_INFINITY);

    //  normalize iteration count to avoid running off end of data source
    len = (start + source.getSize()).min(start + limit);

    oldSource = params.at('$INPUT');

    arr = TP.ac();

    for (i = start; i < len; i++) {

        //  Make the current index available
        params.atPut('$INDEX', i);

        //  In an iterating context, '$#' is an alias for $INDEX
        params.atPut('$#', i);

        //  Make the current item available
        params.atPut('$ITEM', source.at(i));

        //  In an iterating context, '$_' is an alias for $ITEM
        params.atPut('$_', source.at(i));

        //  Some convenience variables
        params.atPut('$FIRST', i === start);
        params.atPut('$MIDDLE', i > start && i < len - 1);
        params.atPut('$LAST', i === len - 1);
        params.atPut('$EVEN', i % 2 === 0);
        params.atPut('$ODD', i % 2 !== 0);

        try {
            TP.$$templateContext = params;
            val = this(source.at(i), params);
            TP.$$templateContext = null;
        } catch (e) {
            return this.raise(
                    'TP.sig.TransformFailed',
                    TP.ec(e, 'Repeating transform failed on item: ' + i));
        }

        arr.push(val);
    }

    //  In case any nested templates messed with the $INPUT, restore it to the
    //  value we set before template execution and clear the others.

    params.atPut('$INPUT', oldSource);

    params.atPut('$INDEX', null);
    params.atPut('$#', null);
    params.atPut('$ITEM', null);
    params.atPut('$_', null);

    return arr.join('');
});

//  ========================================================================
//  Templating Parser
//  ========================================================================

//  Generate this by executing the following command (assuming NodeJS is
//  available):

//  pegjs --export-var 'TP.$templateParser' <tibet_dir>/src/tibet/grammars/template_parser.pegjs

/* eslint-disable */

TP.$templateParser = (function() {
  "use strict";

  /*
   * Generated by PEG.js 0.9.0.
   *
   * http://pegjs.org/
   */

  function peg$subclass(child, parent) {
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor();
  }

  function peg$SyntaxError(message, expected, found, location) {
    this.message  = message;
    this.expected = expected;
    this.found    = found;
    this.location = location;
    this.name     = "SyntaxError";

    if (typeof Error.captureStackTrace === "function") {
      Error.captureStackTrace(this, peg$SyntaxError);
    }
  }

  peg$subclass(peg$SyntaxError, Error);

  function peg$parse(input) {
    var options = arguments.length > 1 ? arguments[1] : {},
        parser  = this,

        peg$FAILED = {},

        peg$startRuleFunctions = { start: peg$parsestart },
        peg$startRuleFunction  = peg$parsestart,

        peg$c0 = function(body) { return ["text", body.join("")]},
        peg$c1 = "\\{",
        peg$c2 = { type: "literal", value: "\\{", description: "\"\\\\{\"" },
        peg$c3 = "\\}",
        peg$c4 = { type: "literal", value: "\\}", description: "\"\\\\}\"" },
        peg$c5 = { type: "any", description: "any character" },
        peg$c6 = function(c) {return c},
        peg$c7 = function(inner) {return ["value", inner.join("")]},
        peg$c8 = "{{",
        peg$c9 = { type: "literal", value: "{{", description: "\"{{\"" },
        peg$c10 = /^[:\/]/,
        peg$c11 = { type: "class", value: "[:/]", description: "[:/]" },
        peg$c12 = "}}",
        peg$c13 = { type: "literal", value: "}}", description: "\"}}\"" },
        peg$c14 = function(body) {return body},
        peg$c15 = /^[#%@]/,
        peg$c16 = { type: "class", value: "[#%@]", description: "[#%@]" },
        peg$c17 = "{",
        peg$c18 = { type: "literal", value: "{", description: "\"{\"" },
        peg$c19 = "}",
        peg$c20 = { type: "literal", value: "}", description: "\"}\"" },
        peg$c21 = function(sigil, body) {return sigil + '{' + body.join('') + '}'},
        peg$c22 = function(command) { return ["command", ""]},
        peg$c23 = function(command, body) { return ["command", body.join("")]},
        peg$c24 = function(body) { return body},
        peg$c25 = "html",
        peg$c26 = { type: "literal", value: "html", description: "\"html\"" },
        peg$c27 = "=",
        peg$c28 = { type: "literal", value: "=", description: "\"=\"" },
        peg$c29 = "!",
        peg$c30 = { type: "literal", value: "!", description: "\"!\"" },
        peg$c31 = function() {return "comment"},
        peg$c32 = function(open, inner, else_b, close) {
              if (open.command == close){
                if (open.command == "if"){
                  return [open.command, open.body.join(""), inner, else_b];
                } else {
                  if(open.args){
                    return [open.command, {args : open.args[0], data: open.body.join("")}, inner];
                  } else {
                    return [open.command, open.body.join(""), inner];
                  }
                }
              } else {
                throw new this.SyntaxError(
                  "No closing tag found for " + open.command + ' on line: ' + line() + ' at position: ' + column()
                );
              }
            },
        peg$c33 = "{{:",
        peg$c34 = { type: "literal", value: "{{:", description: "\"{{:\"" },
        peg$c35 = /^[a-zA-Z0-9]/,
        peg$c36 = { type: "class", value: "[a-zA-Z0-9]", description: "[a-zA-Z0-9]" },
        peg$c37 = "{{/:",
        peg$c38 = { type: "literal", value: "{{/:", description: "\"{{/:\"" },
        peg$c39 = function(command, args, body) { return {command:command, body:body, args:args}},
        peg$c40 = function(tail) { return tail},
        peg$c41 = "if",
        peg$c42 = { type: "literal", value: "if", description: "\"if\"" },
        peg$c43 = "for",
        peg$c44 = { type: "literal", value: "for", description: "\"for\"" },
        peg$c45 = "with",
        peg$c46 = { type: "literal", value: "with", description: "\"with\"" },
        peg$c47 = "log",
        peg$c48 = { type: "literal", value: "log", description: "\"log\"" },
        peg$c49 = "(",
        peg$c50 = { type: "literal", value: "(", description: "\"(\"" },
        peg$c51 = ")",
        peg$c52 = { type: "literal", value: ")", description: "\")\"" },
        peg$c53 = function(inner) { return inner.join("")},
        peg$c54 = function(body) { return body },
        peg$c55 = "else",
        peg$c56 = { type: "literal", value: "else", description: "\"else\"" },
        peg$c57 = function(expression, inner) { return ["else", expression, inner] },
        peg$c58 = function() { return "true"},
        peg$c59 = function(expression) { return expression.join("")},
        peg$c60 = "/",
        peg$c61 = { type: "literal", value: "/", description: "\"/\"" },
        peg$c62 = function(body) { return "{{" + body.join("") + "}}"},
        peg$c63 = function(body) { return "{{"+ body.join("") +"}}"},
        peg$c64 = { type: "other", description: "whitespace" },
        peg$c65 = /^[ \t\n\r]/,
        peg$c66 = { type: "class", value: "[ \\t\\n\\r]", description: "[ \\t\\n\\r]" },

        peg$currPos          = 0,
        peg$savedPos         = 0,
        peg$posDetailsCache  = [{ line: 1, column: 1, seenCR: false }],
        peg$maxFailPos       = 0,
        peg$maxFailExpected  = [],
        peg$silentFails      = 0,

        peg$result;

    if ("startRule" in options) {
      if (!(options.startRule in peg$startRuleFunctions)) {
        throw new Error("Can't start parsing from rule \"" + options.startRule + "\".");
      }

      peg$startRuleFunction = peg$startRuleFunctions[options.startRule];
    }

    function text() {
      return input.substring(peg$savedPos, peg$currPos);
    }

    function location() {
      return peg$computeLocation(peg$savedPos, peg$currPos);
    }

    function expected(description) {
      throw peg$buildException(
        null,
        [{ type: "other", description: description }],
        input.substring(peg$savedPos, peg$currPos),
        peg$computeLocation(peg$savedPos, peg$currPos)
      );
    }

    function error(message) {
      throw peg$buildException(
        message,
        null,
        input.substring(peg$savedPos, peg$currPos),
        peg$computeLocation(peg$savedPos, peg$currPos)
      );
    }

    function peg$computePosDetails(pos) {
      var details = peg$posDetailsCache[pos],
          p, ch;

      if (details) {
        return details;
      } else {
        p = pos - 1;
        while (!peg$posDetailsCache[p]) {
          p--;
        }

        details = peg$posDetailsCache[p];
        details = {
          line:   details.line,
          column: details.column,
          seenCR: details.seenCR
        };

        while (p < pos) {
          ch = input.charAt(p);
          if (ch === "\n") {
            if (!details.seenCR) { details.line++; }
            details.column = 1;
            details.seenCR = false;
          } else if (ch === "\r" || ch === "\u2028" || ch === "\u2029") {
            details.line++;
            details.column = 1;
            details.seenCR = true;
          } else {
            details.column++;
            details.seenCR = false;
          }

          p++;
        }

        peg$posDetailsCache[pos] = details;
        return details;
      }
    }

    function peg$computeLocation(startPos, endPos) {
      var startPosDetails = peg$computePosDetails(startPos),
          endPosDetails   = peg$computePosDetails(endPos);

      return {
        start: {
          offset: startPos,
          line:   startPosDetails.line,
          column: startPosDetails.column
        },
        end: {
          offset: endPos,
          line:   endPosDetails.line,
          column: endPosDetails.column
        }
      };
    }

    function peg$fail(expected) {
      if (peg$currPos < peg$maxFailPos) { return; }

      if (peg$currPos > peg$maxFailPos) {
        peg$maxFailPos = peg$currPos;
        peg$maxFailExpected = [];
      }

      peg$maxFailExpected.push(expected);
    }

    function peg$buildException(message, expected, found, location) {
      function cleanupExpected(expected) {
        var i = 1;

        expected.sort(function(a, b) {
          if (a.description < b.description) {
            return -1;
          } else if (a.description > b.description) {
            return 1;
          } else {
            return 0;
          }
        });

        while (i < expected.length) {
          if (expected[i - 1] === expected[i]) {
            expected.splice(i, 1);
          } else {
            i++;
          }
        }
      }

      function buildMessage(expected, found) {
        function stringEscape(s) {
          function hex(ch) { return ch.charCodeAt(0).toString(16).toUpperCase(); }

          return s
            .replace(/\\/g,   '\\\\')
            .replace(/"/g,    '\\"')
            .replace(/\x08/g, '\\b')
            .replace(/\t/g,   '\\t')
            .replace(/\n/g,   '\\n')
            .replace(/\f/g,   '\\f')
            .replace(/\r/g,   '\\r')
            .replace(/[\x00-\x07\x0B\x0E\x0F]/g, function(ch) { return '\\x0' + hex(ch); })
            .replace(/[\x10-\x1F\x80-\xFF]/g,    function(ch) { return '\\x'  + hex(ch); })
            .replace(/[\u0100-\u0FFF]/g,         function(ch) { return '\\u0' + hex(ch); })
            .replace(/[\u1000-\uFFFF]/g,         function(ch) { return '\\u'  + hex(ch); });
        }

        var expectedDescs = new Array(expected.length),
            expectedDesc, foundDesc, i;

        for (i = 0; i < expected.length; i++) {
          expectedDescs[i] = expected[i].description;
        }

        expectedDesc = expected.length > 1
          ? expectedDescs.slice(0, -1).join(", ")
              + " or "
              + expectedDescs[expected.length - 1]
          : expectedDescs[0];

        foundDesc = found ? "\"" + stringEscape(found) + "\"" : "end of input";

        return "Expected " + expectedDesc + " but " + foundDesc + " found.";
      }

      if (expected !== null) {
        cleanupExpected(expected);
      }

      return new peg$SyntaxError(
        message !== null ? message : buildMessage(expected, found),
        expected,
        found,
        location
      );
    }

    function peg$parsestart() {
      var s0, s1;

      s0 = [];
      s1 = peg$parseVALUE();
      if (s1 === peg$FAILED) {
        s1 = peg$parseCOMMAND();
        if (s1 === peg$FAILED) {
          s1 = peg$parseBLOCK();
          if (s1 === peg$FAILED) {
            s1 = peg$parseTEXT();
          }
        }
      }
      while (s1 !== peg$FAILED) {
        s0.push(s1);
        s1 = peg$parseVALUE();
        if (s1 === peg$FAILED) {
          s1 = peg$parseCOMMAND();
          if (s1 === peg$FAILED) {
            s1 = peg$parseBLOCK();
            if (s1 === peg$FAILED) {
              s1 = peg$parseTEXT();
            }
          }
        }
      }

      return s0;
    }

    function peg$parseTEXT() {
      var s0, s1, s2;

      s0 = peg$currPos;
      s1 = [];
      s2 = peg$parseTEXT_INNER();
      if (s2 !== peg$FAILED) {
        while (s2 !== peg$FAILED) {
          s1.push(s2);
          s2 = peg$parseTEXT_INNER();
        }
      } else {
        s1 = peg$FAILED;
      }
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$c0(s1);
      }
      s0 = s1;

      return s0;
    }

    function peg$parseTEXT_INNER() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      s1 = peg$currPos;
      peg$silentFails++;
      s2 = peg$parseBLOCK_START();
      peg$silentFails--;
      if (s2 === peg$FAILED) {
        s1 = void 0;
      } else {
        peg$currPos = s1;
        s1 = peg$FAILED;
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseVALUE_START();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = void 0;
        } else {
          peg$currPos = s2;
          s2 = peg$FAILED;
        }
        if (s2 !== peg$FAILED) {
          if (input.substr(peg$currPos, 2) === peg$c1) {
            s3 = peg$c1;
            peg$currPos += 2;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c2); }
          }
          if (s3 === peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c3) {
              s3 = peg$c3;
              peg$currPos += 2;
            } else {
              s3 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c4); }
            }
            if (s3 === peg$FAILED) {
              if (input.length > peg$currPos) {
                s3 = input.charAt(peg$currPos);
                peg$currPos++;
              } else {
                s3 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c5); }
              }
            }
          }
          if (s3 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c6(s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      return s0;
    }

    function peg$parseVALUE() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      s1 = peg$parseVALUE_START();
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parseVALUE_INNER();
        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$parseVALUE_INNER();
          }
        } else {
          s2 = peg$FAILED;
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parseVALUE_END();
          if (s3 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c7(s2);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      return s0;
    }

    function peg$parseVALUE_START() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 2) === peg$c8) {
        s1 = peg$c8;
        peg$currPos += 2;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c9); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        if (peg$c10.test(input.charAt(peg$currPos))) {
          s3 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c11); }
        }
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = void 0;
        } else {
          peg$currPos = s2;
          s2 = peg$FAILED;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      return s0;
    }

    function peg$parseVALUE_END() {
      var s0;

      if (input.substr(peg$currPos, 2) === peg$c12) {
        s0 = peg$c12;
        peg$currPos += 2;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c13); }
      }

      return s0;
    }

    function peg$parseVALUE_INNER() {
      var s0, s1, s2;

      s0 = peg$currPos;
      s1 = peg$parseOBJECT();
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$c14(s1);
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseFORMAT_SUBSTITUTION();
        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c14(s1);
        }
        s0 = s1;
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$parseEMPTY_OBJECT();
          if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c14(s1);
          }
          s0 = s1;
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$currPos;
            peg$silentFails++;
            s2 = peg$parseVALUE_END();
            peg$silentFails--;
            if (s2 === peg$FAILED) {
              s1 = void 0;
            } else {
              peg$currPos = s1;
              s1 = peg$FAILED;
            }
            if (s1 !== peg$FAILED) {
              if (input.length > peg$currPos) {
                s2 = input.charAt(peg$currPos);
                peg$currPos++;
              } else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c5); }
              }
              if (s2 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c14(s2);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
            if (s0 === peg$FAILED) {
              s0 = peg$currPos;
              if (input.substr(peg$currPos, 2) === peg$c1) {
                s1 = peg$c1;
                peg$currPos += 2;
              } else {
                s1 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c2); }
              }
              if (s1 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c14(s1);
              }
              s0 = s1;
            }
          }
        }
      }

      return s0;
    }

    function peg$parseFORMAT_SUBSTITUTION() {
      var s0, s1, s2, s3, s4;

      s0 = peg$currPos;
      if (peg$c15.test(input.charAt(peg$currPos))) {
        s1 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c16); }
      }
      if (s1 !== peg$FAILED) {
        if (input.charCodeAt(peg$currPos) === 123) {
          s2 = peg$c17;
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c18); }
        }
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$parseFORMAT_SUBSTITUTION_INNER();
          if (s4 !== peg$FAILED) {
            while (s4 !== peg$FAILED) {
              s3.push(s4);
              s4 = peg$parseFORMAT_SUBSTITUTION_INNER();
            }
          } else {
            s3 = peg$FAILED;
          }
          if (s3 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 125) {
              s4 = peg$c19;
              peg$currPos++;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c20); }
            }
            if (s4 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c21(s1, s3);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      return s0;
    }

    function peg$parseFORMAT_SUBSTITUTION_INNER() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      s1 = peg$currPos;
      peg$silentFails++;
      if (input.charCodeAt(peg$currPos) === 123) {
        s2 = peg$c17;
        peg$currPos++;
      } else {
        s2 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c18); }
      }
      peg$silentFails--;
      if (s2 === peg$FAILED) {
        s1 = void 0;
      } else {
        peg$currPos = s1;
        s1 = peg$FAILED;
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        if (input.charCodeAt(peg$currPos) === 125) {
          s3 = peg$c19;
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c20); }
        }
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = void 0;
        } else {
          peg$currPos = s2;
          s2 = peg$FAILED;
        }
        if (s2 !== peg$FAILED) {
          if (input.length > peg$currPos) {
            s3 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c5); }
          }
          if (s3 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c14(s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      return s0;
    }

    function peg$parseCOMMAND() {
      var s0, s1, s2, s3, s4, s5, s6, s7;

      s0 = peg$currPos;
      s1 = peg$parseBLOCK_START();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 !== peg$FAILED) {
          s3 = peg$parseCOMMANDS();
          if (s3 !== peg$FAILED) {
            s4 = peg$parse_();
            if (s4 !== peg$FAILED) {
              s5 = peg$parseBLOCK_END();
              if (s5 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c22(s3);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseBLOCK_START();
        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();
          if (s2 !== peg$FAILED) {
            s3 = peg$parseCOMMANDS();
            if (s3 !== peg$FAILED) {
              s4 = peg$parse_();
              if (s4 !== peg$FAILED) {
                s5 = [];
                s6 = peg$parseCOMMAND_INNER();
                if (s6 !== peg$FAILED) {
                  while (s6 !== peg$FAILED) {
                    s5.push(s6);
                    s6 = peg$parseCOMMAND_INNER();
                  }
                } else {
                  s5 = peg$FAILED;
                }
                if (s5 !== peg$FAILED) {
                  s6 = peg$parse_();
                  if (s6 !== peg$FAILED) {
                    s7 = peg$parseBLOCK_END();
                    if (s7 !== peg$FAILED) {
                      peg$savedPos = s0;
                      s1 = peg$c23(s3, s5);
                      s0 = s1;
                    } else {
                      peg$currPos = s0;
                      s0 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      }

      return s0;
    }

    function peg$parseCOMMAND_INNER() {
      var s0, s1, s2;

      s0 = peg$currPos;
      s1 = peg$parseOBJECT();
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$c24(s1);
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseEMPTY_OBJECT();
        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c24(s1);
        }
        s0 = s1;
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$currPos;
          peg$silentFails++;
          s2 = peg$parseBLOCK_END();
          peg$silentFails--;
          if (s2 === peg$FAILED) {
            s1 = void 0;
          } else {
            peg$currPos = s1;
            s1 = peg$FAILED;
          }
          if (s1 !== peg$FAILED) {
            if (input.length > peg$currPos) {
              s2 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s2 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c5); }
            }
            if (s2 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c24(s2);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        }
      }

      return s0;
    }

    function peg$parseCOMMANDS() {
      var s0, s1;

      if (input.substr(peg$currPos, 4) === peg$c25) {
        s0 = peg$c25;
        peg$currPos += 4;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c26); }
      }
      if (s0 === peg$FAILED) {
        if (input.charCodeAt(peg$currPos) === 61) {
          s0 = peg$c27;
          peg$currPos++;
        } else {
          s0 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c28); }
        }
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 33) {
            s1 = peg$c29;
            peg$currPos++;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c30); }
          }
          if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c31();
          }
          s0 = s1;
        }
      }

      return s0;
    }

    function peg$parseBLOCK() {
      var s0, s1, s2, s3, s4;

      s0 = peg$currPos;
      s1 = peg$parseBLOCK_OPEN();
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parseBLOCK_INNER();
        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$parseBLOCK_INNER();
          }
        } else {
          s2 = peg$FAILED;
        }
        if (s2 === peg$FAILED) {
          s2 = null;
        }
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$parseELSE_BLOCK();
          if (s4 !== peg$FAILED) {
            while (s4 !== peg$FAILED) {
              s3.push(s4);
              s4 = peg$parseELSE_BLOCK();
            }
          } else {
            s3 = peg$FAILED;
          }
          if (s3 === peg$FAILED) {
            s3 = null;
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$parseBLOCK_CLOSE();
            if (s4 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c32(s1, s2, s3, s4);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      return s0;
    }

    function peg$parseBLOCK_START_OPEN_BLOCK() {
      var s0, s1, s2, s3, s4;

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 3) === peg$c33) {
        s1 = peg$c33;
        peg$currPos += 3;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c34); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = [];
        if (peg$c35.test(input.charAt(peg$currPos))) {
          s4 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s4 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c36); }
        }
        if (s4 !== peg$FAILED) {
          while (s4 !== peg$FAILED) {
            s3.push(s4);
            if (peg$c35.test(input.charAt(peg$currPos))) {
              s4 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c36); }
            }
          }
        } else {
          s3 = peg$FAILED;
        }
        peg$silentFails--;
        if (s3 !== peg$FAILED) {
          peg$currPos = s2;
          s2 = void 0;
        } else {
          s2 = peg$FAILED;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      return s0;
    }

    function peg$parseBLOCK_START_CLOSE_BLOCK() {
      var s0, s1, s2, s3, s4;

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 4) === peg$c37) {
        s1 = peg$c37;
        peg$currPos += 4;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c38); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = [];
        if (peg$c35.test(input.charAt(peg$currPos))) {
          s4 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s4 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c36); }
        }
        if (s4 !== peg$FAILED) {
          while (s4 !== peg$FAILED) {
            s3.push(s4);
            if (peg$c35.test(input.charAt(peg$currPos))) {
              s4 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c36); }
            }
          }
        } else {
          s3 = peg$FAILED;
        }
        peg$silentFails--;
        if (s3 !== peg$FAILED) {
          peg$currPos = s2;
          s2 = void 0;
        } else {
          s2 = peg$FAILED;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      return s0;
    }

    function peg$parseBLOCK_START() {
      var s0;

      s0 = peg$parseBLOCK_START_OPEN_BLOCK();
      if (s0 === peg$FAILED) {
        s0 = peg$parseBLOCK_START_CLOSE_BLOCK();
      }

      return s0;
    }

    function peg$parseBLOCK_END() {
      var s0;

      if (input.substr(peg$currPos, 2) === peg$c12) {
        s0 = peg$c12;
        peg$currPos += 2;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c13); }
      }

      return s0;
    }

    function peg$parseBLOCK_OPEN() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

      s0 = peg$currPos;
      s1 = peg$parseBLOCK_START_OPEN_BLOCK();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 !== peg$FAILED) {
          s3 = peg$parseBLOCK_COMMANDS();
          if (s3 !== peg$FAILED) {
            s4 = peg$parse_();
            if (s4 !== peg$FAILED) {
              s5 = [];
              s6 = peg$parseBLOCK_ARGS();
              if (s6 !== peg$FAILED) {
                while (s6 !== peg$FAILED) {
                  s5.push(s6);
                  s6 = peg$parseBLOCK_ARGS();
                }
              } else {
                s5 = peg$FAILED;
              }
              if (s5 === peg$FAILED) {
                s5 = null;
              }
              if (s5 !== peg$FAILED) {
                s6 = peg$parse_();
                if (s6 !== peg$FAILED) {
                  s7 = [];
                  s8 = peg$parseCOMMAND_INNER();
                  if (s8 !== peg$FAILED) {
                    while (s8 !== peg$FAILED) {
                      s7.push(s8);
                      s8 = peg$parseCOMMAND_INNER();
                    }
                  } else {
                    s7 = peg$FAILED;
                  }
                  if (s7 !== peg$FAILED) {
                    s8 = peg$parse_();
                    if (s8 !== peg$FAILED) {
                      s9 = peg$parseBLOCK_END();
                      if (s9 !== peg$FAILED) {
                        peg$savedPos = s0;
                        s1 = peg$c39(s3, s5, s7);
                        s0 = s1;
                      } else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                      }
                    } else {
                      peg$currPos = s0;
                      s0 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      return s0;
    }

    function peg$parseBLOCK_CLOSE() {
      var s0, s1, s2, s3, s4, s5;

      s0 = peg$currPos;
      s1 = peg$parseBLOCK_START_CLOSE_BLOCK();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 !== peg$FAILED) {
          s3 = peg$parseBLOCK_COMMANDS();
          if (s3 !== peg$FAILED) {
            s4 = peg$parse_();
            if (s4 !== peg$FAILED) {
              s5 = peg$parseBLOCK_END();
              if (s5 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c40(s3);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      return s0;
    }

    function peg$parseBLOCK_INNER() {
      var s0, s1;

      s0 = peg$currPos;
      s1 = peg$parseBLOCK();
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$c24(s1);
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseCOMMAND();
        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c24(s1);
        }
        s0 = s1;
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$parseVALUE();
          if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c24(s1);
          }
          s0 = s1;
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$parseTEXT();
            if (s1 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c24(s1);
            }
            s0 = s1;
          }
        }
      }

      return s0;
    }

    function peg$parseBLOCK_COMMANDS() {
      var s0;

      s0 = peg$parseCOMMAND_FOR();
      if (s0 === peg$FAILED) {
        s0 = peg$parseCOMMAND_IF();
        if (s0 === peg$FAILED) {
          s0 = peg$parseCOMMAND_WITH();
          if (s0 === peg$FAILED) {
            s0 = peg$parseCOMMAND_LOG();
          }
        }
      }

      return s0;
    }

    function peg$parseCOMMAND_IF() {
      var s0;

      if (input.substr(peg$currPos, 2) === peg$c41) {
        s0 = peg$c41;
        peg$currPos += 2;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c42); }
      }

      return s0;
    }

    function peg$parseCOMMAND_FOR() {
      var s0;

      if (input.substr(peg$currPos, 3) === peg$c43) {
        s0 = peg$c43;
        peg$currPos += 3;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c44); }
      }

      return s0;
    }

    function peg$parseCOMMAND_WITH() {
      var s0;

      if (input.substr(peg$currPos, 4) === peg$c45) {
        s0 = peg$c45;
        peg$currPos += 4;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c46); }
      }

      return s0;
    }

    function peg$parseCOMMAND_LOG() {
      var s0;

      if (input.substr(peg$currPos, 3) === peg$c47) {
        s0 = peg$c47;
        peg$currPos += 3;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c48); }
      }

      return s0;
    }

    function peg$parseBLOCK_ARGS() {
      var s0, s1, s2, s3, s4;

      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 40) {
        s1 = peg$c49;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c50); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$parseBLOCK_ARGS_INNER();
          if (s4 !== peg$FAILED) {
            while (s4 !== peg$FAILED) {
              s3.push(s4);
              s4 = peg$parseBLOCK_ARGS_INNER();
            }
          } else {
            s3 = peg$FAILED;
          }
          if (s3 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 41) {
              s4 = peg$c51;
              peg$currPos++;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c52); }
            }
            if (s4 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c53(s3);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      return s0;
    }

    function peg$parseBLOCK_ARGS_INNER() {
      var s0, s1, s2;

      s0 = peg$currPos;
      s1 = peg$currPos;
      peg$silentFails++;
      if (input.charCodeAt(peg$currPos) === 41) {
        s2 = peg$c51;
        peg$currPos++;
      } else {
        s2 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c52); }
      }
      peg$silentFails--;
      if (s2 === peg$FAILED) {
        s1 = void 0;
      } else {
        peg$currPos = s1;
        s1 = peg$FAILED;
      }
      if (s1 !== peg$FAILED) {
        if (input.length > peg$currPos) {
          s2 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c5); }
        }
        if (s2 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c54(s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      return s0;
    }

    function peg$parseCOMMAND_ELSE() {
      var s0;

      if (input.substr(peg$currPos, 4) === peg$c55) {
        s0 = peg$c55;
        peg$currPos += 4;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c56); }
      }

      return s0;
    }

    function peg$parseELSE_BLOCK() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      s1 = peg$parseELSE_BLOCK_OPEN();
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parseBLOCK_INNER();
        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$parseBLOCK_INNER();
          }
        } else {
          s2 = peg$FAILED;
        }
        if (s2 === peg$FAILED) {
          s2 = null;
        }
        if (s2 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c57(s1, s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      return s0;
    }

    function peg$parseELSE_BLOCK_OPEN() {
      var s0, s1, s2, s3, s4, s5, s6, s7;

      s0 = peg$currPos;
      s1 = peg$parseBLOCK_START();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 !== peg$FAILED) {
          s3 = peg$parseCOMMAND_ELSE();
          if (s3 !== peg$FAILED) {
            s4 = peg$parse_();
            if (s4 !== peg$FAILED) {
              s5 = peg$parseBLOCK_END();
              if (s5 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c58();
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseBLOCK_START();
        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();
          if (s2 !== peg$FAILED) {
            s3 = peg$parseCOMMAND_ELSE();
            if (s3 !== peg$FAILED) {
              s4 = peg$parse_();
              if (s4 !== peg$FAILED) {
                s5 = [];
                s6 = peg$parseCOMMAND_INNER();
                if (s6 !== peg$FAILED) {
                  while (s6 !== peg$FAILED) {
                    s5.push(s6);
                    s6 = peg$parseCOMMAND_INNER();
                  }
                } else {
                  s5 = peg$FAILED;
                }
                if (s5 !== peg$FAILED) {
                  s6 = peg$parse_();
                  if (s6 !== peg$FAILED) {
                    s7 = peg$parseBLOCK_END();
                    if (s7 !== peg$FAILED) {
                      peg$savedPos = s0;
                      s1 = peg$c59(s5);
                      s0 = s1;
                    } else {
                      peg$currPos = s0;
                      s0 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      }

      return s0;
    }

    function peg$parseELSE_BLOCK_CLOSE() {
      var s0, s1, s2, s3, s4, s5, s6;

      s0 = peg$currPos;
      s1 = peg$parseBLOCK_START();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 47) {
            s3 = peg$c60;
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c61); }
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$parseCOMMAND_IF();
            if (s4 !== peg$FAILED) {
              s5 = peg$parse_();
              if (s5 !== peg$FAILED) {
                s6 = peg$parseBLOCK_END();
                if (s6 !== peg$FAILED) {
                  s1 = [s1, s2, s3, s4, s5, s6];
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      return s0;
    }

    function peg$parseEMPTY_OBJECT() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 2) === peg$c8) {
        s1 = peg$c8;
        peg$currPos += 2;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c9); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 === peg$FAILED) {
          s2 = null;
        }
        if (s2 !== peg$FAILED) {
          if (input.substr(peg$currPos, 2) === peg$c12) {
            s3 = peg$c12;
            peg$currPos += 2;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c13); }
          }
          if (s3 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c62(s2);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      return s0;
    }

    function peg$parseOBJECT() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 2) === peg$c8) {
        s1 = peg$c8;
        peg$currPos += 2;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c9); }
      }
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parseOBJECT_INNER();
        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$parseOBJECT_INNER();
          }
        } else {
          s2 = peg$FAILED;
        }
        if (s2 !== peg$FAILED) {
          if (input.substr(peg$currPos, 2) === peg$c12) {
            s3 = peg$c12;
            peg$currPos += 2;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c13); }
          }
          if (s3 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c63(s2);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }

      return s0;
    }

    function peg$parseOBJECT_INNER() {
      var s0, s1, s2;

      s0 = peg$parseEMPTY_OBJECT();
      if (s0 === peg$FAILED) {
        s0 = [];
        s1 = peg$parseOBJECT();
        if (s1 !== peg$FAILED) {
          while (s1 !== peg$FAILED) {
            s0.push(s1);
            s1 = peg$parseOBJECT();
          }
        } else {
          s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$currPos;
          peg$silentFails++;
          if (input.substr(peg$currPos, 2) === peg$c12) {
            s2 = peg$c12;
            peg$currPos += 2;
          } else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c13); }
          }
          peg$silentFails--;
          if (s2 === peg$FAILED) {
            s1 = void 0;
          } else {
            peg$currPos = s1;
            s1 = peg$FAILED;
          }
          if (s1 !== peg$FAILED) {
            if (input.length > peg$currPos) {
              s2 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s2 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c5); }
            }
            if (s2 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c14(s2);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        }
      }

      return s0;
    }

    function peg$parse_() {
      var s0, s1;

      peg$silentFails++;
      s0 = [];
      s1 = peg$parsewhitespace();
      while (s1 !== peg$FAILED) {
        s0.push(s1);
        s1 = peg$parsewhitespace();
      }
      peg$silentFails--;
      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c64); }
      }

      return s0;
    }

    function peg$parsewhitespace() {
      var s0;

      if (peg$c65.test(input.charAt(peg$currPos))) {
        s0 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c66); }
      }

      return s0;
    }

    peg$result = peg$startRuleFunction();

    if (peg$result !== peg$FAILED && peg$currPos === input.length) {
      return peg$result;
    } else {
      if (peg$result !== peg$FAILED && peg$currPos < input.length) {
        peg$fail({ type: "end", description: "end of input" });
      }

      throw peg$buildException(
        null,
        peg$maxFailExpected,
        peg$maxFailPos < input.length ? input.charAt(peg$maxFailPos) : null,
        peg$maxFailPos < input.length
          ? peg$computeLocation(peg$maxFailPos, peg$maxFailPos + 1)
          : peg$computeLocation(peg$maxFailPos, peg$maxFailPos)
      );
    }
  }

  return {
    SyntaxError: peg$SyntaxError,
    parse:       peg$parse
  };
})();

/* eslint-enable */

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETDOMTypes.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 */

//  ========================================================================
//  TP.dom.Node
//  ========================================================================

/**
 * @summary General purpose Node object. This type provides a convenient
 *     wrapper around native DOM node instances. This allows TIBET methods to be
 *     used effectively on DOM nodes.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('dom.Node');

//  actual node instances returned are specialized on a number of factors
TP.dom.Node.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('construct',
function(nodeSpec, varargs) {

    /**
     * @method construct
     * @summary Constructs a new instance to wrap a native node. The native
     *     node may have been provided or a String could have been provided . By
     *     far the most common usage is construction of a wrapper around an
     *     existing node.
     * @description This method takes two arguments. Depending on the validity
     *     and types of those arguments, various sorts of Node construction can
     *     happen:
     *
     *     Stage 1: Obtain a source node
     *
     *     - If nodeSpec is a TP.dom.Node, it is simply returned and no
     *     further stages are processed.
     *
     *     - If nodeSpec is not valid, an attempt is made to construct a native
     *     node to use as the source object using the receiver's
     *     'constructNativeNode' method. As this type level, that method tries
     *     to use the built-in 'template' object (either a Node, URI or markup
     *     String) to construct a native node.
     *
     *     - If nodeSpec is a native node, it is kept as the source node.
     *
     *     - If nodeSpec is a TP.uri.URI or a String that can be determined to
     *     be a URI, the resource TP.dom.Node of that URI is fetched, cloned
     *     and returned. No further stages are processed.
     *
     *     - If nodeSpec is a String that can be determined to be only markup,
     *     a native node is made from that markup, and that node is recursively
     *     supplied to another call to this method.
     *
     *     - If nodeSpec is a non-markup String that ends with a colon (':'),
     *     then that String is treated as a 'namespace prefix' and an XML
     *     namespace URI is resolved from it. If that namespace has a default
     *     root element name associated with it, a native Element is built using
     *     that name and that element is recursively supplied to another call to
     *     this method.
     *
     *     - If nodeSpec is a non-markup String that can be resolved into a
     *     TIBET type name, then construct is invoked against that type, with
     *     a null as the first parameter and the other parameters supplied to
     *     this method. That type can then decide the best course of action for
     *     making instances of itself.
     *
     *     Stage 2: Process a source node
     *
     *     - If no varargs argument is supplied, then the supplied source node
     *     is wrapped in an instance of this type (i.e. this type's 'init'
     *     method is called) and that value is returned. - If a varargs argument
     *     is supplied and it is either a URI (or URI string) or a String, it
     *     (or its resource) is used as the template for performing a
     *     transformation using the source node as the source object to the
     *     transformation. If a third argument is supplied to this method, it is
     *     supplied to the transformation as a 'transform hash'. - If a varargs
     *     argument is supplied and it is a TP.core.Hash, then the source node
     *     is wrapped in an instance of this type (i.e. this type's 'init'
     *     method is called) and then '.setAttribute()' is called on it for each
     *     item in the TP.core.Hash. That value is then returned.
     *
     *
     * @param {Node|URI|String|TP.dom.Node} nodeSpec Some suitable object to
     *     construct a source node. See type discussion above. Can also be null.
     * @param {arguments} varargs Optional additional arguments for the
     *     constructor.
     * @returns {TP.dom.Node|undefined} A new instance.
     */

    var node,
        newDoc,

        resp,
        template,
        str,
        uri,

        prefix,
        nsURI,
        defaultRootName,

        retVal,
        retType,

        inst,
        args,

        concreteInst;

    //  ---
    //  Node Construction
    //  ---

    if (!TP.isNode(node = nodeSpec)) {
        //  note that this will throw if receiver is abstract or if the node
        //  creation fails
        if (!TP.isNode(node = this.constructNativeNode())) {
            return;
        }
    }

    //  first phase is all about getting a valid native node to wrap either
    //  as input, or by working with the input in some fashion
    if (TP.isNode(node)) {

        //  If we got a real element that is detached and was created in a
        //  document, but not appended to it (as will happen with the
        //  TP.XML_FACTORY_DOCUMENT), then create a document and hang the node
        //  off of it.
        if (TP.isElement(node) &&
            !TP.nodeIsDetached(node) &&
            !TP.nodeContainsNode(node.ownerDocument, node)) {

            newDoc = TP.constructDocument();

            //  Note here how we use a 'low level' append child. That is
            //  because we don't want any 'importNode' or anything to be run
            //  here - we're simply trying to give the node a real document to
            //  be hung off of.
            newDoc.appendChild(node);
        }

        //  We only do this if varargs is either a URI (or URI String) or a
        //  String. If its a TP.core.Hash, it will be processed against a
        //  wrapped version of the node later in this method.
        if (TP.isValid(varargs) &&
            (TP.isURI(varargs) || TP.isString(varargs))) {

            args = varargs;

            if (TP.isURIString(args)) {
                args = TP.uc(args);
            }

            if (TP.isURI(args)) {
                resp = TP.uc(args).getResource(
                            TP.hc('async', false, 'resultType', TP.WRAP));
                template = resp.get('result');

                if (TP.isKindOf(template, 'TP.dom.DocumentNode')) {
                    template.getDocumentElement().removeAttribute('id');
                } else if (TP.isKindOf(template, 'TP.dom.ElementNode')) {
                    template.removeAttribute('id');
                }
            } else if (TP.isString(args)) {
                template = args;
            }

            str = TP.format(node, template, arguments[2]);

            //  NB: Make sure to not pass any other arguments besides the
            //  str in here - otherwise we recurse endlessly.
            retVal = this.construct(str);

            return retVal;
        }
    } else if (TP.isURIString(nodeSpec)) {

        uri = TP.uc(nodeSpec);
        resp = uri.getResource(TP.hc('async', false, 'resultType', TP.WRAP));

        if (!TP.isNode(retVal = resp.get('result'))) {
            return;
        }

        return retVal.clone(true);
    } else if (TP.isURI(nodeSpec)) {

        uri = nodeSpec;
        resp = uri.getResource(TP.hc('async', false, 'resultType', TP.WRAP));

        if (!TP.isNode(retVal = resp.get('result'))) {
            return;
        }

        return retVal.clone(true);
    } else if (TP.isString(nodeSpec)) {
        str = nodeSpec;

        //  If the nodeSpec is some kind of markup String, try to construct
        //  a Node from it
        if (TP.regex.XML_ALL_MARKUP.test(str)) {
            if (!TP.isNode(node = TP.nodeFromString(str))) {
                return;
            }

            retVal = node;
            retType = TP.dom.Node.getConcreteType(node);
        } else {
            str = nodeSpec.trim();

            //  If it ends with a colon (':'), then it might have been a
            //  shorthand with only a namespace prefix. Look up to see if
            //  that prefix corresponds to a namespace URI that has a
            //  'default root element'. If so, join it together with the
            //  xmlns specified and try to construct a node from that.
            if (str.endsWith(':')) {
                prefix = str.slice(0, -1);

                if (TP.isEmpty(nsURI = TP.w3.Xmlns.getNSURIForPrefix(prefix))) {
                    return;
                }

                if (TP.isEmpty(defaultRootName =
                            TP.w3.Xmlns.getRootElementName(nsURI))) {
                    return;
                }

                str = TP.join('<', str, defaultRootName, '/>');

                if (!TP.isElement(node = TP.nodeFromString(str))) {
                    return;
                }

                retVal = node;
            } else if (TP.isType(retType = TP.sys.getTypeByName(str))) {
                //  Set retVal to null, so that when we invoke construct
                //  against the retType (set above), it will be as if it was
                //  actually invoked with no nodeSpec and the machinery
                //  above will take over.
                retVal = null;
            }
        }

        /* eslint-disable consistent-this */
        if (!TP.isType(retType)) {
            retType = this;
        }
        /* eslint-enable consistent-this */

        switch (arguments.length) {
            case 0:
            case 1:
                return retType.construct(retVal);
            case 2:
                return retType.construct(retVal, varargs);
            default:
                args = TP.args(arguments);
                args.atPut(0, retVal);
                return retType.construct.apply(this, args);
        }
    } else if (TP.isKindOf(nodeSpec, 'TP.dom.Node')) {
        //  it's already wrapped, return it
        return nodeSpec;
    } else {
        //  not valid alternatives for node content (yet)
        this.raise('TP.sig.InvalidParameter');

        return;
    }

    //  NOTE that we override construct here to ensure that all node types
    //  will perform the processing necessary to construct viable node
    //  content and register their instances correctly, but abstract types
    //  don't need to do that, they need to move as quickly as possible to
    //  the constructViaSubtype pathway.
    if (this.isAbstract()) {
        concreteInst = this.constructViaSubtype.apply(this, arguments);
    }

    //  ---
    //  Instance Construction
    //  ---

    //  If we're not an abstract type and therefore couldn't have executed
    //  constructViaSubtype above, see if the native node already has a pointer
    //  to a wrapper that was created for it.
    inst = node[TP.WRAPPER];
    if (TP.notValid(concreteInst) && TP.isValid(inst)) {
        return inst;
    }

    args = TP.args(arguments);
    args.atPut(0, node);

    //  If we are an abstract type and therefore executed constructViaSubtype
    //  above and actually got a real concrete instance, then use that as our
    //  instance.
    if (TP.isValid(concreteInst)) {
        inst = concreteInst;
    } else {
        inst = this.callNextMethod.apply(this, args);
    }

    //  If varargs is a TP.core.Hash and inst is an instance of some subtype
    //  of TP.dom.ElementNode, then try to execute '.setAttribute()'
    //  against the new instance for each key in the hash.
    if (TP.isHash(varargs) &&
        TP.isKindOf(inst, 'TP.dom.ElementNode')) {
        varargs.perform(
            function(kvPair) {
                inst.setAttribute(kvPair.first(), kvPair.last());
            });
    }

    //  Go ahead and put a reference to the wrapper onto the native node.
    node[TP.WRAPPER] = inst;

    //  Grab the *actual* type (the computed type above could've been a type
    //  cluster, etc.) and cache it on the node for fast access.
    node[TP.NODE_TYPE] = inst.getType();

    return inst;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('constructNativeNode',
function() {

    /**
     * @method constructNativeNode
     * @summary Returns a node suitable for use as an instance of the receiver.
     * @returns {Node|undefined} A new native node, cloned from the receiver's
     *     template.
     */

    var template,

        uri,
        resp,
        retVal;

    if (this.isAbstract()) {
        this.raise('TP.sig.UnsupportedOperation',
                        'Cannot construct instance of abstract type.');

        return;
    }

    if (TP.notEmpty(template = this.get('template'))) {
        if (TP.isNode(template)) {
            return TP.nodeCloneNode(template, true);
        } else if (TP.isURIString(template)) {

            uri = TP.uc(template);
            resp = uri.getResource(TP.hc('async', false, 'resultType', TP.DOM));

            if (!TP.isNode(retVal = resp.get('result'))) {
                return;
            }

            return TP.nodeCloneNode(retVal, true);
        } else if (TP.isURI(template)) {

            uri = template;
            resp = uri.getResource(TP.hc('async', false, 'resultType', TP.DOM));

            if (!TP.isNode(retVal = resp.get('result'))) {
                return;
            }

            return TP.nodeCloneNode(retVal, true);
        } else if (TP.isString(template)) {
            return TP.elementFromString(template);
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('fromNode',
function(aNode) {

    /**
     * @method fromNode
     * @summary Constructs and returns a new instance initialized using the
     *     node provided.
     * @param {Node} aNode A native node.
     * @returns {TP.dom.Node} The newly constructed TP.dom.Node.
     */

    return this.construct(aNode);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('fromString',
function(aString, defaultNS, shouldReport) {

    /**
     * @method fromString
     * @summary Parses aString and returns a TP.dom.Node wrapper around the
     *     string's root node representation.
     * @param {String} aString The source string to be parsed.
     * @param {String|null} defaultNS What namespace should be used for the
     *     'default namespace' for element markup in the supplied String.
     *     Note that this should be an XML 'namespace URI' (i.e.
     *     'http://www.w3.org/1999/xhtml') *not* a namespace prefix (i.e.
     *     'html:'). To use the 'null' namespace (i.e. xmlns=""), supply
     *     the empty String ('') here. To not specify any default namespace
     *     value and let the parser do what it does natively, supply null here.
     * @param {Boolean} shouldReport False to turn off exception reporting so
     *     strings can be tested for XML compliance without causing exceptions
     *     to be thrown. This is true by default.
     * @exception TP.sig.DOMParseException
     * @returns {TP.dom.Node|undefined} The newly constructed TP.dom.Node.
     */

    var node;

    if (!TP.isDocument(
        node = TP.documentFromString(aString, defaultNS, shouldReport))) {
        return;
    }

    return this.fromNode(node);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('fromTP_dom_Node',
function(aNode) {

    /**
     * @method fromTP_dom_Node
     * @summary Returns the TP.dom.Node wrapper provided.
     * @param {TP.dom.Node} aNode A wrapped node.
     * @returns {TP.dom.Node} The supplied object.
     */

    return aNode;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('fromTP_sig_Signal',
function(aSignal) {

    /**
     * @method fromTP_sig_Signal
     * @summary Constructs and returns a new instance initialized using data in
     *     the signal provided.
     * @param {TP.sig.Signal} aSignal The signal instance to construct a handler
     *     instance for.
     * @returns {TP.dom.Node} The newly constructed TP.dom.Node.
     */

    var inst,
        listener,
        observer;

    listener = aSignal.get('listener');
    if (TP.notValid(listener)) {
        return this.callNextMethod();
    }

    observer = TP.elementGetAttribute(listener, 'observer');
    if (TP.notValid(observer)) {
        return this.callNextMethod();
    }

    //  this should go off to TIBET and try to find a proper node type based
    //  on the tag name information
    inst = TP.bySystemId(observer);

    return inst;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('fromTP_uri_URI',
function(aURI, shouldReport) {

    /**
     * @method fromTP_uri_URI
     * @summary Returns a new instance of the receiver, constructed around the
     *     DOM content of the URI provided. Note that the URI must point to XML
     *     data for this call to succeed.
     * @param {TP.uri.URI} aURI A URI referencing XML content.
     * @param {Boolean} shouldReport False to turn off exception reporting so
     *     strings can be tested for XML compliance without causing exceptions
     *     to be thrown. This is true by default.
     * @exception TP.sig.DOMParseException
     * @returns {TP.dom.Node|undefined} The newly constructed TP.dom.Node.
     */

    var resp,
        content;

    if (TP.notValid(aURI)) {
        return this.raise('TP.sig.InvalidURI');
    }

    //  this will return a TP.dom.Node if at all possible
    resp = aURI.getResource(
                TP.hc('async', false, 'resultType', TP.DOM));
    content = TP.wrap(resp.get('result'));

    if (TP.isKindOf(content, TP.dom.Node)) {
        return content;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('getCanonicalPrefix',
function(aNode) {

    /**
     * @method getCanonicalPrefix
     * @summary Returns the canonical prefix for the namepaceURI of the node.
     *     If the node does not show itself as having a namespaceURI then the
     *     prefix returned is the empty string.
     * @param {Node|TP.dom.Node} aNode The node whose canonical prefix should
     *     be returned.
     * @returns {String} The canonical prefix, if found.
     */

    var node,
        ns,
        prefix;

    //  In case aNode was a TP.dom.Node.
    node = TP.unwrap(aNode);

    if (TP.isDocument(node)) {
        if (!TP.isDocument(node.documentElement)) {
            return '';
        }

        node = node.documentElement;
    }

    if (TP.notEmpty(ns = TP.nodeGetNSURI(node))) {
        prefix = TP.w3.Xmlns.getCanonicalPrefix(ns);
    }

    return TP.ifEmpty(prefix, '');
});

//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('getConcreteType',
function(aNode) {

    /**
     * @method getConcreteType
     * @summary Returns the subtype to use for the node provided.
     * @param {Node} aNode The native node to wrap.
     * @exception TP.sig.InvalidNode
     * @returns {TP.meta.dom.Node} A TP.dom.Node subtype type object.
     */

    if (!TP.isNode(aNode)) {
        return this.raise('TP.sig.InvalidNode',
                            'No node provided.');
    }

    switch (aNode.nodeType) {
        case Node.ELEMENT_NODE:

            return TP.dom.ElementNode.getConcreteType(aNode);

        case Node.DOCUMENT_NODE:

            return TP.dom.DocumentNode.getConcreteType(aNode);

        case Node.DOCUMENT_FRAGMENT_NODE:

            return TP.dom.DocumentFragmentNode;

        case Node.ATTRIBUTE_NODE:

            return TP.dom.AttributeNode.getConcreteType(aNode);

        case Node.TEXT_NODE:

            return TP.dom.TextNode;

        case Node.CDATA_SECTION_NODE:

            return TP.dom.CDATASectionNode;

        case Node.PROCESSING_INSTRUCTION_NODE:

            return TP.dom.ProcessingInstructionNode.getConcreteType(aNode);

        case Node.ENTITY_REFERENCE_NODE:

            return TP.dom.EntityReferenceNode;

        case Node.ENTITY_NODE:

            return TP.dom.EntityNode;

        case Node.COMMENT_NODE:

            return TP.dom.CommentNode;

        case Node.DOCUMENT_TYPE_NODE:

            return TP.dom.DocumentTypeNode;

        case Node.NOTATION_NODE:

            return TP.dom.NotationNode;

        default:
            return this.raise('TP.sig.InvalidNode',
                                'Unable to determine node type.');
    }
});

//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('getContentLanguage',
function(aNode) {

    /**
     * @method getContentLanguage
     * @summary Returns the node's xml:lang value, or the current default
     *     language if no xml:lang specification is found in the node's parent
     *     chain.
     * @param {Node|TP.dom.Node} aNode The node whose content language should
     *     be returned.
     * @returns {String} The node's content language.
     */

    var node,
        lang;

    //  In case aNode was a TP.dom.Node.
    node = TP.unwrap(aNode);

    if (TP.isDocument(node)) {
        if (!TP.isDocument(node.documentElement)) {
            return '';
        }

        node = node.documentElement;
    }

    //  iterate upward until we run out of elements to test
    while (TP.isElement(node)) {
        if (TP.notEmpty(lang = TP.elementGetAttribute(node,
                                                        'xml:lang',
                                                        true))) {
            break;
        }

        node = node.parentNode;
    }

    return TP.ifEmpty(lang, TP.sys.env('tibet.xmllang', 'en-us')).
                                                            toLowerCase();
});

//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('getContentMIMEType',
function(aNode) {

    /**
     * @method getContentMIMEType
     * @summary Returns the node's "content MIME type", the MIME type the node
     *     can render most effectively. This information is drawn from the
     *     namespaceURI of the node in most cases. The mappings between
     *     namespace URIs and MIME types are found in the XMLNS 'info' hash.
     * @param {Node|TP.dom.Node} aNode The node whose content mime type should
     *     be returned.
     * @returns {String} The node's content MIME type.
     */

    var node,
        ns,
        mime;

    //  In case aNode was a TP.dom.Node.
    node = TP.unwrap(aNode);

    //  this works off URI and root element information to try to give us a
    //  best guess
    if (TP.isDocument(node)) {
        return TP.dom.Node.getDocumentMIMEType(node);
    }

    //  if not a document we can still try to use the XMLNS data
    if (TP.notEmpty(ns = TP.nodeGetNSURI(node))) {
        mime = TP.w3.Xmlns.getMIMEType(ns);
    }

    //  TODO:   do we want pure XML here?
    return TP.ifEmpty(mime, TP.ietf.mime.XHTML);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('getDocumentMIMEType',
function(aNode) {

    /**
     * @method getDocumentMIMEType
     * @summary Returns the MIME type of the document containing the node
     *     provided. This method is used to help determine which subtype of
     *     TP.dom.DocumentNode to use when creating new document wrappers but
     *     can be useful in other contexts as well.
     * @param {Node} aNode The node whose document mime type should be returned.
     * @exception TP.sig.InvalidDocument
     * @returns {String} The MIME type to be used as a render type for this tag.
     */

    var node,

        doc,
        docElement,

        ns,
        info,
        mimeType,
        nodeName;

    //  In case aNode was a TP.dom.Node.
    node = TP.unwrap(aNode);

    doc = TP.nodeGetDocument(node);
    if (!TP.isDocument(doc)) {
        return this.raise('TP.sig.InvalidDocument',
                            'Unable to determine node\'s document.');
    }

    //  empty document? either TP.ietf.mime.PLAIN or TP.ietf.mime.XML
    if (!TP.isElement(docElement = doc.documentElement)) {
        if (TP.isXMLDocument(doc)) {
            return TP.ietf.mime.XML;
        } else {
            return TP.ietf.mime.PLAIN;
        }
    }

    if (!TP.isXMLDocument(doc)) {
        //  TODO:   handle META instructions and/or DOCTYPES here
        if (docElement.nodeName.toLowerCase() === 'html') {
            return TP.ietf.mime.HTML;
        } else {
            return TP.ietf.mime.PLAIN;
        }
    }

    //  most accurate is to work from the namespaceURI if found/registered
    if (TP.notEmpty(ns = TP.nodeGetNSURI(docElement))) {
        if (TP.isValid(info = TP.w3.Xmlns.get('info').at(ns))) {
            mimeType = info.at('mimetype');
        }
    } else {
        //  second chance is that we find a canonical root element name
        nodeName = TP.elementGetLocalName(docElement);
        info = TP.w3.Xmlns.get('info').detect(
                function(item) {

                    return item.last().at('rootElement') === nodeName;
                });

        if (TP.isValid(info)) {
            mimeType = info.last().at('mimetype');
        }
    }

    return TP.ifInvalid(mimeType, TP.ietf.mime.XML);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('getNSURI',
function() {

    /**
     * @method getNSURI
     * @summary Returns the namespaceURI of the receiver. This is computed from
     *     the receiver's prefix, so the prefix and namespace *must* be
     *     registered in TIBET's central registry.
     * @returns {String} A namespace URI or the empty string.
     */

    return TP.w3.Xmlns.getNSURIForPrefix(this.get('nsPrefix'));
});

//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('getQueryPath',
function() {

    /**
     * @method getQueryPath
     * @summary Returns the 'query path' that can be used in calls such as
     *     'nodeEvaluatePath' to obtain all of the occurrences of the receiver
     *     in a document.
     * @returns {String} The path that can be used to query for Nodes of this
     *     type.
     */

    //  At this level, we return the empty String.
    return '';
});

//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('generatedNode',
function(aNode) {

    /**
     * @method generatedNode
     * @summary Returns whether or not the receiver generated the supplied Node.
     * @param {Node} aNode The node to check for a generator.
     * @returns {Boolean} True when the receiver is the generator for the
     *     supplied Node.
     */

    var generatorName,
        generatorType;

    generatorName = aNode[TP.GENERATOR];
    if (TP.isEmpty(generatorName)) {
        return false;
    }

    generatorType = TP.sys.getTypeByName(generatorName);
    if (!TP.isType(generatorType)) {
        return false;
    }

    return generatorType === this;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('isResponderFor',
function(aNode, aSignal) {

    /**
     * @method isResponderFor
     * @summary Returns true if the type in question should be considered a
     *     responder for the specific node/signal pair provided.
     * @param {Node} aNode The node to check which may have further data as to
     *     whether this type should be considered to be a responder.
     * @param {TP.sig.Signal} aSignal The signal that responders are being
     *     computed for.
     * @returns {Boolean} True when the receiver should respond to aSignal.
     */

    var signames,

        fname,
        len,
        i,

        desc,
        tpNode;

    if (TP.isValid(aSignal)) {
        signames = aSignal.getSignalNames();
    } else {
        signames = TP.ac('Signal');
    }

    //  Convert all the signal names to simple form (making sure they're
    //  canonical).
    signames = signames.map(
                function(name) {
                    //  Expand first to make sure signal name is prefixed, if
                    //  necessary, but then contract that. This gives canonical
                    //  results.
                    return TP.contractSignalName(TP.expandSignalName(name));
                });

    //  Iterate over all of the signal names and check to see if they respond to
    //  a type method of 'isResponderFor' + the signal name.
    len = signames.getSize();
    for (i = 0; i < len; i++) {
        fname = 'isResponderFor' + signames.at(i);
        if (TP.canInvoke(this, fname)) {
            return this[fname](aNode, aSignal);
        }
    }

    //  If we couldn't find an 'isResponderFor' method, see if the target node
    //  has an instance handler method. If it does, then consider ourself to be
    //  a responder for that signal.

    if (TP.isValid(aSignal)) {
        desc = {
            signal: aSignal,
            //  TODO: determine why we thought this was a good idea. It's
            //  commented out because it means many on: scenarios will fail.
            // dontTraverseSpoofs: true,   //  We're not interested in spoofs
            phase: '*'                  //  We want handler methods of any phase
                                        //  since all we're doing is returning a
                                        //  Boolean.
        };

        tpNode = TP.wrap(aNode);

        if (TP.isCallable(tpNode.getBestHandler(aSignal, desc))) {
            return true;
        }
    }

    return false;
});

//  ------------------------------------------------------------------------
//  Tag Phase Support
//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('populateSubstitutionInfo',
function(aRequest) {

    /**
     * @method populateSubstitutionInfo
     * @summary Populates a hash of substitution information.
     * @description This method populates the following variables into a hash
     *     that it returns, useful for executing substitutions.
     *
     *          TP          ->  The TP root.
     *          APP         ->  The APP root.
     *          $REQUEST    ->  The request that triggered this processing.
     *          $TAG        ->  The TP.dom.ElementNode that contains this text
     *                          node.
     *          $TARGET     ->  The target TP.dom.DocumentNode, if any, that
     *                          the result of this processing will be rendered
     *                          into.
     *          $SOURCE     ->  The original source tag, if this is being
     *                          processed as part of a nested template.
     *          $SELECTION  ->  The current selection. This could be text or an
     *                          Array of objects determined by the selection
     *                          manager.
     *          $*          ->  An alias for $SELECTION
     *          $FOCUS      ->  The currently focused TP.dom.ElementNode in the
     *                          target TP.dom.DocumentNode.
     *          $@          ->  An alias for $FOCUS
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     * @returns {TP.core.Hash|undefined} The hash containing the substitution
     *     info as detailed in the description.
     */

    var node,
        parentNode,

        selectionFunc,
        focusFunc,

        sources,
        source,

        info;

    //  Make sure that we have a node to work from.
    if (!TP.isNode(node = aRequest.at('node'))) {
        return;
    }

    if (TP.isAttributeNode(node)) {
        parentNode = TP.attributeGetOwnerElement(node);
    } else {
        parentNode = node.parentNode;
    }

    selectionFunc = function() {

        var targetTPDoc;

        if (TP.isValid(targetTPDoc = aRequest.at('target'))) {
            return TP.wrap(
                    TP.documentGetSelectionText(
                        TP.unwrap(targetTPDoc)));
        }
    };

    focusFunc = function() {

        var targetTPDoc;

        if (TP.isValid(targetTPDoc = aRequest.at('target'))) {
            return TP.wrap(
                    TP.documentGetFocusedElement(
                        TP.unwrap(targetTPDoc)));
        }
    };

    if (TP.notEmpty(sources = aRequest.at('sources'))) {
        source = sources.last();
    }

    info = TP.hc(
        '$REQUEST', aRequest,
        'TP', TP,
        'APP', APP,
        '$TAG', TP.wrap(parentNode),
        '$TARGET', aRequest.at('target'),
        '$SOURCE', TP.wrap(source),
        '$SELECTION', selectionFunc,
        '$*', selectionFunc,            //  Alias for $SELECTION
        '$FOCUS', focusFunc,
        '$@', focusFunc                 //  Alias for $FOCUS
        );

    return info;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('shouldWrapACPOutput',
function() {

    /**
     * @method shouldWrapACPOutput
     * @summary Whether or not we should wrap ACP expression output in an XHTML
     *     span element. The default is true, but some subtypes that allow ACP
     *     in their embedded templates might choose to not generate these
     *     wrapper spans.
     * @returns {Boolean} Whether or not to wrap it.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('tagPrecompile',
function(aRequest) {

    /**
     * @method tagPrecompile
     * @summary Precompiles the content by running any substitution expressions
     *     in it.
     * @description At this level, this method runs substitutions against the
     *     text content of the node (and the text content of any attributes) and
     *     supplies the following variables to the substitutions expressions:
     *
     *          TP         ->  The TP root.
     *          APP        ->  The APP root.
     *          $REQUEST    ->  The request that triggered this processing.
     *          $TAG        ->  The TP.dom.ElementNode that is being processed.
     *          $TARGET     ->  The target TP.dom.DocumentNode, if any, that
     *                          the result of this processing will be rendered
     *                          into.
     *          $SOURCE     ->  The original source tag, if this is being
     *                          processed as part of a nested template.
     *          $SELECTION  ->  The current selection. This could be text or an
     *                          Array of objects determined by the selection
     *                          manager.
     *          $*          ->  An alias for $SELECTION
     *          $FOCUS      ->  The currently focused TP.dom.ElementNode in the
     *                          target TP.dom.DocumentNode.
     *          $@          ->  An alias for $FOCUS
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var node,
        tpNode,

        info,

        str,

        result,
        elem,
        frag,

        attrs,
        len,
        j;

    //  Make sure that we have a node to work from.
    if (!TP.isNode(node = aRequest.at('node'))) {
        return;
    }

    //  Wrap it so that when we ask for its text content, we're getting the best
    //  representation.
    tpNode = TP.wrap(node);

    //  Populate the substitution information with various variables, etc.
    info = this.populateSubstitutionInfo(aRequest);

    //  The $TAG will have been set to our parent node (the default behavior of
    //  the call above), so we need to set it to the wrapper currently
    //  processing node.
    info.atPut('$TAG', tpNode);

    info.atPut('shouldEcho', false);
    info.atPut('annotateMarkup', this.shouldWrapACPOutput());

    //  Make sure that any required data (i.e. 'id' attributes and others) are
    //  defined. id attributes, in particular, because they can be dynamically
    //  assigned by TIBET, are assumed to 'always exist'. This insures that they
    //  do for use in ACP template processing. Note that we always use the outer
    //  content here, since there may be attributes that we need to detect.
    tpNode.prepopulateRequiredTemplateData(info, tpNode.getOuterContent());

    //  Process the attributes. This method should resolve any ACP expressions
    //  in the attributes themselves.
    attrs = TP.elementGetAttributeNodes(node);
    len = attrs.getSize();
    for (j = 0; j < len; j++) {
        tpNode.transformAttributeNode(attrs.at(j), info);
    }

    //  Grab the best representation text. This may contain ACP templating
    //  expressions.
    str = tpNode.getContent();

    if (TP.regex.HAS_ACP.test(str)) {
        //  Run a transform on it.
        result = str.transform(tpNode, info);

        //  Only do this if the result came out differently than the source
        //  string.
        if (result !== str) {

            //  If the result contains 'element' markup (and does *not* contain
            //  more ACP expressions), then try to create a Fragment from it and
            //  use that to replace the node.
            if (!TP.regex.HAS_ACP.test(result) &&
                TP.regex.CONTAINS_ELEM_MARKUP.test(result)) {

                elem = TP.elem('<root>' + result + '</root>',
                                TP.w3.Xmlns.XHTML,
                                false);

                //  Note that we convert into a DocumentFragment here since the
                //  transformed String may contain multiple peer nodes
                //  (although we were able to parse it due to wrapping it into
                //  Element markup above -- but that's not the 'real' markup).
                frag = TP.nodeListAsFragment(elem.childNodes);

                //  This will check for either Elements or DocumentFragments
                //  (and Documents, too, which is invalid here but highly
                //  unlikely).
                if (TP.isCollectionNode(frag)) {
                    TP.elementSetContent(node, frag, null, false);
                }
            } else if (TP.notEmpty(result)) {
                //  Otherwise, it was just a straight templated value (or it
                //  contained further ACP templating expressions) - just set the
                //  original node's text content.
                tpNode.setTextContent(result);
            }
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('tagDetachDOM',
function(aRequest) {

    /**
     * @method tagDetachDOM
     * @summary Performs any 'detach' logic when the node is detached from its
     *     owning document.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var node,
        id,

        uri;

    //  Make sure that we have a node to work from.
    if (!TP.isNode(node = aRequest.at('node'))) {
        return;
    }

    //  Note that we force false here because we don't want to assign ids for
    //  nodes that are going away, either because they're permanently removed or
    //  because they're becoming part of a template.
    id = TP.gid(node, false);

    if (TP.isURI(uri = TP.uri.URI.getInstanceById(id))) {
        uri.clearCaches();
        TP.uri.URI.removeInstance(uri);
    }

    //  Setting these to null is better for many VMs than using 'delete'.
    node[TP.WRAPPER] = null;
    node[TP.NODE_TYPE] = null;

    return;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  should the receiver flag changes, i.e. mark elements with 'crud'
//  metadata in addition to or in lieu of actually altering markup
TP.dom.Node.Inst.defineAttribute('changeFlagging', false);

//  whether the node has been 'dirtied' or altered since loading
TP.dom.Node.Inst.defineAttribute('dirty', false);

//  the wrapped node when only one node is being managed
TP.dom.Node.Inst.defineAttribute('node');

//  flag for whether this instance can be reused. typically yes.
TP.dom.Node.Inst.defineAttribute('recyclable', true);

//  what phase is the node at in terms of content processing? we start at
//  'UNPROCESSED' for new nodes
TP.dom.Node.Inst.defineAttribute('phase', 'UNPROCESSED');

//  when loaded via a TP.uri.URI this will hold the URI's 'uri' string as a
//  backlink the node can use to get to the original URI instance.
TP.dom.Node.Inst.defineAttribute('uri');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('init',
function(aNode, aURI) {

    /**
     * @method init
     * @summary Returns a newly initialized instance.
     * @param {Node} aNode A native node.
     * @param {TP.uri.URI|String} aURI An optional URI from which the Node
     *     received its content.
     * @returns {TP.dom.Node} The initialized instance.
     */

    this.callNextMethod();

    if (TP.isNode(aNode)) {
        this.$set('node', aNode, false);
    } else {
        return this.raise('TP.sig.InvalidParameter');
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('addContent',
function(aContentObject, aRequest) {

    /**
     * @method addContent
     * @summary Adds the value supplied to the content of the receiver's native
     *     DOM counterpart.
     * @description At this level, this method merely sets adds to the text
     *     content of the node what is produced by executing the
     *     'produceContent' on the supplied content object. Subtypes should
     *     override this method to provide a more specific version of this.
     * @param {Object} aContentObject An object to use for content.
     * @param {TP.sig.Request} aRequest A request containing control parameters.
     * @returns {TP.dom.Node} The receiver.
     */

    var content;

    content = this.getContent();

    content += TP.str(this.produceContent(aContentObject, aRequest));

    this.setTextContent(content);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns a "dump string", which is typically what is used by the
     *     TIBET logs when writing out an object.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A String suitable for log output.
     */

    var nativeNode;

    nativeNode = this.getNativeNode();

    return '[' + TP.tname(this) + ' (' + TP.tname(nativeNode) + ')' +
                    ' :: ' + this.asString() + ']';
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('asHTMLNode',
function(aDocument) {

    /**
     * @method asHTMLNode
     * @summary Returns an HTML node built from the receiver's content. This
     *     may involve rebuilding the node in an HTML document provided for the
     *     purpose of the conversion. The result node will have non-compatible
     *     constructs removed.
     * @param {HTMLDocument} aDocument An HTML Document to use as the owner
     *     document.
     * @returns {Node} An HTML node.
     */

    var doc;

    doc = TP.isHTMLDocument(aDocument) ?
                    aDocument : this.getNativeDocument();

    return TP.nodeAsHTMLNode(this.getNativeNode(), doc);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Returns an HTML string built from the receiver. The result will
     *     have any non-compatible constructs removed.
     * @returns {String} An HTML string.
     */

    return TP.nodeAsHTMLString(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    var marker,
        str;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asJSONSource';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    try {
        str = '{"type":' + TP.tname(this).quoted('"') + ',' +
                '"data":' + TP.jsonsrc(this.getNativeNode()) + '}';
    } catch (e) {
        str = this.toString();
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('asObject',
function() {

    /**
     * @method asObject
     * @summary Returns a 'plain JavaScript object' version of the receiver.
     *     This uses the JXON standard to convert the receiver's DOM structure
     *     to one or more JavaScript objects.
     * @returns {Object|undefined} The receiver as a plain JavaScript object.
     */

    if (TP.isPrototype(this)) {
        return;
    }

    return TP.xml2js(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} A new String containing the 'pretty print' string of
     *     the receiver.
     */

    var nativeNode;

    nativeNode = this.getNativeNode();

    return '<dl class="pretty ' + TP.escapeTypeName(TP.tname(this)) + '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' +
                        TP.tname(nativeNode) +
                    '</dd>' +
                    '<dt class="pretty key">Content</dt>' +
                    '<dd class="pretty value">' +
                        TP.pretty(nativeNode) +
                    '</dd>' +
                    '</dl>';
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a TIBET source code string.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    return 'TP.tpnode(\'' + this.asString() + '\')';
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns a basic string representation of the receiver. For
     *     TP.dom.Nodes this is the serialized string representation of the
     *     native node content.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the TP.dom.Node's String representation. The verbose
     *     representation will contain an XML declaration (if the receiver is
     *     an XML document). Both verbose and non-verbose representations will
     *     also contain all of the child content. The default is true.
     * @returns {String} The receiver as a String.
     */

    var nativeNode,
        wantsVerbose,
        str;

    nativeNode = this.getNativeNode();

    wantsVerbose = TP.ifInvalid(verbose, true);
    if (!wantsVerbose) {
        //  NB: The defaults here are 'false' and 'false' to not product an XML
        //  declaration and to not be 'shallow' (include all of the child
        //  content).
        return TP.nodeAsString(nativeNode);
    }

    try {

        if (TP.isDocument(nativeNode)) {
            //  NB: The parameters to TP.nodeAsString() here tell it to produce
            //  an XML declaration and to not be 'shallow' (i.e. produce all
            //  child content).
            str = TP.nodeAsString(nativeNode, true, false);
        } else {
            //  NB: The parameters to TP.nodeAsString() here tell it to not
            //  produce an XML declaration and to not be 'shallow' (i.e.
            //  produce all child content).
            str = TP.nodeAsString(nativeNode, false, false);
        }

    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('asXHTMLNode',
function() {

    /**
     * @method asXHTMLNode
     * @summary Returns an XHTML node built from the receiver.
     * @description The emphasis here on XHTML, implying that the return value
     *     is an XML node, not an HTML node. Also note that since it's XML the
     *     resulting node may have content in other namespaces. Use
     *     TP.nodePurifyXMLNS() to remove all non-XHTML content, or
     *     TP.nodeRemoveXMLNS() to remove single namespace content.
     * @returns {Node} An XML node containing XHTML content.
     */

    //  We assume that we're (at least partially) an XHTML node.
    return this.getNativeNode();
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('asXHTMLString',
function() {

    /**
     * @method asXHTMLString
     * @summary Returns an XHTML string built from the receiver.
     * @returns {String} A properly formed XHTML string.
     */

    //  We assume that we're (at least partially) an XHTML node.
    return this.asString();
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('asXMLNode',
function(aDocument) {

    /**
     * @method asXMLNode
     * @summary Returns an XML node built from the receiver if possible.
     * @param {XMLDocument} aDocument An XML Document to use as the owner
     *     document.
     * @returns {Node} An XML node.
     */

    var doc;

    doc = TP.isXMLDocument(aDocument) ?
                aDocument : this.getNativeDocument();

    return TP.nodeAsXMLNode(this.getNativeNode(), doc);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver.
     * @returns {String} The receiver in XML string format.
     */

    var marker,
        str;

    //  Trap recursion around potentially nested object structures.
    marker = '$$recursive_asXMLString';
    if (TP.owns(this, marker)) {
        return TP.recursion(this, marker);
    }
    this[marker] = true;

    try {
        str = '<instance type="' + TP.tname(this) + '">' +
                    TP.xmlstr(this.getNativeNode()) +
                    '</instance>';
    } catch (e) {
        str = this.toString();
    } finally {
        delete this[marker];
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('detach',
function() {

    /**
     * @method detach
     * @summary Removes the receiver from its parent.
     * @returns {TP.dom.Node} The detached node.
     */

    var node;

    node = this.getNativeNode();

    return TP.wrap(TP.nodeDetach(node));
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('copy',
function(deep, aFilterNameOrKeys, contentOnly) {

    /**
     * @method copy
     * @summary Returns a 'copy' of the receiver. Actually, a new instance
     *     whose value is equalTo that of the receiver.
     * @param {Boolean} [deep=false] True to force clones to be deep.
     * @param {String|String[]} [aFilterNameOrKeys] get*Interface() filter or
     *     key array.
     * @param {Boolean} [contentOnly=true] Copy content only? This parameter is
     *     ignored for this type.
     * @returns {TP.dom.Node} A copy of the receiver.
     */

    var natNode,
        newNatNode,

        newinst,

        onlyContent,

        filter,
        keys,

        len,
        i,
        ndx,
        val;

    natNode = this.getNativeNode();

    newNatNode = TP.nodeCloneNode(natNode, deep);

    newinst = this.getType().fromNode(newNatNode);

    onlyContent = TP.ifInvalid(contentOnly, true);
    if (onlyContent) {
        //  content only
        return newinst;
    } else {
        filter = TP.ifInvalid(aFilterNameOrKeys, TP.UNIQUE);

        if (TP.isString(filter)) {
            keys = this.getLocalInterface(filter);
        } else if (TP.isArray(filter)) {
            keys = filter;
        } else {
            //  Unusable filter
            return newinst;
        }

        len = keys.getSize();

        for (i = 0; i < len; i++) {
            ndx = keys.at(i);
            val = this.at(ndx);

            if (TP.isTrue(deep) && TP.isReferenceType(val)) {
                //  NB: We do *not* pass along the filter name or keys here
                val = TP.copy(val, deep, null, contentOnly);
            }

            newinst.$set(ndx, val, false, true);
        }
    }

    return newinst;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('equalTo',
function(aNode) {

    /**
     * @method equalTo
     * @summary Returns whether the supplied node is 'equal to' the receiver.
     * @description This method follows the DOM Level 3 standard for
     *     checking Nodes for equality with each other. This specification
     *     states that two Nodes are equal if:
     *          -   The two nodes are of the same type
     *          -   The following string attributes are equal (they are either
     *              both null or they have the same length and are character for
     *              character identical):
     *                  -   nodeName
     *                  -   localName
     *                  -   namespaceURI
     *                  -   prefix
     *                  -   nodeValue
     *          -   The 'attributes' NamedNodeMaps are equal (they are either
     *              both null or have the same length and for each node that
     *              exists in one map there is a node that exists in the other
     *              map and is equal although *not necessarily at the same
     *              index*).
     *          -   The 'childNodes' NodeLists are equal (they are either both
     *              null or have the same length and contain equal nodes *at the
     *              same index*). Note that this method normalizes these nodes
     *              to make sure that this comparison is performed accurately.
     * @param {TP.dom.Node|Node} aNode The TP.dom.Node or Node to use in the
     *     comparison.
     * @exception TP.sig.InvalidNode
     * @returns {Boolean} Whether or not the supplied node is equal to the
     *     receiver.
     */

    var otherNode;

    otherNode = TP.unwrap(aNode);
    if (!TP.isNode(otherNode)) {
        return false;
    }

    return TP.nodeEqualsNode(this.getNativeNode(), otherNode);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getAccessPathFor',
function(attributeName, facetName, originalPath) {

    /**
     * @method getAccessPathFor
     * @summary Returns any access path facet value, if any, for the attribute
     *     and facet provided. See the 'TP.sys.addMetadata()' call for more
     *     information about facets.
     * @param {String} attributeName The name of the attribute to get the access
     *     path facet value for.
     * @param {String} facetName The name of the facet to get the access path
     *     facet value for.
     * @param {TP.core.AccessPath} [originalPath] An optional access path that
     *     the attribute name might have been derived from. Sometimes it is
     *     useful to have access to the original path.
     * @returns {Object} Any access path value of the supplied facet of the
     *     supplied attribute. If there is no access path, this method returns
     *     null.
     */

    //  If we're trying to get or set the 'value', we always return the original
    //  path so that the get/set machinery will use this path instead of trying
    //  to use a custom getter/setter (which will return different results than
    //  what we desire for this slot).
    if (attributeName === 'value') {
        return originalPath;
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getAncestorPositions',
function(includeNode, aPrefix, joinChar) {

    /**
     * @method getAncestorPositions
     * @summary Returns an array of position strings for the receiver's
     *     ancestors. If the includeNode flag is true then the list starts with
     *     the receiver's position, otherwise the first entry represents the
     *     receiver's parentNode position.
     * @param {Boolean} includeNode True to include the receiver's position in
     *     the list. Default is false.
     * @param {String} aPrefix An optional prefix, usually a document location
     *     which allows the positions to be canvas and document specific for
     *     observations.
     * @param {String} joinChar A character to use when joining the index parts.
     *     Default is '.'.
     * @returns {String[]} An array of position strings.
     */

    return TP.nodeGetAncestorPositions(this.getNativeNode(),
                                        aPrefix,
                                        joinChar);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getCanonicalPrefix',
function() {

    /**
     * @method getCanonicalPrefix
     * @summary Returns the canonical prefix for the namepaceURI of the
     *     receiver. If the receiver does not show itself as having a
     *     namespaceURI then the prefix returned is the empty string.
     * @returns {String} The prefix, if found.
     */

    return TP.dom.Node.getCanonicalPrefix(this);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getCanvasID',
function() {

    /**
     * @method getCanvasID
     * @summary Returns the receiver's canvas ID, the ID of the canvas in which
     *     it resides. This is typically synonymous with the ID of the
     *     receiver's window or frame. When no canvas ID can be found this
     *     method returns the empty string.
     * @returns {String} The canvas ID, if found, or the empty string.
     */

    var win;

    win = this.getWindow();
    if (TP.isValid(win)) {
        return win.getCanvasID();
    }

    return '';
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getContent',
function(aRequest) {

    /**
     * @method getContent
     * @summary Returns the receiver's content.
     * @description At this level, this method merely returns the text content
     *     of its native node. Subtypes should override this method to provide a
     *     more specific version of this.
     * @param {TP.sig.Request|TP.core.Hash} aRequest Optional control
     *     parameters.
     * @returns {String} The text content of the native node.
     */

    return this.getTextContent();
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getContentNode',
function(aRequest) {

    /**
     * @method getContentNode
     * @summary Returns the receiver. This method is provided for API
     *     compatibility with other types.
     * @param {TP.sig.Request|TP.core.Hash} aRequest Optional control
     *     parameters.
     * @returns {TP.dom.Node} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getContentText',
function(aRequest) {

    /**
     * @method getContentText
     * @summary Returns the receiver's content in text form. This method is
     *     provided for API compatibility with other types.
     * @param {TP.sig.Request|TP.core.Hash} aRequest Optional control
     *     parameters.
     * @returns {String} The receiver's content as a String.
     */

    return this.getTextContent();
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getContentLanguage',
function() {

    /**
     * @method getContentLanguage
     * @summary Returns the receiver's xml:lang value, or the current default
     *     language if no xml:lang specification is found in the receiver's
     *     parent chain.
     * @returns {String} The receiver's content language.
     */

    return TP.dom.Node.getContentLanguage(this);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getContentLanguage',
function() {

    /**
     * @method getContentLanguage
     * @summary Returns the receiver's xml:lang value, or the current default
     *     language if no xml:lang specification is found in the receiver's
     *     parent chain.
     * @returns {String} The receiver's content language.
     */

    return TP.dom.Node.getContentLanguage(this);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getContentMIMEType',
function() {

    /**
     * @method getContentMIMEType
     * @summary Returns the receiver's "content MIME type", the MIME type the
     *     receiver can render most effectively. This information is drawn from
     *     the namespaceURI of the receiver in most cases. The mappings between
     *     namespace URIs and MIME types are found in the XMLNS 'info' hash.
     * @returns {String} The receiver's content MIME type.
     */

    return TP.dom.Node.getContentMIMEType(this);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getDocument',
function() {

    /**
     * @method getDocument
     * @summary Returns the receiver's TIBET document wrapper. This method will
     *     attempt to get the uniqued version provided via TP.core.Window, which
     *     encaches its document instance to avoid duplication. If the document
     *     isn't visible this method will return a new TP.dom.DocumentNode
     *     wrapper.
     * @exception TP.sig.InvalidDocument
     * @returns {TP.dom.DocumentNode} The receiver's document.
     */

    var node,
        doc;

    //  we're after the real document, not the document of some clone, so
    //  we preserve changes here
    node = this.getNativeNode();

    doc = TP.nodeGetDocument(node);
    if (!TP.isDocument(doc)) {
        return this.raise('TP.sig.InvalidDocument',
                            'Unable to determine node\'s document.');
    }

    return TP.wrap(doc);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getDocumentPosition',
function(joinChar) {

    /**
     * @method getDocumentPosition
     * @summary Returns a 0-indexed position generated for the receiver within
     *     the document. This position is unique within the receiver's document
     *     and can be used for positioning comparison purposes with other nodes.
     * @param {String} joinChar A character to use when joining the index parts.
     *     Default is '.'.
     * @returns {String} The index or TP.NOT_FOUND.
     */

    return TP.nodeGetDocumentPosition(this.getNativeNode(), joinChar);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getDocumentMIMEType',
function() {

    /**
     * @method getDocumentMIMEType
     * @summary Returns the MIME type of the document containing the node.
     * @returns {String} The MIME type of the receiver's node.
     */

    //  we're after the real document, not the document of some clone, so
    //  we preserve changes here
    return TP.dom.Node.getDocumentMIMEType(this);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getFacetedAspectNames',
function() {

    /**
     * @method getFacetedAspectNames
     * @summary Returns an Array of the names of the aspects that are faceted on
     *     the receiver.
     * @returns {String[]} A list of the names of aspects that are faceted on
     *     the receiver.
     */

    var aspects;

    if (TP.owns(this, '$$faceted_aspects')) {
        return this.$$faceted_aspects;
    }

    //  Gather whatever our supertype thinks we should have as aspect names that
    //  have facets.
    aspects = this.callNextMethod();

    //  We filter out aspect names that are used to track our internal data,
    //  while allowing ones that our subtypes might have defined.
    aspects = aspects.filter(
                function(anAspect) {
                    if (anAspect !== '$signalingBatchID' &&
                        anAspect !== '$repeatTemplates' &&
                        anAspect !== '$refreshedElements' &&
                        anAspect !== '$alreadyTransforming' &&
                        anAspect !== 'changeFlagging' &&
                        anAspect !== 'dirty' &&
                        anAspect !== 'node' &&
                        anAspect !== 'recyclable' &&
                        anAspect !== 'phase' &&
                        anAspect !== 'preppedReps' &&
                        anAspect !== 'uri') {
                        return true;
                    }

                    return false;
                });

    return aspects;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getGlobalID',
function(assignIfAbsent) {

    /**
     * @method getGlobalID
     * @summary Returns the global ID (a TIBET URI) of the receiver.
     * @param {Boolean} assignIfAbsent True if an ID should be assigned when one
     *     isn't present. Default is false.
     * @returns {String} The global ID of the receiver.
     */

    return TP.gid(this.getNativeNode(), assignIfAbsent);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('asHTTPValue',
function() {

    /**
     * @method asHTTPValue
     * @summary Returns the best value to be used for the receiver to send via
     *     HTTP.
     * @returns {TP.dom.Node} The best value for HTTP sending, which in this
     *     case is the receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getID',
function() {

    /**
     * @method getID
     * @summary Returns the public ID of the receiver.
     * @returns {String} The public ID of the receiver.
     */

    //  Make sure that, if the receiver is a prototype, we just return the value
    //  of the TP.ID slot. Otherwise, we're trying to get an ID from an object
    //  that represents only a partially formed instance for this type.
    if (TP.isPrototype(this)) {
        return this[TP.ID];
    }

    return TP.gid(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getIndexInParent',
function() {

    /**
     * @method getIndexInParent
     * @summary Returns the index in this node's *parent node's* childNodes
     *     array for the receiver.
     * @returns {Number} The index number, or TP.NOT_FOUND.
     */

    var node,
        parentNode;

    node = this.getNativeNode();
    parentNode = node.parentNode;

    return TP.nodeGetChildIndex(parentNode, node);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getLocalID',
function(assignIfAbsent) {

    /**
     * @method getLocalID
     * @summary Returns the local ID of the element, the ID of the node as
     *     defined in the document it resides in. Since this value isn't unique
     *     across documents it's considered a "local ID".
     * @param {Boolean} assignIfAbsent True if an ID should be assigned when one
     *     isn't present. Default is false.
     * @returns {String} The local ID of the receiver.
     */

    return TP.lid(this.getNativeNode(), assignIfAbsent);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getLocalName',
function() {

    /**
     * @method getLocalName
     * @summary Returns the local (or base) name of the receiver. This method
     *     is only truly valid for elements and attributes (although documents
     *     will return 'document'), so the default version returns an
     *     TP.sig.InvalidOperation exception.
     * @exception TP.sig.InvalidOperation
     * @returns {String} The local name of the receiver.
     */

    return this.raise('TP.sig.InvalidOperation');
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getLocation',
function() {

    /**
     * @method getLocation
     * @summary Returns the location of the node's associated URI, if the node
     *     was loaded on behalf of a URI.
     * @returns {String|undefined} The location of the receiver's URI.
     */

    var url;

    url = this.get('uri');
    if (TP.isURIString(url)) {
        return TP.uc(url).getLocation();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getParentNode',
function() {

    /**
     * @method getParentNode
     * @summary Returns a TP.dom.Node wrapping the parent node of the receiver.
     * @returns {TP.dom.Node} The parent node of the receiver.
     */

    return TP.wrap(this.getNativeNode().parentNode);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getOuterContent',
function(aRequest) {

    /**
     * @method getOuterContent
     * @summary Returns the receiver's 'outer' content - that is, its entire
     *     representation, including any childNode representations.
     * @param {TP.sig.Request|TP.core.Hash} aRequest Optional control
     *     parameters.
     * @returns {String} The outer content of the native node.
     */

    //  For most nodes, this is the same as asString().
    return this.asString();
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getOutermostOfSameKind',
function(aType) {

    /**
     * @method getOutermostOfSameKind
     * @summary Returns the outermost Node (from the receiver) whose type
     *     matches the supplied type, either the receiver if it is standalone or
     *     a parent node whose type matched the supplied type.
     * @param {TP.meta.dom.Node} aType A type object.
     * @returns {TP.dom.Node} The outermost Node matching the supplied type.
     */

    var node,
        retVal,

        tpElem;

    node = this.getNativeNode();

    /* eslint-disable consistent-this */
    retVal = this;
    /* eslint-enable consistent-this */

    while (TP.isElement(node = node.parentNode)) {
        tpElem = TP.wrap(node);

        if (!TP.isKindOf(tpElem, aType)) {
            break;
        }

        retVal = tpElem;
    }

    return retVal;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getMIMEType',
function() {

    /**
     * @method getMIMEType
     * @summary Returns a best-guess MIME type for the receiver, first trying
     *     to acquire it from the receiver's URI if it has one, then via the
     *     receiver's document.
     * @returns {String} The MIME type of the receiver.
     */

    var url;

    if (TP.isURI(url = this.get('uri'))) {
        return TP.uc(url).getMIMEType();
    }

    return this.getDocumentMIMEType();
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getName',
function() {

    /**
     * @method getName
     * @summary Returns the receiver's name, if it exists.
     * @returns {String} The public name of the receiver.
     */

    return TP.name(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getNativeDocument',
function() {

    /**
     * @method getNativeDocument
     * @summary Returns the document object containing the receiver.
     * @returns {Document} The document containing the receiver.
     */

    return TP.nodeGetDocument(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getNativeNode',
function() {

    /**
     * @method getNativeNode
     * @summary Returns the receiver's native DOM node object.
     * @returns {Node} The receiver's native DOM node.
     */

    return this.$get('node');
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getNativeObject',
function() {

    /**
     * @method getNativeObject
     * @summary Returns the native object that the receiver is wrapping. In the
     *     case of TP.dom.Nodes, this is the receiver's native node.
     * @returns {Node} The receiver's native object.
     */

    return this.getNativeNode();
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getNativeWindow',
function() {

    /**
     * @method getNativeWindow
     * @summary Returns the document's native window object.
     * @returns {Window} The receiver's document's native window object.
     */

    //  we're after the real document, not the document of some clone, so
    //  we preserve changes here
    return TP.nodeGetWindow(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getNSPrefixes',
function(aNamespaceURI, includeDescendants) {

    /**
     * @method getNSPrefixes
     * @summary Returns an Array of namespace prefixes for aNamespaceURI in the
     *     receiver.
     * @param {String} aNamespaceURI The namespace URI to return the array of
     *     prefixes for. If empty, all defined prefixes will be returned.
     * @param {Boolean} includeDescendants Should the search run across the
     *     entire DOM tree? Default is false.
     * @returns {String[]} An array of namespace prefixes for the supplied
     *     aNamespaceURI in the document.
     */

    return TP.nodeGetNSPrefixes(this.getNativeNode(),
                                aNamespaceURI,
                                includeDescendants);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getNSURI',
function() {

    /**
     * @method getNSURI
     * @summary Returns the namespaceURI of the receiver. This is typically
     *     found in the namepaceURI but in certain circumstances you'll get an
     *     empty value there even when the xmlns attribute is in place.
     * @returns {String} A namespace URI or the empty string.
     */

    return TP.nodeGetNSURI(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getNSURIs',
function(includeDescendants) {

    /**
     * @method getNSURIs
     * @summary Returns an Array of unique namespace URIs in the receiver.
     * @param {Boolean} includeDescendants Should the search run across the
     *     entire DOM tree? Default is false.
     * @returns {String[]} An array of unique namespace URIs found in the
     *     receiver.
     */

    return TP.nodeGetNSURIs(this.getNativeNode(), includeDescendants);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getProperty',
function(attributeName) {

    /**
     * @method getProperty
     * @summary Returns the value of the named property, checking the native
     *     node first, then the receiver.
     * @returns {Object} The value of the property at the supplied attribute
     *     name in the receiver.
     */

    var node,
        val;

    if (!TP.isNode(node = this.getNativeNode())) {
        return this.$get(attributeName);
    }

    try {
        val = node[attributeName];
    } catch (e) {
        TP.ifError() ?
            TP.error(
                TP.ec(e,
                    'Error retrieving node property: ' + attributeName)) : 0;
    }

    if (TP.notValid(val)) {
        return this.$get(attributeName);
    }

    return val;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getSiblings',
function(aSubset) {

    /**
     * @method getSiblings
     * @summary Returns an Array containing the sibling nodes of the receiver.
     *     Order is from the parent's first child to the parent's last child,
     *     with aNode removed from the list.
     * @description Order is from the parent's first child to the parent's last
     *     child, with aNode removed from the list. Unlike other methods for
     *     node collections this method does *not* normalize content, so a text
     *     node's siblings will be found when multiple text nodes were created
     *     by the browser. This means that that sibling list won't be consistent
     *     for all node types across browsers.
     * @param {String} aSubset TP.NEXT, TP.PREVIOUS, or null to collect all
     *     siblings.
     * @returns {TP.dom.Node[]} An Array containing the nodes found.
     */

    return TP.wrap(TP.nodeGetSiblings(this.getNativeNode(), aSubset));
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getTargetPhase',
function(phaseList, outerElem) {

    /**
     * @method getTargetPhase
     * @summary Returns the maximum phase the node should be processed to based
     *     on checking it and its ancestors for phase information. Child content
     *     shouldn't exceed the phase of its enclosing ancestors.
     * @param {String[]} phaseList An optional array in which to find the target
     *     phase.
     * @param {Element} outerElem An optional 'outermost' element to test.
     *     Testing will not go higher than this element in the DOM tree.
     * @returns {String} The maximum content processing phase name.
     */

    return TP.nodeGetTargetPhase(this.getNativeNode(),
                                    phaseList,
                                    outerElem);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getTextContent',
function() {

    /**
     * @method getTextContent
     * @summary Returns the normalized text content of the receiver's first
     *     text node.
     * @returns {String} The receiver's text value.
     */

    return TP.nodeGetTextContent(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getValue',
function() {

    /**
     * @method getValue
     * @summary Returns the value of the receiver. Unless overridden by a
     *     custom subtype this method will return the text value of the
     *     receiving node.
     * @returns {String} The value in string form.
     */

    return this.getTextContent();
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getWindow',
function() {

    /**
     * @method getWindow
     * @summary Returns the receiver's containing TP.core.Window object.
     * @returns {TP.core.Window} The receiver's TP.core.Window object.
     */

    var win;

    win = this.getNativeWindow();
    if (TP.isWindow(win)) {
        win = TP.core.Window.construct(win);
    }

    return win;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('hasReachedPhase',
function(targetPhase, targetPhaseList) {

    /**
     * @method hasReachedPhase
     * @summary Returns true if the receiver is processed up to or beyond the
     *     phase provided. If no phase is provided, 'Finalize' is assumed (since
     *     that's the last valid phase that doesn't require run-time canvas
     *     information)
     * @param {String} targetPhase A TIBET content "process phase" constant such
     *     as 'Includes'.
     * @param {String[]} targetPhaseList An optional list of phases to search
     *     for the target phase. The default is TP.shell.TSH.NOCACHE.
     * @returns {Boolean} True if the phase has been reached.
     */

    return TP.nodeHasReachedPhase(
                this.getNativeNode(), targetPhase, targetPhaseList);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('hasWindow',
function() {

    /**
     * @method hasWindow
     * @summary Returns whether or not the receiver is in a Window.
     * @returns {Boolean} Whether or not the receiver is in a Window.
     */

    return TP.isWindow(this.getNativeWindow());
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('identicalTo',
function(aNode) {

    /**
     * @method identicalTo
     * @summary Returns whether the supplied node is 'identical to' the
     *     receiver.
     * @description This method will return true if the underlying native Node
     *     of the receiver is identical to the supplied Node (or underlying
     *     native Node if a TP.dom.Node was supplied).
     * @param {TP.dom.Node|Node} aNode The TP.dom.Node or Node to use in the
     *     comparison.
     * @exception TP.sig.InvalidNode
     * @returns {Boolean} Whether or not the supplied node is identical to the
     *     receiver.
     */

    var otherNode;

    otherNode = TP.unwrap(aNode);

    if (!TP.isNode(otherNode)) {
        return false;
    }

    return this.getNativeNode() === otherNode;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('isDirty',
function(aFlag) {

    /**
     * @method isDirty
     * @summary Combined setter/getter for whether the receiver has been
     *     changed since it was first loaded.
     * @param {Boolean} aFlag The state of the node's dirty flag, which will be
     *     set when provided.
     * @returns {Boolean} The current dirty state, after any optional set()
     *     operation has occurred.
     */

    if (TP.isBoolean(aFlag)) {
        this.$set('dirty', aFlag, false);
    }

    return this.$get('dirty');
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('isDetached',
function(aRootNode) {

    /**
     * @method isDetached
     * @summary Returns true if the receiver's parent chain does not terminate
     *     at the root node provided, or at a Document node when no specific
     *     root is given. The root node can be either an element node or a
     *     document node.
     * @param {Node} aRootNode An optional node the receiver must reside in,
     *     hence a Document or Element (Collection) node.
     * @returns {Boolean} True if the receiver isn't in a document.
     */

    return TP.nodeIsDetached(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('$$isPair',
function() {

    /**
     * @method $$isPair
     * @summary Returns true if the receiver can be considered an ordered pair.
     *     This is never true for a node.
     * @returns {Boolean} False for nodes.
     */

    return false;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('isOutermostOfSameKind',
function() {

    /**
     * @method isOutermostOfSameKind
     * @summary Returns true if the receiver is the outermost Node whose type
     *     matches its own type.
     * @returns {Boolean} True if the receiver is the top-most Node of the same
     *     kind.
     */

    return this.getOutermostOfSameKind(this.getType()) === this;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('isSingleValued',
function(aspectName) {

    /**
     * @method isSingleValued
     * @summary Returns true if the receiver deals with single values.
     * @description See the TP.dom.Node's 'isScalarValued()' instance method
     *     for more information.
     * @param {String} [aspectName] An optional aspect name that is being used
     *     by the caller to determine whether the receiver is single valued for.
     * @returns {Boolean} True when single valued.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('isScalarValued',
function(aspectName) {

    /**
     * @method isScalarValued
     * @summary Returns true if the receiver deals with scalar values.
     * @description Most 'field-level' UI controls bind to scalar values (i.e.
     *     Booleans, Numbers and Strings), but action tags and certain other
     *     complex UI elements can bind to nodes or nodelists. In the first
     *     case, this method should return true and in the second it should
     *     return false.
     *     Note that this is different than saying that the receiver is 'single
     *     valued', which means that it can accept only one value. That one
     *     value might very well might not be a scalar value.
     *     When you combine isScalarValued() with isSingleValued() you get a
     *     fairly broad range of options for what a control wants to consume.
     *     Here are examples:
     *
     *     Description         isScalarValued        isSingleValued
     *     -----------         --------------        --------------
     *     X(HT)ML node        true                  true
     *     X(HT)ML element     false                 false
     *     <html:input>        true                  true
     *     <html:textarea>     true                  true
     *     <html:select>       true                  false
     *
     * @param {String} [aspectName] An optional aspect name that is being used
     *     by the caller to determine whether the receiver is scalar valued for.
     * @returns {Boolean} True when scalar valued.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('produceContent',
function(aContentObject, aRequest) {

    /**
     * @method produceContent
     * @summary Produces the content that will be used by the addContent() and
     *     setContent() methods to set the content of the receiver.
     * @param {Object} aContentObject An object to use for content.
     * @param {TP.sig.Request} aRequest A request containing control parameters.
     */

    return TP.str(aContentObject);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('produceValue',
function(aspectName, aContentObject, aRequest) {

    /**
     * @method produceValue
     * @summary Produces the value that will be used by the setValue() method
     *     to set the content of the receiver.
     * @description This method works together with the 'isSingleValued()' and
     *     'isScalarValued()' methods to produce the proper value for the
     *     receiver. See the method description for isScalarValued() for more
     *     information.
     * @param {String} aspectName The aspect name on the receiver that the value
     *     is being produced for. Many times, this is 'value'.
     * @param {Object} aContentObject An object to use for content.
     * @param {TP.sig.Request} aRequest A request containing control parameters.
     */

    var input,
        value,

        result,
        len,
        i,

        keys;

    input = aContentObject;

    //  Reduce the content so we're not dealing with an Array when we're
    //  single-valued... no point in either observing too much or in running it
    //  all through a formatting pipeline when we only want one value.
    if (this.isSingleValued(aspectName)) {
        input = this.$reduceValue(input, aRequest);
    }

    //  If we're scalar-valued we can't process nodes as values. We need to
    //  convert them into a proper scalar value. The same is true for any
    //  collection of input, we've got to convert it into a collection of scalar
    //  values rather than a collection of more complex objects
    if (this.isScalarValued(aspectName)) {
        if (TP.isString(input)) {
            value = input;
        } else if (TP.isNode(input)) {
            value = TP.val(input);
        } else if (TP.isNodeList(input)) {
            //  Since we're scalar-valued we want NodeLists to be converted to
            //  Arrays of the node "values" in text form
            result = TP.ac();
            len = input.length;
            for (i = 0; i < len; i++) {
                result.atPut(i, TP.val(input[i]));
            }
            value = result;
        } else if (TP.isNamedNodeMap(input)) {
            //  Since we're scalar-valued we want NamedNodeMaps to be converted
            //  to Arrays of the map "values" in text form
            result = TP.ac();
            len = input.length;
            for (i = 0; i < len; i++) {
                result.atPut(i, TP.val(input.item(i)));
            }
            value = result;
        } else if (TP.isArray(input)) {
            //  For arrays that aren't nodelists we'll ask for the value via a
            //  more general-purpose routine
            result = TP.ac();
            len = input.getSize();
            for (i = 0; i < len; i++) {
                result.atPut(i, TP.val(input.at(i)));
            }
            value = result;
        } else if (TP.isHash(input)) {
            result = TP.hc();
            keys = input.getKeys();
            len = keys.getSize();
            for (i = 0; i < len; i++) {
                result.atPut(keys.at(i), TP.val(input.at(keys.at(i))));
            }
            value = result;
        } else if (TP.isPlainObject(input)) {
            result = {};
            keys = TP.keys(input);
            len = keys.getSize();
            for (i = 0; i < len; i++) {
                result[keys.at(i)] = TP.val(input[keys.at(i)]);
            }
            value = result;
        } else {
            //  Anything else we'll try to convert using our general purpose
            //  value routine, which quite often returns the string value
            value = TP.val(input);
        }
    } else {
        value = input;
    }

    return value;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('$reduceValue',
function(theContent, anIndex) {

    /**
     * @method $reduceValue
     * @summary Reduces the content value to a 'single value'.
     * @description When the receiver isSingleValued() this method will return a
     *     single object from a content result set (a collection of some sort -
     *     usually an Array, Object, TP.core.Hash, NodeList or NamedNodeMap).
     *     The result set must be a collection for this method to operate
     *     correctly. In all other cases the original content object is
     *     returned. What this method returns depends on the type of content
     *     handed to it:
     *
     *     Array            The content at the index supplied or at 0 if no
     *                      index was supplied.
     *     Object           The *value* of the content at the index supplied or
     *                      at the first key if no index was supplied.
     *     TP.core.Hash     The *value* of the content at the index supplied or
     *                      at the first key if no index was supplied.
     *     NodeList         The content at the index supplied or at 0 if no
     *                      index was supplied.
     *     NamedNodeMap     The *value* of the content at the index supplied or
     *                      at the first key if no index was supplied.
     * @param {Object} theContent The original content object.
     * @param {Number|String} anIndex The index into the collection to use to
     *     supply the value.
     * @returns {Object} The original data, or the proper "single object" from
     *     that collection.
     */

    var result,
        index,
        len;

    if (TP.isString(theContent)) {
        return theContent;
    }

    if (!TP.isCollection(theContent) && !TP.isPlainObject(theContent)) {
        return theContent;
    }

    result = theContent;

    if (TP.isNodeList(result)) {
        result = TP.ac(result);
    }

    //  Because of the conversion above, this handles both Arrays and NodeLists
    if (TP.isArray(result)) {
        index = TP.ifInvalid(anIndex, 0);

        len = result.getSize();

        try {
            //  NB: We use 'native' syntax here as 'result' might be a NodeList
            if (index > len) {
                result = result.at(len - 1);
            } else if (index < 0) {
                result = result.at(0);
            } else {
                result = result.at(index);
            }
        } catch (e) {
            result = undefined;
        }
    } else {
        //  This handles TP.core.Hash, Objects and NamedNodeMaps

        index = anIndex;
        if (TP.notValid(index)) {
            index = TP.keys(result).first();
        }

        if (TP.isHash(result)) {
            result = result.at(index);
        } else {
            result = result[index];
        }
    }

    return result;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('selectChain',
function(aProperty) {

    /**
     * @method selectChain
     * @summary Returns an Array of objects that are obtained by recursively
     *     obtaining the property on each object, starting with the receiver.
     * @param {String} aProperty The property name to use to obtain each return
     *     value.
     * @returns {Object[]} An Array of objects obtained by recursing using the
     *     supplied property.
     */

    return TP.wrap(TP.nodeSelectChain(this.getNativeNode(), aProperty));
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('serializeForStorage',
function(storageInfo) {

    /**
     * @method serializeForStorage
     * @summary Serialize the receiver in a manner appropriate for storage.
     * @description This method provides a serialized representation of the
     *     receiver that can be used to store it in a persistent storage. The
     *     supplied storageInfo hash should contain a storage key under the
     *     'store' key that will be used to uniquely identify the content
     *     produced for this receiver. Note that nested nodes might produce
     *     their own 'serialization stores'. All of the stores can be found
     *     under the 'stores' key in the storageInfo after the serialization
     *     process is complete.
     *     For this type, serialization means simply returning the node's value.
     * @param {TP.core.Hash} storageInfo A hash containing various flags for and
     *     results of the serialization process. Notable keys include:
     *          'wantsXMLDeclaration': Whether or not the receiver's document
     *          node should include an 'XML declaration' at the start of its
     *          serialization. The default is false.
     *          'wantsPrefixedXMLNSAttrs': Whether or not the receiver and its
     *          decendant elements should generate prefixed (i.e. 'xmlns:foo')
     *          attributes to support their proper serialization. The default is
     *          true.
     *          'result': The current serialization result as it's being built
     *          up.
     *          'store': The key under which the current serialization result
     *          will be stored.
     *          'stores': A hash of 1...n serialization results that were
     *          generated during the serialization process. Note that nested
     *          nodes might generated results that will go into different
     *          stores, and so they will all be stored here, each keyed by a
     *          unique key (which, by convention, will be the URI they should be
     *          saved to).
     * @returns {TP.dom.Node} The receiver.
     */

    return TP.unwrap(this).nodeValue;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('serializeNonTag',
function(storageInfo) {

    /**
     * @method serializeNonTag
     * @summary Serializes the non tag node receiver.
     * @param {TP.core.Hash} storageInfo A hash containing various flags for and
     *     results of the serialization process. Notable keys include:
     *          'wantsXMLDeclaration': Whether or not the receiver's document
     *          node should include an 'XML declaration' at the start of its
     *          serialization. The default is false.
     *          'wantsPrefixedXMLNSAttrs': Whether or not the receiver and its
     *          decendant elements should generate prefixed (i.e. 'xmlns:foo')
     *          attributes to support their proper serialization. The default is
     *          true.
     *          'result': The current serialization result as it's being built
     *          up.
     *          'store': The key under which the current serialization result
     *          will be stored.
     *          'stores': A hash of 1...n serialization results that were
     *          generated during the serialization process. Note that nested
     *          nodes might generated results that will go into different
     *          stores, and so they will all be stored here, each keyed by a
     *          unique key (which, by convention, will be the URI they should be
     *          saved to).
     * @returns {String} A serialization of the non-tag receiver.
     */

    return TP.unwrap(this).nodeValue;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('setContent',
function(aContentObject, aRequest) {

    /**
     * @method setContent
     * @summary Sets the content of the receiver's native DOM counterpart to
     *     the value supplied.
     * @description At this level, this method merely sets the text content of
     *     the node to what is produced by executing the 'produceContent'
     *     on the supplied content object. Subtypes should override this method
     *     to provide a more specific version of this.
     * @param {Object} aContentObject An object to use for content.
     * @param {TP.sig.Request} aRequest A request containing control parameters.
     * @returns {TP.dom.Node} The receiver.
     */

    this.setTextContent(aContentObject);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('setNativeNode',
function(aNode, shouldSignal) {

    /**
     * @method setNativeNode
     * @summary Sets the receiver's native DOM node object.
     * @param {Node} aNode The node to wrap.
     * @param {Boolean} shouldSignal If false this operation will not trigger a
     *     change notification. This defaults to the return value of sending
     *     shouldSignalChange() to the receiver.
     * @exception TP.sig.InvalidNode
     * @returns {TP.dom.Node} The receiver.
     */

    var oldNode,

        flag;

    if (!TP.isNode(aNode)) {
        return this.raise('TP.sig.InvalidNode', aNode);
    }

    this.$set('node', aNode, false);

    //  NB: Use this construct this way for better performance
    if (TP.notValid(flag = shouldSignal)) {
        flag = this.shouldSignalChange();
    }

    if (flag) {
        this.$changed('content', TP.UPDATE,
                        TP.hc(TP.OLDVAL, oldNode, TP.NEWVAL, aNode));
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('setRawContent',
function(newContent, aRequest) {

    /**
     * @method setRawContent
     * @summary Sets the content of the receiver to the content provided
     *     without performing any content processing on it. At this level, this
     *     method just performs a setContent() and returns.
     * @param {Object} newContent The content to write into the receiver. This
     *     can be a String, a Node, or an Object capable of being converted into
     *     one of those forms.
     * @param {TP.sig.Request} aRequest An optional request object which defines
     *     further parameters.
     * @returns {TP.dom.Node} The result of setting the content of the
     *     receiver.
     */

    return this.setContent(newContent, aRequest);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('setProperty',
function(attributeName, attributeValue, shouldSignal) {

    /**
     * @method setProperty
     * @summary Sets the value of the named attribute to attributeValue. For a
     *     TP.dom.Node this is called by set() after the attribute has been
     *     resolved and the value has been validated.
     * @param {String} attributeName The attribute to set.
     * @param {Object} attributeValue The value to set.
     * @param {Boolean} shouldSignal Should changes be notified. If false changes
     *     are not signaled. Defaults to this.shouldSignalChange().
     * @returns {TP.dom.Node} The receiver.
     * @fires Change
     */

    var model,
        val,
        flag;

    //  no model? store locally. note that the fetch here is for the
    //  unchanged node, preserving any crud/delete flagged nodes
    if (!TP.isNode(model = this.getNativeNode())) {
        return this.$set(attributeName,
                            attributeValue,
                            shouldSignal);
    }

    //  issue for TP.dom.Node is that we don't want to put things on the
    //  node that might disappear if the node gets transformed when those
    //  things are defined attributes of TP.dom.Node (or the subtype). So
    //  we have to check for that case first...
    if (TP.isDefined(this.$get(attributeName))) {
        return this.$set(attributeName,
                            attributeValue,
                            shouldSignal);
    }

    //  do it the old-fashioned way...
    val = this.getProperty(attributeName);
    if (TP.isDefined(val)) {
        //  val exists either as null or other defined value. the ==
        //  test should be adequate since we're getting a value from the
        //  model which is typically a string/number/boolean.
        if (typeof val === typeof attributeValue) {
            if (val === attributeValue) {
                //  if new value is a match then no change is needed
                return this;
            }
        }
    }

    //  model exists so set the value...to null if we have to for
    //  initialization. note we use try/catch here to avoid problems with IE
    //  complaining about slot access for things it doesn't recognize
    try {
        model[attributeName] = TP.ifUndefined(attributeValue, null);
        if (model[attributeName] === attributeValue) {
            // this.modelChanged(attributeName);

            //  NB: Use this construct this way for better performance
            if (TP.notValid(flag = shouldSignal)) {
                flag = this.shouldSignalChange();
            }

            if (flag) {
                this.$changed(attributeName, TP.UPDATE);
            }
        } else {
            //  value didn't take...non-mutable model/aspect?
            this.$set(attributeName, attributeValue, shouldSignal);
        }
    } catch (e) {
        this.$set(attributeName, attributeValue, shouldSignal);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('setTextContent',
function(aValue, shouldSignal) {

    /**
     * @method setTextContent
     * @summary Sets the text content of the receiver's first text node to
     *     aValue. For general node types this method sets the value/content of
     *     the node.
     * @description For common nodes the standard attribute list and the type of
     *     input determines what is actually manipulated. For element and
     *     document nodes the behavior is a little different. When the receiver
     *     has a pre-existing value attribute that's typically what is
     *     manipulated. When no value attribute is found the content of the node
     *     is changed. The type of node and input can alter how this actually is
     *     done. See the setContent call for more information.
     * @param {Object} aValue The value to set the 'content' of the node to.
     * @param {Boolean} shouldSignal Should changes be notified. If false
     *     changes are not signaled. Defaults to this.shouldSignalChange().
     * @returns {Boolean} Whether or not the value was changed from the value it
     *     had before this method was called.
     */

    var node,
        oldValue,
        flag;

    //  fetch the value without preserving changes so we can test against
    //  the "current state" if flagged
    node = this.getNativeNode();

    //  capture a value so we can test for change
    oldValue = TP.nodeGetTextContent(node);

    //  this test should be adequate for text comparison
    if (aValue === oldValue) {
        return false;
    }

    //  refetch the true native node, preserving crud/deletes so the new
    //  value really sticks
    node = this.getNativeNode();

    //  set the text value if it appears it will change
    TP.nodeSetTextContent(node, aValue);

    //  signal as needed

    //  NB: Use this construct this way for better performance
    if (TP.notValid(flag = shouldSignal)) {
        flag = this.shouldSignalChange();
    }

    if (flag) {
        this.$changed('value', TP.UPDATE);
    }

    //  Since, at the TP.dom.Node level, setting the value is equivalent to
    //  setting the content, we signal that we've done that.

    try {
        //  We only signal TP.sig.DOMContentLoaded if the system is configured
        //  for it.
        if (TP.sys.shouldSignalDOMLoaded()) {
            TP.signal(TP.gid(node),
                        'TP.sig.DOMContentLoaded',
                        aValue);
        }
    } catch (e) {
        TP.ifError() ?
            TP.error(
                TP.ec(e,
                    'TP.sig.DOMContentLoaded handler generated error.')) : 0;
    }

    return true;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('setUri',
function(aURI) {

    /**
     * @method setUri
     * @summary Sets the 'source URI' of the receiver. This allows tracking of
     *     the source that the receiver came from.
     * @param {TP.uri.URI} aURI The URI to set as the receiver's source URI.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.dom.Node} The receiver.
     */

    if (!TP.isURIString(aURI) && !TP.isURI(aURI)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    this.$set('uri', aURI.asString(), false);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('setValue',
function(aValue, shouldSignal) {

    /**
     * @method setValue
     * @summary Sets the value of the receiver's node. For general node types
     *     this method sets the value/content of the node. See this type's
     *     'setTextContent' method for more information.
     * @param {Object} aValue The value to set the 'value' of the node to.
     * @param {Boolean} shouldSignal Should changes be notified. If false
     *     changes are not signaled. Defaults to this.shouldSignalChange().
     * @returns {Boolean} Whether or not the value was changed from the value it
     *     had before this method was called.
     */

    var newValue;

    newValue = this.produceValue('value', aValue);

    return this.setTextContent(newValue, shouldSignal);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('toJSON',
function() {

    /**
     * @method toJSON
     * @summary Returns the object to use in JSON representations.
     * @returns {Object} The object to use in a JSON representation.
     */

    return this.asObject();
});

//  ------------------------------------------------------------------------
//  DNU SUPPORT
//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('canResolveDNU',
function(anOrigin, aMethodName, anArgArray, callingContext) {

    /**
     * @method canResolveDNU
     * @summary Provides an instance that triggers the DNU machinery with an
     *     opportunity to handle the problem itself. TP.dom.Nodes look to the
     *     TP.* primitives, followed by their native node in an attempt to
     *     resolve these situations.
     * @param {Object} anOrigin The object asking for help. The receiver in this
     *     case.
     * @param {String} aMethodName The method name that failed.
     * @param {Object[]} anArgArray Optional arguments to function.
     * @param {Function|arguments} callingContext The calling context.
     * @exception TP.sig.InvalidNode
     * @returns {Boolean} TRUE means resolveDNU() will be called. FALSE means
     *     the standard DNU machinery will continue processing. The default is
     *     TRUE for TP.dom.Node subtypes.
     */

    var node,
        fname,
        target,
        invocable;

    if (!TP.isNode(node = this.getNativeNode())) {
        return this.raise('TP.sig.InvalidNode');
    }

    if (TP.isEmpty(aMethodName)) {
        return false;
    }

    //  first check is for a TP primitive starting with "element",
    //  "document", etc. based on the node type we've got
    switch (node.nodeType) {
        case Node.ELEMENT_NODE:

            fname = 'element' + aMethodName.asTitleCase();
            if (TP.canInvoke(TP, fname)) {
                target = 'TP';
            }

            break;

        case Node.DOCUMENT_NODE:

            fname = 'document' + aMethodName.asTitleCase();
            if (TP.canInvoke(TP, fname)) {
                target = 'TP';
            }

            break;

        case Node.ATTRIBUTE_NODE:

            fname = 'attribute' + aMethodName.asTitleCase();
            if (TP.canInvoke(TP, fname)) {
                target = 'TP';
            }

            break;

        default:
            break;
    }

    //  common fallback case is generic node* method
    if (TP.notValid(target)) {
        fname = 'node' + aMethodName.asTitleCase();
        if (TP.canInvoke(TP, fname)) {
            target = 'TP';
        }

        //  slighly less common fallback case is object* method
        if (TP.notValid(target)) {
            fname = 'object' + aMethodName.asTitleCase();
            if (TP.canInvoke(TP, fname)) {
                target = 'TP';
            }

            if (TP.notValid(target)) {
                //  finally, look to the native node itself
                if (TP.canInvoke(node, aMethodName)) {
                    target = 'this.getNativeNode()';
                    invocable = TP.isCallable(node[aMethodName].invoke);
                }
            }
        }
    }

    if (TP.notValid(target)) {
        return false;
    }

    //  return the result of building the resolver we need
    return this.$$constructDNUResolver(target, fname, invocable);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('$$constructDNUResolver',
function(aTarget, aMethodName, supportsInvoke) {

    /**
     * @method $$constructDNUResolver
     * @summary Builds a method capable of resolving a DNU and associates it
     *     with the receiver. If this operation is successful this method will
     *     return true, supporting the canResolve method.
     * @param {String} aTarget A target string which is the receiver of the
     *     resolving method. Normally 'TP' for a TP.dom.Node.
     * @param {String} aMethodName The name of the method to invoke on the
     *     target.
     * @param {Boolean} supportsInvoke False to force apply to be used.
     * @returns {Boolean} True if the creation is successful.
     */

    var fstr,
        func;

    if (TP.isFalse(supportsInvoke)) {
        fstr = TP.join('function(arglist)',
                        '{',
                            'var args;',
                            'args = TP.args(arglist);',
                            'args.unshift(this.getNativeNode());',
                            'return ', aTarget, '[', aMethodName, '].',
                                'apply(', aTarget, ', args);',
                        '}');
    } else {
        fstr = TP.join('function(arglist)',
                        '{',
                            'return ', aTarget, '[', aMethodName, '].',
                                'apply(', aTarget, ', arglist);',
                        '}');
    }

    func = TP.fc(fstr);

    if (!TP.isFunction(func)) {
        return false;
    }

    //  add it to the receiver's type as a new instance method
    this.getType().Inst.defineMethod(aMethodName, func);

    return TP.canInvoke(this, aMethodName);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('resolveDNU',
function(anOrigin, aMethodName, anArgArray, callingContext) {

    /**
     * @method resolveDNU
     * @summary Invoked by the main DNU machinery when the instance has
     *     responded TRUE to canResolveDNU() for the parameters given.
     * @description Handles resolution of methods which have triggered the
     *     inferencer. For TP.dom.DocumentNodes the resolution process is used
     *     in conjunction with method aspects to allow the receiver to translate
     *     method calls.
     * @param {Object} anOrigin The object asking for help.
     * @param {String} aMethodName The method name that failed.
     * @param {Object[]} anArgArray Optional arguments to function.
     * @param {Function|arguments} callingContext The calling context.
     * @exception TP.sig.InvalidNode
     * @returns {Object} The result of invoking the method using the receiver's
     *     native node.
     */

    if (!TP.isNode(this.getNativeNode())) {
        return this.raise('TP.sig.InvalidNode');
    }

    if (TP.isEmpty(aMethodName)) {
        return false;
    }

    return this[aMethodName].apply(this, anArgArray);
});

//  ------------------------------------------------------------------------
//  XPATH SUPPORT
//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('evaluateXPath',
function(XPathExpr, resultType, logErrors) {

    /**
     * @method evaluateXPath
     * @summary Returns the result of executing the XPath expression provided
     *     against the receiver's native node/nodeset.
     * @param {String} XPathExpr The XPath expression to use to query the tree
     *     starting from the receiver.
     * @param {Number} resultType The type of result desired, either TP.NODESET
     *     or TP.FIRST_NODE.
     * @param {Boolean} logErrors Used to turn off error notification,
     *     particularly during operations such as string localization which can
     *     cause recusion issues.
     * @returns {Object} The result of executing the XPath.
     */

    return TP.xpc(XPathExpr).exec(this, resultType, logErrors);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('evaluateXPathFromNode',
function(XPathExpr, resultType, logErrors, aNode, flagChanges) {

    /**
     * @method evaluateXPathFromNode
     * @summary Returns the result of executing the XPath expression provided
     *     against the supplied native node/nodeset.
     * @param {String} XPathExpr The XPath expression to use to query the tree
     *     starting from the supplied Node.
     * @param {Number} resultType The type of result desired, either TP.NODESET
     *     or TP.FIRST_NODE.
     * @param {Boolean} logErrors Used to turn off error notification,
     *     particularly during operations such as string localization which can
     *     cause recusion issues.
     * @param {Node} aNode The context node for the XPath expression.
     * @param {Boolean} flagChanges True if any newly created nodes should be
     *     flagged.
     * @exception TP.sig.InvalidNode
     * @returns {Object} The result of executing the XPath.
     */

    if (!TP.isNode(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    return TP.xpc(XPathExpr).execOnNative(aNode,
                                            resultType,
                                            logErrors,
                                            flagChanges);
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('getDelegate',
function() {

    /**
     * @method getDelegate
     * @summary Returns the receiver's delegate. For TP.dom.Node this is the
     *     receiver's native node.
     * @returns {Node} The receiver's native node.
     */

    return this.getNativeNode();
});

//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('clone',
function(deep, viaString) {

    /**
     * @method cloneNode
     * @summary Clones the receiver, deeply if the 'deep' parameter is true.
     * @param {Boolean} deep Whether or not to clone the node 'deeply' (that is,
     *     to recursively clone its children). Defaults to true.
     * @param {Boolean} viaString If deep, this flag will cause the cloning to
     *     use string-based operations to ensure Moz doesn't mess up the
     *     document reference. Defaults to false.
     * @returns {TP.dom.Node} The resulting clone of aNode.
     */

    return TP.wrap(TP.nodeCloneNode(this.getNativeNode(), deep, viaString));
});

//  ------------------------------------------------------------------------
//  NODE CHANGE TRACKING
//  ------------------------------------------------------------------------

TP.dom.Node.Inst.defineMethod('shouldSignalChange',
function(aFlag) {

    /**
     * @method shouldSignalChange
     * @summary Defines whether the receiver should actively signal change
     *     notifications.
     * @description In general objects do not signal changes when no observers
     *     exist. This flag is triggered by observe where the signal being
     *     observed is a form of Change signal to "arm" the object for change
     *     notification. You can also manipulate it during multi-step
     *     manipulations to signal only when a series of changes has been
     *     completed.
     * @param {Boolean} aFlag true/false signaling status.
     * @returns {Boolean|undefined} The current status.
     */

    //  NB: Because of all of the machinery around signaling and tracking
    //  changes, it's best that this method is written to poke around at the
    //  native node.

    var natNode;

    //  Notice here how we use the 'fast' native node get method to avoid any
    //  sorts of recursion issues.
    natNode = this.getNativeNode();

    if (TP.notValid(natNode)) {
        return;
    }

    if (TP.isBoolean(aFlag)) {
        if (TP.notTrue(aFlag)) {
            delete natNode[TP.SHOULD_SIGNAL_CHANGE];

            return false;
        } else {
            natNode[TP.SHOULD_SIGNAL_CHANGE] = true;

            return true;
        }
    }

    //  when suspended is true we always return false which allows an
    //  override to succeed
    if (natNode[TP.SHOULD_SUSPEND_SIGNALING] === true) {
        return false;
    }

    return natNode[TP.SHOULD_SIGNAL_CHANGE] === true;
});

//  ------------------------------------------------------------------------
//  Primitives
//  ------------------------------------------------------------------------

TP.definePrimitive('nodeGetConcreteType',
function(aNode) {

    /**
     * @method nodeGetConcreteType
     * @summary Returns the specific TP.dom.Node subtype associated with the
     *     node provided.
     * @param {Node} aNode The native node to test.
     * @exception TP.sig.InvalidNode
     * @returns {TP.meta.dom.Node} A TP.dom.Node subtype type object.
     */

    return TP.dom.Node.getConcreteType(aNode);
});

//  ========================================================================
//  TP.dom.CollectionNode
//  ========================================================================

/**
 * @type {TP.dom.CollectionNode}
 * @summary A node type providing common collection-style operations for
 *     certain node subtypes such as document and element nodes.
 * @description The TP.dom.CollectionNode is an abstract supertype for nodes
 *     such as document or element nodes which can support a TIBET collection
 *     API. The API methods of this type are extensive since TP.dom.Node is the
 *     primary data management structure for XForms and various web service
 *     request/response pairs. The API includes methods from:
 *
 *     TP.api.Collection API:
 *
 *     'add', 'addAll', 'addAllIfAbsent', 'addIfAbsent', 'addItem',
 *     'addWithCount', 'asArray', 'asHash', 'asIterator', 'asRange', 'asString',
 *     'collapse', 'collect', 'collectGet', 'collectInvoke', 'compact',
 *     'conform', 'contains', 'containsAll', 'containsAny', 'containsString',
 *     'convert', 'countOf', 'detect', 'detectInvoke', 'detectMax', 'detectMin',
 *     'difference', 'disjunction', 'empty', 'flatten', 'getItems',
 *     'getIterator', 'getIteratorType', 'getSize', 'getValues', 'grep',
 *     'groupBy', 'injectInto', 'intersection', 'isSortedCollection', 'merge',
 *     'partition', 'perform', 'performInvoke', 'performSet', 'performUntil',
 *     'performWhile', 'performWith', 'reject', 'remove', 'removeAll',
 *     'replace', 'replaceAll', 'select', 'union', 'unique',
 *
 *     TP.api.IndexedCollection API:
 *
 *     'addAt', 'addAllAt', 'at', 'atAll', 'atAllPut',
 *     'atIfInvalid', 'atIfNull', 'atIfUndefined', 'atPut', 'atPutIfAbsent',
 *     'containsKey', 'containsValue', 'detectKeyAt', 'getKeys', 'getKVPairs',
 *     'getPosition', 'getPositions', 'grepKeys', 'performOver', 'removeAt',
 *     'removeAtAll', 'removeKey', 'removeKeys', 'transpose',
 *
 *     TP.api.OrderedCollection API:
 *
 *     'addAfter', 'addAllAfter', 'addAllBefore', 'addAllFirst', 'addAllLast',
 *     'addBefore', 'addFirst', 'addLast', 'after', 'before', 'first',
 *     'getLastPosition', 'last', 'orderedBy', 'removeFirst', 'removeLast',
 *     'replaceFirst', 'replaceLast', 'reverse',
 *
 *     The methods defined above are adjusted such that they normally operate
 *     on other TP.dom.Nodes, native Nodes, Nodelists, or TIBET collections
 *     containing TP.dom.Nodes or Nodes. Most methods rely on XPath expressions
 *     when locations are being defined.
 */

//  ------------------------------------------------------------------------

TP.dom.Node.defineSubtype('dom.CollectionNode');

//  can't construct concrete instances of this since its really not a native
//  node type wrapper
TP.dom.CollectionNode.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Type.defineAttribute('namespace', null);

//  the node's tag name. for elements this is the tag name used when
//  creating a new instance of the receiver without additional data. for a
//  document this is the tag name of the document element created when no
//  other data is available
TP.dom.CollectionNode.Type.defineAttribute('tagname', null);

//  a registry of 'original nodes' that were authored.
TP.dom.CollectionNode.Type.defineAttribute('originals');

//  whether or not we're in the middle of recasting this node.
TP.dom.CollectionNode.Type.defineAttribute('$isRecasting', false);

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  Whether or not we're already in the middle of 'transforming' a piece of
//  markup. This helps avoid endless recursions between the 'transform' method
//  and the 'compute' method/tag processing pipeline.
TP.dom.CollectionNode.Inst.defineAttribute('$alreadyTransforming');

TP.dom.CollectionNode.Inst.defineAttribute('preppedReps');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Type.defineMethod('refreshInstances',
function(aDocument) {

    /**
     * @method refreshInstances
     * @summary Refreshes instances on the supplied Document or the current
     *     uicanvas if aDocument isn't supplied.
     * @description This method attempts to obtain the node as it was originally
     *     authored, reprocess and re-awaken it.
     * @param {Document} aDocument The native document containing instances of
     *     this node to refresh instances of. This defaults to the document of
     *     the current uicanvas.
     * @returns {TP.meta.dom.CollectionNode} The receiver.
     */

    var originals,

        cssQuery,

        allInstances,

        world,
        screenDocs,

        canvasDoc;

    //  Grab our 'originals' registry. This is where we store clones of the
    //  original node.
    if (!TP.isValid(originals = this.get('originals'))) {
        return this;
    }

    //  If the Lama is loaded, we turn *off* processing of DOM mutations so
    //  that changes to recasting elements below will not propagate into source
    //  documents.
    if (TP.sys.hasFeature('lama')) {
        TP.bySystemId('Lama').set('shouldProcessDOMMutations', false);
    }

    //  Compute the CSS query path, indicating that we want a path that will
    //  find both 'deep elements' (i.e. elements even under other elements of
    //  this same type) and processed representations of this element.
    cssQuery = this.getQueryPath(true, true);

    allInstances = TP.ac();

    //  Get the Lama world (if we're running the Lama).
    world = TP.byId('LamaWorld', TP.sys.getUIRoot());

    //  If we have a valid Lama world, then scan its documents for instances.
    if (TP.isValid(world)) {
        //  Get all of the world's documents
        screenDocs = world.getScreenDocuments();

        //  Go through each document in the world and query it for elements that
        //  match the instance we're replacing.
        screenDocs.forEach(
            function(aTPDoc) {
                var docInstances;

                //  Find any instances that are currently drawn on the document.
                docInstances = TP.byCSSPath(cssQuery, aTPDoc.getNativeNode());

                allInstances = allInstances.concat(docInstances);
            });
    } else {
        //  Otherwise, go to the UI canvas and scan it.
        canvasDoc = TP.sys.getUICanvas();
        allInstances = TP.byCSSPath(cssQuery, canvasDoc.getNativeNode());
    }

    if (TP.isEmpty(allInstances)) {
        return this;
    }

    //  Iterate over the instances that were found.
    allInstances.forEach(
        function(aTPElem) {

            var authoredElem,
                gid,
                recastTPDoc,
                handler;

            //  Grab the originally authored representation of the node.
            authoredElem = originals.at(aTPElem.getLocalID());

            if (TP.isNode(authoredElem)) {
                authoredElem = TP.nodeCloneNode(authoredElem);

                //  Note here how we set the 'tibet:recasting' attribute to let
                //  the system know that we're recasting the current, in place,
                //  element. This flag will be removed by the 'mutation added'
                //  method.

                gid = aTPElem.getID();

                //  Signal that we're going to recast the node.
                TP.signal(null,
                            'TP.sig.NodeWillRecast',
                            TP.hc('recastTarget', aTPElem));

                //  This is all being done in a Function that executes after the
                //  next repaint, so that any GUI updating that happens as part
                //  of the NodeWillRecast signal can be rendered.
                (function() {

                    var autodefineMissingTags,
                        oldNode,
                        oldNodeClone,

                        newNode,
                        newNodeClone,

                        oldParentNode;

                    //  The new content may have a tag that we don't know
                    //  about. Therefore we force the system to autodefine
                    //  missing tags here.
                    autodefineMissingTags =
                        TP.sys.cfg('lama.autodefine_missing_tags');
                    TP.sys.setcfg('lama.autodefine_missing_tags', true);

                    //  Grab both the old and new nodes being transformed,
                    //  clone them and clean them. This provides the best
                    //  canonical comparison below when we check them for
                    //  equality.

                    oldNode = aTPElem.getNativeNode();
                    oldNodeClone = TP.nodeCloneNode(oldNode);
                    TP.elementClean(oldNodeClone);

                    newNode = authoredElem;
                    newNodeClone = TP.nodeCloneNode(newNode);
                    TP.elementClean(newNodeClone);

                    oldParentNode = oldNode.parentNode;

                    //  process the content, supplying the authored node as the
                    //  'alternate element' to process. This is the core of
                    //  'recasting'. Note that awaken will happen via the core
                    //  TIBET Mutation Observer when the new node is attached to
                    //  the DOM. It will send a MutationAttach signal that we
                    //  install a handler for below.

                    //  We're getting ready to some recasting. Flip the
                    //  type-level flag on. This is used by some types to manage
                    //  things like caches of markup.
                    TP.dom.CollectionNode.$set('$isRecasting', true);

                    aTPElem.setAttribute('tibet:recasting', true);
                    aTPElem.compile(null, true, authoredElem);

                    //  Put the autodefine setting back to what it was.
                    TP.sys.setcfg('lama.autodefine_missing_tags',
                                    autodefineMissingTags);

                    //  The native node might have changed under the covers
                    //  during compilation, so we need to set the attribute
                    //  again.
                    aTPElem.setAttribute('tibet:recasting', true);

                    recastTPDoc = TP.tpdoc(aTPElem);

                    //  Install a handler looking for a MutationAttach signal
                    //  that will have the global ID for the element being
                    //  recast.
                    handler = function(aSignal) {

                        var recastTPElem;

                        //  If one of the mutated nodes was our recast Element
                        //  then the GIDs will be the same (but its a 'new
                        //  element' insofar as the DOM is concerned, so we
                        //  can't use '===' comparing).
                        if (aSignal.at('mutatedNodeIDs').contains(gid)) {

                            //  Make sure to uninstall the handler.
                            handler.ignore(recastTPDoc,
                                            'TP.sig.MutationAttach');

                            //  Grab the wrapped element by using the GID to get
                            //  a reference back to it.
                            recastTPElem = TP.bySystemId(gid);

                            //  Refresh any data bindings that are a part of or
                            //  are under the recast element.
                            recastTPElem.refresh();

                            //  If the two nodes, old and new, are not equal,
                            //  then update the source document, replacing one
                            //  with the other.
                            if (!TP.nodeEqualsNode(
                                    oldNodeClone, newNodeClone)) {

                                if (TP.sys.hasFeature('lama')) {
                                    TP.bySystemId('Lama').
                                        updateUICanvasSource(
                                            TP.ac(oldNode),
                                            oldParentNode,
                                            TP.UPDATE,
                                            null,
                                            null,
                                            null,
                                            false,
                                            newNode);
                                }
                            }

                            //  Signal that we did recast the node.
                            TP.signal(null,
                                        'TP.sig.NodeDidRecast',
                                        TP.hc('recastTarget',
                                                recastTPElem));
                        }

                        //  We're done recasting. Flip the type-level flag off.
                        TP.dom.CollectionNode.$set('$isRecasting', false);
                    };

                    //  Set up the MutationAttach observation on the original
                    //  Element's Document. This will stay the same throughout
                    //  the recasting process, so we're safe to do that.
                    handler.observe(recastTPDoc, 'TP.sig.MutationAttach');
                }).queueAfterNextRepaint(TP.nodeGetWindow(authoredElem));
            }
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Type.defineMethod('$shouldAddToOriginals',
function(sourceNode, mutatedNode, targetNode) {

    /**
     * @method $shouldAddToOriginals
     * @summary Whether or not the receiver should add a node that is being
     *     processed to its set of 'originals' - that is, nodes that need to be
     *     updated if the receiver's computation/templating output changes.
     * @param {Node} sourceNode A clone of the original node that is
     *     representing the receiver before 'computation'/'transformation. The
     *     original version of this node is what will be added to the set of
     *     originals.
     * @param {Node} mutatedNode The original node after having been mutated by
     *     computation/transformation.
     * @param {Node} targetNode The target element that the receiver is a part
     *     of. This is useful when needing information about the visual surface
     *     that the currently processing element will be drawn into.
     * @returns {Boolean} Whether or not to add the node to the receiver's set
     *     of 'originals'. The default is false.
     */

    return false;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Type.defineMethod('$tagCompileAndRegister',
function(aRequest) {

    /**
     * @method $tagCompileAndRegister
     * @summary A private method that is used by the tag processing system to
     *      store off a copy of the original collection node if the system is
     *      configured to do. It then calls the authored 'tagCompile' method.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     * @returns {Element} The new element.
     */

    var elem,
        elemClone,

        result,

        targetElem,

        originals,
        localID;

    elem = aRequest.at('node');

    //  Make sure that we can invoke 'tagCompile' on ourself - if not, just
    //  exit.
    if (!TP.canInvoke(this, 'tagCompile')) {
        return elem;
    }

    //  Clone the original element for comparison purposes below. This avoids
    //  issues with the node equality routine and Text nodes under original
    //  Element. If all that changes is a single Text node under the original
    //  Element, then elem and result will still be considered equal because the
    //  change will now be present in *both* of them (changing the Text node's
    //  value by processing it will change it in both because it's just the
    //  '.nodeValue' that's being updated).
    elemClone = TP.nodeCloneNode(elem);

    result = this.tagCompile(aRequest);

    //  We didn't get a valid Node or Array back - log an Error
    if (!TP.isNode(result) && !TP.isArray(result)) {
        TP.ifError() ?
            TP.error(
                this.getTypeName() +
                ' compile returned invalid replacement for: ' +
                TP.str(elem)) : 0;
    }

    //  The target element that the receiver is a part of. This is useful when
    //  needing information about the visual surface that the currently
    //  compiling element will be drawn into.
    targetElem = TP.unwrap(aRequest.at('target'));

    //  If we got a collection node back and we should add the element to our
    //  set of 'originals', register a reference to a clone of the
    //  original element (if the 'content.retain_originals' cfg flag is on).
    if (TP.isCollectionNode(result) &&
        this.$shouldAddToOriginals(elemClone, result, targetElem)) {

        if (TP.sys.cfg('content.retain_originals')) {

            //  Make sure to create the type-level (each type - not shared)
            //  originals registry. This will hold clones of the original nodes
            //  shared by type.
            originals = this.get('originals');
            if (!TP.isValid(originals)) {
                originals = TP.hc();
                this.set('originals', originals, false);
            } else {
                //  If we had an originals registry, check to make sure that it
                //  doesn't already have the local id of the element in it. If
                //  it does, just return. Note how we pass 'false' to *not*
                //  assign an ID.
                localID = TP.elementGetAttribute(elem, 'id', true);
                if (originals.hasKey(localID)) {

                    //  Make sure to set the result's ID here - this will link
                    //  the result to the original element for future
                    //  replacement.
                    TP.elementSetAttribute(result, 'id', localID, true);
                    return result;
                }
            }

            //  If the result defined an ID, then we use that - note how we pass
            //  'false' to *not* assign an ID.
            localID = TP.elementGetAttribute(result, 'id', true);

            if (TP.isEmpty(localID)) {
                //  The result didn't have an ID - compute one. This will be our
                //  key into the registry.
                localID = TP.lid(elem, true);
            } else {
                //  The result had an ID - we need to make sure that original
                //  elem has a matching one.
                TP.elementSetAttribute(elem, 'id', localID, true);
            }

            //  If the registry doesn't have it, then register the original.
            //  Note that this is one-time only so that we don't overwrite what
            //  the author originally intended with subsequent renderings.
            if (!originals.hasKey(localID)) {
                originals.atPut(localID, TP.nodeCloneNode(elem));
            }

            //  Make sure to *always* set the ID on the result - this is
            //  important so that we can find the copy in the registry more than
            //  once.
            TP.elementSetAttribute(result, 'id', localID, true);
        }
    } else if (TP.isArray(result)) {
        //  TODO: We don't currently handle setting the original element on an
        //  Array of returned elements - might not be possible.
    }

    return result;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('addTIBETSrc',
function(aURI, force) {

    /**
     * @method addTIBETSrc
     * @summary Adds a TP.SRC_LOCATION value to the ownerDocument of the
     *     receiver (or the receiver itself, if its the Document). This method
     *     is normally invoked when the Node is "owned" by a URI to ensure
     *     proper ID generation can occur.
     * @param {TP.uri.URI|String} aURI An optional URI value. If not provided
     *     then the receiver's uri is used.
     * @param {Boolean} force True to force setting the value even if the node
     *     already has one. Default is false.
     * @returns {TP.dom.Node} The receiver.
     */

    var node,
        url;

    node = TP.nodeGetDocument(this.getNativeNode());

    url = aURI || this.get('uri');
    if (TP.notValid(url)) {
        return this;
    }

    if (TP.isKindOf(url, TP.uri.URI)) {
        url = url.getLocation();
    }

    TP.documentSetLocation(node, url, force);

    //  NB: We don't signal change here because when we have a URI with this
    //  node as it's primary resource, signaling change from it's resource node
    //  causes 'handleChange' to fire, which then tries to obtain the primary
    //  resource which then loops back around to this method, setting up a
    //  recursion.

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('addXMLBase',
function(aURI, force, aParamHash) {

    /**
     * @method addXMLBase
     * @summary Adds an XML Base value to the documentElement of the receiver.
     *     This method is normally invoked when the Node is "owned" by a URI to
     *     ensure proper base-aware attribute computation can occur. If the
     *     receiver's document already has xml:base definition on the
     *     documentElement this method will return without altering the content.
     * @param {TP.uri.URI|String} aURI An optional URI value. If not provided
     *     then the receiver's uri is used.
     * @param {Boolean} force True to force setting the value even if the node
     *     already has one. Default is false.
     * @param {TP.core.Hash|TP.sig.Request} aParamHash A set of key/value pairs
     *     which should be used to control the transformation. If the 'aURI'
     *     value is null and a 'uri' slot is defined on this object, that
     *     object's String value will be used as the XML Base value.
     * @returns {TP.dom.Node} The receiver.
     */

    var url,
        node,
        doc;

    node = this.getNativeNode();

    //  if we've already got an xml:base reference we can exit
    if (this.hasXMLBase()) {
        return this;
    }

    url = aURI || this.get('uri');

    //  If a specific URL wasn't supplied, check to see if a parameter hash
    //  was supplied.
    if (TP.notValid(url)) {
        if (TP.isValid(aParamHash)) {
            //  Check to see if the parameter hash has a 'uri' value.

            //  NOTE the key here which is required to get proper relative
            //  path resolution
            url = aParamHash.at('uri');
            if (TP.isURIString(url) || TP.isURI(url)) {
                //  The 'uri' slot in the param hash sometimes contains a
                //  TP.uri.URI instance... make sure its a String.
                url = url.asString();
            } else {
                url = '~app_xmlbase';
            }
        } else {
            url = '~app_xmlbase';
        }
    }

    if (TP.isDocument(node)) {
        node = node.documentElement;
    }

    //  if we're going to add one we want to add it to the documentElement
    //  of the enclosing document
    doc = TP.nodeGetDocument(node);
    if (TP.isEmpty(doc)) {
        return this;
    }

    node = doc.documentElement;
    if (!TP.isElement(node)) {
        return this;
    }

    //  If its already got one, bail out here.
    if (TP.elementHasAttribute(node, 'xml:base', true) && TP.notTrue(force)) {
        return this;
    }

    //  need to rewrite and fully expand these so they're a true reflection
    //  of where this file was loaded from. Note that we only do this if the
    //  url is absolute
    if (TP.uriIsAbsolute(url.getLocation())) {
        url = TP.uri.URI.rewrite(url).getLocation();
    }

    //  we may need to reset the value for things like cache file nodes, so
    //  don't bother checking for existing values here.
    TP.elementSetAttributeInNS(
                            node,
                            'xml:base',
                            TP.uriCollectionPath(url) + '/',
                            TP.w3.Xmlns.XML);

    this.changed('@xml:base', TP.CREATE);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('computeAbsoluteURIFromValue',
function(aValue) {

    /**
     * @method computeAbsoluteURIFromAttribute
     * @summary Returns the value of the supplied URI value which is expected
     *      to contain a URI joined with the value of the receiver's 'XML Base'
     *      value or it's document's 'baseURI'.
     * @param {String} aValue The URI to use as the relative path.
     * @returns {String} The supplied URI value as joined to the receiver's XML
     *      Base value or its document's base URI.
     */

    var node,
        baseURI,
        pathURI,
        val,

        retVal;

    if (TP.isEmpty(val = aValue)) {
        return '';
    }

    node = this.getNativeNode();

    if (TP.isDocument(node)) {
        baseURI = node.baseURI;
        node = node.documentElement;
    } else {
        baseURI = node.ownerDocument.baseURI;
    }

    if (!TP.isURIString(pathURI = TP.elementComputeXMLBaseFrom(node))) {
        pathURI = baseURI;
    }

    if (TP.isURI(pathURI) && TP.isURI(val)) {
        retVal = TP.uriJoinPaths(TP.uriCollectionPath(pathURI), val);
    }

    return retVal;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getContent',
function(aRequest) {

    /**
     * @method getContent
     * @summary Returns the receiver's content.
     * @description At this level, this method returns its 'inner content',
     *     which is basically all of its child nodes serialized as a document
     *     fragment.
     * @param {TP.sig.Request|TP.core.Hash} aRequest Optional control
     *     parameters.
     * @returns {String} The text content of the native node.
     */

    var nativeNode,
        frag;

    nativeNode = this.getNativeNode();

    if (nativeNode.childNodes.length === 1) {
        if (TP.isTextNode(nativeNode.firstChild)) {
            return this.getTextContent();
        }

        return TP.wrap(nativeNode.firstChild).asString();
    }

    //  Note here that we're only interested in the shallow '.childNodes'
    //  collection. Note also that we allow this routine to default the
    //  document, but force it to make a copy of the fragment - otherwise, we'll
    //  lose the content.
    if (!TP.isFragment(frag = TP.nodeListAsFragment(
                                        nativeNode.childNodes, null, true))) {
        return '';
    }

    return TP.wrap(frag).asString();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getContentNode',
function(aRequest) {

    /**
     * @method getContentNode
     * @summary Returns the receiver's content node(s). This method is provided
     *     for API compatibility with other types.
     * @description At this level, this method returns its 'inner content' node,
     *     which is either a TP.dom.Node, if there's only one child or a
     *     TP.dom.DocumentFragment, if there is more than one. NOTE: If a
     *     TP.dom.DocumentFragment is returned, it contains a *clone* of the
     *     child nodes, not the originals.
     * @param {TP.sig.Request|TP.core.Hash} aRequest Optional control
     *     parameters.
     * @returns {TP.dom.Node|TP.dom.DocumentFragment} The only child node or a
     *     TP.dom.DocumentFragment containing a *clone* of all child nodes.
     */

    var nativeNode,
        frag;

    nativeNode = this.getNativeNode();

    if (nativeNode.childNodes.length === 1) {
        return TP.wrap(nativeNode.firstChild);
    }

    //  Note here that we're only interested in the shallow '.childNodes'
    //  collection. Note also that we allow this routine to default the
    //  document, but force it to make a copy of the fragment - otherwise, we'll
    //  lose the content.
    if (!TP.isFragment(frag = TP.nodeListAsFragment(
                                        nativeNode.childNodes, null, true))) {
        return null;
    }

    return TP.wrap(frag);
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getIndexInParent',
function() {

    /**
     * @method getIndexInParent
     * @summary Returns the index of the node in its parentNode's childNodes
     *     array. If there is no parentNode for the node this method returns
     *     TP.NOT_FOUND.
     * @returns {Number} The index number, or TP.NOT_FOUND.
     */

    return TP.nodeGetIndexInParent(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getValue',
function() {

    /**
     * @method getValue
     * @summary Returns the value of the receiver. Unless overridden by a
     *     custom subtype this method will return the text value of the
     *     receiving node.
     * @returns {String} The value in string form.
     */

    return this.getContent();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('hasXMLBase',
function() {

    /**
     * @method hasXMLBase
     * @summary Returns true if xml:base references are found on or above the
     *     receiver.
     * @returns {Boolean} Whether an xml:base reference was found on or above
     *     the receiver.
     */

    var node;

    node = this.getNativeNode();

    if (TP.isDocument(node)) {
        node = node.documentElement;
    }

    if (TP.notEmpty(TP.elementGetAttribute(node, 'xml:base', true))) {
        return true;
    }

    while (TP.isElement(node = node.parentNode)) {
        if (TP.notEmpty(TP.elementGetAttribute(node, 'xml:base', true))) {
            return true;
        }
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('setNativeNode',
function(aNode, shouldSignal) {

    /**
     * @method setNativeNode
     * @summary Sets the receiver's native DOM node object.
     * @param {Node} aNode The node to wrap.
     * @param {Boolean} shouldSignal If false this operation will not trigger a
     *     change notification. This defaults to the return value of sending
     *     shouldSignalChange() to the receiver.
     * @exception TP.sig.InvalidNode
     * @returns {TP.dom.Node} The receiver.
     */

    var nodes,
        ndx,

        elem,
        phase,
        doc,
        flag;

    if (!TP.isNode(aNode)) {
        return this.raise('TP.sig.InvalidNode', aNode);
    }

    //  what we do here varies by whether we're checkpointing or not...
    if (TP.isArray(nodes = this.get('nodes'))) {
        ndx = this.get('currentIndex');
        if (TP.isNumber(ndx)) {
            //  working in the middle of the list, have to truncate
            nodes.length = ndx;
            nodes.add(aNode);

            //  clear the index since we're basically defining the end of
            //  the list now
            this.$set('currentIndex', null, false);
        } else {
            nodes.atPut(nodes.getSize() - 1, aNode);
        }
    } else {
        this.$set('node', aNode, false);
    }

    //  update our processing phase to match that of our node (or it's
    //  enclosing document)
    if (TP.isDocument(aNode)) {
        if (TP.isElement(elem = aNode.documentElement)) {
            phase = TP.elementGetAttribute(elem, 'tibet:phase', true);
        }
    } else if (TP.isElement(aNode)) {
        if (TP.isDocument(doc = TP.nodeGetDocument(aNode))) {
            if (TP.isElement(elem = doc.documentElement)) {
                phase = TP.elementGetAttribute(elem, 'tibet:phase', true);
            }
        }

        if (TP.isEmpty(phase)) {
            phase = TP.elementGetAttribute(aNode, 'tibet:phase', true);
        }
    }

    //  default phase is unprocessed so we reset properly on new content
    phase = TP.ifEmpty(phase, 'UNPROCESSED');

    //  if we're setting a new node for any phase prior to finalized then
    //  our prepped cache is invalid (it's caching data from a phase this
    //  node hasn't reached yet)
    if (phase !== 'Finalize') {
        this.$set('preppedReps', null, false);
    }

    //  skip any wrapper method so we don't reset on the native element
    this.$set('phase', phase, false);

    //  NB: Use this construct this way for better performance
    if (TP.notValid(flag = shouldSignal)) {
        flag = this.shouldSignalChange();
    }

    if (flag) {
        this.$changed('content', TP.UPDATE);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('serializeForStorage',
function(storageInfo) {

    /**
     * @method serializeForStorage
     * @summary Serialize the receiver in a manner appropriate for storage.
     * @description This method provides a serialized representation of the
     *     receiver that can be used to store it in a persistent storage. The
     *     supplied storageInfo hash should contain a storage key under the
     *     'store' key that will be used to uniquely identify the content
     *     produced for this receiver. Note that nested nodes might produce
     *     their own 'serialization stores'. All of the stores can be found
     *     under the 'stores' key in the storageInfo after the serialization
     *     process is complete.
     *     For this type, serialization means writing an opening tag for the
     *     element by calling 'serializeOpenTag', then whatever non-Element
     *     content (i.e. text nodes, comment nodes, etc) and then the closing
     *     tag for the element by calling 'serializeCloseTag'.
     * @param {TP.core.Hash} storageInfo A hash containing various flags for and
     *     results of the serialization process. Notable keys include:
     *          'wantsXMLDeclaration': Whether or not the receiver's document
     *          node should include an 'XML declaration' at the start of its
     *          serialization. The default is false.
     *          'wantsPrefixedXMLNSAttrs': Whether or not the receiver and its
     *          decendant elements should generate prefixed (i.e. 'xmlns:foo')
     *          attributes to support their proper serialization. The default is
     *          true.
     *          'result': The current serialization result as it's being built
     *          up.
     *          'store': The key under which the current serialization result
     *          will be stored.
     *          'stores': A hash of 1...n serialization results that were
     *          generated during the serialization process. Note that nested
     *          nodes might generated results that will go into different
     *          stores, and so they will all be stored here, each keyed by a
     *          unique key (which, by convention, will be the URI they should be
     *          saved to).
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    var node,

        storeKey,
        stores,

        result;

    node = this.getNativeNode();

    if (TP.isDocument(node)) {
        node = node.documentElement;
    }

    //  Make sure that we have a result that we can concatentate results to.
    storageInfo.atPutIfAbsent('result', TP.ac());

    //  NB: We do *NOT* capture the above 'result' into a closured local
    //  variable and use it below, because steps in the processing process might
    //  decide to clear out the results and we need to respect that.

    //  Traverse in a depth-wise manner, starting at the receiver's native node.
    TP.nodeDepthTraversal(
        node,
        function(anElem) {

            //  This function gets called when the start tag of an element is
            //  encountered.

            var tpElem,
                serializationResult;

            //  Wrap the element and serialize its open tag.
            tpElem = TP.wrap(anElem);
            serializationResult = tpElem.serializeOpenTag(storageInfo);

            //  If we got a String back, there are no special control constants
            //  (i.e. TP.CONTINUE, TP.DESCEND or TP.BREAK), so we just push the
            //  result and continue with the 'default' behavior (which will be
            //  to descend if the receiver has child nodes)
            if (TP.isString(serializationResult)) {
                storageInfo.at('result').push(serializationResult);
                return;
            } else if (TP.isArray(serializationResult)) {

                //  Otherwise, if we got an Array, that means that the result
                //  will be in the first position and should be pushed onto the
                //  results and the special control constant is in the second
                //  position and should be returned.
                storageInfo.at('result').push(serializationResult.first());
                return serializationResult.last();
            } else {

                //  Otherwise, all we got back was a special control constant.
                return serializationResult;
            }
        },
        function(anElem) {

            //  This function gets called when the end tag of an element is
            //  encountered.

            var tpElem,
                serializationResult;

            //  Wrap the element and serialize its close tag.
            tpElem = TP.wrap(anElem);
            serializationResult = tpElem.serializeCloseTag(storageInfo);

            //  This behavior is the same as for the opening tag - see the
            //  Function above.

            if (TP.isString(serializationResult)) {
                storageInfo.at('result').push(serializationResult);
                return;
            } else if (TP.isArray(serializationResult)) {
                storageInfo.at('result').push(serializationResult.first());
                return serializationResult.last();
            } else {
                return serializationResult;
            }
        },
        function(nonElementNode) {
            var str;

            //  This function gets called when non-element content (i.e. comment
            //  nodes, other text nodes, etc.) of an element is encountered.
            str = TP.wrap(nonElementNode).serializeNonTag(storageInfo);
            storageInfo.at('result').push(str);
        }
    );

    //  Join together the result Array and convert any HTML entities to their
    //  XML equivalent. This causes replacements such as any HTML '&nbsp;'s
    //  with the XML-compliant '&#160;'s.
    result = TP.htmlEntitiesToXMLEntities(storageInfo.at('result').join(''));

    //  Grab the current store key and put the result into the overall 'stores'
    //  hash (creating it if it doesn't exist).
    storeKey = storageInfo.at('store');

    if (TP.isValid(storeKey)) {
        stores = storageInfo.atPutIfAbsent('stores', TP.hc());
        stores.atPut(storeKey, result);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('transform',
function(anObject, aParamHash) {

    /**
     * @method transform
     * @summary Transforms the supplied Node (or TP.dom.Node) by using the
     *     content of the receiver.
     * @param {Object} anObject The object supplying the data to use in the
     *     transformation.
     * @param {TP.core.Hash|TP.sig.Request} aParamHash A parameter container
     *     responding to at(). For string transformations a key of 'repeat' with
     *     a value of true will cause iteration to occur (if anObject is an
     *     'ordered collection' this flag needs to be set to 'true' in order to
     *     have 'automatic' iteration occur). Additional keys of '$STARTINDEX'
     *     and '$REPEATCOUNT' determine the range of the iteration. A special
     *     key of 'xmlns:fixup' should be set to true to fix up 'xmlns'
     *     attributes such that they won't be lost during the transformation.
     * @returns {String} The string resulting from the transformation process.
     */

    var templateName,
        templateFunc,

        resultStr,
        resultNode,
        resultTPNode,

        str,
        urn;

    if (TP.notEmpty(templateName = this.getTemplateName())) {

        //  NB: This should be a URN, therefore we assume 'async' of false here.
        templateFunc = TP.uc(templateName).getResource().get('result');
        if (TP.isCallable(templateFunc)) {
            //  Run the transform Function
            resultStr = templateFunc.transform(anObject, aParamHash);
/*
            //  Strip out any 'attr="null"' attributes - existence of null
            //  attributes can cause unintended consequences.
            TP.regex.XML_ATTR_CONTAINING_NULL.lastIndex = 0;
            resultStr = resultStr.strip(TP.regex.XML_ATTR_CONTAINING_NULL);
*/
            //  Now, we need to make sure that any constructs that were
            //  generated into the result that need tag processing are
            //  processed.

            //  Try to create a real Node from the supplied content (passing
            //  'true' to TP.nodeAsString() so that it will report parsing
            //  errors). If we can't parse a valid Node from the content, we
            //  just return the String.
            if (TP.isElement(
                    resultNode = TP.nodeFromString(resultStr, null, true)) &&
                TP.notTrue(this.get('$alreadyTransforming'))) {

                this.set('$alreadyTransforming', true, false);
                resultTPNode = TP.wrap(resultNode);
                resultTPNode.compile();
                this.set('$alreadyTransforming', false, false);

                return resultTPNode.asString();
            } else {
                return resultStr;
            }
        }
    }

    //  Turn ourself into a String and continue.
    str = this.asString();

    //  We want a compiled Function so we go ahead and compile a Function
    //  off of our String representation, but don't register the Function as
    //  the template.
    if (TP.notEmpty(str) &&
        TP.isCallable(templateFunc = str.compile(null, true, false))) {

        //  Create a template name per tsh:template model.
        //  TODO:   convert genID into a "hash code" for uniquing.
        templateName = 'template_' + TP.genID();
        this.setAttribute('tsh:template', templateName);

        //  Store the function in the URN for later lookup.
        urn = TP.TIBET_URN_PREFIX + templateName;
        TP.uc(urn).setResource(templateFunc);
    }

    if (TP.isCallable(templateFunc)) {
        //  Run the transform Function
        resultStr = templateFunc.transform(anObject, aParamHash);
/*
        //  Strip out any 'attr="null"' attributes - existence of null
        //  attributes can cause unintended consequences.
        TP.regex.XML_ATTR_CONTAINING_NULL.lastIndex = 0;
        resultStr = resultStr.strip(TP.regex.XML_ATTR_CONTAINING_NULL);
*/
        //  Now, we need to make sure that any constructs that were generated
        //  into the result that need tag processing are processed.

        //  Try to create a real Node from the supplied content (passing 'true'
        //  to TP.nodeAsString() so that it will report parsing errors). If we
        //  can't parse a valid Node from the content, we just return the
        //  String.
        if (TP.isElement(
                resultNode = TP.nodeFromString(resultStr, null, true)) &&
            TP.notTrue(this.get('$alreadyTransforming'))) {

            this.set('$alreadyTransforming', true, false);
            resultTPNode = TP.wrap(resultNode);
            resultTPNode.compile();
            this.set('$alreadyTransforming', false, false);

            return resultTPNode.asString();
        } else {
            return resultStr;
        }
    }

    //  Didn't have a template function and couldn't build one either.
    return this.raise('TP.sig.InvalidFunction');
});

//  ------------------------------------------------------------------------
//  NODE MODIFICATION
//  ------------------------------------------------------------------------

/*
Operations supporting common Node transformations. You can also use a
selection operation such as getChildNodes() followed by a perform() or
similar iteration operation to operate on node content.
*/

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('addContent',
function(newContent, aRequest, stdinContent) {

    /**
     * @method addContent
     * @summary Adds (appends) new content to the receiver, processing it first
     *     for any tag transformations, interpolations, etc.
     * @param {Object} newContent The content to write into the receiver. This
     *     can be a String, a Node, or an Object capable of being converted into
     *     one of those forms.
     * @param {TP.sig.Request} aRequest An optional request object which defines
     *     further parameters.
     * @param {Object} stdinContent Content to set as the 'stdin' when executing
     *     the supplied content. Note that if this parameter is supplied, the
     *     content is 'executed', as well as processed, by the shell.
     * @returns {TP.dom.Node|undefined} The result of adding content to the
     *     receiver. If a DocumentFragment was supplied in newContent, this
     *     return value will the *first* DOM node that was added.
     */

    var request,
        resp,
        content,
        nativeContent;

    if (TP.notValid(newContent) || newContent === '') {
        return;
    }

    request = TP.request(aRequest);
    request.atPutIfAbsent('targetPhase', this.getTargetPhase());

    //  If the content to be set is a URI, then track it via the 'uri'
    //  property on the request. This helps downstream routines check to see if
    //  the content changes are URI/document level.
    if (TP.isURIString(newContent)) {
        request.atPutIfAbsent('uri', newContent);
    }

    //  Put ourself into the 'target' slot, so that the content pipeline has
    //  the target 'surface' that its processing for available to it.
    request.atPut('target', this);

    //  For now, anyway, processing the content needs to be synchronous.
    request.atPut('async', false);

    //  Content drawn from here will be awakened when the nodes are placed into
    //  a visible DOM, so we don't awaken them here.
    request.atPutIfAbsent('awaken', false);

    //  If stdin content was supplied, execute the content as well as process
    //  it.
    if (TP.notEmpty(stdinContent)) {
        resp = TP.processAndExecuteWith(newContent,
                                        request,
                                        stdinContent);
    } else {
        resp = TP.process(newContent, request);
    }

    if (request.didFail()) {
        return;
    }

    content = resp.get('result');

    //  Unwrap the content and, if it's an Element, check to see if its a
    //  'tibet_root' element (note that this element might have a default
    //  namespace defined that was used to qualify the markup handed in - we
    //  can't rely on that namespace). This means that the DOM parsing code
    //  detected a DocumentFragment as the result DOM node and handed us back
    //  the actual root node it used to parse the content.
    //  In this case, we extract the child nodes of the content out as a
    //  fragment and use that to set our content.
    nativeContent = TP.unwrap(content);
    if (TP.isElement(nativeContent)) {
        if (TP.elementGetLocalName(nativeContent) === 'tibet_root') {
            content = TP.nodeListAsFragment(nativeContent.childNodes);
        }
    }

    //  Note that if content was a DocumentFragment here, this call will return
    //  the *first* DOM node that was added.
    return this.addRawContent(content, request);
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('addRawContent',
function(newContent, aRequest, shouldSignal) {

    /**
     * @method addRawContent
     * @summary Adds new content to the receiver without performing any content
     *     processing on it.
     * @param {Object} newContent The content to write into the receiver. This
     *     can be a String, a Node, or an Object capable of being converted into
     *     one of those forms.
     * @param {TP.sig.Request} aRequest An optional request object which defines
     *     further parameters.
     * @param {Boolean} shouldSignal If false this operation will not trigger a
     *     change notification. This defaults to true.
     * @returns {TP.dom.Node|undefined} The result of adding content to the
     *     receiver. If a DocumentFragment was supplied in newContent, this
     *     return value will the *first* DOM node that was added.
     */

    var node,

        content,
        request,

        arrContent,

        func,
        thisref,

        reqLoadFunc,
        loadFunc,

        result;

    node = this.getNativeNode();

    if (TP.notValid(newContent) || newContent === '') {
        return;
    }

    request = TP.request(aRequest);
    content = TP.unwrap(newContent);

    if (!TP.isKindOf(content, Node) && !TP.isString(content)) {

        //  If the content is an Array, then we want the individual
        //  '.asString()' representations of each item - not what Array gives
        //  us.
        if (TP.isArray(arrContent = content)) {
            content = '';
            arrContent.perform(
                    function(item) {
                        content += TP.str(item);
                    });
        } else {
            content = TP.str(content);
        }
    }

    func = this.getContentPrimitive(TP.APPEND);
    thisref = this;

    if (TP.isCallable(reqLoadFunc = request.at(TP.ONLOAD))) {
        loadFunc =
            function(targetNode, newNode) {

                reqLoadFunc(targetNode, newNode);

                if (TP.notFalse(shouldSignal)) {
                    thisref.changed('content', TP.APPEND);
                }
            };
    } else {
        loadFunc =
            function(targetNode, newNode) {

                thisref.contentAppendCallback(targetNode);

                if (TP.notFalse(shouldSignal)) {
                    thisref.changed('content', TP.APPEND);
                }
            };
    }

    result = func(node,
                    content,
                    loadFunc,
                    TP.ifKeyInvalid(request, 'awaken', false));

    //  If we're an Element and we're flagging changes, go ahead and do that
    //  now.
    if (TP.isElement(node) && this.shouldFlagChanges()) {
        TP.elementFlagChange(node, TP.SELF, TP.APPEND);

        TP.ifTrace() && TP.$DEBUG ?
            TP.trace('Node flagged: ' + TP.nodeAsString(node)) : 0;
    }

    //  The primitive will have returned a native Node, but we need to
    //  return a TP.dom.Node.
    return TP.wrap(result);
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('clearTextContent',
function() {

    /**
     * @method clearTextContent
     * @summary Clears out the text content of any text nodes under the
     *     receiver, thereby clearing all of the text and leaving just the node
     *     structure.
     * @description This method works by setting each text node to the empty
     *     String.
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    var node,
        descendantTextNodes;

    node = this.getNativeNode();

    //  First, we make sure to normalize to reduce the number of total text
    //  nodes.
    TP.nodeNormalize(node);

    //  Grab all of the descendant text nodes and empty their textContent.
    descendantTextNodes = TP.nodeGetDescendantsByType(node, Node.TEXT_NODE);
    descendantTextNodes.perform(
            function(aTextNode) {
                aTextNode.textContent = '';
            });

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('contentAppendCallback',
function(aNode) {

    /**
     * @method contentAppendCallback
     * @summary This method is the standard 'content append' callback when
     *     addRawContent() method is called.
     * @param {Node} aNode The node that content has been appended to. Unless
     *     this node has been altered by the method that is appending the
     *     content, this should be the same as the receiver's native node.
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('contentInsertCallback',
function(aNode) {

    /**
     * @method contentInsertCallback
     * @summary This method is the standard 'content insert' callback when
     *     insertRawContent() method is called.
     * @param {Node} aNode The node that content has been inserted into. Unless
     *     this node has been altered by the method that is inserting the
     *     content, this should be the same as the receiver's native node.
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('contentReplaceCallback',
function(aNode) {

    /**
     * @method contentReplaceCallback
     * @summary This method is the standard 'content replace' callback when
     *     setRawContent() method is called.
     * @param {Node} aNode The node that content has been replaced for. Unless
     *     this node has been altered by the method that is replacing the
     *     content, this should be the same as the receiver's native node.
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getContentPrimitive',
function(operation) {

    /**
     * @method getContentPrimitive
     * @summary Returns the primitive function used to perform the operation
     *     specified. For example, an operation of TP.APPEND might return the
     *     TP.nodeAddContent primitive or a related function specific to the
     *     type of node being modified.
     * @param {String} operation A constant defining the operation. Valid values
     *     include: TP.APPEND TP.INSERT TP.UPDATE.
     * @exception TP.sig.InvalidOperation When the operation isn't a valid one.
     * @returns {Function|undefined} A TP primitive function.
     */

    switch (operation) {
        case TP.APPEND:
            return TP.nodeAddContent;
        case TP.INSERT:
            return TP.nodeInsertContent;
        case TP.UPDATE:
            return TP.nodeSetContent;
        default:
            return this.raise('TP.sig.InvalidOperation');
    }
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('insertContent',
function(newContent, aPositionOrPath, aRequest, stdinContent) {

    /**
     * @method insertContent
     * @summary Inserts content from newContent into the receiver based on the
     *     position given. The position should indicate whether the content
     *     should become the previous sibling, next sibling, first child or last
     *     child of aNode.
     * @param {Object} newContent The content to write into the receiver. This
     *     can be a String, a Node, or an Object capable of being converted into
     *     one of those forms.
     * @param {String} aPositionOrPath The position to place the content
     *     relative to the receiver or a path to evaluate to get to a node at
     *     that position. This should be one of four values: TP.BEFORE_BEGIN
     *     TP.AFTER_BEGIN TP.BEFORE_END TP.AFTER_END or the path to evaluate.
     *     Default is TP.BEFORE_END.
     * @param {TP.sig.Request} aRequest An optional request object which defines
     *     further parameters.
     * @param {Object} stdinContent Content to set as the 'stdin' when executing
     *     the supplied content. Note that if this parameter is supplied, the
     *     content is 'executed', as well as processed, by the shell.
     * @returns {TP.dom.Node|undefined} The result of setting the content of the
     *     receiver. If a DocumentFragment was supplied in newContent, this
     *     return value will the *first* DOM node that was added.
     */

    var request,
        resp,
        content,
        nativeContent;

    if (TP.notValid(newContent) || newContent === '') {
        return;
    }

    request = TP.request(aRequest);
    request.atPutIfAbsent('targetPhase', this.getTargetPhase());

    //  If the content to be set is a URI, then track it via the 'uri'
    //  property on the request. This allows us to use it later when
    //  attempting to add to the history mechanism.
    if (TP.isURIString(newContent)) {
        request.atPutIfAbsent('uri', newContent);
    }

    //  Put ourself into the 'target' slot, so that the content pipeline has
    //  the target 'surface' that its processing for available to it.
    request.atPut('target', this);

    //  For now, anyway, processing the content needs to be synchronous.
    request.atPut('async', false);

    //  Content drawn from here will be awakened when the nodes are placed into
    //  a visible DOM, so we don't awaken them here.
    request.atPutIfAbsent('awaken', false);

    //  If stdin content was supplied, execute the content as well as process
    //  it.
    if (TP.notEmpty(stdinContent)) {
        resp = TP.processAndExecuteWith(newContent, request, stdinContent);
    } else {
        resp = TP.process(newContent, request);
    }

    if (request.didFail()) {
        return;
    }

    content = resp.get('result');

    //  Unwrap the content and, if it's an Element, check to see if its a
    //  'tibet_root' element (note that this element might have a default
    //  namespace defined that was used to qualify the markup handed in - we
    //  can't rely on that namespace). This means that the DOM parsing code
    //  detected a DocumentFragment as the result DOM node and handed us back
    //  the actual root node it used to parse the content.
    //  In this case, we extract the child nodes of the content out as a
    //  fragment and use that to set our content.
    nativeContent = TP.unwrap(content);
    if (TP.isElement(nativeContent)) {
        if (TP.elementGetLocalName(nativeContent) === 'tibet_root') {
            content = TP.nodeListAsFragment(nativeContent.childNodes);
        }
    }

    //  Note that if content was a DocumentFragment here, this call will return
    //  the *first* DOM node that was added.
    return this.insertRawContent(content, aPositionOrPath, request);
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('insertRawContent',
function(newContent, aPositionOrPath, aRequest, shouldSignal) {

    /**
     * @method insertRawContent
     * @summary Inserts new content in the receiver without performing any
     *     content processing on it.
     * @param {Object} newContent The content to write into the receiver. This
     *     can be a String, a Node, or an Object capable of being converted into
     *     one of those forms.
     * @param {String} aPositionOrPath The position to place the content
     *     relative to the receiver or a path to evaluate to get to a node at
     *     that position. This should be one of four values: TP.BEFORE_BEGIN
     *     TP.AFTER_BEGIN TP.BEFORE_END TP.AFTER_END or the path to evaluate.
     *     Default is TP.BEFORE_END.
     * @param {TP.sig.Request} aRequest An optional request object which defines
     *     further parameters.
     * @param {Boolean} shouldSignal If false this operation will not trigger a
     *     change notification. This defaults to true.
     * @returns {TP.dom.Node|undefined} The result of adding content to the
     *     receiver. If a DocumentFragment was supplied in newContent, this
     *     return value will the *first* DOM node that was added.
     */

    var node,

        content,
        request,

        arrContent,

        func,
        thisref,

        reqLoadFunc,
        loadFunc,

        result;

    node = this.getNativeNode();

    if (TP.notValid(newContent) || newContent === '') {
        return;
    }

    request = TP.request(aRequest);
    content = TP.unwrap(newContent);

    if (!TP.isKindOf(content, Node) && !TP.isString(content)) {

        //  If the content is an Array, then we want the individual
        //  '.asString()' representations of each item - not what Array gives
        //  us.
        if (TP.isArray(arrContent = content)) {
            content = '';
            arrContent.perform(
                    function(item) {
                        content += TP.str(item);
                    });
        } else {
            content = TP.str(content);
        }
    }

    func = this.getContentPrimitive(TP.INSERT);
    thisref = this;

    if (TP.isCallable(reqLoadFunc = request.at(TP.ONLOAD))) {
        loadFunc =
            function(targetNode, newNode) {

                reqLoadFunc(targetNode, newNode);

                if (TP.notFalse(shouldSignal)) {
                    thisref.changed('content', TP.INSERT);
                }
            };
    } else {
        loadFunc =
            function(targetNode, newNode) {

                thisref.contentInsertCallback(targetNode);

                if (TP.notFalse(shouldSignal)) {
                    thisref.changed('content', TP.INSERT);
                }
            };
    }

    result = func(node,
                    content,
                    aPositionOrPath,
                    loadFunc,
                    TP.ifKeyInvalid(request, 'awaken', false));

    //  If we're an Element and we're flagging changes, go ahead and do that
    //  now.
    if (TP.isElement(node) && this.shouldFlagChanges()) {
        TP.elementFlagChange(node, TP.SELF, TP.INSERT);

        TP.ifTrace() && TP.$DEBUG ?
            TP.trace('Node flagged: ' + TP.nodeAsString(node)) : 0;
    }

    //  The primitive will have returned a native Node, but we need to
    //  return a TP.dom.Node.
    return TP.wrap(result);
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('isEmpty',
function(elementsOnly) {

    /**
     * @method isEmpty
     * @summary Returns whether or not the receiver is considered 'empty'.
     * @param {Boolean} [elementsOnly=false] If true this method will only
     *     look at Element type nodes when considering whether the receiver is
     *     empty. This defaults to false.
     * @returns {Boolean} Whether or not the receiver is empty.
     */

    var count;

    if (TP.isTrue(elementsOnly)) {
        count = TP.nodeGetChildElements(this.getNativeNode()).getSize();
    } else {
        count = TP.nodeGetChildNodes(this.getNativeNode()).getSize();
    }

    return count === 0;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('isRecasting',
function() {

    /**
     * @method isRecasting
     * @summary Returns whether or not the receiver is considered to be in state
     *     of 'recasting' - that is, TIBET's processing and rendering machinery
     *     are re-processing it (probably in a Lama development session).
     * @returns {Boolean} Whether or not the receiver is empty.
     */

    var elem,
        ans;

    elem = this.getNativeNode();

    //  True if we ourself are being recast.
    if (TP.elementHasAttribute(elem, 'tibet:recasting', true)) {
        return true;
    }

    //  Or if one of our ancestors is being recast.
    ans = TP.nodeDetectAncestorMatchingCSS(elem, '*[tibet|recasting]');

    return TP.isElement(ans);
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('reviveContent',
function(aParamHash) {

    /**
     * @method reviveContent
     * @summary Causes the receiver to perform whatever steps are necessary to
     *     revive its content, presuming that it has just been read in from a
     *     compiled cache representation.
     * @param {TP.core.Hash} aParamHash A set of key/value pairs which should be
     *     used to control the transformation.
     * @returns {TP.dom.Node} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('replaceWith',
function(newContent, aRequest, stdinContent) {

    /**
     * @method replaceWith
     * @summary Replaces the receiver's native DOM counterpart with the content
     *     supplied.
     * @param {Object} newContent The content to replace the receiver with. This
     *     can be a String, a Node, or an Object capable of being converted into
     *     one of those forms.
     * @param {TP.sig.Request} aRequest An optional request object which defines
     *     further parameters.
     * @param {Object} stdinContent Content to set as the 'stdin' when executing
     *     the supplied content. Note that if this parameter is supplied, the
     *     content is 'executed', as well as processed, by the shell.
     * @returns {TP.dom.Node|undefined} The result of setting the content of the
     *     receiver. If a DocumentFragment was supplied in newContent, this
     *     return value will the *first* DOM node that was added.
     */

    var request,
        resp,
        content,

        str,

        isElement,
        isURIStr,
        containsElemMarkup,
        containsEntities,

        nativeContent;

    //  We return if newContent isn't valid and clear ourself if newContent is
    //  the empty String.
    if (TP.notValid(newContent)) {
        return;
    } else if (newContent === '') {
        return this.empty();
    }

    content = TP.unwrap(newContent);
    str = TP.str(content);

    isElement = TP.isElement(content);

    //  NB: We use the TP.regex.URI_LIKELY RegExp here instead of the
    //  TP.isURIString() method because the content can be so mixed that it
    //  might have embedded URIs.
    isURIStr = TP.regex.URI_LIKELY.test(str);

    containsElemMarkup = TP.regex.CONTAINS_ELEM_MARKUP.test(str);
    containsEntities = TP.regex.HAS_ENTITY.test(str);

    //  If the unwrapped content isn't an Element and the stringified content
    //  isn't a URI and if the stringified content doesn't contain markup or
    //  entities, then it doesn't need to be processed but can just be set as
    //  the regular content of the receiver, so we call up to the supertype to
    //  do that. At the Node level, it is determined whether this is a scalar
    //  or single-value node and might do some further processing on
    //  'newContent' at that point.
    if (!isElement &&
        !isURIStr &&
        !containsElemMarkup &&
        !containsEntities) {
        return this.callNextMethod();
    }

    //  If the unwrapped content isn't an Element and the stringified content
    //  isn't a URI and if the stringified content doesn't contain markup but
    //  does contain entities, then it doesn't need to be processed but can just
    //  be set as the regular content of the receiver, so we call
    //  replaceRawWith() to do that.
    if (!isElement &&
        !isURIStr &&
        !containsElemMarkup &&
        containsEntities) {
        return this.replaceRawWith(content, request);
    }

    request = TP.request(aRequest);
    request.atPutIfAbsent('targetPhase', this.getTargetPhase());

    //  If the content to be set is a URI, then track it via the 'uri'
    //  property on the request. This allows us to use it later when
    //  attempting to add to the history mechanism.
    if (TP.isURIString(newContent)) {
        request.atPutIfAbsent('uri', newContent);
    }

    //  Put ourself into the 'target' slot, so that the content pipeline has
    //  the target 'surface' that its processing for available to it.
    request.atPut('target', this);

    //  For now, anyway, processing the content needs to be synchronous.
    request.atPut('async', false);

    //  If this is not a Document node, content drawn from here will be awakened
    //  when the nodes are placed into a visible DOM, so we don't awaken them
    //  here. But, if this is a Document node, we need to manually configure the
    //  nodes to be awakened.
    if (TP.isDocument(this.getNativeNode())) {
        request.atPutIfAbsent('awaken', true);
    }

    //  If stdin content was supplied, execute the content as well as process
    //  it.
    if (TP.notEmpty(stdinContent)) {
        resp = TP.processAndExecuteWith(newContent, request, stdinContent);
    } else {
        resp = TP.process(newContent, request);
    }

    if (request.didFail()) {
        return;
    }

    content = resp.get('result');

    //  Unwrap the content and, if it's an Element, check to see if its a
    //  'tibet_root' element (note that this element might have a default
    //  namespace defined that was used to qualify the markup handed in - we
    //  can't rely on that namespace). This means that the DOM parsing code
    //  detected a DocumentFragment as the result DOM node and handed us back
    //  the actual root node it used to parse the content.
    //  In this case, we extract the child nodes of the content out as a
    //  fragment and use that to set our content.
    nativeContent = TP.unwrap(content);
    if (TP.isElement(nativeContent)) {
        if (TP.elementGetLocalName(nativeContent) === 'tibet_root') {
            content = TP.nodeListAsFragment(nativeContent.childNodes);
        }
    }

    //  Note that if content was a DocumentFragment here, this call will return
    //  the *first* DOM node that was added.
    return this.replaceRawWith(content, request);
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('replaceRawWith',
function(newContent, aRequest, shouldSignal) {

    /**
     * @method replaceRawWith
     * @summary Replaces the receiver with the content provided without
     *     performing any content processing on it.
     * @param {Object} newContent The content to replace the receiver with. This
     *     can be a String, a Node, or an Object capable of being converted into
     *     one of those forms.
     * @param {TP.sig.Request} aRequest An optional request object which defines
     *     further parameters.
     * @param {Boolean} shouldSignal If false this operation will not trigger a
     *     change notification. This defaults to true.
     * @returns {TP.dom.Node|undefined} The result of setting the content of the
     *     receiver. If a DocumentFragment was supplied in newContent, this
     *     return value will the *first* DOM node that was added.
     */

    var node,
        content,
        request,
        arrContent,
        func,
        thisref,
        reqLoadFunc,
        loadFunc,
        result,

        docURI;

    node = this.getNativeNode();

    //  We return if newContent isn't valid and clear ourself if newContent is
    //  the empty String.
    if (TP.notValid(newContent)) {
        return;
    } else if (newContent === '') {
        return this.empty();
    }

    request = TP.request(aRequest);
    content = TP.unwrap(newContent);

    if (!TP.isKindOf(content, Node) && !TP.isString(content)) {

        //  If the content is an Array, then we want the individual
        //  '.asString()' representations of each item - not what Array gives
        //  us.
        if (TP.isArray(arrContent = content)) {
            content = '';
            arrContent.perform(
                    function(item) {
                        content += TP.str(item);
                    });
        } else {
            content = TP.str(content);
        }
    }

    func = this.getContentPrimitive(TP.REPLACE);
    thisref = this;

    if (TP.isEmpty(docURI = request.at('uri')) &&
        TP.isKindOf(newContent, TP.dom.Node)) {
        docURI = newContent.get('uri');
    }
    if (TP.isDocument(node) && TP.notEmpty(docURI)) {
        //  NB: We pass true to force the document URI to update.
        TP.documentSetLocation(node, docURI.getLocation(), true);
    }

    if (TP.isCallable(reqLoadFunc = request.at(TP.ONLOAD))) {
        loadFunc =
            function(targetNode, newNode) {

                reqLoadFunc(targetNode, newNode);

                if (TP.notFalse(shouldSignal)) {
                    thisref.changed('content', TP.UPDATE);
                }
            };
    } else {
        loadFunc =
            function(targetNode, newNode) {

                if (TP.notFalse(shouldSignal)) {
                    thisref.changed('content', TP.UPDATE);
                }
            };
    }

    result = func(node,
                    content,
                    loadFunc,
                    TP.ifKeyInvalid(request, 'awaken', false));

    //  If we're an Element and we're flagging changes, go ahead and do that
    //  now.
    if (TP.isElement(node) && this.shouldFlagChanges()) {
        TP.elementFlagChange(node, TP.SELF, TP.UPDATE);

        TP.ifTrace() && TP.$DEBUG ?
            TP.trace('Node flagged: ' + TP.nodeAsString(node)) : 0;
    }

    //  The primitive will have returned a native Node, but we need to
    //  return a TP.dom.Node.
    return TP.wrap(result);
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('setContent',
function(newContent, aRequest, stdinContent) {

    /**
     * @method setContent
     * @summary Sets the content of the receiver's native DOM counterpart to
     *     the content supplied.
     * @param {Object} newContent The content to write into the receiver. This
     *     can be a String, a Node, or an Object capable of being converted into
     *     one of those forms.
     * @param {TP.sig.Request} aRequest An optional request object which defines
     *     further parameters.
     * @param {Object} stdinContent Content to set as the 'stdin' when executing
     *     the supplied content. Note that if this parameter is supplied, the
     *     content is 'executed', as well as processed, by the shell.
     * @returns {TP.dom.Node|undefined} The result of setting the content of the
     *     receiver. If a DocumentFragment was supplied in newContent, this
     *     return value will the *first* DOM node that was added.
     */

    var request,
        resp,
        content,

        str,

        isElement,
        isURIStr,
        containsElemMarkup,
        containsEntities,

        nativeContent,

        targetPath,
        targetTPElem;

    //  We return if newContent isn't valid and clear ourself if newContent is
    //  the empty String.
    if (TP.notValid(newContent)) {
        return;
    } else if (newContent === '') {
        return this.empty();
    }

    content = TP.unwrap(newContent);
    str = TP.str(content);

    isElement = TP.isElement(content);

    //  NB: We use the TP.regex.URI_LIKELY RegExp here instead of the
    //  TP.isURIString() method because the content can be so mixed that it
    //  might have embedded URIs.
    isURIStr = TP.regex.URI_LIKELY.test(str);

    containsElemMarkup = TP.regex.CONTAINS_ELEM_MARKUP.test(str);
    containsEntities = TP.regex.HAS_ENTITY.test(str);

    //  If the unwrapped content isn't an Element and the stringified content
    //  isn't a URI and if the stringified content doesn't contain markup or
    //  entities, then it doesn't need to be processed but can just be set as
    //  the regular content of the receiver, so we call up to the supertype to
    //  do that. At the Node level, it is determined whether this is a scalar
    //  or single-value node and might do some further processing on
    //  'newContent' at that point.
    if (!isElement &&
        !isURIStr &&
        !containsElemMarkup &&
        !containsEntities) {
        return this.callNextMethod();
    }

    //  If the unwrapped content isn't an Element and the stringified content
    //  isn't a URI and if the stringified content doesn't contain markup but
    //  does contain entities, then it doesn't need to be processed but can just
    //  be set as the regular content of the receiver, so we call
    //  setRawContent() to do that.
    if (!isElement &&
        !isURIStr &&
        !containsElemMarkup &&
        containsEntities) {
        return this.setRawContent(content, request);
    }

    request = TP.request(aRequest);
    request.atPutIfAbsent('targetPhase', this.getTargetPhase());

    //  If the content to be set is a URI, then track it via the 'uri' property
    //  on the request. This allows us to use it later when attempting to add to
    //  the history mechanism.
    if (TP.isURIString(newContent)) {
        request.atPutIfAbsent('uri', newContent);
    }

    //  Put ourself into the 'target' slot, so that the content pipeline has the
    //  target 'surface' that its processing for available to it.
    request.atPut('target', this);

    //  For now, anyway, processing the content needs to be synchronous.
    request.atPut('async', false);

    //  If this is not a Document node, content drawn from here will be awakened
    //  when the nodes are placed into a visible DOM, so we don't awaken them
    //  here. But, if this is a Document node, we need to manually configure the
    //  nodes to be awakened.
    if (TP.isDocument(this.getNativeNode())) {
        request.atPutIfAbsent('awaken', true);
    }

    //  If stdin content was supplied, execute the content as well as process
    //  it.
    if (TP.notEmpty(stdinContent)) {
        resp = TP.processAndExecuteWith(newContent, request, stdinContent);
    } else {
        resp = TP.process(newContent, request);
    }

    if (request.didFail()) {
        return;
    }

    content = resp.get('result');

    //  Unwrap the content and, if it's an Element, check to see if its a
    //  'tibet_root' element (note that this element might have a default
    //  namespace defined that was used to qualify the markup handed in - we
    //  can't rely on that namespace). This means that the DOM parsing code
    //  detected a DocumentFragment as the result DOM node and handed us back
    //  the actual root node it used to parse the content.
    //  In this case, we extract the child nodes of the content out as a
    //  fragment and use that to set our content.
    nativeContent = TP.unwrap(content);
    if (TP.isElement(nativeContent)) {
        if (TP.elementGetLocalName(nativeContent) === 'tibet_root') {
            content = TP.nodeListAsFragment(nativeContent.childNodes);
        }
    }

    //  If a 'targetPath' is defined, then that means that the caller intended
    //  for the content to go into a portion of the document and provided a path
    //  to get there.
    targetPath = request.at('targetPath');
    if (TP.isValid(targetPath)) {

        targetTPElem = this.get(targetPath);

        //  If we found a target element, then set its content and return the
        //  value of that.
        if (TP.isKindOf(targetTPElem, TP.dom.CollectionNode)) {
            return targetTPElem.setRawContent(content, request);
        }
    } else {
        //  Note that if content was a DocumentFragment here, this call will
        //  return the *first* DOM node that was added.
        return this.setRawContent(content, request);
    }
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('setRawContent',
function(newContent, aRequest, shouldSignal) {

    /**
     * @method setRawContent
     * @summary Sets the content of the receiver to the content provided
     *     without performing any content processing on it.
     * @param {Object} newContent The content to write into the receiver. This
     *     can be a String, a Node, or an Object capable of being converted into
     *     one of those forms.
     * @param {TP.sig.Request} aRequest An optional request object which defines
     *     further parameters.
     * @param {Boolean} shouldSignal If false this operation will not trigger a
     *     change notification. This defaults to true.
     * @returns {TP.dom.Node|undefined} The result of setting the content of the
     *     receiver. If a DocumentFragment was supplied in newContent, this
     *     return value will the *first* DOM node that was added.
     */

    var node,
        content,
        request,
        arrContent,
        func,
        thisref,
        reqLoadFunc,
        loadFunc,
        result,

        docURI;

    node = this.getNativeNode();

    //  We return if newContent isn't valid and clear ourself if newContent is
    //  the empty String.
    if (TP.notValid(newContent)) {
        return;
    } else if (newContent === '') {
        return this.empty();
    }

    request = TP.request(aRequest);
    content = TP.unwrap(newContent);

    if (!TP.isKindOf(content, Node) && !TP.isString(content)) {

        //  If the content is an Array, then we want the individual
        //  '.asString()' representations of each item - not what Array gives
        //  us.
        if (TP.isArray(arrContent = content)) {
            content = '';
            arrContent.perform(
                    function(item) {
                        content += TP.str(item);
                    });
        } else {
            content = TP.str(content);
        }
    }

    func = this.getContentPrimitive(TP.UPDATE);
    thisref = this;

    if (TP.isEmpty(docURI = request.at('uri')) &&
        TP.isKindOf(newContent, TP.dom.Node)) {
        docURI = newContent.get('uri');
    }
    if (TP.isDocument(node) && TP.notEmpty(docURI)) {
        //  NB: We pass true to force the document URI to update.
        TP.documentSetLocation(node, docURI.getLocation(), true);
    }

    if (TP.isCallable(reqLoadFunc = request.at(TP.ONLOAD))) {
        loadFunc =
            function(targetNode, newNode) {

                reqLoadFunc(targetNode, newNode);

                if (TP.notFalse(shouldSignal)) {
                    thisref.changed('content', TP.UPDATE);
                }
            };
    } else {
        loadFunc =
            function(targetNode, newNode) {

                thisref.contentReplaceCallback(targetNode);

                if (TP.notFalse(shouldSignal)) {
                    thisref.changed('content', TP.UPDATE);
                }
            };
    }

    //  Note how we default the 'awaken' setting here:

    //  If this is not a Document node, content drawn from here will be awakened
    //  when the nodes are placed into a visible DOM, so we don't awaken them
    //  here. But, if this is a Document node, we need to manually configure the
    //  nodes to be awakened.

    result = func(node,
                    content,
                    loadFunc,
                    TP.ifKeyInvalid(request, 'awaken', TP.isDocument(node)));

    //  If we're an Element and we're flagging changes, go ahead and do that
    //  now.
    if (TP.isElement(node) && this.shouldFlagChanges()) {
        TP.elementFlagChange(node, TP.SELF, TP.UPDATE);

        TP.ifTrace() && TP.$DEBUG ?
            TP.trace('Node flagged: ' + TP.nodeAsString(node)) : 0;
    }

    //  The primitive will have returned a native Node, but we need to
    //  return a TP.dom.Node.
    return TP.wrap(result);
});

//  ------------------------------------------------------------------------
//  NODE CONTENT COLLECTIONS
//  ------------------------------------------------------------------------

/*
Operations to acquire structurally related elements from a Node.
*/

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getAncestors',
function() {

    /**
     * @method getAncestors
     * @summary Returns an Array containing the parent nodes of the receiver.
     *     This list ends with the top level node.
     * @returns {TP.dom.Node[]} An Array of the parent nodes of the supplied
     *     Node.
     */

    return TP.wrap(TP.nodeGetAncestors(this.getNativeNode()));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getAncestorsBySelector',
function(aSelector, stopAncestor) {

    /**
     * @method getAncestorsBySelector
     * @summary Returns all ancestors of the receiver for which aSelector
     *     matches.
     * @param {String} aSelector The selector to match.
     * @param {Element} [stopAncestor] The ancestor to stop at. If not supplied,
     *     this would be identical to the document node of the document that
     *     the receiver is contained in.
     * @returns {TP.dom.ElementNode[]|undefined} The ancestor elements that
     *     match the CSS.
     */

    return TP.wrap(TP.nodeSelectAncestorsMatchingCSS(this.getNativeNode(),
                                                        aSelector,
                                                        stopAncestor));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getChildIndex',
function(aChild) {

    /**
     * @method getChildIndex
     * @summary Returns the index in the childNodes array for the child
     *     provided. If aChild couldn't be found in the aNode, this method
     *     returns TP.NOT_FOUND.
     * @param {Node} aChild The node to find.
     * @returns {Number} The index number, or TP.NOT_FOUND.
     */

    return TP.nodeGetChildIndex(this.getNativeNode(), aChild);
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getChildNodes',
function() {

    /**
     * @method getChildNodes
     * @summary Returns an Array of the child nodes of the receiver.
     * @returns {TP.dom.Node[]} An Array of the child nodes of the receiver.
     */

    return TP.wrap(TP.nodeGetChildNodes(this.getNativeNode()));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getChildElementAt',
function(anIndex) {

    /**
     * @method getChildElementAt
     * @summary Returns the child element of the receiver at the index
     *     provided, if such a child exists. Note that the index provided is
     *     used relative to children which are Element nodes only.
     * @param {Number} anIndex The index in question.
     * @returns {TP.dom.ElementNode} The child element of the supplied Node at
     *     the supplied index.
     */

    return TP.wrap(TP.nodeGetChildElementAt(this.getNativeNode(),
                                            anIndex));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getChildElements',
function() {

    /**
     * @method getChildElements
     * @summary Returns an Array of the children of the receiver which are
     *     Element nodes.
     * @returns {TP.dom.ElementNode[]} An Array of the Element children of the
     *     supplied Node.
     */

    return TP.wrap(TP.nodeGetChildElements(this.getNativeNode()));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getDescendants',
function(breadthFirst) {

    /**
     * @method getDescendants
     * @summary Returns an Array of the children, grandchildren, and so on of
     *     the receiver. Note that for a variety of reasons the return values
     *     from this call are not likely to be the same across browsers,
     *     primarily due to different handling of whitespace (Node.TEXT_NODE) in
     *     the various DOM parsers.
     * @param {Boolean} [breadthFirst=false] Breadth first if true. Default is
     *     false, meaning depth first.
     * @returns {TP.dom.Node[]} An Array containing the nodes found.
     */

    return TP.wrap(TP.nodeGetDescendants(this.getNativeNode(),
                                            breadthFirst));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getDescendantsByType',
function(aType, breadthFirst) {

    /**
     * @method getDescendantsByType
     * @summary Returns an Array of the children, grandchildren, and so on of
     *     the receiver whose node type matches the type provided. Note that if
     *     the type is Node.TEXT_NODE a normalize() call is done to return the
     *     largest possible node content.
     * @param {Number} aType The DOM node type constant to match against.
     * @param {Boolean} [breadthFirst=false] Breadth first if true. Default is
     *     false, meaning depth first.
     * @returns {TP.dom.Node[]} An Array containing the nodes found.
     */

    return TP.wrap(TP.nodeGetDescendantsByType(this.getNativeNode(),
                                                aType,
                                                breadthFirst));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getDescendantElements',
function(breadthFirst) {

    /**
     * @method getDescendantElements
     * @summary Returns an Array of the children, grandchildren, and so on of
     *     the receiver which are Element nodes.
     * @param {Boolean} [breadthFirst=false] Breadth first if true. Default is
     *     false, meaning depth first.
     * @returns {TP.dom.ElementNode[]} An Array of the Element descendants of
     *     the supplied Node.
     */

    return TP.wrap(TP.nodeGetDescendantElements(this.getNativeNode(),
                                                breadthFirst));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getDescendantElementsByAttribute',
function(attrName, attrValue, breadthFirst) {

    /**
     * @method getDescendantElementsByAttribute
     * @summary Returns an Array containing descendants of the receiver which
     *     are Element nodes and which contain an attribute name/value matching
     *     the value provided.
     * @description If the supplied attribute value is null, this method will
     *     return Element nodes that have any value for the named attribute, no
     *     matter its value.
     * @param {String} attrName The attribute to test for.
     * @param {Object} attrValue The attribute value to check.
     * @param {Boolean} [breadthFirst=false] Breadth first if true. Default is
     *     false, meaning depth first.
     * @returns {TP.dom.ElementNode[]} An Array containing the elements found.
     */

    return TP.wrap(TP.nodeGetDescendantElementsByAttribute(
                                                    this.getNativeNode(),
                                                    attrName,
                                                    attrValue,
                                                    breadthFirst));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getDescendantElementsByAttributePrefix',
function(attrPrefix, attrValue, breadthFirst) {

    /**
     * @method getDescendantElementsByAttributePrefix
     * @summary Returns an Array of the children, grandchildren, and so on of
     *     the receiver which are Element nodes and which contain an attribute
     *     name prefixed as required and whose value matches the optionally
     *     supplied value.
     * @description If the supplied attribute value is null, this method will
     *     return Element nodes that have any value for the named attribute, no
     *     matter its value.
     * @param {String} attrPrefix The prefix string to test for.
     * @param {Object} attrValue The attribute value to check.
     * @param {Boolean} [breadthFirst=false] Breadth first if true. Default is
     *     false, meaning depth first.
     * @returns {TP.dom.ElementNode[]} An Array containing the elements found.
     */

    return TP.wrap(TP.nodeGetDescendantElementsByAttributePrefix(
                                                    this.getNativeNode(),
                                                    attrPrefix,
                                                    attrValue,
                                                    breadthFirst));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getDescendantElementsByIdOrName',
function(anIdOrName) {

    /**
     * @method getDescendantElementsByIdOrName
     * @summary Returns any elements that can be found which have either the ID
     *     or Name provided.
     * @description For HTML documents where radio buttons often use the 'name'
     *     attribute as an identifier rather than 'id' we need a way to query
     *     the document for elements matching an identifier which might be
     *     either a name or id value.
     *
     *     This method gives preference to ID values, then searches for
     *     elements with the matching name value, returning an array in both
     *     cases. Since this method is an "Or" rather than "And" it has the
     *     effect of discouraging markup which uses an ID as the value of the
     *     name attribute for other elements, at least as far as it applies to
     *     this function.
     *
     *     NOTE: Since this function is used during event arming that means
     *     elements with a name value that overlaps with an ID cannot be armed
     *     using normal mechanisms.
     * @param {String} anIdOrName The ID or name of the element to find.
     * @returns {TP.dom.ElementNode[]} The elements whose name is equal to
     *     anIdOrName or empty if there are no objects with that name.
     */

    return TP.wrap(TP.nodeGetDescendantElementsByIdOrName(
                                                this.getNativeNode(),
                                                anIdOrName));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getDescendantElementsByName',
function(aName) {

    /**
     * @method getDescendantElementsByName
     * @summary Returns an Array containing any descendants of the receiver
     *     which are Element nodes and whose 'name' attributes match the name
     *     provided.
     * @param {String} aName The value of the 'name' attribute to search for.
     * @returns {TP.dom.ElementNode[]} An Array containing native elements
     *     found.
     */

    return TP.wrap(TP.nodeGetDescendantElementsByName(
                                            this.getNativeNode(),
                                            aName));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getElementsByClassName',
function(aClassName) {

    /**
     * @method getElementsByClassName
     * @summary Returns an Array of Elements under the receiver whose CSS class
     *     name matches aClassName.
     * @param {String} aClassName The class name to use to find matching
     *     elements. Multiple class names should be space separated.
     * @returns {TP.dom.ElementNode[]} An Array of Elements under anElement
     *     whose CSS class name matches aClassName.
     */

    return TP.wrap(TP.nodeGetElementsByClassName(this.getNativeNode(),
                                                    aClassName));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getElementById',
function(anID, retryWithXPath) {

    /**
     * @method getElementById
     * @summary Returns the element with the ID specified, if found in the
     *     receiver's DOM hierarchy.
     * @param {String} anID The unique ID to search for.
     * @param {Boolean} retryWithXPath True will force TIBET to use an XPath
     *     search for id attributes when the native call fails.
     * @returns {TP.dom.ElementNode|undefined} A TP.dom.ElementNode wrapping the
     *     node with the ID specified.
     */

    if (TP.isPrototype(this)) {
        return;
    }

    return TP.wrap(TP.nodeGetElementById(this.getNativeNode(),
                                            anID,
                                            retryWithXPath));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getElementByIndex',
function(anIndex) {

    /**
     * @method getElementByIndex
     * @summary Returns the element at the specified index.
     * @description When using this method indexes are in the form consistent
     *     with the element() scheme in XPointer and those from
     *     TP.elementGetDocumentIndex(). When invoked with a non-document node
     *     the index is taken to be relative to the receiving node.
     * @param {String} anIndex The index to search for.
     * @returns {TP.dom.ElementNode} The element with the index specified.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getElementsBySelector',
function(aSelectorStr) {

    /**
     * @method getElementsBySelector
     * @summary Returns any elements matching the selector given in the
     *     supplied selector String.
     * @param {Node} aNode The node to begin the search. If this parameter is
     *     null, the entire document is searched.
     * @param {String} aSelectorStr The CSS selector to use to search the DOM.
     * @returns {TP.dom.ElementNode[]} An Array containing native elements
     *     found.
     */

    return TP.wrap(TP.nodeEvaluateCSS(this.getNativeNode(),
                                        aSelectorStr));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getElementsByTagName',
function(aName, aNamespaceURI) {

    /**
     * @method getElementsByTagName
     * @summary Returns an Array containing any descendant elements of the
     *     supplied node whose tag names match the name provided. Note that this
     *     function can deal properly with namespace-qualified tag names across
     *     platforms.
     * @description This method merely returns the result of calling the TIBET
     *     DOM primitive call TP.nodeGetElementsByTagName() on the receiver's
     *     native node and then TP.wrap()ing the result. See that function for
     *     more information on the capabilities of this method.
     * @param {String} aName The string tagname to search for.
     * @param {String} aNamespaceURI The namespace URI to search for.
     * @returns {TP.dom.ElementNode[]} An Array containing elements found.
     */

    return TP.wrap(TP.nodeGetElementsByTagName(this.getNativeNode(),
                                                aName,
                                                aNamespaceURI));
});

//  ------------------------------------------------------------------------
//  XPATH SUPPORT
//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('generateXPathTo',
function(aNode) {

    /**
     * @method generateXPathTo
     * @summary Generates a 'simple' XPath expression that would access the
     *     supplied node from the receiver's native node.
     * @param {Node|TP.dom.Node} aNode The node to generate the path to.
     * @exception TP.sig.InvalidNode
     * @returns {String} The generated XPath expression.
     */

    var node,

        targetNode,

        pathStr,
        theNode,

        stopNode;

    node = this.getNativeNode();

    //  In case aNode was a TP.dom.Node.
    targetNode = TP.unwrap(aNode);

    if (!TP.isNode(targetNode)) {
        return this.raise('TP.sig.InvalidNode',
                            'No node provided.');
    }

    //  Need to check to make sure that targetNode is a descendant of our
    //  native node.
    if (TP.notTrue(TP.nodeContainsNode(node, targetNode))) {
        return this.raise('TP.sig.InvalidNode',
                            'Node provided not descendant of receiver.');
    }

    //  First, we need to see if targetNode is an attribute node or not
    if (targetNode.nodeType === Node.ATTRIBUTE_NODE) {
        pathStr = '/@' + targetNode.name;
        theNode = TP.attributeGetOwnerElement(targetNode);
    } else {
        pathStr = '/' + targetNode.tagName;
        theNode = targetNode.parentNode;
    }

    node = this.getNativeNode();

    if (TP.isDocument(node)) {
        if (TP.isEmpty(node)) {
            //  no nodes? then no real path, but return what we've got
            return pathStr;
        }

        stopNode = node.documentElement.parentNode;
    } else {
        stopNode = node;
    }

    //  TODO: Need to detect if we're at a place where there are multiple
    //  occurrences of the same named element and then generate an index
    //  predicate onto that step in the path.
    while (TP.isNode(theNode) && theNode !== stopNode) {
        pathStr = '/' + theNode.tagName + pathStr;
        theNode = theNode.parentNode;
    }

    return pathStr;
});

//  ------------------------------------------------------------------------
//  CHILD TEXT VALUES
//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getChildTextContent',
function(aName, aNamespaceURI) {

    /**
     * @method getChildTextContent
     * @summary Returns the normalized text content of the first child element
     *     with the tag name provided. This is a useful method for pulling apart
     *     nodes which essentially represent lists.
     * @param {String} aName The child tag name to search for.
     * @param {String} aNamespaceURI The namespace URI to search for.
     * @returns {String} The text content of the text child of the first Element
     *     under the receiver whose tag name matches the supplied name (after
     *     all Text nodes under it have been normalized).
     */

    return TP.nodeGetChildTextContent(this.getNativeNode(),
                                        aName,
                                        aNamespaceURI);
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('setChildTextContent',
function(aString, aName, aNamespaceURI) {

    /**
     * @method setChildTextContent
     * @summary Sets the text value of the receiver's first element with a tag
     *     name of aName. This is a useful wrapper for manipulating nodes which
     *     essentially represent lists.
     * @param {String} aName The tag/element name to match.
     * @param {String} aNamespaceURI The namespace URI to search for.
     * @param {String} aString The content text to set.
     * @returns {TP.dom.Node} The receiver.
     */

    //  NOTE the localization here
    TP.nodeSetChildTextContent(
                    this.getNativeNode(),
                    aString.localize(this.getContentLanguage()),
                    aName,
                    aNamespaceURI);

    this.changed('value', TP.UPDATE);

    return this;
});

//  ------------------------------------------------------------------------
//  ANCESTOR SEARCH
//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getFirstAncestorByAttribute',
function(attrName, attrValue) {

    /**
     * @method getFirstAncestorByAttribute
     * @summary Returns the first element ancestor of the receiver which has an
     *     attribute matching attrName and whose value matches the optional
     *     attrValue provided.
     * @description This is a commonly used method in widget construction where
     *     an inner element is looking outward for its containing widget or
     *     control, often during event dispatch.
     * @param {String} attrName The attribute to test for.
     * @param {Object} attrValue The optional attribute value to check.
     * @returns {TP.dom.ElementNode} An element ancestor of the node.
     * @exception TP.sig.InvalidParameter Raised when a node that isn't of type
     *     Node.ELEMENT_NODE or Node.DOCUMENT_NODE is provided to the method.
     * @exception TP.sig.InvalidName Raised when the supplied attribute name is
     *     empty.
     */

    return TP.wrap(TP.nodeGetFirstAncestorByAttribute(
                                this.getNativeNode(),
                                attrName,
                                attrValue,
                                true));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getFirstAncestorBySelector',
function(aSelector, stopAncestor) {

    /**
     * @method getFirstAncestorBySelector
     * @summary Returns the first ancestor of the receiver for which aSelector
     *     matches.
     * @param {String} aSelector The selector to match.
     * @param {Element} [stopAncestor] The ancestor to stop at. If not supplied,
     *     this would be identical to the document node of the document that
     *     the receiver is contained in.
     * @returns {TP.dom.ElementNode|undefined} The ancestor element that matches
     *     the CSS.
     */

    return TP.wrap(TP.nodeDetectAncestorMatchingCSS(this.getNativeNode(),
                                                    aSelector,
                                                    stopAncestor));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getFirstAncestorByTagName',
function(aTagName, aNamespaceURI) {

    /**
     * @method getFirstAncestorByTagName
     * @summary Returns the first element ancestor of the receiver which
     *     matches the name and optional namespace URI provided.
     * @description This is a commonly used method in widget construction where
     *     an inner element is looking outward for its containing widget or
     *     control, often during event dispatch.
     * @param {String} aTagName The string tagname to search for.
     * @param {String} aNamespaceURI The namespace URI to search for.
     * @returns {TP.dom.ElementNode} An element ancestor of the node.
     * @exception TP.sig.InvalidParameter Raised when a node that isn't of type
     *     Node.ELEMENT_NODE or Node.DOCUMENT_NODE is provided to the method.
     * @exception TP.sig.InvalidName Raised when the supplied tag name is empty.
     */

    return TP.wrap(TP.nodeGetFirstAncestorByTagName(
                                this.getNativeNode(),
                                aTagName,
                                aNamespaceURI));
});

//  ------------------------------------------------------------------------
//  FIRST CHILD/ELEMENT SEARCH
//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getFirstElementChildByAttribute',
function(attrName, attrValue) {

    /**
     * @method getFirstElementChildByAttribute
     * @summary Returns the first element child of the node which has an
     *     attribute matching attrName and whose value matches the optional
     *     attrValue provided.
     * @param {String} attrName The attribute to test for.
     * @param {Object} attrValue The attribute value to check.
     * @returns {TP.dom.ElementNode} An element child of the node.
     */

    return TP.wrap(TP.nodeGetFirstElementChildByAttribute(
                                                    this.getNativeNode(),
                                                    attrName,
                                                    attrValue));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getFirstElementChildByTagName',
function(aName, aNamespaceURI) {

    /**
     * @method getFirstElementChildByTagName
     * @summary Returns the first element descendant of the node which matches
     *     the name and optional namespace URI provided.
     * @description This is a commonly used method in widget construction where
     *     the outer widget is looking for specific parts of its content.
     * @param {String} aName The string tagname to search for.
     * @param {String} aNamespaceURI The namespace URI to search for.
     * @returns {TP.dom.ElementNode} An element descendant of the node.
     */

    return TP.wrap(TP.nodeGetFirstElementChildByTagName(
                                                    this.getNativeNode(),
                                                    aName,
                                                    aNamespaceURI));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getFirstChildByType',
function(aType) {

    /**
     * @method getFirstChildByType
     * @summary Returns the first child of the node which has a nodeType
     *     matching the type provided.
     * @param {Number} aType A DOM Node nodeType constant.
     * @returns {TP.dom.Node} A child of the node.
     */

    return TP.wrap(TP.nodeGetFirstChildByType(this.getNativeNode(),
                                                aType));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getFirstChildContentNode',
function() {

    /**
     * @method getFirstChildContentNode
     * @summary Returns the first "content" child of the receiver, the first
     *     text or CDATA child node.
     * @returns {TP.dom.TextNode|TP.dom.CDATASectionNode} The first text child
     *     of the receiver.
     */

    return TP.wrap(TP.nodeGetFirstChildContentNode(this.getNativeNode()));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getFirstChildElement',
function() {

    /**
     * @method getFirstChildElement
     * @summary Returns the first element child of the node.
     * @description This method is a replacement for node.firstChild which
     *     ensures that text nodes, comment nodes, and other node types don't
     *     break your code when you're assuming element nodes.
     * @returns {TP.dom.ElementNode} An element child of the node.
     */

    return TP.wrap(TP.nodeGetFirstChildElement(this.getNativeNode()));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getFirstDescendantByType',
function(aType) {

    /**
     * @method getFirstDescendantByType
     * @summary Returns the first descendant of the node which has a nodeType
     *     matching the type provided.
     * @param {Node} aNode The node to process.
     * @param {Number} aType A Node.nodeType constant.
     * @returns {TP.dom.Node} A descendant of the node.
     */


    return TP.wrap(TP.nodeGetFirstDescendantByType(this.getNativeNode(),
                                                    aType));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getFirstElementByAttribute',
function(attrName, attrValue) {

    /**
     * @method getFirstElementByAttribute
     * @summary Returns the first element descendant of the node which has an
     *     attribute matching attrName and whose value matches the optional
     *     attrValue provided.
     * @param {String} attrName The attribute to test for.
     * @param {Object} attrValue The attribute value to check.
     * @returns {TP.dom.ElementNode} An element descendant of the node.
     */

    return TP.wrap(TP.nodeGetFirstElementByAttribute(this.getNativeNode(),
                                                        attrName,
                                                        attrValue));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getFirstElementByTagName',
function(aName, aNamespaceURI) {

    /**
     * @method getFirstElementByTagName
     * @summary Returns the first element descendant of the node which matches
     *     the name and optional namespace URI provided.
     * @description This is a commonly used method in widget construction where
     *     the outer widget is looking for specific parts of its content.
     * @param {String} aName The string tagname to search for.
     * @param {String} aNamespaceURI The namespace URI to search for.
     * @returns {TP.dom.ElementNode} An element descendant of the node.
     */

    return TP.wrap(TP.nodeGetFirstElementByTagName(this.getNativeNode(),
                                                    aName,
                                                    aNamespaceURI));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getFirstSiblingElement',
function(direction) {

    /**
     * @method getFirstSiblingElement
     * @summary Returns the next, or previous sibling of the receiver which is
     *     an element. This is a useful operation when trying to iterate over
     *     only elements within a particular set of nodes.
     * @param {String} aDirection TP.NEXT or TP.PREVIOUS. The default is TP.NEXT
     *     so searching is forward.
     * @returns {TP.dom.ElementNode} The first sibling.
     */

    return TP.wrap(TP.nodeGetFirstSiblingElement(this.getNativeNode(),
                                                    direction));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getNextNonChild',
function(nodeType) {

    /**
     * @method getNextNonChild
     * @summary Returns the next node in document order that isn't a child of
     *     the node provided. This will often be the receiver's nextSibling, but
     *     it may be a different node when the receiver has no nextSibling. Note
     *     that the last node in document order won't return a valid node here.
     * @param {Number} nodeType A valid nodeType constant. Defaults to any node
     *     type.
     * @returns {TP.dom.Node} The next TP.dom.Node in document order.
     */

    return TP.wrap(TP.nodeGetNextNonChild(this.getNativeNode(), nodeType));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getTopAncestor',
function() {

    /**
     * @method getTopAncestor
     * @summary Returns the top-most node in the receiver's ancestor chain.
     *     This is typically a Document node (#document) but will be an Element
     *     or the node itself if the receiver is in a detached tree branch.
     * @returns {TP.dom.Node} The topmost TP.dom.Node.
     */

    return TP.wrap(TP.nodeGetTopAncestor(this.getNativeNode()));
});

//  ------------------------------------------------------------------------
//  NODE COLLECTION ITERATION
//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('ancestorsPerform',
function(aFunction) {

    /**
     * @method ancestorsPerform
     * @summary Executes aFunction with each ancestor of the node, working from
     *     the node outward.
     * @description Perform can be used as an alternative to constructing for
     *     loops to iterate over a collection. By returning TP.BREAK from your
     *     iterator you can also cause the enclosing iteration to terminate.
     * @param {Function} aFunction A function which performs some action with a
     *     TP.dom.ElementNode node.
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    TP.nodeAncestorsPerform(this.getNativeNode(),
                            TP.INVOKE_WRAPPED(aFunction));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('childElementsPerform',
function(aFunction) {

    /**
     * @method childElementsPerform
     * @summary Executes aFunction with each child element of the node.
     * @description Perform can be used as an alternative to constructing for
     *     loops to iterate over a collection. By returning TP.BREAK from your
     *     iterator you can also cause the enclosing iteration to terminate.
     *     Note the filter here for child nodes that are elements. The index
     *     provided to aFunction is the index that would be used had you
     *     collected the elements first, then iterated on that array. This also
     *     means that, if the first or last node are not elements, the iteration
     *     function will not be called.
     * @param {Function} aFunction A function which performs some action with
     *     each TP.dom.ElementNode provided.
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    TP.nodeChildElementsPerform(this.getNativeNode(),
                                TP.INVOKE_WRAPPED(aFunction));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('childNodesPerform',
function(aFunction) {

    /**
     * @method childNodesPerform
     * @summary Executes aFunction with each child node of the node. NOTE that
     *     as part of the processing here the node is normalized to coalesce
     *     adjacent text nodes.
     * @description Perform can be used as an alternative to constructing for
     *     loops to iterate over a collection. By returning TP.BREAK from your
     *     iterator you can also cause the enclosing iteration to terminate.
     * @param {Function} aFunction A function which performs some action with
     *     each TP.dom.Node provided.
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    TP.nodeChildNodesPerform(this.getNativeNode(),
                                TP.INVOKE_WRAPPED(aFunction));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('descendantsPerform',
function(aFunction, breadthFirst) {

    /**
     * @method descendantsPerform
     * @summary Executes aFunction with each descendant of the node.
     * @description aFunction implementations can return TP.BREAK to terminate
     *     the traversal, TP.CONTINUE to allow you to skip child content under
     *     an element and proceed to the next non-child element node for
     *     processing (only when the current item is an Element, not non-Element
     *     content) or TP.DESCEND to descend into child element content. If you
     *     need to reverse the iteration use TP.nodeGetDescendants() to get the
     *     descendant list and then use Array's perform operation.
     * @param {Function} aFunction A function which performs some action with
     *     each TP.dom.Node provided.
     * @param {Boolean} breadthFirst Breadth first if true. Default is false,
     *     meaning depth first.
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    TP.nodeDescendantsPerform(this.getNativeNode(),
                                TP.INVOKE_WRAPPED(aFunction),
                                breadthFirst);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('descendantElementsPerform',
function(aFunction, breadthFirst) {

    /**
     * @method descendantElementsPerform
     * @summary Executes aFunction with each element descendant of the node.
     * @description aFunction implementations can return TP.BREAK to terminate
     *     the traversal, TP.CONTINUE to allow you to skip child content under
     *     an element and proceed to the next non-child element node for
     *     processing (only when the current item is an Element, not non-Element
     *     content) or TP.DESCEND to descend into child element content. If you
     *     need to reverse the iteration use TP.nodeGetDescendantElements() to
     *     get the descendant element list and then use Array's perform
     *     operation.
     * @param {Function} aFunction A function which performs some action with
     *     each TP.dom.ElementNode provided.
     * @param {Boolean} breadthFirst Breadth first if true. Default is false,
     *     meaning depth first.
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    TP.nodeDescendantElementsPerform(this.getNativeNode(),
                                        TP.INVOKE_WRAPPED(aFunction),
                                        breadthFirst);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('siblingsPerform',
function(aFunction, aSubset) {

    /**
     * @method siblingsPerform
     * @summary Executes aFunction with each sibling of the node.
     * @description Perform can be used as an alternative to constructing for
     *     loops to iterate over a collection. By returning TP.BREAK from your
     *     iterator you can also cause the enclosing iteration to terminate.
     *     Note that the index provided to aFunction is the index
     *     that would have been used had you collected the siblings in an array
     *     first, then iterated.
     * @param {Function} aFunction A function which performs some action with
     *     each node provided.
     * @param {String} aSubset TP.NEXT, TP.PREVIOUS, or null to collect all
     *     siblings.
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    TP.nodeSiblingsPerform(this.getNativeNode(),
                            TP.INVOKE_WRAPPED(aFunction),
                            aSubset);

    return this;
});

//  ------------------------------------------------------------------------
//  NODE CONTENT DETECTION
//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('detectAncestor',
function(aFunction) {

    /**
     * @method detectAncestor
     * @summary Returns the first ancestor of the node for which aFunction
     *     returns true. The normal direction of this search is from the node
     *     "outward" toward the document root.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable TP.dom.Node.
     * @returns {TP.dom.ElementNode} An ancestor found acceptable by aFunction.
     */

    return TP.wrap(TP.nodeDetectAncestor(this.getNativeNode(),
                                            TP.INVOKE_WRAPPED(aFunction)));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('detectChildElement',
function(aFunction) {

    /**
     * @method detectChildElement
     * @summary Returns the first child element of the receiver for which
     *     aFunction returns true. Iteration is from firstChild to lastChild.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable TP.dom.ElementNode.
     * @returns {TP.dom.ElementNode} A child element found acceptable by
     *     aFunction.
     */

    return TP.wrap(TP.nodeDetectChildElement(this.getNativeNode(),
                                            TP.INVOKE_WRAPPED(aFunction)));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('detectChildNode',
function(aFunction) {

    /**
     * @method detectChildNode
     * @summary Returns the first child node of the node for which aFunction
     *     returns true. Iteration is from firstChild to lastChild.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable TP.dom.Node.
     * @returns {TP.dom.Node} A child node found acceptable by aFunction.
     */

    return TP.wrap(TP.nodeDetectChildNode(this.getNativeNode(),
                                            TP.INVOKE_WRAPPED(aFunction)));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('detectDescendant',
function(aFunction, breadthFirst) {

    /**
     * @method detectDescendant
     * @summary Returns the first descendant of the node for which aFunction
     *     returns true. Search is typically downward in a depth-first fashion.
     * @description Note that you can't reverse this detection process. To
     *     perform a reverse detection use nodeGetDescendants() to get the
     *     collection in the order you desire and iterate on that.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable TP.dom.Node.
     * @param {Boolean} [breadthFirst=false] Breadth first if true. Default is
     *     false, meaning depth first.
     * @returns {TP.dom.Node} A descendant found acceptable by aFunction.
     */

    return TP.wrap(TP.nodeDetectDescendant(this.getNativeNode(),
                                            TP.INVOKE_WRAPPED(aFunction),
                                            breadthFirst));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('detectDescendantElement',
function(aFunction, breadthFirst) {

    /**
     * @method detectDescendantElement
     * @summary Returns the first element descendant of the node for which
     *     aFunction returns true. Search is typically downward in a depth-first
     *     fashion.
     * @description Note that you can't reverse this detection process. To
     *     perform a reverse detection use TP.nodeGetDescendantElements() to get
     *     the collection in the order you desire and iterate on that
     *     collection.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable TP.dom.ElementNode.
     * @param {Boolean} [breadthFirst=false] Breadth first if true. Default is
     *     false, meaning depth first.
     * @returns {TP.dom.ElementNode} A descendant element found acceptable by
     *     aFunction.
     */

    return TP.wrap(TP.nodeDetectDescendantElement(
                                    this.getNativeNode(),
                                    TP.INVOKE_WRAPPED(aFunction),
                                    breadthFirst));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('detectSibling',
function(aFunction, aSubset) {

    /**
     * @method detectSibling
     * @summary Returns the first sibling node (next, previous, or any) of the
     *     node for which aFunction returns true.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable TP.dom.Node.
     * @param {String} aSubset TP.NEXT, TP.PREVIOUS, or null to collect all
     *     siblings.
     * @returns {TP.dom.Node} A sibling found acceptable by aFunction.
     */

    return TP.wrap(TP.nodeDetectSibling(this.getNativeNode(),
                                        TP.INVOKE_WRAPPED(aFunction),
                                        aSubset));
});

//  ------------------------------------------------------------------------
//  NODE SELECTION (FILTERING)
//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('selectAncestors',
function(aFunction) {

    /**
     * @method selectAncestors
     * @summary Returns an array of ancestors of the node for which aFunction
     *     returns true. The normal direction of this search is from the node
     *     "outward" toward the document root.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable TP.dom.Node.
     * @returns {TP.dom.Node[]} An Array of ancestors found acceptable by
     *     aFunction.
     */

    return TP.wrap(TP.nodeSelectAncestors(this.getNativeNode(),
                                            TP.INVOKE_WRAPPED(aFunction)));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('selectChildElements',
function(aFunction) {

    /**
     * @method selectChildElements
     * @summary Returns an array of child elements of the receiver for which
     *     aFunction returns true. Iteration is from firstChild to lastChild.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable TP.dom.Node.
     * @returns {TP.dom.ElementNode[]} An array of child elements found
     *     acceptable by aFunction.
     */

    return TP.wrap(TP.nodeSelectChildElements(this.getNativeNode(),
                                                TP.INVOKE_WRAPPED(aFunction)));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('selectChildNodes',
function(aFunction) {

    /**
     * @method selectChildNodes
     * @summary Returns an Array of children of the node for which aFunction
     *     returns true. Iteration is from firstChild to lastChild.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable TP.dom.Node.
     * @returns {TP.dom.Node[]} An array of child nodes found acceptable by
     *     aFunction.
     */

    return TP.wrap(TP.nodeSelectChildNodes(this.getNativeNode(),
                                            TP.INVOKE_WRAPPED(aFunction)));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('selectDescendants',
function(aFunction, breadthFirst) {

    /**
     * @method selectDescendants
     * @summary Returns an Array of descendants of the node for which aFunction
     *     returns true. Search is typically downward in a depth-first fashion.
     * @description Note that you can't reverse this selection process. To
     *     perform a reverse selection use nodeGetDescendants() to get the
     *     collection in the order you desire and iterate on that.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable TP.dom.Node.
     * @param {Boolean} [breadthFirst=false] Breadth first if true. Default is
     *     false, meaning depth first.
     * @returns {TP.dom.Node[]} An array of descendant nodes found acceptable by
     *     aFunction.
     */

    return TP.wrap(TP.nodeSelectDescendants(this.getNativeNode(),
                                            TP.INVOKE_WRAPPED(aFunction),
                                            breadthFirst));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('selectDescendantElements',
function(aFunction, breadthFirst) {

    /**
     * @method selectDescendantElements
     * @summary Returns an Array of descendant elements of the node for which
     *     aFunction returns true. Search is typically downward in a depth-first
     *     fashion.
     * @description Note that you can't reverse this selection process. To
     *     perform a reverse selection use TP.nodeGetDescendantElements() to get
     *     the collection in the order you desire and iterate on that
     *     collection.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable TP.dom.Node.
     * @param {Boolean} [breadthFirst=false] Breadth first if true. Default is
     *     false, meaning depth first.
     * @returns {TP.dom.ElementNode[]} An array of descendant elements found
     *     acceptable by aFunction.
     */

    return TP.wrap(TP.nodeSelectDescendantElements(
                                        this.getNativeNode(),
                                        TP.INVOKE_WRAPPED(aFunction),
                                        breadthFirst));
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('selectSiblings',
function(aFunction, aSubset) {

    /**
     * @method selectSiblings
     * @summary Returns an array of siblings (next, previous, or any) of the
     *     node for which aFunction returns true.
     * @param {Function} aFunction A function returning true when passed an
     *     acceptable TP.dom.Node.
     * @param {String} aSubset TP.NEXT, TP.PREVIOUS, or null to collect all
     *     siblings.
     * @returns {TP.dom.Node[]} An Array of siblings found acceptable by
     *     aFunction.
     */

    return TP.wrap(TP.nodeSelectSiblings(this.getNativeNode(),
                                            TP.INVOKE_WRAPPED(aFunction),
                                            aSubset));
});

//  ------------------------------------------------------------------------
//  NODE MODIFICATION
//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('copyChildNodesTo',
function(toNode, beforeNode) {

    /**
     * @method copyChildNodesTo
     * @summary Copies children of the receiver to another node.
     * @param {Node} toNode The target node.
     * @param {Node} beforeNode Optional 'insertion point'.
     * @returns {TP.dom.Node} The first copied child node. This will be a
     *     different node than what was the first child node of the receiver, as
     *     the node will have been copied and might have been imported.
     */

    var node,

        retVal,

        oldSize,
        newSize;

    node = this.getNativeNode();

    try {
        oldSize = node.childNodes.length;
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'Error reading child nodes length.')) : 0;
    }

    retVal = TP.nodeCopyChildNodesTo(node, toNode, beforeNode);

    try {
        newSize = node.childNodes.length;
        if (newSize < oldSize) {
            this.changed('content', TP.DELETE);
        } else if (newSize > oldSize) {
            this.changed('content', TP.INSERT);
        } else {
            this.changed('content', TP.UPDATE);
        }
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'Error reading child nodes length.')) : 0;
    }

    return TP.wrap(retVal);
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('moveChildNodesTo',
function(toNode, beforeNode) {

    /**
     * @method moveChildNodesTo
     * @summary Moves children of the receiver to another node.
     * @param {Node} toNode The target node.
     * @param {Node} beforeNode Optional 'insertion point'.
     * @returns {TP.dom.Node} The first moved child node. This will be a
     *     different node than what was the first child node of the receiver, as
     *     the node will have been copied and might have been imported.
     */

    var node,

        retVal,

        oldSize,
        newSize;

    node = this.getNativeNode();

    try {
        oldSize = node.childNodes.length;
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'Error reading child nodes length.')) : 0;
    }

    retVal = TP.nodeMoveChildNodesTo(node, toNode, beforeNode);

    try {
        newSize = node.childNodes.length;
        if (newSize < oldSize) {
            this.changed('content', TP.DELETE);
        } else if (newSize > oldSize) {
            this.changed('content', TP.INSERT);
        } else {
            this.changed('content', TP.UPDATE);
        }
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'Error reading child nodes length.')) : 0;
    }

    return TP.wrap(retVal);
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('removeChildElement',
function(anElement) {

    /**
     * @method removeChildElement
     * @summary Removes a specific child *element*, ensuring that proper
     *     flagging and/or removal are done along with change notification.
     * @param {Element} anElement A specific child/descendant element.
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    var node,
        child;

    node = this.getNativeNode();

    child = anElement;

    if (this.shouldFlagChanges()) {
        //  if we're flagging rather than 'doing' then we set the change flag to
        //  TP.DELETE and that's all
        TP.elementFlagChange(child, TP.SELF, TP.DELETE);

        TP.ifTrace() && TP.$DEBUG ?
            TP.trace('Node flagged: ' + TP.nodeAsString(child)) : 0;
    } else {
        //  if we're not flagging then just rip it out of the DOM
        TP.nodeRemoveChild(node, child);
    }

    this.changed('content', TP.DELETE);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('removeChildElementAt',
function(anIndex) {

    /**
     * @method removeChildElementAt
     * @summary Removes the child element at the supplied index, ensuring that
     *     proper flagging and/or removal are done along with change
     *     notification.
     * @param {Number} anIndex The index of the child *element*
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    var child;

    child = TP.unwrap(this.getChildElementAt(anIndex));
    if (!TP.isElement(child)) {
        return this.raise(
                'TP.sig.InvalidIndex',
                'Invalid index: ' + anIndex);
    }

    return this.removeChildElement(child);
});

//  ------------------------------------------------------------------------
//  TP.api.Collection API
//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('add',
function() {

    /**
     * @method add
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    var node,
        len,
        i;

    node = this.getNativeNode();

    len = this.length;

    for (i = 0; i < arguments.length; i++) {

        //  Note that we use the low-level primitive here rather than
        //  'addContent()' / 'addRawContent()' because this is a
        //  'lower-level' API and we don't want processed content.
        TP.nodeAddContent(node, arguments[i], null, false);
    }

    if (arguments.length > 0) {
        this.changed('length', TP.INSERT,
                        TP.hc(TP.OLDVAL, len, TP.NEWVAL, this.length));
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('addAll',
function() {

    /**
     * @method addAll
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('addAllIfAbsent',
function() {

    /**
     * @method addAllIfAbsent
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('addIfAbsent',
function() {

    /**
     * @method addIfAbsent
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('addItem',
function() {

    /**
     * @method addItem
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('addWithCount',
function() {

    /**
     * @method addWithCount
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('asArray',
function() {

    /**
     * @method asArray
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('asHash',
function() {

    /**
     * @method asHash
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('asIterator',
function() {

    /**
     * @method asIterator
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('asRange',
function() {

    /**
     * @method asRange
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------
//  asString                    TP.dom.Node
//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('collapse',
function() {

    /**
     * @method collapse
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('collect',
function(aFunction, deep, breadthFirst) {

    /**
     * @method collect
     * @summary Runs aFunction iteratively over each element of the receiver
     *     and returns an Array containing TP.dom.Node return values.
     * @param {Function} aFunction A function taking 2 parameters, the current
     *     wrapped child or descendant node and index.
     * @param {Boolean} [deep=false] Should the iteration cover all descendant
     *     nodes as well? Defaults to false so only direct children are
     *     involved.
     * @param {Boolean} [breadthFirst=false] Breadth first if true. Default is
     *     false, meaning depth first. Only used when deep is true.
     * @returns {TP.dom.Node[]} The return values from each iteration of the
     *     supplied Function.
     */

    var node;

    node = this.getNativeNode();

    if (TP.ifInvalid(deep, false)) {
        return TP.wrap(TP.nodeGetDescendants(node, breadthFirst).collect(
                                        TP.INVOKE_WRAPPED(aFunction)));
    } else {
        return TP.wrap(TP.ac(node.childNodes).collect(
                                        TP.INVOKE_WRAPPED(aFunction)));
    }
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('collectGet',
function() {

    /**
     * @method collectGet
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('collectInvoke',
function() {

    /**
     * @method collectInvoke
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('compact',
function() {

    /**
     * @method compact
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('conform',
function() {

    /**
     * @method conform
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('contains',
function(aDescendant, aTest) {

    /**
     * @method contains
     * @summary Returns whether or not the receiver is an ancestor (or the
     *     document for) aDescendant. If the receiver is a TP.dom.DocumentNode,
     *     this method will return true if aDescendant's document is the
     *     receiver.
     * @description This method checks 'deeply' throughout the receiver's tree.
     * @param {Node|TP.dom.Node} aDescendant Whether or not the receiver
     *     contains the supplied (TP)Node.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Boolean} Whether or not the receiver contains the node
     *     provided.
     */

    var node,
        it;

    node = this.getNativeNode();

    if (aTest === TP.IDENTITY) {
        return TP.nodeContainsNode(node, TP.unwrap(aDescendant));
    }

    it = this.detect(
            function(item, index) {

                return TP.equal(item, aDescendant);
            },
            true);

    //  might contain a null, and nulls can be compared
    return TP.isDefined(it);
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('containsAll',
function(aCollection, aTest) {

    /**
     * @method containsAll
     * @summary Returns true if all the elements in the collection provided are
     *     found in the receiver.
     * @param {TP.api.Collection} aCollection The collection of elements all
     *     of which must be equal to at least one element in the receiver for
     *     this method to return true.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception TP.sig.InvalidCollection
     * @returns {Boolean} Whether or not the receiver contains all of the
     *     elements in the collection provided.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('containsAny',
function(aCollection) {

    /**
     * @method containsAny
     * @summary Returns true if any the elements in the collection provided are
     *     found in the receiver.
     * @param {TP.api.Collection} aCollection The collection of elements any
     *     of which must be equal to at least one element in the receiver for
     *     this method to return true.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @exception TP.sig.InvalidCollection
     * @returns {Boolean} Whether or not the receiver contains any of the
     *     elements in the collection provided.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('containsString',
function() {

    /**
     * @method convert
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('convert',
function() {

    /**
     * @method convert
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('countOf',
function(aNode, aTest) {

    /**
     * @method countOf
     * @summary Returns a count of the number of times aNode is found in the
     *     array.
     * @param {Node|TP.dom.Node} aNode The element whose value is checked
     *     against.
     * @param {String} aTest Which test to use, TP.IDENTITY or TP.EQUALITY. The
     *     default is TP.EQUALITY.
     * @returns {Number} The number of occurrences of aNode.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('detect',
function(aFunction, deep, breadthFirst) {

    /**
     * @method detect
     * @summary Runs aFunction iteratively over each element of the receiver
     *     and returns the first TP.dom.ElementNode for which aFunction is true.
     * @param {Function} aFunction A function taking 2 parameters, the current
     *     wrapped child or descendant node and index.
     * @param {Boolean} [deep=false] Should the iteration cover all descendant
     *     nodes as well? Defaults to false so only direct children are
     *     involved.
     * @param {Boolean} [breadthFirst=false] Breadth first if true. Default is
     *     false, meaning depth first. Only used when deep is true.
     * @returns {TP.dom.Node} The first element detected by the supplied
     *     Function.
     */

    var node;

    node = this.getNativeNode();

    if (TP.ifInvalid(deep, false)) {
        return TP.wrap(TP.nodeDetectDescendant(
                                        node,
                                        TP.INVOKE_WRAPPED(aFunction),
                                        null,
                                        breadthFirst));
    } else {
        return TP.wrap(TP.nodeDetectChildNode(
                                        node,
                                        TP.INVOKE_WRAPPED(aFunction)));
    }
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('detectInvoke',
function() {

    /**
     * @method detectInvoke
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('detectMax',
function() {

    /**
     * @method detectMax
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('detectMin',
function() {

    /**
     * @method detectMin
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('difference',
function() {

    /**
     * @method difference
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('disjunction',
function() {

    /**
     * @method disjunction
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('empty',
function() {

    /**
     * @method empty
     * @summary Removes all content nodes (child nodes) from the receiver's
     *     native node, effectively emptying the node.
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    var node;

    node = this.getNativeNode();

    if (this.shouldFlagChanges()) {
        //  if we're flagging rather than 'doing' then we set the change flag to
        //  TP.DELETE and that's all
        TP.elementFlagChange(node, TP.SELF, TP.DELETE);

        TP.ifTrace() && TP.$DEBUG ?
            TP.trace('Node flagged: ' + TP.nodeAsString(node)) : 0;
    } else {
        //  if we're not flagging then just rip it out of the DOM
        TP.nodeEmptyContent(node);
    }

    this.changed('content', TP.DELETE);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('flatten',
function() {

    /**
     * @method flatten
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getItems',
function() {

    /**
     * @method getItems
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getIterator',
function() {

    /**
     * @method getIterator
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getIteratorType',
function() {

    /**
     * @method getIteratorType
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getSize',
function() {

    /**
     * @method getSize
     * @summary Returns the size of the receiver. For TP.dom.CollectionNodes,
     *     this is the number of *child* (not descendant) nodes that they have.
     * @returns {Number} The size of the receiver.
     */

    var node;

    node = this.getNativeNode();

    return node.childNodes.length;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getValues',
function() {

    /**
     * @method getValues
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('grep',
function() {

    /**
     * @method grep
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('groupBy',
function() {

    /**
     * @method groupBy
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('injectInto',
function(aValue, aFunction, deep, breadthFirst) {

    /**
     * @method injectInto
     * @summary Performs the function with each element of the receiver as the
     *     first argument and aValue as the second argument. The current index
     *     is provided as the third argument.
     * @description injectInto allows you to pass an additional value to the
     *     function along with each element of the receiver as it performs the
     *     function. This is useful when attempting to do an operation like
     *     summing all the values in an array where the added variable you pass
     *     in holds the sum.
     *
     *     The actual behavior is embodied in:
     *
     *     aValue = aFunction(this[index], aValue, index)
     *
     *     You should therefore pass a function which expects three arguments
     *     where the first argument is the current array element. On completion
     *     the injected value is returned.
     * @param {Object} aValue The value to pass as the second argument to
     *     aFunction.
     * @param {Function} aFunction A function which performs some action with
     *     the TP.dom.Nodes it is passed and returns aValue.
     * @param {Boolean} [deep=false] Should the iteration cover all descendant
     *     nodes as well? Defaults to false so only direct children are
     *     involved.
     * @param {Boolean} [breadthFirst=false] Breadth first if true. Default is
     *     false, meaning depth first. Only used when deep is true.
     * @returns {Object} The value of performing aFunction with aValue over the
     *     receiver.
     */

    var node;

    node = this.getNativeNode();

    if (TP.ifInvalid(deep, false)) {
        return TP.nodeGetDescendants(node, breadthFirst).injectInto(
                                                aValue,
                                                TP.INVOKE_WRAPPED(aFunction));
    } else {
        return TP.ac(node.childNodes).injectInto(
                                                aValue,
                                                TP.INVOKE_WRAPPED(aFunction));
    }
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('intersection',
function() {

    /**
     * @method intersection
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('isSortedCollection',
function() {

    /**
     * @method isSortedCollection
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('merge',
function() {

    /**
     * @method merge
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('partition',
function() {

    /**
     * @method partition
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('perform',
function(aFunction, deep, breadthFirst) {

    /**
     * @method perform
     * @summary Runs aFunction iteratively over each element of the receiver.
     * @param {Function} aFunction A function taking 2 parameters, the current
     *     wrapped child or descendant node and index.
     * @param {Boolean} [deep=false] Should the iteration cover all descendant
     *     nodes as well? Defaults to false so only direct children are
     *     involved.
     * @param {Boolean} [breadthFirst=false] Breadth first if true. Default is
     *     false, meaning depth first. Only used when deep is true.
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    var node;

    node = this.getNativeNode();

    if (TP.ifInvalid(deep, false)) {
        TP.nodeDescendantsPerform(
                            node,
                            TP.INVOKE_WRAPPED(aFunction),
                            null,
                            breadthFirst);
    } else {
        TP.nodeChildNodesPerform(node, TP.INVOKE_WRAPPED(aFunction));
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('performInvoke',
function() {

    /**
     * @method performInvoke
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('performSet',
function() {

    /**
     * @method performSet
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('performUntil',
function() {

    /**
     * @method performUntil
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('performWhile',
function() {

    /**
     * @method performWhile
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------
//  performWith         Kernel
//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('reject',
function(aFunction, deep, breadthFirst) {

    /**
     * @method reject
     * @summary Runs aFunction iteratively over each element of the receiver
     *     and returns an Array containing the items for which the function
     *     returns false. In other words, the function returns true if the item
     *     should be rejected from the result set.
     * @param {Function} aFunction A function taking 2 parameters, the current
     *     wrapped child or descendant node and index. This function should
     *     return true if the item should be removed from the result set.
     * @param {Boolean} [deep=false] Should the iteration cover all descendant
     *     nodes as well? Defaults to false so only direct children are
     *     involved.
     * @param {Boolean} [breadthFirst=false] Breadth first if true. Default is
     *     false, meaning depth first. Only used when deep is true.
     * @returns {TP.dom.Node[]} An Array of TP.dom.Nodes that weren't rejected
     *     by the supplied Function.
     */

    var node;

    node = this.getNativeNode();

    if (TP.ifInvalid(deep, false)) {
        return TP.wrap(TP.nodeGetDescendants(node, breadthFirst).reject(
                                                TP.INVOKE_WRAPPED(aFunction)));
    } else {
        return TP.wrap(TP.ac(node.childNodes).reject(
                                                TP.INVOKE_WRAPPED(aFunction)));
    }
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('remove',
function(attributeName) {

    /**
     * @method remove
     * @summary Removes the named attribute from the receiver when dealing with
     *     a non-XPath attribute specification, or all nodes matching the XPath
     *     when provided with an XPath.
     * @description In this type, if an XPath is supplied, then it is used to
     *     locate nodes (including attribute nodes) to remove. NB: You *must*
     *     use a '/', '[', '@' or '.' to allow the XPath mechanism to trigger
     *     properly.
     * @param {String} attributeName The attribute name to remove.
     * @exception TP.sig.InvalidParameter
     * @returns {Number}
     */

    var path;

    if (TP.isEmpty(attributeName)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  If the attributeName matches any char that would indicate a valid
    //  XPath expression, then we will remove nodes using that path.
    if (TP.regex.XPATH_PATH.test(attributeName)) {
        path = TP.xpc(attributeName);
        path.shouldFlagChanges(this.shouldFlagChanges());

        //  This will signal change and flag changes (if enabled)
        return path.execRemove(this);
    }

    //  This will signal change and flag changes (if enabled)
    return this.removeAttribute(attributeName);
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('removeAll',
function() {

    /**
     * @method removeAll
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('replace',
function() {

    /**
     * @method replace
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('replaceAll',
function() {

    /**
     * @method replaceAll
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('select',
function(aFunction, deep, breadthFirst) {

    /**
     * @method select
     * @summary Runs aFunction iteratively over each element of the receiver
     *     and returns an Array containing the elements for which the function
     *     returns true.
     * @param {Function} aFunction A function taking 2 parameters, the current
     *     wrapped child or descendant node and index. This function should
     *     return true if the item should be included in the result set.
     * @param {Boolean} [deep=false] Should the iteration cover all descendant
     *     nodes as well? Defaults to false so only direct children are
     *     involved.
     * @param {Boolean} [breadthFirst=false] Breadth first if true. Default is
     *     false, meaning depth first. Only used when deep is true.
     * @returns {TP.dom.Node[]} An Array of TP.dom.Nodes that were selected by
     *     the supplied Function.
     */

    var node;

    node = this.getNativeNode();

    if (TP.ifInvalid(deep, false)) {
        return TP.wrap(TP.nodeSelectDescendants(node,
                                                TP.INVOKE_WRAPPED(aFunction),
                                                null,
                                                breadthFirst));
    } else {
        return TP.wrap(TP.nodeSelectChildNodes(node,
                                                TP.INVOKE_WRAPPED(aFunction)));
    }
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('union',
function() {

    /**
     * @method union
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('unique',
function() {

    /**
     * @method unique
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------
//  TP.api.IndexedCollection API
//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('addAt',
function(anObject, anIndex, aPosition) {

    /**
     * @method addAt
     * @summary Inserts content into the receiver at the index location
     *     provided. The position defines a "before" or "after" orientation to
     *     the insertion. The default is AfterEnd so the result is like an
     *     appendChild operation.
     * @param {Node|TP.dom.Node|Nodelist} anObject A node or nodelist
     *     containing the new content.
     * @param {Number} anIndex The numerical index, corresponding to a childNode
     *     index, or an XPath which selects nodes as "pivot" points.
     * @param {String} aPosition The position to place the content relative to
     *     the receiver. This should be one of four values: TP.BEFORE_BEGIN,
     *     TP.AFTER_BEGIN, TP.BEFORE_END, TP.AFTER_END. Default is TP.AFTER_END.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.IndexOutOfRange
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    var node,

        obj,

        position,
        child,
        results,

        len,
        i,

        objLen,
        j;

    node = this.getNativeNode();

    if (!TP.isNode(anObject) &&
        !TP.isKindOf(anObject, 'TP.dom.Node') &&
        !TP.isNodeList(anObject)) {
        return this.raise('TP.sig.InvalidParameter',
                            'Must provide a Node or list of Nodes.');
    }

    obj = TP.unwrap(anObject);

    //  default to an appendChild
    position = TP.ifInvalid(aPosition, TP.AFTER_END);

    //  for XPaths we find the child nodes by running the path, then we can
    //  use them as the pivot points for the content insertion
    if (TP.regex.XPATH_PATH.test(anIndex)) {
        results = this.evaluateXPath(anIndex);
        if (TP.isEmpty(results)) {
            return this;
        }

        //  for each node we need to insert the content, either a node or a
        //  set of nodes from a nodelist
        len = results.getSize();
        for (i = 0; i < len; i++) {
            if (TP.isNodeList(obj)) {
                objLen = obj.length;
                for (j = 0; j < objLen; j++) {
                    try {
                        TP.elementInsertContent(
                                        results[i], obj[j], position);
                    } catch (e) {
                        TP.ifError() ?
                            TP.error(TP.ec(e, 'Error adding node at.')) : 0;
                    }
                }
            } else {
                try {
                    TP.elementInsertContent(results[i], obj, position);
                } catch (e) {
                    TP.ifError() ?
                        TP.error(TP.ec(e, 'Error adding node at.')) : 0;
                }
            }
        }

        this.changed('content', TP.INSERT);

        return this;
    } else {
        if (!TP.isNumber(parseInt(anIndex, 10))) {
            this.raise('TP.sig.InvalidParameter',
                        'Index must be an XPath or a Number: ' + anIndex);

            return this;
        }

        if (node.childNodes.length < anIndex || anIndex < 0) {
            return this.raise('TP.sig.IndexOutOfRange');
        }

        //  empty? then we insert, or iterate and insert as needed
        if (node.childNodes.length === 0 && anIndex === 0) {
            if (TP.isNodeList(obj)) {
                objLen = obj.length;

                for (i = 0; i < objLen; i++) {
                    TP.nodeAppendChild(node, obj[i]);
                }
            } else {
                TP.nodeAppendChild(node, obj);
            }

            this.changed('content', TP.INSERT);

            return this;
        }

        child = node.childNodes[anIndex];

        if (TP.isNodeList(obj)) {
            //  if we have the child as a starting point and we're going to
            //  insert a block of data "before" it then we want to insert
            //  from the start to the end of the collection so each new item
            //  goes between the last insertion and the child. if we're
            //  going after however, we want to insert from the end of the
            //  list forward, so the last item we insert is the first one in
            //  the list.
            switch (position) {
                case TP.BEFORE_END:
                case TP.BEFORE_BEGIN:

                    objLen = obj.length;
                    for (i = 0; i < objLen; i++) {
                        results = TP.elementInsertContent(child,
                                                            obj[i],
                                                            aPosition);
                    }

                    break;

                default:

                    for (i = obj.length - 1; i >= 0; i--) {
                        results = TP.elementInsertContent(child,
                                                            obj[i],
                                                            aPosition);
                    }

                    break;
            }
        } else {
            results = TP.elementInsertContent(child, obj, aPosition);
        }

        if (TP.isValid(results)) {
            this.changed('content', TP.INSERT);
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('addAllAt',
function() {

    /**
     * @method addAllAt
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('at',
function(anIndex) {

    /**
     * @method at
     * @summary Returns the content at the index provided. A synonym for get().
     *     For TP.dom.CollectionNodes, the 'index' is an attribute name.
     * @returns {String|Object} The value of the desired index/attribute.
     */

    return this.get(anIndex);
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('atAll',
function() {

    /**
     * @method atAll
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('atAllPut',
function() {

    /**
     * @method atAllPut
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('atIfInvalid',
function() {

    /**
     * @method atIfInvalid
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('atIfNull',
function() {

    /**
     * @method atIfNull
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('atIfUndefined',
function() {

    /**
     * @method atIfUndefined
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('atPut',
function() {

    /**
     * @method atPut
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('atPutIfAbsent',
function() {

    /**
     * @method atPutIfAbsent
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('containsKey',
function() {

    /**
     * @method containsKey
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('containsValue',
function() {

    /**
     * @method containsValue
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('detectKeyAt',
function() {

    /**
     * @method detectKeyAt
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getKeys',
function() {

    /**
     * @method getKeys
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getKVPairs',
function() {

    /**
     * @method getKVPairs
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getPosition',
function() {

    /**
     * @method getPosition
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getPositions',
function() {

    /**
     * @method getPositions
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('grepKeys',
function() {

    /**
     * @method grepKeys
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('performOver',
function() {

    /**
     * @method performOver
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('removeAt',
function(anIndex) {

    /**
     * @method removeAt
     * @summary Removes content at the index provided. Note that the index may
     *     be either a numerical value, or an XPath which selects nodes for
     *     removal.
     * @param {Number|String} anIndex An integer index, or an XPath which
     *     selects nodes for removal.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    var node,
        path,
        child;

    node = this.getNativeNode();

    //  if it looks like an XPath then we'll do it that way...
    if (TP.regex.XPATH_PATH.test(anIndex)) {
        path = TP.xpc(anIndex);
        path.shouldFlagChanges(this.shouldFlagChanges());

        return path.execRemove(this);
    }

    if (!TP.isNumber(parseInt(anIndex, 10))) {
        this.raise('TP.sig.InvalidParameter',
                    'Index must be an XPath or a Number: ' + anIndex);

        return this;
    }

    if (node.childNodes.length < anIndex || anIndex < 0) {
        return this.raise('TP.sig.IndexOutOfRange');
    }

    child = node.childNodes[anIndex];

    if (this.shouldFlagChanges()) {
        //  if we're flagging rather than 'doing' then we set the change flag to
        //  TP.DELETE and that's all
        TP.elementFlagChange(child, TP.SELF, TP.DELETE);

        TP.ifTrace() && TP.$DEBUG ?
            TP.trace('Node flagged: ' + TP.nodeAsString(child)) : 0;
    } else {
        //  if we're not flagging then just rip it out of the DOM
        TP.nodeDetach(child);
    }

    this.changed('content', TP.DELETE);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('removeAtAll',
function() {

    /**
     * @method removeAtAll
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('removeKey',
function() {

    /**
     * @method removeKey
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('removeKeys',
function() {

    /**
     * @method removeKeys
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('transpose',
function() {

    /**
     * @method transpose
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------
//  TP.api.OrderedCollection API
//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('addAfter',
function() {

    /**
     * @method addAfter
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('addAllAfter',
function() {

    /**
     * @method addAllAfter
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('addAllBefore',
function() {

    /**
     * @method addAllBefore
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('addAllFirst',
function() {

    /**
     * @method addAllFirst
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('addAllLast',
function() {

    /**
     * @method addAllLast
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('addBefore',
function() {

    /**
     * @method addBefore
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('addFirst',
function() {

    /**
     * @method addFirst
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('addLast',
function() {

    /**
     * @method addLast
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('after',
function() {

    /**
     * @method after
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('before',
function() {

    /**
     * @method before
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('first',
function(aNumber) {

    /**
     * @method first
     * @summary Returns the first N *immediate children* elements of the
     *     receiver where N defaults to 1.
     * @param {Number} aNumber The number of elements to return. When N is
     *     greater than 1 the return value is a new array.
     * @returns {Object} The first N elements (TP.dom.Nodes) in this node.
     */

    var node,

        childNodesArr,
        result;

    node = this.getNativeNode();

    childNodesArr = TP.ac(node.childNodes);
    result = childNodesArr.first(aNumber);

    return TP.wrap(result);
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('getLastPosition',
function() {

    /**
     * @method getLastPosition
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('last',
function(aNumber) {

    /**
     * @method last
     * @summary Returns the last N *immediate children* elements of the
     *     receiver where N defaults to 1.
     * @param {Number} aNumber The number of elements to return. When N is
     *     greater than 1 the return value is a new array.
     * @returns {Object} The last N elements (TP.dom.Nodes) in this node.
     */

    var node,

        childNodesArr,
        result;

    node = this.getNativeNode();

    childNodesArr = TP.ac(node.childNodes);
    result = childNodesArr.last(aNumber);

    return TP.wrap(result);
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('orderedBy',
function() {

    /**
     * @method orderedBy
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('removeFirst',
function() {

    /**
     * @method removeFirst
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('removeLast',
function() {

    /**
     * @method removeLast
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('replaceFirst',
function() {

    /**
     * @method replaceFirst
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('replaceLast',
function() {

    /**
     * @method replaceLast
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('reverse',
function() {

    /**
     * @method reverse
     * @summary
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------
//  Content Processing
//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('awaken',
function() {

    /**
     * @method awaken
     * @summary This method invokes the 'awaken' functionality of the tag
     *     processing system, to provide 'post-render' awakening of various
     *     features such as events and CSS styles.
     * @returns {TP.dom.Node} The receiver.
     */

    var node,
        shouldProcess;

    node = this.getNativeNode();

    //  Initially we're set to process this markup.
    shouldProcess = true;

    //  But if the node is an Element and it has an attribute of
    //  'tibet:no-awaken', then skip processing it.
    if (TP.isElement(node) &&
        TP.elementHasAttribute(node, 'tibet:no-awaken', true)) {
        shouldProcess = false;
    }

    if (shouldProcess) {
        TP.nodeAwakenContent(this.getNativeNode());
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('compile',
function(aRequest, replaceNode, alternateNode) {

    /**
     * @method compile
     * @summary This method invokes the 'compile' functionality of the tag
     *     processing system, to provide conversion from authored markup into
     *     markup that can be understood by the platform.
     * @description It is important to note that this method will use the
     *     receiver's native node as the source for compilation *and will
     *     reassign the receiver's native node reference to any new content
     *     produced*. It will *not*, however, replace it's old node in that
     *     node's hierarchy unless the 'replaceNode' flag is true (or unless the
     *     receiver's compilation process has already done it).
     * @param {TP.sig.Request} aRequest A request containing control parameters.
     * @param {Boolean} [replaceNode=false] Whether or not this method will
     *     replace its native node in that node's hierarchy. Note that,
     *     depending on the receiver's compilation process, this might have
     *     already been done.
     * @param {Node} [alternateNode] An alternate node to use in place of the
     *     native node of the receiver when compiling. This parameter is
     *     optional.
     * @returns {TP.dom.CollectionNode} The receiver or a new object if the
     *     tag content compiles to a different kind of tag than the receiver.
     */

    var originalNode,

        node,

        shouldProcess,

        foundCached,
        nodeLID,

        request,

        processor,

        nodeGID,

        workNode,
        newNode,

        type;

    originalNode = this.getNativeNode();

    //  If an alternate node was supplied, use it (and set it as our native node
    //  so that the compilation machinery will work properly).
    if (TP.isNode(alternateNode)) {

        //  Remove all TP.GLOBAL_ID and TP.EVENT_IDs slots from the original and
        //  alternate nodes, so that these are recomputed when being swapped
        //  around the DOM.
        delete originalNode[TP.EVENT_IDS];
        delete originalNode[TP.GLOBAL_ID];

        delete alternateNode[TP.EVENT_IDS];
        delete alternateNode[TP.GLOBAL_ID];

        //  Remove all TP.GLOBAL_ID and TP.EVENT_IDs slots from any elements
        //  under the alternate node that have them - this will cause them to
        //  reset.
        if (TP.isCollectionNode(alternateNode)) {
            TP.ac(alternateNode.getElementsByTagName('*')).forEach(
                    function(anElem) {
                        delete anElem[TP.EVENT_IDS];
                        delete anElem[TP.GLOBAL_ID];
                    });
        }

        node = alternateNode;
        this.setNativeNode(alternateNode);
    } else {
        node = originalNode;
    }

    //  before we worry about anything else let's make sure we've got the
    //  proper frame of reference for any URI content
    if (TP.isDocument(node)) {
        this.addTIBETSrc(this.get('uri'));
        this.addXMLBase(this.get('uri'), null, aRequest);
    }

    //  Initially we're set to process this markup.
    shouldProcess = true;

    //  Initially we've not found anything in the compiled markup cache.
    foundCached = false;

    if (TP.isElement(node)) {
        //  If the node has an attribute of 'tibet:no-compile', then skip
        //  processing it.
        if (TP.elementHasAttribute(node, 'tibet:no-compile', true)) {
            shouldProcess = false;
        } else {
            //  Otherwise, retrieve or compute a local ID for the node and check
            //  with our compiled document cache.
            nodeLID = TP.lid(node);
            newNode = TP.$compiled_doc_cache.at(nodeLID);

            //  If we have a cached node, but we're recasting, then remove the
            //  cache entry and set newNode to null so that we go back through
            //  the tag compiler.
            if (TP.isNode(newNode) &&
                TP.dom.CollectionNode.$get('$isRecasting')) {
                TP.$compiled_doc_cache.removeKey(nodeLID);
                newNode = null;
            }

            //  If we successfully found an entry in the cache, then set the
            //  flags to not process and indicate that we found an entry in the
            //  cache.
            if (TP.isNode(newNode)) {
                shouldProcess = false;
                foundCached = true;

                //  Clone the node we found in the cache.
                newNode = TP.nodeCloneNode(newNode);
            }
        }
    }

    //  If the node is a Document and it's documentElement has an attribute of
    //  'tibet:no-compile', then skip processing it.
    if (TP.isDocument(node) &&
        TP.elementHasAttribute(
                        node.documentElement, 'tibet:no-compile', true)) {
        shouldProcess = false;
    }

    if (shouldProcess) {
        request = TP.request(aRequest);

        //  We do *not* clone our native node before we process it - the
        //  processing system will not process a detached node so we process it
        //  in situ.

        //  Allocate a tag processor and initialize it with the COMPILE_PHASES
        processor = TP.tag.TagProcessor.constructWithPhaseTypes(
                                        TP.tag.TagProcessor.COMPILE_PHASES);

        //  Capture this before processing - the following steps will virtually
        //  detach this node.
        nodeGID = TP.gid(node);

        //  If we're working with a Document, get it's document element - we
        //  don't really process Document nodes.
        if (TP.isDocument(node)) {
            workNode = node.documentElement;
        } else {
            workNode = node;
        }

        //  Wrap the work node in a 'root element for processing'. This is
        //  because, the way the transformation engine works, it holds onto the
        //  root node reference as it processes and replaces, so we want to give
        //  it a root that means nothing to the caller of this method. Also,
        //  this facilitates processing DocumentFragments in case we are one of
        //  those.
        workNode = TP.elem('<processingroot>' +
                            TP.str(workNode) +
                            '</processingroot>');

        if (!TP.isCollectionNode(workNode)) {
            request.fail('work node is not a collection node', TP.FAILED);
            return this;
        }

        //  Process the tree of markup
        processor.processTree(workNode, request);

        //  Pluck the first child out of our faked 'root' from above.
        newNode = workNode.firstChild;

        //  Signal from the node that compile processing is complete.
        TP.signal(nodeGID, 'TP.sig.CompileComplete');

        //  If the shell request failed then our enclosing request has failed.
        if (request.didFail()) {
            request.fail(request.getFaultText(),
                            request.getFaultCode(),
                            request.getFaultInfo());
            return this;
        }

        //  If we successfully retrieved or computed a local ID above, that must
        //  mean that the source node was an Element. Cache it here under that
        //  local ID.
        if (TP.notEmpty(nodeLID)) {
            TP.$compiled_doc_cache.atPut(nodeLID, newNode);
        }
    } else if (!foundCached) {

        //  We're not processing - exit here.
        return this;
    }

    //  if our processing produced a new native node of the same type as our
    //  original content (so we're still the right kind of wrapper) we can
    //  update our internal node content. If not we'll need to get a new
    //  wrapper and return that as the result.

    if (!TP.isNode(newNode)) {

        return newNode;

    } else if (TP.isDocument(node)) {

        //  The original node was a document, so set its document element to the
        //  newly produced node.
        TP.nodeReplaceChild(node, newNode, node.documentElement, false);

    } else if ((type = TP.dom.Node.getConcreteType(newNode)) ===
                                                            this.getType()) {

        //  if our processing produced a new native node of the same type as our
        //  original native node (so we're still the right kind of wrapper) we
        //  can update our internal node content.
        if (!TP.nodeIsDetached(originalNode) && TP.isTrue(replaceNode)) {

            newNode = TP.elementReplaceWith(
                                originalNode, newNode, null, false);
        }
        this.setNativeNode(newNode);

    } else {
        //  It's not so we'll need to get a new wrapper and return that as the
        //  result.
        return type.construct(newNode);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('deaden',
function() {

    /**
     * @method deaden
     * @summary This method invokes the 'deaden' functionality of the tag
     *     processing system, to provide 'post-render' deadening of various
     *     features such as events and CSS styles.
     * @description You don't normally call this - in fact, it's rarely invoked.
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    var node,
        shouldProcess;

    node = this.getNativeNode();

    //  Initially we're set to process this markup.
    shouldProcess = true;

    //  But if the node is an Element and it has an attribute of
    //  'tibet:no-awaken', then skip processing it.
    if (TP.isElement(node) &&
        TP.elementHasAttribute(node, 'tibet:no-awaken', true)) {
        shouldProcess = false;
    }

    if (shouldProcess) {
        TP.nodeDeadenContent(this.getNativeNode());
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('processTP_sig_Request',
function(aRequest) {

    /**
     * @method processTP_sig_Request
     * @summary Processes the receiver's content. The processing is done via
     *     the TSH as a standard set of execution phases defined as sets of
     *     sequenced phase names on the TSH type.
     * @param {TP.sig.Request} aRequest A request containing control parameters.
     * @returns {TP.sig.Response} A response containing the processing results.
     */

    var request,
        result,
        response;

    request = TP.request(aRequest);
    result = this.compile(request);

    response = request.getResponse(result);
    request.complete(result);

    return response;
});

//  ------------------------------------------------------------------------

TP.dom.CollectionNode.Inst.defineMethod('$escapeCSSConstructs',
function() {

    /**
     * @method $escapeCSSConstructs
     * @summary An internal method that makes sure that any link or style
     *     elements containing external references are escaped before performing
     *     an XSLT operations. Failure to do this can cause Mozilla-based
     *     browsers to crash.
     * @returns {TP.dom.CollectionNode} The receiver.
     */

    var node,
        newNode;

    node = this.getNativeNode();

    if (TP.canInvoke(TP, '$nodeEscapeCSSConstructs')) {
        newNode = TP.$nodeEscapeCSSConstructs(node);
        if (newNode !== node) {
            this.setNativeNode(newNode, false);
        }
    }

    return this;
});

//  ========================================================================
//  TP.dom.DocumentFragmentNode
//  ========================================================================

TP.dom.CollectionNode.defineSubtype('DocumentFragmentNode');

//  ------------------------------------------------------------------------

TP.dom.DocumentFragmentNode.Inst.defineMethod('addTIBETSrc',
function(aURI, force) {

    /**
     * @method addTIBETSrc
     * @summary Adds a TP.SRC_LOCATION value to the ownerDocument of the
     *     receiver (or the receiver itself, if its the Document). This method
     *     is normally invoked when the Node is "owned" by a URI to ensure
     *     proper ID generation can occur.
     * @description At this level, this method is a no-op.
     * @param {TP.uri.URI|String} aURI An optional URI value. If not provided
     *     then the receiver's uri is used.
     * @param {Boolean} force True to force setting the value even if the node
     *     already has one. Default is false.
     * @returns {TP.dom.Node} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentFragmentNode.Inst.defineMethod('addXMLBase',
function(aURI, force, aParamHash) {

    /**
     * @method addXMLBase
     * @summary Adds an XML Base value to the documentElement of the receiver.
     *     This method is normally invoked when the Node is "owned" by a URI to
     *     ensure proper base-aware attribute computation can occur. If the
     *     receiver's document already has xml:base definition on the
     *     documentElement this method will return without altering the content.
     * @description At this level, this method is a no-op.
     * @param {TP.uri.URI|String} aURI An optional URI value. If not provided
     *     then the receiver's uri is used.
     * @param {Boolean} force True to force setting the value even if the node
     *     already has one. Default is false.
     * @param {TP.core.Hash|TP.sig.Request} aParamHash A set of key/value pairs
     *     which should be used to control the transformation. If the 'aURI'
     *     value is null and a 'uri' slot is defined on this object, that
     *     object's String value will be used as the XML Base value.
     * @returns {TP.dom.Node} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentFragmentNode.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a TIBET source code string.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    return 'TP.tpfrag(\'' + this.asString() + '\')';
});

//  ------------------------------------------------------------------------

TP.dom.DocumentFragmentNode.Inst.defineMethod('getAttribute',
function(attributeName) {

    /**
     * @method getAttribute
     * @summary Returns the value of the attribute provided.
     * @description At this level, this method is a no-op.
     * @param {String} attributeName The attribute to find.
     * @returns {undefined} No attributes for DocumentFragments.
     */

    return;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentFragmentNode.Inst.defineMethod('getAttributes',
function(attributeName, stripPrefixes) {

    /**
     * @method getAttributes
     * @summary Returns a hash of zero to N attribute name/value pairs,
     *     potentially matching the attribute name provided. For document nodes
     *     this operation effectively operates on the document's
     *     documentElement.
     * @description At this level, this method is a no-op.
     * @param {String|RegExp} attributeName An attributeName "search" criteria
     *     of the form 'wholename' '*:localname' or 'prefix:*' or any RegExp.
     *     This is optional.
     * @param {Boolean} stripPrefixes Whether or not to strip any namespace
     *     prefixes from the attribute names as they are populated into the
     *     return value.
     * @returns {undefined} No attributes for DocumentFragments.
     */

    return;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentFragmentNode.Inst.defineMethod('getTemplateName',
function() {

    /**
     * @method getTemplateName
     * @summary Returns the name of any associated template for the receiver.
     * @description At this level, this method is a no-op.
     * @returns {undefined} No template name for DocumentFragments.
     */

    return;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentFragmentNode.Inst.defineMethod('hasAttribute',
function(attributeName) {

    /**
     * @method hasAttribute
     * @summary Returns whether or not the receiver has the named attribute
     *     provided. This method essentially emulates the native node
     *     hasAttribute call. Note that this call is only valid for Element
     *     nodes; when invoked on a document wrapper the documentElement is
     *     targeted.
     * @description At this level, this method is a no-op.
     * @param {String} attributeName The attribute to test.
     * @exception TP.sig.InvalidOperation
     * @returns {Boolean} Whether or not the receiver has the named attribute.
     */

    return false;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentFragmentNode.Inst.defineMethod('hasXMLBase',
function() {

    /**
     * @method hasXMLBase
     * @summary Returns true if xml:base references are found on or above the
     *     receiver.
     * @description At this level, this method is a no-op.
     * @returns {Boolean} Whether an xml:base reference was found on or above
     *     the receiver.
     */

    return false;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentFragmentNode.Inst.defineMethod('removeAttribute',
function(attributeName) {

    /**
     * @method removeAttribute
     * @summary Removes the named attribute. This version is a wrapper around
     *     the native element node removeAttribute call which attempts to handle
     *     standard change notification semantics for native nodes as well as
     *     proper namespace management.
     * @description At this level, this method is a no-op.
     * @param {String} attributeName The attribute name to remove.
     * @returns {undefined} No attributes for DocumentFragments.
     */

    return;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentFragmentNode.Inst.defineMethod('setAttribute',
function(attributeName, attributeValue) {

    /**
     * @method setAttribute
     * @summary Sets the value of the named attribute. This version is a
     *     wrapper around the native element node setAttribute call which
     *     attempts to handle standard change notification semantics for native
     *     nodes as well as proper namespace management.
     * @description At this level, this method is a no-op.
     * @param {String} attributeName The attribute name to set.
     * @param {Object} attributeValue The value to set.
     * @returns {undefined} No attributes for DocumentFragments.
     */

    return;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentFragmentNode.Inst.defineMethod('setAttributes',
function(attributeHash) {

    /**
     * @method setAttributes
     * @summary Sets the value of the attributes provided using the supplied
     *     TP.core.Hash. For document nodes this operation effectively operates
     *     on the document's documentElement.
     * @description At this level, this method is a no-op.
     * @param {TP.core.Hash} attributeHash The attributes to set.
     * @returns {undefined} No attributes for DocumentFragments.
     */

    return;
});

//  ------------------------------------------------------------------------
//  Content Processing
//  ------------------------------------------------------------------------

TP.dom.DocumentFragmentNode.Inst.defineMethod('awaken',
function() {

    /**
     * @method awaken
     * @summary This method invokes the 'awaken' functionality of the tag
     *     processing system, to provide 'post-render' awakening of various
     *     features such as events and CSS styles.
     * @returns {TP.dom.Node} The receiver.
     */

    //  DocumentFragments aren't responsible for awakening their content - for
    //  the most part they've already been 'flattened out' by the time their
    //  inserted into a visual DOM (unless they've been created there - but then
    //  you're already dealing with awakened nodes).

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentFragmentNode.Inst.defineMethod('compile',
function(aRequest) {

    /**
     * @method compile
     * @summary This method invokes the 'compile' functionality of the tag
     *     processing system, to provide conversion from authored markup into
     *     markup that can be understood by the platform.
     * @param {TP.sig.Request} aRequest A request containing control parameters.
     * @returns {TP.dom.CollectionNode} The receiver or a new object if the
     *     tag content compiles to a different kind of tag than the receiver.
     */

    var node,

        request,

        processor,

        childNodes,
        len,
        i,

        childNode,
        nodeGID;

    node = this.getNativeNode();

    request = TP.request(aRequest);

    //  Allocate a tag processor and initialize it with the COMPILE_PHASES
    processor = TP.tag.TagProcessor.constructWithPhaseTypes(
                                    TP.tag.TagProcessor.COMPILE_PHASES);

    childNodes = TP.nodeGetChildNodes(node);

    len = childNodes.getSize();

    //  Process each child that we have.
    for (i = 0; i < len; i++) {

        childNode = childNodes.at(i);

        //  Capture this before processing - processing this node might very
        //  well detach it.
        nodeGID = TP.gid(childNode);

        //  But if the node is an Element and it has an attribute of
        //  'tibet:no-compile', then skip processing it.
        if (TP.isElement(childNode) &&
            TP.elementHasAttribute(childNode, 'tibet:no-compile', true)) {
            continue;
        }

        processor.processTree(childNode, request);

        //  If the shell request failed then our enclosing request has failed.
        if (request.didFail()) {
            aRequest.fail(request.getFaultText(),
                            request.getFaultCode(),
                            request.getFaultInfo());
            return this;
        }

        //  Signal from the node that compile processing is complete.
        TP.signal(nodeGID, 'TP.sig.CompileComplete');
    }

    return this;
});

//  ------------------------------------------------------------------------
//  XPATH SUPPORT
//  ------------------------------------------------------------------------

TP.dom.DocumentFragmentNode.Inst.defineMethod('generateXPathTo',
function(aNode) {

    /**
     * @method generateXPathTo
     * @summary Generates a 'simple' XPath expression that would access the
     *     supplied node from the receiver's native node.
     * @description At this level, this method is a no-op.
     * @param {Node|TP.dom.Node} aNode The node to generate the path to.
     * @returns {undefined} No path generation for DocumentFragments.
     */

    return;
});

//  ========================================================================
//  TP.dom.ElementNode
//  ========================================================================

TP.dom.CollectionNode.defineSubtype('ElementNode');

//  allow for subtypes to be created based on namespace and localname
TP.dom.ElementNode.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  The attributes for this element type that are considered to 'boolean
//  attributes' that either exist or don't exist - this matters especially to
//  HTML (but not XHTML ;-) ).
TP.dom.ElementNode.Type.defineAttribute('booleanAttrs', TP.ac());

//  A cache of computed URI keys. This dictionary is used to avoid recomputing
//  the resource URI values for various keys. Note that the keys here mirror
//  those you'd normally see in TP.sys.cfg with respect to paths.
TP.dom.ElementNode.Type.defineAttribute('computedKeys', TP.hc());

//  The attributes for this element type that are considered to 'URI
//  attributes' that need XML Base/virtual URI resolution.
TP.dom.ElementNode.Type.defineAttribute('uriAttrs', TP.ac());

//  The attributes for this element type that are URI attributes that are also
//  'reloadable' - that is, if the system is configured to reload URIs and the
//  server that the resource loads from can send change notifications about URI
//  changes, this type will be messaged when the resource pointed to by one of
//  these URI attributes changes.
TP.dom.ElementNode.Type.defineAttribute('reloadableUriAttrs', TP.ac());

//  the node's template. this will be used when instances are constructed
//  with a TP.core.Hash incoming value
TP.dom.ElementNode.Type.defineAttribute('template');

//  a cache of URI locations and the TP.dom.ElementNode objects created from
//  that URI.
TP.dom.ElementNode.Type.defineAttribute('$resourceElements', TP.hc());

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('computeResourceExtension',
function(resource, mimeType) {

    /**
     * @method computeResourceExtension
     * @summary Returns the default extension to use for the resource and mime
     *     type provided. Information in TP.ietf.mime is used when a list of
     *     extensions is needed.
     * @param {String} resource The resource name. Typically template, style,
     *     style_{theme}, etc. but it could be essentially anything except the
     *     word 'resource' (since that would trigger a recursion).
     * @param {String} mimeType The mimeType for the resource being looked up.
     * @returns {String} The computed extension.
     */

    var res,
        ext,
        mime,
        extensions;

    res = resource.toLowerCase();

    //  If we have an explicit mapping for an extension we will avoid worrying
    //  about any mime type extension list and just rely on the explicit one.
    ext = this.get(res.asTitleCase() + 'Extension');
    if (TP.isEmpty(ext)) {

        //  Without an explicit extension we'll drop back to mime type and see
        //  if we can leverage that.
        mime = TP.ifInvalid(this.get(res + 'Mime'), mimeType);

        if (TP.isEmpty(mime)) {

            if (/^style_/.test(res)) {
                mime = TP.ietf.mime.CSS;
            } else if (/^template_/.test(res)) {
                mime = TP.ietf.mime.XHTML;
            } else {
                switch (res) {
                    case 'template':
                        mime = TP.ietf.mime.XHTML;
                        break;
                    case 'style':
                        mime = TP.ietf.mime.CSS;
                        break;
                    default:
                        mime = TP.ietf.mime.XML;
                        break;
                }
            }
        }

        //  Once we have a mime type we can fetch the extensions and default to
        //  the first one (the canonical one based on convention).
        extensions = TP.ietf.mime.getExtensions(mime);
        if (TP.notEmpty(extensions)) {
            ext = extensions.at(0);
        }
    }

    return ext;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('computeResourceURI',
function(resource, mimeType, fallback) {

    /**
     * @method computeResourceURI
     * @summary Computes a resource URI using information including a resource
     *     "name" and mime type (for use in determining potential extensions).
     *     This routine is leveraged by getResourceURI-invoked methods which
     *     need to compute default file paths.
     * @description The computation process goes through a number of checks:
     *
     *     First, we might be in a "rollup" state where tags which normally have
     *     their own file/uri need to use a uri path from a rolled up file.
     *     This check uses path.{resource}.rollup as a cfg key.
     *
     *     Second, tags in a namespace may be sharing a namespace-level
     *     resource file (which is a common form of limited rollup).
     *     This check uses path.{prefix}.{resource}.rollup as a cfg key.
     *
     *     Third, we might be using a specific resource file for the tag.
     *     This check uses path.{resourceName}.{resource}.rollup as a cfg key
     *     where resourceName is the receiver's getResourceTypeName() value.
     *
     *     If no config flag setting is found the type is queried via a call to
     *     get() with a property name of {resource}URI which will essentially
     *     check for a get{Resource}URI method or attribute value.
     *
     *     The receiver's namespace is then queried using the same get() call to
     *     let a namespace respond on behalf of its members.
     *
     *     Last, but not least a computation using the receiver's load path is
     *     used to try to find a file with a MIME-specific extension for the
     *     resource being computed. Basically we assume a tag's template and css
     *     are in the same directory with the tag javascript.
     *
     *     In all cases whatever value is found/computed is cached under a key
     *     of path.{name}.{res} for future lookups. These latter keys are
     *     not saved, they exist only at runtime.
     *
     * @param {String} resource The resource name. Typically template, style,
     *     style_{theme}, etc. but it could be essentially anything except the
     *     word 'resource' (since that would trigger a recursion).
     * @param {String} mimeType The mimeType for the resource being looked up.
     * @param {Boolean} [fallback] Whether or not to compute a fallback value
     *     if the computation returns an empty value (but not TP.NO_RESULT -
     *     those are considered non-empty).  Defaults to the value of
     *     'uri.<resource type>_fallback'.
     * @returns {String|TP.NO_RESULT|undefined} A properly computed URL in
     *     string form or TP.NO_RESULT if the receiver has specifically
     *     determined that it has no such resource.
     */

    var res,
        name,
        theme,
        cachekey,
        computed,
        prefix,
        key,
        value,
        type,
        ext,
        uri;

    if (!TP.isString(resource) || TP.isEmpty(resource) ||
            resource === 'resource') {
        return this.raise('TP.sig.InvalidParameter',
            'Must supply a valid resource name.');
    }

    res = resource.toLowerCase();
    name = this.getResourceTypeName();
    theme = /^style_/.test(res) ? theme = res.split('_').last() : '';

    //  ---
    //  source file and test file lookups.
    //  ---

    if (res === 'source') {
        return TP.objectGetSourcePath(this);
    }

    if (res === 'tests') {
        //  TODO: should _test be a config var?
        return TP.objectGetSourcePath(this).replace(/\.js$/, '_test.js');
    }

    //  ---
    //  cached value check
    //  ---

    //  If we've done computation before don't repeat it. Also, this serves
    //  as a way for individual types to provide a specific override via cfg.

    cachekey = 'path.' + name + '.' + res;

    computed = TP.dom.ElementNode.get('computedKeys');
    value = computed.at(cachekey);
    if (TP.notEmpty(value)) {
        return value;
    }

    //  ---
    //  resource-level rollup check
    //  ---

    //  Production-level rollups are done via the CLI and have to be able to
    //  override pretty much any other consideration in terms of computation
    //  order so we check those first.

    //  TODO:   should we use a project-specific one here?
    // key = 'path.' + project + '.' + res + '.rollup';
    key = 'path.' + res + '.rollup';
    value = TP.sys.cfg(key);
    if (TP.notEmpty(value)) {
        computed.atPut(cachekey, TP.uriNormalize(value));
        return value;
    }

    //  ---
    //  namespace-level rollup check
    //  ---

    prefix = this.getNamespacePrefix().toLowerCase();

    key = 'path.' + prefix + '.' + res + '.rollup';
    value = TP.sys.cfg(key);
    if (TP.notEmpty(value)) {
        computed.atPut(cachekey, TP.uriNormalize(value));
        return value;
    }

    //  ---
    //  resource-level flag check
    //  ---

    key = 'path.' + name + '.' + res;
    value = TP.sys.cfg(key);
    if (TP.notEmpty(value)) {
        computed.atPut(cachekey, TP.uriNormalize(value));
        return value;
    }

    //  ---
    //  receiver method
    //  ---

    //  Don't cause infinite recursion... (get('resource' + 'URI') etc.)
    if (res !== 'resource') {
        //  Must have asked for style_{theme} as the resource value.
        if (TP.notEmpty(theme)) {
            uri = this.get('themeURI', theme);
        } else {
            uri = this.get(res + 'URI');    // e.g. 'style' + 'URI'
        }
        if (TP.notEmpty(uri)) {
            if (!TP.isString(uri) && TP.isURI(uri)) {
                return uri.getVirtualLocation();
            }
            return uri;
        }
    }

    //  ---
    //  namespace method
    //  ---

    type = this.getNamespaceObject();
    if (TP.canInvoke(type, 'get')) {
        if (res !== 'resource') {
            //  Must have asked for style_{theme} as the resource value.
            if (TP.notEmpty(theme)) {
                uri = type.get('themeURI', theme);
            } else {
                uri = type.get(res + 'URI');    // e.g. 'style' + 'URI'
            }
            if (TP.notEmpty(uri)) {
                if (!TP.isString(uri) && TP.isURI(uri)) {
                    return uri.getVirtualLocation();
                }
                return uri;
            }
        }
    }

    //  ---
    //  computed fallback
    //  ---

    //  If forced false nothing else matters...we're done.
    if (TP.isFalse(fallback)) {
        return;
    }

    //  If forced true, or the flag is true, we'll compute a fallback value.
    res = /^style_/.test(res) ? 'style' : res;
    if (TP.isTrue(fallback) ||
        TP.isTrue(TP.sys.cfg('uri.' + res + '_fallback'))) {

        ext = this.computeResourceExtension(resource, mimeType);

        //  Default to receiver's load path and full type name.
        value = TP.objectGetSourceCollectionPath(this) + '/' + this.getName();

        //  Tack on theme as needed to provide theme-specific computation.
        value = TP.isEmpty(theme) ? value : value + '_' + theme;

        //  Finally add the proper mime extension such as CSS or XHTML.
        value += '.' + ext;

        computed.atPut(cachekey, TP.uriNormalize(value));
        return value;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('constructContentObject',
function(content, aURI) {

    /**
     * @method constructContentObject
     * @summary Returns a content handler for the URI provided. This method is
     *     invoked as part of MIME-type specific handling for URIs.
     * @param {Object} content The content to set into the content object.
     * @param {TP.uri.URI} aURI The URI containing the content.
     * @returns {Object} The object representation of the content.
     */

    var contentObj;

    if (TP.isDocument(contentObj = content)) {
        contentObj = content.documentElement;
    }

    return this.construct(contentObj);
});

//  ------------------------------------------------------------------------

//  fromArray() is handled by fromObject() below

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('fromBoolean',
function(anObject, aRequest) {

    /**
     * @method fromBoolean
     * @summary Returns a formatted XML String with the supplied Boolean object
     *     as the content.
     * @param {Boolean} anObject The Object to wrap in the elements.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An optional object
     *     containing parameters.
     * @returns {String} The content formatted as markup.
     */

    return TP.join(
            '<', this.getCanonicalName(), '>',
                    TP.str(anObject),
            '</', this.getCanonicalName(), '>');
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('fromDate',
function(anObject, aRequest) {

    /**
     * @method fromDate
     * @summary Returns a formatted XML String with the supplied Date object as
     *     the content.
     * @description The supplied request can contain the following keys and
     *     values that are used in this method:
     *
     *     'escapeContent' Boolean Whether or not to 'escape' the content (i.e.
     *     if it has embedded markup). This defaults to false.
     * @param {Boolean} anObject The Object to wrap in the elements.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An optional object
     *     containing parameters.
     * @returns {String} The content formatted as markup.
     */

    var val;

    if (TP.isTrue(aRequest.at('escapeContent'))) {
        val = TP.xmlLiteralsToEntities(TP.str(anObject));
    } else {
        val = TP.str(anObject);
    }

    return TP.join(
            '<', this.getCanonicalName(), '>',
                    val,
            '</', this.getCanonicalName(), '>');
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('fromNumber',
function(anObject, aRequest) {

    /**
     * @method fromNumber
     * @summary Returns a formatted XML String with the supplied Number object
     *     as the content.
     * @param {Boolean} anObject The Object to wrap in the elements.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An optional object
     *     containing parameters.
     * @returns {String} The content formatted as markup.
     */

    return TP.join(
            '<', this.getCanonicalName(), '>',
                    TP.str(anObject),
            '</', this.getCanonicalName(), '>');
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('fromObject',
function(anObject, aRequest) {

    /**
     * @method fromObject
     * @summary Returns a formatted XML String with each item in the Array as
     *     the content of each item in the Array.
     * @description The supplied request can contain the following keys and
     *     values that are used in this method:
     *
     *     'attrInfo'   TP.core.Hash|Function
     *     The Hash or Function to use to compute attributes for the main
     *     element.
     *
     *     'format'     String
     *     How items should be formatted when this routine loops.
     *
     *     'autowrap'   Boolean
     *     Whether or not this routine iterates over an item list, generating
     *     markup for individual items, or just generates 'start & end' tags and
     *     hands the Object to the 'format' specified (or to this tag's 'item
     *     tag name') to iterate.
     *
     *     'infos'      Array
     *     The Array containing information about each 'level' of the formatting
     *     recursion. If attrInfo is supplied, and its a Function, that Function
     *     should be defined like so:
     *
     *         function(item) {
     *             return 'foo="bar"';
     *         };
     *
     *     where the item is the Array itself. It should return a String as
     *     demonstrated. If itemAttrInfo is supplied, and its a Function, that
     *     Function should be defined like so:
     *
     *         function(item) {
     *             return 'foo="bar"';
     *         };
     *
     *     where the item is the item itself at that position in the Array. It
     *     should return a String as demonstrated.
     * @param {Object} anObject The Object of content to wrap in markup.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An optional object
     *     containing parameters.
     * @returns {String} The content formatted as markup.
     */

    var theRequest,

        currentLevel,
        infos,
        levelInfo,
        i,
        reqCopy,

        attrInfo,
        attrStr,

        itemFormat,
        formatArgs,

        shouldAutoWrap,

        retVal;

    if (TP.notValid(anObject)) {
        return this.raise('TP.sig.InvalidObject');
    }

    //  Get the 'top-level' request
    if (TP.notValid(aRequest)) {
        theRequest = TP.hc();
    } else {
        theRequest = aRequest;
    }

    //  If we have a 'currentLevel', see what level we're at and whether or
    //  not we have info for that level.
    if (TP.isNumber(currentLevel = theRequest.at('currentLevel'))) {
        if (currentLevel === 0) {
            //  We're at 'level 0' - use a copy of the supplied request.
            levelInfo = TP.copy(theRequest);
        } else {

            //  See if there's an Array of 'infos' hashes. These will be used to
            //  communicate parameters 'further down' into the recursion.
            infos = theRequest.at('infos');

            //  No infos - just use a copy of the supplied request.
            if (TP.notValid(infos)) {
                levelInfo = TP.copy(theRequest);
            } else {

                //  Otherwise, grab the info hash representing our level (which
                //  will be the one at our current level minus 1).
                levelInfo = infos.at(currentLevel - 1);

                //  If there is none, then we need to search for one.
                if (TP.notValid(levelInfo)) {

                    //  Start two levels up from our current level.
                    i = currentLevel - 2;

                    //  Back up through all of the level numbers, looking for a
                    //  valid info hash.
                    while (i > -1) {
                        if (TP.isValid(infos.at(i))) {
                            levelInfo = infos.at(i);
                            break;
                        }
                        i--;
                    }

                    //  If we still didn't find an info hash, just use a copy of
                    //  the supplied request.
                    if (TP.notValid(levelInfo)) {
                        levelInfo = TP.copy(theRequest);
                    } else {

                        //  Otherwise, copy the supplied request (to get the
                        //  most specific values) and then add in any values
                        //  that we got from the info hash we computed.
                        reqCopy = TP.copy(theRequest.getPayload());
                        reqCopy.addAllIfAbsent(levelInfo);
                        levelInfo = reqCopy;
                    }
                }
            }
        }
    } else {
        //  We must be at 'level 0' - there not even a 'currentLevel' set. Use a
        //  copy of the supplied request.
        levelInfo = TP.copy(theRequest);
    }

    //  If 'currentLevel' wasn't defined before, that means that we're at
    //  level 0 (the caller's entry point). Define it to be 'level 1'.
    //  Otherwise, increment the level count.
    if (TP.notValid(levelInfo.at('currentLevel'))) {
        levelInfo.atPut('currentLevel', 1);
    } else {
        levelInfo.atPut('currentLevel', levelInfo.at('currentLevel') + 1);
    }

    //  Note that for these configuration parameters, 'levelInfo' very well
    //  maybe be an empty TP.core.Hash.

    //  Grab the attribute info from the level info
    attrInfo = levelInfo.at('$attrInfo');

    //  If the level info specified a format, use that. Otherwise, see if
    //  the receiver has an 'item tag name' (e.g. 'tr' has an 'item tag
    //  name' of 'td').
    if (TP.isEmpty(itemFormat = levelInfo.at('format'))) {
        itemFormat = this.getItemTagName(anObject, levelInfo);
    }

    //  Now we're going to determine whether we'll auto-wrap or not.
    shouldAutoWrap = this.shouldAutoWrapItems(anObject, levelInfo);

    //  If itemFormat isn't real here, then we just use 'String' -
    //  everything can respond to 'asString()' ;-).
    if (TP.notValid(itemFormat)) {
        itemFormat = 'String';
        formatArgs = null;
    } else {
        formatArgs = levelInfo;
    }

    if (!shouldAutoWrap) {
        //  No attribute info? Then we can just use the tag name and the
        //  item format.
        if (TP.notValid(attrInfo)) {
            attrStr = '';
        } else {
            //  If attrInfo isn't a Function, then see if its a String or
            //  TP.core.Hash.
            if (!TP.isCallable(attrInfo)) {
                if (TP.isString(attrInfo)) {
                    //  It's a String - just use it.
                    attrStr = ' ' + attrInfo;
                } else if (TP.isValid(attrInfo)) {
                    //  It should be a TP.core.Hash at this point - convert
                    //  to a String.
                    attrStr = ' ' + attrInfo.asAttributeString();
                } else {
                    //  Otherwise, its not valid so its the empty String.
                    attrStr = '';
                }
            } else {
                attrStr = ' ' + attrInfo(anObject);
            }
        }

        //  Generate a chunk of markup representing the supplied object.
        retVal = this.generateMarkup(anObject, attrStr,
                                        itemFormat, shouldAutoWrap,
                                        formatArgs,
                                        levelInfo);
    } else {
        //  No attribute info? Then we can just use the tag name and the
        //  item format.
        if (TP.notValid(attrInfo)) {
            attrStr = '';
        } else {
            //  If attrInfo isn't a Function, then see if its a String or
            //  TP.core.Hash.
            if (!TP.isCallable(attrInfo)) {
                attrStr = ' {{$attrStr}}';

                if (TP.isString(attrInfo)) {
                    //  It's a String - just use it.
                    levelInfo.atPut(
                                '$attrStr',
                                attrInfo);
                } else if (TP.isValid(attrInfo)) {
                    //  It should be a TP.core.Hash at this point - convert
                    //  to a String.
                    levelInfo.atPut('$attrStr',
                                        attrInfo.asAttributeString());
                } else {
                    //  Otherwise, its not valid so its the empty String.
                    levelInfo.atPut('$attrStr', '');
                }
            } else {
                attrStr = ' {{.%$attrInfo}}';
            }
        }

        //  Generate a chunk of markup representing the supplied object.
        retVal = this.generateMarkup(anObject, attrStr,
                                        itemFormat, shouldAutoWrap,
                                        formatArgs,
                                        levelInfo);
    }

    return retVal;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('fromString',
function(anObject, aRequest) {

    /**
     * @method fromString
     * @summary Returns a formatted XML String with the supplied String object
     *     as the content.
     * @description The supplied request can contain the following keys and
     *     values that are used in this method:
     *
     *     'escapeContent' Boolean Whether or not to 'escape' the content (i.e.
     *     if it has embedded markup). This defaults to false.
     * @param {Boolean} anObject The Object to wrap in the elements.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An optional object
     *     containing parameters.
     * @returns {String} The content formatted as markup.
     */

    var val,
        request;

    request = TP.request(aRequest);

    if (TP.isTrue(request.at('escapeContent'))) {
        val = TP.xmlLiteralsToEntities(
                            TP.htmlEntitiesToXMLEntities(TP.str(anObject)));
    } else {
        val = TP.str(anObject);
    }

    return TP.join(
            '<', this.getCanonicalName(), '>',
                    val,
            '</', this.getCanonicalName(), '>');
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('generateMarkup',
function(anObject, attrStr, itemFormat, shouldAutoWrap, formatArgs, theRequest) {

    /**
     * @method generateMarkup
     * @summary Generates markup for the supplied Object using the other
     *     parameters supplied.
     * @param {Object} anObject The Object of content to wrap in markup.
     * @param {String} attrStr The String containing either the literal
     *     attribute markup or a 'template invocation' that can be used inside
     *     of a template.
     * @param {String} itemFormat The name of an 'item format', either a tag
     *     name (which defaults to the 'item tag name' of this type) or some
     *     other format type which can be applied to this type.
     * @param {Boolean} shouldAutoWrap Whether or not the markup generation
     *     machinery should 'autowrap' items of the supplied object (each item
     *     in an Array or each key/value pair in an Object).
     * @param {TP.core.Hash} formatArgs The 'formatting arguments' used by this
     *     machinery to generate item markup.
     * @param {TP.sig.Request|TP.core.Hash} theRequest An optional object
     *     containing parameters.
     * @returns {String} The markup generated by taking the supplied Object and
     *     iterating over its items.
     */

    var tagName,
        template,
        str;

    tagName = this.getCanonicalName();

    //  Don't generate markup annotated with the data expression
    theRequest.atPut('annotateMarkup', false);

    //  If we're not auto-wrapping, then just do an 'as' with the object.
    if (TP.isFalse(shouldAutoWrap)) {
        //  Join the tag name with the result of calling 'as' using the
        //  itemFormat to format the whole Array we were supplied.
        str = TP.join('<', tagName, attrStr, '>',
                        anObject.as(itemFormat, formatArgs),
                        '</', tagName, '>');
    } else {
        //  Otherwise, we're going to auto-wrap, so we leverage the
        //  'template' capability.

        //  If the object is an Array, then wrap each item in a tag.

        //  Build a template by joining the tag name with an invocation of
        //  the itemFormat for each value.
        if (TP.isArray(anObject) || TP.notTrue(theRequest.at('repeat'))) {
            template = TP.join('<', tagName, attrStr, '>',
                                '{{.%', itemFormat, '}}',
                                '</', tagName, '>');
        } else {
            //  Otherwise, the object that will be handed to the iteration
            //  mechanism will be [key,value] pairs, so we can use that fact
            //  to generate item tags around each one.

            //  Build a template by joining the tag name with an invocation
            //  of the itemFormat for both the key and the value.
            template = TP.join('<', tagName, attrStr, '>',
                                '{{0.%', itemFormat, '}}',
                                '</', tagName, '>',
                                '<', tagName, attrStr, '>',
                                '{{1.%', itemFormat, '}}',
                                '</', tagName, '>');
        }

        //  Perform the transformation.
        str = template.transform(anObject, theRequest);
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('generateMarkupContent',
function(attrStr, wantsXMLNS, targetDefaultNS) {

    /**
     * @method generateMarkupContent
     * @summary Generates the 'empty markup' representation of the receiver.
     * @description The empty representation contains child node content, but
     *     does contain the proper 'xmlns' attribute so that the receiver can be
     *     properly placed in any document that has that namespace defined. It
     *     can also contain any optionally supplied attribute content.
     * @param {String} [attrStr] The String containing optional attribute
     *     markup.
     * @param {Boolean} [wantsXMLNS=true] Whether or not the caller wants an
     *     'xmlns:' namespace definition generated into the result.
     * @param {String} [targetDefaultNS] The default NS of the target
     *     environment that the markup String will be inserted into.
     * @returns {String} The 'empty markup' representation of the receiver.
     */

    var attrMarkup,

        ourNSURI,

        str;

    if (TP.notEmpty(attrStr)) {
        attrMarkup = ' ' + TP.trim(attrStr);
    } else {
        attrMarkup = '';
    }

    //  Grab our namespace URI. We'll use this to compare against the default
    //  namespace that the markup we generate is being placed into.
    ourNSURI = this.getNSURI();

    //  If the caller wants an 'xmlns' generated into the markup.
    if (TP.notFalse(wantsXMLNS)) {
        //  If we got passed a target default namespace and its the same as our
        //  own namespace, then just generate an unprefixed tag name and a
        //  default 'xmlns' definition
        if (TP.notEmpty(targetDefaultNS) && ourNSURI === targetDefaultNS) {
            str = TP.join('<',
                        this.getLocalName(),
                        ' xmlns',
                        '="',
                        ourNSURI +
                        '"' +
                        attrMarkup +
                        '/>');
        } else {
            //  Otherwise, generate a prefixed tag name and a prefixed 'xmlns:'
            //  definition to match.
            str = TP.join('<',
                        this.getNamespacePrefix(),
                        ':',
                        this.getLocalName(),
                        ' xmlns:', this.getNamespacePrefix(),
                        '="',
                        TP.w3.Xmlns.getNSURIForPrefix(this.getNamespacePrefix()),
                        '"' +
                        attrMarkup +
                        '/>');
        }
    } else {
        //  Otherwise, the caller did not want an 'xmlns' generated into the
        //  markup.

        //  If we got passed a target default namespace and its the same as our
        //  own namespace, then just generate an unprefixed tag name.
        if (TP.notEmpty(targetDefaultNS) && ourNSURI === targetDefaultNS) {
            str = TP.join('<',
                        this.getLocalName(),
                        attrMarkup +
                        '/>');
        } else {
            //  Otherwise, generate a prefixed tag name.
            str = TP.join('<',
                        this.getNamespacePrefix(),
                        ':',
                        this.getLocalName(),
                        attrMarkup +
                        '/>');
        }
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('getCanonicalName',
function() {

    /**
     * @method getCanonicalName
     * @summary Returns the receiver's canonical tag name. For elements types,
     *     this is the tag prefix (usually corresponding to the tag type's
     *     namespace) followed by a colon (':') followed by the tag's 'local
     *     name' (usually corresponding to the tag type's name).
     * @returns {String} The receiver's canonical name.
     */

    return this.get('nsPrefix') + ':' + this.get('localName');
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('getConcreteType',
function(aNode) {

    /**
     * @method getConcreteType
     * @summary Returns the subtype to use for the node provided.
     * @description This method determines the 'TP wrapper' type for the
     *     supplied node by using the following logic cascade:
     *     1. Checks for the 'tibet:tag' attribute on the node and attempts to
     *     obtain a type matching that name.
     *     2. If there is a 'tibet:tag' attribute and its exact type cannot be
     *     found, it computes a name using that name and the suffix ':Element'
     *     and attempts to obtain a type matching that name.
     *     3. Obtains the node's 'full name' (i.e. the name that the author used
     *     in the source markup) and attempts to obtain a type matching that
     *     name.
     *     4. Obtains the node's 'canonical name' (i.e. if the node has a
     *     namespace, it uses the canonical prefix for that namespace) and
     *     attempts to obtain a type matching that name.
     *     5. Obtains the node's 'canonical prefix' (if the node has a
     *     namespace) and computes a name using that prefix and the suffix
     *     ':Element' and attempts to obtain a type matching that name.
     *     6. Obtains the node's namespace URI (if the node has a namespace) and
     *     checks with the XMLNS 'info' hash to see if there is a
     *     'defaultNodeType' name registered under that namespace and attempts
     *     to obtain a matching type.
     * @param {Node} aNode The native node to wrap.
     * @returns {TP.meta.dom.ElementNode} A TP.dom.ElementNode subtype type
     *     object.
     */

    var name,
        last,
        type,

        prefix,

        url,
        info,

        defaultType;

    //  If the proper TP.dom.Node subtype has been cached on the supplied
    //  node, then just return it.
    if (TP.isValid(type = aNode[TP.NODE_TYPE])) {
        return type;
    }

    //  tag is how we can override the natural tag's lookup model
    if (TP.notEmpty(name = TP.elementGetAttribute(
                                    aNode,
                                    'tibet:tag',
                                    true)) && name !== last) {
        last = name;
        //  name wins if we have a type with that precise name
        if (TP.isType(type = TP.sys.getTypeByName(name))) {

            //  If the type's Type prototype is not the same as this one's Type
            //  prototype and it owns a 'getConcreteType' method (meaning it is
            //  a type cluster and wants to specialize the type even further),
            //  then invoke that and use the return value.
            if (type.Type !== this.Type &&
                TP.owns(type.Type, 'getConcreteType')) {
                type = type.getConcreteType(aNode);
            }

            if (!type.isAbstract()) {
                //  Only set the slot if its an HTML node... see above.
                TP.isHTMLNode(aNode) ? aNode[TP.NODE_TYPE] = type : 0;

                return type;
            }
        }

        //  namespace qualified tags have two more tests to see if
        //  a) to see if there is a type named '<prefix>:Element' or
        //  b) the namespace has a default type we should use
        if (TP.regex.NS_QUALIFIED.test(name)) {
            if (TP.notEmpty(prefix = name.match(/(.*):/)[1])) {
                //  If that namespace has a 'prefix' associated with it,
                //  we'll try to find a type named '<prefix>:Element'
                if (TP.isType(type = TP.sys.getTypeByName(prefix + ':Element')) &&
                    !type.isAbstract()) {
                    //  Only set the slot if its an HTML node... see above.
                    TP.isHTMLNode(aNode) ? aNode[TP.NODE_TYPE] = type : 0;

                    return type;
                }

                if (TP.notEmpty(url = TP.w3.Xmlns.getNSURIForPrefix(prefix))) {
                    if (TP.isValid(info =
                                    TP.w3.Xmlns.get('info').at(url))) {
                        if (TP.notEmpty(defaultType =
                                            info.at('defaultNodeType'))) {
                            if (TP.isType(type =
                                            TP.sys.getTypeByName(defaultType))) {

                                //  If the type's Type prototype is not the same
                                //  as this one's Type prototype and it owns a
                                //  'getConcreteType' method (meaning it is a
                                //  type cluster and wants to specialize the
                                //  type even further), then invoke that and use
                                //  the return value.
                                if (type.Type !== this.Type &&
                                    TP.owns(type.Type, 'getConcreteType')) {
                                    type = type.getConcreteType(aNode);
                                }

                                if (!type.isAbstract()) {
                                    //  Only set the slot if its an HTML node...
                                    //  see above.
                                    TP.isHTMLNode(aNode) ?
                                            aNode[TP.NODE_TYPE] = type :
                                            0;

                                    return type;
                                }
                            }
                        }
                    }
                }
            }
        }

        //  TODO:   log a warning? no wrapper type but a tag?
    }

    //  We next try to find a type based on the 'full name'. This will be
    //  the name that the author gave in the source markup.
    //  Note how we pass 'true' to ignore any tibet:tag value (which
    //  shouldn't exist anyway)
    last = name;
    name = TP.elementGetFullName(aNode, true);
    if (name !== last && TP.isType(type = TP.sys.getTypeByName(name))) {

        //  Sometime local tag names are also native types in the system - don't
        //  return those
        if (!TP.isNativeType(type)) {

            //  If the type's Type prototype is not the same as this one's Type
            //  prototype and it owns a 'getConcreteType' method (meaning it is
            //  a type cluster and wants to specialize the type even further),
            //  then invoke that and use the return value.
            if (type.Type !== this.Type &&
                TP.owns(type.Type, 'getConcreteType')) {
                type = type.getConcreteType(aNode);
            }

            if (!type.isAbstract()) {
                //  Only set the slot if its an HTML node... see above.
                TP.isHTMLNode(aNode) ? aNode[TP.NODE_TYPE] = type : 0;

                return type;
            }
        }
    }

    //  We next try to find a type based on the 'canonical name'. This may
    //  be different from the name that the author gave in the source
    //  markup, since it uses the 'canonical prefix' for the node (if the
    //  node has a namespace).
    //  Note how we pass 'true' to ignore any tibet:tag value (which
    //  shouldn't exist anyway)
    last = name;
    name = TP.elementGetCanonicalName(aNode, true);
    if (name !== last && TP.isType(type = TP.sys.getTypeByName(name))) {

        //  If the type's Type prototype is not the same as this one's Type
        //  prototype and it owns a 'getConcreteType' method (meaning it is a
        //  type cluster and wants to specialize the type even further), then
        //  invoke that and use the return value.
        if (type.Type !== this.Type &&
            TP.owns(type.Type, 'getConcreteType')) {
            type = type.getConcreteType(aNode);
        }

        if (!type.isAbstract()) {
            //  Only set the slot if its an HTML node... see above.
            TP.isHTMLNode(aNode) ? aNode[TP.NODE_TYPE] = type : 0;

            return type;
        }
    }

    //  couldn't find either a tibet:tag or a type that matches either the 'full
    //  name' given in the source or the 'canonical name' that is computed using
    //  the node's namespace's 'canonicalprefix', so we try is to see if the
    //  node has a native namespace URI, and if so, we'll try 2 other
    //  approaches.

    if (TP.notEmpty(url = TP.nodeGetNSURI(aNode))) {
        if (TP.isValid(info = TP.w3.Xmlns.get('info').at(url))) {
            //  If that namespace has a 'prefix' associated with it, we'll
            //  try to find a type named '<prefix>:Element'
            if (TP.notEmpty(prefix = info.at('prefix'))) {
                if (TP.isType(
                        type = TP.sys.getTypeByName(prefix + ':Element'))) {

                    //  If the type's Type prototype is not the same as this
                    //  one's Type prototype and it owns a 'getConcreteType'
                    //  method (meaning it is a type cluster and wants to
                    //  specialize the type even further), then invoke that and
                    //  use the return value.
                    if (type.Type !== this.Type &&
                        TP.owns(type.Type, 'getConcreteType')) {
                        type = type.getConcreteType(aNode);
                    }

                    if (!type.isAbstract()) {
                        //  Only set the slot if its an HTML node... see above.
                        TP.isHTMLNode(aNode) ? aNode[TP.NODE_TYPE] = type : 0;

                        return type;
                    }
                }
            }

            //  If that namespace has a 'defaultNodeType' associated
            //  with it, we'll try to find a type named that.
            if (TP.notEmpty(defaultType = info.at('defaultNodeType'))) {
                if (TP.isType(type = TP.sys.getTypeByName(defaultType))) {

                    //  If the type's Type prototype is not the same as this
                    //  one's Type prototype and it owns a 'getConcreteType'
                    //  method (meaning it is a type cluster and wants to
                    //  specialize the type even further), then invoke that and
                    //  use the return value.
                    if (type.Type !== this.Type &&
                        TP.owns(type.Type, 'getConcreteType')) {
                        type = type.getConcreteType(aNode);
                    }

                    if (!type.isAbstract()) {
                        //  Only set the slot if its an HTML node... see above.
                        TP.isHTMLNode(aNode) ? aNode[TP.NODE_TYPE] = type : 0;

                        return type;
                    }
                }
            }
        }
    }

    //  default is to wrap based on XML vs. HTML
    if (TP.isHTMLNode(aNode)) {
        //  NOTE that we don't cache TP.NODE_TYPE here to leave open the
        //  possibility that we're still loading functionality and may find
        //  a better match on subsequent attempts
        return TP.dom.HTMLElementNode;
    } else {
        //  TODO Should be checking for XHTML nodes as well.
        return TP.dom.XMLElementNode;
    }
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('getItemTagName',
function(anObject, formatArgs) {

    /**
     * @method getItemTagName
     * @summary Returns the 'default item tag name' for use it the
     *     fromArray()/fromObject() methods. Note that this should return the
     *     receiver's *canonical* name.
     * @param {Object} anObject The Object of content to wrap in markup.
     * @param {TP.core.Hash} formatArgs The 'formatting arguments' used by this
     *     machinery to generate item markup.
     * @returns {String} The item tag name.
     */

    return null;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('getKeybindingsURI',
function(mimeType) {

    /**
     * @method getKeybindingsURI
     * @summary Returns a keybinding map file URI for the receiver. This method
     *     will only return a valid URI if one is found via configuration
     *     settings. There is no default/fallback logic for key mapping.
     * @param {String} mimeType The mimeType for the resource being looked up.
     * @returns {TP.uri.URI|undefined} The computed resource URI.
     */

    var uri,
        name,
        key,
        value;

    uri = this.$get('keybindingsURI');
    if (TP.notEmpty(uri)) {
        if (uri === TP.NO_RESULT) {
            return;
        }

        return TP.uc(uri);
    }

    name = this.getResourceTypeName();
    key = 'path.' + name + '.keybindings';
    value = TP.sys.cfg(key);

    if (TP.notEmpty(value)) {
        return TP.uc(value);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('getNamespaceType',
function(mimeType) {

    /**
     * @method getNamespaceType
     * @summary Returns the 'namespace' for the receiver. The canonical form of
     *     the name of the namespace type is the namespace root (i.e. 'TP'),
     *     followed by the namespace (i.e. 'html'), followed by 'XMLNS'.
     * @returns {TP.meta.dom.ElementNode|undefined} The type object representing
     *     the receiver's namespace type.
     */

    var root,
        nsName,
        typeName,
        type;

    root = this.getNamespaceRoot();
    nsName = this.getNamespacePrefix();

    typeName = root + '.' + nsName + '.' + 'XMLNS';

    if (!TP.isType(type = TP.sys.getTypeByName(typeName))) {
        return;
    }

    return type;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('getDependencies',
function() {

    /**
     * @method getDependencies
     * @summary Returns an Array of Objects that the receiver considers to be
     *     it's manually determined set of 'dependent' objects that it needs in
     *     order to operate successfully. These objects can be any type of
     *     object in the system, so long as they themselves can respond to the
     *     'getDependencies' method. In this way, we can recursively
     *     determine the chain of dependent objects. This terminates at the
     *     meta-level by returning an empty Array.
     * @description Many objects can be determined via method invocation
     *     tracking to be included or excluded for packaging purposes. This
     *     method allows the receiving object to statically force a particular
     *     object to be included along with the receiver in the package. In
     *     some cases this is the only way to determine whether or not an object
     *     should be included/excluded in a particular package.
     * @returns {Object[]} The property descriptor of the attribute on the
     *     receiver.
     */

    var dependencies,

        nsType;

    //  First, grab whatever dependencies the supertype thinks are important.
    dependencies = this.callNextMethod();

    if (TP.isType(nsType = this.getNamespaceType())) {
        dependencies.push(nsType);
    }

    return dependencies;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('getQueryPath',
function(wantsDeep, wantsCompiled, wantsDisabled) {

    /**
     * @method getQueryPath
     * @summary Returns the 'query path' that can be used in calls such as
     *     'nodeEvaluatePath' to obtain all of the occurrences of the receiver
     *     in a document.
     * @param {Boolean} wantsDeep Whether or not the query should represent a
     *     'deep query' - that is, all of the occurrences of this element even
     *     under elements of the same type. This defaults to false.
     * @param {Boolean} [wantsCompiled=false] Whether or not the query should
     *     also find compiled representations of the receiver. This defaults to
     *     false.
     * @param {Boolean} [wantsDisabled=true] Whether or not the query should
     *     also find disabled versions of the receiver. This defaults to true.
     * @returns {String} The path that can be used to query for Nodes of this
     *     type.
     */

    var sourceTagQuery,
        compiledTagQuery,
        query;

    //  Note here how we generate a CSS3 namespace query
    sourceTagQuery = this.get('nsPrefix') + '|' + this.get('localName');
    if (TP.isFalse(wantsDisabled)) {
        sourceTagQuery += ':not([disabled])';
    }

    compiledTagQuery = '*[tibet|tag="' +
                        this.get('nsPrefix') + ':' + this.get('localName') +
                        '"]';
    if (TP.isFalse(wantsDisabled)) {
        compiledTagQuery += ':not([disabled])';
    }

    query = sourceTagQuery;

    if (TP.isTrue(wantsCompiled)) {
        query += ', ' + compiledTagQuery;
    }

    //  If the caller wants a deep query, we can simply return the full name
    //  here.
    if (TP.isTrue(wantsDeep)) {
        return query;
    }

    //  Otherwise, we return a query that looks for a) immediate children with
    //  this name and b) descendants with this name, but only those that don't
    //  have a parent with this name - hence giving the 'shallow' quality.
    query = '> ' + sourceTagQuery +
            ',' + ' *:not(' + sourceTagQuery + ') ' + sourceTagQuery;

    if (TP.isTrue(wantsCompiled)) {
        query += ',' +
                    ' > ' + compiledTagQuery +
                    ',' + ' *:not(' + compiledTagQuery + ') ' +
                                                        compiledTagQuery;
    }

    return query;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('getResourceElement',
function(resource, mimeType, setupFunc) {

    /**
     * @method getResourceElement
     * @summary Returns a resource element wrapper specific to the resource and
     *     mime type provided. This routine leverages getResourceURI to locate
     *     the source URI and then loads and wraps its content as needed.
     * @param {String} resource The resource name. Typically template, style,
     *     style_{theme}, etc. but it could be essentially anything except the
     *     word 'resource' (since that would trigger a recursion).
     * @param {String} mimeType The mimeType for the resource being looked up.
     * @param {Function} [setupFunc] An optional set up function for the
     *     resource element that will be executed before it is wrapped for
     *     return.
     * @returns {TP.dom.ElementNode} The wrapped element containing the
     *     content.
     */

    var uri,
        src,
        result,

        resp,
        str,

        mime,
        xmlnsInfo,
        defaultNS,

        doc,
        elem;

    uri = this.getResourceURI(resource, mimeType);

    if (!TP.isURI(uri)) {
        return this.raise('InvalidURI',
            'Unable to locate resource URI for ' + this.asString());
    }

    src = uri.getLocation();

    //  If a TP.dom.ElementNode with a URI that matches the src has been cached,
    //  then return it.
    result = this.get('$resourceElements').at(src);

    //  If we have a cached result, but we're recasting, then set result to null
    //  so that we retrieve the new markup from the URI cache. The new result
    //  will be cached below before we exit this method.
    if (TP.isValid(result) && TP.dom.CollectionNode.$get('$isRecasting')) {
        result = null;
    }

    if (TP.isValid(result)) {
        return result;
    }

    //  Grab the receiver's content for processing. We do this synchronously
    //  here and we also get it in string form so we can process the markup and
    //  add default namespace as needed to make authoring more convenient.
    resp = uri.getResource(
            TP.hc('async', false,
                    'resultType', TP.TEXT,
                    'signalChange', false));

    str = resp.get('result');

    if (TP.isEmpty(mime = mimeType)) {
        mime = uri.getMIMEType();
    }

    //  Try to guess the default XML namespace from the MIME type computed from
    //  the supplied text and URL.
    if (TP.isValid(xmlnsInfo = TP.w3.Xmlns.fromMIMEType(mime))) {
        defaultNS = xmlnsInfo.at('uri');
    } else {
        defaultNS = null;
    }

    doc = TP.documentFromString(str, defaultNS, true);

    //  Make sure that the resource had real markup that could be built as such.
    if (!TP.isDocument(doc) || !TP.isElement(elem = doc.documentElement)) {
        return this.raise('InvalidTemplate', src);
    }

    //  If we were able to load a real document from the source URI stamp that
    //  path on it so we have it for reference.
    if (TP.notEmpty(src)) {
        doc[TP.SRC_LOCATION] = src;
    }

    //  If we were supplied with a setup Function, then execute it here.
    if (TP.isCallable(setupFunc)) {
        setupFunc(elem);
    }

    result = TP.wrap(elem);

    //  Cache the TP.dom.ElementNode under the URI's source.
    this.get('$resourceElements').atPut(src, result);

    return result;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('getResourceType',
function() {

    /**
     * @method getResourceType
     * @summary Returns the resource type that will be queried to find resources
     *     for this type.
     * @description By default, this method returns the receiver itself.
     *     Subtypes can override to provide a type that will queried instead for
     *     this type's resources.
     * @returns {TP.meta.dom.ElementNode} The resource type for the receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('getResourceTypeName',
function() {

    /**
     * @method getResourceTypeName
     * @summary Returns the resource type name for this type. The resource type
     *     name is used when computing resource paths for this type. It is
     *     usually the type name, but can be some other unique identifier.
     * @returns {String} The resource type name for the receiver.
     */

    return this.getName();
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('getResourceURI',
function(resource, mimeType, fallback) {

    /**
     * @method getResourceURI
     * @summary Returns a resource URI specific to the receiver for the named
     *     resource and mimeType. This method is used to look up template,
     *     style, theme, and other resource URIs by leveraging cfg flags and
     *     methods on the receiver specific to each resource/mime requirement.
     * @param {String} resource The resource name. Typically 'template',
     *     'style', 'style_{theme}', etc. but it could be essentially anything
     *     except the word 'resource' (since that would trigger a recursion).
     * @param {String} mimeType The mimeType for the resource being looked up.
     *     This is used to locate viable extensions based on the data in TIBET's
     *     TP.ietf.mime.INFO dictionary.
     * @param {Boolean} [fallback] Compute a fallback value?  Defaults to the
     *     value of 'uri.fallbacks'.
     * @returns {TP.uri.URI|String|TP.NO_RESULT} The computed resource URI.
     */

    var loc,
        uri;

    loc = this.getResourceType().computeResourceURI(
                                    resource, mimeType, fallback);

    if (TP.notEmpty(loc) && loc !== TP.NO_RESULT) {
        uri = TP.uc(loc);
        if (TP.isValid(uri)) {
            return uri.getConcreteURI();
        } else {
            TP.ifWarn() ?
                TP.warn('Unable to construct concrete URI for: ' + loc) : 0;
        }
    }

    return loc;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('getStyleExtension',
function() {

    /**
     * @method getStyleExtension
     * @summary Returns any mapped style extension. This allows projects to
     *     configure for less or sass across all style URIs.
     * @returns {String} The style extension, if any is mapped.
     */

    var name,
        prefix,
        key,
        ext;

    name = this.getResourceTypeName();
    prefix = this.getNamespacePrefix().toLowerCase();

    //  e.g. style.TP.xctrls.codeeditor.extension => 'css'
    key = 'style.' + name + '.extension';
    ext = TP.sys.getcfg(key);

    if (TP.isEmpty(ext)) {
        //  e.g. style.xctrls.extension => 'less'
        key = 'style.' + prefix + '.extension';
        ext = TP.sys.getcfg(key);
    }

    if (TP.isEmpty(ext)) {
        //  NOTE: this is _not_ 'style.project.extension' in case there's a
        //  prefix somewhere that's "project".
        ext = TP.sys.getcfg('project.style.extension');
    }

    return ext;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('getXMLObserver',
function(aSignal) {

    /**
     * @method getXMLObserver
     * @summary Attempts to extract the actual observer of the signal from the
     *     supplied signal. This is very useful in cases where the target of the
     *     signal has been set to a type.
     * @param {TP.sig.Signal} aSignal The signal to attempt to extract the
     *     observer from.
     * @returns {Object|undefined} The native observer.
     */

    var listener,
        id,
        inst;

    listener = aSignal.get('listener');
    if (!TP.isElement(listener)) {
        return;
    }

    if (TP.isEmpty(id = TP.elementGetAttribute(listener, 'observer'))) {
        id = TP.elementGetAttribute(listener, 'ev:observer', true);
        if (TP.isEmpty(id)) {
            return;
        }
    }

    inst = TP.bySystemId(id);
    if (TP.notValid(inst)) {
        return this.raise('TP.sig.InvalidHandler',
                            'Unable to construct handler instance');
    }

    return inst;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('guessContentTypeAndLocation',
function(anElement) {

    /**
     * @method guessContentTypeAndLocation
     * @summary Retrieves (and caches on the receiver) the MIME type and
     *     location of the receiver's content.
     * @description This method guesses the receiver's content type and
     *     location, if the receiver has external content. It then populates
     *     that information on the TP.SRC_LOCATION property and 'tibet:mime'
     *     attribute.
     * @param {Element|TP.dom.ElementNode} anElement The element to guess the
     *     type and location for.
     * @returns {TP.meta.dom.ElementNode} The receiver.
     */

    var elem,
        src,
        len,
        i,
        mime,
        mimeType,
        uri,
        mimeTypes;

    //  Make sure that we were supplied a real Element (or TP.dom.ElementNode)
    if (!TP.isElement(elem = TP.unwrap(anElement))) {
        //  TODO: Raise an exception
        return this;
    }

    //  The source attribute can be provided or computed from configuration
    //  data. When it's not provided we need to know whether to look for an
    //  XSLT or XHTML file when the markup type is XML of some form.
    src = elem.ownerDocument[TP.SRC_LOCATION];
    if (TP.isEmpty(src)) {
        //  If a MIME type was explicitly defined by the targeted element, then
        //  get its resource URI and use that as the source.
        if (TP.notEmpty(
                mime = TP.elementGetAttribute(elem, 'tibet:mime', true))) {
            uri = this.getResourceURI('template', mime);

            if (TP.isURI(uri)) {
                src = uri.getLocation();
            }
        } else {
            //  Otherwise, try to poke at the resource URI with a set of MIME
            //  types and see if there are any matches. Note that this Array is
            //  constructed in order with the most common types first and least
            //  common last.
            mimeTypes = TP.ac(TP.ietf.mime.XHTML,
                                TP.ietf.mime.XML,
                                TP.ietf.mime.XSLT);

            len = mimeTypes.getSize();
            for (i = 0; i < len; i++) {
                mimeType = mimeTypes.at(i);
                uri = this.getResourceURI('template', mimeType);

                if (TP.isURI(uri)) {
                    src = uri.getLocation();
                    mime = mimeType;
                    break;
                }
            }
        }
    }

    if (TP.notEmpty(src)) {
        elem.ownerDocument[TP.SRC_LOCATION] = src;
    }

    if (TP.notEmpty(mime)) {
        TP.elementSetAttribute(elem, 'tibet:mime', mime, true);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineHandler('Signal',
function(aSignal) {

    /**
     * @method handleSignal
     * @summary Handles notification of an incoming signal. For types the
     *     standard handle call will try to locate a signal-specific handler
     *     function just like with instances, but the default method for
     *     handling them defers to an instance rather than the type itself.
     * @param {TP.sig.Signal} aSignal The signal instance to respond to.
     * @returns {Object|undefined} The function's return value.
     */

    var observer;

    //  if the signal has an observer instance we can identify and acquire
    //  then we can leverage that, otherwise we shouldn't have been targeted
    observer = this.getXMLObserver(aSignal);

    //  Guard against recursion by invoking this indirectly again.
    if (observer === this) {
        return this.raise('TP.sig.InvalidHandler',
            'Recursive observer definition.');
    }

    if (TP.isValid(observer)) {
        return TP.handle(observer, aSignal);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('isBlockLevel',
function() {

    /**
     * @method isBlockLevel
     * @summary Returns whether the receiving type represents a block level
     *     element either in native form or when compiling (in the case of
     *     action elements).
     * @returns {Boolean} Whether the element is block level. The default is
     *     false.
     */

    return false;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('isOpaqueBubblerFor',
function(anElement, aSignal, signalNames) {

    /**
     * @method isOpaqueBubblerFor
     * @summary Returns whether the elements of this type are considered to be
     *     an 'opaque bubbler' for the supplied signal (i.e. it won't let the
     *     signal 'ascend' further up its parent hierarchy). This means that
     *     they will handle the signal themselves and not allow ancestors above
     *     them to handle it.
     * @description At this level, the supplied element is checked for a
     *     'tibet:opaque-bubbling' attribute, which should contain a
     *     space-separated set of TIBET signal names that will be captured by
     *     this element during the bubble phase of signaling. If that attribute
     *     is not present, it will check the 'opaqueBubblingSignalNames' type
     *     attribute for a list of signal names.
     * @param {Element} anElem The element to check for the
     *     'tibet:opaque-bubbling' attribute.
     * @param {TP.sig.Signal} aSignal The signal to check.
     * @param {String[]} [signalNames] The list of signal names to use when
     *     computing opacity for the signal. This is an optional parameter. If
     *     this method needs the list of signal names and this parameter is not
     *     provided, it can be derived from the supplied signal itself.
     * @returns {Boolean} Whether or not the receiver is opaque during the
     *     bubble phase for the signal.
     */

    var attrVal,

        opaqueSigNames,

        sigNames,

        len,
        i;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  Check to see if the supplied element has a 'tibet:opaque-bubbling'
    //  attribute. If so, split on space (' ') and use those values as the list
    //  of signals.
    if (TP.elementHasAttribute(anElement, 'tibet:opaque-bubbling', true)) {
        attrVal = TP.elementGetAttribute(
                        anElement, 'tibet:opaque-bubbling', true);
        opaqueSigNames = attrVal.split(' ');
    } else {
        //  Otherwise, ask the type.
        opaqueSigNames = this.get('opaqueBubblingSignalNames');
    }

    if (TP.isEmpty(opaqueSigNames)) {
        return false;
    }

    //  If the signal names were not supplied in the optional parameter, grab
    //  all of the signal names from the signal.
    sigNames = TP.ifInvalid(signalNames, aSignal.getSignalNames());

    len = sigNames.getSize();
    for (i = 0; i < len; i++) {
        if (opaqueSigNames.indexOf(sigNames.at(i)) !== TP.NOT_FOUND) {
            return true;
        }
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('isOpaqueCapturerFor',
function(anElement, aSignal, signalNames) {

    /**
     * @method isOpaqueCapturerFor
     * @summary Returns whether the elements of this type are considered to be
     *     an 'opaque capturer' for the supplied signal (i.e. it won't let the
     *     signal 'descend' further into its descendant hierarchy). This means
     *     that they will handle the signal themselves and not allow targeted
     *     descendants underneath them to handle it.
     * @description At this level, the supplied element is checked for a
     *     'tibet:opaque-capturing' attribute, which should contain a
     *     space-separated set of TIBET signal names that will be captured by
     *     this element during the capture phase of signaling. If that attribute
     *     is not present, it will check the 'opaqueCapturingSignalNames' type
     *     attribute for a list of signal names.
     * @param {Element} anElem The element to check for the
     *     'tibet:opaque-capturing' attribute.
     * @param {TP.sig.Signal} aSignal The signal to check.
     * @param {String[]} [signalNames] The list of signal names to use when
     *     computing opacity for the signal. This is an optional parameter. If
     *     this method needs the list of signal names and this parameter is not
     *     provided, it can be derived from the supplied signal itself.
     * @returns {Boolean} Whether or not the receiver is opaque during the
     *     capture phase for the signal.
     */

    var attrVal,

        opaqueSigNames,

        sigNames,

        len,
        i;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  Check to see if the supplied element has a 'tibet:opaque-capturing'
    //  attribute. If so, split on space (' ') and use those values as the list
    //  of signals.
    if (TP.elementHasAttribute(anElement, 'tibet:opaque-capturing', true)) {
        attrVal = TP.elementGetAttribute(
                        anElement, 'tibet:opaque-capturing', true);
        opaqueSigNames = attrVal.split(' ');
    } else {
        //  Otherwise, ask the type.
        opaqueSigNames = this.get('opaqueCapturingSignalNames');
    }

    if (TP.isEmpty(opaqueSigNames)) {
        return false;
    }

    //  If the signal names were not supplied in the optional parameter, grab
    //  all of the signal names from the signal.
    sigNames = TP.ifInvalid(signalNames, aSignal.getSignalNames());

    //  Some signals, keyboard signals in particular, have multiple signal
    //  names. We need to make sure that all of them are tested here.
    len = sigNames.getSize();
    for (i = 0; i < len; i++) {
        if (opaqueSigNames.indexOf(sigNames.at(i)) !== TP.NOT_FOUND) {
            return true;
        }
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('mutationAddedNodes',
function(anElement, nodesAdded) {

    /**
     * @method mutationAddedNodes
     * @summary Handles a 'nodes added' synthetic 'event' that was dispatched
     *     against the supplied native element.
     * @description This method is usually activated as the result of a 'DOM
     *     Mutation' of this node whereby a descendant is being added. Note that
     *     the 'nodesAdded' parameter here contains a list of *roots* that will
     *     have been added to the receiver. Any descendants of these roots will
     *     not be in this list.
     * @param {HTMLElement} anElement The target element computed for this
     *     signal.
     * @param {Node[]} nodesAdded The nodes added to the receiver.
     * @exception TP.sig.InvalidElement
     * @returns {TP.meta.dom.UIElementNode} The receiver.
     */

    var processor,

        mutatedGIDs,

        rootNodesAdded,

        len,
        i,

        root,

        beforeProcessingDescendants,

        doc,
        evt;

    if (!TP.isElement(anElement)) {
        return this.raise('TP.sig.InvalidElement');
    }

    //  Allocate a tag processor and initialize it with the ATTACH_PHASES
    processor = TP.tag.TagProcessor.constructWithPhaseTypes(
                                    TP.tag.TagProcessor.ATTACH_PHASES);

    mutatedGIDs = TP.ac();

    //  Filter out any non-roots. We only want to process roots.
    rootNodesAdded = TP.nodeListFilterNonRoots(nodesAdded);

    //  Now, process each *root* that we have gotten as an added root
    len = rootNodesAdded.getSize();
    for (i = 0; i < len; i++) {
        root = rootNodesAdded.at(i);

        //  Check to make sure we haven't already awakened this content. If so
        //  we want to exit.
        if (root[TP.AWAKENED]) {
            continue;
        }

        //  Check to make sure this isn't a 'generated node'. If so we want to
        //  exit.
        if (root[TP.GENERATED]) {
            continue;
        }

        //  It seems weird that the root might be detached since it was 'added',
        //  but the way that mutation observers work (they trigger this code) is
        //  that the root might have been added and then removed all before the
        //  'mutation records' are processed. We need to make sure the DOM root
        //  is still attached.
        if (TP.nodeIsDetached(root)) {
            continue;
        }

        //  If the root is an Element and it has an attribute of
        //  'tibet:no-awaken', then skip processing it.
        if (TP.isElement(root) &&
            TP.elementHasAttribute(root, 'tibet:no-awaken', true)) {
            continue;
        }

        //  If the root has an ancestor Element that has an attribute of
        //  'tibet:no-awaken', then skip processing it.
        if (TP.isElement(TP.nodeGetFirstAncestorByAttribute(
                                        root, 'tibet:no-awaken', null, true))) {
            continue;
        }

        //  Note here how we assign the global ID if there isn't one present.
        //  This is important for observers of this signal who will want to come
        //  back and reference these elements.
        if (TP.isElement(root)) {
            mutatedGIDs.push(TP.gid(root, true));
        } else {
            mutatedGIDs.push(TP.gid(root.parentNode, true));
        }

        //  If root is a collection node (i.e. Element, Document or
        //  DocumentFragment), then we stamp TP.AWAKENED on all of its
        //  descendant nodes. The awakening process will have awakened them too.
        //  That way, if another mutation signal is sent with one of them as a
        //  root, they will be filtered out of this loop. Note that they will
        //  still get a 'TP.sig.AttachComplete' signal sent from them below.

        //  NOTE: We do this *before* processing the DOM tree starting with
        //  root, in case any descendants are added in that process. We *only*
        //  want descendants who were there *prior* to the processing to be
        //  stamped.
        if (TP.isCollectionNode(root)) {
            beforeProcessingDescendants = TP.nodeGetDescendants(root);
        } else {
            beforeProcessingDescendants = null;
        }

        processor.processTree(root);

        if (TP.isValid(beforeProcessingDescendants)) {
            beforeProcessingDescendants.forEach(
                function(aNode) {
                    aNode[TP.AWAKENED] = true;
                });
        }

        //  If the node is an element, then remove any 'tibet:recasting' flag
        //  that might have been put on the element by our redraw machinery.
        if (TP.isElement(root)) {
            TP.elementRemoveAttribute(root, 'tibet:recasting', true);
        }
    }

    //  Now, we iterate again over all of our root nodes and, whether they were
    //  already awakened as part of their parents awakening and ignoring their
    //  (or a parent's) 'tibet:no-awaken' attribute, we send a
    //  'TP.sig.AttachComplete' signal from them and containing all of the
    //  mutated GIDs that we gathered above.
    for (i = 0; i < len; i++) {
        root = rootNodesAdded.at(i);

        //  Check to make sure this isn't a 'generated node'. If so we want to
        //  exit.
        if (root[TP.GENERATED]) {
            continue;
        }

        //  It seems weird that the root might be detached since it was 'added',
        //  but the way that mutation observers work (they trigger this code) is
        //  that the root might have been added and then removed all before the
        //  'mutation records' are processed. We need to make sure the DOM root
        //  is still attached.
        if (TP.nodeIsDetached(root)) {
            continue;
        }

        //  Signal from the root node that attach processing is complete.
        TP.signal(TP.wrap(root),
                    'TP.sig.AttachComplete',
                    TP.hc('mutatedNodeIDs', mutatedGIDs));
    }

    //  Send a custom DOM-level event to allow 3rd party libraries to know that
    //  content has been added.

    doc = TP.doc(anElement);

    evt = doc.createEvent('Event');
    evt.initEvent('TIBETContentAdded', true, true);
    evt.data = rootNodesAdded;

    doc.body.dispatchEvent(evt);

    //  Signal from our target element's document that we attached nodes due to
    //  a mutation.
    TP.signal(TP.tpdoc(anElement),
                'TP.sig.MutationAttach',
                TP.hc('mutationTarget', TP.wrap(anElement),
                        'mutatedNodeIDs', mutatedGIDs));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('mutationRemovedNodes',
function(anElement, nodesRemoved) {

    /**
     * @method mutationRemovedNodes
     * @summary Handles a 'nodes removed' synthetic 'event' that was dispatched
     *     against the supplied native element.
     * @description This method is usually activated as the result of a 'DOM
     *     Mutation' of this node whereby a descendant is being removed. Note
     *     that the 'nodesRemoved' parameter here contains a list of *roots*
     *     that will have been removed from the receiver. Any descendants of
     *     these roots will not be in this list.
     * @param {HTMLElement} anElement The target element computed for this
     *     signal.
     * @param {Node[]} nodesRemoved  The nodes removed from the receiver.
     * @exception TP.sig.InvalidElement
     * @returns {TP.meta.dom.UIElementNode} The receiver.
     */

    var processor,

        mutatedGIDs,

        rootNodesRemoved,

        focusStackCheckElems,

        len,
        i,

        shouldProcess,

        parentHasNoAwaken,
        targetHasNoAwaken,
        targetAnsHasNoAwaken,

        root,

        tpElement,

        doc,
        evt;

    if (!TP.isElement(anElement)) {
        return this.raise('TP.sig.InvalidElement');
    }

    //  Allocate a tag processor and initialize it with the DETACH_PHASES
    processor = TP.tag.TagProcessor.constructWithPhaseTypes(
                                    TP.tag.TagProcessor.DETACH_PHASES);

    mutatedGIDs = TP.ac();

    //  Filter out any non-roots. We only want to process roots.
    rootNodesRemoved = TP.nodeListFilterNonRoots(nodesRemoved);

    focusStackCheckElems = TP.ac();

    //  Now, process each *root* that we have gotten as a removed root
    len = rootNodesRemoved.getSize();
    for (i = 0; i < len; i++) {

        root = rootNodesRemoved.at(i);

        //  Check to make sure this isn't a 'generated node'. If so we want to
        //  exit.
        if (root[TP.GENERATED]) {
            continue;
        }

        //  Note here how we assign the global ID if there isn't one present.
        //  This is important for observers of this signal who will want to come
        //  back and reference these elements.
        if (TP.isElement(root)) {
            mutatedGIDs.push(TP.gid(root, true));
        } else {
            mutatedGIDs.push(TP.gid(root.parentNode, true));
        }

        //  Initially we're set to process this markup.
        shouldProcess = true;

        //  But if the root is an Element and it has an attribute of
        //  'tibet:no-awaken', then skip processing it.
        if (TP.isElement(root) &&
            TP.elementHasAttribute(root, 'tibet:no-awaken', true)) {
            shouldProcess = false;
        }

        //  If the shouldProcess flag is still true
        if (shouldProcess) {
            //  We need to now check for 'tibet:no-awaken' in the hierarchy of
            //  the root. Because the root is detached, we need to break this
            //  check into 2 parts: the first part will check the root's
            //  ancestor tree (if there is any) and the second part will check
            //  from the target root.
            //  Then both results will be checked. This gives the maximum chance
            //  that a 'tibet:no-awaken' flag will be found, if it ever existed
            //  for this root.

            if (TP.isElement(root.parentNode)) {
                parentHasNoAwaken = TP.nodeGetFirstAncestorByAttribute(
                                        root, 'tibet:no-awaken', null, true);
            }

            targetHasNoAwaken = TP.elementHasAttribute(
                                    anElement, 'tibet:no-awaken', true);

            targetAnsHasNoAwaken = TP.nodeGetFirstAncestorByAttribute(
                                    anElement, 'tibet:no-awaken', null, true);

            if (parentHasNoAwaken ||
                targetHasNoAwaken ||
                targetAnsHasNoAwaken) {
                shouldProcess = false;
            }
        }

        if (shouldProcess) {
            //  Note here how we pass true to allow the processing pipeline to
            //  process the root, even though it was detached.
            processor.processTree(root, null, true);
        }

        if (TP.isElement(root)) {
            focusStackCheckElems.push(root);

            focusStackCheckElems = focusStackCheckElems.concat(
                                TP.nodeGetDescendantElements(root, '*'));
        }

        //  Signal from the root node that detach processing is complete.
        TP.signal(TP.wrap(root),
                    'TP.sig.DetachComplete',
                    TP.hc('mutatedNodeIDs', mutatedGIDs));
    }

    tpElement = TP.wrap(anElement);

    //  Send a custom DOM-level event to allow 3rd party libraries to know that
    //  content has been added.

    doc = TP.doc(anElement);

    evt = doc.createEvent('Event');
    evt.initEvent('TIBETContentRemoved', true, true);
    evt.data = rootNodesRemoved;

    doc.body.dispatchEvent(evt);

    //  Signal from our target element's document that we detached nodes due to
    //  a mutation.
    TP.signal(TP.tpdoc(anElement),
                'TP.sig.MutationDetach',
                TP.hc('mutationTarget', tpElement,
                        'mutatedNodeIDs', mutatedGIDs));

    //  If the target element is empty, signal DOMContentUnloaded for
    //  convenience purposes for observers.
    if (tpElement.isEmpty()) {
        TP.signal(tpElement, 'TP.sig.DOMContentUnloaded');
    }

    //  Filter any elements that are descendants of the nodes we are removing
    //  from the DOM out of the $focus_stack.

    if (TP.notEmpty(focusStackCheckElems)) {
        TP.$focus_stack = TP.$focus_stack.reject(
                            function(aTPElem) {
                                if (focusStackCheckElems.contains(
                                        aTPElem.getNativeNode(),
                                        TP.IDENTITY)) {
                                    return true;
                                }

                                return false;
                            });
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('shouldAutoWrapItems',
function(anObject, formatArgs) {

    /**
     * @method shouldAutoWrapItems
     * @summary Whether or not our fromArray() / fromObject() methods
     *     'auto-wrap items'. See those methods for more information.
     * @param {Object} anObject The Object of content to wrap in markup.
     * @param {TP.core.Hash} formatArgs An optional object containing
     *     parameters.
     * @returns {Boolean} Whether or not we automatically wrap items.
     */

    if (TP.isBoolean(formatArgs.at('autowrap'))) {
        return formatArgs.at('autowrap');
    }

    return true;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver. For most tags this is a noop.
     * @param {TP.sig.ShellRequest} aRequest The shell request currently being
     *     processed.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    return TP.CONTINUE;
});

//  ------------------------------------------------------------------------
//  Awakening/Deadening Methods
//  ------------------------------------------------------------------------

/*
TIBET's content-setting methods rely on TP.nodeAwakenContent to ensure
that any runtime setup or "awakening" needed by the new content gets done.

Specific examples include XML Events setup, which is needed to ensure that
both the arming and observation phases are done for any ev: namespaced
content. Without an awakening step the page's events would not operate.
*/

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeAwakenContent',
function(aNode) {

    /**
     * @method nodeAwakenContent
     * @summary This method is the primary entry point for awakening new
     *     content that has been added to a visible DOM.
     * @description You don't normally call this, it's invoked by the various
     *     setContent() calls to ensure that new content is properly awakened.
     * @param {Node} aNode The node to awaken.
     * @exception TP.sig.InvalidNode
     */

    var processor;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    //  NB: We don't bother to check the TP.AWAKENED and TP.GENERATED flags here
    //  since we're 'forcing' an awaken.

    //  If the node is an Element and it has an attribute of 'tibet:no-awaken',
    //  then skip processing it.
    if (TP.isElement(aNode) &&
        TP.elementHasAttribute(aNode, 'tibet:no-awaken', true)) {
        return;
    }

    //  If the node has an ancestor Element that has an attribute of
    //  'tibet:no-awaken', then skip processing it.
    if (TP.isElement(TP.nodeGetFirstAncestorByAttribute(
                                    aNode, 'tibet:no-awaken', null, true))) {
        return;
    }

    //  Allocate a tag processor and initialize it with the ATTACH_PHASES
    processor = TP.tag.TagProcessor.constructWithPhaseTypes(
                                    TP.tag.TagProcessor.ATTACH_PHASES);

    //  Process the tree of markup
    processor.processTree(aNode);

    //  Flag the node as having been awakened. This state is checked by mutation
    //  handlers etc. to avoid duplicate effort.
    aNode[TP.AWAKENED] = true;

    //  If the node is an element, then remove any 'tibet:recasting' flag that
    //  might have been put on the element by our redraw machinery.
    if (TP.isElement(aNode)) {
        TP.elementRemoveAttribute(aNode, 'tibet:recasting', true);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.definePrimitive('nodeDeadenContent',
function(aNode) {

    /**
     * @method nodeDeadenContent
     * @summary This method is the primary entry point for deadening existing
     *     content that is being removed from a visible DOM.
     * @description You don't normally call this - in fact, it's rarely invoked.
     * @param {Node} aNode The node to deaden.
     * @exception TP.sig.InvalidNode
     */

    var processor;

    if (!TP.isNode(aNode)) {
        return TP.raise(this, 'TP.sig.InvalidNode');
    }

    //  NB: We don't bother to check the TP.AWAKENED and TP.GENERATED flags here
    //  since we're 'forcing' a deaden.

    //  If the node is an Element and it has an attribute of 'tibet:no-awaken',
    //  then skip processing it.
    if (TP.isElement(aNode) &&
        TP.elementHasAttribute(aNode, 'tibet:no-awaken', true)) {
        return;
    }

    //  If the node has an ancestor Element that has an attribute of
    //  'tibet:no-awaken', then skip processing it.
    if (TP.isElement(TP.nodeGetFirstAncestorByAttribute(
                                    aNode, 'tibet:no-awaken', null, true))) {
        return;
    }

    //  Allocate a tag processor and initialize it with the ATTACH_PHASES
    processor = TP.tag.TagProcessor.constructWithPhaseTypes(
                                    TP.tag.TagProcessor.DETACH_PHASES);

    //  Process the tree of markup
    processor.processTree(aNode);

    //  Flag the node as having not been awakened. This state is checked by
    //  mutation handlers etc. to avoid duplicate effort.
    aNode[TP.AWAKENED] = false;

    //  If the node is an element, then remove any 'tibet:recasting' flag that
    //  might have been put on the element by our redraw machinery.
    if (TP.isElement(aNode)) {
        TP.elementRemoveAttribute(aNode, 'tibet:recasting', true);
    }

    return;
});

//  ------------------------------------------------------------------------
//  Tag Phase Support
//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('tagAttachBinds',
function(aRequest) {

    /**
     * @method tagAttachBinds
     * @summary Awakens any bind: namespace event handlers for the element in
     *     aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var node,
        type;

    if (TP.notValid(type = TP.bind.XMLNS)) {
        return this.raise('TP.sig.InvalidType',
                            'Couldn\'t find the \'bind:\' namespace type');
    }

    node = aRequest.at('node');

    return type.setup(node);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('tagAttachComplete',
function(aRequest) {

    /**
     * @method tagAttachComplete
     * @summary Executes once the tag has been fully processed and its
     *     attachment phases are fully complete.
     * @description At this level, this type detects any 'on:' attributes that
     *     have to do with 'attachment' and processes them according to 'on:'
     *     rules.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var node,
        onAttrNodes,

        len,
        i,

        name,

        sigData;

    node = aRequest.at('node');

    //  Detect if there are any attribute nodes in the 'on:' namespace
    if (TP.notEmpty(onAttrNodes = TP.elementGetAttributeNodesInNS(
                            node, null, TP.w3.Xmlns.ON))) {

        //  If so, loop over them, detecting to see if any of them have to do
        //  with attachment.
        len = onAttrNodes.getSize();
        for (i = 0; i < len; i++) {

            name = TP.attributeGetLocalName(onAttrNodes.at(i));

            //  If the name matches any one of the three forms that we allow,
            //  then go ahead and grab the signal data from the attribute's
            //  value and queue the signal.
            if (name === 'attach' ||
                name === 'TP.sig.AttachComplete' ||
                name === 'AttachComplete') {

                sigData = onAttrNodes.at(i).value;

                TP.queueSignalFromData(
                    sigData,
                    node,
                    null,   //  signal
                    null,   //  payload
                    null,   //  policy
                    TP.sig.ResponderSignal);
            }
        }
    }

    //  Since the type is actually being used, we register it as a 'manual
    //  dependency' (since, sometimes, custom elements are simple and don't have
    //  methods to get triggered, and therefore tracked). Note that we only do
    //  this if we're tracking method invocations, which means we're probably
    //  trying to compute missing packages or scripts given a baseline code
    //  package. .
    if (TP.isTrue(TP.sys.cfg('oo.$$track_invocations'))) {
        if (!TP.sys.hasManualDependencies(TP.name(this))) {
            TP.sys.addManualDependencies(TP.name(this), this.getDependencies());
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('tagAttachDOM',
function(aRequest) {

    /**
     * @method tagAttachDOM
     * @summary Sets up runtime machinery for the element in aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var elem,
        tpElem,

        reloadableAttrs,
        len,
        i,

        attrName,
        val,

        uri,

        obsAttrs;

    //  If we are configured to watch remote resources, then we need to query
    //  this type for any 'reloadable URI attributes' and observe any URI
    //  values that we find there.
    if (TP.sys.cfg('uri.source.watch_changes')) {

        //  Make sure that we have a node to work from.
        if (!TP.isElement(elem = aRequest.at('node'))) {
            return this.raise('TP.sig.InvalidNode');
        }

        tpElem = TP.wrap(elem);

        //  Iterate over the reloadable attributes and try to get a URI value
        //  from each one.

        reloadableAttrs = this.get('reloadableUriAttrs');
        len = reloadableAttrs.getSize();

        for (i = 0; i < len; i++) {
            attrName = reloadableAttrs.at(i);

            if (TP.notEmpty(
                val = TP.elementGetAttribute(elem, attrName, true))) {

                //  If we can create a valid URI from the value we find there,
                //  observe it for changes and tell it to watch its handler for
                //  change notifications.

                uri = TP.uc(val);
                if (TP.isURI(uri)) {
                    tpElem.observe(uri, 'TP.sig.ValueChange');
                    uri.watch();
                }

                if (!TP.isArray(obsAttrs = elem[TP.OBSERVED_ATTRS])) {
                    obsAttrs = TP.ac();
                    elem[TP.OBSERVED_ATTRS] = obsAttrs;
                }

                obsAttrs.push(attrName);
            }
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('tagAttachEvents',
function(aRequest) {

    /**
     * @method tagAttachEvents
     * @summary Attaches any ev: namespace event handlers for the element in
     *     aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var node,
        type;

    if (TP.notValid(type = TP.ev.XMLNS)) {
        return this.raise('TP.sig.InvalidType',
                            'Couldn\'t find the \'ev:\' namespace type');
    }

    node = aRequest.at('node');

    return type.setup(node);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('tagAttachSignals',
function(aRequest) {

    /**
     * @method tagAttachSignals
     * @summary Awakens any on: namespace signal handlers for the element in
     *     aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var node,
        type;

    if (TP.notValid(type = TP.on.XMLNS)) {
        return this.raise('TP.sig.InvalidType',
                            'Couldn\'t find the \'on:\' namespace type');
    }

    node = aRequest.at('node');

    return type.setup(node);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('tagDetachBinds',
function(aRequest) {

    /**
     * @method tagDetachBinds
     * @summary Detaches any bind: namespace event handlers for the element in
     *     aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var node,
        type;

    if (TP.notValid(type = TP.bind.XMLNS)) {
        return this.raise('TP.sig.InvalidType',
                            'Couldn\'t find the \'bind:\' namespace type');
    }

    node = aRequest.at('node');

    return type.teardown(node);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('tagDetachComplete',
function(aRequest) {

    /**
     * @method tagDetachComplete
     * @summary Executes when the tag's detachment phases are fully complete.
     * @description At this level, this type detects any 'on:' attributes that
     *     have to do with 'detachment' and processes them according to 'on:'
     *     rules.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var node,
        onAttrNodes,

        len,
        i,

        name,

        sigData;

    node = aRequest.at('node');

    //  Detect if there are any attribute nodes in the 'on:' namespace
    if (TP.notEmpty(onAttrNodes = TP.elementGetAttributeNodesInNS(
                            node, null, TP.w3.Xmlns.ON))) {

        //  If so, loop over them, detecting to see if any of them have to do
        //  with detachment.
        len = onAttrNodes.getSize();
        for (i = 0; i < len; i++) {

            name = TP.attributeGetLocalName(onAttrNodes.at(i));

            //  If the name matches any one of the three forms that we allow,
            //  then go ahead and grab the signal data from the attribute's
            //  value and queue the signal.
            if (name === 'detach' ||
                name === 'TP.sig.DetachComplete' ||
                name === 'DetachComplete') {

                sigData = onAttrNodes.at(i).value;

                TP.queueSignalFromData(
                    sigData,
                    node,
                    null,   //  signal
                    null,   //  payload
                    null,   //  policy
                    TP.sig.ResponderSignal);
            }
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('tagDetachDOM',
function(aRequest) {

    /**
     * @method tagDetachDOM
     * @summary Performs any 'detach' logic when the node is detached from its
     *     owning document.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var elem,
        tpElem,

        reloadableAttrs,
        len,
        i,

        attrName,
        val,

        uri,

        obsAttrs;

    //  If we are configured to watch remote resources, then we need to query
    //  this type for any 'reloadable URI attributes' and ignore any URI
    //  values that we find there (we will have already observed them in the
    //  'tagAttachDOM' call above).
    if (TP.sys.cfg('uri.source.watch_changes')) {

        //  Make sure that we have a node to work from.
        if (!TP.isElement(elem = aRequest.at('node'))) {
            return this.raise('TP.sig.InvalidNode');
        }

        tpElem = TP.wrap(elem);

        //  Iterate over the reloadable attributes and try to get a URI value
        //  from each one.

        reloadableAttrs = this.get('reloadableUriAttrs');
        len = reloadableAttrs.getSize();

        for (i = 0; i < len; i++) {

            if (!TP.isArray(obsAttrs = elem[TP.OBSERVED_ATTRS])) {
                continue;
            }

            attrName = reloadableAttrs.at(i);

            if (obsAttrs.contains(attrName)) {

                if (TP.notEmpty(val =
                        TP.elementGetAttribute(elem, attrName, true))) {

                    //  If we can create a valid URI from the value we find
                    //  there, ignore it for changes and tell it to unwatch its
                    //  handler for change notifications.

                    uri = TP.uc(val);
                    if (TP.isURI(uri)) {
                        tpElem.ignore(uri, 'TP.sig.ValueChange');

                        //  NOTE: we DO NOT unwatch() the URI since other
                        //  elements may be observing it.
                    }

                    obsAttrs.splice(obsAttrs.indexOf(attrName), 1);
                }
            }
        }

        //  Note: call this *after* we do the above since it does a bunch of
        //  unregistration, etc.
        this.callNextMethod();
    }

    return;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('tagDetachEvents',
function(aRequest) {

    /**
     * @method tagDetachEvents
     * @summary Detaches any ev: namespace event handlers for the element in
     *     aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var node,
        type;

    if (TP.notValid(type = TP.ev.XMLNS)) {
        return this.raise('TP.sig.InvalidType',
                            'Couldn\'t find the \'ev:\' namespace type');
    }

    node = aRequest.at('node');

    return type.teardown(node);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('tagDetachSignals',
function(aRequest) {

    /**
     * @method tagDetachSignals
     * @summary Detaches any on: namespace signal handlers for the element in
     *     aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var node,
        type;

    if (TP.notValid(type = TP.on.XMLNS)) {
        return this.raise('TP.sig.InvalidType',
                            'Couldn\'t find the \'on:\' namespace type');
    }

    node = aRequest.at('node');

    return type.teardown(node);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('tagResolve',
function(aRequest) {

    /**
     * @method tagResolve
     * @summary Resolves the receiver's content. This includes resolving XML
     *     Base URIs and virtual URIs that may occur on the receiver's
     *     attributes.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var elem,
        uriAttrs;

    //  Make sure that we have a node to work from.
    if (!TP.isNode(elem = aRequest.at('node'))) {
        //  TODO: Raise an exception.
        return;
    }

    //  Grab the element's 'URI attributes'. If that's empty, then just
    //  return.
    if (TP.isEmpty(uriAttrs = this.get('uriAttrs'))) {
        return;
    }

    //  Iterate over any URI attributes and call rewrite() on their values.
    //  This will cause any mapped URIs to be rewritten before their XML
    //  Base value is resolved.
    uriAttrs.perform(
            function(attrName) {

                var attrVal,

                    hadScheme,

                    newVal,

                    root,
                    base;

                attrVal = TP.elementGetAttribute(elem, attrName, true);

                //  Just in case the URI was encoded, as it is by some browsers
                //  (Firefox), make sure to decode it.
                attrVal = decodeURIComponent(attrVal);

                //  If its an absolute URI, check to see if it needs to be
                //  rewritten.
                if (TP.uriIsAbsolute(attrVal)) {

                    //  If the attribute value already has a scheme, that will
                    //  affect whether we check after we rewrite it to see if
                    //  it needs to be prepended with '~app'
                    hadScheme = TP.regex.HAS_SCHEME.test(attrVal);

                    //  Use the URI map to rewrite the URL.
                    newVal = TP.uri.URI.rewrite(attrVal).getLocation();

                    //  Grab the rewritten URI's root (i.e. scheme + separator)
                    //  and base (the rest after scheme + separator).
                    root = TP.uriRoot(newVal);
                    base = newVal.slice(root.getSize());

                    //  If the URI didn't have a scheme before it was rewritten
                    //  and it's base is exactly the same as the original value,
                    //  then it's a 'root relative path'. Expand it after
                    //  prepending a '~app' onto the front of it.
                    if (!hadScheme && base === attrVal) {
                        newVal = TP.uriExpandPath('~app' + base);
                    }

                    if (newVal !== attrVal) {
                        TP.elementSetAttribute(elem,
                                                attrName,
                                                newVal,
                                                true);
                    }
                }
            });

    //  update the XML Base references in the node
    TP.elementResolveXMLBase(elem, uriAttrs);

    return;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  An Array of attributes that we're suspending from setting temporarily.
TP.dom.ElementNode.Inst.defineAttribute('$suspendedAttributes');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('addAttributeValue',
function(attributeName, attributeValue, checkAttrNSURI) {

    /**
     * @method addAttributeValue
     * @summary Adds an attribute value to the receiver. If the attribute
     *     doesn't exist this is equivalent to setAttribute, however if the
     *     attribute does exist this method will add the new value as a
     *     space-separated portion of the attribute's value.
     * @param {String} attributeName The attribute to set.
     * @param {String} attributeValue The attribute value.
     * @param {Boolean} [checkAttrNSURI=false] True will cause this method to be
     *     more rigorous in its checks for prefixed attributes, looking via
     *     internal TIBET mechanisms in addition to the standard platform
     *     mechanism. The default is false (to keep things faster).
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var natNode,
        hadAttr,
        oldValue,

        retVal,
        newValue,

        op;

    natNode = this.getNativeNode();

    hadAttr = TP.elementHasAttribute(natNode, attributeName);

    oldValue = TP.elementGetAttribute(natNode, attributeName, checkAttrNSURI);

    retVal = TP.elementAddAttributeValue(natNode, attributeName, attributeValue,
                                            checkAttrNSURI);

    newValue = TP.elementGetAttribute(natNode, attributeName, checkAttrNSURI);

    op = hadAttr ? TP.UPDATE : TP.CREATE;

    if (this.shouldFlagChanges() &&
        !TP.regex.TIBET_SCHEME.test(attributeName)) {
        TP.elementFlagChange(natNode, TP.ATTR + attributeName, op);
    }

    this.changed('@' + attributeName,
                    op,
                    TP.hc(TP.OLDVAL, oldValue,
                            TP.NEWVAL, newValue));

    return retVal;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('addClass',
function(className) {

    /**
     * @method addClass
     * @summary Adds the named class to the receiving element.
     * @param {String} className The class to add.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var natNode,
        oldValue,
        newValue;

    natNode = this.getNativeNode();

    oldValue = TP.elementGetClass(natNode);
    TP.elementAddClass(natNode, className);
    newValue = TP.elementGetClass(natNode);

    if (oldValue === newValue) {
        return this;
    }

    if (this.shouldFlagChanges()) {
        TP.elementFlagChange(natNode, TP.ATTR + 'class', TP.UPDATE);
    }

    this.changed('@class',
                    TP.UPDATE,
                    TP.hc(TP.OLDVAL, oldValue,
                            TP.NEWVAL, newValue));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('addObserver',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method addObserver
     * @summary Adds a local signal observation which is roughly like a DOM
     *     element adding an event listener. The observer is typically the
     *     handler provided to an observe() call while the signal is a signal or
     *     string which the receiver is likely to signal or is intercepting for
     *     centralized processing purposes.
     * @description Note that we implement this method because, in order to have
     *     TP.dom.ElementNodes as event sources, they *must* have an assigned,
     *     globally-unique, ID. By implementing this method, we ensure they have
     *     that before they're registered in the signaling system as signal
     *     sources.
     * @param {Object|Object[]} anOrigin One or more origins to observe.
     * @param {Object|Object[]} aSignal One or more signals to observe from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn on observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to add the observation, false otherwise.
     */

    //  To be observed, we really need a global ID. Here, we don't care about
    //  the return value, but make sure to force the assignment of an ID if it's
    //  not already there.
    TP.gid(this.getNativeNode(), true);

    //  Always tell the notification to register our handler, etc.
    return true;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a TIBET source code string.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    return 'TP.tpelem(\'' + this.asString() + '\')';
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('computeAttrMethodName',
function(aPrefix, anAttributeName) {

    /**
     * @method computeAttrMethodName
     * @summary Computes a 'specific' method name based on the supplied prefix
     *     and attribute name. This is usually used for things like 'specific'
     *     setter and getter attribute methods that would be called in lieu of
     *     setAttribute()/getAttribute().
     * @param {String} aPrefix The prefix to prepend to the method name.
     * @param {String} anAttributeName The attribute name to use to compute the
     *     method name. Note that this can be a namespaced attribute name (i.e.
     *     with a colon - ':') and this method will 'collapse' that into a
     *     canonical form.
     * @returns {String} The computed method name.
     */

    var attrName,
        parts,

        methodName;

    attrName = anAttributeName;

    //  if the attribute is namespace qualified, we 'start upper' each piece.
    //  e.g. 'foo:bar' -> 'FooBar'
    if (TP.regex.HAS_COLON.test(attrName)) {
        parts = attrName.split(/:/);
        attrName = TP.makeStartUpper(parts.first()) +
                    TP.makeStartUpper(parts.last());
    } else {

        //  Otherwise, we just 'start upper' the whole piece
        //  'foo' -> 'Foo'
        attrName = TP.makeStartUpper(attrName);
    }

    methodName = aPrefix + attrName;

    return methodName;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('defineBinding',
function(targetAttributeName, resourceOrURI, sourceAttributeName,
         sourceFacetName, transformationFunc) {

    /**
     * @method defineBinding
     * @summary Adds a binding to the instance receiver.
     * @param {String} targetAttributeName The target attribute name.
     * @param {Object} resourceOrURI The resource specification.
     * @param {String} sourceAttributeName The source attribute name. If not
     *     specified, this will default to targetAttributeName.
     * @param {String} sourceFacetName The source facet name. If not specified,
     *     this will default to 'value'.
     * @param {Function} transformationFunc A Function to transform the value
     *     before it is supplied to the observer of the binding. It takes one
     *     parameter, the new value from the model and returns the
     *     transformation parameter. This parameter is optional.
     * @returns {Object} The receiver.
     */

    var targetAttr;

    targetAttr = targetAttributeName;

    //  If the targetAttributeName is either '@content' or '@value', then we
    //  trim it down to 'content' or 'value' - these have special meanings in
    //  TIBET.
    if (targetAttr === '@content') {
        targetAttr = 'content';
    } else if (targetAttr === '@value') {
        targetAttr = 'value';
    }

    return this.callNextMethod(targetAttr, resourceOrURI, sourceAttributeName,
                                sourceFacetName, transformationFunc);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('destroyBinding',
function(targetAttributeName, resourceOrURI, sourceAttributeName,
         sourceFacetName) {

    /**
     * @method destroyBinding
     * @summary Removes a binding from the instance receiver.
     * @param {String} targetAttributeName The target attribute name.
     * @param {Object} resourceOrURI The resource specification.
     * @param {String} sourceAttributeName The source attribute name. If not
     *     specified, this will default to targetAttributeName.
     * @param {String} sourceFacetName The source facet name. If not specified,
     *     this will default to 'value'.
     * @returns {Object} The receiver.
     */

    var targetAttr;

    targetAttr = targetAttributeName;

    //  If the targetAttributeName is either '@content' or '@value', then we
    //  trim it down to 'content' or 'value' - these have special meanings in
    //  TIBET.
    if (targetAttr === '@content') {
        targetAttr = 'content';
    } else if (targetAttr === '@value') {
        targetAttr = 'value';
    }

    return this.callNextMethod(targetAttr, resourceOrURI, sourceAttributeName,
                                sourceFacetName);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('get',
function(attributeName) {

    /**
     * @method get
     * @summary Returns the value, if any, of the attribute provided. Note
     *     however that special parsing rules apply to TP.dom.Node types.
     * @description TP.dom.Nodes, particularly TP.dom.ElementNode nodes, can
     *     process complex paths consistent with a variety of standards. The
     *     parsing of these paths is handled by the TP.nodeEvaluatePath()
     *     primitive when any non-JS identifier characters are found in the
     *     path. In all other cases the standard attribute/property access rules
     *     apply. This implies that to force a path to be parsed a certain way
     *     there must be either unique character values in the path or a
     *     "scheme" function must enclose the path. This latter approach is
     *     consistent with how XPointers and XForms extensions work, making use
     *     of xpointer(), xpath1(), element() and similar schemes. TIBET adds
     *     css() and similar extensions to allow a URI fragment to define a
     *     specific form of path traversal, reducing overhead and helping to
     *     avoid ambiguous syntax variations. In the absence of this indicator
     *     the path is checked for various characters that might help indicate
     *     what type of path it is, but given the overlap between standards the
     *     result isn't always deterministic. See nodeEvaluatePath() for more.
     * @param {String} attributeName The name of the attribute to return.
     * @returns {String|Object} The value of the desired attribute.
     */

    var path,
        pathStr,

        funcName,

        args;

    if (TP.isEmpty(attributeName)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  We can shortcut '#document' by just returning our document
    if (attributeName === '#document') {
        return this.getDocument();
    }

    //  A shortcut - if the attribute name is '.' or '$_', then that's
    //  shorthand for returning ourselves.
    if (TP.regex.ONLY_PERIOD.test(attributeName) ||
        TP.regex.ONLY_STDIN.test(attributeName)) {
        return this;
    }

    //  If we got handed an 'access path', then we need to let it handle this.
    if (!TP.isString(attributeName) && attributeName.isAccessPath()) {
        path = attributeName;

        //  If the path's String representation is a simple JS_IDENTIFIER, then
        //  we need to check to see if this is just a TIBET path with a name to
        //  an 'aliased' access path (i.e. 'lastname' -> 'foo.bar.lastname').
        //  So, here we check to see if there is an access path for this simple
        //  identifier and, if there is, we use *that* path as the way to access
        //  the underlying data. If not, then we check to see (since we have a
        //  JS identifier as a simple path String) if there is a getter that
        //  matches the identifier.
        if (TP.regex.JS_IDENTIFIER.test(pathStr = path.get('srcPath'))) {
            if (TP.notValid(path = this.getAccessPathFor(
                                        pathStr, 'value', attributeName))) {
                //  try common naming convention first
                funcName = 'get' + TP.makeStartUpper(pathStr);
                if (TP.canInvoke(this, funcName)) {
                    switch (arguments.length) {
                        case 1:
                            return this[funcName]();
                        default:
                            args = TP.args(arguments, 1);
                            return this[funcName].apply(this, args);
                    }
                }

                //  There wasn't a valid access path aliased to that identifier,
                //  so just use the path we were originally going to use.
                path = attributeName;
            }
        }
    } else if (TP.regex.NON_SIMPLE_PATH.test(attributeName) &&
                !TP.regex.ATTRIBUTE.test(attributeName)) {
        path = TP.apc(attributeName, TP.hc('shouldCollapse', true));
    }

    if (TP.notValid(path)) {
        //  optimize for attribute access when prefix indicates (but not for
        //  '@*' paths where the caller wants all attributes).
        if (TP.regex.ATTRIBUTE.test(attributeName) &&
            !TP.regex.ATTRIBUTE_ALL.test(attributeName)) {
            return this.getAttribute(attributeName.slice(1));
        }

        //  We can shortcut barename IDs by evaluating just the barename syntax
        if (TP.regex.BARENAME.test(attributeName)) {

            //  Make sure to TP.wrap() the return value for consistent results
            return TP.wrap(TP.nodeEvaluateBarename(this.getNativeNode(),
                                                    attributeName));
        }

        //  try common naming convention
        funcName = 'get' + TP.makeStartUpper(attributeName);
        if (TP.canInvoke(this, funcName)) {
            switch (arguments.length) {
                case 1:
                    return this[funcName]();
                default:
                    args = TP.args(arguments, 1);
                    return this[funcName].apply(this, args);
            }
        }
    }

    //  If we got a valid path above or if we have a 'value' facet that has an
    //  access path, then invoke the path.
    if (TP.isValid(path) ||
        TP.isValid(path = this.getAccessPathFor(attributeName, 'value'))) {

        pathStr = path.asString();
        //  A shortcut - if the path string is '.' or '$_', then that's
        //  shorthand for returning ourselves.
        if (TP.regex.ONLY_PERIOD.test(pathStr) ||
            TP.regex.ONLY_STDIN.test(pathStr)) {
            return this;
        }

        //  Note here how, if we were given more than 1 arguments, we grab all
        //  of the arguments supplied, make our path source the first argument
        //  and invoke with an apply(). Otherwise, we make an Array that has our
        //  path source and our 'path parameters' as the last argument. In both
        //  cases, this is because executeGet() takes varargs (in case the path
        //  is parameterized).
        if (arguments.length > 1) {
            args = TP.args(arguments);
            args.atPut(0, this.getPathSource(path));
        } else {
            args = TP.ac(this.getPathSource(path), this.getPathParameters());
        }

        //  Make sure to TP.wrap() the return value for consistent results
        return TP.wrap(path.executeGet.apply(path, args));
    }

    //  let the standard mechanism handle it
    return this.getProperty(attributeName);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$getAttribute',
function(attributeName) {

    /**
     * @method $getAttribute
     * @summary Returns the value of the attribute provided.
     * @description The typical operation is to retrieve the attribute from the
     *     receiver's native node. When the attribute is prefixed this method
     *     will attempt to find the matching attribute value for that prefix
     *     based on the document's prefixes and TIBET's canonical prefixing
     *     information regarding namespaces. Note that this call is only valid
     *     for Element nodes; when invoked on a document the documentElement is
     *     targeted.
     * @param {String} attributeName The attribute to find.
     * @returns {String} The attribute value, if found.
     */

    var node;

    node = this.getNativeNode();

    return TP.elementGetAttribute(node, attributeName, true);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getAttribute',
function(attributeName) {

    /**
     * @method getAttribute
     * @summary Returns the value of the attribute provided.
     * @description The typical operation is to retrieve the attribute from the
     *     receiver's native node. When the attribute is prefixed this method
     *     will attempt to find the matching attribute value for that prefix
     *     based on the document's prefixes and TIBET's canonical prefixing
     *     information regarding namespaces. Note that this call is only valid
     *     for Element nodes; when invoked on a document the documentElement is
     *     targeted.
     * @param {String} attributeName The attribute to find.
     * @returns {String} The attribute value, if found.
     */

    var methodName;

    //  try attribute manipulation naming convention first
    methodName = this.computeAttrMethodName('getAttr', attributeName);
    if (TP.canInvoke(this, methodName)) {
        return this[methodName]();
    }

    return this.$getAttribute(attributeName);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getAttributes',
function(attributeName, stripPrefixes) {

    /**
     * @method getAttributes
     * @summary Returns a hash of zero to N attribute name/value pairs,
     *     potentially matching the attribute name provided. For document nodes
     *     this operation effectively operates on the document's
     *     documentElement.
     * @param {String|RegExp} attributeName An attributeName "search" criteria
     *     of the form 'wholename' '*:localname' or 'prefix:*' or any RegExp.
     *     This is optional.
     * @param {Boolean} stripPrefixes Whether or not to strip any namespace
     *     prefixes from the attribute names as they are populated into the
     *     return value.
     * @returns {TP.core.Hash} A collection of name/value pairs.
     */

    var node;

    node = this.getNativeNode();

    return TP.elementGetAttributes(node, attributeName, stripPrefixes);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getCanonicalName',
function() {

    /**
     * @method getCanonicalName
     * @summary Returns a string containing the receiving node's canonical
     *     name, the canonical namespace prefix and local name combination.
     * @returns {String} The receiver's tag name.
     */

    return TP.elementGetCanonicalName(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getClass',
function() {

    /**
     * @method getClass
     * @summary Returns the CSS class attribute value of the receiving element.
     * @returns {String} The class value, if any.
     */

    var natNode;

    natNode = this.getNativeNode();

    return TP.elementGetClass(natNode);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getContentPrimitive',
function(operation) {

    /**
     * @method getContentPrimitive
     * @summary Returns the primitive function used to perform the operation
     *     specified. For example, an operation of TP.APPEND might return the
     *     TP.nodeAddContent primitive or a related function specific to the
     *     type of node being modified.
     * @param {String} operation A constant defining the operation. Valid values
     *     include: TP.APPEND TP.INSERT TP.UPDATE.
     * @exception TP.sig.InvalidOperation When the operation isn't a valid one.
     * @returns {Function} A TP primitive function.
     */

    switch (operation) {
        case TP.APPEND:
            return TP.elementAddContent;
        case TP.INSERT:
            return TP.elementInsertContent;
        case TP.REPLACE:
            return TP.elementReplaceWith;
        case TP.UPDATE:
            return TP.elementSetContent;
        default:
            return this.raise('TP.sig.InvalidOperation');
    }
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getChangeAction',
function(locationPath) {

    /**
     * @method getChangeAction
     * @summary Returns any action for the supplied location path.
     * @description The supplied location path should take the form of:
     *     TP.SELF                  ->  The action for the receiving element
     *                                  itself.
     *     TP.ATTR + attributeName  ->  The action for a named attribute
     *                                  E.g. 'TP.ATTRfoo'
     * @param {String} locationPath The location path to query for an action.
     * @returns {String} An action such as TP.CREATE, TP.UPDATE or TP.DELETE
     */

    var action;

    action = TP.elementGetChangeAction(
                            this.getNativeNode(true, true),
                            locationPath);

    return action;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getFullName',
function() {

    /**
     * @method getFullName
     * @summary Returns a string containing the receiving node's full
     *     name, the actual namespace prefix and local name combination.
     * @returns {String} The receiver's tag name.
     */

    return TP.elementGetFullName(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getID',
function() {

    /**
     * @method getID
     * @summary Returns the public ID of the receiver.
     * @returns {String} The public ID of the receiver.
     */

    //  Make sure that, if the receiver is a prototype, we just return the value
    //  of the TP.ID slot. Otherwise, we're trying to get an ID from an object
    //  that represents only a partially formed instance for this type.
    if (TP.isPrototype(this)) {
        return this[TP.ID];
    }

    //  Note the difference here from the version we override from our supertype
    //  - we want to force the assignment of an ID if it's not already there.

    return TP.gid(this.getNativeNode(), true);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getLocalName',
function() {

    /**
     * @method getLocalName
     * @summary Returns the local (unprefixed) name of the receiver.
     * @returns {String} The local name of the receiver.
     */

    return TP.elementGetLocalName(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getTagName',
function() {

    /**
     * @method getTagName
     * @summary Returns a string containing the receiving node's 'tagname'.
     *     This operation only returns valid strings for Element nodes.
     * @returns {String} The receiver's tag name.
     */

    var node;

    node = this.getNativeNode();

    return node.tagName;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getTagPrefix',
function() {

    /**
     * @method getTagPrefix
     * @summary Returns a string containing the receiving node's 'prefix'.
     *     This operation only returns valid strings for Element nodes.
     * @returns {String} The receiver's tag prefix.
     */

    var node;

    node = this.getNativeNode();

    return node.prefix;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getTemplateName',
function() {

    /**
     * @method getTemplateName
     * @summary Returns the name of any associated template for the receiver.
     * @returns {String|undefined} The template name.
     */

    var urn;

    urn = this.getAttribute('tsh:template');
    if (TP.notEmpty(urn)) {
        urn = urn.startsWith(TP.TIBET_URN_PREFIX) ?
                    urn :
                    TP.TIBET_URN_PREFIX + urn;

        return urn;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getTextContent',
function() {

    /**
     * @method getTextContent
     * @summary Returns the normalized text content of the receiver.
     * @returns {String} The receiver's text value.
     */

    var content,
        type,
        formats;

    content = TP.nodeGetTextContent(this.getNativeNode());

    //  If the receiver has a 'ui:type' attribute, then try first to convert the
    //  content to that type before trying to format it.
    if (TP.notEmpty(type = this.getAttribute('ui:type'))) {
        if (!TP.isType(type = TP.sys.getTypeByName(type))) {
            return this.raise('TP.sig.InvalidType');
        } else {
            content = type.fromString(content);
        }
    }

    //  If the receiver has a 'ui:storage' attribute, then format the return
    //  value according to the formats found there.
    if (TP.notEmpty(formats = this.getAttribute('ui:storage'))) {
        content = this.$formatValue(content, formats);
    }

    return content;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getTextNodesMatching',
function(aMatchFunction) {

    /**
     * @method getTextNodesMatching
     * @summary Returns any descendant Text nodes under the receiving element
     *     that return true when the supplied matching Function executed against
     *     their nodeValue.
     * @param {Function} aMatchFunction The Function to execute against the
     *     nodeValue of each descendant Text node. This should take one
     *     argument, the text node to test, and return a Boolean as to whether
     *     the text node matches.
     * @returns {Text[]} An array of Text nodes that match the criteria in the
     *     supplied matching Function.
     */

    return TP.elementGetTextNodesMatching(
                            this.getNativeNode(), aMatchFunction);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineHandler('ValueChange',
function(aSignal) {

    /**
     * @method handleValueChange
     * @summary Handles notification of a change.
     * @description If the origin is a URI that one of our 'reloadable
     *     attributes' has as the reference to its remote resource, then the
     *     'reloadFrom<Attr>' method is invoked on the receiver.
     * @param {TP.sig.Signal} aSignal The signal instance to respond to.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var origin,

        aspect,

        originLocation,

        reloadableAttrs,
        len,
        i,

        attrName,
        attrVal,
        attrURI,

        val,

        methodName,

        dependentURIs,
        lenj,
        j,
        dependentVal;

    //  Grab the signal origin - for changes to observed URI resources (see the
    //  tagAttachDOM()/tagDetachDOM() methods) this should be the URI that
    //  changed.
    origin = aSignal.getSignalOrigin();

    //  If it was a URL, then process it as a 'remote resource change'.
    if (TP.isKindOf(origin, TP.uri.URL)) {

        //  If the aspect is one of URI's 'special aspects', then we just return
        //  here.
        aspect = aSignal.at('aspect');
        if (TP.uri.URI.SPECIAL_ASPECTS.contains(aspect)) {
            return this;
        }

        //  Grab the fully expanded location of the URI that changed.
        originLocation = origin.getLocation();

        //  Iterate over the reloadable attributes.

        reloadableAttrs = this.getType().get('reloadableUriAttrs');
        len = reloadableAttrs.getSize();

        for (i = 0; i < len; i++) {

            attrName = reloadableAttrs.at(i);

            if (TP.notEmpty(attrVal = this.getAttribute(attrName)) &&
                    TP.isURI(attrURI = TP.uc(attrVal))) {

                //  Grab any URI location value that can be computed from the
                //  result of getting the attribute on ourself (and removing any
                //  'unique query' cache-busting string from it).
                val = TP.uriRemoveUniqueQuery(attrURI.getLocation());

                //  Make sure to reset the URI reference here - we want the
                //  original URI in attrURI, not the one with any unique query.
                attrURI = TP.uc(val);

                //  If that value equals the location that changed, call the
                //  proper messaging machinery.
                if (val === originLocation) {

                    //  Compute a method name for reloading the resource
                    //  referenced by that attribute on ourself and invoke it if
                    //  we respond to that method.
                    methodName = this.computeAttrMethodName(
                                                'reloadFromAttr', attrName);

                    if (TP.canInvoke(this, methodName)) {
                        this[methodName](val);
                        break;
                    }
                } else if (TP.notEmpty(dependentURIs =
                                        attrURI.get('dependentURIs'))) {

                    //  If the URI represented by the attribute value has
                    //  'dependent URIs' (it may point to a CSS stylesheet that
                    //  had @imports in it - those @import URIs are dependent
                    //  URIs), then check them against the origin location and
                    //  process them as well, if necessary.
                    lenj = dependentURIs.getSize();
                    for (j = 0; j < lenj; j++) {

                        dependentVal = TP.uriRemoveUniqueQuery(
                                dependentURIs.at(j).getLocation());

                        if (dependentVal === originLocation) {
                            methodName = this.computeAttrMethodName(
                                                'reloadFromAttr', attrName);

                            if (TP.canInvoke(this, methodName)) {
                                this[methodName](val);
                                break;
                            }
                        }
                    }
                }
            }
        }
    } else {
        return this.callNextHandler();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('hasClass',
function(className) {

    /**
     * @method hasClass
     * @summary Tests to see if the receiving element has the named class.
     * @param {String} className The class to test.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var natNode;

    natNode = this.getNativeNode();

    return TP.elementHasClass(natNode, className);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('hasAttribute',
function(attributeName) {

    /**
     * @method hasAttribute
     * @summary Returns whether or not the receiver has the named attribute
     *     provided. This method essentially emulates the native node
     *     hasAttribute call. Note that this call is only valid for Element
     *     nodes; when invoked on a document wrapper the documentElement is
     *     targeted.
     * @param {String} attributeName The attribute to test.
     * @exception TP.sig.InvalidOperation
     * @returns {Boolean} Whether or not the receiver has the named attribute.
     */

    var methodName,
        node;

    //  try attribute manipulation naming convention first
    methodName = this.computeAttrMethodName('hasAttr', attributeName);
    if (TP.canInvoke(this, methodName)) {
        return this[methodName]();
    }

    node = this.getNativeNode();

    return TP.elementHasAttribute(node, attributeName, true);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('isSingleValued',
function(aspectName) {

    /**
     * @method isSingleValued
     * @summary Returns true if the receiver deals with single values.
     * @description See the TP.dom.Node's 'isScalarValued()' instance method
     *     for more information.
     * @param {String} [aspectName] An optional aspect name that is being used
     *     by the caller to determine whether the receiver is single valued for.
     * @returns {Boolean} True when single valued.
     */

    var elem,
        attrVal;

    elem = this.getNativeNode();

    //  If this element has a 'tibet:single' attribute, then we return the value
    //  of that. This allows 'instance level' programming of a particular
    //  element.
    if (TP.elementHasAttribute(elem, 'tibet:single', true)) {
        if (TP.notEmpty(aspectName)) {
            attrVal = TP.elementGetAttribute(elem, 'tibet:single', true);
            attrVal = attrVal.split(' ');
            return attrVal.contains(aspectName);
        }

        return true;
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('isScalarValued',
function(aspectName) {

    /**
     * @method isScalarValued
     * @summary Returns true if the receiver deals with scalar values.
     * @description See the TP.dom.Node's 'isScalarValued()' instance method
     *     for more information.
     * @param {String} [aspectName] An optional aspect name that is being used
     *     by the caller to determine whether the receiver is scalar valued for.
     * @returns {Boolean} True when scalar valued.
     */

    //  If this element has a 'tibet:scalar' attribute, then we return the value
    //  of that. This allows 'instance level' programming of a particular
    //  element.
    var elem,
        attrVal;

    elem = this.getNativeNode();

    //  If this element has a 'tibet:scalar' attribute, then we return the value
    //  of that. This allows 'instance level' programming of a particular
    //  element.
    if (TP.elementHasAttribute(elem, 'tibet:scalar', true)) {
        if (TP.notEmpty(aspectName)) {
            attrVal = TP.elementGetAttribute(elem, 'tibet:scalar', true);
            attrVal = attrVal.split(' ');
            return attrVal.contains(aspectName);
        }

        return true;
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('isSerializationEmpty',
function() {

    /**
     * @method isSerializationEmpty
     * @summary Returns whether or not the receiver should serialize with no
     *     content (i.e. an 'empty element')
     * @description At this type level, this simply returns whether the receiver
     *     is empty (i.e. devoid of child nodes). Subtypes may choose to use
     *     different criteria to determine this.
     * @returns {Boolean} Whether or not the receiver should serialize as an
     *     'empty element'.
     */

    return this.isEmpty();
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('prepopulateRequiredTemplateData',
function(info, nodeContent) {

    /**
     * @method prepopulateRequiredTemplateData
     * @summary Makes sure that any 'required data' needed for processing tags
     *     is defined.
     * @description This method makes sure that if expressions, such as
     *     '{{$SOURCE.(@id)}}' are used in the node's content, that the source
     *     does indeed have a value. This is especially true of attributes like
     *     'id', since there is an assumption that TIBET will dynamically assign
     *     these for us. Therefore, templates are authored that make this
     *     assumption, but in the case of nested templates we need to really
     *     make sure that this happens.
     * @param {TP.core.Hash} info A hash of data used for transforming
     *     templates. The $SOURCE (and other) objects can be found here.
     * @param {String} [nodeContent] The node content where constructs requiring
     *     this data can be found. If this is not supplied, the receiver's
     *     (inner) content is used.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var str,

        sourceElem,
        sourceIDVal;

    str = TP.ifInvalid(nodeContent, this.getContent());

    //  If we match a 'SOURCE id' statement *and* the id of the $SOURCE node has
    //  an ACP expression, then we need to rewrite it so that the $SOURCE node
    //  has a real id value (a generated one).
    if (TP.regex.ACP_SOURCE_ID_STATEMENT.test(str)) {

        sourceElem = info.at('$SOURCE').getNativeNode();
        sourceIDVal = TP.elementGetAttribute(sourceElem, 'id', true);

        if (TP.regex.HAS_ACP.test(sourceIDVal)) {
            TP.elementRemoveAttribute(sourceElem, 'id', true);
            TP.elementSetAttribute(
                    sourceElem, 'id', TP.elemGenID(sourceElem), true);
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('produceValue',
function(aspectName, aContentObject, aRequest) {

    /**
     * @method produceValue
     * @summary Produces the value that will be used by the setValue() method
     *     to set the content of the receiver.
     * @description This method works together with the 'isSingleValued()' and
     *     'isScalarValued()' methods to produce the proper value for the
     *     receiver. See the method description for isScalarValued() for more
     *     information.
     * @param {String} aspectName The aspect name on the receiver that the value
     *     is being produced for. Many times, this is 'value'.
     * @param {Object} aContentObject An object to use for content.
     * @param {TP.sig.Request} aRequest A request containing control parameters.
     */

    var value,
        formats;

    value = aContentObject;

    //  If the receiver has a 'ui:display' attribute, then format the return
    //  value according to the formats found there.
    if (TP.notEmpty(formats = this.getAttribute('ui:display'))) {
        value = this.$formatValue(value, formats);
        value = this.callNextMethod(aspectName, value, aRequest);
    } else {
        value = this.callNextMethod();
    }

    return value;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('removeClass',
function(className) {

    /**
     * @method removeClass
     * @summary Removes the named class from the receiving element.
     * @param {String} className The class to remove, if found.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var natNode,
        oldValue,
        newValue;

    natNode = this.getNativeNode();

    oldValue = TP.elementGetClass(natNode);
    TP.elementRemoveClass(natNode, className);
    newValue = TP.elementGetClass(natNode);

    if (oldValue === newValue) {
        return this;
    }

    if (this.shouldFlagChanges()) {
        TP.elementFlagChange(natNode, TP.ATTR + 'class', TP.DELETE);
    }

    this.changed('@class',
                    TP.UPDATE,
                    TP.hc(TP.OLDVAL, oldValue,
                            TP.NEWVAL, newValue));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$removeAttribute',
function(attributeName, shouldSignal) {

    /**
     * @method removeAttribute
     * @summary Removes the named attribute. This version is a wrapper around
     *     the native element node removeAttribute call which attempts to handle
     *     standard change notification semantics for native nodes as well as
     *     proper namespace management.
     * @param {String} attributeName The attribute name to remove.
     * @param {Boolean} shouldSignal If false no signaling occurs. Defaults to
     *     this.shouldSignalChange().
     */

    var attr,
        node,

        flag;

    node = this.getNativeNode();

    //  work from the attribute node so we can be more accurate. this helps
    //  ensure that environments which don't preserve the concept of a
    //  namespace URI consistently (html) won't end up with two attributes
    //  of the same name but different namespace URIs

    if (TP.regex.HAS_COLON.test(attributeName)) {
        //  Note here the usage of our own call which will attempt to divine
        //  the namespace URI if the checkAttrNSURIs flag is true.
        attr = TP.$elementGetPrefixedAttributeNode(node,
                                                    attributeName,
                                                    true);
    } else {
        attr = node.getAttributeNode(attributeName);
    }

    //  no node? nothing to remove then
    if (TP.notValid(attr)) {
        return;
    }

    //  NB: Use this construct this way for better performance
    if (TP.notValid(flag = shouldSignal)) {
        flag = this.shouldSignalChange();
    }

    //  NB: We don't flag changes for internal 'tibet:' attributes
    //  (presuming change flagging is on)
    if (this.shouldFlagChanges() &&
        !TP.regex.TIBET_SCHEME.test(attributeName)) {
        TP.elementFlagChange(node, TP.ATTR + attributeName, TP.DELETE);
    }

    //  rip out the attribute itself
    TP.elementRemoveAttribute(node, attributeName, true);

    if (flag) {
        this.$changed('@' + attributeName, TP.DELETE);
    }

    //  removeAttribute returns void according to the spec
    return;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('removeAttribute',
function(attributeName) {

    /**
     * @method removeAttribute
     * @summary Removes the named attribute. This version is a wrapper around
     *     the native element node removeAttribute call which attempts to handle
     *     standard change notification semantics for native nodes as well as
     *     proper namespace management.
     * @param {String} attributeName The attribute name to remove.
     */

    var methodName;

    //  try attribute manipulation naming convention first
    methodName = this.computeAttrMethodName('removeAttr', attributeName);
    if (TP.canInvoke(this, methodName)) {
        return this[methodName]();
    }

    return this.$removeAttribute(attributeName);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('render',
function() {

    /**
     * @method render
     * @summary Renders the receiver. At this type level, this method does
     *     nothing.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    //  Signal to observers that this control has rendered.
    this.signal('TP.sig.DidRender');

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('replaceClass',
function(oldClass, newClass) {

    /**
     * @method replaceClass
     * @summary A convenience wrapper for TP.elementReplaceClass.
     * @param {String} oldClass The class value to find.
     * @param {String} newClass The class value to set.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var natNode,
        oldValue,
        newValue;

    natNode = this.getNativeNode();

    oldValue = TP.elementGetClass(natNode);
    TP.elementReplaceClass(natNode, oldClass, newClass);
    newValue = TP.elementGetClass(natNode);

    if (oldValue === newValue) {
        return this;
    }

    if (this.shouldFlagChanges()) {
        TP.elementFlagChange(natNode, TP.ATTR + 'class', TP.UPDATE);
    }

    this.changed('@class',
                    TP.UPDATE,
                    TP.hc(TP.OLDVAL, oldValue,
                            TP.NEWVAL, newValue));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('resume',
function(aSignal) {

    /**
     * @method resume
     * @summary Causes notifications of the signal provided to resume. Undoes
     *     the effect of having called suspend(). The origin being resumed is
     *     the receiver.
     * @param {TP.sig.Signal} aSignal The signal to resume.
     * @returns {Object} The registration.
     */

    //  re-enabling all notification
    if (TP.notValid(aSignal)) {
        delete this.getNativeNode()[TP.SHOULD_SUSPEND_SIGNALING];
    }

    return TP.resume(this, aSignal);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('resumeSettingOf',
function(attributeName) {

    /**
     * @method resumeSettingOf
     * @summary Removes a previous suspension of setting of the supplied
     *     attribute name by the suspendSettingOf method.
     * @param {String} attributeName The attribute name to resume.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var suspendedAttrs;

    suspendedAttrs = this.get('$suspendedAttributes');
    if (TP.notValid(suspendedAttrs)) {
        return this;
    }

    suspendedAttrs.remove(attributeName);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('serializeCloseTag',
function(storageInfo) {

    /**
     * @method serializeCloseTag
     * @summary Serializes the closing tag for the receiver.
     * @description At this type level, this method, in conjunction with the
     *     'serializeOpenTag' method, will always produce the 'XML version' of
     *     an empty tag (i.e. '<foo/>' rather than '<foo></foo>').
     * @param {TP.core.Hash} storageInfo A hash containing various flags for and
     *     results of the serialization process. Notable keys include:
     *          'wantsXMLDeclaration': Whether or not the receiver's document
     *          node should include an 'XML declaration' at the start of its
     *          serialization. The default is false.
     *          'wantsPrefixedXMLNSAttrs': Whether or not the receiver and its
     *          decendant elements should generate prefixed (i.e. 'xmlns:foo')
     *          attributes to support their proper serialization. The default is
     *          true.
     *          'result': The current serialization result as it's being built
     *          up.
     *          'store': The key under which the current serialization result
     *          will be stored.
     *          'stores': A hash of 1...n serialization results that were
     *          generated during the serialization process. Note that nested
     *          nodes might generated results that will go into different
     *          stores, and so they will all be stored here, each keyed by a
     *          unique key (which, by convention, will be the URI they should be
     *          saved to).
     * @returns {String} A serialization of the closing tag of the receiver.
     */

    var result,
        elem,

        nextSib,

        hadNewlineTN;

    result = TP.ac();

    elem = this.getNativeNode();

    //  If the tag serializes as empty, then the serializeOpenTag() method will
    //  have written 'empty XML syntax', so we don't need to do anything here.
    if (!this.isSerializationEmpty()) {
        result.push('</', elem.tagName.toLowerCase(), '>');
    }

    //  Otherwise, let's test the next sibling to see if it's an Element or
    //  already contains a newline.
    nextSib = elem.nextSibling;
    if (TP.isElement(nextSib)) {
        //  It's an Element it won't contain a newline - add one.
        result.push('\n');
    } else {

        //  Iterate until we run out of sibling or run into an Element and, if
        //  the sibling is a Text node, test to see if it's already providing a
        //  newline.
        hadNewlineTN = false;
        while (TP.isValid(nextSib) && !TP.isElement(nextSib)) {
            if (TP.isTextNode(nextSib) &&
                TP.regex.ONLY_NEWLINE_WHITESPACE.test(nextSib.nodeValue)) {
                hadNewlineTN = true;
                break;
            }

            nextSib = nextSib.nextSibling;
        }

        //  No newline was found - add one.
        if (!hadNewlineTN) {
            result.push('\n');
        }
    }

    return result.join('');
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('serializeOpenTag',
function(storageInfo) {

    /**
     * @method serializeOpenTag
     * @summary Serializes the opening tag for the receiver.
     * @description At this type level, this method performs a variety of
     *     transformations and filtering of various attributes. See the code
     *     below for more details. One notable transformation is that this
     *     method, in conjunction with the 'serializeCloseTag' method,  will
     *     always produce the 'XML version' of an empty tag (i.e. '<foo/>'
     *     rather than '<foo></foo>').
     * @param {TP.core.Hash} storageInfo A hash containing various flags for and
     *     results of the serialization process. Notable keys include:
     *          'wantsXMLDeclaration': Whether or not the receiver's document
     *          node should include an 'XML declaration' at the start of its
     *          serialization. The default is false.
     *          'wantsPrefixedXMLNSAttrs': Whether or not the receiver and its
     *          decendant elements should generate prefixed (i.e. 'xmlns:foo')
     *          attributes to support their proper serialization. The default is
     *          true.
     *          'result': The current serialization result as it's being built
     *          up.
     *          'store': The key under which the current serialization result
     *          will be stored.
     *          'stores': A hash of 1...n serialization results that were
     *          generated during the serialization process. Note that nested
     *          nodes might generated results that will go into different
     *          stores, and so they will all be stored here, each keyed by a
     *          unique key (which, by convention, will be the URI they should be
     *          saved to).
     * @returns {String} A serialization of the opening tag of the receiver.
     */

    var result,

        elem,

        elemTagName,

        realElemPrefix,
        realElemLocalName,
        realElemName,

        computedElemName,
        computedElemNameParts,
        computedElemPrefix,
        computedElemLocalName,

        elemAttrs,

        i,

        attrName,
        attrPrefix,
        attrValue,

        currentNSURI,
        currentNSPrefixes,

        wantsPrefixedXMLNSAttrs,

        mimeType,

        storageLoc,

        desugaredAttrExprs,
        entryStr,
        bindEntries,

        childTextNodes;

    result = TP.ac();

    elem = this.getNativeNode();

    //  Grab the element's tag name and convert it to lowercase. It
    //  it's empty, bail out.
    if (TP.isEmpty(elemTagName = elem.tagName.toLowerCase())) {
        return '';
    }

    //  If the tag is a 'meta' tag with a 'generator', then its
    //  unnecessary for our produced markup so we exit here.
    if (elemTagName === 'meta') {
        if (elem.name.toLowerCase() === 'generator') {
            return '';
        }
    }

    realElemPrefix = this.getTagPrefix();
    realElemLocalName = this.getTagName();
    if (realElemLocalName.contains(':')) {
        realElemName = realElemLocalName;
    } else {
        if (TP.notEmpty(realElemPrefix)) {
            realElemName = realElemPrefix + ':' + realElemLocalName;
        } else {
            realElemName = realElemLocalName;
        }
    }

    computedElemName = this.getFullName();
    computedElemNameParts = computedElemName.split(':');
    computedElemPrefix = computedElemNameParts.first();
    computedElemLocalName = computedElemNameParts.last();

    currentNSPrefixes = TP.ac();

    //  By default, we emit *prefixed* 'xmlns:' attributes.
    wantsPrefixedXMLNSAttrs = storageInfo.atIfInvalid(
                                    'wantsPrefixedXMLNSAttrs', true);

    //  Start the tag
    result.push('<', elemTagName);

    //  Grab the element's attributes
    elemAttrs = elem.attributes;

    //  Loop over them and compute the name and value for them.
    for (i = 0; i < elemAttrs.length; i++) {

        attrName = elemAttrs[i].localName;
        attrPrefix = elemAttrs[i].prefix;
        attrValue = elemAttrs[i].value;

        //  If the attribute has a colon (':') in it, check to see if a
        //  namespace can be found that would match the part of the attribute
        //  name before the colon.
        if (TP.notEmpty(attrPrefix)) {

            switch (attrPrefix) {

                case 'acl':
                case 'xml':
                case 'pclass':
                    continue;

                case 'tibet':

                    //  It's a 'tibet:tag' attribute. See if it matches the
                    //  computed element name. If so, then skip it.
                    if (attrName === 'tag' &&
                        attrValue === realElemName) {
                        continue;
                    }

                    //  It's a 'tibet:' attribute that we never serialize.
                    if (TP.NEVER_SERIALIZED_TIBET_ATTRS.contains(
                                        attrPrefix + ':' + attrName)) {
                        continue;
                    }

                    break;

                case 'xmlns':   //  NB: We allow default namespaces below.

                    //  If the prefix has a matching URI, then it's a 'built in'
                    //  (or has been registered), so we skip it. Otherwise, it
                    //  needs to be printed.
                    if (TP.notEmpty(TP.w3.Xmlns.getNSURIForPrefix(attrName))) {
                        continue;
                    }

                /* eslint-disable no-fallthrough */
                default:

                    //  If this prefix is not in the 'current prefixes list'
                    //  (tracked element-by-element and emptied after each
                    //  element is processed) then try to grab the URI and build
                    //  an 'xmlns' attribute.
                    if (!currentNSPrefixes.contains(attrPrefix)) {

                        if (wantsPrefixedXMLNSAttrs) {

                            currentNSURI = TP.w3.Xmlns.getNSURIForPrefix(
                                                                attrPrefix);

                            if (TP.notEmpty(currentNSURI)) {
                                result.push(' ', 'xmlns:', attrPrefix,
                                        '="', currentNSURI, '"');
                            } else {
                                result.push(' ', 'xmlns:', attrPrefix,
                                        '="urn:tibet:unrecognizednamespace"');
                            }
                        }

                        //  Remember that we processed this prefix for this
                        //  element so that we don't end up with multiple
                        //  'xmlns:' attributes with the same prefix on the same
                        //  element.
                        currentNSPrefixes.push(attrPrefix);
                    }
                /* eslint-enable no-fallthrough */
            }
        }

        switch (attrName) {
            case 'pseudo-inline':

                //  Don't emit this attribute.
                continue;

            case 'class':

                attrValue = attrValue.strip(/lama(\-\w+)+\s{0,}/g).trim();
                attrValue = attrValue.strip(/\s{0,}lama(\-\w+)+/g).trim();

                if (TP.isEmpty(attrValue)) {
                    continue;
                }

                break;

            case 'xmlns':

                //  A default namespace. Try to obtain the document's MIME type
                //  and derive a namespace from it. If it's the same as the
                //  value of this attribute, then ignore it (per TIBET's 'auto
                //  namespacing' capability).
                mimeType = this.getDocumentMIMEType();

                if (TP.notEmpty(mimeType)) {
                    currentNSURI = TP.w3.Xmlns.fromMIMEType(mimeType).at('uri');
                    if (TP.notEmpty(currentNSURI) &&
                        currentNSURI === attrValue) {
                        continue;
                    }
                }

                break;

            case 'id':

                if (attrValue.startsWith(
                        computedElemPrefix + '_' +
                        computedElemLocalName + '_')) {
                    continue;
                }

                if (attrValue.startsWith(
                        realElemPrefix + '_' +
                        realElemLocalName + '_')) {
                    continue;
                }

                break;

            case 'href':

                if (elem.tagName !== 'link' && elem.tagName !== 'a') {
                    break;
                }

                storageLoc = storageInfo.at('store');

                if (TP.isURIString(storageLoc)) {
                    attrValue = TP.uriRelativeToPath(
                                    attrValue,
                                    storageLoc,
                                    true);
                }

                break;

            case 'src':

                if (elem.tagName !== 'script') {
                    break;
                }

                storageLoc = storageInfo.at('store');

                if (TP.isURIString(storageLoc)) {
                    attrValue = TP.uriRelativeToPath(
                                    attrValue,
                                    storageLoc,
                                    true);
                }

                break;

            case 'style':

                //  The best way to get the attribute value of the 'style'
                //  attribute is to grab its 'cssText' property (we also
                //  lowercase it here to conform to TIBET coding standards).
                attrValue = TP.elementGetStyleObj(elem).cssText.toLowerCase();
                break;

            case 'in':

                if (attrPrefix === 'bind') {

                    //  If the element has desugared ACP attribute expressions,
                    //  then process them back into their original form.
                    desugaredAttrExprs = TP.elementGetAttribute(
                            elem, 'tibet:desugared', true);

                    if (TP.notEmpty(desugaredAttrExprs)) {

                        //  Get all of the attribute names that were desugared.
                        desugaredAttrExprs = desugaredAttrExprs.split(' ');

                        //  Reconstitute the attribute value (which contains all
                        //  of the binding entries) into JSON.
                        entryStr = TP.reformatJSToJSON(attrValue, false);
                        bindEntries = TP.json2js(entryStr);

                        //  Iterate over each attribute name/value pair.
                        /* eslint-disable no-loop-func */
                        bindEntries.perform(
                            function(aKVPair) {
                                var bindAttrName;

                                bindAttrName = aKVPair.first();

                                //  If this binding expression references a
                                //  desugared attribute, then emit the attribute
                                //  in its original form.
                                if (desugaredAttrExprs.contains(bindAttrName)) {
                                    result.push(' ', bindAttrName, '="',
                                                aKVPair.last().unquoted(), '"');
                                }
                            });
                        /* eslint-enable no-loop-func */

                        continue;
                    }
                }

                break;

            default:

                //  No special handling... just go ahead and use the value from
                //  the attribute node.
                break;
        }

        //  If no attribute value was supplied, then we merely set it to be the
        //  empty string.
        if (TP.isEmpty(attrValue)) {
            if (TP.isEmpty(attrPrefix)) {
                result.push(' ', attrName, '=""');
            } else {
                result.push(' ', attrPrefix, ':', attrName, '=""');
            }
        } else {
            //  Otherwise, we set it to its value after replacing literal
            //  constructs with entities.
            if (TP.isEmpty(attrPrefix)) {
                result.push(' ', attrName, '="',
                            TP.xmlLiteralsToEntities(attrValue).replace(
                                                            /&apos;/g, '\''),
                            '"');
            } else {
                result.push(' ', attrPrefix, ':', attrName, '="',
                            TP.xmlLiteralsToEntities(attrValue).replace(
                                                            /&apos;/g, '\''),
                            '"');
            }
        }
    }

    //  End the tag.

    //  If the tag serializes as empty, then we use 'XML empty' syntax along
    //  with a newline.
    if (this.isSerializationEmpty()) {
        result.push('/>');
    } else {
        //  Otherwise, simply close the opening tag and then use a more
        //  sophisticated way to detect whether or not to append a newline. If
        //  there are no child text nodes (i.e. only child element nodes) or if
        //  the first or last child text nodes are whitespace *only*, then
        //  append a newline.
        result.push('>');
        childTextNodes = TP.nodeGetChildNodesByType(elem, Node.TEXT_NODE);
        /* eslint-disable no-extra-parens */
        if (TP.isEmpty(childTextNodes) ||
            (TP.notEmpty(childTextNodes) &&
                (TP.regex.ONLY_NON_NEWLINE_WHITESPACE.test(
                                childTextNodes.first().nodeValue) ||
                TP.regex.ONLY_NON_NEWLINE_WHITESPACE.test(
                                childTextNodes.last().nodeValue)))) {
            result.push('\n');
        }
        /* eslint-enable no-extra-parens */
    }

    //  Clear out any current namespace prefixes we are tracking.
    currentNSPrefixes.empty();

    return result.join('');
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('set',
function(attributeName, attributeValue, shouldSignal) {

    /**
     * @method set
     * @summary Sets the value of the named attribute or path target to the
     *     value provided.
     * @description Paths of various forms can be used to define what should be
     *     set via this call. These paths are typically found in XML source such
     *     as XForms or XControls in bind: attributes. NB: You *must* use a '/',
     *     '[', '(', or '@' in the XPath to allow XPaths to be recognized
     *     properly. If you want to set child nodes by using their tag name, you
     *     must use an expression such as './child' and not just 'child', as the
     *     latter will be used by this object to look up a 'child' slot on this
     *     object. When a non-path attribute name is provided and it resolves
     *     via aspect mapping to a path this process is also invoked. All other
     *     attributes are set on the TP.dom.Node itself just as with other
     *     TIBET instances.
     * @param {String} attributeName The attribute name to set.
     * @param {Object} attributeValue The value to set.
     * @param {Boolean} shouldSignal If false no signaling occurs. Defaults to
     *     this.shouldSignalChange().
     * @returns {Object} The result of setting the attribute on the receiver.
     *     This can vary in actual type.
     */

    var path,
        pathStr,

        funcName,

        args;

    if (TP.isEmpty(attributeName)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  If we got handed an 'access path', then we need to let it handle this.
    if (!TP.isString(attributeName) && attributeName.isAccessPath()) {
        path = attributeName;

        //  If the path's String representation is a simple JS_IDENTIFIER, then
        //  we need to check to see if this is just a TIBET path with a name to
        //  an 'aliased' access path (i.e. 'lastname' -> 'foo.bar.lastname').
        //  So, here we check to see if there is an access path for this simple
        //  identifier and, if there is, we use *that* path as the way to access
        //  the underlying data. If not, then we check to see (since we have a
        //  JS identifier as a simple path String) if there is a setter that
        //  matches the identifier.
        if (TP.regex.JS_IDENTIFIER.test(pathStr = path.get('srcPath'))) {
            if (TP.notValid(path = this.getAccessPathFor(
                                        pathStr, 'value', attributeName))) {
                //  try common naming convention first
                funcName = 'set' + TP.makeStartUpper(pathStr);
                if (TP.canInvoke(this, funcName)) {
                    switch (arguments.length) {
                        case 1:
                            return this[funcName]();
                        default:
                            args = TP.args(arguments, 1);
                            return this[funcName].apply(this, args);
                    }
                }

                //  There wasn't a valid access path aliased to that identifier,
                //  so just use the path we were originally going to use.
                path = attributeName;
            }
        }
    } else if (TP.regex.NON_SIMPLE_PATH.test(attributeName) &&
                !TP.regex.ATTRIBUTE.test(attributeName)) {
        path = TP.apc(attributeName, TP.hc('shouldCollapse', true));
    }

    if (TP.notValid(path)) {

        //  optimize for attribute access when prefix indicates (but not for
        //  '@*' paths where the caller wants all attributes).
        if (TP.regex.ATTRIBUTE.test(attributeName) &&
            !TP.regex.ATTRIBUTE_ALL.test(attributeName)) {
            return this.setAttribute(attributeName.slice(1), attributeValue);
        }

        //  try common naming convention first
        funcName = 'set' + TP.makeStartUpper(attributeName);
        if (TP.canInvoke(this, funcName)) {
            switch (arguments.length) {
                case 1:
                    return this[funcName]();
                default:
                    args = TP.args(arguments, 1);
                    return this[funcName].apply(this, args);
            }
        }
    }

    //  If we got a valid path above or if we have a 'value' facet that has an
    //  access path, then invoke the path.
    if (TP.isValid(path) ||
        TP.isValid(path = this.getAccessPathFor(attributeName, 'value'))) {

        //  Note here how, if we were given more than 3 arguments, we grab all
        //  of the arguments supplied, make our path source the first argument
        //  and invoke with an apply(). Otherwise, we make an Array that has our
        //  path source and our 'path parameters' as the last argument. In both
        //  cases, this is because executeGet() takes varargs (in case the path
        //  is parameterized).
        if (arguments.length > 3) {
            args = TP.args(arguments);
            args.atPut(0, this.getPathSource(path));
        } else {
            args = TP.ac(this.getPathSource(path), attributeValue, shouldSignal,
                            this.getPathParameters());
        }

        return path.executeSet.apply(path, args);
    }

    //  let the standard method handle it
    return this.setProperty(attributeName, attributeValue, shouldSignal);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('setClass',
function(className) {

    /**
     * @method setClass
     * @summary A convenience wrapper for TP.elementSetClass.
     * @param {String} className The class value to set.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var natNode,
        oldValue,
        newValue;

    natNode = this.getNativeNode();

    oldValue = TP.elementGetClass(natNode);
    TP.elementSetClass(natNode, className);
    newValue = TP.elementGetClass(natNode);

    if (oldValue === newValue) {
        return this;
    }

    if (this.shouldFlagChanges()) {
        TP.elementFlagChange(natNode, TP.ATTR + 'class', TP.UPDATE);
    }

    this.changed('@class',
                    TP.UPDATE,
                    TP.hc(TP.OLDVAL, oldValue,
                            TP.NEWVAL, newValue));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('setID',
function(anID) {

    /**
     * @method setID
     * @summary Sets the public ID of the receiver. Note that this corresponds
     *     to the 'local ID' of the receiver.
     * @description Note that this method will assign a generated ID if the
     *     supplied ID is empty.
     * @param {String} anID The value to use as a public ID.
     * @returns {String} The ID that was set.
     */

    var natNode,
        wasRegistered,

        id,
        docID,
        globalID;

    natNode = this.getNativeNode();

    //  If the receiver was registered under an 'id', unregister it and
    //  re-register with the new ID below.
    if (TP.notEmpty(id = TP.gid(natNode, false)) && id !== anID) {
        wasRegistered = TP.sys.hasRegistered(this, id);
        TP.sys.unregisterObject(this, id);
    }

    if (TP.isEmpty(id = anID)) {
        id = TP.elemGenID(natNode);
    }

    TP.elementSetAttribute(natNode, 'id', id, true);

    if (TP.notEmpty(docID = TP.gid(TP.nodeGetDocument(natNode), true))) {
        globalID = docID.replace(/#.+/, '#' + id);
        //  Note here how we put the slot directly on the element for speed and
        //  to avoid markup clutter.
        natNode[TP.GLOBAL_ID] = globalID;
    }

    if (wasRegistered) {
        //  Note here how we *refetch the global ID* since that's what we're
        //  replacing... not just the local ID that we just set.
        id = TP.gid(natNode, false);
        TP.sys.registerObject(this, id);
    }

    return id;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('setPhase',
function(aPhase) {

    /**
     * @method setPhase
     * @summary Sets the current processing phase for the content. This
     *     attribute is also placed on the content itself to mark it for
     *     inspection by other routines.
     * @param {String} aPhase A content-processing phase value.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    //  don't forget to do the real work ;)
    this.$set('phase', aPhase);

    //  update the native node. usually we won't be doing this at the node
    //  level, but on occasion we'll process here rather than at the
    //  document level

    //  Note here how we pass 'true' as the fourth parameter to use 'strict'
    //  namespace setting to force this call to truly place the attribute
    //  inside of the 'tibet:' namespace. Otherwise, the attribute will
    //  'lose' its namespace along the way of processing.
    TP.elementSetAttribute(this.getNativeNode(),
                            'tibet:phase',
                            aPhase,
                            true);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$setAttribute',
function(attributeName, attributeValue, shouldSignal) {

    /**
     * @method setAttribute
     * @summary Sets the value of the named attribute. This version is a
     *     wrapper around the native element node setAttribute call which
     *     attempts to handle standard change notification semantics for native
     *     nodes as well as proper namespace management.
     * @param {String} attributeName The attribute name to set.
     * @param {Object} attributeValue The value to set.
     * @param {Boolean} shouldSignal If false no signaling occurs. Defaults to
     *     this.shouldSignalChange().
     * @returns {undefined} Undefined according to the spec for DOM
     *     'setAttribute'.
     */

    var boolAttrs,

        node,

        hadAttribute,

        oldValue,

        attr,

        flag,

        nameParts,
        prefix,
        name,
        url;

    if (TP.notEmpty(boolAttrs = this.get('booleanAttrs')) &&
        boolAttrs.containsString(attributeName) &&
        TP.isFalsey(attributeValue)) {

        return this.removeAttribute(attributeName);
    }

    node = this.getNativeNode();

    hadAttribute = TP.elementHasAttribute(node, attributeName, true);

    //  work from the attribute node so we can be more accurate. this helps
    //  ensure that environments which don't preserve the concept of a
    //  namespace URI consistently (html) won't end up with two attributes
    //  of the same name but different namespace URIs

    if (TP.regex.HAS_COLON.test(attributeName)) {
        //  Note here the usage of our own call which will attempt to divine
        //  the namespace URI if the checkAttrNSURIs flag is true.
        attr = TP.$elementGetPrefixedAttributeNode(node,
                                                    attributeName,
                                                    true);
    } else {
        attr = node.getAttributeNode(attributeName);
    }

    //  NB: Use this construct this way for better performance
    if (TP.notValid(flag = shouldSignal)) {
        flag = this.shouldSignalChange();
    }

    if (TP.isAttributeNode(attr)) {
        //  Capture the current value
        oldValue = attr.value;

        if (attr.value === attributeValue) {
            return;
        } else {
            //  NB: We don't flag changes for internal 'tibet:' attributes
            //  (presuming change flagging is on)
            if (this.shouldFlagChanges() &&
                !TP.regex.TIBET_SCHEME.test(attributeName)) {
                TP.elementFlagChange(node, TP.ATTR + attributeName, TP.UPDATE);
            }

            attr.value = attributeValue;

            if (flag) {
                this.$changed('@' + attributeName,
                                hadAttribute ? TP.UPDATE : TP.CREATE,
                                TP.hc(TP.OLDVAL, oldValue,
                                        TP.NEWVAL, attributeValue));
            }

            return;
        }
    }

    //  if this is a prefixed attribute then we'll attempt to "do the right
    //  thing" by finding the registered namespace and placing the attribute
    //  in that namespace
    if (TP.regex.NS_QUALIFIED.test(attributeName)) {
        nameParts = attributeName.match(TP.regex.NS_QUALIFIED);
        prefix = nameParts.at(1);
        name = nameParts.at(2);

        if (attributeName.startsWith('xmlns')) {
            //  If the caller was trying to add an 'xmlns' attribute, then
            //  first check to make sure that they weren't trying to set the
            //  default namespace - can't do that :-(.
            if (attributeName === 'xmlns') {
                //  TODO: Throw an error - you cannot reset the default
                //  namespace :-(.
                return;
            }

            //  Otherwise, they're trying to add a prefixed namespace
            //  definition.
            TP.elementAddNSURI(node, prefix + ':' + name, attributeValue);

            //  NB: We don't 'flag changes' for setting an 'xmlns:*' attribute

            if (flag) {
                this.$changed('@' + attributeName, TP.CREATE);
            }

            return;
        }

        //  if we made it here we're not setting an xmlns attribute so the
        //  only other reason not to flag the element is if we're setting a
        //  tibet: internal attribute (presuming change flagging is on)
        if (this.shouldFlagChanges() &&
            !TP.regex.TIBET_SCHEME.test(attributeName)) {
            TP.elementFlagChange(node, TP.ATTR + attributeName, TP.CREATE);
        }

        //  seems like we're dealing with a prefixed attribute that isn't an
        //  xmlns attribute, so the question is do we know a URI so we can
        //  map it properly?
        if (TP.notEmpty(url = TP.w3.Xmlns.getNSURIForPrefix(prefix))) {
            TP.elementSetAttributeInNS(node,
                                        prefix + ':' + name,
                                        attributeValue,
                                        url);
        } else {
            //  no known prefix, just set it as an attribute whose name
            //  happens to include a colon
            TP.elementSetAttribute(node, attributeName, attributeValue);
        }
    } else {
        //  not a prefixed attribute so we just need to ensure that we've
        //  updated the element crud flags as needed and set the value
        if (this.shouldFlagChanges()) {
            TP.elementFlagChange(node, TP.ATTR + attributeName, TP.CREATE);
        }

        TP.elementSetAttribute(node, attributeName, attributeValue);
    }

    if (flag) {
        this.$changed('@' + attributeName,
                        TP.CREATE,
                        TP.hc('oldValue', oldValue,
                                'newValue', attributeValue));
    }

    //  setAttribute returns void according to the spec
    return;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('setAttribute',
function(attributeName, attributeValue) {

    /**
     * @method setAttribute
     * @summary Sets the value of the named attribute. This version is a
     *     wrapper around the native element node setAttribute call which
     *     attempts to handle standard change notification semantics for native
     *     nodes as well as proper namespace management.
     * @param {String} attributeName The attribute name to set.
     * @param {Object} attributeValue The value to set.
     * @returns {undefined} Undefined according to the spec for DOM
     *     'setAttribute'.
     */

    var suspendedAttrs,

        methodName;

    //  Make sure that we're not suspending changes to the supplied attribute.
    //  If we are, then just return.
    suspendedAttrs = this.$get('$suspendedAttributes');
    if (TP.isValid(suspendedAttrs) &&
        suspendedAttrs.indexOf(attributeName) !== TP.NOT_FOUND) {
        //  returns null according to the spec for DOM 'setAttribute'.
        return;
    }

    //  try attribute manipulation naming convention first
    methodName = this.computeAttrMethodName('setAttr', attributeName);
    if (TP.canInvoke(this, methodName)) {
        return this[methodName](attributeValue);
    }

    //  Otherwise, there was no specific setter, so just use $setAttribute()
    return this.$setAttribute(attributeName, attributeValue);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('setAttributes',
function(attributeHash) {

    /**
     * @method setAttributes
     * @summary Sets the value of the attributes provided using the supplied
     *     TP.core.Hash. For document nodes this operation effectively operates
     *     on the document's documentElement.
     * @param {TP.core.Hash} attributeHash The attributes to set.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    attributeHash.perform(
        function(kvPair) {
            this.setAttribute(kvPair.first(), kvPair.last());
        }.bind(this));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('setValue',
function(aValue, shouldSignal) {

    /**
     * @method setValue
     * @summary Sets the value of the receiver's node. For general node types
     *     this method sets the value/content of the node.
     * @description For common nodes the standard attribute list and the type of
     *     input determines what is actually manipulated. For element and
     *     document nodes the behavior is a little different. When the receiver
     *     has a pre-existing value attribute that's typically what is
     *     manipulated. When no value attribute is found the content of the node
     *     is changed. The type of node and input can alter how this actually is
     *     done. See the setContent call for more information.
     * @param {Object} aValue The value to set the 'value' of the node to.
     * @param {Boolean} shouldSignal Should changes be notified. If false
     *     changes are not signaled. Defaults to this.shouldSignalChange().
     * @returns {Boolean} Whether or not the value was changed from the value it
     *     had before this method was called.
     */

    var flag,

        newValue,
        newValueStr,

        didChange;

    //  If the value isn't valid, just return.
    if (TP.notValid(aValue)) {
        newValueStr = '';
    } else {
        newValue = this.produceValue('value', aValue);
        newValueStr = TP.str(newValue);
    }

    //  If the String value of newValue doesn't have Element markup in it, then
    //  we can just use 'setTextContent'. Otherwise, we have to use the full
    //  'setContent'.
    if (!TP.regex.CONTAINS_ELEM_MARKUP.test(newValueStr)) {
        didChange = this.setTextContent(newValueStr, shouldSignal);
    } else {
        this.setContent(newValue);
        didChange = true;
    }

    //  signal as needed

    //  NB: Use this construct this way for better performance
    if (TP.notValid(flag = shouldSignal)) {
        flag = this.shouldSignalChange();
    }

    if (flag) {
        this.$changed('value', TP.UPDATE);
    }

    return didChange;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('suspendSettingOf',
function(attributeName) {

    /**
     * @method suspendSettingOf
     * @summary Suspends the setting of the supplied attribute name. Setting can
     *     be resumed by using the resumeSettingOf method.
     * @param {String} attributeName The attribute name to suspend.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var suspendedAttrs;

    suspendedAttrs = this.get('$suspendedAttributes');
    if (TP.notValid(suspendedAttrs)) {
        suspendedAttrs = TP.ac();
        this.set('$suspendedAttributes', suspendedAttrs, false);
    }

    suspendedAttrs.push(attributeName);

    //  NB: This mutates the Array
    suspendedAttrs.unique();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('toggleClass',
function(className) {

    /**
     * @method toggleClass
     * @summary A convenience wrapper which will toggle a class, meaning that
     *     if the class is present it is removed, and if it's not present it
     *     will be added.
     * @param {String} className The class value to toggle.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var natNode,
        oldValue,
        newValue;

    natNode = this.getNativeNode();

    oldValue = TP.elementGetClass(natNode);
    if (TP.hasClass(natNode, className)) {
        TP.elementRemoveClass(natNode, className);
    } else {
        TP.elementAddClass(natNode, className);
    }
    newValue = TP.elementGetClass(natNode);

    if (oldValue === newValue) {
        return this;
    }

    if (this.shouldFlagChanges()) {
        TP.elementFlagChange(natNode, TP.ATTR + 'class', TP.UPDATE);
    }

    this.changed('@class',
                    TP.UPDATE,
                    TP.hc(TP.OLDVAL, oldValue,
                            TP.NEWVAL, newValue));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('transformAttributeNode',
function(attrNode, info) {

    /**
     * @method transformAttributeNode
     * @summary Transforms the content of the supplied attribute using the data
     *     found in the supplied info hash.
     * @param {Attribute} attrNode The attribute node to transform the content
     *     of.
     * @param {TP.core.Hash} info The dictionary of transformation source data
     *     to use to transform the attribute node content.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var str,
        result;

    //  Grab the text content of the Attribute node.
    str = TP.nodeGetTextContent(attrNode);

    if (TP.regex.HAS_ACP.test(str)) {
        //  Run a transform on it.
        result = str.transform(this, info);
        if (result !== str) {
            TP.nodeSetTextContent(attrNode, result);
        }
    }

    return this;
});

//  ------------------------------------------------------------------------
//  NODE CHANGE TRACKING
//  ------------------------------------------------------------------------

/**
 * @Methods in this section provide support for tracking state changes on the
 *     markup by flagging the elements involved with special attributes. These
 *     values are then observed in other parts of TP.dom.Node's processing
 *     machinery.
 */

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('shouldFlagChanges',
function(aFlag) {

    /**
     * @method shouldFlagChanges
     * @summary A combined setter/getter for the change flagging flag for the
     *     receiver.
     * @description When a TP.dom.ElementNode instance is flagging changes the
     *     alterations it makes to a DOM structure are flagged in the form of
     *     'tibet:crud' attributes. Note in particular that deletes don't
     *     actually occur when change flagging is on, items are simply flagged
     *     for delete.
     * @returns {Boolean} Whether or not to flag changes to the receiver.
     */

    var natElem;

    //  NB: Because of all of the machinery around signaling and tracking
    //  changes, it's best that this method is written to poke around at the
    //  native element node.

    //  Notice here how we use the 'fast' native node get method to avoid any
    //  sorts of recursion issues.
    natElem = this.getNativeNode();

    if (TP.isBoolean(aFlag)) {
        if (TP.notTrue(aFlag)) {
            TP.elementRemoveAttribute(natElem, 'tibet:flagchanges');
        } else {
            TP.elementSetAttribute(
                    natElem, 'tibet:flagchanges', true);
        }
    }

    return TP.elementGetAttribute(natElem, 'tibet:flagchanges') ===
                    'true';
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('suspend',
function(aSignal) {

    /**
     * @method suspend
     * @summary Causes notifications of aSignal to pause from the receiver.
     *     Calling resume() with the same signal type will turn them back on.
     * @param {TP.sig.Signal} aSignal The signal to suspend.
     * @returns {Object} The registration.
     */

    //  turning off all notifications
    if (TP.notValid(aSignal)) {
        this.getNativeNode()[TP.SHOULD_SUSPEND_SIGNALING] = true;
    }

    return TP.suspend(this, aSignal);
});

//  ------------------------------------------------------------------------
//  Event Methods
//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('dispatch',
function(aSignal, aTarget, argsOrEvent, aPolicy, isCancelable, isBubbling) {

    /**
     * @method dispatch
     * @summary Dispatches a signal to the target element via TP.DOM_FIRING.
     * @description This method is used rather than signal() when it's necessary
     *     to ensure compatibility the requirements of XForms event processing.
     *     When the target is a window this routine will target that window's
     *     document.
     * @param {String|TP.sig.Signal} aSignal The signal or signal name to
     *     signal, often null so it defaults to the event name.
     * @param {Object} aTarget The target element that the event might have
     *     originated from. Usually set to 'this' in an on* method to provide
     *     the originating context object.
     * @param {Object} argsOrEvent The native Event object or other signal args
     *     in a hash.
     * @param {Object} aPolicy A standard signal policy name or definition.
     *     Defaults to TP.INHERITANCE_FIRING unless the signal has a default
     *     firing policy.
     * @param {Boolean} isCancelable Optional boolean for whether the signal is
     *     cancelable.
     * @param {Boolean} isBubbling Optional flag for whether this signal should
     *     bubble.
     * @returns {TP.sig.Signal} The signal instance which was fired.
     */

    var targetElem,
        doc;

    //  first task is to acquire the target element so we'll be able to
    //  determine the event path IDs we'll signal across
    if (TP.notValid(aTarget)) {
        targetElem = this.getNativeNode();
    } else if (TP.isString(aTarget)) {
        doc = this.getNativeDocument();
        targetElem = TP.nodeGetElementById(doc, aTarget, true);

        //  fallback here is to use TP.byId which means we can use TIBET URI
        //  references (or standard URIs for that matter) so that dispatch
        //  is "cross-document" (think iframes :))
        if (!TP.isElement(targetElem)) {
            targetElem = TP.byId(aTarget);

            if (TP.canInvoke(targetElem, 'getNativeNode')) {
                targetElem = targetElem.getNativeElement();
            } else if (TP.canInvoke(targetElem, 'getNativeDocument')) {
                targetElem = targetElem.getNativeDocument();
            } else {
                return this.raise('TP.sig.InvalidTarget',
                                    'Specified target not found: ' +
                                        aTarget);
            }
        }
    } else if (TP.isElement(aTarget)) {
        targetElem = aTarget;
    } else if (TP.canInvoke(aTarget, 'getNativeNode')) {
        targetElem = aTarget.getNativeNode();
    } else if (TP.canInvoke(aTarget, 'getNativeDocument')) {
        targetElem = aTarget.getNativeDocument();
    } else {
        return this.raise('TP.sig.InvalidParameter',
                            'Specified target not a valid dispatch target');
    }

    //  do the actual dispatch work here using TIBET's standard
    //  TP.dispatch() call (this can handle keyboard events etc)
    return TP.dispatch(targetElem,
                        aSignal,
                        targetElem,
                        argsOrEvent,
                        aPolicy,
                        isCancelable,
                        isBubbling);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getEventIds',
function() {

    /**
     * @method getEventIds
     * @summary Returns an array of the event IDs (origin IDs) for the
     *     receiver, starting with the receiver and working out to the top-most
     *     parent element.
     * @description The returned Array is configured as an 'origin set' for use
     *     by the TIBET notification system.
     * @returns {String[]} An Array containing the event IDs of the receiver.
     */

    //  The TP.elementGetEventIds() call's return value has already been
    //  configured as an 'origin set'.
    return TP.elementGetEventIds(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('observe',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method observe
     * @summary Causes notifications to a particular handler to start. The
     *     origin and signal combination define how this occurs. Using null for
     *     either value means "any" and sets up a generic observation. The
     *     policy is a "registration" policy that defines how the observation
     *     will be configured. If no handler is provided the receiver is assumed
     *     and registered.
     * @param {Object} anOrigin The originator to be observed.
     * @param {TP.sig.Signal} aSignal The signal to observe.
     * @param {Object} aHandler The handler to notify.
     * @param {Function} aPolicy A "registration" policy that will define how
     *     the handler is registered.
     * @returns {Object} The registration object.
     */

    //  make sure we have an ID that will let the notification system find
    //  this element again
    if (TP.isEmpty(this.getAttribute('id'))) {
        //  Assign an ID
        TP.lid(this, true);
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------
//  Formatting/Validation Methods
//  ------------------------------------------------------------------------

/**
 *     The methods here provide support for display and storage formatting of
 *     field data as well as general-purpose data validation.
 *
 *     TIBET formatters work in chains, successively processing the value. This
 *     allows you to reuse formatters more effectively. The ui:display and
 *     ui:storage namespaced attributes accept whitespace-separated format
 *     expression values which will be used to format the output of the previous
 *     formatter in the list.
 *
 *     The type validation process here is general purpose in the sense that
 *     since both model and UI elements ultimately have TP.dom.Node wrappers
 *     they can both benefit from type checks. There are two mechanisms for
 *     validation: XMLSchema and TIBET-specific types. Both offer advantages and
 *     disadvantages but the nice thing is you can mix them in the same
 *     environment if you need to.
 *
 *     When using XML Schema simply put xsi:type attributes on the elements you
 *     wish to constrain, or use the ui:type attribute to access TIBET types.
 *     The ui:type attribute takes a list of types separated by either a
 *     space or vertical bar (|). When separated by spaces all types must agree
 *     the value is valid, when separated by a vertical bar only one of the
 *     types must agree.
 */

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$formatValue',
function(aValue, formats) {

    /**
     * @method $formatValue
     * @summary Formats a value using the formatter list in the attribute
     *     provided.
     * @description The value provided is formatted based on the rules of the
     *     formatter value(s) found in the attribute provided. Note that even
     *     null values are formatted based on this rule such that you can cause
     *     a null to appear as '' or null or any other value your formatter
     *     cares to output. For that reason you can't "default" the value
     *     provided to this method since even a null value is considered a valid
     *     value to format. If the format type cannot produce a proper
     *     instance/output for the from() method for a null then the result of
     *     TP.str(null) is returned.
     *
     *     NOTE that when an error is encountered during any phase of the
     *     formatting process the value is returned without any alteration so
     *     partially formatted results are not returned. This is also true when
     *     a value "degrades" from a non-null to a null value. In that case the
     *     original value is returned.
     * @param {Object} aValue The value to format.
     * @param {String} formats A string of format expressions separated by a
     *     '|.'
     * @returns {String} The formatted value.
     */

    var value,
        params,

        result,

        i,
        len,

        elemFmts,
        format;

    //  nothing to do?
    if (TP.isEmpty(formats)) {
        return aValue;
    }

    value = aValue;

    params = TP.hc('target', this);

    //  If the formats represent a list we've got to do more work, but if not,
    //  we want to move fast on the most common case.
    try {
        if (!TP.regex.ACP_FORMAT_SEPARATOR.test(formats)) {

            //  one format
            format = formats;

            if (/^\s*\*/.test(format)) {
                format = format.slice(format.indexOf('*') + 1).trim();
                params.atPut('repeat', true);
            } else {
                params.atPut('repeat', false);
            }

            result = TP.format(value, format, params);
            value = TP.notValid(result) ? value : result;

            return value;
        }
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'Formatting error.')) : 0;

        value = aValue;
    }

    //  Formatters can sometimes consist of chain separated (for compatibility
    //  with TSH) with '.|'. We split these and process each one individually in
    //  the chain.

    elemFmts = formats.split(TP.regex.ACP_FORMAT_SEPARATOR);
    len = elemFmts.getSize();

    try {
        //  one value, multiple formats -- second most common case,
        //  basically a format chain
        for (i = 0; i < len; i++) {

            format = elemFmts.at(i);

            //  If it was a chain, we will have a leading '$_' followed by a
            //  '.|' (or '.|*') in which case the first item will be '$_'.  We
            //  will throw this away, since it's there to represent 'standard
            //  in' for compatibility with shell formatting expressions.
            if (format === '$_') {
                continue;
            }

            if (/^\s*\*/.test(format)) {
                format = format.slice(format.indexOf('*') + 1).trim();
                params.atPut('repeat', true);
            } else {
                params.atPut('repeat', false);
            }

            value = TP.format(value, format, params);
        }

        value = TP.notValid(value) ? aValue : value;

        return value;
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'Formatting error.')) : 0;

        value = aValue;
    }

    return value;
});

//  ========================================================================
//  TP.dom.HTMLElementNode
//  ========================================================================


/**
 * @summary A placeholder used only when an HTML DOM element doesn't locate a
 *     viable wrapper type.
 */
TP.dom.ElementNode.defineSubtype('HTMLElementNode');

//  actual HTML Element instances returned are specialized on a number of
//  factors
TP.dom.HTMLElementNode.isAbstract(true);

//  ------------------------------------------------------------------------

TP.dom.HTMLElementNode.Inst.defineMethod('getContentPrimitive',
function(operation) {

    /**
     * @method getContentPrimitive
     * @summary Returns the primitive function used to perform the operation
     *     specified. For example, an operation of TP.APPEND might return the
     *     TP.nodeAddContent primitive or a related function specific to the
     *     type of node being modified.
     * @param {String} operation A constant defining the operation. Valid values
     *     include: TP.APPEND TP.INSERT TP.UPDATE.
     * @exception TP.sig.InvalidOperation When the operation isn't a valid one.
     * @returns {Function} A TP primitive function.
     */

    switch (operation) {
        case TP.APPEND:
            return TP.htmlElementAddContent;
        case TP.INSERT:
            return TP.htmlElementInsertContent;
        case TP.REPLACE:
            return TP.htmlElementReplaceWith;
        case TP.UPDATE:
            return TP.htmlElementSetContent;
        default:
            return this.raise('TP.sig.InvalidOperation');
    }
});

//  ========================================================================
//  TP.dom.XMLElementNode
//  ========================================================================


/**
 * @summary A placeholder used only when an XML DOM element doesn't locate a
 *     viable wrapper type.
 */
TP.dom.ElementNode.defineSubtype('XMLElementNode');

//  ------------------------------------------------------------------------

TP.dom.XMLElementNode.Inst.defineMethod('getContentPrimitive',
function(operation) {

    /**
     * @method getContentPrimitive
     * @summary Returns the primitive function used to perform the operation
     *     specified. For example, an operation of TP.APPEND might return the
     *     TP.nodeAddContent primitive or a related function specific to the
     *     type of node being modified.
     * @param {String} operation A constant defining the operation. Valid values
     *     include: TP.APPEND TP.INSERT TP.UPDATE.
     * @exception TP.sig.InvalidOperation When the operation isn't a valid one.
     * @returns {Function} A TP primitive function.
     */

    switch (operation) {
        case TP.APPEND:
            return TP.xmlElementAddContent;
        case TP.INSERT:
            return TP.xmlElementInsertContent;
        case TP.REPLACE:
            return TP.xmlElementReplaceWith;
        case TP.UPDATE:
            return TP.xmlElementSetContent;
        default:
            return this.raise('TP.sig.InvalidOperation');
    }
});

//  ========================================================================
//  TP.dom.AttributeNode
//  ========================================================================

TP.dom.Node.defineSubtype('AttributeNode');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.dom.AttributeNode.Type.defineMethod('getConcreteType',
function(aNode) {

    /**
     * @method getConcreteType
     * @summary Returns a viable attribue node type for aNode.
     * @description If a specific type isn't found the return value is
     *     TP.dom.AttributeNode itself. The lookup process calculates a type
     *     name by acquiring the attribute's 'full name' (it's prefix + local
     *     name), and looking up a type based on that.
     * @returns {TP.meta.dom.AttributeNode} A TP.dom.AttributeNode subtype type
     *     object.
     */

    var name,
        type;

    name = TP.attributeGetFullName(aNode);

    type = TP.sys.getTypeByName(name);

    //  Make sure that we got a subtype of TP.dom.AttributeNode. Sometimes the
    //  value of an attribute will have the same value as a custom tag name and
    //  we don't want that in this case.
    if (TP.isType(type) &&
        TP.isSubtypeOf(type, TP.dom.AttributeNode) &&
        !type.isAbstract()) {
        return type;
    }

    return TP.dom.AttributeNode;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dom.AttributeNode.Inst.defineMethod('getLocalName',
function() {

    /**
     * @method getLocalName
     * @summary Returns the local (unprefixed) name of the receiver.
     * @returns {String} The local name of the receiver.
     */

    return TP.attributeGetLocalName(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.AttributeNode.Inst.defineMethod('getOwnerElement',
function() {

    /**
     * @method getOwnerElement
     * @summary Returns the receiver's owner element as a TP.dom.ElementNode.
     * @returns {TP.dom.ElementNode} The owner element of the receiver.
     */

    return TP.wrap(TP.attributeGetOwnerElement(this.getNativeNode()));
});

//  ------------------------------------------------------------------------

TP.dom.AttributeNode.Inst.defineMethod('getTextContent',
function() {

    /**
     * @method getTextContent
     * @summary Returns the normalized text content of the receiver.
     * @returns {String} The receiver's text value.
     */

    var node;

    node = this.getNativeNode();

    return node.value;
});

//  ------------------------------------------------------------------------

TP.dom.AttributeNode.Inst.defineMethod('setValue',
function(aValue, shouldSignal) {

    /**
     * @method setValue
     * @summary Sets the value of the receiver's node. For attribute nodes,
     *     this calls 'setAttribute' with the attribute name on the owner
     *     element.
     * @param {Object} aValue The value to set the 'value' of the node to.
     * @param {Boolean} shouldSignal Should changes be notified. If false
     *     changes are not signaled. Defaults to this.shouldSignalChange().
     * @returns {Boolean} Whether or not the value was changed from the value it
     *     had before this method was called.
     */

    var newValue;

    newValue = this.produceValue('value', aValue);

    this.getOwnerElement().setAttribute(this.getNativeNode().nodeName,
                                        newValue);

    //  TODO: Optimize the return value here by comparing the old and new data
    //  values.
    return true;
});

//  ========================================================================
//  TP.dom.TextNode
//  ========================================================================

TP.dom.Node.defineSubtype('TextNode');

//  ------------------------------------------------------------------------
//  Tag Phase Support
//  ------------------------------------------------------------------------

TP.dom.TextNode.Type.defineMethod('tagAttachBinds',
function(aRequest) {

    /**
     * @method tagAttachBinds
     * @summary Awakens any binding expressions for the text node in
     *     aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var node,

        str,
        index,

        exprNode,

        newSpan;

    //  Make sure that we have a node to work from.
    if (!TP.isNode(node = aRequest.at('node'))) {
        //  TODO: Raise an exception
        return;
    }

    //  Grab the original text node's text content and compute the index to the
    //  starting '[['
    str = TP.nodeGetTextContent(node);
    index = str.indexOf('[[');

    //  Use the DOM to split the text node at that boundary. This creates a text
    //  node with the content *after* the index and appends it as 'node's
    //  nextSibling into the DOM.
    exprNode = node.splitText(index);

    //  Grab that text node's content and compute the index to the ']]' (plus 2
    //  - we want to leave the expression end delimiter in exprNode)
    str = TP.nodeGetTextContent(exprNode);
    index = str.indexOf(']]') + 2;

    //  We don't care about what's on the right hand side, so we don't grab the
    //  return value here. This creates another text node to the right with
    //  whatever text was there and appends it as 'exprNode's nextSibling into
    //  the DOM.
    exprNode.splitText(index);

    //  Get the text of exprNode, which will now be the '[[...]]' expression.
    str = TP.nodeGetTextContent(exprNode);

    //  Trim off the surrounding whitespace
    str = TP.trim(str);

    //  If the expression doesn't contain a '%', then it doesn't need quoting,
    //  but does need the leading and trailing '[[' and ']]' to be trimmed.
    if (!TP.regex.HAS_PERCENT.test(str)) {
        str = str.slice(2, -2);
    } else {
        str = str.quoted('\'');
    }

    //  Create a new span and set a 'bind:in' attribute on it, binding it's
    //  'content' property using the expression given (minus the leading and
    //  trailing brackets).
    newSpan = TP.documentConstructElement(TP.doc(node),
                                            'span',
                                            TP.w3.Xmlns.XHTML);

    TP.elementSetAttribute(newSpan,
                            'bind:in',
                            '{content: ' + str + '}',
                            true);

    //  Replace that text node with the span, leaving the text nodes to the left
    //  (the original) to the right (created by the 2nd 'splitText' above).
    newSpan = TP.nodeReplaceChild(node.parentNode,
                                    newSpan,
                                    exprNode,
                                    false);

    return newSpan;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dom.TextNode.Inst.defineMethod('getTextContent',
function() {

    /**
     * @method getTextContent
     * @summary Returns the normalized text content of the receiver.
     * @returns {String} The normalized text content of the receiver.
     */

    var node;

    node = this.getNativeNode();

    return node.nodeValue;
});

//  ------------------------------------------------------------------------

TP.dom.TextNode.Inst.defineMethod('getPageRect',
function(wantsTransformed) {

    /**
     * @method getPageRect
     * @summary Returns the receiver's page position and size as a
     *     TP.gui.Rect. The page position is the text node's position relative
     *     to its overall page.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. For this type, this parameter
     *     is ignored. According to the CSS specification, for Text nodes, this
     *     will always return transformed values.
     * @returns {TP.gui.Rect} The receiver's page position and size.
     */

    var range,

        domRects;

    range = this.getNativeDocument().createRange();

    range.selectNode(this.getNativeNode());

    domRects = range.getClientRects();

    if (TP.notEmpty(domRects)) {
        return TP.rtc(domRects[0]);
    }

    return TP.rtc();
});

//  ------------------------------------------------------------------------

TP.dom.TextNode.Inst.defineMethod('serializeNonTag',
function(storageInfo) {

    /**
     * @method serializeNonTag
     * @summary Serializes the non tag node receiver.
     * @param {TP.core.Hash} storageInfo A hash containing various flags for and
     *     results of the serialization process. Notable keys include:
     *          'wantsXMLDeclaration': Whether or not the receiver's document
     *          node should include an 'XML declaration' at the start of its
     *          serialization. The default is false.
     *          'wantsPrefixedXMLNSAttrs': Whether or not the receiver and its
     *          decendant elements should generate prefixed (i.e. 'xmlns:foo')
     *          attributes to support their proper serialization. The default is
     *          true.
     *          'result': The current serialization result as it's being built
     *          up.
     *          'store': The key under which the current serialization result
     *          will be stored.
     *          'stores': A hash of 1...n serialization results that were
     *          generated during the serialization process. Note that nested
     *          nodes might generated results that will go into different
     *          stores, and so they will all be stored here, each keyed by a
     *          unique key (which, by convention, will be the URI they should be
     *          saved to).
     * @returns {String} A serialization of the non-tag receiver.
     */

    var node,
        str;

    node = this.getNativeNode();

    str = node.nodeValue;

    str = TP.htmlEntitiesToXMLEntities(str, false, false);
    str = TP.xmlLiteralsToEntities(str, false, false);

    //  We make sure to replace any 'special characters' with their entity
    //  equivalent. This is because that is  probably how things were authored
    //  in the original markup.
    str = str.replace(
            /[\u00A0-\u9999]/gim,
            function(char) {
                return '&#' + char.charCodeAt(0) + ';';
            });

    return str;
});

//  ========================================================================
//  TP.dom.CDATASectionNode
//  ========================================================================

TP.dom.Node.defineSubtype('CDATASectionNode');

//  ------------------------------------------------------------------------

TP.dom.CDATASectionNode.Inst.defineMethod('getTextContent',
function() {

    /**
     * @method getTextContent
     * @summary Returns the normalized text content of the receiver.
     * @returns {String} The normalized text content of the receiver.
     */

    var node;

    node = this.getNativeNode();

    return node.nodeValue;
});

//  ------------------------------------------------------------------------

TP.dom.CDATASectionNode.Inst.defineMethod('serializeNonTag',
function(storageInfo) {

    /**
     * @method serializeNonTag
     * @summary Serializes the non tag node receiver.
     * @param {TP.core.Hash} storageInfo A hash containing various flags for and
     *     results of the serialization process. Notable keys include:
     *          'wantsXMLDeclaration': Whether or not the receiver's document
     *          node should include an 'XML declaration' at the start of its
     *          serialization. The default is false.
     *          'wantsPrefixedXMLNSAttrs': Whether or not the receiver and its
     *          decendant elements should generate prefixed (i.e. 'xmlns:foo')
     *          attributes to support their proper serialization. The default is
     *          true.
     *          'result': The current serialization result as it's being built
     *          up.
     *          'store': The key under which the current serialization result
     *          will be stored.
     *          'stores': A hash of 1...n serialization results that were
     *          generated during the serialization process. Note that nested
     *          nodes might generated results that will go into different
     *          stores, and so they will all be stored here, each keyed by a
     *          unique key (which, by convention, will be the URI they should be
     *          saved to).
     * @returns {String} A serialization of the non-tag receiver.
     */

    var node,
        str;

    node = this.getNativeNode();

    str = '<![CDATA[' + node.nodeValue + ']]>';

    return str;
});

//  ========================================================================
//  TP.dom.EntityReferenceNode
//  ========================================================================

TP.dom.Node.defineSubtype('EntityReferenceNode');

//  ========================================================================
//  TP.dom.EntityNode
//  ========================================================================

TP.dom.Node.defineSubtype('EntityNode');

//  ========================================================================
//  TP.dom.ProcessingInstructionNode
//  ========================================================================

TP.dom.Node.defineSubtype('ProcessingInstructionNode');

//  actual TP.dom.ProcessingInstructionNode instances returned are
//  specialized on a number of factors
TP.dom.ProcessingInstructionNode.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.dom.ProcessingInstructionNode.Type.defineMethod('getConcreteType',
function(aNode) {

    /**
     * @method getConcreteType
     * @summary Returns a viable processing instruction node type for aNode.
     * @description If a specific type isn't found the return value is
     *     either TP.dom.HTMLProcessingInstructionNode or
     *     TP.dom.XMLProcessingInstructionNode depending on whether the node's
     *     owner document is HTML or XML. The lookup process first calculates
     *     a type name by acquiring the PI's name, title casing that name,
     *     making its first character be uppercase, and stripping it of
     *     punctuation. It then uses that name with a suffix of 'PINode'. For
     *     example, a PI of the form '<?tibet-stylesheet?>' will search for
     *     TP.dom.TibetStylesheetPINode.
     * @returns {TP.meta.dom.ProcessingInstructionNode} A
     *     TP.dom.ProcessingInstructionNode subtype type object.
     */

    var name,
        type;

    name = aNode.target;
    name = name.asTitleCase().strip(TP.regex.PUNCTUATION);

    //  TODO: This is a hardcoded namespace -- probably need a version of
    //  getTypeByName() that can do a 'deep' search across namespaces.
    type = TP.sys.getTypeByName('TP.dom.' + name + 'PINode');

    //  Make sure that we got a subtype of TP.dom.ProcessingInstructionNode.
    //  Sometimes the value of a processing instruction will have the same value
    //  as a custom tag name and we don't want that in this case.
    if (TP.isType(type) &&
        TP.isSubtypeOf(type, TP.dom.ProcessingInstructionNode) &&
        !type.isAbstract()) {
        return type;
    }

    //  default is to wrap based on XML vs. HTML
    if (TP.isHTMLNode(aNode)) {
        return TP.dom.HTMLProcessingInstructionNode;
    } else {
        return TP.dom.XMLProcessingInstructionNode;
    }
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dom.ProcessingInstructionNode.Inst.defineMethod('getTextContent',
function() {

    /**
     * @method getTextContent
     * @summary Returns the normalized text content of the receiver.
     * @returns {String} The normalized text content of the receiver.
     */

    var node;

    node = this.getNativeNode();

    return node.nodeValue;
});

//  ========================================================================
//  TP.dom.TibetStylesheetPINode
//  ========================================================================

TP.dom.ProcessingInstructionNode.defineSubtype('TibetStylesheetPINode');

//  A RegExp that matches 'href' entries with processing instructions
TP.dom.TibetStylesheetPINode.Type.defineConstant(
                        'HREF_REGEX',
                        TP.rc('.*href=[\'"](.*)[\'"]'));

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.dom.TibetStylesheetPINode.Type.defineMethod('tagInstructions',
function(aRequest) {

    /**
     * @method tagInstructions
     * @summary Processes any 'tibet-stylesheet' processing instructions in the
     *     receiver's content. When you load content via XMLHTTP.sig.Request
     *     these PIs aren't executed so you have to run them through this
     *     transform to see their effect on the document.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     * @exception TP.sig.InvalidNode
     */

    var node,

        doc,

        sheetPath,

        hrefValue,
        url,

        resp,
        styleTPDoc,

        rootElem,
        resultNode;

    //  Make sure that we have a node to work from.
    if (!TP.isNode(node = aRequest.at('node'))) {
        //  TODO: Raise an exception.
        return;
    }

    TP.ifInfo() ?
        TP.sys.logTransform(
                TP.annotate(
                        node, 'XSLT finalization transform starting.'),
            TP.INFO) : 0;

    doc = TP.nodeGetDocument(node);

    //  See if the document has a TP.SRC_LOCATION property. If so, we can try to
    //  use it to provide a collection path (if the sheet needs it - i.e. it's
    //  not an absolute path).
    if (TP.isValid(doc[TP.SRC_LOCATION])) {
        sheetPath = TP.uriCollectionPath(doc[TP.SRC_LOCATION]);
    } else if (TP.isValid(aRequest)) {
        //  Otherwise, see if the request has that path under the 'uri' key.

        if (TP.isValid(sheetPath = aRequest.at('uri'))) {
            //  The 'uri' slot in the param hash typically contains a
            //  TP.uri.URI instance... make sure its a String.
            sheetPath = sheetPath.asString();

            //  And we want the 'collection' URL.
            sheetPath = TP.uriCollectionPath(sheetPath);
        } else {
            sheetPath = '~app_xsl';
        }
    } else {
        //  Otherwise, just use the app's 'xsl' path.
        sheetPath = '~app_xsl';
    }

    //  Use our HREF_REGEX to pull out the 'href' data off of the processing
    //  instruction (as it doesn't have 'real' attributes - it just
    //  considers its internal content to be raw text).
    hrefValue = this.HREF_REGEX.exec(node.data).at(1);

    //  If we didn't get a valid href value
    if (TP.isEmpty(hrefValue)) {
        //  No valid href - log an error and return.
        TP.ifError() ?
            TP.error('Invalid stylesheet href',
                        TP.TRANSFORM_LOG) : 0;

        return;
    }

    //  Construct a TP.uri.URI relative to the sheetPath from the href
    //  value.
    url = TP.uc(TP.uriResolvePaths(sheetPath, hrefValue));

    //  Grab the content (TP) node of the stylesheet. If its a
    //  TP.dom.XSLDocumentNode, run the transformation process using it.
    resp = url.getResource(TP.hc('async', false, 'resultType', TP.WRAP));
    styleTPDoc = resp.get('result');

    if (!TP.canInvoke(styleTPDoc, 'getNativeNode')) {
        //  Couldn't find the sheet - log an error and return.
        TP.ifError() ?
            TP.error('Invalid stylesheet at: ' + url.getLocation(),
                        TP.TRANSFORM_LOG) : 0;

        return;
    }

    //  It's best to remove ourself (the actual PI) from the content before
    //  processing to avoid any problems with the XSLT engines.
    TP.nodeRemoveChild(node.parentNode, node);

    //  We want to transform the element that represents the *root* of node we
    //  were handed (as per XSLT). In regular XSLT, this will be the document
    //  element, but in our environment we have a specially configured 'root'
    //  element that takes into account the fact that the tag transformation
    //  engine is holding onto the same element throughout the transformation
    //  process.
    if (!TP.isNode(rootElem = aRequest.at('root'))) {
        //  TODO: Raise an exception.
        return;
    }

    //  If we got an XSLT TP.dom.Node, do the transform and get the result.
    if (TP.isKindOf(styleTPDoc, 'TP.dom.XSLDocumentNode')) {
        resultNode = TP.node(
                        TP.unwrap(styleTPDoc.transform(rootElem, aRequest)));
    } else {
        TP.ifError() ?
            TP.error('Invalid stylesheet at ' + url.getLocation(),
                        TP.TRANSFORM_LOG) : 0;
    }

    //  Didn't get a valid result. Raise an exception and bail.
    if (!TP.isNode(resultNode)) {
        return this.raise('TP.sig.InvalidNode',
                            'Transformation returned empty document.');
    }

    //  Go ahead and replace the document element with the native node of
    //  the newly transformed content.
    rootElem.parentNode.replaceChild(resultNode, rootElem);

    TP.ifInfo() ?
        TP.sys.logTransform(
                TP.annotate(TP.str(resultNode),
                            'XSLT finalization transform complete.'),
            TP.INFO) : 0;

    return;
});

//  ========================================================================
//  TP.dom.HTMLProcessingInstructionNode
//  ========================================================================

TP.dom.ProcessingInstructionNode.defineSubtype('HTMLProcessingInstructionNode');

//  ========================================================================
//  TP.dom.XMLProcessingInstructionNode
//  ========================================================================

TP.dom.ProcessingInstructionNode.defineSubtype('XMLProcessingInstructionNode');

//  ========================================================================
//  TP.dom.CommentNode
//  ========================================================================

TP.dom.Node.defineSubtype('CommentNode');

//  ------------------------------------------------------------------------

TP.dom.CommentNode.Inst.defineMethod('getTextContent',
function() {

    /**
     * @method getTextContent
     * @summary Returns the normalized text content of the receiver.
     * @returns {String} The normalized text content of the receiver.
     */

    var node;

    node = this.getNativeNode();

    return node.nodeValue;
});

//  ------------------------------------------------------------------------

TP.dom.CommentNode.Inst.defineMethod('serializeNonTag',
function(storageInfo) {

    /**
     * @method serializeNonTag
     * @summary Serializes the non tag node receiver.
     * @description This method provides a serialized representation of the
     *     receiver that can be used to store it in a persistent storage. The
     *     supplied storageInfo hash should contain a storage key under the
     *     'store' key that will be used to uniquely identify the content
     *     produced for this receiver. Note that nested nodes might produce
     *     their own 'serialization stores'. All of the stores can be found
     *     under the 'stores' key in the storageInfo after the serialization
     *     process is complete.
     *     For this type, serialization means writing an opening tag for the
     *     element by calling 'serializeOpenTag', then whatever non-Element
     *     content (i.e. text nodes, comment nodes, etc) and then the closing
     *     tag for the element by calling 'serializeCloseTag'.
     * @param {TP.core.Hash} storageInfo A hash containing various flags for and
     *     results of the serialization process. Notable keys include:
     *          'wantsXMLDeclaration': Whether or not the receiver's document
     *          node should include an 'XML declaration' at the start of its
     *          serialization. The default is false.
     *          'wantsPrefixedXMLNSAttrs': Whether or not the receiver and its
     *          decendant elements should generate prefixed (i.e. 'xmlns:foo')
     *          attributes to support their proper serialization. The default is
     *          true.
     *          'result': The current serialization result as it's being built
     *          up.
     *          'store': The key under which the current serialization result
     *          will be stored.
     *          'stores': A hash of 1...n serialization results that were
     *          generated during the serialization process. Note that nested
     *          nodes might generated results that will go into different
     *          stores, and so they will all be stored here, each keyed by a
     *          unique key (which, by convention, will be the URI they should be
     *          saved to).
     * @returns {String} A serialization of the non-tag receiver.
     */

    var node,
        str;

    node = this.getNativeNode();

    //  Make sure that any embedded '--' are converted to something benign.
    str = node.nodeValue.replace(/--/g, '__');

    //  Push on content that has the proper leading and trailing comment
    //  characters.
    str = '<!--' + str + '-->';

    return str;
});

//  ========================================================================
//  TP.dom.DocumentNode
//  ========================================================================

TP.dom.CollectionNode.defineSubtype('DocumentNode');

//  abstract because we specialize document node types by mime type
TP.dom.DocumentNode.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Type.defineMethod('getConcreteType',
function(aNode) {

    /**
     * @method getConcreteType
     * @summary Returns the subtype to use for the node provided. In this case
     *     the node is always some form of Document node (type 9).
     * @param {Node} aNode The native node to wrap.
     * @returns {TP.meta.dom.DocumentNode} A TP.dom.DocumentNode subtype type
     *     object.
     */

    var mime,
        info,
        name,
        type,
        prefix;

    //  get the mime type and see if we have a type for that mime type, that
    //  way we can manage documents like xslts etc. using custom subtypes
    mime = TP.dom.Node.getContentMIMEType(aNode);
    if (TP.isString(mime)) {
        //  two choices here, there may be a 'tpDocNodeType' registered, or
        //  we may just work from naming convention
        if (TP.notEmpty(info = TP.ietf.mime.get('info').at(mime))) {
            if (TP.notEmpty(name = info.at('tpDocNodeType'))) {
                if (TP.isType(type = TP.sys.getTypeByName(name)) &&
                    !type.isAbstract()) {
                    return type;
                }
            }
        }
    }

    //  next choice is to work from document prefix (the canonical prefix
    //  for the document element's namespace URI)
    prefix = TP.dom.Node.getCanonicalPrefix(aNode);
    if (TP.notEmpty(prefix)) {
        prefix = prefix.toUpperCase();
        name = prefix + 'DocumentNode';

        //  use require to see if we can find that document type and use it
        if (TP.isType(type = TP.sys.getTypeByName(name)) && !type.isAbstract()) {
            return type;
        }
    }

    //  default is to wrap based on XML vs. HTML
    if (TP.isHTMLDocument(aNode)) {
        return TP.dom.HTMLDocumentNode;
    } else if (TP.isXHTMLDocument(aNode)) {
        return TP.dom.XHTMLDocumentNode;
    } else {
        return TP.dom.XMLDocumentNode;
    }
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('addObserver',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method addObserver
     * @summary Adds a local signal observation which is roughly like a DOM
     *     element adding an event listener. The observer is typically the
     *     handler provided to an observe() call while the signal is a signal or
     *     string which the receiver is likely to signal or is intercepting for
     *     centralized processing purposes.
     * @description Note that we implement this method because, in order to have
     *     TP.dom.DocumentNodes as event sources, they *must* have an assigned,
     *     globally-unique, ID. By implementing this method, we ensure they have
     *     that before they're registered in the signaling system as signal
     *     sources.
     * @param {Object|Object[]} anOrigin One or more origins to observe.
     * @param {Object|Object[]} aSignal One or more signals to observe from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn on observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to add the observation, false otherwise.
     */

    //  To be observed, we really need a global ID. Here, we don't care about
    //  the return value, but make sure to force the assignment of an ID if it's
    //  not already there.
    TP.gid(this.getNativeNode(), true);

    //  Always tell the notification to register our handler, etc.
    return true;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a TIBET source code string.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    return 'TP.tpdoc(\'' + this.asString() + '\')';
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('get',
function(attributeName) {

    /**
     * @method get
     * @summary Returns the value, if any, of the attribute provided. NOTE
     *     however that special parsing rules apply to TP.dom.Node types with
     *     respect to the nature of the attribute name provided.
     * @description TP.dom.Nodes, particularly TP.dom.ElementNode nodes, can
     *     process complex paths consistent with XPointer and XPath syntax.
     *     These sometimes overlapping syntax options are handled in the order
     *     presented here. First a check is done to see if the path appears to
     *     be an XPointer (indicated by the existence of a # and either an ID,
     *     xpointer(), xpath1(), or element() function. Next are XPaths,
     *     indicated by characters such as '[', '(', '/', etc. Finally,
     *     dot-separated paths are treated as TIBET's "aspect path" form.
     * @param {String} attributeName The name of the attribute to return.
     * @returns {String|Object} The value of the desired attribute.
     */

    var path,
        pathStr,

        args,

        funcName;

    if (TP.isEmpty(attributeName)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  A shortcut - if the attribute name is '.' or '$_', then that's
    //  shorthand for returning ourselves.
    if (TP.regex.ONLY_PERIOD.test(attributeName) ||
        TP.regex.ONLY_STDIN.test(attributeName)) {
        return this;
    }

    //  We can shortcut '#document' by just returning this. The '#document'
    //  of us is ourself ;-)
    if (attributeName === '#document') {
        return this;
    }

    //  If we got handed an 'access path', then we need to let it handle this.
    if (!TP.isString(attributeName) && attributeName.isAccessPath()) {
        path = attributeName;

        //  If the path's String representation is a simple JS_IDENTIFIER, then
        //  we need to check to see if this is just a TIBET path with a name to
        //  an 'aliased' access path (i.e. 'lastname' -> 'foo.bar.lastname').
        //  So, here we check to see if there is an access path for this simple
        //  identifier and, if there is, we use *that* path as the way to access
        //  the underlying data. If not, then we check to see (since we have a
        //  JS identifier as a simple path String) if there is a getter that
        //  matches the identifier.
        if (TP.regex.JS_IDENTIFIER.test(pathStr = path.get('srcPath'))) {
            if (TP.notValid(path = this.getAccessPathFor(
                                        pathStr, 'value', attributeName))) {
                //  try common naming convention first
                funcName = 'get' + TP.makeStartUpper(pathStr);
                if (TP.canInvoke(this, funcName)) {
                    switch (arguments.length) {
                        case 1:
                            return this[funcName]();
                        default:
                            args = TP.args(arguments, 1);
                            return this[funcName].apply(this, args);
                    }
                }

                //  There wasn't a valid access path aliased to that identifier,
                //  so just use the path we were originally going to use.
                path = attributeName;
            }
        }
    } else if (TP.regex.NON_SIMPLE_PATH.test(attributeName)) {
        path = TP.apc(attributeName, TP.hc('shouldCollapse', true));
    }

    if (TP.notValid(path)) {

        //  We can shortcut barename IDs by evaluating just the barename syntax
        if (TP.regex.BARENAME.test(attributeName)) {
            //  Make sure to TP.wrap() the return value for consistent results
            return TP.wrap(TP.nodeEvaluateBarename(this.getNativeNode(),
                                                    attributeName));
        }

        //  try common naming convention
        funcName = 'get' + TP.makeStartUpper(attributeName);
        if (TP.canInvoke(this, funcName)) {
            switch (arguments.length) {
                case 1:
                    return this[funcName]();
                default:
                    args = TP.args(arguments, 1);
                    return this[funcName].apply(this, args);
            }
        }
    }

    //  If we got a valid path above or if we have a 'value' facet that has an
    //  access path, then invoke the path.
    if (TP.isValid(path) ||
        TP.isValid(path = this.getAccessPathFor(attributeName, 'value'))) {

        pathStr = path.asString();
        //  A shortcut - if the path string is '.' or '$_', then that's
        //  shorthand for returning ourselves.
        if (TP.regex.ONLY_PERIOD.test(pathStr) ||
            TP.regex.ONLY_STDIN.test(pathStr)) {
            return this;
        }

        //  Note here how, if we were given more than 1 arguments, we grab all
        //  of the arguments supplied, make our path source the first argument
        //  and invoke with an apply(). Otherwise, we make an Array that has our
        //  path source and our 'path parameters' as the last argument. In both
        //  cases, this is because executeGet() takes varargs (in case the path
        //  is parameterized).
        if (arguments.length > 1) {
            args = TP.args(arguments);
            args.atPut(0, this.getPathSource(path));
        } else {
            args = TP.ac(this.getPathSource(path), this.getPathParameters());
        }

        //  Make sure to TP.wrap() the return value for consistent results
        return TP.wrap(path.executeGet.apply(path, args));
    }

    //  let the standard mechanism handle it
    return this.getProperty(attributeName);
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('getDocument',
function() {

    /**
     * @method getDocument
     * @summary Returns a TP.dom.DocumentNode representing the receiver's
     *     document. For TP.dom.DocumentNode this returns the receiver itself.
     * @returns {TP.dom.DocumentNode} The document of the receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('getDocumentElement',
function() {

    /**
     * @method getDocumentElement
     * @summary Returns the receiver's root element as a TP.dom.ElementNode.
     * @returns {TP.dom.ElementNode} The root element of the receiver.
     */

    return TP.wrap(this.getNativeDocument().documentElement);
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('getDocumentElementType',
function() {

    /**
     * @method getDocumentElementType
     * @summary Returns the Type object that TIBET would use to wrap the
     *     receiver's root element as a TP.dom.ElementNode.
     * @returns {TP.meta.dom.ElementNode} A TP.dom.ElementNode subtype type
     *     object.
     */

    return TP.dom.ElementNode.getConcreteType(
                        this.getNativeDocument().documentElement);
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('getID',
function() {

    /**
     * @method getID
     * @summary Returns the public ID of the receiver.
     * @returns {String} The public ID of the receiver.
     */

    //  Make sure that, if the receiver is a prototype, we just return the value
    //  of the TP.ID slot. Otherwise, we're trying to get an ID from an object
    //  that represents only a partially formed instance for this type.
    if (TP.isPrototype(this)) {
        return this[TP.ID];
    }

    //  Note the difference here from the version we override from our supertype
    //  - we want to force the assignment of an ID if it's not already there.

    return TP.gid(this.getNativeNode(), true);
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('getLocalName',
function() {

    /**
     * @method getLocalName
     * @summary Returns the local (or base) name of the receiver. In the case
     *     of 'document' nodes, this returns the 'document' value.
     * @returns {String} The local name of the receiver.
     */

    return 'document';
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('getLocation',
function() {

    /**
     * @method getLocation
     * @summary Returns the location of the documents's associated URI.
     * @returns {String|undefined} The location of the receiver's URI.
     */

    var loc,
        url;

    loc = TP.documentGetLocation(this.getNativeNode());
    if (TP.isURIString(loc)) {
        url = TP.uc(loc);
        if (TP.isURI(url)) {
            return url.getLocation();
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('getNativeDocument',
function() {

    /**
     * @method getNativeDocument
     * @summary Returns the receiver's native document.
     * @returns {Document} The receiver's native document.
     */

    //  For TP.dom.DocumentNodes, the document *is* their native node.
    return this.getNativeNode();
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('getNativeDocumentElement',
function() {

    /**
     * @method getNativeDocumentElement
     * @summary Returns the receiver's native document element.
     * @returns {Node} The receiver's native document element.
     */

    return this.getNativeDocument().documentElement;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('getRoot',
function() {

    /**
     * @method getRoot
     * @summary Returns the TP.dom.ElementNode that represents the root
     *     element in this document. For HTML/XHTML documents this would be the
     *     <html> element. For an SVG document it would be the <svg> element.
     * @exception TP.sig.InvalidDocument
     * @returns {TP.dom.ElementNode} The root element of the receiver.
     */

    return TP.wrap(TP.documentGetRoot(this.getNativeNode()));
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('getTheme',
function(fallback) {

    /**
     * @method getTheme
     * @summary Returns the *current* UI 'project' theme. It does this by
     *     obtaining the data-theme attribute on the receiver's body that is
     *     helping to drive themed CSS. If the current 'project' theme isn't
     *     available, and the fallback flag is supplied, then the current 'lib'
     *     theme will be returned.
     * @description Note that the receiver might be configured with both a 'lib'
     *     theme and a 'project' theme. The value returned here will always be
     *     the 'project' theme unless the fallback flag is supplied.
     * @param {Boolean} [fallback=false] Whether or not to return the 'lib'
     *     theme if the 'project' theme is unavailable.
     * @returns {String} The theme in effect for the receiver.
     */

    return TP.documentGetTheme(this.getNativeNode(), fallback);
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('getTitle',
function() {

    /**
     * @method getTitle
     * @summary Returns the receiver's 'title' content. This is the
     *     text content of the 'title' element in the receiver's 'head' element.
     * @returns {String} The document's title content.
     */

    return TP.documentGetTitleContent(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('getValue',
function() {

    /**
     * @method getValue
     * @summary Returns the value of the receiver.
     * @description Document nodes are handled a little differently than
     *     typical nodes since without their documentElement they're not of much
     *     use. For that reason setting the value of a document node actually
     *     sets the value of the document's documentElement.
     * @exception TP.sig.InvalidDocument
     * @returns {String} The value in string form.
     */

    var tpElem;

    if (TP.isValid(tpElem = this.getDocumentElement())) {
        return tpElem.getValue();
    }

    return this.raise('TP.sig.InvalidDocument',
                        'No document element.');
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('serializeForStorage',
function(storageInfo) {

    /**
     * @method serializeForStorage
     * @summary Serialize the receiver in a manner appropriate for storage.
     * @description This method provides a serialized representation of the
     *     receiver that can be used to store it in a persistent storage. The
     *     supplied storageInfo hash should contain a storage key under the
     *     'store' key that will be used to uniquely identify the content
     *     produced for this receiver. Note that nested nodes might produce
     *     their own 'serialization stores'. All of the stores can be found
     *     under the 'stores' key in the storageInfo after the serialization
     *     process is complete.
     *     For this type, serialization means possibly writing an XML
     *     declaration (if the 'wantsXMLDeclaration' flag in the storageInfo
     *     hash is true) and the HTML5 doctype. It then calls upon its document
     *     element to serialize itself.
     * @param {TP.core.Hash} storageInfo A hash containing various flags for and
     *     results of the serialization process. Notable keys include:
     *          'wantsXMLDeclaration': Whether or not the document node should
     *          include an 'XML declaration' at the start of its serialization.
     *          The default is false.
     *          'wantsPrefixedXMLNSAttrs': Whether or not element nodes in the
     *          document should generate prefixed (i.e. 'xmlns:foo') attributes
     *          to support their proper serialization. The default is true.
     *          'result': The current serialization result as it's being built
     *          up.
     *          'store': The key under which the current serialization result
     *          will be stored.
     *          'stores': A hash of 1...n serialization results that were
     *          generated during the serialization process. Note that nested
     *          nodes might generated results that will go into different
     *          stores, and so they will all be stored here, each keyed by a
     *          unique key (which, by convention, will be the URI they should be
     *          saved to).
     * @returns {TP.dom.DocumentNode} The receiver.
     */

    var result;

    result = storageInfo.atPutIfAbsent('result', TP.ac());

    if (storageInfo.at('wantsXMLDeclaration') === true) {
        result.push(TP.XML_10_HEADER, '\n\n');
    }

    result.push(TP.w3.DocType.XHTML_50.asString(), '\n\n');

    this.getDocumentElement().serializeForStorage(storageInfo);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('setID',
function(anID) {

    /**
     * @method setID
     * @summary Sets the public ID of the receiver. Note that while, for
     *     Element nodes, this corresponds to the 'local ID' of the receiver,
     *     for Document nodes this corresponds to the 'global ID' (since they
     *     don't really have a local ID).
     * @description Note that this method will assign a generated ID if the
     *     supplied ID is empty.
     * @param {String} anID The value to use as a public ID.
     * @returns {String} The ID that was set.
     */

    var node;

    node = this.getNativeNode();

    TP.elementSetAttribute(
                    node.documentElement, TP.GLOBAL_DOCID_ATTR, anID, true);

    return anID;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('setPhase',
function(aPhase) {

    /**
     * @method setPhase
     * @summary Sets the current processing phase for the content. This
     *     attribute is also placed on the content itself to mark it for
     *     inspection by other routines such as hasReachedPhase.
     * @param {String} aPhase A content-processing phase value.
     * @returns {TP.dom.DocumentNode} The receiver.
     */

    var elem;

    //  don't forget to do the real work ;)
    this.$set('phase', aPhase);

    //  we'll set the documentElement's attribute, as long as we have one
    elem = this.getNativeDocument().documentElement;
    if (TP.isNode(elem)) {
        //  Note here how we pass 'true' as the fourth parameter to use
        //  'strict' namespace setting to force this call to truly place the
        //  attribute inside of the 'tibet:' namespace. Otherwise, the
        //  attribute will 'lose' its namespace along the way of processing.
        TP.elementSetAttribute(elem, 'tibet:phase', aPhase, true);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('setRawContent',
function(newContent, aRequest, shouldSignal) {

    /**
     * @method setRawContent
     * @summary Sets the content of the receiver to the content provided
     *     without performing any content processing on it.
     * @param {Object} newContent The content to write into the receiver. This
     *     can be a String, a Node, or an Object capable of being converted into
     *     one of those forms.
     * @param {TP.sig.Request} aRequest An optional request object which defines
     *     further parameters.
     * @param {Boolean} shouldSignal If false this operation will not trigger a
     *     change notification. This defaults to true.
     * @returns {TP.dom.Node} The result of setting the content of the
     *     receiver.
     */

    var loc,
        uri,

        retVal,

        natWin,
        unloadHandler;

    //  Call up to our supertype, which will set the location/content.
    retVal = this.callNextMethod();

    //  If the receiver is associated with a Window (i.e. it's being drawn into
    //  a visible DOM), observe / ignore its content for change.
    if (TP.isWindow(natWin = this.getNativeWindow())) {

        //  Get the new location and observe/watch the URI for the ValueChange.
        loc = this.getLocation();
        uri = TP.uc(loc);

        if (TP.isURI(uri)) {
            this.observe(uri, 'TP.sig.ValueChange');
            uri.watch();
        }

        //  Set up an 'document unloaded' handler on the native window so when
        //  the URI unloads from the window, it is unwatched and ignored for
        //  ValueChange.
        /* eslint-disable no-extra-parens */
        unloadHandler = (function(aSig) {

            var wasRegistered,
                unloadURI;

            unloadHandler.ignore(TP.gid(natWin), 'TP.sig.DocumentUnloaded');

            wasRegistered = TP.uri.URI.hasInstance(loc);
            unloadURI = TP.uc(loc);

            //  Grab our current location and ignore/unwatch the URI for the
            //  ValueChange.
            if (TP.isURI(unloadURI)) {
                this.ignore(unloadURI, 'TP.sig.ValueChange');
                unloadURI.unwatch();
            }

            if (!wasRegistered) {
                unloadURI.unregister();
            }
        }.bind(this));
        /* eslint-enable no-extra-parens */

        unloadHandler.observe(TP.gid(natWin), 'TP.sig.DocumentUnloaded');
    }

    return retVal;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('setTheme',
function(themeName) {

    /**
     * @method setTheme
     * @summary Sets a data-theme attribute on the receiver's body to help drive
     *     themed CSS. Note that this should be the UI 'project' theme. This
     *     will have the 'lib' theme added to it for theming 'backstop'
     *     purposes.
     * @param {String} themeName The theme name to set for the receiver.
     * @returns {TP.dom.DocumentNode} The receiver.
     */

    TP.documentSetTheme(this.getNativeNode(), themeName);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('setTitle',
function(titleText) {

    /**
     * @method setTitle
     * @summary Sets the receiver's 'title' content.
     * @param {String} titleText The value to use as the title content.
     * @returns {TP.dom.DocumentNode} The receiver.
     */

    TP.documentSetTitleContent(this.getNativeNode(), titleText);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('setValue',
function(aValue, signalFlag) {

    /**
     * @method setValue
     * @summary Sets the value of the receiver's node.
     * @description Document nodes are handled a little differently than
     *     typical nodes since without their documentElement they're not of much
     *     use. For that reason setting the value of a document node actually
     *     sets the value of the document's documentElement.
     * @param {Object} aValue The value to set the 'value' of the node to.
     * @param {Boolean} signalFlag Should changes be notified. If false changes
     *     are not signaled. Defaults to this.shouldSignalChange().
     * @exception TP.sig.InvalidDocument
     * @returns {Boolean} Whether or not the value was changed from the value it
     *     had before this method was called.
     */

    var tpElem;

    if (TP.isValid(tpElem = this.getDocumentElement())) {

        //  NB: This will signal change
        return tpElem.setValue(aValue, signalFlag);
    }

    return this.raise('TP.sig.InvalidDocument',
                        'No document element.');
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('shouldFlagChanges',
function(aFlag) {

    /**
     * @method shouldFlagChanges
     * @summary A combined setter/getter for the change flagging flag for the
     *     receiver.
     * @description When the document element of a TP.dom.DocumentNode instance
     *     is flagging changes the alterations it makes to a DOM structure are
     *     flagged in the form of 'tibet:crud' attributes. Note in particular
     *     that deletes don't actually occur when change flagging is on, items
     *     are simply flagged for delete.
     * @returns {Boolean} Whether or not to flag changes to the receiver.
     */

    return this.getDocumentElement().shouldFlagChanges(aFlag);
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('shouldSignalChange',
function(aFlag) {

    /**
     * @method shouldSignalChange
     * @summary Defines whether the receiver should actively signal change
     *     notifications.
     * @description In general objects do not signal changes when no observers
     *     exist. This flag is triggered by observe where the signal being
     *     observed is a form of Change signal to "arm" the object for change
     *     notification. You can also manipulate it during multi-step
     *     manipulations to signal only when a series of changes has been
     *     completed.
     * @param {Boolean} aFlag true/false signaling status.
     * @returns {Boolean} The current status.
     */

    var tpDocElem;

    tpDocElem = this.getDocumentElement();

    if (TP.isValid(tpDocElem)) {
        return tpDocElem.shouldSignalChange(aFlag);
    }
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('transform',
function(anObject, aParamHash) {

    /**
     * @method transform
     * @summary Transforms the supplied Node (or TP.dom.Node) by using the
     *     content of the receiver.
     * @param {Object} anObject The object supplying the data to use in the
     *     transformation.
     * @param {TP.core.Hash|TP.sig.Request} aParamHash A parameter container
     *     responding to at(). For string transformations a key of 'repeat' with
     *     a value of true will cause iteration to occur (if anObject is an
     *     'ordered collection' this flag needs to be set to 'true' in order to
     *     have 'automatic' iteration occur). Additional keys of '$STARTINDEX'
     *     and '$REPEATCOUNT' determine the range of the iteration. A special
     *     key of 'xmlns:fixup' should be set to true to fix up 'xmlns'
     *     attributes such that they won't be lost during the transformation.
     * @returns {String} The string resulting from the transformation process.
     */

    return this.getDocumentElement().transform(anObject, aParamHash);
});

//  ------------------------------------------------------------------------

//  create backstop hooks for the native document methods we support
TP.backstop(
    TP.ac('createElement',
            'createTextNode',
            'getElementsByName',
            'createAttribute',
            'createComment',
            'createDocumentFragment',
            'createCDATASection',
            'createEntityReference',
            'createProcessingInstruction'),
    TP.dom.DocumentNode.getInstPrototype());

//  ========================================================================
//  TP.dom.Document (alias)
//  ========================================================================

TP.dom.Document = TP.dom.DocumentNode;
TP.sys.addCustomType('TP.dom.Document', TP.dom.Document);

//  ========================================================================
//  TP.dom.HTMLDocumentNode
//  ========================================================================

/**
 * @type {TP.dom.HTMLDocumentNode}
 * @summary Generic HTML document wrapper.
 */

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.defineSubtype('HTMLDocumentNode');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dom.HTMLDocumentNode.Inst.defineMethod('close',
function() {

    /**
     * @method close
     * @summary Closes the document and flushes any write content. This method
     *     will automatically instrument the window as well.
     * @exception TP.sig.InvalidDocument
     * @returns {TP.dom.HTMLDocumentNode} The receiver.
     */

    var doc,
        win;

    if (!TP.isHTMLDocument(doc = this.getNativeNode())) {
        return this.raise('TP.sig.InvalidDocument');
    }

    //  Assign ids to common elements, such as the root element, the head
    //  element and the body element. These might have gotten blown away in
    //  (re)writing the document content.
    win = this.getNativeWindow();

    if (TP.isWindow(win)) {
        TP.windowAssignCommonIds(win);
    }

    doc.close();

    //  updates the window to be instrumented which also will have been
    //  cleared by any write calls
    if (TP.isWindow(win)) {
        TP.core.Window.instrument(win);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.HTMLDocumentNode.Inst.defineMethod('getBody',
function() {

    /**
     * @method getBody
     * @summary Returns the TP.dom.ElementNode that represents the 'body'
     *     element in this document.
     * @exception TP.sig.InvalidDocument
     * @returns {TP.html.body} The 'body' element of the receiver.
     */

    return TP.wrap(TP.documentGetBody(this.getNativeNode()));
});

//  ------------------------------------------------------------------------

TP.dom.HTMLDocumentNode.Inst.defineMethod('getContentPrimitive',
function(operation) {

    /**
     * @method getContentPrimitive
     * @summary Returns the primitive function used to perform the operation
     *     specified. For example, an operation of TP.APPEND might return the
     *     TP.nodeAddContent primitive or a related function specific to the
     *     type of node being modified.
     * @param {String} operation A constant defining the operation. Valid values
     *     include: TP.APPEND TP.INSERT TP.UPDATE.
     * @exception TP.sig.InvalidOperation When the operation isn't a valid one.
     * @returns {Function|undefined} A TP primitive function.
     */

    switch (operation) {
        case TP.APPEND:
            return TP.htmlDocumentAddContent;
        case TP.INSERT:
            return TP.htmlDocumentInsertContent;
        case TP.UPDATE:
            return TP.htmlDocumentSetContent;
        default:
            return this.raise('TP.sig.InvalidOperation');
    }
});

//  ------------------------------------------------------------------------

TP.dom.HTMLDocumentNode.Inst.defineMethod('getFocusedElement',
function(orActiveElement) {

    /**
     * @method getFocusedElement
     * @summary Returns the TP.dom.ElementNode that represents the currently
     *     focused (i.e. 'active') element in this document.
     * @param {Boolean} [orActiveElement=true] Whether or not to return the
     *     standard HTML5 '.activeElement' if a 'TIBET focused' element isn't
     *     available. The default is true.
     * @exception TP.sig.InvalidDocument
     * @returns {TP.dom.ElementNode} The currently focused element.
     */

    return TP.wrap(TP.documentGetFocusedElement(
                    this.getNativeNode(), orActiveElement));
});

//  ------------------------------------------------------------------------

TP.dom.HTMLDocumentNode.Inst.defineMethod('getHead',
function() {

    /**
     * @method getHead
     * @summary Returns the TP.dom.ElementNode that represents the 'head'
     *     element in this document.
     * @exception TP.sig.InvalidDocument
     * @returns {TP.html.head} The 'head' element of the receiver.
     */

    return TP.wrap(TP.documentGetHead(this.getNativeNode()));
});

//  ------------------------------------------------------------------------

TP.dom.HTMLDocumentNode.Inst.defineMethod('getNativeWindow',
function() {

    /**
     * @method getNativeWindow
     * @summary Returns the document's native window object.
     * @exception TP.sig.InvalidDocument
     * @returns {Window} The receiver's native window object.
     */

    return TP.nodeGetWindow(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.HTMLDocumentNode.Inst.defineHandler('DOMClose',
function(aSignal) {

    /**
     * @method handleDOMClose
     * @summary Closes the document and targets the window with an
     *     TP.sig.DOMClose.
     * @param {TP.sig.DOMClose} aSignal The signal instance which triggered this
     *     handler.
     * @returns {TP.dom.HTMLDocumentNode} The receiver.
     */

    //  close our document down so it's empty
    this.close();

    //  and target our window for close as well
    TP.handle(this.getWindow(), aSignal, 'TP.sig.DOMClose');

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.HTMLDocumentNode.Inst.defineMethod('open',
function(mimeType) {

    /**
     * @method open
     * @summary Opens the document for writing.
     * @param {The} mimeType MIME type used when opening the native document.
     * @exception TP.sig.InvalidDocument
     * @returns {TP.dom.DocumentNode} The receiver.
     */

    var doc,
        win;

    if (!TP.isHTMLDocument(doc = this.getNativeNode())) {
        return this.raise('TP.sig.InvalidDocument');
    }

    doc.open(mimeType);

    //  We make sure that the window is re-instrumented here because, in
    //  some browsers, opening the document of the window blows away the
    //  TIBET instrumentation.
    win = this.getNativeWindow();
    if (TP.isWindow(win)) {
        TP.core.Window.instrument(win);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.HTMLDocumentNode.Inst.defineMethod('write',
function(theContent, setupFunction) {

    /**
     * @method write
     * @summary Writes content to the receiver's native document, ensuring that
     *     open and close are called, along with any logging which might be
     *     turned on.
     * @param {String} theContent The content to write into the native document.
     * @param {Function} setupFunction The setup function to execute as part of
     *     the document's 'onload' processing.
     * @exception TP.sig.InvalidDocument
     * @returns {TP.dom.DocumentNode} The receiver.
     */

    var doc,
        win,
        content;

    if (!TP.isHTMLDocument(doc = this.getNativeNode())) {
        return this.raise('TP.sig.InvalidDocument');
    }

    //  If a valid setup function was supplied, register it as an 'onload'
    //  function on the document. This will then be executed when the
    //  native document's 'close' method is called.

    //  NB: It doesn't matter if the setupFunction gets registered multiple
    //  times (because this method might have been called multiple times
    //  before close()) because the code that actually executes the onload
    //  function uniques all of its functions before it runs them.
    if (TP.isCallable(setupFunction)) {
        win = this.getNativeWindow();
        if (TP.isWindow(win)) {
            TP.core.Window.registerOnloadFunction(win, setupFunction);
        }
    }

    content = theContent;

    //  watch for tibet_ and replace hacks as needed
    if (/tibet_/.test(content)) {
        //  due to certain bugs in mozilla we want to check for a
        //  couple of special attributes/elements and replace them
        //  before we hand back the content
        try {
            //  update namespace references
            content = content.replace(/tibet__/g, 'tibet:');

            //  we had to escape HTML style elements and HTML link elements
            //  pointing to stylesheets and CSS imports to avoid problems
            //  with the content processing system under Mozilla, so we need
            //  to unescape those constructs here before we write the file.
            content = TP.$unescapeCSSConstructs(content);
        } catch (e) {
            //  typical error here is html rather than xhtml markup
            //  coming in and being mangled (since it wasn't really
            //  xml from the transformer's perspective)
            return this.raise(
                        'TP.sig.InvalidDocument',
                        TP.ec(e, TP.join('XML-to-XHTML conversion failed. ',
                                            'Was it truly XHTML?')));
        }
    }

    doc.write(content);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.HTMLDocumentNode.Inst.defineMethod('writeln',
function(content, setupFunction) {

    /**
     * @method writeln
     * @summary Writes content to the receiver's native document (with a
     *     newline).
     * @param {String} content The content to write into the native document.
     * @param {Function} setupFunction The setup function to execute as part of
     *     the document's 'onload' processing.
     * @exception TP.sig.InvalidDocument
     * @returns {TP.dom.DocumentNode} The receiver.
     */

    var doc,
        win;

    if (!TP.isHTMLDocument(doc = this.getNativeNode())) {
        return this.raise('TP.sig.InvalidDocument');
    }

    //  If a valid setup function was supplied, register it as an 'onload'
    //  function on the document. This will then be executed when the
    //  native document's 'close' method is called.

    //  NB: It doesn't matter if the setupFunction gets registered multiple
    //  times (because this method might have been called multiple times
    //  before close()) because the code that actually executes the onload
    //  function uniques all of its functions before it runs them.
    if (TP.isCallable(setupFunction)) {
        win = this.getNativeWindow();
        if (TP.isWindow(win)) {
            TP.core.Window.registerOnloadFunction(win, setupFunction);
        }
    }

    doc.writeln(content);

    return this;
});

//  ========================================================================
//  TP.dom.XMLDocumentNode
//  ========================================================================

/**
 * @type {TP.dom.XMLDocumentNode}
 * @summary Generic XML document wrapper.
 */

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.defineSubtype('XMLDocumentNode');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dom.XMLDocumentNode.Inst.defineMethod('getContentPrimitive',
function(operation) {

    /**
     * @method getContentPrimitive
     * @summary Returns the primitive function used to perform the operation
     *     specified. For example, an operation of TP.APPEND might return the
     *     TP.nodeAddContent primitive or a related function specific to the
     *     type of node being modified.
     * @param {String} operation A constant defining the operation. Valid values
     *     include: TP.APPEND TP.INSERT TP.UPDATE.
     * @exception TP.sig.InvalidOperation When the operation isn't a valid one.
     * @returns {Function} A TP primitive function.
     */

    switch (operation) {
        case TP.APPEND:
            return TP.xmlDocumentAddContent;
        case TP.INSERT:
            return TP.xmlDocumentInsertContent;
        case TP.UPDATE:
            return TP.xmlDocumentSetContent;
        default:
            return this.raise('TP.sig.InvalidOperation');
    }
});

//  ========================================================================
//  TP.dom.XHTMLDocumentNode
//  ========================================================================

/**
 * @type {TP.dom.XHTMLDocumentNode}
 * @summary XHTML document wrapper.
 */

//  ------------------------------------------------------------------------

TP.dom.XMLDocumentNode.defineSubtype('XHTMLDocumentNode');

//  ------------------------------------------------------------------------

TP.dom.XHTMLDocumentNode.Inst.defineMethod('getBody',
function() {

    /**
     * @method getBody
     * @summary Returns the TP.dom.ElementNode that represents the 'body'
     *     element in this document.
     * @exception TP.sig.InvalidDocument
     * @returns {TP.html.body} The 'body' element of the receiver.
     */

    var doc;

    if (!TP.isDocument(doc = this.getNativeNode())) {
        return this.raise('TP.sig.InvalidDocument');
    }

    return TP.wrap(TP.documentGetBody(doc));
});

//  ------------------------------------------------------------------------

TP.dom.XHTMLDocumentNode.Inst.defineMethod('getFocusedElement',
function(orActiveElement) {

    /**
     * @method getFocusedElement
     * @summary Returns the TP.dom.ElementNode that represents the currently
     *     focused (i.e. 'active') element in this document.
     * @param {Boolean} [orActiveElement=true] Whether or not to return the
     *     standard HTML5 '.activeElement' if a 'TIBET focused' element isn't
     *     available. The default is true.
     * @exception TP.sig.InvalidDocument
     * @returns {TP.dom.ElementNode} The currently focused element.
     */

    var doc;

    if (!TP.isDocument(doc = this.getNativeNode())) {
        return this.raise('TP.sig.InvalidDocument');
    }

    return TP.wrap(TP.documentGetFocusedElement(doc, orActiveElement));
});

//  ------------------------------------------------------------------------

TP.dom.XHTMLDocumentNode.Inst.defineMethod('getHead',
function() {

    /**
     * @method getHead
     * @summary Returns the TP.dom.ElementNode that represents the 'head'
     *     element in this document.
     * @exception TP.sig.InvalidDocument
     * @returns {TP.html.head} The 'head' element of the receiver.
     */

    var doc;

    if (!TP.isDocument(doc = this.getNativeNode())) {
        return this.raise('TP.sig.InvalidDocument');
    }

    return TP.wrap(TP.documentGetHead(doc));
});

//  ------------------------------------------------------------------------

TP.dom.XHTMLDocumentNode.Inst.defineMethod('getNativeWindow',
function() {

    /**
     * @method getNativeWindow
     * @summary Returns the document's native window object.
     * @exception TP.sig.InvalidDocument
     * @returns {Window} The receiver's native window object.
     */

    var doc;

    if (!TP.isDocument(doc = this.getNativeNode())) {
        return this.raise('TP.sig.InvalidDocument');
    }

    return TP.nodeGetWindow(doc);
});

//  ------------------------------------------------------------------------

TP.dom.XHTMLDocumentNode.Inst.defineHandler('DOMClose',
function(aSignal) {

    /**
     * @method handleDOMClose
     * @summary Closes the document and targets the window with an
     *     TP.sig.DOMClose.
     * @param {TP.sig.DOMClose} aSignal The signal instance which triggered this
     *     handler.
     * @returns {TP.dom.XHTMLDocumentNode} The receiver.
     */

    //  and target our window for close as well
    TP.handle(this.getWindow(), aSignal, 'TP.sig.DOMClose');

    return this;
});

//  ========================================================================
//  TP.dom.XSLDocumentNode
//  ========================================================================

/**
 * @type {TP.dom.XSLDocumentNode}
 * @summary A type specific to XSL documents.
 */

//  ------------------------------------------------------------------------

TP.dom.XMLDocumentNode.defineSubtype('XSLDocumentNode');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dom.XSLDocumentNode.Inst.defineMethod('transform',
function(anObject, aParamHash) {

    /**
     * @method transform
     * @summary Transforms the supplied Node (or TP.dom.Node) by using the
     *     content of the receiver.
     * @param {Object} anObject The object supplying the data to use in the
     *     transformation.
     * @param {TP.core.Hash|TP.sig.Request} aParamHash A parameter container
     *     responding to at(). For string transformations a key of 'repeat' with
     *     a value of true will cause iteration to occur (if anObject is an
     *     'ordered collection' this flag needs to be set to 'true' in order to
     *     have 'automatic' iteration occur). Additional keys of '$STARTINDEX'
     *     and '$REPEATCOUNT' determine the range of the iteration. A special
     *     key of 'xmlns:fixup' should be set to true to fix up 'xmlns'
     *     attributes such that they won't be lost during the transformation.
     * @exception TP.sig.InvalidNode
     * @returns {String} The string resulting from the transformation process.
     */

    var node,

        dataNode,

        result,
        resultTPNode;

    node = this.getNativeNode();

    if (TP.isNode(anObject)) {
        dataNode = anObject;
    } else if (TP.canInvoke(anObject, 'getNativeNode')) {
        dataNode = anObject.getNativeNode();
    } else if (TP.isString(anObject)) {
        dataNode = TP.documentFromString(anObject);
    } else if (TP.canInvoke(anObject, 'asXMLNode')) {
        dataNode = anObject.asXMLNode();
    }

    if (!TP.isNode(dataNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    result = TP.documentTransformNode(node, dataNode, aParamHash);

    //  Now, we need to make sure that any constructs that were generated into
    //  the result that need tag compilation are processed.

    if (TP.isElement(result) &&
        TP.notTrue(this.get('$alreadyTransforming'))) {

        this.set('$alreadyTransforming', true, false);
        resultTPNode = TP.wrap(result);
        resultTPNode.compile();
        this.set('$alreadyTransforming', false, false);

        return resultTPNode.asString();

    } else if (TP.isNode(result)) {
        return TP.str(result);
    }

    return null;
});

//  ========================================================================
//  TP.dom.DocumentTypeNode
//  ========================================================================

TP.dom.Node.defineSubtype('DocumentTypeNode');

//  ========================================================================
//  TP.dom.NotationNode
//  ========================================================================

TP.dom.Node.defineSubtype('NotationNode');

//  ========================================================================
//  XSLT ELEMENTS
//  ========================================================================

TP.dom.ElementNode.defineSubtype('xsl.Element');

//  actual XSL Element instances returned are specialized on a number of
//  factors
TP.xsl.Element.isAbstract(true);

//  ------------------------------------------------------------------------
//  xsl:stylesheet
//  ------------------------------------------------------------------------

TP.xsl.Element.defineSubtype('stylesheet');

//  ------------------------------------------------------------------------
//  xsl:import
//  ------------------------------------------------------------------------

TP.xsl.Element.defineSubtype('import');

TP.xsl.import.Type.set('uriAttrs', TP.ac('href'));

//  ------------------------------------------------------------------------
//  xsl:include
//  ------------------------------------------------------------------------

TP.xsl.Element.defineSubtype('include');

TP.xsl.include.Type.set('uriAttrs', TP.ac('href'));

//  ========================================================================
//  XINCLUDE PROCESSING
//  ========================================================================

TP.dom.ElementNode.defineSubtype('xi.Element');

//  actual XI Element instances returned are specialized on a number of
//  factors
TP.xi.Element.isAbstract(true);

//  ------------------------------------------------------------------------
//  xi:include
//  ------------------------------------------------------------------------

TP.xi.Element.defineSubtype('include');

TP.xi.include.Type.set('uriAttrs', TP.ac('href'));

//  ------------------------------------------------------------------------

TP.xi.include.Type.defineMethod('tagIncludes',
function(aRequest) {

    /**
     * @method tagIncludes
     * @summary Processes any 'xinclude' elements in the receiver's content.
     *     This will expand any virtual URIs and resolve XML Base references on
     *     the xinclude element, retrieve the (possibly XPointered) content from
     *     the designated URI and replace it in-situ, replacing the xinclude
     *     element.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     * @returns {Node} The node representing the newly included content, telling
     *     the system to descend into the children of this element (which very
     *     well may be content that was included by this element).
     */

    var elem,

        fallback,

        parse,
        href,
        xpointer,

        parts,
        path,
        resp,
        content,

        url,

        newNode,

        errorMsgElem,

        i,
        cnode;

    //  Make sure that we have a node to work from.
    if (!TP.isNode(elem = aRequest.at('node'))) {
        //  TODO: Raise an exception.
        return;
    }

    TP.ifInfo() ?
        TP.sys.logTransform(
                TP.annotate(TP.str(elem),
                            'XInclude content inclusion starting.'),
            TP.INFO) : 0;

    //  now update the XML Base references in the element
    TP.elementResolveXMLBase(elem, this.get('uriAttrs'));

    //  according to the latest spec the following rules apply:
    //
    //  1.  if parse isn't found parse="xml"
    //  2.  if href is missing or empty xpointer must be present
    //  3.  if href is present no # is allowed in any position
    //  4.  if parse="text" then xpointer is not allowed
    //  5.  if parse="xml" encoding has no effect
    //
    //  6.  if accept is provided it should be used as Accept header
    //  7.  if accept-language is provided it should be used as the
    //          Accept-Language header

    fallback = false;

    if (TP.isEmpty(parse = TP.elementGetAttribute(elem, 'parse'))) {
        parse = 'xml';
    } else {
        parse = parse.toLowerCase();
        if (parse !== 'xml' && parse !== 'text') {
            //  fatal error according to spec, must have text or xml
            this.raise('TP.sig.InvalidXInclude',
                'XInclude requires parse="text" or parse="xml" : ' +
                TP.nodeAsString(elem));

            return;
        }
    }

    href = TP.elementGetAttribute(elem, 'href');
    xpointer = TP.elementGetAttribute(elem, 'xpointer');

    if (parse === 'text' && TP.notEmpty(xpointer)) {
        //  fatal error according to spec, must have xml with xpointer
        this.raise('TP.sig.InvalidXInclude',
            'XInclude requires parse="xml" for xpointer: ' +
            TP.nodeAsString(elem));

        return;
    }

    if (TP.notEmpty(href)) {
        if (/#/.test(href)) {
            //  fatal error according to specification...
            this.raise('TP.sig.InvalidXInclude',
                'Invalid href for XInclude: ' +
                TP.nodeAsString(elem));

            return;
        }
    } else {
        if (TP.isEmpty(xpointer)) {
            //  fatal error according to spec, must have href or xpointer
            //  value to include something
            this.raise('TP.sig.InvalidXInclude',
                'XInclude requires href or xpointer value: ' +
                TP.nodeAsString(elem));

            return;
        }
    }

    if (TP.isEmpty(href)) {
        //  xpointer should be pointing to a part of the current document so
        //  try to locate that element
        if (/^xmlns/.test(xpointer)) {
            //  TODO
            return TP.todo();
        } else if (TP.notEmpty(parts = xpointer.match(TP.regex.XPOINTER))) {
            //  with no href the pointer is to the current document being
            //  transformed.

            //  save the path we've found so far
            path = parts.at(2).unquoted();

            //  see if we can optimize even further by matching an ID
            //  lookup instead of a general form XPath
            if (TP.notEmpty(parts = xpointer.match(TP.regex.ID_POINTER))) {
                path = parts.at(1).unquoted();
                content = TP.nodeGetElementById(elem, path, true);
            } else {
                //  use the saved path from first match here
                content = TP.nodeEvaluateXPath(elem, path);
            }
        } else {
            //  with no href the pointer is to the current document
            //  being transformed...
            content = TP.nodeGetElementById(elem, xpointer, true);
        }
    } else {
        if (TP.notEmpty(xpointer)) {
            href = href + '#' + xpointer;
        }

        url = TP.uc(href);
        if (!TP.isURI(url)) {
            //  bad URI specification
            this.raise('TP.sig.InvalidXInclude',
                'Invalid href value, could not construct URI instance: ' +
                TP.nodeAsString(elem));

            return;
        }

        //  rely on the URI to manage things for content acquisition, but
        //  unwrap any node wrappers we might get
        resp = url.getResource(TP.hc('async', false, 'resultType', TP.WRAP));
        content = TP.unwrap(resp.get('result'));
    }

    //  no content to include?
    if (TP.notValid(content)) {
        //  look for a fallback element that defines what we should do next
        fallback = TP.nodeGetFirstElementChildByTagName(elem, 'fallback');

        //  If we found a 'fallback' element, we need to use that to obtain
        //  our error message.
        if (TP.isElement(fallback)) {
            //  Move all of the children under the 'fallback' element into
            //  the spot occupied by XInclude element, remove the XInclude
            //  element and return the fallback's first new child.
            newNode = TP.nodeMoveChildNodesTo(fallback,
                                                elem.parentNode,
                                                elem);
            TP.nodeDetach(elem);

            return newNode;
        } else {
            if (TP.notValid(href)) {
                TP.ifWarn() ?
                    TP.warn('Invalid HREF attribute for XInclude.',
                            TP.TRANSFORM_LOG) : 0;
            } else if (TP.notValid(url)) {
                TP.ifWarn() ?
                    TP.warn('Unable to construct URI for XInclude HREF: ' +
                                href,
                            TP.TRANSFORM_LOG) : 0;
            } else {
                TP.ifWarn() ?
                    TP.warn('Content not found for XInclude HREF: ' +
                                href,
                            TP.TRANSFORM_LOG) : 0;
            }

            //  Otherwise, we insert our own error element into the
            //  resulting markup and proceed.

            //  TODO: This is a dependency on XHTML-only reps. Make it
            //  generic. Also, update this to the 'workflow model'.
            errorMsgElem = TP.nodeGetDocument(elem).createElement('span');
            TP.nodeAppendChild(
                errorMsgElem,
                TP.nodeGetDocument(elem).createTextNode(
                'Could not retrieve content for: ' +
                    TP.xmlEntitiesToLiterals(TP.nodeAsString(elem))));

            //  Replace the XInclude element with the error message element
            //  and return.
            newNode = TP.nodeReplaceChild(elem.parentNode,
                                            errorMsgElem,
                                            elem);

            return newNode;
        }
    } else if (TP.isDocument(content)) {
        if (TP.notEmpty(content)) {
            content = TP.nodeCloneNode(content.documentElement);
            newNode = TP.nodeInsertBefore(elem.parentNode,
                                            content,
                                            elem);
            TP.nodeDetach(elem);
        }
    } else if (TP.isNode(content)) {
        content = TP.nodeCloneNode(content);
        newNode = TP.nodeInsertBefore(elem.parentNode,
                                        content,
                                        elem);
        TP.nodeDetach(elem);
    } else if (TP.isArray(content)) {
        //  Loop over all of the content nodes handed back by getting the
        //  content from the URI, insert them before the XInclude element
        //  one at a time and then finally remove the XInclude.
        for (i = 0; i < content.getSize(); i++) {
            cnode = TP.nodeCloneNode(content.at(i));

            //  We want the first new node inserted.
            if (!TP.isNode(newNode)) {
                newNode = TP.nodeInsertBefore(elem.parentNode,
                                                cnode,
                                                elem);
            } else {
                TP.nodeInsertBefore(elem.parentNode,
                                    cnode,
                                    elem);
            }
        }

        TP.nodeDetach(elem);
    }

    TP.ifInfo() ?
        TP.sys.logTransform(
                TP.annotate(TP.str(elem),
                            'XInclude content inclusion complete.'),
            TP.INFO) : 0;

    return newNode;
});

//  ========================================================================
//  TP.dom.TemplatedNode
//  ========================================================================

/**
 * @type {TP.dom.TemplatedNode}
 * @summary A trait type which allows the target type to have sugared access to
 *     a tsh:template during compilation. The result is that the tag can
 *     leverage a src="" attribute, child content, or other means to make the
 *     compiled representation of the tag easier to maintain. The common usage
 *     pattern is a .JS file, a .XHTML or .XSL "template", and .CSS file which
 *     make up the tag "bundle".
 */

//  ------------------------------------------------------------------------

TP.dom.ElementNode.defineSubtype('dom.TemplatedNode');

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation.
TP.dom.TemplatedNode.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  Whether or not the node wants a 'tsh:template' wrapper (necessary for
//  dynamic templating, etc.)
TP.dom.TemplatedNode.Type.defineAttribute('wantsTemplateWrapper');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  Tag Phase Support
//  ------------------------------------------------------------------------

TP.dom.TemplatedNode.Type.defineMethod('tagCompile',
function(aRequest) {

    /**
     * @method tagCompile
     * @summary Convert the receiver into a format suitable for inclusion in a
     *     markup DOM. This type replaces the current node with the result of
     *     executing its template content.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     * @returns {Element} The new element.
     */

    var elem,
        id,

        wantsTemplateWrapper,

        replacement,
        replacementClone,

        canonicalName,

        resourceTPElem,
        resourceElem;

    //  Make sure that we have an element to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        return;
    }

    //  If we generated this element, then just return it.
    if (this.generatedNode(elem)) {
        return elem;
    }

    wantsTemplateWrapper = TP.ifInvalid(this.get('wantsTemplateWrapper'),
                                        false);

    if (wantsTemplateWrapper) {
        //  The process here is fairly direct. We create a surrogate
        //  tsh:template which replaces the receiver. That template tag is _not
        //  yet processed_ but is instrumented to know that it should replace
        //  itself with the result of running itself immediately. The
        //  TP.GENERATOR property gives the template a reference back to the
        //  original type which built it.
        replacement = TP.documentConstructElement(
                            TP.nodeGetDocument(elem),
                            'tsh:template',
                            TP.w3.Xmlns.TSH);

        canonicalName = TP.elementGetCanonicalName(elem);

        //  Set the name of the replacement and the 'generator name' to be the
        //  canonical name of the templated element. This is not the normal
        //  value of TP.GENERATOR, which is why we don't use
        //  TP.elementSetGenerator.
        TP.elementSetAttribute(
                replacement, 'tsh:name', canonicalName, true);
        replacement[TP.GENERATOR] = canonicalName;

        this.guessContentTypeAndLocation(elem);

        //  Migrate any child content to the template. That content will serve
        //  as fallback data should the src not be found, or not exist.
        TP.nodeMoveChildNodesTo(elem, replacement);

        //  Merge any remaining attributes. Note that we don't want to overwrite
        //  or duplicate any src attribute we had to compute.
        TP.elementMergeAttributes(elem, replacement);

        //  Remove any processing phase attribute migrated from the receiver...
        //  we'll let the processing engine worry about that.
        TP.elementRemoveAttribute(elem, 'tibet:phase', true);

    } else {

        canonicalName = TP.elementGetCanonicalName(elem);

        //  We didn't need a template wrapper - just fetch the resource content
        //  as indicated by the MIME type that should be in the element's
        //  'tibet:mime' attribute (if missing, the MIME type will be guessed).
        resourceTPElem = this.getResourceElement(
                            'template',
                            TP.elementGetAttribute(elem, 'tibet:mime', true));

        //  If no replacement came back we're dealing with likely problems in
        //  the template itself. Those should be notified via the prior call.
        if (TP.notValid(resourceTPElem)) {
            return;
        }

        //  Use the *native* mechanism to clone the Element here - otherwise,
        //  the wrapped element will try to return a wrapper and end up going
        //  through the whole cycle to create another wrapper element, etc.
        resourceElem = resourceTPElem.getNativeNode();
        replacementClone = TP.nodeCloneNode(resourceElem);

        //  Make sure that (almost) all of the expandos get copied to the clone.
        TP.nodeCopyTIBETExpandos(resourceElem, replacementClone, false);

        //  We've computed the generator, so (re)set it here. This is not the
        //  normal value of TP.GENERATOR, which is why we don't use
        //  TP.elementSetGenerator.
        replacementClone[TP.GENERATOR] = canonicalName;

        //  Merge any remaining attributes. Note that we don't want to overwrite
        //  or duplicate any src attribute we had to compute.
        TP.elementMergeAttributes(elem, replacementClone);

        //  One last thing...since this is a template we need to force any
        //  existing ID from the source element over any ID found on the
        //  template content. Template content will get IDs largely due to
        //  change notification semantics, but they should never take the place
        //  of IDs from the authored source.
        id = TP.elementGetAttribute(elem, 'id');
        if (TP.notEmpty(id)) {
            TP.elementSetAttribute(replacementClone, 'id', id);
        }

        replacement = replacementClone;
    }

    //  Replace the original element in the DOM so processing will continue in
    //  the proper context.
    replacement = TP.elementReplaceWith(elem, replacement, null, false);

    return replacement;
});

//  ========================================================================
//  TP.dom.EmbeddedTemplateNode
//  ========================================================================

/**
 * @type {TP.dom.EmbeddedTemplateNode}
 * @summary A trait type which allows the target type to have embedded elements
 *     of tsh:template under it.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('dom.EmbeddedTemplateNode');

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation.
TP.dom.EmbeddedTemplateNode.isAbstract(true);

//  ------------------------------------------------------------------------

TP.dom.EmbeddedTemplateNode.Type.defineMethod('tagAttachDOM',
function(aRequest) {

    /**
     * @method tagAttachDOM
     * @summary Sets up runtime machinery for the element in aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var elem,
        templateElems,
        ourID;

    //  Make sure that we have a node to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        //  TODO: Raise an exception
        return;
    }

    //  Grab all template elements
    if (TP.isEmpty(templateElems =
                    TP.nodeGetElementsByTagName(elem, 'tsh:template'))) {
        return elem;
    }

    //  Grab our ID (making sure we have one and generating/assigning one if
    //  we don't)
    ourID = TP.lid(elem, true);

    //  Note how we stamp a TP.GENERATOR of our ID onto individual template
    //  elements. This is not the normal value of TP.GENERATOR, which is why we
    //  don't use TP.elementSetGenerator.
    templateElems.perform(
        function(anElem) {

            var templateName,
                transformElem;

            if (TP.notEmpty(templateName = TP.elementGetAttribute(
                                                anElem, 'tsh:name', true))) {
                TP.uc(TP.TIBET_URN_PREFIX + templateName).setResource(null);
            }

            //  We are the TP.GENERATOR for these template elements.
            anElem[TP.GENERATOR] = ourID;

            transformElem = TP.tsh.template.wrapInTransformElement(
                                                            anElem, ourID);

            //  Note here that we don't have to capture the return value,
            //  since we're not doing anything with it.
            TP.nodeReplaceChild(anElem.parentNode,
                                transformElem,
                                anElem,
                                false);
        });

    return;
});

//  ========================================================================
//  TP.dom.EmptyElementNode
//  ========================================================================

/**
 * @type {TP.dom.EmptyElementNode}
 * @summary A trait type which allows the target type to be defined as 'empty'
 *     for purposes of setting content, etc.
 */

//  ------------------------------------------------------------------------

TP.dom.ElementNode.defineSubtype('dom.EmptyElementNode');

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation.
TP.dom.EmptyElementNode.isAbstract(true);

//  ------------------------------------------------------------------------

TP.dom.EmptyElementNode.Inst.defineMethod('getContent',
function(aRequest) {

    /**
     * @method getContent
     * @summary Returns the receiver's content.
     * @description Tags that trait-in this type are supposed to be "EMPTY",
     *     according to some definition (maybe a DTD or something). Therefore,
     *     for this type, this method does nothing and returns null.
     * @param {TP.sig.Request|TP.core.Hash} aRequest Optional control
     *     parameters.
     * @returns {null}
     */

    return null;
});

//  ------------------------------------------------------------------------

TP.dom.EmptyElementNode.Inst.defineMethod('setContent',
function(aContentObject, aRequest) {

    /**
     * @method setContent
     * @summary Sets the content of the receiver's native DOM counterpart to
     *     the value supplied.
     * @description Tags that trait-in this type are supposed to be "EMPTY",
     *     according to some definition (maybe a DTD or something). Therefore,
     *     for this type, this method does nothing and returns null.
     * @param {Object} aContentObject An object to use for content.
     * @param {TP.sig.Request} aRequest A request containing control parameters.
     * @returns {null}
     */

    return null;
});

//  ========================================================================
//  XML-RPC NODE FORMAT
//  ========================================================================

/**
 * @type {TP.dom.XMLRPCNode}
 * @summary A type capable of serializing data into XMLRPC format and of
 *     reconstituting XMLRPC-formatted XML nodes into JavaScript objects. This
 *     type is used as the primary "internal" TIBET data conversion type since
 *     TIBET's default XML format is XMLRPC.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('dom.XMLRPCNode');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  the value to use if nil support is turned on
TP.dom.XMLRPCNode.Type.defineConstant('NIL', '<nil/>');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.dom.XMLRPCNode.Type.defineMethod('fromArray',
function(anObj, filter, useNil) {

    /**
     * @method fromArray
     * @summary Returns a Node that represents anObj in the XML-RPC format.
     * @param {Object} anObj The object to format.
     * @param {TP.core.Hash} filter The filter parameters that determine which
     *     attributes of anObj to include in the output. The default is
     *     'unique_attributes'.
     * @param {Boolean} useNil Should null values be filled in with the
     *     non-standard nil?
     * @returns {Node} The receiver as an XML-RPC Node.
     */

    var nullVal,

        dataElem,

        len,
        i,
        valueElem,
        theValue,

        str,
        arrayElem;

    //  If we're using the NIL value, then use it for nulls, otherwise we
    //  use the empty String.
    if (TP.isTrue(useNil)) {
        nullVal = TP.documentFromString(this.NIL).documentElement;
    } else {
        nullVal = TP.XML_FACTORY_DOCUMENT.createTextNode('');
    }

    //  If the supplied object is not valid, return the value used for
    //  nulls.
    if (TP.notValid(anObj)) {
        return nullVal;
    }

    dataElem = TP.XML_FACTORY_DOCUMENT.createElement('data');

    //  Loop over the supplied object, creating a 'value' element for each
    //  value and appending that to the parent 'data' element.
    len = anObj.getSize();
    for (i = 0; i < len; i++) {
        valueElem = TP.XML_FACTORY_DOCUMENT.createElement('value');

        //  If the value is not valid, use the null value
        if (TP.notValid(theValue = anObj.at(i))) {
            //  Note reassignment since the node we're adding might have
            //  come from another document.
            nullVal = TP.nodeAppendChild(valueElem, nullVal);
        } else {
            //  Otherwise, the value is valid so ask it for its
            //  TP.dom.XMLRPCNode representation.
            try {
                TP.nodeAppendChild(valueElem,
                                    theValue.as('TP.dom.XMLRPCNode'));
            } catch (e) {
                if (TP.notValid(str = TP.str(e))) {
                    str = '!!! SERIALIZATION ERROR !!!';
                }

                TP.nodeAppendChild(valueElem, str.as('TP.dom.XMLRPCNode'));
            }
        }

        TP.nodeAppendChild(dataElem, valueElem);
    }

    //  Create an overall 'array' element and append the 'data' element to
    //  that.
    arrayElem = TP.XML_FACTORY_DOCUMENT.createElement('array');
    TP.nodeAppendChild(arrayElem, dataElem);

    return arrayElem;
});

//  ------------------------------------------------------------------------

TP.dom.XMLRPCNode.Type.defineMethod('fromBoolean',
function(anObj, filter, useNil) {

    /**
     * @method fromBoolean
     * @summary Returns a Node that represents anObj in the XML-RPC format.
     * @param {Object} anObj The object to format.
     * @param {TP.core.Hash} filter The filter parameters that determine which
     *     attributes of anObj to include in the output. The default is
     *     'unique_attributes'.
     * @param {Boolean} useNil Should null values be filled in with the
     *     non-standard nil?
     * @returns {Node} The receiver as an XML-RPC Node.
     */

    var booleanElem;

    booleanElem = TP.XML_FACTORY_DOCUMENT.createElement('boolean');

    //  The XML-RPC standard says that Boolean values are either '0' or '1',
    //  so we convert the supplied object into a Number before creating the
    //  text node around it.
    TP.nodeAppendChild(
            booleanElem,
            TP.XML_FACTORY_DOCUMENT.createTextNode(anObj.asNumber()));

    return booleanElem;
});

//  ------------------------------------------------------------------------

TP.dom.XMLRPCNode.Type.defineMethod('fromDate',
function(anObj, filter, useNil) {

    /**
     * @method fromDate
     * @summary Returns a Node that represents anObj in the XML-RPC format.
     * @param {Object} anObj The object to format.
     * @param {TP.core.Hash} filter The filter parameters that determine which
     *     attributes of anObj to include in the output. The default is
     *     'unique_attributes'.
     * @param {Boolean} useNil Should null values be filled in with the
     *     non-standard nil?
     * @returns {Node} The receiver as an XML-RPC Node.
     */

    var dateElem;

    dateElem = TP.XML_FACTORY_DOCUMENT.createElement('dateTime.iso8601');

    //  The XML-RPC standard says that Date values are always formatted
    //  according to ISO 8601 so we do that here (without YMD separators)
    TP.nodeAppendChild(
        dateElem,
        TP.XML_FACTORY_DOCUMENT.createTextNode(
            anObj.as('TP.iso.ISO8601',
                        TP.iso.ISO8601.FORMATS.at('YYYYMMDDTHH:MM:SS'))));

    return dateElem;
});

//  ------------------------------------------------------------------------

TP.dom.XMLRPCNode.Type.defineMethod('fromNumber',
function(anObj, filter, useNil) {

    /**
     * @method fromNumber
     * @summary Returns a Node that represents anObj in the XML-RPC format.
     * @param {Object} anObj The object to format.
     * @param {TP.core.Hash} filter The filter parameters that determine which
     *     attributes of anObj to include in the output. The default is
     *     'unique_attributes'.
     * @param {Boolean} useNil Should null values be filled in with the
     *     non-standard nil?
     * @returns {Node} The receiver as an XML-RPC Node.
     */

    var numberElem;

    //  If the value of the supplied object when rounded is the same as the
    //  object itself, then its an integer - otherwise, its a double.
    if (anObj.round() === anObj) {
        numberElem = TP.XML_FACTORY_DOCUMENT.createElement('i4');
    } else {
        numberElem = TP.XML_FACTORY_DOCUMENT.createElement('double');
    }

    TP.nodeAppendChild(
        numberElem,
        TP.XML_FACTORY_DOCUMENT.createTextNode(anObj.toString()));

    return numberElem;
});

//  ------------------------------------------------------------------------

TP.dom.XMLRPCNode.Type.defineMethod('fromObject',
function(anObj, useNil) {

    /**
     * @method fromObject
     * @summary Returns an instance that encodes anObj in the format according
     *     to the type description.
     * @param {Object} anObj The object to format.
     * @param {Boolean} useNil Should null values be filled in with the
     *     non-standard nil?
     * @returns {Node} An instance of a Node with anObj encoded according to
     *     this format.
     */

    var nullVal,

        structElem,

        k,
        len,
        i,

        theValue,

        memberElem,
        nameElem,

        str,

        valueElem;

    //  If we're using the NIL value, then use it for nulls, otherwise we
    //  use the empty String.
    if (TP.isTrue(useNil)) {
        nullVal = TP.documentFromString(this.NIL).documentElement;
    } else {
        nullVal = TP.XML_FACTORY_DOCUMENT.createTextNode('');
    }

    //  If the supplied object is not valid, return the value used for
    //  nulls.
    if (TP.notValid(anObj)) {
        return nullVal;
    }

    structElem = TP.XML_FACTORY_DOCUMENT.createElement('struct');

    k = anObj.getKeys().sort();

    //  Loop over the keys of the supplied object, creating a 'member'
    //  element for each key/value pair and appending that to the parent
    //  'struct' element.
    len = k.getSize();
    for (i = 0; i < len; i++) {
        memberElem = TP.XML_FACTORY_DOCUMENT.createElement('member');

        //  Create a 'name' element to hold the key name and append it to
        //  the parent 'member' element.
        nameElem = TP.XML_FACTORY_DOCUMENT.createElement('name');

        str = k.at(i);

        TP.nodeAppendChild(
                nameElem,
                TP.XML_FACTORY_DOCUMENT.createTextNode(str));

        //  Note reassignment since the node we're adding might have come
        //  from another document.
        nameElem = TP.nodeAppendChild(memberElem, nameElem);

        //  Create a 'value' element to hold the key name and append it to
        //  the parent 'member' element.
        valueElem = TP.XML_FACTORY_DOCUMENT.createElement('value');

        //  If the value is not valid, use the null value
        if (TP.notValid(theValue = anObj.at(k.at(i)))) {
            TP.nodeAppendChild(valueElem, nullVal);
        } else {
            //  Otherwise, the value is valid so ask it for its
            //  TP.dom.XMLRPCNode representation.
            try {
                TP.nodeAppendChild(valueElem,
                                    theValue.as('TP.dom.XMLRPCNode'));
            } catch (e) {
                if (TP.notValid(str = TP.str(e))) {
                    str = '!!! SERIALIZATION ERROR !!!';
                }

                TP.nodeAppendChild(valueElem, str.as('TP.dom.XMLRPCNode'));
            }
        }

        TP.nodeAppendChild(memberElem, valueElem);

        TP.nodeAppendChild(structElem, memberElem);
    }

    return structElem;
});

//  ------------------------------------------------------------------------

TP.dom.XMLRPCNode.Type.defineMethod('fromString',
function(anObj, filter, useNil) {

    /**
     * @method fromString
     * @summary Returns a Node that represents anObj in the XML-RPC format.
     * @param {Object} anObj The object to format.
     * @param {TP.core.Hash} filter The filter parameters that determine which
     *     attributes of anObj to include in the output. The default is
     *     'unique_attributes'.
     * @param {Boolean} useNil Should null values be filled in with the
     *     non-standard nil?
     * @returns {Node} The receiver as an XML-RPC Node.
     */

    var stringElem;

    stringElem = TP.XML_FACTORY_DOCUMENT.createElement('string');

    //  note the encoding of literals to entities here to avoid issues
    TP.nodeAppendChild(
        stringElem,
        TP.XML_FACTORY_DOCUMENT.createTextNode(
            TP.xmlLiteralsToEntities(
                TP.htmlEntitiesToXMLEntities(anObj.asString()))));

    return stringElem;
});

//  ------------------------------------------------------------------------

TP.dom.XMLRPCNode.Type.defineMethod('fromTP_core_Hash',
function(anObj, filter, useNil) {

    /**
     * @method fromTP_core_Hash
     * @summary Returns a Node that represents anObj in the XML-RPC format.
     * @param {Object} anObj The object to format.
     * @param {TP.core.Hash} filter The filter parameters that determine which
     *     attributes of anObj to include in the output. The default is
     *     'unique_attributes'.
     * @param {Boolean} useNil Should null values be filled in with the
     *     non-standard nil?
     * @returns {Node} The receiver as an XML-RPC Node.
     */

    return this.fromObject(anObj, filter, useNil);
});

//  ------------------------------------------------------------------------

TP.dom.XMLRPCNode.Type.defineMethod('objectFromNode',
function(aNode) {

    /**
     * @method objectFromNode
     * @summary Returns aNode as a TIBET/JavaScript object.
     * @param {Node} aNode The Node to reconstitute into a JavaScript object.
     * @returns {Object|undefined} The TIBET/JavaScript object that was
     *     reconstituted from the supplied Node.
     */

    var len,
        i,
        key,
        val,
        inst,
        str,
        node,
        member,
        members,
        tagType,
        tagChild;

    if (!TP.isNode(aNode)) {
        return;
    }

    //  often provided a document element, we need to drill down to content
    if (!TP.isElement(aNode)) {
        node = aNode.firstChild;
    } else {
        node = aNode;
    }

    tagType = TP.elementGetLocalName(node);
    tagChild = node.firstChild;

    //  since we're dealing with primitive nodes we'll just go with a
    //  simple procedural mechanism here rather than trying to do an OO
    //  approach here
    switch (tagType) {
        case 'array':

            //  note that we want to avoid any text nodes here...
            tagChild = TP.nodeGetChildElementAt(node, 0);

            if (TP.isNode(tagChild) &&
                TP.elementGetLocalName(tagChild) === 'data') {
                //  valid data structure embedded in array tag...append
                //  each child element of the 'data' tag (which will be
                //  value tags containing data of various formats) into
                //  an array
                inst = TP.ac();
                members = TP.nodeGetChildElements(tagChild);

                len = members.getSize();
                for (i = 0; i < len; i++) {
                    member = members.at(i);

                    if (TP.elementGetLocalName(member) === 'value') {
                        inst.add(this.objectFromNode(member));
                    }
                }
                return inst;
            } else {
                //  no nested data tag
                return this.raise('InvalidTP.dom.XMLRPCNode',
                                    node);
            }

        case 'base64':

            if (TP.isNode(tagChild)) {
                str = TP.str(tagChild.nodeValue);

                try {
                    //  Mozilla can be very touchy about this function if
                    //  the data isn't actually encoded properly
                    return TP.atob(str);
                } catch (e) {
                    return str;
                }
            } else {
                return null;
            }

        case 'boolean':

            return TP.isNode(tagChild) ? tagChild.nodeValue === 1 : null;

        case 'dateTime.iso8601':

            return TP.isNode(tagChild) ?
                        Date.fromString(tagChild.nodeValue) : null;

        case 'double':
        case 'int':
        case 'i4':

            return TP.isNode(tagChild) ?
                        TP.nc(tagChild.nodeValue) : null;

        case 'string':

            //  note the TP.xmlEntitiesToLiterals() call here to reverse the
            //  encoding process which needs to escape them
            return TP.isNode(tagChild) ?
                TP.str(TP.xmlEntitiesToLiterals(tagChild.nodeValue)) : null;

        case 'struct':

            //  structs will contain 0 or more member elements containing
            //  a 'name' and a 'value'. iterating across the members and
            //  adding their values under the names will rebuild the inst
            inst = TP.hc();
            members = TP.nodeGetChildElements(node);

            len = members.getSize();
            for (i = 0; i < len; i++) {
                member = members.at(i);

                if (TP.elementGetLocalName(member) === 'member') {
                    //  note that we want to avoid any text nodes here...
                    key = TP.nodeGetChildElementAt(member, 0);
                    val = TP.nodeGetChildElementAt(member, 1);

                    inst.atPut(key.firstChild.nodeValue,
                                this.objectFromNode(val));
                }
            }

            return inst;

        case 'value':

            //  value tags will either contain a child tag, or a string
            //  value (not consistent here since the string tag isn't
            //  required...presumably that's to make things easier by
            //  creating special cases in encoding ;)

            //  note that we want to avoid any text nodes here...
            tagChild = TP.nodeGetChildElementAt(node, 0);

            if (TP.isNode(tagChild)) {
                //  embedded tag so we can ignore the 'value' wrapper
                return this.objectFromNode(tagChild);
            } else {
                //  embedded string but no string tag...
                tagChild = node.firstChild;

                return TP.isNode(tagChild) ?
                            TP.str(tagChild.nodeValue) : null;
            }

        default:

            return this.raise('InvalidTP.dom.XMLRPCNode', node);
    }
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETUIDOMTypes.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @type {TP.dom.UIElementNode}
 * @summary TP.dom.UIElementNode is the common supertype for all UI node
 *     types. In particular, this includes the entire html: tree and most of
 *     the xctrls: namespace, which constitute the majority of UI nodes in
 *     TIBET.
 */

//  ========================================================================
//  TP.dom.UIElementNode
//  ========================================================================

TP.dom.ElementNode.defineSubtype('UIElementNode');

//  need a node of a specific subtype, almost always a node in a specific
//  namespace such as html:
TP.dom.UIElementNode.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  The map of keys to signals for any keybindings for this type.
TP.dom.UIElementNode.Type.defineAttribute('keybindings');

//  Whether or not resources like style are inlined
TP.dom.UIElementNode.Type.defineAttribute('resourcesInlined');

//  The Array of loaded stylesheet element GIDs
TP.dom.UIElementNode.Type.defineAttribute('loadedStylesheetDocumentGIDs');

//  The attributes that are toggleable on this type and subtypes. By default,
//  no states are toggleable.
TP.dom.UIElementNode.Type.defineAttribute('toggleableStateNames', TP.ac());

//  A TP.core.Hash of 'required attributes' that should be populated on all
//  new instances of the tag.
TP.dom.UIElementNode.Type.defineAttribute('requiredAttrs');

//  Note how these properties are TYPE_LOCAL, by design.

//  The TP.dom.UIElementNode that focus is moving to, based on TIBET
//  calculations.
TP.dom.UIElementNode.defineAttribute('$calculatedFocusingTPElem');

//  The Element that the system is trying to move the focus to because we're
//  manually focusing on an Element, but which TIBET will do its best to prevent
//  in favor of the TIBET-calculated element (i.e. focus/blur events are not
//  cancellable - sigh).
TP.dom.UIElementNode.defineAttribute('$manuallyFocusingElement');
TP.dom.UIElementNode.defineAttribute('$manuallyBlurringElement');

//  The currently calculated focus context
TP.dom.UIElementNode.defineAttribute('$calculatedFocusContext');

//  Whether or not focus is shifting because of a mouse click/down/up
TP.dom.UIElementNode.defineAttribute('$focusingViaMouseEvent');

//  The element that was the last activated.
TP.dom.UIElementNode.defineAttribute('$lastActiveElement');

//  Whether or not we're switching focus contexts in an asynchronous fashion.
TP.dom.UIElementNode.defineAttribute('$asyncSwitchingContexts');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('$addStylesheetResource',
function(aDocument, sheetElemID, aStyleURI) {

    /**
     * @method $addStylesheetResource
     * @summary Finds the receiver's stylesheet resource and adds to the
     *     supplied document. If the stylesheet is already present, this method
     *     will *not* add another instance.
     * @param {Document} aDocument Document to add the stylesheet resource to.
     * @param {String} sheetElemID The ID to use as the stylesheet element ID.
     * @param {String} aStyleURI The stylesheet URI to use as the source of the
     *     style content.
     * @returns {Element|undefined} The newly inserted style element containing
     *     the stylesheet resource or null if no new style element was added
     *     because an existing one was found.
     * @exception TP.sig.InvalidDocument Raised when an invalid Document is
     *     provided to the method.
     */

    var styleURI,
        styleLoc,

        styleElem,

        docHead,
        existingStyleElems,
        insertionPoint,

        inlined,

        inlinedStyleElem,
        fetchOptions,
        inlineStyleContent,

        insertedStyleElem;

    if (!TP.isDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  First, see if another occurrence of this UI element node (and which
    //  uses this same stylesheet) has already been processed and has placed
    //  that stylesheet in the document. We don't want the same stylesheet
    //  placed into the document over and over for each occurrence of the
    //  same type of element node.
    if (TP.isElement(styleElem = TP.byId(sheetElemID, aDocument, false))) {
        return;
    }

    //  Capture this into a local since we may reassign it below.
    styleURI = aStyleURI;

    styleLoc = styleURI.getLocation();

    //  Make sure we have a 'head' element and query it for existing 'style'
    //  elements.
    docHead = TP.documentEnsureHeadElement(aDocument);

    //  Initially, set insertionPoint to null (which is the same as doing an
    //  append child).
    insertionPoint = null;

    //  Start by looking for style elements that have a 'tibet:originalhref' on
    //  them - these will have been placed here by the system as part of
    //  processing, possibly inline processing. Note that we make sure to go
    //  after only HTML style elements here.
    existingStyleElems = TP.byCSSPath('> html|style[tibet|originalhref]',
                                        docHead,
                                        false,
                                        false);

    //  If we found one, use the *nextSibling* after the last one as the
    //  insertion point (i.e. the place where we want to 'insert before').
    if (TP.notEmpty(existingStyleElems)) {
        insertionPoint = existingStyleElems.last().nextSibling;
    } else {

        //  Otherwise, if there were existing style elements (without a
        //  'tibet:originalhref they were most likely hand authored by the page
        //  author), we choose the first one as our insertion point.

        //  This is done because stylesheets added using this mechanism should
        //  come before any further stylesheet elements in the page, which have
        //  probably been added by the page author to further customize the
        //  style and that style should have higher precedence than the style
        //  we're adding here.
        existingStyleElems = TP.nodeGetElementsByTagName(docHead, 'style');

        if (TP.notEmpty(existingStyleElems)) {
            insertionPoint = existingStyleElems.first();
        }
    }

    //  If the system is running with inlined resources we create 'style'
    //  elements rather than 'link' elements for CSS files.
    inlined = TP.uriIsInlined(styleLoc, this);

    //  We don't support packaging for other kinds of files besides pure CSS.
    //  Other styling languages (i.e. LESS) must be translated into native CSS
    //  in order to take advantage of inlined mode.
    if (styleURI.getMIMEType() !== TP.CSS_TEXT_ENCODED) {
        inlined = false;
    }

    //  We track whether our resources are inlined or not.
    this.set('resourcesInlined', inlined, false);

    if (inlined) {

        //  First, see if we've processed this style URI before. Note that we
        //  make sure to go after only HTML style elements here.
        inlinedStyleElem = TP.byCSSPath('html|style[tibet|originalhref=' +
                                            '"' +
                                            styleURI.getOriginalSource() +
                                            '"]',
                                        aDocument,
                                        true,
                                        false);

        //  If so, we can just exit here.
        if (TP.isElement(inlinedStyleElem)) {
            return;
        }

        //  Fetch content from the URI's resource

        //  Note how we force 'refresh' to false, since we'll be reading
        //  from inlined content.
        fetchOptions = TP.hc('async', false,
                                'resultType', TP.TEXT,
                                'refresh', false);
        inlineStyleContent = styleURI.getResource(fetchOptions).get('result');

        //  Set the content of a new style element that contains the inlined
        //  style, resolving @import statements and possible rewriting
        //  CSS url(...) values.
        inlinedStyleElem = TP.documentInlineCSSURIContent(
                                        aDocument,
                                        styleURI,
                                        inlineStyleContent,
                                        insertionPoint);

        if (TP.notEmpty(sheetElemID)) {

            //  Make sure also to set the style element's 'id' attribute, so
            //  that the above 'uniquing' logic will work for future occurrences
            //  of this element being processed (which ensures that we don't add
            //  the same element more than once).
            TP.elementSetAttribute(inlinedStyleElem,
                                    'id',
                                    sheetElemID,
                                    true);
        }

        insertedStyleElem = inlinedStyleElem;

    } else {

        //  Otherwise, since it very well may have TIBET-isms (i.e. be a 'TIBET
        //  CSS' kind of CSS)  - set up a 'tibet:style' element, with a type
        //  that denotes that, and let the processing machinery handle it.
        styleElem = TP.documentConstructElement(
                        aDocument,
                        'tibet:style',
                        TP.w3.Xmlns.TIBET);

        TP.elementSetAttribute(styleElem, 'href', styleLoc, true);
        TP.elementSetAttribute(styleElem, 'type', TP.ietf.mime.TIBET_CSS, true);

        //  Make sure also to set the style element's 'id' attribute, so that
        //  the above 'uniquing' logic will work for future occurrences of this
        //  element being processed (which ensures that we don't add the same
        //  element more than once).

        //  Note also how we do this *before* we insert/awaken the content - if
        //  the system hasn't started and the content needs to be awakened (see
        //  below), the awaken machinery will set up an observation on this
        //  element's URI - we want that to be set up using the proper ID.
        TP.elementSetAttribute(styleElem, 'id', sheetElemID, true);

        //  Make sure to set the 'shouldAwake' parameter to the inverse of
        //  whether the system has started or not. This is because, if the
        //  system has already started, the MutationObserver machinery will take
        //  care of awakening this content (i.e. the 'tibet:style' element) but
        //  if it hasn't already started, then we need to do that manually.

        //  Go ahead and insert the new element - note here how we *always*
        //  awaken the content. Because we could be being called as part of an
        //  asychronous populating of the page, it's impossible to tell if we're
        //  already part of an awaken cycle or not. But, because of our check
        //  above to determine whether we already exist, we don't have to worry
        //  about multiple awakenings.
        styleElem = TP.nodeInsertBefore(docHead,
                                        styleElem,
                                        insertionPoint,
                                        true);

        if (TP.isElement(styleElem)) {

            insertedStyleElem = styleElem;

            //  Track the original source from the URI - this is what the author
            //  originally typed and might be a virtual URI. We'd like to track
            //  it here.
            TP.elementSetAttribute(styleElem,
                                    'tibet:originalhref',
                                    styleURI.getOriginalSource(),
                                    true);
        }
    }

    //  Stamp our TIBET type name onto the newly created style element.
    TP.elementSetAttribute(
        insertedStyleElem, 'tibet:type', TP.name(this), true);

    return insertedStyleElem;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('addStylesheetTo',
function(aDocument) {

    /**
     * @method addStylesheetTo
     * @summary Adds the receiver's stylesheet to the supplied document. If the
     *     stylesheet is already present, this method will *not* add another
     *     instance.
     * @param {Document} aDocument Document to add the stylesheet to.
     * @exception TP.sig.InvalidDocument Raised when an invalid Document is
     *     provided to the method.
     * @returns {TP.meta.dom.UIElementNode} The receiver.
     */

    var computeObservationID,

        ourID,
        themeName,

        themeNewStyleElem,
        newStyleElem,

        styleURI,

        resourceTypeName,

        observeID,

        projectThemes,
        libThemes,
        allThemes,

        len,
        i,

        doc,

        styleElemToObserve,
        inlined;

    if (!TP.isDocument(aDocument)) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    computeObservationID = function(aStyleElem) {

        var tagName;

        //  If a 'tibet:style' element is being inserted, then that means that
        //  we're executing in a non-inlined environment that will allow
        //  alternate style content (like LESS) to be brought in directly.
        tagName = TP.elementGetFullName(aStyleElem);
        if (tagName === 'tibet:style') {
            //  The *real* stylesheet that will eventually come in when the LESS
            //  or whatever is finished processing will be the ID with the word
            //  '_generated' appended to it.
            return TP.elementGetAttribute(aStyleElem, 'id', true) +
                    '_generated';
        }

        return TP.elementGetAttribute(aStyleElem, 'id', true);
    };

    //  Add any theme name we might be using. The presumption is that a theme
    //  sheet that isn't standalone will @import what it requires.

    //  Note that we try to see if the document already has a theme, which will
    //  override any application-level theme (which is computed from the current
    //  UI canvas document or system properties if a theme cannot be found
    //  there). Note that this will be either the 'project' theme or the 'lib'
    //  theme. If the 'project' theme cannot be found, then by passing true as
    //  the second parameter, the 'lib' theme will be returned, if it can be
    //  found.
    if (TP.isEmpty(themeName = TP.documentGetTheme(aDocument, true))) {
        themeName = TP.sys.getApplication().getTheme();
    }

    //  Add the core stylesheet for the receiver. Note that we supply ourID for
    //  both the unique identifier for the receiver and as the element ID to use
    //  for this stylesheet.
    styleURI = this.getResourceURI('style', TP.ietf.mime.CSS);

    //  The resource type name is usually the type name, but can be overridden
    //  for special types that need to supply a different name here for use in
    //  resource location computations.
    resourceTypeName = this.getResourceTypeName();

    //  If the style URI contains the resource type name, then the stylesheet is
    //  specific to this type. Otherwise, it applies to all types in this
    //  namespace.
    if (styleURI.getLocation().contains(resourceTypeName)) {
        ourID = TP.escapeTypeName(resourceTypeName);
    } else {
        ourID = TP.escapeTypeName(this.getNamespaceObject().getName()) + '_NS';
    }

    if (TP.isValid(styleURI) && styleURI !== TP.NO_RESULT) {
        newStyleElem = this.$addStylesheetResource(
                                aDocument, ourID, styleURI);
    }

    observeID = null;

    //  If there is a theme, add the corresponding them stylesheet for the
    //  receiver.
    if (TP.notEmpty(themeName)) {

        //  Grab the resource URI for the theme. Note here how we specify no
        //  fallback for the resource URI, because .
        styleURI = this.getResourceURI(
                            'style_' + themeName, TP.ietf.mime.CSS, false);

        //  The themeing resource specifically indicated that it has no result,
        //  so we skip any themeing fallback here
        if (styleURI === TP.NO_RESULT) {
            //  empty
        } else {

            //  Otherwise, we were meant to get a meaningful result, but didn't.
            //  Let's try iterating through all of the other themes that the
            //  system knows about and see if there's a defined URI that
            //  matches.
            if (TP.notValid(styleURI)) {
                TP.ifWarn() ?
                    TP.warn(
                        'Couldn\'t compute a theme URI for type: ' +
                        this.getName() +
                        ' and theme: ' +
                        themeName +
                        '. Attempting fallback.') : 0;

                //  Grab all of the 'project' and 'lib' themes.
                projectThemes = TP.sys.getcfg('project.theme.list');
                libThemes = TP.sys.getcfg('tibet.theme.list');

                //  If we had a real set of 'project' themes, then copy them and
                //  set all themes to that. This allows us to consider each
                //  project theme, in order.
                if (TP.isArray(projectThemes)) {
                    allThemes = TP.copy(projectThemes);
                } else {
                    //  Otherwise, set all themes to an empty Array.
                    allThemes = TP.ac();
                }

                //  If we have 'lib' themes, then we'll consider them after all
                //  of the project themes, again in the order in which they were
                //  defined.
                if (TP.isArray(libThemes)) {
                    allThemes = allThemes.concat(TP.copy(libThemes));
                }

                //  Iterate over all of the themes. If there is a defined URI
                //  for the receiver and theme, then break.
                len = allThemes.getSize();
                for (i = 0; i < len; i++) {
                    styleURI = this.getResourceURI(
                                    'style_' + allThemes.at(i),
                                    TP.ietf.mime.CSS,
                                    false);
                    if (TP.isValid(styleURI)) {
                        break;
                    }
                }
            }

            //  Got a valid style URI? Use it.
            if (TP.isValid(styleURI)) {
                themeNewStyleElem = this.$addStylesheetResource(
                                        aDocument,
                                        ourID + '_' + themeName,
                                        styleURI);

                if (TP.isElement(themeNewStyleElem)) {
                    //  if we inserted a new style element for the theme
                    //  stylesheet, set the new style element to be that style
                    //  element.
                    newStyleElem = themeNewStyleElem;
                }
            }
        }
    }

    //  if we inserted a new style element for either the core or theme
    //  stylesheet, set the observation ID using the style element inserted for
    //  the core sheet
    if (TP.isElement(newStyleElem)) {
        observeID = computeObservationID(newStyleElem);
    }

    //  If we computed a valid observation ID, then set up the necessary
    //  observations.
    if (TP.isValid(observeID)) {

        doc = TP.nodeGetDocument(newStyleElem);

        //  If we can't find the style element that matches the observation ID,
        //  then we set up a subtree query to notify us when that element is
        //  created.
        styleElemToObserve = TP.byId(observeID, doc, false);

        inlined = TP.isTrue(this.get('resourcesInlined'));

        if (!TP.isElement(styleElemToObserve)) {

            //  We register a query that, if any subtree mutations occur under
            //  the new style element's document element, to notify any
            //  instances of this type know that the stylesheet (one that they
            //  probably rely on to render) is available.

            //  Note that this calls our 'mutationAddedFilteredNodes' method
            //  below with just the nodes that got added or removed.
            TP.core.MutationSignalSource.addSubtreeQuery(
                                                this,
                                                TP.cpc('#' + observeID),
                                                doc);
        } else if (inlined) {

            //  If the resources are inlined, then we notify any existing
            //  instances of this type that the stylesheet has already been
            //  loaded (since loading inlined resources is a synchronous
            //  operation).
            this.$notifyInstancesThatStylesheetLoaded(
                                        TP.wrap(styleElemToObserve));
        } else {

            //  Set up a notification that will let any instances of this type
            //  know that the stylesheet (one that they probably rely on to
            //  render) is available.
            this.$notifyInstancesWhenStylesheetLoaded(
                                        TP.wrap(styleElemToObserve));
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('canHandleKey',
function(aSignal, anEvent) {

    /**
     * @method canHandleKey
     * @summary Whether or not the receiver can be handle the key that
     *     generated the supplied event.
     * @param {aSignal} aSignal A signal containing key information or an actual
     *     key name.
     * @param {Event} anEvent The native event that was triggered.
     * @returns {Boolean} Whether or not the receiver can handle the key.
     */

    var sigNames,

        len,
        i,

        keyname;

    sigNames = aSignal.getSignalNames();

    len = sigNames.getSize();
    for (i = 0; i < len; i++) {

        //  Compute the key name by slicing off everything up through the last
        //  period ('.'). I.e. the 'TP.sig.'.
        keyname = sigNames.at(i).slice(sigNames.at(i).lastIndexOf('.') + 1);

        switch (keyname) {

            //  These are the standard keys used for activating.

            case 'DOM_Enter_Down':
            case 'DOM_Enter_Up':

                return true;

            default:
                //  Look in the keybindings map. If there's an entry there,
                //  then we handle the key.
                if (TP.notEmpty(this.getKeybinding(keyname, anEvent))) {
                    return true;
                }
        }
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('populateCompilationAttrs',
function(aRequest, anElement) {

    /**
     * @method populateCompilationAttrs
     * @summary Populates attributes on the element that is produced by this
     *     type when it is compiled.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     * @param {Element} anElement The element to populate the attributes onto.
     * @returns {TP.meta.dom.UIElementNode} The receiver.
     */

    var reqAttrs,

        sources,
        sourceElem,

        classes;

    //  Make sure that we have an element to work from.
    if (!TP.isElement(anElement)) {
        return null;
    }

    //  If the type has specified 'required attributes' that need to be
    //  populated on all new tag instances, then do that here.
    if (TP.notEmpty(reqAttrs = this.get('requiredAttrs'))) {
        TP.elementSetAttributes(anElement, reqAttrs, true);
    }

    //  If we have source elements, grab the first one and get it's 'class name'
    //  values.
    if (TP.isArray(sources = aRequest.getPayload().at('sources'))) {
        if (TP.isElement(sourceElem = sources.first())) {
            classes = TP.elementGetAttribute(sourceElem, 'class').split(' ');
        }
    }

    //  If we have class names, add them to the destination element if they're
    //  not already there.
    if (TP.isArray(classes)) {
        classes.forEach(
                function(aClassName) {
                    //  This will only add the class if it isn't already there.
                    TP.elementAddClass(anElement, aClassName);
                });
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('getKeybinding',
function(keyname, anEvent) {

    /**
     * @method getKeybinding
     * @summary Returns a unique binding for a TIBET keyname by seaching the
     *     receiver's type inheritance chain for a matching binding.
     * @param {String} keyname The name of the key such as DOM_Ctrl_Z_Down.
     * @param {Event} anEvent The native event that was triggered.
     * @returns {String|undefined} A signal name if a matching binding is found.
     */

    var map,
        sigName,
        ancestor;

    map = this.getKeybindings();
    if (TP.isValid(map)) {
        sigName = map.at(keyname);
        if (TP.notEmpty(sigName)) {
            return sigName;
        }
    }

    ancestor = this.getSupertype();
    if (TP.canInvoke(ancestor, 'getKeybinding')) {
        return ancestor.getKeybinding(keyname, anEvent);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('getKeybindings',
function() {

    /**
     * @method getKeybindings
     * @summary Returns the receiving type's unique keybinding map. This is a
     *     hash containing the specific bindings made for this particular type.
     *     Note that you cannot use this map to see all available mappings since
     *     it does not attempt to capture data from supertype maps. Use
     *     canHandleKey and/or getKeybinding to check for specific signal
     *     mappings for a key since those methods will iterate up through the
     *     supertype maps in an attempt to find a viable map entry.
     * @returns {TP.core.Hash|null} The key bindings map or null.
     */

    return this.$get('keybindings');
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('isOpaqueCapturerFor',
function(anElement, aSignal, signalNames) {

    /**
     * @method isOpaqueCapturerFor
     * @summary Returns whether the elements of this type are considered to be
     *     an 'opaque capturer' for the supplied signal (i.e. it won't let the
     *     signal 'descend' further into its descendant hierarchy). This means
     *     that they will handle the signal themselves and not allow targeted
     *     descendants underneath them to handle it.
     * @description At this level, the supplied element is checked to see if it
     *     can handle a particular key signal. If so, it is considered to be an
     *     opaque capturer.
     * @param {Element} anElem The element to check for the
     *     'tibet:opaque-capturing' attribute.
     * @param {String} aSignalName The signal to check.
     * @param {String[]} [signalNames] The list of signal names to use when
     *     computing opacity for the signal. This is an optional parameter. If
     *     this method needs the list of signal names and this parameter is not
     *     provided, it can be derived from the supplied signal itself.
     * @returns {Boolean} Whether or not the receiver is opaque during the
     *     capture phase for the signal.
     */

    //  If it's a keyboard signal, we test to see if it can handle the key. If
    //  so, then this type can be considered an 'opaque capturer' for the
    //  supplied key signal.
    if (TP.isKindOf(aSignal, TP.sig.DOMKeySignal)) {
        if (this.canHandleKey(aSignal, aSignal.getPayload())) {
            return true;
        }
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('getLoadedStylesheetDocumentGIDs',
function() {

    /**
     * @method getLoadedStylesheetDocumentGIDs
     * @summary Returns an Array of Document global IDs where the 'main'
     *     stylesheet of this type (either it's core stylesheet or it's themed
     *     stylesheet if the receiver is executing in a themed environment) is
     *     currently installed.
     * @returns {String[]} The Array of Document global IDs.
     */

    var gids;

    gids = this.$get('loadedStylesheetDocumentGIDs');

    if (TP.notValid(gids)) {
        gids = TP.ac();
        this.$set('loadedStylesheetDocumentGIDs', gids, false);
    }

    return gids;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('isResponderForUIFocusChange',
function(aNode, aSignal) {

    /**
     * @method isResponderForUIFocusChange
     * @summary Returns true if the node has a 'tabindex' attribute (but not if
     *     it has a 'disabled' attribute) to match (X)HTML semantics.
     * @param {Node} aNode The node to check which may have further data as to
     *     whether this type should be considered to be a responder.
     * @param {TP.sig.Signal} aSignal The signal that responders are being
     *     computed for.
     * @returns {Boolean} True when the receiver should respond to aSignal.
     */

    return TP.elementHasAttribute(aNode, 'tabindex', true) &&
            !TP.elementHasAttribute(aNode, 'disabled', true);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('isResponderForUIFocusComputation',
function(aNode, aSignal) {

    /**
     * @method isResponderForUIFocusComputation
     * @summary Returns true if the node has a 'tabindex' attribute (but not if
     *     it has a 'disabled' attribute) to match (X)HTML semantics.
     * @param {Node} aNode The node to check which may have further data as to
     *     whether this type should be considered to be a responder.
     * @param {TP.sig.Signal} aSignal The signal that responders are being
     *     computed for.
     * @returns {Boolean} True when the receiver should respond to aSignal.
     */

    return TP.elementHasAttribute(aNode, 'tabindex', true) &&
            !TP.elementHasAttribute(aNode, 'disabled', true);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('mutationAddedFilteredNodes',
function(addedNodes, queryInfo) {

    /**
     * @method mutationAddedFilteredNodes
     * @summary Handles when nodes got added to the DOM we're in, filtered by
     *     the query that we registered with the MutationSignalSource.
     * @param {Node[]} addedNodes The Array of nodes that got added to the DOM,
     *     then filtered by our query.
     * @param {TP.core.Hash} queryInfo Information that was registered for this
     *     query when it was originally set up.
     * @returns {TP.meta.dom.UIElementNode} The receiver.
     */

    var queryStr,
        queryID,

        len,
        i,

        addedNodeID;

    //  The query will be a CSS 'ID query' path object.
    queryStr = queryInfo.at('path').asString();

    //  Slice off the '#'.
    queryID = queryStr.slice(1);

    //  Iterate over all of the added nodes.
    len = addedNodes.getSize();
    for (i = 0; i < len; i++) {
        if (TP.isElement(addedNodes.at(i))) {

            //  Iterate over all of the added nodes. If the Node is an Element
            //  and it's ID matches that of the queryID, then set up a
            //  notification that will let any instances of this type know that
            //  the stylesheet (one that they probably rely on to render) is
            //  available.
            addedNodeID = TP.elementGetAttribute(addedNodes.at(i), 'id', true);
            if (addedNodeID === queryID) {

                this.$notifyInstancesWhenStylesheetLoaded(
                                                TP.wrap(addedNodes.at(i)));
            }
        }
    }

    TP.core.MutationSignalSource.removeSubtreeQuery(this);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('$notifyInstancesThatStylesheetLoaded',
function(styleTPElem) {

    /**
     * @method $notifyInstancesThatStylesheetLoaded
     * @summary Notifies instances of the receiver that the stylesheet that they
     *     (probably) rely on to render is available.
     * @param {TP.html.style} styleTPElem The stylesheet element that got
     *     loaded.
     * @returns {TP.meta.dom.UIElementNode} The receiver.
     */

    var body,

        gids,
        notReadyToRenderInstances;

    //  Grab the body and, if its a real Element, then reset the CSS rule caches
    //  of all of the elements in it.
    body = TP.documentGetBody(styleTPElem.getNativeDocument());
    if (TP.isElement(body)) {
        TP.elementResetAppliedNativeStyleRules(body);
    }

    //  Grab all of the existing instances in that document and then iterate
    //  and notify them.
    notReadyToRenderInstances = TP.byCSSPath(
                            this.getQueryPath(true, true),
                            styleTPElem.getNativeDocument(),
                            false,
                            true);

    //  Filter out any instances that are already ready to render. No sense in
    //  sending them a method that might do things like cause extra rendering.
    notReadyToRenderInstances = notReadyToRenderInstances.filter(
        function(anInstance) {
            return anInstance.isReadyToRender();
        });

    //  Add the Document global ID of the stylesheet Element to our list of
    //  where the stylesheet has been successfully installed.
    gids = this.get('loadedStylesheetDocumentGIDs');
    gids.push(styleTPElem.getDocument().getGlobalID());
    gids.unique();

    notReadyToRenderInstances.forEach(
        function(aTPElem) {
            aTPElem.stylesheetReady(styleTPElem);
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('$notifyInstancesWhenStylesheetLoaded',
function(styleTPElemToObserve) {

    /**
     * @method $notifyInstancesWhenStylesheetLoaded
     * @summary Sets up an observation on the supplied style element that will
     *     notify instances of the receiver that the stylesheet that they
     *     (probably) rely on to render is available.
     * @param {TP.html.style} styleTPElemToObserve The stylesheet element to
     *     observe for when it is loaded.
     * @returns {TP.meta.dom.UIElementNode} The receiver.
     */

    var loadedHandler;

    //  Create a loaded handler (bound to the receiver) that will notify all
    //  instances that the stylesheet has loaded.
    loadedHandler = function(aSignal) {

        var target;

        //  Make sure to ignore() the signal once we've been notified.
        loadedHandler.ignore(aSignal.getOrigin(), 'TP.sig.DOMReady');

        target = aSignal.at('target');

        //  Notify any existing instances of this type that the stylesheet has
        //  been loaded.
        this.$notifyInstancesThatStylesheetLoaded(TP.wrap(target));

    }.bind(this);

    //  Observe TP.sig.DOMReady, which is what an XHTML style element will
    //  signal when it is loaded, it's style has been parsed and that style has
    //  been applied.
    loadedHandler.observe(styleTPElemToObserve, 'TP.sig.DOMReady');

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('onblur',
function(aTargetElem, anEvent) {

    /**
     * @method onblur
     * @summary Handles a 'blur' native event that was dispatched against the
     *     supplied native element.
     * @param {HTMLElement} aTargetElem The target element computed for this
     *     signal.
     * @param {Event} anEvent The native event that was triggered.
     * @exception TP.sig.InvalidElement
     * @returns {TP.meta.dom.UIElementNode} The receiver.
     */

    var manuallyBlurringElement,

        evtTargetTPElem,
        focusIDs,

        manuallyFocusingElement;

    if (!TP.isElement(aTargetElem)) {
        return this.raise('TP.sig.InvalidElement');
    }

    /* Uncomment for low-level focus stack debugging
    console.log(
        'Invoking the "onblur" event handler. The event target is: \n' +
        TP.gid(aTargetElem));
    */

    manuallyBlurringElement =
        TP.dom.UIElementNode.get('$manuallyBlurringElement');

    if (TP.isElement(manuallyBlurringElement)) {

        //  Reset this to null for the next pass.
        TP.dom.UIElementNode.set('$manuallyBlurringElement', null, false);

        return this;
    }

    //  If the 'manually focusing element' that we're tracking as the one that
    //  the system will try to focus is the same as the target element *and it
    //  doesn't exist somewhere in our focusing stack* (we might be trying to
    //  focus elements ourselves from our focus stack, which is perfectly ok and
    //  isn't considered to "be the system focusing outside of our control"),
    //  then we prevent any signaling of UI* signals.

    //  See the 'onfocus' and other focus calculation machinery methods for more
    //  information.
    manuallyFocusingElement =
        TP.dom.UIElementNode.get('$manuallyFocusingElement');

    if (TP.isValid(manuallyFocusingElement)) {

        if (manuallyFocusingElement === aTargetElem) {

            focusIDs = TP.$focus_stack.collect(
                            function(item) {
                                return item.getLocalID();
                            });

            if (!focusIDs.contains(TP.lid(manuallyFocusingElement))) {
                return this;
            }
        }
    }

    //  Grab the event target element and wrap it
    evtTargetTPElem = TP.wrap(aTargetElem);

    //  NB: This only is triggered for non-XHTML element if a 'blur' event is
    //  thrown directly at it via a manual trigger.
    if (!TP.isXHTMLNode(aTargetElem)) {
        evtTargetTPElem = TP.wrap(aTargetElem);
        evtTargetTPElem.blur();
    } else {
        evtTargetTPElem.signal('TP.sig.UIBlur',
                                TP.hc('trigger', TP.wrap(anEvent)));
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('onfocus',
function(aTargetElem, anEvent) {

    /**
     * @method onfocus
     * @summary Handles a 'focus' native event that was dispatched against the
     *     supplied native element.
     * @param {HTMLElement} aTargetElem The target element computed for this
     *     signal.
     * @param {Event} anEvent The native event that was triggered.
     * @exception TP.sig.InvalidElement
     * @returns {TP.meta.dom.UIElementNode} The receiver.
     */

    var focusedElem,

        evtTargetTPElem,
        focusingTPElem,

        oldMFE;

    if (!TP.isElement(aTargetElem)) {
        return this.raise('TP.sig.InvalidElement');
    }

    if (TP.elementIsDisabled(aTargetElem)) {
        return this;
    }

    /* Uncomment for low-level focus stack debugging
    console.log(
        'Invoking the "onfocus" event handler. The event target is: \n' +
        TP.gid(aTargetElem));
    */

    //  If there is a manually focusing element, that means that the system is
    //  trying to focus an element.
    //  Because focus/blur events are not cancellable, this will be called even
    //  though we don't want it, but we can prevent having any TIBET-level UI*
    //  signals from being dispatched.
    if (TP.isValid(TP.dom.UIElementNode.get('$manuallyFocusingElement'))) {
        //  Reset this to null for the next pass.
        TP.dom.UIElementNode.set('$manuallyFocusingElement', null, false);

        return this;
    }

    //  If there is a calculated TIBET focusing TP.dom.ElementNode, and its
    //  native node isn't the target element, then configure 'manually focusing
    //  element' to be the target element, and force the calculated one to
    //  focus. Note that we return here. That will avoid any extraneous TIBET
    //  signaling of UI* signals. These will be signaled when the 'focus()' call
    //  here comes back through this mechanism and the calculated one *will* be
    //  the same as the target.
    focusingTPElem = TP.dom.UIElementNode.get('$calculatedFocusingTPElem');

    if (TP.isValid(focusingTPElem)) {

        if (focusingTPElem.getNativeNode() !== aTargetElem) {

            oldMFE = TP.dom.UIElementNode.get('$manuallyFocusingElement');
            TP.dom.UIElementNode.set(
                    '$manuallyFocusingElement', aTargetElem, false);

            focusingTPElem.focus();

            TP.dom.UIElementNode.set('$manuallyFocusingElement', oldMFE, false);
        }

        //  Reset this to null for the next pass.
        TP.dom.UIElementNode.set('$calculatedFocusingTPElem', null, false);

        //  Whether or not this was the calculated element, we return here - the
        //  rest of the machinery will take care of things.
        return this;
    }

    //  See if there's a focused element (without considering the
    //  '.activeElement' property)
    focusedElem = TP.documentGetFocusedElement(
                            TP.nodeGetDocument(aTargetElem), false);

    //  If it's the same as the target element, then the browser is being stupid
    //  and is trying to focus the same element. This will screw up our focus
    //  stack semantics, so we exit here.
    if (focusedElem === aTargetElem) {
        return this;
    }

    //  If the target element is the same as the current active element (which
    //  we access directly here) and we *weren't* focusing via a mouse event of
    //  some sort, then we just return. Otherwise, the focusing machinery gets
    //  invoked all over again.
    if (aTargetElem === TP.nodeGetDocument(aTargetElem).activeElement &&
        TP.notTrue(TP.dom.UIElementNode.get('$focusingViaMouseEvent'))) {
        return this;
    }

    //  If the focused element is valid and is *not* an XHTML node, then
    //  'manually' blur it. This is because the browser machinery will not do
    //  this by default, like it does with XHTML elements.
    if (TP.isValid(focusedElem) && !TP.isXHTMLNode(focusedElem)) {
        focusedElem.blur();
    }

    //  Grab the event target element and wrap it
    evtTargetTPElem = TP.wrap(aTargetElem);

    //  NB: This only is triggered for non-XHTML element if a 'focus' event is
    //  thrown directly at it via a manual trigger.
    if (!TP.isXHTMLNode(aTargetElem)) {
        evtTargetTPElem = TP.wrap(aTargetElem);
        evtTargetTPElem.focus();
    } else {
        evtTargetTPElem.signal('TP.sig.UIFocus',
                                TP.hc('trigger', TP.wrap(anEvent)));
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('onkeydown',
function(aTargetElem, anEvent) {

    /**
     * @method onkeydown
     * @summary Handles a 'keydown' native event that was dispatched against
     *     the supplied native element.
     * @param {HTMLElement} aTargetElem The target element computed for this
     *     signal.
     * @param {Event} anEvent The native event that was triggered.
     * @exception TP.sig.InvalidElement
     * @returns {TP.meta.dom.UIElementNode} The receiver.
     */

    var focusedTPElem,

        evtTargetTPElem,

        signal,

        keyname,
        activateSignal,
        bindingsType,

        sigName,
        sigType;

    if (!TP.isElement(aTargetElem)) {
        return this.raise('TP.sig.InvalidElement');
    }

    //  Grab the event target element and wrap it
    evtTargetTPElem = TP.wrap(aTargetElem);

    //  If the event target element is the same as the documentElement (i.e. the
    //  HTML element) that means that the browser might be being stupid and
    //  refusing to dispatch key events to the focused element because the
    //  focused element is a non-XHTML element. Grab the focused element and set
    //  the target to be that element anyway.
    if (aTargetElem === TP.nodeGetDocument(aTargetElem).documentElement) {
        focusedTPElem = evtTargetTPElem.getFocusedElement(true);
        evtTargetTPElem = focusedTPElem;

        //  Note here how we have to reset the resolvedTarget on the Event as
        //  well.
        anEvent.$$_resolvedTarget = focusedTPElem.getNativeNode();
    }

    signal = TP.wrap(anEvent);

    //  If the event target element can handle the key indicated by the signal
    if (evtTargetTPElem.getType().canHandleKey(signal, anEvent)) {
        //  Grab the TIBET 'key name' from the event.
        keyname = TP.eventGetDOMSignalName(anEvent);

        if (keyname === 'DOM_Enter_Down') {
            //  Try to activate the event target element
            activateSignal = evtTargetTPElem.signal(
                                'TP.sig.UIActivate',
                                TP.hc('trigger', signal));

            //  Cache a reference to the target element that we sent the
            //  'TP.sig.UIActivate' signal from.
            TP.dom.UIElementNode.set(
                        '$lastActiveElement', evtTargetTPElem, false);

            if (activateSignal.shouldPrevent()) {
                //  Since the activation signal was cancelled, we cancel the
                //  native event
                anEvent.preventDefault();
            }

            return this;
        } else if (/DOM(.*)_Tab_Down/.test(keyname)) {

            //  If the target element is configured to want manual tab mgmt,
            //  then allow for that by just returning here.
            if (TP.elementHasAttribute(aTargetElem, 'tibet:manualtabs', true)) {
                return this;
            }

            //  We're going to handle this key down to move the focus ourselves,
            //  so we don't want the browser's natural 'tabbing' code to do
            //  anything. To prevent this, we preventDefault() on the event.
            anEvent.preventDefault();
        }

        sigName = null;

        //  Look in the external keybindings map. If there's an entry there,
        //  then we get the signal name from there.

        //  We compute the 'bindings' type (where we might find key bindings)
        //  from the target TP.dom.ElementNode.
        if (TP.isType(bindingsType = evtTargetTPElem.getType())) {

            //  Query for a signal name via the getKeybinding method. This call
            //  will look up through the supertype chain for the first match.
            sigName = bindingsType.getKeybinding(keyname, anEvent);
            if (TP.isEmpty(sigName)) {
                return this;
            }

            //  If the signal name is a real TIBET type, then go ahead and
            //  signal using the name, using the currently focused
            //  TP.dom.ElementNode as the 'target' of this signal.
            sigType = TP.sys.getTypeByName(sigName);
            if (TP.isType(sigType)) {
                if (TP.notValid(focusedTPElem)) {
                    focusedTPElem = evtTargetTPElem.getFocusedElement(true);
                }
                focusedTPElem.signal(sigName,
                                        TP.hc('trigger', TP.wrap(anEvent)));
                if (TP.isKindOf(sigType, TP.sig.UIFocusComputation)) {
                    TP.eventPreventDefault(anEvent);
                }
            } else {
                //  Otherwise, it should just be sent as a keyboard event. We
                //  found a map entry for it, but there was no real type.
                evtTargetTPElem.signal(sigName,
                                        TP.hc('trigger', TP.wrap(anEvent)),
                                        TP.DOM_FIRING,
                                        'TP.sig.' + keyname);
            }
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('onkeyup',
function(aTargetElem, anEvent) {

    /**
     * @method onkeyup
     * @summary Handles a 'keyup' native event that was dispatched against the
     *     supplied native element.
     * @param {HTMLElement} aTargetElem The target element computed for this
     *     signal.
     * @param {Event} anEvent The native event that was triggered.
     * @exception TP.sig.InvalidElement
     * @returns {TP.meta.dom.UIElementNode} The receiver.
     */

    var evtTargetTPElem,

        signal,

        keyname,
        deactivateSignal,
        bindingsType,
        sigName,
        sigType,
        incrementalVal,
        focusedTPElem;

    if (!TP.isElement(aTargetElem)) {
        return this.raise('TP.sig.InvalidElement');
    }

    //  Grab the event target element and wrap it
    evtTargetTPElem = TP.wrap(aTargetElem);

    //  If the event target element is the same as the documentElement (i.e. the
    //  HTML element) that means that the browser might be being stupid and
    //  refusing to dispatch key events to the focused element because the
    //  focused element is a non-XHTML element. Grab the focused element and set
    //  the target to be that element anyway.
    if (aTargetElem === TP.nodeGetDocument(aTargetElem).documentElement) {
        focusedTPElem = evtTargetTPElem.getFocusedElement(true);
        evtTargetTPElem = focusedTPElem;

        //  Note here how we have to reset the resolvedTarget on the Event as
        //  well.
        anEvent.$$_resolvedTarget = focusedTPElem.getNativeNode();
    }

    //  Compute the target to send the 'TP.sig.UIDeactivate' signal from. We
    //  look at (in order):
    //      - the last active element
    //      - the currently focused element
    //      - the target element supplied to this method
    evtTargetTPElem = TP.ifInvalid(
                        TP.dom.UIElementNode.get('$lastActiveElement'),
                        focusedTPElem);
    if (TP.notValid(evtTargetTPElem)) {
        evtTargetTPElem = TP.wrap(aTargetElem);
    }

    signal = TP.wrap(anEvent);

    //  If the event target element can handle the key indicated by the signal
    if (evtTargetTPElem.getType().canHandleKey(signal, anEvent)) {
        //  Grab the TIBET 'key name' from the event.
        keyname = TP.eventGetDOMSignalName(anEvent);

        if (keyname === 'DOM_Enter_Up') {
            //  Try to deactivate the event target element
            deactivateSignal = evtTargetTPElem.signal(
                                'TP.sig.UIDeactivate',
                                TP.hc('trigger', signal));

            if (deactivateSignal.shouldPrevent()) {
                //  Since the activation signal was cancelled, we cancel the
                //  native event
                anEvent.preventDefault();
            }

            return this;
        }

        //  Look in the external keybindings map. If there's an entry there,
        //  then we get the signal name from there.

        //  We compute the 'bindings' type (where we might find key bindings)
        //  from the target TP.dom.ElementNode.
        if (TP.isType(bindingsType = evtTargetTPElem.getType())) {

            //  Query for a signal name via the getKeybinding method. This call
            //  will look up through the supertype chain for the first match.
            sigName = bindingsType.getKeybinding(keyname, anEvent);
            if (TP.isEmpty(sigName)) {
                return this;
            }

            //  If the signal name is a real TIBET type, then go ahead and
            //  signal using the name, using the currently focused
            //  TP.dom.ElementNode as the 'target' of this signal.
            sigType = TP.sys.getTypeByName(sigName);
            if (TP.isType(sigType)) {
                if (TP.notValid(focusedTPElem)) {
                    focusedTPElem = evtTargetTPElem.getFocusedElement(true);
                }
                focusedTPElem.signal(sigName,
                                        TP.hc('trigger', TP.wrap(anEvent)));
                if (TP.isKindOf(sigType, TP.sig.UIFocusComputation)) {
                    TP.eventPreventDefault(anEvent);
                }
            } else {
                //  Otherwise, it should just be sent as a keyboard event. We
                //  found a map entry for it, but there was no real type.
                evtTargetTPElem.signal(sigName,
                                        TP.hc('trigger', TP.wrap(anEvent)),
                                        TP.DOM_FIRING,
                                        'TP.sig.' + keyname);
            }
        }
    } else if (evtTargetTPElem.isBoundElement()) {
        //  If the target is a bound element, then we should check to see if it
        //  wants incremental value updates.
        incrementalVal = evtTargetTPElem.getAttribute('ui:incremental');

        //  There are 3 possible values for 'ui:incremental' - 'control',
        //  'model' and 'both'. We handle 'model' and 'both' here.
        if (incrementalVal === 'model' || incrementalVal === 'both') {
            evtTargetTPElem.setBoundValueIfBound(
                                    evtTargetTPElem.getValue());
        }
    }

    //  Make sure to null out the last active element for the 'next run'.
    TP.dom.UIElementNode.set('$lastActiveElement', null, false);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('onmousedown',
function(aTargetElem, anEvent) {

    /**
     * @method onmousedown
     * @summary Handles a 'mousedown' native event that was dispatched against
     *     the supplied native element.
     * @param {HTMLElement} aTargetElem The target element computed for this
     *     signal.
     * @param {Event} anEvent The native event that was triggered.
     * @exception TP.sig.InvalidElement
     * @returns {TP.meta.dom.UIElementNode} The receiver.
     */

    var evtTargetTPElem,

        activateSignal;

    //  If we're manually focusing an element, then we don't proceed here. It
    //  probably means that it's a non-XHTML node that's shifting it's focus via
    //  mousedown/mouseup events.
    if (TP.isValid(TP.dom.UIElementNode.get('$manuallyFocusingElement'))) {
        return this;
    }

    if (!TP.isElement(aTargetElem)) {
        return this.raise('TP.sig.InvalidElement');
    }

    //  We will only signal UIActivate and focus if the button that was
    //  depressed was TP.LEFT.
    if (TP.eventGetButton(anEvent) !== TP.LEFT) {
        return this;
    }

    //  Grab the event target element and wrap it
    evtTargetTPElem = TP.wrap(aTargetElem);

    //  Try to activate the event target element
    activateSignal = evtTargetTPElem.signal(
                            'TP.sig.UIActivate',
                            TP.hc('trigger', TP.wrap(anEvent)));

    //  Cache a reference to the target element that we sent the
    //  'TP.sig.UIActivate' signal from.
    TP.dom.UIElementNode.set('$lastActiveElement', evtTargetTPElem, false);

    if (activateSignal.shouldPrevent()) {
        //  Since the activation signal was cancelled, we cancel the native
        //  event
        anEvent.preventDefault();
    }

    //  If the target can be focused, do what the 'moveFocus' instance method
    //  does after it computes a 'successor element to focus' - in this case,
    //  that successor element is the element that is our target.
    if (evtTargetTPElem.canFocus()) {
        TP.dom.UIElementNode.set(
                    '$calculatedFocusingTPElem', evtTargetTPElem, false);
    }

    //  Set the flag to let the rest of the focusing machinery know that this is
    //  happening due to a mouse event.
    TP.dom.UIElementNode.set('$focusingViaMouseEvent', true, false);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('onmouseup',
function(aTargetElem, anEvent) {

    /**
     * @method onmouseup
     * @summary Handles a 'mouseup' native event that was dispatched against
     *     the supplied native element.
     * @param {HTMLElement} aTargetElem The target element computed for this
     *     signal.
     * @param {Event} anEvent The native event that was triggered.
     * @exception TP.sig.InvalidElement
     * @returns {TP.meta.dom.UIElementNode} The receiver.
     */

    var evtTargetTPElem,

        deactivateSignal;

    //  If we're manually focusing an element, then we don't proceed here. It
    //  probably means that it's a non-XHTML node that's shifting it's focus via
    //  mousedown/mouseup events.
    if (TP.isValid(TP.dom.UIElementNode.get('$manuallyFocusingElement'))) {
        return this;
    }

    if (!TP.isElement(aTargetElem)) {
        return this.raise('TP.sig.InvalidElement');
    }

    //  We will only signal UIDeactivate and focus if the button that was
    //  depressed was TP.LEFT.
    if (TP.eventGetButton(anEvent) !== TP.LEFT) {
        return this;
    }

    //  Compute the target to send the 'TP.sig.UIDeactivate' signal from. We
    //  look at (in order):
    //      - the last active element
    //      - the target element supplied to this method
    evtTargetTPElem = TP.dom.UIElementNode.get('$lastActiveElement');
    if (TP.notValid(evtTargetTPElem)) {
        evtTargetTPElem = TP.wrap(aTargetElem);
    }

    //  Try to deactivate the event target element
    deactivateSignal = evtTargetTPElem.signal(
                            'TP.sig.UIDeactivate',
                            TP.hc('trigger', TP.wrap(anEvent)));

    if (deactivateSignal.shouldPrevent()) {
        //  Since the deactivation signal was cancelled, we cancel the
        //  native event
        anEvent.preventDefault();
    }

    if (evtTargetTPElem.canFocus() && !TP.isXHTMLNode(aTargetElem)) {
        evtTargetTPElem.focus();
    }

    //  Make sure to null out the last active element for the 'next run'.
    TP.dom.UIElementNode.set('$lastActiveElement', null, false);

    TP.dom.UIElementNode.set('$calculatedFocusingTPElem', null, false);

    //  Reset the flag that let's the rest of the focusing machinery know that
    //  this is happening due to a mouse event to false.
    TP.dom.UIElementNode.set('$focusingViaMouseEvent', false, false);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('popOffFocusStack',
function() {

    /**
     * @method popOffFocusStack
     * @summary Pops the last entry (which should be a TP.dom.ElementNode) from
     *     the focus stack and returns it.
     * @returns {TP.dom.ElementNode} The last entry from the focus stack.
     */

    var focusStack,
        retVal;

    focusStack = TP.$focus_stack;

    /* Uncomment for low-level focus stack debugging
    console.log(
        'getting ready to pop. Stack is currently: \n' +
        TP.$focus_stack.collect(
            function(aTPElem) {
                return TP.gid(aTPElem);
            }).join('\n'));
    */

    retVal = focusStack.pop();

    /* Uncomment for low-level focus stack debugging
    console.log(
        'we popped. Stack is currently: \n' +
        TP.$focus_stack.collect(
            function(aTPElem) {
                return TP.gid(aTPElem);
            }).join('\n'));
    */

    return retVal;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('pushOnFocusStack',
function(aTPElem) {

    /**
     * @method pushOnFocusStack
     * @summary Pushes the supplied TP.dom.ElementNode onto the focus stack.
     * @param {TP.dom.ElementNode} aTPElem The TP.dom.ElementNode to push onto
     *     the focus stack.
     */

    var focusStack;

    focusStack = TP.$focus_stack;

    if (focusStack.last() === aTPElem) {
        TP.ifWarn() ?
            TP.warn('Element at top of focus stack is the same.') : 0;
    }

    /* Uncomment for low-level focus stack debugging
    console.log(
        'getting ready to push. Stack is currently: \n' +
        TP.$focus_stack.collect(
            function(fooTPElem) {
                return TP.gid(fooTPElem);
            }).join('\n'));
    */

    focusStack.push(aTPElem);

    /* Uncomment for low-level focus stack debugging
    console.log(
        'we pushed. Stack is currently: \n' +
        TP.$focus_stack.collect(
            function(fooTPElem) {
                return TP.gid(fooTPElem);
            }).join('\n'));
    */

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('registerKeybinding',
function(keyname, signal) {

    /**
     * @method registerKeybinding
     * @summary Registers a unique binding to a TIBET keyname. The binding is
     *     essentially a signal name to be fired when the matching key or
     *     sequence is triggered.
     * @param {String} keyname The name of the key such as DOM_Ctrl_Z_Down.
     * @param {String|TP.sig.Signal} signal The name of the signal to be fired.
     */

    var map,
        name;

    name = signal.getSignalName();

    map = this.getKeybindings();
    if (TP.notValid(map)) {
        map = TP.hc();
        this.$set('keybindings', map, false);
    }

    map.atPut(keyname, name);

    return this;
});

//  ------------------------------------------------------------------------
//  Tag Phase Support
//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('tagCompile',
function(aRequest) {

    /**
     * @method tagCompile
     * @summary Convert the receiver into a format suitable for inclusion in a
     *     markup DOM.
     * @description This method operates differently depending on a variety of
     *     factors:
     *          - If the current node has a 'tibet:ctrl', but not a
     *              'tibet:tag', and its operating in a native namespace,
     *              this method returns with no transformation occurring and no
     *              child content being processed.
     *          - If the request contains a command target document and that
     *              target document is not an HTML document, then this element
     *              remains untransformed but its children are processed.
     *          - Otherwise, the element is transformed into a 'div' or 'span',
     *              depending on the return value of the 'isBlockLevel' method.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     * @returns {Element} The element that this tag has become.
     */

    var elem,
        ns,

        targetDoc,

        newElem;

    //  Make sure that we have an element to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        return;
    }

    //  We may have gotten here because the tag processing system was able to
    //  obtain a 'concrete type' for this node using the 'tibet:ctrl' attribute
    //  (which is really just defining a controller type) not a 'tibet:tag'
    //  attribute.

    //  Therefore, we want to check the namespace URI of the element and if its
    //  a 'native namespace' (i.e. this element is supported natively on the
    //  platform) and we don't have a 'tibet:tag' attribute we don't want to
    //  transform the tag, so we just exit here.
    if (TP.notEmpty(ns = elem.namespaceURI) &&
        TP.w3.Xmlns.isNativeNS(ns) &&
        !TP.elementHasAttribute(elem, 'tibet:tag', true)) {

        elem = TP.nodeCloneNode(elem);

        TP.elementSetGenerator(elem);

        //  Populate any 'compilation attributes' from the request onto the
        //  element that we're producing.
        this.populateCompilationAttrs(aRequest, elem);

        return elem;
    }

    //  One last check is to see if we're not operating in an HTML document.
    //  We may be operating in an *XHTML* document, in which case we do
    //  *not* 'auto transform' into a 'div' or 'span', but just leave things
    //  alone.
    if (TP.isValid(targetDoc = aRequest.at('doc'))) {
        if (!TP.isHTMLDocument(targetDoc)) {

            elem = TP.nodeCloneNode(elem);

            TP.elementSetGenerator(elem);

            //  Populate any 'compilation attributes' from the request onto the
            //  element that we're producing.
            this.populateCompilationAttrs(aRequest, elem);

            return elem;
        }
    }

    //  Create a new XHTML element from elem, using either 'div' or 'span'
    //  depending on whether the element is block level or not
    newElem = TP.elementBecome(elem, this.isBlockLevel() ? 'div' : 'span');

    return newElem;
});

//  ------------------------------------------------------------------------
//  TSH Execution Content
//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('cmdRunContent',
function(aRequest) {

    /**
     * @method cmdRunContent
     * @summary Runs the receiver, effectively invoking its action. This method
     *     is invoked any time a tag is being run as part of the processing of
     *     an enclosing tsh:script, which happens most often when the tag is
     *     being run interactively.
     * @param {TP.sig.ShellRequest} aRequest The request containing command
     *     input for the shell.
     * @returns {Object} A value which controls how the outer TSH processing
     *     loop should continue. TP.CONTINUE and TP.BREAK are common values.
     */

    var interactive,
        node,
        shell,
        str;

    interactive = TP.ifKeyInvalid(aRequest, 'cmdBuildGUI', false);
    if (interactive) {
        shell = aRequest.at('cmdShell');
        node = shell.updateCommandNode(aRequest);

        str = TP.wrap(node).asString();

        //  Have to output the action to get it into the DOM for
        //  awakening etc, otherwise it can't register/run/display.
        aRequest.stdout(str, TP.hc('cmdBox', false,
                                    'cmdAsIs', true,
                                    'cmdEcho', true));

        aRequest.set('result', str);
        aRequest.complete();

        return TP.CONTINUE;
    }

    return this.tshExecute(aRequest);
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('act',
function(aSignal) {

    /**
     * @method act
     * @summary Runs the receiver as if it were an action tag. For UI tags this
     *     is a noop.
     * @param {TP.sig.Signal} aSignal The signal (typically a request) which
     *     triggered this activity.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('acceptFocusedResponder',
function() {

    /**
     * @method acceptFocusedResponder
     * @summary Asks the receiver to accept its role as 'focused responder'.
     * @returns {Boolean} Whether or not the receiver should accept focused
     *     responder status.
     */

    var focusTPElem;

    //  If the type is holding a real $calculatedFocusingTPElem, then we want to
    //  reject accepting focused responder status because this means that the
    //  element that we *really* want to focus on (and which is now contained in
    //  this type's '$calculatedFocusingTPElem' property) is a different element
    //  than the one we're processing focused responder status for. So we reject
    //  focused responder status here and then this property will be cleared
    //  and when the desired target element is focused, we will accept it.
    focusTPElem = TP.dom.UIElementNode.get('$calculatedFocusingTPElem');

    if (TP.isKindOf(focusTPElem, TP.dom.UIElementNode) &&
        !focusTPElem.identicalTo(this)) {

        return false;
    }

    return true;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('becomeFocusedResponder',
function() {

    /**
     * @method becomeFocusedResponder
     * @summary Tells the receiver that it is now the 'focused responder'.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    //  Push ourself and signal 'TP.sig.UIDidPushFocus'
    this.getType().pushOnFocusStack(this);
    this.signal('TP.sig.UIDidPushFocus');

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('canAlterCSSProperty',
function(aProperty) {

    /**
     * @method canAlterCSSProperty
     * @summary This method tests as to whether the receiver can effectively
     *     alter the given CSS property. By 'effectively alter', we mean by
     *     altering the property, it will have a real effect on the element.
     * @description Effectively altering means that the element could take on a
     *     different visual presentation.
     * @param {String} aProperty The name of the CSS property to adjust.
     * @returns {String[]} A list of reasons as to why the property cannot be
     *     altered.
     */

    var elem,
        reasons;

    elem = this.getNativeNode();

    reasons = TP.ac();

    switch (aProperty) {
        case 'top':
        case 'right':
        case 'bottom':
        case 'left':
            if (!TP.elementIsPositioned(elem)) {
                reasons.push(TP.ELEMENT_NEEDS_TO_BE_POSITIONED);
            }
            break;
        case 'width':
        case 'height':
            if (!TP.elementCanBeSized(elem)) {
                reasons.push(TP.ELEMENT_NEEDS_TO_BE_BLOCK);
            }
            break;
        default:
            break;
    }

    return reasons;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('canFocus',
function() {

    /**
     * @method canFocus
     * @summary Whether or not the receiver can be focused. In TIBET, this
     *     means that it would have some sort of 'tabindex' attribute, since we
     *     require that for GUI elements that want focus.
     * @returns {Boolean} Whether or not the receiver can be focused.
     */

    var query;

    //  TP.FOCUSABLE_QUERIES contains a CSS query to tell us whether or not an
    //  Element is focusable.
    query = TP.FOCUSABLE_QUERIES.join(', ');

    return TP.elementMatchesCSS(this.getNativeNode(), query);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('clearStyleProperty',
function(aProperty) {

    /**
     * @method clearStyleProperty
     * @summary Clears the receiver's style property named by the supplied
     *     property name.
     * @param {String} aProperty The name of the style property to clear.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    TP.elementClearStyleProperty(this.getNativeNode(), aProperty);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('computeSuccessorFocusElement',
function(focusedTPElem, moveAction) {

    /**
     * @method computeSuccessorFocusElement
     * @summary Computes the 'successor' focus element using the currently
     *     focused element (if there is one) and the move action.
     * @param {TP.dom.ElementNode} focusedTPElem The currently focused element.
     *     This may be null if no element is currently focused.
     * @param {String} moveAction The type of 'move' that the user requested.
     *     This can be one of the following:
     *         TP.FIRST
     *         TP.LAST
     *         TP.NEXT
     *         TP.PREVIOUS
     *         TP.FIRST_IN_GROUP
     *         TP.LAST_IN_GROUP
     *         TP.FIRST_IN_NEXT_GROUP
     *         TP.FIRST_IN_PREVIOUS_GROUP
     *         TP.FOLLOWING
     *         TP.PRECEDING
     * @returns {TP.dom.ElementNode} The element that is the successor focus
     *     element.
     */

    var currentIsInGroup,

        win,

        bodyTPElem,

        currentGroupName,
        currentGroup,

        finalFocusedTPElem,

        bodyElem,
        focusedElem,

        theMoveAction,

        currentGroupWraps,

        computedGroup,

        results,

        nextGroupName,
        prevGroupName,

        resultTPElem,

        currentGroupResults,
        computedGroupResults,

        focusableQuery,

        noGroupResults;

    currentIsInGroup = false;

    win = this.getNativeWindow();

    //  If there is a current element, find the closest group to it - this
    //  dictates the 'context' of the search.
    if (TP.isValid(focusedTPElem)) {
        bodyTPElem = focusedTPElem.getDocument().getBody();

        //  If the current element has a group, then we use it.
        if (TP.notEmpty(currentGroupName = focusedTPElem.getGroupName())) {
            currentGroup = TP.byId(currentGroupName, win);
            currentIsInGroup = true;
        } else {
            //  Otherwise, the 'context' is the body element.
            currentGroup = bodyTPElem;
        }
    } else {
        bodyTPElem = this.getDocument().getBody();

        //  Otherwise, the 'context' is the body element.
        currentGroup = bodyTPElem;
    }

    //  Grab the 'focus boundary' from the currently focused element. If the
    //  focused element is an 'atomic' element (that is, an element that doesn't
    //  contain other, focusable elements) then this will just return the
    //  element itself. Otherwise, it will return a common parent with the
    //  'tibet:focusboundary' attribute on it.
    finalFocusedTPElem = focusedTPElem.getFocusBoundaryElement();

    bodyElem = TP.unwrap(bodyTPElem);
    focusedElem = TP.unwrap(finalFocusedTPElem);

    theMoveAction = moveAction;

    //  Compute whether the current group 'wraps' or not. It will wrap if it
    //  has a 'focuswrap' attribute and the value of that is not 'false'.
    currentGroupWraps =
            currentGroup.hasAttribute('focuswrap') &&
            currentGroup.getAttribute('focuswrap') !== 'false';

    //  If the current group doesn't wrap, then the move action turns from a
    //  TP.NEXT into a TP.FOLLOWING or from a TP.PREVIOUS into a
    //  TP.PRECEDING.
    if (!currentGroupWraps) {
        if (theMoveAction === TP.NEXT) {
            theMoveAction = TP.FOLLOWING;
        } else if (theMoveAction === TP.PREVIOUS) {
            theMoveAction = TP.PRECEDING;
        }
    }

    //  If we're moving between groups, then we need to query for them and
    //  set the computed group element appropriately.

    switch (theMoveAction) {
        case TP.FIRST:
        case TP.LAST:
        case TP.NEXT:
        case TP.PREVIOUS:
        case TP.FIRST_IN_GROUP:
        case TP.LAST_IN_GROUP:

            //  No computed group needed for these actions
            break;

        case TP.FIRST_IN_NEXT_GROUP:

            //  If the currently focused element isn't in a group, the 'next
            //  group' is going to be the first group (or the wrapped body).
            if (!currentIsInGroup) {
                if (TP.notEmpty(results = bodyTPElem.get(
                                'tibet:group'.asType().getQueryPath(
                                                    false, false, false)))) {

                    //  There was no group found, so the 'next group' is
                    //  going to be the first group (or the only group).
                    if (TP.isArray(results)) {
                        computedGroup = TP.wrap(results.first());
                    } else {
                        computedGroup = results;
                    }
                } else {
                    //  Couldn't find any groups - use the body element.
                    computedGroup = bodyTPElem;
                }
            } else {
                //  Grab the next group name from the current group (which
                //  may be nested, and we are interested in wrapping)
                nextGroupName =
                        this.getNextGroupName(currentGroupName, true, true);
                if (TP.isValid(nextGroupName)) {
                    computedGroup = TP.byId(nextGroupName, win);
                }
            }

            break;

        case TP.FIRST_IN_PREVIOUS_GROUP:

            //  If the currently focused element isn't in a group, the 'previous
            //  group' is going to be the last group (or the wrapped body).
            if (!currentIsInGroup) {
                if (TP.notEmpty(results = bodyTPElem.get(
                                'tibet:group'.asType().getQueryPath(
                                                    false, false, false)))) {

                    //  There was no group found, so the 'next group' is
                    //  going to be the last group (or the only group).
                    if (TP.isArray(results)) {
                        computedGroup = TP.wrap(results.last());
                    } else {
                        computedGroup = results;
                    }
                } else {
                    //  Couldn't find any groups - use the body element.
                    computedGroup = bodyTPElem;
                }
            } else {
                //  Grab the previous group name from the current group
                //  (which may be nested, and we are interested in wrapping)
                prevGroupName =
                        this.getPreviousGroupName(currentGroupName, true, true);
                if (TP.isValid(prevGroupName)) {
                    computedGroup = TP.byId(prevGroupName, win);
                }
            }

            break;

        case TP.FOLLOWING:

            //  If the currently focused element isn't in a group, the 'next
            //  group' is going to be the first group (or the wrapped body).
            if (!currentIsInGroup) {
                if (TP.notEmpty(results = bodyTPElem.get(
                                'tibet:group'.asType().getQueryPath(
                                                    false, false, false)))) {

                    //  There was more than 1 group found, so the 'next group'
                    //  is going to be the first group (or the only group).
                    if (TP.isArray(results)) {
                        computedGroup = TP.wrap(results.first());
                    } else {
                        computedGroup = results;
                    }

                    //  If we're not wrapping, then we need to make sure that
                    //  the 'next group' falls *after* this element - otherwise,
                    //  we're not interested in it.
                    if (!currentGroupWraps &&
                        !TP.nodeComparePosition(
                            this.getNativeNode(),
                            computedGroup.getNativeNode(),
                            TP.FOLLOWING_NODE)) {
                        computedGroup = null;
                    }
                } else {
                    //  Couldn't find any groups - use the body element.
                    computedGroup = bodyTPElem;
                }
            } else {
                //  Try to grab the next group name, which may be nested, but we
                //  are not interested in wrapping - we want to see if we need
                //  to check the body for focusable elements.
                nextGroupName =
                    this.getNextGroupName(currentGroupName, false, true);

                //  If we're not wrapping, then we need to make sure that the
                //  'next group' falls *after* this element - otherwise, we're
                //  not interested in it.
                if (TP.notEmpty(nextGroupName) &&
                    !currentGroupWraps &&
                    !TP.nodeComparePosition(
                        this.getNativeNode(),
                        TP.byId(nextGroupName, this.getNativeDocument(), false),
                        TP.FOLLOWING_NODE)) {
                    nextGroupName = null;
                }

                //  If there was no next group without wrapping and the current
                //  group doesn't have a parent group, then the computed group
                //  may be the body if it has focusable elements.
                if (TP.notValid(nextGroupName) &&
                    TP.notValid(this.getParentGroupName(currentGroupName))) {
                    //  Check to see if the body has focusable elements - if so,
                    //  then set the computedGroup to be the wrapped body.
                    if (TP.notEmpty(bodyTPElem.findFocusableElements())) {
                        computedGroup = bodyTPElem;
                    }
                }

                if (TP.notValid(computedGroup)) {
                    //  Grab the next group name from the current group (which
                    //  may be nested). This time we wrap.
                    nextGroupName =
                        this.getNextGroupName(currentGroupName, true, true);

                    //  If we couldn't compute a next group or if its the same
                    //  as the current group (in which case, it's a 'leaf' group
                    //  with no sibling groups), then see if we can use the
                    //  parent group.
                    if (TP.notValid(nextGroupName) ||
                        nextGroupName === currentGroupName) {
                        nextGroupName =
                                this.getParentGroupName(currentGroupName);
                    }

                    computedGroup = TP.byId(nextGroupName, win);
                }
            }

            break;

        case TP.PRECEDING:

            //  If the currently focused element isn't in a group, the 'previous
            //  group' is going to be the last group (or the wrapped body).
            if (!currentIsInGroup) {
                if (TP.notEmpty(results = bodyTPElem.get(
                                'tibet:group'.asType().getQueryPath(
                                                    false, false, false)))) {

                    //  There was more than 1 group found, so the 'previous
                    //  group' is going to be the last group (or the only
                    //  group).
                    if (TP.isArray(results)) {
                        computedGroup = TP.wrap(results.last());
                    } else {
                        computedGroup = results;
                    }

                    //  If we're not wrapping, then we need to make sure that
                    //  the 'previous group' falls *before* this element -
                    //  otherwise, we're not interested in it.
                    if (!currentGroupWraps &&
                        !TP.nodeComparePosition(
                            this.getNativeNode(),
                            computedGroup.getNativeNode(),
                            TP.PRECEDING_NODE)) {
                        computedGroup = null;
                    }
                } else {
                    //  Couldn't find any groups - use the body element.
                    computedGroup = bodyTPElem;
                }
            } else {
                //  Try to grab the previous group name, which may be nested,
                //  but we are not interested in wrapping - we want to see if we
                //  need to check the body for focusable elements.
                prevGroupName =
                    this.getPreviousGroupName(currentGroupName, false, true);

                //  If we're not wrapping, then we need to make sure that the
                //  'previous group' falls *before* this element - otherwise,
                //  we're not interested in it.
                if (TP.notEmpty(prevGroupName) &&
                    !currentGroupWraps &&
                    !TP.nodeComparePosition(
                        this.getNativeNode(),
                        TP.byId(prevGroupName, this.getNativeDocument(), false),
                        TP.PRECEDING_NODE)) {
                    prevGroupName = null;
                }

                //  If there was no previous group without wrapping and the
                //  current group doesn't have a parent group, then the computed
                //  group may be the body if it has focusable elements.
                if (TP.notValid(prevGroupName) &&
                    TP.notValid(this.getParentGroupName(currentGroupName))) {
                    //  Check to see if the body has focusable elements - if so,
                    //  then set the computedGroup to be the wrapped body.
                    if (TP.notEmpty(bodyTPElem.findFocusableElements())) {
                        computedGroup = bodyTPElem;
                    }
                }

                if (TP.notValid(computedGroup)) {
                    //  Grab the previous group name from the current group
                    //  (which may be nested). This time we wrap.
                    prevGroupName =
                        this.getPreviousGroupName(currentGroupName, true, true);

                    //  If we couldn't compute a previous group or if its the
                    //  same as the current group (in which case, it's a 'leaf'
                    //  group with no sibling groups), then see if we can use
                    //  the parent group.
                    if (TP.notValid(prevGroupName) ||
                        prevGroupName === currentGroupName) {
                        prevGroupName =
                                this.getParentGroupName(currentGroupName);
                    }

                    computedGroup = TP.byId(prevGroupName, win);
                }
            }

            break;

        default:

            return null;
    }

    resultTPElem = null;

    //  Based on the move action, grab the first, last, next or previous
    //  focusable element (using the current element for next and previous)
    switch (theMoveAction) {
        case TP.FIRST:

            //  We always use the body here - we don't care what the
            //  currentGroup is.

            if (TP.notEmpty(
                    TP.byCSSPath('tibet|group', bodyElem, false, false))) {
                focusableQuery = TP.computeFocusableQuery(
                                    'tibet|group:first > ', ':first');

                results = TP.byCSSPath(focusableQuery, bodyElem);
                results = TP.wrap(results);
            } else {
                results = bodyTPElem.findFocusableElements();
            }

            if (TP.isEmpty(results)) {
                return null;
            }

            resultTPElem = results.first();

            break;

        case TP.LAST:

            //  We always use the body here - we don't care what the
            //  currentGroup is.

            if (TP.notEmpty(
                    TP.byCSSPath('tibet|group', bodyElem, false, false))) {
                focusableQuery = TP.computeFocusableQuery(
                                    'tibet|group:last > ', ':last');

                results = TP.byCSSPath(focusableQuery, bodyElem, false);
            } else {
                results = bodyTPElem.findFocusableElements();
            }

            if (TP.isEmpty(results)) {
                return null;
            }

            resultTPElem = results.last();

            break;

        case TP.NEXT:

            if (TP.isEmpty(currentGroupResults =
                            currentGroup.findFocusableElements(true))) {
                //  The current group had no focusable elements.
                return null;
            }

            if (TP.notValid(finalFocusedTPElem) ||
                TP.notValid(resultTPElem = currentGroupResults.after(
                                            finalFocusedTPElem.getNativeNode(),
                                            TP.EQUALITY,
                                            true))) {

                //  NB: This assumes that we're wrapping - if we're not,
                //  then this operation got converted into a 'TP.FOLLOWING'
                //  above.

                resultTPElem = currentGroupResults.first();
            }

            break;

        case TP.PREVIOUS:

            if (TP.isEmpty(currentGroupResults =
                            currentGroup.findFocusableElements(true))) {
                //  The current group had no focusable elements.
                return null;
            }

            if (TP.notValid(finalFocusedTPElem) ||
                TP.notValid(resultTPElem = currentGroupResults.before(
                                            finalFocusedTPElem.getNativeNode(),
                                            TP.EQUALITY,
                                            true))) {

                //  NB: This assumes that we're wrapping - if we're not,
                //  then this operation got converted into a 'TP.PRECEDING'
                //  above.

                resultTPElem = currentGroupResults.last();
            }

            break;

        case TP.FIRST_IN_GROUP:

            if (TP.isEmpty(currentGroupResults =
                            currentGroup.findFocusableElements())) {
                //  The current group had no focusable elements.
                return null;
            }

            resultTPElem = currentGroupResults.first();

            break;

        case TP.LAST_IN_GROUP:

            if (TP.isEmpty(currentGroupResults =
                            currentGroup.findFocusableElements())) {
                //  The current group had no focusable elements.
                return null;
            }

            resultTPElem = currentGroupResults.last();

            break;

        case TP.FIRST_IN_NEXT_GROUP:
        case TP.FIRST_IN_PREVIOUS_GROUP:

            if (!TP.isValid(computedGroup) ||
                TP.isEmpty(computedGroupResults =
                            computedGroup.findFocusableElements())) {
                //  The computed group had no focusable elements.
                return null;
            }

            resultTPElem = computedGroupResults.first();

            break;

        case TP.FOLLOWING:

            if (TP.isEmpty(currentGroupResults =
                            currentGroup.findFocusableElements(true))) {
                //  The current group had no focusable elements.
                return null;
            }

            //  First, we check to see if the focused element is itself the
            //  body. If so, we just return the first result (which will have
            //  been properly sorted by tabindex by the 'findFocusableElements'
            //  call above)
            if (focusedElem === bodyElem) {

                //  The focused element was the body itself (which means that
                //  current group is as well), which means we should just use
                //  the first result element that got returned.
                resultTPElem = currentGroupResults.first();
            } else {

                //  We try to see if the current group has a focusable field
                //  following the current one.
                resultTPElem = currentGroupResults.after(
                                    finalFocusedTPElem, TP.EQUALITY, true);

                if (TP.notValid(finalFocusedTPElem) ||
                    TP.notValid(resultTPElem)) {

                    if (!TP.isValid(computedGroup)) {
                        if (currentGroupResults.last() === finalFocusedTPElem) {
                            return currentGroupResults.first();
                        }

                        return null;
                    }

                    //  Try to get the first focusable field of the computed
                    //  group (which will be the 'next group' according to the
                    //  group computation which occurred above).

                    //  First, we query with wanting groups, to see if there are
                    //  any focusable items after our current group.
                    computedGroupResults =
                                computedGroup.findFocusableElements(true);

                    if (TP.isEmpty(computedGroupResults)) {
                        return null;
                    }

                    resultTPElem = computedGroupResults.after(
                                    currentGroup, TP.EQUALITY, true);

                    //  If there are no focusable items after our current group,
                    //  then we re-query, but this time with no groups.
                    if (TP.notValid(resultTPElem)) {
                        noGroupResults =
                            computedGroup.findFocusableElements(false);

                        //  If we got 'no group' results, then we try to
                        //  determine if there is an element after the
                        //  currently focused element. If so, we use that as our
                        //  result element.
                        //  Otherwise, we just use the first 'no group' element.
                        if (TP.notEmpty(noGroupResults)) {
                            resultTPElem = noGroupResults.after(
                                    finalFocusedTPElem, TP.EQUALITY, true);
                            if (TP.notValid(resultTPElem)) {
                                resultTPElem = noGroupResults.first();
                            }
                        } else {
                            resultTPElem = computedGroupResults.first();
                        }
                    }
                }
            }

            break;

        case TP.PRECEDING:

            if (TP.isEmpty(currentGroupResults =
                            currentGroup.findFocusableElements(true))) {
                //  The current group had no focusable elements.
                return null;
            }

            //  First, we check to see if the focused element is itself the
            //  body. If so, we just return the first result (which will have
            //  been properly sorted by tabindex by the 'findFocusableElements'
            //  call above)
            if (focusedElem === bodyElem) {

                //  The focused element was the body itself (which means that
                //  current group is as well), which means we should just use
                //  the last result element that got returned.
                resultTPElem = currentGroupResults.last();
            } else {
                //  We try to see if the current group has a focusable field
                //  preceding the current one.
                resultTPElem = currentGroupResults.before(
                                    finalFocusedTPElem, TP.EQUALITY, true);

                if (TP.notValid(finalFocusedTPElem) ||
                    TP.notValid(resultTPElem)) {

                    if (!TP.isValid(computedGroup)) {
                        if (currentGroupResults.first() === finalFocusedTPElem) {
                            return currentGroupResults.last();
                        }

                        return null;
                    }

                    //  Try to get the last focusable field of the computed
                    //  group (which will be the 'last group' according to the
                    //  group computation which occurred above).

                    //  First, we query with wanting groups, to see if there are
                    //  any focusable items before our current group.
                    computedGroupResults =
                                computedGroup.findFocusableElements(true);

                    if (TP.isEmpty(computedGroupResults)) {
                        return null;
                    }

                    resultTPElem = computedGroupResults.before(
                                    currentGroup, TP.EQUALITY, true);

                    //  If there are no focusable items before our current
                    //  group, then we re-query, but this time with no groups.
                    if (TP.notValid(resultTPElem)) {
                        noGroupResults =
                            computedGroup.findFocusableElements(false);

                        //  If we got 'no group' results, then we try to
                        //  determine if there is an element before the
                        //  currently focused element. If so, we use that as our
                        //  result element.
                        //  Otherwise, we just use the last 'no group' element.
                        if (TP.notEmpty(noGroupResults)) {
                            resultTPElem = noGroupResults.before(
                                    finalFocusedTPElem, TP.EQUALITY, true);
                            if (TP.notValid(resultTPElem)) {
                                resultTPElem = noGroupResults.last();
                            }
                        } else {
                            resultTPElem = computedGroupResults.last();
                        }
                    }
                }
            }

            break;

        default:

            return null;
    }

    //  If there's a real result element, then return it. Otherwise return
    //  null.
    if (TP.isValid(resultTPElem)) {
        return resultTPElem;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('dispatchResponderSignalFromAttr',
function(aSignalName, aTriggerSignal) {

    /**
     * @method dispatchResponderSignalFromAttr
     * @summary Dispatches a signal with the supplied name that uses
     *     RESPONDER_FIRING and should have a corresponding 'on:' attribute on
     *     the receiver (i.e. 'on:UIActivate') that contains configuration and
     *     firing information.
     * @param {String} aSignalName The name of the signal that has a
     *     RESPONDER_FIRING policy. This is the name that will be used to look
     *     for an attribute of the same name (or shortened signal name, if
     *     applicable).
     * @param {TP.sig.Signal} aTriggerSignal The signal that triggered the
     *     machinery to get to this point. This is usually some kind of signal
     *     wrapping a native GUI Event.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var originElem,

        sigName,
        sigData;

    originElem = this.getNativeNode();

    //  First, try the full signal name.
    sigName = 'on:' + TP.expandSignalName(aSignalName);
    if (TP.elementHasAttribute(originElem, sigName, true)) {
        sigData = TP.elementGetAttribute(originElem, sigName, true);
    } else {
        //  Next, try the shortened version of that name.
        sigName = 'on:' + TP.contractSignalName(aSignalName);
        sigData = TP.elementGetAttribute(originElem, sigName, true);
    }

    //  If we were able to successfully extract signal data, then queue up a
    //  signal that will fire based on this data.
    if (TP.notEmpty(sigData)) {
        TP.queueSignalFromData(
                    sigData,
                    originElem,
                    aTriggerSignal,
                    null,   //  payload
                    null,   //  policy
                    TP.sig.ResponderSignal);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('findFocusableElements',
function(includesGroups) {

    /**
     * @method findFocusableElements
     * @summary Finds focusable elements under the receiver and returns an
     *     Array of TP.dom.ElementNodes of them.
     * @param {Boolean} includesGroups Whether or not to include 'tibet:group'
     *     elements as 'focusable' elements under the receiver. The default is
     *     false.
     * @returns {TP.dom.ElementNode[]} An Array of TP.dom.ElementNodes under the
     *     receiver that can be focused.
     */

    var elem,

        results,

        queryStr,

        noIntermediateGroups,

        finalResult;

    //  Query for any elements under the context element that are focusable.

    //  Note here that the query only includes:
    //  -   elements that are focusable that are *direct* children of the
    //      receiver
    //  -   elements that are focusable that are descendants of any element
    //      under the receiver that is *not* a tibet:group element.
    //  This allows us to filter out elements that are focusable but nested
    //  under another tibet:group that is in the receiver (we don't want
    //  these elements).

    elem = this.getNativeNode();

    //  NOTE: Because of how these queries are structured, they have to be
    //  executed separately and their results combined.
    results = TP.ac();

    //  Query for any immediate children that have a 'tibet:group' attribute
    //  that are focusable.
    queryStr = TP.computeFocusableQuery('> ');

    results.push(
        TP.byCSSPath(queryStr,
                        elem,
                        false,
                        false));

    queryStr = TP.computeFocusableQuery('*:not(tibet|group) ');

    //  Query for any descendants that do not have a parent that is a
    //  'tibet:group' element.
    noIntermediateGroups = TP.byCSSPath(queryStr,
                                        elem,
                                        false,
                                        false);

    //  Now, filter that result set to make sure that there are no 'tibet:group'
    //  elements between each result node and our own element.
    finalResult = noIntermediateGroups.filter(
                            function(focusableElem) {
                                return !TP.isElement(
                                            TP.nodeDetectAncestorMatchingCSS(
                                                focusableElem,
                                                'tibet|group',
                                                elem));
                            });

    //  Now, filter that result set to make sure that there are no elements with
    //  'tibet:focusboundary' attributes between each result node and our own
    //  element.
    finalResult = finalResult.filter(
                            function(focusableElem) {
                                return !TP.isElement(
                                            TP.nodeDetectAncestorMatchingCSS(
                                                focusableElem,
                                                '[tibet|focusboundary]',
                                                elem));
                            });

    results.push(finalResult);

    if (includesGroups) {
        results.push(
            TP.byCSSPath('> tibet|group, *:not(tibet|group) tibet|group',
                            elem,
                            false,
                            false));
    }

    //  Flatten out the results and unique them.
    results = results.flatten();
    results.unique();

    //  Iterate over them and see if they're displayed (not hidden by CSS -
    //  although they could currently not be visible to the user).
    results = results.select(
                    function(anElem) {
                        return TP.elementIsDisplayed(anElem);
                    });

    //  Sort the Array of elements by their 'tabindex' according to the
    //  HTML5 tabindex rules.
    results.sort(TP.sort.TABINDEX_ORDER);

    //  Wrap the results to make TP.dom.ElementNodes
    return TP.wrap(results);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getComputedStyleProperty',
function(aProperty, inPixels) {

    /**
     * @method getComputedStyleProperty
     * @summary Returns the receiver's *computed* style property named by the
     *     supplied property name.
     * @param {String} aProperty The name of the style property to retrieve.
     * @param {Boolean} [inPixels=false] Whether or not we want this value back
     *     as a Number of pixels. Obviously this will only work with values of
     *     properties that contain some sort of size. The default is false.
     * @returns {Object} The current computed value of the style property named
     *     by aProperty on the supplied element.
     */

    var elem,
        val;

    elem = this.getNativeNode();

    if (TP.isTrue(inPixels)) {
        val = TP.elementGetComputedStyleValueInPixels(
                                                elem, aProperty.asDOMName());
    } else {
        val = TP.elementGetComputedStyleProperty(elem, aProperty);
    }

    return val;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getAssociatedCustomCSSProperty',
function(selectorText, aPropertyName, aRuleIndex) {

    /**
     * @method getAssociatedCustomCSSProperty
     * @summary Gets the value of the named custom CSS property found in a rule
     *     associated with the receiver.
     * @param {String} selectorText The text of the selector to match.
     * @param {String} aPropertyName The CSS custom property name to get the
     *     value of.
     * @param {Number} [aRuleIndex=0] The index of the rule to obtain the value
     *     from if there is more than 1 rule that has the same selector.
     * @exception TP.sig.InvalidStyleSheet
     * @exception TP.sig.InvalidElement
     * @returns {Object|null} The property value or null.
     */

    var styleSheet,
        sheetOwnerElem;

    styleSheet = this.getStylesheetForStyleResource();
    if (!TP.isStyleSheet(styleSheet)) {
        return this.raise('TP.sig.InvalidStyleSheet');
    }

    sheetOwnerElem = TP.styleSheetGetOwnerNode(styleSheet);
    if (!TP.isElement(sheetOwnerElem)) {
        return this.raise('TP.sig.InvalidElement');
    }

    return TP.cssElementGetCustomCSSPropertyValue(
            sheetOwnerElem, selectorText, aPropertyName, aRuleIndex);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getDisplayValue',
function(anAttribute) {

    /**
     * @method getDisplayValue
     * @summary Gets the display, or visual, value of the receiver's node. This
     *     is the value the HTML, or other UI tag, is actually displaying to the
     *     user at the moment.
     * @returns {Object} The visual value of the receiver's UI node.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getFocusBoundaryElement',
function() {

    /**
     * @method getFocusBoundaryElement
     * @summary Returns the TP.dom.UIElementNode that forms the receiver's
     *     'focus bound'. This is normally the receiver itself, but it can be
     *     any ancestor element with the 'tibet:focusboundary' attribute.
     * @returns {TP.dom.UIElementNode} The TP.dom.UIElementNode acting as the
     *      'focus context' element of the receiver.
     */

    var focusBoundaryTPElem;

    if (TP.isValid(focusBoundaryTPElem =
            this.getFirstAncestorByAttribute('tibet:focusboundary'))) {
        return focusBoundaryTPElem;
    } else {
        return this;
    }
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getFocusContextElement',
function() {

    /**
     * @method getFocusContextElement
     * @summary Returns the TP.dom.UIElementNode that forms the receiver's
     *     'focus context'. This is normally the document's 'body' element, but
     *     it can be any ancestor element with the 'tibet:focuscontext'
     *     attribute.
     * @returns {TP.dom.UIElementNode} The TP.dom.UIElementNode acting as the
     *      'focus context' element of the receiver.
     */

    var focusContextTPElem;

    if (TP.isValid(focusContextTPElem =
            this.getFirstAncestorByAttribute('tibet:focuscontext'))) {
        return focusContextTPElem;
    } else {
        return this.getDocument().getBody();
    }
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getFocusedElement',
function(includeBody) {

    /**
     * @method getFocusedElement
     * @summary Returns the TP.dom.UIElementNode representing the element in
     *     the document that currently has focus.
     * @param {Boolean} includeBody Whether or not to include the 'body' element
     *     if another element can't be found. HTML5 says that the 'body' will
     *     be the 'active' element if another element can't be found, but
     *     sometimes callers don't want that. This defaults to true.
     * @exception TP.sig.InvalidDocument
     * @returns {TP.dom.UIElementNode} The TP.dom.UIElementNode that currently
     *     has focus in the document.
     */

    var currentDoc,
        currentElement;

    if (!TP.isDocument(currentDoc = this.getNativeDocument())) {
        return TP.raise(this, 'TP.sig.InvalidDocument');
    }

    //  Couldn't find a focused element
    if (!TP.isElement(currentElement =
                         TP.documentGetFocusedElement(currentDoc))) {
        return null;
    }

    if (TP.notTrue(includeBody) &&
         currentElement === TP.documentGetBody(currentDoc)) {

        //  The caller doesn't want the body back
        return null;
    }

    //  Found a currently focused element - wrap it.
    return TP.wrap(currentElement);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getHeight',
function() {

    /**
     * @method getHeight
     * @summary Returns the receiver's height in pixels.
     * @returns {Number} The receiver's height in pixels.
     */

    return TP.elementGetHeight(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getGlobalPoint',
function(wantsTransformed) {

    /**
     * @method getGlobalPoint
     * @summary Returns the receiver's global position as a TP.gui.Point. The
     *     global position is the element's position relative to its overall
     *     *top level* window.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @returns {TP.gui.Point} The receiver's global position.
     */

    var coords;

    coords = TP.elementGetGlobalXY(this.getNativeNode(),
                                    TP.BORDER_BOX,
                                    null,
                                    wantsTransformed);

    return TP.pc(coords);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getGlobalRect',
function(wantsTransformed) {

    /**
     * @method getGlobalRect
     * @summary Returns the receiver's global position and size as a
     *     TP.gui.Rect. The global position is the element's position relative
     *     to its overall *top level* window.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @returns {TP.gui.Rect} The receiver's global position and size.
     */

    var coords;

    coords = TP.elementGetGlobalBox(this.getNativeNode(),
                                    TP.BORDER_BOX,
                                    null,
                                    wantsTransformed);

    return TP.rtc(coords);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getGroupChainNames',
function() {

    /**
     * @method getGroupChainNames
     * @summary Returns an Array of the 'tibet:group' element names that the
     *     receiver is a member of, from the most specific group to the least
     *     specific group (i.e. up the group hierarchy).
     * @returns {String[]} The Array of 'tibet:group' names that the receiver is
     *     a member of or the empty Array.
     */

    var groupName,

        win,
        groupElem,

        allNames,

        allElemsWithGroupNames;

    //  First, get our group name
    groupName = this.getGroupName();

    if (TP.isEmpty(groupName)) {
        return null;
    }

    //  Next, get the element that is associated with that group.
    win = this.getNativeWindow();
    groupElem = TP.byId(groupName, win, false);

    //  Our group name doesn't correspond to a real Element - it might have been
    //  removed. Remove our attribute and return null.
    if (!TP.isElement(groupElem)) {
        this.removeAttribute('tibet:group');
        return null;
    }

    //  Start collecting our group names by pushing our own group name onto the
    //  list.
    allNames = TP.ac();
    allNames.push(groupName);

    //  If we had a hard group name placed on us, either by the author or by the
    //  system, then we need to start searching 'upward' *from the group
    //  element* (not ourself) for ancestors that have 'tibet:group' attributes
    //  on them.
    if (this.hasAttribute('tibet:group')) {
        allElemsWithGroupNames = TP.nodeSelectAncestorsMatchingCSS(
                                        groupElem,
                                        'tibet|group');
    } else {
        //  Otherwise, search from ourself for ancestors that have 'tibet:group'
        //  attributes.
        allElemsWithGroupNames = TP.nodeSelectAncestorsMatchingCSS(
                                        this.getNativeNode(),
                                        'tibet|group');
    }

    //  Iterate over the ancestors and collect the names.
    allElemsWithGroupNames.forEach(
        function(aGroupingElem) {
            allNames.push(
                TP.elementGetAttribute(aGroupingElem, 'id', true));
        });

    //  Sometimes we'll have duplicate group names (if we had a hard group name,
    //  but our grouping ancestor also had that group name - which usually means
    //  that element was responsible for us having the hard name), so we unique
    //  the returned group names here.
    return allNames.unique();
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getGroupName',
function() {

    /**
     * @method getGroupName
     * @summary Returns the 'tibet:group' element name that the receiver is a
     *     member of.
     * @returns {String|null} The 'tibet:group' name that the receiver is a
     *     member of or null.
     */

    var groupName,
        ancestorWithGroupName;

    groupName = this.getAttribute('tibet:group');

    //  If we don't have a 'tibet:group' attribute, then check 'up' our
    //  hierarchy to see if one of our ancestors does.
    if (TP.isEmpty(groupName)) {
        ancestorWithGroupName = TP.nodeDetectAncestorMatchingCSS(
                                        this.getNativeNode(),
                                        '*[tibet|group]');
        if (TP.notValid(ancestorWithGroupName)) {
            return null;
        }

        groupName = TP.elementGetAttribute(ancestorWithGroupName,
                                            'tibet:group',
                                            true);
    }

    return groupName;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getGroupElements',
function() {

    /**
     * @method getGroupElements
     * @summary Returns an Array containing other TP.dom.UIElementNodes that
     *     are members of the same group as the receiver.
     * @returns {TP.dom.UIElementNode[]} The array of other
     *     TP.dom.UIElementNodes belonging to the same group as the receiver.
     */

    var groupID,

        tpGroupElem;

    if (TP.notEmpty(groupID = this.getGroupName())) {

        tpGroupElem = TP.byId(groupID, this.getDocument(), true);

        if (TP.isValid(tpGroupElem) && !TP.isArray(tpGroupElem)) {
            return tpGroupElem.getMemberElements();
        }
    }

    return TP.ac();
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getNextGroupName',
function(startGroupName, alwaysWrap, wantsNested) {

    /**
     * @method getNextGroupName
     * @summary Returns the 'next' group name. If a starting group name is
     *     supplied, it is used as the starting point. Otherwise, the group name
     *     of the receiver is used as the starting point.
     * @param {String} startGroupName The group name to start the search for the
     *     next group at.
     * @param {Boolean} alwaysWrap Whether or not to ignore wrapping behavior
     *     and 'always wrap' around. Defaults to false.
     * @param {Boolean} wantsNested Whether or not to consider nested groups as
     *     part of this query. Defaults to false.
     * @returns {String|null} The name of the 'next' group or null if one can't
     *     be computed (or it would be the same group).
     */

    var ourGroupName,
        fromGroupName,

        shouldWrap,

        chainNames,

        win,

        fromGroupTPElem,

        parentGroupName,
        allGroups,

        memberGroupTPElems,

        nextGroupTPElem,

        parentGroupTPElem;

    if (TP.isEmpty(ourGroupName = this.getGroupName())) {
        return null;
    }

    fromGroupName = TP.ifEmpty(startGroupName, ourGroupName);

    shouldWrap = TP.ifInvalid(alwaysWrap, false);

    //  Grab the 'chain' of group names up the group hierarchy
    chainNames = this.getGroupChainNames();

    win = this.getNativeWindow();

    fromGroupTPElem = TP.byId(fromGroupName, win);

    //  Look for the 'parent group' name, which should be in the chain after
    //  the 'from' group name.
    if (TP.isEmpty(parentGroupName = chainNames.after(fromGroupName))) {
        //  Can't find the parent group - check the body by obtaining all of
        //  the tibet:groups under the body.
        if (TP.notEmpty(allGroups = this.getDocument().getBody().get(
                        'tibet:group'.asType().getQueryPath(
                                                wantsNested, false, false)))) {

            //  If there is only one group and it's the same group as the one
            //  we're coming from, then just return null
            if (!TP.isArray(allGroups) && allGroups === fromGroupTPElem) {
                return null;
            }

            //  Wrap all of them.
            memberGroupTPElems = TP.wrap(allGroups);

            //  Look for the group out of all of the groups that comes after
            //  the 'from' group.
            if (TP.notValid(nextGroupTPElem = memberGroupTPElems.after(
                                    fromGroupTPElem, TP.EQUALITY, true))) {
                //  There is no 'next' group after the 'from group'. If
                //  shouldWrap is true, set the next group element to be the
                //  first element - otherwise, return null
                if (shouldWrap) {
                    nextGroupTPElem = memberGroupTPElems.first();
                } else {
                    return null;
                }
            }
        } else {
            //  There are no tibet:group elements - return null
            return null;
        }
    } else {
        //  Grab the parent group's TP.dom.ElementNode and its member
        //  groups.
        parentGroupTPElem = TP.byId(parentGroupName, win);
        memberGroupTPElems = parentGroupTPElem.getMemberGroups();

        //  If there is only one member group, then it is the 'from' group
        //  itself - choose the parent group
        if (memberGroupTPElems.getSize() === 1) {
            nextGroupTPElem = parentGroupTPElem;
        } else if (TP.notValid(nextGroupTPElem = memberGroupTPElems.after(
                                    fromGroupTPElem, TP.EQUALITY, true))) {

            //  Otherwise, loop for the group out of all of the groups *of only
            //  the parent group* that comes after the 'from' group.

            //  If the parent tibet:group has a 'focuswrap' attribute on it
            //  use that to determine whether we should wrap... unless we
            //  should always wrap, ignoring 'focuswrap'
            if (parentGroupTPElem.hasAttribute('focuswrap') || shouldWrap) {
                //  TODO: There are other values for 'focuswrap'
                nextGroupTPElem = memberGroupTPElems.first();
            } else {
                //  Can't find the next group and we're not wrapping -
                //  return null
                return null;
            }
        }
    }

    return nextGroupTPElem.getAttribute('id');
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getOffsetParent',
function() {

    /**
     * @method getOffsetParent
     * @summary Returns the receiver's 'offset parent'.
     * @returns {TP.dom.UIElementNode} The receiver's 'offset parent' in the
     *     DOM.
     */

    return TP.wrap(TP.elementGetOffsetParent(this.getNativeNode()));
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getOffsetPoint',
function(wantsTransformed) {

    /**
     * @method getOffsetPoint
     * @summary Returns the receiver's offset position as a TP.gui.Point. The
     *     offset position is the element's position relative to its offset
     *     parent.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @returns {TP.gui.Point} The receiver's offset position.
     */

    var coords;

    coords = TP.elementGetOffsetXY(this.getNativeNode(),
                                    TP.BORDER_BOX,
                                    wantsTransformed);

    return TP.pc(coords);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getOffsetRect',
function(wantsTransformed) {

    /**
     * @method getOffsetRect
     * @summary Returns the receiver's offset position and size as a
     *     TP.gui.Rect. The offset position is the element's position relative
     *     to its offset parent.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @returns {TP.gui.Rect} The receiver's offset position and size.
     */

    var coords;

    coords = TP.elementGetOffsetBox(this.getNativeNode(),
                                    TP.BORDER_BOX,
                                    wantsTransformed);

    return TP.rtc(coords);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getPagePoint',
function(wantsTransformed) {

    /**
     * @method getPagePoint
     * @summary Returns the receiver's page position as a TP.gui.Point. The
     *     page position is the element's position relative to its overall page.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @returns {TP.gui.Point} The receiver's page position.
     */

    var coords;

    coords = TP.elementGetPageXY(this.getNativeNode(),
                                    TP.BORDER_BOX,
                                    null,
                                    wantsTransformed);

    return TP.pc(coords);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getPageRect',
function(wantsTransformed) {

    /**
     * @method getPageRect
     * @summary Returns the receiver's page position and size as a
     *     TP.gui.Rect. The page position is the element's position relative to
     *     its overall page.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to return 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @returns {TP.gui.Rect} The receiver's page position and size.
     */

    var coords;

    coords = TP.elementGetPageBox(this.getNativeNode(),
                                    TP.BORDER_BOX,
                                    null,
                                    wantsTransformed);

    return TP.rtc(coords);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getParentGroupName',
function(startGroupName) {

    /**
     * @method getParentGroupName
     * @summary Returns the 'next' group name. If a starting group name is
     *     supplied, it is used as the starting point. Otherwise, the group name
     *     of the receiver is used as the starting point.
     * @param {String} startGroupName The group name to start the search for the
     *     next group at.
     * @param {Boolean} alwaysWrap Whether or not to ignore wrapping behavior
     *     and 'always wrap' around.
     * @returns {String} The name of the 'next' group.
     */

    var ourGroupName,
        fromGroupName,

        chainNames,

        parentGroupName;

    if (TP.isEmpty(ourGroupName = this.getGroupName())) {
        return null;
    }

    fromGroupName = TP.ifEmpty(startGroupName, ourGroupName);

    //  Grab the 'chain' of group names up the group hierarchy
    chainNames = this.getGroupChainNames();

    //  Look for the 'parent group' name, which should be in the chain after
    //  the 'from' group name.
    if (TP.isEmpty(parentGroupName = chainNames.after(fromGroupName))) {
        return null;
    }

    return parentGroupName;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getPreviousGroupName',
function(startGroupName, alwaysWrap, wantsNested) {

    /**
     * @method getPreviousGroupName
     * @summary Returns the 'previous' group name. If a starting group name is
     *     supplied, it is used as the starting point. Otherwise, the group name
     *     of the receiver is used as the starting point.
     * @param {String} startGroupName The group name to start the search for the
     *     next group at.
     * @param {Boolean} alwaysWrap Whether or not to ignore wrapping behavior
     *     and 'always wrap' around. Defaults to false.
     * @param {Boolean} wantsNested Whether or not to consider nested groups as
     *     part of this query. Defaults to false.
     * @returns {String|null} The name of the 'previous' group or null if one
     *     can't be computed (or it would be the same group).
     */

    var ourGroupName,
        fromGroupName,

        shouldWrap,

        chainNames,

        win,

        fromGroupTPElem,

        parentGroupName,

        allGroups,

        memberGroupTPElems,

        prevGroupTPElem,

        parentGroupTPElem;

    if (TP.isEmpty(ourGroupName = this.getGroupName())) {
        return null;
    }

    fromGroupName = TP.ifEmpty(startGroupName, ourGroupName);

    shouldWrap = TP.ifInvalid(alwaysWrap, false);

    //  Grab the 'chain' of group names up the group hierarchy
    chainNames = this.getGroupChainNames();

    win = this.getNativeWindow();

    fromGroupTPElem = TP.byId(fromGroupName, win);

    //  Look for the 'parent group' name, which should be in the chain after
    //  the 'from' group name.
    if (TP.isEmpty(parentGroupName = chainNames.after(fromGroupName))) {
        //  Can't find the parent group - check the body by obtaining all of
        //  the tibet:groups under the body.
        if (TP.notEmpty(allGroups = this.getDocument().getBody().get(
                        'tibet:group'.asType().getQueryPath(
                                                wantsNested, false, false)))) {

            //  If there is only one group and it's the same group as the one
            //  we're coming from, then just return null
            if (!TP.isArray(allGroups) && allGroups === fromGroupTPElem) {
                return null;
            }

            //  Wrap all of them.
            memberGroupTPElems = TP.wrap(allGroups);

            //  Look for the group out of all of the groups that comes
            //  before the 'from' group.
            if (TP.notValid(prevGroupTPElem = memberGroupTPElems.before(
                                    fromGroupTPElem, TP.EQUALITY, true))) {
                //  There is no 'previous' group before the 'from group'. If
                //  shouldWrap is true, set the previous group element to be
                //  the last element - otherwise, return null
                if (shouldWrap) {
                    prevGroupTPElem = memberGroupTPElems.last();
                } else {
                    return null;
                }
            }
        } else {
            //  There are no tibet:group elements - return null
            return null;
        }
    } else {
        //  Grab the parent group's TP.dom.ElementNode and its member
        //  groups.
        parentGroupTPElem = TP.byId(parentGroupName, win);
        memberGroupTPElems = parentGroupTPElem.getMemberGroups();

        //  If there is only one member group, then it is the 'from' group
        //  itself - choose the parent group
        if (memberGroupTPElems.getSize() === 1) {
            prevGroupTPElem = parentGroupTPElem;
        } else if (TP.notValid(prevGroupTPElem = memberGroupTPElems.before(
                                    fromGroupTPElem, TP.EQUALITY, true))) {

            //  Otherwise, look for the group out of all of the groups *of only
            //  the parent group* that comes before the 'from' group.

            //  If the parent tibet:group has a 'focuswrap' attribute on it
            //  use that to determine whether we should wrap... unless we
            //  should always wrap, ignoring 'focuswrap'
            if (parentGroupTPElem.hasAttribute('focuswrap') || shouldWrap) {
                //  TODO: There are other values for 'focuswrap'
                prevGroupTPElem = memberGroupTPElems.last();
            } else {
                //  Can't find the previous group and we're not wrapping -
                //  return null
                return null;
            }
        }
    }

    return prevGroupTPElem.getAttribute('id');
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getScrollOffsetFromAncestor',
function(anAncestor, wantsTransformed) {

    /**
     * @method getScrollOffsetFromAncestor
     * @summary Returns an Array containing the X and Y of the total amount
     *     that the receiver is scrolled from the top, left corner of the
     *     supplied ancestor. If the ancestor isn't supplied, it defaults to
     *     the supplied element's document.
     * @param {HTMLElement} [anAncestor] The ancestor element to use as the
     *     'outermost' element to compute the scroll offset from. This is an
     *     optional parameter that defaults to the document.
     * @param {Boolean} [wantsTransformed] An optional parameter that determines
     *     whether to return 'transformed' values if the receiver has been
     *     transformed with a CSS transformation. The default is false.
     * @returns {TP.gui.Point} The receiver's scroll offset position.
     */

    var elem,
        offsets;

    elem = this.getNativeNode();

    offsets = TP.elementGetScrollOffsetFromAncestor(elem,
                                                    anAncestor,
                                                    wantsTransformed);

    return TP.pc(offsets.first(), offsets.last());
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getScrollOffset',
function() {

    /**
     * @method getScrollOffset
     * @summary Returns the receiver's scroll offset position (i.e. scrollLeft &
     *     scrollTop) as a TP.gui.Point.
     * @returns {TP.gui.Point} The receiver's scroll offset position.
     */

    var elem;

    elem = this.getNativeNode();

    return TP.pc(elem.scrollLeft, elem.scrollTop);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getStyleProperty',
function(aProperty) {

    /**
     * @method getStyleProperty
     * @summary Gets the receiver's style property named by the supplied
     *     property name. Note that this will be the *local* style value - not
     *     the *computed* style value.
     * @param {String} aProperty The name of the style property to get.
     * @returns {Object} The current value of the local style property named by
     *     aProperty on the supplied element.
     */

    return TP.elementGetStyleProperty(this.getNativeNode(), aProperty);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getSubmitName',
function() {

    /**
     * @method getSubmitName
     * @summary Returns the name under which the receiver would be submitted
     *     when used in a forms context. This defaults to the value of the id
     *     attribute, followed by the name attribute.
     * @returns {String} The receiver's submission name.
     */

    var node;

    node = this.getNativeNode();

    //  ID is our first choice, followed by Name
    return TP.elementGetAttribute(node, 'id') ||
            TP.elementGetAttribute(node, 'name');
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getStylesheetForStyleResource',
function() {

    /**
     * @method getStylesheetForStyleResource
     * @summary Returns a native CSSStylesheet object for the receiver's style
     *     resource (i.e. the stylesheet that would've been added via the
     *     'addStylesheetTo' method).
     * @returns {CSSStylesheet} The native CSSStyleSheet object.
     */

    var cssElementID,
        cssElement,

        stylesheet;

    //  We compute an 'id' by taking our *resource* type name and escaping
    //  it. The resource type name is usually the type name, but can be
    //  overridden for special types that need to supply a different name
    //  here for use in resource location computations.
    cssElementID = TP.escapeTypeName(this.getType().getResourceTypeName());

    //  Try to find the style element in our document given the computed ID.
    cssElement = TP.byId(cssElementID, this.getNativeDocument(), false);
    if (!TP.isElement(cssElement)) {
        return null;
    }

    //  If a 'tibet:style' element was found, then that means that we're
    //  executing in a non-inlined environment that will allow alternate style
    //  content (like LESS) to be brought in directly. But we're not interested
    //  in that element - we're only interested in native CSS elements that are
    //  generated from those.
    if (TP.elementGetFullName(cssElement) === 'tibet:style') {
        //  The *real* stylesheet is the one created when the LESS or whatever
        //  is finished processing will be the ID with the word '_generated'
        //  appended to it.
        cssElement = TP.byId(cssElementID + '_generated',
                                this.getNativeDocument(),
                                false);
    }

    //  If we couldn't find it, then exit.
    if (!TP.isElement(cssElement)) {
        return null;
    }

    //  Obtain the CSSStyleSheet object associated with that style element.
    stylesheet = TP.cssElementGetStyleSheet(cssElement);

    return stylesheet;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getTransformValues',
function() {

    /**
     * @method getTransformValues
     * @summary Returns the values of any CSS3 transforms of the receiver.
     * @returns {TP.core.Hash} A hash of values, keyed by the following keys:
     *     TP.ROTATE, TP.SKEW, TP.SCALE, TP.TRANSLATE
     */

    return TP.elementGetTransformValues(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getWidth',
function() {

    /**
     * @method getWidth
     * @summary Returns the receiver's width in pixels.
     * @returns {Number} The receiver's width in pixels.
     */

    return TP.elementGetWidth(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getWidthAndHeight',
function() {

    /**
     * @method getWidthAndHeight
     * @summary Returns the receiver's width and height as an Array of pixels.
     * @returns {Number[]} An Array of the receiver's width and height in
     *     pixels.
     */

    return TP.ac(TP.elementGetWidth(this.getNativeNode()),
                    TP.elementGetHeight(this.getNativeNode()));
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('hasFocus',
function(includeDescendants) {

    /**
     * @method hasFocus
     * @summary Returns whether or not the receiver (or any of its descendants,
     *     by default), are currently the focused element.
     * @param {Boolean} [includeDescendants=true] Should descendant elements be
     *     considered when trying to determine whether the receiver has focus.
     * @returns {Boolean} Whether or not the receiver has focus.
     */

    var focusedTPElem,
        hasFocus;

    focusedTPElem = this.getFocusedElement();
    if (TP.notValid(focusedTPElem)) {
        return false;
    }

    hasFocus = focusedTPElem.identicalTo(this);
    if (!hasFocus && TP.notFalse(includeDescendants)) {
        hasFocus = this.contains(focusedTPElem);
    }

    return hasFocus;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('hide',
function(preserveSpace) {

    /**
     * @method hide
     * @summary Hides the receiver's node.
     * @param {Boolean} preserveSpace Whether or not to 'preserve the space'
     *     taken up by the element in its document. The default is false.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    TP.elementHide(this.getNativeNode(), preserveSpace);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('ignoreKeybindingsDirectly',
function() {

    /**
     * @method ignoreKeybindingsDirectly
     * @summary Ignore any handler that's been installed to observe signals
     *     (normally those that use OBSERVER_FIRING) that are thrown from keys
     *     that are bound using the receiver's key bindings. This is normally
     *     used in a 'temporary mode' for a GUI element.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var keySignalHandler;

    //  Grab the private, instance-level key handler that would've gotten
    //  installed when the observation was made in the
    //  'observeKeybindingsDirectly' method.
    keySignalHandler = this.$get('$$keybindingSignalHandler');

    if (TP.isCallable(keySignalHandler)) {
        this.ignore(TP.core.Keyboard.getCurrentKeyboard(),
                    'TP.sig.DOMKeySignal',
                    keySignalHandler);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('isDisabled',
function() {

    /**
     * @method isDisabled
     * @summary Returns whether or not the receiver is *really* disabled. This
     *     includes whether any of the receiver's parent nodes are disabled,
     *     which means that the receiver is disabled.
     * @returns {Boolean} Whether or not anElement is disabled.
     */

    return TP.elementIsDisabled(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('isDisplayed',
function() {

    /**
     * @method isDisplayed
     * @summary Returns whether or not the receiver is displayed to the user.
     *     This is dependent not only on its own 'display' and 'visibility'
     *     settings, but on those settings of its parents.
     * @description Note that this only tests whether the receiver is currently
     *     being displayed insofar as CSS is concerned. The receiver very well
     *     may be scrolled off screen or under the influence of a CSS transform
     *     that would cause it to not be visible to the user. Use the
     *     isVisible() method to test whether the element is truly visible.
     * @returns {Boolean} Whether or not anElement is displayed.
     */

    return TP.elementIsDisplayed(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('isOverflowing',
function(direction) {

    /**
     * @method isOverflowing
     * @summary Returns whether or not the receiver is overflowing its
     *     containing block.
     * @param {String} [direction] The direction to test overflowing. If
     *     specified, this should be either TP.HORIZONTAL or TP.VERTICAL. If
     *     this is not specified, then both directions will be tested.
     * @returns {Boolean} Whether or not the receiver is overflowing its
     *     containing block.
     */

    var elem;

    elem = this.getNativeNode();

    switch (direction) {

        case TP.VERTICAL:
            if (elem.offsetHeight === 0) {
                return false;
            }
            return elem.scrollHeight > elem.offsetHeight;

        case TP.HORIZONTAL:
            if (elem.offsetWidth === 0) {
                return false;
            }
            return elem.scrollWidth > elem.offsetWidth;

        default:
            if (elem.offsetWidth === 0 && elem.offsetHeight === 0) {
                return false;
            }
            return elem.scrollHeight > elem.offsetHeight ||
                    elem.scrollWidth > elem.offsetWidth;
    }
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('isReadyToRender',
function() {

    /**
     * @method isReadyToRender
     * @summary Whether or not the receiver is 'ready to render'. Normally, this
     *     means that all of the resources that the receiver relies on to render
     *     have been loaded.
     * @returns {Boolean} Whether or not the receiver is ready to render.
     */

    var styleURI,

        head,
        styleLoc,

        styleElems,

        gids;

    //  Grab the style (i.e. CSS) URI associated with the receiver.
    styleURI = this.getType().getResourceURI('style', TP.ietf.mime.CSS);

    //  If it's not valid or has been defined a 'NO_RESULT', then return true
    //  since we're certainly not waiting for a stylesheet to load to be
    //  considered 'ready to render'.
    if (TP.notValid(styleURI) || styleURI === TP.NO_RESULT) {
        return true;
    } else {
        //  Otherwise, in some cases where a single stylesheet contains
        //  definitions for multiple types, another type will have loaded the
        //  stylesheet. Check to see if it is in the head of our document
        //  already.
        head = TP.documentEnsureHeadElement(this.getNativeDocument());
        styleLoc = styleURI.getLocation();

        //  Generate a CSS query that looks under the head for any style
        //  elements that have an 'originalhref' attribute that contains
        //  (anywhere in its path) our styleURI's location. Note that we make
        //  sure to go after only HTML style elements here.
        styleElems = TP.byCSSPath(
                        '> html|style[tibet|originalhref~="' + styleLoc + '"]',
                        head,
                        false,
                        false);

        //  If we found at least one matching stylesheet, then we're ready to
        //  render.
        if (TP.notEmpty(styleElems)) {
            return true;
        }
    }

    //  Check with the set of global IDs that our type is keeping and see if
    //  that contains our document's global ID. If so, then that means that our
    //  style sheets have been loaded into our document.
    gids = this.getType().get('loadedStylesheetDocumentGIDs');

    return gids.indexOf(this.getDocument().getGlobalID()) !== TP.NOT_FOUND;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('isVisible',
function(partial, direction, wantsTransformed) {

    /**
     * @method isVisible
     * @summary Returns whether or not the receiver is *really* visible to the
           user, no matter what its CSS setting is.
     * @description In addition to the standard CSS properties of 'display' and
           'visibility', this call also takes into account scrolling and any
           CSS transformation that has been applied to the element.
     * @param {Boolean} [partial=false] Whether or not the element can be
     *     partially visible or has to be completely visible. The default is
     *     false (i.e. it should be completely visible).
     * @param {String} [direction] The direction to test visibility in. If
     *     specified, this should be either TP.HORIZONTAL or TP.VERTICAL. If
     *     this is not specified, then both directions will be tested.
     * @param {Boolean} [wantsTransformed=false] An optional parameter that
     *     determines whether to use 'transformed' values if the element has
     *     been transformed with a CSS transformation. The default is false.
     * @returns {Boolean} Whether or not anElement is visible.
     */

    return TP.elementIsVisible(this.getNativeNode(),
                                partial, direction, wantsTransformed);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('observeKeybindingsDirectly',
function() {

    /**
     * @method observeKeybindingsDirectly
     * @summary Install a handler to observe signals (normally those that use
     *     OBSERVER_FIRING) that are thrown from keys that are bound using the
     *     receiver's key bindings. This is normally used in a 'temporary mode'
     *     for a GUI element.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var keySignalHandler;

    //  Define a handler that will trigger a signal based on a mapping in a
    //  keybindings map.

    keySignalHandler = function(aSignal) {

        var sigNames,

            evt,

            keyname,

            target,
            originArray,

            len,
            i,

            origin,
            originType,

            sigName,
            sigType,

            focusedTPElem;

        sigNames = aSignal.getSignalNames();

        evt = aSignal.getPayload();

        keyname = TP.eventGetDOMSignalName(evt);

        //  If this is a key signal, we should unshift a signal name matching
        //  the key name onto the front of the signal names. Because all
        //  specific key signals have spoofed names, this is important if the
        //  implementor wants to catch a specific key name.
        if (TP.isKindOf(aSignal, TP.sig.DOMKeySignal)) {
            if (!TP.core.Keyboard.isPrintable(evt)) {
                sigName = 'TP.sig.DOM_' +
                            TP.core.Keyboard.$getVirtualKeySignalName(evt);

                sigNames.unshift(sigName);
            }
        }

        //  Grab the the target and the event origins from it.
        target = TP.eventGetTarget(evt);
        originArray = TP.elementGetEventOrigins(target);

        //  Slice off the start of the origins between the window and our origin
        //  (inclusive). We do this since we don't care about origins that occur
        //  'above' us (hence the whole reason for this method to begin with -
        //  we're observing key bindings directly from event sources that only
        //  occur within ourself).
        originArray = originArray.slice(
                        originArray.indexOf(this.getNativeNode()) + 1);

        len = originArray.getSize();
        for (i = 0; i < len; i++) {

            origin = originArray.at(i);

            if (TP.isElement(origin)) {
                //  Grab the TIBET wrapper type for the element and query it to
                //  see if the current element is considered to be 'opaque' for
                //  the event at it's level as it bubbles. Note here how we pass
                //  the list of signal names that we computed above. This is
                //  optional for this method, but we want to make sure to
                //  supply the specific key signal by computing it above.
                if (TP.isType(originType =
                                TP.dom.ElementNode.getConcreteType(origin))) {
                    if (originType.isOpaqueBubblerFor(
                                        origin, aSignal, sigNames)) {
                        return this;
                    }
                }
            }
        }

        //  Look in the external keybindings map. If there's an entry there,
        //  then we get the signal name from there.

        //  Query for a signal name via the getKeybinding method. This call will
        //  look up through the supertype chain for the first match.
        sigName = this.getType().getKeybinding(keyname, evt);
        if (TP.isEmpty(sigName)) {
            return this;
        }

        //  If the signal name is a real TIBET type, then go ahead and signal
        //  using the name, using the currently focused TP.dom.ElementNode as
        //  the 'target' of this signal.
        sigType = TP.sys.getTypeByName(sigName);
        if (TP.isType(sigType)) {
            if (TP.notValid(focusedTPElem)) {
                focusedTPElem = this.getFocusedElement(true);
            }
            focusedTPElem.signal(sigName, TP.hc('trigger', TP.wrap(evt)));
            if (TP.isKindOf(sigType, TP.sig.UIFocusComputation)) {
                TP.eventPreventDefault(evt);
            }
        } else {
            //  Otherwise, it should just be sent as a keyboard event. We
            //  found a map entry for it, but there was no real type.
            this.signal(sigName,
                        TP.hc('trigger', TP.wrap(evt)),
                        TP.DOM_FIRING,
                                    'TP.sig.' + keyname);
        }

        return this;
    }.bind(this);

    //  Set up the observation.
    this.observe(TP.core.Keyboard.getCurrentKeyboard(),
                    'TP.sig.DOMKeySignal',
                    keySignalHandler);

    this.defineAttribute('$$keybindingSignalHandler');
    this.$set('$$keybindingSignalHandler', keySignalHandler);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('moveFocus',
function(moveAction, fromFocusedElement) {

    /**
     * @method moveFocus
     * @summary Moves the focus to a 'successor' element based on the
     *     information contained in the supplied event and on the move action.
     * @param {String} moveAction The type of 'move' that the user requested.
     *     This can be one of the following:
     *          TP.FIRST
     *          TP.LAST
     *          TP.NEXT
     *          TP.PREVIOUS
     *          TP.FIRST_IN_GROUP
     *          TP.LAST_IN_GROUP
     *          TP.FIRST_IN_NEXT_GROUP
     *          TP.FIRST_IN_PREVIOUS_GROUP
     *          TP.FOLLOWING
     *          TP.PRECEDING
     * @param {Boolean} [fromFocusedElement=true] Whether or not to compute the
     *     successor element from the currently focused element or not. If not,
     *     the successor element will be computed from the receiver. The default
     *     is true.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var currentTPElem,

        successorTPElem;

    if (TP.notFalse(fromFocusedElement)) {
        //  NB: We pass 'true' here because we want the 'body' element returned
        //  if no other element is focused
        currentTPElem = this.getFocusedElement(true);
    } else {
        /* eslint-disable consistent-this */
        currentTPElem = this;
        /* eslint-enable consistent-this */
    }

    //  If there was a real currently focused element, then we move away from it
    //  to the desired element.
    if (TP.isKindOf(currentTPElem, TP.dom.UIElementNode)) {
        //  Now, compute the 'successor' element to focus based on the move
        //  action, the event and the currently focused element (which is
        //  ourself since the signal was fired at us). This could be null if
        //  there is no successor element.
        successorTPElem = this.computeSuccessorFocusElement(
                                        currentTPElem, moveAction);
    } else {
        //  Otherwise, there was no currently focused element, so we compute
        //  the successor element in a different way.
        successorTPElem = this.computeSuccessorFocusElement(
                                        null, moveAction);
    }

    //  If there's a real successor element, then focus it. This will cause the
    //  standard focusing behavior to take over which should cause
    //  UIFocus/UIDidFocus to be signaled, etc. etc.
    if (TP.isKindOf(successorTPElem, TP.dom.UIElementNode)) {

        TP.dom.UIElementNode.set(
                    '$calculatedFocusingTPElem', successorTPElem, false);

        //  We do this to match the native focusing behavior that haven't been
        //  sent through this computation routine (i.e. clicks, etc.)

        //  Note that we pass the moveAction here - if this is a group, it will
        //  act as a hint as to where to put the focus within the group.
        successorTPElem.focus(moveAction);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('removeAttrActive',
function() {

    /**
     * @method removeAttrActive
     * @summary Remove the attribute corresponding to the receiver's active
     *     state.
     * @returns {Boolean} false
     */

    return this.$isInState('pclass:active', false);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('removeAttrBusy',
function() {

    /**
     * @method removeAttrBusy
     * @summary Remove the attribute corresponding to the receiver's busy
     *     state.
     * @returns {Boolean} false
     */

    return this.$isInState('pclass:busy', false);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('removeAttrClosed',
function() {

    /**
     * @method removeAttrClosed
     * @summary Remove the attribute corresponding to the receiver's closed
     *     state.
     * @returns {Boolean} false
     */

    return this.$isInState('pclass:closed', false);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('removeAttrCollapsed',
function() {

    /**
     * @method removeAttrCollapsed
     * @summary Remove the attribute corresponding to the receiver's collapsed
     *     state.
     * @returns {Boolean} false
     */

    return this.$isInState('pclass:collapsed', false);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('removeAttrDisabled',
function() {

    /**
     * @method removeAttrDisabled
     * @summary Remove the attribute corresponding to the receiver's disabled
     *     state.
     * @returns {Boolean} false
     */

    this.$removeAttribute('disabled');

    return this.$isInState('pclass:disabled', false);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('removeAttrFocused',
function() {

    /**
     * @method removeAttrFocused
     * @summary Remove the attribute corresponding to the receiver's focused
     *     state.
     * @returns {Boolean} false
     */

    return this.$isInState('pclass:focus', false);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('removeAttrHidden',
function() {

    /**
     * @method removeAttrHidden
     * @summary Remove the attribute corresponding to the receiver's hidden
     *     state.
     * @returns {Boolean} false
     */

    return this.$isInState('pclass:hidden', false);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('removeAttrInvalid',
function() {

    /**
     * @method removeAttrInvalid
     * @summary Remove the attribute corresponding to the receiver's invalid
     *     state.
     * @returns {Boolean} false
     */

    return this.$isInState('pclass:invalid', false);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('removeAttrOutOfRange',
function() {

    /**
     * @method removeAttrOutOfRange
     * @summary Remove the attribute corresponding to the receiver's
     *     out-of-range state.
     * @returns {Boolean} false
     */

    return this.$isInState('pclass:out-of-range', false);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('removeAttrReadonly',
function() {

    /**
     * @method removeAttrReadonly
     * @summary Remove the attribute corresponding to the receiver's readonly
     *     state.
     * @returns {Boolean} false
     */

    return this.$isInState('pclass:readonly', false);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('removeAttrRequired',
function() {

    /**
     * @method removeAttrRequired
     * @summary Remove the attribute corresponding to the receiver's required
     *     state.
     * @returns {Boolean} false
     */

    return this.$isInState('pclass:required', false);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('removeAttrSelected',
function() {

    /**
     * @method removeAttrSelected
     * @summary Remove the attribute corresponding to the receiver's selected
     *     state.
     * @returns {Boolean} false
     */

    return this.$isInState('pclass:selected', false);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('removeStyleProperty',
function(aProperty) {

    /**
     * @method removeStyleProperty
     * @summary Removes the receiver's style property named by the supplied
     *     property name.
     * @param {String} aProperty The name of the style property to remove.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    TP.elementRemoveStyleProperty(this.getNativeNode(), aProperty);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('removeTransform',
function() {

    /**
     * @method removeTransform
     * @summary Removes any CSS transform set on the receiver.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    TP.elementRemoveTransform(this.getNativeNode());

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('resignFocusedResponder',
function() {

    /**
     * @method resignFocusedResponder
     * @summary Tells the receiver that it is no longer the 'focused
     *     responder'.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var newFocusTPElem,
        newFocusContext,

        currentFocusContext,

        foundPreviousContext,

        foundContext,
        tpElementToFocus;

    //  The element that the focus is moving to. This might be null if we aren't
    //  being told to resign focus because of the TIBET focus manager.
    newFocusTPElem = TP.dom.UIElementNode.get('$calculatedFocusingTPElem');

    //  Now, we should clear the $calculatedFocusingTPElem property so that
    //  focusing on the new element will succeed. We'll adjust this below as
    //  necessary in case we don't want the focusing to happen on the 'current
    //  new element' that the system thinks it wants to focus on, but another
    //  element of our own choosing.
    TP.dom.UIElementNode.set('$calculatedFocusingTPElem', null, false);

    //  If the system has this flag on, that must mean that a component with a
    //  different focus context will be taking focus, but in an asynchronous
    //  fashion. Therefore, we do *not* want to proceed with manipulating the
    //  focus stack. We want to leave the current element on there.
    if (TP.dom.UIElementNode.get('$asyncSwitchingContexts')) {
        TP.dom.UIElementNode.set('$asyncSwitchingContexts', false, false);
        return this;
    }

    //  If the focus stack is empty, exit here - the 'becomeFocusedResponder'
    //  routine will take care of pushing the new element on the stack.
    if (TP.isEmpty(TP.$focus_stack)) {
        return this;
    }

    //  We are the currently focused element, get our focus context
    currentFocusContext = this.getFocusContextElement();

    //  Grab the new focus context. This will either be the calculated focus
    //  context or a focus context that can be computed from the element that
    //  TIBET wants us to focus. Since the focusing element is becoming the
    //  focused responder, this context will be considered to be the 'new'
    //  context.
    newFocusContext = TP.dom.UIElementNode.get('$calculatedFocusContext');
    if (TP.notValid(newFocusContext)) {
        if (TP.isKindOf(newFocusTPElem, TP.dom.UIElementNode)) {
            newFocusContext = newFocusTPElem.getFocusContextElement();
        }
    }

    //  If we haven't been able to calculate a new focus context and the focus
    //  stack has at least 2 elements on it, then use the focus context of the
    //  element that is the *second to the last* (because the element that we're
    //  resigning is the last element).
    foundPreviousContext = false;
    if (TP.notValid(newFocusContext) && TP.$focus_stack.getSize() > 1) {
        newFocusContext = TP.$focus_stack.at(-2).getFocusContextElement();
        if (TP.isValid(newFocusContext)) {

            //  Track whether or not we found a previous context.
            foundPreviousContext = true;
        }
    }

    //  If the two focus contexts are the same, then we pop the old focused
    //  element, and exit here. The new element will be pushed by the
    //  becomeFocusedResponder() method.
    if (TP.notValid(newFocusContext) ||
        newFocusContext.identicalTo(currentFocusContext)) {

        this.getType().popOffFocusStack();

        this.signal('TP.sig.UIDidPopFocus');

        return this;
    }

    //  Look at the stack to see if the focus context for the 'new' element is
    //  the same as the focus context of one of the elements that has already
    //  been pushed at some point.

    foundContext = TP.$focus_stack.detect(
            function(aTPElement) {
                return aTPElement.getFocusContextElement().identicalTo(
                                                        newFocusContext);
            });

    //  We found a context back on the stack that is the same focus context as
    //  the 'new' element.
    if (TP.isValid(foundContext)) {
        //  Pop the stack once to get back to the previously focused element.
        this.getType().popOffFocusStack();

        this.signal('TP.sig.UIDidPopFocus');

        //  Pop it again (and capture the value because this will be the element
        //  that we want to refocus) to get back to the element *before* the
        //  previously focused element. We're gonna re-push the previously
        //  focused element when we focus it below.
        tpElementToFocus = this.getType().popOffFocusStack();

        //  If we found a previous context, then we go ahead and focus what was
        //  previously the *second to last* (but is now the last) element on the
        //  focus stack.
        if (foundPreviousContext) {
            tpElementToFocus.focus();
        } else {

            //  Otherwise, reset the 'focusing element' to be the previously
            //  focused element. The presence of this element will cause the
            //  currently focusing element to *not* be focused (the event will
            //  be cancelled) and then the 'focus' call below will try to focus
            //  this element *after it is forked* (allowing the stack to
            //  unwind). See 'acceptFocusedResponder' for more information.
            TP.dom.UIElementNode.set(
                    '$calculatedFocusingTPElem', tpElementToFocus, false);
        }
    }

    //  The new element's focusing context has never been encountered before -
    //  leave the stack alone and just return.

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('scrollBy',
function(direction, incrementValue, cssProperty) {

    /**
     * @method scrollBy
     * @summary Scrolls the receiver (which should be clipped in some fashion)
     *     in the supplied direction by the supplied incrementValue. Note that
     *     this increment value can be provided as a non-pixel value ('1em' or
     *     '30%') and this will be converted to a pixel value.
     * @param {String} direction A named direction to scroll the element. Any
     *     one of:
     *          TP.UP
     *          TP.RIGHT
     *          TP.DOWN
     *          TP.LEFT
     * @param {String|Number} incrementValue The amount to scroll by. If this is
     *     a Number, it will be assumed to be a number of pixels. Otherwise, it
     *     will be used as a CSS value that a number of pixels will be computed
     *     from.
     * @param {String} [cssProperty] The name of the property being used to
     *     compute a pixel value from the supplied incrementValue. This is only
     *     required if a percentage value is given, but is desired to produce
     *     the most accurate results.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var elem,
        bufferSize,
        computedIncrement;

    elem = this.getNativeNode();

    //  If we're paging, then we want to go one whole 'page' (i.e. offset
    //  width/height) minus 2em of 'buffer' to give the user a visual cue.
    if (incrementValue === TP.PAGE) {

        bufferSize = TP.elementGetPixelValue(
                            elem,
                            TP.sys.cfg('tibet.ui_paging_buffer', '20px'),
                            cssProperty);

        if (direction === TP.UP || direction === TP.DOWN) {
            computedIncrement = TP.elementGetHeight(elem) - bufferSize;
        } else if (direction === TP.LEFT || direction === TP.RIGHT) {
            computedIncrement = TP.elementGetWidth(elem) - bufferSize;
        } else {
            computedIncrement = 0;
        }
    } else if (incrementValue === TP.LINE) {

        computedIncrement = TP.elementGetPixelValue(
                            elem,
                            TP.sys.cfg('tibet.ui_scrolling_lineheight', '20px'),
                            cssProperty);

    } else {
        computedIncrement = TP.elementGetPixelValue(
                                    elem, incrementValue, cssProperty);
    }

    switch (direction) {
        case TP.UP:
            elem.scrollTop -= computedIncrement;
            break;
        case TP.RIGHT:
            elem.scrollLeft += computedIncrement;
            break;
        case TP.DOWN:
            elem.scrollTop += computedIncrement;
            break;
        case TP.LEFT:
            elem.scrollLeft -= computedIncrement;
            break;
        default:
            break;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('scrollTo',
function(direction, scrollValue, cssProperty) {

    /**
     * @method scrollTo
     * @summary Scrolls the receiver (which should be clipped in some fashion)
     *     to either a side (TP.TOP, TP.RIGHT, TP.BOTTOM, TP.LEFT) directly or
     *     to a value of a particular direction (TP.HORIZONTAL or TP.VERTICAL).
     * @param {String} direction A named direction to scroll the element. Any
     *     one of:
     *          TP.TOP
     *          TP.RIGHT
     *          TP.BOTTOM
     *          TP.LEFT
     *
     *          TP.HORIZONTAL
     *          TP.VERTICAL
     * @param {String|Number} scrollValue The value to scroll to. If this is
     *     a Number, it will be assumed to be a number of pixels. Otherwise, it
     *     will be used as a CSS value that a number of pixels will be computed
     *     from. This parameter will not be used unless TP.HORIZONTAL or
     *     TP.VERTICAL is used.
     * @param {String} [cssProperty] The name of the property being used to
     *     compute a pixel value from the supplied incrementValue. This is only
     *     required if a percentage value is given, but is desired to produce
     *     the most accurate results. This parameter will not be used unless
     *     TP.HORIZONTAL or TP.VERTICAL is used.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var elem,
        computedValue;

    elem = this.getNativeNode();

    if (direction === TP.HORIZONTAL || direction === TP.VERTICAL) {
        computedValue = TP.elementGetPixelValue(
                                    elem, scrollValue, cssProperty);
    }

    switch (direction) {
        case TP.TOP:
            elem.scrollTop = 0;
            break;
        case TP.RIGHT:
            elem.scrollLeft = elem.scrollWidth;
            break;
        case TP.BOTTOM:
            elem.scrollTop = elem.scrollHeight;
            break;
        case TP.LEFT:
            elem.scrollLeft = 0;
            break;
        case TP.HORIZONTAL:
            elem.scrollLeft = computedValue;
            break;
        case TP.VERTICAL:
            elem.scrollTop = computedValue;
            break;
        default:
            break;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('$setAttribute',
function(attributeName, attributeValue, shouldSignal) {

    /**
     * @method $setAttribute
     * @summary Sets the value of the named attribute. This version overrides
     *     the one inherited from TP.dom.ElementNode to not bother with
     *     snapshotting changes to a transactionally consistent DOM, since this
     *     object's native node is an on-screen control.
     * @param {String} attributeName The attribute name to set.
     * @param {Object} attributeValue The value to set.
     * @param {Boolean} shouldSignal If false no signaling occurs. Defaults to
     *     this.shouldSignalChange().
     * @returns {undefined} Undefined according to the spec for DOM
     *     'setAttribute'.
     */

    var node,

        hadAttribute,

        flag,

        nameParts,
        prefix,
        name,

        url,

        attrNode,
        attrTPNode,
        attrFlag,

        id,
        attrURI;

    node = this.getNativeNode();

    hadAttribute = TP.elementHasAttribute(node, attributeName, true);

    //  NB: Use this construct this way for better performance
    if (TP.notValid(flag = shouldSignal)) {
        flag = this.shouldSignalChange();
    }

    //  if this is a prefixed attribute then we'll attempt to "do the right
    //  thing" by finding the registered namespace and placing the attribute
    //  in that namespace
    if (TP.regex.NS_QUALIFIED.test(attributeName)) {
        nameParts = attributeName.match(TP.regex.NS_QUALIFIED);
        prefix = nameParts.at(1);
        name = nameParts.at(2);

        if (attributeName.startsWith('xmlns')) {
            //  If the caller was trying to add an 'xmlns' attribute, then
            //  first check to make sure that they weren't trying to set the
            //  default namespace - can't do that :-(.
            if (attributeName === 'xmlns') {
                //  TODO: Throw an error - you cannot reset the default
                //  namespace :-(.
                return;
            }

            //  Otherwise, they're trying to add a prefixed namespace
            //  definition.
            TP.elementAddNSURI(node, prefix + ':' + name, attributeValue);

            if (flag) {
                this.$changed('@' + attributeName, TP.UPDATE);
            }

            return;
        }

        //  seems like we're dealing with a prefixed attribute that isn't an
        //  xmlns attribute, so the question is do we know a URI so we can
        //  map it properly?
        if (TP.notEmpty(url = TP.w3.Xmlns.getNSURIForPrefix(prefix))) {
            TP.elementSetAttributeInNS(node,
                                        prefix + ':' + name,
                                        attributeValue,
                                        url);
        } else {
            //  no known prefix, just set it as an attribute whose name
            //  happens to include a colon
            TP.elementSetAttribute(node, attributeName, attributeValue, true);
        }
    } else {
        TP.elementSetAttribute(node, attributeName, attributeValue, true);
    }

    if (flag) {
        this.$changed('@' + attributeName,
                        hadAttribute ? TP.UPDATE : TP.CREATE,
                        TP.hc(TP.OLDVAL,
                                TP.elementGetAttribute(
                                    node, attributeName, true),
                                TP.NEWVAL,
                                attributeValue));

        attrNode = TP.elementGetAttributeNode(node, attributeName, true);

        //  Now, in case anyone is bound to this attribute, wrap it, configure
        //  it to signal Change and send it.
        attrTPNode = TP.wrap(attrNode);

        //  Capture the value of whether the attribute node is configured to
        //  signal changes and then configure it to definitely signal a Change.
        attrFlag = attrTPNode.shouldSignalChange();
        attrTPNode.shouldSignalChange(true);

        //  Signal the Change
        attrTPNode.$changed('value', TP.UPDATE);

        //  If the attribute is on an Element that's in the UICANVAS, then
        //  build a URI from it and signal a 'change' from that URI, for any
        //  data bindings that are using 'direct to GUI' binding.
        if (TP.nodeGetWindow(attrNode) === TP.sys.getUICanvas(true)) {
            id = this.getLocalID();
            attrURI = TP.uc('tibet://uicanvas#' + id + '@' + attributeName);
            attrURI.$changed();
        }

        //  Put the 'should signal change' value back to whatever it was.
        attrTPNode.shouldSignalChange(attrFlag);
    }

    //  setAttribute returns void according to the spec
    return;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setAssociatedCustomCSSProperty',
function(selectorText, aPropertyName, aPropertyValue, aRuleIndex,
         shouldSignal) {

    /**
     * @method setAssociatedCustomCSSProperty
     * @summary Sets the value of the named custom CSS property found in a rule
     *     associated with the receiver.
     * @param {String} selectorText The text of the selector to match.
     * @param {String} aPropertyName The CSS custom property name to set the
     *     value of.
     * @param {String} aPropertyValue The value to set the CSS custom property
     *     to.
     * @param {Number} [aRuleIndex=0] The index of the rule to change if there
     *     is more than 1 rule that has the same selector.
     * @param {Boolean} [shouldSignal=true] If false no signaling occurs.
     * @exception TP.sig.InvalidStyleSheet
     * @exception TP.sig.InvalidElement
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var styleSheet,
        sheetOwnerElem;

    styleSheet = this.getStylesheetForStyleResource();
    if (!TP.isStyleSheet(styleSheet)) {
        return this.raise('TP.sig.InvalidStyleSheet');
    }

    sheetOwnerElem = TP.styleSheetGetOwnerNode(styleSheet);
    if (!TP.isElement(sheetOwnerElem)) {
        return this.raise('TP.sig.InvalidElement');
    }

    TP.cssElementSetCustomCSSPropertyValue(
            sheetOwnerElem, selectorText, aPropertyName, aPropertyValue,
            aRuleIndex, shouldSignal);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setDisplayValue',
function(aValue) {

    /**
     * @method setDisplayValue
     * @summary Sets the display, or visual, value of the receiver's node. The
     *     value provided to this method is typically already formatted using
     *     the receiver's display formatters (if any). You don't normally call
     *     this method directly, instead call setValue() and it will ensure
     *     proper display formatting.
     * @param {Object} aValue The value to set.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('$setFacet',
function(aspectName, facetName, facetValue, shouldSignal) {

    /**
     * @method $setFacet
     * @summary Sets the value of the named facet of the named aspect to the
     *     value provided. This method should be called from any 'custom facet
     *     setter' in order to a) set the property and b) signal a change, if
     *     configured.
     * @param {String} aspectName The name of the aspect to set.
     * @param {String} facetName The name of the facet to set.
     * @param {Object} facetValue The value to set the facet to.
     * @param {Boolean} shouldSignal If false no signaling occurs. Defaults to
     *     this.shouldSignalChange().
     * @returns {Boolean} Whether or not the value was changed from the value it
     *     had before this method was called.
     */

    var funcName,
        currentFacetVal;

    //  See if there is a specific Attribute setter on this element. If so, use
    //  it to set any attribute named with the aspect name. This will be done in
    //  addition to any internal value of the aspect on the receiver (i.e. both
    //  attribute 'foo' and the internal 'foo' property will be set).

    funcName = this.computeAttrMethodName('getAttr', aspectName);

    if (TP.canInvoke(this, funcName)) {
        currentFacetVal = this[funcName]();
    } else if (facetName === 'value') {
        //  If the facet is 'value', then use the standard 'get' mechanism.
        currentFacetVal = this.get(aspectName);
    } else {
        //  It didn't have a 'getAttr<aspectName>' and the name of the facet
        //  that changed wasn't 'value', so we just signal that it changed and
        //  return. This keeps compatibility with non-'value' facets.
        this.signalUsingFacetAndValue(facetName, facetValue);
        return true;
    }

    if (!TP.equal(currentFacetVal, facetValue)) {
        funcName = this.computeAttrMethodName('setAttr', aspectName);

        if (TP.canInvoke(this, funcName)) {
            this[funcName](facetValue);
        } else if (facetName === 'value') {
            //  If the facet is 'value', then use the standard 'set'
            //  mechanism.

            //  NB: This will signal the standard TP.sig.ValueChange (where
            //  'value' is the facet that changed).
            this.set(aspectName, facetValue, shouldSignal);
        }

        this.signalUsingFacetAndValue(facetName, facetValue);

        //  Return true because the value of the facet changed.
        return true;
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setGroupElement',
function(aTPElem) {

    /**
     * @method setGroupElement
     * @summary Sets the supplied tibet:group element as a grouping element for
     *     the receiver.
     * @param {tibet:group|null} aTPElem The element to use as the grouping
     *     element for the receiver. If this parameter is null, then the
     *     receiver will be disassociated from any group.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (TP.isValid(aTPElem)) {
        this.setAttribute('tibet:group', aTPElem.getLocalID());
    } else {
        this.removeAttribute('tibet:group');
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setHeight',
function(aHeight) {

    /**
     * @method setHeight
     * @summary Sets the receiver's height.
     * @description If a Number is supplied to aHeight a default unit of 'px' is
     *     assumed.
     * @param {Number|String} aHeight The height dimension to set the receiver's
     *     height to.
     */

    return TP.elementSetHeight(this.getNativeNode(), aHeight);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setGlobalPosition',
function(aPointOrObject) {

    /**
     * @method setGlobalPosition
     * @summary Sets the position of the receiver by manipulating its top and
     *     left style properties. This method expects that these values are
     *     provided *relative to the top-level window containing the receiver*
     *     and that the receiver is positioned in some fashion.
     * @param {TP.gui.Point|TP.core.Hash|Number[]} aPointOrObject A TP.gui.Point
     *     to use or an object that has 'x' and 'y' slots or an Array that has
     *     x in the first position, and y in the second position.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var elem,
        elemWin,

        xVal,
        yVal,

        winFrameElem,
        frameOffsetXAndY,

        pagePosition;

    elem = this.getNativeNode();

    if (!TP.isWindow(elemWin = TP.nodeGetWindow(elem))) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (TP.isKindOf(aPointOrObject, TP.gui.Point)) {
        xVal = aPointOrObject.getX();
        yVal = aPointOrObject.getY();
    } else if (TP.isHash(aPointOrObject)) {
        xVal = aPointOrObject.at('x');
        yVal = aPointOrObject.at('y');
    } else if (TP.isArray(aPointOrObject)) {
        xVal = aPointOrObject.at(0);
        yVal = aPointOrObject.at(1);
    } else {
        xVal = aPointOrObject.x;
        yVal = aPointOrObject.y;
    }

    if (TP.isElement(winFrameElem = elemWin.frameElement)) {
        //  Note here that we pass the result of obtaining the top window for
        //  the supplied element as the first argument since we really just want
        //  the offset of winFrameElem from the top (which will be 0,0 offset
        //  from itself).
        frameOffsetXAndY = TP.windowComputeWindowOffsets(
                            TP.nodeGetTopWindow(elem),
                            TP.elementGetIFrameWindow(winFrameElem));
    } else {
        frameOffsetXAndY = TP.ac(0, 0);
    }

    pagePosition = TP.pc(xVal - frameOffsetXAndY.first(),
                            yVal - frameOffsetXAndY.last());

    this.setPagePosition(pagePosition);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setGlobalPositionAndSize',
function(aRectOrObject) {

    /**
     * @method setGlobalPositionAndSize
     * @summary Sets the position of the receiver by manipulating its top and
     *     left style properties. This method expects that these values are
     *     provided *relative to the top-level window containing the receiver*
     *     and that the receiver is positioned in some fashion. It also sets the
     *     width and height according to the data supplied.
     * @param {TP.gui.Rect|TP.core.Hash|Number[]} aRectOrObject A TP.gui.Rect to
     *     use or an object that has 'x', 'y', 'width' and 'height' slots or an
     *     Array that has x in the first position, y in the second position,
     *     width in the third position and height in the fourth position.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var elem,
        elemWin,

        xVal,
        yVal,
        widthVal,
        heightVal,

        winFrameElem,
        frameOffsetXAndY,

        pagePositionAndSize;

    elem = this.getNativeNode();

    if (!TP.isWindow(elemWin = TP.nodeGetWindow(elem))) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (TP.isKindOf(aRectOrObject, TP.gui.Rect)) {
        xVal = aRectOrObject.getX();
        yVal = aRectOrObject.getY();
        widthVal = aRectOrObject.getWidth();
        heightVal = aRectOrObject.getHeight();
    } else if (TP.isHash(aRectOrObject)) {
        xVal = aRectOrObject.at('x');
        yVal = aRectOrObject.at('y');
        widthVal = aRectOrObject.at('width');
        heightVal = aRectOrObject.at('height');
    } else if (TP.isArray(aRectOrObject)) {
        xVal = aRectOrObject.at(0);
        yVal = aRectOrObject.at(1);
        widthVal = aRectOrObject.at(2);
        heightVal = aRectOrObject.at(3);
    } else {
        xVal = aRectOrObject.x;
        yVal = aRectOrObject.y;
        widthVal = aRectOrObject.width;
        heightVal = aRectOrObject.height;
    }

    if (TP.isElement(winFrameElem = elemWin.frameElement)) {
        //  Note here that we pass the result of obtaining the top window for
        //  the supplied element as the first argument since we really just want
        //  the offset of winFrameElem from the top (which will be 0,0 offset
        //  from itself).
        frameOffsetXAndY = TP.windowComputeWindowOffsets(
                            TP.nodeGetTopWindow(elem),
                            TP.elementGetIFrameWindow(winFrameElem));
    } else {
        frameOffsetXAndY = TP.ac(0, 0);
    }

    pagePositionAndSize = TP.rtc(
                            xVal - frameOffsetXAndY.first(),
                            yVal - frameOffsetXAndY.last(),
                            widthVal,
                            heightVal);

    this.setPagePositionAndSize(pagePositionAndSize);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setGlobalX',
function(aPointOrObject) {

    /**
     * @method setOffsetX
     * @summary Sets the X position of the receiver by manipulating its left
     *     style property. This method expects that this value is provided
     *     *relative to the top-level window containing the receiver* and that
     *     the receiver is positioned in some fashion.
     * @param {TP.gui.Point|TP.core.Hash|Array|Number} aPointOrObject A
     *     TP.gui.Point to use or an object that has an 'x' slot or an Array
     *     that has x in the first position or a Number.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var elem,
        elemWin,

        xVal,

        winFrameElem,
        frameOffsetXAndY,

        pageX;

    elem = this.getNativeNode();

    if (!TP.isWindow(elemWin = TP.nodeGetWindow(elem))) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (TP.isKindOf(aPointOrObject, TP.gui.Point)) {
        xVal = aPointOrObject.getX();
    } else if (TP.isHash(aPointOrObject)) {
        xVal = aPointOrObject.at('x');
    } else if (TP.isArray(aPointOrObject)) {
        xVal = aPointOrObject.at(0);
    } else if (TP.isPlainObject(aPointOrObject)) {
        xVal = aPointOrObject.x;
    } else {
        xVal = aPointOrObject;
    }

    if (TP.isElement(winFrameElem = elemWin.frameElement)) {
        //  Note here that we pass the result of obtaining the top window for
        //  the supplied element as the first argument since we really just want
        //  the offset of winFrameElem from the top (which will be 0,0 offset
        //  from itself).
        frameOffsetXAndY = TP.windowComputeWindowOffsets(
                            TP.nodeGetTopWindow(elem),
                            TP.elementGetIFrameWindow(winFrameElem));
    } else {
        frameOffsetXAndY = TP.ac(0, 0);
    }

    pageX = xVal - frameOffsetXAndY.first();

    this.setPageX(pageX);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setGlobalY',
function(aPointOrObject) {

    /**
     * @method setOffsetY
     * @summary Sets the Y position of the receiver by manipulating its top
     *     style property. This method expects that this value is provided
     *     *relative to the top-level window containing the receiver* and that
     *     the receiver is positioned in some fashion.
     * @param {TP.gui.Point|TP.core.Hash|Array|Number} aPointOrObject A
     *     TP.gui.Point to use or an object that has an 'y' slot or an Array
     *     that has y in the first position or a Number.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var elem,
        elemWin,

        yVal,

        winFrameElem,
        frameOffsetXAndY,

        pageY;

    elem = this.getNativeNode();

    if (!TP.isWindow(elemWin = TP.nodeGetWindow(elem))) {
        return TP.raise(this, 'TP.sig.InvalidWindow');
    }

    if (TP.isKindOf(aPointOrObject, TP.gui.Point)) {
        yVal = aPointOrObject.getY();
    } else if (TP.isHash(aPointOrObject)) {
        yVal = aPointOrObject.at('y');
    } else if (TP.isArray(aPointOrObject)) {
        yVal = aPointOrObject.at(1);
    } else if (TP.isPlainObject(aPointOrObject)) {
        yVal = aPointOrObject.y;
    } else {
        yVal = aPointOrObject;
    }

    if (TP.isElement(winFrameElem = elemWin.frameElement)) {
        //  Note here that we pass the result of obtaining the top window for
        //  the supplied element as the first argument since we really just want
        //  the offset of winFrameElem from the top (which will be 0,0 offset
        //  from itself).
        frameOffsetXAndY = TP.windowComputeWindowOffsets(
                            TP.nodeGetTopWindow(elem),
                            TP.elementGetIFrameWindow(winFrameElem));
    } else {
        frameOffsetXAndY = TP.ac(0, 0);
    }

    pageY = yVal - frameOffsetXAndY.last();

    this.setPageY(pageY);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setOffsetPosition',
function(aPointOrObject) {

    /**
     * @method setOffsetPosition
     * @summary Sets the position of the receiver by manipulating its top and
     *     left style properties. This method expects that these values are
     *     provided *relative to the offset parent of the receiver* and that the
     *     receiver is positioned in some fashion.
     * @param {TP.gui.Point|TP.core.Hash|Number[]} aPointOrObject A TP.gui.Point
     *     to use or an object that has 'x' and 'y' slots or an Array that has
     *     x in the first position, and y in the second position.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var styleObj;

    styleObj = TP.elementGetStyleObj(this.getNativeNode());

    if (TP.isKindOf(aPointOrObject, TP.gui.Point)) {
        styleObj.left = aPointOrObject.getX() + 'px';
        styleObj.top = aPointOrObject.getY() + 'px';
    } else if (TP.isHash(aPointOrObject)) {
        styleObj.left = aPointOrObject.at('x') + 'px';
        styleObj.top = aPointOrObject.at('y') + 'px';
    } else if (TP.isArray(aPointOrObject)) {
        styleObj.left = aPointOrObject.at(0) + 'px';
        styleObj.top = aPointOrObject.at(1) + 'px';
    } else {
        styleObj.left = aPointOrObject.x + 'px';
        styleObj.top = aPointOrObject.y + 'px';
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setOffsetPositionAndSize',
function(aRectOrObject) {

    /**
     * @method setOffsetPositionAndSize
     * @summary Sets the position of the receiver by manipulating its top and
     *     left style properties. This method expects that these values are
     *     provided *relative to the offset parent of the receiver* and that the
     *     receiver is positioned in some fashion. It also sets the width and
     *     height according to the data supplied.
     * @param {TP.gui.Rect|TP.core.Hash|Number[]} aRectOrObject A TP.gui.Rect to
     *     use or an object that has 'x', 'y', 'width' and 'height' slots or an
     *     Array that has x in the first position, y in the second position,
     *     width in the third position and height in the fourth position.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var styleObj;

    styleObj = TP.elementGetStyleObj(this.getNativeNode());

    if (TP.isKindOf(aRectOrObject, TP.gui.Rect)) {
        styleObj.left = aRectOrObject.getX() + 'px';
        styleObj.top = aRectOrObject.getY() + 'px';
        styleObj.width = aRectOrObject.getWidth() + 'px';
        styleObj.height = aRectOrObject.getHeight() + 'px';
    } else if (TP.isHash(aRectOrObject)) {
        styleObj.left = aRectOrObject.at('x') + 'px';
        styleObj.top = aRectOrObject.at('y') + 'px';
        styleObj.width = aRectOrObject.at('width') + 'px';
        styleObj.height = aRectOrObject.at('height') + 'px';
    } else if (TP.isArray(aRectOrObject)) {
        styleObj.left = aRectOrObject.at(0) + 'px';
        styleObj.top = aRectOrObject.at(1) + 'px';
        styleObj.width = aRectOrObject.at(2) + 'px';
        styleObj.height = aRectOrObject.at(3) + 'px';
    } else {
        styleObj.left = aRectOrObject.x + 'px';
        styleObj.top = aRectOrObject.y + 'px';
        styleObj.width = aRectOrObject.width + 'px';
        styleObj.height = aRectOrObject.height + 'px';
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setOffsetX',
function(aPointOrObject) {

    /**
     * @method setOffsetX
     * @summary Sets the X position of the receiver by manipulating its left
     *     style property. This method expects that this value is provided
     *     *relative to the offset parent of the receiver* and that the receiver
     *     is positioned in some fashion.
     * @param {TP.gui.Point|TP.core.Hash|Array|Number} aPointOrObject A
     *     TP.gui.Point to use or an object that has an 'x' slot or an Array
     *     that has x in the first position or a Number.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var xVal,

        elem,

        styleObj;

    if (TP.isKindOf(aPointOrObject, TP.gui.Point)) {
        xVal = aPointOrObject.getX();
    } else if (TP.isHash(aPointOrObject)) {
        xVal = aPointOrObject.at('x');
    } else if (TP.isArray(aPointOrObject)) {
        xVal = aPointOrObject.at(0);
    } else if (TP.isPlainObject(aPointOrObject)) {
        xVal = aPointOrObject.x;
    } else {
        xVal = aPointOrObject;
    }

    elem = this.getNativeNode();

    styleObj = TP.elementGetStyleObj(elem);

    /* eslint-disable no-extra-parens */
    styleObj.left = xVal + 'px';
    /* eslint-enable no-extra-parens */

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setOffsetY',
function(aPointOrObject) {

    /**
     * @method setOffsetY
     * @summary Sets the Y position of the receiver by manipulating its top
     *     style property. This method expects that this value is provided
     *     *relative to the offset parent of the receiver* and that the receiver
     *     is positioned in some fashion.
     * @param {TP.gui.Point|TP.core.Hash|Array|Number} aPointOrObject A
     *     TP.gui.Point to use or an object that has an 'y' slot or an Array
     *     that has y in the first position or a Number.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var yVal,

        elem,

        styleObj;

    if (TP.isKindOf(aPointOrObject, TP.gui.Point)) {
        yVal = aPointOrObject.getY();
    } else if (TP.isHash(aPointOrObject)) {
        yVal = aPointOrObject.at('y');
    } else if (TP.isArray(aPointOrObject)) {
        yVal = aPointOrObject.at(1);
    } else if (TP.isPlainObject(aPointOrObject)) {
        yVal = aPointOrObject.y;
    } else {
        yVal = aPointOrObject;
    }

    elem = this.getNativeNode();

    styleObj = TP.elementGetStyleObj(elem);

    /* eslint-disable no-extra-parens */
    styleObj.top = yVal + 'px';
    /* eslint-enable no-extra-parens */

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setPagePosition',
function(aPointOrObject) {

    /**
     * @method setPagePosition
     * @summary Sets the position of the receiver by manipulating its top and
     *     left style properties. This method expects that these values are
     *     provided *relative to the whole page of the receiver* and that the
     *     receiver is positioned in some fashion.
     * @param {TP.gui.Point|TP.core.Hash|Number[]} aPointOrObject A TP.gui.Point
     *     to use or an object that has 'x' and 'y' slots or an Array that has
     *     x in the first position, and y in the second position.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var xVal,
        yVal,

        elem,

        offsetParent,
        offsets,
        styleObj;

    if (TP.isKindOf(aPointOrObject, TP.gui.Point)) {
        xVal = aPointOrObject.getX();
        yVal = aPointOrObject.getY();
    } else if (TP.isHash(aPointOrObject)) {
        xVal = aPointOrObject.at('x');
        yVal = aPointOrObject.at('y');
    } else if (TP.isArray(aPointOrObject)) {
        xVal = aPointOrObject.at(0);
        yVal = aPointOrObject.at(1);
    } else {
        xVal = aPointOrObject.x;
        yVal = aPointOrObject.y;
    }

    elem = this.getNativeNode();

    //  The offsetParent can be null if the element is position: fixed.
    offsetParent = TP.elementGetOffsetParent(elem);
    if (TP.isElement(offsetParent)) {
        offsets = TP.elementGetOffsetFromContainer(offsetParent);
    } else {
        offsets = TP.ac(0, 0);
    }

    styleObj = TP.elementGetStyleObj(elem);

    /* eslint-disable no-extra-parens */
    styleObj.left = (xVal - offsets.first()) + 'px';
    styleObj.top = (yVal - offsets.last()) + 'px';
    /* eslint-enable no-extra-parens */

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setPagePositionAndSize',
function(aRectOrObject) {

    /**
     * @method setPagePositionAndSize
     * @summary Sets the position of the receiver by manipulating its top and
     *     left style properties. This method expects that these values are
     *     provided *relative to the whole page of the receiver* and that the
     *     receiver is positioned in some fashion. It also sets the width and
     *     height according to the data supplied.
     * @param {TP.gui.Rect|TP.core.Hash|Number[]} aRectOrObject A TP.gui.Rect to
     *     use or an object that has 'x', 'y', 'width' and 'height' slots or an
     *     Array that has x in the first position, y in the second position,
     *     width in the third position and height in the fourth position.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var xVal,
        yVal,

        elem,
        offsets,
        styleObj;

    styleObj = TP.elementGetStyleObj(this.getNativeNode());

    if (TP.isKindOf(aRectOrObject, TP.gui.Rect)) {
        xVal = aRectOrObject.getX();
        yVal = aRectOrObject.getY();
        styleObj.width = aRectOrObject.getWidth() + 'px';
        styleObj.height = aRectOrObject.getHeight() + 'px';
    } else if (TP.isHash(aRectOrObject)) {
        xVal = aRectOrObject.at('x');
        yVal = aRectOrObject.at('y');
        styleObj.width = aRectOrObject.at('width') + 'px';
        styleObj.height = aRectOrObject.at('height') + 'px';
    } else if (TP.isArray(aRectOrObject)) {
        xVal = aRectOrObject.at(0);
        yVal = aRectOrObject.at(1);
        styleObj.width = aRectOrObject.at(2) + 'px';
        styleObj.height = aRectOrObject.at(3) + 'px';
    } else {
        xVal = aRectOrObject.x;
        yVal = aRectOrObject.y;
        styleObj.width = aRectOrObject.width + 'px';
        styleObj.height = aRectOrObject.height + 'px';
    }

    elem = this.getNativeNode();

    offsets = TP.elementGetOffsetFromContainer(elem);

    /* eslint-disable no-extra-parens */
    styleObj.left = (xVal - offsets.first()) + 'px';
    styleObj.top = (yVal - offsets.last()) + 'px';
    /* eslint-enable no-extra-parens */

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setPageX',
function(aPointOrObject) {

    /**
     * @method setPageX
     * @summary Sets the X position of the receiver by manipulating its left
     *     style property. This method expects that this value is provided
     *     *relative to the whole page of the receiver* and that the receiver is
     *     positioned in some fashion.
     * @param {TP.gui.Point|TP.core.Hash|Array|Number} aPointOrObject A
     *     TP.gui.Point to use or an object that has an 'x' slot or an Array
     *     that has x in the first position or a Number.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var xVal,

        elem,

        offsetParent,
        offsets,
        styleObj;

    if (TP.isKindOf(aPointOrObject, TP.gui.Point)) {
        xVal = aPointOrObject.getX();
    } else if (TP.isHash(aPointOrObject)) {
        xVal = aPointOrObject.at('x');
    } else if (TP.isArray(aPointOrObject)) {
        xVal = aPointOrObject.at(0);
    } else if (TP.isPlainObject(aPointOrObject)) {
        xVal = aPointOrObject.x;
    } else {
        xVal = aPointOrObject;
    }

    elem = this.getNativeNode();

    //  The offsetParent can be null if the element is position: fixed.
    offsetParent = TP.elementGetOffsetParent(elem);
    if (TP.isElement(offsetParent)) {
        offsets = TP.elementGetOffsetFromContainer(offsetParent);
    } else {
        offsets = TP.ac(0, 0);
    }

    styleObj = TP.elementGetStyleObj(elem);

    /* eslint-disable no-extra-parens */
    styleObj.left = (xVal - offsets.first()) + 'px';
    /* eslint-enable no-extra-parens */

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setPageY',
function(aPointOrObject) {

    /**
     * @method setPageY
     * @summary Sets the Y position of the receiver by manipulating its top
     *     style property. This method expects that this value is provided
     *     *relative to the whole page of the receiver* and that the receiver is
     *     positioned in some fashion.
     * @param {TP.gui.Point|TP.core.Hash|Array|Number} aPointOrObject A
     *     TP.gui.Point to use or an object that has an 'y' slot or an Array
     *     that has y in the first position or a Number.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var yVal,

        elem,

        offsetParent,
        offsets,
        styleObj;

    if (TP.isKindOf(aPointOrObject, TP.gui.Point)) {
        yVal = aPointOrObject.getY();
    } else if (TP.isHash(aPointOrObject)) {
        yVal = aPointOrObject.at('y');
    } else if (TP.isArray(aPointOrObject)) {
        yVal = aPointOrObject.at(1);
    } else if (TP.isPlainObject(aPointOrObject)) {
        yVal = aPointOrObject.y;
    } else {
        yVal = aPointOrObject;
    }

    elem = this.getNativeNode();

    //  The offsetParent can be null if the element is position: fixed.
    offsetParent = TP.elementGetOffsetParent(elem);
    if (TP.isElement(offsetParent)) {
        offsets = TP.elementGetOffsetFromContainer(offsetParent);
    } else {
        offsets = TP.ac(0, 0);
    }

    styleObj = TP.elementGetStyleObj(elem);

    /* eslint-disable no-extra-parens */
    styleObj.top = (yVal - offsets.last()) + 'px';
    /* eslint-enable no-extra-parens */

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setStyleProperty',
function(aProperty, aPropertyValue) {

    /**
     * @method setStyleProperty
     * @summary Sets the receiver's style property named by the supplied
     *     property name.
     * @param {String} aProperty The name of the style property to set.
     * @param {String|Number} aPropertyValue The value to set the style property
     *     to.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    TP.elementSetStyleProperty(this.getNativeNode(), aProperty, aPropertyValue);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setTransform',
function(aTransformStr) {

    /**
     * @method setTransform
     * @summary Sets the CSS transform of the receiver using the supplied
     *     String (which should conform to one of the values specified in the
     *     CSS Transform specification).
     * @param {String} aTransformStr The value to set on the receiver as its CSS
     *     Transform.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    TP.elementSetTransform(this.getNativeNode(), aTransformStr);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setTransformOrigin',
function(xValue, yValue, zValue) {

    /**
     * @method setTransformOrigin
     * @summary Sets the transformation origin of the receiver using the
     *     supplied X and Y and (possibly) Z values.
     * @description The X and Y values supplied to this method can be any CSS
     *     'length' value (i.e. a number with a unit or a percentage) or one of
     *     the approved CSS keywords. If a Number is supplied, 'px' is assumed.
     *     The Z value must be a length, not keyword or percentage.
     * @param {Number|String} xValue The 'X value' to set the transformation
     *     origin to.
     * @param {Number|String} yValue The 'Y value' to set the transformation
     *     origin to.
     * @param {Number|String} [zValue] The 'Z value' to set the transformation
     *     origin to. Note that this *cannot* be a keyword or percentage.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    TP.elementSetTransformOrigin(this.getNativeNode(), xValue, yValue, zValue);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setWidth',
function(aWidth) {

    /**
     * @method setWidth
     * @summary Sets the receiver's width.
     * @description If a Number is supplied to aWidth a default unit of 'px' is
     *     assumed.
     * @param {Number|String} aWidth The width dimension to set the receiver's
     *     width to.
     */

    return TP.elementSetWidth(this.getNativeNode(), aWidth);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('show',
function() {

    /**
     * @method show
     * @summary Show's the receiver's node.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    TP.elementShow(this.getNativeNode());

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('signalUsingFacetAndValue',
function(facetName, facetValue) {

    /**
     * @method signalUsingFacetAndValue
     * @summary Signals one of the UI state change signals based on the facet
     *     name and value supplied.
     * @param {String} facetName The name of the facet to use to compute the
     *     signal to send.
     * @param {Boolean} facetValue The value of the facet to use to compute the
     *     signal to send.
     * @returns {Object} The receiver.
     */

    var signalName;

    //  Generate a proper signal name based on the facet name and whether the
    //  value is true or false

    switch (facetName) {

        case 'readonly':

            if (TP.isTrue(facetValue)) {
                signalName = 'TP.sig.UIReadonly';
            } else {
                signalName = 'TP.sig.UIReadwrite';
            }

            break;

        case 'relevant':

            if (TP.isTrue(facetValue)) {
                signalName = 'TP.sig.UIEnabled';
            } else {
                signalName = 'TP.sig.UIDisabled';
            }

            break;

        case 'required':

            if (TP.isTrue(facetValue)) {
                signalName = 'TP.sig.UIRequired';
            } else {
                signalName = 'TP.sig.UIOptional';
            }

            break;

        case 'valid':

            if (TP.isTrue(facetValue)) {
                signalName = 'TP.sig.UIValid';
            } else {
                signalName = 'TP.sig.UIInvalid';
            }

            break;

        default:
            signalName = 'TP.sig.ValueChange';
            break;
    }

    //  Signal the signal name - because the signals above are all responder
    //  policy signals, this will trigger this object's handler as part of the
    //  responder chain. Note we supply the facet name here as a convenience.
    this.signal(signalName, TP.hc('facet', facetName));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('smartScrollIntoView',
function(direction, wantsTransformed) {

    /**
     * @method smartScrollIntoView
     * @summary Scrolls the receiver into view if necessary.
     * @param {String} [direction] The direction to test visibility in. If
     *     specified, this should be either TP.HORIZONTAL or TP.VERTICAL. If
     *     this is not specified, then both directions will be tested.
     * @param {Boolean} wantsTransformed An optional parameter that determines
     *     whether to use 'transformed' values if the element has been
     *     transformed with a CSS transformation. The default is false.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var elem,

        offsetParentRect,
        ourPoint,

        corner;

    elem = this.getNativeNode();

    //  If we're already visible, just exit here.
    if (TP.elementIsVisible(elem, false, direction, wantsTransformed)) {
        return this;
    }

    //  Get our offsetParent's global rect and our global (top, left) point
    offsetParentRect = this.getOffsetParent().getGlobalRect(wantsTransformed);
    ourPoint = this.getGlobalPoint(wantsTransformed);

    //  Get the 'compass corner' for our global point within our offsetParent's
    //  global rect.
    corner = offsetParentRect.getCompassCorner(ourPoint);

    switch (corner) {
        case TP.NORTH:
        case TP.NORTHEAST:
        case TP.NORTHWEST:

            //  It's towards the top - scroll up.
            elem.scrollIntoView(true);
            break;

        case TP.SOUTHEAST:
        case TP.SOUTH:
        case TP.SOUTHWEST:

            //  It's towards the bottom - scroll up.
            elem.scrollIntoView(false);
            break;

        case TP.EAST:
        case TP.WEST:
            //  Pure TP.EAST or TP.WEST will scroll to the bottom by default.
            elem.scrollIntoView(false);
            break;

        default:
            break;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('stylesheetReady',
function(aStyleTPElem) {

    /**
     * @method stylesheetReady
     * @summary A method that is invoked when the supplied stylesheet is
     *     'ready', which means that it's attached to the receiver's Document
     *     and all of it's style has been parsed and applied.
     * @description Typically, the supplied stylesheet Element is the one that
     *     the receiver is waiting for so that it can finalized style
     *     computations. This could be either the receiver's 'core' stylesheet
     *     or it's current 'theme' stylesheet, if the receiver is executing in a
     *     themed environment.
     * @param {TP.html.style} aStyleTPElem The XHTML 'style' element that is
     *     ready.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('yieldFocusedResponder',
function(focusingElement) {

    /**
     * @method yieldFocusedResponder
     * @summary Asks the receiver to yield its role as 'focused responder'.
     * @description At this level, this type just returns true, but subtypes may
     *     run various checks for valid values, etc. and return false if those
     *     checks don't pass.
     * @param {TP.dom.UIElementNode} focusingElement The element that the focus
     *     is moving to. This might be null if we aren't being asked to yield
     *     focus because of the TIBET focus manager.
     * @returns {Boolean} Whether or not the receiver should yield focused
     *     responder status.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('toggleDisplay',
function() {

    /**
     * @method toggleDisplay
     * @summary Toggles the 'display' of the receiver from 'node' to it's
     *     default display state or vice-versa, depending on the current
     *     visibility state.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var elem;

    elem = this.getNativeNode();

    if (TP.elementIsDisplayed(elem)) {
        TP.elementHide(elem);
    } else {
        TP.elementShow(elem);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('toggleVisibility',
function() {

    /**
     * @method toggleVisibility
     * @summary Toggles the 'visibility' of the receiver from 'hidden' to
     *     'visible' or vice-versa, depending on the current visibility state.
     * @exception TP.sig.InvalidStyleDeclaration
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var elem,

        styleObj,
        computedStyle;

    elem = this.getNativeNode();

    //  Grab the style object for the element
    if (TP.notValid(styleObj = TP.elementGetStyleObj(elem))) {
        return this.raise('TP.sig.InvalidStyleDeclaration');
    }

    //  Grab the computed style object for the element
    if (TP.notValid(computedStyle = TP.elementGetComputedStyleObj(elem))) {
        return this.raise('TP.sig.InvalidStyleDeclaration');
    }

    if (computedStyle.visibility === 'visible') {
        styleObj.visibility = 'hidden';
    } else {
        styleObj.visibility = 'visible';
    }

    return this;
});

//  ------------------------------------------------------------------------
//  LOCAL CSS TRANSFORMS
//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('addLocalTransform',
function(transformType, varargs) {

    /**
     * @method addLocalTransform
     * @summary Adds a "local" transform to the receiver. This will be a CSS3
     *     transform that will affect just the receiver by using it's local
     *     '.style' attribute.
     * @param {String} transformType The type of transformation to add to the
     *     local transformations. This should be one of the following:
     *     TP.ROTATE, TP.SKEW, TP.SCALE,
     *     TP.TRANSLATE.
     * @param {arguments} varargs One or more additional arguments to provide to
     *     configure the transform.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var localTransforms;

    //  If our native node already has an attribute that contains the local
    //  transforms, we use that (decoding it's value from the string JSON
    //  representation that is used). Otherwise, we create one.
    if (TP.isEmpty(localTransforms = this.getAttribute('local-transforms'))) {
        localTransforms = TP.ac();
    } else {
        localTransforms = TP.json2js(localTransforms);
    }

    //  Push on a TP.core.Hash containing the transform type and an Array
    //  containing the arguments to this method (after slicing off the transform
    //  type).
    localTransforms.push(
        TP.hc('type', transformType, 'args', TP.ac(arguments).slice(1)));

    //  JSONify the local transforms data structure and set the attribute.
    this.setAttribute('local-transforms', TP.js2json(localTransforms));

    //  Set the local transform style from the local transforms that we're
    //  managing.
    this.setTransformFromLocalTransforms();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('generateCSSValueFromTransformRecord',
function(aTransformRecord) {

    /**
     * @method generateCSSValueFromTransformRecord
     * @summary Generates a CSS value from the supplied transform 'record'.
     * @description A transform record consists of a TP.core.Hash that has two
     *     keys: the transform 'type' that should consist of one of the
     *     following values: TP.ROTATE, TP.SKEW, TP.SCALE, TP.TRANSLATE and the
     *     transform 'args', which are arguments to the transformation.
     * @param {TP.core.Hash} aTransformRecord The transformation record to use
     *     to generate the CSS value.
     * @exception TP.sig.InvalidParameter
     * @returns {String} The generated CSS value String.
     */

    var str,
        transformArgs;

    if (TP.notValid(aTransformRecord)) {
        return this.raise('TP.sig.InvalidParameter',
                            'Must supply a valid transform record.');
    }

    str = '';

    transformArgs = aTransformRecord.at('args');

    switch (aTransformRecord.at('type')) {

        case TP.ROTATE:

            str += 'rotate(' +
                    transformArgs + 'deg)';

            break;

        case TP.SKEW:

            str += 'skewX(' +
                    transformArgs.first() + 'deg) ' +
                    'skewY(' +
                    transformArgs.last() + 'deg)';

            break;

        case TP.SCALE:

            str += 'scaleX(' +
                    transformArgs.first() + ') ' +
                    'scaleY(' +
                    transformArgs.last() + ')';

            break;

        case TP.TRANSLATE:

            str += 'translateX(' +
                    transformArgs.first() + 'px) ' +
                    'translateY(' +
                    transformArgs.last() + 'px)';
            break;

        default:
            break;
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getLocalTransformValue',
function(transformType, transformIndex) {

    /**
     * @method getLocalTransformValue
     * @summary Returns the values of a particular local transform that has
     *     been added to the receiver as a CSS value.
     * @param {String} transformType The type of transformation to return the
     *     CSS value of. This should be one of the following:
     *     TP.ROTATE, TP.SKEW, TP.SCALE, TP.TRANSLATE, TP.ANY.
     * @param {Number} transformIndex The index of the transform to return the
     *     CSS value of. If this argument is not supplied or invalid, 0 (the
     *     first transform of the specified type) is assumed.
     * @returns {String} The generated CSS value String.
     */

    var localTransforms,

        recordIndex,

        transformRecords,
        typeIndex;

    //  If our native node has an attribute that contains the local transforms,
    //  we use that. Otherwise, there is nothing to do here, so we exit here.
    if (TP.isEmpty(localTransforms = this.getAttribute('local-transforms'))) {
        return '';
    } else {
        localTransforms = TP.json2js(localTransforms);
    }

    //  If a Number wasn't supplied in the transformIndex, we assume a value of
    //  0.
    recordIndex = TP.ifInvalid(transformIndex, 0);

    transformRecords = null;

    //  Find the transform, given our transform type and index
    if (transformType === TP.ANY) {
        //  We're looking for any transform - just return the one at that index.
        return this.generateCSSValueFromTransformRecord(
                                    localTransforms.at(recordIndex));
    } else {
        //  We're looking for a particular type of transform at a particular
        //  index. Keep track of the index which will increment every time we
        //  encounter a transform of that type.
        typeIndex = 0;
        transformRecords = localTransforms.select(
            function(aTransformRecord) {
                if (aTransformRecord.at('type') === transformType) {
                    if (typeIndex === recordIndex) {
                        return aTransformRecord;
                    }
                    typeIndex++;
                }
            });
    }

    //  We found a valid transform record - generate a CSS value from it and
    //  return that.
    if (TP.notEmpty(transformRecords)) {
        return this.generateCSSValueFromTransformRecord(
                                    transformRecords.first());
    }

    return '';
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('removeAllLocalTransforms',
function() {

    /**
     * @method removeAllLocalTransforms
     * @summary Removes all of the local transforms from the receiver.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    return this.removeLocalTransform(TP.ANY, TP.ALL);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('removeLocalTransform',
function(transformType, transformIndex) {

    /**
     * @method removeLocalTransform
     * @summary Removes a particular local transform from the receiver.
     * @param {String} transformType The type of transformation to remove.
     *     This should be one of the following:
     *     TP.ROTATE, TP.SKEW, TP.SCALE, TP.TRANSLATE, TP.ANY.
     * @param {Number} transformIndex The index of the transform to remove.
     *     If this argument is not supplied or invalid, 0 (the first transform
     *     of the specified type) is assumed. This argument can also have a
     *     value of TP.ALL, in which case all transforms of the specified type
     *     will be removed.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var localTransforms,

        recordIndex,

        transformRecords,

        typeIndex,

        i,
        len;

    //  If our native node has an attribute that contains the local transforms,
    //  we use that. Otherwise, there is nothing to do here, so we exit here.
    if (TP.isEmpty(localTransforms = this.getAttribute('local-transforms'))) {
        return this;
    } else {
        localTransforms = TP.json2js(localTransforms);
    }

    //  If a value wasn't supplied in the transformIndex, we assume a value of
    //  0.
    recordIndex = TP.ifInvalid(transformIndex, 0);

    if (transformType === TP.ANY && recordIndex === TP.ALL) {
        transformRecords = TP.ac();
    } else {
        transformRecords = localTransforms;

        //  If it's any kind of transform, then just splice out the one at the
        //  recordIndex
        if (transformType === TP.ANY) {
            transformRecords.splice(recordIndex, 1);
        } else {
            typeIndex = 0;

            len = transformRecords.getSize();
            for (i = 0; i < len; i++) {
                if (transformRecords.at(i).at('type') === transformType) {
                    if (recordIndex === TP.ALL) {
                        transformRecords.splice(i, 1);
                        len--;
                        i--;
                    } else if (recordIndex === typeIndex) {
                        transformRecords.splice(i, 1);
                        break;
                    }
                    typeIndex++;
                }
            }
        }
    }

    //  JSONify the local transforms data structure and set the attribute.
    this.setAttribute('local-transforms', TP.js2json(transformRecords));

    //  Set the local transform style from the local transforms that we're
    //  managing.
    this.setTransformFromLocalTransforms();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('rotate',
function(degrees) {

    /**
     * @method rotate
     * @summary Rotates the receiver by the amount indicated by using a 'local
     *     transformation'.
     * @param {Number} degrees The amount in degrees to rotate the receiver
     *     by.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    this.addLocalTransform(TP.ROTATE, degrees);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('scale',
function(x, y) {

    /**
     * @method scale
     * @summary Scales the receiver by the amount indicated by using a 'local
     *     transformation'. Note that, if the 'y' value isn't supplied, it is
     *     defaulted to the 'x' value.
     * @param {Number} x The amount to scale the receiver along the X axis.
     * @param {Number} y The amount to scale the receiver along the Y axis.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var yVal;

    //  If a Y value wasn't supplied, use x
    yVal = TP.ifInvalid(y, x);

    this.addLocalTransform(TP.SCALE, x, yVal);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setLocalTransform',
function(transformType, transformIndex, varargs) {

    /**
     * @method setLocalTransform
     * @summary Sets the values of a particular local transform that has been
     *     added for the receiver.
     * @param {String} transformType The type of transformation to set the
     *     values of. This should be one of the following:
     *     TP.ROTATE, TP.SKEW, TP.SCALE, TP.TRANSLATE, TP.ANY.
     * @param {Number} transformIndex The index of the transform to set the
     *     values of. If this argument is not supplied or invalid, 0 (the first
     *     transform of the specified type) is assumed.
     * @param {arguments} varargs One or more additional arguments to provide to
     *     configure the transform.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var localTransforms,

        recordIndex,

        transformRecords,
        typeIndex;

    //  If our native node has an attribute that contains the local transforms,
    //  we use that. Otherwise, there is nothing to do here, so we exit here.
    if (TP.isEmpty(localTransforms = this.getAttribute('local-transforms'))) {
        return this;
    } else {
        localTransforms = TP.json2js(localTransforms);
    }

    //  If a Number wasn't supplied in the transformIndex, we assume a value of
    //  0.
    recordIndex = TP.ifInvalid(transformIndex, 0);

    //  Find the transform, given our transform type and index
    if (transformType === TP.ANY) {
        //  We're looking for any transform - just return the one at that index
        //  (but wrap it in an Array for use below).
        transformRecords = TP.ac(localTransforms.at(recordIndex));
    } else {
        //  We're looking for a particular type of transform at a particular
        //  index. Keep track of the index which will increment every time we
        //  encounter a transform of that type.
        typeIndex = 0;
        transformRecords = localTransforms.select(
                    function(aTransformRecord) {
                        if (aTransformRecord.at('type') === transformType) {
                            if (typeIndex === recordIndex) {
                                return true;
                            }
                            typeIndex++;
                        }
                    });
    }

    //  Couldn't find any transform records matching our criteria - bail out.
    if (TP.isEmpty(transformRecords)) {
        return this;
    }

    //  Get the first TP.core.Hash in the result array and put new arguments
    //  into it's 'args' Array that are the arguments to this method (after
    //  slicing off the transform type and index).
    transformRecords.first().atPut('args', TP.ac(arguments).slice(2));

    //  JSONify the local transforms data structure and set the attribute.
    this.setAttribute('local-transforms', TP.js2json(localTransforms));

    //  Set the local transform style from the local transforms that we're
    //  managing.
    this.setTransformFromLocalTransforms();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setTransformFromLocalTransforms',
function() {

    /**
     * @method setTransformFromLocalTransforms
     * @summary Sets the receiver's CSS3 'transforms' style property to the
     *     local transforms that have been populated on the receiver by adding
     *     them.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var localTransforms,
        transformStr;

    //  If our native node does not have an attribute that contains the local
    //  transforms, there is nothing to do, so we set the CSS3 transform to
    //  nothing and exit here.
    if (!this.hasAttribute('local-transforms')) {
        this.setTransform('');

        return this;
    }

    //  If our native node has no local transforms, there is nothing to do, so
    //  we exit here.
    if (TP.isEmpty(localTransforms = this.getAttribute('local-transforms'))) {
        return this;
    } else {
        localTransforms = TP.json2js(localTransforms);
    }

    transformStr = '';

    //  Loop over the local transforms and build up a String containing their
    //  'CSS value'.
    localTransforms.perform(
        function(aRecord) {
            transformStr +=
                    this.generateCSSValueFromTransformRecord(aRecord) + ' ';
        }.bind(this));

    //  Set the CSS transform to the generated String
    this.setTransform(transformStr);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('skew',
function(x, y) {

    /**
     * @method skew
     * @summary Skews the receiver by the amount indicated by using a 'local
     *     transformation'. Note that, if the 'y' value isn't supplied, it is
     *     defaulted to the 'x' value.
     * @param {Number} x The amount in degrees to skew the receiver along the X
     *     axis.
     * @param {Number} y The amount in degrees to skew the receiver along the Y
     *     axis.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var yVal;

    //  If a Y value wasn't supplied, use x
    yVal = TP.ifInvalid(y, x);

    this.addLocalTransform(TP.SKEW, x, yVal);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('translate',
function(x, y) {

    /**
     * @method translate
     * @summary Translates the receiver by the amount indicated by using a
     *     'local transformation'. Note that, if the 'y' value isn't supplied,
     *     it is defaulted to the 'x' value.
     * @param {Number} x The amount in pixels to translate the receiver along
     *     the X axis.
     * @param {Number} y The amount in pixels to translate the receiver along
     *     the Y axis.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var yVal;

    //  If a Y value wasn't supplied, use x
    yVal = TP.ifInvalid(y, x);

    this.addLocalTransform(TP.TRANSLATE, x, yVal);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('zoomToPoint',
function(aPoint, aDelta, incrementFactor, maximumScale) {

    /**
     * @method zoomToPoint
     * @summary Zooms around the point given, using the given delta, which is
     *     clamped to a value of -1 to 1.
     * @param {TP.gui.Point} aPoint The point to zoom around.
     * @param {Number} aDelta The amount of change in the zoom factor that will
     *     be made in this invocation of the call.
     * @param {Number} [incrementFactor=0.1] The factor to increment or
     *     decrement the zoom by.
     * @param {Number} [maximumScale=4] The maximum scaling factor to allow (the
     *     minimum scaling factor is 1).
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var width,
        height,

        delta,

        transformVals,

        position,
        scale,

        posX,
        posY,

        zoomTargetPoint,

        factor,
        maxScale;

    width = this.getWidth();
    height = this.getHeight();

    //  Keep delta to -1,1
    delta = Math.max(-1, Math.min(1, aDelta));

    //  Get the current set of transformation values. This is how the element is
    //  already transformed.
    transformVals = this.getTransformValues();

    //  Grab the scale first. We'll need to use that to compute the unscaled
    //  position.
    scale = transformVals.at(TP.SCALE).first();

    //  Compute the unscaled position. We need it unscaled so that we can use it
    //  along with the untransformed point that we've been handed.
    posX = transformVals.at(TP.TRANSLATE).first() / scale;
    posY = transformVals.at(TP.TRANSLATE).last() / scale;

    zoomTargetPoint = TP.pc(
        (aPoint.getX() - posX) / scale,
        (aPoint.getY() - posY) / scale);

    factor = TP.ifInvalid(incrementFactor, 0.1);
    maxScale = TP.ifInvalid(maximumScale, 4);

    scale += delta * factor * scale;
    scale = Math.max(1, Math.min(maxScale, scale));

    position = TP.pc(
        -zoomTargetPoint.getX() * scale + aPoint.getX(),
        -zoomTargetPoint.getY() * scale + aPoint.getY());

    //  Clamp the X values to some reasonable values.

    if (position.getX() > 0) {
        position.setX(0);
    }

    if (position.getX() + width * scale < width) {
        position.setX(-width * (scale - 1));
    }

    //  Clamp the Y values to some reasonable values.

    if (position.getY() > 0) {
        position.setY(0);
    }

    if (position.getY() + height * scale < height) {
        position.setY(-height * (scale - 1));
    }

    this.setTransform(
        'scale(' + scale + ',' + scale + ')' +
        ' translate(' + position.getX() + 'px,' + position.getY() + 'px)');

    this.setTransformOrigin(position.getX(), position.getY());

    return this;
});

//  ------------------------------------------------------------------------
//  STATE TESTING/MANIPULATION
//  ------------------------------------------------------------------------

/*
Most state flags in TIBET are stored as pclass: attributes on the elements.
This implies that for TIBET we see states as pseudo-classes, much like the
W3 might think of hover. Methods for checking/setting these states all use
the is* pattern common to Boolean attributes. TIBET's get() and set() calls
will look for is* as part of their lookup mechanisms so this all plays well
together.
*/

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('$isInState',
function(stateAttribute, stateFlag, shouldSignal) {

    /**
     * @method $isInState
     * @summary A combined setter/getter for manipulating a particular Boolean
     *     state attribute on the receiver.
     * @param {String} stateAttribute The name of the attribute which maintains
     *     this state.
     * @param {Boolean} stateFlag Optional parameter which defines the whether
     *     the state is in effect.
     * @param {Boolean} shouldSignal If false no signaling occurs. Defaults to
     *     this.shouldSignalChange().
     * @returns {Boolean} Whether the receiver's state is active.
     */

    var flag,

        parts,
        attrName;

    //  NB: we use the '$' versions of setAttribute/getAttribute here or
    //  otherwise we'll endlessly recurse.

    if (TP.isBoolean(stateFlag)) {
        if (stateFlag) {
            this.$setAttribute(stateAttribute, 'true', false);
        } else {
            this.$removeAttribute(stateAttribute, false);
        }

        //  NB: Use this construct this way for better performance
        if (TP.notValid(flag = shouldSignal)) {
            flag = this.shouldSignalChange();
        }

        if (flag) {

            //  if the attribute is namespace qualified, we 'start upper' each
            //  piece.
            //  e.g. 'foo:bar' -> 'FooBar'
            if (TP.regex.HAS_COLON.test(stateAttribute)) {
                parts = stateAttribute.split(/:/);
                attrName = TP.makeStartUpper(parts.first()) +
                            TP.makeStartUpper(parts.last());
            } else {

                //  Otherwise, we just 'start upper' the whole piece
                //  'foo' -> 'Foo'
                attrName = TP.makeStartUpper(stateAttribute);
            }

            this.$changed(attrName,
                            TP.UPDATE,
                            TP.hc('baseSignalType', TP.sig.AttributeChange));
        }
    }

    return this.hasAttribute(stateAttribute);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getAttrActive',
function() {

    /**
     * @method getAttrActive
     * @summary The getter for the receiver's active state.
     * @returns {Boolean} Whether the receiver's state is active.
     */

    return this.$isInState('pclass:active');
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getAttrBusy',
function() {

    /**
     * @method getAttrBusy
     * @summary The getter for the receiver's busy state.
     * @returns {Boolean} Whether the receiver's state is busy.
     */

    return this.$isInState('pclass:busy');
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getAttrClosed',
function() {

    /**
     * @method getAttrClosed
     * @summary The getter for the receiver's closed state.
     * @returns {Boolean} Whether the receiver's state is closed.
     */

    return this.$isInState('pclass:closed');
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getAttrDisabled',
function() {

    /**
     * @method getAttrDisabled
     * @summary The getter for the receiver's disabled state.
     * @returns {Boolean} Whether the receiver's state is disabled.
     */

    return this.$isInState('pclass:disabled');
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getAttrFocused',
function() {

    /**
     * @method getAttrFocused
     * @summary The getter for the receiver's focus state.
     * @returns {Boolean} Whether the receiver's state is focus.
     */

    return this.$isInState('pclass:focus');
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getAttrHidden',
function() {

    /**
     * @method getAttrHidden
     * @summary The getter for the receiver's hidden state.
     * @returns {Boolean} Whether the receiver's state is hidden.
     */

    return this.$isInState('pclass:hidden');
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getAttrInvalid',
function() {

    /**
     * @method getAttrInvalid
     * @summary The getter for the receiver's invalid state.
     * @returns {Boolean} Whether the receiver's state is invalid.
     */

    return this.$isInState('pclass:invalid');
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getAttrOutOfRange',
function() {

    /**
     * @method getAttrOutOfRange
     * @summary The getter for the receiver's out-of-range state.
     * @returns {Boolean} Whether the receiver's state is out-of-range.
     */

    return this.$isInState('pclass:out-of-range');
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getAttrReadonly',
function() {

    /**
     * @method getAttrReadonly
     * @summary The getter for the receiver's readonly state.
     * @returns {Boolean} Whether the receiver's state is readonly.
     */

    return this.$isInState('pclass:readonly');
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getAttrRequired',
function() {

    /**
     * @method getAttrRequired
     * @summary The getter for the receiver's required state.
     * @returns {Boolean} Whether the receiver's state is required.
     */

    return this.$isInState('pclass:required');
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getAttrSelected',
function() {

    /**
     * @method getAttrSelected
     * @summary The getter for the receiver's selected state.
     * @returns {Boolean} Whether the receiver's state is selected.
     */

    return this.$isInState('pclass:selected');
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setAttrActive',
function(beActive) {

    /**
     * @method setAttrActive
     * @summary The setter for the receiver's active state.
     * @param {Boolean} beActive Whether or not the receiver is in an active
     *     state.
     * @returns {Boolean} Whether the receiver's state is active.
     */

    this.$isInState('pclass:active', beActive);

    if (TP.isTrue(beActive)) {
        this.signal('TP.sig.UIDidActivate');
    } else {
        this.signal('TP.sig.UIDidDeactivate');
    }

    return this.$isInState('pclass:active');
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setAttrBusy',
function(beBusy, busyMsg) {

    /**
     * @method setAttrBusy
     * @summary The setter for the receiver's busy state.
     * @param {Boolean} beBusy Whether or not the receiver is in a busy state.
     * @param {String} busyMsg The message to display while busy.
     * @returns {Boolean} Whether the receiver's state is busy.
     */

    this.$isInState('pclass:busy', beBusy);

    if (TP.isTrue(beBusy)) {
        this.displayBusy(busyMsg);

        this.signal('TP.sig.UIDidBusy');
    } else {
        this.hideBusy();

        this.signal('TP.sig.UIDidIdle');
    }

    return this.$isInState('pclass:busy');
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setAttrClosed',
function(beClosed) {

    /**
     * @method setAttrClosed
     * @summary The setter for the receiver's closed state.
     * @param {Boolean} beClosed Whether or not the receiver is in a closed
     *     state.
     * @returns {Boolean} Whether the receiver's state is closed.
     */

    this.$isInState('pclass:closed', beClosed);

    if (TP.isTrue(beClosed)) {
        this.signal('TP.sig.UIDidClose');
    } else {
        this.signal('TP.sig.UIDidOpen');
    }

    return this.$isInState('pclass:closed');
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setAttrCollapsed',
function(beCollapsed) {

    /**
     * @method setAttrCollapsed
     * @summary The setter for the receiver's collapsed state.
     * @param {Boolean} beCollapsed Whether or not the receiver is in a
     *     collapsed state.
     * @returns {Boolean} Whether the receiver's state is collapsed.
     */

    this.$isInState('pclass:collapsed', beCollapsed);

    if (TP.isTrue(beCollapsed)) {
        this.signal('TP.sig.UIDidCollapse');
    } else {
        this.signal('TP.sig.UIDidExpand');
    }

    return this.$isInState('pclass:collapsed');
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setAttrDisabled',
function(beDisabled) {

    /**
     * @method setAttrDisabled
     * @summary The setter for the receiver's disabled state.
     * @param {Boolean} beDisabled Whether or not the receiver is in a disabled
     *     state.
     * @returns {Boolean} Whether the receiver's state is disabled.
     */

    if (TP.isTrue(beDisabled)) {

        //  Make sure to remove the pseudoclass attributes for active and focus
        //  when disabling.
        this.$isInState('pclass:active', false, false);
        this.$isInState('pclass:focus', false, false);

        //  We go ahead and set a generic 'disabled' attribute here that is used
        //  for (X)HTML. Note the '$setAttribute()' call to avoid calling back
        //  into ourself here. Note also how we do *not* signal change here.
        this.$setAttribute('disabled', true, false);
    } else {
        this.removeAttribute('disabled');
    }

    return this.$isInState('pclass:disabled', beDisabled);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setAttrFocused',
function(beFocused) {

    /**
     * @method setAttrFocused
     * @summary The setter for the receiver's focus state.
     * @param {Boolean} beFocused Whether or not the receiver is in a focus
     *     state.
     * @returns {Boolean} Whether the receiver's state is focused.
     */

    return this.$isInState('pclass:focus', beFocused);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setAttrHidden',
function(beHidden) {

    /**
     * @method setAttrHidden
     * @summary The setter for the receiver's hidden state.
     * @param {Boolean} beHidden Whether or not the receiver is in a hidden
     *     state.
     * @returns {Boolean} Whether the receiver's state is hidden.
     */

    this.$isInState('pclass:hidden', beHidden);

    if (TP.isTrue(beHidden)) {
        this.signal('TP.sig.UIDidHide');
    } else {
        this.signal('TP.sig.UIDidShow');
    }

    return this.$isInState('pclass:hidden');
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setAttrInvalid',
function(beInvalid) {

    /**
     * @method setAttrInvalid
     * @summary The setter for the receiver's invalid state.
     * @param {Boolean} beInvalid Whether or not the receiver is in a invalid
     *     state.
     * @returns {Boolean} Whether the receiver's state is invalid.
     */

    return this.$isInState('pclass:invalid', beInvalid);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setAttrOutOfRange',
function(beOutOfRange) {

    /**
     * @method setAttrOutOfRange
     * @summary The setter for the receiver's out-of-range state.
     * @param {Boolean} beOutOfRange Whether or not the receiver is in a
     *     out-of-range state.
     * @returns {Boolean} Whether the receiver's state is out-of-range.
     */

    return this.$isInState('pclass:out-of-range', beOutOfRange);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setAttrReadonly',
function(beReadonly) {

    /**
     * @method setAttrReadonly
     * @summary The setter for the receiver's readonly state.
     * @param {Boolean} beReadonly Whether or not the receiver is in a readonly
     *     state.
     * @returns {Boolean} Whether the receiver's state is readonly.
     */

    return this.$isInState('pclass:readonly', beReadonly);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setAttrRequired',
function(beRequired) {

    /**
     * @method setAttrRequired
     * @summary The setter for the receiver's required state.
     * @param {Boolean} beRequired Whether or not the receiver is in a required
     *     state.
     * @returns {Boolean} Whether the receiver's state is required.
     */

    return this.$isInState('pclass:required', beRequired);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setAttrSelected',
function(beSelected) {

    /**
     * @method setAttrSelected
     * @summary The setter for the receiver's selected state.
     * @param {Boolean} beSelected Whether or not the receiver is in a selected
     *     state.
     * @returns {Boolean} Whether the receiver's state is selected.
     */

    return this.$isInState('pclass:selected', beSelected);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('toggle',
function(stateName) {

    /**
     * @method toggle
     * @summary Toggles the value for a particular piece of the receiver's
     *     state. Note that if the attribute representing the state is not set
     *     on the receiver, that this will default to setting the attribute to
     *     true.
     * @param {String} stateName The name of the piece of state to toggle.
     * @returns {Boolean} The value of the piece of state after toggling it.
     */

    var attrName,
        stateValue;

    //  The attribute will have a 'pclass:' namespace prefix.
    attrName = 'pclass:' + stateName;

    if (this.hasAttribute(attrName)) {
        stateValue = TP.bc(this.getAttribute(stateName));
        stateValue = !stateValue;
    } else {
        stateValue = true;
    }

    this.setAttribute(stateName, stateValue);

    return TP.bc(this.getAttribute(stateName));
});

//  ------------------------------------------------------------------------
//  DISPLAY SUPPORT
//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('asyncActivatingFocusContext',
function() {

    /**
     * @method asyncActivatingFocusContext
     * @summary Prepares the system for a situation where a component with a
     *     different focus context than the currently focused element will want
     *     to focus, but do so in an asynchronous fashion. Therefore, we need to
     *     manage the focus stack in a slightly different fashion.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    TP.dom.UIElementNode.set('$asyncSwitchingContexts', true, false);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('blur',
function() {

    /**
     * @method blur
     * @summary Blurs the receiver for keyboard input.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var node,
        oldMBE;

    node = this.getNativeNode();

    /* Uncomment for low-level focus stack debugging
    console.log(
        'Invoking the "blur" method. The receiver is: \n' +
        TP.gid(node));
    */

    //  Note that we do not need to set our 'focused' attribute to 'false'
    //  here, since our event handler defined on our type does that whenever
    //  this node is focused, whether by this mechanism or some other user
    //  interaction.

    oldMBE = TP.dom.UIElementNode.get('$manuallyBlurringElement');
    TP.dom.UIElementNode.set('$manuallyBlurringElement', node, false);

    node.blur();

    TP.dom.UIElementNode.set('$manuallyBlurringElement', oldMBE, false);

    this.signal('TP.sig.UIBlur');

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('blurFocusedDescendantElement',
function() {

    /**
     * @method blurFocusedDescendantElement
     * @summary Blurs the currently focused element if it is a descendant of the
     *     receiver.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var node;

    node = this.getNativeNode();

    TP.elementBlurFocusedDescendantElement(node);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('focus',
function(moveAction) {

    /**
     * @method focus
     * @summary Focuses the receiver for keyboard input.
     * @param {String} moveAction The type of 'move' that the user requested.
     *     This can be one of the following:
     *          TP.FIRST
     *          TP.LAST
     *          TP.NEXT
     *          TP.PREVIOUS
     *          TP.FIRST_IN_GROUP
     *          TP.LAST_IN_GROUP
     *          TP.FIRST_IN_NEXT_GROUP
     *          TP.FIRST_IN_PREVIOUS_GROUP
     *          TP.FOLLOWING
     *          TP.PRECEDING.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var node,

        focusedElem,

        calculatedTPElem,
        calculatedFocusContext,

        oldMFE;

    node = this.getNativeNode();

    /* Uncomment for low-level focus stack debugging
    console.log(
        'Invoking the "focus" method. The receiver is: \n' +
        TP.gid(node));
    */

    //  If the element is disabled, then just bail here - no sense in going any
    //  further.
    if (TP.elementIsDisabled(node)) {
        return this;
    }

    //  First, see if there's a focused element (without considering the
    //  '.activeElement' property). Note that this may be null.
    focusedElem = TP.documentGetFocusedElement(node.ownerDocument, false);

    //  If so and it's identical to our native node, then just return.
    if (focusedElem === node) {
        return this;
    }

    //  Then, see if there's a focused element (including considering the
    //  '.activeElement')
    focusedElem = TP.documentGetFocusedElement(node.ownerDocument);

    //  If the focused element (including considering the '.activeElement') is
    //  the same as our native node and the top of the focus stack is the same
    //  as ourself, then just return here.
    if (focusedElem === node && TP.$focus_stack.last() === this) {
        return this;
    }

    //  If that's not identical to our native node, then calculate a focusing
    //  context (either from any set calculated focusing TP.dom.ElementNode or
    //  from ourself) and blur the currently focused element. This will cause
    //  focus stack management to occur.
    if (focusedElem !== node) {

        calculatedTPElem =
            TP.dom.UIElementNode.get('$calculatedFocusingTPElem');
        if (TP.isValid(calculatedTPElem)) {
            calculatedFocusContext = calculatedTPElem.getFocusContextElement();
        } else {
            calculatedFocusContext = this.getFocusContextElement();
        }

        TP.dom.UIElementNode.set('$calculatedFocusContext',
                                    calculatedFocusContext,
                                    false);

        TP.wrap(focusedElem).blur();
        TP.dom.UIElementNode.set('$calculatedFocusContext', null, false);
    }

    //  Grab whatever TIBET is trying to focus. If it's real, set 'node' to it.
    calculatedTPElem = TP.dom.UIElementNode.get('$calculatedFocusingTPElem');
    if (TP.isValid(calculatedTPElem)) {
        node = calculatedTPElem.getNativeNode();
    }

    //  Go ahead and call the native 'focus' routine (and set the 'manually
    //  focusing element' trap to avoid recursion).
    oldMFE = TP.dom.UIElementNode.get('$manuallyFocusingElement');
    TP.dom.UIElementNode.set('$manuallyFocusingElement', node, false);

    node.focus();

    TP.dom.UIElementNode.set('$manuallyFocusingElement', oldMFE, false);

    //  Signal that the node focused.
    TP.wrap(node).signal('TP.sig.UIFocus');

    //  We've done what TIBET asked and we've focused the element - set this to
    //  null.
    TP.dom.UIElementNode.set('$calculatedFocusingTPElem', null, false);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod(
'focusAutofocusedOrFirstFocusableDescendant',
function() {

    /**
     * @method focusAutofocusedOrFirstFocusableDescendant.
     * @summary Focuses either any descendant that has an 'autofocus' attribute
     *     or the first focusable descendant if an autofocusable descendant
     *     cannot be found.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var focusedAutofocus,
        focusables;

    //  Try to focus any descendant that has an 'autofocus' attribute.
    focusedAutofocus = TP.elementFocusAutofocusedElement(this.getNativeNode());

    //  Couldn't find one - focus the first focusable descendant.
    if (!focusedAutofocus) {

        //  Note here that we supply true to return 'tibet:group' elements as
        //  well - groups can be focused :-).
        focusables = this.findFocusableElements(true);
        if (TP.notEmpty(focusables)) {
            focusables.first().focus();
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('select',
function() {

    /**
     * @method select
     * @summary Selects the receiver for keyboard input (this also focuses the
     *     receiver).
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var node;

    node = this.getNativeNode();

    //  Set our attributes so that the proper visuals, etc. are showing that
    //  we are both selected and focused.

    this.setAttrSelected(true);
    this.setAttrFocused(true);

    //  TODO: Should we also invoke 'focus' here? If so, we won't need to
    //  set 'selected' above since the focus handler does that.

    if (TP.canInvoke(node, 'select')) {
        node.select();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('setSelected',
function(aFlag) {

    /**
     * @method setSelected
     * @summary Set whether or not the receiver is selected.
     * @param {Boolean} aFlag Whether or not the receiver should be selected.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    this.setAttrSelected(aFlag);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('toggleSelectedItem',
function(oldItem, newItem) {

    /**
     * @method toggleSelectedItem
     * @summary Sets the old item to be deselected and the new item to be
     *     selected.
     * @param {Element} oldItem The old element to deselect.
     * @param {Element} newItem The new element to select.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var item,
        deselectSignal;

    if (TP.isValid(oldItem)) {
        item = TP.wrap(oldItem);
        deselectSignal = item.signal('TP.sig.UIDeselect');

        //  Note how we make sure that the UIDeselect signal doesn't want it's
        //  default prevented before we proceed.
        if (deselectSignal.shouldPrevent()) {
            return this;
        }
    }

    if (TP.isValid(newItem)) {
        item = TP.wrap(newItem);
        item.signal('TP.sig.UISelect');
    }

    return this;
});

//  ------------------------------------------------------------------------
//  UI ACCESSORY DISPLAY
//  ------------------------------------------------------------------------

/*
Per XForms there are several "accessories" (our terminology) which can be
associated with an element. In particular, there is help, hint, and alert
content which can be associated with the element for display when particular
states or events are triggered. We add "busy" to this so that an element can
also be provided with content to display while loading data or performing
other processing that keeps its normal UI from being displayed.
*/

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('displayAlert',
function(content) {

    /**
     * @method displayAlert
     * @summary Displays alert content for the receiver, if any.
     * @param {String} content The alert content to be displayed.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    //  At this level, we do nothing. Override this method to take action.

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('displayBusy',
function(content) {

    /**
     * @method displayBusy
     * @summary Displays busy content for the receiver, if any.
     * @param {String} [content=""] The busy content to be displayed.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    TP.elementShowBusyMessage(this.getNativeNode(), content);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('displayHelp',
function(content) {

    /**
     * @method displayHelp
     * @summary Displays help content for the receiver, if any.
     * @param {String} content The help content to be displayed.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    //  At this level, we do nothing. Override this method to take action.

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('displayHint',
function(content) {

    /**
     * @method displayHint
     * @summary Displays hint content for the receiver, if any.
     * @param {String} content The hint content to be displayed.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    //  At this level, we do nothing. Override this method to take action.

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('hideAlert',
function() {

    /**
     * @method hideAlert
     * @summary Hides alert content for the receiver, if any.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    //  At this level, we do nothing.

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('hideBusy',
function() {

    /**
     * @method hideBusy
     * @summary Hides busy content for the receiver, if any.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    TP.elementHideBusyMessage(this.getNativeNode());

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('hideHelp',
function() {

    /**
     * @method hideHelp
     * @summary Hides help content for the receiver, if any.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    //  At this level, we do nothing.

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('hideHint',
function() {

    /**
     * @method hideHint
     * @summary Hides hint content for the receiver, if any.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    //  At this level, we do nothing.

    return this;
});

//  ------------------------------------------------------------------------
//  Focus Computation Handlers
//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIFocusFirst',
function(aSignal) {

    /**
     * @method handleUIFocusFirst
     * @param {TP.sig.UIFocusFirst} aSignal The signal that caused this handler
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    this.moveFocus(TP.FIRST);

    //  Make sure to stop the signal propagation here - we've already moved the
    //  focus.
    aSignal.stopPropagation();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIFocusLast',
function(aSignal) {

    /**
     * @method handleUIFocusLast
     * @param {TP.sig.UIFocusLast} aSignal The signal that caused this handler
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    this.moveFocus(TP.LAST);

    //  Make sure to stop the signal propagation here - we've already moved the
    //  focus.
    aSignal.stopPropagation();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIFocusNext',
function(aSignal) {

    /**
     * @method handleUIFocusNext
     * @param {TP.sig.UIFocusNext} aSignal The signal that caused this handler
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    this.moveFocus(TP.NEXT);

    //  Make sure to stop the signal propagation here - we've already moved the
    //  focus.
    aSignal.stopPropagation();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIFocusPrevious',
function(aSignal) {

    /**
     * @method handleUIFocusPrevious
     * @param {TP.sig.UIFocusPrevious} aSignal The signal that caused this
     *     handler trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    this.moveFocus(TP.PREVIOUS);

    //  Make sure to stop the signal propagation here - we've already moved the
    //  focus.
    aSignal.stopPropagation();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIFocusFollowing',
function(aSignal) {

    /**
     * @method handleUIFocusFollowing
     * @param {TP.sig.UIFocusFollowing} aSignal The signal that caused this
     *     handler trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    this.moveFocus(TP.FOLLOWING);

    //  Make sure to stop the signal propagation here - we've already moved the
    //  focus.
    aSignal.stopPropagation();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIFocusPreceding',
function(aSignal) {

    /**
     * @method handleUIFocusPreceding
     * @param {TP.sig.UIFocusPreceding} aSignal The signal that caused this
     *     handler trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    this.moveFocus(TP.PRECEDING);

    //  Make sure to stop the signal propagation here - we've already moved the
    //  focus.
    aSignal.stopPropagation();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIFocusFirstInGroup',
function(aSignal) {

    /**
     * @method handleUIFocusFirstInGroup
     * @param {TP.sig.UIFocusFirstInGroup} aSignal The signal that caused this
     *     handler trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    this.moveFocus(TP.FIRST_IN_GROUP);

    //  Make sure to stop the signal propagation here - we've already moved the
    //  focus.
    aSignal.stopPropagation();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIFocusLastInGroup',
function(aSignal) {

    /**
     * @method handleUIFocusLastInGroup
     * @param {TP.sig.UIFocusLastInGroup} aSignal The signal that caused this
     *     handler trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    this.moveFocus(TP.LAST_IN_GROUP);

    //  Make sure to stop the signal propagation here - we've already moved the
    //  focus.
    aSignal.stopPropagation();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIFocusFirstInPreviousGroup',
function(aSignal) {

    /**
     * @method handleUIFocusFirstInPreviousGroup
     * @param {TP.sig.UIFocusFirstInPreviousGroup} aSignal The signal that
     *     caused this handler trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    this.moveFocus(TP.FIRST_IN_PREVIOUS_GROUP);

    //  Make sure to stop the signal propagation here - we've already moved the
    //  focus.
    aSignal.stopPropagation();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIFocusFirstInNextGroup',
function(aSignal) {

    /**
     * @method handleUIFocusFirstInNextGroup
     * @param {TP.sig.UIFocusFirstInNextGroup} aSignal The signal that
     *     caused this handler trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    this.moveFocus(TP.FIRST_IN_NEXT_GROUP);

    //  Make sure to stop the signal propagation here - we've already moved the
    //  focus.
    aSignal.stopPropagation();

    return this;
});

//  ------------------------------------------------------------------------
//  Action Event Handlers
//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIActivate',
function(aSignal) {

    /**
     * @method handleUIActivate
     * @param {TP.sig.UIActivate} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.setAttrActive(true);
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIActivate'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIActivate', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIAlert',
function(aSignal) {

    /**
     * @method handleUIAlert
     * @summary Causes alert content to be displayed for the receiver. The
     *     alert content should be encoded into the signal payload.
     * @param {TP.sig.UIAlert} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.displayAlert(aSignal.getPayload().at('msg'));

        this.signal('TP.sig.UIDidAlert');
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIAlert'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIAlert', aSignal.at('trigger'));

    //  Make sure to stop the signal propagation here - we've already handled
    //  the alert signal.
    aSignal.stopPropagation();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIBlur',
function(aSignal) {

    /**
     * @method handleUIBlur
     * @summary Blurs the receiver's native control. For some controls this has
     *     the side-effect of deselecting any selections in the control.
     * @param {TP.sig.UIBlur} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var focusingTPElem;

    //  The receiver is the currently focused element, but TIBET's focus
    //  navigation machinery stashes a reference to the element we're going to
    //  next. If we're blurring but not coming through the TIBET focus manager,
    //  this will be null.

    focusingTPElem = TP.dom.UIElementNode.get('$calculatedFocusingTPElem');

    if (!this.shouldPerformUIHandler(aSignal) ||
        !this.yieldFocusedResponder(focusingTPElem)) {

        aSignal.preventDefault();

        return this;
    }

    //  We're blurring... set 'focused' to false.
    //  NOTE: We *MUST* do this *before* we try to resign the focused responder.
    //  Otherwise, when that method's machinery tries to compute the currently
    //  focused element, it will sometimes (depending on whether the new target
    //  already got a 'pclass:focus' attribute) warn that there are two elements
    //  that are currently focused.
    this.setAttrFocused(false);

    //  Go ahead and tell ourself to resign from being the focused responder
    this.resignFocusedResponder();

    this.signal('TP.sig.UIDidBlur');

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIBlur'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIBlur', aSignal.at('trigger'));

    //  Make sure to stop the signal propagation here - we've now blurred.
    aSignal.stopPropagation();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIBlurred',
function(aSignal) {

    /**
     * @method handleUIBlurred
     * @summary Causes the receiver to be put into its 'blurred state'.
     * @param {TP.sig.UIBlurred} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {

        if (this.getType().isResponderForUIFocusChange(
                                    this.getNativeNode(), aSignal)) {
            this.blur();
        }

        //  Make sure to stop the signal propagation here - we've already moved
        //  the focus.
        aSignal.stopPropagation();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIBusy',
function(aSignal) {

    /**
     * @method handleUIBusy
     * @summary Causes the receiver to be put into its 'busy state'. Content to
     *     be displayed as part of being busy should be encoded into the signal
     *     payload.
     * @param {TP.sig.UIBusy} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.setAttrBusy(true, aSignal.getPayload().at('msg'));
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIBusy'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIBusy', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIClose',
function(aSignal) {

    /**
     * @method handleUIClose
     * @summary Causes the receiver to be put into its 'closed state'.
     * @param {TP.sig.UIClose} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.setAttrClosed(true);
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIClose'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIClose', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UICollapse',
function(aSignal) {

    /**
     * @method handleUICollapse
     * @summary Collapses the receiver, if that's an appropriate action.
     * @param {TP.sig.UICollapse} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.setAttrCollapsed(true);
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UICollapse'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UICollapse', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIDeactivate',
function(aSignal) {

    /**
     * @method handleUIDeactivate
     * @param {TP.sig.UIDeactivate} aSignal The signal that caused this handler
     *     to trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.setAttrActive(false);
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIDeactivate'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIDeactivate', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIDelete',
function(aSignal) {

    /**
     * @method handleUIDelete
     * @param {TP.sig.UIDelete} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIDelete'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIDelete', aSignal.at('trigger'));

    TP.todo();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIDeselect',
function(aSignal) {

    /**
     * @method handleUIDeselect
     * @summary Deselects the receiver's native data.
     * @param {TP.sig.UIDeselect} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var node;

    if (this.shouldPerformUIHandler(aSignal)) {
        node = this.getNativeNode();

        //  focus and blur are handled by setAttrSelected when implemented
        if (TP.canInvoke(this, 'setAttrSelected')) {
            this.setAttrSelected(false);
        } else if (TP.canInvoke(node, 'blur')) {
            this.getNativeNode().blur();
        }

        this.removeAttribute('selected');

        this.signal('TP.sig.UIDidDeselect');
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIDeselect'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIDeselect', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIDidBlur',
function(aSignal) {

    /**
     * @method handleUIDidBlur
     * @param {TP.sig.UIDidBlur} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
    //  alert('got to did blur');
        void 0;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIDidFocus',
function(aSignal) {

    /**
     * @method handleUIDidFocus
     * @param {TP.sig.UIDidFocus} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
    //  alert('got to did focus');
        void 0;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIDidPopFocus',
function(aSignal) {

    /**
     * @method handleUIDidPopFocus
     * @param {TP.sig.UIDidPopFocus} aSignal The signal that caused this
     *     handler to trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        void 0;

        /*
        TP.ifInfo() ?
            TP.info('Popped the focus stack. Stack now has:\n' +
                 $focus_stack.collect(
                     function (item) {return item.asString()}).join('\n')) : 0;
        */
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIDidPushFocus',
function(aSignal) {

    /**
     * @method handleUIDidPushFocus
     * @param {TP.sig.UIDidPushFocus} aSignal The signal that caused this
     *     handler to trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        void 0;

        /*
        TP.ifInfo() ?
            TP.info('Pushed the focus stack. Stack now has:\n' +
                 $focus_stack.collect(
                     function (item) {return item.asString()}).join('\n')) : 0;
        */
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIDisabled',
function(aSignal) {

    /**
     * @method handleUIDisabled
     * @summary Causes the receiver to be put into its 'disabled state'.
     * @param {TP.sig.UIDisabled} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.setAttrDisabled(true);
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIDisabled'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIDisabled', aSignal.at('trigger'));

    //  By default, all GUI elements do not allow UIDisabled/UIEnabled signals
    //  to bubble outside of themselves. This prevents whole chunks of GUI from
    //  being inadvertently disabled such that they can never be enabled again.
    aSignal.stopPropagation();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIDuplicate',
function(aSignal) {

    /**
     * @method handleUIDuplicate
     * @param {TP.sig.UIDuplicate} aSignal The signal that caused this handler
     *     to trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIDuplicate'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIDuplicate', aSignal.at('trigger'));

    TP.todo();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIEnabled',
function(aSignal) {

    /**
     * @method handleUIEnabled
     * @summary Causes the receiver to be put into its 'enabled state'.
     * @param {TP.sig.UIEnabled} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.setAttrDisabled(false);
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIEnabled'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIEnabled', aSignal.at('trigger'));

    //  By default, all GUI elements do not allow UIDisabled/UIEnabled signals
    //  to bubble outside of themselves. This prevents whole chunks of GUI from
    //  being inadvertently disabled such that they can never be enabled again.
    aSignal.stopPropagation();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIExpand',
function(aSignal) {

    /**
     * @method handleUIExpand
     * @summary Expands the receiver, if that's an appropriate action.
     * @param {TP.sig.UIExpand} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.setAttrCollapsed(false);
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIExpand'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIExpand', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIFocus',
function(aSignal) {

    /**
     * @method handleUIFocus
     * @summary Focuses the receiver's native control.
     * @param {TP.sig.UIFocus} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (!this.shouldPerformUIHandler(aSignal) ||
        !this.acceptFocusedResponder()) {

        aSignal.preventDefault();

        return this;
    }

    //  Go ahead and tell ourself to become the focused responder
    this.becomeFocusedResponder();

    //  We're focusing... set 'focused' to true
    this.setAttrFocused(true);

    this.signal('TP.sig.UIDidFocus');

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIFocus'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIFocus', aSignal.at('trigger'));

    //  Make sure to stop the signal propagation here - we've now focused.
    aSignal.stopPropagation();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIFocusAndSelect',
function(aSignal) {

    /**
     * @method handleUIFocusAndSelect
     * @summary Focuses the receiver, and selects its active content.
     * @param {TP.sig.UIFocusAndSelect} aSignal The signal that caused this
     *     handler to trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        if (!this.acceptFocusedResponder()) {
            aSignal.preventDefault();
        } else {
            //  NB: This should automatically focus and, through a series of
            //  events, the 'UIFocus' handler above will be called.
            this.select();
        }

        //  Make sure to stop the signal propagation here - we've already moved
        //  the focus.
        aSignal.stopPropagation();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIFocused',
function(aSignal) {

    /**
     * @method handleUIFocused
     * @summary Causes the receiver to be put into its 'focused state'.
     * @param {TP.sig.UIFocused} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {

        if (this.getType().isResponderForUIFocusChange(
                                    this.getNativeNode(), aSignal)) {
            this.focus();
        }

        //  Make sure to stop the signal propagation here - we've already moved
        //  the focus.
        aSignal.stopPropagation();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIHelp',
function(aSignal) {

    /**
     * @method handleUIHelp
     * @summary Causes help content to be displayed for the receiver. The help
     *     content should be encoded into the signal payload.
     * @param {TP.sig.UIHelp} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.displayHelp(aSignal.getPayload().at('msg'));

        this.signal('TP.sig.UIDidHelp');
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIHelp'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIHelp', aSignal.at('trigger'));

    //  Make sure to stop the signal propagation here - we've already handled
    //  the help signal.
    aSignal.stopPropagation();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIHide',
function(aSignal) {

    /**
     * @method handleUIHide
     * @summary Hides the receiver, if that's an appropriate action.
     * @param {TP.sig.UIHide} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.setAttrHidden(true);
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIHide'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIHide', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIHint',
function(aSignal) {

    /**
     * @method handleUIHint
     * @summary Causes hint content to be displayed for the receiver. The hint
     *     content should be encoded into the signal payload.
     * @param {TP.sig.UIHint} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.displayHint(aSignal.getPayload().at('msg'));

        this.signal('TP.sig.UIDidHint');
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIHint'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIHint', aSignal.at('trigger'));

    //  Make sure to stop the signal propagation here - we've already handled
    //  the hint signal.
    aSignal.stopPropagation();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIIdle',
function(aSignal) {

    /**
     * @method handleUIIdle
     * @summary Causes the receiver to be put into its 'idle state'.
     * @param {TP.sig.UIIdle} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.setAttrBusy(false);
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIIdle'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIIdle', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIInRange',
function(aSignal) {

    /**
     * @method handleUIInRange
     * @summary Causes the receiver to be put into its 'in range state'.
     * @param {TP.sig.UIInRange} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.setAttrOfOutRange(false);
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIInRange'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIInRange', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIInsert',
function(aSignal) {

    /**
     * @method handleUIInsert
     * @param {TP.sig.UIInsert} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIInsert'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIInsert', aSignal.at('trigger'));

    TP.todo();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIInvalid',
function(aSignal) {

    /**
     * @method handleUIInvalid
     * @summary Causes the receiver to be put into its 'invalid state'.
     * @param {TP.sig.UIInvalid} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.setAttrInvalid(true);
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIInvalid'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIInvalid', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIOpen',
function(aSignal) {

    /**
     * @method handleUIOpen
     * @summary Causes the receiver to be put into its 'open state'.
     * @param {TP.sig.UIOpen} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.setAttrClosed(false);
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIOpen'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIOpen', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIOptional',
function(aSignal) {

    /**
     * @method handleUIOptional
     * @summary Causes the receiver to be put into its 'optional state'.
     * @param {TP.sig.UIOptional} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.setAttrRequired(false);
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIOptional'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIOptional', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIOutOfRange',
function(aSignal) {

    /**
     * @method handleUIOutOfRange
     * @summary Causes the receiver to be put into its 'out of range state'.
     * @param {TP.sig.UIOutOfRange} aSignal The signal that caused this handler
     *     to trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.setAttrOfOutRange(true);
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIOutOfRange'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIOutOfRange', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIReadonly',
function(aSignal) {

    /**
     * @method handleUIReadonly
     * @summary Causes the receiver to be put into its 'read only state'.
     * @param {TP.sig.UIReadonly} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.setAttrReadonly(true);
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIReadonly'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIReadonly', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIReadwrite',
function(aSignal) {

    /**
     * @method handleUIReadwrite
     * @summary Causes the receiver to be put into its 'read write state'.
     * @param {TP.sig.UIReadwrite} aSignal The signal that caused this handler
     *     to trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.setAttrReadonly(false);
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIReadwrite'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIReadwrite', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIRequired',
function(aSignal) {

    /**
     * @method handleUIRequired
     * @summary Causes the receiver to be put into its 'required state'.
     * @param {TP.sig.UIRequired} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.setAttrRequired(true);
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIRequired'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIRequired', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIScroll',
function(aSignal) {

    /**
     * @method handleUIScroll
     * @param {TP.sig.UIScroll} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIScroll'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIScroll', aSignal.at('trigger'));

    TP.todo();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UISelect',
function(aSignal) {

    /**
     * @method handleUISelect
     * @summary Selects the receiver's native data.
     * @param {TP.sig.UISelect} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var node;

    if (this.shouldPerformUIHandler(aSignal)) {
        node = this.getNativeNode();

        //  focus and blur are handled by setAttrSelected when implemented
        if (TP.canInvoke(this, 'setAttrSelected')) {
            this.setAttrSelected(true);
        } else if (TP.canInvoke(node, 'focus')) {
            node.focus();
        }

        this.setAttribute('selected', 'true');

        this.signal('TP.sig.UIDidSelect');
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UISelect'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UISelect', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIShow',
function(aSignal) {

    /**
     * @method handleUIShow
     * @summary Shows the receiver, if that's an appropriate action.
     * @param {TP.sig.UIShow} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.setAttrHidden(false);
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIShow'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIShow', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIToggle',
function(aSignal) {

    /**
     * @method handleUIToggle
     * @summary Causes the receiver to toggle the name of the state supplied in
     *     the signal payload. This state name is defaulted to 'closed'.
     * @param {TP.sig.UIToggle} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var stateName,

        toggled,
        toggleableStates;

    stateName = aSignal.atIfInvalid('stateName', 'closed');

    toggled = false;

    if (this.shouldPerformUIHandler(aSignal)) {

        toggleableStates = this.getType().get('toggleableStateNames');
        if (toggleableStates.contains(stateName)) {
            this.toggle(stateName);
            toggled = true;
        }
    }

    //  If the receiver has an 'on:' attribute matching this signal name
    //  (i.e. 'on:UIToggle'), then dispatch whatever signal is configured to
    //  fire when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIToggle', aSignal.at('trigger'));

    if (toggled) {
        aSignal.stopPropagation();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIValid',
function(aSignal) {

    /**
     * @method handleUIValid
     * @summary Causes the receiver to be put into its 'valid state'.
     * @param {TP.sig.UIValid} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldPerformUIHandler(aSignal)) {
        this.setAttrInvalid(false);
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIValid'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIValid', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIValueChange',
function(aSignal) {

    /**
     * @method handleUIValueChange
     * @param {TP.sig.UIValueChange} aSignal The signal that caused this
     *     handler to trip.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIValueChange'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIValueChange',
                                            aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------
//  Signaling Methods
//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('configureSignalFromAttributes',
function(aSignal) {

    /**
     * @method configureSignalFromAttributes
     * @summary Configures the supplied signal according to any 'ev:'
     *     attributes present on the receiver. These might include attributes to
     *     stop propagation of the signal, prevent the receiver from performing
     *     its default action for that kind of signal or configure the receiver
     *     to perform its action during the capturing phase of the signal
     *     processing.
     * @param {TP.sig.ResponderSignal} aSignal The signal to configure from any
     *     present 'ev:' attributes on the receiver.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    if (this.shouldStopSignal(aSignal)) {
        aSignal.stopPropagation();
    }

    if (this.shouldPreventSignal(aSignal)) {
        aSignal.preventDefault();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('shouldCaptureSignal',
function(aSignal) {

    /**
     * @method shouldCaptureSignal
     * @summary Returns whether or not the signal should be processed as a
     *     capturing signal based on whether the receiver has an 'ev:event'
     *     attribute that contains the supplied signal's name and an 'ev:phase'
     *     of 'capture'.
     * @param {TP.sig.ResponderSignal} aSignal The signal to check to see if it
     *     should be considered to be a 'capturing' signal.
     * @returns {Boolean} Whether or not the signal should be considered to be a
     *     'capturing' signal.
     */

    var node;

    node = this.getNativeNode();

    //  If our native node has an 'ev:event' attribute value matching that
    //  of the signal's name, then check to see if it has an 'ev:phase'
    //  attribute value of 'capture', which means that it would be capturing
    //  the signal.
    if (TP.elementHasAttributeValue(node,
                                    'ev:event',
                                    aSignal.getSignalName())) {
        if (TP.elementHasAttributeValue(node, 'ev:phase', 'capture')) {
            return true;
        }
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('shouldPerformUIHandler',
function(aSignal) {

    /**
     * @method shouldPerformUIHandler
     * @summary Returns whether or not the receiver should perform its UI
     *     handler. This method configures the signal from any 'ev:' attributes
     *     on the receiver and then returns true if the signal is *not*
     *     configured to prevent its default action.
     * @param {TP.sig.ResponderSignal} aSignal The signal to check to see if the
     *     receiver should perform its UI handler for the supplied signal.
     * @returns {Boolean} Whether or not the receiver should perform its UI
     *     handler for the supplied signal.
     */

    this.configureSignalFromAttributes(aSignal);

    return !aSignal.shouldPrevent();
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('shouldPreventSignal',
function(aSignal) {

    /**
     * @method shouldPreventSignal
     * @summary Returns whether or not the signal should be prevented from
     *     performing its default action based on whether the receiver has an
     *     'ev:event' attribute that contains the supplied signal's name and an
     *     'ev:defaultAction' of 'cancel'.
     * @param {TP.sig.ResponderSignal} aSignal The signal to check to see if it
     *     should be prevented.
     * @returns {Boolean} Whether or not the signal should be prevented.
     */

    var node;

    node = this.getNativeNode();

    //  If our native node has an 'ev:event' attribute value matching that
    //  of the signal's name, then check to see if it has an
    //  'ev:defaultAction' attribute value of 'cancel', which means that it
    //  would be cancelling the signal's default action.
    if (TP.elementHasAttributeValue(node,
                                    'ev:event',
                                    aSignal.getSignalName())) {
        if (TP.elementHasAttributeValue(node, 'ev:defaultAction', 'cancel')) {
            return true;
        }
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('shouldStopSignal',
function(aSignal) {

    /**
     * @method shouldStopSignal
     * @summary Returns whether or not the signal should be stopped from
     *     propagating based on whether the receiver has an 'ev:event' attribute
     *     that contains the supplied signal's name and an 'ev:propagate' of
     *     'stop'.
     * @param {TP.sig.ResponderSignal} aSignal The signal to check to see if it
     *     should be stopped.
     * @returns {Boolean} Whether or not the signal should be stopped.
     */

    var node;

    node = this.getNativeNode();

    //  If our native node has an 'ev:event' attribute value matching that
    //  of the signal's name, then check to see if it has an
    //  'ev:propagate' attribute value of 'stop', which means that it
    //  would be stopping propagation of the signal.
    if (TP.elementHasAttributeValue(node,
                                    'ev:event',
                                    aSignal.getSignalName())) {
        if (TP.elementHasAttributeValue(node, 'ev:propagate', 'stop')) {
            return true;
        }
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('signal',
function(aSignal, aPayload, aPolicy, aType, isCancelable, isBubbling) {

    /**
     * @method signal
     * @summary Signals activity to registered observers. Any additional
     *     arguments are passed to the registered handlers along with the origin
     *     and event.
     * @description We override the standard 'signal' method on this type to
     *     possibly alter the firing policy based on whether the signal was
     *     spoofed or not. In the core signaling system, if the signal is
     *     spoofed and a specific firing policy isn't supplied in this call,
     *     then TP.OBSERVER_FIRING is used. This call changes that so that, if a
     *     specific firing policy isn't supplied for a spoofed signal,
     *     TP.RESPONDER_FIRING is used.
     * @param {String|TP.sig.Signal} aSignal The signal to fire.
     * @param {Object} aPayload Optional argument object (unused in this
     *     override).
     * @param {Function} aPolicy A "firing" policy that will define how the
     *     signal is fired.
     * @param {String|TP.sig.Signal} aType A default type to use when the signal
     *     type itself isn't found and a new signal subtype must be created
     *     (unused in this override).
     * @param {Boolean} isCancelable Optional flag for dynamic signals defining
     *     if they can be cancelled.
     * @param {Boolean} isBubbling Optional flag for dynamic signals defining
     *     whether they bubble (when using TP.DOM_FIRING).
     * @returns {TP.sig.Signal} The signal instance which was fired.
     */

    var sigType,
        policy;

    //  Determine whether this is a spoofed signal by getting the signal type.
    if (TP.isString(aSignal)) {
        sigType = TP.sys.getTypeByName(TP.expandSignalName(aSignal));
    } else {
        sigType = aSignal.getType();
    }

    //  Capture any supplied policy.
    policy = aPolicy;

    //  If a policy wasn't explicitly provided, then use TP.RESPONDER_FIRING for
    //  spoofed signals.
    if (TP.notValid(policy)) {
        if (!TP.isType(sigType)) {
            policy = TP.RESPONDER_FIRING;
        } else {
            policy = sigType.getDefaultPolicy();
        }
    }

    //  Dispatch it with the computed firing policy.
    return this.dispatch(aSignal,
                            this.getNativeNode(),
                            aPayload,
                            policy,
                            isCancelable,
                            isBubbling);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('signalAfterNextRepaint',
function(aSignal, aPayload, aPolicy, aType, isCancelable, isBubbling) {

    /**
     * @method signalAfterNextRepaint
     * @summary Signals activity to registered observers, but does so just
     *     after the browser has repainted. This is useful when the signaler
     *     doesn't care about the possibility that the signal could be cancelled
     *     and wants the UI to update before the signal is fired.
     * @param {String|TP.sig.Signal} aSignal The signal to fire.
     * @param {Object} aPayload Optional argument object (unused in this
     *     override).
     * @param {Function} aPolicy A "firing" policy that will define how the
     *     signal is fired.
     * @param {String|TP.sig.Signal} aType A default type to use when the signal
     *     type itself isn't found and a new signal subtype must be created
     *     (unused in this override).
     * @param {Boolean} isCancelable Optional flag for dynamic signals defining
     *     if they can be cancelled.
     * @param {Boolean} isBubbling Optional flag for dynamic signals defining
     *     whether they bubble (when using TP.DOM_FIRING).
     * @returns {TP.sig.Signal}
     */

    var elem;

    elem = this.getNativeNode();

    (function() {
        //  do the actual dispatch work here using TIBET's standard
        //  TP.dispatch() call (this can handle keyboard events etc)
        return TP.dispatch(null, //  'V' will be computed from our native node
                            aSignal,
                            elem,
                            aPayload,
                            aPolicy,
                            isCancelable,
                            isBubbling);
    }).queueAfterNextRepaint(this.getNativeWindow());
});

//  ========================================================================
//  TP.dom.NonNativeUIElementNode
//  ========================================================================

/**
 * @type {TP.dom.NonNativeUIElementNode}
 * @summary A type that represents 'non-native' (to a User Agent) element nodes
 *     that need various things like stylesheets to be attached to a hosting DOM
 *     so that they can be rendered properly. This type is normally 'traited in'
 *     to other types.
 */

//  ------------------------------------------------------------------------

TP.dom.ElementNode.defineSubtype('dom.NonNativeUIElementNode');

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation
TP.dom.NonNativeUIElementNode.isAbstract(true);

//  ------------------------------------------------------------------------

TP.dom.NonNativeUIElementNode.Type.defineMethod('tagAttachStyle',
function(aRequest) {

    /**
     * @method tagAttachStyle
     * @summary Sets up runtime style for the element in aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var doc;

    //  We see if the request has a target document. If so, we use that as the
    //  document.
    if (!TP.isDocument(doc = aRequest.at('doc'))) {
        //  TODO: Raise an exception
        return;
    }

    this.addStylesheetTo(doc);

    return;
});

//  ------------------------------------------------------------------------

TP.dom.NonNativeUIElementNode.Type.defineMethod('tagCompile',
function(aRequest) {

    /**
     * @method tagCompile
     * @summary Convert the receiver into a format suitable for inclusion in a
     *     markup DOM.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     * @returns {Element} The new element.
     */

    var elem;

    //  Make sure that we have an element to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        return;
    }

    elem = TP.nodeCloneNode(elem);

    TP.elementSetGenerator(elem);

    return elem;
});

//  ========================================================================
//  TP.dom.UIDataElement
//  ========================================================================

TP.dom.UIElementNode.defineSubtype('UIDataElement');

//  Need specific subtypes to implement the actual data access.
TP.dom.UIDataElement.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.dom.UIDataElement.Type.defineMethod('tagDetachData',
function(aRequest) {

    /**
     * @method tagDetachData
     * @summary Tears down runtime machinery for the element in aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var elem,
        dataHref,
        dataURI,
        resource,
        tpElem;

    //  Make sure that we have a node to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        return;         //  TODO: Raise an exception
    }

    tpElem = TP.wrap(elem);

    //  If the element is being 'recast' (i.e. recompiled in place, usually when
    //  developing with the Sherpa), then just return here. We don't want to do
    //  any further processing to process/register/unregister data.
    if (tpElem.isRecasting()) {
        return;
    }

    //  If there's local (child node) data we can skip the remote resource href
    //  and related processing and just rely on the child content.
    if (tpElem.hasLocalData()) {
        return;
    }

    if (TP.notEmpty(dataHref = TP.elementGetAttribute(elem, 'name'))) {
        if (!TP.isURI(dataURI = TP.uc(dataHref))) {
            //  Raise an exception
            return this.raise('TP.sig.InvalidURI');
        }
    } else {
        //  No 'name' attribute.
        return;
    }

    //  If the element has local data, then we clear any underlying data if its
    //  a TP.core.Content object and unregister the URI (which will cause the
    //  URI's resource itself to be cleared/collected).
    if (tpElem.hasLocalData()) {
        //  NB: We assume 'async' of false here.
        resource = dataURI.getResource().get('result');

        //  If the new resource result is a content object of some sort (highly
        //  likely) then it should respond to 'setData' so set its data to null
        //  (which will cause it to ignore its data for *Change signals).
        if (TP.canInvoke(resource, 'setData')) {
            resource.setData(null);
        }

        dataURI.unregister();
    }

    //  We're done with this data - signal 'TP.sig.UIDataDestruct'.
    tpElem.signal('TP.sig.UIDataDestruct');

    //  Check and dispatch a signal from our attributes if one exists for this
    //  signal.
    tpElem.dispatchResponderSignalFromAttr('UIDataDestruct', null);

    return;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dom.UIDataElement.Inst.defineMethod('getContentType',
function(mimeType) {

    /**
     * @method getContentType
     * @summary Returns a result type that will either be a TIBET type from the
     *     name specified by the 'content' attribute on the receiver or, if
     *     that's not defined, the MIME type supplied to this method.
     * @param {String} mimeType The MIME type of the data. This will be used to
     *     guess the data type if the receiver doesn't have a 'content'
     *     defined on it.
     * @returns {TP.meta.lang.RootObject|String} The type object (or String as
     *     a fallback) to create for the supplied result data.
     */

    var contentType,
        tibetType;

    //  See if the user has define a 'content' attribute on us. If so, try
    //  to see if TIBET really has a Type matching that.
    if (TP.notEmpty(contentType = this.getAttribute('content'))) {
        tibetType = TP.sys.getTypeByName(contentType);
    }

    //  We still don't have a type for the result. If a MIME type was supplied,
    //  switch off of that.
    if (!TP.isType(tibetType)) {

        //  Depending on the MIME type, return a TIBET (or JS) type object that
        //  the result can be constructed with.

        switch (mimeType) {
            case TP.JSON_ENCODED:
                tibetType = TP.core.JSONContent;
                break;
            case TP.XML_ENCODED:
            case TP.XHTML_ENCODED:
            case TP.XSLT_ENCODED:
            case TP.ATOM_ENCODED:
            case TP.XMLRPC_ENCODED:
            case TP.SOAP_ENCODED:
                tibetType = TP.core.XMLContent;
                break;
            default:
                tibetType = String;
        }
    }

    return tibetType;
});

//  ------------------------------------------------------------------------

TP.dom.UIDataElement.Inst.defineMethod('isReadyToRender',
function() {

    /**
     * @method isReadyToRender
     * @summary Whether or not the receiver is 'ready to render'. For this type,
     *     this always returns true.
     * @returns {Boolean} Whether or not the receiver is ready to render.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.dom.UIDataElement.Inst.defineMethod('hasLocalData',
function() {

    /**
     * @method hasLocalData
     * @summary Does this element have local, not remote data. In particular,
     *     should it rely on child node content for example, over remote hrefs?
     * @returns {Boolean} Whether or not the receiver has local data.
     */

    return false;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETDHTMLTypes.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 */

//  ========================================================================
//  TP.dnd.DragResponder
//  ========================================================================

/**
 * @type {TP.dnd.DragResponder}
 * @summary A StateMachine event responder for simple drag operations.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('dnd.DragResponder');

TP.dnd.DragResponder.addTraits(TP.core.StateResponder);

//  need a drag responsder of a specific subtype
TP.dnd.DragResponder.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.dnd.DragResponder.Type.defineConstant(
'LOCK_X_TO_ELEMENT_X',
function(aDragResponder, aSignal, xyPoint) {

    var target,
        targetParent,

        val;

    target = aDragResponder.get('actionElement');
    targetParent = TP.elementGetOffsetParent(target);

    if (TP.isElement(targetParent)) {
        val = TP.elementGetPageX(targetParent) - TP.elementGetPageX(target);
    } else {
        val = TP.elementGetPageX(target);
    }

    xyPoint.setX(val);

    return;
});

//  ---

TP.dnd.DragResponder.Type.defineConstant(
'LOCK_Y_TO_ELEMENT_Y',
function(aDragResponder, aSignal, xyPoint) {

    var target,
        targetParent,

        val;

    target = aDragResponder.get('actionElement');
    targetParent = TP.elementGetOffsetParent(target);

    if (TP.isElement(targetParent)) {
        val = TP.elementGetPageY(targetParent) - TP.elementGetPageY(target);
    } else {
        val = TP.elementGetPageY(target);
    }

    xyPoint.setY(val);

    return;
});

//  ---

TP.dnd.DragResponder.Type.defineConstant(
'LOCK_X_TO_START_X',
function(aDragResponder, aSignal, xyPoint) {

    xyPoint.setX(aDragResponder.get('startSignal').getPageX() -
                    aDragResponder.get('$offsetPoint').getX());

    return;
});

//  ---

TP.dnd.DragResponder.Type.defineConstant(
'LOCK_Y_TO_START_Y',
function(aDragResponder, aSignal, xyPoint) {

    xyPoint.setY(aDragResponder.get('startSignal').getPageY() -
                    aDragResponder.get('$offsetPoint').getY());

    return;
});

//  ---

TP.dnd.DragResponder.Type.defineConstant(
'INCREMENT_X_BY',
function(aDragResponder, aSignal, xyPoint) {

    var incrVal,
        xVal,
        kallee;

    kallee = TP.dnd.DragResponder.INCREMENT_X_BY;

    /* eslint-disable no-extra-parens */
    if (TP.isNumber(incrVal = kallee.modifierData.at('increment'))) {
        xVal = xyPoint.getX();
        xVal = (((xVal + incrVal) / incrVal).floor()) * incrVal;

        xyPoint.setX(xVal);
    }
    /* eslint-enable no-extra-parens */

    return;
});

//  ---

TP.dnd.DragResponder.Type.defineConstant(
'INCREMENT_Y_BY',
function(aDragResponder, aSignal, xyPoint) {

    var incrVal,
        yVal,
        kallee;

    kallee = TP.dnd.DragResponder.INCREMENT_Y_BY;

    /* eslint-disable no-extra-parens */
    if (TP.isNumber(incrVal = kallee.modifierData.at('increment'))) {
        yVal = xyPoint.getY();
        yVal = (((yVal + incrVal) / incrVal).floor()) * incrVal;

        xyPoint.setY(yVal);
    }
    /* eslint-enable no-extra-parens */

    return;
});

//  ---

TP.dnd.DragResponder.Type.defineConstant(
'INCREMENT_X_AND_Y_BY',
function(aDragResponder, aSignal, xyPoint) {

    var incrXVal,
        xVal,

        incrYVal,
        yVal,
        kallee;

    kallee = TP.dnd.DragResponder.INCREMENT_X_AND_Y_BY;

    /* eslint-disable no-extra-parens */
    if (TP.isNumber(incrXVal = kallee.modifierData.at('incrementX'))) {
        xVal = xyPoint.getX();
        xVal = (((xVal + incrXVal) / incrXVal).floor()) * incrXVal;

        xyPoint.setX(xVal);
    }

    if (TP.isNumber(incrYVal = kallee.modifierData.at('incrementY'))) {
        yVal = xyPoint.getY();
        yVal = (((yVal + incrYVal) / incrYVal).floor()) * incrYVal;

        xyPoint.setY(yVal);
    }
    /* eslint-enable no-extra-parens */

    return;
});

//  ---

TP.dnd.DragResponder.Type.defineConstant(
'CLAMP_X_TO_OFFSET_PARENT',
function(aDragResponder, aSignal, xyPoint) {

    var target,
        targetParent,

        xVal;

    target = aDragResponder.get('actionElement');

    targetParent = TP.elementGetOffsetParent(target);

    xVal = xyPoint.getX();

    xVal = xVal.max(0);

    if (TP.isElement(targetParent)) {
        xVal = xVal.min(TP.elementGetWidth(targetParent) -
                        TP.elementGetWidth(target));
    } else {
        xVal = xVal.min(TP.elementGetWidth(target));
    }

    xyPoint.setX(xVal);

    return;
});

//  ---

TP.dnd.DragResponder.Type.defineConstant(
'CLAMP_Y_TO_OFFSET_PARENT',
function(aDragResponder, aSignal, xyPoint) {

    var target,
        targetParent,

        yVal;

    target = aDragResponder.get('actionElement');

    targetParent = TP.elementGetOffsetParent(target);

    yVal = xyPoint.getY();

    yVal = yVal.max(0);

    if (TP.isElement(targetParent)) {
        yVal = yVal.min(TP.elementGetHeight(targetParent) -
                        TP.elementGetHeight(target));
    } else {
        yVal = yVal.min(TP.elementGetHeight(target));
    }

    xyPoint.setY(yVal);

    return;
});

//  ---

TP.dnd.DragResponder.Type.defineConstant(
'CLAMP_X_AND_Y_TO_CONTAINER',
function(aDragResponder, aSignal, xyPoint) {

    var maxFittedRect,

        target,
        targetContainer,

        coords,

        targetRect,
        containerRect,

        maxPoint,
        kallee;

    kallee = TP.dnd.DragResponder.CLAMP_X_AND_Y_TO_CONTAINER;

    if (TP.notValid(maxFittedRect = kallee.tempData.at(
            'maxFittedRect'))) {
        target = aDragResponder.get('actionElement');

        targetContainer = kallee.modifierData.at('container');
        if (TP.notValid(targetContainer)) {
            targetContainer = TP.elementGetOffsetParent(target);
            if (!TP.isElement(targetContainer)) {
                targetContainer = TP.documentGetBody(
                                    TP.nodeGetDocument(target));
            }
        }

        coords = TP.elementGetPageBox(target,
                                        TP.BORDER_BOX,
                                        null,
                                        false);
        targetRect = TP.rtc(coords);

        coords = TP.elementGetPageBox(targetContainer,
                                        TP.CONTENT_BOX,
                                        null,
                                        false);
        containerRect = TP.rtc(coords);

        maxPoint = targetRect.maxFittedPoint(containerRect);
        maxFittedRect =
                TP.rtc(0,
                        0,
                        maxPoint.getX(),
                        maxPoint.getY());

        kallee.tempData.atPut('maxFittedRect', maxFittedRect);
    }

    xyPoint.clampToRect(maxFittedRect);

    return;
});

//  ---

TP.dnd.DragResponder.Type.defineConstant(
'CLAMP_X_TO_CSS_MINMAX',
function(aDragResponder, aSignal, xyPoint) {

    var actionElem,

        styleVals,

        minWidth,
        maxWidth;

    actionElem = aDragResponder.get('actionElement');
    styleVals = TP.elementGetComputedStyleValuesInPixels(
                    TP.ac('minWidth', 'maxWidth'));

    if (!TP.isNumber(minWidth = styleVals.at('minWidth'))) {
        minWidth = 0;
    }

    if (!TP.isNumber(maxWidth = styleVals.at('maxWidth'))) {
        //  Note here how we get the "content box", since that's what we're
        //  using when we set 'width'.
        maxWidth = TP.elementGetContentWidth(actionElem);
    }

    xyPoint.clampXToMinMax(minWidth, maxWidth);

    return;
});

//  ---

TP.dnd.DragResponder.Type.defineConstant(
'CLAMP_Y_TO_CSS_MINMAX',
function(aDragResponder, aSignal, xyPoint) {

    var actionElem,

        styleVals,

        minHeight,
        maxHeight;

    actionElem = aDragResponder.get('actionElement');
    styleVals = TP.elementGetComputedStyleValuesInPixels(
                    actionElem,
                    TP.ac('minHeight', 'maxHeight'));

    if (!TP.isNumber(minHeight = styleVals.at('minHeight'))) {
        minHeight = 0;
    }

    if (!TP.isNumber(maxHeight = styleVals.at('maxHeight'))) {
        //  Note here how we get the "content box", since that's what we're
        //  using when we set 'width'.
        maxHeight = TP.elementGetContentHeight(actionElem);
    }

    xyPoint.clampYToMinMax(minHeight, maxHeight);

    return;
});

//  ---

TP.dnd.DragResponder.Type.defineConstant(
'CLAMP_X_AND_Y_TO_RECT',
function(aDragResponder, aSignal, xyPoint) {

    var clampRect,
        kallee;

    kallee = TP.dnd.DragResponder.CLAMP_X_AND_Y_TO_RECT;

    if (TP.notValid(clampRect = kallee.tempData.at('clampData'))) {
        return;
    }

    if (!TP.isKindOf(clampRect, TP.gui.Rect)) {
        if (TP.isElement(clampRect)) {
            clampRect = TP.wrap(clampRect);
        }

        if (TP.isKindOf(clampRect, TP.dom.UIElementNode)) {
            clampRect = clampRect.getPageRect();
        } else {
            clampRect = TP.gui.Rect.construct(clampRect);
        }

        if (!TP.isKindOf(clampRect, TP.gui.Rect)) {
            clampRect = null;
        }

        kallee.tempData.atPut('clampData', clampRect);
    }

    xyPoint.clampToRect(clampRect);

    return;
});

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  A state machine shared amongst all of the dragging responders.
TP.dnd.DragResponder.Type.defineAttribute('dragStateMachine');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.dnd.DragResponder.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    var dragSM;

    //  Construct a new state machine that will be shared amongst the various
    //  drag responders.
    dragSM = TP.core.StateMachine.construct();

    //  For our state machine, the only trigger signals are DOMDragHover and
    //  DOMDragMove. We handle putting the state machine into the proper state
    //  (via calling 'transition()' manually) in the 'ondragdown' below and
    //  transitioning it out of that in 'ondragup' below.

    dragSM.addTrigger(TP.core.Mouse, 'TP.sig.DOMDragHover');
    dragSM.addTrigger(TP.core.Mouse, 'TP.sig.DOMDragMove');

    dragSM.defineState(null, 'idle');         //  start-able state
    dragSM.defineState('idle');               //  final-able state

    //  Define a method that will accept the state machine going into the 'idle'
    //  state if we get a 'TP.sig.DOMDragUp' signal.
    dragSM.defineMethod('acceptIdle',
        function(signalOrParams) {

            if (TP.notValid(signalOrParams)) {
                return true;
            }

            return TP.isKindOf(signalOrParams, 'TP.sig.DOMDragUp');
        });

    this.set('dragStateMachine', dragSM);

    return;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.dnd.DragResponder.Inst.defineAttribute('startSignal');
TP.dnd.DragResponder.Inst.defineAttribute('currentSignal');
TP.dnd.DragResponder.Inst.defineAttribute('lastSignal');

TP.dnd.DragResponder.Inst.defineAttribute('startPoint');
TP.dnd.DragResponder.Inst.defineAttribute('currentPoint');

//  The target element the drag machine will be watching for drag events.
TP.dnd.DragResponder.Inst.defineAttribute('targetElement');

TP.dnd.DragResponder.Inst.defineAttribute('infoAttrs');

//  The action element the drag machine will be modifying for drag events.
TP.dnd.DragResponder.Inst.defineAttribute('actionElement');

TP.dnd.DragResponder.Inst.defineAttribute('$offsetPoint');

TP.dnd.DragResponder.Inst.defineAttribute('actionWindow');
TP.dnd.DragResponder.Inst.defineAttribute('$frameOffsetPoint');

TP.dnd.DragResponder.Inst.defineAttribute('modifiers');
TP.dnd.DragResponder.Inst.defineAttribute('workers');

TP.dnd.DragResponder.Inst.defineAttribute('dragCorner');

TP.dnd.DragResponder.Inst.defineAttribute('insetTop', 0);
TP.dnd.DragResponder.Inst.defineAttribute('insetRight', 0);
TP.dnd.DragResponder.Inst.defineAttribute('insetBottom', 0);
TP.dnd.DragResponder.Inst.defineAttribute('insetLeft', 0);

//  User-settable X and Y offsets. These are merely added to the current
//  point.
TP.dnd.DragResponder.Inst.defineAttribute('xOffset', 0);
TP.dnd.DragResponder.Inst.defineAttribute('yOffset', 0);

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dnd.DragResponder.Inst.defineMethod('init',
function() {

    /**
     * @method init
     * @summary Initializes a new instance of the receiver.
     * @returns {TP.dnd.DragResponder} A new instance.
     */

    this.callNextMethod();

    this.set('currentPoint', TP.pc(0, 0));

    //  Invoke the setter here with null to force other related attribute
    //  settings to be updated by the setter.
    this.set('actionElement', null);

    this.set('modifiers', TP.ac());
    this.set('workers', TP.ac());

    this.set('$frameOffsetPoint', TP.pc(0, 0));

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragResponder.Inst.defineMethod('addDataModifier',
function(aModifierFunc, modifierData) {

    /**
     * @method addDataModifier
     * @summary Adds a 'data modifier' function to the receiver's list of
     *     modifiers. Modifier functions are those that impose some constraint
     *     (i.e. 'only increment in the X direction') on the gesture.
     * @param {Function} aModifierFunc The modifier function to add to the
     *     receiver's list.
     * @param {Object} modifierData Modifier data that goes along with the
     *     modifier function.
     * @returns {TP.dnd.DragResponder} The receiver.
     */

    if (!TP.isFunction(aModifierFunc)) {
        return this.raise('TP.sig.InvalidFunction',
                            'Invalid modifier function: ' + aModifierFunc);
    }

    aModifierFunc.modifierData = modifierData;

    this.get('modifiers').push(aModifierFunc);

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragResponder.Inst.defineMethod('addDragWorker',
function(aWorkerFunc) {

    /**
     * @method addDragWorker
     * @summary Adds a 'drag worker' function to the receiver's list of worker
     *     functions. Worker functions allow a different behavior rather than
     *     the standard 'move' or 'resize' behavior to be processed using the
     *     values computed by the responder engine.
     * @param {Function} aWorkerFunc The modifier function to add to the
     *     receiver's list.
     * @returns {TP.dnd.DragResponder} The receiver.
     */

    if (!TP.isFunction(aWorkerFunc)) {
        return this.raise('TP.sig.InvalidFunction',
                            'Invalid worker function: ' + aWorkerFunc);
    }

    this.get('workers').push(aWorkerFunc);

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragResponder.Inst.defineMethod('computeOffsetPoint',
function() {

    /**
     * @method computeOffsetPoint
     * @summary Computes the gestures initial 'offset point'.
     * @description When computing the offset point, this method takes into
     *     account the following parameters:
     *     - The initial starting point
     *     - The offset from the action element's offset parent to the action
     *       element.
     *     - The border of the action element.
     *     - The 'drag corner' that was configured or computed for the gesture.
     * @returns {TP.dnd.DragResponder} The receiver.
     */

    var actionElem,

        startPoint,
        startX,
        startY,

        containerOffsets,

        offsetX,
        offsetY,

        marginOffsets,

        corner,

        borderXOffset,
        borderYOffset,

        elemBox;

    //  If there's no action element, we can't go very far here - bail out
    if (!TP.isElement(actionElem = this.get('actionElement'))) {
        this.set('$offsetPoint', TP.pc(0, 0));

        return this;
    }

    //  Grab the starting point - this is where the mouse point has begun in our
    //  drag session
    startPoint = this.get('startPoint');
    startX = startPoint.getX();
    startY = startPoint.getY();

    //  Subtract off the offset from the container to the action element from
    //  our start position.
    containerOffsets = TP.elementGetOffsetFromContainer(actionElem);

    offsetX = startX - containerOffsets.first();
    offsetY = startY - containerOffsets.last();

    //  Take into account the margin of the action element.
    marginOffsets = TP.elementGetMarginInPixels(actionElem);

    offsetX += marginOffsets.at(3);
    offsetY += marginOffsets.at(0);

    //  If the user specified a 'drag corner', then we'll be snapping over to
    //  that corner before we begin manipulation of the active element.
    //  Adjust the offset point accordingly.
    if (TP.isValid(corner = this.get('dragCorner'))) {
        borderXOffset = TP.elementGetBorderInPixels(actionElem, TP.LEFT);
        borderYOffset = TP.elementGetBorderInPixels(actionElem, TP.TOP);

        //  Since moving/resizing happens by setting 'top', 'left', 'width' or
        //  'height' of the 'style' property, we need to use the *content box*
        //  when measuring.
        elemBox = TP.elementGetPageBox(actionElem, TP.CONTENT_BOX);

        /* eslint-disable no-extra-parens */

        switch (corner) {
            case TP.TOP:

                offsetX += elemBox.at('left') +
                            (elemBox.at('width') / 2) -
                            startX -
                            borderXOffset;
                offsetY += elemBox.at('top') -
                            startY -
                            borderYOffset;

                break;

            case TP.TOP_RIGHT:

                offsetX += elemBox.at('left') +
                            elemBox.at('width') -
                            startX;
                offsetY += elemBox.at('top') -
                            startY -
                            borderYOffset;

                break;

            case TP.RIGHT:

                offsetX += elemBox.at('left') +
                            elemBox.at('width') -
                            startX;
                offsetY += elemBox.at('top') +
                            (elemBox.at('height') / 2) -
                            startY -
                            borderYOffset;

                break;

            case TP.BOTTOM_RIGHT:

                offsetX += elemBox.at('left') +
                            elemBox.at('width') -
                            startX;
                offsetY += elemBox.at('top') +
                            elemBox.at('height') -
                            startY;

                break;

            case TP.BOTTOM:

                offsetX += elemBox.at('left') +
                            (elemBox.at('width') / 2) -
                            startX -
                            borderXOffset;
                offsetY += elemBox.at('top') +
                            elemBox.at('height') -
                            startY;

                break;

            case TP.BOTTOM_LEFT:

                offsetX += elemBox.at('left') -
                            startX -
                            borderXOffset;
                offsetY += elemBox.at('top') +
                            elemBox.at('height') -
                            startY;

                break;

            case TP.LEFT:

                offsetX += elemBox.at('left') -
                            startX -
                            borderXOffset;
                offsetY += elemBox.at('top') +
                            (elemBox.at('height') / 2) -
                            startY -
                            borderYOffset;

                break;

            case TP.TOP_LEFT:

                offsetX += elemBox.at('left') -
                            startX -
                            borderXOffset;
                offsetY += elemBox.at('top') -
                            startY -
                            borderYOffset;

                break;

            default:
                break;
        }

        /* eslint-enable no-extra-parens */
    }

    //  Create a TP.gui.Point and use it for the offset point.
    this.set('$offsetPoint', TP.pc(offsetX, offsetY));

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragResponder.Inst.defineMethod('getCurrentPoint',
function(runModifiers) {

    /**
     * @method getCurrentPoint
     * @summary Returns the responder's 'current point' (after running any 'data
     *     modifiers' on the point data).
     * @param {Boolean} runModifiers Whether or not to run the 'data modifiers'
     *     (i.e. Functions that alter the current point). Defaults to true.
     * @returns {TP.gui.Point} The responder's current point.
     */

    var xyPoint,
        currentSignal,

        eventWin,

        frameOffsetPoint;

    //  If the object has a 'recursion marker', that means a String
    //  representation of some sort is being produced and we should just return
    //  the current value here.
    if (TP.objectHasMarker(this)) {
        return '';
    }

    //  Grab the TP.gui.Point representing the current point and the current
    //  signal (which will probably be some sort of DOMDrag signal)
    xyPoint = this.$get('currentPoint');
    currentSignal = this.get('currentSignal');

    //  Set the point to the signals X and Y
    xyPoint.setXY(currentSignal.getPageX() + this.get('xOffset'),
                    currentSignal.getPageY() + this.get('yOffset'));

    //  If the existing 'current drag window' doesn't match the signal's window,
    //  then we need to compute the offsets from the signal's window to the
    //  window of the action element and store those away in a TP.gui.Point
    //  which is the 'frame offset point'.
    if (this.get('actionWindow') !==
        (eventWin = TP.eventGetWindow(currentSignal.getEvent()))) {
        frameOffsetPoint = TP.pc(
                    TP.windowComputeWindowOffsets(
                        TP.nodeGetWindow(this.get('actionElement')),
                        eventWin));

        this.set('$frameOffsetPoint', frameOffsetPoint);
        this.set('actionWindow', eventWin);
    } else {
        //  Grab the current 'frame offset' point. Initially, this will be a
        //  TP.gui.Point of 0,0 but may have been modified if the mouse pointer
        //  is over an iframe.
        frameOffsetPoint = this.get('$frameOffsetPoint');
    }

    //  Translate the current point by that amount
    xyPoint.translateByPoint(frameOffsetPoint);

    //  If the caller didn't explicitly turn off 'data modifiers' execution then
    //  we run those here.
    if (TP.notFalse(runModifiers)) {
        this.modifyResponderData(currentSignal, xyPoint);
    }

    return xyPoint;
});

//  ------------------------------------------------------------------------

TP.dnd.DragResponder.Inst.defineHandler('DOMDragHover',
function(aSignal) {

    /**
     * @method handleDOMDragHover
     * @summary Executed when this receiver receives a TP.sig.DOMDragHover
     *     signal (which it subscribes for when it enters the 'dragging' state).
     * @param {TP.sig.DOMDragHover} aSignal The DOMDragHover signal generated by
     *     the mouse.
     * @returns {TP.dnd.DragResponder} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragResponder.Inst.defineHandler('DOMDragMove',
function(aSignal) {

    /**
     * @method handleDOMDragMove
     * @summary Executed when this receiver receives a TP.sig.DOMDragMove
     *     signal (which it subscribes for when it enters the 'dragging' state).
     * @param {TP.sig.DOMDragMove} aSignal The DOMDragMove signal generated by
     *     the mouse.
     * @returns {TP.dnd.DragResponder} The receiver.
     */

    var currentSignal;

    //  The DOMDragMove signal that we want to become the 'current signal'

    //  If we have already have a current signal, capture it as the 'last
    //  signal' for possible usage by the receiver's machinery.
    if (TP.isValid(currentSignal = this.get('currentSignal'))) {
        this.set('lastSignal', currentSignal);
    }

    //  Capture the current signal.
    this.set('currentSignal', aSignal);

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragResponder.Inst.defineMethod('modifyResponderData',
function(aSignal, aPoint) {

    /**
     * @method modifyResponderData
     * @summary Executes all of the registered 'data modifiers' (such as the
     *     constraint functions that are type constants on this type).
     * @param {TP.sig.DOMDragMove} aSignal The current DOMDragMove signal.
     * @param {TP.gui.Point} aPoint Optional point data to modify.
     * @returns {TP.dnd.DragResponder} The receiver.
     */

    var modifiers,
        i,
        modifierFunc,
        args;

    //  If there's no action element, we can't go very far here - bail out
    if (!TP.isElement(this.get('actionElement'))) {
        return this;
    }

    if (TP.isEmpty(modifiers = this.get('modifiers'))) {
        return this;
    }

    //  Iterate over all of the 'modifier' Functions and invoke them on the
    //  signal and/or point data.
    for (i = 0; i < modifiers.getSize(); i++) {

        if (TP.isCallable(modifierFunc = modifiers.at(i))) {
            try {
                switch (arguments.length) {
                    case 1:
                        modifierFunc(this, aSignal);
                        break;
                    case 2:
                        modifierFunc(this, aSignal, aPoint);
                        break;
                    default:
                        args = TP.args(arguments);
                        args.unshift(this);
                        modifierFunc.call(args);
                        break;
                }
            } catch (e) {
                this.raise('TP.sig.ModifierFailed',
                    'Signal modifier function failed: ' +
                    TP.ec(e, modifierFunc));
            }
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragResponder.Inst.defineMethod('prepareFrom',
function(infoTPElement, srcTPElement, evtTPElement, initialSignal, attrHash) {

    /**
     * @method prepareFrom
     * @summary Prepares the receiver by using well-known attributes present on
     *     the supplied info element.
     * @param {TP.dom.ElementNode} infoTPElement The object to obtain
     *     configuration information from.
     * @param {TP.dom.ElementNode} srcTPElement The object that acts as the
     *     'source' of the drag operation.
     * @param {TP.dom.ElementNode} evtTPElement The object that the originating
     *     event occurred in and which might be used as the action element.
     * @param {TP.sig.DOMMouseSignal} initialSignal The signal that started the
     *     dragging session. Usually this will be an instance of
     *     TP.sig.DOMDragDown.
     * @param {TP.core.Hash} attrHash An optional hash that this method will use
     *     instead of the attribute data from the info element.
     * @returns {TP.dnd.DragResponder} The receiver.
     */

    var attrs,

        attrVal,

        lastDown,

        targetElem,
        srcElem,
        actionElem,
        eventClientXY,
        actionElems,
        pointElem,

        i,

        attrVals,

        startPoint;

    //  If no attribute hash was supplied, then grab one from the 'information'
    //  TP.dom.ElementNode.
    if (TP.notValid(attrs = attrHash)) {
        attrs = infoTPElement.getAttributes();
    }

    this.set('infoAttrs', attrs);

    if (TP.notEmpty(attrVal = infoTPElement.getAttribute('drag:item'))) {

        lastDown = TP.core.Mouse.get('lastDown');

        if (attrVal === 'target') {
            if (TP.isElement(targetElem =
                                TP.eventGetResolvedTarget(lastDown))) {
                actionElem = targetElem;
            }
        } else {
            srcElem = srcTPElement.getNativeNode();

            //  Note here how we specify 'autocollapse' for the
            //  TP.nodeEvaluatePath() call since we only want one element
            actionElem = TP.nodeEvaluatePath(srcElem, attrVal, null, true);

            //  If there was actually more than one element that matched, then
            //  autoCollapse won't matter - we got an Array. Get the element
            //  under the mouse point of the current 'down' event (using
            //  clientX/clientY since we're computing relative to the srcElement
            //  within the overall window/document).
            if (TP.isArray(actionElems = actionElem)) {
                actionElem = null;
                eventClientXY = TP.eventGetClientXY(lastDown);

                pointElem = TP.elementGetElementAtPoint(
                                srcElem,
                                eventClientXY.first(),
                                eventClientXY.last());

                for (i = 0; i < actionElems.getSize(); i++) {
                    if (actionElems.at(i) === pointElem) {
                        actionElem = actionElems.at(i);
                        break;
                    }
                }
            }
        }

        if (!TP.isElement(actionElem)) {
            return this.raise('TP.sig.InvalidParameter',
                'No elements found for drag:item path: ' + attrVal);
        }

    } else {
        actionElem = evtTPElement.getNativeNode();
    }

    this.set('actionElement', actionElem);

    //  If the author has configured a drag increment, install our own modifier
    //  function for that and remove the key so that supertypes won't install
    //  anything else for that.
    if (TP.notEmpty(attrVal = attrs.at('drag:increment'))) {

        attrVals = TP.cssDimensionValuesFromString(attrVal);

        attrVal = TP.elementGetPixelValue(
                                actionElem, attrVals.at('left'), 'width');
        if (attrVal !== 0) {
            this.addDataModifier(
                TP.dnd.DragResponder.INCREMENT_X_BY,
                TP.hc('increment', attrVal));
        }

        attrVal = TP.elementGetPixelValue(
                                actionElem, attrVals.at('top'), 'height');
        if (attrVal !== 0) {
            this.addDataModifier(
                TP.dnd.DragResponder.INCREMENT_Y_BY,
                TP.hc('increment', attrVal));
        }
    }

    //  If the author has configured a drag corner, set our value for that
    //  and remove the key so that supertypes won't install anything else
    //  for that.

    if (TP.notEmpty(attrVal = attrs.at('drag:corner'))) {
        this.set('dragCorner', TP[attrVal]);
    }

    //  If the author has configured a drag offset, set our values for that
    //  and remove the key so that supertypes won't install anything else
    //  for that.

    if (TP.notEmpty(attrVal = attrs.at('drag:offset'))) {
        attrVals = TP.cssDimensionValuesFromString(attrVal);

        this.set('xOffset', TP.elementGetPixelValue(
                                actionElem, attrVals.at('left'), 'width'));
        this.set('yOffset', TP.elementGetPixelValue(
                                actionElem, attrVals.at('top'), 'height'));
    }

    //  If the author has configured a set of drag insets, set our values
    //  for that and remove the key so that supertypes won't install
    //  anything else for that.

    if (TP.notEmpty(attrVal = attrs.at('drag:insets'))) {
        attrVals = TP.cssDimensionValuesFromString(attrVal);

        this.set('insetTop',
                    TP.elementGetPixelValue(
                            actionElem, attrVals.at('top'), 'height'));
        this.set('insetRight',
                    TP.elementGetPixelValue(
                            actionElem, attrVals.at('right'), 'width'));
        this.set('insetBottom',
                    TP.elementGetPixelValue(
                            actionElem, attrVals.at('bottom'), 'height'));
        this.set('insetLeft',
                    TP.elementGetPixelValue(
                            actionElem, attrVals.at('left'), 'width'));
    }

    //  NB: We process 'drag:constraints' in the various subtypes version of
    //  this method.

    //  initialSignal will be the DOMDragDown signal that started us dragging

    if (TP.isValid(initialSignal)) {
        this.set('startSignal', initialSignal);
        this.set('currentSignal', initialSignal);

        startPoint = initialSignal.getPagePoint();
        this.set('startPoint', startPoint);

        //  Compute the offset point (after we set the corner)
        this.computeOffsetPoint();

        //  Set up any installed data modifiers
        this.setupDataModifiers();

        //  Note here how we do *not* run any modifiers. Therefore, the
        //  start point will remain unchanged.
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragResponder.Inst.defineMethod('setActionElement',
function(anElement) {

    /**
     * @method setActionElement
     * @summary Sets the 'action element' for the receiver. This defined setter
     *     method also configured internal responder state based on the element
     *     provided.
     * @param {HTMLElement} anElement The Element to use as the the action
     *     element.
     * @returns {TP.dnd.DragResponder} The receiver.
     */

    var actionElem;

    if (TP.notValid(anElement)) {
        this.$set('actionElement', null);
        this.set('actionWindow', null);

        return this;
    }

    //  If we receive a valid value then it must resolve successfully to an
    //  element or we've got an error condition.
    actionElem = TP.unwrap(anElement);
    if (!TP.isElement(actionElem)) {
        //  Try to resolve the source as a DOM query of some form.
        actionElem = TP.byPath(anElement);

        //  The source must resolve to a native element.
        actionElem = TP.elem(actionElem);
        if (!TP.isElement(actionElem)) {
            return this.raise('TP.sig.InvalidParameter',
                'Could not resolve anElement to an element: ' +
                anElement);
        }
    }

    //  To avoid recursion, use '$set()'
    this.$set('actionElement', actionElem);

    this.set('actionWindow', TP.nodeGetWindow(actionElem));

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragResponder.Inst.defineMethod('setupDataModifiers',
function() {

    /**
     * @method setupDataModifiers
     * @summary Sets up any installed data modifiers in preparation for a 'drag
     *     session'.
     * @returns {TP.dnd.DragResponder} The receiver.
     */

    var modifiers;

    //  If there's no action element, we can't go very far here - bail out
    if (!TP.isElement(this.get('actionElement'))) {
        return this;
    }

    if (TP.isEmpty(modifiers = this.get('modifiers'))) {
        return this;
    }

    //  Make sure that any installed modifers get a fresh 'temp data'
    //  TP.core.Hash
    modifiers.perform(
            function(aModifierFunc) {
                aModifierFunc.tempData = TP.hc();
            });

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragResponder.Inst.defineMethod('teardownDataModifiers',
function() {

    /**
     * @method teardownDataModifiers
     * @summary Tears down any installed data modifiers at the conclusion of a
     *     'drag session'.
     * @returns {TP.dnd.DragResponder} The receiver.
     */

    var modifiers;

    if (TP.isEmpty(modifiers = this.get('modifiers'))) {
        return this;
    }

    //  Make sure that any installed modifers get a fresh 'temp data'
    //  TP.core.Hash
    modifiers.perform(
            function(aModifierFunc) {
                delete aModifierFunc.modifierData;
                delete aModifierFunc.tempData;
            });

    modifiers.empty();

    return this;
});

//  ========================================================================
//  TP.dnd.MoveResponder
//  ========================================================================

/**
 * @type {TP.dnd.MoveResponder}
 * @summary A DragResponder responsible for simple move operations.
 */

//  ------------------------------------------------------------------------

TP.dnd.DragResponder.defineSubtype('MoveResponder');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.dnd.MoveResponder.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    var stateMachine,
        inst;

    //  Construct a new state machine and use it as the state machine for the
    //  move singleton.
    stateMachine = TP.dnd.DragResponder.get('dragStateMachine');

    //  The state machine will transition to 'moving' when it is activated.
    stateMachine.defineState('idle', 'moving');
    stateMachine.defineState('moving', 'idle');

    //  Construct the move singleton - this will cause it to register itself.
    inst = this.construct();
    inst.setID('MoveService');

    inst.addStateMachine(stateMachine);

    return;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.dnd.MoveResponder.Inst.defineAttribute('$overlayElement');

TP.dnd.MoveResponder.Inst.defineAttribute('$computedPoint');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dnd.MoveResponder.Inst.defineHandler('DOMDragMove',
function(aSignal) {

    /**
     * @method handleDOMDragMove
     * @summary Executed when this receiver receives a TP.sig.DOMDragMove
     *     signal (which it subscribes for when it enters the 'dragging' state).
     * @param {TP.sig.DOMDragMove} aSignal The DOMDragMove signal generated by
     *     the mouse.
     * @returns {TP.dnd.MoveResponder} The receiver.
     */

    var currentSignal,

        currentPoint,
        currentX,
        currentY,

        actionElem,

        offsetPoint,

        computedPoint,

        actionWin,
        styleObj,

        workerFuncs,
        infoAttrs,

        computedX,
        computedY,

        topVal,
        leftVal;

    this.callNextMethod();

    currentSignal = this.get('currentSignal');
    actionElem = this.get('actionElement');

    if (TP.notValid(currentSignal) || !TP.isElement(actionElem)) {
        return this;
    }

    currentPoint = this.getCurrentPoint(false);

    currentX = currentPoint.getX();
    currentY = currentPoint.getY();

    offsetPoint = this.get('$offsetPoint');

    computedPoint = this.get('$computedPoint');

    actionWin = TP.nodeGetWindow(actionElem);
    styleObj = TP.elementGetStyleObj(actionElem);

    workerFuncs = this.get('workers');
    infoAttrs = this.get('infoAttrs');

    computedX = currentX - offsetPoint.getX();
    computedY = currentY - offsetPoint.getY();

    computedPoint.setXY(computedX, computedY);
    this.modifyResponderData(currentSignal, computedPoint);
    computedX = computedPoint.getX();
    computedY = computedPoint.getY();

    topVal = computedY;
    leftVal = computedX;

    actionWin.requestAnimationFrame(
        function() {
            if (TP.notEmpty(workerFuncs)) {
                workerFuncs.forEach(
                    function(aFunc) {
                        aFunc(actionElem,
                                styleObj,
                                TP.hc(
                                    'top', topVal,
                                    'left', leftVal),
                                infoAttrs);
                    });
            } else {
                styleObj.top = computedY + 'px';
                styleObj.left = computedX + 'px';
            }
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.MoveResponder.Inst.defineHandler('MovingEnter',
function(aSignal) {

    /**
     * @method handleMovingEnter
     * @summary Executed when the state machine associated with this receiver
     *     enters the 'moving' state. This method performs whatever processing
     *     is necessary to start the moving process.
     * @param {TP.sig.StateSignal} aSignal The state signal generated by the
     *     state machine machinery when triggering this state.
     * @returns {TP.dnd.MoveResponder} The receiver.
     */

    var startSignal,

        actionElem,

        overlayElem,

        insetTop,
        insetRight,
        insetBottom,
        insetLeft,

        startPoint,
        startX,
        startY,

        styleObj,

        bodyElem;

    startSignal = this.get('startSignal');
    actionElem = this.get('actionElement');

    if (TP.notValid(startSignal) || !TP.isElement(actionElem)) {
        return this;
    }

    //  Create an 'overlay element' that will overlay the entire action
    //  element during the time that the gesture is active.
    overlayElem = TP.documentConstructElement(
                            TP.nodeGetDocument(actionElem),
                            'div',
                            TP.w3.Xmlns.XHTML);

    insetTop = this.get('insetTop');
    insetRight = this.get('insetRight');
    insetBottom = this.get('insetBottom');
    insetLeft = this.get('insetLeft');

    TP.elementSetStyleString(overlayElem,
                        TP.join('position: ', 'absolute;',
                                ' top: ', insetTop + 'px;',
                                ' right: ', insetRight + 'px;',
                                ' bottom: ', insetBottom + 'px;',
                                ' left: ', insetLeft + 'px;',
                                ' background-color: ', 'transparent;',
                                ' cursor: ', 'default;'));

    this.set('$overlayElement', overlayElem);

    //  Append the overlay element to the element we're performing the action
    //  on. This will allow us to 'hit test' with the insets we computed above.
    TP.nodeAppendChild(actionElem, overlayElem, false);

    //  Grab the start point and make sure that the overlay element contains
    //  it. If it doesn't, we must've come down on one of the insets, so we
    //  just stop propagation of the state signal, detach the overlay
    //  element and exit.

    startPoint = this.get('startPoint');
    startX = startPoint.getX();
    startY = startPoint.getY();

    if (!TP.elementContainsPoint(overlayElem, startX, startY)) {
        aSignal.stopPropagation();

        TP.nodeDetach(overlayElem);

        this.set('actionElement', null);

        return this;
    }

    //  Now we repurpose the overlay element to overlay the whole body for
    //  dragging purposes. This will prevent spurious events from affecting the
    //  dragging action.

    //  First, reset all of the style position/sizes to 0
    styleObj = TP.elementGetStyleObj(overlayElem);
    styleObj.top = '0px';
    styleObj.right = '0px';
    styleObj.bottom = '0px';
    styleObj.left = '0px';

    //  Then (re)append the overlay element onto the body.
    bodyElem = TP.documentGetBody(TP.nodeGetDocument(actionElem));
    TP.nodeAppendChild(bodyElem, overlayElem, false);

    //  Make sure and disable the user select on the body element so that we
    //  don't get weird selection behavior from the host platform.
    TP.elementDisableUserSelect(TP.nodeGetDocument(actionElem).body);

    //  A reusable point that we can use in our dragging computations.
    this.set('$computedPoint', TP.pc());

    //  Set the attribute on the action element that indicates we are
    //  'moving' it.
    TP.elementSetAttribute(actionElem, 'pclass:moving', 'true', true);

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.MoveResponder.Inst.defineHandler('MovingExit',
function(aSignal) {

    /**
     * @method handleMovingExit
     * @summary Executed when the state machine associated with this receiver
     *     exits the 'moving' state. This method performs whatever processing
     *     is necessary to stop the moving process.
     * @param {TP.sig.StateSignal} aSignal The state signal generated by the
     *     state machine machinery when triggering this state.
     * @returns {TP.dnd.MoveResponder} The receiver.
     */

    var actionElem,

        overlayElem;

    actionElem = this.get('actionElement');

    if (!TP.isElement(actionElem)) {
        return this;
    }

    //  Remove the attribute on the action element that indicated we were
    //  'moving' it.
    TP.elementRemoveAttribute(actionElem, 'pclass:moving', true);

    //  Reenable the user select behavior for the body element
    TP.elementEnableUserSelect(TP.nodeGetDocument(actionElem).body);

    //  Remove the element that was overlaying the action element
    overlayElem = this.get('$overlayElement');
    TP.nodeDetach(overlayElem);

    //  Since this is a shared responder, we need to teardown it's responder
    //  data.
    this.teardownDataModifiers();

    //  Empty out any workers that got added
    this.get('workers').empty();

    //  These parameters need to be reset since this responder is shared and may
    //  be used again
    this.set('actionElement', null);
    this.set('targetElement', null);

    this.set('xOffset', 0);
    this.set('yOffset', 0);

    this.set('dragCorner', null);

    this.set('currentPoint', TP.pc(0, 0));
    this.set('$frameOffsetPoint', TP.pc(0, 0));

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.MoveResponder.Inst.defineMethod('prepareFrom',
function(infoTPElement, srcTPElement, evtTPElement, initialSignal, attrHash) {

    /**
     * @method prepareFrom
     * @summary Prepares the receiver by using well-known attributes present on
     *     the supplied info element.
     * @param {TP.dom.ElementNode} infoTPElement The object to obtain
     *     configuration information from.
     * @param {TP.dom.ElementNode} srcTPElement The object that acts as the
     *     'source' of the drag operation.
     * @param {TP.dom.ElementNode} evtTPElement The object that the originating
     *     event occurred in and which might be used as the action element.
     * @param {TP.sig.DOMMouseSignal} initialSignal The signal that started the
     *     dragging session. Usually this will be an instance of
     *     TP.sig.DOMDragDown.
     * @param {TP.core.Hash} attrHash An optional hash that this method will use
     *     instead of the attribute data from the element.
     * @returns {TP.dnd.MoveResponder} The receiver.
     */

    var attrs,

        attrVal,
        containerElem;

    //  If no attribute hash was supplied, then grab one from the 'information'
    //  TP.dom.ElementNode.
    if (TP.notValid(attrs = attrHash)) {
        attrs = infoTPElement.getAttributes();
    }

    //  If the author has configured a drag container, install our own
    //  modifier function for that and remove the key so that supertypes
    //  won't install anything else for that.

    //  Note here how we specify both 'autocollapse' and 'retry with
    //  document', for the TP.nodeEvaluatePath() call since we only want one
    //  element and we want the document to be retried as the context node -
    //  very useful for CSS paths.
    if (TP.notEmpty(attrVal = attrs.at('drag:container')) &&
        TP.isElement(containerElem = TP.nodeEvaluatePath(
                                        evtTPElement.getNativeNode(),
                                        attrVal,
                                        null,
                                        true,
                                        true))) {
        this.addDataModifier(
                TP.dnd.DragResponder.CLAMP_X_AND_Y_TO_CONTAINER,
                TP.hc('container', containerElem));
    }

    //  If the author has configured a set of drag constraint function names,
    //  use them to configure the modifier functions

    if (TP.notEmpty(attrVal = attrs.at('drag:constraints'))) {

        //  The author can define multiple values.
        attrVal = attrVal.split(' ');

        attrVal.perform(
                function(aConstraintVal) {
                    var constraintFunc;

                    //  If the value names a constant on the
                    //  TP.dnd.MoveResponder or the TP.dnd.DragResponder
                    //  type that points to a callable Function, then add it
                    //  as a data modifier.
                    if (TP.isCallable(
                            constraintFunc =
                                TP.dnd.MoveResponder[aConstraintVal]) ||
                        TP.isCallable(
                            constraintFunc =
                                TP.dnd.DragResponder[aConstraintVal])) {
                        this.addDataModifier(constraintFunc);
                    }
                }.bind(this));
    }

    if (TP.notEmpty(attrVal = attrs.at('drag:workers'))) {

        //  The author can define multiple values.
        attrVal = attrVal.split(' ');

        attrVal.perform(
                function(aConstraintVal) {
                    var workerFunc;

                    //  If the value names a constant on the
                    //  TP.dnd.MoveResponder or the TP.dnd.DragResponder
                    //  type that points to a callable Function, then add it
                    //  as a data modifier.
                    if (TP.isCallable(
                            workerFunc =
                                TP.dnd.MoveResponder[aConstraintVal]) ||
                        TP.isCallable(
                            workerFunc =
                                TP.dnd.DragResponder[aConstraintVal])) {
                        this.addDragWorker(workerFunc);
                    }
                }.bind(this));
    }

    //  Need to do this since we might have generated 'attrs' here and want
    //  to pass it along.
    return this.callNextMethod(infoTPElement, srcTPElement,
                                evtTPElement, initialSignal, attrs);
});

//  ========================================================================
//  TP.dnd.ResizeResponder
//  ========================================================================

/**
 * @type {TP.dnd.ResizeResponder}
 * @summary A DragResponder responsible for simple resize operations.
 */

//  ------------------------------------------------------------------------

TP.dnd.DragResponder.defineSubtype('ResizeResponder');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.dnd.ResizeResponder.Type.defineConstant(
        'CLAMP_RECT_TO_CONTAINER',
function(aDragResponder, aSignal, xyPoint) {

    var kallee,

        containerRect,

        target,
        targetRect,
        targetContainer,

        borderXOffset,
        borderYOffset;

    kallee = TP.dnd.ResizeResponder.CLAMP_RECT_TO_CONTAINER;

    if (TP.notValid(containerRect = kallee.tempData.at('containerRect'))) {

        target = aDragResponder.get('actionElement');

        targetRect = TP.rtc(TP.elementGetOffsetBox(target,
                                                    TP.CONTENT_BOX,
                                                    null,
                                                    false));

        targetContainer = kallee.modifierData.at('container');
        if (TP.notValid(targetContainer)) {
            targetContainer = TP.elementGetOffsetParent(target);
            if (!TP.isElement(targetContainer)) {
                targetContainer = TP.documentGetBody(
                                    TP.nodeGetDocument(target));
            }
        }

        containerRect = TP.rtc(TP.elementGetPageBox(targetContainer,
                                                    TP.CONTENT_BOX,
                                                    null,
                                                    false));

        containerRect.setXY(0, 0);

        borderXOffset = TP.elementGetBorderInPixels(target, TP.RIGHT);
        borderYOffset = TP.elementGetBorderInPixels(target, TP.BOTTOM);

        containerRect.shrink(targetRect.getX() + borderXOffset,
                                targetRect.getY() + borderYOffset);

        kallee.tempData.atPut('containerRect', containerRect);
    }

    xyPoint.clampToRect(containerRect);
});

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.dnd.ResizeResponder.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    var stateMachine,
        inst;

    //  Construct a new state machine and use it as the state machine for the
    //  resize singleton.
    stateMachine = TP.dnd.DragResponder.get('dragStateMachine');

    //  The state machine will transition to 'resizing' when it is activated.
    stateMachine.defineState('idle', 'resizing');
    stateMachine.defineState('resizing', 'idle');

    //  Construct the resize singleton - this will cause it to register itself.
    inst = this.construct();
    inst.setID('ResizeService');

    inst.addStateMachine(stateMachine);

    return;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.dnd.ResizeResponder.Inst.defineAttribute('$overlayElement');

TP.dnd.ResizeResponder.Inst.defineAttribute('$computedPoint');

TP.dnd.ResizeResponder.Inst.defineAttribute('dragSide');
TP.dnd.ResizeResponder.Inst.defineAttribute('sideComputed');

TP.dnd.ResizeResponder.Inst.defineAttribute('perimeterTop');
TP.dnd.ResizeResponder.Inst.defineAttribute('perimeterRight');
TP.dnd.ResizeResponder.Inst.defineAttribute('perimeterBottom');
TP.dnd.ResizeResponder.Inst.defineAttribute('perimeterLeft');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dnd.ResizeResponder.Inst.defineMethod('init',
function() {

    /**
     * @method init
     * @summary Initializes a new instance of the receiver.
     * @returns {TP.dnd.ResizeResponder} A new instance.
     */

    this.callNextMethod();

    this.set('perimeterTop', 10);
    this.set('perimeterRight', 10);
    this.set('perimeterBottom', 10);
    this.set('perimeterLeft', 10);

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.ResizeResponder.Inst.defineMethod('computeOffsetPoint',
function() {

    /**
     * @method computeOffsetPoint
     * @summary Computes the gestures initial 'offset point'.
     * @description When computing the offset point, this method takes into
     *     account the following parameters:
     *     - The initial starting point
     *     - The offset from the action element's offset parent to the action
     *       element.
     *     - The border of the action element.
     *     - The 'drag corner' that was configured or computed for the gesture.
     * @returns {TP.dnd.ResizeResponder} The receiver.
     */

    var actionElem,

        startPoint,
        startX,
        startY,

        containerOffsets,

        offsetX,
        offsetY,

        side,
        sideComputed,

        elemBox,

        borderXOffset,
        borderYOffset,

        offsetParent,

        rightDiff,
        bottomDiff,
        leftDiff,
        topDiff,

        totalElemOffsets,

        borderWidthTotal,
        borderHeightTotal;

    //  If there's no action element, we can't go very far here - bail out
    if (!TP.isElement(actionElem = this.get('actionElement'))) {
        this.set('$offsetPoint', TP.pc(0, 0));

        return this;
    }

    //  Grab the starting point - this is where the mouse point has begun in
    //  our drag session
    startPoint = this.get('startPoint');
    startX = startPoint.getX();
    startY = startPoint.getY();

    containerOffsets = TP.elementGetOffsetFromContainer(actionElem);

    offsetX = startX - containerOffsets.first();
    offsetY = startY - containerOffsets.last();

    if (TP.notValid(side = this.get('dragSide'))) {
        //  NB: Note here how we just divvy the element's box up into equally
        //  sized chunks to do the corner computation. The real offsets aren't
        //  really relevant here, since they would've already denied the resize
        //  earlier if the user moused down in one of them.
        side = TP.elementComputeCornerUsing(actionElem, startX, startY,
                                            this.get('perimeterTop'),
                                            this.get('perimeterRight'),
                                            this.get('perimeterBottom'),
                                            this.get('perimeterLeft'));

        this.set('dragSide', side);
        sideComputed = true;
    } else {
        sideComputed = false;
    }

    this.set('sideComputed', sideComputed);

    //  Since moving/resizing happens by setting 'top', 'left', 'width'
    //  or 'height' of the 'style' property, we need to use the *content
    //  box* when measuring.
    elemBox = TP.elementGetPageBox(actionElem, TP.CONTENT_BOX);

    if (!sideComputed) {
        borderXOffset = TP.elementGetBorderInPixels(actionElem, TP.LEFT);
        borderYOffset = TP.elementGetBorderInPixels(actionElem, TP.TOP);

        /* eslint-disable no-extra-parens */
        switch (side) {
            case TP.TOP:

                offsetX += elemBox.at('left') +
                            (elemBox.at('width') / 2) -
                            startX -
                            borderXOffset;
                offsetY += elemBox.at('top') -
                            startY -
                            borderYOffset;

                break;

            case TP.TOP_RIGHT:

                offsetX += elemBox.at('left') +
                            elemBox.at('width') -
                            startX;
                offsetY += elemBox.at('top') -
                            startY -
                            borderYOffset;

                break;

            case TP.RIGHT:

                offsetX += elemBox.at('left') +
                            elemBox.at('width') -
                            startX;
                offsetY += elemBox.at('top') +
                            (elemBox.at('height') / 2) -
                            startY -
                            borderYOffset;

                break;

            case TP.BOTTOM_RIGHT:

                offsetX += elemBox.at('left') +
                            elemBox.at('width') -
                            startX;
                offsetY += elemBox.at('top') +
                            elemBox.at('height') -
                            startY;

                break;

            case TP.BOTTOM:

                offsetX += elemBox.at('left') +
                            (elemBox.at('width') / 2) -
                            startX -
                            borderXOffset;
                offsetY += elemBox.at('top') +
                            elemBox.at('height') -
                            startY;

                break;

            case TP.BOTTOM_LEFT:

                offsetX += elemBox.at('left') -
                            startX -
                            borderXOffset;
                offsetY += elemBox.at('top') +
                            elemBox.at('height') -
                            startY;

                break;

            case TP.LEFT:

                offsetX += elemBox.at('left') -
                            startX -
                            borderXOffset;
                offsetY += elemBox.at('top') +
                            (elemBox.at('height') / 2) -
                            startY -
                            borderYOffset;

                break;

            case TP.TOP_LEFT:

                offsetX += elemBox.at('left') -
                            startX -
                            borderXOffset;
                offsetY += elemBox.at('top') -
                            startY -
                            borderYOffset;

                break;

            default:
                break;
        }

        /* eslint-enable no-extra-parens */
    }

    offsetParent = TP.elementGetOffsetParent(actionElem);

    //  If the action element's offset parent is the document element, then we
    //  want to just set some default values for the 'diff' values that get used
    //  below to adjust the offset value.
    if (!TP.isElement(offsetParent) ||
        offsetParent === TP.nodeGetDocument(actionElem).documentElement) {

        topDiff = 0;
        rightDiff = offsetX;
        bottomDiff = offsetY;
        leftDiff = 0;

    } else {

        //  Otherwise, if the action element is offset because its in another
        //  container (i.e. it's offset parent is *not* the document element),
        //  then we compute real values for our 'diff' values.

        if (!sideComputed) {
            topDiff = 0;
            rightDiff = elemBox.at('width') +
                        TP.elementGetBorderInPixels(actionElem, TP.RIGHT);
            bottomDiff = elemBox.at('height') +
                        TP.elementGetBorderInPixels(actionElem, TP.BOTTOM);
            leftDiff = 0;
        } else {
            totalElemOffsets =
                TP.elementGetPageXY(
                        actionElem,
                        TP.BORDER_BOX,
                        TP.documentGetBody(TP.nodeGetDocument(actionElem)));

            borderWidthTotal =
                TP.elementGetBorderInPixels(actionElem, TP.LEFT) +
                TP.elementGetBorderInPixels(actionElem, TP.RIGHT);

            borderHeightTotal =
                TP.elementGetBorderInPixels(actionElem, TP.TOP) +
                TP.elementGetBorderInPixels(actionElem, TP.BOTTOM);

            topDiff = startY -
                        (totalElemOffsets.last() + borderHeightTotal);

            /* eslint-disable no-extra-parens */
            rightDiff = startX - (totalElemOffsets.first());
            bottomDiff = startY - (totalElemOffsets.last());
            /* eslint-enable no-extra-parens */

            leftDiff = startX -
                        (totalElemOffsets.first() + borderWidthTotal);
        }
    }

    switch (side) {
        case TP.TOP:

            offsetY = offsetY - topDiff;

            break;

        case TP.TOP_RIGHT:

            offsetX = elemBox.at('width') - rightDiff;
            offsetY = offsetY - topDiff;

            break;

        case TP.RIGHT:

            offsetX = elemBox.at('width') - rightDiff;

            break;

        case TP.BOTTOM_RIGHT:

            offsetX = elemBox.at('width') - rightDiff;
            offsetY = elemBox.at('height') - bottomDiff;

            break;

        case TP.BOTTOM:

            offsetY = elemBox.at('height') - bottomDiff;

            break;

        case TP.BOTTOM_LEFT:

            offsetX = offsetX - leftDiff;
            offsetY = elemBox.at('height') - bottomDiff;

            break;

        case TP.LEFT:

            offsetX = offsetX - leftDiff;

            break;

        case TP.TOP_LEFT:

            offsetX = offsetX - leftDiff;
            offsetY = offsetY - topDiff;

            break;

        default:
            break;
    }

    //  Create a TP.gui.Point and use it for the offset point.
    this.set('$offsetPoint', TP.pc(offsetX, offsetY));

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.ResizeResponder.Inst.defineHandler('DOMDragMove',
function(aSignal) {

    /**
     * @method handleDOMDragMove
     * @summary Executed when this receiver receives a TP.sig.DOMDragMove
     *     signal (which it subscribes for when it enters the 'dragging' state).
     * @param {TP.sig.DOMDragMove} aSignal The DOMDragMove signal generated by
     *     the mouse.
     * @returns {TP.dnd.ResizeResponder} The receiver.
     */

    var currentSignal,

        actionElem,

        currentPoint,
        currentX,
        currentY,

        pageBox,
        offsetBox,

        offsetPoint,

        computedPoint,

        actionWin,
        styleObj,

        side,

        borderTop,
        borderLeft,

        offsetParent,

        parentBorderTop,
        parentBorderLeft,

        workerFuncs,
        infoAttrs,

        computedX,
        computedY,

        dimensionX,
        dimensionY,

        clampXVal,
        clampYVal,

        topVal,
        leftVal,
        heightVal,
        widthVal;

    this.callNextMethod();

    currentSignal = this.get('currentSignal');
    actionElem = this.get('actionElement');

    if (TP.notValid(currentSignal) || !TP.isElement(actionElem)) {
        return this;
    }

    currentPoint = this.getCurrentPoint(false);
    currentX = currentPoint.getX();
    currentY = currentPoint.getY();

    //  Since moving/resizing happens by setting 'top', 'left', 'width' or
    //  'height' of the 'style' property, we need to use the *content box*
    //  when measuring.
    pageBox = TP.elementGetPageBox(actionElem, TP.CONTENT_BOX);
    offsetBox = TP.elementGetOffsetBox(actionElem, TP.CONTENT_BOX);

    offsetPoint = this.get('$offsetPoint');

    computedPoint = this.get('$computedPoint');

    actionWin = TP.nodeGetWindow(actionElem);
    styleObj = TP.elementGetStyleObj(actionElem);

    side = this.get('dragSide');

    borderLeft = TP.elementGetBorderInPixels(actionElem, TP.LEFT);
    borderTop = TP.elementGetBorderInPixels(actionElem, TP.TOP);

    offsetParent = TP.elementGetOffsetParent(actionElem);

    if (TP.isElement(offsetParent)) {
        parentBorderTop = TP.elementGetBorderInPixels(offsetParent, TP.TOP);
        parentBorderLeft = TP.elementGetBorderInPixels(offsetParent, TP.LEFT);
    } else {
        parentBorderTop = 0;
        parentBorderLeft = 0;
    }

    workerFuncs = this.get('workers');
    infoAttrs = this.get('infoAttrs');

    switch (side) {
        case TP.TOP:

            computedY = currentY - offsetPoint.getY();

            computedPoint.setY(computedY);
            this.modifyResponderData(currentSignal, computedPoint);
            computedY = computedPoint.getY();

            if (computedY > 0) {
                dimensionY =
                        offsetBox.at('height') -
                        (computedY - parentBorderTop - offsetBox.at('top')) -
                        borderTop;
            } else {
                dimensionY = offsetBox.at('height') -
                                (computedY - offsetBox.at('top')) -
                                borderTop;
            }

            clampYVal = offsetBox.at('top') +
                        offsetBox.at('height') -
                        (borderTop - parentBorderTop);

            if (computedY < clampYVal) {

                topVal = computedY;
                if (computedY > 0) {
                    /* eslint-disable no-extra-parens */
                    heightVal = (dimensionY - parentBorderTop);
                    /* eslint-enable no-extra-parens */
                } else {
                    heightVal = dimensionY;
                }

                actionWin.requestAnimationFrame(
                    function() {
                        if (TP.notEmpty(workerFuncs)) {
                            workerFuncs.forEach(
                                function(aFunc) {
                                    aFunc(actionElem,
                                            styleObj,
                                            TP.hc(
                                                'top', topVal,
                                                'height', heightVal),
                                            infoAttrs);
                                });
                        } else {
                            styleObj.top = topVal + 'px';
                            styleObj.height = heightVal + 'px';
                        }
                    });
            }

            break;

        case TP.TOP_RIGHT:

            computedY = currentY - offsetPoint.getY();
            computedX = currentX - pageBox.at('left') + offsetPoint.getX();

            computedPoint.setXY(computedX, computedY);
            this.modifyResponderData(currentSignal, computedPoint);
            computedX = computedPoint.getX();
            computedY = computedPoint.getY();

            if (computedY > 0) {
                dimensionY =
                        offsetBox.at('height') -
                        (computedY - parentBorderTop - offsetBox.at('top')) -
                        borderTop;
            } else {
                dimensionY = offsetBox.at('height') -
                                (computedY - offsetBox.at('top')) -
                                borderTop;
            }

            clampYVal = offsetBox.at('top') +
                        offsetBox.at('height') -
                        (borderTop - parentBorderTop);

            if (computedY < clampYVal) {

                topVal = computedY;

                if (computedY > 0) {
                    /* eslint-disable no-extra-parens */
                    heightVal = (dimensionY - parentBorderTop);
                    /* eslint-enable no-extra-parens */
                } else {
                    heightVal = dimensionY;
                }

                widthVal = computedX;

                actionWin.requestAnimationFrame(
                    function() {
                        if (TP.notEmpty(workerFuncs)) {
                            workerFuncs.forEach(
                                function(aFunc) {
                                    aFunc(actionElem,
                                            styleObj,
                                            TP.hc(
                                                'top', topVal,
                                                'height', heightVal,
                                                'width', widthVal),
                                            infoAttrs);
                                });
                        } else {
                            styleObj.top = topVal + 'px';
                            styleObj.height = heightVal + 'px';
                            styleObj.width = widthVal + 'px';
                        }
                    });
            }

            break;

        case TP.RIGHT:

            computedX = currentX - pageBox.at('left') + offsetPoint.getX();

            computedPoint.setX(computedX);
            this.modifyResponderData(currentSignal, computedPoint);
            computedX = computedPoint.getX();

            widthVal = computedX;

            actionWin.requestAnimationFrame(
                function() {
                    if (TP.notEmpty(workerFuncs)) {
                        workerFuncs.forEach(
                            function(aFunc) {
                                aFunc(actionElem,
                                        styleObj,
                                        TP.hc(
                                            'width', widthVal),
                                        infoAttrs);
                            });
                    } else {
                        styleObj.width = widthVal + 'px';
                    }
            });

            break;

        case TP.BOTTOM_RIGHT:

            computedX = currentX - pageBox.at('left') + offsetPoint.getX();
            computedY = currentY - pageBox.at('top') + offsetPoint.getY();

            computedPoint.setXY(computedX, computedY);
            this.modifyResponderData(currentSignal, computedPoint);
            computedX = computedPoint.getX();
            computedY = computedPoint.getY();

            widthVal = computedX;
            heightVal = computedY;

            actionWin.requestAnimationFrame(
                function() {
                    if (TP.notEmpty(workerFuncs)) {
                        workerFuncs.forEach(
                            function(aFunc) {
                                aFunc(actionElem,
                                        styleObj,
                                        TP.hc(
                                            'height', heightVal,
                                            'width', widthVal),
                                        infoAttrs);
                            });
                    } else {
                        styleObj.width = widthVal + 'px';
                        styleObj.height = heightVal + 'px';
                    }
                });

            break;

        case TP.BOTTOM:

            computedY = currentY - pageBox.at('top') + offsetPoint.getY();

            computedPoint.setY(computedY);
            this.modifyResponderData(currentSignal, computedPoint);
            computedY = computedPoint.getY();

            heightVal = computedY;

            actionWin.requestAnimationFrame(
                function() {
                    if (TP.notEmpty(workerFuncs)) {
                        workerFuncs.forEach(
                            function(aFunc) {
                                aFunc(actionElem,
                                        styleObj,
                                        TP.hc(
                                            'height', heightVal),
                                        infoAttrs);
                            });
                    } else {
                        styleObj.height = heightVal + 'px';
                    }
                });

            break;

        case TP.BOTTOM_LEFT:

            computedX = currentX - offsetPoint.getX();
            computedY = currentY - pageBox.at('top') + offsetPoint.getY();

            computedPoint.setXY(computedX, computedY);
            this.modifyResponderData(currentSignal, computedPoint);
            computedX = computedPoint.getX();
            computedY = computedPoint.getY();

            if (computedX > 0) {
                dimensionX =
                        offsetBox.at('width') -
                        (computedX - parentBorderLeft - offsetBox.at('left')) -
                        borderLeft;
            } else {
                dimensionX = offsetBox.at('width') -
                                (computedX - offsetBox.at('left')) -
                                borderLeft;
            }

            clampXVal = offsetBox.at('left') +
                        offsetBox.at('width') -
                        (borderLeft - parentBorderLeft);

            if (computedX < clampXVal) {

                leftVal = computedX;

                if (computedX > 0) {
                    /* eslint-disable no-extra-parens */
                    widthVal = (dimensionX - parentBorderLeft);
                    /* eslint-enable no-extra-parens */
                } else {
                    widthVal = dimensionX;
                }

                heightVal = computedY;

                actionWin.requestAnimationFrame(
                    function() {
                        if (TP.notEmpty(workerFuncs)) {
                            workerFuncs.forEach(
                                function(aFunc) {
                                    aFunc(actionElem,
                                            styleObj,
                                            TP.hc(
                                                'left', leftVal,
                                                'height', heightVal,
                                                'width', widthVal),
                                            infoAttrs);
                                });
                        } else {
                            styleObj.left = leftVal + 'px';
                            styleObj.height = heightVal + 'px';
                            styleObj.width = widthVal + 'px';
                        }
                    });
            }

            break;

        case TP.LEFT:

            computedX = currentX - offsetPoint.getX();

            computedPoint.setX(computedX);
            this.modifyResponderData(currentSignal, computedPoint);
            computedX = computedPoint.getX();

            if (computedX > 0) {
                dimensionX =
                        offsetBox.at('width') -
                        (computedX - parentBorderLeft - offsetBox.at('left')) -
                        borderLeft;
            } else {
                dimensionX = offsetBox.at('width') -
                                (computedX - offsetBox.at('left')) -
                                borderLeft;
            }

            clampXVal = offsetBox.at('left') +
                        offsetBox.at('width') -
                        (borderLeft - parentBorderLeft);

            if (computedX < clampXVal) {

                leftVal = computedX;

                if (computedX > 0) {
                    /* eslint-disable no-extra-parens */
                    widthVal = (dimensionX - parentBorderLeft);
                    /* eslint-enable no-extra-parens */
                } else {
                    widthVal = dimensionX;
                }

                actionWin.requestAnimationFrame(
                    function() {
                        if (TP.notEmpty(workerFuncs)) {
                            workerFuncs.forEach(
                                function(aFunc) {
                                    aFunc(actionElem,
                                            styleObj,
                                            TP.hc(
                                                'left', leftVal,
                                                'width', widthVal),
                                            infoAttrs);
                                });
                        } else {
                            styleObj.left = leftVal + 'px';
                            styleObj.width = widthVal + 'px';
                        }
                    });
            }

            break;

        case TP.TOP_LEFT:

            computedX = currentX - offsetPoint.getX();
            computedY = currentY - offsetPoint.getY();

            computedPoint.setXY(computedX, computedY);
            this.modifyResponderData(currentSignal, computedPoint);
            computedX = computedPoint.getX();
            computedY = computedPoint.getY();

            if (computedY > 0) {
                dimensionY =
                        offsetBox.at('height') -
                        (computedY - parentBorderTop - offsetBox.at('top')) -
                        borderTop;
            } else {
                dimensionY = offsetBox.at('height') -
                                (computedY - offsetBox.at('top')) -
                                borderTop;
            }

            clampYVal = offsetBox.at('top') +
                        offsetBox.at('height') -
                        (borderTop - parentBorderTop);

            if (computedY < clampYVal) {

                topVal = computedY;

                if (computedY > 0) {
                    /* eslint-disable no-extra-parens */
                    heightVal = (dimensionY - parentBorderTop);
                    /* eslint-enable no-extra-parens */
                } else {
                    heightVal = dimensionY;
                }

                actionWin.requestAnimationFrame(
                    function() {
                        if (TP.notEmpty(workerFuncs)) {
                            workerFuncs.forEach(
                                function(aFunc) {
                                    aFunc(actionElem,
                                            styleObj,
                                            TP.hc(
                                                'top', topVal,
                                                'height', heightVal),
                                            infoAttrs);
                                });
                        } else {
                            styleObj.top = topVal + 'px';
                            styleObj.height = heightVal + 'px';
                        }
                    });
            }

            if (computedX > 0) {
                dimensionX =
                        offsetBox.at('width') -
                        (computedX - parentBorderLeft - offsetBox.at('left')) -
                        borderLeft;
            } else {
                dimensionX = offsetBox.at('width') -
                                (computedX - offsetBox.at('left')) -
                                borderLeft;
            }

            clampXVal = offsetBox.at('left') +
                        offsetBox.at('width') -
                        (borderLeft - parentBorderLeft);

            if (computedX < clampXVal) {

                leftVal = computedX;

                if (computedX > 0) {
                    /* eslint-disable no-extra-parens */
                    widthVal = (dimensionX - parentBorderLeft);
                    /* eslint-enable no-extra-parens */
                } else {
                    widthVal = dimensionX;
                }

                actionWin.requestAnimationFrame(
                    function() {
                        if (TP.notEmpty(workerFuncs)) {
                            workerFuncs.forEach(
                                function(aFunc) {
                                    aFunc(actionElem,
                                            styleObj,
                                            TP.hc(
                                                'left', leftVal,
                                                'width', widthVal),
                                            infoAttrs);
                                });
                        } else {
                            styleObj.left = leftVal + 'px';
                            styleObj.width = widthVal + 'px';
                        }
                    });
            }

            break;

        default:
            break;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.ResizeResponder.Inst.defineHandler('ResizingEnter',
function(aSignal) {

    /**
     * @method handleResizingEnter
     * @summary Executed when the state machine associated with this receiver
     *     enters the 'resizing' state. This method performs whatever processing
     *     is necessary to start the resizing process.
     * @param {TP.sig.StateSignal} aSignal The state signal generated by the
     *     state machine machinery when triggering this state.
     * @returns {TP.dnd.ResizeResponder} The receiver.
     */

    var startSignal,

        actionElem,

        overlayElem,

        insetTop,
        insetRight,
        insetBottom,
        insetLeft,

        startPoint,
        startX,
        startY,

        styleObj,

        bodyElem;

    startSignal = this.get('startSignal');
    actionElem = this.get('actionElement');

    if (TP.notValid(startSignal) || !TP.isElement(actionElem)) {
        return this;
    }

    //  Create an 'overlay element' that will overlay the entire action element
    //  during the time that the gesture is active.
    overlayElem = TP.documentConstructElement(
                            TP.nodeGetDocument(actionElem),
                            'div',
                            TP.w3.Xmlns.XHTML);

    insetTop = this.get('insetTop');
    insetRight = this.get('insetRight');
    insetBottom = this.get('insetBottom');
    insetLeft = this.get('insetLeft');

    TP.elementSetStyleString(overlayElem,
                        TP.join('position: ', 'absolute;',
                                ' top: ', insetTop + 'px;',
                                ' right: ', insetRight + 'px;',
                                ' bottom: ', insetBottom + 'px;',
                                ' left: ', insetLeft + 'px;',
                                ' background-color: ', 'transparent;'));

    this.set('$overlayElement', overlayElem);

    //  Append the overlay element to the element we're performing the action
    //  on. This will allow us to 'hit test' with the insets we computed above.
    TP.nodeAppendChild(actionElem, overlayElem, false);

    //  Grab the start point and make sure that the overlay element contains it.
    //  If it doesn't, we must've come down on one of the insets, so we just
    //  stop propagation of the state signal, detach the overlay element and
    //  exit.

    startPoint = this.get('startPoint');
    startX = startPoint.getX();
    startY = startPoint.getY();

    if (!TP.elementContainsPoint(overlayElem, startX, startY)) {
        aSignal.stopPropagation();

        TP.nodeDetach(overlayElem);

        this.set('actionElement', null);

        return this;
    }

    //  Now we repurpose the overlay element to overlay the whole body for
    //  dragging purposes. This will prevent spurious events from affecting the
    //  dragging action.

    //  First, reset all of the style position/sizes to 0
    styleObj = TP.elementGetStyleObj(overlayElem);
    styleObj.top = '0px';
    styleObj.right = '0px';
    styleObj.bottom = '0px';
    styleObj.left = '0px';

    //  Then (re)append the overlay element onto the body.
    bodyElem = TP.documentGetBody(TP.nodeGetDocument(actionElem));
    TP.nodeAppendChild(bodyElem, overlayElem, false);

    //  Make sure and disable the user select on the body element so that we
    //  don't get weird selection behavior from the host platform.
    TP.elementDisableUserSelect(TP.nodeGetDocument(actionElem).body);

    //  A reusable point that we can use in our dragging computations.
    this.set('$computedPoint', TP.pc());

    //  Set the attribute on the action element that indicates we are 'resizing'
    //  it.
    TP.elementSetAttribute(actionElem, 'pclass:resizing', 'true', true);

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.ResizeResponder.Inst.defineHandler('ResizingExit',
function(aSignal) {

    /**
     * @method handleResizingExit
     * @summary Executed when the state machine associated with this receiver
     *     exits the 'resizing' state. This method performs whatever processing
     *     is necessary to stop the resizing process.
     * @param {TP.sig.StateSignal} aSignal The state signal generated by the
     *     state machine machinery when triggering this state.
     * @returns {TP.dnd.ResizeResponder} The receiver.
     */

    var actionElem,

        overlayElem;

    actionElem = this.get('actionElement');

    if (!TP.isElement(actionElem)) {
        return this;
    }

    //  Remove the attribute on the action element that indicated we were
    //  'resizing' it.
    TP.elementRemoveAttribute(actionElem, 'pclass:resizing', true);

    //  Reenable the user select behavior for the body element
    TP.elementEnableUserSelect(TP.nodeGetDocument(actionElem).body);

    //  Remove the element that was overlaying the action element
    overlayElem = this.get('$overlayElement');
    TP.nodeDetach(overlayElem);

    if (TP.isTrue(this.get('sideComputed'))) {
        this.set('dragSide', null);
    }

    //  Since this is a shared responder, we need to teardown it's responder
    //  data.
    this.teardownDataModifiers();

    //  Empty out any workers that got added
    this.get('workers').empty();

    //  These parameters need to be reset since this responder is shared and may
    //  be used again
    this.set('actionElement', null);
    this.set('targetElement', null);

    this.set('xOffset', 0);
    this.set('yOffset', 0);

    this.set('dragCorner', null);

    this.set('currentPoint', TP.pc(0, 0));
    this.set('$frameOffsetPoint', TP.pc(0, 0));

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.ResizeResponder.Inst.defineMethod('prepareFrom',
function(infoTPElement, srcTPElement, evtTPElement, initialSignal, attrHash) {

    /**
     * @method prepareFrom
     * @summary Prepares the receiver by using well-known attributes present on
     *     the supplied info element.
     * @param {TP.dom.ElementNode} infoTPElement The object to obtain
     *     configuration information from.
     * @param {TP.dom.ElementNode} srcTPElement The object that acts as the
     *     'source' of the drag operation.
     * @param {TP.dom.ElementNode} evtTPElement The object that the originating
     *     event occurred in and which might be used as the action element.
     * @param {TP.sig.DOMMouseSignal} initialSignal The signal that started the
     *     dragging session. Usually this will be an instance of
     *     TP.sig.DOMDragDown.
     * @param {TP.core.Hash} attrHash An optional hash that this method will use
     *     instead of the attribute data from the element.
     * @returns {TP.dnd.ResizeResponder} The receiver.
     */

    var attrs,

        attrVal,
        containerElem;

    //  If no attribute hash was supplied, then grab one from the 'information'
    //  TP.dom.ElementNode.
    if (TP.notValid(attrs = attrHash)) {
        attrs = infoTPElement.getAttributes();
    }

    //  If the author has configured a drag container, install our own modifier
    //  function for that and remove the key so that supertypes won't install
    //  anything else for that.

    //  Note here how we specify both 'autocollapse' and 'retry with document',
    //  for the TP.nodeEvaluatePath() call since we only want one element and we
    //  want the document to be retried as the context node - very useful for
    //  CSS paths.
    if (TP.notEmpty(attrVal = attrs.at('drag:container')) &&
        TP.isElement(containerElem = TP.nodeEvaluatePath(
                                        evtTPElement.getNativeNode(),
                                        attrVal,
                                        null,
                                        true,
                                        true))) {
        this.addDataModifier(
                TP.dnd.ResizeResponder.CLAMP_RECT_TO_CONTAINER,
                TP.hc('container', containerElem));
    }

    //  If the author has configured a resize side, set our value for that and
    //  remove the key so that supertypes won't install anything else for that.

    if (TP.notEmpty(attrVal = attrs.at('drag:side'))) {
        this.set('dragSide', TP[attrVal]);
    }

    //  If the author has configured a set of drag constraint function names,
    //  use them to configure the modifier functions

    if (TP.notEmpty(attrVal = attrs.at('drag:constraints'))) {

        //  The author can define multiple values.
        attrVal = attrVal.split(' ');

        attrVal.perform(
                function(aConstraintVal) {
                    var constraintFunc;

                    //  If the value names a constant on the
                    //  TP.dnd.ResizeResponder or the TP.dnd.DragResponder
                    //  type that points to a callable Function, then add it
                    //  as a data modifier.
                    if (TP.isCallable(
                            constraintFunc =
                                TP.dnd.ResizeResponder[aConstraintVal]) ||
                        TP.isCallable(
                            constraintFunc =
                                TP.dnd.DragResponder[aConstraintVal])) {
                        this.addDataModifier(constraintFunc);
                    }
                }.bind(this));
    }

    if (TP.notEmpty(attrVal = attrs.at('drag:workers'))) {

        //  The author can define multiple values.
        attrVal = attrVal.split(' ');

        attrVal.perform(
                function(aConstraintVal) {
                    var workerFunc;

                    //  If the value names a constant on the
                    //  TP.dnd.ResizeResponder or the TP.dnd.DragResponder
                    //  type that points to a callable Function, then add it
                    //  as a data modifier.
                    if (TP.isCallable(
                            workerFunc =
                                TP.dnd.ResizeResponder[aConstraintVal]) ||
                        TP.isCallable(
                            workerFunc =
                                TP.dnd.DragResponder[aConstraintVal])) {
                        this.addDragWorker(workerFunc);
                    }
                }.bind(this));
    }

    //  Need to do this since we might have generated 'attrs' here and want to
    //  pass it along.
    return this.callNextMethod(infoTPElement, srcTPElement,
                                evtTPElement, initialSignal, attrs);
});

//  ========================================================================
//  TP.dnd.DNDResponder
//  ========================================================================

/**
 * @type {TP.dnd.DNDResponder}
 * @summary A DragResponder responsible for drag and drop operations.
 */

//  ------------------------------------------------------------------------

TP.dnd.MoveResponder.defineSubtype('DNDResponder');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.dnd.DNDResponder.Type.defineConstant(
'CLAMP_X_AND_Y_TO_CONTAINER',
function(aDragResponder, aSignal, xyPoint) {

    var maxFittedRect,

        target,
        targetContainer,

        coords,

        targetRect,
        containerRect,

        maxPoint,
        kallee;

    kallee = TP.dnd.DNDResponder.CLAMP_X_AND_Y_TO_CONTAINER;

    if (TP.notValid(maxFittedRect = kallee.tempData.at('maxFittedRect'))) {

        target = aDragResponder.get('itemElement');

        targetContainer = kallee.modifierData.at('container');
        if (TP.notValid(targetContainer)) {
            targetContainer = TP.elementGetOffsetParent(target);
            if (!TP.isElement(targetContainer)) {
                targetContainer = TP.documentGetBody(
                                    TP.nodeGetDocument(target));
            }
        }

        coords = TP.elementGetPageBox(target,
                                        TP.BORDER_BOX,
                                        null,
                                        false);
        targetRect = TP.rtc(coords);

        coords = TP.elementGetPageBox(targetContainer,
                                        TP.CONTENT_BOX,
                                        null,
                                        false);
        containerRect = TP.rtc(coords);

        maxPoint = targetRect.maxFittedPoint(containerRect);
        maxFittedRect = TP.rtc(containerRect.getX(),
                    containerRect.getY(),
                    maxPoint.getX(),
                    maxPoint.getY());

        kallee.tempData.atPut('maxFittedRect', maxFittedRect);
    }

    xyPoint.clampToRect(maxFittedRect);
});

//  ---

TP.dnd.DNDResponder.Type.defineConstant(
'FILTER_BY_STRING_OR',
function(aDragResponder, sourceTPElem, targetTPElem, itemTPElem) {

    var acceptVal,
        vendVal,

        acceptVals,
        vendVals;

    if (TP.isEmpty(acceptVal = targetTPElem.getAttribute('dnd:accept'))) {
        return false;
    }

    if (TP.notEmpty(vendVal = sourceTPElem.getAttribute('dnd:vend'))) {

        acceptVals = acceptVal.split(' ');
        vendVals = vendVal.split(' ');

        return acceptVals.containsAny(vendVals);
    }

    return false;
});

//  ---

TP.dnd.DNDResponder.Type.defineConstant(
'FILTER_BY_STRING_AND',
function(aDragResponder, sourceTPElem, targetTPElem, itemTPElem) {

    var acceptVal,
        vendVal,

        acceptVals,
        vendVals;

    if (TP.isEmpty(acceptVal = targetTPElem.getAttribute('dnd:accept'))) {
        return false;
    }

    if (TP.notEmpty(vendVal = sourceTPElem.getAttribute('dnd:vend'))) {

        acceptVals = acceptVal.split(' ');
        vendVals = vendVal.split(' ');

        return acceptVals.containsAll(vendVals);
    }

    return false;
});

//  ---

TP.dnd.DNDResponder.Type.defineConstant(
'FILTER_BY_TYPE',
function(aDragResponder, sourceTPElem, targetTPElem, itemTPElem) {

    var acceptVal,
        vendVal,

        sig,

        acceptVals,
        vendVals;

    //  If there is no value for 'dnd:accept', then we can early exit here with
    //  false. 'Nothing to see here'...
    if (TP.isEmpty(acceptVal =
                    targetTPElem.getAttribute('dnd:accept'))) {
        return false;
    }

    if (TP.notEmpty(vendVal =
                    sourceTPElem.getAttribute('dnd:vend'))) {
        //  Grab 1...n type names from the vend values and try to compute TIBET
        //  type names from them.
        vendVals = vendVal.split(' ');

        //  Manufacture a DOMDNDWillVend signal
        sig = TP.sig.DOMDNDWillVend.construct(null);

        //  Manually call 'handle' against any type names that can be derived
        //  from each vend value
        vendVals.perform(
            function(aVal) {
                var typ;

                if (TP.isType(typ = TP.sys.getTypeByName(aVal))) {
                    typ.handle(sig);
                }
            });

        //  If the signal has been 'prevent default'ed, then return false
        if (sig.shouldPrevent()) {
            return false;
        }

        //  Now fire the signal, using the source as the 'signal source'
        sig = sourceTPElem.signal(sig);

        //  If the signal has been 'prevent default'ed, then return false
        if (sig.shouldPrevent()) {
            return false;
        }

        //  Grab 1...n type names from the accept values and try to compute
        //  TIBET type names from them.
        acceptVals = acceptVal.split(' ');

        //  Manufacture a DOMDNDWillAccept signal
        sig = TP.sig.DOMDNDWillAccept.construct(null);

        //  Manually call 'handle' against any type names that can be derived
        //  from each accept value
        acceptVals.perform(
            function(aVal) {
                var typ;

                if (TP.isType(typ = TP.sys.getTypeByName(aVal))) {
                    typ.handle(sig);
                }
            });

        //  If the signal has been 'prevent default'ed, then return false
        if (sig.shouldPrevent()) {
            return false;
        }

        //  Now fire the signal, using the target as the 'signal source'
        sig = targetTPElem.signal(sig);

        //  If the signal has been 'prevent default'ed, then return false
        if (sig.shouldPrevent()) {
            return false;
        }

        //  Otherwise, return true
        return true;
    }

    return false;
});

//  ---

TP.dnd.DNDResponder.Type.defineConstant(
'FILTER_BY_PATH',
function(aDragResponder, sourceTPElem, targetTPElem, itemTPElem) {

    var vendVal,
        matchedElems,

        vendPath;

    //  The target element only needs to have a 'dnd:accept' value. We don't pay
    //  attention to the actual value.
    if (!targetTPElem.hasAttribute('dnd:accept')) {
        return false;
    }

    if (TP.notEmpty(vendVal = sourceTPElem.getAttribute('dnd:vend'))) {

        vendPath = TP.apc(vendVal);
        vendPath.set('shouldCollapse', false);

        if (TP.notEmpty(matchedElems = sourceTPElem.get(vendPath))) {
            return matchedElems.contains(targetTPElem, TP.IDENTITY);
        }
    }

    return false;
});

//  ---

TP.dnd.DNDResponder.Type.defineConstant(
'FILTER_BY_DTD',
function(aDragResponder, sourceTPElem, targetTPElem, itemTPElem) {

    //  The target element only needs to have a 'dnd:accept' value. We don't pay
    //  attention to the actual value.
    if (!targetTPElem.hasAttribute('dnd:accept')) {
        return false;
    }

    return TP.w3.DocType.HTML_401_STRICT.get(
                'dtdInfo').elementIsValidChildOf(
                        itemTPElem.getTagName().toLowerCase(),
                        targetTPElem.getTagName().toLowerCase());
});

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.dnd.DNDResponder.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    var stateMachine,
        inst;

    //  Construct a new state machine and use it as the state machine for the
    //  DND singleton.
    stateMachine = TP.dnd.DragResponder.get('dragStateMachine');

    //  The state machine will transition to 'resizing' when it is activated.
    stateMachine.defineState('idle', 'dragdropping');
    stateMachine.defineState('dragdropping', 'idle');

    //  Construct the responder instance and add our state machine.
    inst = this.construct();
    inst.setID('DNDService');

    inst.addStateMachine(stateMachine);

    return;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  The 'real' action element. This type uses a 'cover element' as the action
//  element.
TP.dnd.DNDResponder.Inst.defineAttribute('$realActionElem');

//  The item element - the element that the 'action element' (i.e. the DND
//  representation element) was generated from.
TP.dnd.DNDResponder.Inst.defineAttribute('itemElement');

//  The item element's offset X/Y point.
TP.dnd.DNDResponder.Inst.defineAttribute('itemPagePoint');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dnd.DNDResponder.Inst.defineMethod('computeOffsetPoint',
function() {

    /**
     * @method computeOffsetPoint
     * @summary Computes the gestures initial 'offset point'.
     * @description When computing the offset point, this method takes into
     *     account the following parameters:
     *     - The initial starting point
     *     - The offset from the action element's offset parent to the action
     *       element.
     *     - The border and margin from the action element's offset parent.
     *     - The 'drag corner' that was configured or computed for the gesture.
     * @returns {TP.dnd.DragResponder} The receiver.
     */

    var startPoint,
        startX,
        startY,

        actionElem,

        itemPagePoint,

        offsetParent,

        borderXOffset,
        borderYOffset,

        offsetX,
        offsetY,

        corner,
        elemBox,

        offsetPoint;

    //  In this type, the action element is the 'clone element' that we are
    //  dragging.

    if (!TP.isElement(actionElem = this.get('actionElement'))) {
        return this;
    }

    startPoint = this.get('startPoint');
    startX = startPoint.getX();
    startY = startPoint.getY();

    //  In this type, we don't worry about container offsets, since the action
    //  element is always a child of the 'body'. We do, however, have to obtain
    //  offsets from the original source element and compute those in.
    itemPagePoint = this.get('itemPagePoint');

    //  We do want to make sure that if the 'body' has a border, we account for
    //  it though.
    offsetParent = TP.elementGetOffsetParent(actionElem);

    if (TP.isElement(offsetParent)) {
        borderXOffset = TP.elementGetBorderInPixels(offsetParent, TP.LEFT);
        borderYOffset = TP.elementGetBorderInPixels(offsetParent, TP.TOP);
    } else {
        borderXOffset = 0;
        borderYOffset = 0;
    }

    offsetX = startX - borderXOffset - itemPagePoint.getX();
    offsetY = startY - borderYOffset - itemPagePoint.getY();

    if (TP.isValid(corner = this.get('dragCorner'))) {
        //  Since moving/resizing happens by setting 'top', 'left', 'width' or
        //  'height' of the 'style' property, we need to use the *content box*
        //  when measuring.
        elemBox = TP.elementGetPageBox(actionElem, TP.CONTENT_BOX);

        switch (corner) {
            case TP.TOP:

                break;

            case TP.TOP_RIGHT:

                offsetX = elemBox.at('left') + elemBox.at('width') - startX;

                break;

            case TP.RIGHT:

                offsetX = elemBox.at('left') + elemBox.at('width') - startX;

                break;

            case TP.BOTTOM_RIGHT:

                offsetX = elemBox.at('left') + elemBox.at('width') - startX;
                offsetY = elemBox.at('top') + elemBox.at('height') - startY;

                break;

            case TP.BOTTOM:

                offsetY = elemBox.at('top') + elemBox.at('height') - startY;

                break;

            case TP.BOTTOM_LEFT:

                offsetY = elemBox.at('top') + elemBox.at('height') - startY;

                break;

            case TP.LEFT:
                break;

            case TP.TOP_LEFT:
                break;

            default:
                break;
        }
    }

    offsetPoint = TP.pc(offsetX, offsetY);

    this.set('$offsetPoint', offsetPoint);

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DNDResponder.Inst.defineHandler('DragdroppingEnter',
function(aSignal) {

    /**
     * @method handleDragdroppingEnter
     * @summary Executed when the state machine associated with this receiver
     *     enters the 'dragdropping' state. This method performs whatever
     *     processing is necessary to start the dragdropping process.
     * @param {TP.sig.StateSignal} aSignal The state signal generated by the
     *     state machine machinery when triggering this state.
     * @returns {TP.dnd.DNDResponder} The receiver.
     */

    var actionElem,
        dndElem;

    //  Do this *first* before setting up the rest of the state machine

    //  Grab the current 'action element' - we'll actually use that as the
    //  'drag rep' element. The real action element will be the dndElem.
    if (!TP.isElement(actionElem = this.get('actionElement'))) {
        //  TODO: Bad stuff here...
        return this;
    }

    dndElem = this.makeDragElementFrom(actionElem);

    this.set('$realActionElem', actionElem);
    this.set('actionElement', dndElem);

    //  A reusable point that we can use in our dragging computations.
    this.set('$computedPoint', TP.pc());

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DNDResponder.Inst.defineHandler('DragdroppingExit',
function(aSignal) {

    /**
     * @method handleDragdroppingExit
     * @summary Executed when the state machine associated with this receiver
     *     exits the 'dragdropping' state. This method performs whatever
     *     processing is necessary to stop the dragging process.
     * @param {TP.sig.StateSignal} aSignal The state signal generated by the
     *     state machine machinery when triggering this state.
     * @returns {TP.dnd.DNDResponder} The receiver.
     */

    var sourceTPElem,

        targetTPElem,
        sigPayload,

        dndElem;

    sourceTPElem = TP.dom.UIElementNode.get('currentDNDSource');

    if (TP.isValid(targetTPElem =
                    TP.dom.UIElementNode.get('currentDNDTarget'))) {
        sigPayload = TP.hc('dndSource',
                            sourceTPElem,
                            'dndTarget',
                            targetTPElem);

    } else {
        sigPayload = TP.hc('dndSource', sourceTPElem);
    }

    if (TP.isValid(targetTPElem) && targetTPElem.willDrop()) {

        //  Send a 'TP.sig.DOMDNDSucceeded' signal
        this.signal('TP.sig.DOMDNDSucceeded', sigPayload);

    } else {

        //  Send a 'TP.sig.DOMDNDFailed' signal
        this.signal('TP.sig.DOMDNDFailed', sigPayload);
    }

    //  Send a 'TP.sig.DOMDNDCompleted' signal
    this.signal('TP.sig.DOMDNDCompleted', sigPayload);

    TP.dom.UIElementNode.Type.set('currentDNDSource', null);
    TP.dom.UIElementNode.Type.set('currentDNDTarget', null);
    TP.dom.UIElementNode.Type.set('currentDNDItem', null);

    //  Send a 'TP.sig.DOMDNDTerminate' signal
    this.signal('TP.sig.DOMDNDTerminate');

    //  Reset the D&D infrastructure

    //  NB: These steps are in a very particular order, due to the logic in
    //  supertypes.

    //  This will be the 'drag element' used by the receiver to drag the content
    //  around. NB: We need to grab this reference before 'calling up', since
    //  the action element gets cleared.
    dndElem = this.get('actionElement');

    //  Remove the drag element to avoid problems with mouse events which might
    //  hit the element by mistake.
    TP.nodeDetach(dndElem);

    // this.set('actionElement', this.get('$realActionElem'));

    //  Since this is a shared responder, we need to teardown it's responder
    //  data.
    this.teardownDataModifiers();

    //  These parameters need to be reset since this responder is shared and may
    //  be used again
    this.set('actionElement', null);
    this.set('targetElement', null);

    this.set('xOffset', 0);
    this.set('yOffset', 0);

    this.set('dragCorner', null);

    this.set('currentPoint', TP.pc(0, 0));
    this.set('$frameOffsetPoint', TP.pc(0, 0));

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DNDResponder.Inst.defineMethod('makeDragElementFrom',
function(anElement) {

    /**
     * @method makeDragElementFrom
     * @summary Returns the element to drag, creating it if necessary. This
     *     presets the manufactured drag element's top, left, width and height
     *     to those of the supplied element.
     * @param {HTMLElement} anElement The element supplied to use to position
     *     the manufactured element.
     * @returns {HTMLElement|undefined} The element using as a 'dragging
     *     element' for use in drag and drop operations.
     */

    var dragDoc,
        dragElement,

        dragCoords,

        dragElementWidth,
        dragElementHeight,

        dragCoverElement;

    if (TP.notValid(dragDoc = TP.nodeGetDocument(anElement))) {
        //  TODO: Throw an exception here?

        return;
    }

    //  Create a drag element and identify it for later lookup.
    dragElement = TP.documentConstructElement(dragDoc,
                                            'div',
                                            TP.w3.Xmlns.XHTML);
    dragElement.setAttribute('id', '__dragElement__');

    //  Set the style here (note that we'll set the z-index later when we begin
    //  the drag session - which we have to do anyway for dragging elements that
    //  we haven't created here).
    dragElement.setAttribute(
        'style',
        'position: absolute;' +
        ' z-index: ' + TP.DRAG_DROP_TIER + ';' +
        ' pointer-events: none');

    //  Mark this element as one that was generated by TIBET and shouldn't be
    //  considered in CSS queries, etc.
    dragElement[TP.GENERATED] = true;

    TP.nodeAppendChild(TP.documentGetBody(dragDoc), dragElement, false);

    //  Note that we don't worry about reassignment here
    TP.nodeAppendChild(dragElement, anElement, false);

    dragCoords = this.get('itemPagePoint');

    dragElement.style.left = dragCoords.getX() + 'px';
    dragElement.style.top = dragCoords.getY() + 'px';

    //  The width of the drag element is going to be the same as the original
    //  element.
    dragElementWidth = TP.elementGetContentWidth(anElement);
    dragElementHeight = TP.elementGetContentHeight(anElement);

    //  Set its width and height based on the width and height of the content of
    //  the original element.
    TP.elementSetWidth(dragElement, dragElementWidth);
    TP.elementSetHeight(dragElement, dragElementHeight);

    //  Generate a 'drag cover element' to cover the entire contents of the
    //  dragElement. We append this last so that if spurious mouse events occur
    //  where the user was moving the drag element so fast that they actually
    //  dragged the mouse *back* over the top of the dragElement those events
    //  will be trapped by this drag cover element.

    if (TP.notValid(dragCoverElement = dragElement.dragCoverElement)) {
        dragCoverElement = TP.documentConstructElement(dragDoc,
                                                        'div',
                                                        TP.w3.Xmlns.XHTML);

        dragCoverElement.setAttribute(
                    'style',
                    'position: absolute; background-color: transparent; ' +
                    ' top: -5px; right: -5px; bottom: -5px; left: -5px;' +
                    ' pointer-events: none');

        dragElement.dragCoverElement = dragCoverElement;
    }

    //  Note that we don't worry about reassignment here (but we do append the
    //  transparent 'cover element' *after* the content element).
    TP.nodeAppendChild(dragElement, dragCoverElement, false);

    return dragElement;
});

//  ------------------------------------------------------------------------

TP.dnd.DNDResponder.Inst.defineMethod('prepareFrom',
function(infoTPElement, srcTPElement, evtTPElement, initialSignal, attrHash) {

    /**
     * @method prepareFrom
     * @summary Prepares the receiver by using well-known attributes present on
     *     the supplied info element.
     * @param {TP.dom.ElementNode} infoTPElement The object to obtain
     *     configuration information from.
     * @param {TP.dom.ElementNode} srcTPElement The object that acts as the
     *     'source' of the drag operation.
     * @param {TP.dom.ElementNode} evtTPElement The object that the originating
     *     event occurred in and which might be used as the action element.
     * @param {TP.sig.DOMMouseSignal} initialSignal The signal that started the
     *     dragging session. Usually this will be an instance of
     *     TP.sig.DOMDragDown.
     * @param {TP.core.Hash} attrHash An optional hash that this method will use
     *     instead of the attribute data from the element.
     * @returns {TP.dnd.DNDResponder} The receiver.
     */

    var attrs,

        attrVal,
        containerElem;

    //  If no attribute hash was supplied, then grab one from the 'information'
    //  TP.dom.ElementNode.
    if (TP.notValid(attrs = attrHash)) {
        attrs = infoTPElement.getAttributes();
    }

    this.set('infoAttrs', attrs);

    //  If the author has configured a drag container, install our own
    //  modifier function for that and remove the key so that supertypes
    //  won't install anything else for that.

    //  Note here how we specify both 'autocollapse' and 'retry with
    //  document', for the TP.nodeEvaluatePath() call since we only want one
    //  element and we want the document to be retried as the context node -
    //  very useful for CSS paths.
    if (TP.notEmpty(attrVal = attrs.at('drag:container')) &&
        TP.isElement(containerElem = TP.nodeEvaluatePath(
                                        evtTPElement.getNativeNode(),
                                        attrVal,
                                        null,
                                        true,
                                        true))) {
        this.addDataModifier(
                TP.dnd.DNDResponder.CLAMP_X_AND_Y_TO_CONTAINER,
                TP.hc('container', containerElem));
    }

    //  NB: We do *not* call up to the TP.dnd.MoveResponder's method here,
    //  since we have different logic for setup.

    return this;
});

//  ========================================================================
//  TP.dom.UIElementNode additions
//  ========================================================================

/**
 * @summary Additions to the TP.dom.UIElementNode type to support drag and
 *     drop operations.
 */

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineConstant(
        'DRAG_CSS_PROPERTY_NAMES',
        TP.ac('background', 'backgroundAttachment', 'backgroundColor',
                'backgroundImage', 'backgroundPosition', 'backgroundRepeat',
                'border', 'borderBottom', 'borderBottomColor',
                'borderBottomStyle', 'borderBottomWidth', 'borderCollapse',
                'borderColor', 'borderLeft', 'borderLeftColor',
                'borderLeftStyle', 'borderLeftWidth', 'borderRight',
                'borderRightColor', 'borderRightStyle', 'borderRightWidth',
                'borderSpacing', 'borderStyle', 'borderTop',
                'borderTopColor', 'borderTopStyle', 'borderTopWidth',
                'borderWidth', 'clear', 'clip', 'color',
                'content', 'counterIncrement', 'counterReset', 'cssFloat',
                'cursor', 'direction', 'display', 'emptyCells', 'font',
                'fontFamily', 'fontSize', 'fontSizeAdjust', 'fontStretch',
                'fontStyle', 'fontVariant', 'fontWeight', 'height',
                'letterSpacing', 'lineHeight', 'listStyle',
                'listStyleImage', 'listStylePosition', 'listStyleType',
                'margin', 'marginBottom', 'marginLeft', 'marginRight',
                'marginTop', 'maxHeight', 'maxWidth', 'minHeight',
                'minWidth', 'outline', 'outlineColor', 'outlineStyle',
                'outlineWidth', 'overflow', 'padding', 'paddingBottom',
                'paddingLeft', 'paddingRight', 'paddingTop', 'position',
                'quotes', 'size', 'tableLayout', 'textAlign',
                'textDecoration', 'textIndent', 'textShadow',
                'textTransform', 'unicodeBidi', 'verticalAlign',
                'visibility', 'whiteSpace', 'width', 'wordSpacing'));

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineAttribute('currentDNDSource');
TP.dom.UIElementNode.Type.defineAttribute('currentDNDTarget');
TP.dom.UIElementNode.Type.defineAttribute('currentDNDItem');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('ondragdown',
function(aTargetElem, anEvent) {

    /**
     * @method ondragdown
     * @summary Handles a 'dragdown' native event (well, 'native' in that TIBET
     *     simulates it) that was dispatched against the supplied native element.
     * @param {HTMLElement} aTargetElem The target element computed for this
     *     signal.
     * @param {Event} anEvent The native event that was triggered.
     * @exception TP.sig.InvalidElement
     * @returns {TP.meta.dom.UIElementNode} The receiver.
     */

    var evtTargetTPElem,
        sourceTPElem,
        infoTPElem,

        stateMachine,

        moveResponder,
        resizeResponder,
        dndResponder,

        sig,

        itemTPElem,

        actionElem,
        itemElem,

        initialSignal,
        startPoint,

        itemOffsets;

    if (!TP.isElement(aTargetElem)) {
        return this.raise('TP.sig.InvalidElement');
    }

    //  Grab the event target element and wrap it
    evtTargetTPElem = TP.wrap(aTargetElem);

    //  Check to see if the event target will move. If so, activate the shared
    //  MoveService (an instance of TP.dnd.MoveResponder), set it up, activate
    //  it and exit.
    if (evtTargetTPElem.willMove(anEvent)) {
        if (TP.isValid(moveResponder = TP.bySystemId('MoveService'))) {

            //  Cache the target element - we'll need this ondragup
            moveResponder.set('targetElement', aTargetElem);

            //  Ask the wrapped event target element for its 'drag source'
            //  TP.dom.ElementNode. If it can't find one, then it acts as it's
            //  own.
            sourceTPElem = evtTargetTPElem.getDragSource();

            //  Ask the drag source TP.dom.ElementNode for its 'drag info'
            //  TP.dom.ElementNode
            infoTPElem = sourceTPElem.getDragInfo();

            //  Set up the responder using the info, source and event target
            //  native elements
            moveResponder.prepareFrom(infoTPElem,
                                        sourceTPElem,
                                        evtTargetTPElem,
                                        TP.wrap(anEvent));
        }

        stateMachine = moveResponder.getStateMachines().first();

        if (!stateMachine.isActive()) {
            stateMachine.activate();
        }

        stateMachine.transition('moving');

        return this;
    }

    //  Check to see if the event target will resize. If so, activate the shared
    //  ResizeService (an instance of TP.dnd.ResizeResponder), set it up,
    //  activate it and exit.
    if (evtTargetTPElem.willResize(anEvent)) {
        if (TP.isValid(resizeResponder = TP.bySystemId('ResizeService'))) {

            //  Cache the target element - we'll need this ondragup
            resizeResponder.set('targetElement', aTargetElem);

            //  Ask the wrapped event target element for its 'drag source'
            //  TP.dom.ElementNode
            sourceTPElem = evtTargetTPElem.getDragSource();

            //  Ask the drag source for its 'drag info' TP.dom.ElementNode
            infoTPElem = sourceTPElem.getDragInfo();

            //  Set up the responder using the info, source and event target
            //  native elements
            resizeResponder.prepareFrom(infoTPElem,
                                        sourceTPElem,
                                        evtTargetTPElem,
                                        TP.wrap(anEvent));
        }

        stateMachine = resizeResponder.getStateMachines().first();

        if (!stateMachine.isActive()) {
            stateMachine.activate();
        }

        stateMachine.transition('resizing');

        return this;
    }

    //  Check to see if the event target will grab. If so, obtain the
    //  drag-and-drop 'source' TP.dom.ElementNode and proceed from there.
    if (evtTargetTPElem.willGrab(anEvent) &&
        TP.isValid(sourceTPElem = evtTargetTPElem.getDNDSource())) {
        if (TP.isValid(dndResponder = TP.bySystemId('DNDService'))) {
            //  Send a 'TP.sig.DOMDNDInitiate' signal and make sure no one
            //  cancels it
            sig = dndResponder.signal('TP.sig.DOMDNDInitiate');
            if (sig.shouldPrevent()) {
                return this;
            }

            //  Ask the source for its 'drag info' TP.dom.ElementNode. This
            //  very well may be the sourceTPElem itself if there is no separate
            //  element pointed to by 'drag:info'.
            infoTPElem = sourceTPElem.getDNDInfo();

            //  Get the 'drag item' TP.dom.ElementNode. Again, this very well
            //  may be the sourceTPElem itself, but it might an 'item' within
            //  the source or some other element. It's the one we actually want
            //  to drag.
            itemTPElem = infoTPElem.getDragItem();

            //  Ask the item TP.dom.ElementNode if a 'DND representation
            //  element' can be computed. If one can be, then set up the shared
            //  DND responder.
            if (TP.isElement(actionElem = itemTPElem.getDNDRepElement())) {

                //  Set up the shared dnd responder using the info, source
                //  and event target native elements

                initialSignal = TP.wrap(anEvent);

                //  Cache the target element - we'll need this ondragup
                dndResponder.set('targetElement', aTargetElem);

                //  Note here how we make the 'action element' be the rep
                //  element that was computed from the item element.
                dndResponder.prepareFrom(infoTPElem,
                                            sourceTPElem,
                                            evtTargetTPElem,
                                            initialSignal);
                dndResponder.set('actionElement', actionElem);

                //  Some filter functions need a handle to the item element
                //  itself.
                itemElem = itemTPElem.getNativeNode();
                dndResponder.set('itemElement', itemElem);

                //  Grab the item elements pageX/pageY. This will be used when
                //  computing where to place the rep element.
                itemOffsets = TP.elementGetPageXY(itemElem);
                dndResponder.set('itemPagePoint', TP.pc(itemOffsets));

                //  initialSignal will be the DOMDragDown signal that started us
                //  dragging

                if (TP.isValid(initialSignal)) {
                    dndResponder.set('startSignal', initialSignal);
                    dndResponder.set('currentSignal', initialSignal);

                    startPoint = initialSignal.getPagePoint();
                    dndResponder.set('startPoint', startPoint);

                    //  Note that if we can calculate a start point because we
                    //  got a DOMDragDown signal, then we also use that as our
                    //  item page point since (for D&D scenarios) we actually
                    //  want the item to move to wherever the mouse is starting
                    //  the D&D operation.
                    dndResponder.set('itemPagePoint', startPoint);

                    //  Compute the offset point (after we set the corner)
                    dndResponder.computeOffsetPoint();

                    //  Set up any installed data modifiers
                    dndResponder.setupDataModifiers();

                    //  Note here how we do *not* run any modifiers. Therefore,
                    //  the start point will remain unchanged.
                }

                TP.dom.UIElementNode.Type.set(
                                        'currentDNDSource', sourceTPElem);
                TP.dom.UIElementNode.Type.set(
                                        'currentDNDItem', itemTPElem);

                stateMachine = dndResponder.getStateMachines().first();

                if (!stateMachine.isActive()) {
                    stateMachine.activate();
                }

                stateMachine.transition('dragdropping');
            }
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('ondragup',
function(aTargetElem, anEvent) {

    /**
     * @method ondragup
     * @summary Handles a 'dragup' native event (well, 'native' in that TIBET
     *     simulates it) that was dispatched against the supplied native
     *     element.
     * @param {HTMLElement} aTargetElem The target element computed for this
     *     signal.
     * @param {Event} anEvent The native event that was triggered.
     * @exception TP.sig.InvalidElement
     * @returns {TP.meta.dom.UIElementNode} The receiver.
     */

    var dragStateMachine,

        responder,
        targetElement;

    if (!TP.isElement(aTargetElem)) {
        return this.raise('TP.sig.InvalidElement');
    }

    dragStateMachine = TP.dnd.DragResponder.get('dragStateMachine');
    if (!dragStateMachine.isActive()) {
        return this;
    }

    //  Grab the target element before we deactivate.
    //  TODO: This is a little cheesy - we should have another way to get back
    //  to the responders
    responder = TP.bySystemId('MoveService');
    targetElement = responder.get('targetElement');

    if (!TP.isElement(targetElement)) {
        responder = TP.bySystemId('ResizeService');
        targetElement = responder.get('targetElement');
    }

    if (!TP.isElement(targetElement)) {
        responder = TP.bySystemId('DNDService');
        targetElement = responder.get('targetElement');
    }

    dragStateMachine.transition('idle');

    dragStateMachine.deactivate();

    if (TP.isElement(targetElement)) {
        return this.onmouseup(targetElement, anEvent);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('ondragover',
function(aTargetElem, anEvent) {

    /**
     * @method ondragover
     * @summary Handles a 'dragover' native event (well, 'native' in that TIBET
     *     simulates it) that was dispatched against the supplied native
     *     element.
     * @param {HTMLElement} aTargetElem The target element computed for this
     *     signal.
     * @param {Event} anEvent The native event that was triggered.
     * @exception TP.sig.InvalidElement
     * @returns {TP.meta.dom.UIElementNode} The receiver.
     */

    var dragStateMachine,

        evtTargetTPElem,

        targetTPElem;

    if (!TP.isElement(aTargetElem)) {
        return this.raise('TP.sig.InvalidElement');
    }

    dragStateMachine = TP.dnd.DragResponder.get('dragStateMachine');
    if (!dragStateMachine.isActive()) {
        return this;
    }

    evtTargetTPElem = TP.wrap(aTargetElem);

    targetTPElem = evtTargetTPElem.getDNDTarget();

    if (TP.isValid(targetTPElem) && targetTPElem.isValidTarget()) {

        //  Cache a reference to the 'current drag and drop target' for when the
        //  target exits.
        TP.dom.UIElementNode.Type.set('currentDNDTarget', targetTPElem);

        //  Send a 'TP.sig.DOMDNDTargetOver' signal
        targetTPElem.signal('TP.sig.DOMDNDTargetOver', TP.hc('event', anEvent));
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Type.defineMethod('ondragout',
function(aTargetElem, anEvent) {

    /**
     * @method ondragout
     * @summary Handles a 'dragout' native event (well, 'native' in that TIBET
     *     simulates it) that was dispatched against the supplied native
     *     element.
     * @param {HTMLElement} aTargetElem The target element computed for this
     *     signal.
     * @param {Event} anEvent The native event that was triggered.
     * @exception TP.sig.InvalidElement
     * @returns {TP.meta.dom.UIElementNode} The receiver.
     */

    var dragStateMachine,

        targetTPElem;

    if (!TP.isElement(aTargetElem)) {
        return this.raise('TP.sig.InvalidElement');
    }

    dragStateMachine = TP.dnd.DragResponder.get('dragStateMachine');
    if (!dragStateMachine.isActive()) {
        return this;
    }

    if (TP.notValid(targetTPElem =
                    TP.dom.UIElementNode.get('currentDNDTarget'))) {
        return this;
    }

    //  Send a 'TP.sig.DOMDNDTargetOut' signal
    targetTPElem.signal('TP.sig.DOMDNDTargetOut', TP.hc('event', anEvent));

    //  Clear out the reference to the 'current drag and drop target'
    TP.dom.UIElementNode.Type.set('currentDNDTarget', null);

    return this;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getDragInfo',
function() {

    /**
     * @method getDragInfo
     * @summary Returns drag information for the receiver. This information is
     *     found by looking for a 'drag:info' attribute on the receiver that
     *     should point (via some type of access path) to a 'drag info' object
     *     that provides information about configuring the drag session.
     * @description If the 'drag:info' attribute doesn't exist on the receiver,
     *     then the receiver itself is returned as the source for drag
     *     information.
     * @returns {TP.dom.ElementNode} The element that provides information
     *     about configuring the drag session.
     */

    var attrVal,
        infoElem;

    //  If there is no 'drag:info' attribute on the element, then we just return
    //  the receiver.
    if (!this.hasAttribute('drag:info')) {
        return this;
    }

    if (TP.notEmpty(attrVal = TP.elementGetAttribute(this.getNativeNode(),
                                                        'drag:info',
                                                        true))) {
        //  Note here how we specify both 'autocollapse' and 'retry with
        //  document', since we only want one element and we want the document
        //  to be retried as the context node - very useful for CSS paths.
        if (TP.isElement(
                infoElem =
                    TP.nodeEvaluatePath(
                        this.getNativeNode(), attrVal, null, true, true))) {
            return TP.wrap(infoElem);
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getDragItem',
function() {

    /**
     * @method getDragItem
     * @summary Returns the element that will act as the item that should be
     *     dragged in a drag session. This will be provided by the 'drag:item'
     *     attribute on the receiver that should point to the item to be
     *     dragged.
     * @description If the value of the 'drag:item' attribute is the word
     *     'target', then the target of the last mouse down event is used as the
     *     drag item. If the 'drag:item' attribute doesn't exist on the
     *     receiver, then the receiver itself is returned as the drag item.
     * @returns {TP.dom.ElementNode} The element to be dragged in a drag
     *     session.
     */

    var attrVal,

        lastDown,

        targetElem,
        itemElem,

        sourceNatElem;

    //  If there is no 'drag:item' attribute on the info element, then we just
    //  return the source, since they're one and the same.
    if (!this.hasAttribute('drag:item')) {
        return this;
    }

    //  If we found a 'drag:item' attribute, we see what it's value is. If its
    //  'target', then we use the 'lastDown's target element. Otherwise, we
    //  assume that its a path and we execute the path *in the context of the
    //  source element*

    attrVal = this.getAttribute('drag:item');

    if (attrVal === 'target') {

        lastDown = TP.core.Mouse.get('lastDown');

        if (TP.isElement(targetElem = TP.eventGetResolvedTarget(lastDown))) {
            itemElem = targetElem;
        }
    } else {

        sourceNatElem = this.getNativeNode();

        //  Note here how we specify 'autocollapse' for the
        //  TP.nodeEvaluatePath() call since we only want one element
        if (!TP.isElement(itemElem = TP.nodeEvaluatePath(
                                            sourceNatElem,
                                            attrVal,
                                            null,
                                            true))) {
            itemElem = sourceNatElem;
        }
    }

    return TP.wrap(itemElem);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getDragSource',
function() {

    /**
     * @method getDragSource
     * @summary Returns the element that provides the 'drag source' for the
     *     current drag session.
     * @description If the 'drag:mover' or 'drag:resizer' attributes exist on
     *     the receiver, then the receiver itself is returned as the dragging
     *     source.
     * @returns {TP.dom.ElementNode} The element that provides information
     *     about configuring the drag session.
     */

    var sourceTPElem,
        infoTPElem,

        results;

    //  If the receiver itself has a 'dnd:mover' or 'dnd:resizer' attribute,
    //  then we can use it.
    if (this.hasAttribute('drag:mover') || this.hasAttribute('drag:resizer')) {
        return this;
    }

    //  Otherwise, we scan upwards through our ancestors looking for a
    //  'drag:item' attribute
    sourceTPElem =
        this.detectAncestor(
            function(ansTPElem) {
                return ansTPElem.hasAttribute('drag:mover') ||
                        ansTPElem.hasAttribute('drag:resizer');
            });

    //  If we found a valid source TP.dom.ElementNode, get its 'info'
    //  TP.dom.ElementNode and make sure that the receiver's native node is
    //  part of the results returned by executing the path supplied in the
    //  'drag:item' attribute (relative to the source element).
    if (TP.isValid(sourceTPElem)) {
        infoTPElem = sourceTPElem.getDragInfo();
        if (infoTPElem.hasAttribute('drag:item')) {
            if (TP.notEmpty(results = TP.nodeEvaluatePath(
                                        sourceTPElem.getNativeNode(),
                                        infoTPElem.getAttribute('drag:item'),
                                        null))) {
                //  Confirmed that the receiver does exist within the path
                //  given as the 'drag:item' on the infoTPElementNode
                if (results.contains(this.getNativeNode(), TP.IDENTITY)) {
                    return sourceTPElem;
                }
            }
        }
    }

    //  If we can't find a drag info for ourself, then we act as our own.
    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getDNDInfo',
function() {

    /**
     * @method getDNDInfo
     * @summary Returns drag and drop information for the receiver. This
     *     information is found by looking for a 'dnd:info' attribute on the
     *     receiver that should point (via some type of access path) to a 'dnd
     *     info' object that provides information about configuring the drag and
     *     drop session.
     * @description If the 'dnd:info' attribute doesn't exist on the receiver,
     *     then the receiver itself is returned as the source for drag and drop
     *     information.
     * @returns {TP.dom.ElementNode} The element that provides information
     *     about configuring the drag and drop session.
     */

    var attrVal,
        infoElem;

    //  If there is no 'dnd:info' attribute on the element, then we just return
    //  the receiver (which should be the source), since they're one and the
    //  same.
    if (!this.hasAttribute('dnd:info')) {
        return this;
    }

    if (TP.notEmpty(attrVal = TP.elementGetAttribute(this.getNativeNode(),
                                                        'dnd:info',
                                                        true))) {
        //  Note here how we specify both 'autocollapse' and 'retry with
        //  document', since we only want one element and we want the document
        //  to be retried as the context node - very useful for CSS paths.
        if (TP.isElement(
                    infoElem =
                        TP.nodeEvaluatePath(
                        this.getNativeNode(), attrVal, null, true, true))) {
            return TP.wrap(infoElem);
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getDNDRepElement',
function() {

    /**
     * @method getDNDRepElement
     * @summary Returns a native Element node that will represent the receiver
     *     during a drag and drop operation. At this type level, this method
     *     provides the default implementation of this method, which is to
     *     return the receiver's native node.
     * @exception TP.sig.InvalidElement
     * @returns {Element} The native Element to use as a representation during a
     *     drag and drop operation.
     */

    var elem,

        attrVal,

        repElem,

        dragClone,

        pclassAttrNodes,
        styleStr;

    if (TP.notValid(elem = this.getNativeNode())) {
        return this.raise('TP.sig.InvalidElement');
    }

    if (TP.notEmpty(attrVal = TP.elementGetAttribute(elem, 'dnd:rep', true))) {
        //  Note here how we specify both 'autocollapse' and 'retry with
        //  document', since we only want one element and we want the document
        //  to be retried as the context node - very useful for CSS paths.
        if (!TP.isElement(repElem = TP.nodeEvaluatePath(
                                        elem, attrVal, null, true, true))) {
            repElem = elem;
        }
    } else {
        repElem = elem;
    }

    //  Find any 'pclass:' attributes and remove them. This will affect the
    //  style that we're going to copy.
    pclassAttrNodes = TP.elementGetAttributeNodesInNS(
                                        repElem, null, TP.w3.Xmlns.PCLASS);

    if (TP.notEmpty(pclassAttrNodes)) {
        pclassAttrNodes.forEach(
            function(anAttrNode) {
                TP.elementRemoveAttribute(repElem, anAttrNode.name, true);
            });
    }

    //  Now, clone the representation element without the 'pclass:' attributes
    //  on it.
    dragClone = TP.nodeCloneNode(repElem);

    //  And compute the style string to use with the drag clone without the
    //  affects of any 'pclass:' attributes.
    styleStr = TP.elementGetComputedStyleString(
                    repElem,
                    TP.dom.UIElementNode.DRAG_CSS_PROPERTY_NAMES);

    //  Put any removed 'pclass:' attributes back onto the representation
    //  element to leave it untouched.
    if (TP.notEmpty(pclassAttrNodes)) {
        pclassAttrNodes.forEach(
            function(anAttrNode) {
                TP.elementSetAttribute(
                    repElem, anAttrNode.name, anAttrNode.value, true);
            });
    }

    //  Set the style string on the clone.
    TP.elementSetStyleString(dragClone, styleStr);

    //  Remove the 'id' to make sure the clone is unique in the document.
    TP.elementRemoveAttribute(dragClone, 'id');

    //  Make sure that the clone is 'shown' - if the D&D rep was gotten from a
    //  hidden block somewhere, it may not be showing.
    TP.elementShow(dragClone);

    return dragClone;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getDNDSource',
function() {

    /**
     * @method getDNDSource
     * @summary Returns the element that provides the 'dnd source' for the
     *     current drag and drop session.
     * @description If the 'drag:vend' attribute exists on the receiver, then
     *     the receiver itself is returned as the drag and drop source.
     * @returns {TP.dom.ElementNode} The element that acts as the source for a
     *     drag and drop session.
     */

    //  If the receiver itself has a 'dnd:vend' attribute, then we can use it.
    if (this.hasAttribute('dnd:vend')) {
        return this;
    }

    //  Otherwise, we need to traverse the parent chain, looking for a
    //  'dnd:vend'.
    return this.detectAncestor(
                function(ansTPElem) {
                    return ansTPElem.hasAttribute('dnd:vend');
                });
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('getDNDTarget',
function() {

    /**
     * @method getDNDTarget
     * @summary Returns the element that provides the 'dnd target' for the
     *     current drag and drop session.
     * @description If the 'drag:accept' attribute exists on the receiver, then
     *     the receiver itself is returned as the drag and drop target.
     * @returns {TP.dom.ElementNode} The element that acts as the target for a
     *     drag and drop session.
     */

    //  If the receiver itself has a 'dnd:accept' attribute, then we can grab
    //  it.
    if (this.hasAttribute('dnd:accept')) {
        return this;
    }

    //  Otherwise, we need to traverse the parent chain, looking for a
    //  'dnd:accept'.
    return this.detectAncestor(
                function(ansTPElem) {
                    return ansTPElem.hasAttribute('dnd:accept');
                });
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('isValidTarget',
function() {

    /**
     * @method isValidTarget
     * @summary Whether or not the receiver is a valid drop target for the
     *     current drag and drop session. This method uses information from the
     *     current drag source and the receiver to calculate whether the
     *     receiver is a valid target. The computation of this can also be
     *     altered by the value of the 'dnd:filter' attribute on the receiver.
     * @returns {Boolean} Whether or not the receiver is a valid drop target for
     *     the current drag and drop session.
     */

    var dndSource,
        dndItem,

        testFuncName,

        dragResponder;

    if (!this.hasAttribute('dnd:accept')) {
        return false;
    }

    if (TP.notValid(dndSource = this.getType().get('currentDNDSource')) ||
        TP.notValid(dndItem = this.getType().get('currentDNDItem'))) {
        return false;
    }

    testFuncName = TP.ifEmpty(
                        dndSource.getAttribute('dnd:filter'),
                        'FILTER_BY_STRING_OR');

    //  Try some built-in values
    switch (testFuncName) {
        case 'or':
            testFuncName = 'FILTER_BY_STRING_OR';
            break;

        case 'and':
            testFuncName = 'FILTER_BY_STRING_AND';
            break;

        case 'type':
            testFuncName = 'FILTER_BY_TYPE';
            break;

        case 'path':
            testFuncName = 'FILTER_BY_PATH';
            break;

        case 'dtd':
            testFuncName = 'FILTER_BY_DTD';
            break;

        default:
            break;
    }

    if (!TP.isCallable(TP.dnd.DNDResponder[testFuncName])) {
        return false;
    }

    if (TP.notValid(dragResponder = TP.bySystemId('DNDService'))) {
        return false;
    }

    return TP.dnd.DNDResponder[testFuncName](dragResponder,
                                                dndSource,
                                                this,
                                                dndItem);
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('willDrop',
function() {

    /**
     * @method willDrop
     * @summary Returns whether or not drag and drop items can be dropped into
     *     the receiver.
     * @returns {Boolean} Whether or not drag and drop items can be dropped into
     *     the receiver.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('willGrab',
function(normalizedEvent) {

    /**
     * @method willGrab
     * @summary Returns whether or not items can be grabbed to start a drag and
     *     drop session.
     * @param {Event} normalizedEvent The native event containing the signal's
     *     raw data.
     * @returns {Boolean} Whether or not items can be grabbed to start a drag
     *     and drop session.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('willMove',
function(normalizedEvent) {

    /**
     * @method willMove
     * @summary Returns whether or not the receiver can be moved via a drag
     *     session.
     * @param {Event} normalizedEvent The native event containing the signal's
     *     raw data.
     * @returns {Boolean} Whether or not the receiver can be moved via a drag
     *     session.
     */

    var sourceTPElem,
        infoTPElem,

        results;

    //  If the receiver' 'drag info' element (usually itself) has a 'drag:mover'
    //  attribute, then we just return true
    if (this.getDragInfo().hasAttribute('drag:mover')) {
        return true;
    }

    //  Otherwise, we scan upwards through our ancestors looking for a
    //  'drag:item' attribute
    sourceTPElem =
        this.detectAncestor(
                function(ansTPElem) {
                    return ansTPElem.hasAttribute('drag:item');
                });

    //  If we found a valid source TP.dom.ElementNode, get its 'info'
    //  TP.dom.ElementNode and make sure that the info TP.dom.ElementNode has
    //  a 'drag:mover' attribute and that the receiver's native node is part of
    //  the results returned by executing the path supplied in the 'drag:item'
    //  attribute (relative to the source element).
    if (TP.isValid(sourceTPElem)) {

        infoTPElem = sourceTPElem.getDragInfo();

        if (!infoTPElem.hasAttribute('drag:mover')) {
            return false;
        }

        if (TP.notEmpty(results = TP.nodeEvaluatePath(
                                    sourceTPElem.getNativeNode(),
                                    infoTPElem.getAttribute('drag:item'),
                                    null))) {
            return results.contains(this.getNativeNode(), TP.IDENTITY);
        }
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineMethod('willResize',
function(normalizedEvent) {

    /**
     * @method willResize
     * @summary Returns whether or not the receiver can be resized via a drag
     *     session.
     * @param {Event} normalizedEvent The native event containing the signal's
     *     raw data.
     * @returns {Boolean} Whether or not the receiver can be resized via a drag
     *     session.
     */

    var sourceTPElem,
        infoTPElem,

        results;

    //  If the receiver' 'drag info' element (usually itself) has a
    //  'drag:resizer' attribute, then we just return true
    if (this.getDragInfo().hasAttribute('drag:resizer')) {
        return true;
    }

    //  Otherwise, we scan upwards through our ancestors looking for a
    //  'drag:item' attribute
    sourceTPElem =
        this.detectAncestor(
                function(ansTPElem) {
                    return ansTPElem.hasAttribute('drag:item');
                });

    //  If we found a valid source TP.dom.ElementNode, get its 'info'
    //  TP.dom.ElementNode and make sure that the info TP.dom.ElementNode has
    //  a 'drag:resizer' attribute and that the receiver's native node is part
    //  of the results returned by executing the path supplied in the
    //  'drag:item' attribute (relative to the source element).
    if (TP.isValid(sourceTPElem)) {

        infoTPElem = sourceTPElem.getDragInfo();

        if (!infoTPElem.hasAttribute('drag:resizer')) {
            return false;
        }

        if (TP.notEmpty(results = TP.nodeEvaluatePath(
                                    sourceTPElem.getNativeNode(),
                                    infoTPElem.getAttribute('drag:item'),
                                    null))) {

            return results.contains(this.getNativeNode(), TP.IDENTITY);
        }
    }

    return false;
});

//  ========================================================================
//  TP.dnd.DragTracker
//  ========================================================================

/**
 * @type {TP.dnd.DragTracker}
 * @summary The TP.dnd.DragTracker is an object which responds to the
 *     current drag state and related events by tracking the mouse relative to a
 *     "domain" of objects.
 * @description Based on the configuration of the tracker instance the various
 *     geometric relationships between the mouse, any currently active drag
 *     element, and the domain objects, cause the tracker to signal
 *     "interesting" events. For example, a tracker configured for drag
 *     rectangle computations can be used to assist with over/out processing
 *     which avoids the problem of the mouse being over the drag element and not
 *     provided accurate over/out events itself. As another example a tracker
 *     might be configured to watch for edge-detection/alignment with the mouse
 *     and signaling when edges, centerpoints, or other alignments occur. These
 *     events could be observed by a "guideline displayer" to provide visual
 *     feedback.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('dnd.DragTracker');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  ---
//  "Filter functions"...functions which restrict the domain objects to a
//  subset that matches some criteria.
//  ---

TP.dnd.DragTracker.Type.defineConstant('VEND_ACCEPT',
function(domainObj, computeObj, mouseEvent) {
    //  Returns true if the vend and accept attributes are a match.
});


//  ---
//  "Range functions"...functions which collect computable values from a
//  domain object returned by a domainSpec.
//  ---

/* eslint-disable new-cap */

TP.dnd.DragTracker.Type.defineConstant('GLOBAL_CENTER',
    function(target) {
        var rect;

        if (TP.isValid(rect = this.GLOBAL_RECT(target))) {
            return rect.getCenterPoint();
        }

        return;
    });

TP.dnd.DragTracker.Type.defineConstant('GLOBAL_RECT',
    function(target) {
        if (TP.canInvoke(target, 'getGlobalRect')) {
            return target.getGlobalRect();
        } else if (TP.isElement(target)) {
            return TP.rtc(TP.elementGetGlobalBox(target));
        }

        return;
    });

TP.dnd.DragTracker.Type.defineConstant('GLOBAL_X_COORDS',
    function(target) {
        var rect;

        if (TP.isValid(rect = this.GLOBAL_RECT(target))) {
            return TP.ac(rect.getX(), rect.getX().addToX(rect.getWidth()));
        }

        return;
    });

TP.dnd.DragTracker.Type.defineConstant('GLOBAL_Y_COORDS',
    function(target) {
        var rect;

        if (TP.isValid(rect = this.GLOBAL_RECT(target))) {
            return TP.ac(rect.getY(), rect.getY().addToY(rect.getHeight()));
        }

        return;
    });

TP.dnd.DragTracker.Type.defineConstant('PAGE_CENTER',
    function(target) {
        var rect;

        if (TP.isValid(rect = this.PAGE_RECT(target))) {
            return rect.getCenterPoint();
        }

        return;
    });

TP.dnd.DragTracker.Type.defineConstant('PAGE_RECT',
    function(target) {
        if (TP.canInvoke(target, 'getPageRect')) {
            return target.getPageRect();
        } else if (TP.isElement(target)) {
            return TP.rtc(TP.elementGetPageBox(target));
        }

        return;
    });

TP.dnd.DragTracker.Type.defineConstant('PAGE_X_COORDS',
    function(target) {
        var rect;

        if (TP.isValid(rect = this.PAGE_RECT(target))) {
            return TP.ac(rect.getX(), rect.getX().addToX(rect.getWidth()));
        }

        return;
    });

TP.dnd.DragTracker.Type.defineConstant('PAGE_Y_COORDS',
    function(target) {
        var rect;

        if (TP.isValid(rect = this.PAGE_RECT(target))) {
            return TP.ac(rect.getY(), rect.getY().addToY(rect.getHeight()));
        }

        return;
    });

/* eslint-enable new-cap */

//  ---
//  "Test functions"...functions which return a boolean result relative to the
//  input data provided. The test function is effectively a "select" function
//  in TIBET terms. All domain/compute objects are iterated and those for
//  which the test function returns true become the payload of the
//  trackingSignal fired when the result set isn't empty.
//  ---

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  The state machine we observe for tracking event state changes.
TP.dnd.DragTracker.Inst.defineAttribute('stateMachine');

//  The list of objects the tracker uses for computation.
TP.dnd.DragTracker.Inst.defineAttribute('computeList');

//  The list of objects the tracker resolved by executing the domainSpec.
TP.dnd.DragTracker.Inst.defineAttribute('domainList');

//  A function constructed from the domainSpec which is used to construct the
//  domainList.
TP.dnd.DragTracker.Inst.defineAttribute('domainFunction');

//  The query specification used to describe (and acquire) the domainList.
TP.dnd.DragTracker.Inst.defineAttribute('domainSpec');

//  The default value for the filter function...simple vend/accept matching.
TP.dnd.DragTracker.Inst.defineAttribute('filterFunction',
    TP.dnd.DragTracker.VEND_ACCEPT);

//  The default value for the range function...page rectangle.
TP.dnd.DragTracker.Inst.defineAttribute('rangeFunction',
    TP.dnd.DragTracker.PAGE_RECT);

//  The test function run against each computable as the tracker's event
//  stream is processed. The default is a simple vend/accept matcher.
TP.dnd.DragTracker.Inst.defineAttribute('testFunction',
    TP.dnd.DragTracker.VEND_ACCEPT);

//  The signal to fire when the testFunction returns at least one computable.
TP.dnd.DragTracker.Inst.defineAttribute('trackingSignal',
    'TP.sig.DragTrackerResults');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dnd.DragTracker.Inst.defineMethod('init',
function(domainSpec, filterFunction, rangeFunction, testFunction, trackingSignal) {

    /**
     * @method init
     * @summary Initializes a new instance of the receiver.
     * @param {String|Function} domainSpec A domain specification function or
     *     string.
     * @param {Function} filterFunction
     * @param {Function} rangeFunction
     * @param {Function} testFunction
     * @param {TP.sig.Signal} trackingSignal
     * @returns {TP.dnd.DragTracker} A new instance.
     */

    var machine;

    if (TP.notValid(domainSpec)) {
        return this.raise('TP.sig.InvalidParamter',
            'Invalid domain specification.');
    }

    //  Configure a DragMachine to keep the responder informed on drag state.
    machine = TP.core.DragMachine.construct();

    this.callNextMethod();

    this.$set('stateMachine', machine);
    this.observe(machine, TP.sig.Dragging);

    this.$set('domainSpec', domainSpec);

    //  Validate and store any filter function provided.
    if (TP.isValid(filterFunction)) {
        if (!TP.isFunction(filterFunction)) {
            return this.raise('TP.sig.InvalidFunction',
                'Invalid filter function: ' + filterFunction);
        }
        this.$set('filterFunction', filterFunction);
    }

    //  Validate and store any range function provided.
    if (TP.isValid(rangeFunction)) {
        if (!TP.isFunction(rangeFunction)) {
            return this.raise('TP.sig.InvalidFunction',
                'Invalid range function: ' + rangeFunction);
        }
        this.$set('rangeFunction', rangeFunction);
    }

    //  Validate and store any test function provided.
    if (TP.isValid(testFunction)) {
        if (!TP.isFunction(testFunction)) {
            return this.raise('TP.sig.InvalidFunction',
                'Invalid test function: ' + testFunction);
        }
        this.$set('testFunction', testFunction);
    }

    //  Validate and store any tracking signal.
    if (TP.isValid(trackingSignal)) {
        if (!TP.canInvoke(trackingSignal, 'getSignalName')) {
            return this.raise('TP.sig.InvalidParameter',
                'trackingSignal can not provide signal name: ' +
                trackingSignal);
        }
        this.$set('trackingSignal', trackingSignal.getSignalName());
    }

    this.$set('computeList', TP.ac());
    this.$set('domainList', TP.ac());

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragTracker.Inst.defineMethod('clearComputables',
function() {

    /**
     * @method clearComputables
     * @summary Clears the receiver's cache of computable data.
     * @returns {TP.dnd.DragTracker} The receiver.
     */

    var list;

    list = this.$get('computeList');
    list.length = 0;

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragTracker.Inst.defineMethod('clearDomain',
function() {

    /**
     * @method clearDomain
     * @summary Clears the receiver's cache of domain objects, the objects
     *     which provide the basis for selection sets and computations.
     * @returns {TP.dnd.DragTracker} The receiver.
     */

    var list;

    list = this.$get('domainList');
    list.length = 0;

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragTracker.Inst.defineHandler('DraggingEnter',
function(aSignal) {

    /**
     * @method handleDraggingEnter
     * @summary Executed when the state machine associated with this receiver
     *     enters the 'dragging' state. This method performs whatever processing
     *     is necessary to start the dragging process.
     * @param {TP.sig.StateSignal} aSignal The state signal generated by the
     *     state machine machinery when triggering this state.
     * @returns {TP.dnd.DragTracker} The receiver.
     */

    //  Invoking a refresh of the domain will cause all lists to be cleared
    //  and regenerated using our current domainSpec as the starting point.
    this.refreshDomain();

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragTracker.Inst.defineHandler('DraggingExit',
function(aSignal) {

    /**
     * @method handleDraggingExit
     * @summary Executed when the state machine associated with this receiver
     *     exits the 'dragging' state. This method performs whatever processing
     *     is necessary to stop drag tracking.
     * @param {TP.sig.StateSignal} aSignal The state signal generated by the
     *     state machine machinery when triggering this state.
     * @returns {TP.dnd.DragTracker} The receiver.
     */

    //  When we terminate dragging we clear our caches to avoid holding on to
    //  references to elements or other data objects.
    this.clearDomain();
    this.clearComputables();

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragTracker.Inst.defineHandler('DOMDragHover',
function(aSignal) {

    /**
     * @method handleDOMDragHover
     * @summary Executed when this receiver receives a TP.sig.DOMDragHover
     *     signal (which it subscribes for when it enters the 'dragging' state).
     * @param {TP.sig.DOMDragHover} aSignal The DOMDragHover signal generated by
     *     the mouse.
     * @returns {TP.dnd.DragTracker} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragTracker.Inst.defineHandler('DOMDragMove',
function(aSignal) {

    /**
     * @method handleDOMDragMove
     * @summary Executed when this receiver receives a TP.sig.DOMDragMove
     *     signal (which it subscribes for when it enters the 'dragging' state).
     * @param {TP.sig.DOMDragMove} aSignal The DOMDragMove signal generated by
     *     the mouse.
     * @returns {TP.dnd.DragTracker} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragTracker.Inst.defineMethod('refreshComputables',
function() {

    /**
     * @method refreshComputables
     * @summary Refreshes the receiver's cache of computable data.
     * @returns {TP.dnd.DragTracker} The receiver.
     */

    this.clearComputables();

    //  Query each domain object using our current range function to compute a
    //  new set of computable values we'll run tracking tests against.

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragTracker.Inst.defineMethod('refreshDomain',
function() {

    /**
     * @method refreshDomain
     * @summary Refreshes the receiver's cache of domain objects, the objects
     *     which provide the basis for selection sets and computations.
     * @returns {TP.dnd.DragTracker} The receiver.
     */

    //  If the domain is being refreshed both our domain and computable lists
    //  have to be flushed. The computable list will be cleared when we
    //  refreshComputables after updating the domain list.
    this.clearDomain();

    //  Run the current domainSpec to get a set of domain objects rebuilt.

    //  Once we have new domain objects we need to refresh our computable
    //  list from that set of domain objects.
    this.refreshComputables();

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragTracker.Inst.defineMethod('setFilterFunction',
function(filterFunction) {

    /**
     * @method setFilterFunction
     * @summary Sets the filter function for the receiver. When the value
     *     changes the domain is re-filtered and the range function is rerun to
     *     update the computables list.
     * @param {Function} filterFunction The function to invoke on each domain
     *     object filter out non-matches.
     * @returns {TP.dnd.DragTracker} The receiver.
     */

    if (!TP.isFunction(filterFunction)) {
        return this.raise('TP.sig.InvalidFunction',
            'Invalid filter function: ' + filterFunction);
    }

    this.$set('filterFunction', filterFunction);

    //  Once we have a new filter function run it to update our range, and
    //  subsequently the computables list.
    this.refreshRange();

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragTracker.Inst.defineMethod('setRangeFunction',
function(rangeFunction) {

    /**
     * @method setRangeFunction
     * @summary Sets the range function for the receiver. When the value
     *     changes all computables are refreshed by querying the domain objects
     *     for their computable value.
     * @param {Function} rangeFunction The function to invoke on each domain
     *     object to acquire a computable value.
     * @returns {TP.dnd.DragTracker} The receiver.
     */

    if (!TP.isFunction(rangeFunction)) {
        return this.raise('TP.sig.InvalidFunction',
            'Invalid range function: ' + rangeFunction);
    }

    this.$set('rangeFunction', rangeFunction);

    //  Once we have a new range function run it to update our compute list.
    this.refreshComputables();

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragTracker.Inst.defineMethod('setTestFunction',
function(testFunction) {

    /**
     * @method setTestFunction
     * @summary Sets the test function for the receiver. This function is run
     *     when the event stream handler invokes it. All computables which pass
     *     the test function's checks are then placed in the payload of a
     *     tracking signal which notifies observers.
     * @param {Function} testFunction The function to invoke on each computable
     *     value to find tracking matches.
     * @returns {TP.dnd.DragTracker} The receiver.
     */

    if (!TP.isFunction(testFunction)) {
        return this.raise('TP.sig.InvalidFunction',
            'Invalid test function: ' + testFunction);
    }

    this.$set('testFunction', testFunction);

    return this;
});

//  ------------------------------------------------------------------------

TP.dnd.DragTracker.Inst.defineMethod('setTrackingSignal',
function(trackingSignal) {

    /**
     * @method setTrackingSignal
     * @summary Sets the tracking signal to fire when tracking matches are
     *     found.
     * @param {TP.sig.Signal|String} trackingSignal A signal or string which can
     *     provide the signal name to fire when tracking matches are found.
     * @returns {TP.dnd.DragTracker} The receiver.
     */

    if (!TP.canInvoke(trackingSignal, 'getSignalName')) {
        return this.raise('TP.sig.InvalidParameter',
            'trackingSignal can not provide signal name: ' + trackingSignal);
    }

    this.$set('trackingSignal', trackingSignal.getSignalName());

    return this;
});

//  ========================================================================
//  TP.core.KeyResponder
//  ========================================================================

/**
 * @type {TP.core.KeyResponder}
 * @summary A StateMachine event responder for simple keyboard operations.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('TP.core.KeyResponder');

TP.core.KeyResponder.addTraits(TP.core.StateResponder);

//  ------------------------------------------------------------------------

TP.core.KeyResponder.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @description We override at this level to just produce type and ID since
     *     this is a very 'deep' object that produces a very long JSON
     *     representation that takes a long time to render in a user interface.
     * @returns {String} A JSON-formatted string.
     */

    var str;

    str = '{"type":"' + TP.tname(this) + '",' +
            '"ID":"' + TP.id(this) + '"}';

    return str;
});

//  ------------------------------------------------------------------------

TP.core.KeyResponder.Inst.defineHandler('DOMKeySignal',
function(aSignal) {

    /**
     * @method handleDOMKeySignal
     * @summary Executes the handler on the receiver (if there is one) for the
     *     trigger signal (the underlying signal that caused a StateInput signal
     *     to be fired from the state machine to this object).
     * @param {TP.sig.StateInput} aSignal The signal that caused the state
     *     machine to get further input. The original triggering signal (most
     *     likely a keyboard-related signal) will be in this signal's payload
     *     under the key 'trigger'.
     * @returns {TP.core.KeyResponder} The receiver.
     */

    var handlerName;

    //  At this level, this type only handles subtypes of TP.sig.DOMKeySignal
    if (TP.isKindOf(aSignal, TP.sig.DOMKeySignal)) {

        handlerName = TP.composeHandlerName(aSignal.getKeyName());

        if (TP.canInvoke(this, handlerName)) {
            this[handlerName](aSignal);
        }
    }

    return this;
});

//  ========================================================================
//  TP.dom.SelectableItemUIElementNode
//  ========================================================================

TP.dom.UIElementNode.defineSubtype('SelectableItemUIElementNode');

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation
TP.dom.SelectableItemUIElementNode.isAbstract(true);

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dom.SelectableItemUIElementNode.Inst.defineMethod('getLabelText',
function() {

    /**
     * @method getLabelText
     * @summary Returns the text of the label of the receiver.
     * @returns {String} The receiver's label text.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.dom.SelectableItemUIElementNode.Inst.defineMethod('$getMarkupValue',
function() {

    /**
     * @method $getMarkupValue
     * @summary Returns the 'value' of the receiver as authored by user in the
     *     markup. Many times this is represented as a 'value' attribute in the
     *     markup and serves as the default.
     * @returns {String} The markup value of the receiver.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.dom.SelectableItemUIElementNode.Inst.defineMethod('$getPrimitiveValue',
function() {

    /**
     * @method $getPrimitiveValue
     * @summary Returns the low-level primitive value stored by the receiver in
     *     internal storage.
     * @returns {String} The primitive value of the receiver.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.dom.SelectableItemUIElementNode.Inst.defineMethod('$getVisualToggle',
function() {

    /**
     * @method $getVisualToggle
     * @summary Returns the low-level primitive 'toggle value' used by the
     *     receiver to display a 'selected' state.
     * @returns {Boolean} The low-level primitive 'toggle value' of the
     *     receiver.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.dom.SelectableItemUIElementNode.Inst.defineMethod('isSelected',
function() {

    /**
     * @method isSelected
     * @summary Returns true if the receiver is selected.
     * @returns {Boolean} Whether or not the receiver is selected.
     */

    return this.$getVisualToggle();
});

//  ------------------------------------------------------------------------

TP.dom.SelectableItemUIElementNode.Inst.defineMethod('$setVisualToggle',
function(aToggleValue) {

    /**
     * @method $setVisualToggle
     * @summary Sets the low-level primitive 'toggle value' used by the receiver
     *     to display a 'checked' or 'selected' state.
     * @param {Boolean} aToggleValue Whether or not to display the receiver's
     *     'checked' or 'selected' state.
     * @returns {TP.dom.SelectableItemUIElementNode} The receiver.
     */

    return TP.override();
});

//  ========================================================================
//  TP.dom.SelectingUIElementNode
//  ========================================================================

TP.dom.UIElementNode.defineSubtype('SelectingUIElementNode');

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation
TP.dom.SelectingUIElementNode.isAbstract(true);

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

/**
 * The selection model. This consists of a Hash where the keys are the selection
 * 'aspects' and the values are an Array of values of that aspect that at least
 * one of the items of the receiver needs to match in order for that item of the
 * receiver to be considered 'selected'.
 * @type {TP.core.Hash}
 */
TP.dom.SelectingUIElementNode.Inst.defineAttribute('selectionModel');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dom.SelectingUIElementNode.Inst.defineMethod('addSelection',
function(aValue, anAspect) {

    /**
     * @method addSelection
     * @summary Adds a selection to the receiver. Note that this method does not
     *     clear existing selections when processing the value(s) provided
     *     unless the receiver is not one that 'allows multiples'.
     * @description Note that the aspect can be one of the following, which will
     *      be the property used to determine which of them will be selected.
     *          'value'     ->  The value of the element (the default)
     *          'label'     ->  The label of the element
     *          'id'        ->  The id of the element
     *          'index'     ->  The numerical index of the element
     * @param {Object|Object[]} aValue The value to use when determining the
     *      elements to add to the selection. Note that this can be an Array.
     * @param {String} [anAspect=value] The property of the elements to use to
     *      determine which elements should be selected.
     * @exception TP.sig.InvalidOperation
     * @returns {Boolean} Whether or not a selection was added.
     */

    var separator,
        aspect,

        value,
        valueEntry,

        dirty,

        selectionModel,

        len,
        i;

    //  watch for multiple selection issues
    if (TP.isArray(aValue) && !this.allowsMultiples()) {
        return this.raise(
                'TP.sig.InvalidOperation',
                'Target TP.dom.SelectingUIElementNode does not allow' +
                ' multiple selection');
    }

    separator = TP.ifEmpty(this.getAttribute('bind:separator'),
                            TP.sys.cfg('bind.value_separator'));

    //  We default the aspect to 'value'
    aspect = TP.ifInvalid(anAspect, 'value');

    //  Refresh the selection model (in case we're dealing with components, like
    //  XHTML ones, that have no way of notifying us when their underlying
    //  '.value' or '.selectedIndex' changes).
    this.$refreshSelectionModelFor(aspect);

    if (TP.isString(aValue)) {
        value = aValue.split(separator);
    } else if (TP.isArray(aValue)) {
        value = aValue;
    } else {
        value = TP.ac(aValue);
    }

    dirty = false;

    //  Grab the selection model. If it doesn't allow multiples, then empty it.
    selectionModel = this.$getSelectionModel();
    if (!this.allowsMultiples()) {
        selectionModel.empty();
    }

    //  Grab the entry at the aspect provided. If the entry doesn't exist, then
    //  we just place the whole Array that we got above by splitting the value
    //  under the aspect key in the selection model and mark ourselves as dirty.
    valueEntry = selectionModel.at(aspect);
    if (TP.notValid(valueEntry)) {
        this.$getSelectionModel().atPut(aspect, value);
        dirty = true;
    } else {
        //  Otherwise, iterate over the Array that we got above by splitting the
        //  value and check to see if each value is in the Array that we have
        //  under that aspect in the selection model. If it isn't, push it in
        //  and mark ourselves as dirty.
        len = value.getSize();
        for (i = 0; i < len; i++) {
            if (!valueEntry.contains(value.at(i))) {
                valueEntry.push(value.at(i));
                dirty = true;
            }
        }
    }

    this.render();

    if (dirty) {
        this.changed('selection', TP.UPDATE);
    }

    return dirty;
});

//  ------------------------------------------------------------------------

TP.dom.SelectingUIElementNode.Inst.defineMethod('allowsMultiples',
function() {

    /**
     * @method allowsMultiples
     * @summary Returns true by default.
     * @returns {Boolean} Whether or not the receiver allows multiple selection.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.dom.SelectingUIElementNode.Inst.defineMethod('deselect',
function(aValue, anIndex, shouldSignal) {

    /**
     * @method deselect
     * @summary De-selects (clears) the element which has the provided value (if
     *     found) or is at the provided index. Also note that if no value is
     *     provided this will deselect (clear) all selected items.
     * @param {Object} [aValue] The value to de-select. Note that this can be an
     *     Array.
     * @param {Number} [anIndex] The index of the value in the receiver's data
     *     set.
     * @param {Boolean} [shouldSignal=true] Should selection changes be signaled.
     *     If false changes to the selection are not signaled. Defaults to true.
     * @returns {Boolean} Whether or not a selection was deselected.
     */

    var dirty;

    if (TP.isEmpty(aValue)) {
        return this.deselectAll();
    }

    dirty = this.removeSelection(aValue, 'value');

    if (dirty && TP.notFalse(shouldSignal)) {
        this.dispatch('TP.sig.UIDeselect');
    }

    return dirty;
});

//  ------------------------------------------------------------------------

TP.dom.SelectingUIElementNode.Inst.defineMethod('deselectAll',
function() {

    /**
     * @method deselectAll
     * @summary Clears any current selection(s).
     * @returns {TP.dom.SelectingUIElementNode} The receiver.
     */

    var selectionModel,
        oldSize,

        dirty;

    selectionModel = this.$getSelectionModel();

    //  Capture the size of the selection model before we empty it.
    oldSize = selectionModel.getSize();

    selectionModel.empty();

    //  We're dirty if the selection model had content before we emptied it.
    dirty = oldSize > 0;

    this.render();

    if (dirty) {
        this.changed('selection', TP.UPDATE);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.SelectingUIElementNode.Inst.defineMethod('$getSelectionModel',
function() {

    /**
     * @method $getSelectionModel
     * @summary Returns the current selection model (and creates a new one if it
     *     doesn't exist).
     * @returns {TP.core.Hash} The selection model.
     */

    var selectionModel;

    if (TP.notValid(selectionModel = this.$get('selectionModel'))) {
        selectionModel = TP.hc();
        this.set('selectionModel', selectionModel);
    }

    return selectionModel;
});

//  ------------------------------------------------------------------------

TP.dom.SelectingUIElementNode.Inst.defineMethod('isSelected',
function(aValue, anAspect) {

    /**
     * @method isSelected
     * @summary Checks to see if a control within the receiver containing the
     *     supplied value is selected.
     * @description Note that the aspect can be one of the following, which will
     *      be the property used to determine which of them will be selected.
     *          'value'     ->  The value of the element (the default)
     *          'label'     ->  The label of the element
     *          'id'        ->  The id of the element
     *          'index'     ->  The numerical index of the element
     * @param {Object|Object[]} aValue The value to use when determining the
     *      whether a particular element is selected. Note that this can be an
     *      Array.
     * @param {String} [anAspect=value] The property of the elements to use to
     *      determine which elements are selected.
     * @returns {Boolean} Whether or not a control within the receiver is
            selected.
     */

    var separator,
        aspect,

        value,
        valueEntry,

        selected,

        selectionModel,

        len,
        i;

    //  watch for multiple selection issues
    if (TP.isArray(aValue) && !this.allowsMultiples()) {
        return this.raise(
                'TP.sig.InvalidOperation',
                'Target TP.dom.SelectingUIElementNode does not allow' +
                ' multiple selection');
    }

    separator = TP.ifEmpty(this.getAttribute('bind:separator'),
                            TP.sys.cfg('bind.value_separator'));

    //  We default the aspect to 'value'
    aspect = TP.ifInvalid(anAspect, 'value');

    //  Refresh the selection model (in case we're dealing with components, like
    //  XHTML ones, that have no way of notifying us when their underlying
    //  '.value' or '.selectedIndex' changes).
    this.$refreshSelectionModelFor(aspect);

    if (TP.isString(aValue)) {
        value = aValue.split(separator);
    } else if (TP.isArray(aValue)) {
        value = aValue;
    } else {
        value = TP.ac(aValue);
    }

    selected = false;

    //  Grab the selection model.
    selectionModel = this.$getSelectionModel();

    //  Grab the entry at the aspect provided. If the entry doesn't exist, then
    //  there is no selection and we'll return false.
    valueEntry = selectionModel.at(aspect);
    if (TP.isValid(valueEntry)) {
        //  Otherwise, iterate over the Array that we got above by splitting the
        //  value and check to see if each value is in the Array that we have
        //  under that aspect in the selection model. If it isn't, mark
        //  ourselves as not selected and break.
        selected = true;
        len = value.getSize();
        for (i = 0; i < len; i++) {
            if (!valueEntry.contains(value.at(i))) {
                selected = false;
                break;
            }
        }
    }

    return selected;
});

//  ------------------------------------------------------------------------

TP.dom.SelectingUIElementNode.Inst.defineMethod('isSingleValued',
function(aspectName) {

    /**
     * @method isSingleValued
     * @summary If the aspect is 'value' this method returns true if the
     *     receiver is configured to *not* allow multiple selection. Otherwise
     *     it returns whatever the supertype returns.
     * @description See the TP.dom.Node's 'isScalarValued()' instance method
     *     for more information.
     * @param {String} [aspectName] An optional aspect name that is being used
     *     by the caller to determine whether the receiver is single valued for.
     * @returns {Boolean} If the aspectName is 'value', true if it does *not*
     *     allow multiple selection, false if otherwise. And false for all other
     *     aspects.
     */

    if (aspectName === 'value') {
        return !this.allowsMultiples();
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.dom.SelectingUIElementNode.Inst.defineMethod('$refreshSelectionModelFor',
function(anAspect) {

    /**
     * @method $refreshSelectionModelFor
     * @summary Refreshes the underlying selection model based on state settings
     *     in the UI.
     * @description Note that the aspect can be one of the following:
     *          'value'     ->  The value of the element (the default)
     *          'label'     ->  The label of the element
     *          'id'        ->  The id of the element
     *          'index'     ->  The numerical index of the element
     *     Note that, for this trait type, this method does nothing. Other types
     *     that mix in this trait should implement this if necessary.
     * @param {String} anAspect The property of the elements to use to
     *      determine which elements should be selected.
     * @returns {TP.dom.SelectingUIElementNode} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.SelectingUIElementNode.Inst.defineMethod('removeSelection',
function(aValue, anAspect) {

    /**
     * @method removeSelection
     * @summary Removes a selection from the receiver. Note that this method
     *     does not clear existing selections when processing the value(s)
     *     provided.
     * @description Note that the aspect can be one of the following, which will
     *      be the property used to determine which of them will be deselected.
     *          'value'     ->  The value of the element (the default)
     *          'label'     ->  The label of the element
     *          'id'        ->  The id of the element
     *          'index'     ->  The numerical index of the element
     * @param {Object|Object[]} aValue The value to use when determining the
     *      elements to remove from the selection. Note that this can be an
     *      Array.
     * @param {String} [anAspect=value] The property of the elements to use to
     *      determine which elements should be deselected.
     * @exception TP.sig.InvalidOperation
     * @returns {Boolean} Whether or not a selection was removed.
     */

    var separator,
        aspect,

        value,
        valueEntry,

        dirty,

        len,
        i,

        valIndex;

    //  watch for multiple selection issues
    if (TP.isArray(aValue) && !this.allowsMultiples()) {
        return this.raise(
                'TP.sig.InvalidOperation',
                'Target TP.dom.SelectingUIElementNode does not allow' +
                ' multiple selection');
    }

    separator = TP.ifEmpty(this.getAttribute('bind:separator'),
                            TP.sys.cfg('bind.value_separator'));

    //  We default the aspect to 'value'
    aspect = TP.ifInvalid(anAspect, 'value');

    //  Refresh the selection model (in case we're dealing with components, like
    //  XHTML ones, that have no way of notifying us when their underlying
    //  '.value' or '.selectedIndex' changes).
    this.$refreshSelectionModelFor(aspect);

    if (TP.isString(aValue)) {
        value = aValue.split(separator);
    } else if (TP.isArray(aValue)) {
        value = aValue;
    } else {
        value = TP.ac(aValue);
    }

    dirty = false;

    //  Grab the entry in the selection model at the aspect provided. If the
    //  entry doesn't exist, then we just return false. There was no selection
    //  and we're not dirty.
    valueEntry = this.$getSelectionModel().at(aspect);
    if (TP.notValid(valueEntry)) {
        return false;
    } else {
        //  Otherwise, iterate over the Array that we got above by splitting the
        //  value and check to see if each value is in the Array that we have
        //  under that aspect in the selection model. If it is, splice it out of
        //  the Array and mark ourselves as dirty.
        len = value.getSize();
        for (i = 0; i < len; i++) {
            //  NB: Leave this using getPosition() rather than changing to
            //  indexOf(). value.at(i) might be an Array and we need an equality
            //  comparison.
            valIndex = valueEntry.getPosition(value.at(i));

            if (valIndex !== TP.NOT_FOUND) {
                valueEntry.splice(valIndex, 1);
                dirty = true;
            }
        }
    }

    if (dirty) {
        this.$getSelectionModel().removeKey(TP.ALL);
    }

    this.render();

    if (dirty) {
        this.changed('selection', TP.UPDATE);
    }

    return dirty;
});

//  ------------------------------------------------------------------------

TP.dom.SelectingUIElementNode.Inst.defineMethod('select',
function(aValue, anIndex, shouldSignal) {

    /**
     * @method select
     * @summary Selects the element which has the provided value (if found) or
     *     is at the provided index.
     *     Note that this method is roughly identical to setDisplayValue() with
     *     the exception that, if the receiver allows multiple selection, this
     *     method does not clear existing selections when processing the
     *     value(s) provided.
     * @param {Object} aValue The value to select. Note that this can be an
     *     Array.
     * @param {Number} [anIndex] The index of the value in the receiver's data
     *     set.
     * @param {Boolean} [shouldSignal=true] Should selection changes be signaled.
     *     If false changes to the selection are not signaled. Defaults to true.
     * @returns {Boolean} Whether or not a selection was selected.
     */

    var dirty;

    if (TP.notValid(aValue)) {
        return false;
    }

    //  If allowsMultiples is false, then we can use a reference to a singular
    //  value that will be used as the selected value.
    if (!this.allowsMultiples()) {
        this.$getSelectionModel().empty();
    }

    dirty = this.addSelection(aValue, 'value');

    if (dirty && TP.notFalse(shouldSignal)) {
        this.dispatch('TP.sig.UISelect');
    }

    return dirty;
});

//  ------------------------------------------------------------------------

TP.dom.SelectingUIElementNode.Inst.defineMethod('selectAll',
function() {

    /**
     * @method selectAll
     * @summary Selects all elements with the same 'name' attribute as the
     *     receiver. Note that for groupings of controls that don't allow
     *     multiple selections (such as radiobuttons), this will raise an
     *     'InvalidOperation' exception.
     * @exception TP.sig.InvalidOperation
     * @returns {TP.dom.SelectingUIElementNode} The receiver.
     */

    var selectionModel,
        dirty;

    if (!this.allowsMultiples()) {
        return this.raise(
                'TP.sig.InvalidOperation',
                'Target does not allow multiple selection');
    }

    selectionModel = this.$getSelectionModel();

    //  If the selection model already has the special key 'TP.ALL', then
    //  everything is already selected.
    if (selectionModel.hasKey(TP.ALL)) {
        return this;
    }

    selectionModel.empty();
    selectionModel.atPut(TP.ALL, true);

    this.render();

    //  TODO: Can we always assume 'true' here? If all of the items of the
    //  receiver were selected individually, then this method was invoked, the
    //  special TP.ALL key won't be in selection model, but everything was
    //  already in the model.
    dirty = true;

    if (dirty) {
        this.changed('selection', TP.UPDATE);
    }

    return this;
});

//  ========================================================================
//  TP.dom.TogglingUIElementNode
//  ========================================================================

TP.dom.SelectingUIElementNode.defineSubtype('TogglingUIElementNode');

//  Add in selectable item traits - instances of this type manage themselves as
//  selectable items.
TP.dom.TogglingUIElementNode.addTraits(TP.dom.SelectableItemUIElementNode);

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation
TP.dom.TogglingUIElementNode.isAbstract(true);

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dom.TogglingUIElementNode.Inst.defineMethod('deselect',
function(aValue, anIndex, shouldSignal) {

    /**
     * @method deselect
     * @summary De-selects (clears) the element which has the provided value (if
     *     found) or is at the provided index. Also note that if no value is
     *     provided this will deselect (clear) all selected items.
     * @param {Object} [aValue] The value to de-select. Note that this can be an
     *     Array.
     * @param {Number} [anIndex] The index of the value in the receiver's data
     *     set.
     * @param {Boolean} [shouldSignal=true] Should selection changes be signaled.
     *     If false changes to the selection are not signaled. Defaults to true.
     * @returns {Boolean} Whether or not a selection was deselected.
     */

    var valueTPElems,

        len,
        i,
        item,

        value,

        matches;

    //  If aValue is a RegExp, then we use it to test against all of the value
    //  elements 'primitive value'. If we find one that matches, then we use
    //  that as the value to remove from our selection.

    if (TP.isRegExp(aValue)) {
        if (TP.notValid(valueTPElems = this.getValueElements())) {
            return this.raise('TP.sig.InvalidValueElements');
        }

        matches = TP.ac();

        len = valueTPElems.getSize();
        for (i = 0; i < len; i++) {

            item = valueTPElems.at(i);

            value = item.$getPrimitiveValue();

            if (aValue.test(value)) {
                matches.push(value);
            }
        }

        return this.callNextMethod(matches, anIndex, shouldSignal);
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.dom.TogglingUIElementNode.Inst.defineMethod('$generateSelectionHashFrom',
function(aValue) {

    /**
     * @method $generateSelectionHashFrom
     * @summary Returns a Hash that is driven off of the supplied value which
     *     can then be used to set the receiver's selection.
     * @returns {TP.core.Hash} A Hash that is populated with data from the
     *     supplied value that can be used for manipulating the receiver's
     *     selection.
     */

    var dict,
        keys,
        len,
        i;

    //  avoid MxN iterations by creating a hash of aValues
    if (TP.isArray(aValue)) {
        dict = TP.hc().addAllKeys(aValue, '');
    } else if (TP.isHash(aValue)) {
        dict = TP.hc().addAllKeys(aValue.getValues());
    } else if (TP.isPlainObject(aValue)) {
        dict = TP.hc();
        keys = TP.keys(aValue);
        len = keys.getSize();
        for (i = 0; i < len; i++) {
            dict.atPut(aValue[keys.at(i)], i);
        }
    } else if (TP.isNodeList(aValue)) {
        dict = TP.hc();
        len = aValue.length;
        for (i = 0; i < len; i++) {
            dict.atPut(TP.val(aValue[keys.at(i)]), i);
        }
    } else if (TP.isNamedNodeMap(aValue)) {
        dict = TP.hc();
        len = aValue.length;
        for (i = 0; i < len; i++) {
            dict.atPut(TP.val(aValue.item(i)), i);
        }
    } else {
        dict = TP.hc(aValue, '');
    }

    return dict;
});

//  ------------------------------------------------------------------------

TP.dom.TogglingUIElementNode.Inst.defineMethod('getDisplayValue',
function() {

    /**
     * @method getDisplayValue
     * @summary Returns the selected value of the select list. This corresponds
     *     to the value of the currently selected item or items.
     * @exception TP.sig.InvalidValueElements
     * @returns {String|String[]} A String containing the selected value or an
     *     Array of zero or more selected values if the receiver is set up to
     *     allow multiple selections.
     */

    var valueTPElems,
        selectionArray,
        len,
        i,
        item,

        val;

    if (TP.notValid(valueTPElems = this.getValueElements())) {
        return this.raise('TP.sig.InvalidValueElements');
    }

    selectionArray = TP.ac();

    //  Loop over all of the elements and if the element at the index is
    //  selected, add it to the Array of selected elements.
    len = valueTPElems.getSize();
    for (i = 0; i < len; i++) {

        item = valueTPElems.at(i);

        if (item.$getVisualToggle()) {
            //  NB: We check the original markup value here because we want to
            //  see if the author specified a value in the originally authored
            //  markup.
            if (TP.isEmpty(val = item.$getMarkupValue())) {
                val = true;
            }
            selectionArray.push(val);
        } else {
            //  If it's not checked, *and doesn't have a markup value in the
            //  originally authored markup* then we go ahead and add a "false"
            //  at that spot in the Array (to keep things consistent with the
            //  logic above).
            if (TP.isEmpty(val = item.$getMarkupValue())) {
                selectionArray.push(false);
            }
        }
    }

    if (!this.allowsMultiples()) {
        return selectionArray.first();
    }

    return selectionArray;
});

//  ------------------------------------------------------------------------

TP.dom.TogglingUIElementNode.Inst.defineMethod('getValue',
function() {

    /**
     * @method getValue
     * @summary Returns the value of the receiver. For a UI element this method
     *     will ensure any storage formatters are invoked.
     * @returns {String} The value in string form.
     */

    var value,

        type,
        formats,

        tpElems,
        i;

    value = this.getDisplayValue();

    //  Given that this type can represent multiple items, it will return an
    //  Array. We should check to make sure the Array isn't empty before doing
    //  any more work.
    if (TP.notEmpty(value)) {

        //  If the receiver has a 'ui:type' attribute, then try first to convert
        //  the content to that type before trying to format it.
        if (TP.notEmpty(type = this.getAttribute('ui:type'))) {
            if (!TP.isType(type = TP.sys.getTypeByName(type))) {
                return this.raise('TP.sig.InvalidType');
            } else {
                value = type.fromString(value);
            }
        }

        //  If the receiver has a 'ui:storage' attribute, then format the return
        //  value according to the formats found there.

        //  NB: We find the first element in the receiver's 'element Array' that
        //  has a 'ui:storage' attribute and use that value as the formats we
        //  should use.
        tpElems = this.getValueElements();

        for (i = 0; i < tpElems.getSize(); i++) {
            if (TP.notEmpty(formats =
                            tpElems.at(i).getAttribute('ui:storage'))) {
                value = this.$formatValue(value, formats);
                break;
            }
        }
    }

    return value;
});

//  ------------------------------------------------------------------------

TP.dom.TogglingUIElementNode.Inst.defineMethod('getValueElements',
function() {

    /**
     * @method getValueElements
     * @summary Returns an Array TP.dom.UIElementNodes that share a common
     *     'value object' with the receiver. That is, a change to the 'value' of
     *     the receiver will also change the value of one of these other
     *     TP.dom.UIElementNodes. By default, this method will return other
     *     elements that are part of the same 'tibet:group'.
     * @returns {TP.dom.UIElementNode[]} The Array of shared value items.
     */

    var valueTPElems,
        ourCanonicalName;

    valueTPElems = this.getGroupElements();

    if (TP.isEmpty(valueTPElems)) {
        valueTPElems.push(this);
    } else {
        //  We want to filter out all of the elements that *aren't* of the same
        //  kind as the receiver
        ourCanonicalName = this.getCanonicalName();

        valueTPElems =
            valueTPElems.select(
                    function(aTPElem) {
                        return aTPElem.getCanonicalName() === ourCanonicalName;
                    });
    }

    return valueTPElems;
});

//  ------------------------------------------------------------------------

TP.dom.TogglingUIElementNode.Inst.defineMethod('isScalarValued',
function(aspectName) {

    /**
     * @method isScalarValued
     * @summary Returns true if the receiver deals with scalar values.
     * @description See the TP.dom.Node's 'isScalarValued()' instance method
     *     for more information.
     * @param {String} [aspectName] An optional aspect name that is being used
     *     by the caller to determine whether the receiver is scalar valued for.
     * @returns {Boolean} For most UI element types, this returns true.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.dom.TogglingUIElementNode.Inst.defineMethod('produceValue',
function(aspectName, aContentObject, aRequest) {

    /**
     * @method produceValue
     * @summary Produces the value that will be used by the setValue() method
     *     to set the content of the receiver.
     * @description This method is overridden here because (X)HTML checkboxes
     *     and radio buttons are part of a 'group', as determined by their
     *     'name' attribute. If one member of the group has a 'ui:display'
     *     attribute, then setting the value on any of members of the group
     *     should format the value according to that 'ui:display', even if it
     *     wasn't present on the receiving element. Note that this will format
     *     values using the first 'ui:display' setting found in the group and
     *     then exit.
     * @param {String} aspectName The aspect name on the receiver that the value
     *     is being produced for. Many times, this is 'value'.
     * @param {Object} aContentObject An object to use for content.
     * @param {TP.sig.Request} aRequest A request containing control parameters.
     */

    var value,

        tpElems,
        i,

        formats;

    value = this.callNextMethod();

    //  If the receiver has a 'ui:display' attribute, that means that the
    //  super method would have formatted the value, so we just return it.
    if (TP.notEmpty(this.getAttribute('ui:display'))) {
        return value;
    }

    tpElems = this.getValueElements();

    for (i = 0; i < tpElems.getSize(); i++) {
        if (TP.notEmpty(formats = tpElems.at(i).getAttribute('ui:display'))) {
            value = this.$formatValue(value, formats);
            break;
        }
    }

    return value;
});

//  ------------------------------------------------------------------------

TP.dom.TogglingUIElementNode.Inst.defineMethod('$refreshSelectionModelFor',
function(anAspect) {

    /**
     * @method $refreshSelectionModelFor
     * @summary Refreshes the underlying selection model based on state settings
     *     in the UI.
     * @description Note that the aspect can be one of the following:
     *          'value'     ->  The value of the element (the default)
     *          'label'     ->  The label of the element
     *          'id'        ->  The id of the element
     *          'index'     ->  The numerical index of the element
     * @param {String} anAspect The property of the elements to use to
     *      determine which elements should be selected.
     * @exception TP.sig.InvalidValueElements
     * @returns {TP.dom.TogglingUIElementNode} The receiver.
     */

    var valueTPElems,

        selectionModel,
        aspect,

        valueEntry,

        allCount,

        len,
        i,

        item,

        val;

    if (TP.notValid(valueTPElems = this.getValueElements())) {
        return this.raise('TP.sig.InvalidValueElements');
    }

    selectionModel = this.$getSelectionModel();

    //  We default the aspect to 'value'
    aspect = TP.ifInvalid(anAspect, 'value');

    selectionModel.empty();

    valueEntry = TP.ac();
    selectionModel.atPut(aspect, valueEntry);

    allCount = 0;

    len = valueTPElems.getSize();
    for (i = 0; i < len; i++) {

        item = valueTPElems.at(i);

        if (item.$getVisualToggle()) {

            switch (aspect) {
                case 'label':
                    val = item.getLabelText();
                    break;

                case 'id':
                    val = item.getLocalID();
                    break;

                case 'index':
                    val = i;
                    break;

                case 'value':
                default:
                    val = item.$getPrimitiveValue();
                    break;
            }

            valueEntry.push(val);

            allCount++;
        }
    }

    if (allCount === len) {
        selectionModel.atPut(TP.ALL, true);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.TogglingUIElementNode.Inst.defineMethod('render',
function() {

    /**
     * @method render
     * @summary Renders the receiver.
     * @description In the case of this type, this method will properly
     *     configure the receiver's 'value elements' based on the current
     *     selection model.
     * @exception TP.sig.InvalidValueElements
     * @returns {TP.dom.TogglingUIElementNode} The receiver.
     */

    var valueTPElems,

        selectionModel,
        aspectKeys,

        leni,
        i,

        item,

        lenj,
        j,

        aspect,

        val;

    if (TP.notValid(valueTPElems = this.getValueElements())) {
        return this.raise('TP.sig.InvalidValueElements');
    }

    selectionModel = this.$getSelectionModel();
    aspectKeys = selectionModel.getKeys();

    leni = valueTPElems.getSize();

    if (TP.isEmpty(selectionModel)) {
        //  If the selection model is empty, then we deselect everything.
        for (i = 0; i < leni; i++) {
            item = valueTPElems.at(i);
            item.$setVisualToggle(false);
        }
    } else if (selectionModel.hasKey(TP.ALL)) {
        //  If the selection model has the special key of 'TP.ALL', then we
        //  select everything.
        for (i = 0; i < leni; i++) {
            item = valueTPElems.at(i);
            item.$setVisualToggle(true);
        }
    } else {

        //  Iterate over all of the value elements and the various aspects that
        //  might have values in the selection model (i.e. 'value', 'id',
        //  'index', 'label', etc.), select or deselect each value element if
        //  that aspect matches the value in the selection model.
        for (i = 0; i < leni; i++) {

            item = valueTPElems.at(i);

            lenj = aspectKeys.getSize();
            for (j = 0; j < lenj; j++) {

                aspect = aspectKeys.at(j);

                switch (aspect) {
                    case 'label':
                        val = item.getLabelText();
                        break;

                    case 'id':
                        val = item.getLocalID();
                        break;

                    case 'index':
                        val = i;
                        break;

                    case 'value':
                    default:
                        val = item.$getPrimitiveValue();
                        break;
                }

                //  NOTE that we don't clear ones that don't match, we just add
                //  the new items to the selection
                if (selectionModel.at(aspect).contains(val)) {
                    item.$setVisualToggle(true);
                } else {
                    item.$setVisualToggle(false);
                }
            }
        }
    }

    //  Signal to observers that this control has rendered.
    this.signal('TP.sig.DidRender');

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.TogglingUIElementNode.Inst.defineMethod('setDisplayValue',
function(aValue) {

    /**
     * @method setDisplayValue
     * @summary Sets the receivers' value to the value provided (if it matches
     *     the value of an item in the group). Note that any selected items not
     *     provided in aValue are cleared, which is different than the behavior
     *     of selectValue() which simply adds the new selected items to the
     *     existing selection.
     * @param {Object} aValue The value to set (select) in the receiver. For a
     *     select list this might be an array.
     * @exception TP.sig.InvalidValueElements
     * @returns {TP.dom.TogglingUIElementNode} The receiver.
     */

    var valueTPElems,
        separator,
        value,

        dict,
        len,
        i,

        dirty,
        deselectCount,

        item;

    //  empty value means clear any selection(s)
    if (TP.isEmpty(aValue)) {
        return this.deselectAll();
    }

    if (TP.notValid(valueTPElems = this.getValueElements())) {
        return this.raise('TP.sig.InvalidValueElements');
    }

    separator = TP.ifEmpty(this.getAttribute('bind:separator'),
                            TP.sys.cfg('bind.value_separator'));

    value = aValue;

    //  If the value is an Array and has a size of 1, just use that item.
    //  Otherwise, turn the Array into String representations of the objects it
    //  contains.
    if (TP.isArray(value)) {
        if (value.getSize() === 1) {
            value = value.first();
        } else {

            //  Iterate over each item, getting it's String value and possibly
            //  making a new nested Array by splitting on any separator if it
            //  exists.
            value = value.collect(
                            function(aVal) {
                                var val;

                                val = TP.str(aVal);
                                val = val.split(separator).collapse();

                                return val;
                            });

            //  Make sure to flatten the resultant Array.
            value = value.flatten();
        }
    }

    if (TP.isString(value)) {
        value = value.split(separator).collapse();
    }

    //  watch for multiple selection issues
    if (TP.isArray(value) && !this.allowsMultiples()) {
        value = value.at(0);
    }

    //  Generate a selection hash. This should populate the hash with keys that
    //  match 1...n values in the supplied value.
    dict = this.$generateSelectionHashFrom(value);

    dirty = false;
    deselectCount = 0;

    len = valueTPElems.getSize();
    for (i = 0; i < len; i++) {

        item = valueTPElems.at(i);

        if (dict.containsKey(item.$getPrimitiveValue())) {
            if (!item.$getVisualToggle()) {
                dirty = true;
            }
            item.$setVisualToggle(true);
        } else {
            if (item.$getVisualToggle()) {
                dirty = true;
            }
            item.$setVisualToggle(false);
            deselectCount++;
        }
    }

    //  If we 'deselected' all of the items
    if (deselectCount === i) {
        //  Empty the selection model to keep it in sync
        this.$getSelectionModel().empty();
    } else {
        //  Keep the selection model in sync with the selected values.
        this.$getSelectionModel().atPut('value', dict.getKeys());
    }

    if (dirty) {
        this.changed('selection', TP.UPDATE);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.TogglingUIElementNode.Inst.defineMethod('select',
function(aValue, anIndex, shouldSignal) {

    /**
     * @method select
     * @summary Selects the element which has the provided value (if found) or
     *     is at the provided index.
     *     Note that this method is roughly identical to setDisplayValue() with
     *     the exception that, if the receiver allows multiple selection, this
     *     method does not clear existing selections when processing the
     *     value(s) provided.
     * @param {Object} [aValue] The value to select. Note that this can be an
     *     Array.
     * @param {Number} [anIndex] The index of the value in the receiver's data
     *     set.
     * @param {Boolean} [shouldSignal=true] Should selection changes be signaled.
     *     If false changes to the selection are not signaled. Defaults to true.
     * @returns {Boolean} Whether or not a selection was selected.
     */

    var valueTPElems,

        len,
        i,
        item,

        value,

        matches;

    //  If aValue is a RegExp, then we use it to test against all of the value
    //  elements 'primitive value'. If we find one that matches, then we use
    //  that as the value to add to our selection.

    if (TP.isRegExp(aValue)) {
        if (TP.notValid(valueTPElems = this.getValueElements())) {
            return this.raise('TP.sig.InvalidValueElements');
        }

        matches = TP.ac();

        len = valueTPElems.getSize();
        for (i = 0; i < len; i++) {

            item = valueTPElems.at(i);

            value = item.$getPrimitiveValue();

            if (aValue.test(value)) {
                matches.push(value);
            }
        }

        return this.callNextMethod(matches, null, shouldSignal);
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.dom.TogglingUIElementNode.Inst.defineMethod('setValue',
function(aValue, shouldSignal) {

    /**
     * @method setValue
     * @summary Sets the value of the receiver's node. For a UI element this
     *     method will ensure any display formatters are invoked. NOTE that this
     *     method does not update the receiver's bound value if it's a bound
     *     control. In fact, this method is used in response to a change in the
     *     bound value to update the display value, so this method should avoid
     *     changes to the bound value to avoid recursions.
     * @param {Object} aValue The value to set the 'value' of the node to.
     * @param {Boolean} shouldSignal Should changes be notified. If false
     *     changes are not signaled. Defaults to this.shouldSignalChange().
     * @returns {Boolean} Whether or not the value was changed from the value it
     *     had before this method was called.
     */

    var oldValue,
        newValue,

        displayValue,

        flag;

    oldValue = this.getValue();

    newValue = this.produceValue('value', aValue);

    if (this.allowsMultiples()) {

        //  If we didn't get an Array back and this control allows for
        //  multiples, then wrap the newValue in an Array for consistency in
        //  value checking.
        if (!TP.isArray(oldValue)) {
            oldValue = TP.ac(oldValue);
        }

        //  If newValue is not value, then we're just setting the value to an
        //  empty Array.
        if (TP.notValid(newValue)) {
            newValue = TP.ac();
        } else if (!TP.isArray(newValue)) {
            newValue = TP.ac(newValue);
        }
    } else {

        //  Make sure that both old and new values are non-Arrays so that we can
        //  compare them properly. Note that we don't use 'collapse()'
        //  functionality here because we don't necessarily want 'null's if
        //  these are empty (TODO: Really? Why can't we collapse?).
        if (TP.isArray(oldValue)) {
            oldValue = oldValue.first();
        }
        if (TP.isArray(newValue)) {
            newValue = newValue.first();
        }
    }

    //  If the values are equal, there's nothing to do here - bail out.
    if (TP.equal(TP.str(oldValue), TP.str(newValue))) {
        return false;
    }

    this.setDisplayValue(newValue);

    //  signal as needed

    displayValue = this.getDisplayValue();

    //  Sometimes the display value computed from the new value can be equal to
    //  the old value. If that's *not* the case, then propagate and set the
    //  bound value.
    if (!TP.equal(oldValue, displayValue)) {
        //  NB: Use this construct this way for better performance
        if (TP.notValid(flag = shouldSignal)) {
            flag = this.shouldSignalChange();
        }

        if (flag) {
            this.$changed('value', TP.UPDATE,
                            TP.hc(TP.OLDVAL, oldValue, TP.NEWVAL, newValue));
        }

        //  If the element is bound, then update its bound value.
        this.setBoundValueIfBound(this.getValue());
    }

    return true;
});

//  ------------------------------------------------------------------------

TP.dom.TogglingUIElementNode.Inst.defineMethod('toggleValue',
function(aValue) {

    /**
     * @method toggleValue
     * @summary Toggles the value to the inverse of its current value.
     * @param {Object} aValue The value to toggle.
     * @returns {TP.dom.TogglingUIElementNode} The receiver.
     */

    var isSelected;

    isSelected = this.isSelected(aValue, 'value');

    if (isSelected) {
        this.removeSelection(aValue, 'value');
    } else {
        this.addSelection(aValue, 'value');
    }

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETGraphicsTypes.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

//  ========================================================================
//  TP.gui.GraphicData
//  ========================================================================

/**
 * @type {TP.gui.GraphicData}
 * @summary A type that acts as the common supertype.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('gui.GraphicData');

//  can't construct concrete instances of this
TP.gui.GraphicData.isAbstract(true);

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.GraphicData.Inst.defineMethod('copy',
function(deep, aFilterNameOrKeys, contentOnly) {

    /**
     * @method copy
     * @summary Returns a 'copy' of the receiver. Actually, a new instance
     *     whose value is equalTo that of the receiver.
     * @param {Boolean} [deep=false] True to force clones to be deep.
     * @param {String|String[]} aFilterNameOrKeys get*Interface() filter or key
     *     array.
     * @param {Boolean} [contentOnly=true] Copy content only?
     * @returns {TP.gui.GraphicData} A new TP.gui.Point which is a copy of the
     *     receiver.
     */

    var newinst,

        onlyContent,

        filter,
        keys,

        len,
        i,
        ndx,
        val;

    newinst = this.getType().construct(this);

    onlyContent = TP.ifInvalid(contentOnly, true);
    if (onlyContent) {
        //  content only
        return newinst;
    } else {
        filter = TP.ifInvalid(aFilterNameOrKeys, TP.UNIQUE);

        if (TP.isString(filter)) {
            keys = this.getLocalInterface(filter);
        } else if (TP.isArray(filter)) {
            keys = filter;
        } else {
            //  Unusable filter
            return newinst;
        }

        len = keys.getSize();

        for (i = 0; i < len; i++) {
            ndx = keys.at(i);
            val = this.at(ndx);

            if (TP.isTrue(deep) && TP.isReferenceType(val)) {
                //  NB: We do *not* pass along the filter name or keys here
                val = TP.copy(val, deep, null, contentOnly);
            }

            newinst.$set(ndx, val, false, true);
        }
    }

    return newinst;
});

//  ========================================================================
//  TP.gui.Point
//  ========================================================================

/**
 * @type {TP.gui.Point}
 * @summary A type that can manage point (x, y) values.
 */

//  ------------------------------------------------------------------------

TP.gui.GraphicData.defineSubtype('gui.Point');

//  ------------------------------------------------------------------------

//  Note that we use apply here - otherwise, when TP.gui.Point's 'init'
//  method is called, it will incorrectly report 4 arguments even if there
//  is just 1.
TP.definePrimitive('pc',
function(x, y) {

    return TP.gui.Point.construct.apply(TP.gui.Point, arguments);
});

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.gui.Point.Type.defineMethod('constructFromPolar',
function(radius, angle) {

    var x,
        y;

    x = radius * angle.cosD();
    y = radius * angle.sinD();

    return this.construct(x, y);
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineAttribute('data');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('init',
function(x, y) {

    /**
     * @method init
     * @summary Initialize the instance.
     * @param {Number|TP.gui.Point|Object|TP.core.Hash|Number[]} x The x value
     *     of the receiver or a TP.gui.Point to copy or an object that has 'x'
     *     and 'y' (or 'top' and 'left') slots or an Array that has x in the
     *     first position and y in the last position.
     * @param {Number} y The y value of the receiver.
     * @returns {TP.gui.Point} The receiver.
     */

    var theData,
        newData;

    this.callNextMethod();

    if (TP.notEmpty(arguments)) {
        if (arguments.length === 1) {
            //  Got handed one argument. It could be:
            //      a) another TP.gui.Point
            //      b) an Array with 2 values
            //      c) an Object that has 'x' and 'y' slots

            theData = arguments[0];
            if (TP.isKindOf(theData, TP.gui.Point)) {
                theData = theData.$get('data');
                newData = {
                    x: theData.x,
                    y: theData.y
                };
            } else if (TP.isHash(theData)) {
                newData = {
                    x: theData.at('x') || theData.at('left'),
                    y: theData.at('y') || theData.at('top')
                };
            } else if (TP.isArray(theData)) {
                newData = {
                    x: theData.first(),
                    y: theData.last()
                };
            } else {
                newData = {
                    x: theData.x,
                    y: theData.y
                };
            }
        } else {
            //  Got handed two Numbers.
            newData = {
                x: x,
                y: y
            };
        }
    } else {
        //  Got nothing - set everything to 0.
        newData = {
            x: 0,
            y: 0
        };
    }

    this.$set('data', newData, false);

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('add',
function(aPoint) {

    /**
     * @method add
     * @summary Adds the dimensions of the supplied point to the receiver.
     * @param {TP.gui.Point} aPoint The point to add to the receiver.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Point} The receiver.
     */

    var data;

    if (TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');

    data.x += aPoint.get('x');
    data.y += aPoint.get('y');

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('addToX',
function(xDiff) {

    /**
     * @method addToX
     * @summary Adds the value supplied to the x value of the receiver.
     * @param {Number} xDiff The amount to add to the x value of the receiver.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Point} The receiver.
     */

    if (!TP.isNumber(xDiff)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    this.$get('data').x += xDiff;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('addToY',
function(yDiff) {

    /**
     * @method addToY
     * @summary Adds the value supplied to the y value of the receiver.
     * @param {Number} yDiff The amount to add to the y value of the receiver.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Point} The receiver.
     */

    if (!TP.isNumber(yDiff)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    this.$get('data').y += yDiff;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    var data,
        repStr,

        str;

    str = '[' + TP.tname(this) + ' :: ';

    data = this.$get('data');
    repStr = TP.join('(', data.x, ', ', data.y, ')');

    str += repStr + ']';

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver.
     * @returns {String} The receiver in HTML string format.
     */

    var data,
        str;

    data = this.$get('data');

    try {
        str = '<span class="TP_gui_Point">' +
                    '<span data-name="x">' + data.x + '</span>' +
                    '<span data-name="y">' + data.y + '</span>' +
                '</span>';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    var data;

    data = this.$get('data');

    return '{"type":' + TP.tname(this).quoted('"') + ',' +
             '"data":{' +
                 '"x":"' + data.x + '",' +
                 '"y":"' + data.y + '"' +
                 '}}';
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} The receiver's 'pretty print' String representation.
     */

    var data,
        str;

    data = this.$get('data');

    try {
        str = '<dl class="pretty ' + TP.escapeTypeName(TP.tname(this)) + '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' +
                        this.getTypeName() +
                    '</dd>' +
                    '<dt class="pretty key">x</dt>' +
                    '<dd class="pretty value">' +
                        data.x +
                    '</dd>' +
                    '<dt class="pretty key">y</dt>' +
                    '<dd class="pretty value">' +
                        data.y +
                    '</dd>' +
                    '</dl>';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a TIBET source code string.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    var data;

    data = this.$get('data');

    return TP.join('TP.pc(', data.x, ', ', data.y, ')');
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns the String representation of the receiver.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the TP.gui.Point's String representation. This flag is ignored in
     *     this version of this method.
     * @returns {String} The String representation of the receiver.
     */

    var data,
        repStr;

    data = this.$get('data');
    repStr = TP.join('(', data.x, ', ', data.y, ')');

    return repStr;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver.
     * @returns {String} The receiver in XML string format.
     */

    var data,
        str;

    data = this.$get('data');

    try {
        str = '<instance type="' + TP.tname(this) + '"' +
                ' x="' + data.x + '" y="' + data.y + '"' +
                '/>';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('clampToPoint',
function(aPoint) {

    /**
     * @method clampToPoint
     * @summary Clamps the receiver's X and Y values to values less than or
     *     equal to the supplied point.
     * @param {TP.gui.Point} aPoint The point to clamp to.
     * @returns {TP.gui.Point} The receiver.
     */

    var otherData,
        data;

    data = this.$get('data');
    otherData = aPoint.$get('data');

    data.x = data.x.min(otherData.x);
    data.y = data.y.min(otherData.y);

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('clampToRect',
function(aRect) {

    /**
     * @method clampToRect
     * @summary Clamps the receiver's X and Y values to values within the
     *     supplied rectangle.
     * @param {TP.gui.Rect} aRect The rect to clamp to.
     * @returns {TP.gui.Point} The receiver.
     */

    var rectData,
        data;

    data = this.$get('data');
    rectData = aRect.$get('data');

    data.x = data.x.max(rectData.x).min(rectData.x + rectData.width);
    data.y = data.y.max(rectData.y).min(rectData.y + rectData.height);

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('clampXToMinMax',
function(aMin, aMax) {

    /**
     * @method clampXToMinMax
     * @summary Clamps the receiver's X value to the minimum and maximum values
     *     provided.
     * @param {Number} aMin The minimum amount to clamp the X value of the
     *     receiver to.
     * @param {Number} aMax The maximum amount to clamp the X value of the
     *     receiver to.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Point} The receiver.
     */

    var data;

    if (!TP.isNumber(aMin) || !TP.isNumber(aMax)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    data = this.$get('data');

    data.x = data.x.max(aMin).min(aMax);

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('clampYToMinMax',
function(aMin, aMax) {

    /**
     * @method clampYToMinMax
     * @summary Clamps the receiver's Y value to the minimum and maximum values
     *     provided.
     * @param {Number} aMin The minimum amount to clamp the Y value of the
     *     receiver to.
     * @param {Number} aMax The maximum amount to clamp the Y value of the
     *     receiver to.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Point} The receiver.
     */

    var data;

    if (!TP.isNumber(aMin) || !TP.isNumber(aMax)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    data = this.$get('data');

    data.y = data.y.max(aMin).min(aMax);

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('computeMidpoint',
function(aPoint) {

    /**
     * @method computeMidpoint
     * @summary Computes the midpoint between the receiver and the supplied
     *     point
     * @param {TP.gui.Point} aPoint The other point to use to compute the
     *     midpoint.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Point} A new TP.gui.Point which is the midpoint
     *     between the receiver and the supplied point.
     */

    var data;

    if (TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');

    return this.getType().construct(
                    (data.x + aPoint.get('x')) / 2,
                    (data.y + aPoint.get('y')) / 2);
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('distanceBetween',
function(aPoint) {

    /**
     * @method distanceBetween
     * @summary Returns the distance between the receiver and the supplied
     *     point.
     * @param {TP.gui.Point} aPoint The other point to compute the distance
     *     from.
     * @exception TP.sig.InvalidParameter
     * @returns {Number} The distance between the receiver and the supplied
     *     point.
     */

    var data,
        otherData,

        distance;

    if (TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');
    otherData = aPoint.$get('data');

    distance = ((otherData.x - data.x).pow(2) +
                (otherData.y - data.y).pow(2)).sqrt();

    return distance;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('getX',
function() {

    /**
     * @method getX
     * @summary Returns the X coordinate of the receiver as a Number.
     * @returns {Number} The X coordinate of the receiver.
     */

    return this.$get('data').x;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('getY',
function() {

    /**
     * @method getY
     * @summary Returns the Y coordinate of the receiver as a Number.
     * @returns {Number} The Y coordinate of the receiver.
     */

    return this.$get('data').y;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('interpolate',
function(aPoint, t) {

    /**
     * @method interpolate
     * @summary Computes an interpolated point between the receiver and the
     *     supplied point.
     * @description The interpolation factor determines how much a 'weight'
     *     towards the supplied point will be used. It should be a Number
     *     between 0 and 1. To weight the computed point towards the receiver,
     *     use a value approaching 0. To weight it towards the supplied point,
     *     use a value approaching 1.
     * @param {TP.gui.Point} aRect The point to compute an interpolation with
     *     the receiver.
     * @param {Number} t Interpolation factor. Should be a Number between 0 and
     *     1.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Point} A new point with the coordinates of the receiver
     *     interpolated with the supplied point using the supplied interpolation
     *     factor.
     */

    var data,
        otherData,

        interpFunc;

    if (!TP.isNumber(t)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    data = this.$get('data');
    otherData = aPoint.$get('data');

    interpFunc =
        function(a, b, factor) {

            return a + (b - a) * factor;
        };

    return this.getType().construct(
                    interpFunc(data.x, otherData.x, t),
                    interpFunc(data.y, otherData.y, t));
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('invert',
function() {

    /**
     * @method invert
     * @summary Inverts the values in the receiver by multiplying them by -1.
     * @returns {TP.gui.Point} The receiver.
     */

    var data;

    data = this.$get('data');

    data.x *= -1;
    data.y *= -1;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('setX',
function(xVal) {

    /**
     * @method setX
     * @summary Sets the X coordinate of the receiver to the supplied value.
     * @param {Number} xVal The amount to set the 'x' coordinate of the receiver
     *     to.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Point} The receiver.
     */

    if (!TP.isNumber(xVal)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    this.$get('data').x = xVal;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('setY',
function(yVal) {

    /**
     * @method setY
     * @summary Sets the Y coordinate of the receiver to the supplied value.
     * @param {Number} yVal The amount to set the 'y' coordinate of the receiver
     *     to.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Point} The receiver.
     */

    if (!TP.isNumber(yVal)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    this.$get('data').y = yVal;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('setXY',
function(xVal, yVal) {

    /**
     * @method setXY
     * @summary Sets the X and Y coordinates of the receiver to the supplied
     *     values.
     * @param {Number} xVal The amount to set the 'x' coordinate of the receiver
     *     to.
     * @param {Number} yVal The amount to set the 'y' coordinate of the receiver
     *     to.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Point} The receiver.
     */

    var data;

    if (!TP.isNumber(xVal) || !TP.isNumber(yVal)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    data = this.$get('data');

    data.x = xVal;
    data.y = yVal;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('snapToIncrement',
function(xIncrement, yIncrement) {

    /**
     * @method snapToIncrement
     * @summary
     * @param {Number} xIncrement The amount to snap the x value of the receiver
     *     to.
     * @param {Number} yDiff The amount to snap the y value of the receiver to.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Point} The receiver.
     */

    var data;

    if (!TP.isNumber(xIncrement) || !TP.isNumber(yIncrement)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    data = this.$get('data');

    data.x = ((data.x + xIncrement) / xIncrement).floor() * xIncrement;
    data.y = ((data.y + yIncrement) / yIncrement).floor() * yIncrement;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('sortByDistance',
function(points) {

    /**
     * @method sortByDistance
     * @summary Sorts the supplied Array by comparing the distance of each
     *     point in the Array to the receiver. This returns the same Array with
     *     the points sorted in ascending order (i.e closest one first).
     * @param {TP.gui.Point[]} points The Array of TP.gui.Points to sort.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Point[]} The supplied Array with the points sorted by
     *     computing the distance between the receiver and each point.
     */

    var thisX,
        thisY;

    if (TP.notValid(points)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    thisX = this.get('x');
    thisY = this.get('y');

    points.sort(
        function(point1, point2) {

            var dist1,
                dist2;

            dist1 = ((point1.get('x') - thisX).pow(2) +
                    (point1.get('y') - thisY).pow(2)).sqrt();
            dist1 = ((point2.get('x') - thisX).pow(2) +
                    (point2.get('y') - thisY).pow(2)).sqrt();

            return dist1 - dist2;
        });

    return points;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('subtract',
function(aPoint) {

    /**
     * @method subtract
     * @summary Subtracts the dimensions of the supplied point from the
     *     receiver.
     * @param {TP.gui.Point} aPoint The point to subtract from the receiver.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Point} The receiver.
     */

    var data;

    if (TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');

    data.x -= aPoint.get('x');
    data.y -= aPoint.get('y');

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('subtractFromX',
function(xDiff) {

    /**
     * @method subtractFromX
     * @summary Subtracts the value supplied from the x value of the receiver.
     * @param {Number} xDiff The amount to subtract from the x value of the
     *     receiver.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Point} The receiver.
     */

    if (!TP.isNumber(xDiff)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    this.$get('data').x -= xDiff;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('subtractFromY',
function(yDiff) {

    /**
     * @method subtractFromY
     * @summary Subtracts the value supplied from the y value of the receiver.
     * @param {Number} yDiff The amount to subtract from the y value of the
     *     receiver.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Point} The receiver.
     */

    if (!TP.isNumber(yDiff)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    this.$get('data').y -= yDiff;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('translate',
function(xDiff, yDiff) {

    /**
     * @method translate
     * @summary Translates the position of the receiver by the values supplied.
     * @param {Number} xDiff The amount to add to the x value of the receiver.
     * @param {Number} yDiff The amount to add to the y value of the receiver.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Point} The receiver.
     */

    var data;

    if (!TP.isNumber(xDiff) || !TP.isNumber(yDiff)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    data = this.$get('data');

    data.x += xDiff;
    data.y += yDiff;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Point.Inst.defineMethod('translateByPoint',
function(aPoint) {

    /**
     * @method translateByPoint
     * @summary Translates the position of the receiver by the values of the
     *     supplied point.
     * @param {TP.gui.Point} aPoint The point to use to translate the receiver.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Point} The receiver.
     */

    var data;

    if (TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');

    data.x += aPoint.get('x');
    data.y += aPoint.get('y');

    return this;
});

//  ========================================================================
//  TP.gui.Rect
//  ========================================================================

/**
 * @type {TP.gui.Rect}
 * @summary A type that can manage rectangle (x, y, width, height) values.
 */

//  ------------------------------------------------------------------------

TP.gui.GraphicData.defineSubtype('gui.Rect');

//  ------------------------------------------------------------------------

//  Note that we use apply here - otherwise, when TP.gui.Rect's 'init'
//  method is called, it will incorrectly report 4 arguments even if there
//  is just 1.
TP.definePrimitive('rtc',
function(x, y, width, height) {

    return TP.gui.Rect.construct.apply(TP.gui.Rect, arguments);
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineAttribute('data');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('init',
function(x, y, width, height) {

    /**
     * @method init
     * @summary Initialize the instance.
     * @param {Number|TP.gui.Rect|Object|TP.core.Hash|Number[]} x The x value of
     *     the receiver or a TP.gui.Rect to copy or an object that has 'x', 'y'
     *     (or 'top', 'left'), 'width' and 'height' slots or an Array that has x
     *     in the first position, y in the second position, width in the third
     *     position and height in the fourth position.
     * @param {Number} y The y value of the receiver.
     * @param {Number} width The width value of the receiver.
     * @param {Number} height The height value of the receiver.
     * @returns {TP.gui.Rect} The receiver.
     */

    var theData,
        newData;

    this.callNextMethod();

    if (TP.notEmpty(arguments)) {
        if (arguments.length === 1) {
            //  Got handed one argument. It could be:
            //      a) another TP.gui.Rect
            //      b) an Array with 4 values
            //      c) an Object that has 'x', 'y', 'width', and 'height'
            //      slots.

            theData = arguments[0];
            if (TP.isKindOf(theData, TP.gui.Rect)) {
                theData = theData.$get('data');
                newData = {
                    x: theData.x,
                    y: theData.y,
                    width: theData.width,
                    height: theData.height
                };
            } else if (TP.isHash(theData)) {
                newData = {
                    x: theData.at('x') || theData.at('left'),
                    y: theData.at('y') || theData.at('top'),
                    width: theData.at('width'),
                    height: theData.at('height')
                };
            } else if (TP.isArray(theData)) {
                newData = {
                    x: theData.at(0),
                    y: theData.at(1),
                    width: theData.at(2),
                    height: theData.at(3)
                };
            } else {
                newData = {
                    x: theData.x,
                    y: theData.y,
                    width: theData.width,
                    height: theData.height
                };
            }
        } else if (arguments.length === 2) {
            //  Got handed two TP.gui.Rects.
            newData = {
                x: arguments[0].$get('data').x,
                y: arguments[0].$get('data').y,
                width: arguments[1].$get('data').x,
                height: arguments[1].$get('data').y
            };
        } else {
            //  Got handed four Numbers.
            newData = {
                x: x,
                y: y,
                width: width,
                height: height
            };
        }
    } else {
        //  Got nothing - set everything to 0.
        newData = {
            x: 0,
            y: 0,
            width: 0,
            height: 0
        };
    }

    this.$set('data', newData, false);

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('addByPoint',
function(aPoint) {

    /**
     * @method addByPoint
     * @summary Adds the dimensions of the supplied point to the receiver.
     * @param {TP.gui.Point} aPoint The point to add to the receiver.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Rect} The receiver.
     */

    var data;

    if (TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');

    data.x += aPoint.get('x');
    data.y += aPoint.get('y');

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('addToX',
function(xDiff) {

    /**
     * @method addToX
     * @summary Adds the value supplied to the x value of the receiver.
     * @param {Number} xDiff The amount to add to the x value of the receiver.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Rect} The receiver.
     */

    if (!TP.isNumber(xDiff)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    this.$get('data').x += xDiff;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('addToY',
function(yDiff) {

    /**
     * @method addToY
     * @summary Adds the value supplied to the y value of the receiver.
     * @param {Number} yDiff The amount to add to the y value of the receiver.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Rect} The receiver.
     */

    if (!TP.isNumber(yDiff)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    this.$get('data').y += yDiff;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    var data,
        repStr,

        str;

    str = '[' + TP.tname(this) + ' :: ';

    data = this.$get('data');
    repStr = TP.join('(', data.x, ', ', data.y, ', ',
                        data.width, ', ', data.height, ')');

    str += repStr + ']';

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver.
     * @returns {String} The receiver in HTML string format.
     */

    var data,
        str;

    data = this.$get('data');

    try {
        str = '<span class="TP_gui_Rect">' +
                    '<span data-name="x">' + data.x + '</span>' +
                    '<span data-name="y">' + data.y + '</span>' +
                    '<span data-name="width">' + data.width + '</span>' +
                    '<span data-name="height">' + data.height + '</span>' +
                '</span>';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    var data;

    data = this.$get('data');

    return '{"type":' + TP.tname(this).quoted('"') + ',' +
             '"data":{' +
                 '"x":"' + data.x + '",' +
                 '"y":"' + data.y + '",' +
                 '"width":"' + data.width + '",' +
                 '"height":"' + data.height + '"' +
                 '}}';
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} The receiver's 'pretty print' String representation.
     */

    var data,
        str;

    data = this.$get('data');

    try {
        str = '<dl class="pretty ' + TP.escapeTypeName(TP.tname(this)) + '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' +
                        this.getTypeName() +
                    '</dd>' +
                    '<dt class="pretty key">x</dt>' +
                    '<dd class="pretty value">' +
                        data.x +
                    '</dd>' +
                    '<dt class="pretty key">y</dt>' +
                    '<dd class="pretty value">' +
                        data.y +
                    '</dd>' +
                    '<dt class="pretty key">width</dt>' +
                    '<dd class="pretty value">' +
                        data.width +
                    '</dd>' +
                    '<dt class="pretty key">height</dt>' +
                    '<dd class="pretty value">' +
                        data.height +
                    '</dd>' +
                    '</dl>';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a TIBET source code string.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    var data;

    data = this.$get('data');

    return TP.join('TP.rtc(', data.x, ', ', data.y, ', ',
                            data.width, ', ', data.height, ')');
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns the String representation of the receiver.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the TP.gui.Rect's String representation. This flag is ignored in
     *     this version of this method.
     * @returns {String} The String representation of the receiver.
     */

    var data,
        repStr;

    data = this.$get('data');

    repStr = TP.join('(', data.x, ', ', data.y, ', ',
                        data.width, ', ', data.height, ')');

    return repStr;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver.
     * @returns {String} The receiver in XML string format.
     */

    var data,
        str;

    data = this.$get('data');

    try {
        str = '<instance type="' + TP.tname(this) + '"' +
                ' x="' + data.x + '" y="' + data.y + '"' +
                ' width="' + data.width + '" height="' + data.height + '"' +
                 '/>';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('clampToRect',
function(aRect) {

    /**
     * @method clampToRect
     * @summary Clamps the receiver's X and Y values to values within the
     *     supplied rectangle, taking into account the receiver's width and
     *     height.
     * @param {TP.gui.Rect} aRect The rect to clamp to.
     * @returns {TP.gui.Rect} The receiver.
     */

    var rectData,
        data;

    data = this.$get('data');
    rectData = aRect.$get('data');

    data.x = data.x.max(rectData.x).min(rectData.width - data.width);
    data.y = data.y.max(rectData.y).min(rectData.height - data.height);

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('constrainPoint',
function(aPoint) {

    /**
     * @method constrainPoint
     * @summary Constrains the supplied point to be within the bounds of the
     *     receiver.
     * @param {TP.gui.Point} aPoint The point to constrain.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Rect} The receiver.
     */

    var data,
        pointData;

    if (TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');
    pointData = aPoint.$get('data');

    pointData.x = pointData.x.max(data.x).min(data.x + data.width);
    pointData.y = pointData.y.max(data.y).min(data.y + data.height);

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('constrainRect',
function(aRect) {

    /**
     * @method constrainRect
     * @summary Constrains the supplied rect to be within the bounds of the
     *     receiver.
     * @param {TP.gui.Rect} aRect The rect to constrain.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Rect} The receiver.
     */

    var data,

        rectData,

        diffX,
        diffY;

    if (TP.notValid(aRect)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');
    rectData = aRect.$get('data');

    //  Make sure that our own rectangle isn't smaller in either width or height
    //  than the supplied rectangle. Otherwise, just return without modifying
    //  the supplied rectangle.
    if (this.getWidth() < aRect.getWidth() ||
        this.getHeight() < aRect.getHeight()) {
        return this;
    }

    /* eslint-disable no-extra-parens */
    diffX = ((rectData.x + rectData.width) - (data.x + data.width)).max(0);
    diffY = ((rectData.y + rectData.height) - (data.y + data.height)).max(0);
    /* eslint-enable no-extra-parens */

    rectData.x -= diffX;
    rectData.y -= diffY;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('containsPoint',
function(aPoint) {

    /**
     * @method containsPoint
     * @summary Returns whether or not the receiver contains the supplied
     *     point.
     * @param {TP.gui.Point} aPoint The point to test.
     * @exception TP.sig.InvalidParameter
     * @returns {Boolean} Whether or not the receiver contains the point.
     */

    var data,
        pointData;

    if (TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');
    pointData = aPoint.$get('data');

    /* eslint-disable no-extra-parens */
    if (pointData.x >= data.x &&
        pointData.y >= data.y &&
        pointData.x <= (data.x + data.width) &&
        pointData.y <= (data.y + data.height)) {
        return true;
    }
    /* eslint-enable no-extra-parens */

    return false;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('containsPointX',
function(aPoint) {

    /**
     * @method containsPointX
     * @summary Returns whether or not the receiver contains the supplied
     *     point's X value.
     * @param {TP.gui.Point} aPoint The point to test.
     * @exception TP.sig.InvalidParameter
     * @returns {Boolean} Whether or not the receiver contains the point's X
     *     value.
     */

    var data,
        pointData;

    if (TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');
    pointData = aPoint.$get('data');

    /* eslint-disable no-extra-parens */
    if (pointData.x >= data.x &&
        pointData.x <= (data.x + data.width)) {
        return true;
    }
    /* eslint-enable no-extra-parens */

    return false;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('containsPointY',
function(aPoint) {

    /**
     * @method containsPointY
     * @summary Returns whether or not the receiver contains the supplied
     *     point's Y value.
     * @param {TP.gui.Point} aPoint The point to test.
     * @exception TP.sig.InvalidParameter
     * @returns {Boolean} Whether or not the receiver contains the point's Y
     *     value.
     */

    var data,
        pointData;

    if (TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');
    pointData = aPoint.$get('data');

    /* eslint-disable no-extra-parens */
    if (pointData.y >= data.y &&
        pointData.y <= (data.y + data.height)) {
        return true;
    }
    /* eslint-enable no-extra-parens */

    return false;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('containsRect',
function(aRect) {

    /**
     * @method containsRect
     * @summary Returns whether or not the receiver contains the supplied
     *     rectangle.
     * @param {TP.gui.Rect} aRect The rectangle to test.
     * @exception TP.sig.InvalidParameter
     * @returns {Boolean} Whether or not the receiver contains the rectangle.
     */

    var data,
        otherData;

    if (TP.notValid(aRect)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');
    otherData = aRect.$get('data');

    /* eslint-disable no-extra-parens */
    if (otherData.x >= data.x &&
        (data.x + data.width >= otherData.x + otherData.width) &&
        otherData.y >= data.y &&
        (data.y + data.height >= otherData.y + otherData.height)) {
        return true;
    }
    /* eslint-enable no-extra-parens */

    return false;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('difference',
function(aRect) {

    /**
     * @method difference
     * @summary Returns an Array of rectangles that contain the remaining
     *     regions of the receiver after the supplied rectangle has been
     *     subtracted.
     * @description This routine is adapted from Google's Closure library.
     * @param {TP.gui.Rect} aRect The rectangle to test.
     * @returns {TP.gui.Rect[]} An Array of TP.gui.Rects containing the
     *     remaining regions.
     */

    var intersectingRect,
        result,
        data,
        otherData,

        thisY,
        thisHeight,

        thisRight,
        thisBottom,

        otherRight,
        otherBottom;

    intersectingRect = this.intersection(aRect);

    if (TP.notValid(intersectingRect) ||
        intersectingRect.$get('data').width <= 0 ||
        intersectingRect.$get('data').height <= 0) {

        return TP.ac(this.copy());
    }

    data = this.$get('data');
    otherData = aRect.$get('data');

    result = TP.ac();

    thisY = data.y;
    thisHeight = data.height;

    thisRight = data.x + data.width;
    thisBottom = data.y + data.height;

    otherRight = otherData.x + otherData.width;
    otherBottom = otherData.y + otherData.height;

    //  Subtract off any area on top where the receiver extends past the
    //  supplied rectangle.
    if (otherData.y > data.y) {
        result.push(
            this.getType().construct(data.x, data.y,
                                        data.width, otherData.y - data.y));

        thisY = otherData.y;

        //  If we're moving the top down, we also need to subtract the
        //  height diff.
        thisHeight -= otherData.y - data.y;
    }

    //  Subtract off any area on bottom where the receiver extends past the
    //  supplied rectangle.
    if (otherBottom < thisBottom) {
        result.push(
            this.getType().construct(data.x, otherBottom,
                                        data.width, thisBottom - otherBottom));

        thisHeight = otherBottom - thisY;
    }

    //  Subtract any area on left where the receiver extends past the
    //  supplied rectangle.
    if (otherData.x > data.x) {
        result.push(
            this.getType().construct(data.x, thisY,
                                        otherData.x - data.x, thisHeight));
    }

    //  Subtract any area on right where the receiver extends past the
    //  supplied rectangle.
    if (otherRight < thisRight) {
        result.push(
            this.getType().construct(otherRight, thisY,
                                        thisRight - otherRight, thisHeight));
    }

    return result;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('empty',
function() {

    /**
     * @method empty
     * @summary Sets the receiver to be the 'empty' rectangle (i.e. all
     *     coordinates are set to 0).
     * @returns {TP.gui.Rect} The receiver.
     */

    var data;

    data = this.$get('data');

    data.x = 0;
    data.y = 0;
    data.width = 0;
    data.height = 0;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('getCenterPoint',
function() {

    /**
     * @method getCenterPoint
     * @summary Returns the center point of the receiver.
     * @returns {TP.gui.Point} The center point of the receiver.
     */

    var data;

    data = this.$get('data');

    /* eslint-disable no-extra-parens */
    return TP.gui.Point.construct(data.x + (data.width / 2),
                                    data.y + (data.height / 2));
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('getClosestEdgePointFromPoint',
function(aPoint) {

    /**
     * @method getClosestEdgePointFromPoint
     * @summary Returns the 'closest edge point to the supplied point' of the
     *     receiver.
     * @param {TP.gui.Point} aPoint The point to use to calculate the closest
     *     edge point from.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Point} The closest edge point of the receiver.
     */

    var data,

        compassCorner,
        centerPoint;

    if (TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');

    compassCorner = this.getCompassCorner(aPoint, 8);
    centerPoint = this.getCenterPoint();

    switch (compassCorner) {
        case TP.NORTH:
            return TP.pc(centerPoint.get('x'), 0);

        case TP.NORTHEAST:
            return TP.pc(data.x + data.width, 0);

        case TP.EAST:
            return TP.pc(data.x + data.width, centerPoint.get('y'));

        case TP.SOUTHEAST:
            return TP.pc(data.x + data.width, data.y + data.height);

        case TP.SOUTH:
            return TP.pc(centerPoint.get('x'), data.y + data.height);

        case TP.SOUTHWEST:
            return TP.pc(0, data.y + data.height);

        case TP.WEST:
            return TP.pc(0, centerPoint.get('y'));

        case TP.NORTHWEST:
        default:
            return TP.pc(0, 0);
    }
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('getCompassCorner',
function(aPoint) {

    /**
     * @method getCompassCorner
     * @summary Returns the 'compass corner' of the receiver.
     * @description This method returns the 'compass corner' that the supplied
     *     point occupies within the receiver. Note that this routine clamps its
     *     value to the 'common 8' compass values matching these constants:
     *
     *     TP.NORTH
     *     TP.NORTHEAST
     *     TP.EAST
     *     TP.SOUTHEAST
     *     TP.SOUTH
     *     TP.SOUTHWEST
     *     TP.WEST
     *     TP.NORTHWEST
     *
     * @param {TP.gui.Point} aPoint The point to use to calculate the compass
     *     point from.
     * @exception TP.sig.InvalidParameter
     * @returns {Number} A Number matching the constant corresponding to the
     *     compass corner.
     */

    var angle,
        corner;

    if (TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    angle = TP.computeAngleFromEnds(this.getCenterPoint(), aPoint);

    corner = TP.computeCompassCorner(angle, 8);

    return corner;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('getEdgePoint',
function(compassCorner) {

    /**
     * @method getEdgePoint
     * @summary Gets the 'edge point' of the receiver matching the supplied
     *     compass corner. For instance, TP.NORTHWEST will return the top-left
     *     corner point and TP.SOUTHEAST will return the bottom-right corner
     *     point.
     * @param {Number} compassCorner A Number matching the compass corner
     *     constant to return the edge point of. This should be one of these
     *     constants:
     *
     *     TP.NORTH
     *     TP.NORTHEAST
     *     TP.EAST
     *     TP.SOUTHEAST
     *     TP.SOUTH
     *     TP.SOUTHWEST
     *     TP.WEST
     *     TP.NORTHWEST
     *
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Point} The closest edge point of the receiver.
     */

    var data;

    if (TP.notValid(compassCorner)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');

    /* eslint-disable no-extra-parens */
    switch (compassCorner) {
        case TP.NORTHWEST:
            return TP.pc(data.x, data.y);

        case TP.NORTH:
            return TP.pc(data.x + (data.width / 2), data.y);

        case TP.NORTHEAST:
            return TP.pc(data.x + data.width, data.y);

        case TP.EAST:
            return TP.pc(data.x + data.width, data.y + (data.height / 2));

        case TP.SOUTHEAST:
            return TP.pc(data.x + data.width, data.y + data.height);

        case TP.SOUTH:
            return TP.pc(data.x + (data.width / 2), data.y + data.height);

        case TP.SOUTHWEST:
            return TP.pc(data.x, data.y + data.height);

        case TP.WEST:
            return TP.pc(data.x, data.y + (data.height / 2));

        default:
            return TP.pc(0, 0);
    }
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('getHeight',
function() {

    /**
     * @method getHeight
     * @summary Returns the height of the receiver as a Number.
     * @returns {Number} The height of the receiver.
     */

    return this.$get('data').height;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('getWidth',
function() {

    /**
     * @method getWidth
     * @summary Returns the width of the receiver as a Number.
     * @returns {Number} The width of the receiver.
     */

    return this.$get('data').width;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('getX',
function() {

    /**
     * @method getX
     * @summary Returns the X coordinate of the receiver as a Number.
     * @returns {Number} The X coordinate of the receiver.
     */

    return this.$get('data').x;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('getXYPoint',
function() {

    /**
     * @method getXYPoint
     * @summary Returns the X,Y (i.e. left, top)  point of the receiver.
     * @returns {TP.gui.Point} The X,Y point of the receiver.
     */

    var data;

    data = this.$get('data');

    /* eslint-disable no-extra-parens */
    return TP.gui.Point.construct(data.x, data.y);
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('getY',
function() {

    /**
     * @method getY
     * @summary Returns the Y coordinate of the receiver as a Number.
     * @returns {Number} The Y coordinate of the receiver.
     */

    return this.$get('data').y;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('grow',
function(widthDiff, heightDiff) {

    /**
     * @method grow
     * @summary Grows the width and height of the receiver by the values
     *     supplied.
     * @param {Number} widthDiff The amount to add to the width value of the
     *     receiver.
     * @param {Number} heightDiff The amount to add to the height value of the
     *     receiver.
     * @returns {TP.gui.Rect} The receiver.
     */

    var data;

    if (!TP.isNumber(widthDiff) || !TP.isNumber(heightDiff)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    data = this.$get('data');

    data.width += widthDiff;
    data.height += heightDiff;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('growByPoint',
function(aPoint) {

    /**
     * @method growByPoint
     * @summary Grows the width and height of the receiver by the values of the
     *     supplied point.
     * @param {TP.gui.Point} aPoint The point to use to grow the receiver.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Rect} The receiver.
     */

    var data;

    if (TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');

    data.width += aPoint.get('x');
    data.height += aPoint.get('y');

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('interpolate',
function(aRect, t) {

    /**
     * @method interpolate
     * @summary Computes an interpolated rectangle between the receiver and the
     *     supplied rectangle.
     * @description The interpolation factor determines how much a 'weight'
     *     towards the supplied rectangle will be used. It should be a Number
     *     between 0 and 1. To weight the computed rectangle towards the
     *     receiver, use a value approaching 0. To weight it towards the
     *     supplied rectangle, use a value approaching 1.
     * @param {TP.gui.Rect} aRect The rectangle to compute an interpolation
     *     with the receiver.
     * @param {Number} t Interpolation factor. Should be a Number between 0 and
     *     1.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Rect} A new rectangle with the coordinates of the
     *     receiver interpolated with the supplied rectangle using the supplied
     *     interpolation factor.
     */

    var data,
        otherData,

        interpFunc;

    if (!TP.isNumber(t)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    data = this.$get('data');
    otherData = aRect.$get('data');

    interpFunc =
        function(a, b, factor) {

            return a + (b - a) * factor;
        };

    return this.getType().construct(
                    interpFunc(data.x, otherData.x, t),
                    interpFunc(data.y, otherData.y, t),
                    interpFunc(data.width, otherData.width, t),
                    interpFunc(data.height, otherData.height, t));
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('intersection',
function(aRect) {

    /**
     * @method intersection
     * @summary Returns a new rectangle that contains the area common to both
     *     the receiver and the supplied rectangle.
     * @param {TP.gui.Rect} aRect The rectangle to compute an intersection with
     *     the receiver.
     * @returns {TP.gui.Rect} A new rectangle that contains the area common to
     *     the receiver and the supplied rectangle.
     */

    var data,
        otherData,

        minX,
        minY,

        maxX,
        maxY;

    if (this.isEmpty()) {
        return this.getType().construct(aRect);
    }

    if (aRect.isEmpty()) {
        return this.getType().construct(this);
    }

    data = this.$get('data');
    otherData = aRect.$get('data');

    minX = data.x.max(otherData.x);
    maxX = (data.x + data.width).min(otherData.x + otherData.width);

    if (minX <= maxX) {
        minY = data.y.max(otherData.y);
        maxY = (data.y + data.height).min(otherData.y + otherData.height);

        if (minY <= maxY) {
            return this.getType().construct(minX,
                                            minY,
                                            maxX - minX,
                                            maxY - minY);
        }
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('intersects',
function(aRect) {

    /**
     * @method intersects
     * @summary Returns whether the supplied rectangle intersects the receiver.
     * @param {TP.gui.Rect} aRect The rectangle to test to see if it intersects
     *     with the receiver.
     * @returns {Boolean} Whether or not the supplied rectangle intersects the
     *     rectangle.
     */

    var data,
        otherData;

    data = this.$get('data');
    otherData = aRect.$get('data');

    if (data.x <= otherData.x + otherData.width &&
        otherData.x <= data.x + data.width &&
        data.y <= otherData.y + otherData.height &&
        otherData.y <= data.y + data.height) {
        return true;
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('isEmpty',
function() {

    /**
     * @method isEmpty
     * @summary Returns whether the receiver is an 'empty' rectangle - that is,
     *     whether its width or height is less than or equal to 0.
     * @returns {Boolean}
     */

    return this.$get('data').width <= 0 || this.$get('data').height <= 0;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('isOffsetFromCenterBy',
function(aPoint, offset) {

    /**
     * @method isOffsetFromCenterBy
     * @summary Returns whether or not the supplied point is offset from the
     *     receiver's center point by at least the amount supplied in the offset
     *     parameter.
     * @param {TP.gui.Point} aPoint The point to test.
     * @param {Number|String} offset The minimum amount that the supplied point
     *     should be offset from the receiver's center point.
     * @exception TP.sig.InvalidParameter
     * @returns {Boolean} Whether or not the receiver's center point is offset
     *     from the supplied point by the supplied minimum amount.
     */

    var centerPoint,
        distanceFromCenter,

        cornerPoint,
        distanceFromCorner,

        result,
        val;

    if (TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    centerPoint = this.getCenterPoint();
    distanceFromCenter = aPoint.distanceBetween(centerPoint);

    cornerPoint = this.getClosestEdgePointFromPoint(aPoint);
    distanceFromCorner = cornerPoint.distanceBetween(centerPoint);

    result = false;
    if (TP.isValid(offset) && !TP.isNaN(val = offset.asNumber())) {
        if (TP.regex.PERCENTAGE.test(offset)) {
            val = val * distanceFromCorner;
        }

        /* eslint-disable no-extra-parens */
        result = (distanceFromCenter >= val);
        /* eslint-enable no-extra-parens */
    }

    return result;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('maxFittedPoint',
function(aRect) {

    /**
     * @method maxFittedPoint
     * @summary Computes the maximum X/Y coordinates that the receiver can have
     *     while still remaining completely enclosed within the supplied
     *     rectangle.
     * @param {TP.gui.Rect} aRect The rectangle to use to compute the maximum
     *     fitted point for the receiver.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Point} The maximum 'fitted point'.
     */

    var data,
        otherData,

        maxFittedX,
        maxFittedY;

    if (TP.notValid(aRect)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');
    otherData = aRect.$get('data');

    maxFittedX = otherData.width - data.width;
    maxFittedY = otherData.height - data.height;

    return TP.pc(maxFittedX, maxFittedY);
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('union',
function(aRect) {

    /**
     * @method union
     * @summary Returns a new rectangle that contains both the receiver and the
     *     supplied rectangle.
     * @param {TP.gui.Rect} aRect The rectangle to compute a union with the
     *     receiver.
     * @returns {TP.gui.Rect} A new rectangle that contains both the receiver
     *     and the supplied rectangle.
     */

    var data,
        otherData,

        newX,
        newY;

    if (this.isEmpty()) {
        return this.getType().construct(aRect);
    }

    if (aRect.isEmpty()) {
        return this.getType().construct(this);
    }

    data = this.$get('data');
    otherData = aRect.$get('data');

    newX = data.x.min(otherData.x);
    newY = data.y.min(otherData.y);

    return this.getType().construct(
                newX,
                newY,
                (data.x + data.width - newX).max(
                            otherData.x + otherData.width - newX),
                (data.y + data.height - newY).max(
                            otherData.y + otherData.height - newY));
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('scale',
function(xScaleFactor, yScaleFactor) {

    /**
     * @method scale
     * @summary Scales the coordinates of the receiver around its center using
     *     the supplied scaling factor and returns a new TP.gui.Rect with those
     *     new coordinates.
     * @param {Number} xScaleFactor The amount to scale the coordinates of the
     *     receiver to. If this is the only argument supplied, the Y value will
     *     also be scaled using this argument.
     * @param {Number} yScaleFactor The amount to scale the coordinates of the
     *     receiver to.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Rect} A new rectangle with the coordinates of the
     *     receiver scaled using the scaling factor.
     */

    var data,

        newWidth,
        newHeight;

    //  yScaleFactor is optional
    if (!TP.isNumber(xScaleFactor)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    data = this.$get('data');

    if (TP.isNumber(yScaleFactor)) {
        newWidth = data.width * xScaleFactor;
        newHeight = data.height * yScaleFactor;
    } else {
        newWidth = data.width * xScaleFactor;
        newHeight = data.height * xScaleFactor;
    }

    return this.getType().construct(
                    data.x - (newWidth - data.width) / 2,
                    data.y - (newHeight - data.height) / 2,
                    newWidth,
                    newHeight);
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('setHeight',
function(aHeight) {

    /**
     * @method setHeight
     * @summary Sets the height of the receiver to the supplied value.
     * @param {Number} aHeight The amount to set the height of the receiver to.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Rect} The receiver.
     */

    if (!TP.isNumber(aHeight)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    this.$get('data').height = aHeight;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('setWidth',
function(aWidth) {

    /**
     * @method setWidth
     * @summary Sets the width of the receiver to the supplied value.
     * @param {Number} aWidth The amount to set the width of the receiver to.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Rect} The receiver.
     */

    if (!TP.isNumber(aWidth)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    this.$get('data').width = aWidth;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('setX',
function(xVal) {

    /**
     * @method setX
     * @summary Sets the X coordinate of the receiver to the supplied value.
     * @param {Number} xVal The amount to set the 'x' coordinate of the receiver
     *     to.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Rect} The receiver.
     */

    if (!TP.isNumber(xVal)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    this.$get('data').x = xVal;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('setY',
function(yVal) {

    /**
     * @method setY
     * @summary Sets the Y coordinate of the receiver to the supplied value.
     * @param {Number} yVal The amount to set the 'y' coordinate of the receiver
     *     to.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Rect} The receiver.
     */

    if (!TP.isNumber(yVal)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    this.$get('data').y = yVal;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('setXY',
function(xVal, yVal) {

    /**
     * @method setXY
     * @summary Sets the X and Y coordinates of the receiver to the supplied
     *     values.
     * @param {Number} xVal The amount to set the 'x' coordinate of the receiver
     *     to.
     * @param {Number} yVal The amount to set the 'y' coordinate of the receiver
     *     to.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Rect} The receiver.
     */

    var data;

    if (!TP.isNumber(xVal) || !TP.isNumber(yVal)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    data = this.$get('data');

    data.x = xVal;
    data.y = yVal;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('shrink',
function(widthDiff, heightDiff) {

    /**
     * @method shrink
     * @summary Shrinks the width and height of the receiver by the values
     *     supplied.
     * @param {Number} widthDiff The amount to subtract from the width value of
     *     the receiver.
     * @param {Number} heightDiff The amount to subtract from the height value
     *     of the receiver.
     * @returns {TP.gui.Rect} The receiver.
     */

    var data;

    if (!TP.isNumber(widthDiff) || !TP.isNumber(heightDiff)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    data = this.$get('data');

    data.width -= widthDiff;
    data.height -= heightDiff;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('shrinkByPoint',
function(aPoint) {

    /**
     * @method shrinkByPoint
     * @summary Shrinks the width and height of the receiver by the values of
     *     the supplied point.
     * @param {TP.gui.Point} aPoint The point to use to grow the receiver.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Rect} The receiver.
     */

    var data;

    if (TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');

    data.width -= aPoint.get('x');
    data.height -= aPoint.get('y');

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('subtractByPoint',
function(aPoint) {

    /**
     * @method subtractByPoint
     * @summary Subtracts the dimensions of the supplied point from the
     *     receiver.
     * @param {TP.gui.Point} aPoint The point to subtract from the receiver.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Rect} The receiver.
     */

    var data;

    if (TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');

    data.x -= aPoint.get('x');
    data.y -= aPoint.get('y');

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('subtractFromX',
function(xDiff) {

    /**
     * @method subtractFromX
     * @summary Subtracts the value supplied from the x value of the receiver.
     * @param {Number} xDiff The amount to subtract from the x value of the
     *     receiver.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Rect} The receiver.
     */

    if (!TP.isNumber(xDiff)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    this.$get('data').x -= xDiff;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('subtractFromY',
function(yDiff) {

    /**
     * @method subtractFromY
     * @summary Subtracts the value supplied from the y value of the receiver.
     * @param {Number} yDiff The amount to subtract from the y value of the
     *     receiver.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Rect} The receiver.
     */

    if (!TP.isNumber(yDiff)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    this.$get('data').y -= yDiff;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('translate',
function(xDiff, yDiff) {

    /**
     * @method translate
     * @summary Translates the position of the receiver by the values supplied.
     * @param {Number} xDiff The amount to add to the x value of the receiver.
     * @param {Number} yDiff The amount to add to the y value of the receiver.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Rect} The receiver.
     */

    var data;

    if (!TP.isNumber(xDiff) || !TP.isNumber(yDiff)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    data = this.$get('data');

    data.x += xDiff;
    data.y += yDiff;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Rect.Inst.defineMethod('translateByPoint',
function(aPoint) {

    /**
     * @method translateByPoint
     * @summary Translates the position of the receiver by the values of the
     *     supplied point.
     * @param {TP.gui.Point} aPoint The point to use to translate the receiver.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Rect} The receiver.
     */

    var data;

    if (TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');

    data.x += aPoint.get('x');
    data.y += aPoint.get('y');

    return this;
});

//  ========================================================================
//  TP.gui.Matrix
//  ========================================================================

/**
 * @type {TP.gui.Matrix}
 * @summary A type that can manage matrix (xx, xy, yx, yy, dx, dy) values.
 */

//  ------------------------------------------------------------------------

TP.gui.GraphicData.defineSubtype('gui.Matrix');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  A RegExp that can construct a TP.gui.Matrix from
//  'matrix(xx, yx, xy, yy, dx, dy)'
TP.gui.Matrix.Type.defineConstant('MATRIX_REGEX',
                    TP.rc('matrix\\s*\\(\\s*([-.\\d]+)\\s*' +
                            '(?:,\\s*)([-.\\d]+)\\s*' +
                            '(?:,\\s*)([-.\\d]+)\\s*' +
                            '(?:,\\s*)([-.\\d]+)\\s*' +
                            '(?:,\\s*)([-.\\d]+)\\s*' +
                            '(?:,\\s*)([-.\\d]+)\\s*\\)'));

//  A RegExp that can construct a TP.gui.Matrix from 'rotate(deg)'
TP.gui.Matrix.Type.defineConstant('ROTATE_REGEX',
                    TP.rc('rotate\\s*\\(\\s*([-.\\d]+)\\s*\\)'));

//  A RegExp that can construct a TP.gui.Matrix from
//  'scale(xScale, yScale)'
//  NB: The yScale value is optional and will default to the xScale value
//  if not supplied
TP.gui.Matrix.Type.defineConstant('SCALE_REGEX',
                    TP.rc('scale\\s*\\(\\s*([-.\\d]+)\\s*' +
                            '(?:,\\s*)?([-.\\d]+)?\\s*\\)'));

//  A RegExp that can construct a TP.gui.Matrix from 'skewX(xSkew)'
TP.gui.Matrix.Type.defineConstant('SKEWX_REGEX',
                    TP.rc('skewX\\s*\\(\\s*([-.\\d]+)\\s*\\)'));

//  A RegExp that can construct a TP.gui.Matrix from 'skewY(ySkew)'
TP.gui.Matrix.Type.defineConstant('SKEWY_REGEX',
                    TP.rc('skewY\\s*\\(\\s*([-.\\d]+)\\s*\\)'));

//  A RegExp that can construct a TP.gui.Matrix from
//  'translate(xVal, yVal)'
//  NB: The yVal value is optional and will default to the xVal value if not
//  supplied
TP.gui.Matrix.Type.defineConstant('TRANSLATE_REGEX',
                    TP.rc('translate\\s*\\(\\s*([-.\\d]+)\\s*' +
                            '(?:,\\s*)?([-.\\d]+)?\\s*\\)'));

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.gui.Matrix.Type.defineConstant('STYLE_DECLVALUE_PARSER',
function(aString) {

    /**
     * @method STYLE_DECLVALUE_PARSER
     * @summary Converts a String containing a matrix description to a
     *     TP.gui.Matrix object.
     * @description The supplied String can be in one of seven formats:
     *     translate(xCoord, yCoord) translate(xAndYCoord) scale(xFactor,
     *     yFactor) scale(xAndYFactor) rotate(rotationAngle) skewX(skewAngle)
     *     skewY(skewAngle) matrix(xx, yx, xy, yy, dx, dy)
     * @param {The} aString String definition to use to build a TP.gui.Matrix
     *     object from.
     * @returns {TP.gui.Matrix} A TP.gui.Matrix expressing the supplied
     *     transformation.
     */

    var newObj,

        vals,

        xVal,
        yVal;

    //  No need to do parameter check here. We wouldn't have gotten here if
    //  aString wasn't a String.

    newObj = null;

    if (/translate/.test(aString)) {
        vals = TP.gui.Matrix.TRANSLATE_REGEX.match(aString);

        xVal = vals.at(1);
        yVal = vals.at(2);

        if (TP.notValid(yVal)) {
            yVal = xVal;
        }

        newObj = this.constructTranslationMatrix(
                                        parseFloat(xVal), parseFloat(yVal));
    } else if (/scale/.test(aString)) {
        vals = TP.gui.Matrix.SCALE_REGEX.match(aString);

        xVal = vals.at(1);
        yVal = vals.at(2);

        if (TP.notValid(yVal)) {
            yVal = xVal;
        }

        newObj = this.constructScalingMatrix(
                                        parseFloat(xVal), parseFloat(yVal));
    } else if (/rotate/.test(aString)) {
        vals = TP.gui.Matrix.ROTATE_REGEX.match(aString);

        newObj = this.constructRotationMatrix(
                                        parseFloat(vals.at(1)));
    } else if (/skewX/.test(aString)) {
        vals = TP.gui.Matrix.SKEWX_REGEX.match(aString);

        xVal = vals.at(1);

        newObj = this.constructSkewXMatrix(parseFloat(xVal));
    } else if (/skewY/.test(aString)) {
        vals = TP.gui.Matrix.SKEWY_REGEX.match(aString);

        yVal = vals.at(1);

        newObj = this.constructSkewYMatrix(parseFloat(yVal));
    } else if (/matrix/.test(aString)) {
        vals = TP.gui.Matrix.MATRIX_REGEX.match(aString);

        if (vals.getSize() < 7) {
            newObj = null;
        } else {
            newObj = this.construct({
                xx: parseFloat(vals.at(1)),
                yx: parseFloat(vals.at(2)),
                xy: parseFloat(vals.at(3)),
                yy: parseFloat(vals.at(4)),
                dx: parseFloat(vals.at(5)),
                dy: parseFloat(vals.at(6))
            });
        }
    }

    return newObj;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.addParser(TP.gui.Matrix.STYLE_DECLVALUE_PARSER);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.gui.Matrix.Type.defineMethod('cloneIdentityData',
function() {

    /**
     * @method cloneIdentityData
     * @summary Returns a copy of the type's 'identity data' that can be used
     *     in an identity matrix or in other computations.
     * @returns {Object} An object that contains identity matrix information.
     */

    var identityData;

    identityData = {
        xx: 1, xy: 0,
        yx: 0, yy: 1,
        dx: 0, dy: 0
    };

    return identityData;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Type.defineMethod('constructIdentityMatrix',
function() {

    /**
     * @method constructIdentityMatrix
     * @summary Returns a matrix that has configured its data to be an identity
     *     matrix.
     * @returns {TP.gui.Matrix} An identity matrix.
     */

    //  An identity matrix is the default.
    return this.construct();
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Type.defineMethod('constructFlipXMatrix',
function() {

    /**
     * @method constructFlipXMatrix
     * @summary Returns a matrix that will flip coordinates on the X axis.
     * @returns {TP.gui.Matrix} A matrix that flips X coordinates.
     */

    var newMatrix;

    newMatrix = this.construct();

    newMatrix.$get('data').xx = -1;

    return newMatrix;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Type.defineMethod('constructFlipYMatrix',
function() {

    /**
     * @method constructFlipYMatrix
     * @summary Returns a matrix that will flip coordinates on the Y axis.
     * @returns {TP.gui.Matrix} A matrix that flips Y coordinates.
     */

    var newMatrix;

    newMatrix = this.construct();

    newMatrix.$get('data').yy = -1;

    return newMatrix;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Type.defineMethod('constructFlipXYMatrix',
function() {

    /**
     * @method constructFlipXYMatrix
     * @summary Returns a matrix that will flip coordinates on both the X and Y
     *     axis.
     * @returns {TP.gui.Matrix} A matrix that flips both X and Y coordinates.
     */

    var newMatrix;

    newMatrix = this.construct();

    newMatrix.$get('data').xx = -1;
    newMatrix.$get('data').yy = -1;

    return newMatrix;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Type.defineMethod('constructProjectionMatrix',
function(projectX, projectY) {

    /**
     * @method constructProjectionMatrix
     * @summary Returns a matrix that will project X and Y coordinates around a
     *     point defined by the supplied X and Y.
     * @param {Number|TP.gui.Point} projectX The X coordinate to project points
     *     around or a TP.gui.Point to use as both the X and Y coordinates.
     * @param {Number} projectY The Y coordinate to project points around.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Matrix} A matrix that projects X and Y coordinates
     *     around the supplied X and Y point.
     */

    var newMatrix,

        x,
        y,

        x2,
        y2,

        n2,
        xy,

        newMatrixData;

    //  NB: We don't test projectY here, since this method allows it to not
    //  be defined.

    if (TP.notValid(projectX)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    newMatrix = this.construct();
    newMatrixData = newMatrix.$get('data');

    if (arguments.length === 1) {
        x = projectX.get('data').x;
        y = projectX.get('data').y;
    } else {
        x = projectX;
        y = projectY;
    }

    x2 = x * x;
    y2 = y * y;

    n2 = x2 + y2;

    xy = x * y / n2;

    newMatrixData.xx = x2 / n2;
    newMatrixData.xy = xy;

    newMatrixData.yx = xy;
    newMatrixData.yy = y2 / n2;

    return newMatrix;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Type.defineMethod('constructReflectionMatrix',
function(reflectX, reflectY) {

    /**
     * @method constructReflectionMatrix
     * @summary Returns a matrix that will reflect X and Y coordinates around a
     *     point defined by the supplied X and Y.
     * @param {Number|TP.gui.Point} reflectX The X coordinate to reflect points
     *     around or a TP.gui.Point to use as both the X and Y coordinates.
     * @param {Number} reflectY The Y coordinate to reflect points around.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Matrix} A matrix that reflects X and Y coordinates
     *     around the supplied X and Y point.
     */

    var newMatrix,

        x,
        y,

        x2,
        y2,

        n2,
        xy,

        newMatrixData;

    //  NB: We don't test reflectY here, since this method allows it to not
    //  be defined.

    if (TP.notValid(reflectX)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    newMatrix = this.construct();
    newMatrixData = newMatrix.$get('data');

    if (arguments.length === 1) {
        x = reflectX.get('data').x;
        y = reflectX.get('data').y;
    } else {
        x = reflectX;
        y = reflectY;
    }

    x2 = x * x;
    y2 = y * y;

    n2 = x2 + y2;

    xy = 2 * x * y / n2;

    newMatrixData.xx = 2 * x2 / n2 - 1;
    newMatrixData.xy = xy;

    newMatrixData.yx = xy;
    newMatrixData.yy = 2 * y2 / n2 - 1;

    return newMatrix;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Type.defineMethod('constructRotationMatrix',
function(angle) {

    /**
     * @method constructRotationMatrix
     * @summary Returns a matrix that will rotate its X and Y coordinates by
     *     the supplied amount around the (0,0) point.
     * @param {Number} angle The angle in radians to rotate the X and Y
     *     coordinates by.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Matrix} A matrix that rotates X and Y coordinates
     *     around the (0,0) point by the supplied amounts.
     */

    var newMatrix,
        newMatrixData,

        angleSine,
        angleCosine;

    if (!TP.isNumber(angle)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    newMatrix = this.construct();
    newMatrixData = newMatrix.$get('data');

    angleSine = angle.sin();
    angleCosine = angle.cos();

    newMatrixData.xx = angleCosine;
    newMatrixData.yy = angleCosine;

    newMatrixData.xy = -angleSine;
    newMatrixData.yx = angleSine;

    return newMatrix;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Type.defineMethod('constructScalingMatrix',
function(diffX, diffY) {

    /**
     * @method constructScalingMatrix
     * @summary Returns a matrix that will scale X and Y coordinates by the
     *     supplied amounts.
     * @param {Number|TP.gui.Point} diffX The amount to scale X coordinates or
     *     a TP.gui.Point to use for both X and Y amounts.
     * @param {Number} diffY The amount to scale Y coordinates.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Matrix} A matrix that scales X and Y coordinates by the
     *     supplied amounts.
     */

    var newMatrix;

    //  NB: We don't test diffY here, since this method allows it to not
    //  be defined.

    if (TP.notValid(diffX)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    newMatrix = this.construct();

    if (arguments.length === 1) {
        newMatrix.$get('data').xx = diffX.get('data').x;
        newMatrix.$get('data').yy = diffX.get('data').y;
    } else {
        newMatrix.$get('data').xx = diffX;
        newMatrix.$get('data').yy = diffY;
    }

    return newMatrix;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Type.defineMethod('constructSkewXMatrix',
function(skewAngle) {

    /**
     * @method constructSkewXMatrix
     * @summary Returns a matrix that will skew coordinates on the X axis
     *     around the (0,0) point.
     * @param {Number} skewAngle The angle in radians to skew the X coordinates
     *     by.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Matrix} A matrix that skews X coordinates.
     */

    var newMatrix;

    if (!TP.isNumber(skewAngle)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    newMatrix = this.construct();

    newMatrix.$get('data').xy = -skewAngle.tan();

    return newMatrix;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Type.defineMethod('constructSkewYMatrix',
function(skewAngle) {

    /**
     * @method constructSkewYMatrix
     * @summary Returns a matrix that will skew coordinates on the Y axis
     *     around the (0,0) point.
     * @param {Number} skewAngle The angle in radians to skew the Y coordinates
     *     by.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Matrix} A matrix that skews Y coordinates.
     */

    var newMatrix;

    if (!TP.isNumber(skewAngle)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    newMatrix = this.construct();

    newMatrix.$get('data').yx = skewAngle.tan();

    return newMatrix;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Type.defineMethod('constructTranslationMatrix',
function(diffX, diffY) {

    /**
     * @method constructTranslationMatrix
     * @summary Returns a matrix that will move X and Y coordinates by the
     *     supplied amounts.
     * @param {Number|TP.gui.Point} diffX The amount to move X coordinates or a
     *     TP.gui.Point to use for both X and Y amounts.
     * @param {Number} diffY The amount to move Y coordinates.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Matrix} A matrix that moves X and Y coordinates by the
     *     supplied amounts.
     */

    var newMatrix;

    //  NB: We don't test diffY here, since this method allows it to not
    //  be defined.

    if (TP.notValid(diffX)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    newMatrix = this.construct();

    if (arguments.length === 1) {
        newMatrix.$get('data').dx = diffX.get('data').x;
        newMatrix.$get('data').dy = diffX.get('data').y;
    } else {
        newMatrix.$get('data').dx = diffX;
        newMatrix.$get('data').dy = diffY;
    }

    return newMatrix;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Type.defineMethod('fromCSSString',
function(aString) {

    /**
     * @method fromString
     * @summary Converts a String containing a CSS matrix represenation to a
     *     TP.gui.Matrix object.
     * @description The supplied String can be in either the 3X2 'matrix()'
     *     format for CSS 2D transforms or the 4X4 'matrix3d()' format for CSS
     *     3D transforms. Since this type only supports 3X2 matrices, however,
     *     3D 4X4 matrices will be converted to 3X2 matrices.
     * @param {String} aString The String that an instance of this type will be
     *     extracted from.
     * @returns {TP.gui.Matrix} A TP.gui.Matrix having a set of values as
     *     expressed in the supplied String.
     */

    //  Make sure to pass 'true' as the second parameter to get a 3X2 matrix.
    return this.fromArray(TP.matrixFromCSSString(aString, true));
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Type.defineMethod('fromArray',
function(anObj) {

    /**
     * @method fromArray
     * @summary Returns an instance of this type as extracted from anObj, which
     *     should be an Array. This Array should be in the format of:
     *     [[xx, xy, dx], [yx, yy, dy]]
     * @description This type only supports 3X2 matrices, so this method will
     *     only take a 3X2 set of Arrays representing that. 4X4 3D matrices have
     *     to be converted to a 3X2 matrix first.
     * @param {Number[][]} anObj The Array that an instance of this type will be
     *     extracted from.
     * @returns {TP.gui.Matrix} An instance of this type as extracted from
     *     anObj.
     */

    var data,
        newObj;

    data = {
        xx: anObj[0][0],
        xy: anObj[0][1],
        yx: anObj[1][0],
        yy: anObj[1][1],
        dx: anObj[0][2],
        dy: anObj[1][2]
    };

    newObj = this.construct(data);

    return newObj;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Type.defineMethod('rotateAt',
function(angle, aPoint) {

    /**
     * @method rotateAt
     * @summary Returns a matrix that is rotated around the supplied point
     *     (used as a center point) according to the supplied rotation angle.
     * @param {Number} angle The angle in radians to rotate around the X and Y
     *     coordinates.
     * @param {TP.gui.Point} aPoint The point to use as the center point of the
     *     rotation.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Matrix} A matrix that is rotated around the point by
     *     the angle supplied.
     */

    var rotationMatrix;

    if (!TP.isNumber(angle) || TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    rotationMatrix = this.constructRotationMatrix(angle);

    return rotationMatrix.applyTransformsUsing(aPoint);
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Type.defineMethod('scaleAt',
function(aPoint, xFactor, yFactor) {

    /**
     * @method scaleAt
     * @summary Returns a matrix that scales its X and Y axis around the
     *     supplied point (used as a center point) according to the supplied
     *     scaling factors.
     * @param {TP.gui.Point} aPoint The point to use as the center point of the
     *     scaling.
     * @param {Number} xFactor The amount to scale the X axis by.
     * @param {Number} yFactor The amount to scale the Y axis by.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Matrix} A matrix that scales around the point by the
     *     angle supplied.
     */

    var scalingMatrix;

    if (TP.notValid(aPoint) ||
        !TP.isNumber(xFactor) ||
        !TP.isNumber(yFactor)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    scalingMatrix = this.constructScalingMatrix(xFactor, yFactor);

    return scalingMatrix.applyTransformsUsing(aPoint);
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Type.defineMethod('skewXAt',
function(angle, aPoint) {

    /**
     * @method skewXAt
     * @summary Returns a matrix that skews the X axis using the supplied point
     *     (used as a center point) according to the supplied rotation angle.
     * @param {Number} angle The angle in radians to skew the X axis around the
     *     X and Y coordinates.
     * @param {TP.gui.Point} aPoint The point to use as the center point of the
     *     skew.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Matrix} A matrix that skews the X axis around the point
     *     by the angle supplied.
     */

    var skewMatrix;

    if (!TP.isNumber(angle) || TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    skewMatrix = this.constructSkewXMatrix(angle);

    return skewMatrix.applyTransformsUsing(aPoint);
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Type.defineMethod('skewYAt',
function(angle, aPoint) {

    /**
     * @method skewYAt
     * @summary Returns a matrix that skews the Y axis using the supplied point
     *     (used as a center point) according to the supplied rotation angle.
     * @param {Number} angle The angle in radians to skew the Y axis around the
     *     X and Y coordinates.
     * @param {TP.gui.Point} aPoint The point to use as the center point of the
     *     skew.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Matrix} A matrix that skews the Y axis around the point
     *     by the angle supplied.
     */

    var skewMatrix;

    if (!TP.isNumber(angle) || TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    skewMatrix = this.constructSkewYMatrix(angle);

    return skewMatrix.applyTransformsUsing(aPoint);
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Type.defineMethod('translateBy',
function(diffX, diffY, aPoint) {

    /**
     * @method translateBy
     * @summary Returns a matrix that translates the X and Y axis using the
     *     supplied point (used as a center point) according to the supplied
     *     rotation angle.
     * @param {Number} diffX The difference to translate the X axis.
     * @param {Number} diffY The difference to translate the Y axis.
     * @param {TP.gui.Point} aPoint The point to use as the center point of the
     *     skew.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Matrix} A matrix that translates the X and Y axis
     *     around the point by the differences supplied.
     */

    var translationMatrix;

    if (!TP.isNumber(diffX) || !TP.isNumber(diffY) || TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    translationMatrix = this.constructTranslationMatrix(diffX, diffY);

    return translationMatrix.applyTransformsUsing(aPoint);
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.gui.Matrix.Inst.defineAttribute('data');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.Matrix.Inst.defineMethod('init',
function(matrixData) {

    /**
     * @method init
     * @summary Initialize the instance.
     * @description The argument to this method may be either a literal Object
     *     that contains matrix data to initialize the new instance with, a
     *     TP.gui.Matrix or an Array of either of these type of objects. If the
     *     objects are literal Objects, they should have the following keys /
     *     format: { xx: 1, xy: 0, yx: 0, yy: 1, dx: 0, dy: 0 };
     *
     *     Note that this example is the 'identity matrix' data that can be
     *     obtained by calling TP.gui.Matrix.cloneIdentityData().
     * @param {Object|TP.gui.Matrix|Number[][]} matrixData One or more objects
     *     of matrix data to initialize the matrix with. If this parameter is
     *     not valid, the matrix is initialized with the 'identity matrix'.
     * @returns {TP.gui.Matrix} The receiver.
     */

    var newData,

        i,

        lastData,
        currentData,

        newMatrixData;

    this.callNextMethod();

    if (TP.notEmpty(arguments)) {
        newData = arguments[0];

        if (TP.isKindOf(newData, TP.gui.Matrix)) {
            newData = newData.$get('data');

            newData = {
                xx: newData.xx, xy: newData.xy,
                yx: newData.yx, yy: newData.yy,
                dx: newData.dx, dy: newData.dy
            };
        }

        //  Loop over the rest of the arguments and 'accumulate' them into a
        //  single TP.gui.Matrix.
        for (i = 1; i < arguments.length; i++) {
            lastData = newData;
            currentData = arguments[i];

            if (TP.isKindOf(currentData, TP.gui.Matrix)) {
                currentData = currentData.$get('data');
            }

            newData = TP.gui.Matrix.cloneIdentityData();

            newData.xx = lastData.xx * currentData.xx +
                            lastData.xy * currentData.yx;
            newData.xy = lastData.xx * currentData.xy +
                            lastData.xy * currentData.yy;
            newData.yx = lastData.yx * currentData.xx +
                            lastData.yy * currentData.yx;
            newData.yy = lastData.yx * currentData.xy +
                            lastData.yy * currentData.yy;
            newData.dx = lastData.xx * currentData.dx +
                            lastData.xy * currentData.dy + lastData.dx;
            newData.dy = lastData.yx * currentData.dx +
                            lastData.yy * currentData.dy + lastData.dy;
        }

        newMatrixData = newData;
    } else {
        newMatrixData = TP.gui.Matrix.cloneIdentityData();
    }

    this.set('data', newMatrixData);

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Inst.defineMethod('add',
function(aMatrix) {

    /**
     * @method add
     * @summary Changes the receiver by summing the receiver and the supplied
     *     matrix together.
     * @param {TP.gui.Matrix} aMatrix The matrix to add to the receiver.
     * @returns {TP.gui.Matrix} The receiver.
     */

    var data,
        otherData;

    data = this.$get('data');
    otherData = aMatrix.$get('data');

    data.xx += otherData.xx;
    data.xy += otherData.xy;
    data.yx += otherData.yx;
    data.yy += otherData.yy;
    data.dx += otherData.dx;
    data.dy += otherData.dy;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Inst.defineMethod('applyTransformsUsing',
function(aPoint) {

    /**
     * @method applyTransformsUsing
     * @summary Applies the a positive translation, the receiver (which
     *     performs the actual transformation) and a negative translation to the
     *     point given and returns a matrix.
     * @param {TP.gui.Point} aPoint The point to use to compute the two
     *     translation matrices.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Matrix} A new TP.gui.Matrix containing the result of
     *     executing the translations and the receiver against the supplied
     *     point.
     */

    var pointData,

        matrix1,
        matrix2,

        resultMatrix;

    if (TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    pointData = aPoint.get('data');

    matrix1 = this.getType().constructTranslationMatrix(pointData.x,
                                                        pointData.y);
    matrix2 = this.getType().constructTranslationMatrix(-pointData.x,
                                                        -pointData.y);

    resultMatrix = matrix1.multiply(this, matrix2);

    return resultMatrix;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Inst.defineMethod('asCSSTransformString',
function() {

    /**
     * @method asCSSTransformString
     * @summary Returns the receiver as a String value that can be used for CSS
     *     Transforms.
     * @returns {String} The CSS Transform representation of the receiver.
     */

    var data;

    data = this.$get('data');

    return TP.join('matrix(', data.xx, ',', data.yx, ',',
                                data.xy, ',', data.yy, ',',
                                data.dx, ',', data.dy, ')');
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    var data,
        repStr,

        str;

    str = '[' + TP.tname(this) + ' :: ';
    data = this.$get('data');

    repStr = TP.join('{',
                        'xx: ', data.xx,
                        ', xy: ', data.xy,
                        ', yx: ', data.yx,
                        ', yy: ', data.yy,
                        ', dx: ', data.dx,
                        ', dy: ', data.dy,
                        '}');

    str += repStr + ']';

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver.
     * @returns {String} The receiver in HTML string format.
     */

    var data,
        str;

    data = this.$get('data');

    try {
        str = '<span class="TP_gui_Matrix">' +
                    '<span data-name="xx">' + data.xx + '</span>' +
                    '<span data-name="xy">' + data.xy + '</span>' +
                    '<span data-name="yx">' + data.yx + '</span>' +
                    '<span data-name="yy">' + data.yy + '</span>' +
                    '<span data-name="dx">' + data.dx + '</span>' +
                    '<span data-name="dy">' + data.dy + '</span>' +
                '</span>';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    var data;

    data = this.$get('data');

    return '{"type":' + TP.tname(this).quoted('"') + ',' +
             '"data":{' +
                 '"xx":"' + data.xx + '",' +
                 '"xy":"' + data.xy + '",' +
                 '"yx":"' + data.yx + '",' +
                 '"yy":"' + data.yy + '",' +
                 '"dx":"' + data.dx + '",' +
                 '"dy":"' + data.dy + '"' +
                 '}}';
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} The receiver's 'pretty print' String representation.
     */

    var data,
        str;

    data = this.$get('data');

    try {
        str = '<dl class="pretty ' + TP.escapeTypeName(TP.tname(this)) + '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' +
                        this.getTypeName() +
                    '</dd>' +
                    '<dt class="pretty key">xx</dt>' +
                    '<dd class="pretty value">' +
                        data.xx +
                    '</dd>' +
                    '<dt class="pretty key">xy</dt>' +
                    '<dd class="pretty value">' +
                        data.xy +
                    '</dd>' +
                    '<dt class="pretty key">yx</dt>' +
                    '<dd class="pretty value">' +
                        data.yx +
                    '</dd>' +
                    '<dt class="pretty key">yy</dt>' +
                    '<dd class="pretty value">' +
                        data.yy +
                    '</dd>' +
                    '<dt class="pretty key">dx</dt>' +
                    '<dd class="pretty value">' +
                        data.dx +
                    '</dd>' +
                    '<dt class="pretty key">dy</dt>' +
                    '<dd class="pretty value">' +
                        data.dy +
                    '</dd>' +
                    '</dl>';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a TIBET source code string.
     * @returns {String} An appropriate form for recreating the receiver.
     */

    var data,
        dataStr;

    data = this.$get('data');

    dataStr = TP.join('{',
                        'xx: ', data.xx,
                        ', xy: ', data.xy,
                        ', yx: ', data.yx,
                        ', yy: ', data.yy,
                        ', dx: ', data.dx,
                        ', dy: ', data.dy,
                        '}');

    return 'TP.gui.Matrix.construct(' + dataStr + ')';
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Inst.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns the matrix data formatted as a JavaScript literal
     *     object as its String representation.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the TP.gui.Matrix's String representation. This flag is ignored
     *     in this version of this method.
     * @returns {String} The String representation of the receiver.
     */

    var data,
        repStr;

    data = this.$get('data');

    repStr = TP.join('{',
                        'xx: ', data.xx,
                        ', xy: ', data.xy,
                        ', yx: ', data.yx,
                        ', yy: ', data.yy,
                        ', dx: ', data.dx,
                        ', dy: ', data.dy,
                        '}');

    return repStr;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver.
     * @returns {String} The receiver in XML string format.
     */

    var data,
        str;

    data = this.$get('data');

    try {
        str = '<instance type="' + TP.tname(this) + '"' +
                ' xx="' + data.xx + '" xy="' + data.xy + '"' +
                ' yx="' + data.yx + '" yy="' + data.yy + '"' +
                ' dx="' + data.dx + '" dy="' + data.dy + '"' +
                 '/>';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Inst.defineMethod('invert',
function() {

    /**
     * @method invert
     * @summary Inverts the receiver.
     * @returns {TP.gui.Matrix} The receiver.
     */

    var data,

        diff;

    data = this.$get('data');

    diff = data.xx * data.yy - data.xy * data.yx;

    data.xx = data.yy / diff;
    data.xy = -data.xy / diff;
    data.yx = -data.yx / diff;
    data.yy = data.xx / diff;
    data.dx = (data.xy * data.dy - data.yy * data.dx) / diff;
    data.dy = (data.yx * data.dx - data.xx * data.dy) / diff;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Inst.defineMethod('multiply',
function() {

    /**
     * @method multiply
     * @summary Multiplies the supplied 1 or more TP.gui.Matrix objects
     *     against the receiver, beginning with the receiver.
     * @description This method accepts 1 or more TP.gui.Matrix objects as
     *     arguments and therefore has no named parameters.
     * @returns {TP.gui.Matrix} The receiver.
     */

    var newData,

        i,

        lastData,
        currentData;

    newData = this.$get('data');

    //  Loop over all of the arguments and 'accumulate' them into a single
    //  TP.gui.Matrix.
    for (i = 0; i < arguments.length; i++) {
        lastData = newData;
        currentData = arguments[i].$get('data');

        newData = TP.gui.Matrix.cloneIdentityData();

        newData.xx = lastData.xx * currentData.xx +
                        lastData.xy * currentData.yx;
        newData.xy = lastData.xx * currentData.xy +
                        lastData.xy * currentData.yy;
        newData.yx = lastData.yx * currentData.xx +
                        lastData.yy * currentData.yx;
        newData.yy = lastData.yx * currentData.xy +
                        lastData.yy * currentData.yy;
        newData.dx = lastData.xx * currentData.dx +
                        lastData.xy * currentData.dy + lastData.dx;
        newData.dy = lastData.yx * currentData.dx +
                        lastData.yy * currentData.dy + lastData.dy;
    }

    this.$set('data', newData);

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Inst.defineMethod('rotate',
function(angle) {

    /**
     * @method rotate
     * @summary Applies a rotation transformation to the receiver.
     * @param {Number} angle The angle in radians to rotate the X and Y
     *     coordinates by.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.Matrix} The receiver.
     */

    var data,

        angleSine,
        angleCosine;

    if (!TP.isNumber(angle)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    data = this.$get('data');

    angleSine = angle.sin();
    angleCosine = angle.cos();

    data.xx = angleCosine;
    data.yy = angleCosine;

    data.xy = -angleSine;
    data.yx = angleSine;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Inst.defineMethod('scale',
function(diffX, diffY) {

    /**
     * @method scale
     * @summary Applies a scaling transformation to the receiver.
     * @param {Number|TP.gui.Point} diffX The amount to scale X coordinates or
     *     a TP.gui.Point to use for both X and Y amounts.
     * @param {Number} diffY The amount to scale Y coordinates.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Matrix} The receiver.
     */

    var data;

    if (TP.notValid(diffX)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');

    if (arguments.length === 1) {
        data.xx = diffX.get('x');
        data.yy = diffX.get('y');
    } else {
        data.xx = diffX;
        data.yy = diffY;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Inst.defineMethod('subtract',
function(aMatrix) {

    /**
     * @method subtract
     * @summary Changes the receiver by subtracting the supplied matrix and the
     *     receiver.
     * @param {TP.gui.Matrix} aMatrix The matrix to subtract from the receiver.
     * @returns {TP.gui.Matrix} The receiver.
     */

    var data,
        otherData;

    data = this.$get('data');
    otherData = aMatrix.$get('data');

    data.xx -= otherData.xx;
    data.xy -= otherData.xy;
    data.yx -= otherData.yx;
    data.yy -= otherData.yy;
    data.dx -= otherData.dx;
    data.dy -= otherData.dy;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Inst.defineMethod('transformPoint',
function(aPoint) {

    /**
     * @method transformPoint
     * @summary Uses the receiver to multiply the supplied TP.gui.Point,
     *     thereby transforming it.
     * @param {TP.gui.Point} aPoint The point to apply the receiver to.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Point} The transformed point.
     */

    var data,
        pointData,

        newPoint;

    if (TP.notValid(aPoint)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');
    pointData = aPoint.$get('data');

    newPoint = TP.gui.Point.construct(
            data.xx * pointData.x + data.xy * pointData.y + data.dx,
            data.yx * pointData.x + data.yy * pointData.y + data.dy);

    return newPoint;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Inst.defineMethod('transformRect',
function(aRect) {

    /**
     * @method transformRect
     * @summary Uses the receiver to multiply the supplied TP.gui.Rect,
     *     thereby transforming it.
     * @param {TP.gui.Rect} aRect The rect to apply the receiver to.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Rect} The transformed rect.
     */

    var data,
        rectData,

        newRect;

    if (TP.notValid(aRect)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');
    rectData = aRect.$get('data');

    //  Note here how we do *not* add the dx,dy to the width and height
    newRect = TP.gui.Rect.construct(
            data.xx * rectData.x + data.xy * rectData.y + data.dx,
            data.yx * rectData.x + data.yy * rectData.y + data.dy,
            data.xx * rectData.width + data.xy * rectData.height,
            data.yx * rectData.width + data.yy * rectData.height
            );

    return newRect;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Inst.defineMethod('translate',
function(diffX, diffY) {

    /**
     * @method translate
     * @summary Applies a translation transformation to the receiver.
     * @param {Number|TP.gui.Point} diffX The amount to move X coordinates or a
     *     TP.gui.Point to use for both X and Y amounts.
     * @param {Number} diffY The amount to move Y coordinates.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Matrix} The receiver.
     */

    var data;

    if (TP.notValid(diffX)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    data = this.$get('data');

    if (arguments.length === 1) {
        data.dx = diffX.get('x');
        data.dy = diffX.get('y');
    } else {
        data.dx = diffX;
        data.dy = diffY;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Matrix.Inst.defineMethod('transpose',
function() {

    /**
     * @method transpose
     * @summary Transposes the receiver.
     * @returns {TP.gui.Matrix} The receiver.
     */

    var data,
        newData;

    data = this.$get('data');

    newData = {
        xx: data.xx,
        xy: data.yx,
        yx: data.xy,
        yy: data.yy,
        dx: 0,
        dy: 0
    };

    this.$set('data', newData);

    return this;
});

//  ========================================================================
//  TP.gui.Color
//  ========================================================================

/**
 * @type {TP.gui.Color}
 * @summary A type that can manage color values. These values contain red,
 *     green, blue and alpha information.
 * @description This type can be produced by a String having one of the
 *     following nine formats: FFFFFF #FFFFFF FFF #FFF rgb(255, 255, 255)
 *     rgba(255, 255, 255, .5) hsl(120, 50%, 50%) hsla(120, 50%, 50%, .5)
 *     <aColorName>
 */

//  ------------------------------------------------------------------------

TP.gui.GraphicData.defineSubtype('gui.Color');

//  ------------------------------------------------------------------------

//  Note that we use apply here - otherwise, when TP.gui.Color's 'init'
//  method is called, it will incorrectly report 4 arguments even if there
//  is just 1.
TP.definePrimitive('cc',
function(r, g, b, a) {

    return TP.gui.Color.construct.apply(TP.gui.Color, arguments);
});

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.gui.Color.Type.defineMethod('fromString',
function(aString) {

    /**
     * @method fromString
     * @summary Converts a String containing a color to a TP.gui.Color object.
     * @description The supplied String can be in one of nine formats: FFFFFF
     *     #FFFFFF FFF #FFF rgb(255, 255, 255) rgba(255, 255, 255, .5) hsl(120,
     *     50%, 50%) hsla(120, 50%, 50%, .5) <aColorName>
     * @returns {TP.gui.Color} A TP.gui.Color having this color value
     *     expressed as RGB.
     */

    var newObj;

    //  All conditions passed, so construct a new instance of ourself.
    newObj = this.construct(aString);

    return newObj;
});

//  ------------------------------------------------------------------------

TP.gui.Color.Type.defineMethod('fromArray',
function(anObj) {

    /**
     * @method fromArray
     * @summary Returns an instance of this type as extracted from anObj, which
     *     should be an Array. This Array should be in the format of:
     *     [redNumber, greenNumber, blueNumber, alphaNumber]
     * @param {Number[]} anObj The Array that an instance of this type will be
     *     extracted from.
     * @returns {TP.gui.Color} An instance of this type as extracted from
     *     anObj.
     */

    var newObj;

    newObj = this.construct(anObj);

    return newObj;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.gui.Color.Inst.defineAttribute('data');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.Color.Inst.defineMethod('init',
function(red, green, blue, alpha) {

    /**
     * @method init
     * @summary Initialize the instance.
     * @param {Number|TP.gui.Color|Object|Array|String} red The red value of
     *     the receiver or a TP.gui.Color to copy or an object that has 'r',
     *     'g', 'b', and 'a' slots or an Array that has r in the first position,
     *     b in the second position, g in the third position and a in the last
     *     position.
     * @param {Number} green The green value of the receiver if 4 arguments are
     *     supplied or the alpha value if 2 arguments are supplied.
     * @param {Number} blue The blue value of the receiver, if 4 arguments are
     *     supplied.
     * @param {Number} alpha The alpha value of the receiver, if 4 arguments are
     *     supplied.
     * @returns {TP.gui.Color|undefined} The receiver.
     */

    var theData,
        newData;

    this.callNextMethod();

    if (TP.notEmpty(arguments)) {
        if (arguments.length <= 2) {
            //  Got handed one or two arguments. The first argument could
            //  be:
            //      a) another TP.gui.Color
            //      b) an Array with 3 or 4 values
            //      c) an Object that has 'r', 'g', 'b', and (maybe) 'a'
            //          slots

            theData = arguments[0];
            if (TP.isKindOf(theData, TP.gui.Color)) {
                theData = theData.$get('data');

                newData = {
                    r: theData.r,
                    g: theData.g,
                    b: theData.b,
                    a: theData.a
                };
            } else if (TP.isString(theData)) {
                if (TP.notValid(theData =
                                TP.colorStringAsArray(theData))) {
                    return;
                }

                newData = {
                    r: theData.at(0),
                    g: theData.at(1),
                    b: theData.at(2),
                    a: TP.ifInvalid(theData.at(3), 1.0).min(1).max(0)
                };
            } else if (TP.isArray(theData)) {
                newData = {
                    r: theData.at(0).min(255).max(0),
                    g: theData.at(1).min(255).max(0),
                    b: theData.at(2).min(255).max(0),
                    a: TP.ifInvalid(theData.at(3), 1.0).min(1).max(0)
                };
            } else {
                newData = {
                    r: theData.r,
                    g: theData.g,
                    b: theData.b,
                    a: theData.a
                };
            }

            //  If we were handed a second argument, it will be the opacity.
            if (arguments.length === 2) {
                newData.a = arguments[1].min(1).max(0);
            }
        } else {
            //  Got handed four Numbers.
            newData = {
                r: red.min(255).max(0),
                g: green.min(255).max(0),
                b: blue.min(255).max(0),
                a: TP.ifInvalid(alpha, 1.0).min(1).max(0)
            };
        }
    } else {
        //  Got nothing - set everything to 0.
        newData = {
            r: 0,
            g: 0,
            b: 0,
            a: 0
        };
    }

    this.$set('data', newData, false);

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Color.Inst.defineMethod('add',
function(aColor) {

    /**
     * @method addColor
     * @summary Adds the supplied color to the receiver.
     * @param {TP.gui.Color} aColor The color to add to the receiver.
     * @returns {TP.gui.Color} The receiver.
     */

    var colorData,
        otherData;

    colorData = this.$get('data');
    otherData = aColor.$get('data');

    colorData.r = (colorData.r + otherData.r).min(255).max(0);
    colorData.g = (colorData.g + otherData.g).min(255).max(0);
    colorData.b = (colorData.b + otherData.b).min(255).max(0);
    colorData.a = colorData.a + otherData.a;

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Color.Inst.defineMethod('asArray',
function() {

    /**
     * @method asArray
     * @summary Returns the receiver as an Array of: [red, green, blue, alpha].
     * @returns {Number[]} An Array containing the color expressed in RGB values
     *     ([red, green, blue, alpha]).
     */

    var colorData;

    if (TP.notValid(colorData = this.$get('data'))) {
        return null;
    }

    return TP.ac(colorData.r, colorData.g, colorData.b, colorData.a);
});

//  ------------------------------------------------------------------------

TP.gui.Color.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    var repStr,
        str;

    str = '[' + TP.tname(this) + ' :: ';

    repStr = this.asRGBAString();

    str += repStr + ']';

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.Color.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver.
     * @returns {String} The receiver in HTML string format.
     */

    var data,
        str;

    data = this.$get('data');

    try {
        str = '<span class="TP_gui_Color">' +
                    '<span data-name="r">' + data.r + '</span>' +
                    '<span data-name="g">' + data.g + '</span>' +
                    '<span data-name="b">' + data.b + '</span>' +
                    '<span data-name="a">' + data.a + '</span>' +
                '</span>';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.Color.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    var data;

    data = this.$get('data');

    return '{"type":' + TP.tname(this).quoted('"') + ',' +
             '"data":{' +
                 '"r":"' + data.r + '",' +
                 '"g":"' + data.g + '",' +
                 '"b":"' + data.b + '",' +
                 '"a":"' + data.a + '"' +
                 '}}';
});

//  ------------------------------------------------------------------------

TP.gui.Color.Inst.defineMethod('asRGBString',
function() {

    /**
     * @method asRGBString
     * @summary Returns the receiver as a CSS RGB String: rgb(red, green,
     *     blue).
     * @returns {String} A String containing the color expressed as a CSS RGB
     *     string.
     */

    var arrayVal;

    if (TP.notValid(arrayVal = this.asArray())) {
        return null;
    }

    //  Make sure to slice off any alpha value
    return 'rgb(' + arrayVal.slice(0, 3).asString() + ')';
});

//  ------------------------------------------------------------------------

TP.gui.Color.Inst.defineMethod('asRGBAString',
function() {

    /**
     * @method asRGBAString
     * @summary Returns the receiver as a CSS RGBA String: rgb(red, green,
     *     blue, alpha).
     * @returns {String} A String containing the color expressed as a CSS RGBA
     *     string.
     */

    var arrayVal;

    if (TP.notValid(arrayVal = this.asArray())) {
        return null;
    }

    return 'rgba(' + arrayVal.asString() + ')';
});

//  ------------------------------------------------------------------------

TP.gui.Color.Inst.defineMethod('asHexString',
function() {

    /**
     * @method asHexString
     * @summary Returns the receiver as a CSS hexadecimal String: #RRGGBB
     * @returns {String} A String containing the color expressed as a CSS hex
     *     string.
     */

    return TP.colorStringAsHex(this.asRGBString());
});

//  ------------------------------------------------------------------------

TP.gui.Color.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a JavaScript source code string. This
     *     method is intended to provide a primitive form of serialization.
     * @returns {Object} An appropriate form for recreating the receiver.
     */

    return 'TP.gui.Color.from(\'' + this.asRGBAString() + '\')';
});

//  ------------------------------------------------------------------------

TP.gui.Color.Inst.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns the String representation of the receiver.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the TP.gui.Color's String representation. This flag is ignored in
     *     this version of this method.
     * @returns {String} The String representation of the receiver.
     */

    return this.asRGBAString();
});

//  ------------------------------------------------------------------------

TP.gui.Color.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} The receiver's 'pretty print' String representation.
     */

    var data,
        str;

    data = this.$get('data');

    try {
        str = '<dl class="pretty ' + TP.escapeTypeName(TP.tname(this)) + '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' +
                        this.getTypeName() +
                    '</dd>' +
                    '<dt class="pretty key">R</dt>' +
                    '<dd class="pretty value">' +
                        data.r +
                    '</dd>' +
                    '<dt class="pretty key">G</dt>' +
                    '<dd class="pretty value">' +
                        data.g +
                    '</dd>' +
                    '<dt class="pretty key">B</dt>' +
                    '<dd class="pretty value">' +
                        data.b +
                    '</dd>' +
                    '<dt class="pretty key">A</dt>' +
                    '<dd class="pretty value">' +
                        data.a +
                    '</dd>' +
                    '</dl>';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.Color.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver.
     * @returns {String} The receiver in XML string format.
     */

    var data,
        str;

    data = this.$get('data');

    try {
        str = '<instance type="' + TP.tname(this) + '"' +
                ' r="' + data.r + '" g="' + data.g + '"' +
                ' b="' + data.b + '" a="' + data.a + '"' +
                 '/>';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.Color.Inst.defineMethod('blendToColor',
function(toColor, weight) {

    /**
     * @method blendColor
     * @summary Blends the supplied color with the receiver, according to the
     *     supplied weight and returns the result of that blend.
     * @param {TP.gui.Color} toColor The color to blend to starting at the
     *     receiver.
     * @param {Number} weight The weighting factor, a number between 0 and 1,
     *     that determines how much of the 'toColor' to blend into the receiver.
     * @returns {TP.gui.Color} The new color, after toColor has been blended
     *     with the receiver.
     */

    var balanceWeight,
        colorVal,
        colorAsNum,
        otherColorAsNum;

    if (TP.notValid(weight)) {
        balanceWeight = 0;
    } else {
        //  Make sure that balanceWeight is between 0 and 1.
        balanceWeight = weight.min(1).max(0);
    }

    colorAsNum = TP.colorStringAsLongNumber(this.asHexString());
    otherColorAsNum = TP.colorStringAsLongNumber(toColor.asHexString());

    colorVal = TP.longNumberAsColorString(
                        TP.colorValuesInterpolate(colorAsNum,
                                                    otherColorAsNum,
                                                    balanceWeight));

    return this.getType().construct(colorVal);
});

//  ------------------------------------------------------------------------

TP.gui.Color.Inst.defineMethod('getAlpha',
function() {

    /**
     * @method getAlpha
     * @summary Returns the alpha component of the receiver.
     * @returns {Number} The alpha component of the receiver.
     */

    return this.$get('data').a;
});

//  ------------------------------------------------------------------------

TP.gui.Color.Inst.defineMethod('getBlue',
function() {

    /**
     * @method getBlue
     * @summary Returns the blue component of the receiver.
     * @returns {Number} The blue component of the receiver.
     */

    return this.$get('data').b;
});

//  ------------------------------------------------------------------------

TP.gui.Color.Inst.defineMethod('getGreen',
function() {

    /**
     * @method getGreen
     * @summary Returns the green component of the receiver.
     * @returns {Number} The green component of the receiver.
     */

    return this.$get('data').g;
});

//  ------------------------------------------------------------------------

TP.gui.Color.Inst.defineMethod('getRed',
function() {

    /**
     * @method getRed
     * @summary Returns the red component of the receiver.
     * @returns {Number} The red component of the receiver.
     */

    return this.$get('data').r;
});

//  ------------------------------------------------------------------------

TP.gui.Color.Inst.defineMethod('subtract',
function(aColor) {

    /**
     * @method subtract
     * @summary Subtracts the supplied color from the receiver.
     * @param {TP.gui.Color} aColor The color to subtract from the receiver.
     * @returns {TP.gui.Color} The receiver.
     */

    var colorData,
        otherData;

    colorData = this.$get('data');
    otherData = aColor.$get('data');

    colorData.r = (colorData.r - otherData.r).min(255).max(0);
    colorData.g = (colorData.g - otherData.g).min(255).max(0);
    colorData.b = (colorData.b - otherData.b).min(255).max(0);
    colorData.a = colorData.a - otherData.a;

    return this;
});

//  ========================================================================
//  TP.gui.Gradient
//  ========================================================================

/**
 * @type {TP.gui.Gradient}
 * @summary A type which models a progression of color values along a vector,
 *     either linear or radial.
 */

//  ------------------------------------------------------------------------

TP.gui.GraphicData.defineSubtype('gui.Gradient');

//  TP.gui.Gradient is an abstract type.
TP.gui.Gradient.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  A RegExp that can separate a gradient angle value from gradient color
//  stop values in the following format:
//      'gradient-linear(deg, color stop, ...)'
TP.gui.Gradient.Type.defineConstant(
        'GRADIENT_LINEAR_REGEX',
        TP.rc('gradient-linear\\(\\s*(\\d+deg\\s*,)?\\s*(.+)\\s*\\)'));

TP.gui.Gradient.Type.defineConstant(
        'GRADIENT_RADIAL_REGEX',
        TP.rc('gradient-radial\\(\\s*(?:(\\S+? \\S+?)\\s*,){1}\\s*(.+)\\s*\\)'));

//  ------------------------------------------------------------------------

TP.gui.Gradient.Type.defineConstant('STYLE_DECLVALUE_PARSER',
function(aString) {

    /**
     * @method STYLE_DECLVALUE_PARSER
     * @summary Converts a String containing a gradient description to a
     *     TP.gui.Gradient object.
     * @description The supplied String can be in one of two formats:
     *     gradient-linear(angle, color stop, ...) gradient-radial(center-x
     *     center-y, color stop, ...)
     * @param {The} aString String definition to use to build a TP.gui.Gradient
     *     object from.
     * @returns {TP.gui.Gradient} A TP.gui.Gradient expressing the supplied
     *     gradient information.
     */

    var newObj,

        colorsAndStopsStr,
        colorsAndStops,

        angleAndColorStops,
        angle,

        centerPointAndColorStops,
        centerPoint;

    //  No need to do parameter check here. We wouldn't have gotten here if
    //  aString wasn't a String.

    newObj = null;

    if (/gradient-linear/.test(aString)) {
        //  Extract the color stops and the (optional) angle from the
        //  supplied String.
        angleAndColorStops = TP.gui.Gradient.GRADIENT_LINEAR_REGEX.exec(
                                    aString);

        if (TP.notValid(angleAndColorStops)) {
            return null;
        }

        //  The colors and stops part of the definition will be at the third
        //  place in the results.
        if (TP.isEmpty(colorsAndStopsStr = angleAndColorStops.at(2))) {
            return null;
        }

        //  Extract those into an Array
        colorsAndStops = TP.gui.Gradient.$extractColorsAndStops(
                                                colorsAndStopsStr);

        //  Invoke the constructor, supplying the colors and stops Array as
        //  the arguments to the constructor.
        newObj = TP.gui.LinearGradient.construct.apply(
                            TP.gui.LinearGradient, colorsAndStops);

        //  The gradient angle, if it was defined, will be at the second
        //  position in the results.
        if (TP.notEmpty(angle = angleAndColorStops.at(1)) &&
            !TP.isNaN(angle = parseFloat(angle))) {
            newObj.set('angle', angle);
        }
    } else if (/gradient-radial/.test(aString)) {
        //  Extract the color stops and the center point from the supplied
        //  String.
        centerPointAndColorStops =
                TP.gui.Gradient.GRADIENT_RADIAL_REGEX.exec(aString);

        if (TP.notValid(centerPointAndColorStops)) {
            return null;
        }

        //  The center point will be at the second position in the results.
        if (TP.isEmpty(centerPoint = centerPointAndColorStops.at(1))) {
            return null;
        }

        //  The colors and stops part of the definition will be at the third
        //  place in the results.
        if (TP.isEmpty(colorsAndStopsStr = centerPointAndColorStops.at(2))) {
            return null;
        }

        colorsAndStops = TP.gui.Gradient.$extractColorsAndStops(
                                                colorsAndStopsStr);

        //  Invoke the constructor, supplying the colors and stops Array as
        //  the arguments to the constructor.
        newObj = TP.gui.RadialGradient.construct.apply(
                                    TP.gui.RadialGradient, colorsAndStops);

        centerPoint = centerPoint.split(' ');

        //  Note here how when we initially set the 'fx' and 'fy' that
        //  they're the same as the 'cx' and 'cy', respectively. This is to
        //  comply with the SVG spec.
        newObj.set('cx', centerPoint.first());
        newObj.set('fx', centerPoint.first());

        newObj.set('cy', centerPoint.last());
        newObj.set('fy', centerPoint.last());
    }

    return newObj;
});

//  ------------------------------------------------------------------------

TP.gui.Gradient.addParser(TP.gui.Gradient.STYLE_DECLVALUE_PARSER);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.gui.Gradient.Type.defineMethod('$extractColorsAndStops',
function(aString) {

    /**
     * @method $extractColorsAndStops
     * @summary Extracts the color and stop values from the supplied String.
     * @param {String} aString The String to extract the color and stop values
     *     from.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.meta.gui.Gradient} The receiver.
     */

    var colors,
        count,

        colorsAndStops;

    if (!TP.isString(aString)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    colors = TP.ac();

    count = 0;

    //  Find all of the color values, capture them into the 'colors' Array
    //  and replace them with '_<count>_'.
    colorsAndStops = aString.replace(
            TP.regex.CSS_COLOR_GLOBAL,
            function(wholeMatch) {

                colors.push(wholeMatch.trim());
                return wholeMatch.replace(/(\s*)(.+)(\s*)/,
                                            '$1_' + count++ + '_$3 ');
            });

    //  Make sure and trim off the last whitespace.
    colorsAndStops = colorsAndStops.trim();

    //  Split the remaining value along spaces (with an optional leading
    //  comma).
    colorsAndStops = colorsAndStops.split(/,* /);

    //  Convert the '_<count>_' values back into their respective color
    //  values by searching for them in the split-out Array.
    colorsAndStops = colorsAndStops.collect(
            function(item) {

                if (/_\d+_/.test(item)) {
                    return colors.at(parseInt(item.slice(1, -1), 10));
                }

                return item;
            });

    return colorsAndStops;
});

//  ------------------------------------------------------------------------

TP.gui.Gradient.Type.defineMethod('constructShadowGradient',
function(color, opacity) {

    /**
     * @method constructShadowGradient
     * @summary Constructs a gradient that uses the color to fade from the
     *     given opacity value to a 0 opacity.
     * @param {TP.gui.Color|Number|String} color A color value that can be
     *     represented as a TP.gui.Color.
     * @param {Number} opacity An opacity percentage value, given as a Number
     *     between 0.0 and 1.0.
     * @exception TP.sig.InvalidParameter
     * @exception TP.sig.InvalidNumber
     * @returns {TP.meta.gui.Gradient} The receiver.
     */

    var opacityOffset,
        newGradient;

    if (TP.notValid(color)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    if (!TP.isNumber(opacity)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    opacityOffset = (opacity + 0.1).min(1.0);

    newGradient = this.construct(
                    0,
                    TP.gui.Color.construct(color, opacityOffset),
                    0.25,
                    TP.gui.Color.construct(color, opacity),
                    1,
                    TP.gui.Color.construct(color, 0));

    return newGradient;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.gui.Gradient.Inst.defineAttribute('colors');
TP.gui.Gradient.Inst.defineAttribute('stops');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.Gradient.Inst.defineMethod('init',
function() {

    /**
     * @method init
     * @summary Initialize the instance.
     * @returns {TP.gui.Gradient} The receiver.
     */

    var colors,
        stops,

        i;

    this.callNextMethod();

    colors = TP.ac();
    stops = TP.ac();

    if (TP.notEmpty(arguments)) {
        for (i = 0; i < arguments.length; i += 2) {
            stops.push(arguments[i]);
            colors.push(TP.gui.Color.construct(arguments[i + 1]));
        }
    }

    this.set('colors', colors);
    this.set('stops', stops);

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Gradient.Inst.defineMethod('addColorStop',
function(aStopValue, aColorValue) {

    /**
     * @method addColorStop
     * @summary Adds a 'color stop', a color value paired with a length,
     *     usually a number or percentage, denoting where that color should stop
     *     along the gradient vector.
     * @param {String} aStopValue A value denoting where the color should stop.
     * @param {TP.gui.Color|String} aColorValue A color value.
     * @exception TP.sig.InvalidParameter
     * @returns {TP.gui.Gradient} The receiver.
     */

    var colorValue;

    if (!TP.isString(aStopValue)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    if (TP.notValid(aColorValue)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    this.get('stops').push(aStopValue);

    if (!TP.isKindOf(colorValue = aColorValue, TP.gui.Color)) {
        colorValue = TP.gui.Color.construct(aColorValue);
    }

    this.get('colors').push(colorValue);

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Gradient.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a JavaScript source code string. This
     *     method is intended to provide a primitive form of serialization.
     * @returns {Object} An appropriate form for recreating the receiver.
     */

    return 'TP.gui.Gradient.from(\'' + this.asString() + '\')';
});

//  ------------------------------------------------------------------------

TP.gui.Gradient.Inst.defineMethod('copy',
function() {

    /**
     * @method copy
     * @summary Returns a 'copy' of the receiver. Actually, a new instance
     *     whose value is equalTo that of the receiver.
     * @returns {TP.gui.Gradient} A new TP.gui.Gradient which is a copy of the
     *     receiver.
     */

    var newGradient;

    newGradient = this.callNextMethod();

    newGradient.set('colors', this.get('colors').copy());
    newGradient.set('stops', this.get('stops').copy());

    return newGradient;
});

//  ------------------------------------------------------------------------

TP.gui.Gradient.Inst.defineMethod('normalizeGradientValues',
function() {

    /**
     * @method normalizeGradientValues
     * @summary Normalizes the receiver's color stops so that there are a
     *     consistent number of stops that match the number of colors.
     * @returns {TP.gui.Gradient|undefined} The receiver.
     */

    var colors,
        stops,

        gradientColors,
        gradientStopValues,

        numStops;

    colors = this.get('colors');
    stops = this.get('stops');

    gradientColors = colors;

    //  If stop values for the gradient weren't explicitly provided,
    //  manufacture the stops.
    if (TP.isEmpty(gradientStopValues = stops)) {
        //  The number of stops that we'll manufacture here is equal to the
        //  number of colors minus 1.
        numStops = gradientColors.getSize() - 1;
        gradientStopValues = (1).to(numStops).collect(
            function(stopNum) {

                //  Compute the stop value by dividing the stop number by
                //  the total number of stops.

                /* eslint-disable no-extra-parens */
                return (stopNum / numStops);
                /* eslint-enable no-extra-parens */
            });

        //  Go ahead and prepend a '0' as the first stop value.
        gradientStopValues.unshift(0);
    } else {
        if (stops.getSize() !== colors.getSize()) {
            //  TODO: Raise an exception
            return;
        }

        //  Otherwise, make sure any '%'age numbers are converted to their
        //  decimal equivalent.
        gradientStopValues = stops.collect(
                                function(aStop) {

                                    if (/%/.test(aStop)) {
                                        return parseFloat(aStop) / 100;
                                    }

                                    return aStop;
                                });
    }

    this.set('colors', gradientColors);
    this.set('stops', gradientStopValues);

    return this;
});

//  ========================================================================
//  TP.gui.LinearGradient
//  ========================================================================

/**
 * @type {TP.gui.LinearGradient}
 * @summary A type that represents a 'linear gradient' - that is, a color
 *     transition that proceeds along an angle having one or more 'color stops'.
 */

//  ------------------------------------------------------------------------

TP.gui.Gradient.defineSubtype('LinearGradient');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.gui.LinearGradient.Inst.defineAttribute('angle');

TP.gui.LinearGradient.Inst.defineAttribute('x1');
TP.gui.LinearGradient.Inst.defineAttribute('y1');
TP.gui.LinearGradient.Inst.defineAttribute('x2');
TP.gui.LinearGradient.Inst.defineAttribute('y2');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.LinearGradient.Inst.defineMethod('init',
function() {

    /**
     * @method init
     * @summary Initialize the instance.
     * @returns {TP.gui.LinearGradient} The receiver.
     */

    this.callNextMethod();

    //  This will default the x1,y1 x2,y2 values to something sensible.
    this.set('angle', TP.HORIZONTAL);

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.LinearGradient.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    var arr,
        repStr,

        str;

    arr = TP.ac('gradient-linear(');

    //  If the angle isn't the default of 90, then include it in the String
    //  representation.
    if (this.get('angle') !== 90) {
        arr.push(this.get('angle'), ', ');
    }

    if (TP.notEmpty(this.get('stops'))) {

        //  Loop over the stops and push both a stop value and a color value
        //  onto the Array that we're building.
        this.get('stops').performWith(
            function(aStopValue, aColorValue) {

                arr.push(aStopValue, ' ', aColorValue.asString(), ' ');
            },
            this.get('colors'));

        //  Pop off the trailing whitespace
        arr.pop();
    }

    //  Close the rep
    arr.push(')');

    str = '[' + TP.tname(this) + ' :: ';

    repStr = arr.join('');

    str += repStr + ']';

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.LinearGradient.Inst.defineMethod('asGeckoCSSString',
function() {

    /**
     * @method asGeckoCSSString
     * @summary Returns the receiver as a String value that can be used in
     *     Gecko 1.9.2+ (FF 3.6+) browsers.
     * @returns {String} The Gecko CSS String representation of the receiver.
     */

    var arr;

    arr = TP.ac('-moz-linear-gradient(');

    //  Gecko allows us to set an 'angle' value directly.
    arr.push(this.get('angle'), 'deg, ');

    //  Loop over the stops and push both a stop value and a color value
    //  onto the Array that we're building.
    this.get('stops').performWith(
        function(aStopValue, aColorValue) {

            arr.push(aColorValue.asString(), ' ', aStopValue * 100, '%',
                        ', ');
        },
        this.get('colors'));

    //  Pop off the trailing comma & whitespace and push on a ')'.
    arr.pop();
    arr.push(')');

    return arr.join('');
});

//  ------------------------------------------------------------------------

TP.gui.LinearGradient.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver.
     * @returns {String} The receiver in HTML string format.
     */

    var str;

    try {
        str = '<span class="TP_gui_LinearGradient">' +
                '<span data-name="angle">' + this.get('angle') + '</span>';

        if (TP.notEmpty(this.get('stops'))) {

            //  Loop over the stops and push both a stop value and a color value
            //  onto the Array that we're building.
            this.get('stops').performWith(
                function(aStopValue, aColorValue) {

                    str +=
                         '<span data-name="stop">' +
                            '<span data-name="value">' +
                                aStopValue +
                            '</span>' +
                            '<span data-name="color">' +
                                TP.htmlstr(aColorValue) +
                            '</span>' +
                        '</span>';
                },
                this.get('colors'));
        }

        str += '</span>';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.LinearGradient.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    var stops;

    stops = '';

    if (TP.notEmpty(this.get('stops'))) {

        //  Loop over the stops and push both a stop value and a color value
        //  onto the Array that we're building.
        this.get('stops').performWith(
            function(aStopValue, aColorValue) {

                stops +=
                     '{' +
                        '"value":"' + aStopValue + '",' +
                        '"color":' + TP.jsonsrc(aColorValue) +
                    '},';
            },
            this.get('colors'));

        stops = stops.slice(0, stops.getSize() - 1);
    }

    return '{"type":' + TP.tname(this).quoted('"') + ',' +
             '"data":{' +
                 '"angle":"' + this.get('angle') + '",' +
                 '"stops":[' + stops + ']' +
                 '}}';
});

//  ------------------------------------------------------------------------

TP.gui.LinearGradient.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} The receiver's 'pretty print' String representation.
     */

    var str;

    try {
        str = '<dl class="pretty ' + TP.escapeTypeName(TP.tname(this)) + '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' +
                        this.getTypeName() +
                    '</dd>' +
                    '<dt class="pretty key">angle</dt>' +
                    '<dd class="pretty value">' +
                        this.get('angle') +
                    '</dd>';

        if (TP.notEmpty(this.get('stops'))) {

            //  Loop over the stops and push both a stop value and a color value
            //  onto the Array that we're building.
            this.get('stops').performWith(
                function(aStopValue, aColorValue) {

                    str +=
                        '<dt class="pretty key">stop</dt>' +
                        '<dd class="pretty value">' +
                        '<dl>' +
                            '<dt class="pretty key">value</dt>' +
                            '<dd class="pretty value">' + aStopValue + '</dd>' +
                            '<dt class="pretty key">color</dt>' +
                            '<dd class="pretty value">' +
                                TP.pretty(aColorValue) +
                            '</dd>' +
                        '</dl>' +
                        '</dd>';
                },
                this.get('colors'));
        }

        str += '</dl>';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.LinearGradient.Inst.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns the String representation of the receiver.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the TP.gui.LinearGradient's String representation. This flag is
     *     ignored in this version of this method.
     * @returns {String} The String representation of the receiver.
     */

    var arr,
        repStr;

    arr = TP.ac('gradient-linear(');

    //  If the angle isn't the default of 90, then include it in the String
    //  representation.
    if (this.get('angle') !== 90) {
        arr.push(this.get('angle'), ', ');
    }

    if (TP.notEmpty(this.get('stops'))) {

        //  Loop over the stops and push both a stop value and a color value
        //  onto the Array that we're building.
        this.get('stops').performWith(
            function(aStopValue, aColorValue) {

                arr.push(aStopValue, ' ', aColorValue.asString(), ' ');
            },
            this.get('colors'));

        //  Pop off the trailing whitespace
        arr.pop();
    }

    //  Close the rep
    arr.push(')');

    repStr = arr.join('');

    return repStr;
});

//  ------------------------------------------------------------------------

TP.gui.LinearGradient.Inst.defineMethod('asWebkitCSSString',
function() {

    /**
     * @method asWebkitCSSString
     * @summary Returns the receiver as a String value that can be used in
     *     Webkit browsers.
     * @returns {String} The Webkit CSS String representation of the receiver.
     */

    var arr;

    arr = TP.ac('-webkit-gradient(linear ');

    //  For Webkit, the 'angle' value is limited to what can be computed by
    //  our setAngle() method.
    arr.push(this.get('x1'), ' ', this.get('y1'), ', ',
                this.get('x2'), ' ', this.get('y2'), ', ');

    //  Loop over the stops and push both a stop value and a color value
    //  onto the Array that we're building.
    this.get('stops').performWith(
        function(aStopValue, aColorValue) {

            arr.push('color-stop(', aStopValue, ', ',
                                    aColorValue.asString(), ')',
                        ', ');
        },
        this.get('colors'));

    //  Pop off the trailing comma & whitespace and push on a ')'.
    arr.pop();
    arr.push(')');

    return arr.join('');
});

//  ------------------------------------------------------------------------

TP.gui.LinearGradient.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver.
     * @returns {String} The receiver in XML string format.
     */

    var str;

    try {
        str = '<instance type="' + TP.tname(this) + '"' +
                ' angle="' + this.get('angle') + '">';

        if (TP.notEmpty(this.get('stops'))) {

            //  Loop over the stops and push both a stop value and a color value
            //  onto the Array that we're building.
            this.get('stops').performWith(
                function(aStopValue, aColorValue) {

                    str +=
                         '<stop>' +
                            '<value>' + aStopValue + '</value>' +
                            '<color>' + TP.xmlstr(aColorValue) + '</color>' +
                        '</stop>';
                },
                this.get('colors'));
        }

        str += '</instance>';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.LinearGradient.Inst.defineMethod('setAngle',
function(anAngle) {

    /**
     * @method setAngle
     * @summary Sets the angle of the receiver.
     * @description For now, only the following discrete values are supported as
     *     the angle: 0, 45, 90, 135, 180, 225, 270, 315
     * @param {Number} anAngle The angle of the gradient.
     * @exception TP.sig.InvalidNumber
     * @returns {TP.gui.LinearGradient} The receiver.
     */

    var gradientAngle,

        x1,
        y1,
        x2,
        y2;

    //  If the anAngle is TP.HORIZONTAL, that means that the gradient angle
    //  will be 90 degrees.
    if (anAngle === TP.HORIZONTAL) {
        gradientAngle = 90;
    } else if (anAngle === TP.VERTICAL) {
        //  TP.VERTICAL is 0 degrees.
        gradientAngle = 0;
    } else {
        //  Otherwise, use the number supplied.
        gradientAngle = anAngle;
    }

    //  Note that we put the parameter check here so that the caller can use
    //  the TP.HORIZONTAL and TP.VERTICAL aliases.
    if (!TP.isNumber(gradientAngle)) {
        return this.raise('TP.sig.InvalidNumber');
    }

    //  Based on the gradient angle, we adjust x1, y1, x2, and y2
    //  appropriately.
    switch (gradientAngle) {
        case 0:

            x1 = '0%';
            y1 = '0%';
            x2 = '100%';
            y2 = '0%';

            break;

        case 45:

            x1 = '0%';
            y1 = '0%';
            x2 = '100%';
            y2 = '100%';

            break;

        case 90:

            x1 = '0%';
            y1 = '0%';
            x2 = '0%';
            y2 = '100%';

            break;

        case 135:

            x1 = '100%';
            y1 = '0%';
            x2 = '0%';
            y2 = '100%';

            break;

        case 180:

            x1 = '100%';
            y1 = '0%';
            x2 = '0%';
            y2 = '0%';

            break;

        case 225:

            x1 = '100%';
            y1 = '100%';
            x2 = '0%';
            y2 = '0%';

            break;

        case 270:

            x1 = '0%';
            y1 = '100%';
            x2 = '0%';
            y2 = '0%';

            break;

        case 315:

            x1 = '0%';
            y1 = '100%';
            x2 = '100%';
            y2 = '0%';

            break;

        default:
            break;
    }

    //  Note the use of the '$set' version here to avoid recursion right
    //  back into this method.
    this.$set('angle', gradientAngle);

    this.set('x1', x1);
    this.set('y1', y1);
    this.set('x2', x2);
    this.set('y2', y2);

    return this;
});

//  ========================================================================
//  TP.gui.RadialGradient
//  ========================================================================

/**
 * @type {TP.gui.RadialGradient}
 * @summary A type that represents a 'radial gradient' - that is, a color
 *     transition that radiates outward from a supplied center point along one
 *     or more 'color stops'.
 */

//  ------------------------------------------------------------------------

TP.gui.Gradient.defineSubtype('RadialGradient');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.gui.RadialGradient.Inst.defineAttribute('cx');
TP.gui.RadialGradient.Inst.defineAttribute('cy');
TP.gui.RadialGradient.Inst.defineAttribute('radius');
TP.gui.RadialGradient.Inst.defineAttribute('fx');
TP.gui.RadialGradient.Inst.defineAttribute('fy');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.RadialGradient.Inst.defineMethod('init',
function() {

    /**
     * @method init
     * @summary Initialize the instance.
     * @returns {TP.gui.RadialGradient} The receiver.
     */

    this.callNextMethod();

    //  Default these to something sensible.

    //  Default these to 50%, as per the SVG spec.
    this.set('cx', '50%');
    this.set('cy', '50%');
    this.set('radius', '50%');

    //  These default to the same value as cx, cy unless specified, as per
    //  the SVG spec.
    this.set('fx', '50%');
    this.set('fy', '50%');

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.RadialGradient.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    var arr,
        repStr,

        str;

    arr = TP.ac('gradient-radial(');

    arr.push(this.get('cx'), ' ', this.get('cy'));

    if (TP.notEmpty(this.get('stops'))) {

        //  Push a comma (',') before pushing the stops
        arr.push(', ');

        //  Loop over the stops and push both a stop value and a color value
        //  onto the Array that we're building.
        this.get('stops').performWith(
            function(aStopValue, aColorValue) {

                arr.push(aStopValue, ' ', aColorValue.asString(), ' ');
            },
            this.get('colors'));

        //  Pop off the trailing whitespace
        arr.pop();
    }

    //  Close the rep
    arr.push(')');

    str = '[' + TP.tname(this) + ' :: ';

    repStr = arr.join('');

    str += repStr + ']';

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.RadialGradient.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    var stops;

    stops = '';

    if (TP.notEmpty(this.get('stops'))) {

        //  Loop over the stops and push both a stop value and a color value
        //  onto the Array that we're building.
        this.get('stops').performWith(
            function(aStopValue, aColorValue) {

                stops +=
                     '{' +
                        '"value":"' + aStopValue + '",' +
                        '"color":' + TP.jsonsrc(aColorValue) +
                    '},';
            },
            this.get('colors'));

        stops = stops.slice(0, stops.getSize() - 1);
    }

    return '{"type":' + TP.tname(this).quoted('"') + ',' +
             '"data":{' +
                 '"cx":"' + this.get('cx') + '",' +
                 '"cy":"' + this.get('cy') + '",' +
                 '"stops":[' + stops + ']' +
                 '}}';
});

//  ------------------------------------------------------------------------

TP.gui.RadialGradient.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver.
     * @returns {String} The receiver in HTML string format.
     */

    var str;

    try {
        str = '<span class="TP_gui_RadialGradient">' +
                '<span data-name="cx">' + this.get('cx') + '</span>' +
                '<span data-name="cy">' + this.get('cy') + '</span>';

        if (TP.notEmpty(this.get('stops'))) {

            //  Loop over the stops and push both a stop value and a color value
            //  onto the Array that we're building.
            this.get('stops').performWith(
                function(aStopValue, aColorValue) {

                    str +=
                         '<span data-name="stop">' +
                            '<span data-name="value">' +
                                aStopValue +
                            '</span>' +
                            '<span data-name="color">' +
                                TP.htmlstr(aColorValue) +
                            '</span>' +
                        '</span>';
                },
                this.get('colors'));
        }

        str += '</span>';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.RadialGradient.Inst.defineMethod('asGeckoCSSString',
function() {

    /**
     * @method asGeckoCSSString
     * @summary Returns the receiver as a String value that can be used in
     *     Gecko 1.9.2+ (FF 3.6+) browsers.
     * @returns {String} The Gecko CSS String representation of the receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.gui.RadialGradient.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} The receiver's 'pretty print' String representation.
     */

    var str;

    try {
        str = '<dl class="pretty ' + TP.escapeTypeName(TP.tname(this)) + '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' +
                        this.getTypeName() +
                    '</dd>' +
                    '<dt class="pretty key">cx</dt>' +
                    '<dd class="pretty value">' +
                        this.get('cx') +
                    '</dd>' +
                    '<dt class="pretty key">cy</dt>' +
                    '<dd class="pretty value">' +
                        this.get('cy') +
                    '</dd>';

        if (TP.notEmpty(this.get('stops'))) {

            //  Loop over the stops and push both a stop value and a color value
            //  onto the Array that we're building.
            this.get('stops').performWith(
                function(aStopValue, aColorValue) {

                    str +=
                        '<dt class="pretty key">stop</dt>' +
                        '<dd class="pretty value">' +
                        '<dl>' +
                            '<dt class="pretty key">value</dt>' +
                            '<dd class="pretty value">' + aStopValue + '</dd>' +
                            '<dt class="pretty key">color</dt>' +
                            '<dd class="pretty value">' +
                                TP.pretty(aColorValue) +
                            '</dd>' +
                        '</dl>' +
                        '</dd>';
                },
                this.get('colors'));
        }

        str += '</dl>';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.RadialGradient.Inst.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns the String representation of the receiver.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the TP.gui.RadialGradient's String representation. This flag is
     *     ignored in this version of this method.
     * @returns {String} The String representation of the receiver.
     */

    var arr,
        repStr;

    arr = TP.ac('gradient-radial(');

    arr.push(this.get('cx'), ' ', this.get('cy'));

    if (TP.notEmpty(this.get('stops'))) {

        //  Push a comma (',') before pushing the stops
        arr.push(', ');

        //  Loop over the stops and push both a stop value and a color value
        //  onto the Array that we're building.
        this.get('stops').performWith(
            function(aStopValue, aColorValue) {

                arr.push(aStopValue, ' ', aColorValue.asString(), ' ');
            },
            this.get('colors'));

        //  Pop off the trailing whitespace
        arr.pop();
    }

    //  Close the rep
    arr.push(')');

    repStr = arr.join('');

    return repStr;
});

//  ------------------------------------------------------------------------

TP.gui.RadialGradient.Inst.defineMethod('asWebkitCSSString',
function() {

    /**
     * @method asWebkitCSSString
     * @summary Returns the receiver as a String value that can be used in
     *     Webkit browsers.
     * @returns {String} The Webkit CSS String representation of the receiver.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.gui.RadialGradient.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver.
     * @returns {String} The receiver in XML string format.
     */

    var str;

    try {
        str = '<instance type="' + TP.tname(this) + '"' +
                ' cx="' + this.get('cx') + '"' +
                ' cy="' + this.get('cy') + '">';

        if (TP.notEmpty(this.get('stops'))) {

            //  Loop over the stops and push both a stop value and a color value
            //  onto the Array that we're building.
            this.get('stops').performWith(
                function(aStopValue, aColorValue) {

                    str +=
                         '<stop>' +
                            '<value>' + aStopValue + '</value>' +
                            '<color>' + TP.xmlstr(aColorValue) + '</color>' +
                        '</stop>';
                },
                this.get('colors'));
        }

        str += '</instance>';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ========================================================================
//  TP.gui.Pattern
//  ========================================================================

/**
 * @type {TP.gui.Pattern}
 * @summary A type that can manage patterns (i.e. a repeatable image within a
 *     particular boundary).
 */

//  ------------------------------------------------------------------------

TP.gui.GraphicData.defineSubtype('gui.Pattern');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  A RegExp that can construct a TP.gui.Pattern from
//  'pattern(url(...), x, y, width, height)'
TP.gui.Pattern.Type.defineConstant(
        'PATTERN_REGEX',
        TP.rc('pattern\\(url\\((.+?)\\)\\s*,\\s*(.+?)\\s*,\\s*(.+?)\\s*,\\s*(.+?)\\s*,\\s*(.+?)\\s*\\)'));

//  ------------------------------------------------------------------------

TP.gui.Pattern.Type.defineConstant('STYLE_DECLVALUE_PARSER',
function(aString) {

    /**
     * @method STYLE_DECLVALUE_PARSER
     * @summary Converts a String containing a matrix description to a
     *     TP.gui.Pattern object.
     * @description The supplied String can be in the following format:
     *     pattern(url(...), rect(...))
     * @param {The} aString String definition to use to build a TP.gui.Pattern
     *     object from.
     * @returns {TP.gui.Pattern} A TP.gui.Pattern expressing the supplied
     *     gradient information.
     */

    var newObj,

        results,

        url,

        x,
        y,

        width,
        height;

    //  No need to do parameter check here. We wouldn't have gotten here if
    //  aString wasn't a String.

    newObj = null;

    //  Extract pattern info from the supplied String.
    if (TP.isArray(results = TP.gui.Pattern.PATTERN_REGEX.exec(aString))) {
        //  The url will be at the first position.
        if (TP.notEmpty(url = results.at(1))) {
            //  If the author enclosed it in quotes, strip them off.
            url = url.stripEnclosingQuotes();
        }

        //  Grab the rest of the parameters.
        x = results.at(2);
        y = results.at(3);
        width = results.at(4);
        height = results.at(5);

        //  Make sure that none of the parameters are empty.
        if (TP.isEmpty(url) ||
            TP.isEmpty(x) || TP.isEmpty(y) ||
            TP.isEmpty(width) || TP.isEmpty(height)) {
            return null;
        }

        //  Allocate and initialize the new instance.

        newObj = this.construct();

        newObj.set('uri', TP.uc(url));

        newObj.set('x', x);
        newObj.set('y', y);
        newObj.set('width', width);
        newObj.set('height', height);
    }

    return newObj;
});

//  ------------------------------------------------------------------------

TP.gui.Pattern.addParser(TP.gui.Pattern.STYLE_DECLVALUE_PARSER);

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.gui.Pattern.Inst.defineAttribute('uri');

TP.gui.Pattern.Inst.defineAttribute('x');
TP.gui.Pattern.Inst.defineAttribute('y');
TP.gui.Pattern.Inst.defineAttribute('width');
TP.gui.Pattern.Inst.defineAttribute('height');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.Pattern.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    var arr,
        repStr,

        str;

    arr = TP.ac('pattern(');

    arr.push('url(', this.get('uri'), '), ',
                this.get('x'), ', ',
                this.get('y'), ', ',
                this.get('width'), ', ',
                this.get('height'));

    //  Push on a ')'.
    arr.push(')');

    str = '[' + TP.tname(this) + ' :: ';

    repStr = arr.join('');

    str += repStr + ']';

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.Pattern.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver.
     * @returns {String} The receiver in HTML string format.
     */

    var str;

    try {
        str = '<span class="TP_gui_Pattern">' +
                '<span data-name="x">' + this.get('x') + '</span>' +
                '<span data-name="y">' + this.get('y') + '</span>' +
                '<span data-name="width">' + this.get('width') + '</span>' +
                '<span data-name="height">' + this.get('height') + '</span>' +
                '<span data-name="url">' + this.get('url') + '</span>' +
            '</span>';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.Pattern.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    return '{"type":' + TP.tname(this).quoted('"') + ',' +
             '"data":{' +
                 '"x":"' + this.get('x') + '",' +
                 '"y":"' + this.get('y') + '",' +
                 '"width":"' + this.get('width') + '",' +
                 '"height":"' + this.get('height') + '",' +
                 '"url":"' + this.get('uri') + '"' +
                 '}}';
});

//  ------------------------------------------------------------------------

TP.gui.Pattern.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} The receiver's 'pretty print' String representation.
     */

    var str;

    try {
        str = '<dl class="pretty ' + TP.escapeTypeName(TP.tname(this)) + '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' +
                        this.getTypeName() +
                    '</dd>' +
                    '<dt class="pretty key">x</dt>' +
                    '<dd class="pretty value">' +
                        this.get('x') +
                    '</dd>' +
                    '<dt class="pretty key">y</dt>' +
                    '<dd class="pretty value">' +
                        this.get('y') +
                    '</dd>' +
                    '<dt class="pretty key">width</dt>' +
                    '<dd class="pretty value">' +
                        this.get('width') +
                    '</dd>' +
                    '<dt class="pretty key">height</dt>' +
                    '<dd class="pretty value">' +
                        this.get('height') +
                    '</dd>' +
                    '<dt class="pretty key">url</dt>' +
                    '<dd class="pretty value">' +
                        this.get('uri') +
                    '</dd>' +
                    '</dl>';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.Pattern.Inst.defineMethod('asSource',
function() {

    /**
     * @method asSource
     * @summary Returns the receiver as a JavaScript source code string. This
     *     method is intended to provide a primitive form of serialization.
     * @returns {Object} An appropriate form for recreating the receiver.
     */

    return 'TP.gui.Pattern.from(\'' + this.asString() + '\')';
});

//  ------------------------------------------------------------------------

TP.gui.Pattern.Inst.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns the String representation of the receiver.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the TP.gui.Pattern's String representation. This flag is ignored
     *     in this version of this method.
     * @returns {String} The String representation of the receiver.
     */

    var arr,
        repStr;

    arr = TP.ac('pattern(');

    arr.push('url(', this.get('uri'), '), ',
                this.get('x'), ', ',
                this.get('y'), ', ',
                this.get('width'), ', ',
                this.get('height'));

    //  Push on a ')'.
    arr.push(')');

    repStr = arr.join('');

    return repStr;
});

//  ------------------------------------------------------------------------

TP.gui.Pattern.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver.
     * @returns {String} The receiver in XML string format.
     */

    var str;

    try {
        str = '<instance type="' + TP.tname(this) + '"' +
                ' x="' + this.get('x') + '" y="' + this.get('y') + '"' +
                ' width="' + this.get('width') +
                '" height="' + this.get('height') + '"' +
                '>';

        str += '<url>' + TP.xmlstr(this.get('uri')) + '</url>';

        str += '</instance>';
    } catch (e) {
        str = this.toString();
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.Pattern.Inst.defineMethod('copy',
function() {

    /**
     * @method copy
     * @summary Returns a 'copy' of the receiver. Actually, a new instance
     *     whose value is equalTo that of the receiver.
     * @returns {TP.gui.Pattern} A new TP.gui.Pattern which is a copy of the
     *     receiver.
     */

    var newPattern;

    newPattern = this.callNextMethod();

    newPattern.set('uri', TP.uc(this.get('uri')));

    newPattern.set('x', this.get('x'));
    newPattern.set('y', this.get('y'));
    newPattern.set('width', this.get('width'));
    newPattern.set('height', this.get('height'));

    return newPattern;
});

//  ------------------------------------------------------------------------

TP.gui.Pattern.Inst.defineMethod('getURI',
function() {

    /**
     * @method getURI
     * @summary Returns the location of the internally stored URI.
     * @returns {String} The location of the pattern's URI.
     */

    //  Return the 'fully expanded' version of the URI.
    return this.$get('uri').getLocation();
});

//  ========================================================================
//  TP.gui.Path
//  ========================================================================

/**
 * @type {TP.gui.Path}
 * @summary A type that can manage an arbitrarily complex set of points.
 */

//  ------------------------------------------------------------------------

TP.gui.GraphicData.defineSubtype('gui.Path');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.gui.Path.Type.defineConstant('MOVE_TO_ABS', 0);
TP.gui.Path.Type.defineConstant('LINE_TO_ABS', 1);
TP.gui.Path.Type.defineConstant('HORIZ_LINE_TO_ABS', 2);
TP.gui.Path.Type.defineConstant('VERT_LINE_TO_ABS', 3);
TP.gui.Path.Type.defineConstant('CURVE_TO_ABS', 4);
TP.gui.Path.Type.defineConstant('SMOOTH_CURVE_TO_ABS', 5);
TP.gui.Path.Type.defineConstant('QUAD_CURVE_TO_ABS', 6);
TP.gui.Path.Type.defineConstant('QUAD_SMOOTH_CURVE_TO_ABS', 7);
TP.gui.Path.Type.defineConstant('ARC_TO_ABS', 8);
TP.gui.Path.Type.defineConstant('CLOSE_PATH_ABS', 9);

TP.gui.Path.Type.defineConstant('MOVE_TO_REL', 10);
TP.gui.Path.Type.defineConstant('LINE_TO_REL', 11);
TP.gui.Path.Type.defineConstant('HORIZ_LINE_TO_REL', 12);
TP.gui.Path.Type.defineConstant('VERT_LINE_TO_REL', 13);
TP.gui.Path.Type.defineConstant('CURVE_TO_REL', 14);
TP.gui.Path.Type.defineConstant('SMOOTH_CURVE_TO_REL', 15);
TP.gui.Path.Type.defineConstant('QUAD_CURVE_TO_REL', 16);
TP.gui.Path.Type.defineConstant('QUAD_SMOOTH_CURVE_TO_REL', 17);
TP.gui.Path.Type.defineConstant('ARC_TO_REL', 18);
TP.gui.Path.Type.defineConstant('CLOSE_PATH_REL', 19);

//  Subtypes should redefine this.
TP.gui.Path.Type.defineConstant('SEGMENT_INFO', TP.hc());

//  Subtypes should redefine this.
TP.gui.Path.Type.defineConstant('PATH_SPLITUP_REGEX', TP.rc('.+', 'g'));

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.gui.Path.Inst.defineAttribute('pathSegments');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.Path.Inst.defineMethod('init',
function() {

    /**
     * @method init
     * @summary Initialize the instance.
     * @returns {TP.gui.Path} A new instance.
     */

    this.set('pathSegments', TP.ac());

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Path.Inst.defineMethod('addSegment',
function(segmentOpConstant, segmentArgs) {

    /**
     * @method addSegment
     * @summary Adds a segment to the path, using the supplied operator
     *     constant and segmentArgs Array.
     * @param {String} segmentOpConstant A constant that denotes the operator of
     *     the path segment. This should be one of the constant values defined
     *     in this type's SEGMENT_INFO hash.
     * @param {Array<Number|Boolean|Array|TP.gui.Point>} segmentArgs An Array of
     *     Numbers, Booleans, Arrays or TP.gui.Points that contain the segment
     *     arguments.
     * @returns {TP.gui.Path} The receiver.
     */

    var segmentInfo,
        segmentOperator,
        segmentNumArgs,

        suppliedArgs;

    if (TP.isValid(segmentInfo = this.getType().at(
                                    'SEGMENT_INFO').at(segmentOpConstant))) {
        segmentOperator = segmentInfo.first();
        segmentNumArgs = segmentInfo.last();

        //  Make sure that the operands are supplied as numbers.
        suppliedArgs = this.operandsAsNumbers(segmentArgs);

        if (suppliedArgs.getSize() !== segmentNumArgs) {
            //  TODO: Raise an exception here?
            return this;
        }

        this.get('pathSegments').push(segmentOperator, suppliedArgs);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Path.Inst.defineMethod('operandsAsNumbers',
function(operandsArray) {

    /**
     * @method operandsAsNumbers
     * @summary Converts the supplied Array of operands (each of which can be a
     *     Number, a Boolean, an Array or a TP.gui.Point), into a Number
     *     sequence suitable for use in a segment.
     * @param {Object[]} operandsArray An Array of objects to convert.
     * @returns {Number[]} An Array of Numbers.
     */

    var i,

        convertedOperands,
        operand;

    convertedOperands = TP.ac();

    for (i = 0; i < operandsArray.getSize(); i++) {
        operand = operandsArray.at(i);

        if (TP.isNumber(operand)) {
            convertedOperands.push(operand);
        } else if (TP.isBoolean(operand)) {
            if (operand) {
                convertedOperands.push(1);
            } else {
                convertedOperands.push(0);
            }
        } else if (TP.isArray(operand)) {
            convertedOperands.addAll(this.operandsAsNumbers(operand));
        } else if (operand.getType() === TP.gui.Point) {
            convertedOperands.push(operand.get('x'), operand.get('y'));
        }
    }

    return convertedOperands;
});

//  ------------------------------------------------------------------------

TP.gui.Path.Inst.defineMethod('deleteSegment',
function(segmentOpConstant, occurrenceCount) {

    /**
     * @method deleteSegment
     * @summary Deletes a segment from the path, using the supplied operator
     *     constant and occurrence of the segment's operator.
     * @param {String} segmentOpConstant A constant that denotes the operator of
     *     the path segment. This should be one of the constant values defined
     *     in this type's SEGMENT_INFO hash.
     * @param {Number} occurrenceCount The occurrence of the particular operator
     *     that should be removed from the path. E.g. 'The 3rd MOVETO'.
     * @returns {TP.gui.Path} The receiver.
     */

    var segmentInfo,
        segmentOperator,

        index;

    if (TP.isValid(segmentInfo = this.getType().at(
                                    'SEGMENT_INFO').at(segmentOpConstant))) {
        segmentOperator = segmentInfo.first();

        index = this.getSegmentIndex(segmentOperator, occurrenceCount);

        if (index > -1) {
            this.get('pathSegments').splice(index, 2);
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Path.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    var repStr,
        str;

    //  NB: Because of the interesting way that Array's 'toString'
    //  implementation works, the following path, stored internally as:
    //      ['M', [10, 10]]
    //  will be output when joined by a space (' ') as:
    //      'M 10,10'
    //  which is exactly what we want.

    str = '[' + TP.tname(this) + ' :: ';

    repStr = this.get('pathSegments').join(' ');

    str += repStr + ']';

    return str;
});

//  ------------------------------------------------------------------------

TP.gui.Path.Inst.defineMethod('asHTMLString',
function() {

    /**
     * @method asHTMLString
     * @summary Produces an HTML string representation of the receiver.
     * @returns {String} The receiver in HTML string format.
     */

    return '<span class="TP_gui_Pattern">' +
                TP.htmlstr(this.get('pathSegments')) +
            '</span>';
});

//  ------------------------------------------------------------------------

TP.gui.Path.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    return '{"type":' + TP.tname(this).quoted('"') + ',' +
             '"data":{' +
                 '"segments":' + TP.jsonsrc(this.get('pathSegments')) +
                 '}}';
});

//  ------------------------------------------------------------------------

TP.gui.Path.Inst.defineMethod('asPrettyString',
function() {

    /**
     * @method asPrettyString
     * @summary Returns the receiver as a string suitable for use in 'pretty
     *     print' output.
     * @returns {String} A new String containing the 'pretty print' string of
     *     the receiver.
     */

    return '<dl class="pretty ' + TP.escapeTypeName(TP.tname(this)) + '">' +
                    '<dt>Type name</dt>' +
                    '<dd class="pretty typename">' +
                        this.getTypeName() +
                    '</dd>' +
                    '<dt class="pretty key">Segments</dt>' +
                    '<dd class="pretty value">' +
                        TP.pretty(this.asString()) +
                    '</dd>' +
                    '</dl>';
});

//  ------------------------------------------------------------------------

TP.gui.Path.Inst.defineMethod('asString',
function(verbose) {

    /**
     * @method asString
     * @summary Returns a String representation of the receiver.
     * @param {Boolean} verbose Whether or not to return the 'verbose' version
     *     of the TP.gui.Path's String representation. The default is true.
     * @returns {String} The receiver's String representation.
     */

    var repStr;

    //  NB: Because of the interesting way that Array's 'toString'
    //  implementation works, the following path, stored internally as:
    //      ['M', [10, 10]]
    //  will be output when joined by a space (' ') as:
    //      'M 10,10'
    //  which is exactly what we want.

    repStr = this.get('pathSegments').join(' ');

    return repStr;
});

//  ------------------------------------------------------------------------

TP.gui.Path.Inst.defineMethod('asXMLString',
function() {

    /**
     * @method asXMLString
     * @summary Produces an XML string representation of the receiver.
     * @returns {String} The receiver in XML string format.
     */

    return '<instance type="' + TP.tname(this) + '">' +
                    TP.xmlstr(this.asString()) +
                    '</instance>';
});

//  ------------------------------------------------------------------------

TP.gui.Path.Inst.defineMethod('getSegment',
function(segmentOpConstant, occurrenceCount) {

    /**
     * @method getSegment
     * @summary Retrieves a segment from the path, using the supplied operator
     *     constant and occurrence of the segment's operator.
     * @param {String} segmentOpConstant A constant that denotes the operator of
     *     the path segment. This should be one of the constant values defined
     *     in this type's SEGMENT_INFO hash.
     * @param {Number} occurrenceCount The occurrence of the particular operator
     *     that should be obtained from the path. E.g. 'The 3rd MOVETO'.
     * @returns {Array<String,Number[]>} An Array containing the desired segment
     *     in the following format: [operator, [operand, operand]].
     */

    var segmentInfo,
        segmentOperator,

        index,
        path;

    if (TP.isValid(segmentInfo = this.getType().at(
                                    'SEGMENT_INFO').at(segmentOpConstant))) {
        segmentOperator = segmentInfo.first();

        index = this.getSegmentIndex(segmentOperator, occurrenceCount);

        if (index > -1) {
            path = this.get('pathSegments');

            return TP.ac(path.at(index), path.at(index + 1));
        }
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.gui.Path.Inst.defineMethod('getSegmentIndex',
function(segmentOpConstant, occurrenceCount) {

    /**
     * @method getSegmentIndex
     * @summary Retrieves a segment's index from the path, using the supplied
     *     operator constant and occurrence of the segment's operator.
     * @param {String} segmentOpConstant A constant that denotes the operator of
     *     the path segment. This should be one of the constant values defined
     *     in this type's SEGMENT_INFO hash.
     * @param {Number} occurrenceCount The occurrence of the particular operator
     *     that should be obtained from the path. E.g. 'The 3rd MOVETO'.
     * @returns {Number} The index of the segment in the path.
     */

    var path,

        theOccurrenceCount,
        count,

        i;

    path = this.get('pathSegments');

    theOccurrenceCount = TP.ifInvalid(occurrenceCount, 1);

    count = 0;

    //  Note here the increment of the path by 2 - we're skipping over the
    //  arguments arrays and just looking at the operator.
    for (i = 0; i < path.getSize(); i += 2) {
        if (path.at(i) === segmentOpConstant) {
            count++;

            if (count === theOccurrenceCount) {
                return i;
            }
        }
    }

    return -1;
});

//  ------------------------------------------------------------------------

TP.gui.Path.Inst.defineMethod('insertSegment',
function(segmentOpConstant, segmentArgs, insPointSegmentConstant,
         occurrenceCount) {

    /**
     * @method insertSegment
     * @summary Inserts a segment into the path, using the supplied operator
     *     constant and segmentArgs Array. This segment will be inserted before
     *     the 'occurrenceCount' occurrence of the insertion point segment
     *     constant.
     * @param {String} segmentOpConstant A constant that denotes the operator of
     *     the path segment. This should be one of the constant values defined
     *     in this type's SEGMENT_INFO hash.
     * @param {Array<Number|Boolean|Array|TP.gui.Point>} segmentArgs An Array of
     *     Numbers, Booleans, Arrays or TP.gui.Points that contain the segment
     *     arguments.
     * @param {String} insPointSegmentConstant A constant that denotes the
     *     operator of the insertion point path segment. This should be one of
     *     the constant values defined in this type's SEGMENT_INFO hash.
     * @param {Number} occurrenceCount The occurrence of the particular operator
     *     that should be the insertion point from the path. E.g. 'The 3rd
     *     MOVETO'.
     * @returns {TP.gui.Path} The receiver.
     */

    var segmentInfo,
        insPointSegmentInfo,

        segmentOperator,
        segmentNumArgs,

        suppliedArgs,

        insPointSegmentOperator,

        index;

    if (TP.isValid(segmentInfo = this.getType().at(
                            'SEGMENT_INFO').at(segmentOpConstant)) &&
        TP.isValid(insPointSegmentInfo = this.getType().at(
                            'SEGMENT_INFO').at(insPointSegmentConstant))) {
        segmentOperator = segmentInfo.first();
        segmentNumArgs = segmentInfo.last();

        //  Make sure that the operands are supplied as numbers.
        suppliedArgs = this.operandsAsNumbers(segmentArgs);

        if (suppliedArgs.getSize() !== segmentNumArgs) {
            //  TODO: Raise an exception here?
            return this;
        }

        insPointSegmentOperator = insPointSegmentInfo.first();

        index = this.getSegmentIndex(insPointSegmentOperator,
                                        occurrenceCount);

        if (index > -1) {

            //  Splice in at 'index', removing 0, and inserting the segment
            //  operator and arguments.
            this.get('pathSegments').splice(index,
                                            0,
                                            segmentOperator,
                                            suppliedArgs);
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Path.Inst.defineMethod('updateSegment',
function(segmentOpConstant, segmentArgs, occurrenceCount) {

    /**
     * @method updateSegment
     * @summary Updates a segment in the path, using the supplied operator
     *     constant and segmentArgs Array.
     * @param {String} segmentOpConstant A constant that denotes the operator of
     *     the path segment. This should be one of the constant values defined
     *     in this type's SEGMENT_INFO hash.
     * @param {Array<Number|Boolean|Array|TP.gui.Point>} segmentArgs An Array of
     *     Numbers, Booleans, Arrays or TP.gui.Points that contain the segment
     *     arguments.
     * @param {Number} occurrenceCount The occurrence of the particular operator
     *     that should be obtained from the path. E.g. 'The 3rd MOVETO'.
     * @returns {TP.gui.Path} The receiver.
     */

    var segmentInfo,
        segmentOperator,
        segmentNumArgs,

        suppliedArgs,

        index,
        path;

    if (TP.isValid(segmentInfo = this.getType().at(
                                    'SEGMENT_INFO').at(segmentOpConstant))) {
        segmentOperator = segmentInfo.first();
        segmentNumArgs = segmentInfo.last();

        //  Make sure that the operands are supplied as numbers.
        suppliedArgs = this.operandsAsNumbers(segmentArgs);

        if (suppliedArgs.getSize() !== segmentNumArgs) {
            //  TODO: Raise an exception here?
            return this;
        }

        index = this.getSegmentIndex(segmentOperator, occurrenceCount);

        if (index > -1) {
            path = this.get('pathSegments');

            path.atPut(index, segmentOperator);
            path.atPut(index + 1, suppliedArgs);
        }
    }

    return this;
});

//  ========================================================================
//  TP.gui.SVGPath
//  ========================================================================

/**
 * @summary A subtype of TP.gui.Path that can manage SVG paths.
 */

//  ------------------------------------------------------------------------

TP.gui.Path.defineSubtype('SVGPath');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.gui.SVGPath.Type.defineConstant('SEGMENT_INFO',
    TP.hc(
        TP.gui.Path.MOVE_TO_ABS, TP.ac('M', 2),
        TP.gui.Path.LINE_TO_ABS, TP.ac('L', 2),
        TP.gui.Path.HORIZ_LINE_TO_ABS, TP.ac('H', 1),
        TP.gui.Path.VERT_LINE_TO_ABS, TP.ac('V', 1),
        TP.gui.Path.CURVE_TO_ABS, TP.ac('C', 6),
        TP.gui.Path.SMOOTH_CURVE_TO_ABS, TP.ac('S', 4),
        TP.gui.Path.QUAD_CURVE_TO_ABS, TP.ac('Q', 4),
        TP.gui.Path.QUAD_SMOOTH_CURVE_TO_ABS, TP.ac('T', 2),
        TP.gui.Path.ARC_TO_ABS, TP.ac('A', 7),
        TP.gui.Path.CLOSE_PATH_ABS, TP.ac('Z', 0),

        TP.gui.Path.MOVE_TO_REL, TP.ac('m', 2),
        TP.gui.Path.LINE_TO_REL, TP.ac('l', 2),
        TP.gui.Path.HORIZ_LINE_TO_REL, TP.ac('h', 1),
        TP.gui.Path.VERT_LINE_TO_REL, TP.ac('v', 1),
        TP.gui.Path.CURVE_TO_REL, TP.ac('c', 6),
        TP.gui.Path.SMOOTH_CURVE_TO_REL, TP.ac('s', 4),
        TP.gui.Path.QUAD_CURVE_TO_REL, TP.ac('q', 4),
        TP.gui.Path.QUAD_SMOOTH_CURVE_TO_REL, TP.ac('t', 2),
        TP.gui.Path.ARC_TO_REL, TP.ac('a', 7),
        TP.gui.Path.CLOSE_PATH_REL, TP.ac('z', 0)
        ));

//  ------------------------------------------------------------------------

TP.gui.SVGPath.Type.defineConstant('PATH_SPLITUP_REGEX',
        TP.rc('([A-Za-z])|(\\d+(\\.\\d+)?)|(\\.\\d+)|(-\\d+(\\.\\d+)?)|(-\\.\\d+)',
    'g'));

//  ------------------------------------------------------------------------

TP.gui.SVGPath.Type.defineConstant('PATH_PARSER',
function(aString) {

    /**
     * @method PATH_PARSER
     * @summary Converts a String containing a path description to a
     *     TP.gui.Path object.
     * @param {The} aString String definition to use to build a TP.gui.Path
     *     object from.
     * @returns {TP.gui.SVGPath} A TP.gui.Path expressing the supplied
     *     transformation.
     */

    var newPath,

        pathParts,
        operatorMatcher,

        i,

        operator,
        operatorArray,

        newObj;

    newPath = TP.ac();

    pathParts = TP.gui.SVGPath.at('PATH_SPLITUP_REGEX').match(aString);

    operatorMatcher = TP.rc('[MLHVCSQTAZ]', 'i');

    for (i = 0; i < pathParts.getSize(); i++) {
        if (operatorMatcher.test(pathParts.at(i))) {
            operator = pathParts.at(i);

            newPath.push(operator);
            i++;

            operatorArray = TP.ac();
            while (i < pathParts.getSize()) {
                if (operatorMatcher.test(pathParts.at(i))) {
                    i--;
                    break;
                }

                operatorArray.push(parseFloat(pathParts.at(i)));
                i++;
            }

            newPath.push(operatorArray);
        }
    }

    if (TP.notEmpty(newPath)) {
        newObj = this.construct();
        newObj.set('pathSegments', newPath);

        return newObj;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.gui.SVGPath.addParser(TP.gui.SVGPath.PATH_PARSER);

//  ------------------------------------------------------------------------
//  Type Methods.
//  ------------------------------------------------------------------------

TP.gui.SVGPath.Type.defineMethod('elementGetBoundingBox',
function(anElement) {

    /**
     * @method elementGetBoundingBox
     * @summary Returns the rectangle that completely encloses the shape.
     * @param {Element} anElement An SVG 'path' element to return the bounding
     *     box rectangle for.
     * @returns {TP.gui.Rect} The rectangle that encloses the shape.
     */

    var pathStr,

        pathObj;

    if (TP.isEmpty(pathStr = anElement.getAttribute('d'))) {
        return TP.gui.Rect.construct(-1, -1, -1, -1);
    }

    if (TP.notValid(pathObj = TP.gui.SVGPath.from(pathStr))) {
        return TP.gui.Rect.construct(-1, -1, -1, -1);
    }

    return pathObj.getBoundingBox();
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.SVGPath.Inst.defineMethod('$updateBBoxData',
function(bboxData, x, y) {

    /**
     * @method $updateBBoxData
     * @summary Update
     * @returns {TP.gui.Path}
     */

    if (bboxData.left === TP.NOT_FOUND) {
        bboxData.top = y;
        bboxData.right = x;
        bboxData.left = x;
        bboxData.bottom = y;
    }

    if (bboxData.top > y) {
        bboxData.top = y;
    }

    if (bboxData.right < x) {
        bboxData.right = x;
    }

    if (bboxData.bottom < y) {
        bboxData.bottom = y;
    }

    if (bboxData.left > x) {
        bboxData.left = x;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.SVGPath.Inst.defineMethod('$updateBBoxFromSegment',
function(segmentOperator, segmentArgs, trackingPoint, trackingData) {

    /**
     * @method $updateBBox
     * @summary
     * @param {String} segmentOperator
     * @param {Array<Number|Boolean|Array|TP.gui.Point>} segmentArgs An Array of
     *     Numbers, Booleans, Arrays or TP.gui.Points that contain the segment
     *     arguments.
     * @param {TP.gui.Point} trackingPoint
     * @param {Array} trackingData
     * @returns {TP.gui.SVGPath}
     */

    var i,
        x,
        y,

        start;

    switch (segmentOperator) {
        case 'M':
        case 'L':
        case 'C':
        case 'S':
        case 'Q':
        case 'T':

            for (i = 0; i < segmentArgs.getSize(); i += 2) {
                this.$updateBBoxData(trackingData,
                                        segmentArgs.at(i),
                                        segmentArgs.at(i + 1));
            }

            trackingPoint.set('x', segmentArgs.at(i - 2));
            trackingPoint.set('y', segmentArgs.at(i - 1));
            trackingPoint.set('absolute', true);

            break;

        case 'H':

            for (i = 0; i < segmentArgs.getSize(); ++i) {
                this.$updateBBoxData(trackingData,
                                        segmentArgs.at(i),
                                        trackingPoint.get('y'));
            }

            trackingPoint.set('x', segmentArgs.at(i - 1));
            trackingPoint.set('absolute', true);

            break;

        case 'V':

            for (i = 0; i < segmentArgs.getSize(); ++i) {
                this.$updateBBoxData(trackingData,
                                        trackingPoint.get('x'),
                                        segmentArgs.at(i));
            }

            trackingPoint.set('y', segmentArgs.at(i - 1));
            trackingPoint.set('absolute', true);

            break;

        case 'A':

            for (i = 0; i < segmentArgs.getSize(); i += 7) {
                this.$updateBBoxData(trackingData,
                                        segmentArgs.at(i + 5),
                                        segmentArgs.at(i + 6));
            }

            trackingPoint.set('x', segmentArgs.at(i - 2));
            trackingPoint.set('y', segmentArgs.at(i - 1));
            trackingPoint.set('absolute', true);

            break;

        case 'm':

            if (trackingPoint.get('x') === TP.NOT_FOUND) {
                x = segmentArgs.at(0);
                y = segmentArgs.at(1);

                this.$updateBBoxData(trackingData, x, y);

                start = 2;
            } else {
                x = trackingPoint.get('x');
                y = trackingPoint.get('y');

                start = 0;
            }

            for (i = start; i < segmentArgs.getSize(); i += 2) {
                x = x + segmentArgs.at(i);
                y = y + segmentArgs.at(i + 1);

                this.$updateBBoxData(trackingData, x, y);
            }

            trackingPoint.set('x', x);
            trackingPoint.set('y', y);
            trackingPoint.set('absolute', false);

            break;

        case 'l':
        case 't':

            x = trackingPoint.get('x');
            y = trackingPoint.get('y');

            for (i = 0; i < segmentArgs.getSize(); i += 2) {
                x = x + segmentArgs.at(i);
                y = y + segmentArgs.at(i + 1);

                this.$updateBBoxData(trackingData, x, y);
            }

            trackingPoint.set('x', x);
            trackingPoint.set('y', y);
            trackingPoint.set('absolute', false);

            break;

        case 'h':

            x = trackingPoint.get('x');
            y = trackingPoint.get('y');

            for (i = 0; i < segmentArgs.getSize(); ++i) {
                x = x + segmentArgs.at(i);

                this.$updateBBoxData(trackingData, x, y);
            }

            trackingPoint.set('x', x);
            trackingPoint.set('absolute', false);

            break;

        case 'v':

            x = trackingPoint.get('x');
            y = trackingPoint.get('y');

            for (i = 0; i < segmentArgs.getSize(); ++i) {
                y = y + segmentArgs.at(i);

                this.$updateBBoxData(trackingData, x, y);
            }

            trackingPoint.set('y', y);
            trackingPoint.set('absolute', false);

            break;

        case 'c':

            x = trackingPoint.get('x');
            y = trackingPoint.get('y');

            for (i = 0; i < segmentArgs.getSize(); i += 6) {
                this.$updateBBoxData(trackingData,
                                        x + segmentArgs.at(i),
                                        y + segmentArgs.at(i + 1));

                this.$updateBBoxData(trackingData,
                                        x + segmentArgs.at(i + 2),
                                        y + segmentArgs.at(i + 3));

                //  We only accumulate the third point.
                x = x + segmentArgs.at(i + 4);
                y = y + segmentArgs.at(i + 5);

                this.$updateBBoxData(trackingData, x, y);
            }

            trackingPoint.set('x', x);
            trackingPoint.set('y', y);
            trackingPoint.set('absolute', false);

            break;

        case 's':
        case 'q':

            x = trackingPoint.get('x');
            y = trackingPoint.get('y');

            for (i = 0; i < segmentArgs.getSize(); i += 4) {
                this.$updateBBoxData(trackingData,
                                        x + segmentArgs.at(i),
                                        y + segmentArgs.at(i + 1));

                //  We only accumulate the second point.
                x = x + segmentArgs.at(i + 2);
                y = y + segmentArgs.at(i + 3);

                this.$updateBBoxData(trackingData, x, y);
            }

            trackingPoint.set('x', x);
            trackingPoint.set('y', y);
            trackingPoint.set('absolute', false);

            break;

        case 'a':

            x = trackingPoint.get('x');
            y = trackingPoint.get('y');

            for (i = 0; i < segmentArgs.getSize(); i += 7) {
                x = x + segmentArgs.at(i + 5);
                y = y + segmentArgs.at(i + 6);

                this.$updateBBoxData(trackingData, x, y);
            }

            trackingPoint.set('x', x);
            trackingPoint.set('y', y);
            trackingPoint.set('absolute', false);

            break;

        default:
            break;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.SVGPath.Inst.defineMethod('getBoundingBox',
function() {

    /**
     * @method getBoundingBox
     * @summary Returns the rectangle that completely encloses the shape.
     * @param {Element} anElement An SVG 'path' element to return the bounding
     *     box rectangle for.
     * @returns {TP.gui.Rect} The rectangle that encloses the shape.
     */

    var pathParts,

        trackingPoint,
        trackingData,

        i;

    pathParts = this.get('pathSegments');

    trackingPoint = TP.pc(-1, -1);
    trackingPoint.defineAttribute('absolute', false);

    trackingData = {
        top: -1,
        right: -1,
        bottom: -1,
        left: -1
    };

    //  Note here the increment of the path by 2, processing each
    //  operator/operand pair.
    for (i = 0; i < pathParts.getSize(); i += 2) {
        this.$updateBBoxFromSegment(pathParts.at(i),
                                    pathParts.at(i + 1),
                                    trackingPoint,
                                    trackingData);
    }

    return TP.gui.Rect.construct(
                            trackingData.left,
                            trackingData.top,
                            trackingData.right - trackingData.left,
                            trackingData.bottom - trackingData.top);
});

//  ========================================================================
//  TP.gui.Transition
//  ========================================================================

/**
 * @type {TP.gui.Transition}
 * @summary The common supertype for transition types in TIBET, providing
 *     (mostly abstract) methods for use in subtypes.
 */

//  ------------------------------------------------------------------------

TP.gui.GraphicData.defineSubtype('gui.Transition');

//  This is an abstract type.
TP.gui.Transition.isAbstract(true);

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.gui.Transition.Inst.defineAttribute('transitionJob');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.Transition.Inst.defineMethod('init',
function(controlParams, stepParams) {

    /**
     * @method init
     * @summary Initialize the instance.
     * @description Parameters supplied in the controlParams TP.core.Hash for
     *     this method override any setting for the receiving transition. If a
     *     parameter value isn't supplied for a particular parameter, the
     *     receiving transition type will be queried via a 'get*()' method (i.e.
     *     get('limit'), get('count'), etc.) for a 'built-in' value. Note that
     *     the step params TP.core.Hash is optional and may not be available,
     *     especially if this job is meant to be invoked repeatedly.
     * @param {TP.core.Hash} controlParams A TP.core.Hash of the following job
     *     control parameters: delay, interval, limit, count, compute, freeze.
     * @param {TP.core.Hash} stepParams A TP.core.Hash of the following job step
     *     parameters: target, property.
     * @returns {TP.gui.Transition} A new instance.
     */

    var transitionJob;

    //  If we're part of a multi-transition, we may not be handed a 'control
    //  parameters' hash - unless we're the multi-transition itself ;-).
    if (TP.notValid(controlParams)) {
        return this;
    }

    //  Make sure that we created a valid TP.core.Job
    if (TP.notValid(transitionJob =
                    this.constructJob(controlParams, stepParams))) {
        return null;
    }

    this.set('transitionJob', transitionJob);

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Transition.Inst.defineMethod('clearValues',
function(params) {

    /**
     * @method clearValues
     * @summary Clears the values for the targets given the property name.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @returns {TP.gui.Transition} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Transition.Inst.defineMethod('configure',
function(job, params) {

    /**
     * @method configure
     * @summary Configures the transition, based on what this particular type
     *     of transition is trying to accomplish.
     * @description Note that the 'job' parameter supplied here points to the
     *     same instance as our 'job' instance variable, but this method is used
     *     by the job control system, so our method signature must match.
     * @param {TP.core.Job} job The job object that is currently processing this
     *     configure method.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @returns {Boolean} Whether or not this method configured the transition
     *     successfully.
     */

    TP.override();

    return false;
});

//  ------------------------------------------------------------------------

TP.gui.Transition.Inst.defineMethod('constructJob',
function(controlParams, stepParams) {

    /**
     * @method constructJob
     * @summary Constructs a TP.core.Job to execute the receiving transition
     *     type.
     * @description Parameters supplied in the controlParams TP.core.Hash for
     *     this method override any setting for the receiving transition. If a
     *     parameter value isn't supplied for a particular parameter, the
     *     receiving transition type will be queried via a 'get*()' method (i.e.
     *     get('limit'), get('count'), etc.) for a 'built-in' value. Note that
     *     the step params TP.core.Hash is optional and may not be available,
     *     especially if this job is meant to be invoked repeatedly.
     * @param {TP.core.Hash} controlParams A TP.core.Hash of the following job
     *     control parameters: delay, interval, limit, count, compute, freeze.
     * @param {TP.core.Hash} stepParams A TP.core.Hash of the following job step
     *     parameters: target, property.
     * @returns {TP.core.JobStatus} The job or job group that was constructed to
     *     service the effect.
     */

    var ctrlParams,
        jobCtrlParams,
        thisref,
        transitionJob,
        param,
        oldPre,
        oldPost;

    ctrlParams = controlParams;
    if (TP.notValid(ctrlParams)) {
        ctrlParams = TP.hc();
    }

    //  Some of these parameters (delay, interval, limit, count & compute)
    //  might exist on the supplied hash, but if they do not, we ask ourself
    //  to see if we have default values for our particular kind of
    //  transition.

    //  NB: We purposely leave out: 'lastInterval', 'stats', 'freeze',
    //  'preserve' and 'restore' - they are handled below.
    jobCtrlParams = TP.hc(
        'config', this.configure.bind(this),
        'pre', ctrlParams.at('pre'),
        'step', this.step.bind(this),
        'post', ctrlParams.at('post')
    );

    param = ctrlParams.at('compute');
    if (TP.notValid(param)) {
        param = this.get('computeFunction');
    }
    jobCtrlParams.atPut('compute', param);

    thisref = this;
    ['delay', 'interval', 'limit', 'count', 'isAnimation'].forEach(
    function(key) {
        var val;

        val = ctrlParams.at(key);
        if (TP.notValid(val)) {
            val = thisref.get(key);
        }
        jobCtrlParams.atPut(key, val);
    });

    //  Construct a job using those control parameters.
    transitionJob = TP.core.Job.construct(jobCtrlParams);

    if (TP.notValid(transitionJob)) {
        return null;
    }

    //  If we are 'preserving' or 'restoring' values on the target elements,
    //  then we register pre and/or post functions with the job that will
    //  call upon the transition to preserve (or restore) property values
    //  before (or after) it ends.

    if (TP.isTrue(ctrlParams.at('preserve'))) {
        //  Capture any previously set 'pre' function on the job - we'll
        //  call it inside of our 'pre'.
        oldPre = transitionJob.get('pre');

        transitionJob.set(
            'pre',
            function(job, params) {

                this.preserveValues(params);

                //  Run any existing 'pre' function that was defined as part
                //  of our parameters.
                if (TP.isCallable(oldPre)) {
                    oldPre(job, params);
                }
            }.bind(this));
    }

    if (TP.isTrue(ctrlParams.at('restore'))) {
        //  Capture any previously set 'post' function on the job - we'll
        //  call it inside of our 'post'.
        oldPost = transitionJob.get('post');

        transitionJob.set(
            'post',
            function(job, params) {

                //  Run any existing 'post' function that was defined as
                //  part of our parameters.
                if (TP.isCallable(oldPost)) {
                    oldPost(job, params);
                }

                this.restoreValues(params);

            }.bind(this));
    } else if (TP.notTrue(ctrlParams.at('freeze'))) {
        //  If 'restore' wasn't true and 'freeze' wasn't true, then we call
        //  upon the transition to clear any property values that it set.

        //  Capture any previously set 'post' function on the job - we'll
        //  call it inside of our 'post'.
        oldPost = transitionJob.get('post');

        transitionJob.set(
            'post',
            function(job, params) {

                //  Run any existing 'post' function that was defined as
                //  part of our parameters.
                if (TP.isCallable(oldPost)) {
                    oldPost(job, params);
                }

                this.clearValues(params);

            }.bind(this));
    }

    return transitionJob;
});

//  ------------------------------------------------------------------------

TP.gui.Transition.Inst.defineMethod('constructJobGroup',
function() {

    /**
     * @method constructJobGroup
     * @summary Constructs a TP.core.JobGroup and adds any objects that were
     *     handed in (and that should conform to the TP.core.JobStatus
     *     specification which means that they could be TP.core.Jobs or other
     *     TP.core.JobGroups) as children to the new TP.core.JobGroup.
     * @param {arguments} varargs One or more objects to add as child objects to
     *     the constructed job group.
     * @returns {TP.core.JobGroup} The newly constructed job group.
     */

    var transitionJobGroup,
        args;

    if (TP.notValid(transitionJobGroup = TP.core.JobGroup.construct())) {
        //  No valid job group? Can't go on.
        //  TODO: Raise an exception.
        return null;
    }

    //  Construct a regular Array from the 'arguments' object.
    args = TP.args(arguments);

    args.perform(
        function(aJob) {
            transitionJobGroup.addChild(aJob);
        });

    return transitionJobGroup;
});

//  ------------------------------------------------------------------------

TP.gui.Transition.Inst.defineMethod('getComputeFunction',
function() {

    /**
     * @method getComputeFunction
     * @summary Returns the default compute Function for the receiving
     *     transition type.
     * @returns {Function} The default compute Function for this type.
     */

    //  At this level, this defaults to the simple
    //  TP.core.Job.LINEAR_COMPUTE.
    return TP.core.Job.LINEAR_COMPUTE;
});

//  ------------------------------------------------------------------------

TP.gui.Transition.Inst.defineMethod('getCount',
function() {

    /**
     * @method getCount
     * @summary Returns the default number of times that the transition should
     *     execute for this transition type.
     * @returns {Number} The default number of times the transition should
     *     execute.
     */

    //  By returning null here, we allow the job that will run this
    //  transition to default.

    return null;
});

//  ------------------------------------------------------------------------

TP.gui.Transition.Inst.defineMethod('getDelay',
function() {

    /**
     * @method getDelay
     * @summary Returns the default delay to begin executing the transition in
     *     either Number, String or Duration or a Function to compute the delay.
     *     Depending on type, the delay will be computed thusly: Number The
     *     number of milliseconds to delay String The number of milliseconds to
     *     delay or a Duration Function A function returning the number of
     *     milliseconds to delay.
     * @returns {Number|String|Duration|Function} The delay as expressed above.
     */

    //  By returning null here, we allow the job that will run this
    //  transition to default.

    return null;
});

//  ------------------------------------------------------------------------

TP.gui.Transition.Inst.defineMethod('getInterval',
function() {

    /**
     * @method getInterval
     * @summary Returns the default interval which determines the millisecond
     *     interval between iterations of the receiver's 'stepping' function.
     * @returns {Number} The number of milliseconds between iterations of the
     *     receiver's 'step' function.
     */

    //  By returning null here, we allow the job that will run this
    //  transition to default.

    return null;
});

//  ------------------------------------------------------------------------

TP.gui.Transition.Inst.defineMethod('getLimit',
function() {

    /**
     * @method getLimit
     * @summary Returns the default limit which determines how long the
     *     receiving transition should execute using either Number, String or
     *     Duration or a Function to compute the limit. Depending on type, the
     *     limit will be computed thusly: Number The number of steps to execute
     *     before stopping. String The number of milliseconds or a Duration to
     *     execute before stopping Function A function returning true if the
     *     transition should stop.
     * @returns {Number|String|Duration|Function} The limit as expressed above.
     */

    //  We return 1 second as a String representation of milliseconds.
    return '1000';
});

//  ------------------------------------------------------------------------

TP.gui.Transition.Inst.defineMethod('preserveValues',
function(params) {

    /**
     * @method preserveValues
     * @summary Preserves the values for the targets given the property name.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @returns {TP.gui.Transition} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Transition.Inst.defineMethod('reset',
function() {

    /**
     * @method reset
     * @summary Resets the effect so that it can be executed again.
     * @returns {TP.gui.Transition} The receiver.
     */

    //  At this level, we just reset our job.
    this.get('transitionJob').reset();

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Transition.Inst.defineMethod('restoreValues',
function(params) {

    /**
     * @method restoreValues
     * @summary Restores the values for the targets given the property name.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @returns {TP.gui.Transition} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.Transition.Inst.defineMethod('start',
function(params) {

    /**
     * @method start
     * @summary Executes the transition against the supplied element.
     * @param {TP.core.Hash} params A TP.core.Hash of the following stepping
     *     parameters: target.
     * @returns {TP.core.JobStatus|undefined} The job or job group that was
     *     forked to service the transition.
     */

    var transitionJob;

    if (TP.notValid(transitionJob = this.get('transitionJob'))) {
        //  No valid job? Can't go on. We may be part of a multi-transition.
        return;
    }

    if (TP.isValid(params)) {
        //  We can't proceed without a target element.
        if (TP.notValid(params.at('target'))) {
            return;
        }

        transitionJob.set('parameters', params);
    }

    transitionJob.start();

    return transitionJob;
});

//  ------------------------------------------------------------------------

TP.gui.Transition.Inst.defineMethod('step',
function(job, params) {

    /**
     * @method step
     * @summary Changes some aspect of the target given when this transition
     *     was executed via the 'start()' method.
     * @description Note that the 'job' parameter supplied here points to the
     *     same instance as our 'job' instance variable, but this method is used
     *     by the job control system, so our method signature must match.
     * @param {TP.core.Job} job The job object that is currently processing this
     *     step method.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @returns {Boolean} Whether or not the 'step' processed successfully.
     */

    TP.override();

    return false;
});

//  ========================================================================
//  TP.gui.MultiTransition
//  ========================================================================

/**
 * @type {TP.gui.MultiTransition}
 */

//  ------------------------------------------------------------------------

TP.gui.Transition.defineSubtype('MultiTransition');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.gui.MultiTransition.Inst.defineAttribute('transitionEntries');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.MultiTransition.Inst.defineMethod('init',
function(controlParams, stepParams) {

    /**
     * @method init
     * @summary Initialize the instance.
     * @description Parameters supplied in the controlParams TP.core.Hash for
     *     this method override any setting for the receiving transition. If a
     *     parameter value isn't supplied for a particular parameter, the
     *     receiving transition type will be queried via a 'get*()' method (i.e.
     *     get('limit'), get('count'), etc.) for a 'built-in' value. Note that
     *     the step params TP.core.Hash is optional and may not be available,
     *     especially if this job is meant to be invoked repeatedly.
     * @param {TP.core.Hash} controlParams A TP.core.Hash of the following job
     *     control parameters: delay, interval, limit, count, compute, freeze.
     * @param {TP.core.Hash} stepParams A TP.core.Hash of the following job step
     *     parameters: target, property.
     * @returns {TP.gui.MultiTransition} A new instance.
     */

    this.callNextMethod();

    this.set('transitionEntries', TP.ac());

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.MultiTransition.Inst.defineMethod('addTransitionEntry',
function(transitionEntry) {

    /**
     * @method addTransitionEntry
     * @summary Adds the supplied transition entry to the receiver.
     * @param {TP.core.Hash} aTransitionEntry The transition entry to add to the
     *     list of the receiver's transitions.
     * @returns {TP.gui.MultiTransition} A new instance.
     */

    var transitionType;

    if (TP.isType(transitionType = transitionEntry.at('transition'))) {
        //  Construct an instance of the transition and register it under
        //  'transitionInst' in the transition entry.
        transitionEntry.atPut('transitionInst', transitionType.construct());

        //  Capture the parameters 'as supplied at entry addition time' so
        //  that in case we run the job over and over, we can copy these and
        //  supply them to the job as if its running for the first time.
        transitionEntry.atPut('origParams',
                                transitionEntry.at('params').copy());

        this.get('transitionEntries').add(transitionEntry);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.MultiTransition.Inst.defineMethod('clearValues',
function(params) {

    /**
     * @method clearValues
     * @summary Clears the values for the targets given the property name.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @returns {TP.gui.MultiTransition} The receiver.
     */

    var transitionEntries,
        i,

        transitionEntry,
        transitionParams;

    //  Loop over each entry, and execute its 'clearValues' method.

    transitionEntries = this.get('transitionEntries');
    for (i = 0; i < transitionEntries.getSize(); i++) {
        //  Each transition entry contains:
        //      'params'
        //      'compute'
        //      'transition'

        transitionEntry = transitionEntries.at(i);

        //  Each 'params' hash contains individual values for:
        //      'from'
        //      'to'
        //      'delta'
        //      'target'
        transitionParams = transitionEntry.at('params');

        transitionEntry.at('transitionInst').clearValues(transitionParams);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.MultiTransition.Inst.defineMethod('configure',
function(job, params) {

    /**
     * @method configure
     * @summary Configures the transition, based on what this particular type
     *     of transition is trying to accomplish.
     * @description Note that the 'job' parameter supplied here points to the
     *     same instance as our 'job' instance variable, but this method is used
     *     by the job control system, so our method signature must match.
     * @param {TP.core.Job} job The job object that is currently processing this
     *     step method.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @returns {Boolean} Whether or not this method configured the transition
     *     successfully.
     */

    var transitionEntries,
        i,
        transitionEntry,
        transitionParams,

        fromVal,
        toVal;

    transitionEntries = this.get('transitionEntries');
    for (i = 0; i < transitionEntries.getSize(); i++) {
        transitionEntry = transitionEntries.at(i);

        //  Make a copy of the original parameters as they were when this
        //  transition was added to the multi-transition and make it the
        //  transition parameters for this transition.
        transitionParams = transitionEntry.at('origParams').copy();
        transitionEntry.atPut('params', transitionParams);

        transitionEntry.at('transitionInst').configure(
                                                job, transitionParams);

        //  To simulate the population of missing parameters, we populate
        //  the 'delta' property on the transitionEntry parameters.
        if (TP.isNumber(fromVal = transitionParams.at('from')) &&
            TP.isNumber(toVal = transitionParams.at('to'))) {
            transitionParams.atPut('delta', toVal - fromVal);
        }

        //  And populate the compute function on the transition entry
        //  itself.
        if (TP.notValid(transitionEntry.at('compute'))) {
            transitionEntry.atPut(
                'compute',
                transitionEntry.at(
                            'transitionInst').get('computeFunction'));
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.MultiTransition.Inst.defineMethod('preserveValues',
function(params) {

    /**
     * @method preserveValues
     * @summary Preserves the values for the targets given the property name.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @returns {TP.gui.MultiTransition} The receiver.
     */

    var transitionEntries,
        i,

        transitionEntry,
        transitionParams;

    //  Loop over each entry, and execute its 'preserveValues' method.

    transitionEntries = this.get('transitionEntries');
    for (i = 0; i < transitionEntries.getSize(); i++) {
        //  Each transition entry contains:
        //      'params'
        //      'compute'
        //      'transition'

        transitionEntry = transitionEntries.at(i);

        //  Each 'params' hash contains individual values for:
        //      'from'
        //      'to'
        //      'delta'
        //      'target'
        transitionParams = transitionEntry.at('params');

        transitionEntry.at('transitionInst').preserveValues(
                                                    transitionParams);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.MultiTransition.Inst.defineMethod('restoreValues',
function(params) {

    /**
     * @method restoreValues
     * @summary Restores the values for the targets given the property name.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @returns {TP.gui.MultiTransition} The receiver.
     */

    var transitionEntries,
        i,

        transitionEntry,
        transitionParams;

    //  Loop over each entry, and execute its 'restoreValues' method.

    transitionEntries = this.get('transitionEntries');
    for (i = 0; i < transitionEntries.getSize(); i++) {
        //  Each transition entry contains:
        //      'params'
        //      'compute'
        //      'transition'

        transitionEntry = transitionEntries.at(i);

        //  Each 'params' hash contains individual values for:
        //      'from'
        //      'to'
        //      'delta'
        //      'target'
        transitionParams = transitionEntry.at('params');

        transitionEntry.at('transitionInst').restoreValues(
                                                    transitionParams);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.MultiTransition.Inst.defineMethod('step',
function(job, params) {

    /**
     * @method step
     * @summary Changes the clipping rect of the target element given when this
     *     transition was executed via the 'start()' method.
     * @description Note that the 'job' parameter supplied here points to the
     *     same instance as our 'job' instance variable, but this method is used
     *     by the job control system, so our method signature must match.
     * @param {TP.core.Job} job The job object that is currently processing this
     *     step method.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @returns {Boolean} Whether or not the 'step' processed successfully.
     */

    var transitionEntry,

        transitionEntries,
        i,
        transitionParams;

    transitionEntry = null;

    //  Set up a locally programmed version of 'getStepValue()' on the job
    //  instance we were supplied. This utilizes a closured variable,
    //  'transitionEntry', which is advanced to each entry in our list of
    //  transitions as we loop and execute each one. Note here how we are
    //  emulating the behavior of the instance-level method version of
    //  'getStepValue()' by accepting parameters and then defaulting them
    //  *to the entry's parameters* if they weren't supplied as a parameter
    //  to the method..
    job.defineMethod(
        'getStepValue',
        function(stepParams) {

            var newParams;

            newParams = TP.isValid(stepParams) ?
                                    stepParams :
                                    transitionEntry.at('params');

            return transitionEntry.at('compute')(this, newParams);
        });

    //  Loop over each entry, and execute its 'step' method.

    transitionEntries = this.get('transitionEntries');
    for (i = 0; i < transitionEntries.getSize(); i++) {
        //  Each transition entry contains:
        //      'params'
        //      'compute'
        //      'transition'

        transitionEntry = transitionEntries.at(i);

        //  Each 'params' hash contains individual values for:
        //      'from'
        //      'to'
        //      'delta'
        //      'target'
        transitionParams = transitionEntry.at('params');

        transitionEntry.at('transitionInst').step(job, transitionParams);
    }

    return true;
});

//  ========================================================================
//  TP.gui.ObjectPropertyTransition
//  ========================================================================

/**
 * @type {TP.gui.ObjectPropertyTransition}
 * @summary A subtype of TP.gui.Transition that supplies some common methods
 *     for transitioning object properties.
 */

//  ------------------------------------------------------------------------

TP.gui.Transition.defineSubtype('ObjectPropertyTransition');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.gui.ObjectPropertyTransition.Type.defineMethod('transition',
function(aTarget, propertyName, aTransitionParams) {

    /**
     * @method transition
     * @summary A convenience wrapper for invoking this type of
     *     TP.gui.Transition to do a 'simple transition'.
     * @param {Element|Element[]} aTarget The target or targets to transition.
     * @param {String} propertyName The name of the property to transition.
     * @param {TP.core.Hash} aTransitionParams A hash of parameters to use for
     *     the transition.
     * @exception TP.sig.InvalidObject
     * @exception TP.sig.InvalidParameter
     * @returns {TP.core.Job} The TP.core.Job object that is managing the
     *     transition.
     */

    var targets,

        transitionParams,

        origins,
        sig,

        limit,

        computeFunc,

        controlParams,
        stepParams,

        valuesArr,

        aTransition,
        transitionJob,

        oldPost;

    if (TP.notValid(propertyName)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  If its an Array, then we already have what we need. Otherwise, we
    //  assume its a single target element and wrap it into an Array.
    if (!TP.isArray(aTarget)) {
        if (!TP.isElement(aTarget)) {
            return this.raise('TP.sig.InvalidObject');
        }

        targets = TP.ac(aTarget);
    } else {
        targets = aTarget;
    }

    transitionParams = aTransitionParams;
    if (TP.notValid(transitionParams)) {
        transitionParams = TP.hc();
    }

    //  If the transition params haven't specified any target origins, then
    //  compute some.
    if (TP.notValid(origins = transitionParams.at('targetOrigins'))) {
        origins = targets.collect(
                            function(target) {

                                return TP.gid(target);
                            });
        origins.isOriginSet(true);
    }

    sig = origins.signal('TP.sig.PropertyWillTransition',
                            transitionParams,
                            transitionParams.atIfInvalid('signalPolicy',
                                                            TP.FIRE_ONE));

    if (sig.shouldPrevent()) {
        return this;
    }

    //  Grab the compute function and, if its valid, it should be a property
    //  on TP.core.Job.
    if (TP.isCallable(computeFunc = transitionParams.at('compute'))) {
        computeFunc = TP.core.Job[computeFunc];
    } else {
        computeFunc = null;
    }

    //  If no limit was supplied, then go forever. We set limit to
    //  TP.core.Job.FOREVER which will cause the underlying 'job'
    //  functionality to never quit until its terminated.
    if (TP.notValid(limit = transitionParams.at('limit'))) {
        limit = TP.core.Job.FOREVER;
    } else if (TP.isString(limit) && !limit.startsWith('PT')) {
        //  The user almost got it right - xs:duration types should begin
        //  with 'PT'
        limit = 'PT' + limit;
    }

    //  Set up the control parameters.

    //  NB: We purposely leave out:
    //      'config', 'step', 'lastInterval', 'stats'
    controlParams = TP.hc('pre', transitionParams.at('pre'),
                            'post', transitionParams.at('post'),
                            'compute', computeFunc,
                            'delay', transitionParams.at('delay'),
                            'interval', transitionParams.at('interval'),
                            'limit', limit,
                            'count', transitionParams.at('count'),
                            'freeze', transitionParams.at('freeze'),
                            'preserve', transitionParams.at('preserve'),
                            'restore', transitionParams.at('restore'));

    //  We just copy these slots over...

    //  Set up the step parameters: target, property
    stepParams = TP.hc('target', targets,
                        'property', propertyName);

    //  If the user supplied 'values', split them along a space (' ') into
    //  an Array.
    if (TP.isArray(valuesArr = transitionParams.at('values'))) {
        if (TP.isString(valuesArr)) {
            valuesArr = valuesArr.split(' ');
        }
    } else {
        valuesArr = null;
    }

    //  If there was a valid 'values' Array, it takes precedence over any
    //  'from', 'to' or 'by' values.
    if (TP.isArray(valuesArr)) {
        stepParams.atPut('values', valuesArr);
    } else {
        stepParams.atPut('from', transitionParams.at('from'));
        stepParams.atPut('to', transitionParams.at('to'));
        stepParams.atPut('by', transitionParams.at('by'));
    }

    //  We sneak the property onto the control params so that abstract
    //  subtypes that need to look up concrete types (like
    //  TP.gui.CSSPropertyTransition), can use it.
    controlParams.atPut('property', propertyName);

    //  All the configuration is over. Set up the transition.
    aTransition = this.construct(controlParams);

    transitionJob = aTransition.get('transitionJob');

    //  We need a 'post' function that will remove our 'job slot'

    //  Capture any previously set 'post' function on the job - we'll
    //  call them when our 'post' finishes.
    oldPost = transitionJob.get('post');

    transitionJob.set(
        'post',
        function(job, params) {

            var theTargets,
                theProperty;

            //  Note here how we grab both the target elements and the
            //  property from the supplied job. This is to avoid closure
            //  problems with previous invocations of this method.
            if (TP.isEmpty(theTargets = params.at('target'))) {
                return;
            }

            //  Note here how we grab the property from the job. This is
            //  to avoid closure problems with previous invocations of
            //  this method.
            if (TP.isEmpty(theProperty = params.at('property'))) {
                return;
            }

            theTargets.perform(
                function(target) {

                    //  Clear the slot that we put on the element that
                    //  contained a reference to our job for tracking
                    //  purposes in case other animations get fired up
                    //  in the middle of this one and want to take over.
                    if (TP.isValid(target['transition_' + theProperty])) {
                        target['transition_' + theProperty] = null;
                    }
                });

            //  Run any existing 'post' function that was defined as
            //  part of our parameters.
            if (TP.isCallable(oldPost)) {
                oldPost(job, params);
            }

            origins.signal('TP.sig.PropertyDidTransition',
                            transitionParams);
        });

    //  Instrument the individual elements that we are touching with the
    //  job. These will allow the deactivation routine below to prematurely
    //  terminate the job if another call to this method is called on the
    //  same element.

    targets.perform(
        function(target) {

            var prevJob,

                params,
                allElems,
                i;

            //  If the target element already had a job running that was
            //  animating that property, shut it down.

            //  If the element has a TP.core.Job registered under a slot
            //  named 'transition_' + the property being animated and that
            //  TP.core.Job hasn't already finished (or been told to finish
            //  by 'shutting down' another element sharing the job), then we
            //  begin the process to shut down the job.
            if (TP.isValid(
                        prevJob = target['transition_' + propertyName]) &&
                !prevJob.didComplete()) {
                //  If the job has elements that it is animating and there
                //  is more than 1 element in that set, then we're not the
                //  only one, so we just remove ourself from the list of
                //  elements.
                if (TP.isValid(params = prevJob.$get('parameters')) &&
                    TP.isArray(allElems = params.at('target')) &&
                    allElems.length > 1) {
                    for (i = 0; i < allElems.length; i++) {
                        if (allElems[i] === target) {
                            //  Remove the element from the job's 'target'
                            //  Array so that this property is no longer
                            //  animated by that job.
                            allElems.splice(i, 1);
                            break;
                        }
                    }
                } else {
                    //  Otherwise, we're the only element left in the job so
                    //  we try to shut the job down as cleanly as possible.
                    prevJob.shutdown();
                }
            }

            //  Cache the new animation job on the element, so that it can
            //  be shutdown in the future if necessary.
            target['transition_' + propertyName] = transitionJob;
        });

    //  Do the deed.
    aTransition.start(stepParams);

    return transitionJob;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.ObjectPropertyTransition.Inst.defineMethod('configure',
function(job, params) {

    /**
     * @method configure
     * @summary Configures the transition, based on what this particular type
     *     of transition is trying to accomplish.
     * @description Note that the 'job' parameter supplied here points to the
     *     same instance as our 'job' instance variable, but this method is used
     *     by the job control system, so our method signature must match.
     * @param {TP.core.Job} job The job object that is currently processing this
     *     configure method.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @returns {Boolean} Whether or not this method configured the transition
     *     successfully.
     */

    var property,
        target,

        from,
        to,
        by,

        fromAsNumber,
        toAsNumber,
        byAsNumber;

    property = params.at('property');

    //  We can't proceed without a style property.
    if (TP.isEmpty(property)) {
        return false;
    }

    target = params.at('target');

    //  We can't proceed without a target.
    if (TP.notValid(target)) {
        return false;
    }

    //  Note that the contents of 'target' could also be an Array of
    //  targets to be animated all at once. In this case, all computations
    //  below are done using the first target in this array.
    if (TP.isArray(target)) {
        target = target.first();
    }

    //  If we're animating across a set of values, then we're good to go. We
    //  assume that the caller has provided all the information necessary.
    if (TP.isArray(params.at('values'))) {
        return true;
    }

    //  Otherwise, we're using a 'from...to...by' model, so go ahead and
    //  grab those values.

    //  If the 'from' value is empty, we weren't given a 'from' value, so we
    //  need to compute one. This call ensures that the return value is in
    //  pixels.
    if (TP.isEmpty(from = params.at('from'))) {
        from = target.get(property);
    }

    //  Make sure 'from' is a Number.
    fromAsNumber = from.asNumber();

    //  If the 'to' value is not empty, then we were supplied with the value
    //  that the animation will stop at.
    if (TP.notEmpty(to = params.at('to'))) {
        //  Make sure 'to' is a Number.
        toAsNumber = to.asNumber();
    } else if (TP.notEmpty(by = params.at('by'))) {
        //  Otherwise, we didn't have a 'to' value, but we did have a 'by'
        //  value, so we can compute a 'to' value from it by adding it to
        //  the 'from' value.

        //  Make sure 'by' is a Number.
        byAsNumber = by.asNumber();

        //  It's easy to compute 'to' now - its just 'from' plus 'by'
        toAsNumber = fromAsNumber + byAsNumber;
    } else {
        //  No 'to' or 'by' - can't proceed from here.
        //  TODO: Raise an exception
        return false;
    }

    //  Reset the 'from' and 'to' based on our computed values.
    params.atPut('from', fromAsNumber);
    params.atPut('to', toAsNumber);

    params.atPut('respondsToSet', TP.canInvoke(target, 'set'));

    return true;
});

//  ------------------------------------------------------------------------

TP.gui.ObjectPropertyTransition.Inst.defineMethod('step',
function(job, params) {

    /**
     * @method step
     * @summary Changes the attribute of the target element given when this
     *     transition was executed via the 'start()' method.
     * @description Note that the 'job' parameter supplied here points to the
     *     same instance as our 'job' instance variable, but this method is used
     *     by the job control system, so our method signature must match.
     * @param {TP.core.Job} job The job object that is currently processing this
     *     step method.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @returns {Boolean} Whether or not the 'step' processed successfully.
     */

    var property,

        target,

        stepval,

        len,
        i;

    property = params.at('property');

    //  We can't proceed without a style property.
    if (TP.isEmpty(property)) {
        return false;
    }

    target = params.at('target');

    //  We can't proceed without a target element.
    if (TP.notValid(target)) {
        return false;
    }

    stepval = job.getStepValue();

    //  Note that the contents of 'target' could also be an Array of
    //  targets to be transitioned all at once.
    if (TP.isArray(target)) {
        len = target.length;
        for (i = 0; i < len; i++) {
            if (TP.isTrue(params.at('respondsToSet'))) {
                target[i].set(property, stepval);
            } else {
                target[i][property] = stepval;
            }
        }
    } else {
        if (TP.isTrue(params.at('respondsToSet'))) {
            target.set(property, stepval);
        } else {
            target[property] = stepval;
        }
    }

    return true;
});

//  ========================================================================
//  TP.gui.AttributeTransition
//  ========================================================================

/**
 * @type {TP.gui.AttributeTransition}
 * @summary A subtype of TP.gui.ObjectPropertyTransition that supplies some
 *     common methods for transitioning element attributes.
 */

//  ------------------------------------------------------------------------

TP.gui.ObjectPropertyTransition.defineSubtype('AttributeTransition');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.AttributeTransition.Inst.defineMethod('configure',
function(job, params) {

    /**
     * @method configure
     * @summary Configures the transition, based on what this particular type
     *     of transition is trying to accomplish.
     * @description Note that the 'job' parameter supplied here points to the
     *     same instance as our 'job' instance variable, but this method is used
     *     by the job control system, so our method signature must match.
     * @param {TP.core.Job} job The job object that is currently processing this
     *     configure method.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @returns {Boolean} Whether or not this method configured the transition
     *     successfully.
     */

    var property,
        target,

        from,
        to,
        by,

        fromAsNumber,
        toAsNumber,
        byAsNumber;

    property = params.at('property');

    //  We can't proceed without a style property.
    if (TP.isEmpty(property)) {
        return false;
    }

    target = params.at('target');

    //  We can't proceed without a target.
    if (TP.notValid(target)) {
        return false;
    }

    //  Note that the contents of 'target' could also be an Array of
    //  targets to be animated all at once. In this case, all computations
    //  below are done using the first target in this array.
    if (TP.isArray(target)) {
        target = target.first();
    }

    //  If we're animating across a set of values, then we're good to go. We
    //  assume that the caller has provided all the information necessary.
    if (TP.isArray(params.at('values'))) {
        return true;
    }

    //  Otherwise, we're using a 'from...to...by' model, so go ahead and
    //  grab those values.

    //  If the 'from' value is empty, we weren't given a 'from' value, so we
    //  need to compute one. This call ensures that the return value is in
    //  pixels.
    if (TP.isEmpty(from = params.at('from'))) {
        from = TP.elementGetAttribute(target, property, true);
    }

    //  Make sure 'from' is a Number.
    fromAsNumber = from.asNumber();

    //  If the 'to' value is not empty, then we were supplied with the value
    //  that the animation will stop at.
    if (TP.notEmpty(to = params.at('to'))) {
        //  Make sure 'to' is a Number.
        toAsNumber = to.asNumber();
    } else if (TP.notEmpty(by = params.at('by'))) {
        //  Otherwise, we didn't have a 'to' value, but we did have a 'by'
        //  value, so we can compute a 'to' value from it by adding it to
        //  the 'from' value.

        //  Make sure 'by' is a Number.
        byAsNumber = by.asNumber();

        //  It's easy to compute 'to' now - its just 'from' plus 'by'
        toAsNumber = fromAsNumber + byAsNumber;
    } else {
        //  No 'to' or 'by' - can't proceed from here.
        //  TODO: Raise an exception
        return false;
    }

    //  Reset the 'from' and 'to' based on our computed values.
    params.atPut('from', fromAsNumber);
    params.atPut('to', toAsNumber);

    return true;
});

//  ------------------------------------------------------------------------

TP.gui.AttributeTransition.Inst.defineMethod('step',
function(job, params) {

    /**
     * @method step
     * @summary Changes the attribute of the target element given when this
     *     transition was executed via the 'start()' method.
     * @description Note that the 'job' parameter supplied here points to the
     *     same instance as our 'job' instance variable, but this method is used
     *     by the job control system, so our method signature must match.
     * @param {TP.core.Job} job The job object that is currently processing this
     *     step method.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @returns {Boolean} Whether or not the 'step' processed successfully.
     */

    var property,

        target,

        stepval,

        len,
        i;

    property = params.at('property');

    //  We can't proceed without a style property.
    if (TP.isEmpty(property)) {
        return false;
    }

    target = params.at('target');

    //  We can't proceed without a target element.
    if (TP.notValid(target)) {
        return false;
    }

    stepval = job.getStepValue();

    //  Note that the contents of 'target' could also be an Array of
    //  targets to be transitioned all at once.
    if (TP.isArray(target)) {
        len = target.length;
        for (i = 0; i < len; i++) {
            TP.elementSetAttribute(target[i], property, stepval, true);
        }
    } else {
        TP.elementSetAttribute(target[i], property, stepval, true);
    }

    return true;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETCSSTypes.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

//  ========================================================================
//  TP.gui.CSSPropertyTransition
//  ========================================================================

/**
 * @type {TP.gui.CSSPropertyTransition}
 * @summary A subtype (abstract) of TP.gui.ObjectPropertyTransition that
 *     supplies some common methods for animating CSS properties. This type can
 *     also capture the property name, a property prefix and a property suffix
 *     as instance variables.
 */

//  ------------------------------------------------------------------------

TP.gui.ObjectPropertyTransition.defineSubtype('CSSPropertyTransition');

//  This is an abstract type.
TP.gui.CSSPropertyTransition.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.gui.CSSPropertyTransition.Type.defineMethod('getConcreteType',
function(params) {

    /**
     * @method getConcreteType
     * @summary Returns the type to use for a particular transition.
     * @param {TP.core.Hash} params A TP.core.Hash of the following job control
     *     parameters: delay, interval, limit, count, compute, freeze.
     * @returns {TP.meta.core.CSSProperty} A TP.core.CSSProperty subtype type
     *     object.
     */

    var propertyName;

    propertyName = params.at('property');

    if (TP.CSS_COLOR_PROPERTIES.contains(propertyName)) {
        return TP.gui.CSSColorTransition;
    }

    if (TP.CSS_LENGTH_PROPERTIES.contains(propertyName)) {
        return TP.gui.CSSLengthTransition;
    }

    if (TP.CSS_UNITLESS_PROPERTIES.contains(propertyName)) {
        return TP.gui.CSSValueTransition;
    }

    return null;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.gui.CSSPropertyTransition.Inst.defineAttribute('styleProperty');

TP.gui.CSSPropertyTransition.Inst.defineAttribute('propPrefix');
TP.gui.CSSPropertyTransition.Inst.defineAttribute('propSuffix');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.CSSPropertyTransition.Inst.defineMethod('init',
function(controlParams, stepParams) {

    /**
     * @method init
     * @summary Initialize the instance.
     * @description Parameters supplied in the controlParams TP.core.Hash for
     *     this method override any setting for the receiving transition. If a
     *     parameter value isn't supplied for a particular parameter, the
     *     receiving transition type will be queried via a 'get*()' method (i.e.
     *     get('limit'), get('count'), etc.) for a 'built-in' value. Note that
     *     the step params TP.core.Hash is optional and may not be available,
     *     especially if this job is meant to be invoked repeatedly.
     * @param {TP.core.Hash} controlParams A TP.core.Hash of the following job
     *     control parameters: delay, interval, limit, count, compute, freeze.
     * @param {TP.core.Hash} stepParams A TP.core.Hash of the following job
     *     step parameters: target, property.
     * @returns {TP.gui.CSSPropertyTransition|undefined} A new instance.
     */


    var newInst;

    newInst = this.callNextMethod();

    //  If a TP.core.Job couldn't be constructed, we may have gotten here.
    if (TP.notValid(newInst)) {
        return;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.CSSPropertyTransition.Inst.defineMethod('clearValues',
function(params) {

    /**
     * @method clearValues
     * @summary Clears the values for the targets given the property name.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @returns {TP.gui.CSSPropertyTransition} The receiver.
     */

    /* eslint-disable no-unused-vars */

    var theTargets,
        styleProperty,

        dummyVal;

    if (TP.isEmpty(theTargets = params.at('target'))) {
        return this;
    }

    styleProperty = params.at('property');
    if (TP.notValid(styleProperty)) {
        styleProperty = this.get('styleProperty');
    }

    if (TP.isEmpty(styleProperty)) {
        return this;
    }

    //  NB: We assign to dummyVal below to ensure that the JS engine is forced
    //  to access (and assign) the value so that it can't optimize it away.

    if (TP.isArray(theTargets)) {
        theTargets.perform(
            function(aTarget) {
                TP.elementClearStyleProperty(aTarget, styleProperty);
            });

        //  Make sure that any drawing that needed to 'flush' to the window
        //  does so.
        dummyVal = TP.documentGetBody(TP.nodeGetDocument(
                                        theTargets.first())).offsetHeight;
    } else {
        TP.elementClearStyleProperty(theTargets, styleProperty);
        dummyVal = TP.documentGetBody(TP.nodeGetDocument(
                                        theTargets)).offsetHeight;
    }

    return this;

    /* eslint-enable no-unused-vars */
});

//  ------------------------------------------------------------------------

TP.gui.CSSPropertyTransition.Inst.defineMethod('constructWorkFunction',
function(transitionJob) {

    /**
     * @method constructWorkFunction
     * @summary Sets up a 'specialized' work function for transitions, since on
     *     some browsers its necessary to tweak the body's offsetHeight in order
     *     to get the transition to redraw.
     * @param {TP.core.Job} transitionJob The transition job that the work
     *     function will be used in.
     * @returns {Function} A new transition work function.
     */

    /* eslint-disable no-unused-vars */

    var step,
        func;

    //  grab the actual step function(s) so we can close around them
    step = transitionJob.$get('step');

    //  a simple wrapper around a potential set of functions which
    //  allows them all to run as a single work function.
    func = function(job, params) {

        var dummyVal;

        TP.isCallable(step) ?
                    job.wasSuccessful = step(job, params) :
                    job.wasSuccessful = step.apply(null, arguments);

        if (TP.notValid(func.targetBody)) {
            if (TP.isArray(params.at('target'))) {
                func.targetBody =
                    TP.documentGetBody(TP.nodeGetDocument(
                                            params.at('target').first()));
            } else {
                func.targetBody =
                    TP.documentGetBody(TP.nodeGetDocument(
                                            params.at('target')));
            }
        }

        //  NB: We assign to dummyVal below to ensure that the JS engine is
        //  forced to access (and assign) the value so that it can't optimize it
        //  away.

        dummyVal = func.targetBody.offsetHeight;

        return job.wasSuccessful;
    };

    //  support access for debugging purposes. this mirrors what we do
    //  with other wrapper functions such as bind (but may not always be
    //  a function if the work is an array of them)
    func.$realFunc = step;

    return func;

    /* eslint-enable no-unused-vars */
});

//  ------------------------------------------------------------------------

TP.gui.CSSPropertyTransition.Inst.defineMethod('constructJob',
function(controlParams, stepParams) {

    /**
     * @method constructJob
     * @summary Constructs a TP.core.Job to execute the receiving transition
     *     type.
     * @description Parameters supplied in the controlParams TP.core.Hash for
     *     this method override any setting for the receiving transition. If a
     *     parameter value isn't supplied for a particular parameter, the
     *     receiving transition type will be queried via a 'get*()' method (i.e.
     *     get('limit'), get('count'), etc.) for a 'built-in' value. Note that
     *     the step params TP.core.Hash is optional and may not be available,
     *     especially if this job is meant to be invoked repeatedly. We override
     *     this here to provide a custom work function.
     * @param {TP.core.Hash} controlParams A TP.core.Hash of the following
     *     control parameters: delay, interval, limit, count, compute.
     * @param {TP.core.Hash} stepParams A TP.core.Hash of the following job step
     *     parameters: target, property.
     * @returns {TP.core.Job} The job constructed for executing the receiving
     *     transition.
     */

    var ctrlParams,
        transitionJob;

    //  Make sure that we're configuring the job to know that it's running a
    //  visual animation
    ctrlParams = TP.isValid(controlParams) ? controlParams : TP.hc();
    ctrlParams.atPut('isAnimation', true);

    //  Call next method to get the transition job.
    transitionJob = this.callNextMethod(ctrlParams, stepParams);

    //  Set a custom work function on it.
    transitionJob.set('work', this.constructWorkFunction(transitionJob));

    return transitionJob;
});

//  ------------------------------------------------------------------------

TP.gui.CSSPropertyTransition.Inst.defineMethod('getComputeFunction',
function() {

    /**
     * @method getComputeFunction
     * @summary Returns the default compute Function for the receiving
     *     transition type.
     * @returns {Function} The default compute Function for this type.
     */

    //  Note that for this type we return 'null' since its best to let the
    //  TP.core.Job choose the compute function, based on whether we have
    //  'values' or not.

    return null;
});

//  ------------------------------------------------------------------------

TP.gui.CSSPropertyTransition.Inst.defineMethod('preserveValues',
function(params) {

    /**
     * @method preserveValues
     * @summary Preserves the values for the targets given the property name.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @returns {TP.gui.CSSPropertyTransition} The receiver.
     */

    var theTargets,
        styleProperty,

        oldVal;

    if (TP.isEmpty(theTargets = params.at('target'))) {
        return this;
    }

    styleProperty = params.at('property');
    if (TP.notValid(styleProperty)) {
        styleProperty = this.get('styleProperty');
    }

    if (TP.isEmpty(styleProperty)) {
        return this;
    }

    if (TP.isArray(theTargets)) {
        theTargets.perform(
            function(aTarget) {
                var val;

                val = TP.elementGetStyleProperty(aTarget, styleProperty);
                TP.elementPushStyleProperty(aTarget, styleProperty, val);
            });
    } else {
        oldVal = TP.elementGetStyleProperty(theTargets, styleProperty);

        TP.elementPushStyleProperty(theTargets, styleProperty, oldVal);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.gui.CSSPropertyTransition.Inst.defineMethod('restoreValues',
function(params) {

    /**
     * @method restoreValues
     * @summary Restores the values for the targets given the property name.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @returns {TP.gui.CSSPropertyTransition} The receiver.
     */

    /* eslint-disable no-unused-vars */

    var theTargets,
        styleProperty,

        oldVal,

        dummyVal;

    if (TP.isEmpty(theTargets = params.at('target'))) {
        return this;
    }

    styleProperty = params.at('property');
    if (TP.notValid(styleProperty)) {
        styleProperty = this.get('styleProperty');
    }

    if (TP.isEmpty(styleProperty)) {
        return this;
    }

    //  NB: We assign to dummyVal below to ensure that the JS engine is forced
    //  to access (and assign) the value so that it can't optimize it away.

    if (TP.isArray(theTargets)) {
        theTargets.perform(
            function(aTarget) {
                var val;

                val = TP.elementPopStyleProperty(aTarget, styleProperty);
                TP.elementGetStyleObj(aTarget)[styleProperty] = val;
            });

        //  Make sure that any drawing that needed to 'flush' to the window
        //  does so.
        dummyVal = TP.documentGetBody(TP.nodeGetDocument(
                                        theTargets.first())).offsetHeight;
    } else {
        oldVal = TP.elementPopStyleProperty(theTargets, styleProperty);

        TP.elementGetStyleObj(theTargets)[styleProperty] = oldVal;

        //  Make sure that any drawing that needed to 'flush' to the window
        //  does so.
        dummyVal = TP.documentGetBody(TP.nodeGetDocument(
                                        theTargets)).offsetHeight;
    }

    return this;

    /* eslint-enable no-unused-vars */
});

//  ========================================================================
//  TP.gui.CSSValueTransition
//  ========================================================================

/**
 * @type {TP.gui.CSSValueTransition}
 * @summary A subtype of TP.gui.CSSPropertyTransition that knows how to
 *     animate CSS values. It doesn't take into account unit lengths, but is
 *     good for non-unit values like opacity. A subtype of this type,
 *     TP.gui.CSSLengthTransition, should be used for CSS values that have unit
 *     lengths.
 */

//  ------------------------------------------------------------------------

TP.gui.CSSPropertyTransition.defineSubtype('CSSValueTransition');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.CSSValueTransition.Inst.defineMethod('configure',
function(job, params) {

    /**
     * @method configure
     * @summary Configures the transition, based on what this particular type
     *     of transition is trying to accomplish.
     * @description Note that the 'job' parameter supplied here points to the
     *     same instance as our 'job' instance variable, but this method is used
     *     by the job control system, so our method signature must match.
     * @param {TP.core.Job} job The job object that is currently processing this
     *     configure method.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @exception TP.sig.InvalidStyleDeclaration
     * @returns {Boolean} Whether or not this method configured the transition
     *     successfully.
     */

    var styleProperty,
        element,

        computedStyle,

        from,
        to,
        by,

        fromAsNumber,
        toAsNumber,
        byAsNumber;

    styleProperty = params.at('property');
    if (TP.notValid(styleProperty)) {
        styleProperty = this.get('styleProperty');
    }

    //  We can't proceed without a style property.
    if (TP.isEmpty(styleProperty)) {
        return false;
    }

    element = params.at('target');

    //  We can't proceed without a target element.
    if (TP.notValid(element)) {
        return false;
    }

    //  Note that the contents of 'target' could also be an Array of
    //  elements to be animated all at once. In this case, all computations
    //  below are done using the first element in this array.
    if (TP.isArray(element)) {
        element = element.first();
    }

    if (TP.CSS_DISALLOW_NEGATIVE_VALUES.contains(styleProperty)) {
        params.atPut('nonegvalues', true);
    }

    //  If we're animating across a set of values, then we're good to go. We
    //  assume that the caller has provided length units, etc. as necessary.
    if (TP.isArray(params.at('values'))) {
        return true;
    }

    //  Otherwise, we're using a 'from...to...by' model, so go ahead and
    //  grab those values.

    //  If the 'from' value is empty, we weren't given a 'from' value, so we
    //  need to compute one. This call ensures that the return value is in
    //  pixels.
    if (TP.isEmpty(from = params.at('from'))) {
        if (TP.notValid(computedStyle =
                        TP.elementGetComputedStyleObj(element))) {
            return this.raise('TP.sig.InvalidStyleDeclaration');
        }

        from = computedStyle[styleProperty];
    }

    //  Make sure the stepping value prefix and suffix either use the
    //  instance variable value for their values or have an empty String
    //  if they're not defined.
    params.atPutIfAbsent('propPrefix',
                            TP.ifEmpty(this.get('propPrefix'), ''));

    params.atPutIfAbsent('propSuffix',
                            TP.ifEmpty(this.get('propSuffix'), ''));

    //  We might have been handed a value with percentage units, so make
    //  sure to convert it.
    fromAsNumber = TP.elementGetPropertyValueAsNumber(
                            element, styleProperty, from);

    //  If the 'to' value is not empty, then we were supplied with the value
    //  that the animation will stop at.
    if (TP.notEmpty(to = params.at('to'))) {
        //  We might have been handed a value with percentage units, so make
        //  sure to convert it.
        toAsNumber = TP.elementGetPropertyValueAsNumber(
                            element, styleProperty, to);
    } else if (TP.notEmpty(by = params.at('by'))) {
        //  Otherwise, we didn't have a 'to' value, but we did have a 'by'
        //  value, so we can compute a 'to' value from it by adding it to
        //  the 'from' value.

        //  We might have been handed a value with percentage units, so make
        //  sure to convert it.
        byAsNumber = TP.elementGetPropertyValueAsNumber(
                            element, styleProperty, by);

        //  It's easy to compute 'to' now - its just 'from' plus 'by'
        toAsNumber = fromAsNumber + byAsNumber;
    } else {
        //  No 'to' or 'by' - can't proceed from here.
        //  TODO: Raise an exception
        return false;
    }

    //  Reset the 'from' and 'to' based on our computed values.
    params.atPut('from', fromAsNumber);
    params.atPut('to', toAsNumber);

    return true;
});

//  ------------------------------------------------------------------------

TP.gui.CSSValueTransition.Inst.defineMethod('step',
function(job, params) {

    /**
     * @method step
     * @summary Changes some aspect of the target element given when this
     *     transition was executed via the 'start()' method.
     * @description Note that the 'job' parameter supplied here points to the
     *     same instance as our 'job' instance variable, but this method is used
     *     by the job control system, so our method signature must match.
     * @param {TP.core.Job} job The job object that is currently processing this
     *     step method.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @returns {Boolean} Whether or not the 'step' processed successfully.
     */

    var styleProperty,

        element,

        stepval,

        len,
        i;

    styleProperty = params.at('property');
    if (TP.notValid(styleProperty)) {
        styleProperty = this.get('styleProperty');
    }

    //  We can't proceed without a style property.
    if (TP.isEmpty(styleProperty)) {
        return false;
    }

    element = params.at('target');

    //  We can't proceed without a target element.
    if (TP.notValid(element)) {
        return false;
    }

    stepval = job.getStepValue();

    //  If we're not animating 'a set of values', then we go ahead and
    //  append a length unit onto the stepping value, if available.
    if (TP.notValid(params.at('values'))) {
        if (stepval < 0 && TP.isTrue(params.at('nonnegvalues'))) {
            stepval = params.at('from') + stepval;
        }

        //  The step value may have prefixes and suffixes (a suffix might be
        //  a 'unit' like 'px').
        stepval = params.at('propPrefix') +
                    stepval +
                    params.at('propSuffix');
    }

    //  Note that the contents of 'target' could also be an Array of
    //  elements to be animated all at once.
    if (TP.isArray(element)) {
        len = element.getSize();
        for (i = 0; i < len; i++) {
            if (styleProperty === 'opacity') {
                TP.elementSetOpacity(element[i], stepval);
            } else {
                element[i].style[styleProperty] = stepval;
            }
        }
    } else {
        if (styleProperty === 'opacity') {
            TP.elementSetOpacity(element, stepval);
        } else {
            TP.elementGetStyleObj(element)[styleProperty] = stepval;
        }
    }

    return true;
});

//  ========================================================================
//  TP.gui.CSSLengthTransition
//  ========================================================================

/**
 * @type {TP.gui.CSSLengthTransition}
 * @summary A subtype of TP.gui.CSSValueTransition that knows how to animate
 *     CSS values with unit lengths, such as top, left, width, height, etc.
 */

//  ------------------------------------------------------------------------

TP.gui.CSSValueTransition.defineSubtype('CSSLengthTransition');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.CSSLengthTransition.Inst.defineMethod('configure',
function(job, params) {

    /**
     * @method configure
     * @summary Configures the transition, based on what this particular type
     *     of transition is trying to accomplish.
     * @description Note that the 'job' parameter supplied here points to the
     *     same instance as our 'job' instance variable, but this method is used
     *     by the job control system, so our method signature must match.
     * @param {TP.core.Job} job The job object that is currently processing this
     *     configure method.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @exception TP.sig.InvalidStyleDeclaration
     * @returns {Boolean} Whether or not this method configured the transition
     *     successfully.
     */

    var styleProperty,
        element,

        computedStyle,

        from,

        results,

        to,
        by,

        fromAsNumber,
        toAsNumber,
        byAsNumber;

    styleProperty = params.at('property');
    if (TP.notValid(styleProperty)) {
        styleProperty = this.get('styleProperty');
    }

    //  We can't proceed without a style property.
    if (TP.isEmpty(styleProperty)) {
        return false;
    }

    element = params.at('target');

    //  We can't proceed without a target element.
    if (TP.notValid(element)) {
        return false;
    }

    //  Note that the contents of 'target' could also be an Array of
    //  elements to be animated all at once. In this case, all computations
    //  below are done using the first element in this array.
    if (TP.isArray(element)) {
        element = element.first();
    }

    if (TP.CSS_DISALLOW_NEGATIVE_VALUES.contains(styleProperty)) {
        params.atPut('nonegvalues', true);
    }

    //  If we're animating across a set of values, then we're good to go. We
    //  assume that the caller has provided length units, etc. as necessary.
    if (TP.isArray(params.at('values'))) {
        return true;
    }

    //  Otherwise, we're using a 'from...to...by' model, so go ahead and
    //  grab those values.

    //  If the 'from' value is empty, we weren't given a 'from' value, so we
    //  need to compute one. This call ensures that the return value is in
    //  pixels.
    if (TP.isEmpty(from = params.at('from'))) {
        if (TP.notValid(computedStyle =
                        TP.elementGetComputedStyleObj(element))) {
            return this.raise('TP.sig.InvalidStyleDeclaration');
        }

        from = computedStyle[styleProperty];
    }

    params.atPutIfAbsent('propPrefix',
                            TP.ifEmpty(this.get('propPrefix'), ''));

    if (TP.isArray(results = TP.regex.CSS_UNIT.match(from))) {
        params.atPut('propSuffix', results.at(3));
    } else {
        params.atPutIfAbsent('propSuffix',
                                TP.ifEmpty(this.get('propSuffix'), 'px'));
    }

    //  We might have been handed a value with units other than pixels (such
    //  as '%'ages or 'em's), so make sure to convert it.
    fromAsNumber = TP.elementGetPixelValue(
                                element, from, styleProperty);

    //  If the 'to' value is not empty, then we were supplied with the value
    //  that the animation will stop at.
    if (TP.notEmpty(to = params.at('to'))) {
        //  We might have been handed a value with units other than pixels
        //  (such as '%'ages or 'em's), so make sure to convert it.
        toAsNumber = TP.elementGetPixelValue(
                                element, to, styleProperty);
    } else if (TP.notEmpty(by = params.at('by'))) {
        //  Otherwise, we didn't have a 'to' value, but we did have a 'by'
        //  value, so we can compute a 'to' value from it by adding it to
        //  the 'from' value.

        //  We might have been handed a value with units other than pixels
        //  (such as '%'ages or 'em's), so make sure to convert it.
        byAsNumber = TP.elementGetPixelValue(
                                element, by, styleProperty);

        //  It's easy to compute 'to' now - its just 'from' plus 'by'
        toAsNumber = fromAsNumber + byAsNumber;
    } else {
        //  No 'to' or 'by' - can't proceed from here.
        //  TODO: Raise an exception
        return false;
    }

    //  Reset the 'from' and 'to' based on our computed values.
    params.atPut('from', fromAsNumber);
    params.atPut('to', toAsNumber);

    return true;
});

//  ========================================================================
//  TP.gui.CSSColorTransition
//  ========================================================================

/**
 * @type {TP.gui.CSSColorTransition}
 * @summary A subtype of TP.gui.CSSValueTransition that knows how to animate
 *     CSS colors values, such as color, backgroundColor, etc.
 */

//  ------------------------------------------------------------------------

TP.gui.CSSValueTransition.defineSubtype('CSSColorTransition');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.CSSColorTransition.Inst.defineMethod('configure',
function(job, params) {

    /**
     * @method configure
     * @summary Configures the transition, based on what this particular type
     *     of transition is trying to accomplish.
     * @description Note that the 'job' parameter supplied here points to the
     *     same instance as our 'job' instance variable, but this method is used
     *     by the job control system, so our method signature must match.
     * @param {TP.core.Job} job The job object that is currently processing this
     *     configure method.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @exception TP.sig.InvalidStyleDeclaration
     * @returns {Boolean} Whether or not this method configured the transition
     *     successfully.
     */

    var styleProperty,
        element,

        values,
        from,
        to,
        by,

        computedStyle,

        valuesAsNumbers,
        fromAsNumber,
        toAsNumber,
        byAsNumber;

    styleProperty = params.at('property');
    if (TP.notValid(styleProperty)) {
        styleProperty = this.get('styleProperty');
    }

    //  We can't proceed without a style property.
    if (TP.isEmpty(styleProperty)) {
        return false;
    }

    element = params.at('target');

    //  We can't proceed without a target element.
    if (TP.notValid(element)) {
        return false;
    }

    //  Note that the contents of 'target' could also be an Array of
    //  elements to be animated all at once. In this case, all computations
    //  below are done using the first element in this array.
    if (TP.isArray(element)) {
        element = element.first();
    }

    //  If we're animating across a set of values, then we should iterate
    //  across those values, converting the colors into their numerical
    //  representation for use by the animation system. Note how we set our
    //  new Array as the 'values' array for use by the animation system.
    if (TP.isArray(values = params.at('values'))) {
        valuesAsNumbers = values.collect(
                function(aValue) {

                    return TP.colorStringAsLongNumber(aValue);
                });

        params.atPut('values', valuesAsNumbers);

        return true;
    }

    //  Otherwise, we're using a 'from...to...by' model, so go ahead and
    //  grab those values.

    //  We make sure to do 'asString's here, in case we got handed a
    //  TP.gui.Color.
    if (TP.notEmpty(from = params.at('from'))) {
        from = from.asString();
    }

    if (TP.notEmpty(to = params.at('to'))) {
        to = to.asString();
    }

    if (TP.notEmpty(by = params.at('by'))) {
        by = by.asString();
    }

    //  If the 'from' value is not empty, then we were supplied with the
    //  value to start the animation from.
    if (TP.notEmpty(from)) {
        //  We were handed a 'color value' (a name, a hex, an rgb(...),
        //  etc.) string, so convert it into a number so that we can use it
        //  in the animation.
        fromAsNumber = TP.colorStringAsLongNumber(from);
    } else {
        //  Otherwise, we weren't given a 'from' color value, so we need to
        //  compute one. If the property that we're changing is the
        //  background color, we use a special routine that will determine
        //  background color, even if the element is transparent.
        if (styleProperty === 'backgroundColor') {
            fromAsNumber = TP.colorStringAsLongNumber(
                        TP.elementGetEffectiveBackgroundColor(element));
        } else {
            if (TP.notValid(computedStyle =
                            TP.elementGetComputedStyleObj(element))) {
                return this.raise('TP.sig.InvalidStyleDeclaration');
            }

            fromAsNumber = TP.colorStringAsLongNumber(
                                            computedStyle[styleProperty]);
        }
    }

    //  If the 'to' value is not empty, then we were supplied with the value
    //  that the animation will stop at.
    if (TP.notEmpty(to)) {
        //  We were handed a 'color value' (a name, a hex, an rgb(...),
        //  etc.) string, so convert it into a number so that we can use it
        //  in the animation.
        toAsNumber = TP.colorStringAsLongNumber(to);
    } else if (TP.notEmpty(by)) {
        //  Otherwise, we didn't have a 'to' value, but we did have a 'by'
        //  value, so we can compute a 'to' value from it by adding it to
        //  the 'from' value.

        //  We were handed a 'color value' (a name, a hex, an rgb(...),
        //  etc.) string, so convert it into a number so that we can use it
        //  in the animation.
        byAsNumber = TP.colorStringAsLongNumber(by);

        //  It's easy to compute 'to' now - its just 'from' plus 'by'
        toAsNumber = fromAsNumber + byAsNumber;
    } else {
        //  No 'to' or 'by' - can't proceed from here.
        //  TODO: Raise an exception
        void 0;
    }

    params.atPut('from', fromAsNumber);
    params.atPut('to', toAsNumber);

    return true;
});

//  ------------------------------------------------------------------------

TP.gui.CSSColorTransition.Inst.defineMethod('step',
function(job, params) {

    /**
     * @method step
     * @summary Changes some aspect of the target element given when this
     *     transition was executed via the 'start()' method.
     * @description Note that the 'job' parameter supplied here points to the
     *     same instance as our 'job' instance variable, but this method is used
     *     by the job control system, so our method signature must match.
     * @param {TP.core.Job} job The job object that is currently processing this
     *     step method.
     * @param {TP.core.Hash} params The 'step parameters' supplied to the job.
     * @returns {Boolean} Whether or not the 'step' processed successfully.
     */

    var styleProperty,

        element,

        stepval,

        fromAsNumber,
        toAsNumber,
        colorStep,

        len,
        i;

    styleProperty = params.at('property');
    if (TP.notValid(styleProperty)) {
        styleProperty = this.get('styleProperty');
    }

    //  We can't proceed without a style property.
    if (TP.isEmpty(styleProperty)) {
        return false;
    }

    element = params.at('target');

    //  We can't proceed without a target element.
    if (TP.notValid(element)) {
        return false;
    }

    //  If we're animating across a set of values, then there isn't any
    //  interpolation necessary between the start and end colors, so we just
    //  grab the value.
    if (TP.notEmpty(params.at('values'))) {
        stepval = TP.longNumberAsColorString(job.getStepValue());
    } else {
        fromAsNumber = params.at('from');
        toAsNumber = params.at('to');

        //  getPercentComplete() can return null if the caller is using a
        //  'Function based' limit - in that case, there's no way to know.
        if (TP.isNumber(colorStep = job.getPercentComplete())) {
            //  We compute the step color by using the step value in a color
            //  interpolation and then turn that into a hex color.
            stepval = TP.longNumberAsColorString(
                                            TP.colorValuesInterpolate(
                                                    fromAsNumber,
                                                    toAsNumber,
                                                    colorStep));
        } else {
            stepval = '';
        }
    }

    //  Note that the contents of 'target' could also be an Array of
    //  elements to be animated all at once.
    if (TP.isArray(element)) {
        len = element.getSize();
        for (i = 0; i < len; i++) {
            element[i].style[styleProperty] = stepval;
        }
    } else {
        TP.elementGetStyleObj(element)[styleProperty] = stepval;
    }

    return true;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETCSSTypesW3C.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

//  ========================================================================
//  TP.gui.Gradient
//  ========================================================================

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.Gradient.Inst.defineMethod('asCanvasGradientOn',
function(aCanvas) {

    /**
     * @method asCanvasGradientOn
     * @summary Converts the receiver into a gradient that can be used by the
     *     supplied HTML Canvas element.
     * @param {HTMLCanvas} aCanvas The HTML Canvas element to produce the
     *     gradient for.
     * @returns {Object} An HTML Canvas gradient object suitable for use with
     *     the supplied HTML Canvas.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.gui.Gradient.Inst.defineMethod('asSVGGradientOn',
function(anElement, idValue) {

    /**
     * @method asSVGGradientOn
     * @summary Sets up an SVG 'linear gradient' element, given information in
     *     the receiver.
     * @param {Element} anElement The element to set the gradient up for.
     * @param {String} idValue The ID value for the gradient. If a gradient has
     *     already been created with this ID, it will be returned, thereby
     *     reusing the gradient element.
     * @returns {String} The 'gradient URL' for elements to use.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.gui.Gradient.Inst.defineMethod('$setupSVGGradientElement',
function(anElement, idValue, gradientTagName) {

    /**
     * @method $setupSVGGradientElement
     * @summary Sets up a gradient element for the supplied element. This
     *     manages all of the setup of the gradient element in the proper place
     *     in the SVG element hierarchy.
     * @param {SVGElement} anElement The element to set the gradient up for.
     * @param {String} idValue The ID value for the gradient. If a gradient has
     *     already been created with this ID, it will be returned, thereby
     *     reusing the gradient element.
     * @param {String} gradientTagName The tag name of the gradient to create -
     *     either 'linear' or 'radial'.
     * @returns {Element} The newly created SVG 'gradient' element.
     */

    var nativeDoc,

        gradElem,

        svgElem,
        defsElem,

        gradID,

        colors,
        stops;

    //  Grab the element's document and its 'closest' enclosing 'svg'
    //  element (the element named 'svg').
    nativeDoc = TP.nodeGetDocument(anElement);

    //  If there's already a gradient element with that ID, we just return
    //  it.
    if (TP.isElement(gradElem = nativeDoc.getElementById(idValue))) {
        return gradElem;
    }

    svgElem = TP.nodeGetFirstAncestorByTagName(anElement, 'svg');

    //  See if there's a 'defs' element under the 'svg' element. This is
    //  where we need to place the gradient element.
    if (TP.notValid(defsElem = TP.nodeGetFirstElementByTagName(
                                                svgElem, 'defs'))) {
        //  No pre-existing 'defs' element, so we create one and insert it
        //  as the first child to the 'svg' element.
        defsElem = TP.documentConstructElement(nativeDoc,
                                            'defs',
                                            TP.w3.Xmlns.SVG);
        svgElem.insertBefore(defsElem, svgElem.firstChild);
    }

    //  If an ID value was supplied, we want to make sure to get the 'local
    //  ID' (that is, the ID without any leading URL bits or trailing
    //  parentheses).
    if (TP.notEmpty(gradID = idValue)) {
        gradID = gradID.slice(gradID.indexOf('#') + 1,
                                gradID.lastIndexOf(')'));
    }

    //  If no gradient ID was supplied or an existing gradient element
    //  couldn't be found with that ID, then we create a gradient element
    //  and put it at the proper place within the SVG DOM.
    if (TP.isEmpty(gradID) ||
        !TP.isElement(gradElem = TP.byId(gradID, nativeDoc, false))) {
        gradElem = TP.documentConstructElement(nativeDoc,
                                            gradientTagName,
                                            TP.w3.Xmlns.SVG);

        //  Get a unique ID, but then reassign a lowercase version of
        //  it. We'll assign it ourselves. We do this because when it
        //  gets written into the style entry we want to make sure its
        //  all lowercase, because the conversion to style hashes forces
        //  things into lowercase and we want everything to match.
        gradID = TP.lid(gradElem, true).toLowerCase();
        TP.elementSetAttribute(gradElem, 'id', gradID);

        TP.elementSetAttribute(gradElem, 'gradientUnits', 'userSpaceOnUse');

        //  Append the gradient into the 'defs' element.
        defsElem.appendChild(gradElem);
    } else {
        //  Empty out any previous stops
        TP.nodeEmptyContent(gradElem);
    }

    //  Make sure to 'normalize' the color and stop values on ourself.
    //  This will ensure that all of the colors are expressed properly, that
    //  all of the stops are expressed properly and that the number of
    //  colors and stops are equal,
    this.normalizeGradientValues();

    colors = this.get('colors');
    stops = this.get('stops');

    //  Loop over the colors and stops and set up SVG 'stop' elements.
    colors.performWith(
        function(aColor, aStop) {

            var stopElem;

            stopElem = TP.documentConstructElement(
                                    nativeDoc,
                                    'stop',
                                    TP.w3.Xmlns.SVG);

            TP.elementSetAttribute(stopElem,
                                    'offset',
                                    aStop.toFixed(8));
            TP.elementSetAttribute(stopElem,
                                    'stop-color',
                                    aColor.asHexString());
            TP.elementSetAttribute(stopElem,
                                    'stop-opacity',
                                    aColor.get('alpha'));

            //  Append each 'stop' element under the gradient element.
            gradElem.appendChild(stopElem);
        }, stops);

    return gradElem;
});

//  ========================================================================
//  TP.gui.LinearGradient
//  ========================================================================

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.LinearGradient.Inst.defineMethod('asCanvasGradientOn',
function(aCanvas) {

    /**
     * @method asCanvasGradientOn
     * @summary Converts the receiver into a gradient that can be used by the
     *     supplied HTML Canvas element.
     * @param {HTMLCanvas} aCanvas The HTML Canvas element to produce the
     *     gradient for.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidContext
     * @returns {Object} An HTML Canvas gradient object suitable for use with
     *     the supplied HTML Canvas.
     */

    var the2DContext,

        x1,
        y1,
        x2,
        y2,

        canvasGradient,

        colors,
        stops;

    if (TP.notValid(aCanvas)) {
        return this.raise('TP.sig.InvalidElement');
    }

    if (TP.notValid(the2DContext = aCanvas.getContext('2d'))) {
        return this.raise('TP.sig.InvalidContext',
                            'Canvas has invalid 2D context');
    }

    //  The receiver can express it's x1, y1, x2, y2 as percentages to be
    //  compliant with SVG. The Canvas object, however, provides for no such
    //  capability. Therefore we need to multiply by the canvas width and
    //  height to derive the proper values for a Canvas.

    /* eslint-disable no-extra-parens */

    if (/%/.test(x1 = this.get('x1'))) {
        x1 = (parseFloat(x1) / 100) * aCanvas.width;
    }

    if (/%/.test(y1 = this.get('y1'))) {
        y1 = (parseFloat(y1) / 100) * aCanvas.height;
    }

    if (/%/.test(x2 = this.get('x2'))) {
        x2 = (parseFloat(x2) / 100) * aCanvas.width;
    }

    if (/%/.test(y2 = this.get('y2'))) {
        y2 = (parseFloat(y2) / 100) * aCanvas.height;
    }

    /* eslint-enable no-extra-parens */

    canvasGradient = the2DContext.createLinearGradient(x1, y1, x2, y2);

    //  Install the color stops.

    //  First, make sure that the colors and stops are normalized (i.e.
    //  expressed in the proper units, etc.
    this.normalizeGradientValues();

    stops = this.get('stops');
    colors = this.get('colors');

    //  Iterate over the stops Array, using each color from the colors Array
    //  and add a color stop for each item iterated over.
    stops.performWith(
        function(aStopValue, aColorValue) {

            if (TP.isNumber(aStopValue)) {
                canvasGradient.addColorStop(aStopValue,
                                            aColorValue.asRGBAString());
            }
        },
        colors);

    return canvasGradient;
});

//  ------------------------------------------------------------------------

TP.gui.LinearGradient.Inst.defineMethod('asSVGGradientOn',
function(anElement, idValue) {

    /**
     * @method asSVGGradientOn
     * @summary Sets up an SVG 'linear gradient' element, given information in
     *     the receiver.
     * @param {SVGElement} anElement The element to set the gradient up for.
     * @param {String} idValue The ID value for the gradient. If a gradient has
     *     already been created with this ID, it will be returned, thereby
     *     reusing the gradient element.
     * @returns {String} The 'gradient URL' for elements to use.
     */

    var gradElem,
        gradURL;

    //  Set up a linear gradient element (or return an existing one with the
    //  supplied ID).
    gradElem = this.$setupSVGGradientElement(anElement,
                                                idValue,
                                                'linearGradient');

    //  Set the various x1, y1, x2, y2 values given those values on the
    //  TP.gui.Gradient object.
    TP.elementSetAttribute(gradElem, 'x1', this.get('x1'));
    TP.elementSetAttribute(gradElem, 'y1', this.get('y1'));
    TP.elementSetAttribute(gradElem, 'x2', this.get('x2'));
    TP.elementSetAttribute(gradElem, 'y2', this.get('y2'));

    //  Compute a 'gradient URL' that can be referenced by elements in their
    //  'fill' or 'stroke' properties. This includes the 'URL' of the
    //  element's document to avoid bugs in Mozilla 1.8 (Firefox 2.X).
    gradURL = TP.join('url(',
                        TP.nodeGetDocument(anElement).URL,
                        '#',
                        TP.elementGetAttribute(gradElem, 'id'),
                        ')');

    return gradURL;
});

//  ========================================================================
//  TP.gui.RadialGradient
//  ========================================================================

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.RadialGradient.Inst.defineMethod('asCanvasGradientOn',
function(aCanvas) {

    /**
     * @method asCanvasGradientOn
     * @summary Converts the receiver into a gradient that can be used by the
     *     supplied HTML Canvas element.
     * @param {HTMLCanvas} aCanvas The HTML Canvas element to produce the
     *     gradient for.
     * @exception TP.sig.InvalidElement
     * @exception TP.sig.InvalidContext
     * @returns {Object} An HTML Canvas gradient object suitable for use with
     *     the supplied HTML Canvas.
     */

    var the2DContext,

        cx,
        cy,

        viewportVal,
        radius,

        canvasGradient,

        colors,
        stops;

    if (TP.notValid(aCanvas)) {
        return this.raise('TP.sig.InvalidElement');
    }

    if (TP.notValid(the2DContext = aCanvas.getContext('2d'))) {
        return this.raise('TP.sig.InvalidContext',
                            'Canvas has invalid 2D context');
    }

    //  The receiver can express it's cx, cy, radius as percentages to be
    //  compliant with SVG. The Canvas object, however, provides for no such
    //  capability. Therefore we need to multiply by the canvas width and
    //  height (or by a precomputed 'viewport value' in the case of radius)
    //  to derive the proper values for a Canvas.

    /* eslint-disable no-extra-parens */

    if (/%/.test(cx = this.get('cx'))) {
        cx = (parseFloat(cx) / 100) * aCanvas.width;
    }

    if (/%/.test(cy = this.get('cy'))) {
        cy = (parseFloat(cy) / 100) * aCanvas.height;
    }

    if (/%/.test(radius = this.get('radius'))) {
        //  As per the SVG spec.
        viewportVal =
            (aCanvas.width.pow(2) + aCanvas.height.pow(2)).sqrt() /
                (2).sqrt();

        radius = (parseFloat(radius) / 100) * viewportVal;
    }

    /* eslint-enable no-extra-parens */

    canvasGradient = the2DContext.createRadialGradient(
                                            cx, cy, 0, cx, cy, radius);

    //  Install the color stops.

    //  First, make sure that the colors and stops are normalized (i.e.
    //  expressed in the proper units, etc.
    this.normalizeGradientValues();

    stops = this.get('stops');
    colors = this.get('colors');

    //  Iterate over the stops Array, using each color from the colors Array
    //  and add a color stop for each item iterated over.
    stops.performWith(
        function(aStopValue, aColorValue) {

            if (TP.isNumber(aStopValue)) {
                canvasGradient.addColorStop(aStopValue,
                                            aColorValue.asRGBAString());
            }
        },
        colors);

    return canvasGradient;
});

//  ------------------------------------------------------------------------

TP.gui.RadialGradient.Inst.defineMethod('asSVGGradientOn',
function(anElement, idValue) {

    /**
     * @method asSVGGradientOn
     * @summary Sets up an SVG 'radial gradient' element, given information in
     *     the receiver.
     * @param {Element} anElement The element to set the gradient up for.
     * @param {String} idValue The ID value for the gradient. If a gradient has
     *     already been created with this ID, it will be returned, thereby
     *     reusing the gradient element.
     * @returns {String} The 'gradient URL' for elements to use.
     */

    var gradElem,
        gradURL;

    //  Set up a radial gradient element (or return an existing one with the
    //  supplied ID).
    gradElem = this.$setupSVGGradientElement(anElement,
                                                idValue,
                                                'radialGradient');

    //  Set the various cx, cy, r, fx, fy values given those values on the
    //  TP.gui.Gradient object.
    TP.elementSetAttribute(gradElem, 'cx', this.get('cx'));
    TP.elementSetAttribute(gradElem, 'cy', this.get('cy'));

    TP.elementSetAttribute(gradElem, 'r', this.get('radius'));

    TP.elementSetAttribute(gradElem, 'fx', this.get('fx'));
    TP.elementSetAttribute(gradElem, 'fy', this.get('fy'));

    //  Compute a 'gradient URL' that can be referenced by elements in their
    //  'fill' or 'stroke' properties. This includes the 'URL' of the
    //  element's document to avoid bugs in Mozilla 1.8 (Firefox 2.X).
    gradURL = TP.join('url(',
                        TP.nodeGetDocument(anElement).URL,
                        '#',
                        TP.elementGetAttribute(gradElem, 'id'),
                        ')');

    return gradURL;
});

//  ========================================================================
//  TP.gui.Pattern
//  ========================================================================

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.gui.Pattern.Inst.defineMethod('asCanvasPatternOn',
function(aCanvas) {

    /**
     * @method asCanvasPatternOn
     * @summary Converts the receiver into a pattern that can be used by the
     *     supplied HTML Canvas element.
     * @param {HTMLCanvas} aCanvas The HTML Canvas element to produce the
     *     pattern for.
     * @returns {Object} An HTML Canvas pattern object suitable for use with the
     *     supplied HTML Canvas.
     */

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.gui.Pattern.Inst.defineMethod('asSVGPatternOn',
function(anElement, idValue) {

    /**
     * @method asSVGPatternOn
     * @summary Sets up an SVG 'radial gradient' element, given information in
     *     the receiver.
     * @param {Element} anElement The element to set the pattern up for.
     * @param {String} idValue The ID value for the pattern. If a pattern has
     *     already been created with this ID, it will be returned, thereby
     *     reusing the pattern element.
     * @returns {Element} The newly created SVG 'pattern' element.
     */

    var nativeDoc,

        svgElem,
        defsElem,

        patID,

        patternElem,
        imageElem,

        patternURL;

    //  Grab the element's document and its 'closest' enclosing 'svg'
    //  element (the element named 'svg').
    nativeDoc = TP.nodeGetDocument(anElement);
    svgElem = TP.nodeGetFirstAncestorByTagName(anElement, 'svg');

    //  See if there's a 'defs' element under the 'svg' element. This is
    //  where we need to place the pattern element.
    if (TP.notValid(defsElem = TP.nodeGetFirstElementByTagName(
                                                svgElem, 'defs'))) {
        //  No pre-existing 'defs' element, so we create one and insert it
        //  as the first child to the 'svg' element.
        defsElem = TP.documentConstructElement(nativeDoc,
                                            'defs',
                                            TP.w3.Xmlns.SVG);
        svgElem.insertBefore(defsElem, svgElem.firstChild);
    }

    //  If an ID value was supplied, we want to make sure to get the 'local
    //  ID' (that is, the ID without any leading URL bits or trailing
    //  parentheses).
    if (TP.notEmpty(patID = idValue)) {
        patID = patID.slice(patID.indexOf('#') + 1,
                                patID.lastIndexOf(')'));
    }

    //  If no pattern ID was supplied or an existing pattern element
    //  couldn't be found with that ID, then we create a pattern element
    //  and put it at the proper place within the SVG DOM.
    if (TP.isEmpty(patID) ||
        !TP.isElement(patternElem = TP.byId(patID, nativeDoc, false))) {
        patternElem = TP.documentConstructElement(nativeDoc,
                                                'pattern',
                                                TP.w3.Xmlns.SVG);

        //  Get a unique ID, but then reassign a lowercase version of
        //  it. We'll assign it ourselves. We do this because when it
        //  gets written into the style entry we want to make sure its
        //  all lowercase, because the conversion to style hashes forces
        //  things into lowercase and we want everything to match.
        patID = TP.lid(patternElem, true).toLowerCase();
        TP.elementSetAttribute(patternElem, 'id', patID);

        TP.elementSetAttribute(patternElem,
                                'patternUnits',
                                'userSpaceOnUse');

        //  Append the pattern into the 'defs' element.
        defsElem.appendChild(patternElem);
    }

    //  If an 'image' element isn't under the pattern element in the DOM,
    //  then create one and append it in.
    if (TP.notValid(imageElem =
                    patternElem.getElementsByTagName('image')[0])) {
        imageElem = TP.documentConstructElement(nativeDoc,
                                                'image',
                                                TP.w3.Xmlns.SVG);

        patternElem.appendChild(imageElem);
    }

    //  Set the various x, y, width, height values of the pattern element
    //  given those values on the TP.gui.Gradient object.
    TP.elementSetAttribute(imageElem, 'x', this.get('x'));
    TP.elementSetAttribute(imageElem, 'y', this.get('y'));
    TP.elementSetAttribute(imageElem, 'width', this.get('width'));
    TP.elementSetAttribute(imageElem, 'height', this.get('height'));

    //  Set the 'xlink:href' to the URI of the pattern.
    TP.elementSetAttributeInNS(imageElem,
                                'href',
                                this.get('uri'),
                                TP.w3.Xmlns.XLINK);

    //  Compute a 'pattern URL' that can be referenced by elements in their
    //  'fill' or 'stroke' properties. This includes the 'URL' of the
    //  element's document to avoid bugs in Mozilla 1.8 (Firefox 2.X).
    patternURL = TP.join('url(',
                            TP.nodeGetDocument(anElement).URL,
                            '#',
                            patID,
                            ')');

    return patternURL;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETWorkflowDOMTypes.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.ietf.vcard
//  ========================================================================

/**
 * @type {TP.ietf.vcard}
 * @summary A VCard originally based on the Jabber/XEP-0054 vcard-temp spec.
 * @description The primary purpose of this type in TIBET is to support
 *     TP.core.User instances in the definition of their organization and role
 *     affiliations. By virtue of vcard association types can autoload
 *     organization-specific role/unit types which serve as delegates for
 *     permission-specific behaviors and as keepers of associated keys/keyrings.
 *
 *     Given the relatively limited goals for this type at the present time we
 *     focus only on the <fn>, <role>, <org> and <x-orgunit> elements.
 *     Additional aspect mappings, and an expanded node template, would allow
 *     this type to be a full-featured wrapper for the full XEP-0054 vcard
 *     element.
 *
 *     See http://www.xmpp.org/extensions/xep-0054.html for more info.
 *
 *     See the vcards.xml sample file for specific markup examples.
 */

//  ------------------------------------------------------------------------

TP.dom.ElementNode.defineSubtype('ietf.vcard');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

/**
 * The dictionary of registered vcards.
 * @type {TP.core.Hash}
 */
TP.ietf.vcard.Type.defineAttribute('instances', TP.hc());

//  ------------------------------------------------------------------------
//  Types Methods
//  ------------------------------------------------------------------------

TP.ietf.vcard.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    var url;

    url = TP.sys.cfg('path.lib_vcards');
    if (TP.notEmpty(url)) {
        TP.ietf.vcard.loadVCards(url).then(
            function(result) {
                TP.ietf.vcard.initVCards(result);
            }).catch(
            function(err) {
                TP.ifError() ?
                    TP.error('Error loading library vcards: ' +
                                TP.str(err)) : 0;
            });
    }

    url = TP.sys.cfg('path.app_vcards');
    if (TP.notEmpty(url)) {
        TP.ietf.vcard.loadVCards(url).then(
            function(result) {
                TP.ietf.vcard.initVCards(result);
            }).catch(
            function(err) {
                TP.ifError() ?
                    TP.error('Error loading application vcards: ' +
                                TP.str(err)) : 0;
            });
    }
});

//  ------------------------------------------------------------------------

TP.ietf.vcard.Type.defineMethod('generate',
function(userInfo) {

    /**
     * @method generate
     * @summary Generates a new vcard instance using data contained in userInfo.
     *     Keys can include 'fn', 'n', 'role', 'org', and 'orgunit'. Defaults
     *     are taken from the user.default_* keys in TIBET's configuration data.
     * @param {TP.core.Hash} userInfo The user information to build a card for.
     * @returns {TP.ietf.vcard} The new instance.
     */

    var params,

        role,
        primaryRole,
        otherRoles,

        org,
        primaryOrg,
        otherOrgs,

        xml,

        i,

        node;

    params = TP.hc(userInfo);
    params.atPutIfAbsent('fn', TP.sys.cfg('user.default_name'));
    params.atPutIfAbsent('n', params.at('fn'));
    params.atPutIfAbsent('nickname', params.at('fn'));
    params.atPutIfAbsent('org', TP.sys.cfg('user.default_org'));
    params.atPutIfAbsent('orgunit', params.at('org'));

    role = TP.ifEmpty(params.at('role'), TP.sys.cfg('user.default_role'));
    if (TP.isArray(role)) {
        primaryRole = role.first();
        otherRoles = role.slice(1);
    } else {
        primaryRole = role;
    }
    params.atPut('role', primaryRole);

    org = TP.ifEmpty(params.at('org'), TP.sys.cfg('user.default_org'));
    if (TP.isArray(org)) {
        primaryOrg = org.first();
        otherOrgs = org.slice(1);
    } else {
        primaryOrg = org;
    }
    params.atPut('org', primaryOrg);

    xml = TP.ac(
        '<vcard xmlns="urn:ietf:params:xml:ns:vcard-4.0"',
                ' xmlns:vcard-ext="http://www.technicalpursuit.com/vcard-ext">',
            '<fn><text>' + params.at('fn') + '</text></fn>',
            '<n><surname>' + params.at('n') + '</surname><given/><prefix/></n>',
            '<nickname><text>' + params.at('nickname') + '</text></nickname>',
            '<role><text>' + params.at('role') + '</text></role>',
            '<org><text>' + params.at('org') + '</text></org>',
            '<tel>',
                '<parameters>',
                    '<type><text>work</text><text>voice</text></type>',
                '</parameters>',
                '<text></text>',
                '<uri></uri>',
            '</tel>',
            '<email><text/></email>',
            '<url>',
                '<parameters>',
                    '<type><text>work</text></type>',
                '</parameters>',
                '<uri/>',
            '</url>',
            '<tz><text/></tz>',
            '<vcard-ext:x-orgunit>',
                '<text>' + params.at('orgunit') + '</text>',
            '</vcard-ext:x-orgunit>');

    if (TP.notEmpty(otherRoles)) {
        xml.push('<vcard-ext:x-otherroles>');
        for (i = 0; i < otherRoles.getSize(); i++) {
            xml.push('<text>' + otherRoles.at(i) + '</text>');
        }
        xml.push('</vcard-ext:x-otherroles>');
    } else {
        xml.push('<vcard-ext:x-otherroles/>');
    }

    if (TP.notEmpty(otherOrgs)) {
        xml.push('<vcard-ext:x-otherorgs>');
        for (i = 0; i < otherOrgs.getSize(); i++) {
            xml.push('<text>' + otherOrgs.at(i) + '</text>');
        }
        xml.push('</vcard-ext:x-otherorgs>');
    } else {
        xml.push('<vcard-ext:x-otherorgs/>');
    }

    xml.push('</vcard>');

    xml = xml.join('\n');

    node = TP.elementFromString(xml);

    return TP.ietf.vcard.construct(node);
});

//  ------------------------------------------------------------------------

TP.ietf.vcard.Type.defineMethod('getInstanceById',
function(anID) {

    /**
     * @method getInstanceById
     * @summary Returns the vcard instance whose <fn> value matches the ID
     *     provided. If the ID matches that of the user.default_name value and
     *     the vcard isn't found a default version will be created.
     * @returns {TP.ietf.vcard} A vcard element wrapper.
     */

    var vcards,
        inst;

    //  NOTE the access to the top-level type here, not 'this'.
    vcards = TP.ietf.vcard.get('instances');

    inst = vcards.at(anID);
    if (TP.isValid(inst)) {
        return inst;
    }

    //  Due to startup sequencing we may need to create the default instance on
    //  demand. Role/Unit initializers trigger a call to this method.
    return this.generate(TP.hc('fn', anID));
});

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.ietf.vcard.Type.defineMethod('initVCards',
function(aDocument) {

    /**
     * @method initVCards
     * @summary Initializes instances of vcard based on vcard elements found
     *     in the document provided. This method is usually invoked after a call
     *     to loadVCards to acquire a vcard-containing document.
     * @param {Document} aDocument A TIBET vcards document. See the
     *     documentation on TIBET vcard files for more information.
     * @returns {TP.ietf.vcard[]} An array of vcard instances.
     */

    var vcards,
        list;

    if (!TP.isDocument(aDocument)) {
        return this.raise('InvalidDocument', aDocument);
    }

    vcards = TP.nodeEvaluateXPath(aDocument, '//$def:vcard', TP.NODESET);
    list = vcards.collect(
                    function(elem) {
                        return TP.ietf.vcard.construct(elem);
                    });

    return list;
});

//  ------------------------------------------------------------------------

TP.ietf.vcard.Type.defineMethod('loadVCards',
function(aURI) {

    /**
     * @method loadVCards
     * @summary Loads vcard data from the URI provided, or from the default
     *     vcard path if one is defined. The resulting document can then be
     *     passed to initVCards() which will construct instances for each of
     *     the vcard elements found in the document.
     * @returns {TP.sig.Response|undefined} A TIBET Response object (which is
     *     Promise-compatible) which will resolve on completion.
     */

    var url,
        fname;

    url = aURI;

    if (TP.notValid(url)) {
        //  If we don't have a viable setting for application-level vcards we
        //  should try library-level vcards.
        url = TP.sys.cfg('path.app_vcards');
        if (TP.isEmpty(url)) {

            //  If we don't have a viable setting for library-level vcards then
            //  we should just return quietly.
            url = TP.sys.cfg('path.lib_vcards');
            if (TP.isEmpty(url)) {
                return;
            }
        }
    }

    //  If we got a URI or path of some kind it's time to validate it and create
    //  the URI instance needed to perform the data load.
    if (!TP.isKindOf(url, TP.uri.URI)) {
        fname = TP.uriExpandPath(url);
        if (!TP.isURI(url = TP.uc(fname))) {
            return this.raise('InvalidURI', aURI);
        }
    }

    return url.getResource(TP.hc('resultType', TP.DOM));
});

//  ------------------------------------------------------------------------

TP.ietf.vcard.Type.defineMethod('registerVCard',
function(aVCard) {

    /**
     * @method registerVCard
     * @summary Registers a single vcard with the vcard type using the
     *     'fullname' (i.e. the <text> value of <fn>) as the key to register it
     *     under. This method is invoked automatically during vcard instance
     *     creation so you don't normally need to call it yourself.
     * @param {TP.ietf.vcard} aVCard The vcard instance to register.
     * @returns {TP.ietf.vcard} The registered vcard instance.
     */

    var id,
        keys;

    if (!TP.canInvoke(aVCard, 'get')) {
        return this.raise('InvalidVCard', aVCard);
    }

    id = aVCard.get('fullname');
    if (TP.isEmpty(id)) {
        return this.raise('InvalidVCard', aVCard);
    }

    //  NOTE the access to the top-level type here, not 'this'.
    keys = TP.ietf.vcard.get('instances');
    keys.atPut(id, aVCard);

    return aVCard;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  Note the use of the non-standard '$def:' TIBET extension used to query
//  elements in default namespaces.

TP.ietf.vcard.Inst.defineAttribute('fullname',
    TP.xpc('./$def:fn/$def:text',
        TP.hc('shouldCollapse', true, 'extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('shortname',
    TP.xpc('./$def:n/$def:surname',
        TP.hc('shouldCollapse', true, 'extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('surname',
    TP.xpc('./$def:n/$def:surname',
        TP.hc('shouldCollapse', true, 'extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('givenname',
    TP.xpc('./$def:n/$def:given',
        TP.hc('shouldCollapse', true, 'extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('prefix',
    TP.xpc('./$def:n/$def:prefix',
        TP.hc('shouldCollapse', true, 'extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('nickname',
    TP.xpc('./$def:nickname/$def:text',
        TP.hc('shouldCollapse', true, 'extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('jid',
    TP.xpc('./$def:impp/$def:uri',
        TP.hc('shouldCollapse', true, 'extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('url',
    TP.xpc('./$def:url/$def:uri',
        TP.hc('shouldCollapse', true, 'extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('email',
    TP.xpc('./$def:email/$def:text',
        TP.hc('shouldCollapse', true, 'extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('tel',
    TP.xpc('./$def:tel/$def:text',
        TP.hc('shouldCollapse', true, 'extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('url',
    TP.xpc('./$def:url/$def:uri',
        TP.hc('shouldCollapse', true, 'extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('timezone',
    TP.xpc('./$def:tz/$def:text',
        TP.hc('shouldCollapse', true, 'extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('role',
    TP.xpc('./$def:role/$def:text',
        TP.hc('shouldCollapse', true, 'extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('otherroles',
    TP.xpc('./vcard-ext:x-otherroles/$def:text',
        TP.hc('extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('orgname',
    TP.xpc('./$def:org/$def:text',
        TP.hc('shouldCollapse', true, 'extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('otherorgnames',
    TP.xpc('./vcard-ext:x-otherorgs/$def:text',
        TP.hc('extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('orgunit',
    TP.xpc('./vcard-ext:x-orgunit/$def:text',
        TP.hc('shouldCollapse', true, 'extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('key',
    TP.xpc('./$def:key/$def:text',
        TP.hc('shouldCollapse', true, 'extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('secretkey',
    TP.xpc('./vcard-ext:x-secret-key',
        TP.hc('shouldCollapse', true, 'extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('username',
    TP.xpc('./vcard-ext:x-username',
        TP.hc('shouldCollapse', true, 'extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('password',
    TP.xpc('./vcard-ext:x-password/$def:text',
        TP.hc('shouldCollapse', true, 'extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('auth',
    TP.xpc('./vcard-ext:x-auth',
        TP.hc('shouldCollapse', true, 'extractWith', 'value')));

TP.ietf.vcard.Inst.defineAttribute('iswebdav',
    TP.xpc('./vcard-ext:x-is-webdav',
        TP.hc('shouldCollapse', true, 'extractWith', 'value')));

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.ietf.vcard.Inst.defineMethod('init',
function(aVCard) {

    /**
     * @method  init
     * @summary Creates a new vcard instance from the input data provided.
     *     Note that if the inbound vcard has an <fn> matching one already
     *     registered the new vcard will override the existing one. Also note
     *     that this method will update the associated resource instance if one
     *     is found for the 'id' (fullname) portion of the vcard.
     * @param {Element} aVCard The vcard element to wrap in an instance.
     * @returns {TP.ietf.vcard} The newly created vcard instance.
     */

    var id,
        resource;

    this.callNextMethod();

    //  Must have an ID to be a viable instance.
    if (TP.isEmpty(this.get('fullname'))) {
        return this.raise('InvalidVCard', aVCard);
    }

    TP.ietf.vcard.registerVCard(this);

    //  Update the associated resource to have the updated vCard instance.
    id = this.get('fullname');
    if (TP.notEmpty(id)) {
        resource = TP.core.Resource.getResourceById(id);
        if (TP.isValid(resource)) {
            resource.setVCard(this);
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.ietf.vcard.Inst.defineMethod('asJSONSource',
function() {

    /**
     * @method asJSONSource
     * @summary Returns a JSON string representation of the receiver.
     * @returns {String} A JSON-formatted string.
     */

    /*
    var str;

    str = '["vcard",' +
            '[' +
            '["version", {}, "text", "4.0"],';

    str += ']' +
            ']';
    */

    //  TODO: Finish the implementation here according to RFC 7095

    return TP.todo();
});

//  ------------------------------------------------------------------------

TP.ietf.vcard.Inst.defineMethod('getAccessKeys',
function() {

    /**
     * @method getAccessKeys
     * @summary Returns an array of permission keys defined by the receiver's
     *     role and unit definitions.
     * @returns {String[]} An array of permission keys (strings).
     */

    var keys,
        roles,
        units,
        names;

    //  NOTE
    //  we cache the key string to avoid recomputation overhead
    if (TP.notEmpty(keys = this.getAttribute('keys'))) {
        return keys.split(' ');
    }

    keys = TP.ac();

    names = this.getRoleNames();

    roles = this.getRoles();
    keys = roles.injectInto(
            keys,
            function(role, accum) {
                accum.push.apply(accum, role.getAccessKeys(names));

                return accum;
            });

    names = this.getOrgUnitNames();

    units = this.getUnits();
    keys = units.injectInto(
            keys,
            function(unit, accum) {
                accum.push.apply(accum, unit.getAccessKeys(names));

                return accum;
            });

    //  since we've blended keys from a number of sources, unique and sort
    //  for easier debugging in the UI
    return keys.unique().sort();
});

//  ------------------------------------------------------------------------

TP.ietf.vcard.Inst.defineMethod('getOrgNames',
function() {

    /**
     * @method getOrgNames
     * @summary Returns an array of org names found in the vcard instance.
     * @returns {String[]} An array of org names.
     */

    var org,
        names;

    //  Grab the name of the primary org name.
    org = this.get('orgname');
    if (TP.isEmpty(org)) {
        return TP.ac();
    }

    //  Get any 'other orgs' that the card might define (using a TIBET-extended)
    //  vCard schema. If there are no other orgs, just create an empty Array.
    names = this.get('otherorgnames');
    if (TP.notValid(names)) {
        names = TP.ac();
    }

    //  Set the primary org as the first org by unshifting it onto the front of
    //  the list of orgs.
    names.unshift(org);

    return names;
});

//  ------------------------------------------------------------------------

TP.ietf.vcard.Inst.defineMethod('getOrgUnitNames',
function() {

    /**
     * @method getOrgUnitNames
     * @summary Returns an array of org-unit names found in the vcard. Note this
     *     list is the combination of orgname and orgunit information with a '-'
     *     separator injected between them.
     * @returns {String[]} An array of org-unit names.
     */

    var orgs,
        units,
        name,
        i,
        j,
        results;

    orgs = this.getOrgNames();
    units = this.getUnitNames();

    results = TP.ac();

    for (i = 0; i < orgs.getSize(); i++) {
        for (j = 0; j < units.getSize(); j++) {
            //  we normalize both the org name and role name so things like
            //  dashes, slashes, parens, etc. in names don't mess us up.
            name = orgs.at(i).asJSIdentifier() + '-' +
                units.at(j).asJSIdentifier();
            results.push(name);
        }
    }

    results.compact();

    return results;
});

//  ------------------------------------------------------------------------

TP.ietf.vcard.Inst.defineMethod('getRoleNames',
function() {

    /**
     * @method getRoleNames
     * @summary Returns an array of role names found in the vcard instance.
     * @returns {String[]} An array of role names.
     */

    var role,
        names;

    //  Grab the name of the primary role.
    role = this.get('role');
    if (TP.isEmpty(role)) {
        return TP.ac();
    }

    //  Get any 'other roles' that the card might define (using a TIBET-extended)
    //  vCard schema. If there are no other roles, just create an empty Array.
    names = this.get('otherroles');
    if (TP.notValid(names)) {
        names = TP.ac();
    }

    //  Set the primary role as the first role by unshifting it onto the front of
    //  the list of roles.
    names.unshift(role);

    return names;
});

//  ------------------------------------------------------------------------

TP.ietf.vcard.Inst.defineMethod('getRoles',
function() {

    /**
     * @method getRoles
     * @summary Returns an array of TP.core.Role types that were found for the
     *     receiver. When a named role can't be loaded it won't be included in
     *     this list, and a warning will be logged.
     * @returns {TP.core.Role[]} An array containing loadable TP.core.Role
     *     types.
     */

    var orgs,
        roles,
        results,
        i,
        j,
        typeName;

    orgs = this.getOrgNames();
    roles = this.getRoleNames();

    results = TP.ac();

    for (i = 0; i < orgs.getSize(); i++) {
        for (j = 0; j < roles.getSize(); j++) {
            //  we normalize both the org name and role name so things like
            //  dashes, slashes, parens, etc. in names don't mess us up.
            typeName = orgs.at(i).asJSIdentifier() + '-' +
                roles.at(j).asJSIdentifier();

            //  NOTE we push the type if found, otherwise we push the
            //  top-level role class (which can still load keys etc).
            results.push(
                TP.sys.getTypeByName('APP.role.' + typeName) ||
                TP.sys.getTypeByName('TP.role.' + typeName) ||
                TP.core.Role);
        }
    }

    //  Make sure to remove any null/undefined values
    results.compact();

    return results;
});

//  ------------------------------------------------------------------------

TP.ietf.vcard.Inst.defineMethod('getUnitNames',
function() {

    /**
     * @method getUnitNames
     * @summary Returns an array of unit names found in the vcard instance.
     *     Note this is the set of ORGUNIT element values without any ORGNAME.
     * @returns {String[]} An array of unit names (TP.core.Unit subtype names).
     */

    var unit;

    unit = this.get('orgunit');
    if (TP.isEmpty(unit)) {
        return TP.ac();
    }

    return unit.split(';').compact();
});

//  ------------------------------------------------------------------------

TP.ietf.vcard.Inst.defineMethod('getUnits',
function() {

    /**
     * @method getUnits
     * @summary
     * @returns {TP.meta.role[]}
     */

    var names;

    names = this.getOrgUnitNames();

    return names.collect(function(name) {
        return TP.sys.getTypeByName('APP.unit.' + name) ||
            TP.sys.getTypeByName('TP.unit.' + name) ||
            TP.core.Unit;
    });
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================

//  ========================================================================
//  TP.tibet.keyring
//  ========================================================================

/**
 * @type {TP.tibet.keyring}
 * @summary A keyring is a container for one or more keys, strings that
 *     represent individual permissions within an application. Obviously this
 *     isn't a security feature, it's designed more with allowing easy CSS
 *     and functionality switching based on user role assignments, helping to
 *     ease development of applications that have role-specific UI features.
 *     Data security is presumed to be managed at the server as appropriate.
 * @description To help manage permissions in the most flexible way possible
 *     TIBET uses the concept of keys, strings you define to have some meaning
 *     relative to permissions in your application. These keys can be grouped
 *     within keyrings, which can be nested to keep things easier to maintain.
 *
 *     After a user logs in you can supply a vcard which defines the user's
 *     organization-qualified role and unit affiliations. The role and unit
 *     definitions found in the vcard provide one or more keyrings to their
 *     associated user(s), granting members their permissions. The permission
 *     strings are added to TIBET's UICANVAS <body> element for help in driving
 *     CSS rules which alter UI based on a user's particular role/unit.
 *
 *     See the keyrings.xml sample file for specific markup examples.
 */

//  ------------------------------------------------------------------------

TP.dom.ElementNode.defineSubtype('tibet:keyring');

//  ------------------------------------------------------------------------
//  Types Attributes
//  ------------------------------------------------------------------------

/**
 * The dictionary of registered keyrings.
 * @type {TP.core.Hash}
 */
TP.tibet.keyring.Type.defineAttribute('instances', TP.hc());

//  ------------------------------------------------------------------------
//  Types Methods
//  ------------------------------------------------------------------------

TP.tibet.keyring.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    var url;

    url = TP.sys.cfg('path.app_keyrings');
    if (TP.notEmpty(url)) {
        TP.tibet.keyring.loadKeyrings(url).then(function(result) {
            TP.tibet.keyring.initKeyrings(result);
        }).catch(function(err) {
            TP.ifError() ?
                TP.error('Error loading application keyrings: ' +
                            TP.str(err)) : 0;
        });
    }

    url = TP.sys.cfg('path.lib_keyrings');
    if (TP.notEmpty(url)) {
        TP.tibet.keyring.loadKeyrings(url).then(function(result) {
            TP.tibet.keyring.initKeyrings(result);
        }).catch(function(err) {
            TP.ifError() ?
                TP.error('Error loading library keyrings: ' +
                            TP.str(err)) : 0;
        });
    }
});

//  ------------------------------------------------------------------------

TP.tibet.keyring.Type.defineMethod('generate',
function(anID) {

    /**
     * @method generate
     * @summary Generates a new keyring instance using the ID provided.
     * @param {String} anID The keyring ID to build.
     * @returns {TP.tibet.keyring} The new instance.
     */

    var id,
        node;

    id = TP.ifEmpty(anID, TP.sys.cfg('user.default_keyring'));

    node = TP.elementFromString(
                    '<keyring' +
                    ' xmlns="' + TP.w3.Xmlns.TIBET + '"' +
                    ' id="' + id + '"/>');

    return TP.tibet.keyring.construct(node);
});

//  ------------------------------------------------------------------------

TP.tibet.keyring.Type.defineMethod('getInstanceById',
function(anID) {

    /**
     * @method getInstanceById
     * @summary Returns the keyring instance whose id attribute matches the ID
     *     provided. If the ID matches that of the user.default_keys value and
     *     the keyring isn't found a default version will be created.
     * @returns {tibet:keyring} A keyring element wrapper.
     */

    var keyrings,
        inst;

    //  NOTE the access to the top-level type here, not 'this'.
    keyrings = TP.tibet.keyring.get('instances');

    inst = keyrings.at(anID);
    if (TP.isValid(inst)) {
        return inst;
    }

    //  Due to startup sequencing we may need to create the default instance on
    //  demand. Role/Unit initializers trigger a call to this method.
    return this.generate(anID);
});

//  ------------------------------------------------------------------------

TP.tibet.keyring.Type.defineMethod('initKeyrings',
function(aDocument) {

    /**
     * @method initKeyrings
     * @summary Initializes instances of keyring based on keyring elements found
     *     in the document provided. This method is usually invoked after a call
     *     to loadKeyrings to acquire a keyrings document.
     * @param {Document} aDocument A TIBET keyrings document. See the
     *     documentation on TIBET Keyring files for more information.
     * @returns {TP.tibet.keyring[]} An array of keyring instances created.
     */

    var keyrings,
        type,
        list;

    if (!TP.isDocument(aDocument)) {
        return this.raise('InvalidDocument', aDocument);
    }

    type = TP.tibet.keyring;

    keyrings = TP.nodeEvaluateXPath(aDocument, '//$def:keyring', TP.NODESET);
    list = keyrings.collect(
                function(elem) {
                    if (TP.isEmpty(TP.elementGetAttribute(elem, 'id'))) {
                        return;
                    }
                    return type.construct(elem);
                });

    return list.compact();
});

//  ------------------------------------------------------------------------

TP.tibet.keyring.Type.defineMethod('loadKeyrings',
function(aURI) {

    /**
     * @method loadKeyrings
     * @summary Loads keyring data from the URI provided, or from the default
     *     keyring path if one is defined. The resulting document can then be
     *     passed to initKeyrings() which will construct instances for each of
     *     the keyring elements found in the document.
     * @returns {TP.sig.Response|undefined} A TIBET Response object (which is
     *     Promise-compatible) which will resolve on completion.
     */

    var url,
        fname;

    url = aURI;

    if (TP.notValid(aURI)) {
        //  If we don't have a viable setting for application-level keyrings we
        //  should try library-level keyrings.
        url = TP.sys.cfg('path.app_keyrings');
        if (TP.isEmpty(url)) {

            //  If we don't have a viable setting for library-level keyrings
            //  then we should just return quietly.
            url = TP.sys.cfg('path.lib_keyrings');
            if (TP.isEmpty(url)) {
                return;
            }
        }
    }

    //  If we got a URI or path of some kind it's time to validate it and create
    //  the URI instance needed to perform the data load.
    if (!TP.isKindOf(url, TP.uri.URI)) {
        fname = TP.uriExpandPath(url);
        if (!TP.isURI(url = TP.uc(fname))) {
            return this.raise('InvalidURI', aURI);
        }
    }

    return url.getResource(TP.hc('resultType', TP.DOM));
});

//  ------------------------------------------------------------------------

TP.tibet.keyring.Type.defineMethod('registerKeyring',
function(aKeyring) {

    /**
     * @method registerKeyring
     * @summary Registers a single keyring with the keyring type. This method is
     *     invoked automatically during keyring instance creation so you don't
     *     normally need to call it yourself.
     * @param {TP.tibet.keyring} aKeyring The keyring instance to register.
     * @returns {TP.tibet.keyring|undefined} The registered keyring instance.
     */

    var id,
        keys;

    if (!TP.canInvoke(aKeyring, 'getKeyID')) {
        return this.raise('InvalidKeyring', aKeyring);
    }

    id = aKeyring.getKeyID();
    if (TP.isEmpty(id)) {
        //  Might be a ref to another one (which we ignore).
        if (TP.isEmpty(aKeyring.getNativeNode().getAttribute('ref'))) {
            return this.raise('InvalidKeyring', aKeyring);
        } else {
            return;
        }
    }

    //  NOTE the access to the top-level type here, not 'this'.
    keys = TP.tibet.keyring.get('instances');
    keys.atPut(id, aKeyring);

    return aKeyring;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.tibet.keyring.Inst.defineMethod('init',
function(aKeyring) {

    /**
     * @method  init
     * @summary Creates a new keyring instance from the input data provided.
     *     Note that if the inbound keyring has an ID matching one already
     *     registered the new keyring will override the existing one.
     * @param {Element} aKeyring The keyring element to wrap in an instance.
     * @returns {TP.tibet.keyring} The newly created keyring instance.
     */

    this.callNextMethod();

    //  Must have an ID to be a viable instance.
    if (TP.isEmpty(this.getID())) {
        return this.raise('InvalidKeyring', aKeyring);
    }

    TP.tibet.keyring.registerKeyring(this);

    return this;
});

//  ------------------------------------------------------------------------

TP.tibet.keyring.Inst.defineMethod('getAccessKeys',
function() {

    /**
     * @method getAccessKeys
     * @summary Returns an array of the string keys found in the receiver.
     * @returns {String[]} An array containing the string keys of the receiver.
     */

    var keys,
        arr,
        rings;

    //  NOTE: we cache the key string to avoid recomputation overhead,
    //  particularly around nested keyrings.

    //  ALSO: since we use the keys attribute as a cache this can be leveraged
    //  by any web service you may write as a way to return an element of the
    //  form <keyring keys="ab cd ef"/> rather than a nested structure.
    if (TP.notEmpty(keys = this.getAttribute('keys'))) {
        return keys.split(' ');
    }

    //  build an empty array we can inject into the following processes
    keys = TP.ac();

    //  first we'll gather up any keys from our "child" keyrings
    rings = this.getKeyrings();
    keys = rings.injectInto(
                keys,
                function(ring, accum) {

                    //  the apply will flatten the nested keys into the keyset
                    accum.push.apply(accum, ring.getAccessKeys());

                    //  injectInto requires that we return the injected data
                    return accum;
                });

    //  now we want to add our local keys (make sure that we get an Array even
    //  if there's only one)
    arr = this.evaluateXPath('./$def:key/@name', TP.NODESET);
    keys = arr.injectInto(
                keys,
                function(attr, accum) {

                    //  turn attribute nodes into string values
                    accum.push(TP.str(attr.value));

                    //  injectInto requires that we return the injected data
                    return accum;
                });

    //  since we've blended keys from a number of sources, unique and sort for
    //  easier debugging in the UI
    keys = keys.unique().sort();

    //  cache the result
    this.setAttribute('keys', keys.join(' '));

    return keys;
});

//  ------------------------------------------------------------------------

TP.tibet.keyring.Inst.defineMethod('getKeyrings',
function() {

    /**
     * @method getKeyrings
     * @summary Returns an array of any nested keyrings found in the receiver.
     *     This list's related keys also become part of the overall key set
     *     returned by the getAccessKeys() method so you rarely need to call it
     *     directly.
     * @returns {String[]} An array containing the string keys of the receiver.
     */

    var arr;

    //  NB: we make sure that we get an Array even if there's only one
    arr = this.evaluateXPath('./$def:keyring/@ref', TP.NODESET);
    arr.convert(
        function(attr) {

            return TP.tibet.keyring.getInstanceById(TP.str(attr.value));
        });

    return arr;
});

//  ------------------------------------------------------------------------

TP.tibet.keyring.Inst.defineMethod('getKeyID',
function() {

    /**
     * @method getKeyID
     * @summary Returns the receiver's key ID, the unique keyring ID it uses.
     * @returns {String} The ID value.
     */

    return TP.elementGetAttribute(this.getNativeNode(), 'id');
});

//  ------------------------------------------------------------------------

TP.tibet.keyring.Inst.defineMethod('hasAccessKey',
function(aKey) {

    /**
     * @method hasAccessKey
     * @summary Returns true if the receiving key ring has the named key.
     * @returns {Boolean} True if the key is found.
     */

    return this.getAccessKeys().contains(aKey);
});

//  ========================================================================
//  TP.tag.TagProcessor
//  ========================================================================

/**
 * @type {TP.tag.TagProcessor}
 * @summary The core engine responsible for processing tags (or any type of DOM
 *     construct like PIs or Text nodes, really). This object holds a set of
 *     processing phases and is responsible for executing them against a chunk
 *     of supplied content.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('tag.TagProcessor');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  A set of phase types used when 'attaching' content to a visual DOM
TP.tag.TagProcessor.Type.defineConstant(
    'ATTACH_PHASES',
    TP.ac(
    'TP.tag.AttachDOMPhase',       //  Late additions to the DOM needed for
                                    //  visual structuring
    'TP.tag.AttachEventsPhase',    //  ev: namespace. NOTE others can generate
    'TP.tag.AttachSignalsPhase',   //  on: namespace (for non-native events)
    'TP.tag.AttachDataPhase',      //  model construct et. al.
    'TP.tag.AttachInfoPhase',      //  other info tags (acl:, dnd:, etc)
    'TP.tag.AttachBindsPhase',     //  data bindings in the bind: namespace
    'TP.tag.AttachStylePhase',     //  CSS is near end so display: none can
                                    //  flip late
    'TP.tag.AttachCompletePhase'
    ));

//  A set of phase types used when 'detaching' content from a visual DOM
//  Note how these are reversed from the attach phases, to give things that rely
//  on these phases chance to unwind in reverse order.
TP.tag.TagProcessor.Type.defineConstant(
    'DETACH_PHASES',
    TP.ac(
    'TP.tag.DetachStylePhase',
    'TP.tag.DetachDataPhase',
    'TP.tag.DetachBindsPhase',
    'TP.tag.DetachInfoPhase',
    'TP.tag.DetachSignalsPhase',
    'TP.tag.DetachEventsPhase',
    'TP.tag.DetachDOMPhase',
    'TP.tag.DetachCompletePhase'
    ));

//  A set of phase types used when 'computing' or transforming content from one
//  representation into another.
TP.tag.TagProcessor.Type.defineConstant(
    'COMPILE_PHASES',
    TP.ac(
    'TP.tag.IncludesPhase',        //  xi:includes, CSS @imports, etc.
    'TP.tag.InstructionsPhase',    //  ?tibet, ?xsl-stylesheet, etc.
    'TP.tag.PrecompilePhase',      //  conversion to computable form
    'TP.tag.CompilePhase',         //  tag/macro expansion (ACT)
    'TP.tag.TidyPhase',            //  move non-DTD content out of html:head
                                    //  etc.

    'TP.tag.ResolvePhase',         //  resolve xml:base TP.uri.URI references,
                                    //  decode etc.

    'TP.tag.LocalizePhase',        //  adjust for browser, lang, etc.
    'TP.tag.CompileCompletePhase'
    ));

//  A common query used by some phases to find custom nodes - elements or
//  attributes. This query returns only nodes that are:
//      1. Element-type Nodes OR
//      2. Attribute-type Nodes that:
//          a. Have a namespace - most don't
//          b. Are not in the 'bind:' namespace
//          c. Are not in the 'ev:' namespace
//          d. Are not in the 'on:' namespace

//  A version of the expression that filters out elements that have an ancestor
//  with an attribute of 'tibet:no-compile'.
TP.tag.TagProcessor.Type.defineConstant(
    'CUSTOM_NODES_QUERY_NO_COMPILE',
        'descendant-or-self::*[not(ancestor::*[@tibet:no-compile])]' +
        ' | ' +
        'descendant-or-self::*[not(ancestor::*[@tibet:no-compile])]/@*[' +
        'namespace-uri() != ""' +
        ' and ' +
        'namespace-uri() != "' + TP.w3.Xmlns.XML + '"' +
        ' and ' +
        'namespace-uri() != "' + TP.w3.Xmlns.BIND + '"' +
        ' and ' +
        'namespace-uri() != "' + TP.w3.Xmlns.XML_EVENTS + '"' +
        ' and ' +
        'namespace-uri() != "' + TP.w3.Xmlns.ON + '"' +
        ']');

//  A version of the expression that filters out elements that have an ancestor
//  with an attribute of 'tibet:no-compile'.
TP.tag.TagProcessor.Type.defineConstant(
    'CUSTOM_NODES_QUERY_NO_AWAKEN',
        'descendant-or-self::*[not(ancestor::*[@tibet:no-awaken])]' +
        ' | ' +
        'descendant-or-self::*[not(ancestor::*[@tibet:no-awaken])]/@*[' +
        'namespace-uri() != ""' +
        ' and ' +
        'namespace-uri() != "' + TP.w3.Xmlns.XML + '"' +
        ' and ' +
        'namespace-uri() != "' + TP.w3.Xmlns.BIND + '"' +
        ' and ' +
        'namespace-uri() != "' + TP.w3.Xmlns.XML_EVENTS + '"' +
        ' and ' +
        'namespace-uri() != "' + TP.w3.Xmlns.ON + '"' +
        ']');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

/**
 * A dictionary (hash) of tag types to tag identifiers. This is a cache so that
 * we don't have to look up the types each time.
 * @type {TP.core.Hash}
 */
TP.tag.TagProcessor.Type.defineAttribute('$tagTypeDict');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tag.TagProcessor.Type.defineMethod('constructWithPhaseTypes',
function(phaseTypesArray) {

    /**
     * @method constructWithPhaseTypes
     * @summary Returns an instance of a tag processor with a set of instances
     *     of phases constructed from the supplied Array of phase types.
     * @param {String[]} phaseTypesArray The Array of phase type objects to
     *     construct the phases from.
     * @returns {TP.tag.TagProcessor} A new instance configured with instances
     *     of the phase types as its phase list.
     */

    var phaseInstances,
        newInst;

    phaseInstances = phaseTypesArray.collect(
                        function(phaseType) {
                            return phaseType.construct();
                        });

    newInst = this.construct(phaseInstances);

    return newInst;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

/**
 * The list of phases to run over the content when this processor is used
 * @type {String[]}
 */
TP.tag.TagProcessor.Inst.defineAttribute('phases');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.tag.TagProcessor.Inst.defineMethod('init',
function(phases) {

    /**
     * @method init
     * @summary Initialize the instance.
     * @param {String[]} phases The list of phases to use when this processor is
     *     run over supplied content.
     * @returns {TP.tag.TagProcessor} The receiver.
     */

    this.callNextMethod();

    this.set('phases', phases);

    return this;
});

//  ------------------------------------------------------------------------

TP.tag.TagProcessor.Inst.defineMethod('processTree',
function(aNode, aRequest, allowDetached) {

    /**
     * @method processTree
     * @summary Processes the supplied tree of content through this processor's
     *     configured set of phases.
     * @param {Node} aNode The node tree to use as the root to start the
     *     processing.
     * @param {TP.sig.Request} aRequest The request containing control
     *     parameters which may or may not be used, depending on the phase
     *     involved.
     * @param {Boolean} [allowDetached=false] Whether or not this method should
     *     allow detached nodes to be processed. Normally, this method does not
     *     process detached nodes, but sometimes (i.e. during node detachment
     *     unawaken processing), whether a node is detached or not needs to be
     *     ignored (obviously).
     * @exception TP.sig.InvalidNode
     * @returns {TP.tag.TagProcessor} The receiver.
     */

    var phases,

        currentNode,

        len,
        i,

        wasACPTextNode,

        parentNode;

    if (!TP.isNode(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  Normalize the node to try to reduce the number of Text nodes as much as
    //  possible
    TP.nodeNormalize(aNode);

    phases = this.get('phases');

    currentNode = aNode;

    //  Iterate over the phases, processing the content through each one.
    len = phases.getSize();
    for (i = 0; i < len; i++) {

        //  A flag that is used if the currently processing node is a Text node
        //  containing ACP expressions.
        wasACPTextNode = false;

        //  If the node is a Text node and had ACP expressions, flag it and
        //  capture it's parent node.
        if (TP.isTextNode(currentNode) &&
            TP.regex.HAS_ACP.test(TP.nodeGetTextContent(currentNode))) {

            wasACPTextNode = true;
            parentNode = currentNode.parentNode;
        }

        phases.at(i).processNode(currentNode, this, aRequest, allowDetached);

        //  If we were processing a Text node containing ACP expressions and
        //  it's now detached, then we resume the next phase at it's (former)
        //  parent node (since it might have been replaced by a whole fragment).
        if (wasACPTextNode && TP.nodeIsDetached(currentNode)) {
            currentNode = parentNode;
        }
    }

    //  NB: We do *not* bubble XML namespaces here, since they will just end up
    //  on our processing node, doing us no good and - in some cases - actually
    //  doing harm.

    return this;
});

//  ========================================================================
//  TP.tag.TagProcessorPhase
//  ========================================================================

/**
 * @type {TP.tag.TagProcessorPhase}
 * @summary The top-level tag processor 'phase' type, used in conjunction with
 *     the tag processor type. The tag processor holds 1...n phases and
 *     processes it's content through each one.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('tag.TagProcessorPhase');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.tag.TagProcessorPhase.Inst.defineMethod('getFilteredNodes',
function(aNode, aProcessor) {

    /**
     * @method getFilteredNodes
     * @summary Given the supplied node, this method queries it (using the
     *     'queryForNodes()' method) and then filters that set down to the nodes
     *     whose TIBET wrapper type can respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @param {TP.tag.TagProcessor} aProcessor The processor that 'owns' this
     *     phase.
     * @exception TP.sig.InvalidNode
     * @exception TP.sig.InvalidParameter
     * @returns {Node[]} An array containing a set of filtered Nodes.
     */

    var methodName,

        tagTypeDict,
        canInvokeInfo,

        queriedNodes,
        filteredNodes;

    if (!TP.isNode(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    if (!TP.isString(methodName = this.getTargetMethod())) {
        return this.raise('TP.sig.InvalidParameter');
    }

    //  Grab the processor-wide tag type hash that is used to cache tag types.
    tagTypeDict = aProcessor.getType().get('$tagTypeDict');
    if (TP.notValid(tagTypeDict)) {
        tagTypeDict = TP.hc();
        aProcessor.getType().set('$tagTypeDict', tagTypeDict);
    }

    //  Build a hash that will track whether certain tag types can invoke the
    //  target method for this phase.
    canInvokeInfo = TP.hc();

    //  Query the tree for the set of nodes to consider when processing. This
    //  can significantly reduce the number of nodes considered.
    queriedNodes = this.queryForNodes(aNode);

    //  Out of the batch of queried nodes, select only those whose TIBET wrapper
    //  type implement this phases's target method.
    filteredNodes = queriedNodes.select(
        function(node) {
            var type,
                elemKey,

                canInvoke;

            //  If the considered node is an element, see if there are entries
            //  for it in the tag type hash and invocation tracking hash under
            //  its full name. This means this type of element has already been
            //  found once and queried as to whether it can respond to this
            //  phase's target method.
            if (TP.isElement(node)) {
                elemKey = TP.elementComputeTIBETTypeKey(node);
                if (tagTypeDict.hasKey(elemKey) &&
                    canInvokeInfo.hasKey(elemKey)) {
                    return canInvokeInfo.at(elemKey);
                }
            }

            //  If we can't get a concrete type at all, then we just return
            //  false. Can't do anything from here.
            if (!TP.isType(type = TP.dom.Node.getConcreteType(node))) {
                return false;
            }

            //  If the type is an abstract type, warn about it. It's probably
            //  not what we're looking for.
            if (!tagTypeDict.hasKey(elemKey) &&
                TP.notEmpty(elemKey) &&
                type.isAbstract()) {
                TP.ifWarn() ?
                    TP.warn('Abstract type: ' + TP.name(type) +
                            ' computed for element key: ' + elemKey + '.') : 0;
            }

            //  If we're processing an Element, elemKey will have been set
            //  above.
            if (TP.notEmpty(elemKey) &&
                elemKey !== 'processingroot' &&
                type === TP.dom.XMLElementNode &&
                TP.sys.cfg('lama.autodefine_missing_tags')) {

                //  If the Lama is loaded and has been configured to
                //  automatically define missing tags, then we do so.
                if (TP.sys.hasFeature('lama')) {
                    TP.lama.IDE.replaceWithUnknownElementProxy(node);
                }
            }

            canInvoke = TP.canInvoke(type, methodName);

            //  If the considered node is an element, then we can make an entry
            //  for it in our tag type hash and invocation tracking hash under
            //  that name for later fast lookup for the same type of element in
            //  the tree of nodes being considered.
            if (TP.isElement(node)) {
                tagTypeDict.atPut(elemKey, type);
                canInvokeInfo.atPut(elemKey, canInvoke);
            }

            return canInvoke;
        });

    return filteredNodes;
});

//  ------------------------------------------------------------------------

TP.tag.TagProcessorPhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.tag.TagProcessorPhase.Inst.defineMethod('processNode',
function(aNode, aProcessor, aRequest, allowDetached) {

    /**
     * @method processNode
     * @summary Processes the content of the supplied Node through this
     *     processor phase.
     * @param {Node} aNode The root node to start the processing from.
     * @param {TP.tag.TagProcessor} aProcessor The processor that 'owns' this
     *     phase.
     * @param {TP.sig.Request} aRequest The request containing control
     *     parameters which may or may not be used, depending on the phase
     *     involved.
     * @param {Boolean} [allowDetached=false] Whether or not this method should
     *     allow detached nodes to be processed. Normally, this method does not
     *     process detached nodes, but sometimes (i.e. during node detachment
     *     unawaken processing), whether a node is detached or not needs to be
     *     ignored (obviously).
     * @exception TP.sig.InvalidNode
     * @exception TP.sig.InvalidParameter
     * @returns {TP.tag.TagProcessorPhase} The receiver.
     */

    var methodName,
        nodes,
        tagTypeDict,

        producedEntries,

        processingRequest,

        len,
        i,

        node,
        type,

        result,

        subPhases,
        subProcessor,
        subProcessingRequest,

        sources,

        nodeToProcess,
        source;

    if (!TP.isNode(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    if (!TP.isString(methodName = this.getTargetMethod())) {
        return this.raise('TP.sig.InvalidParameter');
    }

    if (TP.isEmpty(nodes = this.getFilteredNodes(aNode, aProcessor))) {
        return this;
    }

    //  Configure the processing request, starting with any parameters from the
    //  supplied request.
    processingRequest = TP.request(aRequest);

    processingRequest.atPut('currentPhase', this);
    processingRequest.atPut('phases', aProcessor.get('phases'));

    processingRequest.atPutIfAbsent('doc', TP.nodeGetDocument(aNode));

    //  Some invokers of this method will have the content in a 'processing
    //  root' element that takes into account that this engine holds onto the
    //  same node throughout the transformation process, so that's not the node
    //  that can itself be transformed. In any case, we want our 'root'
    //  parameter to be set to that root element's firstChild if it's present.
    if (TP.isElement(aNode) &&
        TP.elementGetLocalName(aNode) === 'processingroot') {
        processingRequest.atPut('root', aNode.firstChild);
    } else {
        processingRequest.atPut('root', aNode);
    }

    //  Grab the processor-wide tag type hash that is used to cache tag types.
    tagTypeDict = aProcessor.getType().get('$tagTypeDict');
    if (TP.notValid(tagTypeDict)) {
        tagTypeDict = TP.hc();
        aProcessor.getType().set('$tagTypeDict', tagTypeDict);
    }

    //  Any nodes that are actually newly-produced (and returned) by running the
    //  processor over the supplied content.
    producedEntries = TP.ac();

    //  Put a reference to all of the nodes that this phase identifier for
    //  processing. NOTE: This Array can be modified by the phase. See note
    //  below about why 'getSize()' is used each time through the loop.
    processingRequest.atPut('detectedNodes', nodes);

    //  NB: Do *not* change this to have a cached size - leave it as
    //  'getSize()', since processing steps can remove nodes from this Array as
    //  they process and this needs to be retested each time.
    for (i = 0; i < nodes.getSize(); i++) {
        node = nodes.at(i);

        //  If one of the phases detached this node, then just continue on.
        if (TP.nodeIsDetached(node) && TP.notTrue(allowDetached)) {
            continue;
        }

        //  If the considered node is an element, see if there are entries for
        //  it in the tag type hash under its full name. This means this type of
        //  element has already been found once. Otherwise, just go ahead and
        //  query it for it's TIBET wrapper type.
        if (TP.isElement(node)) {
            if (TP.elementGetLocalName(node) === 'processingroot') {
                continue;
            }

            if (!TP.isType(type = tagTypeDict.at(
                                    TP.elementComputeTIBETTypeKey(node)))) {
                type = TP.dom.Node.getConcreteType(node);
            }
        } else {
            type = TP.dom.Node.getConcreteType(node);
        }

        processingRequest.atPut('node', node);

        try {
            //  Do the deed, invoking the target method against the wrapper type
            //  and supplying the request.
            result = type[methodName](processingRequest);
        } catch (e) {
            TP.ifError() ?
                TP.error(TP.ec(e,
                        'Error in ' +
                        type.getTypeName() + ' for: ' + TP.str(node))) : 0;
        }

        //  If we got a node we need to inspect that node and compare to result
        //  to determine the right action to take.
        if (TP.isNode(result)) {

            //  Compare result. If identical or equal we essentially have an
            //  "unprocessed" variation of the original node as our result.
            if (result === node || TP.nodeEqualsNode(result, node)) {

                //  If the node had a generator and it's not the same as the one
                //  for our result node we've got outstanding work to do due to
                //  the generator change, otherwise we're done here.
                if (TP.isValid(node[TP.GENERATOR]) &&
                    node[TP.GENERATOR] !== result[TP.GENERATOR]) {
                    void 0;
                } else {
                    //  If we were to reprocess here the likely result is an
                    //  endless recursion since we got back matching content the
                    //  first time through.
                    continue;
                }
            } else if (TP.isValid(node[TP.GENERATOR]) &&
                node[TP.GENERATOR] === result[TP.GENERATOR]) {
                //  Otherwise, if the node had a generator and it *is* the same
                //  as the one for our result node, we have no more outstanding
                //  work to do. Continue on to the next node.
                continue;
            }

            producedEntries.push(TP.ac(result, node));
        }
    }

    //  If the list of nodes that executing this phase against the various
    //  target content Nodes is not empty, then we need to process them *from
    //  the processor's first phase up through ourself* (so as to have
    //  consistent results).
    if (TP.notEmpty(producedEntries)) {
        //  Grab the processor's phase list and slice a copy of it from the
        //  beginning to this phase (inclusive)
        subPhases = aProcessor.get('phases');

        subPhases = subPhases.slice(0, subPhases.indexOf(this) + 1);

        //  Configure a new processor with that phase list
        subProcessor = TP.tag.TagProcessor.construct();
        subProcessor.set('phases', subPhases);

        subProcessingRequest = TP.request(aRequest);

        //  The 'sources' Array provides processing sub nodes with a reference
        //  back to the node that produced them
        if (!TP.isArray(sources = subProcessingRequest.at('sources'))) {
            sources = TP.ac();
            subProcessingRequest.atPut('sources', sources);
        }

        //  Run the subprocessor on the produced nodes, thereby recursively
        //  processing the tree.
        len = producedEntries.getSize();
        for (i = 0; i < len; i++) {

            nodeToProcess = producedEntries.at(i).first();
            source = producedEntries.at(i).last();

            //  If one of the phases detached this node, then just continue on.
            if (TP.nodeIsDetached(nodeToProcess) && TP.notTrue(allowDetached)) {
                continue;
            }

            //  Push the node that produced the node we're going to process into
            //  the sources Array. See above to see how producedEntries is
            //  populated.
            sources.push(source);

            subProcessor.processTree(nodeToProcess, subProcessingRequest);

            //  Pop the source that was in effect.
            sources.pop();
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.tag.TagProcessorPhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var query,
        queriedNodes;

    //  According to DOM Level 3 XPath, we can't use DocumentFragments as the
    //  context node for evaluating an XPath expression.
    if (!TP.isNode(aNode) || TP.isFragment(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  The default phase grabs *all* nodes here - not just Elements. Note that
    //  this expression will also grab aNode itself.
    query = 'descendant-or-self::node()';

    queriedNodes = TP.nodeEvaluateXPath(aNode, query, TP.NODESET);

    return queriedNodes;
});

//  ========================================================================
//  TP.tag.IncludesPhase
//  ========================================================================

/**
 * @type {TP.tag.IncludesPhase}
 */

//  ------------------------------------------------------------------------

TP.tag.TagProcessorPhase.defineSubtype('tag.IncludesPhase');

//  ------------------------------------------------------------------------

TP.tag.IncludesPhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagIncludes';
});

//  ------------------------------------------------------------------------

TP.tag.IncludesPhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var query,
        queriedNodes;

    //  According to DOM Level 3 XPath, we can't use DocumentFragments as the
    //  context node for evaluating an XPath expression.
    if (!TP.isNode(aNode) || TP.isFragment(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  If aNode is not a collection node, then the query will have no impact
    //  (and may error, depending on platform). Just return an empty Array.
    if (!TP.isCollectionNode(aNode)) {
        return TP.ac();
    }

    query = 'descendant-or-self::*[namespace-uri() = "' +
                                        TP.w3.Xmlns.XINCLUDE +
                                        '"]';

    queriedNodes = TP.nodeEvaluateXPath(aNode, query, TP.NODESET);

    return queriedNodes;
});

//  ========================================================================
//  TP.tag.InstructionsPhase
//  ========================================================================

/**
 * @type {TP.tag.InstructionsPhase}
 */

//  ------------------------------------------------------------------------

TP.tag.TagProcessorPhase.defineSubtype('tag.InstructionsPhase');

//  ------------------------------------------------------------------------

TP.tag.InstructionsPhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagInstructions';
});

//  ------------------------------------------------------------------------

TP.tag.InstructionsPhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var query,
        queriedNodes;

    //  According to DOM Level 3 XPath, we can't use DocumentFragments as the
    //  context node for evaluating an XPath expression.
    if (!TP.isNode(aNode) || TP.isFragment(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  If aNode is not a collection node, then the query will have no impact
    //  (and may error, depending on platform). Just return an empty Array.
    if (!TP.isCollectionNode(aNode)) {
        return TP.ac();
    }

    query = './/processing-instruction()[name()="tibet-stylesheet"]';

    queriedNodes = TP.nodeEvaluateXPath(aNode, query, TP.NODESET);

    return queriedNodes;
});

//  ========================================================================
//  TP.tag.PrecompilePhase
//  ========================================================================

/**
 * @type {TP.tag.PrecompilePhase}
 */

//  ------------------------------------------------------------------------

TP.tag.TagProcessorPhase.defineSubtype('tag.PrecompilePhase');

//  ------------------------------------------------------------------------

TP.tag.PrecompilePhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagPrecompile';
});

//  ------------------------------------------------------------------------

TP.tag.PrecompilePhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var queriedNodes;

    if (!TP.isNode(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  If the supplied node is a text node or an attribute node and has ACP
    //  (templating) expressions, then return an Array with that node's either
    //  ownerElement or parentNode (depending on whether it is an attribute or
    //  text node).
    if (TP.isAttributeNode(aNode) &&
        TP.regex.HAS_ACP.test(TP.nodeGetTextContent(aNode))) {
        queriedNodes = TP.ac(aNode.ownerElement);
    } else if (TP.isTextNode(aNode) &&
        TP.regex.HAS_ACP.test(TP.nodeGetTextContent(aNode))) {
        queriedNodes = TP.ac(aNode.parentNode);
    } else {

        //  Run an XPath query to find text within either attributes or elements
        //  that has ACP expressions *and return their parent Element* (i.e.
        //  either ownerElement or parentNode, depending on node type). Note
        //  that this filters out any content under elements with a
        //  'bind:repeat', since ACP expressions in those contexts need to be
        //  evaluated each time content is (re)generated under those elements.

        //  NB: The attribute portion of this query does *not* pick attributes
        //  in the TP.w3.Xmlns.UI namespace - they might contain runtime
        //  formatting instructions (i.e. 'ui:display', etc.)
        queriedNodes = TP.nodeEvaluateXPath(
            aNode,
            './/@*[contains(.,"{{") and ' +
                        'namespace-uri() != "' + TP.w3.Xmlns.UI +
                        '" and (not(../ancestor::*[@*[local-name() = "repeat"' +
                        ' and namespace-uri() = "' +
                                    TP.w3.Xmlns.BIND + '"]]))]' +
                        '/..' +
            ' | ' +
            './/text()[contains(.,"{{")' +
                        ' and (not(../ancestor::*[@*[local-name() = "repeat"' +
                        ' and namespace-uri() = "' +
                                    TP.w3.Xmlns.BIND + '"]]))]/..',
            TP.NODESET);
    }

    if (TP.isEmpty(queriedNodes)) {
        return queriedNodes;
    }

    //  We only want the roots out of this node set - that'll give us the 'most
    //  shallow' nodes with ACP expressions.
    return TP.nodesGetRoots(queriedNodes);
});

//  ========================================================================
//  TP.tag.CompilePhase
//  ========================================================================

/**
 * @type {TP.tag.CompilePhase}
 */

//  ------------------------------------------------------------------------

TP.tag.TagProcessorPhase.defineSubtype('tag.CompilePhase');

//  ------------------------------------------------------------------------

TP.tag.CompilePhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return '$tagCompileAndRegister';
});

//  ------------------------------------------------------------------------

TP.tag.CompilePhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var query,
        queriedNodes;

    if (!TP.isNode(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  If aNode is not a collection node, then the query will have no impact
    //  (and may error, depending on platform). Just return an empty Array.
    if (!TP.isCollectionNode(aNode)) {
        return TP.ac();
    }

    //  See the type constants for a description of this query.
    query = TP.tag.TagProcessor.CUSTOM_NODES_QUERY_NO_COMPILE;

    queriedNodes = TP.nodeEvaluateXPath(aNode, query, TP.NODESET);

    return queriedNodes;
});

//  ========================================================================
//  TP.tag.TidyPhase
//  ========================================================================

/**
 * @type {TP.tag.TidyPhase}
 */

//  ------------------------------------------------------------------------

TP.tag.TagProcessorPhase.defineSubtype('tag.TidyPhase');

//  ------------------------------------------------------------------------

TP.tag.TidyPhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagTidy';
});

//  ------------------------------------------------------------------------

TP.tag.TidyPhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var queriedNodes;

    if (!TP.isNode(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  We're only interested in Element-type Nodes.
    queriedNodes = TP.nodeGetElementsByTagName(aNode, '*');

    return queriedNodes;
});

//  ========================================================================
//  TP.tag.ResolvePhase
//  ========================================================================

/**
 * @type {TP.tag.ResolvePhase}
 */

//  ------------------------------------------------------------------------

TP.tag.TagProcessorPhase.defineSubtype('tag.ResolvePhase');

//  ------------------------------------------------------------------------

TP.tag.ResolvePhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagResolve';
});

//  ------------------------------------------------------------------------

TP.tag.ResolvePhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var queriedNodes;

    if (!TP.isNode(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  We're only interested in Element-type Nodes.
    queriedNodes = TP.nodeGetElementsByTagName(aNode, '*');

    return queriedNodes;
});

//  ========================================================================
//  TP.tag.LocalizePhase
//  ========================================================================

/**
 * @type {TP.tag.LocalizePhase}
 */

//  ------------------------------------------------------------------------

TP.tag.TagProcessorPhase.defineSubtype('tag.LocalizePhase');

//  ------------------------------------------------------------------------

TP.tag.LocalizePhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagLocalize';
});

//  ========================================================================
//  TP.tag.CompileCompletePhase
//  ========================================================================

/**
 * @type {TP.tag.CompileCompletePhase}
 */

//  ------------------------------------------------------------------------

TP.tag.TagProcessorPhase.defineSubtype('tag.CompileCompletePhase');

//  ------------------------------------------------------------------------

TP.tag.CompileCompletePhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagCompileComplete';
});

//  ========================================================================
//  TP.tag.MutationPhase
//  ========================================================================

/**
 * @type {TP.tag.MutationPhase}
 */

//  ------------------------------------------------------------------------

TP.tag.TagProcessorPhase.defineSubtype('tag.MutationPhase');

TP.tag.MutationPhase.isAbstract(true);

//  ========================================================================
//  TP.tag.AttachDOMPhase
//  ========================================================================

/**
 * @type {TP.tag.AttachDOMPhase}
 */

//  ------------------------------------------------------------------------

TP.tag.MutationPhase.defineSubtype('tag.AttachDOMPhase');

//  ------------------------------------------------------------------------

TP.tag.AttachDOMPhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagAttachDOM';
});

//  ------------------------------------------------------------------------

TP.tag.AttachDOMPhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var query,
        queriedNodes;

    if (!TP.isNode(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  If aNode is not a collection node, then the query will have no impact
    //  (and may error, depending on platform). Just return an empty Array.
    if (!TP.isCollectionNode(aNode)) {
        return TP.ac();
    }

    //  See the type constants for a description of this query.
    query = TP.tag.TagProcessor.CUSTOM_NODES_QUERY_NO_AWAKEN;

    queriedNodes = TP.nodeEvaluateXPath(aNode, query, TP.NODESET);

    return queriedNodes;
});

//  ========================================================================
//  TP.tag.AttachEventsPhase
//  ========================================================================

/**
 * @type {TP.tag.AttachEventsPhase}
 */

//  ------------------------------------------------------------------------

TP.tag.MutationPhase.defineSubtype('tag.AttachEventsPhase');

//  ------------------------------------------------------------------------

TP.tag.AttachEventsPhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagAttachEvents';
});

//  ------------------------------------------------------------------------

TP.tag.AttachEventsPhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var query,
        queriedNodes;

    //  According to DOM Level 3 XPath, we can't use DocumentFragments as the
    //  context node for evaluating an XPath expression.
    if (!TP.isNode(aNode) || TP.isFragment(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  If aNode is not a collection node, then the query will have no impact
    //  (and may error, depending on platform). Just return an empty Array.
    if (!TP.isCollectionNode(aNode)) {
        return TP.ac();
    }

    //  We're only interested in elements that either are in the 'ev:' namespace
    //  or have attributes in the 'ev:' namespace
    query = 'descendant-or-self::*' +
            '[' +
            'not(ancestor::*[@tibet:no-awaken]) and ' +
            '(namespace-uri() = "' + TP.w3.Xmlns.XML_EVENTS + '"' +
            ' or ' +
            '@*[namespace-uri() = "' + TP.w3.Xmlns.XML_EVENTS + '"])' +
            ']';

    queriedNodes = TP.nodeEvaluateXPath(aNode, query, TP.NODESET);

    return queriedNodes;
});

//  ========================================================================
//  TP.tag.AttachDataPhase
//  ========================================================================

/**
 * @type {TP.tag.AttachDataPhase}
 */

//  ------------------------------------------------------------------------

TP.tag.MutationPhase.defineSubtype('tag.AttachDataPhase');

//  ------------------------------------------------------------------------

TP.tag.AttachDataPhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagAttachData';
});

//  ------------------------------------------------------------------------

TP.tag.AttachDataPhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var query,
        queriedNodes;

    //  According to DOM Level 3 XPath, we can't use DocumentFragments as the
    //  context node for evaluating an XPath expression.
    if (!TP.isNode(aNode) || TP.isFragment(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  If aNode is not a collection node, then the query will have no impact
    //  (and may error, depending on platform). Just return an empty Array.
    if (!TP.isCollectionNode(aNode)) {
        return TP.ac();
    }

    query = 'descendant-or-self::*' +
            '[' +
            'not(ancestor::*[@tibet:no-awaken])' +
            ']';

    queriedNodes = TP.nodeEvaluateXPath(aNode, query, TP.NODESET);

    return queriedNodes;
});

//  ========================================================================
//  TP.tag.AttachSignalsPhase
//  ========================================================================

/**
 * @type {TP.tag.AttachSignalsPhase}
 */

//  ------------------------------------------------------------------------

TP.tag.MutationPhase.defineSubtype('tag.AttachSignalsPhase');

//  ------------------------------------------------------------------------

TP.tag.AttachSignalsPhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagAttachSignals';
});

//  ------------------------------------------------------------------------

TP.tag.AttachSignalsPhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var query,
        queriedNodes;

    //  According to DOM Level 3 XPath, we can't use DocumentFragments as the
    //  context node for evaluating an XPath expression.
    if (!TP.isNode(aNode) || TP.isFragment(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  If aNode is not a collection node, then the query will have no impact
    //  (and may error, depending on platform). Just return an empty Array.
    if (!TP.isCollectionNode(aNode)) {
        return TP.ac();
    }

    query = 'descendant-or-self::*' +
            '[' +
            'not(ancestor::*[@tibet:no-awaken]) and ' +
            '@*[namespace-uri() = "' + TP.w3.Xmlns.ON + '"]' +
            ']';

    queriedNodes = TP.nodeEvaluateXPath(aNode, query, TP.NODESET);

    return queriedNodes;
});

//  ========================================================================
//  TP.tag.AttachInfoPhase
//  ========================================================================

/**
 * @type {TP.tag.AttachInfoPhase}
 */

//  ------------------------------------------------------------------------

TP.tag.MutationPhase.defineSubtype('tag.AttachInfoPhase');

//  ------------------------------------------------------------------------

TP.tag.AttachInfoPhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagAttachInfo';
});

//  ------------------------------------------------------------------------

TP.tag.AttachInfoPhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var query,
        queriedNodes;

    //  According to DOM Level 3 XPath, we can't use DocumentFragments as the
    //  context node for evaluating an XPath expression.
    if (!TP.isNode(aNode) || TP.isFragment(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  If aNode is not a collection node, then the query will have no impact
    //  (and may error, depending on platform). Just return an empty Array.
    if (!TP.isCollectionNode(aNode)) {
        return TP.ac();
    }

    //  We're only interested in elements that have a local name of 'info'.
    query = 'descendant-or-self::*' +
            '[' +
            'not(ancestor::*[@tibet:no-awaken]) and ' +
            'local-name() = "info"' +
            ']';

    queriedNodes = TP.nodeEvaluateXPath(aNode, query, TP.NODESET);

    return queriedNodes;
});

//  ========================================================================
//  TP.tag.AttachBindsPhase
//  ========================================================================

/**
 * @type {TP.tag.AttachBindsPhase}
 */

//  ------------------------------------------------------------------------

TP.tag.MutationPhase.defineSubtype('tag.AttachBindsPhase');

//  ------------------------------------------------------------------------

TP.tag.AttachBindsPhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagAttachBinds';
});

//  ------------------------------------------------------------------------

TP.tag.AttachBindsPhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var query,
        boundElements,

        boundTextNodes,

        allBoundNodes,
        commonAncestor;

    //  According to DOM Level 3, we can't use DocumentFragments as the context
    //  node for evaluating a CSS expression.
    if (!TP.isNode(aNode) || TP.isFragment(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  If this wasn't another type of collection node (i.e. Document or
    //  Element), then just return an empty Array here.
    if (!TP.isCollectionNode(aNode)) {
        return TP.ac();
    }

    //  Query for any attributes named 'io', 'in', 'scope' or 'repeat', no
    //  matter what namespace they're in. Note that this is about as
    //  sophisticated as we can get with namespaces using the querySelectorAll()
    //  call in most browsers. It is extremely fast, which is why we use it and
    //  then filter more later, but it's query capabilities around namespaces is
    //  quite pathetic.
    query = '*[*|io],' +
            '*[*|in],' +
            '*[*|scope],' +
            '*[*|repeat]';

    boundElements = aNode.ownerDocument.querySelectorAll(query);

    //  Make sure to filter out all non-roots. This will filter out the vast
    //  majority of bound nodes (esp. in a bind:repeat) but we will still get
    //  valid results, since we're looking for common ancestors that don't have
    //  'tibet:no-awaken' on them.
    boundElements = TP.nodeListFilterNonRoots(boundElements);

    //  Since querySelectorAll always queries from the Document even though we
    //  messaged the Element (yet another limitation... sigh...) we have to
    //  filter further based on containment.
    boundElements = boundElements.filter(
            function(anElem) {
                var ans;

                ans = TP.nodeDetectAncestorMatchingCSS(anElem,
                                                        '*[tibet|no-awaken]');

                if (TP.isElement(ans) ||
                    TP.elementHasAttribute(anElem, 'tibet:no-awaken', true)) {
                    return false;
                }

                return aNode.contains(anElem);
            });

    //  Grab any standalone text nodes that have binding expressions.
    boundTextNodes = TP.wrap(aNode).getTextNodesMatching(
            function(aTextNode) {

                var ans,
                    textContent;

                ans = TP.nodeDetectAncestorMatchingCSS(aTextNode.parentNode,
                                                        '*[tibet|no-awaken]');

                if (TP.isElement(ans) ||
                    TP.elementHasAttribute(aTextNode.parentNode,
                                            'tibet:no-awaken',
                                            true)) {
                    return false;
                }

                textContent = aTextNode.textContent;

                //  Note here that we not only check to see if the text content
                //  has double-bracket binding statements, but also to make sure
                //  that it's not a JSON String - we don't want to turn whole
                //  chunks of JSON data into the value of the 'bind:in'
                if (TP.regex.BINDING_STATEMENT_DETECT.test(textContent) &&
                    !TP.isJSONString(textContent)) {
                    return true;
                }

                return false;
            });

    //  If any node under the context node matches, then we need to find a
    //  common ancestor for the nodes that matched.

    //  Start by making a set of all bound nodes, Elements or Text nodes.
    allBoundNodes = boundElements.concat(boundTextNodes);

    //  If there is more than 1, then find the common ancestor and return an
    //  Array with that Element.
    if (allBoundNodes.getSize() > 1) {
        commonAncestor = TP.nodeGetCommonAncestor.apply(TP, allBoundNodes);

        return TP.ac(commonAncestor);
    } else if (allBoundNodes.getSize() === 1) {

        //  Otherwise, if its just 1 then if there are no bound *Elements*, it
        //  must be a single Text node. Return an Array with that Text node's
        //  parent node (i.e. the Element surrounding it).
        if (boundElements.getSize() === 0) {
            return TP.ac(boundTextNodes.first().parentNode);
        } else {

            //  Otherwise, the bound elements Array already has what we want.
            return boundElements;
        }
    }

    //  No binding Elements or Text nodes found.
    return TP.ac();
});

//  ========================================================================
//  TP.tag.AttachStylePhase
//  ========================================================================

/**
 * @type {TP.tag.AttachStylePhase}
 */

//  ------------------------------------------------------------------------

TP.tag.MutationPhase.defineSubtype('tag.AttachStylePhase');

//  ------------------------------------------------------------------------

TP.tag.AttachStylePhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagAttachStyle';
});

//  ------------------------------------------------------------------------

TP.tag.AttachStylePhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var query,
        queriedNodes;

    //  According to DOM Level 3 XPath, we can't use DocumentFragments as the
    //  context node for evaluating an XPath expression.
    if (!TP.isNode(aNode) || TP.isFragment(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  If aNode is not a collection node, then the query will have no impact
    //  (and may error, depending on platform). Just return an empty Array.
    if (!TP.isCollectionNode(aNode)) {
        return TP.ac();
    }

    query = 'descendant-or-self::*' +
            '[' +
            'not(ancestor::*[@tibet:no-awaken])' +
            ']';

    queriedNodes = TP.nodeEvaluateXPath(aNode, query, TP.NODESET);

    return queriedNodes;
});

//  ========================================================================
//  TP.tag.AttachCompletePhase
//  ========================================================================

/**
 * @type {TP.tag.AttachCompletePhase}
 */

//  ------------------------------------------------------------------------

TP.tag.MutationPhase.defineSubtype('tag.AttachCompletePhase');

//  ------------------------------------------------------------------------

TP.tag.AttachCompletePhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagAttachComplete';
});

//  ------------------------------------------------------------------------

TP.tag.AttachCompletePhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var query,
        queriedNodes;

    //  According to DOM Level 3 XPath, we can't use DocumentFragments as the
    //  context node for evaluating an XPath expression.
    if (!TP.isNode(aNode) || TP.isFragment(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  If aNode is not a collection node, then the query will have no impact
    //  (and may error, depending on platform). Just return an empty Array.
    if (!TP.isCollectionNode(aNode)) {
        return TP.ac();
    }

    query = 'descendant-or-self::*' +
            '[' +
            'not(ancestor::*[@tibet:no-awaken])' +
            ']';

    queriedNodes = TP.nodeEvaluateXPath(aNode, query, TP.NODESET);

    return queriedNodes;
});

//  ========================================================================
//  TP.tag.DetachDOMPhase
//  ========================================================================

/**
 * @type {TP.tag.DetachDOMPhase}
 */

//  ------------------------------------------------------------------------

TP.tag.MutationPhase.defineSubtype('tag.DetachDOMPhase');

//  ------------------------------------------------------------------------

TP.tag.DetachDOMPhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagDetachDOM';
});

//  ========================================================================
//  TP.tag.DetachEventsPhase
//  ========================================================================

/**
 * @type {TP.tag.DetachEventsPhase}
 */

//  ------------------------------------------------------------------------

TP.tag.MutationPhase.defineSubtype('tag.DetachEventsPhase');

//  ------------------------------------------------------------------------

TP.tag.DetachEventsPhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagDetachEvents';
});

//  ------------------------------------------------------------------------

TP.tag.DetachEventsPhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var query,
        queriedNodes;

    //  According to DOM Level 3 XPath, we can't use DocumentFragments as the
    //  context node for evaluating an XPath expression.
    if (!TP.isNode(aNode) || TP.isFragment(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  If aNode is not a collection node, then the query will have no impact
    //  (and may error, depending on platform). Just return an empty Array.
    if (!TP.isCollectionNode(aNode)) {
        return TP.ac();
    }

    //  We're only interested in elements that either are in the 'ev:' namespace
    //  or have attributes in the 'ev:' namespace
    query = 'descendant-or-self::*' +
            '[' +
            'not(ancestor::*[@tibet:no-awaken]) and ' +
            'namespace-uri() = "' + TP.w3.Xmlns.XML_EVENTS + '"' +
            ' or ' +
            '@*[namespace-uri() = "' + TP.w3.Xmlns.XML_EVENTS + '"]' +
            ']';

    queriedNodes = TP.nodeEvaluateXPath(aNode, query, TP.NODESET);

    return queriedNodes;
});

//  ========================================================================
//  TP.tag.DetachSignalsPhase
//  ========================================================================

/**
 * @type {TP.tag.DetachSignalsPhase}
 */

//  ------------------------------------------------------------------------

TP.tag.MutationPhase.defineSubtype('tag.DetachSignalsPhase');

//  ------------------------------------------------------------------------

TP.tag.DetachSignalsPhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagDetachSignals';
});

//  ------------------------------------------------------------------------

TP.tag.DetachSignalsPhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var query,
        queriedNodes;

    //  According to DOM Level 3 XPath, we can't use DocumentFragments as the
    //  context node for evaluating an XPath expression.
    if (!TP.isNode(aNode) || TP.isFragment(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  If aNode is not a collection node, then the query will have no impact
    //  (and may error, depending on platform). Just return an empty Array.
    if (!TP.isCollectionNode(aNode)) {
        return TP.ac();
    }

    //  We're only interested in elements that have attributes in the 'on:'
    //  namespace
    query = 'descendant-or-self::*' +
            '[' +
            'not(ancestor::*[@tibet:no-awaken]) and ' +
            '@*[namespace-uri() = "' + TP.w3.Xmlns.ON + '"]' +
            ']';

    queriedNodes = TP.nodeEvaluateXPath(aNode, query, TP.NODESET);

    return queriedNodes;
});

//  ========================================================================
//  TP.tag.DetachDataPhase
//  ========================================================================

/**
 * @type {TP.tag.DetachDataPhase}
 */

//  ------------------------------------------------------------------------

TP.tag.MutationPhase.defineSubtype('tag.DetachDataPhase');

//  ------------------------------------------------------------------------

TP.tag.DetachDataPhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagDetachData';
});

//  ------------------------------------------------------------------------

TP.tag.DetachDataPhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var query,
        queriedNodes;

    //  According to DOM Level 3 XPath, we can't use DocumentFragments as the
    //  context node for evaluating an XPath expression.
    if (!TP.isNode(aNode) || TP.isFragment(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  If aNode is not a collection node, then the query will have no impact
    //  (and may error, depending on platform). Just return an empty Array.
    if (!TP.isCollectionNode(aNode)) {
        return TP.ac();
    }

    query = 'descendant-or-self::*' +
            '[' +
            'not(ancestor::*[@tibet:no-awaken])' +
            ']';

    queriedNodes = TP.nodeEvaluateXPath(aNode, query, TP.NODESET);

    return queriedNodes;
});

//  ========================================================================
//  TP.tag.DetachInfoPhase
//  ========================================================================

/**
 * @type {TP.tag.DetachInfoPhase}
 */

//  ------------------------------------------------------------------------

TP.tag.MutationPhase.defineSubtype('tag.DetachInfoPhase');

//  ------------------------------------------------------------------------

TP.tag.DetachInfoPhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagDetachInfo';
});

//  ------------------------------------------------------------------------

TP.tag.DetachInfoPhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var query,
        queriedNodes;

    //  According to DOM Level 3 XPath, we can't use DocumentFragments as the
    //  context node for evaluating an XPath expression.
    if (!TP.isNode(aNode) || TP.isFragment(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  If aNode is not a collection node, then the query will have no impact
    //  (and may error, depending on platform). Just return an empty Array.
    if (!TP.isCollectionNode(aNode)) {
        return TP.ac();
    }

    //  We're only interested in elements that have a local name of 'info'.
    query = 'descendant-or-self::*' +
            '[' +
            'not(ancestor::*[@tibet:no-awaken]) and ' +
            'local-name() = "info"' +
            ']';

    queriedNodes = TP.nodeEvaluateXPath(aNode, query, TP.NODESET);

    return queriedNodes;
});

//  ========================================================================
//  TP.tag.DetachBindsPhase
//  ========================================================================

/**
 * @type {TP.tag.DetachBindsPhase}
 */

//  ------------------------------------------------------------------------

TP.tag.MutationPhase.defineSubtype('tag.DetachBindsPhase');

//  ------------------------------------------------------------------------

TP.tag.DetachBindsPhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagDetachBinds';
});

//  ------------------------------------------------------------------------

TP.tag.DetachBindsPhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var query,
        boundElements,

        boundTextNodes,

        allBoundNodes,
        commonAncestor;

    //  According to DOM Level 3, we can't use DocumentFragments as the context
    //  node for evaluating a CSS expression.
    if (!TP.isNode(aNode) || TP.isFragment(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  If this wasn't another type of collection node (i.e. Document or
    //  Element), then just return an empty Array here.
    if (!TP.isCollectionNode(aNode)) {
        return TP.ac();
    }

    //  Query for any attributes named 'io', 'in', 'scope' or 'repeat', no
    //  matter what namespace they're in. Note that this is about as
    //  sophisticated as we can get with namespaces using the querySelectorAll()
    //  call in most browsers. It is extremely fast, which is why we use it and
    //  then filter more later, but it's query capabilities around namespaces is
    //  quite pathetic.
    query = '*[*|io],' +
            '*[*|in],' +
            '*[*|scope],' +
            '*[*|repeat]';

    boundElements = aNode.ownerDocument.querySelectorAll(query);

    //  Make sure to filter out all non-roots. This will filter out the vast
    //  majority of bound nodes (esp. in a bind:repeat) but we will still get
    //  valid results, since we're looking for common ancestors that don't have
    //  'tibet:no-awaken' on them.
    boundElements = TP.nodeListFilterNonRoots(boundElements);

    //  Since querySelectorAll always queries from the Document even though we
    //  messaged the Element (yet another limitation... sigh...) we have to
    //  filter further based on containment.
    boundElements = boundElements.filter(
            function(anElem) {
                var ans;

                ans = TP.nodeDetectAncestorMatchingCSS(anElem,
                                                        '*[tibet|no-awaken]');

                if (TP.isElement(ans) ||
                    TP.elementHasAttribute(anElem, 'tibet:no-awaken', true)) {
                    return false;
                }

                return aNode.contains(anElem);
            });

    //  Grab any standalone text nodes that have binding expressions.
    boundTextNodes = TP.wrap(aNode).getTextNodesMatching(
            function(aTextNode) {

                var ans,
                    textContent;

                ans = TP.nodeDetectAncestorMatchingCSS(aTextNode.parentNode,
                                                        '*[tibet|no-awaken]');

                if (TP.isElement(ans) ||
                    TP.elementHasAttribute(aTextNode.parentNode,
                                            'tibet:no-awaken',
                                            true)) {
                    return false;
                }

                textContent = aTextNode.textContent;

                //  Note here that we not only check to see if the text content
                //  has double-bracket binding statements, but also to make sure
                //  that it's not a JSON String - we don't want to turn whole
                //  chunks of JSON data into the value of the 'bind:in'
                if (TP.regex.BINDING_STATEMENT_DETECT.test(textContent) &&
                    !TP.isJSONString(textContent)) {
                    return true;
                }

                return false;
            });

    //  If any node under the context node matches, then we need to find a
    //  common ancestor for the nodes that matched.

    //  Start by making a set of all bound nodes, Elements or Text nodes.
    allBoundNodes = boundElements.concat(boundTextNodes);

    //  If there is more than 1, then find the common ancestor and return an
    //  Array with that Element.
    if (allBoundNodes.getSize() > 1) {
        commonAncestor = TP.nodeGetCommonAncestor.apply(TP, allBoundNodes);

        return TP.ac(commonAncestor);
    } else if (allBoundNodes.getSize() === 1) {

        //  Otherwise, if its just 1 then if there are no bound *Elements*, it
        //  must be a single Text node. Return an Array with that Text node's
        //  parent node (i.e. the Element surrounding it).
        if (boundElements.getSize() === 0) {
            return TP.ac(boundTextNodes.first().parentNode);
        } else {

            //  Otherwise, the bound elements Array already has what we want.
            return boundElements;
        }
    }

    //  No binding Elements or Text nodes found.
    return TP.ac();
});

//  ========================================================================
//  TP.tag.DetachStylePhase
//  ========================================================================

/**
 * @type {TP.tag.DetachStylePhase}
 */

//  ------------------------------------------------------------------------

TP.tag.MutationPhase.defineSubtype('tag.DetachStylePhase');

//  ------------------------------------------------------------------------

TP.tag.DetachStylePhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagDetachStyle';
});

//  ------------------------------------------------------------------------

TP.tag.DetachStylePhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var query,
        queriedNodes;

    //  According to DOM Level 3 XPath, we can't use DocumentFragments as the
    //  context node for evaluating an XPath expression.
    if (!TP.isNode(aNode) || TP.isFragment(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  If aNode is not a collection node, then the query will have no impact
    //  (and may error, depending on platform). Just return an empty Array.
    if (!TP.isCollectionNode(aNode)) {
        return TP.ac();
    }

    query = 'descendant-or-self::*' +
            '[' +
            'not(ancestor::*[@tibet:no-awaken])' +
            ']';

    queriedNodes = TP.nodeEvaluateXPath(aNode, query, TP.NODESET);

    return queriedNodes;
});

//  ========================================================================
//  TP.tag.DetachCompletePhase
//  ========================================================================

/**
 * @type {TP.tag.DetachCompletePhase}
 */

//  ------------------------------------------------------------------------

TP.tag.MutationPhase.defineSubtype('tag.DetachCompletePhase');

//  ------------------------------------------------------------------------

TP.tag.DetachCompletePhase.Inst.defineMethod('getTargetMethod',
function() {

    /**
     * @method getTargetMethod
     * @summary Returns the method that a target of this tag processor phase
     *     (usually a TIBET wrapper type for a node) needs to implement in order
     *     for this phase to consider that part of content in its processing.
     * @returns {String} The name of the method this phase will use to message
     *     the target content.
     */

    return 'tagDetachComplete';
});

//  ------------------------------------------------------------------------

TP.tag.DetachCompletePhase.Inst.defineMethod('queryForNodes',
function(aNode) {

    /**
     * @method queryForNodes
     * @summary Given the supplied node, this method queries it using a query
     *     very specific to this phase.
     * @description This method should produce the sparsest result set possible
     *     for consideration by the next phase of the tag processing engine,
     *     which is to then filter this set by whether a) a TIBET wrapper type
     *     can be found for each result and b) whether that wrapper type can
     *     respond to this phase's target method.
     * @param {Node} aNode The root node to start the query from.
     * @returns {Node[]} An array containing the subset of Nodes from the root
     *     node that this phase should even consider to try to process.
     */

    var query,
        queriedNodes;

    //  According to DOM Level 3 XPath, we can't use DocumentFragments as the
    //  context node for evaluating an XPath expression.
    if (!TP.isNode(aNode) || TP.isFragment(aNode)) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  If aNode is not a collection node, then the query will have no impact
    //  (and may error, depending on platform). Just return an empty Array.
    if (!TP.isCollectionNode(aNode)) {
        return TP.ac();
    }

    query = 'descendant-or-self::*' +
            '[' +
            'not(ancestor::*[@tibet:no-awaken])' +
            ']';

    queriedNodes = TP.nodeEvaluateXPath(aNode, query, TP.NODESET);

    return queriedNodes;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETBinding.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ============================================================================

//  ========================================================================
//  OBJECT BINDING
//  ========================================================================

TP.definePrimitive('defineBinding',
function(target, targetAttributeName, resourceOrURI, sourceAttributeName,
         sourceFacetName, transformationFunc) {

    /**
     * @method defineBinding
     * @summary Adds a binding to the supplied target object.
     * @param {Object} target The target object to define the binding on.
     * @param {String} targetAttributeName The target attribute name.
     * @param {Object} resourceOrURI The resource specification.
     * @param {String} sourceAttributeName The source attribute name. If not
     *     specified, this will default to targetAttributeName.
     * @param {String} sourceFacetName The source facet name. If TP.ALL is
     *     specified, then all facets from the source will bound to. If not
     *     specified, this will default to 'value'.
     * @param {Function} transformationFunc A Function to transform the value
     *     before it is supplied to the observer of the binding. It takes one
     *     parameter, the new value from the model and returns the
     *     transformation parameter. This parameter is optional.
     * @returns {Object} The target object.
     */

    var resource,

        finalTarget,

        sourceAttr,

        facetName,
        signalName,
        aspectKey,

        methodName,

        handler,

        resourceValue,

        i,
        allFacets;

    if (TP.isEmpty(targetAttributeName)) {
        return this.raise('TP.sig.InvalidParameter',
            'No attribute name provided for bind.');
    }

    if (TP.isString(resourceOrURI)) {
        resource = TP.uc(TP.TIBET_URN_PREFIX + resourceOrURI);
    } else if (TP.isKindOf(resourceOrURI, TP.uri.TIBETURL)) {
        resource = resourceOrURI.getConcreteURI();
    } else {
        resource = resourceOrURI;
    }

    //  Prefer URIs but can bind to any object in theory.
    if (TP.notValid(resource)) {
        return this.raise('TP.sig.InvalidResource',
            'No resource spec provided for bind.');
    }

    finalTarget = target;

    if (TP.isKindOf(finalTarget, TP.uri.TIBETURL)) {
        finalTarget = finalTarget.getConcreteURI();
    }

    //  Get the source attribute. If there is no source attribute, then use the
    //  target attribute as the source attribute.
    if (TP.notValid(sourceAttr = sourceAttributeName)) {
        sourceAttr = targetAttributeName;
    }

    //  Get the source facet. If there is no source facet, then default it to
    //  'value'.
    if (TP.notValid(facetName = sourceFacetName)) {
        facetName = 'value';
    }

    //  Choose the correct subtype of TP.sig.FacetSignal to use, depending on
    //  facet.
    switch (facetName) {

        //  Specifying TP.ALL means that we use the supertype of all facet
        //  signals.
        case TP.ALL:
            signalName = 'TP.sig.FacetChange';
            break;

        case 'readonly':
            signalName = 'TP.sig.ReadonlyChange';
            break;

        case 'relevant':
            signalName = 'TP.sig.RelevantChange';
            break;

        case 'required':
            signalName = 'TP.sig.RequiredChange';
            break;

        case 'valid':
            signalName = 'TP.sig.ValidChange';
            break;

        case 'value':
        default:
            signalName = 'TP.sig.ValueChange';
            break;
    }

    if (sourceAttr.isAccessPath()) {

        //  Do a 'get' to establish the interest in the path - we're not really
        //  interested in the value though. We don't do this if it's a URI,
        //  though, since the URI will do that automatically.
        if (!TP.isURI(resource)) {
            resource.get(sourceAttr);
        }
    } else {
        //  If the facet is 'value' as well, but the sourceAttr *isn't*, then we
        //  go ahead and set up for a spoofed <aspect>Change signal (if the
        //  sourceAttr is 'value' we'd rather have a signal name of
        //  'TP.sig.ValueChange' than 'ValueChange').
        if (facetName === 'value' && sourceAttr !== 'value') {
            signalName = TP.makeStartUpper(sourceAttr) + 'Change';
        }
    }

    //  Make sure that target object has a local method to handle the change
    methodName = TP.composeHandlerName(signalName);

    if (TP.notValid(handler = finalTarget.getMethod(methodName))) {

        //  Define a handler function
        handler = function(aSignal) {

            var origin,

                aspect,
                facet,

                mapKey,

                entry,
                targetAttr,
                transformFunc,

                source,
                newVal,

                parsedVal;

            try {
                origin = aSignal.getOrigin();

                aspect = aSignal.at('aspect');

                facet = aSignal.at('facet');

                //  Compute a map key in the same way we did above when we made
                //  the registration and see if the map has it.
                mapKey = TP.gid(origin) +
                                TP.JOIN +
                                TP.str(aspect) +
                                TP.JOIN +
                                facet;

                //  If we found a target attribute registration under the key,
                //  then perform the set()
                if (TP.notEmpty(entry =
                                handler.$observationsMap.at(mapKey))) {

                    //  The target attribute is the first item in the entry pair
                    //  and any (optional) transformation Function is the last.
                    targetAttr = entry.first();
                    transformFunc = entry.last();

                    newVal = aSignal.getValue();

                    //  If what we got back was a String, and that String can be
                    //  parsed into another 'JavaScript primitive' data type
                    //  (Number, Boolean, RegExp, etc.), then we do that here
                    //  *before* we call the transformation function.
                    if (TP.isString(newVal) &&
                        TP.isValid(parsedVal =
                                    TP.getParsedPrimitiveValue(newVal))) {
                        newVal = parsedVal;
                    }

                    //  If there was a transformation Function registered, then
                    //  execute it.
                    if (TP.isCallable(transformFunc)) {

                        source = aSignal.getSource();
                        newVal = transformFunc(source, TP.ac(newVal));
                    }

                    this.setFacet(targetAttr, facet, newVal, false);
                }
            } catch (e) {
                this.raise('TP.sig.InvalidBinding', TP.ec(e));
            }
        };

        //  Allocate an aspect map that various aspects will register themselves
        //  with. This allows a set of source aspects to share a single change
        //  handler function.
        handler.$observationsMap = TP.hc();
        finalTarget.defineHandler(signalName, handler);
    }

    if (facetName !== TP.ALL) {

        //  The key into the aspect map is the global ID of the resource, the
        //  source attr name and the source facet name all joined together.
        aspectKey = TP.gid(resource) + TP.JOIN +
                    TP.str(sourceAttr) + TP.JOIN +
                    facetName;

        //  Add an entry to make a mapping between a source aspect and a target
        //  aspect.
        handler.$observationsMap.atPut(aspectKey,
                                        TP.ac(targetAttributeName,
                                                transformationFunc));
    } else {

        //  TP.ALL was specified - set up an entry for each facet.

        allFacets = TP.FACET_NAMES.concat('value');
        for (i = 0; i < allFacets.getSize(); i++) {

            aspectKey = TP.gid(resource) + TP.JOIN +
                        TP.str(sourceAttr) + TP.JOIN +
                        allFacets.at(i);

            handler.$observationsMap.atPut(aspectKey,
                                            TP.ac(targetAttributeName,
                                                    transformationFunc));
        }
    }

    //  PERF

    //  If the resource is a URI and we can obtain the resource result value of
    //  it, make sure that it is configured to signal Change notifications.

    //  NB: We assume 'async' of false here.
    if (TP.isURI(resource) &&
        TP.isValid(resourceValue =
            resource.getResource(TP.hc('resultType', TP.WRAP)).get('result'))) {
        resourceValue.shouldSignalChange(true);
    }

    //  Go ahead and make the observation.
    finalTarget.observe(resource, signalName);

    return finalTarget;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('defineBinding',
function(targetAttributeName, resourceOrURI, sourceAttributeName,
         sourceFacetName, transformationFunc) {

    /**
     * @method defineBinding
     * @summary Adds a binding to the receiver.
     * @param {String} targetAttributeName The target attribute name.
     * @param {Object} resourceOrURI The resource specification.
     * @param {String} sourceAttributeName The source attribute name. If not
     *     specified, this will default to targetAttributeName.
     * @param {String} sourceFacetName The source facet name. If TP.ALL is
     *     specified, then all facets from the source will bound to. If not
     *     specified, this will default to 'value'.
     * @param {Function} transformationFunc A Function to transform the value
     *     before it is supplied to the observer of the binding. It takes one
     *     parameter, the new value from the model and returns the
     *     transformation parameter. This parameter is optional.
     * @returns {Object} The receiver.
     */

    return TP.defineBinding(
            this, targetAttributeName, resourceOrURI,
            sourceAttributeName, sourceFacetName, transformationFunc);
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('defineBinding',
function(targetAttributeName, resourceOrURI, sourceAttributeName,
         sourceFacetName, transformationFunc) {

    /**
     * @method defineBinding
     * @summary Adds a binding to the type receiver.
     * @param {String} targetAttributeName The target attribute name.
     * @param {Object} resourceOrURI The resource specification.
     * @param {String} sourceAttributeName The source attribute name. If not
     *     specified, this will default to targetAttributeName.
     * @param {String} sourceFacetName The source facet name. If TP.ALL is
     *     specified, then all facets from the source will bound to. If not
     *     specified, this will default to 'value'.
     * @param {Function} transformationFunc A Function to transform the value
     *     before it is supplied to the observer of the binding. It takes one
     *     parameter, the new value from the model and returns the
     *     transformation parameter. This parameter is optional.
     * @returns {Object} The receiver.
     */

    return TP.defineBinding(
            this, targetAttributeName, resourceOrURI,
            sourceAttributeName, sourceFacetName, transformationFunc);
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('defineBinding',
function(targetAttributeName, resourceOrURI, sourceAttributeName,
         sourceFacetName, transformationFunc) {

    /**
     * @method defineBinding
     * @summary Adds a binding to the instance receiver.
     * @param {String} targetAttributeName The target attribute name.
     * @param {Object} resourceOrURI The resource specification.
     * @param {String} sourceAttributeName The source attribute name. If not
     *     specified, this will default to targetAttributeName.
     * @param {String} sourceFacetName The source facet name. If TP.ALL is
     *     specified, then all facets from the source will bound to. If not
     *     specified, this will default to 'value'.
     * @param {Function} transformationFunc A Function to transform the value
     *     before it is supplied to the observer of the binding. It takes one
     *     parameter, the new value from the model and returns the
     *     transformation parameter. This parameter is optional.
     * @returns {Object} The receiver.
     */

    return TP.defineBinding(
            this, targetAttributeName, resourceOrURI,
            sourceAttributeName, sourceFacetName, transformationFunc);
});

//  ------------------------------------------------------------------------

TP.definePrimitive('destroyBinding',
function(target, targetAttributeName, resourceOrURI, sourceAttributeName,
         sourceFacetName) {

    /**
     * @method destroyBinding
     * @summary Removes a binding from the supplied target object.
     * @param {Object} target The target object to remove the binding from.
     * @param {String} targetAttributeName The target attribute name.
     * @param {Object} resourceOrURI The resource specification.
     * @param {String} sourceAttributeName The source attribute name. If not
     *     specified, this will default to targetAttributeName.
     * @param {String} sourceFacetName The source facet name. If TP.ALL is
     *     specified, then all facets from the source will be unbound. If not
     *     specified, this will default to 'value'.
     * @returns {Object} The target object.
     */

    var resource,
        sourceAttr,

        facetName,
        signalName,
        aspectKey,

        methodName,

        handler,

        i,
        allFacets;

    if (TP.isEmpty(targetAttributeName)) {
        return this.raise('TP.sig.InvalidParameter',
            'No attribute name provided for bind.');
    }

    if (TP.isString(resourceOrURI)) {
        resource = TP.uc(TP.TIBET_URN_PREFIX + resourceOrURI);
    } else if (TP.isKindOf(resourceOrURI, TP.uri.TIBETURL)) {
        resource = resourceOrURI.getConcreteURI();
    } else {
        resource = resourceOrURI;
    }

    //  Prefer URIs but can bind to any object in theory.
    if (TP.notValid(resource)) {
        return this.raise('TP.sig.InvalidResource',
            'No resource spec provided for bind.');
    }

    //  Get the source attribute. If there is no source attribute, then use the
    //  target attribute as the source attribute.
    if (TP.notValid(sourceAttr = sourceAttributeName)) {
        sourceAttr = targetAttributeName;
    }

    //  Get the source facet. If there is no source facet, then default it to
    //  'value'.
    if (TP.notValid(facetName = sourceFacetName)) {
        facetName = 'value';
    }

    //  Choose the correct subtype of TP.sig.FacetSignal to use, depending on
    //  facet.
    switch (facetName) {

        //  Specifying TP.ALL means that we use the supertype of all facet
        //  signals.
        case TP.ALL:
            signalName = 'TP.sig.FacetChange';
            break;

        case 'readonly':
            signalName = 'TP.sig.ReadonlyChange';
            break;

        case 'relevant':
            signalName = 'TP.sig.RelevantChange';
            break;

        case 'required':
            signalName = 'TP.sig.RequiredChange';
            break;

        case 'valid':
            signalName = 'TP.sig.ValidChange';
            break;

        case 'value':
        default:
            signalName = 'TP.sig.ValueChange';
            break;
    }

    if (!sourceAttr.isAccessPath()) {
        //  If the facet is 'value' as well, but the sourceAttr *isn't*, then we
        //  go ahead and set up for a spoofed <aspect>Change signal (if the
        //  sourceAttr is 'value' we'd rather have a signal name of
        //  'TP.sig.ValueChange' than 'ValueChange').
        if (facetName === 'value' && sourceAttr !== 'value') {
            signalName = TP.makeStartUpper(sourceAttr) + 'Change';
        }
    }

    //  Make sure that target object has a local method to handle the change
    methodName = TP.composeHandlerName(signalName);

    if (TP.isValid(handler = target.getMethod(methodName)) &&
        TP.isValid(handler.$observationsMap)) {

        if (facetName !== TP.ALL) {

            //  The key into the aspect map is the global ID of the resource,
            //  the source attr name and the source facet name all joined
            //  together.
            aspectKey = TP.gid(resource) + TP.JOIN +
                        TP.str(sourceAttr) + TP.JOIN +
                        facetName;

            //  There was a valid handler and a valid key map - remove our
            //  source aspect from it.
            handler.$observationsMap.removeKey(aspectKey);
        } else {

            //  TP.ALL was specified - remove the entry for each facet.

            allFacets = TP.FACET_NAMES.concat('value');
            for (i = 0; i < allFacets.getSize(); i++) {

                aspectKey = TP.gid(resource) + TP.JOIN +
                            TP.str(sourceAttr) + TP.JOIN +
                            allFacets.at(i);

                handler.$observationsMap.removeKey(aspectKey);
            }
        }
    }

    //  Ignore the target.
    target.ignore(resource, signalName);

    return target;
});

//  ------------------------------------------------------------------------

TP.defineMetaInstMethod('destroyBinding',
function(targetAttributeName, resourceOrURI, sourceAttributeName,
         sourceFacetName) {

    /**
     * @method destroyBinding
     * @summary Removes a binding from the receiver.
     * @param {String} targetAttributeName The target attribute name.
     * @param {Object} resourceOrURI The resource specification.
     * @param {String} sourceAttributeName The source attribute name. If not
     *     specified, this will default to targetAttributeName.
     * @param {String} sourceFacetName The source facet name. If TP.ALL is
     *     specified, then all facets from the source will be unbound. If not
     *     specified, this will default to 'value'.
     * @returns {Object} The receiver.
     */

    return TP.destroyBinding(
            this, targetAttributeName, resourceOrURI,
            sourceAttributeName, sourceFacetName);
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Type.defineMethod('destroyBinding',
function(targetAttributeName, resourceOrURI, sourceAttributeName,
         sourceFacetName) {

    /**
     * @method destroyBinding
     * @summary Removes a binding from the type receiver.
     * @param {String} targetAttributeName The target attribute name.
     * @param {Object} resourceOrURI The resource specification.
     * @param {String} sourceAttributeName The source attribute name. If not
     *     specified, this will default to targetAttributeName.
     * @param {String} sourceFacetName The source facet name. If TP.ALL is
     *     specified, then all facets from the source will be unbound. If not
     *     specified, this will default to 'value'.
     * @returns {Object} The receiver.
     */

    return TP.destroyBinding(
            this, targetAttributeName, resourceOrURI,
            sourceAttributeName, sourceFacetName);
});

//  ------------------------------------------------------------------------

TP.lang.RootObject.Inst.defineMethod('destroyBinding',
function(targetAttributeName, resourceOrURI, sourceAttributeName,
         sourceFacetName) {

    /**
     * @method destroyBinding
     * @summary Removes a binding from the instance receiver.
     * @param {String} targetAttributeName The target attribute name.
     * @param {Object} resourceOrURI The resource specification.
     * @param {String} sourceAttributeName The source attribute name. If not
     *     specified, this will default to targetAttributeName.
     * @param {String} sourceFacetName The source facet name. If TP.ALL is
     *     specified, then all facets from the source will be unbound. If not
     *     specified, this will default to 'value'.
     * @returns {Object} The receiver.
     */

    return TP.destroyBinding(
            this, targetAttributeName, resourceOrURI,
            sourceAttributeName, sourceFacetName);
});

//  ========================================================================
//  MARKUP BINDING
//  ========================================================================

TP.totalSetupTime = 0;

TP.totalBranchQueryTime = 0;
TP.totalInlineQueryTime = 0;
TP.totalTextQueryTime = 0;

TP.totalUpdateTime = 0;

TP.totalInitialGetTime = 0;

//  ------------------------------------------------------------------------
//  TP.dom.DocumentNode
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineAttribute('$signalingBatchID');
TP.dom.DocumentNode.Inst.defineAttribute('$repeatTemplates');
TP.dom.DocumentNode.Inst.defineAttribute('$refreshedElements');
TP.dom.DocumentNode.Inst.defineAttribute('$observedLocations');
TP.dom.DocumentNode.Inst.defineAttribute('$originalLocationInfos');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineHandler('FacetChange',
function(aSignal) {

    /**
     * @method handleFacetChange
     * @summary Handles when an object (usually a URI of some sort) changes and
     *     some components on the receiver surface (i.e. usually GUI widgets)
     *     need to be updated in response to that change.
     * @param {Change} aSignal The signal instance which triggered this handler.
     * @returns {TP.dom.DocumentNode} The receiver.
     */

    var changedPaths,

        ourBatchID,
        signalBatchID,

        signalFlag,

        sigOrigin,
        primarySource,

        changedPrimaryLoc,
        changedPrimaryURI,

        doc,

        query,
        boundElems,

        tpDocElem,

        i,
        j,

        changedPathKeys,
        keysToProcess,

        changedKey,
        keyToProcess,

        matcher,
        len,

        attrName,

        ownerElem,
        ownerTPElem,

        aspect,
        facet,

        originWasURI,

        sigSource,
        sigIndexes,

        pathPieces,

        boundAttrNodes,
        attrs,
        attrVal,

        aspectNames,

        originVal,

        allRefreshedElements;

    //  See if the signal has a payload of TP.CHANGE_PATHS. If so, that means
    //  that there were specific paths to data that changed and we can more
    //  'intelligent' about updating just the items that are dependent on that
    //  data.
    changedPaths = aSignal.at(TP.CHANGE_PATHS);

    //  If the underlying machinery that sent this signal supports 'signal
    //  batching', then we can leverage that to avoid making multiple passes
    //  through the updating logic.

    //  The first step is to check for a batching ID.
    if (TP.isValid(changedPaths)) {
        if (TP.notValid(ourBatchID = this.get('$signalingBatchID'))) {

            //  If there's already a TP.END_SIGNAL_BATCH id before we've even
            //  set our cached batch ID, then there must've only been one path
            //  so we go ahead and process the signal.
            if (TP.isValid(signalBatchID = aSignal.at(TP.END_SIGNAL_BATCH))) {
                //  empty
            } else {
                if (TP.isValid(
                        signalBatchID = aSignal.at(TP.START_SIGNAL_BATCH))) {
                    this.set('$signalingBatchID', signalBatchID);
                }

                //  At the start of a batch (or a batchID wasn't provided). In
                //  either case, don't update - just return.
                return this;
            }
        } else if (TP.isValid(
                    signalBatchID = aSignal.at(TP.END_SIGNAL_BATCH))) {
            if (ourBatchID !== signalBatchID) {
                //  The batch is ending, but it didn't match our cached batch ID
                //  then return.
                return this;
            }

            //  Otherwise, we clear our cached batch ID proceed ahead.
            this.set('$signalingBatchID', null);
        } else {
            //  This wasn't the end of the batch - return.
            return this;
        }
    }

    //  Turn off any kind of DOM loaded signaling. This just adds overhead and
    //  is unnecessary - in this mode, dependent items are themselves
    //  responsible for signaling that their content got replaced.
    signalFlag = TP.sys.shouldSignalDOMLoaded();
    TP.sys.shouldSignalDOMLoaded(false);

    //  Grab the signal origin and do some testing. The signal is either going
    //  to be coming from a data source URI or an 'on page' item that is in a
    //  'direct to GUI' binding relationship.
    sigOrigin = aSignal.getOrigin();

    if (TP.isKindOf(sigOrigin, TP.uri.URI)) {

        //  The changed data source is a URI

        //  The primary source is the overall 'whole data' object that changed.
        primarySource = sigOrigin.getResource().get('result');
        changedPrimaryLoc = sigOrigin.getPrimaryLocation();

        //  Compute a RegExp that will be used to match 'top level' (i.e. not
        //  nested under further data scopes) binding expressions.
        matcher = TP.rc(TP.regExpEscape(changedPrimaryLoc));

    } else {

        //  The changed data source is another item in a 'direct to GUI' binding
        //  relationship.

        //  Note that, for these kinds of expressions, we only match top-level
        //  expressions (i.e. these are usually something like TIBET 'uicanvas'
        //  URLs that don't respect any sort of binding data scope).

        //  The primary source is the value that changed on the signal origin -
        //  there is no 'larger object' for us to consider.
        primarySource = sigOrigin.get('value');
        changedPrimaryLoc = sigOrigin.getID();

        changedPrimaryURI = TP.uc(changedPrimaryLoc);

        //  Grab the 'canvas' from the primary location URI. If it's the same as
        //  the current GUI canvas window, then we're updating the correct
        //  window.
        if (changedPrimaryURI.getCanvas() === TP.sys.uiwin(true)) {

            if (TP.isKindOf(sigOrigin, TP.dom.ElementNode)) {

                //  If signal origin was a TP.dom.ElementNode, then we want to
                //  use its local ID to compute our RegExp to match 'top level'
                //  binding expressions.
                changedPrimaryLoc = sigOrigin.getLocalID();

            } else if (TP.isKindOf(sigOrigin, TP.dom.AttributeNode)) {

                //  If signal origin was a TP.dom.AttributeNode, then we want
                //  to use its owner element's local ID and then a '@' separator
                //  and then its local name to compute our RegExp to match 'top
                //  level' binding expressions.
                changedPrimaryLoc = sigOrigin.getOwnerElement().getLocalID() +
                                    '@' + sigOrigin.getLocalName();
            }

            //  Build a RegExp that will match any of the following:
            //      'tibet://uicanvas#foo'
            //      '#foo'
            //      'tibet://uicanvas#foo@bar'
            //      '#foo@bar'
            matcher = TP.rc('(tibet://uicanvas#' +
                            TP.regExpEscape(changedPrimaryLoc) + '|' +
                            '#' + TP.regExpEscape(changedPrimaryLoc) + ')');
        }
    }

    doc = this.getNativeNode();

    //  Query for all elements containing namespaced attributes of 'io', 'in',
    //  'scope' or repeat. This is the most sophisticated 'namespace like' query
    //  we can give the native querySelectorAll() call since it doesn't really
    //  recognize namespaces... we'll fix that later. Note here how we ignore
    //  bind:scopes that contain a '[' (and are therefore scopes generated by us
    //  under a bind:repeat).
    query = '*[*|io], *[*|in], *[*|scope]:not([*|scope*="["]), *[*|repeat]';

    boundElems = TP.ac(doc.documentElement.querySelectorAll(query));

    //  Grab the TP.dom.ElementNode that is our document Element.
    tpDocElem = this.getDocumentElement();

    aspect = aSignal.at('aspect');
    facet = aSignal.at('facet');

    originWasURI = TP.isURI(sigOrigin);

    sigSource = aSignal.getSource();
    sigIndexes = aSignal.at('indexes');

    //  If the signal had a payload of TP.CHANGE_PATHS then we can drive the
    //  updating process directly from those paths.
    if (TP.isValid(changedPaths)) {

        //  TIMING: var startUpdate = Date.now();

        //  Grab the keys of the changed paths and sort them so that the
        //  'shortest' keys are first. This will cause the 'least specific'
        //  paths to be sorted to the top.

        changedPathKeys = changedPaths.getKeys();
        changedPathKeys.sort(
            function(a, b) {
                return a.length - b.length;
            });

        //  Start with the shortest path key. This is the 'least specific path'.
        keysToProcess = TP.ac(changedPathKeys.first());

        //  Then iterate over all path keys that have changed. If the key starts
        //  with any of the keys that are in the keys that we're going to
        //  process, then it must be a 'more specific' version of that key, so
        //  we skip it. Otherwise, we add it to the list of keys that we're
        //  going to process. In this way, we end up with a reasonably
        //  parsimonious, yet complete, set of paths that we're going to update.
        for (i = 0; i < changedPathKeys.getSize(); i++) {

            //  NB: We use getSize() here as we expect that this Array could
            //  change size as we add keys to it.
            for (j = 0; j < keysToProcess.getSize(); j++) {
                changedKey = changedPathKeys.at(i);
                keyToProcess = keysToProcess.at(j);

                if (changedKey === keyToProcess &&
                    keysToProcess.indexOf(changedKey) !== TP.NOT_FOUND) {
                    continue;
                } else if (changedKey.startsWith(keyToProcess)) {
                    continue;
                }

                keysToProcess.push(changedPathKeys.at(i));
            }
        }

        //  Iterate over all of the keys and update any items that are dependent
        //  on them.
        keysToProcess.forEach(
                function(changedPath) {

                    var actions,
                        actionLen,
                        k,

                        initialVal,

                        pathAction,
                        pathParts,
                        pathType;

                    //  This will be a list of actions for the path - TP.CREATE,
                    //  TP.UPDATE, TP.DELETE, etc.
                    actions = changedPaths.at(changedPath).getKeys();

                    //  We have to iterate for each action.
                    actionLen = actions.getSize();
                    for (k = 0; k < actionLen; k++) {

                        //  The initial value is the primary source, but this
                        //  might change below.
                        initialVal = primarySource;

                        pathAction = actions.at(k);

                        //  Grab the path parts and type for the path that
                        //  changed.
                        pathParts = TP.getAccessPathParts(changedPath);
                        pathType = TP.getAccessPathType(changedPath);

                        //  If the path is an XPath and the changed path started
                        //  with a '/', then update the first part to contain
                        //  the '/' (TP.getAccessPathParts() will - correctly -
                        //  not include that '/', but we want it in this
                        //  context).
                        if (pathType === TP.XPATH_PATH_TYPE &&
                            changedPath.startsWith('/')) {
                            pathParts.atPut(0, '/' + pathParts.at(0));
                        } else if (pathType === TP.TIBET_PATH_TYPE) {

                            //  If it wasn't an XPath, reset the initial value
                            //  to its 'value'.
                            initialVal = initialVal.get('value');
                        }

                        //  Unshift the pointer scheme onto the front of the
                        //  list of path parts.
                        pathParts.unshift(
                                '#' + TP.getPointerScheme(changedPath) + '()');

                        //  Unshift the primary location onto the front.
                        pathParts.unshift(changedPrimaryLoc);

                        //  Refresh all 'branches' (i.e. items, including
                        //  top-level bound expressions and scoped expressions,
                        //  of course) using all of the information that we
                        //  compiled.
                        tpDocElem.$refreshBranches(
                            primarySource,
                            facet,
                            facet === 'value' ?
                                        initialVal :
                                        aSignal.at(TP.NEWVAL),
                            boundElems,
                            pathType,
                            pathParts,
                            pathAction,
                            false,
                            sigOrigin,
                            originWasURI,
                            sigSource,
                            sigIndexes);
                    }
                });

        //  TIMING: var endUpdate = Date.now();
        //  TIMING: TP.totalUpdateTime += (endUpdate - startUpdate);

    } else {

        //  TIMING: var startSetup = Date.now();

        //  If our signal origin is a URI and the aspect is one of URI's
        //  'special aspects', then we just return here.
        if (originWasURI && TP.uri.URI.SPECIAL_ASPECTS.contains(aspect)) {

            //  Set the DOM content loaded signaling whatever it was when we
            //  entered this method.
            TP.sys.shouldSignalDOMLoaded(signalFlag);

            return this;
        }

        //  If we have an aspect and the facet that we're updating is *not*
        //  'value', then that means we're updating other facets such as
        //  'readonly', 'required', etc. This means that we try to compute the
        //  path parts if our origin was a URI or just use the singular aspect
        //  as the 'path parts'. In either case, we use a TIBET-type path for
        //  non-'value' facets (no matter how the 'value' facet is bound).
        if (TP.notEmpty(aspect) && facet !== 'value') {

            if (originWasURI) {
                pathPieces = TP.ac(changedPrimaryLoc, '#tibet()', aspect);
            } else {
                pathPieces = TP.ac(aspect);
            }

            //  Refresh all 'branches' using the aspect from the path, since
            //  we're updating 'non value facet' bindings..
            tpDocElem.$refreshBranches(
                    primarySource,
                    facet,
                    aSignal.at(TP.NEWVAL),
                    boundElems,
                    TP.TIBET_PATH_TYPE,
                    pathPieces,
                    TP.UPDATE,
                    false,
                    sigOrigin,
                    originWasURI,
                    sigSource,
                    sigIndexes);
        } else if (TP.notEmpty(facet)) {

            //  Otherwise, we're updating a 'value' fact.

            //  If the signal origin is either a TIBETURL with a non-empty
            //  canvas or the signal origin wasn't a URI at all, it must've been
            //  another GUI control within the page. Because we don't have
            //  'changed data paths' to go by, we update all 'direct GUI'
            //  bindings.
            /* eslint-disable no-extra-parens */
            if ((TP.isKindOf(sigOrigin, TP.uri.TIBETURL) &&
                TP.notEmpty(sigOrigin.getCanvasName())) || !originWasURI) {
            /* eslint-enable no-extra-parens */

                //  Gather up all of the bound attributes.

                boundAttrNodes = TP.ac();

                //  Loop over all of the elements that were found.
                for (i = 0; i < boundElems.length; i++) {
                    attrs = boundElems[i].attributes;

                    //  Loop over all of the attributes of the found element.
                    for (j = 0; j < attrs.length; j++) {

                        attrVal = attrs[j].value;

                        //  If the attribute was in the BIND namespace and
                        //  either matched our matcher OR contained ACP
                        //  variables, then add it to our list of bound
                        //  attributes.
                        if (attrs[j].namespaceURI === TP.w3.Xmlns.BIND &&
                            (matcher.test(attrVal) ||
                                TP.regex.ACP_PATH_CONTAINS_VARIABLES.test(
                                                                    attrVal))) {

                            boundAttrNodes.push(attrs[j]);
                        }
                    }
                }

                //  Sort the attribute nodes so that 'bind:in' attributes come
                //  first. This is important when an element has both 'bind:in'
                //  and 'bind:io' attributes, since we want the 'in' bindings to
                //  be refreshed first to have that data available to the 'io'
                //  bindings.
                boundAttrNodes.sort(
                    function(a, b) {

                        if (a.nodeName === 'bind:in' &&
                            b.nodeName !== 'bind:in') {
                            return -1;
                        } else if (a.nodeName !== 'bind:in' &&
                                    b.nodeName === 'bind:in') {
                            return 1;
                        }

                        return 0;
                    });

                if (originWasURI) {
                    originVal = sigOrigin.getContent();
                } else {
                    originVal = sigOrigin;
                }

                len = boundAttrNodes.getSize();
                for (i = 0; i < len; i++) {

                    attrName = boundAttrNodes.at(i).localName;

                    //  We only worry about updating 'bind:io' and 'bind:in'
                    //  paths.
                    if (attrName === 'io' || attrName === 'in') {

                        attrVal = boundAttrNodes.at(i).value;

                        if (matcher.test(attrVal)) {

                            ownerElem = boundAttrNodes.at(i).ownerElement;
                            ownerTPElem = TP.wrap(ownerElem);

                            //  Grab all of the names of the aspects referencing
                            //  the changed location, as given by the matcher.
                            aspectNames = ownerTPElem.$computeMatchingAspects(
                                                    boundAttrNodes.at(i).name,
                                                    attrVal,
                                                    matcher);

                            //  Note that we use sigOrigin here as the
                            //  primarySource and initialValue. We let the
                            //  observers of this element decide how to use this
                            //  element based on their standard data binding /
                            //  decoding methods (isSingleValued,
                            //  isScalarValued, etc.)
                            ownerTPElem.$refreshLeaf(
                                    facet,
                                    originVal,
                                    aspectNames,
                                    boundAttrNodes[i],
                                    null,
                                    sigSource,
                                    null,
                                    NaN);
                        }
                    }
                }
            } else {
                tpDocElem.$refreshBranches(
                        primarySource,
                        facet,
                        primarySource,
                        boundElems,
                        null,
                        null,
                        null,
                        false,
                        sigOrigin,
                        originWasURI,
                        sigSource,
                        sigIndexes);
            }
        }

        //  TIMING: var endSetup = Date.now();
        //  TIMING: TP.totalSetupTime += (endSetup - startSetup);
    }

    //  Set the DOM content loaded signaling whatever it was when we entered
    //  this method.
    TP.sys.shouldSignalDOMLoaded(signalFlag);

    //  Send a custom DOM-level event to allow 3rd party libraries to know that
    //  the bindings have been refreshed.
    allRefreshedElements = this.get('$refreshedElements');
    if (TP.notEmpty(allRefreshedElements)) {
        this.getBody().$sendNativeRefreshEvent();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineHandler('UIRefresh',
function(aSignal) {

    /**
     * @method handleUIRefresh
     * @summary Refreshes the receiver's bound data.
     * @param {TP.sig.UIRefresh} aSignal The signal instance which triggered
     *     this handler.
     * @returns {TP.dom.DocumentNode} The receiver.
     */

    this.refresh();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.DocumentNode.Inst.defineMethod('refresh',
function(shouldRender) {

    /**
     * @method refresh
     * @summary Updates the receiver's content by refreshing all bound elements
     *     in the document. For an HTML document this will refresh content under
     *     the body, while in an XML document all elements including the
     *     documentElement are refreshed.
     * @param {Boolean} [shouldRender] Whether or not to force (or not force)
     *     re-rendering if the data source changes. If not supplied, this
     *     parameter will default to true if the bound data changed and false if
     *     it didn't.
     * @returns {Boolean} Whether or not the bound value was different than the
     *     receiver already had and, therefore, truly changed.
     */

    var node,
        body;

    node = this.getNativeNode();

    if (TP.isHTMLDocument(node) || TP.isXHTMLDocument(node)) {
        if (TP.isElement(body = TP.documentGetBody(node))) {
            return TP.tpnode(body).refresh(shouldRender);
        }
    } else {
        return TP.tpnode(node.documentElement).refresh(shouldRender);
    }

    return false;
});

//  ------------------------------------------------------------------------
//  TP.dom.ElementNode
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  The attributes for this element type that are considered to 'bidi
//  attributes' that can not only be bound to data source but be bound *back* to
//  the data source so that when they are changed by the user, they update the
//  data source.
TP.dom.ElementNode.Type.defineAttribute('bidiAttrs', TP.ac());

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('computeBindingInfo',
function(targetElement, attributeValue) {

    /**
     * @method computeBindingInfo
     * @summary Gets binding information from the attribute named by the
     *     supplied attribute name on the receiver.
     * @param {Element} targetElement The element the attribute is on.
     * @param {String} attributeValue The element the attribute is on.
     * @returns {TP.core.Hash} A hash of binding information keyed by the
     *     binding target name.
     */

    var entryStr,
        bindEntries,

        keys,
        aspectName,

        len,
        i,

        entry,

        extractedEntry;

    if (TP.isEmpty(attributeValue)) {
        return TP.hc();
    }

    //  Otherwise, parse out each name: value pair.

    //  First, try to get the attribute as a JSON string. This allows for
    //  attribute values like:
    //
    //      {value: urn:tibet:fluffy}
    //
    //      which are converted to:
    //
    //      {"value": "urn:tibet:fluffy"}
    entryStr = TP.reformatJSToJSON(attributeValue, false);

    //  If we couldn't get a JSON String, try to default it to {"value":"..."}
    if (!TP.isJSONString(entryStr)) {
        entryStr = '{"value":"' + attributeValue + '"}';
    }

    //  Try to parse the entry string into a TP.core.Hash.
    bindEntries = TP.json2js(entryStr);

    if (TP.isEmpty(bindEntries)) {
        return this.raise('TP.sig.InvalidBinding',
                            'Source Element: ' + TP.str(targetElement) +
                            ' Generated bindings: ' + entryStr);
    }

    keys = bindEntries.getKeys();

    //  Loop over all of the extracted binding entries.
    len = bindEntries.getSize();
    for (i = 0; i < len; i++) {
        aspectName = keys.at(i);
        entry = bindEntries.at(aspectName);

        //  Extract the expression record from the entry. This returns a hash
        //  that we'll register under the aspectName.
        extractedEntry = this.extractExpressionRecord(aspectName, entry);

        bindEntries.atPut(aspectName, extractedEntry);
    }

    return bindEntries;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('computeTransformationFunction',
function(anExpression, stdinIsSpecial) {

    /**
     * @method computeTransformationFunction
     * @summary Computes a 'transformation function' for values that are bound
     *     by virtue of the binding expressions that are in the supplied
     *     expression.
     * @param {String} anExpression The expression to extract binding
     *     information from to compute the transformation function and data
     *     expressions.
     * @param {Boolean} [stdinIsSpecial=false] Whether or not the STDIN (i.e.
     *     '$_') syntax should be treated specially (not as part of a path).
     * @returns {Array<Function,String[]>} An Array of a Function, which is the
     *     Function that will transform the values being updated and an Array
     *     which contains all of the data expressions that are embedded in the
     *     expression.
     */

    var finalExpr,
        isSimpleExpr,

        textWithoutExprs,
        needsEval,

        referencedExprs,

        sigilIndex,

        exprParts,
        exprWithBrackets,
        exprWithoutBrackets,

        hasSurroundingContent,

        formatExpr,
        valueExpr,

        splitURI,
        computedValueExpr,

        transformFunc;

    finalExpr = anExpression;

    isSimpleExpr = true;

    //  Compute whether or not the transformation Function needs to eval its
    //  return value based on whether or not the statement *without the
    //  expressions* contains JavaScript operators.
    TP.regex.BINDING_STATEMENT_EXTRACT.lastIndex = 0;
    textWithoutExprs = anExpression.strip(TP.regex.BINDING_STATEMENT_EXTRACT);
    needsEval = TP.regex.JS_OPERATORS.test(textWithoutExprs);

    referencedExprs = TP.ac();

    //  While we can still extract binding expressions from the value, keep
    //  looping. This allows us to have multiple expressions in a single value
    //  (i.e. 'foo [[bar]] is called: [[baz]]')
    TP.regex.BINDING_STATEMENT_EXTRACT.lastIndex = 0;
    while (TP.isValid(exprParts =
            TP.regex.BINDING_STATEMENT_EXTRACT.exec(anExpression))) {

        //  We want the expression both with and without the surrounding
        //  brackets ([[...]])
        exprWithBrackets = exprParts.first();
        exprWithoutBrackets = exprParts.last();

        //  If the expression doesn't exactly equal the expression without
        //  brackets surrounded by brackets, then it has 'surrounding content'.
        hasSurroundingContent =
                '[[' + exprWithoutBrackets + ']]' !== anExpression;

        //  If the expression without brackets has an ACP format, then we slice
        //  around and extract separate value and format expressions.
        if (TP.regex.ACP_FORMAT.test(exprWithoutBrackets)) {

            sigilIndex = exprWithoutBrackets.indexOf('.%');

            valueExpr = exprWithoutBrackets.slice(0, sigilIndex).trim();
            formatExpr = ' .% ' + exprWithoutBrackets.slice(
                                                    sigilIndex + 2).trim();
        } else {

            //  Otherwise, the value expression is the whole expression without
            //  brackets and the format expression is empty.
            valueExpr = exprWithoutBrackets;
            formatExpr = '';
        }

        //  If the expression to execute is a path that contains variables, then
        //  we use the 'value' of the URI and leverage the transformation
        //  function installed below to form a final value.
        /* eslint-disable no-extra-parens */
        if (TP.regex.ACP_PATH_CONTAINS_VARIABLES.test(valueExpr) ||
            (TP.regex.HAS_STDIN.test(valueExpr) && TP.isTrue(stdinIsSpecial))) {
        /* eslint-enable no-extra-parens */

            isSimpleExpr = false;

            //  If the expression to execute is a fully-formed URI, then we
            //  don't take the scope values into consideration. We build a URI
            //  location consisting of the URI's primary href with a
            //  '#tibet(...)' XPointer that will return the source object
            //  itself. This is important in the transformation function when we
            //  run the 'transform' call, because the expression is going to
            //  expect to run against the core source object itself. We then
            //  reset the expression to execute to be just the fragment text.
            if (TP.isURIString(valueExpr)) {

                //  Grab the primary URI from a URI computed from the value
                //  expression and append a '#tibet(.)' on it (which will
                //  retrieve the whole value).
                splitURI = TP.uc(valueExpr);

                if (splitURI.hasFragment()) {
                    valueExpr = splitURI.getPrimaryLocation() + '#tibet(.)';
                    //  Set the 'computed' value expression to just the fragment.
                    computedValueExpr = splitURI.getFragmentExpr();
                } else {
                    computedValueExpr = valueExpr;
                }
            } else {
                //  Set the 'computed' value expression to the whole value
                //  expression.
                computedValueExpr = valueExpr;
            }

            TP.regex.ACP_VARIABLE_FUNCTION_STATEMENT.lastIndex = 0;
            if (TP.regex.ACP_VARIABLE_FUNCTION_STATEMENT.test(valueExpr)) {
                TP.regex.ACP_VARIABLE_FUNCTION_STATEMENT.lastIndex = 0;
                computedValueExpr = valueExpr.replace(
                    TP.regex.ACP_VARIABLE_FUNCTION_STATEMENT, '({{$1}})$4');
            } else {
                computedValueExpr =
                    '{{' + computedValueExpr + formatExpr + '}}';
            }

            //  Make sure to replace that expression in the expression to
            //  execute with a 'formatting expression', so that the
            //  templating function below will work.
            finalExpr = finalExpr.replace(exprWithBrackets, computedValueExpr);

            //  Unquote any final expression (note that this only removes
            //  surrounding quotes - not embedded ones).
            finalExpr = finalExpr.unquoted('"');
        } else {

            //  If the expression has surrounding literal content we flip the
            //  'isSimpleExpr' flag to false and install a more complex
            //  transformation function below.
            if (TP.notEmpty(formatExpr) || hasSurroundingContent) {

                isSimpleExpr = false;

                finalExpr = finalExpr.replace(
                    exprWithBrackets,
                    '{{$ARG' + referencedExprs.getSize() + formatExpr + '}}');

                finalExpr = finalExpr.unquoted('"');
            }
        }

        //  Keep a list of the 'referenced value expressions'.
        referencedExprs.push(valueExpr);
    }

    //  If this is not a simple expression, then we install a transformation
    //  Function that will transform the data before returning it.
    if (!isSimpleExpr) {

        transformFunc = function(source, vals, targetTPElem,
                                 repeatSource, index, isXMLResource) {
            var wrappedVal,

                tpDoc,

                params,

                last,

                val,
                retVal;

            //  Wrap the value - it helps when trying to extract a value from it
            //  to get the most 'intelligent' data type.
            //  NB: For performance reasons, we don't do this for Arrays and
            //  TP.core.Hashes
            if (!TP.isArray(vals.first()) && !TP.isHash(vals.first())) {
                wrappedVal = TP.wrap(vals.first());
            } else {
                wrappedVal = vals.first();
            }

            if (TP.isValid(targetTPElem)) {
                tpDoc = targetTPElem.getDocument();
            }

            //  Iterating context
            if (TP.isNumber(index)) {

                if (isXMLResource) {

                    last = repeatSource.getSize();

                    params = TP.hc(
                                '$REQUEST', null,
                                'TP', TP,
                                'APP', APP,
                                '$SOURCE', source,
                                '$TAG', targetTPElem,
                                '$TARGET', tpDoc,
                                '$_', wrappedVal,
                                '$INPUT', repeatSource,
                                '$INDEX', index,
                                '$FIRST', index === 1,
                                '$MIDDLE', index > 1 && index < last,
                                '$LAST', index !== last,
                                '$EVEN', index % 2 === 0,
                                '$ODD', index % 2 !== 0,
                                '$#', index);
                } else {

                    last = repeatSource.getSize() - 1;

                    params = TP.hc(
                                '$REQUEST', null,
                                'TP', TP,
                                'APP', APP,
                                '$SOURCE', source,
                                '$TAG', targetTPElem,
                                '$TARGET', tpDoc,
                                '$_', wrappedVal,
                                '$INPUT', repeatSource,
                                '$INDEX', index,
                                '$FIRST', index === 0,
                                '$MIDDLE', index > 0 && index < last,
                                '$LAST', index !== last,
                                '$EVEN', index % 2 === 0,
                                '$ODD', index % 2 !== 0,
                                '$#', index);
                }
            } else {

                //  Non-iterating context
                params = TP.hc(
                            '$REQUEST', null,
                            'TP', TP,
                            'APP', APP,
                            '$SOURCE', source,
                            '$TAG', targetTPElem,
                            '$TARGET', tpDoc,
                            '$_', wrappedVal,
                            '$INPUT', vals);
            }

            //  Register the Array of values we were handed as 'arguments' under
            //  '$ARGN' variable names.
            vals.forEach(
                function(aVal, valIndex) {
                    params.atPut('$ARG' + valIndex, aVal);
                });

            //  If we got a non-empty Array of values, then process them. Note
            //  here that we do *not* hand in a 'main data source', but all
            //  parameters to the templating Function are supplied as params.
            if (TP.notEmpty(vals)) {
                val = transformFunc.$$templateFunc.transform(null, params);
                if (transformFunc.$$needsEval) {
                    try {
                        /* eslint-disable no-eval */
                        retVal = eval(val);
                        /* eslint-enable no-eval */
                    } catch (e) {
                        retVal = val;
                    }
                } else {
                    retVal = val;
                }

            } else {
                //  null or undefined (or empty), but let's be pendantic
                retVal = vals;
            }

            return retVal;
        };

        //  Compile the 'final expression' into a templating Function and
        //  stash a reference to it on our transformation Function.
        transformFunc.$$templateFunc = finalExpr.compile();

    } else {

        //  Otherwise, we generated a simple transformation Function that will
        //  just return the 'reduced value'. This is necessary especially for
        //  XML where val will be an Element, but we want the text value of
        //  the Element.
        transformFunc = function(source, initialVal) {
            var val,
                retVal;

            val = TP.val(initialVal);

            if (transformFunc.$$needsEval) {
                try {
                    /* eslint-disable no-eval */
                    retVal = eval(val);
                    /* eslint-enable no-eval */
                } catch (e) {
                    retVal = val;
                }
            } else {
                retVal = val;
            }

            return retVal;
        };
    }

    //  Mark the fact that this is a transformation Function. This assists
    //  callers in determining whether this Function was generated using this
    //  method and mechanism.
    transformFunc.$$transformationFunction = true;

    //  Mark whether or not the transformation Function needs to perform an
    //  eval() of its return value.
    transformFunc.$$needsEval = needsEval;

    //  Return an Array containing the transformation Function and an Array of
    //  the referenced expressions.
    return TP.ac(transformFunc, referencedExprs);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Type.defineMethod('extractExpressionRecord',
function(aspectName, anExpression) {

    /**
     * @method extractExpressionRecord
     * @summary Constructs an 'expression record' from the supplied binding
     *     expression.
     * @param {String} aspectName The name of the aspect that the supplied
     *     binding expression was found in.
     * @param {String} anExpression The binding expression.
     * @returns {TP.core.Hash} A hash of binding information.
     */

    var recordText,

        hadBrackets,

        formatExpr,

        preEntry,
        postEntry,

        sigilIndex,

        fullExpr,

        transformInfo,
        transformFunc,
        dataLocs;

    recordText = anExpression;

    //  If the binding statement had embedded [[...]], then
    hadBrackets = TP.regex.BINDING_STATEMENT_DETECT.test(recordText);
    if (hadBrackets) {
        formatExpr = null;

        //  Slice out the expression from the record text and reset the record
        //  text
        preEntry = recordText.slice(0, recordText.indexOf('[['));
        postEntry = recordText.slice(recordText.indexOf(']]') + 2);
        recordText = recordText.slice(recordText.indexOf('[[') + 2,
                                        recordText.indexOf(']]'));

        //  If the record text has a formatting expression, then extract it into
        //  a separate formatting expression.
        if (TP.regex.ACP_FORMAT.test(recordText)) {
            sigilIndex = recordText.indexOf('.%');

            formatExpr = recordText.slice(sigilIndex);
            recordText = recordText.slice(0, sigilIndex).trim();
        }

        fullExpr = recordText;

        //  The prior expression will have trimmed off the first space, but
        //  we want to preserve it for the full expression.
        if (TP.notEmpty(formatExpr)) {
            fullExpr += ' ' + formatExpr;
        }

        fullExpr = preEntry + '[[' + fullExpr + ']]' + postEntry;

        //  Sometimes the expression is quoted to allow whitespace in the
        //  *value* portion of the 'JSON-y' structure that we use to define
        //  bindings, but we don't want surrounding quotes here - strip them
        //  off.
        fullExpr = fullExpr.unquoted();
    } else {

        //  Otherwise, the record text had no embedded brackets and we can just
        //  use that as the full expression.
        fullExpr = recordText;
    }

    //  If the expression contains ACP variables, then we *must* generate a
    //  transformation Function to process them properly. The expression
    //  might or might not have surrounding '[[...]]', but we take care of
    //  that here.
    if (TP.regex.ACP_PATH_CONTAINS_VARIABLES.test(fullExpr)) {

        //  If the expression doesn't start with '[[' AND end with ']]',
        //  then we fix that here.
        if (!/^\s*\[\[/.test(fullExpr) && !/\]\]\s*$/.test(fullExpr)) {
            fullExpr = '[[' + fullExpr + ']]';
        }

        //  Compute the transform Function and dependent data expressions.
        transformInfo = this.computeTransformationFunction(fullExpr);

        //  The Function object that does the transformation.
        transformFunc = transformInfo.first();

        //  The referenced expressions.
        dataLocs = transformInfo.last();
    } else if (hadBrackets &&
        (!/^\s*\[\[/.test(fullExpr) || !/\]\]\s*$/.test(fullExpr) ||
        TP.regex.ACP_FORMAT.test(fullExpr) ||
        /\[\[/g.match(fullExpr).getSize() > 1)) {


        //  The full expression had 'surrounding content' (i.e. literal
        //  content on either or both sides of the leading or trailing
        //  square brackets). We need a transformation expression to handle
        //  this.
        transformInfo = this.computeTransformationFunction(fullExpr);

        //  The Function object that does the transformation.
        transformFunc = transformInfo.first();

        //  The referenced expressions.
        dataLocs = transformInfo.last();
    } else {

        //  Otherwise, the data locations consist of one expression, which
        //  is the whole record text.
        dataLocs = TP.ac(recordText);
    }

    return TP.hc('bindingAspect', aspectName,
                    'transformFunc', transformFunc,
                    'fullExpr', fullExpr,
                    'dataExprs', dataLocs);
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineAttribute('scopeValues');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('addBindingExpressionTo',
function(attributeName, aspectName, expression) {

    /**
     * @method addBindingExpressionTo
     * @summary Adds the supplied binding expression to the receiver's binding
     *     attribute named by the supplied attribute name.
     * @param {String} attributeName The name of the binding attribute to
     *     update.
     * @param {String} aspectName The name of the aspect that we're setting up a
     *     binding expression for.
     * @param {String} expression The text of the 'full' binding expression to
     *     register for the named aspect.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var elem,
        doc,

        registry,

        infoKey,

        bindEntries,

        attrVal,

        extractedEntry;

    //  Grab the native Element and Document.
    elem = this.getNativeNode();
    doc = TP.nodeGetDocument(elem);

    //  If there's no 'bind registry' installed on the Document, then create
    //  one. This registry is used to avoid computing the binding information
    //  from the attribute value each time we need it. It's computed once and
    //  then stored under a key that is the whole attribute value. In this way,
    //  it can be shared amongst multiple attributes and elements, as long as
    //  the value of the attribute is exactly the same.
    if (TP.notValid(registry = doc[TP.BIND_INFO_REGISTRY])) {
        registry = TP.hc();
        doc[TP.BIND_INFO_REGISTRY] = registry;
    }

    infoKey = TP.join(TP.gid(elem),
                        TP.JOIN,
                        attributeName,
                        TP.JOIN,
                        expression);

    //  If the attribute value (acting as a key) is already in the registry,
    //  then just exit here - we don't want dups in the registry.
    if (registry.hasKey(infoKey)) {
        bindEntries = registry.at(infoKey);
    } else {
        //  Ask the type to compute the binding info and put it into the
        //  registry.
        attrVal = TP.elementGetAttribute(elem, attributeName, true);

        //  NB: Even if attrVal is empty, we'll get an empty hash, which we need
        //  below.
        bindEntries = this.getType().computeBindingInfo(elem, attrVal);
        registry.atPut(infoKey, bindEntries);
    }

    //  Extract an expression record from the supplied aspect name and
    //  expression.
    extractedEntry = this.getType().extractExpressionRecord(
                                            aspectName, expression);

    //  Put it into the bind entries
    bindEntries.atPut(aspectName, extractedEntry);

    //  Now, because much of the binding machinery uses the attribute value to
    //  perform its work, we need to rewrite the attribute value and set it.

    //  Build up a 'fully bracketed' attribute value that contains each aspect
    //  and it's 'full expression'.
    attrVal = '{';

    bindEntries.perform(
        function(kvPair) {
            attrVal += kvPair.first() +
                        ': ' +
                        kvPair.last().at('fullExpr') +
                        ', ';
        });

    //  Slice off the last ', '
    attrVal = attrVal.slice(0, -2);

    attrVal += '}';

    //  Set the updated attribute value back onto the element.
    TP.elementSetAttribute(elem, attributeName, attrVal, true);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$computeValueForBoundAspect',
function(bindInfo, scopeValues) {

    /**
     * @method $computeValueForBoundAspect
     * @summary Computes the bound value for a particular bound aspect of the
     *     receiver.
     * @param {TP.core.Hash} bindInfo The hash of binding information for the
     *     particular bound aspect that we want a value for.
     * @param {String[]} scopeValues The list of scoping values (i.e. parts
     *     that, when combined, make up the entire bind scoping path).
     * @returns {Object|String} The value of the bound aspect. Note that if the
     *     supplied binding information for this aspect has more than 1 data
     *     expressions, this will be a String with all of the values
     *     concatenated together.
     */

    var dataExprs,
        len,
        i,

        dataExpr,

        allVals,
        fullExpr,

        wholeURI,

        result,
        finalResult;

    //  There will be 1...n data expressions here. Iterate over them and compute
    //  a model reference.
    dataExprs = bindInfo.at('dataExprs');
    len = dataExprs.getSize();

    for (i = 0; i < len; i++) {
        dataExpr = TP.trim(dataExprs.at(i));

        if (TP.isEmpty(dataExpr)) {
            continue;
        }

        if (TP.notEmpty(scopeValues)) {
            //  Concatenate the binding value onto the scope values array
            //  (thereby creating a new Array) and use it to join all of the
            //  values together.
            allVals = scopeValues.concat(dataExpr);
            fullExpr = TP.uriJoinFragments.apply(TP, allVals);

            //  If we weren't able to compute a real URI from the fully expanded
            //  URI value, then raise an exception and return here.
            if (!TP.isURIString(fullExpr)) {
                this.raise('TP.sig.InvalidURI');

                break;
            }

            wholeURI = TP.uc(fullExpr);
        } else {
            //  Scope values is empty - this is (hopefully) a fully qualified
            //  binding expression.

            //  If we weren't able to compute a real URI from the fully expanded
            //  URI value, then raise an exception and return here.
            if (!TP.isURIString(dataExpr = TP.trim(dataExpr))) {
                this.raise('TP.sig.InvalidURI');

                break;
            }

            wholeURI = TP.uc(dataExpr);
        }

        if (!TP.isURI(wholeURI)) {
            this.raise('TP.sig.InvalidURI');

            break;
        }

        //  Grab the result from the computed URI.
        result = wholeURI.getResource().get('result');

        //  If we have a valid result, then either set the finalResult to it or
        //  append it onto the finalResult if that already exists (this will
        //  occur if we have multiple data expressions).
        if (TP.isValid(result)) {
            if (TP.isValid(finalResult)) {
                finalResult = TP.str(finalResult) + result;
            } else {
                finalResult = result;
            }
        }
    }

    return finalResult;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$computeMatchingAspects',
function(attributeName, attributeValue, valueMatcher) {

    /**
     * @method $computeMatchingAspects
     * @summary Returns the names of the aspects that have expression values
     *     that match the supplied matcher.
     * description This method iterates through the aspects of the supplied
     *     bound attribute, looking for ones that have values that match the
     *     supplied valueMatcher regexp. Note that this method also takes into
     *     account the receiver's scoping values. If any of the scoping values
     *     match, then (if the aspect doesn't have an absolute URI as its
     *     value), that aspect is also added. Finally, if the aspect's value
     *     contains an ACP variable, that aspect is added.
     * @param {String} attributeName The name of binding attribute to retrieve
     *     the binding information from.
     * @param {String} attributeValue The value of the binding attribute to
     *     extract binding information from.
     * @param {RegExp} valueMatcher The RegExp to use to match against aspect
     *     values.
     * @returns {String[]} An array of aspect names that matched using the
     *     criteria described above.
     */

    var scopeVals,

        scopeMatched,

        len,
        i,

        bindingInfo,
        aspectNames;

    //  Grab all of the scoping values.
    scopeVals = this.getBindingScopeValues();

    //  See if any of the scope values match using the supplied matcher and set
    //  the flag. This will be used if the aspect's value doesn't contain a URI
    //  value but still needs to be matched because it's scope matched.

    scopeMatched = false;

    len = scopeVals.getSize();
    for (i = 0; i < len; i++) {
        if (valueMatcher.test(scopeVals.at(i))) {
            scopeMatched = true;
            break;
        }
    }

    //  Grab the binding information.
    bindingInfo = this.getBindingInfoFrom(attributeName, attributeValue);

    aspectNames = TP.ac();

    //  Iterate over each binding aspect/info pair
    bindingInfo.perform(
        function(kvPair) {
            var aspect,
                dataExprs,

                exprsLen,
                j,

                theExpr;

            aspect = kvPair.first();
            dataExprs = kvPair.last().at('dataExprs');

            //  Iterate over each data expression.
            exprsLen = dataExprs.getSize();
            for (j = 0; j < exprsLen; j++) {

                theExpr = dataExprs.at(j);

                //  If theExpr doesn't contain a likely URI but one of the
                //  scoping values matched, then add the aspect.
                if (!TP.isURIString(theExpr) && scopeMatched) {
                    aspectNames.push(aspect);
                    break;
                }

                //  If the matcher matched the expression itself, which means
                //  that the aspect is probably a 'whole URI' (since it failed
                //  the test above), then add the aspect.
                if (valueMatcher.test(theExpr)) {
                    aspectNames.push(aspect);
                    break;
                }

                //  Lastly, if the expression contains ACP variables, then add
                //  the aspect. We cannot be sure what is referenced here or
                //  not, so we need to be safe and include this aspect in our
                //  list.
                if (TP.regex.ACP_PATH_CONTAINS_VARIABLES.test(theExpr)) {
                    aspectNames.push(aspect);
                    break;
                }
            }
        });

    return aspectNames;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('computeCommonScope',
function(sourceURI, isLeaf, alternateURI) {

    /**
     * @method computeCommonScope
     * @summary Computes a common scope that will allow the receiver to bind
     *     properly to the source URI given any inherited scoping values.
     * description This method will compute a common scoping value between the
     *     supplied source URI and the inherited scoping value that is computed
     *     from the receiver. If a common primary URI scope cannot be computed
     *     between the two, then the scoping value returned from this method
     *     will be prepended either by the optionally supplied 'alternate URI'
     *     or the primary URI of the supplied source URI.
     * @param {TP.core.URI} sourceURI The URI that a scope should be computed to
     *     from the receiver, given the receiver's inherited scoping values.
     *     Note that this URI *must* have a fragment.
     * @param {Boolean} isLeaf Whether or not the fragment in the source URI
     *     points to a 'leaf' data item.
     * @param {TP.core.URI} [alternateURI] An alternate URI that the computed
     *     scope value will be joined with if the computed scoping value cannot
     *     be computed relative to the receiver's inherited scope. If this value
     *     isn't supplied, the primary URI of the source URI will be used.
     * @returns {String} The computed scope.
     */

    var sourcePrimaryURI,

        sourceFrag,

        sourcePath,
        sourcePathType,
        sourcePathParts,

        inheritedScopeVals,
        inheritedExpr,
        inheritedURI,

        needsWholeScopingURI,

        inheritedPrimaryURI,

        inheritedFragExpr,

        inheritedFrag,
        inheritedPath,

        commonParts,

        scopeParts,

        separator,

        computedScope,

        scopePrefix,
        scopePath;

    sourcePrimaryURI = sourceURI.getPrimaryURI();

    sourceFrag = sourceURI.getFragment();
    if (TP.isEmpty(sourceFrag)) {
        //  TODO: Raise an exception
        return null;
    }

    sourcePath = TP.apc(sourceFrag);
    sourcePathType = sourcePath.getPathType();
    sourcePathParts = sourcePath.getPathParts();

    //  ---

    //  This is the scope path as seen by the receiver by looking up its tree.

    //  Grab the scoping values from the element we're connecting to.
    inheritedScopeVals = this.getBindingScopeValues();

    //  If the element we're connecting to has inherited scoping values, then
    //  compute the full URI from it and compute a scoping value based on
    //  comparing the URI we connected to and the URI we're 'inherting' scope
    //  from.
    if (TP.notEmpty(inheritedScopeVals)) {
        inheritedExpr = TP.uriJoinFragments.apply(TP, inheritedScopeVals);
        inheritedURI = TP.uc(inheritedExpr);
    } else {
        inheritedURI = null;
    }

    //  ---

    needsWholeScopingURI = true;

    if (TP.isValid(inheritedURI)) {

        inheritedPrimaryURI = inheritedURI.getPrimaryURI();

        //  Attempt to compute a scope by first looking at the *primary URIs* of
        //  the inherited and connected URIs.
        if (inheritedPrimaryURI.equalTo(sourcePrimaryURI)) {

            needsWholeScopingURI = false;

            //  NB: We use the fragment expression here to test for emptiness,
            //  since the fragment itself will contain the XPointer scheme.
            inheritedFragExpr = inheritedURI.getFragmentExpr();
            if (TP.notEmpty(inheritedFragExpr)) {

                //  Use the whole fragment here (including the XPointer scheme
                //  since that will produce more accurate paths).
                inheritedFrag = inheritedURI.getFragment();
                inheritedPath = TP.apc(inheritedFrag);

                //  Try to see if there are any common parts between the
                //  connected path and the inherited path.
                commonParts =
                    sourcePath.computeCommonLeadingParts(inheritedPath);

                //  Not a 100% match?
                if (commonParts.getSize() !== sourcePathParts.getSize()) {

                    scopeParts = sourcePathParts.slice(
                                                    commonParts.getSize());

                    if (isLeaf) {
                        scopeParts = scopeParts.slice(0, -1);
                    }

                    if (TP.notEmpty(scopeParts)) {
                        computedScope =
                            '#' + sourcePath.getPointerScheme() +
                            '(' +
                                TP.joinAccessPathParts(
                                    scopeParts, sourcePathType) +
                            ')';
                    } else {
                        //  Otherwise, the scopes are equivalent - there is no
                        //  real computed scope.
                        computedScope = '';
                    }
                }
            }
        }
    }

    //  The above logic did not compute a scope - we're going to just return a
    //  scope computed from the connected path and the supplied scoping URI.
    if (TP.notValid(computedScope)) {

        if (isLeaf) {
            scopeParts = sourcePathParts.slice(0, -1);
        } else {
            scopeParts = sourcePathParts;
        }

        //  Grab the property information under the entry that matches our
        //  scope (joined together by a path separator).
        if (sourcePathType === TP.TIBET_PATH_TYPE ||
            sourcePathType === TP.JSON_PATH_TYPE) {
            separator = '.';
        } else if (sourcePathType === TP.XPATH_PATH_TYPE) {
            separator = '/';
        }

        scopePrefix = scopeParts.join(separator);

        scopePath = TP.apc(scopePrefix);

        if (needsWholeScopingURI) {
            if (TP.isURI(alternateURI)) {
                computedScope = alternateURI.getLocation() +
                                scopePath.asXPointerString();
            } else {
                computedScope = sourcePrimaryURI.getLocation() +
                                scopePath.asXPointerString();
            }
        } else {
            computedScope = scopePath.asXPointerString();
        }
    }

    return computedScope;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$deleteRepeatRowAt',
function(indexes) {

    /**
     * @method $deleteRepeatRowAt
     * @summary Removes the rows at the indexes provided.
     * @description Note that the indexes supplied to this method should match
     *     the type of data source object of the repeat. If the data source of
     *     the repeat is an XML object, these indexes should be '1-based' (like
     *     XPath). If it is an JS or JSON object, these indexes should be
     *     '0-based' (like JSONPath).
     * @param {Number[]} indexes An Array of Numbers that indicate the indexes
     *     of the items to remove.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var elem,

        wrapperElement,

        len,
        i,
        index,

        deletionElement,

        followingScopedSiblings,

        len2,
        j,
        scopedSibling,
        scopeVal,

        thisref,

        evt;

    elem = this.getNativeNode();

    //  Whichever element has a 'tibet:no-mutations' attribute on it is
    //  acting as a common wrapper for the 'rows' making up the repeat. This may
    //  be a <tbody> element if we're repeating rows in a <table>, but it
    //  doesn't have to be.
    if (TP.elementHasAttribute(elem, 'tibet:no-mutations', true)) {
        wrapperElement = elem;
    } else {
        wrapperElement = TP.byCSSPath(
                            '> *[tibet|no-mutations]',
                            elem,
                            true,
                            false);
    }

    if (!TP.isElement(wrapperElement)) {
        //  TODO: Raise exception
        return this;
    }

    //  Loop over all of the supplied indices
    len = indexes.getSize();
    for (i = 0; i < len; i++) {

        index = indexes.at(i);

        //  The deletion element would be the element with the same index as the
        //  row we're deleting. If we find one, we delete that row and decrement
        //  the number of all numeric scoped elements *at the same level* with
        //  an index equal to or greater than the delete index.
        deletionElement = TP.byCSSPath(
                                '> *[bind|scope="[' + index + ']"]',
                                wrapperElement,
                                true,
                                false);

        //  If we couldn't find the row to delete, then continue to the next
        //  index to delete.
        if (!TP.isElement(deletionElement)) {
            continue;
        }

        //  Now, grab all of the scoped siblings that follow the element that
        //  we're going to delete.
        followingScopedSiblings = TP.byCSSPath(
                                    '~ *[bind|scope^="["][bind|scope$="]"]',
                                    deletionElement,
                                    false,
                                    false);

        //  Now that we've found the scoped siblings, we can remove the deletion
        //  element
        TP.nodeDetach(deletionElement);

        //  Iterate over all of the scoped siblings and adjust their index. Note
        //  how we start by using the index we just deleted. Then we increment
        //  that number and advance.

        len2 = followingScopedSiblings.getSize();
        for (j = 0; j < len2; j++) {

            scopedSibling = followingScopedSiblings.at(j);

            if (TP.notEmpty(scopeVal = TP.elementGetAttribute(
                                    scopedSibling, 'bind:scope', true))) {

                if (TP.regex.SIMPLE_NUMERIC_PATH.test(scopeVal)) {

                    TP.elementSetAttribute(
                            scopedSibling,
                            'bind:scope',
                            '[' + index + ']',
                            true);

                    //  Note how we increment this *after* we set the attribute.
                    //  This is because we're shifting everything 'up' and so we
                    //  want to start renumbering *at the same index* as the
                    //  deletion element was.
                    index += 1;
                }
            }
        }
    }

    //  Send a UIDidDelete with ourself as the target and the set of indexes
    //  that the insertion happened at.
    thisref = this;

    (function() {
        thisref.signal('TP.sig.UIDidDelete',
                        TP.hc('target', thisref, 'indexes', indexes));
    }).queueBeforeNextRepaint(this.getNativeWindow());

    //  Send a custom DOM-level event to allow 3rd party libraries to know that
    //  content has been removed.

    evt = this.getNativeDocument().createEvent('Event');
    evt.initEvent('TIBETContentRemoved', true, true);
    evt.data = TP.ac(deletionElement);

    wrapperElement.dispatchEvent(evt);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$extractValue',
function(sourceVal, expression, pathConstructor, pathOptions) {

    /**
     * @method $extractValue
     * @summary Extracts a value from the supplied source value using the
     *     supplied expression. This method will test to see if the source value
     *     has a custom getter or attribute that matches expression (if
     *     expression conforms to the definition of a JavaScript identifier).
     * @param {Object} sourceVal The source value to extract the value from.
     * @param {String} expression The expression to use to extract the value.
     * @param {Function} pathConstructor The constructor to use to construct a
     *     path, if that's necessary
     * @param {TP.core.Hash} [pathOptions] The hash of options to use when
     *     constructing a path, if that's necessary.
     * @returns {Object} The value extracted from the source value.
     */

    var funcName,
        resultVal,

        extractPath;

    //  If the expression is just a JavaScript identifier (i.e. alphanum
    //  characters only), then test to see if the source value has either a
    //  'getter' or it (or its prototype) has an attribute that matches that
    //  name.
    if (TP.regex.JS_IDENTIFIER.test(expression)) {
        funcName = 'get' + TP.makeStartUpper(expression);
        if (TP.canInvoke(sourceVal, funcName)) {
            resultVal = sourceVal[funcName]();
        } else if (TP.owns(sourceVal, expression)) {
            resultVal = sourceVal.get(expression);
        } else if (TP.owns(Object.getPrototypeOf(sourceVal), expression)) {
            resultVal = sourceVal.get(expression);
        } else {
            //  None of the above were true. Build a path and execute it.
            extractPath = pathConstructor(expression, pathOptions);
            resultVal = extractPath.executeGet(sourceVal);
        }
    } else {
        //  Otherwise, the expression contained non-alphanumeric characters.
        //  Build a path and execute it.
        extractPath = pathConstructor(expression, pathOptions);
        resultVal = extractPath.executeGet(sourceVal);
    }

    return resultVal;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('flushBindingInfoCacheFor',
function(attributeName) {

    /**
     * @method flushBindingInfoCacheFor
     * @summary Flushes the binding information cache for the supplied attribute
     *     value.
     * @param {String} attributeName The name of the attribute to obtain binding
     *     information from.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var elem,
        doc,

        registry,

        attrVal,

        infoKey;

    //  Grab the native Element and Document.
    elem = this.getNativeNode();
    doc = TP.nodeGetDocument(elem);

    //  If there's no 'bind registry' installed on the Document, then just
    //  return.
    if (TP.notValid(registry = doc[TP.BIND_INFO_REGISTRY])) {
        return this;
    }

    attrVal = TP.elementGetAttribute(elem, attributeName, true);

    infoKey = TP.join(TP.gid(elem),
                        TP.JOIN,
                        attributeName,
                        TP.JOIN,
                        attrVal);

    registry.removeKey(infoKey);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getAttrBindRepeatindex',
function(size) {

    /**
     * @method getAttrBindRepeatindex
     * @summary Gets the repeat index that the receiver will use to display
     *     'pages' of repeating data.
     * @returns {Number} The repeat index of the receiver.
     */

    var repeatIndex;

    repeatIndex = TP.elementGetAttribute(
                    this.getNativeNode(), 'bind:repeatindex', true);

    repeatIndex = repeatIndex.asNumber();
    if (!TP.isNumber(repeatIndex)) {
        repeatIndex = 0;
    }

    return repeatIndex;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getAttrBindRepeatsize',
function(size) {

    /**
     * @method getAttrBindRepeatsize
     * @summary Gets the repeat size that the receiver will use to display
     *     'pages' of repeating data.
     * @returns {Number} The repeat size of the receiver.
     */

    var repeatSize;

    repeatSize = TP.elementGetAttribute(
                    this.getNativeNode(), 'bind:repeatsize', true);

    repeatSize = repeatSize.asNumber();
    if (!TP.isNumber(repeatSize)) {
        repeatSize = 1;
    }

    return repeatSize;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getBindingInfoFrom',
function(attributeName, attributeValue, flushCache) {

    /**
     * @method getBindingInfoFrom
     * @summary Gets binding information from the attribute named by the
     *     supplied attribute name on the receiver.
     * @param {String} attributeName The name of the attribute that binding
     *     information is coming from.
     * @param {String} attributeValue The attribute value to obtain binding
     *     information from.
     * @param {Boolean} [flushCache=false] Whether or not to flush any currently
     *     cached binding info for the supplied attribute value.
     * @returns {TP.core.Hash} A hash of binding information keyed by the
     *     binding target name.
     */

    var elem,
        doc,

        registry,

        infoKey,

        bindEntries;

    //  Grab the native Element and Document.
    elem = this.getNativeNode();
    doc = TP.nodeGetDocument(elem);

    //  If there's no 'bind registry' installed on the Document, then create
    //  one. This registry is used to avoid computing the binding information
    //  from the attribute value each time we need it. It's computed once and
    //  then stored under a key that is the whole attribute value. In this way,
    //  it can be shared amongst multiple attributes and elements, as long as
    //  the value of the attribute is exactly the same.
    if (TP.notValid(registry = doc[TP.BIND_INFO_REGISTRY])) {
        registry = TP.hc();
        doc[TP.BIND_INFO_REGISTRY] = registry;
    }

    infoKey = TP.join(TP.gid(elem, true),
                        TP.JOIN,
                        attributeName,
                        TP.JOIN,
                        attributeValue);

    if (TP.isTrue(flushCache)) {
        registry.removeKey(infoKey);
    }

    //  If the attribute value (acting as a key) is already in the registry,
    //  then just exit here - we don't want dups in the registry.
    if (registry.hasKey(infoKey)) {
        return registry.at(infoKey);
    }

    //  Ask the type to compute the binding info and put it into the registry.
    bindEntries = this.getType().computeBindingInfo(elem, attributeValue);
    registry.atPut(infoKey, bindEntries);

    return bindEntries;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getBindingScopeValues',
function(trimFormatExprs, ignoreCache, setCache) {

    /**
     * @method getBindingScopeValues
     * @summary Returns the binding scope values by starting at the receiver
     *      and traversing the DOM tree up to the #document node, gathering
     *      'bind:scope' attribute values along the way. This will be used to
     *      qualify binding expressions on the receiver.
     * @param {Boolean} [trimFormatExprs=true] Whether or not to trim formatting
     *     expressions from the scoping values.
     * @param {Boolean} [ignoreCache=false] Whether or not to ignore the
     *     receiver's cache of scope values.
     * @param {Boolean} [setCache=true] Whether or not to cache the computed
     *     scope values in the receiver's cache.
     * @returns {String[]} An Array of binding scope values.
     */

    var elem,

        localScopeNode,

        scopeVals;

    //  If we've already cached our scope values, then there's no need to
    //  recompute them - just return the cached values.
    if (TP.notTrue(ignoreCache) &&
        TP.notEmpty(scopeVals = this.get('scopeValues'))) {
        return scopeVals;
    }

    elem = this.getNativeNode();

    scopeVals = TP.ac();

    //  Check to see if there is a local 'scope' attribute on the element
    //  itself. This will be used to qualify any expressions on the element
    //  itself.
    if (TP.notEmpty(localScopeNode = TP.elementGetAttributeNodesInNS(
                            elem, /\w+:(scope|repeat)/, TP.w3.Xmlns.BIND))) {
        scopeVals.push(localScopeNode[0].value);
    }

    //  Gather the 'bind:scope' setting up the chain.
    TP.nodeAncestorsPerform(
        elem,
        function(aNode) {

            var scopeAttrVal;

            //  Have to check to make sure we're not at the #document node.
            if (TP.isElement(aNode)) {

                //  Get any 'scope' attributes belonging to the TP.w3.Xmlns.BIND
                //  namespace.

                //  First, check to see if there's a 'bind:repeat' attribute. If
                //  so, we want to use it's value first.
                scopeAttrVal = TP.elementGetAttribute(
                                        aNode, 'bind:repeat', true);

                if (TP.notEmpty(scopeAttrVal)) {
                    scopeVals.push(scopeAttrVal);
                }

                //  If the scope value is a URI, then we break here - we now
                //  have a fully-formed set of scopes.
                if (TP.isURIString(scopeAttrVal)) {
                    return TP.BREAK;
                }

                //  Then, check to see if there's a 'bind:scope' attribute. If
                //  so, we want to use it's value next.
                scopeAttrVal = TP.elementGetAttribute(
                                        aNode, 'bind:scope', true);

                if (TP.notEmpty(scopeAttrVal)) {
                    scopeVals.push(scopeAttrVal);
                }

                //  If the scope value is a URI, then we break here - we now
                //  have a fully-formed set of scopes.
                if (TP.isURIString(scopeAttrVal)) {
                    return TP.BREAK;
                }
            }
        });

    //  Make sure to reverse the scope values, since we want the 'most
    //  significant' to be first.
    scopeVals.reverse();

    //  Trim off formatting expressions unless the caller explicitly asked not
    //  to do it.
    if (TP.notFalse(trimFormatExprs)) {
        scopeVals = scopeVals.map(
                        function(aVal) {
                            if (TP.regex.ACP_FORMAT.test(aVal)) {
                                return aVal.slice(0, aVal.indexOf('.%')).trim();
                            }

                            return aVal;
                        });
    }

    if (TP.notFalse(setCache)) {
        //  Cache the values. Note here how we supply false to *not* broadcast a
        //  change signal - otherwise, the binding machinery will get involved
        //  and send extra notifications.
        this.$set('scopeValues', scopeVals, false);
    }

    return scopeVals;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$getBoundElements',
function(wantsShallowScope) {

    /**
     * @method $getBoundElements
     * @summary Returns an Array of the bound elements under the receiver.
     * @param {Boolean} wantsShallowScope Whether or not to produce bound
     *     elements that are 'under' a nested scope (i.e. either a bind:scope or
     *     bind:repeat) under the receiver.
     * @returns {Element[]} An Array of bound elements.
     */

    var elem,

        doc,

        filterQuery,

        allFilters,
        ownShallowFilters,

        allBoundQuery,
        boundElems;

    elem = this.getNativeNode();

    doc = TP.nodeGetDocument(elem);

    //  Define a query that will filter out binding expressions under elements
    //  with a tibet:opaque="bind" attribute.
    filterQuery = '*|*[*|opaque="bind"]';

    if (wantsShallowScope) {
        //  Note here how we ignore bind:scopes that contain a '[' (and are
        //  therefore bind:repeat scopes).
        filterQuery += ', *[*|scope]:not([*|scope*="["]), *[*|repeat]';
    }

    //  Grab all of the filtering elements in the whole document.
    allFilters = TP.ac(doc.documentElement.querySelectorAll(filterQuery));

    //  We need to compute the set of filtering elements that *are* under the
    //  receiver, so that we can use them later for filtering.

    //  Filter all of the filtering elements in the document so that only those
    //  that are under the target element and at the shallowest level (i.e. not
    //  containing any other filtering elements themselves) are left.
    ownShallowFilters = allFilters.filter(
            function(aFilter) {

                var k;

                //  We don't want ourself in the list
                if (aFilter === elem) {
                    return false;
                }

                if (!elem.contains(aFilter)) {
                    return false;
                }

                for (k = 0; k < allFilters.length; k++) {
                    //  If:
                    //  -   We're not checking ourself as a filter
                    //  -   The filter we're checking is actually contained in
                    //      the element
                    //  -   The iterating filter contains the target filter
                    //  -   We're at the end of checking all of the filters
                    //  then return false to filter out the target filter.
                    if (allFilters[k] !== aFilter &&
                        elem.contains(allFilters[k]) &&
                        allFilters[k].contains(aFilter)) {
                            if (k === allFilters.length - 1) {
                                return false;
                            }
                    }
                }

                return true;
            });

    //  Grab all of the bound elements, including scoping elements, in the whole
    //  document. Note here how we ignore bind:scopes that contain a '[' (and
    //  are therefore scopes generated by us under a bind:repeat).
    allBoundQuery =
        '*[*|io], *[*|in], *[*|scope]:not([*|scope*="["]), *[*|repeat]';

    boundElems = TP.ac(doc.documentElement.querySelectorAll(allBoundQuery));

    //  Filter all of the bound elements so that they're a) under ourself and
    //  b) that they're only under one of *our* filtering elements.
    boundElems = boundElems.filter(
            function(aNewElem) {

                var k;

                //  We don't want ourself in the list
                if (aNewElem === elem) {
                    return false;
                }

                if (elem.contains(aNewElem)) {

                    for (k = 0; k < ownShallowFilters.length; k++) {

                        //  The element was contained in a subscope - return
                        //  false to filter it out.
                        if (ownShallowFilters[k].contains(aNewElem)) {
                            return false;
                        }
                    }

                    return true;
                }

                return false;
            });

    //  If there are shallow filter elements that occurred under the target
    //  element, then we add them to the result. Note that we filter out any
    //  non-roots (since we won't want nested shallow filters appended here -
    //  each filter root will find *all* of the bound nodes under itself,
    //  including those in a nested filter).
    if (TP.notEmpty(ownShallowFilters)) {
        ownShallowFilters = TP.nodeListFilterNonRoots(ownShallowFilters);
        boundElems = boundElems.concat(ownShallowFilters);
    }

    return boundElems;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getBoundValue',
function(aspectName) {

    /**
     * @method getBoundValue
     * @summary Returns the bound value of the aspect on the receiver.
     * @param {String} aspectName The name of the aspect that the caller wants
     *     the bound value for.
     * @returns {Object} The value of the bound aspect.
     */

    var result,

        scopeValues,

        bindingInfo,

        keys,
        len,
        i,

        bindEntry,
        bindAspectName,
        bindVal;

    result = null;

    scopeValues = this.getBindingScopeValues();

    //  Extract the binding information from the supplied binding information
    //  value String. This may have already been parsed and cached, in which
    //  case we get the cached values back.
    bindingInfo = this.getBindingInfoFrom(
                    'bind:in', this.getAttribute('bind:in'));

    keys = bindingInfo.getKeys();
    len = keys.getSize();
    for (i = 0; i < len; i++) {

        bindEntry = bindingInfo.at(keys.at(i));
        bindAspectName = bindEntry.first();

        if (bindAspectName === aspectName) {
            bindVal = bindEntry.last();

            result = this.$computeValueForBoundAspect(bindVal, scopeValues);

            return result;
        }
    }

    //  It might not have been in the 'bind:in', so we do it again with
    //  'bind:io'

    //  Extract the binding information from the supplied binding information
    //  value String. This may have already been parsed and cached, in which
    //  case we get the cached values back.
    bindingInfo = this.getBindingInfoFrom(
                    'bind:io', this.getAttribute('bind:io'));

    keys = bindingInfo.getKeys();
    len = keys.getSize();
    for (i = 0; i < len; i++) {

        bindEntry = bindingInfo.at(keys.at(i));
        bindAspectName = bindEntry.first();

        if (bindAspectName === aspectName) {
            bindVal = bindEntry.last();

            result = this.$computeValueForBoundAspect(bindVal, scopeValues);

            return result;
        }
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getBoundValues',
function(attributeName, scopeValues, bindingInfoValue) {

    /**
     * @method getBoundValues
     * @summary Returns a hash of the bound values of the receiver.
     * @param {String} attributeName The name of the attribute that binding
     *     information is coming from.
     * @param {String[]} scopeValues The list of scoping values (i.e. parts
     *     that, when combined, make up the entire bind scoping path).
     * @param {String} bindingInfoValue A String, usually in a JSON-like format,
     *     that details the binding information for the receiver. That is, the
     *     bounds aspects of the receiver and what they're bound to.
     * @returns {TP.core.Hash} A hash of the bound values where the key is the
     *     bound aspect and the value is the value of that aspect in the bound
     *     data source.
     */

    var retVal,

        bindingInfo;

    retVal = TP.hc();

    //  Extract the binding information from the supplied binding information
    //  value String. This may have already been parsed and cached, in which
    //  case we get the cached values back.
    bindingInfo = this.getBindingInfoFrom(attributeName, bindingInfoValue);

    //  Iterate over each binding expression in the binding information.
    bindingInfo.perform(
        function(bindEntry) {
            var aspectName,

                bindVal,

                result;

            aspectName = bindEntry.first();
            bindVal = bindEntry.last();

            result = this.$computeValueForBoundAspect(bindVal, scopeValues);

            retVal.atPut(aspectName, result);
        }.bind(this));

    return retVal;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$getBranchValueAndPathType',
function(branchExpr, initialVal, initialPathType) {

    /**
     * @method $getBranchValueAndPathType
     * @summary Returns the branch value given the expression and the initial
     *     value. If a path type is supplied, it is used to further refine the
     *     value extraction.
     * @param {String} branchExpr The branch binding expressions that we're
     *     using to retrieve the value.
     * @param {Object} initialVal The initial value to use to compute the branch
     *     value.
     * @param {Number} [initialPathType] The path type that was precomputed by
     *     the caller. Note that the method will also return a computed path
     *     type. If this parameter is supplied, it will be taken into account
     *     when computing the path type.
     * @returns {Array<Object, Number>} The computed value and path type.
     */

    var theVal,

        branchValReq,
        branchURI,
        branchVal,

        pathType;

    theVal = initialVal;

    //  If the attribute value is a whole URI, then just grab the
    //  result of the URI and use that as the branch value to
    //  process 'the next level down' in the branching.
    if (TP.isURIString(branchExpr)) {
        branchURI = TP.uc(branchExpr);
        branchValReq = TP.request('shouldCollapse', false);

        if (branchURI.hasFragment()) {
            branchVal = branchURI.getResource(branchValReq).get('result');
        } else if (TP.isValid(theVal)) {
            branchVal = theVal;
        } else {
            branchVal = branchURI.getResource(branchValReq).get('result');
        }

        //  Try to detect the type of path based on tasting the
        //  branch value. This makes things much easier later on.
        if (TP.isXMLNode(branchVal)) {
            pathType = TP.ifInvalid(initialPathType, TP.XPATH_PATH_TYPE);
        } else if (TP.isKindOf(branchVal, TP.dom.Node)) {
            pathType = TP.ifInvalid(initialPathType, TP.XPATH_PATH_TYPE);
        } else if (TP.regex.JSON_POINTER.test(branchExpr) ||
                    TP.regex.JSON_PATH.test(branchExpr)) {
            pathType = TP.ifInvalid(initialPathType, TP.JSON_PATH_TYPE);
        } else if (branchURI.hasFragment()) {
            pathType = branchURI.getFragmentAccessPathType();
        }

    } else {

        if (TP.isValid(theVal)) {

            //  Adjust for the fact that, if it's an Array of XML nodes, that
            //  the extraction expression will be done in XPath (i.e. 1-based),
            //  but the Array is, of course, 0-based. So unshift a TP.NULL as a
            //  first value onto the front of the Array (but only if we haven't
            //  been here before and there's already a TP.NULL in the first
            //  position).
            if (TP.isArray(theVal) &&
                theVal.first() !== TP.NULL &&
                TP.isXMLNode(TP.unwrap(theVal.first()))) {
                theVal = TP.copy(theVal);
                theVal.unshift(TP.NULL);
            }

            if (TP.isXMLNode(theVal)) {
                branchVal = TP.wrap(theVal).get(TP.xpc(branchExpr));
                pathType = TP.ifInvalid(initialPathType,
                                        TP.XPATH_PATH_TYPE);
            } else if (TP.isKindOf(theVal, TP.dom.Node)) {
                branchVal = theVal.get(TP.xpc(branchExpr));
                pathType = TP.ifInvalid(initialPathType,
                                        TP.XPATH_PATH_TYPE);
            } else if (TP.regex.JSON_POINTER.test(branchExpr) ||
                        TP.regex.JSON_PATH.test(branchExpr)) {
                if (!TP.isKindOf(theVal, TP.core.JSONContent)) {
                    theVal = TP.core.JSONContent.construct(theVal);
                }

                branchVal = this.$extractValue(theVal,
                                                branchExpr,
                                                TP.jpc,
                                                TP.hc('shouldCollapse', false));

                pathType = TP.ifInvalid(initialPathType, TP.JSON_PATH_TYPE);
            } else if (TP.isKindOf(theVal, TP.core.JSONContent) &&
                        TP.regex.JS_IDENTIFIER.test(branchExpr)) {
                branchVal = theVal.get('$.' + branchExpr);
                pathType = TP.JSON_PATH_TYPE;
            } else if (TP.notValid(theVal)) {
                branchVal = null;
            } else if (TP.isPlainObject(theVal)) {
                branchVal = theVal[branchExpr];
            } else {
                branchVal = theVal.get(branchExpr);
            }
        }
    }

    pathType = TP.ifInvalid(pathType, initialPathType);

    return TP.ac(branchVal, pathType);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getFullBindingPathFrom',
function(pathTail) {

    /**
     * @method getFullBindingPathFrom
     * @summary Returns a path computed from the receiver's binding scope and
     *     the supplied path tail.
     * @param {String} [pathTail=''] The tail of the path to use for the
     *     returned full binding path. Note that this will default to the empty
     *     String.
     * @returns {String} The fully qualified binding path computed from the
     *     binding scope of the receiver and the supplied path tail.
     */

    var scopeVals,
        tail,

        allVals,

        fullPath;

    scopeVals = this.getBindingScopeValues();
    tail = TP.ifInvalid(pathTail, '');

    allVals = scopeVals.concat(tail);

    fullPath = TP.uriJoinFragments.apply(TP, allVals);

    return fullPath;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getFullyExpandedBindingExpressions',
function(attributeName) {

    /**
     * @method getFullyExpandedBindingExpressions
     * @summary Returns all of the 'fully expanded' binding expressions for the
     *     receiver.
     * @param {String} attributeName The name of the attribute to obtain binding
     *     information from.
     * @description These are computed by taking all of the scoping values plus
     *     the local expression and then expanding them into the fully expanded
     *     binding expression.
     * @returns {TP.core.Hash} A hash of the aspect names and an Array of
     *     fully-formed binding expressions on the receiver for each name.
     */

    var scopeVals,

        results,

        attrVal,

        info;

    if (TP.isEmpty(attributeName)) {
        return null;
    }

    //  Get all of the scoping values and the local attribute value for the
    //  attribute name computed above.
    scopeVals = this.getBindingScopeValues();

    results = TP.hc();

    //  If the attribute is a 'bind:scope' or 'bind:repeat', then all we really
    //  need are the scoping values themselves.
    if (attributeName === 'bind:scope' || attributeName === 'bind:repeat') {
        results.atPut('scope', TP.ac(TP.uriJoinFragments.apply(TP, scopeVals)));
    } else {
        attrVal = this.getAttribute(attributeName);

        //  Grab the binding info for that local attribute value.
        info = this.getBindingInfoFrom(attributeName, attrVal);

        info.perform(
            function(kvPair) {

                var dataExprs,
                    exprResults,

                    len,
                    i,

                    dataExpr,

                    allVals,
                    fullExpr;

                //  Get all data expressions for the named aspect.
                dataExprs = kvPair.last().at('dataExprs');

                exprResults = TP.ac();

                len = dataExprs.getSize();
                for (i = 0; i < len; i++) {
                    dataExpr = TP.trim(dataExprs.at(i));

                    if (TP.isEmpty(dataExpr)) {
                        continue;
                    }

                    //  Join together the each expression along with the scoping
                    //  values to calculate the 'fully formed' binding
                    //  expression.
                    allVals = scopeVals.concat(dataExpr);

                    fullExpr = TP.uriJoinFragments.apply(TP, allVals);

                    exprResults.push(fullExpr);
                }

                results.atPut(kvPair.first(), exprResults);
            });
    }

    return results;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$getNearestRepeatIndex',
function() {

    /**
     * @method $getNearestRepeatIndex
     * @summary Returns the 'nearest' repeat index to the receiver. The receiver
     *     might be nested in multiple repeat contexts and this will return the
     *     'most specific' one to the receiver.
     * @returns {Number} The repeat index 'nearest' to the receiver in it's
     *     ancestor chain or TP.NOT_FOUND.
     */

    var scopeVals,

        len,
        i,

        repeatIndex,

        val;

    //  Grab all of the binding scope values. If there aren't any, then we just
    //  return TP.NOT_FOUND
    scopeVals = this.getBindingScopeValues();

    if (TP.isEmpty(scopeVals)) {
        return TP.NOT_FOUND;
    }

    //  Reverse the values, since we want to find the nearest (i.e. the most
    //  specific) index (we might be in a nested repeat)
    scopeVals.reverse();

    repeatIndex = TP.NOT_FOUND;

    //  Iterate up through the scoping values, looking for a numeric scope.
    len = scopeVals.getSize();
    for (i = 0; i < len; i++) {

        val = scopeVals.at(i);

        //  If attribute value contains '[N]', where N is an integer, then we
        //  extract that and convert it to a Number.
        if (TP.regex.SIMPLE_NUMERIC_PATH.test(val)) {
            repeatIndex = TP.regex.SIMPLE_NUMERIC_PATH.exec(
                                        val).at(1).asNumber();
            break;
        }
    }

    return repeatIndex;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getRepeatPageCount',
function() {

    /**
     * @method getRepeatPageCount
     * @summary Returns the total number of repeat 'pages' there are in the
     *     receiver, based on the total number of items in the collection being
     *     represented by the 'bind:repeat' and the value of the
     *     'bind:repeatsize' attribute (which defaults to 1).
     * @returns {Number} The total number of repeat 'pages' there are.
     */

    var repeatCollection,
        repeatSize;

    repeatCollection = this.$getRepeatValue();

    if (!TP.isCollection(repeatCollection)) {
        return -1;
    }

    repeatSize = this.getAttribute('bind:repeatsize');

    return (repeatCollection.getSize() / repeatSize).ceil();
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('getRepeatPage',
function() {

    /**
     * @method getRepeatPage
     * @summary Returns the repeat page 'position', that is the currently
     *     showing page of repeating results.
     * @returns {Number} The repeat page position.
     */

    var repeatSize,
        repeatIndex;

    repeatSize = this.getAttribute('bind:repeatsize');

    //  Need to adjust for 1-based vs. 0-based computation.
    repeatIndex = this.getAttribute('bind:repeatindex') + 1;

    return (repeatIndex / repeatSize).ceil();
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$getRepeatSourceAndIndex',
function(repeatElem) {

    /**
     * @method $getRepeatSourceAndIndex
     * @summary Returns the repeating data source and index for the receiver if
     *     the receiver is under a 'bind:repeat' and is participating in the
     *     repeating iteration mechanics.
     * @param {Element} repeatElem The element containing the repeat.
     * @returns {Array<Object,Number>} An Array containing the repeat source and
     *     repeat index.
     */

    var elem,

        cachedIndexingSource,

        repeatAttrVal,

        repeatSource,

        repeatScopeVals,
        repeatPath,

        attrVal,
        repeatIndex;

    elem = this.getNativeNode();

    //  See if there's a parent element where we've cached the repeat source
    //  (and repeat index) when we generated the repeat.
    cachedIndexingSource = TP.nodeDetectAncestor(
                            elem,
                            function(aNode) {
                                return TP.isValid(aNode[TP.REPEAT_SOURCE]) &&
                                        TP.isNumber(aNode[TP.REPEAT_INDEX]);
                            });

    //  If we successfully found a cached properties parent, return the value of
    //  the cached source and cached index for this element.
    if (TP.isElement(cachedIndexingSource)) {
        //  Return an Array containing the repeat source and repeat index.
        return TP.ac(cachedIndexingSource[TP.REPEAT_SOURCE],
                        cachedIndexingSource[TP.REPEAT_INDEX]);
    }

    //  If we successfully detected a 'bind:repeat' ancestor, then try to
    //  calculate a repeat resource and our index within that repeat resource.
    if (TP.isElement(repeatElem)) {

        //  Grab any cached repeat resource on the repeat element that we might
        //  have computed already.
        repeatSource = repeatElem[TP.REPEAT_SOURCE];

        //  If there is none, compute it and cache it on the repeat.
        if (TP.notValid(repeatSource)) {

            repeatAttrVal = TP.elementGetAttribute(elem, 'bind:repeat', true);

            //  Try to calculate a repeat resource

            //  NB: Note how we do *not* want the getResource() call to collapse
            //  it's results for these calls - we always want a collection.

            //  If it's a URI String, then we can calculate a TP.uri.URI from it
            //  and just grab that resource's value.
            if (TP.isURIString(repeatAttrVal)) {
                repeatSource = TP.uc(repeatAttrVal).getResource(
                            TP.request('shouldCollapse', false)).get('value');
            } else {

                //  Otherwise, get the 'bind:repeat' ancestor's binding scope
                //  values, compute a path from them and use that as the URI.
                repeatScopeVals = TP.wrap(repeatElem).
                                getBindingScopeValues().concat(repeatAttrVal);
                repeatPath = TP.uriJoinFragments.apply(TP, repeatScopeVals);

                repeatSource = TP.uc(repeatPath).getResource(
                            TP.request('shouldCollapse', false)).get('value');
            }

            repeatElem[TP.REPEAT_SOURCE] = repeatSource;
        }

        //  Try to calculate a repeat index

        //  If we have a numeric 'bind:scope' attribute, then that means that
        //  we're the actual 'row' in the repeat.
        if (TP.elementHasAttribute(elem, 'bind:scope', true)) {
            if (TP.notEmpty(attrVal = TP.elementGetAttribute(
                                            elem, 'bind:scope', true))) {

                //  If attribute value contains '[N]', where N is an integer,
                //  then we extract that and convert it to a Number.
                if (TP.regex.SIMPLE_NUMERIC_PATH.test(attrVal)) {
                    repeatIndex = TP.regex.SIMPLE_NUMERIC_PATH.exec(
                                                attrVal).at(1).asNumber();

                    //  Cache the repeat source and repeat index values on the
                    //  binding scope.
                    elem[TP.REPEAT_SOURCE] = repeatSource;
                    elem[TP.REPEAT_INDEX] = repeatIndex;
                }
            }
        }

        //  If we could not get a repeat index from ourself, then we look up the
        //  ancestor chain looking for one.
        if (!TP.isNumber(repeatIndex)) {

            TP.nodeDetectAncestor(
                elem,
                function(aNode) {
                    if (TP.isElement(aNode) &&
                        TP.notEmpty(attrVal = TP.elementGetAttribute(
                                                aNode, 'bind:scope', true))) {

                        //  If attribute value contains '[N]', where N is an
                        //  integer, then we extract that and convert it to a
                        //  Number.
                        if (TP.regex.SIMPLE_NUMERIC_PATH.test(attrVal)) {
                            repeatIndex = TP.regex.SIMPLE_NUMERIC_PATH.exec(
                                                    attrVal).at(1).asNumber();

                            //  Cache the repeat source and repeat index values
                            //  on the binding scope.
                            aNode[TP.REPEAT_SOURCE] = repeatSource;
                            aNode[TP.REPEAT_INDEX] = repeatIndex;

                            return true;
                        }
                    }

                    return false;
                });
        }

        //  Return an Array containing the repeat source and repeat index.
        return TP.ac(repeatSource, repeatIndex);
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$getRepeatTemplate',
function() {

    /**
     * @method $getRepeatTemplate
     * @summary Returns the repeat template Element for the receiver.
     * @returns {Element} The repeat template Element.
     */

    var elem,

        templateID,
        templateInfo,

        repeatContent;

    elem = this.getNativeNode();

    //  If we successfully detected a 'bind:repeat' ancestor, then try to
    //  calculate a repeat resource and our index within that repeat resource.
    if (TP.elementHasAttribute(elem, 'bind:repeat', true)) {

        //  Grab the unique templateID that should've been placed on us when our
        //  template content was captured.
        templateID = TP.elementGetAttribute(elem, 'tibet:templateid', true);
        if (TP.isEmpty(templateID)) {
            //  TODO: Raise an exception
            return null;
        }

        //  The template content was stored on our TP.dom.Document when it was
        //  captured and was stored under our templateID.
        if (TP.notValid(
                templateInfo = this.getDocument().get('$repeatTemplates'))) {
            //  TODO: Raise an exception
            return null;
        }

        if (TP.notValid(repeatContent = templateInfo.at(templateID))) {
            //  TODO: Raise an exception
            return null;
            /*
            repeatContent = this.$captureRepeatContent(boundElems);
            if (!TP.owns(this, 'addContent')) {
                this.defineMethod(
                    'addContent',
                    function(newContent, aRequest, stdinContent) {
                        this.callNextMethod();
                        this.$captureRepeatContent();
                    });
                this.defineMethod(
                    'insertContent',
                    function(newContent, aRequest, stdinContent) {
                        this.callNextMethod();
                        this.$captureRepeatContent();
                    });
                this.defineMethod(
                    'replaceWith',
                    function(newContent, aRequest, stdinContent) {
                        this.callNextMethod();
                        this.$captureRepeatContent();
                    });
                this.defineMethod(
                    'setContent',
                    function(newContent, aRequest, stdinContent) {
                        this.callNextMethod();
                        this.$captureRepeatContent();
                    });
            }
            */
        }

        return repeatContent;
    }

    return null;
}, {
    patchCallee: false
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$getRepeatValue',
function() {

    /**
     * @method $getRepeatValue
     * @summary Returns the repeating data source for the receiver if the
     *     receiver is itself a 'bind:repeat'.
     * @returns {Object} The object representing the receiver's repeat value.
     *     This should be a Collection that can be iterated on.
     */

    var elem,

        repeatScopeVals,
        repeatPath,

        repeatSource;

    elem = this.getNativeNode();

    //  If we successfully detected a 'bind:repeat' ancestor, then try to
    //  calculate a repeat resource and our index within that repeat resource.
    if (TP.elementHasAttribute(elem, 'bind:repeat', true)) {

        //  Try to calculate a repeat resource

        //  NB: Note how we do *not* want the getResource() call to collapse
        //  it's results for this call - we always want a collection.

        //  Get the 'bind:repeat' ancestor's binding scope values, compute a
        //  path from them and use that as the URI.
        repeatScopeVals = this.getBindingScopeValues();
        repeatPath = TP.uriJoinFragments.apply(TP, repeatScopeVals);

        repeatSource = TP.uc(repeatPath).getResource(
                        TP.request('shouldCollapse', false)).get('value');

        return repeatSource;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineHandler('UIPageEnd',
function(aSignal) {

    /**
     * @method handleUIPageEnd
     * @summary Handles when the data 'pages' should be set to the last page.
     * @param {TP.sig.UIPageEnd} aSignal The signal instance which triggered
     *     this handler.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var elem,
        pagePos;

    elem = this.getNativeNode();
    if (TP.elementHasAttribute(elem, 'bind:repeat', true)) {

        pagePos = this.getRepeatPageCount();
        this.setRepeatPage(pagePos);

        //  Make sure to stop the signal propagation here - we've processed the
        //  paging.
        aSignal.stopPropagation();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineHandler('UIPageNext',
function(aSignal) {

    /**
     * @method handleUIPageNext
     * @summary Handles when the data 'pages' should be set to the next page
     *     from the current one.
     * @param {TP.sig.UIPageNext} aSignal The signal instance which triggered
     *     this handler.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var elem,
        pagePos;

    elem = this.getNativeNode();
    if (TP.elementHasAttribute(elem, 'bind:repeat', true)) {

        pagePos = this.getRepeatPage() + 1;
        this.setRepeatPage(pagePos);

        //  Make sure to stop the signal propagation here - we've processed the
        //  paging.
        aSignal.stopPropagation();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineHandler('UIPagePrevious',
function(aSignal) {

    /**
     * @method handleUIPagePrevious
     * @summary Handles when the data 'pages' should be set to the previous page
     *     from the current one.
     * @param {TP.sig.UIPagePrevious} aSignal The signal instance which
     *     triggered this handler.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var elem,
        pagePos;

    elem = this.getNativeNode();
    if (TP.elementHasAttribute(elem, 'bind:repeat', true)) {

        pagePos = this.getRepeatPage() - 1;
        this.setRepeatPage(pagePos);

        //  Make sure to stop the signal propagation here - we've processed the
        //  paging.
        aSignal.stopPropagation();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineHandler('UIPageSet',
function(aSignal) {

    /**
     * @method handleUIPageSet
     * @summary Handles when the data 'pages' should be set to a specific page.
     * @param {TP.sig.UIPageSet} aSignal The signal instance which triggered
     *     this handler.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var elem,
        pagePos;

    elem = this.getNativeNode();
    if (TP.elementHasAttribute(elem, 'bind:repeat', true)) {

        pagePos = aSignal.at('pageNum');
        this.setRepeatPage(pagePos);

        //  Make sure to stop the signal propagation here - we've processed the
        //  paging.
        aSignal.stopPropagation();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineHandler('UIPageStart',
function(aSignal) {

    /**
     * @method handleUIPageStart
     * @summary Handles when the data 'pages' should be set to the first page.
     * @param {TP.sig.UIPageStart} aSignal The signal instance which triggered
     *     this handler.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var elem;

    elem = this.getNativeNode();
    if (TP.elementHasAttribute(elem, 'bind:repeat', true)) {

        this.setRepeatPage(1);

        //  Make sure to stop the signal propagation here - we've processed the
        //  paging.
        aSignal.stopPropagation();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineHandler('UIRefresh',
function(aSignal) {

    /**
     * @method handleUIRefresh
     * @summary Refreshes the receiver's bound data.
     * @param {TP.sig.UIRefresh} aSignal The signal instance which triggered
     *     this handler.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    this.refresh();

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$insertRepeatRowAt',
function(indexes, aCollection) {

    /**
     * @method $insertRepeatRowAt
     * @summary Insert rows at the indexes provided.
     * @description Note that the indexes supplied to this method should match
     *     the type of data source object of the repeat. If the data source of
     *     the repeat is an XML object, these indexes should be '1-based' (like
     *     XPath). If it is an JS or JSON object, these indexes should be
     *     '0-based' (like JSONPath).
     * @param {Number[]} indexes An Array of Numbers that indicate the indexes
     *     of the items to insert new items at.
     * @param {Object} aCollection The collection data model that will be used
     *     for the repeating content. Note that this method merely generates the
     *     blank repeating row for the single insertion - it is up to other
     *     methods to refresh the data bindings within them.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var elem,

        templateID,
        templateInfo,

        repeatContent,

        wrapperElement,

        tpDoc,

        isXMLResource,

        str,

        len,
        i,

        index,

        newElement,
        newTPElem,

        scopeIndex,
        last,

        info,

        result,

        insertionPoint,

        followingScopedSiblings,
        len2,
        j,
        scopedSibling,
        scopeVal,

        firstRow,

        thisref,

        evt;

    elem = this.getNativeNode();

    templateID = TP.elementGetAttribute(elem, 'tibet:templateid', true);
    if (TP.isEmpty(templateID)) {
        //  TODO: Raise an exception
        return this;
    }

    if (TP.notValid(
            templateInfo = this.getDocument().get('$repeatTemplates'))) {
        //  TODO: Raise an exception
        return this;
    }

    //  This will be a DocumentFragment that we stuffed away when the receiver
    //  was rebuilt.
    if (TP.notValid(repeatContent = templateInfo.at(templateID))) {
        return this;
    }

    //  If the repeat content's child element list has a size of 1, then we
    //  reach under there and use that element as the repeat content
    if (TP.nodeGetChildElements(repeatContent).getSize() === 1) {
        repeatContent = repeatContent.firstElementChild;
    }

    //  Whichever element has a 'tibet:no-mutations' attribute on it is
    //  acting as a common wrapper for the 'rows' making up the repeat. This may
    //  be a <tbody> element if we're repeating rows in a <table>, but it
    //  doesn't have to be.
    if (TP.elementHasAttribute(elem, 'tibet:no-mutations', true)) {
        wrapperElement = elem;
    } else {
        wrapperElement = TP.byCSSPath(
                            '> *[tibet|no-mutations]',
                            elem,
                            true,
                            false);
    }

    if (!TP.isElement(wrapperElement)) {
        //  TODO: Raise exception
        return this;
    }

    tpDoc = this.getDocument();

    if (TP.canInvoke(aCollection, 'first')) {
        //  Detect whether we're drawing GUI for model which is a chunk of XML
        //  data - we'll use this information later.
        isXMLResource = TP.isXMLNode(TP.unwrap(aCollection.first()));
    } else {
        isXMLResource = false;
    }

    //  Get the String representation of the repeat content. We'll use this
    //  later to check for ACP expressions.
    str = TP.str(repeatContent);

    //  Loop over all of the supplied indices
    len = indexes.getSize();
    for (i = 0; i < len; i++) {

        index = indexes.at(i);

        //  Make sure to clone the content and set it's 'bind:scope' to the
        //  index that we're inserting at.
        newElement = TP.nodeCloneNode(repeatContent);
        newTPElem = TP.wrap(newElement);

        //  NB: We don't do index adjustment here for XML resources since the
        //  changed indices were supplied to this call already having been
        //  adjusted for the supplied data source.
        scopeIndex = index;

        if (TP.regex.HAS_ACP.test(str)) {
            if (isXMLResource) {

                last = aCollection.getSize();

                info = TP.hc(
                        '$REQUEST', null,
                        'TP', TP,
                        'APP', APP,
                        '$SOURCE', this,
                        '$TAG', newTPElem,
                        '$TARGET', tpDoc,
                        '$_', aCollection.at(scopeIndex),
                        '$INPUT', aCollection,
                        '$INDEX', scopeIndex,
                        '$FIRST', scopeIndex === 1,
                        '$MIDDLE', scopeIndex > 1 && scopeIndex < last,
                        '$LAST', scopeIndex !== last,
                        '$EVEN', scopeIndex % 2 === 0,
                        '$ODD', scopeIndex % 2 !== 0,
                        '$#', scopeIndex);
            } else {

                last = aCollection.getSize() - 1;

                info = TP.hc(
                        '$REQUEST', null,
                        'TP', TP,
                        'APP', APP,
                        '$SOURCE', this,
                        '$TAG', newTPElem,
                        '$TARGET', tpDoc,
                        '$_', aCollection.at(scopeIndex),
                        '$INPUT', aCollection,
                        '$INDEX', scopeIndex,
                        '$FIRST', scopeIndex === 0,
                        '$MIDDLE', scopeIndex > 0 && scopeIndex < last,
                        '$LAST', scopeIndex !== last,
                        '$EVEN', scopeIndex % 2 === 0,
                        '$ODD', scopeIndex % 2 !== 0,
                        '$#', scopeIndex);
            }

            result = str.transform(null, info);
            newElement = TP.elem(result);
        }

        TP.elementSetAttribute(newElement,
                                'bind:scope',
                                '[' + index + ']',
                                true);

        //  An insertion point would be the element with the same index as the
        //  row we're inserting. If we find one, we insert the new row before
        //  that and increment the number of all numeric scoped elements *at the
        //  same level* with an index equal to or greater than the insert index.
        insertionPoint = TP.byCSSPath(
                                '> *[bind|scope="[' + index + ']"]',
                                wrapperElement,
                                true,
                                false);

        //  There was no insertion point - just append the element.
        if (!TP.isElement(insertionPoint)) {
            newElement = TP.nodeAppendChild(wrapperElement, newElement, false);
        } else {

            //  Otherwise, go ahead and insert the element and then renumber all
            //  of the ones coming after. Note the reassignment.
            newElement = TP.nodeInsertBefore(
                            wrapperElement, newElement, insertionPoint, false);

            //  Now, grab all of the scoped siblings that follow the element
            //  that we're going to insert.
            followingScopedSiblings = TP.byCSSPath(
                                        '~ *[bind|scope^="["][bind|scope$="]"]',
                                        newElement,
                                        false,
                                        false);

            //  Iterate over all of the scoped siblings and adjust their index.
            //  Note how we start by incrementing the index 1 past where we just
            //  inserted the new row. Then we set the sibling to that scope
            //  number and advance.

            len2 = followingScopedSiblings.getSize();
            for (j = 0; j < len2; j++) {

                scopedSibling = followingScopedSiblings.at(j);

                if (TP.notEmpty(scopeVal = TP.elementGetAttribute(
                                        scopedSibling, 'bind:scope', true))) {

                    if (TP.regex.SIMPLE_NUMERIC_PATH.test(scopeVal)) {

                        index += 1;
                        TP.elementSetAttribute(
                                scopedSibling,
                                'bind:scope',
                                '[' + index + ']',
                                true);
                    }
                }
            }
        }

        //  Awaken any content under the newly inserted Element.
        TP.nodeAwakenContent(newElement);

        //  Bubble any xmlns attributes upward to avoid markup clutter.
        TP.elementBubbleXMLNSAttributes(newElement);

        if (i === 0) {
            firstRow = newElement;
        }
    }

    if (TP.isElement(firstRow)) {
        //  Focus the first autofocus or focusable descendant of the new row.
        //  TODO: Should this be configurable (i.e. via another 'bind:'
        //  attribute - 'bind:focusfirst' or something).
        (function() {
            TP.wrap(firstRow).focusAutofocusedOrFirstFocusableDescendant();
        }).queueBeforeNextRepaint(this.getNativeWindow());
    }

    //  Send a UIDidInsert with ourself as the target and the set of indexes
    //  that the insertion happened at.
    thisref = this;

    (function() {
        thisref.signal('TP.sig.UIDidInsert',
                        TP.hc('target', thisref, 'indexes', indexes));
    }).queueBeforeNextRepaint(this.getNativeWindow());

    //  Send a custom DOM-level event to allow 3rd party libraries to know that
    //  content has been added.

    evt = this.getNativeDocument().createEvent('Event');
    evt.initEvent('TIBETContentAdded', true, true);
    evt.data = TP.ac(newElement);

    wrapperElement.dispatchEvent(evt);

    return newElement;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('isBoundElement',
function() {

    /**
     * @method isBoundElement
     * @summary Whether or not the receiver is a bound element.
     * @returns {Boolean} Whether or not the receiver is bound.
     */

    var elem;

    elem = this.getNativeNode();

    return TP.elementHasAttribute(elem, 'bind:in', true) ||
            TP.elementHasAttribute(elem, 'bind:out', true) ||
            TP.elementHasAttribute(elem, 'bind:io', true);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('isScopingElement',
function() {

    /**
     * @method isScopingElement
     * @summary Returns whether or not the receiver is a 'scoping' element (that
     *     is, an Element containing a 'bind:scope' or 'bind:repeat').
     * @returns {Boolean} Whether or not the receiver is a scoping element.
     */

    var elem;

    elem = this.getNativeNode();

    return TP.elementHasAttribute(elem, 'bind:scope', true) ||
            TP.elementHasAttribute(elem, 'bind:repeat', true);
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$refresh',
function(shouldRender) {

    /**
     * @method $refresh
     * @summary Updates the receiver's content by refreshing all bound aspects
     *     in the receiver.
     * @param {Boolean} [shouldRender] Whether or not to force (or not force)
     *     re-rendering if the data source changes. If not supplied, this
     *     parameter will default to true if the bound data changed and false if
     *     it didn't.
     * @returns {Boolean} Whether or not the bound value was different than the
     *     receiver already had and, therefore, truly changed.
     */

    var elem,

        scopeVals,

        didProcess,

        attrNode,
        attrVal,

        valChanged,

        willRender;

    elem = this.getNativeNode();

    //  If this element has a bind:repeat, then just refresh it and move on.
    if (TP.elementHasAttribute(elem, 'bind:repeat', true)) {

        //  If the repeat page position isn't already set to a Number, then
        //  initialize it to 1.
        if (!TP.isNumber(
                this.getAttribute('bind:repeatpage').asNumber())) {
            this.$setAttribute('bind:repeatpage', 1, false);
        }

        //  Refresh the repeating data under us, passing true to regenerate any
        //  new repeat chunks that may be required.
        this.$refreshRepeatData(true);

        return true;
    }

    didProcess = false;
    scopeVals = this.getBindingScopeValues();

    valChanged = false;

    if (TP.elementHasAttribute(elem, 'bind:in', true)) {
        didProcess = true;
        attrNode = TP.elementGetAttributeNode(elem, 'bind:in');
        attrVal = this.getAttribute('bind:in');

        valChanged = this.$refreshAttr(scopeVals, attrNode, 'bind:in', attrVal);
    }

    if (TP.elementHasAttribute(elem, 'bind:io', true)) {
        didProcess = true;
        attrNode = TP.elementGetAttributeNode(elem, 'bind:io');
        attrVal = this.getAttribute('bind:io');

        valChanged = this.$refreshAttr(scopeVals, attrNode, 'bind:io', attrVal);
    }

    //  If this element has a bind:scope, then refresh our bound descendants.
    if (TP.elementHasAttribute(elem, 'bind:scope', true)) {
        valChanged = this.refreshBoundDescendants(shouldRender, false);
    }

    if (!didProcess) {
        //  If this isn't an element around one of those four attributes, then
        //  just call render() and return.
        this.render();

        return valChanged;
    }

    //  If there is no attribute value, then just return
    if (TP.isEmpty(attrVal)) {
        return valChanged;
    }

    //  Note here how we force the value of willRender to shouldRender (no
    //  matter whether it's true or false) if shouldRender is supplied.
    if (TP.notValid(shouldRender)) {
        willRender = valChanged;
    } else {
        willRender = shouldRender;
    }

    if (willRender) {
        this.render();
    }

    return valChanged;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('refresh',
function(shouldRender, shouldRefreshBindings) {

    /**
     * @method refresh
     * @summary Updates the receiver's content by refreshing all bound aspects
     *     in the receiver and all of the descendants of the receiver that are
     *     bound.
     * @param {Boolean} [shouldRender] Whether or not to force (or not force)
     *     re-rendering if the data source changes. If not supplied, this
     *     parameter will default to true if the bound data changed and false if
     *     it didn't.
     * @param {Boolean} [shouldRefreshBindings] Whether or not to refresh data
     *     bindings from the receiver down (in a 'sparse' fashion). If not
     *     supplied, this parameter will default to true.
     * @returns {Boolean} Whether or not the bound value was different than the
     *     receiver already had and, therefore, truly changed.
     */

    var retVal,

        allRefreshedElements;

    //  First, call refresh on all of the *direct children* of the receiver,
    //  specifying to *not* refresh data bindings. We'll do that in a more
    //  efficient way below. In this way, the child refresh will not try to
    //  refresh bindings, but leave it to the sparse update routine below to do
    //  it.
    this.getChildElements().forEach(
        function(aChildTPElem) {
            aChildTPElem.refresh(shouldRender, false);
        });

    //  If the caller hasn't explicitly said to refresh data bindings, then we
    //  do so.
    if (TP.notFalse(shouldRefreshBindings)) {
        retVal = this.$refresh(shouldRender);

        //  If this element has a 'bind:scope', then the '$refresh' call above
        //  will have already called refreshBoundDescendants on it. Note that
        //  refreshBoundDescendants will process refreshed elements so we only
        //  do that if we don't call it.
        if (!this.hasAttribute('bind:scope')) {
            this.refreshBoundDescendants(shouldRender);
        } else {
            //  Send a custom DOM-level event to allow 3rd party libraries to
            //  know that the bindings have been refreshed.
            allRefreshedElements = this.getDocument().get('$refreshedElements');
            if (TP.notEmpty(allRefreshedElements)) {
                this.$sendNativeRefreshEvent();
            }
        }
    } else {
        retVal = false;
    }

    return retVal;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$refreshAttr',
function(scopeVals, attributeNode, bindingAttrName, bindingAttrValue) {

    /**
     * @method $refreshAttr
     * @summary Updates the receiver's content using the supplied scope values,
     *     attribute node and binding expression.
     * @param {String[]} scopeVals An Array of scoping values to use for
     *     computing the binding scope when evaluating the expressions as
     *     supplied in the binding expression.
     * @param {Attribute} attributeNode The attribute node that the binding
     *     expression was found on. This is passed along to code that refreshes
     *     expressions at our 'leaf' level.
     * @param {String} bindingAttrName The name of the binding attribute.
     * @param {String} bindingAttrValue The value of the binding attribute. This
     *     will contain the information that binding expressions can be
     *     extracted from.
     * @returns {Boolean} Whether or not the bound value was different than the
     *     receiver already had and, therefore, truly changed.
     */

    var bindingInfo,

        scopedValExpr,
        scopedURI,
        scopedVal,

        pathType,

        valueAndPath,

        didRefresh;

    //  Extract the binding information from the supplied binding information
    //  value String. This may have already been parsed and cached, in which
    //  case we get the cached values back.
    bindingInfo = this.getBindingInfoFrom(bindingAttrName, bindingAttrValue);

    //  If we are inside of a scoping context.
    if (TP.notEmpty(scopeVals)) {
        //  Concatenate the binding value onto the scope values array (thereby
        //  creating a new Array) and use it to join all of the values together.
        scopedValExpr = TP.uriJoinFragments.apply(TP, scopeVals);

        //  If we weren't able to compute a real URI from the fully expanded URI
        //  value, then raise an exception and return here.
        if (!TP.isURIString(scopedValExpr)) {
            this.raise('TP.sig.InvalidURI');

            return false;
        }

        //  Create a URI from the scoped expression and get its result. This
        //  will provide with the 'closest scoped expression'. Note here how we
        //  specifically tell the URI to *not* signal change if it has to fetch
        //  new content.
        scopedURI = TP.uc(scopedValExpr);
        scopedVal = scopedURI.getResource(
                            TP.request('signalChange', false)).get('result');

        //  Obtain the branching value and path type, given the scoped value
        //  expression and the value as we've computed it so far.
        valueAndPath = this.$getBranchValueAndPathType(
                                scopedValExpr, scopedVal);

        scopedVal = valueAndPath.at(0);
        pathType = valueAndPath.at(1);

    } else {
        scopedVal = null;
        pathType = null;
    }

    didRefresh = false;

    //  Iterate over each binding expression in the binding information.
    bindingInfo.perform(
        function(bindEntry) {

            var aspectName,
                bindVal,

                dataExprs,
                transformFunc,

                refreshedEntry;

            aspectName = bindEntry.first();
            bindVal = bindEntry.last();

            //  There will be 1...n data expressions here.
            dataExprs = bindVal.at('dataExprs');

            //  If a transformation function was computed from the expression,
            //  it will be here.
            transformFunc = bindVal.at('transformFunc');

            //  Set our final value for the current binding expresssion. This
            //  will return whether or not setting this value will have changed
            //  one or more of the values of the observers.
            refreshedEntry = this.$setFinalValue(
                                    aspectName,
                                    dataExprs,
                                    scopedVal,
                                    TP.ac(aspectName),
                                    'value',
                                    transformFunc,
                                    pathType,
                                    this,
                                    null,
                                    NaN);

            //  If at least one returned true, then flip the flag to true. Note
            //  that this is constructed such that, once the flag is flipped to
            //  true, it cannot be changed back.
            if (refreshedEntry) {
                didRefresh = refreshedEntry;
            }
        }.bind(this));

    return didRefresh;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('refreshBoundDescendants',
function(shouldRender, shouldSendEvent) {

    /**
     * @method refreshBoundDescendants
     * @summary Updates bound descendants content by refreshing all bound
     *     aspects in each one.
     * @param {Boolean} [shouldRender] Whether or not to force (or not force)
     *     re-rendering if the data source changes. If not supplied, this
     *     parameter will default to true if the bound data changed and false if
     *     it didn't.
     * @param {Boolean} [shouldSendEvent=true] Whether or not we should send a
     *     custom native event that indicates that we refreshed the bindings.
     * @returns {Boolean} Whether or not the bound value was different than the
     *     receiver already had and, therefore, truly changed.
     */

    var valChanged,

        boundDescendants,

        allRefreshedElements;

    //  Get the bound descendant elements of the receiver. Note how we pass
    //  'true' here to *just* get elements that are 'shallow'. If we pick up
    //  'scope' or 'repeat' elements, those will recursively call this method
    //  for any 'in' or 'io' elements under them.
    boundDescendants = TP.wrap(this.$getBoundElements(true));

    valChanged = false;

    boundDescendants.forEach(
        function(aDescendant) {
            var testValChanged;

            //  NB: We call the primitive '$refresh' call here - otherwise,
            //  we'll end up recursing. Note that, even though boundDescendants
            //  will contain 'bind:scope' and 'bind:repeat' elements at this
            //  point, they will be filtered out by this method. Their
            //  descendants, the real bind:[in|io|out] elements, will be
            //  refreshed.
            testValChanged = aDescendant.$refresh(shouldRender);

            //  NB: We only flip this if the descendant returned true. Once
            //  flipped to true, we never want to flip it back to false.
            if (testValChanged) {
                valChanged = true;
            }
        });

    //  Send a custom DOM-level event to allow 3rd party libraries to know that
    //  the bindings have been refreshed.
    allRefreshedElements = this.getDocument().get('$refreshedElements');
    if (TP.notEmpty(allRefreshedElements) && TP.notFalse(shouldSendEvent)) {
        this.$sendNativeRefreshEvent();
    }

    return valChanged;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$refreshBranches',
function(primarySource, aFacet, initialVal, needsRefreshElems, aPathType, pathParts, pathAction, isScoped, sigOrigin, originWasURI, changeSource, updateIndexes) {

    /**
     * @method $refreshBranches
     * @summary Refreshes any data bindings that are collections ('branches')
     *     under the set of supplied bound elements.
     * @param {Object} primarySource The object that is the primary data source
     *     that leafs under the receiver could be bound to. This is usually a
     *     collection of data.
     * @param {String} [aFacet=value] The facet of the binding expressions that
     *     we're refreshing. This defaults to 'value' which is the 99% case.
     * @param {Object} initialVal The initial value to use to update the
     *     binding. This could be mutated inside of this method to a final,
     *     massaged, value.
     * @param {Element[]} needsRefreshElems An array of elements that are
     *     descendants of the receiver that need to be refreshed from their
     *     binding expressions.
     * @param {Number} [aPathType] The path type that is contained in the
     *     binding expression.
     * @param {String[]} [pathParts] An array of parts of the data binding path
     *     that are being updated as computed by the data content management
     *     engine.
     * @param {String} pathAction If one of the leafs under the receiver is a
     *     repeating construct, then this is a constant to tell the machinery
     *     whether to create/insert or delete items.
     * @param {Boolean} [isScoped] Whether or not this invocation of this method
     *     is servicing a 'scoped' context. Used internally by recursive calls
     *     to this method.
     * @param {Object} [sigOrigin] If a signal initiated the refreshing process,
     *     this will be the signal's 'origin'.
     * @param {Boolean} [originWasURI=false] If a signal initiated the
     *     refreshing process, then this is whether or not the origin of the
     *     signal that started the refreshing process was a TP.uri.URI.
     * @param {Object} [changeSource] The source of the change. If a signal
     *     initiated the refreshing process, this will be the signal's 'source'.
     * @param {Number[]} [updateIndexes] If one of the leafs under the receiver
     *     is a repeating construct, then this is an optional set of indexes
     *     that tells the repeat where to insert, delete, etc.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var elem,

        subscopes,

        boundElems,

        nextElems,

        primaryLoc,
        originalLocationInfos,
        matcherEntries,

        boundAttrCount,

        boundAttrNodes,
        attrs,
        i,
        j,

        theVal,

        primaryLocMatcher,

        len,

        boundAttr,
        attrName,
        attrVal,

        ownerElem,

        bindStr,
        bindEntries,
        bindKeys,
        k,
        bailCount,
        bailEntry,

        isScopingElement,

        valueAndPath,

        branchURI,
        branchVal,

        pathType,

        aspectNames,

        repeatElem,
        inRepeatContext,

        repeatSource,
        repeatIndex,
        repeatInfo,

        repeatScopeVals,
        repeatPath,
        repeatFragExpr,

        updateRepeatIndexes,

        ownerTPElem,

        searchParts,

        partsNegativeSlice,
        predicatePhaseOneComplete,

        didProcess,

        attrInfo,
        updatedUIAspects,

        lastPart,

        startPredIndex,
        endPredIndex,
        hasPredicate,
        predicateStmt,

        searchPath,

        branchMatcher,
        leafMatcher,

        processedElements,

        remainderParts,

        needsRefresh,
        allRefreshedElements,

        insideRepeatScope,

        newRowElem;

    elem = this.getNativeNode();

    //  TIMING: var startQuery = Date.now();

    //  Grab all of the elements that contain 'scope' or 'repeat' attributes.
    //  Note that we can't filter for the 'bind:' (TP.w3.Xmlns.BIND) namespace
    //  on those attributes here because the 'querySelectorAll' call has no
    //  namespace support :-(. It is, however, very fast. We'll filter for that
    //  later.
    subscopes = TP.ac(elem.querySelectorAll('*[*|scope], *[*|repeat]'));

    subscopes = subscopes.filter(
            function(aSubscope) {

                var l;

                //  We don't want ourself in the list
                if (aSubscope === elem) {
                    return false;
                }

                if (!elem.contains(aSubscope)) {
                    return false;
                }

                for (l = 0; l < subscopes.length; l++) {
                    //  If:
                    //  -   We're not checking ourself as a subscope
                    //  -   The subscope we're checking is actually contained in
                    //      the element
                    //  -   The iterating subscope contains the target subscope
                    //  -   We're at the end of checking all of the subscopes
                    //  then return false to filter out the target subscope.
                    if (subscopes[l] !== aSubscope &&
                        elem.contains(subscopes[l]) &&
                        subscopes[l].contains(aSubscope)) {
                            if (l === subscopes.length - 1) {
                                return false;
                            }
                    }
                }

                return true;
            });

    boundElems = needsRefreshElems;

    //  Get the set of elements that are contained within the receiver, but in a
    //  'shallow' fashion - that is, 'under' the receiver but not under any
    //  nested scopes (i.e. 'bind:scope' or 'bind:repeat') that are also under
    //  the receiver.
    nextElems = boundElems.filter(
            function(anElem) {

                var bindIOValue,
                    bindInValue,
                    bindOutValue,

                    l;

                bindIOValue = anElem.getAttributeNS(TP.w3.Xmlns.BIND, 'io');
                bindInValue = anElem.getAttributeNS(TP.w3.Xmlns.BIND, 'in');
                bindOutValue = anElem.getAttributeNS(TP.w3.Xmlns.BIND, 'out');

                //  We don't want ourself in the list unless we have a value for
                //  'bind:io', 'bind:in' or 'bind:out'
                if (anElem === elem) {
                    if (TP.notEmpty(bindIOValue) ||
                        TP.notEmpty(bindInValue) ||
                        TP.notEmpty(bindOutValue)) {
                        return true;
                    }

                    return false;
                }

                if (elem.contains(anElem)) {
                    for (l = 0; l < subscopes.length; l++) {

                        //  If the subscope contains the element, then we will
                        //  normally return false to exclude it from the
                        //  'this-level' scopes that we're interested in. One
                        //  exception to this is if the binding value contains
                        //  'urn:' or '//:' which would indicate some sort of
                        //  absolute path.
                        if (subscopes[l].contains(anElem)) {

                            if (TP.notEmpty(bindIOValue) &&
                                (bindIOValue.contains('urn:') ||
                                    bindIOValue.contains('://'))) {
                                    return true;
                            }

                            if (TP.notEmpty(bindInValue) &&
                                (bindInValue.contains('urn:') ||
                                    bindInValue.contains('://'))) {
                                    return true;
                            }

                            if (TP.notEmpty(bindOutValue) &&
                                (bindOutValue.contains('urn:') ||
                                    bindOutValue.contains('://'))) {
                                    return true;
                            }

                            return false;
                        }
                    }

                    return true;
                }

                return false;
            });

    //  Compute a RegExp matcher that will match the 'primary location' (i.e.
    //  the rooted URI).

    //  Grab the primary location of the signal origin.
    primaryLoc = sigOrigin.getPrimaryLocation();

    //  Grab the 'original location' info records that were computed by the
    //  'bind:' namespace object when the content containing these binds was
    //  loaded.
    originalLocationInfos = this.getDocument().get('$originalLocationInfos');

    matcherEntries = TP.ac();

    //  Iterate over each location info record and build up a set of RegExp
    //  expressions that will match the primary binding expressions in the
    //  document. A location info record will be a pair that contains the
    //  originally authored location in the first position and the concrete /
    //  fully expanded URI in the last position.
    originalLocationInfos.forEach(
        function(infoPair) {

            var originalLocation,
                concreteLocation;

            //  Grab the concrete location and test it against the primary
            //  location obtained above. If they don't match, then we're not
            //  going to match here at all.
            concreteLocation = infoPair.last();
            if (concreteLocation !== primaryLoc) {
                return;
            }

            //  Grab the originally authored location. If it contains a
            //  fragment, then we reset it by slicing off the fragment.
            originalLocation = infoPair.first();
            if (originalLocation.indexOf('#') !== TP.NOT_FOUND) {
                originalLocation = originalLocation.slice(
                                    0,
                                    originalLocation.indexOf('#'));
            }

            //  If the two locations *don't* match, then we add a separate
            //  RegExp expression entry for the originally authored location.
            //  This allows us to match locations like relative and virtual
            //  URIs.
            if (originalLocation !== concreteLocation) {
                matcherEntries.push(TP.regExpEscape(originalLocation));
            }

            //  Add a RegExp expression entry for the concrete location.
            matcherEntries.push(TP.regExpEscape(concreteLocation));
        });

    //  Compute an 'alternating RegExp' that contains all of the computed
    //  matcher entries.
    primaryLocMatcher = TP.rc('(' + matcherEntries.join('|') + ')');

    //  If we have subscopes, filter out any non-roots (since we won't want
    //  nested subscopes appended here - each subscope root will find *all* of
    //  the bound nodes under itself, including those in a nested subscope).
    if (TP.notEmpty(subscopes)) {
        subscopes = TP.nodeListFilterNonRoots(
                        subscopes,
                        function(rootNode, testNode) {
                            var val;

                            //  If the root node we're testing contains the test
                            //  node, then check for fully qualified URIs.
                            if (rootNode.contains(testNode)) {

                                //  Grab the 'bind:scope' value - if it's a
                                //  fully qualified URI and it matches the
                                //  primary location, then we return false to
                                //  *not* filter it from the subscopes list.
                                val = testNode.getAttributeNS(
                                            TP.w3.Xmlns.BIND, 'scope');
                                if (TP.isURIString(val) &&
                                    primaryLocMatcher.test(val)) {
                                    return false;
                                }

                                //  Grab the 'bind:repeat' value - if it's a
                                //  fully qualified URI and it matches the
                                //  primary location, then we return false to
                                //  *not* filter it from the subscopes list.
                                val = testNode.getAttributeNS(
                                            TP.w3.Xmlns.BIND, 'repeat');
                                if (TP.isURIString(val) &&
                                    primaryLocMatcher.test(val)) {
                                    return false;
                                }

                                return true;
                            }

                            return false;
                        });
        nextElems = nextElems.concat(subscopes);
    }

    //  Iterate over all of those elements containing binding attributes and
    //  grab the attribute nodes that are in the TP.w3.Xmlns.BIND namespace.
    boundAttrNodes = TP.ac();
    for (i = 0; i < nextElems.length; i++) {
        attrs = nextElems[i].attributes;

        boundAttrCount = 0;
        for (j = 0; j < attrs.length; j++) {

            //  Make sure the attribute is in the binding namespace. This also
            //  accounts for the deficency of the querySelectorAll() call above.
            if (attrs[j].namespaceURI === TP.w3.Xmlns.BIND &&
                /^bind:(in|out|io|scope|repeat)$/.test(attrs[j].name)) {
                boundAttrNodes.push(attrs[j]);
                boundAttrCount++;
            }
        }

        //  Stamp the number of bound attributes onto the element. We will use
        //  this to track how many bound attributes a particular element still
        //  has left for processing (for performance reasons).
        nextElems[i][TP.BOUND_ATTR_COUNT] = boundAttrCount;
    }

    //  Sort the attribute nodes so that 'bind:in' attributes come first. This
    //  is important when an element has both 'bind:in' and 'bind:io'
    //  attributes, since we want the 'in' bindings to be refreshed first to
    //  have that data available to the 'io' bindings.
    boundAttrNodes.sort(
        function(a, b) {

            if (a.nodeName === 'bind:in' && b.nodeName !== 'bind:in') {
                return -1;
            } else if (a.nodeName !== 'bind:in' && b.nodeName === 'bind:in') {
                return 1;
            }

            return 0;
        });

    //  TIMING: var endQuery = Date.now();
    //  TIMING: TP.totalBranchQueryTime += (endQuery - startQuery);

    if (TP.isPlainObject(initialVal)) {
        theVal = TP.hc(initialVal);
    } else {
        theVal = initialVal;
    }

    if (TP.isEmpty(pathParts)) {

        //  Loop over all of the found binding attributes.
        len = boundAttrNodes.getSize();
        for (i = 0; i < len; i++) {

            boundAttr = boundAttrNodes.at(i);

            attrName = boundAttr.localName;
            attrVal = boundAttr.value;

            /* eslint-disable no-extra-parens */
            isScopingElement = (attrName === 'scope' || attrName === 'repeat');
            /* eslint-enable no-extra-parens */

            ownerElem = boundAttr.ownerElement;

            //  If the attribute value contains a URI scheme, but it's primary
            //  location doesn't match the primary location that changed and
            //  that we're refreshing from (which may happen because we're
            //  querying from the *document* down), then we need to check the
            //  binding expression further - we may just bail out.
            //  NB: The reason this can't be a simple check is that it will
            //  match 'data:', for instance, because 'data:' is a legal URN
            //  scheme... but sometimes binding aspects are also in a binding
            //  expression as 'data:'.
            if (TP.regex.ALL_SCHEMES.test(attrVal) &&
                !primaryLocMatcher.test(attrVal)) {

                //  Make a JSON-y string from the attribute value. If it can't
                //  be converted, then it's a shorthand. Assign it to 'value'
                //  and try again.
                bindStr = TP.reformatJSToJSON(attrVal, false);
                if (!TP.isJSONString(bindStr)) {
                    bindStr = '{"value":"' + attrVal + '"}';
                }

                //  Try to parse the entry string into a TP.core.Hash.
                bindEntries = TP.json2js(bindStr);
                bindKeys = bindEntries.getKeys();

                //  Iterate over each binding entry. We track each 'bail out'
                //  entry via this counter. If *all* of the entries are bail out
                //  entries, then we bail out.
                bailCount = 0;
                for (k = 0; k < bindKeys.getSize(); k++) {
                    bailEntry = bindEntries.at(bindKeys.at(k));
                    if (TP.regex.ALL_SCHEMES.test(bailEntry) &&
                        !primaryLocMatcher.test(bailEntry)) {
                        bailCount++;
                    }
                }

                //  The 'bail out' counter is the same as the number of keys -
                //  bail out.
                if (bailCount === bindKeys.getSize()) {
                    continue;
                }
            }

            ownerTPElem = TP.wrap(ownerElem);

            //  Are we processing a nested scope?

            if (isScopingElement) {

                if (attrVal === '[NaN]') {
                    theVal = null;
                }

                //  If our facet is 'value', then we obtain the branching value
                //  and path type, given the expression in the attribute value,
                //  the value as we've computed it so far and whatever path type
                //  we've been able to calculate.
                //  If the facet is not 'value', then we just use what is
                //  supplied.
                if (aFacet === 'value') {

                    //  If the attribute is a 'bind:repeat' and the path isn't a
                    //  simple numeric path, then collapse the value.
                    if (attrName === 'repeat' &&
                        !TP.regex.SIMPLE_NUMERIC_PATH.test(attrVal)) {
                        theVal = TP.collapse(theVal);
                    }

                    valueAndPath = this.$getBranchValueAndPathType(
                                                attrVal, theVal, aPathType);

                    branchVal = valueAndPath.at(0);
                    pathType = valueAndPath.at(1);
                } else {
                    branchVal = theVal;
                    pathType = aPathType;
                }

                if (attrName === 'repeat') {

                    if (!TP.isURIString(attrVal)) {
                        repeatScopeVals =
                            this.getBindingScopeValues().concat(attrVal);
                        repeatPath =
                            TP.uriJoinFragments.apply(TP, repeatScopeVals);
                        repeatFragExpr = TP.uc(repeatPath).getFragmentExpr();
                        TP.apc(repeatFragExpr).executeGet(primarySource);
                    }

                    //  Normalize the value for repeat purposes (we're
                    //  interested in an Array of key,value pairs).
                    branchVal = this.$normalizeRepeatValue(branchVal);

                    //  Make sure that branchVal is a collection.
                    if (TP.isCollection(branchVal)) {

                        //  NB: This modifies the supplied 'boundElems' Array to
                        //  add the newly generated elements. They will be
                        //  refreshed below.
                        //  If $regenerateRepeat returns false, then it didn't
                        //  regenerate any chunks and, therefore, we need to
                        //  manually update the repeat indexes.
                        updateRepeatIndexes = !ownerTPElem.$regenerateRepeat(
                                                        branchVal, boundElems);
                        if (updateRepeatIndexes) {
                            ownerTPElem.$updateRepeatRowIndices(branchVal);
                        }
                    }
                } else if (attrName === 'scope') {

                    //  If the owner element had both a 'bind:scope' and one of
                    //  the binding attributes on it, then we refresh the
                    //  element itself.
                    if (ownerTPElem.isBoundElement()) {
                        aspectNames = ownerTPElem.$computeMatchingAspects(
                                                        boundAttr.name,
                                                        attrVal,
                                                        primaryLocMatcher);
                        ownerTPElem.$refreshLeaf(
                            aFacet,
                            branchVal,
                            aspectNames,
                            boundAttr,
                            pathType,
                            changeSource,
                            null,
                            null);

                        //  Now, we must remove the ownerTPElem from the list of
                        //  bound elements, or we'll recurse endlessly.
                        /* eslint-disable no-loop-func */
                        boundElems = boundElems.filter(
                            function(anElem) {
                                return anElem !== ownerTPElem.getNativeNode();
                            });
                        /* eslint-enable no-loop-func */
                    }
                }

                ownerTPElem.$refreshBranches(
                                primarySource,
                                aFacet,
                                branchVal,
                                boundElems,
                                pathType,
                                null,
                                pathAction,
                                true,
                                sigOrigin,
                                originWasURI,
                                changeSource,
                                updateIndexes);
            } else {

                //  If we're not scoped (i.e. we're running top-level
                //  expressions) and the expression that we're processing
                //  doesn't contain ACP variables and the primary location
                //  matcher doesn't match the expression, then it's a top-level
                //  expression pointing at another data location - don't process
                //  them.
                if (!isScoped &&
                    !TP.regex.ACP_PATH_CONTAINS_VARIABLES.test(attrVal) &&
                    !primaryLocMatcher.test(attrVal)) {
                    continue;
                }

                //  Grab all of the names of the aspects referencing the changed
                //  location, as given by the primaryLocMatcher.
                aspectNames = ownerTPElem.$computeMatchingAspects(
                                                boundAttr.name,
                                                attrVal,
                                                primaryLocMatcher);

                repeatElem = TP.nodeDetectAncestor(
                            ownerElem,
                            function(aNode) {
                                var isRepeat;

                                isRepeat = TP.isElement(aNode) &&
                                            TP.elementHasAttribute(
                                                    aNode, 'bind:repeat', true);

                                return isRepeat;
                            });

                inRepeatContext = TP.isElement(repeatElem);

                repeatSource = null;
                repeatIndex = NaN;

                if (inRepeatContext) {
                    //  Grab the repeating information.
                    repeatInfo = this.$getRepeatSourceAndIndex(repeatElem);

                    if (TP.isValid(repeatInfo)) {
                        repeatSource = repeatInfo.first();
                        repeatIndex = repeatInfo.last();
                    }
                }

                //  Go ahead and process this as a leaf.
                ownerTPElem.$refreshLeaf(
                    aFacet,
                    theVal,
                    aspectNames,
                    boundAttr,
                    aPathType,
                    changeSource,
                    repeatSource,
                    repeatIndex);
            }
        }

    } else {

        searchParts = pathParts;

        partsNegativeSlice = 0;

        predicatePhaseOneComplete = false;

        //  Work in reverse order, trying to find the 'most specific' branching
        //  elements.
        while (TP.notEmpty(searchParts)) {

            didProcess = false;

            lastPart = searchParts.last();
            startPredIndex = lastPart.indexOf('[');

            //  Note that we don't allow statements such as '[0]' to qualify as
            //  predicates we want to process, hence looking for a '[' at a
            //  position greater than 0.
            hasPredicate = startPredIndex > 0;

            if (hasPredicate && predicatePhaseOneComplete) {
                endPredIndex = lastPart.lastIndexOf(']') + 1;
                predicateStmt = lastPart.slice(startPredIndex, endPredIndex);
                lastPart = lastPart.slice(0, startPredIndex);
                searchParts.atPut(searchParts.getSize() - 1, lastPart);
            } else {
                predicateStmt = null;
            }

            if (searchParts.getSize() > 1) {
                if (TP.isURIString(searchParts.first())) {
                    //  Has a full URL
                    searchPath = TP.uriJoinFragments.apply(TP, searchParts);
                } else if (searchParts.first().startsWith('#')) {
                    //  Starts with XPointer scheme
                    searchPath = TP.uriJoinFragments.apply(TP, searchParts);
                } else {
                    searchPath = TP.joinAccessPathParts(searchParts, aPathType);
                }
            } else {
                searchPath = searchParts.first();
            }

            //  If the search path contains a complete URL, then we build the
            //  branch matcher directly from that.
            if (TP.isURIString(searchPath) || searchPath.startsWith('#')) {
                branchMatcher = TP.rc(
                                '(^|:\\s*)' +
                                TP.regExpEscape(searchPath) +
                                '($|\\s*[,}])');
            } else {
                branchMatcher =
                    TP.rc(
                    '(^|:\\s*)' +
                    '((#[()a-zA-Z0-9]+)?' +
                    TP.regExpEscape(searchPath) +
                    '|.)' +
                    '($|\\s*[,}])');
            }

            //  If the search path is only one character and that character is
            //  '/' or '$', then we've reached the root of either an XPath or
            //  JSONPath. We don't update from whole roots, so empty the
            //  searchParts (so we don't endlessly recurse) and break out of the
            //  whole loop.
            if (searchPath === '/' || searchPath === '$') {
                searchParts.empty();
                break;
            }

            //  If there is only one search part, and it is a URI, then we've
            //  'trimmed back' to the most general part of the source URI. In
            //  that case, we only want to match 'leafs' that are looking at the
            //  'whole' URI, not all of the ones that have subparts that match.
            if (searchParts.getSize() === 1 && TP.isURIString(searchPath)) {
                leafMatcher = TP.rc(
                                '(^|:\\s*)' +
                                TP.regExpEscape(searchPath) +
                                '($|\\s*[,}])');
            } else {
                leafMatcher = TP.rc(TP.regExpEscape(searchPath));
            }

            processedElements = TP.ac();

            len = boundAttrNodes.getSize();
            for (j = 0; j < len; j++) {
                boundAttr = boundAttrNodes.at(j);

                attrName = boundAttr.localName;
                attrVal = boundAttr.value;

                ownerElem = boundAttr.ownerElement;

                //  Check to see if we've already processed this element. If
                //  there are more than one binding attributes on an element,
                //  we still don't want to process it more than once.
                if (processedElements.indexOf(ownerElem) !== TP.NOT_FOUND) {
                    if (ownerElem[TP.BOUND_ATTR_PROCESSED_COUNT] ===
                        ownerElem[TP.BOUND_ATTR_COUNT] - 1) {
                        continue;
                    }
                    ownerElem[TP.BOUND_ATTR_PROCESSED_COUNT]++;
                } else {
                    //  Keep track of already processed elements.
                    processedElements.push(ownerElem);
                    ownerElem[TP.BOUND_ATTR_PROCESSED_COUNT] = 0;
                }

                ownerTPElem = TP.wrap(ownerElem);

                isScopingElement =
                        attrName === 'scope' || attrName === 'repeat';

                if (isScopingElement && branchMatcher.test(attrVal)) {

                    //  If the scoping element has a '.' or '$_', then it wants
                    //  to scope to the data (probably a collection) that was
                    //  supplied to this method and is currently in theVal.
                    if (TP.regex.ONLY_PERIOD.test(attrVal) ||
                        TP.regex.ONLY_STDIN.test(attrVal)) {
                        return ownerTPElem.$refreshBranches(
                                primarySource,
                                aFacet,
                                theVal,
                                boundElems,
                                aPathType,
                                pathParts,
                                pathAction,
                                true,
                                sigOrigin,
                                originWasURI,
                                changeSource,
                                updateIndexes);
                    }

                    if (aFacet === 'value') {

                        if (TP.isURIString(attrVal)) {
                            branchURI = TP.uc(attrVal);
                            if (branchURI.hasFragment()) {
                                branchVal =
                                    branchURI.getResource().get('result');
                            } else {
                                branchVal = theVal;
                            }
                        } else {

                            if (TP.isValid(theVal)) {
                                if (TP.isArray(theVal) &&
                                    theVal.first() !== TP.NULL &&
                                    TP.isXMLNode(TP.unwrap(theVal.first()))) {
                                    theVal.unshift(TP.NULL);
                                }

                                if (TP.isXMLNode(theVal)) {

                                    branchVal =
                                        TP.wrap(theVal).get(TP.xpc(attrVal));
                                    pathType = TP.ifInvalid(
                                        aPathType, TP.XPATH_PATH_TYPE);

                                } else if (TP.isKindOf(theVal, TP.dom.Node)) {

                                    branchVal = theVal.get(TP.xpc(attrVal));
                                    pathType = TP.ifInvalid(aPathType,
                                                            TP.XPATH_PATH_TYPE);

                                } else if (
                                    TP.regex.JSON_POINTER.test(attrVal) ||
                                            TP.regex.JSON_PATH.test(attrVal)) {
                                    if (!TP.isKindOf(
                                            theVal, TP.core.JSONContent)) {
                                        theVal = TP.core.JSONContent.construct(
                                                                        theVal);
                                    }

                                    branchVal = this.$extractValue(
                                                theVal,
                                                attrVal,
                                                TP.jpc,
                                                TP.hc('shouldCollapse', false));

                                    pathType = TP.ifInvalid(aPathType,
                                                            TP.JSON_PATH_TYPE);
                                } else if (TP.isKindOf(
                                        theVal, TP.core.JSONContent) &&
                                        TP.regex.JS_IDENTIFIER.test(attrVal)) {
                                    attrVal = '$.' + attrVal;
                                    branchVal = theVal.get(attrVal);
                                    pathType = TP.JSON_PATH_TYPE;
                                } else {
                                    branchVal = theVal.get(attrVal);
                                    pathType = TP.ifInvalid(aPathType,
                                                            TP.TIBET_PATH_TYPE);
                                }
                            }
                        }
                    } else {
                        branchVal = initialVal;
                        pathType = TP.ifInvalid(aPathType, TP.TIBET_PATH_TYPE);
                    }

                    if (partsNegativeSlice === 0) {
                        remainderParts = TP.ac();
                    } else {
                        remainderParts = pathParts.slice(partsNegativeSlice);
                    }

                    pathType = TP.ifInvalid(pathType, aPathType);

                    if (hasPredicate && predicatePhaseOneComplete) {
                        remainderParts.unshift(predicateStmt);
                    }

                    needsRefresh = true;

                    insideRepeatScope =
                        TP.regex.SIMPLE_NUMERIC_PATH.test(attrVal) &&
                        TP.elementHasClass(ownerElem, 'item');

                    if ((attrName === 'repeat' || insideRepeatScope) &&
                        TP.isEmpty(remainderParts) &&
                        attrVal === searchPath) {

                        if (insideRepeatScope) {
                            ownerElem = TP.nodeDetectAncestor(
                                ownerElem,
                                function(aNode) {
                                    return TP.isElement(aNode) &&
                                            TP.elementHasAttribute(
                                                    aNode, 'bind:repeat', true);
                                });

                            ownerTPElem = TP.wrap(ownerElem);
                        }

                        switch (pathAction) {

                            case TP.CREATE:
                            case TP.INSERT:

                                if (TP.notEmpty(updateIndexes)) {
                                    newRowElem =
                                        ownerTPElem.$insertRepeatRowAt(
                                                                updateIndexes,
                                                                branchVal);
                                    ownerTPElem.$refreshBranches(
                                        primarySource,
                                        'value',
                                        branchVal,
                                        ownerTPElem.$getBoundElements(),
                                        null,
                                        null,
                                        null,
                                        false,
                                        sigOrigin,
                                        true,
                                        ownerTPElem,
                                        null);

                                } else {

                                    ownerTPElem.empty();

                                    //  NB: This modifies the supplied
                                    //  'boundElems' Array to add the newly
                                    //  generated elements. They will be
                                    //  refreshed below.
                                    updateRepeatIndexes =
                                        !ownerTPElem.$regenerateRepeat(
                                                    branchVal, boundElems);
                                    //  If $regenerateRepeat returns false, then
                                    //  it didn't regenerate any chunks and,
                                    //  therefore, we need to manually update
                                    //  the repeat indexes.
                                    if (updateRepeatIndexes) {
                                        ownerTPElem.$updateRepeatRowIndices(
                                                        branchVal);
                                    }
                                }

                                needsRefresh = false;

                                break;

                            case TP.DELETE:

                                if (TP.notEmpty(updateIndexes)) {
                                    ownerTPElem.$deleteRepeatRowAt(
                                                            updateIndexes);
                                } else {
                                    ownerTPElem.empty();
                                }

                                needsRefresh = false;

                                break;

                            default:
                                break;
                        }

                        allRefreshedElements =
                            ownerTPElem.getDocument().get('$refreshedElements');
                        if (TP.notEmpty(allRefreshedElements)) {
                            ownerTPElem.$sendNativeRefreshEvent();
                        }
                    }

                    didProcess = true;

                    if (needsRefresh) {
                        ownerTPElem.$refreshBranches(
                                primarySource,
                                aFacet,
                                branchVal,
                                boundElems,
                                pathType,
                                remainderParts,
                                pathAction,
                                true,
                                sigOrigin,
                                originWasURI,
                                changeSource,
                                updateIndexes);
                    } else {
                        break;
                    }

                } else if (!isScopingElement && leafMatcher.test(attrVal)) {

                    //  If there is pseudo-JSON content in the attribute, that
                    //  means that a) the user might not just be binding to the
                    //  'value' aspect and b) there might be more than 1 aspect
                    //  binding defined.
                    if (/\{/g.test(attrVal)) {
                        //  Grab all of the binding values by parsing the
                        //  attribute value and making it into a Hash.
                        attrInfo = TP.json2js(
                                    TP.reformatJSToJSON(attrVal, false));

                        //  Select only those UI aspects that match the
                        //  leafMatcher (and therefore have a reference to the
                        //  updating model aspect)
                        /* eslint-disable no-loop-func */
                        updatedUIAspects = attrInfo.getKeys().select(
                            function(aKey) {
                                return leafMatcher.test(attrInfo.at(aKey));
                            });
                        /* eslint-enable no-loop-func */
                    } else {
                        //  Otherwise, we can just say that the 'value' aspect
                        //  is being updated.
                        updatedUIAspects = TP.ac('value');
                    }

                    repeatElem = TP.nodeDetectAncestor(
                            ownerElem,
                            function(aNode) {
                                var isRepeat;

                                isRepeat = TP.isElement(aNode) &&
                                            TP.elementHasAttribute(
                                                    aNode, 'bind:repeat', true);

                                return isRepeat;
                            });

                    inRepeatContext = TP.isElement(repeatElem);

                    repeatSource = null;
                    repeatIndex = NaN;

                    if (inRepeatContext) {
                        //  Grab the repeating information.
                        repeatInfo = this.$getRepeatSourceAndIndex(repeatElem);

                        if (TP.isValid(repeatInfo)) {
                            repeatSource = repeatInfo.first();
                            repeatIndex = repeatInfo.last();
                        }
                    }

                    ownerTPElem.$refreshLeaf(
                        aFacet,
                        theVal,
                        updatedUIAspects,
                        boundAttr,
                        aPathType,
                        changeSource,
                        repeatSource,
                        repeatIndex);

                    didProcess = true;
                }
            }

            //  If we didn't process at least once, and the last part of the
            //  path is a simple numeric path, and there is a value at the end
            //  of that path, then we may have an insertion.
            if (!didProcess &&
                TP.regex.SIMPLE_NUMERIC_PATH.test(lastPart) &&
                TP.isDefined(branchVal = TP.wrap(theVal).get(lastPart)) &&
                (pathAction === TP.CREATE || pathAction === TP.INSERT)) {

                if (TP.notEmpty(updateIndexes)) {
                    newRowElem = this.$insertRepeatRowAt(updateIndexes,
                                                            branchVal);

                    TP.wrap(newRowElem).refreshBoundDescendants();
                } else {

                    ownerTPElem.empty();

                    //  NB: This modifies the supplied 'boundElems' Array to add
                    //  the newly generated elements. They will be refreshed
                    //  below.
                    updateRepeatIndexes = !ownerTPElem.$regenerateRepeat(
                                                        branchVal, boundElems);

                    //  If $regenerateRepeat returns false, then it didn't
                    //  regenerate any chunks and, therefore, we need to
                    //  manually update the repeat indexes.
                    if (updateRepeatIndexes) {
                        ownerTPElem.$updateRepeatRowIndices(branchVal);
                    }

                    TP.wrap(ownerTPElem).refreshBoundDescendants();
                }
            }

            if (hasPredicate && !predicatePhaseOneComplete) {
                predicatePhaseOneComplete = true;
            } else {
                predicatePhaseOneComplete = false;
                partsNegativeSlice--;
                searchParts = pathParts.slice(0, partsNegativeSlice);
            }
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$refreshLeaf',
function(aFacet, initialVal, updatedAspects, bindingAttr, aPathType, changeSource, repeatSource, repeatIndex) {

    /**
     * @method $refreshLeaf
     * @summary Refreshes any data bindings occurring as a 'leaf' (i.e. a
     *     scalar displayed value) under the receiver.
     * @param {String} [aFacet=value] The facet of the binding expressions that
     *     we're refreshing. This defaults to 'value' which is the 99% case.
     * @param {Object} initialVal The initial value to use to update the
     *     binding. This could be mutated inside of this method to a final,
     *     massaged, value.
     * @param {Array|TP.ALL} updatedAspects An Array of the aspects of the data
     *     model that are being updated or TP.ALL, to indicate that all of them
     *     are.
     * @param {AttributeNode} bindingAttr The attribute node containing the
     *     binding expression.
     * @param {Number} aPathType The path type that is contained in the
     *     binding expression.
     * @param {Object} changeSource The source of the change. If a signal
     *     initiated the refreshing process, this will be the signal's 'source'.
     * @param {Object} repeatSource The 'whole source' of the repeat, if the
     *     receiver is inside of a repeat context.
     * @param {Number} repeatIndex The index of the nearest scope within the
     *     nearest repeat if the receiver is inside of a repeat context.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var bindingInfo,

        didRefresh;

    //  Extract the binding information from the supplied binding information
    //  value String. This may have already been parsed and cached, in which
    //  case we get the cached values back.
    bindingInfo = this.getBindingInfoFrom(bindingAttr.name, bindingAttr.value);

    didRefresh = false;

    //  Iterate over each binding expression in the binding information.
    bindingInfo.perform(
        function(bindEntry) {

            var aspectName,
                bindVal,

                dataExprs,
                transformFunc,

                refreshedEntry;

            aspectName = bindEntry.first();
            bindVal = bindEntry.last();

            //  There will be 1...n data expressions here.
            dataExprs = bindVal.at('dataExprs');

            //  If a transformation function was computed from the expression,
            //  it will be here.
            transformFunc = bindVal.at('transformFunc');

            //  Set our final value for the current binding expresssion. This
            //  will return whether or not setting this value will have changed
            //  one or more of the values of the observers.
            refreshedEntry = this.$setFinalValue(
                                    aspectName,
                                    dataExprs,
                                    initialVal,
                                    updatedAspects,
                                    aFacet,
                                    transformFunc,
                                    aPathType,
                                    changeSource,
                                    repeatSource,
                                    repeatIndex);

            //  If at least one returned true, then flip the flag to true. Note
            //  that this is constructed such that, once the flag is flipped to
            //  true, it cannot be changed back.
            if (refreshedEntry) {
                didRefresh = refreshedEntry;
            }
        }.bind(this));

    return didRefresh;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$normalizeRepeatValue',
function(aRepeatValue) {

    /**
     * @method $normalizeRepeatValue
     * @summary Normalizes the supplied value into something that can be
     *     iterated over by a 'bind:repeat'. This is usually an Array.
     * @param {Object} aRepeatValue The value to normalize.
     * @returns {Object[]} An Array of objects that a bind:repeat can iterate
     *     over.
     */

    var repeatVal;

    repeatVal = aRepeatValue;

    //  If repeatVal is a POJO, make it into a TP.core.Hash.
    if (TP.isPlainObject(repeatVal)) {
        repeatVal = TP.hc(repeatVal);
    }

    //  Make sure that repeatVal is a collection.
    if (TP.isCollection(repeatVal)) {

        //  If repeatResult is a TP.core.Hash, then convert it
        //  into an Array of key/value pairs. Binding repeats
        //  need a collection they can index numerically.
        if (TP.isHash(repeatVal)) {
            repeatVal = repeatVal.getKVPairs();
        }

        //  If the repeatVal isn't an Array, then make it be the
        //  single item in an Array.
        if (!TP.isArray(repeatVal)) {
            repeatVal = TP.ac(repeatVal);
        }
    }

    return repeatVal;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$refreshRepeatData',
function(regenerateIfNecessary) {

    /**
     * @method $refreshRepeatData
     * @summary Refresh (and possibly regenerate) the data that is shown if the
     *     receiver contains a 'bind:repeat' attribute.
     * @param {Boolean} [regenerateIfNecessary=false] Whether or not to
     *     regenerate the UI chunks necessary to display the repeat. This is
     *     false by default because regeneration is performance intensive.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var scopeVals,

        lastExpr,
        sigilIndex,
        formatExpr,
        uriValueExpr,

        repeatFullExpr,

        repeatURI,
        repeatWholeURI,

        repeatWholeResult,
        repeatResult,

        repeatResultSize,

        regenerateFunc,

        allRefreshedElements,

        templatedAttrs,

        elem,
        tpDoc,

        isXMLResource,

        templatedElems,
        repeatIndex,
        repeatSize,

        groupingSize,
        repeatResultSlice,

        remainderTPElems,

        last,

        templateRefreshedElems,

        existingValueRefreshedElems,

        remainderAttrs;

    //  Grab our binding scoping values and compute a 'binding repeat'
    //  expression from them and any local value on us. Note here how we both
    //  ignore the cache and do *not* cache these values on the receiver.
    scopeVals = this.getBindingScopeValues(false, true, false);

    //  Grab the last of the scope values and see if it contains a formatting
    //  expression. If so, slice it off and copy & alter the scope values array
    //  to contain a last segment with no formatting expression. Retain the
    //  formatting expression for later use in this method.
    lastExpr = scopeVals.last();

    if (TP.regex.ACP_FORMAT.test(lastExpr)) {
        sigilIndex = lastExpr.indexOf('.%');

        formatExpr = lastExpr.slice(sigilIndex + 2).trim();
        uriValueExpr = lastExpr.slice(0, sigilIndex).trim();

        scopeVals = TP.copy(scopeVals);

        scopeVals.pop();
        scopeVals.push(uriValueExpr);
    }

    repeatFullExpr = TP.uriJoinFragments.apply(TP, scopeVals);

    //  Grab both the URI that is computed from our binding expression and it's
    //  'whole source' (i.e. the root collection that contains our bound data).
    repeatURI = TP.uc(repeatFullExpr);
    repeatWholeURI = repeatURI.getPrimaryURI();

    //  Grab the results of both URIs.

    //  NB: Note how we do *not* want the getResource() call to collapse
    //  it's results here - we always want a collection.
    repeatResult = repeatURI.getResource(
                    TP.request('shouldCollapse', false)).get('result');
    repeatWholeResult = repeatWholeURI.getResource(
                    TP.request('shouldCollapse', false)).get('result');

    if (TP.notValid(repeatResult)) {
        return this;
    }

    //  If we successfully extracted a formatting expression, use it here.
    if (TP.isValid(formatExpr)) {
        if (!TP.regex.SIMPLE_NUMERIC_PATH.test(repeatFullExpr)) {
            repeatResult = TP.collapse(repeatResult);
        }

        if (TP.isPlainObject(repeatResult)) {
            repeatResult = TP.hc(repeatResult);
        }

        repeatResult = TP.format(repeatResult, formatExpr);
    }

    //  Normalize the value for repeat purposes (we're interested in an Array of
    //  key,value pairs).
    repeatResult = this.$normalizeRepeatValue(repeatResult);
    repeatResultSize = repeatResult.getSize();

    regenerateFunc = function(shouldRegenerate) {
        var alreadySignaled,
            boundElems;

        //  Whether or not we signaled 'TP.sig.DidRenderData'.
        alreadySignaled = false;

        //  If this flag is true, then go ahead and regenerate (if necessary).
        //  Note how we pass any empty Array in here, since we're not adding or
        //  removing rows that need to be recursively processed at this time.
        if (TP.isTrue(shouldRegenerate)) {
            this.$regenerateRepeat(repeatResult, TP.ac());

            //  $regenerateRepeat signals 'TP.sig.DidRenderData'.
            alreadySignaled = true;
        }

        //  Grab any bound elements and refresh their values.

        boundElems = this.$getBoundElements();

        if (TP.notEmpty(boundElems)) {
            this.$refreshBranches(
                    repeatWholeResult,
                    'value',
                    repeatResult,
                    boundElems,
                    null,
                    null,
                    null,
                    false,
                    repeatWholeURI,
                    true,
                    this,
                    null);
        }

        //  If we haven't already signaled TP.sig.DidRenderData, do so now.
        if (!alreadySignaled) {
            this.signal('TP.sig.DidRenderData');
        }
    }.bind(this);

    //  Make sure that repeatResult is a collection.
    if (TP.isCollection(repeatResult)) {

        //  Grab the hash of refreshed elements. This will be updated by the
        //  binding machinery if there are bound elements to be refreshed.
        allRefreshedElements = this.getDocument().get('$refreshedElements');

        //  Call upon the regeneration function, which will regenerate the
        //  repeat (and update from bindings) if necessary.
        regenerateFunc(regenerateIfNecessary);

        //  If we didn't regenerate, then we need to see if we should update
        //  from templates.
        if (TP.notTrue(regenerateIfNecessary)) {

            isXMLResource = TP.isXMLNode(TP.unwrap(repeatResult.first()));

            //  Grab the repeat index. If one isn't available, we just use
            //  either 0 or 1, depending on whether we're dealing with an XML
            //  resource or not.
            repeatIndex = this.getAttribute('bind:repeatindex');
            if (!TP.isNumber(repeatIndex)) {
                if (isXMLResource) {
                    repeatIndex = 1;
                } else {
                    repeatIndex = 0;
                }
            }

            elem = this.getNativeNode();

            tpDoc = this.getDocument();

            //  Grab any templated elements and refresh their values.

            templatedElems =
                TP.byCSSPath('*[tibet|templateexpr]',
                                elem,
                                false,
                                true);

            if (TP.notEmpty(templatedElems)) {

                //  Grab the repeat size. If one isn't available, just use the
                //  whole size of the group.
                repeatSize = this.getAttribute('bind:repeatsize');
                if (!TP.isNumber(repeatSize)) {
                    repeatSize =
                        (repeatResultSize / templatedElems.getSize()).floor();
                }

                //  If the number of templated elements doesn't evenly divide
                //  into the repeatSize, then we need to regenerate the repeat.
                if (templatedElems.getSize() % repeatSize > 0) {
                    //  Call upon the regeneration function, which will
                    //  regenerate the repeat (and update from bindings) if
                    //  necessary.
                    regenerateFunc(true);

                    return this;
                }

                //  We have the total number of templated elements. We now need
                //  to compute how many are in each 'group' by dividing that
                //  into the size of the repeat result.
                groupingSize =
                    (templatedElems.getSize() / repeatSize).floor();

                groupingSize = groupingSize.max(1);

                //  Slice off the chunk of the repeat result that corresponds to
                //  the initial repeat index and size.
                repeatResultSlice = repeatResult.slice(
                                            repeatIndex,
                                            repeatIndex + repeatSize);

                //  Whatever is left over of the templated elements are ones
                //  that we need to set to blank.
                remainderTPElems = templatedElems.slice(
                                    groupingSize * repeatResultSlice.getSize());

                if (isXMLResource) {
                    last = repeatIndex + repeatSize;
                } else {
                    last = repeatIndex + repeatSize - 1;
                }

                //  Use this Array to keep track of the elements that we refresh
                //  using the templating machinery below.
                templateRefreshedElems = TP.ac();

                repeatResultSlice.forEach(
                    function(aData, scopeIndex) {
                        var startIndex,
                            endIndex,
                            firstTemplatedElem,
                            nearestScopeElem,
                            nearestScopeTPElem,
                            dataIndex,
                            i,
                            templatedElem,
                            info,
                            template,
                            val;

                        //  Set the starting index to the current scope index
                        //  times the number of elements in each group and the
                        //  end index to that plus the number of elements in
                        //  each group.
                        startIndex = scopeIndex * groupingSize;
                        endIndex = startIndex + groupingSize;

                        firstTemplatedElem =
                                templatedElems.at(startIndex).getNativeNode();

                        if (TP.elementHasAttribute(
                                    firstTemplatedElem, 'bind:scope', true)) {
                            nearestScopeElem = firstTemplatedElem;
                        } else {
                            //  Grab the nearest ancestor to the first templated
                            //  element in this group that has a scope.
                            nearestScopeElem =
                                TP.nodeDetectAncestorMatchingCSS(
                                    firstTemplatedElem,
                                    '*[bind|scope]',
                                    elem);
                        }

                        nearestScopeTPElem = TP.wrap(nearestScopeElem);

                        dataIndex = scopeIndex + repeatIndex;

                        for (i = startIndex; i < endIndex; i++) {

                            templatedElem = templatedElems.at(i);

                            if (isXMLResource) {
                                info = TP.hc(
                                        '$REQUEST', null,
                                        'TP', TP,
                                        'APP', APP,
                                        '$SOURCE', this,
                                        '$TAG', nearestScopeTPElem,
                                        '$TARGET', tpDoc,
                                        '$_', aData,
                                        '$INPUT', repeatResultSlice,
                                        '$INDEX', dataIndex,
                                        '$FIRST', dataIndex === 1,
                                        '$MIDDLE',
                                            dataIndex > 1 && dataIndex < last,
                                        '$LAST', dataIndex !== last,
                                        '$EVEN', dataIndex % 2 === 0,
                                        '$ODD', dataIndex % 2 !== 0,
                                        '$#', dataIndex);
                            } else {
                                info = TP.hc(
                                        '$REQUEST', null,
                                        'TP', TP,
                                        'APP', APP,
                                        '$SOURCE', this,
                                        '$TAG', nearestScopeTPElem,
                                        '$TARGET', tpDoc,
                                        '$_', aData,
                                        '$INPUT', repeatResultSlice,
                                        '$INDEX', dataIndex,
                                        '$FIRST', dataIndex === 0,
                                        '$MIDDLE',
                                            dataIndex > 0 && dataIndex < last,
                                        '$LAST', dataIndex !== last,
                                        '$EVEN', dataIndex % 2 === 0,
                                        '$ODD', dataIndex % 2 !== 0,
                                        '$#', dataIndex);
                            }

                            //  Grab the templating expression and wrap it in
                            //  ACP brackets. This allows the transform
                            //  machinery to treat it properly.
                            template = templatedElem.getAttribute(
                                                        'tibet:templateexpr');
                            template = '{{' + template + '}}';

                            //  Run the the transform machinery and use the
                            //  value it produces to set the 'value' of the
                            //  templated element.
                            val = template.transform(null, info);
                            templatedElems.at(i).set('value', val);

                            //  Add this to the list of elements that the
                            //  templating machinery refreshed.
                            templateRefreshedElems.push(
                                    templatedElem.getNativeNode());
                        }
                    }.bind(this));

                //  If there are remainder elements, they need to be set to
                //  blank and then added to the list of elements that the
                //  templating machinery refreshed.
                if (TP.notEmpty(remainderTPElems)) {
                    remainderTPElems.forEach(
                        function(aTPElem) {
                            aTPElem.setTextContent('');
                            templateRefreshedElems.push(
                                            aTPElem.getNativeNode());
                        });
                }

                //  If there were already refreshed elements because of the
                //  binding update machinery, just go into that hash under the
                //  'value__value' entry and add to it.
                if (TP.notEmpty(allRefreshedElements)) {
                    existingValueRefreshedElems =
                        allRefreshedElements.at('value__value');
                    existingValueRefreshedElems =
                        existingValueRefreshedElems.concat(
                                                    templateRefreshedElems);
                    allRefreshedElements.atPut(
                        'value__value', existingValueRefreshedElems);
                } else {
                    //  Otherwise, make a 'value__value' entry from the elements
                    //  that we refreshed from templates.
                    allRefreshedElements = TP.hc('value__value',
                                                    templateRefreshedElems);
                }
            }

            templatedAttrs =
                TP.byPath('.//*/@*' +
                    '[contains(., "' + TP.ACP_ENCODED_BEGIN + '") and ' +
                    'namespace-uri() != "' + TP.w3.Xmlns.BIND + '"]',
                            elem,
                            false,
                            false);

            if (TP.notEmpty(templatedAttrs)) {

                //  Grab the repeat size. If one isn't available, just use the
                //  whole size of the group.
                repeatSize = this.getAttribute('bind:repeatsize');
                if (!TP.isNumber(repeatSize)) {
                    repeatSize =
                        (repeatResultSize / templatedAttrs.getSize()).floor();
                }

                //  If the number of templated elements doesn't evenly divide
                //  into the repeatSize, then we need to regenerate the repeat.
                if (templatedAttrs.getSize() % repeatSize > 0) {
                    //  Call upon the regeneration function, which will
                    //  regenerate the repeat (and update from bindings) if
                    //  necessary.
                    regenerateFunc(true);

                    return this;
                }

                //  We have the total number of templated elements. We now need
                //  to compute how many are in each 'group' by dividing that
                //  into the size of the repeat result.
                groupingSize =
                    (templatedAttrs.getSize() / repeatSize).floor();

                groupingSize = groupingSize.max(1);

                //  Slice off the chunk of the repeat result that corresponds to
                //  the initial repeat index and size.
                repeatResultSlice = repeatResult.slice(
                                            repeatIndex,
                                            repeatIndex + repeatSize);

                //  Whatever is left over of the templated elements are ones
                //  that we need to set to blank.
                remainderAttrs = templatedAttrs.slice(
                                    groupingSize * repeatResultSlice.getSize());

                if (isXMLResource) {
                    last = repeatIndex + repeatSize;
                } else {
                    last = repeatIndex + repeatSize - 1;
                }

                //  Use this Array to keep track of the elements that we refresh
                //  using the templating machinery below.
                templateRefreshedElems = TP.ac();

                repeatResultSlice.forEach(
                    function(aData, scopeIndex) {
                        var startIndex,
                            endIndex,
                            ownerElem,
                            nearestScopeElem,
                            nearestScopeTPElem,
                            dataIndex,
                            i,
                            templatedAttr,
                            info,
                            jsonStr,
                            attrData;

                        //  Set the starting index to the current scope index
                        //  times the number of elements in each group and the
                        //  end index to that plus the number of elements in
                        //  each group.
                        startIndex = scopeIndex * groupingSize;
                        endIndex = startIndex + groupingSize;

                        ownerElem = templatedAttrs.at(startIndex).ownerElement;

                        if (TP.elementHasAttribute(
                                            ownerElem, 'bind:scope', true)) {
                            nearestScopeElem = ownerElem;
                        } else {
                            //  Grab the nearest ancestor to the first templated
                            //  element in this group that has a scope.
                            nearestScopeElem =
                                TP.nodeDetectAncestorMatchingCSS(
                                    templatedAttrs.at(startIndex).ownerElement,
                                    '*[bind|scope]',
                                    elem);
                        }

                        nearestScopeTPElem = TP.wrap(nearestScopeElem);

                        dataIndex = scopeIndex + repeatIndex;

                        for (i = startIndex; i < endIndex; i++) {

                            templatedAttr = templatedAttrs.at(i);

                            if (isXMLResource) {
                                info = TP.hc(
                                        '$REQUEST', null,
                                        'TP', TP,
                                        'APP', APP,
                                        '$SOURCE', this,
                                        '$TAG', nearestScopeTPElem,
                                        '$TARGET', tpDoc,
                                        '$_', aData,
                                        '$INPUT', repeatResultSlice,
                                        '$INDEX', dataIndex,
                                        '$FIRST', dataIndex === 1,
                                        '$MIDDLE',
                                            dataIndex > 1 && dataIndex < last,
                                        '$LAST', dataIndex !== last,
                                        '$EVEN', dataIndex % 2 === 0,
                                        '$ODD', dataIndex % 2 !== 0,
                                        '$#', dataIndex);
                            } else {
                                info = TP.hc(
                                        '$REQUEST', null,
                                        'TP', TP,
                                        'APP', APP,
                                        '$SOURCE', this,
                                        '$TAG', nearestScopeTPElem,
                                        '$TARGET', tpDoc,
                                        '$_', aData,
                                        '$INPUT', repeatResultSlice,
                                        '$INDEX', dataIndex,
                                        '$FIRST', dataIndex === 0,
                                        '$MIDDLE',
                                            dataIndex > 0 && dataIndex < last,
                                        '$LAST', dataIndex !== last,
                                        '$EVEN', dataIndex % 2 === 0,
                                        '$ODD', dataIndex % 2 !== 0,
                                        '$#', dataIndex);
                            }

                            jsonStr = TP.reformatJSToJSON(
                                        templatedAttr.nodeValue, false);

                            attrData = TP.json2js(jsonStr);

                            /* eslint-disable no-loop-func */
                            attrData.perform(
                                function(kvPair) {
                                    var attrName,
                                        attrVal,

                                        val;

                                    attrName = kvPair.first();
                                    attrVal = kvPair.last();

                                    attrVal = attrVal.unquoted('"');

                                    attrVal = attrVal.replace(
                                                TP.regex.ACP_ENCODED_BEGIN,
                                                TP.ACP_BEGIN);
                                    attrVal = attrVal.replace(
                                                TP.regex.ACP_ENCODED_END,
                                                TP.ACP_END);

                                    val = attrVal.transform(null, info);

                                    TP.elementSetAttribute(ownerElem,
                                                            attrName,
                                                            val,
                                                            true);
                                });
                            /* eslint-enable no-loop-func */

                            //  Add this to the list of elements that the
                            //  templating machinery refreshed.
                            templateRefreshedElems.push(
                                    templatedAttr.ownerElement);
                        }
                    }.bind(this));

                //  If there are remainder elements, they need to be set to
                //  blank and then added to the list of elements that the
                //  templating machinery refreshed.
                if (TP.notEmpty(remainderAttrs)) {
                    remainderAttrs.forEach(
                        function(anAttr) {
                            var jsonStr,
                                attrData;

                            jsonStr = TP.reformatJSToJSON(anAttr.nodeValue, false);

                            attrData = TP.json2js(jsonStr);

                            attrData.perform(
                                function(kvPair) {
                                    var attrName;

                                    attrName = kvPair.first();

                                    TP.elementRemoveAttribute(
                                                anAttr.ownerElement,
                                                attrName,
                                                true);
                                });

                            templateRefreshedElems.push(
                                            anAttr.ownerElement);
                        });
                }

                //  If there were already refreshed elements because of the
                //  binding update machinery, just go into that hash under the
                //  'value__value' entry and add to it.
                if (TP.notEmpty(allRefreshedElements)) {
                    existingValueRefreshedElems =
                        allRefreshedElements.at('value__value');
                    existingValueRefreshedElems =
                        existingValueRefreshedElems.concat(
                                                    templateRefreshedElems);
                    allRefreshedElements.atPut(
                        'value__value', existingValueRefreshedElems);
                } else {
                    //  Otherwise, make a 'value__value' entry from the elements
                    //  that we refreshed from templates.
                    allRefreshedElements = TP.hc('value__value',
                                                    templateRefreshedElems);
                }
            }
        }

        //  Send a custom DOM-level event to allow 3rd party libraries to know
        //  that the bindings have been refreshed.
        if (TP.notEmpty(allRefreshedElements)) {
            this.$sendNativeRefreshEvent();
        }

        this.signal('TP.sig.DidRenderData');
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$regenerateRepeat',
function(aCollection, elems) {

    /**
     * @method $regenerateRepeat
     * @summary Regenerates any repeat content under the receiver, if the
     *     receiver is configured to have 'repeating content'.
     * @param {Object} aCollection The collection data model that will be used
     *     for the repeating content. Note that this method merely generates the
     *     blank repeating rows - it is up to other methods to refresh the data
     *     bindings within them.
     * @param {Element[]} elems The list of elements that the bind engine is
     *     currently processing, of which is this an element. We will splice any
     *     new content that this method generates into this collection so that
     *     the engine will recursively process into this new content.
     * @returns {Boolean} Whether or not new items were actually generated.
     */

    var repeatContent,

        resourceLength,

        elem,
        allRepeatChunks,

        existingChunkCount,

        repeatSize,
        endIndex,

        doc,

        bodyFragment,

        isXMLResource,

        str,
        last,
        info,
        result,

        startIndex,

        tpDoc,

        scopeIndex,

        i,

        newElement,
        newTPElem,

        newElems,
        elemIndex,
        args,

        overflow,
        remainderSize,
        remainderTextNodes,

        descendants,

        evt;

    if (TP.notValid(aCollection)) {
        //  TODO: Raise an exception
        return false;
    }

    if (TP.notValid(repeatContent = this.$getRepeatTemplate())) {
        //  TODO: Raise an exception
        return false;
    }

    resourceLength = aCollection.getSize();

    elem = this.getNativeNode();

    //  Find all of the existing *direct children* bound rows under us that have
    //  a 'bind:scope' that starts with a '[' and ends with a ']'.
    allRepeatChunks = TP.byCSSPath(
                        '> *[bind|scope^="["][bind|scope$="]"]',
                        elem,
                        false,
                        false);

    existingChunkCount = allRepeatChunks.getSize();

    //  If we have a 'bind:repeatindex', then we can compute a starting index
    //  from it.
    if (this.hasAttribute('bind:repeatindex')) {
        if (!TP.isNumber(startIndex =
                            this.getAttribute('bind:repeatindex').asNumber())) {
            startIndex = 0;
        }
    } else {
        startIndex = 0;
    }

    //  If we have a 'bind:repeatsize', then we can compute how many rows we
    //  should be displaying.
    if (this.hasAttribute('bind:repeatsize')) {

        //  If we have a 'bind:repeatsize', then we can compute an ending index
        //  from that and the startIndex
        if (TP.isNumber(repeatSize =
                        this.getAttribute('bind:repeatsize').asNumber())) {
            endIndex = startIndex + repeatSize;
        } else {
            endIndex = resourceLength - startIndex;
        }
    } else {
        endIndex = resourceLength;
    }

    //  If the repeat content's child element list has a size of 1, then we
    //  reach under there and use that element as the repeat content
    if (TP.nodeGetChildElements(repeatContent).getSize() === 1) {
        repeatContent = repeatContent.firstElementChild;
    }

    //  Get the String representation of the repeat content. We'll use this
    //  later to check for ACP expressions.
    str = TP.str(repeatContent);

    //  Use either the resource length or the paging size, whichever is smaller.
    endIndex = endIndex.min(resourceLength);

    //  If we have already generated chunks and the count of those generated
    //  items is the same as the chunks we're going to produce, then we don't
    //  need to regenerate so we can just exit here.
    if (existingChunkCount === endIndex - startIndex &&
        !TP.regex.HAS_ACP.test(str)) {

        //  Clear any repeat source or repeat index on any descendant elements.
        //  Just because we're reusing the chunk doesn't mean that we're using
        //  the same data source (or want whatever the index was set to last).
        TP.nodeGetDescendantElements(elem).forEach(
            function(anElem) {
                anElem[TP.REPEAT_SOURCE] = null;
                anElem[TP.REPEAT_INDEX] = null;
            });

        return false;
    }

    tpDoc = this.getDocument();
    doc = tpDoc.getNativeNode();

    bodyFragment = doc.createDocumentFragment();

    //  Detect whether we're drawing GUI for model which is a chunk of XML data
    //  - we'll use this information later.
    isXMLResource = TP.isXMLNode(TP.unwrap(aCollection.first()));

    for (i = startIndex; i < endIndex; i++) {

        //  Make sure to clone the content.
        newElement = TP.nodeCloneNode(repeatContent);
        newTPElem = TP.wrap(newElement);

        //  If this is an XML resource, then we need to increment by 1
        //  because XPath is 1-based.
        if (isXMLResource) {
            scopeIndex = i + 1;
        } else {
            scopeIndex = i;
        }

        if (TP.regex.HAS_ACP.test(str)) {
            if (isXMLResource) {

                last = aCollection.getSize();

                info = TP.hc(
                        '$REQUEST', null,
                        'TP', TP,
                        'APP', APP,
                        '$SOURCE', this,
                        '$TAG', newTPElem,
                        '$TARGET', tpDoc,
                        '$_', aCollection.at(scopeIndex),
                        '$INPUT', aCollection,
                        '$INDEX', scopeIndex,
                        '$FIRST', scopeIndex === 1,
                        '$MIDDLE', scopeIndex > 1 && scopeIndex < last,
                        '$LAST', scopeIndex !== last,
                        '$EVEN', scopeIndex % 2 === 0,
                        '$ODD', scopeIndex % 2 !== 0,
                        '$#', scopeIndex);
            } else {

                last = aCollection.getSize() - 1;

                info = TP.hc(
                        '$REQUEST', null,
                        'TP', TP,
                        'APP', APP,
                        '$SOURCE', this,
                        '$TAG', newTPElem,
                        '$TARGET', tpDoc,
                        '$_', aCollection.at(scopeIndex),
                        '$INPUT', aCollection,
                        '$INDEX', scopeIndex,
                        '$FIRST', scopeIndex === 0,
                        '$MIDDLE', scopeIndex > 0 && scopeIndex < last,
                        '$LAST', scopeIndex !== last,
                        '$EVEN', scopeIndex % 2 === 0,
                        '$ODD', scopeIndex % 2 !== 0,
                        '$#', scopeIndex);
            }

            result = str.transform(null, info);
            newElement = TP.elem(result);
        }

        //  Stamp a 'bind:scope' with an attribute containing the numeric
        //  scoping index (i.e. '[2]'). This will be used in bind scoping
        //  computations.
        TP.elementSetAttribute(newElement,
                                'bind:scope',
                                '[' + scopeIndex + ']',
                                true);

        //  Cache the repeating source and index on the element for much better
        //  bind:repeat performance
        newElement[TP.REPEAT_SOURCE] = aCollection;
        newElement[TP.REPEAT_INDEX] = scopeIndex;

        //  Append this new chunk of markup to the document fragment we're
        //  building up and then loop to the top to do it again.
        bodyFragment.appendChild(newElement);
    }

    //  If we have a real repeatSize, then see if there are remainder (i.e.
    //  blank) rows that need to be generated.
    if (TP.isNumber(repeatSize)) {

        overflow = endIndex % repeatSize;

        if (overflow > 0) {

            remainderSize = repeatSize - overflow;

            //  Iterate over the number of remaining rows, clone the content and
            //  blank all of the Text node (but only if they contain
            //  non-whitespace content).
            for (i = 0; i < remainderSize; i++) {

                //  Make sure to clone the content.
                newElement = TP.nodeCloneNode(repeatContent);

                remainderTextNodes = TP.elementGetTextNodesMatching(
                                        newElement, TP.RETURN_TRUE);
                remainderTextNodes.forEach(
                    function(aTextNode) {
                        if (!TP.regex.ONLY_WHITESPACE.test(
                                            aTextNode.nodeValue)) {
                            TP.nodeSetTextContent(aTextNode, '');
                        }
                    });

                //  If this is an XML resource, then we need to increment
                //  by 1 because XPath is 1-based.
                if (isXMLResource) {
                    scopeIndex = endIndex + i + 1;
                } else {
                    scopeIndex = endIndex + i;
                }

                //  Stamp a 'bind:scope' with an attribute containing the
                //  numeric scoping index (i.e. '[2]'). This will be used in
                //  bind scoping computations.
                TP.elementSetAttribute(newElement,
                                        'bind:scope',
                                        '[' + scopeIndex + ']',
                                        true);

                //  Cache the repeating source and index on the element for much
                //  better bind:repeat performance
                newElement[TP.REPEAT_SOURCE] = aCollection;
                newElement[TP.REPEAT_INDEX] = scopeIndex;

                //  Append this new chunk of markup to the document fragment
                //  we're building up and then loop to the top to do it again.
                bodyFragment.appendChild(newElement);
            }
        }
    }

    //  Put an attribute on ourself that will prevent Mutation signals from
    //  being sent from content under us. This also marks us as the 'repeating
    //  body' (i.e. the element containing the repeating content).
    TP.elementSetAttribute(elem, 'tibet:no-mutations', true, true);

    //  Grab all of the descendants under ourself.
    descendants = TP.nodeGetDescendants(elem);

    //  Make sure to empty the repeat element of any existing content. Note that
    //  we do this *before* sending the event in order to be consistent with
    //  when this event is sent from the MutationObserver machinery.
    TP.nodeEmptyContent(elem);

    //  Send a custom DOM-level event to allow 3rd party libraries to know that
    //  content has been removed.

    evt = doc.createEvent('Event');
    evt.initEvent('TIBETContentRemoved', true, true);
    evt.data = descendants;

    elem.dispatchEvent(evt);

    //  Finally, append the whole fragment under the receiver element
    TP.nodeAppendChild(elem, bodyFragment, false);

    //  Awaken any content that has been inserted under this element. We have to
    //  do this manually, since we turned off mutation tracking for this element
    //  above.
    TP.nodeAwakenContent(elem);

    //  Bubble any xmlns attributes that are found on descendants upward to
    //  avoid markup clutter.
    TP.elementBubbleXMLNSAttributesOnDescendants(elem);

    //  Grab any bound elements under this element. We will need to splice them
    //  into the list of elements that the engine is processing, of which we are
    //  one. This ensures that any nested binding constructs (i.e. nested
    //  repeats, for instance) are recursively processed.
    newElems = this.$getBoundElements(false);

    //  Splice the new elements just after our spot in the list of elements that
    //  the engine is currently processing.
    elemIndex = elems.indexOf(elem);
    args = TP.ac(elemIndex + 1, 0).concat(newElems);
    Array.prototype.splice.apply(elems, args);

    //  Send a custom DOM-level event to allow 3rd party libraries to know that
    //  content has been added.

    //  Grab all of the descendants under ourself.
    descendants = TP.nodeGetDescendants(elem);

    evt = doc.createEvent('Event');
    evt.initEvent('TIBETContentAdded', true, true);
    evt.data = descendants;

    elem.dispatchEvent(evt);

    this.signal('TP.sig.DidRenderData');

    return true;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$registerRepeatContent',
function() {

    /**
     * @method $registerRepeatContent
     * @summary Registers the content under the receiver as repeat content with
     *     the receiver's TP.dom.Document for iteration purposes.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var elem,
        doc,

        nestedRepeatElems,
        nestedRepeatTPElems,

        i,

        repeatContent,

        elemsWithIDs,
        len,
        j,
        elemWithID,

        attrVal,

        repeatItems,

        templateID,
        templateInfo;

    elem = this.getNativeNode();

    //  If this attribute is present, then we've already register - just bail
    //  out.
    if (TP.elementHasAttribute(elem, 'tibet:templateid', true)) {
        return this;
    }

    doc = TP.nodeGetDocument(elem);

    //  Cause any repeats that haven't registered their content to grab it
    //  before we start other processing.
    //  To do this, we need any repeats that are under us (but only the ones
    //  under us, which is we need to use the filter here).
    nestedRepeatElems =
            TP.ac(doc.documentElement.querySelectorAll('*[*|repeat]'));
    nestedRepeatElems = nestedRepeatElems.filter(
                    function(anElem) {
                        return elem !== anElem && elem.contains(anElem);
                    });

    //  To avoid mutation events as register the repeat content will cause DOM
    //  modifications, we wrap all of the found 'bind:repeat' Elements at once
    //  here.
    nestedRepeatTPElems = TP.wrap(nestedRepeatElems);

    for (i = 0; i < nestedRepeatTPElems.getSize(); i++) {
        nestedRepeatTPElems.at(i).$registerRepeatContent();
    }

    //  Append a 'wrap element' as the container of the repeat content. This is
    //  especially useful if the repeat content has no root element itself and
    //  therefore we would end up with 1...n sibling nodes, which are harder to
    //  manage.
    repeatContent = TP.documentConstructElement(this.getNativeDocument(),
                                                'span',
                                                TP.w3.Xmlns.XHTML);

    //  Add a class of 'item' for easier managability.
    TP.elementAddClass(repeatContent, 'item');

    //  Strip out all 'id's on elements... if an Element has an ID, warn here.
    elemsWithIDs = TP.byCSSPath(' *[id]', elem, false, false);

    //  Loop over any elements that were found with IDs.
    len = elemsWithIDs.getSize();
    for (j = 0; j < len; j++) {

        elemWithID = elemsWithIDs.at(j);

        attrVal = TP.elementGetAttribute(elemWithID, 'id', true);

        //  If the attribute value contains ACP expressions, then we need to
        //  leave it alone.
        if (TP.regex.HAS_ACP.test(attrVal)) {
            continue;
        }

        if (!TP.elementHasGeneratedID(elemWithID)) {
            TP.ifWarn() ?
                TP.warn('Stripping ID from Element in repeat template: ' +
                        TP.str(elemWithID) + '. ' +
                        'IDs are supposed to be unique in markup.') : 0;
        }

        TP.elementRemoveAttribute(elemWithID, 'id', true);
    }

    //  Grab the childNodes of the receiver as a DocumentFragment.
    //  NOTE: This *removes* these child nodes from the receiver.
    repeatItems = TP.nodeListAsFragment(elem.childNodes);

    //  Append that DocumentFragment into our repeat content container.
    TP.nodeAppendChild(repeatContent, repeatItems, false);

    //  Generate a unique ID for our repeat content. We'll use this to register
    //  the repeat content with our TP.dom.DocumentNode.
    templateID = TP.genID('bind_repeat_template');

    //  Create a registry on our TP.dom.DocumentNode for repeat content if it's
    //  not already there.
    if (TP.notValid(
            templateInfo = this.getDocument().get('$repeatTemplates'))) {
        templateInfo = TP.hc();
        this.getDocument().set('$repeatTemplates', templateInfo);
    }

    //  Register our repeat content under the unique ID we generated.
    templateInfo.atPut(templateID, repeatContent);
    TP.elementSetAttribute(elem, 'tibet:templateid', templateID, true);

    return repeatContent;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$sendNativeRefreshEvent',
function() {

    /**
     * @method $sendNativeRefreshEvent
     * @summary Sends a native custom browser event ('TIBETBindingsRefreshed')
     *     with the elements that have been refreshed by the binding system
     *     This allow third party libraries to know when data changes have been
     *     in the TIBET system.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var allRefreshedElements,

        allContainedElements,

        notContainedElementInfo,

        evt;

    //  Send a custom DOM-level event to allow 3rd party libraries to know that
    //  the bindings have been refreshed.

    allRefreshedElements = this.getDocument().get('$refreshedElements');
    if (TP.notEmpty(allRefreshedElements)) {

        //  Allocate an Array for elements that *are* contained in the receiver.
        //  We will use this Array to send the signal.
        allContainedElements = TP.ac();

        //  Build out a Hash for elements that are *not* contained in the
        //  receiver. We'll preserve the Hash of the elements that are *not*
        //  contained within the receiver and set 'allRefreshedElements' to
        //  that.
        notContainedElementInfo = TP.hc();

        allRefreshedElements.perform(
            function(kvPair) {
                var containedElems,
                    notContainedElems,

                    aspectKey,
                    elems,

                    len,
                    i,

                    elem;

                containedElems = TP.ac();
                notContainedElems = TP.ac();

                aspectKey = kvPair.first();
                elems = kvPair.last();

                //  Iterate over all of the elements and sort them into two
                //  Arrays, one for elements contained in the receiver and one
                //  for elements that are not.
                len = elems.getSize();
                for (i = 0; i < len; i++) {
                    elem = elems.at(i);
                    if (this.contains(elem, TP.IDENTITY)) {
                        containedElems.push(elem);
                        elem[TP.BOUND_ATTR_PROCESSED_COUNT] = 0;
                    } else {
                        notContainedElems.push(elem);
                    }
                }

                //  If there are elements that are contained in the receiver,
                //  concatenate them into the overall Array that we will use to
                //  send the signal.
                if (TP.notEmpty(containedElems)) {
                    allContainedElements =
                            allContainedElements.concat(containedElems);
                }

                //  If there are elements that are *not* contained in the
                //  receiver, add an entry to the Hash under the aspect key.
                //  This is the Hash that we'll preserve for other runs of this
                //  method.
                if (TP.notEmpty(notContainedElems)) {
                    notContainedElementInfo.atPut(aspectKey, notContainedElems);
                }
            }.bind(this));

        //  If we have contained elements, then send the signal.
        if (TP.notEmpty(allContainedElements)) {
            allContainedElements.unique();

            evt = this.getNativeDocument().createEvent('Event');
            evt.initEvent('TIBETBindingsRefreshed', true, true);

            evt.data = allContainedElements;

            this.getNativeNode().dispatchEvent(evt);
        }

        this.getDocument().set('$refreshedElements', notContainedElementInfo);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('setAttrBindRepeatindex',
function(index) {

    /**
     * @method setAttrBindRepeatindex
     * @summary Sets the repeat index that the receiver will use to start
     *     repeating from.
     * @param {Number} index The index to start repeating from.
     */

    //  NB: We pass true here to signal change in case anything in the GUI is
    //  watching this attribute.
    this.$setAttribute('bind:repeatindex', index, true);

    this.$updateRepeatRowIndices();

    //  Refresh the repeating data under us, passing false to *not* regenerate
    //  repeat chunks. We're merely changing the index here - that will not be
    //  required.
    this.$refreshRepeatData(false);

    //  setting an attribute returns void according to the spec
    return;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('setAttrBindRepeatsize',
function(size) {

    /**
     * @method setAttrBindRepeatsize
     * @summary Sets the repeat size that the receiver will use to display
     *     'pages' of repeating data.
     * @param {Number} size The size of the data 'page'.
     */

    //  NB: We pass true here to signal change in case anything in the GUI is
    //  watching this attribute.
    this.$setAttribute('bind:repeatsize', size, true);

    //  Refresh the repeating data under us, passing true to regenerate any new
    //  repeat chunks that may be required.
    this.$refreshRepeatData(true);

    //  setting an attribute returns void according to the spec
    return;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('setBoundAspect',
function(attributeName, anAspect, aValue, scopeVals, bindingInfoValue,
ignoreBidiInfo) {

    /**
     * @method setBoundAspect
     * @summary Sets the bound aspect of the receiver to the supplied value.
     *     This takes the supplied aspect and value and sets that value onto the
     *     model under that aspect.
     * @param {String} attributeName The name of the attribute to find the
     *     binding information that we're setting.
     * @param {String} anAspect The aspect of model that we're going to set
     * @param {Object} aValue The value to set onto the model.
     * @param {String[]} scopeVals The list of scoping values (i.e. parts that,
     *     when combined, make up the entire bind scoping path).
     * @param {String} bindingInfoValue A String, usually in a JSON-like format,
     *     that details the binding information for the receiver. That is, the
     *     bounds aspects of the receiver and what they're bound to.
     * @param {Boolean} [ignoreBidiInfo=false] Whether or not to ignore the
     *     receiver's bidirectional attribute information. If this parameter is
     *     true, this method will always set the bound value whether or not the
     *     bound attribute is considered to be both a getter and setter.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var bindingInfo,
        bidiAttrs;

    //  Extract the binding information from the supplied binding information
    //  value String. This may have already been parsed and cached, in which
    //  case we get the cached values back.
    bindingInfo = this.getBindingInfoFrom(attributeName, bindingInfoValue);

    if (TP.notTrue(ignoreBidiInfo)) {
        //  Grab the list of our 'bidirectional' instance (not DOM) attributes.
        //  This will tell us which aspects can be 'set' from GUI to model.
        bidiAttrs = this.getType().get('bidiAttrs');

        //  Make sure that the receiver is configured with bidi instance
        //  attributes. If there are none, that means that we have no GUI to
        //  model capable aspects, so warn and exit here.
        if (TP.isEmpty(bidiAttrs)) {
            TP.ifWarn() ?
                TP.warn('No bidi attrs defined for bound control: ' +
                        TP.name(this) + '.') : 0;

            return this;
        }
    }

    //  Iterate over each binding expression in the binding information.
    bindingInfo.perform(
        function(bindEntry) {

            var boundAspect,

                bindVal,

                dataExprs,
                i,
                dataExpr,

                allVals,
                fullExpr,

                wholeURI,
                primaryURI,

                frag,

                result,
                newValue;

            boundAspect = bindEntry.first();

            //  If the bound aspect that we're processing doesn't match the
            //  aspect name that was supplied to this method, then we skip it.
            if (boundAspect !== anAspect) {
                return;
            }

            //  If the attribute isn't one of the bidi attributes, then we can
            //  just exit here (i.e. its not an attribute that we can 'set' from
            //  the UI)
            if (TP.notTrue(ignoreBidiInfo) &&
                !bidiAttrs.contains(boundAspect)) {
                return;
            }

            bindVal = bindEntry.last();

            //  There will be 1...n data expressions here. Iterate over them and
            //  compute a model reference.
            dataExprs = bindVal.at('dataExprs');
            for (i = 0; i < dataExprs.getSize(); i++) {
                dataExpr = TP.trim(dataExprs.at(i));

                if (TP.isEmpty(dataExpr)) {
                    continue;
                }

                if (TP.notEmpty(scopeVals)) {
                    //  Concatenate the binding value onto the scope values
                    //  array (thereby creating a new Array) and use it to
                    //  join all of the values together.
                    allVals = scopeVals.concat(dataExpr);
                    fullExpr = TP.uriJoinFragments.apply(TP, allVals);

                    //  If we weren't able to compute a real URI from the
                    //  fully expanded URI value, then raise an exception
                    //  and return here.
                    if (!TP.isURIString(fullExpr)) {
                        this.raise('TP.sig.InvalidURI');

                        break;
                    }

                    wholeURI = TP.uc(fullExpr);
                } else {
                    //  Scope values is empty - this is (hopefully) a fully
                    //  qualified binding expression.

                    //  If we weren't able to compute a real URI from the
                    //  fully expanded URI value, then raise an exception
                    //  and return here.
                    dataExpr = TP.trim(dataExpr);
                    if (!TP.isURIString(dataExpr) &&
                            !TP.regex.URI_FRAGMENT.test(dataExpr)) {
                        this.raise('TP.sig.InvalidURI');
                        break;
                    }

                    wholeURI = TP.uc(dataExpr);
                }

                if (!TP.isURI(wholeURI)) {
                    this.raise('TP.sig.InvalidURI');

                    break;
                }

                primaryURI = wholeURI.getPrimaryURI();
                frag = wholeURI.getFragment();

                //  Grab the result from the 'primary URI'. If the value can't
                //  be retrieved, then create a TP.lang.ValueHolder object and
                //  set it's 'value' value to the value that we're trying to
                //  set. Then set that as the 'whole resource' of the primary
                //  URI.
                if (TP.notValid(
                        result = primaryURI.getResource().get('result'))) {

                    newValue = TP.lang.ValueHolder.construct(aValue);

                    //  NB: This will mark the primaryURI as dirty.
                    primaryURI.setResource(
                        newValue, TP.hc('observeResource', true,
                                        'signalChange', true));
                } else {

                    //  Since we have a reference to the portion of the data
                    //  referenced by primaryURI, we have to manually mark it as
                    //  dirty here (and send a notification).
                    primaryURI.isDirty(true, true);

                    //  If no fragment could be computed, then we set the 'whole
                    //  value'.
                    if (TP.isEmpty(frag)) {
                        result.set('value', aValue);
                    } else {
                        //  If we got a Window wrapper as the result from the
                        //  primary URI, then we're a 'direct to GUI' binding.
                        //  Use the *whole* URI to get a reference to the
                        //  (wrapped) element and set its value.
                        if (TP.isKindOf(result, TP.core.Window)) {
                            result = wholeURI.getResource().get('result');
                            result.set('value', aValue);
                        } else {
                            result.set(TP.apc(frag), aValue);
                        }
                    }
                }
            }
        }.bind(this));

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('setBoundValueIfBound',
function(aValue, ignoreBidiInfo) {

    /**
     * @method setBoundValueIfBound
     * @summary Sets the bound value of the receiver to the supplied value if
     *     the receiver is bound. This takes the supplied value and sets that
     *     value onto the model.
     * @description This method is a convenience wrapper for setBoundAspect
     *     that assumes an aspect of 'value' and that the receiver's binding
     *     scope values and binding attribute value will be used.
     * @param {Object} aValue The value to set onto the model.
     * @param {Boolean} [ignoreBidiInfo=false] Whether or not to ignore the
     *     receiver's bidirectional attribute information. If this parameter is
     *     true, this method will always set the bound value whether or not the
     *     bound attribute is considered to be both a getter and setter.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var elem,

        attrName;

    //  If we're part of a chain that started with refreshing the bind machinery
    //  (i.e. the bind machinery called setValue(), which is calling us), then
    //  just bail out here.
    if (TP.isTrue(TP.$$settingFromBindMachinery)) {
        return this;
    }

    elem = this.getNativeNode();

    //  NB: 'bind:in' doesn't matter here - that goes 'in', these go 'out'.

    if (TP.elementHasAttribute(elem, 'bind:io', true)) {
        attrName = 'bind:io';
    } else if (TP.elementHasAttribute(elem, 'bind:out', true)) {
        attrName = 'bind:out';
    }

    if (TP.isEmpty(attrName)) {
        return this;
    }

    //  Call setBoundAspect, using the supplied value and assuming our binding
    //  scope values and the value of the found binding attribute.
    this.setBoundAspect(attrName,
                        'value',
                        aValue,
                        this.getBindingScopeValues(),
                        this.getAttribute(attrName),
                        ignoreBidiInfo);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$setFinalValue',
function(aspect, exprs, outerScopeValue, updatedAspects, aFacet, transformFunc, aPathType, changeSource, repeatSource, repeatIndex) {

    /**
     * @method $setFinalValue
     * @summary Sets the 'final value' of the receiver.
     * @param {String} aspect The aspect of the receiver to update.
     * @param {String[]} exprs The list of data expressions that were parsed
     *     from the overall binding expression.
     * @param {Object} outerScopeVal The outer scoped value (usually a
     *     collection) to use to update the binding (unless the binding is a
     *     fully qualified exression). The binding will take a portion of this
     *     data to update.
     * @param {Array|TP.ALL} updatedAspects An Array of the aspects of the data
     *     model that are being updated or TP.ALL, to indicate that all of them
     *     are.
     * @param {String} aFacet=value The facet of the data that we're updating.
     *     we're refreshing. This defaults to 'value' which is the 99% case.
     * @param {Function} transformFunc Any transformation Function that was
     *     computed from the binding expression (that will have 1..n data
     *     expressions - supplied here in the 'exprs' parameter) embedded in it.
     * @param {Number} aPathType The path type that is contained in the
     *     binding expression.
     * @param {Object} changeSource The source of the change. If a signal
     *     initiated the refreshing process, this will be the signal's 'source'.
     * @param {Object} repeatSource The 'whole source' of the repeat, if the
     *     receiver is inside of a repeat context.
     * @param {Number} repeatIndex The index of the nearest scope within the
     *     nearest repeat if the receiver is inside of a repeat context.
     * @returns {Boolean} Whether or not the machinery invoked the set machinery
     *     of the leaf to change the value it is displaying.
     */

    var elem,

        facet,

        allRefreshedElements,
        refreshedElemsByAspectAndFacet,

        pathOptions,

        shouldExtractVal,
        shouldCollapseVal,

        getRequest,

        initialScopedValue,

        hasTransformFunc,

        finalVal,

        exprVals,

        len,
        i,

        scopedVal,

        expr,

        customGetterName,

        uriExpr,

        pathType,

        exprVal,

        pathExpr,

        isXMLResource,
        xmlTestVal,

        didRefresh;

    elem = this.getNativeNode();

    facet = TP.ifInvalid(aFacet, 'value');

    //  Grab the list of elements that have been refreshed.
    allRefreshedElements = this.getDocument().get('$refreshedElements');
    if (TP.notValid(allRefreshedElements)) {
        //  The hash of all refreshed elements didn't exist - create it.
        allRefreshedElements = TP.hc();
        this.getDocument().set('$refreshedElements', allRefreshedElements);

        //  Now, create an Array and register it under a composite key of the
        //  aspect and facet.
        refreshedElemsByAspectAndFacet = TP.ac();
        allRefreshedElements.atPut(
                    aspect + '__' + facet,
                    refreshedElemsByAspectAndFacet);
    } else {

        //  Grab the Array under the composite key of the aspect and facet.
        refreshedElemsByAspectAndFacet = allRefreshedElements.at(
                    aspect + '__' + facet);

        //  If that didn't exist, then create it.
        if (TP.notValid(refreshedElemsByAspectAndFacet)) {
            refreshedElemsByAspectAndFacet = TP.ac();
            allRefreshedElements.atPut(
                    aspect + '__' + facet,
                    refreshedElemsByAspectAndFacet);
        } else {
            //  Otherwise, if the Array under that composite key contains the
            //  receiver's native element, then we've already refreshed it in
            //  this 'pass'. Just return here.
            if (refreshedElemsByAspectAndFacet.indexOf(elem) !== TP.NOT_FOUND) {
                return false;
            }
        }
    }

    refreshedElemsByAspectAndFacet.push(elem);

    //  If we were handed an Array of the aspects of the model that were
    //  updated (and not TP.ALL, meaning all aspects), then check to see
    //  if the aspect we're currently updating is in that Array. If not,
    //  continue on.
    if (updatedAspects !== TP.ALL &&
        !updatedAspects.contains(aspect)) {
        return;
    }

    if (facet !== 'value' && TP.isValid(outerScopeValue)) {
        finalVal = outerScopeValue;
    } else {
        pathOptions = TP.hc();

        //  If the receiver is a 'scalar valued' target object, then we set
        //  flags to extract the value from the data value.
        shouldExtractVal = false;
        if (this.isScalarValued(aspect)) {
            shouldExtractVal = true;
            pathOptions.atPut('extractWith', 'value');
        }

        //  If the receiver is a 'single valued' target object, then we set
        //  flags to collapse a single item value from the data value.
        shouldCollapseVal = false;
        if (this.isSingleValued(aspect)) {
            shouldCollapseVal = true;
            pathOptions.atPut('shouldCollapse', true);
        }

        getRequest = TP.request('shouldCollapse', false);

        initialScopedValue = TP.collapse(outerScopeValue);

        hasTransformFunc = TP.isCallable(transformFunc);

        finalVal = '';

        exprVals = TP.ac();

        len = exprs.getSize();
        for (i = 0; i < len; i++) {

            //  NB: These get modified in the loop - we need to reset them here.
            scopedVal = initialScopedValue;
            customGetterName = null;

            expr = TP.trim(exprs.at(i));

            if (TP.isEmpty(expr)) {
                continue;
            }

            //  If we were handed a 'barename' expression, then we're
            //  referencing the value of another control on the same GUI page.
            if (TP.regex.BARENAME.test(expr)) {
                expr = 'tibet://uicanvas' + expr;
            } else if (TP.regex.JS_IDENTIFIER.test(expr)) {
                customGetterName = 'get' + TP.makeStartUpper(expr);
            }

            //  Compute a final value based on whether we were handed:
            //      1. A URI that we can extract the final value from.
            //      2. A path type if one was supplied and matches the value we
            //      were supplied.
            //      3. A value that can be extracted based on the supplied value
            //      and a computed extraction mechanism.

            if (TP.isURIString(expr)) {

                //  If there's a fragment, use that. Otherwise, we append a
                //  '#tibet(.)' fragment expression onto the URI, which will
                //  just return whatever object is considered the 'whole value'
                //  of the resource's result.
                if (TP.regex.URI_FRAGMENT.test(expr)) {
                    uriExpr = expr;
                } else {
                    uriExpr = TP.uc(expr).getPrimaryLocation() + '#tibet(.)';
                }

                exprVal = TP.uc(uriExpr).getResource(getRequest).get('result');

                if (shouldCollapseVal) {
                    exprVal = TP.collapse(exprVal);
                }

                //  If there is no transformation function defined, and if the
                //  value extraction flag is defined, then extract the value.
                //  If there is a transformation function, then we just hand the
                //  unextracted value of the data value to it.
                if (!hasTransformFunc && shouldExtractVal) {
                    exprVal = TP.val(exprVal);
                } else if (/tibet:\/\/uicanvas/.test(expr)) {
                    exprVal = TP.val(exprVal);
                }

            } else if (TP.isValid(customGetterName) &&
                        TP.canInvoke(scopedVal, customGetterName)) {

                //  There was a custom getter on the supplied scoped value -
                //  execute it and use that value.
                exprVal = scopedVal[customGetterName]();
            } else {

                //  Test the path type we were handed. If it doesn't match the
                //  type of data that we're processing in the loop, then we set
                //  the pathType to null and let the machinery handle it as if
                //  no path type was supplied.
                pathType = aPathType;

                //  If the expression contains ACP variables or a '$_' stdin
                //  indicator, then set the pathType to null and let the
                //  machinery that looks at the value compute the expression
                //  value.
                if (TP.regex.ACP_PATH_CONTAINS_VARIABLES.test(expr) ||
                    expr.contains('$_')) {
                    pathType = null;
                }

                if (TP.isValid(pathType)) {

                    switch (pathType) {
                        case TP.XPATH_PATH_TYPE:

                            if (TP.isXMLNode(scopedVal) ||
                                TP.isKindOf(scopedVal, TP.dom.Node)) {
                                //  empty
                            } else {
                                pathType = null;
                            }

                            break;

                        case TP.JSON_PATH_TYPE:
                            if (TP.isKindOf(scopedVal, TP.core.JSONContent)) {
                                //  empty
                            } else {
                                pathType = null;
                            }

                            break;

                        default:
                            break;
                    }
                }

                if (TP.isValid(pathType)) {

                    if (TP.isValid(scopedVal)) {
                        switch (pathType) {

                            case TP.XPATH_PATH_TYPE:

                                if (TP.isXMLNode(scopedVal)) {
                                    scopedVal = TP.wrap(scopedVal);
                                }

                                exprVal = this.$extractValue(
                                                        scopedVal,
                                                        expr,
                                                        TP.xpc,
                                                        pathOptions);

                                break;

                            case TP.JSON_PATH_TYPE:

                                if (!/^\$\./.test(expr)) {
                                    expr = '$.' + expr;
                                }

                                //  Because of the check above, scopedVal has to
                                //  be a JSONContent object here.

                                exprVal = this.$extractValue(
                                                        scopedVal,
                                                        expr,
                                                        TP.jpc,
                                                        pathOptions);

                                break;

                            case TP.TIBET_PATH_TYPE:

                                if (TP.isPlainObject(scopedVal)) {
                                    exprVal = this.$extractValue(
                                                        TP.hc(scopedVal),
                                                        expr,
                                                        TP.tpc,
                                                        pathOptions);
                                } else {
                                    exprVal = this.$extractValue(
                                                        scopedVal,
                                                        expr,
                                                        TP.tpc,
                                                        pathOptions);
                                }

                                break;

                            default:

                                exprVal = scopedVal.get(expr);

                                break;
                        }
                    }

                } else {

                    if (TP.isValid(scopedVal)) {

                        //  Note use of 'primitive' fetch in some places here -
                        //  at this level we're just trying to extract values,
                        //  not track data interests or anything like that.

                        if (TP.regex.COMPOSITE_PATH.test(expr)) {
                            exprVal = TP.wrap(scopedVal).get(
                                                TP.apc(expr, pathOptions));
                        } else if (TP.regex.ACP_PATH_CONTAINS_VARIABLES.test(
                                                                        expr)) {
                            exprVal = scopedVal;
                        } else if (TP.isPlainObject(scopedVal)) {
                            exprVal = TP.extern.jsonpath.nodes(
                                                    scopedVal, expr)[0];

                            if (TP.isValid(exprVal)) {
                                exprVal = exprVal.value;
                                exprVal =
                                    TP.processValueUsingConfig(
                                    exprVal,
                                    scopedVal,
                                    shouldCollapseVal,
                                    shouldExtractVal ? 'value' : null);
                            }
                        } else if (TP.isXMLNode(scopedVal)) {
                            exprVal = TP.nodeEvaluatePath(
                                        scopedVal,
                                        expr,
                                        TP.XPATH_PATH_TYPE,
                                        false);

                            exprVal =
                                TP.processValueUsingConfig(
                                exprVal,
                                scopedVal,
                                shouldCollapseVal,
                                shouldExtractVal ? 'value' : null);

                        } else if (TP.isKindOf(scopedVal, TP.dom.Node)) {
                            exprVal = TP.nodeEvaluatePath(
                                        TP.unwrap(scopedVal),
                                        expr,
                                        TP.XPATH_PATH_TYPE,
                                        false);

                            exprVal =
                                TP.processValueUsingConfig(
                                exprVal,
                                scopedVal,
                                shouldCollapseVal,
                                shouldExtractVal ? 'value' : null);

                        } else if (TP.isKindOf(scopedVal,
                                                TP.core.JSONContent)) {
                            pathExpr = expr;

                            if (TP.regex.JSON_POINTER.test(pathExpr)) {
                                pathExpr =
                                    TP.regex.JSON_POINTER.match(pathExpr).at(1);
                            }

                            exprVal = TP.extern.jsonpath.nodes(
                                    scopedVal.get('data'), pathExpr)[0];

                            if (TP.isValid(exprVal)) {
                                exprVal = exprVal.value;
                                exprVal =
                                    TP.processValueUsingConfig(
                                    exprVal,
                                    scopedVal,
                                    shouldCollapseVal,
                                    shouldExtractVal ? 'value' : null);
                            }
                        } else if (TP.isKindOf(scopedVal,
                                                TP.core.XMLContent)) {
                            pathExpr = expr;

                            if (TP.regex.XPATH_POINTER.test(pathExpr)) {
                                pathExpr =
                                    TP.regex.XPATH_POINTER.match(pathExpr).at(2);
                            }

                            exprVal = TP.nodeEvaluatePath(
                                        TP.unwrap(scopedVal.get('data')),
                                        pathExpr,
                                        TP.XPATH_PATH_TYPE,
                                        false);

                            exprVal =
                                TP.processValueUsingConfig(
                                exprVal,
                                scopedVal,
                                shouldCollapseVal,
                                shouldExtractVal ? 'value' : null);
                        } else if (TP.regex.JSON_POINTER.test(expr) ||
                                    TP.regex.JSON_PATH.test(expr)) {
                            pathExpr = expr;

                            if (TP.regex.JSON_POINTER.test(pathExpr)) {
                                pathExpr =
                                    TP.regex.JSON_POINTER.match(pathExpr).at(1);
                            }

                            if (TP.isKindOf(scopedVal, TP.core.JSONContent)) {
                                exprVal = TP.extern.jsonpath.nodes(
                                    scopedVal.get('data'), pathExpr)[0].value;
                            } else {
                                exprVal = TP.extern.jsonpath.nodes(
                                    scopedVal, pathExpr)[0].value;
                            }

                            exprVal =
                                TP.processValueUsingConfig(
                                exprVal,
                                scopedVal,
                                shouldCollapseVal,
                                shouldExtractVal ? 'value' : null);
                        } else if (TP.notValid(scopedVal)) {
                            exprVal = null;
                        } else if (TP.regex.QUOTED_CONTENT.test(expr)) {
                            exprVal = TP.regex.QUOTED_CONTENT.match(expr).at(2);
                        } else if (!TP.isMutable(scopedVal)) {
                            //  If it's a String, Number or Boolean, then
                            //  scopedVal is the actual value we want to use.
                            exprVal = scopedVal;
                        } else {
                            exprVal = scopedVal.get(expr);
                        }
                    }
                }

                //  If there is no transformation function defined, and if the
                //  value extraction flags are defined, then extract the value.
                //  If there is a transformation function, then we just hand the
                //  unextracted value of the data value to it.
                if (!hasTransformFunc && shouldExtractVal) {
                    exprVal = TP.val(exprVal);
                }

                if (shouldCollapseVal) {
                    exprVal = TP.collapse(exprVal);
                }
            }

            exprVals.push(exprVal);
        }

        //  If we ended up with a *valid* final value and a transformation
        //  Function was defined, then execute it with that value.
        if (TP.notEmpty(exprVals)) {
            if (hasTransformFunc) {

                xmlTestVal = exprVals.first();

                if (TP.isCollection(xmlTestVal)) {
                    isXMLResource = TP.isXMLNode(TP.unwrap(xmlTestVal.first()));
                } else {
                    isXMLResource = TP.isXMLNode(TP.unwrap(xmlTestVal));
                }

                if (isXMLResource) {
                    exprVals.convert(
                        function(aVal) {
                            if (TP.isNode(aVal) ||
                                TP.isKindOf(aVal, TP.dom.Node)) {
                                return TP.objectValue(aVal, 'value', true);
                            }
                        });
                }

                finalVal = transformFunc(
                                changeSource,
                                exprVals,
                                this,
                                repeatSource,
                                repeatIndex,
                                isXMLResource);
            } else {
                //  Try to preserve the data type here. If there is only 1
                //  expression, then there is no sense in stringifying the final
                //  value.
                if (exprVals.getSize() === 1) {
                    finalVal = exprVal;
                } else {
                    finalVal = exprVals.join('');
                }
            }
        }
    }

    //  NB: We will *always* call either setValue or setFacet, even if the value
    //  is null or undefined. This way we can let the receiver decide how to
    //  manage those values.
    if (aspect === 'value' && facet === 'value') {
        TP.$$settingFromBindMachinery = true;
        didRefresh = this.setValue(finalVal);
        TP.$$settingFromBindMachinery = false;
    } else {
        TP.$$settingFromBindMachinery = true;
        didRefresh = this.setFacet(aspect, facet, finalVal);
        TP.$$settingFromBindMachinery = false;
    }

    return didRefresh;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('setInitialValue',
function(aValue) {

    /**
     * @method setInitialValue
     * @summary Sets the initial value of the receiver.
     * @description This method is a convenience wrapper for setting an initial
     *     value. The property 'initialValue' has no special meaning, but is a
     *     defacto property name chosen by TIBET that will simply set the bound
     *     value. This should only be used in a 'read-only' fashion by authors
     *     to set the initial value of a piece of model data.
     * @param {Object} aValue The inital value to set onto the model.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    this.setBoundValueIfBound(aValue);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('setRepeatPage',
function(aPosition) {

    /**
     * @method setRepeatPage
     * @summary Sets the repeat page 'position', that is the currently showing
     *     page of repeating results.
     * @param {Number} aPosition The position to set the repeating paging system
     *     to.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var repeatSize,

        position,
        endIndex;

    repeatSize = this.getAttribute('bind:repeatsize');

    position = aPosition;

    //  Can't go before the first page.
    if (position < 0) {
        return this;
    }

    //  Can't go after the last page.
    if (position > this.getRepeatPageCount()) {
        return this;
    }

    endIndex = (position - 1) * repeatSize;

    this.setAttribute('bind:repeatindex', endIndex);

    //  NB: We pass true here to signal change in case anything in the GUI is
    //  watching this attribute.
    this.$setAttribute('bind:repeatpage', aPosition, true);

    return this;
});

//  ------------------------------------------------------------------------

TP.dom.ElementNode.Inst.defineMethod('$updateRepeatRowIndices',
function(aCollection) {

    /**
     * @method $updateRepeatRowIndices
     * @summary This method updates repeating rows indices based on the values
     *     of the receiver's 'bind:repeatindex' and 'bind:repeatsize' attribute
     *     values.
     * @description Note that the 'bind:repeatindex' is 1-based, so the first
     *     row is '1', not '0'. Also, this method will default the
     *     'bind:repeatsize' to the length of the collection or a maximum row
     *     value, whichever is less, if one isn't specified.
     * @param {Object} aCollection The collection data model that is used for
     *     the repeating content.
     * @returns {TP.dom.ElementNode} The receiver.
     */

    var elem,

        collection,
        isXMLResource,

        resourceLength,

        allRepeatChunks,

        startIndex,
        endIndex,
        repeatSize,

        indices,

        repeatElem,
        scopeIndex,

        len,
        i;

    elem = this.getNativeNode();

    collection = aCollection;

    //  If a collection wasn't supplied, then go obtain the 'repeat source'.
    if (!TP.isCollection(collection)) {
        collection = this.$getRepeatValue();
    }

    //  If collection is a TP.core.Hash, then convert it into an Array of
    //  key/value pairs. Binding repeats need a collection they can index
    //  numerically.
    if (TP.isHash(collection)) {
        collection = collection.getKVPairs();
    }

    //  Detect whether we're drawing GUI for model which is a chunk of XML data
    //  - we'll use this information later.
    isXMLResource = TP.isXMLNode(TP.unwrap(collection.first()));

    //  The maximum number of rows.
    resourceLength = collection.getSize();

    //  Find all of the existing *direct children* bound rows under us that have
    //  a 'bind:scope' that starts with a '[' and ends with a ']'.
    allRepeatChunks = TP.byCSSPath(
                        '> *[bind|scope^="["][bind|scope$="]"]',
                        elem,
                        false,
                        false);

    //  If we have a 'bind:repeatindex', then we can compute a starting index
    //  from it.
    if (this.hasAttribute('bind:repeatindex')) {
        if (!TP.isNumber(startIndex =
                            this.getAttribute('bind:repeatindex').asNumber())) {
            startIndex = 0;
        }
    } else {
        startIndex = 0;
    }

    //  If we have a 'bind:repeatsize', then we can compute how many rows we
    //  should be displaying.
    if (this.hasAttribute('bind:repeatsize')) {

        //  If we have a 'bind:repeatsize', then we can compute an ending index
        //  from that and the startIndex
        if (TP.isNumber(repeatSize =
                        this.getAttribute('bind:repeatsize').asNumber())) {
            endIndex = startIndex + repeatSize;
        } else {
            endIndex = resourceLength - startIndex;
        }

        endIndex -= 1;
    } else {
        endIndex = resourceLength;
    }

    //  The startIndex has to be at least 0.
    startIndex = startIndex.max(0);

    //  The endIndex cannot be larger than the number of rows.
    endIndex = endIndex.min(resourceLength);

    //  Generate a list of numbers from startIndex...endIndex.
    indices = Array.generateNumericSequence(startIndex, endIndex);

    //  Iterate over all of the repeating content rows in the receiver and show
    //  or hide them, depending on whether their index exists in the numeric
    //  sequence.
    len = allRepeatChunks.getSize();
    for (i = 0; i < len; i++) {

        repeatElem = allRepeatChunks.at(i);

        //  If we're dealing with an XML resource, then we add one to the index
        //  we're processing (since indices in XPath are 1-based, which is fine
        //  for XML, but not for other 0-based data, like JS or JSON).
        if (!isXMLResource) {
            scopeIndex = indices.at(i);
        } else {
            scopeIndex = indices.at(i) + 1;
        }

        //  Update the 'bind:scope' with an attribute containing the numeric
        //  scoping index (i.e. '[2]'). This will be used in bind scoping
        //  computations.
        TP.elementSetAttribute(repeatElem,
                                'bind:scope',
                                '[' + scopeIndex + ']',
                                true);

        //  Update the cached repeating index on the element for much better
        //  bind:repeat performance
        repeatElem[TP.REPEAT_INDEX] = scopeIndex;
    }

    if (!TP.isNumber(this.getAttribute('bind:repeatpage').asNumber())) {
        //  NB: We pass true here to signal change in case anything in the GUI
        //  is watching this attribute.
        this.$setAttribute('bind:repeatpage', 1, true);
    }

    return this;
});

//  ------------------------------------------------------------------------
//  TP.dom.UIElementNode
//  ------------------------------------------------------------------------

TP.dom.UIElementNode.Inst.defineHandler('UIEdit',
function(aSignal) {

    /**
     * @method handleUIEdit
     * @summary Handles when the user wants to edit the underlying data source.
     *     For now, this method a) only works for bind:repeat and b) only uses a
     *     simple text field to allow editing.
     * @param {TP.sig.UIEdit} aSignal The signal instance which triggered
     *     this handler.
     * @returns {TP.dom.UIElementNode} The receiver.
     */

    var targetElem,
        textNode,

        removeEditorAndSetValue,
        moveEditorTo,

        editor,

        keydownHandler;

    //  It is important to remember that this code is shared by all
    //  TP.dom.ElementNode nodes. Therefore, we need to use other checking logic
    //  (like whether or not we have this attribute) to see if we handle this.

    if (!this.hasAttribute('bind:repeat')) {
        return this;
    }

    //  We can handle this - stop propagation so that ancestors up the chain
    //  don't get notified.
    aSignal.stopPropagation();

    //  Compute the target element from the underlying DOM signal.
    targetElem = aSignal.getDOMTarget();

    //  If the target was a Text node, then we use its parent node.
    if (TP.isTextNode(targetElem)) {
        textNode = targetElem;
        targetElem = targetElem.parentNode;
    } else {
        textNode = targetElem.firstChild;
    }

    //  A Function that tears down the editor and sets the bound value.
    removeEditorAndSetValue = function() {

        var newText,
            newTextNode,

            boundElem,
            boundTPElem;

        //  Grab the value from the editor and create a new Text node from it.
        newText = editor.value;
        newTextNode = editor.ownerDocument.createTextNode(newText);

        //  Now, starting from the editor, we need to determine the nearest
        //  'bound element' up our chain. This is the one we'll be setting the
        //  value for.
        boundElem = TP.nodeDetectAncestor(
                        editor,
                        function(aNode) {
                            return TP.isElement(aNode) &&
                                    TP.wrap(aNode).isBoundElement();
                        });

        //  Replace the editor with the newly generated text node
        TP.nodeReplaceChild(editor.parentNode,
                            newTextNode,
                            editor,
                            false);

        //  Wrap the element that we're really setting the value for and set its
        //  bound value.
        boundTPElem = TP.wrap(boundElem);
        boundTPElem.setBoundAspect(
                        'bind:in',
                        'value',
                        newText,
                        boundTPElem.getBindingScopeValues(),
                        boundTPElem.getAttribute('bind:in'),
                        true);
    };

    //  A Function that moves the editor to the supplied Element
    moveEditorTo = function(anElem) {

        var elemTextContent,
            elemTextNode;

        //  Grab the text content from the element
        elemTextContent = TP.nodeGetTextContent(anElem);

        //  Replace the underlying text node with the editor.
        elemTextNode = anElem.firstChild;
        editor = TP.nodeReplaceChild(anElem,
                                        editor,
                                        elemTextNode,
                                        false);

        //  Set the value of the editor to the element's text content.
        editor.value = elemTextContent;

        //  Select the text in the editor, but cause this to happen after the
        //  next repaint to allow the GUI to refresh, which seems to help out
        //  focusing mechanics.
        editor.select.queueAfterNextRepaint(TP.nodeGetWindow(anElem));
    };

    //  Replace the text node with an editor and style it.
    editor = TP.nodeReplaceTextWithEditor(textNode);
    TP.elementSetStyleString(editor, 'width: 100%; height: 100%;');

    //  Set up a 'keydown' handler on the editor.
    editor.addEventListener(
            'keydown',
            keydownHandler = function(evt) {
                var editorTargetElem,
                    editorTargetType,

                    keyName,
                    sigName,

                    repeatElem,
                    allBindIns,

                    destinationElement;

                //  NB: We don't use variables captured from the enclosing scope
                //  (except for 'editor') in this handler function, since
                //  closure semantics can cause problems. Therefore, we obtain
                //  everything from 'editor' or from the event parameter.

                //  The current target element is the parent node of the editor.
                editorTargetElem = editor.parentNode;

                //  Get the TIBET type for the editor element.
                editorTargetType = TP.wrap(editorTargetElem).getType();

                //  Grab the key name and consult the editor type's key binding
                //  map for a signal name. This will tell us whether we should
                //  just keep processing keys or move the editor or dismiss the
                //  editor.
                keyName = TP.eventGetDOMSignalName(evt);
                sigName = editorTargetType.getKeybinding(keyName, evt);

                //  If we didn't have a mapping signal, and the key name wasn't
                //  an 'Enter' then we will just keep processing keys
                if (TP.notValid(sigName) && keyName !== 'DOM_Enter_Down') {
                    return;
                }

                //  Grab our ancestor that contains the 'bind:repeat' attribute.
                repeatElem = TP.nodeDetectAncestor(
                                editorTargetElem,
                                function(aNode) {
                                    return TP.isElement(aNode) &&
                                            TP.elementHasAttribute(
                                                aNode, 'bind:repeat', true);
                                });

                //  Grab all of the elements under the element with the
                //  'bind:repeat' that have 'bind:in' attributes.
                allBindIns = TP.byCSSPath(' *[bind|in]',
                                            repeatElem,
                                            false,
                                            false);

                //  Based on the signal name, compute the element we should be
                //  going to.
                switch (sigName) {

                    case 'TP.sig.UIFocusFirst':

                        destinationElement = allBindIns.first();
                        break;

                    case 'TP.sig.UIFocusLast':

                        destinationElement = allBindIns.last();
                        break;

                    case 'TP.sig.UIFocusNext':

                        destinationElement =
                                allBindIns.after(editorTargetElem);
                        //  If we couldn't find an element following the target
                        //  element, then we wrap around to the first one.
                        if (!TP.isElement(destinationElement)) {
                            destinationElement = allBindIns.first();
                        }
                        break;

                    case 'TP.sig.UIFocusPrevious':

                        destinationElement =
                                allBindIns.before(editorTargetElem);

                        //  If we couldn't find an element preceding the target
                        //  element, then we wrap around to the last one.
                        if (!TP.isElement(destinationElement)) {
                            destinationElement = allBindIns.last();
                        }
                        break;

                    default:

                        //  No destination element could be computed - just
                        //  dismiss the editor and remove this handler. See
                        //  below.
                        destinationElement = TP.NOT_FOUND;
                        break;
                }

                //  Make sure to both prevent default and stop propagation of
                //  the native event. We don't want keypresses or keyups.
                evt.preventDefault();
                evt.stopPropagation();

                //  If we truly didn't find any destination element, then the
                //  user did something like hit Enter, which means they just
                //  wanted to dismiss the editor.
                if (destinationElement === TP.NOT_FOUND) {

                    //  Remove the editor and set the value.
                    removeEditorAndSetValue();

                    //  Remove the 'keydown' listener handler.
                    this.removeEventListener('keydown', keydownHandler, false);
                } else {

                    //  Otherwise, the user wants to move the editor to another
                    //  element.

                    //  Remove the editor and set the value.
                    removeEditorAndSetValue();

                    //  Move the editor to the destination element.
                    moveEditorTo(destinationElement);
                }
            });

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETCoreTags.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 */

//  ========================================================================
//  TP.lama.*
//  ========================================================================

TP.sys.addFeatureTest('lama',
function() {

    //  NB: For the system to be considered to have the 'lama' feature, it has
    //  to both have the 'TP.lama.IDE' type loaded *and* have the Lama
    //  enabled for opening. The Lama HUD doesn't necessarily have to be open.
    return TP.isType(TP.sys.getTypeByName('TP.lama.IDE')) &&
            TP.sys.cfg('lama.enabled') === true &&
            TP.sys.inExtension() !== true;
});

//  ========================================================================
//  TP.tag.CustomTag
//  ========================================================================

/**
 * @type {TP.tag.CustomTag}
 * @summary A common supertype for custom UI tags.
 */

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.defineSubtype('TP.tag.CustomTag');

TP.tag.CustomTag.addTraits(TP.dom.NonNativeUIElementNode);

TP.tag.CustomTag.Type.resolveTrait(
        'tagCompile',
        TP.dom.UIElementNode);

TP.tag.CustomTag.Inst.resolveTraits(
        TP.ac('$setAttribute', 'removeAttribute', 'select', 'signal'),
        TP.dom.UIElementNode);

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  Whether or not we're currently in the process of being serialized.
TP.tag.CustomTag.Inst.defineAttribute('$areSerializing');

//  Whether or not we have real selected descendant content that we serialize.
//  This is used to determine what kind of tag (empty or not) to serialize.
TP.tag.CustomTag.Inst.defineAttribute('$serializesAsEmpty');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tag.CustomTag.Type.defineHandler('ValueChange',
function(aSignal) {

    /**
     * @method handleValueChange
     * @summary Handles notification of a change.
     * @description If the origin is a URI that one of our 'reloadable
     *     attributes' has as the reference to its remote resource, then the
     *     'reloadFrom<Attr>' method is invoked on the receiver.
     * @param {TP.sig.Signal} aSignal The signal instance to respond to.
     * @returns {TP.meta.tag.CustomTag} The receiver.
     */

    var origin,
        aspect;

    //  Grab the signal origin - for changes to observed URI resources (see the
    //  tagAttachDOM()/tagDetachDOM() methods) this should be the URI that
    //  changed.
    origin = aSignal.getSignalOrigin();

    //  If it was a URL, then check to see if it's one of URL's 'special
    //  aspects'.
    if (TP.isKindOf(origin, TP.uri.URL)) {

        //  If the aspect is one of URI's 'special aspects', then we just return
        //  here.
        aspect = aSignal.at('aspect');
        if (TP.uri.URI.SPECIAL_ASPECTS.contains(aspect)) {
            return this;
        }
    }

    if (TP.canInvoke(this, 'refreshInstances')) {
        this.refreshInstances();
    }

    return this;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.tag.CustomTag.Inst.defineMethod('getDescendantsForSerialization',
function() {

    /**
     * @method getDescendantsForSerialization
     * @summary Returns an Array of descendants of the receiver to include in
     *     the receiver's serialization. Typically, these will be nodes that
     *     will be 'slotted' into the receiver by the author and not nodes that
     *     the template generated 'around' the slotted nodes.
     * @returns {TP.dom.Node[]} An Array of descendant nodes to serialize.
     */

    return TP.ac();
});

//  ------------------------------------------------------------------------

TP.tag.CustomTag.Inst.defineMethod('getSerializationTraversal',
function() {

    /**
     * @method getSerializationTraversal
     * @summary Returns a constant, either TP.DESCEND or TP.CONTINUE, that
     *     determines whether serialization will descend into descendant nodes
     *     of this node or not. If TP.CONTINUE is returned that means that only
     *     select descendants, as determined by this type's
     *     getDescendantsForSerialization method will be serialized.
     * @returns {Number} Either TP.DESCEND or TP.CONTINUE.
     */

    var ourName,
        appTagName;

    ourName = this.getCanonicalName();

    //  NB: We pass false here to skip returning any Lama tag since we're
    //  running in a Lama-enabled environment.
    appTagName = TP.tibet.root.computeAppTagTypeName(false);

    //  If our (canonical) name is the same as the app tag name, then we allow
    //  descendant mutations.
    if (ourName === appTagName) {
        return TP.DESCEND;
    }

    return TP.CONTINUE;
});

//  ------------------------------------------------------------------------

TP.tag.CustomTag.Inst.defineMethod('isSerializationEmpty',
function() {

    /**
     * @method isSerializationEmpty
     * @summary Returns whether or not the receiver should serialize with no
     *     content (i.e. an 'empty element')
     * @description At this type level, this simply returns whether the receiver
     *     is empty (i.e. devoid of child nodes). Subtypes may choose to use
     *     different criteria to determine this.
     * @returns {Boolean} Whether or not the receiver should serialize as an
     *     'empty element'.
     */

    return this.get('$serializesAsEmpty');
});

//  ------------------------------------------------------------------------

TP.tag.CustomTag.Inst.defineMethod('serializeCloseTag',
function(storageInfo) {

    /**
     * @method serializeCloseTag
     * @summary Serializes the closing tag for the receiver.
     * @description At this type level, this method, in conjunction with the
     *     'serializeOpenTag' method, will always produce the 'XML version' of
     *     an empty tag (i.e. '<foo/>' rather than '<foo></foo>').
     * @param {TP.core.Hash} storageInfo A hash containing various flags for and
     *     results of the serialization process. Notable keys include:
     *          'wantsXMLDeclaration': Whether or not the document node should
     *          include an 'XML declaration' at the start of it's serialization.
     *          The default is false.
     *          'result': The current serialization result as it's being built
     *          up.
     *          'store': The key under which the current serialization result
     *          will be stored.
     *          'stores': A hash of 1...n serialization results that were
     *          generated during the serialization process. Note that nested
     *          nodes might generated results that will go into different
     *          stores, and so they will all be stored here, each keyed by a
     *          unique key (which, by convention, will be the URI they should be
     *          saved to).
     * @returns {String} A serialization of the closing tag of the receiver.
     */

    var str;

    //  If we're serializing, then we just do what our supertype does and
    //  descend into our child nodes.
    if (this.get('$areSerializing')) {
        str = this.callNextMethod();
        return TP.ac(str, TP.DESCEND);
    }

    return TP.CONTINUE;
});

//  ------------------------------------------------------------------------

TP.tag.CustomTag.Inst.defineMethod('serializeOpenTag',
function(storageInfo) {

    /**
     * @method serializeOpenTag
     * @summary Serializes the opening tag for the receiver.
     * @description At this type level, this method performs a variety of
     *     transformations and filtering of various attributes. See the code
     *     below for more details. One notable transformation is that this
     *     method, in conjunction with the 'serializeCloseTag' method,  will
     *     always produce the 'XML version' of an empty tag (i.e. '<foo/>'
     *     rather than '<foo></foo>').
     * @param {TP.core.Hash} storageInfo A hash containing various flags for and
     *     results of the serialization process. Notable keys include:
     *          'wantsXMLDeclaration': Whether or not the document node should
     *          include an 'XML declaration' at the start of it's serialization.
     *          The default is false.
     *          'result': The current serialization result as it's being built
     *          up.
     *          'store': The key under which the current serialization result
     *          will be stored.
     *          'stores': A hash of 1...n serialization results that were
     *          generated during the serialization process. Note that nested
     *          nodes might generated results that will go into different
     *          stores, and so they will all be stored here, each keyed by a
     *          unique key (which, by convention, will be the URI they should be
     *          saved to).
     * @returns {String} A serialization of the opening tag of the receiver.
     */

    var str,

        traversalSetting,

        currentStore,
        currentResult,

        resourceURI,

        loc;

    //  If we're serializing, then we just do what our supertype does and
    //  descend into our child nodes.
    if (this.get('$areSerializing')) {

        //  Grab the traversal setting. If it's not TP.DESCEND (which is the
        //  default), then call a method to serialize select descendants.
        traversalSetting = this.get('serializationTraversal');
        if (traversalSetting !== TP.DESCEND) {
            //  Serialize descendants. Set whether or not we serialize as empty
            //  as to whether there was actual descendant content.
            str = this.serializeSelectDescendants(storageInfo);
            this.set('$serializesAsEmpty', TP.isEmpty(str), false);
        } else {
            str = '';
            //  Otherwise, this tag serializes as empty if it really is empty.
            //  Note that we don't rely on the isSerializationEmpty method here
            //  since it is the consumer of this flag - we're setting the flag
            //  for it's usage.
            this.set('$serializesAsEmpty', this.isEmpty(), false);
        }

        //  Call 'super' to get the serialized version of ourself and prepend it
        //  onto our selected descendants markup.
        str = this.callNextMethod() + str;

        return TP.ac(str, traversalSetting);
    }

    //  Turn the serializing flag on.
    this.set('$areSerializing', true, false);

    //  Grab our template's resource URI - we'll use this as our 'store' key.
    resourceURI = this.getType().getResourceURI(
                        'template',
                        TP.elementGetAttribute(
                            this.getNativeNode(), 'tibet:mime', true));

    loc = resourceURI.getLocation();

    currentStore = storageInfo.at('store');

    //  If we're 'locking' the store, that means that all serialization results
    //  will go into a single serialization store. That means that nested tags
    //  will represent themselves in their hosting template - their template
    //  won't change.
    if (TP.notTrue(storageInfo.at('lockStore'))) {

        //  If we're not actually serializing our own template, then store off
        //  the current result - we'll need it below.
        if (currentStore !== loc) {
            currentResult = storageInfo.at('result');
        }

        //  Set our template resource URI as the current 'store' key and create
        //  a new result Array.
        storageInfo.atPut('store', loc);
        storageInfo.atPut('result', TP.ac());

        //  Serialize ourself - this will loop back around to this method, hence
        //  the '$areSerializing' flag. This will also place any generated
        //  results 'under' us into the 'stores' hash under our store key.
        this.serializeForStorage(storageInfo);

        //  If we're not actually serializing our own template, then restore the
        //  current 'store' (i.e. location) and result.
        if (currentStore !== loc) {
            //  Restore the previous 'store' key and result.
            storageInfo.atPut('store', currentStore);
            storageInfo.atPut('result', currentResult);
        }
    } else {
        //  Serialize ourself - this will loop back around to this method, hence
        //  the '$areSerializing' flag. This will also place any generated
        //  results 'under' us into the 'stores' hash under our store key.
        this.serializeForStorage(storageInfo);
    }

    //  Turn the serializing flag off.
    this.set('$areSerializing', false, false);

    //  If we're not actually serializing our own template, then return an empty
    //  version of ourself as the placeholder in the 'higher level' markup that
    //  we're being serialized as a part of.
    if (currentStore !== loc && TP.notTrue(storageInfo.at('lockStore'))) {
        //  Return an Array containing our full name (as opposed to our actual
        //  rendered tag name) as an empty tag and continue on to our next
        //  sibling, thereby treating our child content as opaque.
        return TP.ac('<' + this.getFullName() + '/>', TP.CONTINUE);
    }

    //  We were serializing our own template and we included the results of that
    //  above - just hand back the empty String and continue on to the next
    //  sibling.
    return TP.ac('', TP.CONTINUE);
});

//  ------------------------------------------------------------------------

TP.tag.CustomTag.Inst.defineMethod('serializeSelectDescendants',
function(storageInfo) {

    /**
     * @method serializeSelectDescendants
     * @summary Serializes selected descendants per the logic of this tag. This
     *     method is only called if the setting of 'serializationTraversal' is
     *     set to a value *other* than TP.DESCEND (which is the default). Note
     *     that, at a minimum, this method *must* return the empty String.
     * @description At this type level, this method just returns the empty
     *     String. A templated tag subtype might choose to override this to
     *     serialize selected descendants. If so, it needs to set it's
     *     type-level 'serializationTraversal' attribute to something other than
     *     TP.DESCEND (probably TP.CONTINUE) and then implement this method.
     * @param {TP.core.Hash} storageInfo A hash containing various flags for and
     *     results of the serialization process. Notable keys include:
     *          'wantsXMLDeclaration': Whether or not the document node should
     *          include an 'XML declaration' at the start of it's serialization.
     *          The default is false.
     *          'result': The current serialization result as it's being built
     *          up.
     *          'store': The key under which the current serialization result
     *          will be stored.
     *          'stores': A hash of 1...n serialization results that were
     *          generated during the serialization process. Note that nested
     *          nodes might generated results that will go into different
     *          stores, and so they will all be stored here, each keyed by a
     *          unique key (which, by convention, will be the URI they should be
     *          saved to).
     * @returns {String} A serialization of selected descendants of the
     *     receiver.
     */

    var selectedDescendants,

        localID,

        serializationStorage,
        str;

    //  Get the descendants that we want to serialize. If there are none, just
    //  return the empty String.
    selectedDescendants = this.getDescendantsForSerialization();
    if (TP.isEmpty(selectedDescendants)) {
        return '';
    }

    localID = this.getLocalID();

    //  Set up a serialization storage, with a store registered under our local
    //  (unique) ID. Note that we also copy other 'meta information' about
    //  serializaton.
    serializationStorage = TP.hc(
        'store', localID,
        'wantsPrefixedXMLNSAttrs', storageInfo.at('wantsPrefixedXMLNSAttrs'));

    str = '';

    //  Iterate over the selected descendants and serialize them into the store.
    selectedDescendants.forEach(
        function(aDescendant) {
            var siblings;

            //  Grab all of our 'previous' siblings.
            siblings = aDescendant.getSiblings(TP.PREVIOUS);
            siblings.forEach(
                function(aSiblingTPNode) {
                    //  Make sure the sibling isn't an Element
                    if (!TP.isKindOf(aSiblingTPNode, TP.dom.ElementNode)) {
                        str += aSiblingTPNode.serializeNonTag(
                                            serializationStorage);
                    }
                });

            //  Note here how we create a new result for each iteration of this
            //  loop. This is because we're creating content above and below and
            //  don't want the serialization routine to use the store, but to
            //  use a fresh result at each 'level'.
            serializationStorage.atPut('result', TP.ac());
            aDescendant.serializeForStorage(serializationStorage);

            //  Grab the result at the store registered under our local ID.
            str += serializationStorage.at('stores').at(localID);

            //  Grab all of our 'next' siblings.
            siblings = aDescendant.getSiblings(TP.NEXT);
            siblings.forEach(
                function(aSiblingTPNode) {
                    //  Make sure the sibling isn't an Element
                    if (!TP.isKindOf(aSiblingTPNode, TP.dom.ElementNode)) {
                        str += aSiblingTPNode.serializeNonTag(
                                            serializationStorage);
                    }
                });
        });

    return str;
});

//  ------------------------------------------------------------------------

TP.tag.CustomTag.Type.defineMethod('$shouldAddToOriginals',
function(originalNode, mutatedNode, targetNode) {
    /**
     * @method $shouldAddToOriginals
     * @summary Whether or not the receiver should add a node that is being
     *     processed to its set of 'originals' - that is, nodes that need to be
     *     updated if the receiver's computation/templating output changes.
     * @description For this type, the Window that the node is destined for (as
     *     supplied by the targetNode, if its available) will be queried for. If
     *     it is the same as the current UI canvas, then true is returned. If
     *     there is no targetNode or it's Window cannot be determined, then true
     *     will be returned.
     * @param {Node} sourceNode A clone of the original node that is
     *     representing the receiver before 'computation'/'transformation. The
     *     original version of this node is what will be added to the set of
     *     originals.
     * @param {Node} mutatedNode The original node after having been mutated by
     *     computation/transformation.
     * @param {Node} targetNode The target element that the receiver is a part
     *     of. This is useful when needing information about the visual surface
     *     that the currently processing element will be drawn into.
     * @returns {Boolean} Whether or not to add the node to the receiver's set
     *     of 'originals'.
     */

    var win;

    if (TP.isNode(targetNode)) {
        win = TP.nodeGetWindow(targetNode);
        if (TP.isWindow(win)) {
            return win === TP.sys.uiwin(true);
        }
    }

    return true;
});

//  ========================================================================
//  TP.tag.ComputedTag
//  ========================================================================

/**
 * @type {TP.tag.ComputedTag}
 * @summary A common supertype for computed UI tags.
 */

//  ------------------------------------------------------------------------

TP.tag.CustomTag.defineSubtype('TP.tag.ComputedTag');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tag.ComputedTag.Type.defineMethod('defineMethod',
function(methodName, methodBody, methodDescriptor, display, $isHandler) {

    /**
     * @method defineMethod
     * @summary Adds the function with name and body provided as a type or
     *     'type local' method.
     * @param {String} methodName The name of the new method.
     * @param {Function} methodBody The actual method implementation.
     * @param {Object} methodDescriptor An optional 'property descriptor'. If a
     *     'value' slot is supplied here, it is ignored in favor of the
     *     methodBody parameter to this method.
     * @param {String} display Optional string defining the public display name
     *     for the function.
     * @param {Boolean} [$isHandler=false] True will cause the definition to
     *     pass without errors for deprecated use of defineMethod for handlers.
     * @returns {Function} The newly defined method.
     */

    var retVal;

    //  Gotta love TIBET - redefining the 'defineMethod' method for a particular
    //  type and its subtypes. And callNextMethod() too!

    retVal = this.callNextMethod();

    //  If we're redefining the 'tagCompile' method and the system has started,
    //  then we need to refresh all of the existing instances.
    if (methodName === 'tagCompile' && TP.sys.hasStarted()) {
        this[TP.OWNER].refreshInstances();
    }

    return retVal;
});

//  ------------------------------------------------------------------------

TP.tag.ComputedTag.Type.defineMethod('tagCompile',
function(aRequest) {

    /**
     * @method tagCompile
     * @summary Convert instances of the tag into their HTML representation.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     * @returns {Element} The new element.
     */

    var str,
        elem,
        newElem;

    if (!TP.isElement(elem = aRequest.at('node'))) {
        return;
    }

    if (TP.sys.hasFeature('lama')) {
        str = '<a onclick="TP.bySystemId(\'LamaConsoleService\')' +
                '.sendConsoleRequest(\':inspect ' +
                this.getID().replace(':', '.') + '.Type.tagCompile' +
                '\'); return false;" href="#" tibet:tag="' +
                this.getCanonicalName() + '" tibet:no-rewrite="true">' +
                '&lt;' + this.getCanonicalName() + '/&gt;' +
                '</a>';
    } else {
        str = '<a onclick="alert(\'Edit ' + this.getID() +
                '.Type.tagCompile.\')" href="#" tibet:tag="' +
                this.getCanonicalName() + '" tibet:no-rewrite="true">' +
                '&lt;' + this.getCanonicalName() + '/&gt;' +
                '</a>';
    }

    newElem = TP.xhtmlnode(str);

    //  Note here how we return the *result* of this method due to node
    //  importing, etc.
    newElem = TP.elementReplaceWith(elem, newElem);

    TP.elementSetGenerator(newElem);

    return newElem;
});

//  ========================================================================
//  TP.tag.TemplatedTag
//  ========================================================================

/**
 * @type {TP.tag.TemplatedTag}
 * @summary A common supertype for templated UI tags. This type provides an
 * inheritance root for templated tags by mixing in TemplatedNode properly.
 */

TP.tag.CustomTag.defineSubtype('TP.tag.TemplatedTag');

//  Mix in templating behavior, resolving computation in favor of templating.
TP.tag.TemplatedTag.addTraits(TP.dom.TemplatedNode);

TP.tag.TemplatedTag.Type.resolveTrait('tagCompile', TP.dom.TemplatedNode);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.tag.TemplatedTag.Type.defineAttribute('registeredForURIUpdates');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tag.TemplatedTag.Type.defineMethod('construct',
function(nodeSpec, varargs) {

    /**
     * @method construct
     * @summary Constructs a new instance to wrap a native node. The native node
     *     may have been provided or a String could have been provided. By far
     *     the most common usage is construction of a wrapper around an existing
     *     node.
     * @param {Node|URI|String|TP.dom.Node} nodeSpec Some suitable object to
     *     construct a source node. See type discussion above. Can also be null.
     * @param {arguments} varargs Optional additional arguments for the
     *     constructor.
     * @returns {TP.tag.TemplatedTag} A new instance.
     */

    var retVal,

        elem,
        uri;

    //  Call up to get the instance of this type wrapping our native node.
    retVal = this.callNextMethod();

    //  Grab the native node
    elem = retVal.getNativeNode();

    //  If we haven't set up this type to register for updates coming from it's
    //  URI, do so now.
    if (TP.notTrue(this.get('registeredForURIUpdates'))) {

        uri = this.getResourceURI(
                        'template',
                        TP.elementGetAttribute(elem, 'tibet:mime', true));

        if (TP.isURI(uri)) {
            this.observe(uri, 'TP.sig.ValueChange');
            uri.watch();
        }

        //  Set the flag so that we don't do this again.
        this.set('registeredForURIUpdates', true);
    }

    return retVal;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.tag.TemplatedTag.Inst.defineMethod('getSerializationTraversal',
function() {

    /**
     * @method getSerializationTraversal
     * @summary Returns a constant, either TP.DESCEND or TP.CONTINUE, that
     *     determines whether serialization will descend into descendant nodes
     *     of this node or not. If TP.CONTINUE is returned that means that only
     *     select descendants, as determined by this type's
     *     getDescendantsForSerialization method will be serialized.
     * @returns {Number} Either TP.DESCEND or TP.CONTINUE.
     */

    var docSourceLoc,
        docSourceURI,

        templateSourceURI;

    docSourceLoc = this.getDocument().getDocumentElement().
                                        getAttribute(TP.GLOBAL_DOCID_ATTR);

    if (TP.isURIString(docSourceLoc, true)) {
        docSourceURI = TP.uc(docSourceLoc).getPrimaryURI();
        templateSourceURI = this.getType().getResourceURI('template');

        if (TP.equal(docSourceURI, templateSourceURI)) {
            return TP.DESCEND;
        }
    }

    return this.callNextMethod();
});

//  ========================================================================
//  TP.tibet.app
//  ========================================================================

/**
 * @type {TP.tibet.app}
 * @summary TP.tibet.app represents the 'non-Lama' application tag. It is
 *     usually generated by the TP.tibet.root tag type if Lama is not loaded
 *     or disabled.
 */

//  ------------------------------------------------------------------------

TP.tag.ComputedTag.defineSubtype('tibet:app');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  This tag has no associated CSS. Note how this property is TYPE_LOCAL, by
//  design.
TP.tibet.app.defineAttribute('styleURI', TP.NO_RESULT);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tibet.app.Type.defineMethod('tagAttachDOM',
function(aRequest) {

    /**
     * @method tagAttachDOM
     * @summary Sets up runtime machinery for the element in aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    //  TODO: The UICANVAS should be set to be the UIROOT here.

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.tibet.app.Type.defineMethod('tagCompile',
function(aRequest) {

    /**
     * @method tagCompile
     * @summary Convert the receiver into a format suitable for inclusion in a
     *     markup DOM.
     * @description In this type, this method generates either a 'tibet:app' or
     *     a 'tibet:lama' tag, depending on whether or not the current boot
     *     environment is set to 'development' or not.
     * @param {TP.sig.ShellRequest} aRequest The request containing command
     *     input for the shell.
     * @returns {Element} The new element.
     */

    var elem,
        name,
        tag,
        newElem;

    //  Make sure that we have an element to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        return;
    }

    name = TP.sys.cfg('project.name');
    tag = TP.sys.cfg('tibet.apptag') || 'APP.' + name + ':app';

    newElem = TP.xhtmlnode(
    '<div tibet:tag="tibet:app" class="tag-defaulted">' +
        '<h1 class="tag-defaulted">' +
            'Application tag for ' + name + ' failed to render. ' +
            'Defaulted to &lt;tibet:app/&gt;' +
        '</h1>' +

        '<p>' +
        'If you are seeing this error message it usually means either:<br/><br/>' +
        '- The tag specified for your application (' + tag + ') is missing; or<br/>' +
        '- <b>The specified tag type has a syntax error or failed to load.</b>' +
        '</p>' +

        '<p>Source for that tag would typically be found in:</p>' +

        '<p><code>src/tags/' + tag.replace(/:/g, '.') + '.js</code></p>' +

        '<p>' +
        'Check that file for syntax errors if it is the right file, or check' +
        ' your tibet.apptag settings to ensure the right tag type is being' +
        ' specified along with your ~app_cfg/main.xml package to ensure you' +
        ' are loading it.' +
        '</p>' +

        '<p class="hint">' +
        'Hint: You can use Alt-Up to toggle the boot log/console.' +
        '</p>' +
    '</div>');

    //  Note here how we return the *result* of this method due to node
    //  importing, etc.
    newElem = TP.elementReplaceWith(elem, newElem);

    TP.elementSetGenerator(newElem);

    return newElem;
});

//  ========================================================================
//  TP.tibet.root
//  ========================================================================

/**
 * @type {TP.tibet.root}
 * @summary TP.tibet.root represents the tag placed in 'UIROOT' pages (i.e. the
 *     root page of the system). Depending on whether the Lama project is
 *     loaded/disabled, this tag will generate either a 'tibet:app' tag or a
 *     'tibet:lama' tag to handle the main UI.
 */

//  ------------------------------------------------------------------------

TP.tag.ComputedTag.defineSubtype('tibet:root');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  This tag has no associated CSS. Note how these properties are TYPE_LOCAL, by
//  design.
TP.tibet.root.defineAttribute('styleURI', TP.NO_RESULT);
TP.tibet.root.defineAttribute('themeURI', TP.NO_RESULT);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tibet.root.Type.defineMethod('computeAppTagTypeName',
function(wantsLama) {

    /**
     * @method computeAppTagTypeName
     * @summary Computes the current tag type name by using system config
     *     information to try to find a type and, if that can't found, falling
     *     back to the 'tibet:lama' or 'tibet:app' tag.
     * @param {Boolean} wantsLama Whether or not to include the 'tibet:lama'
     *     tag in the result output. The default is true.
     * @returns {String} The name of the type to use as the 'app tag'.
     */

    var cfg,
        opts,

        lamaOk,

        type,
        name;

    //  Build up a list of tag names to check. We'll use the first one we have a
    //  matching type for.
    opts = TP.ac();

    cfg = TP.sys.cfg('tibet.apptag');
    if (TP.notEmpty(cfg)) {
        opts.push(cfg);
    }

    cfg = TP.sys.cfg('project.name');
    if (TP.notEmpty(cfg)) {
        opts.push(cfg + ':app');
    }

    lamaOk = TP.ifInvalid(wantsLama, true);

    if (TP.sys.hasFeature('lama') && lamaOk) {
        opts.unshift('tibet:lama');
    }

    //  When in doubt at least produce something :)
    opts.push('tibet:app');

    //  Keep string for error reporting.
    cfg = opts.join();

    while (TP.notValid(type) && TP.notEmpty(name = opts.shift())) {
        type = TP.sys.getTypeByName(name, false);
    }

    if (!TP.isType(type)) {
        this.raise('TypeNotFound', 'Expected one of: ' + cfg);
        return null;
    }

    return name;
});

//  ------------------------------------------------------------------------

TP.tibet.root.Type.defineMethod('tagAttachComplete',
function(aRequest) {

    /**
     * @method tagAttachComplete
     * @summary Sets up runtime machinery for the element in aRequest.
     * @description In this type, if the Lama is not 'active' this method
     *     loads the URL pointed to by the TP.sys.getHomeURL method into the
     *     UIROOT frame. If a value hasn't been configured, then the standard
     *     system blank page is loaded into that frame.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var elem,
        elemWin,
        request,
        homeURL;

    //  If the Lama is configured to be on (and we've actually loaded the
    //  Lama code), then exit here - the Lama does some special things to
    //  the 'tibet:root' tag.
    if (TP.sys.hasFeature('lama')) {
        return;
    }

    //  Make sure that we have an element to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        return;
    }

    //  Make sure that we have a Window to draw into.
    if (!TP.isWindow(elemWin = TP.nodeGetWindow(elem))) {
        return;
    }

    //  Capture the actual home page URL for loading which means passing true
    //  here to force session variables to be checked.
    homeURL = TP.uc(TP.sys.getHomeURL(true));

    request = TP.request();
    request.atPut(TP.ONLOAD,
                function(aDocument) {
                    //  Signal we are starting. This provides a hook for
                    //  extensions etc. to tap into the startup sequence before
                    //  routing or other behaviors but after we're sure the UI
                    //  is finalized.
                    TP.signal('TP.sys', 'AppWillStart');

                    //  Signal actual start. The default handler on Application
                    //  will invoke the start() method in response to this
                    //  signal.
                    TP.signal('TP.sys', 'AppStart');
                });

    //  We load the URL associated with the home URL, but we only trigger this
    //  *after* we've finished loading the document containing this tag.
    TP.wrap(elemWin).queueAfterNextReload(
                function() {
                    TP.wrap(elemWin).setContent(homeURL, request);
                });

    return;
});

//  ------------------------------------------------------------------------

TP.tibet.root.Type.defineMethod('tagCompile',
function(aRequest) {

    /**
     * @method tagCompile
     * @summary Convert the receiver into a format suitable for inclusion in a
     *     markup DOM.
     * @description In this type, if the Lama is 'active' (not just loaded but
     *     active) this method converts the receiver (a 'tibet:root' tag) into a
     *     'tibet:lama' tag.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     * @returns {Element} The new element.
     */


    var elem,
        newElem;

    //  Make sure that we have an element to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        return;
    }

    //  If the Lama is configured to be on (and we've actually loaded the
    //  Lama code), then turn the receiver into a 'tibet:lama' tag.
    if (TP.sys.hasFeature('lama')) {

        newElem = TP.elementBecome(elem, 'tibet:lama');

        //  We're changing out the tag entirely, so remove any evidence via the
        //  tibet:tag reference.
        TP.elementRemoveAttribute(newElem, 'tibet:tag', true);

        TP.elementSetGenerator(newElem);

        return newElem;
    }

    elem = TP.nodeCloneNode(elem);

    TP.elementSetGenerator(elem);

    return elem;
});

//  ========================================================================
//  TP.tag.InfoTag
//  ========================================================================

/**
 * @type {TP.tag.InfoTag}
 * @summary TP.tag.InfoTag is the supertype for all 'info' elements in
 *     the TIBET framework. Examples of info elements are acl:info, bind:info,
 *     drag:info, ev:info, and similar items which provide processing
 *     information but don't typically perform direct action in the way that a
 *     TP.tag.ActionTag might.
 */
//  ------------------------------------------------------------------------

TP.tag.CustomTag.defineSubtype('InfoTag');

//  Can't construct concrete instances of this type.
TP.tag.InfoTag.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  This tag has no associated CSS. Note how these properties are *not*
//  TYPE_LOCAL, by design.
TP.tag.InfoTag.Type.defineAttribute('styleURI', TP.NO_RESULT);
TP.tag.InfoTag.Type.defineAttribute('themeURI', TP.NO_RESULT);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tag.InfoTag.Type.defineMethod('cmdAddContent',
function(aRequest) {

    /**
     * @inheritDoc
     */

    this.raise('TP.sig.InvalidSink');

    return;
});

//  ------------------------------------------------------------------------

TP.tag.InfoTag.Type.defineMethod('cmdFilterInput',
function(aRequest) {

    /**
     * @inheritDoc
     */

    this.raise('TP.sig.InvalidFilter');

    return;
});

//  ------------------------------------------------------------------------

TP.tag.InfoTag.Type.defineMethod('cmdGetContent',
function(aRequest) {

    /**
     * @inheritDoc
     */

    this.raise('TP.sig.InvalidSource');

    return;
});

//  ------------------------------------------------------------------------

TP.tag.InfoTag.Type.defineMethod('cmdRunContent',
function(aRequest) {

    /**
     * @method cmdRunContent
     * @summary Runs the receiver, effectively invoking its action.
     * @description This method is invoked any time a tag is being run as part
     *     of the processing of an enclosing tsh:script, which happens most
     *     often when the tag is being run interactively. When being run
     *     interactively the tag will execute when no ev:event is defined which
     *     implies processing should wait for that event.
     * @param {TP.sig.ShellRequest} aRequest The request containing command
     *     input for the shell.
     * @returns {Object} A value which controls how the outer TSH processing
     *     loop should continue. TP.CONTINUE and TP.BREAK are common values.
     */

    var interactive,
        node,
        str;

    interactive = TP.ifKeyInvalid(aRequest, 'cmdBuildGUI', false);
    if (interactive) {
        node = aRequest.at('cmdNode');
        if (TP.notEmpty(TP.elementGetAttribute(node, 'ev:event', true))) {
            str = TP.wrap(node).asString();

            //  Output with asIs false will echo the tag for display.
            aRequest.stdout(str,
                            TP.hc('cmdBox', false, 'cmdAsIs', false,
                                'cmdAppend', true, 'cmdEcho', true));

            //  Have to output the action to get it into the DOM for
            //  awakening etc, otherwise it can't register/run.
            aRequest.stdout(str,
                            TP.hc('cmdBox', false, 'cmdAsIs', true,
                                'cmdEcho', true));

            aRequest.set('result', str);
            aRequest.complete();

            return TP.CONTINUE;
        }
    }

    return this.tshExecute(aRequest);
});

//  ------------------------------------------------------------------------

TP.tag.InfoTag.Type.defineMethod('cmdSetContent',
function(aRequest) {

    /**
     * @inheritDoc
     */

    this.raise('TP.sig.InvalidSink');

    return;
});

//  ------------------------------------------------------------------------

TP.tag.InfoTag.Type.defineMethod('cmdTransformInput',
function(aRequest) {

    /**
     * @inheritDoc
     */

    this.raise('TP.sig.InvalidTransform');

    return;
});

//  ------------------------------------------------------------------------

TP.tag.InfoTag.Type.defineMethod('tagCompile',
function(aRequest) {

    /**
     * @method tagCompile
     * @summary Convert the receiver into a format suitable for inclusion in a
     *     markup DOM.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     * @returns {Element} The new element.
     */

    var elem;

    //  Default for info tags is to not be transformed, but to have a
    //  'tibet-info' CSS class added to their markup.

    elem = aRequest.at('node');
    TP.elementAddClass(elem, 'tibet-info');

    elem = TP.nodeCloneNode(elem);

    TP.elementSetGenerator(elem);

    return elem;
});

//  ========================================================================
//  TP.tag.ActionTag
//  ========================================================================

/**
 * @type {TP.tag.ActionTag}
 * @summary TP.tag.ActionTag is the supertype for all action elements
 *     in the TIBET framework. Action nodes are found most typically in
 *     association with XControls and the various TIBET shells where they serve
 *     as "xml macros" for various JavaScript operations or commands.
 * @description An action element is essentially a "macro" encoded in tag form.
 *     The XForms specification defines a number of these tags and TIBET extends
 *     this concept as part of the TIBET Shell (TSH).
 *
 *     Because of their use in visual markup as well as TIBET scripts action
 *     tags provide both a signaling interface and a direct invocation
 *     interface. The signaling interface simply defers to the direct invocation
 *     approach, so you'll normally just implement a tshExecute() method on your
 *     action element with a request object as the first parameter. Note that
 *     like much of TIBET's other APIs a request in this context can be a
 *     TP.sig.Request or a simple hash of parameter values.
 */
//  ------------------------------------------------------------------------

TP.tag.CustomTag.defineSubtype('ActionTag');

//  can't construct concrete instances of this
TP.tag.ActionTag.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  This tag has no associated CSS. Note how these properties are *not*
//  TYPE_LOCAL, by design.
TP.tag.ActionTag.Type.defineAttribute('styleURI', TP.NO_RESULT);
TP.tag.ActionTag.Type.defineAttribute('themeURI', TP.NO_RESULT);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  the default request type to use for construction of a request
TP.tag.ActionTag.Type.defineAttribute('requestType', 'TP.sig.Request');

//  an optional name which refines the request by altering its name
TP.tag.ActionTag.Type.defineAttribute('requestName');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tag.ActionTag.Type.defineMethod('canAct',
function(aNode) {

    /**
     * @method canAct
     * @summary Returns true if the node provided is 'actionable' based on ACL
     *     permissions for the current user.
     * @param {Node} aNode A native node to test for ACL restrictions.
     * @returns {Boolean} True if the action can proceed.
     */

    var actionable,
        attrs,

        rkeys,
        ekeys,

        len,
        i,
        attr;

    //  presume true
    actionable = true;

    //  one interesting thing here is that we tie action execution into ACL
    //  checks, restricting script/command access based on ACL keys
    if (TP.notEmpty(attrs = TP.elementGetAttributeNodes(aNode, 'acl:*'))) {
        rkeys = TP.sys.getRealUser().getAccessKeys();
        ekeys = TP.sys.getEffectiveUser().getAccessKeys();

        len = attrs.getSize();

        for (i = 0; i < len; i++) {
            attr = attrs[i];
            switch (attr.name) {
                case 'acl:if_real':

                    //  only if rkeys contains this key
                    actionable = false;
                    if (rkeys.containsAny(attr.value.split(' '))) {
                        actionable = true;
                    }

                    break;

                case 'acl:if_effective':

                    //  only if ekeys contains this key
                    actionable = false;
                    if (ekeys.containsAny(attr.value.split(' '))) {
                        actionable = true;
                    }

                    break;

                case 'acl:unless_real':

                    //  unless rkeys contains these keys
                    if (rkeys.containsAny(attr.value.split(' '))) {
                        actionable = false;
                    }

                    break;

                case 'acl:unless_effective':

                    //  unless ekeys contains these keys
                    if (ekeys.containsAny(attr.value.split(' '))) {
                        actionable = false;
                    }

                    break;

                default:

                    actionable = false;
                    break;
            }
        }
    }

    return actionable;
});

//  ------------------------------------------------------------------------

TP.tag.ActionTag.Type.defineMethod('cmdAddContent',
function(aRequest) {

    /**
     * @inheritDoc
     */

    this.raise('TP.sig.InvalidSink');

    return;
});

//  ------------------------------------------------------------------------

TP.tag.ActionTag.Type.defineMethod('cmdFilterInput',
function(aRequest) {

    /**
     * @inheritDoc
     */

    this.raise('TP.sig.InvalidFilter');

    return;
});

//  ------------------------------------------------------------------------

TP.tag.ActionTag.Type.defineMethod('cmdGetContent',
function(aRequest) {

    /**
     * @inheritDoc
     */

    this.raise('TP.sig.InvalidSource');

    return;
});

//  ------------------------------------------------------------------------

TP.tag.ActionTag.Type.defineMethod('cmdRunContent',
function(aRequest) {

    /**
     * @method cmdRunContent
     * @summary Runs the receiver, effectively invoking its action.
     * @description This method is invoked any time a tag is being run as part
     *     of the processing of an enclosing tsh:script, which happens most
     *     often when the tag is being run interactively. When being run
     *     interactively the tag will execute when no ev:event is defined which
     *     implies processing should wait for that event.
     * @param {TP.sig.ShellRequest} aRequest The request containing command
     *     input for the shell.
     * @returns {Object} A value which controls how the outer TSH processing
     *     loop should continue. TP.CONTINUE and TP.BREAK are common values.
     */

    var interactive,
        node,
        str;

    interactive = TP.ifKeyInvalid(aRequest, 'cmdBuildGUI', false);
    if (interactive) {
        node = aRequest.at('cmdNode');
        if (TP.notEmpty(TP.elementGetAttribute(node, 'ev:event', true))) {
            str = TP.wrap(node).asString();

            //  Output with asIs false will echo the tag for display.
            aRequest.stdout(str,
                        TP.hc('cmdBox', false, 'cmdAsIs', false,
                        'cmdAppend', true, 'cmdEcho', true));

            //  Have to output the action to get it into the DOM for
            //  awakening etc, otherwise it can't register/run.
            aRequest.stdout(str,
                        TP.hc('cmdBox', false, 'cmdAsIs', true,
                            'cmdEcho', true));

            aRequest.set('result', str);
            aRequest.complete();

            return TP.CONTINUE;
        }
    }

    return this.tshExecute(aRequest);
});

//  ------------------------------------------------------------------------

TP.tag.ActionTag.Type.defineMethod('cmdSetContent',
function(aRequest) {

    /**
     * @inheritDoc
     */

    this.raise('TP.sig.InvalidSink');

    return;
});

//  ------------------------------------------------------------------------

TP.tag.ActionTag.Type.defineMethod('cmdTransformInput',
function(aRequest) {

    /**
     * @inheritDoc
     */

    this.raise('TP.sig.InvalidTransform');

    return;
});

//  ------------------------------------------------------------------------

TP.tag.ActionTag.Type.defineMethod('getActionInput',
function(aRequest) {

    /**
     * @method getActionInput
     * @summary Returns either the request's standard input or the receiver's
     *     'primary argument'.
     * @param {TP.sig.Request} aRequest The request to check for stdin.
     * @returns {Object|undefined} The input data.
     */

    var input;

    if (!TP.isNode(aRequest.at('cmdNode'))) {
        return;
    }

    if (TP.notEmpty(input = aRequest.stdin())) {
        //  stdin is always an array, so we can just return it
        return input;
    } else {
        input = this.getPrimaryArgument(aRequest);
    }

    if (TP.isValid(input)) {
        input = TP.ac(input);
    }

    return input;
});

//  ------------------------------------------------------------------------

TP.tag.ActionTag.Type.defineMethod('getActionParam',
function(aRequest, parameterName) {

    /**
     * @method getActionParam
     * @summary Checks the receiver for child <param> tags and returns the
     *     value associated with the named parameter if found.
     * @param {TP.sig.Request} aRequest The request being processed.
     * @param {String} parameterName The name of the parameter to find.
     * @returns {String|undefined} The parameter value, if any.
     */

    var shell;

    shell = aRequest.at('cmdShell');
    if (TP.notValid(shell)) {
        this.raise('TP.sig.InvalidRequest',
                    'No cmdShell in request.');

        return;
    }

    return shell.getParam(aRequest, parameterName);
});

//  ------------------------------------------------------------------------

TP.tag.ActionTag.Type.defineMethod('getPrimaryArgument',
function(aRequest) {

    /**
     * @method getPrimaryArgument
     * @summary Returns the value of the receiver's primary argument, which
     *     must be named by the return value of getPrimaryArgumentName(). By
     *     default action tags return null here due to there being no default
     *     for getPrimaryArgumentName. Overriding that method to provide a valid
     *     name is usually sufficient.
     * @param {TP.sig.Request} aRequest The request being processed.
     * @returns {Object|undefined} The argument data.
     */

    var name,
        shell;

    if (TP.isEmpty(name = this.getPrimaryArgumentName())) {
        return;
    }

    shell = aRequest.at('cmdShell');
    if (TP.isValid(shell)) {
        //  NB: We supply 'null' here as the default value
        return shell.getArgument(aRequest, name, null, true);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.tag.ActionTag.Type.defineMethod('getPrimaryArgumentName',
function() {

    /**
     * @method getPrimaryArgumentName
     * @summary Returns the primary argument name, which by default is null.
     *     For action tags this method typically must be overridden or the
     *     getPrimaryArgument() and getActionInput() calls will typically fail
     *     to return useful results.
     * @returns {undefined} The argument name.
     */

    return;
});

//  ------------------------------------------------------------------------

TP.tag.ActionTag.Type.defineMethod('tagCompile',
function(aRequest) {

    /**
     * @method tagCompile
     * @summary Convert the receiver into a format suitable for inclusion in a
     *     markup DOM.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     * @returns {Element} The new element.
     */

    var elem;

    //  Default for action tags is to not be transformed, but to have a
    //  'tibet-action' CSS class added to their markup.

    elem = aRequest.at('node');
    TP.elementAddClass(elem, 'tibet-action');

    elem = TP.nodeCloneNode(elem);

    TP.elementSetGenerator(elem);

    return elem;
});

//  ------------------------------------------------------------------------

TP.tag.ActionTag.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.ShellRequest} aRequest The request containing command
     *     input for the shell.
     * @returns {Number} A TSH shell loop control constant which controls how
     *     the outer TSH processing loop should continue. Common values are
     *     TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    return aRequest.complete();
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.tag.ActionTag.Inst.defineMethod('act',
function(aSignal) {

    /**
     * @method act
     * @summary Performs the action the receiver is responsible for. This
     *     method should be overridden in subtypes to provide concrete behavior.
     * @description The act method is typically invoked indirectly by the handle
     *     functionality found in this type, however you can invoke it directly
     *     when you've got a handle to a specific action element. When invoked
     *     via handle the signal which is currently being processed is provided
     *     as the first argument.
     * @param {TP.sig.Signal} [aSignal] The signal instance which triggered this
     *     activity. Only valid when being invoked in response to a handle call.
     * @returns {TP.tag.ActionTag} The receiver.
     */

    var request,
        shell;

    //  check with the type to see if we can run
    if (TP.notTrue(this.getType().canAct(this.getNativeNode()))) {
        return this;
    }

    request = this.constructActRequest(aSignal);

    shell = TP.shell.TSH.getDefaultInstance();
    shell[TP.composeHandlerName('ShellRequest')](request);

    return this;
});

//  ------------------------------------------------------------------------

TP.tag.ActionTag.Inst.defineMethod('constructActRequest',
function(aSignal) {

    /**
     * @method constructActRequest
     * @summary Returns a TP.sig.Request subtype instance suitable for the
     *     receiver's requirements. This is typically a TP.sig.ShellRequest so
     *     the TIBET Shell can be used to process/execute the tag.
     * @param {TP.sig.Signal|TP.core.Hash} [aSignal] A signal or hash containing
     *     parameter data. Note that this parameter is optional and is only used
     *     if the receiver is being invoked due to a handle call.
     * @returns {TP.sig.Request} A proper TP.sig.Request for the action.
     */

    var request;

    request = TP.sig.ShellRequest.construct(
                    TP.hc('cmdLiteral', true,
                            'cmdNode', this.getNativeNode(),
                            'cmdExecute', true,
                            'cmdPhases', 'Execute'
                    ));

    if (TP.isKindOf(aSignal, TP.sig.Signal)) {
        request.atPut('cmdTrigger', aSignal);
        request.atPut(TP.STDIN, TP.ac(aSignal.get('payload')));
    }

    return request;
});

//  ------------------------------------------------------------------------

TP.tag.ActionTag.Inst.defineMethod('getActionParam',
function(aRequest, parameterName) {

    /**
     * @method getActionParam
     * @summary Checks the receiver for child <param> tags and returns the
     *     value associated with the named parameter if found.
     * @param {TP.sig.Request} aRequest The request being processed.
     * @param {String} parameterName The name of the parameter to find.
     * @returns {String} The parameter value, if any.
     */

    return this.getType().getActionParam(aRequest, parameterName);
});

//  ------------------------------------------------------------------------

TP.tag.ActionTag.Inst.defineMethod('getRequestName',
function() {

    /**
     * @method getRequestName
     * @summary Returns the request name used for this service when no override
     *     has been given on the element.
     * @returns {String} A specific request name.
     */

    return this.getType().get('requestName');
});

//  ------------------------------------------------------------------------

TP.tag.ActionTag.Inst.defineMethod('getRequestType',
function() {

    /**
     * @method getRequestType
     * @summary Returns the request type used for this service when no override
     *     has been given on the element.
     * @returns {TP.sig.Request} A specific request type.
     */

    var name,
        type;

    name = this.getType().get('requestType') || 'TP.sig.Request';

    type = TP.sys.getTypeByName(name);
    if (TP.notValid(type)) {
        this.raise('TP.sig.InvalidType',
                    'Request type not found for: ' + this.asString());

        type = TP.sig.Request;
    }

    return type;
});

//  ------------------------------------------------------------------------

TP.tag.ActionTag.Inst.defineMethod('getDownstreamSegment',
function() {

    /**
     * @method getUpstreamSegment
     * @summary Returns the 'downstream' segment for this action - that is, any
     *     following action element in a command sequence.
     * @returns {TP.tag.ActionTag|null} The downstream segment of this
     *     action or null if it's the last segment.
     */

    var retVal;

    retVal = this.detectSibling(
                function(aTPNode) {
                    var node;

                    node = TP.unwrap(aTPNode);
                    if (TP.isElement(node) &&
                        TP.elementGetLocalName(node) === 'cmd') {
                        return true;
                    }

                    return false;
                },
                TP.NEXT);

    return retVal;
});

//  ------------------------------------------------------------------------

TP.tag.ActionTag.Inst.defineMethod('getUpstreamSegment',
function() {

    /**
     * @method getUpstreamSegment
     * @summary Returns the 'upstream' segment for this action - that is, any
     *     preceding action element in a command sequence.
     * @returns {TP.tag.ActionTag|null} The upstream segment of this
     *     action or null if it's the first segment.
     */

    var retVal;

    retVal = this.detectSibling(
                function(aTPNode) {
                    var node;

                    node = TP.unwrap(aTPNode);
                    if (TP.isElement(node) &&
                        TP.elementGetLocalName(node) === 'cmd') {
                        return true;
                    }

                    return false;
                },
                TP.PREVIOUS);

    return retVal;
});

//  ------------------------------------------------------------------------

TP.tag.ActionTag.Inst.defineMethod('getRedirectionType',
function() {

    /**
     * @method getRedirectionType
     * @summary Returns what kind of redirection type, if any, the receiver
     *     has.
     * @returns {String} One of the following: TP.ADD, TP.GET, TP.SET,
     *     TP.FILTER, TP.TRANSFORM (or TP.NONE if there is no redirection)
     */

    var pipe;

    pipe = this.getAttribute('tsh:pipe', true);

    if (TP.TSH_ADD_PIPES.contains(pipe)) {
        return TP.ADD;
    } else if (TP.TSH_GET_PIPES.contains(pipe)) {
        return TP.GET;
    } else if (TP.TSH_SET_PIPES.contains(pipe)) {
        return TP.SET;
    } else if (TP.TSH_FILTER_PIPES.contains(pipe)) {
        return TP.FILTER;
    } else if (TP.TSH_TRANSFORM_PIPES.contains(pipe)) {
        return TP.TRANSFORM;
    }

    return TP.NONE;
});

//  ------------------------------------------------------------------------

TP.tag.ActionTag.Inst.defineMethod('isLastSegment',
function() {

    /**
     * @method isLastSegment
     * @summary Returns whether or not this node is the last 'segment' of
     *     commands in a script.
     * @returns {Boolean} Whether or not this is the 'last segment' of a script.
     */

    return TP.notValid(this.getDownstreamSegment());
});

//  ------------------------------------------------------------------------

TP.tag.ActionTag.Inst.defineHandler('Signal',
function(aSignal) {

    /**
     * @method handleSignal
     * @summary Responds to an inbound signal by running the receiver's
     *     action(s) via the act() method.
     * @param {TP.sig.Signal} aSignal The signal instance which triggered this
     *     call.
     * @returns {TP.tag.ActionTag} The receiver.
     */

    var sig;

    sig = this.signal('TP.sig.WillRun');
    if (sig.shouldPrevent()) {
        return this;
    }

    try {
        this.act(aSignal);
    } finally {
        this.signal('TP.sig.DidRun');
    }

    return this;
});

//  ========================================================================
//  TP.dom.PipeSegmentElementNode
//  ========================================================================

/**
 * @type {TP.dom.PipeSegmentElementNode}
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('dom.PipeSegmentElementNode');

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation
TP.dom.PipeSegmentElementNode.isAbstract(true);

//  ------------------------------------------------------------------------

TP.dom.PipeSegmentElementNode.Type.defineMethod('cmdFilterInput',
function(aRequest) {

    /**
     * @method cmdFilterInput
     * @summary Run when the receiver is being used in a filtering pipe.
     * @param {TP.sig.Request} aRequest The request to process.
     */

    this.processInput(aRequest, 'filterInput');

    return;
});

//  ------------------------------------------------------------------------

TP.dom.PipeSegmentElementNode.Type.defineMethod('cmdTransformInput',
function(aRequest) {

    /**
     * @method cmdTransformInput
     * @summary Run when the receiver is being used in a transforming pipe.
     * @param {TP.sig.Request} aRequest The request to process.
     */

    this.processInput(aRequest, 'transformInput');

    return;
});

//  ------------------------------------------------------------------------

TP.dom.PipeSegmentElementNode.Type.defineMethod('filterInput',
function(anInput, cmdNode, aRequest) {

    /**
     * @method filterInput
     * @summary Filters an input object using information from the request
     *     provided. This method must be overridden by subtypes to avoid having
     *     an TP.sig.InvalidFilter exception raised.
     * @param {Object} anInput The object to test/filter.
     * @param {Node} cmdNode The original filtration node.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @exception TP.sig.InvalidFilter
     * @returns {Boolean} True if the object should remain in the output stream,
     *     false otherwise.
     */

    this.raise('TP.sig.InvalidFilter');

    return false;
});

//  ------------------------------------------------------------------------

TP.dom.PipeSegmentElementNode.Type.defineMethod('getDefaultAction',
function(aRequest) {

    /**
     * @method getDefaultAction
     * @summary Returns the proper action name to use based on the pipe symbol
     *     being processed.
     * @param {TP.sig.Request} aRequest The request to process.
     * @returns {String|undefined} 'filterInput' or 'transformInput'.
     */

    var node,
        pipe;

    if (!TP.isElement(node = aRequest.at('cmdNode'))) {
        return;
    }

    pipe = TP.elementGetAttribute(node, 'tsh:pipe', true);
    if (/\?/.test(pipe)) {
        return 'filterInput';
    }

    return 'transformInput';
});

//  ------------------------------------------------------------------------

TP.dom.PipeSegmentElementNode.Type.defineMethod('processInput',
function(aRequest, functionName) {

    /**
     * @method processInput
     * @summary Performs common processing of the input in terms of setting up
     *     a loop for iterating on splatted input, providing the proper
     *     collect/select branching for filtering vs. transforming, etc. This
     *     method is typically invoked for you and will call either filter() or
     *     transform() to do the real work of the receiving tag.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @param {String|undefined} functionName 'filterInput' or 'transformInput'.
     */

    var node,
        input,

        len,
        i,
        content,
        msg,
        result;

    //  Make sure that we have a node to work from.
    if (!TP.isNode(node = aRequest.at('cmdNode'))) {
        msg = 'No action node.';
        aRequest.fail(msg);

        return;
    }

    //  Check input, and whether it's required.
    if (TP.notValid(input = this.getActionInput(aRequest))) {
        if (this.shouldFailOnEmptyInput()) {
            msg = 'No action input.';
            aRequest.fail(msg);

            return;
        } else {
            //  Mimic stdin, which provides an Array
            input = TP.ac();
        }
    }

    len = input.getSize();
    for (i = 0; i < len; i++) {
        content = input.at(i);
        if (TP.notValid(content)) {
            continue;
        }

        //  if we're splatted then the return/output variable is expected to
        //  be a collection rather than a single item
        if (aRequest.at('cmdIterate')) {
            if (TP.isCollection(content)) {
                switch (functionName) {
                    case 'filterInput':

                        //  even though the filter call can process things
                        //  in a loop we interpret the splat as a directive
                        //  to return an array of results rather than a
                        //  single string so we loop here
                        /* eslint-disable no-loop-func */
                        result = content.select(
                            function(item) {

                                return this.filterInput(item,
                                                        node,
                                                        aRequest);
                            }.bind(this));
                        /* eslint-enable no-loop-func */

                        break;

                    case 'transformInput':

                        //  even though the transform call can process
                        //  things in a loop we interpret the splat as a
                        //  directive to return an array of results rather
                        //  than a single string so we loop here
                        /* eslint-disable no-loop-func */
                        result = content.collect(
                            function(item) {

                                return this.transformInput(item,
                                                            node,
                                                            aRequest);
                            }.bind(this));
                        /* eslint-enable no-loop-func */

                        break;

                    default:

                        msg = 'Invalid operation: ' + functionName;
                        aRequest.fail(msg);

                        return;
                }
            } else {
                TP.ifWarn() ?
                    TP.warn('Splatting with non-collection content.') : 0;

                result = TP.ac(this[functionName](content, node, aRequest));
            }
        } else {
            //  no splat, no repeat
            result = this[functionName](content, node, aRequest);
        }
    }

    if (aRequest.didFail()) {
        //  If the request failed, it will have already printed the failure code
        //  and message. Make sure that any result is appended to any output so
        //  that it doesn't replace the failure code and/or message (and prepend
        //  any result with the label 'Result: ').
        aRequest.atPut('cmdAppend', true);
        aRequest.stdout(TP.sc('Result: ') + result);
    } else {
        aRequest.complete(result);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.dom.PipeSegmentElementNode.Type.defineMethod('shouldFailOnEmptyInput',
function() {

    /**
     * @method shouldFailOnEmptyInput
     * @summary Returns true when the receiver's type will typically fail() any
     *     request which can't provide viable input data. The default is true.
     * @returns {Boolean} Whether processing should stop if input data is null
     *     or undefined.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.dom.PipeSegmentElementNode.Type.defineMethod('transformInput',
function(anInput, cmdNode, aRequest) {

    /**
     * @method transformInput
     * @summary Transforms an input object using information from the request
     *     provided. This method must be overridden by subtypes to avoid having
     *     an TP.sig.InvalidTransform exception raised.
     * @param {Object} anInput The object to transform.
     * @param {Node} cmdNode The original transformation node.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @exception TP.sig.InvalidTransform
     * @returns {undefined} The transformed input.
     */

    this.raise('TP.sig.InvalidTransform');

    return;
});

//  ------------------------------------------------------------------------

TP.dom.PipeSegmentElementNode.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Run when the receiver is executed directly, or as part of a
     *     cmdRunContent invocation from the interactive shell. This method
     *     relies on the default action implied by the current pipe symbol to
     *     dispatch to the proper cmd*Input method.
     * @param {TP.sig.Request} aRequest The request to process.
     * @returns {Number} A TSH shell loop control constant which controls how
     *     the outer TSH processing loop should continue. Common values are
     *     TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var action;

    action = this.getDefaultAction(aRequest);

    switch (action) {
        case 'filterInput':
            return this.cmdFilterInput(aRequest);
        case 'transformInput':
            return this.cmdTransformInput(aRequest);
        default:
            return TP.CONTINUE;
    }
});

//  ========================================================================
//  TP.dom.MultipliedElement
//  ========================================================================

/**
 * @type {TP.dom.MultipliedElement}
 */

//  ------------------------------------------------------------------------

TP.tag.CustomTag.defineSubtype('dom.MultipliedElement');

TP.dom.MultipliedElement.addTraits(TP.dom.ElementNode);

TP.dom.MultipliedElement.Inst.resolveTraits(
        TP.ac('serializeCloseTag', 'serializeOpenTag'),
        TP.dom.ElementNode);

TP.dom.MultipliedElement.defineAttribute('styleURI', TP.NO_RESULT);

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETLogging.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ============================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ============================================================================

/*
 * Loosely based on log4j 2.0 but adjusted to fit TIBET's unique requirements.
 *
 * Most major aspects of the log4js 2.0 architecture and API are supported
 * including Manager, Logger, Appender, Layout, Filter, Marker, and Entry types.
 * Logger additivity in log4j terms is supported for appenders and filters.
 *
 * TIBET provides two "primary" loggers, TP and APP, which make it easier to
 * differentiate between framework and application logging output. In addition
 * there are methods on both TP and APP to log at various levels which defer to
 * the default logger for each branch (TP.debug vs. APP.debug for example).
 */

/* eslint-disable no-unused-vars */
/* global $STATUS:true */
/* eslint-enable no-unused-vars */

//  ----------------------------------------------------------------------------

/**
 * The namespace responsible for all framework logging.
 */
/* eslint-disable no-unused-vars */
TP.defineNamespace('TP.log');
/* eslint-enable no-unused-vars */

//  ============================================================================
//  TP.log.Manager
//  ============================================================================

/**
 * The log manager, responsible for the overall logging subsystem.
 * @type {TP.log.Manager}
 */
TP.lang.Object.defineSubtype('log.Manager');

//  ----------------------------------------------------------------------------

/**
 * Dictionary of available loggers, by logger name. NOTE that this dictionary is
 * local to the TP.log.Manager type. No subtypes are expected for this type.
 * @type {TP.core.Hash}
 */
TP.log.Manager.defineAttribute('loggers', TP.hc());

//  ----------------------------------------------------------------------------

/**
 * The name of the root logger. This is normally stripped from any logging
 * output.
 * @type {String}
 */
TP.log.Manager.Type.defineConstant('ROOT_LOGGER_NAME', 'ROOT');

//  ----------------------------------------------------------------------------

TP.log.Manager.Type.defineMethod('exists',
function(aName) {

    /**
     * @method exists
     * @summary Returns true if the named logger exists. This method provides a
     *     way to check for existence without creating a new logger if it does
     *     not yet exist (as getLogger does).
     * @param {String} aName The logger to verify.
     * @returns {Boolean} True if the named logger exists.
     */

    var name;

    /* eslint-disable no-extra-parens */
    name = (aName === TP.log.Manager.ROOT_LOGGER_NAME) ? aName :
        aName.toLowerCase();
    /* eslint-enable no-extra-parens */

    return TP.isValid(this.loggers.at(name));
});

//  ----------------------------------------------------------------------------

TP.log.Manager.Type.defineMethod('getLogger',
function(aName) {

    /**
     * @method getLogger
     * @summary Returns the logger instance with the specified name. If the
     *     instance does not exist it is created, registered, and returned as a
     *     result of this call.
     * @param {String} aName The logger to return, or create and return.
     * @returns {TP.log.Logger} The named logger instance.
     */

    var name,
        logger;

    if (TP.isEmpty(aName)) {
        return this.raise('InvalidName');
    }

    /* eslint-disable no-extra-parens */
    name = (aName === TP.log.Manager.ROOT_LOGGER_NAME) ? aName :
        aName.toLowerCase();
    /* eslint-enable no-extra-parens */

    logger = this.loggers.at(name);

    if (TP.isValid(logger)) {
        return logger;
    }

    return this.getLoggerFactory().construct(aName);
});

//  ----------------------------------------------------------------------------

TP.log.Manager.Type.defineMethod('getLoggers',
function() {

    /**
     * @method getLoggers
     * @summary Returns the dictionary of all known loggers. The keys of this
     *     dictionary are the logger names converted to lowercase to normalize
     *     them. The entries are the logger instances themselves.
     * @returns {TP.core.Hash} The logger dictionary.
     */

    return this.loggers;
});

//  ----------------------------------------------------------------------------

TP.log.Manager.Type.defineMethod('getLoggerFactory',
function() {

    /**
     * @method getLoggerFactory
     * @summary Returns the type to use for construction of new loggers.
     * @returns {TP.log.Logger} A logger type or subtype.
     */

    return TP.sys.getTypeByName(TP.sys.cfg('log.default_factory'));
});

//  ----------------------------------------------------------------------------

TP.log.Manager.Type.defineMethod('getRootLogger',
function() {

    /**
     * @method getRootLogger
     * @summary Returns the root logger for TIBET. This logger instance is the
     *     "parent" instance for the TP and APP log instances. This logger has
     *     no name with respect to logging output.
     * @returns {TP.log.Logger} The root logger instance.
     */

    return this.getLogger(this.ROOT_LOGGER_NAME);
});

//  ----------------------------------------------------------------------------

TP.log.Manager.Type.defineMethod('initialize',
function(aName) {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     * @description For this type, this method ensures that the initial root and
     *     primary logger instances are created
     */

    //  Force construction of the root logger on startup.
    TP.log.Manager.getRootLogger();

    return;
});

//  ----------------------------------------------------------------------------

TP.log.Manager.Type.defineMethod('registerLogger',
function(aLogger) {

    /**
     * @method registerLogger
     * @summary Registers a logger instance by name.
     * @param {TP.log.Logger} aLogger The logger to register.
     * @returns {TP.meta.log.Manager} The receiver.
     */

    var name;

    name = aLogger.get('name');
    if (this.exists(name)) {
        return this.raise('DuplicateRegistration', name);
    }

    /* eslint-disable no-extra-parens */
    name = (name === TP.log.Manager.ROOT_LOGGER_NAME) ? name :
        name.toLowerCase();
    /* eslint-enable no-extra-parens */

    this.loggers.atPut(name, aLogger);

    return this;
});

//  ----------------------------------------------------------------------------

TP.log.Manager.Type.defineMethod('removeLogger',
function(aLogger) {

    /**
     * @method removeLogger
     * @summary Removes a logger instance by name.
     * @param {TP.log.Logger} aLogger The logger to remove.
     * @returns {TP.meta.log.Manager} The receiver.
     */

    var name;

    name = TP.isString(aLogger) ? aLogger : aLogger.get('name');

    //  Ignore attempts to remove the root logger.
    if (name === TP.log.Manager.ROOT_LOGGER_NAME) {
        return this;
    }

    if (this.exists(name)) {
        this.loggers.removeKey(name.toLowerCase());
    }

    return this;
});

//  ============================================================================
//  TP.log.Nestable
//  ============================================================================

/**
 * A common root type for objects in the logging system whose naming represents
 * a hierarchy of sorts. Two examples are Logger and Marker instances.
 */
TP.lang.Object.defineSubtype('log.Nestable');

//  TP.log.Nestable is an abstract supertype. You can't create instances
//  directly.
TP.log.Nestable.isAbstract(true);

//  ----------------------------------------------------------------------------

TP.log.Nestable.Type.defineMethod('getInstanceByName',
function(aName) {

    /**
     * Returns the instance whose name matches the name provided. If the
     * instance doesn't exist this method will not create it.
     * @returns {TP.log.Logger} The named instance.
     */

    TP.override();
});

//  ----------------------------------------------------------------------------
//  Nestable - Instance Definition
//  ----------------------------------------------------------------------------

/**
 * The list of ancestors for the receiver. This is computed once and cached.
 * @type {TP.log.Nestable[]}
 */
TP.log.Nestable.Inst.defineAttribute('ancestors');

//  ----------------------------------------------------------------------------

/**
 * The list of ancestor names for the receiver. This is computed once and
 * cached.
 * @type {String[]}
 */
TP.log.Nestable.Inst.defineAttribute('ancestorNames');

//  ----------------------------------------------------------------------------

/**
 * The receiver's full name including any ancestor portions.
 * @type {String}
 */
TP.log.Nestable.Inst.defineAttribute('name');

//  ----------------------------------------------------------------------------

/**
 * The parent instance for the receiver. May be null.
 * @type {TP.log.Nestable}
 */
TP.log.Nestable.Inst.defineAttribute('parent');

//  ----------------------------------------------------------------------------

TP.log.Nestable.Inst.defineMethod('getName',
function() {

    /**
     * @method getName
     * @summary Returns the name of the marker.
     * @returns {String} The marker name.
     */

    return this.name;
});

//  ----------------------------------------------------------------------------

TP.log.Nestable.Inst.defineMethod('init',
function(aName) {

    /**
     * @method init
     * @summary Initializes new instances, configuring their default values etc.
     * @param {String} aName The marker's name. May include '.' for hierarchy.
     * @returns {TP.log.Nestable} The new marker instance.
     */

    this.callNextMethod();

    this.set('name', aName);

    return this;
});

//  ----------------------------------------------------------------------------

TP.log.Nestable.Inst.defineMethod('getAncestors',
function() {

    /**
     * @method getAncestors
     * @summary Returns a list of all ancestor instances for the receiver.
     * @returns {TP.log.Nestable[]} The ancestor list.
     */

    var ancestors,
        type;

    ancestors = this.$get('ancestors');
    if (TP.isValid(ancestors)) {
        return ancestors;
    }

    type = this.getType();

    ancestors = this.getAncestorNames().map(
                            function(name) {
                                return type.getInstanceByName(name);
                            });

    this.set('ancestors', ancestors);

    return ancestors;
});

//  ----------------------------------------------------------------------------

TP.log.Nestable.Inst.defineMethod('getAncestorNames',
function() {

    /**
     * @method getAncestorNames
     * @summary Returns a list of all ancestor instance names for the receiver.
     * @returns {String[]} The ancestor name list.
     */

    var str,
        names;

    names = this.$get('ancestorNames');
    if (TP.isValid(names)) {
        return names;
    }

    str = this.get('name');
    names = TP.ac();

    while (str.indexOf('.') !== TP.NOT_FOUND) {
        str = str.slice(0, str.lastIndexOf('.'));
        names.push(str);
    }

    this.set('ancestorNames', names);

    return names;
});

//  ----------------------------------------------------------------------------

TP.log.Nestable.Inst.defineMethod('getParent',
function() {

    /**
     * @method getParent
     * @summary Returns the receiver's parent instance, the instance whose name
     *     is one "level" above the receiver.
     * @returns {TP.log.Nestable|undefined} The parent instance.
     */

    var pname,
        parent;

    if (TP.isValid(parent = this.$get('parent'))) {
        return parent;
    }

    if (this.get('name').indexOf('.') === TP.NOT_FOUND) {
        return;
    }

    pname = this.get('name').slice(0, this.get('name').lastIndexOf('.'));
    parent = this.getType().getInstanceByName(pname);

    this.set('parent', parent);

    return parent;
});

//  ============================================================================
//  TP.log.Filtered
//  ============================================================================

/**
 * @type {TP.log.Filtered}
 * @summary A trait intended to be leveraged by Logger and Appender which both
 *     rely onfiltering logic and TP.log.Filter instances.
 */
TP.lang.Object.defineSubtype('log.Filtered');

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation
TP.log.Filtered.isAbstract(true);

//  ----------------------------------------------------------------------------
//  Filtered - Instance Definition
//  ----------------------------------------------------------------------------

/**
 * The instance's list of filters. Can be empty.
 * @type {TP.log.Filter[]}
 */
TP.log.Filtered.Inst.defineAttribute('filters');

//  ----------------------------------------------------------------------------

TP.log.Filtered.Inst.defineMethod('addFilter',
function(aFilter) {

    /**
     * @method addFilter
     * @summary Adds a new filter to the receiver. Instances can have 0 to N
     *     filters defined.
     * @param {TP.log.Filter} aFilter The new filter to add.
     * @returns {TP.log.Filtered} The receiver.
     */

    var filters;

    //  Make sure to use $get() here to only get our local filters, not any of
    //  our parent's filters.
    if (TP.notValid(filters = this.$get('filters'))) {
        filters = TP.ac();
        this.set('filters', filters);
    }

    if (!filters.contains(aFilter)) {
        filters.push(aFilter);
    }

    return this;
});

//  ----------------------------------------------------------------------------

TP.log.Filtered.Inst.defineMethod('clearFilters',
function() {

    /**
     * @method clearFilters
     * @summary Empties the receiver's filter list.
     * @returns {TP.log.Filtered} The receiver.
     */

    this.set('filters', null);

    return this;
});

//  ----------------------------------------------------------------------------

TP.log.Filtered.Inst.defineMethod('filter',
function(anEntry) {

    /**
     * @method filter
     * @summary Verifies that the entry should be logged by the receiver. The
     *     first check is the entry level but the entry is also checked by any
     *     filters for the receiver or its parent chain (if filters inherit).
     *     NOTE that unlike log4j TIBET filtering simply checks that no filter
     *     blocks the entry. There is no "neutral" or "pass and ignore others"
     *     option in our implementation of filters.
     * @returns {Boolean} Returns true if the entry should be logged/appended.
     */

    var filters,
        results;

    if (TP.notValid(anEntry)) {
        return false;
    }

    if (!this.isEnabled(anEntry.getLevel())) {
        return false;
    }

    filters = this.getFilters();
    if (TP.notEmpty(filters)) {
        results = filters.map(
                    function(filter) {
                        return filter.filter(anEntry);
                    });

        if (results.contains(false)) {
            return false;
        }
    }

    return true;
});

//  ----------------------------------------------------------------------------

TP.log.Filtered.Inst.defineMethod('getFilters',
function() {

    /**
     * @method getFilters
     * @summary Returns an array of filters for the receiver. If the receiver
     *     inheritsFilters() the list includes all inherited filters.
     * @returns {TP.log.Filter[]} The filter list.
     */

    var filters;

    filters = this.$get('filters');
    if (TP.notValid(filters)) {
        filters = TP.ac();
    }

    return filters;
});

//  ============================================================================
//  TP.log.Leveled
//  ============================================================================

/**
 * A trait intended to be leveraged by types which can limit their logging based
 * on a log entry level.
 * @type {TP.log.Leveled}
 */
TP.lang.Object.defineSubtype('log.Leveled');

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation
TP.log.Leveled.isAbstract(true);

//  ----------------------------------------------------------------------------
//  Leveled - Instance Definition
//  ----------------------------------------------------------------------------

/**
 * The instance's current logging level. Messages logged at this level and above
 * will be visible.
 * @type {TP.log.Level}
 */
TP.log.Leveled.Inst.defineAttribute('level');

//  ----------------------------------------------------------------------------

TP.log.Leveled.Inst.defineMethod('getLevel',
function() {

    /**
     * @method getLevel
     * @summary Returns the logging level for the receiver. Defaults to ALL.
     * @returns {TP.log.Level} The current logging level.
     */

    return TP.ifInvalid(this.$get('level'), TP.log.ALL);
});

//  ----------------------------------------------------------------------------

TP.log.Leveled.Inst.defineMethod('isEnabled',
function(aLevel) {

    /**
     * @method isEnabled
     * @summary Returns true if the receiver can log at the level provided.
     * @param {TP.log.Level} aLevel The level to verify.
     * @returns {Boolean} True if the receiver can log at aLevel.
     */

    //  Is the level provided "enabled" eg. "visible" relative to our threshold.
    return aLevel.isVisibleAt(this.getLevel());
});

//  ----------------------------------------------------------------------------

TP.log.Leveled.Inst.defineMethod('setLevel',
function(aLevel) {

    /**
     * @method setLevel
     * @summary Sets the logging level for the receiver.
     * @param {TP.log.Level} aLevel The new level to set.
     * @returns {TP.log.Logger} The receiver.
     */

    this.$set('level', aLevel);

    return this;
});

//  ============================================================================
//  TP.log.Logger
//  ============================================================================

/**
 * The primary logging type whose filter/appender/layout configurations define
 * how log entries are processed.
 * @type {TP.log.Logger}
 */
TP.log.Nestable.defineSubtype('log.Logger');

//  ----------------------------------------------------------------------------

TP.log.Logger.addTraits(TP.log.Leveled);
TP.log.Logger.addTraits(TP.log.Filtered);

//  Logger's inherit from their ancestor chain so we need to preserve getters.
TP.log.Logger.Inst.resolveTraits(
    TP.ac('getFilters', 'getLevel', 'getParent'),
    TP.log.Logger);

TP.log.Logger.Inst.resolveTrait('getName', TP.log.Nestable);

//  ----------------------------------------------------------------------------

/**
 * A default instance of appender which can be reused by loggers which don't
 * have one configured directly.
 * @type {TP.log.Appender}
 */
TP.log.Logger.Type.defineAttribute('defaultAppender');

//  ----------------------------------------------------------------------------

/**
 * The default type name to use when constructing a default appender instance.
 * @type {String}
 */
TP.log.Logger.Type.defineAttribute('defaultAppenderType');

//  ----------------------------------------------------------------------------

TP.log.Logger.Type.defineMethod('construct',
function(aName) {

    /**
     * @method construct
     * @summary Allocates and initializes a new logger instance. Note that
     *     while aName can be in any case loggers are uniqued by their
     *     lower-case names so 'test', 'Test', and 'TEST' will all return the
     *     same logger. The first registered logger's name is the one preserved.
     * @param {String} aName The new logger's name.
     * @returns {TP.log.Logger} The newly created Logger.
     */

    var name,
        logger;

    if (TP.isEmpty(aName)) {
        return this.raise('InvalidName');
    }

    /* eslint-disable no-extra-parens */
    name = (aName === TP.log.Manager.ROOT_LOGGER_NAME) ? aName :
        aName.toLowerCase();
    /* eslint-enable no-extra-parens */

    if (TP.log.Manager.exists(name)) {
        return TP.log.Manager.getLogger(name);
    }

    logger = this.callNextMethod();
    TP.log.Manager.registerLogger(logger);

    return logger;
});

//  ----------------------------------------------------------------------------

TP.log.Logger.Type.defineMethod('getDefaultAppender',
function() {

    /**
     * Returns an instance of the default appender type for the receiver.
     * @returns {TP.log.Appender} The default appender instance.
     */

    var name,
        type,
        inst;

    inst = this.$get('defaultAppender');
    if (TP.isValid(inst)) {
        return inst;
    }

    name = this.$get('defaultAppenderType');
    if (TP.notValid(name)) {
        name = TP.sys.cfg('log.appender');
    }

    if (TP.notEmpty(name)) {
        type = TP.sys.getTypeByName(name);
    }

    if (TP.notValid(type)) {
        type = TP.sys.getTypeByName('TP.log.ConsoleAppender');
    }

    //  If the types in question can't be located use one from this file...
    if (TP.notValid(type)) {
        type = TP.sys.getTypeByName('TP.log.Appender');
    }

    inst = type.construct();
    this.set('defaultAppender', inst);

    return inst;
});

//  ----------------------------------------------------------------------------

TP.log.Logger.Type.defineMethod('getInstanceByName',
function(aName) {

    /**
     * Returns the instance whose name matches the name provided. If the
     * instance doesn't exist this method will not create it.
     * @returns {TP.log.Logger} The named instance.
     */

    if (TP.log.Manager.exists(aName)) {
        return TP.log.Manager.getLogger(aName);
    }
});

//  ----------------------------------------------------------------------------
//  Logger - Instance Definition
//  ----------------------------------------------------------------------------

/**
 * Whether the receiver inherits appenders from its ancestor chain. By default
 * all loggers inherit appender lists.
 * @type {Boolean}
 */
TP.log.Logger.Inst.defineAttribute('additiveAppenders', true);

//  ----------------------------------------------------------------------------

/**
 * Whether the receiver inherits filters from its ancestor chain. By default
 * all loggers inherit filter lists.
 * @type {Boolean}
 */
TP.log.Logger.Inst.defineAttribute('additiveFilters', true);

//  ----------------------------------------------------------------------------

/**
 * The logger's list of appenders. Can be empty.
 @type {TP.log.Appender[]}
 */
TP.log.Logger.Inst.defineAttribute('appenders');

//  ----------------------------------------------------------------------------

/**
 * Whether the logger is buffered. If true, the logger will only trigger append
 * operations when flush is triggered, normally by reaching a buffer limit.
 * @type {Boolean}
 */
TP.log.Logger.Inst.defineAttribute('buffered', false);

//  ----------------------------------------------------------------------------

/**
 * The logger's list of entries. This will only contain data if the logger has
 * been marked as either persistent or buffered. Both cases require the logger
 * to maintain entries.
 @type {TP.log.Entry[]}
 */
TP.log.Logger.Inst.defineAttribute('entries');

//  ----------------------------------------------------------------------------

TP.log.Logger.Inst.defineMethod('init',
function(aName) {

    /**
     * @method init
     * @summary Initializes new instances, configuring their default values
     *     etc.
     * @param {String} aName The logger's name. May include '.' for hierarchy.
     * @returns {TP.log.Logger} The new logger instance.
     */

    var level;

    this.callNextMethod();

    //  We have some special setup for the root logger to ensure it acts as a
    //  proper backstop for level and parent searching.
    if (this.$get('name') === TP.log.Manager.ROOT_LOGGER_NAME) {

        level = TP.sys.cfg('log.level') || TP.sys.cfg('boot.level') || 'info';
        level = level.toLowerCase();

        this.set('level', TP.log.Level.getLevel(level));

        //  The root doesn't inherit anything.
        this.set('additiveAppenders', false);
        this.set('additiveFilters', false);

        //  We need a default appender at the root level to backstop things.
        this.addAppender(this.getType().getDefaultAppender());
    }

    return this;
});

//  ----------------------------------------------------------------------------

TP.log.Logger.Inst.defineMethod('addAppender',
function(anAppender) {

    /**
     * @method addAppender
     * @summary Adds a new appender to the logger. Loggers can have 0 to N
     *     appenders.
     * @param {TP.log.Appender} anAppender The new appender to add.
     * @returns {TP.log.Logger} The receiver.
     */

    var appenders;

    //  Make sure to use $get() here to only get our local appenders, not any of
    //  our parent's appenders.
    if (TP.notValid(appenders = this.$get('appenders'))) {
        appenders = TP.ac();
        this.set('appenders', appenders);
    }

    if (!appenders.contains(anAppender)) {
        appenders.push(anAppender);
    }

    return this;
});

//  ----------------------------------------------------------------------------

TP.log.Logger.Inst.defineMethod('clearAppenders',
function() {

    /**
     * @method clearAppenders
     * @summary Removes any local appenders from the receiver. If this logger
     *     inherits parent appenders those are unaffected.
     * @returns {TP.log.Logger} The receiver.
     */

    return this.$set('appenders', TP.ac());
});

//  ----------------------------------------------------------------------------

TP.log.Logger.Inst.defineMethod('clearFilters',
function() {

    /**
     * @method clearFilters
     * @summary Removes any local filters from the receiver. If this logger
     *     inherits parent filters those are unaffected.
     * @returns {TP.log.Logger} The receiver.
     */

    return this.$set('filters', TP.ac());
});

//  ----------------------------------------------------------------------------

TP.log.Logger.Inst.defineMethod('getAppenders',
function(localOnly) {

    /**
     * @method getAppenders
     * @summary Returns an array of appenders for the receiver. If the receiver
     *     inheritsAppenders() the list includes all inherited appenders.
     * @param {Boolean} [localOnly=false] True to avoid collecting inherited
     *     appenders.
     * @returns {TP.log.Appender[]|undefined} The appender list.
     */

    var appenders,

        parent,
        parentAppenders;

    appenders = this.$get('appenders');

    if (!this.inheritsAppenders() || localOnly === true) {
        return appenders;
    }

    if (TP.notValid(parent = this.getParent())) {
        return;
    }

    parentAppenders = parent.getAppenders();

    if (TP.isEmpty(parentAppenders)) {
        return appenders;
    }

    if (TP.isEmpty(appenders)) {
        return parentAppenders.copy();
    }

    return parentAppenders.concat(appenders);
});

//  ----------------------------------------------------------------------------

TP.log.Logger.Inst.defineMethod('getFilters',
function(localOnly) {

    /**
     * @method getFilters
     * @summary Returns an array of filters for the receiver. If the receiver
     *     inheritsFilters() the list includes all inherited filters.
     * @param {Boolean} [localOnly=false] True to avoid collecting inherited
     *     appenders.
     * @returns {TP.log.Filter[]|undefined} The filter list.
     */

    var filters,

        parent,
        parentFilters;

    filters = this.$get('filters');

    if (!this.inheritsFilters() || localOnly === true) {
        return filters;
    }

    if (TP.notValid(parent = this.getParent())) {
        return;
    }

    parentFilters = parent.getFilters();

    if (TP.isEmpty(parentFilters)) {
        return filters;
    }

    if (TP.isEmpty(filters)) {
        return parentFilters.copy();
    }

    return parentFilters.concat(filters);
});

//  ----------------------------------------------------------------------------

TP.log.Logger.Inst.defineMethod('getLevel',
function() {

    /**
     * @method getLevel
     * @summary Returns the logging level for the receiver. This search may
     *     include traversing up the parent chain to return the first level
     *     which is specifically defined. Level is inherited bottom up.
     * @returns {TP.log.Level} The current logging level.
     */

    var parent;

    if (TP.isValid(this.$get('level'))) {
        return this.$get('level');
    }

    parent = this.getParent();
    if (TP.notValid(parent)) {
        return TP.ALL;
    }

    return parent.getLevel();
});

//  ----------------------------------------------------------------------------

TP.log.Logger.Inst.defineMethod('getParent',
function() {

    /**
     * @method getParent
     * @summary Returns the receiver's parent logger, if any. The root logger
     *     will not have one but all other loggers will ultimately inherit from
     *     the root logger.
     * @returns {TP.log.Logger|undefined} The parent logger.
     */

    var pname,
        parent;

    if (TP.isValid(this.$get('parent'))) {
        return this.$get('parent');
    }

    if (this.get('name') === TP.log.Manager.ROOT_LOGGER_NAME) {
        return;
    }

    if (this.get('name').indexOf('.') === TP.NOT_FOUND) {
        parent = TP.log.Manager.getRootLogger();
    } else {
        pname = this.get('name').slice(0, this.get('name').lastIndexOf('.'));
        parent = TP.log.Manager.getLogger(pname);
    }

    this.set('parent', parent);

    return parent;
});

//  ----------------------------------------------------------------------------

TP.log.Logger.Inst.defineMethod('inheritsAppenders',
function(aFlag) {

    /**
     * @method inheritsAppenders
     * @summary Optionally updates and then returns the value for whether the
     *     receiver inherits appenders from ancestral loggers.
     * @param {Boolean} aFlag A new value for the inherited appender state.
     * @returns {Boolean} The current inherited appender state.
     */

    if (TP.isDefined(aFlag)) {
        this.set('additiveAppenders', aFlag);
    }

    return this.get('additiveAppenders');
});

//  ----------------------------------------------------------------------------

TP.log.Logger.Inst.defineMethod('inheritsFilters',
function(aFlag) {

    /**
     * @method inheritsFilters
     * @summary Optionally updates and then returns the value for whether the
     *     receiver inherits filters from ancestral loggers.
     * @param {Boolean} aFlag A new value for the inherited filter state.
     * @returns {Boolean} The current inherited filter state.
     */

    if (TP.isDefined(aFlag)) {
        this.set('additiveFilters', aFlag);
    }

    return this.get('additiveFilters');
});

//  ----------------------------------------------------------------------------

TP.log.Logger.Inst.defineMethod('$logArglist',
function(aLevel, arglist) {

    /**
     * @method $logArglist
     * @summary Logs one or more objects based on the argument list. This
     *     method is typically invoked via one of the common logging methods
     *     such as warn() or error() and therefore the arglist has a typical
     *     format. The result of this method is to invoke $logEntry() after
     *     constructing a logging entry for the inbound level and argument data.
     * @param {TP.log.Level} aLevel The level to log at.
     * @param {Object[]} arglist An array of arguments from the invoking function.
     *     Content should follow [aLevel, aMarkerOrObject, ..., anError]
     *     where the marker and error elements are optional but checked by this
     *     routine and processed if found. All other items are treated as
     *     content to be logged regardless of it particular type.
     * @returns {TP.log.Logger} The receiver.
     */

    this.$logEntry(TP.log.Entry.construct(this, aLevel, arglist));

    return this;
});

//  ----------------------------------------------------------------------------

TP.log.Logger.Inst.defineMethod('$logEntry',
function(anEntry) {

    /**
     * @method $logEntry
     * @summary Logs an entry based on the level, marker, and message content
     *     data found in the entry. This is the routine that handles the lower
     *     level work involved in filtering and forwarding to appenders. This
     *     method is invoked via $logArglist after that method constructs a log
     *     Entry owned by the receiver.
     * @param {TP.log.Entry} anEntry The log entry to output.
     * @returns {TP.log.Logger|undefined} The receiver.
     */

    var appenders;

    if (TP.notTrue(this.filter(anEntry))) {
        return;
    }

    appenders = this.getAppenders();
    if (TP.notEmpty(appenders)) {
        appenders.forEach(
                    function(appender) {
                        appender.log(anEntry);
                    });
    }

    return this;
});

//  ----------------------------------------------------------------------------

TP.log.Logger.Inst.defineMethod('removeAppender',
function(anAppender) {

    /**
     * @method removeAppender
     * @summary Removes a appender from the logger. Loggers can have 0 to N
     *     appenders.
     * @param {TP.log.Appender} anAppender The appender to remove.
     * @returns {TP.log.Logger} The receiver.
     */

    var appenders;

    //  Make sure to use $get() here to only get our local appenders, not any of
    //  our parent's appenders.
    if (TP.notValid(appenders = this.$get('appenders'))) {
        return this;
    }

    appenders.remove(anAppender, TP.IDENTITY);

    return this;
});

//  ----------------------------------------------------------------------------

TP.log.Logger.Inst.defineMethod('trace',
function(varargs) {

    /**
     * @method trace
     * @summary Log all arguments provided at trace level. If there is a marker
     *     for this entry it should be the first argument.
     * @param {arguments} varargs One or more arguments as desired.
     * @returns {TP.log.Logger|undefined} The receiver or null if the log for
     *     this level is disabled.
     */

    if (!this.isEnabled(TP.log.TRACE)) {
        return;
    }

    return this.$logArglist(TP.log.TRACE, TP.args(arguments));
});

//  ----------------------------------------------------------------------------

TP.log.Logger.Inst.defineMethod('debug',
function(varargs) {

    /**
     * @method debug
     * @summary Log all arguments provided at debug level. If there is a marker
     *     for this entry it should be the first argument.
     * @param {arguments} varargs One or more arguments as desired.
     * @returns {TP.log.Logger|undefined} The receiver or null if the log for
     *     this level is disabled.
     */

    if (!this.isEnabled(TP.log.DEBUG)) {
        return;
    }

    return this.$logArglist(TP.log.DEBUG, TP.args(arguments));
});

//  ----------------------------------------------------------------------------

TP.log.Logger.Inst.defineMethod('info',
function(varargs) {

    /**
     * @method info
     * @summary Log all arguments provided at info level. If there is a marker
     *     for this entry it should be the first argument.
     * @param {arguments} varargs One or more arguments as desired.
     * @returns {TP.log.Logger|undefined} The receiver or null if the log for
     *     this level is disabled.
     */

    if (!this.isEnabled(TP.log.INFO)) {
        return;
    }

    return this.$logArglist(TP.log.INFO, TP.args(arguments));
});

//  ----------------------------------------------------------------------------

TP.log.Logger.Inst.defineMethod('warn',
function(varargs) {

    /**
     * @method warn
     * @summary Log all arguments provided at warn level. If there is a marker
     *     for this entry it should be the first argument.
     * @param {arguments} varargs One or more arguments as desired.
     * @returns {TP.log.Logger|undefined} The receiver or null if the log for
     *     this level is disabled.
     */

    if (!this.isEnabled(TP.log.WARN)) {
        return;
    }

    return this.$logArglist(TP.log.WARN, TP.args(arguments));
});

//  ----------------------------------------------------------------------------

TP.log.Logger.Inst.defineMethod('error',
function(varargs) {

    /**
     * @method error
     * @summary Log all arguments provided at error level. If there is a marker
     *     for this entry it should be the first argument.
     * @param {arguments} varargs One or more arguments as desired.
     * @returns {TP.log.Logger|undefined} The receiver or null if the log for
     *     this level is disabled.
     */

    if (!this.isEnabled(TP.log.ERROR)) {
        return;
    }

    return this.$logArglist(TP.log.ERROR, TP.args(arguments));
});

//  ----------------------------------------------------------------------------

TP.log.Logger.Inst.defineMethod('fatal',
function(varargs) {

    /**
     * @method fatal
     * @summary Log all arguments provided at fatal level. If there is a marker
     *     for this entry it should be the first argument.
     * @param {arguments} varargs One or more arguments as desired.
     * @returns {TP.log.Logger|undefined} The receiver or null if the log for
     *     this level is disabled.
     */

    if (!this.isEnabled(TP.log.FATAL)) {
        return;
    }

    return this.$logArglist(TP.log.FATAL, TP.args(arguments));
});

//  ----------------------------------------------------------------------------

TP.log.Logger.Inst.defineMethod('system',
function(varargs) {

    /**
     * @method system
     * @summary Log all arguments provided at system level. If there is a
     *     marker for this entry it should be the first argument.
     * @param {arguments} varargs One or more arguments as desired.
     * @returns {TP.log.Logger|undefined} The receiver or null if the log for
     *     this level is disabled.
     */

    if (!this.isEnabled(TP.log.SYSTEM)) {
        return;
    }

    return this.$logArglist(TP.log.SYSTEM, TP.args(arguments));
});

//  ============================================================================
//  TP.log.Appender
//  ============================================================================

/**
 * The core type for actual logging. Appender types and their instances do the
 * actual work of outputting log entries to various sinks such as the browser
 * console, the TIBET UI, or remote servers.
 */
TP.lang.Object.defineSubtype('log.Appender');

//  ----------------------------------------------------------------------------

//  Appenders are leveled and filtered based on both level and filter content.
TP.log.Appender.addTraits(TP.log.Leveled);
TP.log.Appender.addTraits(TP.log.Filtered);

//  ----------------------------------------------------------------------------

/**
 * A default instance of layout which can be reused by appenders which don't
 * have one configured directly.
 * @type {TP.log.Layout}
 */
TP.log.Appender.Type.defineAttribute('defaultLayout');

//  ----------------------------------------------------------------------------

/**
 * The default type name to use when constructing a default layout instance.
 * @type {String}
 */
TP.log.Appender.Type.defineAttribute('defaultLayoutType');

//  ----------------------------------------------------------------------------

TP.log.Appender.Type.defineMethod('getDefaultLayout',
function() {

    /**
     * Returns an instance of the default layout type for the receiver.
     * @returns {TP.log.Layout} The default layout instance.
     */

    var name,
        type,
        inst;

    inst = this.$get('defaultLayout');
    if (TP.isValid(inst)) {
        return inst;
    }

    name = this.$get('defaultLayoutType');
    if (TP.notValid(name)) {
        name = TP.sys.cfg('log.layout');
    }

    if (TP.notEmpty(name)) {
        type = TP.sys.getTypeByName(name);
    }

    if (TP.notValid(type)) {
        type = TP.sys.getTypeByName('TP.log.ConsoleLayout');
    }

    //  If the types in question can't be located use one from this file...
    if (TP.notValid(type)) {
        type = TP.sys.getTypeByName('TP.log.Layout');
    }

    inst = type.construct();
    this.set('defaultLayout', inst);

    return inst;
});

//  ----------------------------------------------------------------------------
//  Appender - Instance Definition
//  ----------------------------------------------------------------------------

/**
 * The layout used by the appender to format any entries it may process.
 * @type {TP.log.Layout}
 */
TP.log.Appender.Inst.defineAttribute('layout');

//  ----------------------------------------------------------------------------

TP.log.Appender.Inst.defineMethod('append',
function(anEntry) {

    /**
     * @method append
     * @summary Formats the entry data using the receiver's layout, if any, and
     *     then outputs the content as appropriate. The default implementation
     *     simply returns (so TP.log.Appender is a "NullAppender" as it were).
     * @param {TP.log.Entry} anEntry The log entry to format and append.
     * @returns {TP.log.Appender} The receiver.
     */

    return this;
});

//  ----------------------------------------------------------------------------

TP.log.Appender.Inst.defineMethod('getLayout',
function() {

    /**
     * @method getLayout
     * @summary Returns the layout used by the receiver. If no specific layout
     *     has been assigned TP.log.Appender.DEFAULT_LAYOUT_TYPE is used.
     * @param {TP.log.Layout} aLayout The layout to use.
     * @returns {TP.log.Layout} The receiver's layout.
     */

    var layout;

    layout = this.$get('layout');
    if (TP.notValid(layout)) {
        layout = this.getType().getDefaultLayout();
    }

    return layout;
});

//  ----------------------------------------------------------------------------

TP.log.Appender.Inst.defineMethod('log',
function(anEntry) {

    /**
     * @method log
     * @summary Invokes the receiver's filter method to filter anEntry and then
     *     invokes append() if the entry passes all the filters.
     * @param {TP.log.Entry} anEntry The log entry to output.
     * @returns {TP.log.Appender|undefined} The receiver.
     */

    if (TP.notTrue(this.filter(anEntry))) {
        return;
    }

    this.append(anEntry);

    return this;
});

//  ----------------------------------------------------------------------------

TP.log.Appender.Inst.defineMethod('setLayout',
function(aLayout) {

    /**
     * @method setLayout
     * @summary Defines the layout formatter the receiver will use to format
     *     log entries prior to being appended.
     * @param {TP.log.Layout} aLayout The layout to use.
     * @returns {TP.log.Appender} The receiver.
     */

    this.$set('layout', aLayout);

    return this;
});

//  ============================================================================
//  TP.log.Entry
//  ============================================================================

/**
 * A container for all information related to a specific logging method
 * invocation. Log entries know their logger, level, time, and content and may
 * be annotated via a TP.log.Marker for easier filtering.
 */
TP.lang.Object.defineSubtype('log.Entry');

//  ----------------------------------------------------------------------------
//  Entry - Instance Definition
//  ----------------------------------------------------------------------------

/**
 * An array of the original arguments (not including level) being logged.
 * @type {arguments}
 */
TP.log.Entry.Inst.defineAttribute('arglist');

//  ----------------------------------------------------------------------------

/**
 * The date/time of the entry. Defaults to creation time.
 * @type {Date}
 */
TP.log.Entry.Inst.defineAttribute('date');

//  ----------------------------------------------------------------------------

/**
 * The entry's level. All entries have a level assigned when they are created.
 * @type {TP.log.Level}
 */
TP.log.Entry.Inst.defineAttribute('level');

//  ----------------------------------------------------------------------------

/**
 * The logger instance responsible for constructing this entry. Useful as a way
 * of accessing the logger name and other context data as needed.
 * @type {TP.log.Logger}
 */
TP.log.Entry.Inst.defineAttribute('logger');

//  ----------------------------------------------------------------------------

/**
 * Set to the first item of the arglist if that item is a Marker instance.
 * @type {TP.log.Marker}
 */
TP.log.Entry.Inst.defineAttribute('marker');

//  ----------------------------------------------------------------------------

TP.log.Entry.Inst.defineMethod('getArglist',
function() {

    /**
     * @method getArgList
     * @summary Returns the original arguments passed to the logging function.
     * @returns {Object[]} The argument list in array form.
     */

    return this.$get('arglist');
});

//  ----------------------------------------------------------------------------

TP.log.Entry.Inst.defineMethod('getDate',
function() {

    /**
     * @method getDate
     * @summary Returns the entry date. The millisecond data from this is often
     *     used as part of logging output, or to compute log entry delta times.
     * @returns {Date} The entry's date.
     */

    return this.$get('date');
});

//  ----------------------------------------------------------------------------

TP.log.Entry.Inst.defineMethod('getLevel',
function() {

    /**
     * @method getLevel
     * @summary Returns the level for the entry.
     * @returns {TP.log.Level} The entry's level.
     */

    return this.$get('level');
});

//  ----------------------------------------------------------------------------

TP.log.Entry.Inst.defineMethod('getLogger',
function() {

    /**
     * @method getLogger
     * @summary Returns the logger for the entry.
     * @returns {TP.log.Logger} The entry's logger.
     */

    return this.$get('logger');
});

//  ----------------------------------------------------------------------------

TP.log.Entry.Inst.defineMethod('getMarker',
function() {

    /**
     * @method getMarker
     * @summary Returns the entry marker, which contains possible data for
     *     filtering.
     * @returns {TP.log.Marker} The entry's marker.
     */

    return this.$get('marker');
});

//  ----------------------------------------------------------------------------

TP.log.Entry.Inst.defineMethod('init',
function(aLogger, aLevel, arglist) {

    /**
     * @method init
     * @summary Initializes a new log entry instance, assigning it the proper
     *     values for level, date/time, arguments, and marker. If there is a
     *     marker it must be the first item in the argument list to be used.
     * @param {TP.log.Logger} aLogger The logger responsible for this entry.
     * @param {TP.log.Level} aLevel The level this entry is relevant for.
     * @param {Object[]} arglist A list of all message items etc. provided
     *     to the initial logging method.
     * @returns {TP.log.Entry} The receiver.
     */

    var arg0,
        marker,
        str;

    this.callNextMethod();

    this.date = new Date();

    this.set('logger', aLogger);
    this.set('level', aLevel);
    this.set('arglist', arglist);

    //  See if we have a marker or marker name as the first entry. If so we
    //  shift that off our argument list and treat it as our marker value.
    if (arglist && arglist.length > 0) {
        arg0 = arglist.at(0);
        if (TP.isString(arg0)) {
            marker = TP.log.Marker.getInstanceByName(arg0);
            if (TP.isValid(marker)) {
                this.set('marker', marker);
                arglist.shift();
            }
        } else if (TP.isKindOf(arg0, TP.log.Marker)) {
            this.set('marker', arglist.shift());
        }

        //  With marker check in place see if we have a sprintf string. If so we
        //  replace the current argument list with the result of invocation.
        arg0 = arglist.at(0);
        if (arglist.length > 1 && TP.isString(arg0) &&
                TP.regex.HAS_PERCENT.match(arg0)) {
            try {
                str = TP.sprintf.apply(null, arglist);
                arglist.empty();
                arglist.push(str);
            } catch (e) {
                //  Ignore cases where the string wasn't valid. The result
                //  should be that the string will show up unprocessed if it was
                //  an attempt to use sprintf with bad formatting, but what the
                //  user expected if the string just said "foo is at 23%".
                void 0;
            }
        }
    }

    return this;
});

//  ----------------------------------------------------------------------------

TP.log.Entry.Inst.defineMethod('isError',
function() {

    /**
     * @method isError
     * @summary Returns whether or not this log entry represents an error
     *     condition.
     * @returns {Boolean} Whether or not this entry represents an error.
     */

    //  NB: The boot system expects to see these in all uppercase. For example,
    //  TP.boot.ERROR.
    return TP.boot.Log.isErrorLevel(this.getLevel().get('name').toUpperCase());
});

//  ============================================================================
//  TP.log.Filter
//  ============================================================================

/**
 * A type whose specific subtypes provide different log Entry filtering options.
 * @type {TP.log.Filter}
 */
TP.lang.Object.defineSubtype('log.Filter');

//  ----------------------------------------------------------------------------
//  Filter - Instance Definition
//  ----------------------------------------------------------------------------

TP.log.Filter.Inst.defineMethod('filter',
function(anEntry) {

    /**
     * @method filter
     * @summary Runs one or more checks on anEntry to decide whether it can be
     *     passed forward to an appender. The default implementation is intended
     *     to be overridden by subtype versions.
     * @param {TP.log.Entry} anEntry The entry to filter.
     * @returns {Boolean} True if the entry is valid.
     */

    return true;
});

//  ============================================================================
//  TP.log.Layout
//  ============================================================================

/**
 * A type whose specific subtypes provide alternative ways to format a log
 * Entry. Some common options include browser console form, TDC form, etc.
 */
TP.lang.Object.defineSubtype('log.Layout');

//  ----------------------------------------------------------------------------
//  Layout - Instance Definition
//  ----------------------------------------------------------------------------

TP.log.Layout.Inst.defineMethod('layout',
function(anEntry) {

    /**
     * @method layout
     * @summary Formats an entry. The various data fields in the entry may be
     *     processed in virtually any fashion as a result. The default format is
     *     whatever is produced by TP.str() which relies on the Entry type.
     * @param {TP.log.Entry} anEntry The entry to format.
     * @returns {TP.core.Hash} A hash of output containing at least one key,
     *     'content'.
     */

    return TP.hc('content', TP.str(anEntry));
});

//  ============================================================================
//  TP.log.Level
//  ============================================================================

/**
 * A simple type for managing logging levels and their behavior. Level
 * instances are placed on TP.log and are given an uppercase name to set
 * them off as "pseudo-constants" once they're created.
 */
TP.lang.Object.defineSubtype('log.Level');

//  ----------------------------------------------------------------------------

/**
 * A dictionary of the level instances which have been created, by name.
 * @type {TP.core.Hash}
 */
TP.log.Level.defineAttribute('levels', TP.hc());

//  ----------------------------------------------------------------------------

TP.log.Level.Type.defineMethod('construct',
function(aName, anIndex) {

    /**
     * @method construct
     * @summary Creates and returns unique Level instances based on the
     * combination of name and index.
     * @param {String} aName The string used when logging for this level.
     * @param {Number} anIndex The integer value for this level, used for
     *     comparisons to other levels.
     */

    var key,
        level;

    key = aName.toUpperCase();
    level = this.levels.at(key);

    if (TP.isValid(level)) {
        if (level.getLevel() === anIndex) {
            return level;
        } else {
            return this.raise('InvalidOperation',
                'TP.log.' + key + ' index cannot be changed.');
        }
    }

    //  Verify we can place the new level key on TP.log for access.
    if (TP.log.hasOwnProperty(key)) {
        return this.raise('InvalidLevel',
            'TP.log[' + key + '] already exists.');
    }

    level = this.callNextMethod();

    //  Register the new instance.
    this.levels.atPut(key, level);

    //  NOTE we also put the instance on TP.log as a pseudo-constant value.
    TP.log[key] = level;

    return level;
});

//  ----------------------------------------------------------------------------

TP.log.Level.Type.defineMethod('getLevel',
function(aName) {

    /**
     * @method getLevel
     * @summary Returns the Level instance with the given name, if it exists.
     * @param {String} aName The level name to retrieve.
     * @returns {TP.log.Level|undefined} The level instance with the given name.
     */

    var key;

    if (TP.isEmpty(aName)) {
        return;
    }

    key = aName.toUpperCase();

    return this.levels.at(key);
});

//  ----------------------------------------------------------------------------
//  Level - Instance Definition
//  ----------------------------------------------------------------------------

/**
 * The index value of the level. Used for comparing level ordering.
 * @type {Number}
 */
TP.log.Level.Inst.defineAttribute('index');

//  ----------------------------------------------------------------------------

/**
 * The name of the level. Used by some formatters as part of logging output.
 * @type {String}
 */
TP.log.Level.Inst.defineAttribute('name');

//  ----------------------------------------------------------------------------

TP.log.Level.Inst.defineMethod('compareTo',
function(aLevel) {

    /**
     * @method compareTo
     * @summary Returns an integer defining whether the receiver is less than
     *     (-1), equal to (0), or greater than (1) the level provided.
     * @returns {Number} The comparison value.
     */

    var level,
        index;

    level = TP.isString(aLevel) ? TP.log.Level.getLevel(aLevel) : aLevel;
    if (!TP.canInvoke(level, 'get')) {
        return -1;
    }

    index = level.get('index');

    if (this.get('index') === index) {
        return 0;
    } else if (this.get('index') < index) {
        return -1;
    } else {
        return 1;
    }
});

//  ----------------------------------------------------------------------------

TP.log.Level.Inst.defineMethod('equalTo',
function(aLevel) {

    /**
     * @method equalTo
     * @summary Returns true if the two levels are equal in terms of their
     *     index values.
     * @returns {Boolean} True if the levels are equal.
     */

    var level;

    if (!TP.canInvoke(aLevel, 'get')) {
        if (!TP.isNumber(aLevel)) {
            return false;
        } else {
            level = aLevel;
        }
    } else {
        level = aLevel.get('index');
    }

    return this.get('index') === level;
});

//  ----------------------------------------------------------------------------

TP.log.Level.Inst.defineMethod('getName',
function(aLevel) {

    /**
     * @method getName
     * @summary Returns the level name, typically one of 'TRACE', 'DEBUG', etc.
     * @returns {String} The level name.
     */

    return this.$get('name');
});

//  ----------------------------------------------------------------------------

TP.log.Level.Inst.defineMethod('init',
function(aName, anIndex) {

    /**
     * @method init
     * @summary Initializes a new instance. The name is used by certain
     *     formatters as part of the logging output. The index provides a means
     *     for comparing different level values.
     *     Note that the name must be a valid JavaScript identifier and must be
     *     unique since it will be placed on TP.log for ease-of-use.
     * @constructor
     * @param {String} aName The string used when logging for this level.
     * @param {Number} anIndex The integer value for this level, used for
     *     comparisons to other levels.
     */

    this.callNextMethod();

    this.set('name', aName.toUpperCase());
    this.set('index', anIndex);

    return this;
});

//  ----------------------------------------------------------------------------

TP.log.Level.Inst.defineMethod('isVisibleAt',
function(aLevel) {

    /**
     * @method isVisibleAt
     * @summary Returns true if the receiver is visible when the level
     *     threshold is set to the level provided.
     * @returns {Boolean} True if the the level is "greater than or equal to"
     *     the receiving level.
     */

    if (this === TP.log.OFF) {
        return false;
    }

    if (this === TP.log.ALL && aLevel !== TP.log.OFF) {
        return true;
    }

    //  If the receiver's index is greater than or equal to the threshold the
    //  receiver should be visible.
    return this.compareTo(aLevel) >= 0;
});

//  ============================================================================
//  TP.log.Level - Standard Instances
//  ============================================================================

TP.log.Level.construct('ALL', Number.NEGATIVE_INFINITY);
TP.log.Level.construct('OFF', Number.POSITIVE_INFINITY);

TP.log.Level.construct('TRACE', 100);
TP.log.Level.construct('DEBUG', 200);
TP.log.Level.construct('INFO', 300);
TP.log.Level.construct('WARN', 400);
TP.log.Level.construct('ERROR', 500);
TP.log.Level.construct('FATAL', 600);
TP.log.Level.construct('SYSTEM', 700);

//  ============================================================================
//  TP.log.Marker
//  ============================================================================

/**
 * A named object which can be used as a form of log entry annotation. Log
 * entries containing markers can optionally be filtered or formatted based on
 * their marker content.
 */
TP.log.Nestable.defineSubtype('log.Marker');

//  ----------------------------------------------------------------------------

/**
 * A dictionary of the marker instances which have been created, by name.
 * @type {TP.core.Hash}
 */
TP.log.Marker.defineAttribute('markers', TP.hc());

//  ----------------------------------------------------------------------------

TP.log.Marker.Type.defineMethod('construct',
function(aName) {

    /**
     * @method construct
     * @summary Allocates and initializes a new marker instance.
     * @constructor
     * @param {String} aName The marker name.
     * @returns {TP.log.Marker} The new instance.
     */

    var marker;

    marker = TP.log.Marker.markers.at(aName);
    if (TP.isValid(marker)) {
        return marker;
    }

    marker = this.callNextMethod();

    //  Register the new instance.
    TP.log.Marker.markers.atPut(aName, marker);

    return marker;
});

//  ----------------------------------------------------------------------------

TP.log.Marker.Type.defineMethod('getInstanceByName',
function(aName) {

    /**
     * @method getInstanceByName
     * @summary Returns the instance whose name matches the name provided. If
     *     the instance doesn't exist this method will not create it.
     * @returns {TP.log.Logger} The named instance.
     */

    return this.getMarker(aName);
});

//  ----------------------------------------------------------------------------

TP.log.Marker.Type.defineMethod('getMarker',
function(aName) {

    /**
     * @method getMarker
     * @summary Returns the Marker instance with the given name, if it exists.
     * @param {String} aName The marker name to search for.
     * @returns {TP.log.Marker|undefined} The marker instance with the given name.
     */

    if (TP.isEmpty(aName)) {
        return;
    }

    return TP.log.Marker.markers.at(aName);
});

//  ----------------------------------------------------------------------------

TP.log.Marker.Type.defineMethod('getMarkerNames',
function(aName) {

    /**
     * @method getMarkerNames
     * @summary Returns the list of all known marker names.
     * @returns {String[]} The marker name list.
     */

    return TP.log.Marker.markers.getKeys();
});

//  ----------------------------------------------------------------------------

TP.log.Marker.Inst.defineMethod('isCategoryOf',
function(nameOrMarker) {

    /**
     * @method isCategoryOf
     * @summary Returns true if the marker is a "more specific category" of the
     *     marker or marker name provided.
     * @param {String|Marker} nameOrMarker The marker or marker name to test.
     * @returns {Boolean} Whether or not the marker is a more specific category.
     */

    if (TP.isString(name)) {
        return this.getAncestorNames().contains(nameOrMarker);
    } else if (TP.isKindOf(nameOrMarker, TP.log.Marker)) {
        return this.getAncestors().contains(nameOrMarker);
    }

    return false;
});

//  ============================================================================
//  TP.log.Timer
//  ============================================================================

/**
 * A type which allows the construction of named timers, objects which can track
 * elapsed time across operations. Timers are uniqued by name.
 */
TP.lang.Object.defineSubtype('log.Timer');

//  ----------------------------------------------------------------------------

/**
 * A dictionary of all known timers.
 * @type {TP.core.Hash}
 */
TP.log.Timer.defineAttribute('timers', TP.hc());

//  ----------------------------------------------------------------------------

TP.log.Timer.Type.defineMethod('construct',
function(aName) {

    /**
     * @method construct
     * @summary Creates a new timer with the name provided. If the timer
     *     already exists it is simply returned.
     * @param {String} aName The name of the timer being requested.
     * @returns {TP.log.Timer} A new instance.
     */

    var timer;

    timer = TP.log.Timer.timers.at(aName);
    if (TP.isValid(timer)) {
        return timer;
    }

    timer = this.callNextMethod();

    TP.log.Timer.timers.atPut(aName, timer);

    return timer;
});

//  ----------------------------------------------------------------------------
//  Timer - Instance Definition
//  ----------------------------------------------------------------------------

/**
 * The name of the timer so it can be acquired later.
 * @type {String}
 */
TP.log.Timer.Inst.defineAttribute('name');

//  ----------------------------------------------------------------------------

/**
 * The ending timestamp.
 * @type {Date}
 */
TP.log.Timer.Inst.defineAttribute('end');

//  ----------------------------------------------------------------------------

/**
 * The starting timestamp.
 * @type {Date}
 */
TP.log.Timer.Inst.defineAttribute('start');

//  ----------------------------------------------------------------------------

TP.log.Timer.Inst.defineMethod('getElapsedTime',
function() {

    /**
     * @method getElapsedTime
     * @summary Returns the amount of time recorded by the timer. If the timer
     *     is still running this uses the current time, otherwise it is computed
     *     from the end time set at the time stop() was called.
     * @returns {Number} The milliseconds the timer has recorded.
     */

    var end;

    end = this.end;
    if (TP.notValid(end)) {
        end = Date.now();
    }

    return end.getTime() - this.start.getTime();
});

//  ----------------------------------------------------------------------------

TP.log.Timer.Inst.defineMethod('init',
function(aName) {

    /**
     * @method init
     * @summary Initializes a new instance.
     * @param {String} aName The new timer's name.
     * @returns {TP.log.Timer} The receiver.
     */

    this.callNextMethod();

    //  NB: Leave this to be pure property syntax, as we're capturing timing
    //  results here.
    this.name = aName;

    return this;
});

//  ----------------------------------------------------------------------------

TP.log.Timer.Inst.defineMethod('reset',
function() {

    /**
     * @method reset
     * @summary Resets the timer, clearing any end timestamp and updating the
     *     start time to the present.
     * @returns {TP.log.Timer} The receiver.
     */

    //  NB: Leave this to be pure property syntax, as we're capturing timing
    //  results here.
    this.start = Date.now();
    this.end = null;

    return this;
});

//  ----------------------------------------------------------------------------

TP.log.Timer.Inst.defineMethod('stop',
function() {

    /**
     * @method stop
     * @summary Stops the timer, recording an end timestamp.
     * @returns {TP.log.Timer} The receiver.
     */

    //  NB: Leave this to be pure property syntax, as we're capturing timing
    //  results here.
    this.end = Date.now();

    return this;
});

//  ============================================================================
//  TP Logging Methods
//  ============================================================================

TP.defineMetaInstMethod('shouldLog',
function(aFlag, aLogName) {

    /**
     * @method shouldLog
     * @summary Defines whether the receiver should log to the activity log
     *     relative to a particular log type. When no type is provided the
     *     setting takes effect for all logging for the receiver.
     * @param {Boolean} aFlag The optional state of the flag to be set as a
     *     result of this call.
     * @param {String} aLogName One of the TIBET log type names, or a custom
     *     name if custom logging is being used. See TP.*_LOG for names.
     * @returns {Boolean} The value of the flag after any optional set.
     */

    var flag,
        owner;

    //  TODO: the logic here should check the type, if the type is off then
    //  there's no point in doing things at an instance level. We can rework
    //  this as a way to override type settings.

    //  specific instruction/query regarding a particular log
    if (TP.isString(aLogName)) {
        if (TP.isBoolean(aFlag)) {
            this['$shouldLog' + aLogName] = TP.bc(aFlag);
        }

        flag = this['$shouldLog' + aLogName];
    } else {
        if (TP.isBoolean(aFlag)) {
            this['$shouldLog' + TP.LOG] = TP.bc(aFlag);
        }

        flag = this['$shouldLog' + TP.LOG];
    }

    if (TP.isBoolean(flag)) {
        return flag;
    } else if (TP.isMethod(this)) {
        //  functions that are methods can test their owners to see if
        //  logging is turned off for specific types or instances
        if (TP.isValid(owner = this[TP.OWNER])) {
            if (TP.canInvoke(owner, 'shouldLog')) {
                return owner.shouldLog(aFlag, aLogName);
            }
        }

        return true;
    } else {
        return true;
    }
});

//  ----------------------------------------------------------------------------
//
//  ----------------------------------------------------------------------------

//  TODO: migrate to housekeeping...
TP.definePrimitive('$$log', TP.$$log);

//  ----------------------------------------------------------------------------

TP.sys.defineMethod('$$log',
function(argList, aLogLevel, logRoot) {

    /**
     * @method $$log
     * @summary Directs an incoming set of logging parameters to the appropriate
     *     logger for processing.
     * @param {arguments} argList A list of arguments from a logging call.
     * @param {Number} aLogLevel TP.INFO or a similar level name.
     * @param {Object} logRoot The root to use (TP or APP usually).
     * @returns {Boolean} True if the logging operation succeeded.
     */

    var args,
        marker,
        logger,
        level;

    args = TP.args(argList);

    if (args.length > 1) {
        marker = args.first();
        if (TP.isString(marker)) {

            if (TP.log.Manager.exists(marker)) {
                logger = TP.log.Manager.getLogger(marker);
            } else if (TP.log.Manager.exists('APP.' + marker)) {
                logger = APP.getLogger(marker);
            } else if (TP.log.Manager.exists('TP.' + marker)) {
                logger = TP.getLogger(marker);
            }

            if (TP.isValid(logger)) {
                //  NOTE we trim off that argument so we don't log it below.
                args = args.slice(1);
            }
        }
    }

    if (TP.notValid(logger)) {
        if (TP.canInvoke(logRoot, 'getDefaultLogger')) {
            logger = logRoot.getDefaultLogger();
        } else {
            logger = TP.getDefaultLogger();
        }
    }

    level = TP.isString(aLogLevel) ? TP.log[aLogLevel] : aLogLevel;
    level = TP.ifInvalid(level, TP.log.INFO);

    logger.$logArglist(level, args);

    return true;
});

//  ============================================================================
//  TP Logging Extensions
//  ============================================================================

/**
 * TODO
 */

//  ----------------------------------------------------------------------------
//
//  ----------------------------------------------------------------------------

TP.definePrimitive('getDefaultLogger',
function() {

    /**
     * @method getDefaultLogger
     * @summary Returns the default application logger instance.
     * @returns {TP.log.Logger} The default logger instance.
     */

    return TP.log.Manager.getLogger(this.getID());
});

//  ----------------------------------------------------------------------------

TP.definePrimitive('getLogger',
function(aName) {

    /**
     * @method getLogger
     * @summary Returns a logger for the library side of operation. All loggers
     *     returned by this method will inherit (ultimately) from the TP or APP
     *     logger.
     * @param {String} aName The logger to return, or create and return.
     * @returns {TP.log.Logger} The named logger instance.
     */

    var name,
        id;

    id = this.getID();
    name = TP.ifEmpty(aName, id);

    if (aName !== id && aName.indexOf(id + '.') !== 0) {
        name = id + '.' + aName;
    }

    name = TP.ifInvalid(name, aName);

    return TP.log.Manager.getLogger(name);
});

//  ----------------------------------------------------------------------------

TP.definePrimitive('getLogLevel',
function(aLogger) {

    /**
     * @method getLogLevel
     * @summary Returns the logging level for the logger provided, or the
     *     default logger for the receiver.
     * @param {TP.log.Logger} aLogger The logger to retrive the level for.
     * @returns {Number} The current logging level for the logger provided.
     */

    if (TP.notEmpty(aLogger)) {
        return this.getLogger(aLogger).getLevel();
    } else {
        return this.getDefaultLogger().getLevel();
    }
});

//  ----------------------------------------------------------------------------

TP.definePrimitive('setLogLevel',
function(aLevel, aLogger) {

    /**
     * @method setLogLevel
     * @summary Sets the logging level for the logger provided, or the
     *     default logger for the receiver.
     * @param {String} aLevel A logging level name to be set.
     * @param {TP.log.Logger} aLogger The logger to set the level for.
     * @returns {TP.log.Logger} The logger the level was set for.
     */

    var level;

    level = TP.isString(aLevel) ? TP.log[aLevel.toUpperCase()] : aLevel;
    if (TP.notValid(level)) {
        this.raise('InvalidLevel');
    }

    if (TP.notEmpty(aLogger)) {
        return this.getLogger(aLogger).setLevel(level);
    } else {
        return this.getDefaultLogger().setLevel(level);
    }
});

//  ----------------------------------------------------------------------------
//  BRANCH DETECTION
//  ----------------------------------------------------------------------------

/*
 *  Utility functions to help limit message construction overhead when needed.
 *
 *  The versions here replace the boot system versions and verify that the level
 *  is enabled for the log name provided (the boot system versions don't since
 *  there are no loggers at that point in the startup process).
*/

//  ----------------------------------------------------------------------------

TP.definePrimitive('ifTrace',
function(aLogName) {

    /**
     * @method ifTrace
     * @summary Returns true if logging is enabled for TP.log.TRACE level
     *     for the specified log, or the current default log. This function
     *     is commonly used in the idiomatic expression:
     *     <code>
     *          TP.ifTrace() ? TP.trace(...) : 0;
     *     </code>
     *     This idiom can help performance in cases where message construction
     *     overhead is high.
     * @param {String} aLogName An optional log name to check for level.
     * @returns {Boolean} True if trace-level logging is active.
     */

    var logger;

    logger = aLogName ? this.getLogger(aLogName) : this.getDefaultLogger();

    return logger.isEnabled(TP.log.TRACE);

}, null, 'TP.ifTrace');

//  ----------------------------------------------------------------------------

TP.definePrimitive('ifDebug',
function(aLogName) {

    /**
     * @method ifDebug
     * @summary Returns true if logging is enabled for TP.log.DEBUG level
     *     for the specified log, or the current default log. This function
     *     is commonly used in the idiomatic expression:
     *     <code>
     *          TP.ifDebug() ? TP.debug(...) : 0;
     *     </code>
     *     This idiom can help performance in cases where message construction
     *     overhead is high.
     * @param {String} aLogName An optional log name to check for level.
     * @returns {Boolean} True if debug-level logging is active.
     */

    var logger;

    logger = aLogName ? this.getLogger(aLogName) : this.getDefaultLogger();

    return logger.isEnabled(TP.log.DEBUG);

}, null, 'TP.ifDebug');

//  ----------------------------------------------------------------------------

TP.definePrimitive('ifInfo',
function(aLogName) {

    /**
     * @method ifInfo
     * @summary Returns true if logging is enabled for TP.log.INFO level
     *     for the specified log, or the current default log. This function
     *     is commonly used in the idiomatic expression:
     *     <code>
     *          TP.ifInfo() ? TP.info(...) : 0;
     *     </code>
     *     This idiom can help performance in cases where message construction
     *     overhead is high.
     * @param {String} aLogName An optional log name to check for level.
     * @returns {Boolean} True if info-level logging is active.
     */

    var logger;

    logger = aLogName ? this.getLogger(aLogName) : this.getDefaultLogger();

    return logger.isEnabled(TP.log.INFO);

}, null, 'TP.ifInfo');

//  ----------------------------------------------------------------------------

TP.definePrimitive('ifWarn',
function(aLogName) {

    /**
     * @method ifWarn
     * @summary Returns true if logging is enabled for TP.log.WARN level
     *     for the specified log, or the current default log. This function
     *     is commonly used in the idiomatic expression:
     *     <code>
     *          TP.ifWarn() ? TP.warn(...) : 0;
     *     </code>
     *     This idiom can help performance in cases where message construction
     *     overhead is high.
     * @param {String} aLogName An optional log name to check for level.
     * @returns {Boolean} True if warn-level logging is active.
     */

    var logger;

    logger = aLogName ? this.getLogger(aLogName) : this.getDefaultLogger();

    return logger.isEnabled(TP.log.WARN);

}, null, 'TP.ifWarn');

//  ----------------------------------------------------------------------------

TP.definePrimitive('ifError',
function(aLogName) {

    /**
     * @method ifError
     * @summary Returns true if logging is enabled for TP.log.ERROR level
     *     for the specified log, or the current default log. This function
     *     is commonly used in the idiomatic expression:
     *     <code>
     *          TP.ifError() ? TP.error(...) : 0;
     *     </code>
     *     This idiom can help performance in cases where message construction
     *     overhead is high.
     * @param {String} aLogName An optional log name to check for level.
     * @returns {Boolean} True if error-level logging is active.
     */

    var logger;

    logger = aLogName ? this.getLogger(aLogName) : this.getDefaultLogger();

    return logger.isEnabled(TP.log.ERROR);

}, null, 'TP.ifError');

//  ----------------------------------------------------------------------------

TP.definePrimitive('ifFatal',
function(aLogName) {

    /**
     * @method ifFatal
     * @summary Returns true if logging is enabled for TP.log.FATAL level
     *     for the specified log, or the current default log. This function
     *     is commonly used in the idiomatic expression:
     *     <code>
     *          TP.ifFatal() ? TP.fatal(...) : 0;
     *     </code>
     *     This idiom can help performance in cases where message construction
     *     overhead is high.
     * @param {String} aLogName An optional log name to check for level.
     * @returns {Boolean} True if fatal-level logging is active.
     */

    var logger;

    logger = aLogName ? this.getLogger(aLogName) : this.getDefaultLogger();

    return logger.isEnabled(TP.log.FATAL);

}, null, 'TP.ifFatal');

//  ----------------------------------------------------------------------------

TP.definePrimitive('ifSystem',
function(aLogName) {

    /**
     * @method ifSystem
     * @summary Returns true if logging is enabled for TP.log.SYSTEM level
     *     for the specified log, or the current default log. This function
     *     is commonly used in the idiomatic expression:
     *     <code>
     *          TP.ifSystem() ? TP.system(...) : 0;
     *     </code>
     *     This idiom can help performance in cases where message construction
     *     overhead is high.
     * @param {String} aLogName An optional log name to check for level.
     * @returns {Boolean} True if system-level logging is active.
     */

    var logger;

    logger = aLogName ? this.getLogger(aLogName) : this.getDefaultLogger();

    return logger.isEnabled(TP.log.SYSTEM);

}, null, 'TP.ifSystem');

//  ----------------------------------------------------------------------------
//  Level Loggers
//  ----------------------------------------------------------------------------

/*
 * The methods here are defined in the boot code and delegate through a simple
 * branching routine which targets TP.boot.$$log during startup and TP.sys.$$log
 * once the system has started (and can leverage all this nice TP.log stuff :)).
 */

//  TODO: migrate to housekeeping
TP.definePrimitive('trace', TP.trace);
TP.definePrimitive('debug', TP.debug);
TP.definePrimitive('info', TP.info);
TP.definePrimitive('warn', TP.warn);
TP.definePrimitive('error', TP.error);
TP.definePrimitive('fatal', TP.fatal);
TP.definePrimitive('system', TP.system);

//  ============================================================================
//  APP Logging Extensions
//  ============================================================================

/**
 * Extensions specifically for the APP branch of logging. The methods here
 * mirror the basic if[Level] and APP[level] methods found on the TP object but
 * they leverage the APP logger as their primary root rather than the TP logger.
 */

//  ----------------------------------------------------------------------------
//  TODO: convert these into traits, or some other approach for sharing...
//  ----------------------------------------------------------------------------

APP.getDefaultLogger = TP.getDefaultLogger;
APP.getLogger = TP.getLogger;
APP.getLogLevel = TP.getLogLevel;
APP.setLogLevel = TP.setLogLevel;

APP.ifTrace = TP.ifTrace;
APP.ifDebug = TP.ifDebug;
APP.ifInfo = TP.ifInfo;
APP.ifWarn = TP.ifWarn;
APP.ifError = TP.ifError;
APP.ifFatal = TP.ifFatal;
APP.ifSystem = TP.ifSystem;

APP.$log = TP.$log;
APP.trace = TP.trace;
APP.debug = TP.debug;
APP.info = TP.info;
APP.warn = TP.warn;
APP.error = TP.error;
APP.fatal = TP.fatal;
APP.system = TP.system;

//  ============================================================================
//  TP.sys
//  ============================================================================

//  ----------------------------------------------------------------------------
//  CSS LOGGING
//  ----------------------------------------------------------------------------

/**
 * All CSS processor output can be captured in the CSS log for review provided
 * that TP.sys.shouldLogCSS() is true.
 */

//  ----------------------------------------------------------------------------

TP.sys.defineMethod('logCSS',
function(anObject, aLogLevel) {

    /**
     * @method logCSS
     * @summary Adds anObject to the CSS log. This method will have no effect
     *     if the TP.sys.shouldLogCSS() flag is false.
     * @param {Object} anObject The message/object to log.
     * @param {Number} aLogLevel The logging level, from TP.TRACE through
     *     TP.SYSTEM.
     * @returns {Boolean} True if the logging operation succeeded.
     */

    if (!TP.sys.shouldLogCSS()) {
        return false;
    }

    TP.sys.$$log(TP.ac(TP.CSS_LOG, anObject), aLogLevel);

    return true;
});

//  ----------------------------------------------------------------------------
//  INFERENCE LOGGING
//  ----------------------------------------------------------------------------

/*
The inference log is a simple log for tracking activity of the inferencing
engine. All messages generated by the inference engine show up here, with
content that often includes the message, target, arguments, etc.
*/

//  ----------------------------------------------------------------------------

TP.sys.defineMethod('logInference',
function(anObject, aLogLevel) {

    /**
     * @method logInference
     * @summary Adds anObject to the inference log. This method will have no
     *     effect if the TP.sys.shouldLogInferences() flag is false.
     * @param {Object} anObject The message/object to log.
     * @param {Number} aLogLevel The logging level, from TP.TRACE through
     *     TP.SYSTEM.
     * @returns {Boolean} True if the logging operation succeeded.
     */

    if (!TP.sys.shouldLogInferences()) {
        return false;
    }

    TP.sys.$$log(TP.ac(TP.INFERENCE_LOG, anObject), aLogLevel);

    return true;
});

//  ----------------------------------------------------------------------------
//  IO LOGGING
//  ----------------------------------------------------------------------------

/*
The IO log tracks activity of communication primitives for both file and http
access. All messages generated by communication calls show up here allowing you
to see a single view of all server or host communication.
*/

//  ----------------------------------------------------------------------------

TP.sys.defineMethod('logIO',
function(anObject, aLogLevel) {

    /**
     * @method logIO
     * @summary Logs anObject to the IO log. Note that this method will have no
     *     effect if TP.sys.shouldLogIO() is false.
     * @summary This call is used by various file and http access routines
     *     to log their activity. The object argument can provide data in one or
     *     more keys including:
     *
     *     'uri'            the targetUrl
     *     'uriparams'      optional parameters for url-encoding,
     *     'separator'      optional uri parameter separator
     *
     *     'headers'        http headers, or response headers,
     *     'async'          true or false
     *     'method'         the command method (GET/POST/PUT/DELETE etc)
     *     'body'           any data content for the call,
     *
     *     'noencode'       turns off body content encoding 'mimetype'
     *     'mimetype'       used for body encoding 'encoding'
     *     'charset'        encoding used for multi-part
     *     'multiparttypes' used for multi-part encodings
     *
     *     'commObj'        the XMLHttpRequest object used, if any
     *
     *     'request'        TP.sig.Request reference
     *     'response'       TP.sig.Response reference
     *
     *     'direction'      TP.SEND or TP.RECV
     *     'message'        the log message
     *     'object'         any Error object which might be related,
     *
     *     'finaluri'       the fully expanded uri w/parameters
     *     'finalbody'      the TP.str(body) value actually sent
     *
     *     Note that IO log entries will only be pushed to the activity log (and
     *     stdout) when the logging level is INFO.
     * @param {Object} anObject The message/object to log.
     * @param {Number} aLogLevel The logging level, from TP.TRACE through
     *     TP.SYSTEM.
     * @returns {Boolean} True if the logging operation succeeded.
     */

    if (!TP.sys.shouldLogIO()) {
        return false;
    }

    TP.sys.$$log(TP.ac(TP.IO_LOG, anObject), aLogLevel);

    return true;
});

//  ----------------------------------------------------------------------------
//  JOB LOGGING
//  ----------------------------------------------------------------------------

/*
The job log contains information on all TP.core.Job processing done by TIBET.
The TP.core.Job type manages virtually all setInterval/setTimeout style
processing in TIBET so that all asynchronous processing can be managed
consistently.
*/

//  ----------------------------------------------------------------------------

TP.sys.defineMethod('logJob',
function(anObject, aLogLevel) {

    /**
     * @method logJob
     * @summary Logs a job-related event. This method has no effect if
     *     TP.sys.shouldLogJobs() is false.
     * @param {Object} anObject The message/object to log.
     * @param {Number} aLogLevel The logging level, from TP.TRACE through
     *     TP.SYSTEM.
     * @returns {Boolean} True if the logging operation succeeded.
     */

    if (!TP.sys.shouldLogJobs()) {
        return false;
    }

    TP.sys.$$log(TP.ac(TP.JOB_LOG, anObject), aLogLevel);

    return true;
});

//  ----------------------------------------------------------------------------
//  KEY LOGGING
//  ----------------------------------------------------------------------------

/*
The key log contains information on all key events being logged. Logging keys
can be a useful way to help adjust keyboard map entries.
*/

//  ----------------------------------------------------------------------------

TP.sys.defineMethod('logKey',
function(anObject, aLogLevel) {

    /**
     * @method logKey
     * @summary Logs a key event. This method has no effect if
     *     TP.sys.shouldLogKeys() is false.
     * @param {Object} anObject The message/object to log.
     * @param {Number} aLogLevel The logging level, from TP.TRACE through
     *     TP.SYSTEM.
     * @returns {Boolean} True if the logging operation succeeded.
     */

    if (!TP.sys.shouldLogKeys()) {
        return false;
    }

    TP.sys.$$log(TP.ac(TP.KEY_LOG, anObject), aLogLevel);

    return true;
});

//  ----------------------------------------------------------------------------
//  LINK LOGGING
//  ----------------------------------------------------------------------------

/*
The link log contains information on all links traversed via TIBET's link
methods such as TP.go2(). This information can be used to provide valuable
usability analysis data, user tracking data, or debugging information on the
path a user took up to the point of an error.
*/

//  ----------------------------------------------------------------------------

TP.sys.defineMethod('logLink',
function(anObject, aLogLevel) {

    /**
     * @method logLink
     * @summary Logs a link activation event. This method has no effect if
     *     TP.sys.shouldLogLinks() is false.
     * @param {Object} anObject The message/object to log.
     * @param {Number} aLogLevel The logging level, from TP.TRACE through
     *     TP.SYSTEM.
     * @returns {Boolean} True if the logging operation succeeded.
     */

    if (!TP.sys.shouldLogLinks()) {
        return false;
    }

    TP.sys.$$log(TP.ac(TP.LINK_LOG, anObject), aLogLevel);

    return true;
});

//  ----------------------------------------------------------------------------
//  MOUSE LOGGING
//  ----------------------------------------------------------------------------

/*
The mouse log contains information on all mouse events being logged. Logging
mouse events can be a useful way to debug code like drag and drop.
*/

//  ----------------------------------------------------------------------------

TP.sys.defineMethod('logMouse',
function(anObject, aLogLevel) {

    /**
     * @method logMouse
     * @summary Logs a mouse event. This method has no effect if
     *     TP.sys.shouldLogMouse() is false.
     * @param {Object} anObject The message/object to log.
     * @param {Number} aLogLevel The logging level, from TP.TRACE through
     *     TP.SYSTEM.
     * @returns {Boolean} True if the logging operation succeeded.
     */

    if (!TP.sys.shouldLogMouse()) {
        return false;
    }

    TP.sys.$$log(TP.ac(TP.MOUSE_LOG, anObject), aLogLevel);

    return true;
});

//  ----------------------------------------------------------------------------
//  SECURITY LOGGING
//  ----------------------------------------------------------------------------

/*
Security events such as requesting permissions on Mozilla or performing a
cross-domain HTTP request can be logged separately (and are by default).
*/

//  ----------------------------------------------------------------------------

TP.sys.defineMethod('logSecurity',
function(anObject, aLogLevel) {

    /**
     * @method logSecurity
     * @summary Logs a security event. This method has no effect if
     *     TP.sys.shouldLogSecurity() is false.
     * @param {Object} anObject The message/object to log.
     * @param {Number} aLogLevel The logging level, from TP.TRACE through
     *     TP.SYSTEM.
     * @returns {Boolean} True if the logging operation succeeded.
     */

    if (!TP.sys.shouldLogSecurity()) {
        return false;
    }

    TP.sys.$$log(TP.ac(TP.SECURITY_LOG, anObject), aLogLevel);

    return true;
});

//  ----------------------------------------------------------------------------
//  SIGNAL LOGGING
//  ----------------------------------------------------------------------------

/*
The signal log tracks the activity of the TIBET signaling engine. This subset of
log entries can be critical to understanding how your application operates. The
log entries typically contain the signal object itself.
*/

//  ----------------------------------------------------------------------------

TP.sys.defineMethod('logSignal',
function(anObject, aLogLevel) {

    /**
     * @method logSignal
     * @summary Logs a signaling message to the activity log. The signal string
     *     typically contains the origin, signal name, context, and any
     *     arguments which were passed.
     * @param {Object} anObject The message/object to log.
     * @param {Number} aLogLevel The logging level, from TP.TRACE through
     *     TP.SYSTEM.
     * @returns {Boolean} True if the logging operation succeeded.
     */

    if (!TP.sys.shouldLogSignals()) {
        return false;
    }

    TP.sys.$$log(TP.ac(TP.SIGNAL_LOG, anObject.get('message')), aLogLevel);

    return true;
});

//  ----------------------------------------------------------------------------
//  TRANSFORM LOGGING
//  ----------------------------------------------------------------------------

/*
The transform log contains all output from the content processing system. The
TP.sys.shouldLogTransforms() method controls whether logging actually occurs.
*/

//  ----------------------------------------------------------------------------

TP.sys.defineMethod('logTransform',
function(anObject, aLogLevel) {

    /**
     * @method logTransform
     * @summary Logs a content transfomation event to the transform log.
     * @param {Object} anObject The message/object to log.
     * @param {Number} aLogLevel The logging level, from TP.TRACE through
     *     TP.SYSTEM.
     * @returns {Boolean} True if the logging operation succeeded.
     */

    if (!TP.sys.shouldLogTransforms()) {
        return false;
    }

    TP.sys.$$log(TP.ac(TP.TRANSFORM_LOG, anObject), aLogLevel);

    return true;
});

//  ============================================================================
//  Console Appender
//  ============================================================================

/**
 * An appender specific to output to the typical JavaScript console object.
 */
TP.log.Appender.defineSubtype('ConsoleAppender');

//  ----------------------------------------------------------------------------

/**
 * The default layout type for this appender.
 * @type {TP.log.Layout}
 */
TP.log.ConsoleAppender.Type.$set('defaultLayoutType', 'TP.log.ConsoleLayout');

//  ----------------------------------------------------------------------------
//  Instance Definition
//  ----------------------------------------------------------------------------

TP.log.ConsoleAppender.Inst.defineMethod('append',
function(anEntry) {

    /**
     * @method append
     * @summary Formats the entry data using the receiver's layout and writes it
     *     to the console using the best console API method possible.
     * @param {TP.log.Entry} anEntry The log entry to format and append.
     * @returns {TP.log.Appender} The receiver.
     */

    var name,
        writer,
        layout,
        content;

    //  Remap our logging level to the standardized browser console logging
    //  level. TIBET semantics and browser semantics sometimes differ...
    name = anEntry.getLevel().get('name').toLowerCase();
    switch (name) {
        case 'error':
        case 'fatal':
            writer = 'error';
            break;
        case 'info':
            writer = 'info';
            break;
        case 'trace':
            //  Chrome at least treats 'debug' as a 'verbose' mode so use that
            //  if found, otherwise just use standard logging.
            writer = TP.isValid(TP.topWindow.console.debug) ? 'debug' : 'log';
            break;
        default:
            //  debug, system, all
            writer = 'log';
            break;
    }

    //  If the entry contains multiple parts and we have access to a
    //  group/groupEnd api via the console we'll group our output to help show
    //  that it's all the result of a single logging call...
    //  TODO:

    //  Format the little critter...
    layout = this.getLayout();
    content = layout.layout(anEntry).at('content');

    //  If the content matches the TSH_NO_VALUE, exit here - we don't log that
    //  value.
    if (TP.regex.TSH_NO_VALUE_MATCHER.test(content)) {
        return this;
    }

    try {
        TP.topWindow.console[writer](content);
    } catch (e) {
        TP.topWindow.console.log(content);
    }

    //  Verify one last thing...we didn't just blow the stack did we? For some
    //  reason, possibly a catch block in the wrong place we've yet to find,
    //  this is the only way we can ensure certain code can trap recusion
    //  errors.
    if (/maximum call stack/i.test(content)) {
        $STATUS = TP.FAILED;
    }

    return this;
});

//  ============================================================================
//  Console Layout
//  ============================================================================

/**
 * A layout specific to JavaScript console output.
 */
TP.log.Layout.defineSubtype('ConsoleLayout');

//  ----------------------------------------------------------------------------
//  Instance Definition
//  ----------------------------------------------------------------------------

TP.log.ConsoleLayout.Inst.defineMethod('layout',
function(anEntry) {

    /**
     * @method layout
     * @summary Formats an entry. The default output format for top.console is:
     *     {ms} - {level} {logger} - {string}
     * @param {TP.log.Entry} anEntry The entry to format.
     * @returns {TP.core.Hash} A hash of output containing at least one key,
     *     'content'.
     */

    var str,
        marker,
        arglist;

    str = '' + anEntry.getDate().asTimestamp() + ' - ' +
                anEntry.getLogger().get('name') + ' ' +
                anEntry.getLevel().get('name');

    //  If there's a marker we can output that as well...
    marker = anEntry.getMarker();
    if (TP.isValid(marker)) {
        str += ' [' + marker.get('name') + ']';
    }

    //  The arglist may have multiple elements in it which we need to handle.
    arglist = anEntry.getArglist();
    if (TP.isValid(arglist)) {
        str += ' - ';
        arglist.forEach(function(item) {
            str += TP.str(item);
            str += ' ';
        });
        str = str.trim();
        if (str.charAt(str.getSize() - 1) !== '.') {
            str += '.';
        }
    }

    return TP.hc('content', str);
});

//  ============================================================================
//  Arglist Layout
//  ============================================================================

/**
 * A simple layout specific to JavaScript console output which doesn't include
 * any timestamp or leveling data, just the content of the Entry argument list.
 */
TP.log.Layout.defineSubtype('ArglistLayout');

//  ----------------------------------------------------------------------------
//  Instance Definition
//  ----------------------------------------------------------------------------

TP.log.ArglistLayout.Inst.defineMethod('layout',
function(anEntry) {

    /**
     * @method layout
     * @summary Formats an entry using only the argument list, no timestamp,
     *     level, or other information.
     * @param {TP.log.Entry} anEntry The entry to format.
     * @returns {TP.core.Hash} A hash of output containing at least one key,
     *     'content'.
     */

    var str,
        arglist;

    str = '';

    //  The arglist may have multiple elements in it which we need to handle.
    arglist = anEntry.getArglist();

    if (TP.isValid(arglist)) {
        arglist.forEach(function(item) {
            str += TP.str(item);
            str += ' ';
        });
        str = str.trim();
    }

    return TP.hc('content', str);
});

//  ============================================================================
//  CHANGE LOG
//  ============================================================================

TP.sys.defineMethod('logCodeChange',
function(anObject, aLogLevel) {

    /**
     * @method logCodeChange
     * @summary Adds source code to the change log. Returns true if the log
     *     entry is successful. This method will have no effect when the
     *     TP.sys.shouldLogCodeChanges() flag is false.
     * @param {Object} anObject The source code change to log.
     * @param {Number} aLogLevel The logging level. Ignored for this call. Code
     *     changes are always logged at TP.SYSTEM level.
     * @returns {Boolean} True if the logging operation succeeded.
     */

    if (!TP.sys.shouldLogCodeChanges()) {
        return false;
    }

    TP.sys.$$log(TP.ac(TP.CHANGE_LOG, anObject), TP.SYSTEM);

    return true;
});

//  ----------------------------------------------------------------------------
//  ChangeLog Appender
//  ----------------------------------------------------------------------------

/**
 * An appender specific to tracking code changes that have been logged.
 */
TP.log.Appender.defineSubtype('ChangeLogAppender');

//  ----------------------------------------------------------------------------

/**
 * The default layout type for this appender.
 * @type {TP.log.Layout}
 */
TP.log.ChangeLogAppender.Type.$set('defaultLayoutType', 'TP.log.ArglistLayout');

//  ----------------------------------------------------------------------------
//  Instance Definition
//  ----------------------------------------------------------------------------

TP.log.ChangeLogAppender.Inst.defineMethod('append',
function(anEntry) {

    /**
     * @method append
     * @summary Formats the entry data using the receiver's layout and writes it
     *     to the console. Logging is always done using the default 'log' call
     *     rather than a call which might alter the output in any form.
     * @param {TP.log.Entry} anEntry The log entry to format and append.
     * @returns {TP.log.Appender} The receiver.
     */

    var layout,
        content;

    layout = this.getLayout();
    content = layout.layout(anEntry).at('content');

    //  If the content matches the TSH_NO_VALUE, exit here - we don't log that
    //  value.
    if (TP.regex.TSH_NO_VALUE_MATCHER.test(content)) {
        return this;
    }

    TP.topWindow.console.log(content);

    return this;
});

//  ----------------------------------------------------------------------------
//  Configuration
//  ----------------------------------------------------------------------------

(function() {
    var logger,
        appender;

    logger = TP.getLogger(TP.CHANGE_LOG);
    appender = TP.log.ChangeLogAppender.construct();

    logger.inheritsAppenders(false);
    logger.addAppender(appender);
    logger.setLevel(TP.log.ALL);
}());

//  ============================================================================
//  TEST LOG
//  ============================================================================

TP.sys.defineMethod('logTest',
function(anObject, aLogLevel) {

    /**
     * @method logTest
     * @summary Adds an entry to the test log. Note that there is no level
     *     filtering in test logging, the level parameter only filters parallel
     *     entries which might be made to the activity log.
     * @param {Object} anObject The test data to log. This can range from a
     *     simple object to a hash, TP.test.Suite, or TP.test.Case. Common
     *     keys should follow TP.core.JobControl standards such as statusCode,
     *     statusText, etc. Note that not all appenders designed for the test
     *     log will use all keys.
     * @param {Number} aLogLevel The logging level, from TP.TRACE through
     *     TP.SYSTEM.
     * @returns {Boolean} True if the logging operation succeeded.
     */

    if (TP.isString(anObject)) {
        TP.sys.$$log(TP.ac(TP.TEST_LOG,
            TP.hc('statusCode', TP.ACTIVE, 'statusText', anObject)), aLogLevel);

        return true;
    }

    TP.sys.$$log(TP.ac(TP.TEST_LOG, anObject), aLogLevel);

    return true;
});

//  ----------------------------------------------------------------------------
//  TestLog Layout
//  ----------------------------------------------------------------------------

/**
 * A simple layout specific to processing test log input data.
 */
TP.log.Layout.defineSubtype('TestLogLayout');

//  ----------------------------------------------------------------------------
//  Instance Definition
//  ----------------------------------------------------------------------------

TP.log.TestLogLayout.Inst.defineMethod('layout',
function(anEntry) {

    /**
     * @method layout
     * @summary Extracts the first object logged in the log entry to produce a
     *     hash containing that object as the 'content' to be logged.
     * @param {TP.log.Entry} anEntry The entry to format.
     * @returns {TP.core.Hash} A hash of output containing at least one key,
     *     'content'.
     */

    var arglist;

    //  TODO:   we currently rely on historical TAP output being generated by
    //  the logging system rather than generating it ourselves. Probably need to
    //  adjust that so we do the TAP formatting in the layout. That would mean
    //  processing the entry argument list more here.
    arglist = anEntry.getArglist();

    //  The first object in the list is the one with status info for the test.
    return TP.hc('content', arglist.first());
});

//  ----------------------------------------------------------------------------
//  TestLog Appender
//  ----------------------------------------------------------------------------

/**
 * An appender specific to outputting test log data to the browser console.
 */
TP.log.Appender.defineSubtype('TestLogAppender');

//  ----------------------------------------------------------------------------

/**
 * The default layout type for this appender.
 * @type {TP.log.Layout}
 */
TP.log.TestLogAppender.Type.$set('defaultLayoutType', 'TP.log.TestLogLayout');

//  ----------------------------------------------------------------------------
//  Instance Definition
//  ----------------------------------------------------------------------------

TP.log.TestLogAppender.Inst.defineMethod('append',
function(anEntry) {

    /**
     * @method append
     * @summary Processes a test log entry and logs it to either the system
     *     console or to the appropriate TIBET stdio function.
     * @param {TP.log.Entry} anEntry The log entry to format and append.
     * @returns {TP.log.Appender} The receiver.
     */

    var name,
        writer,

        layout,
        results,
        content,
        message,
        asIs,
        cmdID,
        stdio,

        rootRequest;

    //  Try to find a matching console API method to our level name. If we find
    //  it we'll use that to output the message content.
    name = anEntry.getLevel().get('name').toLowerCase();
    switch (name) {
        case 'warn':
            writer = 'warn';
            stdio = 'stdout';
            break;
        case 'error':
        case 'fatal':
            writer = 'error';
            stdio = 'stderr';
            break;
        default:
            //  trace, debug, info, system, all
            writer = 'log';
            stdio = 'stdout';
            break;
    }

    //  If the entry contains multiple parts and we have access to a
    //  group/groupEnd api via the console we'll group our output to help show
    //  that it's all the result of a single logging call...
    //  TODO:

    //  Format the little critter...
    layout = this.getLayout();

    results = layout.layout(anEntry);
    content = results.at('content');

    //  Content should be either a hash containing job status-like data, or an
    //  Error object if reporting on a failed/errored test condition.
    if (TP.isString(content)) {
        message = content;
    } else if (TP.canInvoke(content, 'at')) {
        message = content.at('statusText');
    } else if (TP.isError(content)) {
        message = content.message || content.name;
    } else {
        message = TP.str(content);
    }

    asIs = results.at('cmdAsIs');

    //  If we don't use the console (but rely on stdio) Headless won't be
    //  happy.
    if (TP.sys.cfg('boot.context') === 'headless') {

        //  If the content matches the TSH_NO_VALUE, exit here - we don't log
        //  that value.
        if (TP.regex.TSH_NO_VALUE_MATCHER.test(message)) {
            return this;
        }

        try {
            TP.topWindow.console[writer](message);
        } catch (e) {
            TP.topWindow.console.log(message);
        }
    } else {

        rootRequest = TP.test.Suite.get('$rootRequest');

        if (TP.isValid(rootRequest)) {
            cmdID = rootRequest.getRootID();
        }

        TP[stdio](
            message,
            TP.hc('cmdTAP', true, 'cmdAsIs', asIs, 'cmdID', cmdID));
    }

    return this;
});

//  ----------------------------------------------------------------------------
//  Configuration
//  ----------------------------------------------------------------------------

(function() {
    var logger,
        appender;

    logger = TP.getLogger(TP.TEST_LOG);

    appender = TP.log.TestLogAppender.construct();

    logger.inheritsAppenders(false);
    logger.addAppender(appender);
    logger.setLevel(TP.log.ALL);
}());

//  ----------------------------------------------------------------------------
//  end
//  ============================================================================
TP.boot.$$srcPath = '~lib_src/tibet/kernel/TIBETFinalization.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/*
Kernel finalization. Any last configuration and processing is done here.
*/

//  ------------------------------------------------------------------------
//  GLOBAL INIT's
//  ------------------------------------------------------------------------

/* eslint-disable no-unused-vars */
TP.sys.$extraglobals = TP.sys.$nativeglobals.difference(
                            TP.sys.$ecmaglobals).difference(
                                TP.sys.$systemglobals).difference(
                                    TP.sys.$windowglobals).difference(
                                        TP.sys.$globals);
/* eslint-enable no-unused-vars */

TP.sys.$keywords = TP.hc().addAllKeys(TP.sys.$keywords);
TP.sys.$reservedwords = TP.hc().addAllKeys(TP.sys.$reservedwords);
TP.sys.$globals = TP.hc().addAllKeys(TP.sys.$globals);
TP.sys.$globalexcludes = TP.hc().addAllKeys(TP.sys.$globalexcludes);
TP.sys.$ecmaglobals = TP.hc().addAllKeys(TP.sys.$ecmaglobals);
TP.sys.$systemglobals = TP.hc().addAllKeys(TP.sys.$systemglobals);
TP.sys.$nativeglobals = TP.hc().addAllKeys(TP.sys.$nativeglobals);
TP.sys.$windowglobals = TP.hc().addAllKeys(TP.sys.$windowglobals);
TP.sys.$extraglobals = TP.hc().addAllKeys(TP.sys.$extraglobals);

TP.sys.defineMethod('defineGlobal',
function(aName, aValue, force) {

    /**
     * @method defineGlobal
     * @summary Defines a global variable and adds it to TIBET's list of
     *     globals. This list is used to support symbol exports. Note that while
     *     this does have the effect of setting a global value there is no
     *     change notification associated with this operation. Use set() to
     *     achieve that effect.
     * @param {String} aName The global name to define.
     * @param {Object} aValue The value to set for the global.
     * @param {Boolean} force True means an existing value will be forcefully
     *     replaced with the new value. The default is false.
     * @returns {Object|undefined} The value after setting.
     */

    //  we prefer explicit tests
    if (TP.isEmpty(aName)) {
        return;
    }

    //  NOTE NOTE NOTE, not an array push any more...
    TP.sys.$globals.atPut(aName, null);

    //  simple check for having already defined it, if not we add to the
    //  list. as a coding standard we use self when we're referring to
    //  the "global" instead of implying "window" behavior
    if (TP.notValid(TP.global[aName]) || force) {
        TP.global[aName] = aValue;
    }

    return TP.global[aName];
});

//  ------------------------------------------------------------------------
//  MARKERS
//  ------------------------------------------------------------------------

//  A list of all of the markers used to prevent 'endless recursion' when
//  producing String representation.
TP.sys.defineGlobal('$$markers',
    TP.ac(
        '$$recursive_lama_pp',
        '$$recursive_asObject',
        '$$recursive_asDumpString',
        '$$recursive_asHTMLString',
        '$$recursive_asJSONSource',
        '$$recursive_anObject',
        '$$recursive_asPrettyString',
        '$$recursive_asSource',
        '$$recursive_asXMLString',
        '$$recursive_asString'
    ));

//  ------------------------------------------------------------------------

TP.definePrimitive('objectHasMarker',
function(anObject, aMarker) {

    /**
     * @method objectHasMarker
     * @summary Tests to see whether an object has either a particular marker or
     *     any marker currently present.
     * @param {Object} anObject The target object.
     * @param {String} [aMarker] The marker to test for. If this isn't provided,
     *     then the target object will be tested for all markers.
     * @returns {Boolean} Whether or not the supplied marker (or any marker if
     *     the marker wasn't supplied) is present.
     */

    var markers,
        len,
        i;

    //  A particular marker was supplied - test only for that one.
    if (TP.isString(aMarker)) {
        return TP.owns(anObject, aMarker);
    }

    //  Iterate over all markers and test each one.
    markers = TP.global.$$markers;
    len = markers.getSize();
    for (i = 0; i < len; i++) {
        if (TP.owns(anObject, markers.at(i))) {
            //  Found one - exit returning true.
            return true;
        }
    }

    return false;
});

//  ------------------------------------------------------------------------
//  CLEANUP
//  ------------------------------------------------------------------------

//  process any pending signals
TP.sys.fireNextSignal();

//  ------------------------------------------------------------------------
//  APPLICATION STARTUP
//  ------------------------------------------------------------------------

TP.sys.defineMethod('activate',
function() {

    /**
     * @method activate
     * @summary Activates the entire TIBET 'system'.
     * @description TP.sys's 'activate()' method is called from $activate in the
     *     boot system once the blank page has been loaded and the UI canvas is
     *     read to display initialization messages. The handler here is
     *     responsible for performing all code initialization, initialize the
     *     TP.core.Application object and then signaling the next signal in the
     *     startup sequence. Activation of the TIBET system includes:
     *     - Initializing all of the TIBET types loaded.
     *     - Initializing type and method proxies.
     *     - Initializing native and non-native XML namespaces.
     *     - Initializing the browser locale.
     *     - Initializing the signaling system.
     *     - Checking the TIBET system version.
     *     - Loading the root window with content.
     * @returns {TP.sys} The receiver.
     */

    var sig,

        locale,
        type,
        msg,
        name,

        rootName,
        rootWindow,

        promise,

        typeInits;

    // We only do this once.
    if (TP.sys.hasInitialized()) {
        return this;
    }

    //  Final signal before UI begins processing.

    //  If this signal is canceled, that means a handler didn't want to start
    //  the system and so we'll call TP.sys.isExiting() and throw an Error.
    sig = TP.signal('TP.sys', 'AppWillInitialize');
    if (sig.shouldPrevent()) {

        TP.sys.isExiting(true);

        throw new Error('System abended');
    }

    TP.boot.$setStage('initializing');

    //  Load the environment with any information we have about plugins.
    if (TP.sys.cfg('tibet.plugins')) {
        TP.boot.$configurePluginEnvironment();
    }

    //  Install the patches for various native prototypes, etc. in the current
    //  code frame (where we are executing).
    TP.boot.installPatches(TP.topWindow);

    //  Capture the list of type initializers. We'll invoke these first to
    //  ensure the types are properly set up, then let completion on that
    //  task trigger activation of the rest of our workload.
    typeInits = TP.sys.getTypeInitializers();

    //  Execute the following steps in a series of Functions that get scheduled
    //  to allow for GUI updating.

    //  Make sure we have a root window so that we can schedule the Functions.
    rootName = TP.sys.getUIRootName();
    if (TP.notValid(rootWindow = TP.sys.getWindowById(rootName))) {
        TP.boot.$stderr('Canvas specification error. Cannot find window: ' +
                            rootName);
        TP.boot.$flushLog(true);

        return this;
    }

    promise = TP.extern.Promise.resolve().then(
        function() {
            var uri,
                req;

            msg = 'Initializing user...';

            if (TP.sys.cfg('boot.use_login')) {
                if (TP.sys.cfg('boot.context') === 'electron') {
                    /*
                     * TODO: The Electron login process
                     */
                    /*
                    return TP.extern.Promise.construct(
                        function(resolver, rejector) {
                            var success;
                            success = function(aSignal) {
                                var result;

                                success.ignore(
                                    TP.core.ElectronMain,
                                    'TP.sig.UserAuthenticationData');

                                result = TP.doc(aSignal.at('data'));
                                TP.ietf.vcard.initVCards(result);
                                TP.core.User.construct(
                                    TP.core.User.extractFullName(result));

                                resolver();
                            };

                            success.observe(
                                    TP.core.ElectronMain,
                                    'TP.sig.UserAuthenticationData');

                            TP.electron.ElectronMain.signalMain(
                                    'TP.sig.GetUserAuthenticationData');
                        });
                    */

                    //  For now, we do the standard thing that we do for
                    //  no-login applications.
                    TP.core.User.getRealUser();
                    TP.core.User.setupUserResources();
                } else {
                    //  User should be logged in. We want to load/generate a
                    //  vcard for them if possible.
                    uri = TP.sys.cfg('tds.vcard.uri');
                    if (TP.isEmpty(uri)) {
                        TP.core.User.getRealUser();
                        TP.core.User.setupUserResources();
                    } else {
                        uri = TP.uriExpandPath(uri);
                        req = TP.request('uri', uri, 'async', true);
                        req.defineHandler('IOSucceeded',
                            function(aSignal) {
                                var result;

                                result = aSignal.getResult();
                                if (TP.isDocument(result)) {
                                    TP.ietf.vcard.initVCards(result);
                                    TP.core.User.construct(
                                        TP.core.User.extractFullName(result));
                                } else {
                                    TP.ifWarn() ?
                                        TP.warn('Invalid or missing user' +
                                                                ' vcard.') : 0;
                                    TP.core.User.getRealUser();
                                }

                                TP.core.User.setupUserResources();
                            });
                        req.defineHandler('IOFailed',
                            function(aSignal) {
                                TP.ifWarn() ?
                                        TP.warn('Invalid or missing user' +
                                                                ' vcard.') : 0;

                                TP.core.User.getRealUser();
                                TP.core.User.setupUserResources();
                            });
                        TP.httpGet(uri, req);

                        //  Return the request's response as a Promise. This
                        //  will cause the request to succeed or fail before
                        //  therest of the Promise chain can proceed.
                        return req.getResponse().asPromise();
                    }
                }
            } else {
                //  Not a login-restricted application. Force construction of
                //  default user.
                TP.core.User.getRealUser();
                TP.core.User.setupUserResources();
            }
        });

    promise.then(
        function() {

            var tibetToken;

            //  Set up common URIs for the user object, the raw user vCard data
            //  and the host data.
            TP.uc('urn:tibet:hosturi').setResource(
                                        TP.uc('~').getConcreteURI());

            //  If we're running in headless mode, then we need to check to see
            //  if we have a valid 'TIBET.boot.tibet_token' in the
            //  sessionStorage. If not, see if the cfg has a
            //  'headless.tibet_token' configured. If so, set it's value into
            //  the session storage. This helps when running tests or builds
            //  with apps that want to load resources on login. Note that we do
            //  *not* check to see if the application is configured to require
            //  login here. When in a headless mode, the 'boot.use_login' cfg
            //  parameter will always be false.
            if (TP.sys.cfg('boot.context') === 'headless') {

                tibetToken = TP.global.sessionStorage.getItem(
                                            'TIBET.boot.tibet_token');

                if (TP.isEmpty(tibetToken)) {
                    tibetToken = TP.sys.getcfg('headless.tibet_token');

                    if (TP.notEmpty(tibetToken)) {
                        TP.global.sessionStorage.setItem(
                                        'TIBET.boot.tibet_token', tibetToken);
                    }
                }
            }

            (function() {
                var i;

                //  One tricky part is that we can sometimes trigger application
                //  instance creation during phase one of parallel booting.
                //  Because of that, it will be an instance of the common
                //  TP.core.Application type and not the specific subtype of
                //  TP.core.Application that we'll want for the rest of the life
                //  of running the app.

                //  So, when that happens we want to clear the singleton
                //  instance now that phase two has loaded and before we try
                //  anything that would depend on routes etc. This singleton
                //  instance will be re-created as an instance of our
                //  application-specific subtype.
                TP.core.Application.set('singleton', null);

                //  Initialize all the types which own initialize methods so
                //  we're sure they're ready for operation. this may cause them
                //  to load other types so we do this before proxy setup.
                try {
                    //  Final signal before initializers are run.
                    TP.signal('TP.sys', 'AppInitialize');

                    msg = 'Initializing TIBET types...';

                    TP.ifDebug() ? TP.debug(msg) : 0;
                    TP.boot.$stdout(msg, TP.DEBUG);

                    //  Run through the type initializers and run them.
                    for (i = 0; i < typeInits.getSize(); i++) {
                        typeInits.at(i)();
                    }
                } catch (e) {
                    msg = 'TIBET Type Initialization Error';
                    TP.ifError() ? TP.error(TP.ec(e, msg)) : 0;
                    TP.boot.$stderr(msg, e, TP.FATAL);

                    TP.boot.shouldStop('Type Initialization Failure(s).');
                    TP.boot.$stderr('Initialization failure.', TP.FATAL);

                    throw e;
                }
            }).queueAfterNextRepaint(rootWindow);

            (function() {

                msg = 'Initializing root canvas...';

                //  Force initialization of the root canvas id before any
                //  changes are made to the canvas setting by other operations.
                try {
                    TP.ifDebug() ? TP.debug(msg) : 0;
                    TP.boot.$stdout(msg, TP.DEBUG);
                    name = TP.sys.getUIRootName();
                    if (TP.notValid(name)) {
                        throw new Error('InvalidUIRoot');
                    }
                } catch (e) {
                    msg = 'Canvas Initialization Error';
                    TP.ifError() ? TP.error(TP.ec(e, msg)) : 0;
                    TP.boot.$stderr(msg, e);
                    throw e;
                }
            }).queueAfterNextRepaint(rootWindow);

            (function() {

                msg = 'Initializing type proxies...';

                //  Initialize type proxies for types we didn't load as a result
                //  of the boot manifest or through type initialization.
                try {
                    TP.ifDebug() ? TP.debug(msg) : 0;
                    TP.boot.$stdout(msg, TP.DEBUG);

                    TP.sys.initializeTypeProxies();
                } catch (e) {
                    msg = 'Proxy Initialization Error';
                    TP.ifError() ? TP.error(TP.ec(e, msg)) : 0;
                    TP.boot.$stderr(msg, e);
                    throw e;
                }
            }).queueAfterNextRepaint(rootWindow);

            (function() {

                msg = 'Initializing namespace support...';

                //  Install native/non-native namespace support. this may also
                //  involve loading types
                try {
                    TP.ifDebug() ? TP.debug(msg) : 0;
                    TP.boot.$stdout(msg, TP.DEBUG);

                    //  Two classes of namespace, internally supported and those
                    //  TIBET has to provide support for.
                    TP.core.Browser.installNativeNamespaces();
                    TP.core.Browser.installNonNativeNamespaces();
                } catch (e) {
                    msg = 'Namespace Initialization Error';
                    TP.ifError() ? TP.error(TP.ec(e, msg)) : 0;
                    TP.boot.$stderr(msg, e);
                    throw e;
                }
            }).queueAfterNextRepaint(rootWindow);

            (function() {

                msg = 'Initializing default locale...';

                //  Bring in any locale that might be specified
                try {
                    TP.ifDebug() ? TP.debug(msg) : 0;
                    TP.boot.$stdout(msg, TP.DEBUG);

                    if (TP.notEmpty(locale = TP.sys.cfg('tibet.locale'))) {
                        type = TP.sys.getTypeByName(locale);

                        if (TP.notValid(type)) {
                            msg = 'Locale Initialization Error: ' +
                                locale + ' not found.';
                            TP.boot.$stderr(msg);
                            TP.ifError() ? TP.error(msg) : 0;

                            //  set the default based on the current language
                            TP.sys.setLocale();
                        } else {
                            TP.sys.setLocale(type);
                        }
                    } else {
                        //  set the default based on the current language
                        TP.sys.setLocale();
                    }
                } catch (e) {
                    msg = 'Locale Initialization Error';
                    TP.ifError() ? TP.error(TP.ec(e, msg)) : 0;
                    TP.boot.$stderr(msg, e);
                    throw e;
                }
            }).queueAfterNextRepaint(rootWindow);

            (function() {

                msg = 'TIBET Initialization complete.';

                TP.ifDebug() ? TP.debug(msg) : 0;
                TP.boot.$stdout(msg, TP.DEBUG);

                //  Ensure dependent code knows we're now fully initialized.
                TP.sys.hasInitialized(true);

                //  Refresh controllers now that all initialization is done.
                //  Note that this will build the proper Application subtype
                //  instance and configure it.
                TP.sys.getApplication().refreshControllers();

                try {
                    //  Compute common sizes, such as font metrics and scrollbar
                    //  sizes.
                    TP.computeCommonSizes();
                } catch (e) {
                    msg = 'UI metrics/size computations failed.';
                    TP.ifError() ? TP.error(TP.ec(e, msg)) : 0;
                    TP.boot.$stderr(msg, e);
                    //  Fall through and take our chances the UI will display
                    //  properly.
                }

                //  Final signal before UI begins processing.
                TP.signal('TP.sys', 'AppDidInitialize');

                if (TP.sys.inDeveloperMode()) {

                    //  Set up handler for tibet.json changes... NOTE that
                    //  because we're referencing via a TIBETURL we want to get
                    //  the concrete URI to actually apply the handler to. The
                    //  TIBETURL will delegate to that during processing.
                    TP.uc('~app/tibet.json').getConcreteURI().defineMethod(
                        'processRefreshedContent',
                        function() {
                            var obj,
                                str;

                            TP.info('Refreshing tibet.json configuration' +
                                                                    ' values.');

                            str = TP.str(this.getContent());
                            try {
                                obj = JSON.parse(str);
                            } catch (e) {
                                TP.error('Failed to parse: ' +
                                                this.getLocation(), e);
                                return;
                            }

                            TP.boot.$configureOptions(obj);

                            //  Configure routing data from cfg() parameters
                            TP.uri.URIRouter.$configureRoutes();

                            //  Call the supertype method here, which will
                            //  inform any observers of the 'tibet.json' URI
                            //  that it's content changed.
                            return this.callNextMethod();
                        }, {
                            patchCallee: true
                        });

                    TP.boot.$getStageInfo('starting').head =
                        'Loading developer extensions...';
                }

                //  If we initialized without error move on to starting.
                TP.boot.$setStage('starting');

                //  Recapture starting time in case we broke for debugging.
                TP.boot.$uitime = new Date();

                //  If we're in an extension environment, then just signal
                //  AppWillStart and AppStart manually. Otherwise, load the root
                //  page.
                if (TP.sys.inExtension() === true) {
                    //  Signal we are starting. This provides a hook for
                    //  extensions etc. to tap into the startup sequence before
                    //  routing or other behaviors but after we're sure the UI
                    //  is finalized.
                    TP.signal('TP.sys', 'AppWillStart');

                    //  Signal actual start. The default handler on Application
                    //  will invoke the start() method in response to this
                    //  signal.
                    TP.signal('TP.sys', 'AppStart');
                } else {
                    //  Load the UI. This will ultimately trigger UIReady.
                    TP.sys.loadUIRoot();
                }
            }).queueAfterNextRepaint(rootWindow);

            //  If caching of the app has been deferred (probably because this
            //  is a 'login based' application), then populate the caches.

            //  NOTE!!! NOTE!! We *MUST* do this *after* loading the UI root.
            //  This process turns on and off cfg flags (like 'boot.teamtibet')
            //  that will interfere with the normal booting operations, so we
            //  must wait for all of that to have completed.
            (function() {

                msg = 'Populating deferred caches...';

                //  If the app uses logins, then the caches will *not* have been
                //  populated (due to issues around trying to retrieve all of
                //  the package XML files and not being able to retrieve the
                //  app-level ones since we weren't logged in). In that case,
                //  either one of these flags may be true and we need to call
                //  into the boot system to populate those caches.
                if (TP.sys.cfg('boot.use_login')) {
                    if (TP.boot.$libCacheNeedsPopulatingAfterLogin ||
                        TP.boot.$appCacheNeedsPopulatingAfterLogin) {
                        TP.boot.populateCaches(
                                    TP.boot.$libCacheNeedsPopulatingAfterLogin,
                                    TP.boot.$appCacheNeedsPopulatingAfterLogin);
                    }
                }
            }).queueAfterNextRepaint(rootWindow);
    });

    return this;
}, {
    dependencies: [TP.extern.Promise],
    patchCallee: false
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('buildAndConfigAppInstance',
function() {

    /**
     * @method buildAndConfigAppInstance
     * @summary Gets the application type and instance set up after all
     *     loading and type initialization has been done.
     * @returns {TP.core.Application} The application instance.
     */

    var typeName,
        appType,
        newAppInst;

    //  Configure the application type setting, defaulting the value as needed.
    typeName = TP.sys.cfg('project.app_type');
    if (TP.isEmpty(typeName)) {
        typeName = 'APP.' + TP.sys.cfg('project.name') + '.Application';
    }

    //  If we're supposed to grab a different type that'll happen here.
    appType = TP.sys.getTypeByName(typeName);

    //  May be paused or booting in two phases, so only warn if we're fully
    //  loaded.
    if (TP.notValid(appType)) {
        if (TP.sys.hasLoaded()) {
            TP.ifWarn() ?
                TP.warn('Unable to locate application controller type: ' +
                    typeName + '. ' +
                    'Defaulting to TP.core.Application.') : 0;
        }
        appType = TP.sys.getTypeByName('TP.core.Application');
    }

    //  Create the new instance and define it as our singleton for any future
    //  application instance requests.
    newAppInst = appType.construct('Application', null);
    newAppInst.setID('Application');
    TP.core.Application.set('singleton', newAppInst);

    return newAppInst;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('loadUIRoot',
function() {

    /**
     * @method loadUIRoot
     * @summary Loads the 'ui root' window with the initial content.
     * @returns {TP.sys} The receiver.
     */

    var inHeadless,

        rootLoc,
        rootURI,
        rootName,
        rootWindow,

        hasBootToggle,

        request,
        toggleKey,

        bootTPFrameElem,
        bootdoc;

    inHeadless = TP.sys.cfg('boot.context') === 'headless';

    rootLoc = TP.uriJoinPaths('~boot_xhtml', TP.sys.cfg('project.root_page'));

    //  Construct a TP.uri.URI wrapper around the location and perform a
    //  rewrite on it, in case its actually a URI that's been mapped using
    //  the URI mapping system.
    rootURI = TP.uc(rootLoc);
    rootURI = rootURI.rewrite();

    if (TP.notValid(rootURI)) {
        TP.sys.raise('TP.sig.InvalidURI', rootLoc);
        TP.boot.$flushLog(true);
    }

    //  the 'path' to the 'root' (the window we will draw the initial
    //  content into)
    rootName = TP.sys.getUIRootName();

    //  make sure we have a root window
    if (TP.notValid(rootWindow = TP.sys.getWindowById(rootName))) {
        TP.boot.$stderr('Canvas specification error. Cannot find window: ' +
                            rootName);
        TP.boot.$flushLog(true);

        return this;
    }

    //  As long as we're not sharing a UI for booting with the final target UI
    //  we can go ahead and hide the root UI while keeping the boot UI visible
    //  in case errors occur.
    if (TP.boot.getUIRoot() !== TP.boot.getUIBoot()) {
        TP.boot.hideUIRoot();
    }

    //  To avoid flickering, we set 'display' of the rootWindow's frameElement
    //  (i.e. '#UIROOT') to 'none' in our index file. We *must* turn back on
    //  display here, as the CSS layout engine needs to lay out on screen
    //  components it can compute sizes, etc. Note that the 'visibility' of this
    //  element is still 'hidden' as per the hideUIRoot() call above.
    TP.elementDefaultDisplay(rootWindow.frameElement);

    //  Build a request we can pass to the setContent routine to handle any
    //  callbacks, error conditions, etc.
    request = TP.request();

    //  TODO: these should be methods, not functions in the payload. fixing this
    //  requires changing everywhere that expects TP.ONLOAD as a key (many DOM
    //  and DHTML primitives (ack TP.ONLOAD for the list).

    request.atPut(
        TP.ONLOAD,
        function(aDocument) {

            //  If the boot didn't trigger ONFAIL but is stopping then we're
            //  still essentially in failure mode. Make sure we do the right
            //  thing.
            if (TP.boot.shouldStop()) {
                request.at(TP.ONFAIL)(request);
                return;
            }

            //  NOTE that we don't have logic here. Formerly we'd trigger app
            //  start signaling here but we have to let that happen via either
            //  the tibet:root or tibet:lama tag processing for proper
            //  sequencing.
            if (inHeadless) {
                //  Signal we are starting. This provides a hook for extensions
                //  etc. to tap into the startup sequence before routing or
                //  other behaviors but after we're sure the UI is finalized.
                TP.signal('TP.sys', 'AppWillStart');

                //  Signal actual start. The default handler on Application will
                //  invoke the start() method in response to this signal.
                TP.signal('TP.sys', 'AppStart');
            } else if (!TP.sys.hasFeature('lama') && hasBootToggle) {

                //  No hook file in the boot screen so we initialize manually.
                bootTPFrameElem = TP.byId(TP.sys.cfg('boot.uiboot'),
                                    TP.topWindow);
                if (TP.isValid(bootTPFrameElem)) {
                    TP.boot.initializeCanvas(
                        bootTPFrameElem.getContentWindow().getNativeWindow());
                }

                //  Prep the UI for full console mode.
                if (TP.isValid(bootTPFrameElem)) {
                    bootTPFrameElem.getContentDocument().getBody().addClass(
                        'full_console');
                }
            }
        });

    request.atPut(
        TP.ONFAIL,
        function(req) {
            var msg,
                txt;

            //  Be certain our boot UI is displayed.
            TP.boot.showUIBoot();

            txt = req.getFaultText();
            msg = TP.sc('UIRoot Initialization Error') +
                    (txt ? ': ' + txt + '.' : '.');

            //  TODO: Dig around and figure out what went wrong. getFaultText is
            //  pretty limited in terms of details.
            TP.boot.$stderr(msg, TP.FATAL);
        });

    //  If we're not running with a UI (not headless), and we have a properly
    //  configured 'boot toggle' key, then set up an observation that will cause
    //  that key to toggle between the boot log and the application's user
    //  interface.
    hasBootToggle = TP.notEmpty(TP.sys.cfg('boot.toggle_key'));

    if (!inHeadless && hasBootToggle) {

        //  Configure a toggle so we can always get back to the boot UI as
        //  needed.
        toggleKey = TP.sys.cfg('boot.toggle_key');

        if (!toggleKey.startsWith('TP.sig.')) {
            toggleKey = 'TP.sig.' + toggleKey;
        }

        if (!TP.sys.hasFeature('lama')) {

            /* eslint-disable no-extra-parens */
            //  set up keyboard toggle to show/hide the boot UI
            (function() {
                TP.boot.toggleUI();
                TP.boot.$scrollLog();
            }).observe(TP.core.Keyboard, toggleKey);
            /* eslint-enable no-extra-parens */

        } else {

            //  With lama in place the normal TP.core.Keyboard hook won't be
            //  installed in UIBOOT, we need to do a lower level listener so
            //  when/if that UI becomes primary we have event hooks in place.
            bootTPFrameElem = TP.byId(TP.sys.cfg('boot.uiboot'), TP.topWindow);
            if (TP.isValid(bootTPFrameElem)) {
                try {
                    bootdoc = bootTPFrameElem.getContentDocument().
                                                    getNativeDocument();
                    bootdoc.addEventListener('keyup',
                    function(ev) {

                        var keySigName;

                        keySigName = 'TP.sig.' + TP.eventGetDOMSignalName(ev);

                        if (keySigName === toggleKey) {
                            TP.boot.showUIRoot();
                        }
                    }, false);
                } catch (e) {
                    TP.boot.$stderr('Unable to attach boot UI toggle: ' +
                        e.message);
                }
            }
        }
    }

    //  Set the location of the window (wrapping it to be a TP.core.Window).
    TP.wrap(rootWindow).setContent(rootURI, request);

    return this;
});

//  ------------------------------------------------------------------------
//  APPLICATION SHUTDOWN
//  ------------------------------------------------------------------------

TP.sys.defineMethod('finalizeShutdown',
function() {

    /**
     * @method finalizeShutdown
     * @summary Finalizes the shut down of the application by sending the
     *     'TP.sig.AppShutdown' signal.
     * @returns {TP.sys} The receiver.
     */

    TP.signal(TP.sys, 'TP.sig.AppShutdown');

    return this;
});

//  ------------------------------------------------------------------------

TP.sys.defineMethod('terminate',
function(aURI, navigateToURI) {

    /**
     * @method terminate
     * @summary Terminates the application by removing the protective
     *     onbeforeunload hooks that TIBET installs and navigating to the
     *     supplied URI. If a URI is not supplied the value from
     *     TP.sys.cfg('path.blank_page') is used.
     * @summary This function should be called by applications *only after
     *     all 'quit' logic (e.g. saving data to the server, etc.) has been
     *     executed by the application*.
     * @param {String} aURI The URI to navigate to in order to terminate the
     *     application.
     * @param {Boolean} [navigateToURI=true] Whether or not we'll navigate to
     *     the URI. If not, this method will just call TP.sys.finalizeShutdown
     *     manually.
     * @returns {Boolean} Whether or not we're really terminating. If one of the
     *     handlers of TP.sig.AppWillShutdown has prevented the default action,
     *     then we will *not* terminate.
     */

    var sig,

        url,
        str;

    //  Put the system in a mode that let's everyone know we're exiting.
    TP.sys.isExiting(true);

    //  Send a TP.sig.AppWillShutdown signal. This can be canceled (i.e.
    //  'prevent default'ed), in which case we just return.
    sig = TP.signal(TP.sys, 'TP.sig.AppWillShutdown');

    //  If the signal has been 'prevent default'ed, then return.
    if (sig.shouldPrevent()) {

        //  Put the system in a mode that let's everyone know we're no longer
        //  exiting.
        TP.sys.isExiting(false);

        return false;
    }

    //  Make sure to remove the 'TIBET.boot.tibet_token' value from
    //  sessionStorage. If we're running against a server that vended us an
    //  authentication token (like the TDS), it should be under this storage
    //  key.
    TP.global.sessionStorage.removeItem('TIBET.boot.tibet_token');

    //  close open/registered windows. won't always work, but we can try :)
    TP.core.Window.closeRegisteredWindows();

    //  By setting this on the code (i.e. top-level) window's document's body
    //  element, we tell the onbeforeunload handler to just return and don't
    //  supply text to the browser. This allows a 'clean' unload.

    //  Note that the 'finalizeShutdown' method will be called from the 'unload'
    //  handler as the code unloads.
    if (TP.isElement(TP.documentGetBody(window.document))) {
        TP.elementSetAttribute(TP.documentGetBody(window.document),
                                'unloadable',
                                'true');
    }

    //  If we are navigating to a new URL, then compute one and go there.
    if (TP.notFalse(navigateToURI)) {
        if (TP.isValid(aURI)) {
            url = TP.uc(aURI);
        } else {
            url = TP.uc(TP.sys.cfg('path.blank_page'));
        }

        str = url.getLocation();

        //  Can't use a 'tibet://' URL here.
        if (str.match(/tibet:/)) {
            TP.ifWarn() ?
                TP.warn('Invalid termination URI provided: ' + aURI) : 0;

            //  didn't resolve properly, not a valid resource URI
            url = TP.uc(TP.sys.cfg('path.blank_page'));
        }

        //  put up the blank page at top, which blows away the app

        //  NB: This will eventually cause the 'finalizeShutdown' machinery
        //  above through the 'unload' event handler.
        window.location = url.getLocation();
    } else {
        TP.sys.finalizeShutdown();
    }

    return true;
});

//  ------------------------------------------------------------------------

//  We now have a complete kernel in place which means other files can test
//  whether then can invoke kernel versions of primitives etc.
TP.sys.hasKernel(true);

//  ----------------------------------------------------------------------------

/**
 * The namespace used for temporary data
 */
/* eslint-disable no-unused-vars */
TP.defineNamespace('TP.tmp');
/* eslint-enable no-unused-vars */

TP.w3.Xmlns.registerNSInfo(
    'urn:tibet:tmp',
    TP.hc('prefix', 'tmp'));

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_dat/TP.uri.URI.default_urimap.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
/**
 * Settings for default URI mappings.
 */

TP.sys.setcfg('uri.map.sabredav.pattern', 'http://demo.sabredav.com');
TP.sys.setcfg('uri.map.sabredav.urihandler', 'TP.uri.WebDAVHandler');

TP.sys.setcfg('uri.map.ws.pattern', 'ws://.*:10081');
TP.sys.setcfg('uri.map.ws.urihandler', 'TP.test.WSEchoHandler');

TP.sys.setcfg('uri.map.googledocs.pattern', 'http://docs.google.com.*');
TP.sys.setcfg('uri.map.googledocs.urihandler', 'TP.google.GoogleDocsHandler');

TP.sys.setcfg('uri.map.googlesearch.pattern',
                'jsonp://ajax.googleapis.com/ajax/services/search/web');
TP.sys.setcfg('uri.map.googlesearch.contenttype', 'TP.google.GoogleSearchData');

TP.sys.setcfg('uri.map.couchdb.pattern', 'http://.*:5984[^\\?]*$');
TP.sys.setcfg('uri.map.couchdb.urihandler', 'TP.uri.CouchDBURLHandler');
TP.sys.setcfg('uri.map.couchdb.lama_inspector_handler', 'TP.lama.CouchTools');

TP.sys.setcfg('uri.map.couchnoext.pattern', 'http://.*:5984.*\\/[^.\\?]*$');
TP.sys.setcfg('uri.map.couchnoext.urihandler', 'TP.uri.CouchDBURLHandler');
TP.sys.setcfg('uri.map.couchnoext.contenttype', 'TP.core.JSONContent');

TP.sys.setcfg('uri.map.jsonp.pattern', 'jsonp://');
TP.sys.setcfg('uri.map.jsonp.contenttype', 'TP.core.JSONContent');

TP.sys.setcfg('uri.map.pouchdb.pattern', 'pouchdb://');
TP.sys.setcfg('uri.map.pouchdb.contenttype', 'TP.core.JSONContent');
TP.boot.$$srcPath = '~lib_dat/TP.dom.UIElementNode.default_keybindings.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
/**
 * Settings for default UIElementNode keybindings.
 */

//  Entries that map Ctrl-Z/Meta-Z into an Undo event.
TP.dom.UIElementNode.registerKeybinding('DOM_Ctrl_Z_Down', 'TP.sig.DOMUndo');
TP.dom.UIElementNode.registerKeybinding('DOM_Meta_Z_Down', 'TP.sig.DOMUndo');

//  Focus first/last
TP.dom.UIElementNode.registerKeybinding('DOM_Home_Down', 'TP.sig.UIFocusFirst');
TP.dom.UIElementNode.registerKeybinding('DOM_End_Down', 'TP.sig.UIFocusLast');

//  Focus next/previous field.
TP.dom.UIElementNode.registerKeybinding('DOM_Tab_Down', 'TP.sig.UIFocusNext');
TP.dom.UIElementNode.registerKeybinding('DOM_Shift_Tab_Down',
    'TP.sig.UIFocusPrevious');

//  Focus following/preceding (which can apply to traversing groups).
//  Note that, in practice, the notion of "navigate to next/previous field or
//  next/previous group if at end/start" can actually be a bit confusing.
TP.dom.UIElementNode.registerKeybinding('DOM_Ctrl_RightCurlyBracket_Down',
    'TP.sig.UIFocusFollowing');
TP.dom.UIElementNode.registerKeybinding('DOM_Ctrl_LeftCurlyBracket_Down',
    'TP.sig.UIFocusPreceding');

//  Focus first/last field in current group.
TP.dom.UIElementNode.registerKeybinding('DOM_PageUp_Down',
    'TP.sig.UIFocusFirstInGroup');
TP.dom.UIElementNode.registerKeybinding('DOM_PageDown_Down',
    'TP.sig.UIFocusLastInGroup');

//  Focus first in next/previous group.
TP.dom.UIElementNode.registerKeybinding('DOM_Ctrl_RightSquareBracket_Down',
    'TP.sig.UIFocusFirstInNextGroup');
TP.dom.UIElementNode.registerKeybinding('DOM_Ctrl_LeftSquareBracket_Down',
    'TP.sig.UIFocusFirstInPreviousGroup');

TP.boot.$$srcPath = '~lib_dat/TP.dat.COUNTRYCODES.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
/*
 * International country codes by abbreviation (code) and name.
 */

(function() {

    /* eslint-disable quote-props */
    TP.dat.defineConstant('COUNTRY_BY_CODE', TP.hc({
        'AF': 'Afghanistan',
        'AX': 'Åland Islands',
        'AL': 'Albania',
        'DZ': 'Algeria',
        'AS': 'American Samoa',
        'AD': 'Andorra',
        'AO': 'Angola',
        'AI': 'Anguilla',
        'AQ': 'Antarctica',
        'AG': 'Antigua and Barbuda',
        'AR': 'Argentina',
        'AM': 'Armenia',
        'AW': 'Aruba',
        'AU': 'Australia',
        'AT': 'Austria',
        'AZ': 'Azerbaijan',
        'BS': 'Bahamas',
        'BH': 'Bahrain',
        'BD': 'Bangladesh',
        'BB': 'Barbados',
        'BY': 'Belarus',
        'BE': 'Belgium',
        'BZ': 'Belize',
        'BJ': 'Benin',
        'BM': 'Bermuda',
        'BT': 'Bhutan',
        'BO': 'Bolivia, Plurinational State of',
        'BQ': 'Bonaire, Sint Eustatius and Saba',
        'BA': 'Bosnia and Herzegovina',
        'BW': 'Botswana',
        'BV': 'Bouvet Island',
        'BR': 'Brazil',
        'IO': 'British Indian Ocean Territory',
        'BN': 'Brunei Darussalam',
        'BG': 'Bulgaria',
        'BF': 'Burkina Faso',
        'BI': 'Burundi',
        'KH': 'Cambodia',
        'CM': 'Cameroon',
        'CA': 'Canada',
        'CV': 'Cape Verde',
        'KY': 'Cayman Islands',
        'CF': 'Central African Republic',
        'TD': 'Chad',
        'CL': 'Chile',
        'CN': 'China',
        'CX': 'Christmas Island',
        'CC': 'Cocos (Keeling) Islands',
        'CO': 'Colombia',
        'KM': 'Comoros',
        'CG': 'Congo',
        'CD': 'Congo, the Democratic Republic of the',
        'CK': 'Cook Islands',
        'CR': 'Costa Rica',
        'CI': 'Côte d\'Ivoire',
        'HR': 'Croatia',
        'CU': 'Cuba',
        'CW': 'Curaçao',
        'CY': 'Cyprus',
        'CZ': 'Czech Republic',
        'DK': 'Denmark',
        'DJ': 'Djibouti',
        'DM': 'Dominica',
        'DO': 'Dominican Republic',
        'EC': 'Ecuador',
        'EG': 'Egypt',
        'SV': 'El Salvador',
        'GQ': 'Equatorial Guinea',
        'ER': 'Eritrea',
        'EE': 'Estonia',
        'ET': 'Ethiopia',
        'FK': 'Falkland Islands (Malvinas)',
        'FO': 'Faroe Islands',
        'FJ': 'Fiji',
        'FI': 'Finland',
        'FR': 'France',
        'GF': 'French Guiana',
        'PF': 'French Polynesia',
        'TF': 'French Southern Territories',
        'GA': 'Gabon',
        'GM': 'Gambia',
        'GE': 'Georgia',
        'DE': 'Germany',
        'GH': 'Ghana',
        'GI': 'Gibraltar',
        'GR': 'Greece',
        'GL': 'Greenland',
        'GD': 'Grenada',
        'GP': 'Guadeloupe',
        'GU': 'Guam',
        'GT': 'Guatemala',
        'GG': 'Guernsey',
        'GN': 'Guinea',
        'GW': 'Guinea-Bissau',
        'GY': 'Guyana',
        'HT': 'Haiti',
        'HM': 'Heard Island and McDonald Islands',
        'VA': 'Holy See (Vatican City State)',
        'HN': 'Honduras',
        'HK': 'Hong Kong',
        'HU': 'Hungary',
        'IS': 'Iceland',
        'IN': 'India',
        'ID': 'Indonesia',
        'IR': 'Iran, Islamic Republic of',
        'IQ': 'Iraq',
        'IE': 'Ireland',
        'IM': 'Isle of Man',
        'IL': 'Israel',
        'IT': 'Italy',
        'JM': 'Jamaica',
        'JP': 'Japan',
        'JE': 'Jersey',
        'JO': 'Jordan',
        'KZ': 'Kazakhstan',
        'KE': 'Kenya',
        'KI': 'Kiribati',
        'KP': 'Korea, Democratic People\'s Republic of',
        'KR': 'Korea, Republic of',
        'KW': 'Kuwait',
        'KG': 'Kyrgyzstan',
        'LA': 'Lao People\'s Democratic Republic',
        'LV': 'Latvia',
        'LB': 'Lebanon',
        'LS': 'Lesotho',
        'LR': 'Liberia',
        'LY': 'Libya',
        'LI': 'Liechtenstein',
        'LT': 'Lithuania',
        'LU': 'Luxembourg',
        'MO': 'Macao',
        'MK': 'Macedonia, the Former Yugoslav Republic of',
        'MG': 'Madagascar',
        'MW': 'Malawi',
        'MY': 'Malaysia',
        'MV': 'Maldives',
        'ML': 'Mali',
        'MT': 'Malta',
        'MH': 'Marshall Islands',
        'MQ': 'Martinique',
        'MR': 'Mauritania',
        'MU': 'Mauritius',
        'YT': 'Mayotte',
        'MX': 'Mexico',
        'FM': 'Micronesia, Federated States of',
        'MD': 'Moldova, Republic of',
        'MC': 'Monaco',
        'MN': 'Mongolia',
        'ME': 'Montenegro',
        'MS': 'Montserrat',
        'MA': 'Morocco',
        'MZ': 'Mozambique',
        'MM': 'Myanmar',
        'NA': 'Namibia',
        'NR': 'Nauru',
        'NP': 'Nepal',
        'NL': 'Netherlands',
        'NC': 'New Caledonia',
        'NZ': 'New Zealand',
        'NI': 'Nicaragua',
        'NE': 'Niger',
        'NG': 'Nigeria',
        'NU': 'Niue',
        'NF': 'Norfolk Island',
        'MP': 'Northern Mariana Islands',
        'NO': 'Norway',
        'OM': 'Oman',
        'PK': 'Pakistan',
        'PW': 'Palau',
        'PS': 'Palestine, State of',
        'PA': 'Panama',
        'PG': 'Papua New Guinea',
        'PY': 'Paraguay',
        'PE': 'Peru',
        'PH': 'Philippines',
        'PN': 'Pitcairn',
        'PL': 'Poland',
        'PT': 'Portugal',
        'PR': 'Puerto Rico',
        'QA': 'Qatar',
        'RE': 'Réunion',
        'RO': 'Romania',
        'RU': 'Russian Federation',
        'RW': 'Rwanda',
        'BL': 'Saint Barthélemy',
        'SH': 'Saint Helena, Ascension and Tristan da Cunha',
        'KN': 'Saint Kitts and Nevis',
        'LC': 'Saint Lucia',
        'MF': 'Saint Martin (French part)',
        'PM': 'Saint Pierre and Miquelon',
        'VC': 'Saint Vincent and the Grenadines',
        'WS': 'Samoa',
        'SM': 'San Marino',
        'ST': 'Sao Tome and Principe',
        'SA': 'Saudi Arabia',
        'SN': 'Senegal',
        'RS': 'Serbia',
        'SC': 'Seychelles',
        'SL': 'Sierra Leone',
        'SG': 'Singapore',
        'SX': 'Sint Maarten (Dutch part)',
        'SK': 'Slovakia',
        'SI': 'Slovenia',
        'SB': 'Solomon Islands',
        'SO': 'Somalia',
        'ZA': 'South Africa',
        'GS': 'South Georgia and the South Sandwich Islands',
        'SS': 'South Sudan',
        'ES': 'Spain',
        'LK': 'Sri Lanka',
        'SD': 'Sudan',
        'SR': 'Suriname',
        'SJ': 'Svalbard and Jan Mayen',
        'SZ': 'Swaziland',
        'SE': 'Sweden',
        'CH': 'Switzerland',
        'SY': 'Syrian Arab Republic',
        'TW': 'Taiwan, Province of China',
        'TJ': 'Tajikistan',
        'TZ': 'Tanzania, United Republic of',
        'TH': 'Thailand',
        //  No country code for Tibet. :(
        'TL': 'Timor-Leste',
        'TG': 'Togo',
        'TK': 'Tokelau',
        'TO': 'Tonga',
        'TT': 'Trinidad and Tobago',
        'TN': 'Tunisia',
        'TR': 'Turkey',
        'TM': 'Turkmenistan',
        'TC': 'Turks and Caicos Islands',
        'TV': 'Tuvalu',
        'UG': 'Uganda',
        'UA': 'Ukraine',
        'AE': 'United Arab Emirates',
        'GB': 'United Kingdom',
        'US': 'United States',
        'UM': 'United States Minor Outlying Islands',
        'UY': 'Uruguay',
        'UZ': 'Uzbekistan',
        'VU': 'Vanuatu',
        'VE': 'Venezuela, Bolivarian Republic of',
        'VN': 'Viet Nam',
        'VG': 'Virgin Islands, British',
        'VI': 'Virgin Islands, U.S.',
        'WF': 'Wallis and Futuna',
        'EH': 'Western Sahara',
        'YE': 'Yemen',
        'ZM': 'Zambia',
        'ZW': 'Zimbabwe'
    }));

    TP.dat.defineConstant('COUNTRY_BY_NAME', TP.hc({
        'Afghanistan': 'AF',
        'Åland Islands': 'AX',
        'Albania': 'AL',
        'Algeria': 'DZ',
        'American Samoa': 'AS',
        'Andorra': 'AD',
        'Angola': 'AO',
        'Anguilla': 'AI',
        'Antarctica': 'AQ',
        'Antigua and Barbuda': 'AG',
        'Argentina': 'AR',
        'Armenia': 'AM',
        'Aruba': 'AW',
        'Australia': 'AU',
        'Austria': 'AT',
        'Azerbaijan': 'AZ',
        'Bahamas': 'BS',
        'Bahrain': 'BH',
        'Bangladesh': 'BD',
        'Barbados': 'BB',
        'Belarus': 'BY',
        'Belgium': 'BE',
        'Belize': 'BZ',
        'Benin': 'BJ',
        'Bermuda': 'BM',
        'Bhutan': 'BT',
        'Bolivia, Plurinational State of': 'BO',
        'Bonaire, Sint Eustatius and Saba': 'BQ',
        'Bosnia and Herzegovina': 'BA',
        'Botswana': 'BW',
        'Bouvet Island': 'BV',
        'Brazil': 'BR',
        'British Indian Ocean Territory': 'IO',
        'Brunei Darussalam': 'BN',
        'Bulgaria': 'BG',
        'Burkina Faso': 'BF',
        'Burundi': 'BI',
        'Cambodia': 'KH',
        'Cameroon': 'CM',
        'Canada': 'CA',
        'Cape Verde': 'CV',
        'Cayman Islands': 'KY',
        'Central African Republic': 'CF',
        'Chad': 'TD',
        'Chile': 'CL',
        'China': 'CN',
        'Christmas Island': 'CX',
        'Cocos (Keeling) Islands': 'CC',
        'Colombia': 'CO',
        'Comoros': 'KM',
        'Congo': 'CG',
        'Congo, the Democratic Republic of the': 'CD',
        'Cook Islands': 'CK',
        'Costa Rica': 'CR',
        'Côte d\'Ivoire': 'CI',
        'Croatia': 'HR',
        'Cuba': 'CU',
        'Curaçao': 'CW',
        'Cyprus': 'CY',
        'Czech Republic': 'CZ',
        'Denmark': 'DK',
        'Djibouti': 'DJ',
        'Dominica': 'DM',
        'Dominican Republic': 'DO',
        'Ecuador': 'EC',
        'Egypt': 'EG',
        'El Salvador': 'SV',
        'Equatorial Guinea': 'GQ',
        'Eritrea': 'ER',
        'Estonia': 'EE',
        'Ethiopia': 'ET',
        'Falkland Islands (Malvinas)': 'FK',
        'Faroe Islands': 'FO',
        'Fiji': 'FJ',
        'Finland': 'FI',
        'France': 'FR',
        'French Guiana': 'GF',
        'French Polynesia': 'PF',
        'French Southern Territories': 'TF',
        'Gabon': 'GA',
        'Gambia': 'GM',
        'Georgia': 'GE',
        'Germany': 'DE',
        'Ghana': 'GH',
        'Gibraltar': 'GI',
        'Greece': 'GR',
        'Greenland': 'GL',
        'Grenada': 'GD',
        'Guadeloupe': 'GP',
        'Guam': 'GU',
        'Guatemala': 'GT',
        'Guernsey': 'GG',
        'Guinea': 'GN',
        'Guinea-Bissau': 'GW',
        'Guyana': 'GY',
        'Haiti': 'HT',
        'Heard Island and McDonald Islands': 'HM',
        'Holy See (Vatican City State)': 'VA',
        'Honduras': 'HN',
        'Hong Kong': 'HK',
        'Hungary': 'HU',
        'Iceland': 'IS',
        'India': 'IN',
        'Indonesia': 'ID',
        'Iran, Islamic Republic of': 'IR',
        'Iraq': 'IQ',
        'Ireland': 'IE',
        'Isle of Man': 'IM',
        'Israel': 'IL',
        'Italy': 'IT',
        'Jamaica': 'JM',
        'Japan': 'JP',
        'Jersey': 'JE',
        'Jordan': 'JO',
        'Kazakhstan': 'KZ',
        'Kenya': 'KE',
        'Kiribati': 'KI',
        'Korea, Democratic People\'s Republic of': 'KP',
        'Korea, Republic of': 'KR',
        'Kuwait': 'KW',
        'Kyrgyzstan': 'KG',
        'Lao People\'s Democratic Republic': 'LA',
        'Latvia': 'LV',
        'Lebanon': 'LB',
        'Lesotho': 'LS',
        'Liberia': 'LR',
        'Libya': 'LY',
        'Liechtenstein': 'LI',
        'Lithuania': 'LT',
        'Luxembourg': 'LU',
        'Macao': 'MO',
        'Macedonia, the Former Yugoslav Republic of': 'MK',
        'Madagascar': 'MG',
        'Malawi': 'MW',
        'Malaysia': 'MY',
        'Maldives': 'MV',
        'Mali': 'ML',
        'Malta': 'MT',
        'Marshall Islands': 'MH',
        'Martinique': 'MQ',
        'Mauritania': 'MR',
        'Mauritius': 'MU',
        'Mayotte': 'YT',
        'Mexico': 'MX',
        'Micronesia, Federated States of': 'FM',
        'Moldova, Republic of': 'MD',
        'Monaco': 'MC',
        'Mongolia': 'MN',
        'Montenegro': 'ME',
        'Montserrat': 'MS',
        'Morocco': 'MA',
        'Mozambique': 'MZ',
        'Myanmar': 'MM',
        'Namibia': 'NA',
        'Nauru': 'NR',
        'Nepal': 'NP',
        'Netherlands': 'NL',
        'New Caledonia': 'NC',
        'New Zealand': 'NZ',
        'Nicaragua': 'NI',
        'Niger': 'NE',
        'Nigeria': 'NG',
        'Niue': 'NU',
        'Norfolk Island': 'NF',
        'Northern Mariana Islands': 'MP',
        'Norway': 'NO',
        'Oman': 'OM',
        'Pakistan': 'PK',
        'Palau': 'PW',
        'Palestine, State of': 'PS',
        'Panama': 'PA',
        'Papua New Guinea': 'PG',
        'Paraguay': 'PY',
        'Peru': 'PE',
        'Philippines': 'PH',
        'Pitcairn': 'PN',
        'Poland': 'PL',
        'Portugal': 'PT',
        'Puerto Rico': 'PR',
        'Qatar': 'QA',
        'Réunion': 'RE',
        'Romania': 'RO',
        'Russian Federation': 'RU',
        'Rwanda': 'RW',
        'Saint Barthélemy': 'BL',
        'Saint Helena, Ascension and Tristan da Cunha': 'SH',
        'Saint Kitts and Nevis': 'KN',
        'Saint Lucia': 'LC',
        'Saint Martin (French part)': 'MF',
        'Saint Pierre and Miquelon': 'PM',
        'Saint Vincent and the Grenadines': 'VC',
        'Samoa': 'WS',
        'San Marino': 'SM',
        'Sao Tome and Principe': 'ST',
        'Saudi Arabia': 'SA',
        'Senegal': 'SN',
        'Serbia': 'RS',
        'Seychelles': 'SC',
        'Sierra Leone': 'SL',
        'Singapore': 'SG',
        'Sint Maarten (Dutch part)': 'SX',
        'Slovakia': 'SK',
        'Slovenia': 'SI',
        'Solomon Islands': 'SB',
        'Somalia': 'SO',
        'South Africa': 'ZA',
        'South Georgia and the South Sandwich Islands': 'GS',
        'South Sudan': 'SS',
        'Spain': 'ES',
        'Sri Lanka': 'LK',
        'Sudan': 'SD',
        'Suriname': 'SR',
        'Svalbard and Jan Mayen': 'SJ',
        'Swaziland': 'SZ',
        'Sweden': 'SE',
        'Switzerland': 'CH',
        'Syrian Arab Republic': 'SY',
        'Taiwan, Province of China': 'TW',
        'Tajikistan': 'TJ',
        'Tanzania, United Republic of': 'TZ',
        'Thailand': 'TH',
        //  No country code for Tibet. :(
        'Timor-Leste': 'TL',
        'Togo': 'TG',
        'Tokelau': 'TK',
        'Tonga': 'TO',
        'Trinidad and Tobago': 'TT',
        'Tunisia': 'TN',
        'Turkey': 'TR',
        'Turkmenistan': 'TM',
        'Turks and Caicos Islands': 'TC',
        'Tuvalu': 'TV',
        'Uganda': 'UG',
        'Ukraine': 'UA',
        'United Arab Emirates': 'AE',
        'United Kingdom': 'GB',
        'United States': 'US',
        'United States Minor Outlying Islands': 'UM',
        'Uruguay': 'UY',
        'Uzbekistan': 'UZ',
        'Vanuatu': 'VU',
        'Venezuela, Bolivarian Republic of': 'VE',
        'Viet Nam': 'VN',
        'Virgin Islands, British': 'VG',
        'Virgin Islands, U.S.': 'VI',
        'Wallis and Futuna': 'WF',
        'Western Sahara': 'EH',
        'Yemen': 'YE',
        'Zambia': 'ZM',
        'Zimbabwe': 'ZW'
    }));

}());
TP.boot.$$srcPath = '~lib_dat/TP.dat.STATECODES.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
/**
 * Simple state code lists in both abbreviation and name order.
 */

(function() {
    /* eslint-disable quote-props */
    TP.dat.defineConstant('STATE_BY_CODE', TP.hc({
        'AL': 'Alabama',
        'AK': 'Alaska',
        'AS': 'American Samoa',
        'AZ': 'Arizona',
        'AR': 'Arkansas',
        'CA': 'California',
        'CO': 'Colorado',
        'CT': 'Connecticut',
        'DE': 'Delaware',
        'DC': 'District Of Columbia',
        'FM': 'Federated States Of Micronesia',
        'FL': 'Florida',
        'GA': 'Georgia',
        'GU': 'Guam',
        'HI': 'Hawaii',
        'ID': 'Idaho',
        'IL': 'Illinois',
        'IN': 'Indiana',
        'IA': 'Iowa',
        'KS': 'Kansas',
        'KY': 'Kentucky',
        'LA': 'Louisiana',
        'ME': 'Maine',
        'MH': 'Marshall Islands',
        'MD': 'Maryland',
        'MA': 'Massachusetts',
        'MI': 'Michigan',
        'MN': 'Minnesota',
        'MS': 'Mississippi',
        'MO': 'Missouri',
        'MT': 'Montana',
        'NE': 'Nebraska',
        'NV': 'Nevada',
        'NH': 'New Hampshire',
        'NJ': 'New Jersey',
        'NM': 'New Mexico',
        'NY': 'New York',
        'NC': 'North Carolina',
        'ND': 'North Dakota',
        'MP': 'Northern Mariana Islands',
        'OH': 'Ohio',
        'OK': 'Oklahoma',
        'OR': 'Oregon',
        'PW': 'Palau',
        'PA': 'Pennsylvania',
        'PR': 'Puerto Rico',
        'RI': 'Rhode Island',
        'SC': 'South Carolina',
        'SD': 'South Dakota',
        'TN': 'Tennessee',
        'TX': 'Texas',
        'UT': 'Utah',
        'VT': 'Vermont',
        'VI': 'Virgin Islands',
        'VA': 'Virginia',
        'WA': 'Washington',
        'WV': 'West Virginia',
        'WI': 'Wisconsin',
        'WY': 'Wyoming'
    }));

    TP.dat.defineConstant('STATE_BY_NAME', TP.hc({
        'Alabama': 'AL',
        'Alaska': 'AK',
        'American Samoa': 'AS',
        'Arizona': 'AZ',
        'Arkansas': 'AR',
        'California': 'CA',
        'Colorado': 'CO',
        'Connecticut': 'CT',
        'Delaware': 'DE',
        'District Of Columbia': 'DC',
        'Federated States Of Micronesia': 'FM',
        'Florida': 'FL',
        'Georgia': 'GA',
        'Guam': 'GU',
        'Hawaii': 'HI',
        'Idaho': 'ID',
        'Illinois': 'IL',
        'Indiana': 'IN',
        'Iowa': 'IA',
        'Kansas': 'KS',
        'Kentucky': 'KY',
        'Louisiana': 'LA',
        'Maine': 'ME',
        'Marshall Islands': 'MH',
        'Maryland': 'MD',
        'Massachusetts': 'MA',
        'Michigan': 'MI',
        'Minnesota': 'MN',
        'Mississippi': 'MS',
        'Missouri': 'MO',
        'Montana': 'MT',
        'Nebraska': 'NE',
        'Nevada': 'NV',
        'New Hampshire': 'NH',
        'New Jersey': 'NJ',
        'New Mexico': 'NM',
        'New York': 'NY',
        'North Carolina': 'NC',
        'North Dakota': 'ND',
        'Northern Mariana Islands': 'MP',
        'Ohio': 'OH',
        'Oklahoma': 'OK',
        'Oregon': 'OR',
        'Palau': 'PW',
        'Pennsylvania': 'PA',
        'Puerto Rico': 'PR',
        'Rhode Island': 'RI',
        'South Carolina': 'SC',
        'South Dakota': 'SD',
        'Tennessee': 'TN',
        'Texas': 'TX',
        'Utah': 'UT',
        'Vermont': 'VT',
        'Virgin Islands': 'VI',
        'Virginia': 'VA',
        'Washington': 'WA',
        'West Virginia': 'WV',
        'Wisconsin': 'WI',
        'Wyoming': 'WY'
    }));
}());
TP.boot.$$srcPath = '~lib_schema/html401_strict.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_kernel.xml';
TP.boot.$$srcConfig = 'base';
(function() {
    var dtdInfo;

    dtdInfo = '{"entity":{"heading":{"type":"param","value":["h1","h2","h3","h4","h5","h6"]},"special":{"type":"param","value":["a","img","object","br","script","map","q","sub","sup","span","bdo"]},"flow":{"type":"param","value":["p","h1","h2","h3","h4","h5","h6","ul","ol","pre","dl","div","noscript","blockquote","form","hr","table","fieldset","address","#pcdata","tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"]},"TFrame":{"type":"param","value":["void","above","below","hsides","lhs","rhs","vsides","box","border"]},"list":{"type":"param","value":["ul","ol"]},"inline":{"type":"param","value":["#pcdata","tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"]},"head.misc":{"type":"param","value":["script","style","meta","link","object"]},"TRules":{"type":"param","value":["none","groups","rows","cols","all"]},"Shape":{"type":"param","value":["rect","circle","poly","default"]},"InputType":{"type":"param","value":["text","password","checkbox","radio","submit","reset","file","hidden","image","button"]},"pre.exclusion":{"type":"param","value":["img","object","big","small","sub","sup"]},"formctrl":{"type":"param","value":["input","select","textarea","label","button"]},"fontstyle":{"type":"param","value":["tt","i","b","big","small"]},"Scope":{"type":"param","value":["row","col","rowgroup","colgroup"]},"phrase":{"type":"param","value":["em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym"]},"TAlign":{"type":"param","value":["left","center","right"]},"block":{"type":"param","value":["p","h1","h2","h3","h4","h5","h6","ul","ol","pre","dl","div","noscript","blockquote","form","hr","table","fieldset","address"]}},"element":{"input":{"attributes":{"ondblclick":{"default":"","type":"#implied","value":"cdata"},"onchange":{"default":"","type":"#implied","value":"cdata"},"readonly":{"default":"","type":"#implied","value":"readonly"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"src":{"default":"","type":"#implied","value":"cdata"},"value":{"default":"","type":"#implied","value":"cdata"},"name":{"default":"","type":"#implied","value":"cdata"},"checked":{"default":"","type":"#implied","value":"checked"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"},"type":{"default":"text","type":"","value":"text password checkbox radio submit reset file hidden image button"},"accesskey":{"default":"","type":"#implied","value":"cdata"},"disabled":{"default":"","type":"#implied","value":"disabled"},"usemap":{"default":"","type":"#implied","value":"cdata"},"ismap":{"default":"","type":"#implied","value":"ismap"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"size":{"default":"","type":"#implied","value":"cdata"},"onblur":{"default":"","type":"#implied","value":"cdata"},"onfocus":{"default":"","type":"#implied","value":"cdata"},"maxlength":{"default":"","type":"#implied","value":"number"},"onselect":{"default":"","type":"#implied","value":"cdata"},"accept":{"default":"","type":"#implied","value":"cdata"},"alt":{"default":"","type":"#implied","value":"cdata"},"tabindex":{"default":"","type":"#implied","value":"number"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{},"empty":true,"omitStart":false,"omitEnd":true,"text":false},"acronym":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"span":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"fieldset":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"sequenceGroup":{"children":[{"orGroup":{"children":[],"elements":["p","h1","h2","h3","h4","h5","h6","ul","ol","pre","dl","div","noscript","blockquote","form","hr","table","fieldset","address","tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}],"elements":["legend"],"text":true}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"h3":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"option":{"attributes":{"disabled":{"default":"","type":"#implied","value":"disabled"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"value":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"label":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"},"selected":{"default":"","type":"#implied","value":"selected"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"sequenceGroup":{"children":[],"elements":[],"text":true}}]},"empty":false,"omitStart":false,"omitEnd":true,"text":false},"optgroup":{"attributes":{"disabled":{"default":"","type":"#implied","value":"disabled"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"label":{"default":"","type":"#required","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{"expanded":[{"sequenceGroup":{"children":[],"elements":["option"],"text":false}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"del":{"attributes":{"ondblclick":{"default":"","type":"#implied","value":"cdata"},"datetime":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"cite":{"default":"","type":"#implied","value":"cdata"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["p","h1","h2","h3","h4","h5","h6","ul","ol","pre","dl","div","noscript","blockquote","form","hr","table","fieldset","address","tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"sub":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"meta":{"attributes":{"http-equiv":{"default":"","type":"#implied","value":"name"},"lang":{"default":"","type":"#implied","value":"name"},"content":{"default":"","type":"#required","value":"cdata"},"name":{"default":"","type":"#implied","value":"name"},"scheme":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{},"empty":true,"omitStart":false,"omitEnd":true,"text":false},"sup":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"hr":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{},"empty":true,"omitStart":false,"omitEnd":true,"text":false},"title":{"attributes":{"lang":{"default":"","type":"#implied","value":"name"},"dir":{"default":"","type":"#implied","value":"ltr rtl"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"sequenceGroup":{"children":[],"elements":[],"text":true}}],"exclusions":[{"orGroup":{"children":[],"elements":["script","style","meta","link","object"],"text":false}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"body":{"attributes":{"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onunload":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onload":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["p","h1","h2","h3","h4","h5","h6","ul","ol","pre","dl","div","noscript","blockquote","form","hr","table","fieldset","address","script"],"text":false,"occurrence":"+"}}],"inclusions":[{"orGroup":{"children":[],"elements":["ins","del"],"text":false}}]},"empty":false,"omitStart":true,"omitEnd":true,"text":false},"noscript":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["p","h1","h2","h3","h4","h5","h6","ul","ol","pre","dl","div","noscript","blockquote","form","hr","table","fieldset","address"],"text":false,"occurrence":"+"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"base":{"attributes":{"href":{"default":"","type":"#required","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{},"empty":true,"omitStart":false,"omitEnd":true,"text":false},"em":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"col":{"attributes":{"width":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"charoff":{"default":"","type":"#implied","value":"cdata"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"align":{"default":"","type":"#implied","value":"left center right justify char"},"lang":{"default":"","type":"#implied","value":"name"},"valign":{"default":"","type":"#implied","value":"top middle bottom baseline"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"char":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"},"span":{"default":"1","type":"","value":"number"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{},"empty":true,"omitStart":false,"omitEnd":true,"text":false},"table":{"attributes":{"width":{"default":"","type":"#implied","value":"cdata"},"frame":{"default":"","type":"#implied","value":"void above below hsides lhs rhs vsides box border"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"rules":{"default":"","type":"#implied","value":"none groups rows cols all"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"datapagesize":{"default":"","type":"#implied","value":"cdata"},"summary":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"cellspacing":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"border":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"cellpadding":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{"expanded":[{"sequenceGroup":{"children":[{"orGroup":{"children":[],"elements":["col","colgroup"],"text":false}}],"elements":["caption","thead","tfoot","tbody"],"text":false}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"button":{"attributes":{"accesskey":{"default":"","type":"#implied","value":"cdata"},"disabled":{"default":"","type":"#implied","value":"disabled"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"onblur":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onfocus":{"default":"","type":"#implied","value":"cdata"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"tabindex":{"default":"","type":"#implied","value":"number"},"lang":{"default":"","type":"#implied","value":"name"},"value":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"name":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"type":{"default":"submit","type":"","value":"button submit reset"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["p","h1","h2","h3","h4","h5","h6","ul","ol","pre","dl","div","noscript","blockquote","form","hr","table","fieldset","address","tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}],"exclusions":[{"orGroup":{"children":[],"elements":["a","input","select","textarea","label","button","form","fieldset"],"text":false}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"head":{"attributes":{"profile":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"dir":{"default":"","type":"#implied","value":"ltr rtl"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{"expanded":[{"andGroup":[]}],"inclusions":[{"orGroup":{"children":[],"elements":["script","style","meta","link","object"],"text":false}}]},"empty":false,"omitStart":true,"omitEnd":true,"text":false},"caption":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"q":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"cite":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"tr":{"attributes":{"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"charoff":{"default":"","type":"#implied","value":"cdata"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"align":{"default":"","type":"#implied","value":"left center right justify char"},"valign":{"default":"","type":"#implied","value":"top middle bottom baseline"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"char":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["th","td"],"text":false,"occurrence":"+"}}]},"empty":false,"omitStart":false,"omitEnd":true,"text":false},"ol":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{"expanded":[{"sequenceGroup":{"children":[],"elements":["li"],"text":false}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"tbody":{"attributes":{"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"charoff":{"default":"","type":"#implied","value":"cdata"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"align":{"default":"","type":"#implied","value":"left center right justify char"},"valign":{"default":"","type":"#implied","value":"top middle bottom baseline"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"char":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{"expanded":[{"sequenceGroup":{"children":[],"elements":["tr"],"text":false}}]},"empty":false,"omitStart":true,"omitEnd":true,"text":false},"legend":{"attributes":{"accesskey":{"default":"","type":"#implied","value":"cdata"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"p":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":true,"text":false},"code":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"dd":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["p","h1","h2","h3","h4","h5","h6","ul","ol","pre","dl","div","noscript","blockquote","form","hr","table","fieldset","address","tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":true,"text":false},"kbd":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"area":{"attributes":{"accesskey":{"default":"","type":"#implied","value":"cdata"},"coords":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"onblur":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onfocus":{"default":"","type":"#implied","value":"cdata"},"nohref":{"default":"","type":"#implied","value":"nohref"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"href":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"tabindex":{"default":"","type":"#implied","value":"number"},"alt":{"default":"","type":"#required","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"},"shape":{"default":"rect","type":"","value":"rect circle poly default"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{},"empty":true,"omitStart":false,"omitEnd":true,"text":false},"h4":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"th":{"attributes":{"headers":{"default":"","type":"#implied","value":"idrefs"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"axis":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"abbr":{"default":"","type":"#implied","value":"cdata"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"colspan":{"default":"1","type":"","value":"number"},"rowspan":{"default":"1","type":"","value":"number"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"charoff":{"default":"","type":"#implied","value":"cdata"},"scope":{"default":"","type":"#implied","value":"row col rowgroup colgroup"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"align":{"default":"","type":"#implied","value":"left center right justify char"},"lang":{"default":"","type":"#implied","value":"name"},"valign":{"default":"","type":"#implied","value":"top middle bottom baseline"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"char":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["p","h1","h2","h3","h4","h5","h6","ul","ol","pre","dl","div","noscript","blockquote","form","hr","table","fieldset","address","tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":true,"text":false},"style":{"attributes":{"lang":{"default":"","type":"#implied","value":"name"},"media":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"type":{"default":"","type":"#required","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"}},"cdata":true,"childElements":[],"contentType":"cdata","contentModel":{"expanded":[]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"ins":{"attributes":{"ondblclick":{"default":"","type":"#implied","value":"cdata"},"datetime":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"cite":{"default":"","type":"#implied","value":"cdata"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["p","h1","h2","h3","h4","h5","h6","ul","ol","pre","dl","div","noscript","blockquote","form","hr","table","fieldset","address","tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"h6":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"cite":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"big":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"abbr":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"ul":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{"expanded":[{"sequenceGroup":{"children":[],"elements":["li"],"text":false}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"img":{"attributes":{"width":{"default":"","type":"#implied","value":"cdata"},"ismap":{"default":"","type":"#implied","value":"ismap"},"usemap":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"alt":{"default":"","type":"#required","value":"cdata"},"longdesc":{"default":"","type":"#implied","value":"cdata"},"src":{"default":"","type":"#required","value":"cdata"},"name":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"height":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{},"empty":true,"omitStart":false,"omitEnd":true,"text":false},"dl":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["dt","dd"],"text":false,"occurrence":"+"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"h5":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"samp":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"map":{"attributes":{"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"name":{"default":"","type":"#required","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{"expanded":[{"orGroup":{"children":[{"orGroup":{"children":[],"elements":["p","h1","h2","h3","h4","h5","h6","ul","ol","pre","dl","div","noscript","blockquote","form","hr","table","fieldset","address"],"text":false}}],"elements":["area"],"text":false,"occurrence":"+"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"tfoot":{"attributes":{"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"charoff":{"default":"","type":"#implied","value":"cdata"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"align":{"default":"","type":"#implied","value":"left center right justify char"},"valign":{"default":"","type":"#implied","value":"top middle bottom baseline"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"char":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{"expanded":[{"sequenceGroup":{"children":[],"elements":["tr"],"text":false}}]},"empty":false,"omitStart":false,"omitEnd":true,"text":false},"dfn":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"h1":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"script":{"attributes":{"defer":{"default":"","type":"#implied","value":"defer"},"for":{"default":"","type":"#implied","value":"cdata"},"src":{"default":"","type":"#implied","value":"cdata"},"type":{"default":"","type":"#required","value":"cdata"},"charset":{"default":"","type":"#implied","value":"cdata"},"event":{"default":"","type":"#implied","value":"cdata"}},"cdata":true,"childElements":[],"contentType":"cdata","contentModel":{"expanded":[]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"link":{"attributes":{"rel":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"media":{"default":"","type":"#implied","value":"cdata"},"href":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"charset":{"default":"","type":"#implied","value":"cdata"},"hreflang":{"default":"","type":"#implied","value":"name"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"rev":{"default":"","type":"#implied","value":"cdata"},"type":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{},"empty":true,"omitStart":false,"omitEnd":true,"text":false},"div":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["p","h1","h2","h3","h4","h5","h6","ul","ol","pre","dl","div","noscript","blockquote","form","hr","table","fieldset","address","tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"h2":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"b":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"address":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"li":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["p","h1","h2","h3","h4","h5","h6","ul","ol","pre","dl","div","noscript","blockquote","form","hr","table","fieldset","address","tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":true,"text":false},"small":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"colgroup":{"attributes":{"width":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"charoff":{"default":"","type":"#implied","value":"cdata"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"align":{"default":"","type":"#implied","value":"left center right justify char"},"lang":{"default":"","type":"#implied","value":"name"},"valign":{"default":"","type":"#implied","value":"top middle bottom baseline"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"char":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"},"span":{"default":"1","type":"","value":"number"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{"expanded":[{"sequenceGroup":{"children":[],"elements":["col"],"text":false}}]},"empty":false,"omitStart":false,"omitEnd":true,"text":false},"var":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"i":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"textarea":{"attributes":{"accesskey":{"default":"","type":"#implied","value":"cdata"},"disabled":{"default":"","type":"#implied","value":"disabled"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"rows":{"default":"","type":"#required","value":"number"},"onblur":{"default":"","type":"#implied","value":"cdata"},"cols":{"default":"","type":"#required","value":"number"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onchange":{"default":"","type":"#implied","value":"cdata"},"onfocus":{"default":"","type":"#implied","value":"cdata"},"readonly":{"default":"","type":"#implied","value":"readonly"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"onselect":{"default":"","type":"#implied","value":"cdata"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"tabindex":{"default":"","type":"#implied","value":"number"},"lang":{"default":"","type":"#implied","value":"name"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"name":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"sequenceGroup":{"children":[],"elements":[],"text":true}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"thead":{"attributes":{"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"charoff":{"default":"","type":"#implied","value":"cdata"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"align":{"default":"","type":"#implied","value":"left center right justify char"},"valign":{"default":"","type":"#implied","value":"top middle bottom baseline"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"char":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{"expanded":[{"sequenceGroup":{"children":[],"elements":["tr"],"text":false}}]},"empty":false,"omitStart":false,"omitEnd":true,"text":false},"select":{"attributes":{"disabled":{"default":"","type":"#implied","value":"disabled"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"onblur":{"default":"","type":"#implied","value":"cdata"},"size":{"default":"","type":"#implied","value":"number"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onchange":{"default":"","type":"#implied","value":"cdata"},"onfocus":{"default":"","type":"#implied","value":"cdata"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"tabindex":{"default":"","type":"#implied","value":"number"},"lang":{"default":"","type":"#implied","value":"name"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"name":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"multiple":{"default":"","type":"#implied","value":"multiple"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["optgroup","option"],"text":false,"occurrence":"+"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"param":{"attributes":{"value":{"default":"","type":"#implied","value":"cdata"},"name":{"default":"","type":"#required","value":"cdata"},"type":{"default":"","type":"#implied","value":"cdata"},"valuetype":{"default":"data","type":"","value":"data ref object"},"id":{"default":"","type":"#implied","value":"id"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{},"empty":true,"omitStart":false,"omitEnd":true,"text":false},"label":{"attributes":{"accesskey":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"onblur":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onfocus":{"default":"","type":"#implied","value":"cdata"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"for":{"default":"","type":"#implied","value":"idref"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}],"exclusions":[{"sequenceGroup":{"children":[],"elements":["label"],"text":false}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"object":{"attributes":{"width":{"default":"","type":"#implied","value":"cdata"},"usemap":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"tabindex":{"default":"","type":"#implied","value":"number"},"standby":{"default":"","type":"#implied","value":"cdata"},"archive":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"classid":{"default":"","type":"#implied","value":"cdata"},"name":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"data":{"default":"","type":"#implied","value":"cdata"},"height":{"default":"","type":"#implied","value":"cdata"},"codetype":{"default":"","type":"#implied","value":"cdata"},"declare":{"default":"","type":"#implied","value":"declare"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"type":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"},"codebase":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["param","p","h1","h2","h3","h4","h5","h6","ul","ol","pre","dl","div","noscript","blockquote","form","hr","table","fieldset","address","tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"blockquote":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"cite":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["p","h1","h2","h3","h4","h5","h6","ul","ol","pre","dl","div","noscript","blockquote","form","hr","table","fieldset","address","script"],"text":false,"occurrence":"+"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"dt":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":true,"text":false},"html":{"attributes":{"lang":{"default":"","type":"#implied","value":"name"},"dir":{"default":"","type":"#implied","value":"ltr rtl"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{"expanded":[{"sequenceGroup":{"children":[],"elements":["head","body"],"text":false}}]},"empty":false,"omitStart":true,"omitEnd":true,"text":false},"a":{"attributes":{"accesskey":{"default":"","type":"#implied","value":"cdata"},"rel":{"default":"","type":"#implied","value":"cdata"},"coords":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"onblur":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onfocus":{"default":"","type":"#implied","value":"cdata"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"href":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"tabindex":{"default":"","type":"#implied","value":"number"},"lang":{"default":"","type":"#implied","value":"name"},"name":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"charset":{"default":"","type":"#implied","value":"cdata"},"hreflang":{"default":"","type":"#implied","value":"name"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"rev":{"default":"","type":"#implied","value":"cdata"},"shape":{"default":"rect","type":"","value":"rect circle poly default"},"type":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}],"exclusions":[{"sequenceGroup":{"children":[],"elements":["a"],"text":false}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"bdo":{"attributes":{"lang":{"default":"","type":"#implied","value":"name"},"style":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"dir":{"default":"","type":"#required","value":"ltr rtl"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"pre":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}],"exclusions":[{"orGroup":{"children":[],"elements":["img","object","big","small","sub","sup"],"text":false}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"br":{"attributes":{"style":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{},"empty":true,"omitStart":false,"omitEnd":true,"text":false},"tt":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"strong":{"attributes":{"onmouseover":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"class":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false},"td":{"attributes":{"headers":{"default":"","type":"#implied","value":"idrefs"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"axis":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"abbr":{"default":"","type":"#implied","value":"cdata"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"colspan":{"default":"1","type":"","value":"number"},"rowspan":{"default":"1","type":"","value":"number"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"id":{"default":"","type":"#implied","value":"id"},"charoff":{"default":"","type":"#implied","value":"cdata"},"scope":{"default":"","type":"#implied","value":"row col rowgroup colgroup"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"align":{"default":"","type":"#implied","value":"left center right justify char"},"lang":{"default":"","type":"#implied","value":"name"},"valign":{"default":"","type":"#implied","value":"top middle bottom baseline"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"char":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"mixed","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["p","h1","h2","h3","h4","h5","h6","ul","ol","pre","dl","div","noscript","blockquote","form","hr","table","fieldset","address","tt","i","b","big","small","em","strong","dfn","code","samp","kbd","var","cite","abbr","acronym","a","img","object","br","script","map","q","sub","sup","span","bdo","input","select","textarea","label","button"],"text":true,"occurrence":"*"}}]},"empty":false,"omitStart":false,"omitEnd":true,"text":false},"form":{"attributes":{"onsubmit":{"default":"","type":"#implied","value":"cdata"},"enctype":{"default":"application/x-www-form-urlencoded","type":"","value":"cdata"},"ondblclick":{"default":"","type":"#implied","value":"cdata"},"dir":{"default":"","type":"#implied","value":"ltr rtl"},"onkeydown":{"default":"","type":"#implied","value":"cdata"},"onkeyup":{"default":"","type":"#implied","value":"cdata"},"onreset":{"default":"","type":"#implied","value":"cdata"},"onmouseup":{"default":"","type":"#implied","value":"cdata"},"method":{"default":"get","type":"","value":"get post"},"id":{"default":"","type":"#implied","value":"id"},"onmouseover":{"default":"","type":"#implied","value":"cdata"},"accept":{"default":"","type":"#implied","value":"cdata"},"lang":{"default":"","type":"#implied","value":"name"},"name":{"default":"","type":"#implied","value":"cdata"},"style":{"default":"","type":"#implied","value":"cdata"},"onmousemove":{"default":"","type":"#implied","value":"cdata"},"onmouseout":{"default":"","type":"#implied","value":"cdata"},"accept-charset":{"default":"","type":"#implied","value":"cdata"},"onmousedown":{"default":"","type":"#implied","value":"cdata"},"onkeypress":{"default":"","type":"#implied","value":"cdata"},"action":{"default":"","type":"#required","value":"cdata"},"onclick":{"default":"","type":"#implied","value":"cdata"},"title":{"default":"","type":"#implied","value":"cdata"},"class":{"default":"","type":"#implied","value":"cdata"}},"cdata":false,"childElements":[],"contentType":"element","contentModel":{"expanded":[{"orGroup":{"children":[],"elements":["p","h1","h2","h3","h4","h5","h6","ul","ol","pre","dl","div","noscript","blockquote","form","hr","table","fieldset","address","script"],"text":false,"occurrence":"+"}}],"exclusions":[{"sequenceGroup":{"children":[],"elements":["form"],"text":false}}]},"empty":false,"omitStart":false,"omitEnd":false,"text":false}}}';

    TP.w3.DTDInfo.set('schemaInfo', dtdInfo);

}());
TP.boot.$$srcPath = '~lib_deps/xpath-tpi.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'parsers';
﻿/*
 * xpath.js
 *
 * An XPath 1.0 library for JavaScript.
 *
 * Cameron McCormack <cam (at) mcc.id.au>
 *
 *
 * Revision 20: April 26, 2011
 *   Fixed a typo resulting in FIRST_ORDERED_NODE_TYPE results being wrong,
 *   thanks to <shi_a009 (at) hotmail.com>.
 *
 * Revision 19: November 29, 2005
 *   Nodesets now store their nodes in a height balanced tree, increasing
 *   performance for the common case of selecting nodes in document order,
 *   thanks to Sébastien Cramatte <contact (at) zeninteractif.com>.
 *   AVL tree code adapted from Raimund Neumann <rnova (at) gmx.net>.
 *
 * Revision 18: October 27, 2005
 *   DOM 3 XPath support.  Caveats:
 *     - namespace prefixes aren't resolved in XPathEvaluator.createExpression,
 *       but in XPathExpression.evaluate.
 *     - XPathResult.invalidIteratorState is not implemented.
 *
 * Revision 17: October 25, 2005
 *   Some core XPath function fixes and a patch to avoid crashing certain
 *   versions of MSXML in PathExpr.prototype.getOwnerElement, thanks to
 *   Sébastien Cramatte <contact (at) zeninteractif.com>.
 *
 * Revision 16: September 22, 2005
 *   Workarounds for some IE 5.5 deficiencies.
 *   Fixed problem with prefix node tests on attribute nodes.
 *
 * Revision 15: May 21, 2005
 *   Fixed problem with QName node tests on elements with an xmlns="...".
 *
 * Revision 14: May 19, 2005
 *   Fixed QName node tests on attribute node regression.
 *
 * Revision 13: May 3, 2005
 *   Node tests are case insensitive now if working in an HTML DOM.
 *
 * Revision 12: April 26, 2005
 *   Updated licence.  Slight code changes to enable use of Dean
 *   Edwards' script compression, http://dean.edwards.name/packer/ .
 *
 * Revision 11: April 23, 2005
 *   Fixed bug with 'and' and 'or' operators, fix thanks to
 *   Sandy McArthur <sandy (at) mcarthur.org>.
 *
 * Revision 10: April 15, 2005
 *   Added support for a virtual root node, supposedly helpful for
 *   implementing XForms.  Fixed problem with QName node tests and
 *   the parent axis.
 *
 * Revision 9: March 17, 2005
 *   Namespace resolver tweaked so using the document node as the context
 *   for namespace lookups is equivalent to using the document element.
 *
 * Revision 8: February 13, 2005
 *   Handle implicit declaration of 'xmlns' namespace prefix.
 *   Fixed bug when comparing nodesets.
 *   Instance data can now be associated with a FunctionResolver, and
 *     workaround for MSXML not supporting 'localName' and 'getElementById',
 *     thanks to Grant Gongaware.
 *   Fix a few problems when the context node is the root node.
 *
 * Revision 7: February 11, 2005
 *   Default namespace resolver fix from Grant Gongaware
 *   <grant (at) gongaware.com>.
 *
 * Revision 6: February 10, 2005
 *   Fixed bug in 'number' function.
 *
 * Revision 5: February 9, 2005
 *   Fixed bug where text nodes not getting converted to string values.
 *
 * Revision 4: January 21, 2005
 *   Bug in 'name' function, fix thanks to Bill Edney.
 *   Fixed incorrect processing of namespace nodes.
 *   Fixed NamespaceResolver to resolve 'xml' namespace.
 *   Implemented union '|' operator.
 *
 * Revision 3: January 14, 2005
 *   Fixed bug with nodeset comparisons, bug lexing < and >.
 *
 * Revision 2: October 26, 2004
 *   QName node test namespace handling fixed.  Few other bug fixes.
 *
 * Revision 1: August 13, 2004
 *   Bug fixes from William J. Edney <bedney (at) technicalpursuit.com>.
 *   Added minimal licence.
 *
 * Initial version: June 14, 2004
 */

/*eslint indent:0, quotes:0, no-parameter-reassign:0, operator-linebreak:0, array-bracket-spacing:0, vars-on-top:0, one-var:0, init-declarations:0, newline-after-var:0,default-case:0*/

!function () {
// XPathParser ///////////////////////////////////////////////////////////////

XPathParser.prototype = new Object();
XPathParser.prototype.constructor = XPathParser;
XPathParser.superclass = Object.prototype;

function XPathParser() {
	this.init();
}

XPathParser.prototype.init = function() {
	this.reduceActions = [];

	this.reduceActions[3] = function(rhs) {
		return new OrOperation(rhs[0], rhs[2]);
	};
	this.reduceActions[5] = function(rhs) {
		return new AndOperation(rhs[0], rhs[2]);
	};
	this.reduceActions[7] = function(rhs) {
		return new EqualsOperation(rhs[0], rhs[2]);
	};
	this.reduceActions[8] = function(rhs) {
		return new NotEqualOperation(rhs[0], rhs[2]);
	};
	this.reduceActions[10] = function(rhs) {
		return new LessThanOperation(rhs[0], rhs[2]);
	};
	this.reduceActions[11] = function(rhs) {
		return new GreaterThanOperation(rhs[0], rhs[2]);
	};
	this.reduceActions[12] = function(rhs) {
		return new LessThanOrEqualOperation(rhs[0], rhs[2]);
	};
	this.reduceActions[13] = function(rhs) {
		return new GreaterThanOrEqualOperation(rhs[0], rhs[2]);
	};
	this.reduceActions[15] = function(rhs) {
		return new PlusOperation(rhs[0], rhs[2]);
	};
	this.reduceActions[16] = function(rhs) {
		return new MinusOperation(rhs[0], rhs[2]);
	};
	this.reduceActions[18] = function(rhs) {
		return new MultiplyOperation(rhs[0], rhs[2]);
	};
	this.reduceActions[19] = function(rhs) {
		return new DivOperation(rhs[0], rhs[2]);
	};
	this.reduceActions[20] = function(rhs) {
		return new ModOperation(rhs[0], rhs[2]);
	};
	this.reduceActions[22] = function(rhs) {
		return new UnaryMinusOperation(rhs[1]);
	};
	this.reduceActions[24] = function(rhs) {
		return new BarOperation(rhs[0], rhs[2]);
	};
	this.reduceActions[25] = function(rhs) {
		return new PathExpr(undefined, undefined, rhs[0]);
	};
	this.reduceActions[27] = function(rhs) {
		rhs[0].locationPath = rhs[2];
		return rhs[0];
	};
	this.reduceActions[28] = function(rhs) {
		rhs[0].locationPath = rhs[2];
		rhs[0].locationPath.steps.unshift(new Step(Step.DESCENDANTORSELF, new NodeTest(NodeTest.NODE, undefined), []));
		return rhs[0];
	};
	this.reduceActions[29] = function(rhs) {
		return new PathExpr(rhs[0], [], undefined);
	};
	this.reduceActions[30] = function(rhs) {
		if (Utilities.instance_of(rhs[0], PathExpr)) {
			if (rhs[0].filterPredicates == undefined) {
				rhs[0].filterPredicates = [];
			}
			rhs[0].filterPredicates.push(rhs[1]);
			return rhs[0];
		} else {
			return new PathExpr(rhs[0], [rhs[1]], undefined);
		}
	};
	this.reduceActions[32] = function(rhs) {
		return rhs[1];
	};
	this.reduceActions[33] = function(rhs) {
		return new XString(rhs[0]);
	};
	this.reduceActions[34] = function(rhs) {
		return new XNumber(rhs[0]);
	};
	this.reduceActions[36] = function(rhs) {
		return new FunctionCall(rhs[0], []);
	};
	this.reduceActions[37] = function(rhs) {
		return new FunctionCall(rhs[0], rhs[2]);
	};
	this.reduceActions[38] = function(rhs) {
		return [ rhs[0] ];
	};
	this.reduceActions[39] = function(rhs) {
		rhs[2].unshift(rhs[0]);
		return rhs[2];
	};
	this.reduceActions[43] = function(rhs) {
		return new LocationPath(true, []);
	};
	this.reduceActions[44] = function(rhs) {
		rhs[1].absolute = true;
		return rhs[1];
	};
	this.reduceActions[46] = function(rhs) {
		return new LocationPath(false, [ rhs[0] ]);
	};
	this.reduceActions[47] = function(rhs) {
		rhs[0].steps.push(rhs[2]);
		return rhs[0];
	};
	this.reduceActions[49] = function(rhs) {
		return new Step(rhs[0], rhs[1], []);
	};
	this.reduceActions[50] = function(rhs) {
		return new Step(Step.CHILD, rhs[0], []);
	};
	this.reduceActions[51] = function(rhs) {
		return new Step(rhs[0], rhs[1], rhs[2]);
	};
	this.reduceActions[52] = function(rhs) {
		return new Step(Step.CHILD, rhs[0], rhs[1]);
	};
	this.reduceActions[54] = function(rhs) {
		return [ rhs[0] ];
	};
	this.reduceActions[55] = function(rhs) {
		rhs[1].unshift(rhs[0]);
		return rhs[1];
	};
	this.reduceActions[56] = function(rhs) {
		if (rhs[0] == "ancestor") {
			return Step.ANCESTOR;
		} else if (rhs[0] == "ancestor-or-self") {
			return Step.ANCESTORORSELF;
		} else if (rhs[0] == "attribute") {
			return Step.ATTRIBUTE;
		} else if (rhs[0] == "child") {
			return Step.CHILD;
		} else if (rhs[0] == "descendant") {
			return Step.DESCENDANT;
		} else if (rhs[0] == "descendant-or-self") {
			return Step.DESCENDANTORSELF;
		} else if (rhs[0] == "following") {
			return Step.FOLLOWING;
		} else if (rhs[0] == "following-sibling") {
			return Step.FOLLOWINGSIBLING;
		} else if (rhs[0] == "namespace") {
			return Step.NAMESPACE;
		} else if (rhs[0] == "parent") {
			return Step.PARENT;
		} else if (rhs[0] == "preceding") {
			return Step.PRECEDING;
		} else if (rhs[0] == "preceding-sibling") {
			return Step.PRECEDINGSIBLING;
		} else if (rhs[0] == "self") {
			return Step.SELF;
		}
		return -1;
	};
	this.reduceActions[57] = function(rhs) {
		return Step.ATTRIBUTE;
	};
	this.reduceActions[59] = function(rhs) {
		if (rhs[0] == "comment") {
			return new NodeTest(NodeTest.COMMENT, undefined);
		} else if (rhs[0] == "text") {
			return new NodeTest(NodeTest.TEXT, undefined);
		} else if (rhs[0] == "processing-instruction") {
			return new NodeTest(NodeTest.PI, undefined);
		} else if (rhs[0] == "node") {
			return new NodeTest(NodeTest.NODE, undefined);
		}
		return new NodeTest(-1, undefined);
	};
	this.reduceActions[60] = function(rhs) {
		return new NodeTest(NodeTest.PI, rhs[2]);
	};
	this.reduceActions[61] = function(rhs) {
		return rhs[1];
	};
	this.reduceActions[63] = function(rhs) {
		rhs[1].absolute = true;
		rhs[1].steps.unshift(new Step(Step.DESCENDANTORSELF, new NodeTest(NodeTest.NODE, undefined), []));
		return rhs[1];
	};
	this.reduceActions[64] = function(rhs) {
		rhs[0].steps.push(new Step(Step.DESCENDANTORSELF, new NodeTest(NodeTest.NODE, undefined), []));
		rhs[0].steps.push(rhs[2]);
		return rhs[0];
	};
	this.reduceActions[65] = function(rhs) {
		return new Step(Step.SELF, new NodeTest(NodeTest.NODE, undefined), []);
	};
	this.reduceActions[66] = function(rhs) {
		return new Step(Step.PARENT, new NodeTest(NodeTest.NODE, undefined), []);
	};
	this.reduceActions[67] = function(rhs) {
		return new VariableReference(rhs[1]);
	};
	this.reduceActions[68] = function(rhs) {
		return new NodeTest(NodeTest.NAMETESTANY, undefined);
	};
	this.reduceActions[69] = function(rhs) {
		var prefix = rhs[0].substring(0, rhs[0].indexOf(":"));
		return new NodeTest(NodeTest.NAMETESTPREFIXANY, prefix);
	};
	this.reduceActions[70] = function(rhs) {
		return new NodeTest(NodeTest.NAMETESTQNAME, rhs[0]);
	};
};

XPathParser.actionTable = [
	" s s        sssssssss    s ss  s  ss",
	"                 s                  ",
	"r  rrrrrrrrr         rrrrrrr rr  r  ",
	"                rrrrr               ",
	" s s        sssssssss    s ss  s  ss",
	"rs  rrrrrrrr s  sssssrrrrrr  rrs rs ",
	" s s        sssssssss    s ss  s  ss",
	"                            s       ",
	"                            s       ",
	"r  rrrrrrrrr         rrrrrrr rr rr  ",
	"r  rrrrrrrrr         rrrrrrr rr rr  ",
	"r  rrrrrrrrr         rrrrrrr rr rr  ",
	"r  rrrrrrrrr         rrrrrrr rr rr  ",
	"r  rrrrrrrrr         rrrrrrr rr rr  ",
	"  s                                 ",
	"                            s       ",
	" s           s  sssss          s  s ",
	"r  rrrrrrrrr         rrrrrrr rr  r  ",
	"a                                   ",
	"r       s                    rr  r  ",
	"r      sr                    rr  r  ",
	"r   s  rr            s       rr  r  ",
	"r   rssrr            rss     rr  r  ",
	"r   rrrrr            rrrss   rr  r  ",
	"r   rrrrrsss         rrrrr   rr  r  ",
	"r   rrrrrrrr         rrrrr   rr  r  ",
	"r   rrrrrrrr         rrrrrs  rr  r  ",
	"r   rrrrrrrr         rrrrrr  rr  r  ",
	"r   rrrrrrrr         rrrrrr  rr  r  ",
	"r  srrrrrrrr         rrrrrrs rr sr  ",
	"r  srrrrrrrr         rrrrrrs rr  r  ",
	"r  rrrrrrrrr         rrrrrrr rr rr  ",
	"r  rrrrrrrrr         rrrrrrr rr rr  ",
	"r  rrrrrrrrr         rrrrrrr rr rr  ",
	"r   rrrrrrrr         rrrrrr  rr  r  ",
	"r   rrrrrrrr         rrrrrr  rr  r  ",
	"r  rrrrrrrrr         rrrrrrr rr  r  ",
	"r  rrrrrrrrr         rrrrrrr rr  r  ",
	"                sssss               ",
	"r  rrrrrrrrr         rrrrrrr rr sr  ",
	"r  rrrrrrrrr         rrrrrrr rr  r  ",
	"r  rrrrrrrrr         rrrrrrr rr rr  ",
	"r  rrrrrrrrr         rrrrrrr rr rr  ",
	"                             s      ",
	"r  srrrrrrrr         rrrrrrs rr  r  ",
	"r   rrrrrrrr         rrrrr   rr  r  ",
	"              s                     ",
	"                             s      ",
	"                rrrrr               ",
	" s s        sssssssss    s sss s  ss",
	"r  srrrrrrrr         rrrrrrs rr  r  ",
	" s s        sssssssss    s ss  s  ss",
	" s s        sssssssss    s ss  s  ss",
	" s s        sssssssss    s ss  s  ss",
	" s s        sssssssss    s ss  s  ss",
	" s s        sssssssss    s ss  s  ss",
	" s s        sssssssss    s ss  s  ss",
	" s s        sssssssss    s ss  s  ss",
	" s s        sssssssss    s ss  s  ss",
	" s s        sssssssss    s ss  s  ss",
	" s s        sssssssss    s ss  s  ss",
	" s s        sssssssss    s ss  s  ss",
	" s s        sssssssss    s ss  s  ss",
	" s s        sssssssss    s ss  s  ss",
	" s s        sssssssss      ss  s  ss",
	" s s        sssssssss    s ss  s  ss",
	" s           s  sssss          s  s ",
	" s           s  sssss          s  s ",
	"r  rrrrrrrrr         rrrrrrr rr rr  ",
	" s           s  sssss          s  s ",
	" s           s  sssss          s  s ",
	"r  rrrrrrrrr         rrrrrrr rr sr  ",
	"r  rrrrrrrrr         rrrrrrr rr sr  ",
	"r  rrrrrrrrr         rrrrrrr rr  r  ",
	"r  rrrrrrrrr         rrrrrrr rr rr  ",
	"                             s      ",
	"r  rrrrrrrrr         rrrrrrr rr rr  ",
	"r  rrrrrrrrr         rrrrrrr rr rr  ",
	"                             rr     ",
	"                             s      ",
	"                             rs     ",
	"r      sr                    rr  r  ",
	"r   s  rr            s       rr  r  ",
	"r   rssrr            rss     rr  r  ",
	"r   rssrr            rss     rr  r  ",
	"r   rrrrr            rrrss   rr  r  ",
	"r   rrrrr            rrrss   rr  r  ",
	"r   rrrrr            rrrss   rr  r  ",
	"r   rrrrr            rrrss   rr  r  ",
	"r   rrrrrsss         rrrrr   rr  r  ",
	"r   rrrrrsss         rrrrr   rr  r  ",
	"r   rrrrrrrr         rrrrr   rr  r  ",
	"r   rrrrrrrr         rrrrr   rr  r  ",
	"r   rrrrrrrr         rrrrr   rr  r  ",
	"r   rrrrrrrr         rrrrrr  rr  r  ",
	"                                 r  ",
	"                                 s  ",
	"r  srrrrrrrr         rrrrrrs rr  r  ",
	"r  srrrrrrrr         rrrrrrs rr  r  ",
	"r  rrrrrrrrr         rrrrrrr rr  r  ",
	"r  rrrrrrrrr         rrrrrrr rr  r  ",
	"r  rrrrrrrrr         rrrrrrr rr  r  ",
	"r  rrrrrrrrr         rrrrrrr rr  r  ",
	"r  rrrrrrrrr         rrrrrrr rr rr  ",
	"r  rrrrrrrrr         rrrrrrr rr rr  ",
	" s s        sssssssss    s ss  s  ss",
	"r  rrrrrrrrr         rrrrrrr rr rr  ",
	"                             r      "
];

XPathParser.actionTableNumber = [
	" 1 0        /.-,+*)('    & %$  #  \"!",
	"                 J                  ",
	"a  aaaaaaaaa         aaaaaaa aa  a  ",
	"                YYYYY               ",
	" 1 0        /.-,+*)('    & %$  #  \"!",
	"K1  KKKKKKKK .  +*)('KKKKKK  KK# K\" ",
	" 1 0        /.-,+*)('    & %$  #  \"!",
	"                            N       ",
	"                            O       ",
	"e  eeeeeeeee         eeeeeee ee ee  ",
	"f  fffffffff         fffffff ff ff  ",
	"d  ddddddddd         ddddddd dd dd  ",
	"B  BBBBBBBBB         BBBBBBB BB BB  ",
	"A  AAAAAAAAA         AAAAAAA AA AA  ",
	"  P                                 ",
	"                            Q       ",
	" 1           .  +*)('          #  \" ",
	"b  bbbbbbbbb         bbbbbbb bb  b  ",
	"                                    ",
	"!       S                    !!  !  ",
	"\"      T\"                    \"\"  \"  ",
	"$   V  $$            U       $$  $  ",
	"&   &ZY&&            &XW     &&  &  ",
	")   )))))            )))\\[   ))  )  ",
	".   ....._^]         .....   ..  .  ",
	"1   11111111         11111   11  1  ",
	"5   55555555         55555`  55  5  ",
	"7   77777777         777777  77  7  ",
	"9   99999999         999999  99  9  ",
	":  c::::::::         ::::::b :: a:  ",
	"I  fIIIIIIII         IIIIIIe II  I  ",
	"=  =========         ======= == ==  ",
	"?  ?????????         ??????? ?? ??  ",
	"C  CCCCCCCCC         CCCCCCC CC CC  ",
	"J   JJJJJJJJ         JJJJJJ  JJ  J  ",
	"M   MMMMMMMM         MMMMMM  MM  M  ",
	"N  NNNNNNNNN         NNNNNNN NN  N  ",
	"P  PPPPPPPPP         PPPPPPP PP  P  ",
	"                +*)('               ",
	"R  RRRRRRRRR         RRRRRRR RR aR  ",
	"U  UUUUUUUUU         UUUUUUU UU  U  ",
	"Z  ZZZZZZZZZ         ZZZZZZZ ZZ ZZ  ",
	"c  ccccccccc         ccccccc cc cc  ",
	"                             j      ",
	"L  fLLLLLLLL         LLLLLLe LL  L  ",
	"6   66666666         66666   66  6  ",
	"              k                     ",
	"                             l      ",
	"                XXXXX               ",
	" 1 0        /.-,+*)('    & %$m #  \"!",
	"_  f________         ______e __  _  ",
	" 1 0        /.-,+*)('    & %$  #  \"!",
	" 1 0        /.-,+*)('    & %$  #  \"!",
	" 1 0        /.-,+*)('    & %$  #  \"!",
	" 1 0        /.-,+*)('    & %$  #  \"!",
	" 1 0        /.-,+*)('    & %$  #  \"!",
	" 1 0        /.-,+*)('    & %$  #  \"!",
	" 1 0        /.-,+*)('    & %$  #  \"!",
	" 1 0        /.-,+*)('    & %$  #  \"!",
	" 1 0        /.-,+*)('    & %$  #  \"!",
	" 1 0        /.-,+*)('    & %$  #  \"!",
	" 1 0        /.-,+*)('    & %$  #  \"!",
	" 1 0        /.-,+*)('    & %$  #  \"!",
	" 1 0        /.-,+*)('    & %$  #  \"!",
	" 1 0        /.-,+*)('      %$  #  \"!",
	" 1 0        /.-,+*)('    & %$  #  \"!",
	" 1           .  +*)('          #  \" ",
	" 1           .  +*)('          #  \" ",
	">  >>>>>>>>>         >>>>>>> >> >>  ",
	" 1           .  +*)('          #  \" ",
	" 1           .  +*)('          #  \" ",
	"Q  QQQQQQQQQ         QQQQQQQ QQ aQ  ",
	"V  VVVVVVVVV         VVVVVVV VV aV  ",
	"T  TTTTTTTTT         TTTTTTT TT  T  ",
	"@  @@@@@@@@@         @@@@@@@ @@ @@  ",
	"                             \x87      ",
	"[  [[[[[[[[[         [[[[[[[ [[ [[  ",
	"D  DDDDDDDDD         DDDDDDD DD DD  ",
	"                             HH     ",
	"                             \x88      ",
	"                             F\x89     ",
	"#      T#                    ##  #  ",
	"%   V  %"+"%            U       %"+"%  %  ",   // split because of packing
	"'   'ZY''            'XW     ''  '  ",
	"(   (ZY((            (XW     ((  (  ",
	"+   +++++            +++\\[   ++  +  ",
	"*   *****            ***\\[   **  *  ",
	"-   -----            ---\\[   --  -  ",
	",   ,,,,,            ,,,\\[   ,,  ,  ",
	"0   00000_^]         00000   00  0  ",
	"/   /////_^]         /////   //  /  ",
	"2   22222222         22222   22  2  ",
	"3   33333333         33333   33  3  ",
	"4   44444444         44444   44  4  ",
	"8   88888888         888888  88  8  ",
	"                                 ^  ",
	"                                 \x8a  ",
	";  f;;;;;;;;         ;;;;;;e ;;  ;  ",
	"<  f<<<<<<<<         <<<<<<e <<  <  ",
	"O  OOOOOOOOO         OOOOOOO OO  O  ",
	"`  `````````         ``````` ``  `  ",
	"S  SSSSSSSSS         SSSSSSS SS  S  ",
	"W  WWWWWWWWW         WWWWWWW WW  W  ",
	"\\  \\\\\\\\\\\\\\\\\\         \\\\\\\\\\\\\\ \\\\ \\\\  ",
	"E  EEEEEEEEE         EEEEEEE EE EE  ",
	" 1 0        /.-,+*)('    & %$  #  \"!",
	"]  ]]]]]]]]]         ]]]]]]] ]] ]]  ",
	"                             G      "
];

XPathParser.gotoTable = [
	"3456789:;<=>?@ AB  CDEFGH IJ ",
	"                             ",
	"                             ",
	"                             ",
	"L456789:;<=>?@ AB  CDEFGH IJ ",
	"            M        EFGH IJ ",
	"       N;<=>?@ AB  CDEFGH IJ ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"            S        EFGH IJ ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"              e              ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                        h  J ",
	"              i          j   ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"o456789:;<=>?@ ABpqCDEFGH IJ ",
	"                             ",
	"  r6789:;<=>?@ AB  CDEFGH IJ ",
	"   s789:;<=>?@ AB  CDEFGH IJ ",
	"    t89:;<=>?@ AB  CDEFGH IJ ",
	"    u89:;<=>?@ AB  CDEFGH IJ ",
	"     v9:;<=>?@ AB  CDEFGH IJ ",
	"     w9:;<=>?@ AB  CDEFGH IJ ",
	"     x9:;<=>?@ AB  CDEFGH IJ ",
	"     y9:;<=>?@ AB  CDEFGH IJ ",
	"      z:;<=>?@ AB  CDEFGH IJ ",
	"      {:;<=>?@ AB  CDEFGH IJ ",
	"       |;<=>?@ AB  CDEFGH IJ ",
	"       };<=>?@ AB  CDEFGH IJ ",
	"       ~;<=>?@ AB  CDEFGH IJ ",
	"         \x7f=>?@ AB  CDEFGH IJ ",
	"\x80456789:;<=>?@ AB  CDEFGH IJ\x81",
	"            \x82        EFGH IJ ",
	"            \x83        EFGH IJ ",
	"                             ",
	"                     \x84 GH IJ ",
	"                     \x85 GH IJ ",
	"              i          \x86   ",
	"              i          \x87   ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"                             ",
	"o456789:;<=>?@ AB\x8cqCDEFGH IJ ",
	"                             ",
	"                             "
];

XPathParser.productions = [
	[1, 1, 2],
	[2, 1, 3],
	[3, 1, 4],
	[3, 3, 3, -9, 4],
	[4, 1, 5],
	[4, 3, 4, -8, 5],
	[5, 1, 6],
	[5, 3, 5, -22, 6],
	[5, 3, 5, -5, 6],
	[6, 1, 7],
	[6, 3, 6, -23, 7],
	[6, 3, 6, -24, 7],
	[6, 3, 6, -6, 7],
	[6, 3, 6, -7, 7],
	[7, 1, 8],
	[7, 3, 7, -25, 8],
	[7, 3, 7, -26, 8],
	[8, 1, 9],
	[8, 3, 8, -12, 9],
	[8, 3, 8, -11, 9],
	[8, 3, 8, -10, 9],
	[9, 1, 10],
	[9, 2, -26, 9],
	[10, 1, 11],
	[10, 3, 10, -27, 11],
	[11, 1, 12],
	[11, 1, 13],
	[11, 3, 13, -28, 14],
	[11, 3, 13, -4, 14],
	[13, 1, 15],
	[13, 2, 13, 16],
	[15, 1, 17],
	[15, 3, -29, 2, -30],
	[15, 1, -15],
	[15, 1, -16],
	[15, 1, 18],
	[18, 3, -13, -29, -30],
	[18, 4, -13, -29, 19, -30],
	[19, 1, 20],
	[19, 3, 20, -31, 19],
	[20, 1, 2],
	[12, 1, 14],
	[12, 1, 21],
	[21, 1, -28],
	[21, 2, -28, 14],
	[21, 1, 22],
	[14, 1, 23],
	[14, 3, 14, -28, 23],
	[14, 1, 24],
	[23, 2, 25, 26],
	[23, 1, 26],
	[23, 3, 25, 26, 27],
	[23, 2, 26, 27],
	[23, 1, 28],
	[27, 1, 16],
	[27, 2, 16, 27],
	[25, 2, -14, -3],
	[25, 1, -32],
	[26, 1, 29],
	[26, 3, -20, -29, -30],
	[26, 4, -21, -29, -15, -30],
	[16, 3, -33, 30, -34],
	[30, 1, 2],
	[22, 2, -4, 14],
	[24, 3, 14, -4, 23],
	[28, 1, -35],
	[28, 1, -2],
	[17, 2, -36, -18],
	[29, 1, -17],
	[29, 1, -19],
	[29, 1, -18]
];

XPathParser.DOUBLEDOT = 2;
XPathParser.DOUBLECOLON = 3;
XPathParser.DOUBLESLASH = 4;
XPathParser.NOTEQUAL = 5;
XPathParser.LESSTHANOREQUAL = 6;
XPathParser.GREATERTHANOREQUAL = 7;
XPathParser.AND = 8;
XPathParser.OR = 9;
XPathParser.MOD = 10;
XPathParser.DIV = 11;
XPathParser.MULTIPLYOPERATOR = 12;
XPathParser.FUNCTIONNAME = 13;
XPathParser.AXISNAME = 14;
XPathParser.LITERAL = 15;
XPathParser.NUMBER = 16;
XPathParser.ASTERISKNAMETEST = 17;
XPathParser.QNAME = 18;
XPathParser.NCNAMECOLONASTERISK = 19;
XPathParser.NODETYPE = 20;
XPathParser.PROCESSINGINSTRUCTIONWITHLITERAL = 21;
XPathParser.EQUALS = 22;
XPathParser.LESSTHAN = 23;
XPathParser.GREATERTHAN = 24;
XPathParser.PLUS = 25;
XPathParser.MINUS = 26;
XPathParser.BAR = 27;
XPathParser.SLASH = 28;
XPathParser.LEFTPARENTHESIS = 29;
XPathParser.RIGHTPARENTHESIS = 30;
XPathParser.COMMA = 31;
XPathParser.AT = 32;
XPathParser.LEFTBRACKET = 33;
XPathParser.RIGHTBRACKET = 34;
XPathParser.DOT = 35;
XPathParser.DOLLAR = 36;

XPathParser.prototype.tokenize = function(s1) {
	var types = [];
	var values = [];
	var s = s1 + '\0';

	var pos = 0;
	var c = s.charAt(pos++);
	while (1) {
		while (c == ' ' || c == '\t' || c == '\r' || c == '\n') {
			c = s.charAt(pos++);
		}
		if (c == '\0' || pos >= s.length) {
			break;
		}

		if (c == '(') {
			types.push(XPathParser.LEFTPARENTHESIS);
			values.push(c);
			c = s.charAt(pos++);
			continue;
		}
		if (c == ')') {
			types.push(XPathParser.RIGHTPARENTHESIS);
			values.push(c);
			c = s.charAt(pos++);
			continue;
		}
		if (c == '[') {
			types.push(XPathParser.LEFTBRACKET);
			values.push(c);
			c = s.charAt(pos++);
			continue;
		}
		if (c == ']') {
			types.push(XPathParser.RIGHTBRACKET);
			values.push(c);
			c = s.charAt(pos++);
			continue;
		}
		if (c == '@') {
			types.push(XPathParser.AT);
			values.push(c);
			c = s.charAt(pos++);
			continue;
		}
		if (c == ',') {
			types.push(XPathParser.COMMA);
			values.push(c);
			c = s.charAt(pos++);
			continue;
		}
		if (c == '|') {
			types.push(XPathParser.BAR);
			values.push(c);
			c = s.charAt(pos++);
			continue;
		}
		if (c == '+') {
			types.push(XPathParser.PLUS);
			values.push(c);
			c = s.charAt(pos++);
			continue;
		}
		if (c == '-') {
			types.push(XPathParser.MINUS);
			values.push(c);
			c = s.charAt(pos++);
			continue;
		}
		if (c == '=') {
			types.push(XPathParser.EQUALS);
			values.push(c);
			c = s.charAt(pos++);
			continue;
		}
		if (c == '$') {
			types.push(XPathParser.DOLLAR);
			values.push(c);
			c = s.charAt(pos++);
			continue;
		}

		if (c == '.') {
			c = s.charAt(pos++);
			if (c == '.') {
				types.push(XPathParser.DOUBLEDOT);
				values.push("..");
				c = s.charAt(pos++);
				continue;
			}
			if (c >= '0' && c <= '9') {
				var number = "." + c;
				c = s.charAt(pos++);
				while (c >= '0' && c <= '9') {
					number += c;
					c = s.charAt(pos++);
				}
				types.push(XPathParser.NUMBER);
				values.push(number);
				continue;
			}
			types.push(XPathParser.DOT);
			values.push('.');
			continue;
		}

		if (c == '\'' || c == '"') {
			var delimiter = c;
			var literal = "";
			while ((c = s.charAt(pos++)) != delimiter && c!= "") {
				literal += c;
			}
			if (c == "" ) {
				throw new Error("Unclosed literal:'" + literal + "'");
			}
			types.push(XPathParser.LITERAL);
			values.push(literal);
			c = s.charAt(pos++);
			continue;
		}

		if (c >= '0' && c <= '9') {
			var number = c;
			c = s.charAt(pos++);
			while (c >= '0' && c <= '9') {
				number += c;
				c = s.charAt(pos++);
			}
			if (c == '.') {
				if (s.charAt(pos) >= '0' && s.charAt(pos) <= '9') {
					number += c;
					number += s.charAt(pos++);
					c = s.charAt(pos++);
					while (c >= '0' && c <= '9') {
						number += c;
						c = s.charAt(pos++);
					}
				}
			}
			types.push(XPathParser.NUMBER);
			values.push(number);
			continue;
		}

		if (c == '*') {
			if (types.length > 0) {
				var last = types[types.length - 1];
				if (last != XPathParser.AT
						&& last != XPathParser.DOUBLECOLON
						&& last != XPathParser.LEFTPARENTHESIS
						&& last != XPathParser.LEFTBRACKET
						&& last != XPathParser.AND
						&& last != XPathParser.OR
						&& last != XPathParser.MOD
						&& last != XPathParser.DIV
						&& last != XPathParser.MULTIPLYOPERATOR
						&& last != XPathParser.SLASH
						&& last != XPathParser.DOUBLESLASH
						&& last != XPathParser.BAR
						&& last != XPathParser.PLUS
						&& last != XPathParser.MINUS
						&& last != XPathParser.EQUALS
						&& last != XPathParser.NOTEQUAL
						&& last != XPathParser.LESSTHAN
						&& last != XPathParser.LESSTHANOREQUAL
						&& last != XPathParser.GREATERTHAN
						&& last != XPathParser.GREATERTHANOREQUAL) {
					types.push(XPathParser.MULTIPLYOPERATOR);
					values.push(c);
					c = s.charAt(pos++);
					continue;
				}
			}
			types.push(XPathParser.ASTERISKNAMETEST);
			values.push(c);
			c = s.charAt(pos++);
			continue;
		}

		if (c == ':') {
			if (s.charAt(pos) == ':') {
				types.push(XPathParser.DOUBLECOLON);
				values.push("::");
				pos++;
				c = s.charAt(pos++);
				continue;
			}
		}

		if (c == '/') {
			c = s.charAt(pos++);
			if (c == '/') {
				types.push(XPathParser.DOUBLESLASH);
				values.push("//");
				c = s.charAt(pos++);
				continue;
			}
			types.push(XPathParser.SLASH);
			values.push('/');
			continue;
		}

		if (c == '!') {
			if (s.charAt(pos) == '=') {
				types.push(XPathParser.NOTEQUAL);
				values.push("!=");
				pos++;
				c = s.charAt(pos++);
				continue;
			}
		}

		if (c == '<') {
			if (s.charAt(pos) == '=') {
				types.push(XPathParser.LESSTHANOREQUAL);
				values.push("<=");
				pos++;
				c = s.charAt(pos++);
				continue;
			}
			types.push(XPathParser.LESSTHAN);
			values.push('<');
			c = s.charAt(pos++);
			continue;
		}

		if (c == '>') {
			if (s.charAt(pos) == '=') {
				types.push(XPathParser.GREATERTHANOREQUAL);
				values.push(">=");
				pos++;
				c = s.charAt(pos++);
				continue;
			}
			types.push(XPathParser.GREATERTHAN);
			values.push('>');
			c = s.charAt(pos++);
			continue;
		}

		if (c == '_' || Utilities.isLetter(c.charCodeAt(0))) {
			var name = c;
			c = s.charAt(pos++);
			while (Utilities.isNCNameChar(c.charCodeAt(0))) {
				name += c;
				c = s.charAt(pos++);
			}
			if (types.length > 0) {
				var last = types[types.length - 1];
				if (last != XPathParser.AT
						&& last != XPathParser.DOUBLECOLON
						&& last != XPathParser.LEFTPARENTHESIS
						&& last != XPathParser.LEFTBRACKET
						&& last != XPathParser.AND
						&& last != XPathParser.OR
						&& last != XPathParser.MOD
						&& last != XPathParser.DIV
						&& last != XPathParser.MULTIPLYOPERATOR
						&& last != XPathParser.SLASH
						&& last != XPathParser.DOUBLESLASH
						&& last != XPathParser.BAR
						&& last != XPathParser.PLUS
						&& last != XPathParser.MINUS
						&& last != XPathParser.EQUALS
						&& last != XPathParser.NOTEQUAL
						&& last != XPathParser.LESSTHAN
						&& last != XPathParser.LESSTHANOREQUAL
						&& last != XPathParser.GREATERTHAN
						&& last != XPathParser.GREATERTHANOREQUAL) {
					if (name == "and") {
						types.push(XPathParser.AND);
						values.push(name);
						continue;
					}
					if (name == "or") {
						types.push(XPathParser.OR);
						values.push(name);
						continue;
					}
					if (name == "mod") {
						types.push(XPathParser.MOD);
						values.push(name);
						continue;
					}
					if (name == "div") {
						types.push(XPathParser.DIV);
						values.push(name);
						continue;
					}
				}
			}
			if (c == ':') {
				if (s.charAt(pos) == '*') {
					types.push(XPathParser.NCNAMECOLONASTERISK);
					values.push(name + ":*");
					pos++;
					c = s.charAt(pos++);
					continue;
				}
				if (s.charAt(pos) == '_' || Utilities.isLetter(s.charCodeAt(pos))) {
					name += ':';
					c = s.charAt(pos++);
					while (Utilities.isNCNameChar(c.charCodeAt(0))) {
						name += c;
						c = s.charAt(pos++);
					}
					if (c == '(') {
						types.push(XPathParser.FUNCTIONNAME);
						values.push(name);
						continue;
					}
					types.push(XPathParser.QNAME);
					values.push(name);
					continue;
				}
				if (s.charAt(pos) == ':') {
					types.push(XPathParser.AXISNAME);
					values.push(name);
					continue;
				}
			}
			if (c == '(') {
				if (name == "comment" || name == "text" || name == "node") {
					types.push(XPathParser.NODETYPE);
					values.push(name);
					continue;
				}
				if (name == "processing-instruction") {
					if (s.charAt(pos) == ')') {
						types.push(XPathParser.NODETYPE);
					} else {
						types.push(XPathParser.PROCESSINGINSTRUCTIONWITHLITERAL);
					}
					values.push(name);
					continue;
				}
				types.push(XPathParser.FUNCTIONNAME);
				values.push(name);
				continue;
			}
			types.push(XPathParser.QNAME);
			values.push(name);
			continue;
		}

		throw new Error("Unexpected character " + c);
	}
	types.push(1);
	values.push("[EOF]");
	return [types, values];
};

XPathParser.SHIFT = 's';
XPathParser.REDUCE = 'r';
XPathParser.ACCEPT = 'a';

XPathParser.prototype.parse = function(s) {
	var types;
	var values;
	var res = this.tokenize(s);
	if (res == undefined) {
		return undefined;
	}
	types = res[0];
	values = res[1];
	var tokenPos = 0;
	var state = [];
	var tokenType = [];
	var tokenValue = [];
	var s;
	var a;
	var t;

	state.push(0);
	tokenType.push(1);
	tokenValue.push("_S");

	a = types[tokenPos];
	t = values[tokenPos++];
	while (1) {
		s = state[state.length - 1];
		switch (XPathParser.actionTable[s].charAt(a - 1)) {
			case XPathParser.SHIFT:
				tokenType.push(-a);
				tokenValue.push(t);
				state.push(XPathParser.actionTableNumber[s].charCodeAt(a - 1) - 32);
				a = types[tokenPos];
				t = values[tokenPos++];
				break;
			case XPathParser.REDUCE:
				var num = XPathParser.productions[XPathParser.actionTableNumber[s].charCodeAt(a - 1) - 32][1];
				var rhs = [];
				for (var i = 0; i < num; i++) {
					tokenType.pop();
					rhs.unshift(tokenValue.pop());
					state.pop();
				}
				var s_ = state[state.length - 1];
				tokenType.push(XPathParser.productions[XPathParser.actionTableNumber[s].charCodeAt(a - 1) - 32][0]);
				if (this.reduceActions[XPathParser.actionTableNumber[s].charCodeAt(a - 1) - 32] == undefined) {
					tokenValue.push(rhs[0]);
				} else {
					tokenValue.push(this.reduceActions[XPathParser.actionTableNumber[s].charCodeAt(a - 1) - 32](rhs));
				}
				state.push(XPathParser.gotoTable[s_].charCodeAt(XPathParser.productions[XPathParser.actionTableNumber[s].charCodeAt(a - 1) - 32][0] - 2) - 33);
				break;
			case XPathParser.ACCEPT:
				return new XPath(tokenValue.pop());
			default:
				throw new Error("XPath parse error");
		}
	}
};

// XPath /////////////////////////////////////////////////////////////////////

var pushed = false;

XPath.prototype = new Object();
XPath.prototype.constructor = XPath;
XPath.superclass = Object.prototype;

function XPath(e) {
	this.expression = e;
}

XPath.prototype.toString = function() {
	return this.expression.toString();
};

XPath.prototype.evaluate = function(c) {
	c.contextNode = c.expressionContextNode;
	c.contextSize = 1;
	c.contextPosition = 1;
	c.caseInsensitive = false;
	if (c.contextNode != null) {
		var doc = c.contextNode;
		if (doc.nodeType != 9 /*Node.DOCUMENT_NODE*/) {
			doc = doc.ownerDocument;
		}
		try {
			c.caseInsensitive = doc.implementation.hasFeature("HTML", "2.0");
		} catch (e) {
			c.caseInsensitive = true;
		}
	}
	return this.expression.evaluate(c);
};

XPath.XML_NAMESPACE_URI = "http://www.w3.org/XML/1998/namespace";
XPath.XMLNS_NAMESPACE_URI = "http://www.w3.org/2000/xmlns/";

// Expression ////////////////////////////////////////////////////////////////

Expression.prototype = new Object();
Expression.prototype.constructor = Expression;
Expression.superclass = Object.prototype;

function Expression() {
}

Expression.prototype.init = function() {
};

Expression.prototype.toString = function() {
	return "<Expression>";
};

Expression.prototype.toReplacedString = function(replacementFunc) {
;
};

Expression.prototype.evaluate = function(c) {
	throw new Error("Could not evaluate expression.");
};

Expression.prototype.gatherLocationPathsInto = function(arr) {
;
};

// UnaryOperation ////////////////////////////////////////////////////////////

UnaryOperation.prototype = new Expression();
UnaryOperation.prototype.constructor = UnaryOperation;
UnaryOperation.superclass = Expression.prototype;

function UnaryOperation(rhs) {
	if (arguments.length > 0) {
		this.init(rhs);
	}
}

UnaryOperation.prototype.init = function(rhs) {
	this.rhs = rhs;
};

// UnaryMinusOperation ///////////////////////////////////////////////////////

UnaryMinusOperation.prototype = new UnaryOperation();
UnaryMinusOperation.prototype.constructor = UnaryMinusOperation;
UnaryMinusOperation.superclass = UnaryOperation.prototype;

function UnaryMinusOperation(rhs) {
	if (arguments.length > 0) {
		this.init(rhs);
	}
}

UnaryMinusOperation.prototype.init = function(rhs) {
	UnaryMinusOperation.superclass.init.call(this, rhs);
};

UnaryMinusOperation.prototype.evaluate = function(c) {
	return this.rhs.evaluate(c).number().negate();
};

UnaryMinusOperation.prototype.toString = function() {
	return "-" + this.rhs.toString();
};

UnaryMinusOperation.prototype.toReplacedString = function(replacementFunc) {
	return "-" + this.rhs.toReplacedString(replacementFunc);
};

UnaryMinusOperation.prototype.gatherLocationPathsInto = function(arr) {
	this.rhs.gatherLocationPathsInto(arr);
};

// BinaryOperation ///////////////////////////////////////////////////////////

BinaryOperation.prototype = new Expression();
BinaryOperation.prototype.constructor = BinaryOperation;
BinaryOperation.superclass = Expression.prototype;

function BinaryOperation(lhs, rhs) {
	if (arguments.length > 0) {
		this.init(lhs, rhs);
	}
}

BinaryOperation.prototype.init = function(lhs, rhs) {
	this.lhs = lhs;
	this.rhs = rhs;
};

BinaryOperation.prototype.toReplacedString = function(replacementFunc) {
	return "(" + this.lhs.toReplacedString(replacementFunc) + " " +
			this.constructor.prototype.operator + " " +
			this.rhs.toReplacedString(replacementFunc) + ")";
};

BinaryOperation.prototype.gatherLocationPathsInto = function(arr) {
	this.lhs.gatherLocationPathsInto(arr);
	this.rhs.gatherLocationPathsInto(arr);
};

// OrOperation ///////////////////////////////////////////////////////////////

OrOperation.prototype = new BinaryOperation();
OrOperation.prototype.constructor = OrOperation;
OrOperation.prototype.operator = "or";
OrOperation.superclass = BinaryOperation.prototype;

function OrOperation(lhs, rhs) {
	if (arguments.length > 0) {
		this.init(lhs, rhs);
	}
}

OrOperation.prototype.init = function(lhs, rhs) {
	OrOperation.superclass.init.call(this, lhs, rhs);
};

OrOperation.prototype.toString = function() {
	return "(" + this.lhs.toString() + " or " + this.rhs.toString() + ")";
};

OrOperation.prototype.evaluate = function(c) {
	var b = this.lhs.evaluate(c).bool();
	if (b.booleanValue()) {
		return b;
	}
	return this.rhs.evaluate(c).bool();
};

// AndOperation //////////////////////////////////////////////////////////////

AndOperation.prototype = new BinaryOperation();
AndOperation.prototype.constructor = AndOperation;
AndOperation.prototype.operator = "and";
AndOperation.superclass = BinaryOperation.prototype;

function AndOperation(lhs, rhs) {
	if (arguments.length > 0) {
		this.init(lhs, rhs);
	}
}

AndOperation.prototype.init = function(lhs, rhs) {
	AndOperation.superclass.init.call(this, lhs, rhs);
};

AndOperation.prototype.toString = function() {
	return "(" + this.lhs.toString() + " and " + this.rhs.toString() + ")";
};

AndOperation.prototype.evaluate = function(c) {
	var b = this.lhs.evaluate(c).bool();
	if (!b.booleanValue()) {
		return b;
	}
	return this.rhs.evaluate(c).bool();
};

// EqualsOperation ///////////////////////////////////////////////////////////

EqualsOperation.prototype = new BinaryOperation();
EqualsOperation.prototype.constructor = EqualsOperation;
EqualsOperation.prototype.operator = "=";
EqualsOperation.superclass = BinaryOperation.prototype;

function EqualsOperation(lhs, rhs) {
	if (arguments.length > 0) {
		this.init(lhs, rhs);
	}
}

EqualsOperation.prototype.init = function(lhs, rhs) {
	EqualsOperation.superclass.init.call(this, lhs, rhs);
};

EqualsOperation.prototype.toString = function() {
	return "(" + this.lhs.toString() + " = " + this.rhs.toString() + ")";
};

EqualsOperation.prototype.evaluate = function(c) {
	return this.lhs.evaluate(c).equals(this.rhs.evaluate(c));
};

// NotEqualOperation /////////////////////////////////////////////////////////

NotEqualOperation.prototype = new BinaryOperation();
NotEqualOperation.prototype.constructor = NotEqualOperation;
NotEqualOperation.prototype.operator = "!=";
NotEqualOperation.superclass = BinaryOperation.prototype;

function NotEqualOperation(lhs, rhs) {
	if (arguments.length > 0) {
		this.init(lhs, rhs);
	}
}

NotEqualOperation.prototype.init = function(lhs, rhs) {
	NotEqualOperation.superclass.init.call(this, lhs, rhs);
};

NotEqualOperation.prototype.toString = function() {
	return "(" + this.lhs.toString() + " != " + this.rhs.toString() + ")";
};

NotEqualOperation.prototype.evaluate = function(c) {
	return this.lhs.evaluate(c).notequal(this.rhs.evaluate(c));
};

// LessThanOperation /////////////////////////////////////////////////////////

LessThanOperation.prototype = new BinaryOperation();
LessThanOperation.prototype.constructor = LessThanOperation;
LessThanOperation.prototype.operator = "<";
LessThanOperation.superclass = BinaryOperation.prototype;

function LessThanOperation(lhs, rhs) {
	if (arguments.length > 0) {
		this.init(lhs, rhs);
	}
}

LessThanOperation.prototype.init = function(lhs, rhs) {
	LessThanOperation.superclass.init.call(this, lhs, rhs);
};

LessThanOperation.prototype.evaluate = function(c) {
	return this.lhs.evaluate(c).lessthan(this.rhs.evaluate(c));
};

LessThanOperation.prototype.toString = function() {
	return "(" + this.lhs.toString() + " < " + this.rhs.toString() + ")";
};

// GreaterThanOperation //////////////////////////////////////////////////////

GreaterThanOperation.prototype = new BinaryOperation();
GreaterThanOperation.prototype.constructor = GreaterThanOperation;
GreaterThanOperation.prototype.operator = ">";
GreaterThanOperation.superclass = BinaryOperation.prototype;

function GreaterThanOperation(lhs, rhs) {
	if (arguments.length > 0) {
		this.init(lhs, rhs);
	}
}

GreaterThanOperation.prototype.init = function(lhs, rhs) {
	GreaterThanOperation.superclass.init.call(this, lhs, rhs);
};

GreaterThanOperation.prototype.evaluate = function(c) {
	return this.lhs.evaluate(c).greaterthan(this.rhs.evaluate(c));
};

GreaterThanOperation.prototype.toString = function() {
	return "(" + this.lhs.toString() + " > " + this.rhs.toString() + ")";
};

// LessThanOrEqualOperation //////////////////////////////////////////////////

LessThanOrEqualOperation.prototype = new BinaryOperation();
LessThanOrEqualOperation.prototype.constructor = LessThanOrEqualOperation;
LessThanOrEqualOperation.prototype.operator = "<=";
LessThanOrEqualOperation.superclass = BinaryOperation.prototype;

function LessThanOrEqualOperation(lhs, rhs) {
	if (arguments.length > 0) {
		this.init(lhs, rhs);
	}
}

LessThanOrEqualOperation.prototype.init = function(lhs, rhs) {
	LessThanOrEqualOperation.superclass.init.call(this, lhs, rhs);
};

LessThanOrEqualOperation.prototype.evaluate = function(c) {
	return this.lhs.evaluate(c).lessthanorequal(this.rhs.evaluate(c));
};

LessThanOrEqualOperation.prototype.toString = function() {
	return "(" + this.lhs.toString() + " <= " + this.rhs.toString() + ")";
};

// GreaterThanOrEqualOperation ///////////////////////////////////////////////

GreaterThanOrEqualOperation.prototype = new BinaryOperation();
GreaterThanOrEqualOperation.prototype.constructor = GreaterThanOrEqualOperation;
GreaterThanOrEqualOperation.prototype.operator = ">=";
GreaterThanOrEqualOperation.superclass = BinaryOperation.prototype;

function GreaterThanOrEqualOperation(lhs, rhs) {
	if (arguments.length > 0) {
		this.init(lhs, rhs);
	}
}

GreaterThanOrEqualOperation.prototype.init = function(lhs, rhs) {
	GreaterThanOrEqualOperation.superclass.init.call(this, lhs, rhs);
};

GreaterThanOrEqualOperation.prototype.evaluate = function(c) {
	return this.lhs.evaluate(c).greaterthanorequal(this.rhs.evaluate(c));
};

GreaterThanOrEqualOperation.prototype.toString = function() {
	return "(" + this.lhs.toString() + " >= " + this.rhs.toString() + ")";
};

// PlusOperation /////////////////////////////////////////////////////////////

PlusOperation.prototype = new BinaryOperation();
PlusOperation.prototype.constructor = PlusOperation;
PlusOperation.prototype.operator = "+";
PlusOperation.superclass = BinaryOperation.prototype;

function PlusOperation(lhs, rhs) {
	if (arguments.length > 0) {
		this.init(lhs, rhs);
	}
}

PlusOperation.prototype.init = function(lhs, rhs) {
	PlusOperation.superclass.init.call(this, lhs, rhs);
};

PlusOperation.prototype.evaluate = function(c) {
	return this.lhs.evaluate(c).number().plus(this.rhs.evaluate(c).number());
};

PlusOperation.prototype.toString = function() {
	return "(" + this.lhs.toString() + " + " + this.rhs.toString() + ")";
};

// MinusOperation ////////////////////////////////////////////////////////////

MinusOperation.prototype = new BinaryOperation();
MinusOperation.prototype.constructor = MinusOperation;
MinusOperation.prototype.operator = "-";
MinusOperation.superclass = BinaryOperation.prototype;

function MinusOperation(lhs, rhs) {
	if (arguments.length > 0) {
		this.init(lhs, rhs);
	}
}

MinusOperation.prototype.init = function(lhs, rhs) {
	MinusOperation.superclass.init.call(this, lhs, rhs);
};

MinusOperation.prototype.evaluate = function(c) {
	return this.lhs.evaluate(c).number().minus(this.rhs.evaluate(c).number());
};

MinusOperation.prototype.toString = function() {
	return "(" + this.lhs.toString() + " - " + this.rhs.toString() + ")";
};

// MultiplyOperation /////////////////////////////////////////////////////////

MultiplyOperation.prototype = new BinaryOperation();
MultiplyOperation.prototype.constructor = MultiplyOperation;
MultiplyOperation.prototype.operator = "*";
MultiplyOperation.superclass = BinaryOperation.prototype;

function MultiplyOperation(lhs, rhs) {
	if (arguments.length > 0) {
		this.init(lhs, rhs);
	}
}

MultiplyOperation.prototype.init = function(lhs, rhs) {
	MultiplyOperation.superclass.init.call(this, lhs, rhs);
};

MultiplyOperation.prototype.evaluate = function(c) {
	return this.lhs.evaluate(c).number().multiply(this.rhs.evaluate(c).number());
};

MultiplyOperation.prototype.toString = function() {
	return "(" + this.lhs.toString() + " * " + this.rhs.toString() + ")";
};

// DivOperation //////////////////////////////////////////////////////////////

DivOperation.prototype = new BinaryOperation();
DivOperation.prototype.constructor = DivOperation;
DivOperation.prototype.operator = "div";
DivOperation.superclass = BinaryOperation.prototype;

function DivOperation(lhs, rhs) {
	if (arguments.length > 0) {
		this.init(lhs, rhs);
	}
}

DivOperation.prototype.init = function(lhs, rhs) {
	DivOperation.superclass.init.call(this, lhs, rhs);
};

DivOperation.prototype.evaluate = function(c) {
	return this.lhs.evaluate(c).number().div(this.rhs.evaluate(c).number());
};

DivOperation.prototype.toString = function() {
	return "(" + this.lhs.toString() + " div " + this.rhs.toString() + ")";
};

// ModOperation //////////////////////////////////////////////////////////////

ModOperation.prototype = new BinaryOperation();
ModOperation.prototype.constructor = ModOperation;
ModOperation.prototype.operator = "mod";
ModOperation.superclass = BinaryOperation.prototype;

function ModOperation(lhs, rhs) {
	if (arguments.length > 0) {
		this.init(lhs, rhs);
	}
}

ModOperation.prototype.init = function(lhs, rhs) {
	ModOperation.superclass.init.call(this, lhs, rhs);
};

ModOperation.prototype.evaluate = function(c) {
	return this.lhs.evaluate(c).number().mod(this.rhs.evaluate(c).number());
};

ModOperation.prototype.toString = function() {
	return "(" + this.lhs.toString() + " mod " + this.rhs.toString() + ")";
};

// BarOperation //////////////////////////////////////////////////////////////

BarOperation.prototype = new BinaryOperation();
BarOperation.prototype.constructor = BarOperation;
BarOperation.prototype.operator = "|";
BarOperation.superclass = BinaryOperation.prototype;

function BarOperation(lhs, rhs) {
	if (arguments.length > 0) {
		this.init(lhs, rhs);
	}
}

BarOperation.prototype.init = function(lhs, rhs) {
	BarOperation.superclass.init.call(this, lhs, rhs);
};

BarOperation.prototype.evaluate = function(c) {
	return this.lhs.evaluate(c).nodeset().union(this.rhs.evaluate(c).nodeset());
};

BarOperation.prototype.toString = function() {
	return this.lhs.toString() + " | " + this.rhs.toString();
};

// PathExpr //////////////////////////////////////////////////////////////////

PathExpr.prototype = new Expression();
PathExpr.prototype.constructor = PathExpr;
PathExpr.superclass = Expression.prototype;

function PathExpr(filter, filterPreds, locpath) {
	if (arguments.length > 0) {
		this.init(filter, filterPreds, locpath);
	}
}

PathExpr.prototype.init = function(filter, filterPreds, locpath) {
	PathExpr.superclass.init.call(this);
	this.filter = filter;
	this.filterPredicates = filterPreds;
	this.locationPath = locpath;
};

PathExpr.prototype.evaluate = function(c) {
	var nodes;
	var xpc = new XPathContext();
	xpc.variableResolver = c.variableResolver;
	xpc.functionResolver = c.functionResolver;
	xpc.namespaceResolver = c.namespaceResolver;
	xpc.expressionContextNode = c.expressionContextNode;
	xpc.virtualRoot = c.virtualRoot;
	xpc.caseInsensitive = c.caseInsensitive;
	xpc.shouldCreateNodes = c.shouldCreateNodes;
	xpc.shouldFlagNodes = c.shouldFlagNodes;
	if (this.filter == null) {
		nodes = [ c.contextNode ];
	} else {
		var ns = this.filter.evaluate(c);
		if (!Utilities.instance_of(ns, XNodeSet)) {
			if (this.filterPredicates != null && this.filterPredicates.length > 0 || this.locationPath != null) {
				throw new Error("Path expression filter must evaluate to a nodset if predicates or location path are used");
			}
			return ns;
		}
		nodes = ns.toArray();
		if (this.filterPredicates != null) {
			// apply each of the predicates in turn
			for (var j = 0; j < this.filterPredicates.length; j++) {
				var pred = this.filterPredicates[j];
				var newNodes = [];
                var likeChildNodes;

				xpc.contextSize = nodes.length;
                //  wje (2015-03-29): Patched an issue where the position of the
                //  actual node was tied to the looping index. If the set of
                //  nodes comes from different parts of the DOM, their position
                //  *must* be computed relative to their parent, not to the
                //  index of the query result structure.
				//for (xpc.contextPosition = 1; xpc.contextPosition <= xpc.contextSize; xpc.contextPosition++) {
				//	xpc.contextNode = nodes[xpc.contextPosition - 1];
                for (var k = 0; k < xpc.contextSize; k++) {
					xpc.contextNode = nodes[k];
                    likeChildNodes = TP.nodeGetChildNodesByType(
                                                    nodes[k].parentNode,
                                                    nodes[k].nodeType);
                    xpc.contextPosition =
                        Array.prototype.indexOf.call(
                                likeChildNodes, nodes[k]) + 1;

					if (this.predicateMatches(pred, xpc)) {
						newNodes.push(xpc.contextNode);
					}
				}
				nodes = newNodes;
			}
		}
	}
	if (this.locationPath != null) {
		if (this.locationPath.absolute) {
			if (nodes[0].nodeType != 9 /*Node.DOCUMENT_NODE*/) {
				if (xpc.virtualRoot != null) {
					nodes = [ xpc.virtualRoot ];
				} else {
					if (nodes[0].ownerDocument == null) {
						// IE 5.5 doesn't have ownerDocument?
						var n = nodes[0];
						while (n.parentNode != null) {
							n = n.parentNode;
						}
						nodes = [ n ];
					} else {
						nodes = [ nodes[0].ownerDocument ];
					}
				}
			} else {
				nodes = [ nodes[0] ];
			}
		}
		for (var i = 0; i < this.locationPath.steps.length; i++) {
			var step = this.locationPath.steps[i];
			var newNodes = [];
			var newLocalContext = [];
			for (var j = 0; j < nodes.length; j++) {
				xpc.contextNode = nodes[j];
				switch (step.axis) {
					case Step.ANCESTOR:
						// look at all the ancestor nodes
						if (xpc.contextNode === xpc.virtualRoot) {
							break;
						}
						var m;
						if (xpc.contextNode.nodeType == 2 /*Node.ATTRIBUTE_NODE*/) {
							m = this.getOwnerElement(xpc.contextNode);
						} else {
							m = xpc.contextNode.parentNode;
						}
						while (m != null) {
							if (step.nodeTest.matches(m, xpc)) {
								newNodes.push(m);
							}
							if (m === xpc.virtualRoot) {
								break;
							}
							m = m.parentNode;
						}
						break;

					case Step.ANCESTORORSELF:
						// look at all the ancestor nodes and the current node
						for (var m = xpc.contextNode; m != null; m = m.nodeType == 2 /*Node.ATTRIBUTE_NODE*/ ? this.getOwnerElement(m) : m.parentNode) {
							if (step.nodeTest.matches(m, xpc)) {
								newNodes.push(m);
							}
							if (m === xpc.virtualRoot) {
								break;
							}
						}
						break;

					case Step.ATTRIBUTE:
						// look at the attributes
						pushed = false;
						var nnm = xpc.contextNode.attributes;
						if (nnm != null) {
							for (var k = 0; k < nnm.length; k++) {
								var m = nnm.item(k);
								if (step.nodeTest.matches(m, xpc)) {
									newNodes.push(m);
									pushed = true;
								}
							}
						}
						// couldn't find the matching attribute - are we
						// configured to 'create nodes'?
						if (pushed == false && xpc.shouldCreateNodes == true) {
							var newNode;
							if (xpc.shouldFlagNodes == true) {
								//  this will mark with crud attribute
								TP.elementFlagChange(
										xpc.contextNode,
										TP.ATTR + step.nodeTest.value,
										TP.CREATE);
							}

							xpc.contextNode.setAttribute(
									step.nodeTest.value, '');
							newNode = xpc.contextNode.getAttributeNode(
									step.nodeTest.value);
							newNodes.push(newNode);
						}
						break;

					case Step.CHILD:
						// look at all child elements
						pushed = false;
						var pos = 0
						var tmpContext = []
						for (var m = xpc.contextNode.firstChild; m != null; m = m.nextSibling) {
							if (step.nodeTest.matches(m, xpc)) {
								if (xpc.shouldFlagNodes == true) {
									//  if nodes are being flagged we have
									//  to check for deleted status nodes
									//  and reset as we go...
									var existingAction,
                                        elem;
                                    elem = m.nodeType === 1 ? m : m.parentNode;
									existingAction =
										TP.elementGetChangeAction(elem, TP.SELF);
									if (existingAction === TP.DELETE) {
										if (xpc.shouldCreateNodes == true) {
											TP.elementFlagChange(
													elem, TP.SELF, TP.CREATE);
											newNodes.push(m);
                                            //keep track of the element position between other matching siblings
                                            tmpContext.push({contextPosition: ++pos});
											pushed = true;
										} else {
											//  pretend node isn't there
											pushed = false;
										}
									} else {
								        newNodes.push(m);
                                        //keep track of the element position between other matching siblings
                                        tmpContext.push({contextPosition: ++pos});
										pushed = true;
									}
								} else {
                                    newNodes.push(m);
                                    //keep track of the element position between other matching siblings
                                    tmpContext.push({contextPosition: ++pos});
									pushed = true;
                                }
							}
						}

						if ((pushed == false) &&
							(xpc.shouldCreateNodes == true)) {
							var ownerDoc,

                                flagNode,
                                newNode,
                                action,

                                name,
                                hadScalar;

							//  when the root portion of the path doesn't
							//  match you end up at the document element and
							//  have to respond differently
							ownerDoc = xpc.contextNode.ownerDocument;
							if (TP.notValid(ownerDoc)) {
								ownerDoc = xpc.contextNode;
							}

                            hadScalar = false;

                            switch(step.nodeTest.type) {
                                case NodeTest.COMMENT:
                                    flagNode = xpc.contextNode;
                                    newNode = ownerDoc.createComment(
                                                        step.nodeTest.value);
                                    action = TP.UPDATE;
                                    break;
                                case NodeTest.TEXT:
                                    flagNode = xpc.contextNode;
                                    newNode = ownerDoc.createTextNode(
										step.nodeTest.value);
                                    action = TP.UPDATE;
                                    break;
                                case NodeTest.PI:
                                    flagNode = xpc.contextNode;
                                    newNode =
                                        ownerDoc.createProcessingInstruction(
                                                        step.nodeTest.value);
                                    action = TP.UPDATE;
                                    break;
                                default:
                                    name = step.nodeTest.value ?
                                            step.nodeTest.value :
                                            xpc.contextNode.nodeName;

                                    newNode = ownerDoc.createElement(name);
                                    flagNode = newNode;
                                    action = TP.CREATE;

                                    TP.nodeNormalize(xpc.contextNode);

                                    if (xpc.contextNode.childNodes.length === 1 &&
                                        xpc.contextNode.childNodes[0].nodeType === 3) {
                                        xpc.contextNode.removeChild(
                                                xpc.contextNode.childNodes[0]);
                                        hadScalar = true;
                                    }
                            }

							if (xpc.shouldFlagNodes == true) {
								TP.elementFlagChange(flagNode, TP.SELF, action);
							}

							xpc.contextNode.appendChild(newNode);
							if (hadScalar && xpc.shouldFlagNodes == true) {
								TP.elementFlagChange(xpc.contextNode,
                                                        TP.SELF,
                                                        TP.UPDATE);
							}

							newNodes.push(newNode);

                            pushed = true;
						}

						for (var k=0; k<tmpContext.length; k++) {
							//track size of matching siblings
							tmpContext[k].contextSize = pos
							newLocalContext.push(tmpContext[k])
						}

						break;

					case Step.DESCENDANT:
						// look at all descendant nodes
						var st = [ xpc.contextNode.firstChild ];
						while (st.length > 0) {
							for (var m = st.pop(); m != null; ) {
								if (step.nodeTest.matches(m, xpc)) {
									newNodes.push(m);
								}
								if (m.firstChild != null) {
									st.push(m.nextSibling);
									m = m.firstChild;
								} else {
									m = m.nextSibling;
								}
							}
						}
						break;

					case Step.DESCENDANTORSELF:
						// look at self
						if (step.nodeTest.matches(xpc.contextNode, xpc)) {
							newNodes.push(xpc.contextNode);
						}
						// look at all descendant nodes
						var st = [ xpc.contextNode.firstChild ];
						while (st.length > 0) {
							for (var m = st.pop(); m != null; ) {
								if (step.nodeTest.matches(m, xpc)) {
									newNodes.push(m);
								}
								if (m.firstChild != null) {
									st.push(m.nextSibling);
									m = m.firstChild;
								} else {
									m = m.nextSibling;
								}
							}
						}
						break;

					case Step.FOLLOWING:
						if (xpc.contextNode === xpc.virtualRoot) {
							break;
						}
						var st = [];
						if (xpc.contextNode.firstChild != null) {
							st.unshift(xpc.contextNode.firstChild);
						} else {
							st.unshift(xpc.contextNode.nextSibling);
						}
						for (var m = xpc.contextNode; m != null && m.nodeType != 9 /*Node.DOCUMENT_NODE*/ && m !== xpc.virtualRoot; m = m.parentNode) {
							st.unshift(m.nextSibling);
						}
						do {
							for (var m = st.pop(); m != null; ) {
								if (step.nodeTest.matches(m, xpc)) {
									newNodes.push(m);
								}
								if (m.firstChild != null) {
									st.push(m.nextSibling);
									m = m.firstChild;
								} else {
									m = m.nextSibling;
								}
							}
						} while (st.length > 0);
						break;

					case Step.FOLLOWINGSIBLING:
						if (xpc.contextNode === xpc.virtualRoot) {
							break;
						}
						for (var m = xpc.contextNode.nextSibling; m != null; m = m.nextSibling) {
							if (step.nodeTest.matches(m, xpc)) {
								newNodes.push(m);
							}
						}
						break;

					case Step.NAMESPACE:
						var n = {};
						if (xpc.contextNode.nodeType == 1 /*Node.ELEMENT_NODE*/) {
							n["xml"] = XPath.XML_NAMESPACE_URI;
							n["xmlns"] = XPath.XMLNS_NAMESPACE_URI;
							for (var m = xpc.contextNode; m != null && m.nodeType == 1 /*Node.ELEMENT_NODE*/; m = m.parentNode) {
								for (var k = 0; k < m.attributes.length; k++) {
									var attr = m.attributes.item(k);
									var nm = String(attr.name);
									if (nm == "xmlns") {
										if (n[""] == undefined) {
											n[""] = attr.value;
										}
									} else if (nm.length > 6 && nm.substring(0, 6) == "xmlns:") {
										var pre = nm.substring(6, nm.length);
										if (n[pre] == undefined) {
											n[pre] = attr.value;
										}
									} else if (attr.namespaceURI == 'http://www.w3.org/2000/xmlns/') {
										if (n[nm] == undefined) {
											n[nm] = attr.value;
										}
									}
								}
							}
							for (var pre in n) {
								var nsn = new NamespaceNode(pre, n[pre], xpc.contextNode);
								if (step.nodeTest.matches(nsn, xpc)) {
									newNodes.push(nsn);
								}
							}
						}
						break;

					case Step.PARENT:
						m = null;
						if (xpc.contextNode !== xpc.virtualRoot) {
							if (xpc.contextNode.nodeType == 2 /*Node.ATTRIBUTE_NODE*/) {
								m = this.getOwnerElement(xpc.contextNode);
							} else {
								m = xpc.contextNode.parentNode;
							}
						}
						if (m != null && step.nodeTest.matches(m, xpc)) {
							newNodes.push(m);
						}
						break;

					case Step.PRECEDING:
						var st;
						if (xpc.virtualRoot != null) {
							st = [ xpc.virtualRoot ];
						} else {
							st = xpc.contextNode.nodeType == 9 /*Node.DOCUMENT_NODE*/
								? [ xpc.contextNode ]
								: [ xpc.contextNode.ownerDocument ];
						}
						outer: while (st.length > 0) {
							for (var m = st.pop(); m != null; ) {
								if (m == xpc.contextNode) {
									break outer;
								}
								if (step.nodeTest.matches(m, xpc)) {
									newNodes.unshift(m);
								}
								if (m.firstChild != null) {
									st.push(m.nextSibling);
									m = m.firstChild;
								} else {
									m = m.nextSibling;
								}
							}
						}
						break;

					case Step.PRECEDINGSIBLING:
						if (xpc.contextNode === xpc.virtualRoot) {
							break;
						}
						for (var m = xpc.contextNode.previousSibling; m != null; m = m.previousSibling) {
							if (step.nodeTest.matches(m, xpc)) {
								newNodes.push(m);
							}
						}
						break;

					case Step.SELF:
						if (step.nodeTest.matches(xpc.contextNode, xpc)) {
							newNodes.push(xpc.contextNode);
						}
						break;

					default:
				}
			}
			nodes = newNodes;
            var checkedOnce = false;
			// apply each of the predicates in turn
			for (var j = 0; j < step.predicates.length; j++) {
				var pred = step.predicates[j];
				var newNodes = [];
                var likeChildNodes;

				xpc.contextSize = nodes.length;
                //  wje (2015-03-29): Patched an issue where the position of the
                //  actual node was tied to the looping index. If the set of
                //  nodes comes from different parts of the DOM, their position
                //  *must* be computed relative to their parent, not to the
                //  index of the query result structure.
				//for (xpc.contextPosition = 1; xpc.contextPosition <= xpc.contextSize; xpc.contextPosition++) {
				//	xpc.contextNode = nodes[xpc.contextPosition - 1];
                for (var k = 0; k < xpc.contextSize; k++) {
					xpc.contextNode = nodes[k];
                    likeChildNodes = TP.nodeGetChildNodesByType(
                                                    nodes[k].parentNode,
                                                    nodes[k].nodeType);
                    xpc.contextPosition =
                        Array.prototype.indexOf.call(
                                likeChildNodes, nodes[k]) + 1;

                    //  wje (2015-03-30): Added 'node building' code for certain
                    //  limited predicate expressions (position() and
                    //  local-name() matching).
                    if (checkedOnce == false && xpc.shouldCreateNodes == true) {

                        var matchRe,
                            results,
                            nums,
                            names,
                            count,
                            contextParent,
                            minNumChildNodes,
                            numChildNodes,
                            createNumNodes;

                        contextParent = xpc.contextNode.parentNode;

                        ownerDoc = contextParent.ownerDocument;
                        if (TP.notValid(ownerDoc)) {
                            ownerDoc = contextParent;
                        }

                        if (/position\(\)/.test(pred.toString())) {
                            matchRe = /position[^\d]+(\d+?)/g;
                            nums = [];

                            //  Extract all of the numeric indexes from the
                            //  'position()' statements in the predicate
                            //  statement, convert them to Numbers and sort
                            //  lowest to highest.
                            while ((results = matchRe.exec(pred.toString()))) {
                                nums.push(parseInt(results[1], 10));
                            }
                            nums.sort(function(a, b) {
                                        return a - b;
                                        });

                            //  If we got real numbers, then make sure that the
                            //  current context node's *parent* node has the
                            //  correct number of children. If not, build them
                            //  and flag each one as being created.
                            if (nums.length > 0) {
                                minNumChildNodes = nums[nums.length - 1];
                                numChildNodes = contextParent.childNodes.length;

                                if (numChildNodes < minNumChildNodes) {
                                    createNumNodes =
                                        minNumChildNodes - numChildNodes;

                                    for (count = 0;
                                            count < createNumNodes;
                                            count++) {

                                        newNode = ownerDoc.createElement(
                                                        contextParent.nodeName);
                                        action = TP.CREATE;

                                        if (xpc.shouldFlagNodes == true) {
                                            TP.elementFlagChange(newNode,
                                                                    TP.SELF,
                                                                    action);
                                        }

                                        contextParent.appendChild(newNode);

                                        //  Add the newly created node to the
                                        //  set of nodes that is being
                                        //  'considered' for this step in the
                                        //  predicate engine
                                        nodes.push(newNode);
                                    }
                                }
                            }
                        }

                        if (/local-name\(\)/.test(pred.toString())) {
                            matchRe = /local-name\(\)\s*=\s*['"]?([^'"]+)['"]?/g;
                            names = [];

                            //  Extract any names used with 'local-name()'
                            while ((results = matchRe.exec(pred.toString()))) {
                                names.push(results[1]);
                            }

                            //  Iterate over the set of names.
                            for (count = 0; count < names.length; count++) {
                                //  Detect if there a *child* element under the
                                //  context node's parent node. If not, create
                                //  one with that name and flag it as created.
                                if (TP.byCSSPath(
                                            '> ' + names[count],
                                            contextParent,
                                            false,
                                            false).length === 0) {

                                    newNode = ownerDoc.createElement(
                                                            names[count]);
                                    action = TP.CREATE;

                                    if (xpc.shouldFlagNodes == true) {
                                        TP.elementFlagChange(newNode,
                                                                TP.SELF,
                                                                action);
                                    }

                                    contextParent.appendChild(newNode);

                                    //  Add the newly created node to the set of
                                    //  nodes that is being 'considered' for
                                    //  this step in the predicate engine
                                    nodes.push(newNode);
                                }
                            }
                        }

                        //  NOTE: Make sure to update the context size here with
                        //  the newly added nodes!
                        xpc.contextSize = nodes.length;

                        //  Update our flag - we've already checked once for
                        //  this location step - no need to check again.
                        checkedOnce = true;
                    }

                    //  wje (2015-07-26): For now we don't use this.
					//if we keep track of the node original context then use it
					//end goal is to always use original cotnext, now implemented just for CHILD axis
					//var localCtx = newLocalContext.length>0?this.getLocalCtx(xpc, newLocalContext[k]):xpc
					//if (this.predicateMatches(pred, localCtx)) {
					if (this.predicateMatches(pred, xpc)) {
						newNodes.push(xpc.contextNode);
					} else {
					}
				}
				nodes = newNodes;
				//console.log(nodes.length)
			}
		}
	}
	var ns = new XNodeSet();
	ns.addArray(nodes);
	return ns;
};

PathExpr.prototype.getLocalCtx = function(xpc, localCtx, length) {
	var res = new XPathContext();
	res.variableResolver = xpc.variableResolver;
	res.functionResolver = xpc.functionResolver;
	res.namespaceResolver = xpc.namespaceResolver;
	res.expressionContextNode = xpc.expressionContextNode;
	res.virtualRoot = xpc.virtualRoot;
	res.caseInsensitive = xpc.caseInsensitive;
	res.contextNode = xpc.contextNode;
	res.contextPosition = localCtx.contextPosition;
	res.contextSize = localCtx.contextSize;
	return res;
};

PathExpr.prototype.predicateMatches = function(pred, c) {
	var res = pred.evaluate(c);
	if (Utilities.instance_of(res, XNumber)) {
		var val = c.contextPosition == res.numberValue()
		return val;
	}
	return res.booleanValue();
};

PathExpr.prototype.toString = function() {
	if (this.filter != undefined) {
		var s = this.filter.toString();
		if (Utilities.instance_of(this.filter, XString)) {
			s = "'" + s + "'";
		}
		if (this.filterPredicates != undefined) {
			for (var i = 0; i < this.filterPredicates.length; i++) {
				s = s + "[" + this.filterPredicates[i].toString() + "]";
			}
		}
		if (this.locationPath != undefined) {
			if (!this.locationPath.absolute) {
				s += "/";
			}
			s += this.locationPath.toString();
		}
		return s;
	}
	return this.locationPath.toString();
};

PathExpr.prototype.toReplacedString = function(replacementFunc) {
	if (this.filter != undefined) {
		var s = "";

		//if (this.filter.constructor === XString) {
		if (Utilities.instance_of(this.filter, XString)) {
			s += "'" + this.filter.toString() + "'";
		}
		else {
			s += this.filter.toReplacedString(replacementFunc);
		}
		if (this.filterPredicates != undefined) {
			for (var i = 0; i < this.filterPredicates.length; i++) {
				s = s + "[" + this.filterPredicates[i].toReplacedString(replacementFunc) + "]";
			}
		}
		if (this.locationPath != undefined) {
			if (!this.locationPath.absolute) {
				s += "/";
			}
			s += this.locationPath.toReplacedString(replacementFunc);
		}
		return s;
	}
	return replacementFunc(this.locationPath);
};

PathExpr.prototype.gatherLocationPathsInto = function(arr) {
	if (this.filter != undefined) {
		this.filter.gatherLocationPathsInto(arr);
	}
	if (this.locationPath != undefined) {
	    arr.push(this);
	}
};

PathExpr.prototype.getOwnerElement = function(n) {
	// DOM 2 has ownerElement
	if (n.ownerElement) {
		return n.ownerElement;
	}
	// DOM 1 Internet Explorer can use selectSingleNode (ironically)
	try {
		if (n.selectSingleNode) {
			return n.selectSingleNode("..");
		}
	} catch (e) {
	}
	// Other DOM 1 implementations must use this egregious search
	var doc = n.nodeType == 9 /*Node.DOCUMENT_NODE*/
			? n
			: n.ownerDocument;
	var elts = doc.getElementsByTagName("*");
	for (var i = 0; i < elts.length; i++) {
		var elt = elts.item(i);
		var nnm = elt.attributes;
		for (var j = 0; j < nnm.length; j++) {
			var an = nnm.item(j);
			if (an === n) {
				return elt;
			}
		}
	}
	return null;
};

// LocationPath //////////////////////////////////////////////////////////////

LocationPath.prototype = new Object();
LocationPath.prototype.constructor = LocationPath;
LocationPath.superclass = Object.prototype;

function LocationPath(abs, steps) {
	if (arguments.length > 0) {
		this.init(abs, steps);
	}
}

LocationPath.prototype.init = function(abs, steps) {
	this.absolute = abs;
	this.steps = steps;
};

LocationPath.prototype.toString = function() {
	var s;
	if (this.absolute) {
		s = "/";
	} else {
		s = "";
	}
	for (var i = 0; i < this.steps.length; i++) {
		if (i != 0) {
			s += "/";
		}
		s += this.steps[i].toString();
	}
	return s;
};

LocationPath.prototype.toReplacedString = function(replacementFunc) {
	var s;
	if (this.absolute) {
		s = "/";
	} else {
		s = "";
	}
	for (var i = 0; i < this.steps.length; i++) {
		if (i != 0) {
			s += "/";
		}
		s += this.steps[i].toString();
	}
	return s;
};

// Step //////////////////////////////////////////////////////////////////////

Step.prototype = new Object();
Step.prototype.constructor = Step;
Step.superclass = Object.prototype;

function Step(axis, nodetest, preds) {
	if (arguments.length > 0) {
		this.init(axis, nodetest, preds);
	}
}

Step.prototype.init = function(axis, nodetest, preds) {
	this.axis = axis;
	this.nodeTest = nodetest;
	this.predicates = preds;
};

Step.prototype.toString = function() {
	var s;
	switch (this.axis) {
		case Step.ANCESTOR:
			s = "ancestor";
			break;
		case Step.ANCESTORORSELF:
			s = "ancestor-or-self";
			break;
		case Step.ATTRIBUTE:
			s = "attribute";
			break;
		case Step.CHILD:
			s = "child";
			break;
		case Step.DESCENDANT:
			s = "descendant";
			break;
		case Step.DESCENDANTORSELF:
			s = "descendant-or-self";
			break;
		case Step.FOLLOWING:
			s = "following";
			break;
		case Step.FOLLOWINGSIBLING:
			s = "following-sibling";
			break;
		case Step.NAMESPACE:
			s = "namespace";
			break;
		case Step.PARENT:
			s = "parent";
			break;
		case Step.PRECEDING:
			s = "preceding";
			break;
		case Step.PRECEDINGSIBLING:
			s = "preceding-sibling";
			break;
		case Step.SELF:
			s = "self";
			break;
	}
	s += "::";
	s += this.nodeTest.toString();
	for (var i = 0; i < this.predicates.length; i++) {
		s += "[" + this.predicates[i].toString() + "]";
	}
	return s;
};

Step.ANCESTOR = 0;
Step.ANCESTORORSELF = 1;
Step.ATTRIBUTE = 2;
Step.CHILD = 3;
Step.DESCENDANT = 4;
Step.DESCENDANTORSELF = 5;
Step.FOLLOWING = 6;
Step.FOLLOWINGSIBLING = 7;
Step.NAMESPACE = 8;
Step.PARENT = 9;
Step.PRECEDING = 10;
Step.PRECEDINGSIBLING = 11;
Step.SELF = 12;

// NodeTest //////////////////////////////////////////////////////////////////

NodeTest.prototype = new Object();
NodeTest.prototype.constructor = NodeTest;
NodeTest.superclass = Object.prototype;

function NodeTest(type, value) {
	if (arguments.length > 0) {
		this.init(type, value);
	}
}

NodeTest.prototype.init = function(type, value) {
	this.type = type;
	this.value = value;
};

NodeTest.prototype.toString = function() {
	switch (this.type) {
		case NodeTest.NAMETESTANY:
			return "*";
		case NodeTest.NAMETESTPREFIXANY:
			return this.value + ":*";
		case NodeTest.NAMETESTRESOLVEDANY:
			return "{" + this.value + "}*";
		case NodeTest.NAMETESTQNAME:
			return this.value;
		case NodeTest.NAMETESTRESOLVEDNAME:
			return "{" + this.namespaceURI + "}" + this.value;
		case NodeTest.COMMENT:
			return "comment()";
		case NodeTest.TEXT:
			return "text()";
		case NodeTest.PI:
			if (this.value != undefined) {
				return "processing-instruction(\"" + this.value + "\")";
			}
			return "processing-instruction()";
		case NodeTest.NODE:
			return "node()";
	}
	return "<unknown nodetest type>";
};

NodeTest.prototype.matches = function(n, xpc) {
	switch (this.type) {
		case NodeTest.NAMETESTANY:
			if (n.nodeType == 2 /*Node.ATTRIBUTE_NODE*/
					|| n.nodeType == 1 /*Node.ELEMENT_NODE*/
					|| n.nodeType == XPathNamespace.XPATH_NAMESPACE_NODE) {
				return true;
			}
			return false;
		case NodeTest.NAMETESTPREFIXANY:
			if ((n.nodeType == 2 /*Node.ATTRIBUTE_NODE*/ || n.nodeType == 1 /*Node.ELEMENT_NODE*/)) {
				var ns = xpc.namespaceResolver.getNamespace(this.value, xpc.expressionContextNode);
				if (ns == null) {
					throw new Error("Cannot resolve QName " + this.value);
				}
				return true;
			}
			return false;
		case NodeTest.NAMETESTQNAME:
			if (n.nodeType == 2 /*Node.ATTRIBUTE_NODE*/
					|| n.nodeType == 1 /*Node.ELEMENT_NODE*/
					|| n.nodeType == XPathNamespace.XPATH_NAMESPACE_NODE) {
				var test = Utilities.resolveQName(this.value, xpc.namespaceResolver, xpc.expressionContextNode, false);
				if (test[0] == null) {
					throw new Error("Cannot resolve QName " + this.value);
				}
				test[0] = String(test[0]);
				test[1] = String(test[1]);
				if (test[0] == "") {
					test[0] = null;
				}
				var node = Utilities.resolveQName(n.nodeName, xpc.namespaceResolver, n, n.nodeType == 1 /*Node.ELEMENT_NODE*/);
				node[0] = String(node[0]);
				node[1] = String(node[1]);
				if (node[0] == "") {
					node[0] = null;
				}
				if (xpc.caseInsensitive) {
					return test[0] == node[0] && String(test[1]).toLowerCase() == String(node[1]).toLowerCase();
				}
				return test[0] == node[0] && test[1] == node[1];
			}
			return false;
		case NodeTest.COMMENT:
			return n.nodeType == 8 /*Node.COMMENT_NODE*/;
		case NodeTest.TEXT:
			return n.nodeType == 3 /*Node.TEXT_NODE*/ || n.nodeType == 4 /*Node.CDATA_SECTION_NODE*/;
		case NodeTest.PI:
			return n.nodeType == 7 /*Node.PROCESSING_INSTRUCTION_NODE*/
				&& (this.value == null || n.nodeName == this.value);
		case NodeTest.NODE:
			return n.nodeType == 9 /*Node.DOCUMENT_NODE*/
				|| n.nodeType == 1 /*Node.ELEMENT_NODE*/
				|| n.nodeType == 2 /*Node.ATTRIBUTE_NODE*/
				|| n.nodeType == 3 /*Node.TEXT_NODE*/
				|| n.nodeType == 4 /*Node.CDATA_SECTION_NODE*/
				|| n.nodeType == 8 /*Node.COMMENT_NODE*/
				|| n.nodeType == 7 /*Node.PROCESSING_INSTRUCTION_NODE*/;
	}
	return false;
};

NodeTest.NAMETESTANY = 0;
NodeTest.NAMETESTPREFIXANY = 1;
NodeTest.NAMETESTQNAME = 2;
NodeTest.COMMENT = 3;
NodeTest.TEXT = 4;
NodeTest.PI = 5;
NodeTest.NODE = 6;

// VariableReference /////////////////////////////////////////////////////////

VariableReference.prototype = new Expression();
VariableReference.prototype.constructor = VariableReference;
VariableReference.superclass = Expression.prototype;

function VariableReference(v) {
	if (arguments.length > 0) {
		this.init(v);
	}
}

VariableReference.prototype.init = function(v) {
	this.variable = v;
};

VariableReference.prototype.toString = function() {
	return "$" + this.variable;
};

VariableReference.prototype.evaluate = function(c) {
	return c.variableResolver.getVariable(this.variable, c);
};

// FunctionCall //////////////////////////////////////////////////////////////

FunctionCall.prototype = new Expression();
FunctionCall.prototype.constructor = FunctionCall;
FunctionCall.superclass = Expression.prototype;

function FunctionCall(fn, args) {
	if (arguments.length > 0) {
		this.init(fn, args);
	}
}

FunctionCall.prototype.init = function(fn, args) {
	this.functionName = fn;
	this.arguments = args;
};

FunctionCall.prototype.toString = function() {
	var s = this.functionName + "(";
	for (var i = 0; i < this.arguments.length; i++) {
		if (i > 0) {
			s += ", ";
		}
		s += this.arguments[i].toString();
	}
	return s + ")";
};

FunctionCall.prototype.toReplacedString = function(replacementFunc) {
	var s = this.functionName + '(';
	for (var i = 0; i < this.arguments.length; i++) {
		if (i > 0) {
			s += ', ';
		}
		s += this.arguments[i].toReplacedString(replacementFunc);
	}
	return s + ')';
};

FunctionCall.prototype.evaluate = function(c) {
	var f = c.functionResolver.getFunction(this.functionName, c);
	if (f == undefined) {
		throw new Error("Unknown function " + this.functionName);
	}
	var a = [c].concat(this.arguments);
	return f.apply(c.functionResolver.thisArg, a);
};

// XString ///////////////////////////////////////////////////////////////////

XString.prototype = new Expression();
XString.prototype.constructor = XString;
XString.superclass = Expression.prototype;

function XString(s) {
	if (arguments.length > 0) {
		this.init(s);
	}
}

XString.prototype.init = function(s) {
	this.str = s;
};

XString.prototype.toString = function() {
	return this.str;
};

XString.prototype.evaluate = function(c) {
	return this;
};

XString.prototype.string = function() {
	return this;
};

XString.prototype.number = function() {
	return new XNumber(this.str);
};

XString.prototype.bool = function() {
	return new XBoolean(this.str);
};

XString.prototype.nodeset = function() {
	throw new Error("Cannot convert string to nodeset");
};

XString.prototype.stringValue = function() {
	return this.str;
};

XString.prototype.numberValue = function() {
	return this.number().numberValue();
};

XString.prototype.booleanValue = function() {
	return this.bool().booleanValue();
};

XString.prototype.equals = function(r) {
	if (Utilities.instance_of(r, XBoolean)) {
		return this.bool().equals(r);
	}
	if (Utilities.instance_of(r, XNumber)) {
		return this.number().equals(r);
	}
	if (Utilities.instance_of(r, XNodeSet)) {
		return r.compareWithString(this, Operators.equals);
	}
	return new XBoolean(this.str == r.str);
};

XString.prototype.notequal = function(r) {
	if (Utilities.instance_of(r, XBoolean)) {
		return this.bool().notequal(r);
	}
	if (Utilities.instance_of(r, XNumber)) {
		return this.number().notequal(r);
	}
	if (Utilities.instance_of(r, XNodeSet)) {
		return r.compareWithString(this, Operators.notequal);
	}
	return new XBoolean(this.str != r.str);
};

XString.prototype.lessthan = function(r) {
	if (Utilities.instance_of(r, XNodeSet)) {
		return r.compareWithNumber(this.number(), Operators.greaterthanorequal);
	}
	return this.number().lessthan(r.number());
};

XString.prototype.greaterthan = function(r) {
	if (Utilities.instance_of(r, XNodeSet)) {
		return r.compareWithNumber(this.number(), Operators.lessthanorequal);
	}
	return this.number().greaterthan(r.number());
};

XString.prototype.lessthanorequal = function(r) {
	if (Utilities.instance_of(r, XNodeSet)) {
		return r.compareWithNumber(this.number(), Operators.greaterthan);
	}
	return this.number().lessthanorequal(r.number());
};

XString.prototype.greaterthanorequal = function(r) {
	if (Utilities.instance_of(r, XNodeSet)) {
		return r.compareWithNumber(this.number(), Operators.lessthan);
	}
	return this.number().greaterthanorequal(r.number());
};

// XNumber ///////////////////////////////////////////////////////////////////

XNumber.prototype = new Expression();
XNumber.prototype.constructor = XNumber;
XNumber.superclass = Expression.prototype;

function XNumber(n) {
	if (arguments.length > 0) {
		this.init(n);
	}
}

XNumber.prototype.init = function(n) {
	this.num = Number(n);
};

XNumber.prototype.toString = function() {
	return this.num;
};

XNumber.prototype.evaluate = function(c) {
	return this;
};

XNumber.prototype.string = function() {
	return new XString(this.num);
};

XNumber.prototype.number = function() {
	return this;
};

XNumber.prototype.bool = function() {
	return new XBoolean(this.num);
};

XNumber.prototype.nodeset = function() {
	throw new Error("Cannot convert number to nodeset");
};

XNumber.prototype.stringValue = function() {
	return this.string().stringValue();
};

XNumber.prototype.numberValue = function() {
	return this.num;
};

XNumber.prototype.booleanValue = function() {
	return this.bool().booleanValue();
};

XNumber.prototype.negate = function() {
	return new XNumber(-this.num);
};

XNumber.prototype.equals = function(r) {
	if (Utilities.instance_of(r, XBoolean)) {
		return this.bool().equals(r);
	}
	if (Utilities.instance_of(r, XString)) {
		return this.equals(r.number());
	}
	if (Utilities.instance_of(r, XNodeSet)) {
		return r.compareWithNumber(this, Operators.equals);
	}
	return new XBoolean(this.num == r.num);
};

XNumber.prototype.notequal = function(r) {
	if (Utilities.instance_of(r, XBoolean)) {
		return this.bool().notequal(r);
	}
	if (Utilities.instance_of(r, XString)) {
		return this.notequal(r.number());
	}
	if (Utilities.instance_of(r, XNodeSet)) {
		return r.compareWithNumber(this, Operators.notequal);
	}
	return new XBoolean(this.num != r.num);
};

XNumber.prototype.lessthan = function(r) {
	if (Utilities.instance_of(r, XNodeSet)) {
		return r.compareWithNumber(this, Operators.greaterthanorequal);
	}
	if (Utilities.instance_of(r, XBoolean) || Utilities.instance_of(r, XString)) {
		return this.lessthan(r.number());
	}
	return new XBoolean(this.num < r.num);
};

XNumber.prototype.greaterthan = function(r) {
	if (Utilities.instance_of(r, XNodeSet)) {
		return r.compareWithNumber(this, Operators.lessthanorequal);
	}
	if (Utilities.instance_of(r, XBoolean) || Utilities.instance_of(r, XString)) {
		return this.greaterthan(r.number());
	}
	return new XBoolean(this.num > r.num);
};

XNumber.prototype.lessthanorequal = function(r) {
	if (Utilities.instance_of(r, XNodeSet)) {
		return r.compareWithNumber(this, Operators.greaterthan);
	}
	if (Utilities.instance_of(r, XBoolean) || Utilities.instance_of(r, XString)) {
		return this.lessthanorequal(r.number());
	}
	return new XBoolean(this.num <= r.num);
};

XNumber.prototype.greaterthanorequal = function(r) {
	if (Utilities.instance_of(r, XNodeSet)) {
		return r.compareWithNumber(this, Operators.lessthan);
	}
	if (Utilities.instance_of(r, XBoolean) || Utilities.instance_of(r, XString)) {
		return this.greaterthanorequal(r.number());
	}
	return new XBoolean(this.num >= r.num);
};

XNumber.prototype.plus = function(r) {
	return new XNumber(this.num + r.num);
};

XNumber.prototype.minus = function(r) {
	return new XNumber(this.num - r.num);
};

XNumber.prototype.multiply = function(r) {
	return new XNumber(this.num * r.num);
};

XNumber.prototype.div = function(r) {
	return new XNumber(this.num / r.num);
};

XNumber.prototype.mod = function(r) {
	return new XNumber(this.num % r.num);
};

// XBoolean //////////////////////////////////////////////////////////////////

XBoolean.prototype = new Expression();
XBoolean.prototype.constructor = XBoolean;
XBoolean.superclass = Expression.prototype;

function XBoolean(b) {
	if (arguments.length > 0) {
		this.init(b);
	}
}

XBoolean.prototype.init = function(b) {
	this.b = Boolean(b);
};

XBoolean.prototype.toString = function() {
	return this.b.toString();
};

XBoolean.prototype.evaluate = function(c) {
	return this;
};

XBoolean.prototype.string = function() {
	return new XString(this.b);
};

XBoolean.prototype.number = function() {
	return new XNumber(this.b);
};

XBoolean.prototype.bool = function() {
	return this;
};

XBoolean.prototype.nodeset = function() {
	throw new Error("Cannot convert boolean to nodeset");
};

XBoolean.prototype.stringValue = function() {
	return this.string().stringValue();
};

XBoolean.prototype.numberValue = function() {
	return this.num().numberValue();
};

XBoolean.prototype.booleanValue = function() {
	return this.b;
};

XBoolean.prototype.not = function() {
	return new XBoolean(!this.b);
};

XBoolean.prototype.equals = function(r) {
	if (Utilities.instance_of(r, XString) || Utilities.instance_of(r, XNumber)) {
		return this.equals(r.bool());
	}
	if (Utilities.instance_of(r, XNodeSet)) {
		return r.compareWithBoolean(this, Operators.equals);
	}
	return new XBoolean(this.b == r.b);
};

XBoolean.prototype.notequal = function(r) {
	if (Utilities.instance_of(r, XString) || Utilities.instance_of(r, XNumber)) {
		return this.notequal(r.bool());
	}
	if (Utilities.instance_of(r, XNodeSet)) {
		return r.compareWithBoolean(this, Operators.notequal);
	}
	return new XBoolean(this.b != r.b);
};

XBoolean.prototype.lessthan = function(r) {
	if (Utilities.instance_of(r, XNodeSet)) {
		return r.compareWithNumber(this.number(), Operators.greaterthanorequal);
	}
	return this.number().lessthan(r.number());
};

XBoolean.prototype.greaterthan = function(r) {
	if (Utilities.instance_of(r, XNodeSet)) {
		return r.compareWithNumber(this.number(), Operators.lessthanorequal);
	}
	return this.number().greaterthan(r.number());
};

XBoolean.prototype.lessthanorequal = function(r) {
	if (Utilities.instance_of(r, XNodeSet)) {
		return r.compareWithNumber(this.number(), Operators.greaterthan);
	}
	return this.number().lessthanorequal(r.number());
};

XBoolean.prototype.greaterthanorequal = function(r) {
	if (Utilities.instance_of(r, XNodeSet)) {
		return r.compareWithNumber(this.number(), Operators.lessthan);
	}
	return this.number().greaterthanorequal(r.number());
};

// AVLTree ///////////////////////////////////////////////////////////////////

AVLTree.prototype = new Object();
AVLTree.prototype.constructor = AVLTree;
AVLTree.superclass = Object.prototype;

function AVLTree(n) {
	this.init(n);
}

AVLTree.prototype.init = function(n) {
	this.left = null;
    this.right = null;
	this.node = n;
	this.depth = 1;
};

AVLTree.prototype.balance = function() {
    var ldepth = this.left  == null ? 0 : this.left.depth;
    var rdepth = this.right == null ? 0 : this.right.depth;

	if (ldepth > rdepth + 1) {
        // LR or LL rotation
        var lldepth = this.left.left  == null ? 0 : this.left.left.depth;
        var lrdepth = this.left.right == null ? 0 : this.left.right.depth;

        if (lldepth < lrdepth) {
            // LR rotation consists of a RR rotation of the left child
            this.left.rotateRR();
            // plus a LL rotation of this node, which happens anyway
        }
        this.rotateLL();
    } else if (ldepth + 1 < rdepth) {
        // RR or RL rorarion
		var rrdepth = this.right.right == null ? 0 : this.right.right.depth;
		var rldepth = this.right.left  == null ? 0 : this.right.left.depth;

        if (rldepth > rrdepth) {
            // RR rotation consists of a LL rotation of the right child
            this.right.rotateLL();
            // plus a RR rotation of this node, which happens anyway
        }
        this.rotateRR();
    }
};

AVLTree.prototype.rotateLL = function() {
    // the left side is too long => rotate from the left (_not_ leftwards)
    var nodeBefore = this.node;
    var rightBefore = this.right;
    this.node = this.left.node;
    this.right = this.left;
    this.left = this.left.left;
    this.right.left = this.right.right;
    this.right.right = rightBefore;
    this.right.node = nodeBefore;
    this.right.updateInNewLocation();
    this.updateInNewLocation();
};

AVLTree.prototype.rotateRR = function() {
    // the right side is too long => rotate from the right (_not_ rightwards)
    var nodeBefore = this.node;
    var leftBefore = this.left;
    this.node = this.right.node;
    this.left = this.right;
    this.right = this.right.right;
    this.left.right = this.left.left;
    this.left.left = leftBefore;
    this.left.node = nodeBefore;
    this.left.updateInNewLocation();
    this.updateInNewLocation();
};

AVLTree.prototype.updateInNewLocation = function() {
    this.getDepthFromChildren();
};

AVLTree.prototype.getDepthFromChildren = function() {
    this.depth = this.node == null ? 0 : 1;
    if (this.left != null) {
        this.depth = this.left.depth + 1;
    }
    if (this.right != null && this.depth <= this.right.depth) {
        this.depth = this.right.depth + 1;
    }
};

AVLTree.prototype.order = function(n1, n2) {
	if (n1 === n2) {
		return 0;
	}
	var d1 = 0;
	var d2 = 0;
	for (var m1 = n1; m1 != null; m1 = m1.parentNode) {
		d1++;
	}
	for (var m2 = n2; m2 != null; m2 = m2.parentNode) {
		d2++;
	}
	if (d1 > d2) {
		while (d1 > d2) {
			n1 = n1.parentNode;
			d1--;
		}
		if (n1 == n2) {
			return 1;
		}
	} else if (d2 > d1) {
		while (d2 > d1) {
			n2 = n2.parentNode;
			d2--;
		}
		if (n1 == n2) {
			return -1;
		}
	}
	while (n1.parentNode != n2.parentNode) {
		n1 = n1.parentNode;
		n2 = n2.parentNode;
	}
	while (n1.previousSibling != null && n2.previousSibling != null) {
		n1 = n1.previousSibling;
		n2 = n2.previousSibling;
	}
	if (n1.previousSibling == null) {
		return -1;
	}
	return 1;
};

AVLTree.prototype.add = function(n)  {
	if (n === this.node) {
        return false;
    }

	var o = this.order(n, this.node);

    var ret = false;
    if (o == -1) {
        if (this.left == null) {
            this.left = new AVLTree(n);
            ret = true;
        } else {
            ret = this.left.add(n);
            if (ret) {
                this.balance();
            }
        }
    } else if (o == 1) {
        if (this.right == null) {
            this.right = new AVLTree(n);
            ret = true;
        } else {
            ret = this.right.add(n);
            if (ret) {
                this.balance();
            }
        }
    }

    if (ret) {
        this.getDepthFromChildren();
    }
    return ret;
};

// XNodeSet //////////////////////////////////////////////////////////////////

XNodeSet.prototype = new Expression();
XNodeSet.prototype.constructor = XNodeSet;
XNodeSet.superclass = Expression.prototype;

function XNodeSet() {
	this.init();
}

XNodeSet.prototype.init = function() {
	this.tree = null;
	this.size = 0;
};

XNodeSet.prototype.toString = function() {
	var p = this.first();
	if (p == null) {
		return "";
	}
	return this.stringForNode(p);
};

XNodeSet.prototype.evaluate = function(c) {
	return this;
};

XNodeSet.prototype.string = function() {
	return new XString(this.toString());
};

XNodeSet.prototype.stringValue = function() {
	return this.toString();
};

XNodeSet.prototype.number = function() {
	return new XNumber(this.string());
};

XNodeSet.prototype.numberValue = function() {
	return Number(this.string());
};

XNodeSet.prototype.bool = function() {
	return new XBoolean(this.tree != null);
};

XNodeSet.prototype.booleanValue = function() {
	return this.tree != null;
};

XNodeSet.prototype.nodeset = function() {
	return this;
};

XNodeSet.prototype.stringForNode = function(n) {
	if (n.nodeType == 9 /*Node.DOCUMENT_NODE*/) {
		n = n.documentElement;
	}
	if (n.nodeType == 1 /*Node.ELEMENT_NODE*/) {
		return this.stringForNodeRec(n);
	}
	if (n.isNamespaceNode) {
		return n.namespace;
	}
	return n.nodeValue;
};

XNodeSet.prototype.stringForNodeRec = function(n) {
	var s = "";
	for (var n2 = n.firstChild; n2 != null; n2 = n2.nextSibling) {
		if (n2.nodeType == 3 /*Node.TEXT_NODE*/) {
			s += n2.nodeValue;
		} else if (n2.nodeType == 1 /*Node.ELEMENT_NODE*/) {
			s += this.stringForNodeRec(n2);
		}
	}
	return s;
};

XNodeSet.prototype.first = function() {
	var p = this.tree;
	if (p == null) {
		return null;
	}
	while (p.left != null) {
		p = p.left;
	}
	return p.node;
};

	/*
XNodeSet.prototype.add = function(n) {
    var added;
    if (this.tree == null) {
        this.tree = new AVLTree(n);
        added = true;
    } else {
        added = this.tree.add(n);
    }
    if (added) {
        this.size++;
    }
};
	*/

XNodeSet.prototype.add = function(n) {
	if (this.tree == null) {
		this.tree = new Object();
		this.tree.node = n;
		this.tree.left = null;
		this.tree.right = null;
		this.size = 1;
		return;
	}

	var p = this.tree;
	while (1) {
		var o = this.order(n, p.node);
		if (o == 0) {
			return;
		}
		if (o > 0) {
			if (p.right == null) {
				p.right = new Object();
				p.right.node = n;
				p.right.left = null;
				p.right.right = null;
				this.size++;
				return;
			}
			p = p.right;
		} else {
			if (p.left == null) {
				p.left = new Object();
				p.left.node = n;
				p.left.left = null;
				p.left.right = null;
				this.size++;
				return;
			}
			p = p.left;
		}
	}
};

XNodeSet.prototype.addArray = function(ns) {
	for (var i = 0; i < ns.length; i++) {
		this.add(ns[i]);
	}
};

XNodeSet.prototype.toArray = function() {
	var a = [];
	this.toArrayRec(this.tree, a);
	return a;
};

XNodeSet.prototype.toArrayRec = function(t, a) {
	if (t != null) {
		this.toArrayRec(t.left, a);
		a.push(t.node);
		this.toArrayRec(t.right, a);
	}
};

XNodeSet.prototype.order = function(n1, n2) {
	if (n1 == n2) {
		return 0;
	}
	var d1 = 0,
		d2 = 0;
	for (var m1 = n1; m1 != null; m1 = m1.parentNode) {
		d1++;
	}
	for (var m2 = n2; m2 != null; m2 = m2.parentNode) {
		d2++;
	}
	if (d1 > d2) {
		while (d1 > d2) {
			n1 = n1.parentNode;
			d1--;
		}
		if (n1 == n2) {
			return 1;
		}
	} else if (d2 > d1) {
		while (d2 > d1) {
			n2 = n2.parentNode;
			d2--;
		}
		if (n1 == n2) {
			return -1;
		}
	}
	while (n1.parentNode != n2.parentNode) {
		n1 = n1.parentNode;
		n2 = n2.parentNode;
	}
	while (n1.previousSibling != null && n2.previousSibling != null) {
		n1 = n1.previousSibling;
		n2 = n2.previousSibling;
	}
	if (n1.previousSibling == null) {
		return -1;
	}
	return 1;
};

XNodeSet.prototype.compareWithString = function(r, o) {
	var a = this.toArray();
	for (var i = 0; i < a.length; i++) {
		var n = a[i];
		var l = new XString(this.stringForNode(n));
		var res = o(l, r);
		if (res.booleanValue()) {
			return res;
		}
	}
	return new XBoolean(false);
};

XNodeSet.prototype.compareWithNumber = function(r, o) {
	var a = this.toArray();
	for (var i = 0; i < a.length; i++) {
		var n = a[i];
		var l = new XNumber(this.stringForNode(n));
		var res = o(l, r);
		if (res.booleanValue()) {
			return res;
		}
	}
	return new XBoolean(false);
};

XNodeSet.prototype.compareWithBoolean = function(r, o) {
	return o(this.bool(), r);
};

XNodeSet.prototype.compareWithNodeSet = function(r, o) {
	var a = this.toArray();
	for (var i = 0; i < a.length; i++) {
		var n = a[i];
		var l = new XString(this.stringForNode(n));
		var b = r.toArray();
		for (var j = 0; j < b.length; j++) {
			var n2 = b[j];
			var r = new XString(this.stringForNode(n2));
			var res = o(l, r);
			if (res.booleanValue()) {
				return res;
			}
		}
	}
	return new XBoolean(false);
};

XNodeSet.prototype.equals = function(r) {
	if (Utilities.instance_of(r, XString)) {
		return this.compareWithString(r, Operators.equals);
	}
	if (Utilities.instance_of(r, XNumber)) {
		return this.compareWithNumber(r, Operators.equals);
	}
	if (Utilities.instance_of(r, XBoolean)) {
		return this.compareWithBoolean(r, Operators.equals);
	}
	return this.compareWithNodeSet(r, Operators.equals);
};

XNodeSet.prototype.notequal = function(r) {
	if (Utilities.instance_of(r, XString)) {
		return this.compareWithString(r, Operators.notequal);
	}
	if (Utilities.instance_of(r, XNumber)) {
		return this.compareWithNumber(r, Operators.notequal);
	}
	if (Utilities.instance_of(r, XBoolean)) {
		return this.compareWithBoolean(r, Operators.notequal);
	}
	return this.compareWithNodeSet(r, Operators.notequal);
};

XNodeSet.prototype.lessthan = function(r) {
	if (Utilities.instance_of(r, XString)) {
		return this.compareWithNumber(r.number(), Operators.lessthan);
	}
	if (Utilities.instance_of(r, XNumber)) {
		return this.compareWithNumber(r, Operators.lessthan);
	}
	if (Utilities.instance_of(r, XBoolean)) {
		return this.compareWithBoolean(r, Operators.lessthan);
	}
	return this.compareWithNodeSet(r, Operators.lessthan);
};

XNodeSet.prototype.greaterthan = function(r) {
	if (Utilities.instance_of(r, XString)) {
		return this.compareWithNumber(r.number(), Operators.greaterthan);
	}
	if (Utilities.instance_of(r, XNumber)) {
		return this.compareWithNumber(r, Operators.greaterthan);
	}
	if (Utilities.instance_of(r, XBoolean)) {
		return this.compareWithBoolean(r, Operators.greaterthan);
	}
	return this.compareWithNodeSet(r, Operators.greaterthan);
};

XNodeSet.prototype.lessthanorequal = function(r) {
	if (Utilities.instance_of(r, XString)) {
		return this.compareWithNumber(r.number(), Operators.lessthanorequal);
	}
	if (Utilities.instance_of(r, XNumber)) {
		return this.compareWithNumber(r, Operators.lessthanorequal);
	}
	if (Utilities.instance_of(r, XBoolean)) {
		return this.compareWithBoolean(r, Operators.lessthanorequal);
	}
	return this.compareWithNodeSet(r, Operators.lessthanorequal);
};

XNodeSet.prototype.greaterthanorequal = function(r) {
	if (Utilities.instance_of(r, XString)) {
		return this.compareWithNumber(r.number(), Operators.greaterthanorequal);
	}
	if (Utilities.instance_of(r, XNumber)) {
		return this.compareWithNumber(r, Operators.greaterthanorequal);
	}
	if (Utilities.instance_of(r, XBoolean)) {
		return this.compareWithBoolean(r, Operators.greaterthanorequal);
	}
	return this.compareWithNodeSet(r, Operators.greaterthanorequal);
};

XNodeSet.prototype.union = function(r) {
	var ns = new XNodeSet();
	ns.tree = this.tree;
	ns.size = this.size;
	ns.addArray(r.toArray());
	return ns;
};

// XPathNamespace ////////////////////////////////////////////////////////////

XPathNamespace.prototype = new Object();
XPathNamespace.prototype.constructor = XPathNamespace;
XPathNamespace.superclass = Object.prototype;

function XPathNamespace(pre, ns, p) {
	this.isXPathNamespace = true;
	this.ownerDocument = p.ownerDocument;
	this.nodeName = "#namespace";
	this.prefix = pre;
	this.localName = pre;
	this.namespaceURI = ns;
	this.nodeValue = ns;
	this.ownerElement = p;
	this.nodeType = XPathNamespace.XPATH_NAMESPACE_NODE;
}

XPathNamespace.prototype.toString = function() {
	return "{ \"" + this.prefix + "\", \"" + this.namespaceURI + "\" }";
};

// Operators /////////////////////////////////////////////////////////////////

var Operators = new Object();

Operators.equals = function(l, r) {
	return l.equals(r);
};

Operators.notequal = function(l, r) {
	return l.notequal(r);
};

Operators.lessthan = function(l, r) {
	return l.lessthan(r);
};

Operators.greaterthan = function(l, r) {
	return l.greaterthan(r);
};

Operators.lessthanorequal = function(l, r) {
	return l.lessthanorequal(r);
};

Operators.greaterthanorequal = function(l, r) {
	return l.greaterthanorequal(r);
};

// XPathContext //////////////////////////////////////////////////////////////

XPathContext.prototype = new Object();
XPathContext.prototype.constructor = XPathContext;
XPathContext.superclass = Object.prototype;

function XPathContext(vr, nr, fr) {
	this.variableResolver = vr != null ? vr : new VariableResolver();
	this.namespaceResolver = nr != null ? nr : new NamespaceResolver();
	this.functionResolver = fr != null ? fr : new FunctionResolver();
}

// VariableResolver //////////////////////////////////////////////////////////

VariableResolver.prototype = new Object();
VariableResolver.prototype.constructor = VariableResolver;
VariableResolver.superclass = Object.prototype;

function VariableResolver() {
}

VariableResolver.prototype.getVariable = function(vn, c) {
	var parts = Utilities.splitQName(vn);
	if (parts[0] != null) {
		parts[0] = c.namespaceResolver.getNamespace(parts[0], c.expressionContextNode);
        if (parts[0] == null) {
            throw new Error("Cannot resolve QName " + fn);
        }
	}
	return this.getVariableWithName(parts[0], parts[1], c.expressionContextNode);
};

VariableResolver.prototype.getVariableWithName = function(ns, ln, c) {
	return null;
};

// FunctionResolver //////////////////////////////////////////////////////////

FunctionResolver.prototype = new Object();
FunctionResolver.prototype.constructor = FunctionResolver;
FunctionResolver.superclass = Object.prototype;

function FunctionResolver(thisArg) {
	this.thisArg = thisArg != null ? thisArg : Functions;
	this.functions = new Object();
	this.addStandardFunctions();
}

FunctionResolver.prototype.addStandardFunctions = function() {
	this.functions["{}last"] = Functions.last;
	this.functions["{}position"] = Functions.position;
	this.functions["{}count"] = Functions.count;
	this.functions["{}id"] = Functions.id;
	this.functions["{}local-name"] = Functions.localName;
	this.functions["{}namespace-uri"] = Functions.namespaceURI;
	this.functions["{}name"] = Functions.name;
	this.functions["{}string"] = Functions.string;
	this.functions["{}concat"] = Functions.concat;
	this.functions["{}starts-with"] = Functions.startsWith;
	this.functions["{}contains"] = Functions.contains;
	this.functions["{}substring-before"] = Functions.substringBefore;
	this.functions["{}substring-after"] = Functions.substringAfter;
	this.functions["{}substring"] = Functions.substring;
	this.functions["{}string-length"] = Functions.stringLength;
	this.functions["{}normalize-space"] = Functions.normalizeSpace;
	this.functions["{}translate"] = Functions.translate;
	this.functions["{}boolean"] = Functions.boolean_;
	this.functions["{}not"] = Functions.not;
	this.functions["{}true"] = Functions.true_;
	this.functions["{}false"] = Functions.false_;
	this.functions["{}lang"] = Functions.lang;
	this.functions["{}number"] = Functions.number;
	this.functions["{}sum"] = Functions.sum;
	this.functions["{}floor"] = Functions.floor;
	this.functions["{}ceiling"] = Functions.ceiling;
	this.functions["{}round"] = Functions.round;
};

FunctionResolver.prototype.addFunction = function(ns, ln, f) {
	this.functions["{" + ns + "}" + ln] = f;
};

FunctionResolver.prototype.getFunction = function(fn, c) {
	var parts = Utilities.resolveQName(fn, c.namespaceResolver, c.contextNode, false);
    if (parts[0] == null) {
        throw new Error("Cannot resolve QName " + fn);
    }
	return this.getFunctionWithName(parts[0], parts[1], c.contextNode);
};

FunctionResolver.prototype.getFunctionWithName = function(ns, ln, c) {
	return this.functions["{" + ns + "}" + ln];
};

// NamespaceResolver /////////////////////////////////////////////////////////

NamespaceResolver.prototype = new Object();
NamespaceResolver.prototype.constructor = NamespaceResolver;
NamespaceResolver.superclass = Object.prototype;

function NamespaceResolver() {
}

NamespaceResolver.prototype.getNamespace = function(prefix, n) {
	if (prefix == "xml") {
		return XPath.XML_NAMESPACE_URI;
	} else if (prefix == "xmlns") {
		return XPath.XMLNS_NAMESPACE_URI;
	}
	if (n.nodeType == 9 /*Node.DOCUMENT_NODE*/) {
		n = n.documentElement;
	} else if (n.nodeType == 2 /*Node.ATTRIBUTE_NODE*/) {
		n = PathExpr.prototype.getOwnerElement(n);
	} else if (n.nodeType != 1 /*Node.ELEMENT_NODE*/) {
		n = n.parentNode;
	}
	while (n != null && n.nodeType == 1 /*Node.ELEMENT_NODE*/) {
		var nnm = n.attributes;
		for (var i = 0; i < nnm.length; i++) {
			var a = nnm.item(i);
			var aname = a.nodeName;
			if (aname == "xmlns" && prefix == ""
					|| aname == "xmlns:" + prefix) {
				return String(a.nodeValue);
			}
		}
		n = n.parentNode;
	}
	return null;
};

// Functions /////////////////////////////////////////////////////////////////

var Functions = new Object();

Functions.last = function() {
	var c = arguments[0];
	if (arguments.length != 1) {
		throw new Error("Function last expects ()");
	}
	return new XNumber(c.contextSize);
};

Functions.position = function() {
	var c = arguments[0];
	if (arguments.length != 1) {
		throw new Error("Function position expects ()");
	}
	return new XNumber(c.contextPosition);
};

Functions.count = function() {
	var c = arguments[0];
	var ns;
	if (arguments.length != 2 || !Utilities.instance_of(ns = arguments[1].evaluate(c), XNodeSet)) {
		throw new Error("Function count expects (node-set)");
	}
	return new XNumber(ns.size);
};

Functions.id = function() {
	var c = arguments[0];
	var id;
	if (arguments.length != 2) {
		throw new Error("Function id expects (object)");
	}
	id = arguments[1].evaluate(c);
	if (Utilities.instance_of(id, XNodeSet)) {
		id = id.toArray().join(" ");
	} else {
		id = id.stringValue();
	}
	var ids = id.split(/[\x0d\x0a\x09\x20]+/);
	var count = 0;
	var ns = new XNodeSet();
	var doc = c.contextNode.nodeType == 9 /*Node.DOCUMENT_NODE*/
			? c.contextNode
			: c.contextNode.ownerDocument;
	for (var i = 0; i < ids.length; i++) {
		var n;
		if (doc.getElementById) {
			n = doc.getElementById(ids[i]);
		} else {
			n = Utilities.getElementById(doc, ids[i]);
		}
		if (n != null) {
			ns.add(n);
			count++;
		}
	}
	return ns;
};

Functions.localName = function() {
	var c = arguments[0];
	var n;
	if (arguments.length == 1) {
		n = c.contextNode;
	} else if (arguments.length == 2) {
		n = arguments[1].evaluate(c).first();
	} else {
		throw new Error("Function local-name expects (node-set?)");
	}
	if (n == null) {
		return new XString("");
	}
	return new XString(n.localName ? n.localName : n.baseName);
};

Functions.namespaceURI = function() {
	var c = arguments[0];
	var n;
	if (arguments.length == 1) {
		n = c.contextNode;
	} else if (arguments.length == 2) {
		n = arguments[1].evaluate(c).first();
	} else {
		throw new Error("Function namespace-uri expects (node-set?)");
	}
	if (n == null) {
		return new XString("");
	}
	return new XString(n.namespaceURI);
};

Functions.name = function() {
	var c = arguments[0];
	var n;
	if (arguments.length == 1) {
		n = c.contextNode;
	} else if (arguments.length == 2) {
		n = arguments[1].evaluate(c).first();
	} else {
		throw new Error("Function name expects (node-set?)");
	}
	if (n == null) {
		return new XString("");
	}
	if (n.nodeType == 1 /*Node.ELEMENT_NODE*/ || n.nodeType == 2 /*Node.ATTRIBUTE_NODE*/) {
		return new XString(n.nodeName);
	} else if (n.localName == null) {
		return new XString("");
	} else {
		return new XString(n.localName);
	}
};

Functions.string = function() {
	var c = arguments[0];
	if (arguments.length == 1) {
		return XNodeSet.prototype.stringForNode(c.contextNode);
	} else if (arguments.length == 2) {
		return arguments[1].evaluate(c).string();
	}
	throw new Error("Function string expects (object?)");
};

Functions.concat = function() {
	var c = arguments[0];
	if (arguments.length < 3) {
		throw new Error("Function concat expects (string, string, string*)");
	}
	var s = "";
	for (var i = 1; i < arguments.length; i++) {
		s += arguments[i].evaluate(c).stringValue();
	}
	return new XString(s);
};

Functions.startsWith = function() {
	var c = arguments[0];
	if (arguments.length != 3) {
		throw new Error("Function startsWith expects (string, string)");
	}
	var s1 = arguments[1].evaluate(c).stringValue();
	var s2 = arguments[2].evaluate(c).stringValue();
	return new XBoolean(s1.substring(0, s2.length) == s2);
};

Functions.contains = function() {
	var c = arguments[0];
	if (arguments.length != 3) {
		throw new Error("Function contains expects (string, string)");
	}
	var s1 = arguments[1].evaluate(c).stringValue();
	var s2 = arguments[2].evaluate(c).stringValue();
	return new XBoolean(s1.indexOf(s2) != -1);
};

Functions.substringBefore = function() {
	var c = arguments[0];
	if (arguments.length != 3) {
		throw new Error("Function substring-before expects (string, string)");
	}
	var s1 = arguments[1].evaluate(c).stringValue();
	var s2 = arguments[2].evaluate(c).stringValue();
	return new XString(s1.substring(0, s1.indexOf(s2)));
};

Functions.substringAfter = function() {
	var c = arguments[0];
	if (arguments.length != 3) {
		throw new Error("Function substring-after expects (string, string)");
	}
	var s1 = arguments[1].evaluate(c).stringValue();
	var s2 = arguments[2].evaluate(c).stringValue();
	if (s2.length == 0) {
		return new XString(s1);
	}
	var i = s1.indexOf(s2);
	if (i == -1) {
		return new XString("");
	}
	return new XString(s1.substring(s1.indexOf(s2) + 1));
};

Functions.substring = function() {
	var c = arguments[0];
	if (!(arguments.length == 3 || arguments.length == 4)) {
		throw new Error("Function substring expects (string, number, number?)");
	}
	var s = arguments[1].evaluate(c).stringValue();
	var n1 = Math.round(arguments[2].evaluate(c).numberValue()) - 1;
	var n2 = arguments.length == 4 ? n1 + Math.round(arguments[3].evaluate(c).numberValue()) : undefined;
	return new XString(s.substring(n1, n2));
};

Functions.stringLength = function() {
	var c = arguments[0];
	var s;
	if (arguments.length == 1) {
		s = XNodeSet.prototype.stringForNode(c.contextNode);
	} else if (arguments.length == 2) {
		s = arguments[1].evaluate(c).stringValue();
	} else {
		throw new Error("Function string-length expects (string?)");
	}
	return new XNumber(s.length);
};

Functions.normalizeSpace = function() {
	var c = arguments[0];
	var s;
	if (arguments.length == 1) {
		s = XNodeSet.prototype.stringForNode(c.contextNode);
	} else if (arguments.length == 2) {
		s = arguments[1].evaluate(c).stringValue();
	} else {
		throw new Error("Function normalize-space expects (string?)");
	}
	var i = 0;
	var j = s.length - 1;
	while (Utilities.isSpace(s.charCodeAt(j))) {
		j--;
	}
	var t = "";
	while (i <= j && Utilities.isSpace(s.charCodeAt(i))) {
		i++;
	}
	while (i <= j) {
		if (Utilities.isSpace(s.charCodeAt(i))) {
			t += " ";
			while (i <= j && Utilities.isSpace(s.charCodeAt(i))) {
				i++;
			}
		} else {
			t += s.charAt(i);
			i++;
		}
	}
	return new XString(t);
};

Functions.translate = function() {
	var c = arguments[0];
	if (arguments.length != 4) {
		throw new Error("Function translate expects (string, string, string)");
	}
	var s1 = arguments[1].evaluate(c).stringValue();
	var s2 = arguments[2].evaluate(c).stringValue();
	var s3 = arguments[3].evaluate(c).stringValue();
	var map = [];
	for (var i = 0; i < s2.length; i++) {
		var j = s2.charCodeAt(i);
		if (map[j] == undefined) {
			var k = i > s3.length ? "" : s3.charAt(i);
			map[j] = k;
		}
	}
	var t = "";
	for (var i = 0; i < s1.length; i++) {
		var c = s1.charCodeAt(i);
		var r = map[c];
		if (r == undefined) {
			t += s1.charAt(i);
		} else {
			t += r;
		}
	}
	return new XString(t);
};

Functions.boolean_ = function() {
	var c = arguments[0];
	if (arguments.length != 2) {
		throw new Error("Function boolean expects (object)");
	}
	return arguments[1].evaluate(c).bool();
};

Functions.not = function() {
	var c = arguments[0];
	if (arguments.length != 2) {
		throw new Error("Function not expects (object)");
	}
	return arguments[1].evaluate(c).bool().not();
};

Functions.true_ = function() {
	if (arguments.length != 1) {
		throw new Error("Function true expects ()");
	}
	return new XBoolean(true);
};

Functions.false_ = function() {
	if (arguments.length != 1) {
		throw new Error("Function false expects ()");
	}
	return new XBoolean(false);
};

Functions.lang = function() {
	var c = arguments[0];
	if (arguments.length != 2) {
		throw new Error("Function lang expects (string)");
	}
	var lang;
	for (var n = c.contextNode; n != null && n.nodeType != 9 /*Node.DOCUMENT_NODE*/; n = n.parentNode) {
		var a = n.getAttributeNS(XPath.XML_NAMESPACE_URI, "lang");
		if (a != null) {
			lang = String(a);
			break;
		}
	}
	if (lang == null) {
		return new XBoolean(false);
	}
	var s = arguments[1].evaluate(c).stringValue();
	return new XBoolean(lang.substring(0, s.length) == s
				&& (lang.length == s.length || lang.charAt(s.length) == '-'));
};

Functions.number = function() {
	var c = arguments[0];
	if (!(arguments.length == 1 || arguments.length == 2)) {
		throw new Error("Function number expects (object?)");
	}
	if (arguments.length == 1) {
		return new XNumber(XNodeSet.prototype.stringForNode(c.contextNode));
	}
	return arguments[1].evaluate(c).number();
};

Functions.sum = function() {
	var c = arguments[0];
	var ns;
	if (arguments.length != 2 || !Utilities.instance_of((ns = arguments[1].evaluate(c)), XNodeSet)) {
		throw new Error("Function sum expects (node-set)");
	}
	ns = ns.toArray();
	var n = 0;
	for (var i = 0; i < ns.length; i++) {
		n += new XNumber(XNodeSet.prototype.stringForNode(ns[i])).numberValue();
	}
	return new XNumber(n);
};

Functions.floor = function() {
	var c = arguments[0];
	if (arguments.length != 2) {
		throw new Error("Function floor expects (number)");
	}
	return new XNumber(Math.floor(arguments[1].evaluate(c).numberValue()));
};

Functions.ceiling = function() {
	var c = arguments[0];
	if (arguments.length != 2) {
		throw new Error("Function ceiling expects (number)");
	}
	return new XNumber(Math.ceil(arguments[1].evaluate(c).numberValue()));
};

Functions.round = function() {
	var c = arguments[0];
	if (arguments.length != 2) {
		throw new Error("Function round expects (number)");
	}
	return new XNumber(Math.round(arguments[1].evaluate(c).numberValue()));
};

// Utilities /////////////////////////////////////////////////////////////////

var Utilities = new Object();

Utilities.splitQName = function(qn) {
	var i = qn.indexOf(":");
	if (i == -1) {
		return [ null, qn ];
	}
	return [ qn.substring(0, i), qn.substring(i + 1) ];
};

Utilities.resolveQName = function(qn, nr, n, useDefault) {
	var parts = Utilities.splitQName(qn);
	if (parts[0] != null) {
		parts[0] = nr.getNamespace(parts[0], n);
	} else {
		if (useDefault) {
			parts[0] = nr.getNamespace("", n);
			if (parts[0] == null) {
				parts[0] = "";
			}
		} else {
			parts[0] = "";
		}
	}
	return parts;
};

Utilities.isSpace = function(c) {
	return c == 0x9 || c == 0xd || c == 0xa || c == 0x20;
};

Utilities.isLetter = function(c) {
	return c >= 0x0041 && c <= 0x005A ||
		c >= 0x0061 && c <= 0x007A ||
		c >= 0x00C0 && c <= 0x00D6 ||
		c >= 0x00D8 && c <= 0x00F6 ||
		c >= 0x00F8 && c <= 0x00FF ||
		c >= 0x0100 && c <= 0x0131 ||
		c >= 0x0134 && c <= 0x013E ||
		c >= 0x0141 && c <= 0x0148 ||
		c >= 0x014A && c <= 0x017E ||
		c >= 0x0180 && c <= 0x01C3 ||
		c >= 0x01CD && c <= 0x01F0 ||
		c >= 0x01F4 && c <= 0x01F5 ||
		c >= 0x01FA && c <= 0x0217 ||
		c >= 0x0250 && c <= 0x02A8 ||
		c >= 0x02BB && c <= 0x02C1 ||
		c == 0x0386 ||
		c >= 0x0388 && c <= 0x038A ||
		c == 0x038C ||
		c >= 0x038E && c <= 0x03A1 ||
		c >= 0x03A3 && c <= 0x03CE ||
		c >= 0x03D0 && c <= 0x03D6 ||
		c == 0x03DA ||
		c == 0x03DC ||
		c == 0x03DE ||
		c == 0x03E0 ||
		c >= 0x03E2 && c <= 0x03F3 ||
		c >= 0x0401 && c <= 0x040C ||
		c >= 0x040E && c <= 0x044F ||
		c >= 0x0451 && c <= 0x045C ||
		c >= 0x045E && c <= 0x0481 ||
		c >= 0x0490 && c <= 0x04C4 ||
		c >= 0x04C7 && c <= 0x04C8 ||
		c >= 0x04CB && c <= 0x04CC ||
		c >= 0x04D0 && c <= 0x04EB ||
		c >= 0x04EE && c <= 0x04F5 ||
		c >= 0x04F8 && c <= 0x04F9 ||
		c >= 0x0531 && c <= 0x0556 ||
		c == 0x0559 ||
		c >= 0x0561 && c <= 0x0586 ||
		c >= 0x05D0 && c <= 0x05EA ||
		c >= 0x05F0 && c <= 0x05F2 ||
		c >= 0x0621 && c <= 0x063A ||
		c >= 0x0641 && c <= 0x064A ||
		c >= 0x0671 && c <= 0x06B7 ||
		c >= 0x06BA && c <= 0x06BE ||
		c >= 0x06C0 && c <= 0x06CE ||
		c >= 0x06D0 && c <= 0x06D3 ||
		c == 0x06D5 ||
		c >= 0x06E5 && c <= 0x06E6 ||
		c >= 0x0905 && c <= 0x0939 ||
		c == 0x093D ||
		c >= 0x0958 && c <= 0x0961 ||
		c >= 0x0985 && c <= 0x098C ||
		c >= 0x098F && c <= 0x0990 ||
		c >= 0x0993 && c <= 0x09A8 ||
		c >= 0x09AA && c <= 0x09B0 ||
		c == 0x09B2 ||
		c >= 0x09B6 && c <= 0x09B9 ||
		c >= 0x09DC && c <= 0x09DD ||
		c >= 0x09DF && c <= 0x09E1 ||
		c >= 0x09F0 && c <= 0x09F1 ||
		c >= 0x0A05 && c <= 0x0A0A ||
		c >= 0x0A0F && c <= 0x0A10 ||
		c >= 0x0A13 && c <= 0x0A28 ||
		c >= 0x0A2A && c <= 0x0A30 ||
		c >= 0x0A32 && c <= 0x0A33 ||
		c >= 0x0A35 && c <= 0x0A36 ||
		c >= 0x0A38 && c <= 0x0A39 ||
		c >= 0x0A59 && c <= 0x0A5C ||
		c == 0x0A5E ||
		c >= 0x0A72 && c <= 0x0A74 ||
		c >= 0x0A85 && c <= 0x0A8B ||
		c == 0x0A8D ||
		c >= 0x0A8F && c <= 0x0A91 ||
		c >= 0x0A93 && c <= 0x0AA8 ||
		c >= 0x0AAA && c <= 0x0AB0 ||
		c >= 0x0AB2 && c <= 0x0AB3 ||
		c >= 0x0AB5 && c <= 0x0AB9 ||
		c == 0x0ABD ||
		c == 0x0AE0 ||
		c >= 0x0B05 && c <= 0x0B0C ||
		c >= 0x0B0F && c <= 0x0B10 ||
		c >= 0x0B13 && c <= 0x0B28 ||
		c >= 0x0B2A && c <= 0x0B30 ||
		c >= 0x0B32 && c <= 0x0B33 ||
		c >= 0x0B36 && c <= 0x0B39 ||
		c == 0x0B3D ||
		c >= 0x0B5C && c <= 0x0B5D ||
		c >= 0x0B5F && c <= 0x0B61 ||
		c >= 0x0B85 && c <= 0x0B8A ||
		c >= 0x0B8E && c <= 0x0B90 ||
		c >= 0x0B92 && c <= 0x0B95 ||
		c >= 0x0B99 && c <= 0x0B9A ||
		c == 0x0B9C ||
		c >= 0x0B9E && c <= 0x0B9F ||
		c >= 0x0BA3 && c <= 0x0BA4 ||
		c >= 0x0BA8 && c <= 0x0BAA ||
		c >= 0x0BAE && c <= 0x0BB5 ||
		c >= 0x0BB7 && c <= 0x0BB9 ||
		c >= 0x0C05 && c <= 0x0C0C ||
		c >= 0x0C0E && c <= 0x0C10 ||
		c >= 0x0C12 && c <= 0x0C28 ||
		c >= 0x0C2A && c <= 0x0C33 ||
		c >= 0x0C35 && c <= 0x0C39 ||
		c >= 0x0C60 && c <= 0x0C61 ||
		c >= 0x0C85 && c <= 0x0C8C ||
		c >= 0x0C8E && c <= 0x0C90 ||
		c >= 0x0C92 && c <= 0x0CA8 ||
		c >= 0x0CAA && c <= 0x0CB3 ||
		c >= 0x0CB5 && c <= 0x0CB9 ||
		c == 0x0CDE ||
		c >= 0x0CE0 && c <= 0x0CE1 ||
		c >= 0x0D05 && c <= 0x0D0C ||
		c >= 0x0D0E && c <= 0x0D10 ||
		c >= 0x0D12 && c <= 0x0D28 ||
		c >= 0x0D2A && c <= 0x0D39 ||
		c >= 0x0D60 && c <= 0x0D61 ||
		c >= 0x0E01 && c <= 0x0E2E ||
		c == 0x0E30 ||
		c >= 0x0E32 && c <= 0x0E33 ||
		c >= 0x0E40 && c <= 0x0E45 ||
		c >= 0x0E81 && c <= 0x0E82 ||
		c == 0x0E84 ||
		c >= 0x0E87 && c <= 0x0E88 ||
		c == 0x0E8A ||
		c == 0x0E8D ||
		c >= 0x0E94 && c <= 0x0E97 ||
		c >= 0x0E99 && c <= 0x0E9F ||
		c >= 0x0EA1 && c <= 0x0EA3 ||
		c == 0x0EA5 ||
		c == 0x0EA7 ||
		c >= 0x0EAA && c <= 0x0EAB ||
		c >= 0x0EAD && c <= 0x0EAE ||
		c == 0x0EB0 ||
		c >= 0x0EB2 && c <= 0x0EB3 ||
		c == 0x0EBD ||
		c >= 0x0EC0 && c <= 0x0EC4 ||
		c >= 0x0F40 && c <= 0x0F47 ||
		c >= 0x0F49 && c <= 0x0F69 ||
		c >= 0x10A0 && c <= 0x10C5 ||
		c >= 0x10D0 && c <= 0x10F6 ||
		c == 0x1100 ||
		c >= 0x1102 && c <= 0x1103 ||
		c >= 0x1105 && c <= 0x1107 ||
		c == 0x1109 ||
		c >= 0x110B && c <= 0x110C ||
		c >= 0x110E && c <= 0x1112 ||
		c == 0x113C ||
		c == 0x113E ||
		c == 0x1140 ||
		c == 0x114C ||
		c == 0x114E ||
		c == 0x1150 ||
		c >= 0x1154 && c <= 0x1155 ||
		c == 0x1159 ||
		c >= 0x115F && c <= 0x1161 ||
		c == 0x1163 ||
		c == 0x1165 ||
		c == 0x1167 ||
		c == 0x1169 ||
		c >= 0x116D && c <= 0x116E ||
		c >= 0x1172 && c <= 0x1173 ||
		c == 0x1175 ||
		c == 0x119E ||
		c == 0x11A8 ||
		c == 0x11AB ||
		c >= 0x11AE && c <= 0x11AF ||
		c >= 0x11B7 && c <= 0x11B8 ||
		c == 0x11BA ||
		c >= 0x11BC && c <= 0x11C2 ||
		c == 0x11EB ||
		c == 0x11F0 ||
		c == 0x11F9 ||
		c >= 0x1E00 && c <= 0x1E9B ||
		c >= 0x1EA0 && c <= 0x1EF9 ||
		c >= 0x1F00 && c <= 0x1F15 ||
		c >= 0x1F18 && c <= 0x1F1D ||
		c >= 0x1F20 && c <= 0x1F45 ||
		c >= 0x1F48 && c <= 0x1F4D ||
		c >= 0x1F50 && c <= 0x1F57 ||
		c == 0x1F59 ||
		c == 0x1F5B ||
		c == 0x1F5D ||
		c >= 0x1F5F && c <= 0x1F7D ||
		c >= 0x1F80 && c <= 0x1FB4 ||
		c >= 0x1FB6 && c <= 0x1FBC ||
		c == 0x1FBE ||
		c >= 0x1FC2 && c <= 0x1FC4 ||
		c >= 0x1FC6 && c <= 0x1FCC ||
		c >= 0x1FD0 && c <= 0x1FD3 ||
		c >= 0x1FD6 && c <= 0x1FDB ||
		c >= 0x1FE0 && c <= 0x1FEC ||
		c >= 0x1FF2 && c <= 0x1FF4 ||
		c >= 0x1FF6 && c <= 0x1FFC ||
		c == 0x2126 ||
		c >= 0x212A && c <= 0x212B ||
		c == 0x212E ||
		c >= 0x2180 && c <= 0x2182 ||
		c >= 0x3041 && c <= 0x3094 ||
		c >= 0x30A1 && c <= 0x30FA ||
		c >= 0x3105 && c <= 0x312C ||
		c >= 0xAC00 && c <= 0xD7A3 ||
		c >= 0x4E00 && c <= 0x9FA5 ||
		c == 0x3007 ||
		c >= 0x3021 && c <= 0x3029;
};

Utilities.isNCNameChar = function(c) {
	return c >= 0x0030 && c <= 0x0039
		|| c >= 0x0660 && c <= 0x0669
		|| c >= 0x06F0 && c <= 0x06F9
		|| c >= 0x0966 && c <= 0x096F
		|| c >= 0x09E6 && c <= 0x09EF
		|| c >= 0x0A66 && c <= 0x0A6F
		|| c >= 0x0AE6 && c <= 0x0AEF
		|| c >= 0x0B66 && c <= 0x0B6F
		|| c >= 0x0BE7 && c <= 0x0BEF
		|| c >= 0x0C66 && c <= 0x0C6F
		|| c >= 0x0CE6 && c <= 0x0CEF
		|| c >= 0x0D66 && c <= 0x0D6F
		|| c >= 0x0E50 && c <= 0x0E59
		|| c >= 0x0ED0 && c <= 0x0ED9
		|| c >= 0x0F20 && c <= 0x0F29
		|| c == 0x002E
		|| c == 0x002D
		|| c == 0x005F
		|| Utilities.isLetter(c)
		|| c >= 0x0300 && c <= 0x0345
		|| c >= 0x0360 && c <= 0x0361
		|| c >= 0x0483 && c <= 0x0486
		|| c >= 0x0591 && c <= 0x05A1
		|| c >= 0x05A3 && c <= 0x05B9
		|| c >= 0x05BB && c <= 0x05BD
		|| c == 0x05BF
		|| c >= 0x05C1 && c <= 0x05C2
		|| c == 0x05C4
		|| c >= 0x064B && c <= 0x0652
		|| c == 0x0670
		|| c >= 0x06D6 && c <= 0x06DC
		|| c >= 0x06DD && c <= 0x06DF
		|| c >= 0x06E0 && c <= 0x06E4
		|| c >= 0x06E7 && c <= 0x06E8
		|| c >= 0x06EA && c <= 0x06ED
		|| c >= 0x0901 && c <= 0x0903
		|| c == 0x093C
		|| c >= 0x093E && c <= 0x094C
		|| c == 0x094D
		|| c >= 0x0951 && c <= 0x0954
		|| c >= 0x0962 && c <= 0x0963
		|| c >= 0x0981 && c <= 0x0983
		|| c == 0x09BC
		|| c == 0x09BE
		|| c == 0x09BF
		|| c >= 0x09C0 && c <= 0x09C4
		|| c >= 0x09C7 && c <= 0x09C8
		|| c >= 0x09CB && c <= 0x09CD
		|| c == 0x09D7
		|| c >= 0x09E2 && c <= 0x09E3
		|| c == 0x0A02
		|| c == 0x0A3C
		|| c == 0x0A3E
		|| c == 0x0A3F
		|| c >= 0x0A40 && c <= 0x0A42
		|| c >= 0x0A47 && c <= 0x0A48
		|| c >= 0x0A4B && c <= 0x0A4D
		|| c >= 0x0A70 && c <= 0x0A71
		|| c >= 0x0A81 && c <= 0x0A83
		|| c == 0x0ABC
		|| c >= 0x0ABE && c <= 0x0AC5
		|| c >= 0x0AC7 && c <= 0x0AC9
		|| c >= 0x0ACB && c <= 0x0ACD
		|| c >= 0x0B01 && c <= 0x0B03
		|| c == 0x0B3C
		|| c >= 0x0B3E && c <= 0x0B43
		|| c >= 0x0B47 && c <= 0x0B48
		|| c >= 0x0B4B && c <= 0x0B4D
		|| c >= 0x0B56 && c <= 0x0B57
		|| c >= 0x0B82 && c <= 0x0B83
		|| c >= 0x0BBE && c <= 0x0BC2
		|| c >= 0x0BC6 && c <= 0x0BC8
		|| c >= 0x0BCA && c <= 0x0BCD
		|| c == 0x0BD7
		|| c >= 0x0C01 && c <= 0x0C03
		|| c >= 0x0C3E && c <= 0x0C44
		|| c >= 0x0C46 && c <= 0x0C48
		|| c >= 0x0C4A && c <= 0x0C4D
		|| c >= 0x0C55 && c <= 0x0C56
		|| c >= 0x0C82 && c <= 0x0C83
		|| c >= 0x0CBE && c <= 0x0CC4
		|| c >= 0x0CC6 && c <= 0x0CC8
		|| c >= 0x0CCA && c <= 0x0CCD
		|| c >= 0x0CD5 && c <= 0x0CD6
		|| c >= 0x0D02 && c <= 0x0D03
		|| c >= 0x0D3E && c <= 0x0D43
		|| c >= 0x0D46 && c <= 0x0D48
		|| c >= 0x0D4A && c <= 0x0D4D
		|| c == 0x0D57
		|| c == 0x0E31
		|| c >= 0x0E34 && c <= 0x0E3A
		|| c >= 0x0E47 && c <= 0x0E4E
		|| c == 0x0EB1
		|| c >= 0x0EB4 && c <= 0x0EB9
		|| c >= 0x0EBB && c <= 0x0EBC
		|| c >= 0x0EC8 && c <= 0x0ECD
		|| c >= 0x0F18 && c <= 0x0F19
		|| c == 0x0F35
		|| c == 0x0F37
		|| c == 0x0F39
		|| c == 0x0F3E
		|| c == 0x0F3F
		|| c >= 0x0F71 && c <= 0x0F84
		|| c >= 0x0F86 && c <= 0x0F8B
		|| c >= 0x0F90 && c <= 0x0F95
		|| c == 0x0F97
		|| c >= 0x0F99 && c <= 0x0FAD
		|| c >= 0x0FB1 && c <= 0x0FB7
		|| c == 0x0FB9
		|| c >= 0x20D0 && c <= 0x20DC
		|| c == 0x20E1
		|| c >= 0x302A && c <= 0x302F
		|| c == 0x3099
		|| c == 0x309A
		|| c == 0x00B7
		|| c == 0x02D0
		|| c == 0x02D1
		|| c == 0x0387
		|| c == 0x0640
		|| c == 0x0E46
		|| c == 0x0EC6
		|| c == 0x3005
		|| c >= 0x3031 && c <= 0x3035
		|| c >= 0x309D && c <= 0x309E
		|| c >= 0x30FC && c <= 0x30FE;
};

Utilities.coalesceText = function(n) {
	for (var m = n.firstChild; m != null; m = m.nextSibling) {
		if (m.nodeType == 3 /*Node.TEXT_NODE*/ || m.nodeType == 4 /*Node.CDATA_SECTION_NODE*/) {
			var s = m.nodeValue;
			var first = m;
			m = m.nextSibling;
			while (m != null && (m.nodeType == 3 /*Node.TEXT_NODE*/ || m.nodeType == 4 /*Node.CDATA_SECTION_NODE*/)) {
				s += m.nodeValue;
				var del = m;
				m = m.nextSibling;
				del.parentNode.removeChild(del);
			}
			if (first.nodeType == 4 /*Node.CDATA_SECTION_NODE*/) {
				var p = first.parentNode;
				if (first.nextSibling == null) {
					p.removeChild(first);
					p.appendChild(p.ownerDocument.createTextNode(s));
				} else {
					var next = first.nextSibling;
					p.removeChild(first);
					p.insertBefore(p.ownerDocument.createTextNode(s), next);
				}
			} else {
				first.nodeValue = s;
			}
			if (m == null) {
				break;
			}
		} else if (m.nodeType == 1 /*Node.ELEMENT_NODE*/) {
			Utilities.coalesceText(m);
		}
	}
};

Utilities.instance_of = function(o, c) {
	while (o != null) {
		if (o.constructor === c) {
			return true;
		}
		if (o === Object) {
			return false;
		}
		o = o.constructor.superclass;
	}
	return false;
};

Utilities.getElementById = function(n, id) {
	// Note that this does not check the DTD to check for actual
	// attributes of type ID, so this may be a bit wrong.
	if (n.nodeType == 1 /*Node.ELEMENT_NODE*/) {
		if (n.getAttribute("id") == id
				|| n.getAttributeNS(null, "id") == id) {
			return n;
		}
	}
	for (var m = n.firstChild; m != null; m = m.nextSibling) {
		var res = Utilities.getElementById(m, id);
		if (res != null) {
			return res;
		}
	}
	return null;
};

// XPathException ////////////////////////////////////////////////////////////

XPathException.prototype = {};
XPathException.prototype.constructor = XPathException;
XPathException.superclass = Object.prototype;

function XPathException(c, e) {
	this.code = c;
	this.exception = e;
}

XPathException.prototype.toString = function() {
	var msg = this.exception ? ": " + this.exception.toString() : "";
	switch (this.code) {
		case XPathException.INVALID_EXPRESSION_ERR:
			return "Invalid expression" + msg;
		case XPathException.TYPE_ERR:
			return "Type error" + msg;
	}
};

XPathException.INVALID_EXPRESSION_ERR = 51;
XPathException.TYPE_ERR = 52;

// XPathExpression ///////////////////////////////////////////////////////////

XPathExpression.prototype = {};
XPathExpression.prototype.constructor = XPathExpression;
XPathExpression.superclass = Object.prototype;

function XPathExpression(e, r, p) {
	this.xpath = p.parse(e);
	this.context = new XPathContext();
	this.context.namespaceResolver = new XPathNSResolverWrapper(r);
}

XPathExpression.prototype.evaluate = function(n, t, res) {
	this.context.expressionContextNode = n;
	var result = this.xpath.evaluate(this.context);
	return new XPathResult(result, t);
}

// XPathNSResolverWrapper ////////////////////////////////////////////////////

XPathNSResolverWrapper.prototype = {};
XPathNSResolverWrapper.prototype.constructor = XPathNSResolverWrapper;
XPathNSResolverWrapper.superclass = Object.prototype;

function XPathNSResolverWrapper(r) {
	this.xpathNSResolver = r;
}

XPathNSResolverWrapper.prototype.getNamespace = function(prefix, n) {
    if (this.xpathNSResolver == null) {
        return null;
    }
	return this.xpathNSResolver.lookupNamespaceURI(prefix);
};

// NodeXPathNSResolver ///////////////////////////////////////////////////////

NodeXPathNSResolver.prototype = {};
NodeXPathNSResolver.prototype.constructor = NodeXPathNSResolver;
NodeXPathNSResolver.superclass = Object.prototype;

function NodeXPathNSResolver(n) {
	this.node = n;
	this.namespaceResolver = new NamespaceResolver();
}

NodeXPathNSResolver.prototype.lookupNamespaceURI = function(prefix) {
	return this.namespaceResolver.getNamespace(prefix, this.node);
};

// XPathResult ///////////////////////////////////////////////////////////////

XPathResult.prototype = {};
XPathResult.prototype.constructor = XPathResult;
XPathResult.superclass = Object.prototype;

function XPathResult(v, t) {
	if (t == XPathResult.ANY_TYPE) {
		if (v.constructor === XString) {
			t = XPathResult.STRING_TYPE;
		} else if (v.constructor === XNumber) {
			t = XPathResult.NUMBER_TYPE;
		} else if (v.constructor === XBoolean) {
			t = XPathResult.BOOLEAN_TYPE;
		} else if (v.constructor === XNodeSet) {
			t = XPathResult.UNORDERED_NODE_ITERATOR_TYPE;
		}
	}
	this.resultType = t;
	switch (t) {
		case XPathResult.NUMBER_TYPE:
			this.numberValue = v.numberValue();
			return;
		case XPathResult.STRING_TYPE:
			this.stringValue = v.stringValue();
			return;
		case XPathResult.BOOLEAN_TYPE:
			this.booleanValue = v.booleanValue();
			return;
		case XPathResult.ANY_UNORDERED_NODE_TYPE:
		case XPathResult.FIRST_ORDERED_NODE_TYPE:
			if (v.constructor === XNodeSet) {
				this.singleNodeValue = v.first();
				return;
			}
			break;
		case XPathResult.UNORDERED_NODE_ITERATOR_TYPE:
		case XPathResult.ORDERED_NODE_ITERATOR_TYPE:
			if (v.constructor === XNodeSet) {
				this.invalidIteratorState = false;
				this.nodes = v.toArray();
				this.iteratorIndex = 0;
				return;
			}
			break;
		case XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE:
		case XPathResult.ORDERED_NODE_SNAPSHOT_TYPE:
			if (v.constructor === XNodeSet) {
				this.nodes = v.toArray();
				this.snapshotLength = this.nodes.length;
				return;
			}
			break;
	}
	throw new XPathException(XPathException.TYPE_ERR);
};

XPathResult.prototype.iterateNext = function() {
	if (this.resultType != XPathResult.UNORDERED_NODE_ITERATOR_TYPE
			&& this.resultType != XPathResult.ORDERED_NODE_ITERATOR_TYPE) {
		throw new XPathException(XPathException.TYPE_ERR);
	}
	return this.nodes[this.iteratorIndex++];
};

XPathResult.prototype.snapshotItem = function(i) {
	if (this.resultType != XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE
			&& this.resultType != XPathResult.ORDERED_NODE_SNAPSHOT_TYPE) {
		throw new XPathException(XPathException.TYPE_ERR);
	}
	return this.nodes[i];
};

XPathResult.ANY_TYPE = 0;
XPathResult.NUMBER_TYPE = 1;
XPathResult.STRING_TYPE = 2;
XPathResult.BOOLEAN_TYPE = 3;
XPathResult.UNORDERED_NODE_ITERATOR_TYPE = 4;
XPathResult.ORDERED_NODE_ITERATOR_TYPE = 5;
XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE = 6;
XPathResult.ORDERED_NODE_SNAPSHOT_TYPE = 7;
XPathResult.ANY_UNORDERED_NODE_TYPE = 8;
XPathResult.FIRST_ORDERED_NODE_TYPE = 9;

//  ------------------------------------------------------------------------
//  TPI
//  ------------------------------------------------------------------------

XPathParser.FunctionResolver = FunctionResolver;
XPathParser.VariableResolver = VariableResolver;
XPathParser.NamespaceResolver = NamespaceResolver;

XPathParser.XPathContext = XPathContext;

XPathParser.XString = XString;
XPathParser.XNumber = XNumber;
XPathParser.XBoolean = XBoolean;

self.XPathParser = XPathParser;
}();
TP.boot.$$srcPath = '';

        
        TP.registerExternalObject('XPathParser', window.XPathParser);
        
    
TP.boot.$$srcPath = '~lib_src/tibet/storage/TP.core.DeviceStorage.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'device_storage';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.core.DeviceStorage}
 * @summary A common supertype for all objects handling client-side storage
 *      mechanisms in TIBET.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('core.DeviceStorage');

//  This type is abstract
TP.core.DeviceStorage.isAbstract(true);

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.DeviceStorage.Inst.defineMethod('at',
function(aKey) {

    /**
     * @method at
     * @summary Retrieves the value stored under the key in the receiver.
     * @param {String} aKey The key to find the data to be retrieved.
     * @returns {Object} The object stored under the key in the receiver.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.core.DeviceStorage.Inst.defineMethod('atEncrypted',
function(aKey, aPassword) {

    /**
     * @method atEncrypted
     * @summary Retrieves the value stored under the key in the receiver.
     * @param {String} aKey The key to find the data to be retrieved.
     * @param {String} aPassword The password to use to decrypt the data that
     *     was retrieved.
     * @exception TP.sig.InvalidString
     * @returns {Object} The object stored under the key in the receiver.
     */

    var recordStr,
        value;

    if (!TP.isString(aKey) || !TP.isString(aPassword)) {
        return this.raise('TP.sig.InvalidString');
    }

    //  See if there is a 'record' value (a JSON String) at the key. This should
    //  contain the 'salt' used to create the password, the encrypted value and
    //  the 'iv' value used to encrypt the value.
    if (TP.isEmpty(recordStr = this.at(aKey))) {
        return null;
    }

    value = TP.decryptStorageValue(recordStr, aPassword);

    return value;
});

//  ------------------------------------------------------------------------

TP.core.DeviceStorage.Inst.defineMethod('atPut',
function(aKey, aValue) {

    /**
     * @method atPut
     * @summary Sets the value stored under the key in the receiver.
     * @param {String} aKey The key to use to set the data to be stored.
     * @param {String} aValue The data to store under the supplied key.
     * @returns {TP.core.DeviceStorage} The receiver.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.core.DeviceStorage.Inst.defineMethod('atPutEncrypted',
function(aKey, aValue, aPassword) {

    /**
     * @method atPutEncrypted
     * @summary Sets the value stored under the key in the receiver.
     * @param {String} aKey The key to use to set the data to be stored.
     * @param {String} aValue The data to store under the supplied key.
     * @param {String} aPassword The password to use to encrypt the data that
     *     is being stored.
     * @exception TP.sig.InvalidString
     * @returns {TP.core.DeviceStorage} The receiver.
     */

    var recordStr;

    if (!TP.isString(aKey) || !TP.isString(aValue) || !TP.isString(aPassword)) {
        return this.raise('TP.sig.InvalidString');
    }

    recordStr = TP.encryptStorageValue(aValue, aPassword);

    //  Put this overall value into the storage using the supplied key.
    this.atPut(aKey, recordStr);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.DeviceStorage.Inst.defineMethod('empty',
function() {

    /**
     * @method empty
     * @summary Removes all of the values stored in the receiver.
     * @returns {TP.core.DeviceStorage} The receiver.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.core.DeviceStorage.Inst.defineMethod('removeKey',
function(aKey) {

    /**
     * @method removeKey
     * @summary Removes the value stored under the key in the receiver.
     * @param {String} aKey The key to find the data to be removed.
     * @returns {Boolean} True if the value was successfully removed, false
     *     otherwise.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/storage/TP.core.LocalStorage.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'device_storage';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.core.LocalStorage}
 * @summary A subtype of TP.core.DeviceStorage for handling 'local storage'
 *     persistence mechanisms.
 */

//  ------------------------------------------------------------------------

TP.core.DeviceStorage.defineSubtype('LocalStorage');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.LocalStorage.Type.defineMethod('canConstruct',
function() {

    /**
     * @method canConstruct
     * @summary Returns true or false whether or not a storage object of this
     *     type can be constructed on the currently executing platform.
     * @returns {Boolean} Whether or not an instance can be constructed on this
     *     platform.
     */

    return true;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.LocalStorage.Inst.defineMethod('at',
function(aKey) {

    /**
     * @method at
     * @summary Retrieves the value stored under the key in the receiver.
     * @param {String} aKey The key to find the data to be retrieved.
     * @returns {Object} The object stored under the key in the receiver.
     */

    //  If the key matches a local/instance slot on ourself, then just
    //  callNextMethod. Note we check TP.isDefined() here, since we don't
    //  care if it has a null value.
    if (TP.isDefined(this[aKey])) {
        //  This is basically TP.lang.Object's version of 'at', since our
        //  supertype has an 'TP.override()' call to force overriding.
        if (TP.canInvoke(this, 'get')) {
            return this.get(aKey);
        }

        return this[aKey];
    }

    if (TP.isValid(TP.global.localStorage)) {
        return TP.global.localStorage.getItem(aKey);
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.core.LocalStorage.Inst.defineMethod('atPut',
function(aKey, aValue) {

    /**
     * @method atPut
     * @summary Sets the value stored under the key in the receiver.
     * @param {String} aKey The key to use to set the data to be stored.
     * @param {String} aValue The data to store under the supplied key.
     * @returns {TP.core.LocalStorage} The receiver.
     */

    //  If the key matches a local/instance slot on ourself, then just
    //  callNextMethod. Note we check TP.isDefined() here, since we don't
    //  care if it has a null value.
    if (TP.isDefined(this[aKey])) {
        //  This is basically TP.lang.Object's version of 'atPut', since our
        //  supertype has an 'TP.override()' call to force overriding.
        return this.$set(
                    aKey > 0 ? aKey : this.normalizeIndex(aKey),
                    aValue);
    }

    if (TP.isValid(TP.global.localStorage)) {
        return TP.global.localStorage.setItem(aKey, aValue);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.LocalStorage.Inst.defineMethod('empty',
function() {

    /**
     * @method empty
     * @summary Removes all of the values stored in the receiver.
     * @returns {TP.core.LocalStorage} The receiver.
     */

    if (TP.isValid(TP.global.localStorage)) {
        return TP.global.localStorage.clear();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.LocalStorage.Inst.defineMethod('removeKey',
function(aKey) {

    /**
     * @method removeKey
     * @summary Removes the value stored under the key in the receiver.
     * @param {String} aKey The key to find the data to be removed.
     * @returns {TP.core.LocalStorage} The receiver.
     */

    if (TP.isValid(TP.global.localStorage)) {
        return TP.global.localStorage.removeItem(aKey);
    }

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/storage/TP.core.SessionStorage.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'device_storage';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.core.SessionStorage}
 * @summary A subtype of TP.core.DeviceStorage for handling 'session storage'
 *     persistence mechanisms.
 */

//  ------------------------------------------------------------------------

TP.core.DeviceStorage.defineSubtype('SessionStorage');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.core.SessionStorage.Type.defineMethod('canConstruct',
function() {

    /**
     * @method canConstruct
     * @summary Returns true or false whether or not a storage object of this
     *     type can be constructed on the currently executing platform.
     * @returns {Boolean} Whether or not an instance can be constructed on this
     *     platform.
     */

    return true;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.SessionStorage.Inst.defineMethod('at',
function(aKey) {

    /**
     * @method at
     * @summary Retrieves the value stored under the key in the receiver.
     * @param {String} aKey The key to find the data to be retrieved.
     * @returns {Object} The object stored under the key in the receiver.
     */

    //  If the key matches a local/instance slot on ourself, then just
    //  callNextMethod. Note we check TP.isDefined() here, since we don't
    //  care if it has a null value.
    if (TP.isDefined(this[aKey])) {
        //  This is basically TP.lang.Object's version of 'at', since our
        //  supertype has an 'TP.override()' call to force overriding.
        if (TP.canInvoke(this, 'get')) {
            return this.get(aKey);
        }

        return this[aKey];
    }

    if (TP.isValid(TP.global.sessionStorage)) {
        return TP.global.sessionStorage.getItem(aKey);
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.core.SessionStorage.Inst.defineMethod('atPut',
function(aKey, aValue) {

    /**
     * @method atPut
     * @summary Sets the value stored under the key in the receiver.
     * @param {String} aKey The key to use to set the data to be stored.
     * @param {String} aValue The data to store under the supplied key.
     * @returns {TP.core.SessionStorage} The receiver.
     */

    //  If the key matches a local/instance slot on ourself, then just
    //  callNextMethod. Note we check TP.isDefined() here, since we don't
    //  care if it has a null value.
    if (TP.isDefined(this[aKey])) {
        //  This is basically TP.lang.Object's version of 'atPut', since our
        //  supertype has an 'TP.override()' call to force overriding.
        return this.$set(
                    aKey > 0 ? aKey : this.normalizeIndex(aKey),
                    aValue);
    }

    if (TP.isValid(TP.global.sessionStorage)) {
        return TP.global.sessionStorage.setItem(aKey, aValue);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.SessionStorage.Inst.defineMethod('empty',
function() {

    /**
     * @method empty
     * @summary Removes all of the values stored in the receiver.
     * @returns {TP.core.SessionStorage} The receiver.
     */

    if (TP.isValid(TP.global.sessionStorage)) {
        return TP.global.sessionStorage.clear();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.core.SessionStorage.Inst.defineMethod('removeKey',
function(aKey) {

    /**
     * @method removeKey
     * @summary Removes the value stored under the key in the receiver.
     * @param {String} aKey The key to find the data to be removed.
     * @returns {TP.core.SessionStorage} The receiver.
     */

    if (TP.isValid(TP.global.sessionStorage)) {
        return TP.global.sessionStorage.removeItem(aKey);
    }

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/storage/localdb/TP.sig.LocalDBStorageRequest.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'device_storage';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.sig.LocalDBStorageRequest}
 * @summary A subtype of TP.sig.Request that is used in conjunction with the
 *     TP.core.LocalDBStorageService type to communicate to in-browser 'local
 *     storage' data stores.
 * @example Communicating with a local data store from TIBET consists of:
 *
 *     1. Define the operation you want to perform via a set of 'request
 *          parameters'.
 *     2. Instantiating an TP.sig.LocalDBStorageRequest object, supplying those
 *          parameters.
 *     3. Firing the request.
 *
 *     Defining request parameters:
 *
 *     - Request parameters need to include an 'action', which should be either
 *          'getItem' or 'putItem'. The data should be a TP.core.Hash that is
 *          placed in the 'body' parameter.
 *
 *     req = TP.sig.LocalDBStorageRequest.construct(
 *                  TP.hc('action', 'updateItem',
 *                          'dbName', 'local_test',
 *                          'id', 'author_info',
 *                          'body', TP.hc('foo', 'bar')));
 *
 *     Request parameters examples:
 *
 *     - 'Create' an item in local DB
 *
 *     requestParams = TP.hc('action', 'createItem',
 *                              'dbName', 'local_test',
 *                              'id', 'author_info',
 *                              'body', TP.hc('foo', 'bar'));
 *
 *     - 'Retrieve' an item from local DB
 *
 *     requestParams = TP.hc('action', 'retrieveItem',
 *                              'dbName', 'local_test',
 *                              'id', 'author_info');
 *
 *     - 'Retrieve' an item info from local DB
 *
 *     requestParams = TP.hc('action', 'retrieveItemInfo',
 *                              'dbName', 'local_test',
 *                              'id', 'author_info');
 *
 *     - 'Retrieve' a info about a DB in local DB
 *
 *     requestParams = TP.hc('action', 'retrieveDBInfo',
 *                              'dbName', 'local_test');
 *
 *     - 'Update' an item in local DB
 *
 *     requestParams = TP.hc('action', 'updateItem',
 *                              'dbName', 'local_test',
 *                              'id', 'author_info',
 *                              'body', TP.hc('foo', 'baz'));
 *
 *     - 'Delete' an item from local DB
 *
 *     requestParams = TP.hc('action', 'deleteItem',
 *                              'dbName', 'local_test',
 *                              'id', 'author_info');
 *
 *     - 'Delete' a DB in local DB
 *
 *     requestParams = TP.hc('action', 'deleteDB',
 *                              'dbName', 'local_test');
 *
 *     Package and fire the request:
 *
 *     req = TP.sig.LocalDBStorageRequest.construct(requestParams);
 *
 *     req.defineHandler('RequestSucceeded',
 *          function(aResponse) {
 *              TP.info('Success! Result: ' + TP.json(aResponse.getResult()));
 *          });
 *
 *     req.defineHandler('RequestFailed',
 *          function(aResponse) {
 *              TP.info('Failure... Result: ' + TP.json(aResponse.getResult()));
 *          });
 *
 *     req.fire();
 *
 *     Data can be easily encrypted and decrypted by adding a 'securePW'
 *     attribute to the request:
 *
 *     requestParams = TP.hc('action', 'createItem',
 *                              'dbName', 'local_test',
 *                              'securePW', 'fluffy',
 *                              'id', 'author_info',
 *                              'body', TP.hc('foo', 'bar'));
 *
 */

//  ------------------------------------------------------------------------

TP.sig.IORequest.defineSubtype('LocalDBStorageRequest');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.sig.LocalDBStorageRequest.Type.defineAttribute('responseType',
                                        'TP.sig.LocalDBStorageResponse');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/storage/localdb/TP.sig.LocalDBStorageResponse.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'device_storage';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.sig.LocalDBStorageResponse}
 */

//  ------------------------------------------------------------------------

TP.sig.IOResponse.defineSubtype('LocalDBStorageResponse');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/storage/localdb/TP.core.LocalDBStorageService.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'device_storage';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.core.LocalDBStorageService}
 * @summary A subtype of TP.core.Service that communicates with in-browser
 *     'local storage' local data stores.
 * @example If the TP.sig.LocalDBStorageRequest/TP.sig.LocalDBStorageResponse
 *     processing model is used, it is unnecessary to manually set up a
 *     TP.core.LocalDBStorageService. As part of the TIBET infrastructure of
 *     using request/response pairs, a 'default' instance of this service will
 *     be instantiated and registered to handle all
 *     TP.sig.LocalDBStorageRequests.
 *
 *     This 'default' instance of the service will be registered with the
 *     system under the name 'LocalDBStorageService'.
 *
 *     It is possible, however, to manually set up a server. To do so, execute
 *     the following:
 *
 *     myLocalDBStorageService = TP.core.LocalDBStorageService.construct(
 *          'localLocalDBStorageServer');
 *
 *     You will then need to register your service instance so that it services
 *     TP.sig.LocalDBStorageRequests (otherwise, the TIBET machinery will
 *     instantiate the 'default' instance of TP.core.LocalDBStorageService as
 *     described above and register it to service these kinds of requests):
 *
 *     myLocalDBStorageService.register();
 *
 *    The backing storage for local DB storage is W3C-specified 'local storage'.
 *    The specific data storage format for data stored in this way is:
 *
 *    localstorage key: TP.LOCALSTORAGE_DB_NAME
 *    localstorage value:
 *        {
 *            "<db_name>" :
 *            {
 *                "<_id>" :
 *                {
 *                    "_id" : <_id>,
 *                    "_date_created": <Date>,
 *                    "_date_modified": <Date>,
 *                    "_body": <body>
 *                }
 *            }
 *        }
 */

//  ------------------------------------------------------------------------

TP.core.IOService.defineSubtype('LocalDBStorageService');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.core.LocalDBStorageService.Type.defineAttribute(
    'triggers', TP.ac(TP.ac(TP.ANY, 'TP.sig.LocalDBStorageRequest')));

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  current versions of the LocalDBStorage spec allow sync only so force that
//  here
TP.core.LocalDBStorageService.Type.defineAttribute(
                        'supportedModes', TP.core.SyncAsync.SYNCHRONOUS);
TP.core.LocalDBStorageService.Type.defineAttribute(
                        'mode', TP.core.SyncAsync.SYNCHRONOUS);

TP.core.LocalDBStorageService.register();

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.LocalDBStorageService.Inst.defineHandler('LocalDBStorageRequest',
function(aRequest) {

    /**
     * @method handleLocalDBStorageRequest
     * @summary Handles when an TP.sig.LocalDBStorageRequest is fired. Since
     *     this service will register itself as the default handler for these
     *     kinds of requests, the default instance of it will usually handle all
     *     of these kinds of requests.
     * @param {TP.sig.LocalDBStorageRequest} aRequest The request object to take
     *     the request parameters from.
     * @returns {TP.core.LocalDBStorageService} The receiver.
     */

    var request,

        url,
        commObj,

        resultStr,

        storageInstance,

        allDBsValue,
        allDBs,

        theDB,

        needsFlush,

        id,
        dbName,
        body,

        resultData,

        produceResultOutput,

        securePW,

        rowData,

        str,
        resultType;

    request = TP.request(aRequest);

    //  Make sure that we have a real URI
    url = TP.uc(request.at('uri'));

    //  if we don't have a viable URL, we must fail the request.
    if (TP.notValid(url)) {
        request.fail('TP.sig.InvalidURI');
        return this;
    }

    //  Set the 'comm object' of the url to be a plain Object (to emulate an
    //  XHR). The caller can extract information such as status codes, text,
    //  etc. from it.
    commObj = {
        response: null,
        responseText: null,
        responseType: 'text',
        responseXML: null,
        status: 200,
        statusText: '200 OK'
    };

    url.set('commObject', commObj);

    //  rewrite the mode, whether we're async or sync. This will only change
    //  the value if it hasn't been set to something already, but it may
    //  warn when the value appears to be inconsistent with what the service
    //  is capable of processing.
    request.atPut('async', this.rewriteRequestMode(request));

    if (TP.notValid(storageInstance = TP.core.LocalStorage.construct())) {

        resultStr = TP.sc('Cannot open local DB storage instance.');

        commObj.responseType = '';
        commObj.status = 500;
        commObj.statusText = '500 ' + resultStr;

        request.fail(resultStr);

        return this;
    }

    needsFlush = false;

    if (TP.notValid(
        allDBsValue = storageInstance.at(TP.LOCALSTORAGE_DB_NAME))) {

        allDBs = TP.hc();
        needsFlush = true;
    } else {
        if (TP.notValid(allDBs = TP.json2js(allDBsValue))) {
            resultStr = TP.sc('Local DB storage instance is corrupted.');

            commObj.responseType = '';
            commObj.status = 500;
            commObj.statusText = '500 ' + resultStr;

            request.fail(resultStr);

            return this;
        }
    }

    id = request.at('id');
    dbName = request.at('dbName');
    body = request.at('body');

    resultData = null;

    produceResultOutput = function(aRecord) {
        var output,
            outBody;

        output = aRecord.copy();

        outBody = output.at('_body');

        if (TP.notEmpty(securePW = request.at('securePW'))) {
            outBody = TP.decryptStorageValue(outBody, securePW);
            output.atPut('_body', outBody);
        }

        return output;
    };

    switch (request.at('action')) {
        case 'deleteDB':

            if (TP.notValid(allDBs.at(dbName))) {
                resultStr = TP.sc('Can\'t delete non-existent database named: ',
                                    dbName, '.');

                commObj.responseType = '';
                commObj.status = 500;
                commObj.statusText = '500 ' + resultStr;

                request.fail(resultStr);

                return this;
            }

            allDBs.removeKey(dbName);

            //  Assign what gets returned from here to match the CouchDB
            //  return value.
            resultData = TP.hc('ok', true);

            needsFlush = true;

            break;

        case 'deleteItem':

            if (TP.notValid(theDB = allDBs.at(dbName))) {
                resultStr =
                    TP.sc('Can\'t delete item in non-existent database named: ',
                            dbName, '.');

                commObj.responseType = '';
                commObj.status = 500;
                commObj.statusText = '500 ' + resultStr;

                request.fail(resultStr);

                return this;
            }

            if (TP.notValid(resultData = theDB.at(id))) {

                resultStr = TP.sc('Can\'t find item with id: ', id,
                                    ' in database:', dbName, ' to delete.');

                commObj.responseType = '';
                commObj.status = 500;
                commObj.statusText = '500 ' + resultStr;

                request.fail(resultStr);

                return this;
            }

            theDB.removeKey(id);

            //  Assign what gets returned from here to match the CouchDB
            //  return value.
            resultData = TP.hc('ok', true);

            needsFlush = true;

            break;

        case 'retrieveItem':

            if (TP.isValid(theDB = allDBs.at(dbName))) {

                if (TP.isValid(theDB.at(id))) {
                    resultData = produceResultOutput(theDB.at(id));
                }
            }

            break;

        case 'retrieveItemInfo':

            if (TP.isValid(theDB = allDBs.at(dbName))) {
                resultData = theDB.at(id);
                resultData = TP.hc(
                        '_date_created', resultData.at('_date_created'),
                        '_date_modified', resultData.at('_date_modified'));
            }

            break;

        case 'retrieveDBInfo':

            if (TP.isValid(theDB = allDBs.at(dbName))) {
                resultData = TP.hc('total_rows', theDB.getSize());
                rowData = TP.ac();
                theDB.perform(
                        function(kvPair) {
                            rowData.push(produceResultOutput(kvPair.last()));
                        });
                resultData.atPut('rows', rowData);
            }

            break;

        case 'createItem':

            if (TP.notValid(theDB = allDBs.at(dbName))) {
                theDB = TP.hc();
                allDBs.atPut(dbName, theDB);
            }

            if (TP.isValid(theDB.at(id))) {

                resultStr = TP.sc('Already had item with id: ', id,
                                    ' in database:', dbName, '.');

                commObj.responseType = '';
                commObj.status = 500;
                commObj.statusText = '500 ' + resultStr;

                request.fail(resultStr);

                //  Do not 'return' here - fall through, in case needsFlush is
                //  true and we want to store DB structure anyway...
            } else {

                //  Make sure we have a real id
                id = TP.isEmpty(id) ? TP.genUUID() : id;

                if (TP.notEmpty(securePW = request.at('securePW'))) {
                    body = TP.encryptStorageValue(TP.js2json(body), securePW);
                }

                resultData = TP.hc(
                                '_id', id,
                                '_date_created', TP.dc(),
                                '_date_modified', TP.dc(),
                                '_body', body);

                theDB.atPut(id, resultData);

                //  Assign what gets returned from here to match the CouchDB
                //  return value.
                resultData = TP.hc('ok', true, '_id', id);

                needsFlush = true;
            }

            break;

        case 'updateItem':

            if (TP.notValid(theDB = allDBs.at(dbName))) {
                theDB = TP.hc();
                allDBs.atPut(dbName, theDB);
            }

            if (TP.notEmpty(securePW = request.at('securePW'))) {
                body = TP.encryptStorageValue(TP.js2json(body), securePW);
            }

            //  We don't strictly need there to be existing data for an
            //  update. We'll create an item using the supplied id.
            if (TP.notValid(resultData = theDB.at(id))) {

                resultData = TP.hc(
                                '_id', id,
                                '_date_created', TP.dc(),
                                '_body', body);
            } else {
                //  There was existing data... update it.
                resultData.atPut('_body', body);
            }

            resultData.atPut('_date_modified', TP.dc());

            theDB.atPut(id, resultData);

            needsFlush = true;

            //  Assign what gets returned from here to match the CouchDB
            //  return value.
            resultData = TP.hc('ok', true, '_id', id);

            break;

        default:
            break;
    }

    if (needsFlush) {

        try {
            storageInstance.atPut(TP.LOCALSTORAGE_DB_NAME, TP.js2json(allDBs));
        } catch (e) {
            resultStr = e.message;

            commObj.responseType = '';
            commObj.status = 500;
            commObj.statusText = '500 ' + resultStr;

            request.fail(resultStr);
        }
    }

    str = TP.str(resultData);
    resultType = 'text';

    if (TP.isJSONString(resultData)) {
        resultType = 'json';
    } else if (TP.regex.CONTAINS_ELEM_MARKUP.test(resultData)) {
        resultData = TP.documentFromString(resultData);
        resultType = 'document';
    }

    commObj.response = resultData;
    commObj.responseType = resultType;
    commObj.responseText = str;
    commObj.responseXML = TP.isDocument(resultData) ? resultData : null;

    request.complete(resultData);

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/storage/localdb/TP.uri.LocalDBURL.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'device_storage';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @type {TP.uri.LocalDBURL}
 * @summary A subtype of TP.uri.URL specific to the 'local:' scheme.
 * @description

    'local://' URLs behave in a very RESTy way and are modeled on those used in
    CouchDB. You can find an explanation of how those work here:

        http://wiki.apache.org/couchdb/HTTP_Document_API

    //  ---

    GET (RETRIEVE):

    local://<db_name>/<_id>

        Returns value of all keys in record

        {
            "_id": "author_info"
            "_date_created": <Date>,
            "_date_modified": <Date>
            "First_name": "Bill",
            "Last_name": "Edney"
        }

    //  ---

    HEAD:

    local://<db_name>/<_id>

        Returns values of '_date_created' and '_date_modified':

        {
            "_date_created": <Date>,
            "_date_modified": <Date>
        }

    //  ---

    Return listing of all documents in db:

    GET local://<db_name>/_all_docs

        Returns:

        {
            "total_rows": 3,
            "rows": [
                        {"_id": _id, ...},
                    ]
        }
    //  ---

    PUT (UPDATE):

    local://<db_name>/<_id>

        Sets the value of the 'body' under that _id:

        {
            "First_name": "November",
            "Last_name": "Jones"
        }

        Returns:

        {
            "ok": true,
            "_id": <_id>
        }

    //  ---

    POST (CREATE):

    local://<db_name>/

        Sets the value of the 'body' under a generated _id:

        {
            "First_name": "November",
            "Last_name": "Jones"
        }

        Returns:

        {
            "ok": true,
            "_id": <_id> (generated)
        }

    //  ---

    DELETE (DELETE):

    local://<db_name>/<_id>

        Removes the entire value under that _id:

        Returns:

        {
            "ok": true,
            "_id": <_id>
        }

    //  ---

    It is possible to encrypt/decrypt data automatically by supplying a
    'securePW' parameter on the URL:

    local://<db_name>/<_id>?securePW=fluffy
 */

//  ------------------------------------------------------------------------

TP.uri.URL.defineSubtype('TP.uri.LocalDBURL');

TP.uri.LocalDBURL.addTraits(TP.uri.CommURL);

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  This RegExp splits up the URL into the following components:
//  local://dbName/(?id)
TP.uri.LocalDBURL.Type.defineConstant('LOCALDB_REGEX',
    TP.rc('^localdb://([^/]+)(/([^?]+)(\\??(\\S*))?)?'));

TP.uri.LocalDBURL.Type.defineConstant('SCHEME', 'localdb');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.uri.LocalDBURL.Type.defineAttribute('supportedModes',
                                    TP.core.SyncAsync.SYNCHRONOUS);
TP.uri.LocalDBURL.Type.defineAttribute('mode',
                                    TP.core.SyncAsync.SYNCHRONOUS);

TP.uri.LocalDBURL.registerForScheme('localdb');

TP.uri.LocalDBURL.Inst.defineAttribute('query');
TP.uri.LocalDBURL.Inst.defineAttribute('queryDict');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  note that there are 'scheme', 'path' and 'fragment' ivars on
//  TP.uri.URI / TP.uri.URL
TP.uri.LocalDBURL.Inst.defineAttribute('dbName');
TP.uri.LocalDBURL.Inst.defineAttribute('resourceID');

TP.uri.LocalDBURL.Inst.defineAttribute('$lastAdded');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.uri.LocalDBURL.Type.defineMethod('$getDefaultHandler',
function(aURI, aRequest) {

    /**
     * @method $getDefaultHandler
     * @summary Return the default URI handler type for this URI type.
     * @param {TP.uri.URI|String} aURI The URI to obtain the default handler
     *     for.
     * @param {TP.sig.Request} aRequest The request whose values should inform
     *     the routing assignment.
     * @returns {TP.meta.uri.URIHandler} A TP.uri.URIHandler subtype type
     *     object.
     */

    return TP.uri.LocalDBURLHandler;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.uri.LocalDBURL.Inst.defineMethod('init',
function(aURIString) {

    /**
     * @method init
     * @summary Initialize the instance.
     * @param {String} aURIString A String containing a proper URI.
     * @returns {TP.uri.LocalDBURL} A new instance.
     */

    var results,

        dbName,
        resourceID,

        uriQuery,
        queryDict;

    this.callNextMethod();

    //  Run the type's RegExp and grab the pieces of the URL.
    results = this.getType().LOCALDB_REGEX.exec(aURIString);

    if (TP.notValid(results) || TP.isEmpty(dbName = results.at(1))) {
        return this.raise('TP.sig.InvalidURI',
                    'Invalid local URL - no dbName: ' + aURIString);
    }

    //  Reset the 'path' ivar - the standard getPath() routine isn't smart
    //  enough to not include the query and it shouldn't for these kinds of
    //  URLs.
    this.set('path', TP.join(results.at(1), '/', results.at(3)));

    this.set('dbName', dbName);

    //  If there is a resource ID specified, then use it.
    if (TP.notEmpty(resourceID = results.at(3))) {
        this.set('resourceID', resourceID);
    }

    //  If there are parameters in the query, process them into a hash.
    if (TP.notEmpty(uriQuery = results.at(5))) {
        this.set('query', uriQuery);

        //  Create a hash from the query string.
        queryDict = TP.core.Hash.fromString(uriQuery);

        this.set('queryDict', queryDict);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.LocalDBURL.Inst.defineMethod('addResource',
function(existingResource, newResource, aRequest) {

    /**
     * @method addResource
     * @summary Adds to the receiver's resource object, the object TIBET will
     *     treat as the resource for any subsequent processing.
     * @param {Object} existingResource The existing resource assigned to this
     *     object, if available.
     * @param {Object} newResource The resource object to add to the resource of
     *     the receiver.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
     *     optional parameters.
     * @returns {TP.uri.URL|TP.sig.Response} The receiver or a TP.sig.Response
     *     when the resource must be acquired in an async fashion prior to
     *     setting any fragment value.
     */

    this.set('$lastAdded', newResource);

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.LocalDBURL.Inst.defineMethod('getContent',
function(aRequest) {

    /**
     * @method getContent
     * @summary Fetches the receiver's content, returns a content-specific
     *     object or a TP.sig.Response when the request is asynchronous.
     * @description For localdb: URLs, this method defaults the 'refresh'
     *     parameter to true, which is inverted from the base URI type's value
     *     of 'false'. This is because most of the time the requestor won't want
     *     the cached value of the URI, but will want to query the database.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {Object}
     */

    if (TP.isValid(aRequest)) {
        aRequest.atPutIfAbsent('refresh', true);
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/storage/localdb/TP.uri.LocalDBURLHandler.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'device_storage';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @type {TP.uri.LocalDBURLHandler}
 * @summary A URI handler type that can store and load from 'localdb://' URIs.
 */

//  ------------------------------------------------------------------------

TP.uri.URIHandler.defineSubtype('LocalDBURLHandler');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  CONTENT METHODS
//  ------------------------------------------------------------------------

TP.uri.LocalDBURLHandler.Type.defineMethod('load',
function(targetURI, aRequest) {

    /**
     * @method load
     * @summary Loads URI data content and returns it on request. This is a
     *     template method which defines the overall process used for loading
     *     URI data and ensuring that the URI's cache and header content are
     *     kept up to date. You should normally override one of the more
     *     specific load* methods in subtypes if you're doing custom load
     *     handling.
     * @param {TP.uri.URI} targetURI The URI to load. NOTE that this URI will
     *     not have been rewritten/ resolved.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @exception TP.sig.InvalidURI
     * @exception TP.sig.InvalidRequest
     * @returns {TP.sig.Response} A valid response object for the request.
     */

    var request,
        response,

        action,
        resourceID,
        dbName,

        queryDict,
        securePW,

        requestParams,

        loadRequest;

    request = TP.request(aRequest);
    response = request.getResponse();

    //  GET requests require at least a dbName
    if (TP.notValid(dbName = targetURI.get('dbName'))) {
        request.fail('No db name specified for: ' + TP.str(targetURI));

        return response;
    }

    resourceID = targetURI.get('resourceID');

    if (request.at('method') === TP.HTTP_HEAD) {
        action = 'retrieveItemInfo';
    } else if (TP.isValid(resourceID)) {
        if (resourceID === '_all_docs') {
            action = 'retrieveDBInfo';
        } else {
            action = 'retrieveItem';
        }
    } else {
        request.fail('Can\'t compute a load action for: ' + TP.str(targetURI));

        return response;
    }

    if (TP.isValid(queryDict = targetURI.get('queryDict'))) {
        securePW = queryDict.at('securePW');
    }

    requestParams = TP.hc(
                    'action', action,
                    'dbName', dbName,
                    'securePW', securePW,
                    'id', resourceID,
                    'uri', targetURI.getLocation());

    //  Construct and initialize a TP.sig.LocalDBStorageRequest
    loadRequest = TP.sig.LocalDBStorageRequest.construct(requestParams);

    //  'Join' that request to the incoming request. This will cause the
    //  incoming request to 'pause' until the get item request finishes and
    //  to be 'dependent' on the success/failure of the get item request.
    request.andJoinChild(loadRequest);

    //  Fire the load request to trigger service operation.
    loadRequest.fire();

    //  Make sure that the 2 requests match on sync/async
    request.updateRequestMode(loadRequest);

    return response;
});

//  ------------------------------------------------------------------------

TP.uri.LocalDBURLHandler.Type.defineMethod('delete',
function(targetURI, aRequest) {

    /**
     * @method delete
     * @summary Deletes the target URL.
     * @param {TP.uri.URI} targetURI The URI to delete. NOTE that this URI will
     *     not have been rewritten/ resolved.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} A valid response object for the request.
     */

    var request,
        response,

        action,

        dbName,
        resourceID,

        queryDict,
        securePW,

        requestParams,

        deleteRequest;

    request = TP.request(aRequest);
    response = request.getResponse();

    //  DELETE requests require a dbName
    if (TP.notValid(dbName = targetURI.get('dbName'))) {
        request.fail('No db name specified for: ' + TP.str(targetURI));

        return response;
    }

    if (TP.isValid(resourceID = targetURI.get('resourceID'))) {
        action = 'deleteItem';
    } else {
        action = 'deleteDB';
    }

    if (TP.isValid(queryDict = targetURI.get('queryDict'))) {
        securePW = queryDict.at('securePW');
    }

    requestParams = TP.hc(
                    'action', action,
                    'dbName', dbName,
                    'securePW', securePW,
                    'id', resourceID,
                    'uri', targetURI.getLocation());

    //  Construct and initialize a TP.sig.LocalDBStorageRequest
    deleteRequest = TP.sig.LocalDBStorageRequest.construct(requestParams);

    //  'Join' that request to the incoming request. This will cause the
    //  incoming request to 'pause' until the get item request finishes and
    //  to be 'dependent' on the success/failure of the delete item request.
    request.andJoinChild(deleteRequest);

    //  Fire the delete request to trigger service operation.
    deleteRequest.fire();

    //  Make sure that the 2 requests match on sync/async
    request.updateRequestMode(deleteRequest);

    return response;
});

//  ------------------------------------------------------------------------

TP.uri.LocalDBURLHandler.Type.defineMethod('save',
function(targetURI, aRequest) {

    /**
     * @method save
     * @summary
     * @param {TP.uri.URI} targetURI The URI to save. NOTE that this URI will
     *     not have been rewritten/ resolved.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @exception TP.sig.InvalidURI
     * @exception TP.sig.InvalidRequest
     * @returns {TP.sig.Response} A valid response object for the request.
     */

    var request,
        response,

        dbName,
        resourceID,

        queryDict,
        securePW,

        cmdAction,
        resp,
        content,

        requestParams,

        saveRequest;

    request = TP.request(aRequest);
    response = request.getResponse();

    //  PUT and POST requests require at least a dbName
    if (TP.notValid(dbName = targetURI.get('dbName'))) {
        request.fail('No db name specified for: ' + TP.str(targetURI));

        return response;
    }

    resourceID = targetURI.get('resourceID');

    //  If we're adding content, then see if we have the content to add.
    cmdAction = request.at('cmdAction');

    if (cmdAction === TP.ADD) {
        //  Adding content - grab the 'last added content' that should be on our
        //  URI

        //  TODO: Figure this out.
        //  content = targetURI.get('$lastAdded');
        void 0;
    } else {
        //  Setting the content

        //  Grab whatever is in *the memory cache* of the URI. This will be the
        //  value of whatever was just 'set' as the 'resource' of the URI -
        //  the result value will be the value that we want to update.

        //  Note here how we force refresh. as well as async, to 'false' so we
        //  effectively do a synchronous "cache read".
        resp = targetURI.getResource(TP.hc('refresh', false, 'async', false));
        if (TP.isEmpty(content = resp.get('result'))) {
            request.fail('No content to save for: ' + TP.str(targetURI));

            return response;
        }
    }

    if (TP.isValid(queryDict = targetURI.get('queryDict'))) {
        securePW = queryDict.at('securePW');
    }

    if (request.at('method') === TP.HTTP_PUT) {

        if (TP.notValid(resourceID)) {
            request.fail('No resource ID specified for: ' + TP.str(targetURI));

            return response;
        }

        requestParams = TP.hc(
                        'action', 'updateItem',
                        'dbName', dbName,
                        'securePW', securePW,
                        'id', resourceID,
                        'body', content,
                        'uri', targetURI.getLocation());
    } else {

        requestParams = TP.hc(
                        'action', 'createItem',
                        'dbName', dbName,
                        'securePW', securePW,
                        'body', content,
                        'uri', targetURI.getLocation());
    }

    //  Construct and initialize a TP.sig.LocalDBStorageRequest
    saveRequest = TP.sig.LocalDBStorageRequest.construct(requestParams);

    //  'Join' that request to the incoming request. This will cause the
    //  incoming request to 'pause' until the put item request finishes and
    //  to be 'dependent' on the success/failure of the save request.
    request.andJoinChild(saveRequest);

    //  Fire the save request to trigger service operation.
    saveRequest.fire();

    //  Make sure that the 2 requests match on sync/async
    request.updateRequestMode(saveRequest);

    return response;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/storage/TP.uri.StorageURL.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'device_storage';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @type {TP.uri.StorageURL}
 * @summary A subtype of TP.uri.URL specific to the storage: scheme, a custom
 *     TIBET scheme specific to working with local and session storage data.
 */

//  ------------------------------------------------------------------------

TP.uri.URL.defineSubtype('TP.uri.StorageURL');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  This RegExp splits up the URL into the following components:
//  storage://store(/?key[=value])
TP.uri.StorageURL.Type.defineConstant('STORAGE_URL_REGEX',
    TP.rc('^storage://([^/]+)((/)(.+))*'));

TP.uri.StorageURL.Type.defineConstant('SCHEME', 'storage');

TP.uri.StorageURL.Type.defineConstant('VALID_STORES',
    TP.ac('local', 'session'));

TP.uri.StorageURL.Type.defineAttribute('supportedModes',
                                    TP.core.SyncAsync.DUAL_MODE);
TP.uri.StorageURL.Type.defineAttribute('mode',
                                    TP.core.SyncAsync.SYNCHRONOUS);

//  NOTE we need to register with the overall system to the URI.construct call
//  is aware of our scheme.
TP.uri.StorageURL.registerForScheme('storage');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.uri.StorageURL.Inst.defineAttribute('item');
TP.uri.StorageURL.Inst.defineAttribute('store');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.uri.StorageURL.Type.defineMethod('$getDefaultHandler',
function(aURI, aRequest) {

    /**
     * @method $getDefaultHandler
     * @summary Return the default URI handler type for this URI type.
     * @param {TP.uri.URI|String} aURI The URI to obtain the default handler
     *     for.
     * @param {TP.sig.Request} aRequest The request whose values should inform
     *     the routing assignment.
     * @returns {TP.meta.uri.URIHandler} A TP.uri.URIHandler object.
     */

    //  Handle requests ourselves.
    return this;
});

//  ------------------------------------------------------------------------
//  Handler Methods
//  ------------------------------------------------------------------------

TP.uri.StorageURL.Type.defineMethod('load',
function(targetURI, aRequest) {

    /**
     * @method load
     * @summary Loads URI data content, returning the TP.sig.Response object
     *     used to manage the low-level service response.
     * @param {TP.uri.URI} targetURI The URI to load. Note that this call is
     *     typically made via the load call of a URI and so rewriting and
     *     routing have already occurred.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The response.
     */

    var request,
        response,
        store,
        item,
        result,
        parsed;

    request = targetURI.constructRequest(aRequest);
    response = request.getResponse();

    store = TP.global[targetURI.get('store') + 'Storage'];
    if (TP.notValid(store)) {
        this.raise('InvalidStore', targetURI.get('store'));
    }

    item = targetURI.get('item');
    if (TP.notEmpty(item)) {
        result = store.getItem(item);
        if (TP.notEmpty(result)) {
            try {
                parsed = TP.json2js(result);
                result = parsed;
            } catch (e) {
                //  ignore data that wasn't JSON formatted properly and just
                //  rely on the origin result.
                void 0;
            }
        }

        request.complete(result);
    } else {
        result = TP.hc(store);
        request.complete(result);
    }

    return response;
});

//  ------------------------------------------------------------------------

TP.uri.StorageURL.Type.defineMethod('delete',
function(targetURI, aRequest) {

    /**
     * @method delete
     * @summary Deletes a URI entirely, returning the TP.sig.Response object
     *     used to manage the low-level service response.
     * @param {TP.uri.URI} targetURI The URI to delete. Note that this call is
     *     typically made via the delete call of a URI and so rewriting and
     *     routing have already occurred.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The response.
     */

    var request,
        response,
        store,
        item;

    request = targetURI.constructRequest(aRequest);
    response = request.getResponse();

    store = TP.global[targetURI.get('store') + 'Storage'];
    if (TP.notValid(store)) {
        this.raise('InvalidStore', targetURI.get('store'));
    }

    item = targetURI.get('item');
    if (TP.isEmpty(item)) {
        this.raise('InvalidOperation');
        request.fail('InvalidOperation');
    } else {
        store.removeItem(item);
        request.complete();
    }

    return response;
});

//  ------------------------------------------------------------------------

TP.uri.StorageURL.Type.defineMethod('save',
function(targetURI, aRequest) {

    /**
     * @method save
     * @summary Saves URI data content. This is the default data persistence
     *     method for most URI content.
     * @description By creating alternative URI handlers and ensuring that URI
     *     routing can find them you can alter how data is managed for different
     *     URI instances. See TP.uri.URIRewriter and TP.uri.URIMapper for more
     *     information. Important keys include 'append', 'body', and 'backup',
     *     which define whether this save should append or write new content,
     *     what content is being saved, and whether a backup should be created
     *     if possible (for 'file' scheme uris).
     * @param {String|TP.uri.URI} targetURI A target URI.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The response.
     */

    var request,
        response,
        store,
        item,
        content;

    request = targetURI.constructRequest(aRequest);
    response = request.getResponse();

    store = TP.global[targetURI.get('store') + 'Storage'];
    if (TP.notValid(store)) {
        this.raise('InvalidStore', targetURI.get('store'));
    }

    item = targetURI.get('item');
    if (TP.isEmpty(item)) {
        this.raise('InvalidOperation');
        request.fail('InvalidOperation');
    } else {
        //  NOTE we do _not_ want to force a fetch here, we only want whatever
        //  the targetURI already has stored as its resource.
        content = targetURI.$get('resource');

        //  often a content wrapper...we need string value.
        if (TP.isValid(content)) {
            content = TP.str(content);
        }

        store.setItem(item, TP.js2json(content));
        request.complete();
    }

    return response;
});

//  ------------------------------------------------------------------------

TP.uri.StorageURL.Type.defineMethod('watch',
function(targetURI, aRequest) {

    /**
     * @method watch
     * @summary Watches URI data content. This is used for URIs that represent
     *     remote resources in the system and can be notified by a server-side
     *     component that those resources have changed.
     * @description At this level, this method does nothing. Handlers that
     *     represent change-notification capable servers should override this
     *     method to set up change notification machinery for this URI back to
     *     TIBET.
     * @param {String|TP.uri.URI} targetURI A target URI.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The response.
     */

    var request,
        response;

    request = targetURI.constructRequest(aRequest);
    response = request.getResponse();

    request.fail('UnsupportedOperation');

    return response;
});

//  ------------------------------------------------------------------------

TP.uri.StorageURL.Type.defineMethod('unwatch',
function(targetURI, aRequest) {

    /**
     * @method unwatch
     * @summary Unwatches (i.e. ignores) URI data content. This is used for URIs
     *     that represent remote resources in the system and can be notified by
     *     a server-side component that those resources have changed.
     * @description At this level, this method does nothing. Handlers that
     *     represent change-notification capable servers should override this
     *     method to tear down change notification machinery that it would have
     *     method to tear down change notification machinery for this URI that
     *     it would have set up to TIBET.
     * @param {String|TP.uri.URI} targetURI A target URI.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The response.
     */

    var request,
        response;

    request = targetURI.constructRequest(aRequest);
    response = request.getResponse();

    request.fail('UnsupportedOperation');

    return response;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.uri.StorageURL.Inst.defineMethod('$getPrimaryResource',
function(aRequest, filterResult) {

    /**
     * @method $getPrimaryResource
     * @summary Returns the value for the targeted URL from browser storage.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @param {Boolean} filterResult True if the resource result will be used
     *     directly and should be filtered to match any resultType definition
     *     found in the request. The default is false.
     * @returns {TP.sig.Response} A TP.sig.Response created with the resource's
     *     content set as its result.
     */

    var request,
        result,
        response;

    request = this.constructRequest(aRequest);

    //  NOTE that we always load from localStorage value...never 'resource'
    result = this.load().get('result');
    this.$set('resource', result);

    //  filter any remaining data
    if (TP.isTrue(filterResult) && TP.isValid(result)) {
        result = this.$getFilteredResult(result, request, false);
    }

    response = request.getResponse(result);
    request.complete(result);

    return response;
});

//  ------------------------------------------------------------------------

TP.uri.StorageURL.Inst.defineMethod('getResource',
function(aRequest) {

    /**
     * @method getResource
     * @summary Returns the resource the URL references.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} A TP.sig.Response created with the resource's
     *     content set as its result.
     */

    var primaryResource,

        request,
        result,

        response;

    request = this.constructRequest(aRequest);

    primaryResource = this.$get('resource');

    result = this.$getFilteredResult(primaryResource, request);

    //  synchronous? complete any request we might actually have.
    if (TP.canInvoke(request, 'complete')) {
        request.complete(result);
    }

    response = request.getResponse(result);

    return response;
});

//  ------------------------------------------------------------------------

TP.uri.StorageURL.Inst.defineMethod('getValue',
function() {

    /**
     * @method getValue
     * @summary Returns the value of the URI, essentially the 'resource'.
     * @returns {Object} The value of the receiver's resource.
     */

    return TP.val(this.getContent());
});

//  ------------------------------------------------------------------------

TP.uri.StorageURL.Inst.defineMethod('isPrimaryURI',
function() {

    /**
     * @method isPrimaryURI
     * @summary Returns true if the receiver is a primary URI, meaning it has
     *     no fragment portion and can store data. Storage URIs are always
     *     primary URIs, there is no concept of a fragment.
     * @returns {Boolean} True if the receiver is a primary URI.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.uri.StorageURL.Inst.defineMethod('$initURIComponents',
function(parts) {

    /**
     * @method $initURIComponents
     * @summary Performs any post-parsing initialization appropriate for the
     *     URI components which were parsed during scheme-specific parsing.
     * @param {TP.core.Hash} parts The parsed URI components.
     * @returns {TP.uri.StorageURL} The receiver.
     */

    this.callNextMethod();

    if (TP.isEmpty(parts)) {
        return this;
    }

    //  NOTE: These 'set' calls use 'false' to avoid notification!! This is
    //  necessary when creating a URI, since otherwise the change notification
    //  mechanism will cause errors trying to get observations set up before
    //  everything is in place.

    this.set('store', parts.at('store'), false);
    this.set('item', parts.at('item'), false);

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.StorageURL.Inst.defineMethod('$parseSchemeSpecificPart',
function(schemeSpecificString) {

    /**
     * @method $parseSchemeSpecificPart
     * @summary Parses inbound URI string content in a fashion specific to the
     *     scheme(s) being managed by the receiver.
     * @param {String} schemeSpecificString A String containing the
     *     "scheme-specific-part" of a URI.
     * @returns {TP.core.Hash} The parsed URI 'components'.
     */

    var hash,
        parts;

    this.callNextMethod();

    parts = this.getType().STORAGE_URL_REGEX.exec(
                    'storage:' + schemeSpecificString);

    if (TP.notValid(parts)) {
        return TP.hc();
    }

    hash = TP.hc();
    hash.atPut('store', parts[1]);
    hash.atPut('item', parts[4]);

    return hash;
});

//  ------------------------------------------------------------------------

TP.uri.StorageURL.Inst.defineMethod('$setPrimaryResource',
function(aResource, aRequest) {

    /**
     * @method $setPrimaryResource
     * @summary Sets the receiver's resource object, the object TIBET will
     *     treat as the primary resource for any subsequent processing.
     * @param {Object} aResource The resource object to assign.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request containing
     *     optional parameters.
     * @listens {TP.sig.Change} Observes the primary resource for Change.
     * @returns {TP.uri.StorageURL|TP.sig.Response} The receiver or a
     *     TP.sig.Response when the resource must be acquired in an async fashion
     *     prior to setting any fragment value.
     */

    this.$set('resource', aResource);

    //  NOTE that we always push value to proper storage target.
    if (aResource === undefined) {
        this.delete(aRequest);
    } else {
        this.save(aRequest);
    }

    //  Perform normal processing to ensure we signal etc.
    this.callNextMethod();

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/workflow/TP.sig.UserIOSignal.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'workflow';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @type {TP.sig.UserIOSignal}
 * @summary A common MIXIN used for TP.sig.UserIORequest and
 *     TP.sig.UserIOResponse types so they can inherit directly from
 *     Request/Response as needed while sharing common UserIO functionality.
 */

//  ------------------------------------------------------------------------

//  NOTE that we're not a TP.sig.Signal, the attributes and methods here are
//  intended to be mixed in to TP.sig.Signal subtypes
TP.lang.Object.defineSubtype('sig.UserIOSignal');

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation
TP.sig.UserIOSignal.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.sig.UserIOSignal.Type.defineMethod('shouldLog',
function() {

    return TP.sys.shouldLogUserIOSignals();
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  what type of message? help, request, success, error, prompt, etc.
TP.sig.UserIOSignal.Inst.defineAttribute('messageType', 'message');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.UserIOSignal.Inst.defineMethod('getMessageType',
function() {

    /**
     * @method getMessageType
     * @summary Returns the message type, one of a number of values which map
     *     directly to CSS entries and node templates used to provided
     *     theme-able output.
     * @returns {String}
     */

    var val;

    if (TP.isValid(val = this.at('messageType'))) {
        return val;
    }

    return this.$get('messageType');
});

//  ------------------------------------------------------------------------

TP.sig.UserIOSignal.Inst.defineMethod('isError',
function(aFlag) {

    /**
     * @method isError
     * @summary Combined setter/getter for whether the receiver represents an
     *     error response request.
     * @param {Boolean} aFlag True will signify the receiver holds an error
     *     message to respond to.
     * @returns {Boolean}
     */

    if (TP.isBoolean(aFlag)) {
        if (TP.isValid(this.at('messageType'))) {
            this.atPut('messageType', aFlag);
        } else {
            this.$set('messageType', 'failure');
        }
    }

    return this.getMessageType() === 'failure';
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/workflow/TP.sig.UserIORequest.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'workflow';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @type {TP.sig.UserIORequest}
 * @summary The common supertype used for all user IO requests. These requests
 *     are typically handled by the console, whose response is to provide the
 *     user with an input cell for entering a response.
 */

//  ------------------------------------------------------------------------

TP.sig.IORequest.defineSubtype('UserIORequest');

TP.sig.UserIORequest.addTraits(TP.sig.UserIOSignal);

TP.sig.UserIORequest.Type.resolveTrait('shouldLog', TP.sig.UserIOSignal);
TP.sig.UserIORequest.Type.resolveTrait('getSignalName', TP.sig.Signal);

TP.sig.UserIORequest.Inst.resolveTrait('resume', TP.core.JobStatus);

TP.sig.UserIORequest.Inst.resolveTraits(
    TP.ac('init', 'handle', 'recycle'),
    TP.sig.Request);

TP.sig.UserIORequest.Inst.resolveTraits(
    TP.ac('asDumpString', 'asHTMLString', 'asJSONSource', 'asPrettyString',
            'asRecursionString', 'asSource', 'asString', 'asXMLString', 'at',
            'atPut', 'copy', 'getProperty', 'getSignalName', 'isRecyclable',
            'removeKey', 'shouldLog'),
    TP.sig.Signal);

TP.sig.UserIORequest.isSignalingRoot(true);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.sig.UserIORequest.Type.defineAttribute('defaultPolicy',
                                            TP.INHERITANCE_FIRING);

TP.sig.UserIORequest.Type.defineAttribute('responseType',
                                            'TP.sig.UserIOResponse');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/workflow/TP.sig.UserIOResponse.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'workflow';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @type {TP.sig.UserIOResponse}
 * @summary A type used as the common response type for TP.sig.UserIORequests.
 */

//  ------------------------------------------------------------------------

TP.sig.IOResponse.defineSubtype('UserIOResponse');

TP.sig.UserIOResponse.addTraits(TP.sig.UserIOSignal);

TP.sig.UserIOResponse.Type.resolveTrait('shouldLog', TP.sig.UserIOSignal);
TP.sig.UserIOResponse.Type.resolveTrait('getSignalName', TP.sig.Signal);

TP.sig.UserIOResponse.Inst.resolveTrait('resume', TP.core.JobStatus);

TP.sig.UserIOResponse.Inst.resolveTrait('init', TP.sig.Response);

TP.sig.UserIOResponse.Inst.resolveTraits(
    TP.ac('asDumpString', 'asHTMLString', 'asJSONSource', 'asPrettyString',
            'asRecursionString', 'asSource', 'asString', 'asXMLString', 'at',
            'atPut', 'copy', 'getProperty', 'getSignalName', 'isRecyclable',
            'recycle', 'removeKey', 'shouldLog'),
    TP.sig.Signal);

//  ========================================================================
//  TP.sig.UserOutput
//  ========================================================================

/**
 * @type {TP.sig.UserOutput}
 * @summary A common type for holding output generated by the user.
 */

//  ------------------------------------------------------------------------

TP.sig.UserIOResponse.defineSubtype('UserOutput');

//  ========================================================================
//  TP.sig.UserInput
//  ========================================================================

/**
 * @type {TP.sig.UserInput}
 * @summary The type used to contain input from the user. This is the primary
 *     form of TP.sig.UserIOResponse used by the console.
 */

//  ------------------------------------------------------------------------

TP.sig.UserIOResponse.defineSubtype('UserInput');

//  ========================================================================
//  TP.sig.UserInputEntry
//  ========================================================================

/**
 * @type {TP.sig.UserInputEntry}
 * @summary A response containing a single entry of user input in what will
 *     likely be a series of query/response pairs. This type is used by the
 *     TP.sig.UserInputSeries request type as its response type.
 */

//  ------------------------------------------------------------------------

TP.sig.UserInput.defineSubtype('UserInputEntry');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/workflow/TP.core.UserIOService.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'workflow';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @type {TP.core.UserIOService}
 * @summary A TP.core.Service specific to handling TP.sig.UserIORequests. The
 *     best example is the TIBET console which provides a way for the system to
 *     interact with the User.
 */

//  ------------------------------------------------------------------------

TP.core.IOService.defineSubtype('UserIOService');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  what signals will trigger this resource/service?
TP.core.UserIOService.Type.defineAttribute(
    'triggers', TP.ac(TP.ac(TP.ANY, 'TP.sig.UserIORequest')));

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  the list of currently queued requests. when IO requests come in they may
//  be queued if the service is currently handing a blocking request.
TP.core.UserIOService.Inst.defineAttribute('requestQueue');

TP.core.UserIOService.Inst.defineAttribute('lastInputRequest');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.core.UserIOService.Inst.defineMethod('init',
function(aResourceID, aRequest) {

    /**
     * @method init
     * @summary Initializes a new instance.
     * @param {String} aResourceID The unique identifier for this service.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An optional request or
     *     hash containing a service URI if the service is going to be tied to a
     *     particular target location.
     * @returns {TP.core.UserIOService} A new instance.
     */

    this.callNextMethod();

    this.$set('requestQueue', TP.ac());

    return this;
});

//  ------------------------------------------------------------------------

TP.core.UserIOService.Inst.defineMethod('getRequestQueue',
function() {

    /**
     * @method getRequestQueue
     * @summary Returns the receiver's request queue, the list of requests
     *     which are currently awaiting processing.
     * @returns {TP.sig.Request[]}
     */

    return this.$get('requestQueue');
});

//  ------------------------------------------------------------------------

TP.core.UserIOService.Inst.defineMethod('getNextRequest',
function(aRequest) {

    /**
     * @method getNextRequest
     * @summary Removes a request from the queue and returns it for processing.
     * @param {TP.sig.Request} aRequest The last request, which sometimes will
     *     need to provide information to this process.
     * @returns {TP.sig.UserIORequest} The IO request to process.
     */

    return this.get('requestQueue').shift();
});

//  ------------------------------------------------------------------------

TP.core.UserIOService.Inst.defineMethod('getRequestById',
function(aRequestID) {

    /**
     * @method getRequestById
     * @summary Retrieves a request from the queue and returns it for
     *     processing. This is typically used to retrieve queued requests as
     *     part of RequestCompleted processing since those signals originate
     *     from the ID of the request that is complete.
     * @param {String} aRequestID The unique request ID for the request.
     * @returns {TP.sig.UserIORequest} The IO request found.
     */

    var req,
        queue;

    //  first check the last input request since that's the common case
    if (TP.isValid(req = this.get('lastInputRequest'))) {
        if (req.getRequestID() === aRequestID) {
            return req;
        }
    }

    //  didn't find it? check the request queue for it then...
    queue = this.get('requestQueue');
    req = queue.detect(
                function(item) {
                    return item.getRequestID() === aRequestID;
                });

    return req;
});

//  ------------------------------------------------------------------------

TP.core.UserIOService.Inst.defineHandler('NextRequest',
function(aRequest) {

    /**
     * @method handleNextRequest
     * @summary Processes the next request in the receiver's request queue.
     *     This method is automatically invoked at the end of each request cycle
     *     so any pending requests are handled in FIFO order.
     * @param {TP.sig.Request} aRequest The last request, which sometimes will
     *     need to provide information to this process.
     * @returns {TP.core.UserIOService} The receiver.
     */

    var req,
        handler;

    //  when input causes a new input request to be queued the
    //  'lastInputRequest' might not have been handled yet, so we have to
    //  check that first before we decide to clear it...
    if (TP.isValid(req = this.get('lastInputRequest'))) {
        if (req.isActive()) {
            //  update in case the signal has altered on the fly (by
            //  updating prompt or default value for example)
            this.refreshFromRequest(req);

            return this;
        }
    }

    //  always clear the last request to force the new request to be set and
    //  make sure we think we're available for use
    this.set('lastInputRequest', null);
    this.isAwaitingInput(false);
    this.shouldConcealInput(false);

    //  deal with running out of requests to process
    if (TP.notValid(req = this.getNextRequest(aRequest))) {
        return this[TP.composeHandlerName('NoMoreRequests')](aRequest);
    }

    handler = this.getBestHandler(req);
    if (TP.isFunction(handler)) {
        handler.call(this);
    }

    this.raise('TP.sig.UnhandledInputRequest', req);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.UserIOService.Inst.defineHandler('NoMoreRequests',
function(aRequest) {

    /**
     * @method handleNoMoreRequests
     * @summary Performs any processing required when all queued requests have
     *     been processed. The default is simply to return.
     * @param {TP.sig.Request} aRequest The last request, which sometimes will
     *     need to provide information to this process.
     * @returns {TP.core.UserIOService} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.UserIOService.Inst.defineHandler('UserInputRequest',
function(aSignal) {

    /**
     * @method handleUserInputRequest
     * @summary Responds to input requests, either handling them directly or
     *     queuing them for later processing.
     * @param {TP.sig.UserInputRequest} aSignal
     * @returns {TP.core.UserIOService} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.UserIOService.Inst.defineHandler('UserInputSeries',
function(aSignal) {

    /**
     * @method handleUserInpuSeries
     * @summary Responds to input series, either handling them directly or
     *     queuing them for later processing.
     * @param {TP.sig.UserInputSeries} aSignal
     * @returns {TP.core.UserIOService} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.UserIOService.Inst.defineHandler('UserOutputRequest',
function(aSignal) {

    /**
     * @method handleUserOutputRequest
     * @summary Responds to output requests, either handling them directly or
     *     queuing them for later processing.
     * @param {TP.sig.UserOutputRequest} aSignal
     * @returns {TP.core.UserIOService} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.core.UserIOService.Inst.defineMethod('isAwaitingInput',
function(aFlag) {

    /**
     * @method isAwaitingInput
     * @summary Combined setter/getter for whether the receiver is waiting for
     *     input. This method will interrogate the input cell as part of the
     *     process.
     * @param {Boolean} aFlag An optional new setting.
     * @returns {Boolean} The current input state.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.core.UserIOService.Inst.defineMethod('queueIORequest',
function(aSignal) {

    /**
     * @method queueIORequest
     * @summary Queues the incoming signal for later processing. This method is
     *     typically invoked automatically by services that are currently
     *     blocked servicing a prior request.
     * @param {TP.sig.UserIORequest} aSignal
     * @returns {TP.core.UserIOService} The receiver.
     */

    this.get('requestQueue').add(aSignal);

    return this;
});

//  ------------------------------------------------------------------------

TP.core.UserIOService.Inst.defineMethod('refreshFromRequest',
function(aRequest) {

    /**
     * @method refreshFromRequest
     * @summary Performs any updates necessary to ensure that the display is
     *     current with the current state of the request. The default
     *     implementation does nothing.
     * @param {TP.sig.UserIORequest} aRequest
     * @returns {TP.core.UserIOService} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/workflow/TP.sig.UserInputRequest.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'workflow';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @type {TP.sig.UserInputRequest}
 * @summary The common type used to get direct input from the user. In response
 *     to TP.sig.UserInputRequests the console will give control over the input
 *     cell content to the request, skipping any parsing of content.
 */

//  ------------------------------------------------------------------------

TP.sig.UserIORequest.defineSubtype('UserInputRequest');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.sig.UserInputRequest.Type.defineAttribute('responseType', 'TP.sig.UserInput');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  what type of message? help, request, success, error, etc.
TP.sig.UserInputRequest.Inst.defineAttribute('messageType', 'prompt');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/workflow/TP.sig.UserInputSeries.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'workflow';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @type {TP.sig.UserInputSeries}
 * @summary A request type specifically intended to query the user for a series
 *     of data elements, validating each one before proceeding. This type can
 *     also be used to construct simple query sequences or console 'wizards' to
 *     prompt the user for information in a sequence.
 * @example
 *     uis = TP.sig.UserInputSeries.construct();
 *
 *     uis.addQuery(TP.hc('query', 'Knock Knock Neo...', 'validator',
 *                  function(input) {
 *                      return /who.*s there/i.test(input);
 *                  }));
 *
 *     uis.addQuery(TP.hc('query', 'Hello', 'validator',
 *                  function(input) {
 *                      return /hello who/i.test(input);
 *                  }));
 *
 *     uis.addCancelHook(
 *              function(series) {
 *                  TP.sig.UserOutputRequest.construct(
 *                      TP.hc( 'output','Quitter!', 'messageType','failure')).
 *                                                  fire(series.get('origin'));
 *              });
 *
 *     uis.addFailureHook(
 *              function(series) {
 *                  TP.sig.UserOutputRequest.construct(
 *                      TP.hc( 'output','Oops!', 'messageType','failure' )).
 *                                                  fire(series.get('origin'));
 *              });
 *
 *     uis.addSuccessHook(
 *              function(series) {
 *                  TP.sig.UserOutputRequest.construct(
 *                      TP.hc('output','Hello World!')).
 *                                                  fire(series.get('origin'));
 *              });
 *
 *     Note that we need to associate the request with a shell if we want a
 *     console to respond since consoles only work on behalf of their models:
 *
 *     uis.fire(this);
 */

//  ------------------------------------------------------------------------

TP.sig.UserInputRequest.defineSubtype('UserInputSeries');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  constants defining array indices for query records
TP.sig.UserInputSeries.Type.defineConstant('QUERY_INDEX', 0);
TP.sig.UserInputSeries.Type.defineConstant('DEFAULT_INDEX', 1);
TP.sig.UserInputSeries.Type.defineConstant('PASSWORD_INDEX', 2);
TP.sig.UserInputSeries.Type.defineConstant('RETRY_INDEX', 3);
TP.sig.UserInputSeries.Type.defineConstant('VALIDATOR_INDEX', 4);
TP.sig.UserInputSeries.Type.defineConstant('COUNT_INDEX', 5);

//  common validation functions
TP.sig.UserInputSeries.Type.defineConstant('OPTIONAL',
    function() {

        return true;
    });

TP.sig.UserInputSeries.Type.defineConstant('MANDATORY',
    function(input) {

        return TP.notEmpty(input);
    });

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.sig.UserInputSeries.Type.defineAttribute('responseType', 'TP.sig.UserInput');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  the origin we were last initiated with
TP.sig.UserInputSeries.Inst.defineAttribute('origin');

//  holder for an array of query entries
TP.sig.UserInputSeries.Inst.defineAttribute('queries');

//  the current index in the query list
TP.sig.UserInputSeries.Inst.defineAttribute('queryIndex', 0);

//  holder for the user's replies to the queries
TP.sig.UserInputSeries.Inst.defineAttribute('replies');

//  the number of times to retry a query/validation step before quitting
TP.sig.UserInputSeries.Inst.defineAttribute('retries', 0);
TP.sig.UserInputSeries.Inst.defineAttribute('retryMax', 5);

//  holder for a shared TP.sig.UserOutputRequest for error messages etc.
TP.sig.UserInputSeries.Inst.defineAttribute('uor');

TP.sig.UserInputSeries.Inst.defineAttribute('cancelHooks');
TP.sig.UserInputSeries.Inst.defineAttribute('failureHooks');
TP.sig.UserInputSeries.Inst.defineAttribute('successHooks');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.UserInputSeries.Inst.defineMethod('init',
function() {

    /**
     * @method init
     * @summary Initializes a new request object and returns it.
     * @returns {TP.sig.UserInputSeries} A new instance.
     */

    this.callNextMethod();

    //  initialize our query array
    this.$set('queries', TP.ac());

    //  initialize the response array
    this.$set('replies', TP.ac());

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.UserInputSeries.Inst.defineMethod('failJob',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method failJob
     * @summary Tells the request/response to fail, meaning the receiver should
     *     do whatever finalization is necessary to reach the TP.FAILED state.
     *     If the receiver has specific behavior to implement it can be added
     *     via addFailureHook() calls. Note that the status is TP.FAILING during
     *     any processing and TP.FAILED after processing is done.
     * @param {String} aFaultString Description of the error.
     * @param {Object} aFaultCode A code providing additional information on
     *     what went wrong.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the failure.
     * @returns {TP.sig.UserInputSeries} The receiver.
     */

    var arr,
        i,
        len;

    //  Call the supertype method to make sure to get the proper signals
    //  sent.
    //  NOTE: This may have other implications around signaling things like
    //  'TP.sig.RequestFailed' / 'TP.sig.RequestSucceeded' before we run the
    //  hooks.

    this.callNextMethod();

    this.setSignalName(this.getTypeName());

    //  run failure hooks, if any...
    if (TP.isArray(arr = this.get('failureHooks'))) {
        len = arr.getSize();
        for (i = 0; i < len; i++) {
            try {
                arr.at(i)(this, aFaultString, aFaultCode, aFaultInfo);
            } catch (e) {
                TP.ifError() ?
                    TP.error(TP.ec(e, 'Error running failure hook.')) : 0;
            }
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.UserInputSeries.Inst.defineMethod('addCancelHook',
function(aFunction) {

    /**
     * @method addCancelHook
     * @summary Adds a function to run at cancellation. There can be multiple
     *     functions added via this method, and they will be executed in the
     *     order they were added.
     * @param {Function} aFunction A function to run if the request is
     *     cancelled.
     * @returns {TP.sig.UserInputSeries}
     */

    var arr;

    if (!TP.isCallable(aFunction)) {
        return this.raise('TP.sig.InvalidFunction');
    }

    if (TP.notValid(arr = this.get('cancelHooks'))) {
        arr = TP.ac();
        this.$set('cancelHooks', arr);
    }

    arr.add(aFunction);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.UserInputSeries.Inst.defineMethod('addFailureHook',
function(aFunction) {

    /**
     * @method addFailureHook
     * @summary Adds a function to run on failure. There can be multiple
     *     functions added via this method, and they will be executed in the
     *     order they were added.
     * @param {Function} aFunction A function to run if the request ends in
     *     failure.
     * @returns {TP.sig.UserInputSeries}
     */

    var arr;

    if (!TP.isCallable(aFunction)) {
        return this.raise('TP.sig.InvalidFunction');
    }

    if (TP.notValid(arr = this.get('failureHooks'))) {
        arr = TP.ac();
        this.$set('failureHooks', arr);
    }

    arr.add(aFunction);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.UserInputSeries.Inst.defineMethod('addQuery',
function(aParamHash) {

    /**
     * @method addQuery
     * @summary Adds a query, optional default value, and optional validator to
     *     the list of queries this request should manage.
     * @param {TP.core.Hash} aParamHash A hash containing optional parameter
     *     keys including: 'query': A string or function which can generate a
     *     string used as the query string. 'count': The number of times this
     *     validator should be attempted before failing. Default is 3.
     *     'default': The default value for the query, or a function which can
     *     generate it at runtime. 'hideInput': Should input be hidden, i.e. is
     *     this a password field etc? Defaults to false. 'retryPrompt': A string
     *     to show when the input isn't valid. Default is 'Retry?' 'validator':
     *     A function which should return true if the user's response is valid.
     * @returns {TP.sig.UserInputSeries}
     */

    var arr,
        params;

    params = aParamHash || TP.hc();

    //  note we put the entries into an array inside the list so we
    //  can access them later via index constants
    arr = TP.ac();
    arr.atPut(this.getType().get('QUERY_INDEX'), params.at('query'));
    arr.atPut(this.getType().get('DEFAULT_INDEX'),
                    params.at('default'));
    arr.atPut(this.getType().get('PASSWORD_INDEX'),
                    params.atIfInvalid('hideInput', false));
    arr.atPut(this.getType().get('RETRY_INDEX'),
                    params.atIfInvalid('retryPrompt', 'Retry?'));
    arr.atPut(this.getType().get('VALIDATOR_INDEX'),
                    params.atIfInvalid('validator', TP.isValid));
    arr.atPut(this.getType().get('COUNT_INDEX'),
                    params.atIfInvalid('count', 3));

    this.get('queries').add(arr);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.UserInputSeries.Inst.defineMethod('addSuccessHook',
function(aFunction) {

    /**
     * @method addSuccessHook
     * @summary Adds a function to run on success. There can be multiple
     *     functions added via this method, and they will be executed in the
     *     order they were added.
     * @param {Function} aFunction A function to run if the request completes
     *     successfully.
     * @returns {TP.sig.UserInputSeries}
     */

    var arr;

    if (!TP.isCallable(aFunction)) {
        return this.raise('TP.sig.InvalidFunction');
    }

    if (TP.notValid(arr = this.get('successHooks'))) {
        arr = TP.ac();
        this.$set('successHooks', arr);
    }

    arr.add(aFunction);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.UserInputSeries.Inst.defineMethod('cancelJob',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method cancelJob
     * @summary Tells the request/response to cancel, meaning the request is
     *     being rescinded by the user or calling process. If the receiver has
     *     specific behavior to implement it can be added via addCancelHook()
     *     calls. Note that the status is TP.CANCELLING during any processing
     *     and TP.CANCELLED after.
     * @param {String} aFaultString Description of the error.
     * @param {Object} aFaultCode A code providing additional information on the
     *     reason for the cancellation.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the cancellation.
     * @returns {TP.sig.UserInputSeries} The receiver.
     */

    var arr,
        i,
        len;

    //  Call the supertype method to make sure to get the proper signals
    //  sent.
    //  NOTE: This may have other implications around signaling things like
    //  'TP.sig.RequestCancelled' / 'TP.sig.RequestSucceeded' before we run
    //  the hooks.

    this.callNextMethod();

    this.setSignalName(this.getTypeName());

    //  run any cancellation hooks...
    if (TP.isArray(arr = this.get('cancelHooks'))) {
        len = arr.getSize();
        for (i = 0; i < len; i++) {
            try {
                arr.at(i)(this, aFaultString, aFaultCode, aFaultInfo);
            } catch (e) {
                TP.ifError() ?
                    TP.error(TP.ec(e, 'Error running cancellation hook.')) : 0;
            }
        }
    }

    //  now that hooks have run, reset any parameters they might have wanted
    //  to their 'cancelled' states
    this.$set('queryIndex', Number.POSITIVE_INFINITY);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.UserInputSeries.Inst.defineMethod('completeJob',
function(aResult) {

    /**
     * @method completeJob
     * @summary Tells the request/response to complete, meaning the receiver
     *     should do whatever finalization is necessary to reach the
     *     TP.SUCCEEDED state. If the receiver has specific behavior to
     *     implement it can be added via addSuccessHook() calls. Note that the
     *     status is TP.COMPLETING during any processing and TP.SUCCEEDED after
     *     processing is done.
     * @returns {TP.sig.UserInputSeries} The receiver.
     */

    var arr,
        i,
        len;

    //  Call the supertype method to make sure to get the proper signals
    //  sent.
    //  NOTE: This may have other implications around signaling things like
    //  'TP.sig.RequestCompleted' / 'TP.sig.RequestSucceeded' before we run
    //  the hooks.

    this.callNextMethod();

    this.setSignalName(this.getTypeName());

    //  run completion hooks, if any...
    if (TP.isArray(arr = this.get('successHooks'))) {
        len = arr.getSize();
        for (i = 0; i < len; i++) {
            try {
                arr.at(i)(this);
            } catch (e) {
                TP.ifError() ?
                    TP.error(TP.ec(e, 'Error running success hook.')) : 0;
            }
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.UserInputSeries.Inst.defineMethod('fire',
function(anOrigin, aPayload, aPolicy) {

    /**
     * @method fire
     * @summary Starts the request processing sequence, resetting the query
     *     index of the receiver to the beginning of the series.
     * @param {Object} anOrigin An optional firing origin for this activation.
     * @param {Object} aPayload Optional signal arguments.
     * @param {Function} aPolicy A firing policy function.
     * @returns {TP.sig.UserInputSeries} The receiver.
     */

    var arr,
        qry,
        def,
        pass;

    //  reset to default state, TP.READY, with attributes/parameters cleared
    this.reset();

    //  track the origin so we can pass it to the various hook functions
    this.set('origin', TP.ifInvalid(this.getRequestID(), anOrigin));

    //  reset our query index to the starting point
    this.$set('queryIndex', 0);

    //  clear our retry count so we run the proper number of times
    this.$set('retries', 0);

    //  clear the response list so we capture the new data cleanly
    this.get('replies').empty();

    //  get the first query configuration
    arr = this.get('queries').at(0);
    if (TP.notValid(arr)) {
        TP.ifWarn() ?
            TP.warn('No queries for TP.sig.UserInputSeries.') : 0;

        return this;
    }

    //  set up our state for the request
    qry = arr.at(this.getType().get('QUERY_INDEX'));
    def = arr.at(this.getType().get('DEFAULT_INDEX'));

    //  cover whether this query's response should be hidden
    if (TP.isTrue(pass = arr.at(this.getType().get('PASSWORD_INDEX')))) {
        this.atPut('password', true);
    } else {
        this.atPut('password', false);
    }

    //  note we can generate the prompt and default using runtime data :)
    try {
        this.atPut('query', TP.isCallable(qry) ?
                    qry(this.getLastReply(), this).asString() : qry);
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'Error executing query generator.')) : 0;

        this.atPut('query', qry);
    }

    if (TP.isFalse(pass)) {
        try {
            this.atPut('default', TP.isCallable(def) ?
                    def(this.getLastReply(), this).asString() : def);
        } catch (e) {
            TP.ifError() ?
                TP.error(TP.ec(e, 'Error executing default generator.')) : 0;

            this.atPut('default', def);
        }
    }

    //  let the standard processing handle the rest
    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.sig.UserInputSeries.Inst.defineMethod('getLastReply',
function() {

    /**
     * @method getLastReply
     * @summary Returns the last response string acquired by the receiver.
     * @returns {String} The last user response.
     */

    return this.get('replies').last();
});

//  ------------------------------------------------------------------------

TP.sig.UserInputSeries.Inst.defineMethod('getReplies',
function() {

    /**
     * @method getReplies
     * @summary Returns the array of current replies to the receiver's queries.
     * @returns {String[]} The list of response strings acquired so far.
     */

    return this.$get('replies');
});

//  ------------------------------------------------------------------------

TP.sig.UserInputSeries.Inst.defineMethod('getUor',
function() {

    /**
     * @method getUor
     * @summary Returns a shared TP.sig.UserOutputRequest instance which can be
     *     used to provide output such as error messages during user input
     *     processing of the series.
     * @returns {TP.sig.UserOutputRequest} An instance of an output request.
     */

    var uor;

    uor = this.$get('uor');
    if (TP.notValid(uor)) {
        uor = TP.sig.UserOutputRequest.construct();
        this.$set('uor', uor);
    }

    return uor;
});

//  ------------------------------------------------------------------------

TP.sig.UserInputSeries.Inst.defineHandler('UserInput',
function(aSignal) {

    /**
     * @method handleUserInput
     * @summary Responds to TP.sig.UserInput signals, which are sent in
     *     response to the receiver (a TP.sig.UserInputRequest). By managing
     *     completion status here the request can continue to remain active, or
     *     it can complete.
     * @param {TP.sig.UserInput} aSignal The signal instance that triggered this
     *     handler.
     * @returns {TP.sig.UserInputSeries} The receiver.
     */

    var pass,
        qry,
        def,
        arr,
        ndx,
        uor,
        func,
        valid,
        res,
        err,
        count,
        responder;

    if (aSignal.get('statusCode') === TP.CANCELLED) {
        this.cancel();
        return this;
    }

    //  capture the user's input for validation purposes
    res = aSignal.getResult();

    responder = this.get('responder');

    //  track input from all requests
    this.get('replies').atPut(this.get('queryIndex'), res);

    //  if there's no query at the current index it's because we're done...
    arr = this.get('queries').at(this.get('queryIndex'));
    if (TP.isEmpty(arr)) {
        this.complete();
        return this;
    }

    //  set up to have our retry count limited as defined
    count = TP.ifInvalid(arr.at(this.getType().get('COUNT_INDEX')),
                                this.get('retryMax'));
    count = count.min(this.get('retryMax'));

    //  if there's a validator run it and deal with any errors by
    //  resetting the receiver and keeping it ACTIVE
    func = arr.at(this.getType().get('VALIDATOR_INDEX'));
    if (TP.isCallable(func)) {
        try {
            valid = func(res, this);
        } catch (e) {
            TP.ifError() ?
                TP.error(TP.ec(e, 'Error executing validator.')) : 0;

            valid = false;
        }

        if (!valid) {
            this.set('retries', this.get('retries') + 1);

            uor = this.get('uor');

            //  deal with retry count updates
            if (this.get('retries') > count) {
                uor.atPut('output',
                                'Aborting.... Retry limit reached.');
                uor.atPut('messageType', 'failure');

                uor.fire(this.get('origin'));

                this.fail();

                return this;
            }

            err = arr.at(this.getType().get('RETRY_INDEX'));
            if (TP.notValid(err)) {
                err = 'Invalid input. Please retry.';
            }

            uor.atPut('output',
                    TP.$DEBUG && TP.$VERBOSE ?
                        'Invalid input. Validator is: ' + func :
                        err);

            uor.atPut('messageType', 'failure');

            uor.fire(this.get('origin'));

            //  make their initial nput the default value and retry
            this.reset();
            this.isActive(true);
            this.atPut('default', res);

            this.setSignalName('TP.sig.RequestModified');
            TP.handle(responder, this);

            return this;
        }
    }

    //  update our query index to show we've completed the current query
    ndx = this.get('queryIndex') + 1;
    this.$set('queryIndex', ndx);

    //  having handled this query are we done now?
    if (TP.notValid(arr = this.get('queries').at(ndx))) {
        this.complete();
        return this;
    }

    //  clear existing data in the signal regarding request/response info
    this.reset();
    this.isActive(true);

    //  cover whether this query's response should be hidden
    if (TP.isTrue(pass = arr.at(this.getType().get('PASSWORD_INDEX')))) {
        this.atPut('password', true);
    } else {
        this.atPut('password', false);
    }

    //  set up for the new query
    //  note we can generate the prompt and default using runtime data :)
    qry = arr.at(this.getType().get('QUERY_INDEX'));
    def = arr.at(this.getType().get('DEFAULT_INDEX'));

    try {
        this.atPut('query', TP.isCallable(qry) ?
                    qry(this.getLastReply(), this).asString() : qry);
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'Error executing query generator.')) : 0;

        this.atPut('query', qry);
    }

    if (TP.isFalse(pass)) {
        try {
            this.atPut('default', TP.isCallable(def) ?
                    def(this.getLastReply(), this).asString() : def);
        } catch (e) {
            TP.ifError() ?
                TP.error(TP.ec(e, 'Error executing default generator.')) : 0;

            this.atPut('default', def);
        }
    }

    this.setSignalName('TP.sig.RequestModified');
    TP.handle(responder, this);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.UserInputSeries.Inst.defineMethod('reset',
function() {

    /**
     * @method reset
     * @summary Prepares the receiver to be re-fired, leaving certain values in
     *     place to retain continuity.
     * @returns {TP.sig.UserInputSeries} The receiver.
     */

    //  NOTE:   we don't clear origin in particular so that any hook
    //          functions we invoke can continue to access it for proper
    //          output targeting

    this.setSignalName(this.getTypeName());

    this.$set('response', null, false);
    this.$set('statusCode', TP.READY, false);

    this.atPut('messageType', 'prompt', false);

    this.atPut('query', null, false);
    this.atPut('default', null, false);
    this.atPut('password', null, false);

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/workflow/TP.sig.UserOutputRequest.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'workflow';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @type {TP.sig.UserOutputRequest}
 * @summary The primary type used to provide output to the user. In response to
 *     requests of this type the console will look up a template and use it to
 *     format output for display.
 */

//  ------------------------------------------------------------------------

TP.sig.UserIORequest.defineSubtype('UserOutputRequest');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.sig.UserOutputRequest.Type.defineAttribute('responseType', 'TP.sig.UserOutput');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  what type of message? help, request, success, error, etc.
TP.sig.UserOutputRequest.Inst.defineAttribute('messageType', 'message');

//  the node used to display the output for this request
TP.sig.UserOutputRequest.Inst.defineAttribute('outputNode');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.UserOutputRequest.Inst.defineMethod('getOutputNode',
function() {

    /**
     * @method getOutputNode
     * @summary Returns the output node used to display output for this
     *     request. Requestors can leverage this to get a handle to the actual
     *     output cell without having direct knowledge of the console used to
     *     perform the output itself.
     * @returns {Node}
     */

    return this.$get('outputNode');
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/workflow/TP.sig.SignalCoalescer.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'workflow';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.sig.SignalCoalescer}
 * @summary An object whose goal is to coalesce a set of signals into a single
 *     new signal. These operations form the cornerstone of using events as
 *     triggers in a Petri-net style workflow model.
 * @description When designing with events it quickly becomes necessary to
 *     support ways of blending or coalescing a set of events into a new, more
 *     semantically-interesting event. Examples are points in workflow where an
 *     Or-Join or And-Join occur and a new signal defining the transition from
 *     'waiting' to 'moving forward' is fired. Another simple example is a
 *     "gesture" made from combining multiple mouse/keyboard events such as a
 *     "grab" operation which may require a mouse down and 2 or more mouse move
 *     operations.
 *
 *     A signal coalescer leverages three key concepts: triggers, spoilers, and
 *     notifiers. Triggers are the signals a coalescer is watching for, spoilers
 *     are events which cause the coalescer to reset, and the notifier is the
 *     signal that will be sent when the receiver "hasCoalesced", meaning it has
 *     received the triggers in the order/number necessary to meet its criteria
 *     without seeing any spoilers along the way.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('sig.SignalCoalescer');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.sig.SignalCoalescer.Type.defineConstant('ORIGIN_INDEX', 0);
TP.sig.SignalCoalescer.Type.defineConstant('SIGNAL_INDEX', 1);
TP.sig.SignalCoalescer.Type.defineConstant('COUNT_INDEX', 2);
TP.sig.SignalCoalescer.Type.defineConstant('SEEN_INDEX', 3);
TP.sig.SignalCoalescer.Type.defineConstant('ORDER_INDEX', 4);

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  should the instance automatically reset observation counts on success?
TP.sig.SignalCoalescer.Inst.defineAttribute('autoReset', true);

//  the container for our triggers and observations
TP.sig.SignalCoalescer.Inst.defineAttribute('triggers');

//  the container for any spoilers, signals which reset the observations
TP.sig.SignalCoalescer.Inst.defineAttribute('spoilers');

//  what signal should we send out when we 'coalesce'?
TP.sig.SignalCoalescer.Inst.defineAttribute('notifier');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.SignalCoalescer.Inst.defineMethod('init',
function(aSignalName) {

    /**
     * @method init
     * @summary Initializes a new instance for use. The signal name provided is
     *     the signal which will be fired when the receiver coalesces. This
     *     value defaults to the receiver's type name.
     * @param {String} aSignalName The signal type name the instance should
     *     signal when it coalesces. Default is the receiver's type name.
     * @returns {TP.sig.SignalCoalescer} The new instance.
     */

    this.callNextMethod();

    this.$set('triggers', TP.hc());
    this.$set('spoilers', TP.hc());
    this.$set('notifier', aSignalName || this.getTypeName());

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.SignalCoalescer.Inst.defineMethod('addSpoiler',
function(anOrigin, aSignal, aCount, aPolicy) {

    /**
     * @method addSpoiler
     * @summary Adds a spoiler observation to the receiver. Each spoiler is
     *     tracked by origin/signal key along with a count. The order of the
     *     spoilers may matter to certain subtypes. By default each spoiler only
     *     needs to appear once for it to reset the receiver's coalescing
     *     process.
     * @param {String} anOrigin What origin is being observed?
     * @param {String} aSignal What signal is being observed?
     * @param {Number} aCount How many instances of this spoiler are required to
     *     cause a reset?
     * @param {Function} aPolicy A registration policy. Using this you can
     *     define capture vs. bubble observations.
     * @returns {TP.sig.SignalCoalescer} The receiver.
     */

    var item,
        count,
        spoilers;

    //  make sure we get a default count
    count = TP.ifInvalid(aCount, 1);

    spoilers = this.get('spoilers');

    //  if we've already done an observe don't do another, increment our
    //  expected count for the spoiler
    item = spoilers.at(this.computeSignalID(anOrigin, aSignal));
    if (TP.isValid(item)) {
        item.atPut(TP.sig.SignalCoalescer.COUNT_INDEX,
                    item.at(TP.sig.SignalCoalescer.COUNT_INDEX) + count);
        return this;
    }

    //  looks like a new one...put an array in place containing our spoiler
    //  data along with the required count and a current count of 0. This
    //  will get incremented when we see new signals
    spoilers.atPut(this.computeSignalID(anOrigin, aSignal),
                    TP.ac(anOrigin, aSignal, count, 0, spoilers.getSize()));

    //  the policy allows us to specify if the observation should be
    //  capturing etc.
    this.observe(anOrigin, aSignal, this, aPolicy);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.SignalCoalescer.Inst.defineMethod('addTrigger',
function(anOrigin, aSignal, aCount, aPolicy) {

    /**
     * @method addTrigger
     * @summary Adds a trigger observation to the receiver. Each trigger is
     *     tracked by origin/signal key along with a count. The order of the
     *     triggers may matter to certain subtypes. By default each trigger only
     *     needs to appear once for it to contribute to the receiver's concept
     *     of coalescing.
     * @param {String} anOrigin What origin is being observed?
     * @param {String} aSignal What signal is being observed?
     * @param {Number} aCount How many instances of this trigger are required to
     *     cause notification?
     * @param {Function} aPolicy A registration policy. Using this you can
     *     define capture vs. bubble observations.
     * @returns {TP.sig.SignalCoalescer} The receiver.
     */

    var item,
        count,
        triggers;

    //  make sure we get a default count
    count = TP.ifInvalid(aCount, 1);

    triggers = this.get('triggers');

    //  if we've already done an observe don't do another, increment our
    //  expected count for the trigger
    item = triggers.at(this.computeSignalID(anOrigin, aSignal));
    if (TP.isValid(item)) {
        item.atPut(TP.sig.SignalCoalescer.COUNT_INDEX,
                    item.at(TP.sig.SignalCoalescer.COUNT_INDEX) + count);
        return this;
    }

    //  looks like a new one...put an array in place containing our trigger
    //  data along with the required count and a current count of 0. This
    //  will get incremented when we see new signals
    triggers.atPut(this.computeSignalID(anOrigin, aSignal),
                    TP.ac(anOrigin, aSignal, count, 0, triggers.getSize()));

    //  the policy allows us to specify if the observation should be
    //  capturing etc.
    this.observe(anOrigin, aSignal, this, aPolicy);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.SignalCoalescer.Inst.defineMethod('computeSignalID',
function(anOrigin, aSignal) {

    /**
     * @method computeSignalID
     * @summary Returns a string computed from the two parameters provided. The
     *     resulting ID is used as a key for trigger storage.
     * @param {String} anOrigin What origin is being observed?
     * @param {String} aSignal What signal is being observed?
     * @returns {String} The trigger ID.
     */

    var oKey,
        sKey;

    oKey = TP.notValid(anOrigin) ? TP.ANY : TP.id(anOrigin);
    sKey = TP.notValid(aSignal) ? TP.ANY : aSignal.getSignalName();

    return oKey + '.' + sKey;
});

//  ------------------------------------------------------------------------

TP.sig.SignalCoalescer.Inst.defineHandler('Signal',
function(aSignal) {

    /**
     * @method handleSignal
     * @summary Responds to signal notifications which drive the receiver by
     *     updating the receiver's trigger observation counts.
     * @description To support the semantics that are implied by using null, or
     *     TP.ANY for an origin in the observation phase this method will
     *     actually count an incoming signal both against a specific origin and
     *     against an undifferentiated origin, meaning that signals may be
     *     counted twice when using both specific origins and global
     *     observations in the same signal coalescer.
     * @param {TP.sig.Signal} aSignal The specific signal instance.
     * @returns {TP.sig.SignalCoalescer} The receiver.
     */

    var origin,
        id,
        item;

    //  we start with the original origin, which won't typically be ANY
    origin = aSignal.getOrigin();
    id = this.computeSignalID(origin, aSignal);

    item = this.get('triggers').at(id);
    if (TP.isValid(item)) {
        //  increment the observed count for this trigger
        item.atPut(TP.sig.SignalCoalescer.SEEN_INDEX,
                    item.at(TP.sig.SignalCoalescer.SEEN_INDEX) + 1);

        //  if the item causes us to 'coalesce' then we'll notify
        this.hasCoalesced(item);
    }

    //  when the origin wasn't ANY we'll simulate it now so that we can
    //  count triggers for "global" observations as well
    if (origin !== TP.ANY) {
        origin = TP.ANY;
        id = this.computeSignalID(origin, aSignal);

        item = this.get('triggers').at(id);
        if (TP.isValid(item)) {
            //  increment the observed count for this trigger
            item.atPut(TP.sig.SignalCoalescer.SEEN_INDEX,
                    item.at(TP.sig.SignalCoalescer.SEEN_INDEX) + 1);
        }
    }

    //  if the item causes us to 'coalesce' then we'll notify
    if (this.hasCoalesced(item)) {
        this.signal(this.get('notifier'));

        //  should we clear our observations after signaling?
        if (this.shouldAutoReset()) {
            this.resetObservations();
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.SignalCoalescer.Inst.defineMethod('hasCoalesced',
function(anItem) {

    /**
     * @method hasCoalesced
     * @summary Returns true if the receiver has reached a coalescing point. If
     *     true the handleSignal method will perform notification.
     * @param {Object[]} anItem A 'trigger' array. Used primarily to optimize for
     *     Or-Join scenarios.
     * @exception SubtypeResponsibility
     * @returns {Boolean} True if the receiver should signal it's notifier.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.sig.SignalCoalescer.Inst.defineMethod('resetObservations',
function() {

    /**
     * @method resetObservations
     * @summary Clears any counts of observed signals.
     * @returns {TP.sig.SignalCoalescer} The receiver.
     */

    //  triggers is a hash, so we want to manipulate the values which are
    //  our observation array
    this.get('triggers').perform(
        function(item) {
            item.last().atPut(TP.sig.SignalCoalescer.SEEN_INDEX, 0);
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.SignalCoalescer.Inst.defineMethod('setNotifier',
function(aSignalName) {

    /**
     * @method setNotifier
     * @summary Sets the notification signal that will be sent when the
     *     receiver coalesces.
     * @param {String} aSignalName The signal name to use.
     * @returns {TP.sig.SignalCoalescer} The receiver.
     */

    if (TP.notValid(aSignalName)) {
        return this.raise('TP.sig.InvalidSignal');
    }

    this.$set('notifier', aSignalName);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.SignalCoalescer.Inst.defineMethod('shouldAutoReset',
function(aFlag) {

    /**
     * @method shouldAutoReset
     * @summary Sets/gets the value for the auto-reset flag.
     * @param {Boolean} aFlag The setting for auto-reset.
     * @returns {Boolean}
     */

    if (TP.isDefined(aFlag)) {
        //  NOTE:   we use false here to avoid having any form of signal
        //          sent out which might confuse observers
        this.set('autoReset', aFlag, false);
    }

    return this.get('autoReset');
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/workflow/TP.sig.OrJoin.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'workflow';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.sig.OrJoin}
 * @summary An 'or-join' is a coalescer which will notify when any one of its
 *     configured notifiers is seen. When counts are involved an or-join can be
 *     spoiled by seeing a spoiler prior to reaching the target count for one of
 *     its triggers.
 */

//  ------------------------------------------------------------------------

TP.sig.SignalCoalescer.defineSubtype('OrJoin');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.OrJoin.Inst.defineMethod('hasCoalesced',
function(anItem) {

    /**
     * @method hasCoalesced
     * @summary Returns true if the receiver has reached a coalescing point. If
     *     true the handleSignal method will perform notification.
     * @param {Object[]} anItem A 'trigger' array. Used primarily to optimize for
     *     Or-Join scenarios.
     * @returns {Boolean} True if the receiver should signal it's notifier.
     */

    //  seen the proper count? then yes, at least one trigger qualification
    //  has been met
    return anItem.at(TP.sig.SignalCoalescer.SEEN_INDEX) ===
            anItem.at(TP.sig.SignalCoalescer.COUNT_INDEX);
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/workflow/TP.sig.AndJoin.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'workflow';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.sig.AndJoin}
 * @summary An 'and-join' is a coalescer which notifies when a specific
 *     combination of triggers has been witnessed. The order of the triggers can
 *     matter, as can the count. Spoilers seen before the entire triggering
 *     sequence has been observed will typically reset the coalescer so it
 *     starts over in attempting to coalesce.
 */

//  ------------------------------------------------------------------------

TP.sig.SignalCoalescer.defineSubtype('AndJoin');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  defines whether the triggering data was provided in order and whether
//  notification should only happen if observations happen in that order
TP.sig.AndJoin.Inst.defineAttribute('orderMatters', false);

//  defines whether 'extra' notifications of a particular trigger are
//  allowed. If not then any extra signal seen before all triggers are seen
//  will cause a failure/reset.
TP.sig.AndJoin.Inst.defineAttribute('allowOverflow', true);

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.AndJoin.Inst.defineMethod('hasCoalesced',
function(anItem) {

    /**
     * @method hasCoalesced
     * @summary Returns true if the receiver has reached a coalescing point. If
     *     true the handleSignal method will perform notification.
     * @param {Object[]} anItem A 'trigger' array. Used primarily to optimize for
     *     Or-Join scenarios.
     * @returns {Boolean} True if the receiver should signal it's notifier.
     */

    var triggers,
        item,
        keys,
        vals,
        id,
        i,
        ndx,
        len;

    triggers = this.get('triggers');

    //  if observations have to occur in order things are much more complex
    if (this.shouldOrderMatter()) {
        //  TODO: DANGEROUS, relies on hash keeping keys in order, which
        //  TP.core.Hash does but it isn't really a solid guarantee
        keys = TP.keys(triggers);

        id = this.computeSignalID(anItem.at(TP.sig.SignalCoalescer.ORIGIN_INDEX),
                                anItem.at(TP.sig.SignalCoalescer.SIGNAL_INDEX));

        //  if order matters then the rule is simple, there can't be any
        //  triggers 'in front' of us that aren't full. if there are any
        //  that aren't full then this signal is out of order and we reset
        ndx = keys.getPosition(id);
        if (TP.notValid(ndx)) {
            //  oops! didn't find our index!
            this.raise('TP.sig.InvalidTriggerID');
            return false;
        }

        //  loop across each entry, verifying it conforms to requirements
        for (i = 0; i < ndx; i++) {
            item = triggers.at(keys.at(i));

            //  if we're not allowed to overflow but the item did we reset
            if (!this.shouldAllowOverflow()) {
                if (item.at(TP.sig.SignalCoalescer.SEEN_INDEX) >
                    item.at(TP.sig.SignalCoalescer.COUNT_INDEX)) {
                    this.resetObservations();
                    return false;
                }
            }

            //  if the count for this item isn't accurate and we're not to
            //  the new item yet then we're out of order...prior slots
            //  aren't "complete" before we saw the new trigger
            if (item.at(TP.sig.SignalCoalescer.SEEN_INDEX) !==
                item.at(TP.sig.SignalCoalescer.COUNT_INDEX)) {
                this.resetObservations();
                return false;
            }
        }

        //  passed the first test...question is, are we done?
        if (keys.last() === id) {
            //  we're last...that's a start...are the counts equal?
            return item.at(TP.sig.SignalCoalescer.SEEN_INDEX) ===
                    item.at(TP.sig.SignalCoalescer.COUNT_INDEX);
        } else {
            return false;
        }
    } else {
        //  order doesn't matter...whew...

        //  reset condition here would be the new item overflowing
        if (!this.shouldAllowOverflow()) {
            if (item.at(TP.sig.SignalCoalescer.SEEN_INDEX) >
                item.at(TP.sig.SignalCoalescer.COUNT_INDEX)) {
                this.resetObservations();
                return false;
            }
        }

        //  only question left is are we all matched up?
        vals = triggers.getValues();
        len = vals.getSize();
        for (i = 0; i < len; i++) {
            item = vals.at(i);
            if (item.at(TP.sig.SignalCoalescer.SEEN_INDEX) !==
                item.at(TP.sig.SignalCoalescer.COUNT_INDEX)) {
                return false;
            }
        }

        return true;
    }
});

//  ------------------------------------------------------------------------

TP.sig.AndJoin.Inst.defineMethod('shouldAllowOverflow',
function(aFlag) {

    /**
     * @method shouldAllowOverflow
     * @summary Sets/gets the value for the allow-overflow flag. If this flag
     *     is true the receiver will allow extra notifications to occur.
     * @param {Boolean} aFlag
     * @returns {Boolean}
     */

    if (TP.isDefined(aFlag)) {
        //  NOTE:   we use false here to avoid having any form of signal
        //          sent out which might confuse observers
        this.$set('allowOverflow', aFlag, false);
    }

    return this.$get('allowOverflow');
});

//  ------------------------------------------------------------------------

TP.sig.AndJoin.Inst.defineMethod('shouldOrderMatter',
function(aFlag) {

    /**
     * @method shouldOrderMatter
     * @summary Sets/gets the value for the order-matters flag. If this flag is
     *     true the receiver will require notifications to happen in the same
     *     order they are registered.
     * @param {Boolean} aFlag
     * @returns {Boolean}
     */

    if (TP.isDefined(aFlag)) {
        //  NOTE:   we use false here to avoid having any form of signal
        //          sent out which might confuse observers
        this.$set('orderMatters', aFlag, false);
    }

    return this.$get('orderMatters');
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/workflow/TP.sig.RequestCoalescer.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'workflow';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.sig.RequestCoalescer}
 * @summary An object designed to help with management of multiple
 *     TP.sig.Request objects, treating them as a single request in terms of
 *     state. The coalescer will fire RequestCompleted only upon completion of
 *     all of its component requests.
 */

//  ------------------------------------------------------------------------

TP.sig.AndJoin.defineSubtype('RequestCoalescer');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.RequestCoalescer.Inst.defineMethod('addRequest',
function(aRequest) {

    /**
     * @method addRequest
     * @summary Adds a request as a trigger for the receiver. This method is a
     *     convenience wrapper for the appropriate addTrigger call using the
     *     various properties of the request. The signal observed in this case
     *     is RequestCompleted.
     * @param {TP.sig.Request} aRequest A new request to observe.
     * @exception TP.sig.InvalidRequest
     * @returns {TP.sig.RequestCoalescer} The receiver.
     */

    if (TP.notValid(aRequest)) {
        return this.raise('TP.sig.InvalidRequest');
    }

    this.addTrigger(aRequest.getRequestID(), 'TP.sig.RequestCompleted');

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/shells/TP.sig.ShellResponse.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'shells';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @type {TP.sig.ShellResponse}
 * @summary The common response type for TP.sig.ShellRequest instances. These
 *     responses provide the shell's response to incoming requests and are the
 *     common response mechanism between a shell requestor and the shell.
 */

//  ------------------------------------------------------------------------

TP.sig.Response.defineSubtype('ShellResponse');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  what type of message? help, request, success, error, etc.
TP.sig.ShellResponse.Inst.defineAttribute('messageType', 'response');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.sig.ShellResponse.Type.defineMethod('shouldLog',
function() {

    /**
     * @method shouldLog
     * @summary Returns true when the signal can be logged during signal
     *     processing. The default is true for most signals, but this type of
     *     signal checks the 'shouldLogTSHSignals' TIBET configuration flags to
     *     see if it can currently be logged.
     * @returns {Boolean} True if the signal can be logged.
     */

    return TP.sys.shouldLogTSHSignals();
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.ShellResponse.Inst.defineMethod('init',
function(aRequest, aResult) {

    /**
     * @method init
     * @summary Initialize a new instance. The request should be the original
     *     TP.sig.Request instance while the optional result is whatever data
     *     should be assigned to the request as the result.
     * @param {TP.sig.Request} aRequest A request object. In the case of
     *     TP.sig.Response instances the request object provided here must be a
     *     TP.sig.Request instance, not one of the more loosely typed "request
     *     hash" types used by other request-oriented methods.
     * @param {Object} aResult A result object.
     * @returns {TP.sig.Response} A new instance.
     */

    this.$set('result', undefined, false, true);

    switch (arguments.length) {
        case 0:
            return this.callNextMethod();
        case 1:
            return this.callNextMethod(aRequest);
        case 2:
            return this.callNextMethod(aRequest, aResult);
        default:
            return this.callNextMethod.apply(this, arguments);
    }
});

//  ------------------------------------------------------------------------

TP.sig.ShellResponse.Inst.defineMethod('getMessageType',
function() {

    /**
     * @method getMessageType
     * @summary Returns the message type, one of a number of values which map
     *     directly to CSS entries and node templates used to provided
     *     theme-able output.
     * @returns {String}
     */

    var val;

    if (TP.isValid(val = this.at('messageType'))) {
        return val;
    }

    return this.$get('messageType');
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/shells/TP.sig.ShellRequest.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'shells';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @type {TP.sig.ShellRequest}
 * @summary The primary type used to make requests of the shell. These requests
 *     can be made with or without a console to get shell processing to occur.
 *     This allows any object in the system to leverage the processing power of
 *     the shell without requiring a console UI.
 */

//  ------------------------------------------------------------------------

TP.sig.Request.defineSubtype('ShellRequest');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.sig.ShellRequest.Type.defineAttribute('responseType',
                                        'TP.sig.ShellResponse');

TP.sig.ShellRequest.Type.defineAttribute('tableName', 'history');

TP.sig.ShellRequest.Type.defineAttribute('defaultPolicy', TP.FIRE_ONE);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.sig.ShellRequest.Type.defineMethod('construct',
function(aPayload) {

    /**
     * @method construct
     * @summary Constructs a new instance of the receiver, ensuring it is
     *     properly configured for use.
     * @param {String|TP.core.Hash|TP.sig.Request} aPayload A string, hash, or
     *     other request whose value(s) will populate this new request.
     * @returns {TP.sig.ShellRequest|undefined} A new instance.
     */

    var payload;

    //  goal here is to unpackage other request payloads so we always
    //  construct a proper TP.sig.ShellRequest that can provide input to the
    //  shells
    if (TP.isString(aPayload)) {
        //  'cmd' become the command text, all other parameters default
        payload = TP.hc('cmd', aPayload);
    } else if (TP.canInvoke(aPayload, 'getPayload')) {
        //  other requests have their payloads extracted and reused
        payload = aPayload.getPayload();
    } else if (TP.canInvokeInterface(aPayload, TP.ac('at', 'atPut'))) {
        //  dictionaries are used as is
        payload = aPayload;
    } else {
        //  nothing else is valid
        this.raise('TP.sig.InvalidParameter');

        return;
    }

    return this.callNextMethod(payload);
});

//  ------------------------------------------------------------------------

TP.sig.ShellRequest.Type.defineMethod('shouldLog',
function() {

    /**
     * @method shouldLog
     * @summary Returns true when the signal can be logged during signal
     *     processing. The default is true for most signals, but this type of
     *     signal checks the 'shouldLogTSHSignals' TIBET configuration flags to
     *     see if it can currently be logged.
     * @returns {Boolean} True if the signal can be logged.
     */

    return TP.sys.shouldLogTSHSignals();
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  placeholder for command arguments
TP.sig.ShellRequest.Inst.defineAttribute('ARGUMENTS');
TP.sig.ShellRequest.Inst.defineAttribute('PARAMS');

//  what type of message? log, help, request, success, error, etc.
TP.sig.ShellRequest.Inst.defineAttribute('messageType', 'query');

//  the message itself.
TP.sig.ShellRequest.Inst.defineAttribute('message');

//  the subrequests used to process this request, if any.
TP.sig.ShellRequest.Inst.defineAttribute('subrequests');

//  timing variables used to track processing overhead
TP.sig.ShellRequest.Inst.defineAttribute('$timestart');
TP.sig.ShellRequest.Inst.defineAttribute('$evaltime');
TP.sig.ShellRequest.Inst.defineAttribute('$exectime');
TP.sig.ShellRequest.Inst.defineAttribute('$tagtime');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.ShellRequest.Inst.defineMethod('asDumpString',
function(depth, level) {

    /**
     * @method asDumpString
     * @summary Returns the receiver as a string suitable for use in log
     *     output.
     * @param {Number} [depth=1] Optional max depth to descend into target.
     * @param {Number} [level=1] Passed by machinery, don't provide this.
     * @returns {String} A new String containing the dump string of the
     *     receiver.
     */

    var origPayload,
        payload;

    origPayload = this.getPayload();

    //  Copy the original payload and just make 'cmdShell' and 'cmdPeer' have
    //  values of their ID - this avoids the recursion trap and its output.
    payload = origPayload.copy();
    payload.atPut('cmdShell', TP.id(origPayload.at('cmdShell')));
    payload.atPut('cmdPeer', TP.id(origPayload.at('cmdPeer')));

    this.setPayload(payload);

    this.callNextMethod();

    this.setPayload(origPayload);

    return TP.BREAK;
});

//  ------------------------------------------------------------------------

TP.sig.ShellRequest.Inst.defineMethod('cancel',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method cancel
     * @summary Tells the receiver to cancel, meaning it is being rescinded by
     *     the user or calling process. If the receiver has specific behavior to
     *     implement it should override the cancelJob() method invoked as part
     *     of this method's operation.
     * @param {String} aFaultString A string description of the fault.
     * @param {Object} aFaultCode A code providing additional information on the
     *     reason for the cancellation.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the cancellation.
     * @returns {TP.BREAK}
     */

    this.callNextMethod();

    return TP.BREAK;
});

//  ------------------------------------------------------------------------

TP.sig.ShellRequest.Inst.defineMethod('complete',
function(aResult) {

    /**
     * @method complete
     * @summary Tells the receiver to complete, meaning the receiver should do
     *     whatever finalization is necessary to reach the TP.SUCCEEDED state.
     *     If the receiver has specific behavior to implement it should override
     *     the completeJob() method invoked as part of this method's operation.
     * @param {Object} aResult An optional object to set as the result for the
     *     request.
     * @returns {TP.sig.ShellRequest} The receiver.
     */

    var responder;

    this.callNextMethod();

    responder = this.get('responder');
    if (TP.canInvoke(responder, 'saveProfile')) {
        setTimeout(function() {
            responder.saveProfile();
        }, 0);
    }

    return TP.CONTINUE;
});

//  ------------------------------------------------------------------------

TP.sig.ShellRequest.Inst.defineMethod('fail',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method fail
     * @summary Tells the receiver to fail, meaning it failed due to some form
     *     of exception. If the receiver has specific behavior to implement it
     *     should override the failJob() method invoked as part of this method's
     *     operation.
     * @param {String} aFaultString A string description of the fault.
     * @param {Object} aFaultCode A code providing additional information on the
     *     reason for the failure.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the failure.
     * @returns {TP.BREAK|undefined}
     */

    if (this.isCompleting() || this.didComplete()) {
        return;
    }

    this.callNextMethod();

    return TP.BREAK;
});

//  ------------------------------------------------------------------------

TP.sig.ShellRequest.Inst.defineMethod('getEvaltime',
function() {

    /**
     * @method getEvaltime
     * @summary Returns the amount of time in milliseconds that 'eval'
     *     processing occurred during request processing.
     * @returns {Number}
     */

    return this.$summarizeSubrequestData('$evaltime');
});

//  ------------------------------------------------------------------------

TP.sig.ShellRequest.Inst.defineMethod('getExectime',
function() {

    /**
     * @method getExectime
     * @summary Returns the amount of time in milliseconds that the entire
     *     request processing took.
     * @returns {Number}
     */

    return this.$get('$exectime');
});

//  ------------------------------------------------------------------------

TP.sig.ShellRequest.Inst.defineMethod('getOriginalCmdText',
function() {

    /**
     * @method getOriginalCmdText
     * @summary
     * @returns {String}
     */

    var text,
        cmds,
        cmdRoot,
        textContentNode;

    text = '';

    //  If we have multiple subrequests then we're dealing with a pipe and the
    //  only real way to respond is via 'cmd' slot.
    cmds = this.get('subrequests');
    if (TP.notEmpty(cmds) && cmds.getSize() > 1) {
        if (TP.isEmpty(text = this.at('cmd'))) {
            text = '';
        }
    }

    if (TP.isEmpty(text)) {
        if (TP.isNode(cmdRoot = this.at('cmdRoot'))) {
            if (TP.isCDATASectionNode(
                    textContentNode = TP.nodeGetFirstDescendantByType(
                                                cmdRoot,
                                                Node.CDATA_SECTION_NODE))) {
                text = TP.nodeGetTextContent(textContentNode);
            }
        }
    }

    //  Some commands (like a history entry) will not have content in the
    //  cmdRoot node, but will in its 'cmdTitle'.

    if (TP.isEmpty(text)) {
        if (TP.isEmpty(text = this.at('cmdTitle'))) {
            text = '';
        }
    }

    //  Some commands (like the ':history' command itself) will not have content
    //  in either place, but will in its 'cmd' property.

    if (TP.isEmpty(text)) {
        if (TP.isEmpty(text = this.at('cmd'))) {
            text = '';
        }
    }

    return text;
});

//  ------------------------------------------------------------------------

TP.sig.ShellRequest.Inst.defineMethod('getTagtime',
function() {

    /**
     * @method getTagtime
     * @summary Returns the amount of time in milliseconds that tag-specific or
     *     built-in processing occurred during request processing.
     * @returns {Number}
     */

    return this.$summarizeSubrequestData('$tagtime');
});

//  ------------------------------------------------------------------------

TP.sig.ShellRequest.Inst.defineMethod('getMessageType',
function() {

    /**
     * @method getMessageType
     * @summary Returns the message type, one of a number of values which map
     *     directly to CSS entries and node templates used to provided
     *     theme-able output.
     * @returns {String}
     */

    var val;

    if (TP.isValid(val = this.at('messageType'))) {
        return val;
    }

    return this.$get('messageType');
});

//  ------------------------------------------------------------------------

TP.sig.ShellRequest.Inst.defineMethod('setMessageType',
function(aMessageType) {

    /**
     * @method setMessageType
     * @summary Sets the receiver's message type, which provides information to
     *     the responder on the nature of the request.
     * @param {String} aMessageType The message type. Typically a string such as
     *     message, help, success, error, etc.
     * @returns {TP.sig.ShellRequest} The receiver.
     */

    return this.atPut('messageType', aMessageType);
});

//  ------------------------------------------------------------------------

TP.sig.ShellRequest.Inst.defineMethod('stderr',
function(output, request) {

    /**
     * @method stderr
     * @summary Standard function for writing error output during shell
     *     execution.
     * @param {Object} output The object to write to stderr.
     * @param {TP.sig.Request|TP.core.Hash|undefined} request Optional
     *     request/parameters. Defaults to the receiver.
     */

    var req,
        shell;

    req = TP.request(TP.ifInvalid(request, this));
    if (TP.notTrue(req.at('cmdSilent'))) {
        shell = req.at('cmdShell');
        if (TP.canInvoke(shell, 'stderr')) {
            shell.stderr(output, req);
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.ShellRequest.Inst.defineMethod('stdin',
function() {

    /**
     * @method stdin
     * @summary Provides a common function for reading from "standard input"
     *     during shell execution. Standard input is always provided as an array
     *     of 0 to N items provided by the various stdout, stderr, and input
     *     redirection calls related to a request.
     * @returns {Object[]} An array of 0 to N input objects.
     */

    var stdin;

    stdin = this.at(TP.STDIN);
    if (TP.notValid(stdin)) {
        stdin = TP.ac();
    }

    return stdin;
});

//  ------------------------------------------------------------------------

TP.sig.ShellRequest.Inst.defineMethod('stdout',
function(output, request) {

    /**
     * @method stdout
     * @summary Standard function for writing valid output during shell
     *     execution.
     * @param {Object} output The object to write to stdout.
     * @param {TP.sig.Request|TP.core.Hash|undefined} request Optional
     *     request/parameters. Defaults to the receiver.
     */

    var req,
        shell;

    req = TP.request(TP.ifInvalid(request, this));
    if (TP.notTrue(req.at('cmdSilent'))) {
        shell = req.at('cmdShell');
        if (TP.canInvoke(shell, 'stdout')) {
            shell.stdout(output, req);
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.sig.ShellRequest.Inst.defineMethod('$summarizeSubrequestData',
function(aPropertyName) {

    /**
     * @method $summarizeSubrequestData
     * @summary When a request is processed via one or more subrequests we
     *     often need to provide a summary of that data for requestors.
     * @param {String} aPropertyName The name of the property to sum.
     * @returns {Number} The result of summing subrequest data for a particular
     *     value.
     */

    var cmds,
        data,
        sum;

    cmds = this.get('subrequests');
    if (TP.notEmpty(cmds)) {
        data = cmds.collect(
                function(item) {

                    return TP.ifInvalid(item.get(aPropertyName), 0);
                });

        if (TP.notEmpty(data)) {
            if (TP.isNumber(data.first())) {
                sum = 0;
                data.perform(
                    function(item) {

                        sum += item;
                    });

                return sum;
            }
        }

        return 0;
    }

    return this.get(aPropertyName);
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/shells/TP.shell.Shell.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'shells';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 *
 */

//  ------------------------------------------------------------------------
//  Shell Primitives
//  ------------------------------------------------------------------------

TP.definePrimitive('shellExec',
function(aRequest) {

    /**
     * @method shellExec
     * @summary A wrapper for constructing and firing a TP.sig.ShellRequest.
     *     This is often used in UI event handlers to avoid complex
     *     TP.dispatch() logic for triggering script execution. NOTE that this
     *     command makes use of the current TP.core.User instance to provide
     *     profile information, if any. This ties the TP.shellExec() command
     *     into TIBET's user-interface permission machinery.
     * @param {String|TP.sig.Request|TP.core.Hash} aRequest The String of TSH
     *     content to execute or a request containing proper shell parameters.
     *     Those include:
     *
     *          {String|Node} cmdSrc The shell input content, either the sugared
     *          source text or a desugared XML node, ready to execute.
     *
     *          {Boolean} cmdEcho Should the input be sent to any UI attached
     *          to the shell. [false].
     *
     *          {Boolean} cmdHistory Should the input generate a history entry?
     *          [false].
     *
     *          {Object} cmdStdio The object type or ID to use for handling
     *          any stdio for the request. This object should implement notify,
     *          stdin, stdout, and stderr calls. This call with install a
     *          standard version that uses the standard TIBET logs for these.
     *
     *          {Boolean} cmdSilent Should shell output be reserved only for
     *          the response (and not sent to any Logger) [false].
     *
     *          {String} shellID The ID or typename of the shell to target.
     *          When a typename is given the ultimate target is that type's
     *          default instance. [TSH].
     *
     *          {Function} TP.ONSUCCESS The Function that should run if the
     *          shell command successfully completes.
     *
     *          {Function} TP.ONFAIL The Function that should run if the
     *          shell command does not successfully complete.
     *
     * @returns {TP.sig.ShellRequest|undefined} The request instance used.
     */

    var shell,
        params,

        cmdSrc,
        shellID,
        silent,
        stdio,

        request,

        stdioProvider,
        stdioResults,

        success,
        failure,
        successHandler,
        failureHandler;

    if (TP.isString(aRequest)) {
        params = TP.hc('cmdSrc', aRequest);
    } else {
        params = aRequest;
        if (TP.notValid(params)) {
            params = TP.hc();
        }
    }

    cmdSrc = params.at('cmdSrc');
    if (TP.isEmpty(cmdSrc)) {
        TP.raise(this, 'InvalidInput');
        return;
    }

    //  Compute a shell to run the supplied command against.
    shellID = params.at('shellID');
    if (TP.isEmpty(shellID)) {

        //  By default, we run stuff against the TSH.
        shell = TP.shell.TSH.getDefaultInstance();

    } else if (TP.isString(shellID)) {

        shell = TP.core.Resource.getResourceById(shellID);
        if (!TP.isKindOf(shell, 'TP.shell.Shell')) {
            TP.raise(this, 'TP.sig.InvalidParameter',
                'Shell ID must be a valid string or shell instance.');
            return;
        }

    } else if (TP.isKindOf(shellID, 'TP.shell.Shell')) {
        shell = shellID;
    } else {
        TP.raise(this, 'TP.sig.InvalidParameter',
                    'Shell ID must be a valid string or shell instance.');
        return;
    }

    //  Configure the STDIO handler to be used for the request.
    stdio = TP.ifInvalid(params.at('cmdStdio'), '');
    if (TP.isString(stdio)) {
        stdio = TP.core.Resource.getResourceById(stdio);
    } else if (TP.canInvokeInterface(
                stdio, TP.ac('notify', 'stdin', 'stdout', 'stderr'))) {
        void 0;
    }

    silent = TP.ifInvalid(params.at('cmdSilent'), false);

    request = TP.sig.ShellRequest.construct(
                    TP.hc(
                            //  Execute this command
                            'cmd', cmdSrc,

                            //  The STDIO provider to use.
                            'cmdStdio', stdio,

                            //  Don't format any stdout/stderr
                            'cmdAsIs', true,

                            //  We definitely want the shell to 'execute' as
                            //  well as 'process' this content :-)
                            'cmdExecute', true,

                            //  Because we turn off interactive environment, we
                            //  have to turn this flag on to allow the
                            //  environment to properly process command
                            //  substitutions (which can use eval)
                            'cmdAllowSubs', true,

                            //  We definitely want expansion, desugaring, etc.
                            //  This will not be 'literal' content.
                            'cmdLiteral', false,

                            //  There is no more sophisticated processing than
                            //  just running the command - no caching of
                            //  processed output, etc.
                            'cmdPhases', 'nocache',

                            //  The shell that we're executing against
                            'cmdShell', shell,

                            //  Whether or not we should silence shell output.
                            'cmdSilent', silent
                    ));

    //  Whether or not to create history for this command
    request.atPut('cmdHistory', params.at('cmdHistory') === true);

    //  Whether or not to echo the request information
    request.atPut('cmdEcho', params.at('cmdEcho') === true);

    //  Whether or not to build a GUI output for this command
    request.atPut('cmdBuildGUI', params.at('cmdBuildGUI') === true);

    if (!params.hasKey('cmdStdio')) {
        //  Build a hash that will hold stdio results for various commands.
        stdioResults = TP.ac();

        //  Configure STDIO on the shell to capture it for providing to the
        //  handler functions. Note that we push entries in the order they occur
        //  so callers get a time-ordered collection of all output from the
        //  request.
        stdioProvider = TP.lang.Object.construct();
        stdioProvider.defineMethod('notify',
                        function(anObject, req) {
                            stdioResults.push(
                                {
                                    meta: 'notify',
                                    data: anObject
                                });
                        });
        stdioProvider.defineMethod('stdin',
                        function(anObject, aDefault, req) {
                            stdioResults.push(
                                {
                                    meta: 'stdin',
                                    data: anObject
                                });
                        });
        stdioProvider.defineMethod('stdout',
                        function(anObject, req) {
                            stdioResults.push(
                                {
                                    meta: 'stdout',
                                    data: anObject
                                });
                        });
        stdioProvider.defineMethod('stderr',
                        function(anObject, req) {
                            stdioResults.push(
                                {
                                    meta: 'stderr',
                                    data: anObject
                                });
                        });

        stdioProvider.defineMethod('report',
             function(aSignal, results) {
                 results.forEach(
                        function(item) {
                            if (TP.notValid(item)) {
                                return;
                            }

                            switch (item.meta) {
                                case 'notify':
                                    TP.info(TP.str(item.data));
                                    break;
                                case 'stdin':
                                    TP.info(TP.str(item.data));
                                    break;
                                case 'stdout':
                                    TP.info(TP.str(item.data));
                                    break;
                                case 'stderr':
                                    TP.error(TP.str(item.data));
                                    break;
                                default:
                                    break;
                            }
                        });
             });
    } else {
        stdioProvider = aRequest.at('cmdStdio');
    }

    //  Install our object as the STDIO provider
    shell.attachSTDIO(stdioProvider);

    //  Configure the success handler, or a default one to report any output.
    success = params.at(TP.ONSUCCESS);
    if (TP.notValid(success)) {
        if (request.at('cmdSilent') !== true) {
            success = TP.isCallable(stdioProvider.report) ?
                                                stdioProvider.report :
                                                TP.RETURN_NULL;
        } else {
            success = TP.RETURN_NULL;
        }
    }
    successHandler = function(aSignal) {
        shell.detachSTDIO();
        success(aSignal, stdioResults);
    };

    request.defineHandler('RequestSucceeded', successHandler);

    //  Configure the failure handler, or a default one to report any output.
    failure = params.at(TP.ONFAIL);
    if (TP.notValid(failure)) {
        if (request.at('cmdSilent') !== true) {
            failure = TP.isCallable(stdioProvider.report) ?
                                                stdioProvider.report :
                                                TP.RETURN_NULL;
        } else {
            failure = TP.RETURN_NULL;
        }
    }
    failureHandler = function(aSignal) {
        shell.detachSTDIO();
        failure(aSignal, stdioResults);
    };

    request.defineHandler('RequestFailed', failureHandler);

    //  Go ahead and tell the shell to handle the shell request.
    shell[TP.composeHandlerName('ShellRequest')](request);

    return request;
});

//  ------------------------------------------------------------------------
//  TP.shell.Shell
//  ------------------------------------------------------------------------

TP.core.Service.defineSubtype('shell.Shell');

//  The core shell type is abstract.
TP.shell.Shell.isAbstract(true);

//  ------------------------------------------------------------------------
//  Local Attributes
//  ------------------------------------------------------------------------

//  container for help information
TP.shell.Shell.defineAttribute('helpTopics');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  rough limits on how many entries we'll maintain in core data structures
TP.shell.Shell.Type.defineConstant('HISTORY_MAX', 250);

//  the limit of the number of positional arguments
TP.shell.Shell.Type.defineConstant('POSITIONAL_MAX', 25);

TP.shell.Shell.Type.defineConstant('MIN_USERNAME_LEN', 2);
TP.shell.Shell.Type.defineConstant('MIN_PASSWORD_LEN', 2);

TP.shell.Shell.Type.defineConstant('INVALID_ARGUMENT_MATCHER',
    TP.rc('(xmlns' +
            '|xmlns:\\w+' +
            '|class' +
            '|tibet:tag' +
            '|tag' +
            '|tsh:argv' +
            '|argv' +
            '|tibet:attrtemplateexprs)'));

//  'starter' snippet list used for new accounts. a list of pairs:
//  ([[command, user text], ...])
TP.shell.Shell.Type.defineAttribute(
                'STARTER_SNIPPETS',
                TP.ac(
                        TP.ac(':clear', 'Clear'),
                        TP.ac(':config', 'Config Settings'),
                        TP.ac('TP.sys.getBootLog()', 'Show Boot Log')
                ));

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  TP.sig.ShellRequests are the service triggers, activating shell
//  processing
TP.shell.Shell.Type.defineAttribute(
    'triggers', TP.ac(TP.ac(TP.ANY, 'TP.sig.ShellRequest')));

//  the default namespace prefix for unprefixed commands in this shell.
TP.shell.Shell.Type.defineAttribute('commandPrefix', '');

//  any TIBET update info that was obtained on system startup.
TP.shell.Shell.Type.defineAttribute('updateInfo');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.shell.Shell.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    //  these are how virtually all incoming requests are made, but the
    //  shell will construct some of its own when redispatching commands
    TP.sys.getTypeByName('TP.sig.ShellRequest');

    //  to communicate with the user we make use of these two, which are
    //  typically handled by a console instance serving as view/ctrlr
    TP.sys.getTypeByName('TP.sig.UserOutputRequest');
    TP.sys.getTypeByName('TP.sig.UserInputRequest');

    //  certain commands can attempt to affect a connected console. the
    //  console is responsible for filtering these to respond only when the
    //  origin is the shell the console is currently managing
    TP.sys.getTypeByName('TP.sig.ConsoleRequest');

    //  observe the 'TP.sig.UpdateAvailable' call. If there's an update to
    //  TIBET available, the kernel will notify us and we can log a message
    //  to the user.
    this.observe(TP.sys, 'TP.sig.UpdateAvailable');

    return;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Type.defineHandler('UpdateAvailable',
function(aSignal) {

    /**
     * @method handleUpdateAvailable
     * @summary Handles when an 'TP.sig.UpdateAvailable' signal is thrown.
     * @param {TP.sig.UpdateAvailable} aSignal The signal that caused this
     *     handler to execute.
     * @returns {TP.meta.shell.Shell} The receiver.
     */

    var updateInfo,
        notifyFunc;

    //  We only do this once per launch. Make sure to ignore to avoid future
    //  notifications.
    this.ignore(TP.sys, 'TP.sig.UpdateAvailable');

    if (TP.isValid(updateInfo = aSignal.getPayload())) {
        this.set('updateInfo', updateInfo);

        notifyFunc =
            function() {
                var req;

                req = TP.sig.UserOutputRequest.construct(
                        TP.hc('cmdTitle', 'Version Update',
                                'cmdEcho', true,
                                'output',
                                TP.elem(
                                    TP.join(
                                    '<span xmlns="', TP.w3.Xmlns.XHTML, '">',
                                    'There is a new TIBET version: ',
                                    TP.sys.getLibVersion(updateInfo),
                                    '</span>')),
                            'cmdAsIs', true,
                            'cmdBox', false));
                req.fire(this);
            };

        //  Fork it so that, in case the shell isn't running, it gives it a
        //  chance to get up and running.
        setTimeout(notifyFunc, TP.sys.cfg('shell.update.delay', 2000));
    }

    return this;
});

//  ------------------------------------------------------------------------
//  HELP TOPICS
//  ------------------------------------------------------------------------

TP.shell.Shell.Type.defineMethod('addHelpTopic',
function(command, method, abstract, usage, description) {

    /**
     * @method addHelpTopic
     * @summary Adds a help usage/abstract for a particular shell command. The
     *     resulting text is output by the built-in :help command.
     * @param {String} command The command name ([ns]:[tag]) for the topic.
     * @param {String} usage The usage string for the command.
     * @param {String} abstract The abstract of the command. Should be a single
     *     line of text maximum.
     * @param {Function} method The method object that implements the command.
     * @returns {TP.meta.shell.Shell} The receiver.
     */

    var topics;

    if (TP.isEmpty(command) || !TP.isMethod(method)) {
        return this.raise('InvalidParameter');
    }

    if (TP.isEmpty(usage) || TP.isEmpty(abstract)) {
        TP.warn('Empty usage or abstract string for help topic: ' + command);
    }

    topics = TP.shell.Shell.get('helpTopics');
    if (TP.notValid(topics)) {
        topics = TP.hc();
        topics.setSortFunction(TP.sort.CASE_INSENSITIVE);
        TP.shell.Shell.$set('helpTopics', topics);
    }

    //  tuck usage/abstract onto method itself. we'll retreive from there.
    //  use slot access here since we don't define these as 'attributes'.
    method.$$usage = usage;
    method.$$abstract = abstract;
    method.$$description = abstract;

    //  save the command name and the implementation. when we retrieve this we
    //  can use the method to access the abstract and its comment text for docs.
    topics.atPut(command, method);

    return this;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  the current list of aliases for this shell
TP.shell.Shell.Inst.defineAttribute('aliases');

//  the default namespace prefix for unprefixed commands
TP.shell.Shell.Inst.defineAttribute('commandPrefix');

//  the current prompt string. this is built from the command prefix
TP.shell.Shell.Inst.defineAttribute('commandPrompt');

//  the object used as a variable scope for processing local variables
//  within the shell.
TP.shell.Shell.Inst.defineAttribute('executionInstance');

//  history list support
TP.shell.Shell.Inst.defineAttribute('history');
TP.shell.Shell.Inst.defineAttribute('historyIndex', 0);

TP.shell.Shell.Inst.defineAttribute('nextPID', 0);

//  whether the shell is currently running (has started)
TP.shell.Shell.Inst.defineAttribute('running', false);

//  an optional initial request which triggered instance creation
TP.shell.Shell.Inst.defineAttribute('request');

//  slots for the previous and current request's which are/have been
//  executed
TP.shell.Shell.Inst.defineAttribute('current');
TP.shell.Shell.Inst.defineAttribute('previous');

//  the current username (profile name) for the shell
TP.shell.Shell.Inst.defineAttribute('username');

//  the shell's path stack, a set of paths which have been previously
//  manipulated via a path operation such as pushd or popd
TP.shell.Shell.Inst.defineAttribute('pathStack');

//  the announcement used when a shell of this type starts up
TP.shell.Shell.Inst.defineAttribute('announcement', null);

//  additional information presented when a shell of this type starts up
TP.shell.Shell.Inst.defineAttribute('introduction', null);

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('init',
function(aResourceID, aRequest) {

    /**
     * @method init
     * @summary Initializes a new instance, preparing it for command
     *     processing. The resource ID provided will be used to register the
     *     instance for later lookup/targeting logic.
     * @param {String} aResourceID The standard service identifier.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request or hash
     *     containing shell parameters etc.
     * @returns {TP.shell.Shell} A new instance.
     */

    this.callNextMethod();

    //  capture our initiating request for reference to parameters etc.
    this.$set('request', aRequest);

    //  configure our internal list/lookup variables
    this.$set('aliases', TP.hc());
    this.$set('history', TP.ac());

    this.$set('pathStack', TP.ac());

    //  force prefix/prompt construction
    this.setPrefix();
    this.setPrompt(this.getPrefix() + '&#160;&#187;');

    //  observe the 'TP.sig.AppShutdown' call. If the system is about to be
    //  shut down, the kernel will notify us and we can follow proper shutdown
    //  procedures, like logging the current user out (which does things like
    //  saving their profile).
    this.observe(TP.sys, 'TP.sig.AppShutdown');

    //  register so we can be found by resourceID for shell etc
    TP.sys.registerObject(this, aResourceID);

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('getCommandMethod',
function(aCommandName) {

    /**
     * @method getCommandMethod
     * @summary Returns the method corresponding to the command name that is
     *     supplied.
     * @description This method will search the 'tsh' namespace and the
     *     currently executing shells, looking for a method that corresponds to
     *     the command name, according to the naming convention.
     * @returns {Function|null} The method corresponding to the supplied method
     *     name.
     */

    var cmdName,
        cmdPrefix,
        cmdParts,

        namespace,
        type,

        method,

        shells,
        i;

    cmdName = aCommandName;

    //  If the command name has a leading ':', slice it off
    if (cmdName.startsWith(':')) {

        cmdName = cmdName.slice(1);

        //  Grab the shell's default namespace prefix
        cmdPrefix = this.getPrefix();

        //  If it's empty, bail out
        if (TP.isEmpty(cmdPrefix)) {
            TP.error('Can\'t find a command prefix for this shell.');

            return null;
        }
    } else if (cmdName.contains(':')) {

        cmdParts = cmdName.split(':');

        cmdPrefix = cmdParts.first();
        cmdName = cmdParts.last();
    }

    //  First, we see if the 'tsh:' namespace has a type that corresponds to the
    //  command name
    namespace = TP[cmdPrefix];

    if (TP.isNamespace(namespace)) {

        type = TP[cmdPrefix][cmdName];
        if (TP.isType(type)) {

            //  Need to check to make sure that the type's prototype *owns* the
            //  slot - we'll see the inherited one otherwise.
            if (TP.owns(type.Type, 'cmdRunContent')) {

                method = type.Type.getMethod('cmdRunContent');

                //  Found a 'cmdRunContent' method on the target type.
                if (TP.isMethod(method)) {
                    return method;
                }
            }

            //  Need to check to make sure that the type's prototype *owns* the
            //  slot - we'll see the inherited one otherwise.
            if (TP.owns(type.Type, 'tshExecute')) {

                method = type.Type.getMethod('tshExecute');

                //  Found a 'tshExecute' method on the target type.
                if (TP.isMethod(method)) {
                    return method;
                }
            }
        }
    } else {
        TP.error('Can\'t find a namespace for prefix: ' + cmdPrefix);

        return null;
    }

    //  Then we see if the shell itself has the method for the command. The core
    //  shell types have some built-in methods modeled this way.

    //  TODO: Iterate over the currently installed shells
    shells = TP.ac(TP.shell.TSH);
    for (i = 0; i < shells.getSize(); i++) {
        method = shells.at(i).Inst.getMethod(
                                    'execute' + TP.makeStartUpper(cmdName));

        //  Found an 'execute<cmdName>' method on the target type.
        if (TP.isMethod(method)) {
            return method;
        }
    }

    TP.error('Can\'t find a command method for command: ' + aCommandName);

    return null;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('$getEqualityValue',
function() {

    /**
     * @method $getEqualityValue
     * @summary Returns the value which should be used for testing equality for
     *     the receiver.
     * @returns {String} The test value, typically the shell's GID.
     */

    return this.getID();
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('getNextPID',
function() {

    /**
     * @method getNextPID
     * @summary Returns the next available PID for requests made of this shell.
     * @returns {Number} The PID value.
     */

    var ndx;

    //  note use of $get to avoid recursion
    ndx = this.$get('nextPID');

    //  If the object has a 'recursion marker', that means a String
    //  representation of some sort is being produced and we should just return
    //  the current value here.
    if (TP.objectHasMarker(this)) {
        return ndx;
    }

    this.$set('nextPID', ndx + 1);

    return ndx;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('getPrefix',
function() {

    /**
     * @method getPrefix
     * @summary Returns the current command prefix, not including a trailing
     *     namespace separator (:). For example, this method typically returns
     *     'tsh' in the TSH (TIBET Shell).
     * @returns {String} The command prefix plus NS separator.
     */

    return this.$get('commandPrefix');
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('getPrompt',
function() {

    /**
     * @method getPrompt
     * @summary Returns the prompt a console or other UI should display for
     *     this shell.
     * @returns {String} The prompt.
     */

    return this.$get('commandPrompt');
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('setPrefix',
function(aPrefix) {

    /**
     * @method setPrefix
     * @summary Sets the default command prefix for any unprefixed commands.
     * @param {String} aPrefix The namespace prefix. This should typically be in
     *     lower case (tsh, yak, etc).
     * @returns {TP.shell.Shell} The receiver.
     */

    var prefix;

    prefix = TP.ifEmpty(aPrefix, this.getType().get('commandPrefix'));
    this.$set('commandPrefix', prefix);

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('setPrompt',
function(aPromptString) {

    /**
     * @method setPrompt
     * @summary Sets the prompt string, a string which will be transformed and
     *     used by this shell to signify command input.
     * @param {String} aPromptString The prompt.
     * @returns {TP.shell.Shell} The receiver.
     */

    this.$set('commandPrompt', aPromptString);

    return this;
});

//  ------------------------------------------------------------------------
//  STARTUP/LOGIN/LOGOUT
//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('announce',
function(aRequest) {

    /**
     * @method announce
     * @summary Displays an announcement specific to the current shell and/or
     *     request being processed. This is typically invoked by the
     *     TP.tdp.Console to emulate how standard shells announce their version
     *     etc.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request or hash
     *     containing parameters.
     * @returns {TP.meta.shell.Shell} The receiver.
     */

    var str,
        req;

    str = TP.ifInvalid(this.get('announcement'), '');
    str += TP.ifInvalid(this.get('introduction'), '');

    //  output any startup announcement for the shell
    req = TP.sig.UserOutputRequest.construct(
                    TP.hc('cmdTitle', '',
                            'cmdEcho', true,
                            'output', str,
                            'cssClass', 'inbound_announce',
                            'cmdAsIs', true,
                            'cmdBox', false));

    req.fire(this);

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineHandler('AppShutdown',
function(aSignal) {

    /**
     * @method handleAppShutdown
     * @summary Handles when an 'TP.sig.AppShutdown' signal is thrown.
     * @param {TP.sig.AppShutdown} aSignal The signal that caused this
     *     handler to execute.
     * @returns {TP.meta.shell.Shell} The receiver.
     */

    this.logout(aSignal);

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('isLoginShell',
function() {

    /**
     * @method isLoginShell
     * @summary Returns true if the receiver is a top-level login shell.
     * @returns {Boolean}
     */

    //  by default we presume that shells must log in
    return true;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('isRunning',
function(aFlag) {

    /**
     * @method isRunning
     * @summary Combined setter/getter for whether the shell is active.
     * @param {Boolean} aFlag Optional new value to set.
     * @returns {Boolean} The current value.
     */

    if (TP.isBoolean(aFlag)) {
        this.$set('running', aFlag);
    }

    return this.$get('running');
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('login',
function(aRequest) {

    /**
     * @method login
     * @summary Performs any login sequence necessary for the receiver. The
     *     default is to take no action. Subtypes should override this to
     *     provide target-specific login/profile management features.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request or hash
     *     containing parameters.
     * @returns {TP.shell.Shell} The receiver.
     */

    TP.override();

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('logout',
function(aRequest) {

    /**
     * @method logout
     * @summary Logs out of the current login shell.
     * @description The shell uses several variables on logout to determine what
     *     values if any to save. These variables are SAVEVARS, SAVEALIAS,
     *     SAVEHIST, and SAVEDIRS. The DISCARD variable controls whether change
     *     set data should be discarded, the default is false.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request or hash
     *     containing parameters.
     * @returns {TP.shell.Shell} The receiver.
     */

    //  can't log out of a non-login shell
    if (!this.isLoginShell(aRequest)) {
        return this;
    }

    if (this.isRunning()) {
        try {
            //  TODO:   configure "save profile" and then save those
            //  elements of the user's profile as efficiently as possible
            this.saveProfile();
        } finally {
            //  update our running status
            this.isRunning(false);
        }
    }

    //  notify any observers that we've logged out
    this.signal('TP.sig.TSH_Logout');

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('start',
function(aRequest) {

    /**
     * @method start
     * @summary Performs common startup processing, including displaying an
     *     announcement specific to the current shell. The login() sequence is
     *     initiated as part of this method.
     * @returns {TP.sig.ShellRequest} The request.
     */

    if (this.isRunning()) {
        return aRequest;
    }

    //  login shells imply interactive user shells, so we announce the shell
    //  and start the login sequence in that case. otherwise we can simply
    //  flip the running state to true
    if (this.isLoginShell(aRequest)) {
        this.announce(aRequest);
    } else {
        this.isRunning(true);
    }

    return aRequest;
});

//  ------------------------------------------------------------------------
//  PROFILE
//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('initProfile',
function() {

    /**
     * @method initProfile
     * @summary Initializes common and user-phase profile data.
     * @returns {TP.shell.Shell} The receiver.
     */

    var name,

        profileStorage,

        newHistory,

        userData,

        dataSet,

        historyEntries,
        snippetEntries,
        bookmarkEntries,
        editorTabEntries,
        deployInfoEntries,
        screenLocEntries;

    if (TP.notEmpty(name = this.get('username'))) {

        profileStorage = TP.core.LocalStorage.construct();

        userData = profileStorage.at('user_' + name);

        if (TP.notEmpty(userData)) {

            dataSet = TP.json2js(userData);

            //  ---
            //  History
            //  ---

            if (TP.notEmpty(historyEntries = dataSet.at('history'))) {

                newHistory = TP.ac();

                historyEntries.perform(
                    function(anEntry, anIndex) {

                        var newReq;

                        newReq = TP.sig.ShellRequest.construct(
                            TP.hc(
                                'cmd',
                                    anEntry.at('cmd'),
                                'cmdAllowSubs',
                                    anEntry.at('cmdAllowSubs'),
                                'cmdAsIs',
                                    anEntry.at('cmdAsIs'),
                                'cmdExecute',
                                    anEntry.at('cmdExecute'),
                                //  We're not creating a history of
                                //  commands that restore history ;-).
                                'cmdHistory', false,
                                //  Assign ID based on iteration when
                                //  rebuilding. This will reset to 0-histmax but
                                //  that's better than nothing.
                                'cmdHistoryID', anIndex,
                                    // TP.ifInvalid(anEntry.at('cmdHistoryID'),
                                    // anIndex),
                                'cmdBuildGUI',
                                    anEntry.at('cmdBuildGUI'),
                                'cmdLiteral',
                                    anEntry.at('cmdLiteral'),
                                'cmdPhases',
                                    anEntry.at('cmdPhases'),
                                'cmdRecycle',
                                    anEntry.at('cmdRecycle'),
                                'cmdRoot',
                                    TP.elem(anEntry.at('cmdRoot')),
                                'cmdShell',
                                    anEntry.at('cmdShell'),
                                'cmdSilent',
                                    anEntry.at('cmdSilent')
                                ));

                        newReq.atPut('cmdPeer', newReq);

                        newHistory.add(newReq);
                    });

                this.set('history', newHistory);
                if (TP.notEmpty(newHistory)) {
                    this.set('historyIndex',
                        newHistory.last().at('cmdHistoryID') + 1);
                } else {
                    this.set('historyIndex', 1);
                }
            }

            //  ---
            //  Snippets
            //  ---

            snippetEntries = dataSet.at('snippets');

            if (TP.isEmpty(snippetEntries)) {
                snippetEntries = this.getType().STARTER_SNIPPETS.copy();
            }

            TP.uc('urn:tibet:tsh_snippets').setResource(
                                            snippetEntries,
                                            TP.hc('observeResource', true,
                                                    'signalChange', true));
            //  ---
            //  Bookmarks
            //  ---

            bookmarkEntries = dataSet.at('bookmarks');

            if (TP.isEmpty(bookmarkEntries)) {
                bookmarkEntries = TP.ac();
            }

            TP.uc('urn:tibet:lama_bookmarks').setResource(
                                            bookmarkEntries,
                                            TP.hc('observeResource', true,
                                                    'signalChange', true));
            //  ---
            //  Deploy Info Entries
            //  ---

            deployInfoEntries = dataSet.at('deployinfos');

            if (TP.isEmpty(deployInfoEntries)) {
                deployInfoEntries = TP.hc();
            } else {
                //  This resource expects POJOs under the top-level hash, so
                //  convert it
                deployInfoEntries.perform(
                    function(aKVPair) {
                        deployInfoEntries.atPut(
                            aKVPair.first(),
                            aKVPair.last().asObject());
                    });
            }

            TP.uc('urn:tibet:lama_deployinfos').setResource(
                                            deployInfoEntries,
                                            TP.hc('observeResource', true,
                                                    'signalChange', true));
            //  ---
            //  Screen Locations
            //  ---

            screenLocEntries = dataSet.at('screenlocs');

            if (TP.isEmpty(screenLocEntries)) {
                screenLocEntries = TP.ac();
            }

            TP.uc('urn:tibet:lama_screenlocs').setResource(
                                            screenLocEntries,
                                            TP.hc('observeResource', true,
                                                    'signalChange', true));
            //  ---
            //  Console Editor Tabs
            //  ---

            editorTabEntries = dataSet.at('editortabs');

            if (TP.isEmpty(editorTabEntries)) {
                editorTabEntries = TP.ac();
            }

            TP.uc('urn:tibet:lama_consoletabs').setResource(
                                            editorTabEntries,
                                            TP.hc('observeResource', true,
                                                    'signalChange', true));
        } else {

            //  ---
            //  Snippets
            //  ---

            snippetEntries = this.getType().STARTER_SNIPPETS.copy();
            TP.uc('urn:tibet:tsh_snippets').setResource(
                                            snippetEntries,
                                            TP.hc('observeResource', true,
                                                    'signalChange', true));

            //  ---
            //  Bookmarks
            //  ---

            bookmarkEntries = TP.ac();
            TP.uc('urn:tibet:lama_bookmarks').setResource(
                                            bookmarkEntries,
                                            TP.hc('observeResource', true,
                                                    'signalChange', true));

            //  ---
            //  Deploy Info Entries
            //  ---

            deployInfoEntries = TP.hc();
            TP.uc('urn:tibet:lama_deployinfos').setResource(
                                            deployInfoEntries,
                                            TP.hc('observeResource', true,
                                                    'signalChange', true));
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('saveProfile',
function() {

    /**
     * @method saveProfile
     * @summary Stores common and user-phase profile data.
     * @returns {TP.shell.Shell} The receiver.
     */

    var name,

        historyEntries,
        snippetEntries,
        bookmarkEntries,
        editorTabEntries,
        deployInfoEntries,
        screenLocEntries,

        userData,
        profileStorage;

    if (TP.notEmpty(name = this.get('username'))) {

        //  ---
        //  History
        //  ---

        historyEntries =
            this.get('history').collect(
                function(aShellReq) {

                    return TP.hc(
                        'cmd', aShellReq.at('cmd'),
                        'cmdAllowSubs', aShellReq.at('cmdAllowSubs'),
                        'cmdExecute', aShellReq.at('cmdExecute'),
                        'cmdBuildGUI', aShellReq.at('cmdBuildGUI'),
                        'cmdHistoryID', aShellReq.at('cmdHistoryID'),
                        'cmdLiteral', aShellReq.at('cmdLiteral'),
                        'cmdPhases', aShellReq.at('cmdPhases'),
                        'cmdRecycle', aShellReq.at('cmdRecycle'),
                        'cmdRoot', TP.str(aShellReq.at('cmdRoot')),
                        'cmdSilent', aShellReq.at('cmdSilent'));
                });

        //  ---
        //  Snippets
        //  ---

        snippetEntries =
            TP.uc('urn:tibet:tsh_snippets').getResource().get('result');
        if (TP.isEmpty(snippetEntries)) {
            snippetEntries = TP.ac();
        }

        //  ---
        //  Bookmarks
        //  ---

        bookmarkEntries =
            TP.uc('urn:tibet:lama_bookmarks').getResource().get('result');
        if (TP.isEmpty(bookmarkEntries)) {
            bookmarkEntries = TP.ac();
        }

        //  ---
        //  Console Editor Tabs
        //  ---

        editorTabEntries =
            TP.uc('urn:tibet:lama_consoletabs').getResource().get('result');
        if (TP.isEmpty(editorTabEntries)) {
            editorTabEntries = TP.ac();
        }

        //  ---
        //  Deploy Info
        //  ---

        deployInfoEntries =
            TP.uc('urn:tibet:lama_deployinfos').getResource().get('result');
        if (TP.isEmpty(deployInfoEntries)) {
            deployInfoEntries = TP.hc();
        }

        //  ---
        //  Screens
        //  ---

        screenLocEntries =
            TP.uc('urn:tibet:lama_screenlocs').getResource().get('result');

        if (TP.isEmpty(screenLocEntries)) {
            screenLocEntries = TP.ac();
        }

        //  ---
        //  Save it all
        //  ---

        userData = TP.hc(
                    'history', historyEntries,
                    'snippets', snippetEntries,
                    'bookmarks', bookmarkEntries,
                    'editortabs', editorTabEntries,
                    'deployinfos', deployInfoEntries,
                    'screenlocs', screenLocEntries);

        profileStorage = TP.core.LocalStorage.construct();
        profileStorage.atPut('user_' + name, TP.js2json(userData));
    }

    return this;
});

//  ------------------------------------------------------------------------
//  ALIASES
//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('getAlias',
function(aName) {

    /**
     * @method getAlias
     * @summary Returns the value of the named alias, if found.
     * @param {String} aName The alias name to look up.
     * @returns {String} The string value entered.
     */

    var dict,
        val,

        parentShell;

    //  TODO:   map alias storage into local DB or local store, or
    //          cookie, or file, but store it somewhere.
    dict = this.get('aliases');
    if (TP.notValid(dict)) {
        dict = TP.hc();
    }

    //  first we look locally, then we'll check parent. note that we test
    //  to see if the value is defined, which still allows it to be null so
    //  we can 'unset' locally
    if (TP.isDefined(val = dict.at(aName))) {
        return this.getAlias(val);
    }

    if (TP.isValid(parentShell = this.get('parent'))) {
        return parentShell.getAlias(aName);
    }

    //  fallback is to return the original value
    return aName;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('setAlias',
function(aName, aValue) {

    /**
     * @method setAlias
     * @summary Sets the string value of an alias.
     * @param {String} aName The alias name to set.
     * @param {String} aValue The string value to set. No object resolution is
     *     done on alias values so this will be used literally.
     * @returns {TP.shell.Shell} The receiver.
     */

    var value;

    if (aValue.charAt(0) === '"') {
        value = this.resolveVariableSubstitutions(aValue.unquoted());
    } else {
        value = aValue.unquoted();
    }

    this.get('aliases').atPut(aName, value);

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('unsetAlias',
function(aName) {

    /**
     * @method unsetAlias
     * @summary Removes an alias definition from the receiver.
     * @param {String} aName The alias name to remove.
     * @returns {TP.shell.Shell} The receiver.
     */

    this.get('aliases').removeKey(aName);

    return this;
});

//  ------------------------------------------------------------------------
//  HISTORY
//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('addHistory',
function(aRequest) {

    /**
     * @method addHistory
     * @summary Adds a request to the command history for the receiver.
     * @description The variable HISTSIZE controls whether the list will be
     *     trimmed as a result, keeping a maximum number of entries. Also, the
     *     HISTDUP variable will determine if the entry is actually added. If
     *     HISTDUP is 'prev' the entry will only be added if its command text is
     *     not the same as the previous entry. If HISTDUP is 'all' the entry
     *     will only be added if its command text is unique across all history
     *     entries.
     * @param {TP.sig.ShellRequest} aRequest The request to add.
     * @returns {Number} The index at which the entry was placed.
     */

    var list,
        root,
        cmd,
        index,
        histmax,
        dups,

        i,

        offset;

    list = this.get('history');

    root = aRequest.at('rootRequest');
    if (TP.notValid(root)) {
        root = aRequest;
    }

    cmd = root.at('cmd');
    cmd = cmd.trim();

    //  no matter what, we reset the history index to the end so any
    //  next/prev operations are reset
    histmax = this.getVariable('HISTSIZE');
    if (TP.notValid(histmax)) {
        histmax = this.getType().HISTORY_MAX;
    }

    dups = TP.ifInvalid(this.getVariable('HISTDUP'), 'prev');
    dups.toLowerCase();

    if (dups === 'prev' && list.getSize() > 0) {
        if (list.last().at('cmd') === cmd) {
            index = list.last().at('cmdHistoryID');
            this.set('historyIndex', index + 1);
            return index;
        }
    } else if (dups === 'all') {
        for (i = list.getSize() - 1; i >= 0; i--) {
            if (list.at(i).at('cmd') === cmd) {
                this.set('historyIndex', i + 1);
                return i;
            }
        }
    }

    //  compute the index and store it with the root request
    if (TP.notEmpty(list)) {
        index = list.last().at('cmdHistoryID') + 1;
    } else {
        index = 1;
    }

    root.atPut('cmdHistoryID', index);
    list.add(root);

    offset = list.getSize() - histmax;
    if (offset > 0) {
        //  We're over the history maximum. Since history is LRU, we shift off
        //  the first item.
        list.shift();
    }

    this.set('historyIndex', index + 1);

    return index;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('decrementHistoryIndex',
function() {

    /**
     * @method decrementHistoryIndex
     * @summary Decreases the current history index by 1, unless the index is
     *     already at 0. This method shifts the 'current history' entry to point
     *     to the new index location.
     * @returns {Number} The new index.
     */

    var index,
        first,
        min;

    //  Current index value?
    index = this.get('historyIndex');

    //  Index value at the start of the list. Can't get smaller than this.
    first = this.get('history').first();
    min = TP.notValid(first) ? 0 : first.at('cmdHistoryID');

    //  Whichever's smaller, the current index value or one at the head of the
    //  list, offset by one to allow clean input result and increment to work.
    this.set('historyIndex', index.max(min) - 1);

    return this.get('historyIndex');
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('getHistory',
function(anIndex, afterExpansion) {

    /**
     * @method getHistory
     * @summary Returns the history entry at the index provided, or the entire
     *     list if no index is provided.
     * @param {Number|String|RegExp} anIndex The history index to look up.
     * @param {Boolean} afterExpansion True to work against the expanded form
     *     rather than the original source command text.
     * @returns {String|undefined} The history entry's stored string content.
     */

    var expanded,
        entry,
        hist,
        text,
        doc,

        histMatch,
        list,
        request;

    expanded = TP.ifInvalid(afterExpansion, false);

    //  no index means we want the entire history list
    if (TP.notValid(anIndex)) {
        return this.$get('history');
    }

    if (TP.isNumber(anIndex)) {
        hist = this.$get('history');

        //  If the index provided is a negative number (usually -1) then we're
        //  not being asked for a specific item by "id" we're being asked based
        //  on offset.
        if (anIndex < 0) {
            //  NOTE offset here is -2 because currently executing command is
            //  the last one (aka -1).
            entry = hist.at(-2);
        } else {
            entry = hist.detect(function(item) {
                return item.at('cmdHistoryID') === anIndex;
            });
        }

        if (TP.isValid(entry)) {
            //  re-constituted history entries may be simple strings
            if (TP.isString(entry)) {
                return entry;
            } else if (expanded) {
                text = entry.getOriginalCmdText();

                return text;
            } else {
                return entry.at('cmd');
            }
        }
    } else {
        //  string or regular expression match for command text

        //  if its a RegExp, then the caller has already defined the matcher
        //  they're gonna use. If not, we build a RegExp from the String
        //  that it should've been. Note how the RegExp forces the String to
        //  be at the start of the match, but allows any trailing
        //  characters.
        if (!TP.isRegExp(histMatch = anIndex)) {
            histMatch = TP.rc('^' +
                                RegExp.escapeMetachars(anIndex) +
                                '[\\s\\S]*');
        }

        if (TP.notValid(histMatch)) {
            this.raise('TP.sig.InvalidParameter', anIndex);

            return;
        }

        //  have to skip the current command here or we'll just find that.
        list = this.$get('history').slice(0, -1);
        request = list.reverse().detect(
                            function(req) {

                                var histText;

                                histText = expanded ?
                                        req.getOriginalCmdText() :
                                        req.at('cmd');

                                return histMatch.test(histText);
                            });

        if (TP.isValid(request)) {
            text = expanded ?
                    request.getOriginalCmdText() :
                    request.at('cmd');
        } else {
            return;
        }

        //  strip common boilerplate
        if (TP.isDocument(doc = TP.documentFromString(text))) {
            text = TP.elementGetInnerContent(doc.documentElement);
        }

        return text;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('incrementHistoryIndex',
function() {

    /**
     * @method incrementHistoryIndex
     * @summary Increases the current history index by 1, unless the index is
     *     already at HISTSIZE. This method shifts the 'current history' entry
     *     to point to the new index location.
     * @returns {Number} The new index.
     */

    var index,
        last,
        max;

    //  Current index value?
    index = this.get('historyIndex');

    //  Index value of the entry at the tail of the list. Can't get bigger than
    //  this + 1;
    last = this.get('history').last();
    max = TP.notValid(last) ? 0 : last.at('cmdHistoryID');

    //  note that we let this push past the end of the list so we get an
    //  empty entry and are properly positioned for the next decrement call
    this.set('historyIndex', index.min(max) + 1);

    return this.get('historyIndex');
});

//  ------------------------------------------------------------------------
//  VARIABLES
//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('getVariable',
function(aName) {

    /**
     * @method getVariable
     * @summary Returns the value of the named shell variable, if found.
     * @param {String} aName The variable name to look up.
     * @returns {String} The string value entered.
     */

    var dict,
        name,

        ourVar,
        parentShell;

    dict = this.getExecutionInstance();

    //  normalize name to $X
    name = aName.toUpperCase();
    if (name.charAt(0) !== '$') {
        name = '$' + name;
    }

    //  first we look locally, then we'll check parent. note that we test
    //  to see if the value is defined, which still allows it to be null so
    //  we can 'unset' locally
    if (TP.isDefined(ourVar = dict.at(name))) {
        return ourVar;
    }

    if (TP.isValid(parentShell = this.get('parent'))) {
        return parentShell.getVariable(name);
    }

    //  NOTE the fallback here, configuration variables and then environment
    //  variables set during boot...and note that these are not the
    //  converted values, but the original values as provided by the call.
    return TP.sys.cfg(aName) || TP.sys.env(aName) || window[aName];
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('setVariable',
function(aName, aValue) {

    /**
     * @method setVariable
     * @summary Sets the string value of a variable name. Note that variable
     *     names are normalized to uppercase $-prefixed values for storage in
     *     the $SCOPE object. For example, aName of 'focus' will become '$FOCUS'
     *     for variable storage. The getVariable call follows this convention as
     *     well, so it is largely invisible except when examining the $SCOPE
     *     object.
     * @param {String} aName The variable name to set.
     * @param {String} aValue The string value to set. Note that when evaluated
     *     as part of command input this may still resolve to an object, but no
     *     resolution is done at the time of variable definition.
     * @returns {TP.shell.Shell} The receiver.
     */

    var name;

    //  normalize name to $X
    name = aName.toUpperCase();
    if (name.charAt(0) !== '$') {
        name = '$' + name;
    }

    this.getExecutionInstance().atPut(name, aValue);
    window[name] = aValue;

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('unsetVariable',
function(aName) {

    /**
     * @method unsetVariable
     * @summary Removes a variable definition from the receiver.
     * @param {String} aName The variable name to remove.
     * @returns {TP.shell.Shell} The receiver.
     */

    var name;

    //  normalize name to $X
    name = aName.toUpperCase();
    if (name.charAt(0) !== '$') {
        name = '$' + name;
    }

    this.getExecutionInstance().removeKey(name);

    return this;
});

//  ------------------------------------------------------------------------
//  REQUEST HANDLING
//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineHandler('ShellRequest',
function(aRequest) {

    /**
     * @method handleShellRequest
     * @summary Constructs a response to the request provided.
     *     TP.sig.ShellRequest instances are the typical way commands are
     *     provided to the shell for processing.
     * @param {TP.sig.ShellRequest} aRequest The request to respond to.
     * @returns {TP.shell.ShellResponse|undefined} A response to the request.
     */

    var thisref,
        response,
        cmd,
        constructOutInfo;

    aRequest.isActive(true);

    //  first make sure we can construct a valid response
    if (TP.notValid(response = aRequest.getResponse())) {
        aRequest.fail('Couldn\'t construct response.');
        this.raise(
            'TP.sig.ProcessingException',
            'Couldn\'t construct response.');

        return;
    }

    //  sign up as the responder for the request so downstream objects can
    //  get a handle back to the shell instance.
    aRequest.set('responder', this);
    aRequest.atPut('cmdShell', this);

    this.$set('previous', this.$get('current'));
    this.$set('current', aRequest);

    thisref = this;

    //  If there is a GUI and the request does not wish to run silently, we
    //  build a 'construct out UI' request and tie it back to the original
    //  request using the 'cmdID'.
    if (TP.isTrue(aRequest.at('cmdBuildGUI')) &&
        TP.notTrue(aRequest.at('cmdSilent')) &&
        TP.notValid(aRequest.at('cmdPeer'))) {

        //  ensure we've got a unique ID for the overall request. this will
        //  be propagated down to all subrequests which help in processing.
        aRequest.atPutIfAbsent('cmdID', aRequest.getRequestID());

        //  Make sure that this request will try to recycle the output UI
        //  that we're constructing using the constructOutInfo.
        aRequest.atPut('cmdRecycle', true);

        cmd = aRequest.at('cmd');

        if (TP.notBlank(cmd)) {
            constructOutInfo =
                    TP.hc('cmd', cmd,
                            'cmdID', aRequest.at('cmdID'),
                            'cmdConstruct', true,
                            'cmdEcho', true);

            //  It's ok to pass a null here, since the console should be in
            //  'construct out UI' mode, given our 'cmdConstruct' flag
            //  above.
            this.stdout(null, constructOutInfo);
        }

        //  the last real work has to be the execute call so we can handle
        //  the possibility of asynchronous work going on underneath.

        //  Note here how we fork the execution (but as quickly as
        //  possible so that it goes back on the stack ASAP) so that the GUI
        //  has the chance to draw the output cell before we run.
        (function() {
            thisref.execute(aRequest);
        }).queueAfterNextRepaint(TP.sys.getUIRoot(true));
    } else {
        //  the last real work has to be the execute call so we can handle
        //  the possibility of asynchronous work going on underneath
        this.execute(aRequest);
    }

    //  in either case we return the response that will ultimately hold the
    //  results when the request is done processing.
    return response;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineHandler('UserInput',
function(aSignal) {

    /**
     * @method handleUserInput
     * @summary Responds to TP.sig.UserInput signals, which are sent in
     *     response to a previous TP.sig.UserInputRequest from the shell itself.
     * @description The implication is that this method is only invoked when the
     *     shell had a prior request in the queue. The request itself will have
     *     been bound to the input response. The shell's response is to invoke
     *     the input as if it were a standard shell request.
     *     TP.sig.UserInputRequests originated by commands or other objects are
     *     presumed to "do the right thing" in response to the input they are
     *     provided.
     * @param {TP.sig.UserInput} aSignal The signal instance that triggered this
     *     handler.
     * @returns {TP.shell.ShellResponse} The response produced when processing
     *     the TP.sig.ShellRequest constructed by this method.
     */

    var request,
        responder,

        req,

        response;

    //  capture the responder so we can let it know when we're done. this
    //  will typically be something like the TP.tdp.Console or a similar UI.
    request = aSignal.getRequest();
    request.isActive(true);

    responder = aSignal.getRequest().get('responder');

    //  construct a request we can process to accomplish the new task
    req = TP.sig.ShellRequest.construct(TP.hc('cmd', aSignal.getResult()));
    req.set('requestor', this);

    try {
        TP.handle(this, req);
    } finally {
        //  if there was a responder let it know we're done
        if (TP.isValid(responder)) {
            aSignal.getRequestID().signal('TP.sig.RequestCompleted');
        }
    }

    response = aSignal.getResponse();

    //  TODO:   why both?
    response.complete();
    request.complete();

    return response;
});

//  ------------------------------------------------------------------------
//  STDIO
//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('attachSTDIO',
function(aProvider) {

    /**
     * @method attachSTDIO
     * @summary Attaches the receiver's stdio hooks to a STDIO provider, an
     *     object which implements those hooks for reuse.
     * @param {Object} aProvider An object implementing stdin, stdout, and
     *     stderr hook functions.
     * @returns {TP.shell.Shell} The receiver.
     */

    if (!TP.canInvokeInterface(
                    aProvider,
                    TP.ac('notify', 'stdin', 'stdout', 'stderr'))) {
        return this.raise(
            'TP.sig.InvalidProvider',
            'STDIO provider must implement stdin, stdout, and stderr');
    }

    this.notify =
            function(anObject, aRequest) {

                return aProvider.notify(anObject, aRequest);
            };

    this.stdin =
            function(aQuery, aDefault, aRequest) {

                return aProvider.stdin(aQuery, aDefault, aRequest);
            };

    this.stdout =
            function(anObject, aRequest) {

                return aProvider.stdout(anObject, aRequest);
            };

    this.stderr =
            function(anError, aRequest) {
                return aProvider.stderr(anError, aRequest);
            };

    //  The first thing to attach "wins" in that it will be the one we default
    //  to whenever we detach later.
    if (TP.notValid(this.$origStdin)) {
        this.$origNotify = this.notify;
        this.$origStdin = this.stdin;
        this.$origStdout = this.stdout;
        this.$origStderr = this.stderr;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('detachSTDIO',
function() {

    /**
     * @method detachSTDIO
     * @summary Detaches the receiver's stdio hooks from a STDIO provider,
     *     reverting them to their original settings.
     * @returns {TP.shell.Shell} The receiver.
     */

    if (TP.notValid(this.$origStdin)) {
        return this;
    }

    this.notify = this.$origNotify;
    this.stdin = this.$origStdin;
    this.stdout = this.$origStdout;
    this.stderr = this.$origStderr;

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('notify',
function(anObject, aRequest) {

    /**
     * @method notify
     * @summary Notifies the user outside of "stdout" of a message.
     * @description The default version of this method uses the low-level
     *     TP.boot.$alert() function. Shells which are connect to a Console or
     *     other UI will typically have this version overwritten so output is
     *     directed to the UI.
     * @param {Object} anObject The object to output.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object with optional
     *     values for 'cmdNotifier', 'cmdAsIs', 'messageType', etc.
     * @returns {TP.shell.Shell} The receiver.
     */

    var message;

    if (TP.isString(anObject)) {
        message = anObject;
    } else if (TP.isError(anObject)) {
        message = TP.ifInvalid(anObject.message, '');
    } else if (TP.canInvoke(anObject, 'at')) {
        message = anObject.at('message');
        if (TP.notValid(message) && TP.canInvoke(anObject, 'get')) {
            message = anObject.get('message');
        }

        if (TP.notValid(message) || !TP.isString(message)) {
            message = TP.str(anObject);
        }
    } else {
        message = TP.str(anObject);
    }

    // name = TP.ifKeyInvalid(aRequest, 'cmdNotifier', null);
    // raw = TP.ifKeyInvalid(aRequest, 'cmdAsIs', false);

    TP.boot.$alert(message);

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('stderr',
function(anError, aRequest) {

    /**
     * @method stderr
     * @summary Outputs the error provided using any parameters in the request
     *     to assist with formatting etc. Parameters include messageType,
     *     cmdAsIs, etc.
     * @param {String} anError The error to output.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object with optional
     *     values for messageType, cmdAsIs, etc.
     * @returns {TP.shell.Shell} The receiver.
     */

    var req;

    if (TP.notValid(aRequest)) {
        req = TP.sig.UserOutputRequest.construct();
        req.set('requestor', this);
    } else if (TP.isKindOf(aRequest, TP.sig.UserOutputRequest)) {
        req = aRequest;
    } else {
        //  convert from collection form to UOR form
        req = TP.sig.UserOutputRequest.construct(aRequest);
        req.set('requestor', this);
    }

    req.atPut('output', anError);
    req.atPut('messageType', 'failure');

    req.atPutIfAbsent('messageLevel', 'error');

    req.fire(this);

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('stdin',
function(aQuery, aDefault, aRequest) {

    /**
     * @method stdin
     * @summary Requests input from the user.
     * @param {String} aQuery An optional query string to format as a question
     *     for the user.
     * @param {String} aDefault An optional string value to use as the default
     *     value.
     * @param {TP.sig.UserInputRequest} aRequest An input request containing
     *     processing instructions. The request should be capable of responding
     *     to TP.sig.UserInput signals so it can process the result when ready.
     * @returns {TP.shell.Shell} The receiver.
     */

    var req;

    if (TP.notValid(aRequest)) {
        req = TP.sig.UserInputRequest.construct();
        req.set('requestor', this);
    } else if (TP.isKindOf(aRequest, TP.sig.UserInputRequest)) {
        req = aRequest;
    } else {
        //  convert from collection form to UIR form
        req = TP.sig.UserInputRequest.construct(aRequest);
        req.set('requestor', this);
    }

    req.atPut('query', aQuery);
    req.atPut('default', aDefault);

    req.fire(this);

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('stdout',
function(anObject, aRequest) {

    /**
     * @method stdout
     * @summary Outputs the object provided using any parameters in the request
     *     to assist with formatting etc. Parameters include messageType,
     *     cmdAsIs, etc.
     * @param {Object} anObject The object to output.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object with optional
     *     values for messageType, cmdAsIs, etc.
     * @returns {TP.shell.Shell} The receiver.
     */

    var req;

    if (TP.notValid(aRequest)) {
        req = TP.sig.UserOutputRequest.construct();
        req.set('requestor', this);
    } else if (TP.isKindOf(aRequest, TP.sig.UserIORequest)) {
        req = aRequest;
    } else {
        //  Need to repackage in the proper subtype for processing.
        req = TP.sig.UserOutputRequest.construct(aRequest);
        req.set('requestor', this);
    }

    req.atPut('output', anObject);
    req.fire(this);

    return this;
});

//  ------------------------------------------------------------------------
//  Paths
//  ------------------------------------------------------------------------

/*
Methods relating to path expansion and path stack operation.
*/

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('addPath',
function(aPath) {

    /**
     * @method addPath
     * @summary Pushes a path on the path stack of the receiver. Paths in the
     *     path stack are used to support URI expansion operations. Paths are
     *     expanded when added so all paths in the stack are absolute paths once
     *     the add has completed.
     * @param {String} aPath The path description to add.
     * @returns {Number|undefined} The index of the path.
     */

    var path,

        list,

        pathmax,

        dups,

        i,
        offset;

    if (TP.notValid(path = this.expandPath(aPath))) {
        this.stderr('Path expansion failed for ' + aPath);

        return;
    }

    list = this.get('pathStack');

    pathmax = this.getVariable('PATHSIZE');
    if (TP.notValid(pathmax)) {
        pathmax = this.getType().PATH_MAX;
    }

    dups = TP.ifInvalid(this.getVariable('PATHDUP'), 'prev');
    dups.toLowerCase();

    if (dups === 'prev') {
        if (list.last() === path) {
            return;
        }
    } else if (dups === 'all') {
        for (i = list.getSize() - 1; i >= 0; i--) {
            if (list.at(i) === path) {
                return;
            }
        }
    }

    list.add(path);
    offset = list.getSize() - pathmax;
    if (offset > 0) {
        list.atPut(offset - 1, null);
    }

    //  return the index of the path so it can be tracked/displayed later
    return list.getSize() - 1;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('clearPaths',
function() {

    /**
     * @method clearPaths
     * @summary Empties the path stack.
     * @returns {TP.shell.Shell} The receiver.
     */

    this.get('pathStack').empty();

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('execute',
function(aRequest) {

    /**
     * @method execute
     * @summary The main command execution method, responsible for parsing and
     *     processing shell input in a fashion suitable for the specific
     *     requirements of each shell and for the specific content being
     *     processed.
     * @param {TP.sig.ShellRequest} aRequest The request containing command
     *     input.
     * @returns {TP.sig.ShellRequest} The request.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('expandPath',
function(aPath) {

    /**
     * @method expandPath
     * @summary Expands a path to absolute form using current path stack and
     *     environment information.
     * @description Expansion uses the following rules:
     *
     *     Absolute paths start with a scheme, either http(s) or file and are
     *     left unchanged by this process. All other paths are considered
     *     relative and are expanded as follows.
     *
     *     When a ~ is used as the start of a path the expansion is done
     *     relative to the current launch directory for the application, the
     *     default value of TP.getAppRoot() for ~app, or the library root if
     *     ~lib is specified.
     *
     *     Paths starting with an = followed by either - or a digit will be
     *     resolved to an entry in the path stack and replaced with that entry's
     *     value.
     *
     *     Paths starting with '/', './' or '../' are expanded relative to the
     *     current path, which is represented by the top of the directory stack
     *     at the time of resolution.
     * @param {String} aPath The path to expand.
     * @returns {String} aPath The expanded path.
     */

    var home,
        url,

        isURI,

        subs,
        schemes,

        arr,
        ndx,

        path;

    if (TP.isEmpty(aPath)) {
        return this.getPath();
    }

    home = this.getVariable('HOME');
    if (TP.notValid(home)) {
        home = TP.getAppRoot();
    }

    //  ensure we strip any quotes the user may have used
    url = aPath.unquoted();

    isURI = false;

    subs = TP.uri.URI.getSubtypes(true) || TP.ac();
    schemes = subs.collect(
                function(item) {

                    return item.get('SCHEME');
                });

    schemes.perform(
        function(item) {
            if (TP.isValid(item) && item !== '' && url.startsWith(item)) {
                isURI = true;
            }
        });

    if (isURI) {
        return url;
    }

    //  handle leading characters a bit differently since they're special
    if (aPath.startsWith('~app/')) {
        //  NB: We slice off the slash here too, so that TP.uriJoinPaths()
        //  doesn't think its absolute.
        url = TP.uriJoinPaths(home, aPath.slice(5));
    } else if (aPath.toLowerCase().startsWith('~lib/')) {
        //  NB: We slice off the slash here too, so that TP.uriJoinPaths()
        //  doesn't think its absolute.
        url = TP.uriJoinPaths(TP.getLibRoot(), aPath.slice(5));
    } else if (aPath.startsWith('~/')) {
        //  NB: We slice off the slash here too, so that TP.uriJoinPaths()
        //  doesn't think its absolute.
        url = TP.uriJoinPaths(TP.getAppHead(), aPath.slice(2));
    } else if (aPath.first() === '=') {
        arr = aPath.split('/');
        ndx = arr.shift().slice(1);

        if (ndx.equalTo('-')) {
            path = this.getPath();
            url = TP.uriJoinPaths(path, arr.join('/'));
        } else {
            if (!TP.isNaN(parseInt(ndx, 10))) {
                path = this.get('pathStack').at(ndx);
                if (TP.isString(path)) {
                    //  peel off the =N part and join what's left
                    url = TP.uriJoinPaths(path, arr.join('/'));
                }
            }
        }

        if (TP.notValid(url)) {
            this.stderr('Unable to resolve "=' + ndx + '"');
        }
    } else {
        //  not alpha? probably '.' or '/' so resolve it here
        if (/^[a-zA-Z]/.test(aPath)) {
            url = TP.uriResolvePaths(this.getPath(), aPath);
        }
    }

    return url;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('getPath',
function(anIndex) {

    /**
     * @method getPath
     * @summary Returns the path entry at the index provided, or at the current
     *     index if no value is provided.
     * @param {Number} anIndex The path index to look up.
     * @returns {String|undefined} The path entry.
     */

    var path;

    if (TP.isNumber(anIndex)) {
        path = this.$get('pathStack').at(anIndex);
    }

    //  tried to use an index, but it wasn't a number
    if (TP.isNumber(anIndex)) {
        this.raise('TP.sig.InvalidParameter', anIndex);

        return;
    }

    path = this.$get('pathStack').last();

    //  we use the lib root for defaults
    if (TP.notValid(path)) {
        return TP.getLibRoot();
    }

    return path;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('getLastPath',
function() {

    /**
     * @method getLastPath
     * @summary Returns the text of the last path entry.
     * @returns {String} The last path string.
     */

    return this.$get('pathStack').last();
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('removePath',
function(anIndex) {

    /**
     * @method removePath
     * @summary Removes the path at anIndex, or the last path in the list if no
     *     index is provided.
     * @param {Number} anIndex The index of the path to remove, if provided.
     * @returns {String|undefined} The path removed.
     */

    var list,
        item;

    list = this.$get('pathStack');
    if (list.getSize() === 0) {
        return;
    }

    if (TP.notValid(anIndex)) {
        item = this.getLastPath();
        list.removeLast();
    } else {
        if (list.getSize() > anIndex) {
            item = list.at(anIndex);
            list.removeAt(anIndex);
        } else {
            this.stderr('Path index not found for removal.');
        }
    }

    return item;
});

//  ------------------------------------------------------------------------
//  OBJECT RESOLUTION
//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('getExecutionContext',
function(aRequest) {

    /**
     * @method getExecutionContext
     * @summary Returns the execution context for the receiver, the window or
     *     frame used for eval calls. This is typically the window in which the
     *     code was loaded, and therefore virtually always the top window in a
     *     standard installation.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request or hash
     *     containing parameters.
     * @returns {Window} The execution context.
     */

    var ctx,
        win;

    //  does the request have an execution context? If so, use it.
    if (TP.isValid(aRequest) &&
        TP.isValid(ctx = aRequest.at('execContext'))) {
        return ctx;
    }

    //  already set or cached? quick exit
    if (TP.isValid(ctx = this.$get('context'))) {
        return ctx;
    }

    //  default when not set is to map it to the TIBET code frame.
    if (TP.isWindow(TP.global.$$TIBET)) {
        win = TP.global.$$TIBET;
    }

    //  "shouldn't happen" ;), but just in case...
    if (TP.notValid(win)) {
        win = window;
    }

    //  cache for next time, and build contextual evaluator while were at it
    this.setExecutionContext(win);

    return this.$get('context');
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('getExecutionInstance',
function(aRequest) {

    /**
     * @method getExecutionInstance
     * @summary Returns the execution instance, an object used to provide
     *     scoped variable support for the shell.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request or hash
     *     containing parameters.
     * @returns {Object} The execution instance.
     */

    var ctx,
        obj;

    //  does the request have an execution instance? If so, use it.
    if (TP.isValid(aRequest) &&
        TP.isValid(ctx = aRequest.at('execInstance'))) {
        return ctx;
    }

    if (TP.notValid(obj = this.$get('executionInstance'))) {

        //  NOTE! This *MUST* be an object that 'slots' can be placed directly
        //  on. In order for the shell to work properly, these slots will be
        //  copied back and forth to the context that the eval is happening in.

        obj = {};

        //  We do go ahead and instance program these methods onto this object
        //  for cleanliness in other places in the code. Note that we hide these
        //  methods so that they don't show up when we dump $SCOPE.
        TP.defineSlot(obj,
                        'at',
                        function(slotName) {
                            return this[slotName];
                        },
                        TP.METHOD, TP.LOCAL_TRACK, TP.HIDDEN_DESCRIPTOR);

        TP.defineSlot(obj,
                        'atPut',
                        function(slotName, slotValue) {
                            this[slotName] = slotValue;
                        },
                        TP.METHOD, TP.LOCAL_TRACK, TP.HIDDEN_DESCRIPTOR);

        TP.defineSlot(obj,
                        'getKeys',
                        function() {
                            return Object.keys(this);
                        },
                        TP.METHOD, TP.LOCAL_TRACK, TP.HIDDEN_DESCRIPTOR);

        TP.defineSlot(obj,
                        'hasKey',
                        function(slotName) {
                            return this[slotName] !== undefined;
                        },
                        TP.METHOD, TP.LOCAL_TRACK, TP.HIDDEN_DESCRIPTOR);

        TP.defineSlot(obj,
                        'removeKey',
                        function(slotName) {
                            delete this[slotName];
                        },
                        TP.METHOD, TP.LOCAL_TRACK, TP.HIDDEN_DESCRIPTOR);

        this.$set('executionInstance', obj);
    }

    return obj;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('resolveObjectReference',
function(anObjectSpec, aRequest, forArguments) {

    /**
     * @method resolveObjectReference
     * @summary Returns an object based on the string specification provided.
     *     This method will attempt to evaluate the spec as an expression as
     *     well as treating it like a tibet://URI in an attempt to locate the
     *     object.
     * @param {String} anObjectSpec An object spec or TIBET URI.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request or hash
     *     containing parameters.
     * @param {Boolean} [forArguments=false] Optional signifier that the
     *     resolution is occurring for a command argument rather than a pure
     *     reference. This largely matters only when using dereferencing.
     * @returns {Object} The object, if found.
     */

    var execInstance,
        execContext,

        spec,
        deref,

        url,
        resp,
        $$inst,
        parts,

        instType,

        isIdentifier,
        i,
        specs;

    //  We can't use non-Strings for object specifications anyway.
    if (!TP.isString(anObjectSpec)) {
        return anObjectSpec;
    }

    if (anObjectSpec.charAt(0) === '{' || anObjectSpec.charAt(0) === '[') {
        return TP.$tokenizedConstruct(anObjectSpec);
    }

    spec = anObjectSpec;

    //  The $SCOPE object (the local context object that shell variables have
    //  been set against)
    execInstance = this.getExecutionInstance();

    //  The $CONTEXT object (the global context shell code is being eval'ed in)
    execContext = this.getExecutionContext();

    //  If 'spec' matches shell 'dereference sugar' (i.e. '@foo'), then we have
    //  to strip the leading '@'.
    if (TP.regex.TSH_DEREF_SUGAR.test(spec)) {
        spec = spec.slice(1);
        //  Can only dereference a variable, not a standard value.
        if (spec.charAt(0) !== '$') {
            spec = '$' + spec;
        }
        deref = true;
    }

    //  Convert any shell variable that starts with '${' and ends with '}' to
    //  it's plain form.
    //  NB: We do *not* want to use the TP.regex.TSH_VARSUB_EXTENDED replacement
    //  technique here, since we're only looking at the start and the end of the
    //  entire expression for variable conversion - leaving anything in the
    //  interior along.
    if (spec.startsWith('${') && spec.endsWith('}')) {
        spec = '$' + spec.slice(2, -1);
    }

    //  Convert 'Meta*' references to their true internal names.
    if (spec.indexOf('MetaInst') === 0) {
        spec = spec.replace(/^MetaInst/, 'TP.META_INST_OWNER');
        //  Remove any 'track' reference. It won't resolve (or help).
        spec = spec.replace(/\.MetaInst/, '');
    } else if (spec.indexOf('MetaType') === 0) {
        spec = spec.replace(/^MetaType/, 'TP.META_TYPE_OWNER');
        //  Remove any 'track' reference. It won't resolve (or help).
        spec = spec.replace(/\.MetaType/, '');
    }

    //  With most of our desugaring done can we just use getObjectById? Let's
    //  see if the spec is a JS identifer (or dot-separated JS identifier).
    isIdentifier = false;
    specs = spec.split('.');
    for (i = 0; i < specs.getSize(); i++) {
        if (!TP.regex.JS_IDENTIFIER.test(specs.at(i))) {
            //  Not a JS identifier - can't use it as such.
            isIdentifier = false;
            break;
        }
        isIdentifier = true;
    }

    if (isIdentifier) {
        $$inst = TP.sys.getObjectById(spec);
        if (TP.isValid($$inst)) {
            if (deref && TP.notTrue(forArguments)) {
                //  TODO:   check forArguments flag and act accordingly
                if (TP.canInvoke($$inst, 'cmdGetContent')) {
                    $$inst = $$inst.cmdGetContent(aRequest);
                } else if (TP.canInvoke($$inst, 'getType')) {
                    instType = $$inst.getType();
                    if (TP.canInvoke(instType, 'cmdGetContent')) {
                        $$inst = instType.cmdGetContent(aRequest);
                    }
                }
            }

            return $$inst;
        }
    }

    if (TP.regex.VALID_NAMESPACENAME.test(spec)) {
        parts = TP.regex.VALID_NAMESPACENAME.match(spec);
        $$inst = TP.global[parts.at(1)][parts.at(2)];
        if (TP.isValid($$inst) && TP.isNamespace($$inst)) {
            return $$inst;
        }
    }

    try {
        if (TP.regex.URI_LIKELY.test(spec) &&
            !TP.regex.REGEX_LITERAL_STRING.test(spec)) {
            url = this.expandPath(spec);
            if (TP.isURI(url = TP.uc(url))) {
                resp = url.getResource(TP.hc('async', false));
                $$inst = resp.get('result');
            }
        } else if (execInstance.hasKey(spec)) {
            $$inst = execInstance.at(spec);
        } else {

            //  eval has problems with Object and Function literals, but
            //  wrapping them in parentheses helps...

            //  Object literals
            if (spec.charAt(0) === '{' &&
                spec.charAt(spec.length - 1) === '}') {
                spec = '(' + spec + ')';
            }

            //  Function literals
            //  Note that this RegExp is normally used for extracting the name,
            //  but works well here to just detect Function literals...
            if (Function.$$getNameRegex.test(spec)) {
                spec = '(' + spec + ')';
            }

            try {
                $$inst = execContext.eval(spec);

                //  If the spec points to a 'special Window property' that is
                //  *not* a Window reference itself (i.e. an iframe Window),
                //  then we don't resolve it but just return undefined.
                if (TP.sys.$windowglobals.hasKey(spec) &&
                    !TP.isWindow($$inst)) {
                    return;
                }

                if (TP.notValid($$inst)) {
                    if (TP.regex.NS_QUALIFIED.test(spec)) {
                        $$inst = execContext.eval(
                                    '\'' + spec + '\'.asType()');
                    }
                }
            } catch (e2) {
                if (TP.regex.NS_QUALIFIED.test(spec)) {
                    $$inst = execContext.eval(
                                '\'' + spec + '\'.asType()');
                }
            }

        }

    } catch (e) {
        $$inst = undefined;
    }

    //  We don't "dive in" to cmd* method references for simple argument usage,
    //  only for sink processing.
    if (TP.isTrue(deref) && TP.notTrue(forArguments)) {
        if (TP.canInvoke($$inst, 'cmdGetContent')) {
            $$inst = $$inst.cmdGetContent(aRequest);
        } else if (TP.canInvoke($$inst, 'getType')) {
            instType = $$inst.getType();
            if (TP.canInvoke(instType, 'cmdGetContent')) {
                $$inst = instType.cmdGetContent(aRequest);
            }
        }
    }

    return $$inst;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('resolveVariableSubstitutions',
function(aString) {

    /**
     * @method resolveVariableSubstitutions
     * @summary Handles variable substitution syntax, typically in values
     *     provided as command tag attributes or content.
     * @param {String} aString A string requiring resolution.
     * @returns {String} The string with resolved variable substitutions.
     */

    var str;

    str = aString;

    //  We special case the standard "stdin" variable $_ so it doesn't have
    //  to be mentioned in an enclosing ${...} construct (${_}).
    if (str === '$_') {
        return this.getExecutionInstance().at('$_');
    }

    //  Don't expand variables being used as part of a dereferencing operation.
    if (/@\$/.test(str)) {
        return str;
    }

    //  Don't expand strings that are single-quoted.
    if (str.unquoted().quoted('\'') === str) {
        return str;
    }

    if (TP.regex.TSH_VARSUB.test(str)) {
        str = str.replace(
                TP.regex.TSH_VARSUB,
                function(wholeMatch, varName) {
                    var value;

                    value = this.getExecutionInstance().at('$' + varName);

                    //  If the variable isn't defined in scope return it so the
                    //  string value "exposes" that variable as being
                    //  unresolved.
                    if (TP.notDefined(value)) {
                        return wholeMatch;
                    }

                    return value;
                }.bind(this));
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('setExecutionContext',
function(aWindow) {

    /**
     * @method setExecutionContext
     * @summary Sets the execution context, the window or frame used for eval
     *     calls. A side-effect of this call is that a local method for
     *     executing native JS is installed which uses the context
     *     window/frame's eval call for processing.
     * @param {Window|String} aWindow The window or frame to target, either as a
     *     reference or a string ID.
     * @returns {Window} The new context.
     */

    var win;

    win = TP.ifInvalid(aWindow, window);
    if (!TP.isWindow(win)) {
        if (TP.isString(win)) {
            win = TP.bySystemId(win);
            if (TP.notValid(win)) {
                return this.raise('TP.sig.InvalidWindow');
            } else if (!TP.isWindow(win)) {
                if (!TP.isFunction(win.getNativeWindow)) {
                    return this.raise('TP.sig.InvalidWindow');
                } else {
                    win = win.getNativeWindow();
                }
            }
        } else if (TP.isFunction(win.getNativeWindow)) {
            if (!TP.isWindow(win = win.getNativeWindow())) {
                return this.raise('TP.sig.InvalidWindow');
            }
        } else {
            return this.raise('TP.sig.InvalidWindow');
        }
    }

    this.$set('context', win);

    return win;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('updateCommandNode',
function(aRequest, shouldReport) {

    /**
     * @method updateCommandNode
     * @summary Handles variable substitution syntax, typically in values
     *     provided as command tag attributes or content, specifically expanding
     *     attribute values on the request's command node.
     * @param {TP.sig.Request} aRequest A TP.sig.TSHRunRequest in most cases.
     * @param {Boolean} shouldReport Whether to report missing substitutions or
     *     not. Default is true.
     * @returns {Node} The fully interpolated command node.
     */

    var node,
        len,
        i;

    if (TP.notValid(node = aRequest.at('cmdNode'))) {
        return aRequest.fail();
    }

    if (!TP.isElement(node)) {
        return aRequest.fail();
    }

    len = node.attributes.length;
    for (i = 0; i < len; i++) {
        node.attributes[i].value =
            this.resolveVariableSubstitutions(node.attributes[i].value);
    }

    return node;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('updateExecutionInstance',
function(aRequest) {

    /**
     * @method updateExecutionInstance
     * @summary Updates the execution instance ($SCOPE object) with the data
     *     from the request to help ensure that variable substitution and other
     *     data access references are current.
     * @param {TP.sig.Request} aRequest A TP.sig.TSHRunRequest in most cases.
     * @returns {Object} The updated execution instance ($SCOPE object).
     */

    var scope,

        len,
        i,

        stdin;

    scope = this.getExecutionInstance();

    len = this.getType().POSITIONAL_MAX;

        //  clear any existing positional arguments in the scope...
    for (i = 0; i < len; i++) {
        if (TP.notDefined(scope.at('$' + i))) {
            break;
        }

        delete scope['$' + i];
    }

    //  update the $INPUT value to point to the first available data.
    stdin = aRequest.stdin();
    scope.atPut('$INPUT', stdin.at(0));

    if (aRequest.at('cmdIterate')) {
        //  Looping/iteration has to be handled by individual tags.
        scope.atPut('$_', null);
    } else {
        scope.atPut('$_', scope.at('$INPUT'));

        //  populate any new positional parameters for the request.
        for (i = 0; i < stdin.length; i++) {
            scope.atPut('$' + i, stdin.at(i));
        }
    }

    return scope;
});

//  ------------------------------------------------------------------------
//  REQUEST SUGARS
//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('getArgument',
function(aRequest, argumentName, defaultValue, searchAll, wantsOriginal) {

    /**
     * @method getArgument
     * @summary Returns a single value acquired from the current command node's
     *     primary argument, argv, or the node's content.
     * @description A number of tags have a single argument which defines the
     *     target of the tag's operation. For sugaring purposes it's not
     *     uncommon for that argument's name to be left off so that the argument
     *     value ends up in the argv vector. Alternatively the argument content
     *     can end up in the tag's content. This method will search them all
     *     when searchAll is true, or will stop the search with the argument
     *     hash if not.
     * @param {TP.sig.ShellRequest} aRequest The request to query.
     * @param {String} argumentName The name of the argument to get the value
     *     for.
     * @param {Object} defaultValue The default value for the argument if a
     *     value can't be found.
     * @param {Boolean} searchAll Whether or not to search all places an
     *     argument could be (by name, by argv '0' or by content). The default
     *     is false.
     * @param {Boolean} wantsOriginal Whether or not to return the 'original
     *     value' of the argument (i.e. the value actually given by the script
     *     author, before any substitution was performed). The default is false.
     * @returns {String} The argument value.
     */

    var args,
        value,
        node,
        vals;

    //  Because we supply true as the second parameter here, this method returns
    //  a pair of values per argument name: [original, expanded]
    if (TP.notValid(args = this.getArguments(aRequest, TP.ALLFORMS))) {
        //  This might be null or undefined - that's ok
        return defaultValue;
    }

    //  Did we get any results for this argument (i.e. was it supplied at all?)
    if (TP.isValid(value = args.at(argumentName))) {
        //  Usually the user wants the expanded value, but they might have
        //  specified otherwise.
        if (argumentName === 'ARGV') {
            if (wantsOriginal) {
                value = value.collect(
                        function(item) {
                            return item.first();
                        });
            } else {
                value = value.collect(
                        function(item) {
                            return item.last();
                        });
            }

            return value;
        } else {
            value = wantsOriginal ? value.first() : value.last();
            if (TP.isValid(value)) {
                return value;
            }
        }
    }

    //  if a simple name check failed we fall back to position 0, and then
    //  to the element's content when searching for a "primary argument"
    if (searchAll) {

        //  If there's something in position 0, look there
        if (TP.isValid(value = args.at('ARG0'))) {
            value = wantsOriginal ? value.first() : value.last();
            if (TP.isValid(value)) {
                return value;
            }
        }

        //  NOTE that when we use content we have to process it and cache
        //  the resulting value to keep overhead down
        node = aRequest.at('cmdNode');
        if (TP.isElement(node)) {
            if (TP.notEmpty(value = TP.nodeGetTextContent(node))) {
                vals = TP.ac(value,
                                this.resolveVariableSubstitutions(
                                    TP.xmlEntitiesToLiterals(value)));

                //  cache it
                args.atPut(argumentName, vals);

                value = wantsOriginal ? vals.first() : vals.last();

                return value;
            }
        }
    }

    //  Couldn't find any value, even after 'searching all' - return default
    //  value.
    return defaultValue;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('getArguments',
function(aRequest, forms) {

    /**
     * @method getArguments
     * @summary Returns a hash of key/value pairs where the keys are the
     *     request command node's attribute names and the values are the
     *     attribute values. These represent the named parameters and flags
     *     provided to the command. Positional arguments are named ARG0 through
     *     ARG[n] within this hash and the key ARGV contains an array of those.
     * @param {TP.sig.ShellRequest} aRequest The request to query.
     * @param {String} [forms=TP.EXPANDED] Which forms (TP.ORIGINAL,
     *     TP.EXPANDED, or TP.ALLFORMS) should be returned.
     * @returns {TP.core.Hash|undefined} The hash of named arguments with either
     *     individual expanded values, individual original values, or an Array
     *     of values for each entry (original, expanded).
     */

    var newDict,
        aspect,
        node,
        shell,
        args,
        index,
        dict,
        format,

        prefix,
        keyTester,

        argKeys,
        len,
        i,
        argKey;

    format = TP.ifInvalid(forms, TP.EXPANDED);

    if (TP.isValid(dict = aRequest.get('ARGUMENTS'))) {

        //  If the caller specified that they wanted all forms of the value,
        //  then just hand back the full dictionary.
        if (format === TP.ALLFORMS) {
            return dict;
        }

        aspect = format === TP.ORIGINAL ? 'first' : 'last';

        //  Collect the values (original or expanded) being requested.
        newDict = TP.hc();
        dict.perform(
            function(kvPair) {
                var key,
                    val,
                    arr;

                key = kvPair.first();
                val = kvPair.last();

                if (key !== 'ARGV') {
                    //  Remember value is an array of original, expanded.
                    newDict.atPut(key, val[aspect]());
                } else {
                    //  ARGV is special. It's the only nested structure.
                    arr = val.collect(
                                function(item) {
                                    return item[aspect]();
                                });

                    newDict.atPut(key, arr);
                }
            });

        return newDict;
    }

    node = aRequest.at('cmdNode');
    if (!TP.isElement(node)) {
        TP.raise(this,
                    'TP.sig.InvalidElement',
                    'Command node not an element.');

        return;
    }

    /* eslint-disable consistent-this */
    shell = this;

    args = TP.elementGetAttributes(node);
    dict = TP.hc();
    index = 0;

    //  convert string values into their equivalent boolean forms and
    //  process any interpolations within attribute values
    args.perform(
        function(item) {
            var name,
                value,
                argv,
                argvParts,
                parts,
                val,
                j,
                lenj,
                argvPart,
                chunk,
                stop,
                part,
                partName,
                expandedVal,
                reParts,
                reText;

            name = item.first();
            value = TP.xmlEntitiesToLiterals(item.last().trim());

            if (name === 'tsh:argv') {

                argv = TP.ac();
                dict.atPut('ARGV', argv);

                argvParts = TP.$tokenizedSplit(value);

                lenj = argvParts.getSize();
                for (j = 0; j < lenj; j++) {
                    argvPart = argvParts.at(j);

                    //  Make sure to null out val and expandedVal
                    val = null;
                    expandedVal = null;
                    chunk = null;

                    //  Substitution/expansion logic below will require a token
                    //  to inspect so we retokenize the individual argument. If
                    //  that results in something that's not "atomic" we treat
                    //  it as a string token.
                    parts = TP.$tokenize(
                                argvPart,
                                TP.tsh.script.$tshAndJSOperators,
                                true, false, false, true);

                    if (parts.length > 1) {
                        partName = parts.at(0).name;
                        part = {
                            name: partName,
                            value: argvPart
                        };
                    } else {
                        part = parts.at(0);
                    }

                    //  If it's a Number or RegExp literal string, then
                    //  try to turn it into one of those objects
                    if (part.name === 'number') {
                        //  Handle Numbers
                        expandedVal = part.value.asNumber();
                    } else if (part.name === 'regexp') {
                        //  Handle RegExps
                        reParts = part.value.split('/');
                        reText = TP.tsh.eval.expandContent(
                                        reParts.at(1), shell, aRequest);
                        expandedVal = TP.rc(reText, reParts.at(2));
                    } else if (part.name === 'keyword' &&
                                (part.value === 'true' ||
                                 part.value === 'false')) {
                        //  Handle Booleans
                        expandedVal = TP.bc(part.value);
                    } else if (part.name === 'string') {
                        //  Handle Strings
                        if (part.value.charAt(0) === '"') {
                            //  Strip the quotes and let the expanded value be
                            //  produced down below during value expansion.
                            val = part.value.unquoted();
                        } else if (part.value.charAt(0) === '\'') {
                            //  Strip the quotes but also set the expanded value
                            //  so no further expansion happens down below.
                            expandedVal = part.value.unquoted();
                            val = part.value.unquoted();
                        }
                    } else if (part.name === 'substitution' ||
                                part.name === 'template' ||
                                part.name === 'identifier') {
                        //  Before we unquote check for `substitution`. If
                        //  we find those we need to expand content, then
                        //  optionally resolve object references to see if we
                        //  evaluated to a number, boolean, etc.
                        if (part.value.charAt(0) === '`') {
                            val = TP.tsh.eval.expandContent(part.value,
                                shell, aRequest);
                            expandedVal = shell.resolveObjectReference(val);
                            expandedVal = TP.ifUndefined(expandedVal, val);
                        } else {
                            val = part.value.unquoted();
                        }

                        if (val.startsWith('${') && val.endsWith('}')) {
                            //  This might not find a value, but if it does we
                            //  essentially are resolving the identifier.
                            expandedVal = shell.getVariable(
                                '$' + val.slice(2, -1));
                        } else if (part.name === 'identifier') {
                            expandedVal = shell.resolveObjectReference(
                                part.value);
                            expandedVal = TP.ifUndefined(expandedVal,
                                part.value);
                        }
                    } else if (part.name === 'operator' &&
                        (part.value.charAt(0) === '[' ||
                         part.value.charAt(0) === '{')) {

                        //  The trick here is that we're working with an array
                        //  of parts split on whitespace, so we can have things
                        //  like '[1' or 'a:' etc. We have to essentially scan
                        //  for the closing token and then cause our index to
                        //  adjust beyond the range of the object.
                        if (argvPart === '[]') {
                            expandedVal = '[]';
                        } else if (argvPart === '{}') {
                            expandedVal = '{}';
                        } else {
                            stop = part.value.charAt(0) === '[' ? ']' : '}';
                            chunk = '';
                            while (argvPart && argvPart.last() !== stop) {
                                chunk += argvPart;
                                j++;
                                argvPart = argvParts[j];
                            }

                            if (argvPart && argvPart.last() === stop) {
                                chunk += argvPart;
                            }

                            expandedVal = TP.$tokenizedConstruct(chunk);
                        }
                    } else {
                        expandedVal = part.value;
                    }

                    //  If we don't have an 'expanded value', then call upon the
                    //  TP.tsh.eval type to expand / resolve the value. Which
                    //  one depends on quoting and whether the value is an
                    //  atomic variable reference or not.
                    if (TP.isValid(val) && TP.notValid(expandedVal)) {
                        if (TP.regex.TSH_VARIABLE.test(val) ||
                                TP.regex.TSH_VARIABLE_DEREF.test(val)) {

                            expandedVal = shell.resolveObjectReference(
                                                                val, true);

                            //  Requote if original references were
                            //  string-based.
                            if (part.value.charAt(0) === '"') {
                                expandedVal = TP.str(expandedVal);
                            }
                        } else {
                            expandedVal = TP.tsh.eval.expandContent(
                                            val, shell, aRequest);

                            if (expandedVal === 'null') {
                                expandedVal = null;
                            } else if (expandedVal === 'undefined') {
                                expandedVal = undefined;
                            }
                        }
                    }

                    //  If the expanded value is an Array or a plain Object,
                    //  then we use the JSON representation as the final
                    //  expanded value. Otherwise, if we use asString(), an
                    //  empty Array and a plain Object will produce empty
                    //  strings, rather than '[]' and '{}', respectively.
                    if (TP.isArray(expandedVal) ||
                        TP.isPlainObject(expandedVal)) {
                        expandedVal = TP.js2json(expandedVal);
                    } else {
                        expandedVal = TP.str(expandedVal);
                        if (expandedVal === 'null') {
                            expandedVal = null;
                        } else if (expandedVal === 'undefined') {
                            expandedVal = undefined;
                        }
                    }

                    //  The value we use for the 'original' value depends on
                    //  whether the initial value was quoted. When we get
                    //  unquoted arguments (42, true, etc) we consider the
                    //  original to be that value, not the string version.
                    if (TP.regex.TSH_QUOTECHAR.test(part.value.charAt(0))) {
                        part = TP.ac(part.value, expandedVal);
                    } else {
                        switch (format) {
                            case TP.ORIGINAL:
                                //  requestor asked for original values as part
                                //  of return value so we explicitly don't
                                //  convert here.
                                part = TP.ac(chunk || part.value, expandedVal);
                                break;
                            case TP.EXPANDED:
                                part = TP.ac(expandedVal, expandedVal);
                                break;
                            case TP.ALLFORMS:
                                //  requestor asked for all forms of the values
                                //  as part of return value so we explicitly
                                //  don't convert here.
                                part = TP.ac(chunk || part.value, expandedVal);
                                break;
                            default:
                                break;
                        }
                    }

                    dict.atPut('ARG' + index, part);
                    argv.push(part);

                    index++;
                }

            } else if (!TP.shell.Shell.INVALID_ARGUMENT_MATCHER.test(name)) {
                val = value;
                expandedVal = null;

                //  Filter all of the 'internal' keys that aren't really
                //  arguments.
                if (val === 'true' || val === 'false') {
                    //  Handle Booleans
                    expandedVal = TP.bc(val);
                } else if (TP.regex.REGEX_LITERAL_STRING.test(val)) {
                    //  Handle RegExps
                    reParts = val.split('/');
                    reText = TP.tsh.eval.expandContent(
                                reParts.at(1), shell, aRequest);
                    expandedVal = TP.rc(reText, reParts.at(2));
                } else if (TP.regex.ANY_NUMBER.test(val) ||
                            TP.regex.PERCENTAGE.test(val)) {
                    expandedVal = val.asNumber();
                } else {
                    //  Handle Strings

                    //  We have three forms of "quoting" using either single,
                    //  double, or backtick for different semantic meanings.
                    if (val.charAt(0) === '"') {
                        val = val.unquoted();
                    } else if (val.charAt(0) === '\'') {
                        expandedVal = val.unquoted();
                        val = val.unquoted();
                    } else if (val.charAt(0) === '`') {
                        val = TP.tsh.eval.expandContent(value, shell, aRequest);
                        expandedVal = shell.resolveObjectReference(val);
                        expandedVal = TP.ifUndefined(expandedVal, val);
                    }

                    //  If we don't have an 'expanded value', then call upon the
                    //  TP.tsh.eval type to expand this content for us. Content
                    //  expansion includes command substitution (i.e. `...`
                    //  constructs) and template rendering but *not* variable
                    //  substitution and/or object resolution.
                    if (TP.isValid(val) && TP.notValid(expandedVal)) {
                        if (TP.regex.TSH_VARIABLE.test(val) ||
                                TP.regex.TSH_VARIABLE_DEREF.test(val)) {

                            expandedVal = shell.resolveObjectReference(
                                                                val, true);

                            //  Requote if original references were
                            //  string-based.
                            if (value.charAt(0) === '"') {
                                expandedVal = TP.str(expandedVal);
                            }
                        } else {
                            expandedVal = TP.tsh.eval.expandContent(
                                val, shell, aRequest);
                            if (expandedVal === 'null') {
                                expandedVal = null;
                            } else if (expandedVal === 'undefined') {
                                expandedVal = undefined;
                            }
                        }
                    }
                }

                //  If the expanded value is an Array or a plain Object, then we
                //  use the JSON representation as the final expanded value.
                //  Otherwise, if we use toString(), an empty Array will produce
                //  an empty string, rather than '[]' and plain Objects will
                //  always produce '[object Object]'.
                if (TP.isArray(expandedVal) || TP.isPlainObject(expandedVal)) {
                    expandedVal = TP.js2json(expandedVal);
                } else {
                    expandedVal = TP.tostr(expandedVal);
                }

                //  The value we use for the 'original' value depends on whether
                //  the initial value was quoted. When we get unquoted arguments
                //  (42, true, etc) we consider the original to be that value,
                //  not the string version.
                if (TP.regex.TSH_QUOTECHAR.test(value.charAt(0))) {
                    dict.atPut(name, TP.ac(value, expandedVal));
                } else {
                    switch (format) {
                        case TP.ORIGINAL:
                            //  requestor asked for original values as part of
                            //  return value so we explicitly don't convert
                            //  here.
                            dict.atPut(name, TP.ac(value, expandedVal));
                            break;
                        case TP.EXPANDED:
                            dict.atPut(name, TP.ac(expandedVal, expandedVal));
                            break;
                        case TP.ALLFORMS:
                            //  requestor asked for all forms of the values as
                            //  part of return value so we explicitly don't
                            //  convert here.
                            dict.atPut(name, TP.ac(value, expandedVal));
                            break;
                        default:
                            break;
                    }
                }
            }
        });

    /* eslint-enable consistent-this */

    //  Make sure there's at least an empty ARGV, if one hasn't been populated
    //  above.
    dict.atPutIfAbsent('ARGV', TP.ac());

    aRequest.set('ARGUMENTS', dict);

    //  Iterate over all of the arguments and, if they don't have any prefix
    //  and they're not the ARGV argument, make a prefixed version of the
    //  argument using that prefix with the same value.
    prefix = TP.w3.Xmlns.getCanonicalPrefix(
                            aRequest.at('cmdNode').namespaceURI);
    keyTester = /^(\w+:|ARGV)/;

    argKeys = TP.keys(dict);
    len = argKeys.getSize();
    for (i = 0; i < len; i++) {
        argKey = argKeys.at(i);
        if (!keyTester.test(argKey)) {
            dict.atPut(prefix + ':' + argKey, dict.at(argKey));
        }
    }

    if (this.getVariable('LOGARGS')) {
        TP.info('TSH args: ' + TP.dump(dict));
    }

    if (format === TP.ALLFORMS) {
        return dict;
    } else {
        return this.getArguments(aRequest);
    }
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('hasTrueArgument',
function(aRequest, anArgument) {

    /**
     * Returns true if the incoming request has a value for the argument which
     * shows that argument as "true" in a TIBET sense (i.e. TIBET's boolean
     * checks would say the value represents true if it's a string) or the
     * value is consistent with markup-based existence attributes such as
     * --checked="checked".
     * @param {TP.sig.ShellRequest} aRequest The request to query.
     * @param {String} The argument name to check.
     * @returns {Boolean} True if the argument exists.
     */

    this.todo();

    return false;
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('hasArguments',
function(aRequest) {

    /**
     * Returns true if the incoming request has at least one usable argument.
     * @param {TP.sig.ShellRequest} aRequest The request to query.
     * @returns {Boolean} True for non-zero argument lists.
     */

    var args,
        keys;

    args = this.getArguments(aRequest, TP.ALLFORMS);
    keys = args.getKeys();

    if (keys.getSize() > 1) {
        return true;
    }

    return TP.notEmpty(args.at('ARGV'));
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('getParam',
function(aRequest, parameterName) {

    /**
     * @method getParam
     * @summary Returns a single value acquired from the current command node's
     *     child <param> tags, if any.
     * @param {TP.sig.ShellRequest} aRequest The request to query.
     * @param {String} parameterName The parameter to look up.
     * @returns {String} The parameter value.
     */

    var params;

    params = this.getParams(aRequest);

    return params.at(parameterName);
});

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('getParams',
function(aRequest) {

    /**
     * @method getParams
     * @summary Returns a hash of key/value pairs where the keys are the
     *     request command node's child <param> names and the values are the
     *     <param> values.
     * @param {TP.sig.ShellRequest} aRequest The request to query.
     * @returns {TP.core.Hash|undefined} The hash of named parameters.
     */

    var dict,

        node;

    if (TP.isValid(dict = aRequest.get('PARAMS'))) {
        return dict;
    }

    node = aRequest.at('cmdNode');
    if (!TP.isElement(node)) {
        TP.raise(this,
                    'TP.sig.InvalidElement',
                    'Command node not an element.');

        return;
    }

    dict = TP.hc();

    //  TODO:   restructure what's here to simply ask the tsh:param tag
    //  (which isn't a real type at this point) to getName/getValue so we
    //  can override and add other behavior (like "trigger action on
    //  refresh" or something so bound param/name/value tags can cause a
    //  service invocation when their source data causes a new parameter
    //  value to be assigned).

    //  iterate over child elements and process those whose local name is
    //  param (we don't worry about alternative namespaces here).
    TP.nodeChildElementsPerform(
        node,
        function(item) {

            var name,

                child,

                value;

            if (TP.elementGetFullName(item) !== 'tsh:param') {
                return;
            }

            //  three options for param tags, either name/value on the
            //  tag, or name on the tag, value in the child content, or
            //  both in the param tag as child content.
            if (TP.isEmpty(name = TP.elementGetAttribute(item,
                                                            'tsh:name',
                                                            true))) {
                name = TP.nodeGetChildTextContent(item, 'tsh:name');
                if (TP.isEmpty(name)) {
                    if (TP.isElement(
                                child = TP.nodeGetFirstElementChildByTagName(
                                                        item, 'tsh:name'))) {
                        name = TP.wrap(child).getBoundInput();
                    }

                    if (TP.isEmpty(name)) {
                        TP.raise(item, 'TP.sig.InvalidElement',
                            '<param> tag has no name property or child.');

                        return TP.BREAK;
                    }
                }
            }

            if (TP.isEmpty(value = TP.elementGetAttribute(item,
                                                            'tsh:value',
                                                            true))) {
                value = TP.nodeGetChildTextContent(item, 'tsh:value');
                if (TP.isEmpty(value)) {
                    if (TP.isElement(
                                child = TP.nodeGetFirstElementChildByTagName(
                                                        item, 'tsh:value'))) {
                        value = TP.wrap(child).getBoundInput();
                    }

                    if (TP.isEmpty(value)) {
                        TP.raise(item,
                                    'TP.sig.InvalidElement',
                                    '<param> tag has no value property' +
                                    ' or child.');

                        return TP.BREAK;
                    }
                }
            }

            dict.atPut(name, value);
        });

    aRequest.set('PARAMS', dict);

    return dict;
});

//  ------------------------------------------------------------------------
//  COMMON BUILT-INS
//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('executeAbout',
function(aRequest) {

    /**
     * @method executeAbout
     * @summary Displays information about the current shell.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request or hash
     *     containing parameters.
     */

    var str;

    str = TP.ifInvalid(this.get('announcement'), '');
    str += TP.ifInvalid(this.get('introduction'), '');

    return aRequest.complete(str);
});

TP.shell.Shell.addHelpTopic('about',
    TP.shell.Shell.Inst.getMethod('executeAbout'),
    'Outputs a simple identification string.',
    ':about',
    'Identifies the current TIBET environment.');

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('executeAlias',
function(aRequest) {

    /**
     * @method executeAlias
     * @summary Processes alias-related commands which can list all aliases,
     *     list the value of a specific alias, define an alias, or remove an
     *     alias (by setting its value to null or to the key).
     * @param {TP.sig.ShellRequest} aRequest The request which triggered this
     *     command.
     * @returns {TP.sig.Request} The request.
     */

    var shell,
        argv,

        name,
        value,

        node;

    shell = aRequest.at('cmdShell');
    argv = this.getArgument(aRequest, 'ARGV');

    switch (argv.getSize()) {
        case 0:

            //  listing
            aRequest.stdout(shell.get('aliases'));
            break;

        case 1:

            //  list single value
            name = argv.at(0);

            aRequest.stdout(shell.getAlias(name));
            break;

        case 2:

            //  set/unset value
            name = argv.at(0);
            value = argv.at(1);

            if (value === 'null' || value === name) {
                shell.unsetAlias(name);
            } else {
                //  When we set an alias from the command line we have to
                //  be sensitive to the quoting rules for variable
                //  interpolation. Double-quoted values get interpolated
                //  while single quoted values are preserved "as-is".
                shell.setAlias(name, value);
            }

            aRequest.stdout(shell.getAlias(name));
            break;

        default:

            //  syntax error
            node = aRequest.at('cmdNode');
            return aRequest.fail(
                        'Too many arguments: ' + TP.str(node));
    }

    return aRequest.complete();
});

TP.shell.Shell.addHelpTopic('alias',
    TP.shell.Shell.Inst.getMethod('executeAlias'),
    'Define or display a command alias.',
    ':alias [name] [value]',
    'Displays all aliases, a single alias or creates/deletes an alias (to' +
    ' delete, supply null as the alias value)');

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('executeClear',
function(aRequest) {

    /**
     * @method executeClear
     * @summary Clears any receiver-related console display by issuing a
     *     TP.sig.ConsoleRequest. If there is no associated console then the
     *     signal is simply ignored.
     * @param {TP.sig.ShellRequest} aRequest The request which triggered this
     *     command.
     * @returns {TP.sig.Request} The request.
     */

    var req;

    req = TP.sig.ConsoleRequest.construct(
                        TP.hc('cmd', 'clear',
                                'cmdSilent', true));
    req.fire(this);

    return aRequest.complete();
});

TP.shell.Shell.addHelpTopic('clear',
    TP.shell.Shell.Inst.getMethod('executeClear'),
    'Clears the console output.',
    ':clear',
    'Clears the entire console output region.');

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('executeConfig',
function(aRequest) {

    /**
     * @method executeConfig
     * @summary A shortcut specific to working with setcfg/getcfg to manage
     *     TIBET and application configuration values.
     * @param {TP.sig.ShellRequest} aRequest The request which triggered this
     *     command.
     * @returns {TP.sig.Request} The request.
     */

    var name,
        value,

        hash;

    name = this.getArgument(aRequest, 'name');
    value = this.getArgument(aRequest, 'ARG0');

    //  One common case is name=value which will mean value is empty and name
    //  isn't the real name...
    /* eslint-disable no-div-regex */
    if (/=/.test(name)) {
        value = name.slice(name.indexOf('=') + 1);
        name = name.slice(0, name.indexOf('='));
    }
    /* eslint-enable no-div-regex */

    if (TP.isEmpty(name)) {
        //  listing....here we combine both env and cfg data
        hash = TP.hc();
        hash.addAll(TP.sys.cfg());
        hash.addAll(TP.sys.env());
        hash.sort();

        aRequest.stdout(hash);
    } else if (TP.isEmpty(value)) {
        //  list single value
        if (name.indexOf('.') > -1) {
            aRequest.stdout(name + ',' + TP.sys.cfg(name));
        } else {
            aRequest.stdout(TP.hc(TP.sys.cfg(name)).sort());
        }
    } else {
        //  set a config value...note that the value of argv is actually all
        //  positional parameters collected, so it works like "auto-quoting"
        if (TP.notDefined(TP.sys.get('configuration').at(name))) {
            TP.ifWarn() ?
                TP.warn('Unknown config setting: ' + name) : 0;
        }

        TP.sys.setcfg(name, value);
        aRequest.stdout(TP.sys.cfg(name));
    }

    return aRequest.complete();
});

TP.shell.Shell.addHelpTopic('config',
    TP.shell.Shell.Inst.getMethod('executeConfig'),
    'Generates a list of TIBET configuration values.',
    ':config [name[=value]]',
    'Shows the names and values for all configuration values if no arguments' +
    ' are supplied, shows the value for one if its name is supplied, or sets' +
    ' the value if both a name and value are supplied.');

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('executeHelp',
function(aRequest) {

    /**
     * @method executeHelp
     * @summary
     * @param {TP.sig.ShellRequest} aRequest The request which triggered this
     *     command.
     * @returns {TP.sig.Request} The request.
     */

    var topics,
        result,

        output;

    //  Grab all of the help topics that were grabbed as the commands loaded
    topics = TP.shell.Shell.get('helpTopics');
    result = TP.hc();

    topics.perform(
        function(pair) {
            var cmd,
                func;

            cmd = pair.first();
            func = pair.last();

            result.atPut(cmd, func.$$abstract);
        });

    //  ---

    output = '<dl>';

    result.perform(
        function(kvPair) {

            output +=
                '<dt>' +
                    '<a href="#" onclick="TP.bySystemId(\'LamaConsoleService\').get(\'$consoleGUI\').setInputContent(\':' + kvPair.first() + ' \'); return false;">' +
                    kvPair.first() +
                    '</a>' +
                '</dt>' +
                '<dd>' +
                    //  We don't use a CDATA section here because we can't copy
                    //  and paste entries from history on Chrome when we do:
                    //  https://bugs.chromium.org/p/chromium/issues/detail?id=696551
                    TP.xmlLiteralsToEntities(kvPair.last()) +
                '</dd>';
        });

    output += '</dl>';

    //  ---

    output += '<div style="text-align: center; font-weight: bold; font-size: large">Prefixes</div>';

    result = TP.hc(
        '?', 'Alias for the help command. \':help (tsh:help)\'',
        ':', 'Command prefix for shell tags. \':test => tsh:test\'',
        '!', 'Command history reference and execution. \'!!\' or \'!23\' etc',
        '=', 'Disable TSH parsing for input. \'=raw_js (functions etc)\'',
        ';', 'Turns off output cell creation. \';do_not_output_retval\'',
        '~', 'Starts a virtual URI reference. \'~app/tibet.json\'',
        '.', 'Source in following reference. \'.APP.hello.world (loads JS)\'',
        '/', 'Get or set a configuration flag. \'/{{some_flag}}=true\'',
        '&', 'List HTML/XML entity table. \'&amp;\'',
        '%', 'List active TIBET jobs. \'%\''
    );

    //  ---

    output += '<dl>';

    result.perform(
        function(kvPair) {
            output +=
                '<dt>' +
                    TP.xmlLiteralsToEntities(kvPair.first()) +
                '</dt>' +
                '<dd>' +
                    //  We don't use a CDATA section here because we can't copy
                    //  and paste entries from history on Chrome when we do:
                    //  https://bugs.chromium.org/p/chromium/issues/detail?id=696551
                    TP.xmlLiteralsToEntities(kvPair.last()) +
                '</dd>';
        });

    output += '</dl>';

    aRequest.atPut('cmdAsIs', true);

    return aRequest.complete(output);
});

TP.shell.Shell.addHelpTopic('help',
    TP.shell.Shell.Inst.getMethod('executeHelp'),
    'Outputs a list of available commands.',
    ':Help',
    '');

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('executeSave',
function(aRequest) {

    /**
     * @method executeSave
     * @summary
     * @param {TP.sig.ShellRequest} aRequest The request which triggered this
     *     command.
     * @returns {TP.sig.Request} The request.
     */

    this.saveProfile();

    return aRequest.complete();
});

TP.shell.Shell.addHelpTopic('save',
    TP.shell.Shell.Inst.getMethod('executeSave'),
    'Saves current user profile settings to the persistent store.',
    ':save',
    'Saves the currect user profile settings to the browser\'s local storage.');

//  ------------------------------------------------------------------------

TP.shell.Shell.Inst.defineMethod('executeSet',
function(aRequest) {

    /**
     * @method executeSet
     * @summary Sets a shell variable in response to a command request.
     * @param {TP.sig.ShellRequest} aRequest The request containing the command
     *     input.
     * @returns {TP.sig.ShellRequest} The request.
     */

    var varname,
        argv,
        value,
        dict;

    //  This lets us check count which affects behavior of this command.
    argv = this.getArgument(aRequest, 'ARGV', null, true, true);

    //  If no args it's a request to dump the current list.
    if (TP.isEmpty(argv)) {
        dict = TP.hc(this.getExecutionInstance());
        aRequest.stdout(dict);
        return aRequest.complete();
    }

    //  We can get the unexpanded string form of the variable from arg0.
    varname = this.getArgument(aRequest, 'ARG0', null, true, true);
    if (TP.isEmpty(varname)) {
        dict = TP.hc(this.getExecutionInstance());
        aRequest.stdout(dict);

        return aRequest.complete();
    }

    //  one arg means clear value of the variable.
    if (argv.getSize() === 1) {
        this.unsetVariable(varname);
        return aRequest.complete('Variable cleared.');
    }

    //  two args means we need the resolved value of the second argument
    value = this.getArgument(aRequest, 'ARG1');

    this.setVariable(varname, value);

    aRequest.stdout(this.getVariable(varname));

    return aRequest.complete();
});

TP.shell.Shell.addHelpTopic('set',
    TP.shell.Shell.Inst.getMethod('executeSet'),
    'Sets a shell variable to a specified value or clears it.',
    ':set [name] [value]',
    'Shows the names and values for all shell variables if no arguments are' +
    ' supplied, clears the value for one if its name is supplied, or sets' +
    ' the value for one if both a name and value are supplied.');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/shells/ShellExtensions.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'shells';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 */

/* eslint-disable no-loop-func */

//  ------------------------------------------------------------------------
//  Meta-Type Methods
//  ------------------------------------------------------------------------

//  NB: We only install these as meta-type methods since types are only checked
//  for these methods *after* instances are, but many types that implement these
//  methods implement the type version, so we can't install these as
//  meta-instance methods and ever expect the system to find specialized type
//  versions.

TP.defineMetaTypeMethod('cmdFilterInput',
function(aRequest) {

    /**
     * @method cmdFilterInput
     * @summary Invoked by the TSH when the receiver is a segment in a pipe
     *     where the implied operation is to filter standard input using a
     *     filter operation such as .|?.
     * @description This method work in conjunction with 'tsh:eval' type's
     *     'cmdRunContent' method. It equips every object with the capability to
     *     'filter' content. At this level, it simply complete()s the request
     *     with the receiver as the result.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    aRequest.complete(this);

    return;
});

//  ------------------------------------------------------------------------

TP.defineMetaTypeMethod('cmdTransformInput',
function(aRequest) {

    /**
     * @method cmdTransformInput
     * @summary Invoked by the TSH when the receiver is a segment in a pipe
     *     where the implied operation is to transform standard input using a
     *     simple transform operation such as .|
     * @description This method work in conjunction with 'tsh:eval' type's
     *     'cmdRunContent' method. It equips every object with the capability to
     *     'transform' content. At this level, it simply complete()s the request
     *     with the receiver as the result.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    aRequest.complete(this);

    return;
});

//  ------------------------------------------------------------------------
//  Object Methods
//  ------------------------------------------------------------------------

Object.Type.defineMethod('cmdAddContent',
function(aRequest) {

    /**
     * @method cmdAddContent
     * @summary Invoked by the TSH when the receiver is the data sink for a
     *     command sequence which is piping data to the receiver using an
     *     appending operation such as .>>.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     * @exception TP.sig.InvalidSink
     */

    this.raise('TP.sig.InvalidSink');

    return;
});

//  ------------------------------------------------------------------------

Object.Type.defineMethod('cmdGetContent',
function(aRequest) {

    /**
     * @method cmdGetContent
     * @summary Invoked by the TSH when the receiver is the data source for a
     *     command sequence which is piping data from the receiver.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    var obj,
        msg,
        val;

    if (TP.notValid(obj = aRequest.at('cmdInstance'))) {
        msg = 'No command instance.';
        return aRequest.fail(msg);
    }

    if (TP.notDefined(val = obj.get('value'))) {
        msg = 'No command content.';
        return aRequest.fail(msg);
    }

    aRequest.complete(val);

    return;
});

//  ------------------------------------------------------------------------

Object.Type.defineMethod('cmdRunContent',
function(aRequest) {

    /**
     * @method cmdRunContent
     * @summary Runs the receiver, effectively invoking its action.
     * @description This method is invoked any time a tag is being run as part
     *     of the processing of an enclosing tsh:script, which happens most
     *     often when the tag is being run interactively. The default defers to
     *     the tshExecute method of their type.
     * @param {TP.sig.ShellRequest} aRequest The request containing command
     *     input for the shell.
     * @returns {Object} A value which controls how the outer TSH processing
     *     loop should continue. TP.CONTINUE and TP.BREAK are common values.
     */

    return this.tshExecute(aRequest);
});

//  ------------------------------------------------------------------------

Object.Type.defineMethod('cmdSetContent',
function(aRequest) {

    /**
     * @method cmdSetContent
     * @summary Invoked by the TSH when the receiver is the data sink for a
     *     command sequence which is piping data to the receiver using a simple
     *     set operation such as .>
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    var input,
        msg,
        obj,
        result;

    if (TP.isEmpty(input = aRequest.stdin())) {
        msg = 'No command stdin.';
        return aRequest.fail(msg);
    }

    if (TP.notValid(obj = aRequest.at('cmdInstance'))) {
        msg = 'No command instance.';
        return aRequest.fail(msg);
    }

    //  stdin is an array...so we just want the first item here
    result = input.first();

    obj.set('value', result);

    aRequest.complete(result);

    return;
});

//  ------------------------------------------------------------------------
//  Array Methods
//  ------------------------------------------------------------------------

Array.Type.defineMethod('cmdAddContent',
function(aRequest) {

    /**
     * @method cmdAddContent
     * @summary Invoked by the TSH when the receiver is the data sink for a
     *     command sequence which is piping data to the receiver using an
     *     appending operation such as .>>.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    var input,
        msg,
        arr;

    if (TP.isEmpty(input = aRequest.stdin())) {
        msg = 'No command stdin.';
        return aRequest.fail(msg);
    }

    if (TP.notValid(arr = aRequest.at('cmdInstance'))) {
        msg = 'No command instance.';
        return aRequest.fail(msg);
    }

    //  stdin is an array...so addAll, not push here
    arr.addAll(input);

    aRequest.complete(arr);

    return;
});

//  ------------------------------------------------------------------------

Array.Type.defineMethod('cmdSetContent',
function(aRequest) {

    /**
     * @method cmdSetContent
     * @summary Invoked by the TSH when the receiver is the data sink for a
     *     command sequence which is piping data to the receiver using a simple
     *     set operation such as .>
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    var input,
        msg,
        arr;

    if (TP.isEmpty(input = aRequest.stdin())) {
        msg = 'No command stdin.';
        return aRequest.fail(msg);
    }

    if (TP.notValid(arr = aRequest.at('cmdInstance'))) {
        msg = 'No command instance.';
        return aRequest.fail(msg);
    }

    //  truncate to clear first since this is a "set", not an "add"
    arr.length = 0;

    //  stdin is an array...so addAll, not push here
    arr.addAll(input);

    aRequest.complete(arr);

    return;
});

//  ------------------------------------------------------------------------
//  RegExp Methods
//  ------------------------------------------------------------------------

RegExp.Type.defineMethod('cmdFilterInput',
function(aRequest) {

    /**
     * @method cmdFilterInput
     * @summary Invoked by the TSH when the receiver is a segment in a pipe
     *     where the implied operation is to filter standard input using a
     *     filter operation such as .|?.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    var input,
        msg,
        len,
        i,
        content,
        re,
        result;

    if (TP.isEmpty(input = aRequest.stdin())) {
        msg = 'No command stdin.';
        return aRequest.fail(msg);
    }

    if (TP.notValid(re = aRequest.at('cmdInstance'))) {
        msg = 'No command instance.';
        return aRequest.fail(msg);
    }

    len = input.getSize();
    for (i = 0; i < len; i++) {
        content = input.at(i);
        if (TP.notValid(content)) {
            continue;
        }

        //  if we're splatted then the return/output variable is expected to
        //  be a collection rather than a single item
        if (aRequest.at('cmdIterate')) {
            if (TP.isCollection(content)) {
                //  note that filter implies SELECT rather than COLLECT
                result = content.select(
                            function(item) {

                                return re.test(TP.str(item));
                            });

                //  output array, empty or not
                aRequest.stdout(result);
            } else {
                TP.ifWarn() ?
                    TP.warn('Splatting with non-collection content.') : 0;

                if (re.test(TP.str(content))) {
                    aRequest.stdout(TP.ac(content));
                } else {
                    aRequest.stdout(undefined);
                }
            }
        } else {
            //  not expecting collections, work at the object level by
            //  testing the string value of whatever we received.
            if (re.test(TP.str(content))) {
                aRequest.stdout(content);
            } else {
                aRequest.stdout(undefined);
            }
        }
    }

    aRequest.complete();

    return;
});

//  ------------------------------------------------------------------------

RegExp.Type.defineMethod('cmdTransformInput',
function(aRequest) {

    /**
     * @method cmdTransformInput
     * @summary Invoked by the TSH when the receiver is a segment in a pipe
     *     where the implied operation is to transform standard input using a
     *     simple transform operation such as .|
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    var input,
        msg,
        len,
        i,
        content,
        re,
        result,
        str,
        arr,
        match;

    if (TP.isEmpty(input = aRequest.stdin())) {
        msg = 'No command stdin.';
        return aRequest.fail(msg);
    }

    if (TP.notValid(re = aRequest.at('cmdInstance'))) {
        msg = 'No command instance.';
        return aRequest.fail(msg);
    }

    //  reset in case this is a global instance before looping
    re.lastIndex = 0;

    len = input.getSize();
    for (i = 0; i < len; i++) {
        content = input.at(i);
        if (TP.notValid(content)) {
            continue;
        }

        //  if we're splatted then the return/output variable is expected to
        //  be a collection rather than a single item
        if (aRequest.at('cmdIterate')) {
            if (TP.isCollection(content)) {
                //  transform is more "exec/match" than "test"
                result = content.collect(
                            function(item) {

                                if (re.global) {
                                    str = TP.str(item);
                                    arr = TP.ac();

                                    /* eslint-disable no-extra-parens */
                                    while ((match = re.exec(str))) {
                                        arr.push(match);
                                    }
                                    /* eslint-enable no-extra-parens */

                                    return arr;
                                } else {
                                    return re.exec(TP.str(item));
                                }
                            });

                //  output array, empty or not
                aRequest.stdout(result);
            } else {
                TP.ifWarn() ?
                    TP.warn('Splatting with non-collection content.') : 0;

                aRequest.stdout(re.exec(TP.str(content)));
            }
        } else {
            //  not expecting collections, work at the object level by
            //  testing the string value of whatever we received.
            if (re.global) {
                str = TP.str(content);
                arr = TP.ac();

                /* eslint-disable no-extra-parens */
                while ((match = re.exec(str))) {
                    arr.push(match);
                }
                /* eslint-enable no-extra-parens */

                aRequest.stdout(arr);
            } else {
                aRequest.stdout(re.exec(TP.str(content)));
            }
        }
    }

    aRequest.complete();

    return;
});

//  ------------------------------------------------------------------------
//  String Methods
//  ------------------------------------------------------------------------

String.Type.defineMethod('cmdFilterInput',
function(aRequest) {

    /**
     * @method cmdFilterInput
     * @summary Invoked by the TSH when the receiver is a segment in a pipe
     *     where the implied operation is to filter standard input using a
     *     filter operation such as .|?.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    var input,
        msg,
        obj,
        str,
        len,
        i,
        content,
        result,
        testfunc;

    if (TP.isEmpty(input = aRequest.stdin())) {
        msg = 'No command stdin.';
        return aRequest.fail(msg);
    }

    if (TP.notValid(obj = aRequest.at('cmdInstance'))) {
        msg = 'No command instance.';
        return aRequest.fail(msg);
    }

    //  strings are invoked in quoted form due to parsing requirements of
    //  the shell so we want to remove those quotes to avoid complications
    str = obj.unquoted();

    len = input.getSize();
    for (i = 0; i < len; i++) {
        content = input.at(i);
        if (TP.notValid(content)) {
            continue;
        }

        //  TODO:   expand on capability here. currently the string has to
        //  be something the TP.objectValue() call can handle

        testfunc =
            function(item) {
                return TP.isValid(TP.objectValue(item, str));
            };

        //  if we're splatted then the return/output variable is expected to
        //  be a collection rather than a single item
        if (aRequest.at('cmdIterate')) {
            if (TP.isCollection(content)) {
                result = content.select(testfunc);

                //  output array, empty or not
                aRequest.stdout(result);
            } else {
                TP.ifWarn() ?
                    TP.warn('Splatting with non-collection content.') : 0;

                if (testfunc(content)) {
                    aRequest.stdout(content);
                } else {
                    aRequest.stdout(undefined);
                }
            }
        } else {
            //  not expecting collections, work at the object level by
            //  testing the string value of whatever we received.
            if (testfunc(content)) {
                aRequest.stdout(content);
            } else {
                aRequest.stdout(undefined);
            }
        }
    }

    aRequest.complete();

    return;
});

//  ------------------------------------------------------------------------

String.Type.defineMethod('cmdTransformInput',
function(aRequest) {

    /**
     * @method cmdTransformInput
     * @summary Invoked by the TSH when the receiver is a segment in a pipe
     *     where the implied operation is to transform standard input using a
     *     simple transform operation such as .|
     * @description This occurs when the string is quoted in a pipe segment
     *     which does not include a ? implying filtering. In these cases the
     *     string is treated either as a template or as an aspect path used to
     *     query the objects for a new value.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    var input,
        msg,
        obj,
        str,
        len,
        i,
        content,
        params,
        func,
        result;

    if (TP.isEmpty(input = aRequest.stdin())) {
        msg = 'No command stdin.';
        return aRequest.fail(msg);
    }

    if (TP.notValid(obj = aRequest.at('cmdInstance'))) {
        msg = 'No command instance.';
        return aRequest.fail(msg);
    }

    //  strings are invoked in quoted form due to parsing requirements of
    //  the shell so we want to remove those quotes to avoid complications
    str = obj.unquoted();

    len = input.getSize();
    for (i = 0; i < len; i++) {
        content = input.at(i);
        if (TP.notValid(content)) {
            //  when there's no stdin to process we have to assume the
            //  string is the desired output
            return str;
        }

        //  first special sugar is when the string represents a templating
        //  string or a format substitution
        if (TP.regex.HAS_ACP.test(str) ||
            TP.regex.FORMAT_SUBSTITUTION.test(str)) {

            //  has templating syntax, we'll go with treating it like a
            //  template rather than a filter then...

            params = aRequest.getPayload();
            if (TP.notValid(params)) {
                params = TP.hc();
            }

            //  if we're splatted then the return/output variable is
            //  expected to be a collection rather than a single item
            if (aRequest.at('cmdIterate')) {
                if (TP.isCollection(content)) {
                    //  even though the transform call can process things in
                    //  a loop we interpret the splat as a directive to
                    //  return an array of results rather than a single
                    //  string so we loop here
                    result = content.collect(
                                function(item) {
                                    return str.transform(item, params);
                                });

                    //  output array, empty or not
                    aRequest.stdout(result);

                    break;
                } else {
                    TP.ifWarn() ?
                        TP.warn('Splatting with non-collection content.') : 0;

                    aRequest.stdout(TP.ac(str.transform(content, params)));
                }
            } else {
                //  no splat, no repeat
                aRequest.stdout(str.transform(content, params));
            }
        } else {
            //  if the string represents a type name then we'll presume
            //  that we want to call TP.format rather than treating it
            //  like a property access transformation.
            func = TP.isType(TP.sys.getTypeByName(str)) ?
                                TP.format :
                                TP.val;

            //  if we're splatted then the return/output variable is
            //  expected to be a collection rather than a single item
            if (TP.isTrue(aRequest.at('cmdIterate'))) {
                if (TP.isCollection(content)) {
                    result = content.collect(
                                function(item) {

                                    return func(item, str);
                                });

                    //  output array, empty or not
                    aRequest.stdout(result);

                    break;
                } else {
                    TP.ifWarn() ?
                        TP.warn('Splatting with non-collection content.') : 0;

                    aRequest.stdout(TP.ac(func(content, str)));
                }
            } else {
                //  not expecting collections, work at the object level by
                //  testing the string value of whatever we received.
                aRequest.stdout(func(content, str));
            }
        }
    }

    aRequest.complete();

    return;
});

//  ------------------------------------------------------------------------
//  TP.dom.Node Methods
//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('cmdAddContent',
function(aRequest) {

    /**
     * @method cmdSetContent
     * @summary Invoked by the TSH when the receiver is the data sink for a
     *     command sequence which is piping data to the receiver using an
     *     appending operation such as .>>.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    var input,
        msg,
        obj,
        result;

    if (TP.isEmpty(input = aRequest.stdin())) {
        msg = 'No command stdin.';
        return aRequest.fail(msg);
    }

    if (TP.notValid(obj = aRequest.at('cmdInstance'))) {
        msg = 'No command instance.';
        return aRequest.fail(msg);
    }

    //  stdin is an array...so we just want the first item here
    result = input.first();

    obj.addContent(result, aRequest);

    aRequest.complete(result);

    return;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('cmdGetContent',
function(aRequest) {

    /**
     * @method cmdGetContent
     * @summary Invoked by the TSH when the receiver is the data source for a
     *     command sequence which is piping data from the receiver.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    var obj,
        msg,
        node;

    if (TP.notValid(obj = aRequest.at('cmdInstance'))) {
        msg = 'No command instance.';
        return aRequest.fail(msg);
    }

    if (TP.notValid(node = obj.get('content'))) {
        msg = 'No command content.';
        return aRequest.fail(msg);
    }

    aRequest.complete(node);

    return;
});

//  ------------------------------------------------------------------------

TP.dom.Node.Type.defineMethod('cmdSetContent',
function(aRequest) {

    /**
     * @method cmdSetContent
     * @summary Invoked by the TSH when the receiver is the data sink for a
     *     command sequence which is piping data to the receiver using a simple
     *     set operation such as .>
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    var input,
        obj,
        result,
        msg;

    if (TP.isEmpty(input = aRequest.stdin())) {
        msg = 'No command stdin.';
        return aRequest.fail(msg);
    }

    if (TP.notValid(obj = aRequest.at('cmdInstance'))) {
        msg = 'No command instance.';
        return aRequest.fail(msg);
    }

    //  stdin is always an Array, so we want the first item.
    result = input.at(0);

    obj.set('content', result, aRequest);

    aRequest.complete(result);

    return;
});

//  ------------------------------------------------------------------------
//  TP.dom.XSLDocumentNode Methods
//  ------------------------------------------------------------------------

TP.dom.XSLDocumentNode.Type.defineMethod('cmdTransformInput',
function(aRequest) {

    /**
     * @method cmdTransformInput
     * @summary Invoked by the TSH when the receiver is a segment in a pipe
     *     where the implied operation is to transform standard input using a
     *     simple transform operation such as .|
     * @description This occurs when the XSL Node is quoted in a pipe segment
     *     which does not include a ? implying filtering. In these cases the
     *     Node is treated an XSLT for use in transforming the content supplied
     *     to it, resulting in new content.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    var input,
        obj,
        msg,
        len,
        i,
        content,

        result;

    //  Check input
    if (TP.isEmpty(input = aRequest.stdin())) {
        msg = 'No command stdin.';
        return aRequest.fail(msg);
    }

    if (TP.notValid(obj = aRequest.at('cmdInstance'))) {
        msg = 'No command instance.';
        return aRequest.fail(msg);
    }

    len = input.getSize();
    for (i = 0; i < len; i++) {
        content = input.at(i);
        if (TP.notValid(content)) {
            continue;
        }

        //  if we're splatted then the return/output variable is expected to
        //  be a collection rather than a single item
        if (aRequest.at('cmdIterate')) {
            if (TP.isCollection(content)) {
                //  even though the transform call can process things in a
                //  loop we interpret the splat as a directive to return an
                //  array of results rather than a single string so we loop
                //  here
                result = content.collect(
                            function(item) {
                                return obj.transform(item, aRequest);
                            });

                //  output array, empty or not
                aRequest.stdout(result);

                break;
            } else {
                TP.ifWarn() ?
                    TP.warn('Splatting with non-collection content.') : 0;

                aRequest.stdout(
                            TP.ac(obj.transform(content, aRequest)));
            }
        } else {
            //  no splat, no repeat
            aRequest.stdout(obj.transform(content, aRequest));
        }
    }

    aRequest.complete();

    return;
});

//  ------------------------------------------------------------------------
//  TP.core.UICanvas Methods
//  ------------------------------------------------------------------------

TP.core.UICanvas.Type.defineMethod('cmdGetContent',
function(aRequest) {

    /**
     * @method cmdGetContent
     * @summary Invoked by the TSH when the receiver is the data source for a
     *     command sequence which is piping data from the receiver.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    var obj,
        doc,
        msg;

    if (TP.notValid(obj = aRequest.at('cmdInstance'))) {
        msg = 'No command instance.';
        return aRequest.fail(msg);
    }

    if (TP.notValid(doc = obj.getContentDocument())) {
        msg = 'No command content.';
        return aRequest.fail(msg);
    }

    return aRequest.complete(doc);
});

//  ------------------------------------------------------------------------

TP.core.UICanvas.Type.defineMethod('cmdSetContent',
function(aRequest) {

    /**
     * @method cmdSetContent
     * @summary Invoked by the TSH when the receiver is the data sink for a
     *     command sequence which is piping data to the receiver using a simple
     *     set operation such as .>
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    var input,
        obj,
        msg,
        result;

    if (TP.isEmpty(input = aRequest.stdin())) {
        msg = 'No command stdin.';
        return aRequest.fail(msg);
    }

    if (TP.notValid(obj = aRequest.at('cmdInstance'))) {
        msg = 'No command instance.';
        return aRequest.fail(msg);
    }

    //  stdin is always an Array, so we want the first item.
    result = TP.wrap(input.first());
    obj.setContent(result, aRequest);

    aRequest.complete(result);

    return;
});

//  ------------------------------------------------------------------------
//  TP.uri.URI Methods
//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('cmdAddContent',
function(aRequest) {

    /**
     * @method cmdAddContent
     * @summary Invoked by the TSH when the receiver is the data sink for a
     *     command sequence which is piping data to the receiver using an
     *     appending operation such as .>>.
     * @description On this type, this method merely invokes 'cmdRunContent'
     *     against the receiver.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    return this.cmdRunContent(aRequest, TP.ADD);
});

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('cmdFilterInput',
function(aRequest) {

    /**
     * @method cmdFilterInput
     * @summary Invoked by the TSH when the receiver is a segment in a pipe
     *     where the implied operation is to filter standard input using a
     *     filter operation such as .|?.
     * @description On this type, this method merely invokes 'cmdRunContent'
     *     against the receiver.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    return this.cmdRunContent(aRequest, TP.FILTER);
});

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('cmdGetContent',
function(aRequest) {

    /**
     * @method cmdGetContent
     * @summary Invoked by the TSH when the receiver is the data source for a
     *     command sequence which is piping data from the receiver.
     * @description On this type, this method merely invokes 'cmdRunContent'
     *     against the receiver.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    return this.cmdRunContent(aRequest, TP.GET);
});

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('cmdRunContent',
function(aRequest, cmdType) {

    /**
     * @method cmdRunContent
     * @summary Runs the receiver, effectively invoking its action. For
     *     TP.uri.URI this method is responsible for dispatching all the
     *     variations of pipe methods which are suitable for use with a URI.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     */

    var obj,
        msg,

        href,

        pipe,
        crud,

        result,

        fname,
        subrequest,
        commitreq,
        content;

    if (TP.notValid(obj = aRequest.at('cmdInstance'))) {
        msg = 'No command instance.';
        return aRequest.fail(msg);
    }

    href = obj.getLocation();

    pipe = TP.elementGetAttribute(aRequest.at('cmdNode'), 'tsh:pipe', true);

    //  Since we may run into a variety of things during actual processing
    //  we construct a subrequest with our parameter data.

    //  If we're being used from a TP.tsh.uri, then there will be parameters
    //  picked up from that tag. If not, this will be null and there won't be
    //  any additional parameters.
    subrequest = TP.request(aRequest.at('TP.tsh.uri.params'));

    subrequest.atPut('cmdAction', aRequest.at('cmdAction'));

    subrequest.defineMethod('cancelJob',
        function(aFaultString, aFaultCode, aFaultInfo) {

            switch (arguments.length) {
                case 1:
                    this.$wrapupJob('Cancelled', TP.CANCELLED, aFaultString);
                    return aRequest.cancel(aFaultString);
                case 2:
                    this.$wrapupJob('Cancelled', TP.CANCELLED, aFaultString,
                                    aFaultCode);
                    return aRequest.cancel(aFaultString, aFaultCode);
                case 3:
                    this.$wrapupJob('Cancelled', TP.CANCELLED, aFaultString,
                                    aFaultCode, aFaultInfo);
                    return aRequest.cancel(aFaultString,
                                            aFaultCode,
                                            aFaultInfo);
                default:
                    this.$wrapupJob('Cancelled', TP.CANCELLED);
                    return aRequest.cancel();
            }
        });

    subrequest.defineMethod('completeJob',
        function(aResult) {

            var res;

            switch (arguments.length) {
                case 1:
                    this.$wrapupJob('Succeeded', TP.SUCCEEDED, aResult);
                    return aRequest.complete(aResult);
                default:    //  0
                    res = subrequest.getResult();
                    if (TP.isDefined(res)) {
                        this.$wrapupJob('Succeeded', TP.SUCCEEDED, res);
                        return aRequest.complete(res);
                    } else {
                        this.$wrapupJob('Succeeded', TP.SUCCEEDED);
                        return aRequest.complete();
                    }
            }
        });

    subrequest.defineMethod('failJob',
        function(aFaultString, aFaultCode, aFaultInfo) {

            switch (arguments.length) {
                case 1:
                    this.$wrapupJob('Failed', TP.FAILED, aFaultString);
                    return aRequest.fail(aFaultString);
                case 2:
                    this.$wrapupJob('Failed', TP.FAILED, aFaultString,
                                    aFaultCode);
                    return aRequest.fail(aFaultString, aFaultCode);
                case 3:
                    this.$wrapupJob('Failed', TP.FAILED, aFaultString,
                                    aFaultCode,
                                    aFaultInfo);
                    return aRequest.fail(aFaultString,
                                            aFaultCode,
                                            aFaultInfo);
                default:
                    this.$wrapupJob('Failed', TP.FAILED);
                    return aRequest.fail();
            }
        });

    switch (cmdType) {

        case TP.TRANSFORM:
            //  transform content...fall through

        case TP.FILTER:
            //  filter content

            fname = /\?/.test(pipe) ?
                    'cmdFilterInput' :
                    'cmdTransformInput';

            //  We rely on the result resource object to filter or transform
            //  the data so we need a slightly more complex handler for
            //  success in this case.
            subrequest.defineHandler('RequestSucceeded',
                function(aSignal) {

                    var res,
                        type,
                        failMsg;

                    res = aSignal.getResult();
                    if (TP.notValid(res)) {
                        failMsg = 'Missing pipe resource: ' + href;
                        aRequest.fail(failMsg);

                        return;
                    } else if (TP.canInvoke(res, fname)) {
                        res = res[fname](aRequest);
                    } else if (TP.canInvoke(res, 'getType')) {
                        type = res.getType();
                        if (TP.canInvoke(type, fname)) {
                            aRequest.atPut('cmdInstance', res);
                            res = type[fname](aRequest);
                        }
                    } else {
                        failMsg = 'Incapable pipe resource: ' + href;
                        aRequest.fail(failMsg);

                        return;
                    }

                    if (TP.isDefined(res)) {
                        aRequest.complete(res);
                    } else {
                        aRequest.complete();
                    }

                    return;
                });

            obj.getResource(subrequest);

            return;

        case TP.SET:

            //  set content, with or without commit

            //  NOTE that because of how TP.uri.URI operates any invocation
            //  of a setContent() call that isn't followed by a commit
            //  operation simply sets the content of the URI without any
            //  network or local DB access. As a result we can update
            //  content without any extra effort and use request/response
            //  only when doing a commit.
            content = aRequest.stdin().at(0);

            //  Make sure to get the CRUD value *before* setting the resource,
            //  as that will flip the 'isLoaded' flag to true.
            crud = obj.isLoaded() ? TP.UPDATE : TP.CREATE;

            result = obj.setResource(content);

            //  if ! for commit is present then we can simply queue the save
            //  operation and rely on the subrequest to handle resync.
            if (/!/.test(pipe)) {
                result = null;
                subrequest.atPut('crud', crud);
                if (subrequest.at('method') === TP.HTTP_DELETE) {
                    obj.delete(subrequest);
                } else {
                    obj.save(subrequest);
                }
            } else {
                //  Save is synchronous for all URI types since it's a
                //  "local save" to the URI's internal cache unless a commit
                //  is being requested. We need to complete() to have the
                //  rest of the system behave appropriately.
                subrequest.complete(result);
            }

            return;

        case TP.ADD:

            //  add content, with or without commit

            //  If we're going to be doing a commit operation we'll need to
            //  ensure we can pass along the same parameters for save().
            if (/!/.test(pipe)) {
                commitreq = TP.request();

                commitreq.defineHandler('RequestFailed',
                    function(aSignal) {

                        aRequest.fail(aSignal.getResult());

                        return;
                    });

                commitreq.defineHandler('RequestSucceeded',
                    function(aSignal) {

                        aRequest.complete(aSignal.getResult());

                        return;
                    });
            }

            //  NOTE that append is more difficult than set since we have to
            //  first acquire the existing content. That implies that we
            //  have a two or three-step process rather than a single step.
            //  Our first step is to process the getContent call, handling
            //  any asynchronous fetch there might be. The second step
            //  is to take that data and append the new content to the URIs
            //  content cache. The final step is to save the resulting data
            //  when a commit operation has been requested.
            subrequest.defineHandler('RequestSucceeded',
                function(aSignal) {

                    var input,
                        res;

                    res = aSignal.getResult();
                    input = aRequest.stdin().at(0);

                    //  if ! for commit is present then we can simply queue
                    //  the save operation and rely on the subrequest to
                    //  handle resync.
                    if (/!/.test(pipe)) {
                        commitreq.atPut('crud', TP.CREATE);
                        obj.save(commitreq);

                        //  Note here that we use 'addResource' so that the
                        //  receiving URI can do with the new data as it sees
                        //  fit.
                        obj.addResource(res, input, commitreq);
                    } else {
                        //  Note here that we use 'addResource' so that the
                        //  receiving URI can do with the new data as it sees
                        //  fit.
                        obj.addResource(res, input, aRequest);
                    }

                    return;
                });

            //  invoke stage one, the content acquisition, and let the
            //  response handlers take it from there.
            obj.getResource(subrequest);

            return;

        case TP.GET:

            //  NOTE fallthrough to the default which is to fetch content

        default:

            if (subrequest.at('method') === TP.HTTP_DELETE) {
                obj.delete(subrequest);
                break;
            }

            //  trigger the fetch sequence, relying on the subrequest's
            //  handlers to update the request appropriately.
            obj.getResource(subrequest);
            break;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('cmdSetContent',
function(aRequest) {

    /**
     * @method cmdSetContent
     * @summary Invoked by the TSH when the receiver is the data sink for a
     *     command sequence which is piping data to the receiver using a simple
     *     set operation such as .>
     * @description On this type, this method merely invokes 'cmdRunContent'
     *     against the receiver.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    return this.cmdRunContent(aRequest, TP.SET);
});

//  ------------------------------------------------------------------------

TP.uri.URI.Type.defineMethod('cmdTransformInput',
function(aRequest) {

    /**
     * @method cmdTransformInput
     * @summary Invoked by the TSH when the receiver is a segment in a pipe
     *     where the implied operation is to transform standard input using a
     *     simple transform operation such as .|
     * @description On this type, this method merely invokes 'cmdRunContent'
     *     against the receiver.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    return this.cmdRunContent(aRequest, TP.TRANSFORM);
});

//  ------------------------------------------------------------------------
//  TP.core.Window Methods
//  ------------------------------------------------------------------------

TP.core.Window.Type.defineMethod('cmdAddContent',
function(aRequest) {

    /**
     * @method cmdAddContent
     * @summary Invoked by the TSH when the receiver is the data sink for a
     *     command sequence which is piping data to the receiver using an
     *     appending operation such as .>>.
     * @description On this type, this method merely invokes 'cmdRunContent'
     *     against the receiver.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    var obj;

    if (TP.notValid(obj = aRequest.at('cmdInstance'))) {
        return aRequest.fail('No command instance');
    }

    return obj.getDocument().getType().cmdAddContent(aRequest);
});

//  ------------------------------------------------------------------------

TP.core.Window.Type.defineMethod('cmdGetContent',
function(aRequest) {

    /**
     * @method cmdGetContent
     * @summary Invoked by the TSH when the receiver is the data source for a
     *     command sequence which is piping data from the receiver.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    var obj;

    if (TP.notValid(obj = aRequest.at('cmdInstance'))) {
        return aRequest.fail('No command instance');
    }

    return obj.getDocument().getType().cmdGetContent(aRequest);
});

//  ------------------------------------------------------------------------

TP.core.Window.Type.defineMethod('cmdSetContent',
function(aRequest) {

    /**
     * @method cmdSetContent
     * @summary Invoked by the TSH when the receiver is the data sink for a
     *     command sequence which is piping data to the receiver using a simple
     *     set operation such as .>
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    var input,
        msg,
        obj,
        result,

        maybeURI,
        request;

    if (TP.isEmpty(input = aRequest.stdin())) {
        msg = 'No command stdin.';
        return aRequest.fail(msg);
    }

    if (TP.notValid(obj = aRequest.at('cmdInstance'))) {
        return aRequest.fail('No command instance');
    }

    //  stdin is always an Array, so we want the first item.
    result = input.at(0);

    if (TP.isKindOf(result, TP.dom.XHTMLDocumentNode)) {
        maybeURI = result.get('uri');
    } else if (TP.isKindOf(result, TP.core.Content)) {
        maybeURI = result.get('sourceURI');
    } else {
        maybeURI = result;
    }

    //  If we were able to get a URI, then use it in a setLocation call to get
    //  proper push/history state management.
    if (TP.isURIString(maybeURI) || TP.isURI(maybeURI)) {

        //  Build a request we can pass to the setLocation routine to handle any
        //  callbacks, error conditions, etc.
        request = TP.request();

        //  Attach TP.ONLOAD and TP.ONFAIL handlers to the request. These will
        //  be called back when the receiving window is done loading.
        request.atPut(TP.ONLOAD, function(aDocument) {
            aRequest.complete();
        });

        request.atPut(TP.ONFAIL, function(req) {
            aRequest.fail();
        });

        //  Set the location of the window
        obj.setLocation(maybeURI, request);

        //  Return separately for consistency with this API vs. TP.go2() API
        //  which returns false.
        return;
    } else {
        //  Otherwise, the input wasn't a URI, so forward it on to our document.
        return obj.getDocument().getType().cmdSetContent(aRequest);
    }
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/shells/TP.shell.TSH.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'shells';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @type {TP.shell.TSH}
 * @summary TIBET's primary shell, used for content processing, script
 *     execution, and interactive development via the TIBET console.
 * @description When working in the client we found it invaluable to have an
 *     interactive tool we could use to support debugging and simple
 *     experimentation. A simple 'workspace' in Smalltalk terms. But simply
 *     eval'ing JS was pretty limiting so we started adding features like
 *     history. Before we knew it we found ourselves wanting pipes,
 *     redirections, and other UNIX shell features.
 *
 *     As the shell grew we found ourselves wanting to have an easy way to
 *     extend the command set. We were already processing XML tags as macros for
 *     generating markup and at some point we realized the entire system could
 *     be coalesced as higher-level XML scripting. That's today's TSH...UNIX
 *     meets sugared XML.
 *
 *     Today's TSH is effectively the heart of the TIBET system. When you load
 *     content it is processed by running your page through the shell as a
 *     script. There is literally no difference between a "page" and a "script"
 *     in TSH -- tags are simply commands regardless of where they are found.
 *     Non-XML formats are often converted into an XML-equivalent and processed
 *     in that form, providing ways to optimize authoring of CSS, JSON, etc.
 *
 *     In addition to executing tags and JS/TIBET source code the TSH supports
 *     history, aliases, command substitutions, and variable expansion to cut
 *     down on repetitive typing. URI expansion is done so you can use relative
 *     or virtual paths in most places you'd normally have to type a full URI.
 *     Perhaps most importantly, TSH also supports pipes and redirections
 *     between URIs, handing asynchronicity seamlessly and invisibly.
 *
 *     You can extend the shell by simply creating custom tag types, unifying
 *     how you extend the shell with how you extend your TIBET environment in
 *     general. The majority of XML syntax is hidden from you during interactive
 *     use thanks to shell sugars.
 *
 *     You can configure your shell environment using profile files which are
 *     loaded during the shell login sequence. Like other environments TIBET
 *     supports both "group level" and "user level" profile files so you can
 *     reuse common functionality across users with ease.
 *
 *     Obviously the primary goal in all of this is to support faster
 *     development of web-based applications, particularly those that leverage
 *     client-side code. Since the shell is desugaring your input into XML tags
 *     a natural workflow is to prototype in the console, then simply connect
 *     the resulting XML script to your application's events as appropriate.
 *     Since the shell and tag system are unified there's a seamless
 *     productivity gain.
 *
 *     Of course, you can also use TIBET's inheritance features to create your
 *     own shell types, with their own unique command languages. The YAK shell
 *     is an example of this. It's a shell designed specifically to chat over
 *     XMPP/Jabber from a TIBET console. The TSH is the primary development
 *     shell however.
 *
 *     TSH Character Usage:
 *
 *     The TIBET shell isn't just an "object shell" where everything within the
 *     pipes is an object, it's also an "XML shell" in the sense that everything
 *     which makes up the actual pipe structure is converted from sugared TSH
 *     syntax into equivalent XML form. The resulting XML tags are then
 *     "processed" and "run" by the shell. We obviously try to sugar things as
 *     much as possible so you don't have to deal with the verbose syntax of XML
 *     very often, in fact most shell input looks like normal JavaScript -- but
 *     you could have always entered it as strict XML. This is useful since it
 *     means entering XML and a CDATA block can always help with escaping etc.
 *
 *     From a syntax perspective a primary goal is still to evaluate native
 *     JavaScript. As a result we decided to sugar TSH using characters that are
 *     either illegal in JS, or in the context within which they appear on a
 *     particular command line.
 *
 *     The following characters are not part of the JS operator set, meaning
 *     they are never valid in unquoted portions of JS source. That being the
 *     case we've use them as somewhat primary tokens.
 *
 *
 *      @   &commat;    Dereferencing operator. Used to force the shell to treat
 *                      a variable's content object as a target during redirect
 *                      operations rather than the variable name itself.
 *
 *      \   &bsol;      Escape character. Used to escape the first command
 *                      character from shell processing so you can enter lines
 *                      starting with symbols which might otherwise cause
 *                      command processing to occur. The result is therefore
 *                      the same as sending the command line without the
 *                      leading backslash directly to the current responder.
 *                      Anywhere else on the command line this symbol is
 *                      handled by the responder itself as an escape of the
 *                      character which follows.
 *
 *     `    &grave;     Command substitution. If a command line includes
 *                      unquoted backticks the contents are extracted,
 *                      processed, and the results are spliced back into the
 *                      original command before execution. This is similar to
 *                      tcsh but is only performed when the input is coming
 *                      from an interactive user.
 *
 *     #    &num;       Fragment/barename prefix. We use a leading # in standard
 *                      URI fragment fashion allowing easy reference to elements
 *                      within the current target document. A pipe to one of
 *                      these operators is very common.
 *
 *     The following characters are unary operators (or valid as a leading
 *     character like '.'), but with rules that provided some opportunities for
 *     specific pattern usage. We use them when they fit a pattern that wouldn't
 *     be found in valid JS or in cases where they might be legal but are used
 *     so infrequently that we require a leading \ to get the default JS
 *     operation.
 *
 *     !    &excl;      History prefix, 'imperative' suffix. Equivalent to
 *                      tcsh's normal history prefixing, so !23 means event 23.
 *                      Since ! (not) is legal JS but not typical outside of
 *                      assignment or testing we require an escape to say
 *                      something like \!varname.
 *
 *     ~    &tilde;     Path prefix. This is TIBET's "virtual URI" prefix by
 *                      default; an escape must be used to have a line start
 *                      with a one's complement JS operation.
 *
 *     .    &period;    Path prefix, operator prefix. Used to delimit operators
 *                      by placing a period before the corresponding tcsh
 *                      construct. For example, .| is a pipe in TSH. Also used
 *                      in path constructs since ../ and ./ aren't valid JS
 *                      when found outside of a quoted string.
 *
 *     The following characters are valid operators, but are binary or trinary
 *     in nature so they are potentially useful when used as a leading or
 *     trailing character since that wouldn't be valid JS.
 *
 *     /    &sol;       Used in conjunction with ~ and . for paths. Also used
 *                      as prefix for config such as /log.level etc.
 *
 *     =    &equals;    Used at the start of a pipe segment as sugar for the
 *                      tsh:where tag, which serves as a filter on content.
 *
 *     &    &amp;       When prefixed (.&) this operator will pipe stderr
 *                      rather than stdout. Also used in certain combinations to
 *                      signify that error data is flowing. Reserved as a suffix
 *                      for fork.
 *
 *     %    &percnt;    Job access. When used alone this lists the current
 *                      TP.core.Job instances which are running. By listing them
 *                      you can then kill off pending/pesky ones. When used as
 *                      a unary prefix to a number that job is listed.
 *
 *     ^    &circ;      Used at start of line to perform simple regex
 *                      replacements on prior command line input. Similar to
 *                      tcsh, but we also process trailing flags so ^foo^bar^g
 *                      is a global replace and ^foo^bar^i is case-insensitive.
 *
 *     ?    &quest;     Used at the start of a line to ask for help on what
 *                      follows, so ?alias will display help on the alias
 *                      command. When added to a pipe symbol this signifies
 *                      "filter" rather than "transform" as an operation.
 *                      Reserved for URI expansion.
 *
 *     $    $dollar;    ${var} is used to specify that var should be looked up
 *                      in the shell's list of variables. Shell variables are
 *                      set using :set var and can be viewed by entering :set
 *                      with no variable name. :unset removes them.
 *
 *                      Note that unlike standard shells you must use the
 *                      bracketed notation since $ is valid JS as part of an
 *                      identifier, but it can only be followed by a-z, A-Z,
 *                      0-9, and underscore in that form.
 *
 *     < or <<          Input redirection and "here document" input.
 *
 *     > or >>          Output redirection, with and without append semantics.
 *
 *     |                Standard pipe. Output from command preceding is piped to
 *                      second command.
 *
 *     || or &&         Conditional execution combinators.
 *
 *     *    &ast;       Also reserved for URI expansion.
 *
 *     :    &colon;     Namespace qualifier. When a command is entered it is
 *                      always checked for a : to determine whether a command is
 *                      being entered or native JS. If the first word in a
 *                      statement has a colon (:) then that word is taken as
 *                      the tag/command name and that tag is looked up and
 *                      provided with the attribute (parameter) values from the
 *                      statement. A leading : simply defaults to the current
 *                      namespace which can be set via the TSH's command line.
 *                      This is typically the namespace of the current shell.
 *
 *                      Word modifier if used in a history or variable
 *                      substitution as in #3:2 which would refer to the third
 *                      word in event #3.
 *
 *     See tsh_script.js for a full description of how these characters are
 *     combined into TSH-specific operators.
 */

/* global netscape:false
*/

//  ------------------------------------------------------------------------

TP.shell.Shell.defineSubtype('shell.TSH');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  command and content escaping prefixes
TP.shell.TSH.Type.defineConstant('ACTION_PREFIX', ':');
TP.shell.TSH.Type.defineConstant('ESCAPE_PREFIX', '*');

//  how we split text buffers for subcommand processing
TP.shell.TSH.Type.defineConstant('COMMAND_SPLIT_REGEX',
    /\n([-a-zA-Z_0-9]*?):([-a-zA-Z_0-9]*?)($|\s)/g);
TP.shell.TSH.Type.defineConstant('COMMAND_START_REGEX',
    /^([-a-zA-Z_0-9]*?):([-a-zA-Z_0-9]*?)($|\s)/);

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  'starter' snippet list used for new accounts. a list of pairs:
//  ([[command, user text], ...])
TP.shell.TSH.Type.defineAttribute(
                'STARTER_SNIPPETS',
                TP.ac(
                        TP.ac(':help', 'Help'),
                        TP.ac(':keys', 'Keys'),
                        TP.ac(':clear', 'Clear'),
                        TP.ac(':history', 'History'),
                        TP.ac(':config', 'Config'),
                        TP.ac(':doclint', 'Doclint'),
                        TP.ac('TP.sys.getBootLog()', 'Boot Log')
                ));

//  standard phases for content processing pipeline. NOTE that there are two
//  other explicit phases which are not found here. The 'Construct' phase is
//  always done to any inbound content to ensure XML-compliant command text.
//  Execute is optionally done with user-generated command input after
//  all other phases have been run.
TP.shell.TSH.Type.defineConstant(
    'AWAKEN_PHASES',
    TP.ac('AwakenDOM',          //  xi:includes, CSS @imports, etc.
            'AwakenEvents',     //  ev: namespace. NOTE others can generate
            'AwakenData',       //  model construct et. al.
            'AwakenInfo',       //  other info tags (acl:, dnd:, etc)
            'AwakenBinds',      //  data bindings in the bind: namespace
            'AwakenStyle'       //  CSS is last so display: none can flip
                                //  late
        ));

TP.shell.TSH.Type.defineConstant(
    'CACHE_PHASES',
    TP.ac('Includes',           //  xi:includes, CSS @imports, etc.
            'Instructions',     //  ?tibet, ?xsl-stylesheet, etc.
            'Precompile',       //  conversion to compilable form
            'Compile',          //  tag/macro expansion (ACT)
            'Tidy',             //  move non-DTD content out of html:head
                                //  etc.

            'Marshal',          //  virtualize xml:base URIs, encode data
                                //  etc.
            'Store',            //  save the content in a cache/repository
            'Load',             //  load the content from a cache/repository
            'Resolve',          //  resolve xml:base TP.uri.URI references,
                                //  decode etc.

            'Localize',         //  adjust for browser, lang, etc.
            'Optimize',         //  do performance-related indexing etc.
            'Finalize'));       //  complete (ready for HTML DOM etc)

TP.shell.TSH.Type.defineConstant(
    'COMPILE_PHASES',
    TP.ac('Includes',           //  xi:includes, CSS @imports, etc.
            'Instructions',     //  ?tibet, ?xsl-stylesheet, etc.
            'Precompile',       //  conversion to compilable form
            'Compile'));        //  tag/macro expansion (ACT)

TP.shell.TSH.Type.defineConstant(
    'EXECUTE_PHASES',
    TP.ac());                   //  rely on built-in Execute only

TP.shell.TSH.Type.defineConstant(
    'NOCACHE_PHASES',
    TP.ac('Includes',           //  xi:includes, CSS @imports, etc.
            'Instructions',     //  ?tibet, ?xsl-stylesheet, etc.
            'Precompile',       //  conversion to compilable form
            'Compile',          //  tag/macro expansion (ACT)
            'Tidy',             //  move non-DTD content out of html:head
                                //  etc.

            'Localize',         //  adjust for browser, lang, etc.
            'Optimize',         //  do performance-related indexing etc.
            'Finalize'));       //  formerly known as "prepped"

TP.shell.TSH.Type.defineConstant(
    'REVIVE_PHASES',
    TP.ac('Resolve',            //  move non-DTD content out of html:head
                                //  etc.
            'Localize',         //  adjust for browser, lang, etc.
            'Optimize',         //  do performance-related indexing etc.
            'Finalize'));       //  formerly known as "prepped"

TP.shell.TSH.set('commandPrefix', 'tsh');

    //  set up observations for TP.sig.ShellRequests
TP.shell.TSH.register();

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  the current execution context, a window or frame whose eval will be used
TP.shell.TSH.Inst.defineAttribute('context');

TP.shell.TSH.Inst.defineAttribute('commandXMLNS', 'tsh:');

//  the XPath visualization controller object
TP.shell.TSH.Inst.defineAttribute('xpathVizController');

//  whether a test is currently in process
TP.shell.TSH.Inst.defineAttribute('testing', false);

//  current test count
TP.shell.TSH.Inst.defineAttribute('testCount', 0);

//  what's the ID of the current test
TP.shell.TSH.Inst.defineAttribute('testID');

//  was the last test successful?
TP.shell.TSH.Inst.defineAttribute('testOk', true);

//  should the test been run in verbose mode?
TP.shell.TSH.Inst.defineAttribute('testVerbose', false);

//  additional information presented when a shell of this type starts up
TP.shell.TSH.Inst.defineAttribute('introduction', null);

//  whether or not we're watching changes to remote resources
TP.shell.TSH.Inst.defineAttribute('remoteWatch');

//  a TP.core.Socket object used to communicate with the TDS
TP.shell.TSH.Inst.defineAttribute('cliSocket');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('init',
function(aResourceID, aRequest) {

    /**
     * @method init
     * @summary Initializes a new instance.
     * @param {String} aResourceID A unique identifier for this instance.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request or hash
     *     containing an optional "parentShell" key used to define a parent for
     *     the newly constructed shell instance.
     * @returns {TP.shell.TSH} A new instance.
     */

    var name;

    this.callNextMethod();

    //  force in the default XMLNS type as a type after setting our prompt
    //  to reflect the current default
    name = this.get('commandXMLNS');

    this.setPrompt(name.chop(':') + '&#160;&#187;');

    this.$set('commandXMLNS', TP.sys.getTypeByName(name));

    // this.set('xpathVizController', TPXPathVizController.construct());

    return this;
});

//  ------------------------------------------------------------------------
//  STARTUP/LOGIN/LOGOUT
//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('getAnnouncement',
function() {

    /**
     * @method getAnnouncement
     * @summary Returns the announcement string to use for the receiver.
     * @returns {String} The announcement string.
     */

    var str;

    str = this.$get('announcement');
    if (TP.isEmpty(str)) {
        str = TP.join('TIBET Web Shell (TSH) ', TP.sys.getLibVersion());
        this.$set('announcement', str);
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('isLoginShell',
function(aRequest) {

    /**
     * @method isLoginShell
     * @summary Returns true if the receiver is a top-level login shell.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request or hash
     *     containing parameters.
     * @returns {Boolean}
     */

    var request,
        login;

    request = this.get('request');
    if (TP.isValid(request)) {
        login = request.atIfInvalid('cmdLogin', false);
        return login;
    } else {
        return this.callNextMethod();
    }
});

//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('login',
function(aRequest) {

    /**
     * @method login
     * @summary Performs any login sequence necessary for the receiver. The
     *     TP.shell.TSH relies on the current TP.sys.getEffectiveUser() value as
     *     the starting point for the login sequence. When that data is empty
     *     the current 'username' cookie for the application is used to define a
     *     default username whose profile should load.
     * @param {TP.sig.Request|TP.core.Hash} aRequest A request or hash
     *     containing parameters.
     * @returns {TP.shell.TSH} The receiver.
     */

    var request,

        shell,
        successFunc,

        user,
        name,
        usernameReq;

    request = TP.request(aRequest);

    /* eslint-disable consistent-this */

    //  capture 'this' for closure purposes
    shell = this;

    successFunc = function(userName) {

        var existingUser,
            existingUserName,

            newUser;

        existingUser = TP.sys.getEffectiveUser();
        existingUserName = existingUser.get('username');

        if (TP.notValid(existingUser)) {

            //  creating a TP.core.User instance will trigger the UI updating
            //  done based on vcard role/unit assignments (if this user has a
            //  vcard). Note that this also sets the real user.
            TP.core.User.construct(userName);

        } else if (existingUserName !== userName) {

            //  The user names didn't match - construct a new user and manually
            //  set it to be the real user.
            newUser = TP.core.User.construct(userName);

            //  Set the real user to the new user
            TP.core.User.set('realUser', newUser);
        }

        //  access to the shell instance through our previously defined
        //  shell = this reference
        shell.isRunning(true);
        shell.setVariable('USER', userName);

        //  store the username away in a cookie
        TP.core.Cookie.setCookie(
            'username',
            userName,
            TP.dc().addDuration('P1Y'));

        //  TODO:   clean this up with something more sensible that isn't so
        //  aware of what might be in the console (or that there is a console)

        //  start login message thread...
        TP.sig.UserOutputRequest.construct(
            TP.hc('output', 'Loading and initializing user profile' +
                            ' data for user "' + userName + '"...',
                    'cssClass', 'inbound_announce',
                    'cmdAsIs', true
                    )).fire(shell);

        //  if we're logged in, initiate the run sequence which will load any
        //  startup files but allow the login output message to display by
        //  forking the call here
        setTimeout(function() {
            shell.initProfile();

            //  notify any observers that we've logged in
            shell.signal('TP.sig.TSH_Login');

        }, TP.sys.cfg('shell.init.delay', 20));
    };

    //  If the user is running this shell in an already-authenticated
    //  application then we piggyback on that user information instead of asking
    //  for new information
    if (TP.notEmpty(user = request.at('username'))) {
        name = user;
    } else if (TP.isValid(user = TP.sys.getEffectiveUser()) &&
                TP.notEmpty(name = user.get('username'))) {

        this.set('username', name);

        //  There's no success or failure here - call the success handler.
        successFunc(name);

        return this;

    } else if (TP.notEmpty(user = TP.core.Cookie.getCookie('username'))) {
        //  this will remove the quotes wrapping the cookie value since
        //  TIBET cookies are stored in JS source format
        try {
            name = user.unquoted();
        } catch (e) {
            //  empty
        }
    }

    name = TP.ifEmpty(name, '');
    this.set('username', name);

    //  Demo version of prompting for a login/password. Note the nested call for
    //  the password input if the username input appears valid. This is shown
    //  'the hard way', since request subtypes would clarify the code
    //  significantly here. This version locally programs the input requests
    //  with their response handlers, an approach that would get out of hand
    //  with more than one or two chained prompts.

    //  SEE the YAK shell for the "other way", using a TP.sig.UserInputSeries

    usernameReq = TP.sig.UserInputRequest.construct(
                                    TP.hc('query', 'username:',
                                            'default', name,
                                            'async', true));

    //  response comes as a TP.sig.UserInput signal, so add a local handler
    usernameReq.defineHandler(
        'UserInput',
        function(aSignal) {

            var invalidUsernameReq,
                passwordReq,
                usernameResult;

            //  do this so the triggering request clears the queue
            if (TP.isValid(aSignal.getRequest().get('responder'))) {
                aSignal.getRequestID().signal('TP.sig.RequestCompleted');
            }

            usernameResult = aSignal.getResult();

            //  if the response wasn't adequate we can deal with that by simply
            //  reporting via an output request
            /* eslint-disable no-extra-parens */
            if (TP.notValid(usernameResult) ||
                usernameResult.getSize() < TP.shell.Shell.MIN_USERNAME_LEN) {
                shell.isRunning(false);
            /* eslint-enable no-extra-parens */

                invalidUsernameReq = TP.sig.UserOutputRequest.construct(
                            TP.hc('output', 'Invalid username. Must be ' +
                                            TP.shell.Shell.MIN_USERNAME_LEN +
                                            ' chars or more.',
                                    'async', true));

                invalidUsernameReq.isError(true);
                invalidUsernameReq.fire(shell);

                return;
            }

            //  a valid response means we want to formulate a request for the
            //  next step in the process, confirming the profile name by
            //  prompting for a password. NOTE that we tuck the username away in
            //  this new request to support our simple comparison in the
            //  response handler below
            passwordReq = TP.sig.UserInputRequest.construct(
                TP.hc('username', usernameResult,
                        'query', usernameResult + ' password:',
                        'default', null,
                        'hideInput', true,
                        'async', true));

            //  add a local input handler to the second-stage request which will
            //  be called when the password has been entered
            passwordReq.defineHandler(
                'UserInput',
                function(anotherSignal) {

                    var invalidPasswordReq,
                        passwordResult;

                    //  do this so the current request clears the queue
                    if (TP.isValid(
                            anotherSignal.getRequest().get('responder'))) {
                        anotherSignal.getRequestID().signal(
                            'TP.sig.RequestCompleted');
                    }

                    passwordResult = anotherSignal.getResult();

                    //  TODO: replace with decent validation hook
                    if (TP.notValid(passwordResult) ||
                        !passwordResult.equalTo(this.at('username'))) {
                        shell.isRunning(false);

                        invalidPasswordReq =
                            TP.sig.UserOutputRequest.construct(
                                    TP.hc('output', 'Login failed.' +
                                        ' Defaulting requestor settings.' +
                                        ' Use :login to try again.'));

                        invalidPasswordReq.isError(true);
                        invalidPasswordReq.fire(shell);

                        return;
                    }

                    //  We succeeded - call the success handler.
                    successFunc(this.at('username'));

                    return;
                });

            //  second-stage (password) request and response handler are
            //  defined, now trigger them using the shell as originator
            passwordReq.fire(shell);

            return;
        });

    /* eslint-enable consistent-this */

    //  first-stage request (username) and response handler are defined so
    //  initiate the sequence, using the shell as the originator
    usernameReq.fire(shell);

    return this;
});

//  ------------------------------------------------------------------------
//  REQUEST HANDLING
//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('handle',
function(aRequest) {

    /**
     * @method handle
     * @summary The primary resource/request handling method.
     * @description We override this here to enable privileges if we're on
     *     Mozilla. This avoids a lot of issues when manipulating a window or
     *     contents of a window that come from another domain. The shell
     *     variable PRIVILEGED must be true for this feature to be enabled. It's
     *     false by default.
     * @param {TP.sig.Request} aRequest The request to be serviced.
     * @returns {Object} The handler function's results.
     */

    if (TP.sys.isUA('GECKO') &&
        TP.isTrue(this.getVariable('PRIVILEGED')) &&
        TP.sys.shouldRequestPrivileges()) {
        try {
            if (TP.sys.cfg('log.privilege_requests')) {
                TP.sys.logSecurity('Privilege request at ' +
                       'handle',
                            TP.DEBUG);
            }

            netscape.security.PrivilegeManager.enablePrivilege(
                        'UniversalBrowserRead ' +
                        'UniversalBrowserWrite ' +
                        'UniversalXPConnect');
        } catch (e) {
            this.setVariable('PRIVILEGED', false);

            TP.sys.logSecurity(
                TP.join(
                'Enhanced privileges refused. Setting PRIVILEGED to',
                ' false.\n',
                'You may need signed.applets.codebase_principal_support\n',
                'set to true. See the TIBET installation guide for more.'),
                TP.WARN);
        }
    }

    //  handing off to the standard version within the scope of having
    //  acquire permission means downstream calls will have permissions
    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineHandler('ShellRequest',
function(aRequest) {

    /**
     * @method handleShellRequest
     * @summary Constructs a response to the request provided. This is the
     *     entry point into the shell's input processing sequence.
     * @param {TP.sig.ShellRequest} aRequest The request to respond to.
     * @returns {TP.sig.ShellResponse} A response to the request.
     */

    //  all requests handled by the TP.shell.TSH get a PID or 'process id'
    //  which can be used by responders as a threadID which can be leveraged
    //  to keep output from related requests together if desired
    aRequest.atPut('PID', this.getNextPID());

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineHandler('ShellRequestCompleted',
function(aSignal) {

    /**
     * @method handleShellRequestCompleted
     * @summary Processes notifications that a shell request the receiver
     *     processed has been completed. We use that notification to set final
     *     execution times and perform other cleanup.
     * @param {TP.sig.ShellResponse} aSignal The response signal, masquerading
     *     as a "Completed" signal.
     * @returns {TP.sig.ShellResponse} The response signal instance.
     */

    var response,
        request,

        timestart,
        timeend,
        exectime;

    response = aSignal;
    request = response.getRequest();

    //  compute/normalize our execution time information
    timestart = request.get('$timestart');
    timeend = Date.now();

    exectime = timeend - timestart;
    request.set('$exectime', TP.isNaN(exectime) ? 0 : exectime);

    return response;
});

//  ------------------------------------------------------------------------
//  EXECUTION
//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('shouldComputeCosts',
function(aFlag) {

    /**
     * @method shouldComputeCosts
     * @summary Combined setter/getter for manipulating the shell's
     *     COMPUTE_COSTS variable. When this variable is true the shell will
     *     compute execution time and object creation counts among other things.
     * @param {Boolean} aFlag The optional value to set.
     * @returns {Boolean} The current setting.
     */

    if (TP.isBoolean(aFlag)) {
        this.setVariable('COMPUTE_COSTS', aFlag);
    }

    return TP.ifInvalid(this.getVariable('COMPUTE_COSTS'), false);
});

//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('translateSymbol',
function(aString) {

    /**
     * @method translateSymbol
     * @summary Translates the symbol provided into its text equivalent. This
     *     method allows symbolic prefixes to be mapped into valid strings for
     *     help reporting and other purposes.
     * @param {String} aString The command prefix.
     * @returns {String|undefined} The translated string.
     */

    var ch,
        pre;

    if (TP.notValid(aString)) {
        return;
    }

    ch = aString.charAt(0);
    switch (ch) {
        case '@':
            pre = 'commat';
            break;
        case '\\':
            pre = 'bsol';
            break;
        case '`':
            pre = 'grave';
            break;
        case '#':
            pre = 'num';
            break;
        case '!':
            pre = 'excl';
            break;
        case '~':
            pre = 'tilde';
            break;
        case '/':
            pre = 'sol';
            break;
        case '&':
            pre = 'amp';
            break;
        case '%':
            pre = 'percnt';
            break;
        case '=':
            pre = 'equals';
            break;
        case '.':
            pre = 'period';
            break;
        case '^':
            pre = 'circ';
            break;
        case '?':
            pre = 'quest';
            break;
        case '$':
            pre = 'dollar';
            break;
        case '*':
            pre = 'ast';
            break;
        case ':':
            pre = 'colon';
            break;
        case ',':
            pre = 'comma';
            break;
        case '<':
            pre = 'lt';
            break;
        case '>':
            pre = 'gt';
            break;
        case '|':
            pre = 'brvbar';
            break;
        default:
            return aString;
    }

    return pre + aString.slice(1);
});

//  ------------------------------------------------------------------------
//  SHELL PROCESSING PIPELINE
//  ------------------------------------------------------------------------

/**
 *     Methods in this section support the core processing pipeline for shell
 *     requests. In particular, the execute method and the various helper
 *     functionsit relies upon are defined here.
 *
 *     The invoker is responsible for reading cached reps and submitting them to
 *     the pipeline, the pipeline only runs on content and skips steps until
 *     reaching the phase the content already exists at. NOTE that for shell and
 *     console input there's never a cache so things just run as expected. For
 *     URIs it means processing is always invoked from the URI initially so the
 *     URI can manage cached URI content.
 *
 *     IFF the page is in a "relativized" state then the page is "revived" by
 *     invoking each tag's revive method. NOTE that when a request's XML shows
 *     that it's a processed representation the previous steps are all skipped
 *     and processing begins with this step.
 *
 *     - any tag-specific URI attributes are converted to app paths
 *
 *     - xml:base markers are resolved to application-specific paths
 *
 *     --- XML PRE-PROCESSING ---
 *
 *     - resulting XML is now processed consistently with XML and browser
 *     precedence rules to complete any "pre-processing" transformations.
 *
 *     NOTE that doing these at this point implies that xi:include and
 *     early-stage XSLT etc. can produce tsh:eval tags whose content is still in
 *     sugared form. We can allow this _when_ there is already tsh:eval content
 *     and the request is sugared. otherwise we should be prepared to strip such
 *     content or "disable" it so the exec loop ignores tags injected through
 *     those means.
 *
 *     //   xi:include
 *
 *     //   <?tibet?> processing instructions
 *
 *     //   <?xsl-stylesheet?> instructions
 *
 *     --- MACRO EXPANSION ---
 *
 *     tags are invoked to produce their "expanded" representation, which
 *     typically means producing XHTML content that could be injected into a
 *     rendering surface. action tags produce XHTML as well, but rarely alter
 *     their child content since that's often runtime-sensitive.
 *
 *     NOTE that we only need to message the root node since expansion is a
 *     recursive descent process and descendant content will be managed by the
 *     initial node itself as it expands its child content
 *
 *     NOTE that in the past this process started with XMLNS XSLT
 *     transformations and moved on to individual tags. The proposed approach
 *     now is that we run the tag method and let the tag fall  back to the
 *     namespace as needed
 *
 *     NOTE that for a lot of these a single global "turn it into a span"
 *     process could be used as a final backstop rather than using that logic
 *     but separately for each unique namespace
 *
 *     NOTE that this approach could use an array/push method such that each
 *     entry in the array could be either a string/template or a node based on
 *     the particular tag's situation. The resulting array is then combined
 *     into a new document via a custom join() which first converts nodes to
 *     strings, joins, then TP.node()s.
 *
 *     NOTE that the tsh:script and tsh:eval tags injected during the initial
 *     processing phase can be produced in "pre-compiled form" to keep this
 *     overhead low for interactive scripts
 *
 *     --- DOCUMENT REPAIR ---
 *
 *     With or without caching in place we want to "repair" the document so it
 *     won't give other tools (or the browser) too much heartburn. (NOTE that
 *     this used to be part of the finalize call, but it's not really
 *     canvas-specific so that was an inappropriate location).
 *
 *     --- CACHING ---
 *
 *     Requestor is told to cache content. remaining question of what is cached
 *     if anything is handled by the specific content type(s).
 *
 *     --- PRE-RENDERING ---
 *
 *     MOVE MOVE MOVE to setContent as a built-in transform call, so the shell
 *     won't actually be involved here
 *
 *     IFF node implements finalize content, finalize for canvas, making it
 *     possible to handle variables and processing logic that should be updated
 *     each time a page or content is actually rendered
 *
 *     <?tibet?> instructions are executed (do we still want this?)
 *
 *     `command substitution` expansions (is this secure?)
 *
 *     NEW: replace above with string template execution/evaluation where the
 *     template is provided with the request as the source data and the window
 *     and document are injected?
 */

//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('execute',
function(aRequest) {

    /**
     * @method execute
     * @summary The main command execution method, responsible for parsing and
     *     processing shell input in a fashion suitable for the specific
     *     requirements of each shell and for the specific content being
     *     processed.
     * @param {TP.sig.ShellRequest} aRequest The request containing command
     *     input.
     * @returns {Number|undefined} A TP.shell.Shell control constant.
     */

    var src,
        response,
        hid,

        nstype,
        tagname,
        tagtype,

        node,
        rootDoc,

        phases,
        targetPhase,

        startPhase,

        cycles,
        cyclemax,

        root,
        cmdNode,

        nextPhase;

    //  no request means no work :)
    if (TP.notValid(aRequest)) {
        return;
    }

    //  clear the result completely
    aRequest.set('result', undefined, null, true);

    aRequest.set('$timestart', Date.now());

    //  the 'cmd' slot of the request must contain the input to process
    if (TP.notValid(src = aRequest.at('cmd'))) {
        if (TP.notValid(src = aRequest.at('cmdNode'))) {
            return aRequest.fail('Invalid request input.');
        }

        aRequest.atPut('cmd', TP.nodeAsString(src, false, true));
    }

    //  ---
    //  RESPONSE PREP
    //  ---

    //  handleShellRequest should ensure we have a viable response
    //  object to work with. if not then we can't proceed
    if (TP.notValid(response = aRequest.get('response'))) {
        return aRequest.fail('No response object found.');
    }

    //  TODO:   tie this back into the shouldComputeCosts call etc.,
    //  probably should be at the command level however
    response.atPut('creations', 'off');

    //  any time we react to a command we should ensure our result is sent
    //  back as an inbound response (from the console/receiver perspective)
    response.set('messageType', 'response');

    //  ---
    //  REQUEST RECORDING
    //  ---

    //  save history if requested
    if (TP.isTrue(aRequest.at('cmdHistory'))) {
        hid = this.addHistory(aRequest);
        aRequest.atPut('cmdHistoryID', hid);

        this.saveProfile();
    }

    //  ---
    //  XML-IFICATION
    //  ---

    //  NOTE that this phase is always done, all other phases rely on the
    //  content being able to be massaged into XML form somehow. For all
    //  inbound content the shell adds an enclosing 'script' tag from the
    //  current XMLNS (typically tsh:). This outer tag serves as a common
    //  root which helps maintain flexibility around content processing.

    aRequest.atPut('cmdPhase', 'Construct');

    if (TP.isString(src)) {
        //  "blank" requests don't require processing
        if (TP.isEmpty(src = src.trim())) {
            return aRequest.complete();
        }

        //  ---
        //  NAMESPACE DEFINITION
        //  ---

        //  a built-in as it were...any single word ending in a : represents
        //  a potentially new default namespace. when that is recognized the
        //  shell updates that value and returns success.

        //  TODO: potentially split the buffer here based on single lines of
        //  this type and wrap each subcontent section in the proper tag.
        //  the entire buffer would then likely go into a tsh:script tag.
        if (/^(\w)*:$/.test(src)) {
            if (TP.isType(nstype = TP.sys.getTypeByName(src))) {
                this.$set('commandXMLNS', nstype);
                this.setPrompt(src.chop(':') + '&#160;&#187;');

                return aRequest.complete();
            } else {
                return aRequest.fail('Unable to switch to XMLNS ' + src);
            }
        }

        //  ---
        //  CONTENT-TYPING
        //  ---

        //  requests can provide a specific XMLNS whose script tag should be
        //  used as the enclosing script execution tag. if that's not found
        //  we look to the current default XMLNS for the shell
        if (TP.isValid(nstype = aRequest.at('cmdXMLNS'))) {
            nstype = TP.sys.getTypeByName(nstype);
            if (TP.notValid(nstype)) {
                return aRequest.fail(
                            'Unable to find XMLNS type: ' +
                                aRequest.at('cmdXMLNS'));
            }
        } else {
            nstype = this.get('commandXMLNS');
            if (TP.notValid(nstype)) {
                nstype = TP.sys.getTypeByName('tsh:');
            }
        }

        //  most of the time we can go with the NS name + ':script', but
        //  leave the opportunity for each XMLNS to override that.
        if (TP.canInvoke(nstype, 'getTSHScriptTag')) {
            tagname = nstype.getTSHScriptTag();
        } else {
            //  NOTE that type names here are presumed to be namespace types
            //  so the resulting tag name is expected to be of the form
            //  prefix:script where prefix is the default prefix.
            tagname = nstype.getCanonicalName() + 'script';
        }

        tagtype = TP.sys.getTypeByName(tagname);
        if (TP.notValid(tagtype) ||
            !TP.canInvoke(tagtype, '$xmlifyContent')) {
            return aRequest.fail(
                    'Unable to find tag type: ' + tagname);
        }

        //  before we can attempt to convert into XML we have to handle
        //  things at a token level so we can support mixed JS and XML,
        //  which means sugars for containers such as here documents and
        //  nested script tags have to be desugared before the next step.
        src = tagtype.$xmlifyContent(src, this, aRequest);

        //  try for a node now that "content" area entities have been
        //  processed along with any other high-level tag desugaring
        node = TP.nodeFromString(
                TP.join('<', tagname, '>', src,
                    '</', tagname, '>'), false);

        if (TP.notValid(node)) {
            node = TP.nodeFromString(
                TP.join('<', tagname, '><![CDATA[',
                    src, ']]></', tagname, '>'));
        }

        //  if the content isn't a valid node by now we've got a problem
        //  since the remaining steps work by leveraging polymorphic
        //  APIs on the tags
        if (TP.notValid(node)) {
            //  problem transforming command buffer into XML. Typically
            //  either malformed XML or a missing xmlns declaration.
            return aRequest.fail(
                        'Unable to create command XML: "' + src + '".');
        }
    } else if (!TP.isNode(node = src)) {
        //  if the content had been a string or node then we can work with
        //  it but otherwise we'll consider it an error
        return aRequest.fail('Invalid command: "' + src + '". Try ? or :help.');
    }

    //  all processing has to take place within a viable document, so we
    //  make sure we have a proper one here. if the node already lives in a
    //  document we presume that's the document the invoker desires.
    if (TP.isDocument(node)) {
        //  node is already a document. start here.
        rootDoc = node;

        if (TP.notValid(node)) {
            //  ouch! no content
            return aRequest.fail(
                        'Unable to process empty document.');
        }
    } else {
        if (TP.nodeIsDetached(node)) {
            rootDoc = TP.constructDocument('', 'request');
            rootDoc.documentElement.appendChild(node);
        } else {
            rootDoc = TP.nodeGetDocument(node);
        }
    }

    //  store the original root node for reference. this may change based on
    //  processing, but each phase starts from this node
    aRequest.atPut('cmdRoot', node);

    //  ---
    //  PHASED CONTENT PIPELINE
    //  ---

    //  To allow the shell to be configured for various purposes we drive
    //  everything off a list of phases. The phases map to methods in the
    //  various tag types. Different content types can provide a different
    //  set of phases to the shell to have it process their content through
    //  a different sequence but the default sequence comes from the shell
    //  itself. the only two hard-coded phases are Construct and Execute.

    //  NOTE that we are looking for one of two values here, either a string
    //  which names a pre-defined phase-set or an array containing actual
    //  phase names we want to process.
    phases = aRequest.atIfInvalid('cmdPhases', 'nocache');
    if (TP.isString(phases)) {
        phases = this.getType()[phases.toUpperCase() + '_PHASES'];
        if (TP.notValid(phases)) {
            TP.ifWarn() ?
                TP.warn('Invalid phase set in request: ' +
                            aRequest.at('cmdPhases')) : 0;

            phases = this.getType().NOCACHE_PHASES;
        }
    } else if (!TP.isArray(phases)) {
        return aRequest.fail(
                    'Invalid phase definition: ' + phases + '.');
    }

    //  we default to targeting the last phase in whatever list we were
    //  provided, but try to honor any specific target set in the request.
    targetPhase = TP.ifKeyInvalid(aRequest, 'targetPhase', phases.last());

    //  configure for our loop and termination values. we have a default
    //  parameter we start from and then allow the request to override that
    //  when the specific request may have deeper cycle requirements.
    cycles = 0;

    //  We default the maximum of the phase cycles to twice the number of
    //  our phases, unless a Number is defined in the 'cmdPhaseMax' slot of
    //  the request.
    cyclemax = aRequest.at('cmdPhaseMax');
    if (TP.notValid(cyclemax)) {
        cyclemax = phases.getSize() * 2;
    }

    aRequest.atPut('cmdPhases', phases);

    if (TP.notEmpty(phases)) {
        startPhase = TP.nodeGetStartPhase(node,
                                            phases,
                                            aRequest.at('cmdRoot'));

        aRequest.atPut('cmdPhase', phases.at(
                                        phases.getPosition(startPhase)));
        do {
            //  count cycles as a fallback limit in case phases are getting
            //  reset such that we'd otherwise loop forever
            cycles++;

            //  typically we want to restart at the root node, the node
            //  which we started with, but in some cases that node can be
            //  replaced by transformation activity, particularly when we're
            //  processing a subset of content entered interactively in the
            //  console.
            root = aRequest.at('cmdRoot');
            if (TP.nodeIsDetached(root, rootDoc)) {
                cmdNode = aRequest.at('cmdNode');
                if (TP.nodeIsDetached(cmdNode, rootDoc)) {
                    //  error. both the root and node have been swapped out
                    //  by processing of some kind and neither was replaced
                    //  in the request with a viable alternative.
                    return aRequest.fail(
                                aRequest.at('cmdPhase') +
                                ' cycle node detached: ' +
                                TP.str(cmdNode, false));
                }

                aRequest.atPut('cmdRoot', cmdNode);
            } else {
                aRequest.atPut('cmdNode', root);
            }

            //  don't process past the target phase
            if (TP.nodeHasReachedPhase(aRequest.at('cmdRoot'),
                                        targetPhase,
                                        phases,
                                        aRequest.at('cmdRoot'))) {
                break;
            }

            //  clear any nextPhase information so we don't get into a
            //  strange loop unless the phase execution demands it, then run
            //  the phase
            aRequest.atPut('nextPhase', null);
            this.$runPhase(aRequest);

            //  mark that we've processed the node this far
            TP.elementSetAttributeInNS(
                        TP.elem(aRequest.at('cmdRoot')),
                        'tibet:phase',
                        aRequest.at('cmdPhase'),
                        TP.w3.Xmlns.TIBET);

            //  compute next phase, allowing the previous processing to
            //  define where we go from here as needed.
            nextPhase = aRequest.at('nextPhase');
            if (TP.notValid(nextPhase)) {
                nextPhase =
                    aRequest.at('cmdPhases').after(aRequest.at('cmdPhase'));
            }

            aRequest.atPut('cmdPhase', nextPhase);
        }
        while (cycles < cyclemax &&
                TP.isValid(nextPhase) &&
                aRequest.isRunnable());
    }

    //  make sure we ended the loop the right way, otherwise warn/exit
    if (TP.notEmpty(phases) && cycles >= cyclemax) {
        return aRequest.fail(
            'Terminated content processing: content.phase_max exceeded.');
    } else if (aRequest.didComplete()) {
        //  cancelled or failed
        return aRequest;
    }

    //  ---
    //  TAG EXECUTION
    //  ---

    //  NOTE that this phase is optional, and external to the core phase
    //  execution machinery. Execution is done primarly when the shell
    //  or TP.tdp.Console provide a request and flag it for explicit
    //  execution, otherwise this phase is rarely part of the standard phase
    //  sequence.
    if (aRequest.atIfInvalid('cmdExecute', false)) {
        //  process from top again, ensuring all content is part of the
        //  execution sequence.
        root = aRequest.at('cmdRoot');
        if (TP.nodeIsDetached(root, rootDoc)) {
            cmdNode = aRequest.at('cmdNode');
            if (TP.nodeIsDetached(cmdNode, rootDoc)) {
                //  error. both the root and node have been swapped out by
                //  processing of some kind and neither was replaced in the
                //  request with a viable alternative.
                return aRequest.fail(
                            'Execution cycle node detached: ' +
                            TP.str(cmdNode, false));
            }

            aRequest.atPut('cmdRoot', cmdNode);
        } else {
            aRequest.atPut('cmdNode', root);
        }

        //  store the expanded text for history purposes. this is
        //  effectively what would be stored as the "ready to run" XML
        aRequest.atPut(
            'cmdExpansion',
            TP.nodeAsString(aRequest.at('cmdRoot'), true, false));

        //  Do the actual phase invocation.
        aRequest.atPut('cmdPhase', 'Execute');
        this.$runPhase(aRequest);
    }

    //  When no subcommands are involved (which commonly occurs if the
    //  request is doing content processing rather than interactive script
    //  execution), then we have to ensure a proper result. The default when
    //  the result is still undefined is to presume the cmdRoot.
    if (!aRequest.didComplete() && aRequest.canComplete()) {
        //  patch over result data for any callers in need of the content
        //  that was processed.
        if (TP.notValid(aRequest.get('result'))) {
            aRequest.set('result', aRequest.at('cmdRoot'), null, true);
        }

        //  NOTE that we don't worry about output of results when not
        //  executing.
        if (aRequest.at('cmdPhase') === 'Execute') {
            aRequest.complete(aRequest.get('result'));
        } else {
            aRequest.complete();
        }
    }

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('$runPhase',
function(aRequest) {

    /**
     * @method $runPhase
     * @summary Runs a particular phase of request processing based on
     *     information found in the request. Important key/value pairs include
     *     cmdPhase and cmdNode which define the phase and the node to process
     *     respectively.
     * @param {TP.sig.ShellRequest} aRequest The request containing parameter
     *     data.
     * @returns {TP.sig.ShellRequest|undefined}
     */

    var phases,
        phase,
        node,
        rootDoc,
        funcName;

    //  list of phases is needed to ensure processed nodes aren't
    //  reprocessed.
    phases = aRequest.at('cmdPhases');

    //  phase should be set by the phase iteration logic in the execute
    //  method.
    phase = aRequest.at('cmdPhase');
    if (TP.isEmpty(phase)) {
        return;
    }

    TP.ifTrace() && TP.sys.cfg('log.tsh_phases') ?
        TP.trace(Date.now() + ' TP.shell.TSH ' + phase) : 0;

    //  the node we should process should be found in cmdNode. it can change
    //  between phases as replacement documents/nodes are built etc, but it
    //  should exist in some form between each processing phase, having been
    //  reset to cmdRoot after each successful pass.
    node = aRequest.at('cmdNode');
    if (TP.notValid(node)) {
        return;
    }

    //  capture a root document we can use for detachment detection
    rootDoc = TP.nodeGetDocument(node);

    //  All phase methods for the TP.shell.TSH are prefixed as such.
    funcName = 'tsh' + phase;

    //  traverse the entire DOM of the current cmdRoot, processing each
    //  node for the phase in question. NOTE that the nodeDepthTraversal
    //  routine is specifically coded to handle dynamic changes to the tree
    //  that it is iterating over.
    TP.nodeDepthTraversal(
        node,
        function(child) {

            /*
            Enter function.
            */

            var type,
                retval,
                result,
                newnode,
                cmdRoot,
                message;

            //  We leverage TP.dom.Node subtypes to manage type/tag-specific
            //  logic in a coherent fashion, so get a viable type. Tags we can't
            //  seem to find a type for are skipped by simply returning from the
            //  block.
            type = TP.dom.Node.getConcreteType(child);
            if (TP.notValid(type)) {
                //  TODO: Return message to say 'I don't know about this type --
                //  please teach me about it' (hide behind flag for development
                //  mode, etc.)
                return;
            }

            //  So that phases aren't hard-coded into the logic we'll test here
            //  before we dispatch. this allows new kinds of content to define
            //  their own phases as long as they stick to the common prefixing
            //  rule
            if (TP.canInvoke(type, funcName)) {
                //  If the node is already processed up to the phase in question
                //  we don't want to work on it again. This can occur when a
                //  template or similar compilation returns processed elements
                //  which refer to concrete types via tibet:tag.
                if (TP.nodeHasReachedPhase(child, phase, phases)) {
                    TP.ifTrace() &&
                            TP.$VERBOSE &&
                            TP.sys.cfg('log.tsh_phases') &&
                            TP.sys.cfg('log.tsh_phase_skips') ?
                                TP.trace('TP.shell.TSH ' + phase +
                                            ' skipping: ' +
                                            TP.name(type) + ' ' +
                                            TP.nodeAsString(child,
                                                false, true)) : 0;

                    //  don't reprocess. descend or continue.
                    if (TP.isElement(
                        newnode = TP.nodeGetFirstChildElement(child))) {
                        result = newnode;
                    } else {
                        if (TP.isElement(
                            newnode = TP.nodeGetFirstSiblingElement(child))) {
                            result = newnode;
                        } else {
                            newnode = child.parentNode;
                            result = TP.ac(newnode, TP.CONTINUE);
                        }
                    }

                    //  When dealing with generated nodes we'll often have a
                    //  phase placed on the tag to ensure
                    //  TP.nodeHasReachedPhase. Once we've branched however, we
                    //  want to clear the flag.

                    //  TODO: Can't do this here because of processing errors
                    //  around including templates multiple times... Need a fix.
                    // TP.elementRemoveAttribute(child, 'tibet:phase', true);
                } else {
                    aRequest.atPut('cmdNode', child);

                    TP.ifTrace() &&
                        TP.$VERBOSE &&
                        TP.sys.cfg('log.tsh_phases') &&
                        TP.sys.cfg('log.tsh_phase_nodes') ?
                            TP.trace(Date.now() + ' TP.shell.TSH ' + phase +
                                ' ctrl: ' + TP.name(type) +
                                ' ' +
                                TP.nodeAsString(child, false, true)) : 0;

                    try {
                        result = type[funcName](aRequest);
                    } catch (e) {
                        message = 'Error running ' + TP.name(type) + '.' +
                            funcName + ': ' + e.message;

                        TP.error(message + '\n' +
                            TP.getStackInfo(e).join('\n'));

                        return aRequest.fail(TP.ec(e, message));
                    }
                }

                if (TP.isArray(result)) {
                    newnode = result.at(0);
                    retval = result.at(1);
                } else if (TP.isNode(result)) {
                    newnode = result;
                } else if (TP.notValid(result)) {
                    /*
                    //  Not a Node, an Array or one of our constants...
                    message = 'No return value running: ' +
                                TP.name(type) + '.' + funcName;
                    TP.warn(message);
                    */
                    //  Need to set both - we return result, but use retval in
                    //  tests below.
                    result = TP.DESCEND;
                    retval = TP.DESCEND;
                } else if (TP.isKindOf(result, TP.sig.Request)) {
                    //  If we got a request and its complete, that means that
                    //  the tag itself handled whatever child processing that
                    //  needed to occur and that we should move on to the next
                    //  *sibling*.
                    if (result.isCompleted()) {
                        result = TP.CONTINUE;
                        retval = TP.CONTINUE;
                    } else {
                        //  TODO: We could potentially look for a new node in
                        //  the result, but for now we're just going to descend.
                        result = TP.DESCEND;
                        retval = TP.DESCEND;
                    }
                } else {
                    retval = result;
                }

                //  after execution we have to check to be sure the various
                //  control node slots are updated relative to any node
                //  replacements etc. which may have occurred.
                if (TP.isNode(newnode)) {
                    cmdRoot = aRequest.at('cmdRoot');

                    //  If the cmdNode is the same as the cmdRoot, then that
                    //  means we're processing the node at the top of the
                    //  tree we were handed (i.e. the first node)
                    if (child === cmdRoot) {
                        //  If cmdRoot has been detached or newnode is not a
                        //  descendant of cmdRoot (i.e. the processing step
                        //  either detached it or is returning a node from a
                        //  completely new tree), then we reset it to the
                        //  newnode itself (like we did for 'cmdNode').
                        if (TP.nodeIsDetached(cmdRoot, rootDoc)) {

                            if (TP.nodeContainsNode(cmdRoot, newnode)) {
                                //  Descendant of detached root - error
                                void 0;
                            } else {
                                //  newnode is a replacement root

                                //  Update the reference to cmdRoot in the
                                //  request and set the traversal to be
                                //  TP.REPEAT.
                                aRequest.atPut('cmdRoot', newnode);

                                //  If we weren't given a value for retval,
                                //  then we set it to TP.REPEAT here because we
                                //  were simply returned a node and don't know
                                //  where to go.
                                if (TP.notValid(retval)) {
                                    retval = TP.REPEAT;
                                }
                            }
                        } else {
                            //  root is not detached - is newnode detached?
                            if (TP.nodeIsDetached(newnode, rootDoc)) {
                                //  TODO
                                void 0;
                            } else {
                                //  neither cmdRoot or newnode is detached

                                //  If we weren't given a value for retval,
                                //  then we set it to TP.REPEAT here because we
                                //  were simply returned a node and don't know
                                //  where to go.
                                if (TP.notValid(retval)) {
                                    retval = TP.REPEAT;
                                }
                            }
                        }
                    } else {
                        //  If the newnode isn't in the rootDoc, then that means
                        //  that it was returned without being placed. Do that
                        //  here, replacing the 'child'.
                        if (TP.nodeIsDetached(newnode, rootDoc)) {
                            TP.nodeReplaceChild(child.parentNode,
                                                newnode,
                                                child,
                                                false);
                        }
                    }

                    //  We didn't get set to TP.REPEAT above, so set our retval
                    //  to TP.CONTINUE
                    if (TP.notValid(retval)) {
                        retval = TP.CONTINUE;
                    }

                    aRequest.atPut('cmdNode', newnode);
                } else if (retval !== TP.BREAK) {
                    //  if we're not terminating and didn't return a new
                    //  command node it's possible that the transform could
                    //  have overlooked updating the cmdNode. we want to be
                    //  sure that the child is still contained in the node
                    //  to trap potentially bad transform logic
                    if (TP.nodeIsDetached(child, rootDoc)) {
                        message = 'TP.shell.TSH ' + phase +
                                    ' node detached: ' +
                                    TP.nodeAsString(child, false);
                        TP.error(message);

                        return aRequest.fail(message);
                    }
                }
            } else {
                TP.ifTrace() &&
                        TP.$VERBOSE &&
                        TP.sys.cfg('log.tsh_phases') &&
                        TP.sys.cfg('log.tsh_phase_skips') ?
                            TP.trace('TP.shell.TSH ' + phase +
                                ' skipping: ' +
                                TP.name(type) + ' ' +
                                TP.nodeAsString(child,
                                    false, true)) : 0;
            }

            return result;
        },
        null,   //  No exitFunc
        function(child) {

            /*
            Content function.
            */
            var type,
                retval,
                result,
                newnode,
                cmdRoot,
                message;

            //  We only process ProcessingInstruction 'content' nodes.
            if (child.nodeType !== Node.PROCESSING_INSTRUCTION_NODE) {
                return;
            }

            //  we leverage TP.dom.Node subtypes to manage
            //  type/tag-specific logic in a coherent fashion, so get a
            //  viable type. Tags we can't seem to find a type for are
            //  skipped by simply returning from the block.
            type = TP.dom.Node.getConcreteType(child);
            if (TP.notValid(type)) {
                return;
            }

            //  so that phases aren't hard-coded into the logic we'll test
            //  here before we dispatch. this allows new kinds of content to
            //  define their own phases as long as they stick to the common
            //  prefixing rule
            if (TP.canInvoke(type, funcName)) {
                aRequest.atPut('cmdNode', child);

                TP.ifTrace() &&
                        TP.$VERBOSE &&
                        TP.sys.cfg('log.tsh_phases') &&
                        TP.sys.cfg('log.tsh_phase_nodes') ?
                            TP.trace(Date.now() + ' TP.shell.TSH ' + phase +
                                ' ctrl: ' + TP.name(type) +
                                ' ' +
                                TP.nodeAsString(child,
                                    false, true)) : 0;

                try {
                    result = type[funcName](aRequest);
                } catch (e) {
                    message = 'Error running ' + TP.name(type) + '.' +
                        funcName + ': ' + e.message;

                    TP.error(message + '\n' + TP.getStackInfo(e).join('\n'));

                    return aRequest.fail(TP.ec(e, message));
                }

                if (TP.isArray(result)) {
                    newnode = result.at(0);
                    retval = result.at(1);
                } else if (TP.isNode(result)) {
                    newnode = result;
                    retval = result;
                }

                //  after execution we have to check to be sure the various
                //  control node slots are updated relative to any node
                //  replacements etc. which may have occurred.
                if (TP.isNode(newnode)) {
                    cmdRoot = aRequest.at('cmdRoot');

                    //  If the cmdNode is the same as the cmdRoot, then that
                    //  means we're processing the node at the top of the
                    //  tree we were handed (i.e. the first node)
                    if (child === cmdRoot) {
                        //  If cmdRoot has been detached or newnode is not a
                        //  descendant of cmdRoot (i.e. the processing step
                        //  either detached it or is returning a node from a
                        //  completely new tree), then we reset it to the
                        //  newnode itself (like we did for 'cmdNode').
                        if (TP.nodeIsDetached(cmdRoot, rootDoc) ||
                            !TP.nodeContainsNode(cmdRoot, newnode)) {
                            aRequest.atPut('cmdRoot', newnode);
                        }
                    } else {
                        //  If the newnode isn't in the rootDoc, then that means
                        //  that it was returned without being placed. Do that
                        //  here, replacing the 'child'.
                        if (TP.nodeIsDetached(newnode, rootDoc)) {
                            TP.nodeReplaceChild(child.parentNode,
                                                newnode,
                                                child,
                                                false);
                        }
                    }

                    aRequest.atPut('cmdNode', newnode);
                } else if (retval !== TP.BREAK) {
                    //  if we're not terminating and didn't return a new
                    //  command node it's possible that the transform could
                    //  have overlooked updating the cmdNode. we want to be
                    //  sure that the child is still contained in the node
                    //  to trap potentially bad transform logic
                    if (TP.nodeIsDetached(child, rootDoc)) {
                        message = 'TP.shell.TSH ' + phase +
                                    ' node detached: ' +
                                    TP.nodeAsString(child, false);
                        TP.error(message);

                        return aRequest.fail(message);
                    }
                }
            } else {
                TP.ifTrace() &&
                        TP.$VERBOSE &&
                        TP.sys.cfg('log.tsh_phases') &&
                        TP.sys.cfg('log.tsh_phase_skips') ?
                            TP.trace('TP.shell.TSH ' + phase +
                                ' skipping: ' +
                                TP.name(type) + ' ' +
                                TP.nodeAsString(child,
                                    false, true)) : 0;
            }

            return result;
        });

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('$processRequestUsingElectron',
function(aRequest) {

    /**
     * @method $processRequestUsingElectron
     * @summary Processes request using Electron. Note that this method also
     *     completes the request.
     * @param {TP.sig.ShellRequest} aRequest The request to process using
     *     Electron.
     * @returns {TP.sig.Request} The request to process.
     */

    var cmd,
        realCmd,

        spawnArgs,

        argv,
        seenKeys,
        args,

        process,
        msgCallback,
        errCallback;

    cmd = this.getArgument(aRequest, 'ARG0', null, false);
    if (TP.isEmpty(cmd)) {
        cmd = 'help';
        realCmd = false;
    } else {
        realCmd = true;
    }

    //  Prepend the word 'tibet' onto the front of the command. This will force
    //  commands coming from TSH to run as 'tibet' subcommands.
    cmd = 'tibet ' + cmd;

    //  ---
    //  Assemble the spawn arguments
    //  ---

    spawnArgs = TP.ac();

    argv = this.getArgument(aRequest, 'ARGV');
    if (TP.notEmpty(argv)) {

        argv.shift();       //  pop off the first one, it's the command.

        if (TP.notEmpty(argv)) {
            argv.forEach(
                    function(item, ind) {
                        spawnArgs.push(item);
                    });
        }
    }

    seenKeys = TP.hc();

    args = this.getArguments(aRequest);

    //  If there is a real command (which there is in all cases except when
    //  the command is 'help'), filter argN variants. We don't want to have
    //  duplicate arguments sent over the wire.
    if (realCmd) {
        args = args.select(
                function(kvPair) {
                    if (/ARG\d/.test(kvPair.first()) ||
                        /tsh:ARG\d/.test(kvPair.first())) {
                        if (TP.isValid(args.at('ARGV'))) {
                            args.at('ARGV').shift();
                        }

                        return false;
                    }

                    return true;
                });
    }

    args.perform(
        function(arg) {
            var key,
                value;

            key = arg.first();
            value = arg.last();

            //  We already processed ARGV above, which includes all ARG*
            //  arguments.
            if (/^ARG/.test(key)) {
                return;
            }

            //  Have to get a little fancier here. If we see tsh: prefixes we
            //  want to remove those. If we don't see a value that key is a
            //  boolean flag.
            if (/tsh:/.test(key)) {
                key = key.slice(4);
            }

            if (seenKeys.at(key)) {
                return;
            }

            seenKeys.atPut(key, true);

            //  NB: The following logic matches that of the 'cli' plugin for
            //  the TDS.

            spawnArgs.push('--' + key);

            //  We don't add the value if it is null, undefined,
            //  true, the empty string or if the key equals the
            //  value (like a good XML shell, TSH will duplicate
            //  the key name as the value for Boolean flags:
            //  --no-color="no-color").
            if (value !== null &&
                value !== undefined &&
                value !== 'true' &&
                value !== '' &&
                value !== key) {

                spawnArgs.push(('' + value).stripEnclosingQuotes());
            }
        });

    //  ---
    //  Helpers
    //  ---

    //  Helper function to process a single result object (print/resolve).
    process = function(result, request) {
        var lvl,
            data,
            reason;

        //  Ignore empty results. Should be JSON structure with 'ok' key.
        if (TP.isEmpty(result)) {
            return;
        }

        //  If there's a level try to set the request to output at the
        //  corresponding level.
        if (TP.notEmpty(result.level)) {
            //  TODO:   currently this isn't translating to console style.
            //  TODO:   maybe verify we never "downgrade" message level so
            //          we keep the "worst" level (error) once it's hit.
            lvl = result.level;
            request.atPut('messageLevel', TP.log.Level.getLevel(lvl));
        }

        if (TP.notEmpty(result.ok)) {

            if (result.ok === true) {
                if (TP.notEmpty(result.data)) {
                    data = TP.stringStripANSIControlCharacters(result.data);
                    TP.notEmpty(data) ? request.stdout(data) : 0;
                }
            } else {
                if (TP.notEmpty(result.reason)) {
                    reason = TP.stringStripANSIControlCharacters(result.reason);
                    TP.notEmpty(reason) ? request.stderr(reason) : 0;
                }
            }

            if (result.status === 0) {
                request.complete();
                return;
            } else if (result.status !== undefined) {
                request.fail();
                return;
            }

        } else {

            if (result.status === 0) {
                if (TP.notEmpty(result.data)) {
                    data = TP.stringStripANSIControlCharacters(result.data);
                    TP.notEmpty(data) ? request.stderr(data) : 0;
                }
                request.complete();
                return;
            } else if (result.status !== undefined) {
                if (TP.notEmpty(result.reason)) {
                    reason = TP.stringStripANSIControlCharacters(result.reason);
                    TP.notEmpty(reason) ? request.stderr(reason) : 0;
                }
                request.fail();
                return;
            }
        }
    };

    msgCallback = function(evt) {
        try {
            if (TP.notEmpty(evt.data)) {
                evt.data = TP.stringStripANSIControlCharacters(evt.data);
            }
            process(evt, aRequest);
        } catch (e) {
            aRequest.stderr(e.message);
            if (TP.notEmpty(evt.data)) {
                evt.data = TP.stringStripANSIControlCharacters(evt.data);
            }
            aRequest.stdout(evt);
        }
    };

    errCallback = function(evt) {
        aRequest.stderr(evt.reason);
        aRequest.fail(evt.reason);
    };

    TP.extern.electron_lib_utils.commandSpawn(
        cmd, spawnArgs, msgCallback, errCallback).then(
        function(spawnResult) {
            if (spawnResult.level === 'error') {
                errCallback(spawnResult);
                return;
            }

            msgCallback(spawnResult);
            aRequest.complete();
        },
        function(spawnError) {
            errCallback(spawnError);
        });

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('$processRequestUsingTDS',
function(aRequest) {

    /**
     * @method $processRequestUsingTDS
     * @summary Processes request using the TDS. This involves encoding the
     *     commands parameters, invoking the command remotely and then decoding
     *     the results. Note that this method also completes the request.
     * @param {TP.sig.ShellRequest} aRequest The request to process using the
     *     TDS.
     * @returns {TP.sig.Request} The request to process.
     */

    var cmd,
        realCmd,
        url,
        argv,
        seenKeys,
        noSocket,
        configure,
        process,
        args,
        str,
        req,
        shell,
        cliSocket;

    //  TODO: sanity check them for non-alphanumeric 'command line' chars.

    cmd = this.getArgument(aRequest, 'ARG0', null, false);
    if (TP.isEmpty(cmd)) {
        cmd = 'help';
        realCmd = false;
    } else {
        realCmd = true;
    }

    noSocket = this.getArgument(aRequest, 'tsh:nosocket');

    shell = TP.shell.TSH.getDefaultInstance();

    //  ---
    //  Assemble the command string. We use the same "url format" in all cases.
    //  ---

    str = 'cmd=' + encodeURIComponent(cmd);

    argv = this.getArgument(aRequest, 'ARGV');
    if (TP.notEmpty(argv)) {

        argv.shift();       //  pop off the first one, it's the command.

        if (TP.notEmpty(argv)) {
            argv.forEach(
                    function(item, ind) {
                        str += '&arg' + ind + '=' + encodeURIComponent(item);
                    });
        }
    }

    seenKeys = TP.hc();

    args = this.getArguments(aRequest);

    //  If there is a real command (which there is in all cases except when the
    //  command is 'help'), filter argN variants. We don't want to have
    //  duplicate arguments sent over the wire.
    if (realCmd) {
        args = args.select(
                function(kvPair) {
                    if (/ARG\d/.test(kvPair.first()) ||
                        /tsh:ARG\d/.test(kvPair.first())) {
                        if (TP.isValid(args.at('ARGV'))) {
                            args.at('ARGV').shift();
                        }

                        return false;
                    }

                    return true;
                });
    }

    args.perform(
        function(arg) {
            var key,
                value;

            key = arg.first();
            value = arg.last();

            //  We already processed ARGV above, which includes all ARG*
            //  arguments.
            if (/^ARG/.test(key)) {
                return;
            }

            //  Have to get a little fancier here. If we see tsh: prefixes we
            //  want to remove those. If we don't see a value that key is a
            //  boolean flag.
            if (/tsh:/.test(key)) {
                key = key.slice(4);
            }

            if (seenKeys.at(key)) {
                return;
            }

            seenKeys.atPut(key, true);

            str += '&' + encodeURIComponent(key);
            if (TP.notEmpty(value)) {
                if (value !== true) {
                    str += '=' + encodeURIComponent(
                        ('' + value).stripEnclosingQuotes());
                }
            }
        });

    //  ---
    //  Helpers
    //  ---

    //  Helper function to process a single result object (print/resolve).
    process = function(result, request) {
        var lvl,
            data,
            reason;

        //  Ignore empty results. Should be JSON structure with 'ok' key.
        if (TP.isEmpty(result)) {
            return;
        }

        //  If there's a level try to set the request to output at the
        //  corresponding level.
        if (TP.notEmpty(result.level)) {
            //  TODO:   currently this isn't translating to console style.
            //  TODO:   maybe verify we never "downgrade" message level so
            //          we keep the "worst" level (error) once it's hit.
            lvl = result.level;
            request.atPut('messageLevel', TP.log.Level.getLevel(lvl));
        }

        if (TP.notEmpty(result.ok)) {

            if (result.ok === true) {
                if (TP.notEmpty(result.data)) {
                    data = TP.stringStripANSIControlCharacters(result.data);
                    TP.notEmpty(data) ? request.stdout(data) : 0;
                }
            } else {
                if (TP.notEmpty(result.reason)) {
                    reason = TP.stringStripANSIControlCharacters(result.reason);
                    TP.notEmpty(reason) ? request.stderr(reason) : 0;
                }
            }

            if (result.status === 0) {
                request.complete();
                return;
            } else if (result.status !== undefined) {
                request.fail();
                return;
            }

        } else {

            if (result.status === 0) {
                if (TP.notEmpty(result.data)) {
                    data = TP.stringStripANSIControlCharacters(result.data);
                    TP.notEmpty(data) ? request.stderr(data) : 0;
                }
                request.complete();
                return;
            } else if (result.status !== undefined) {
                if (TP.notEmpty(result.reason)) {
                    reason = TP.stringStripANSIControlCharacters(result.reason);
                    TP.notEmpty(reason) ? request.stderr(reason) : 0;
                }
                request.fail();
                return;
            }
        }
    };

    //  Helper function to configure the methods for standard socket events.
    configure = function(request) {

        var socket;

        socket = shell.get('cliSocket');

        //  When a connection is opened
        socket.defineMethod('onopen',
            function(evt) {
                request.stdout('CLI socket connection opened.');
                socket.send(str);
            });

        //  When data is received
        socket.defineMethod('onmessage',
            function(evt) {
                var result,
                    data;

                try {
                    if (TP.notEmpty(evt.data)) {
                        data = TP.stringStripANSIControlCharacters(evt.data);
                        result = JSON.parse(data);
                    } else {
                        result = {};
                    }
                    process(result, request);
                } catch (e) {
                    request.stderr(e.message);
                    if (TP.notEmpty(evt.data)) {
                        result = TP.stringStripANSIControlCharacters(evt.data);
                    } else {
                        result = '';
                    }
                    request.stdout(result);
                }
            });

        //  When a connection could not be made
        socket.defineMethod('onerror',
            function(evt) {
                var result;

                shell.set('cliSocket', null);

                result = evt;
                request.stderr(result);
                request.fail(evt);
            });

        //  When a connection is closed
        socket.defineMethod('onclose',
            function(evt) {
                shell.set('cliSocket', null);

                request.complete();
            });
    };

    //  ---
    //  URI version
    //  ---

    if (noSocket === true || !TP.core.Socket.isSupported()) {

        url = TP.uriExpandPath(TP.sys.getcfg('tds.cli.uri'));

        url += '?' + str + '&nosocket=true';
        url = TP.uc(url);

        if (TP.notValid(url)) {
            return aRequest.fail('Invalid request input.');
        }

        req = TP.sig.HTTPRequest.construct(
                    TP.hc('uri', url.getLocation(),
                            'resultType', TP.TEXT));

        req.defineHandler('RequestSucceeded',
                            function() {
                                var result,
                                    obj;

                                result = req.getResult();

                                try {
                                    obj = JSON.parse(result);
                                    if (TP.isArray(obj)) {
                                        obj.forEach(function(item) {
                                            process(item, aRequest);
                                        });
                                    } else {
                                        process(obj, aRequest);
                                    }
                                } catch (e) {
                                    aRequest.stdout(result);
                                    aRequest.complete();
                                }
                            });

        req.defineHandler('RequestFailed',
                            function() {
                                var result,
                                    obj;

                                result = req.getResult();

                                try {
                                    obj = JSON.parse(result);
                                    if (TP.isArray(obj)) {
                                        obj.forEach(function(item) {
                                            process(item, aRequest);
                                        });
                                    } else {
                                        process(obj, aRequest);
                                    }
                                } catch (e) {
                                    aRequest.stderr(result);
                                    aRequest.fail(result);
                                }
                            });

        url.httpPost(req);

        return this;
    }

    //  ---
    //  Socket version
    //  ---

    cliSocket = shell.get('cliSocket');

    //  We have a socket, but it's closed. Null it out and re-create it.
    if (TP.isValid(cliSocket) && cliSocket.isClosed()) {
        cliSocket = null;
        shell.set('cliSocket', null);
    }

    if (TP.notValid(cliSocket)) {

        //  Calling the URL with no command or arguments sets up the socket.
        url = TP.uriExpandPath(TP.sys.getcfg('tds.cli.uri'));

        TP.httpPost(url).then(
            function() {
                var path,
                    socket;

                path = TP.uriExpandPath('~app').slice(0, -1).replace(
                                                            'http:', 'ws:');

                //  Create, configure, and activate the new socket.
                socket = TP.core.Socket.construct(path, TP.ac('tibet-cli'));
                shell.set('cliSocket', socket);

                configure(aRequest);
                socket.activate();

                //  NOTE: no send() here...it's in the onopen handler installed
                //  via the configure() call.
            });

        return aRequest;

    } else {

        //  Rebuild the event listeners by tearing down any current ones,
        //  reconfiguring the methods on the instance, and re-attaching
        //  listeners on the underlying source.
        cliSocket.teardownStandardHandlers();

        configure(aRequest);

        cliSocket.setupStandardHandlers();

        cliSocket.send(str);
    }

    return aRequest;
});

//  ------------------------------------------------------------------------
//  DATA BUILT-INS
//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('executeLog',
function(aRequest) {

    /**
     * @method executeLog
     * @summary Outputs a log's content to the current stdout pipeline.
     * @param {TP.sig.ShellRequest} aRequest The request which triggered this
     *     command.
     * @returns {TP.sig.Request} The request.
     */

    aRequest.stdout('Coming soon.');

    return aRequest.complete();
});

TP.shell.TSH.addHelpTopic('log',
    TP.shell.TSH.Inst.getMethod('executeLog'),
    'Generates a listing of a particular log.',
    ':log',
    'Coming soon.');

//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('executeLogin',
function(aRequest) {

    /**
     * @method executeLogin
     * @summary
     * @param {TP.sig.ShellRequest} aRequest The request which triggered this
     *     command.
     * @returns {TP.sig.Request} The request.
     */

    var args,
        name;

    args = this.getArgument(aRequest, 'ARGV');

    //  If a name was supplied, then use it. Otherwise, the current effective
    //  user's vCard 'nickname' or the 'username' property from a cookie will be
    //  used.
    if (TP.notEmpty(name = args.first())) {
        aRequest.atPut('username', name);
    }

    this.login(aRequest);

    return aRequest.complete();
});

TP.shell.TSH.addHelpTopic('login',
    TP.shell.TSH.Inst.getMethod('executeLogin'),
    'Logs in to a specific user profile.',
    ':login',
    '');

//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('executeLogout',
function(aRequest) {

    /**
     * @method executeLogout
     * @summary
     * @param {TP.sig.ShellRequest} aRequest The request which triggered this
     *     command.
     * @returns {TP.sig.Request} The request.
     */

    var req;

    this.logout();

    req = TP.sig.UserOutputRequest.construct(
                TP.hc('output', '\n' +
                                'Logging out user "' +
                                this.get('username') +
                                '"',
                        'cssClass', 'inbound_announce',
                        'cmdAsIs', true));

    req.fire(this);

    return req;
});

TP.shell.TSH.addHelpTopic('logout',
    TP.shell.TSH.Inst.getMethod('executeLogout'),
    'Logs out of a specific user profile.',
    ':logout',
    '');

//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('executeSort',
function(aRequest) {

    /**
     * @method executeSort
     * @summary
     * @param {TP.sig.ShellRequest} aRequest The request which triggered this
     *     command.
     * @returns {TP.sig.Request} The request.
     */

    aRequest.stdout('Coming soon.');

    return aRequest.complete();
});

TP.shell.TSH.addHelpTopic('sort',
    TP.shell.TSH.Inst.getMethod('executeSort'),
    'Sorts stdin and writes it to stdout.',
    ':sort',
    'Coming soon.');

//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('executeUniq',
function(aRequest) {

    /**
     * @method executeUniq
     * @summary
     * @param {TP.sig.ShellRequest} aRequest The request which triggered this
     *     command.
     * @returns {TP.sig.Request} The request.
     */

    aRequest.stdout('Coming soon.');

    return aRequest.complete();
});

TP.shell.TSH.addHelpTopic('uniq',
    TP.shell.TSH.Inst.getMethod('executeUniq'),
    'Uniques stdin and writes it to stdout.',
    ':uniq',
    'Coming soon.');

//  ------------------------------------------------------------------------
//  DEBUGGING BUILT-INS
//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('executeBreak',
function(aRequest) {

    /**
     * @method executeBreak
     * @summary
     * @param {TP.sig.ShellRequest} aRequest The request which triggered this
     *     command.
     * @returns {TP.sig.Request} The request.
     */

    aRequest.stdout('Coming soon.');

    return aRequest.complete();
});

TP.shell.TSH.addHelpTopic('break',
    TP.shell.TSH.Inst.getMethod('executeBreak'),
    'Sets a debugger breakpoint.',
    ':break',
    'Coming soon.');

//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('executeExpect',
function(aRequest) {

    /**
     * @method executeExpect
     * @summary
     * @param {TP.sig.ShellRequest} aRequest The request which triggered this
     *     command.
     * @returns {TP.sig.Request} The request.
     */

    aRequest.stdout('Coming soon.');

    return aRequest.complete();
});

TP.shell.TSH.addHelpTopic('expect',
    TP.shell.TSH.Inst.getMethod('executeExpect'),
    'Sets an expectation to be verified.',
    ':expect',
    'Coming soon.');

//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('executeWatch',
function(aRequest) {

    /**
     * @method executeWatch
     * @summary
     * @param {TP.sig.ShellRequest} aRequest The request which triggered this
     *     command.
     * @returns {TP.sig.Request} The request.
     */

    aRequest.stdout('Coming soon.');

    return aRequest.complete();
});

TP.shell.TSH.addHelpTopic('watch',
    TP.shell.TSH.Inst.getMethod('executeWatch'),
    'Sets a value watch expression to be monitored.',
    ':watch',
    'Coming soon.');

//  ------------------------------------------------------------------------
//  JOB BUILT-INS
//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('executeJob',
function(aRequest) {

    /**
     * @method executeJob
     * @summary
     * @param {TP.sig.ShellRequest} aRequest The request which triggered this
     *     command.
     * @returns {TP.sig.Request} The request.
     */

    aRequest.stdout('Coming soon.');

    return aRequest.complete();
});

TP.shell.TSH.addHelpTopic('job',
    TP.shell.TSH.Inst.getMethod('executeJob'),
    'Generates a table of active "processes".',
    ':job',
    'Coming soon.');

//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('executeKill',
function(aRequest) {

    /**
     * @method executeKill
     * @summary
     * @param {TP.sig.ShellRequest} aRequest The request which triggered this
     *     command.
     * @returns {TP.sig.Request} The request.
     */

    aRequest.stdout('Coming soon.');

    return aRequest.complete();
});

TP.shell.TSH.addHelpTopic('kill',
    TP.shell.TSH.Inst.getMethod('executeKill'),
    'Kill an active TIBET "job" instance.',
    ':kill',
    'Coming soon.');

//  ------------------------------------------------------------------------
//  FORMATTING BUILT-INS
//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('executeMan',
function(aRequest) {

    /**
     * @method executeMan
     * @summary
     * @param {TP.sig.ShellRequest} aRequest The request which triggered this
     *     command.
     * @returns {TP.sig.Request} The request.
     */

    aRequest.stdout('Coming soon.');

    return aRequest.complete();
});

TP.shell.TSH.addHelpTopic('man',
    TP.shell.TSH.Inst.getMethod('executeMan'),
    'Produces a man page for the target object.',
    ':man',
    'Coming soon.');

//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('executeResource',
function(aRequest) {

    /**
     * @method executeResource
     * @summary Produces a list of computed resources as defined by the
     *     currently loaded list of types. This command is used by the TIBET
     *     command line's resource command to produce the list of computed
     *     resources.
     * @param {TP.sig.ShellRequest} aRequest The request containing command
     *     input.
     * @returns {TP.sig.ShellRequest} The request.
     */

    var arr,
        profile,
        pkg,
        cfg,
        context,
        phase,

        raw,
        tname,

        type,
        types,
        promise,
        paths;

    arr = [];

    profile = this.getArgument(aRequest, 'tsh:profile', null, false);
    if (TP.isEmpty(profile)) {
        pkg = this.getArgument(aRequest, 'tsh:package', '~app_cfg/main', false);
        cfg = this.getArgument(aRequest, 'tsh:config', 'base', false);
        profile = pkg + '@' + cfg;
    }

    context = this.getArgument(aRequest, 'tsh:context', 'app', false);
    if (context === 'app') {
        phase = TP.PHASE_TWO;
    } else if (context === 'lib') {
        phase = TP.PHASE_ONE;
    }

    raw = this.getArgument(aRequest, 'tsh:raw', null, false);
    tname = this.getArgument(aRequest, 'tsh:type', null, false);
    if (TP.notEmpty(tname)) {
        type = this.resolveObjectReference(tname, aRequest);
        if (TP.isType(type)) {
            types = TP.hc(tname, type);
        } else {
            return aRequest.fail(
                'Unable to find type ' + TP.str(tname));
        }

        promise = Promise.resolve();
    } else {
        //  NOTE we only access resource data for custom types.
        types = TP.sys.getCustomTypes();

        //  Get the list of paths from the defined profile.
        promise = TP.sys.getAllScriptPaths(profile, phase).then(
            function(scriptPaths) {
            paths = scriptPaths.collect(
                    function(path) {
                        return TP.uriInTIBETFormat(path);
                    }).unique();
            }).then(function() {

                //  Filter types by the package paths we're provided. If it's
                //  part of the overall package we retain it.
                types = types.select(function(item) {
                    var srcpath;

                    srcpath = TP.objectGetSourcePath(item[1]);

                    return paths.contains(srcpath);
                });
            });
    }

    promise.then(
        function() {
            //  types will be a hash of names/type objects.
            types.perform(function(item) {
                var itemtype,
                    themes,
                    val;

                itemtype = item.last();
                if (TP.canInvoke(itemtype, 'computeResourceURI')) {
                    val = itemtype.computeResourceURI('template');
                    if (TP.notEmpty(val) && val !== TP.NO_RESULT) {
                        arr.push(
                            val + TP.JOIN +
                            itemtype[TP.LOAD_STAGE] + TP.JOIN +
                            itemtype.getName()
                        );
                    }
                    val = itemtype.computeResourceURI('style');
                    if (TP.notEmpty(val) && val !== TP.NO_RESULT) {
                        arr.push(
                            val + TP.JOIN +
                            itemtype[TP.LOAD_STAGE] + TP.JOIN +
                            itemtype.getName()
                        );
                    }

                    //  Now iterate on the known themes...
                    themes = TP.sys.getcfg('project.theme.list', []);
                    themes = themes.concat(
                                    TP.sys.getcfg('tibet.theme.list', []));
                    themes.forEach(
                        function(theme) {
                            val = itemtype.computeResourceURI('style_' + theme);
                            if (TP.notEmpty(val) && val !== TP.NO_RESULT) {
                                arr.push(
                                    val + TP.JOIN +
                                    itemtype[TP.LOAD_STAGE] + TP.JOIN +
                                    itemtype.getName()
                                );
                            }
                        });

                    if (raw) {
                        val = itemtype.computeResourceURI('source');
                        if (TP.notEmpty(val) && val !== TP.NO_RESULT) {
                            arr.push(
                                val + TP.JOIN +
                                itemtype[TP.LOAD_STAGE] + TP.JOIN +
                                itemtype.getName()
                            );
                        }

                        val = itemtype.computeResourceURI('tests');
                        if (TP.notEmpty(val) && val !== TP.NO_RESULT) {
                            arr.push(
                                val + TP.JOIN +
                                itemtype[TP.LOAD_STAGE] + TP.JOIN +
                                itemtype.getName()
                            );
                        }
                    }
                }
            });

            arr = arr.unique().compact().map(
                function(item) {
                    delete item.$$oid;
                    return item;
                });

            //  Headless/CLI support requires output line-by-line.
            if (TP.sys.cfg('boot.context') === 'headless') {

                //  Reprocess paths to void ~Type/* format. That won't resolve
                //  in CLI.
                arr.forEach(
                    function(result) {
                        var parts,
                            res;

                        parts = result.split(TP.JOIN);
                        parts[0] = TP.uriInTIBETFormat(
                                    TP.uriExpandPath(parts[0]));
                        res = parts.join(TP.JOIN);

                        aRequest.stdout(res);
                    });

                aRequest.complete();
                return;
            }

            aRequest.complete(arr);
    });

    return aRequest;
});

TP.shell.TSH.addHelpTopic('resource',
    TP.shell.TSH.Inst.getMethod('executeResource'),
    'Produce a list of computed resource URIs for the application.',
    ':resource',
    '');

//  ------------------------------------------------------------------------
//  LOADING BUILT-INS
//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('executeSource',
function(aRequest) {

    /**
     * @method executeSource
     * @summary Reloads the source file from which an object was loaded. The
     *     object specification should be provided as ref="obj".
     * @param {TP.sig.ShellRequest} aRequest The request containing command
     *     input.
     * @returns {TP.sig.ShellRequest} The request.
     */

    var input,

        len,
        i,

        ref,

        $$inst,

        file,

        flag,

        url,
        resp,
        src,

        debug;

    if (TP.notValid(aRequest.at('cmdNode'))) {
        return aRequest.fail();
    }

    //  NB: We supply 'null' as the default value if 'tsh:ref' wasn't
    //  specified.
    input = this.getArgument(aRequest, 'tsh:ref', null, false);
    if (TP.notValid(input)) {
        if (TP.isEmpty(input = aRequest.stdin())) {
            return aRequest.fail(
                'Unable to find reference for ' + TP.str(input));
        }
    } else {
        input = TP.ac(input);
    }

    len = input.getSize();
    for (i = 0; i < len; i++) {
        ref = input.at(i);

        //  Try to resolve the object reference
        $$inst = this.resolveObjectReference(ref, aRequest);

        if (TP.notValid($$inst)) {
            aRequest.fail(
                'Unable to resolve object reference ' + ref);

            continue;
        }

        if (TP.notEmpty(file = TP.objectGetSourcePath($$inst))) {
            try {
                flag = TP.sys.shouldLogCodeChanges();
                TP.sys.shouldLogCodeChanges(false);

                /*
                root.stdout('tsh:source loading source from ' + file,
                    aRequest);
                */

                url = TP.uc(file);
                if (TP.notValid(url)) {
                    aRequest.fail(
                        'tsh:source failed to load ' + file);

                    continue;
                }

                resp = url.getResource(TP.hc('refresh', true, 'async', false));
                if (TP.notValid(src = resp.get('result'))) {
                    aRequest.fail(
                        'tsh:source failed to load ' + file);

                    continue;
                }

                debug = TP.sys.shouldUseDebugger();
                TP.sys.shouldUseDebugger(false);

                //  This will take care of initializing any newly-defined types
                //  if a) they define an 'initialize' method and b) if they
                //  haven't been initialized before.
                TP.boot.$sourceImport(src, null, file, true);

            } catch (e) {
                aRequest.fail(
                    TP.ec(e, 'tsh:source failed to eval ' + file));

                continue;
            } finally {
                TP.sys.shouldLogCodeChanges(flag);
                TP.sys.shouldUseDebugger(debug);
            }
        } else {
            aRequest.fail(
                'Object ' + ref + ' source file not found.');

            continue;
        }
    }

    aRequest.complete(url.getLocation());

    return aRequest;
});

TP.shell.TSH.addHelpTopic('source',
    TP.shell.TSH.Inst.getMethod('executeSource'),
    'Reloads the source file for an object/type.',
    ':source [target]',
    '');

//  ------------------------------------------------------------------------
//  REFLECTION BUILT-INS
//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('executeBuiltins',
function(aRequest) {

    /**
     * @method executeBuiltins
     * @summary
     * @param {TP.sig.ShellRequest} aRequest The request which triggered this
     *     command.
     * @returns {TP.sig.Request} The request.
     */

    aRequest.stdout('Coming soon.');

    return aRequest.complete();
});

TP.shell.TSH.addHelpTopic('builtins',
    TP.shell.TSH.Inst.getMethod('executeBuiltins'),
    'Lists the available built-in functions.',
    ':builtins',
    'Coming soon.');

//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('executeGlobals',
function(aRequest) {

    /**
     * @method executeGlobals
     * @summary
     * @param {TP.sig.ShellRequest} aRequest The request which triggered this
     *     command.
     * @returns {TP.sig.Request} The request.
     */

    var keys;

    //  TODO: Should we keep this command??

    keys = TP.$getOwnKeys(window);
    keys = keys.select(
            function(key) {

                if (TP.isFunction(window[key]) &&
                    (window[key][TP.TRACK] === TP.GLOBAL_TRACK ||
                        window[key][TP.TRACK] === TP.LOCAL_TRACK)) {
                    return true;
                }

                return false;
            });

    aRequest.stdout(keys.sort().join('\n'));

    aRequest.complete(keys);
});

TP.shell.TSH.addHelpTopic('globals',
    TP.shell.TSH.Inst.getMethod('executeGlobals'),
    'Display global variables, functions, etc.',
    ':globals',
    '');

//  ------------------------------------------------------------------------
//  TIMING BUILT-INS
//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('executeSleep',
function(aRequest) {

    /**
     * @method executeSleep
     * @summary Sleeps a specified number of milliseconds before continuing
     *     script processing. Note that sleeps in excess of 30 seconds can only
     *     be achieved by setting tsh.max_sleep higher. script processing. Note
     *     that sleeps in excess of 30 seconds can only be achieved by setting
     *     tsh.max_sleep higher.
     * @param {TP.sig.ShellRequest} aRequest The request containing command
     *     input.
     * @returns {TP.sig.ShellRequest} The request.
     */

    var ms;

    //  NB: We supply the cfg value of 'tsh.default_sleep' as the default value
    //  if 'tsh:ms' wasn't specified.
    ms = this.getArgument(aRequest,
                            'tsh:ms',
                            TP.sys.cfg('tsh.default_sleep', 1000),
                            false);

    ms = Math.max(ms, TP.sys.cfg('tsh.max_sleep', 30000));

    setTimeout(
        function() {
            aRequest.complete();
        }, ms);

    return aRequest;
});

TP.shell.TSH.addHelpTopic('sleep',
    TP.shell.TSH.Inst.getMethod('executeSleep'),
    'Pauses and waits a specified amount of time.',
    ':sleep',
    '');

//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('executeWait',
function(aRequest) {

    /**
     * @method executeWait
     * @summary Effectively pauses execution until a signal is observed. The
     *     signal can be tied to an origin, so this is effectively a way to tie
     *     shell execution timing to an $observe call.
     * @param {TP.sig.ShellRequest} aRequest The request containing command
     *     input.
     * @returns {TP.sig.ShellRequest} The request.
     */

    aRequest.stdout('Coming soon.');

    return aRequest.complete();
});

TP.shell.TSH.addHelpTopic('wait',
    TP.shell.TSH.Inst.getMethod('executeWait'),
    'Pauses execution until a signal is received.',
    ':wait',
    'Coming soon.');

//  ------------------------------------------------------------------------
//  TIBET COMMAND INTERFACE
//  ------------------------------------------------------------------------

TP.shell.TSH.Inst.defineMethod('executeCli',
function(aRequest) {

    /**
     * @method executeCli
     * @summary
     * @param {TP.sig.ShellRequest} aRequest The request which triggered this
     *     command.
     * @returns {TP.sig.Request} The request.
     */

    if (TP.sys.cfg('boot.context') === 'electron') {
        this.$processRequestUsingElectron(aRequest);
    } else {
        this.$processRequestUsingTDS(aRequest);
    }

    return aRequest;
});

TP.shell.TSH.addHelpTopic('cli',
    TP.shell.TSH.Inst.getMethod('executeCli'),
    'Runs a tibet CLI call. Requires active TDS or Electron environment.',
    ':cli',
    '');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/shells/TP.shell.YAK.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_extensions.xml';
TP.boot.$$srcConfig = 'shells';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @type {TP.shell.YAK(tm)}
 * @summary A TP.shell.Shell specific to handling XMPP (Jabber) communication.
 *     The default "execution" in this shell is to send the input to the
 *     currently targeted JID.
 */

//  ------------------------------------------------------------------------

TP.shell.Shell.defineSubtype('shell.YAK');

TP.shell.YAK.set('commandPrefix', 'yak');

TP.w3.Xmlns.registerNSInfo('urn:yak',
        TP.hc('uri', 'urn:yak', 'prefix', 'yak'));

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  whether to display the raw XMPP traffic. note that this is separate from
//  the TP.sys.shouldLogIO() setting, which may also cause you to see
//  portions of the XMPP traffic on the wire.
TP.shell.YAK.Inst.defineAttribute('debug', true);

//  the last inbound message packet, used for :reply processing
TP.shell.YAK.Inst.defineAttribute('lastNode');

//  collection containing secure jids and their keys
TP.shell.YAK.Inst.defineAttribute('secureJIDs');

//  the server uri we last asked to connect to
TP.shell.YAK.Inst.defineAttribute('serverURI');

//  the last server name we tried to connect to
TP.shell.YAK.Inst.defineAttribute('serverName');

//  the ID of the service this instance uses, typically this is set to the
//  receiver's resource ID plus 'Service'
TP.shell.YAK.Inst.defineAttribute('serviceID');

//  the currently targeted JID for our output traffic
TP.shell.YAK.Inst.defineAttribute('targetJID');

//  the last user JID we used when logging in
TP.shell.YAK.Inst.defineAttribute('userJID');

//  additional information presented when a shell of this type starts up
TP.shell.YAK.Inst.defineAttribute('introduction',
    TP.join('Shift-Return to send. Shift-Up/Down for history. ',
            'Shift-Delete to clear. Shift-Esc to cancel.<br/><br/>',
            'Type ',

            '<a class="help_table_link" href="#" onclick="TP.shellExec(',
                '\':help\', false, false, false, \'', '`getID()`', '\'); ',
                'return false;">?</a> or ',

            '<a class="help_table_link" href="#" onclick="TP.shellExec(',
                '\':help\', false, false, false, \'', '`getID()`', '\'); ',
                'return false;">:help</a> for help, ',

            '<a class="help_table_link" href="#" onclick="TP.shellExec(',
                '\':history\', false, false, false, \'', '`getID()`', '\'); ',
                'return false;">#?</a> or ',

            '<a class="help_table_link" href="#" onclick="TP.shellExec(',
                '\':history\', false, false, false, \'', '`getID()`', '\'); ',
                'return false;">:history</a> for history; use ',

            '<a class="help_table_link" href="#" onclick="TP.shellExec(',
                '\':to \', false, false, false, \'', '`getID()`', '\'); ',
                'return false;">:to</a> to target a specific JID.',

            '<br/>'));

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('init',
function(resourceID) {

    /**
     * @method init
     * @summary Initializes a new instance.
     * @param {String} resourceID A unique resource identifier for this shell
     *     instance.
     * @returns {TP.shell.YAK} A new instance.
     */

    //  pass the adjusted resource ID to the supertype constructor
    this.callNextMethod(resourceID);

    //  make sure we know about input from our connections
    this.observe(null, 'TP.sig.XMPPInput');

    //  construct the secure key collection so it's ready for action
    this.$set('secureJIDs', TP.hc());

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('canSend',
function() {

    /**
     * @method canSend
     * @summary Returns true if the receiver has an open, authenticated
     *     connection which will support a send operation.
     * @returns {Boolean}
     */

    var yakService;

    if (!this.isRunning()) {
        return false;
    }

    if (TP.notValid(yakService =
                        TP.uri.XMPPService.getInstanceById(
                                                    this.getServiceID()))) {
        return false;
    }

    return yakService.hasAuthConnection();
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('displayDebugData',
function(aMessage) {

    /**
     * @method displayDebugData
     * @summary Displays debugging information related to the message provided.
     *     This method is typically invoked when the shell has debugging turned
     *     on.
     * @param {TP.xmpp.Message} aMessage The message instance.
     * @returns {TP.shell.YAK} The receiver.
     */

    var yakService,
        packet,
        str,
        msgType;

    if (TP.notTrue(this.get('debug')) || !this.isRunning()) {
        return this;
    }

    yakService = TP.uri.XMPPService.getInstanceById(this.getServiceID());

    packet = yakService.get('connection').getOutputStream().getLastPacket();
    if (TP.notValid(packet)) {
        return this;
    }

    msgType = TP.isValid(aMessage) ? aMessage.getTypeName() + ':\n' : '';

    try {
        str = TP.join('[SEND]\n', msgType, TP.nodeAsString(packet));

        TP.sig.UserOutputRequest.construct(
                TP.hc(
                    'output', str,
                    'messageType', 'debug'
                    )).fire(this);
    } catch (e) {
        //  empty
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('getAnnouncement',
function() {

    /**
     * Returns the announcement string to use for the receiver.
     * @returns {String} The announcement string.
     */

    var str;

    str = this.$get('announcement');
    if (TP.isEmpty(str)) {
        str = TP.join('TIBET Messaging Shell (YAK) ',
            TP.sys.getLibVersion());
        this.$set('announcement', str);
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('getServiceID',
function() {

    /**
     * @method getServiceID
     * @summary Returns the service ID for the service this instance of shell
     *     uses for its server communication.
     * @returns {String} The service ID.
     */

    //  used to be hard-coded to 'TP.shell.YAKService'
    return this.getID() + 'Service';
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('setTargetJID',
function(aJID) {

    /**
     * @method setTargetJID
     * @summary Sets the default JID to target with unqualified sends.
     * @param {TP.xmpp.JID} aJID The JID to target.
     * @returns {TP.shell.YAK} The receiver.
     */

    this.$set('targetJID', aJID);

    //  the TARGET variable will display in the status bar if set
    this.setVariable('TARGET', aJID.asString());

    return this;
});

//  ------------------------------------------------------------------------
//  STARTUP/LOGIN/LOGOUT
//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('login',
function(aRequest) {

    /**
     * @method login
     * @summary Performs any login sequence necessary for the receiver. The
     *     TP.shell.YAK initiates a query sequence to get proper values for a
     *     server uri, server name, jid, and password.
     * @param {TP.sig.ShellRequest} aRequest The request which is triggering
     *     this activity.
     * @returns {TP.shell.YAK} The receiver.
     */

    var shell,

        uis;

    if (this.isRunning()) {
        this.stderr('Still logged in. Please log out first.');

        return this;
    }

    /* eslint-disable consistent-this */

    shell = this;

    uis = TP.sig.UserInputSeries.construct();

    //  Add a query to the series to get the 'polling uri' (that is, the
    //  polling URL).
    uis.addQuery(
        TP.hc('query', 'polling uri:',
                'retryPrompt', 'Invalid URI. Please re-enter...',
                'validator',
                    function(response, request) {

                        if (TP.notValid(response) ||
                            response.getSize() < 'http://'.getSize() ||
                            TP.notValid(TP.uc(response))) {
                            return false;
                        }

                        shell.$set('serverURI', response);

                        return true;
                    }));

    //  Add a query to the series to get the 'server name' (that is, the
    //  actual Jabber server).
    uis.addQuery(
        TP.hc('query', 'server name:',
                'retryPrompt', 'Invalid server name. Please re-enter...',
                'default',
                function(response, request) {

                    var res,
                        hostname;

                    //  note we want to use the response to the first
                    //  question to generate part of our value here
                    res = request.getLastReply();

                    try {
                        hostname = TP.uc(res).get('hostname');
                    } catch (e) {
                        hostname = '';
                    }

                    return hostname;
                },
                'validator',
                function(response, request) {

                    //  need a valid server name
                    if (TP.notValid(response) || response.getSize() < 1) {
                        return false;
                    }

                    shell.$set('serverName', response);

                    return true;
                }));

    //  Add a query to the series to get the 'user jid'.
    uis.addQuery(
        TP.hc('query', 'user jid:',
                'retryPrompt', 'Invalid JID. Please re-enter...',
                'validator',
                function(response, request) {

                    var val;

                    if (TP.notValid(response) ||
                        TP.notValid(val = TP.xmpp.JID.construct(response))) {
                        return false;
                    }

                    shell.$set('userJID', val);

                    return true;
                }));

    //  Add a query to the series to get the user's 'password'.
    uis.addQuery(
        TP.hc('query', 'password:',
                'hideInput', true,
                'retryPrompt', 'Password cannot be empty.' +
                                ' Please re-enter...',
                'validator',
                function(response, request) {

                    if (TP.notValid(response) ||
                        response.getSize() <
                                 TP.shell.Shell.MIN_PASSWORD_LEN) {
                        return false;
                    }

                    return true;
                }));

    //  Add a hook in case the user cancels the operation during the login
    //  process.
    uis.addCancelHook(
        function(aUIS) {

            TP.sig.UserOutputRequest.construct(
                TP.hc(
                    'output', 'Login request cancelled.',
                    'messageType', 'failure'
                    )).fire(shell);

            shell.logout();

            return;
        });

    //  Add a hook in case the login operation fails during the login
    //  process.
    uis.addFailureHook(
        function(aUIS) {

            TP.sig.UserOutputRequest.construct(
                TP.hc(
                    'output', 'Login request failed.',
                    'messageType', 'failure'
                    )).fire(shell);

            shell.logout();

            return;
        });

    //  Add the hook in case the login operation succeeds.
    uis.addSuccessHook(
        function(aUIS) {

            TP.sig.UserOutputRequest.construct(
                TP.hc(
                    'output', 'Login parameters obtained.' +
                                ' Attempting login...'
                    )).fire(shell);

            shell.loginCompletion(aUIS);

            return;
        });

    /* eslint-enable consistent-this */

    //  now initiate the input series
    uis.fire(shell);

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('loginCompletion',
function(aUserInputSeries) {

    /**
     * @method loginCompletion
     * @summary Completes a login sequence using the information contained in
     *     the receiver's instance variables and the user input series provided.
     *     This method is leveraged by both the login and register sequences to
     *     complete the login process.
     * @param {TP.sig.UserInputSeries} aUserInputSeries An input request
     *     containing all the necessary data.
     * @returns {TP.shell.YAK} The receiver.
     */

    var ndx,
        arr,
        i,
        pass,

        yakService;

    //  find the password data so we're ready for action
    ndx = TP.NOT_FOUND;
    arr = aUserInputSeries.get('queries');

    for (i = 0; i < arr.getSize(); i++) {
        if (arr.at(i).at(aUserInputSeries.getType().QUERY_INDEX).
                                                    startsWith('password')) {
            ndx = i;
            break;
        }
    }

    pass = aUserInputSeries.get('replies').at(ndx);

    //  Allocate the service and set its serviceURI and serverName
    if (TP.notValid(yakService =
                        TP.uri.XMPPService.getInstanceById(
                                this.getServiceID()))) {
        yakService = TP.uri.XMPPService.construct(this.getServiceID());
        yakService.set('serviceURI', this.get('serverURI'));
        yakService.set('serverName', this.get('serverName'));
    }

    //  make the connection/login attempt...

    //  First, check to see if the service already had an authenticated
    //  connection. This may have happened if the service was allocated
    //  before and we're reusing it. Note that in order for the service to
    //  consider the connection 'authenticated', the connection's URI and
    //  server name must match those of the service and it must be
    //  authenticated with a JID.
    if (yakService.hasAuthConnection()) {
        return this;
    }

    //  Then try to open a new connection
    if (!yakService.openConnection()) {
        TP.sig.UserOutputRequest.construct(
                TP.hc(
                    'output', 'Login attempt failed.' +
                                ' Connection did not open.',
                    'messageType', 'failure'
                    )).fire(this);

        return this;
    }

    //  now that the connection is open, go ahead and try to establish
    //  the connection with the server. This will authenticate our
    //  connection with the server, request various resources from the
    //  server and try to establish a session.
    if (yakService.authenticateConnection(this.get('userJID'), pass)) {
        //  creating a TP.core.User instance will trigger the UI updating
        //  done based on vcard role/unit assignments (if this user has a
        //  vcard)
        TP.core.User.construct(this.get('userJID'));

        //  login successful
        this.isRunning(true);

        this.setVariable('USER', this.get('userJID').asString());

        TP.sig.UserOutputRequest.construct(
                TP.hc(
                    'output',
                            this.get('userJID').asString() +
                            ' logged in at ' +
                            TP.dc().toLocaleString(),
                    'messageType', 'response',
                    'cssClass', 'inbound_announce'
                    )).fire(this);

        yakService.setupCurrentUser();

        this.displayDebugData(yakService.get('lastMsg'));
    } else {
        //  failed to log in
        TP.sig.UserOutputRequest.construct(
                TP.hc(
                    'output', 'Login authentication failed.',
                    'messageType', 'failure'
                    )).fire(this);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('logout',
function(aRequest) {

    /**
     * @method logout
     * @summary Logs out of the current session, closing the connection.
     * @param {TP.sig.ShellRequest} aRequest The request which is triggering
     *     this activity.
     * @returns {TP.shell.YAK} The receiver.
     */

    var yakService;

    //  Make sure we have an open connection. Otherwise, there's nothing to
    //  'log out' from.
    try {
        //  No XMPP service? Shut this shell down and exit here.
        if (TP.notValid(yakService =
                            TP.uri.XMPPService.getInstanceById(
                                this.getServiceID()))) {
            if (this.isRunning()) {
                this.isRunning(false);
            }

            this.signal('TP.sig.Logout');

            return this;
        }

        //  Tell the service to shut down its connection.
        yakService.shutdownConnection();
    } catch (e) {
        //  ignore problems closing
        //  empty
    }

    if (this.isRunning()) {
        this.isRunning(false);
    }

    this.signal('TP.sig.Logout');

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('register',
function(aRequest) {

    /**
     * @method register
     * @summary Initiates the registration process for a new user with the
     *     Jabber server.
     * @param {TP.sig.ShellRequest} aRequest The request which is triggering
     *     this activity.
     * @returns {TP.shell.YAK} The receiver.
     */

    var shell,
        uis;

    if (this.isRunning()) {
        this.stderr('Still logged in. Please log out first.');
        return this;
    }

    /* eslint-disable consistent-this */

    shell = this;

    uis = TP.sig.UserInputSeries.construct();

    //  Add a query to the series to get the 'polling uri' (that is, the
    //  polling URL).
    uis.addQuery(
            TP.hc('query', 'polling uri:',
                    'retryPrompt', 'Invalid URI. Please re-enter...',
                    'validator',
                    function(response, request) {

                        if (TP.notValid(response) ||
                            response.getSize() < 'http://'.getSize() ||
                            TP.notValid(TP.uc(response))) {
                            return false;
                        }

                        shell.$set('serverURI', response);

                        return true;
                    }));

    //  Add a query to the series to get the 'server name' (that is, the
    //  actual Jabber server).
    uis.addQuery(
            TP.hc('query', 'server name:',
                    'default',
                    function(response, request) {

                        var res,
                            hostname;

                        //  note we want to use the response to the first
                        //  question to generate part of our value here
                        res = request.getLastReply();

                        try {
                            hostname = TP.uc(res).get('hostname');
                        } catch (e) {
                            hostname = '';
                        }

                        return hostname;
                    },
                    'retryPrompt', 'Invalid server name.' +
                                    ' Please re-enter...',
                    'validator',
                    function(response, request) {

                        //  need a valid server name
                        if (TP.notValid(response) ||
                            response.getSize() < 1) {
                            return false;
                        }

                        shell.$set('serverName', response);

                        return true;
                    }));

    //  Add a hook in case the user cancels the operation during the
    //  registration process.
    uis.addCancelHook(
        function(aUIS) {

            TP.sig.UserOutputRequest.construct(
                TP.hc(
                    'output', 'Registration request cancelled.',
                    'messageType', 'failure'
                    )).fire(shell);

            shell.logout();

            return;
        });

    //  Add a hook in case the login operation fails during the registration
    //  process.
    uis.addFailureHook(
        function(aUIS) {

            TP.sig.UserOutputRequest.construct(
                TP.hc(
                    'output', 'Registration request failed.',
                    'messageType', 'failure'
                    )).fire(shell);

            shell.logout();

            return;
        });

    //  Add the hook in case the registration operation succeeds.
    uis.addSuccessHook(
        function(aUIS) {

            var yakService,
                res;

            //  Allocate the service and set its serviceURI and serverName
            if (TP.notValid(yakService =
                                TP.uri.XMPPService.getInstanceById(
                                    this.getServiceID()))) {
                yakService = TP.uri.XMPPService.construct(
                                    this.getServiceID());

                yakService.set('serviceURI', shell.get('serverURI'));
                yakService.set('serverName', shell.get('serverName'));
            }

            //  make the connection/login attempt...

            //  we don't check to see if we have an authenticated connection
            //  here since we're trying to register for a JID in the first
            //  place...

            //  first step is to try to opening the connection
            if (!yakService.openConnection()) {
                TP.sig.UserOutputRequest.construct(
                        TP.hc(
                            'output',
                            'Registration attempt failed.' +
                                ' Connection did not open.',
                            'messageType', 'failure'
                            )).fire(shell);

                return;
            }

            res = yakService.initiateRegistration();

            if (TP.notValid(res)) {
                //  failed to get connection
                TP.sig.UserOutputRequest.construct(
                        TP.hc(
                            'output', 'Registration attempt failed.' +
                                        ' No response.',
                            'messageType', 'failure'
                            )).fire(shell);

                return;
            }

            try {
                //  finish the registration process with the data we've
                //  collected
                shell.registerCompletion(res);
            } catch (e) {
                //  failed to get registered
                TP.sig.UserOutputRequest.construct(
                        TP.hc(
                            'output',
                            'Registration attempt failed processing' +
                                ' response.',
                            'messageType', 'failure'
                            )).fire(shell);
            }

            return;
        });

    /* eslint-enable consistent-this */

    //  now initiate the input series
    uis.fire(shell);

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('registerCompletion',
function(aRegistrationNode) {

    /**
     * @method registerCompletion
     * @summary Completes a registration sequence using the information
     *     contained in the receiver's instance variables and the user input
     *     series provided.
     * @param {TP.xmpp.Node} aRegistrationNode The node containing the
     *     registration information.
     * @returns {TP.shell.YAK} The receiver.
     */

    var shell,
        uis,

        yakService,

        regFields;

    /* eslint-disable consistent-this */

    shell = this;
    uis = TP.sig.UserInputSeries.construct();

    //  username and password are always required so we'll do them manually
    uis.addQuery(
        TP.hc('query', 'username:',
                'retryPrompt', 'Username cannot be empty.' +
                                ' Please re-enter...',
                'validator',
                function(response, request) {

                    var val;

                    if (TP.isEmpty(response)) {
                        return false;
                    }

                    //  adjust for whether they used an @ or not
                    if (response.containsString('@')) {
                        val = TP.xmpp.JID.construct(response);
                    } else {
                        val = TP.xmpp.JID.construct(
                                response + '@' + shell.get('serverName'));
                    }

                    shell.$set('userJID', val);

                    return true;
                }));

    uis.addQuery(
        TP.hc('query', 'password:',
                'hideInput', true,
                'retryPrompt', 'Password cannot be empty.' +
                                ' Please re-enter...',
                'validator',
                function(response, request) {

                    if (TP.notValid(response) ||
                        response.getSize() <
                             TP.shell.Shell.MIN_PASSWORD_LEN) {
                        return false;
                    }

                    return true;
                }));

    yakService = TP.uri.XMPPService.getInstanceById(this.getServiceID());

    //  This returns a hash of registration field names and descriptions
    //  that the server wants the user to complete in order to register with
    //  this particular server. We process each one of these into an
    //  additional query for the user. We skip 'username' and 'password'
    //  since almost every server requires them and we've hardcoded them
    //  above.
    regFields = yakService.getRegistrationFieldsFrom(aRegistrationNode);

    regFields.perform(
        function(kvPair) {

            //  Skip fields where the key is either 'username' or
            //  'password' - we took care of those above.
            if (kvPair.first() === 'username' ||
                kvPair.first() === 'password') {
                return;
            }

            //  If key is 'instructions', then there's nothing we need the
            //  user to do, so we just output that to stdout.
            if (kvPair.first() === 'instructions') {
                shell.stdout(kvPair.last());

                return;
            }

            //  Otherwise, add a query for that field (putting the
            //  description in parens for the user's convenience)
            uis.addQuery(
                TP.hc('query',
                        TP.join(kvPair.first(),
                                ' (', kvPair.last(), '): ')));
        });

    uis.addSuccessHook(
        function(aUIS) {

            var service,

                regValues,

                arr,
                i,

                item,
                val,
                res;

            regValues = TP.hc();

            arr = aUIS.get('queries');
            for (i = 0; i < arr.getSize(); i++) {
                item = arr.at(i).at(aUIS.getType().QUERY_INDEX);
                item = item.chop(':');

                val = aUIS.getReplies().at(i);

                //  special handling required here to avoid having the
                //  server name in the username we send
                if (item.startsWith('username') &&
                    item.containsString('@')) {
                    val = val.split('@').at(0);
                }

                regValues.atPut(item, val);
            }

            service = TP.uri.XMPPService.getInstanceById(
                                                this.getServiceID());

            res = service.finalizeRegistration(regValues);

            if (TP.notValid(res)) {
                //  failed to get connection
                TP.sig.UserOutputRequest.construct(
                        TP.hc(
                            'output', 'Registration attempt failed.' +
                                        ' No response.',
                            'messageType', 'failure'
                            )).fire(shell);

                return;
            }

            if (res.isError()) {
                //  failed to get connection
                TP.sig.UserOutputRequest.construct(
                        TP.hc(
                            'output', 'Registration attempt failed. ' +
                                                    res.get('errorMessage'),
                            'messageType', 'failure'
                            )).fire(shell);
            } else {
                //  it worked, output status and complete login sequence
                TP.sig.UserOutputRequest.construct(
                        TP.hc(
                            'output', 'Registration successful.' +
                                        ' Logging in...'
                            )).fire(shell);

                shell.loginCompletion(aUIS);
            }

            return;
        });

    /* eslint-enable consistent-this */

    uis.fire(shell);

    return this;
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('start',
function(aRequest) {

    /**
     * @method start
     * @summary Performs common startup processing, including displaying an
     *     announcement specific to the current shell. The login() sequence is
     *     initiated as part of this method.
     * @param {TP.sig.ShellRequest} aRequest The request which is triggering
     *     this activity.
     * @returns {TP.shell.YAK} The receiver.
     */

    var req,
        shell;

    if (this.isRunning()) {
        return this;
    }

    /* eslint-disable consistent-this */

    shell = this;

    this.announce(aRequest);

    //  turn off display of 'null' return values when doing input
    this.setVariable('SHOW_INVALID', false);

    //  prompt in this case tries to determine if we're working to register
    //  a new user or an existing one

    req = TP.sig.UserInputRequest.construct(
            TP.hc(
                'query', '(n)ew or (e)xisting user?',
                'default', 'existing',
                'async', true));

    // req.observe(req.getRequestID(), 'TP.sig.UserInput');

    //  if the user hit 'Shift-Esc', then we need to make sure everything is
    //  closed out.
    req.defineHandler('RequestCancelled',
        function() {

            shell.logout(aRequest);
        });

    req.defineHandler('UserInput',
        function(anotherSignal) {

            var result;

            req.ignore(req.getRequestID(), 'TP.sig.UserInput');
            req.getRequestID().signal('TP.sig.RequestCompleted');

            //  be prepared for cancellation etc.
            if (anotherSignal.didFail()) {
                shell.logout(aRequest);

                return;
            }

            result = anotherSignal.getResult();

            //  is this 'existing' or a new registration request?
            if (TP.isString(result) && result.toLowerCase().startsWith('e')) {
                shell.login(aRequest);
            } else {
                shell.register(aRequest);
            }
        });

    /* eslint-enable consistent-this */

    req.fire(shell);

    return this;
});

//  ------------------------------------------------------------------------
//  EXECUTION
//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('echoRequest',
function(aRequest) {

    /**
     * @method echoRequest
     * @summary Outputs the request by making a TP.sig.UserOutputRequest with
     *     the request command text.
     * @param {TP.sig.Request} aRequest The request object containing the input.
     * @returns {TP.sig.Request} The request.
     */

    var req,
        cmd,
        typ,
        out,
        jid;

    if (TP.notValid(cmd = aRequest.at('cmd'))) {
        return aRequest;
    }

    if (TP.notTrue(aRequest.at('cmdEcho'))) {
        return aRequest;
    }

    //  when the text is a command we think in terms of a 'query', otherwise
    //  its a standard message
    if (cmd.startsWith(':')) {
        typ = 'query';
        out = cmd;
    } else {
        //  peel off any escape of the prefix
        if (cmd.startsWith('\\:')) {
            cmd = cmd.slice(1);
        }

        jid = this.get('targetJID');
        if (TP.notValid(jid)) {
            jid = 'undefined';
        }

        typ = 'message';
        out = TP.join('<span class="outbound_ident_time">',
                        '[', TP.dc().asTimestamp(false, false), ']',
                        '</span><span class="outbound_ident_tid">',
                            '&nbsp;&gt;&nbsp;',
                            jid.asString(),
                        '</span>&nbsp;',
                            cmd);
    }

    req = TP.sig.UserOutputRequest.construct(
            TP.hc('output', out,
                    'render', true,
                    'messageType', typ));
    req.fire(this);

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('execute',
function(aRequest) {

    var response;

    //  first make sure we can construct a valid response
    if (TP.notValid(response = aRequest.getResponse())) {
        this.raise('TP.sig.ProcessingException',
                    'Couldn\'t construct response.');

        return;
    }

    //  TODO
    //  command lookup is simple in this shell, just parse for built-ins
    //  and run them or default to a :send action

    return response;
});

//  ------------------------------------------------------------------------
//  TP.shell.YAK BUILT-INS
//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('executeAvailable',
function(aRequest) {

    /**
     * @method executeAvailable
     * @summary Updates the availability status of the current JID in response
     *     to command requests.
     * @param {TP.sig.ShellRequest} aRequest The request containing the command
     *     input.
     * @returns {TP.sig.ShellRequest} The request.
     */

    var args,
        jidStatus,

        yakService;

    if (!this.canSend()) {
        return aRequest.fail(
            'No active XMPP connection. Please login.');
    }

    args = this.getCommandArguments(aRequest);
    if (args.getSize() > 0) {
        jidStatus = args.join(' ');
    } else {
        jidStatus = '';
    }

    yakService = TP.uri.XMPPService.getInstanceById(this.getServiceID());
    yakService.setPresence(TP.xmpp.XMLNS.ONLINE, jidStatus);

    this.displayDebugData(yakService.get('lastMsg'));

    return aRequest.complete();
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('executeAway',
function(aRequest) {

    /**
     * @method executeAway
     * @summary Updates the current JID's away status in response to a command
     *     request.
     * @param {TP.sig.ShellRequest} aRequest The request containing the command
     *     input.
     * @returns {TP.sig.ShellRequest} The request.
     */

    var args,
        jidStatus,

        yakService;

    if (!this.canSend()) {
        return aRequest.fail(
            'No active XMPP connection. Please login.');
    }

    args = this.getCommandArguments(aRequest);
    if (args.getSize() > 0) {
        jidStatus = args.join(' ');
    } else {
        jidStatus = '';
    }

    yakService = TP.uri.XMPPService.getInstanceById(this.getServiceID());
    yakService.setPresence(TP.xmpp.XMLNS.AWAY, jidStatus);

    this.displayDebugData(yakService.get('lastMsg'));

    return aRequest.complete();
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('executeDebug',
function(aRequest) {

    /**
     * @method executeDebug
     * @summary Turns on or off debugging output in response to a command
     *     request.
     * @param {TP.sig.ShellRequest} aRequest The request containing the command
     *     input.
     * @returns {TP.sig.ShellRequest} The request.
     */

    var args,
        bool;

    args = this.getCommandArguments(aRequest);
    if (args.getSize() !== 0) {
        bool = TP.bc(args.at(0));
        this.set('debug', bool);
    }

    //  TODO:
    //  in debug mode we want to see packets in both directions so we need
    //  to hook into the send machinery somehow
    aRequest.set('result',
        'debug is ' + (TP.isTrue(this.get('debug')) ? 'on' : 'off'));

    return aRequest.complete();
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('executeRegister',
function(aRequest) {

    /**
     * @method executeRegister
     * @summary Initiates a registration sequence.
     * @param {TP.sig.ShellRequest} aRequest The request containing the command
     *     input.
     * @returns {TP.sig.ShellRequest} The request.
     */

    this.register();

    return aRequest.complete();
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('executeRoster',
function(aRequest) {

    /**
     * @method executeRoster
     * @summary Requests and displays the current JIDs roster information.
     * @param {TP.sig.ShellRequest} aRequest The request containing the command
     *     input.
     * @returns {TP.sig.ShellRequest} The request.
     */

    var yakService;

    if (!this.canSend()) {
        return aRequest.fail(
            'No active XMPP connection. Please login.');
    }

    yakService = TP.uri.XMPPService.getInstanceById(this.getServiceID());
    yakService.fetchRoster();

    this.displayDebugData(yakService.get('lastMsg'));

    return aRequest.complete();
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('executeSecure',
function(aRequest) {

    /**
     * @method executeSecure
     * @summary Defines a secure key for a target JID. The first argument is
     *     the JID and all remaining text is considered to be the key string to
     *     use for that JID. If no key is provided it defaults to the current
     *     window location, allowing users across a single server to have a
     *     shared default key.
     * @param {TP.sig.ShellRequest} aRequest The request containing the command
     *     input.
     * @returns {TP.sig.ShellRequest} The request.
     */

    var args,
        jid,
        key;

    args = this.getCommandArguments(aRequest);
    if (args.getSize() < 1) {
        //  display the current secure JIDs (but not their key strings)
        TP.sig.UserOutputRequest.construct(
                TP.hc(
                    'output', TP.keys(this.get('secureJIDs')),
                    'messageType', 'response'
                    )).fire(this);

        return aRequest.complete();
    }

    jid = args.at(0);
    if (args.getSize() === 1) {
        //  when only the JID is specified the key defaults to the
        //  load URI for the application (which lets users from the
        //  same server share a key across all users of that server)
        key = window.location;
    } else {
        args.shift();
        key = args.join(' ');
    }

    this.get('secureJIDs').atPut(jid, key);

    return aRequest.complete();
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('executeSend',
function(aRequest) {

    /**
     * @method executeSend
     * @summary Responds to requests to send content to the currently targeted
     *     JID.
     * @param {TP.sig.ShellRequest} aRequest The request containing the command
     *     input.
     * @returns {TP.sig.ShellRequest} The request.
     */

    var yakService,

        jid,
        key,
        msgContent;

    if (!this.canSend()) {
        return aRequest.fail(
            'No active XMPP connection. Please login.');
    }

    if (TP.notValid(jid = this.get('targetJID'))) {
        return aRequest.fail(
            'No active target JID. Use :to to set one.');
    }

    if (TP.notValid(key = this.get('secureJIDs').at(jid))) {
        msgContent = aRequest.at('cmd');
    } else {
        msgContent = aRequest.at('cmd').encrypt(key);
    }

    yakService = TP.uri.XMPPService.getInstanceById(this.getServiceID());
    yakService.sendMessage(jid, msgContent);

    this.displayDebugData(yakService.get('lastMsg'));

    return aRequest.complete();
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('executeStatus',
function(aRequest) {

    /**
     * @method executeStatus
     * @summary Displays status information for all known JIDs (the current
     *     JID's buddy list) in response to a command request.
     * @param {TP.sig.ShellRequest} aRequest The request containing the command
     *     input.
     * @returns {TP.sig.ShellRequest} The request.
     */

    var pkt,
        str,
        list,
        show,
        stat,
        keys,
        i,
        item;

    str = TP.ac();
    str.push('<table width="100%" cellpadding="3" cellspacing="0"',
                ' class="xmpp_table"><thead class="xmpp_table_title">',
                    '<tr><td>JID</td>',
                    '<td>Showing</td>',
                    '<td>Status</td></tr></thead>',
                '<tbody class="xmpp_table_data">');

    list = TP.xmpp.JID.get('instances');
    keys = TP.keys(list).sort();

    for (i = 0; i < keys.getSize(); i++) {
        item = list.at(keys.at(i));
        if (TP.notValid(pkt = item.get('presence'))) {
            //  for some reason we have a JID but no presence
            show = 'unknown';
            stat = 'unknown';
        } else {
            show = TP.ifInvalid(pkt.get('show'), 'Online');
            stat = TP.ifInvalid(pkt.get('status'), '');
        }

        //  don't output those we have no data on
        if (show === 'unknown') {
            continue;
        }

        str.push('<tr><td>',
                    '<a href="#" onclick="',
                        'TP.shellExec(',
                        '\':to ', keys.at(i), '\'',
                        ', false, false, false,',
                        '\'', this.getID(), '\'',
                        ');',
                    ' return false;">',
                    keys.at(i),
                    '</a>',
                    '</td>');

        str.push('<td>', show, '</td>');
        str.push('<td>', stat, '</td>');
        str.push('</tr>');
    }

    str.push('</tbody></table>');

    str = str.join('');

    TP.sig.UserOutputRequest.construct(
            TP.hc(
                'output', str,
                'render', true,
                'messageType', 'response'
                )).fire(this);

    return aRequest.complete();
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('executeSubscribe',
function(aRequest) {

    /**
     * @method executeSubscribe
     * @summary Places a request to subscribe to a particular JID in response
     *     to a command request.
     * @param {TP.sig.ShellRequest} aRequest The request containing the command
     *     input.
     * @returns {TP.sig.ShellRequest} The request.
     */

    var args,
        jid,

        yakService;

    args = this.getCommandArguments(aRequest);
    if (args.getSize() < 1) {
        return aRequest.complete();
    } else {
        jid = args.at(0);
    }

    if (!this.canSend()) {
        return aRequest.fail(
            'No active XMPP connection. Please login.');
    }

    yakService = TP.uri.XMPPService.getInstanceById(this.getServiceID());
    yakService.subscribeTo(jid);

    this.displayDebugData(yakService.get('lastMsg'));

    return aRequest.complete();
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('executeTo',
function(aRequest) {

    /**
     * @method executeTo
     * @summary Sets the target JID for any unqualified messages, or, when
     *     followed directly by message text sends a one-time message to the JID
     *     provided without altering the default JID.
     * @param {TP.sig.ShellRequest} aRequest The request containing the command
     *     input.
     * @returns {TP.sig.ShellRequest} The request.
     */

    var args,
        jid,
        str,

        msgContent,
        yakService,

        out,
        req,
        key;

    args = this.getCommandArguments(aRequest);
    if (args.getSize() < 1) {
        //  display the current target
        TP.sig.UserOutputRequest.construct(
                TP.hc(
                    'output', this.get('targetJID'),
                    'messageType', 'response'
                    )).fire(this);

        return aRequest.complete();
    } else if (args.getSize() === 1) {
        //  adjust default JID
        this.set('targetJID', args.at(0));

        return aRequest.complete();
    }

    //  if we got here it's because they want to send a one-time message...
    if (!this.canSend()) {
        return aRequest.fail(
            'No active XMPP connection. Please login.');
    }

    jid = args.at(0);

    args.shift();
    str = args.join(' ');

    if (TP.notValid(key = this.get('secureJIDs').at(jid))) {
        msgContent = str;
    } else {
        msgContent = str.encrypt(key);
    }

    yakService = TP.uri.XMPPService.getInstanceById(this.getServiceID());
    yakService.sendMessage(jid, msgContent);

    this.displayDebugData(yakService.get('lastMsg'));

    out = TP.join('<span class="outbound_ident_time">',
                '[', TP.dc().asTimestamp(false, false), ']',
                '</span><span class="outbound_ident_tid">',
                    '&nbsp;&gt;&nbsp;',
                    jid,
                '</span>&nbsp;',
                    str);

    req = TP.sig.UserOutputRequest.construct(
                    TP.hc('output', out,
                            'render', true,
                            'messageType', 'message'));
    req.fire(this);

    return aRequest.complete();
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('executeUnavailable',
function(aRequest) {

    /**
     * @method executeUnavailable
     * @summary Sets the current JID's status to unavailable in response to a
     *     command request.
     * @param {TP.sig.ShellRequest} aRequest The request containing the command
     *     input.
     * @returns {TP.sig.ShellRequest} The request.
     */

    return this.executeAway(aRequest);
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('executeUnsecure',
function(aRequest) {

    /**
     * @method executeUnsecure
     * @summary Removes any secure encryption key for the JID provided, making
     *     communication with that JID unsecure.
     * @param {TP.sig.ShellRequest} aRequest The request containing the command
     *     input.
     * @returns {TP.sig.ShellRequest} The request.
     */

    var args,
        jid;

    args = this.getCommandArguments(aRequest);
    if (args.getSize() !== 1) {
        aRequest.atPut('topic', 'unsecure');

        return this.executeHelpTopic(aRequest);
    }

    jid = args.at(0);
    this.get('secureJIDs').removeKey(jid);

    return aRequest.complete();
});

//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineMethod('executeUnsubscribe',
function(aRequest) {

    /**
     * @method executeUnsubscribe
     * @summary Responds to requests to unsubscribe the current JID from a
     *     particular target JID's presence updates.
     * @param {TP.sig.ShellRequest} aRequest The request containing the command
     *     input.
     * @returns {TP.sig.ShellRequest} The request.
     */

    var args,
        jid,
        yakService;

    args = this.getCommandArguments(aRequest);
    if (args.getSize() < 1) {
        return aRequest.complete();
    } else {
        jid = args.at(0);
    }

    if (!this.canSend()) {
        return aRequest.fail(
            'No active XMPP connection. Please login.');
    }

    yakService = TP.uri.XMPPService.getInstanceById(this.getServiceID());
    yakService.unsubscribeFrom(jid);

    this.displayDebugData(yakService.get('lastMsg'));

    return aRequest.complete();
});

//  ------------------------------------------------------------------------
//  INBOUND TRAFFIC
//  ------------------------------------------------------------------------

TP.shell.YAK.Inst.defineHandler('XMPPInput',
function(aSignal) {

    /**
     * @method handleXMPPInput
     * @summary Responds to notifications of XMPP input. This method provides
     *     the hook between the XMPP data stream and the console, allowing the
     *     console to see packets as they arrive.
     * @param {TP.sig.XMPPInput} aSignal The triggering signal.
     * @returns {TP.shell.YAK} The receiver.
     */

    var str,
        args,
        node,
        render;

    if (TP.notValid(aSignal) || TP.notValid(args = aSignal.getPayload())) {
        TP.ifWarn() ?
            TP.warn('Invalid signal data for TP.sig.XMPPInput event.') : 0;

        return this;
    }

    if (TP.notValid(node = args.at('node'))) {
        TP.ifWarn() ?
            TP.warn('Missing stanza data for TP.sig.XMPPInput event.') : 0;

        return this;
    }

    //  hold node to support :reply
    this.set('lastNode', node);

    render = false;

    //  produce debug output as needed
    if (TP.isTrue(this.get('debug'))) {
        str = '[RECV]\n' +
                node.getTypeName() + ':\n' +
                node.asString() + '\n';

        TP.sig.UserOutputRequest.construct(
                TP.hc(
                    'output', str,
                    'render', render,
                    'messageType', 'debug'
                    )).fire(this);
    }

    try {
        str = node.asConsoleString(this);
        render = node.shouldRenderConsoleString();

        TP.sig.UserOutputRequest.construct(
                TP.hc(
                    'output', str,
                    'render', render,
                    'messageType', 'message'
                    )).fire(this);
    } catch (e) {
        TP.sig.UserOutputRequest.construct(
                TP.hc(
                    'output', TP.str(e),
                    'messageType', 'failure'
                    )).fire(this);
    }

    try {
        //  give the node a chance to respond to arrival
        if (TP.canInvoke(node, 'handleArrival')) {
            aSignal.set('console', this);
            node[TP.composeHandlerName('Arrival')](aSignal);
        }
    } catch (e) {
        TP.sig.UserOutputRequest.construct(
                TP.hc(
                    'output', TP.str(e),
                    'messageType', 'failure'
                    )).fire(this);
    }

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/xmlns/TP.tibet.XMLNS.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tibet';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {tibet:}
 * @summary This type represents the TIBET namespace
 *     (http://www.technicalpursuit.com/1999/tibet) in the tag processing
 *     system.
 */

//  ------------------------------------------------------------------------

TP.core.XMLNamespace.defineSubtype('tibet.XMLNS');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/xmlns/TP.tibet.group.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tibet';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tibet.group}
 * @summary A subtype of TP.dom.ElementNode that implements 'grouping'
 *     behavior for UI elements.
 */

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.defineSubtype('tibet:group');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tibet.group.Type.defineMethod('getQueryPath',
function(wantsDeep, wantsCompiled, wantsDisabled) {

    /**
     * @method getQueryPath
     * @summary Returns the 'query path' that can be used in calls such as
     *     'nodeEvaluatePath' to obtain all of the occurrences of the receiver
     *     in a document.
     * @param {Boolean} wantsDeep Whether or not the query should represent a
     *     'deep query' - that is, all of the occurrences of this element even
     *     under elements of the same type. This defaults to false.
     * @param {Boolean} [wantsCompiled=false] Whether or not the query should
     *     also find compiled representations of the receiver. This defaults to
     *     false.
     * @param {Boolean} [wantsDisabled=true] Whether or not the query should
     *     also find disabled versions of the receiver. This defaults to true.
     * @returns {String} The path that can be used to query for Nodes of this
     *     type.
     */

    var str,

        queryTypes,

        len,
        i;

    //  Grab the standard query for this type.
    str = this.callNextMethod();

    //  Note here how we do *not* ask for the subtypes deeply. This call will
    //  recurse endlessly if we do. We'll traverse each level as appropriate.
    queryTypes = this.getSubtypes();

    //  Grab the query for each subtype and append it (after separating with the
    //  standard CSS selector separator ',').
    len = queryTypes.getSize();
    for (i = 0; i < len; i++) {
        str += ', ' + queryTypes.at(i).getQueryPath(
                            wantsDeep, wantsCompiled, wantsDisabled);
    }

    return str;
});

//  ------------------------------------------------------------------------
//  Tag Phase Support
//  ------------------------------------------------------------------------

TP.tibet.group.Type.defineMethod('tagAttachDOM',
function(aRequest) {

    /**
     * @method tagAttachDOM
     * @summary Sets up runtime machinery for the element in aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var elem,
        elemTPNode,

        query,
        context;

    //  NOTE: WE DO *NOT* callNextMethod() here. This method is unusual in that
    //  it can take in Attribute nodes, etc. and our supertype method assumes
    //  Element nodes.

    //  Make sure that we have a node to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        //  TODO: Raise an exception
        return;
    }

    //  Get a handle to a TP.dom.Node representing an instance of this
    //  element type wrapped around elem. Note that this will both ensure a
    //  unique 'id' for the element and register it.
    elemTPNode = TP.tpnode(elem);

    //  Configure the wrapper to send change signals. This is important because
    //  if the group element changes its state due to underlying state changes
    //  in its members, it needs to signal changes.
    elemTPNode.shouldSignalChange(true);

    //  Set up the members of the group (i.e. by adding attributes to them that
    //  associate them with this group).
    elemTPNode.setupMembers();

    //  We register a query that, if any subtree mutations occur under our
    //  document element we want to be notified. Note that we don't actually
    //  register a query or a query context here - we want to know about all
    //  added or removed nodes.

    //  Note that this calls our 'mutationAddedFilteredNodes' and
    //  'mutationRemovedFilteredNodes' methods below with just the nodes
    //  that got added or removed.

    //  If we provided a query, then build a path object from it and set the
    //  context to be the whole document (since this probably what the author is
    //  going to be thinking when they write the query). Finally, register a
    //  'subtree query' with the mutation machinery so that any new content is
    //  assigned a group according to the query.
    if (TP.notEmpty(query = elemTPNode.getAttribute('query'))) {
        query = TP.apc(query);
        context = elemTPNode.getNativeDocument();

        TP.core.MutationSignalSource.addSubtreeQuery(
                elem,
                query,
                context);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.tibet.group.Type.defineMethod('tagDetachDOM',
function(aRequest) {

    /**
     * @method tagDetachDOM
     * @summary Tears down runtime machinery for the element in aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var elem,
        elemTPNode;

    //  Make sure that we have a node to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        //  TODO: Raise an exception
        return;
    }

    //  Get a handle to a TP.dom.Node representing an instance of this
    //  element type wrapped around elem. Note that this will both ensure a
    //  unique 'id' for the element and register it.
    elemTPNode = TP.tpnode(elem);

    //  Tear down the members of the group (i.e. by removing attributes from
    //  them that associate them with this group).
    elemTPNode.teardownMembers();

    //  We're going away - remove the subtree query that we registered when we
    //  got attached into this DOM.
    TP.core.MutationSignalSource.removeSubtreeQuery(elem);

    //  this makes sure we maintain parent processing - but we need to do it
    //  last because it nulls out our wrapper reference.
    this.callNextMethod();

    return;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.tibet.group.Inst.defineMethod('checkTestConditions',
function(attrName, conditionAttrVal, invertConditions) {

    /**
     * @method checkTestConditions
     * @summary Checks attribute test conditions for the receiver.
     * @description It is possible for group elements to change their attribute
     *     setting for certain 'ui state' attributes (i.e. readonly, disabled,
     *     required, invalid) based on whether one or all of their members have
     *     that setting. These take the form of:
     *
     *     validwhen="all"            All of the members must be invalid
     *     validwhen="any"            Any of the members may be invalid
     *     validwhen="none-or-all"    None or all of the members must be
     *                                invalid
     * @param {String} attrName The name of the attribute to check on each of
     *     the receiver's members to see if the test condition passes.
     * @param {String} conditionAttrVal The value of the 'test condition'
     *     attribute on the receiver. This determines what kind of test will be
     *     run and can currently consist of 'all', 'any' or 'none-or-all'
     * @param {Boolean} invertConditions Whether or not to 'invert' conditions
     *     because the value that is supplied is actually for the inverse
     *     attribute. For instance, the user authors a 'validwhen' attribute on
     *     the group, but the attribute we're checking for and need logic built
     *     around is '(pclass:)invalid'.
     * @returns {Boolean|null} True if the members meet the condition, false if
     *     they don't or null if the value of the test condition doesn't match
     *     one of it's currently supported values.
     */

    var shouldHaveAttribute,

        members,
        boundMembers,

        condition,

        len,

        i,

        val;

    //  Grab all of the members of this group and test their values.
    members = this.getMemberElements();

    //  Filter out only members that are bound. They're the only ones we'll
    //  consider for testing.
    boundMembers = members.select(
                    function(anElem) {
                        return TP.wrap(anElem).isBoundElement();
                    });

    if (invertConditions) {

        //  Inverting the value of the condition. (i.e. 'valid' when 'all' of
        //  them are valid means 'invalid' when 'any' are invalid.
        if (conditionAttrVal === 'all') {
            condition = 'any';
        } else if (conditionAttrVal === 'any') {
            //  (i.e. 'valid' when 'any' of them are valid means 'invalid' when
            //  'all' are invalid
            condition = 'all';
        }
    } else {
        condition = conditionAttrVal;
    }

    len = boundMembers.getSize();

    shouldHaveAttribute = null;

    switch (condition) {

        case 'all':

            if (invertConditions) {

                //  If the condition is 'all', that means that if *any* of the
                //  elements under the group do not have the attribute, then the
                //  group should not have the attribute.

                //  Initially set shouldHaveAttribute to true.
                shouldHaveAttribute = true;

                for (i = 0; i < len; i++) {
                    val = TP.bc(boundMembers.at(i).getAttribute(attrName));
                    if (val === false) {
                        //  One did have the attribute - we set our flag to
                        //  false
                        shouldHaveAttribute = false;
                        break;
                    }
                }
            } else {

                //  If the condition is 'all', that means that if *any* of the
                //  elements under the group have the attribute, then the group
                //  should have the attribute.

                //  Initially set shouldHaveAttribute to false.
                shouldHaveAttribute = false;

                for (i = 0; i < len; i++) {
                    val = TP.bc(boundMembers.at(i).getAttribute(attrName));
                    if (val === true) {
                        //  One did have the attribute - we set our flag to true
                        shouldHaveAttribute = true;
                        break;
                    }
                }
            }

            break;

        case 'any':

            if (invertConditions) {

                //  If the condition is 'any', that means that if *any* of the
                //  elements under the group have the attribute, then the group
                //  should have the attribute.

                //  Initially set shouldHaveAttribute to false.
                shouldHaveAttribute = false;

                for (i = 0; i < len; i++) {
                    val = TP.bc(boundMembers.at(i).getAttribute(attrName));
                    if (val === true) {
                        //  One did have the attribute - we set our flag to true
                        shouldHaveAttribute = true;
                        break;
                    }
                }

            } else {

                //  If the condition is 'any', that means that if *any* of the
                //  elements under the group do not have the attribute, then the
                //  group should not have the attribute.

                //  Initially set shouldHaveAttribute to true.
                shouldHaveAttribute = true;

                for (i = 0; i < len; i++) {
                    val = TP.bc(boundMembers.at(i).getAttribute(attrName));
                    if (val === false) {
                        //  One did *not* have the attribute - we set our flag to
                        //  false
                        shouldHaveAttribute = false;
                        break;
                    }
                }
            }

            break;

        default:
            break;
    }

    return shouldHaveAttribute;
});

//  ------------------------------------------------------------------------

TP.tibet.group.Inst.defineMethod('findFocusableElements',
function(includesGroups) {

    /**
     * @method findFocusableElements
     * @summary Finds focusable elements under the receiver and returns an
     *     Array of TP.dom.ElementNodes of them.
     * @param {Boolean} includesGroups Whether or not to include 'tibet:group'
     *     elements as 'focusable' elements under the receiver. The default is
     *     false.
     * @returns {TP.dom.ElementNode[]} An Array of TP.dom.ElementNodes under the
     *     receiver that can be focused.
     */

    var elem,

        lid,

        results,

        queryStr,

        noIntermediateGroups;

    //  Query for any elements under the context element that are focusable.

    //  Note here that the query only includes:
    //  -   elements that are focusable that are *direct* children of the
    //      receiver
    //  -   elements that are focusable that are descendants of any element
    //      under the receiver that is *not* a tibet:group element.
    //  This allows us to filter out elements that are focusable but nested
    //  under another tibet:group that is in the receiver (we don't want
    //  these elements).

    //  Also note that, unlike our supertype's version of this method, we add an
    //  attribute selector to the query to filter for only elements that are
    //  within our group, not in any other groups.

    elem = this.getNativeNode();

    lid = this.getLocalID();

    //  NOTE: Because of how these queries are structured, they have to be
    //  executed separately and their results combined.
    results = TP.ac();

    //  Query for any immediate children that either don't have a tibet:group
    //  attribute or have a 'tibet:group' attribute that matches our group ID.
    queryStr = TP.computeFocusableQuery('> ', ':not([tibet|group=])') + ', ' +
                TP.computeFocusableQuery('> ', '[tibet|group="' + lid + '"]');

    results.push(
        TP.byCSSPath(queryStr,
                        elem,
                        false,
                        false));

    //  Query for any descendants that either don't have a tibet:group attribute
    //  or have a 'tibet:group' attribute that matches our group ID.
    queryStr = TP.computeFocusableQuery(null, ':not([tibet|group])') + ', ' +
                TP.computeFocusableQuery(null, '[tibet|group="' + lid + '"]');

    //  Query for any descendants that have a 'tibet:group' attribute
    //  that matches our group ID.
    noIntermediateGroups = TP.byCSSPath(queryStr,
                                        elem,
                                        false,
                                        false);

    //  Now, filter that result set to make sure that there are no 'tibet:group'
    //  elements between each result node and our own element.
    noIntermediateGroups = noIntermediateGroups.filter(
                            function(focusableElem) {
                                return !TP.isElement(
                                            TP.nodeDetectAncestorMatchingCSS(
                                                focusableElem,
                                                'tibet|group',
                                                elem));
                            });

    results.push(noIntermediateGroups);

    if (includesGroups) {
        results.push(
            TP.byCSSPath('> tibet|group, *:not(tibet|group) tibet|group',
                            elem,
                            false,
                            false));
    }

    //  Flatten out the results and unique them.
    results = results.flatten();
    results.unique();

    //  Iterate over them and see if they're displayed (not hidden by CSS -
    //  although they could currently not be visible to the user).
    results = results.select(
                    function(anElem) {
                        return TP.elementIsDisplayed(anElem);
                    });

    //  Sort the Array of elements by their 'tabindex' according to the
    //  HTML5 tabindex rules.
    results.sort(TP.sort.TABINDEX_ORDER);

    //  Wrap the results to make TP.dom.ElementNodes
    return TP.wrap(results);
});

//  ------------------------------------------------------------------------

TP.tibet.group.Inst.defineMethod('focus',
function(moveAction) {

    /**
     * @method focus
     * @summary Focuses the receiver for keyboard input.
     * @param {String} moveAction The type of 'move' that the user requested.
     *     This can be one of the following:
     *          TP.FIRST
     *          TP.LAST
     *          TP.NEXT
     *          TP.PREVIOUS
     *          TP.FIRST_IN_GROUP
     *          TP.LAST_IN_GROUP
     *          TP.FIRST_IN_NEXT_GROUP
     *          TP.FIRST_IN_PREVIOUS_GROUP
     *          TP.FOLLOWING
     *          TP.PRECEDING.
     * @returns {TP.tibet.group} The receiver.
     */

    var focusableElements,
        tpElementToFocus;

    //  If there are focusable element under the group, then move the focus to
    //  one of them.
    if (TP.notEmpty(focusableElements = this.findFocusableElements())) {

        //  If there was a supplied move action that was one of the 'focus
        //  last/previous' actions, then just use the last focusable element.
        if (moveAction === TP.LAST ||
            moveAction === TP.PREVIOUS ||
            moveAction === TP.LAST_IN_GROUP ||
            moveAction === TP.PRECEDING) {
            tpElementToFocus = focusableElements.last();
        } else {

            //  Otherwise, see if there was any selected elements - if there
            //  were, grab the first one. We'll use that.
            tpElementToFocus =
                focusableElements.detect(
                            function(aTPElem) {
                                return aTPElem.hasAttribute('pclass:selected');
                            });

            //  No selected element? Just use the first one.
            if (TP.notValid(tpElementToFocus)) {
                tpElementToFocus = focusableElements.first();
            }
        }

        TP.dom.UIElementNode.set('$calculatedFocusingTPElem',
                                    tpElementToFocus);

        tpElementToFocus.focus();
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.tibet.group.Inst.defineMethod('getMemberElements',
function() {

    /**
     * @method getMemberElements
     * @summary Returns the members of the group based on the query on the
     *     receiver.
     * @description If no query is supplied, a default of './*' (all descendants
     *     from the receiver down) is used. Also, if the receiver is not empty,
     *     it is used as the 'context' of the query. If the receiver is empty,
     *     then the document element of the document the receiver is in is used
     *     as the context.
     * @returns {TP.dom.ElementNode[]} The Array of member TP.dom.ElementNodes
     *     that the receiver designates via its query and context.
     */

    var query,
        queryWasDefined,

        contextElem,

        results;

    //  No query? Use the standard 'all child elements'
    if (TP.isEmpty(query = this.getAttribute('query'))) {
        queryWasDefined = false;

        //  This query allows direct children who are any kind of element,
        //  including groups, and other descendants who aren't *under* a group,
        //  thereby populating only shallowly.
        query = '> *, *:not(tibet|group) *';
    } else {
        queryWasDefined = true;
    }

    //  If we don't have any child *elements*, then the context is the
    //  documentElement.
    if (TP.isEmpty(this.getChildElements())) {

        //  If the query wasn't defined by the user, then we don't want to query
        //  against the document element using the query above - just return an
        //  empty Array here.
        if (!queryWasDefined) {
            return TP.ac();
        }

        contextElem = this.getDocument().getDocumentElement();
    } else {
        //  Otherwise, its the receiver.
        /* eslint-disable consistent-this */
        contextElem = this;
        /* eslint-enable consistent-this */
    }

    //  Grab the 'result nodes' using the get call. If there were no
    //  results, return the empty Array.
    if (TP.notValid(results = contextElem.get(
                    TP.apc(query, TP.hc('shouldCollapse', false))))) {
        return TP.ac();
    }

    //  Make sure that it contains only Elements.
    results = results.select(
                function(aTPNode) {
                    return TP.isKindOf(aTPNode, TP.dom.ElementNode);
                });

    //  This will wrap all of the elements found in the results
    results = TP.wrap(results);

    return results;
});

//  ------------------------------------------------------------------------

TP.tibet.group.Inst.defineMethod('getMemberGroups',
function() {

    /**
     * @method getMemberGroups
     * @summary Returns the members of the group that are themselves groups
     * @returns {TP.tibet.group[]} The Array of member 'tibet:group'
     *     TP.dom.ElementNodes.
     */

    var allMembers,
        results;

    if (TP.isEmpty(allMembers = this.getMemberElements())) {
        return TP.ac();
    }

    results = allMembers.select(
                    function(aTPElem) {
                        return TP.isKindOf(aTPElem, TP.tibet.group);
                    });

    return results;
});

//  ------------------------------------------------------------------------

TP.tibet.group.Inst.defineHandler('AttributeChange',
function(aSignal) {

    /**
     * @method handleAttributeChange
     * @summary Handles when one of this group's members changes one of its
     *     attributes. This may cause this group element to add or remove the
     *     same attribute from itself.
     * @description It is possible for group elements to change their attribute
     *     setting for certain 'ui state' attributes (i.e. readonly, disabled,
     *     required, invalid) based on whether one or all of their members have
     *     that setting. These take the form of:
     *
     *     validwhen="all"            All of the members must be invalid
     *     validwhen="any"            Any of the members may be invalid
     *     validwhen="none-or-all"    None or all of the members must be
     *                                invalid
     * @param {TP.sig.UIAttributeChange} aSignal The signal that caused this
     *     handler to trip.
     * @returns {TP.tibet.group} The receiver.
     */

    var attrName,
        conditionAttrVal,

        invertCondition,

        positiveState;

    if (TP.isEmpty(attrName = aSignal.at('aspect'))) {
        //  TODO: Raise exception
        return this;
    }

    //  Slice off the 'Pclass' prefix and lowercase the remaining portion so
    //  that we can test it consistently.
    attrName = attrName.slice(6).toLowerCase();

    //  attrName will be one of the following:
    //      readonly
    //      disabled
    //      required
    //      invalid

    //  If the attribute name is 'invalid' we query for a 'validwhen' attribute
    //  and set the flag to invert the condition testing.
    if (attrName === 'invalid') {
        conditionAttrVal = this.getAttribute('validwhen');
        invertCondition = true;
    } else {
        conditionAttrVal = this.getAttribute(attrName + 'when');
        invertCondition = false;
    }

    if (TP.notEmpty(conditionAttrVal)) {

        //  NB: This method could return true, false or null. We test explicitly
        //  for true or false below.

        positiveState = this.checkTestConditions(
                                attrName, conditionAttrVal, invertCondition);

        //  Set the flag (or not) and send the proper signal depending on
        //  whether the flag is already set.

        //  Note that positiveState could be null, in which case neither one of
        //  these statements will execute.
        if (TP.isTrue(positiveState)) {
            if (!this.$isInState('pclass:' + attrName)) {
                if (attrName === 'invalid') {
                    this.signalUsingFacetAndValue('valid', false);
                } else {
                    this.signalUsingFacetAndValue(attrName, true);
                }
            }
        } else if (TP.isFalse(positiveState)) {
            if (this.$isInState('pclass:' + attrName)) {
                if (attrName === 'invalid') {
                    this.signalUsingFacetAndValue('valid', true);
                } else {
                    this.signalUsingFacetAndValue(attrName, false);
                }
            }
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.tibet.group.Inst.defineHandler('UIDisabled',
function(aSignal) {

    /**
     * @method handleUIDisabled
     * @summary Causes the receiver to be put into its 'disabled state'.
     * @param {TP.sig.UIDisabled} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.tibet.group} The receiver.
     */

    var conditionAttrVal,
        positiveState,

        shouldSet;

    if (this.shouldPerformUIHandler(aSignal)) {

        //  Grab the value of the 'qualifer' attribute that might be set on the
        //  receiver.
        conditionAttrVal = this.getAttribute('disabledwhen');

        //  If that attribute was set on the receiver, then do a more
        //  sophisticated check to see if we should set the attribute matching
        //  this state on the receiver.
        if (TP.notEmpty(conditionAttrVal)) {

            //  Check to see if any of the test conditions are true, using the
            //  name of the attribute of the receiver's members that should be
            //  queried as part of the testing and the value of the qualifier.
            positiveState = this.checkTestConditions(
                                        'disabled', conditionAttrVal, false);

            shouldSet = false;

            if (TP.isTrue(positiveState)) {
                if (!this.$isInState('pclass:disabled')) {
                    shouldSet = true;
                }
            }
        } else {

            //  Otherwise, no sophisticated check required - do the set.
            shouldSet = true;
        }

        if (shouldSet) {
            this.setAttrDisabled(true);
        }
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIDisabled'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIDisabled', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.tibet.group.Inst.defineHandler('UIEnabled',
function(aSignal) {

    /**
     * @method handleUIEnabled
     * @summary Causes the receiver to be put into its 'enabled state'.
     * @param {TP.sig.UIEnabled} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.tibet.group} The receiver.
     */

    var conditionAttrVal,
        positiveState,

        shouldSet;

    if (this.shouldPerformUIHandler(aSignal)) {

        //  Grab the value of the 'qualifer' attribute that might be set on the
        //  receiver.
        conditionAttrVal = this.getAttribute('disabledwhen');

        //  If that attribute was set on the receiver, then do a more
        //  sophisticated check to see if we should set the attribute matching
        //  this state on the receiver.
        if (TP.notEmpty(conditionAttrVal)) {

            //  Check to see if any of the test conditions are true, using the
            //  name of the attribute of the receiver's members that should be
            //  queried as part of the testing and the value of the qualifier.
            positiveState = this.checkTestConditions(
                                        'disabled', conditionAttrVal, false);

            shouldSet = false;

            if (TP.isFalse(positiveState)) {
                if (this.$isInState('pclass:disabled')) {
                    shouldSet = true;
                }
            }
        } else {

            //  Otherwise, no sophisticated check required - do the set.
            shouldSet = true;
        }

        if (shouldSet) {
            this.setAttrDisabled(false);
        }
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIEnabled'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIEnabled', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.tibet.group.Inst.defineHandler('UIInvalid',
function(aSignal) {

    /**
     * @method handleUIInvalid
     * @summary Causes the receiver to be put into its 'invalid state'.
     * @param {TP.sig.UIInvalid} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.tibet.group} The receiver.
     */

    var conditionAttrVal,
        positiveState,

        shouldSet;

    if (this.shouldPerformUIHandler(aSignal)) {

        //  Grab the value of the 'qualifer' attribute that might be set on the
        //  receiver.
        conditionAttrVal = this.getAttribute('validwhen');

        //  If that attribute was set on the receiver, then do a more
        //  sophisticated check to see if we should set the attribute matching
        //  this state on the receiver.
        if (TP.notEmpty(conditionAttrVal)) {

            //  Check to see if any of the test conditions are true, using the
            //  name of the attribute of the receiver's members that should be
            //  queried as part of the testing and the value of the qualifier.
            positiveState = this.checkTestConditions(
                                        'invalid', conditionAttrVal, true);

            shouldSet = false;

            if (TP.isTrue(positiveState)) {
                if (!this.$isInState('pclass:invalid')) {
                    shouldSet = true;
                }
            }
        } else {

            //  Otherwise, no sophisticated check required - do the set.
            shouldSet = true;
        }

        if (shouldSet) {
            this.setAttrInvalid(true);
        }
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIInvalid'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIInvalid', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.tibet.group.Inst.defineHandler('UIOptional',
function(aSignal) {

    /**
     * @method handleUIOptional
     * @summary Causes the receiver to be put into its 'optional state'.
     * @param {TP.sig.UIOptional} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.tibet.group} The receiver.
     */

    var conditionAttrVal,
        positiveState,

        shouldSet;

    if (this.shouldPerformUIHandler(aSignal)) {

        //  Grab the value of the 'qualifer' attribute that might be set on the
        //  receiver.
        conditionAttrVal = this.getAttribute('requiredwhen');

        //  If that attribute was set on the receiver, then do a more
        //  sophisticated check to see if we should set the attribute matching
        //  this state on the receiver.
        if (TP.notEmpty(conditionAttrVal)) {

            //  Check to see if any of the test conditions are true, using the
            //  name of the attribute of the receiver's members that should be
            //  queried as part of the testing and the value of the qualifier.
            positiveState = this.checkTestConditions(
                                        'required', conditionAttrVal, false);

            shouldSet = false;

            if (TP.isFalse(positiveState)) {
                if (this.$isInState('pclass:required')) {
                    shouldSet = true;
                }
            }
        } else {

            //  Otherwise, no sophisticated check required - do the set.
            shouldSet = true;
        }

        if (shouldSet) {
            this.setAttrRequired(false);
        }
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIOptional'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIOptional', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.tibet.group.Inst.defineHandler('UIReadonly',
function(aSignal) {

    /**
     * @method handleUIReadonly
     * @summary Causes the receiver to be put into its 'read only state'.
     * @param {TP.sig.UIReadonly} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.tibet.group} The receiver.
     */

    var conditionAttrVal,
        positiveState,

        shouldSet;

    if (this.shouldPerformUIHandler(aSignal)) {

        //  Grab the value of the 'qualifer' attribute that might be set on the
        //  receiver.
        conditionAttrVal = this.getAttribute('readonlywhen');

        //  If that attribute was set on the receiver, then do a more
        //  sophisticated check to see if we should set the attribute matching
        //  this state on the receiver.
        if (TP.notEmpty(conditionAttrVal)) {

            //  Check to see if any of the test conditions are true, using the
            //  name of the attribute of the receiver's members that should be
            //  queried as part of the testing and the value of the qualifier.
            positiveState = this.checkTestConditions(
                                        'readonly', conditionAttrVal, false);

            shouldSet = false;

            if (TP.isTrue(positiveState)) {
                if (!this.$isInState('pclass:readonly')) {
                    shouldSet = true;
                }
            }
        } else {

            //  Otherwise, no sophisticated check required - do the set.
            shouldSet = true;
        }

        if (shouldSet) {
            this.setAttrReadonly(true);
        }
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIReadonly'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIReadonly', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.tibet.group.Inst.defineHandler('UIReadwrite',
function(aSignal) {

    /**
     * @method handleUIReadwrite
     * @summary Causes the receiver to be put into its 'read write state'.
     * @param {TP.sig.UIReadwrite} aSignal The signal that caused this handler
     *     to trip.
     * @returns {TP.tibet.group} The receiver.
     */

    var conditionAttrVal,
        positiveState,

        shouldSet;

    if (this.shouldPerformUIHandler(aSignal)) {

        //  Grab the value of the 'qualifer' attribute that might be set on the
        //  receiver.
        conditionAttrVal = this.getAttribute('readonlywhen');

        //  If that attribute was set on the receiver, then do a more
        //  sophisticated check to see if we should set the attribute matching
        //  this state on the receiver.
        if (TP.notEmpty(conditionAttrVal)) {

            //  Check to see if any of the test conditions are true, using the
            //  name of the attribute of the receiver's members that should be
            //  queried as part of the testing and the value of the qualifier.
            positiveState = this.checkTestConditions(
                                        'readonly', conditionAttrVal, false);

            shouldSet = false;

            if (TP.isFalse(positiveState)) {
                if (this.$isInState('pclass:readonly')) {
                    shouldSet = true;
                }
            }
        } else {

            //  Otherwise, no sophisticated check required - do the set.
            shouldSet = true;
        }

        if (shouldSet) {
            this.setAttrReadonly(false);
        }
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIReadwrite'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIReadwrite', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.tibet.group.Inst.defineHandler('UIRequired',
function(aSignal) {

    /**
     * @method handleUIRequired
     * @summary Causes the receiver to be put into its 'required state'.
     * @param {TP.sig.UIRequired} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.tibet.group} The receiver.
     */

    var conditionAttrVal,
        positiveState,

        shouldSet;

    if (this.shouldPerformUIHandler(aSignal)) {

        //  Grab the value of the 'qualifer' attribute that might be set on the
        //  receiver.
        conditionAttrVal = this.getAttribute('requiredwhen');

        //  If that attribute was set on the receiver, then do a more
        //  sophisticated check to see if we should set the attribute matching
        //  this state on the receiver.
        if (TP.notEmpty(conditionAttrVal)) {

            //  Check to see if any of the test conditions are true, using the
            //  name of the attribute of the receiver's members that should be
            //  queried as part of the testing and the value of the qualifier.
            positiveState = this.checkTestConditions(
                                        'required', conditionAttrVal, false);

            shouldSet = false;

            if (TP.isTrue(positiveState)) {
                if (!this.$isInState('pclass:required')) {
                    shouldSet = true;
                }
            }
        } else {

            //  Otherwise, no sophisticated check required - do the set.
            shouldSet = true;
        }

        if (shouldSet) {
            this.setAttrRequired(true);
        }
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIRequired'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIRequired', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.tibet.group.Inst.defineHandler('UIValid',
function(aSignal) {

    /**
     * @method handleUIValid
     * @summary Causes the receiver to be put into its 'valid state'.
     * @param {TP.sig.UIValid} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.tibet.group} The receiver.
     */

    var conditionAttrVal,
        positiveState,

        shouldSet;

    if (this.shouldPerformUIHandler(aSignal)) {

        //  Grab the value of the 'qualifer' attribute that might be set on the
        //  receiver.
        conditionAttrVal = this.getAttribute('validwhen');

        //  If that attribute was set on the receiver, then do a more
        //  sophisticated check to see if we should set the attribute matching
        //  this state on the receiver.
        if (TP.notEmpty(conditionAttrVal)) {

            //  Check to see if any of the test conditions are true, using the
            //  name of the attribute of the receiver's members that should be
            //  queried as part of the testing and the value of the qualifier.
            positiveState = this.checkTestConditions(
                                        'invalid', conditionAttrVal, true);

            shouldSet = false;

            if (TP.isFalse(positiveState)) {
                if (this.$isInState('pclass:invalid')) {
                    shouldSet = true;
                }
            }
        } else {

            //  Otherwise, no sophisticated check required - do the set.
            shouldSet = true;
        }

        if (shouldSet) {
            this.setAttrInvalid(false);
        }
    }

    //  If the receiver has an 'on:' attribute matching this signal name (i.e.
    //  'on:UIValid'), then dispatch whatever signal is configured to fire
    //  when this signal is processed.
    this.dispatchResponderSignalFromAttr('UIValid', aSignal.at('trigger'));

    return this;
});

//  ------------------------------------------------------------------------

TP.tibet.group.Inst.defineMethod('isReadyToRender',
function() {

    /**
     * @method isReadyToRender
     * @summary Whether or not the receiver is 'ready to render'. For this type,
     *     this always returns true.
     * @returns {Boolean} Whether or not the receiver is ready to render.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.tibet.group.Inst.defineMethod('mutationAddedFilteredNodes',
function(addedNodes, queryInfo) {

    /**
     * @method mutationAddedFilteredNodes
     * @summary Handles when nodes got added to the DOM we're in, filtered by
     *     the query that we registered with the MutationSignalSource.
     * @param {Node[]} addedNodes The Array of nodes that got added to the DOM,
     *     then filtered by our query.
     * @param {TP.core.Hash} queryInfo Information that was registered for this
     *     query when it was originally set up.
     * @returns {TP.tibet.group} The receiver.
     */

    var groupTPElems,
        groupElems,

        addedElems,

        occursInBoth,

        ourLocalID;

    //  Grab all elements that could be our members - if the added nodes are
    //  part of our group, they will now be in this list.
    if (TP.notEmpty(groupTPElems = this.getMemberElements())) {

        //  Unwrap them
        groupElems = TP.unwrap(groupTPElems);

        //  Collect up all of the descendant elements under the addedNodes
        //  (since the mutation machinery will only hand us the added 'roots')
        addedElems = addedNodes.collect(
            function(aNode) {
                if (TP.isElement(aNode)) {
                    return TP.ac(aNode, TP.nodeGetDescendantElements(aNode));
                }
            });

        //  This will be an Array of Arrays - flatten it.
        addedElems = addedElems.flatten();

        //  Compare that list to what the mutation machinery handed us as added
        //  nodes.
        occursInBoth = groupElems.intersection(addedElems, TP.IDENTITY);

        ourLocalID = this.getLocalID();

        //  Set the group of any that are in both lists. Also, we observe each
        //  one for AttributeChange.
        occursInBoth.perform(
                function(anElem) {
                    var aTPElem;

                    aTPElem = TP.wrap(anElem);

                    //  Use $setAttribute() and don't signal for these new
                    //  elements since we're just setting them up.
                    aTPElem.$setAttribute('tibet:group', ourLocalID, false);

                    this.observe(aTPElem, 'AttributeChange');
                }.bind(this));
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.tibet.group.Inst.defineMethod('mutationRemovedFilteredNodes',
function(removedNodes, queryInfo) {

    /**
     * @method mutationRemovedFilteredNodes
     * @summary Handles when nodes got removed from the DOM we're in, filtered
     *     bythe query that we registered with the MutationSignalSource.
     * @param {Node[]} removedNodes The Array of *all* of the nodes that got
     *     removed from the DOM. Note that because these nodes have already been
     *     removed from the DOM by the time TIBET's machinery gets called,
     *     unlike mutationAddedFilteredNodes, they will *not* have been filtered
     *     by the query.
     * @param {TP.core.Hash} queryInfo Information that was registered for this
     *     query when it was originally set up.
     * @returns {TP.tibet.group} The receiver.
     */

    var groupTPElems,
        groupElems,

        removedElems,

        occursInBoth;

    //  Grab all elements that could be our members - if the added nodes are
    //  part of our group, they will now be in this list.
    if (TP.notEmpty(groupTPElems = this.getMemberElements())) {

        //  Unwrap them
        groupElems = TP.unwrap(groupTPElems);

        //  Collect up all of the descendant elements under the addedNodes
        //  (since the mutation machinery will only hand us the removed 'roots')
        removedElems = removedNodes.collect(
                    function(aNode) {
                        if (TP.isElement(aNode)) {
                            return TP.nodeGetDescendantElements(aNode);
                        }
                    });

        //  This will be an Array of Arrays - flatten it.
        removedElems = removedElems.flatten();

        //  Compare that list to what the mutation machinery handed us as added
        //  nodes.
        occursInBoth = groupElems.intersection(removedElems, TP.IDENTITY);

        //  Ignore each member for AttributeChange. This undoes the observation
        //  that we do in mutationAddedFilteredNodes.
        occursInBoth.perform(
                function(anElem) {
                    var aTPElem;

                    aTPElem = TP.wrap(anElem);

                    this.ignore(aTPElem, 'AttributeChange');
                }.bind(this));
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.tibet.group.Inst.defineMethod('setupMembers',
function() {

    /**
     * @method setupMembers
     * @summary Sets up the members of this group. This includes associating
     *     them to the group and observing any attribute changes from those
     *     members.
     * @returns {TP.tibet.group} The receiver.
     */

    var groupTPElems;

    //  Grab all of the members of this group, iterate over them and add
    //  ourself as a group that contains them. Note that an element can have
    //  more than one group. Also, we observe each one for AttributeChange.
    if (TP.notEmpty(groupTPElems = this.getMemberElements())) {
        groupTPElems.perform(
                function(aTPElem) {

                    //  Note: This will overwrite any prior group element
                    //  setting for aTPElem
                    aTPElem.setGroupElement(this);

                    this.observe(aTPElem, 'AttributeChange');
                }.bind(this));
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.tibet.group.Inst.defineMethod('teardownMembers',
function() {

    /**
     * @method teardownMembers
     * @summary Tears down the members of this group. This includes
     *     disassociating them from the group and ignoring any attribute changes
     *     from those members.
     * @returns {TP.tibet.group} The receiver.
     */

    var groupTPElems;

    //  Grab all of the members of this group, iterate over them and add
    //  ourself as a group that contains them. Note that an element can have
    //  more than one group. Also, we observe each one for AttributeChange.
    if (TP.notEmpty(groupTPElems = this.getMemberElements())) {
        groupTPElems.perform(
                function(aTPElem) {

                    //  Note: This will remove the attribute associating aTPElem
                    //  with this group.
                    aTPElem.setGroupElement(null);

                    this.ignore(aTPElem, 'AttributeChange');
                }.bind(this));
    }

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/xmlns/TP.tibet.data.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tibet';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tibet.data}
 * @summary A subtype of TP.dom.ElementNode that implements the ability to put
 *         'static data' in the page.
 */

//  ------------------------------------------------------------------------

TP.dom.UIDataElement.defineSubtype('tibet:data');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  Tag Phase Support
//  ------------------------------------------------------------------------

TP.tibet.data.Type.defineMethod('tagPrecompile',
function(aRequest) {

    /**
     * @method tagPrecompile
     * @summary Precompiles the content by running any substitution expressions
     *     in it.
     * @description At this level, this method runs substitutions against the
     *     the text content of any attributes *only* (and *not* its text content
     *     like the supertype, in case that has ACP expressions embedded in its
     *     data) and supplies the following variables to the substitutions
     *     expressions:
     *
     *          TP         ->  The TP root.
     *          APP        ->  The APP root.
     *          $REQUEST    ->  The request that triggered this processing.
     *          $TAG        ->  The TP.dom.ElementNode that is being processed.
     *          $TARGET     ->  The target TP.dom.DocumentNode, if any, that
     *                          the result of this processing will be rendered
     *                          into.
     *          $SOURCE     ->  The original source tag, if this is being
     *                          processed as part of a nested template.
     *          $SELECTION  ->  The current selection. This could be text or an
     *                          Array of objects determined by the selection
     *                          manager.
     *          $*          ->  An alias for $SELECTION
     *          $FOCUS      ->  The currently focused TP.dom.ElementNode in the
     *                          target TP.dom.DocumentNode.
     *          $@          ->  An alias for $FOCUS
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var node,
        tpNode,

        info,

        attrs,
        len,
        j;

    //  Make sure that we have a node to work from.
    if (!TP.isNode(node = aRequest.at('node'))) {
        return;
    }

    //  Wrap it so that when we ask for its text content, we're getting the best
    //  representation.
    tpNode = TP.wrap(node);

    //  Populate the substitution information with various variables, etc.
    info = this.populateSubstitutionInfo(aRequest);

    //  The $TAG will have been set to our parent node (the default behavior of
    //  the call above), so we need to set it to the wrapper currently
    //  processing node.
    info.atPut('$TAG', tpNode);

    info.atPut('shouldEcho', false);
    info.atPut('annotateMarkup', this.shouldWrapACPOutput());

    //  Make sure that any required data (i.e. 'id' attributes and others) are
    //  defined. id attributes, in particular, because they can be dynamically
    //  assigned by TIBET, are assumed to 'always exist'. This insures that they
    //  do for use in ACP template processing. Note that we always use the outer
    //  content here, since there may be attributes that we need to detect.
    tpNode.prepopulateRequiredTemplateData(info, tpNode.getOuterContent());

    //  Process the attributes. This method should resolve any ACP expressions
    //  in the attributes themselves.
    attrs = TP.elementGetAttributeNodes(node);
    len = attrs.getSize();
    for (j = 0; j < len; j++) {
        tpNode.transformAttributeNode(attrs.at(j), info);
    }

    return;
});

//  ------------------------------------------------------------------------

TP.tibet.data.Type.defineMethod('tagAttachComplete',
function(aRequest) {

    /**
     * @method tagAttachComplete
     * @summary Executes once the tag has been fully processed and its
     *     attachment phases are fully complete.
     * @description Because tibet:data tag content drives binds and we need to
     *     notify even without a full page load, we notify from here once the
     *     attachment is complete (instead of during tagAttachData).
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var elem,
        tpElem;

    //  this makes sure we maintain parent processing
    this.callNextMethod();

    //  Make sure that we have a node to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        return;
    }

    tpElem = TP.wrap(elem);

    //  If the element is being 'recast' (i.e. recomputed in place, usually when
    //  developing with the Sherpa), then just return here. We don't want to do
    //  any further processing to process/register/unregister data.
    if (tpElem.isRecasting()) {
        return;
    }

    //  Start off by 'resetting' the element. This will set up all of the data
    //  structures, etc.
    tpElem.reset();

    return;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.tibet.data.Inst.defineMethod('getNamedResource',
function() {

    /**
     * @method getNamedResource
     * @returns {Object} Returns the resource named by the receiver.
     */

    var namedHref,
        namedURI;

    if (TP.notEmpty(namedHref = this.getAttribute('name'))) {
        if (!TP.isURI(namedURI = TP.uc(namedHref))) {
            //  Raise an exception
            return this.raise('TP.sig.InvalidURI');
        }
    } else {
        //  No 'name' attribute.
        return null;
    }

    //  NB: We assume 'async' of false here.
    return namedURI.getResource().get('result');
});

//  ------------------------------------------------------------------------

TP.tibet.data.Inst.defineMethod('hasLocalData',
function() {

    /**
     * @method hasLocalData
     * @summary Does this element have local, not remote data. In particular,
     *     should it rely on child node content for example, over remote hrefs?
     * @returns {Boolean} Whether or not the receiver has local data.
     */

    var elem,
        childCDATASectionNodes;

    elem = this.getNativeNode();
    childCDATASectionNodes = TP.nodeGetChildNodesByType(
                                        elem, Node.CDATA_SECTION_NODE);

    return TP.notEmpty(childCDATASectionNodes);
});

//  ------------------------------------------------------------------------

TP.tibet.data.Inst.defineMethod('reset',
function() {

    /**
     * @method reset
     * @summary Resets the receiver to have the data structures and content as
     *     originally authored by the page author.
     * @returns {TP.tibet.data} The receiver.
     */

    var elem,
        namedHref,

        children,
        cdatas,

        resourceStr,

        buildout;

    elem = this.getNativeNode();

    //  If we're not empty, then we use our child content as our 'named'
    //  resource's content.
    if (TP.notEmpty(elem.childNodes)) {

        namedHref = this.getAttribute('name');
        if (!TP.isURI(TP.uc(namedHref))) {
            return this.raise('TP.sig.InvalidURI');
        }

        //  NOTE: logic here focuses on the native node since we want to
        //  manipulate native node objects here.

        //  Normalize the node to try to get the best representation.
        TP.nodeNormalize(elem);

        //  Get a result type for the data (either defined on the receiver
        //  element itself or from a supplied MIME type), construct an instance
        //  of that type and set it as the named URI's resource.

        //  If there is a CDATA section, then we grab it's text value...it's
        //  probably JSON data.
        cdatas = TP.nodeGetDescendantsByType(elem, Node.CDATA_SECTION_NODE);
        if (TP.notEmpty(cdatas)) {
            //  The string we'll use is from the first CDATA.
            resourceStr = TP.nodeGetTextContent(cdatas.first());
        } else {
            children = TP.nodeGetChildElements(elem);

            //  We rely on the first child element to be XML for usable data.
            if (TP.isXMLNode(children.first())) {
                if (children.getSize() > 1) {
                    return this.raise(
                            'TP.sig.InvalidNode',
                            'tibet:data elements do not support fragments.');
                }

                //  Stringify the XML for use in our upcoming setContent call.
                resourceStr = TP.str(children.first());
            }
        }

        if (TP.notEmpty(resourceStr)) {
            //  A bit strange to remove content into string form only to set it
            //  again, but the setContent step forces interpretation of the data
            //  into our URI, triggers the right change notifications etc.
            this.setContent(resourceStr);
        }
    } else {

        //  If we should make structures, then go ahead and set the content to
        //  'null'. Some content types, such as TP.core.XMLContent and
        //  TP.core.JSONContent, can handle null content objects handed to their
        //  initialization logic.
        buildout = TP.bc(this.getAttribute('buildout'));
        if (buildout) {
            this.setContent(null);
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.tibet.data.Inst.defineMethod('setAttrName',
function(aName) {

    /**
     * @method setAttrName
     * @summary Sets the 'name' value for the receiver. This will cause the
     *     receiver to reregister it's content under the new name URI.
     * @param {String} anHref The value to set the 'href' to.
     */

    var oldName,
        oldURI,

        resource,

        newURI;

    oldName = this.$getAttribute('name');

    //  NB: We assume 'async' of false here.
    if (!TP.isURI(oldURI = TP.uc(oldName))) {
        //  Raise an exception
        return this.raise('TP.sig.InvalidURI');
    }
    resource = oldURI.getResource().get('result');
    if (TP.canInvoke(resource, 'setData')) {
        resource.setData(null);
    }
    oldURI.unregister();

    //  NB: We assume 'async' of false here.
    if (!TP.isURI(newURI = TP.uc(aName))) {
        //  Raise an exception
        return this.raise('TP.sig.InvalidURI');
    }

    newURI.setResource(
        resource,
        TP.hc('observeResource', true, 'signalChange', true));

    this.$setAttribute('name', aName);

    //  setting an attribute returns void according to the spec
    return;
});

//  ------------------------------------------------------------------------

TP.tibet.data.Inst.defineMethod('setContent',
function(aContentObject, aRequest) {

    /**
     * @method setContent
     * @summary Sets the content of the receiver's native DOM counterpart to
     *     the value supplied.
     * @param {Object} aContentObject An object to use for content.
     * @param {TP.sig.Request} aRequest A request containing control parameters.
     *     For this method, the most notable parameter is 'shouldSignal'. If
     *     this is set to false (it defaults to true), then change signaling
     *     from the receiver will not occur.
     * @returns {null}
     */

    var namedHref,
        namedURI,

        req,
        shouldSignal,

        mimeType,
        contentType,

        newResource,
        strResource,

        isValid;

    this.callNextMethod();

    if (TP.notEmpty(namedHref = this.getAttribute('name'))) {
        if (!TP.isURI(namedURI = TP.uc(namedHref))) {
            //  Raise an exception
            return this.raise('TP.sig.InvalidURI');
        }
    } else {
        //  No 'name' attribute.
        return null;
    }

    req = TP.request(aRequest);
    shouldSignal = TP.notFalse(req.at('shouldSignal'));

    if (TP.isEmpty(mimeType = this.getAttribute('type'))) {
        mimeType = TP.ietf.mime.guessMIMEType(aContentObject);
    }

    //  If the MIME type that was computed is text/plain, then something
    //  probably went wrong (i.e. the data couldn't be parsed) and so we warn
    //  about that.
    if (TP.notNull(aContentObject) && mimeType === TP.PLAIN_TEXT_ENCODED) {
        TP.ifWarn() ?
            TP.warn('Computed a content type of text/plain for' +
                    ' <tibet:data/> with id: ' +
                    this.getAttribute('id') + '.') : 0;
    }

    //  Obtain a MIME type for the result and use it to obtain a result type.
    //  Note that there might not be either a 'type' or 'content' attribute
    //  on the receiver, in which case we'll just get a String result type here.
    contentType = this.getContentType(mimeType);

    //  If the new resource result is a content object of some sort (highly
    //  likely) then we should initialize it with both the content String and
    //  the URI that it should be associated with. The content object type will
    //  convert it from a String to the proper type.
    if (TP.isSubtypeOf(contentType, TP.core.Content)) {
        newResource = contentType.construct(aContentObject, namedURI);
        if (this.hasAttribute('buildout')) {
            newResource.set('buildout',
                            TP.bc(this.getAttribute('buildout')));
        }
    } else {
        strResource = TP.str(aContentObject);
        if (contentType === String) {
            newResource = strResource;
        } else {
            newResource = contentType.from(strResource);
        }
    }

    //  Make sure that it's valid for its container. Note that we pass 'false'
    //  as a second parameter here for content objects that do both trivial and
    //  full facet checks on their data. We only want trival checks here (i.e.
    //  is the XML inside of a TP.core.XMLContent really XML - same for JSON)
    isValid = contentType.validate(newResource, false);
    if (!isValid) {
        return this.raise('TP.sig.InvalidValue');
    }

    //  If the named URI has existing data, then we signal
    //  'TP.sig.UIDataDestruct'.
    //  NB: We assume 'async' of false here.
    if (shouldSignal && TP.notEmpty(namedURI.getResource().get('result'))) {
        this.signal('TP.sig.UIDataDestruct');

        //  Check and dispatch a signal from our attributes if one exists for
        //  this signal.
        this.dispatchResponderSignalFromAttr('UIDataDestruct', null);
    }

    //  Set the resource to the new resource (causing any observers of the URI
    //  to get notified of a change) and signal 'TP.sig.UIDataConstruct'.
    namedURI.setResource(
        newResource,
        TP.hc('observeResource', true, 'signalChange', true));

    if (shouldSignal) {
        this.signal('TP.sig.UIDataConstruct');

        //  Check and dispatch a signal from our attributes if one exists for
        //  this signal.
        this.dispatchResponderSignalFromAttr('UIDataConstruct', null);

        //  Dispatch 'TP.sig.DOMReady' for consistency with other elements that
        //  dispatch this when their 'dynamic content' is resolved. Note that we
        //  use 'dispatch()' here because this is a DOM signal and we want all
        //  of the characteristics of a DOM signal.
        this.dispatch('TP.sig.DOMReady');
    }

    return null;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/xmlns/TP.tibet.type.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tibet';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tibet.type}
 * @summary A custom tag that implements a way of describing a TIBET type
 */

//  ------------------------------------------------------------------------

TP.dom.NonNativeUIElementNode.defineSubtype('tibet:type');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  Tag Phase Support
//  ------------------------------------------------------------------------

TP.tibet.type.Type.defineMethod('tagAttachDOM',
function(aRequest) {

    /**
     * @method tagAttachDOM
     * @summary Sets up runtime machinery for the element in aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var elem,
        elemTPNode,

        supertypeName,
        supertype,
        typeName,

        forceDefinition,

        type,

        schema,
        schemaLocs,

        computeFacetSetting,

        aspectTPElems;

    //  this makes sure we maintain parent processing
    this.callNextMethod();

    //  Make sure that we have a node to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        //  TODO: Raise an exception
        return;
    }

    //  Get a handle to a TP.dom.Node representing an instance of this
    //  element type wrapped around elem. Note that this will both ensure a
    //  unique 'id' for the element and register it.
    elemTPNode = TP.tpnode(elem);

    if (TP.isEmpty(supertypeName = elemTPNode.getAttribute('base'))) {
        return this.raise(
                    'TP.sig.InvalidParameter',
                    'Couldn\'t find an attribute defining the base type');
    }

    if (!TP.isType(supertype = TP.sys.getTypeByName(supertypeName))) {
        return this.raise(
                    'TP.sig.InvalidType',
                    'Couldn\'t find the base type');
    }

    if (TP.isEmpty(typeName = elemTPNode.getAttribute('name'))) {
        return this.raise(
                    'TP.sig.InvalidParameter',
                    'Couldn\'t find an attribute defining the type');
    }

    //  If the tag has an attribute named 'redefine' that resolves to true, or
    //  we can't find a type matching the name given in the 'name' attribute,
    //  then we define our type here.
    forceDefinition = TP.bc(elemTPNode.getAttribute('redefine'));
    if (TP.isTrue(forceDefinition) ||
            !TP.isType(type = TP.sys.getTypeByName(typeName))) {
        type = supertype.defineSubtype(typeName);
    }

    //  Import any schemas required - they'll be a set of space-separated URLs
    if (TP.notEmpty(schema = elemTPNode.getAttribute('schema'))) {
        if (TP.notEmpty(schemaLocs = schema.split(' '))) {
            schemaLocs.perform(
                function(aSchemaLoc) {
                    var schemaURI,

                        fetchParams,

                        resp,
                        schemaObj;

                    schemaURI = TP.uc(aSchemaLoc);
                    fetchParams = TP.hc('async', false, 'resultType', TP.WRAP);

                    if (schemaURI.getExtension() === 'json') {
                        fetchParams.atPut(
                                    'resultType', TP.CONTENT,
                                    'contentType', TP.json.JSONSchemaContent);
                    }

                    resp = schemaURI.getResource(fetchParams);

                    if (TP.isValid(schemaObj = resp.get('result'))) {
                        if (TP.isKindOf(schemaObj, TP.dom.XMLDocumentNode)) {
                            schemaObj = schemaObj.getDocumentElement();
                        }
                    }

                    if (TP.canInvoke(schemaObj, 'defineTypes')) {
                        schemaObj.defineTypes();
                    }
                });
        }
    }

    //  Define a convenience Function that we use below to try to create the
    //  correct kind of Object to use as the facet setting.
    computeFacetSetting = function(facetSrc) {
        var facetVal;

        //  If the facet has an ACP variable statement, then we assume that the
        //  user has entered an expression for evaluation.
        if (TP.regex.ACP_VARIABLE_STATEMENT.test(facetSrc)) {

            //  The user might have needed to escape entities - we definitely
            //  want the literal values here.
            facetVal = TP.xmlEntitiesToLiterals(facetSrc);

            //  For convenience, we allow the user to use words like AND and OR
            //  instead of '&&' and '||' which might have to be escaped.
            facetVal = TP.replaceConvenienceOperators(facetVal);

            //  Generate binding syntax around found ACP variables. These are
            //  not really binding statements, but it's necessary when using the
            //  transformation function computation machinery below for it to
            //  think they are.
            facetVal = TP.generateBindingSyntaxAroundACPVariables(facetVal);

            //  Compute a transformation function. Note here how we pass true as
            //  the second argument because we want '$_' to be treated
            //  'specially' (i.e. as a computed expression and not as part of
            //  any overall path).
            facetVal = TP.dom.ElementNode.computeTransformationFunction(
                                                                facetVal, true);

            //  The Function object itself will be in the first position of the
            //  return value.
            facetVal = facetVal.first();
        } else if (/\s*(true|false)\s*/.test(facetSrc)) {
            facetVal = TP.bc(facetSrc);
        } else if (TP.regex.ONLY_NUM.test(facetSrc)) {
            facetVal = TP.nc(facetSrc);
        } else if (/\s*\[.+\]\s*/.test(facetSrc)) {
            facetVal = TP.tostr(facetSrc).split(',');
        } else if (TP.regex.JS_IDENTIFIER.test.facetSrc) {
            facetVal = facetSrc;
        } else {
            facetVal = TP.apc(facetSrc, TP.hc('shouldCollapse', true));
        }

        return facetVal;
    };

    //  Grab all of the members of this content, iterate over them and build up
    //  a set of aspect facet settings for the newly-defined type.
    if (TP.notEmpty(aspectTPElems = TP.byCSSPath('> tibet|aspect', elem))) {

        aspectTPElems.perform(
                function(aTPElem) {
                    var name,
                        descriptor,
                        val,
                        typeVal;

                    if (TP.isEmpty(name = aTPElem.getAttribute('name'))) {
                        return this.raise(
                                    'TP.sig.InvalidParameter',
                                    'Couldn\'t find an aspect name');
                    }

                    descriptor = {};

                    //  ---

                    //  'readonly'
                    if (TP.notEmpty(val = aTPElem.getAttribute('readonly'))) {
                        descriptor.readonly = computeFacetSetting(val);
                    }

                    //  ---

                    //  'relevant'
                    if (TP.notEmpty(val = aTPElem.getAttribute('relevant'))) {
                        descriptor.relevant = computeFacetSetting(val);
                    }

                    //  ---

                    //  'required'
                    if (TP.notEmpty(val = aTPElem.getAttribute('required'))) {
                        descriptor.required = computeFacetSetting(val);
                    }

                    //  ---

                    //  'valid'

                    //  If there's a 'valid' attribute, then we compute a facet
                    //  setting directly from it. Otherwise, we look for
                    //  sub-valid facet settings by looking for attributes.
                    if (TP.notEmpty(val = aTPElem.getAttribute('valid'))) {
                        descriptor.valid = computeFacetSetting(val);
                    } else {

                        descriptor.valid = {};

                        if (TP.notEmpty(
                                val = aTPElem.getAttribute('dataType'))) {
                            if (!TP.isType(
                                typeVal = TP.sys.getTypeByName(val))) {
                                return this.raise(
                                            'TP.sig.InvalidType',
                                            'Couldn\'t find the type: ' + val);
                            }
                            descriptor.valid.dataType = typeVal;
                        }

                        if (TP.notEmpty(val =
                                        aTPElem.getAttribute('enumeration'))) {
                            descriptor.valid.enumeration =
                                                computeFacetSetting(val);
                        }

                        if (TP.notEmpty(val =
                                        aTPElem.getAttribute('equal'))) {
                            descriptor.valid.equal = computeFacetSetting(val);
                        }

                        if (TP.notEmpty(
                                val =
                                    aTPElem.getAttribute('fractionDigits'))) {
                            descriptor.valid.fractionDigits =
                                                    computeFacetSetting(val);
                        }

                        if (TP.notEmpty(val =
                                        aTPElem.getAttribute('length'))) {
                            descriptor.valid.length = computeFacetSetting(val);
                        }

                        if (TP.notEmpty(val =
                                        aTPElem.getAttribute('maxExclusive'))) {
                            descriptor.valid.maxExclusive =
                                                    computeFacetSetting(val);
                        }

                        if (TP.notEmpty(val =
                                        aTPElem.getAttribute('maxInclusive'))) {
                            descriptor.valid.maxInclusive =
                                                    computeFacetSetting(val);
                        }

                        if (TP.notEmpty(val =
                                        aTPElem.getAttribute('maxLength'))) {
                            descriptor.valid.maxLength =
                                                    computeFacetSetting(val);
                        }

                        if (TP.notEmpty(val =
                                        aTPElem.getAttribute('maxValue'))) {
                            descriptor.valid.maxValue =
                                                    computeFacetSetting(val);
                        }

                        if (TP.notEmpty(val =
                                        aTPElem.getAttribute('minExclusive'))) {
                            descriptor.valid.minExclusive =
                                                    computeFacetSetting(val);
                        }

                        if (TP.notEmpty(val =
                                        aTPElem.getAttribute('minInclusive'))) {
                            descriptor.valid.minInclusive =
                                                    computeFacetSetting(val);
                        }

                        if (TP.notEmpty(val =
                                        aTPElem.getAttribute('minLength'))) {
                            descriptor.valid.minLength =
                                                    computeFacetSetting(val);
                        }

                        if (TP.notEmpty(val =
                                        aTPElem.getAttribute('minValue'))) {
                            descriptor.valid.minValue =
                                                    computeFacetSetting(val);
                        }

                        if (TP.notEmpty(val =
                                        aTPElem.getAttribute('notEqual'))) {
                            descriptor.valid.notEqual =
                                                    computeFacetSetting(val);
                        }

                        if (TP.notEmpty(val =
                                        aTPElem.getAttribute('pattern'))) {
                            if (TP.isString(descriptor.valid.pattern =
                                                    computeFacetSetting(val))) {
                                descriptor.valid.pattern =
                                        TP.rc(descriptor.valid.pattern);
                            }
                        }

                        if (TP.notEmpty(val =
                                        aTPElem.getAttribute('totalDigits'))) {
                            descriptor.valid.totalDigits =
                                                computeFacetSetting(val);
                        }
                    }

                    //  ---

                    //  'value' is treated specially by the 'defineAttribute'
                    //  call below.
                    if (TP.notEmpty(val = aTPElem.getAttribute('value'))) {
                        val = computeFacetSetting(val);
                    }

                    //  ---

                    //  Define the attribute on the type, using the descriptor
                    //  that we just built up.
                    type.Inst.defineAttribute(name, val, descriptor);
                }.bind(this));
    }

    return;
});

//  ========================================================================
//  TP.tibet.aspect
//  ========================================================================

/**
 * @type {TP.tibet.aspect}
 * @summary A subtype of TP.dom.ElementNode that implements a way of describing
 *     an 'aspect' of a 'content type', along with rules about it. It is defined
 *     so that development when the Sherpa is loaded does not cause an
 *     'autodefinition' of a missing tag.
 */

//  ------------------------------------------------------------------------

TP.dom.NonNativeUIElementNode.defineSubtype('tibet:aspect');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/xmlns/TP.tibet.service.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tibet';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tibet.service}
 * @summary A subtype of TP.dom.ElementNode that acts as an abstract supertype
 *     for tags that expose a remote service endpoint in markup.
 */

//  ------------------------------------------------------------------------

TP.dom.UIDataElement.defineSubtype('tibet.service');

//  can't construct concrete instances of this
TP.tibet.service.isAbstract(true);

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.tibet.service.Inst.defineAttribute('$value');
TP.tibet.service.Inst.defineAttribute('isActivated');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.tibet.service.Inst.defineMethod('activate',
function() {

    /**
     * @method activate
     * @summary This method causes the receiver to perform it's 'action'. In
     *     this case, retrieving or sending data to a remote URI endpoint.
     *     Subtypes need to override this method and provide an implementation
     *     of real code to activate.
     * @returns {TP.tibet.service} The receiver.
     */

    return TP.override();
});

//  ------------------------------------------------------------------------

TP.tibet.service.Inst.defineMethod('getValue',
function() {

    /**
     * @method getValue
     * @summary Returns the value of the receiver.
     * @returns {String} The value of the receiver.
     */

    return this.$get('$value');
});

//  ------------------------------------------------------------------------

TP.tibet.service.Inst.defineHandler('ValueChange',
function(aSignal) {

    /**
     * @method handleValueChange
     * @summary Handles notification of a change.
     * @description This is triggered if we're watching the remote resource
     *     referenced by our 'href'.
     * @param {TP.sig.Signal} aSignal The signal instance to respond to.
     * @returns {TP.tibet.service} The receiver.
     */

    var newContent;

    //  If the aspect isn't 'value', we're not interested.
    if (aSignal.at('aspect') !== 'value') {
        return this;
    }

    //  Grab the new value from the signal, copy it and use it to update the
    //  result URI. This will cause any data bindings that are using the result
    //  URI to update.
    newContent = aSignal.at(TP.NEWVAL);
    newContent = TP.copy(newContent);

    this.updateResultURI(newContent);

    return this;
});

//  ------------------------------------------------------------------------

TP.tibet.service.Inst.defineMethod('setValue',
function(aValue, shouldSignal) {

    /**
     * @method setValue
     * @summary Sets the value of the receiver's node. For this node type
     *     this method triggers this tag to activate, thereby fetching data from
     *     the service.
     * @param {Object} aValue The value to set the 'value' of the node to.
     * @param {Boolean} shouldSignal Should changes be notified. If false
     *     changes are not signaled. Defaults to this.shouldSignalChange().
     * @returns {Boolean} Whether or not the value was changed from the value it
     *     had before this method was called.
     */

    var elem,

        currentValue;

    elem = this.getNativeNode();

    //  If we're setting this value due to an update from the binding machinery
    //  and we have awakened, then check to see if any value that we might be
    //  bound to has changed. If so, then activate.
    if (TP.isTrue(TP.$$settingFromBindMachinery) && elem[TP.AWAKENED]) {
        currentValue = this.$get('$value');
        if (!TP.equal(currentValue, aValue)) {
            this.activate();
        }
    }

    this.$set('$value', aValue);

    //  This node type never broadcasts that it changes its 'value'.
    return false;
});

//  ------------------------------------------------------------------------

TP.tibet.service.Inst.defineMethod('updateResultURI',
function(aResult) {

    /**
     * @method updateResultURI
     * @summary Updates the result URI to the supplied object. This will cause
     *     any data-bound objects that are using the result URI to update
     * @param {Object} aResult The result object to set as the resource of the
     *     result URI.
     * @returns {TP.tibet.service} The receiver.
     */

    var href,
        resultURI,

        mimeType,
        contentType,

        isValid,

        newResource,
        strResource;

    //  See if a 'name' href is available and a URI can be created from it.
    if (TP.notEmpty(href = this.getAttribute('name'))) {
        if (!TP.isURI(resultURI = TP.uc(href))) {
            //  Raise an exception
            return this.raise('TP.sig.InvalidURI');
        }
    } else {
        //  We might have be 'send only' service tag.
        return this;
    }

    //  If the result URI's 'name' is already equal to what we're handing in,
    //  then exit here
    if (TP.equal(
            resultURI.getResource(TP.hc('refresh', false)).get('result'),
            aResult)) {
        return this;
    }

    //  If the result is a String, try to turn it into more
    if (TP.isString(aResult)) {

        //  Obtain a MIME type for the result and use it to obtain a
        //  result type.
        mimeType = TP.ietf.mime.guessMIMEType(aResult, this);

        contentType = this.getContentType(mimeType);

        //  If a result type couldn't be determined, then just use
        //  String.
        if (!TP.isType(contentType)) {
            contentType = String;
        }

        //  Make sure that it's valid for its container. Note that we
        //  pass 'false' as a second parameter here for content
        //  objects that do both trivial and full facet checks on
        //  their data. We only want trival checks here (i.e. is the
        //  XML inside of a TP.core.XMLContent really XML - same for
        //  JSON)
        isValid = contentType.validate(aResult, false);
        if (!isValid) {
            return this.raise('TP.sig.InvalidValue');
        }

        //  If the new resource result is a content object of some
        //  sort (highly likely) then we should initialize it with
        //  both the content String and the URI that it should be
        //  associated with. The content object type will convert it
        //  from a String to the proper type.
        if (TP.isSubtypeOf(contentType, TP.core.Content)) {
            newResource = contentType.construct(aResult, resultURI);
        } else {
            strResource = TP.str(aResult);
            if (contentType === String) {
                newResource = strResource;
            } else {
                newResource = contentType.from(strResource);
            }
        }
    } else if (TP.isNode(aResult)) {
        newResource = TP.wrap(aResult);
    } else {
        newResource = aResult;
    }

    //  Set the resource to the new resource (causing any observers
    //  of the URI to get notified of a change) and signal
    //  'TP.sig.UIDataConstruct'.
    resultURI.setResource(
        newResource,
        TP.hc('observeResource', true, 'signalChange', true));

    return this;
});

//  ------------------------------------------------------------------------
//  Action Event Handlers
//  ------------------------------------------------------------------------

TP.tibet.service.Inst.defineHandler('UIActivate',
function(aSignal) {

    /**
     * @method handleUIActivate
     * @summary Activates the receiver. For this type, that means interacting
     *     with the data store configured by its remote URL.
     * @param {TP.sig.UIActivate} aSignal The signal that caused this handler to
     *     trip.
     * @returns {TP.tibet.service} The receiver.
     */

    this.activate();

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/xmlns/TP.tibet.style.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tibet';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tibet.style}
 * @summary A subtype of TP.dom.ElementNode that implements the ability to have
 *      'non native' style content (such as LESS) embedded on a page.
 */

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.defineSubtype('tibet:style');

TP.tibet.style.Type.set('uriAttrs', TP.ac('href'));
TP.tibet.style.Type.set('reloadableUriAttrs', TP.ac('href'));

//  ------------------------------------------------------------------------
//  Tag Phase Support
//  ------------------------------------------------------------------------

TP.tibet.style.Type.defineMethod('tagAttachDOM',
function(aRequest) {

    /**
     * @method tagAttachDOM
     * @summary Sets up runtime machinery for the element in aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var elem,
        tpElem,

        href;

    //  this makes sure we maintain parent processing
    this.callNextMethod();

    //  Make sure that we have a node to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        return this.raise('TP.sig.InvalidNode');
    }

    tpElem = TP.wrap(elem);

    //  If we're not empty, then we reload from our child text content.
    if (!tpElem.isEmpty()) {

        tpElem.reloadFromContent();

    } else if (TP.notEmpty(href = TP.elementGetAttribute(elem, 'href', true))) {

        //  Otherwise, if our 'href' attribute isn't empty, then we reload from
        //  the content that can be found at the end of the URI contained there.
        tpElem.reloadFromAttrHref(href);

    } else {

        //  Raise an exception
        return this.raise('TP.sig.InvalidNode');
    }

    return;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.tibet.style.Inst.defineMethod('isReadyToRender',
function() {

    /**
     * @method isReadyToRender
     * @summary Whether or not the receiver is 'ready to render'. For this type,
     *     this always returns true.
     * @returns {Boolean} Whether or not the receiver is ready to render.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.tibet.style.Inst.defineMethod('reloadFromAttrHref',
function(anHref) {

    /**
     * @method reloadFromAttrHref
     * @summary Reloads the receiver with the content found at the end of the
     *     href.
     * @param {String} anHref The URL that the receiver will use to reload its
     *     content.
     * @returns {TP.tibet.style} The receiver.
     */

    var doc,

        generatedStyleID,
        ourID,

        newStyleElem,
        existingStyleElem,

        ext,
        hrefURI,
        hrefLocation,
        newHref,

        styleURI,
        fetchOptions,
        inlineStyleContent,
        inlinedStyleElem;

    if (TP.notEmpty(anHref)) {

        ext = TP.uriExtension(anHref);

        hrefURI = TP.uc(anHref);
        hrefLocation = hrefURI.getLocation();

        switch (ext) {

            default:

                doc = this.getNativeDocument();

                //  Get our local ID, assigning it if necessary.
                ourID = this.getLocalID(true);

                //  Compute an ID for our generated (real) CSS style sheet.
                generatedStyleID = ourID + '_generated';

                if (this.getAttribute('type') === TP.ietf.mime.TIBET_CSS) {

                    styleURI = TP.uc(hrefLocation);

                    //  Grab any existing inlined style element, if available.
                    //  Note that we make sure to go after only HTML style
                    //  elements here.
                    inlinedStyleElem = TP.byCSSPath(
                                            'html|style[tibet|originalhref=' +
                                            '"' +
                                            styleURI.getOriginalSource() +
                                            '"]',
                                        doc,
                                        true,
                                        false);

                    //  If the element existed, check to make sure that it
                    //  doesn't have a 'tibet:no-reload' attribute. If it does,
                    //  then exit here without reloading.
                    if (TP.isElement(inlinedStyleElem) &&
                        TP.elementHasAttribute(
                            inlinedStyleElem, 'tibet:no-reload', true)) {
                        return;
                    }

                    //  Note how we *don't* specify 'refresh' here, since we
                    //  want the latest content as set into the URL.
                    fetchOptions = TP.hc('async', false,
                                            'resultType', TP.TEXT,
                                            'signalChange', false);
                    inlineStyleContent =
                        styleURI.getResource(fetchOptions).get('result');

                    //  Set the content of an inlined XHTML style element that
                    //  contains the inlined style, resolving @import statements
                    //  and possible rewriting CSS url(...) values. Note that
                    //  this will generate a new style element if it has to.
                    inlinedStyleElem = TP.documentInlineCSSURIContent(
                                            doc,
                                            styleURI,
                                            inlineStyleContent,
                                            this.getNativeNode().nextSibling,
                                            true);

                    //  NB: We do *not* mark this element as having been
                    //  generated by TIBET because we want it itself to be
                    //  findable via TIBET's CSS query mechanism

                    //  Make sure also to set the style element's 'id'
                    //  attribute, so that the above 'uniquing' logic will work
                    //  for future occurrences of this element being processed
                    //  (which ensures that we don't add the same element more
                    //  than once).
                    TP.elementSetAttribute(inlinedStyleElem,
                                            'id',
                                            generatedStyleID,
                                            true);

                    //  Track the original source from the URI - this is what
                    //  the author originally typed and might be a virtual URI.
                    //  We'd like to track it here.
                    TP.elementSetAttribute(inlinedStyleElem,
                                            'tibet:originalhref',
                                            styleURI.getOriginalSource(),
                                            true);

                } else {

                    //  Grab any existing style element, if available.
                    existingStyleElem = TP.byCSSPath(
                                        '*[tibet|for="' + ourID + '"]',
                                        doc,
                                        true,
                                        false);

                    //  If the element existed, check to make sure that it
                    //  doesn't have a 'tibet:no-reload' attribute. If it does,
                    //  then exit here without reloading.
                    if (TP.isElement(existingStyleElem) &&
                        TP.elementHasAttribute(
                            existingStyleElem, 'tibet:no-reload', true)) {
                        return;
                    }

                    //  If there is no existing 'style' element, create one and
                    //  set its content.
                    if (!TP.isElement(existingStyleElem)) {
                        //  Just some CSS - link it in.
                        newStyleElem = TP.documentAddCSSLinkElement(
                                            doc,
                                            hrefLocation,
                                            this.getNativeNode().nextSibling);

                        //  Mark this element as having been generated by TIBET.
                        newStyleElem[TP.GENERATED] = true;

                        TP.elementSetAttribute(
                                newStyleElem, 'id', generatedStyleID, true);

                        //  Set an attribute on our newly created style element
                        //  that links it back to the source element.
                        TP.elementSetAttribute(newStyleElem,
                                                'tibet:for',
                                                ourID,
                                                true);

                        //  Track the original source from the URI - this is what
                        //  the author originally typed and might be a virtual
                        //  URI. We'd like to track it here.
                        TP.elementSetAttribute(inlinedStyleElem,
                                                'tibet:originalhref',
                                                hrefLocation,
                                                true);

                    } else {

                        //  Otherwise, just compute a new href from the old href
                        //  value that is guaranteed to be unique and set the
                        //  'href' property of the existing style element to it,
                        //  thereby guaranteeing a reload of the content.
                        newHref = TP.uriAddUniqueQuery(hrefLocation);

                        existingStyleElem.href = newHref;
                    }
                }
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.tibet.style.Inst.defineMethod('reloadFromContent',
function() {

    /**
     * @method reloadFromContent
     * @summary Reloads the receiver with the child text content found inside of
     *     the receiver.
     * @returns {null}
     */

    var resourceStr,

        doc,

        generatedStyleID,
        ourID,

        type,

        newStyleElem,
        existingStyleElem;

    doc = this.getNativeDocument();

    //  Get our local ID, assigning it if necessary.
    ourID = this.getLocalID(true);

    //  Compute an ID for our generated (real) CSS style sheet.
    generatedStyleID = ourID + '_generated';

    resourceStr = this.getTextContent();

    //  If there's a 'type' attribute, that should have the type of style
    //  that we're being asked to process.
    type = this.getAttribute('type');

    switch (type) {
        default:

            //  If there is no existing 'style' element, create one and set
            //  its content.
            if (!TP.isElement(
                    existingStyleElem =
                    TP.byCSSPath('*[tibet|for="' + ourID + '"]',
                                    doc,
                                    true,
                                    false))) {

                //  Just some CSS
                newStyleElem = TP.documentAddCSSStyleElement(
                                    doc,
                                    resourceStr,
                                    this.getNativeNode().nextSibling);

                TP.elementSetAttribute(
                        newStyleElem, 'id', generatedStyleID, true);

                //  Set an attribute on our newly created style element that
                //  links it back to the source element.
                TP.elementSetAttribute(newStyleElem, 'tibet:for', ourID, true);
            } else {
                //  Otherwise, just set the content of the existing one.
                TP.cssStyleElementSetContent(existingStyleElem, resourceStr);
            }
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.tibet.style.Inst.defineMethod('serializeCloseTag',
function(storageInfo) {

    /**
     * @method serializeCloseTag
     * @summary Serializes the closing tag for the receiver.
     * @description At this type level, this method, in conjunction with the
     *     'serializeOpenTag' method, will always produce the 'XML version' of
     *     an empty tag (i.e. '<foo/>' rather than '<foo></foo>').
     * @param {TP.core.Hash} storageInfo A hash containing various flags for and
     *     results of the serialization process. Notable keys include:
     *          'wantsXMLDeclaration': Whether or not the document node should
     *          include an 'XML declaration' at the start of it's serialization.
     *          The default is false.
     *          'result': The current serialization result as it's being built
     *          up.
     *          'store': The key under which the current serialization result
     *          will be stored.
     *          'stores': A hash of 1...n serialization results that were
     *          generated during the serialization process. Note that nested
     *          nodes might generated results that will go into different
     *          stores, and so they will all be stored here, each keyed by a
     *          unique key (which, by convention, will be the URI they should be
     *          saved to).
     * @returns {String} A serialization of the closing tag of the receiver.
     */

    var attrNode;

    attrNode = this.getNativeNode().attributes.type;
    if (TP.isAttributeNode(attrNode)) {
        //  If the 'type' attribute is 'TIBET_CSS', that means it was
        //  auto-populated and shouldn't be written.
        if (attrNode.value === TP.ietf.mime.TIBET_CSS) {
            return TP.CONTINUE;
        }
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.tibet.style.Inst.defineMethod('serializeOpenTag',
function(storageInfo) {

    /**
     * @method serializeOpenTag
     * @summary Serializes the opening tag for the receiver.
     * @description At this type level, this method performs a variety of
     *     transformations and filtering of various attributes. See the code
     *     below for more details. One notable transformation is that this
     *     method, in conjunction with the 'serializeCloseTag' method,  will
     *     always produce the 'XML version' of an empty tag (i.e. '<foo/>'
     *     rather than '<foo></foo>').
     * @param {TP.core.Hash} storageInfo A hash containing various flags for and
     *     results of the serialization process. Notable keys include:
     *          'wantsXMLDeclaration': Whether or not the document node should
     *          include an 'XML declaration' at the start of it's serialization.
     *          The default is false.
     *          'result': The current serialization result as it's being built
     *          up.
     *          'store': The key under which the current serialization result
     *          will be stored.
     *          'stores': A hash of 1...n serialization results that were
     *          generated during the serialization process. Note that nested
     *          nodes might generated results that will go into different
     *          stores, and so they will all be stored here, each keyed by a
     *          unique key (which, by convention, will be the URI they should be
     *          saved to).
     * @returns {String} A serialization of the opening tag of the receiver.
     */

    var attrNode;

    attrNode = this.getNativeNode().attributes.type;
    if (TP.isAttributeNode(attrNode)) {
        //  If the 'type' attribute is 'TIBET_CSS', that means it was
        //  auto-populated and shouldn't be written.
        if (attrNode.value === TP.ietf.mime.TIBET_CSS) {
            return TP.CONTINUE;
        }
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.tibet.style.Inst.defineMethod('setContent',
function(aContentObject, aRequest) {

    /**
     * @method setContent
     * @summary Sets the content of the receiver's native DOM counterpart to
     *     the value supplied.
     * @param {Object} aContentObject An object to use for content.
     * @param {TP.sig.Request} aRequest A request containing control parameters.
     * @returns {null}
     */

    this.callNextMethod();

    //  reload from the child text content found inside ourself.
    this.reloadFromContent();

    return null;
});

//  ------------------------------------------------------------------------

TP.tibet.style.Inst.defineMethod('setAttrHref',
function(anHref) {

    /**
     * @method setAttrHref
     * @summary Sets the href that the receiver will use to retrieve its
     *     content.
     * @param {String} anHref The URL that the receiver will use to fetch its
     *     content.
     */

    this.$setAttribute('href', anHref);

    //  reload from the content found at the href.
    this.reloadFromAttrHref(anHref);

    //  setting an attribute returns void according to the spec
    return;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/xmlns/TP.tibet.template.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tibet';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tibet.template}
 * @summary A subtype of TP.tag.CustomTag that knows how to define XML
 *     templates.
 */

//  ------------------------------------------------------------------------

TP.tag.CustomTag.defineSubtype('tibet:template');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  This tag has no associated CSS. Note how these properties are TYPE_LOCAL, by
//  design.
TP.tibet.template.defineAttribute('styleURI', TP.NO_RESULT);
TP.tibet.template.defineAttribute('themeURI', TP.NO_RESULT);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tibet.template.Type.defineMethod('populateCompilationAttrs',
function(aRequest, anElement) {

    /**
     * @method populateCompilationAttrs
     * @summary Populates attributes on the element that is produced by this
     *     type when it is processed.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     * @param {Element} anElement The element to populate the attributes onto.
     * @returns {TP.meta.tibet.template} The receiver.
     */

    //  Make sure that we have an element to work from.
    if (!TP.isElement(anElement)) {
        return null;
    }

    TP.elementSetAttribute(anElement, 'tibet:opaque', 'bind', true);

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/acl/TP.acl.XMLNS.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'acl';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {acl:}
 * @summary A simple namespace for managing user interface access control in a
 *     way that is easy for authors to manage.
 * @summary A common issue in web UI is to enable/disable, show/hide, or
 *     otherwise modify the UI based on current user and data values.
 *
 *     TIBET's TP.core.User type maintains two user identities, a "real" user
 *     and an "effective" user. The real user is typically the user instance
 *     associated with the server session (when there is a server :)) while the
 *     effective user is the user currently being used for "less privileged"
 *     areas of the user interface. This separation is most clearly seen in
 *     applications where an administrator may be operating on behalf of another
 *     user.
 *
 *     The permission keys associated with each of these users by virtue of
 *     their associated vcard data is automatically populated on all open window
 *     body elements by TIBET. In particular, the body element will contain an
 *     acl:real and acl:effective attribute which contain the current real and
 *     effective keys.
 *
 *     By creating CSS rules based on these strings you can manage a number of
 *     the common UI alterations without the need for code. For example
 *     combining the following element and CSS rules results in a div that is
 *     visible when the real user has ABC permission (presumably it's hidden
 *     otherwise):
 *
 *     <div xctrls:hidden="true" acl:if_real="ABC"/>
 *
 *     *[xctrls|hidden="true"] { display: none; }
 *
 *     body[acl|real~="ABC"] *[acl|if_real~="ABC"] { display: block; }
 *
 *     Common attributes for acl control are:
 *
 *     acl:if_real acl:if_effective acl:unless_real acl:unless_effective
 *
 *     These four attributes, combined with the body's acl:real and
 *     acl:effective values, allow you to create CSS rules that can selectively
 *     be applied to the various inclusion or exclusion rules you wish to apply
 *     based on real or effective user keys.
 *
 *     Most ACL rules leverage the ~= (contains) attribute selector so they can
 *     be leveraged against multiple key string values.
 *
 *     Note that you can combine these rules and standard CSS declarations to
 *     accomplish most tasks. When you need to do a little more custom
 *     processing you can leverage one or more -tibet* CSS declarations. These
 *     declarations provide you with a CSS-authored way of invoking more
 *     powerful operations when a particular CSS rule matches.
 */

//  ------------------------------------------------------------------------

TP.core.XMLNamespace.defineSubtype('acl.XMLNS');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/acl/TP.acl.info.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'acl';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {acl:info}
 * @summary A wrapper element for access control list (acl) information.
 */

//  ------------------------------------------------------------------------

TP.tag.InfoTag.defineSubtype('acl:info');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/bind/TP.bind.XMLNS.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'bind';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {bind:}
 * @summary This type represents the TIBET bind namespace
 *     (http://www.technicalpursuit.com/2005/binding) in the tag processing
 *     system.
 */

//  ------------------------------------------------------------------------

TP.core.XMLNamespace.defineSubtype('bind.XMLNS');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.bind.XMLNS.Type.defineMethod('$gatherReferencedLocations',
function(anElement) {

    /**
     * @method $gatherReferencedLocations
     * @param {Element} anElement The element under which to gather referenced
     *     locations.
     * @returns {String[]} An Array of referenced locations.
     */

    var query,
        boundElements,

        uriLocs,

        infoCacheDict,

        i,


        attrs,
        j,

        attrVal,

        bindEntries,
        entriesKeys,
        k,

        dataExprs,
        l,

        location;

    //  Query for any attributes named 'io', 'in', 'scope' or 'repeat', no
    //  matter what namespace they're in. Note that this is about as
    //  sophisticated as we can get with namespaces using the querySelectorAll()
    //  call in most browsers. It is extremely fast, which is why we use it and
    //  then filter more later, but it's query capabilities around namespaces is
    //  quite pathetic.
    query = '*[*|io], *[*|in], *[*|scope], *[*|repeat]';

    boundElements = TP.ac(anElement.querySelectorAll(query));

    //  Additionally, if the supplied Element itself matches that query (tested
    //  by either '.matches' or '.matchesSelector', depending on platform...),
    //  then unshift it onto the result.
    if (anElement.matches && anElement.matches(query)) {
        boundElements.unshift(anElement);
    } else if (anElement.matchesSelector && anElement.matchesSelector(query)) {
        boundElements.unshift(anElement);
    }

    uriLocs = TP.ac();

    //  Since computing binding information is compute intensive, we keep a
    //  local cache of binding information for a particular attribute value
    //  (since the binding information is itself completely described by the
    //  content of the attribute).
    infoCacheDict = TP.hc();

    //  Iterate over all of the bound Elements
    for (i = 0; i < boundElements.length; i++) {

        //  Iterate over each of the bound Attribute nodes on that bound
        //  Element.
        attrs = boundElements[i].attributes;
        for (j = 0; j < attrs.length; j++) {

            //  Make sure the attribute namespace is the binding namespace. The
            //  CSS query above can't do that... sigh.
            if (attrs[j].namespaceURI === TP.w3.Xmlns.BIND) {

                attrVal = attrs[j].value;

                //  If we detect a 'binding attribute' value, then it's a
                //  'bind:io' or 'bind:in' attribute. Extract the binding
                //  information.
                if (TP.regex.BINDING_ATTR_VALUE_DETECT.test(attrVal)) {

                    //  If it's not in our local caching dictionary, then
                    //  compute it.
                    if (TP.notValid(bindEntries = infoCacheDict.at(attrVal))) {

                        bindEntries = TP.dom.ElementNode.computeBindingInfo(
                                                    boundElements[i], attrVal);
                        infoCacheDict.atPut(attrVal, bindEntries);

                        //  There can be 1...n 'entries' in a particular
                        //  Attribute's binding expression.
                        entriesKeys = bindEntries.getKeys();

                        //  Iterate over all of entries that we would've found
                        //  in our binding expression and grab the 'data'
                        //  expression.
                        for (k = 0; k < entriesKeys.getSize(); k++) {
                            dataExprs = bindEntries.at(entriesKeys.at(k)).
                                                            at('dataExprs');

                            //  Iterate over each data expression and, if it is
                            //  either a URI or a barename expression (used for
                            //  direct GUI-to-GUI binding), grab it's value.
                            for (l = 0; l < dataExprs.getSize(); l++) {

                                location = dataExprs.at(l);

                                //  If this is a URI String or is a barename
                                //  (used for direct GUI-to-GUI binding), then
                                //  it's one we're interested in. Note here that
                                //  we pass true to make matching a scheme
                                //  optional.
                                if (TP.isURIString(location, true) ||
                                    TP.regex.BARENAME.test(location)) {
                                    uriLocs.push(location);
                                }
                            }
                        }
                    }
                } else if (TP.isURIString(attrVal) ||
                            TP.regex.BARENAME.test(attrVal)) {
                    //  Otherwise, it's a 'bind:scope' or 'bind:repeat', which
                    //  can we extract the URI information directly.
                    location = attrVal;
                    uriLocs.push(location);
                }
            }
        }
    }

    return uriLocs;
});

//  ------------------------------------------------------------------------

TP.bind.XMLNS.Type.defineMethod('setup',
function(anElement) {

    /**
     * @method setup
     * @param {Element} anElement The element to set up.
     * @returns {null}
     */

    var doc,

        boundTextNodes,

        repeatElems,

        repeatTPElems,
        len,
        i,
        repeatTPElem;

    doc = TP.nodeGetDocument(anElement);

    //  Convert any text nodes containing '[[...]]' to span elements with
    //  'bind:in' attributes

    //  Grab any Text nodes under the supplied Element that have standalone
    //  binding expressions.
    boundTextNodes = TP.wrap(anElement).getTextNodesMatching(
            function(aTextNode) {

                var textContent;

                textContent = aTextNode.textContent;

                //  Note here that we not only check to see if the text content
                //  has double-bracket binding statements, but also to make sure
                //  that it's not a JSON String - we don't want to turn whole
                //  chunks of JSON data into the value of the 'bind:in'
                if (TP.regex.BINDING_STATEMENT_DETECT.test(textContent) &&
                    !TP.isJSONString(textContent)) {
                    return true;
                }

                return false;
            });

    //  Iterate over them, converting them into XHTML <span>s with 'bind:in'
    //  binding attributes.
    boundTextNodes.forEach(
        function(aTextNode) {

            var nextNode,

                tnStr,
                index,
                exprNode,
                newSpan;

            //  Start off with the supplied text node.
            nextNode = aTextNode;

            //  While we have a valid 'next node', keep looping.
            while (TP.isTextNode(nextNode)) {

                //  Grab the text node's text content and compute the index to
                //  the starting '[['
                tnStr = TP.nodeGetTextContent(nextNode);
                index = tnStr.indexOf('[[');

                //  If we can't find any more '[[', then break out.
                if (index === TP.NOT_FOUND) {
                    break;
                }

                //  Use the DOM to split the text node at that boundary. This
                //  creates a text node with the expression content *after* the
                //  index and appends it as 'node's nextSibling into the DOM.
                exprNode = nextNode.splitText(index);

                //  Grab that text node's content and compute the index to the
                //  ']]' (plus 2 - we want to leave the expression end delimiter
                //  in exprNode)
                tnStr = TP.nodeGetTextContent(exprNode);
                index = tnStr.indexOf(']]') + 2;

                //  This creates another text node to the right with whatever
                //  text was there and appends it as 'exprNode's nextSibling
                //  into the DOM. We grab that and will use it as the 'next
                //  node' for the next iteration of this loop.
                nextNode = exprNode.splitText(index);

                //  Get the text of exprNode, which will now be the '[[...]]'
                //  expression.
                tnStr = TP.nodeGetTextContent(exprNode);

                //  Trim off the surrounding whitespace
                tnStr = TP.trim(tnStr);

                //  If the expression doesn't contain ACP variables or
                //  formatting expressions, then we can trim off the '[[' and
                //  ']]' and it doesn't need quoting.
                if (!TP.regex.ACP_PATH_CONTAINS_VARIABLES.test(tnStr) &&
                    !TP.regex.ACP_FORMAT.test(tnStr)) {
                    //  Trim off whitespace
                    tnStr = TP.trim(tnStr);

                    //  Slice off the leading and trailing '[[' and ']]'
                    tnStr = tnStr.slice(2, -2);
                } else {
                    tnStr = tnStr.quoted('\'');
                }

                //  Create a new span and set a 'bind:in' attribute on it,
                //  binding it's 'content' property using the expression given
                //  (minus the leading and trailing brackets).
                newSpan = TP.documentConstructElement(
                                        doc, 'span', TP.w3.Xmlns.XHTML);

                //  Construct a 'bind:in' attribute for this, binding it to the
                //  'value' aspect.
                TP.elementSetAttribute(newSpan,
                                        'bind:in',
                                        '{value: ' + tnStr + '}',
                                        true);

                //  Mark this Element as 'scalar valued' for it's 'value'
                //  aspect, meaning that it will try to convert any bound
                //  'value' value that it is being updated to to a singular,
                //  scalar value if possible.
                TP.elementSetAttribute(newSpan,
                                        'tibet:scalar',
                                        'value',
                                        true);

                TP.elementSetAttribute(newSpan,
                                        'tibet:textbinding',
                                        'true',
                                        true);

                //  Replace that text node with the span, leaving the text nodes
                //  to the left (the original) and to the right (created by the
                //  2nd 'splitText' above).
                newSpan = TP.nodeReplaceChild(aTextNode.parentNode,
                                                newSpan,
                                                exprNode,
                                                false);

                //  Loop, processing whatever we have in nextNode
            }
        });

    //  Cause any repeats that haven't registered their content to grab it
    //  before we start other processing.
    repeatElems = TP.ac(doc.documentElement.querySelectorAll('*[*|repeat]'));
    repeatElems = repeatElems.filter(
                    function(anElem) {
                        return anElement.contains(anElem);
                    });

    //  IMPORTANT: To avoid mutation events as register the repeat content will
    //  cause DOM modifications, we wrap all of the found 'bind:repeat' Elements
    //  at once here.
    repeatTPElems = TP.wrap(repeatElems);

    //  Iterate over all of the found repeat elements and tell them to register
    //  their repeat content. This is done here to avoid (lots of) problems with
    //  dynamic shuffling of Elements under a repeat during render time.
    len = repeatTPElems.getSize();
    for (i = 0; i < len; i++) {
        repeatTPElem = repeatTPElems.at(i);
        repeatTPElem.$registerRepeatContent();
    }

    this.refreshReferencedLocations(anElement);

    return;
});

//  ------------------------------------------------------------------------

TP.bind.XMLNS.Type.defineMethod('refreshReferencedLocations',
function(anElement) {

    /**
     * @method refreshReferencedLocations
     * @param {Element} anElement The element to obtain the document whose
     *     referenced locations we're refreshing.
     * @returns {null}
     */

    var doc,
        tpDoc,

        originalLocationInfos,

        observedLocations,

        uriLocs;

    //  Make sure that the owner TP.dom.Document has an '$observedLocations'
    //  hash. This hash will consist of the location and a counter matching the
    //  number of times this primary URI is encountered in the content. This
    //  counter is used as Elements come and go (see the 'teardown' method
    //  below) and when the count is 0, the TP.dom.Document ignores that
    //  location.

    doc = TP.nodeGetDocument(anElement);

    tpDoc = TP.wrap(doc);

    observedLocations = tpDoc.get('$observedLocations');
    if (TP.notValid(observedLocations)) {
        observedLocations = TP.hc();
        tpDoc.set('$observedLocations', observedLocations);
    }

    //  Gather up the 'original locations' to compute a binding attribute
    //  matcher. This will be an Array of pairs, with the original location in
    //  the first position and the fully expanded location in the last position.
    originalLocationInfos = tpDoc.get('$originalLocationInfos');
    if (TP.notValid(originalLocationInfos)) {
        originalLocationInfos = TP.ac();
        tpDoc.set('$originalLocationInfos', originalLocationInfos);
    }

    //  Gather any locations that are referenced in binding expressions under
    //  the supplied Element. These are the locations that the owner
    //  TP.dom.Document of the supplied Element will observe for FacetChange.
    uriLocs = this.$gatherReferencedLocations(anElement);

    //  Iterate over the gathered locations and register them with the
    //  'observedLocations' hash. Note that the first time a particular location
    //  is encountered, the TP.dom.Document is told to observe it.
    uriLocs.forEach(
        function(aLocation) {
            var originalLocation,

                location,

                concreteURI,
                concreteLoc,

                resultObj,

                uriCount;

            //  Capture the original location before we modify it. We'll use
            //  this later to compute a matcher used by the binding system to
            //  find attributes with those URI values.
            originalLocation = aLocation;

            //  Grab the location. If it's a barename (i.e. starting with '#'
            //  and followed by 1-n word characters), then that's a sugar for a
            //  direct GUI-to-GUI binding. We desugar these by prepending them
            //  with 'tibet://uicanvas', making them into 'TIBET URLs'.
            location = aLocation;
            if (TP.regex.BARENAME.test(location)) {
                location = 'tibet://uicanvas' + location;
            }

            //  Get the concrete URI. For TIBET URLs, this produces a real URL,
            //  resolved to the name of the current ui canvas, that can be
            //  observed by the Document for changes. For other kinds of URIs,
            //  this usually returns the URI itself.
            concreteURI = TP.uc(location).getConcreteURI();

            if (TP.isValid(concreteURI)) {
                //  If we have a TIBET URL, then check to see if its canvas
                //  (i.e. Window) is the same as the current UI canvas Window.
                //  If it is, configure the GUI control to signal change when
                //  its GUI value changes.
                if (TP.isKindOf(concreteURI, TP.uri.TIBETURL)) {

                    if (concreteURI.getCanvas() === TP.sys.uiwin(true)) {

                        if (TP.isValid(resultObj =
                                concreteURI.getResource(
                                    TP.hc('resultType', TP.WRAP)).
                                                        get('result'))) {

                            //  If the binding expression was to an Attribute
                            //  node, then we want to grab the Attribute's owner
                            //  element.
                            if (TP.isKindOf(resultObj, TP.dom.AttributeNode)) {
                                resultObj = resultObj.getOwnerElement();
                            }

                            //  Because it's a TIBET *URL* (not *URN*), we
                            //  assume that it's pointing to another GUI control
                            //  in the same page, and that we're doing a
                            //  GUI-to-GUI binding, so we configure it to signal
                            //  changes.
                            resultObj.shouldSignalChange(true);
                        }
                    }
                } else {
                    //  If this isn't a TIBET URL, just grab it's primary URI.
                    concreteURI = concreteURI.getPrimaryURI();
                }

                concreteLoc = concreteURI.getLocation();
            } else {
                concreteLoc = location;
            }

            //  If we already saw this location, then we increment the counter.
            if (observedLocations.containsKey(concreteLoc)) {
                uriCount = observedLocations.at(concreteLoc);

                uriCount++;

                //  place the new value.
                observedLocations.atPut(concreteLoc, uriCount);
            } else {

                //  Initialize the counter for this primary URI and tell our
                //  TP.dom.Document to observe it for FacetChange.
                observedLocations.atPut(concreteLoc, 1);
                tpDoc.observe(TP.uc(concreteLoc), 'FacetChange');

                //  Push a pair that contains the original location and the
                //  computed, concrete location.
                originalLocationInfos.push(
                    TP.ac(originalLocation, concreteLoc));
            }
        });

    //  Unique this Array to avoid multiple entries of the same information.
    //  This will be used during binding refresh to generate matching RegExps
    //  and we don't want to make them needlessly complex.
    originalLocationInfos.unique();

    return;
});

//  ------------------------------------------------------------------------

TP.bind.XMLNS.Type.defineMethod('teardown',
function(anElement) {

    /**
     * @method teardown
     * @param {Element} anElement The element to tear down.
     * @returns {null}
     */

    var doc,
        tpDoc,

        uriLocs,
        observedLocations;

    doc = TP.nodeGetDocument(anElement);
    tpDoc = TP.wrap(doc);

    //  If the TP.dom.Document has no '$observedLocations', then just exit here.
    if (TP.notValid(observedLocations = tpDoc.get('$observedLocations'))) {
        return;
    }

    //  Gather any URIs that are referenced in binding expressions under the
    //  supplied Element. The primary URIs of these URIs will be the URIs that
    //  the owner TP.dom.Document of the supplied Element could ignore for
    //  FacetChange (if by detecting it, we decrement the count to 0).
    uriLocs = this.$gatherReferencedLocations(anElement);

    uriLocs.forEach(
        function(aLocation) {
            var location,

                concreteURI,
                concreteLoc,

                uriCount;

            //  Grab the location. If it's a barename (i.e. starting with '#'
            //  and followed by 1-n word characters), then that's a sugar for a
            //  direct GUI-to-GUI binding. We desugar these by prepending them
            //  with 'tibet://uicanvas', making them into 'TIBET URLs'.
            location = aLocation;
            if (TP.regex.BARENAME.test(location)) {
                location = 'tibet://uicanvas' + location;
            }

            //  Get the concrete URI. For TIBET URLs, this produces a real URL,
            //  resolved to the name of the current ui canvas, that can be
            //  observed by the Document for changes. For other kinds of URIs,
            //  this usually returns the URI itself.
            concreteURI = TP.uc(aLocation).getConcreteURI();

            if (TP.isValid(concreteURI)) {
                //  If this isn't a TIBET URL, just grab it's primary URI. This
                //  matches the behavior in the setup.
                if (!TP.isKindOf(concreteURI, TP.uri.TIBETURL)) {
                    concreteURI = concreteURI.getPrimaryURI();
                }

                concreteLoc = concreteURI.getLocation();
            } else {
                concreteLoc = location;
            }

            //  If we already saw this location, then we decrement the counter.
            if (observedLocations.containsKey(concreteLoc)) {
                uriCount = observedLocations.at(concreteLoc);

                uriCount--;

                //  If the counter is 0, then tell our TP.dom.Document to
                //  ignore that location for FacetChange and remove that key.
                if (uriCount === 0) {
                    tpDoc.ignore(TP.uc(concreteLoc), 'FacetChange');
                    observedLocations.removeKey(concreteLoc);
                } else {
                    //  Otherwise, just place the new value.
                    observedLocations.atPut(concreteLoc, uriCount);
                }
            }
        });

    return;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/bind/TP.bind.adaptor.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'bind';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.bind.adaptor}
 * @summary A subtype of TP.dom.ElementNode that implements a markup-based way
 *     of defining an aspect of a data model that will be derive its data from
 *     data bindings. Note that these can include data expressions.
 */

//  ------------------------------------------------------------------------

TP.dom.ElementNode.defineSubtype('bind:adaptor');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  Tag Phase Support
//  ------------------------------------------------------------------------

TP.bind.adaptor.Type.defineMethod('tagAttachDOM',
function(aRequest) {

    /**
     * @method tagAttachDOM
     * @summary Sets up runtime machinery for the element in aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var elem,
        elemTPNode,

        targetPath,
        fullPath,

        fullURI,
        primaryURI;

    //  this makes sure we maintain parent processing
    this.callNextMethod();

    //  Make sure that we have a node to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        //  TODO: Raise an exception
        return;
    }

    //  Get a handle to a TP.dom.Node representing an instance of this
    //  element type wrapped around elem. Note that this will both ensure a
    //  unique 'id' for the element and register it.
    elemTPNode = TP.tpnode(elem);

    //  Grab the target path. Note that this may not exist and the method for
    //  computing the full binding path below can handle that.
    targetPath = elemTPNode.getAttribute('target');

    //  Grab the full binding path from the element.
    fullPath = elemTPNode.getFullBindingPathFrom(targetPath);

    //  Create a URI from the full path and grab it's primary URI.
    fullURI = TP.uc(fullPath);
    primaryURI = fullURI.getPrimaryURI();

    elemTPNode.observe(primaryURI, 'TP.sig.ValueChange');

    return;
});

//  ------------------------------------------------------------------------

TP.bind.adaptor.Type.defineMethod('tagDetachDOM',
function(aRequest) {

    /**
     * @method tagDetachDOM
     * @summary Tears down runtime machinery for the element in aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var elem,
        elemTPNode,

        targetPath,
        fullPath,

        fullURI,
        primaryURI;

    //  Make sure that we have a node to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        //  TODO: Raise an exception
        return;
    }

    //  Get a handle to a TP.dom.Node representing an instance of this
    //  element type wrapped around elem. Note that this will both ensure a
    //  unique 'id' for the element and register it.
    elemTPNode = TP.tpnode(elem);

    //  Grab the target path. Note that this may not exist and the method for
    //  computing the full binding path below can handle that.
    targetPath = elemTPNode.getAttribute('target');

    //  Grab the full binding path from the element.
    fullPath = elemTPNode.getFullBindingPathFrom(targetPath);

    //  Create a URI from the full path and grab it's primary URI.
    fullURI = TP.uc(fullPath);
    primaryURI = fullURI.getPrimaryURI();

    elemTPNode.ignore(primaryURI, 'TP.sig.ValueChange');

    return;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.bind.adaptor.Inst.defineAttribute('$targetLocation');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.bind.adaptor.Inst.defineHandler('ValueChange',
function(aSignal) {

    /**
     * @method handleValueChange
     * @summary Handles when one of the aspects of the URI that the receiver is
     *     bound to changes.
     * @param {TP.sig.ValueChange} aSignal The signal that caused this handler
     *     to trip.
     * @returns {TP.bind.adaptor} The receiver.
     */

    if (aSignal.at('aspect') === 'value') {
        this.installAccessorsOnResource(
                    aSignal.at(TP.NEWVAL),
                    aSignal.getOrigin());
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.bind.adaptor.Inst.defineMethod('installAccessorsOnResource',
function(aResource, aBoundURI) {

    /**
     * @method installAccessorsOnResource
     * @summary Installs specific 'get' and 'set' accessors on the supplied
     *     resource.
     * @param {Object} aResource The resource to install accessors on.
     * @param {TP.uri.URI} aBoundURI The URI that the resource is registered
     *     under.
     * @returns {TP.bind.adaptor} The receiver.
     */

    var primaryURI,

        name,
        targetPath,

        pathObj;

    //  Capture the location of the primary URI of the bound URI. We'll use this
    //  to obtain the resource in the various change notification methods.
    primaryURI = aBoundURI.getPrimaryURI();
    this.$set('$targetLocation', primaryURI.getLocation(), false);

    name = this.getAttribute('name');

    //  See if we have a target path for 'setting' the resultant value into the
    //  data model.
    targetPath = this.getAttribute('target');
    if (TP.notEmpty(targetPath)) {
        //  We had a valid path. Compute a path object for use in the getter
        //  and setter.
        pathObj = TP.apc(this.getFullBindingPathFrom(targetPath));
    } else {
        //  Otherwise, just define an attribute slot on the resource.
        aResource.defineAttribute(name);
    }

    //  Install the getter and setter

    aResource.defineMethod(
        'get' + name.asTitleCase(),
        function() {

            //  If there was no valid destination path, then just use '$get()'
            //  to get the slot value. Note that we can't use 'get()' here or
            //  we'll endlessly recurse.
            if (TP.notValid(pathObj)) {
                return this.$get(name);
            }

            return this.get(pathObj);
        });

    aResource.defineMethod(
        'set' + name.asTitleCase(),
        function(aValue) {
            var oldValue;

            //  If there was no valid destination path, then just use '$get()'
            //  to get the slot value. Note that we can't use 'get()' here or
            //  we'll endlessly recurse.
            if (TP.notValid(pathObj)) {
                oldValue = this.$get(name);
            } else {
                oldValue = this.get(pathObj);
            }

            //  If the values are equal, there's nothing to do here - bail out.
            if (TP.equal(TP.str(oldValue), TP.str(aValue))) {
                return false;
            }

            //  If there was no valid destination path, then just use '$set()'
            //  to set the slot value. Note that we can't use 'set()' here or
            //  we'll endlessly recurse.
            if (TP.notValid(pathObj)) {
                this.$set(name, aValue);
            } else {
                this.set(pathObj, aValue);
            }

            return true;
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.bind.adaptor.Inst.defineMethod('setReadonly',
function(aValue, shouldSignal) {

    /**
     * @method setReadonly
     * @summary Sets the readonly facet of the receiver.
     * @description Because the receiver is acting as an adaptor to an aspect on
     *     the data model, setting the readonly 'facet' of the receiver.actually
     *     sets the readonly facet of the aspect on the model.
     * @param {Object} aValue The value to set the 'readonly' facet of the
     *     aspect of the data model that we're adapting to.
     * @param {Boolean} shouldSignal Should changes be notified. If false
     *     changes are not signaled.
     * @returns {Boolean} Whether or not the readonly facet was changed from the
     *     value it had before this method was called.
     */

    var targetLoc,
        targetURI,

        targetResource,

        aspectName,

        retVal;

    targetLoc = this.get('$targetLocation');
    targetURI = TP.uc(targetLoc);

    targetResource = targetURI.getResource().get('result');

    aspectName = this.getAttribute('name');

    retVal = targetResource.setFacet(
                    aspectName, 'readonly', aValue, shouldSignal);

    return retVal;
});

//  ------------------------------------------------------------------------

TP.bind.adaptor.Inst.defineMethod('setRelevant',
function(aValue, shouldSignal) {

    /**
     * @method setRelevant
     * @summary Sets the relevant facet of the receiver.
     * @description Because the receiver is acting as an adaptor to an aspect on
     *     the data model, setting the relevant 'facet' of the receiver.actually
     *     sets the relevant facet of the aspect on the model.
     * @param {Object} aValue The value to set the 'relevant' facet of the
     *     aspect of the data model that we're adapting to.
     * @param {Boolean} shouldSignal Should changes be notified. If false
     *     changes are not signaled.
     * @returns {Boolean} Whether or not the relevant facet was changed from the
     *     value it had before this method was called.
     */

    var targetLoc,
        targetURI,

        targetResource,

        aspectName,

        retVal;

    targetLoc = this.get('$targetLocation');
    targetURI = TP.uc(targetLoc);

    targetResource = targetURI.getResource().get('result');

    aspectName = this.getAttribute('name');

    retVal = targetResource.setFacet(
                    aspectName, 'relevant', aValue, shouldSignal);

    return retVal;
});

//  ------------------------------------------------------------------------

TP.bind.adaptor.Inst.defineMethod('setRequired',
function(aValue, shouldSignal) {

    /**
     * @method setRequired
     * @summary Sets the required facet of the receiver.
     * @description Because the receiver is acting as an adaptor to an aspect on
     *     the data model, setting the required 'facet' of the receiver.actually
     *     sets the required facet of the aspect on the model.
     * @param {Object} aValue The value to set the 'required' facet of the
     *     aspect of the data model that we're adapting to.
     * @param {Boolean} shouldSignal Should changes be notified. If false
     *     changes are not signaled.
     * @returns {Boolean} Whether or not the required facet was changed from the
     *     value it had before this method was called.
     */

    var targetLoc,
        targetURI,

        targetResource,

        aspectName,

        retVal;

    targetLoc = this.get('$targetLocation');
    targetURI = TP.uc(targetLoc);

    targetResource = targetURI.getResource().get('result');

    aspectName = this.getAttribute('name');

    retVal = targetResource.setFacet(
                    aspectName, 'required', aValue, shouldSignal);

    return retVal;
});

//  ------------------------------------------------------------------------

TP.bind.adaptor.Inst.defineMethod('setValue',
function(aValue, shouldSignal) {

    /**
     * @method setValue
     * @summary Sets the value facet of the receiver.
     * @description Because the receiver is acting as an adaptor to an aspect on
     *     the data model, setting the value 'facet' of the receiver.actually
     *     sets the value facet of the aspect on the model.
     * @param {Object} aValue The value to set the 'value' facet of the
     *     aspect of the data model that we're adapting to.
     * @param {Boolean} shouldSignal Should changes be notified. If false
     *     changes are not signaled.
     * @returns {Boolean} Whether or not the value facet was changed from the
     *     value it had before this method was called.
     */

    var targetLoc,
        targetURI,

        targetResource,

        aspectName,

        retVal;

    targetLoc = this.get('$targetLocation');
    targetURI = TP.uc(targetLoc);

    targetResource = targetURI.getResource().get('result');

    aspectName = this.getAttribute('name');

    retVal = targetResource.set(aspectName, aValue, shouldSignal);

    return retVal;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/ev/TP.ev.XMLNS.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'ev';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {ev:}
 * @summary This type represents the XML Events namespace
 *     (http://www.w3.org/2001/xml-events) in the tag processing system.
 */

//  ------------------------------------------------------------------------

TP.core.XMLNamespace.defineSubtype('ev.XMLNS');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.ev.XMLNS.Type.defineMethod('$generateHandlerEntriesFor',
function(anElement, aSignalName, anObserver, aTarget, aHandler) {

    /**
     * @method $generateHandlerEntriesFor
     * @summary Generates handler entries for the supplied element and other
     *     parameters.
     * @param {Element} anElement The element containing the XML Events
     *     information.
     * @param {String} aSignalName The names of the events to arm the observers
     *     with. Note that this can be a space-separated list of events to
     *     register multiple events for the same set of observers. Note that
     *     this parameter assumes fully-expanded signal names (i.e.
     *     'TP.sig.'...).
     * @param {String} anObserver The ID(s) of the elements to set up as
     *     observers of the event(s) specified. Note that this can be a
     *     space-separated list of IDs to register multiple observers for the
     *     same event(s) and handler.
     * @param {String} aTarget The names of the target elements to arm as
     *     signalers of the supplied events. Note that this can be a
     *     space-separated list of IDs to register multiple targets for the same
     *     event(s) and observer(s).
     * @param {String} aHandler The ID of the handler element that will be
     *     activated when the event(s) (is/are) fired from the target(s) and is
     *     observed by the observer(s).
     */

    var doc,

        signalName,
        observer,
        target,
        handler,

        win,

        armingTarget,

        uri,

        ancestor,
        obsElement,

        id,

        sigDispatchType,

        elem,

        arr,

        phase,
        propagate,
        defaultAction,

        entries;

    doc = TP.nodeGetDocument(anElement);

    signalName = aSignalName;
    observer = anObserver;
    target = aTarget;
    handler = aHandler;

    //  by default we plan to arm the element itself, but this will
    //  ultimately end up being adjusted to either the target or the
    //  observer based on XML Event's defaulting rules (and possibly the
    //  nature of the origin/signal themselves)
    armingTarget = anElement;

    //  observer defaults to the element, except when the handler is also
    //  not available, in which case observer becomes the element's parent
    if (TP.isEmpty(observer)) {
        //  if the handler is empty, then the observer is the element's
        //  parent element
        if (TP.isEmpty(handler)) {
            ancestor = anElement.parentNode;

            //  both the observing element and the arming target are the
            //  ancestor element
            obsElement = ancestor;
            armingTarget = ancestor;
        } else {
            //  otherwise, its the element itself

            //  both the observing element and the arming target are the
            //  element
            obsElement = anElement;
            armingTarget = anElement;
        }

        //  make sure that the observing element has an 'id'. This will be
        //  needed when registering the listener with TIBET
        if (TP.isEmpty(TP.elementGetAttribute(obsElement, 'id'))) {
            //  Pass true to assign the new ID after generating it.
            id = TP.elemGenID(obsElement, true);
        }

        //  The observer (ID) is the global ID of the observing element.
        observer = TP.gid(obsElement, true);
    } else if (observer === '*') {
        //  NOTE:   observer="*" means any origin whatsoever. it's a global
        //          observation that has no direct XMLEvents corollary. for
        //          this to work within the scope of the document we have to
        //          arm the entire document
        observer = TP.ANY;
        armingTarget = doc;
    } else if (observer === '#document') {
        //  If the observer was set to be the 'document', then just use the
        //  TP.gid() of the document.
        observer = TP.gid(doc, true);
        armingTarget = doc;
    } else if (TP.isString(observer) && TP.isURI(uri = TP.uc(observer))) {
        //  it's a URI we want to observe
        observer = uri.getLocation();
    } else {
        //  the observing element is that element in the document.
        obsElement = TP.nodeGetElementById(doc, observer);

        //  couldn't find a valid observing element - maybe it wasn't an
        //  'id' after all, but a set of space-separated ids.
        if (TP.notValid(obsElement)) {
            arr = observer.split(' ');

            //  if the observer contains multiple ids
            if (arr.getSize() > 1) {
                //  multiple values, let arming handle it as IDREFS
                armingTarget = observer;

                //  we need to convert the individual observer
                //  references to the global ID of the observing element
                arr.convert(
                    function(observerID) {

                        if (observerID === '#document') {
                            return TP.gid(doc, true);
                        } else if (TP.isElement(obsElement =
                                    TP.nodeGetElementById(doc, observerID))) {
                            return TP.gid(obsElement, true);
                        } else {
                            TP.ifWarn() && TP.$DEBUG ?
                                TP.warn('Specified ev:observer ' +
                                                observerID +
                                                ' not found for: ' +
                                                TP.nodeAsString(anElement)) : 0;

                            return observerID;
                        }
                    });

                observer = arr.join(' ');
            } else {
                TP.ifWarn() && TP.$DEBUG ?
                    TP.warn('Specified ev:observer not found for: ' +
                                    TP.nodeAsString(anElement)) : 0;
            }
        } else {
            //  otherwise, the observer is the global ID of the
            //  observing element and the arming target is the observing
            //  element
            observer = TP.gid(obsElement, true);
            armingTarget = obsElement;
        }
    }

    //  handler should default to the element if it's empty. so that we can
    //  keep things dynamic we work from IDs and we'll actually install one
    //  on the element if it doesn't have one
    if (TP.isEmpty(handler)) {
        if (TP.isEmpty(TP.elementGetAttribute(anElement, 'id'))) {
            //  we compute a local ID here, but don't bother having this
            //  routine assign it, because it will not use 'element()'
            //  scheme, which is what we want here. So we'll let 'TP.lid()'
            //  compute it, but then set it ourself.
            id = TP.lid(anElement);
            TP.elementSetAttribute(anElement, 'id', id);
        }

        //  if the element has a 'tibet:signame' and no 'handler' (and its not
        //  itself a 'tibet:sigdispatch' type of element) then that's shorthand
        //  for 'dispatch that signal' as the handler, so we make up a
        //  'javascript:' handler to do just that. Note how we generate code
        //  that uses the *resolved* target, so that in case parent elements
        //  capture the signal, we're signaling from the correct place.
        if (TP.elementHasAttribute(anElement, 'tibet:signame', true) &&
            TP.isType(sigDispatchType =
                        TP.sys.getTypeByName('tibet:sigdispatch')) &&
            TP.dom.ElementNode.getConcreteType(anElement) !==
                        sigDispatchType) {
            /* eslint-disable no-script-url */
            //  TODO: The 'sig' namespace is no longer used for this. Figure out
            //  the alternative that should be used here now.
            //  handler = TP.join('javascript:',
            //                      'TP.sig.XMLNS.dispatchSignal(',
            //                      'triggerSignal.getResolvedTarget());');
            /* eslint-enable no-script-url */
        } else {
            handler = TP.gid(anElement, true);
        }
    } else {
        //  if not empty we need to know if it's an element reference so we
        //  can expand. note that the value ends up being the target of an
        //  TP.byId() call so it doesn't have to be a local element.

        //  one thing we need to watch out for are barenames prefixed with a
        //  # to help us see that they're local IDs. If we don't respect
        //  that prefix the element won't be found properly later
        if (/^#/.test(handler)) {
            //  The handler had a '#' prefix, so we slice that off and use
            //  the result as an 'id' to getElementById().

            handler = handler.slice(1);
            if (TP.isElement(elem = TP.nodeGetElementById(doc, handler))) {
                //  An element was found with that id, so we use its global
                //  ID.
                handler = TP.gid(elem, true);
            } else {
                //  Otherwise, we use the window's global id, put the '#'
                //  back on the handler id and use the handler id to compute
                //  the overall handler id.
                win = TP.nodeGetWindow(doc);
                if (TP.notValid(win)) {
                    win = TP.sys.uiwin(true);
                }
                handler = TP.gid(win) + '#' + handler;
            }
        } else if (TP.isElement(elem = TP.nodeGetElementById(doc, handler))) {
            handler = TP.gid(elem, true);
        } else {
            //  not empty, but not found. perhaps "external" so we'll allow
            void 0;
        }
    }

    //  also have to resolve target to an ID, and adjust the armingTarget so
    //  that proper DOM semantics can be modeled
    if (TP.isEmpty(target)) {
        //  default target based on XML Events spec rules. in this case our
        //  armingTarget will remain as defined during observer setup (it'll
        //  be the observer element or a list of observer IDs)
        target = observer;
    } else if (target === '*') {
        //  NOTE:   target="*" means any origin whatsoever. it's a global
        //          observation that has no direct XMLEvents corollary. for
        //          this to work within the scope of the document we have to
        //          arm the entire document
        target = TP.ANY;
        armingTarget = doc;
    } else if (target === '#document') {
        //  NOTE that observer isn't particularly relevant here since the
        //  document element represents the only element in the event "V"
        target = TP.gid(doc, true);
        armingTarget = doc;
    } else if (TP.isString(target) && TP.isURI(uri = TP.uc(target))) {
        //  it's a URI we want to observe
        target = uri.getLocation();
    } else if (TP.isElement(elem = TP.nodeGetElementById(doc, target))) {
        //  the target was a specific element, so find that element so we
        //  can arm it instead of the observer. the tricky part here is that
        //  by having an observer differ from the target we arm one element
        //  but observe another...
        target = TP.gid(elem, true);
        armingTarget = elem;
    } else {
        arr = target.split(' ');

        //  if the target contains multiple ids
        if (TP.notEmpty(arr)) {
            arr.convert(
                function(targetID) {

                    if (TP.isElement(
                            elem = TP.nodeGetElementById(doc, targetID))) {
                        return TP.gid(elem, true);
                    }
                });

            armingTarget = arr.join(' ');

            //  update target so both are consistent
            target = armingTarget;
        } else {
            //  not unusual when pointing over to TIBET instead of local so
            //  only log this one when VERBOSE is true and only as a warning
            TP.ifWarn() && TP.$DEBUG && TP.$VERBOSE ?
                            TP.warn('Specified ev:target not found for: ' +
                                            TP.nodeAsString(anElement)) : 0;
        }
    }

    //  The signal now consists of one or more signal type names, joined by
    //  a space. The problem is that '$registerHandlerInfo' below doesn't go
    //  through the normal observe() machinery which converts signal type
    //  names into signal 'signal' names. So we need to do that here and
    //  join them back together.
    signalName = signalName.split(' ');
    signalName = signalName.collect(
                function(signame) {

                    var sigType;

                    if (TP.isType(sigType = TP.sys.getTypeByName(signame))) {
                        return sigType.getSignalName();
                    }

                    return signame;
                });
    signalName = signalName.join(' ');

    //  The remaining information isn't processed until run time so we just
    //  collect it so it's handy. We could collect the target at this point
    //  but by leaving it as a string we allow the system to be a bit more
    //  dynamic so elements can be altered in the DOM
    phase = TP.elementGetAttribute(anElement, 'ev:phase', true);
    propagate = TP.elementGetAttribute(anElement, 'ev:propagate', true);
    defaultAction = TP.elementGetAttribute(anElement,
                                            'ev:defaultAction',
                                            true);

    //  At this point the various parameters have been defaulted and/or
    //  expanded to their full IDs. The 'true' as the last parameter here tells
    //  the registration call that we want to enforce XMLEvents semantics so
    //  the observer will take on the role of origin instead of target.
    entries = TP.sig.SignalMap.$constructHandlerEntries(
                            target, signalName, handler,
                            phase, propagate, defaultAction, observer,
                            true);
    return entries;
});

//  ------------------------------------------------------------------------

TP.ev.XMLNS.Type.defineMethod('$manageEventEntries',
function(anElement, shouldRegister) {

    /**
     * @method $manageEventEntries
     * @summary Manages the registration or unregistration of event entries in
     *     TIBET's notification system.
     * @param {Element} anElement The element to manage entries for.
     * @param {Boolean} shouldRegister Whether to register or remove the
     *     handlers that can be computed from anElement.
     * @returns {null}
     */

    var eventAttrValue,

        signalName,
        signame,
        defaultType,

        observer,
        target,
        handler,

        entries,
        len,
        i,

        signalType,

        signalNames,

        domFirers,
        nondomFirers;

    //  if no ev:event attribute value then there are no events bound to
    //  this element and it's not a listener either
    if (TP.isEmpty(eventAttrValue = TP.elementGetAttribute(anElement,
                                                            'ev:event',
                                                            true))) {
        return;
    }

    signalName = eventAttrValue.trim();

    //  in XML Events this would be an error, but we allow * in both
    //  signalName and observer to support the full range of TIBET dispatch
    //  options
    if (signalName === '*') {
        signalName = TP.ANY;
    }

    observer = TP.elementGetAttribute(anElement, 'ev:observer', true);
    target = TP.elementGetAttribute(anElement, 'ev:target', true);
    handler = TP.elementGetAttribute(anElement, 'ev:handler', true);

    //  We special case to see if there is just one signal name defined as
    //  the signal. This is the common case.
    if (!/ /.test(signalName)) {
        //  If the expanded signal name resolves to a real type, then use
        //  that expanded signal name as the signal name. Otherwise, it's a
        //  spoofed signal so just use the supplied signal name.
        signalName = TP.isType(
                        TP.sys.getTypeByName(
                            signame = TP.expandSignalName(signalName))) ?
                            signame :
                            signalName;

        //  Now we check to see if:

        //  a)  we can resolve the signal name to a TIBET type which is a
        //      subtype of TP.sig.Signal, and
        //  b)  if that type's 'default firing policy' is TP.DOM_FIRING.

        //  If its not, then some of the semantics around XML Events
        //  'targets' don't really fit (since there is no capturing /
        //  bubbling).
        //  In this case, we do two things:
        //      1.  If a target is defined but an observer is not, we copy
        //          the target over to the observer
        //      2.  We clear whatever value the target had

        //  First though, compute a 'default type' that should be used in
        //  case the signal type cannot be found for the supplied signal
        //  name (this happens in the case of spoofed signals - in
        //  particular, keyboard signals that are specific, i.e.
        //  TP.sig.DOM_A_Up)
        defaultType = TP.regex.KEY_EVENT.test(signalName) ?
                        TP.sys.getTypeByName('TP.sig.DOMKeySignal') :
                        TP.sig.Signal;

        if (TP.isType(signalType = TP.sig.SignalMap.$getSignalType(
                                        signalName, defaultType)) &&
            TP.canInvoke(signalType, 'getDefaultPolicy') &&
            signalType.getDefaultPolicy() !== TP.DOM_FIRING) {
            //  a target is defined
            if (TP.notEmpty(target)) {
                //  but not an observer, so we copy it.
                if (TP.isEmpty(observer)) {
                    observer = target;
                }

                //  now, we null the value since 'target' doesn't really
                //  mean anything in a world where there is no
                //  capture / bubble. The logic below will set the target to
                //  be the observer.
                target = null;
            }
        }

        //  Go ahead and register or unregister it.
        entries = this.$generateHandlerEntriesFor(
                        anElement, signalName,
                        observer, target, handler);

        len = entries.getSize();
        if (shouldRegister) {
            for (i = 0; i < len; i++) {
                TP.sig.SignalMap.$registerHandlerEntry(entries.at(i), true);
            }
        } else {
            for (i = 0; i < len; i++) {
                TP.sig.SignalMap.$removeHandlerEntry(entries.at(i), true);
            }
        }
    } else {
        //  Otherwise this is more complex, because we have multiple signal
        //  names that we're registering for. We may have some signals that
        //  have a 'default firing policy' of TP.DOM_FIRING and some who
        //  don't. We must sort them into the two groups (using the same
        //  logic that we used above), and register them with different
        //  values for the observer and target.
        signalNames = signalName.split(' ');

        domFirers = TP.ac();
        nondomFirers = TP.ac();

        signalNames.perform(
            function(aSignalName) {

                var theSignalType,
                    theSignalName,
                    thesigname;

                //  If the expanded signal name resolves to a real type,
                //  then use that expanded signal name as the signal name.
                //  Otherwise, it's a spoofed signal so just use the
                //  supplied signal name.
                theSignalName = TP.isType(
                    TP.sys.getTypeByName(
                        thesigname = TP.expandSignalName(aSignalName))) ?
                        thesigname :
                        aSignalName;

                if (TP.isType(theSignalType =
                                TP.sig.SignalMap.$getSignalType(
                                        theSignalName, TP.sig.Signal)) &&
                    TP.canInvoke(theSignalType, 'getDefaultPolicy') &&
                    theSignalType.getDefaultPolicy() !== TP.DOM_FIRING) {
                    nondomFirers.push(theSignalName);
                } else {
                    domFirers.push(theSignalName);
                }
            });

        //  Register the domFirers (if there were any) first before we mess
        //  with the target and observer.
        if (TP.notEmpty(domFirers)) {

            //  Go ahead and register or unregister the domFirers.
            entries = this.$generateHandlerEntriesFor(
                        anElement, domFirers.join(' '),
                        observer, target, handler);

            len = entries.getSize();
            if (shouldRegister) {
                for (i = 0; i < len; i++) {
                    TP.sig.SignalMap.$registerHandlerEntry(entries.at(i), true);
                }
            } else {
                for (i = 0; i < len; i++) {
                    TP.sig.SignalMap.$removeHandlerEntry(entries.at(i), true);
                }
            }
        }

        //  Now, mess with the target and observer for the nondomFirers

        //  a target is defined
        if (TP.notEmpty(target)) {
            //  but not an observer, so we copy it.
            if (TP.isEmpty(observer)) {
                observer = target;
            }

            //  now, we null the value since 'target' doesn't really mean
            //  anything in a world where there is no capture / bubble. The
            //  logic below will set the target to be the observer.
            target = null;
        }

        //  Now register the nondomFirers (if there were any).
        if (TP.notEmpty(nondomFirers)) {

            //  Go ahead and register or unregister the nondomFirers.
            entries = this.$generateHandlerEntriesFor(
                        anElement, nondomFirers.join(' '),
                        observer, target, handler);

            len = entries.getSize();
            if (shouldRegister) {
                for (i = 0; i < len; i++) {
                    TP.sig.SignalMap.$registerHandlerEntry(entries.at(i), true);
                }
            } else {
                for (i = 0; i < len; i++) {
                    TP.sig.SignalMap.$removeHandlerEntry(entries.at(i), true);
                }
            }
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.ev.XMLNS.Type.defineMethod('setup',
function(anElement) {

    /**
     * @method setup
     * @summary Sets up anElement in the event notification system. This method
     *     is a key element of how TIBET supports XML Events. The various
     *     ev:listeners and elements containing ev: prefixed attributes are
     *     configured during this process so that the proper elements are armed
     *     in the UI and the proper observations are configured within TIBET.
     * @param {Element} anElement The element to set up.
     * @returns {null}
     */

    this.$manageEventEntries(anElement, true);

    return;
});

//  ------------------------------------------------------------------------

TP.ev.XMLNS.Type.defineMethod('teardown',
function(anElement) {

    /**
     * @method teardown
     * @summary Tears down anElement from the event notification system.
     *     Basically this method does the inverse of the 'setup' method above.
     * @param {Element} anElement The element to tear down.
     * @returns {null}
     */

    this.$manageEventEntries(anElement, false);

    return;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/ev/TP.ev.info.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'ev';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {ev:info}
 * @summary A wrapper for the XML Events ev:listener element, named for
 *     consistency with other TIBET 'info' tags.
 * @summary See ev:listener for details.
 */

//  ------------------------------------------------------------------------

TP.tag.InfoTag.defineSubtype('ev:info');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/ev/TP.ev.listener.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'ev';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {ev:listener}
 * @summary A wrapper for the XML Events ev:listener element.
 * @summary The official XML Events listener element is considered by some
 *     to be superfluous since you can place ev: attributes on elements to
 *     event-enable them. Of course, you can XInclude listener elements as one
 *     way of getting "value" from them by allowing you to factor them out into
 *     reusable blocks of event handler support.
 */

//  ------------------------------------------------------------------------

TP.tag.InfoTag.defineSubtype('ev:listener');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/ev/TP.ev.script.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'ev';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.ev.script}
 * @summary Provides a mechanism for supporting script blocks that conform to
 *     those found in the XML Events 2 examples (and hence some XForms examples)
 *     in which script blocks are targeted as handlers. Note however that in
 *     TIBET the default type for an TP.ev.script block is TIBET Shell, not
 *     JavaScript so to use an TP.ev.script tag with javascript you use
 *     type="text/javascript".
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('ev:script');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.ev.script.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @description For this type, this method invokes the script content of the
     *     receiver. The content should have been encapsulated in a CDATA block
     *     to avoid potential problems with entity encoding.
     * @param {TP.sig.Request} aRequest The TP.sig.TSHRunRequest or other shell
     *     related request responsible for this tag.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var node,

        funcID,
        win,
        result,

        src,
        resp,
        source,
        url,
        type,
        req,

        shell,

        signal;

    node = aRequest.at('cmdNode');

    //  see if we've been able to build a cached function for this script
    //  block on a prior invocation. if so we'll call that directly
    if (TP.notEmpty(funcID =
                    TP.elementGetAttribute(node, 'tibet:handlerid', true))) {
        //  caching is done on the node's native window (if it has one) or
        //  on the current TIBET code window
        win = TP.nodeGetWindow(node) || window;
        if (TP.canInvoke(win, funcID)) {
            try {
                result = win[funcID](aRequest, aRequest.at('cmdTrigger'));

                return aRequest.complete(result);
            } catch (e) {
                return aRequest.fail(
                        TP.join('Error executing TP.ev.script function: ',
                            this.asString()),
                        TP.FAILED,
                        'EvalException');
            }
        }
    }

    //  See if an external 'src' URI has been defined. this is equivalent to the
    //  src attribute of a standard html:script tag
    src = TP.elementGetAttribute(node, 'ev:src', true);
    if (TP.isEmpty(src)) {
        source = TP.nodeGetTextContent(node);
    } else {
        //  when we have a src attribute our goal is to get the text content of
        //  that URI so we can process it
        if (TP.notValid(url = TP.uc(src))) {
            return aRequest.fail(
                    'Invalid src attribute value: ' + src);
        }

        resp = url.getResource(TP.hc('async', false, 'resultType', TP.TEXT));
        source = resp.get('result');
    }

    if (TP.isEmpty(source)) {
        return aRequest.fail('No source code found for: ' + TP.str(node));
    }

    //  Check on the type of source, we support both text/javascript and TSH
    //  syntax with this tag but we default to TSH...otherwise you'd have likely
    //  been using an html:script tag right? ;)
    type = TP.ifEmpty(TP.elementGetAttribute(node, 'ev:type', true),
                        TP.ietf.mime.TSH);

    if (type === TP.ietf.mime.TSH) {
        //  TSH source, if already processed, can be managed by the current
        //  request if we can get it into child content where TP.DESCEND could
        //  work effectively, otherwise we need to process it in a full
        //  subrequest and join to that for result processing.

        req = TP.sig.ShellRequest.construct(
            TP.hc('cmd', source,
                    'cmdAllowSubs', false,
                    'cmdAsIs', aRequest.at('cmdAsIs'),
                    'cmdExecute', true,
                    'cmdHistory', false,
                    'cmdBuildGUI', false,
                    'cmdLiteral', aRequest.at('cmdLiteral'),
                    'cmdPhases', 'nocache',
                    'cmdShell', aRequest.at('cmdShell'),
                    'cmdSilent', true,
                    'execContext',
                        TP.ifInvalid(TP.nodeGetWindow(node), window)
            ));

        shell = aRequest.at('cmdShell');

        req.defineMethod('cancelJob',
            function(aFaultString, aFaultCode, aFaultInfo) {

                //  Make sure to unset the variable on the shell that contains
                //  the signal that fired us.
                shell.unsetVariable('SIGNAL');
                shell.unsetVariable('TARGET');

                return aRequest.cancel(
                        TP.ifInvalid(aFaultString, 'TP.ev.script cancelled.'),
                        TP.ifInvalid(aFaultCode, TP.CANCELLED),
                        aFaultInfo);
            });

        req.defineMethod('completeJob',
            function(aResult) {

                //  Make sure to unset the variable on the shell that contains
                //  the signal that fired us.
                shell.unsetVariable('SIGNAL');
                shell.unsetVariable('TARGET');

                //  Don't pass a null. Make sure there's a real result.
                if (arguments.length > 0) {
                    return aRequest.complete(aResult);
                } else {
                    return aRequest.complete();
                }
            });

        req.defineMethod('failJob',
            function(aFaultString, aFaultCode, aFaultInfo) {

                //  Make sure to unset the variable on the shell that contains
                //  the signal that fired us.
                shell.unsetVariable('SIGNAL');
                shell.unsetVariable('TARGET');

                return aRequest.fail(
                        TP.ifInvalid(aFaultString, 'TP.ev.script failed.'),
                        TP.ifInvalid(aFaultCode, TP.FAILED),
                        aFaultInfo);
            });

        //  Configure STDIO that any nested command operations will output to
        //  the location(s) we desire we connect our IO to the subrequest.
        req.configureSTDIO(aRequest);

        //  ensure we map the action input we want/need for STDIN.
        req.atPut(TP.STDIN, this.getActionInput(aRequest));

        //  Set a variable on the shell that will contain the signal that fired
        //  us.
        if (TP.isValid(signal = aRequest.at('cmdTrigger'))) {
            shell.setVariable('SIGNAL', signal);
            shell.setVariable('TARGET', signal.getTarget());
        }

        shell[TP.composeHandlerName('ShellRequest')](req);
    } else if (type === TP.ietf.mime.JS) {
        //  Build a function and cache it on the receiver's window, updating the
        //  node to hold it's ID for next time
        funcID = TP.genID('ev_script');
        source = 'function(shellRequest, triggerSignal) {' + source + '};';

        try {
            //  NOTE that by running the eval here in the window context we'll
            //  build the function such that its internal references
            //  to window/document are proper
            win = TP.nodeGetWindow(node) || window;
            /* eslint-disable no-eval */
            eval('win.$$handler = ' + source);
            /* eslint-enable no-eval */
            win[funcID] = win.$$handler;
        } catch (e) {
            //  First we log an error.
            TP.ifError() ?
                TP.error(TP.ec(e, 'TP.ev.script creation error.')) : 0;

            return aRequest.fail(
                TP.join('Error creating TP.ev.script function: ',
                        source, '. ', TP.str(e)));
        }

        //  Cache the 'function ID' back on the element so that it can be used
        //  above for lookup and we won't eval the code again.
        TP.elementSetAttribute(node, 'tibet:handlerid', funcID, true);

        try {
            result = win[funcID](aRequest, aRequest.at('cmdTrigger'));

            aRequest.complete(result);
        } catch (e) {
            return aRequest.fail(
                    TP.join('Error executing TP.ev.script function: ',
                            this.asString()),
                    TP.FAILED,
                    'EvalException');
        }
    } else {
        return aRequest.fail(
                TP.join('Invalid TP.ev.script source type: ',
                TP.FAILED,
                type));
    }

    return TP.CONTINUE;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xhtml/TP.html.Element.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'html';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.html.Element}
 * @summary The TP.html.Element type is the top-level type in the xhtml node
 *     hierarchy. Note that we use the prefix html here since that is the
 *     defined canonical prefix for XHTML as well as HTML.
 */

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.defineSubtype('html.Element');

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation
TP.html.Element.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.html.Element.Type.set('booleanAttrs',
        TP.ac('translate', 'itemScope', 'hidden', 'draggable',
                'isContentEditable', 'spellcheck',
                'commandHidden', 'commandDisabled', 'commandChecked'));

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.Element.Type.defineMethod('getResourceURI',
function(resource, mimeType, fallback) {

    /**
     * @method getResourceURI
     * @summary Returns a resource URI specific to the receiver for the named
     *     resource and mimeType. This method is used to look up template,
     *     style, theme, and other resource URIs by leveraging cfg flags and
     *     methods on the receiver specific to each resource/mime requirement.
     * @param {String} resource The resource name. Typically 'template',
     *     'style', 'style_{theme}', etc. but it could be essentially anything
     *     except the word 'resource' (since that would trigger a recursion).
     * @param {String} mimeType The mimeType for the resource being looked up.
     *     This is used to locate viable extensions based on the data in TIBET's
     *     TP.ietf.mime.INFO dictionary.
     * @param {Boolean} [fallback] Compute a fallback value?  Defaults to the
     *     value of 'uri.fallbacks'.
     * @returns {TP.uri.URI} The computed resource URI.
     */

    return null;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.Element.Inst.defineMethod('addCSSClass',
function(aCSSClass, atEnd) {

    /**
     * @method addCSSClass
     * @summary Adds the CSS class whose name is equal to aCSSClass to this
     *     object's CSS class name list.
     * @description Note that if the 'atEnd' argument is set to 'true', this
     *     causes aCSSClass to be appended to the end of the list of CSS class
     *     names. Since the order of CSS class names is important when
     *     specifying multiple names in the same 'className' attribute for the
     *     same element (for purposes of computing precedence), this is
     *     important.
     * @param {String} aCSSClass The name of the CSS class to add.
     * @param {Boolean} atEnd Whether or not this CSS class should be added to
     *     the end of the list of CSS classes.
     * @returns {TP.html.Element} The receiver.
     */

    TP.elementAddClass(this.getNativeNode(), aCSSClass, atEnd);

    return this;
});

//  ------------------------------------------------------------------------

TP.html.Element.Inst.defineMethod('getClass',
function() {

    /**
     * @method getClass
     * @summary Gets the CSS class of the receiver.
     * @returns {String} A string containing the current class name.
     */

    return TP.elementGetClass(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.html.Element.Inst.defineMethod('getStyle',
function() {

    /**
     * @method getStyle
     * @summary Gets the style of this component.
     * @returns {String} A string containing the current inline style of this
     *     element.
     */

    return TP.elementGetStyleString(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.html.Element.Inst.defineMethod('isReadyToRender',
function() {

    /**
     * @method isReadyToRender
     * @summary Whether or not the receiver is 'ready to render'. Normally, this
     *     means that all of the resources that the receiver relies on to render
     *     have been loaded.
     * @returns {Boolean} Whether or not the receiver is ready to render.
     */

    //  XHTML elements are always ready to render (at least in modern browsers
    //  ;-))
    return true;
});

//  ------------------------------------------------------------------------

TP.html.Element.Inst.defineMethod('removeCSSClass',
function(aCSSClass) {

    /**
     * @method removeCSSClass
     * @summary Removes the CSS class whose name is equal to aCSSClass from
     *     this object's CSS class name list.
     * @param {String} aCSSClass The name of the CSS class to remove.
     * @returns {TP.html.Element} The receiver.
     */

    TP.elementRemoveClass(this.getNativeNode(), aCSSClass);

    return this;
});

//  ------------------------------------------------------------------------

TP.html.Element.Inst.defineMethod('replaceCSSClass',
function(oldCSSClass, newCSSClass) {

    /**
     * @method replaceCSSClass
     * @summary Replaces the CSS class whose name is equal to oldCSSClass with
     *     the CSS class named newCSSClass. this object's CSS class name list.
     * @param {String} oldCSSClass The name of the CSS class to replace.
     * @param {String} newCSSClass The name of the CSS class to replace it with.
     * @returns {TP.html.Element} The receiver.
     */

    TP.elementReplaceClass(this.getNativeNode(), oldCSSClass, newCSSClass);

    return this;
});

//  ------------------------------------------------------------------------

TP.html.Element.Inst.defineMethod('setClass',
function(aClassName) {

    /**
     * @method setClass
     * @summary An optimized method to set the native element's CSS class name
     *     to aClassName.
     * @param {String} aClassName The CSS class name to set the native element's
     *     class name to.
     * @returns {TP.html.Element} The receiver.
     */

    TP.elementSetClass(this.getNativeNode(), aClassName);

    return this;
});

//  ------------------------------------------------------------------------

TP.html.Element.Inst.defineMethod('setStyle',
function(aStyle) {

    /**
     * @method setStyle
     * @summary Sets the style of this component to the style parameters given
     *     in aStyleString.
     * @param {String|TP.core.Hash} aStyle The description of the style in CSS
     *     format, or a hash of style strings.
     * @returns {TP.html.Element} The receiver.
     */

    var styleObj;

    if (TP.isString(aStyle)) {
        //  We have the whole 'style' String and we want to set it all at
        //  once.
        TP.elementSetStyleString(this.getNativeNode(), aStyle);
    }

    styleObj = this.getNativeNode().style;

    //  Loop over all of the key/value pairs in the hash.
    aStyle.perform(
            function(kvPair) {

                var domPropName;

                //  Get the actual DOM property name
                domPropName = kvPair.first().asDOMName();

                //  If we got a valid DOM property, set its value on the
                //  native style object to the value at this key in the
                //  collection.
                if (TP.isString(domPropName)) {
                    styleObj[domPropName] = kvPair.last();
                }
            });

    return this;
});

//  ------------------------------------------------------------------------
//  DATA BINDING
//  ------------------------------------------------------------------------

TP.html.Element.Inst.defineMethod('getDisplayValue',
function() {

    /**
     * @method getDisplayValue
     * @summary Returns the receiver's "value" whatever that means for this
     *     type. The default operations here check for a non-empty value
     *     attribute, a value slot, and finally the text value.
     * @returns {Object} The value of the receiver.
     */

    var node,
        val;

    node = this.getNativeNode();

    //  attribute is our first choice since that's most common
    if (TP.elementHasAttribute(node, 'value')) {
        return this.getAttribute('value');
    }

    //  next choice is a value slot, but that's rare actually
    try {
        if (TP.notEmpty(val = node.value)) {
            return val;
        }
    } catch (e) {
        TP.ifError() ?
            TP.error(TP.ec(e, 'Error getting display value.')) : 0;
    }

    //  last value option is the text value
    return TP.nodeGetTextContent(node);
});

//  ------------------------------------------------------------------------

TP.html.Element.Inst.defineMethod('setDisplayValue',
function(aValue) {

    /**
     * @method setDisplayValue
     * @summary Sets the receiver's "value" whatever that means for this type.
     *     The two default operations here are to set a 'value' attribute and a
     *     'value' slot if possible.
     * @param {String} aValue The new value to set.
     * @returns {TP.html.Element} The receiver.
     */

    var node;

    node = this.getNativeNode();

    //  we'll work in pairs here, since we want to keep the DOM and XML in
    //  sync as much as possible. NOTE that few controls will actually
    //  respond positively to this, so it's typical to override this method
    this.setAttribute('value', aValue);

    try {
        if (TP.notEmpty(node.value)) {
            node.value = aValue;
        } else {
            TP.nodeSetTextContent(node, aValue);
        }
    } catch (e) {
        TP.nodeSetTextContent(node, aValue);
    }

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xhtml/html_CommonNodes.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'html';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @summary The following types aren't strict XHTML "entities" as defined in
 *     the XTHML DTD but they form a useful framework for attribute inheritance.
 *     TIBET's XHTML node types inherit from appropriate points in this
 *     hierarchy. To improve reuse where necessary, multiple inheritance is used
 *     to further reduce code size.
 * @subject XHTML common node supertypes
 */

//  ========================================================================
//  XHTML "base" types
//  ========================================================================

//  can't construct concrete instances of any of these types

//  ========================================================================
//  TP.html.CoreAttrs
//  ========================================================================

TP.dom.UIElementNode.defineSubtype('html.CoreAttrs');

//  A subtype of TP.core.UIElement that has 4 common attributes:
//  id, class, style, title

TP.html.CoreAttrs.isAbstract(true);

TP.html.CoreAttrs.addTraits(TP.html.Element);

TP.html.CoreAttrs.Type.resolveTrait('booleanAttrs', TP.html.Element);

TP.html.CoreAttrs.Inst.resolveTraits(
        TP.ac('getDisplayValue', 'setDisplayValue'),
        TP.html.Element);

//  ========================================================================
//  TP.html.Attrs
//  ========================================================================

TP.dom.UIElementNode.defineSubtype('html.Attrs');
TP.html.Attrs.isAbstract(true);

TP.html.Attrs.addTraits(TP.html.Element);

TP.html.Attrs.Type.resolveTrait('booleanAttrs', TP.html.Element);

TP.html.Attrs.Inst.resolveTraits(
        TP.ac('getDisplayValue', 'setDisplayValue'),
        TP.html.Element);

//  ========================================================================
//  TP.html.Aligned
//  ========================================================================

TP.html.Attrs.defineSubtype('Aligned');
TP.html.Aligned.isAbstract(true);

//  ========================================================================
//  TP.html.Focused
//  ========================================================================

TP.html.Attrs.defineSubtype('Focused');
TP.html.Focused.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.html.Focused.Type.defineAttribute('opaqueCapturingSignalNames',
        TP.ac(
            'TP.sig.DOMClick',
            'TP.sig.DOMDblClick',

            'TP.sig.DOMKeyDown',
            'TP.sig.DOMKeyPress',
            'TP.sig.DOMKeyUp',

            'TP.sig.DOMMouseDown',
            'TP.sig.DOMMouseEnter',
            'TP.sig.DOMMouseLeave',
            'TP.sig.DOMMouseOut',
            'TP.sig.DOMMouseOver',
            'TP.sig.DOMMouseUp',

            'TP.sig.DOMFocus',
            'TP.sig.DOMBlur'
        ));

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.Focused.Type.defineMethod('isResponderForUIFocusChange',
function(aNode, aSignal) {

    /**
     * @method isResponderForUIFocusChange
     * @summary Returns true if the node does not have a 'disabled' attribute to
     *     match (X)HTML semantics.
     * @param {Node} aNode The node to check which may have further data as to
     *     whether this type should be considered to be a responder.
     * @param {TP.sig.Signal} aSignal The signal that responders are being
     *     computed for.
     * @returns {Boolean} True when the receiver should respond to aSignal.
     */

    return !TP.elementHasAttribute(aNode, 'disabled', true);
});

//  ------------------------------------------------------------------------

TP.html.Focused.Type.defineMethod('isResponderForUIFocusComputation',
function(aNode, aSignal) {

    /**
     * @method isResponderForUIFocusComputation
     * @summary Returns true if the node does not have a 'disabled' attribute to
     *     match (X)HTML semantics.
     * @param {Node} aNode The node to check which may have further data as to
     *     whether this type should be considered to be a responder.
     * @param {TP.sig.Signal} aSignal The signal that responders are being
     *     computed for.
     * @returns {Boolean} True when the receiver should respond to aSignal.
     */

    return !TP.elementHasAttribute(aNode, 'disabled', true);
});

//  ========================================================================
//  TP.html.Citation
//  ========================================================================

TP.html.Attrs.defineSubtype('Citation');
TP.html.Citation.isAbstract(true);

//  ========================================================================
//  TP.html.List
//  ========================================================================

TP.html.Attrs.defineSubtype('List');
TP.html.List.isAbstract(true);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.List.Type.defineMethod('generateMarkup',
function(anObject, attrStr, itemFormat, shouldAutoWrap, formatArgs,
         theRequest) {

    /**
     * @method generateMarkup
     * @summary Generates markup for the supplied Object using the other
     *     parameters supplied.
     * @param {Object} anObject The Object of content to wrap in markup.
     * @param {String} attrStr The String containing either the literal
     *     attribute markup or a 'template invocation' that can be used inside
     *     of a template.
     * @param {String} itemFormat The name of an 'item format', either a tag
     *     name (which defaults to the 'item tag name' of this type) or some
     *     other format type which can be applied to this type.
     * @param {Boolean} shouldAutoWrap Whether or not the markup generation
     *     machinery should 'autowrap' items of the supplied object (each item
     *     in an Array or each key/value pair in an Object).
     * @param {TP.core.Hash} formatArgs The 'formatting arguments' used by this
     *     machinery to generate item markup.
     * @param {TP.sig.Request|TP.core.Hash} theRequest An optional object
     *     containing parameters.
     * @returns {String} The markup generated by taking the supplied Object and
     *     iterating over its items.
     */

    var tagName,
        template,
        str;

    //  Don't generate markup annotated with the data expression
    theRequest.atPut('annotateMarkup', false);

    //  If the object is an Array, then just skip to the bottom of the
    //  method.
    if (TP.isArray(anObject)) {
        void 0;
    } else if (TP.isTrue(shouldAutoWrap) && TP.isTrue(theRequest.at('repeat'))) {
        //  Otherwise, if we're autowrapping and repeating, the object that
        //  will be handed to the iteration mechanism will be [key,value]
        //  pairs, so we can use that fact to generate item tags around each
        //  one.

        tagName = this.getCanonicalName();

        //  Build a template by joining the tag name with an invocation
        //  of the itemFormat for both the key and the value.
        template = TP.join('<', tagName, attrStr, '>',
                            '{{0.%', itemFormat, '}}',
                            '{{1.%', itemFormat, '}}',
                            '</', tagName, '>');

        //  Perform the transformation.
        str = template.transform(anObject, theRequest);

        return str;
    }

    //  It was either an Array or we weren't autowrapping and repeating. In
    //  that case, just call up the supertype chain and return the value.
    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.html.List.Type.defineMethod('getItemTagName',
function() {

    /**
     * @method getItemTagName
     * @summary Returns the 'default item tag name' for use it the
     *     fromArray()/fromObject() methods. Note that this should return the
     *     receiver's *canonical* name.
     * @returns {String} The ID of the observer.
     */

    return 'html:li';
});

//  ------------------------------------------------------------------------

TP.html.List.Type.defineMethod('shouldAutoWrapItems',
function(anObject, formatArgs) {

    /**
     * @method shouldAutoWrapItems
     * @summary Whether or not our fromArray() / fromObject() methods
     *     'auto-wrap items'. See those methods for more information.
     * @param {Object} anObject The Object of content to wrap in markup.
     * @param {TP.core.Hash} formatArgs An optional object containing
     *     parameters.
     * @returns {Boolean} Whether or not we automatically wrap items.
     */

    if (TP.isBoolean(formatArgs.at('autowrap'))) {
        return formatArgs.at('autowrap');
    }

    //  An TP.html.List's default is to *not* wrap each item of an Array in
    //  its own tags (maybe each one goes in an 'li').
    if (TP.isArray(anObject)) {
        return false;
    }

    return true;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xhtml/html_10Nodes.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'html';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @summary This file contains the definitions for the various XHTML 1.0
 *     node subtypes that were not categorized by the W3C into modules in XHTML
 *     1.1. This is mostly because these tags are formatting tags that have been
 *     deprecated by the W3C in favor of using style sheets or they are
 *     frame/frameset related. They are included in TIBET for completeness, but
 *     their use is discouraged.
 * @subject XHTML 1.0 Nodes
 */

//  ========================================================================
//  TP.html.applet
//  ========================================================================

/**
 * @type {TP.html.applet}
 * @summary 'applet' tag. An applet.
 */

//  ------------------------------------------------------------------------

TP.html.CoreAttrs.defineSubtype('applet');

TP.html.applet.Type.set('uriAttrs', TP.ac('src'));

//  ========================================================================
//  TP.html.basefont
//  ========================================================================

/**
 * @type {TP.html.basefont}
 * @summary 'basefont' tag. Base font size.
 */

//  ------------------------------------------------------------------------

TP.html.CoreAttrs.defineSubtype('basefont');

//  ========================================================================
//  TP.html.center
//  ========================================================================

/**
 * @type {TP.html.center}
 * @summary 'center' tag. Center content.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('center');

//  ========================================================================
//  TP.html.dir
//  ========================================================================

/**
 * @type {TP.html.dir}
 * @summary 'dir' tag. Multiple column list. (Deprecated)
 */

//  ------------------------------------------------------------------------

TP.html.List.defineSubtype('dir');

TP.html.dir.Type.set('booleanAttrs', TP.ac('compact'));

//  ========================================================================
//  TP.html.font
//  ========================================================================

/**
 * @type {TP.html.font}
 * @summary 'font' tag. Local font change.
 */

//  ------------------------------------------------------------------------

TP.html.CoreAttrs.defineSubtype('font');

//  ========================================================================
//  TP.html.frame
//  ========================================================================

/**
 * @type {TP.html.frame}
 * @summary 'frame' tag. An individual frame.
 */

//  ------------------------------------------------------------------------

TP.html.CoreAttrs.defineSubtype('frame');

TP.html.frame.Type.set('booleanAttrs', TP.ac('noResize'));

//  ========================================================================
//  TP.html.frameset
//  ========================================================================

/**
 * @type {TP.html.frameset}
 * @summary 'frameset' tag.
 */

//  ------------------------------------------------------------------------

TP.html.CoreAttrs.defineSubtype('frameset');

//  ========================================================================
//  TP.html.iframe
//  ========================================================================

/**
 * @type {TP.html.iframe}
 * @summary 'iframe' tag. Inline frame (subwindow). Note that this type mixes
 *     in TP.core.UICanvas which allows iframe elements to work as UICanvas
 *     elements.
 */

//  ------------------------------------------------------------------------

//  an IFRAME is an element...
TP.html.CoreAttrs.defineSubtype('iframe');

TP.html.iframe.Type.set('booleanAttrs', TP.ac('seamless', 'allowFullscreen'));

//  IFRAME elements are also UI canvases just like windows
TP.html.iframe.addTraits(TP.core.UICanvas);

TP.html.iframe.Type.set('uriAttrs', TP.ac('src', 'longdesc'));

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.iframe.Type.defineMethod('isResponderForUIFocusChange',
function(aNode, aSignal) {

    /**
     * @method isResponderForUIFocusChange
     * @summary Returns true if the node does not have a 'disabled' attribute to
     *     match (X)HTML semantics.
     * @param {Node} aNode The node to check which may have further data as to
     *     whether this type should be considered to be a responder.
     * @param {TP.sig.Signal} aSignal The signal that responders are being
     *     computed for.
     * @returns {Boolean} True when the receiver should respond to aSignal.
     */

    return !TP.elementHasAttribute(aNode, 'disabled', true);
});

//  ------------------------------------------------------------------------

TP.html.iframe.Type.defineMethod('isResponderForUIFocusComputation',
function(aNode, aSignal) {

    /**
     * @method isResponderForUIFocusComputation
     * @summary Returns true if the node does not have a 'disabled' attribute to
     *     match (X)HTML semantics.
     * @param {Node} aNode The node to check which may have further data as to
     *     whether this type should be considered to be a responder.
     * @param {TP.sig.Signal} aSignal The signal that responders are being
     *     computed for.
     * @returns {Boolean} True when the receiver should respond to aSignal.
     */

    return !TP.elementHasAttribute(aNode, 'disabled', true);
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.iframe.Inst.defineMethod('becomeFocusedResponder',
function() {

    /**
     * @method becomeFocusedResponder
     * @summary Tells the receiver that it is now the 'focused responder'.
     * @returns {TP.html.iframe} The receiver.
     */

    //  We override this from our supertype because, while we're considered
    //  officially 'focusable', we'll never want to be pushed onto the focus
    //  stack.

    return this;
});

//  ------------------------------------------------------------------------

TP.html.iframe.Inst.defineMethod('resignFocusedResponder',
function() {

    /**
     * @method resignFocusedResponder
     * @summary Tells the receiver that it is no longer the 'focused
     *     responder'.
     * @returns {TP.html.iframe} The receiver.
     */

    //  We override this from our supertype because, while we're considered
    //  officially 'focusable', we'll never be pushed onto the focus stack and
    //  'blurring' us should never cause the focus stack to be manipulated.

    return this;
});

//  ------------------------------------------------------------------------

TP.html.iframe.Inst.defineMethod('setContentFromSource',
function() {

    /**
     * @method setContentFromSource
     * @summary Sets the content of the receiver to the content pointed to by
     *     it's 'src' attribute, running it through the content processor first.
     * @returns {TP.html.iframe} The receiver.
     */

    var srcPath;

    if (TP.notEmpty(srcPath = this.getAttribute('src'))) {
        this.setContentUsingRelativePath(srcPath);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.html.iframe.Inst.defineMethod('setContentUsingRelativePath',
function(aPath) {

    /**
     * @method setContentUsingRelativePath
     * @summary Sets the content of the receiver to the content pointed to by
     *     the supplied attribute, running it through the content processor
     *     first.
     * @description Note that the supplied path can be a relative URI, as the
     *     receiver will be asked to resolve it to an absolute URI. This is
     *     usually done by resolving it against the receiver's XML Base value or
     *     it's document baseURI if an XML Base value cannot be computed.
     * @param {String} aPath The URI to use as the path.
     * @returns {TP.html.iframe} The receiver.
     */

    var srcPath,
        srcURI;

    if (TP.notEmpty(aPath)) {

        //  This will compute an 'absolute path' using the value of our 'src'
        //  attribute and either our computed XML Base or our document's
        //  'baseURI'.
        srcPath = this.computeAbsoluteURIFromValue(aPath);

        //  See if we can turn the path value into a URI
        srcURI = TP.uc(srcPath);

        //  It may need a rewrite().
        srcURI = srcURI.rewrite();

        //  If we have a URI, set the content of our content window to it.
        if (TP.isURI(srcURI)) {

            //  Set our content to the fetched resource. This will cause content
            //  processing to occur.
            this.setContent(srcURI);
        }
    }

    return this;
});

//  ------------------------------------------------------------------------
//  TP.core.UICanvas Interface
//  ------------------------------------------------------------------------

TP.html.iframe.Inst.defineMethod('getCanvasID',
function() {

    /**
     * @method getCanvasID
     * @summary Returns the canvas ID for the receiver. For an IFRAME this is
     *     computed differently than normal so that IFRAME elements appear to
     *     have canvas IDs similar to true frames.
     * @returns {String} The canvas's global ID.
     */

    return TP.join(this.getWindow().getCanvasID(), '.', this.getLocalID());
});

//  ------------------------------------------------------------------------

TP.html.iframe.Inst.defineMethod('getGlobalID',
function() {

    /**
     * @method getGlobalID
     * @summary Returns the global ID for the receiver.
     * @returns {String} The canvas's global ID.
     */

    //  we want the global ID for the iframe itself here, unlike the traited
    //  version which will return the global ID for the content window
    return TP.gid(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.html.iframe.Inst.defineMethod('getLocalID',
function() {

    /**
     * @method getLocalID
     * @summary Returns the local ID for the receiver.
     * @returns {String} The canvas's local ID.
     */

    //  we want to use the IFRAME element's 'id' attribute here, not an
    //  identifier for the content window as the traited version would do
    return TP.lid(this.getNativeNode());
});

//  ------------------------------------------------------------------------

TP.html.iframe.Inst.defineMethod('getNativeContentDocument',
function() {

    /**
     * @method getNativeContentDocument
     * @summary Returns the content document (that is the contained 'document')
     *     of the receiver in a TP.dom.Document wrapper.
     * @returns {Document} The Document object contained by the receiver.
     */

    var elem;

    if (TP.isElement(elem = this.getNativeNode())) {
        return TP.elementGetIFrameDocument(elem);
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.html.iframe.Inst.defineMethod('getNativeContentWindow',
function() {

    /**
     * @method getNativeContentWindow
     * @summary Returns the content window (that is the 'contained window') of
     *     the receiver.
     * @returns {Window} The Window object contained by the receiver.
     */

    var elem;

    if (TP.isElement(elem = this.getNativeNode())) {
        return TP.elementGetIFrameWindow(elem);
    }

    return null;
});

//  ------------------------------------------------------------------------
//  GENERAL
//  ------------------------------------------------------------------------

TP.html.iframe.Inst.defineMethod('$get',
function(attributeName) {

    /**
     * @method $get
     * @summary Primitive $get() hook. Allows instances of this type to look up
     *     globals on their content window if a value for the attribute cannot
     *     be found on the receiver itself.
     * @param {String} attributeName The name/key of the attribute to return.
     * @returns {Object}
     */

    var val,
        win;

    //  Start by looking for the attribute (or a method) on this object.
    val = this.callNextMethod();

    //  If we got back an undefined value, then try to see if its a 'global
    //  slot' on our content window (very useful if we've loaded our content
    //  window with other code bases).
    if (TP.notDefined(val) &&
        TP.isWindow(win = this.getNativeContentWindow())) {
        val = win[attributeName];
    }

    return val;
});

//  ------------------------------------------------------------------------

TP.html.iframe.Inst.defineMethod('constructObject',
function(constructorName) {

    /**
     * @method constructObject
     * @summary Constructs an object in the receiver's content window.
     * @description Note that all parameters to this method are passed along in
     *     the object creation process. Therefore, arguments to the 'new', if
     *     you will, should be passed after the constructorName. Note that this
     *     type's implementation of this method is different from
     *     TP.core.Window's in that this type tries to construct the object
     *     *inside* of it's content window, not in the window it's located in.
     * @param {String} constructorName The name of the constructor to use to
     *     construct the object.
     * @returns {Object} The object constructed in the receiver's content
     *     window.
     */

    var args,
        win;

    //  constructorName was only pointed out above for documentation
    //  purposes. We pass along *all* arguments after inserting our native
    //  window to the front of the Array.
    win = TP.elementGetIFrameWindow(this.getNativeNode());
    args = TP.args(arguments);
    args.unshift(win);

    return TP.windowConstructObject.apply(win, args);
});

//  ------------------------------------------------------------------------

/*
 * Although this method is defined in our TP.core.UICanvas trait, its also
 * defined on our 'TP.html.Element' supertype and we inherit the one from
 * 'TP.html.Element'. We want the version that TP.core.UICanvas has.
*/

TP.html.iframe.Inst.resolveTrait('setContent', TP.core.UICanvas);

//  ========================================================================
//  TP.html.isindex
//  ========================================================================

/**
 * @type {TP.html.isindex}
 * @summary 'isindex' tag. (Deprecated)
 */

//  ------------------------------------------------------------------------

TP.html.CoreAttrs.defineSubtype('isindex');

//  ========================================================================
//  TP.html.listing
//  ========================================================================

/**
 * @type {TP.html.listing}
 * @summary 'listing' tag.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('listing');

//  ========================================================================
//  TP.html.menu
//  ========================================================================

/**
 * @type {TP.html.menu}
 * @summary 'menu' tag. Single column list. (Deprecated)
 */

//  ------------------------------------------------------------------------

TP.html.List.defineSubtype('menu');

TP.html.menu.Type.set('booleanAttrs', TP.ac('compact'));

//  ========================================================================
//  TP.html.noframes
//  ========================================================================

/**
 * @type {TP.html.noframes}
 * @summary 'noframes' tag. When frames are unsupported.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('noframes');

//  ========================================================================
//  TP.html.s
//  ========================================================================

/**
 * @type {TP.html.s}
 * @summary 's' tag. Strike-through.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('s');

//  ========================================================================
//  TP.html.strike
//  ========================================================================

/**
 * @type {TP.html.strike}
 * @summary 'strike' tag. Strike-through.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('strike');

//  ========================================================================
//  TP.html.u
//  ========================================================================

/**
 * @type {TP.html.u}
 * @summary 'u' tag. Underline.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('u');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xhtml/html_BaseModuleNodes.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'html';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.html.base
//  ========================================================================

/**
 * @type {TP.html.base}
 * @summary 'base' tag. Document base URI.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('base');

TP.html.base.addTraits(TP.dom.EmptyElementNode);

TP.html.base.Inst.resolveTraits(
        TP.ac('getContent', 'setContent'),
        TP.dom.EmptyElementNode);

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xhtml/html_BidirectionalTextModuleNodes.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'html';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.html.bdo
//  ========================================================================

/**
 * @type {TP.html.bdo}
 * @summary 'bdo' Tag. Override layout directionality.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('bdo');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xhtml/html_ClientSideImageMapModuleNodes.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'html';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.html.area
//  ========================================================================

/**
 * @type {TP.html.area}
 * @summary 'area' tag. A clickable area.
 */

//  ------------------------------------------------------------------------

TP.html.Focused.defineSubtype('area');

TP.html.area.Type.set('booleanAttrs', TP.ac('noHref'));

TP.html.area.Type.set('uriAttrs', TP.ac('href'));

TP.html.area.addTraits(TP.dom.EmptyElementNode);

TP.html.area.Type.resolveTraits(
        TP.ac('booleanAttrs', 'uriAttrs'),
        TP.html.area);

TP.html.area.Inst.resolveTraits(
        TP.ac('getContent', 'setContent'),
        TP.dom.EmptyElementNode);

//  ========================================================================
//  TP.html.map
//  ========================================================================

/**
 * @type {TP.html.map}
 * @summary 'map' tag. Client-side image map.
 */

//  ------------------------------------------------------------------------

//  ID is required in this subtype.
TP.html.Attrs.defineSubtype('map');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xhtml/html_EditModuleNodes.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'html';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.html.del
//  ========================================================================

/**
 * @type {TP.html.del}
 * @summary 'del' tag. Denotes deleted content.
 */

//  ------------------------------------------------------------------------

TP.html.Citation.defineSubtype('del');

TP.html.del.Type.set('uriAttrs', TP.ac('cite'));

//  ========================================================================
//  TP.html.ins
//  ========================================================================

/**
 * @type {TP.html.ins}
 * @summary 'ins' tag. Insertion tag.
 */

//  ------------------------------------------------------------------------

TP.html.Citation.defineSubtype('ins');

TP.html.ins.Type.set('uriAttrs', TP.ac('cite'));

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xhtml/html_FormsModuleNodes.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'html';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/* These node type have the following hierarchy

    - '*' indicates abstract supertype
    - (parens) indicate a trait

*   TP.html.Element
*       TP.html.Attrs
            TP.html.datalist
            TP.html.fieldset
            TP.html.form
            TP.html.keygen
            TP.html.label
            TP.html.option (TP.dom.SelectableItemUIElementNode)
            TP.html.optgroup
            TP.html.output
*           TP.html.Aligned
                TP.html.legend
*           TP.html.Focused
                TP.html.select (TP.dom.TogglingUIElementNode)
                TP.html.textarea (TP.html.textUtilities)
*               TP.html.input
                    TP.html.inputImage
                    TP.html.inputHidden
*                   TP.html.inputVisible
*                       TP.html.inputClickable
*                           TP.html.inputCheckable (TP.dom.TogglingUIElementNode)
                                TP.html.inputCheckbox
                                TP.html.inputRadio
                            TP.html.button
                            TP.html.inputButton
                            TP.html.inputColor
                            TP.html.inputDate
                            TP.html.inputDateTime
                            TP.html.inputDateTimeLocal
                            TP.html.inputMonth
                            TP.html.inputRange
                            TP.html.inputReset
                            TP.html.inputSubmit
                            TP.html.inputTime
                            TP.html.inputWeek
*                       TP.html.inputSelectable
                            TP.html.inputEmail (TP.html.textUtilities)
                            TP.html.inputFile
                            TP.html.inputNumber (TP.html.textUtilities)
                            TP.html.inputPassword (TP.html.textUtilities)
                            TP.html.inputSearch (TP.html.textUtilities)
                            TP.html.inputTel (TP.html.textUtilities)
                            TP.html.inputText (TP.html.textUtilities)
                            TP.html.inputUrl (TP.html.textUtilities)
*/

//  ========================================================================
//  TP.html.datalist (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.datalist}
 * @summary 'datalist' tag. Together with 'list' attribute for input can be
 *     used to make a combobox.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('datalist');

//  ========================================================================
//  TP.html.fieldset
//  ========================================================================

/**
 * @type {TP.html.fieldset}
 * @summary 'fieldset' tag. Group form fields.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('fieldset');

TP.html.fieldset.Type.set('booleanAttrs', TP.ac('disabled', 'willValidate'));

//  ========================================================================
//  TP.html.form
//  ========================================================================

/**
 * @type {TP.html.form}
 * @summary 'form' tag. An input form. The TP.html.form object acts as a group
 *     control for individual node component objects representing the form's
 *     items as well as a wrapper for the form operations themselves.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('form');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  Standard type transformations for element<-> node component type.

//  When a particular element is found, the type attribute is used as a
//  key into this hash to locate the TIBET type to use as a wrapper. A new
//  instance of that type is used so get() related calls always return a
//  properly wrapped dom element.
TP.html.form.Type.defineConstant('NODE_TYPE_NAMES',
    TP.hc('button', 'TP.html.inputButton',
            'image', 'TP.html.inputImage',
            'checkbox', 'TP.html.inputCheckbox',
            'color', 'TP.html.inputColor',
            'date', 'TP.html.inputDate',
            'datetime', 'TP.html.inputDateTime',
            'datetime-local', 'TP.html.inputDateTimeLocal',
            'email', 'TP.html.inputEmail',
            'file', 'TP.html.inputFile',
            'hidden', 'TP.html.inputHidden',
            'month', 'TP.html.inputMonth',
            'number', 'TP.html.inputNumber',
            'password', 'TP.html.inputPassword',
            'radio', 'TP.html.inputRadio',
            'range', 'TP.html.inputRange',
            'reset', 'TP.html.inputReset',
            'search', 'TP.html.inputSearch',
            'select-one', 'TP.html.select',
            'select-single', 'TP.html.select',
            'select-multiple', 'TP.html.select',
            'submit', 'TP.html.inputSubmit',
            'tel', 'TP.html.inputTel',
            'text', 'TP.html.inputText',
            'textarea', 'TP.html.textarea',
            'time', 'TP.html.inputTime',
            'url', 'TP.html.inputUrl',
            'week', 'TP.html.inputWeek'));

TP.html.form.Type.set('booleanAttrs', TP.ac('noValidate'));

TP.html.form.Type.set('uriAttrs', TP.ac('action'));

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.form.Type.defineMethod('getItemTagName',
function() {

    /**
     * @method getItemTagName
     * @summary Returns the 'default item tag name' for use it the
     *     fromArray()/fromObject() methods. Note that this should return the
     *     receiver's *canonical* name.
     * @returns {String} The item tag name.
     */

    return 'html:input';
});

//  ------------------------------------------------------------------------

TP.html.form.Type.defineMethod('shouldAutoWrapItems',
function(anObject, formatArgs) {

    /**
     * @method shouldAutoWrapItems
     * @summary Whether or not our fromArray() / fromObject() methods
     *     'auto-wrap items'. See those methods for more information.
     * @param {Object} anObject The Object of content to wrap in markup.
     * @param {TP.core.Hash} formatArgs An optional object containing
     *     parameters.
     * @returns {Boolean} Whether or not we automatically wrap items.
     */

    if (TP.isBoolean(formatArgs.at('autowrap'))) {
        return formatArgs.at('autowrap');
    }

    return false;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.form.Inst.defineMethod('getElementArray',
function() {

    /**
     * @method getElementArray
     * @summary Returns the Array of native elements. In the case of a form
     *     object this is the elements[] Array.
     * @returns {Element[]} The array of native items.
     */

    return TP.ac(this.getNativeNode().elements);
});

//  ------------------------------------------------------------------------

TP.html.form.Inst.defineMethod('getDisplayValue',
function() {

    /**
     * @method getDisplayValue
     * @summary Returns the value of the receiver. When targeting a form the
     *     returned value is the set of key/value pairs for each form control in
     *     the form.
     * @returns {TP.core.Hash} A hash containing keys and values which represent
     *     the overall value of the form.
     */

    var i,
        list,
        el,
        node,
        dict;

    node = this.getNativeNode();

    dict = TP.hc();
    list = node.elements;
    for (i = 0; i < list.length; i++) {
        el = TP.html.Element.construct(list[i]);
        if (TP.notValid(el)) {
            TP.ifWarn() ?
                TP.warn(TP.annotate(
                            TP.nodeCloneNode(list[i]),
                            'Unable to acquire wrapper.')) : 0;

            continue;
        }

        dict.atPut(el.getSubmitName(), el.getValue());
    }

    return dict;
});

//  ------------------------------------------------------------------------

TP.html.form.Inst.defineMethod('setDisplayValue',
function(aValue) {

    /**
     * @method setDisplayValue
     * @summary Sets the value of the receiver. When targeting a form the input
     *     is a set of key/value pairs containing the new data for the form
     *     controls.
     * @param {TP.core.Hash} aValue Hash containing key/value pairs where the
     *     keys need to map to ids or names in the form.
     * @returns {TP.html.form} The receiver.
     */

    var node,
        list,
        i,
        el;

    node = this.getNativeNode();

    if (!TP.isHash(aValue)) {
        return this.raise('TP.sig.InvalidParameter',
                            'Must provide a hash of key value pairs.');
    }

    list = node.elements;
    for (i = 0; i < list.length; i++) {
        el = TP.html.Element.construct(list[i]);
        if (TP.notValid(el)) {
            TP.ifWarn() ?
                TP.warn(TP.annotate(
                            TP.nodeCloneNode(list[i]),
                            'Unable to acquire wrapper.')) : 0;

            continue;
        }

        //  rely on the individual elements to do the real work
        el.setDisplayValue(aValue.at(el.getSubmitName()));
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.html.form.Inst.defineMethod('reset',
function() {

    /**
     * @method reset
     * @summary Resets the form. As a node component, however, this method
     *     provides the opportunity for custom reset pre/post processing.
     */

    var node;

    node = this.getNativeNode();

    //  TODO:   need to deal with bound element/form reset

    //  TODO:   capture potential lost data here?
    return node.reset();
});

//  ------------------------------------------------------------------------

TP.html.form.Inst.defineMethod('submit',
function() {

    /**
     * @method submit
     * @summary Submits the form. As a node component, however, this method
     *     provides the opportunity for custom submit pre/post processing.
     */

    var node;

    node = this.getNativeNode();

    //  TODO:   validation hook? parameters to control submit
    //          method/etc?
    return node.submit();
});

//  ========================================================================
//  TP.html.keygen (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.keygen}
 * @summary 'keygen' tag. Key pair generation.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('keygen');

TP.html.keygen.Type.set('booleanAttrs',
        TP.ac('autofocus', 'disabled', 'willValidate'));

//  ========================================================================
//  TP.html.label
//  ========================================================================

/**
 * @type {TP.html.label}
 * @summary 'label' tag.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('label');

//  ========================================================================
//  TP.html.optgroup
//  ========================================================================

/**
 * @type {TP.html.optgroup}
 * @summary 'optgroup' tag.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('optgroup');

TP.html.optgroup.Type.set('booleanAttrs', TP.ac('disabled'));

//  ========================================================================
//  TP.html.option
//  ========================================================================

/**
 * @type {TP.html.option}
 * @summary 'option' tag. A 'select' tag option. This type acts in the "item"
 *     role relative to an TP.html.Select object. Most methods of interest are
 *     on the TP.html.Select type.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('option');

TP.html.option.addTraits(TP.dom.SelectableItemUIElementNode);

TP.html.option.Type.set('booleanAttrs',
            TP.ac('disabled', 'defaultSelected', 'selected'));

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.option.Type.defineMethod('generateMarkup',
function(anObject, attrStr, itemFormat, shouldAutoWrap, formatArgs, theRequest) {

    /**
     * @method generateMarkup
     * @summary Generates markup for the supplied Object using the other
     *     parameters supplied.
     * @param {Object} anObject The Object of content to wrap in markup.
     * @param {String} attrStr The String containing either the literal
     *     attribute markup or a 'template invocation' that can be used inside
     *     of a template.
     * @param {String} itemFormat The name of an 'item format', either a tag
     *     name (which defaults to the 'item tag name' of this type) or some
     *     other format type which can be applied to this type.
     * @param {Boolean} shouldAutoWrap Whether or not the markup generation
     *     machinery should 'autowrap' items of the supplied object (each item
     *     in an Array or each key/value pair in an Object).
     * @param {TP.core.Hash} formatArgs The 'formatting arguments' used by this
     *     machinery to generate item markup.
     * @param {TP.sig.Request|TP.core.Hash} theRequest An optional object
     *     containing parameters.
     * @returns {String} The markup generated by taking the supplied Object and
     *     iterating over its items.
     */

    var tagName,
        template,
        str;

    tagName = this.getCanonicalName();

    //  Don't generate markup annotated with the data expression
    theRequest.atPut('annotateMarkup', false);

    if (TP.isFalse(shouldAutoWrap)) {
        if (TP.isTrue(theRequest.at('repeat'))) {
            if (TP.isArray(anObject)) {
                template = TP.join('<', tagName,
                                    attrStr, ' value="{{$INDEX}}">',
                                    '{{.%', itemFormat, '}}',
                                    '</', tagName, '>');
            } else {
                template = TP.join('<', tagName,
                                    attrStr, ' value="{{0}}">',
                                    '{{1.%', itemFormat, '}}',
                                    '</', tagName, '>');
            }

            //  Perform the transformation.
            str = template.transform(anObject, theRequest);

            return str;
        }
    } else {
        //  Otherwise, the object that will be handed to the iteration
        //  mechanism will be [key,value] pairs, so we can use that fact
        //  to generate item tags around each one.

        //  Build a template by joining the tag name with an invocation
        //  of the itemFormat for both the key and the value.
        template = TP.join('<', tagName,
                            attrStr, ' value="{{0}}">',
                            '{{1.%', itemFormat, '}}',
                            '</', tagName, '>');

        //  Perform the transformation.
        str = template.transform(anObject, theRequest);

        return str;
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.html.option.Type.defineMethod('shouldAutoWrapItems',
function(anObject, formatArgs) {

    /**
     * @method shouldAutoWrapItems
     * @summary Whether or not our fromArray() / fromObject() methods
     *     'auto-wrap items'. See those methods for more information.
     * @param {Object} anObject The Object of content to wrap in markup.
     * @param {TP.core.Hash} formatArgs An optional object containing
     *     parameters.
     * @returns {Boolean} Whether or not we automatically wrap items.
     */

    if (TP.isBoolean(formatArgs.at('autowrap'))) {
        return formatArgs.at('autowrap');
    }

    return false;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.option.Inst.defineMethod('getLabelText',
function() {

    /**
     * @method getLabelText
     * @summary Returns the text of the label of the receiver.
     * @returns {String} The receiver's label text.
     */

    return this.getTextContent();
});

//  ------------------------------------------------------------------------

TP.html.option.Inst.defineMethod('$getMarkupValue',
function() {

    /**
     * @method $getMarkupValue
     * @summary Returns the 'value' of the receiver as authored by user in the
     *     markup. Many times this is represented as a 'value' attribute in the
     *     markup and serves as the default.
     * @returns {String} The markup value of the receiver.
     */

    var elem,

        attrVal;

    elem = this.getNativeNode();

    //  If we have a real value in a 'value' attribute, then we return the value
    //  of the 'value' attribute.
    attrVal = TP.elementGetAttribute(elem, 'value', true);
    if (TP.notEmpty(attrVal)) {
        return attrVal;
    } else {
        //  We either didn't have a 'value' attribute or it was empty. The HTML
        //  spec says that we return our label text as our value.
        return this.getLabelText();
    }
});

//  ------------------------------------------------------------------------

TP.html.option.Inst.defineMethod('$getPrimitiveValue',
function() {

    /**
     * @method $getPrimitiveValue
     * @summary Returns the low-level primitive value stored by the receiver in
     *     internal storage.
     * @returns {String} The primitive value of the receiver.
     */

    var elem,

        attrVal;

    elem = this.getNativeNode();

    //  If we have a real value in a 'value' attribute, then we return the value
    //  of the '.value' property (they should be the same, but since this method
    //  guarantees the most primitive value, we return it).
    attrVal = TP.elementGetAttribute(elem, 'value', true);
    if (TP.notEmpty(attrVal)) {
        return elem.value;
    } else {
        //  We either didn't have a 'value' attribute or it was empty. The HTML
        //  spec says that we return our label text as our value.
        return this.getLabelText();
    }
});

//  ------------------------------------------------------------------------

TP.html.option.Inst.defineMethod('$getVisualToggle',
function() {

    /**
     * @method $getVisualToggle
     * @summary Returns the low-level primitive 'toggle value' used by the
     *     receiver to display a 'selected' state.
     * @returns {Boolean} The low-level primitive 'toggle value' of the
     *     receiver.
     */

    return this.getNativeNode().selected;
});

//  ------------------------------------------------------------------------

TP.html.option.Inst.defineMethod('isSelected',
function() {

    /**
     * @method isSelected
     * @summary Returns true if the receiver is selected.
     * @returns {Boolean} Whether or not the receiver is selected.
     */

    return this.getNativeNode().selected;
});

//  ------------------------------------------------------------------------

TP.html.option.Inst.defineMethod('on',
function() {

    /**
     * @method on
     * @summary Sets the receiver's selected state to 'true'.
     * @returns {TP.html.option} The receiver.
     */

    this.getNativeNode().selected = true;

    return this;
});

//  ------------------------------------------------------------------------

TP.html.option.Inst.defineMethod('off',
function() {

    /**
     * @method off
     * @summary Sets the receiver's selected state to 'false'.
     * @returns {TP.html.option} The receiver.
     */

    this.getNativeNode().selected = false;

    return this;
});

//  ------------------------------------------------------------------------

TP.html.option.Inst.defineMethod('$setVisualToggle',
function(aToggleValue) {

    /**
     * @method $setVisualToggle
     * @summary Sets the low-level primitive 'toggle value' used by the receiver
     *     to display a 'selected' state.
     * @param {Boolean} aToggleValue Whether or not to display the receiver's
     *     'selected' state.
     * @returns {TP.html.option} The receiver.
     */

    this.getNativeNode().selected = aToggleValue;

    return this;
});

//  ========================================================================
//  TP.html.output (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.output}
 * @summary 'output' tag. Some form of output.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('output');

TP.html.output.Type.set('booleanAttrs', TP.ac('willValidate'));

//  ========================================================================
//  TP.html.textUtilities
//  ========================================================================

/**
 * @type {TP.html.textUtilities}
 * @summary A utility type that is mixed into elements that can manipulate
 *     their text value.
 */

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.defineSubtype('html.textUtilities');

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation
TP.html.textUtilities.isAbstract(true);

TP.html.textUtilities.addTraits(TP.html.Element);

TP.html.textUtilities.Type.resolveTrait('booleanAttrs', TP.html.Element);

TP.html.textUtilities.Inst.resolveTraits(
        TP.ac('getDisplayValue', 'setDisplayValue'),
        TP.html.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  Tag Phase Support
//  ------------------------------------------------------------------------

TP.html.textUtilities.Type.defineMethod('tagResolve',
function(aRequest) {

    /**
     * @method tagResolve
     * @summary Resolves the receiver's content. This includes resolving XML
     *     Base URIs and virtual URIs that may occur on the receiver's
     *     attributes.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var elem;

    //  Make sure that we have a node to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        return;
    }

    //  Set the attribute to not trap dragging in the TIBET D&D system, but
    //  allow targets of this type to do their natural drag operation (which, in
    //  this case, is selecting text).
    TP.elementSetAttribute(elem, 'tibet:no-dragtrap', 'true', true);

    return;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.textUtilities.Inst.defineMethod('clearValue',
function() {

    /**
     * @method clearValue
     * @summary Clears the entire value of the receiver.
     * @returns {TP.html.textUtilities} The receiver.
     */

    var node,

        oldVal;

    node = this.getNativeNode();

    oldVal = node.value;
    node.value = '';

    this.changed('value', TP.DELETE,
                        TP.hc(TP.OLDVAL, oldVal, TP.NEWVAL, ''));

    return this;
});

//  ------------------------------------------------------------------------

TP.html.textUtilities.Inst.defineMethod('clearSelection',
function() {

    /**
     * @method clearSelection
     * @summary Clears the currently selected text.
     * @returns {TP.html.textUtilities} The receiver.
     */

    var oldVal;

    oldVal = this.getSelection();

    TP.textElementReplaceSelection(this.getNativeNode(), '');

    this.changed('selection', TP.DELETE,
                        TP.hc(TP.OLDVAL, oldVal, TP.NEWVAL, ''));

    return this;
});

//  ------------------------------------------------------------------------

TP.html.textUtilities.Inst.defineMethod('collapseSelection',
function(toStart) {

    /**
     * @method collapseSelection
     * @summary Collapse the current selection to one end or the other.
     * @param {Boolean} toStart Whether or not to collapse the selection to the
     *     start of itself. This defaults to false (i.e. the selection will
     *     collapse to the end).
     * @returns {TP.html.textUtilities} The receiver.
     */

    var node;

    node = this.getNativeNode();

    if (toStart) {
        node.setSelectionRange(node.selectionStart, node.selectionStart);
    } else {
        node.setSelectionRange(node.selectionEnd, node.selectionEnd);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.html.textUtilities.Inst.defineMethod('getSelection',
function() {

    /**
     * @method getSelection
     * @summary Returns the currently selected text.
     * @returns {String} The currently selected text.
     */

    var node;

    node = this.getNativeNode();

    return node.value.substring(node.selectionStart, node.selectionEnd);
});

//  ------------------------------------------------------------------------

TP.html.textUtilities.Inst.defineMethod('getSelectionEnd',
function() {

    /**
     * @method getSelectionEnd
     * @summary Returns the ending index of the currently selected text.
     * @returns {Number} The ending index of the current selection.
     */

    return this.getNativeNode().selectionEnd;
});

//  ------------------------------------------------------------------------

TP.html.textUtilities.Inst.defineMethod('getSelectionStart',
function() {

    /**
     * @method getSelectionStart
     * @summary Returns the starting index of the currently selected text.
     * @returns {Number} The starting index of the current selection.
     */

    return this.getNativeNode().selectionStart;
});

//  ------------------------------------------------------------------------

TP.html.textUtilities.Inst.defineMethod('getValue',
function() {

    /**
     * @method getValue
     * @summary Returns the value of the receiver. For a UI element this method
     *     will ensure any storage formatters are invoked.
     * @returns {String} The value in string form.
     */

    var value,

        type,
        formats;

    value = this.getDisplayValue();

    //  If the receiver has a 'ui:type' attribute, then try first to convert the
    //  content to that type before trying to format it.
    if (TP.notEmpty(type = this.getAttribute('ui:type'))) {
        if (!TP.isType(type = TP.sys.getTypeByName(type))) {
            return this.raise('TP.sig.InvalidType');
        } else {
            value = type.fromString(value);
        }
    }

    //  If the receiver has a 'ui:storage' attribute, then format the return
    //  value according to the formats found there.
    if (TP.notEmpty(formats = this.getAttribute('ui:storage'))) {
        value = this.$formatValue(value, formats);
    }

    return value;
});

//  ------------------------------------------------------------------------

TP.html.textUtilities.Inst.defineMethod('insertAfterSelection',
function(aText) {

    /**
     * @method insertAfterSelection
     * @summary Inserts the supplied text after the current selection.
     * @param {String} aText The text to insert after the current selection.
     * @returns {TP.html.textUtilities} The receiver.
     */

    var oldVal,
        newVal;

    oldVal = this.getSelection();

    this.replaceSelection(TP.join(oldVal, aText));

    newVal = this.getSelection();

    this.changed('selection', TP.INSERT,
                        TP.hc(TP.OLDVAL, oldVal, TP.NEWVAL, newVal));

    return this;
});

//  ------------------------------------------------------------------------

TP.html.textUtilities.Inst.defineMethod('insertBeforeSelection',
function(aText) {

    /**
     * @method insertBeforeSelection
     * @summary Inserts the supplied text before the current selection.
     * @param {String} aText The text to insert before the current selection.
     * @returns {TP.html.textUtilities} The receiver.
     */

    var oldVal,
        newVal;

    oldVal = this.getSelection();

    this.replaceSelection(TP.join(aText, oldVal));

    newVal = this.getSelection();

    this.changed('selection', TP.INSERT,
                        TP.hc(TP.OLDVAL, oldVal, TP.NEWVAL, newVal));

    return this;
});

//  ------------------------------------------------------------------------

TP.html.textUtilities.Inst.defineMethod('produceValue',
function(aspectName, aContentObject, aRequest) {

    /**
     * @method produceValue
     * @summary Produces the value that will be used by the setValue() method
     *     to set the content of the receiver.
     * @description This method works together with the 'isSingleValued()' and
     *     'isScalarValued()' methods to produce the proper value for the
     *     receiver. See the method description for isScalarValued() for more
     *     information.
     * @param {String} aspectName The aspect name on the receiver that the value
     *     is being produced for. Many times, this is 'value'.
     * @param {Object} aContentObject An object to use for content.
     * @param {TP.sig.Request} aRequest A request containing control parameters.
     */

    //  If the content that we're trying to compute a value from is not valid,
    //  then we return the empty String. That way, we don't end up with a bunch
    //  of controls that have the word 'undefined' as their value.
    if (TP.notValid(aContentObject)) {
        return '';
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.html.textUtilities.Inst.defineMethod('replaceSelection',
function(aText) {

    /**
     * @method replaceSelection
     * @summary Replaces the current selection with the supplied text.
     * @param {String} aText The text to replace the current selection with.
     * @returns {TP.html.textUtilities} The receiver.
     */

    var node,

        oldVal,
        newVal;

    node = this.getNativeNode();

    oldVal = this.getSelection();

    TP.textElementReplaceSelection(node, aText);

    newVal = this.getSelection();

    this.changed('selection', TP.UPDATE,
                        TP.hc(TP.OLDVAL, oldVal, TP.NEWVAL, newVal));

    return this;
});

//  ------------------------------------------------------------------------

TP.html.textUtilities.Inst.defineMethod('selectFromTo',
function(aStartIndex, anEndIndex) {

    /**
     * @method selectFromTo
     * @summary Selects the contents of the receiver from the supplied starting
     *     index to the supplied ending index.
     * @param {Number} aStartIndex The starting index.
     * @param {Number} aEndIndex The ending index.
     * @returns {TP.html.textUtilities} The receiver.
     */

    var node;

    node = this.getNativeNode();

    node.setSelectionRange(aStartIndex, anEndIndex);

    return this;
});

//  ------------------------------------------------------------------------

TP.html.textUtilities.Inst.defineMethod('setCursorPosition',
function(aPosition) {

    /**
     * @method setCursorPosition
     * @summary Sets the cursor to the supplied position.
     * @param {Number} aPosition The desired cursor position.
     * @returns {TP.html.textUtilities} The receiver.
     */

    var node;

    node = this.getNativeNode();

    try {
        node.focus();
    } catch (e) {
        TP.ifError() ?
            TP.error(
                TP.ec(e,
                    'Error focusing element when setting cursor position.')) :
                    0;
    }

    //  According to the spec, the end index is one character *after* the
    //  intended selection.
    node.setSelectionRange(aPosition, aPosition + 1);

    return this;
});

//  ------------------------------------------------------------------------

TP.html.textUtilities.Inst.defineMethod('setCursorToEnd',
function() {

    /**
     * @method setCursorToEnd
     * @summary Sets the cursor to the end position of the receiver.
     * @returns {TP.html.textUtilities} The receiver.
     */

    try {
        this.getNativeNode().focus();
    } catch (e) {
        TP.ifError() ?
            TP.error(
                TP.ec(e,
                    'Error focusing element when setting cursor to end.')) : 0;
    }

    TP.documentCollapseSelection(this.getNativeDocument());

    return this;
});

//  ------------------------------------------------------------------------

TP.html.textUtilities.Inst.defineMethod('setCursorToStart',
function() {

    /**
     * @method setCursorToStart
     * @summary Sets the cursor to the start position of the receiver.
     * @returns {TP.html.textUtilities} The receiver.
     */

    try {
        this.getNativeNode().focus();
    } catch (e) {
        TP.ifError() ?
            TP.error(
                TP.ec(e,
                    'Error focusing element when setting cursor to start.')) :
                    0;
    }

    TP.documentCollapseSelection(this.getNativeDocument(), true);

    return this;
});

//  ------------------------------------------------------------------------

TP.html.textUtilities.Inst.defineMethod('setValue',
function(aValue, shouldSignal) {

    /**
     * @method setValue
     * @summary Sets the value of the receiver's node. For a UI element this
     *     method will ensure any display formatters are invoked. NOTE that this
     *     method does not update the receiver's bound value if it's a bound
     *     control. In fact, this method is used in response to a change in the
     *     bound value to update the display value, so this method should avoid
     *     changes to the bound value to avoid recursions.
     * @param {Object} aValue The value to set the 'value' of the node to.
     * @param {Boolean} shouldSignal Should changes be notified. If false
     *     changes are not signaled. Defaults to this.shouldSignalChange().
     * @returns {Boolean} Whether or not the value was changed from the value it
     *     had before this method was called.
     */

    var oldValue,
        newValue,

        displayValue,

        flag;

    oldValue = this.getValue();

    newValue = this.produceValue('value', aValue);

    //  If the values are equal, there's nothing to do here - bail out.
    if (TP.equal(TP.str(oldValue), TP.str(newValue))) {
        return false;
    }

    this.setDisplayValue(newValue);

    if (shouldSignal === false) {
        return true;
    }

    //  signal as needed

    displayValue = this.getDisplayValue();

    //  Sometimes the display value computed from the new value can be equal to
    //  the old value. If that's *not* the case, then propagate the change
    //  signal.
    if (!TP.equal(oldValue, displayValue)) {
        //  NB: Use this construct this way for better performance
        if (TP.notValid(flag = shouldSignal)) {
            flag = this.shouldSignalChange();
        }

        if (flag) {
            this.$changed('value', TP.UPDATE,
                            TP.hc(TP.OLDVAL, oldValue, TP.NEWVAL, newValue));
        }

        //  If the element is bound, then update its bound value.
        this.setBoundValueIfBound(this.getValue());
    }

    return true;
});

//  ------------------------------------------------------------------------

TP.html.textUtilities.Inst.defineMethod('setSelection',
function(aText) {

    /**
     * @method setSelection
     * @summary Sets the current selection to the supplied text.
     * @param {String} aText The text to set the selection to.
     * @returns {TP.html.textUtilities} The receiver.
     */

    //  This method is just an alias for replaceSelection().
    this.replaceSelection(aText);

    return this;
});

//  ------------------------------------------------------------------------

TP.html.textUtilities.Inst.defineMethod('wrapSelection',
function(beforeText, afterText) {

    /**
     * @method wrapSelection
     * @summary Wraps the current selection with the beforeText and afterText.
     * @param {String} beforeText The text to insert before the selection.
     * @param {String} afterText The text to insert after the selection.
     * @returns {TP.html.textUtilities} The receiver.
     */

    return this.replaceSelection(TP.join(beforeText,
                                            this.getSelection(),
                                            afterText));
});

//  ========================================================================
//  TP.html.input
//  ========================================================================

/**
 * @type {TP.html.input}
 * @summary INPUT tag. Generic input control.
 * @description NOTE: for TIBET's purposes this particular node type serves as
 *     an abstract supertype from which a number of specialized types descend to
 *     allow custom behavior to be inherited.
 *
 *     Also note that while the actual xhtml DTD doesn't specify intermediate
 *     types we do so here to help maximize reuse. That means we've created
 *     several custom elements such as TP.html.inputClickable or
 *     TP.html.inputCheckable from which the various input subtypes inherit.
 */

//  ------------------------------------------------------------------------

TP.html.Focused.defineSubtype('input');

//  can't construct concrete instances of this
TP.html.input.isAbstract(true);

TP.html.input.addTraits(TP.dom.EmptyElementNode);

TP.html.input.Type.resolveTraits(
        TP.ac('bidiAttrs', 'booleanAttrs', 'uriAttrs'),
        TP.html.input);

TP.html.input.Inst.resolveTraits(
        TP.ac('getContent', 'setContent'),
        TP.dom.EmptyElementNode);

TP.html.input.Type.set('bidiAttrs', TP.ac('value'));

TP.html.input.Type.set('booleanAttrs',
        TP.ac('autofocus', 'defaultChecked', 'checked', 'disabled',
                'formNoValidate', 'indeterminate', 'multiple',
                'readOnly', 'required', 'willValidate'));

TP.html.input.Type.set('uriAttrs', TP.ac('src', 'usemap'));

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.input.Type.defineMethod('fromArray',
function(anObject, aRequest) {

    /**
     * @method fromArray
     * @summary Returns a formatted XML String with the supplied Boolean object
     *     as the content.
     * @param {Boolean} anObject The Object to wrap in the elements.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An optional object
     *     containing parameters.
     * @returns {String} The content formatted as markup.
     */

    return anObject.as('TP.html.select', aRequest);
});

//  ------------------------------------------------------------------------

TP.html.input.Type.defineMethod('fromBoolean',
function(anObject, aRequest) {

    /**
     * @method fromBoolean
     * @summary Returns a formatted XML String with the supplied Boolean object
     *     as the content.
     * @param {Boolean} anObject The Object to wrap in the elements.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An optional object
     *     containing parameters.
     * @returns {String} The content formatted as markup.
     */

    var val,
        fieldNum;

    val = TP.str(anObject);

    fieldNum = aRequest.at('$INDEX');
    if (TP.notValid(fieldNum)) {
        fieldNum = TP.genID().slice(10);
    }

    return TP.join('<html:input id="field_',
                    fieldNum,
                    '" type="checkbox" value="', val, '"/>');
});

//  ------------------------------------------------------------------------

TP.html.input.Type.defineMethod('fromDate',
function(anObject, aRequest) {

    /**
     * @method fromDate
     * @summary Returns a formatted XML String with the supplied Date object as
     *     the content.
     * @description The supplied request can contain the following keys and
     *     values that are used in this method:
     *
     *     'escapeContent' Boolean Whether or not to 'escape' the content (i.e.
     *     if it has embedded markup). This defaults to false.
     * @param {Boolean} anObject The Object to wrap in the elements.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An optional object
     *     containing parameters.
     * @returns {String} The content formatted as markup.
     */

    var val,
        fieldNum;

    if (TP.isTrue(aRequest.at('escapeContent'))) {
        val = TP.xmlLiteralsToEntities(TP.str(anObject));
    } else {
        val = TP.str(anObject);
    }

    fieldNum = aRequest.at('$INDEX');
    if (TP.notValid(fieldNum)) {
        fieldNum = TP.genID().slice(10);
    }

    return TP.join('<html:input id="field_', fieldNum,
                    '" type="text" value="', val, '"/>');
});

//  ------------------------------------------------------------------------

TP.html.input.Type.defineMethod('fromNumber',
function(anObject, aRequest) {

    /**
     * @method fromNumber
     * @summary Returns a formatted XML String with the supplied Number object
     *     as the content.
     * @param {Boolean} anObject The Object to wrap in the elements.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An optional object
     *     containing parameters.
     * @returns {String} The content formatted as markup.
     */

    var val,
        fieldNum;

    if (TP.isTrue(aRequest.at('escapeContent'))) {
        val = TP.xmlLiteralsToEntities(TP.str(anObject));
    } else {
        val = TP.str(anObject);
    }

    fieldNum = aRequest.at('$INDEX');
    if (TP.notValid(fieldNum)) {
        fieldNum = TP.genID().slice(10);
    }

    return TP.join('<html:input id="field_', fieldNum,
                    '" type="text" value="', val, '"/>');
});

//  ------------------------------------------------------------------------

TP.html.input.Type.defineMethod('fromString',
function(anObject, aRequest) {

    /**
     * @method fromString
     * @summary Returns a formatted XML String with the supplied String object
     *     as the content.
     * @description The supplied request can contain the following keys and
     *     values that are used in this method:
     *
     *     'escapeContent' Boolean Whether or not to 'escape' the content (i.e.
     *     if it has embedded markup). This defaults to false.
     * @param {Boolean} anObject The Object to wrap in the elements.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An optional object
     *     containing parameters.
     * @returns {String} The content formatted as markup.
     */

    var val,
        fieldNum;

    if (TP.isTrue(aRequest.at('escapeContent'))) {
        val = TP.xmlLiteralsToEntities(
                        TP.htmlEntitiesToXMLEntities(TP.str(anObject)));
    } else {
        val = TP.str(anObject);
    }

    fieldNum = aRequest.at('$INDEX');
    if (TP.notValid(fieldNum)) {
        fieldNum = TP.genID().slice(10);
    }

    return TP.join('<html:input id="field_', fieldNum,
                    '" type="text" value="', val, '"/>');
});

//  ------------------------------------------------------------------------

TP.html.input.Type.defineMethod('generateMarkup',
function(anObject, attrStr, itemFormat, shouldAutoWrap, formatArgs, theRequest) {

    /**
     * @method generateMarkup
     * @summary Generates markup for the supplied Object using the other
     *     parameters supplied.
     * @param {Object} anObject The Object of content to wrap in markup.
     * @param {String} attrStr The String containing either the literal
     *     attribute markup or a 'template invocation' that can be used inside
     *     of a template.
     * @param {String} itemFormat The name of an 'item format', either a tag
     *     name (which defaults to the 'item tag name' of this type) or some
     *     other format type which can be applied to this type.
     * @param {Boolean} shouldAutoWrap Whether or not the markup generation
     *     machinery should 'autowrap' items of the supplied object (each item
     *     in an Array or each key/value pair in an Object).
     * @param {TP.core.Hash} formatArgs The 'formatting arguments' used by this
     *     machinery to generate item markup.
     * @param {TP.sig.Request|TP.core.Hash} theRequest An optional object
     *     containing parameters.
     * @returns {String} The markup generated by taking the supplied Object and
     *     iterating over its items.
     */

    var template,
        str;

    //  Don't generate markup annotated with the data expression
    theRequest.atPut('annotateMarkup', false);

    //  We use the abstract 'TP.html.input' type here for 'item formatting'.
    //  It will taste the object its receiving and return the 'correct
    //  default markup' based on that.

    if (TP.isArray(anObject)) {
        template = TP.join(
                    '<html:label for="field_{{$INDEX}}">',
                    'Field #{{$INDEX}}:',
                    '</html:label>',
                    '{{.%TP.html.input}}');
    } else {
        //  Otherwise, the object that will be handed to the iteration
        //  mechanism will be [key,value] pairs, so we can use that fact
        //  to generate item tags around each one.
        template = TP.join(
                    '<html:label for="field_{{$INDEX}}">',
                    '{{0}}:',
                    '</html:label>',
                    '{{1.%TP.html.input}}');
    }

    //  Perform the transformation.
    str = template.transform(anObject, theRequest);

    return str;
});

//  ------------------------------------------------------------------------

TP.html.input.Type.defineMethod('generateMarkupContent',
function(attrStr, wantsXMLNS, targetDefaultNS) {

    /**
     * @method generateMarkupContent
     * @summary Generates the 'empty markup' representation of the receiver.
     * @description The empty representation contains child node content, but
     *     does contain the proper 'xmlns' attribute so that the receiver can be
     *     properly placed in any document that has that namespace defined. It
     *     can also contain any optionally supplied attribute content.
     * @param {String} [attrStr] The String containing optional attribute
     *     markup.
     * @param {Boolean} [wantsXMLNS=true] Whether or not the caller wants an
     *     'xmlns:' namespace definition generated into the result.
     * @param {String} [targetDefaultNS] The default NS of the target
     *     environment that the markup String will be inserted into.
     * @returns {String} The 'empty markup' representation of the receiver.
     */

    var attrMarkup,

        typeAttrValue,

        ourNSURI,

        str;

    if (TP.notEmpty(attrStr)) {
        attrMarkup = ' ' + TP.trim(attrStr);
    } else {
        attrMarkup = '';
    }

    //  For (X)HTML 'input' elements, we don't use the local name - that's
    //  always 'input' - but we do qualify by using a 'type="..."' attribute.
    typeAttrValue = this.getTypeAttributeValue();
    if (TP.notValid(typeAttrValue)) {
        typeAttrValue = 'text';
    }

    attrMarkup = ' type="' + typeAttrValue + '"' + attrMarkup;

    //  Grab our namespace URI. We'll use this to compare against the default
    //  namespace that the markup we generate is being placed into.
    ourNSURI = this.getNSURI();

    //  If the caller wants an 'xmlns' generated into the markup.
    if (TP.notFalse(wantsXMLNS)) {
        //  If we got passed a target default namespace and its the same as our
        //  own namespace, then just generate an unprefixed tag name and a
        //  default 'xmlns' definition
        if (TP.notEmpty(targetDefaultNS) && ourNSURI === targetDefaultNS) {
            str = TP.join('<',
                        'input',
                        ' xmlns',
                        '="',
                        ourNSURI +
                        '"' +
                        attrMarkup +
                        '/>');
        } else {
            //  Otherwise, generate a prefixed tag name and a prefixed 'xmlns:'
            //  definition to match.
            str = TP.join('<',
                        this.getNamespacePrefix(),
                        ':',
                        'input',
                        ' xmlns:', this.getNamespacePrefix(),
                        '="',
                        TP.w3.Xmlns.getNSURIForPrefix(this.getNamespacePrefix()),
                        '"' +
                        attrMarkup +
                        '/>');
        }
    } else {
        //  Otherwise, the caller did not want an 'xmlns' generated into the
        //  markup.

        //  If we got passed a target default namespace and its the same as our
        //  own namespace, then just generate an unprefixed tag name.
        if (TP.notEmpty(targetDefaultNS) && ourNSURI === targetDefaultNS) {
            str = TP.join('<',
                        'input',
                        attrMarkup +
                        '/>');
        } else {
            //  Otherwise, generate a prefixed tag name.
            str = TP.join('<',
                        this.getNamespacePrefix(),
                        ':',
                        'input',
                        attrMarkup +
                        '/>');
        }
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.html.input.Type.defineMethod('getConcreteType',
function(aNodeOrId) {

    /**
     * @method getConcreteType
     * @summary Returns the subtype to use for the node provided. Note that for
     *     TP.html.input elements the specific type returned is based on the
     *     value of the type attribute.
     * @param {Node|String} aNodeOrId The native node to wrap or an ID used to
     *     locate it.
     * @returns {TP.meta.html.input} A TP.html.input subtype type object.
     */

    var inputType,
        typeName,
        type;

    if (TP.isString(aNodeOrId)) {
        return TP.byId(aNodeOrId);
    }

    //  Default the inputType to 'text' if its not present, which is what
    //  most browsers do (i.e. if the author leaves of 'type="..."')
    if (TP.isEmpty(inputType = TP.elementGetAttribute(aNodeOrId, 'type'))) {
        inputType = 'text';
    }

    //  TP.html.form contains a map of the native element 'types'
    //  to node component types for those various types.
    typeName = TP.html.form.NODE_TYPE_NAMES.at(inputType);

    type = TP.sys.getTypeByName(typeName);
    if (TP.isType(type) && !type.isAbstract()) {
        return type;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.html.input.Type.defineMethod('getLocalName',
function() {

    /**
     * @method getLocalName
     * @summary Returns the local (aka short) name of the receiver without any
     *     namespace prefix.
     * @returns {String} The receiver's local name.
     */

    return 'input';
});

//  ------------------------------------------------------------------------

TP.html.input.Type.defineMethod('getTypeAttributeValue',
function() {

    /**
     * @method getTypeAttributeValue
     * @summary Returns the value of the 'type' attribute for the receiver.
     * @description (X)HTML 'input' tags all use the same tag name with
     *     different values for the 'type' attribute (i.e. 'text', 'color',
     *     etc). This method returns the value of the 'type' attribute based on
     *     the receiving tag type..
     * @returns {String|null} The value of the 'type' attribute.
     */

    var ourTypeName,
        entry;

    //  Compute the 'type' attribute from the hash of type attribute values to
    //  type names.
    ourTypeName = this.getName();
    entry = TP.html.form.NODE_TYPE_NAMES.detect(
                function(kvPair) {
                    return kvPair.last() === ourTypeName;
                });

    //  If we got a valid value, return the key - this will be the value of the
    //  'type' attribute.
    if (TP.isValid(entry)) {
        return entry.first();
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.html.input.Type.defineMethod('shouldAutoWrapItems',
function(anObject, formatArgs) {

    /**
     * @method shouldAutoWrapItems
     * @summary Whether or not our fromArray() / fromObject() methods
     *     'auto-wrap items'. See those methods for more information.
     * @param {Object} anObject The Object of content to wrap in markup.
     * @param {TP.core.Hash} formatArgs An optional object containing
     *     parameters.
     * @returns {Boolean} Whether or not we automatically wrap items.
     */

    if (TP.isBoolean(formatArgs.at('autowrap'))) {
        return formatArgs.at('autowrap');
    }

    return false;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.input.Inst.defineMethod('isSingleValued',
function(aspectName) {

    /**
     * @method isSingleValued
     * @summary Returns true if the receiver deals with single values.
     * @description See the TP.dom.Node's 'isScalarValued()' instance method
     *     for more information.
     * @param {String} [aspectName] An optional aspect name that is being used
     *     by the caller to determine whether the receiver is single valued for.
     * @returns {Boolean} For input types, this returns true.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.html.input.Inst.defineMethod('isScalarValued',
function(aspectName) {

    /**
     * @method isScalarValued
     * @summary Returns true if the receiver deals with scalar values.
     * @description See the TP.dom.Node's 'isScalarValued()' instance method
     *     for more information.
     * @param {String} [aspectName] An optional aspect name that is being used
     *     by the caller to determine whether the receiver is scalar valued for.
     * @returns {Boolean} For input types, this returns true.
     */

    return true;
});

//  ========================================================================
//  TP.html.inputVisible
//  ========================================================================

/**
 * @type {TP.html.inputVisible}
 * @summary Common functionality for those input nodes which have a visible
 *     representation.
 */

//  ------------------------------------------------------------------------

//  visible ones
TP.html.input.defineSubtype('inputVisible');

//  can't construct concrete instances of this
TP.html.inputVisible.isAbstract(true);

//  ========================================================================
//  TP.html.inputClickable
//  ========================================================================

/**
 * @type {TP.html.inputClickable}
 * @summary Common supertype for nodes that can be clicked with the mouse. This
 *     includes buttons, checkboxes, radio items, etc.
 */

//  ------------------------------------------------------------------------

//  buttons
TP.html.inputVisible.defineSubtype('inputClickable');

//  can't construct concrete instances of this
TP.html.inputClickable.isAbstract(true);

TP.backstop(TP.ac('click'), TP.html.inputClickable.getInstPrototype());

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.inputClickable.Inst.defineMethod('disable',
function() {

    /**
     * @method disable
     * @summary Disables the control using the standard disabled attribute.
     * @returns {TP.html.inputClickable} The receiver.
     */

    this.setAttribute('disabled', 'true');

    return this;
});

//  ------------------------------------------------------------------------

TP.html.inputClickable.Inst.defineMethod('enable',
function() {

    /**
     * @method enable
     * @summary Enables the control by removing any disabled attribute.
     * @returns {TP.html.inputClickable} The receiver.
     */

    this.removeAttribute('disabled');

    return this;
});

//  ========================================================================
//  TP.html.inputCheckable
//  ========================================================================

/**
 * @type {TP.html.inputCheckable}
 * @summary Represents input nodes that can be 'checked' in some form. This
 *     includes checkboxes and radio items.
 */

//  ------------------------------------------------------------------------

//  check boxes / radio buttons
TP.html.inputClickable.defineSubtype('inputCheckable');
TP.html.inputCheckable.addTraits(TP.dom.TogglingUIElementNode);

TP.html.inputCheckable.Inst.resolveTraits(
        TP.ac('getDisplayValue', 'setDisplayValue', 'isScalarValued'),
        TP.dom.TogglingUIElementNode);

//  can't construct concrete instances of this
TP.html.inputCheckable.isAbstract(true);

TP.html.inputCheckable.Type.set('bidiAttrs', TP.ac('checked'));

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.inputCheckable.Type.defineMethod('onclick',
function(aTargetElem, anEvent) {

    /**
     * @method onclick
     * @param {HTMLElement} aTargetElem The target element computed for this
     *     signal.
     * @param {Event} anEvent The native event that was triggered.
     * @returns {TP.html.inputCheckable} The receiver.
     */

    var tpElem,

        valueTPElems,

        len,
        i,

        item,
        bindAttrNodes,

        elem,

        bindInfoTPElem,

        val,

        attrName;

    tpElem = TP.wrap(aTargetElem);

    //  If the element is bound, then update its bound value.
    if (tpElem.isBoundElement()) {

        //  Since a checkable can have 1...n 'value elements', any one of them
        //  can have the binding information we need. Look for the first one
        //  that does.

        if (TP.notValid(valueTPElems = tpElem.getValueElements())) {
            return this.raise('TP.sig.InvalidValueElements');
        }

        len = valueTPElems.getSize();
        for (i = 0; i < len; i++) {

            item = valueTPElems.at(i);

            //  We look for either 'in', 'out', 'io' here to determine if the
            //  receiver is bound.
            bindAttrNodes = TP.elementGetAttributeNodesInNS(
                                item.getNativeNode(),
                                /.*:(in|out|io)/,
                                TP.w3.Xmlns.BIND);

            //  If we found binding attribute nodes, then this is the value
            //  element we're looking for. Capture it and exit.
            if (TP.notEmpty(bindAttrNodes)) {
                bindInfoTPElem = item;

                //  NB: 'bind:in' doesn't matter here - that goes 'in', these go
                //  'out'.

                elem = item.getNativeNode();
                if (TP.elementHasAttribute(elem, 'bind:io', true)) {
                    attrName = 'bind:io';
                } else if (TP.elementHasAttribute(elem, 'bind:out', true)) {
                    attrName = 'bind:out';
                }

                break;
            }
        }

        if (TP.notValid(bindInfoTPElem)) {
            return this.raise('TP.sig.InvalidBinding',
                                'Couldn\'t find binding info for: ' +
                                TP.str(tpElem));
        }

        val = tpElem.getDisplayValue();

        //  If the wrapped element doesn't allow multiple values, make sure to
        //  collapse it down.
        if (!tpElem.allowsMultiples()) {
            val = TP.collapse(val);
        }

        //  Set our bound value, but using the binding information found on one
        //  of our 'value elements' (which might be the targeted element, but
        //  might not be).
        tpElem.setBoundAspect(
                        attrName,
                        'checked',
                        val,
                        bindInfoTPElem.getBindingScopeValues(),
                        bindInfoTPElem.getAttribute('bind:io'));
    }

    if (TP.isValid(tpElem)) {
        tpElem.changed('value', TP.UPDATE);
    }

    return this;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.inputCheckable.Inst.defineMethod('getLabelText',
function() {

    /**
     * @method getLabelText
     * @summary Returns the text of the label of the receiver.
     * @returns {String} The receiver's label text.
     */

    var val,
        labelElem;

    val = '';

    if (TP.isElement(
        labelElem = TP.byCSSPath('label[for="' + this.getLocalID() + '"]',
                                    this.getNativeDocument(),
                                    true,
                                    false))) {

        val = TP.nodeGetTextContent(labelElem);
    }

    return val;
});

//  ------------------------------------------------------------------------

TP.html.inputCheckable.Inst.defineMethod('getValueElements',
function() {

    /**
     * @method getValueElements
     * @summary Returns an Array TP.dom.UIElementNodes that share a common
     *     'value object' with the receiver. That is, a change to the 'value' of
     *     the receiver will also change the value of one of these other
     *     TP.dom.UIElementNodes.
     * @returns {TP.dom.UIElementNode[]} The Array of shared value items.
     */

    var elem,

        name,
        results;

    //  If we don't have a 'name' attribute, at least return an Array with 1
    //  item - ourself
    elem = this.getNativeNode();

    if (TP.isEmpty(name = TP.elementGetAttribute(elem, 'name', true))) {
        return TP.ac(this);
    }

    //  Run a CSS selector, which will return an Array of all of the elements
    //  (including the receiver's native node) that share the same name as the
    //  receiver. Note here how we don't collapse.
    results = TP.byCSSPath('input[name="' + name + '"]',
                            TP.nodeGetDocument(elem),
                            false);

    //  If we didn't get any nodes back from our query, at least return an Array
    //  with 1 item - ourself.
    if (TP.isEmpty(results)) {
        results = TP.ac(this);
    }

    return results;
});

//  ------------------------------------------------------------------------

TP.html.inputCheckable.Inst.defineMethod('$getMarkupValue',
function() {

    /**
     * @method $getMarkupValue
     * @summary Returns the 'value' of the receiver as authored by user in the
     *     markup. Many times this is represented as a 'value' attribute in the
     *     markup and serves as the default.
     * @returns {String} The markup value of the receiver.
     */

    return TP.elementGetAttribute(this.getNativeNode(), 'value', true);
});

//  ------------------------------------------------------------------------

TP.html.inputCheckable.Inst.defineMethod('$getPrimitiveValue',
function() {

    /**
     * @method $getPrimitiveValue
     * @summary Returns the low-level primitive value stored by the receiver in
     *     internal storage.
     * @returns {String} The primitive value of the receiver.
     */

    return this.getNativeNode().value;
});

//  ------------------------------------------------------------------------

TP.html.inputCheckable.Inst.defineMethod('getSubmitName',
function() {

    /**
     * @method getSubmitName
     * @summary Returns the name under which the receiver would be submitted
     *     when used in a forms context.
     * @returns {TP.html.inputCheckable} The receiver.
     */

    var node,
        key;

    node = this.getNativeNode();

    key = TP.elementGetAttribute(node, 'id');
    if (TP.isEmpty(key)) {
        key = TP.elementGetAttribute(node, 'name');
    }

    return key;
});

//  ------------------------------------------------------------------------

TP.html.inputCheckable.Inst.defineMethod('$getVisualToggle',
function() {

    /**
     * @method $getVisualToggle
     * @summary Returns the low-level primitive 'toggle value' used by the
     *     receiver to display a 'checked' state.
     * @returns {Boolean} The low-level primitive 'toggle value' of the
     *     receiver.
     */

    return this.getNativeNode().checked;
});

//  ------------------------------------------------------------------------

TP.html.inputCheckable.Inst.defineMethod('isBoundElement',
function() {

    /**
     * @method isBoundElement
     * @summary Whether or not the receiver is a bound element.
     * @returns {Boolean} Whether or not the receiver is bound.
     */

    var valueTPElems,

        len,
        i,

        item,
        bindAttrNodes;

    //  Since a checkable can have 1...n 'value elements', any one of them can
    //  have the binding information we're trying to detect.

    if (TP.notValid(valueTPElems = this.getValueElements())) {
        return this.raise('TP.sig.InvalidValueElements');
    }

    len = valueTPElems.getSize();
    for (i = 0; i < len; i++) {

        item = valueTPElems.at(i);

        //  We look for either 'in', 'out', 'io' here to determine if the
        //  receiver is bound.
        bindAttrNodes = TP.elementGetAttributeNodesInNS(
                item.getNativeNode(), /.*:(in|out|io)/, TP.w3.Xmlns.BIND);

        //  If we found binding attribute nodes, then the receiver, along with
        //  whatever value elements its a member of, are bound. Return true.
        if (TP.notEmpty(bindAttrNodes)) {
            return true;
        }
    }

    return false;
});

//  ------------------------------------------------------------------------

TP.html.inputCheckable.Inst.defineMethod('isSelected',
function() {

    /**
     * @method isSelected
     * @summary Returns true if the receiver is selected.
     * @returns {Boolean} Whether or not the receiver is selected.
     */

    return this.$getVisualToggle();
});

//  ------------------------------------------------------------------------

TP.html.inputCheckable.Inst.defineMethod('produceValue',
function(aspectName, aContentObject, aRequest) {

    /**
     * @method produceValue
     * @summary Produces the value that will be used by the setValue() method
     *     to set the content of the receiver.
     * @description This method works together with the 'isSingleValued()' and
     *     'isScalarValued()' methods to produce the proper value for the
     *     receiver. See the method description for isScalarValued() for more
     *     information.
     * @param {String} aspectName The aspect name on the receiver that the value
     *     is being produced for. Many times, this is 'value'.
     * @param {Object} aContentObject An object to use for content.
     * @param {TP.sig.Request} aRequest A request containing control parameters.
     */

    //  If the content that we're trying to compute a value from is not valid,
    //  then we return either an Array with false as it's first value or just
    //  false, depending on whether we allow multiple values.
    if (TP.notValid(aContentObject)) {

        if (this.allowsMultiples()) {
            return TP.ac(false);
        }

        return false;
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.html.inputCheckable.Inst.defineMethod('setFacet',
function(aspectName, facetName, facetValue, shouldSignal) {

    /**
     * @method setFacet
     * @summary Sets the value of the named facet of the named aspect to the
     *     value provided.
     * @param {String} aspectName The name of the aspect to set.
     * @param {String} facetName The name of the facet to set.
     * @param {Boolean} facetValue The value to set the facet to.
     * @param {Boolean} shouldSignal If false no signaling occurs. Defaults to
     *     this.shouldSignalChange().
     * @returns {Boolean} Whether or not the value was changed from the value it
     *     had before this method was called.
     */

    //  'checked' should be considered as 'value' in terms of an aspect for
    //  these types of Elements.
    if (aspectName === 'checked') {
        return this.callNextMethod(
                        'value', facetName, facetValue, shouldSignal);
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.html.inputCheckable.Inst.defineMethod('$setVisualToggle',
function(aToggleValue) {

    /**
     * @method $setVisualToggle
     * @summary Sets the low-level primitive 'toggle value' used by the receiver
     *     to display a 'checked' state.
     * @param {Boolean} aToggleValue Whether or not to display the receiver's
     *     'checked' state.
     * @returns {TP.html.inputCheckable} The receiver.
     */

    this.getNativeNode().checked = aToggleValue;

    return this;
});

//  ========================================================================
//  TP.html.inputSelectable
//  ========================================================================

/**
 * @type {TP.html.inputSelectable}
 * @abtract Common supertype for nodes that can be selected. This includes the
 *     various text widgets for example.
 */

//  ------------------------------------------------------------------------

//  file, password, text, etc.
TP.html.inputVisible.defineSubtype('inputSelectable');

//  can't construct concrete instances of this
TP.html.inputSelectable.isAbstract(true);

//  ------------------------------------------------------------------------

TP.backstop(TP.ac('select'), TP.html.inputSelectable.getInstPrototype());

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.inputSelectable.Type.defineMethod('onchange',
function(aTargetElem, anEvent) {

    /**
     * @method onchange
     * @param {HTMLElement} aTargetElem The target element computed for this
     *     signal.
     * @param {Event} anEvent The native event that was triggered.
     * @returns {TP.html.inputSelectable} The receiver.
     */

    var tpElem;

    tpElem = TP.wrap(aTargetElem);

    //  If the element is bound, then update its bound value.
    tpElem.setBoundValueIfBound(tpElem.getValue());

    if (TP.isValid(tpElem)) {
        tpElem.changed('value', TP.UPDATE);
    }

    return this;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.inputSelectable.Inst.defineMethod('getDisplayValue',
function() {

    /**
     * @method getDisplayValue
     * @summary Returns the value of the receiver.
     * @returns {String} The receiver's input value.
     */

    return this.getNativeNode().value;
});

//  ------------------------------------------------------------------------

TP.html.inputSelectable.Inst.defineMethod('setDisplayValue',
function(aValue) {

    /**
     * @method setDisplayValue
     * @summary Sets the value of the receiver.
     * @returns {TP.html.inputSelectable} The receiver.
     */

    this.getNativeNode().value = TP.str(aValue);

    return this;
});

//  ========================================================================
//  TP.html.inputButton
//  ========================================================================

/**
 * @type {TP.html.inputButton}
 * @summary <input type="button"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.inputClickable.defineSubtype('inputButton');

//  ========================================================================
//  TP.html.inputColor
//  ========================================================================

/**
 * @type {TP.html.inputColor}
 * @summary <input type="color"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.inputClickable.defineSubtype('inputColor');

TP.html.inputColor.addTraits(TP.html.textUtilities, TP.html.inputSelectable);

TP.html.inputColor.Inst.resolveTraits(
        TP.ac('getValue', 'setValue'),
        TP.html.textUtilities);

TP.html.inputColor.Inst.resolveTraits(
        TP.ac('getDisplayValue', 'setDisplayValue'),
        TP.html.inputSelectable);

//  ========================================================================
//  TP.html.inputDate
//  ========================================================================

/**
 * @type {TP.html.inputDate}
 * @summary <input type="date"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.inputClickable.defineSubtype('inputDate');

TP.html.inputDate.addTraits(TP.html.textUtilities, TP.html.inputSelectable);

TP.html.inputDate.Inst.resolveTraits(
        TP.ac('getValue', 'setValue'),
        TP.html.textUtilities);

TP.html.inputDate.Inst.resolveTraits(
        TP.ac('getDisplayValue', 'setDisplayValue'),
        TP.html.inputSelectable);

//  ========================================================================
//  TP.html.inputDateTime
//  ========================================================================

/**
 * @type {TP.html.inputDateTime}
 * @summary <input type="datetime"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.inputClickable.defineSubtype('inputDateTime');

TP.html.inputDateTime.addTraits(TP.html.textUtilities, TP.html.inputSelectable);

TP.html.inputDateTime.Inst.resolveTraits(
        TP.ac('getValue', 'setValue'),
        TP.html.textUtilities);

TP.html.inputDateTime.Inst.resolveTraits(
        TP.ac('getDisplayValue', 'setDisplayValue'),
        TP.html.inputSelectable);

//  ========================================================================
//  TP.html.inputDateTimeLocal
//  ========================================================================

/**
 * @type {TP.html.inputDateTimeLocal
 * @summary <input type="datetime-local"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.inputClickable.defineSubtype('inputDateTimeLocal');

TP.html.inputDateTimeLocal.addTraits(TP.html.textUtilities,
                                        TP.html.inputSelectable);

TP.html.inputDateTimeLocal.Inst.resolveTraits(
        TP.ac('getValue', 'setValue'),
        TP.html.textUtilities);

TP.html.inputDateTimeLocal.Inst.resolveTraits(
        TP.ac('getDisplayValue', 'setDisplayValue'),
        TP.html.inputSelectable);

//  ========================================================================
//  TP.html.inputMonth
//  ========================================================================

/**
 * @type {TP.html.inputMonth
 * @summary <input type="month"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.inputClickable.defineSubtype('inputMonth');

TP.html.inputMonth.addTraits(TP.html.textUtilities, TP.html.inputSelectable);

TP.html.inputMonth.Inst.resolveTraits(
        TP.ac('getValue', 'setValue'),
        TP.html.textUtilities);

TP.html.inputMonth.Inst.resolveTraits(
        TP.ac('getDisplayValue', 'setDisplayValue'),
        TP.html.inputSelectable);

//  ========================================================================
//  TP.html.inputRange
//  ========================================================================

/**
 * @type {TP.html.inputRange}
 * @summary <input type="range"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.inputClickable.defineSubtype('inputRange');

TP.html.inputRange.addTraits(TP.html.textUtilities, TP.html.inputSelectable);

TP.html.inputRange.Inst.resolveTraits(
        TP.ac('getValue', 'setValue'),
        TP.html.textUtilities);

TP.html.inputRange.Inst.resolveTraits(
        TP.ac('getDisplayValue', 'setDisplayValue'),
        TP.html.inputSelectable);

//  ========================================================================
//  TP.html.inputCheckbox
//  ========================================================================

/**
 * @type {TP.html.inputCheckbox}
 * @summary <input type="checkbox"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.inputCheckable.defineSubtype('inputCheckbox');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.inputCheckbox.Inst.defineMethod('allowsMultiples',
function() {

    /**
     * @method allowsMultiples
     * @summary Returns false since radio buttons, by their very nature, don't
     *     allow multiple selection.
     * @returns {Boolean} Whether or not the receiver allows multiple selection.
     */

    var valueTPElems;

    if (TP.notValid(valueTPElems = this.getValueElements())) {
        return this.raise('TP.sig.InvalidValueElements');
    }

    //  If there is only one element in the receiver's value elements and it's
    //  the same as the receiver, then we do not consider this control as
    //  'allowing multiple values' and want it to produce simple (i.e.
    //  non-Array) values.
    if (valueTPElems.getSize() === 1 && valueTPElems.first() === this) {
        return false;
    }

    return true;
});

//  ------------------------------------------------------------------------

TP.html.inputCheckbox.Inst.defineMethod('isSingleValued',
function(aspectName) {

    /**
     * @method isSingleValued
     * @summary Returns true if the receiver deals with single values.
     * @description See the TP.dom.Node's 'isScalarValued()' instance method
     *     for more information.
     * @param {String} [aspectName] An optional aspect name that is being used
     *     by the caller to determine whether the receiver is single valued for.
     * @returns {Boolean} For checkbox types, this returns false.
     */

    var valueTPElems;

    if (TP.notValid(valueTPElems = this.getValueElements())) {
        return this.raise('TP.sig.InvalidValueElements');
    }

    //  If there is only one element in the receiver's value elements and it's
    //  the same as the receiver, then we consider this control as binding to
    //  single (i.e. non-Array) values.
    if (valueTPElems.getSize() === 1 && valueTPElems.first() === this) {
        return true;
    }

    //  Checkbox (arrays) are not single valued.
    return false;
});

//  ------------------------------------------------------------------------

TP.html.inputCheckbox.Inst.defineMethod('$generateSelectionHashFrom',
function(aValue) {

    /**
     * @method $generateSelectionHashFrom
     * @summary Returns a Hash that is driven off of the supplied value which
     *     can then be used to set the receiver's selection.
     * @returns {TP.core.Hash} A Hash that is populated with data from the
     *     supplied value that can be used for manipulating the receiver's
     *     selection.
     */

    //  If the value is just true (and we use TP.ifTrue() to check it, since it
    //  might be a Boolean object - i.e. a boxed value), then populate a
    //  selection hash with the word 'on' in it.
    if (TP.isTrue(aValue) === true) {
        return TP.hc('on', '');
    }

    return this.callNextMethod();
});

//  ========================================================================
//  TP.html.inputEmail
//  ========================================================================

/**
 * @type {TP.html.inputEmail}
 * @summary <input type="email"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.inputSelectable.defineSubtype('inputEmail');

TP.html.inputEmail.addTraits(TP.html.textUtilities);

TP.html.inputEmail.Inst.resolveTraits(
        TP.ac('getValue', 'setValue'),
        TP.html.textUtilities);

TP.html.inputEmail.Inst.resolveTraits(
        TP.ac('getDisplayValue', 'setDisplayValue'),
        TP.html.inputSelectable);

//  ========================================================================
//  TP.html.inputFile
//  ========================================================================

/**
 * @type {TP.html.inputFile}
 * @summary <input type="file"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.inputSelectable.defineSubtype('inputFile');

//  ========================================================================
//  TP.html.inputHidden
//  ========================================================================

/**
 * @type {TP.html.inputHidden}
 * @summary <input type="hidden"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.input.defineSubtype('inputHidden');

TP.html.inputHidden.addTraits(TP.html.textUtilities);

TP.html.inputHidden.Type.resolveTraits(
        TP.ac('bidiAttrs', 'booleanAttrs', 'uriAttrs'),
        TP.html.inputHidden);

TP.html.inputHidden.Inst.resolveTraits(
        TP.ac('getValue', 'setValue'),
        TP.html.textUtilities);

TP.html.inputHidden.Inst.resolveTraits(
        TP.ac('getContent', 'setContent'),
        TP.dom.EmptyElementNode);

TP.html.inputHidden.Inst.resolveTraits(
        TP.ac('getDisplayValue', 'setDisplayValue'),
        TP.html.inputSelectable);

//  ========================================================================
//  TP.html.inputNumber
//  ========================================================================

/**
 * @type {TP.html.inputNumber}
 * @summary <input type="number"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.inputSelectable.defineSubtype('inputNumber');

TP.html.inputNumber.addTraits(TP.html.textUtilities);

TP.html.inputNumber.Inst.resolveTraits(
        TP.ac('getValue', 'setValue'),
        TP.html.textUtilities);

TP.html.inputNumber.Inst.resolveTraits(
        TP.ac('getDisplayValue', 'setDisplayValue'),
        TP.html.inputSelectable);

//  ========================================================================
//  TP.html.inputImage
//  ========================================================================

/**
 * @type {TP.html.inputImage}
 * @summary <input type="image"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.input.defineSubtype('inputImage');

//  ========================================================================
//  TP.html.inputPassword
//  ========================================================================

/**
 * @type {TP.html.inputPassword}
 * @summary <input type="password"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.inputSelectable.defineSubtype('inputPassword');

TP.html.inputPassword.addTraits(TP.html.textUtilities);

TP.html.inputPassword.Inst.resolveTraits(
        TP.ac('getValue', 'setValue'),
        TP.html.textUtilities);

TP.html.inputPassword.Inst.resolveTraits(
        TP.ac('getDisplayValue', 'setDisplayValue'),
        TP.html.inputSelectable);

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.inputPassword.Inst.defineMethod('setDisplayValue',
function(aValue) {

    /**
     * @method setDisplayValue
     * @summary Sets the value of the receiver.
     * @returns {TP.html.inputPassword} The receiver.
     */

    //  You can't set the value of a <input type="password"/> field unless its
    //  empty.

    if (TP.isEmpty(aValue)) {
        this.getNativeNode().value = '';
    }

    return this;
});

//  ========================================================================
//  TP.html.inputSearch
//  ========================================================================

/**
 * @type {TP.html.inputSearch}
 * @summary <input type="search"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.inputSelectable.defineSubtype('inputSearch');

TP.html.inputSearch.addTraits(TP.html.textUtilities);

TP.html.inputSearch.Inst.resolveTraits(
        TP.ac('getDisplayValue', 'setDisplayValue'),
        TP.html.inputSelectable);

//  ========================================================================
//  TP.html.inputRadio
//  ========================================================================

/**
 * @type {TP.html.inputRadio}
 * @summary <input type="radio">. This type is a wrapper for a radio group
 *     items, allowing you to set/get their value easily.
 */

//  ------------------------------------------------------------------------

TP.html.inputCheckable.defineSubtype('inputRadio');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.inputRadio.Inst.defineMethod('allowsMultiples',
function() {

    /**
     * @method allowsMultiples
     * @summary Returns false since radio buttons, by their very nature, don't
     *     allow multiple selection.
     * @returns {Boolean} Whether or not the receiver allows multiple selection.
     */

    return false;
});

//  ========================================================================
//  TP.html.inputReset
//  ========================================================================

/**
 * @type {TP.html.inputReset}
 * @summary <input type="reset"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.inputClickable.defineSubtype('inputReset');

//  ========================================================================
//  TP.html.inputSubmit
//  ========================================================================

/**
 * @type {TP.html.inputSubmit}
 * @summary <input type="submit"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.inputClickable.defineSubtype('inputSubmit');

//  ========================================================================
//  TP.html.inputTel
//  ========================================================================

/**
 * @type {TP.html.inputTel}
 * @summary <input type="tel"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.inputSelectable.defineSubtype('inputTel');

TP.html.inputTel.addTraits(TP.html.textUtilities);

TP.html.inputTel.Inst.resolveTraits(
        TP.ac('getValue', 'setValue'),
        TP.html.textUtilities);

TP.html.inputTel.Inst.resolveTraits(
        TP.ac('getDisplayValue', 'setDisplayValue'),
        TP.html.inputSelectable);

//  ========================================================================
//  TP.html.inputText
//  ========================================================================

/**
 * @type {TP.html.inputText}
 * @summary <input type="text"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.inputSelectable.defineSubtype('inputText');

TP.html.inputText.addTraits(TP.html.textUtilities);

TP.html.inputText.Type.resolveTraits(
        TP.ac('bidiAttrs', 'booleanAttrs', 'uriAttrs'),
        TP.html.inputText);

TP.html.inputText.Inst.resolveTraits(
        TP.ac('getValue', 'setValue'),
        TP.html.textUtilities);

TP.html.inputText.Inst.resolveTraits(
        TP.ac('getContent', 'setContent'),
        TP.dom.EmptyElementNode);

TP.html.inputText.Inst.resolveTraits(
        TP.ac('getDisplayValue', 'setDisplayValue'),
        TP.html.inputSelectable);

//  ========================================================================
//  TP.html.inputTime
//  ========================================================================

/**
 * @type {TP.html.inputTime}
 * @summary <input type="time"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.inputClickable.defineSubtype('inputTime');

TP.html.inputTime.addTraits(TP.html.textUtilities, TP.html.inputSelectable);

TP.html.inputTime.Inst.resolveTraits(
        TP.ac('getValue', 'setValue'),
        TP.html.textUtilities);

TP.html.inputTime.Inst.resolveTraits(
        TP.ac('getDisplayValue', 'setDisplayValue'),
        TP.html.inputSelectable);

//  ========================================================================
//  TP.html.inputWeek
//  ========================================================================

/**
 * @type {TP.html.inputWeek}
 * @summary <input type="week"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.inputClickable.defineSubtype('inputWeek');

TP.html.inputTime.addTraits(TP.html.textUtilities, TP.html.inputSelectable);

TP.html.inputWeek.Inst.resolveTraits(
        TP.ac('getValue', 'setValue'),
        TP.html.textUtilities);

TP.html.inputWeek.Inst.resolveTraits(
        TP.ac('getDisplayValue', 'setDisplayValue'),
        TP.html.inputSelectable);

//  ========================================================================
//  TP.html.inputUrl
//  ========================================================================

/**
 * @type {TP.html.inputUrl}
 * @summary <input type="url"> tag.
 */

//  ------------------------------------------------------------------------

TP.html.inputSelectable.defineSubtype('inputUrl');

TP.html.inputUrl.addTraits(TP.html.textUtilities);

TP.html.inputUrl.Type.resolveTraits(
        TP.ac('bidiAttrs', 'booleanAttrs', 'uriAttrs'),
        TP.html.inputUrl);

TP.html.inputUrl.Inst.resolveTraits(
        TP.ac('getValue', 'setValue'),
        TP.html.textUtilities);

TP.html.inputUrl.Inst.resolveTraits(
        TP.ac('getContent', 'setContent'),
        TP.dom.EmptyElementNode);

TP.html.inputUrl.Inst.resolveTraits(
        TP.ac('getDisplayValue', 'setDisplayValue'),
        TP.html.inputSelectable);

//  ========================================================================
//  TP.html.legend
//  ========================================================================

/**
 * @type {TP.html.legend}
 * @summary 'legend' tag. Fieldset label.
 */

//  ------------------------------------------------------------------------

TP.html.Aligned.defineSubtype('legend');

//  ========================================================================
//  TP.html.select
//  ========================================================================

/**
 * @type {TP.html.select}
 * @summary 'select' tag. Single or multiple selection control.
 */

//  ------------------------------------------------------------------------

TP.html.Focused.defineSubtype('select');

TP.html.select.addTraits(TP.dom.TogglingUIElementNode);

//  ------------------------------------------------------------------------

TP.html.select.Type.set('booleanAttrs',
        TP.ac('autofocus', 'disabled', 'multiple', 'required', 'willValidate'));

TP.html.select.Type.set('bidiAttrs', TP.ac('value'));

TP.backstop(TP.ac('add', 'remove'), TP.html.select.getInstPrototype());

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.select.Type.defineMethod('getItemTagName',
function() {

    /**
     * @method getItemTagName
     * @summary Returns the 'default item tag name' for use it the
     *     fromArray()/fromObject() methods. Note that this should return the
     *     receiver's *canonical* name.
     * @returns {String} The ID of the observer.
     */

    return 'html:option';
});

//  ------------------------------------------------------------------------

TP.html.select.Type.defineMethod('onchange',
function(aTargetElem, anEvent) {

    /**
     * @method onchange
     * @param {HTMLElement} aTargetElem The target element computed for this
     *     signal.
     * @param {Event} anEvent The native event that was triggered.
     * @returns {TP.html.select} The receiver.
     */

    var tpElem;

    tpElem = TP.wrap(aTargetElem);

    //  If the element is bound, then update its bound value.
    tpElem.setBoundValueIfBound(tpElem.getValue());

    if (TP.isValid(tpElem)) {
        tpElem.changed('value', TP.UPDATE);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.html.select.Type.defineMethod('shouldAutoWrapItems',
function(anObject, formatArgs) {

    /**
     * @method shouldAutoWrapItems
     * @summary Whether or not our fromArray() / fromObject() methods
     *     'auto-wrap items'. See those methods for more information.
     * @param {Object} anObject The Object of content to wrap in markup.
     * @param {TP.core.Hash} formatArgs An optional object containing
     *     parameters.
     * @returns {Boolean} Whether or not we automatically wrap items.
     */

    if (TP.isBoolean(formatArgs.at('autowrap'))) {
        return formatArgs.at('autowrap');
    }

    return false;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.select.Inst.defineMethod('allowsMultiples',
function() {

    /**
     * @method allowsMultiples
     * @summary Returns true if the receiver is configured for multiple
     *     selection.
     * @returns {Boolean} Whether or not the receiver allows multiple selection.
     */

    /* eslint-disable no-extra-parens */
    return (this.getNativeNode().type === 'select-multiple');
    /* eslint-enable no-extra-parens */
});

//  ------------------------------------------------------------------------

TP.html.select.Inst.defineMethod('deselectAll',
function() {

    /**
     * @method deselectAll
     * @summary Clears any current selection(s).
     * @exception TP.sig.InvalidValueElements
     * @returns {TP.html.select} The receiver.
     */

    this.callNextMethod();

    this.getNativeNode().selectedIndex = -1;

    return this;
});

//  ------------------------------------------------------------------------

TP.html.select.Inst.defineMethod('getDisplayValue',
function() {

    /**
     * @method getDisplayValue
     * @summary Returns the selected value of the select list. This corresponds
     *     to the value of the currently selected item or items.
     * @returns {String|String[]} A String containing the selected value or an
     *     Array of zero or more selected values if the receiver is set up to
     *     allow multiple selections.
     */

    var valueTPElems,
        theIndex,
        selectionArray,
        len,
        i,

        item;

    if (TP.notValid(valueTPElems = this.getValueElements())) {
        return this.raise('TP.sig.InvalidValueElements');
    }

    //  If this Select isn't set up to allow multiple selection, then just
    //  return the value of the element at the native element's selected
    //  index.
    if (!this.allowsMultiples()) {
        if ((theIndex = this.getNativeNode().selectedIndex) === TP.NOT_FOUND) {
            return null;
        }

        return valueTPElems.at(theIndex).$getPrimitiveValue();
    }

    selectionArray = TP.ac();

    //  Loop over all of the elements and if the element at the index is
    //  selected, add it to the Array of selected elements.
    len = valueTPElems.getSize();
    for (i = 0; i < len; i++) {

        item = valueTPElems.at(i);

        if (item.$getVisualToggle()) {
            selectionArray.push(item.$getPrimitiveValue());
        }
    }

    if (!this.allowsMultiples()) {
        return selectionArray.first();
    }

    return selectionArray;
});

//  ------------------------------------------------------------------------

TP.html.select.Inst.defineMethod('getValue',
function() {

    /**
     * @method getValue
     * @summary Returns the value of the receiver. For a UI element this method
     *     will ensure any storage formatters are invoked.
     * @returns {String} The value in string form.
     */

    var value,

        type,
        formats;

    value = this.getDisplayValue();

    //  Given that this type can represent multiple items, it may return an
    //  Array. We should check to make sure the Array isn't empty before doing
    //  any more work.
    if (TP.notEmpty(value)) {

        //  If the receiver has a 'ui:type' attribute, then try first to convert
        //  the content to that type before trying to format it.
        if (TP.notEmpty(type = this.getAttribute('ui:type'))) {
            if (!TP.isType(type = TP.sys.getTypeByName(type))) {
                return this.raise('TP.sig.InvalidType');
            } else {
                value = type.fromString(value);
            }
        }

        //  If the receiver has a 'ui:storage' attribute, then format the return
        //  value according to the formats found there.
        //  the content to that type before trying to format it.
        if (TP.notEmpty(formats = this.getAttribute('ui:storage'))) {
            value = this.$formatValue(value, formats);
        }
    }

    return value;
});

//  ------------------------------------------------------------------------

TP.html.select.Inst.defineMethod('getValueElements',
function() {

    /**
     * @method getValueElements
     * @summary Returns an Array TP.dom.UIElementNodes that share a common
     *     'value object' with the receiver. That is, a change to the 'value' of
     *     the receiver will also change the value of one of these other
     *     TP.dom.UIElementNodes.
     * @returns {TP.dom.UIElementNode[]} The Array of shared value items.
     */

    //  For some reason, on IE, the 'options' Array doesn't work properly. It
    //  returns the native node of the receiver.

    //  So we query by CSS instead. Note here how we don't collapse.
    return TP.byCSSPath('> option', this.getNativeNode(), false);
});

//  ------------------------------------------------------------------------

TP.html.select.Inst.defineMethod('isScalarValued',
function(aspectName) {

    /**
     * @method isScalarValued
     * @summary Returns true if the receiver deals with scalar values.
     * @description See the TP.dom.Node's 'isScalarValued()' instance method
     *     for more information.
     * @param {String} [aspectName] An optional aspect name that is being used
     *     by the caller to determine whether the receiver is scalar valued for.
     * @returns {Boolean} For select types, this returns true.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.html.select.Inst.defineMethod('removeSelection',
function(aValue, optionProperty) {

    /**
     * @method removeSelection
     * @summary Removes the selection matching the criteria if found. Note that
     *     this method does not clear existing selections when processing the
     *     value(s) provided.
     * @description Note that the aspect can be one of the following, which will
     *      be the property used with each 'option' element to determine which
     *      of them will be deselected.
     *          'value'     ->  The value of the option (the default)
     *          'label'     ->  The label of the option
     *          'id'        ->  The id of the option
     *          'index'     ->  The numerical index of the option
     * @param {Object|Object[]} aValue The value to use when determining the
     *      options to remove from the selection. Note that this can be an
     *      Array.
     * @param {String} optionProperty The property of the option elements to use
     *      to determine which options should be deselected.
     * @exception TP.sig.InvalidOperation
     * @exception TP.sig.InvalidValueElements
     * @returns {Boolean} Whether or not a selection was removed.
     */

    var dirty;

    dirty = this.callNextMethod();

    if (dirty) {

        if (!this.allowsMultiples()) {
            //  If the receiver doesn't allow multiples and dirty was true, that
            //  means there are no selections now so make sure to set
            //  selectedIndex to -1 here - some browsers don't seem to set this
            //  to -1 when all options are deselected and it definitely helps
            //  when reading the value back out.
            this.getNativeNode().selectedIndex = -1;
        }
    }

    return dirty;
});

//  ------------------------------------------------------------------------

TP.html.select.Inst.defineMethod('render',
function() {

    /**
     * @method render
     * @summary Renders the receiver.
     * @returns {TP.html.select} The receiver.
     */

    if (TP.isEmpty(this.$getSelectionModel())) {
        this.$refreshSelectionModelFor();
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.html.select.Inst.defineMethod('setData',
function(aDataObject, shouldSignal) {

    /**
     * @method setData
     * @summary Sets the receiver's data object to the supplied object.
     * @param {Object} aDataObject The object to set the receiver's internal
     *     data to.
     * @param {Boolean} [shouldSignal=true] Whether or not to signal change.
     * @returns {TP.html.select} The receiver.
     */

    var dataObj,

        elem,
        doc,

        leni,
        i,

        obj,

        optElem,
        optGrpElem,

        optGrpKeys,

        optGrpKey,
        optGrpData,

        lenj,
        j,

        lenk,
        k;

    //  Make sure to unwrap this from any TP.core.Content objects, etc.
    dataObj = TP.val(aDataObject);

    if (!TP.isArray(dataObj)) {
        //  TODO: Raise an exception
        return this;
    }

    //  Empty out whatever content we currently have
    this.empty();

    elem = this.getNativeNode();
    doc = this.getNativeDocument();

    //  Loop over the outer Array and get either nested Arrays (which are
    //  value/label pairs) or Objects (which are groups) or
    //  Boolean/Date/Number/String (in which case we just set value and text to
    //  be the same)

    leni = dataObj.getSize();
    for (i = 0; i < leni; i++) {

        obj = dataObj.at(i);
        if (TP.isArray(obj)) {

            //  Construct an XHTML 'option' element and append it to ourself.
            optElem = TP.documentConstructElement(
                            doc, 'option', TP.w3.Xmlns.XHTML);
            elem.appendChild(optElem);

            //  Set the option's value and text to the appropriate parts of the
            //  pair.
            optElem.value = obj.first();
            optElem.text = obj.last();

        } else if (TP.isHash(obj)) {

            optGrpKeys = obj.getKeys();

            //  Iterate over all of the keys. They should each have an Array of
            //  option pairs as their value .
            lenj = optGrpKeys.getSize();
            for (j = 0; j < lenj; j++) {

                //  Construct an XHTML 'optgroup' element and append it to
                //  ourself.
                optGrpElem = TP.documentConstructElement(
                                doc, 'optgroup', TP.w3.Xmlns.XHTML);
                elem.appendChild(optGrpElem);

                optGrpKey = optGrpKeys.at(j);
                optGrpData = obj.at(optGrpKey);

                //  Set the option group's label to the key
                optGrpElem.label = optGrpKey;

                //  Iterate over the Array of option pairs found at that key.
                lenk = optGrpData.getSize();
                for (k = 0; k < lenk; k++) {

                    //  Construct an XHTML 'option' element and append it to
                    //  ourself.
                    optElem = TP.documentConstructElement(
                                    doc, 'option', TP.w3.Xmlns.XHTML);
                    optGrpElem.appendChild(optElem);

                    //  Set the option's value and text to the appropriate parts
                    //  of the pair.
                    optElem.value = optGrpData.at(k).first();
                    optElem.text = optGrpData.at(k).last();
                }
            }
        } else if (TP.isBoolean(obj) ||
                    TP.isDate(obj) ||
                    TP.isNumber(obj) ||
                    TP.isString(obj)) {

            //  Construct an XHTML 'option' element and append it to ourself.
            optElem = TP.documentConstructElement(
                            doc, 'option', TP.w3.Xmlns.XHTML);
            elem.appendChild(optElem);

            obj = TP.str(obj);

            //  Set the option's value and text to the object, since its just a
            //  String.
            optElem.value = obj;
            optElem.text = obj;
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.html.select.Inst.defineMethod('setDisplayValue',
function(aValue) {

    /**
     * @method setDisplayValue
     * @summary Sets the receivers' value to the value provided (if it matches
     *     the value of an item in the group). Note that any selected items not
     *     provided in aValue are cleared, which is different than the behavior
     *     of selectValue() which simply adds the new selected items to the
     *     existing selection.
     * @param {Object} aValue The value to set (select) in the receiver. For a
     *     select list this might be an array.
     * @returns {TP.html.select} The receiver.
     */

    var valueTPElems,
        separator,
        value,

        dict,
        len,
        i,

        dirty,
        deselectCount,

        item;

    //  empty value means clear any selection(s)
    if (TP.isEmpty(aValue)) {
        return this.deselectAll();
    }

    if (TP.notValid(valueTPElems = this.getValueElements())) {
        return this.raise('TP.sig.InvalidValueElements');
    }

    separator = TP.ifEmpty(this.getAttribute('bind:separator'),
                            TP.sys.cfg('bind.value_separator'));

    value = aValue;

    //  If the value is an Array and has a size of 1, just use that item.
    //  Otherwise, turn the Array into String representations of the objects it
    //  contains.
    if (TP.isArray(value)) {
        if (value.getSize() === 1) {
            value = value.first();
        } else {

            //  Iterate over each item, getting it's String value and possibly
            //  making a new nested Array by splitting on any separator if it
            //  exists.
            value = value.collect(
                            function(aVal) {
                                var val;

                                val = TP.str(aVal);
                                val = val.split(separator).collapse();

                                return val;
                            });

            //  Make sure to flatten the resultant Array.
            value = value.flatten();
        }
    }

    if (TP.isString(value)) {
        value = value.split(separator).collapse();
    }

    //  watch for multiple selection issues
    if (TP.isArray(value) && !this.allowsMultiples()) {
        value = value.at(0);
    }

    //  Generate a selection hash. This should populate the hash with keys that
    //  match 1...n values in the supplied value.
    dict = this.$generateSelectionHashFrom(value);

    dirty = false;
    deselectCount = 0;

    len = valueTPElems.getSize();
    for (i = 0; i < len; i++) {

        item = valueTPElems.at(i);

        if (dict.containsKey(item.$getPrimitiveValue())) {
            if (!item.$getVisualToggle()) {
                dirty = true;
            }
            item.$setVisualToggle(true);
        } else {
            if (item.$getVisualToggle()) {
                dirty = true;
            }
            item.$setVisualToggle(false);
            deselectCount++;
        }
    }

    //  If there are no selections now, make sure to set selectedIndex to -1
    //  here - some browsers don't seem to set this to -1 when all options are
    //  deselected and it definitely helps when reading the value back out.
    if (deselectCount === i) {
        this.getNativeNode().selectedIndex = -1;

        //  Also, empty the selection model to keep it in sync
        this.$getSelectionModel().empty();
    } else {
        //  Keep the selection model in sync with the selected values.
        this.$getSelectionModel().atPut('value', dict.getKeys());
    }

    if (dirty) {
        this.$changed('selection', TP.UPDATE);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.html.select.Inst.defineMethod('setValue',
function(aValue, shouldSignal) {

    /**
     * @method setValue
     * @summary Sets the value of the receiver's node. For a UI element this
     *     method will ensure any display formatters are invoked. NOTE that this
     *     method does not update the receiver's bound value if it's a bound
     *     control. In fact, this method is used in response to a change in the
     *     bound value to update the display value, so this method should avoid
     *     changes to the bound value to avoid recursions.
     * @param {Object} aValue The value to set the 'value' of the node to.
     * @param {Boolean} shouldSignal Should changes be notified. If false
     *     changes are not signaled. Defaults to this.shouldSignalChange().
     * @returns {TP.html.select} The receiver.
     */

    var oldValue,
        newValue,

        displayValue,

        flag;

    oldValue = this.getValue();

    newValue = this.produceValue('value', aValue);

    //  If the values are equal, there's nothing to do here - bail out.
    if (TP.equal(TP.str(oldValue), TP.str(newValue))) {
        return this;
    }

    this.setDisplayValue(newValue);

    //  signal as needed

    displayValue = this.getDisplayValue();

    //  Sometimes the display value computed from the new value can be equal to
    //  the old value. If that's *not* the case, then propagate the change
    //  signal.
    if (!TP.equal(oldValue, displayValue)) {
        //  NB: Use this construct this way for better performance
        if (TP.notValid(flag = shouldSignal)) {
            flag = this.shouldSignalChange();
        }

        if (flag) {
            this.$changed('value', TP.UPDATE,
                            TP.hc(TP.OLDVAL, oldValue, TP.NEWVAL, newValue));
        }

        //  If the element is bound, then update its bound value.
        this.setBoundValueIfBound(this.getValue());
    }

    return this;
});

//  ========================================================================
//  TP.html.textarea
//  ========================================================================

/**
 * @type {TP.html.textarea}
 * @summary 'textarea' tag. Multiline text input.
 */

//  ------------------------------------------------------------------------

TP.html.Focused.defineSubtype('textarea');

TP.html.textarea.addTraits(TP.html.textUtilities);

TP.html.textarea.Type.resolveTraits(
        TP.ac('booleanAttrs', 'bidiAttrs'),
        TP.html.textarea);

TP.html.textarea.Inst.resolveTraits(
        TP.ac('getValue', 'setValue'),
        TP.html.textUtilities);

TP.html.textarea.Type.set('bidiAttrs', TP.ac('value'));

TP.html.textarea.Type.set('booleanAttrs',
        TP.ac('autofocus', 'disabled', 'readOnly', 'required', 'willValidate'));

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.backstop(TP.ac('select'), TP.html.textarea.getInstPrototype());

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.textarea.Type.defineMethod('isOpaqueBubblerFor',
function(anElement, aSignal, signalNames) {

    /**
     * @method isOpaqueBubblerFor
     * @summary Returns whether the elements of this type are considered to be
     *     an 'opaque bubbler' for the supplied signal (i.e. it won't let the
     *     signal 'ascend' further up its parent hierarchy). This means that
     *     they will handle the signal themselves and not allow ancestors above
     *     them to handle it.
     * @description At this level, DOM_Enter_Down and DOM_EnterUp are filtered
     *     as opaque signals. This prevents Enter key presses from triggering
     *     other signals within the system.
     * @param {Element} anElem The element to check for the
     *     'tibet:opaque-bubbling' attribute.
     * @param {TP.sig.Signal} aSignal The signal to check.
     * @param {String[]} [signalNames] The list of signal names to use when
     *     computing opacity for the signal. This is an optional parameter. If
     *     this method needs the list of signal names and this parameter is not
     *     provided, it can be derived from the supplied signal itself.
     * @returns {Boolean} Whether or not the receiver is opaque during the
     *     bubble phase for the signal.
     */

    var keyname,

        sigNames,

        len,
        i;

    if (!TP.isElement(anElement)) {
        return TP.raise(this, 'TP.sig.InvalidElement');
    }

    //  If the signal names were not supplied in the optional parameter, grab
    //  all of the signal names from the signal.
    sigNames = TP.ifInvalid(signalNames, aSignal.getSignalNames());

    len = sigNames.getSize();
    for (i = 0; i < len; i++) {
        //  Compute the key name by slicing off everything up through the last
        //  period ('.'). I.e. the 'TP.sig.'.
        keyname = sigNames.at(i).slice(sigNames.at(i).lastIndexOf('.') + 1);

        if (keyname === 'DOM_Enter_Down' || keyname === 'DOM_Enter_Up') {
            return true;
        }
    }

    return this.callNextMethod();
});
//  ------------------------------------------------------------------------

TP.html.textarea.Type.defineMethod('onchange',
function(aTargetElem, anEvent) {

    /**
     * @method onchange
     * @param {HTMLElement} aTargetElem The target element computed for this
     *     signal.
     * @param {Event} anEvent The native event that was triggered.
     * @returns {TP.meta.html.textarea} The receiver.
     */

    var tpElem;

    tpElem = TP.wrap(aTargetElem);

    //  If the element is bound, then update its bound value.
    tpElem.setBoundValueIfBound(tpElem.getValue());

    if (TP.isValid(tpElem)) {
        tpElem.changed('value', TP.UPDATE);
    }

    return this;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.textarea.Inst.defineMethod('getDisplayValue',
function() {

    /**
     * @method getDisplayValue
     * @summary Returns the value of the receiver.
     * @returns {String} The receiver's formatted input value.
     */

    return this.getNativeNode().value;
});

//  ------------------------------------------------------------------------

TP.html.textarea.Inst.defineMethod('isSingleValued',
function(aspectName) {

    /**
     * @method isSingleValued
     * @summary Returns true if the receiver deals with single values.
     * @description See the TP.dom.Node's 'isScalarValued()' instance method
     *     for more information.
     * @param {String} [aspectName] An optional aspect name that is being used
     *     by the caller to determine whether the receiver is single valued for.
     * @returns {Boolean} For textarea types, this returns true.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.html.textarea.Inst.defineMethod('isScalarValued',
function(aspectName) {

    /**
     * @method isScalarValued
     * @summary Returns true if the receiver deals with scalar values.
     * @description See the TP.dom.Node's 'isScalarValued()' instance method
     *     for more information.
     * @param {String} [aspectName] An optional aspect name that is being used
     *     by the caller to determine whether the receiver is scalar valued for.
     * @returns {Boolean} For textarea types, this returns true.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.html.textarea.Inst.defineMethod('setDisplayValue',
function(aValue) {

    /**
     * @method setDisplayValue
     * @summary Sets the value of the receiver.
     * @returns {TP.html.textarea} The receiver.
     */

    this.getNativeNode().value = TP.str(aValue);

    return this;
});

//  ========================================================================
//  TP.html.button
//  ========================================================================

/**
 * @type {TP.html.button}
 * @summary 'button' tag.
 * @description NOT the same as <input type="button"> due largely to rendering
 *     differences. The attributes and behavior are largely similar, however.
 *     This tag type supports content between the opening/closing button tags
 *     unlike the input form of this control which has no closing tag and hence
 *     no content.
 */

//  ------------------------------------------------------------------------

TP.html.Focused.defineSubtype('button');

TP.html.button.Type.set('booleanAttrs',
            TP.ac('autofocus', 'disabled', 'formNoValidate', 'willValidate'));

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.button.Type.defineMethod('tagCompile',
function(aRequest) {

    /**
     * @method tagCompile
     * @summary Convert the receiver into a format suitable for inclusion in a
     *     markup DOM.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     * @returns {Element} The new element.
     */


    var elem,
        typeVal;

    //  Make sure that we have an element to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        return;
    }

    typeVal = TP.elementGetAttribute(elem, 'type', true);
    if (TP.notEmpty(typeVal) && typeVal !== 'button') {
        TP.ifWarn() ?
            TP.warn(
                TP.annotate(
                    TP.nodeCloneNode(elem),
                    'Replacing \'type\' attribute value with \'button\'.')) : 0;
    }

    elem = TP.nodeCloneNode(elem);

    //  HTML5 changed the nature of a button - now, if a button is embedded
    //  within a form element, it will act to submit the form unless we set the
    //  new (for HTML5) 'type' attribute to 'button'. In TIBET, since we never
    //  do 'form submits' as a way to communicate with the server, we force
    //  'type' to be 'button'.
    TP.elementSetAttribute(elem, 'type', 'button', true);

    TP.elementSetGenerator(elem);

    return elem;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.button.Inst.defineMethod('disable',
function() {

    /**
     * @method disable
     * @summary Disables the control using the standard disabled attribute.
     * @returns {TP.html.button} The receiver.
     */

    this.setAttribute('disabled', 'true');

    return this;
});

//  ------------------------------------------------------------------------

TP.html.button.Inst.defineMethod('enable',
function() {

    /**
     * @method enable
     * @summary Enables the control by removing any disabled attribute.
     * @returns {TP.html.button} The receiver.
     */

    this.removeAttribute('disabled');

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xhtml/html_HypertextModuleNodes.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'html';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.html.a
//  ========================================================================

/**
 * @type {TP.html.a}
 * @summary A tag. An anchor or hypertext link.
 */

//  ------------------------------------------------------------------------

TP.html.Focused.defineSubtype('a');

TP.html.a.Type.set('uriAttrs', TP.ac('href'));

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.a.Type.defineMethod('isResponderForUIFocusChange',
function(aNode, aSignal) {

    /**
     * @method isResponderForUIFocusChange
     * @summary Returns true if the node has an 'href' attribute (but not if it
     *     has a 'disabled' attribute) to match (X)HTML semantics.
     * @param {Node} aNode The node to check which may have further data as to
     *     whether this type should be considered to be a responder.
     * @param {TP.sig.Signal} aSignal The signal that responders are being
     *     computed for.
     * @returns {Boolean} True when the receiver should respond to aSignal.
     */

    return TP.elementHasAttribute(aNode, 'href', true) &&
            !TP.elementHasAttribute(aNode, 'disabled', true);
});

//  ------------------------------------------------------------------------

TP.html.a.Type.defineMethod('isResponderForUIFocusComputation',
function(aNode, aSignal) {

    /**
     * @method isResponderForUIFocusComputation
     * @summary Returns true if the node has an 'href' attribute (but not if it
     *     has a 'disabled' attribute) to match (X)HTML semantics.
     * @param {Node} aNode The node to check which may have further data as to
     *     whether this type should be considered to be a responder.
     * @param {TP.sig.Signal} aSignal The signal that responders are being
     *     computed for.
     * @returns {Boolean} True when the receiver should respond to aSignal.
     */

    return TP.elementHasAttribute(aNode, 'href', true) &&
            !TP.elementHasAttribute(aNode, 'disabled', true);
});

//  ------------------------------------------------------------------------

TP.html.a.Type.defineMethod('tagResolve',
function(aRequest) {

    /**
     * @method tagResolve
     * @summary Resolves the receiver's content. This includes resolving XML
     *     Base URIs and virtual URIs that may occur on the receiver's
     *     attributes.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var elem,

        href,

        target,

        onClickVal;

    //  Make sure that we have an element to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        return;
    }

    //  Capture the original HREF value so we can undo expansion if necessary.
    href = TP.elementGetAttribute(elem, 'href', true);

    //  Call up the chain and force expansion and any other default processing.
    this.callNextMethod();

    //  If the target is a local reference (a path or _self) it means we're
    //  targeting a TIBET-controlled surface. If not then we don't want to
    //  interfere with normal processing so we don't rewrite.
    if (TP.notEmpty(target = TP.elementGetAttribute(elem, 'target', true))) {
        if (!TP.regex.NON_SIMPLE_PATH.test(target) && target !== '_self') {
            return;
        }
    }

    //  If the element has the 'tibet:no-rewrite' flag, then don't rewrite it.
    if (TP.elementHasAttribute(elem, 'tibet:no-rewrite', true)) {
        return;
    }

    //  If there's already a click handler the author "wins", even if that
    //  means they don't get the benefit of TIBET here.
    onClickVal = TP.elementGetAttribute(elem, 'onclick', true);
    if (TP.notEmpty(onClickVal)) {

        //  If there was an 'href' of '#' or an empty 'href', then we return.
        //  This means either a) the author originally had an 'onclick' value or
        //  b) we already rewrote a link into a TP.go2() expression.
        if (href === '#' || TP.isEmpty(href)) {
            return;
        }
    }

    //  Same check for 'on:click'.
    onClickVal = TP.elementGetAttribute(elem, 'on:click', true);
    if (TP.notEmpty(onClickVal)) {

        //  If the element has an href of '#' and doesn't already have an
        //  'onclick' (native version) attribute, then put one here that will
        //  cause the observers to invoke and, as importantly, return false to
        //  stop link traversal. Note that we only do this if the href is '#',
        //  since other TIBET code will place the proper 'onclick' handler here
        //  if the href is any other value.
        if (href === '#' && !TP.elementHasAttribute(elem, 'onclick', true)) {
            TP.elementSetAttribute(
                elem,
                'onclick',
                'TP.core.Mouse.invokeObservers(\'click\', event);' +
                ' return false;',
                true);

            return;
        }

        //  If there was an 'href' of '#' or an empty 'href', then we return.
        //  This means either a) the author originally had an 'on:click' value
        //  or b) we already rewrote a link into a TP.go2() expression.
        if (href === '#' || TP.isEmpty(href)) {
            return;
        }
    }

    //  Links with an empty HREF will try to reload the page. We really don't
    //  want that, we want to have them do nothing. We set '#' here and let the
    //  check further down add a return false click handler.
    if (TP.isEmpty(href)) {
        TP.elementSetAttribute(elem, 'href', '#', true);
    }

    //  Links with an empty anchor will try to reset at the top of page. Don't
    //  let that happen either, just "dampen them" via onclick.
    if (href === '#') {
        TP.elementSetAttribute(
            elem,
            'onclick',
            'TP.core.Mouse.invokeObservers(\'click\', event);' +
            ' return false;',
            true);

        return;
    }

    //  If the link triggers a javascript url (or is javascript: void 0) exit.
    /* eslint-disable no-script-url */
    if (href.startsWith('javascript:')) {
        return;
    }
    /* eslint-enable no-script-url */

    //  If the original value wasn't a route then refetch to get the fully
    //  expanded form so we use that for our TP.go2() call.
    if (href.indexOf('#') !== 0 && href !== '/') {
        href = TP.elementGetAttribute(elem, 'href', true);
    }

    //  First, just set the 'href' to '#' to limit traversal and link display.
    TP.elementSetAttribute(elem, 'href', '#', true);

    //  Then add an 'onclick' that will service any TIBET click handling
    //  machinery and then trigger TIBET's go2 call to process the link at
    //  runtime. Note that we pass the event object so that the proper observers
    //  can be invoked and also 'return false' to help ensure no traversal from
    //  the link.
    TP.elementSetAttribute(
        elem,
        'onclick',
        ' TP.go2(\'' + href + '\', window, event);' +
        ' return false;',
        true);

    return;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.a.Inst.defineMethod('setAttrHref',
function(value) {

    /**
     * @method setAttrHref
     * @summary Sets the href that the receiver will use to retrieve its
     *     content.
     * @param {String} anHref The URL that the receiver will use to fetch its
     *     content.
     */

    var elem,

        target;

    elem = this.getNativeNode();

    if (!TP.isElement(elem)) {
        //  setting an attribute returns void according to the spec
        return;
    }

    //  If the target is a local reference (a path or _self) it means we're
    //  targeting a TIBET-controlled surface. If not then we don't want to
    //  interfere with normal processing so we don't rewrite.
    if (TP.notEmpty(target = TP.elementGetAttribute(elem, 'target', true))) {
        if (!TP.regex.NON_SIMPLE_PATH.test(target) && target !== '_self') {
            //  setting an attribute returns void according to the spec
            return;
        }
    }

    //  If the element has the 'tibet:no-rewrite' flag, then don't rewrite it.
    if (TP.elementHasAttribute(elem, 'tibet:no-rewrite', true)) {
        return;
    }

    //  NB: Unlike the 'tagResolve' method above, there is no check here to
    //  exit early based on the onclick value. This is due to the fact that the
    //  href is being set, not being rewritten from authored markup, and the
    //  caller should know what they're doing.

    //  Links with an empty HREF will try to reload the page. We really don't
    //  want that, we want to have them do nothing. We set '#' here and let the
    //  check further down add a return false click handler.
    if (TP.isEmpty(value)) {
        TP.elementSetAttribute(elem, 'href', '#', true);
    }

    //  Links with an empty anchor will try to reset at the top of page. Don't
    //  let that happen either, just "dampen them" via onclick.
    if (value === '#') {
        TP.elementSetAttribute(
            elem,
            'onclick',
            'TP.core.Mouse.invokeObservers(\'click\', event);' +
            ' return false;',
            true);

        //  setting an attribute returns void according to the spec
        return;
    }

    //  If the link triggers a javascript url (or is javascript: void 0) exit.
    /* eslint-disable no-script-url */
    if (TP.notEmpty(value) && value.startsWith('javascript:')) {
        //  setting an attribute returns void according to the spec
        return;
    }
    /* eslint-enable no-script-url */

    //  First, just set the 'href' to '#' to limit traversal and link display.
    TP.elementSetAttribute(elem, 'href', '#', true);

    //  Then add an 'onclick' that will service any TIBET click handling
    //  machinery and then trigger TIBET's go2 call to process the link at
    //  runtime. Note that we pass the event object so that the proper observers
    //  can be invoked and also 'return false' to help ensure no traversal from
    //  the link.
    TP.elementSetAttribute(
        elem,
        'onclick',
        ' TP.go2(\'' + value + '\', window, event);' +
        ' return false;',
        true);

    //  setting an attribute returns void according to the spec
    return;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xhtml/html_ImageModuleNodes.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'html';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.html.img
//  ========================================================================

/**
 * @type {TP.html.img}
 * @summary 'img' tag. An inline image.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('img');

TP.html.img.Type.set('uriAttrs', TP.ac('src', 'longdesc', 'usemap'));

TP.html.img.Type.set('booleanAttrs', TP.ac('isMap', 'complete'));

TP.html.img.addTraits(TP.dom.EmptyElementNode);

TP.html.img.Type.resolveTraits(
        TP.ac('booleanAttrs', 'uriAttrs'),
        TP.html.img);

TP.html.img.Inst.resolveTraits(
        TP.ac('getContent', 'setContent'),
        TP.dom.EmptyElementNode);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.img.Type.defineMethod('constructContentObject',
function(content, aURI) {

    /**
     * @method constructContentObject
     * @summary Returns a content object for the URI provided. This method is
     *     invoked as part of MIME-type specific handling for URIs vended as on
     *     of the 'img' MIME types. This method returns an image tag which is
     *     suitable for displaying the image described by the URI.
     * @param {String} content The string content to process. Typically empty
     *     and ignored for this type unless it starts with 'data:' in which case
     *     the URL is ignored and the src attribute is set to the data URI.
     * @param {TP.uri.URI} aURI The URI referencing an image.
     * @returns {Node} A valid TP.html.img node.
     */

    if (TP.isString(content) && content.startsWith('data:')) {
        return TP.tpnode(
            TP.elementFromString(
                    TP.join('<img xmlns="', TP.w3.Xmlns.XHTML,
                            '" src="',
                            content,
                            '"/>')));
    }

    return TP.tpnode(
            TP.elementFromString(
                    TP.join('<img xmlns="', TP.w3.Xmlns.XHTML,
                            '" src="',
                            aURI.getLocation(),
                            '"/>')));
});

//  ------------------------------------------------------------------------
//  Tag Phase Support
//  ------------------------------------------------------------------------

TP.html.img.Type.defineMethod('tagAttachDOM',
function(aRequest) {

    /**
     * @method tagAttachDOM
     * @summary Sets up runtime machinery for the element in aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var elem,
        handlerFunc;

    //  this makes sure we maintain parent processing
    this.callNextMethod();

    //  Make sure that we have a node to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  Register a handler function that will dispatch a TP.sig.DOMReady when
    //  the image has finished loading.
    handlerFunc =
        function() {

            //  Remove this handler to avoid memory leaks.
            elem.removeEventListener('load', handlerFunc, false);

            //  Dispatch 'TP.sig.DOMReady' for consistency with other elements
            //  that dispatch this when their 'dynamic content' is resolved.
            //  Note that we use 'dispatch()' here because this is a DOM signal
            //  and we want all of the characteristics of a DOM signal.
            TP.wrap(elem).dispatch('TP.sig.DOMReady');
        };

    elem.addEventListener('load', handlerFunc, false);

    return;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.img.Inst.defineMethod('setAttrSrc',
function(aSrc) {

    /**
     * @method setAttrSrc
     * @summary Sets the src that the receiver will use to retrieve its
     *     content.
     * @param {String} aSrc The URL that the receiver will use to fetch its
     *     content.
     */

    this.$setAttribute('src', aSrc);

    //  setting an attribute returns void according to the spec
    return;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xhtml/html_LinkModuleNodes.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'html';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.html.link
//  ========================================================================

/**
 * @type {TP.html.link}
 * @summary 'link' tag.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('link');

TP.html.link.Type.set('uriAttrs', TP.ac('href'));
TP.html.link.Type.set('reloadableUriAttrs', TP.ac('href'));

TP.html.link.addTraits(TP.dom.EmptyElementNode);

TP.html.link.Type.resolveTrait('uriAttrs', TP.html.link);

TP.html.link.Inst.resolveTraits(
        TP.ac('getContent', 'setContent'),
        TP.dom.EmptyElementNode);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.link.Type.defineMethod('mutationUpdatedStyle',
function(aTargetElem) {

    /**
     * @method mutationUpdatedStyle
     * @summary Handles a remote resource change against the supplied native
     *     element.
     * @description This method is usually activated as the result of a 'DOM
     *     Mutation' of this node because of changes to the remote resource that
     *     caused this element to be created in the first place
     * @param {HTMLElement} aTargetElem The target element computed for this
     *     signal.
     * @exception TP.sig.InvalidElement
     * @returns {TP.meta.html.link} The receiver.
     */

    var tpElem;

    if (!TP.isElement(aTargetElem)) {
        return this.raise('TP.sig.InvalidElement');
    }

    tpElem = TP.wrap(aTargetElem);

    //  Signal from our (wrapped) target element that we attached more nodes due
    //  to a mutation.
    TP.signal(TP.tpdoc(aTargetElem),
                'TP.sig.MutationStyleChange',
                TP.hc('mutationTarget', tpElem));

    return this;
});

//  ------------------------------------------------------------------------
//  Tag Phase Support
//  ------------------------------------------------------------------------

TP.html.link.Type.defineMethod('tagCompile',
function(aRequest) {

    /**
     * @method tagCompile
     * @summary Convert the receiver into a format suitable for inclusion in a
     *     markup DOM.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     * @returns {Element} The element.
     */

    var elem,
        type;

    elem = aRequest.at('node');

    //  Grab the type and, if it's a 'TIBET CSS' type of styling, then change
    //  the original element into a 'tibet:style' tag.
    type = TP.elementGetAttribute(elem, 'type', true);
    if (type === TP.ietf.mime.TIBET_CSS) {
        elem = TP.elementBecome(elem, 'tibet:style', TP.hc('tibet:tag', null));
    } else {
        elem = TP.nodeCloneNode(elem);
        TP.elementSetGenerator(elem);
    }

    return elem;
});

//  ------------------------------------------------------------------------

TP.html.link.Type.defineMethod('tagAttachDOM',
function(aRequest) {

    /**
     * @method tagAttachDOM
     * @summary Sets up runtime machinery for the element in aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var elem,
        handlerFunc;

    //  this makes sure we maintain parent processing
    this.callNextMethod();

    //  Make sure that we have a node to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  Register a handler function that will process @import'ed URIs and
    //  dispatch a TP.sig.DOMReady when the stylesheet has finished loading.
    handlerFunc =
        function() {

            var tpElem,

                stylesheet,

                mainURI,
                mainDependents,

                importHrefs,

                watchingChanges;

            //  Remove this handler to avoid memory leaks.
            elem.removeEventListener('load', handlerFunc, false);

            tpElem = TP.wrap(elem);

            //  Grab the stylesheet from the element.
            stylesheet = TP.cssElementGetStyleSheet(elem);

            //  If we have a valid CSSStyleSheet object
            if (TP.isValid(stylesheet)) {

                //  Grab the stylesheet's href as a TP.uri.URI and any dependent
                //  URIs it may have.
                mainURI = TP.uc(stylesheet.href);
                mainDependents = mainURI.get('dependentURIs');

                //  Make sure the URI has a dependents list.
                if (TP.notValid(mainDependents)) {
                    mainDependents = TP.ac();
                    mainURI.set('dependentURIs', mainDependents);
                }

                //  Grab any hrefs from @import statements in the stylesheet
                //  and, if we're watching remote changes, register ourself as
                //  observer on them. This will mean that this element will not
                //  only observe changes to the URI computed from it's 'href'
                //  attribute, but from all of the @imports referenced
                //  (recursively) in the sheet for that href.

                watchingChanges = TP.sys.cfg('uri.source.watch_changes');

                //  Note that this method, by default, will recursively retrieve
                //  @import hrefs.
                importHrefs = TP.styleSheetGetImportHrefs(stylesheet);
                importHrefs.forEach(
                    function(anHref) {
                        var uri;

                        //  NB: Note that we intern the URI one way or another,
                        //  whether we're going to watch it or not. This is
                        //  important.
                        uri = TP.uc(anHref);

                        if (TP.isURI(uri)) {
                            if (watchingChanges) {
                                tpElem.observe(uri, 'TP.sig.ValueChange');
                                uri.watch();
                            }

                            //  Track the dependents for the main URI by adding
                            //  this @import URI to its list.
                            mainDependents.push(uri);
                        }
                    });
            }

            //  Dispatch 'TP.sig.DOMReady' for consistency with other elements
            //  that dispatch this when their 'dynamic content' is resolved.
            //  Note that we use 'dispatch()' here because this is a DOM signal
            //  and we want all of the characteristics of a DOM signal.
            tpElem.dispatch('TP.sig.DOMReady');
        };

    elem.addEventListener('load', handlerFunc, false);

    return;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.link.Inst.defineMethod('reloadFromAttrHref',
function(anHref) {

    /**
     * @method reloadFromAttrHref
     * @summary Reloads the receiver with the content found at the end of the
     *     href.
     * @param {String} anHref The URL that the receiver will use to reload its
     *     content.
     * @returns {TP.html.link} The receiver.
     */

    var doc;

    //  If the receiver has a 'tibet:no-reload' attribute, then exit here
    //  without reloading.
    if (this.hasAttribute('tibet:no-reload')) {
        return this;
    }

    if (TP.notEmpty(anHref)) {

        //  Use the core primitive routine to reload our href in our native
        //  document. Note that this will automatically take care of assigning a
        //  cache-busting URL to the href, etc.
        doc = this.getNativeDocument();
        TP.documentReloadCSSLinkElementHref(doc, anHref);

        //  Work around Chrome (and possibly others) stupidity.
        //  TODO: Commented out for now - doesn't seem to need it.
        // TP.windowForceRepaint(TP.nodeGetWindow(doc));
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.html.link.Inst.defineMethod('setAttrHref',
function(anHref) {

    /**
     * @method setAttrHref
     * @summary Sets the href that the receiver will use to retrieve its
     *     content.
     * @param {String} anHref The URL that the receiver will use to fetch its
     *     content.
     */

    this.$setAttribute('href', anHref);

    //  reload from the content found at the href.
    this.reloadFromAttrHref();

    //  setting an attribute returns void according to the spec
    return;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xhtml/html_ListModuleNodes.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'html';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.html.dl
//  ========================================================================

/**
 * @type {TP.html.dl}
 * @summary 'dl' tag. Definition list.
 */

//  ------------------------------------------------------------------------

TP.html.List.defineSubtype('dl');

TP.html.dl.Type.set('booleanAttrs', TP.ac('compact'));

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.dl.Type.defineMethod('generateMarkup',
function(anObject, attrStr, itemFormat, shouldAutoWrap, formatArgs, theRequest) {

    /**
     * @method generateMarkup
     * @summary Generates markup for the supplied Object using the other
     *     parameters supplied.
     * @param {Object} anObject The Object of content to wrap in markup.
     * @param {String} attrStr The String containing either the literal
     *     attribute markup or a 'template invocation' that can be used inside
     *     of a template.
     * @param {String} itemFormat The name of an 'item format', either a tag
     *     name (which defaults to the 'item tag name' of this type) or some
     *     other format type which can be applied to this type.
     * @param {Boolean} shouldAutoWrap Whether or not the markup generation
     *     machinery should 'autowrap' items of the supplied object (each item
     *     in an Array or each key/value pair in an Object).
     * @param {TP.core.Hash} formatArgs The 'formatting arguments' used by this
     *     machinery to generate item markup.
     * @param {TP.sig.Request|TP.core.Hash} theRequest An optional object
     *     containing parameters.
     * @returns {String} The markup generated by taking the supplied Object and
     *     iterating over its items.
     */

    var tagName,
        template,
        str;

    tagName = this.getCanonicalName();

    //  Don't generate markup annotated with the data expression
    theRequest.atPut('annotateMarkup', false);

    if (TP.isTrue(shouldAutoWrap) && TP.isTrue(theRequest.at('repeat'))) {
        if (TP.isArray(anObject)) {
            //  The object that handed to the iteration mechanism is an
            //  Array, generate 'TP.html.dt' tags around each index and
            //  'TP.html.dd' tags around each value.

            //  Build a template by joining the tag name with an invocation
            //  of the 'TP.html.dt' format for the index and an invocation
            //  of the 'TP.html.dd' format for the value.
            template = TP.join('<', tagName, attrStr, '>',
                                '{{$INDEX.%TP.html.dt}}',
                                '{{value.%TP.html.dd}}',
                                '</', tagName, '>');
        } else {
            //  Otherwise, the object that will be handed to the iteration
            //  mechanism will be [key,value] pairs, so we can use that fact
            //  to generate item tags around each one.

            //  Build a template by joining the tag name with an invocation
            //  of the itemFormat for both the key and the value.
            template = TP.join('<', tagName, attrStr, '>',
                                '{{0.%TP.html.dt}}',
                                '{{1.%TP.html.dd}}',
                                '</', tagName, '>');
        }

        //  Perform the transformation.
        str = template.transform(anObject, theRequest);

        return str;
    }

    //  It was either an Array or we weren't autowrapping and repeating. In
    //  that case, just call up the supertype chain and return the value.
    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.html.dl.Type.defineMethod('getItemTagName',
function() {

    /**
     * @method getItemTagName
     * @summary Returns the 'default item tag name' for use it the
     *     fromArray()/fromObject() methods. Note that this should return the
     *     receiver's *canonical* name.
     * @returns {String} The ID of the observer.
     */

    //  NB: We return the empty String here because, if we're repeating, the
    //  generateMarkup() routine above will choose the proper dt/dd
    //  combination, based on the data source supplied, but if not we can't
    //  determine where to place what (i.e. 'TP.html.dl' tags don't have a
    //  'single' item tag) so we just bail out here.

    return '';
});

//  ------------------------------------------------------------------------

TP.html.dl.Type.defineMethod('shouldAutoWrapItems',
function(anObject, formatArgs) {

    /**
     * @method shouldAutoWrapItems
     * @summary Whether or not our fromArray() / fromObject() methods
     *     'auto-wrap items'. See those methods for more information.
     * @param {Object} anObject The Object of content to wrap in markup.
     * @param {TP.core.Hash} formatArgs An optional object containing
     *     parameters.
     * @returns {Boolean} Whether or not we automatically wrap items.
     */

    //  We should always set this to 'true' since our markup generation
    //  method override always uses templates (even though our markup
    //  generation method doesn't support autowrap).
    return true;
});

//  ========================================================================
//  TP.html.dt
//  ========================================================================

/**
 * @type {TP.html.dt}
 * @summary 'dt' tag. Definition term.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('dt');

//  ========================================================================
//  TP.html.dd
//  ========================================================================

/**
 * @type {TP.html.dd}
 * @summary 'dd' tag. Definition definition ;).
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('dd');

//  ========================================================================
//  TP.html.ol
//  ========================================================================

/**
 * @type {TP.html.ol}
 * @summary 'ol' tag. Ordered list.
 */

//  ------------------------------------------------------------------------

TP.html.List.defineSubtype('ol');

TP.html.ol.Type.set('booleanAttrs', TP.ac('compact', 'reversed'));

//  ========================================================================
//  TP.html.ul
//  ========================================================================

/**
 * @type {TP.html.ul}
 * @summary 'ul' tag. Unordered list.
 */

//  ------------------------------------------------------------------------

TP.html.List.defineSubtype('ul');

TP.html.ul.Type.set('booleanAttrs', TP.ac('compact'));

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.ul.Type.defineMethod('generateMarkup',
function(anObject, attrStr, itemFormat, shouldAutoWrap, formatArgs,
         theRequest) {

    /**
     * @method generateMarkup
     * @summary Generates markup for the supplied Object using the other
     *     parameters supplied.
     * @param {Object} anObject The Object of content to wrap in markup.
     * @param {String} attrStr The String containing either the literal
     *     attribute markup or a 'template invocation' that can be used inside
     *     of a template.
     * @param {String} itemFormat The name of an 'item format', either a tag
     *     name (which defaults to the 'item tag name' of this type) or some
     *     other format type which can be applied to this type.
     * @param {Boolean} shouldAutoWrap Whether or not the markup generation
     *     machinery should 'autowrap' items of the supplied object (each item
     *     in an Array or each key/value pair in an Object).
     * @param {TP.core.Hash} formatArgs The 'formatting arguments' used by this
     *     machinery to generate item markup.
     * @param {TP.sig.Request|TP.core.Hash} theRequest An optional object
     *     containing parameters.
     * @returns {String} The markup generated by taking the supplied Object and
     *     iterating over its items.
     */

    var tagName,
        template,
        str;

    //  Don't generate markup annotated with the data expression
    theRequest.atPut('annotateMarkup', false);

    //  If the object is an Array, then just skip to the bottom of the
    //  method.
    if (TP.isArray(anObject)) {
        void 0;
    } else if (TP.isTrue(shouldAutoWrap) && TP.isTrue(theRequest.at('repeat'))) {
        //  Otherwise, if we're autowrapping and repeating, the object that
        //  will be handed to the iteration mechanism will be [key,value]
        //  pairs, so we can use that fact to generate item tags around each
        //  one.

        tagName = this.getCanonicalName();

        //  Build a template by joining the tag name with an invocation
        //  of the itemFormat for both the key and the value.
        template = TP.join('<', tagName, attrStr, '>',
                            '{{0.%', itemFormat, '}}',
                            '{{1.%', itemFormat, '}}',
                            '</', tagName, '>');

        //  Perform the transformation.
        str = template.transform(anObject, theRequest);

        return str;
    }

    //  It was either an Array or we weren't autowrapping and repeating. In
    //  that case, just call up the supertype chain and return the value.
    return this.callNextMethod();
});

//  ========================================================================
//  TP.html.li
//  ========================================================================

/**
 * @type {TP.html.li}
 * @summary 'li' tag. List item.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('li');

TP.html.li.addTraits(TP.dom.SelectableItemUIElementNode);

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  TP.dom.SelectableItemUIElementNode Methods
//  ------------------------------------------------------------------------

TP.html.li.Inst.defineMethod('getLabelText',
function() {

    /**
     * @method getLabelText
     * @summary Returns the text of the label of the receiver.
     * @returns {String} The receiver's label text.
     */

    return this.getTextContent();
});

//  ------------------------------------------------------------------------

TP.html.li.Inst.defineMethod('$getMarkupValue',
function() {

    /**
     * @method $getMarkupValue
     * @summary Returns the 'value' of the receiver as authored by user in the
     *     markup. Many times this is represented as a 'value' attribute in the
     *     markup and serves as the default.
     * @returns {String} The markup value of the receiver.
     */

    return this.getTextContent();
});

//  ------------------------------------------------------------------------

TP.html.li.Inst.defineMethod('$getPrimitiveValue',
function() {

    /**
     * @method $getPrimitiveValue
     * @summary Returns the low-level primitive value stored by the receiver in
     *     internal storage.
     * @returns {String} The primitive value of the receiver.
     */

    return this.getTextContent();
});

//  ------------------------------------------------------------------------

TP.html.li.Inst.defineMethod('$getVisualToggle',
function() {

    /**
     * @method $getVisualToggle
     * @summary Returns the low-level primitive 'toggle value' used by the
     *     receiver to display a 'selected' state.
     * @returns {Boolean} The low-level primitive 'toggle value' of the
     *     receiver.
     */

    return this.hasAttribute('pclass:selected');
});

//  ------------------------------------------------------------------------

TP.html.li.Inst.defineMethod('isSelected',
function() {

    /**
     * @method isSelected
     * @summary Returns true if the receiver is selected.
     * @returns {Boolean} Whether or not the receiver is selected.
     */

    return this.hasAttribute('pclass:selected');
});

//  ------------------------------------------------------------------------

TP.html.li.Inst.defineMethod('$setVisualToggle',
function(aToggleValue) {

    /**
     * @method $setVisualToggle
     * @summary Sets the low-level primitive 'toggle value' used by the receiver
     *     to display a 'selected' state.
     * @param {Boolean} aToggleValue Whether or not to display the receiver's
     *     'selected' state.
     * @returns {TP.html.li} The receiver.
     */

    this.setAttribute('selected', aToggleValue);

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xhtml/html_MetainformationModuleNodes.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'html';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.html.meta
//  ========================================================================

/**
 * @type {TP.html.meta}
 * @summary 'meta' tag.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('meta');

TP.html.meta.addTraits(TP.dom.EmptyElementNode);

TP.html.meta.Inst.resolveTraits(
        TP.ac('getContent', 'setContent'),
        TP.dom.EmptyElementNode);

//  ========================================================================
//  TP.html.template
//  ========================================================================

/**
 * @type {TP.html.template}
 * @summary 'template' tag.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('template');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.template.Inst.defineMethod('getContent',
function(aRequest) {

    /**
     * @method getContent
     * @summary Returns the receiver's content.
     * @description At this level, this method returns its 'inner content',
     *     which is a serialization of the receiver's '.content' property.
     * @param {TP.sig.Request|TP.core.Hash} aRequest Optional control
     *     parameters.
     * @returns {String} The text content of the native node.
     */

    var nativeNode,
        frag;

    nativeNode = this.getNativeNode();

    //  Note here that force making a copy of the '.content' fragment -
    //  otherwise, we'll throw an error.
    frag = TP.copy(nativeNode.content);
    if (!TP.isFragment(frag)) {
        return '';
    }

    return TP.wrap(frag).asString();
});

//  ------------------------------------------------------------------------

TP.html.template.Inst.defineMethod('getContentNode',
function(aRequest) {

    /**
     * @method getContentNode
     * @summary Returns the receiver's content node(s). This method is provided
     *     for API compatibility with other types.
     * @description At this level, this method returns its 'inner content' node,
     *     which is a TP.dom.DocumentFragment, which will contain a *clone* of
     *     the receiver's '.content'. property.
     * @param {TP.sig.Request|TP.core.Hash} aRequest Optional control
     *     parameters.
     * @returns {TP.dom.DocumentFragment} A TP.dom.DocumentFragment containing
     *     a *clone* of the receiver's '.content' DocumentFragment.
     */

    var nativeNode,
        frag;

    nativeNode = this.getNativeNode();

    //  Note here that force making a copy of the '.content' fragment -
    //  otherwise, we'll throw an error.
    frag = TP.copy(nativeNode.content);
    if (!TP.isFragment(frag)) {
        return null;
    }

    return TP.wrap(frag);
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xhtml/html_ObjectModuleNodes.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'html';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.html.audio (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.audio}
 * @summary 'audio' tag. Embedded audio.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('audio');

//  ========================================================================
//  TP.html.canvas (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.canvas}
 * @summary A subtype of TP.html.Attrs that manages HTML Canvas objects.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('canvas');

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.html.canvas.Type.defineConstant('TWO_D_CONTEXT_PROPERTY_NAMES',
        TP.ac(
            //  back-reference to canvas
            'canvas',
            //  compositing
            'globalAlpha', 'globalCompositeOperation',
            //  colors and styles
            'strokeStyle', 'fillStyle',
            //  line caps/joins
            'lineWidth', 'lineCap', 'lineJoin', 'miterLimit',
            //  shadows
            'shadowOffsetX', 'shadowOffsetY', 'shadowBlur', 'shadowColor',
            //  text
            'font', 'textAlign', 'textBaseline'
            ));
TP.html.canvas.Type.defineConstant('TWO_D_CONTEXT_METHOD_NAMES',
        TP.ac(
            //  state
            'save', 'restore',
            //  transformations
            'scale', 'rotate', 'translate', 'transform', 'setTransform',
            //  colors and styles
            'createLinearGradient', 'createRadialGradient', 'createPattern',
            //  rects
            'clearRect', 'fillRect', 'strokeRect',
            //  paths
            'beginPath', 'closePath', 'moveTo', 'lineTo',
                'quadraticCurveTo', 'bezierCurveTo', 'arcTo', 'rect', 'arc',
                'fill', 'stroke', 'clip', 'isPointInPath',
            //  drawing images
            'drawImage',
            //  pixel manipulation
            'createImageData', 'getImageData', 'putImageData',
            //  text
            'fillText', 'strokeText'
            ));

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.canvas.Inst.defineMethod('toDataURL',
function(type) {

    /**
     * @method toDataURL
     * @summary Returns the data which contains a representation of the canvas
     *     as an image.
     * @param {String} type The MIME type indicating which data type to return.
     * @returns {String} The image data.
     */

    return this.getNativeNode().toDataURL(type);
});

//  ------------------------------------------------------------------------

TP.html.canvas.Inst.defineMethod('get2DContext',
function() {

    /**
     * @method get2DContext
     * @summary Returns the receiver's '2D graphics context'.
     * @returns {Object} The receiver's 2D graphics context.
     */

    return this.getNativeNode().getContext('2d');
});

//  ------------------------------------------------------------------------

TP.html.canvas.Inst.defineMethod('getContext',
function(contextId) {

    /**
     * @method getContext
     * @summary Returns the receiver's graphics context matching the supplied
     *     context id.
     * @param {String} contextId The ID of the context to fetch.
     * @returns {Object} The receiver's matching graphics context.
     */

    return this.getNativeNode().getContext(contextId);
});

//  ------------------------------------------------------------------------
//  DNU/Backstop
//  ------------------------------------------------------------------------

TP.html.canvas.Inst.defineMethod('canResolveDNU',
function(anOrigin, aMethodName, anArgArray, callingContext) {

    /**
     * @method canResolveDNU
     * @summary Provides an instance that has triggered DNU machinery with an
     *     opportunity to handle the problem itself.
     * @param {Object} anOrigin The object asking for help. The receiver in this
     *     case.
     * @param {String} aMethodName The method name that failed.
     * @param {Object[]} anArgArray Optional arguments to function.
     * @param {Function|arguments} callingContext The calling context.
     * @returns {Boolean} TRUE means resolveDNU() will be called. FALSE means
     *     the standard DNU machinery will continue processing. The default is
     *     TRUE for TP.dom.Node subtypes.
     */

    //  If the method name is in the list of method names that a 2D context
    //  (which is the object that we will redispatch to) can respond to,
    //  then we return true.
    if (this.getType().TWO_D_CONTEXT_METHOD_NAMES.contains(aMethodName)) {
        return true;
    }

    //  Couldn't find it in our list. Call up the chain.
    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.html.canvas.Inst.defineMethod('resolveDNU',
function(anOrigin, aMethodName, anArgArray, callingContext) {

    /**
     * @method resolveDNU
     * @summary Invoked by the main DNU machinery when the instance has
     *     responded TRUE to canResolveDNU() for the parameters given.
     * @description Handles resolution of methods which have triggered the
     *     inferencer. For TP.core.Window the resolution process is used in
     *     conjunction with method aspects to allow the receiver to translate
     *     method calls.
     * @param {Object} anOrigin The object asking for help.
     * @param {String} aMethodName The method name that failed.
     * @param {Object[]} anArgArray Optional arguments to function.
     * @param {Function|arguments} callingContext The calling context.
     * @returns {Object} The result of invoking the method using the native
     *     window object.
     */

    var the2DContext,
        func;

    //  Make sure that we can obtain a valid 2D context. Without that, we're
    //  going nowhere.
    if (TP.notValid(the2DContext = this.get2DContext())) {
        return this.raise('TP.sig.InvalidContext');
    }

    try {
        if (!TP.isCallable(func = the2DContext[aMethodName])) {
            return this.raise('TP.sig.InvalidFunction');
        }
    } catch (e) {
        return this.raise('TP.sig.InvalidFunction', TP.ec(e));
    }

    //  If there weren't any arguments in the arg array, then we have only
    //  to call the func.
    if (TP.notValid(anArgArray) || anArgArray.length === 0) {
        //  Return the execution of the func
        return the2DContext.func();
    }

    //  Return the application of the func using the array of arguments as
    //  the argument array for  invocation.
    return func.apply(the2DContext, anArgArray);
});

//  ------------------------------------------------------------------------

TP.html.canvas.Inst.defineMethod('$get',
function(attributeName) {

    /**
     * @method $get
     * @summary Primitive $get() hook. Allows instances of this type to look up
     *     globals on their 2D context if a value for the attribute cannot be
     *     found on the receiver itself.
     * @param {String} attributeName The name/key of the attribute to return.
     * @returns {Object}
     * @exception TP.sig.InvalidContext
     */

    var val,
        the2DContext;

    //  Start by looking for the attribute (or a method) on this object.
    val = this.callNextMethod();

    //  If we got back an undefined value, then try to see if its a 'slot'
    //  on our content window (very useful if we've loaded our content
    //  window with other code bases).
    if (TP.notDefined(val)) {
        //  Make sure that we can obtain a valid 2D context. Without that,
        //  we're going nowhere.
        if (TP.notValid(the2DContext = this.get2DContext())) {
            return this.raise('TP.sig.InvalidContext');
        }

        val = the2DContext[attributeName];
    }

    return val;
});

//  ------------------------------------------------------------------------

TP.html.canvas.Inst.defineMethod('$set',
function(attributeName, attributeValue) {

    /**
     * @method $set
     * @summary Primitive $set() hook. Allows instances of this type to set
     *     globals on their 2D context if the attribute cannot be found on the
     *     receiver itself.
     * @param {String} attributeName The attribute to set.
     * @param {Object} attributeValue The value to set it to.
     * @returns {Object}
     * @exception TP.sig.InvalidContext
     */

    var the2DContext;

    //  If the attribute name is not in the list of property names that a 2D
    //  context (which is the object that we will redispatch to) can respond
    //  to, then we return the result of calling up our chain.
    if (!this.getType().TWO_D_CONTEXT_PROPERTY_NAMES.contains(attributeName)) {
        return this.callNextMethod();
    }

    //  Make sure that we can obtain a valid 2D context. Without that, we're
    //  going nowhere.
    if (TP.notValid(the2DContext = this.get2DContext())) {
        return this.raise('TP.sig.InvalidContext');
    }

    the2DContext[attributeName] = attributeValue;

    return attributeValue;
});

//  ========================================================================
//  TP.html.embed (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.embed}
 * @summary 'embed' tag. Embedded object.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('embed');

TP.html.embed.Type.set('uriAttrs', TP.ac('src'));

//  ========================================================================
//  TP.html.object
//  ========================================================================

/**
 * @type {TP.html.object}
 * @summary 'object' tag. Embedded object.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('object');

TP.html.object.isAbstract(true);

TP.html.object.Type.set('booleanAttrs',
            TP.ac('declare', 'typeMustMatch', 'willValidate'));

TP.html.object.Type.set('uriAttrs', TP.ac('classid', 'codebase', 'usemap', 'data'));

//  ------------------------------------------------------------------------

TP.html.object.Type.defineMethod('getConcreteType',
function(aNodeOrId) {

    /**
     * @method getConcreteType
     * @summary Returns the subtype to use for the node provided. Note that for
     *     TP.html.object elements the specific type returned is based on the
     *     value of the type attribute.
     * @param {Node|String} aNodeOrId The native node to wrap or an ID used to
     *     locate it.
     * @returns {TP.meta.html.object} A TP.html.object subtype type object.
     */

    var entry,

        typeName,
        type;

    if (TP.isString(aNodeOrId)) {
        return TP.byId(aNodeOrId);
    }

    entry = TP.ietf.mime.get('info').at(
                TP.elementGetAttribute(aNodeOrId, 'type'));

    if (TP.isValid(entry)) {
        typeName = entry.at('objectNodeType');

        type = TP.sys.getTypeByName(typeName);
        if (TP.isType(type) && !type.isAbstract()) {
            return type;
        }
    } else {
        return TP.html.objectConcrete;
    }

    return this;
});

//  ========================================================================
//  TP.html.objectConcrete
//  ========================================================================

TP.html.object.defineSubtype('objectConcrete');

//  ========================================================================
//  TP.html.param
//  ========================================================================

/**
 * @type {TP.html.param}
 * @summary 'param' tag. Applet parameter.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('param');

TP.html.param.addTraits(TP.dom.EmptyElementNode);

TP.html.param.Inst.resolveTraits(
        TP.ac('getContent', 'setContent'),
        TP.dom.EmptyElementNode);

//  ========================================================================
//  TP.html.picture (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.picture}
 * @summary 'picture' tag. Group of img and 1...n source elements for displaying
 *     alternate versions of images.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('picture');

//  ========================================================================
//  TP.html.source (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.source}
 * @summary 'source' tag. Video or audio source.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('source');

TP.html.source.Type.set('uriAttrs', TP.ac('src'));

//  ========================================================================
//  TP.html.track (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.track}
 * @summary 'track' tag. Tracks for media elements.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('track');

TP.html.track.Type.set('uriAttrs', TP.ac('src'));
TP.html.track.Type.set('booleanAttrs', TP.ac('default'));

TP.html.track.addTraits(TP.dom.EmptyElementNode);

TP.html.track.Inst.resolveTraits(
        TP.ac('getContent', 'setContent'),
        TP.dom.EmptyElementNode);

//  ========================================================================
//  TP.html.video (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.video}
 * @summary 'video' tag. Embedded video.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('video');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xhtml/html_PresentationModuleNodes.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'html';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.html.b
//  ========================================================================

/**
 * @type {TP.html.b}
 * @summary 'b' tag. Bold font.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('b');

//  ========================================================================
//  TP.html.big
//  ========================================================================

/**
 * @type {TP.html.big}
 * @summary 'big' tag. Bigger font.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('big');

//  ========================================================================
//  TP.html.data (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.data}
 * @summary 'data' tag. A tag that links content with a machine-readable
 *     translation.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('data');

//  ------------------------------------------------------------------------

TP.html.data.Inst.defineMethod('getDisplayValue',
function() {

    /**
     * @method getDisplayValue
     * @summary Returns the value of the receiver.
     * @returns {String} The receiver's formatted input value.
     */

    return this.getNativeNode().value;
});

//  ------------------------------------------------------------------------

TP.html.data.Inst.defineMethod('setDisplayValue',
function(aValue) {

    /**
     * @method setDisplayValue
     * @summary Sets the value of the receiver.
     * @returns {TP.html.data} The receiver.
     */

    this.getNativeNode().value = TP.str(aValue);

    return this;
});

//  ========================================================================
//  TP.html.details (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.details}
 * @summary 'details' tag. Represents additional information which the user can
 *     obtain on demand.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('details');

TP.html.details.Type.set('booleanAttrs', TP.ac('open'));

//  ========================================================================
//  TP.html.dialog (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.dialog}
 * @summary 'dialog' tag. Defines a dialog box or window.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('dialog');

TP.html.dialog.Type.set('booleanAttrs', TP.ac('open'));

//  ========================================================================
//  TP.html.hr
//  ========================================================================

/**
 * @type {TP.html.hr}
 * @summary 'hr' tag. Horizontal rule.
 */

//  ------------------------------------------------------------------------

TP.html.Aligned.defineSubtype('hr');

TP.html.hr.Type.set('booleanAttrs', TP.ac('noShade'));

TP.html.hr.addTraits(TP.dom.EmptyElementNode);

TP.html.hr.Type.resolveTrait('booleanAttrs', TP.html.Element);

TP.html.hr.Inst.resolveTraits(
        TP.ac('getContent', 'setContent'),
        TP.dom.EmptyElementNode);

//  ========================================================================
//  TP.html.i
//  ========================================================================

/**
 * @type {TP.html.i}
 * @summary 'i' tag. Italic font.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('i');

//  ========================================================================
//  TP.html.menu (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.menu}
 * @summary 'menu' tag. Defines a menu.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('menu');

//  ========================================================================
//  TP.html.menuitem (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.menuitem}
 * @summary 'menuitem' tag. Defines a menuitem.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('menuitem');

//  ========================================================================
//  TP.html.meter (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.meter}
 * @summary 'meter' tag. A measurement, such as disk usage.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('meter');

//  ========================================================================
//  TP.html.progress (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.progress}
 * @summary 'progress' tag. A completion of a task, such as downloading.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('progress');

//  ========================================================================
//  TP.html.small
//  ========================================================================

/**
 * @type {TP.html.small}
 * @summary 'small' tag. Smaller font.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('small');

//  ========================================================================
//  TP.html.sub
//  ========================================================================

/**
 * @type {TP.html.sub}
 * @summary 'sub' tag. Subscript.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('sub');

//  ========================================================================
//  TP.html.summary (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.summary}
 * @summary 'summary' tag. Represents summary information for a 'details' tag.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('summary');

//  ========================================================================
//  TP.html.sup
//  ========================================================================

/**
 * @type {TP.html.sup}
 * @summary 'sup' tag. Superscript.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('sup');

//  ========================================================================
//  TP.html.time (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.time}
 * @summary 'time' tag. A data and/or time.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('time');

//  ========================================================================
//  TP.html.tt
//  ========================================================================

/**
 * @type {TP.html.tt}
 * @summary 'tt' tag. Fixed (teletype/typewriter) font.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('tt');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xhtml/html_ScriptingModuleNodes.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'html';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.html.noscript
//  ========================================================================

/**
 * @type {TP.html.noscript}
 * @summary 'noscript' tag. When client-side scripts disabled/unsupported.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('noscript');

//  ========================================================================
//  TP.html.script
//  ========================================================================

/**
 * @type {TP.html.script}
 * @summary 'script' tag. Embedded programming -- hmmm sounds familiar ;)
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('script');

TP.html.script.Type.set('booleanAttrs', TP.ac('async', 'defer'));

TP.html.script.Type.set('uriAttrs', TP.ac('src', 'source'));
TP.html.script.Type.set('reloadableUriAttrs', TP.ac('src', 'source'));

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.script.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time type initialization.
     */

    var watchSources,
        query,
        scripts,
        req,
        len,
        i;

    if (TP.sys.cfg('uri.source.watch_changes')) {

        //  Build a CSS query of the watched source paths that can be tested
        //  against all of the 'script' elements in the top-level window's
        //  document. This is where all TIBET code resides. We only want to set
        //  up observations on scripts that are under those paths.
        watchSources = TP.sys.cfg('uri.watch.include');
        query = 'script[src^="' + TP.uriExpandPath(watchSources.at(0)) + '"]';

        for (i = 1; i < watchSources.getSize(); i++) {
            query += ', script[src^="' +
                        TP.uriExpandPath(watchSources.at(i)) +
                        '"]';
        }

        //  Query for them.
        scripts = TP.byCSSPath(query, TP.sys.getLaunchDocument(), false, false);

        req = TP.request();

        //  Loop over each script element found and manually call 'tagAttachDOM'
        //  with a manually constructed request.
        len = scripts.getSize();
        for (i = 0; i < len; i++) {
            req.atPut('node', scripts.at(i));
            TP.html.script.tagAttachDOM(req);
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.html.script.Type.defineMethod('$xmlifyContent',
function(src) {

    //  TODO:   optimize for sugared XHTML input
    return src;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.script.Inst.defineHandler('ValueChange',
function(aSignal) {

    /**
     * @method handleValueChange
     * @summary Handles notification of a change.
     * @description For 'html:script' elements, when they are (re)imported, we
     *     do *not* respond to value changes, as that is handled specially by
     *     the system.
     * @param {TP.sig.Signal} aSignal The signal instance to respond to.
     * @returns {TP.html.script} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.html.script.Inst.defineMethod('reloadFromAttrSrc',
function(aSrc) {

    /**
     * @method reloadFromAttrSrc
     * @summary Reloads the receiver with the content found at the end of the
     *     src by refreshing the 'src' attribute. This will *not* cause the
     *     'whole source text' to be brought in.
     * @param {String} aSrc The URL that the receiver will use to reload its
     *     content.
     * @returns {TP.html.script} The receiver.
     */

    //  For now, we just use the same routine as loading script using the whole
    //  text source.

    //  TODO: Convert this to using the boot system to (re)load by setting the
    //  'src' attribute of the native node.
    return this.reloadFromAttrSource(aSrc);
});

//  ------------------------------------------------------------------------

TP.html.script.Inst.defineMethod('reloadFromAttrSource',
function(aSource) {

    /**
     * @method reloadFromAttrSource
     * @summary Reloads the receiver with the content found at the end of the
     *     source by bringing in the whole source content and refreshing it.
     * @param {String} aSource The URL that the receiver will use to reload its
     *     content.
     * @returns {TP.html.script} The receiver.
     */

    var srcURL,
        resp,
        src,
        defining,
        typenames;

    if (TP.notEmpty(aSource)) {

        srcURL = TP.uc(aSource);
        if (!TP.isURI(srcURL)) {
            return this.raise('InvalidURI',
                                'Not a valid \'src\' URI: ' + aSource);
        }

        resp = srcURL.getResource(
                TP.hc('async', false, 'resultType', TP.TEXT, 'refresh', true));
        src = resp.get('result');

        if (TP.notValid(src)) {
            return this.raise('InvalidString',
                                'No valid Javascript source from: ' + aSource);
        }


        //  A little trick here to intercept which types load in the source.
        defining = TP.sys.definingTypename;

        typenames = TP.ac();

        TP.sys.definingTypename = function(typename) {
            typenames.push(typename);
        };

        try {
            //  Do the job of importing the source. Note that this uses the
            //  actual supplied source code in the src argument for eval'ing
            //  purposes. The location is provided for source code tracking.
            TP.boot.$sourceImport(src, null, srcURL.getLocation(), true);
        } finally {
            TP.sys.definingTypename = defining;
        }

        typenames.forEach(
                function(typename) {
                    var type;

                    type = TP.sys.getTypeByName(typename);
                    if (TP.canInvoke(type, 'refreshInstances')) {
                        type.refreshInstances();
                    }
                });
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.html.script.Inst.defineMethod('setAttrSource',
function(aSource) {

    /**
     * @method setAttrSource
     * @summary Sets the 'source' that the receiver will use to retrieve its
     *     content. Note that this refreshes the source by causing the entire
     *     text content of the script node to be brought in.
     * @param {String} aSource The URL that the receiver will use to fetch its
     *     content.
     */

    this.$setAttribute('source', aSource);

    //  reload from the content found at the 'source'.
    this.reloadFromAttrSource(aSource);

    //  setting an attribute returns void according to the spec
    return;
});

//  ------------------------------------------------------------------------

TP.html.script.Inst.defineMethod('setAttrSrc',
function(aSrc) {

    /**
     * @method setAttrSrc
     * @summary Sets the src that the receiver will use to retrieve its
     *     content. Note that this just refreshes the 'src' attribute and does
     *     not cause the entire text content of the script node to be brought
     *     in.
     * @param {String} aSrc The URL that the receiver will use to fetch its
     *     content.
     */

    this.$setAttribute('src', aSrc);

    //  reload from the content found at the src.
    this.reloadFromAttrSrc(aSrc);

    //  setting an attribute returns void according to the spec
    return;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xhtml/html_StructureModuleNodes.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'html';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.html.article (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.article}
 * @summary 'article' tag. Blog entry or newspaper article.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('article');

//  ========================================================================
//  TP.html.aside (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.aside}
 * @summary 'aside' tag. Content that is slightly related to the rest of the
 *     page.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('aside');

//  ========================================================================
//  TP.html.body
//  ========================================================================

/**
 * @type {TP.html.body}
 * @summary 'body' tag. Document body.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('body');

TP.html.body.Type.set('uriAttrs', TP.ac('background'));

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.body.Type.defineMethod('isResponderForUIFocusChange',
function(aNode, aSignal) {

    /**
     * @method isResponderForUIFocusChange
     * @summary Returns true because the body is always focusable.
     * @param {Node} aNode The node to check which may have further data as to
     *     whether this type should be considered to be a responder.
     * @param {TP.sig.Signal} aSignal The signal that responders are being
     *     computed for.
     * @returns {Boolean} True when the receiver should respond to aSignal.
     */

    return true;
});

//  ------------------------------------------------------------------------

TP.html.body.Type.defineMethod('isResponderForUIFocusComputation',
function(aNode, aSignal) {

    /**
     * @method isResponderForUIFocusComputation
     * @summary Returns true because the body can always participate in focus
     *     computations.
     * @param {Node} aNode The node to check which may have further data as to
     *     whether this type should be considered to be a responder.
     * @param {TP.sig.Signal} aSignal The signal that responders are being
     *     computed for.
     * @returns {Boolean} True when the receiver should respond to aSignal.
     */

    return true;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.body.Inst.defineMethod('becomeFocusedResponder',
function() {

    /**
     * @method becomeFocusedResponder
     * @summary Tells the receiver that it is now the 'focused responder'.
     * @returns {TP.html.body} The receiver.
     */

    //  We override this from our supertype because, while we're considered
    //  officially 'focusable', we'll never want to be pushed onto the focus
    //  stack.

    return this;
});

//  ------------------------------------------------------------------------

TP.html.body.Inst.defineMethod('resignFocusedResponder',
function() {

    /**
     * @method resignFocusedResponder
     * @summary Tells the receiver that it is no longer the 'focused
     *     responder'.
     * @returns {TP.html.body} The receiver.
     */

    //  We override this from our supertype because, while we're considered
    //  officially 'focusable', we'll never be pushed onto the focus stack and
    //  'blurring' us should never cause the focus stack to be manipulated.

    return this;
});

//  ========================================================================
//  TP.html.figcaption (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.figcaption}
 * @summary 'figcaption' tag. A figure caption.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('figcaption');

//  ========================================================================
//  TP.html.figure (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.figure}
 * @summary 'figure' tag. A piece of self-contained flow content.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('figure');

//  ========================================================================
//  TP.html.footer (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.footer}
 * @summary 'footer' tag. A footer for a section.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('footer');

//  ========================================================================
//  TP.html.head
//  ========================================================================

/**
 * @type {TP.html.head}
 * @summary 'head' tag. Document head.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('head');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.head.Type.defineMethod('tagTidy',
function(aRequest) {

    /**
     * @method tagTidy
     * @summary Coalesce and rewrite head content such as css:sheet nodes to
     *     ensure we have them ready for css:* processing later on.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    TP.ifTrace() && TP.sys.cfg('log.css_processing') ?
        TP.trace('Merging css:sheet elements into css:sheetset',
                    TP.CSS_LOG) : 0;

    //  TODO:   tidy up the css:sheet elements from tagCompile phase.

    return;
});

//  ========================================================================
//  TP.html.header (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.header}
 * @summary 'header' tag. A header for a section.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('header');

//  ========================================================================
//  TP.html.html
//  ========================================================================

/**
 * @type {TP.html.html}
 * @summary 'html' tag. Document root.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('html');

//  ------------------------------------------------------------------------
//  Tag Phase Support
//  ------------------------------------------------------------------------

TP.html.html.Type.defineMethod('tagTidy',
function(aRequest) {

    /**
     * @method tagTidy
     * @summary Updates the document so that it remains valid and ready for
     *     storage. The primary responsibility here is moving any expanded
     *     content from the head to the body so the browser stays happy.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var node,

        doc,

        head,

        nonValidElements,

        body,

        len,
        i,

        child;

    node = aRequest.at('node');

    doc = TP.nodeGetDocument(node);
    if (TP.isDocument(doc)) {
        head = TP.nodeGetElementsByTagName(doc, 'head').at(0);

        if (TP.isElement(head)) {
            nonValidElements = TP.nodeEvaluateXPath(
                                head,
                                TP.join('./*[',
                                        'local-name() != "base" and ',
                                        'local-name() != "link" and ',
                                        'local-name() != "meta" and ',
                                        'local-name() != "object" and ',
                                        'local-name() != "script" and ',
                                        'local-name() != "style" and ',
                                        'local-name() != "title" and ',
                                        'namespace-uri() != "',
                                            TP.w3.Xmlns.CSSML, '"',
                                        ']'),
                                TP.NODESET);
        }

        if (TP.notEmpty(nonValidElements)) {
            body = TP.nodeGetElementsByTagName(doc, 'body').at(0);

            if (TP.isElement(body)) {
                len = nonValidElements.getSize();
                for (i = 0; i < len; i++) {
                    child = nonValidElements.at(i);
                    body.appendChild(child);
                }
            }
        }
    }

    return;
});

//  ========================================================================
//  TP.html.main (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.main}
 * @summary 'main' tag. Defines a main.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('main');

//  ========================================================================
//  TP.html.nav (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.nav}
 * @summary 'nav' tag. Section of the document intended for navigation.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('nav');

//  ========================================================================
//  TP.html.section (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.section}
 * @summary 'section' tag. Document section.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('section');

//  ========================================================================
//  TP.html.title
//  ========================================================================

/**
 * @type {TP.html.title}
 * @summary 'title' tag. Document title.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('title');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xhtml/html_StylesheetModuleNodes.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'html';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.html.style
//  ========================================================================

/**
 * @type {TP.html.style}
 * @summary 'style' tag.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('style');

TP.html.style.Type.set('booleanAttrs', TP.ac('scoped'));
TP.html.style.Type.set('reloadableUriAttrs', TP.ac('tibet:originalhref'));

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.style.Type.defineMethod('mutationUpdatedStyle',
function(aTargetElem) {

    /**
     * @method mutationUpdatedStyle
     * @summary Handles a remote resource change against the supplied native
     *     element.
     * @description This method is usually activated as the result of a 'DOM
     *     Mutation' of this node because of changes to the remote resource that
     *     caused this element to be created in the first place
     * @param {HTMLElement} aTargetElem The target element computed for this
     *     signal.
     * @exception TP.sig.InvalidElement
     * @returns {TP.meta.html.style} The receiver.
     */

    var tpElem;

    if (!TP.isElement(aTargetElem)) {
        return this.raise('TP.sig.InvalidElement');
    }

    tpElem = TP.wrap(aTargetElem);

    //  Notify stylesheets that are dependent on this one that it has loaded or
    //  reloaded.
    tpElem.notifyDependentsOfReload();

    //  Signal from our (wrapped) target element that we attached more nodes due
    //  to a mutation.
    TP.signal(TP.tpdoc(aTargetElem),
                'TP.sig.MutationStyleChange',
                TP.hc('mutationTarget', tpElem));

    return this;
});

//  ------------------------------------------------------------------------
//  Tag Phase Support
//  ------------------------------------------------------------------------

TP.html.style.Type.defineMethod('tagCompile',
function(aRequest) {

    /**
     * @method tagCompile
     * @summary Convert the receiver into a format suitable for inclusion in a
     *     markup DOM.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     * @returns {Element} The element.
     */

    var elem,
        type;

    elem = aRequest.at('node');

    //  Grab the type and, if it's a 'TIBET CSS' type of styling, then change
    //  the original element into a 'tibet:style' tag.
    type = TP.elementGetAttribute(elem, 'type', true);
    if (type === TP.ietf.mime.TIBET_CSS) {
        elem = TP.elementBecome(elem, 'tibet:style', TP.hc('tibet:tag', null));
    } else {
        elem = TP.nodeCloneNode(elem);
        TP.elementSetGenerator(elem);
    }

    return elem;
});

//  ------------------------------------------------------------------------

TP.html.style.Type.defineMethod('tagAttachDOM',
function(aRequest) {

    /**
     * @method tagAttachDOM
     * @summary Sets up runtime machinery for the element in aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var elem,
        handlerFunc;

    //  this makes sure we maintain parent processing
    this.callNextMethod();

    //  Make sure that we have a node to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        return this.raise('TP.sig.InvalidNode');
    }

    //  Register a handler function that will process @import'ed URIs and
    //  dispatch a TP.sig.DOMReady when the stylesheet has finished loading.
    handlerFunc =
        function() {

            var stylesheet,
                importHrefs;

            //  Remove this handler to avoid memory leaks.
            elem.removeEventListener('load', handlerFunc, false);

            //  Grab the stylesheet from the element.
            stylesheet = TP.cssElementGetStyleSheet(elem);

            //  If we have a valid CSSStyleSheet object
            if (TP.isValid(stylesheet)) {

                //  Intern the stylesheet's href as a TP.uri.URI. Note that we
                //  don't care about the return value here - we're simply
                //  interested in having a URI object matching the href here.
                TP.uc(stylesheet.href);

                //  Grab any hrefs from @import statements in the stylesheet and
                //  create instances of TP.uri.URIs from them as well. Again,
                //  we're not interested in the return values here. Note that
                //  this method, by default, will recursively retrieve @import
                //  hrefs.
                importHrefs = TP.styleSheetGetImportHrefs(stylesheet);
                importHrefs.forEach(
                    function(anHref) {
                        TP.uc(anHref);
                    });
            }

            //  If the element doesn't have a 'imports' attribute (and,
            //  therefore, doesn't have other resources - usually @imports that
            //  it's waiting on and are being processed separately), dispatch
            //  'TP.sig.DOMReady'. This provides for consistency with other
            //  elements that dispatch this when their 'dynamic content' is
            //  resolved.
            //  Note that we use 'dispatch()' here because this is a DOM signal
            //  and we want all of the characteristics of a DOM signal.
            if (!TP.elementHasAttribute(elem, 'imports', true)) {
                TP.wrap(elem).dispatch(
                            'TP.sig.DOMReady', null, TP.hc('target', elem));
            }
        };

    elem.addEventListener('load', handlerFunc, false);

    return;
});

//  ------------------------------------------------------------------------

TP.html.style.Type.defineMethod('tagDetachComplete',
function(aRequest) {

    /**
     * @method tagDetachComplete
     * @summary Executes when the tag's detachment phases are fully complete.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var elem,
        typeName,

        type;

    //  this makes sure we maintain parent processing
    this.callNextMethod();

    //  Make sure that we have a node to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        //  TODO: Raise an exception
        return;
    }

    //  If the element has an associated TIBET type, use it to maintain that
    //  type's list of where it's stylesheets have been loaded.
    typeName = TP.elementGetAttribute(elem, 'tibet:type', true);
    if (TP.notEmpty(typeName)) {

        //  Grab the type and, if it's a subtype of TP.dom.UIElementNode, then
        //  remove this Element's Document from the list of where its
        //  stylesheets are loaded.
        type = TP.sys.getTypeByName(typeName);
        if (TP.isKindOf(type, TP.dom.UIElementNode)) {
            type.get('loadedStylesheetDocumentGIDs').remove(
                        TP.wrap(elem).getDocument().getGlobalID());
        }
    }

    return;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.html.style.Inst.defineMethod('notifyDependentsOfReload',
function() {

    /**
     * @method notifyDependentsOfReload
     * @summary Notifies any other HTML style elements that are dependent on
     *     this element loading that it has done so. This may allow them to
     *     finally indicate that they are ready, if the receiver is the last one
     *     they were waiting on.
     * @returns {TP.html.style} The receiver.
     */

    var natDoc,

        targetID,

        dependentElements,
        dependentElement,

        len,
        i,

        attrVal,
        idValIndex;

    natDoc = this.getNativeDocument();

    //  Get our local ID and slice off the '_generated' suffix if it exists.
    //  This is because our ID will have gotten registered with any dependent
    //  style elements without the '_generated' suffix.
    targetID = this.getLocalID();
    if (targetID.endsWith('_generated')) {
        targetID = targetID.slice(0, -10);
    }

    //  Query the document head to see if there are any other style elements
    //  that have our ID *anywhere* in the value of their 'imports' attribute.
    dependentElements = TP.byCSSPath(
                            '> style[imports*="' + targetID + '"]',
                            TP.documentGetHead(natDoc),
                            false,
                            false);

    len = dependentElements.getSize();
    for (i = 0; i < len; i++) {

        dependentElement = dependentElements.at(i);

        //  Grab the value of the 'imports' attribute and split on the TP.JOIN
        //  character, which is what all of its dependent IDs was joined on.
        attrVal = TP.elementGetAttribute(dependentElement, 'imports', true);
        attrVal = attrVal.split(TP.JOIN);

        //  Splice out our ID from the list of dependent IDs on the dependent
        //  element.
        idValIndex = attrVal.indexOf(targetID);
        attrVal.splice(idValIndex, 1);

        //  If our ID was the last one, then we remove the 'imports' attribute
        //  from the dependent element and signal that it's ready to go.
        if (TP.isEmpty(attrVal)) {

            TP.elementRemoveAttribute(dependentElement, 'imports', true);

            TP.wrap(dependentElement).dispatch('TP.sig.DOMReady');

        } else {

            //  Otherwise, there are other dependent IDs, so we join them back
            //  together and set the attribute to that new value.
            TP.elementSetAttribute(
                        dependentElement,
                        'imports',
                        attrVal.join(TP.JOIN),
                        true);
        }
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.html.style.Inst.defineMethod('reloadFromAttrTibetOriginalhref',
function(anHref) {

    /**
     * @method reloadFromAttrTibetOriginalhref
     * @summary Sets the href that the receiver will use to retrieve its
     *     content.
     * @description Note that the only reason that the receiver would have this
     *     attribute is if is an 'inlined' version of an XHTML 'link' element.
     *     Therefore, when we refresh its content because its URL changed, we
     *     always inline the content, thereby matching the original action.
     * @param {String} anHref The URL that the receiver will use to fetch its
     *     content.
     * @returns {TP.html.style} The receiver.
     */

    var styleURI,

        inlinedStyleElem,

        fetchOptions,

        styleContent;

    styleURI = TP.uc(anHref);

    if (TP.isURI(styleURI)) {

        //  Grab any existing inlined style element, if available. Note that we
        //  make sure to go after only HTML style elements here.
        inlinedStyleElem = TP.byCSSPath(
                                'html|style[tibet|originalhref=' +
                                '"' +
                                styleURI.getOriginalSource() +
                                '"]',
                            this.getNativeDocument(),
                            true,
                            false);

        //  If the element existed, check to make sure that it
        //  doesn't have a 'tibet:no-reload' attribute. If it does,
        //  then exit here without reloading.
        if (TP.isElement(inlinedStyleElem) &&
            TP.elementHasAttribute(
                inlinedStyleElem, 'tibet:no-reload', true)) {
            return this;
        }

        //  Fetch the CSS content *synchronously*
        fetchOptions = TP.hc('async', false, 'resultType', TP.TEXT);
        styleContent = styleURI.getResource(fetchOptions).get('result');

        //  Set the content of the style element that contains the inlined
        //  style (which will be ourself), resolving @import statements and
        //  possible rewriting CSS url(...) values.
        TP.documentInlineCSSURIContent(
                        this.getNativeDocument(),
                        styleURI,
                        styleContent,
                        this.getNativeNode().nextSibling);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.html.style.Inst.defineMethod('serializeCloseTag',
function(storageInfo) {

    /**
     * @method serializeCloseTag
     * @summary Serializes the closing tag for the receiver.
     * @description At this type level, this method, in conjunction with the
     *     'serializeOpenTag' method, will always produce the 'XML version' of
     *     an empty tag (i.e. '<foo/>' rather than '<foo></foo>').
     * @param {TP.core.Hash} storageInfo A hash containing various flags for and
     *     results of the serialization process. Notable keys include:
     *          'wantsXMLDeclaration': Whether or not the document node should
     *          include an 'XML declaration' at the start of it's serialization.
     *          The default is false.
     *          'result': The current serialization result as it's being built
     *          up.
     *          'store': The key under which the current serialization result
     *          will be stored.
     *          'stores': A hash of 1...n serialization results that were
     *          generated during the serialization process. Note that nested
     *          nodes might generated results that will go into different
     *          stores, and so they will all be stored here, each keyed by a
     *          unique key (which, by convention, will be the URI they should be
     *          saved to).
     * @returns {String} A serialization of the closing tag of the receiver.
     */

    var attrNode;

    attrNode = this.getNativeNode().attributes.id;
    if (TP.isAttributeNode(attrNode)) {
        if (attrNode.value.endsWith('_generated')) {
            return TP.CONTINUE;
        }
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.html.style.Inst.defineMethod('serializeOpenTag',
function(storageInfo) {

    /**
     * @method serializeOpenTag
     * @summary Serializes the opening tag for the receiver.
     * @description At this type level, this method performs a variety of
     *     transformations and filtering of various attributes. See the code
     *     below for more details. One notable transformation is that this
     *     method, in conjunction with the 'serializeCloseTag' method,  will
     *     always produce the 'XML version' of an empty tag (i.e. '<foo/>'
     *     rather than '<foo></foo>').
     * @param {TP.core.Hash} storageInfo A hash containing various flags for and
     *     results of the serialization process. Notable keys include:
     *          'wantsXMLDeclaration': Whether or not the document node should
     *          include an 'XML declaration' at the start of it's serialization.
     *          The default is false.
     *          'result': The current serialization result as it's being built
     *          up.
     *          'store': The key under which the current serialization result
     *          will be stored.
     *          'stores': A hash of 1...n serialization results that were
     *          generated during the serialization process. Note that nested
     *          nodes might generated results that will go into different
     *          stores, and so they will all be stored here, each keyed by a
     *          unique key (which, by convention, will be the URI they should be
     *          saved to).
     * @returns {String} A serialization of the opening tag of the receiver.
     */

    var attrNode;

    attrNode = this.getNativeNode().attributes.id;
    if (TP.isAttributeNode(attrNode)) {
        if (attrNode.value.endsWith('_generated')) {
            return TP.CONTINUE;
        }
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xhtml/html_TableModuleNodes.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'html';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.html.tcell
//  ========================================================================

TP.html.Attrs.defineSubtype('tcell');

//  can't construct concrete instances of this
TP.html.tcell.isAbstract(true);

TP.html.tcell.Type.set('booleanAttrs', TP.ac('noWrap'));

//  ========================================================================
//  TP.html.tcolumn
//  ========================================================================

TP.html.tcell.defineSubtype('tcolumn');

//  can't construct concrete instances of this
TP.html.tcolumn.isAbstract(true);

//  ========================================================================
//  TP.html.caption
//  ========================================================================

/**
 * @type {TP.html.caption}
 * @summary 'caption' tag.
 */

//  ------------------------------------------------------------------------

TP.html.Aligned.defineSubtype('caption');

//  ========================================================================
//  TP.html.col
//  ========================================================================

/**
 * @type {TP.html.col}
 * @summary 'col' tag.
 */

//  ------------------------------------------------------------------------

TP.html.tcolumn.defineSubtype('col');

TP.html.col.addTraits(TP.dom.EmptyElementNode);

TP.html.col.Type.resolveTrait('booleanAttrs', TP.html.Element);

TP.html.col.Inst.resolveTraits(
        TP.ac('getContent', 'setContent'),
        TP.dom.EmptyElementNode);

//  ========================================================================
//  TP.html.colgroup
//  ========================================================================

/**
 * @type {TP.html.colgroup}
 * @summary 'colgroup' tag.
 */

//  ------------------------------------------------------------------------

TP.html.tcolumn.defineSubtype('colgroup');

//  ========================================================================
//  TP.html.table
//  ========================================================================

/**
 * @type {TP.html.table}
 * @summary 'table' tag.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('table');

TP.html.table.Type.set('booleanAttrs', TP.ac('sortable'));

//  ------------------------------------------------------------------------

TP.backstop(
    TP.ac('createCaption',
            'createTFoot',
            'createTHead',
            'deleteCaption',
            'deleteRow',
            'deleteTFoot',
            'deleteTHead',
            'insertRow'),
            TP.html.table.getInstPrototype());

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.table.Type.defineMethod('generateMarkup',
function(anObject, attrStr, itemFormat, shouldAutoWrap, formatArgs,
         theRequest) {

    /**
     * @method generateMarkup
     * @summary Generates markup for the supplied Object using the other
     *     parameters supplied.
     * @param {Object} anObject The Object of content to wrap in markup.
     * @param {String} attrStr The String containing either the literal
     *     attribute markup or a 'template invocation' that can be used inside
     *     of a template.
     * @param {String} itemFormat The name of an 'item format', either a tag
     *     name (which defaults to the 'item tag name' of this type) or some
     *     other format type which can be applied to this type.
     * @param {Boolean} shouldAutoWrap Whether or not the markup generation
     *     machinery should 'autowrap' items of the supplied object (each item
     *     in an Array or each key/value pair in an Object).
     * @param {TP.core.Hash} formatArgs The 'formatting arguments' used by this
     *     machinery to generate item markup.
     * @param {TP.sig.Request|TP.core.Hash} theRequest An optional object
     *     containing parameters.
     * @returns {String} The markup generated by taking the supplied Object and
     *     iterating over its items.
     */

    var tagName,
        template,
        str;

    tagName = this.getCanonicalName();

    //  Don't generate markup annotated with the data expression
    theRequest.atPut('annotateMarkup', false);

    if (TP.isTrue(shouldAutoWrap) && TP.isTrue(theRequest.at('repeat'))) {
        //  Build a template by joining the tag name with an invocation of
        //  the 'TP.html.tr' format for the value.
        template = TP.join('<', tagName, attrStr, '>',
                            '{{value.%TP.html.tr}}',
                            '</', tagName, '>');

        //  Perform the transformation.
        str = template.transform(anObject, theRequest);

        return str;
    }

    //  It was either an Array or we weren't autowrapping and repeating. In
    //  that case, just call up the supertype chain and return the value.
    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.html.table.Type.defineMethod('getItemTagName',
function() {

    /**
     * @method getItemTagName
     * @summary Returns the 'default item tag name' for use it the
     *     fromArray()/fromObject() methods. Note that this should return the
     *     receiver's *canonical* name.
     * @returns {String} The item tag name.
     */

    return 'html:tr';
});

//  ------------------------------------------------------------------------

TP.html.table.Type.defineMethod('shouldAutoWrapItems',
function(anObject, formatArgs) {

    /**
     * @method shouldAutoWrapItems
     * @summary Whether or not our fromArray() / fromObject() methods
     *     'auto-wrap items'. See those methods for more information.
     * @param {Object} anObject The Object of content to wrap in markup.
     * @param {TP.core.Hash} formatArgs An optional object containing
     *     parameters.
     * @returns {Boolean} Whether or not we automatically wrap items.
     */

    if (TP.isBoolean(formatArgs.at('autowrap'))) {
        return formatArgs.at('autowrap');
    }

    //  An 'TP.html.table's default is to *not* wrap each item of an Object
    //  in its own tags (maybe each one goes in an 'TP.html.tr').
    return false;
});

//  ========================================================================
//  TP.html.tbody
//  ========================================================================

/**
 * @type {TP.html.tbody}
 * @summary 'tbody' tag. Table body.
 */

//  ------------------------------------------------------------------------

TP.html.tcell.defineSubtype('tbody');

//  ------------------------------------------------------------------------

TP.backstop(
    TP.ac('deleteRow',
            'insertRow'),
            TP.html.tbody.getInstPrototype());

//  ========================================================================
//  TP.html.td
//  ========================================================================

/**
 * @type {TP.html.td}
 * @summary 'td' tag. Table data.
 */

//  ------------------------------------------------------------------------

TP.html.tcell.defineSubtype('td');

//  ========================================================================
//  TP.html.tfoot
//  ========================================================================

/**
 * @type {TP.html.tfoot}
 * @summary 'tfoot' tag. Table footing.
 */

//  ------------------------------------------------------------------------

TP.html.tcell.defineSubtype('tfoot');

//  ========================================================================
//  TP.html.th
//  ========================================================================

/**
 * @type {TP.html.th}
 * @summary 'th' tag. Table heading.
 */

//  ------------------------------------------------------------------------

TP.html.tcell.defineSubtype('th');

//  ========================================================================
//  TP.html.thead
//  ========================================================================

/**
 * @type {TP.html.thead}
 * @summary 'thead' tag. Table heading.
 */

//  ------------------------------------------------------------------------

TP.html.tcell.defineSubtype('thead');

//  ========================================================================
//  TP.html.tr
//  ========================================================================

/**
 * @type {TP.html.tr}
 * @summary 'tr' tag. Table row.
 */

//  ------------------------------------------------------------------------

TP.html.tcell.defineSubtype('tr');

//  ------------------------------------------------------------------------

TP.backstop(
    TP.ac('deleteCell',
            'insertCell'),
            TP.html.tr.getInstPrototype());

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.html.tr.Type.defineMethod('generateMarkup',
function(anObject, attrStr, itemFormat, shouldAutoWrap, formatArgs,
         theRequest) {

    /**
     * @method generateMarkup
     * @summary Generates markup for the supplied Object using the other
     *     parameters supplied.
     * @param {Object} anObject The Object of content to wrap in markup.
     * @param {String} attrStr The String containing either the literal
     *     attribute markup or a 'template invocation' that can be used inside
     *     of a template.
     * @param {String} itemFormat The name of an 'item format', either a tag
     *     name (which defaults to the 'item tag name' of this type) or some
     *     other format type which can be applied to this type.
     * @param {Boolean} shouldAutoWrap Whether or not the markup generation
     *     machinery should 'autowrap' items of the supplied object (each item
     *     in an Array or each key/value pair in an Object).
     * @param {TP.core.Hash} formatArgs The 'formatting arguments' used by this
     *     machinery to generate item markup.
     * @param {TP.sig.Request|TP.core.Hash} theRequest An optional object
     *     containing parameters.
     * @returns {String} The markup generated by taking the supplied Object and
     *     iterating over its items.
     */

    var tagName,
        template,
        str;

    //  Don't generate markup annotated with the data expression
    theRequest.atPut('annotateMarkup', false);

    //  If the object is an Array, then just skip to the bottom of the
    //  method.
    if (TP.isArray(anObject)) {
        void 0;
    } else if (TP.isTrue(shouldAutoWrap) && TP.isTrue(theRequest.at('repeat'))) {
        //  Otherwise, if we're autowrapping and repeating, the object that
        //  will be handed to the iteration mechanism will be [key,value]
        //  pairs, so we can use that fact to generate item tags around each
        //  one.

        tagName = this.getCanonicalName();

        //  Build a template by joining the tag name with an invocation
        //  of the itemFormat for both the key and the value.
        template = TP.join('<', tagName, attrStr, '>',
                            '{{0.%', itemFormat, '}}',
                            '{{1.%', itemFormat, '}}',
                            '</', tagName, '>');

        //  Perform the transformation.
        str = template.transform(anObject, theRequest);

        return str;
    }

    //  It was either an Array or we weren't autowrapping and repeating. In
    //  that case, just call up the supertype chain and return the value.
    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.html.tr.Type.defineMethod('getItemTagName',
function() {

    /**
     * @method getItemTagName
     * @summary Returns the 'default item tag name' for use it the
     *     fromArray()/fromObject() methods. Note that this should return the
     *     receiver's *canonical* name.
     * @returns {String} The item tag name.
     */

    return 'html:td';
});

//  ------------------------------------------------------------------------

TP.html.tr.Type.defineMethod('shouldAutoWrapItems',
function(anObject, formatArgs) {

    /**
     * @method shouldAutoWrapItems
     * @summary Whether or not our fromArray() / fromObject() methods
     *     'auto-wrap items'. See those methods for more information.
     * @param {Object} anObject The Object of content to wrap in markup.
     * @param {TP.core.Hash} formatArgs An optional object containing
     *     parameters.
     * @returns {Boolean} Whether or not we automatically wrap items.
     */

    if (TP.isBoolean(formatArgs.at('autowrap'))) {
        return formatArgs.at('autowrap');
    }

    //  An 'TP.html.tr's default is to *not* wrap each item of an Array in
    //  its own tags (maybe each one goes in an 'TP.html.td').
    if (TP.isArray(anObject)) {
        return false;
    }

    return true;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xhtml/html_TextModuleNodes.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'html';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

//  ========================================================================
//  TP.html.abbr
//  ========================================================================

/**
 * @type {TP.html.abbr}
 * @summary 'abbr' tag. Abbreviation.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('abbr');

//  ========================================================================
//  TP.html.acronym
//  ========================================================================

/**
 * @type {TP.html.acronym}
 * @summary 'acronym' tag. Acronym.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('acronym');

//  ========================================================================
//  TP.html.address
//  ========================================================================

/**
 * @type {TP.html.address}
 * @summary 'address' tag. Address information.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('address');

//  ========================================================================
//  TP.html.bdi (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.bdi}
 * @summary 'bdi' tag. Defines a section that might be formatted in a different
 * direction.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('bdi');

//  ========================================================================
//  TP.html.blockquote
//  ========================================================================

/**
 * @type {TP.html.blockquote}
 * @summary 'blockquote' tag. Inline quotation.
 */

//  ------------------------------------------------------------------------

TP.html.Citation.defineSubtype('blockquote');

TP.html.blockquote.Type.set('uriAttrs', TP.ac('cite'));

//  ========================================================================
//  TP.html.br
//  ========================================================================

/**
 * @type {TP.html.br}
 * @summary 'br' tag. Paragraph break.
 */

//  ------------------------------------------------------------------------

TP.html.CoreAttrs.defineSubtype('br');

TP.html.br.addTraits(TP.dom.EmptyElementNode);

TP.html.br.Inst.resolveTraits(
        TP.ac('getContent', 'setContent'),
        TP.dom.EmptyElementNode);

//  ========================================================================
//  TP.html.cite
//  ========================================================================

/**
 * @type {TP.html.cite}
 * @summary 'cite' tag. Citation.
 */

//  ------------------------------------------------------------------------

TP.html.Citation.defineSubtype('cite');

//  ========================================================================
//  TP.html.code
//  ========================================================================

/**
 * @type {TP.html.code}
 * @summary 'code' tag. Program code.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('code');

//  ========================================================================
//  TP.html.dfn
//  ========================================================================

/**
 * @type {TP.html.dfn}
 * @summary 'dfn' tag. Definition.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('dfn');

//  ========================================================================
//  TP.html.div
//  ========================================================================

/**
 * @type {TP.html.div}
 * @summary DIV tag. Generic block container.
 */

//  ------------------------------------------------------------------------

TP.html.Aligned.defineSubtype('div');

//  ========================================================================
//  TP.html.em
//  ========================================================================

/**
 * @type {TP.html.em}
 * @summary 'em' tag. Emphasis.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('em');

//  ========================================================================
//  TP.html.h1
//  ========================================================================

/**
 * @type {TP.html.h1}
 * @summary 'h1' tag. Heading.
 */

//  ------------------------------------------------------------------------

TP.html.Aligned.defineSubtype('h1');

//  ========================================================================
//  TP.html.h2
//  ========================================================================

/**
 * @type {TP.html.h2}
 * @summary 'h2' tag. Sub-heading.
 */

//  ------------------------------------------------------------------------

TP.html.Aligned.defineSubtype('h2');

//  ========================================================================
//  TP.html.h3
//  ========================================================================

/**
 * @type {TP.html.h3}
 * @summary 'h3' tag. Sub-sub-heading.
 */

//  ------------------------------------------------------------------------

TP.html.Aligned.defineSubtype('h3');

//  ========================================================================
//  TP.html.h4
//  ========================================================================

/**
 * @type {TP.html.h4}
 * @summary 'h4' tag. Sub-sub-sub-heading.
 */

//  ------------------------------------------------------------------------

TP.html.Aligned.defineSubtype('h4');

//  ========================================================================
//  TP.html.h5
//  ========================================================================

/**
 * @type {TP.html.h5}
 * @summary 'h5' tag. Sub-sub-sub-sub-heading. Are we there yet?
 */

//  ------------------------------------------------------------------------

TP.html.Aligned.defineSubtype('h5');

//  ========================================================================
//  TP.html.h6
//  ========================================================================

/**
 * @type {TP.html.h6}
 * @summary 'h6' tag. You get the picture ;).
 */

//  ------------------------------------------------------------------------

TP.html.Aligned.defineSubtype('h6');

//  ========================================================================
//  TP.html.kbd
//  ========================================================================

/**
 * @type {TP.html.kbd}
 * @summary 'kbd' tag. Example keyboard input.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('kbd');

//  ========================================================================
//  TP.html.mark (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.mark}
 * @summary 'mark' tag. A run of text highlighted for reference purposes.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('mark');

//  ========================================================================
//  TP.html.p
//  ========================================================================

/**
 * @type {TP.html.p}
 * @summary 'p' tag. Paragraph.
 */

//  ------------------------------------------------------------------------

TP.html.Aligned.defineSubtype('p');

//  ========================================================================
//  TP.html.pre
//  ========================================================================

/**
 * @type {TP.html.pre}
 * @summary 'pre' tag. Preserve formatting.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('pre');

//  ========================================================================
//  TP.html.q
//  ========================================================================

/**
 * @type {TP.html.q}
 * @summary 'q' tag. Inline quotation.
 */

//  ------------------------------------------------------------------------

TP.html.Citation.defineSubtype('q');

TP.html.q.Type.set('uriAttrs', TP.ac('cite'));

//  ========================================================================
//  TP.html.ruby (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.ruby}
 * @summary 'ruby' tag. Mark up 'Ruby text' annotations.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('ruby');

//  ========================================================================
//  TP.html.rp (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.rp}
 * @summary 'rp' tag. Mark up 'Ruby text' annotations.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('rp');

//  ========================================================================
//  TP.html.rt (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.rt}
 * @summary 'rt' tag. Mark up 'Ruby text' annotations.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('rt');

//  ========================================================================
//  TP.html.rtc (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.rtc}
 * @summary 'rtc' tag. Contain marked up 'Ruby text' annotations.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('rtc');

//  ========================================================================
//  TP.html.samp
//  ========================================================================

/**
 * @type {TP.html.samp}
 * @summary 'samp' tag. Sample.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('samp');

//  ========================================================================
//  TP.html.span
//  ========================================================================

/**
 * @type {TP.html.span}
 * @summary 'span' tag. Generic inline container.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('span');

//  ========================================================================
//  TP.html.strong
//  ========================================================================

/**
 * @type {TP.html.strong}
 * @summary 'strong' tag. Strong emphasis.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('strong');

//  ========================================================================
//  TP.html.var
//  ========================================================================

/**
 * @type {TP.html.var}
 * @summary 'var' tag. Variable.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('var');

//  ========================================================================
//  TP.html.wbr (HTML 5)
//  ========================================================================

/**
 * @type {TP.html.wbr}
 * @summary 'wbr' tag. Line break opportunity.
 */

//  ------------------------------------------------------------------------

TP.html.Attrs.defineSubtype('wbr');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/on/TP.on.XMLNS.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'on';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {on:}
 * @summary This type represents the TIBET on namespace
 *     (http://www.technicalpursuit.com/2005/on) in the tag processing system.
 */

//  ------------------------------------------------------------------------

TP.core.XMLNamespace.defineSubtype('on.XMLNS');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.on.XMLNS.Type.defineMethod('setup',
function(anElement) {

    /**
     * @method setup
     * @param {Element} anElement The element to set up.
     * @returns {null}
     */

    var onAttrNodes,

        domSigTypeMapVals,

        len,
        i,

        attrNode,
        sigName;

    //  Grab any Attribute nodes in the TP.w3.Xmlns.ON namespace
    if (TP.notEmpty(onAttrNodes = TP.elementGetAttributeNodesInNS(
                                    anElement, null, TP.w3.Xmlns.ON))) {

        domSigTypeMapVals = TP.NON_OBSERVED_ON_ATTRS.getValues();

        //  Loop over them and process individual attributes into observe()
        //  calls.
        len = onAttrNodes.getSize();
        for (i = 0; i < len; i++) {

            attrNode = onAttrNodes.at(i);

            //  The signal name that we'll be observing is the local name of the
            //  attribute.
            sigName = TP.attributeGetLocalName(attrNode);

            //  If this signal name (or event name) points to a UI signal, then
            //  we exit here. Those are processed separately by the DOM_FIRING
            //  policy.
            if (TP.NON_OBSERVED_ON_ATTRS.hasKey(sigName) ||
                domSigTypeMapVals.indexOf(
                        TP.expandSignalName(sigName)) !== TP.NOT_FOUND ||
                domSigTypeMapVals.indexOf(
                        TP.contractSignalName(sigName)) !== TP.NOT_FOUND) {
                continue;
            }

            //  Observe the Element for that signal.
            this.observe(anElement, sigName);
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.on.XMLNS.Type.defineHandler('Signal',
function(aSignal) {

    /**
     * @method handleSignal
     * @summary The top-level handler that can handle any kind of signal sent to
     *     an Element that was configured using an on:* attribute (but only for
     *     non-DOM signals - DOM signals configured by on:* are handled
     *     specially by the DOM_FIRING firing policy in the notification center
     *     code).
     * @param {TP.sig.Signal} aSignal The signal.
     * @returns {TP.meta.on.XMLNS} The receiver.
     */

    var origin,

        originTPElem,
        originElem,

        sigName,
        sigData;

    origin = aSignal.getOrigin();

    if (TP.isString(origin)) {
        //  Grab the real TP.dom.ElementNode that matches the signal origin
        //  (which will be a full GID).
        originTPElem = TP.bySystemId(origin);
        originElem = TP.unwrap(originTPElem);
    } else {
        originElem = origin;
    }

    sigName = aSignal.getSignalName();

    //  First, try the full signal name, which we should get from
    //  getSignalName() above.
    if (TP.elementHasAttribute(originElem, 'on:' + sigName, true)) {
        sigData = TP.elementGetAttribute(
                    originElem, 'on:' + sigName, true);
    } else {

        //  Next, try the shortened version of that name.
        sigData = TP.elementGetAttribute(
                    originElem, 'on:' + TP.contractSignalName(sigName), true);
    }

    //  If we were able to successfully extract signal data, then queue up a
    //  signal that will fire based on this data.
    if (TP.notEmpty(sigData)) {
        TP.queueSignalFromData(
                    sigData,
                    originElem,
                    aSignal,
                    null,   //  payload
                    null,   //  policy
                    TP.sig.ResponderSignal);
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.on.XMLNS.Type.defineMethod('teardown',
function(anElement) {

    /**
     * @method teardown
     * @param {Element} anElement The element to tear down.
     * @returns {null}
     */

    var onAttrNodes,

        domSigTypeMapVals,

        len,
        i,

        attrNode,
        sigName;

    //  Grab any Attribute nodes in the TP.w3.Xmlns.ON namespace
    if (TP.notEmpty(onAttrNodes = TP.elementGetAttributeNodesInNS(
                                    anElement, null, TP.w3.Xmlns.ON))) {

        domSigTypeMapVals = TP.NON_OBSERVED_ON_ATTRS.getValues();

        //  Loop over them and process individual attributes into ignore()
        //  calls.
        len = onAttrNodes.getSize();
        for (i = 0; i < len; i++) {

            attrNode = onAttrNodes.at(i);

            //  The signal name that we'll be ignoring is the local name of the
            //  attribute.
            sigName = TP.attributeGetLocalName(attrNode);

            //  If this signal name (or event name) points to a UI signal, then
            //  we exit here. Those are processed separately by the DOM_FIRING
            //  policy.
            if (TP.NON_OBSERVED_ON_ATTRS.hasKey(sigName) ||
                domSigTypeMapVals.indexOf(
                        TP.expandSignalName(sigName)) !== TP.NOT_FOUND ||
                domSigTypeMapVals.indexOf(
                        TP.contractSignalName(sigName)) !== TP.NOT_FOUND) {
                continue;
            }

            //  Ignore the Element for that signal.
            this.ignore(anElement, sigName);
        }
    }

    return;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.XMLNS.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {tsh:}
 * @summary This type represents the TIBET Shell (TSH) namespace
 *     (http://www.technicalpursuit.com/2007/tsh) in the tag processing system.
 */

//  ------------------------------------------------------------------------

TP.core.XMLNamespace.defineSubtype('tsh.XMLNS');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.Element.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {tsh.Element}
 * @summary The root type for all tsh: action tags and command elements.
 */

//  ------------------------------------------------------------------------

TP.dom.ElementNode.defineSubtype('tsh.Element');

//  This type is intended to be used as a trait type only, so we don't allow
//  instance creation
TP.tsh.Element.isAbstract(true);

//  ------------------------------------------------------------------------

TP.tsh.Element.Type.defineMethod('printDebug',
function(aRequest, expandArguments, resolveArguments) {

    /**
     * @method printDebug
     * @summary Prints debugging information about the command, including the
     *     full XML information that got generated when the source code was
     *     'desugared' and all different values of the passed arguments.
     * @param {TP.sig.Request} aRequest The shell request to print debugging
     *     information for.
     * @param {Boolean} expandArguments Whether or not to show the 'expanded'
     *     value for arguments. The default is true.
     * @param {Boolean} resolveArguments Whether or not to show the 'resolved'
     *     value for arguments. The default is false.
     */

    var shell,

        requestKeys,
        reportHash,

        payload,

        argsReportHash,

        attrs,
        len,
        i,

        item,
        name,

        values,
        originalValue,

        valueDict,

        expandedValue,
        expandedTN,

        j,

        resolvedValue,
        resolvedTN;

    shell = aRequest.at('cmdShell');

    reportHash = TP.hc();

    payload = aRequest.getPayload();
    requestKeys = payload.getKeys();

    len = requestKeys.getSize();
    for (i = 0; i < len; i++) {
        reportHash.atPut(
            requestKeys.at(i),
            TP.xmlLiteralsToEntities(TP.str(payload.at(requestKeys.at(i)))));
    }

    argsReportHash = TP.hc();

    //  all parameters should be named, those with tsh: prefixes are used
    //  by the enclosing request.
    attrs = shell.getArguments(aRequest, TP.ALLFORMS).getItems();
    len = attrs.getSize();
    for (i = 0; i < len; i++) {

        item = attrs.at(i);

        name = item.first();

        if (/^ARGV/.test(name)) {

            values = item.last();

            for (j = 0; j < values.getSize(); j++) {

                originalValue = values.at(j).first();
                valueDict = TP.hc(
                    'Original value tname', TP.tname(originalValue),
                    'Original value', originalValue);

                if (TP.notFalse(expandArguments)) {
                    expandedValue = values.at(j).last();

                    if (TP.notDefined(expandedValue)) {
                        expandedValue = TP.UNDEF;
                        expandedTN = 'Undefined';
                    } else if (TP.isNull(expandedValue)) {
                        expandedValue = TP.NULL;
                        expandedTN = 'Null';
                    } else {
                        expandedTN = TP.tname(expandedValue);
                    }

                    valueDict.add(
                        'Expanded value tname', expandedTN,
                        'Expanded value', expandedValue);
                }

                if (TP.isTrue(resolveArguments)) {

                    resolvedValue = shell.resolveObjectReference(
                                        expandedValue, aRequest);

                    if (TP.notDefined(resolvedValue)) {
                        resolvedValue = TP.UNDEF;
                        resolvedTN = 'Undefined';
                    } else if (TP.isNull(resolvedValue)) {
                        resolvedValue = TP.NULL;
                        resolvedTN = 'Null';
                    } else {
                        resolvedTN = TP.tname(resolvedValue);
                    }

                    valueDict.add(
                        'Resolved value tname', resolvedTN,
                        'Resolved value', resolvedValue);
                }

                argsReportHash.atPut(
                    name + '[' + j + ']',
                    valueDict);
            }
        } else {
            originalValue = item.last().first();
            valueDict = TP.hc(
                'Original value tname', TP.tname(originalValue),
                'Original value', originalValue);

            if (TP.notFalse(expandArguments)) {
                expandedValue = item.last().last();

                if (TP.notDefined(expandedValue)) {
                    expandedValue = TP.UNDEF;
                    expandedTN = 'Undefined';
                } else if (TP.isNull(expandedValue)) {
                    expandedValue = TP.NULL;
                    expandedTN = 'Null';
                } else {
                    expandedTN = TP.tname(expandedValue);
                }

                valueDict.add(
                    'Expanded value tname', expandedTN,
                    'Expanded value', expandedValue);
            }

            if (TP.isTrue(resolveArguments)) {
                resolvedValue = shell.resolveObjectReference(
                                        expandedValue, aRequest);

                if (TP.notDefined(resolvedValue)) {
                    resolvedValue = TP.UNDEF;
                    resolvedTN = 'Undefined';
                } else if (TP.isNull(resolvedValue)) {
                    resolvedValue = TP.NULL;
                    resolvedTN = 'Null';
                } else {
                    resolvedTN = TP.tname(resolvedValue);
                }

                valueDict.add(
                    'Resolved value tname', resolvedTN,
                    'Resolved value', resolvedValue);
            }

            argsReportHash.atPut(
                name,
                valueDict);
        }
    }

    reportHash.atPut('ARGS:', argsReportHash);

    aRequest.stdout(reportHash);

    aRequest.complete(TP.TSH_NO_VALUE);

    return;
});

//  ------------------------------------------------------------------------

TP.tsh.Element.Type.defineMethod('printUsage',
function(aRequest) {

    /**
     * @method printUsage
     * @summary Prints usage information about the command. This usage
     *     information is supplied by using the shell's addHelpTopic method.
     * @param {TP.sig.Request} aRequest The shell request to print usage
     *     information for.
     * @returns {TP.meta.tsh.Element} The receiver.
     */

    var root,
        cmd,

        shell,
        commandMethod,
        usageText;

    root = TP.ifInvalid(aRequest.at('rootRequest'), aRequest);

    cmd = root.at('cmd');
    cmd = cmd.trim();

    //  Make sure to trim off any arguments
    if (/\s+/.test(cmd)) {
        cmd = cmd.slice(0, cmd.indexOf(' '));
    }

    shell = aRequest.at('cmdShell');
    commandMethod = shell.getCommandMethod(cmd);

    if (TP.isMethod(commandMethod)) {

        usageText = commandMethod.$$usage || 'coming soon';
        aRequest.stdout('Usage: ' + usageText);
        aRequest.complete(TP.TSH_NO_VALUE);

        return this;
    }

    aRequest.stdout('Can\'t find usage for: ' + cmd);
    aRequest.complete(TP.TSH_NO_VALUE);

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.CommandAssistant.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @type {TP.tsh.CommandAssistant}
 */

//  ------------------------------------------------------------------------

TP.tag.CustomTag.defineSubtype('tsh.CommandAssistant');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.tsh.CommandAssistant.Inst.defineAttribute('originalRequest');

TP.tsh.CommandAssistant.Inst.defineAttribute('head',
    TP.cpc('> .head', TP.hc('shouldCollapse', true)));

TP.tsh.CommandAssistant.Inst.defineAttribute('body',
    TP.cpc('> .body', TP.hc('shouldCollapse', true)));

TP.tsh.CommandAssistant.Inst.defineAttribute('generatedCmdLine',
    TP.cpc('> .foot > #generatedCmdLine', TP.hc('shouldCollapse', true)));

TP.tsh.CommandAssistant.Inst.defineAttribute('foot',
    TP.cpc('> .foot', TP.hc('shouldCollapse', true)));

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.tsh.CommandAssistant.Inst.defineMethod('generateCommand',
function(info) {

    /**
     * @method generateCommand
     * @summary Generates the command text that will be sent to the shell if the
     *     user dismisses the assistant by clicking 'ok'. At this type level,
     *     this method returns the empty String.
     * @param {TP.core.Hash} info The hash containing the command parameters.
     * @returns {String} The generated command string.
     */

    return '';
});

//  ------------------------------------------------------------------------

TP.tsh.CommandAssistant.Inst.defineHandler('DialogCancel',
function(anObject) {

    /**
     * @method handleDialogCancel
     * @summary Handles when the user has 'canceled' the dialog (i.e. wants to
     *     proceed without taking any action).
     * @param {TP.sig.DialogCancel} aSignal The TIBET signal which triggered
     *     this method.
     * @returns {TP.tsh.CommandAssistant} The receiver.
     */

    var modelURI;

    //  We observed the model URI when we were set up - we need to ignore it now
    //  on our way out.
    modelURI = this.get('assistantModelURI');
    this.ignore(modelURI, 'ValueChange');

    return this;
});

//  ------------------------------------------------------------------------

TP.tsh.CommandAssistant.Inst.defineHandler('DialogOk',
function(anObject) {

    /**
     * @method handleDialogOk
     * @summary Handles when the user has 'ok-ed' the dialog (i.e. wants to
     *     proceed by taking the default action).
     * @param {TP.sig.DialogOk} aSignal The TIBET signal which triggered
     *     this method.
     * @returns {TP.tsh.CommandAssistant} The receiver.
     */

    var modelURI,

        result,
        data,
        assistantInfo,
        str;

    //  We observed the model URI when we were set up - we need to ignore it now
    //  on our way out.
    modelURI = this.get('assistantModelURI');
    this.ignore(modelURI, 'ValueChange');

    result = modelURI.getResource().get('result');

    if (TP.notValid(result)) {
        return this;
    }

    if (TP.notValid(data = result.get('data'))) {
        return this;
    }

    assistantInfo = TP.hc(data).at('info');

    str = this.generateCommand(assistantInfo);

    //  Fire a 'ConsoleCommand' with the command as built.
    TP.signal(null, 'ConsoleCommand', TP.hc('cmdText', str));

    return this;
});

//  ------------------------------------------------------------------------

TP.tsh.CommandAssistant.Inst.defineHandler('ValueChange',
function(aSignal) {

    /**
     * @method handleValueChange
     * @summary Handles when the user changes the value of the underlying model.
     * @param {ValueChange} aSignal The signal that caused this handler to trip.
     * @returns {TP.tsh.CommandAssistant} The receiver.
     */

    var result,
        data,
        assistantInfo,
        str,

        cmdLineTPElem;

    result = this.get('assistantModelURI').getResource().get('result');

    if (TP.notValid(result)) {
        return this;
    }

    if (TP.notValid(data = result.get('data'))) {
        return this;
    }

    assistantInfo = TP.hc(data).at('info');
    str = this.generateCommand(assistantInfo);

    cmdLineTPElem = this.get('generatedCmdLine');
    cmdLineTPElem.setTextContent(str);

    return this;
});

//  ------------------------------------------------------------------------

TP.tsh.CommandAssistant.Inst.defineMethod('setAssistantParams',
function(paramsObj) {

    /**
     * @method setAssistantParams
     * @summary Sets the assistant state from parameters that were given in the
     *     original signaling request.
     * @param {TP.core.Hash} paramsObj The command parameters that were handed
     *     to the request. The original request will be in this hash under the
     *     'originalRequest' key.
     * @returns {TP.tsh.CommandAssistant} The receiver.
     */

    this.setOriginalRequest(paramsObj.at('originalRequest'));

    return this;
});

//  ------------------------------------------------------------------------

TP.tsh.CommandAssistant.Inst.defineMethod('setOriginalRequest',
function(anObj) {

    /**
     * @method setOriginalRequest
     * @summary Sets the original request received by the command that triggered
     *     the assistant.
     * @param {TP.sig.Request} anObj The original request that was supplied to
     *     the assistant via the command.
     * @returns {TP.tsh.CommandAssistant} The receiver.
     */

    this.$set('originalRequest', anObj);

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.eval.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.eval}
 * @summary Provides support for the TIBET Shell (TSH) during command
 *     processing. These tags are typically not entered manually, they're
 *     normally generated by the TP.tsh.script tag during processing which
 *     focuses on the conversion of script source into a structured form that
 *     can be executed effectively.
 */

/* eslint-disable new-cap, no-unused-vars */
/* globals $INPUT:true, $INDEX:true, $_:true */
/* eslint-enable no-unused-vars */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:eval');

TP.tsh.eval.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  A list of operators which are specific to runtime TSH processing. NOTE
//  that operators which desugar to XML tags are not handled here, they are
//  processed by the tsh:script tag during XML desugaring.
TP.tsh.eval.Type.defineAttribute('$tshOperators', TP.ac('^'));

//  The initial key set that the context has before we populate slots onto it,
//  either via the captured scope object or eval()ing code.
TP.tsh.eval.Type.defineAttribute('$originalContextKeySet');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.eval.Type.defineMethod('$desugarTSH',
function(aString, aShell, aRequest, asTokens) {

    /**
     * @method $desugarTSH
     * @summary Processes the string for TSH-specific sugars such as regex
     *     history replacements, aliases, command substitutions, variable
     *     substitutions, etc. and returns the result.
     * @param {String} aString The source string to tokenize.
     * @param {TP.shell.Shell} aShell The shell instance.
     * @param {TP.sig.Request} aRequest The shell request.
     * @param {Boolean} asTokens True to return the token array.
     * @returns {String|String[]} A desugared string or token list.
     */

    //  standard "special variables" we're willing to expose to scripts
    var $LASTREQ,
        $REQUEST,
        $NODE,
        $SHELL,
        $CONTEXT,
        $SCRIPT,

        str,
        arr,
        len,
        i,
        token,
        value,
        result,
        alias,
        next,
        offset,
        j,
        last,
        msg,

        inFunction,
        brackets,
        previous,
        command,
        parts,
        histMatcher,
        req,
        rewrites,
        result2,
        identValue;

    str = aString;

    //  use the condense routine to tokenize our content for runtime parse
    //  but explicitly turn off whitespace removal.
    arr = TP.$condenseJS(
                    str, false, false,
                    //  All of the JS operators *and* the TSH operators
                    TP.tsh.script.$tshAndJSOperators,
                    true, true, true);

    len = arr.length;
    i = 0;

    if (TP.notValid(token = arr[i])) {
        return str;
    }

    //  initialize our function nesting control vars
    inFunction = false;
    brackets = 0;

    //  set up our output buffer
    result = TP.ac();

    rewrites = TP.ac();

    //  the initial token can be an alias, a history regex substitution, or
    //  an escape for aliasing, etc. we have to watch for them before we
    //  begin the main token processing loop.
    switch (token.value) {
        case '\\':
            //  leading escape means don't bother looking up alias
            //  translation for what follows, but strip the escape itself.
            i += 1;
            break;

        case '^':

            //  regular expression-based history substitution relative to
            //  the previous command's fully-expanded text content
            previous = aShell.getHistory().at(-2);
            if (TP.isValid(previous)) {
                command = previous.at('cmd');

                //  form is ^old^new^flags where flags are optional
                parts = str.split('^');
                histMatcher = TP.rc(parts.at(1),
                                    TP.ifInvalid(parts.at(3), ''));

                if (TP.notValid(histMatcher)) {
                    msg = TP.join(
                            TP.sc('Invalid history regexp substitution: '),
                            parts.at(1),
                            ' ',
                            TP.ifInvalid(parts.at(3), ''));

                    aRequest.fail(new Error(msg));

                    return;
                }

                str = command.replace(histMatcher, parts.at(2));

                //  tricky thing here is that the rewrite might well have
                //  changed then entire nature of the prior command's text
                //  and either one might require asynchronous processing. As
                //  a result we effectively have to construct a new request
                //  and join it to the current one so we don't complete
                //  until the newly generated command text has been
                //  processed.
                req = TP.sig.ShellRequest.construct(
                        TP.hc('cmd', str,
                                'cmdAllowSubs', aRequest.at('cmdAllowSubs'),
                                'cmdAsIs', aRequest.at('cmdAsIs'),
                                'cmdExecute', true,
                                'cmdHistory', aRequest.at('cmdHistory'),
                                'cmdBuildGUI', aRequest.at('cmdBuildGUI'),
                                'cmdLiteral', aRequest.at('cmdLiteral'),
                                'cmdPeer', aRequest,
                                'cmdPhases', aRequest.at('cmdPhases'),
                                'cmdRecycle', aRequest.at('cmdRecycle'),
                                'cmdShell', aRequest.at('cmdShell'),
                                'cmdSilent', aRequest.at('cmdSilent')
                        ));

                req.defineMethod(
                    'cancel',
                    function(aFaultString, aFaultCode, aFaultInfo) {

                        var info,
                            subrequests;

                        info = TP.hc(aFaultInfo);
                        if (TP.isValid(subrequests = info.at('subrequests'))) {
                            subrequests.push(req);
                        } else {
                            subrequests = TP.ac(req);
                            info.atPut('subrequests', subrequests);
                        }

                        return aRequest.cancel(
                                aFaultString ||
                                TP.sc('History request cancelled.'),
                            TP.ifInvalid(
                                    aFaultCode,
                                    TP.FAILED),
                            info);
                    });

                req.defineMethod(
                    'complete',
                    function(aResult) {

                        if (arguments.length > 0) {
                            return aRequest.complete(aResult);
                        } else {
                            return aRequest.complete();
                        }
                    });

                req.defineMethod(
                    'fail',
                    function(aFaultString, aFaultCode, aFaultInfo) {

                        var info,
                            subrequests;

                        info = TP.hc(aFaultInfo);
                        if (TP.isValid(subrequests = info.at('subrequests'))) {
                            subrequests.push(req);
                        } else {
                            subrequests = TP.ac(req);
                            info.atPut('subrequests', subrequests);
                        }

                        return aRequest.fail(
                            new Error(
                                aFaultString ||
                                TP.sc('History request failed.')),
                            TP.ifInvalid(
                                    aFaultCode,
                                    TP.FAILED),
                            info);
                    });

                aShell[TP.composeHandlerName('ShellRequest')](req);

                return;
            } else {
                msg = TP.sc('No previous command to edit.');
                aRequest.fail(new Error(msg));

                return;
            }

        case 'function':

            inFunction = true;
            result.push(token.value);
            i += 1;

            break;

        default:

            if (TP.$is_identifier(token.name)) {
                if (TP.isValid(aShell)) {
                    //  might be an alias, so we have to check for that
                    alias = aShell.getAlias(token.value);
                }

                //  if there was an alias then we have to re-submit for
                //  processing since the alias could reference new tags or
                //  other content the tsh_cmd tag can't process itself.
                if (alias !== token.value) {
                    //  before we submit as a "new request" we have to
                    //  process any local variable interpolations in the
                    //  alias such as ARGV or named argument references.
                    str = this.$interpolateAlias(alias, arr.slice(1));
                    str = this.$desugarTSH(str, aShell, aRequest, asTokens);

                    //  if the desugaring failed the request we're already
                    //  done...something like `blah` exploded or a ${blah}
                    //  failed to resolve etc.
                    if (aRequest.didComplete()) {
                        return;
                    }

                    req = TP.sig.ShellRequest.construct(
                        TP.hc('cmd', str,
                                'cmdAllowSubs', aRequest.at('cmdAllowSubs'),
                                'cmdAsIs', aRequest.at('cmdAsIs'),
                                'cmdExecute', true,
                                'cmdHistory', aRequest.at('cmdHistory'),
                                'cmdBuildGUI', aRequest.at('cmdBuildGUI'),
                                'cmdLiteral', aRequest.at('cmdLiteral'),
                                'cmdPeer', aRequest,
                                'cmdPhases', aRequest.at('cmdPhases'),
                                'cmdShell', aRequest.at('cmdShell'),
                                'cmdRecycle', aRequest.at('cmdRecycle'),
                                'cmdSilent', aRequest.at('cmdSilent')
                        ));

                    req.defineMethod(
                        'cancel',
                        function(aFaultString, aFaultCode, aFaultInfo) {

                            var info,
                                subrequests;

                            info = TP.hc(aFaultInfo);
                            if (TP.isValid(subrequests = info.at('subrequests'))) {
                                subrequests.push(req);
                            } else {
                                subrequests = TP.ac(req);
                                info.atPut('subrequests', subrequests);
                            }

                            return aRequest.cancel(
                                    aFaultString ||
                                    TP.sc('Aliased request cancelled.'),
                                TP.ifInvalid(
                                    aFaultCode,
                                    TP.FAILED),
                                info);
                        });

                    req.defineMethod(
                        'complete',
                        function(aResult) {

                            if (arguments.length > 0) {
                                return aRequest.complete(aResult);
                            } else {
                                return aRequest.complete();
                            }
                        });

                    req.defineMethod(
                        'fail',
                        function(aFaultString, aFaultCode, aFaultInfo) {

                            var info,
                                subrequests;

                            info = TP.hc(aFaultInfo);
                            if (TP.isValid(subrequests = info.at('subrequests'))) {
                                subrequests.push(req);
                            } else {
                                subrequests = TP.ac(req);
                                info.atPut('subrequests', subrequests);
                            }

                            return aRequest.fail(
                                new Error(
                                    aFaultString ||
                                    'Aliased request failed: ' +
                                        this.at('cmd')),
                                TP.ifInvalid(
                                    aFaultCode,
                                    TP.FAILED),
                                info);
                        });

                    req.defineMethod(
                        'stderr',
                        function(output, request) {

                            return aRequest.stderr(output, request);
                        });

                    req.defineMethod(
                        'stdin',
                        function() {

                            return aRequest.stdin();
                        });

                    req.defineMethod(
                        'stdout',
                        function(output, request) {

                            return aRequest.stdout(output, request);
                        });

                    aShell[TP.composeHandlerName('ShellRequest')](req);

                    return;
                } else {

                    identValue = token.value;

                    //  Make sure to convert '${X}' into '$X'
                    TP.regex.TSH_VARSUB_EXTENDED.lastIndex = 0;
                    identValue = identValue.replace(
                                    TP.regex.TSH_VARSUB_EXTENDED, '$$$1');

                    //  if the next non-whitespace token is an assignment
                    //  operator then we're looking at a possible local
                    //  variable assignment we need to rewrite. The big
                    //  question is whether we see that as an undefined
                    //  slot when we check the global scope. If the slot
                    //  is defined then we presume it's a global var.
                    if (TP.isValid(next = arr.at(i + 1))) {
                        //  skip any intervening whitespace
                        offset = 2;
                        while (next && TP.$is_whitespace(next.name)) {
                            next = arr.at(i + offset);
                            offset++;
                        }

                        //  assignment? then see if we have a previously set
                        //  global value
                        if (next && next.value === '=') {
                            if (TP.notDefined(TP.global[identValue])) {
                                //  assignment, rewrite the identifier.
                                rewrites.push(identValue);
                            }
                        }
                    }

                    result.push(identValue);
                    i += 1;
                }
            }

            break;
    }

    //  Ensure consistent context variables are in place when/if we do any
    //  eval operations for resolving command substitutions.
    $REQUEST = aRequest;
    $NODE = $REQUEST.at('cmdNode');
    $SHELL = aShell;
    $LASTREQ = $SHELL.get('previous');

    //  The current context (i.e. 'window' / 'self') that the evaluated
    //  statements will be executed in. This provides those statements with
    //  their global scope.
    $CONTEXT = aShell.getExecutionContext($REQUEST);

    //  Only in Mozilla and IE does a 'contextual eval' (i.e. one where
    //  the global/window scope is specified) take into account the current
    //  local scope (i.e. where temp variables are defined).
    //  Other browsers (Safari and Chrome) do not. Therefore, we need to
    //  make these explicitly available on the context that we're gonna
    //  invoke the eval in.
    $CONTEXT.$LASTREQ = $LASTREQ;
    $CONTEXT.$REQUEST = $REQUEST;
    $CONTEXT.$NODE = $NODE;
    $CONTEXT.$SHELL = $SHELL;
    $CONTEXT.$CONTEXT = $CONTEXT;
    $CONTEXT.$SCRIPT = $SCRIPT;
    $CONTEXT.$_ = null;

    //  complete the token processing. this may "reprocess" the initial
    //  token if it didn't signify something particular to the start of a
    //  line such as an alias or ^-based substitution.
    /* eslint-disable no-extra-parens */
    while ((token = arr[i])) {
    /* eslint-enable no-extra-parens */
        switch (token.name) {
            case 'substitution':
            case 'template':

                value = this.expandContent(token.value, $SHELL, $REQUEST);
                result.push(value);

                i += 1;
                break;

            case 'string':

                //  double-quoted strings can go through interpolation if
                //  they contain any embedded `'s or ${blah}s that aren't
                //  escaped...
                if (token.value.indexOf('"') === 0) {
                    value = this.$desugarTSH(
                        token.value.unquoted('"'),
                        aShell,
                        aRequest,
                        false);

                    //  if the desugaring failed the request we're already
                    //  done...something like `blah` exploded or a ${blah}
                    //  failed to resolve etc.
                    if (aRequest.didComplete()) {
                        return;
                    }

                    //  If the value has template constructs, then execute the
                    //  template, providing the shell's 'execution instance'
                    //  as the 'data source'.
                    if (TP.regex.HAS_ACP.test(value)) {
                        value = value.transform(
                            $SHELL.getExecutionInstance($REQUEST));
                    }

                    result.push('"', value, '"');
                } else {
                    //  single-quoted strings are exempt from interpolation
                    //  etc. so we can skip it and push directly into result
                    result.push(token.value);
                }

                i += 1;
                break;

            case 'operator':

                if (token.value === '{') {
                    //  Count when we're "in a function" so we know when we
                    //  leave.
                    if (inFunction) {
                        brackets++;
                    }
                } else if (token.value === '}') {
                    //  If we're closing a function we
                    if (inFunction) {
                        brackets--;
                        if (brackets === 0) {
                            inFunction = false;
                        }
                    }
                }

                result.push(token.value);
                i += 1;
                break;

            default:

                if (token.value === 'function') {
                    inFunction = true;
                    result.push(token.value);
                    i += 1;
                    break;
                }

                //  When we have an identifier that isn't part of a chain we
                //  presume assignments to that identifier are local scope
                //  operations. One thing we have to watch for is we only
                //  want to do this when the identifier is a true "lvalue"
                //  and not when it's being input as part of markup etc.
                if (TP.notTrue(inFunction) && TP.$is_identifier(token.name)) {
                    //  if the next non-whitespace token is an assignment
                    //  operator then we're looking at a possible local
                    //  variable assignment we may need to rewrite.
                    if (TP.isValid(next = arr.at(i + 1))) {
                        //  skip any intervening whitespace
                        offset = 2;
                        while (next && TP.$is_whitespace(next.name)) {
                            next = arr.at(i + offset);
                            offset++;
                        }

                        //  assignment? then see if we have a previously set
                        //  global value
                        if (next && next.value === '=') {
                            //  so we do have an assignment, the question
                            //  is, are we looking at a true lvalue or not?
                            j = result.getSize() - 1;
                            last = result.at(j);

                            while (last) {
                                if (last === ';') {
                                    break;
                                } else if (TP.regex.WHITESPACE.test(last)) {
                                    j--;
                                    last = result[j];
                                } else {
                                    last = null;
                                }
                            }

                            if (last === ';' &&
                                TP.notDefined(TP.global[token.value])) {
                                //  assignment, rewrite the identifier.
                                rewrites.push(token.value);
                            }
                        }
                    }
                }

                result.push(token.value);
                i += 1;

                break;
        }
    }

    //  if there were token rewrites for scope we need to reprocess the list
    //  for any of those token values now.
    if (TP.notEmpty(rewrites)) {
        result2 = TP.ac();
        len = result.length;

        for (i = 0; i < len; i++) {
            value = result[i];
            result2.push(value);
        }

        result = result2;
    }

    if (TP.isTrue(asTokens)) {
        return result;
    }

    return result.join('');
});

//  ------------------------------------------------------------------------

TP.tsh.eval.Type.defineMethod('$interpolateAlias',
function(aliasString, aTokenArray) {

    /**
     * @method $interpolateAlias
     * @summary Accepts an alias string translation and a set of command line
     *     tokens, interpolating them in such a way that tokens referenced by
     *     the alias string are consumed while remaining tokens are placed on
     *     the command line.
     * @param {String} aliasString The alias string to interpolate.
     * @param {String[]} aTokenArray An array of the tokens on the command line
     *     found after the alias.
     * @returns {String} The interpolated command line string.
     */

    var argv,
        params,
        i,
        tokens,
        token,
        next,
        value,
        result,
        name,
        arr,
        format,
        str,
        num;

    //  if the alias has no variables we can do simple concatenation
    if (!TP.regex.VARSUB.test(aliasString)) {
        return aliasString + aTokenArray.collect(
                                function(item) {

                                    return item.value;
                                }).join('');
    }

    //  if the alias has substitutions we have to tokenize it and process
    //  them as we iterate. For that to work we first have to process the
    //  rest of the command line so we know which portions are "named"
    //  parameters and which are "positional"
    argv = TP.ac();
    params = TP.hc();

    i = 0;
    tokens = [];
    token = aTokenArray[i];

    //  Step one is to collapse access paths so we don't treat things like
    //  TP.sig.Signal as a set of 5 positional parameters or fail to treat
    //  that entire reference as a value in a named parameter.
    while (token) {
        if (TP.$is_identifier(token.name)) {
            next = aTokenArray[i + 1];
            while (next &&
                    next.value !== '=' &&
                    !TP.$is_whitespace(next.name)) {
                i += 1;
                token.value += next.value;
                next = aTokenArray[i + 1];
            }
        }

        tokens.push(token);
        i += 1;
        token = aTokenArray[i];
    }

    //  Step two is to process named argument references, which means
    //  watching for a=b form and moving those into the params object as
    //  key/value.
    i = 0;
    token = tokens[i];
    while (token) {
        if (TP.$is_identifier(token.name)) {
            next = tokens[i + 1];
            if (next && next.value === '=') {
                value = tokens[i + 2];
                if (value) {
                    params.atPut(token.value,
                        value.value);
                    i += 3;
                    token = tokens[i];

                    continue;
                }
            }
        }

        if (!TP.$is_whitespace(token.name)) {
            argv.push(token.value);
        }

        i += 1;
        token = tokens[i];
    }

    //  phase two is to iterate over the alias string's token stream
    //  replacing any substitutions we can while consuming them from the
    //  params and argv containers.
    tokens = TP.$tokenize(
                    aliasString,
                    //  All of the JS operators *and* the TSH operators
                    TP.tsh.script.$tshAndJSOperators,
                    true, false, true, true);

    i = 0;
    token = tokens[i];
    result = TP.ac();

    while (token) {
        if (token.name === 'substitution' &&
            token.value.charAt(0) === '$') {
            //  Slice off the leading '${' and trailing '}'
            name = token.value.slice(2, token.value.length - 1);

            if (name.indexOf('|') !== TP.NOT_FOUND) {
                arr = name.split('|');
                name = arr.at(0);
                format = arr.at(1);
            }

            num = TP.nc(name);
            if (TP.isNumber(num)) {
                value = argv.at(num);
                if (TP.isDefined(value)) {
                    argv.atPut(num, '');

                    if (TP.notEmpty(format)) {
                        result.push(TP.format(value, format));
                    } else {
                        result.push(value);
                    }
                } else {
                    result.push(token.value);
                }
            } else {
                value = params.at(name);
                if (TP.isDefined(value)) {
                    params.removeKey(name);
                    if (TP.notEmpty(format)) {
                        result.push(TP.format(value, format));
                    } else {
                        result.push(value);
                    }
                } else {
                    result.push(token.value);
                }
            }
        } else {
            result.push(token.value);
        }

        i += 1;
        token = tokens[i];
    }

    //  final phase is to write out the final command line made up of the
    //  interpolated alias string and any unused tokens from the command
    //  line.

    //  rejoin the alias string's component parts for the first part
    str = result.join('');

    //  add on any named arguments, separated by a space.
    if (TP.notEmpty(params)) {
        str += ' ' + params.asQueryString(' ');
    }

    //  add on any remaining positional arguments
    if (TP.notEmpty(argv)) {
        str += ' ' + argv.join(' ');
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.tsh.eval.Type.defineMethod('isAccessPath',
function(aTokenArray) {

    /**
     * @method isAccessPath
     * @summary Returns true if the token array provided represents what
     *     appears to be a viable access path.
     * @description An access path is a sugared form of property naming which
     *     can be converted into a call to TIBET's 'set' or 'get' functions. For
     *     example, a sequence of tokens such as 'a.b.c' can be resolved by a
     *     get call on 'a' of a.get('b.c'); Note that the access path syntax
     *     supported by the tsh:eval tag includes the proposed slicing syntax
     *     for future editions of JavaScript.
     * @param {String[]} aTokenArray A list of tokens to check.
     * @returns {Boolean}
     */

    var arr,
        token,
        i;

    //  Only worry about access path rewrites for paths with at least 2
    //  tokens, otherwise it's a standalone identifer at most.
    if (TP.isEmpty(arr = aTokenArray) || arr.getSize() < 2) {
        return false;
    }

    i = 0;
    token = arr[i];

    //  First token in the stream has to be a viable identifier, we can't
    //  have paths that start with a number, or a slice.
    if (!TP.$is_identifier(token.name)) {
        return false;
    }

    //  Second token must be a period for property access.
    i += 1;
    token = arr[i];
    if (token.value !== '.') {
        return false;
    }

    i += 1;
    token = arr[i];

    //  Remainder of the path can only have identifiers, numbers, colons,
    //  commas, minus signs or additional periods to specify property
    //  access. We won't validate that they appear in precisely the right
    //  order here, but we'll ensure that no other token values/types are
    //  found.
    while (token) {
        if (!TP.$is_identifier(token.name) &&
            token.name !== 'number' &&
            token.value !== '.' &&
            token.value !== ',' &&
            token.value !== '-' &&
            token.value !== '[' &&
            token.value !== ']' &&
            token.value !== ':') {
            return false;
        }

        i += 1;
        token = arr[i];
    }

    return true;
});

//  ------------------------------------------------------------------------

TP.tsh.eval.Type.defineMethod('cmdAddContent',
function(REQUEST$$) {

    /**
     * @method cmdAddContent
     * @summary Invoked when the receiver is being used as a sink with append
     *     semantics. In this case the object referenced by the receiver's
     *     content will have its cmdAddContent method called if it responds to
     *     one.
     * @param {TP.sig.Request} REQUEST$$ The request containing command input
     *     for the shell.
     */

    return this.cmdRunContent(REQUEST$$, TP.ADD);
});

//  ------------------------------------------------------------------------

TP.tsh.eval.Type.defineMethod('cmdFilterInput',
function(REQUEST$$) {

    /**
     * @method cmdFilterInput
     * @summary Invoked when the receiver is being used as a filter. In this
     *     case the object referenced by the receiver's content will have its
     *     cmdFilterInput method called if it responds to one.
     * @param {TP.sig.Request} REQUEST$$ The request containing command input
     *     for the shell.
     */

    return this.cmdRunContent(REQUEST$$, TP.FILTER);
});

//  ------------------------------------------------------------------------

TP.tsh.eval.Type.defineMethod('cmdGetContent',
function(REQUEST$$) {

    /**
     * @method cmdGetContent
     * @summary Executes the request's content, returning a reference to the
     *     return value of that execution. This method is invoked when the
     *     tsh:eval is used either standalone or as a data source within a TSH
     *     script.
     * @param {TP.sig.Request} REQUEST$$ The request containing command input
     *     for the shell.
     */

    //  internal to the computation process, but shouldn't be visible
    var START$$,
        END$$,
        TIME$$,
        RESULT$$,
        SCOPE$$,
        TOKENS$$,
        ERR$$,
        SCRIPT$$,
        TYPE$$,

    //  standard "special variables" we're willing to expose to scripts
        $LASTREQ,
        $REQUEST,
        $NODE,
        $SHELL,
        $CONTEXT,
        $SCRIPT;

    $REQUEST = REQUEST$$;
    $NODE = $REQUEST.at('cmdNode');
    $SHELL = $REQUEST.at('cmdShell');
    $LASTREQ = $SHELL.get('previous');

    //  tokenize the content so we can check for sugar around the various
    //  substitution and rewriting methods
    $SCRIPT = TP.nodeGetTextContent($NODE);
    if (TP.isBlank($SCRIPT)) {
        $REQUEST.complete();

        return;
    }

    //  if the command text started (originally) with an escape then literal
    //  will be set to true so we don't attempt desugaring
    if ($NODE.getAttribute('tsh:literal') !== 'true' &&
        $REQUEST.at('cmdLiteral') !== true) {
        $SCRIPT = this.$desugarTSH($SCRIPT, $SHELL, $REQUEST);

        //  certain desugaring attempts can recognize that the request is
        //  malformed and fail() it.
        if ($REQUEST.didComplete()) {
            return;
        }

        TP.nodeSetTextContent($NODE, $SCRIPT);
    }

    //  tokenize what's left so we can check for identifiers etc.
    TOKENS$$ = TP.$condenseJS(
                    $SCRIPT, false, false,
                    //  All of the JS operators *and* the TSH operators
                    TP.tsh.script.$tshAndJSOperators,
                    true, true, true);

    if (this.isAccessPath(TOKENS$$)) {

        //  first token in an access path is the object reference,
        //  the rest can be wrapped into a string access path...
        $SCRIPT = TOKENS$$[0].value +
                    '.get(TP.apc(\'' +
                    TOKENS$$.slice(2).collect(
                        function(item) {

                            return item.value;
                        }).join('') + '\'));';

        TP.nodeSetTextContent($NODE, $SCRIPT);
    }

    try {
        //  The current context (i.e. 'window' / 'self') that the evaluated
        //  statements will be executed in. This provides those statements
        //  with their global scope.
        $CONTEXT = $SHELL.getExecutionContext($REQUEST);

        //  Only in Mozilla and IE does a 'contextual eval' (i.e. one
        //  where the global/window scope is specified) take into account
        //  the current local scope (i.e. where temp variables are defined).
        //  Other browsers (Safari and Chrome) do not. Therefore, we need to
        //  make these explicitly available on the context that we're gonna
        //  invoke the eval in.
        $CONTEXT.$LASTREQ = $LASTREQ;
        $CONTEXT.$REQUEST = $REQUEST;
        $CONTEXT.$NODE = $NODE;
        $CONTEXT.$SHELL = $SHELL;
        $CONTEXT.$CONTEXT = $CONTEXT;
        $CONTEXT.$SCRIPT = $SCRIPT;
        $CONTEXT.$_ = null;

        //  eval has problems with Object and Function literals, but
        //  wrapping them in parentheses helps...

        //  Object literals
        if ($SCRIPT.charAt(0) === '{' &&
            $SCRIPT.charAt($SCRIPT.length - 1) === '}') {
            $SCRIPT = '(' + $SCRIPT + ')';
        }

        //  Function literals
        //  To keep things simpler for the regex we run the test on the script
        //  with newlines removed.
        if (TP.regex.FUNCTION_LITERAL.test($SCRIPT.replace(/\n/g, ' '))) {
            $SCRIPT = '(' + $SCRIPT + ')';
        }

        // SCRIPT$$ = TP.$condenseJS($SCRIPT, true);
        SCRIPT$$ = $SCRIPT;

        START$$ = Date.now();

        //  Grab the execution scope.
        SCOPE$$ = $SHELL.getExecutionInstance($REQUEST);

        //  Capture the 'pre eval' state of the context and place the slots from
        //  the scope onto the context.
        TP.tsh.eval.$populateContextFromScope($CONTEXT, SCOPE$$);

        //  Eval the script
        RESULT$$ = $CONTEXT.eval(SCRIPT$$);

        //  Capture the current state of the context and place the slots from
        //  the context onto the scope.
        TP.tsh.eval.$populateScopeFromContext($CONTEXT, SCOPE$$);

        END$$ = Date.now();

        TIME$$ = TP.ifInvalid($REQUEST.get('$evaltime'), 0);
        $REQUEST.set('$evaltime', TIME$$ + (END$$ - START$$));

        //  After resolving the reference, we see if the result (or it's type)
        //  can execute 'cmdGetContent'.

        if (TP.canInvoke(RESULT$$, 'cmdGetContent')) {
            RESULT$$ = RESULT$$.cmdGetContent($REQUEST);
        } else if (TP.isType(TYPE$$ = TP.type(RESULT$$))) {

            if (TP.canInvoke(TYPE$$, 'cmdGetContent')) {
                $REQUEST.atPut('cmdInstance', RESULT$$);
                RESULT$$ = TYPE$$.cmdGetContent($REQUEST);
            }
        }

        $REQUEST.complete(RESULT$$);
    } catch (e) {
        END$$ = Date.now();

        TIME$$ = TP.ifInvalid($REQUEST.get('$evaltime'), 0);
        $REQUEST.set('$evaltime', TIME$$ + (END$$ - START$$));

        if (TP.sys.cfg('tsh.ignore_eval_errors') === true) {
            //  If we're ignoring eval errors, then we just complete the request
            //  with undefined here.
            $REQUEST.complete(undefined);
        } else {
            //  NOTE we slice off the file reference at the tail
            //  since that's not accurate...we're doing
            //  interactive input here.
            ERR$$ = e.message;
            if (ERR$$.contains(' &#171; ')) {
                ERR$$ = TP.trim(ERR$$.slice(0, ERR$$.indexOf(' &#171; ')));
            }

            if (/[sS]yntax/.test(ERR$$)) {
                RESULT$$ = ERR$$ + ': ' + $SCRIPT;
            } else {
                RESULT$$ = ERR$$.endsWith('.') ? ERR$$ : ERR$$ + '.';
            }

            $REQUEST.fail(new Error(RESULT$$));
        }
    } finally {
        delete $CONTEXT.$LASTREQ;
        delete $CONTEXT.$REQUEST;
        delete $CONTEXT.$NODE;
        delete $CONTEXT.$SHELL;
        delete $CONTEXT.$CONTEXT;
        delete $CONTEXT.$SCRIPT;
        delete $CONTEXT.$_;
    }

    return;
});

//  ------------------------------------------------------------------------

TP.tsh.eval.Type.defineMethod('cmdRunContent',
function(REQUEST$$, CMDTYPE$$) {

    /**
     * @method cmdRunContent
     * @summary Invoked when the receiver is being used as either a filter or a
     *     sink in a pipe (otherwise cmdGetContent() is called).
     * @param {TP.sig.Request} REQUEST$$ The request containing command input
     *     for the shell.
     */

    //  internal to the computation process, but shouldn't be visible
    var PIPE$$,
        RESULT$$,
        TOKENS$$,
        TOKEN$$,
        QUERY$$,
        RE$$,
        ACCESS$$,
        EXEC$$,
        TYPE$$,
        CTYPE$$,
        DEREF$$,
        VAR$$,

    //  standard "special variables" we're willing to expose to scripts
        $LASTREQ,
        $REQUEST,
        $NODE,
        $TPNODE,
        $SHELL,
        $CONTEXT,
        $SCRIPT,

        cleanGlobals;

    $REQUEST = REQUEST$$;

    $SHELL = $REQUEST.at('cmdShell');
    $LASTREQ = $SHELL.$LASTREQ;
    $LASTREQ = $SHELL.get('previous');

    $NODE = $REQUEST.at('cmdNode');
    $TPNODE = TP.wrap($NODE);

    $SCRIPT = TP.trim(TP.nodeGetTextContent($NODE));
    if (TP.isBlank($SCRIPT)) {
        $REQUEST.complete();

        return;
    }

    //  The current context (i.e. 'window' / 'self') that the evaluated
    //  statements will be executed in. This provides those statements with
    //  their global scope.
    $CONTEXT = $SHELL.getExecutionContext($REQUEST);

    //  Only in Mozilla and IE does a 'contextual eval' (i.e. one where
    //  the global/window scope is specified) take into account the current
    //  local scope (i.e. where temp variables are defined).
    //  Other browsers (Safari and Chrome) do not. Therefore, we need to
    //  make these explicitly available on the context that we're gonna
    //  invoke the eval in.
    $CONTEXT.$LASTREQ = $LASTREQ;
    $CONTEXT.$REQUEST = $REQUEST;
    $CONTEXT.$NODE = $NODE;
    $CONTEXT.$SHELL = $SHELL;
    $CONTEXT.$CONTEXT = $CONTEXT;
    $CONTEXT.$SCRIPT = $SCRIPT;

    cleanGlobals = function() {

        delete $CONTEXT.$LASTREQ;
        delete $CONTEXT.$REQUEST;
        delete $CONTEXT.$NODE;
        delete $CONTEXT.$SHELL;
        delete $CONTEXT.$CONTEXT;
        delete $CONTEXT.$SCRIPT;
        delete $CONTEXT.$_;
    };

    PIPE$$ = TP.elementGetAttribute($NODE, 'tsh:pipe', true);

    //  there are a few pipe symbols which, while they are part of the
    //  overall pipe syntax, imply the current element shouldn't try to read
    //  from stdin since it's at a segment break. When that's true we clear
    //  the pipe symbol so we'll more likely drop through to a cmdGetContent
    if (TP.$is_ioend(PIPE$$)) {
        PIPE$$ = null;
    }

    //  convert to expand any aliases etc. unless literal text is forced
    if ($NODE.getAttribute('tsh:literal') !== 'true' &&
        $REQUEST.at('cmdLiteral') !== true) {
        $SCRIPT = this.$desugarTSH($SCRIPT, $SHELL, $REQUEST);

        //  certain desugaring attempts can recognize that the request is
        //  malformed and fail() it.
        if ($REQUEST.didComplete()) {
            cleanGlobals();

            return;
        }

        TP.nodeSetTextContent($NODE, $SCRIPT);
    }

    //  if the desugaring process didn't return a viable script then we
    //  have to presume that we're being sidetracked to another request
    //  (typically due to a history rewrite of some kind). In those cases
    //  we have to simply wait for any nested request to come back around
    //  and notify this request when it completes.
    if (TP.isBlank($SCRIPT)) {
        cleanGlobals();

        return;
    }

    //  first phase is to adjust the script to deal with a special case
    //  around targeting a new identifier as a sink as in 1+2 .> foo. If foo
    //  isn't already a symbol then the script won't work properly and we'll
    //  get an error about foo being undefined. If foo already exists we
    //  want to protect it with clobber/noclobber via the ! suffix.
    CTYPE$$ = CMDTYPE$$;
    switch (CMDTYPE$$) {
        case 'add':
        case 'set':

            //  tokenize what's left so we can check for identifiers etc.
            TOKENS$$ = TP.$condenseJS(
                        $SCRIPT, false, false,
                        //  All of the JS operators *and* the TSH operators
                        TP.tsh.script.$tshAndJSOperators,
                        true, true, true);

            //  one special case for sinks is when sugaring for setting a
            //  variable or property. in those cases we're looking for a strict
            //  identifier[.identifier] pattern identifying at most one target
            //  object or variable. If the length is just one identifier it's
            //  even more special.
            if (TOKENS$$.length === 1) {
                TOKEN$$ = TOKENS$$[0];
                if (TOKEN$$ && TP.$is_identifier(TOKEN$$.name)) {
                    //  could be a variable reference. if that variable isn't
                    //  set as a scoped variable then we'll do that manually,
                    //  otherwise we can get the object and test as needed.

                    //  Have to watch for '@' prefixing here. When doing a
                    //  redirection into a dereference we want to adjust the
                    //  token value to allow resolution of the variable.
                    if (TOKEN$$.value.charAt(0) === '@') {
                        TOKEN$$.value = TOKEN$$.value.slice(1);
                        //  Deal with 'shorthand' of @FOO vs. @$FOO.
                        if (TOKEN$$.value.charAt(0) !== '$') {
                            TOKEN$$.value = '$' + TOKEN$$.value;
                        }
                        DEREF$$ = true;
                        CTYPE$$ = TP.SET;
                        $SCRIPT = TOKEN$$.value;
                    }
                } else {
                    //  TODO: Had a token, but it's not an identifier?
                    void 0;
                }
            } else if (this.isAccessPath(TOKENS$$)) {
                //  Set a flag we can check later to see that this command has
                //  been rewritten as an access path, and therefore no
                //  additional work should be done after object resolution has
                //  occurred to add/set content.
                ACCESS$$ = true;

                //  first token in an access path the the object reference, the
                //  rest can be wrapped into a string access path...
                $SCRIPT = TOKENS$$[0].value + '.set(TP.apc(\'' +
                    TOKENS$$.slice(2).collect(
                        function(item) {

                            return item.value;
                        }).join('') + '\').set(\'buildout\', true), $INPUT);';
                TP.nodeSetTextContent($NODE, $SCRIPT);
            } else {
                //  fall through and let the EXEC$$ code try to invoke the
                //  proper method on the RESULT$$ of the expression.
                void 0;
            }

            break;

        default:

            //  for potential filter/transformation operations we need to
            //  look for single-token literals which indicate a sugared
            //  filter or tranformation
            if (TP.notEmpty(PIPE$$)) {
                TOKENS$$ = TP.$condenseJS(
                        $SCRIPT, false, false,
                        //  All of the JS operators *and* the TSH operators
                        TP.tsh.script.$tshAndJSOperators,
                        true, true, true);

                //  all literal token representations are single tokens

                /* eslint-disable no-extra-parens */
                if (TOKENS$$.length === 1) {
                    QUERY$$ = (PIPE$$.indexOf('?') !== TP.NOT_FOUND);
                /* eslint-enable no-extra-parens */

                    TOKEN$$ = TOKENS$$[0];
                    switch (TOKEN$$.name) {
                        case 'regexp':

                            //  the token is a regex but we don't want
                            //  to eval it...just pull it apart to call
                            //  the constructor...but we have to watch
                            //  out for embedded /'s etc...
                            RE$$ = TP.rc(
                                TOKEN$$.value.slice(1,
                                    TOKEN$$.value.lastIndexOf('/')),
                                TOKEN$$.value.slice(
                                    TOKEN$$.value.lastIndexOf('/') + 1));

                            if (TP.notValid(RE$$)) {
                                RESULT$$ = 'Invalid RegExp filter: ' +
                                    TOKEN$$.value.slice(1,
                                        TOKEN$$.value.lastIndexOf('/')) +
                                    ' ' +
                                    TOKEN$$.value.slice(
                                        TOKEN$$.value.lastIndexOf('/') + 1);

                                //  problem creating regular expression
                                //  which should have reported an error
                                $REQUEST.fail(new Error(RESULT$$));

                                cleanGlobals();

                                return;
                            }

                            //  we already know that we have a RegExp and
                            //  that it's type implements cmdFilterInput or
                            //  cmdTransformInput, so just execute that and
                            //  return.
                            $REQUEST.atPut('cmdInstance', RE$$);
                            if (QUERY$$) {
                                RegExp.cmdFilterInput($REQUEST);
                            } else {
                                RegExp.cmdTransformInput($REQUEST);
                            }

                            cleanGlobals();

                            return;

                        case 'string':

                            //  we already know that we have a String and
                            //  that it's type implements cmdFilterInput or
                            //  cmdTransformInput, so just execute that and
                            //  return.
                            $REQUEST.atPut('cmdInstance', TOKEN$$.value);
                            if (QUERY$$) {
                                String.cmdFilterInput($REQUEST);
                            } else {
                                String.cmdTransformInput($REQUEST);
                            }

                            cleanGlobals();

                            return;

                        default:

                            //  single-token content...fall through

                    }
                } else if (this.isAccessPath(TOKENS$$)) {
                    //  Set a flag we can check later to see that this
                    //  command has been rewritten as an access path, and
                    //  therefore no additional work should be done after
                    //  object resolution has occurred to add/set content.
                    ACCESS$$ = true;

                    //  first token in an access path the the object
                    //  reference, the rest can be wrapped into a string
                    //  access path...
                    $SCRIPT = TOKENS$$[0].value + '.get(TP.apc(\'' +
                        TOKENS$$.slice(2).collect(
                            function(item) {

                                return item.value;
                            }).join('') + '\'), $INPUT);';
                    TP.nodeSetTextContent($NODE, $SCRIPT);
                } else {
                    //  multi-token content...fall through
                    void 0;
                }
            } else {
                //  if we're not the target of a pipe life is easy, we're
                //  basically a "getContent" command which may/may not push
                //  our output to a downstream target.

                //  NOTE that by setting literal to true here we avoid
                //  having the getContent logic reparse/re-desugar the
                //  content.
                $REQUEST.atPut('cmdLiteral', true);

                //  NOTE also that we have to ensure a downstream
                //  nodeGetContent operation will find the updated script.
                TP.nodeSetTextContent($NODE, $SCRIPT);

                //  single-token content... we have to determine if we're the
                //  source of a piping construct of some sort (i.e. 'peek ahead'
                //  to the next command element in the pipe). If so, we have to
                //  fetch content - otherwise, we can just fall through.

                //  Note that we're looking at the pipe in the downstream
                //  segment so we want to make sure that *it* is not supposed to
                //  be doing a 'get'. If *it* is not doing a get, that means
                //  that *we* are.
                if (!$TPNODE.isLastSegment() &&
                    $TPNODE.getDownstreamSegment().getRedirectionType() !==
                                                                    TP.GET) {
                    cleanGlobals();

                    return this.cmdGetContent($REQUEST);
                }
            }

            break;
    }

    //  ---
    //  helper function
    //  ---

    EXEC$$ = function(COMPLETE$$) {

        var INPUT$$,
            LOOP$$,
            LEN$$,
            I$$,
            START$$,
            SCOPE$$,
            END$$,
            ERR$$,
            TIME$$,
            SCRIPT$$,
            FLAG$$;

        INPUT$$ = $REQUEST.stdin();
        LOOP$$ = $REQUEST.at('cmdIterate');

        LEN$$ = INPUT$$.getSize();

        //  one possible issue is when the previous command didn't write
        //  output for whatever reason, but the pipe was constructed as if
        //  the current element should expect input. when that's the case we
        //  "fake" a single null as the input data.
        if (LEN$$ === 0) {
            INPUT$$ = TP.ac(null);
            LEN$$ = 1;
        }

        //  eval has problems with Object and Function literals, but
        //  wrapping them in parentheses helps...

        //  Object literals
        if ($SCRIPT.charAt(0) === '{' &&
            $SCRIPT.charAt($SCRIPT.length - 1) === '}') {
            $SCRIPT = '(' + $SCRIPT + ')';
        }

        //  Function literals
        //  To keep things simpler for the regex we run the test on the script
        //  with newlines removed.
        if (TP.regex.FUNCTION_LITERAL.test($SCRIPT.replace(/\n/g, ' '))) {
            $SCRIPT = '(' + $SCRIPT + ')';
        }

        //  String literals - double quoted
        if ($SCRIPT.charAt(0) === '"' &&
                $SCRIPT.charAt($SCRIPT.length - 1) === '"') {
            $SCRIPT = $SHELL.resolveVariableSubstitutions($SCRIPT);
        }

        // SCRIPT$$ = TP.$condenseJS($SCRIPT, true);
        SCRIPT$$ = $SCRIPT;

        //  Tell the main Lama object that it should go ahead and process DOM
        //  mutations to the source DOM.
        if (TP.sys.hasFeature('lama')) {
            TP.bySystemId('Lama').set('shouldProcessDOMMutations', true);
        }

        FLAG$$ = TP.sys.shouldThrowExceptions();
        TP.sys.shouldThrowExceptions(true);

        /* eslint-disable no-loop-func */
        for (I$$ = 0; I$$ < LEN$$; I$$++) {

            $INPUT = INPUT$$.at(I$$);

            try {
                $REQUEST.stdout(TP.TSH_NO_VALUE);

                START$$ = Date.now();
                if (LOOP$$) {
                    if (TP.isCollection($INPUT)) {
                        //  Grab the execution scope.
                        SCOPE$$ = $SHELL.getExecutionInstance($REQUEST);
                        RESULT$$ = $INPUT.collect(
                            function(ITEM$$, INDEX$$) {
                                var result;

                                $INDEX = INDEX$$;
                                $_ = ITEM$$;

                                //  Capture the 'pre eval' state of the context
                                //  and place the slots from the scope onto the
                                //  context.
                                TP.tsh.eval.$populateContextFromScope(
                                                            $CONTEXT, SCOPE$$);

                                //  Eval the script.
                                result = $CONTEXT.eval(SCRIPT$$);

                                //  Capture the current state of the context and
                                //  place the slots from the context onto the
                                //  scope.
                                TP.tsh.eval.$populateScopeFromContext(
                                                            $CONTEXT, SCOPE$$);

                                return result;
                            });
                    } else {
                        //  splatted on non-collection...
                        $_ = $INPUT;

                        //  Grab the execution scope.
                        SCOPE$$ = $SHELL.getExecutionInstance($REQUEST);

                        //  Capture the 'pre eval' state of the context and
                        //  place the slots from the scope onto the context.
                        TP.tsh.eval.$populateContextFromScope(
                                                        $CONTEXT, SCOPE$$);

                        //  Eval the script.
                        RESULT$$ = TP.ac($CONTEXT.eval(SCRIPT$$));

                        //  Capture the current state of the context and place
                        //  the slots from the context onto the scope.
                        TP.tsh.eval.$populateScopeFromContext(
                                                        $CONTEXT, SCOPE$$);
                    }
                } else {
                    $_ = $INPUT;

                    //  Grab the execution scope.
                    SCOPE$$ = $SHELL.getExecutionInstance($REQUEST);

                    //  Capture the 'pre eval' state of the context and place
                    //  the slots from the scope onto the context.
                    TP.tsh.eval.$populateContextFromScope(
                                                    $CONTEXT, SCOPE$$);

                    //  Eval the script.
                    RESULT$$ = $CONTEXT.eval(SCRIPT$$);

                    //  Capture the current state of the context and place the
                    //  slots from the context onto the scope.
                    TP.tsh.eval.$populateScopeFromContext(
                                                    $CONTEXT, SCOPE$$);
                }
                END$$ = Date.now();

                TIME$$ = TP.ifInvalid($REQUEST.get('$evaltime'), 0);
                $REQUEST.set('$evaltime', TIME$$ + (END$$ - START$$));

                if (TP.notFalse(COMPLETE$$)) {
                    $REQUEST.complete(RESULT$$);
                }
            } catch (e) {
                END$$ = Date.now();
                TIME$$ = TP.ifInvalid($REQUEST.get('$evaltime'), 0);
                $REQUEST.set('$evaltime', TIME$$ + (END$$ - START$$));

                //  An exception was thrown - no sense in having the main Lama
                //  object process DOM mutations to the source DOM.
                if (TP.sys.hasFeature('lama')) {
                    TP.bySystemId('Lama').set('shouldProcessDOMMutations',
                                                false);
                }

                if (TP.sys.cfg('tsh.ignore_eval_errors') === true) {
                    //  If we're ignoring eval errors, then we just complete the
                    //  request with undefined here.
                    $REQUEST.complete(undefined);
                } else {
                    //  NOTE we slice off the file reference at the tail
                    //  since that's not accurate...we're doing
                    //  interactive input here.
                    ERR$$ = e.message;

                    /* eslint-disable no-extra-parens */
                    ERR$$ = (ERR$$.indexOf(':: file:') === TP.NOT_FOUND) ?
                    /* eslint-enable no-extra-parens */
                        TP.trim(ERR$$) :
                        TP.trim(ERR$$.slice(0, ERR$$.indexOf(':: file:')));
                    if (/[sS]yntax/.test(ERR$$)) {
                        RESULT$$ = ERR$$ + ': ' + $SCRIPT;
                    } else if (/missing ; before statement/.test(ERR$$)) {
                        //  Rewrites of commands/aliases etc. can sometimes
                        //  cause eval to output a useless message about a
                        //  missing ;. In those cases we want to be sure to dump
                        //  the script.
                        RESULT$$ = 'syntax error: ' + $SCRIPT;
                    } else {
                        RESULT$$ = ERR$$.endsWith('.') ? ERR$$ : ERR$$ + '.';
                    }

                    $REQUEST.fail(new Error(RESULT$$));
                }

                return;
            }
        }

        TP.sys.shouldThrowExceptions(FLAG$$);

        /* eslint-enable no-loop-func */
    };

    //  with our execution helper ready we can now process the command types
    //  and work off their results as needed.
    switch (CTYPE$$) {
        case 'var':

            //  exec once to set variable, then our work is finished
            $REQUEST.atPut('cmdIterate', false);
            EXEC$$();

            break;

        case TP.ADD:

            //  no splatting or other iterations are relevant for 'add' and
            //  we can't complete inside the exec call, we have to wait.
            $REQUEST.atPut('cmdIterate', false);
            EXEC$$(TP.ifInvalid(ACCESS$$, false));

            //  If the eval catch block triggered the request will have
            //  failed so no point in continuing.
            if ($REQUEST.didComplete()) {
                cleanGlobals();

                return;
            }

            if (TP.canInvoke(RESULT$$, 'cmdAddContent')) {
                RESULT$$ = RESULT$$.cmdAddContent($REQUEST);
            } else if (TP.isType(TYPE$$ = TP.type(RESULT$$))) {

                if (TP.canInvoke(TYPE$$, 'cmdAddContent')) {
                    $REQUEST.atPut('cmdInstance', RESULT$$);
                    RESULT$$ = TYPE$$.cmdAddContent($REQUEST);
                } else {
                    $REQUEST.fail(new Error('Invalid sink.'));
                }
            } else if (!TP.isMutable(RESULT$$)) {
                $REQUEST.fail(new Error('Non-mutable sink.'));
            } else {
                $REQUEST.fail(new Error('Missing sink.'));
            }

            break;

        case TP.FILTER:

            //  we can't complete inside the exec call, we have to wait.
            EXEC$$(TP.ifInvalid(ACCESS$$, false));

            //  If the eval catch block triggered the request will have
            //  failed so no point in continuing.
            if ($REQUEST.didComplete()) {
                cleanGlobals();

                return;
            }

            //  If the script doesn't reference either $INPUT or $_ (and hence
            //  couldn't have done "real work" on the inbound data) then we
            //  message the result object to get the content to filter.

            if (/\$INPUT/.test($SCRIPT) !== true &&
                /\$_/.test($SCRIPT) !== true) {

                if (TP.canInvoke(RESULT$$, 'cmdFilterInput')) {
                    RESULT$$ = RESULT$$.cmdFilterInput($REQUEST);
                } else if (TP.isType(TYPE$$ = TP.type(RESULT$$))) {

                    if (TP.canInvoke(TYPE$$, 'cmdFilterInput')) {
                        $REQUEST.atPut('cmdInstance', RESULT$$);
                        RESULT$$ = TYPE$$.cmdFilterInput($REQUEST);
                    } else {
                        $REQUEST.fail(new Error('Invalid pipe.'));
                    }
                } else {
                    $REQUEST.complete(RESULT$$);
                }
            } else {
                $REQUEST.complete(RESULT$$);
            }

            break;

        case TP.SET:

            //  no splatting or other iterations are relevant for 'set' and
            //  we can't complete inside the exec call, we have to wait.
            $REQUEST.atPut('cmdIterate', false);
            EXEC$$(TP.ifInvalid(ACCESS$$, false));

            //  If the eval catch block triggered the request will have
            //  failed so no point in continuing.
            if ($REQUEST.didComplete()) {
                cleanGlobals();

                return;
            }

            //  If DEREF$$ is true we're looking at a script that should resolve
            //  a variable reference. The first check here is for the ${foo}
            //  variant, which we need to adjust.
            if (TP.regex.TSH_VARIABLE.test($SCRIPT)) {
                VAR$$ = $SCRIPT.slice(1);
                if (VAR$$.charAt(0) === '{') {
                    VAR$$ = VAR$$.slice(1, -1);
                }

                if (!DEREF$$) {
                    RESULT$$ = $REQUEST.stdin().at(0);
                    $SHELL.setVariable(VAR$$, RESULT$$);
                    $REQUEST.complete(RESULT$$);

                    cleanGlobals();

                    return;
                } else {
                    RESULT$$ = $SHELL.getVariable(VAR$$);
                }
            }

            if (TP.canInvoke(RESULT$$, 'cmdSetContent')) {
                RESULT$$ = RESULT$$.cmdSetContent($REQUEST);
            } else if (TP.isType(TYPE$$ = TP.type(RESULT$$))) {

                if (TP.canInvoke(TYPE$$, 'cmdSetContent')) {
                    $REQUEST.atPut('cmdInstance', RESULT$$);
                    RESULT$$ = TYPE$$.cmdSetContent($REQUEST);
                } else {
                    $REQUEST.fail('Invalid sink.');
                }
            } else if (!TP.isMutable(RESULT$$)) {
                $REQUEST.fail('Non-mutable sink.');
            } else {
                $REQUEST.fail('Missing sink.');
            }

            break;

        case TP.TRANSFORM:

            //  we can't complete inside the exec call, we have to wait.
            EXEC$$(TP.ifInvalid(ACCESS$$, false));

            //  If the eval catch block triggered the request will have
            //  failed so no point in continuing.
            if ($REQUEST.didComplete()) {
                cleanGlobals();

                return;
            }

            //  If the script doesn't reference either $INPUT or $_ (and hence
            //  couldn't have done "real work" on the inbound data) then we
            //  message the result object to get the content to filter.

            if (/\$INPUT/.test($SCRIPT) !== true &&
                /\$_/.test($SCRIPT) !== true) {

                if (TP.canInvoke(RESULT$$, 'cmdTransformInput')) {
                    RESULT$$ = RESULT$$.cmdTransformInput($REQUEST);
                } else if (TP.isType(TYPE$$ = TP.type(RESULT$$))) {

                    if (TP.canInvoke(TYPE$$, 'cmdTransformInput')) {
                        $REQUEST.atPut('cmdInstance', RESULT$$);
                        RESULT$$ = TYPE$$.cmdTransformInput($REQUEST);
                    } else {
                        $REQUEST.fail('Invalid pipe.');
                    }
                } else {
                    $REQUEST.complete(RESULT$$);
                }
            } else {
                $REQUEST.complete(RESULT$$);
            }

            break;

        default:

            EXEC$$();
            break;
    }

    cleanGlobals();

    return;
});

//  ------------------------------------------------------------------------

TP.tsh.eval.Type.defineMethod('cmdSetContent',
function(REQUEST$$) {

    /**
     * @method cmdSetContent
     * @summary Invoked when the receiver is being used as a sink with set
     *     semantics. In this case the object referenced by the receiver's
     *     content should have its setContent method called if it responds to
     *     one.
     * @param {TP.sig.Request} REQUEST$$ The request containing command input
     *     for the shell.
     */

    return this.cmdRunContent(REQUEST$$, TP.SET);
});

//  ------------------------------------------------------------------------

TP.tsh.eval.Type.defineMethod('cmdTransformInput',
function(REQUEST$$) {

    /**
     * @method cmdTransformInput
     * @summary Invoked when the receiver is being used as a transform. In this
     *     case the object referenced by the receiver's content will its
     *     cmdTransformInput method called if it responds to one.
     * @param {TP.sig.Request} REQUEST$$ The request containing command input
     *     for the shell.
     */

    return this.cmdRunContent(REQUEST$$, TP.TRANSFORM);
});

//  ------------------------------------------------------------------------

TP.tsh.eval.Type.defineMethod('expandContent',
function(aString, aShell, aRequest) {

    /**
     * @method expandContent
     * @summary Expands content contained in the supplied source string using
     *     the provided shell.
     * @description Content expansion consists of expanding any command
     *     substitutions (content inside of `...` constructs), templates, and
     *     shell variables contained in the content.
     * @param {String} aString The source string to expand content in.
     * @param {TP.shell.Shell} aShell The shell instance.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {String} The source string with the content expanded.
     */

    var result,

        SCRIPT$$,
        SCOPE$$,
        RESULT$$,

    //  standard "special variables" we're willing to expose to scripts
        $LASTREQ,
        $REQUEST,
        $NODE,
        $SHELL,
        $CONTEXT,
        $SCRIPT,

        err,
        flag,
        value,
        sourcevars,

        wasCommandSubstitution;

    //  If the string is single-quoted we do nothing.
    if (aString.unquoted().quoted('\'') === aString) {
        return aString;
    }

    //  Don't expand variable names. We leave them for later resolution.
    if (TP.regex.TSH_VARIABLE.test(aString)) {
        return aString;
    }

    //  There is an order of operation here when expanding content:

    //  1. Process template substitutions
    //  2. Process variable substitutions
    //  3. Process command substitutions

    //  set up some common variables
    $REQUEST = aRequest;
    $SHELL = aShell;

    //  set up our output buffer
    result = TP.ac();

    //  ---
    //  Step 1: Process template substitutions
    //  ---

    value = aString;

    //  If the value is a template, then we use template transformation. We do
    //  *not* resolve variable substitutions using the normal mechanism before
    //  transforming the template or otherwise we'll have literal values in the
    //  template, which won't work. Instead, we supply the shell's 'execution
    //  instance' to the templating engine as a 'data source'.
    if (TP.regex.HAS_ACP.test(value)) {

        //  Since templating treats '$' variables specially (i.e. $INDEX,
        //  etc.), and all shell variables have a leading '$', we need to
        //  pull out the names of the variables in our String and supply
        //  them as a set of names that the transformation engine should
        //  treat as 'normal'.

        //  First, we convert '${X}' into '$X'
        TP.regex.TSH_VARSUB_EXTENDED.lastIndex = 0;
        value = value.replace(TP.regex.TSH_VARSUB_EXTENDED, '$$$1');

        //  Next, extract the source variables, either in '$X' or used-to-be
        //  '${X}' form into an Array where they are all normalized to '$X'.
        sourcevars = TP.ac();
        TP.regex.TSH_VARSUB_EXTRACT.lastIndex = 0;
        TP.regex.TSH_VARSUB_EXTRACT.performWith(
                function(wholeMatch, varName) {
                    sourcevars.push('$' + varName);
                }, value);

        //  Do the transformation with the execution instance as the data source.
        value = value.transform(
            $SHELL.getExecutionInstance($REQUEST),
            TP.hc('sourcevars', sourcevars));
    } else {
        TP.regex.TSH_VARSUB_EXTENDED.lastIndex = 0;
        value = value.replace(TP.regex.TSH_VARSUB_EXTENDED, '$$$1');
    }

    //  Make sure to detect command substitutions *before* trying to resolve
    //  variables substitutions
    wasCommandSubstitution = false;

    //  If the value starts with a backtick ('`'), then it's a command
    //  substitution, so flag it as such and trim off the leading and trailing
    //  '`'.
    if (value.indexOf('`') === 0) {
        wasCommandSubstitution = true;
        value = value.slice(1, -1);
    }

    //  ---
    //  Step 2: Process variable substitutions
    //  ---

    $SCRIPT = $SHELL.resolveVariableSubstitutions(value);

    //  ---
    //  Step 3: Process command substitutions
    //  ---

    //  command substitution...effectively inlining result data where the
    //  command text is positioned.
    if (wasCommandSubstitution === true) {

        if (TP.notTrue(TP.ifKeyInvalid(aRequest, 'cmdBuildGUI', false)) &&
            TP.notTrue(TP.ifKeyInvalid(aRequest, 'cmdAllowSubs', false))) {
            aRequest.fail(
                new Error(
                TP.sc(TP.join(
                        'Security violation. Attempt to use',
                        ' command substitution outside of',
                        ' interactive mode.'))));

            return;
        }

        //  If 'value' matches shell 'dereference sugar' (i.e. '@foo'), then we
        //  have to strip the leading '@'.
        if (TP.regex.TSH_DEREF_SUGAR.test(value)) {
            value = value.slice(1);
        }

        $SCRIPT = value;

        //  Ensure consistent context variables are in place when/if we do any
        //  eval operations for resolving command substitutions.
        $NODE = $REQUEST.at('cmdNode');
        $LASTREQ = $SHELL.get('previous');

        //  The current context (i.e. 'window' / 'self') that the evaluated
        //  statements will be executed in. This provides those statements with
        //  their global scope.
        $CONTEXT = aShell.getExecutionContext($REQUEST);

        //  Only in Mozilla and IE does a 'contextual eval' (i.e. one where
        //  the global/window scope is specified) take into account the current
        //  local scope (i.e. where temp variables are defined).
        //  Other browsers (Safari and Chrome) do not. Therefore, we need to
        //  make these explicitly available on the context that we're gonna
        //  invoke the eval in.
        $CONTEXT.$LASTREQ = $LASTREQ;
        $CONTEXT.$REQUEST = $REQUEST;
        $CONTEXT.$NODE = $NODE;
        $CONTEXT.$SHELL = $SHELL;
        $CONTEXT.$CONTEXT = $CONTEXT;
        $CONTEXT.$SCRIPT = $SCRIPT;
        $CONTEXT.$_ = null;

        try {
            flag = TP.sys.shouldThrowExceptions();
            TP.sys.shouldThrowExceptions(true);

            //  Refresh the context's script reference after any substitutions
            //  so any internal reference to it will reflect what's being eval'd.
            $CONTEXT.$SCRIPT = $SCRIPT;

            //  eval has problems with Object and Function literals, but
            //  wrapping them in parentheses helps...

            //  Object literals
            if ($SCRIPT.charAt(0) === '{' &&
                $SCRIPT.charAt($SCRIPT.length - 1) === '}') {
                $SCRIPT = '(' + $SCRIPT + ')';
            }

            //  Function literals
            //  To keep things simpler for the regex we run the test on the
            //  script with newlines removed.
            if (TP.regex.FUNCTION_LITERAL.test($SCRIPT.replace(/\n/g, ' '))) {
                $SCRIPT = '(' + $SCRIPT + ')';
            }

            // $SCRIPT = TP.$condenseJS($SCRIPT, true);
            SCRIPT$$ = $SCRIPT;

            //  Grab the execution scope.
            SCOPE$$ = $SHELL.getExecutionInstance($REQUEST);

            //  Capture the 'pre eval' state of the context and place the slots
            //  from the scope onto the context.
            TP.tsh.eval.$populateContextFromScope($CONTEXT, SCOPE$$);

            //  Eval the script.
            RESULT$$ = $CONTEXT.eval(SCRIPT$$);

            //  Capture the current state of the context and place the slots
            //  from the context onto the scope.
            TP.tsh.eval.$populateScopeFromContext($CONTEXT, SCOPE$$);
        } catch (e) {

            if (TP.sys.cfg('tsh.ignore_eval_errors') === true) {
                //  Note that if we're ignoring eval errors, then we just return
                //  the 'undefined' *String* here (if we just return undefined,
                //  then the engine waits for another request because it thinks
                //  this one hasn't finished and is part of a pipe or
                //  something).
                RESULT$$ = 'undefined';
            } else {
                //  NOTE we slice off the file reference at the tail since that's
                //  not accurate...we're doing interactive input here.
                err = e.message;

                /* eslint-disable no-extra-parens */
                err = (err.indexOf(':: file:') === TP.NOT_FOUND) ?
                /* eslint-enable no-extra-parens */
                    TP.trim(err) :
                    TP.trim(err.slice(0, err.indexOf(':: file:')));
                err = err.endsWith('.') ? err : err + '.';

                $REQUEST.fail(
                    new Error(
                    TP.join(
                        TP.sc('Command substitution `'),
                        aString.slice(1, -1),
                        TP.sc('` failed: '),
                        err)));
            }
        } finally {
            //  Reset our flags...
            TP.sys.shouldThrowExceptions(flag);
        }

        //  if the catch block failed the request we're done.
        if (aRequest.didComplete()) {
            return;
        }

        result.push(RESULT$$);

    } else {
        result.push($SCRIPT);
    }

    return result.join('');
});

//  ------------------------------------------------------------------------

TP.tsh.eval.Type.defineMethod('$populateContextFromScope',
function(context, scope) {

    /**
     * @method $populateContextFromScope
     * @summary Populates the supplied context from the supplied scope. This is
     *     typically called before a shell 'eval' operation.
     * @param {Object} context The context that the eval will happen in.
     * @param {Object} scope The scope object that 'global' properties will be
     *     placed in when code is eval'ed.
     * @returns {TP.meta.tsh.eval} The receiver.
     */

    var originalKeys,
        originalKeySet;

    //  Grab the keys that currently exist on the context and make a Set from
    //  them.
    originalKeys = Object.keys(context);
    originalKeySet = new Set(originalKeys);

    this.$set('$originalContextKeySet', originalKeySet, false);

    //  Grab the keys from the scope, iterate over them and wire them over to
    //  the context.
    TP.keys(scope).forEach(
        function(aKey) {
            context[aKey] = scope[aKey];
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.tsh.eval.Type.defineMethod('$populateScopeFromContext',
function(context, scope) {

    /**
     * @method $populateScopeFromContext
     * @summary Populates the supplied scope from the supplied context. This is
     *     typically called before a shell 'eval' operation.
     * @param {Object} context The context that the eval will happen in.
     * @param {Object} scope The scope object that 'global' properties will be
     *     placed in when code is eval'ed.
     * @returns {TP.meta.tsh.eval} The receiver.
     */

    var originalKeySet,

        currentKeys,
        diffKeys;

    //  This will be the set of keys that the context originally had before we
    //  put slots from the scope onto it.
    originalKeySet = this.$get('$originalContextKeySet');

    //  Grab the set of keys that are currently on the context and filter them
    //  against the set of keys that were there before we put slots from the
    //  scope onto it. This will result in the set of keys that should be copied
    //  over to the scope and deleted from the context.
    currentKeys = Object.keys(context);
    diffKeys = currentKeys.filter(
                function(aKey) {
                    return !originalKeySet.has(aKey);
                });

    diffKeys.forEach(
        function(aKey) {
            var val;

            //  Grab the value for the key from the context and set it onto the
            //  scope.
            val = context[aKey];
            scope.atPut(aKey, val);

            //  Delete the key from the context. Note that context here is
            //  normally the global object.
            delete context[aKey];
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.tsh.eval.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Responds to requests by the TSH to execute. The tsh:eval tag
     *     doesn't process in this fashion, it can only be invoked as part of a
     *     tsh:script tag's execution so this method raises an
     *     TP.sig.InvalidOperation exception.
     * @param {TP.sig.Request} aRequest The request to be processed.
     * @exception TP.sig.InvalidOperation
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    this.raise('TP.sig.InvalidOperation');

    return TP.BREAK;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.pp.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.pp}
 * @summary The default "pretty-print" formatter for the TIBET Shell. Since
 *     this type is a formatter at heart most of the methods are built to
 *     support decent output for common JavaScript data types.
 */

//  ------------------------------------------------------------------------

TP.lang.Object.defineSubtype('tsh.pp');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

//  ========================================================================
//  Objects with as() but without an asTP_tsh_pp...
//  ========================================================================

TP.tsh.pp.Type.defineMethod('fromArray',
function(anObject, optFormat) {

    var len,

        output,

        count,
        colcount,

        i;

    //  If this flag is set to true, that means that we're already trying to
    //  format this object as part of larger object set and we may have an
    //  endless recursion problem if there are circular references and we
    //  let this formatting operation proceed. Therefore, we just return the
    //  'recursion' format of the object.
    if (anObject.$$format_tsh_pp) {
        return TP.recursion(anObject);
    }

    //  Set the recursion flag so that we don't endless recurse when
    //  producing circular representations of this object and its members.
    anObject.$$format_tsh_pp = true;

    //  Don't need to box output from our own markup generator, and we want the
    //  markup here to actually render, but not awake.
    if (TP.isValid(optFormat)) {
        optFormat.atPut('cmdBox', false);
        optFormat.atPut('cmdAsIs', true);
        optFormat.atPut('cmdAwaken', false);
    }

    len = anObject.getSize();

    output = TP.ac();

    output.push('<span class="tsh_pp"><span class="Array">');

    count = 0;
    colcount = 1;

    for (i = 0; i < len; i++) {
        if (count > colcount - 1) {
            count = 0;
        }

        output.push('<span data-name="' + i + '">' +
            TP.boot.$stringify(anObject.at(i), '', true) +
                    '</span>');

        count++;
    }

    output.push('</span></span>');

    //  We're done - we can remove the recursion flag.
    delete anObject.$$format_tsh_pp;

    return output.join('\n');
});

//  ------------------------------------------------------------------------

TP.tsh.pp.Type.defineMethod('fromBoolean',
function(anObject, optFormat) {

    //  Don't need to box output from our own markup generator, and we want the
    //  markup here to actually render, but not awake.
    if (TP.isValid(optFormat)) {
        optFormat.atPut('cmdBox', false);
        optFormat.atPut('cmdAsIs', true);
        optFormat.atPut('cmdAwaken', false);
    }

    return '<span class="tsh_pp">' + anObject.toString() + '</span>';
});

//  ------------------------------------------------------------------------

TP.tsh.pp.Type.defineMethod('fromDate',
function(anObject, optFormat) {

    //  Don't need to box output from our own markup generator, and we want the
    //  markup here to actually render, but not awake.
    if (TP.isValid(optFormat)) {
        optFormat.atPut('cmdBox', false);
        optFormat.atPut('cmdAsIs', true);
        optFormat.atPut('cmdAwaken', false);
    }

    return '<span class="tsh_pp">' + anObject.toISOString() + '</span>';
});

//  ------------------------------------------------------------------------

TP.tsh.pp.Type.defineMethod('fromError',
function(anObject, optFormat) {

    var stackStr,
        stackEntries;

    //  Don't need to box output from our own markup generator, and we want the
    //  markup here to actually render, but not awake.
    if (TP.isValid(optFormat)) {
        optFormat.atPut('cmdBox', false);
        optFormat.atPut('cmdAsIs', true);
        optFormat.atPut('cmdAwaken', false);
    }

    stackStr = '';
    if (TP.sys.shouldLogStack() &&
        TP.notEmpty(stackEntries = TP.getStackInfo(anObject))) {
        stackStr = '<br/>' +
                    stackEntries.collect(
                        function(infoPiece) {
                            return infoPiece.asEscapedXML();
                        }).join('<br/>');
    }

    return '<span class="tsh_pp">' +
                anObject.message.asEscapedXML() +
                stackStr +
            '</span>';
});

//  ------------------------------------------------------------------------

TP.tsh.pp.Type.defineMethod('fromFunction',
function(anObject, optFormat) {

    var str;

    //  Don't need to box output from our own markup generator, and we want the
    //  markup here to actually render, but not awake.
    if (TP.isValid(optFormat)) {
        optFormat.atPut('cmdBox', false);
        optFormat.atPut('cmdAsIs', true);
        optFormat.atPut('cmdAwaken', false);
    }

    str = TP.str(anObject);

    //  NOTE the CDATA blocks here combined with <pre> to hold on to remaining
    //  whitespace while ensuring we ignore any embedded < or > symbols etc.
    return '<span class="tsh_pp Function"><pre><![CDATA[' + str +
        ']]></pre></span>';
});

//  ------------------------------------------------------------------------

TP.tsh.pp.Type.defineMethod('fromNamedNodeMap',
function(anObject, optFormat) {

    var arr,

        len,
        i;

    //  Don't need to box output from our own markup generator.
    if (TP.isValid(optFormat)) {
        optFormat.atPut('cmdBox', false);
        optFormat.atPut('cmdAsIs', true);
        optFormat.atPut('cmdAwaken', false);
    }

    arr = TP.ac();

    len = anObject.length;
    arr.push('<span class="NamedNodeMap">');
    for (i = 0; i < len; i++) {
        arr.push('<span data-name="key">' +
                    TP.name(anObject.item(i)) +
                '</span>' + '\n' +
                '<span data-name="value">' +
                    TP.val(anObject.item(i)) +
                '</span>');
    }
    arr.push('</span>');

    return '<span class="tsh_pp">' + arr.join('\n') + '</span>';
});

//  ------------------------------------------------------------------------

TP.tsh.pp.Type.defineMethod('fromNode',
function(anObject, optFormat) {

    //  Don't need to box output from our own markup generator.
    if (TP.isValid(optFormat)) {
        optFormat.atPut('cmdBox', false);
        optFormat.atPut('cmdAsIs', true);
        optFormat.atPut('cmdAwaken', false);
    }

    return '<span class="tsh_pp">' +
            TP.str(anObject).asEscapedXML() +
            '</span>';
});

//  ------------------------------------------------------------------------

TP.tsh.pp.Type.defineMethod('fromNodeList',
function(anObject, optFormat) {

    var arr,

        len,
        i;

    //  Don't need to box output from our own markup generator.
    if (TP.isValid(optFormat)) {
        optFormat.atPut('cmdBox', false);
        optFormat.atPut('cmdAsIs', true);
        optFormat.atPut('cmdAwaken', false);
    }

    arr = TP.ac();

    len = anObject.length;
    arr.push('<span class="NodeList">');
    for (i = 0; i < len; i++) {
        arr.push('<span data-name="' + i + '">' +
            TP.str(anObject[i]).asEscapedXML() +
        '</span>');
    }
    arr.push('</span>');

    return '<span class="tsh_pp">' + arr.join('\n') + '</span>';
});

//  ------------------------------------------------------------------------

TP.tsh.pp.Type.defineMethod('fromNumber',
function(anObject, optFormat) {

    //  Don't need to box output from our own markup generator, and we want the
    //  markup here to actually render, but not awake.
    if (TP.isValid(optFormat)) {
        optFormat.atPut('cmdBox', false);
        optFormat.atPut('cmdAsIs', true);
        optFormat.atPut('cmdAwaken', false);
    }

    return '<span class="tsh_pp">' + anObject.toString() + '</span>';
});

//  ------------------------------------------------------------------------

TP.tsh.pp.Type.defineMethod('fromObject',
function(anObject, optFormat) {

    var type,
        output,
        i,
        len,
        keys,
        key;

    //  Don't need to box output from our own markup generator, and we want the
    //  markup here to actually render, but not awake.
    if (TP.isValid(optFormat)) {
        optFormat.atPut('cmdBox', false);
        optFormat.atPut('cmdAsIs', true);
        optFormat.atPut('cmdAwaken', false);
    }

    if (TP.notValid(anObject)) {
        // 'null' or 'undefined', as you'd expect.
        return '<span class="tsh_pp">' + anObject + '</span>';
    }

    type = TP.name(TP.type(anObject)).replace(/\./g, '_');
    output = TP.ac();

    output.push('<span class="tsh_pp"><span class="' + type + '">');

    keys = TP.keys(anObject);
    keys.sort();
    keys.compact();
    len = keys.getSize();

    for (i = 0; i < len; i++) {
        key = keys.at(i);

        output.push('<span data-name="' + key + '">' +
            TP.boot.$stringify(anObject[keys.at(i)], '\n', true) +
                    '</span>');
    }

    output.push('</span></span>');

    return output.join('\n');
    /*
    if (anObject === TP || anObject === TP.sys) {
        return '<span class="tsh_pp">' +
                TP.xhtmlstr(TP.keys(anObject).sort()) +
                '<\/span>';
    }

    return '<span class="tsh_pp">' + TP.xhtmlstr(anObject) + '<\/span>';
    */
});

//  ------------------------------------------------------------------------

TP.tsh.pp.Type.defineMethod('fromRegExp',
function(anObject, optFormat) {

    //  Don't need to box output from our own markup generator, and we want the
    //  markup here to actually render, but not awake.
    if (TP.isValid(optFormat)) {
        optFormat.atPut('cmdBox', false);
        optFormat.atPut('cmdAsIs', true);
        optFormat.atPut('cmdAwaken', false);
    }

    return '<span class="tsh_pp">' + anObject.toString() + '</span>';
});

//  ------------------------------------------------------------------------

TP.tsh.pp.Type.defineMethod('fromString',
function(anObject, optFormat) {

    var obj;

    //  Don't need to box output from our own markup generator.
    if (TP.isValid(optFormat)) {
        optFormat.atPut('cmdBox', false);
        optFormat.atPut('cmdAsIs', false);
        optFormat.atPut('cmdAwaken', false);
    }

    if (TP.regex.CONTAINS_ELEM_MARKUP.test(anObject)) {
        if (TP.isValid(optFormat)) {
            optFormat.atPut('cmdAsIs', true);
        }
    }

    obj = anObject.asEscapedXML();

    return '<span class="tsh_pp">' + TP.xhtmlstr(obj) + '</span>';
});

//  ------------------------------------------------------------------------

TP.tsh.pp.Type.defineMethod('fromTP_boot_Annotation',
function(anObject, optFormat) {

    //  Annotations are an object/message pairing within a primitive
    //  wrapper. The object in TP.boot.Annotation instances is almost always
    //  an Error object of some kind.

    //  Don't need to box output from our own markup generator.
    if (TP.isValid(optFormat)) {
        optFormat.atPut('cmdBox', false);
        optFormat.atPut('cmdAsIs', true);
        optFormat.atPut('cmdAwaken', false);
    }

    return '<span class="tsh_pp">' +
                '<span class="TP_boot_Annotation">' +
                    '<span data-name="object">' +
                        TP.xhtmlstr(anObject.object) +
                    '</span>' +
                    '<span data-name="message">' +
                        TP.xhtmlstr(anObject.message) +
                    '</span>' +
                '</span>' +
            '</span>';
});

//  ------------------------------------------------------------------------

TP.tsh.pp.Type.defineMethod('fromTP_boot_Log',
function(anObject, optFormat) {

    var obj,

        str,
        len,
        i;

    //  Don't need to box output from our own markup generator.
    if (TP.isValid(optFormat)) {
        optFormat.atPut('cmdBox', false);
        optFormat.atPut('cmdAsIs', true);
        optFormat.atPut('cmdAwaken', false);
    }

    obj = anObject.getEntries();

    str = '';
    len = obj.getSize();

    for (i = 0; i < len; i++) {
        str += '<span class="Date" data-name="timestamp">' +
                    obj[i][TP.boot.LOG_ENTRY_DATE] +
                '</span>' +
                '<span class="String" data-name="log-name">' +
                    obj[i][TP.boot.LOG_ENTRY_NAME] +
                '</span>' +
                '<span class="Number" data-name="log-level">' +
                    obj[i][TP.boot.LOG_ENTRY_LEVEL] +
                '</span>' +
                '<span class="String" data-name="log-entry">' +
                    obj[i][TP.boot.LOG_ENTRY_PAYLOAD] +
                '</span>' +
                '<span class="String" data-name="log-delta">' +
                    obj[i][TP.boot.LOG_ENTRY_DELTA] +
                '</span>';
    }

    return '<span class="tsh_pp">' +
            str +
            '</span>';
});

//  ------------------------------------------------------------------------

TP.tsh.pp.Type.defineMethod('fromTP_core_JSONContent',
function(anObject, optFormat) {

    return '<span class="tsh_pp">' +
        anObject.asString().asEscapedXML() +
    '</span>';
});

//  ------------------------------------------------------------------------

TP.tsh.pp.Type.defineMethod('fromTP_uri_URI',
function(anObject, optFormat) {

    return this.fromObject(anObject);
});

//  ------------------------------------------------------------------------

TP.tsh.pp.Type.defineMethod('fromTP_core_Hash',
function(anObject, optFormat) {

    var output,
        keys,
        key,
        len,
        i;

    //  If this flag is set to true, that means that we're already trying to
    //  format this object as part of larger object set and we may have an
    //  endless recursion problem if there are circular references and we
    //  let this formatting operation proceed. Therefore, we just return the
    //  'recursion' format of the object.
    if (anObject.$$format_tsh_pp) {
        return TP.recursion(anObject);
    }

    //  Set the recursion flag so that we don't endless recurse when
    //  producing circular representations of this object and its members.
    anObject.$$format_tsh_pp = true;

    //  Don't need to box output from our own markup generator, and we want the
    //  markup here to actually render, but not awake.
    if (TP.isValid(optFormat)) {
        optFormat.atPut('cmdBox', false);
        optFormat.atPut('cmdAsIs', true);
        optFormat.atPut('cmdAwaken', false);
    }

    output = TP.ac();

    output.push('<span class="tsh_pp"><span class="TP_core_Hash">');

    keys = TP.keys(anObject);
    keys.sort();
    keys.compact();
    len = keys.getSize();

    for (i = 0; i < len; i++) {
        key = keys.at(i);

        output.push('<span data-name="' + key + '">' +
            TP.boot.$stringify(anObject.at(keys.at(i)), '\n', true) +
                    '</span>');
    }

    output.push('</span></span>');

    //  We're done - we can remove the recursion flag.
    delete anObject.$$format_tsh_pp;

    return output.join('\n');
});

//  ------------------------------------------------------------------------

TP.tsh.pp.Type.defineMethod('fromTP_dom_Node',
function(anObject, optFormat) {

    //  Don't need to box output from our own markup generator.
    if (TP.isValid(optFormat)) {
        optFormat.atPut('cmdBox', false);
        optFormat.atPut('cmdAsIs', true);
        optFormat.atPut('cmdAwaken', false);
    }

    return '<span class="tsh_pp">' +
            TP.str(anObject.getNativeNode()).asEscapedXML() +
            '</span>';
});

//  ------------------------------------------------------------------------

TP.tsh.pp.Type.defineMethod('fromTP_sig_ShellRequest',
function(anObject, optFormat) {

    var data;

    if (TP.isValid(optFormat)) {
        optFormat.atPut('cmdBox', false);
        optFormat.atPut('cmdAsIs', true);
        optFormat.atPut('cmdAwaken', false);
    }

    //  Requests that are not yet processed should format their command.
    if (anObject.isCompleted()) {
        data = anObject.getResult();
    } else {
        data = anObject.at('cmd');
    }

    return '<span class="tsh_pp">' + data + '</span>';
});

//  ------------------------------------------------------------------------

TP.tsh.pp.Type.defineMethod('fromTP_core_Window',
function(anObject, optFormat) {

    var nativeWin,

        arr,
        keys,
        len,
        i;

    //  Don't need to box output from our own markup generator, and we want the
    //  markup here to actually render, but not awake.
    if (TP.isValid(optFormat)) {
        optFormat.atPut('cmdBox', false);
        optFormat.atPut('cmdAsIs', true);
        optFormat.atPut('cmdAwaken', false);
    }

    nativeWin = anObject.getNativeWindow();

    arr = TP.ac();

    keys = TP.sys.$windowkeys;
    len = keys.length;

    arr.push('<span class="TP_core_Window ' +
                TP.escapeTypeName(TP.tname(nativeWin)) + '">' +
                '<span class="Window" gid="' + TP.gid(nativeWin) + '">');

    for (i = 0; i < len; i++) {
        if (keys[i] === 'document') {
            arr.push('<span data-name="' + keys[i] + '">' +
                TP.str(nativeWin.document).asEscapedXML() + '</span>');
            continue;
        }

        try {
            arr.push('<span data-name="' + keys[i] + '">' +
                TP.xhtmlstr(nativeWin[keys[i]]) + '</span>');
        } catch (e) {
            arr.push('<span data-name="' + keys[i] + '">' +
                'undefined' + '</span>');
        }
    }

    arr.push('</span></span>');

    return '<span class="tsh_pp">' + arr.join('\n') + '</span>';
});

//  ------------------------------------------------------------------------

//  Since this is supplied on TP.lang.RootObject, we need to 'rewire' it here
TP.tsh.pp.Type.defineMethod('fromTP_sig_Signal', TP.tsh.pp.fromObject);

//  ------------------------------------------------------------------------

TP.tsh.pp.Type.defineMethod('fromWindow',
function(anObject, optFormat) {

    var arr,
        keys,
        len,
        i;

    //  Don't need to box output from our own markup generator, and we want the
    //  markup here to actually render, but not awake.
    if (TP.isValid(optFormat)) {
        optFormat.atPut('cmdBox', false);
        optFormat.atPut('cmdAsIs', true);
        optFormat.atPut('cmdAwaken', false);
    }

    arr = TP.ac();

    keys = TP.sys.$windowkeys;
    len = keys.length;

    arr.push('<span class="Window" gid="' + TP.gid(anObject) + '">');

    for (i = 0; i < len; i++) {
        if (keys[i] === 'document') {
            arr.push('<span data-name="' + keys[i] + '">' +
                TP.str(anObject.document).asEscapedXML() + '</span>');
            continue;
        }

        try {
            arr.push('<span data-name="' + keys[i] + '">' +
                TP.xhtmlstr(anObject[keys[i]]) + '</span>');
        } catch (e) {
            arr.push('<span data-name="' + keys[i] + '">' +
                'undefined' + '</span>');
        }
    }

    arr.push('</span>');

    return '<span class="tsh_pp">' + arr.join('\n') + '</span>';
});

//  ========================================================================
//  Objects with no as() (invalid, Error, etc) attempt this.transform()
//  ========================================================================

TP.tsh.pp.Type.defineMethod('transformError',
function(anObject, optFormat) {

    /**
     * Format error objects for output. We output stack information if the
     * system is configured for it and we can access it from the Error.
     * @param {Error} anObject The error object to format.
     * @param {Object} optFormat
     */

    return this.fromError(anObject);
});

//  ------------------------------------------------------------------------

TP.tsh.pp.Type.defineMethod('transformObject',
function(anObject, optFormat) {

    var methodName;

    //  Don't need to box output from our own markup generator, and we want the
    //  markup here to actually render, but not awake.
    if (TP.isValid(optFormat)) {
        optFormat.atPut('cmdBox', false);
        optFormat.atPut('cmdAsIs', true);
        optFormat.atPut('cmdAwaken', false);
    }

    //  Sometimes, we're invoked because we were handed an Object that lives in
    //  a Window that wasn't instrumented with TIBET. We try to redispatch
    //  against a matching from*() method on ourself that would do the job.

    if (TP.notValid(anObject)) {
        // 'null' or 'undefined', as you'd expect.
        return '<span class="tsh_pp">' + anObject + '</span>';
    }

    if (TP.isValid(anObject)) {
        if (TP.notEmpty(methodName =
                        this.getBestMethodName(arguments, anObject, 'from'))) {
            return this[methodName].apply(this, arguments);
        }
    }

    return this.fromObject(anObject);
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.script.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/* eslint-disable no-labels, no-loop-func */

/**
 * @type {TP.tsh.script}
 * @summary Provides support for the TIBET Shell (TSH) during raw content
 *     processing and execution. This tag is typically wrapped around raw
 *     content entered in a TIBET console to provide an XML context for it.
 *     During tag processing this tag handles XML desugaring as well as
 *     splitting of command lines for pipes and redirects. At execution time
 *     this tag handles the processing of individual tsh:eval tags and manages
 *     the overall execution loop.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:script');

TP.tsh.script.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  A list of operators specific to tranform-time TSH processing. In
//  particular these are the operators which define pipe and redirection
//  syntax in TSH scripts. These are used to help parse individual tags from
//  the sugared command input.
TP.tsh.script.Type.defineAttribute('$tshOperators');

//  A list of both TSH and JS operators
TP.tsh.script.Type.defineAttribute('$tshAndJSOperators');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.script.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    this.set(
        '$tshOperators',
        TP.ac(
            '.|', '.&', '.|&',          //  pipe w/wo stderr
            '.|*', '.&*', '.|&*',       //  pipe w/wo stderr (iterate/splat)
            '.|?', '.&?', '.|&?',       //  pipe w/wo stderr
                                        //  (filter follows)
            '.|?*', '.&?*', '.|&?*',    //  pipe w/wo stderr
                                        //  (splatted filter)
            '.|%', '.&%', '.|&%',       //  pipe w/wo stderr
                                        //  (format follows)
            '.|%*', '.&%*', '.|&%*',    //  pipe w/wo stderr
                                        //  (splatted format)

            '.*',                       //  shorthands (iterate)
            '.?', '.?*',                //  shorthands (filter)
            '.%', '.%*',                //  shorthands (format)

            '.||', '.&&',               //  conditional pipes

            '.>', '.&>', '.>&',         //  output w/wo stderr
            '.>!', '.&>!', '.>&!',      //  output w/wo stderr (save)
            '.>>', '.&>>', '.>>&',      //  output and append w/wo stderr
            '.>>!', '.&>>!', '.>>&!',   //  output and append w/wo stderr
                                        //  (save)

            '.<',                       //  input redirection
            '.<!',                      //  input redirection with refresh
                                        //  true

            '.<<',                      //  'here document'

            '.;',                       //  pipe segment terminator

            '.((', '.))',               //  nested tsh:script with own
                                        //  request
            '.{{', '.}}',               //  nested tsh:script with shared
                                        //  request
            '.[[', '.]]',               //  CDATA content sugar

            '<?', '?>',                 //  XML processing instruction
            '<![', ']]>',               //  XML CDATA open and close
            '</', '/>'                  //  XML tag close operators
            ));

    this.set('$tshAndJSOperators',
               TP.boot.$operators.concat(this.$tshOperators));

    //  A regular expression which can be used as either a test or splitting
    //  function for simple pipe constructions.
    TP.regex.TSH_PIPE = TP.rc(
        TP.tsh.script.$tshOperators.map(
            function(item) {
                return TP.regExpEscape(item);
            }).join('|')
        );

    return;
});

//  ------------------------------------------------------------------------

TP.tsh.script.Type.defineMethod('$adjustPipeSymbols',
function(aNode, aCommandList, aRequest) {

    /**
     * @method $adjustPipeSymbols
     * @summary Migrates pipe symbols from the leading element to the trailing
     *     element so that the currently executing request can see what the
     *     input pipe may have been.
     * @param {Node} aNode A native node containing one or more executable child
     *     elements.
     * @param {TP.sig.Request[]} aCommandList The run requests for this script.
     * @param {TP.sig.ShellRequest} aRequest The request containing command
     *     input for the shell.
     */

    var children,
        child,
        previous,
        peer,
        pipe,
        last,
        ins;

    //  the parse phase assigns pipes to the leading element, but we really
    //  want them assigned to the element which has to work with that as a
    //  form of instruction for input/output processing, so we move them.
    children = TP.nodeGetChildElements(aNode);
    if (children.length > 1) {
        child = children.last();
        previous = children.before(child);
        while (previous) {
            if (TP.elementHasAttribute(previous, 'tsh:pipe', true)) {
                TP.elementSetAttribute(
                    child,
                    'tsh:pipe',
                    TP.elementGetAttribute(previous, 'tsh:pipe', true),
                    true);

                TP.elementRemoveAttribute(previous, 'tsh:pipe', true);
            }

            child = previous;
            previous = children.before(child);
        }
    }

    //  the first child element may also receive a pipe symbol if the
    //  overall request contained a cmdPeer reference implying a larger
    //  pipe scope (often found with alias/history translation etc.)
    if (TP.isValid(peer = aRequest.at('cmdPeer'))) {
        pipe = TP.elementGetAttribute(peer.at('cmdNode'), 'tsh:pipe', true);
        if (TP.notEmpty(pipe)) {
            TP.elementSetAttribute(children[0], 'tsh:pipe', pipe, true);
        } else if (TP.notEmpty(ins = peer.get('ins'))) {
            pipe = TP.elementGetAttribute(ins.at(0).at('cmdNode'),
                                            'tsh:pipe',
                                            true);
            TP.elementSetAttribute(children[0], 'tsh:pipe', pipe, true);
        }

        if (TP.notEmpty(pipe)) {
            //  a secondary concern here is that if we're patching the pipe
            //  context from the peer we also need to patch the last command
            //  since that's where the stdio buffers will be found.
            last = peer.at('cmdLast');
            if (TP.isValid(last)) {
                aCommandList.at(0).atPut('cmdLast', last);
            } else {
                aCommandList.at(0).atPut('cmdPeer', peer);
            }
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.tsh.script.Type.defineMethod('$connectPipeSections',
function(commands, aRequest) {

    /**
     * @method $connectPipeSections
     * @summary Joins the various requests involved in processing the pipe so
     *     that the proper workflow semantics are observed.
     * @param {TP.sig.Request[]} commands An array of arrays of requests which
     *     make up the individual sections of command pipeline.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     */

    var i,
        j,
        k,
        len,
        len2,
        len3,

        command,
        last,
        prereqs,
        stdin,

        ins,
        outs,

        node,
        cond,
        state;

    if (!TP.isArray(commands)) {
        this.raise('TP.sig.InvalidParameter',
            'Sequence must be an Array.');
        return;
    }

    len = commands.getSize();
    for (i = 0; i < len; i++) {
        command = commands.at(i);
        state = null;

        //  for the first command in the sequence if we have a request with
        //  pre-supplied STDIN we populate it as if it were part of a larger
        //  pipe. This is used largely when binding to script elements or
        //  when connecting subshell input.
        if (i === 0) {
            if (TP.isValid(stdin = aRequest.at(TP.STDIN))) {
                //  note that stdin is supposed to be an array of one or
                //  more inputs including redirections.
                if (!TP.isArray(stdin)) {
                    command.atPut(TP.STDIN, TP.ac(stdin));
                } else {
                    command.atPut(TP.STDIN, stdin);
                }
            }
        }

        //  one complication is conditional operations. when a pipe uses a
        //  .|| conditional we want to set that command and its associated
        //  ins (if any) to observe TP.FAILED, not TP.SUCCEEDED for the
        //  prior command.
        node = command.at('cmdNode');
        if (TP.notEmpty(cond = TP.elementGetAttribute(node,
                                                        'tsh:cond',
                                                        true))) {
            if (cond === '.||') {
                state = TP.FAILED;
            }
        }

        //  NOTE we have to be careful here because a negative index can
        //  result in wrapping back on ourselves.
        /* eslint-disable no-extra-parens */
        last = (i > 0) ? commands.at(i - 1) : null;
        /* eslint-enable no-extra-parens */

        prereqs = TP.isValid(last) ? last.get('outs') : null;

        //  commands have to wait for all their inputs to complete...and
        //  their inputs have to wait on the previous command/outputs
        ins = command.get('ins');
        if (TP.notEmpty(ins)) {
            len2 = ins.getSize();
            for (j = 0; j < len2; j++) {
                command.andJoin(ins.at(j));

                if (TP.notEmpty(prereqs)) {
                    len3 = prereqs.getSize();
                    for (k = 0; k < len3; k++) {
                        ins.at(j).andJoin(prereqs.at(k), state);
                    }
                } else if (TP.isValid(last)) {
                    last.joinTo(ins.at(j), state);
                }
            }
        } else {
            //  no command inputs, so the command itself has to wait for the
            //  prior command/outputs to complete
            if (TP.notEmpty(prereqs)) {
                len3 = prereqs.getSize();
                for (k = 0; k < len3; k++) {
                    command.andJoin(prereqs.at(k), state);
                }
            } else if (TP.isValid(last)) {
                last.joinTo(command, state);
            }
        }

        //  command outputs just wait for the command itself.
        outs = command.get('outs');
        if (TP.notEmpty(outs)) {
            len2 = outs.getSize();
            for (j = 0; j < len2; j++) {
                command.joinTo(outs.at(j));
            }
        }
    }

    return;
});

//  ------------------------------------------------------------------------

TP.tsh.script.Type.defineMethod('cmdAddContent',
function(aRequest) {

    /**
     * @method cmdAddContent
     * @summary Invoked by the TSH when the receiver is the data sink for a
     *     command sequence which is piping data to the receiver using an
     *     appending operation such as .>>.
     * @description On this type, this method merely invokes 'tshExecute'
     *     against the receiver.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     * @returns {Object} A value which controls how the outer TSH processing
     *     loop should continue.
     */

    return this.tshExecute(aRequest);
});

//  ------------------------------------------------------------------------

TP.tsh.script.Type.defineMethod('cmdFilterInput',
function(aRequest) {

    /**
     * @method cmdFilterInput
     * @summary Invoked by the TSH when the receiver is a segment in a pipe
     *     where the implied operation is to filter standard input using a
     *     filter operation such as .|?.
     * @description On this type, this method merely invokes 'tshExecute'
     *     against the receiver.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     * @returns {Object} A value which controls how the outer TSH processing
     *     loop should continue.
     */

    return this.tshExecute(aRequest);
});

//  ------------------------------------------------------------------------

TP.tsh.script.Type.defineMethod('cmdGetContent',
function(aRequest) {

    /**
     * @method cmdGetContent
     * @summary Invoked by the TSH when the receiver is the data source for a
     *     command sequence which is piping data from the receiver.
     * @description On this type, this method merely invokes 'tshExecute'
     *     against the receiver.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     * @returns {Object} A value which controls how the outer TSH processing
     *     loop should continue.
     */

    return this.tshExecute(aRequest);
});

//  ------------------------------------------------------------------------

TP.tsh.script.Type.defineMethod('cmdRunContent',
function(aRequest) {

    /**
     * @method cmdRunContent
     * @summary Runs the receiver, effectively invoking its action.
     * @description This method is invoked any time a tag is being run as part
     *     of the processing of an enclosing tsh:script, which happens most
     *     often when the tag is being run interactively. The default defers to
     *     the tshExecute method of their type. On this type, this method merely
     *     invokes 'tshExecute' against the receiver.
     * @param {TP.sig.ShellRequest} aRequest The request containing command
     *     input for the shell.
     * @returns {Object} A value which controls how the outer TSH processing
     *     loop should continue. TP.CONTINUE and TP.BREAK are common values.
     */

    return this.tshExecute(aRequest);
});

//  ------------------------------------------------------------------------

TP.tsh.script.Type.defineMethod('cmdSetContent',
function(aRequest) {

    /**
     * @method cmdSetContent
     * @summary Invoked by the TSH when the receiver is the data sink for a
     *     command sequence which is piping data to the receiver using a simple
     *     set operation such as .>
     * @description On this type, this method merely invokes 'tshExecute'
     *     against the receiver.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     * @returns {Object} A value which controls how the outer TSH processing
     *     loop should continue.
     */

    return this.tshExecute(aRequest);
});

//  ------------------------------------------------------------------------

TP.tsh.script.Type.defineMethod('cmdTransformInput',
function(aRequest) {

    /**
     * @method cmdTransformInput
     * @summary Invoked by the TSH when the receiver is a segment in a pipe
     *     where the implied operation is to transform standard input using a
     *     simple transform operation such as .|
     * @description On this type, this method merely invokes 'tshExecute'
     *     against the receiver.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     * @returns {Object} A value which controls how the outer TSH processing
     *     loop should continue.
     */

    return this.tshExecute(aRequest);
});

//  ------------------------------------------------------------------------

TP.tsh.script.Type.defineMethod('$desugarXML',
function(source, shell, sibling, request) {

    /**
     * @method $desugarXML
     * @summary Converts TSH syntax sugaring, particularly XML sugaring, into
     *     its verbose equivalent so the returned string can be turned in to
     *     valid XML nodes.
     * @description The primary purpose of this method is to convert sugared TSH
     *     input into a viable XML string. This means finding any TSH pipe or
     *     redirection operators as well as any other sugared tag syntax. TSH
     *     sugaring is intended to eliminate the need for entering brackets or
     *     extraneous information to identify tag attribute values. That means
     *     things like :clear ultimately become <tsh:clear/>, while input such
     *     as :import href=~code.js become <tsh:import href="~code.js"/>.
     *
     *     Pipes define command line "partitions" which are relevant for history
     *     and aliasing since those can focus on "start of command" in their
     *     processing. NOTE that during command execution when history/alias
     *     expansion is being performed each expanded command is repartitioned
     *     as needed, but those partitions don't create individual history
     *     entries.
     *
     *     Specific pipe syntax processed by this command includes:
     *
     *     a .| b (pipe stdout)
     *     a .& b (pipe stderr)
     *     a .|& b (pipe stdout and stderr)
     *
     *     a .|| b (conditional pipe [if lvalue fails])
     *     a .&& b (conditional pipe [if lvalue succeeds])
     *
     *     For the non-conditional pipe operators you can add a trailing *
     *     (splat) operation to tell the pipe that you want to iterate across a
     *     collection rather than pass the collection as the input value. An
     *     example might be:
     *
     *     a.* b (pipe stdout and iterate over it)
     *     a.|* b (pipe stdout and iterate over it)
     *
     *     In addition to the splatting syntax which drives iteration by those
     *     commands/tags which support it there is a sugar for "query" which
     *     allows strings/selectors to be placed inline in the pipe for use as
     *     extended conditionals. When using this syntax place the ? directly
     *     after the standard pipe symbol and before any trailing * (splat)
     *     operator:
     *
     *     a .? b (pipe stdout and query it via b)
     *     a .|? b (pipe stdout and query it via b)
     *     a .|?* b (pipe stdout and query each item via b)
     *
     *     Redirects define values for stdin, stdout, and/or stderr relative to
     *     a command. As such they define simple pipes where there is an implied
     *     command setting/getting content on a specified object (usually via a
     *     URI). The object side of the redirect does not have history or alias
     *     expansion, it is mapped to a parameter which can subsequently undergo
     *     variable, uri, and substitution processing at runtime.
     *
     *     a .< b (redirect stdin w/getContent)
     *     a .<! b (redirect stdin w/getContent and refresh true)
     *
     *     a .<< (here document...read block as input)
     *
     *     a .> b (redirect stdout w/setContent)
     *     a .&> b (redirect stderr w/setContent)
     *     a .>& b (redirect stdout and stderr w/setContent)
     *
     *     a .>> b (redirect stdout w/addContent)
     *     a .&>> b (redirect stderr w/addContent)
     *     a .>>& b (redirect stdout and stderr w/addContent)
     *
     *     For redirects you can also add a trailing ! (commit) symbol which
     *     tells TIBET that you want the data to be flushed from the local
     *     in-browser cache to the file system or remote server. In other cases
     *     the data simply updates the TP.uri.URI content but doesn't send it
     *     to the server. For example:
     *
     *     a .>! b (redirect stdout and 'commit')
     *
     *     Tag (action) input lines (foo:bar, :bar, etc) are updated to their
     *     XML equivalents, removing simple sugaring for XML.
     *
     *     :clear <tsh:clear/>
     *
     *     //   attribute parameters (named parameters)
     *     :source ref=blah <tsh:source ref="blah"/>
     *
     *     //   'switch' parameters
     *     :lint -full <tsh:lint full="true"/>
     *
     *     //   'identity' parameters
     *     html:checkbox --checked <html:checkbox checked="checked"/>
     *
     *     //   positional parameters
     *     :lint a b c <tsh:lint argv="a b c"/>
     *
     *     All other lines (without pipe, redirect, or other split or tag
     *     sugaring) are wrapped as simple command tags with text contained in
     *     CDATA blocks.
     *
     *     1+2 (simple command) <tsh:eval><![CDATA[1+2]]></tsh:eval>
     *
     *     Multiple commands and input can be mixed using semicolons as
     *     statement terminators. Pipe and redirect symbols also act as
     *     statement terminators. When processing content in this fashion block
     *     constructs in JavaScript are treated as a single command tag to avoid
     *     potential syntax errors from splitting a block-level construct such
     *     as a function.
     *
     *     NOTE that these are all "tranform time" conversions. See
     *     the TP.tsh.eval type for processing specific to "runtime" processing
     *     of shell input.
     * @param {String|String[]} source The input source to translate.
     * @param {TP.shell.Shell} shell The shell instance handling the request
     *     we're processing text for.
     * @param {TP.dom.Node} sibling The previous sibling, which may contain
     *     pipe information.
     * @param {TP.sig.Request} request The request being desugared.
     * @returns {String} The translated/desugared script source.
     */

    var requote,

        arr,

        command,
        result,
        args,
        chunk,
        mode,
        tagname,
        builtin,

        i,
        j,
        token,
        prefix,
        closer,
        close,

        count,
        offset,

        arg,

        last,
        next,
        more,
        block,

        cmdns;

    //  ---
    //  helper functions
    //  ---

    //  Turn the incoming string into a value that will work as an XML
    //  attribute. We rely on double quotes as our outer quoting value
    //  so process accordingly.
    requote = function(tokenValue) {
        var value;

        //  Goal here is to always use double quotes and to preserve any form of
        //  quoting that was already in existence. By preserving we ensure the
        //  "original value" used by the shell's argument parser knows which
        //  type of quote (or if there were even quotes) were used for a value.
        value = tokenValue;
        value = TP.xmlLiteralsToEntities(value);
        //  Since literals include quot; and apos; we can just bracket in
        //  quotes.
        value = '"' + value + '"';

        return value;
    };

    //  if we're provided with an array assume its a set of tokens to
    //  process and do that, otherwise condense the source without removing
    //  newlines or spaces (so we preserve as much semantic data as
    //  possible). We also want to configure to process TSH-specific
    //  operators and to receive a token array back rather than a string
    //  we'd have to just tokenize again.
    arr = TP.isArray(source) ?
                source :
                TP.$condenseJS(
                        source, false, false,
                        //  All of the JS operators *and* the TSH operators
                        TP.tsh.script.$tshAndJSOperators,
                        true, true, true);

    cmdns = 'tsh';

    command = [];
    result = [];
    args = [];
    chunk = [];

    i = 0;
    token = arr[i];

    //  respect overall escape syntax, which is a leading =. in that case we
    //  strip off the first token and return the rest in a standard tsh:eval
    //  tag for source/script evaluation as a chunk.
    if (token && token.value === '=') {
        //  a leading = doesn't affect further parsing, but it does signify
        //  that the literal flag should be observed for the entire request
        if (TP.isValid(request)) {
            request.atPut('cmdLiteral', true);
        }

        i += 1;
        token = arr[i];
    } else if (token && token.value === ';') {
        //  a leading ; doesn't affect other parsing, but it does cause the
        //  rest of the command buffer to be flagged as producing no console
        //  output (although errors always produce console output).
        if (TP.isValid(request)) {
            request.atPut('cmdSilent', true);
        }

        i += 1;
        token = arr[i];
    }

    while (token) {
        switch (mode) {
            case 'tag':

                //  tag mode starts when we see a new statement starting
                //  with an optional prefix followed by a colon and optional
                //  tag name. once we've seen that sequence we read until we
                //  find the end of the tag by locating a terminator token.

                i += 1;
                for (;;) {
                    token = arr[i];
                    if (!token) {
                        break;
                    }

                    //  most terminators end a tag...the one exception we
                    //  parse for is the "CDATA operator" which forces what
                    //  follows to be tag content rather than a new segment.
                    if (TP.$is_terminator(token.value) &&
                        token.value !== '.[[') {
                        //  when the terminator is a TSH pipe/redirect we
                        //  put that information on the tag so it can
                        //  process correctly when executing.
                        switch (token.value) {
                            case ';':
                                //  semicolon, nothing more to do
                                break;
                            default:
                                command.splice(1, 0, ' tsh:pipe="',
                                    TP.xmlLiteralsToEntities(token.value),
                                    '"');
                                break;
                        }

                        //  increment token and break so we close this iteration
                        i += 1;
                        token = arr[i];

                        break;
                    } else if (token.name === 'operator') {
                        //  if we're reading portions of a tag there are,
                        //  strictly speaking, only a few viable operators
                        //  we should see: = for attributes and - for flags.
                        if (token.value === '=') {
                            //  previous token must be a valid identifier
                            //  that could be an attribute name
                            last = arr[i - 1];
                            /* eslint-disable no-extra-parens */
                            if (!last ||
                                (last.name !== 'identifier' &&
                                 last.name !== 'reserved')) {
                                TP.ifWarn() ?
                                    TP.warn('Missing attribute name in' +
                                        ' tag input: ' + token.value) : 0;

                                i += 1;
                                token = arr[i];

                                continue;
                            }
                            /* eslint-enable no-extra-parens */

                            //  if the next token is a "string" then the
                            //  attribute value is already quoted, otherwise
                            //  we want to quote the next sequence of tokens
                            //  up through a new flag or attribute name (the
                            //  next token directly in front of an =).
                            next = arr[i + 1];
                            if (next && next.name !== 'string') {
                                command.push(token.value, '"');

                                chunk.length = 0;

                                //  push all contiguous tokens which don't
                                //  break whitespace or parse as terminators
                                //  into the attribute value
                                i += 1;
                                token = arr[i];

                                while (token &&
                                    !TP.$is_whitespace(token.name) &&
                                    !TP.$is_terminator(token.value)) {
                                    chunk.push(token.value);
                                    i += 1;
                                    token = arr[i];
                                }

                                command.push(chunk.join(''), '"');
                            } else {
                                //  push the = and string value as found,
                                //  requoting the token string so it uses
                                //  double quotes
                                command.push(token.value,
                                                requote(next.value));
                                i += 2;
                                token = arr[i];
                            }
                        } else if (token.value === '--' ||
                                    token.value === '-') {
                            //  flag of some kind. flags are effectively
                            //  just attributes but they're special in terms
                            //  of prefixing and how the shell allocates
                            //  them prior to request execution.
                            next = arr[i + 1];

                            if (next &&
                                (next.name === 'identifier' ||
                                 next.name === 'reserved')) {
                                more = arr[i + 2];

                                if (more && more.value === '=') {
                                    //  appears to be a valued flag, perhaps
                                    //  --as=Array etc so capture value. we
                                    //  can do that by consuming up to the =
                                    //  and then continuing so the = token
                                    //  process captures things.
                                    command.push(' tsh:', next.value);
                                    i += 2;
                                    token = more;

                                    continue;
                                } else {
                                    //  Check name for 'no-' prefix. If found
                                    //  then we'll be inverting the value and
                                    //  adjusting the name we push.
                                    if (/^no-/.test(next.value)) {
                                        command.push(' tsh:',
                                            next.value.slice(3), '="');
                                        command.push('false');
                                    } else {
                                        command.push(' tsh:', next.value, '="');
                                        command.push('true');
                                    }
                                    command.push('"');

                                    i += 2;
                                    token = arr[i];
                                }
                            } else {
                                if (next && token.value === '-') {
                                    args.push(token.value + next.value);
                                    i += 2;
                                } else {
                                    //  - or -- without following identifier?
                                    //  that's a syntax error
                                    TP.ifWarn() ?
                                        TP.warn('Missing flag name in tag' +
                                            ' input: ' + source + '.') : 0;
                                    break;
                                }
                            }
                        } else if (token.value === '.[[') {
                            //  allow for CDATA block sugaring where we
                            //  close off the opening tag, read to the end
                            //  of the cdata, then close the tag.

                            //  close off the tag
                            if (args.length > 0) {
                                command.push(' tsh:argv="');

                                arg = TP.xmlLiteralsToEntities(
                                                    args.join(' ').trim());
                                if (args.length > 1) {
                                    arg = arg.unquoted();
                                }

                                command.push(arg);
                                command.push('"');
                                args.length = 0;
                            }

                            command.push('>');

                            //  push CDATA opening into the command,
                            command.push('<![CDATA[');

                            //  capture cdata content, closing off the tag
                            //  when we reach the final brackets.
                            i += 1;
                            for (;;) {
                                token = arr[i];

                                if (!token) {
                                    TP.ifWarn() ?
                                        TP.warn('Unexpected end of CDATA' +
                                            ' input.') : 0;

                                    break;
                                }

                                if (token.value === '.]]') {
                                    //  close off the CDATA and tag
                                    command.push(']]>');
                                    command.push('</', tagname, '>');
                                    break;
                                }

                                command.push(token.value);
                                i += 1;
                            }

                            closer = '';
                            i += 1;
                            token = arr[i];

                        } else if (token.value === '{') {

                            chunk.length = 0;
                            chunk.push(token.value);

                            //  Process everything up through the closing brace.
                            i += 1;
                            token = arr[i];
                            while (token && token.value !== '}') {

                                if (token.value === '[' || token.value === '{') {
                                    //  capture tokens that comprise nested
                                    //  structure by keeping count until we find
                                    //  the true closing token.
                                    close = token.value === '[' ? ']' : '}';
                                    count = 1;
                                    offset = 0;
                                    while (count !== 0 && arr[i + offset]) {
                                        if (arr[i + offset].value === token.value) {
                                            count++;
                                        } else if (arr[i + offset].value === close) {
                                            count--;
                                        }
                                        offset++;
                                    }

                                    //  If not closed and no arr[i + offset] we
                                    //  ran off the end looking for closer.
                                    if (count !== 0 && !arr[i + offset]) {
                                        //  TODO:   warn/error?
                                        void 0;
                                    }

                                    //  Push count of nested tokens into place.
                                    for (j = 0; j < offset; j++) {
                                        chunk.push(token.value);
                                        i += 1;
                                        token = arr[i];
                                    }

                                    i += 1;
                                    token = arr[i];

                                } else {
                                    chunk.push(token.value);
                                    i += 1;
                                    token = arr[i];
                                }
                            }

                            //  Depending on internal loop we may still need to
                            //  push the closing token.
                            if (token && token.value === '}') {
                                chunk.push(token.value);
                            }

                            args.push(chunk.join(''));

                            i += 1;
                            token = arr[i];

                        } else if (token.value === '[') {

                            chunk.length = 0;
                            chunk.push(token.value);

                            //  Process everything up through the closing brace.
                            i += 1;
                            token = arr[i];
                            while (token && token.value !== ']') {

                                if (token.value === '[' || token.value === '{') {
                                    //  capture tokens that comprise nested
                                    //  structure by keeping count until we find
                                    //  the true closing token.
                                    close = token.value === '[' ? ']' : '}';
                                    count = 1;
                                    offset = 0;
                                    while (count !== 0 && arr[i + offset]) {
                                        if (arr[i + offset].value === token.value) {
                                            count++;
                                        } else if (arr[i + offset].value === close) {
                                            count--;
                                        }
                                        offset++;
                                    }

                                    //  If not closed and no arr[i + offset] we
                                    //  ran off the end looking for closer.
                                    if (count !== 0 && !arr[i + offset]) {
                                        //  TODO:   warn/error?
                                        void 0;
                                    }

                                    //  Push count of nested tokens into place.
                                    for (j = 0; j < offset; j++) {
                                        chunk.push(token.value);
                                        i += 1;
                                        token = arr[i];
                                    }

                                    i += 1;
                                    token = arr[i];

                                } else {
                                    chunk.push(token.value);
                                    i += 1;
                                    token = arr[i];
                                }
                            }

                            //  Depending on internal loop we may still need to
                            //  push the closing token.
                            if (token && token.value === ']') {
                                chunk.push(token.value);
                            }

                            args.push(chunk.join(''));

                            i += 1;
                            token = arr[i];

                        } else {
                            //  probably going to result in a syntax error
                            //  unless it happens to be a tag closing pair
                            //  or an unattributed URI prefix
                            if (!/^(~|\.|\/|{|%)/.test(token.value)) {
                                TP.ifWarn() ?
                                    TP.warn('Unexpected operator in tag' +
                                        ' input: ' + token.value) : 0;
                            }

                            chunk.length = 0;
                            chunk.push(token.value);

                            //  push all contiguous tokens which don't break
                            //  whitespace or parse as terminators into the
                            //  arg list
                            i += 1;
                            token = arr[i];
                            while (token &&
                                    !TP.$is_whitespace(token.name) &&
                                    !TP.$is_terminator(token.value)) {
                                chunk.push(token.value);

                                i += 1;
                                token = arr[i];
                            }

                            args.push(chunk.join(''));

                            i += 1;
                            token = arr[i];
                        }
                    } else if (TP.$is_identifier(token.name) &&
                                TP.isValid(arr[i + 1]) &&
                                arr[i + 1].value === ':') {
                        //  namespace-qualified attribute. for sugaring
                        //  reasons we allow the attribute to be simply
                        //  named (for css existence testing) in which case
                        //  we simply set the value to true, or we allow the
                        //  full expression with =.
                        command.push(token.value, ':');

                        i += 2;
                        token = arr[i];
                        if (token && TP.$is_identifier(token.name)) {
                            command.push(token.value);
                        } else {
                            //  should have seen an identifier next. if not
                            //  then we've got a bit of a problem.
                            TP.ifWarn() ?
                                TP.warn('Unexpected end of prefixed' +
                                    ' attribute.') : 0;

                            break;
                        }

                        //  once we've processed the attribute name we've
                        //  got two choices...either the next token is a =
                        //  showing we've got a value assignment or not.
                        //  when it's not it should be whitespace or a
                        //  terminator so we can close off the attribute.
                        next = arr[i + 1];
                        if (!next ||
                            (TP.$is_whitespace(next.name) ||
                            TP.$is_terminator(next.value))) {
                            command.push('="true"');
                        }

                        i += 1;
                        token = arr[i];
                    } else {
                        //  "open" arguments, i.e. args with no leading - or
                        //  trailing =, are collected into a single arg list
                        //  the consuming tag can treat as the "arguments"
                        last = arr[i - 1];
                        next = arr[i + 1];
                        if (token.name !== 'space' &&
                            token.name !== 'tab' &&
                            (last && last.value !== ':') &&
                            (TP.notValid(next) || next.value !== '=')) {
                            chunk.length = 0;
                            chunk.push(token.value);

                            //  push all contiguous tokens which don't break
                            //  whitespace or parse as terminators into the
                            //  arg list
                            i += 1;
                            token = arr[i];

                            while (token &&
                                    !TP.$is_whitespace(token.name) &&
                                    !TP.$is_terminator(token.value)) {
                                chunk.push(token.value);

                                i += 1;
                                token = arr[i];
                            }

                            args.push(chunk.join(''));
                        } else {
                            //  all other tokens should be output directly
                            //  to the tag. NOTE that we could add more
                            //  logic here to try to catch syntax errors at
                            //  this point.
                            command.push(token.value);

                            i += 1;
                            token = arr[i];
                        }
                    }
                }

                //  close off the tag and reset for next tag/command
                if (args.length > 0) {
                    command.push(' tsh:argv="');

                    arg = TP.xmlLiteralsToEntities(args.join(' ').trim());
                    if (args.length > 1) {
                        arg = arg.unquoted();
                    }

                    command.push(arg);
                    command.push('"');

                    args.length = 0;
                }

                command.push(TP.ifInvalid(closer, '/>'));

                result.addAll(command);
                command.length = 0;

                //  once we've closed the current tag we need to reset the
                //  mode so the next token is treated as a starting token
                mode = null;

                break;

            case 'src':

                //  src mode starts any time we don't fall into tag mode.
                //  any tokens read while in src mode are processed as
                //  content of an enclosing tsh:eval tag which will handle
                //  evaluation of the text at execution time.

                //  src mode is tricky with respect to terminators due to
                //  blocks which may appear in the stream. we have to track
                //  block count and only respect semicolons as a terminator
                //  when the block count is zero.

                block = 0;

                i += 1;
                for (;;) {
                    token = arr[i];
                    if (!token) {
                        break;
                    }

                    //  track nesting level of any block-type construct so
                    //  we don't assume semi-colons found in the block are
                    //  true command terminators.
                    if ('{(['.indexOf(token.value) >= 0) {
                        block++;
                    } else if ('])}'.indexOf(token.value) >= 0) {
                        block--;

                        if (block < 0) {
                            //  TODO:   raise? too many closing delimiters
                            void 0;
                        }
                    }

                    if (TP.$is_terminator(token.value)) {
                        if (token.value === ';') {
                            command.push(token.value);
                            i += 1;
                            token = arr[i];

                            //  if we're at a clean terminator that isn't
                            //  nested in a block construct we terminate
                            //  this particular command tag. otherwise the
                            //  loop continues processing so that code
                            //  statements which are part of a block are all
                            //  contained in a single command tag.
                            if (block <= 0) {
                                if (TP.sys.cfg('tsh.split_commands')) {
                                    break;
                                }

                                //  other case is when the next piece of
                                //  text starts with sugared tag text
                                //  either prefix: or just :tag
                                j = 1;

                                /* eslint-disable no-extra-parens */
                                while ((next = arr[i + j])) {
                                    if (!TP.$is_whitespace(next.name)) {
                                        break;
                                    }
                                    j++;
                                }
                                /* eslint-enable no-extra-parens */

                                if (next) {
                                    if (next.value === ':') {
                                        break;
                                    } else if (TP.$is_identifier(next.name)) {
                                        more = arr[i + j + 1];
                                        if (more && more.value === ':') {
                                            break;
                                        }
                                    }
                                }
                            }
                        } else {
                            //  all other terminators are pipe/redirection
                            //  symbols which should terminate. NOTE however
                            //  that in cases of a terminator being found
                            //  within a block we have a potential error.
                            if (block > 0) {
                                //  TODO:   raise?
                                void 0;
                            }

                            //  splice the token into the pipe attribute so
                            //  we can track that at the shell level
                            command.splice(1, 0,
                                            ' tsh:pipe="',
                                            TP.xmlLiteralsToEntities(
                                                            token.value),
                                            '"');

                            i += 1;
                            token = arr[i];

                            break;
                        }
                    } else {
                        //  non-terminators are pushed into the output
                        //  stream without additional parsing in src mode
                        command.push(token.value);

                        i += 1;
                        token = arr[i];
                    }
                }

                if (block !== 0) {
                    //  if we don't find the right block count then we have
                    //  a potentially missing/unbalanced set of delimiters

                    //  TODO:   raise?
                    void 0;
                }

                //  close the overall command/src tag
                command.push(closer || ']]></tsh:eval>');

                result.addAll(command);
                command.length = 0;

                //  once we've closed the current tag we need to reset the
                //  mode so the next token is treated as a starting token
                mode = null;

                break;

            default:

                //  figure out what mode to be in based on lookahead data
                //  from the token stream. NOTE that we start in this mode
                //  as well, so the very first step in the while loop drops
                //  us here.

                //  clear any tag close data, require new tag modes to
                //  update as needed by their individual requirements
                closer = null;

                switch (token.name) {
                    case 'newline':
                    case 'space':
                    case 'tab':
                        //  whitespace doesn't affect mode
                        i += 1;
                        token = arr[i];
                        break;

                    case 'uri':
                        //  tokenized uris are just packaged into tags
                        command.push('<tsh:uri',
                            ' tsh:href="',
                            TP.xmlLiteralsToEntities(token.value),
                            '"');
                        mode = 'tag';
                        tagname = 'tsh:uri';
                        break;

                    case 'keyword':
                    case 'reserved':
                    case 'identifier':

                        //  identifiers followed immediately by : represent
                        //  either URIs, XML namespace prefixes or, when
                        //  terminated (tsh:), sugar for a "set
                        //  namespace"
                        next = arr[i + 1];

                        if (next && next.value === ':') {
                            //  have to try to determine if this is a URI or
                            //  a tag prefix
                            more = arr[i + 2];

                            if (more && more.value === '/') {
                                //  URI...http:/...file:/...etc.
                                command.push('<tsh:uri');
                                args.push(token.value);

                                i += 1;
                                token = arr[i];

                                while (token &&
                                        !TP.$is_terminator(token.value) &&
                                        !TP.$is_whitespace(token.name)) {
                                    args.push(token.value);

                                    i += 1;
                                    token = arr[i];
                                }

                                if (args.length > 0) {
                                    command.push(
                                            ' tsh:href="',
                                            TP.xmlLiteralsToEntities(
                                                prefix + args.join('')),
                                            '"');

                                    args.length = 0;
                                }

                                if (token &&
                                    (TP.$is_terminator(token.value) ||
                                    TP.$is_whitespace(token.name))) {
                                    i--;
                                }

                                mode = 'tag';
                                tagname = 'tsh:uri';
                            } else if (more && !TP.$is_whitespace(more.name)) {
                                tagname = token.value +
                                            next.value +
                                            more.value;

                                //  If the custom type isn't found verify
                                //  whether the shell may have this as a built
                                //  in. Warn if you can't find either.
                                if (TP.notValid(
                                            TP.sys.getTypeByName(tagname))) {
                                    if (TP.notValid(
                                                TP.sys.getTypeByName(tagname))) {
                                        builtin = 'execute' +
                                            ('' + more.value).asTitleCase();
                                        if (!TP.canInvoke(shell, builtin)) {
                                            TP.ifWarn() ?
                                                TP.warn('Unable to find' +
                                                    ' command ' +
                                                    tagname) : 0;
                                        }
                                    }
                                }

                                command.push('<' + tagname);
                                i += 2;
                                mode = 'tag';
                            } else {
                                //  if the line is of the form xmlns: then
                                //  this is special syntax for changing the
                                //  default xmlns for tags below this one
                                //  until we find another default xmlns.
                                cmdns = token.value;

                                request.stdout(
                                    'Changing default prefix to ' +
                                    token.value + next.value);

                                i += 2;
                                mode = null;
                            }
                        } else {
                            //  identifier but not a : following means
                            //  src mode. NOTE that we push in a potentially
                            //  curious fashion here, but the goal is to
                            //  leave a position where attributes can be
                            //  injected into the command to support pipe
                            //  and/or redirection syntax.
                            command.push('<tsh:eval', '><![CDATA[',
                                            token.value);
                            mode = 'src';
                        }

                        break;

                    case 'operator':

                        //  !!! Make sure to keep the global
                        //  TP.TSH_OPERATOR_CHARS RegExp up-to-date with
                        //  this list of tokens!!!
                        //
                        //  TSH supports a number of 'operator sugars',
                        //  particularly when the operator is a prefix. We
                        //  watch for those here because many are sugar for
                        //  a tsh tag of some type.
                        switch (token.value) {
                        //  case '`':
                        //      //  TSH command substitution, tokenized as a
                        //      //  substitution rather than a operator and
                        //      //  handled at the tsh:eval tag level.

                            /* eslint-disable no-fallthrough */

                            case '#':
                                //  Normally a URI fragment but those have to be
                                //  valid ID values or xpointers. We can
                                //  overload a bit if there's a number or regex
                                //  and use # as snippet (a variant of history).

                                next = arr[i + 1];

                                if (next && (/^\d+/.test(next.value) ||
                                        next.value === '/')) {
                                    command.push('<tsh:history');

                                    //  snippet is of the form #n or #/foo/
                                    //  collect all tokens until whitespace
                                    //  or terminator (or end of stream).
                                    i += 1;
                                    token = arr[i];
                                    while (token &&
                                        !TP.$is_terminator(token.value) &&
                                        !TP.$is_whitespace(token.name)) {
                                        args.push(token.value);
                                        i += 1;
                                        token = arr[i];
                                    }

                                    if (args.length > 0) {
                                        command.push(
                                            ' hid="',
                                            TP.xmlLiteralsToEntities(
                                                            args.join('')),
                                            '"');
                                        args.length = 0;
                                    }

                                    command.push(' edit="true"');

                                    if (token &&
                                        (TP.$is_terminator(token.value) ||
                                        TP.$is_whitespace(token.name))) {
                                        i--;
                                    }
                                    mode = 'tag';
                                    tagname = 'tsh:history';

                                    break;
                                }

                                //  Otherwise, its a TSH URI fragment /
                                //  barename. Treat as a partial URI so fall
                                //  through

                            case '~':

                                /* eslint-enable no-fallthrough */

                                //  TIBET virtual URI syntax. NOTE that
                                //  officially you could type ~23 and that
                                //  would be legal JS, but the odds of that
                                //  are slim so we require an escape \~23.
                                next = arr[i + 1];

                                /* eslint-disable no-extra-parens */
                                if (next &&
                                    (TP.$is_whitespace(next.name) ||
                                    next.value === '(' ||
                                    (!TP.$is_identifier(next.name) &&
                                    (next.value.indexOf('/') !== 0)))) {
                                    command.push('<tsh:eval',
                                        '><![CDATA[', token.value);
                                    mode = 'src';
                                    break;
                                }
                                /* eslint-enable no-extra-parens */

                                command.push('<tsh:uri');
                                prefix = token.value;

                                i += 1;
                                token = arr[i];
                                while (token &&
                                    !TP.$is_terminator(token.value) &&
                                    !TP.$is_whitespace(token.name)) {
                                    args.push(token.value);
                                    i += 1;
                                    token = arr[i];
                                }

                                if (args.length > 0) {
                                    command.push(' tsh:href="',
                                        TP.xmlLiteralsToEntities(
                                            prefix + args.join('')),
                                            '"');
                                    args.length = 0;
                                }

                                if (token &&
                                    (TP.$is_terminator(token.value) ||
                                    TP.$is_whitespace(token.name))) {
                                    i--;
                                }
                                mode = 'tag';
                                tagname = 'tsh:uri';
                                break;

                            case '!':
                                //  TSH history command prefix. NOTE that
                                //  you could use !varname or !value etc.
                                //  but doing that without an LVALUE or IF
                                //  is highly unlikely. Still, we try to
                                //  observe standard shell semantics a bit
                                //  here and allow whitespace, =, or ( to
                                //  override the history interpretation.

                                next = arr[i + 1];
                                if (next &&
                                    (TP.$is_whitespace(next.name) ||
                                    next.value === '(')) {
                                    command.push('<tsh:eval',
                                        '><![CDATA[', token.value);
                                    mode = 'src';
                                    break;
                                }

                                command.push('<tsh:history');

                                //  history is of the form ![+-]n[:m] so
                                //  collect all tokens until whitespace or
                                //  terminator (or end of stream).
                                i += 1;
                                token = arr[i];
                                while (token &&
                                    !TP.$is_terminator(token.value) &&
                                    !TP.$is_whitespace(token.name)) {
                                    args.push(token.value);
                                    i += 1;
                                    token = arr[i];
                                }

                                if (args.length > 0) {
                                    command.push(
                                        ' hid="',
                                        TP.xmlLiteralsToEntities(
                                                        args.join('')),
                                        '"');
                                    args.length = 0;
                                }

                                if (token &&
                                    (TP.$is_terminator(token.value) ||
                                    TP.$is_whitespace(token.name))) {
                                    i--;
                                }
                                mode = 'tag';
                                tagname = 'tsh:history';
                                break;

                        //  case '@':
                        //      //  Used by the system for 'object
                        //      //  dereferencing'

                        //  case '$':
                        //      //  Valid JS identifier, we don't process
                        //      //  into a tag
                        //      //  (not in TP.TSH_OPERATOR_CHARS).

                            case '%':
                                //  TSH "job" syntax.
                                command.push('<tsh:job');
                                next = arr[i + 1];
                                if (next) {
                                    command.push(
                                        ' pid="',
                                        TP.xmlLiteralsToEntities(
                                                        next.value),
                                        '"');
                                    i += 1;
                                }

                                mode = 'tag';
                                tagname = 'tsh:job';
                                break;

                        //  case '^':
                        //      //  Regexp history substitution. Processed
                        //      //  at runtime by tsh:eval tag since it
                        //      //  doesn't convert into a tag.

                            case '&':
                                //  Could cause potential confusion with
                                //  pipes but there's one thing that's just
                                //  too good to pass up...raw entity dumps.
                                next = arr[i + 1];
                                if (next && next.value === '#') {
                                    command.push('<tsh:entity');
                                    mode = 'tag';
                                    i += 1;
                                } else if (TP.notValid(next)) {
                                    command.push('<tsh:entity');
                                    mode = 'tag';
                                } else {
                                    command.push(
                                        '<tsh:eval',
                                        '><![CDATA[&');
                                    mode = 'src';
                                }

                                break;

                        //  case '*':
                        //      //  leading * is available...

                            case '=':

                                //  leading = is a literal signifier for
                                //  command tag input
                                command.push(
                                        '<tsh:eval',
                                        ' literal="true"><![CDATA[');
                                mode = 'src';
                                break;

                        //  case '\\':
                        //      //  Alias escaping per shell. Processed at
                        //      //  runtime by tsh:eval tag.

                        //  case '|':
                        //      //  potential confusion with pipes
                        //      //  (not in TP.TSH_OPERATOR_CHARS).

                        //  case ';':
                        //      //  leading ; is used by TP.tsh.command as the
                        //      //  'null statement' indicator which turns
                        //      //  console output via cmdSilent flagging.

                            case ':':
                                //  command with default namespace prefix
                                i += 1;
                                token = arr[i];

                                command.push('<' +
                                                cmdns +
                                                ':' +
                                                token.value);
                                mode = 'tag';
                                tagname = cmdns + ':' + token.value;

                                break;

                        //  case ',':
                        //      //  leading , is available...

                        //  case '<':
                        //      //  potential confusion with pipes
                        //      //  (not in TP.TSH_OPERATOR_CHARS).

                            case '.':
                                //  An alias for the 'source' or 'import'
                                //  command.

                                //  First, see if it's an identifier
                                next = arr[i + 1];
                                if (next && TP.$is_identifier(next.name)) {

                                    i += 1;
                                    token = arr[i];

                                    while (token &&
                                        !TP.$is_whitespace(token.name) &&
                                        !TP.$is_terminator(token.value)) {
                                        args.push(token.value);
                                        i += 1;
                                        token = arr[i];
                                    }

                                    //  Create a 'tsh:source' command with the
                                    //  identifier name
                                    if (args.length > 0) {
                                        command.push('<tsh:source',
                                            ' ref="',
                                            TP.xmlLiteralsToEntities(
                                                args.join('')),
                                            '"');
                                        args.length = 0;
                                    }

                                    if (token &&
                                        (TP.$is_terminator(token.value) ||
                                        TP.$is_whitespace(token.name))) {
                                        i--;
                                    }
                                    mode = 'tag';
                                    tagname = 'tsh:source';
                                } else if (next && next.name === 'uri') {

                                    //  Otherwise, if it's a URI, it could
                                    //  either be an external TSH script or it
                                    //  could be a file that we want to import.

                                    i += 1;
                                    token = arr[i];

                                    mode = 'tag';

                                    //  If the extension is '.tsh', then its an
                                    //  external TSH script.
                                    if (TP.uriExtension(token.value) ===
                                                                    'tsh') {

                                        command.push('<tsh:script',
                                            ' src="',
                                            TP.xmlLiteralsToEntities(
                                                            token.value),
                                            '"');
                                        tagname = 'tsh:script';
                                    } else {
                                        //  Otherwise, it's something to import
                                        command.push('<tsh:import',
                                            ' href="',
                                            TP.xmlLiteralsToEntities(
                                                            token.value),
                                            '"');
                                        tagname = 'tsh:import';
                                    }
                                } else {
                                    //  Otherwise, it isn't any of that, so just
                                    //  create a command with literal text (make
                                    //  sure to re-created the leading '.').
                                    command.push(
                                            '<tsh:eval',
                                            ' literal="true"><![CDATA[.');
                                    mode = 'src';
                                }

                                break;
                        //  case '>':
                        //      //  potential confusion with pipes
                        //      //  (not in TP.TSH_OPERATOR_CHARS).

                            case '/':
                                //  flag syntax, provides access to TIBET's
                                //  TP.sys.cfg() and TP.sys.setcfg()
                                //  mechanisms. NOTE that the tokenizing
                                //  step will have found true regular
                                //  expressions and comments before we got
                                //  to this point, so we know the / isn't
                                //  part of one of those.
                                i += 1;
                                token = arr[i];
                                while (token &&
                                    !TP.$is_whitespace(token.name) &&
                                    !TP.$is_terminator(token.value)) {
                                    args.push(token.value);
                                    i += 1;
                                    token = arr[i];
                                }

                                command.push('<tsh:config');

                                if (args.length > 0) {
                                    command.push(' name="',
                                        TP.xmlLiteralsToEntities(
                                            args.join('')),
                                        '"');
                                    args.length = 0;
                                }

                                if (token &&
                                    (TP.$is_terminator(token.value) ||
                                    TP.$is_whitespace(token.name))) {
                                    i--;
                                }
                                mode = 'tag';
                                tagname = 'tsh:config';
                                break;

                            case '?':
                                //  TSH help command
                                command.push('<tsh:help');
                                next = arr[i + 1];
                                if (next) {
                                    command.push(
                                        ' topic="',
                                        TP.xmlLiteralsToEntities(
                                                            next.value),
                                        '"');
                                    i += 1;
                                }

                                mode = 'tag';
                                tagname = 'tsh:help';
                                break;

                            default:

                                //  when we see a pipe as the first symbol
                                //  in a text section there are two possible
                                //  meanings...one is that there's an
                                //  element sibling just ahead of the text
                                //  which should have the pipe symbol added
                                //  to it, the other is that we're
                                //  effectively defaulting the first tag to
                                //  the current value of $$ (the last
                                //  command's result value).
                                if (TP.$is_terminator(token.value) &&
                                    token.value !== ';') {
                                    if (TP.isElement(sibling)) {
                                        TP.elementSetAttribute(
                                            sibling,
                                            'tsh:pipe',
                                            TP.xmlLiteralsToEntities(
                                                token.value),
                                            true);
                                    } else {
                                        //  no prior element, so we're
                                        //  defaulting to using $$ as a
                                        //  "source URI"
                                        command.push('<tsh:uri',
                                            ' tsh:pipe="',
                                                TP.xmlLiteralsToEntities(
                                                    token.value),
                                            '"',
                                            ' tsh:href="tibet:///$$" />');
                                            //  TODO: urn:///??? here?
                                    }

                                    i += 1;
                                    token = arr[i];
                                } else {
                                    command.push('<tsh:eval',
                                        '><![CDATA[', token.value);
                                    mode = 'src';
                                }

                                break;
                        }

                        break;

                    default:

                        //  numbers, strings, regexes, etc. which start a
                        //  'statement' are presumed to be standard js
                        command.push('<tsh:eval',
                            '><![CDATA[', token.value);
                        mode = 'src';
                        break;
                }

                break;
        }
    }

    //  when we run out of tokens we need to close off any open tags
    switch (mode) {
        case 'tag':
            //  close off whatever tag was open...must be an empty tag
            command.push('/>');
            break;
        case 'src':
            //  close off tsh:eval we use to wrap source text
            command.push(']]></tsh:eval>');
            break;
        default:
            break;
    }
    result.addAll(command);

    return result.join('');
});

//  ------------------------------------------------------------------------

TP.tsh.script.Type.defineMethod('scriptFail',
function(aRequest, aMessage) {

    /**
     * @method scriptFail
     * @summary Handles failing a request during execution such that commands
     *     which are nested will properly manage request data and return value.
     * @param {TP.sig.Request} aRequest The request to fail.
     * @param {String} aMessage The failure error message, if any.
     * @returns {TP.sig.Request|Number} The request or a TP status constant.
     */

    var msg,
        node,
        root;

    msg = TP.ifInvalid(aMessage, 'Script execution error.');

    node = aRequest.at('cmdNode');
    if (TP.elementIsNested(node)) {
        root = TP.ifKeyInvalid(aRequest,
                            'rootRequest',
                            aRequest.at('cmdShell'));
        root.stderr(msg, aRequest);

        //  returning break here will effectively terminate looping in any
        //  outer processing context.
        return TP.BREAK;
    } else {
        aRequest.fail(msg);
    }

    return TP.BREAK;
});

//  ------------------------------------------------------------------------

TP.tsh.script.Type.defineMethod('tshCompile',
function(aRequest) {

    /**
     * @method tshCompile
     * @summary Processes the content of a tsh:script tag, replacing the tag's
     *     content with one or more child tags which will handle the concrete
     *     processing for the script.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     */

    var node,
        shell,
        stage,
        children,
        len,
        i,
        child,
        text,
        result,
        newChild,
        iodev;

    //  NB: DO NOT CHANGE THIS METHOD TO BE 'tagCompile' UNTIL THE SHELL HAS
    //  BEEN CHANGED TO USE THE TAG PROCESSOR RATHER THAN IT'S OWN TAG
    //  PROCESSING MACHINERY (AT LEAST FOR COMPILATION).

    node = aRequest.at('cmdNode');
    shell = aRequest.at('cmdShell');

    if (TP.notEmpty(stage = TP.elementGetAttribute(node,
                                                    'tibet:phase',
                                                    true))) {
        if (stage === 'Compile') {
            return TP.CONTINUE;
        }
    }

    TP.nodeNormalize(node);

    //  get the list ready. NOTE NOTE NOTE that we convert into an array so
    //  that we can be sure that we process each original child regardless
    //  of how the desugaring process may alter the original node.
    children = TP.ac(node.childNodes);
    len = children.length;

    //  we'll have multiple child nodes potentially since we can have
    //  regular text content interspersed with XML tags which break up the
    //  individual chunks of text. the chunks get wrapped in proper tags,
    //  often tsh:eval tags which can handle the text at execution time.
    for (i = 0; i < len; i++) {
        child = children[i];
        switch (child.nodeType) {
            case Node.TEXT_NODE:
            case Node.CDATA_SECTION_NODE:

                text = TP.nodeGetTextContent(child);
                if (TP.isEmpty(text)) {
                    continue;
                }

                //  reconstitute text into original source form. this is
                //  needed since the initial process turns literals into
                //  entities to produce viable XML and any remaining has to
                //  be converted back before parsing for command breaks
                text = TP.xmlEntitiesToLiterals(text);

                //  convert any text content into desugared XML, including
                //  wrapping simple text in command tags for execution.
                result = this.$desugarXML(text,
                                            shell,
                                            children.before(child),
                                            aRequest);

                newChild = TP.nodeFromString(TP.ifInvalid(result, ''));
                if (newChild) {
                    TP.nodeReplaceChild(node, newChild, child);
                } else {
                    iodev = TP.ifKeyInvalid(aRequest, 'rootRequest', shell);
                    iodev.stderr('Unable to create node from: ' +
                                    result,
                                    aRequest);
                    aRequest.fail();
                }

                break;

            case Node.ELEMENT_NODE:
                break;

            default:
                break;
        }
    }

    return TP.DESCEND;
});

//  ------------------------------------------------------------------------

TP.tsh.script.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Manages the overall execution process for a tsh:script and its
     *     content elements. The primary focus of this method is to parse the
     *     script into separate pipe segments (if any) and to construct a
     *     request pipeline which can process the pipeline while managing any
     *     asynchronous subcomponents of that pipe.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var request,

        node,
        root,
        shell,
        nested,
        cmdID,

        src,
        url,
        resp,
        content,
        req,

        i,
        children,
        child,

        nodetype,
        command,
        pipe,

        next,

        cmdRequest,
        rootRequest,
        pipeRequest,
        constructPR,

        roots,
        cmds,
        inputIndex,

        outs,
        len,
        out,
        service;

    request = TP.request(aRequest);

    node = request.at('cmdNode');
    shell = request.at('cmdShell');

    if (TP.sys.cfg('log.tsh_execute')) {
        TP.ifTrace() ?
            TP.trace('tsh_execute:\n' + TP.str(node)) : 0;
    }

    //  nested scripts have to handle their stdio with respect to the outer
    //  request in certain circumstances, so track that state.
    nested = TP.elementIsNested(node);

    cmdID = request.at('cmdID');
    if (TP.notValid(cmdID)) {
        cmdID = request.getRootID();
    }
    request.atPutIfAbsent('cmdID', cmdID);

    //  keep a list of the commands (which keep track of their own input and
    //  output redirections so we don't have to)
    cmds = TP.ac();

    //  Two modes, just like normal script tags...src= and inline. When we
    //  see a src attribute it will override any inlined content. We fetch
    //  the referenced URI's content and compile (provided it's valid XML).
    //  The resulting compiled script tag's child nodes are then executed.
    src = TP.elementGetAttribute(node, 'src', true);
    if (TP.notEmpty(src)) {
        root = node;
        url = TP.uc(src);
        if (TP.notValid(url)) {
            return this.scriptFail(
                request,
                'Invalid or unresolvable TSH script url: ' + src);
        }

        resp = url.getResource(
                TP.hc('refresh', true, 'async', false, 'resultType', TP.WRAP));
        content = resp.get('content');

        if (!TP.canInvoke(content, 'getNativeNode')) {
            return this.scriptFail(
                request,
                'Unable to read valid XML for: ' + src);
        }

        node = content.getNativeNode();
        if (TP.notValid(node)) {
            return this.scriptFail(
                request,
                'Unable to get XML document for: ' + src);
        }

        node = TP.elem(node);
        if (TP.notValid(node)) {
            return this.scriptFail(
                request,
                'Unable to get root node for: ' + src);
        }

        if (TP.qname(node) !== this.getCanonicalName()) {
            return this.scriptFail(
                request,
                'Invalid (!tsh:script) root node for: ' + src);
        }

        //  Build a request we can process through our shell up through, but
        //  not including execution, and then grab the root node from that.
        req = TP.sig.ShellRequest.construct(
                        TP.hc(
                            'cmdNode', node,
                            'cmdShell', shell
                        ));
        shell.execute(req);

        //  TODO:   what if the processing failed on the subscript content?

        node = req.at('cmdNode');

        if (TP.elementGetAttribute(root, 'subshell') === 'true') {
            TP.ifWarn() ?
                TP.warn('Pure subshell not yet supported. Using block.') : 0;
        }

        //  copy the children out of the loaded script node into the
        //  current one, which will remove a layer of overhead.
        TP.nodeCopyChildNodesTo(node, root);

        //  replace the working node with the original rather than the
        //  loaded script node.
        node = root;
    }

    i = 0;
    children = node.childNodes;

    if (children.length === 0) {
        request.complete();
        return TP.CONTINUE;
    }

    //  the root request is the one in the history list...the top level
    //  request which started the whole thing.
    rootRequest = request.getRootRequest();

    /* eslint-disable no-extra-parens */
    while ((child = children[i])) {
    /* eslint-enable no-extra-parens */
        nodetype = child.nodeType;

        if (nodetype !== Node.ELEMENT_NODE &&
            nodetype !== Node.PROCESSING_INSTRUCTION_NODE) {
            i += 1;
            continue;
        }

        //  the first child in each segment is the command, remaining
        //  elements in a contiguous segment are the redirects
        command = child;

        //  reset the input handle index for any input redirects.
        inputIndex = 0;

        //  each command in the overall script gets a request assigned
        //  so we can manage async join requirements
        cmdRequest = TP.sig.TSHRunRequest.construct(
                        TP.hc(
                            'cmdAllowSubs', request.at('cmdAllowSubs'),
                            //  No 'cmd' - it's already been desugared
                            'cmdAsIs', request.at('cmdAsIs'),
                            //  'cmdExecute' is implied
                            'cmdHistory', request.at('cmdHistory'),
                            'cmdID', cmdID,
                            'cmdBuildGUI', request.at('cmdBuildGUI'),
                            'cmdLast', cmds.last(),
                            'cmdLiteral', request.at('cmdLiteral'),
                            'cmdNode', command,
                            //  'cmdPhases' is implied
                            'cmdRecycle', request.at('cmdRecycle'),
                            'cmdSequence', cmds,
                            'cmdShell', shell,
                            'cmdSilent', request.at('cmdSilent'),

                            'cmdEcho', request.at('cmdEcho'),
                            'execContext', request.at('execContext'),
                            'execInstance', request.at('execInstance'),
                            'rootRequest', rootRequest));

        //  add the new command to the command list
        cmds.push(cmdRequest);

        //  watch out for PIs by checking for element-ness before
        //  looking for a pipe or redirection symbol
        pipe = TP.isElement(command) ?
            TP.elementGetAttribute(command, 'tsh:pipe', true) : '';

        //  NOTE the label here so we can break out of the interior switch
        //  and the overall pipe while loop when we reach a terminator.
        outer: while (TP.notEmpty(pipe)) {
            next = TP.nodeGetFirstSiblingElement(child);
            if (TP.notValid(next) && !nested && pipe !== '.;') {
                rootRequest.stderr('Unexpected end of pipe at: ' +
                    TP.str(child), request);
                return TP.BREAK;
            }

            pipe = TP.xmlEntitiesToLiterals(pipe);
            switch (pipe) {
                //  ---
                //  standard pipes
                //  ---

                case '.|':      //  stdout
                case '.*':      //  stdout (and iterate)
                case '.|*':     //  stdout (and iterate)
                case '.?':      //  stdout (and filter)
                case '.|?':     //  stdout (and filter)
                case '.%':      //  stdout (and format)
                case '.|%':     //  stdout (and format)
                case '.?*':     //  stdout (iterate and filter)
                case '.|?*':    //  stdout (iterate and filter)
                case '.%*':     //  stdout (iterate and format)
                case '.|%*':    //  stdout (iterate and format)

                    cmdRequest.atPut(TP.STDOUT, TP.ac());
                    break outer;

                case '.&':      //  stderr
                case '.&*':     //  stderr (and iterate)
                case '.&?':     //  stderr (and filter)
                case '.&?*':    //  stderr (iterate and filter)
                case '.&%':     //  stderr (and format)
                case '.&%*':    //  stderr (iterate and format)

                    cmdRequest.atPut(TP.STDERR, TP.ac());
                    break outer;

                case '.|&':     //  both
                case '.|&*':    //  both (and iterate)
                case '.|&?':    //  both (and filter)
                case '.|&?*':   //  both (iterate and filter)
                case '.|&%':    //  both (and format)
                case '.|&%*':   //  both (iterate and format)

                    cmdRequest.atPut(TP.STDIO, TP.ac());
                    break outer;

                //  ---
                //  conditional execution
                //  ---

                case '.||':

                    TP.elementSetAttribute(next, 'tsh:cond', '.||', true);
                    break outer;

                case '.&&':

                    TP.elementSetAttribute(next, 'tsh:cond', '.&&', true);
                    break outer;

                //  ---
                //  input redirections
                //  ---

                case '.<':      //  stdin
                case '.<!':     //  stdin with refresh

                    //  have to construct a request that can read the data
                    //  being pointed to by the next element...the
                    //  result of running that command/tag as it were.
                    //  That request's result has to then be placed into
                    //  the cmdRequest's STDIN array in the proper slot
                    //  based on order.
                    pipeRequest = TP.sig.TSHRunRequest.construct(
                        TP.hc(
                            'cmdAllowSubs', request.at('cmdAllowSubs'),
                            //  No 'cmd' - it's already been desugared
                            'cmdAsIs', request.at('cmdAsIs'),
                            //  'cmdExecute' is implied
                            'cmdHistory', cmdRequest.at('cmdHistory'),
                            'cmdID', cmdID,
                            'cmdBuildGUI', cmdRequest.at('cmdBuildGUI'),
                            'cmdIOName', '$_' + inputIndex,
                            'cmdLiteral', cmdRequest.at('cmdLiteral'),
                            'cmdNode', next,
                            //  'cmdPhases' is implied
                            'cmdRecycle', cmdRequest.at('cmdRecycle'),
                            'cmdRequest', cmdRequest,
                            'cmdShell', shell,
                            'cmdSilent', cmdRequest.at('cmdSilent'),

                            'cmdEcho', cmdRequest.at('cmdEcho'),
                            'execContext', request.at('execContext'),
                            'execInstance', request.at('execInstance'),
                            'rootRequest', rootRequest
                        ));

                    pipeRequest.defineMethod('stdout',
                        function(result) {

                            this.at('cmdRequest').atPut(
                                this.at('cmdIOName'),
                                result);
                        });

                    inputIndex++;

                    cmdRequest.addInputRequest(pipeRequest);
                    break;

                case '.<<':     //  here document

                    //  shouldn't happen...here documents are converted
                    //  into tags and their pipe is rewritten to be a
                    //  typical input redirection symbol (.<)
                    rootRequest.stderr(
                        'Unexpected pipe symbol at: ' + TP.str(child),
                        request);

                    return TP.BREAK;

                //  ---
                //  output redirections
                //  ---

                case '.>':      //  stdout
                case '.>!':

                    cmdRequest.atPut(TP.STDOUT, TP.ac());
                    constructPR = true;
                    break;

                case '.&>':     //  stderr
                case '.&>!':

                    cmdRequest.atPut(TP.STDERR, TP.ac());
                    constructPR = true;
                    break;

                case '.>&':     //  both
                case '.>&!':

                    cmdRequest.atPut(TP.STDIO, TP.ac());
                    constructPR = true;
                    break;

                case '.>>':     //  append stdout
                case '.>>!':

                    cmdRequest.atPut(TP.STDOUT, TP.ac());
                    constructPR = true;
                    break;

                case '.&>>':    //  append stderr
                case '.&>>!':

                    cmdRequest.atPut(TP.STDERR, TP.ac());
                    constructPR = true;
                    break;

                case '.>>&':    //  append both
                case '.>>&!':

                    cmdRequest.atPut(TP.STDIO, TP.ac());
                    constructPR = true;
                    break;

                case '.;':      //  explicit end of pipe
                    //  break out so we can generate proper sequence
                    break outer;

                default:        //  bad symbol
                    rootRequest.stderr(
                        'Unexpected pipe symbol at: ' + TP.str(child),
                        request);

                    return TP.BREAK;
            }

            if (constructPR) {
                pipeRequest = TP.sig.TSHRunRequest.construct(
                    TP.hc(
                        'cmdAllowSubs', request.at('cmdAllowSubs'),
                        //  No 'cmd' - it's already been desugared
                        'cmdAsIs', request.at('cmdAsIs'),
                        //  'cmdExecute' is implied
                        'cmdHistory', cmdRequest.at('cmdHistory'),
                        'cmdID', cmdID,
                        'cmdBuildGUI', cmdRequest.at('cmdBuildGUI'),
                        'cmdLiteral', cmdRequest.at('cmdLiteral'),
                        'cmdNode', next,
                        //  'cmdPhases' is implied
                        'cmdRecycle', cmdRequest.at('cmdRecycle'),
                        'cmdRequest', cmdRequest,
                        'cmdShell', shell,
                        'cmdSilent', cmdRequest.at('cmdSilent'),

                        'cmdEcho', cmdRequest.at('cmdEcho'),
                        'execContext', request.at('execContext'),
                        'execInstance', request.at('execInstance'),
                        'rootRequest', rootRequest
                    ));

                cmdRequest.addOutputRequest(pipeRequest);
                constructPR = false;
            }

            //  the next pipe symbol will be on the 'next' element
            pipe = TP.isElement(next) ?
                TP.elementGetAttribute(next, 'tsh:pipe', true) : '';

            child = next;
            i += 1;
        }

        i += 1;
    }


    //  If, for some reason, we didn't get valid content and couldn't
    //  construct a command to run then we have to exit.
    if (TP.notValid(cmdRequest)) {
        return this.scriptFail(
            request,
            'Unable to construct subcommand(s) for: ' + src);
    }

    //  give the top level request the command sequence for inspection
    //  and use in returning results.
    request.set('subrequests', cmds);

    //  connect the current request to either the last command or to it's
    //  various output redirections as an "and'ed set" so we need to hear
    //  from all output redirects before the request can continue.
    outs = cmdRequest.get('outs');
    if (TP.isEmpty(outs)) {
        request.andJoinChild(cmdRequest);
    } else {
        len = outs.getSize();
        for (i = 0; i < len; i++) {
            out = outs.at(i);
            request.andJoinChild(out);
        }
    }

    //  connect the input and output of our children into our overall pipe
    //  sequence so they read/write to the pipe we're a part of.
    if (nested) {
        //  map the last subcommand's output buffers to be ours, which means
        //  it will write to our buffers, and those are what downstream pipe
        //  segments from the nested script tag will be reading.
        cmds.last().atPut(TP.STDOUT, request.at(TP.STDOUT));
        cmds.last().atPut(TP.STDIO, request.at(TP.STDIO));
    }

    //  adjust the pipe symbols so they are in the "right place" so
    //  individual tags can see the pipe symbol which preceded them
    this.$adjustPipeSymbols(node, cmds, request);

    //  if we're a script tag with a pipe we need to push that down onto the
    //  first child so it can find it and be aware that it may have to
    //  handle stdin etc.
    if (TP.notEmpty(pipe = TP.elementGetAttribute(node, 'tsh:pipe', true))) {
        //  when the script is being used to provide input via a redirect we
        //  want our output to become the input for our cmdRequest
        if (pipe === '.<') {
            child = cmds.last();
            if (TP.isValid(child)) {
                child.atPut('cmdRequest', request.at('cmdRequest'));
                child.atPut('cmdIOName', request.at('cmdIOName'));
                child.stdout = request.stdout;
            }
        } else {
            //  all other pipes are "left-to-right" so we want our input to
            //  go to our first subcommand as the default STDIN content.
            child = cmds.first().at('cmdNode');
            if (TP.isElement(child)) {
                TP.elementSetAttribute(child, 'tsh:pipe', pipe, true);
                cmds.first().atPut(TP.STDIN, request.at(TP.STDIN));
            }
        }
    }

    //  perform any work to connect the previous section(s) of pipe
    this.$connectPipeSections(cmds, request);

    //  Tell the main Lama object that it should go ahead and process DOM
    //  mutations to the source DOM.

    //  Note here how we also check to make sure we have a real Lama object.
    //  That's because this code can sometimes run in a 'packaging' environment
    //  where the command is being invoked, hasFeature('Lama') is true,
    //  TP.sys.cfg('lama.enabled') is true, but no real Lama has been
    //  allocated
    if (TP.sys.hasFeature('lama') && TP.isValid(TP.bySystemId('Lama'))) {
        TP.bySystemId('Lama').set('shouldProcessDOMMutations', true);
    }

    service = TP.tsh.RunService.getDefaultInstance();

    //  if the first command has input requests those are first in the
    //  overall pipe sequence, otherwise it's the command itself.
    if (TP.isValid(roots = cmds.first().get('ins'))) {
        roots.perform(
            function(inReq) {

                service[TP.composeHandlerName('TSHRunRequest')](inReq);
            });
    } else {
        service[TP.composeHandlerName('TSHRunRequest')](cmds.first());
    }

    //  return a break to keep from having shell loop descend into children
    return TP.BREAK;
});

//  ------------------------------------------------------------------------

TP.tsh.script.Type.defineMethod('$xmlifyContent',
function(src, shell, request) {

    /**
     * @method $xmlifyContent
     * @summary Processes incoming source text, massaging it to handle mixed
     *     XML and JavaScript input as well as certain TIBET Shell operators to
     *     create the best possible XML string value. As part of this process
     *     XML literals are converted to entities when found outside of opening
     *     and closing tags, TSH here document syntax is processed, subshell
     *     content is handled, and more.
     * @param {String} src The source text to process/convert.
     * @param {TP.shell.Shell} shell The shell instance requesting processing.
     * @param {TP.sig.Request} request The request being processed.
     * @returns {String} The processed/converted content.
     */

    var arr,
        token,
        i,
        result,
        mode,
        next,
        tag,
        term,
        here,
        str,
        literal,
        preserve;

    //  TODO:   coalesce into a single test
    if (!TP.regex.HAS_ELEMENT.test(src) &&
        !TP.regex.HAS_PI.test(src) &&
        !TP.regex.HAS_ENTITY.test(src) &&
        !TP.regex.TSH_SUBSHELL.test(src) &&
        !TP.regex.TSH_SUBGROUP.test(src) &&
        !TP.regex.TSH_HEREDOC.test(src)) {
        return src;
    }

    //  tokenize and do our best...
    arr = TP.$tokenize(
                src,
                //  All of the JS operators *and* the TSH operators
                TP.tsh.script.$tshAndJSOperators,
                true, false, false, false);

    i = 0;
    token = arr[i];

    mode = 'content';

    result = TP.ac();
    here = TP.ac();
    tag = TP.ac();

    while (token) {
        switch (token.value) {
            case '<':
            case '</':
                //  possibly start of opening or closing tag for an element,
                //  but we have to scan ahead to be sure (at least in the
                //  case of the <).
                next = arr[i + 1];
                if (!next) {
                    result.push(TP.xmlLiteralsToEntities(token.value));
                    i += 1;
                    token = arr[i];

                    continue;
                }

                if (next.name !== 'identifier' &&
                    next.name !== 'reserved') {
                    //  could be a comment...we handle PI and CDATA blocks
                    //  elsewhere since their opening syntax is not valid JS
                    //  but a comment's could be as in ( foo < ! --bar )
                    //  which is admittedly pretty obscure but possible
                    if (next.value === '!' && arr[i + 2] !== null &&
                        arr[i + 2].value === '--') {
                        tag.push('<!--');
                        i += 3;

                        for (;;) {
                            token = arr[i];
                            if (!token) {
                                break;
                            }

                            if (token.value === '--' &&
                                arr[i + 1] === '>') {
                                tag.push('-->');
                                i += 1;
                                break;
                            }

                            tag.push(token.value);
                            i += 1;
                        }

                        result.push(tag.join(''));
                        tag.length = 0;

                        i += 1;
                        break;
                    }

                    //  can't be a tag if not <ident with no space etc
                    result.push(TP.xmlLiteralsToEntities(token.value));
                    i += 1;
                    token = arr[i];

                    continue;
                }

                //  scan ahead. only legal tokens inside a tag are
                //  the operators : and =, identifiers, strings, and
                //  spaces. if we don't see a closing operator
                //  before finding something else then this isn't a
                //  tag, otherwise it is

                tag.push(token.value, next.value);
                i += 2;

                for (;;) {
                    token = arr[i];
                    if (!token) {
                        mode = 'content';
                        break;
                    }

                    tag.push(token.value);

                    if (token.name === 'operator') {
                        //  TODO:   officially : . - and _ are all legal in
                        //  tag names but we only support 3 of those and
                        //  even then the logic below here doesn't make sure
                        //  they are found without intervening whitespace.

                        if (token.value === '>' ||
                            token.value === '/>') {
                            //  closing the tag
                            mode = 'tag';
                            break;
                        } else if (token.value === '-') {
                            //  certain XML dialects like to use - in tag
                            //  names, particularly XSLT and XForms
                            i += 1;
                            continue;
                        } else if (token.value !== ':' &&
                                token.value !== '=') {
                            //  can't be a tag, invalid operator
                            mode = 'content';
                            break;
                        }
                    } else if (token.name === 'string' ||
                                TP.$is_identifier(token.name) ||
                                TP.$is_whitespace(token.name)) {
                        //  could be more discriminating here based on
                        //  last/next but for now assume operator check
                        //  will catch the majority of bad tag forms
                        i += 1;
                        continue;
                    } else {
                        //  can't be a tag, found something that's not
                        //  legal inside the tag itself
                        mode = 'content';
                        break;
                    }

                    i += 1;
                }

                if (mode === 'content') {
                    //  not a tag after all...content...which means we
                    //  need to xmlify what's in the tag stream so it
                    //  can be used as valid content

                    if (tag.last() === '.<<') {
                        //  start of a 'here document',
                        tag.length = tag.length - 1;
                        i -= 1;
                    } else if (tag.last() === '.((') {
                        //  start of a nested script subshell
                        tag.length = tag.length - 1;
                        i -= 1;
                    } else if (tag.last() === '.{{') {
                        //  start of a nested script "block"
                        tag.length = tag.length - 1;
                        i -= 1;
                    } else {
                        i += 1;
                    }

                    result.push(TP.xmlLiteralsToEntities(tag.join('')));
                    tag.length = 0;

                } else {
                    //  tag, no additional processing necessary, should
                    //  be in valid markup format already
                    result.push(tag.join(''));
                    tag.length = 0;

                    mode = 'content';

                    i += 1;
                }

                token = arr[i];
                break;

            case '<![':
                //  start of a CDATA block

                //  read and push until we've consumed the
                //  CDATA block content. the primary point here
                //  is that we do not escape or transform
                //  literals etc.
                tag.push('<![CDATA[');
                i += 3;

                for (;;) {
                    token = arr[i];
                    if (!token) {
                        break;
                    }

                    if (token.value === ']' &&
                        arr.slice(i, i + 2).join('') === ']]>') {
                        tag.push(']]>');
                        i += 2;
                        break;
                    }

                    tag.push(token.value);
                    i += 1;
                }

                result.push(tag.join(''));
                tag.length = 0;

                i += 1;
                break;

            case '<?':
                //  start of a processing instruction. read and push
                //  until we get to a closing ?> operator

                tag.push(token.value);
                i += 1;

                token = arr[i];
                while (token && token.value !== '?>') {
                    tag.push(token.value);
                    i += 1;
                    token = arr[i];
                }

                if (token && token.value === '?>') {
                    tag.push(token.value);
                }

                result.push(tag.join(''));
                tag.length = 0;

                i += 1;
                break;

            case '.{{':
                //  start of nested "block" tag. if we replace now with the
                //  equivalent tag we can wait for the full desugaring pass
                //  to handle the rest
                result.push('<tsh:script>');

                i += 1;
                break;

            case '.}}':

                //  close of nested script tag.
                result.push('</tsh:script>');

                i += 1;
                break;

            case '.((':
                //  start of nested script tag. if we replace now with the
                //  equivalent tag we can wait for the full desugaring pass
                //  to handle the rest
                result.push('<tsh:script subshell="true">');

                i += 1;
                break;

            case '.))':

                //  close of nested script tag.
                result.push('</tsh:script>');

                i += 1;
                break;

            case '.<<':

                //  'here' document content which is of the form:
                //  .<< TERM ...content... TERM
                //  where the TERM is any identifier to use as a delimiter
                //  and content is anything which should become content in
                //  the resulting tsh:here tag

                i += 1;
                token = arr[i];

                //  allow optional whitespace prior to first identifier, but
                //  note whether we get a \ before the first identifier
                //  since that will turn off processing of content for shell
                //  sugars and make the content "literal" and preserve any
                //  leading whitespace
                while (token && (token.name !== 'identifier' ||
                            token.name !== 'reserved')) {

                    /* eslint-disable no-extra-parens */
                    literal = (token.value === '\\');
                    preserve = (token.value === '-');
                    /* eslint-enable no-extra-parens */

                    i += 1;
                    token = arr[i];
                }

                //  have to see an identifier which will become our ending
                //  delimiter when we see it again
                if (token && (
                        token.name === 'identifier' ||
                        token.name === 'reserved')) {
                    //  capture the termination delimiter
                    term = token.value;

                    i += 1;
                    token = arr[i];

                    //  skip one whitespace token between the termination
                    //  symbol and the content (since at least one is
                    //  required syntax).
                    if (TP.$is_whitespace(token.name)) {
                        i += 1;
                        token = arr[i];
                    }

                    //  push a stdin redirect into the result which
                    //  points to the here document tag...but do it
                    //  in entity form so it converts properly
                    result.push('.&lt;');

                    //  open a tag and CDATA block to contain the data
                    result.push('<tsh:here');
                    if (literal) {
                        result.push(' literal="true"');
                    }
                    if (preserve) {
                        result.push(' preserve="true"');
                    }
                    result.push(' ><![CDATA[');

                    //  capture tokens "as is" with no translation, placing
                    //  them into a content container
                    while (token) {
                        if (token.value === term) {
                            i += 1;
                            break;
                        }

                        here.push(token.value);
                        i += 1;
                        token = arr[i];
                    }

                    //  if we found real content then push it into the
                    //  CDATA container in proper format
                    if (here.length > 0) {
                        result.push(
                            TP.xmlLiteralsToEntities(here.join('')));
                        here.length = 0;
                    }

                    //  close off the CDATA and tag
                    result.push(']]></tsh:here>');

                    //  reset to content mode for next token
                    mode = 'content';

                    //  look ahead for possible pipe/redirect so we don't
                    //  lose that information
                    //  TODO
                } else {
                    TP.ifWarn() ?
                        TP.warn('Invalid syntax at: ' + token.value) : 0;

                    i += 1;
                }

                break;

            default:

                if (token.name === 'string' ||
                    token.name === 'operator') {
                    //  xmlify string and token content to avoid issues
                    token.value = TP.xmlLiteralsToEntities(token.value);

                    result.push(token.value);
                    i += 1;
                } else {
                    result.push(token.value);
                    i += 1;
                }

                break;
        }

        token = arr[i];
    }

    str = result.join('');

    if (TP.sys.cfg('log.tsh_xmlify')) {
        TP.ifTrace() ?
            TP.trace('tsh_xmlify:\n' + str) : 0;
    }

    return str;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.tsh.script.Inst.defineMethod('constructActRequest',
function(aSignal) {

    /**
     * @method constructActRequest
     * @summary
     * @param {TP.sig.Signal} aSignal The signal instance which triggered this
     *     activity.
     * @returns {TP.sig.Request} The request that was generated (or was
     *     supplied) to run this action.
     */

    var request;

    request = this.callNextMethod();

    //  When processing tsh:script tags via act() calls we will use a
    //  different phase sequence if an external file is used. When content
    //  is inlined we presume it has been processed completely prior to
    //  inclusion in the tag's content area.
    if (TP.notEmpty(this.hasAttribute('src'))) {
        request.atPut('cmdPhases', 'cache');
    }

    return request;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================

//  ========================================================================
//  TP.sig.TSHRunRequest
//  ========================================================================

/**
 * @type {TP.sig.TSHRunRequest}
 * @summary The TSH uses child requests to perform the actual work of running a
 *     script. All requests of this kind are TP.sig.TSHRunRequests.
 */

TP.sig.ShellRequest.defineSubtype('TSHRunRequest');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.sig.TSHRunRequest.Type.defineAttribute('responseType', 'TP.sig.TSHRunResponse');

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

//  a list of the subrequests which provide input redirection data
TP.sig.TSHRunRequest.Inst.defineAttribute('ins');

//  a list of the subrequests which provide output redirection sinks
TP.sig.TSHRunRequest.Inst.defineAttribute('outs');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.sig.TSHRunRequest.Inst.defineMethod('addInputRequest',
function(aRequest) {

    /**
     * @method addInputRequest
     * @summary Adds a request whose purpose is to provide input to the
     *     receiver. These requests are parsed from input redirection and 'here
     *     document' symbols.
     * @param {TP.sig.TSHRunRequest} aRequest The input data request.
     * @returns {TP.sig.TSHRunRequest} The receiver.
     */

    var ins;

    ins = this.$get('ins');
    if (TP.notValid(ins)) {
        ins = TP.ac();
        this.$set('ins', ins);
    }

    ins.push(aRequest);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.TSHRunRequest.Inst.defineMethod('addOutputRequest',
function(aRequest) {

    /**
     * @method addOutputRequest
     * @summary Adds a request whose purpose is to store output from the
     *     receiver. These requests are parsed from output redirection symbols.
     * @param {TP.sig.TSHRunRequest} aRequest The output data request.
     * @returns {TP.sig.TSHRunRequest} The receiver.
     */

    var outs;

    outs = this.$get('outs');
    if (TP.notValid(outs)) {
        outs = TP.ac();
        this.$set('outs', outs);
    }

    outs.push(aRequest);

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.TSHRunRequest.Inst.defineMethod('cancel',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method cancel
     * @summary Tells the receiver to cancel, meaning it is being rescinded by
     *     the user or calling process. If the receiver has specific behavior to
     *     implement it should override the cancelJob() method invoked as part
     *     of this method's operation.
     * @param {String} aFaultString A string description of the fault.
     * @param {Object} aFaultCode A code providing additional information on the
     *     reason for the cancellation.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the cancellation.
     * @returns {TP.BREAK}
     */

    var str,
        faultCode,

        info;

    if (this.isCompleting() || this.didComplete()) {
        return;
    }

    faultCode = TP.ifEmpty(aFaultCode, TP.CANCELLED);

    if (arguments.length > 0 && TP.notTrue(this.at('cmdSilent'))) {
        switch (arguments.length) {
            case 1:
                this.stderr(aFaultString);
                break;
            case 2:
                if (TP.isError(aFaultString)) {
                    //  Try to keep messaging consistent...
                    str = faultCode + ': ' + aFaultString.message;
                    aFaultString.message = str;
                    this.stderr(aFaultString);
                } else {
                    str = faultCode + ': ' + aFaultString;
                    this.stderr(str);
                }
                break;
            case 3:
                info = TP.hc(aFaultInfo);
                if (info.at('error')) {
                    //  Try to keep messaging consistent...
                    str = faultCode + ': ' +
                            info.at('error').message +
                            ' ' + aFaultString;
                    info.at('error').message = str;
                    this.stderr(info.at('error'));
                } else {
                    str = faultCode + ': ' + aFaultString;
                    this.stderr(str);
                }
                break;
            default:
                break;
        }
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.sig.TSHRunRequest.Inst.defineMethod('complete',
function(aResult) {

    /**
     * @method complete
     * @summary Tells the receiver to complete, meaning the receiver should do
     *     whatever finalization is necessary to reach the TP.SUCCEEDED state.
     *     If the receiver has specific behavior to implement it should override
     *     the completeJob() method invoked as part of this method's operation.
     * @param {Object} aResult An optional object to set as the result for the
     *     request.
     * @returns {TP.core.TSHRunRequest} The receiver.
     */

    if (this.isCompleting() || this.didComplete()) {
        return;
    }

    if (arguments.length > 0) {

        //  Allow undefined to be set as a result.
        this.$set('result', aResult, null, true);

        if (TP.notTrue(this.at('cmdSilent'))) {
            this.stdout(aResult);
        }
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.sig.TSHRunRequest.Inst.defineMethod('fail',
function(aFaultString, aFaultCode, aFaultInfo) {

    /**
     * @method fail
     * @summary Tells the receiver to fail, meaning it failed due to some form
     *     of exception. If the receiver has specific behavior to implement it
     *     should override the failJob() method invoked as part of this method's
     *     operation.
     * @param {String} aFaultString A string description of the fault.
     * @param {Object} aFaultCode A code providing additional information on the
     *     reason for the failure.
     * @param {TP.core.Hash} aFaultInfo An optional parameter that will contain
     *     additional information about the error.
     * @returns {TP.BREAK}
     */

    var str,
        faultCode,

        info;

    if (this.isCompleting() || this.didComplete()) {
        return;
    }

    faultCode = TP.ifEmpty(aFaultCode, TP.FAILED);

    if (arguments.length > 0 && TP.notTrue(this.at('cmdSilent'))) {
        switch (arguments.length) {
            case 1:
                this.stderr(aFaultString);
                break;
            case 2:
                if (TP.isError(aFaultString)) {
                    //  Try to keep messaging consistent...
                    str = faultCode + ': ' + aFaultString.message;
                    aFaultString.message = str;
                    this.stderr(aFaultString);
                } else {
                    str = faultCode + ': ' + aFaultString;
                    this.stderr(str);
                }
                break;
            case 3:
                info = TP.hc(aFaultInfo);
                if (info.at('error')) {
                    //  Try to keep messaging consistent...
                    str = faultCode + ': ' +
                            info.at('error').message +
                            ' ' + aFaultString;
                    info.at('error').message = str;
                    this.stderr(info.at('error'));
                } else {
                    str = faultCode + ': ' + aFaultString;
                    this.stderr(str);
                }
                break;
            default:
                break;
        }
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.sig.TSHRunRequest.Inst.defineMethod('notify',
function(output, request) {

    /**
     * @method notify
     * @summary Standard function for notifying of "out of band" content during
     *     request execution.
     * @param {Object} output The object to write to stderr.
     * @param {TP.sig.Request|TP.core.Hash} request Optional request/parameters.
     *     Defaults to the receiver.
     */

    var shell;

    shell = this.at('cmdShell');

    return shell.notify(output, TP.ifInvalid(request, this));
});

//  ------------------------------------------------------------------------

TP.sig.TSHRunRequest.Inst.defineMethod('stderr',
function(output, request) {

    /**
     * @method stderr
     * @summary Standard function for writing error output during shell
     *     execution.
     * @param {Object} output The object to write to stderr.
     * @param {TP.sig.Request|TP.core.Hash} request Optional request/parameters.
     *     Defaults to the receiver.
     */

    var req,
        buffer,
        buffered,

        start,
        end,

        rootRequest;

    //  merge keys when we get extra parameters via the request/hash.
    req = TP.isValid(request) ?
            this.getPayload().addAll(request.getPayload()) :
            this;

    //  write to the stderr "buffer" array if it's defined for us
    if (TP.isValid(buffer = this.at(TP.STDERR))) {
        buffered = true;
        buffer.push(output);
    }

    //  write to the stdio "buffer" array (stdout + stderr) if provided
    if (TP.isValid(buffer = this.at(TP.STDIO))) {
        buffered = true;
        buffer.push(output);
    }

    //  last update wins relative to our "result" but we update it here
    this.set('result', output, null, true);

    //  if we're buffering into one or more arrays then we don't output to
    //  the shell and/or $stderr function, we've been redirected to buffer
    if (buffered) {
        //  IFF we're buffering then we're being piped, in which case the
        //  output here is input for a downstream process/command.
        return;
    }

    //  Compute the tagtime from the cmdStart & cmdEnd
    if (TP.isNumber(start = req.at('cmdStart')) &&
        TP.isNumber(end = req.at('cmdEnd'))) {
        this.$set('$tagtime', end - start);
    }

    //  output to the standard error reporting function if we didn't return
    //  due to buffering check
    rootRequest = this.getRootRequest();

    return rootRequest.stderr(output, req);
});

//  ------------------------------------------------------------------------

TP.sig.TSHRunRequest.Inst.defineMethod('stdin',
function() {

    /**
     * @method stdin
     * @summary Provides a common function for reading from "standard input"
     *     during shell execution. Standard input is always provided as an array
     *     of 0 to N items provided by the various stdout, stderr, and input
     *     redirection calls related to a request.
     * @returns {Object[]} An array of 0 to N input objects.
     */

    var buffer,
        node,
        pipe,
        name,
        last,
        peer,
        index,
        value;

    //  if we've already processed the data we'll have it cached in TP.STDIN
    if (TP.isValid(buffer = this.at(TP.STDIN))) {
        return buffer;
    }

    node = this.at('cmdNode');

    pipe = TP.elementGetAttribute(node, 'tsh:pipe', true);
    pipe = TP.isEmpty(pipe) ? pipe : TP.xmlEntitiesToLiterals(pipe);

    switch (pipe) {
        //  ---
        //  standard pipes
        //  ---

        case '.|':      //  stdout
        case '.|*':     //  stdout (and iterate)
        case '.*':      //  stdout (and iterate shorthand)
        case '.|?':     //  stdout (and filter)
        case '.?':      //  stdout (and filter shorthand)
        case '.|?*':    //  stdout (iterate and filter)
        case '.?*':     //  stdout (iterate and filter shorthand)
        case '.|%':     //  stdout (and format)
        case '.%':      //  stdout (and format shorthand)
        case '.|%*':    //  stdout (iterate and format)
        case '.%*':     //  stdout (iterate and format shorthand)

            name = TP.STDOUT;
            break;

        case '.&':      //  stderr
        case '.&*':     //  stderr (and iterate)
        case '.&?':     //  stderr (and filter)
        case '.&%':     //  stderr (and format)
        case '.&?*':    //  stderr (iterate and filter)
        case '.&%*':    //  stderr (iterate and format)

            name = TP.STDERR;
            break;

        case '.|&':     //  both
        case '.|&*':    //  both (and iterate)
        case '.|&?':    //  both (and filter)
        case '.|&%':    //  both (and format)
        case '.|&?*':   //  both (iterate and filter)
        case '.|&%*':   //  both (iterate and format)

            name = TP.STDIO;
            break;

        //  ---
        //  conditional execution
        //  ---

        case '.||':
        case '.&&':

            //  these are somewhat indeterminate since the symbol itself
            //  doesn't tell us anything regarding stdout vs. stderr
            //  from the prior command...
            name = TP.STDOUT;
            break;

        //  ---
        //  input redirections
        //  ---

        case '.<':      //  stdin
        case '.<!':     //  stdin with refresh
        case '.<<':     //  here document

            //  no reason to think these should leverage either stdout
            //  or stderr from the "prior" command since they're really
            //  somewhat orthagonal to commands other than the one they
            //  feed their data to
            name = TP.STDOUT;
            break;

        //  ---
        //  output redirections
        //  ---

        case '.>':      //  stdout
        case '.>!':
        case '.>>':     //  stdout with append
        case '.>>!':

            name = TP.STDOUT;
            break;

        case '.&>':     //  stderr
        case '.&>!':
        case '.&>>':    //  stderr with append
        case '.&>>!':

            name = TP.STDERR;
            break;

        case '.>&':     //  both
        case '.>&!':
        case '.>>&':    //  both with append
        case '.>>&!':

            name = TP.STDIO;
            break;

        default:        //  bad symbol or no pipe attribute

            break;
    }

    //  two potential sources for data here...the stdout/stderr methods
    //  which write into a pipe (.|, .&, etc) upon completion of the
    //  previous command's execution...and any input redirections for the
    //  current command which have been run prior to invoking the command

    //  if there's a buffer name provided then we know we've downstream from
    //  some pipe that should provide stdout, stderr, or both as our input.
    //  Depending on the nature of that pipe it may be stored in our cmdLast
    //  or cmdRequest slot (cmdRequest when output redirection).
    if (TP.notEmpty(name)) {
        last = this.at('cmdLast') || this.at('cmdRequest');
        if (TP.isValid(last)) {
            buffer = last.at(name);
        } else {
            peer = this.at('cmdPeer');
            if (TP.isValid(peer)) {
                buffer = peer.at(TP.STDIN);
            }
        }
    }

    //  make sure we always at least have an empty buffer by this point.
    //  this may happen either because we're the first command (so cmdLast
    //  is empty) or because we're not being piped to. either way we need to
    //  be ready to process any input redirections.
    if (TP.notValid(buffer)) {
        buffer = TP.ac();
    }

    index = 0;
    for (;;) {
        if (TP.notDefined(value = this.at('$_' + index))) {
            break;
        }

        buffer.push(value);
        index += 1;
    }

    //  cache for recall
    this.atPut(TP.STDIN, buffer);

    return buffer;
});

//  ------------------------------------------------------------------------

TP.sig.TSHRunRequest.Inst.defineMethod('stdout',
function(output, request) {

    /**
     * @method stdout
     * @summary Standard function for writing valid output during shell
     *     execution.
     * @param {Object} output The object to write to stdout.
     * @param {TP.sig.Request|TP.core.Hash} request Optional request/parameters.
     *     Defaults to the receiver.
     */

    var req,
        node,
        asIs,
        buffer,
        buffered,

        start,
        end;

    //  merge keys when we get extra parameters via the request/hash.
    req = TP.isValid(request) ?
            this.getPayload().addAll(request.getPayload()) :
            this;

    //  write to the stdout "buffer" array if it's defined for us
    if (TP.isValid(buffer = this.at(TP.STDOUT))) {
        buffered = true;
        buffer.push(output);
    }

    //  write to the stdio "buffer" array (stdout + stderr) if provided
    if (TP.isValid(buffer = this.at(TP.STDIO))) {
        buffered = true;
        buffer.push(output);
    }

    //  last update wins relative to our "result" but we update it here
    this.set('result', output, null, true);

    //  if we're buffering into one or more arrays then we don't output to
    //  the shell and/or $stderr function, we've been redirected to buffer
    if (buffered) {
        //  IFF we're buffering then we're being piped, in which case the
        //  output here is input for a downstream process/command.
        return;
    }

    //  second "common flag" is the -asis flag telling us to skip
    //  formatting the output any further
    node = this.at('cmdNode');
    asIs = TP.ifEmpty(TP.elementGetAttribute(node, 'tsh:asis', true),
                        req.at('cmdAsIs'));

    if (TP.notEmpty(asIs)) {
        asIs = TP.bc(asIs);
        req.atPut('cmdAsIs', asIs);
    }

    //  Compute the tagtime from the cmdStart & cmdEnd
    if (TP.isNumber(start = req.at('cmdStart')) &&
        TP.isNumber(end = req.at('cmdEnd'))) {
        this.$set('$tagtime', end - start);
    }

    //  we don't recheck output after whatever formatting we may have done,
    //  the shell/console routines will do that and complain as needed.
    return this.at('rootRequest').stdout(output, req);
});

//  ========================================================================
//  TSHRunResponse
//  ========================================================================

TP.sig.ShellResponse.defineSubtype('TSHRunResponse');

//  ========================================================================
//  TP.tsh.RunService
//  ========================================================================

/**
 * @type {TP.tsh.RunService}
 * @summary The primary "working service" for execution of TSH scripts.
 */

TP.core.Service.defineSubtype('tsh.RunService');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  What type of signal do we react to?
TP.tsh.RunService.Type.defineAttribute(
    'triggers', TP.ac(TP.ac(TP.ANY, 'TP.sig.TSHRunRequest')));

TP.tsh.RunService.register();

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.tsh.RunService.Inst.defineHandler('TSHRunRequest',
function(aRequest) {

    /**
     * @method handleTSHRunRequest
     * @summary Processes individual execution requests, dispatching the
     *     request to the proper targeting method so that command tags can
     *     implement fine-grained processing logic easier.
     * @param {TP.sig.TSHRunRequest} aRequest The request instance to process.
     */

    var node,
        shell,
        cmdns,
        nodetype,

        tagname,
        parts,
        prefix,
        fname,

        type,

        start,
        pipe,
        async;

    aRequest.isActive(true);

    node = aRequest.at('cmdNode');
    shell = aRequest.at('cmdShell');

    if (TP.sys.cfg('log.tsh_run')) {
        TP.ifTrace() ?
            TP.trace('tsh_run:\n' + TP.str(node)) : 0;
    }

    //  capture the current command prefix for defaulting purposes.
    cmdns = shell.getType().get('commandPrefix');

    //  make sure we're processing the right kind of node...element or PI.
    nodetype = node.nodeType;
    if (nodetype !== Node.ELEMENT_NODE &&
        nodetype !== Node.PROCESSING_INSTRUCTION_NODE) {
        aRequest.fail();
        return;
    }

    //  a few cases here, external action tags, tags that represent
    //  built-ins, or embedded markup. we look for built-ins first, which
    //  implies you can't replace a built-in with an external tag definition
    pipe = TP.elementGetAttribute(node, 'tsh:pipe', true);
    pipe = TP.isEmpty(pipe) ? pipe : TP.xmlEntitiesToLiterals(pipe);

    //  update the request with any command flags for iteration and
    //  storage/commit that may be on the symbol
    if (TP.notEmpty(pipe)) {
        if (pipe.indexOf('*') !== TP.NOT_FOUND) {
            aRequest.atPut('cmdIterate', true);
        }

        //  ! means either commit or refresh depending on source vs. sink
        if (pipe.indexOf('!') !== TP.NOT_FOUND) {
            aRequest.atPut('cmdCommit', true);
            aRequest.atPut('cmdRefresh', true);
        }

        //  map the basic pipe symbols into a common action type
        if (pipe.indexOf('>>') !== TP.NOT_FOUND) {
            aRequest.atPut('cmdAction', TP.ADD);
        } else if (pipe.indexOf('<') !== TP.NOT_FOUND) {
            aRequest.atPut('cmdAction', TP.GET);
        } else if (pipe.indexOf('>') !== TP.NOT_FOUND) {
            aRequest.atPut('cmdAction', TP.SET);
        } else if (pipe.indexOf('?') !== TP.NOT_FOUND) {
            aRequest.atPut('cmdAction', TP.FILTER);
        } else {
            aRequest.atPut('cmdAction', TP.TRANSFORM);
        }
    }

    async = TP.elementGetAttribute(node, 'tsh:async', true);
    async = TP.isEmpty(async) ? false : TP.bc(async);
    aRequest.atPut('async', async);

    //  TODO:   this will need verification for PIs
    tagname = TP.qname(node);
    parts = tagname.split(':');
    prefix = parts.at(0);
    if (prefix === cmdns) {
        //  prefix matches, may be a built in
        fname = 'execute' +
                TP.makeStartUpper(shell.translateSymbol(parts.at(1)));

        if (TP.canInvoke(shell, fname)) {
            start = Date.now();
            aRequest.atPut('cmdStart', start);

            //  Configure the default stdin values for the most typical
            //  case, no splatting and at most a single object in stdin
            //  buffer.
            shell.updateExecutionInstance(aRequest);

            //  NOTE that we invoke the built-in here and rely entirely on
            //  that to fail/complete
            shell[fname](aRequest);

            return;
        }

        //  clear any leftovers before we fall through
        fname = null;
    }

    //  doesn't match the shell prefix and/or isn't a built-in,
    //  so we move on to specific external tag types.
    type = TP.sys.getTypeByName(tagname);
    if (TP.notValid(type)) {
        aRequest.at('rootRequest').stderr('Invalid command: ' +
            tagname + '. Try ? or :help.', aRequest);
        aRequest.fail();
        return;
    }

    /* eslint-disable no-fallthrough */
    switch (pipe) {
        case '.|':
        case '.|*':
        case '.*':

        case '.&':
        case '.&*':

        case '.|&':
        case '.|&*':

        case '.%':
        case '.%*':

        case '.|%':
        case '.|%*':

        case '.&%':
        case '.&%*':

        case '.|&%':
        case '.|&%*':

            if (TP.canInvoke(type, 'cmdTransformInput')) {
                fname = 'cmdTransformInput';
            }
            break;

        case '.?':
        case '.?*':

        case '.|?':
        case '.|?*':

        case '.&?':
        case '.&?*':

        case '.|&?':
        case '.|&?*':

            if (TP.canInvoke(type, 'cmdFilterInput')) {
                fname = 'cmdFilterInput';
            }
            break;

        case '.>':
        case '.>!':

        case '.&>':
        case '.&>!':

        case '.>&':
        case '.>&!':

            //  temporary sink, set content, but no commit
            if (TP.canInvoke(type, 'cmdSetContent')) {
                fname = 'cmdSetContent';
            }
            break;

        case '.>>':
        case '.>>!':

        case '.&>>':
        case '.&>>!':

        case '.>>&':
        case '.>>&!':

            //  temporary sink via append
            if (TP.canInvoke(type, 'cmdAddContent')) {
                fname = 'cmdAddContent';
            }
            aRequest.atPut('cmdAppend', true);
            break;

        case '.<':      //  stdin
        case '.<!':     //  stdin with refresh
        case '.<<':     //  here document

            if (TP.canInvoke(type, 'cmdGetContent')) {
                fname = 'cmdGetContent';
            }
            break;

        default:

            //  conditional, or perhaps no pipe at all.
            break;
    }
    /* eslint-enable no-fallthrough */

    //  set a start time for "tag exec" before taking the final step
    start = Date.now();
    aRequest.atPut('cmdStart', start);

    //  if we didn't set it to something more specific up above then see if
    //  we can invoke the default execution phase method.
    if (TP.isEmpty(fname)) {
        fname = 'cmdRunContent';
    }

    if (!TP.canInvoke(type, fname)) {
        aRequest.at('rootRequest').stderr('Unable to execute ' +
            tagname + '.' + fname, aRequest);
        aRequest.fail();
        return;
    }

    //  Configure the default stdin values for the most typical case, no
    //  splatting and at most a single object in stdin buffer.
    shell.updateExecutionInstance(aRequest);

    //  trigger the command function and let it complete/fail/etc.
    type[fname](aRequest);

    //  return a break to keep from having shell loop descend into children
    return TP.BREAK;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.uri.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.uri}
 * @summary Provides support for the TIBET Shell (TSH) processing of URIs for
 *     input and output redirection and piping.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:uri');

TP.tsh.uri.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.uri.Type.defineMethod('cmdAddContent',
function(aRequest) {

    /**
     * @method cmdAddContent
     * @summary Invoked by the TSH when the receiver is the data sink for a
     *     command sequence which is piping data to the receiver using an
     *     appending operation such as .>>.
     * @description On this type, this method merely invokes 'cmdRunContent'
     *     against the receiver.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    return this.cmdRunContent(aRequest);
});

//  ------------------------------------------------------------------------

TP.tsh.uri.Type.defineMethod('cmdFilterInput',
function(aRequest) {

    /**
     * @method cmdFilterInput
     * @summary Invoked by the TSH when the receiver is a segment in a pipe
     *     where the implied operation is to filter standard input using a
     *     filter operation such as .|?.
     * @description On this type, this method merely invokes 'cmdRunContent'
     *     against the receiver.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    return this.cmdRunContent(aRequest);
});

//  ------------------------------------------------------------------------

TP.tsh.uri.Type.defineMethod('cmdGetContent',
function(aRequest) {

    /**
     * @method cmdGetContent
     * @summary Invoked by the TSH when the receiver is the data source for a
     *     command sequence which is piping data from the receiver.
     * @description On this type, this method merely invokes 'cmdRunContent'
     *     against the receiver.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    return this.cmdRunContent(aRequest);
});

//  ------------------------------------------------------------------------

TP.tsh.uri.Type.defineMethod('cmdRunContent',
function(aRequest) {

    /**
     * @method cmdRunContent
     * @summary Runs the receiver, effectively invoking its action. For
     *     TP.tsh.uri this method is responsible for dispatching all the
     *     variations of pipe methods which are suitable for use with a URI.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     */

    var shell,
        node,
        body,

        href,
        url,

        params,
        stdin,

        attrs,
        len,
        i,
        item,
        name,
        value,
        resolvedValue;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    node = aRequest.at('cmdNode');
    body = TP.nodeGetTextContent(node);

    //  during desugaring we place the original href value into a 'tsh:'
    //  prefixed href parameter for easier filtering. If this parameter
    //  isn't found this isn't a valid URI tag.

    //  NB: Note how we supply 'null' as a default value for 'tsh:href'
    href = shell.getArgument(aRequest, 'tsh:href', null, true);
    if (TP.isEmpty(href)) {
        aRequest.fail('Invalid href for URI');

        return;
    }

    //  presuming we have an href value we need to confirm we can construct
    //  a viable URI instance from it. If not then we've got another error.
    url = TP.uc(href);
    if (TP.notValid(url)) {
        aRequest.fail('Badly formed href for URI');

        return;
    }

    //  URI is the only parameter we rename beyond simply removing the
    //  tsh: prefixing, so construct the base parameter hash with that
    //  one.
    params = TP.hc('uri', href);

    //  all parameters should be named, those with tsh: prefixes are used
    //  by the enclosing request.
    attrs = shell.getArguments(aRequest).getItems();
    len = attrs.getSize();
    for (i = 0; i < len; i++) {
        item = attrs.at(i);
        name = item.first();
        value = item.last();

        switch (name) {
            case 'tsh:pipe':
                params.atPut('pipe', value);
                break;

            //  Communication layer parameters
            case 'tsh:href':
                //  Already processed.
                break;
            case 'tsh:method':
                params.atPut('method', value.toUpperCase());
                break;
            case 'tsh:mimetype':
                params.atPut('mimetype', value);
                break;
            case 'tsh:async':
                params.atPut('async', TP.bc(value));
                break;
            case 'tsh:refresh':
                params.atPut('refresh', TP.bc(value));
                break;
            case 'tsh:timeout':
                if (TP.isNumber(resolvedValue = parseInt(value, 10))) {
                    resolvedValue = resolvedValue.asDuration();
                }
                params.atPut('timeout',
                                Date.getMillisecondsInDuration(resolvedValue));
                break;
            case 'tsh:encoding':
                params.atPut('encoding', value);
                break;
            case 'tsh:separator':
                params.atPut('separator', value);
                break;
            case 'tsh:noencode':
                params.atPut('noencode', TP.bc(value));
                break;
            case 'tsh:watch':
                url.watch();
                break;
            case 'tsh:unwatch':
                url.unwatch();
                break;
            default:

                //  We don't process 'tsh:' arguments beyond the ones handled
                //  above, nor do we process the 'ARGV' 'special' argument.
                if (/^(tsh:|ARGV)/.test(name)) {
                    continue;
                }

                resolvedValue = shell.resolveObjectReference(value, aRequest);

                params.atPut(name, resolvedValue);

                break;
        }
    }

    //  if there is an explicit body set via something like .[[ content .]]
    //  then we capture that as the content of the impending request. inline
    //  content is always processed first, then potentially overwritten by
    //  input redirections and/or piping of stdio.
    if (TP.notEmpty(body)) {
        params.atPut('body', body);

        //  when provided with inline content the first step is always to
        //  set that as the new content for the URI
        url.setResource(body);
    }

    //  inline content can be overwritten by input redirection provided
    //  there was an input redirect or "here document" for the new content.
    //  Note that there could potentially be multiples here...and the last
    //  one wins up through a maximum of 9.
    i = 9;
    stdin = aRequest.stdin();
    while (i > 0) {
        body = stdin.at(i);
        if (TP.isValid(body)) {
            params.atPut('body', body);
            url.setResource(body);
            break;
        }
        i--;
    }

    //  Now that we've gathered all of the parameters and the body, call the core
    //  TP.uri.URI's 'cmdRunContent' manually to do the work.

    //  First, though, put the URL instance that we've generated so that
    //  cmdRunContent (a type method) can find it and use it.
    aRequest.atPut('cmdInstance', url);

    //  Also, supply any parameters that we've captured on the command line or
    //  in our body with a unique key that tells that method where these
    //  parameters are coming from.
    aRequest.atPut('TP.tsh.uri.params', params);

    //  Call cmdRunContent and supply the kind of redirection that was supplied
    //  (if any). This will be one of: TP.GET, TP.SET, TP.FILTER, TP.TRANSFORM,
    //  TP.ADD or TP.NONE.
    TP.uri.URI.cmdRunContent(aRequest, TP.wrap(node).getRedirectionType());

    return;
});

//  ------------------------------------------------------------------------

TP.tsh.uri.Type.defineMethod('cmdSetContent',
function(aRequest) {

    /**
     * @method cmdSetContent
     * @summary Invoked by the TSH when the receiver is the data sink for a
     *     command sequence which is piping data to the receiver using a simple
     *     set operation such as .>
     * @description On this type, this method merely invokes 'cmdRunContent'
     *     against the receiver.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    return this.cmdRunContent(aRequest);
});

//  ------------------------------------------------------------------------

TP.tsh.uri.Type.defineMethod('cmdTransformInput',
function(aRequest) {

    /**
     * @method cmdTransformInput
     * @summary Invoked by the TSH when the receiver is a segment in a pipe
     *     where the implied operation is to transform standard input using a
     *     simple transform operation such as .|
     * @description On this type, this method merely invokes 'cmdRunContent'
     *     against the receiver.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    return this.cmdRunContent(aRequest);
});

//  ------------------------------------------------------------------------

TP.tsh.uri.Type.defineMethod('tshCompile',
function(aRequest) {

    /**
     * @method tshCompile
     * @summary Convert the receiver into a format suitable for inclusion in a
     *     markup DOM.
     * @param {TP.sig.ShellRequest} aRequest The request containing command
     *     input for the shell.
     * @returns {Array<Node,Number>} An array containing the new node and a TSH
     *     loop control constant, TP.DESCEND by default.
     */

    var node,
        newNode;

    //  NB: DO NOT CHANGE THIS METHOD TO BE 'tagCompile' UNTIL THE SHELL HAS
    //  BEEN CHANGED TO USE THE TAG PROCESSOR RATHER THAN IT'S OWN TAG
    //  PROCESSING MACHINERY (AT LEAST FOR COMPILATION).

    //  Don't copy attributes with defaulting of namespaces, just leave them
    //  as they were input.
    node = aRequest.at('cmdNode');
    newNode = TP.elementBecome(
                    node,
                    'code',
                    TP.hc('class', 'tibet-action'),
                    TP.w3.Xmlns.XHTML);

    return TP.ac(newNode, TP.DESCEND);
});

//  ------------------------------------------------------------------------

TP.tsh.uri.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver.
     * @param {TP.sig.Request} aRequest The request containing command
     *     input for the shell.
     * @returns {Number} A TSH shell loop control constant which controls how
     *     the outer TSH processing loop should continue. Common values are
     *     TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    return this.cmdRunContent(aRequest);
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.apropos.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.apropos}
 * @summary A subtype of TP.tag.ActionTag that knows how to
 *     conditionally process its child actions based on a binding expression.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:apropos');

TP.tsh.apropos.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.apropos.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,
        methods,
        terms,
        limit,
        comments,
        ignorecase,
        minified,
        byName,
        byComments,
        results;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    //  No arguments means we dump usage.
    if (!shell.hasArguments(aRequest)) {
        return this.printUsage(aRequest);
    }

    terms = shell.getArgument(aRequest, 'ARGV');
    limit = Math.max(1, shell.getArgument(aRequest, 'tsh:limit', 2));
    comments = shell.getArgument(aRequest, 'tsh:comments', false);
    ignorecase = shell.getArgument(aRequest, 'tsh:ignorecase', true);

    //  Convert terms into regular expressions if possible. Otherwise use the
    //  original term and we'll try indexOf during checking.
    terms = terms.map(
                function(term) {
                    var regex,
                        str,
                        parts;

                    //  Use a global regex so we can capture counts which form a
                    //  basis for determining which matches are most relevant.
                    str = term.unquoted();
                    parts = TP.stringRegExpComponents(str);
                    if (TP.notTrue(/g/.test(parts[1]))) {
                        parts[1] += 'g';
                    }

                    if (TP.notFalse(ignorecase)) {
                        parts[1] += 'i';
                    }

                    regex = RegExp.construct(parts[0], parts[1]);
                    if (TP.notValid(regex)) {
                        return str;
                    }
                    return regex;
                });

    byName = TP.ac();
    byComments = TP.ac();

    methods = TP.sys.getMetadata('methods');
    methods.perform(
            function(item) {
                var name,
                    method,
                    nameMatch,
                    func,
                    text,
                    file,
                    ands,
                    count;

                //  Metadata stores methods as Owner_Track_Name so split here.
                name = item.at(0);
                method = name.split('_').last();

                func = item.at(1);

                //  Note how we go after load path and not source path. Load
                //  path is where the code was actually loaded from, which may
                //  vary from sourcePath when working with minified code.
                file = TP.objectGetLoadPath(func);
                text = comments ? func.getCommentText() : '';

                //  When there's no comment text in the method body we need to
                //  know if that's because it's minified or not.
                if (TP.isEmpty(text)) {
                    if (TP.notEmpty(file) && file.match(/\.min\./)) {
                        minified = true;
                    }
                }

                ands = 0;
                count = 0;

                //  When we have multiple terms we want to treat them as an AND
                //  condition (since you can easily do OR via RegExp).
                terms.forEach(
                        function(term) {
                            var parts,
                                found,
                                match;

                            if (TP.isString(term)) {
                                //  Split the comment using the string. The
                                //  number of parts represents one more than the
                                //  number of times that string was in the text.
                                parts = text.split(term);
                                count += parts.getSize() - 1;

                                if (method.indexOf(term) !== TP.NOT_FOUND) {
                                    nameMatch = true;
                                    count += 1;
                                    ands += 1;
                                }

                            } else {
                                //  Our regular expressions are global so
                                //  they'll provide a match count for the total
                                //  string.
                                match = term.match(text);
                                if (TP.isValid(match)) {
                                    count += match.getSize();
                                    found = true;
                                    ands += 1;
                                }

                                match = term.match(method);
                                if (TP.isValid(match)) {
                                    nameMatch = true;
                                    count += match.getSize();

                                    //  If we haven't already counted this term
                                    //  count it as having matched.
                                    if (!found) {
                                        ands += 1;
                                    }
                                }
                            }
                        });

                if (ands !== terms.getSize()) {
                    return;
                }

                if (nameMatch) {
                    byName.push(TP.ac(name, count, true));
                } else if (count >= limit) {
                    byComments.push(TP.ac(name, count, false));
                }
            });

    //  Convert common encodings back into proper form for reflection.
    byName = byName.map(function(pair) {
        return pair.atPut(0, pair.at(0).replace('_Primitive_', '.').replace(
                '_Type_', '.Type.').replace('_Inst_', '.Inst.'));
    });

    byComments = byComments.map(function(pair) {
        return pair.atPut(0, pair.at(0).replace('_Primitive_', '.').replace(
            '_Type_', '.Type.').replace('_Inst_', '.Inst.'));
    });

    //  The name matches come first but we still want to sort them by any
    //  additional count information they may have.
    byName = byName.sort(
                function(a, b) {
                    if (a[1] < b[1]) {
                        return 1;
                    } else if (a[1] > b[1]) {
                        return -1;
                    } else {
                        //  counts match, order by character sequencing
                        if ([a, b].sort()[1] === b) {
                            return -1;
                        } else {
                            return 0;
                        }
                    }
                });

    //  Sort comment-based matches by count. We'll append this list to the name
    //  matches for the output sequence.
    byComments = byComments.sort(
                    function(a, b) {
                        if (a[1] < b[1]) {
                            return 1;
                        } else if (a[1] > b[1]) {
                            return -1;
                        } else {
                            //  counts match, order by character sequencing
                            if ([a, b].sort()[1] === b) {
                                return -1;
                            } else {
                                return 0;
                            }
                        }
                    });

    //  Throw some separator content into the output between chunks...
    byName.unshift(TP.ac('#', 0));
    byName.unshift(TP.ac('# by name', 0));
    byName.unshift(TP.ac('', 0));

    if (comments) {
        byName.push(TP.ac('#', 0));
        byName.push(TP.ac('# by comment', 0));
        byName.push(TP.ac('#', 0));
        results = byName.concat(byComments);
    } else {
        results = byName;
    }

    results = results.map(
                function(result) {
                    var str;

                    str = result.at(0);
                    if (comments && result.at(1) >= limit) {
                        str += ' (' + result.at(1) + ')';
                    }

                    return str;
                });

    //  If we found any minified source along the way point that out.
    if (minified) {
        results.unshift(
            'Partial results. Some package@config files were minified.');
    }

    //  Headless/CLI support requires output line-by-line.
    if (TP.sys.cfg('boot.context') === 'headless') {

        results.forEach(
                function(result) {
                    aRequest.stdout(result);
                });

        aRequest.complete('');
        return aRequest;
    }

    //  Filter blank lines and comment output
    aRequest.complete(results.join('\n'));

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('apropos',
    TP.tsh.apropos.Type.getMethod('tshExecute'),
    'List methods related to a topic.',
    ':apropos [--comments] [--limit=N] [--ignorecase[=true|false]] [--no-ignorecase] <terms>',
    'See CLI documentation');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.as.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.as}
 * @summary A subtype of TP.tag.ActionTag that takes stdin data and formats
 *     is via typical TIBET as() processing.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:as');

TP.tsh.as.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.as.Type.defineMethod('cmdTransformInput',
function(aRequest) {

    /**
     * @method cmdTransformInput
     * @summary Invoked by the TSH when the receiver is a segment in a pipe
     *     where the implied operation is to transform standard input using a
     *     simple transform operation such as .|
     * @description On this type, this method merely invokes 'cmdRunContent'
     *     against the receiver.
     * @param {TP.sig.Request} aRequest The shell request being processed.
     */

    return this.tshExecute(aRequest);
});

//  ------------------------------------------------------------------------

TP.tsh.as.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Executes a formatting or template transformation operation on
     *     the current value of stdin.
     * @param {TP.sig.ShellRequest} aRequest The request containing command
     *     input.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,
        node,
        format,
        input,
        repeat,
        len,
        i,
        item,
        result;

    shell = aRequest.at('cmdShell');

    if (TP.notValid(node = aRequest.at('cmdNode'))) {
        return aRequest.fail();
    }

    //  'input' cannot be empty.
    if (TP.isEmpty(input = aRequest.stdin())) {
        return aRequest.fail(
            'Unable to find input for: ' + TP.str(node));
    }

    //  get our primary argument by adding true to our lookup call
    //  NB: We supply 'null' as the default value if 'tsh:format' wasn't
    //  specified.
    format = shell.getArgument(aRequest, 'tsh:format', null, true);

    //  'format' might be null, but we still do the work in case 'repeat' was
    //  specified or the -asis flag was specified. In this case, the
    //  'TP.format()' call below will just hand back the original object.

    //  NB: We supply 'false' as the default value if 'tsh:repeat' wasn't
    //  specified.
    repeat = shell.getArgument(aRequest, 'tsh:repeat', false);

    /* eslint-disable no-loop-func */

    len = input.getSize();
    for (i = 0; i < len; i++) {
        item = input.at(i);
        if (TP.isTrue(aRequest.at('cmdIterate'))) {
            if (TP.canInvoke(item, 'collect')) {
                result = item.collect(
                            function(it) {

                                return TP.format(
                                            it,
                                            format,
                                            TP.hc('repeat', repeat));
                            });
            } else {
                result = TP.format(item, format, TP.hc('repeat', repeat));
            }
        } else {
            result = TP.format(item, format, TP.hc('repeat', repeat));
        }

        //  If the output object is a String and starts with markup and contains
        //  non-native markup anywhere, then frame it.
        if (TP.isString(result) &&
            TP.regex.STARTS_WITH_ELEM_MARKUP.test(result) &&
            !TP.w3.Xmlns.isNativeMarkup(result)) {
            aRequest.atPut('cmdFramed', true);
        }

        aRequest.stdout(result);
    }

    /* eslint-enable no-loop-func */

    aRequest.complete();

    return aRequest;
});

//  ------------------------------------------------------------------------
//
TP.shell.TSH.addHelpTopic('as',
    TP.tsh.as.Type.getMethod('tshExecute'),
    'Transforms stdin and writes it to stdout.',
    ':as',
    '');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.audit.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.audit}
 * @summary A subtype of TP.tag.ActionTag that knows how to
 *     conditionally process its child actions based on a binding expression.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:audit');

TP.tsh.audit.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.audit.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,

        arg0,

        obj,

        results,

        astCache,
        unusedRules;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    //  No arguments means we dump usage.
    if (!shell.hasArguments(aRequest)) {
        return this.printUsage(aRequest);
    }

    arg0 = shell.getArgument(aRequest, 'ARG0');
    if (TP.isString(arg0)) {
        arg0 = arg0.unquoted();
    }

    //  First attempt to resolve the target as a specific object name.
    obj = shell.resolveObjectReference(arg0, aRequest);

    if (TP.notValid(obj)) {
        aRequest.stdout('Invalid document reference: ' + arg0);

        return aRequest.complete(TP.TSH_NO_VALUE);
    }

    obj = TP.unwrap(obj);

    if (!TP.isDocument(obj)) {
        aRequest.stdout('Invalid document reference: ' + arg0);

        return aRequest.complete(TP.TSH_NO_VALUE);
    }

    results = '';

    astCache = TP.hc();

    unusedRules = TP.documentGetUnusedStyleRules(obj);
    unusedRules.forEach(
            function(aRule) {
                var ruleInfo,

                    position,

                    source,
                    start,
                    end;

                ruleInfo = TP.styleRuleGetSourceInfo(aRule, astCache);

                if (TP.isEmpty(ruleInfo)) {
                    results += 'No rule info for: ' + TP.dump(aRule) + '\n\n';
                    return;
                }

                if (TP.notValid(position = ruleInfo.at('position'))) {
                    return;
                }

                source = position.at('source');

                start = position.at('start');
                end = position.at('end');

                results += 'Rule: ' + ruleInfo.at('selectors').join(',') +
                            ' @ ' + source + ':' +
                            start.at('line') + ',' + start.at('column') +
                            '...' +
                            end.at('line') + ',' + end.at('column') +
                            '\n';
            });

    aRequest.complete(results);

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('audit',
    TP.tsh.audit.Type.getMethod('tshExecute'),
    'Scans unused document style rules.',
    ':audit <document>',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.bookmark.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.bookmark}
 * @summary A subtype of TP.tag.ActionTag that knows how to
 *     conditionally process its child actions based on a binding expression.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:bookmark');

TP.tsh.bookmark.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.bookmark.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing path input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,

        arg0,
        arg1,

        isRemove,
        isRemoveAll,

        bookmarks,
        bookmarkNum,
        bookmark,

        path,
        description,

        defaultStr,
        descriptionReq;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    //  This command only works in the context of a loaded and enabled Lama
    if (!TP.sys.hasFeature('lama')) {
        aRequest.stdout(
                'The :bookmark command requires a loaded and enabled Lama');
        aRequest.complete(TP.TSH_NO_VALUE);

        return aRequest;
    }

    arg0 = shell.getArgument(aRequest, 'ARG0');
    arg1 = shell.getArgument(aRequest, 'ARG1');

    isRemove = shell.getArgument(aRequest, 'tsh:remove', false);
    isRemoveAll = shell.getArgument(aRequest, 'tsh:removeall', false);

    bookmarks = TP.uc('urn:tibet:lama_bookmarks').getResource().get('result');

    //  First form - remove all bookmarks:
    //  :bookmark --removeall

    if (TP.isTrue(isRemoveAll)) {
        bookmarks.empty();

        aRequest.stdout('all bookmarks removed');
        aRequest.complete(TP.TSH_NO_VALUE);

        return aRequest;
    }

    //  Second form - remove the 3rd bookmark:
    //  :bookmark --remove 3

    bookmarkNum = TP.nc(arg0);
    if (TP.isTrue(isRemove)) {
        if (TP.isNumber(bookmarkNum)) {
            bookmark = bookmarks.at(bookmarkNum);

            bookmarks.remove(bookmark);

            aRequest.stdout('bookmark removed: ' + bookmark.first());
            aRequest.complete(TP.TSH_NO_VALUE);
        } else {
            aRequest.stdout('bookmark removal requires numeric index');
            aRequest.complete(TP.TSH_NO_VALUE);
        }

        return aRequest;
    }

    path = arg0;
    description = arg1;

    //  Third form - add the bookmark and prompt for the description
    //  :bookmark 'pathPart1/pathPart2'

    if (TP.isEmpty(description) && TP.notEmpty(path)) {

        if (TP.notEmpty(path)) {

            defaultStr = 'Description for bookmark';
            descriptionReq = TP.sig.UserInputRequest.construct(
                                    TP.hc('query', 'Bookmark description:',
                                            'default', defaultStr,
                                            'select', true,
                                            'async', true));

            //  response comes as a TP.sig.UserInput signal, so add a local
            //  handler
            descriptionReq.defineHandler(
                'UserInput',
                function(aSignal) {

                    var descriptionResult,
                        invalidDescriptionReq,
                        validDescriptionReq;

                    //  do this so the triggering request clears the queue
                    if (TP.isValid(aSignal.getRequest().get('responder'))) {
                        aSignal.getRequestID().signal(
                                                'TP.sig.RequestCompleted');
                    }

                    descriptionResult = aSignal.getResult();

                    //  if the response wasn't adequate we can deal with that by
                    //  simply reporting via an output request
                    /* eslint-disable no-extra-parens */
                    if (TP.isEmpty(descriptionResult)) {
                    /* eslint-enable no-extra-parens */

                        invalidDescriptionReq =
                            TP.sig.UserOutputRequest.construct(
                                TP.hc('output', 'Invalid bookmark description',
                                        'async', true));

                        invalidDescriptionReq.isError(true);
                        invalidDescriptionReq.fire(shell);
                    } else {

                        bookmarks.add(TP.ac(path, descriptionResult));

                        validDescriptionReq =
                            TP.sig.UserOutputRequest.construct(
                                TP.hc(
                                'output', 'Bookmark to: "' + path + '" added',
                                'async', true));

                        validDescriptionReq.fire(shell);
                    }

                    //  Make sure to complete the original request to keep
                    //  everything in sync with the shell.
                    aRequest.complete(TP.TSH_NO_VALUE);

                    return;
                });

            //  first-stage request (description) and response handler are
            //  defined so initiate the sequence, using the shell as the
            //  originator
            descriptionReq.fire(shell);
        }

        //  Note how we do *not* complete the request before returning... we
        //  complete it in the handler above.
        return aRequest;
    }

    //  Last form - add the bookmark from scratch:
    //  :bookmark 'pathPart1/pathPart2' 'This is a cool bookmark'

    //  If either argument is empty, we dump usage.
    if (TP.isEmpty(path) || TP.isEmpty(description)) {
        return this.printUsage(aRequest);
    }

    bookmarks.add(TP.ac(path, description));
    aRequest.stdout('Bookmark to: "' + path + '" added');

    aRequest.complete(TP.TSH_NO_VALUE);

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('bookmark',
    TP.tsh.bookmark.Type.getMethod('tshExecute'),
    'Allows addition and removal of commonly used bookmarks of the Lama' +
        ' Inspector.',
    ':bookmark --removeall\n' +
    ':bookmark [--remove=N]\n' +
    ':bookmark <path>\n' +
    ':bookmark <path> <description>',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.build.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.build}
 * @summary A subtype of TP.tag.ActionTag used to trigger a build.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:build');

TP.tsh.build.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.build.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell;

    shell = aRequest.at('cmdShell');

    TP.signal(null, 'RemoteConsoleCommand',
        TP.hc(
            'originalRequest', aRequest,
            'timeout', 60000,
            TP.ONSUCCESS, function(aResponse) {

                var linkOutputReq,
                    locStr;

                //  Grab the location and trim off any trailing '/'.

                locStr = TP.uc('~app').getLocation();
                if (locStr.endsWith('/')) {
                    locStr = locStr.slice(0, -1);
                }

                //  Construct a UserOutputRequest, with our location wrapped in
                //  an anchor targeting a blank page.
                linkOutputReq =
                    TP.sig.UserOutputRequest.construct(
                        TP.hc(
                        'output',
                            'Click to launch your app: ' +
                            '<a href="' + locStr + '" target="_blank">' +
                            locStr +
                            '</a>',
                        'async', true,
                        'cmdAsIs', true));

                linkOutputReq.fire(shell);
            },
            TP.ONFAIL, function(aResponse) {
                //  empty
            }
        ));

    aRequest.complete('delegated to :cli');

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('build',
    TP.tsh.build.Type.getMethod('tshExecute'),
    'Builds a release of a TIBET application.',
    ':build',
    'See CLI documentation');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.colors.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.colors}
 * @summary A subtype of TP.tag.ActionTag that knows how to
 *     conditionally process its child actions based on a binding expression.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:colors');

TP.tsh.colors.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.colors.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    aRequest.stdout('Coming soon.');

    aRequest.complete(TP.TSH_NO_VALUE);

    return;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('colors',
    TP.tsh.colors.Type.getMethod('tshExecute'),
    'Generates a table of the 216 websafe colors.',
    ':colors',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.deploy/TP.tsh.deploy.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.deploy}
 * @summary A subtype of TP.tag.ActionTag that knows how to deploy applications
 *     in the TIBET system.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:deploy');

TP.tsh.deploy.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.deploy.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,
        shouldAssist;

    shell = aRequest.at('cmdShell');

    shouldAssist = TP.bc(shell.getArgument(
                                    aRequest, 'tsh:assist', null, false));

    if (shouldAssist) {

        //  Fire a 'AssistObject' signal, supplying the target object to focus
        //  on.
        TP.signal(
                null,
                'AssistObject',
                TP.hc('targetObject', this,
                        'title', 'Deploy Assistant',
                        'assistantParams', TP.hc('originalRequest', aRequest)));

        return aRequest.complete(TP.TSH_NO_VALUE);
    }

    //  Fire a 'RemoteConsoleCommand' with a 'deploy ...' command, supplying the
    //  original request.
    TP.signal(null, 'RemoteConsoleCommand',
        TP.hc('originalRequest', aRequest,
            'timeout', 60000,
            TP.ONSUCCESS, function(aResponse) {
                //  empty
            },
            TP.ONFAIL, function(aResponse) {
                //  empty
            }
        ));

    aRequest.complete('delegated to :cli');

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.tsh.deploy.Type.defineMethod('getContentForAssistant',
function() {

    /**
     * @method getContentForAssistant
     * @summary Returns the Element representing the root node of the content
     *     for the receiver's 'assistant'.
     * @returns {Element} The root node of the receiver's assistant content.
     */

    var assistantTPElem;

    assistantTPElem = TP.tsh.deploy_assistant.getResourceElement(
                        'template',
                        TP.ietf.mime.XHTML);

    return TP.unwrap(assistantTPElem);
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('deploy',
    TP.tsh.deploy.Type.getMethod('tshExecute'),
    'Deploys a release of a TIBET application.',
    ':deploy <helper> [<options>]',
    'See CLI documentation');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.deploy/TP.tsh.deploy_assistant.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @type {TP.tsh.deploy_assistant}
 */

//  ------------------------------------------------------------------------

TP.tsh.CommandAssistant.defineSubtype('tsh.deploy_assistant');

//  Note how this property is TYPE_LOCAL, by design.
TP.tsh.deploy_assistant.defineAttribute('themeURI', TP.NO_RESULT);

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.tsh.deploy_assistant.Inst.defineMethod('$flushToProfile',
function() {

    /**
     * @method $flushToProfile
     * @summary Flushes the data in the currently bound data model to the user's
     *     shell profile, thereby storing it for future use.
     * @returns {TP.tsh.deploy_assistant} The receiver.
     */

    var modelURI,

        result,
        data,

        deployInfos;

    //  Grab the current binding backing store.

    modelURI = this.get('assistantModelURI');

    result = modelURI.getResource().get('result');

    if (TP.notValid(result)) {
        return this;
    }

    if (TP.notValid(data = result.get('data'))) {
        return this;
    }

    //  Grab the 'deployment information entries' that the user's profile is
    //  storing for us.
    deployInfos =
        TP.uc('urn:tibet:lama_deployinfos').getResource().get('result');

    //  Put a copy of the 'info' aspect (a POJO) found in the binding store into
    //  the deployment information entries.
    deployInfos.atPut(
        data.info.helperName,
        TP.copy(data.info));

    //  Tell the shell to save it's profile. This will force it to flush all of
    //  its data, including the deployment information entries, to its
    //  persistent store.
    TP.bySystemId('TSH').saveProfile();

    return this;
});

//  ------------------------------------------------------------------------

TP.tsh.deploy_assistant.Inst.defineMethod('generateCommand',
function(info) {

    /**
     * @method generateCommand
     * @summary Generates the command text that will be sent to the shell if the
     *     user dismisses the assistant by clicking 'ok'.
     * @param {TP.core.Hash} info The hash containing the command parameters.
     * @returns {String} The generated command string.
     */

    var str,
        helperProps;

    str = ':deploy ' + info.at('helperName');

    //  Build a 'JSON argument' that represents all of the helper properties.
    //  This will allow those to be passed on the command line.
    helperProps = info.at('helperProps');
    if (TP.notEmpty(helperProps)) {
        str += ' \'{';

        helperProps.forEach(
                        function(anEntry) {
                            str += '"' +
                                anEntry.propName +
                                '":"' +
                                anEntry.propValue + '",';
                        });

        str = str.slice(0, -1);

        str += '}\'';
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.tsh.deploy_assistant.Inst.defineMethod('getAssistantModelURI',
function() {

    /**
     * @method getAssistantModelURI
     * @summary Returns the URI containing the model that the assistant is using
     *     to manage all of the selections in its panel.
     * @returns {TP.uri.URI} The URI containing the assistant model.
     */

    return TP.uc('urn:tibet:deploy_cmd_source');
});

//  ------------------------------------------------------------------------

TP.tsh.deploy_assistant.Inst.defineHandler('DialogCancel',
function(anObject) {

    /**
     * @method handleDialogCancel
     * @summary Handles when the user has 'canceled' the dialog (i.e. wants to
     *     proceed without taking any action).
     * @param {TP.sig.DialogCancel} aSignal The TIBET signal which triggered
     *     this method.
     * @returns {TP.tsh.deploy_assistant} The receiver.
     */

    this.callNextMethod();

    //  Keep the 'deploy infos' over in the shell up-to-date
    this.$flushToProfile();

    return this;
});

//  ------------------------------------------------------------------------

TP.tsh.deploy_assistant.Inst.defineHandler('DialogOk',
function(anObject) {

    /**
     * @method handleDialogOk
     * @summary Handles when the user has 'ok-ed' the dialog (i.e. wants to
     *     proceed by taking the default action).
     * @param {TP.sig.DialogOk} aSignal The TIBET signal which triggered
     *     this method.
     * @returns {TP.tsh.deploy_assistant} The receiver.
     */

    this.callNextMethod();

    //  Keep the 'deploy infos' over in the shell up-to-date
    this.$flushToProfile();

    return this;
});

//  ------------------------------------------------------------------------

TP.tsh.deploy_assistant.Inst.defineHandler('ValueChange',
function(aSignal) {

    /**
     * @method handleValueChange
     * @summary Handles when the user changes the value of the underlying model.
     * @param {ValueChange} aSignal The signal that caused this handler to trip.
     * @returns {TP.tsh.deploy_assistant} The receiver.
     */

    var aspect;

    aspect = aSignal.at('aspect');

    //  If the aspect that got changed is the helperName, then (re)populate the
    //  helper properties from the profile data store and/or the values that the
    //  user would have entered in this run of the dialog.
    if (aspect.endsWith('helperName')) {
        this.populateHelperProperties(true);

        //  Keep the 'deploy infos' over in the shell up-to-date
        this.$flushToProfile();

        this.getAssistantModelURI().$changed();
    } else if (aspect.contains('helperProps')) {
        this.populateHelperProperties(false);

        //  Keep the 'deploy infos' over in the shell up-to-date
        this.$flushToProfile();
    }

    this.callNextMethod();

    return this;
});

//  ------------------------------------------------------------------------

TP.tsh.deploy_assistant.Inst.defineMethod('populateHelperProperties',
function(takePropsFromStore) {

    /**
     * @method populateHelperProperties
     * @summary Populates the 'helper properties' in the supplied command
     *     parameters based on the 'helperName' that is also in the command
     *     parameters.
     * @param {Boolean} takePropsFromStore Whether or not to populate the
     *     current set of deployment properties from the 'backing store' of the
     *     user's profile or to use the current binding model.
     * @returns {TP.tsh.deploy_assistant} The receiver.
     */

    var deployInfos,

        modelURI,
        result,
        data,

        assistantInfo,

        helperName,
        helperProps,
        helperPropsNames,

        profileName;

    //  Grab the 'deployment information entries' that the user's profile is
    //  storing for us. If we have an entry here for helper properties, then we
    //  will use that.
    deployInfos =
        TP.uc('urn:tibet:lama_deployinfos').getResource().get('result');

    //  Grab the current binding backing store.

    modelURI = this.get('assistantModelURI');

    result = modelURI.getResource().get('result');

    if (TP.notValid(result)) {
        return this;
    }

    if (TP.notValid(data = result.get('data'))) {
        return this;
    }

    assistantInfo = data.info;

    //  And the helper name from it.
    helperName = assistantInfo.helperName;

    if (takePropsFromStore) {
        //  If the deployment entries have an entry for the helper named with
        //  the helper name, use that. This will be kept up-to-date as we change
        //  from helper to helper (within the same dialog session) and will also
        //  be updated when the user exits the panel (no matter how they did -
        //  either 'ok' or 'cancel').
        if (deployInfos.at(helperName)) {
            helperProps = deployInfos.at(helperName).helperProps;
        } else {
            helperProps = TP.ac();
        }

        //  Set whatever we found *back* into the binding info store's version of
        //  the helper props. Otherwise, they won't show in the UI.
        assistantInfo.helperProps = helperProps;
    } else {
        helperProps = assistantInfo.helperProps;
    }

    helperPropsNames = helperProps.collect(
                            function(anEntry) {
                                return anEntry.propName;
                            });

    switch (helperName) {
        case 'shipit':
            //  Grab the profile name and slice off everything after the '@'.
            //  That will be what we default the 'profile name'.
            profileName = TP.sys.getcfg('boot.profile');
            profileName = profileName.slice(0, profileName.indexOf('@'));

            if (takePropsFromStore &&
                !helperPropsNames.contains('environment')) {
                helperProps.push(
                    {
                        propName: 'environment',
                        propValue: profileName
                    });
            }

            break;
        case 'awselasticbeanstalk':
            break;
        case 'awsfargate':
            break;
        case 'azurewebapps':
            break;
        case 'dockerhub':
            if (takePropsFromStore &&
                !helperPropsNames.contains('password')) {
                helperProps.push(
                    {
                        propName: 'password',
                        propValue: 'fluffy'
                    });
            }
            break;
        case 'heroku':
            break;
        default:
            break;
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.tsh.deploy_assistant.Inst.defineMethod('setOriginalRequest',
function(anObj) {

    /**
     * @method setOriginalRequest
     * @summary Sets the original request received by the command that triggered
     *     the assistant.
     * @param {TP.sig.Request} anObj The original request that was supplied to
     *     the assistant via the command.
     * @returns {TP.tsh.deploy_assistant} The receiver.
     */

    var deployInfo,
        topLevelInfo,

        modelURI,
        modelObj;

    this.callNextMethod();

    //  Configure the GUI using the argument values that we can derive from the
    //  original request

    topLevelInfo = TP.hc();

    deployInfo = TP.hc();
    topLevelInfo.atPut('info', deployInfo);

    deployInfo.atPut('helperName', 'shipit');

    deployInfo.atPut('helperProps', TP.ac());

    //  Set up a model URI and observe it for change ourself. This will allow us
    //  to regenerate the tag representation as the model changes.
    modelURI = this.getAssistantModelURI();
    this.observe(modelURI, 'ValueChange');

    //  Construct a JSONContent object around the model object so that we can
    //  bind to it using the more powerful JSONPath constructs
    modelObj = TP.core.JSONContent.construct(TP.js2json(topLevelInfo));

    //  Set the resource of the model URI to the model object, telling the URI
    //  that it should observe changes to the model (which will allow us to get
    //  notifications from the URI which we're observing above). Note that we
    //  tell it to *not* and signal change right away - we want to populate (and
    //  default) any helper properties that are appropriate for the currently
    //  selected helper.
    modelURI.setResource(
        modelObj, TP.hc('observeResource', true, 'signalChange', false));

    this.populateHelperProperties(true);

    //  Go ahead and tell the model URI that it has been changed (and it will
    //  now signal it).
    modelURI.$changed();

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.dispatch.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.dispatch}
 * @summary A subtype of TP.tag.ActionTag that dispatches a signal according to
 *     the data configured on it.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:dispatch');

TP.tsh.dispatch.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.dispatch.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Executes a formatting or template transformation operation on
     *     the current value of stdin.
     * @param {TP.sig.ShellRequest} aRequest The request containing command
     *     input.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,

        elem,

        orgid,
        doc,
        target,

        sigName,
        sigPayload,
        sigPolicy,
        sigInst,
        sigType,

        outermostAction;

    if (TP.notValid(elem = aRequest.at('cmdNode'))) {
        return aRequest.fail();
    }

    shell = aRequest.at('cmdShell');

    //  ---
    //  origin
    //  ---

    //  If an 'origin' slot was supplied, then we look that up by ID (using
    //  the original origin's document).
    orgid = shell.getArgument(aRequest, 'tsh:origin', null, true);

    if (TP.notEmpty(orgid)) {
        //  Just in case it was supplied as a quoted value
        orgid = orgid.unquoted();

        doc = TP.nodeGetDocument(elem);

        //  Note how we pass false to avoid getting a wrapped origin, which
        //  we don't want here.
        target = TP.byId(orgid, doc, false);
    } else {
        target = null;
    }

    //  ---
    //  signal
    //  ---

    sigName = shell.getArgument(aRequest, 'tsh:signal', null, true);

    //  If there is no signal name, warn and exit.
    if (TP.isEmpty(sigName)) {
        TP.ifError() ?
            TP.error('No signal name in <tsh:dispatch/> tag.') : 0;

        return;
    }

    //  ---
    //  payload
    //  ---

    sigPayload = shell.getArgument(aRequest, 'tsh:payload', null, true);

    if (TP.notEmpty(sigPayload)) {
        if (sigPayload.startsWith('{')) {
            //  What's left is a JS-formatted String. Parse that into a Hash.
            sigPayload = TP.json2js(TP.reformatJSToJSON(sigPayload));
        } else {
            sigPayload = TP.hc();
        }
    }

    //  ---
    //  policy
    //  ---

    sigPolicy = shell.getArgument(aRequest, 'tsh:policy', null, true);

    //  If the author didn't specify a policy, then we try to determine if the
    //  signal is spoofed. If so, then we default the policy to
    //  TP.RESPONDER_FIRING.
    if (TP.isEmpty(sigPolicy)) {

        sigInst = TP.sig.SignalMap.$getSignalInstance(sigName);
        if (sigInst.isSpoofed()) {
            sigPolicy = TP.RESPONDER_FIRING;
        } else {
            sigType = TP.sig.SignalMap.$getSignalType(sigName);
            sigPolicy = sigType.getDefaultPolicy();
        }
    }

    //  ---
    //  Dispatch the signal
    //  ---

    outermostAction = TP.wrap(elem).getOutermostOfSameKind(TP.tag.ActionTag);

    //  If the firing policy is either TP.DOM_FIRING or TP.RESPONDER_FIRING,
    //  then we need to dispatch the signal *from it's parent* - otherwise, the
    //  generic 'handleSignal' method on all action tags will cause the
    //  outermost action tag (either us or a parent that is an action tag -
    //  probably a 'tsh:script' tag) to run us again and we'll endlessly loop.
    if (sigPolicy === TP.DOM_FIRING || sigPolicy === TP.RESPONDER_FIRING) {
        outermostAction.getParentNode().dispatch(
                                    sigName, target, sigPayload, sigPolicy);
    } else {
        outermostAction.dispatch(sigName, target, sigPayload, sigPolicy);
    }

    aRequest.complete();

    return TP.CONTINUE;
});

//  ------------------------------------------------------------------------
//
TP.shell.TSH.addHelpTopic('dispatch',
    TP.tsh.dispatch.Type.getMethod('tshExecute'),
    'Dispatches a signal.',
    ':dispatch [--origin <origin>] [--payload <payload>] [--policy <policy>] --signal <signal>');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.doclint.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.doclint}
 * @summary A subtype of TP.tag.ActionTag that knows how to
 *     conditionally process its child actions based on a binding expression.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:doclint');

TP.tsh.doclint.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.doclint.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,
        tap,
        methods,
        results,
        context,
        missing,
        filter,
        arg0,
        target,
        owner,
        pattern,
        tags,
        aliases,
        keys,
        dups,
        fileDict,
        totalErrors,
        errorFiles,
        totalFiles,
        prefix;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    //  TODO:   migrate the actual checking code to a more reusable location.

    aRequest.atPut('cmdTAP',
        shell.getArgument(aRequest, 'tsh:tap', null, true));
    tap = aRequest.at('cmdTAP');

    missing = shell.getArgument(aRequest, 'tsh:missing', null, false);

    results = TP.ac();

    //  The following tags allow duplicate entries for the same tag. This list is
    //  not strictly exhaustive, but it should be adequate for now.
    dups = TP.ac(
            '@param', '@throws', '@exception', '@fires', '@listens', '@mixes',
            '@example', '@author');

    tags = TP.ac(
            '@abstract', '@virtual', '@access', '@alias', '@augments',
            '@extends', '@author', '@borrows', '@callback', '@class',
            '@constructor', '@classdesc', '@constant', '@const', '@constructs',
            '@copyright', '@default', '@defaultvalue', '@deprecated',
            '@description', '@desc', '@enum', '@event', '@example', '@exports',
            '@external', '@host', '@file', '@fileoverview', '@overview', '@fires',
            '@emits', '@function', '@func', '@method', '@global', '@ignore',
            '@implements', '@inheritdoc', '@inner', '@instance', '@interface',
            '@kind', '@lends', '@license', '@listens', '@member', '@var',
            '@memberof', '@mixes', '@mixin', '@module', '@name', '@namespace',
            '@overide', '@param', '@arg', '@argument', '@private', '@property',
            '@prop', '@protected', '@public', '@readonly', '@requires',
            '@returns', '@return', '@see', '@since', '@static', '@summary',
            '@this', '@throws', '@exception', '@todo', '@tutorial', '@type',
            '@typedef', '@variation', '@version');

    aliases = TP.hc(
            '@virtual', '@abstract',
            '@return', '@returns',
            '@extends', '@augments',
            '@const', '@constant',
            '@defaultvalue', '@default',
            '@desc', '@description',
            '@host', '@external',
            '@fileoverview', '@overview',
            '@file', '@overview',
            '@emits', '@fires',
            //  NOTE we don't convert @exception to @throws, they're different
            //  in TIBET. @exception is based on raise() and @throws is via
            //  throw.
            '@function', '@method',
            '@func', '@method',
            '@member', '@var',
            '@arg', '@param',
            '@argument', '@param',
            '@prop', '@property');

    keys = TP.keys(aliases);

    fileDict = TP.hc();

    arg0 = shell.getArgument(aRequest, 'ARG0');
    if (TP.isValid(arg0)) {
        owner = arg0;
        target = TP.id(arg0);
    } else {
        //  Target is an optional "owner" specification for filtering by method
        //  owner. The value must be resolvable via TP.bySystemId.
        target = shell.getArgument(aRequest, 'tsh:target', null);
        if (TP.notEmpty(target)) {
            target = target.unquoted();

            //  Resolve the reference, but deal with the fact that the input
            //  target can be something like 'bind:' etc. so update target ID.
            owner = shell.resolveObjectReference(target);
            if (TP.isValid(owner)) {
                target = TP.id(owner);
            }
        }
    }

    if (TP.notEmpty(target) && TP.notValid(owner)) {
        return aRequest.fail('Unable to resolve target: ' + target);
    }

    //  Context determines whether we care about app, lib, or both.
    //  NOTE we do NOT default this provided there's a target. If there's a
    //  target we assume the user wants that object's context as the default.
    context = shell.getArgument(aRequest, 'tsh:context');
    if (TP.isEmpty(context)) {
        if (/^TP/.test(target)) {
            context = 'lib';
        } else {
            context = 'app';
        }
    }

    if (TP.isString(context)) {
        context = context.unquoted();
    }

    filter = shell.getArgument(aRequest, 'tsh:filter', null);
    if (TP.notEmpty(filter)) {
        filter = filter.unquoted();

        //  TODO: generalize this
        if (/^\/.+\/([ig]*)$/.test(filter)) {
            pattern = RegExp.construct(filter);
        }
    }

    methods = TP.sys.getMetadata('methods');
    methods.perform(
        function(item) {
            var name,
                func,
                file,
                lines,
                names,
                match,
                found,
                tagline,
                type,
                desc,
                taglines,
                dict,
                text,
                result,
                source,
                error,
                fParams,
                cParams,
                defaultMatch;

            name = item.at(0);
            func = item.at(1);

            //  Owner is our resolved target, used for filtering by method owner.
            if (TP.isValid(owner)) {
                if (!name.startsWith(target)) {
                    return;
                }
            }

            //  Note how we go after load path here, since source paths will
            //  never be minified and that's what we check below.
            file = TP.objectGetLoadPath(func);

            error = {
                file: file,
                name: name,
                errors: TP.ac()
            };

            //  Context can be either app, lib, or both. We use that to
            //  determine if a particular component should be checked at a very
            //  broad level.
            if (context === 'app') {
                if (!TP.boot.$uriInTIBETFormat(file).startsWith('~app')) {
                    return;
                }
            } else if (context === 'lib') {
                if (!TP.boot.$uriInTIBETFormat(file).startsWith('~lib')) {
                    return;
                }
            }

            if (TP.notEmpty(filter)) {
                if (TP.isValid(pattern)) {
                    //  Regular expression as filter.
                    if (!pattern.match(name)) {
                        return;
                    }
                } else {
                    //  Normal text string as filter.
                    if (!name.contains(filter)) {
                        return;
                    }
                }
            }

            //  Create an entry for every file. This will let us count total
            //  files in addition to just error files.
            if (TP.notEmpty(file)) {
                fileDict.atPut(file, null);
            }

            lines = func.getCommentLines();
            source = func.getSourceText();

            if (TP.notValid(lines)) {
                //  Most common issue here is running against a system that's
                //  loading minified code.
                if (TP.notEmpty(file) &&
                    !file.match(/\.min\./) &&
                    !func.$resolutionMethod) {

                    text = func.toString();
                    if (!TP.regex.NATIVE_CODE.test(text)) {
                        results.push(
                            {
                                file: file,
                                name: name,
                                errors: TP.ac('missing comment')
                            });
                    }
                }
            } else if (lines.length === 0) {
                results.push(
                    {
                        file: file,
                        name: name,
                        errors: TP.ac('empty comment')
                    });
            } else {

                //  Comment. Question is, is it viable?

                //  If we're only interested in missing/empty comment blocks
                //  don't worry about processing details in ones that exist.
                if (missing) {
                    return;
                }

                //  ---
                //  tag validity and aliasing
                //  ---

                lines.forEach(
                    function(line, index) {
                        var tag;

                        //  Skip lines for examples etc. which won't start with
                        //  @
                        if (line.charAt(0) !== '@') {
                            return;
                        }

                        //  Alias over any tags so our lint checks focus on
                        //  a canonical variant.
                        keys.forEach(
                                function(key) {
                                    var value;

                                    value = aliases.at(key);

                                    //  NOTE the trailing space. This ensures we
                                    //  don't match @description and think it's
                                    //  @desc etc.
                                    if (line.startsWith(key + ' ')) {
                                        result = TP.ifInvalid(result, error);
                                        result.errors.push(
                                            'prefer ' + value + ' to ' + key);
                                        lines[index] = line.replace(key, value);
                                    }
                                });

                        //  Verify all tags are known.
                        tag = line.split(' ').first();
                        if (tags.indexOf(tag) === TP.NOT_FOUND) {
                            result = TP.ifInvalid(result, error);
                            result.errors.push(tag + ' unknown');
                        }
                    });

                //  ---
                //  @method
                //  ---

                names = lines.filter(
                            function(line) {
                                return line.startsWith('@method ') ||
                                        line.startsWith('@alias ');
                            });

                if (TP.isEmpty(names)) {
                    result = TP.ifInvalid(result, error);
                    result.errors.push('@method missing');
                } else {

                    //  The name is of the form A_B_method_name_parts where we
                    //  can even have double-underscore. As a result we have to
                    //  use a regex rather than split or other approaches.
                    match = name.match(/^(.*)_(.*?)_(.*?)$/);

                    dict = TP.decomposeHandlerName(name);

                    found = false;

                    names.forEach(
                            function(line) {
                                var lineParts,
                                    mDict;

                                //  Throw away tag, keeping remainder.
                                lineParts = line.split(' ').last();

                                if (TP.notEmpty(dict)) {
                                    //  This is a handler name... method name
                                    //  match gets a lot trickier...
                                    mDict = TP.decomposeHandlerName(lineParts);
                                    if (TP.notEmpty(mDict)) {
                                        if (dict.signalName ===
                                            mDict.signalName &&
                                            dict.phase ===
                                            mDict.phase &&
                                            dict.origin ===
                                            mDict.origin &&
                                            dict.state ===
                                            mDict.state) {
                                                found = true;
                                            }
                                    }
                                } else {
                                    if (match && match.at(3) === lineParts) {
                                        found = true;
                                    }
                                }
                            });

                    if (!found) {

                        result = TP.ifInvalid(result, error);
                        result.errors.push('@method incorrect');
                    }
                }

                //  ---
                //  duplicates
                //  ---

                //  Collect all tag-prefixed lines.
                taglines = lines.filter(
                                    function(line) {
                                        return line.startsWith('@');
                                    });

                dict = TP.hc();

                taglines.forEach(
                            function(line) {
                                var tag;

                                //  Slice the tag off the front.
                                tag = line.split(' ').first();

                                //  Check to see if dups are allowed for this
                                //  tag.
                                if (dups.indexOf(tag) !== TP.NOT_FOUND) {
                                    return;
                                }

                                //  Verify via hash lookup and add any new ones.
                                if (dict.at(tag)) {
                                    result = TP.ifInvalid(result, error);
                                    result.errors.push(
                                                'multiple ' + tag + '\'s');
                                } else {
                                    dict.atPut(tag, tag);
                                }
                            });

                //  ---
                //  summary/description
                //  ---

                //  Have to have a summary or description (preferably both ;)).
                taglines = lines.filter(
                                function(line) {
                                    return line.startsWith('@summary ') ||
                                            line.startsWith('@description ');
                                });

                if (TP.isEmpty(taglines)) {
                    result = TP.ifInvalid(result, error);
                    result.errors.push('@summary/@description missing');
                }

                //  ---
                //  @param
                //  ---

                //  Collect the comment parameters...
                cParams = lines.filter(
                                function(line) {
                                    return line.startsWith('@param ');
                                });

                //  Collect comment parameter names. While we're processing
                //  these verify that each @param has a type definition.
                cParams =
                    cParams.map(
                        function(param) {
                            var theParam,

                                paramType,
                                paramParts,
                                count,
                                i,
                                c,
                                len,
                                pname,
                                pdesc,
                                needName,
                                optional,
                                defaulted;

                            theParam = param.slice('@param '.length);

                            //  Check for parameter type references...
                            if (theParam.indexOf('{') !== 0) {

                                //  Apparently not formatted with a type for the
                                //  param.
                                result = TP.ifInvalid(result, error);
                                result.errors.push('missing type for @param ');
                                needName = true;

                            } else {

                                //  Since some parameter type descriptions
                                //  involve the use of nested {}'s we need to
                                //  actually do a simple count here to be
                                //  certain of our result.
                                len = theParam.length;
                                paramType = '';
                                count = 0;

                                for (i = 0; i < len; i++) {

                                    c = theParam.charAt(i);

                                    if (c === '}') {
                                        count--;

                                        if (count === 0) {
                                            theParam =
                                                theParam.slice(i + 1).trim();
                                            break;
                                        }

                                    } else if (c === '{') {
                                        count++;
                                    }

                                    paramType += c;
                                }

                                //  If the braces aren't balanced we can fall
                                //  off the end. Watch out for that.
                                if (count !== 0) {
                                    result = TP.ifInvalid(result, error);
                                    result.errors.push(
                                            'unbalanced {}\'s in @param ');
                                    needName = true;

                                    //  Take our best guess at what the real
                                    //  type and parameter name are.
                                    paramType = theParam.slice(
                                                1, theParam.lastIndexOf('}'));
                                    paramType =
                                        '{' +
                                        paramType.strip('{').strip('}') +
                                        '}';

                                    theParam = theParam.slice(
                                        theParam.lastIndexOf('}') + 1).trim();
                                } else {

                                    //  Otherwise, append a closing '}' to match
                                    //  the logic above
                                    paramType += '}';
                                }

                                //  We want to use a leading '?' not 'null' in
                                //  types.
                                if (paramType.match(/null/)) {

                                    result = TP.ifInvalid(result, error);
                                    result.errors.push(
                                        'prefer {?...} in @param ');

                                    needName = true;
                                }

                                //  We want function() instead of Function for
                                //  function parameters so there's a tendency to
                                //  document signature.
                                if (paramType.match(/Function/)) {

                                    result = TP.ifInvalid(result, error);
                                    result.errors.push(
                                        'prefer {function(...)} in @param ');

                                    needName = true;
                                }

                                //  We want to use Type[] rather than
                                //  Array.<Type>
                                if (paramType.match(/Array/)) {

                                    result = TP.ifInvalid(result, error);
                                    result.errors.push(
                                        'prefer {Type[]} in @param ');

                                    needName = true;
                                }

                                //  We want to use {key: type} rather than
                                //  Object.<>
                                if (paramType.match(/Object\./)) {

                                    result = TP.ifInvalid(result, error);
                                    result.errors.push(
                                        'prefer @param name.slot for @param ');

                                    needName = true;
                                }
                            }

                            //  Param name should be next non-whitespace
                            //  sequence... or the content of ['s before any =
                            //  for signifying a default value.
                            if (theParam.charAt(0) === '[') {

                                optional = true;

                                pname = theParam.slice(1, theParam.indexOf(']'));
                                defaulted = pname.indexOf('=') !== TP.NOT_FOUND;
                                pname = pname.split('=').first();

                                pdesc = theParam.slice(
                                        theParam.lastIndexOf(']') + 1).trim();
                            } else {
                                paramParts = theParam.split(' ');
                                pname = paramParts.shift();
                                pdesc = paramParts.join(' ');
                            }

                            //  Verify the parameter has a description.
                            if (TP.isEmpty(pdesc)) {
                                result = TP.ifInvalid(result, error);
                                result.errors.push(
                                            'missing description for @param ');

                                needName = true;
                            } else {

                                //  There's a description. Does it indicate that
                                //  we may need optional/default value content
                                //  for the pname?
                                if (pdesc.match(/[Oo]ptional/) &&
                                    !optional) {

                                    result = TP.ifInvalid(result, error);
                                    result.errors.push(
                                        'use [name] for optional @param ');

                                    needName = true;
                                }

                                if (pdesc.match(/[Dd]efault/) &&
                                    !defaulted) {

                                    result = TP.ifInvalid(result, error);
                                    result.errors.push(
                                        'use [name=value] for defaulted' +
                                        ' @param ');

                                    needName = true;

                                } else {

                                    defaultMatch = RegExp.construct(
                                        'TP\\.if(Invalid|Null|Undefined)\\(' +
                                        pname);

                                    if (source.match(defaultMatch) &&
                                        !defaulted) {

                                        result = TP.ifInvalid(result, error);
                                        result.errors.push(
                                            'use [name=value] for defaulted' +
                                            ' @param ');

                                        needName = true;
                                    }
                                }
                            }

                            //  If we flagged a missing type we need to append
                            //  the name to the last message.
                            if (needName) {
                                result.errors.atPut(
                                        result.errors.length - 1,
                                        result.errors.last() + pname);
                            }

                            //  If the param is a varargs param we should see
                            //  '...' in the type definition.
                            if (pname === 'varargs' &&
                                    TP.notValid(paramType.match(/\.\.\./))) {

                                result = TP.ifInvalid(result, error);
                                result.errors.push(
                                        '@param varargs needs \'...\' in type');
                            }

                            if (source.match(/arguments\.length/)) {

                                result = TP.ifInvalid(result, error);
                                result.errors.push(
                                        '@param list needs a param of' +
                                        ' \'varargs\' and that params needs' +
                                        ' \'...\' in type');
                            }

                            return pname;
                        });

                //  Get the function's parameter name list.
                fParams = func.getParameterNames();

                //  Filter comment parameters to remove any nested ones.
                cParams = cParams.filter(
                                    function(pname) {
                                        return pname.indexOf('.') ===
                                                                TP.NOT_FOUND;
                                    });

                //  Order matters here so loop over the function signature and
                //  make sure that a) all items are accounted for, and b) the
                //  order of the items (not including "nested properties") is
                //  consistent.
                fParams.forEach(
                            function(pname, index) {

                                //  Does the parameter exist?
                                if (cParams.indexOf(pname) === TP.NOT_FOUND) {

                                    result = TP.ifInvalid(result, error);
                                    result.errors.push(
                                        '@param ' + pname + ' missing');

                                } else if (cParams[index] !== pname) {

                                    result = TP.ifInvalid(result, error);
                                    result.errors.push(
                                        '@param ' + pname + ' mismatch');
                                }
                            });

                //  Now for the other direction, comment parameters which are
                //  found but which are not valid in the function signature...
                cParams.forEach(
                            function(pname) {
                                if (fParams.indexOf(pname) === TP.NOT_FOUND) {

                                    result = TP.ifInvalid(result, error);
                                    result.errors.push(
                                        '@param ' +
                                        pname +
                                        ' not in signature');
                                }
                            });

                //  ---
                //  @returns
                //  ---

                tagline = lines.detect(
                                function(line) {
                                    return line.startsWith('@returns ');
                                });

                //  Returns should include a type at a minimum.
                if (TP.notEmpty(tagline)) {

                    type = tagline.slice(
                            tagline.indexOf('{'),
                            tagline.lastIndexOf('}') + 1);

                    if (TP.isEmpty(type)) {
                        result = TP.ifInvalid(result, error);
                        result.errors.push('no @returns type(s)');
                    } else {
                        desc = tagline.slice(tagline.lastIndexOf('}') + 1);
                        if (TP.isEmpty(desc)) {
                            result = TP.ifInvalid(result, error);
                            result.errors.push('no @returns description');
                        }
                    }
                }

                //  Remaining checks are sanity checks comparing the type and
                //  the nature of the return calls in the code.
                if (source.match(/return (.*?)/)) {

                    //  Complex returns, so there should be a real @returns tag.
                    if (TP.isEmpty(tagline)) {

                        //  If there's at least one occurrence of one that's not
                        //  just 'return;', then we should have a tag, otherwise
                        //  we shouldn't.
                        if (source.match(/return (.+?)/)) {
                            result = TP.ifInvalid(result, error);
                            result.errors.push(
                                    'no @returns for non-empty return(s)');
                        }
                    } else if (type) {
                        if (source.match(/return;/)) {
                            //  At least one nullable return. Make sure the type
                            //  accounts for that.
                            if (type && !type.match(/(null|\?)/)) {
                                result = TP.ifInvalid(result, error);
                                result.errors.push(
                                    'missing {?...} for nullable @returns');
                            }
                        } else if (type && type.match(/null/)) {
                            result = TP.ifInvalid(result, error);
                            result.errors.push(
                                'prefer {?...} for nullable @returns');
                        }
                    }
                } else {

                    //  No complex returns in the code.
                    if (TP.notEmpty(tagline)) {
                        result = TP.ifInvalid(result, error);
                        result.errors.push('extraneous @returns');
                    }
                }

                //  ---
                //  other type checks
                //  ---

                //  @throws, @exception, @signal, @listens should all be done so
                //  we have a separate type and description per line.
                taglines = lines.filter(
                                function(line) {
                                    return line.match(
                                        /@(throws|exception|fires|listens) /);
                                });

                taglines.forEach(
                            function(line) {
                                var tag;

                                tag = line.split(' ').first();

                                if (TP.notEmpty(line)) {

                                    type = line.slice(line.indexOf('{'),
                                            line.lastIndexOf('}'));

                                    if (TP.isEmpty(type)) {

                                        result = TP.ifInvalid(result, error);
                                        result.errors.push(
                                            'no ' + tag + ' type(s)');
                                    } else if (type.match(/[,|]/)) {
                                        result = TP.ifInvalid(result, error);
                                        result.errors.push(
                                            'prefer one type per ' + tag);
                                    }
                                }
                            });

                //  ---
                //  source checks
                //  ---

                if (source.match(/\.todo\(/)) {
                    tagline = lines.detect(
                                    function(line) {
                                        return line.startsWith('@todo ');
                                    });

                    if (TP.isEmpty(tagline)) {
                        result = TP.ifInvalid(result, error);
                        result.errors.push('no @todo for TP.todo()');
                    }
                }

                if (source.match(/\.signal\(/)) {
                    tagline = lines.detect(
                                    function(line) {
                                        return line.startsWith('@fires ');
                                    });

                    if (TP.isEmpty(tagline)) {
                        result = TP.ifInvalid(result, error);
                        result.errors.push('no @fires for signal()');
                    }
                }

                if (source.match(/\.observe\(/)) {
                    tagline = lines.detect(
                                    function(line) {
                                        return line.startsWith('@listens ');
                                    });

                    if (TP.isEmpty(tagline)) {
                        result = TP.ifInvalid(result, error);
                        result.errors.push('no @listens for observe()');
                    }
                }

                if (source.match(/\.raise\(/)) {
                    tagline = lines.detect(
                                    function(line) {
                                        return line.startsWith('@exception ');
                                    });

                    if (TP.isEmpty(tagline)) {
                        result = TP.ifInvalid(result, error);
                        result.errors.push('no @exception for raise()');
                    }
                }

                if (source.match(/throw (.*?);/)) {
                    tagline = lines.detect(
                                    function(line) {
                                        return line.startsWith('@throws ');
                                    });

                    if (TP.isEmpty(tagline)) {
                        result = TP.ifInvalid(result, error);
                        result.errors.push('no @throws for throw');
                    }
                }
            }

            if (result) {
                results.push(result);
            }
        });

    //  Output the results. Our content looks like this:
    //  [ { file: filename, name: funcname, errors: [a, b, c] }, ... ]
    //  Our goal is to coalesce by file name so we can output the set of errors
    //  specific to that file in a set.

    totalFiles = fileDict.getKeys().getSize();
    errorFiles = 0;
    totalErrors = 0;

    results.forEach(
            function(result) {
                var errors;

                errors = fileDict.at(result.file);
                if (TP.notValid(errors)) {
                    errors = TP.ac();
                }
                fileDict.atPut(result.file, errors);

                errors.push(result);
            });

    //  Now that we've reorganized the results truncate that list. We'll use it
    //  again for line-by-line output below.
    results.length = 0;

    //  Loop over the files, sorted by name, and dump the file name and then all
    //  errors for that file.
    fileDict.getKeys().sort().forEach(
            function(key) {

                var entries;

                entries = fileDict.at(key);
                if (TP.notValid(entries)) {
                    if (TP.notEmpty(key)) {
                        results.push((tap ? 'ok - ' : '') +
                            TP.uriExpandPath(key).replace('file://', ''));
                    }
                    return;
                }

                errorFiles++;

                //  Output the file name.
                results.push((tap ? 'not ok - ' : '') +
                    TP.uriExpandPath(key).replace('file://', ''));

                entries.forEach(
                        function(entry) {
                            var name,
                                errors;

                            TP.regex.UNDERSCORES.lastIndex = 0;
                            name = entry.name.replace(
                                    TP.regex.UNDERSCORES, '.');
                            errors = entry.errors;

                            totalErrors += errors.length;

                            results.push(
                                (tap ? '# ' : '') + name + ' (' + errors.length +
                                ') -> [' + errors.join(', ') + ']');
                        });
            });

    //  Output some summary data.
    if (tap) {
        if (totalErrors > 0) {
            prefix = '# FAIL: ';
        } else {
            prefix = '# PASS: ';
        }
    } else {
        prefix = '';
    }

    results.push(prefix + totalErrors + ' errors in ' + errorFiles +
                    ' of ' + totalFiles + ' files.');

    //  Headless/CLI support requires output line-by-line.
    if (TP.sys.cfg('boot.context') === 'headless') {

        results.forEach(
                function(result) {
                    TP.sys.logTest(result);
                });

        aRequest.complete(TP.TSH_NO_VALUE);

        return aRequest;
    }

    //  When outputting outside of Headless/CLI, just join all of the results
    //  together with a newline. Because we specified 'cmdTAP' above, this
    //  output will be untouched.
    aRequest.complete(results.join('\n'));

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('doclint',
    TP.tsh.doclint.Type.getMethod('tshExecute'),
    'Run a lint check on all method comments.',
    ':doclint [--filter <filter>] [--missing] [--tap[=true|false]] [--no-tap] [--context <app|lib|all>] target\n' +
    ':doclint --target <target> [--filter <filter>] [--missing] [--tap[=true|false]] [--no-tap] [--context <app|lib|all>]',
    'See CLI documentation');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.dump.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.dump}
 * @summary A subtype of TP.tag.ActionTag that knows how to
 *     conditionally process its child actions based on a binding expression.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:dump');

TP.tsh.dump.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.dump.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,

        arg0,
        obj;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    //  No arguments means we dump usage.
    if (!shell.hasArguments(aRequest)) {
        return this.printUsage(aRequest);
    }

    arg0 = shell.getArgument(aRequest, 'ARG0');
    obj = shell.resolveObjectReference(arg0, aRequest);

    if (TP.isValid(obj)) {
        aRequest.stdout(obj, TP.request('cmdTitle', TP.name(obj)));
        aRequest.complete(TP.TSH_NO_VALUE);
    } else {
        aRequest.stdout('Invalid object reference: ' + arg0);

        return aRequest.complete(TP.TSH_NO_VALUE);
    }

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('dump',
    TP.tsh.dump.Type.getMethod('tshExecute'),
    'Dumps a detailed version of stdout to stdout.',
    ':dump <target>',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.echo.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.echo}
 * @summary A subtype of TP.tag.ActionTag that echos its arguments to stdout.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:echo');

TP.tsh.echo.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.echo.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Executes the command, echoing any arguments for review.
     * @param {TP.sig.ShellRequest} aRequest The request which triggered
     *     this command.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,
        args;

    shell = aRequest.at('cmdShell');

    args = shell.getArguments(aRequest);
    aRequest.stdout(args);

    return aRequest.complete();
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('echo',
    TP.tsh.echo.Type.getMethod('tshExecute'),
    'Echoes the arguments provided for debugging.',
    ':echo args...',
    'Echoes out whatever arguments are supplied to the command.');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.edit.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.edit}
 * @summary A subtype of TP.tag.ActionTag that knows how to
 *     conditionally process its child actions based on a binding expression.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:edit');

TP.tsh.edit.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.edit.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,

        arg0,
        url,
        obj;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    //  No arguments means we dump usage.
    if (!shell.hasArguments(aRequest)) {
        return this.printUsage(aRequest);
    }

    arg0 = shell.getArgument(aRequest, 'ARG0');

    if (TP.regex.URI_LIKELY.test(arg0) &&
        !TP.regex.REGEX_LITERAL_STRING.test(arg0)) {
        url = shell.expandPath(arg0);
        if (TP.isURI(url = TP.uc(url))) {
            obj = url;
        } else {
            obj = shell.resolveObjectReference(arg0, aRequest);
        }
    } else {
        obj = shell.resolveObjectReference(arg0, aRequest);
    }

    if (TP.notValid(obj)) {
        aRequest.stdout('Invalid object reference: ' + arg0);

        return aRequest.complete(TP.TSH_NO_VALUE);
    }

    //  Fire a 'EditObject' signal, supplying the target object to focus on.
    TP.signal(null,
                'EditObject',
                TP.hc('targetObject', obj,
                        'targetAspect', TP.id(obj),
                        'addTargetAsRoot', true));

    aRequest.complete(TP.TSH_NO_VALUE);

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('edit',
    TP.tsh.edit.Type.getMethod('tshExecute'),
    'Opens an editor for the value at stdin.',
    ':edit <target>',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.entity.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.entity}
 * @summary A subtype of TP.tag.ActionTag that knows how to
 *     conditionally process its child actions based on a binding expression.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:entity');

TP.tsh.entity.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.entity.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,

        arg0,
        entity;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    arg0 = shell.getArgument(aRequest, 'ARG0');
    if (TP.isValid(arg0)) {

        entity = '&#' + arg0.replace(';', '') + ';';
        aRequest.atPut('cmdAsIs', true);

        aRequest.stdout(entity);
    } else {
        aRequest.stdout('Entity table dump coming soon.');

        aRequest.complete(TP.TSH_NO_VALUE);
    }

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('entity',
    TP.tsh.entity.Type.getMethod('tshExecute'),
    'Generates a table of XML entity codes.',
    ':entity\n' +
    ':entity [<entity_name_or_number>]',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.export.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.export}
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:export');

TP.tsh.export.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.export.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @description This command writes out the previous command buffer to the
     *     script file named as the target url.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,

        path,
        ext,
        url,
        hid,

        request,
        content;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    //  No arguments means we dump usage.
    if (!shell.hasArguments(aRequest)) {
        return this.printUsage(aRequest);
    }

    //  TODO:   make this read from stdin for potential buffer content etc

    //  NB: We supply 'null' as the default value if 'tsh:ref' wasn't
    //  specified.
    path = shell.getArgument(aRequest, 'tsh:href', null, true);
    if (TP.isEmpty(path)) {
        return aRequest.fail('Unable to determine target url.');
    }

    ext = TP.uriExtension(path);
    if (TP.isEmpty(ext)) {
        path = path + '.tsh';
    }

    url = TP.uc(path);
    if (TP.notValid(url)) {
        return aRequest.fail('Invalid target url.');
    }

    hid = shell.getArgument(aRequest, 'tsh:hid', null, false);

    hid = TP.ifEmpty(hid, -2);
    hid = parseInt(hid, 10);
    if (TP.notValid(hid) || TP.isNaN(hid)) {
        return aRequest.fail('Invalid target history.');
    }

    //  we want the expanded form of the last command, ready for action.
    request = shell.$get('history').at(hid);

    content = request.at('cmdExpansion');
    content = TP.XML_10_UTF8_HEADER + content;
    content = content.replace(/>/g, '>\n');

    aRequest.stdout(content);
    url.setContent(content, TP.request('resultType', TP.TEXT));

    url.save(TP.request('method', TP.HTTP_PUT));

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('export',
    TP.tsh.export.Type.getMethod('tshExecute'),
    'Writes a previous command to a target URL.',
    ':export --href <exporturl> [--hid <hidnum>]',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.history.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.history}
 * @summary Provides support for constrained history expansion during command
 *     processing. This is a subset of standard shell history referencing which
 *     is focused on accessing entire commands and reinvoking them.
 * @summary Traditional shell history substitution is literally
 *     that...substitution of some or all of a prior command's text into the
 *     current command input stream. The tsh:history tag does that to a certain
 *     extent, but there are some clear differences between goals. This tag's
 *     purpose is to make it easy to reinvoke a previous command by number,
 *     name, or regex match. To the extent that this is done by reprocessing the
 *     prior command's text as a new buffer you can consider it substitution.
 *     However, the tsh:history mechanism does not work inside of strings and it
 *     only partially concerns itself with "word" access within a prior command
 *     buffer.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:history');

TP.tsh.history.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  TSH Execution Support
//  ------------------------------------------------------------------------

TP.tsh.history.Type.defineMethod('cmdRunContent',
function(aRequest) {

    /**
     * @method cmdRunContent
     * @summary
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {Object}
     */

    var shell,

        hid,

        str,
        req,
        output,
        isEdit,
        origReq;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    hid = shell.getArgument(aRequest, 'tsh:hid', null, false);

    //  Initial ! is stripped by desugaring so we have just the "second char"
    //  which should either be ? or blank for "all history" shorthand.
    if (TP.isEmpty(hid) || hid === '?') {
        output = '<dl>';
        shell.get('history').perform(
                        function(aShellReq) {
                            var id;

                            id = aShellReq.at('cmdHistoryID');
                            output +=
                                '<dt>' +
                                    '<a href="#" onclick="TP.bySystemId(\'SherpaConsoleService\').sendConsoleRequest(\':snippet hid=' + id + '\'); return false;">' +
                                    '+' +
                                    '</a>' +
                                    '&#160;&#160;' +
                                    '<a href="#" onclick="TP.bySystemId(\'SherpaConsoleService\').sendConsoleRequest(\'!' + id + '\'); return false;">' +
                                    '!' + id +
                                    '</a>' +
                                    '&#160;&#160;' +
                                    '<a href="#" onclick="TP.bySystemId(\'SherpaConsoleService\').sendConsoleRequest(\'#' + id + '\'); return false;">' +
                                    '#' + id +
                                    '</a>' +
                                '</dt>' +
                                '<dd>' +
                //  We don't use a CDATA section here because we can't copy and
                //  paste entries from history on Chrome when we do:
                //  https://bugs.chromium.org/p/chromium/issues/detail?id=696551
                                    TP.xmlLiteralsToEntities(
                                                    aShellReq.at('cmd')) +
                                '</dd>';
                        });

        output += '</dl>';

        aRequest.atPut('cmdAsIs', true);

        return aRequest.complete(output);
    }

    hid = TP.str(hid);
    str = this.translateHistoryReference(hid, aRequest, shell, false);
    if (TP.isEmpty(str)) {
        //  report on specific error should come from translation
        aRequest.fail();
        return;
    }

    //  if no translation really occurred then we should terminate
    if (str === hid) {
        aRequest.fail(
            TP.sc('History translation failed.'));
        return;
    }

    //  if we got history back we can't process that...
    if (str.indexOf('tsh:history') !== TP.NOT_FOUND) {
        aRequest.fail(
            TP.sc('Recursive history translation unsupported.'));
        return;
    }

    //  aRequest's 'rootRequest's (if it has one) 'cmd' will be something
    //  like '!1', but we want the title text to be that of the command that
    //  we're executing.
    if (TP.notValid(origReq = aRequest.at('rootRequest'))) {
        origReq = aRequest;
    }

    isEdit = shell.getArgument(aRequest, 'tsh:edit', false, false);
    if (TP.bc(isEdit)) {
        req = TP.sig.ConsoleRequest.construct(
                                    TP.hc('cmd', 'input', 'body', str));
        req.fire(shell);

        //  This is a bit hackish - having to put the cmdInput flag on the
        //  response to avoid having the console blow away the input cell
        //  content...
        origReq.getResponse().atPut('cmdInput', true);

        return aRequest.complete(TP.TSH_NO_VALUE);
    }

    //  Construct a new request that can process the history event and
    //  notify the current request when complete.
    req = TP.sig.ShellRequest.construct(
            TP.hc('cmd', str,
                    'cmdAllowSubs', aRequest.at('cmdAllowSubs'),
                    'cmdAsIs', aRequest.at('cmdAsIs'),
                    'cmdExecute', true,
                    //  Do not make a history entry for this request. A history
                    //  entry will be made for the main request that started us.
                    'cmdHistory', false,
                    //  Do not build GUI for this request.
                    'cmdBuildGUI', false,
                    'cmdLiteral', aRequest.at('cmdLiteral'),
                    'cmdPeer', aRequest,
                    'cmdPhases', aRequest.at('cmdPhases'),
                    'cmdRecycle', aRequest.at('cmdRecycle'),
                    //  We configure this request as silent since we don't want
                    //  it to output to stdout. We will output its result
                    //  through the main request that started us in the
                    //  'completeJob' below.
                    'cmdSilent', true
            ));

    origReq.atPut('cmdTitle', str);

    req.defineMethod('cancelJob',
        function(aFaultString, aFaultCode, aFaultInfo) {

            return aRequest.cancel(aFaultString, aFaultCode, aFaultInfo);
        });
    req.defineMethod('completeJob',
        function(aResult) {

            return aRequest.complete(aResult || req.getResult());
        });
    req.defineMethod('failJob',
        function(aFaultString, aFaultCode, aFaultInfo) {

            return aRequest.fail(aFaultString, aFaultCode, aFaultInfo);
        });

    //  run that baby!
    shell[TP.composeHandlerName('ShellRequest')](req);

    return;
});

//  ------------------------------------------------------------------------

TP.tsh.history.Type.defineMethod('translateHistoryReference',
function(aString, aRequest, aShell, expand) {

    /**
     * @method translateHistoryReference
     * @summary Translates a history reference to the appropriate replacement
     *     string. History entries come in the form #n[:w] where the N can be an
     *     absolute or relative reference to a history entry and W represents a
     *     word specifier.
     * @param {String} aString The history reference to replace.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @param {TP.shell.Shell} aShell The shell handling processing and holding
     *     the history list.
     * @returns {String|undefined} The history replacement.
     */

    var rest,

        arr,
        token,

        parts,
        re,

        cmd,

        index,
        num,

        ref,
        tail,
        ndx,
        found,

        str,

        reg,
        list,
        i;

    //  initialize rest to empty string. we'll reset as needed during
    //  processing
    rest = '';

    //  ---
    //  command access
    //  ---

    if (aString === '!') {
        //  entry is the last command
        cmd = aShell.getHistory(-1, expand);
    } else if (aString.charAt(0) === '/') {
        //  should be able to tokenize a regex token from the string which
        //  will help avoid noise around embedded symbols like :
        arr = TP.$tokenize(aString);
        token = arr.at(0);
        if (TP.notValid(token) || token.name !== 'regexp') {
            aRequest.fail(
                TP.sc('Invalid history regex specification'));

            return;
        }

        parts = token.value.split('/');
        re = TP.rc(RegExp.escapeMetachars(parts.at(1)), parts.at(2));
        if (TP.notValid(re)) {
            aRequest.fail(
                TP.sc('Invalid history regex specification'));

            return;
        }

        //  constructed the regex, now off to find the command :)
        cmd = aShell.getHistory(re, expand);
    } else if (/^[\-0-9]/.test(aString)) {
        //  numerical with/without '-' prefixing. split off any word portion
        //  and find the command at that index if possible.
        parts = aString.split(':');
        index = parts.at(0);

        num = index === '0' ? 0 : parseInt(index, 10);
        if (!TP.isNumber(num)) {
            aRequest.fail(
                TP.sc('Invalid history index.'));

            return;
        }

        //  If the user specified a negative index, then we need to adjust the
        //  index to be the current history list size minus that number of
        //  entries (per normal sh behavior)
        if (aString.charAt(0) === '-') {
            //  Note we add here. Since value is negative,we'll back up.
            num = aShell.getHistory().getSize() + num;
        }

        cmd = aShell.getHistory(num, expand);
    } else {
        //  alpha reference, but not a regex...? exact match for start
        cmd = aShell.getHistory(aString, expand);
    }

    //  if we didn't find a command no point in continuing. also, if the command
    //  we did find is just the current entry we're looking for, it's
    //  nonsensical to continue - it's self-referential and will result in an
    //  endless recursion.
    /* eslint-disable no-extra-parens */
    if (TP.isEmpty(cmd) || (cmd === '!' + aString)) {
        aRequest.fail(
            TP.sc('Unable to find specified history entry.'));

        return;
    }
    /* eslint-enable no-extra-parens */

    if (cmd === '!' || cmd === '!?') {
        return ':history';
    }

    //  if we got a reference to another history execution do a deeper
    //  translation
    while (/^!\d*/.test(cmd)) {
        cmd = this.translateHistoryReference(
            cmd.slice(1), aRequest, aShell, expand);

        //  If we translated from a numeric reference try to push the translated
        //  text back up to the root request so it's reflected in history rather
        //  than a reference to a numerical entry.
        if (TP.notEmpty(cmd)) {
            if (aRequest.at('rootRequest')) {
                aRequest.at('rootRequest').atPut('cmd', cmd);
            } else {
                aRequest.atPut('cmd', cmd);
            }
        }
    }

    //  ---
    //  word access
    //  ---

    if (!TP.regex.HAS_COLON.test(aString)) {
        //  no word specifier...we're done
        return cmd;
    }

    //  the history reference is any portion ahead of an optional word
    //  specifier (:), which _must_ not be the first char since we allow
    //  searches to include command text such as :history
    if (TP.regex.HAS_COLON.test(aString)) {
        //  tricky part here is that if we're looking at :alpha then it's
        //  probably a request for an old command
        if (/^:[^\+\-0-9]/.test(aString)) {
            ref = aString;
        } else if (/^:/.test(aString)) {
            ref = '!' + aString;

            arr = ref.split(':');
            ref = arr.at(0);

            if (arr.getSize() > 1) {
                arr.shift();
                //  tail = arr.join('');
            }
        } else {
            arr = aString.split(':');
            ref = arr.at(0);

            arr.shift();
            tail = arr.join('');
        }
    } else {
        ref = aString;
    }

    //  if start is a +/- we're a relative address, else absolute
    if (/^[+\-]/.test(ref)) {
        //  relative, question is do we have an offset?
        if (ref.getSize() === 1) {
            //  +/- only so our index is just 1
            ndx = 1;
        } else {
            //  more than just +/- so we need to see what's there
            ndx = ref.slice(1);
            if (/^[0-9]/.test(ndx)) {
                if (TP.isNaN(parseInt(ndx, 10))) {
                    //  might be a #-2.doMore() where the .doMore() is being
                    //  added to the history reference

                    /* eslint-disable no-extra-parens */
                    if ((found = ndx.match(/[^0-9]/))) {
                    /* eslint-enable no-extra-parens */
                        //  have to split at boundary between numbers and
                        //  text
                        ndx = ndx.slice(0, found);
                        rest = ndx.slice(found);
                    } else {
                        aRequest.fail(
                            TP.sc('Invalid history index.'));

                        return;
                    }
                } else {
                    //  just a number with no trailing non-numerics
                    ndx = parseInt(ndx, 10);
                }
            } else {
                //  didn't follow +/- with a number...not valid
                aRequest.fail(
                    TP.sc('Invalid history index.'));

                return;
            }
        }

        if (ref.charAt(0) === '+') {
            ndx = aShell.get('historyIndex') + ndx - 1;
            str = aShell.getHistory(ndx);
        } else {
            ndx = aShell.get('historyIndex') - ndx - 1;
            str = aShell.getHistory(ndx);
        }
    } else {
        //  absolute reference

        //  does it start with a number? if so we need to look for the
        //  specific numeric reference
        if (/^[0-9]/.test(ref)) {
            if (TP.isNaN(parseInt(ref, 10))) {
                //  might be a #23.doMore() where the .doMore() is being
                //  added to the history reference

                /* eslint-disable no-extra-parens */
                if ((found = ndx.match(/[^0-9]/))) {
                /* eslint-enable no-extra-parens */
                    //  have to split at boundary between numbers and text
                    ndx = ndx.slice(0, found);
                    rest = ndx.slice(found);
                } else {
                    aRequest.fail(
                        TP.sc('Invalid history index.'));

                    return;
                }
            } else {
                str = aShell.getHistory(parseInt(ref, 10));
            }
        } else {
            //  must be # or an alpha reference
            if (/^!/.test(ref)) {
                //  ## means the same as !! (last entry)
                ndx = aShell.get('historyIndex') - 1;
                str = aShell.getHistory(ndx);

                //  pull off the # and process any word/rest text
                ref = ref.slice(1);

                if (TP.notValid(tail)) {
                    rest = ref;
                }
            } else if (/^\?/.test(ref)) {
                //  dump the history list
                return ':history';
            } else {
                //  looks like an alpha reference which we treat like
                //  a regex and try to find in the list
                str = '';
                reg = TP.rc('^' + ref);
                list = aShell.get('history');

                for (i = list.getSize() - 1; i >= 0; i--) {
                    if (reg.test(str = aShell.getHistory(i))) {
                        break;
                    }
                }
            }
        }
    }

    //  if there was no tail (word index) just return the string
    if (TP.notValid(tail)) {
        return TP.ifInvalid(str + rest, '');
    }

    //  found a word index so process it on the current string
    if (TP.isNaN(parseInt(tail, 10))) {
        //  might be a #23:1.doMore() where the .doMore() is being
        //  added to the history reference
        /* eslint-disable no-extra-parens */
        if ((found = tail.match(/[^0-9]/))) {
        /* eslint-enable no-extra-parens */
            //  have to split at boundary between numbers and text
            ndx = tail.slice(0, found);
            rest = tail.slice(found);
        } else {
            aRequest.fail(
                TP.sc('Invalid history index.'));

            return;
        }
    } else {
        ndx = tail;
    }

    str = str.split(' ').at(ndx);

    return TP.isString(str) ? str + rest : '';
});

//  ------------------------------------------------------------------------

TP.tsh.history.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.ShellRequest} aRequest The request containing command
     *     input for the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    return this.cmdRunContent(aRequest);
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('history',
    TP.tsh.history.Type.getMethod('cmdRunContent'),
    'Displays a list of recent commands.',
    ':history' +
    ':history --hid=\'?\' [--edit]\n' +
    ':history --hid=\'!\' [--edit]\n' +
    ':history --hid=\'/regexp/\' [--edit]\n' +
    ':history --hid=7 [--edit]\n' +
    ':history --hid=-1 [--edit]\n' +
    ':history --hid=\'cmdmatch\' [--edit]\n',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.import.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.import}
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:import');

TP.tsh.import.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.import.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @description This command imports the source file referenced if it can be
     *     found. The primary value of this command is that it allows simple
     *     file patterns to be used to determine which file might be desired.
     *     For example, :import TIBETGlobals or simply Globals is enough for
     *     this command to locate the full path to the proper file and to
     *     import it.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,

        input,

        ref,
        options,

        file,
        flag,

        url,
        resp,
        src,

        debug;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    //  No arguments means we dump usage.
    if (!shell.hasArguments(aRequest)) {
        return this.printUsage(aRequest);
    }

    if (TP.notValid(aRequest.at('cmdNode'))) {
        return aRequest.fail();
    }

    //  NB: We supply 'null' as the default value if 'tsh:href' wasn't
    //  specified.
    input = shell.getArgument(aRequest, 'tsh:href', null, true);
    if (TP.notValid(input)) {
        if (TP.isEmpty(input = aRequest.stdin())) {
            return aRequest.fail('Invalid package/file reference.');
        }
    } else {
        input = TP.ac(input);
    }

    if (input.getSize() > 1) {
        aRequest.fail('Import limited to a single target.');
        return;
    }

    ref = input.at(0);

    if (/@/.test(ref)) {

        /* eslint-disable no-loop-func */
        TP.sys.importPackage(ref).then(function(result) {
            aRequest.complete(ref);
        }).catch(function(err) {
            aRequest.fail(
                'tsh:import failed to load ' + ref);
        });
        /* eslint-enable no-loop-func */

        //  NOTE we have to return here and let promise do the rest.
        return;

    } else {
        ref = TP.uriExpandPath(ref);
    }

    options = TP.boot.$$loadpaths.grep(ref);
    if (TP.isEmpty(options)) {
        //  a file we've never seen before
        options = TP.ac(ref);
    }

    //  ambiguous...
    if (options.getSize() > 1) {
        aRequest.fail(
            'Multiple choices: ' + TP.src(options));
        return;
    }

    file = options.collapse();
    try {
        flag = TP.sys.shouldLogCodeChanges();
        TP.sys.shouldLogCodeChanges(false);

        /*
        root.stdout('tsh:import loading source from ' + file,
                        aRequest);
        */

        url = TP.uc(file);
        if (TP.notValid(url)) {
            aRequest.fail(
                'tsh:import failed to load ' + file);
            return;
        }

        resp = url.getResource(TP.hc('refresh', true, 'async', false));
        if (TP.notValid(src = resp.get('result'))) {
            aRequest.fail(
                'tsh:import failed to load ' + file);
            return;
        }

        debug = TP.sys.shouldUseDebugger();
        TP.sys.shouldUseDebugger(false);

        //  This will take care of initializing any newly-defined types if a)
        //  they define an 'initialize' method and b) if they haven't been
        //  initialized before.
        TP.boot.$sourceImport(src, null, TP.str(url), true);

    } catch (e) {
        aRequest.fail(
            TP.ec(e, 'tsh:import failed to load ' + file));
        return;
    } finally {
        TP.sys.shouldLogCodeChanges(flag);
        TP.sys.shouldUseDebugger(debug);
    }

    aRequest.complete(url.getLocation());

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('import',
    TP.tsh.import.Type.getMethod('tshExecute'),
    'Loads/executes a JavaScript/TIBET source file.',
    ':import --href <importurl>\n' +
    ':import --href <@package>',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.inspect.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.inspect}
 * @summary A subtype of TP.tag.ActionTag that knows how to
 *     conditionally process its child actions based on a binding expression.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:inspect');

TP.tsh.inspect.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.inspect.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,

        arg0,
        url,
        obj,

        path,

        showBusy,
        pathParts,

        addTargetAsRoot;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    //  No arguments means we dump usage.
    if (!shell.hasArguments(aRequest)) {
        return this.printUsage(aRequest);
    }

    arg0 = shell.getArgument(aRequest, 'ARG0');

    if (TP.regex.URI_LIKELY.test(arg0) &&
        !TP.regex.REGEX_LITERAL_STRING.test(arg0)) {
        url = shell.expandPath(arg0);
        if (TP.isURI(url = TP.uc(url))) {
            obj = url;
        } else {
            obj = shell.resolveObjectReference(arg0, aRequest);
        }
    } else {
        obj = shell.resolveObjectReference(arg0, aRequest);
    }

    path = shell.getArgument(aRequest, 'tsh:path', '', false);

    //  Convert '/'s to TP.PATH_SEP (but preserve backslashed '/'s)
    path = TP.stringSplitSlashesAndRejoin(path, TP.PATH_SEP);

    showBusy = true;

    if (TP.notEmpty(path)) {
        pathParts = path.split(TP.PATH_SEP);
        if (pathParts.getSize() === 1) {
            showBusy = false;
        }
    }

    addTargetAsRoot = TP.bc(shell.getArgument(
                                    aRequest, 'tsh:addroot', false, false));

    //  Fire a 'InspectObject' signal, supplying the target object to focus on.
    TP.signal(null,
                'InspectObject',
                TP.hc('targetObject', obj,
                        'targetAspect', TP.id(obj),
                        'targetPath', path,
                        'addTargetAsRoot', addTargetAsRoot,
                        'showBusy', showBusy));

    aRequest.complete(TP.TSH_NO_VALUE);

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('inspect',
    TP.tsh.inspect.Type.getMethod('tshExecute'),
    'Generates an inspector for stdin data.',
    ':inspect <target> [--path <path>] [--addroot]',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.interests.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.interests}
 * @summary A subtype of TP.tag.ActionTag that knows how to
 *     conditionally process its child actions based on a binding expression.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:interests');

TP.tsh.interests.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.interests.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    aRequest.stdout('Coming soon.');

    aRequest.complete(TP.TSH_NO_VALUE);

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('interests',
    TP.tsh.interests.Type.getMethod('tshExecute'),
    'Displays the system signal interest map.',
    ':interests',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.keys.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.keys}
 * @summary Dumps a list of keyboard shortcuts for the Sherpa.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:keys');

TP.tsh.keys.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.keys.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,
        keys,

        output;

    shell = aRequest.at('cmdShell');

    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    keys = TP.hc(
        'Alt-UpArrow', 'Show/Hide HUD',
        'Shift-Shift', 'Focus Input Cell',
        'Shift-Return', 'Execute',

        'Ctrl-U', 'Clears the input cell of content',
        'Ctrl-K', 'Clears the output area of all output cells',
        'Ctrl-A', 'Activates auto-complete mode.',

        'Ctrl-DownArrow', 'Cycle output mode downward (will wrap)',
        'Ctrl-UpArrow', 'Cycle output mode upward (will wrap)',

        'Shift-DownArrow', 'Move to "next" history entry (will not wrap)',
        'Shift-UpArrow', 'Move to "last" history entry (will not wrap)',

        'DownArrow', 'Scroll last output cell down 1 line',
        'UpArrow', 'Scroll last output cell up 1 line',

        'PageDown', 'Scroll last output cell down 1 page',
        'PageUp', 'Scroll last output cell up 1 page',

        'Esc', 'Cancels an autocomplete operation',
        'Shift-Esc', 'Cancels a multi-prompt request sequence'
    );

    output = '<dl>';

    keys.perform(
        function(kvPair) {
            output += '<dt>' + kvPair.first() + '</dt>' +
                        '<dd>' + kvPair.last() + '</dd>';
        });

    output += '</dl>';

    aRequest.atPut('cmdAsIs', true);

    aRequest.complete(output);

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('keys',
    TP.tsh.keys.Type.getMethod('tshExecute'),
    'Lists keyboard shortcuts for the Sherpa toolset.',
    ':keys',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.halo.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.halo}
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:halo');

TP.tsh.halo.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.halo.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Turns on/off whether we are currently watching remote resources.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,

        arg0,
        halo;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    //  No arguments and no '--all' parameter means we dump usage.
    if (!shell.hasArguments(aRequest)) {
        return this.printUsage(aRequest);
    }

    arg0 = shell.getArgument(aRequest, 'ARG0');

    if (TP.isValid(arg0)) {

        if (TP.isNode(arg0)) {
            arg0 = TP.wrap(arg0);
        } else if (TP.isString(arg0)) {
            //  Note the lookup on the current UICANVAS.
            arg0 = TP.byId(arg0);
        }

        if (TP.isKindOf(arg0, TP.dom.Node)) {
            halo = TP.byId('SherpaHalo', TP.sys.getUIRoot());
            if (TP.isValid(halo)) {

                halo.blur();
                halo.focusOn(arg0);
            }
        }
    }

    aRequest.complete(TP.TSH_NO_VALUE);

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('halo',
    TP.tsh.halo.Type.getMethod('tshExecute'),
    'Focuses the halo on the node resolved by the supplied argument',
    ':halo <target>',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.method/TP.tsh.method.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.method}
 * @summary A subtype of TP.tag.ActionTag that knows how to create new
 *     types in the TIBET system.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:method');

TP.tsh.method.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.method.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,
        shouldAssist,

        methodOwner,
        methodOwnerType,

        methodName,

        wholeName,

        methodTrack,

        methodKind,

        defMethod,
        desc,
        target,

        newMethod,

        methodSrc,

        patchText,

        sourceLoc,
        sourceURI,

        existingMethodResource,

        putParams,
        saveRequest;

    shell = aRequest.at('cmdShell');

    shouldAssist = TP.bc(shell.getArgument(
                                    aRequest, 'tsh:assist', null, false));

    if (shouldAssist) {

        //  Fire a 'AssistObject' signal, supplying the target object to focus
        //  on.
        TP.signal(
                null,
                'AssistObject',
                TP.hc('targetObject', this,
                        'title', 'Method Assistant',
                        'assistantParams', TP.hc('originalRequest', aRequest)));

        return aRequest.complete(TP.TSH_NO_VALUE);
    }

    methodOwner = shell.getArgument(aRequest, 'tsh:owner', null, false);
    if (TP.isEmpty(methodOwner)) {
        //  TODO: Raise an exception
        return;
    } else {

        methodOwnerType = TP.sys.getTypeByName(methodOwner);
        if (!TP.isType(methodOwnerType)) {
            //  TODO: Raise an exception
            return;
        }
    }

    methodName = shell.getArgument(aRequest, 'tsh:name', null, false);
    if (TP.isEmpty(methodName)) {
        //  TODO: Raise an exception
        return;
    }

    //  It can be either a regular method or a handler

    methodKind = shell.getArgument(aRequest, 'tsh:kind', null, false);
    if (TP.isEmpty(methodKind)) {
        //  TODO: Raise an exception
        return;
    }

    if (methodKind === 'handler') {
        defMethod = 'defineHandler';
        desc = {
            signal: methodName
        };
        wholeName = TP.composeHandlerName(desc);
    } else {
        defMethod = 'defineMethod';
        wholeName = methodName;
    }

    //  It can be a type, instance or type local method

    methodTrack = shell.getArgument(aRequest, 'tsh:track', null, false);
    if (TP.isEmpty(methodTrack)) {
        //  TODO: Raise an exception
        return;
    }

    if (methodTrack === 'type') {
        target = methodOwnerType.Type;
    } else if (methodTrack === 'instance') {
        target = methodOwnerType.Inst;
    } else if (methodTrack === 'typelocal') {
        target = methodOwnerType;
    }

    if (TP.notValid(target) || !TP.isMethod(target[defMethod])) {
        //  TODO Raise an exception
        return;
    }

    //  Make sure that the method isn't already defined
    if (TP.owns(target, wholeName)) {
        aRequest.stderr('Method already exists: ' + wholeName);
        aRequest.complete(TP.TSH_NO_VALUE);

        return;
    }

    //  Define the method (by invoking the computed method definition name
    //  against the target) dynamically in the system.

    //  NOTE NOTE NOTE: The following method bodies are formatted this way
    //  because they, along with their embedded whitespace, will be used as the
    //  templates for new, empty method bodies at the global scope in the
    //  receiving type. Therefore, indenting lint rules have been switched off
    //  and they have been formatted this way on purpose.

    /* eslint-disable indent */

    //  If it's a handler, make sure to include the 'aSignal' parameter.
    if (methodKind === 'handler') {
        newMethod = target[defMethod](
                        methodName,
                        function(aSignal) {
    //  empty
});
    } else {
        newMethod = target[defMethod](
                        methodName,
                        function() {
    //  empty
});
    }

    /* eslint-enable indent */

    newMethod[TP.LOAD_PATH] = methodOwnerType[TP.LOAD_PATH];
    newMethod[TP.LOAD_PACKAGE] = methodOwnerType[TP.LOAD_PACKAGE];
    newMethod[TP.LOAD_CONFIG] = methodOwnerType[TP.LOAD_CONFIG];
    newMethod[TP.LOAD_STAGE] = methodOwnerType[TP.LOAD_STAGE];

    newMethod[TP.SOURCE_PATH] = methodOwnerType[TP.SOURCE_PATH];
    newMethod[TP.SOURCE_PACKAGE] = methodOwnerType[TP.SOURCE_PACKAGE];
    newMethod[TP.SOURCE_CONFIG] = methodOwnerType[TP.SOURCE_CONFIG];

    //  Tag this method as 'not yet having persisted'
    newMethod[TP.IS_PERSISTED] = false;

    methodSrc = '\n' + TP.src(newMethod);

    //  The patch text will be the first item in the Array returned by
    //  getMethodPatch.
    patchText = newMethod.getMethodPatch(methodSrc, false).first();

    //  If the path is a URI and the patch contains '@@', then there were diffs
    //  and the URI should be dirtied.
    if (patchText.contains('@@')) {

        //  Grab the source URI and it's existing method resource.
        sourceLoc = TP.objectGetSourcePath(newMethod);
        sourceURI = TP.uc(sourceLoc);

        existingMethodResource = sourceURI.getResource();
        existingMethodResource.then(
            function(aResult) {
                var finalContent;

                //  Apply the patch to the source URI's current content and set
                //  the result as the URI's new content.
                finalContent = TP.extern.Diff.applyPatch(aResult, patchText);
                sourceURI.setResource(finalContent);

                //  If the '--push' flag was supplied, then save the URI
                //  contents to the server immediately.
                if (shell.getArgument(aRequest, 'tsh:push', null, false)) {

                    putParams = TP.hc('method', TP.HTTP_PUT);
                    saveRequest = sourceURI.constructRequest(putParams);

                    saveRequest.defineHandler('RequestSucceeded',
                        function(aResponse) {
                            delete newMethod[TP.IS_PERSISTED];
                            this.signal('MethodAdded');
                        }.bind(this));

                    saveRequest.defineHandler('RequestFailed',
                        function(aResponse) {
                            //  empty
                        });

                    saveRequest.defineHandler('RequestCompleted',
                        function(aResponse) {
                            //  empty
                        });

                    //  Do the deed.
                    sourceURI.save(saveRequest);
                } else {
                    this.signal('MethodAdded');
                }
            }.bind(this));
    }

    aRequest.complete(TP.TSH_NO_VALUE);

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.tsh.method.Type.defineMethod('getContentForAssistant',
function() {

    /**
     * @method getContentForAssistant
     * @summary Returns the Element representing the root node of the content
     *     for the receiver's 'assistant'.
     * @returns {Element} The root node of the receiver's assistant content.
     */

    var assistantTPElem;

    assistantTPElem = TP.tsh.method_assistant.getResourceElement(
                        'template',
                        TP.ietf.mime.XHTML);

    return TP.unwrap(assistantTPElem);
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.method/TP.tsh.method_assistant.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @type {TP.tsh.method_assistant}
 */

//  ------------------------------------------------------------------------

TP.tsh.CommandAssistant.defineSubtype('tsh.method_assistant');

//  Note how this property is TYPE_LOCAL, by design.
TP.tsh.method_assistant.defineAttribute('themeURI', TP.NO_RESULT);

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.tsh.method_assistant.Inst.defineMethod('generateCommand',
function(info) {

    /**
     * @method generateCommand
     * @summary Generates the command text that will be sent to the shell if the
     *     user dismisses the assistant by clicking 'ok'.
     * @param {TP.core.Hash} info The hash containing the command parameters.
     * @returns {String} The generated command string.
     */

    var track,
        name,

        str;

    if (info.at('methodTrack') === 'instance') {
        track = TP.INST_TRACK;
    } else if (info.at('methodTrack') === 'typelocal') {
        track = TP.TYPE_LOCAL_TRACK;
    } else {
        track = TP.TYPE_TRACK;
    }

    if (info.at('methodKind') === 'handler') {
        name = 'handle' + info.at('methodName') + 'FromANYWhenANY';
    } else {
        name = info.at('methodName');
    }

    str = ':method --name=\'' + info.at('methodName') + '\'' +
            ' --kind=\'' + info.at('methodKind') + '\'' +
            ' --owner=\'' + info.at('methodOwnerTypeName') + '\'' +
            ' --track=\'' + info.at('methodTrack') + '\'' +
            '; ' +
            ':inspect ' + info.at('methodOwnerTypeName') + '.' +
                            track + '.' +
                            name;

    return str;
});

//  ------------------------------------------------------------------------

TP.tsh.method_assistant.Inst.defineMethod('getAssistantModelURI',
function() {

    /**
     * @method getAssistantModelURI
     * @summary Returns the URI containing the model that the assistant is using
     *     to manage all of the selections in its panel.
     * @returns {TP.uri.URI} The URI containing the assistant model.
     */

    return TP.uc('urn:tibet:method_cmd_source');
});

//  ------------------------------------------------------------------------

TP.tsh.method_assistant.Inst.defineHandler('DialogCancel',
function(anObject) {

    /**
     * @method handleDialogCancel
     * @summary Handles when the user has 'canceled' the dialog (i.e. wants to
     *     proceed without taking any action).
     * @param {TP.sig.DialogCancel} aSignal The TIBET signal which triggered
     *     this method.
     * @returns {TP.tsh.method_assistant} The receiver.
     */

    this.callNextMethod();

    this.signal('MethodAdditionCancelled');

    return this;
});

//  ------------------------------------------------------------------------

TP.tsh.method_assistant.Inst.defineMethod('setOriginalRequest',
function(anObj) {

    /**
     * @method setOriginalRequest
     * @summary Sets the original request received by the command that triggered
     *     the assistant.
     * @param {TP.sig.Request} anObj The original request that was supplied to
     *     the assistant via the command.
     * @returns {TP.tsh.method_assistant} The receiver.
     */

    var shell,
        args,

        typeInfo,
        topLevelInfo,

        modelURI,
        modelObj;

    this.callNextMethod();

    //  Configure the GUI using the argument values that we can derive from the
    //  original request

    shell = anObj.at('cmdShell');
    args = shell.getArguments(anObj);

    topLevelInfo = TP.hc();

    typeInfo = TP.hc();
    topLevelInfo.atPut('info', typeInfo);

    typeInfo.atPut('methodName',
                    TP.ifInvalid(args.at('tsh:name'), 'newMethod'));
    typeInfo.atPut('methodKind',
                    TP.ifInvalid(args.at('tsh:kind'), 'method'));
    typeInfo.atPut('methodOwnerTypeName',
                    TP.ifInvalid(args.at('tsh:owner'), ''));
    typeInfo.atPut('methodTrack',
                    TP.ifInvalid(args.at('tsh:track'), 'instance'));

    //  Set up a model URI and observe it for change ourself. This will allow us
    //  to regenerate the tag representation as the model changes.
    modelURI = this.getAssistantModelURI();
    this.observe(modelURI, 'ValueChange');

    //  Construct a JSONContent object around the model object so that we can
    //  bind to it using the more powerful JSONPath constructs
    modelObj = TP.core.JSONContent.construct(TP.js2json(topLevelInfo));

    //  Set the resource of the model URI to the model object, telling the URI
    //  that it should observe changes to the model (which will allow us to get
    //  notifications from the URI which we're observing above) and to go ahead
    //  and signal change to kick things off.
    modelURI.setResource(
        modelObj, TP.hc('observeResource', true, 'signalChange', true));

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.defineSubtype('MethodAdditionCancelled');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.open.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.open}
 * @summary A subtype of TP.tag.ActionTag that knows how to
 *     conditionally process its child actions based on a binding expression.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:open');

TP.tsh.open.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.open.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @description This command opens a URI in a window and completes when the
     *     onload handler within that window has properly triggered. NOTE that
     *     this is only consistent when the tibet_hook.js file is included as
     *     part of the page being loaded. When the hook file isn't available the
     *     results may be less consistent.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    //  No arguments means we dump usage.
    if (!shell.hasArguments(aRequest)) {
        return this.printUsage(aRequest);
    }

    aRequest.stdout('Coming soon.');

    aRequest.complete(TP.TSH_NO_VALUE);

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('open',
    TP.tsh.open.Type.getMethod('tshExecute'),
    'Opens a URI in a window/canvas.',
    ':open <url>',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.package.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.package}
 * @summary A subtype of TP.tag.ActionTag that knows how to
 *     conditionally process its child actions based on a binding expression.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:package');

TP.tsh.package.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.package.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,

        unlisted,

        profile,
        profileParts,

        promise,

        results,

        packageEntries,
        scriptEntries,

        packageOutputEntries,
        scriptOutputEntries,

        libSrcPath,

        shouldFix,

        newArgs,

        str,

        allOutputEntries,

        uri;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    //  No arguments means we dump usage.
    if (!shell.hasArguments(aRequest)) {
        return this.printUsage(aRequest);
    }

    //  Are we looking for unlisted paths?
    unlisted = shell.getArgument(aRequest, 'tsh:unlisted', null, false);

    //  NB: We don't default the value here, because we default it to different
    //  values depending on other flags.
    profile = shell.getArgument(aRequest, 'tsh:profile', null, false);

    if (TP.isString(profile)) {
        profile = profile.unquoted();
    } else if (unlisted) {
        profile = TP.sys.cfg('project.packaging.profile', 'main@base');
    } else {
        profile = TP.sys.cfg('boot.profile', 'main@base');
    }

    //  If we're looking for unlisted paths, then we have to ask the system for
    //  script paths that belong to methods that were actually invoked.
    if (unlisted) {
        promise = TP.sys.getMissingPackagingInfo(profile);

        promise.then(
            function() {

                //  NB: These contain fully expanded paths
                packageEntries = results.at('packageEntries');
                scriptEntries = results.at('scriptEntries');

                //  We want to make all package and script paths that *start*
                //  with the '~lib_src' path be relative to '~lib_src', since
                //  they're going to be added to the application's 'alacarte'
                //  target, which already has a basedir of '~lib_src'.

                //  Compute the fully expanded path to '~lib_src'.
                libSrcPath = TP.uriExpandPath('~lib_src');

                //  Iterate over all of the package entries and make their
                //  scripts relative to the fully expanded '~lib_src' path *if
                //  they start with it*.
                packageOutputEntries = packageEntries.collect(
                    function(anEntry) {
                        var outEntry,
                            path;

                        outEntry = TP.ac('package',
                                            anEntry[TP.LOAD_INDEX],
                                            anEntry[TP.PACKAGING_REP]);

                        //  The path here was already expanded by the call that
                        //  produced these results.
                        path = anEntry[TP.PACKAGING_REP].split('@').first();

                        if (path.startsWith(libSrcPath)) {
                            outEntry.push(
                                    TP.uriRelativeToPath(path, libSrcPath));
                        } else {
                            outEntry.push(path);
                        }

                        return outEntry;
                    });

                //  Iterate over all of the script entries and make their
                //  scripts relative to the fully expanded '~lib_src' path *if
                //  they start with it*.
                scriptOutputEntries = scriptEntries.collect(
                    function(anEntry) {
                        var outEntry,
                            path;

                        outEntry = TP.ac('script',
                                            anEntry[TP.LOAD_INDEX],
                                            anEntry[TP.PACKAGING_REP]);

                        //  The path here was already expanded by the call that
                        //  produced these results.
                        path = anEntry[TP.PACKAGING_REP];

                        if (path.startsWith(libSrcPath)) {
                            outEntry.push(
                                    TP.uriRelativeToPath(path, libSrcPath));
                        } else {
                            outEntry.push(path);
                        }

                        return outEntry;
                    });

                //  If the user is asking us to fix this situation, then we
                //  invoke a remote command to actually patch these into the
                //  config matching the profile.
                shouldFix = shell.getArgument(aRequest, 'tsh:fix', null, false);

                //  TODO: This line should be removed when '--fix' capability is
                //  available in the TDS version of the 'package' command.
                shouldFix = false;

                if (shouldFix) {

                    //  Iterate over all of the paths and escape spaces, since
                    //  we're going to join them all together on a space.
                    results = results.collect(
                                function(aPath) {
                                    return aPath.replace(/ /g, '\\ ');
                                });

                    //  Join all of the paths together with spaces.
                    results = results.join(' ');

                    //  Build a new set of arguments, leaving out the 'unlisted'
                    //  and 'fix' flags and adding the 'add' flag and the paths
                    //  to be added.
                    newArgs = TP.hc(
                                'ARGV', TP.ac(),
                                'tsh:profile', TP.ac(profile, profile),
                                'tsh:add', TP.ac(results, results));

                    aRequest.set('ARGUMENTS', newArgs);

                    TP.signal(null, 'RemoteConsoleCommand',
                        TP.hc(
                            'originalRequest', aRequest,
                            'timeout', 60000,
                            TP.ONSUCCESS, function(aResponse) {

                                var successOutputReq;

                                successOutputReq =
                                    TP.sig.UserOutputRequest.construct(
                                        TP.hc(
                                        'output', 'Profile \'' +
                                                    profile +
                                                    '\' updated.',
                                        'async', true,
                                        'cmdAsIs', true));

                                successOutputReq.fire(shell);
                            },
                            TP.ONFAIL, function(aResponse) {
                                //  empty
                            }
                        ));

                    aRequest.complete('delegated to :cli');
                } else {
                    //  Iterate over all of the paths and compose a chunk of
                    //  markup that could be copied and pasted into a cfg file.
                    str = '<ul>';

                    //  Create an Array of all of the output entries by
                    //  concatenating all of the script output entries onto the
                    //  package output entries. Then sort that by the load
                    //  index. This will make sure that scripts or packages that
                    //  require prerequisites to be loaded before they are are
                    //  generated that way.
                    allOutputEntries = packageOutputEntries.concat(
                                                        scriptOutputEntries);
                    allOutputEntries.sort(function(entryA, entryB) {
                        return entryA.at(1) - entryB.at(1);
                    });

                    //  Write those entries properly based on their type.
                    allOutputEntries.forEach(
                        function(anEntry) {
                            var entryType,

                                path,
                                configParts;

                            entryType = anEntry.at(0);

                            //  The path is the 4th item, whether it's a package
                            //  or script.
                            path = TP.uriInTIBETFormat(anEntry.at(3));

                            if (entryType === 'package') {
                                configParts = anEntry.at(2).split('@');

                                str += '<li>' +
                                        '&lt;package src="' +
                                        path +
                                        '" config="' +
                                            configParts.last() +
                                        '"/&gt;' +
                                        '</li>';
                            } else if (entryType === 'script') {
                                str += '<li>' +
                                        '&lt;script src="' + path + '"/&gt;' +
                                        '</li>';
                            }
                        });

                    str += '</ul>';

                    //  Make sure to mark the request 'as is' since we're
                    //  outputting  markup that we don't want processed.
                    aRequest.atPut('cmdAsIs', true);
                    aRequest.complete(str);
                }
        });
    } else {

        //  Otherwise, we just list the package assets

        profileParts = profile.split('@');

        uri = TP.uriExpandPath(profileParts.first());
        if (!TP.isURIString(uri)) {
            uri = TP.uriJoinPaths('~app_cfg', uri);
        }

        if (TP.isEmpty(TP.uriExtension(uri))) {
            uri += '.xml';
        }

        TP.boot.$listPackageAssets(uri, profileParts.last()).then(
            function(finalResults) {
                aRequest.complete(finalResults);
            });
    }

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('package',
    TP.tsh.package.Type.getMethod('tshExecute'),
    'List package assets either as asset paths or nodes.',
    ':package [[--profile <pkgcfg>] | [--package <package>]] [--config <cfg>]] [--phase=[\'all\'|\'one\'|\'two\'|\'app\'|\'lib\']] [--add <file_list>] [--remove <file_list>] [--all] [--unresolved] [--unlisted] [--inlined] [--building] [--include <asset names>] [--exclude <asset names>][--scripts] [--resources] [--images] [--silent] [--fix] [--verbose] [--stack]',
    'See CLI documentation');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.pull.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.pull}
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:pull');

TP.tsh.pull.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.pull.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Turns on/off whether we are currently watching remote resources.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,

        shouldProcessValue,

        arg0,
        url;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    //  We need to turn on 'uri.source.process_changes' since the user is
    //  forcing it at this point. We capture the existing value first though.
    shouldProcessValue = TP.sys.cfg('uri.source.process_changes');
    TP.sys.setcfg('uri.source.process_changes', true);

    if (shell.getArgument(aRequest, 'tsh:all', null, false)) {

        //  Call the type method that processes all outstanding remote changes
        //  from all remotely changed URIs.
        TP.uri.URI.processRemoteChangeList();
    } else {

        //  No arguments and no '--all' parameter means we dump usage.
        if (!shell.hasArguments(aRequest)) {
            return this.printUsage(aRequest);
        }

        arg0 = shell.getArgument(aRequest, 'ARG0');

        url = TP.uc(arg0);
        if (TP.isURI(url)) {
            url.refreshFromRemoteResource();
        }
    }

    //  Put 'uri.source.process_changes' cfg property back to its original value.
    TP.sys.setcfg('uri.source.process_changes', shouldProcessValue);

    aRequest.complete(TP.TSH_NO_VALUE);

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('pull',
    TP.tsh.pull.Type.getMethod('tshExecute'),
    'Pulls pending remote file system changes into the running system.' +
        ' Requires TDS.',
    ':pull --all\n' +
    ':pull <target>',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.push.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.push}
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:push');

TP.tsh.push.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.push.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Turns on/off whether we are currently watching remote resources.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,

        localChangeList,

        arg0,
        url,

        saveRequest;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    if (shell.getArgument(aRequest, 'tsh:all', null, false)) {

        //  Populate information on all URLs that we're going to push to not
        //  save prefixed XMLNS attributes.
        localChangeList = TP.uri.URI.getLocalChangeList();
        localChangeList.perform(
            function(locURIPair) {
                var req;

                req = locURIPair.last().constructRequest(
                                            TP.hc('method', TP.HTTP_PUT));

                //  Make sure to let the save request know that we're not
                //  interested in serializing 'xmlns:' attributes.
                req.atPut('serializationParams',
                            TP.hc('wantsPrefixedXMLNSAttrs', false,
                                    'lockStore', true));

                //  Do the deed.
                locURIPair.last().save(req);
            });

        //  Call the type method that push all outstanding local changes to the
        //  remote server.
        TP.uri.URI.processRemoteChangeList();
    } else {

        //  No arguments and no '--all' parameter means we dump usage.
        if (!shell.hasArguments(aRequest)) {
            return this.printUsage(aRequest);
        }

        arg0 = shell.getArgument(aRequest, 'ARG0');

        url = TP.uc(arg0);
        if (TP.isURI(url)) {

            saveRequest = url.constructRequest(TP.hc('method', TP.HTTP_PUT));

            //  Make sure to let the save request know that we're not interested
            //  in serializing 'xmlns:' attributes.
            saveRequest.atPut('serializationParams',
                                TP.hc('wantsPrefixedXMLNSAttrs', false,
                                        'lockStore', true));

            //  Do the deed.
            url.save(saveRequest);
        }
    }

    aRequest.complete(TP.TSH_NO_VALUE);

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('push',
    TP.tsh.push.Type.getMethod('tshExecute'),
    'Pushes pending changes in the running system to the remote file system.' +
        ' Requires TDS.',
    ':push <target>\n' +
    ':push --all',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.reflect.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.reflect}
 * @summary A subtype of TP.tag.ActionTag that knows how to
 *     conditionally process its child actions based on a binding expression.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:reflect');

TP.tsh.reflect.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.reflect.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @description This command provides reflection data dependent on the
     *     object and parameters provided. Output from this command is based on
     *     the nature of the object being reflected upon.
     *     - An empty set of arguments returns usage data.
     *     - A standard namespace without arguments provides types on that
     *     namespace. The APP root typically lists namespaces found below that
     *     root. TP will list any namespaces and primitives available for
     *     further reflection.
     *     - A type will normally default to listing type, instance, and local
     *     methods.
     *     - An instance will typically default to local and instance method
     *     listings.
     *     The ultimate goal is to support exploration and filtering across the
     *     metadata from types to methods to method owners.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var getTIBETMethodInfoOrNull,
        renderResults,

        shell,
        arg0,
        meta,
        obj,
        regex,
        str,
        name,
        names,
        path,
        keys,
        types,
        subtypes,
        methods,
        owners,
        attributes,
        filter,
        interf,
        pwd,
        docsonly,
        text,
        file,
        inputStr,
        locStr,
        results,
        nativeref;

    getTIBETMethodInfoOrNull = function(aMethod, methodResults) {

        if (TP.canInvoke(aMethod, 'getMethodName')) {
            methodResults.push(aMethod.getMethodName(), '');
        }
        methodResults.push(aMethod.getSignature());

        text = aMethod.getCommentText();

        if (TP.isEmpty(text)) {

            //  Note how we go after load path here, since source
            //  paths will never be minified and that's what we
            //  check below.
            file = TP.objectGetLoadPath(aMethod);

            if (TP.notEmpty(file)) {
                if (file.match(/\.min\./)) {
                    methodResults.push(
                        'Source minified.' +
                        ' No comment text available.');
                } else {
                    methodResults.push(
                        'Uncommented :(.' +
                        ' No comment text available.');
                }
            } else {
                methodResults.push(
                    'No source file. Native code?');
            }
        } else {
            methodResults.push('');
            methodResults.push(text.replace(/\n\s+\*/g, '\n *'));
        }
    };

    renderResults = function(inputKeys, inputResults, inputRequest) {

        if (TP.sys.cfg('boot.context') === 'headless') {
            inputResults.addAll(inputKeys);
        } else {
            inputRequest.atPut('cmdAsIs', true);

            inputResults.push('<ul>');
            inputKeys.forEach(
                    function(aKey) {
                        results.push(
                            '<li>',
                            '<a href="#" onclick="TP.bySystemId(\'SherpaConsoleService\').sendConsoleRequest(\':reflect ' + aKey + '\'); return false;">',
                            aKey,
                            '</a>',
                            '</li>');
                    });
            inputResults.push('</ul>');
        }
    };

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    //  No arguments means we dump usage.
    if (!shell.hasArguments(aRequest)) {
        return this.printUsage(aRequest);
    }

    arg0 = shell.getArgument(aRequest, 'ARG0');
    if (TP.isString(arg0)) {
        arg0 = arg0.unquoted();
    }

    filter = shell.getArgument(aRequest, 'tsh:filter');
    if (TP.isString(filter)) {
        filter = filter.unquoted();
    }

    interf = shell.getArgument(aRequest, 'tsh:interface');
    if (TP.isString(interf)) {
        interf = interf.unquoted();
    }

    types = shell.getArgument(aRequest, 'tsh:types', false);
    subtypes = shell.getArgument(aRequest, 'tsh:subtypes', false);
    methods = shell.getArgument(aRequest, 'tsh:methods', false);
    owners = shell.getArgument(aRequest, 'tsh:owners', false);
    attributes = shell.getArgument(aRequest, 'tsh:attributes', false);

    pwd = shell.getArgument(aRequest, 'tsh:pwd', false);

    docsonly = shell.getArgument(aRequest, 'tsh:docsonly', false);

    //  We collect data based on potentially multiple flags so the best way to
    //  start is with an empty array we can add to.
    results = TP.ac();

    //  No specification for an object means we need a flag of some kind saying
    //  what we should list (types vs. methods).
    /* eslint-disable no-extra-parens */
    if (TP.notValid(arg0) || (TP.isString(arg0) && TP.isEmpty(arg0))) {
    /* eslint-enable no-extra-parens */

        //  By default we'll dump the type list.
        if (!types && !methods && !attributes) {
            types = true;
        }

        if (types) {
            results.addAll(
                TP.sys.getTypes().getValues().collect(function(type) {
                    return TP.name(type);
                }));
        } else if (methods) {
            results.addAll(
                TP.sys.getMetadata('methods').getKeys().collect(
                function(key) {
                    TP.regex.UNDERSCORES.lastIndex = 0;
                    return key.replace(TP.regex.UNDERSCORES, '.').replace(
                        '.Primitive.', '.');
                }));
        } else if (attributes) {
            results.addAll(
                TP.sys.getMetadata('attributes').getKeys().collect(
                function(key) {
                    TP.regex.UNDERSCORES.lastIndex = 0;
                    return key.replace(TP.regex.UNDERSCORES, '.').replace(
                        '.Primitive.', '.');
                }));
        }

        results.sort();
    } else if (docsonly) {
        nativeref = arg0;

        locStr = this.$computeDevDocsURI(null, nativeref);

        if (TP.notEmpty(locStr)) {
            aRequest.atPut('cmdAsIs', true);
            results.push(
                '<a href="' + locStr + '" target="_blank">',
                locStr,
                '</a>');
        } else {
            results.push(
                'No source file. Native code?');
        }
    } else {

        //  First attempt to resolve the target as a specific object name.
        obj = shell.resolveObjectReference(arg0, aRequest);

        //  Second attempt :) We try to support shortened input with respect to
        //  method names in particular. If we find it via that name in the owner
        //  list we can use that list to filter back through the method keys.
        //  NOTE we don't go here for 'null' values since those actually DID
        //  resolve, probably to an attribute slot or other defined slot value.
        if (TP.notDefined(obj)) {

            meta = TP.sys.getMetadata('methods');

            //  Query for owners, but just names. We don't want to ass_ume
            //  types.
            results = TP.sys.getMethodOwners(arg0, true);
            if (TP.notEmpty(results)) {
                //  Primitives are things like TP_Primitive_str while methods
                //  are typically A.Type.Name_Inst_foo.
                regex = RegExp.construct('(\\.|_)' + arg0 + '(_|$)');
                if (TP.isValid(regex)) {
                    keys = meta.getKeys().filter(
                        function(key) {
                            return TP.notEmpty(regex.match(key));
                        });

                    if (TP.notEmpty(keys) && keys.getSize() > 1) {
                        results = keys.collect(
                                        function(key) {
                                            TP.regex.UNDERSCORES.lastIndex = 0;
                                            return key.replace(
                                                    TP.regex.UNDERSCORES, '.');
                                        });
                    } else {
                        obj = meta.at(keys.first());
                    }
                }
            } else {
                obj = meta.at(arg0);
                if (TP.notValid(obj) && TP.canInvoke(arg0, 'replace')) {
                    obj = meta.at(arg0.replace(/\./g, '_'));
                }
            }
        }

        if (TP.isValid(obj)) {
            //  If we resolve the object reference our goal is to provide
            //  reflection data appropriate to the nature of that object.

            if (TP.isNamespace(obj)) {

                results.push('# Namespace');

                name = TP.name(obj);
                keys = TP.interface(obj, interf);

                keys = keys.map(
                        function(key) {
                            return name + '.' + key;
                        });
                keys.sort();

                renderResults(keys, results, aRequest);

            } else if (TP.isType(obj)) {

                results.push('# Type: ' + TP.name(obj));
                //  NOTE no separator here to avoid issues with headless vs.
                //  browser for things like >> etc.
                names = TP.stnames(obj);
                results.push('# Supertypes: ' + names.join(' '), '');

                //  If we're getting the subtypes, then we get *all* of them,
                //  recursively.
                if (subtypes) {
                    names = obj.getSubtypeNames(true);
                    names.sort();
                    results.push('# Subtypes: ', '');
                    renderResults(names, results, aRequest);
                }

                interf = TP.ifEmpty(interf, TP.SLOT_FILTERS.introduced_methods);

                //  Iterate across the type, the type.Type, and the type.Inst
                //  objects to get a complete picture of the type.
                TP.ac(obj, obj.getPrototype(), obj.getInstPrototype()).forEach(
                function(thing, index) {
                    var id;

                    //  Some rare cases have trouble, at least on headless,
                    //  producing a viable name so build them up as needed.
                    switch (index) {
                        case 0:
                            id = TP.name(obj);
                            break;
                        case 1:
                            id = TP.name(obj) + '.Type';
                            break;
                        case 2:
                            id = TP.name(obj) + '.Inst';
                            break;
                        default:
                            id = TP.id(thing);
                            break;
                    }
                    results.push('# ' + id);

                    keys = TP.interface(thing, interf);
                    keys = keys.map(
                            function(key) {
                                return id + '.' + key;
                            });
                    keys.sort();

                    renderResults(keys, results, aRequest);

                    if (index < 2) {
                        results.push('');
                    }
                });

            } else if (TP.isPrototype(obj)) {

                results.push('# Prototype');

                name = arg0;

                keys = TP.interface(obj, interf);
                keys = keys.map(
                        function(key) {
                            return name + '.' + key;
                        });
                keys.sort();

                renderResults(keys, results, aRequest);

            } else if (TP.isFunction(obj)) {

                if (owners) {
                    //  Query for owners, but just names.
                    results = TP.sys.getMethodOwners(arg0, true);
                    if (TP.notEmpty(results)) {
                        regex = RegExp.construct('(\\.|_)' + arg0 + '(_|$)');
                        if (TP.isValid(regex)) {
                            meta = TP.sys.getMetadata('methods');
                            keys = meta.getKeys().filter(
                                            function(key) {
                                                return TP.notEmpty(
                                                        regex.match(key));
                                            });

                            if (TP.notEmpty(keys) && keys.getSize() > 1) {
                                results = keys.collect(
                                        function(key) {
                                            TP.regex.UNDERSCORES.lastIndex = 0;
                                            return key.replace(
                                                    TP.regex.UNDERSCORES, '.');
                                        });
                            } else {
                                obj = meta.at(keys.first());
                            }
                        }
                    }
                    results.sort();

                    renderResults(keys, results, aRequest);

                } else {

                    results = TP.ac();

                    //  If we're running in a Headless/CLI environment, then
                    //  try to use reflection the best we can to find some
                    //  printable information about the function/method
                    if (TP.sys.cfg('boot.context') === 'headless') {
                        getTIBETMethodInfoOrNull(obj, results);
                    } else {
                        //  We're running in a browser, so we try to use
                        //  reflection the best we can to find some printable
                        //  information about the function/method and if that
                        //  fails, we assume that it's a native function/method
                        //  and we will try to generate a link to the
                        //  documentation on devdocs.io.

                        //  Note how we go after load path here, since source
                        //  paths will never be minified and that's what we
                        //  check below.
                        file = TP.objectGetLoadPath(obj);

                        if (TP.notEmpty(file)) {
                            getTIBETMethodInfoOrNull(obj, results);
                        } else {

                            inputStr = shell.getArgument(
                                                aRequest, 'ARG0',
                                                null, false, true);

                            locStr = this.$computeDevDocsURI(obj, inputStr);

                            if (TP.notEmpty(locStr)) {
                                aRequest.atPut('cmdAsIs', true);
                                results.push(
                                    '<a href="' + locStr + '" target="_blank">',
                                    locStr,
                                    '</a>');
                            } else {
                                results.push(
                                    'No source file. Native code?');
                            }
                        }
                    }
                }

            } else if (!TP.isMutable(obj)) {

                //  Simple values should just output as values.
                try {
                    str = JSON.stringify(obj);
                } catch (e) {
                    str = TP.str(obj);
                }
                results.push(str);

            } else {
                //  Mutable object, but not a Type, Function, etc.
                name = arg0;
                keys = TP.interface(obj, interf);

                keys = keys.map(
                        function(key) {
                            return name + '.' + key;
                        });
                keys.sort();

                renderResults(keys, results, aRequest);
            }
        } else if (TP.isDefined(obj)) {
            results.push(arg0 + ' => null.');
        }

        if (results.getSize() === 0 && TP.notDefined(obj)) {

            inputStr = shell.getArgument(aRequest, 'ARG0', null, false, true);

            locStr = this.$computeDevDocsURI(arg0, inputStr);

            if (TP.notEmpty(locStr)) {
                aRequest.atPut('cmdAsIs', true);
                results.push(
                    '<a href="' + locStr + '" target="_blank">',
                    locStr,
                    '</a>');
            } else {
                results.push(
                    arg0 + ' not found.');
            }
        }
    }

    if (results.getSize() > 0) {

        results.unshift('');

        //  If we have a filter try to apply it now.
        if (TP.notEmpty(filter)) {

            filter = filter.unquoted();
            regex = RegExp.construct(filter);

            results = results.filter(
                        function(result) {

                            //  preserve blank lines from prior constructions
                            if (TP.isEmpty(result)) {
                                return true;
                            }

                            if (TP.isValid(regex)) {
                                return regex.test(result);
                            } else {
                                return result.indexOf(filter) !== TP.NOT_FOUND;
                            }
                        });
        }

        path = TP.objectGetSourcePath(obj);
        if (TP.notEmpty(path)) {
            results.push('');

            if (TP.notEmpty(pwd)) {
                results.push(TP.uriRelativeToPath(path, pwd));
            } else {
                results.push(path);
            }
        }

        //  Headles/CLI support requires output line-by-line.
        if (TP.sys.cfg('boot.context') === 'headless') {
            results.forEach(
                    function(result) {
                        aRequest.stdout(result);
                    });
            aRequest.complete('');

            return;
        }

        aRequest.complete(results.join('\n'));
    } else {
        if (TP.sys.cfg('boot.context') === 'headless') {
            return aRequest.complete('');
        }
        aRequest.complete(TP.TSH_NO_VALUE);
    }

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.tsh.reflect.Type.defineMethod('$computeDevDocsURI',
function(anObj, anInputStr) {

    var httpStr,

        obj,

        pathParts,

        owner,
        track,
        slotName,
        slot,

        nativeSlotExists,
        trackNotSupplied,

        realOwner;

    //  If we're running in a Headless/CLI environment, then we always return
    //  null here since we can't go get Web-based docs.
    if (TP.sys.cfg('boot.context') === 'headless') {
        return null;
    }

    httpStr = 'http://devdocs.io/';

    if (TP.isString(anObj)) {
        obj = anObj;
    } else {
        obj = anInputStr;
    }

    if (TP.isString(obj) ||
        obj.contains('.Inst.') ||
        obj.contains('.Type.')) {

        pathParts = anInputStr.split('.');

        //  If the user typed the special syntax of 'CSS.<css_property_name>',
        //  then compute a URI based on that.
        switch (pathParts.at(0)) {
            case 'CSS':
                httpStr += 'css/' + pathParts.at(1);
                return httpStr;
            default:
                break;
        }

        pathParts = obj.split('.');

        //  If we can't find the first path part on the global object, then we
        //  can't even proceed, so we just return null.
        owner = TP.global[pathParts.at(0)];
        if (TP.notValid(owner)) {
            return null;
        }

        //  If we only had one path part, then it needed to be resolved directly
        //  as a slot on the global object. It either did or didn't, but in any
        //  case don't need to do any further computation.
        if (pathParts.getSize() === 1) {
            nativeSlotExists = true;
        } else {
            trackNotSupplied = false;

            //  If they didn't supply a track, then we assume TP.INST_TRACK
            //  first (but we'll also try the TP.TYPE_TRACK second below).
            if (pathParts.getSize() === 2) {
                track = TP.INST_TRACK;
                trackNotSupplied = true;
                slotName = pathParts.at(1);
            } else {
                track = pathParts.at(1);
                slotName = pathParts.at(2);
            }

            try {
                //  Try the 'instance track' which, for natives, is basically
                //  getting their instance prototype and using that.
                if (track === TP.INST_TRACK || track === 'prototype') {
                    //  Force the track to TP.INST_TRACK in case it was
                    //  'prototype'
                    track = TP.INST_TRACK;
                    slot = owner.getInstPrototype()[slotName];

                    //  Couldn't find it on the instance prototype and the track
                    //  wasn't supplied? Try the (constructor) object itself
                    //  (which is the 'type track' for natives).
                    if (TP.notValid(slot) && trackNotSupplied) {
                        slot = owner[slotName];
                        track = TP.TYPE_TRACK;
                    }
                } else {

                    //  Otherwise, just use the constructor object itself (which
                    //  is the 'type track' for natives).
                    slot = owner[slotName];
                    track = TP.TYPE_TRACK;
                }

                //  Make sure it's a native Function.
                nativeSlotExists = TP.isNativeFunction(slot);
            } catch (e) {
                nativeSlotExists = TP.isValid(
                                    Object.getOwnPropertyDescriptor(
                                        owner.getInstPrototype(), slotName));
            }
        }
    } else {
        slot = obj;
        owner = obj[TP.OWNER];
        if (slot !== owner) {
            slotName = TP.name(obj);
        }
        nativeSlotExists = TP.isNativeFunction(slot);
    }

    if (nativeSlotExists && TP.isNativeType(owner)) {

        //  There is still one issue left to resolve - the owner might *not*
        //  actually be the object that 'owns' the slot. For instance, if the
        //  slotName is 'appendChild' and the owner is 'Element' (prototype),
        //  then the owner should actually be 'Node' (since devdocs.io wants to
        //  see 'Node.appendChild'). To do this, we iterate up the chain,
        //  looking for the slot that actually owns the slot named slotName

        realOwner = owner;
        while (TP.isValid(realOwner)) {
            if (track === TP.INST_TRACK) {
                if (realOwner.prototype.hasOwnProperty(slotName)) {
                    break;
                }
            } else if (track === TP.TYPE_TRACK) {
                if (realOwner.hasOwnProperty(slotName)) {
                    break;
                }
            }

            realOwner = Object.getPrototypeOf(realOwner);
        }

        //  Traversed all of the way to the top and still didn't find the real
        //  owner? Then just default to the original owner.
        if (TP.notValid(realOwner)) {
            realOwner = owner;
        }

        if (Node.prototype.isPrototypeOf(realOwner.prototype) ||
            realOwner.prototype === Node.prototype) {
            httpStr += 'dom/' + TP.name(realOwner);
            if (TP.isValid(slotName)) {
                httpStr += '/' + slotName;
            }
        } else {
            httpStr += 'javascript/global_objects/' + TP.name(realOwner);
            if (TP.isValid(slotName)) {
                httpStr += '/' + slotName;
            }
        }

        httpStr = httpStr.toLowerCase();

        return httpStr;
    }

    return null;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('reflect',
    TP.tsh.reflect.Type.getMethod('tshExecute'),
    'Output targeted reflection data/metadata.',
    ':reflect [[--target] <target>] [--filter <filter>]] [--owners] [--types] [--methods] [--attributes] [--known] [--hidden] [--unique] [--inherited] [--introduced] [--local] [--overridden] [--context=[\'app\'|\'lib\'|\'all\']] [--interface <interface>] [--verbose]' +
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.screen.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.screen}
 * @summary A subtype of TP.tag.ActionTag that knows how to
 *     conditionally process its child actions based on a binding expression.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:screen');

TP.tsh.screen.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.screen.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,

        arg0,

        screenNum,
        screens;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    //  This command only works in the context of a loaded and enabled Lama
    if (!TP.sys.hasFeature('lama')) {
        aRequest.stdout(
                'The :screen command requires a loaded and enabled Lama');
        aRequest.complete(TP.TSH_NO_VALUE);

        return aRequest;
    }

    //  No arguments means we dump usage.
    if (!shell.hasArguments(aRequest)) {
        return this.printUsage(aRequest);
    }

    arg0 = shell.getArgument(aRequest, 'ARG0');

    //  :screen 3

    screenNum = TP.nc(arg0);
    if (TP.isNumber(screenNum)) {

        screens = TP.byId('LamaWorld', TP.sys.getUIRoot()).get('screens');
        if (screenNum < 0 || screenNum > screens.getSize() - 1) {
            aRequest.stdout('screen index is invalid: ' + screenNum);
            aRequest.complete(TP.TSH_NO_VALUE);
        }

        //  Fire a 'ToggleScreen' signal, supplying the screen index to switch
        //  to.
        TP.signal(null,
                    'ToggleScreen',
                    TP.hc('screenIndex', screenNum));

        aRequest.stdout('world switched to screen ' + screenNum);
        aRequest.complete(TP.TSH_NO_VALUE);
    } else {
        aRequest.stdout('screen switching requires numeric index');
        aRequest.complete(TP.TSH_NO_VALUE);

        return aRequest;
    }

    aRequest.complete(TP.TSH_NO_VALUE);

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('screen',
    TP.tsh.screen.Type.getMethod('tshExecute'),
    'Sets the canvas being viewed to a screen.',
    ':screen <screen_number>',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.snippet.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.snippet}
 * @summary A subtype of TP.tag.ActionTag that knows how to
 *     conditionally process its child actions based on a binding expression.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:snippet');

TP.tsh.snippet.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.snippet.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,

        promptForDescription,

        arg0,
        arg1,

        isRemove,

        snippets,
        snippetNum,
        snippet,

        hidNum,

        command,
        description;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    //  This command only works in the context of a loaded and enabled Lama
    if (!TP.sys.hasFeature('lama')) {
        aRequest.stdout(
                'The :snippet command requires a loaded and enabled Lama');
        aRequest.complete(TP.TSH_NO_VALUE);

        return aRequest;
    }

    promptForDescription = function() {

        var defaultStr,
            descriptionReq;

        defaultStr = 'Description for history item #' + hidNum;
        descriptionReq = TP.sig.UserInputRequest.construct(
                                TP.hc('query', 'Snippet description:',
                                        'default', defaultStr,
                                        'select', true,
                                        'async', true));

        //  response comes as a TP.sig.UserInput signal, so add a local
        //  handler
        descriptionReq.defineHandler(
            'UserInput',
            function(aSignal) {

                var descriptionResult,
                    invalidDescriptionReq,
                    validDescriptionReq;

                //  do this so the triggering request clears the queue
                if (TP.isValid(aSignal.getRequest().get('responder'))) {
                    aSignal.getRequestID().signal(
                                            'TP.sig.RequestCompleted');
                }

                descriptionResult = aSignal.getResult();

                //  if the response wasn't adequate we can deal with that by
                //  simply reporting via an output request
                /* eslint-disable no-extra-parens */
                if (TP.isEmpty(descriptionResult)) {
                /* eslint-enable no-extra-parens */

                    invalidDescriptionReq =
                        TP.sig.UserOutputRequest.construct(
                            TP.hc('output', 'Invalid snippet description',
                                    'async', true));

                    invalidDescriptionReq.isError(true);
                    invalidDescriptionReq.fire(shell);
                } else {
                    snippets.add(TP.ac(command, descriptionResult));

                    validDescriptionReq =
                        TP.sig.UserOutputRequest.construct(
                            TP.hc('output', 'Snippet added: ' + command,
                                    'async', true));

                    validDescriptionReq.fire(shell);
                }

                //  Make sure to complete the original request to keep
                //  everything in sync with the shell.
                aRequest.complete(TP.TSH_NO_VALUE);

                return;
            });

        //  first-stage request (description) and response handler are
        //  defined so initiate the sequence, using the shell as the
        //  originator
        descriptionReq.fire(shell);
    };

    arg0 = shell.getArgument(aRequest, 'ARG0');
    arg1 = shell.getArgument(aRequest, 'ARG1');

    isRemove = shell.getArgument(aRequest, 'tsh:remove', false);

    snippets = TP.uc('urn:tibet:tsh_snippets').getResource().get('result');

    //  First form - remove the 3rd snippet:
    //  :snippet --remove 3

    snippetNum = TP.nc(arg0);
    if (TP.isTrue(isRemove)) {
        if (TP.isNumber(snippetNum)) {
            snippet = snippets.at(snippetNum);

            snippets.remove(snippet);

            aRequest.stdout('Snippet removed: ' + snippet.first());
            aRequest.complete(TP.TSH_NO_VALUE);
        } else {
            aRequest.stdout('Snippet removal requires numeric index');
            aRequest.complete(TP.TSH_NO_VALUE);
        }

        return aRequest;
    }

    //  Second form - add the snippet based on the 4th history entry:
    //  :snippet --hid=4
    //  OR
    //  :snippet --hid=4 'This is a cool snippet'

    hidNum = TP.nc(shell.getArgument(aRequest, 'tsh:hid', -1));
    if (TP.isNumber(hidNum) && hidNum > -1) {
        command = shell.get('history').at(hidNum).at('cmd');
        if (TP.notEmpty(command)) {

            description = arg0;

            //  If the user provided a description, use it and return.
            if (TP.notEmpty(description)) {
                snippets.add(TP.ac(command, description));

                aRequest.complete(TP.TSH_NO_VALUE);

                return;
            }

            //  Otherwise, prompt for a description
            promptForDescription();
        }

        //  Note how we do *not* complete the request before returning... we
        //  complete it in the handler above.
        return aRequest;
    }

    //  Last form - add the snippet from scratch:
    //  :snippet '4 + 5' 'This is a cool snippet'

    //  If the first argument is empty, we dump usage.
    if (TP.isEmpty(arg0)) {
        return this.printUsage(aRequest);
    }
    command = arg0;

    //  If the second argument is empty, prompt for a description
    if (TP.isEmpty(arg1)) {
        promptForDescription();

        //  Note how we do *not* complete the request before returning... we
        //  complete it in the handler above.
        return;
    }
    description = arg1;

    snippets.add(TP.ac(command, description));
    aRequest.stdout('Snippet added: ' + snippet.first());

    aRequest.complete(TP.TSH_NO_VALUE);

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('snippet',
    TP.tsh.snippet.Type.getMethod('tshExecute'),
    'Allows addition and removal of commonly used snippets of TSH.',
    ':snippet --remove=N\n' +
    ':snippet --hid=N\n' +
    ':snippet --hid=N <description>\n' +
    ':snippet <snippet> <description>',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.test.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.test}
 * @summary A command tag capable of running a test operation on one or more
 *     objects/functions.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:test');

TP.tsh.test.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.test.Type.defineMethod('cmdRunContent',
function(aRequest) {

    /**
     * @method cmdRunContent
     * @summary
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {Object}
     */

    var shell,
        runner,

        ignore_only,
        ignore_skip,
        inherit,
        subtypes,
        target,
        suiteName,
        cases,

        contextDefaulted,
        context,

        karma,

        total,

        obj,
        nsRoot,
        options,

        params;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    runner = TP.bySystemId('TP.test');
    if (TP.notValid(runner)) {
        aRequest.fail('Unable to find TP.test.');
        return;
    }

    //  Let the stdout/stderr routines have a hook to help them determine how to
    //  format output.
    aRequest.atPut('cmdTAP', true);

    aRequest.stdout(TP.TSH_NO_VALUE);

    ignore_only = shell.getArgument(aRequest, 'tsh:ignore_only', false);
    ignore_skip = shell.getArgument(aRequest, 'tsh:ignore_skip', false);
    inherit = shell.getArgument(aRequest, 'tsh:inherit', false);
    subtypes = shell.getArgument(aRequest, 'tsh:subtypes', false);

    //  Grab the argument for 'target', either from a named flag parameter or
    //  from the 'first argument' (ARG0) of the command. Note that in both cases
    //  we want the 'original' value (not the 'expanded'/'resolve' one) - this
    //  will give us what the user originally typed and what we can resolve into
    //  a symbol below.
    target = shell.getArgument(
                        aRequest,
                        'tsh:target',
                        shell.getArgument(aRequest, 'ARG0', null, false, true),
                        false,
                        true);

    if (TP.isString(target)) {
        target = target.unquoted();
    }

    suiteName = shell.getArgument(
                        aRequest,
                        'tsh:suite',
                        shell.getArgument(aRequest, 'ARG1'));

    if (suiteName === true) {
        //  Only a single dash...syntax glitch...
        suiteName = '';
    } else if (TP.isString(suiteName)) {
        suiteName = suiteName.unquoted();
    }

    cases = shell.getArgument(aRequest, 'tsh:cases', null);
    if (TP.isString(cases)) {
        cases = cases.unquoted();
    }

    //  Note how we keep track of whether the context has been defaulted for use
    //  below when the target is a type object.
    contextDefaulted = false;
    context = shell.getArgument(aRequest, 'tsh:context');
    if (TP.isEmpty(context)) {
        context = 'app';
        contextDefaulted = true;
    }

    if (TP.isString(context)) {
        context = context.unquoted();
    }

    options = TP.hc('ignore_only', ignore_only,
                    'ignore_skip', ignore_skip,
                    'inherit', inherit,
                    'subtypes', subtypes,
                    'context', context,
                    'target', target,
                    'suite', suiteName,
                    'cases', cases);

    //  Stubs for when Karma isn't around.
    karma = TP.extern.karma;
    if (TP.notValid(karma)) {
        karma = {
            info: TP.NOOP,
            error: TP.NOOP,
            results: TP.NOOP,
            complete: TP.NOOP
        };
    }

    TP.test.Suite.set('$rootRequest', aRequest);

    //  Define a local version of 'complete' that nulls out the suite's root
    //  request.
    aRequest.defineMethod('complete',
        function() {
            TP.test.Suite.set('$rootRequest', null);
            return this.callNextMethod();
        });

    if (TP.notValid(target) && TP.isEmpty(suiteName)) {

        total = runner.getCases(options).getSize();

        karma.info(
            {
                total: total
            });

        runner.runSuites(options).then(
            function(result) {
                aRequest.complete(TP.TSH_NO_VALUE);
                karma.complete();
            },
            function(error) {
                aRequest.fail(error);
                karma.complete();
            }
        );

    } else if (TP.notValid(target) && TP.notEmpty(suiteName)) {

        aRequest.stdout(TP.TSH_NO_VALUE);

        total = runner.getCases(options).getSize();

        karma.info(
            {
                total: total
            });

        runner.runSuites(options).then(
            function(result) {
                //  TODO: should we pass non-null results?
                aRequest.complete(TP.TSH_NO_VALUE);
                karma.complete();
            },
            function(error) {
                aRequest.fail(error);
                karma.complete();
            }
        );

    } else {

        if (TP.isString(target)) {
            obj = shell.resolveObjectReference(target, aRequest);
        } else {
            obj = target;
        }

        //  If we defaulted the context and we've got an object to ask then ask
        //  it to help correct any mistake in the defaulting.
        if (contextDefaulted && TP.canInvoke(obj, 'get')) {

            //  Try to grab a 'namespace root'. If obj is a TIBET type, it can
            //  tell you what its root namespace is.
            if (TP.isType(obj)) {
                nsRoot = obj.get('nsRoot');
            } else {
                //  If not, it may be a 'primitive' Function, in which case (if
                //  it was defined using a TIBET method) it has an owner with a
                //  name.
                nsRoot = obj[TP.OWNER][TP.NAME];
            }

            if (TP.isValid(nsRoot) && nsRoot !== 'APP') {
                context = 'lib';
                options.atPut('context', context);
            }
        }

        if (TP.notValid(obj)) {
            aRequest.fail('Unable to resolve object: ' + TP.id(target));
            return;
        }

        if (!TP.canInvoke(obj, 'runTestSuites')) {
            aRequest.fail('Object has no runTestSuites method: ' + TP.id(obj));
            return;
        }

        //  One sugar here is that if the receiver is a type object we can ask
        //  for it to run both Type and Inst tests by essentially running each
        //  of the likely targets.
        if (TP.isType(obj)) {
            if (!shell.getArgument(aRequest, 'tsh:local_only', false)) {

                params = options.asObject();
                params.target = obj.Type;
                total = runner.getCases(params).getSize();
                params.target = obj.Inst;
                total += runner.getCases(params).getSize();
                params.target = obj;
                total += runner.getCases(params).getSize();

                karma.info(
                    {
                        total: total
                    });

                //  Type first, then Inst, then Local
                TP.sys.logTest('# Running Type tests for ' + TP.name(target));
                obj.Type.runTestSuites(options).then(
                    function() {
                        TP.sys.logTest('# Running Inst tests for ' +
                            TP.name(target));

                        //  This method returns a Promise, so we must return
                        //  that here so that everything gets chained
                        //  properly.
                        return obj.Inst.runTestSuites(options);
                    }).then(
                    function() {
                        TP.sys.logTest('# Running Local tests for ' +
                            TP.name(target));

                        //  This method returns a Promise, so we must return
                        //  that here so that everything gets chained
                        //  properly.
                        return obj.runTestSuites(options);
                    }).then(
                    function(result) {
                        //  TODO: should we pass non-null results?
                        aRequest.complete(TP.TSH_NO_VALUE);
                        karma.complete();
                    },
                    function(error) {
                        aRequest.fail(error);
                        karma.complete();
                    }
                );

                return;
            }
        }

        aRequest.stdout(TP.TSH_NO_VALUE);

        params = options.asObject();
        params.target = obj;
        total = runner.getCases(params).getSize();

        karma.info(
            {
                total: total
            });

        TP.sys.logTest('# Running Local tests for ' + TP.id(obj));
        obj.runTestSuites(options).then(
            function(result) {
                //  TODO: should we pass non-null results?
                aRequest.complete(TP.TSH_NO_VALUE);
                karma.complete();
            },
            function(error) {
                aRequest.fail(error);
                karma.complete();
            }
        );
    }

    return;
}, {
    patchCallee: false
});

//  ------------------------------------------------------------------------

TP.tsh.test.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.ShellRequest} aRequest The request containing command
     *     input for the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    return this.cmdRunContent(aRequest);
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('test',
    TP.tsh.test.Type.getMethod('cmdRunContent'),
    'Executes an object\'s tests or test suite.',
    ':test test [[--target] <target>] [--suite <suite>] [--cases <casename>] [--ignore-only] [--ignore-skip] [--inherit] [--subtypes] [--tap[=true|false]] [--no-tap] [--profile <pkgcfg>] [--config <cfg>] [--debug] [--verbose] [--selftest] [--context=[\'app\'|\'lib\'|\'all\']] [--karma[=true|false]] [--no-karma]',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.tidy.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.tidy}
 * @summary A subtype of TP.tag.ActionTag that knows how to
 *     conditionally process its child actions based on a binding expression.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:tidy');

TP.tsh.tidy.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.tidy.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    //  No arguments means we dump usage.
    if (!shell.hasArguments(aRequest)) {
        return this.printUsage(aRequest);
    }

    aRequest.stdout('Coming soon.');

    aRequest.complete(TP.TSH_NO_VALUE);

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('tidy',
    TP.tsh.tidy.Type.getMethod('tshExecute'),
    'Runs a URI through the HTML Tidy service.',
    ':tidy <target>',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.type/TP.tsh.type.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.type}
 * @summary A subtype of TP.tag.ActionTag that knows how to create new
 *     types in the TIBET system.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:type');

TP.tsh.type.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.type.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,
        shouldAssist,

        typeName;

    shell = aRequest.at('cmdShell');

    shouldAssist = TP.bc(shell.getArgument(
                                    aRequest, 'tsh:assist', null, false));

    if (shouldAssist) {

        //  Fire a 'AssistObject' signal, supplying the target object to focus
        //  on.
        TP.signal(
                null,
                'AssistObject',
                TP.hc('targetObject', this,
                        'title', 'Type Assistant',
                        'assistantParams', TP.hc('originalRequest', aRequest)));

        return aRequest.complete(TP.TSH_NO_VALUE);
    }

    //  Make sure that the type isn't already defined
    typeName = shell.getArgument(aRequest, 'tsh:name');
    if (TP.isType(TP.sys.getTypeByName(typeName))) {
        aRequest.stderr('Type already exists: ' + typeName);
    } else {

        //  Fire a 'RemoteConsoleCommand' with a 'type ...' command, supplying
        //  the original request.
        TP.signal(null,
                    'RemoteConsoleCommand',
                    TP.hc('originalRequest', aRequest,
                            TP.ONSUCCESS,
                                function(aResponse) {

                                    //  Subscribe to 'script imported' - those
                                    //  will be the scripts for the new type(s)
                                    //  that got created by executing our
                                    //  command remotely. Note that we do this
                                    //  each time we are run, since we will
                                    //  remove this observation below in our
                                    //  handler. We're not interested in all
                                    //  'script imported' signals.
                                    this.observe(TP.sys, 'ScriptImported');
                                }.bind(this),
                            TP.ONFAIL,
                                function(aResponse) {
                                    //  TODO: Raise an exception;
                                }
                    ));
    }

    aRequest.complete(TP.TSH_NO_VALUE);

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.tsh.type.Type.defineMethod('getContentForAssistant',
function() {

    /**
     * @method getContentForAssistant
     * @summary Returns the Element representing the root node of the content
     *     for the receiver's 'assistant'.
     * @returns {Element} The root node of the receiver's assistant content.
     */

    var assistantTPElem;

    assistantTPElem = TP.tsh.type_assistant.getResourceElement(
                        'template',
                        TP.ietf.mime.XHTML);

    return TP.unwrap(assistantTPElem);
});

//  ------------------------------------------------------------------------

TP.tsh.type.Type.defineHandler('ScriptImported',
function(aSignal) {

    /**
     * @method handleScriptImported
     * @summary Handles notifications of when a script node has been imported
     *     into the system. Typically we set up an observation for these when we
     *     create a new type and are waiting for the system to signal that that
     *     new type has been imported and created on-the-fly. At that point, we
     *     let the rest of the system know that a type has been added.
     * @param {TP.sig.ScriptImported} aSignal The TIBET signal which triggered
     *     this method.
     * @returns {TP.meta.tsh.type} The receiver.
     */

    //  Unsubscribe us from this signal each time we run the handler. We're only
    //  interested in this signal when we're defining new types.
    this.ignore(TP.sys, 'ScriptImported');

    //  Tell the system that we defined new types.
    this.signal('TypeAdded', aSignal.getPayload());

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.type/TP.tsh.type_assistant.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ========================================================================

/**
 * @type {TP.tsh.type_assistant}
 */

//  ------------------------------------------------------------------------

TP.tsh.CommandAssistant.defineSubtype('tsh.type_assistant');

//  Note how this property is TYPE_LOCAL, by design.
TP.tsh.type_assistant.defineAttribute('themeURI', TP.NO_RESULT);

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.tsh.type_assistant.Type.defineConstant('BUILT_IN_DNA_TAG_TYPES',
    TP.ac(
        'TP.tag.ActionTag',
        'TP.tag.ComputedTag',
        'TP.core.Content',
        'TP.core.Controller',
        'TP.tag.InfoTag',
        'TP.tag.TemplatedTag'));

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.tsh.type_assistant.Inst.defineAttribute('dna');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.tsh.type_assistant.Inst.defineMethod('generateCommand',
function(info) {

    /**
     * @method generateCommand
     * @summary Generates the command text that will be sent to the shell if the
     *     user dismisses the assistant by clicking 'ok'.
     * @param {TP.core.Hash} info The hash containing the command parameters.
     * @returns {String} The generated command string.
     */

    var str,

        data,
        val;

    str = ':type --name=\'' +
            info.at('topLevelNS') + '.' + info.at('typeNSAndName') + '\'';

    if (TP.notEmpty(val = info.at('supertype'))) {
        data = TP.uc('urn:tibet:typelist').getResource().get('result');
        if (TP.isValid(data)) {
            val = data.at(val);
        }

        str += ' --supertype=\'' + val + '\'';
    }

    if (TP.notEmpty(val = info.at('dna'))) {
        str += ' --dna=\'' + val + '\'';
    }

    if (TP.notEmpty(val = info.at('package'))) {
        str += ' --package=\'' + val + '\'';
    }

    if (TP.notEmpty(val = info.at('config'))) {
        str += ' --config=\'' + val + '\'';
    }

    if (TP.notEmpty(val = info.at('dir'))) {
        str += ' --dir=\'' + val + '\'';
    }

    return str;
});

//  ------------------------------------------------------------------------

TP.tsh.type_assistant.Inst.defineMethod('getAssistantModelURI',
function() {

    /**
     * @method getAssistantModelURI
     * @summary Returns the URI containing the model that the assistant is using
     *     to manage all of the selections in its panel.
     * @returns {TP.uri.URI} The URI containing the assistant model.
     */

    return TP.uc('urn:tibet:type_cmd_source');
});

//  ------------------------------------------------------------------------

TP.tsh.type_assistant.Inst.defineHandler('DialogCancel',
function(anObject) {

    /**
     * @method handleDialogCancel
     * @summary Handles when the user has 'canceled' the dialog (i.e. wants to
     *     proceed without taking any action).
     * @param {TP.sig.DialogCancel} aSignal The TIBET signal which triggered
     *     this method.
     * @returns {TP.tsh.type_assistant} The receiver.
     */

    this.callNextMethod();

    this.signal('TypeAdditionCancelled');

    return this;
});

//  ------------------------------------------------------------------------

TP.tsh.type_assistant.Inst.defineHandler('ResetSupertype',
function(anObject) {

    /**
     * @method handleResetSupertype
     * @summary Handles when the user wants to reset the supertype.
     * @param {TP.sig.ResetSupertype} aSignal The TIBET signal which triggered
     *     this method.
     * @returns {TP.tsh.type_assistant} The receiver.
     */

    var result;

    result = this.get('assistantModelURI').getResource().get('result');

    if (TP.notValid(result)) {
        return this;
    }

    result.set('$.info.supertype', null);

    return this;
});

//  ------------------------------------------------------------------------

TP.tsh.type_assistant.Inst.defineHandler('ValueChange',
function(aSignal) {

    /**
     * @method handleValueChange
     * @summary Handles when the user changes the value of the underlying model.
     * @param {ValueChange} aSignal The signal that caused this handler to trip.
     * @returns {TP.tsh.type_assistant} The receiver.
     */

    var result,

        currentDNA,
        supertypeForDNA;

    result = this.get('assistantModelURI').getResource().get('result');

    if (TP.notValid(result)) {
        return this;
    }

    currentDNA = result.get('$.info.dna');

    if (currentDNA === this.$get('dna')) {
        return this.callNextMethod();
    } else {
        this.$set('dna', currentDNA);
    }

    switch (currentDNA) {

        case 'default':

            //  If the supertype is currently set to one of the tag types, then
            //  we set it to the empty String, since we're setting it back to a
            //  non preset supertype and we'll let the user choose.
            if (this.getType().BUILT_IN_DNA_TAG_TYPES.contains(
                    result.get('$.info.supertype'))) {
                supertypeForDNA = '';
            } else {
                //  Otherwise, set it to null which will cause the logic below
                //  to skip setting it - that way we won't override what the
                //  user wants.
                supertypeForDNA = null;
            }

            break;

        case 'actiontag':
            supertypeForDNA = 'TP.tag.ActionTag';
            break;

        case 'computedtag':
            supertypeForDNA = 'TP.tag.ComputedTag';
            break;

        case 'content':
            supertypeForDNA = 'TP.core.Content';
            break;

        case 'controller':
            supertypeForDNA = 'TP.core.Controller';
            break;

        case 'infotag':
            supertypeForDNA = 'TP.tag.InfoTag';
            break;

        case 'templatedtag':
            supertypeForDNA = 'TP.tag.TemplatedTag';
            break;

        default:
            supertypeForDNA = 'TP.lang.Object';
            break;
    }

    if (TP.isValid(supertypeForDNA)) {
        result.set('$.info.supertype', supertypeForDNA);
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.tsh.type_assistant.Inst.defineMethod('setOriginalRequest',
function(anObj) {

    /**
     * @method setOriginalRequest
     * @summary Sets the original request received by the command that triggered
     *     the assistant.
     * @param {TP.sig.Request} anObj The original request that was supplied to
     *     the assistant via the command.
     * @returns {TP.tsh.type_assistant} The receiver.
     */

    var shell,
        args,

        topLevelInfo,
        typeInfo,

        name,
        nameParts,

        modelURI,
        modelObj,

        typesURI,

        rootType,

        typesObj;

    this.callNextMethod();

    //  Configure the GUI using the argument values that we can derive from the
    //  original request

    shell = anObj.at('cmdShell');
    args = shell.getArguments(anObj);

    topLevelInfo = TP.hc();

    typeInfo = TP.hc();
    topLevelInfo.atPut('info', typeInfo);

    name = args.at('tsh:name');
    if (TP.notEmpty(name)) {
        nameParts = name.split(/[:.]/g);

        if (nameParts.getSize() === 3) {
            typeInfo.atPut('topLevelNS', nameParts.at(0));
            typeInfo.atPut('typeNSAndName',
                            nameParts.at(1) + '.' + nameParts.at(2));
        } else if (nameParts.getSize() === 2) {
            typeInfo.atPut('topLevelNS', 'APP');
            typeInfo.atPut('typeNSAndName',
                            nameParts.at(0) + '.' + nameParts.at(1));
        } else if (nameParts.getSize() === 1) {
            typeInfo.atPut('topLevelNS', 'APP');
            typeInfo.atPut('typeNSAndName',
                            TP.sys.cfg('project.name') + '.' + nameParts.at(0));
        }
    } else {
        typeInfo.atPut('topLevelNS', 'APP');
        typeInfo.atPut('typeNSAndName', '');
    }

    typeInfo.atPut('supertype',
                    TP.ifInvalid(args.at('tsh:supertype'), ''));
    typeInfo.atPut('dna',
                    TP.ifInvalid(args.at('tsh:dna'), ''));
    typeInfo.atPut('package',
                    TP.ifInvalid(args.at('tsh:package'), ''));
    typeInfo.atPut('config',
                    TP.ifInvalid(args.at('tsh:config'), ''));
    typeInfo.atPut('dir',
                    TP.ifInvalid(args.at('tsh:dir'), ''));

    //  Set up the type list value holder

    typesURI = TP.uc('urn:tibet:typelist');

    //  NB: 'tsh:roottype' is a TSH-only parameter used just for communicating
    //  where to 'root' the supertype list.
    if (TP.notEmpty(args.at('tsh:roottype'))) {
        rootType = TP.sys.getTypeByName(args.at('tsh:roottype'));
        if (TP.isType(rootType)) {
            typesObj = TP.hc();
            rootType.getSubtypeNames(true).sort().perform(
                function(aTypeName) {
                    typesObj.atPut(aTypeName, aTypeName);
                });
        }
    }

    //  Couldn't obtain a types hash above.
    if (TP.notValid(typesObj)) {
        //  Grab all of the type names here as key/value pairs containing the
        //  type name in both slots.
        typesObj = TP.sys.getCustomTypeNameKVPairs();
    }

    //  Set the types value holder to the Array we computed here. We also tell
    //  it to go ahead and signal change to kick things off.
    typesURI.setResource(typesObj, TP.hc('signalChange', true));

    //  Set up a model URI and observe it for change ourself. This will allow us
    //  to regenerate the tag representation as the model changes.
    modelURI = this.getAssistantModelURI();
    this.observe(modelURI, 'ValueChange');

    //  Construct a JSONContent object around the model object so that we can
    //  bind to it using the more powerful JSONPath constructs
    modelObj = TP.core.JSONContent.construct(TP.js2json(topLevelInfo));

    //  Set the resource of the model URI to the model object, telling the URI
    //  that it should observe changes to the model (which will allow us to get
    //  notifications from the URI which we're observing above) and to go ahead
    //  and signal change to kick things off.
    modelURI.setResource(
        modelObj, TP.hc('observeResource', true, 'signalChange', true));

    return this;
});

//  ------------------------------------------------------------------------

TP.sig.Signal.defineSubtype('TypeAdditionCancelled');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.types.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.types}
 * @summary A subtype of TP.tag.ActionTag that knows how to
 *     conditionally process its child actions based on a binding expression.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:types');

TP.tsh.types.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.types.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @description This command returns an array of all of the types in the
     *     system. This will include native types if the 'includenative' flag is
     *     supplied.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell,

        includeNatives,
        typesKeys;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    if (TP.notValid(aRequest.at('cmdNode'))) {
        return aRequest.fail();
    }

    typesKeys = TP.sys.getCustomTypes().getKeys();

    includeNatives = shell.getArgument(aRequest, 'tsh:includenative');
    if (TP.isValid(includeNatives) && TP.isTrue(TP.bc(includeNatives))) {
        typesKeys.addAll(TP.sys.getNativeTypes().getKeys());
    }

    if (TP.notEmpty(typesKeys)) {
        aRequest.stdout(typesKeys.sort());
    }

    aRequest.complete(TP.TSH_NO_VALUE);

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('types',
    TP.tsh.types.Type.getMethod('tshExecute'),
    'Outputs a list of available system types.',
    ':types [--includenative]',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.validate.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.validate}
 * @summary A subtype of TP.tag.ActionTag that knows how to
 *     conditionally process its child actions based on a binding expression.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:validate');

TP.tsh.validate.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.validate.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    //  No arguments means we dump usage.
    if (!shell.hasArguments(aRequest)) {
        return this.printUsage(aRequest);
    }

    aRequest.stdout('Coming soon.');

    aRequest.complete(TP.TSH_NO_VALUE);

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('validate',
    TP.tsh.validate.Type.getMethod('tshExecute'),
    'Runs the W3C validation service on a URL.',
    ':validate <url>',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.xpath.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.xpath}
 * @summary A subtype of TP.tag.ActionTag that knows how to
 *     conditionally process its child actions based on a binding expression.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:xpath');

TP.tsh.xpath.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.xpath.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    //  No arguments means we dump usage.
    if (!shell.hasArguments(aRequest)) {
        return this.printUsage(aRequest);
    }

    aRequest.stdout('Coming soon.');

    aRequest.complete(TP.TSH_NO_VALUE);

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('xpath',
    TP.tsh.xpath.Type.getMethod('tshExecute'),
    'Executes an XPath expression against a node.',
    ':xpath',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tsh/TP.tsh.xslt.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'tsh';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.tsh.xslt}
 * @summary A subtype of TP.tag.ActionTag that knows how to
 *     conditionally process its child actions based on a binding expression.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('tsh:xslt');

TP.tsh.xslt.addTraits(TP.tsh.Element);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.tsh.xslt.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, effectively invoking its action.
     * @param {TP.sig.Request} aRequest The request containing command input for
     *     the shell.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var shell;

    shell = aRequest.at('cmdShell');

    //  If either one of the debugging flags is turned on, then echo the
    //  debugging information.
    if (shell.getArgument(aRequest, 'tsh:debug', null, false)) {
        return this.printDebug(aRequest, true, false);
    }

    if (shell.getArgument(aRequest, 'tsh:debugresolve', null, false)) {
        return this.printDebug(aRequest, true, true);
    }

    //  No arguments means we dump usage.
    if (!shell.hasArguments(aRequest)) {
        return this.printUsage(aRequest);
    }

    aRequest.stdout('Coming soon.');

    aRequest.complete(TP.TSH_NO_VALUE);

    return aRequest;
});

//  ------------------------------------------------------------------------

TP.shell.TSH.addHelpTopic('xslt',
    TP.tsh.xslt.Type.getMethod('tshExecute'),
    'Transforms a node using an XSLT node/file.',
    ':xslt <target>',
    'Coming Soon');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xml/lang/de/TP.i18n.DELocale.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'xml';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.i18n.DELocale}
 * @summary TP.i18n.DELocale provides support for the German language and
 *     related localizations.
 */

//  ------------------------------------------------------------------------

TP.i18n.Locale.defineSubtype('DELocale');

TP.i18n.DELocale.Type.defineAttribute('langCode', 'de');

TP.i18n.DELocale.Type.defineAttribute('falseStrings',
    TP.ac('0', '', 'nein', 'Nein', 'NEIN', 'n', 'N',
        'f', 'F', 'falsch', 'Falsch', 'FALSCH'));

TP.i18n.DELocale.Type.defineAttribute('longMonthNames',
    TP.ac('Januar', 'Februar', 'Marz', 'April', 'Mai', 'Juni', 'Juli',
        'August', 'September', 'Oktober', 'November', 'Dezember'));

TP.i18n.DELocale.Type.defineAttribute('shortMonthNames',
    TP.ac('Jan', 'Feb', 'Mar', 'Apr', 'Mai', 'Jun', 'Jul',
        'Aug', 'Sep', 'Okt', 'Nov', 'Dez'));

TP.i18n.DELocale.Type.defineAttribute('longWeekdayNames',
    TP.ac('Sonntag', 'Montag', 'Dienstag', 'Mittwoch', 'Donnerstag',
        'Frietag', 'Samstag'));

//  TODO:   probably wrong, translation help appreciated :)
TP.i18n.DELocale.Type.defineAttribute('shortWeekdayNames',
    TP.ac('Son', 'Mon', 'Die', 'Mit', 'Don', 'Fri', 'Sam'));

TP.i18n.DELocale.Type.defineAttribute('thousandsSeparator', '.');
TP.i18n.DELocale.Type.defineAttribute('decimalPoint', ',');

//  TODO:   rework the locale registration process so this isn't necessary.
TP.i18n.Locale.registerLocale(TP.i18n.DELocale);

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xml/lang/en/TP.i18n.ENLocale.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'xml';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.i18n.ENLocale}
 * @summary TP.i18n.ENLocale provides support for the English language,
 *     regardless of any specific country. This is the default locale used when
 *     no other locale is specified and the user's language and country codes
 *     doesn't resolve to an alternative locale.
 */

//  ------------------------------------------------------------------------

TP.i18n.Locale.defineSubtype('ENLocale');

TP.i18n.ENLocale.Type.defineAttribute('langCode', 'en');

TP.i18n.Locale.registerLocale(TP.i18n.ENLocale);

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xml/lang/en_gb/TP.i18n.ENGBLocale.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'xml';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.i18n.ENGBLocale}
 * @summary TP.i18n.ENGBLocale provides support for the British English
 *     language and related localizations.
 */

//  ------------------------------------------------------------------------

TP.i18n.ENLocale.defineSubtype('ENGBLocale');

TP.i18n.ENGBLocale.Type.defineAttribute('countryCode', 'gb');

TP.i18n.Locale.registerLocale(TP.i18n.ENGBLocale);

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xml/lang/en_us/TP.i18n.ENUSLocale.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'xml';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.i18n.ENUSLocale}
 * @summary TP.i18n.ENUSLocale provides support for the U.S. English language
 *     and related localizations. This is the default locale used when no other
 *     locale is specified and the user's language code doesn't resolve to an
 *     alternative locale.
 */

//  ------------------------------------------------------------------------

TP.i18n.ENLocale.defineSubtype('ENUSLocale');

TP.i18n.ENUSLocale.Type.defineAttribute('countryCode', 'us');

TP.i18n.Locale.registerLocale(TP.i18n.ENUSLocale);

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/xml/lang/fr/TP.i18n.FRLocale.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'xml';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.i18n.FRLocale}
 * @summary TP.i18n.FRLocale provides support for the French language and
 *     related localizations.
 */

//  ------------------------------------------------------------------------

TP.i18n.Locale.defineSubtype('FRLocale');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.i18n.FRLocale.Type.defineAttribute('langCode', 'fr');

TP.i18n.FRLocale.Type.defineAttribute('thousandsSeparator', '.');
TP.i18n.FRLocale.Type.defineAttribute('decimalPoint', ',');

TP.i18n.Locale.registerLocale(TP.i18n.FRLocale);

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/http/TP.http.XMLNS.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'http';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {http:}
 * @summary This type represents the TIBET http namespace
 *     (http://www.technicalpursuit.com/2020/http) in the tag processing system.
 */

//  ------------------------------------------------------------------------

TP.core.XMLNamespace.defineSubtype('http.XMLNS');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/http/TP.http.service.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'http';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.http.service}
 * @summary A subtype of TP.tibet.service that exposes a remote HTTP service
 *     endpoint in markup.
 */

//  ------------------------------------------------------------------------

TP.tibet.service.defineSubtype('http.service');

//  NB: 'href' for us is a URI attribute, but it's *not* a 'reloadable' URI
//  attribute - we handle reloading specially for this tag.
TP.http.service.Type.set('uriAttrs', TP.ac('href'));

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  Tag Phase Support
//  ------------------------------------------------------------------------

TP.http.service.Type.defineMethod('tagAttachData',
function(aRequest) {

    /**
     * @method tagAttachData
     * @summary Sets up runtime machinery for the element in aRequest.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var elem,
        tpElem;

    //  Make sure that we have a node to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        //  TODO: Raise an exception
        return;
    }

    tpElem = TP.wrap(elem);

    //  If the element is being 'recast' (i.e. reprocessed in place, usually
    //  when developing with the Sherpa), then just return here. We don't want
    //  to do any further processing to process/register/unregister data.
    if (tpElem.isRecasting()) {
        return;
    }

    tpElem.setAttribute('statuscode', '');
    tpElem.setAttribute('statustext', '');

    //  Make sure to run the setter for this, if it has a value, as that's where
    //  the watch/unwatch happens.
    if (tpElem.hasAttribute('watched')) {
        tpElem.setAttrWatched(TP.bc(tpElem.getAttribute('watched')));
    } else {
        //  If we didn't have an watched attribute, then just set a blank
        //  one in case anyone is binding to it.
        tpElem.setAttribute('watched', '');
    }

    tpElem.shouldSignalChange(true);

    return;
});

//  ------------------------------------------------------------------------

TP.http.service.Type.defineMethod('tagResolve',
function(aRequest) {

    /**
     * @method tagResolve
     * @summary Resolves the receiver's content. This includes resolving XML
     *     Base URIs and virtual URIs that may occur on the receiver's
     *     attributes.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    //  We return here because we *don't* want our 'href' attribute rewritten.
    return;
});

//  ------------------------------------------------------------------------
//  Instance Attributes
//  ------------------------------------------------------------------------

TP.http.service.Inst.defineAttribute('isActivated');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.http.service.Inst.defineMethod('activate',
function() {

    /**
     * @method activate
     * @summary This method causes the receiver to perform it's 'action'. In
     *     this case, retrieving or sending data to a remote URI endpoint.
     * @returns {TP.http.service} The receiver.
     */

    var href,
        uri,

        request,

        headersURI,
        bodyURIs,
        resultURI,

        val,

        method,

        thisref,

        hasContentType,

        resp,

        headerContent,
        bodyContent,

        updateUponComplete,

        dataWillSendSignal;

    //  If the element is being 'recast' (i.e. recomputed in place, usually when
    //  developing with the Sherpa), then just return here. We don't want to do
    //  any further processing to process/register/unregister data.
    if (this.isRecasting()) {
        return this;
    }

    //  If we're already activated, just exit here.
    if (TP.isTrue(this.get('isActivated'))) {
        return this;
    }

    //  Make sure that a main href is available and a URI can be created from
    //  it.
    if (TP.notEmpty(href = this.getAttribute('href'))) {
        if (!TP.isURI(uri = TP.uc(href))) {
            //  Raise an exception
            return this.raise('TP.sig.InvalidURI');
        }
    } else {
        //  Raise an exception
        return this;
    }

    //  If we're running in headless mode (we're probably testing), then we need
    //  to rewrite the URL to have an HTTP resource.
    if (TP.sys.cfg('boot.context') === 'headless') {
        href = TP.elementGetAttribute(this.getNativeNode(), 'href', true);

        if (href.startsWith('file:///')) {
            href = href.slice(8);
        } else if (href.startsWith('/')) {
            href = href.slice(1);
        }

        href = TP.uriJoinPaths('http://127.0.0.1:1407', href);

        TP.elementSetAttribute(this.getNativeNode(), 'href', href, true);

        //  Make sure to recompute the URI here.
        uri = TP.uc(href);
    }

    //  Configure the main URI to force a refresh of its contents.
    request = TP.request(TP.hc('refresh', true));

    //  See if a 'headers' href is available and a URI can be created from it.
    if (TP.notEmpty(href = this.getAttribute('headers'))) {
        if (!TP.isURI(headersURI = TP.uc(href))) {
            //  Raise an exception
            return this.raise('TP.sig.InvalidURI');
        }
    } else {
        //  We might not be using extra headers
        void 0;
    }

    //  See if a 'name' href is available and a URI can be created from it.
    if (TP.notEmpty(href = this.getAttribute('name'))) {
        if (!TP.isURI(resultURI = TP.uc(href))) {
            //  Raise an exception
            return this.raise('TP.sig.InvalidURI');
        }
    } else {
        //  We might be a 'send only' service tag.
        void 0;
    }

    //  If there's an HTTP method, use it - otherwise default to GET.
    if (TP.notEmpty(val = this.getAttribute('method'))) {
        method = val;
    } else {
        method = TP.HTTP_GET;
    }

    //  If a 'multipart' attribute is defined then use it as part of the mime
    //  type (prepended with 'multipart/') and configure the individual part
    //  mimetypes into the 'multiparttypes' slot on the request.
    if (TP.notEmpty(val = this.getAttribute('multipart'))) {
        request.atPut('mimetype', 'multipart/' + val);
        //  The mime types for the individual will be a space separated list
        //  under 'mimetype' - they need to go into 'multiparttypes'
        if (TP.notEmpty(val = this.getAttribute('mimetype'))) {
            request.atPut('multiparttypes', val.split(' '));
        }
    } else if (TP.notEmpty(val = this.getAttribute('mimetype'))) {
        request.atPut('mimetype', val);
    }

    //  If we're doing a POST or a PUT, see if a 'body' href is available and a
    //  URI can be created from it.
    if (method === TP.HTTP_POST || method === TP.HTTP_PUT) {

        bodyURIs = TP.ac();

        //  If it's multipart, there may be multiple space-separated URIs
        if (TP.notEmpty(href = this.getAttribute('body'))) {

            //  Extract the 1...n URIs that comprise the body content.
            href = TP.extractURIs(href);

            href.perform(
                    function(anHref) {
                        var hrefURI;

                        if (!TP.isURI(hrefURI = TP.uc(anHref))) {
                            //  Raise an exception
                            return this.raise('TP.sig.InvalidURI');
                        }

                        bodyURIs.push(hrefURI);
                    }.bind(this));
        }
    }

    request.atPut('method', method);

    //  Mark the URI as 'not loaded' to ensure that it will force TIBET to
    //  load data from the underlying source.
    uri.isLoaded(false);

    //  Set up a variety of other TIBETan properties of the call

    if (TP.notEmpty(val = this.getAttribute('async'))) {
        request.atPut('async', TP.bc(val));
    } else {
        request.atPut('async', true);
    }

    if (TP.notEmpty(val = this.getAttribute('timeout'))) {
        if (TP.isNumber(val = parseInt(val, 10))) {
            val = val.asDuration();
        }
        request.atPut('timeout', Date.getMillisecondsInDuration(val));
    }

    if (TP.notEmpty(val = this.getAttribute('encoding'))) {
        request.atPut('encoding', val);
    }

    if (TP.notEmpty(val = this.getAttribute('separator'))) {
        request.atPut('separator', val);
    }

    hasContentType = this.hasAttribute('content');

    //  NB: This is the HTTP resultType parameter, not the result type that we
    //  will use to package the data.
    request.atPut('resultType', TP.WRAP);

    thisref = this;

    //  Add a 'local' method on the individual object that defines a handler for
    //  job completion
    request.defineHandler('RequestSucceeded',
        function(aResponse) {

            var contentType,
                result,

                mimeType,

                newResource,
                strResource;

            //  Mark the URI as being loaded, since we marked it as not being so
            //  above. We need to do this manually to ensure that, if the
            //  resource came back the same, this flag gets set back to it's
            //  prior value, which the URI won't do.
            uri.isLoaded(true);

            //  Signal the fact that we've done the work.
            thisref.signal('TP.sig.UIDataReceived');

            //  Check and dispatch a signal from our attributes if one exists
            //  for this signal.
            thisref.dispatchResponderSignalFromAttr('UIDataReceived', null);

            //  We only do this if the result URI is real - some services might
            //  be 'send only' and not define a result URI.
            if (TP.isURI(resultURI)) {

                //  Grab the result from the response.
                result = aResponse.getResult();

                //  If the result is a String, try to turn it into more
                if (TP.isString(result)) {

                    //  Obtain a MIME type for the result and use it to obtain a
                    //  result type.
                    mimeType = TP.ietf.mime.guessMIMEType(result, uri);

                    contentType = thisref.getContentType(mimeType);

                    //  If a result type couldn't be determined, then just use
                    //  String.
                    if (!TP.isType(contentType)) {
                        contentType = String;
                    }

                    //  If the new resource result is a content object of some
                    //  sort (highly likely) then we should initialize it with
                    //  both the content String and the URI that it should be
                    //  associated with. The content object type will convert it
                    //  from a String to the proper type.
                    if (TP.isSubtypeOf(contentType, TP.core.Content)) {
                        newResource = contentType.construct(result, resultURI);
                        if (this.hasAttribute('buildout')) {
                            newResource.set(
                                    'buildout',
                                    TP.bc(this.getAttribute('buildout')));
                        }
                    } else {
                        strResource = TP.str(result);
                        if (contentType === String) {
                            newResource = strResource;
                        } else {
                            newResource = contentType.from(strResource);
                        }
                    }

                } else if (TP.isNode(result)) {
                    newResource = TP.wrap(result);
                } else {
                    newResource = result;
                }

                //  If the named URI has existing data, then we signal
                //  'TP.sig.UIDataDestruct'.

                //  NB: We assume 'async' of false here.
                if (TP.notEmpty(resultURI.getResource().get('result'))) {

                    thisref.signal('TP.sig.UIDataDestruct');

                    //  Check and dispatch a signal from our attributes if one
                    //  exists for this signal.
                    thisref.dispatchResponderSignalFromAttr(
                                                'UIDataDestruct', null);
                }

                //  Set the resource to the new resource (causing any observers
                //  of the URI to get notified of a change) and signal
                //  'TP.sig.UIDataConstruct'.
                resultURI.setResource(
                    newResource,
                    TP.hc('observeResource', true, 'signalChange', true));

                thisref.signal('TP.sig.UIDataConstruct');

                //  Check and dispatch a signal from our attributes if one
                //  exists for this signal.
                thisref.dispatchResponderSignalFromAttr(
                                                'UIDataConstruct', null);

                //  Dispatch 'TP.sig.DOMReady' for consistency with other
                //  elements that dispatch this when their 'dynamic content' is
                //  resolved. Note that we use 'dispatch()' here because this is
                //  a DOM signal and we want all of the characteristics of a DOM
                //  signal.
                thisref.dispatch('TP.sig.DOMReady');
            }
        });

    request.defineHandler('RequestFailed',
        function(aResponse) {

            var errorRecord,

                statusCode,
                statusText;

            //  If we can retrieve a communications object (an XHR for HTTP
            //  comm, or an emulated object for others), then we can extract a
            //  status code and status text from it.
            if (TP.canInvoke(uri, 'getCommObject')) {
                statusCode = uri.getCommStatusCode();
                statusText = uri.getCommStatusText();

                errorRecord = TP.hc('code', statusCode, 'text', statusText);
            } else {
                errorRecord = null;
            }

            thisref.signal('TP.sig.UIDataFailed', errorRecord);

            //  Check and dispatch a signal from our attributes if one exists
            //  for this signal.
            thisref.dispatchResponderSignalFromAttr('UIDataFailed', null);
        });

    //  Initially, set the 'update URI upon completion' flag to false. Some
    //  calls, like PUT, POST and DELETE, will update the URI with their result
    //  upon completion.
    updateUponComplete = false;

    request.defineHandler('RequestCompleted',
        function(aResponse) {

            var statusCode,
                statusText,

                updateURI,
                responseBodyContent;

            //  If we can retrieve a communications object (an XHR for HTTP
            //  comm, or an emulated object for others), then we can extract a
            //  status code and status text from it.
            if (TP.canInvoke(uri, 'getCommObject')) {
                statusCode = uri.getCommStatusCode();
                statusText = uri.getCommStatusText();

                thisref.setAttribute('statuscode', statusCode);
                thisref.setAttribute('statustext', statusText);
            }

            //  If we're updating the URI when complete, then do so here. Note
            //  that we only update the first body URI (if we were sending
            //  multipart, there will be multiple body URIs).
            if (updateUponComplete && TP.notEmpty(bodyURIs)) {

                updateURI = bodyURIs.first();

                responseBodyContent = uri.getResource(
                                    TP.hc('async', false,
                                            'refresh', false)).get('result');
                responseBodyContent = TP.copy(responseBodyContent);

                if (TP.isKindOf(responseBodyContent, TP.core.Content)) {
                    responseBodyContent.set('sourceURI', updateURI, false);
                }

                updateURI.setResource(responseBodyContent);
            }

            //  Mark us as no longer being activated
            this.set('isActivated', false);
        }.bind(this));

    dataWillSendSignal = this.signal('TP.sig.UIDataWillSend');
    if (dataWillSendSignal.shouldPrevent()) {
        //  TODO: Log a warning?
        return this;
    }

    //  Check and dispatch a signal from our attributes if one exists for this
    //  signal.
    this.dispatchResponderSignalFromAttr('UIDataWillSend', null);

    //  Do the work.

    //  Process any custom headers
    if (TP.isURI(headersURI)) {

        //  NB: We assume 'async' of false here.
        resp = headersURI.getResource(TP.hc('async', false));

        if (TP.isValid(headerContent = resp.get('result'))) {
            headerContent = headerContent.get('value');
            headerContent = TP.hc(headerContent).copy();
            request.atPut('headers', headerContent);
        }
    }

    //  Mark us as having activated
    this.set('isActivated', true);

    //  If the author determined that they want a specialized result type, then
    //  we just want the TP.TEXT back from these calls to the server. We'll do
    //  the data conversion above in the RequestSucceeded handler method.
    if (hasContentType) {
        request.atPut('resultType', TP.TEXT);
    }

    //  Process the method
    switch (request.at('method')) {
        case TP.HTTP_GET:
            uri.getResource(request);
            break;
        /* eslint-disable no-fallthrough */
        case TP.HTTP_POST:

            //  NB: If we're not a multi-part post, we fall through to the logic
            //  we share with PUT below.
            if (TP.notEmpty(this.getAttribute('multipart'))) {

                bodyContent = TP.ac();
                bodyURIs.perform(
                        function(aURI) {
                            var bodyResp,
                                bodyVal;

                            //  NB: We assume 'async' of false here.
                            bodyResp = aURI.getResource(TP.hc('async', false));

                            if (TP.isValid(bodyVal = bodyResp.get('result'))) {
                                bodyVal = bodyVal.get('value');
                            }

                            bodyContent.push(TP.hc('body', bodyVal));
                        });

                uri.setResource(bodyContent);

                //  Set 'refresh' to false - we're not interested in what the
                //  server currently has.
                request.atPut('refresh', false);

                uri.save(request);

                break;
            }
        /* eslint-enable no-fallthrough */
        case TP.HTTP_PUT:

            if (TP.isURI(val = bodyURIs.first())) {

                //  NB: We assume 'async' of false here.
                resp = val.getResource(TP.hc('async', false));
                bodyContent = resp.get('result');

                //  If we had a body, set the resource of the URI to it. We
                //  might not - we might have a simple payload in the query.
                if (TP.isValid(bodyContent)) {

                    //  Copy the body to be used as the resource of the URI to
                    //  send and, if it's a Content object, update that copy's
                    //  URI to the URI object that we're getting ready to send..
                    bodyContent = TP.copy(bodyContent);
                    if (TP.isKindOf(bodyContent, TP.core.Content)) {
                        bodyContent.set('sourceURI', uri, false);
                    }

                    uri.setResource(bodyContent);
                } else {
                    uri.setResource('');
                }
            } else {
                uri.setResource('');
            }

            //  We want to update the URI with the results when we complete the
            //  remote call.
            updateUponComplete = true;

            //  Set 'refresh' to false - we're not interested in what the server
            //  currently has.
            request.atPut('refresh', false);

            uri.save(request);

            break;
        case TP.HTTP_DELETE:

            //  We want to update the URI with the results when we complete the
            //  remote call.
            updateUponComplete = true;

            uri.delete(request);

            break;
        default:
            this.signal('TP.sig.UIDataFailed');

            //  Check and dispatch a signal from our attributes if one exists
            //  for this signal.
            this.dispatchResponderSignalFromAttr('UIDataFailed', null);
            break;
    }

    //  Signal the fact that we're doing the work.
    this.signal('TP.sig.UIDataSent');

    //  Check and dispatch a signal from our attributes if one exists
    //  for this signal.
    this.dispatchResponderSignalFromAttr('UIDataSent', null);

    return this;
});

//  ------------------------------------------------------------------------

TP.http.service.Inst.defineMethod('setAttrWatched',
function(watchedValue) {

    /**
     * @method setAttrWatched
     * @summary Sets the 'watched' value for the receiver.
     * @param {String} watchedValue A value of 'true' or 'false' as to whether
     *     the remote URI on the receiver should be 'watched' for changes.
     */

    var href,
        uri,
        val;

    //  Make sure that a main href is available and a URI can be created from
    //  it.
    if (TP.notEmpty(href = this.getAttribute('href'))) {
        if (!TP.isURI(uri = TP.uc(href))) {
            //  Raise an exception
            return this.raise('TP.sig.InvalidURI');
        }
    } else {
        //  Raise an exception
        return this;
    }

    val = TP.bc(watchedValue);
    uri.set('watched', val);

    if (val) {
        this.observe(uri, 'TP.sig.ValueChange');
    } else {
        this.ignore(uri, 'TP.sig.ValueChange');
    }

    this.$setAttribute('watched', val);

    //  setting an attribute returns void according to the spec
    return;
});

//  ------------------------------------------------------------------------

TP.http.service.Inst.defineMethod('setAttrHref',
function(anHref) {

    /**
     * @method setAttrHref
     * @summary Sets the 'href' value for the receiver. This will normally be
     *     triggered by the data binding machinery if the attribute is data
     *     bound.
     * @param {String} anHref The value to set the 'href' to.
     */

    this.$setAttribute('href', anHref);

    //  setting an attribute returns void according to the spec
    return;
});

//  ------------------------------------------------------------------------

TP.http.service.Inst.defineMethod('setFacet',
function(aspectName, facetName, facetValue, shouldSignal) {

    /**
     * @method setFacet
     * @summary Sets the value of the named facet of the named aspect to the
     *     value provided.
     * @param {String} aspectName The name of the aspect to set.
     * @param {String} facetName The name of the facet to set.
     * @param {Boolean} facetValue The value to set the facet to.
     * @param {Boolean} shouldSignal If false no signaling occurs. Defaults to
     *     this.shouldSignalChange().
     * @returns {Boolean} Whether or not the value was changed from the value it
     *     had before this method was called.
     */

    var elem;

    elem = this.getNativeNode();

    //  If we're setting this value due to an update from the binding machinery
    //  and we have awakened and the aspect name isn't one our 'special' ones,
    //  then go ahead and activate.
    if (TP.isTrue(TP.$$settingFromBindMachinery)) {
        if (elem[TP.AWAKENED] &&
            aspectName !== 'watched' &&
            aspectName !== 'href') {
            this.activate();
        }
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/electron/TP.electron.ElectronMain.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'electron';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.electron.ElectronMain}
 */

//  ========================================================================
//  TP.electron.ElectronMain
//  ========================================================================

TP.core.SignalSource.defineSubtype('electron.ElectronMain');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.electron.ElectronMain.Type.defineAttribute('$listeners', TP.hc());

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.electron.ElectronMain.Type.defineMethod('addObserver',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method addObserver
     * @summary Invoked by observe() to add an observation or activate
     *     underlying signaling hooks necessary to ensure proper signaling.
     * @param {Object|Object[]} anOrigin One or more origins to observe.
     * @param {Object|Object[]} aSignal One or more signals to observe from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn on observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to add the observation, false otherwise.
     */

    var origins,
        signals,

        thisref,

        len,
        i,
        len2,
        j,

        originID,
        sigName,

        entryKey;

    //  If we're running in headless mode, just return false to tell the
    //  signaling system to *not* add the observation to the main
    //  notification engine.
    if (TP.sys.cfg('boot.context') === 'headless') {
        return false;
    }

    if (TP.sys.cfg('boot.context') !== 'electron') {
        return this.raise('UnsupportedOperation');
    }

    if (TP.notValid(anOrigin) || TP.notValid(aSignal)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    if (!TP.isArray(anOrigin)) {
        origins = TP.ac(anOrigin);
    } else {
        origins = anOrigin;
    }

    if (TP.isArray(aSignal)) {
        signals = aSignal;
    } else if (TP.isString(aSignal)) {
        signals = aSignal.split(' ');
    } else if (TP.isType(aSignal)) {
        signals = TP.ac(aSignal);
    } else {
        this.raise('TP.sig.InvalidParameter',
                    'Improper signal definition.');

        return false;
    }

    thisref = this;

    len = signals.getSize();

    /* eslint-disable no-loop-func */
    for (i = 0; i < len; i++) {

        sigName = TP.expandSignalName(signals.at(i).getSignalName());

        len2 = origins.getSize();
        for (j = 0; j < len2; j++) {

            originID = TP.gid(origins.at(j));

            //  Before we add the listener Function, we should check to see if
            //  we already registered one for this origin/signal pair. If so,
            //  then we don't need more than one.
            entryKey = originID + TP.JOIN + sigName;
            if (TP.notValid(this.get('$listeners').at(entryKey))) {

                (function(origin, signal) {
                    var listener;

                    //  Create a listener Function that will signal with the
                    //  supplied signal origin and name with the native Event as
                    //  the payload.
                    listener = function(evt, payload) {
                                TP.signal(origin,
                                            signal,
                                            payload);
                            };

                    //  Add the listener to our listeners hash with the
                    //  origin/signal key as the key. This ensures that no more
                    //  than one entry for each origin/signal is added as a
                    //  listener.
                    thisref.get('$listeners').atPut(entryKey, listener);

                    //  Message our external Electron library to register the
                    //  listener for this signal.
                    TP.extern.electron_lib_utils.addListenerForMainEvent(
                                                            signal, listener);
                }(originID, sigName));
            }
        }
    }
    /* eslint-enable no-loop-func */

    //  Always tell the notification system to register our handler, etc.
    return true;
});

//  ------------------------------------------------------------------------

TP.electron.ElectronMain.Type.defineMethod('removeObserver',
function(anOrigin, aSignal, aHandler, aPolicy) {

    /**
     * @method removeObserver
     * @summary Invoked by ignore() to remove an observation or deactivate
     *     underlying signaling hooks necessary to ensure proper signaling.
     * @param {Object|Object[]} anOrigin One or more origins to ignore.
     * @param {Object|Object[]} aSignal One or more signals to ignore from the
     *     origin(s).
     * @param {Function} aHandler The specific handler to turn off observations
     *     for.
     * @param {Function|String} aPolicy An observation policy, such as
     *     TP.CAPTURING or a specific function to manage the observe process.
     *     IGNORED.
     * @returns {Boolean} True if the observer wants the main notification
     *     engine to remove the observation, false otherwise.
     */

    var origins,
        signals,

        len,
        i,
        len2,
        j,

        originID,
        sigName,

        entryKey,

        listener;

    //  If we're running in headless mode, just return false to tell the
    //  signaling system to *not* add the observation to the main
    //  notification engine.
    if (TP.sys.cfg('boot.context') === 'headless') {
        return false;
    }

    if (TP.sys.cfg('boot.context') !== 'electron') {
        return this.raise('UnsupportedOperation');
    }

    if (TP.notValid(anOrigin) || TP.notValid(aSignal)) {
        return this.raise('TP.sig.InvalidParameter');
    }

    if (!TP.isArray(anOrigin)) {
        origins = TP.ac(anOrigin);
    } else {
        origins = anOrigin;
    }

    if (TP.isArray(aSignal)) {
        signals = aSignal;
    } else if (TP.isString(aSignal)) {
        signals = aSignal.split(' ');
    } else if (TP.isType(aSignal)) {
        signals = TP.ac(aSignal);
    } else {
        this.raise('TP.sig.InvalidParameter',
                    'Improper signal definition.');

        return false;
    }

    len = signals.getSize();

    for (i = 0; i < len; i++) {

        sigName = TP.expandSignalName(signals.at(i).getSignalName());

        len2 = origins.getSize();
        for (j = 0; j < len2; j++) {

            originID = TP.gid(origins.at(j));

            //  Compute a origin/signal key and see if a listener is available
            //  for removal.
            entryKey = originID + TP.JOIN + sigName;
            listener = this.get('$listeners').at(entryKey);

            //  We found a valid listener - remove it from our listeners hash
            //  and message our external Electron library to remove the listener
            //  for this signal.
            if (TP.isValid(listener)) {
                this.get('$listeners').removeKey(entryKey);

                TP.extern.electron_lib_utils.removeListenerForMainEvent(
                    sigName, listener);
            }
        }
    }

    //  Always tell the notification system to remove our handler, etc.
    return true;
});

//  ------------------------------------------------------------------------

TP.electron.ElectronMain.Type.defineMethod('signalMain',
function(aSignal, varargs) {

    /**
     * @method signalMain
     * @summary Sends the specified signal to Electron's 'main' process.
     * @param {String} aSignal The signal name to send to the main process.
     * @param {arguments} varargs Optional additional arguments for the
     *     constructor.
     * @returns {Promise} A Promise returned from sending the event to
     *     the main process. When this Promise is resolved its value will be
     *     whatever value that method returned (limited by the rules of the
     *     Structured Clone Algorithm).
     */

    var args,

        sigArgs,

        len,
        i;

    //  If we're running in headless mode, just return a resolved Promise.
    if (TP.sys.cfg('boot.context') === 'headless') {
        return Promise.resolve();
    }

    if (TP.sys.cfg('boot.context') !== 'electron') {
        return this.raise('UnsupportedOperation');
    }

    //  Grab all of the arguments into an Array and build a new Array of the
    //  '(plain) object representation' of those arguments. This is needed to
    //  serialize properly over the wire.

    args = TP.ac(arguments);

    sigArgs = TP.ac();

    len = args.getSize();
    for (i = 0; i < len; i++) {
        sigArgs.push(TP.obj(args.at(i)));
    }

    //  NB: We just pass along all arguments here - this call will 'do the right
    //  thing'.
    return TP.extern.electron_lib_utils.sendEventToMain(sigArgs);
});

//  ========================================================================
//  TP.electron.ElectronMessageSource
//  ========================================================================

TP.core.MessageSource.defineSubtype('electron.ElectronMessageSource');

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  The list of standard handler names that instances of this type will
//  automatically add listeners for. For Electron message sources, there are
//  none.
TP.electron.ElectronMessageSource.Type.defineAttribute(
    '$standardEventHandlerNames', TP.ac());

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.electron.ElectronMessageSource.Type.defineMethod('isSupported',
function() {

    /**
     * @method isSupported
     * @summary Whether or not events from this source can be sent.
     * @returns {Boolean} Whether or not events can be sent.
     */

    return TP.sys.cfg('boot.context') === 'electron';
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.electron.ElectronMessageSource.Inst.defineMethod('activate',
function() {

    /**
     * @method activate
     * @summary Opens the connection to a remote messaging source.
     * @exception TP.sig.InvalidURI
     * @exception TP.sig.InvalidSource
     * @exception TP.sig.InvalidSourceType
     * @returns {Boolean} Whether or not the connection opened successfully.
     */

    //  If we're not running in Electron, then we can't activate.
    if (TP.sys.cfg('boot.context') !== 'electron') {
        return false;
    }

    //  If we're active and have a real source object nothing to do.
    if (this.isActive() && TP.isValid(this.get('source'))) {
        return true;
    }

    //  Our source is the TP.electron.ElectronMain type - it is what we'll be
    //  receiving signals from.
    this.set('source', TP.electron.ElectronMain);

    //  The receiver is now active.
    this.isActive(true);

    //  Observe the TP.electron.ElectronMain type (our source) for the generic
    //  'message received' signal. This is generic but will have an encoded
    //  signal name that will be dispatched for more-specific purposes.
    this.observe(TP.electron.ElectronMain, 'TP.sig.MessageReceived');

    //  Signal the Electron-side machinery to activate its watcher.
    TP.electron.ElectronMain.signalMain('TP.sig.ActivateWatcher');

    return true;
});

//  ------------------------------------------------------------------------

TP.electron.ElectronMessageSource.Inst.defineHandler('MessageReceived',
function(aSignal) {

    /**
     * @method handleElectionMessageReceived
     * @summary Handles when we receive a message from the Electron main
     *     process.
     * @param {TP.sig.MessageReceived} aSignal The signal indicating that the
     *     main process wants to communicate with us.
     * @returns {TP.electron.ElectronMessageSource} The receiver.
     */

    var evt,
        signalName;

    evt = aSignal.getPayload();

    //  Map over the event. In the SSE code, this is done by using a REMOTE_NAME
    //  along with special handlers. For Electron, our approach can be simpler.
    switch (evt.event) {
        case 'fileChange':
            signalName = 'TP.sig.ElectronFileChange';
            break;
        default:
            //  Not an event name we recognize, so we can't map it to a signal
            //  name. Return here.
            return;
    }

    this.signal(signalName, evt);

    return this;
});

//  ------------------------------------------------------------------------

TP.electron.ElectronMessageSource.Inst.defineMethod('deactivate',
function(closed) {

    /**
     * @method deactivate
     * @summary Deactivates observation of the message source.
     * @param {Boolean} [closed=false] True to tell deactivate any remote
     *     connection that the receiver is managing is already closed so skip
     *     any internal close call.
     * @returns {Boolean} Whether or not the connection closed successfully.
     */

    if (!this.isActive()) {
        return true;
    }

    //  Ignore the TP.electron.ElectronMain type (our source) for the generic
    //  'message received' signal.
    this.ignore(TP.electron.ElectronMain, 'TP.sig.MessageReceived');

    //  Signal the Electron-side machinery to deactivate its watcher.
    TP.electron.ElectronMain.signalMain('TP.sig.DeactivateWatcher');

    //  The receiver is now inactive.
    this.isActive(false);

    return true;
});

//  ------------------------------------------------------------------------

TP.electron.ElectronMessageSource.Inst.defineMethod('setupCustomHandlers',
function(signalTypes) {

    /**
     * @method setupCustomHandlers
     * @summary Sets up handlers for 'custom' server-side events.
     * @description The Server-Sent Events specification does not specify that
     *     the 'onmessage' handler will fire when there is a custom 'event' (as
     *     specified by the 'event:' tag in the received data). We check the
     *     signal types being observed for a REMOTE_NAME which allows it to
     *     adapt to server event names which should map to that signal type and
     *     register a low-level handler accordingly.
     * @param {TP.sig.SourceSignal[]} signalTypes An Array of
     *     TP.sig.SourceSignal subtypes to check for custom handler
     *     registration.
     * @exception TP.sig.InvalidSource
     * @returns {TP.electron.ElectronMessageSource} The receiver.
     */

    //  TP.electron.ElectronMessageSource has no custom handlers.
    return this;
});

//  ------------------------------------------------------------------------

TP.electron.ElectronMessageSource.Inst.defineMethod('teardownCustomHandlers',
function(signalTypes) {

    /**
     * @method teardownCustomHandlers
     * @summary Tears down handlers for 'custom' server-side events.
     * @description Because the Server-Sent Events specification does not
     *     specify that the general 'message' handler will fire when there is a
     *     custom 'event' (as specified by the 'event:' tag in the received
     *     data), we look at the signals being registered and if they have a
     *     'REMOTE_NAME' slot, we use that to unregister a handler with our
     *     private source object.
     * @param {TP.sig.SourceSignal[]} signalTypes An Array of
     *     TP.sig.SourceSignal subtypes to check for custom handler
     *     registration.
     * @returns {TP.electron.ElectronMessageSource} The receiver.
     */

    //  TP.electron.ElectronMessageSource has no custom handlers.
    return this;
});

//  ========================================================================
//  TP.uri.ElectronURLHandler
//  ========================================================================

TP.uri.FileURLHandler.defineSubtype('ElectronFileURLHandler');

TP.uri.ElectronFileURLHandler.addTraits(TP.uri.RemoteURLWatchHandler);

//  ------------------------------------------------------------------------

TP.uri.ElectronFileURLHandler.Type.defineMethod('getWatcherSourceType',
function() {

    /**
     * @method getWatcherSourceType
     * @summary Returns the TIBET type of the watcher signal source. For the
     *     Electron source, this is TP.electron.ElectronMessageSource
     * @returns {TP.electron.ElectronMessageSource} The type that will be
     *     instantiated to make a watcher for the supplied URI.
     */

    return TP.electron.ElectronMessageSource;
});

//  ------------------------------------------------------------------------

TP.uri.ElectronFileURLHandler.Type.defineMethod('getWatcherSignalType',
function() {

    /**
     * @method getWatcherSignalType
     * @summary Returns the TIBET type of the watcher signal. This will be the
     *     signal that the signal source sends when it wants to notify URIs of
     *     changes.
     * @returns {TP.sig.ElectronFileChange} The type that will be instantiated
     *     to construct new signals that notify observers that the *remote*
     *     version of the supplied URI's resource has changed.
     */

    return TP.sig.ElectronFileChange;
});

//  ------------------------------------------------------------------------

TP.uri.ElectronFileURLHandler.Type.defineMethod('activateRemoteWatch',
function() {

    /**
     * @method activateRemoteWatch
     * @summary Performs any processing necessary to activate observation of
     *     remote URL changes.
     * @returns {TP.meta.uri.ElectronFileURLHandler} The receiver.
     */

    var sourceType,
        signalSource,
        signalType;

    sourceType = this.getWatcherSourceType();

    signalSource = sourceType.construct();
    if (TP.notValid(signalSource)) {
        return this.raise('InvalidURLWatchSource');
    }

    signalType = this.getWatcherSignalType();
    this.observe(signalSource, signalType);

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.ElectronFileURLHandler.Type.defineMethod('deactivateRemoteWatch',
function() {

    /**
     * @method deactivateRemoteWatch
     * @summary Performs any processing necessary to shut down observation of
     *     remote URL changes.
     * @returns {TP.meta.uri.ElectronFileURLHandler} The receiver.
     */

    var sourceType,
        signalSource,
        signalType;

    sourceType = this.getWatcherSourceType();

    signalSource = sourceType.construct();
    if (TP.notValid(signalSource)) {
        return this.raise('InvalidURLWatchSource');
    }

    signalType = this.getWatcherSignalType();
    this.ignore(signalSource, signalType);

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.ElectronFileURLHandler.Type.defineHandler('ElectronFileChange',
function(aSignal) {

    /**
     * @method handleElectionFileChange
     * @summary Handles when a TDS-managed resource has changed.
     * @param {TP.sig.ElectronFileChange} aSignal The signal indicating that a
     *     TDS-managed resource has changed.
     * @returns {TP.meta.uri.ElectronFileURLHandler} The receiver.
     */

    var payload,
        path,
        fileName,
        url;

    //  Make sure that we have a payload
    if (TP.notValid(payload = aSignal.getPayload())) {
        return this;
    }

    //  If we can't determine the file path we can't take action in any case.
    path = TP.hc(payload).at('path');
    if (TP.isEmpty(path)) {
        return this;
    }

    //  Strip any enclosing quotes from the path.
    path = path.asString().stripEnclosingQuotes();

    fileName = TP.uriExpandPath(path);

    //  If we can successfully create a URL from the payload, then process the
    //  change.
    if (TP.isURI(url = TP.uc(fileName))) {
        TP.uri.URI.processRemoteResourceChange(url);
    }

    return this;
});

//  ========================================================================
//  TP.sig.ElectronSignal
//  ========================================================================

TP.sig.Signal.defineSubtype('ElectronSignal');

TP.sig.ElectronSignal.defineSubtype('MessageReceived');

TP.sig.ElectronSignal.defineSubtype('CheckForUpdate');
TP.sig.ElectronSignal.defineSubtype('CheckingForUpdate');
TP.sig.ElectronSignal.defineSubtype('UpdateError');
TP.sig.ElectronSignal.defineSubtype('UpdateAvailable');
TP.sig.ElectronSignal.defineSubtype('UpdateNotAvailable');
TP.sig.ElectronSignal.defineSubtype('UpdateDownloaded');

TP.sig.ElectronSignal.defineSubtype('WindowMoved');
TP.sig.ElectronSignal.defineSubtype('WindowResized');

TP.sig.ElectronSignal.defineSubtype('ApplicationWillExit');
TP.sig.ElectronSignal.defineSubtype('ApplicationDidExit');

//  =======================================================================
//  Registration
//  ========================================================================

//  Make sure the remote url watcher knows about this handler type, but wait to
//  do this after the type has been fully configured to avoid api check error.
if (TP.sys.cfg('boot.context') === 'electron' && !TP.sys.inExtension()) {
    TP.uri.RemoteURLWatchHandler.registerWatcher(
                                        TP.uri.ElectronFileURLHandler);
}

//  =======================================================================
//  TP.sig.ElectronFileChange
//  ========================================================================

TP.sig.RemoteURLChange.defineSubtype('ElectronFileChange');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/electron/TP.electron.XMLNS.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'electron';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {electron:}
 * @summary This type represents the Election namespace in the tag processing
 *     system.
 */

//  ------------------------------------------------------------------------

TP.core.XMLNamespace.defineSubtype('electron.XMLNS');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/electron/TP.electron.Application.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'electron';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.electron.Application}
 * @summary The default application controller for Electron applications.
 */

//  ------------------------------------------------------------------------

TP.core.Application.defineSubtype('electron.Application');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.electron.Application.Inst.defineAttribute('isSilent');
TP.electron.Application.Inst.defineAttribute('updateDownloaded');

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.electron.Application.Inst.defineHandler('AppDidStart',
function(aSignal) {

    /**
     * @method handleAppDidStart
     * @param {TP.sig.AppDidStart} aSignal The signal that caused this handler
     *     trip.
     * @returns {TP.electron.Application} The receiver.
     */

    this.observe(TP.electron.ElectronMain,
                    TP.ac('ApplicationWillExit',
                            'ApplicationDidExit',
                            'CheckForUpdate',
                            'CheckingForUpdate',
                            'UpdateError',
                            'UpdateAvailable',
                            'UpdateNotAvailable',
                            'UpdateDownloaded',
                            'WindowMoved',
                            'WindowResized'));

    this.set('isSilent', true);
    this.set('updateDownloaded', false);

    //  Enable the 'About' menu item with the app name
    TP.electron.ElectronMain.signalMain(
        'TP.sig.UpdateMenuItem',
        {
            id: 'about',
            label: TP.sys.cfg('project.name')
        });

    //  Enable the 'version' menu item with the app version
    TP.electron.ElectronMain.signalMain(
        'TP.sig.UpdateMenuItem',
        {
            id: 'version',
            label: 'Version ' + TP.sys.cfg('project.version')
        });

    //  Enable the menu item that allows the user to manually check for updates.
    TP.electron.ElectronMain.signalMain(
        'TP.sig.UpdateMenuItem',
        {
            id: 'updater',
            enabled: true
        });

    //  Signal the main process that the TIBET application has started.
    TP.electron.ElectronMain.signalMain('TP.sig.AppDidStart');

    return this;
});

//  ------------------------------------------------------------------------

TP.electron.Application.Inst.defineHandler('AppShutdown',
function(aSignal) {

    /**
     * @method handleAppShutdown
     * @summary Handles when the app is about to be shut down. Used to save
     *     profile data for the application.
     * @param {TP.sig.AppShutdown} aSignal The signal indicating that the
     *     application is to be shut down.
     * @returns {TP.electron.Application} The receiver.
     */

    var profileData;

    //  Grab the profile. Note how we pass true as the last parameter to get a
    //  nested POJO back.
    profileData = TP.sys.getcfg('profile', null, true);

    //  NB: We need to remove these keys before we send this data to Electron.
    //  They point to Function objects and the Structured Clone Algorithm has
    //  issues with that.
    delete profileData.at;
    delete profileData.atPut;
    delete profileData.getKeys;

    //  Signal the main process that TIBET wants to save profile data.
    TP.electron.ElectronMain.signalMain(
                            'TP.sig.SaveProfile',
                            {
                                data: profileData
                            });

    return this;
});

//  ------------------------------------------------------------------------

TP.electron.Application.Inst.defineHandler('ApplicationDidExit',
function(aSignal) {

    /**
     * @method handleApplicationDidExit
     * @summary Handles when Electron is now shutting down the application. Note
     *     that this happens past 'the point of no return'.
     * @param {TP.sig.ApplicationDidExit} aSignal The signal indicating that
     *     Electron is in the final stages of shutting the application down.
     * @returns {TP.electron.Application} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.electron.Application.Inst.defineHandler('ApplicationWillExit',
function(aSignal) {

    /**
     * @method handleApplicationWillExit
     * @summary Handles when Electron has received an event from the user that
     *     they want to shut down the application.
     * @param {TP.sig.ApplicationWillExit} aSignal The signal indicating that
     *     the user wants the application to be shut down.
     * @returns {TP.electron.Application} The receiver.
     */

    var shouldTerminate;

    //  Terminate the app, but since we're on Electron we don't navigate to a
    //  different URL. Also, if this method returns false, then we do *not*
    //  complete the application exit and ApplicationDidExit will never be
    //  signaled.
    shouldTerminate = TP.sys.terminate(null, false);
    if (shouldTerminate) {
        TP.electron.ElectronMain.signalMain('TP.sig.CompleteExit');
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.electron.Application.Inst.defineHandler('CheckForUpdate',
function(aSignal) {

    /**
     * @method handleCheckForUpdate
     * @param {TP.sig.CheckForUpdate} aSignal The signal that caused this
     *     handler trip.
     * @returns {TP.electron.Application} The receiver.
     */

    var isSilent;

    isSilent = aSignal.getPayload().first();
    this.set('isSilent', isSilent);

    //  Disable the menu item that allows the user to manually check for updates
    //  - we're in the middle of checking for updates.
    TP.electron.ElectronMain.signalMain('TP.sig.UpdateMenuItem',
        {
            id: 'updater',
            label: 'Checking for updates...',
            enabled: false
        });

    //  If we have an update that has been downloaded, then just go ahead and
    //  ask the user whether they want us to install it or not.
    if (TP.isTrue(this.get('updateDownloaded'))) {
        TP.electron.ElectronMain.signalMain('TP.sig.ShowNativeDialog',
            {
                type: 'info',
                title: 'Updates Available',
                message: 'New updates are available and ready to be installed.',
                defaultId: 0,
                cancelId: 1,
                buttons: TP.ac('Install and restart', 'Close')
            }).then(
            function(buttonIndex) {
                if (buttonIndex === 0) {
                    TP.electron.ElectronMain.signalMain(
                            'TP.sig.InstallUpdateAndRestart');
                } else {
                    TP.electron.ElectronMain.signalMain(
                        'TP.sig.UpdateMenuItem',
                        {
                            id: 'updater',
                            label: 'Updates Available',
                            enabled: true
                        });
                }
            });
    } else {
        TP.electron.ElectronMain.signalMain('TP.sig.CheckForUpdates');
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.electron.Application.Inst.defineHandler('CheckingForUpdate',
function(aSignal) {

    /**
     * @method handleCheckingForUpdate
     * @param {TP.sig.CheckingForUpdate} aSignal The signal that caused this
     *     handler trip.
     * @returns {TP.electron.Application} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.electron.Application.Inst.defineHandler('UpdateAvailable',
function(aSignal) {

    /**
     * @method handleUpdateAvailable
     * @param {TP.sig.UpdateAvailable} aSignal The signal that caused this
     *     handler trip.
     * @returns {TP.electron.Application} The receiver.
     */

    //  If we're not being 'silent', then prompt the user to the fact that an
    //  update is available and ask whether we should download it or not.
    if (!this.get('isSilent')) {
        TP.electron.ElectronMain.signalMain('TP.sig.ShowNativeDialog',
            {
                type: 'info',
                title: 'Updates Available',
                message: 'New updates are available. Do you want to update now?',
                defaultId: 0,
                cancelId: 1,
                buttons: TP.ac('Yes', 'No')
            }).then(
            function(buttonIndex) {
                if (buttonIndex === 0) {
                    TP.electron.ElectronMain.signalMain('TP.sig.DownloadUpdate');
                } else {
                    TP.electron.ElectronMain.signalMain(
                        'TP.sig.UpdateMenuItem',
                        {
                            id: 'updater',
                            label: 'Check for updates',
                            enabled: true
                        });
                }
            });
    } else {
        TP.electron.ElectronMain.signalMain('TP.sig.DownloadUpdate');
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.electron.Application.Inst.defineHandler('UpdateDownloaded',
function(aSignal) {

    /**
     * @method handleUpdateDownloaded
     * @param {TP.sig.UpdateDownloaded} aSignal The signal that caused this
     *     handler trip.
     * @returns {TP.electron.Application} The receiver.
     */

    this.set('updateDownloaded', true);

    //  Enable the menu item that allows the user to manually check for updates
    //  - we're no longer in the middle of checking for updates.
    TP.electron.ElectronMain.signalMain(
        'TP.sig.UpdateMenuItem',
        {
            id: 'updater',
            label: 'Updates available',
            enabled: true
        });

    //  If we're not being 'silent', then prompt the user to the fact that an
    //  update is ready to be installed and ask whether we should install it or
    //  not.
    if (!this.get('isSilent')) {
        TP.electron.ElectronMain.signalMain('TP.sig.ShowNativeDialog',
            {
                type: 'info',
                title: 'Install Updates',
                message: 'Updates are ready to be installed.',
                defaultId: 0,
                cancelId: 1,
                buttons: TP.ac('Install and restart', 'Close')
            }).then(
            function(buttonIndex) {
                if (buttonIndex === 0) {
                    TP.electron.ElectronMain.signalMain(
                                'TP.sig.InstallUpdateAndRestart');
                } else {
                    TP.electron.ElectronMain.signalMain(
                        'TP.sig.UpdateMenuItem',
                        {
                            id: 'updater',
                            label: 'Updates Available',
                            enabled: true
                        });
                }
            });
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.electron.Application.Inst.defineHandler('UpdateError',
function(aSignal) {

    /**
     * @method handleUpdateError
     * @param {TP.sig.UpdateError} aSignal The signal that caused this
     *     handler trip.
     * @returns {TP.electron.Application} The receiver.
     */

    var errMsg;

    //  Enable the menu item that allows the user to manually check for updates
    //  - we're no longer in the middle of checking for updates.
    TP.electron.ElectronMain.signalMain('TP.sig.UpdateMenuItem',
        {
            id: 'updater',
            label: 'Check for updates',
            enabled: true
        });

    //  If we're not being 'silent', then tell the user that there was an error
    //  installing the update.
    if (!this.get('isSilent')) {
        errMsg = TP.str(aSignal.getPayload().at(0).message);

        TP.electron.ElectronMain.signalMain('TP.sig.ShowNativeErrorDialog',
            {
                title: 'Error during the update',
                message: 'Application couldn\'t be updated:\n' +
                            errMsg +
                            '\nPlease try again or contact the support team'
            });
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.electron.Application.Inst.defineHandler('UpdateNotAvailable',
function(aSignal) {

    /**
     * @method handleUpdateNotAvailable
     * @param {TP.sig.UpdateNotAvailable} aSignal The signal that caused this
     *     handler trip.
     * @returns {TP.electron.Application} The receiver.
     */

    //  Enable the menu item that allows the user to manually check for updates
    //  - we're no longer in the middle of checking for updates.
    TP.electron.ElectronMain.signalMain(
        'TP.sig.UpdateMenuItem',
        {
            id: 'updater',
            label: 'Check for updates',
            enabled: true
        });

    //  If we're not being 'silent', then tell the user that there were no
    //  updates to be installed.
    if (!this.get('isSilent')) {
        TP.electron.ElectronMain.signalMain('TP.sig.ShowNativeDialog',
            {
                type: 'info',
                title: 'No Updates Available',
                message: 'Current version is up-to-date'
            });
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.electron.Application.Inst.defineHandler('WindowMoved',
function(aSignal) {

    /**
     * @method handleWindowMoved
     * @summary Handles when Electron has detected a 'window moved' event from
     *     the user.
     * @param {TP.sig.WindowMoved} aSignal The signal indicating that
     *     Electron has received a 'window moved' event from the user.
     * @returns {TP.electron.Application} The receiver.
     */

    var windowInfo,
        windowCfgKey;

    //  NB: This is a POJO.
    windowInfo = aSignal.getPayload();

    windowCfgKey = 'profile.windows.' + windowInfo.name + '.';

    TP.sys.setcfg(windowCfgKey + 'top', windowInfo.top);
    TP.sys.setcfg(windowCfgKey + 'left', windowInfo.left);
    TP.sys.setcfg(windowCfgKey + 'width', windowInfo.width);
    TP.sys.setcfg(windowCfgKey + 'height', windowInfo.height);

    return this;
});

//  ------------------------------------------------------------------------

TP.electron.Application.Inst.defineHandler('WindowResized',
function(aSignal) {

    /**
     * @method handleWindowResized
     * @summary Handles when Electron has detected a 'window resize' event from
     *     the user.
     * @param {TP.sig.WindowResized} aSignal The signal indicating that
     *     Electron has received a 'window resize' event from the user.
     * @returns {TP.electron.Application} The receiver.
     */

    var windowInfo,
        windowCfgKey;

    //  NB: This is a POJO.
    windowInfo = aSignal.getPayload();

    windowCfgKey = 'profile.windows.' + windowInfo.name + '.';

    TP.sys.setcfg(windowCfgKey + 'top', windowInfo.top);
    TP.sys.setcfg(windowCfgKey + 'left', windowInfo.left);
    TP.sys.setcfg(windowCfgKey + 'width', windowInfo.width);
    TP.sys.setcfg(windowCfgKey + 'height', windowInfo.height);

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/electron/TP.electron.Element.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'electron';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.electron.Element}
 */

//  ------------------------------------------------------------------------

TP.dom.UIElementNode.defineSubtype('electron.Element');

TP.electron.Element.addTraits(TP.dom.NonNativeUIElementNode);

TP.electron.Element.Type.resolveTrait(
        'tagCompile',
        TP.dom.UIElementNode);

TP.electron.Element.Inst.resolveTraits(
        TP.ac('$setAttribute', 'removeAttribute', 'select', 'signal'),
        TP.dom.UIElementNode);

//  Note how this property is TYPE_LOCAL, by design.
TP.electron.Element.defineAttribute('styleURI', TP.NO_RESULT);
TP.electron.Element.defineAttribute('themeURI', TP.NO_RESULT);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.electron.Element.Type.defineMethod('buildConfigObjectFromAttributes',
function(anElement, attrList) {

    /**
     * @method buildConfigObjectFromAttributes
     * @summary Builds a POJO configuration object by using the names from the
     *     attribute list and the values obtained by getting the value of the
     *     same named attribute on the supplied element.
     * @param {Element} anElement The element to retrieve the values from.
     * @param {String[]} attrList The list of attributes to retrieve from the
     *     supplied element.
     * @returns {Object} The constructed POJO configuration object.
     */

    var configPOJO;

    configPOJO = {};

    attrList.forEach(
        function(anAttribute) {
            var val;

            val = TP.elementGetAttribute(anElement, anAttribute, true);
            if (TP.notEmpty(val)) {
                configPOJO[anAttribute] = val;
            }
        });

    return configPOJO;
});

//  ========================================================================
//  TP.electron.ActionTag
//  ========================================================================

/**
 * @type {TP.electron.ActionTag}
 * @summary A tag type that is an action tag and also has the common aspect of all
 *     Electron tags.
 */

//  ------------------------------------------------------------------------

TP.tag.ActionTag.defineSubtype('electron.ActionTag');

TP.electron.ActionTag.addTraits(TP.electron.Element);

//  Resolve the 'tagCompile' method in favor of TP.electron.Element, but go ahead
//  and execute the one inherited from TP.tag.ActionTag afterwards as well.
TP.electron.ActionTag.Type.resolveTrait(
                                'tagCompile', TP.electron.Element, TP.BEFORE);

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/electron/TP.electron.dialog.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'electron';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.electron.dialog}
 */

//  ------------------------------------------------------------------------

TP.electron.ActionTag.defineSubtype('electron.dialog');

//  Note how this property is TYPE_LOCAL, by design.
TP.electron.dialog.defineAttribute('styleURI', TP.NO_RESULT);
TP.electron.dialog.defineAttribute('themeURI', TP.NO_RESULT);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.electron.dialog.Type.set('bidiAttrs', TP.ac('value'));

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.electron.dialog.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, showing the proper dialog based on the 'type'
     *     attribute (or lack of one).
     * @param {TP.sig.Request} aRequest The TP.sig.TSHRunRequest or other shell
     *     related request responsible for this tag.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var elem,
        tpElem,

        type,

        attrList,
        configPOJO,

        labelTPElem,
        buttonTPElems;

    //  Make sure that we have a node to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        return;
    }

    tpElem = TP.wrap(elem);

    type = TP.elementGetAttribute(elem, 'type', true);

    switch (type) {

        case 'open':

            attrList = TP.ac('title', 'defaultPath', 'buttonLabel', 'filters',
                                'properties');
            configPOJO = this.buildConfigObjectFromAttributes(elem, attrList);

            TP.electron.ElectronMain.signalMain('TP.sig.ShowNativeOpenDialog',
                configPOJO).then(
                function(dialogResult) {
                    var filePaths;

                    if (!dialogResult.canceled) {
                        filePaths = dialogResult.filePaths;

                        //  If the element is bound, then update its bound value.
                        tpElem.setBoundValueIfBound(filePaths);
                    }
                });

            break;

        case 'save':

            attrList = TP.ac('title', 'defaultPath', 'buttonLabel', 'filters',
                                'properties');
            configPOJO = this.buildConfigObjectFromAttributes(elem, attrList);

            TP.electron.ElectronMain.signalMain('TP.sig.ShowNativeSaveDialog',
                configPOJO).then(
                function(dialogResult) {
                    var filePath;

                    if (!dialogResult.canceled) {
                        filePath = dialogResult.filePath;

                        //  If the element is bound, then update its bound value.
                        tpElem.setBoundValueIfBound(filePath);
                    }
                });

            break;

        case 'error':

            attrList = TP.ac('title');
            configPOJO = this.buildConfigObjectFromAttributes(elem, attrList);

            //  Note use of descendant selector
            labelTPElem = tpElem.get(TP.cpc(' label'));

            if (TP.isValid(labelTPElem)) {
                configPOJO.message = TP.str(labelTPElem.getValue());
            }

            //  Note use of descendant selector and that we don't collapse the
            //  result - we always want an Array, even if it's just 1 item.
            buttonTPElems = tpElem.get(TP.cpc(' button',
                                        TP.hc('shouldCollapse', false)));

            TP.electron.ElectronMain.signalMain('TP.sig.ShowNativeErrorDialog',
                configPOJO);

            break;

        default:

            attrList = TP.ac('title', 'type', 'defaultId');
            configPOJO = this.buildConfigObjectFromAttributes(elem, attrList);

            //  Note use of descendant selector
            labelTPElem = tpElem.get(TP.cpc(' label'));

            if (TP.isValid(labelTPElem)) {
                configPOJO.message = TP.str(labelTPElem.getValue());
            }

            //  Note use of descendant selector and that we don't collapse the
            //  result - we always want an Array, even if it's just 1 item.
            buttonTPElems = tpElem.get(TP.cpc(' button',
                                        TP.hc('shouldCollapse', false)));

            if (TP.notEmpty(buttonTPElems)) {
                configPOJO.buttons = TP.ac();

                //  For some reason, showing the native dialog orders the
                //  buttons in reverse order - so we reverse them before we
                //  process them.
                buttonTPElems.reverse();

                buttonTPElems.forEach(
                    function(aButtonTPElem) {
                        configPOJO.buttons.push(
                            TP.str(aButtonTPElem.getValue()));
                    });
            }

            TP.electron.ElectronMain.signalMain('TP.sig.ShowNativeDialog',
                configPOJO).then(
                function(dialogResult) {
                    var buttonIndex;

                    buttonIndex = dialogResult.response;

                    if (TP.isNumber(buttonIndex)) {
                        //  If the element is bound, then update its bound value.
                        tpElem.setBoundValueIfBound(buttonIndex);
                    }
                });

            break;
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/electron/TP.electron.notification.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'electron';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.electron.notification}
 */

//  ------------------------------------------------------------------------

TP.electron.ActionTag.defineSubtype('electron.notification');

//  Note how this property is TYPE_LOCAL, by design.
TP.electron.notification.defineAttribute('styleURI', TP.NO_RESULT);
TP.electron.notification.defineAttribute('themeURI', TP.NO_RESULT);

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.electron.notification.Type.defineMethod('tshExecute',
function(aRequest) {

    /**
     * @method tshExecute
     * @summary Runs the receiver, showing a native notification.
     * @param {TP.sig.Request} aRequest The TP.sig.TSHRunRequest or other shell
     *     related request responsible for this tag.
     * @returns {TP.sig.Request|Number} The request or a TSH shell loop control
     *     constant which controls how the outer TSH processing loop should
     *     continue. Common values are TP.CONTINUE, TP.DESCEND, and TP.BREAK.
     */

    var elem,
        tpElem,

        attrList,
        configPOJO,

        bodyTPElem;

    //  Make sure that we have a node to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        return;
    }

    tpElem = TP.wrap(elem);

    attrList = TP.ac('title');
    configPOJO = this.buildConfigObjectFromAttributes(elem, attrList);

    //  Note use of descendant selector
    bodyTPElem = tpElem.get(TP.cpc(' label'));

    if (TP.isValid(bodyTPElem)) {
        configPOJO.body = TP.str(bodyTPElem.getValue());
    }

    TP.electron.ElectronMain.signalMain('TP.sig.ShowNativeNotification',
        configPOJO);

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/electron/TP.electron.menu.js';
TP.boot.$$srcPackage = '~lib_cfg/lib_namespaces.xml';
TP.boot.$$srcConfig = 'electron';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.electron.menu}
 */

//  ------------------------------------------------------------------------

TP.electron.ActionTag.defineSubtype('electron:menu');

//  Note how this property is TYPE_LOCAL, by design.
TP.electron.menu.defineAttribute('styleURI', TP.NO_RESULT);
TP.electron.menu.defineAttribute('themeURI', TP.NO_RESULT);

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

//  NB: These should be coordinated with the list in the Electron menu plugin.
TP.electron.menu.Type.defineConstant('MENU_TEMPLATE_SLOT_NAMES',
    TP.ac(
            'accelerator',
            'acceleratorWorksWhenHidden',
            'checked',
            'enabled',
            'eventInfo',    //  TIBET-specific
            'icon',
            'id',
            'label',
            'registerAccelerator',
            'role',
            'selector',     //  Undocumented
            'sharingItem',
            'sublabel',
            'tooltip',
            'type',
            'visible'
    ));

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.electron.menu.Type.defineMethod('tagAttachComplete',
function(aRequest) {

    /**
     * @method tagAttachComplete
     * @summary Executes once the tag has been fully processed and its
     *     attachment phases are fully complete.
     * @param {TP.sig.Request} aRequest A request containing processing
     *     parameters and other data.
     */

    var elem,
        tpElem,

        description;

    //  this makes sure we maintain parent processing
    this.callNextMethod();

    //  Make sure that we have a node to work from.
    if (!TP.isElement(elem = aRequest.at('node'))) {
        return;
    }

    tpElem = TP.wrap(elem);

    //  If the wrapped element is the 'outermost' menu (i.e. there's no menus
    //  'above' it), then process it and it's descendants into a configuration
    //  POJO and signal the Electron main that we want to add those menus.
    if (tpElem.isOutermostOfSameKind()) {

        //  Allocate an Array to gather the menu descriptions into and do it.
        //  This data structure will be 'built' as this method is called
        //  recursively for submenus.
        description = TP.ac();
        tpElem.gatherMenuDescription(description);

        TP.electron.ElectronMain.signalMain('TP.sig.AddMenuItem',
            {
                parentId: 'main',
                label: tpElem.getAttribute('label'),
                submenu: description
            });
    }

    return;
});

//  ------------------------------------------------------------------------
//  Instance Methods
//  ------------------------------------------------------------------------

TP.electron.menu.Inst.defineMethod('gatherMenuDescription',
function(description) {

    /**
     * @method gatherMenuDescription
     * @summary Gathers the menu description into the supplied Array,
     *     recursively calling itself to process submenus.
     * @param {Array} description The menu description that will be built up as
     *     this method processes the receivers descendants.
     * @returns {TP.electron.ElectronMessageSource} The receiver.
     */

    var itemTPElems,
        attrList;

    //  Grab all *direct children* that are either menus or menuitems.
    itemTPElems = this.get('> electron|menu, > electron|menuitem');

    //  The list of attributes to retrieve from each item is defined as a type
    //  constant.
    attrList = this.getType().get('MENU_TEMPLATE_SLOT_NAMES');

    if (TP.notEmpty(itemTPElems)) {

        //  Iterate over each child, gathering its attributes into configuration
        //  object and recursively calling this method to process submenus.
        itemTPElems.forEach(
            function(anItemTPElem) {
                var configPOJO,
                    clickSignal;

                configPOJO = this.getType().buildConfigObjectFromAttributes(
                                anItemTPElem.getNativeNode(), attrList);

                //  The 'on:click' is handled specially.
                clickSignal = TP.elementGetAttribute(anItemTPElem.getNativeNode(),
                                                    'on:click',
                                                    true);

                //  If we actually had a value here, tell our overall
                //  Application instance to observe it (for dispatching
                //  purposes) and set an Array on the 'eventInfo' slot that will
                //  be used by the menu plugin on the Electron main side to
                //  dispatch the event.
                if (TP.notEmpty(clickSignal)) {
                    TP.sys.getApplication().observe(
                        TP.electron.ElectronMain, clickSignal);
                    configPOJO.eventInfo = ['TIBET/' + clickSignal];
                }

                description.push(configPOJO);

                //  If the item we processed was itself a menu, allocate an
                //  Array on the 'submenu' slot and recursively call this method
                //  with that Array.
                if (TP.isKindOf(anItemTPElem, TP.electron.menu)) {
                    configPOJO.submenu = TP.ac();
                    anItemTPElem.gatherMenuDescription(configPOJO.submenu);
                }
            }.bind(this));
    }

    return this;
});

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/services/tds/TP.uri.TDSURLHandler.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_services.xml';
TP.boot.$$srcConfig = 'tds';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.uri.TDSURLHandler}
 * @summary A subtype of HTTPURLHandler that manages URLs coming from the TDS.
 *     The TDS can provide change notifications about the URLs it manages and
 *     this type can then dispatch those changes into the TIBET change
 *     notification system.
 */

//  ------------------------------------------------------------------------

TP.uri.HTTPURLHandler.defineSubtype('uri.TDSURLHandler');

TP.uri.TDSURLHandler.addTraits(TP.uri.RemoteURLWatchHandler);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

TP.uri.TDSURLHandler.set('uriConfigName', 'tds.watch.uri');

TP.uri.TDSURLHandler.Type.defineAttribute('uriConfigName',
    'tds.watch.uri');

//  NOTE that these use the more generic 'uri.source.' config roots.
TP.uri.TDSURLHandler.Type.defineAttribute('includeConfigName',
    'uri.watch.include');
TP.uri.TDSURLHandler.Type.defineAttribute('excludeConfigName',
    'uri.watch.exclude');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.uri.TDSURLHandler.Type.defineMethod('getWatcherSignalType',
function() {

    /**
     * @method getWatcherSignalType
     * @summary Returns the TIBET type of the watcher signal. This will be the
     *     signal that the signal source sends when it wants to notify URIs of
     *     changes.
     * @returns {TP.sig.TDSFileChange} The type that will be instantiated
     *     to construct new signals that notify observers that the *remote*
     *     version of the supplied URI's resource has changed.
     */

    return TP.sig.TDSFileChange;
});

//  ------------------------------------------------------------------------

TP.uri.TDSURLHandler.Type.defineMethod('getWatcherSourceType',
function() {

    /**
     * @method getWatcherSourceType
     * @summary Returns the TIBET type of the watcher signal source. Typically,
     *     this is one of the prebuilt TIBET watcher types, like
     *     TP.core.SSEMessageSource for Server-Sent Event sources.
     * @returns {TP.core.SSEMessageSource} The type that will be instantiated to
     *     make a watcher for the supplied URI.
     */

    return TP.core.SSEMessageSource;
});

//  ------------------------------------------------------------------------

TP.uri.TDSURLHandler.Type.defineMethod('patch',
function(targetURI, aRequest) {

    /**
     * @method patch
     * @summary Patches the remote version of the resource pointed to by the
     *     supplied URI by saving a patch in the 'unified diff' format to the
     *     endpoint of a server (such as the TDS) that can handle a patching
     *     operation against that kind of remote resource.
     * @param {TP.uri.URI} targetURI The URI to patch. NOTE that this URI will
     *     not have been rewritten/resolved.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    var request,
        response,

        localResult,
        localContent,

        promise;

    request = targetURI.constructRequest(aRequest);
    response = request.getResponse();

    if (!TP.canInvoke(targetURI, 'getLocation')) {
        request.fail();
        return response;
    }

    //  First, try to get the URI's content as a TP.core.Content object
    localResult =
        targetURI.getResource(
            TP.hc('resultType', TP.CONTENT, 'contentType', TP.core.Content)
        ).get('result');

    //  If that was successful, use 'asCleanString()'. This gives a more
    //  'TIBETan' representation (especially if it's markup).
    if (TP.isKindOf(localResult, TP.core.Content)) {
        localContent = localResult.asCleanString(
                                    aRequest.at('serializationParams'));
    } else {

        //  Otherwise, just use the raw text.
        localResult = targetURI.getResource(
                        TP.hc('resultType', TP.TEXT)).get('result');
        localContent = TP.str(localResult);
    }

    //  This call will generate a patch using the supplied local content and
    //  will fetch the remote content from the targetURI *as it currently exists
    //  on the server* but *without updating the targetURI's resource with the
    //  remote content*.
    promise = targetURI.computeDiffPatchAgainst(localContent);

    promise.then(
            function(diffPatch) {
                if (TP.notEmpty(diffPatch)) {
                    return this.sendPatch(targetURI, diffPatch);
                }
                return null;
            }.bind(this)).then(
            function(successfulPatch) {

                //  Note passing the second 'true' here to signal change of the
                //  'dirty' flag.
                targetURI.isDirty(false, true);

                request.set('result', successfulPatch);
                request.complete();
            });

    return response;
});

//  ------------------------------------------------------------------------

TP.uri.TDSURLHandler.Type.defineMethod('sendPatch',
function(targetURI, patch) {

    /**
     * @method sendPatch
     * @summary Sends an HTTP POST with the supplied diff patch String and
     *     virtual resource location to the server to try to patch the remote
     *     version of the resource pointed to by the receiver.
     * @param {TP.uri.URI} targetURI The URI to patch. NOTE that this URI will
     *     not have been rewritten/resolved.
     * @param {String} patch A 'unified diff' patch String that will be used
     *     to patch the remote version of the resource pointed to by the
     *     receiver.
     * @returns {Promise} A Promise whose resolved value will be a Boolean
     *     indicating whether the patch operation was successful.
     */

    var patchVirtualLoc,
        promise;

    //  Make sure that we have non-empty diff patch and virtual location
    //  Strings.
    if (TP.isEmpty(patch)) {
        return TP.extern.Promise.resolve(false);
    }

    patchVirtualLoc = targetURI.getVirtualLocation();
    if (TP.isEmpty(patchVirtualLoc)) {
        return this.raise('TP.sig.InvalidOperation',
            'Unable to locate source path for content.');
    }

    promise = TP.extern.Promise.construct(
                function(resolver, rejector) {

                    var patchRequest;

                    //  Construct a POST request for the patching operation.
                    //  Note here how it has a JSON mimetype, which is what the
                    //  patching service for the TDS expects.
                    patchRequest = targetURI.constructRequest(
                                            TP.hc('mimetype', TP.JSON_ENCODED));

                    patchRequest.defineHandler('RequestSucceeded',
                                                    function() {
                                                        resolver(true);
                                                    });

                    patchRequest.defineHandler('RequestFailed',
                                                    function() {
                                                        resolver(false);
                                                    });

                    //  Set the body for the request to the patching service URL
                    //  to what the patching service expects to see.
                    patchRequest.atPut('body',
                                            TP.hc('type', 'diff',
                                                    'nowatch', true,
                                                    'target', patchVirtualLoc,
                                                    'content', patch));

                    targetURI.httpPatch(patchRequest);
                });

    return promise;
}, {
    dependencies: [TP.extern.Promise]
});

//  ------------------------------------------------------------------------

TP.uri.TDSURLHandler.Type.defineMethod('save',
function(targetURI, aRequest) {

    /**
     * @method save
     * @summary Saves URI data content. This is the default data persistence
     *     method for most URI content. In this type, this will call 'patch' if
     *     the supplied URI points to content that is 'patchable' by the TDS.
     * @param {TP.uri.URI} targetURI The URI to save. NOTE that this URI will
     *     not have been rewritten/ resolved.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    var request,
        response;

    request = targetURI.constructRequest(aRequest);
    response = request.getResponse();

    if (!TP.canInvoke(targetURI, 'getLocation')) {
        request.fail();
        return response;
    }

    //  If the system is testing, then we never do a PATCH.
    if (TP.sys.isTesting()) {
        return this.callNextMethod();
    }

    //  If the request's method is HTTP_PATCH, then we always do a PATCH
    if (request.at('method') === TP.HTTP_PATCH) {
        return this.patch(targetURI, request);
    }

    //  If the URI can produce a diff patch, then we change the method to
    //  HTTP_PATCH and do a PATCH
    if (targetURI.canDiffPatch()) {
        request.atPut('method', TP.HTTP_PATCH);
        return this.patch(targetURI, request);
    }

    return this.callNextMethod();
});

//  ------------------------------------------------------------------------

TP.uri.TDSURLHandler.Type.defineHandler('TDSFileChange',
function(aSignal) {

    /**
     * @method handleTDSFileChange
     * @summary Handles when a TDS-managed resource has changed.
     * @param {TP.sig.TDSFileChange} aSignal The signal indicating that a
     *     TDS-managed resource has changed.
     * @returns {TP.meta.uri.TDSURLHandler} The receiver.
     */

    var payload,
        data,
        path,
        fileName,
        url;

    //  Make sure that we have a payload
    if (TP.notValid(payload = aSignal.getPayload())) {
        return this;
    }

    //  And that we have SSE data in that payload
    data = payload.at('data');
    if (TP.notValid(data)) {
        return this;
    }

    //  If we can't determine the file path we can't take action in any case.
    path = data.at('path');
    if (TP.isEmpty(path)) {
        return this;
    }

    //  Strip any enclosing quotes from the path.
    path = path.asString().stripEnclosingQuotes();

    fileName = TP.uriExpandPath(path);

    //  If we can successfully create a URL from the data, then process the
    //  change.
    if (TP.isURI(url = TP.uc(fileName))) {
        TP.uri.URI.processRemoteResourceChange(url);
    }

    return this;
});

//  =======================================================================
//  Registration
//  ========================================================================

//  Make sure the remote url watcher knows about this handler type, but wait to
//  do this after the type has been fully configured to avoid api check error.
TP.uri.RemoteURLWatchHandler.registerWatcher(TP.uri.TDSURLHandler);

//  =======================================================================
//  TP.sig.TDSFileChange
//  ========================================================================

TP.sig.RemoteURLChange.defineSubtype('TDSFileChange');

//  We configure our REMOTE_NAME to the same SSE-level event that the TDS is
//  configured to send. When the SSE channel signals that event it will be
//  transformed into a TDSFileChange signal we handle to do the processing.
TP.sig.TDSFileChange.Type.defineConstant('REMOTE_NAME',
    TP.sys.cfg('tds.watch.event'));

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_src/tibet/services/couchdb/TP.uri.CouchDBURLHandler.js';
TP.boot.$$srcPackage = '~lib_cfg/tibet_services.xml';
TP.boot.$$srcConfig = 'couchdb';
//  ========================================================================
/**
 * @copyright Copyright (C) 1999 Technical Pursuit Inc. (TPI) All Rights
 *     Reserved. Patents Pending, Technical Pursuit Inc. Licensed under the
 *     OSI-approved Reciprocal Public License (RPL) Version 1.5. See the RPL
 *     for your rights and responsibilities. Contact TPI to purchase optional
 *     privacy waivers if you must keep your TIBET-based source code private.
 */
//  ------------------------------------------------------------------------

/**
 * @type {TP.uri.CouchDBURLHandler}
 * @summary A URL handler that manages URLs coming from uri. Changes from
 *     CouchDB come in the form of the CouchDB changes feed, which this handler
 *     can be configured to observe. NOTE that CouchDB observations are done
 *     independently of the URI source watch configuration. This independence
 *     lets you interact with both the TDS and CouchDB as needed.
 */

//  ------------------------------------------------------------------------

TP.uri.HTTPURLHandler.defineSubtype('uri.CouchDBURLHandler');

TP.uri.CouchDBURLHandler.addTraits(TP.uri.RemoteURLWatchHandler);

//  ------------------------------------------------------------------------
//  Type Constants
//  ------------------------------------------------------------------------

TP.uri.CouchDBURLHandler.Type.defineConstant(
    'DATABASE_PATH_MATCHER',
    /^[a-z]{1}[a-z0-9_$()+-]*\/$/);

TP.uri.CouchDBURLHandler.Type.defineConstant(
    'DATABASE_AND_DOCUMENT_PATH_MATCHER',
    /^[a-z]{1}[a-z0-9_$()+-]*\/[a-z0-9]+$/);

//  ------------------------------------------------------------------------
//  Type Attributes
//  ------------------------------------------------------------------------

//  Configuration names for the include/exclude configuration setting for the
//  remote url watcher types which mix this in.
TP.uri.CouchDBURLHandler.set('includeConfigName',
    'couch.watch.include');
TP.uri.CouchDBURLHandler.set('excludeConfigName',
    'couch.watch.exclude');

//  Server roots that have been authenticated.
TP.uri.CouchDBURLHandler.Type.defineAttribute('authenticatedRoots');

//  The username used when our authentication scheme is set to 'basic'.
TP.uri.CouchDBURLHandler.Type.defineAttribute('$basicUsername');

//  The password used when our authentication scheme is set to 'basic'.
TP.uri.CouchDBURLHandler.Type.defineAttribute('$basicPassword');

//  ------------------------------------------------------------------------
//  Type Methods
//  ------------------------------------------------------------------------

TP.uri.CouchDBURLHandler.Type.defineMethod('initialize',
function() {

    /**
     * @method initialize
     * @summary Performs one-time setup for the type on startup/import.
     */

    this.set('authenticatedRoots', TP.hc());

    return;
});

//  ------------------------------------------------------------------------

TP.uri.CouchDBURLHandler.Type.defineMethod('activateRemoteWatch',
function() {

    /**
     * @method activateRemoteWatch
     * @summary Performs any processing necessary to activate observation of
     *     remote URL changes.
     * @returns {TP.meta.uri.CouchDBURLHandler} The receiver.
     */

    //  If we're not watching CouchDB changes, then exit here.
    if (TP.notTrue(TP.sys.cfg('couch.watch.changes'))) {
        return this;
    }

    //  Push ourself as a controller onto the application's controller stack.
    //  This will allow us to receive the TP.sig.AppDidStart signal below.
    TP.sys.getApplication().pushController(this);

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.CouchDBURLHandler.Type.defineMethod('addAuthenticatedRoot',
function(aRootLocation, authenticationData) {

    /**
     * @method addAuthenticatedRoot
     * @summary Adds the supplied root location to the list of authenticated
     *     roots. This method will also cause that authentication to time out
     *     according to the setting of 'couch.auth_cookie_timeout' (defaulted
     *     to 600000ms).
     * @param {String} aRootLocation The root location that has been
     *     authenticated and needs to be tracked.
     * @param {TP.core.Hash} [authenticationData] Data about the authenticated
     *     user returned by the authentication call, such as their role.
     * @returns {TP.meta.uri.CouchDBURLHandler} The receiver.
     */

    var authenticatedRoots;

    authenticatedRoots = this.get('authenticatedRoots');

    authenticatedRoots.atPut(aRootLocation,
                                TP.ifInvalid(authenticationData, TP.hc()));

    //  Set a timeout that will remove the root from the list of authenticated
    //  roots.
    /* eslint-disable no-extra-parens */
    setTimeout(
        function() {
            authenticatedRoots.removeKey(aRootLocation);
        }, (TP.sys.cfg('couch.auth_cookie_timeout', 600) * 1000));
    /* eslint-enable no-extra-parens */

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.CouchDBURLHandler.Type.defineMethod('authenticate',
function(aURI, username, password) {

    /**
     * @method authenticate
     * @summary Authenticate the supplied URI. This will actually authenticate
     *     the root of the supplied URI.
     * @param {TP.uri.URI} aURI The URI to authenticate.
     * @param {String} [username] The username to use to authenticate. If this
     *     is not supplied, the user will be prompted to supply it.
     * @param {String} [password] The password to use to authenticate. If this
     *     is not supplied, the user will be prompted to supply it.
     * @returns {TP.sig.HTTPRequest} The authentication request.
     */

    var authScheme;

    authScheme = TP.sys.cfg('couch.auth_scheme', 'basic');
    if (authScheme === 'basic') {
        return this.authenticateBasic(aURI, username, password);
    }

    return this.authenticateCookie(aURI, username, password);
});

//  ------------------------------------------------------------------------

TP.uri.CouchDBURLHandler.Type.defineMethod('authenticateBasic',
function(aURI, username, password) {

    /**
     * @method authenticateBasic
     * @summary Authenticate the supplied URI using the 'basic' authentication
     *     scheme. This will actually authenticate the root of the supplied URI.
     * @param {TP.uri.URI} aURI The URI to authenticate.
     * @param {String} [username] The username to use to authenticate. If this
     *     is not supplied, the user will be prompted to supply it.
     * @param {String} [password] The password to use to authenticate. If this
     *     is not supplied, the user will be prompted to supply it.
     * @returns {TP.sig.HTTPRequest} The authentication request.
     */

    var rootLoc,
        href,
        authRequest,

        thisref;

    //  Build an request that we can post below. For 'basic' authentication, all
    //  we're trying to do is to determine whether the username and password are
    //  correct, since we'll be sending it each time.

    //  Construct the proper href to the authentication endpoint.
    rootLoc = aURI.getRoot();
    href = rootLoc + '/';

    //  Now, since we know we're talking to CouchDB over HTTP, we construct an
    //  HTTPRequest. This will allow enhanced error handling of this request,
    //  such as signaling signals like 401, for instance, if there is an invalid
    //  login.
    authRequest = TP.sig.HTTPRequest.construct(
                    TP.hc(
                        'uri', href,
                        'auth', TP.HTTP_BASIC,
                        'username', username,
                        'password', password));

    //  If the IO succeeds, that means that we have a good username and
    //  password, so we store them away.
    thisref = this;
    authRequest.defineHandler('IOSucceeded',
        function(aResponse) {

            thisref.set('$basicUsername', username);
            thisref.set('$basicPassword', password);

            this.callNextMethod();
        });

    //  Get some information from the auth endpoint.
    TP.httpGet(href, authRequest);

    return authRequest;
}, {
    patchCallee: false
});

//  ------------------------------------------------------------------------

TP.uri.CouchDBURLHandler.Type.defineMethod('authenticateCookie',
function(aURI, username, password) {

    /**
     * @method authenticateCookie
     * @summary Authenticate the supplied URI using the 'cookie token'
     *     authentication scheme. This will actually authenticate the root of
     *     the supplied URI.
     * @param {TP.uri.URI} aURI The URI to authenticate.
     * @param {String} [username] The username to use to authenticate. If this
     *     is not supplied, the user will be prompted to supply it.
     * @param {String} [password] The password to use to authenticate. If this
     *     is not supplied, the user will be prompted to supply it.
     * @returns {TP.sig.HTTPRequest} The authentication request.
     */

    var rootLoc,
        href,
        authRequest,

        thisref,

        loginFunc;

    //  Build an authentication request that we can post below.

    //  Construct the proper href to the authentication endpoint.
    rootLoc = aURI.getRoot();
    href = rootLoc + '/_session';

    //  Now, since we know we're talking to CouchDB over HTTP, we construct an
    //  HTTPRequest. This will allow enhanced error handling of this request,
    //  such as signaling signals like 401, for instance, if there is an invalid
    //  login.
    authRequest = TP.sig.HTTPRequest.construct(
                    TP.hc(
                        'uri', href,
                        'headers',
                            TP.hc('Content-Type', TP.JSON_ENCODED),
                        'simple_cors_only', true));

    //  If the low-level IO request succeeds, then we add the root location as
    //  an authenticated root and tell the HTTPService to handle the new request
    //  directly.
    thisref = this;
    authRequest.defineHandler('IOSucceeded',
        function(aResponse) {

            var result;

            //  Grab the response from the CouchDB cookie authentication call
            //  and convert the JSON string into a TIBET JS object (which will
            //  be a TP.core.Hash) and remove the 'ok' key. The remaining data
            //  will include an Array of roles that this user is now
            //  authenticated for.
            result = aResponse.get('result');
            result = TP.json2js(result);
            result.removeKey('ok');

            //  Note that we add the authenticated root *first* before we 'call
            //  up'. That way, any handlers that rely on this setting are seeing
            //  an accurate authenticated root list.
            thisref.addAuthenticatedRoot(rootLoc, result);

            this.callNextMethod();
        });

    //  Define a common login function that can either be called directly, or
    //  after the user has been prompted for a username and password. This
    //  function takes a username and password to be populated into the
    //  authentication request and posts it to CouchDB's '/_session' endpoint.
    //  Successful authentication here will mean that we have authenticated with
    //  CouchDB using cookie authentication.
    loginFunc = function(loginUsername, loginPassword) {

        var body;

        //  Encode the body of the authentication request by formatting the
        //  username and password as JSON.
        body = TP.hc(
                'username', loginUsername,
                'password', loginPassword).asJSONSource();

        authRequest.atPut('body', body);

        //  Post the authentication request to the auth endpoint.
        TP.httpPost(href, authRequest);
    };

    //  If the username and password (*both* of them) were supplied in this
    //  call, then there is no need to prompt the user for them. Try to log in
    //  using them.
    if (TP.notEmpty(username) && TP.notEmpty(password)) {
        loginFunc(username, password);
    } else {
        //  Otherwise, prompt the user for the CouchDB username
        TP.prompt('Enter CouchDB username:',
                    TP.notValid(username) ? '' : username).then(
            function(retVal) {

                var promptedUsername;

                //  If the value came back empty, then just return.
                if (TP.isEmpty(retVal)) {
                    return;
                }

                promptedUsername = retVal;

                //  Prompt the user for the CouchDB password
                TP.prompt('Enter CouchDB password:',
                            TP.notValid(password) ? '' : password,
                            TP.hc('secure', true)).then(
                    function(retVal2) {

                        var promptedPassword;

                        //  If the value came back empty, then just return.
                        if (TP.isEmpty(retVal2)) {
                            return;
                        }

                        promptedPassword = retVal2;

                        //  Got both a username and password - call the login
                        //  function.
                        loginFunc(promptedUsername, promptedPassword);
                    });
            });
    }

    return authRequest;
}, {
    patchCallee: false
});

//  ------------------------------------------------------------------------

TP.uri.CouchDBURLHandler.Type.defineMethod('deactivateRemoteWatch',
function() {

    /**
     * @method deactivateRemoteWatch
     * @summary Performs any processing necessary to shut down observation of
     *     remote URL changes.
     * @returns {TP.meta.uri.CouchDBURLHandler} The receiver.
     */

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.CouchDBURLHandler.Type.defineMethod('getWatcherSignalType',
function() {

    /**
     * @method getWatcherSignalType
     * @summary Returns the TIBET type of the watcher signal. This will be the
     *     signal that the signal source sends when it wants to notify URIs of
     *     changes.
     * @returns {TP.sig.RemoteURLChange} The type that will be
     *     instantiated to construct new signals that notify observers that the
     *     *remote* version of the supplied URI's resource has changed. At this
     *     level, this returns the common supertype of all such signals.
     */

    return TP.sig.CouchDBChange;
});

//  ------------------------------------------------------------------------

TP.uri.CouchDBURLHandler.Type.defineMethod('getWatcherSourceType',
function() {

    /**
     * @method getWatcherSourceType
     * @summary Returns the TIBET type of the watcher signal source. Typically,
     *     this is one of the prebuilt TIBET watcher types, like
     *     TP.core.SSEMessageSource for Server-Sent Event sources.
     * @returns {TP.core.SSEMessageSource} The type that will be instantiated to
     *     make a watcher for the supplied URI.
     */

    return TP.core.SSEMessageSource;
});

//  ------------------------------------------------------------------------

TP.uri.CouchDBURLHandler.Type.defineMethod('getWatcherSourceURIs',
function() {

    /**
     * @method getWatcherSourceURIs
     * @summary Returns an array of URIs which are needed to observe CouchDBs
     *     various change feeds.
     * @returns {TP.uri.URI[]} An Array of URIs pointing to 'change feed'
     *     resources that will notify TIBET when the supplied URI's resource
     *     changes.
     */

    var watcherSourceURIs,

        rootURLs,
        targets;

    watcherSourceURIs = TP.ac();

    //  Grab the CouchDB 'root' URLs (i.e. servers) that the system knows about
    //  via the config system.
    rootURLs = TP.sys.getcfg('couch.known_server_urls');

    //  Grab the non-server URI patterns that we should be watching.
    targets = TP.sys.getcfg('couch.watch.feeds');

    //  Iterate over the root server URLs and process them.
    rootURLs.forEach(
            function(aPair) {

                var rootURL;

                //  The rootURL will be the last part of the pair.
                rootURL = aPair.last();

                //  Join each URI pattern part onto the end of each root URL
                //  and, if a URI string can be formed, add it to the watcher
                //  source URI list.
                targets.forEach(
                        function(target) {
                            var url;

                            url = TP.uriJoinPaths(rootURL, target);
                            if (TP.isURIString(url)) {
                                watcherSourceURIs.push(TP.uc(url));
                            }
                        });
            });

    return watcherSourceURIs;
});

//  ------------------------------------------------------------------------

TP.uri.CouchDBURLHandler.Type.defineHandler('AppDidStart',
function(aSignal) {

    /**
     * @method handleAppDidStart
     * @summary
     * @param {TP.sig.AppDidStart} aSignal The signal indicating that the
     *     application has completed all of its startup tasks.
     * @returns {TP.meta.uri.CouchDBURLHandler} The receiver.
     */

    var watcherURIs,
        watchSource,

        authScheme,

        authenticatedRoots,
        authenticatingRoots;

    //  Remove ourself from the application's controller stack - we won't be
    //  needing to get any more signals from there.
    TP.sys.getApplication().removeController(this);

    //  Grab all of the 'watcher sources' (i.e. individual CouchDB server
    //  instances) that we are watching.
    watcherURIs = this.getWatcherSourceURIs();

    //  Define a Function that will set up an EventSource on a supplied changes
    //  feed source URI.
    watchSource = function(aSourceURI) {
        var sourceType,
            signalType,

            signalSource;

        sourceType = this.getWatcherSourceType();
        signalType = this.getWatcherSignalType();

        signalSource = sourceType.construct(
                            aSourceURI.getLocation(),
                            TP.hc('withCredentials', true));

        if (TP.notValid(signalSource)) {
            return this.raise('InvalidURLWatchSource');
        }

        this.observe(signalSource, signalType);
    }.bind(this);

    //  If the authentication scheme is 'basic', then we just return. Since,
    //  with basic auth, we authenticate each time, there is no concept of
    //  'authenticated roots'.
    authScheme = TP.sys.cfg('couch.auth_scheme', 'basic');
    if (authScheme === 'basic') {
        return this;
    }

    authenticatedRoots = this.get('authenticatedRoots');

    //  Set up a hash that will track the currently authenticating roots so that
    //  we don't try to authenticate a particular root multiple times. This will
    //  have a key of the authenticating root and an Array of source URIs under
    //  that root that will be set up as EventSources after the connection is
    //  authenticated.
    authenticatingRoots = TP.hc();

    //  Iterate over each watcher source and authenticate with it using 'cookie
    //  authentication'. The browser and CouchDB will manage authentication
    //  after this by putting in the authentication token into the HTTP
    //  headers for each roundtrip.
    watcherURIs.perform(
        function(aURI) {

            var rootLoc,
                href,

                body,

                username,
                password,

                request;

            rootLoc = aURI.getRoot();

            if (TP.isValid(authenticatingRoots.at(rootLoc))) {
                //  This root is in the process of being authenticated, so we
                //  don't want to do that process again. We do, however, want to
                //  track all of the URIs that need to be watched once this root
                //  is authenticated.
                authenticatingRoots.at(rootLoc).push(aURI);
            } else if (authenticatedRoots.hasKey(rootLoc)) {
                //  If its already authenticated, then just call the Function to
                //  watch the source URI.
                watchSource(aURI);
            } else {

                //  Add the root location and the source URI as the first item
                //  in the Array to the hash of authenticating roots.
                authenticatingRoots.atPut(rootLoc, TP.ac(aURI));

                //  Construct the proper href to the authentication endpoint.
                href = rootLoc + '/_session';

                //  Prompt the user for the CouchDB username
                TP.prompt('Enter CouchDB username for: ' + href).then(
                    function(retVal) {

                        //  If the value came back empty, then just return.
                        if (TP.isEmpty(retVal)) {
                            return;
                        }

                        username = retVal;

                        //  Prompt the user for the CouchDB password
                        TP.prompt('Enter CouchDB password for: ' + href).then(
                            function(retVal2) {

                                //  If the value came back empty, then just
                                //  return.
                                if (TP.isEmpty(retVal2)) {
                                    return;
                                }

                                password = retVal2;

                                //  Encode the body of the authentication
                                //  request by formatting the username and
                                //  password as JSON.
                                body = TP.hc(
                                        'username', username,
                                        'password', password).asJSONSource();

                                //  Build a request that we can post below.
                                request = TP.request(
                                        'uri', href,
                                        'headers',
                                            TP.hc('Content-Type',
                                                    TP.JSON_ENCODED),
                                        'body', body,
                                        'simple_cors_only', true);

                                //  Set up a RequestSucceeded handler that will
                                //  set up a SSE observer on the CouchDB changes
                                //  feed.
                                request.defineHandler('RequestSucceeded',
                                    function(aResponse) {
                                        var authenticatedRoot,
                                            watchingURIs,

                                            result;

                                        //  Grab the root of the response's URI.
                                        //  This will be the root that has been
                                        //  authenticated.
                                        authenticatedRoot =
                                            TP.uc(aResponse.at('uri')).getRoot();

                                        //  Grab the response from the CouchDB
                                        //  cookie authentication call and
                                        //  convert the JSON string into a TIBET
                                        //  JS object (which will be a
                                        //  TP.core.Hash) and remove the 'ok'
                                        //  key. The remaining data will include
                                        //  an Array of roles that this user is
                                        //  now authenticated for.
                                        result = aResponse.get('result');
                                        result = TP.json2js(result);
                                        result.removeKey('ok');

                                        //  Add that to our list of
                                        //  authenticated roots.
                                        TP.uri.CouchDBURLHandler.
                                            addAuthenticatedRoot(
                                                authenticatedRoot,
                                                result);

                                        //  Grab the Array of URIs that want to
                                        //  be watched that are associated with
                                        //  our now authentication root.
                                        watchingURIs = authenticatingRoots.at(
                                                            authenticatedRoot);

                                        //  Call the function that will watch
                                        //  them.
                                        watchingURIs.forEach(
                                            function(watchURI) {
                                                watchSource(watchURI);
                                            });
                                    });

                                //  Post the request to the authentication
                                //  endpoint.
                                TP.httpPost(href, request);
                            });
                    });
            }
        });

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.CouchDBURLHandler.Type.defineHandler('CouchDBChange',
function(aSignal) {

    /**
     * @method handleCouchDBChange
     * @summary Handles when a TDS-managed resource has changed.
     * @param {TP.sig.CouchDBChange} aSignal The signal indicating that a
     *     TDS-managed resource has changed.
     * @returns {TP.meta.uri.CouchDBURLHandler} The receiver.
     */

    var payload,

        data,

        doc,
        attachments,

        rawRev,
        rev,

        entry,

        signalSourceURL,

        path,
        changesPathIndex,

        origin,

        urlLoc,
        url,

        id,
        dbDocPath,

        processed,
        docLoc,

        subURIs,
        matcher,
        viewURLs;

    //  Make sure that we have a payload
    if (TP.notValid(payload = aSignal.getPayload())) {
        return this;
    }

    //  And that we have SSE data in that payload
    data = payload.at('data');
    if (TP.notValid(data)) {
        return this;
    }

    //  If there was a property named 'doc' in the data and it has a property
    //  named '_attachments', then we're observing a design document.
    if (TP.isValid(doc = data.at('doc')) &&
        TP.isValid(attachments = doc.at('_attachments'))) {

        //  Grab the '_rev' number
        rawRev = data.at('doc').at('_rev');
        rev = rawRev.slice(0, rawRev.indexOf('-')).asNumber();

        //  Iterate over all of the attachments and grab the one whose 'revpos'
        //  matches the rev number that changed.
        entry = attachments.detect(
                    function(kvPair) {
                        if (kvPair.last().at('revpos') === rev) {
                            return true;
                        }
                        return false;
                    });

        //  If we successfully found one, then the first item in it's key/value
        //  pair was the URL that changed.
        if (TP.isValid(entry)) {
            urlLoc = TP.uriJoinPaths(TP.uc('~app').getLocation(),
                                        entry.first());
        }

    } else {
        //  Otherwise, these changes came from a changes feed monitoring pure
        //  data, not the URLs making up a CouchApp.

        //  For CouchDB, we observe at a database-level, so we want the database
        //  URL.
        signalSourceURL = TP.uc(payload.at('sourceURL'));
        if (!TP.isURI(signalSourceURL)) {
            return this;
        }

        path = signalSourceURL.getPath();

        //  Slice off the portion of the path from the first slash to where the
        //  '/_changes' portion starts. This will give us our database name -
        //  the database that changed. If there is no '/_changes' portion, then
        //  this must be an observation on the '_db_updates' feed, so we just
        //  set the path to the empty String.
        changesPathIndex = path.indexOf('/_changes');
        if (changesPathIndex !== TP.NOT_FOUND) {

            path = path.slice(1, changesPathIndex);

            //  Strip any enclosing quotes from the path.
            path = path.asString().stripEnclosingQuotes();

        } else {
            path = '';
        }

        //  The origin comes from the SSE data and will be server URL, minus the
        //  actual file path.
        origin = payload.at('origin').asString();

        //  Join the two together to form the full URL path
        urlLoc = TP.uriJoinPaths(origin, path);
    }

    //  If we can successfully create a URL from the data, then process the
    //  change.
    if (TP.isURI(url = TP.uc(urlLoc))) {

        processed = false;

        //  If the URL has subURIs, then we want to see if the change feed data
        //  mentions any of them as the 'id' of the document that changed.
        id = data.at('id');
        if (TP.notEmpty(id)) {

            //  Join the 'path' part of the URL (minus the root, and slicing off
            //  the leading '/') and the ID (which should be the ID of the
            //  document that changed).
            dbDocPath = TP.uriJoinPaths(url.getPath().slice(1), data.at('id'));

            //  Make sure that this path is pointing to a server/document.
            if (this.DATABASE_AND_DOCUMENT_PATH_MATCHER.test(dbDocPath)) {

                //  Join the whole URL's location with the ID. This will result
                //  in a URL that represents the full path to the CouchDB
                //  document.
                docLoc = TP.uriJoinPaths(url.getLocation(), data.at('id'));

                //  If there's a registered URL for that document, then we
                //  should fetch it from the server and signal a change
                if (TP.uri.URI.hasInstance(docLoc)) {
                    url = TP.uc(docLoc);
                    url.getResource(
                            TP.hc('refresh', true, 'signalChange', true));

                    processed = true;
                }
            }
        }

        //  If we didn't process the URI, then it wasn't a regular document. We
        //  should let the regular processing machinery handle it.
        if (!processed) {

            //  NB: This will only actually process the resource change if the
            //  'uri.source.process_changes' flag is true. Otherwise, it just
            //  tracks changes.
            TP.uri.URI.processRemoteResourceChange(url);
        }

        //  Update any view URLs that we know about

        //  Compute a RegExp that will find 'view' URLs.
        matcher = TP.rc(url.getLocation() + '/_design/\\w+/_view');

        //  Grab the subURIs of the url that we know about and select out of
        //  them ones that reference a view, per our computed match RegExp
        //  above.
        subURIs = url.getSubURIs();
        viewURLs = subURIs.select(
                    function(aURI) {
                        return matcher.test(aURI.getLocation());
                    });

        //  Iterate over the view URLs and force them to refresh from the
        //  server.
        viewURLs.perform(
            function(aViewURL) {
                aViewURL.getResource(
                            TP.hc('refresh', true, 'signalChange', true));
            });
    }

    return this;
});

//  ------------------------------------------------------------------------

TP.uri.CouchDBURLHandler.Type.defineMethod('isAuthenticated',
function(targetURI, roleName) {

    /**
     * @method isAuthenticated
     * @summary Returns whether or not the URI is authenticated.
     * @param {TP.uri.URI} targetURI The URI to test.
     * @param {String} [roleName] An optional role name to provide a further
     *     check.
     * @returns {Boolean} true if the URI is authenticated.
     */

    var authScheme,

        rootURI,
        authenticationData,

        roles;

    //  If the authentication scheme is 'basic', then we return true if we have
    //  a password that was deemed valid when we first authenticated.
    authScheme = TP.sys.cfg('couch.auth_scheme', 'basic');
    if (authScheme === 'basic') {
        return TP.notEmpty(this.get('$basicPassword'));
    }

    rootURI = targetURI.getRoot();

    authenticationData = this.get('authenticatedRoots').at(rootURI);

    //  If a role name was supplied and we have valid authentication entry for
    //  the URI, then check to see if the role name is in the list of roles.
    if (TP.isValid(authenticationData) && TP.notEmpty(roleName)) {
        roles = authenticationData.at('roles');
        return roles.contains(roleName);
    }

    //  If the role name wasn't specified, then we just return whether we found
    //  an authenticated entry for the supplied URI.
    return TP.isValid(authenticationData);
});

//  ------------------------------------------------------------------------

TP.uri.CouchDBURLHandler.Type.defineMethod('isCouchAppURI',
function(targetURI) {

    /**
     * @method isCouchAppURI
     * @summary Returns whether or not the URI's location is a path that leads
     *     to a 'couch app'.
     * @description This method will return true if the URI points to a location
     *     that's part of a 'couch app' application (i.e. a TIBET application
     *     that is stored inside of the CouchDB database itself).
     * @param {TP.uri.URI} targetURI The URI to test.
     * @returns {Boolean} true if the URI is a CouchApp URI.
     */

    var targetLoc,
        couchAppPortion;

    targetLoc = targetURI.getLocation();
    couchAppPortion = TP.uriJoinPaths(
                        TP.sys.cfg('couch.db_name'),
                        '_design',
                        TP.sys.cfg('project.name'));

    return targetLoc.contains(couchAppPortion);
});

//  ------------------------------------------------------------------------

TP.uri.CouchDBURLHandler.Type.defineMethod('isWatchableURI',
function(targetURI) {

    /**
     * @method isWatchableURI
     * @summary Tests a URI against include/exclude filters to determine if
     *     changes to the URI should be considered for processing.
     * @param {String|TP.uri.URI} targetURI The URI to test.
     * @returns {Boolean} true if the URI passes include/exclude filters.
     */

    //  TODO: In actuality, only some CouchDB URIs are watchable, but for now we
    //  always return true.

    return true;
});

//  ------------------------------------------------------------------------

TP.uri.CouchDBURLHandler.Type.defineMethod('load',
function(targetURI, aRequest) {

    /**
     * @method load
     * @summary Loads URI data content, returning the TP.sig.Response object
     *     used to manage the low-level service response.
     * @param {TP.uri.URI} targetURI The URI to load. NOTE that this URI will
     *     not have been rewritten/ resolved.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    var request,

        authScheme,

        reqParams,
        newReq,

        authRequest;

    request = TP.request(aRequest);

    //  Make sure that the UI is not a 'CouchApp URI' (i.e. isn't being
    //  loaded as part of a CouchApp application). If it is, just return
    //  whatever the supertype does (*without* setting simple CORS below).
    if (this.isCouchAppURI(targetURI)) {
        return this.callNextMethod();
    }

    //  If the authentication scheme is 'basic', then we set up the request to
    //  use HTTP basic authentication, supplying the username and password that
    //  were supplied when the connection was first authenticated.
    authScheme = TP.sys.cfg('couch.auth_scheme', 'basic');
    if (authScheme === 'basic') {
        request.atPut('auth', TP.HTTP_BASIC);
        request.atPut('username', this.get('$basicUsername'));
        request.atPut('password', this.get('$basicPassword'));
    } else {

        //  Otherwise, we're using 'cookie token' authenication.

        //  Make sure that the connection has been authenticated.
        if (!this.isAuthenticated(targetURI)) {

            reqParams = TP.copy(request.getParameters());
            reqParams.atPut('uri', targetURI);

            newReq = TP.sig.HTTPLoadRequest.construct(reqParams);
            request.andJoinChild(newReq);

            authRequest = this.authenticate(targetURI);
            authRequest.defineHandler('RequestSucceeded',
                function(aResponse) {
                    TP.uri.HTTPService.handle(newReq);
                });

            authRequest.defineHandler('RequestFailed',
                function(aResponse) {

                    //  If it doesn't authenticate, notify the user and simulate
                    //  a HTTP 401 error and report it / fail it like the TIBET
                    //  low-level HTTP code will.

                    TP.alert('Authentication Failed').then(
                        function() {
                            request.set('faultCode', 401);
                            request.set('faultText', 'Unauthorized');

                            TP.httpError(targetURI.getLocation(),
                                            'HTTPException',
                                            request,
                                            false);

                            request.fail(
                                    request.at('message'),
                                    request.getFaultCode(),
                                    TP.hc('error', request.at('error'),
                                            'message', request.at('message')));
                        });
                });

            return authRequest.getResponse();
        }

        //  It's best to make CouchDB to deal with 'simple CORS' (i.e. no
        //  preflight requests, etc.) if possible. Configure that here so that
        //  TIBET's low-level HTTP machinery doesn't try to add headers, etc.
        //  that would automatically cause preflight requests for even simple
        //  CORS cases.
        request.atPut('simple_cors_only', true);
        request.atPut('withCredentials', true);
    }

    return this.callNextMethod(targetURI, request);
});

//  ------------------------------------------------------------------------

TP.uri.CouchDBURLHandler.Type.defineMethod('delete',
function(targetURI, aRequest) {

    /**
     * @method delete
     * @summary Deletes a URI entirely, returning the TP.sig.Response object
     *     used to manage the low-level service response.
     * @param {TP.uri.URI} targetURI The URI to delete. NOTE that this URI will
     *     not have been rewritten/ resolved.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    var request,

        authScheme,

        reqParams,
        newReq,

        authRequest;

    request = TP.request(aRequest);

    //  Make sure that the UI is not a 'CouchApp URI' (i.e. isn't being
    //  loaded as part of a CouchApp application). If it is, just return
    //  whatever the supertype does (*without* setting simple CORS below).
    if (this.isCouchAppURI(targetURI)) {
        return this.callNextMethod();
    }

    //  If the authentication scheme is 'basic', then we set up the request to
    //  use HTTP basic authentication, supplying the username and password that
    //  were supplied when the connection was first authenticated.
    authScheme = TP.sys.cfg('couch.auth_scheme', 'basic');
    if (authScheme === 'basic') {
        request.atPut('auth', TP.HTTP_BASIC);
        request.atPut('username', this.get('$basicUsername'));
        request.atPut('password', this.get('$basicPassword'));
    } else {

        //  Otherwise, we're using 'cookie token' authenication.

        //  Make sure that the connection has been authenticated.
        if (!this.isAuthenticated(targetURI)) {

            reqParams = TP.copy(request.getParameters());
            reqParams.atPut('uri', targetURI);

            newReq = TP.sig.HTTPDeleteRequest.construct(reqParams);
            request.andJoinChild(newReq);

            authRequest = this.authenticate(targetURI);
            authRequest.defineHandler('RequestSucceeded',
                function(aResponse) {
                    TP.uri.HTTPService.handle(newReq);
                });

            authRequest.defineHandler('RequestFailed',
                function(aResponse) {

                    //  If it doesn't authenticate, notify the user and simulate
                    //  a HTTP 401 error and report it / fail it like the TIBET
                    //  low-level HTTP code will.

                    TP.alert('Authentication Failed').then(
                        function() {
                            request.set('faultCode', 401);
                            request.set('faultText', 'Unauthorized');

                            TP.httpError(targetURI.getLocation(),
                                            'HTTPException',
                                            request,
                                            false);

                            request.fail(
                                    request.at('message'),
                                    request.getFaultCode(),
                                    TP.hc('error', request.at('error'),
                                            'message', request.at('message')));
                        });
                });

            return authRequest.getResponse();
        }

        //  It's best to make CouchDB to deal with 'simple CORS' (i.e. no
        //  preflight requests, etc.) if possible. Configure that here so that
        //  TIBET's low-level HTTP machinery doesn't try to add headers, etc.
        //  that would automatically cause preflight requests for even simple
        //  CORS cases.
        request.atPut('simple_cors_only', true);
        request.atPut('withCredentials', true);
    }

    return this.callNextMethod(targetURI, request);
});

//  ------------------------------------------------------------------------

TP.uri.CouchDBURLHandler.Type.defineMethod('save',
function(targetURI, aRequest) {

    /**
     * @method save
     * @summary Saves URI data content. This is the default data persistence
     *     method for most URI content. Important request keys include 'method',
     *     'crud', and 'body'. Method will typically default to a POST unless
     *     TP.sys.cfg(http.use_webdav) is true and the crud parameter is set to
     *     'insert', in which case a PUT is used. The crud parameter effectively
     *     defaults to 'update' so you should set it to 'insert' when new
     *     content is being created. The 'body' should contain the new/updated
     *     content, but this is normally configured by the URI's save() method
     *     itself.
     * @param {TP.uri.URI} targetURI The URI to save. NOTE that this URI will
     *     not have been rewritten/ resolved.
     * @param {TP.sig.Request|TP.core.Hash} aRequest An object containing
     *     request information accessible via the at/atPut collection API of
     *     TP.sig.Requests.
     * @returns {TP.sig.Response} The request's response object.
     */

    var request,

        authScheme,

        reqParams,
        newReq,

        authRequest,

        saveURI;

    //  TODO: Only do this if targetURI is pointing to a CouchDB document

    request = TP.request(aRequest);

    //  Make sure that the UI is not a 'CouchApp URI' (i.e. isn't being
    //  loaded as part of a CouchApp application). If it is, just return
    //  whatever the supertype does (*without* setting simple CORS below).
    if (this.isCouchAppURI(targetURI)) {
        return this.callNextMethod();
    }

    //  If the authentication scheme is 'basic', then we set up the request to
    //  use HTTP basic authentication, supplying the username and password that
    //  were supplied when the connection was first authenticated.
    authScheme = TP.sys.cfg('couch.auth_scheme', 'basic');
    if (authScheme === 'basic') {
        request.atPut('auth', TP.HTTP_BASIC);
        request.atPut('username', this.get('$basicUsername'));
        request.atPut('password', this.get('$basicPassword'));
    } else {

        //  Make sure that the connection has been authenticated.
        if (!this.isAuthenticated(targetURI)) {

            reqParams = TP.copy(request.getParameters());
            reqParams.atPut('uri', targetURI);

            newReq = TP.sig.HTTPSaveRequest.construct(reqParams);
            request.andJoinChild(newReq);

            authRequest = this.authenticate(targetURI);
            authRequest.defineHandler('RequestSucceeded',
                function(aResponse) {
                    TP.uri.HTTPService.handle(newReq);
                });

            authRequest.defineHandler('RequestFailed',
                function(aResponse) {

                    //  If it doesn't authenticate, notify the user and simulate
                    //  a HTTP 401 error and report it / fail it like the TIBET
                    //  low-level HTTP code will.

                    TP.alert('Authentication Failed').then(
                        function() {
                            request.set('faultCode', 401);
                            request.set('faultText', 'Unauthorized');

                            TP.httpError(targetURI.getLocation(),
                                            'HTTPException',
                                            request,
                                            false);

                            request.fail(
                                    request.at('message'),
                                    request.getFaultCode(),
                                    TP.hc('error', request.at('error'),
                                            'message', request.at('message')));
                        });
                });

            return authRequest.getResponse();
        }

        //  It's best to make CouchDB to deal with 'simple CORS' (i.e. no
        //  preflight requests, etc.) if possible. Configure that here so that
        //  TIBET's low-level HTTP machinery doesn't try to add headers, etc.
        //  that would automatically cause preflight requests for even simple
        //  CORS cases.
        request.atPut('simple_cors_only', true);
        request.atPut('withCredentials', true);
    }

    saveURI = targetURI;

    //  Add a local handler for when the request succeeds that will update the
    //  '_rev' in the locally cached data to the new 'rev' sent back by the
    //  server.
    request.defineHandler('RequestSucceeded',
                function(aResponse) {
                    var newRev,
                        origData;

                    //  Grab the new 'rev' number from the result of the server
                    //  call.
                    newRev = aResponse.get('result').get('$.rev');

                    //  Using a JSONPath, set the value of '_rev' in the
                    //  original data to the new rev. This original data may be
                    //  used over and over again as updates are made, but per
                    //  CouchDB rules, it needs a new rev each time
                    origData = saveURI.getResource().get('result');

                    //  Note here that we pass 'false' to *not* signal changes
                    //  here.
                    origData.set('$._rev', newRev, false);

                    //  Now set the URI to not being dirty and signal change for
                    //  the whole URI.
                    targetURI.isDirty(false);
                    targetURI.$changed();
                });

    return this.callNextMethod(targetURI, request);
});

//  =======================================================================
//  Registration
//  ========================================================================

//  Make sure the remote url watcher knows about this handler type, but wait to
//  do this after the type has been fully configured to avoid api check error.
//  This will cause the activateRemoteWatch method to be invoked on the
//  TP.uri.CouchDBURLHandler to be invoked.
TP.uri.RemoteURLWatchHandler.registerWatcher(TP.uri.CouchDBURLHandler);

//  =======================================================================
//  TP.sig.CouchDBChange
//  ========================================================================

TP.sig.RemoteURLChange.defineSubtype('CouchDBChange');

//  ------------------------------------------------------------------------
//  end
//  ========================================================================
TP.boot.$$srcPath = '~lib_build/lib_dat-keyrings.xml.js';
TP.boot.$$srcPackage = '~lib_cfg/TIBET.xml';
TP.boot.$$srcConfig = 'base-inlined';
TP.uc('~lib_dat/keyrings.xml').setContent(
'<?xml version="1.0"?>\n<keyrings>\n    <!-- Library keyrings. There aren\'t any by default -->\n</keyrings>\n'
);
TP.boot.$$srcPath = '~lib_build/lib_dat-TP.core.USAscii101Keyboard.xml.js';
TP.boot.$$srcPackage = '~lib_cfg/TIBET.xml';
TP.boot.$$srcConfig = 'base-inlined';
TP.uc('~lib_dat/TP.core.USAscii101Keyboard.xml').setContent(
'<?xml version="1.0" encoding="UTF-8" standalone="yes"?>\n\n<keyboard name="USAscii101Keyboard">\n\n  <!--\n  Keyboard definition for a typical US Ascii 101 Keyboard.\n\n  ID values are prefixed with an underscore (\'_\') to avoid issues with XML.\n  A leading underscore simply makes a numeric code into a valid ID. When a\n  map entry is for a keycode in combination with the Shift key a suffix of\n  \'_shifted\' is appended.\n\n  NOTE that keyboard maps of this type rely on logic in the matching\n  TP.core.Keyboard subtype to normalize keycode/charcode values for browser\n  and platform differences, at least to the extent that a unique ID can be\n  used to provide a mapping. TIBET \'normalizes\' the keycode to whatever the\n  \'keydown\' event uses (\'keypress\' events often get their keyCode wrong).\n\n  TIBET signal names are computed from this map using the following algorithm:\n\n  1.  The name starts with the String \'DOM_\'\n  2.  If any of the modifier keys (Meta, Ctrl, Alt or Shift) are pressed,\n      that word is added to the name (i.e. \'Ctrl_\'). There is an order by\n      which multiple modifiers can be specified:\n\n        a.  \'Meta\'\n        b.  \'Ctrl\'\n        c.  \'Alt\'\n        d.  \'Shift\'\n\n      So a signal name could be: \'DOM_Ctrl_Shift_Tab_Down\', but *not*\n      \'DOM_Shift_Ctrl_Tab_Down\'\n\n  3.  If the key has a value for the \'key=\' attribute in this map, that\n      value is used:\n\n        DOM_Ctrl_Percent_Up\n        DOM_Ctrl_A_Up           //  NB: Lowercase \'a\'\n        DOM_Ctrl_Shift_A_Up     //  NB: Uppercase \'A\'\n\n  4.  If the key does not have a value for the \'key=\' attribute in this\n      map, the value in the \'glyph=\' attribute is used:\n\n        DOM_1_Up\n\n  5.  In addition to either the \'key\' or \'glyph\' value being used in a\n      signal name, TIBET will also generate a second signal name using the\n      Unicode value stored in the \'char=\' attribute. This allows\n      difficult-to-encode keys to be observed:\n\n        DOM_U0027_Up            //  NB: Same as \'DOM_Right_Up\'\n\n  If a key code is representing more than one entry, that means it will have\n  qualifiers depending on operating system (the \'platform\' attribute) and the\n  browser (the \'browser\' attribute). These entries are sorted in the following\n  order:\n\n    - no qualifier\n    - \'platform\' qualifier\n    - \'browser\' qualifier\n    - \'browser\' AND \'platform\' qualifier\n\n  The entry that is found last is then used to dispatch the key.\n\n  This keymap, tested on 5-APR-2013, was tested on the following browsers and\n  operating systems:\n\n    - IE8\n    - Firefox 20.0 (Mac and Windows)\n    - Chrome 26.0 (Mac and Windows)\n    - Safari 6.0 (Mac)\n  -->\n\n  <!-- ** <key keycode="_3" char="U0018" key="Cancel"/> -->\n  <!-- ** <key keycode="_6" key="Help"/> -->\n  <key keycode="_8" char="U0008" key="Backspace"/>\n  <key keycode="_9" char="U0009" key="Tab"/>\n\n  <!-- ** <key keycode="_10" key="Enter"/> -->\n  <key keycode="_12" platform="macosx" key="Clear"/>\n  <key keycode="_13" key="Enter"/>\n\n  <key keycode="_16" key="Shift"/>\n  <!-- Note that, even though we follow the W3C name of \'Control\' here, TIBET\n       will rename this key to \'Ctrl\' for consistency with key names that are\n       generated with the \'Ctrl\' modifier. -->\n  <key keycode="_17" key="Control"/>\n  <key keycode="_18" key="Alt"/>\n  <key keycode="_19" platform="win" key="Pause"/>\n  <key keycode="_20" key="CapsLock"/>\n\n  <key keycode="_27" char="U001B" key="Esc"/>\n\n  <key keycode="_32" key="Spacebar"/>\n\n  <key keycode="_33" key="PageUp"/>\n  <!-- ** <key keycode="_33_shifted" key="Excl"/> -->\n  <key keycode="_34" key="PageDown"/>\n  <!-- ** <key keycode="_34_shifted" key="???"/> -->\n  <key keycode="_35" key="End"/>\n  <!-- ** <key keycode="_35_shifted" key="Num"/> -->\n  <key keycode="_36" key="Home"/>\n  <!-- ** <key keycode="_36_shifted" key="Dollar"/> -->\n\n  <!-- Arrow keys -->\n  <key keycode="_37" key="Left"/>\n  <key keycode="_38" key="Up"/>\n  <key keycode="_39" key="Right"/>\n  <key keycode="_40" key="Down"/>\n\n  <!-- NOTE!!: This only reports this keycode on key up! -->\n  <key keycode="_44" platform="win" key="PrintScreen"/>\n\n  <key keycode="_45" platform="win" key="Insert"/>\n  <!-- Forward delete -->\n  <key keycode="_46" key="Del"/>\n\n  <!-- Alphabetic / Shift-ed Alphabetic -->\n\n  <key keycode="_65" char="U0061" glyph="a"/>\n  <key keycode="_65_shifted" char="U0041" glyph="A"/>\n\n  <key keycode="_66" char="U0062" glyph="b"/>\n  <key keycode="_66_shifted" char="U0042" glyph="B"/>\n\n  <key keycode="_67" char="U0063" glyph="c"/>\n  <key keycode="_67_shifted" char="U0043" glyph="C"/>\n\n  <key keycode="_68" char="U0064" glyph="d"/>\n  <key keycode="_68_shifted" char="U0044" glyph="D"/>\n\n  <key keycode="_69" char="U0065" glyph="e"/>\n  <key keycode="_69_shifted" char="U0045" glyph="E"/>\n\n  <key keycode="_70" char="U0066" glyph="f"/>\n  <key keycode="_70_shifted" char="U0046" glyph="F"/>\n\n  <key keycode="_71" char="U0067" glyph="g"/>\n  <key keycode="_71_shifted" char="U0047" glyph="G"/>\n\n  <key keycode="_72" char="U0068" glyph="h"/>\n  <key keycode="_72_shifted" char="U0048" glyph="H"/>\n\n  <key keycode="_73" char="U0069" glyph="i"/>\n  <key keycode="_73_shifted" char="U0049" glyph="I"/>\n\n  <key keycode="_74" char="U006A" glyph="j"/>\n  <key keycode="_74_shifted" char="U004A" glyph="J"/>\n\n  <key keycode="_75" char="U006B" glyph="k"/>\n  <key keycode="_75_shifted" char="U004B" glyph="K"/>\n\n  <key keycode="_76" char="U006C" glyph="l"/>\n  <key keycode="_76_shifted" char="U004C" glyph="L"/>\n\n  <key keycode="_77" char="U006D" glyph="m"/>\n  <key keycode="_77_shifted" char="U004D" glyph="M"/>\n\n  <key keycode="_78" char="U006E" glyph="n"/>\n  <key keycode="_78_shifted" char="U004E" glyph="N"/>\n\n  <key keycode="_79" char="U006F" glyph="o"/>\n  <key keycode="_79_shifted" char="U004F" glyph="O"/>\n\n  <key keycode="_80" char="U0070" glyph="p"/>\n  <key keycode="_80_shifted" char="U0050" glyph="P"/>\n\n  <key keycode="_81" char="U0071" glyph="q"/>\n  <key keycode="_81_shifted" char="U0051" glyph="Q"/>\n\n  <key keycode="_82" char="U0072" glyph="r"/>\n  <key keycode="_82_shifted" char="U0052" glyph="R"/>\n\n  <key keycode="_83" char="U0073" glyph="s"/>\n  <key keycode="_83_shifted" char="U0053" glyph="S"/>\n\n  <key keycode="_84" char="U0074" glyph="t"/>\n  <key keycode="_84_shifted" char="U0054" glyph="T"/>\n\n  <key keycode="_85" char="U0075" glyph="u"/>\n  <key keycode="_85_shifted" char="U0055" glyph="U"/>\n\n  <key keycode="_86" char="U0076" glyph="v"/>\n  <key keycode="_86_shifted" char="U0056" glyph="V"/>\n\n  <key keycode="_87" char="U0077" glyph="w"/>\n  <key keycode="_87_shifted" char="U0057" glyph="W"/>\n\n  <key keycode="_88" char="U0078" glyph="x"/>\n  <key keycode="_88_shifted" char="U0058" glyph="X"/>\n\n  <key keycode="_89" char="U0079" glyph="y"/>\n  <key keycode="_89_shifted" char="U0059" glyph="Y"/>\n\n  <key keycode="_90" char="U007A" glyph="z"/>\n  <key keycode="_90_shifted" char="U005A" glyph="Z"/>\n\n  <!-- Numeric / Shift-ed Numeric -->\n\n  <key keycode="_48" char="U0030" glyph="0"/>\n  <key keycode="_48_shifted" char="U0029" key="RightParen" glyph=")"/>\n\n  <key keycode="_49" char="U0031" glyph="1"/>\n  <key keycode="_49_shifted" char="U0021" key="Exclamation" glyph="!"/>\n\n  <key keycode="_50" char="U0032" glyph="2"/>\n  <key keycode="_50_shifted" char="U0040" key="At" glyph="@"/>\n\n  <key keycode="_51" char="U0033" glyph="3"/>\n  <key keycode="_51_shifted" char="U0023" key="Hash" glyph="#"/>\n\n  <key keycode="_52" char="U0034" glyph="4"/>\n  <key keycode="_52_shifted" char="U0024" key="Dollar" glyph="$"/>\n\n  <key keycode="_53" char="U0035" glyph="5"/>\n  <key keycode="_53_shifted" char="U0025" key="Percent" glyph="%"/>\n\n  <key keycode="_54" char="U0036" glyph="6"/>\n  <key keycode="_54_shifted" char="U005E" key="Circumflex" glyph="^"/>\n\n  <key keycode="_55" char="U0037" glyph="7"/>\n  <key keycode="_55_shifted" char="U0026" key="Ampersand" glyph="&amp;"/>\n\n  <key keycode="_56" char="U0038" glyph="8"/>\n  <key keycode="_56_shifted" char="U002A" key="Asterisk" glyph="*"/>\n\n  <key keycode="_57" char="U0039" glyph="9"/>\n  <key keycode="_57_shifted" char="U0028" key="LeftParen" glyph="("/>\n\n  <!-- The \'Equals\' character -->\n  <key keycode="_187" char="U003D" key="Equals" glyph="="/>\n  <key keycode="_61" browser="firefox" char="U003D" key="Equals" glyph="="/>\n\n  <!-- The \'Plus\' character -->\n  <key keycode="_187_shifted" char="U002B" key="Plus" glyph="+"/>\n  <key keycode="_61_shifted" browser="firefox" char="U002B" key="Plus" glyph="+"/>\n\n  <!-- The \'HyphenMinus\' character -->\n  <key keycode="_189" char="U002D" key="HyphenMinus" glyph="-"/>\n  <key keycode="_173" browser="firefox" char="U002D" key="HyphenMinus" glyph="-"/>\n\n  <!-- The \'Underscore\' character -->\n  <key keycode="_189_shifted" char="U005F" key="Underscore" glyph="_"/>\n  <key keycode="_173_shifted" browser="firefox" char="U005F" key="Underscore" glyph="_"/>\n\n  <key keycode="_192" char="U0060" key="Grave" glyph="`"/>\n  <key keycode="_192_shifted" char="U007E" key="Tilde" glyph="~"/> <!-- \'Tilde\' not a DOM L3 name -->\n\n  <!-- Numeric keypad (when in numeric mode) -->\n\n  <key keycode="_96" char="U0030" glyph="0"/>\n  <key keycode="_97" char="U0031" glyph="1"/>\n  <key keycode="_98" char="U0032" glyph="2"/>\n  <key keycode="_99" char="U0033" glyph="3"/>\n  <key keycode="_100" char="U0034" glyph="4"/>\n  <key keycode="_101" char="U0035" glyph="5"/>\n  <key keycode="_102" char="U0036" glyph="6"/>\n  <key keycode="_103" char="U0037" glyph="7"/>\n  <key keycode="_104" char="U0038" glyph="8"/>\n  <key keycode="_105" char="U0039" glyph="9"/>\n\n  <!-- Numeric keypad -->\n\n  <key keycode="_106" key="Multiply" glyph="*"/>\n\n  <!-- The \'Add\' key -->\n  <key keycode="_107" key="Add" glyph="+"/>\n  <key keycode="_187" platform="macosx" browser="safari" key="Add" glyph="+"/>\n\n  <!-- ** <key keycode="_108" key="Separator"/> -->\n\n  <!-- The \'Subtract\' key -->\n  <key keycode="_109" key="Subtract" glyph="-"/>\n  <key keycode="_189" platform="macosx" browser="safari" key="Subtract" glyph="-"/>\n\n  <!-- The \'Decimal\' key -->\n  <key keycode="_110" key="Decimal" glyph="."/>\n  <key keycode="_190" platform="macosx" browser="safari" key="Decimal" glyph="."/>\n\n  <!-- The \'Divide\' key -->\n  <key keycode="_111" key="Divide" glyph="/"/>\n  <key keycode="_191" platform="macosx" browser="safari" key="Divide" glyph="/"/>\n\n  <!-- Function keys -->\n\n  <key keycode="_112" key="F1"/>\n  <key keycode="_113" key="F2"/>\n  <key keycode="_114" key="F3"/>\n  <key keycode="_115" key="F4"/>\n  <key keycode="_116" key="F5"/>\n  <key keycode="_117" key="F6"/>\n  <key keycode="_118" key="F7"/>\n  <key keycode="_119" key="F8"/>\n  <key keycode="_120" key="F9"/>\n  <key keycode="_121" key="F10"/>\n  <key keycode="_122" key="F11"/>\n  <key keycode="_123" key="F12"/>\n\n  <!--\n  <key keycode="_124" key="F13"/>\n  <key keycode="_124_shifted" key="Verbar"/>\n  <key keycode="_125" key="F14"/>\n  <key keycode="_126" key="F15"/>\n  <key keycode="_126_shifted" key="Tilde"/>\n  <key keycode="_127" key="F16"/>\n  <key keycode="_128" key="F17"/>\n  <key keycode="_129" key="F18"/>\n  <key keycode="_130" key="F19"/>\n  <key keycode="_131" key="F20"/>\n  <key keycode="_132" key="F21"/>\n  <key keycode="_133" key="F22"/>\n  <key keycode="_134" key="F23"/>\n  <key keycode="_135" key="F24"/>\n  -->\n\n  <key keycode="_144" platform="win" key="NumLock"/>\n  <key keycode="_145" platform="win" key="Scroll"/>\n\n  <key keycode="_188" char="U002C" key="Comma" glyph=","/>\n  <key keycode="_188_shifted" char="U003C" key="LessThan" glyph="&lt;"/>\n\n  <key keycode="_190" char="U002E" key="Period" glyph="."/>\n  <key keycode="_190_shifted" char="U003E" key="GreaterThan" glyph="&gt;"/>\n\n  <key keycode="_191" char="U002F" key="Solidus" glyph="/"/>\n  <key keycode="_191_shifted" char="U003F" key="QuestionMark" glyph="?"/>\n\n  <!-- The \'Semicolon\' character -->\n  <key keycode="_59" browser="firefox" char="U003B" key="Semicolon" glyph=";"/>\n  <key keycode="_186" char="U003B" key="Semicolon" glyph=";"/>\n\n  <!-- The \'Colon\' character -->\n  <key keycode="_59_shifted" browser="firefox" char="U003A" key="Colon" glyph=":"/>\n  <key keycode="_186_shifted" char="U003A" key="Colon" glyph=":"/>\n\n  <key keycode="_222" char="U0027" key="Apostrophe" glyph="&apos;"/>\n  <key keycode="_222_shifted" char="U0022" key="DoubleQuote" glyph="&quot;"/>\n\n  <key keycode="_219" char="U005B" key="LeftSquareBracket" glyph="["/>\n  <key keycode="_219_shifted" char="U007B" key="LeftCurlyBracket" glyph="{"/>\n\n  <key keycode="_221" char="U005D" key="RightSquareBracket" glyph="]"/>\n  <key keycode="_221_shifted" char="U007D" key="RightCurlyBracket" glyph="}"/>\n\n  <key keycode="_220" char="U005C" key="Backslash" glyph="\\"/>\n  <key keycode="_220_shifted" char="U007C" key="Pipe" glyph="|"/>\n\n  <!-- NB: Firefox cannot distinguish between meta keys, so it will always\n       report \'left\' key -->\n\n  <!-- The left meta key -->\n  <key keycode="_91" key="Meta"/>\n\n  <!-- The right meta key -->\n  <key keycode="_92" platform="win" key="Meta"/>\n\n</keyboard>\n'
);
TP.boot.$$srcPath = '~lib_build/lib_dat-vcards.xml.js';
TP.boot.$$srcPackage = '~lib_cfg/TIBET.xml';
TP.boot.$$srcConfig = 'base-inlined';
TP.uc('~lib_dat/vcards.xml').setContent(
'<?xml version="1.0"?>\n<vcards xmlns="urn:ietf:params:xml:ns:vcard-4.0"\n        xmlns:vcard-ext="http://www.technicalpursuit.com/vcard-ext">\n\n    <!-- Server configuration vcards - like many you will find in XMPP/Jabber.\n\n    NB: We\'ve added some custom keys to vcard support in TIBET. These are used\n    for vcard entries that point to server resources and have a custom namespace\n    of \'http://www.technicalpursuit.com/vcard-ext\'. They include:\n\n    x-username      <key value>     Used as the \'username\' for servers that\n                                    require login information.\n    x-password      <key value>     Used as the \'password\' for servers that\n                                    require login information.\n    x-auth          [BASIC|DIGEST]  What kind of authentication the server uses\n                                    to authenticate users. If this is known\n                                    beforehand, TIBET can perform the\n                                    authentication itself to avoid the initial\n                                    roundtrip to the server to determine\n                                    authentication schemes.\n    x-secret-key    <key value>     Used as the \'secret key\' for servers that\n                                    require login information. This complements\n                                    the standard vcard \'KEY\' key which is the\n                                    public key for these types of servers.\n    x-is-webdav     [true|false]    Whether or not the server is capable of\n                                    processing WebDAV queries.\n    x-xmpp-conn-type  [BINDING|POLLING]     Used for XMPP servers. Indicates\n                                            whether the connection to the server\n                                            will use XMPP \'binding\' or \'polling\'\n                                            (deprecated) support.\n    -->\n\n    <!-- An XMPP server set up on \'localhost\' and using an XMPP \'binding\'\n    (XEP-124) connection -->\n    <vcard>\n        <fn><text>XMPPService</text></fn>\n        <n><text>localhost</text></n>\n        <note><text>The default Jabber server</text></note>\n        <url><uri>http://localhost:5280/http-bind/</uri></url>\n        <vcard-ext:x-xmpp-conn-type>BINDING</vcard-ext:x-xmpp-conn-type>\n    </vcard>\n\n    <!-- The Amazon S3 server\'s vcard -->\n    <vcard>\n        <fn><text>AmazonS3Service</text></fn>\n        <note><text>The Amazon S3 Service</text></note>\n\n        <!-- Note no trailing slash here! -->\n        <url><uri>http://s3.amazonaws.com</uri></url>\n\n        <!-- The keys aren\'t supplied here ;-) -->\n        <!-- Your Amazon key ({USER} prompts the user for it the first time) -->\n        <key><text>{USER}</text></key>\n        <!-- Your Amazon secret key ({USER} prompts the user for it the first\n             time) -->\n        <vcard-ext:x-secret-key>{USER}</vcard-ext:x-secret-key>\n    </vcard>\n\n    <!-- The WebDAV test server\'s vcard -->\n    <vcard>\n        <fn><text>WebDAVService</text></fn>\n        <note><text>The WebDAV test Service</text></note>\n        <url><uri>http://localhost:1407/_tds/webdav/</uri></url>\n        <vcard-ext:x-is-webdav>true</vcard-ext:x-is-webdav>\n    </vcard>\n\n</vcards>\n\n'
);
TP.boot.$$srcPath = '~lib_build/lib_src-tsh-TP.tsh.type-TP.tsh.type_assistant.xhtml.js';
TP.boot.$$srcPackage = '~lib_cfg/TIBET.xml';
TP.boot.$$srcConfig = 'base-inlined';
TP.uc('~lib_src/tsh/TP.tsh.type/TP.tsh.type_assistant.xhtml').setContent(
'<!DOCTYPE html>\n\n<tsh:type_assistant id="tshTypeAssistant">\n    <div class="head"/>\n    <div class="body">\n        <tibet:data name="urn:tibet:type_cmd_supertypeFilterName">\n            <![CDATA[\n            {"value":""}\n            ]]>\n        </tibet:data>\n\n        <div class="supertypeFieldGroup">\n            <label for="type_assistant_SupertypeFilterField">Supertype:</label>\n            <input type="text" id="type_assistant_SupertypeFilterField" bind:io="{value: urn:tibet:type_cmd_supertypeFilterName#jpath($.value)}" ui:incremental="model" autocomplete="off"/>\n        </div>\n\n        <xctrls:list id="type_assistant_SupertypeList" bind:in="{data: urn:tibet:typelist, filterValue: urn:tibet:type_cmd_supertypeFilterName#jpath($.value)}" bind:io="{value: urn:tibet:type_cmd_source#jpath($.info.supertype)}" filter="true"/>\n\n        <button class="supertypeResetButton" on:click="ResetSupertype">Reset</button>\n\n        <div class="typeInfoFieldGroup" bind:scope="urn:tibet:type_cmd_source#jpath($.info)">\n            <label for="type_assistant_DNASelect">DNA:</label>\n            <select id="type_assistant_DNASelect" class="dna_select" bind:io="{value: dna}">\n                <option value="templatedtag">Templated Tag</option>\n                <option value="computedtag">Computed Tag</option>\n                <option value="actiontag">Action Tag</option>\n                <option value="infotag">Info Tag</option>\n                <option value="controller">Controller</option>\n                <option value="content">Content</option>\n                <option value="default">Object</option>\n            </select>\n\n            <label for="type_assistant_TopLevelNS">Root NS:</label>\n            <ul id="type_assistant_TopLevelNS" class="nsRadios">\n                <li>\n                    <label for="type_assistant_TopLevelNSRadio2">APP</label>\n                    <input type="radio" name="namespace_radio" value="APP" id="type_assistant_TopLevelNSRadio2"/>\n                </li>\n                <li>\n                    <label for="type_assistant_TopLevelNSRadio1">TP</label>\n                    <input type="radio" name="namespace_radio" value="TP" id="type_assistant_TopLevelNSRadio1" bind:io="{checked: topLevelNS}"/>\n                </li>\n            </ul>\n\n            <label for="type_assistant_TypeNameField">Type name:</label>\n            <input type="text" id="type_assistant_TypeNameField" bind:io="{value: typeNSAndName}" autofocus="autofocus"/>\n\n            <label for="type_assistant_PackageNameField">Package:</label>\n            <input type="text" id="type_assistant_PackageNameField" bind:io="{value: package}"/>\n\n            <label for="type_assistant_ConfigNameField">Config:</label>\n            <input type="text" id="type_assistant_ConfigNameField" bind:io="{value: config}"/>\n\n            <label for="type_assistant_DirectoryField">Directory:</label>\n            <input type="text" id="type_assistant_DirectoryField" bind:io="{value: dir}"/>\n        </div>\n\n    </div>\n    <div class="foot">\n        <code id="generatedCmdLine"/>\n        <button on:click="DialogCancel">Cancel</button>\n        <button on:click="DialogOk">Create</button>\n    </div>\n</tsh:type_assistant>\n'
);
TP.boot.$$srcPath = '~lib_build/lib_src-tsh-TP.tsh.type-TP.tsh.type_assistant.css.js';
TP.boot.$$srcPackage = '~lib_cfg/TIBET.xml';
TP.boot.$$srcConfig = 'base-inlined';
TP.uc('~lib_src/tsh/TP.tsh.type/TP.tsh.type_assistant.css').setContent(
'@namespace tsh url("http://www.technicalpursuit.com/1999/tshell");\n@namespace xctrls url("http://www.technicalpursuit.com/2005/xcontrols");\n\ntsh|type_assistant {\n\n}\n\ntsh|type_assistant > .head {\n}\n\ntsh|type_assistant > .body {\n\n    display: grid;\n\n    grid-template-rows: 3em 2.5em 3em 3em 3em 3em;\n    grid-template-columns: 1fr 1fr;\n    grid-template-areas:\n        "supertype_field_group typeinfo_field_group"\n        "supertype_list typeinfo_field_group"\n        "supertype_list typeinfo_field_group"\n        "supertype_list typeinfo_field_group"\n        "supertype_list typeinfo_field_group"\n        "supertype_reset_button typeinfo_field_group";\n\n    align-items: center;\n\n    top: 0;\n    right: 0;\n    bottom: 7em;\n    left: 0;\n\n    text-align: left;\n}\n\ntsh|type_assistant > .body .supertypeFieldGroup {\n\n    grid-area: supertype_field_group;\n\n    display: flex;\n\n    margin-left: 0.5em;\n    margin-right: 0.5em;\n\n    align-items: center;\n}\n\ntsh|type_assistant > .body .supertypeFieldGroup > label {\n\n    font-weight: bold;\n}\n\ntsh|type_assistant > .body .supertypeFieldGroup > input {\n\n    width: 100%;\n\n    margin: 0;\n    margin-left: 0.5em;\n}\n\ntsh|type_assistant > .body #type_assistant_SupertypeList {\n\n    grid-area: supertype_list;\n\n    width: auto;\n\n    line-height: 1.5;\n\n    height: 11em;\n\n    margin-left: 0.5em;\n    margin-right: 0.5em;\n}\n\ntsh|type_assistant > .body .supertypeResetButton {\n\n    grid-area: supertype_reset_button;\n\n    margin-left: 0.5em;\n    margin-right: 0.5em;\n}\n\ntsh|type_assistant > .body .typeInfoFieldGroup {\n\n    grid-area: typeinfo_field_group;\n\n    display: grid;\n\n    grid-template-rows: 1fr 1fr 1fr 1fr 1fr 1fr;\n    grid-template-columns: 6em 1fr;\n    grid-template-areas:\n        "dna_field_label dna_field_select"\n        "rootns_field_label rootns_field_group"\n        "typename_field_label typename_field_input"\n        "packagename_field_label packagename_field_input"\n        "configname_field_label configname_field_input"\n        "directory_field_label directory_field_input";\n\n    align-items: center;\n\n    margin-top: -1em;\n}\n\ntsh|type_assistant > .body .typeInfoFieldGroup > input[type="text"],\ntsh|type_assistant > .body .typeInfoFieldGroup > select {\n\n    width: calc(100% - 1.5em);\n}\n\ntsh|type_assistant > .body .typeInfoFieldGroup > label {\n\n    font-weight: bold;\n}\n\ntsh|type_assistant > .body .dnaFieldGroup {\n\n    display: flex;\n\n    left: 5px;\n    right: 5px;\n\n    align-items: center;\n}\n\ntsh|type_assistant > .body .typeInfoFieldGroup > label[for="type_assistant_DNASelect"] {\n\n    grid-area: dna_field_label;\n\n    font-weight: bold;\n}\n\ntsh|type_assistant > .body .typeInfoFieldGroup > select#type_assistant_DNASelect {\n\n    grid-area: dna_field_select;\n\n    width: calc(100% - 1em);\n\n    margin-left: 5px;\n    margin-right: 0;\n}\n\ntsh|type_assistant > .body .typeInfoFieldGroup > label[for="type_assistant_TopLevelNS"] {\n\n    grid-area: rootns_field_label;\n\n    font-weight: bold;\n}\n\ntsh|type_assistant > .body .typeInfoFieldGroup .nsRadios#type_assistant_TopLevelNS {\n\n    grid-area: rootns_field_group;\n\n    display: flex;\n\n    margin: 0;\n}\n\ntsh|type_assistant > .body .typeInfoFieldGroup .nsRadios li {\n\n    display: flex;\n\n    align-items: center;\n\n    margin-left: 5px;\n}\n\ntsh|type_assistant > .body .typeInfoFieldGroup .nsRadios li input {\n\n    margin-right: 4px;\n}\n\ntsh|type_assistant > .body .typeInfoFieldGroup .nsRadios li label {\n\n    margin-left: 0;\n    margin-right: 4px;\n\n    font-weight: normal;\n}\n\ntsh|type_assistant > .body .typeInfoFieldGroup > label[for="type_assistant_TypeNameField"] {\n\n    grid-area: typename_field_label;\n}\n\ntsh|type_assistant > .body .typeInfoFieldGroup > input#type_assistant_TypeNameField {\n\n    grid-area: typename_field_input;\n}\n\ntsh|type_assistant > .body .typeInfoFieldGroup > label[for="type_assistant_PackageNameField"] {\n\n    grid-area: packagename_field_label;\n}\n\ntsh|type_assistant > .body .typeInfoFieldGroup > input#type_assistant_PackageNameField {\n\n    grid-area: packagename_field_input;\n}\n\ntsh|type_assistant > .body .typeInfoFieldGroup > label[for="type_assistant_ConfigNameField"] {\n\n    grid-area: configname_field_label;\n}\n\ntsh|type_assistant > .body .typeInfoFieldGroup > input#type_assistant_ConfigNameField {\n\n    grid-area: configname_field_input;\n}\n\ntsh|type_assistant > .body .typeInfoFieldGroup > label[for="type_assistant_DirectoryField"] {\n\n    grid-area: directory_field_label;\n}\n\ntsh|type_assistant > .body .typeInfoFieldGroup > input#type_assistant_DirectoryField {\n\n    grid-area: directory_field_input;\n}\n\ntsh|type_assistant > .foot {\n\n}\n\ntsh|type_assistant > .foot #generatedCmdLine {\n\n    display: block;\n\n    height: 4em;\n\n    max-width: 50vw;\n\n    margin-left: 0.5em;\n    margin-right: 0.5em;\n\n    font-size: 100%;\n    line-height: 1.2em;\n\n    border: dotted 1px black;\n\n    text-align: left;\n\n    background-color: cornsilk;\n\n    overflow: auto;\n\n    word-break: break-word;\n\n    user-select: text;\n}\n\ntsh|type_assistant > .foot button {\n\n    cursor: pointer;\n\n    margin: 0.5em;\n}\n'
);
TP.boot.$$srcPath = '~lib_build/lib_src-tsh-TP.tsh.method-TP.tsh.method_assistant.xhtml.js';
TP.boot.$$srcPackage = '~lib_cfg/TIBET.xml';
TP.boot.$$srcConfig = 'base-inlined';
TP.uc('~lib_src/tsh/TP.tsh.method/TP.tsh.method_assistant.xhtml').setContent(
'<!DOCTYPE html>\n\n<tsh:method_assistant id="tshMethodAssistant">\n    <div class="head"/>\n    <div class="body" bind:scope="urn:tibet:method_cmd_source#jpath($.info)">\n        <label for="method_assistant_MethodKindRadios">Method | Handler:</label>\n        <ul id="method_assistant_MethodKindRadios" class="methodKindRadios">\n            <li>\n                <input type="radio" name="methodkind_radio" value="method" id="methodKindRadio1" bind:io="{checked: methodKind}"/>\n                <label for="methodKindRadio1">Method</label>\n            </li>\n            <li>\n                <input type="radio" name="methodkind_radio" value="handler" id="methodKindRadio2"/>\n                <label for="methodKindRadio2">Handler</label>\n            </li>\n        </ul>\n\n        <label for="method_assistant_MethodOwnerTypeNameField">Method Owner:</label>\n        <input type="text" id="method_assistant_MethodOwnerTypeNameField" bind:io="{value: methodOwnerTypeName}" autocomplete="off"/>\n\n        <label for="method_assistant_MethodTrackRadios">Method Track:</label>\n        <ul id="method_assistant_MethodTrackRadios" class="methodTrackRadios">\n            <li>\n                <input type="radio" name="methodTrack_radio" value="instance" id="methodTrackRadio1" bind:io="{checked: methodTrack}"/>\n                <label for="methodTrackRadio1">Instance</label>\n            </li>\n            <li>\n                <input type="radio" name="methodTrack_radio" value="type" id="methodTrackRadio2"/>\n                <label for="methodTrackRadio2">Type</label>\n            </li>\n            <li>\n                <input type="radio" name="methodTrack_radio" value="typelocal" id="methodTrackRadio3"/>\n                <label for="methodTrackRadio3">Type Local</label>\n            </li>\n        </ul>\n\n        <label for="method_assistant_MethodNameField">Name | Signal:</label>\n        <input type="text" id="method_assistant_MethodNameField" bind:io="{value: methodName}" autofocus="autofocus" autocomplete="off"/>\n    </div>\n    <div class="foot">\n        <code id="generatedCmdLine"/>\n        <button on:click="DialogCancel">Cancel</button>\n        <button on:click="DialogOk">Create</button>\n    </div>\n</tsh:method_assistant>\n'
);
TP.boot.$$srcPath = '~lib_build/lib_src-tsh-TP.tsh.method-TP.tsh.method_assistant.css.js';
TP.boot.$$srcPackage = '~lib_cfg/TIBET.xml';
TP.boot.$$srcConfig = 'base-inlined';
TP.uc('~lib_src/tsh/TP.tsh.method/TP.tsh.method_assistant.css').setContent(
'@namespace tsh url("http://www.technicalpursuit.com/1999/tshell");\n@namespace pclass url("urn:tibet:pseudoclass");\n\ntsh|method_assistant {\n\n}\n\ntsh|method_assistant > .head {\n}\n\ntsh|method_assistant > .body {\n\n    display: grid;\n\n    grid-template-rows: 3em 3em 3em 3em;\n    grid-template-columns: 9em 1fr;\n    grid-template-areas:\n        "methodkind_field_label methodkind_field_group"\n        "methodowner_field_label methodowner_field_input"\n        "methodtrack_field_label methodtrack_field_group"\n        "methodname_field_label methodname_field_input";\n\n    align-items: center;\n\n    top: 0;\n    right: 0;\n    bottom: 7em;\n    left: 0;\n\n    text-align: left;\n}\n\ntsh|method_assistant > .body label {\n\n    font-weight: bold;\n\n    margin-left: 5px;\n\n    justify-self: end;\n}\n\ntsh|method_assistant > .body input[type="text"] {\n\n    width: calc(100% - 1.5em);\n\n    margin-left: 5px;\n}\n\ntsh|method_assistant > .body label[for="method_assistant_MethodKindRadios"] {\n\n    grid-area: methodkind_field_label;\n}\n\ntsh|method_assistant > .body .methodKindRadios#method_assistant_MethodKindRadios {\n\n    grid-area: methodkind_field_group;\n\n    display: flex;\n\n    margin: 0;\n}\n\ntsh|method_assistant > .body > .methodKindRadios li {\n\n    display: flex;\n\n    align-items: center;\n\n    margin-left: 5px;\n}\n\ntsh|method_assistant > .body > .methodKindRadios li input {\n\n    margin-right: 4px;\n}\n\ntsh|method_assistant > .body > .methodKindRadios li label {\n\n    margin-left: 0;\n    margin-right: 4px;\n\n    font-weight: normal;\n}\n\ntsh|method_assistant > .body label[for="method_assistant_MethodOwnerTypeNameField"] {\n\n    grid-area: methodowner_field_label;\n}\n\ntsh|method_assistant > .body input#method_assistant_MethodOwnerTypeNameField {\n\n    grid-area: methodowner_field_input;\n}\n\ntsh|method_assistant > .body label[for="method_assistant_MethodTrackRadios"] {\n\n    grid-area: methodtrack_field_label;\n}\n\ntsh|method_assistant > .body .methodTrackRadios#method_assistant_MethodTrackRadios {\n\n    grid-area: methodtrack_field_group;\n\n    display: flex;\n\n    margin: 0;\n}\n\ntsh|method_assistant > .body > .methodTrackRadios li {\n\n    display: flex;\n\n    align-items: center;\n\n    margin-left: 5px;\n}\n\ntsh|method_assistant > .body > .methodTrackRadios li input {\n\n    margin-right: 4px;\n}\n\ntsh|method_assistant > .body > .methodTrackRadios li label {\n\n    margin-left: 0;\n    margin-right: 4px;\n\n    font-weight: normal;\n}\n\ntsh|method_assistant > .body label[for="method_assistant_MethodNameField"] {\n\n    grid-area: methodname_field_label;\n}\n\ntsh|method_assistant > .body input#method_assistant_MethodNameField {\n\n    grid-area: methodname_field_input;\n}\n\ntsh|method_assistant > .foot {\n\n}\n\ntsh|method_assistant > .foot #generatedCmdLine {\n\n    display: block;\n\n    height: 4em;\n\n    max-width: 50vw;\n\n    margin-left: 0.5em;\n    margin-right: 0.5em;\n\n    font-size: 100%;\n    line-height: 1.2em;\n\n    border: dotted 1px black;\n\n    text-align: left;\n\n    background-color: cornsilk;\n\n    overflow: auto;\n\n    word-break: break-word;\n\n    user-select: text;\n}\n\ntsh|method_assistant > .foot button {\n\n    cursor: pointer;\n\n    margin: 0.5em;\n}\n'
);
TP.boot.$$srcPath = '~lib_build/lib_src-tsh-TP.tsh.deploy-TP.tsh.deploy_assistant.xhtml.js';
TP.boot.$$srcPackage = '~lib_cfg/TIBET.xml';
TP.boot.$$srcConfig = 'base-inlined';
TP.uc('~lib_src/tsh/TP.tsh.deploy/TP.tsh.deploy_assistant.xhtml').setContent(
'<!DOCTYPE html>\n\n<tsh:deploy_assistant id="tshDeployAssistant">\n    <div class="head"/>\n    <div class="body" bind:scope="urn:tibet:deploy_cmd_source#jpath($.info)">\n        <label for="deploy_assistant_HelperSelect">Deploy Target:</label>\n        <select id="deploy_assistant_HelperSelect" class="helper_select" bind:io="{value: helperName}">\n            <option value="shipit">ShipIt!</option>\n            <option value="awselasticbeanstalk">AWS Elastic Beanstalk</option>\n            <option value="awsfargate">AWS Fargate</option>\n            <option value="azurewebapps">Azure Webapps</option>\n            <option value="dockerhub">DockerHub</option>\n            <option value="heroku">Heroku</option>\n        </select>\n        <div class="propertiesControlGroup">\n            <label>Target-specific properties (click + to add):</label>\n            <button class="inserter" on:click="{signal: InsertItem, origin: deploy_assistant_PropertyEntries, payload: {source: \'urn:tibet:deploy_prop_data_blank\', copy: true}}"></button>\n        </div>\n        <div class="propertiesGroup">\n            <tibet:group focuswrap="true" id="deploy_assistant_PropertyEntries" bind:repeat="helperProps">\n                <input type="text" bind:io="{value: propName}" tabindex="0"/>\n                <input type="text" bind:io="{value: propValue}" tabindex="0"/>\n                <span class="deleter" on:click="{signal: DeleteItem, origin: deployAssistant_PropertyEntries, payload: {index: TP.TARGET}}"/>\n            </tibet:group>\n        </div>\n    </div>\n    <div class="foot">\n        <code id="generatedCmdLine"/>\n        <button on:click="DialogCancel">Cancel</button>\n        <button on:click="DialogOk">Execute</button>\n    </div>\n</tsh:deploy_assistant>\n'
);
TP.boot.$$srcPath = '~lib_build/lib_src-tsh-TP.tsh.deploy-TP.tsh.deploy_assistant.css.js';
TP.boot.$$srcPackage = '~lib_cfg/TIBET.xml';
TP.boot.$$srcConfig = 'base-inlined';
TP.uc('~lib_src/tsh/TP.tsh.deploy/TP.tsh.deploy_assistant.css').setContent(
'@namespace tsh url("http://www.technicalpursuit.com/1999/tshell");\n@namespace pclass url("urn:tibet:pseudoclass");\n\ntsh|deploy_assistant {\n\n    position: absolute;\n\n    top: 0;\n    left: 0;\n    bottom: 0;\n    right: 0;\n\n    overflow: hidden;\n}\n\ntsh|deploy_assistant > .head {\n}\n\ntsh|deploy_assistant > .body {\n\n    position: absolute;\n    display: grid;\n\n    grid-template-columns: 9em 1fr;\n    grid-template-rows: 3em 3em 11em;\n    grid-template-areas:\n        "helper_field_label helper_field_select"\n        "properties_control_group properties_control_group"\n        "properties_group properties_group";\n\n    top: 0;\n    right: 0;\n    left: 0;\n    bottom: 7em;\n\n    text-align: left;\n\n    align-items: center;\n}\n\ntsh|deploy_assistant > .body label {\n\n    font-weight: bold;\n\n    margin-left: 5px;\n\n    justify-self: end;\n}\n\ntsh|deploy_assistant > .body input[type="text"] {\n\n    width: calc(100% - 1.5em);\n\n    margin-left: 5px;\n}\n\ntsh|deploy_assistant > .body label[for="deploy_assistant_HelperSelect"] {\n\n    grid-area: helper_field_label;\n}\n\ntsh|deploy_assistant > .body select#deploy_assistant_HelperSelect {\n\n    grid-area: helper_field_select;\n}\n\ntsh|deploy_assistant > .body .propertiesControlGroup {\n\n    grid-area: properties_control_group;\n\n    position: absolute;\n    display: flex;\n\n    top: 8px;\n    right: 5px;\n    left: 5px;\n\n    align-items: center;\n    justify-content: flex-start;\n}\n\ntsh|deploy_assistant > .body .propertiesControlGroup > label {\n\n    font-weight: bold;\n}\n\ntsh|deploy_assistant > .body .propertiesControlGroup > .inserter {\n\n    top: 2px;\n    right: 0;\n\n    width: 24px;\n    height: 24px;\n\n    cursor: pointer;\n\n    background-size: 75%;\n    background-repeat: no-repeat;\n    background-position-x: center;\n    background-position-y: center;\n    background-image: url("../../../src/tibet/tools/lama/media/ic_add_circle_outline_black_24px.svg");\n}\n\ntsh|deploy_assistant > .body .propertiesGroup {\n\n    grid-area: properties_group;\n\n    position: absolute;\n\n    top: 0;\n    right: 5px;\n    bottom: 5px;\n    left: 5px;\n}\n\ntsh|deploy_assistant > .body #deploy_assistant_PropertyEntries {\n\n    position: absolute;\n\n    top: 0;\n    right: 0;\n    bottom: 0;\n    left: 0;\n\n    border: dotted 1px gray;\n\n    overflow-y: auto;\n}\n\ntsh|deploy_assistant > .body #deploy_assistant_PropertyEntries > span {\n\n    display: flex;\n\n    width: 100%;\n}\n\ntsh|deploy_assistant > .body #deploy_assistant_PropertyEntries > span input {\n\n    width: auto;\n    height: 1em;\n\n    margin-left: 0;\n    margin-right: 0;\n    margin-bottom: 2px;\n\n    flex: 1;\n}\n\ntsh|deploy_assistant > .body #deploy_assistant_PropertyEntries .deleter {\n\n    width: 24px;\n    height: 24px;\n\n    cursor: pointer;\n\n    background-size: 50%;\n    background-repeat: no-repeat;\n    background-position-x: center;\n    background-position-y: center;\n    background-image: url("../../../src/tibet/tools/lama/media/ic_close_black_24px.svg");\n}\n\ntsh|deploy_assistant > .foot {\n\n    position: absolute;\n\n    bottom: 0;\n    left: 0;\n    right: 0;\n    width: 100%;\n\n    height: 7em;\n}\n\ntsh|deploy_assistant > .foot #generatedCmdLine {\n\n    display: inline-block;\n\n    width: 90%;\n    height: 4em;\n\n    padding: 0 12px;\n    margin: 0 20px;\n\n    font-size: 100%;\n    line-height: 1.2em;\n\n    border: dotted 1px black;\n\n    text-align: left;\n\n    background-color: cornsilk;\n\n    overflow: auto;\n\n    word-break: break-word;\n\n    user-select: text;\n}\n'
);
